/*************************************************************************
 *
 *  $RCSfile: documentproperties.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __DOCUMENTPROPERTIES_HXX_
#define __DOCUMENTPROPERTIES_HXX_

//______________________________________________________________________________________________________________
//	switches
//	Use these to de/activate some features of this implementation.
//	(for debugging or testing!)
//______________________________________________________________________________________________________________

// de/activate permanently testing of stream
#define	DOCUMENTPROPERTIES_SWITCH_ON_CHECK_SVSTREAM

// Read user specified properties.
// We cant use this place! Namecontainer can have more then 4 elements.
// And size of everyone can be greater then 19 letters.
// We can do the follow:
//		1)	Truncate first 4 items of namecontainer to right size and
//			write it to this place. All other properties will be saved
//			later at the end of header!
//		2)	Search for 4 items of namecontainer, which have right size!
//			But performance wil be low...
//		3)  Let this place free and unused! Save ALL properties
//			later at the end of header! We loose 152 bytes only ...
// We use option 1)!
#define	DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES

//______________________________________________________________________________________________________________
//	includes of other projects
//______________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif

#ifndef _COM_SUN_STAR_IO_XPERSIST_HPP_
#include <com/sun/star/io/XPersist.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_H_
#include <com/sun/star/uno/Type.h>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_H_
#include <cppuhelper/interfacecontainer.h>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _TIMESTAMP_HXX
#include <tools/timestamp.hxx>
#endif

#ifndef _SOT_STORAGE_HXX
#include <sot/storage.hxx>
#endif

#ifndef __SGI_STL_HASH_MAP
#include <stl/hash_map>
#endif

//______________________________________________________________________________________________________________
//	includes of my own project
//______________________________________________________________________________________________________________

//______________________________________________________________________________________________________________
//	defines
//______________________________________________________________________________________________________________

// Some defines to write better code :-)
#define	XMULTISERVICEFACTORY							::com::sun::star::lang::XMultiServiceFactory
#define	XNAMECONTAINER									::com::sun::star::container::XNameContainer
#define	XPERSIST										::com::sun::star::io::XPersist
#define	XPROPERTYSETINFO								::com::sun::star::beans::XPropertySetInfo
#define	XSERVICEINFO									::com::sun::star::lang::XServiceInfo
#define	XTYPEPROVIDER									::com::sun::star::lang::XTypeProvider

#define	ELEMENTEXISTEXCEPTION							::com::sun::star::container::ElementExistException
#define	EXCEPTION										::com::sun::star::uno::Exception
#define	ILLEGALARGUMENTEXCEPTION						::com::sun::star::lang::IllegalArgumentException
#define	IOEXCEPTION										::com::sun::star::io::IOException
#define	NOSUCHELEMENTEXCEPTION							::com::sun::star::container::NoSuchElementException
#define	RUNTIMEEXCEPTION								::com::sun::star::uno::RuntimeException
#define	WRAPPEDTARGETEXCEPTION							::com::sun::star::lang::WrappedTargetException

#define	IPROPERTYARRAYHELPER							::cppu::IPropertyArrayHelper
#define	OBROADCASTHELPER								::cppu::OBroadcastHelper
#define	OPROPERTYARRAYHELPER							::cppu::OPropertyArrayHelper
#define	OPROPERTYSETHELPER								::cppu::OPropertySetHelper
#define	OWEAKOBJECT										::cppu::OWeakObject
#define	OUSTRING										::rtl::OUString

#define	ANY												::com::sun::star::uno::Any
#define	DATETIME										::com::sun::star::util::DateTime
#define	HASH_MAP										::std::hash_map
#define	MUTEX											::osl::Mutex
#define	PROPERTY										::com::sun::star::beans::Property
#define	REFERENCE										::com::sun::star::uno::Reference
#define	SEQUENCE										::com::sun::star::uno::Sequence
#define	UNOTYPE											::com::sun::star::uno::Type

//______________________________________________________________________________________________________________
//	definitions
//______________________________________________________________________________________________________________

/***************************************************************************************************************
 *	@short		structure to define mutex for this class
 *
 *	@descr		This structure is using as "baseclass" of follow class "DocumentProperties".
 *				It's necessary to initialize members AND basclasses in right order and with
 *				a VALID instance of OMutex! (see also implementation of constructor!)
 **************************************************************************************************************/

struct IMPL_MutexContainer
{
	MUTEX m_aMutex ;
} ;

/***************************************************************************************************************
 *	@short		set and get information about properties of an document
 *
 *	@descr		You can use this class to set and get properties of an document. Some properties are predefined!
 *				But you can add and remove user defined properties.
 *
 *	@implements	XServiceInfo
 *				XTypeProvider
 *				XPropertySet
 *				XFastPropertySet
 *				XMultiPropertySet
 *				XNameContainer
 *
 *	@base		IMPL_OMutexContainer
 *				OBroadcastHelper
 *				OPropertySetHelper
 *				OWeakObject
 **************************************************************************************************************/

class DocumentProperties	:	public XSERVICEINFO			,
								public XTYPEPROVIDER		,
								public XNAMECONTAINER		,
								public XPERSIST				,
								public IMPL_MutexContainer	,
								public OBROADCASTHELPER		,
								public OPROPERTYSETHELPER	,
								public OWEAKOBJECT
{
	//---------------------------------------------------------------------------
	//	public methods
	//---------------------------------------------------------------------------
	public:

		//---------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		standard constructor to create instance by factory
	 	 *	@descr		This constructor initialize a new instance of this class by valid factory,
		 *				and will be set valid values on his member and baseclasses.
		 *
		 *	@seealso	-
		 *
	 	 *	@param		"rFactory" is the multi service manager, which create this instance.
		 *				The value must be different from NULL!
		 *
		 *	@return		-
		 *
		 *	@onerror	DBG_ASSERT in debug version or nothing in relaese version.
	 	 */

	 	DocumentProperties ( const REFERENCE< XMULTISERVICEFACTORY >& rFactory ) ;

		/****************************************************************************
	 	 *	@short		standard destructor
	 	 *	@descr		This method destruct an instance of "DocumentProperties" and
		 *				clear some member. (for example: hashtable)
		 *
		 *	@seealso	-
		 *
	 	 *	@param		-
		 *
		 *	@return		-
		 *
		 *	@onerror	-
	 	 */

		virtual	~DocumentProperties	() ;

		//---------------------------------------------------------------------------
		//	XInterface
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		give answer, if interface is supported
	 	 *	@descr		The interfaces are searched by type.
		 *
		 *	@seealso	XInterface
		 *
	 	 *	@param      "rType" is the type of searched interface.
		 *
		 *	@return		Any		information about found interface
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual ANY SAL_CALL queryInterface ( const UNOTYPE& rType ) throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		increment refcount
	 	 *	@descr		-
		 *
		 *	@seealso	XInterface
		 *	@seealso	release()
		 *
	 	 *	@param		-
		 *
		 *	@return		-
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

    	virtual void SAL_CALL acquire () throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		decrement refcount
	 	 *	@descr		-
		 *
		 *	@seealso	XInterface
		 *	@seealso	acquire()
		 *
	 	 *	@param		-
		 *
		 *	@return		-
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

    	virtual void SAL_CALL release () throw ( RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XServiceInfo
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		give answer, if interface is supported
	 	 *	@descr		The interfaces is searched by name.
		 *
		 *	@seealso	XServiceInfo
		 *
	 	 *	@param		"rServiceName" is the name of searched service.
		 *
		 *	@return		sal_TRUE - if supported; sal_FALSE otherway
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

	    virtual sal_Bool SAL_CALL supportsService ( const OUSTRING& rServiceName ) throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		return all supported servicenames of this service
	 	 *	@descr      All servicenames are given as an sequence.
		 *
		 *	@seealso	XServiceInfo
		 *	@seealso	impl_getStaticSupportedServiceNames()
		 *
	 	 *	@param      -
		 *
		 *	@return		sequence of names of type OUString
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

    	virtual SEQUENCE< OUSTRING > SAL_CALL getSupportedServiceNames () throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		return the implementationname of this service
	 	 *	@descr		-
		 *
		 *	@seealso	XServiceInfo
		 *	@seealso	impl_getStaticImplementationName()
		 *
	 	 *	@param		-
		 *
		 *	@return		sequence of names of type OUString
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

    	virtual OUSTRING SAL_CALL getImplementationName () throw ( RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XTypeProvider
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		get information about supported interfaces
	 	 *	@descr      -
		 *
		 *	@seealso	XTypeProvider
		 *
	 	 *	@param      -
		 *
		 *	@return		Sequence of types of all supported interfaces
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual SEQUENCE< UNOTYPE > SAL_CALL getTypes () throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		get implementation id
	 	 *	@descr      This ID is neccessary for UNO-caching. If there no ID, cache is disabled.
		 *				Another way, cache is enabled.
		 *
		 *	@seealso	XTypeProvider
		 *
	 	 *	@param		-
		 *
		 *	@return		ID as Sequence of byte
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual SEQUENCE< sal_Int8 > SAL_CALL getImplementationId () throw ( RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XNameContainer
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		insert persistent property
	 	 *	@descr		This method insert a persistent property. You can set name and value of this.
		 *				But type must be "string".
		 *
		 *	@seealso	XNameContainer
		 *
	 	 *	@param      "rName"		Name of new persistent property
	 	 *	@param      "rElement"	Value of new persistent property
		 *
		 *	@return		-
		 *
		 *	@onerror	IllegalArgumentException, if you call this with an invalid argument
		 *				ElementExistException	, if element with same name already exist
		 *				WrappedTargetException	, if an unknown exception is catched
		 *				RuntimeException		, if something is wrong (not enough memory ...)
	 	 */

		virtual void SAL_CALL insertByName ( const OUSTRING& rName, const ANY& rElement ) throw ( ILLEGALARGUMENTEXCEPTION, ELEMENTEXISTEXCEPTION, WRAPPEDTARGETEXCEPTION, RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		remove persistent property from instance
	 	 *	@descr		This method remove a persistent property by name. But this will not remove
		 *				property from document!
		 *
		 *	@seealso	XNameContainer
		 *
	 	 *	@param      "rName"		Name of new persistent property
		 *
		 *	@return		-
		 *
		 *	@onerror	NoSuchElementException, if exist no such element with this name
		 *				WrappedTargetException, if an unknown exception is catched
		 *				RuntimeException	  , if something is wrong (not enough memory ...)
	 	 */

		virtual void SAL_CALL removeByName ( const OUSTRING& rName ) throw ( NOSUCHELEMENTEXCEPTION, WRAPPEDTARGETEXCEPTION, RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XNameReplace
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		replace value of persistent property
	 	 *	@descr		This change the value of an existing property.
		 *
		 *	@seealso	XNameReplace
		 *
	 	 *	@param      "rName"		Name of property
	 	 *	@param      "rElement"	New value of property
		 *
		 *	@return		-
		 *
		 *	@onerror	IllegalArgumentException, if you call this with an invalid argument
		 *				NoSuchElementException	, if exist no such element with this name
		 *				WrappedTargetException	, if an unknown exception is catched
		 *				RuntimeException	 	, if something is wrong (not enough memory ...)
	 	 */

		virtual void SAL_CALL replaceByName ( const OUSTRING& rName, const ANY& rElement ) throw ( ILLEGALARGUMENTEXCEPTION, NOSUCHELEMENTEXCEPTION, WRAPPEDTARGETEXCEPTION, RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XNameAccess
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		get value of property given by name
	 	 *	@descr		The type of this value is string!
		 *
		 *	@seealso	XNameAccess
		 *
	 	 *	@param      "rName"	Name of property
		 *
		 *	@return		value of property as string
		 *
		 *	@onerror	NoSuchElementException, if exist no such element with this name
		 *				WrappedTargetException, if an unknown exception is catched
		 *				RuntimeException	  , if something is wrong (not enough memory ...)
	 	 */

		virtual ANY SAL_CALL getByName ( const OUSTRING& rName ) throw ( NOSUCHELEMENTEXCEPTION, WRAPPEDTARGETEXCEPTION, RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		give names of all persistent properties
	 	 *	@descr		Don't use this names for transient properties! (XPropertySet)
		 *
		 *	@seealso	XNameAccess
		 *
	 	 *	@param      -
		 *
		 *	@return		Sequence of property names
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual SEQUENCE< OUSTRING > SAL_CALL getElementNames () throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		search for a property with same name
	 	 *	@descr		You can test, if a property with this name exist.
		 *
		 *	@seealso	XNameAccess
		 *
	 	 *	@param      "rName"	Name of searched property
		 *
		 *	@return		sal_TRUE - if property exist, sal_FALSE otherway
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual sal_Bool SAL_CALL hasByName ( const OUSTRING& rName ) throw ( RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XElementAccess
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		return type of ALL persistent properties
	 	 *	@descr		All persistent properties must have the same type! [OUString]
		 *
		 *	@seealso	XElementAccess
		 *
	 	 *	@param      -
		 *
		 *	@return		type of persistent properties
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual UNOTYPE SAL_CALL getElementType () throw ( RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		return state of namecontainer
	 	 *	@descr		Use this method to get information, if properties exist or not.
		 *
		 *	@seealso	XElementAccess
		 *
	 	 *	@param      -
		 *
		 *	@return		sal_TRUE if there are properties, sal_FALSE otherway
		 *
		 *	@onerror	A RuntimeException is thrown.
	 	 */

		virtual sal_Bool SAL_CALL hasElements () throw ( RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	XPersist
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		read properties from URL
	 	 *	@descr      URL must be a valid storage!
		 *
		 *	@seealso	XPersist
		 *
	 	 *	@param		"rURL"	name of storage file
		 *
		 *	@return		-
		 *
		 *	@onerror    URL empty			=>	IOException
		 *				URL not a storage	=> 	IOException
		 *				open stream failed	=> 	IOException
		 *				wrong headertype	=> 	IOException
		 *				DocUserKey's empty	=> 	IOException
		 *				general read error	=> 	IOException
	 	 */

    	virtual void SAL_CALL read ( const OUSTRING& rURL ) throw ( IOEXCEPTION, RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		read properties from URL
	 	 *	@descr		URL must be a valid storage!
		 *
		 *	@seealso	XPersist
		 *
	 	 *	@param		"rURL"	name of storage file
		 *
		 *	@return		-
		 *
		 *	@onerror    URL empty			=>	IOException
		 *				URL not a storage	=> 	IOException
		 *				open stream failed	=> 	IOException
		 *				general write error	=> 	IOException
	 	 */

	    virtual void SAL_CALL write ( const OUSTRING& rURL ) throw ( IOEXCEPTION, RUNTIMEEXCEPTION ) ;

		//---------------------------------------------------------------------------
		//	public impl... methods !!!
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		return static sequence of supported servicenames
	 	 *	@descr		This method is a public (BUT impl...) implementation to build the same
		 *				informationen for all instances of this class. They is used for registration
		 *				and must be public! Don't use this outside this context please!!!
		 *
		 *	@seealso	getSupportedServiceNames()
		 *
	 	 *	@param		-
		 *
		 *	@return		static sequence of names of type OUString
		 *
		 *	@onerror    -
	 	 */

		static SEQUENCE< OUSTRING >	impl_getStaticSupportedServiceNames	() ;

		/****************************************************************************
	 	 *	@short		return static name of this implementation
	 	 *	@descr		This method is a public (BUT impl...) implementation to build the same
		 *				informationen for all instances of this class. They is used for registration
		 *				and must be public! Don't use this outside this context please!!!
		 *
		 *	@seealso	getImplementationName()
		 *
	 	 *	@param		-
		 *
		 *	@return		static name of type OUString
		 *
		 *	@onerror	-
	 	 */

		static OUSTRING impl_getStaticImplementationName () ;

	//---------------------------------------------------------------------------
	//	protected methods
	//---------------------------------------------------------------------------
	protected:

		//---------------------------------------------------------------------------
		//	OPropertySetHelper
		//---------------------------------------------------------------------------

		/****************************************************************************
	 	 *	@short		try to convert a property value
	 	 *	@descr		This method is calling from helperclass "OPropertySetHelper".
		 *				Don't use this directly!
		 *				You must try to convert the value of given propertyhandle and
		 *				return results of this operation. This will be use to ask vetoable
		 *				listener. If no listener have a veto, we will change value realy!
		 *				( in method setFastPropertyValue_NoBroadcast(...) )
		 *
		 *	@seealso	OPropertySetHelper
		 *	@seealso	setFastPropertyValue_NoBroadcast()
		 *
	 	 *	@param		"rConvertedValue"	new converted value of property
	 	 *	@param		"rOldValue"			old value of property
	 	 *	@param		"nHandle"			handle of property
	 	 *	@param		"rValue"			new value of property
		 *
		 *	@return		sal_True if value will be changed, sal_FALSE otherway
		 *
		 *	@onerror	IllegalArgumentException, if you call this with an invalid argument
	 	 */

		virtual sal_Bool convertFastPropertyValue ( ANY& rConvertedValue, ANY& rOldValue, sal_Int32 nHandle, const ANY& rValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		set value of a transient property
	 	 *	@descr		This method is calling from helperclass "OPropertySetHelper".
		 *				Don't use this directly!
		 *				Handle and value are valid everyway! You must set the new value only.
		 *				After this, baseclass send messages to all listener automaticly.
		 *
		 *	@seealso	OPropertySetHelper
		 *
	 	 *	@param      "nHandle"	handle of property to change
	 	 *	@param      "rValue"	new value of property
		 *
		 *	@return		-
		 *
		 *	@onerror	An exception is thrown.
	 	 */

		virtual void setFastPropertyValue_NoBroadcast ( sal_Int32 nHandle, const ANY& rValue ) throw ( EXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		get value of a transient property
	 	 *	@descr		This method is calling from helperclass "OPropertySetHelper".
		 *				Don't use this directly!
		 *
		 *	@seealso	OPropertySetHelper
		 *
	 	 *	@param      "nHandle"	handle of property to change
	 	 *	@param      "rValue"	current value of property
		 *
		 *	@return		-
		 *
		 *	@onerror	-
	 	 */

		virtual void getFastPropertyValue ( ANY& rValue, sal_Int32 nHandle ) const ;

		/****************************************************************************
	 	 *	@short      return structure and information about transient properties
	 	 *	@descr		This method is calling from helperclass "OPropertySetHelper".
		 *				Don't use this directly!
		 *
		 *	@seealso	OPropertySetHelper
		 *
	 	 *	@param		-
		 *
		 *	@return		structure with property-informations
		 *
		 *	@onerror	-
	 	 */

		virtual IPROPERTYARRAYHELPER& getInfoHelper () ;

		/****************************************************************************
	 	 *	@short		return propertysetinfo
	 	 *	@descr		You can call this method to get information about transient properties
		 *				of this object.
		 *
		 *	@seealso	XPropertySet
		 *	@seealso	XMultiPropertySet
		 *
	 	 *	@param		-
		 *
		 *	@return		reference to object with information [XPropertySetInfoRef]
		 *
		 *	@onerror	-
	 	 */

		virtual REFERENCE< XPROPERTYSETINFO > SAL_CALL getPropertySetInfo () ;

	//---------------------------------------------------------------------------
	//	private methods
	//---------------------------------------------------------------------------
	private:

		/****************************************************************************
	 	 *	@short		methods to try to change a value of a property
	 	 *	@descr		This method is used by "convertFastPropertyValue()". There are different
		 *				methods for different basetypes of properties.
		 *
		 *	@seealso	convertFastPropertyValue()
		 *
	 	 *	@param		"rProperty"			reference to property
	 	 *	@param		"rValue"			new value of property
	 	 *	@param		"rOldValue"			current value of property
	 	 *	@param		"rConvertedValue"	new converted value of property
		 *
		 *	@return		sal_True if value has changed, sal_False otherway
		 *
		 *	@onerror	IllegalArgumentException, if you call this with an invalid argument.
	 	 */

		sal_Bool impl_tryToChangeProperty ( const OUSTRING&  			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const DATETIME&  			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const sal_Bool&  			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const sal_Int16& 			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const sal_uInt16& 			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const sal_Int32& 			rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;
		sal_Bool impl_tryToChangeProperty ( const SEQUENCE< sal_Int8 >&	rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( ILLEGALARGUMENTEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		impl. method to read properties from opened stream
	 	 *	@descr		Is used by method "XPersist::read()".
		 *
		 *	@seealso	read()
		 *
	 	 *	@param		"rStream"	reference to opened stream for reading
		 *
		 *	@return		-
		 *
		 *	@onerror    wrong headertype	=> 	IOException
		 *				DocUserKey's empty	=> 	IOException
		 *				general read error	=> 	IOException
	 	 */

		void impl_readStream ( SvStream& rStream ) throw ( IOEXCEPTION, RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		impl. method to write properties to opened stream
	 	 *	@descr		Is used by method "XPersist::write()".
		 *
		 *	@seealso	write()
		 *
	 	 *	@param		"rStream"	reference to opened stream for writing
		 *
		 *	@return		-
		 *
		 *	@onerror    general write error	=> 	IOException
	 	 */

		void impl_writeStream ( SvStream& rStream ) throw ( IOEXCEPTION, RUNTIMEEXCEPTION ) ;

		/****************************************************************************
	 	 *	@short		help methods to read variables with different types from stream
	 	 *	@descr		Sometimes we must convert a readed value or look for somethings else.
		 *				These methods do that.
		 *
		 *	@seealso	impl_readStream()
		 *
	 	 *	@param		"rStream"	reference to stream for reading
	 	 *	@param		"nFixSize"	some strings have a fixed size in file
		 *							(Use this parameter to read all bytes from stream for this string.
		 *							If "nFixSize" == 0, this option is ignored!)
		 *
		 *	@return     read value
		 *
		 *	@onerror	empty value
	 	 */

		OUSTRING				impl_readOUString		( SvStream& rStream, const sal_uInt16& nFixSize = 0	) ;
		SEQUENCE< sal_Int8 >	impl_readCharSequence	( SvStream& rStream 								) ;
		sal_Bool				impl_readBool			( SvStream& rStream 								) ;
		sal_Int8				impl_readInt8			( SvStream& rStream 								) ;
		sal_Int16				impl_readInt16			( SvStream& rStream 								) ;
		sal_uInt16				impl_readuInt16			( SvStream& rStream 								) ;
		sal_Int32				impl_readInt32			( SvStream& rStream 								) ;
		sal_uInt32				impl_readuInt32			( SvStream& rStream 								) ;

		/****************************************************************************
	 	 *	@short		help methods to write variables with different types to stream
	 	 *	@descr		Sometimes we must convert a value or look for somethings else.
		 *				These methods do that.
		 *
		 *	@seealso	impl_writeStream()
		 *
	 	 *	@param		"rStream"	reference to stream for writing
	 	 *	@param		"nFixSize"	some strings have a fixed size in file
		 *							(Use this parameter to write all bytes to stream for this string.
		 *							If "nFixSize" == 0, this option is ignored!)
		 *
		 *	@return     -
		 *
		 *	@onerror	-
	 	 */

		void impl_writeOUString		( SvStream& rStream, const OUSTRING& rOUString, const sal_uInt16& nFixSize = 0	) ;
		void impl_writeCharSequence	( SvStream& rStream, SEQUENCE< sal_Int8 >& rCharSequence						) ;
		void impl_writeBool			( SvStream& rStream, const sal_Bool& rBool										) ;
		void impl_writeInt8			( SvStream& rStream, const sal_Int8& rInt8										) ;
		void impl_writeInt16		( SvStream& rStream, const sal_Int16& rInt16									) ;
		void impl_writeuInt16		( SvStream& rStream, const sal_uInt16& ruInt16									) ;
		void impl_writeInt32		( SvStream& rStream, const sal_Int32& rInt32  									) ;
		void impl_writeuInt32		( SvStream& rStream, const sal_uInt32& ruInt32  								) ;

		/****************************************************************************
	 	 *	@short		convert a format-ID to right MIMEType
	 	 *	@descr		Use "aStaticConvertTable[]" to do that! (see DocumentProperties.cxx)
		 *
		 *	@seealso	aStaticConvertTable[] in CXX-file
		 *
	 	 *	@param		"rFormatID"		index in aStaticConvertTable[] to get right MIMEType
		 *
		 *	@return		MIMEType as string
		 *
		 *	@onerror	-
	 	 */

		OUSTRING impl_FormatID2MIMEType ( const sal_uInt32& rFormatID ) ;

		/****************************************************************************
	 	 *	@short		convert a format-ID to right fileversion
	 	 *	@descr		Use "aStaticConvertTable[]" to do that! (see DocumentProperties.cxx)
		 *
		 *	@seealso	aStaticConvertTable[] in CXX-file
		 *
	 	 *	@param		"rFormatID"		index in aStaticConvertTable[] to get right fileversion
		 *
		 *	@return		fileversion as long
		 *
		 *	@onerror	-
	 	 */

		sal_Int32 impl_FormatID2FileVersion ( const sal_uInt32& rFormatID ) ;

		/****************************************************************************
	 	 *	@short		check fileversion for right value
	 	 *	@descr		There are 4 right value for this only. This method check it.
		 *
		 *	@seealso	SOFFICE_FILEVERSION_31 ... SOFFICE_FILEVERSION_NOW in "tools/solar.h"
		 *
	 	 *	@param		"rFileVersion"		value to check
		 *
		 *	@return		sal_True	, if version ok
		 *	@return		sal_False	, if version invalid
		 *
		 *	@onerror	-
	 	 */

		sal_Bool impl_isFileVersionValid ( const sal_Int32& rFileVersion ) ;

		/****************************************************************************
	 	 *	@short		follow methods convert a timestamp->datetime and datetime->timestamp
	 	 *	@descr		We can't use a DateTime-object directly as UNO-Type! We must use a
		 *				DateTime-structure. But TimeStamp can't use this. We must convert variables.
		 *
		 *	@seealso	tools/TimeStamp
		 *	@seealso	tools/DateTime
		 *	@seealso	struct ::com::sun::star::util::DateTime
		 *
	 	 *	@param      "rTimeStamp"	reference to TimeStamp-object
	 	 *	@param      "rDateTime"		reference to DateTime-structure
		 *
		 *	@return		a TimeStamp-object or a DateTime-structure
		 *
		 *	@onerror	-
	 	 */

		DATETIME	impl_TimeStamp2DateTime ( const TimeStamp&	rTimeStamp	) ;
		TimeStamp	impl_DateTime2TimeStamp ( const DATETIME&	rDateTime	) ;

		/****************************************************************************
	 	 *	@short		convert String->OUString and OUString->String
	 	 *	@descr		We must look for right encoding to do that.
		 *
		 *	@seealso	OStringToOUString()
		 *	@seealso	OUStringToOString()
		 *
	 	 *	@param		"rString"	reference to String to convert
	 	 *	@param		"rOUString"	reference to OUString to convert
		 *
		 *	@return		converted String or OUString with right encoding
		 *
		 *	@onerror	-
	 	 */

		OUSTRING	impl_String2OUString ( const String&	rString		) ;
		String		impl_OUString2String ( const OUSTRING&	rOUString	) ;

		/****************************************************************************
	 	 *	@short		set default values on members of this class and free used memory
	 	 *	@descr		Is used to reset state of object. (for example before read new properties from stream!)
		 *
		 *	@seealso	DocumentProperties()
		 *	@seealso	read()
		 *
	 	 *	@param		-
		 *
		 *	@return		-
		 *
		 *	@onerror	-
	 	 */

		void impl_resetObject () ;

		/****************************************************************************
	 	 *	@short		reset values of a datetime-structure
	 	 *	@descr		We can't use DateTime-object from tools directly as property type!
		 *				We must use a DateTime-struct. And this method set default values
		 *				for struct-members.
		 *
		 *	@seealso	struct ::com::sun::star::util::DateTime
		 *
	 	 *	@param		"rDateTime"	reference to structure to reset
		 *
		 *	@return		-
		 *
		 *	@onerror	-
	 	 */

		void impl_resetDateTime ( DATETIME& rDateTime ) ;

		/****************************************************************************
	 	 *	@short
	 	 *	@descr
		 *
		 *	@seealso
		 *
	 	 *	@param
		 *
		 *	@return
		 *
		 *	@onerror
	 	 */

		static const SEQUENCE< PROPERTY > impl_getStaticPropertyDescriptor();

	//---------------------------------------------------------------------------
	//	debug methods
	//---------------------------------------------------------------------------
	private:

		#ifdef DBG_UTIL

			/****************************************************************************
	 	 	 *	@short		debug-method to check parameter of some other mehods of this class
	 	 	 *	@descr		The following methods are used to check parameters for other methods
			 *				of this class. The return value is used directly for DBG_ASSERT(...).
		 	 *
		 	 *	@seealso	DBG_ASSERTs in implementation!
		 	 *
	 	 	 *	@param		references to checking variables
		 	 *
		 	 *	@return		sal_FALSE on invalid parameter, sal_TRUE otherway
		 	 *
		 	 *	@onerror	-
	 	 	 */

			sal_Bool	impl_debug_checkParameter	( const UNOTYPE& rType											) 		;
			sal_Bool	impl_debug_checkParameter	( const OUSTRING& rOUString										) 		;
			sal_Bool	impl_debug_checkParameter	( ANY& rAny1, ANY& rAny2, sal_Int32 nInt32, const ANY& rAny3	) 		;
			sal_Bool	impl_debug_checkParameter	( sal_Int32 nInt32, const ANY& rAny								) 		;
			sal_Bool	impl_debug_checkParameter	( ANY& rAny, sal_Int32 nInt32									) const ;

			/****************************************************************************
	 	 	 *	@short		debug-method to check state of a SvStream
	 	 	 *	@descr		We don't control SvStream everytime ... (Performance!)
			 *				But for debugging and testing, you can activate this by set
			 *				define "SWITCH_ON_CHECK_SVSTREAM". This mechanism is used
			 *				in all "impl_readXXXX()"- and "impl_writeXXXX"-methods.
		 	 *
		 	 *	@seealso	impl_readXXX() and impl_writeXXX() methods
		 	 *
	 	 	 *	@param		"rStream"	reference to stream for checking
	 	 	 *	@param		"rPosition"	string with name of method, who is calling this method!
		 	 *
		 	 *	@return		-
		 	 *
		 	 *	@onerror	A assertion is thrown.
	 	 	 */

			#ifdef DOCUMENTPROPERTIES_SWITCH_ON_CHECK_SVSTREAM
				void impl_debug_checkSvStream ( SvStream& rStream, const String& rPosition ) ;
			#endif // DOCUMENTPROPERTIES_SWITCH_ON_CHECK_SVSTREAM

		#endif	// DBG_UTIL

	//---------------------------------------------------------------------------
	//	public variables
	//---------------------------------------------------------------------------
	public:

	//---------------------------------------------------------------------------
	//	private structs, types etcpp.
	//---------------------------------------------------------------------------
	private:

		/****************************************************************************
	 	 *	@short		compare keys of hashmap
	 	 *	@descr      This struct is used by stl_hash_map, to convert two keynames of type OUString.
		 *
		 *	@seealso	stl::hashmap
		 *	@seealso	typedef HASH_MAP< ... > IMPL_OPropertyHashTable
		 *
	 	 *	@param		"sString1"	first  keyname
	 	 *	@param		"sString2"	second keyname
		 *
		 *	@return		sal_True if given keynames are equal, sal_False otherway
		 *
		 *	@onerror	-
	 	 */

		struct IMPL_equalOUString
		{
  			sal_Bool operator() ( const OUSTRING& rString1, const OUSTRING& rString2 ) const
  			{
    			return ( rString1 == rString2 ) ;
  			}
		} ;

		/****************************************************************************
	 	 *	@short		return the hashcode of hashfunction for hashmap
	 	 *	@descr      This struct is used by stl_hash_map, to use own hashfunction.
		 *
		 *	@seealso	stl::hashmap
		 *	@seealso	OUString.hashCode()
		 *
	 	 *	@param		"rKey"	reference to searched keyname
		 *
		 *	@return		hashcode for this key
		 *
		 *	@onerror	-
	 	 */

		struct IMPL_hashOUString
		{
			size_t operator() ( const OUSTRING& rKey ) const
			{
				return ( rKey.hashCode () ) ;
			}
		} ;

		/****************************************************************************
	 	 *	@short      type for hashtable for persistent properties
		 *
		 *	@seealso	struct IMPL_equalOUString
		 *	@seealso	struct IMPL_hashOUString
	 	 */

		typedef HASH_MAP<	OUSTRING			,
							OUSTRING			,
							IMPL_hashOUString	,
							IMPL_equalOUString	> IMPL_OPropertyHashTable ;

	//---------------------------------------------------------------------------
	//	private variables
	//---------------------------------------------------------------------------
	private:

		REFERENCE< XMULTISERVICEFACTORY >		m_rFactory					;	/// Reference to factory, which has create this instance.
		IMPL_OPropertyHashTable					m_aPropertyHashTable		;	/// hashtable for persistent properties (used by XNameContainer)
		OUSTRING								m_sHeaderType				;	/// Typename of header
		sal_uInt16								m_nHeaderVersion			;	/// Version number of header
		// m_eFileCharset = sal_uInt16 in file !
		CharSet									m_eFileCharSet				;	/// CharSet of documentinfo
		sal_uInt32								m_nFormatID					;	/// Used to set MIMEType and FileVersion, if not exist in document or has invalid value

		// fixed Properties (sort by name and used by XPropertySet)
		OUSTRING								m_sAuthor					;	/// Creator of this document
		sal_Bool								m_bAutoloadEnabled			;	/// Automatic reload enabled/disabled ?
		sal_Int32								m_nAutoloadSecs     		;	/// Time cycle for automatic reload
		OUSTRING								m_sAutoloadURL      		;	/// URL for automatic reload
		OUSTRING								m_sBlindCopiesTo    		;	/// Adress for BCC
		OUSTRING								m_sCopiesTo           		;	///	Adress CC
		DATETIME								m_aCreationDate     		;	/// Time and date of document creation
		OUSTRING								m_sDefaultTarget    		;	/// Name of default target
		OUSTRING								m_sDescription      		;	/// Short description and comments
		sal_Int16								m_nEditingCycles			;	/// Document number
		sal_Int32								m_nEditingDuration			;	/// Duration since last edit
		SEQUENCE< sal_Int8 >					m_seqExtraData				;	/// Buffer of bytes for some extra data
		OUSTRING								m_sInReplyTo				;	/// Adress for reply to ...
		sal_Bool								m_bIsEncrypted				;	/// Document is en/decrypted
		OUSTRING								m_sKeywords					;	/// Some keywords
		OUSTRING								m_sMIMEType					;	/// MIME-type of document
		OUSTRING								m_sModifiedBy				;	/// Name of user who has modified as last one
		DATETIME								m_aModifyDate				;	/// Date and time of last modification
		OUSTRING								m_sNewsgroups				;	/// Document is a message of newsgroup
		OUSTRING								m_sOriginal					;	/// Message ID
		sal_Bool								m_bPortableGraphics			;	/// Use of portable graphics
		DATETIME								m_aPrintDate				;	/// Date and time of last print
		OUSTRING								m_sPrintedBy				;	/// Name of user who has printed as last one
		sal_uInt16								m_nPriority					;	/// Priority of message, if document a message!
		sal_Bool								m_bQueryTemplate			;	/// Search for template ?
		OUSTRING								m_sRecipient				;	/// Name of recipient
		OUSTRING								m_sReferences				;	/// Some references to other things
		OUSTRING								m_sReplyTo					;	/// Adress to reply
		sal_Bool								m_bSaveGraphicsCompressed	;	/// Compressed/non compressed graphics
		sal_Bool								m_bSaveOriginalGraphics		;	/// Include graphics
		sal_Bool								m_bSaveVersionOnClose		;	/// Save version on close of document ?
		OUSTRING								m_sTemplate					;	/// Name of template
		sal_Bool								m_bTemplateConfig			;	/// Exist template config ?
		DATETIME								m_aTemplateDate				;	/// Date and time of template
		OUSTRING								m_sTemplateFileName			;	/// File name of template
		OUSTRING								m_sTheme					;	/// Name of theme
		OUSTRING								m_sTitle					;	/// Title of document
		sal_Bool								m_bUserData					;	/// Exist user data ?

		static SEQUENCE< PROPERTY >* pPropertyDescriptor ;

} ; // class DOCUMENTPROPERTIES

#endif	// __DOCUMENTPROPERTIES_HXX_
