/*************************************************************************
 *
 *  $RCSfile: macros.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_MACROS_HXX_
#define __FRAMEWORK_MACROS_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_PRIVATEMACROS_HXX_
#include <helper/privatemacros.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_XINTERFACE_HPP_
#include <com/sun/star/uno/XInterface.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	XINTERFACE						::com::sun::star::uno::XInterface
#define	XMULTISERVICEFACTORY			::com::sun::star::lang::XMultiServiceFactory

//_________________________________________________________________________________________________________________
//	macros for declaration and definition of uno-services
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	declaration of XInterface
//*****************************************************************************************************************
#define DECLARE_XINTERFACE																						   	\
																												   	\
	virtual ANY SAL_CALL queryInterface( const UNOTYPE& aType ) throw( RUNTIMEEXCEPTION );	   						\
    virtual void SAL_CALL acquire() throw( RUNTIMEEXCEPTION );											   			\
	virtual void SAL_CALL release() throw( RUNTIMEEXCEPTION );

//*****************************************************************************************************************
//	declaration of XTypeProvider
//*****************************************************************************************************************
#define DECLARE_XTYPEPROVIDER																						\
			   																										\
	virtual SEQUENCE< UNOTYPE > SAL_CALL getTypes() throw( RUNTIMEEXCEPTION );										\
	virtual SEQUENCE< sal_Int8 > SAL_CALL getImplementationId() throw( RUNTIMEEXCEPTION );

//*****************************************************************************************************************
//	declaration of XServiceInfo and helper functions
//*****************************************************************************************************************
#define DECLARE_XSERVICEINFO																											\
																																		\
	/* XServiceInfo */																													\
	virtual OUSTRING SAL_CALL getImplementationName() throw( RUNTIMEEXCEPTION );														\
    virtual sal_Bool SAL_CALL supportsService( const OUSTRING& sServiceName ) throw( RUNTIMEEXCEPTION );								\
    virtual SEQUENCE< OUSTRING > SAL_CALL getSupportedServiceNames() throw( RUNTIMEEXCEPTION );											\
																																		\
	/* Helper for XServiceInfo */																										\
	static SEQUENCE< OUSTRING > impl_getStaticSupportedServiceNames();																	\
	static OUSTRING impl_getStaticImplementationName();																					\
																																		\
	/* Helper for registry */																											\
	static REFERENCE< XINTERFACE > impl_createInstance( const REFERENCE< XMULTISERVICEFACTORY >& xServiceManager ) throw( EXCEPTION );	\
	static REFERENCE< XSINGLESERVICEFACTORY > impl_createFactory( const REFERENCE< XMULTISERVICEFACTORY >& xServiceManager );

//*****************************************************************************************************************
//	help macros for follow XInterface definitions
//*****************************************************************************************************************

//	Use it as parameter for DEFINE_XINTERFACE_X(), if you CAN use an interface directly in queryInterface()!
#define	DIRECT_INTERFACE( INTERFACE )	\
	static_cast< INTERFACE##* >( this )

//	Use it as parameter for DEFINE_XINTERFACE_X(), if you CAN'T use an interface directly in queryInterface()!
#define	DERIVED_INTERFACE( BASEINTERFACE, DERIVEDINTERFACE )	\
	static_cast< BASEINTERFACE##* >( static_cast< DERIVEDINTERFACE##* >( this ) )

//*****************************************************************************************************************
//	implementation of XInterface
//*****************************************************************************************************************

//	implementation of XInterface with 0 additional interface for queryInterface()
#define DEFINE_XINTERFACE_0( CLASS, BASECLASS )	\
	PRIVATE_DEFINE_XINTERFACE_PURE	(	CLASS,										\
								  		BASECLASS									\
									)

//	implementation of XInterface with 1 additional interface for queryInterface()
#define DEFINE_XINTERFACE_1( CLASS, BASECLASS, INTERFACE1 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
							 		BASECLASS,										\
							 		PRIVATE_DEFINE_INTERFACE_1	(	INTERFACE1		\
																)					\
								)

//	implementation of XInterface with 2 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_2( CLASS, BASECLASS, INTERFACE1, INTERFACE2 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_2	(	INTERFACE1	,	\
																	INTERFACE2		\
																)					\
								)

//	implementation of XInterface with 3 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_3( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_3	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3		\
																)					\
								)

//	implementation of XInterface with 4 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_4( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_4	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4		\
																)					\
								)

//	implementation of XInterface with 5 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_5( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_5	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5		\
																)					\
								)

//	implementation of XInterface with 6 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_6( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_6	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6		\
																)					\
								)

//	implementation of XInterface with 7 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_7( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_7	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7		\
																)					\
								)

//	implementation of XInterface with 8 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_8( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_8	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7	,	\
																	INTERFACE8		\
																)					\
								)

//	implementation of XInterface with 9 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_9( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_9	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7	,	\
																	INTERFACE8	,	\
																	INTERFACE9		\
																)					\
								)

//	implementation of XInterface with 10 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_10( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_10	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7	,	\
																	INTERFACE8	,	\
																	INTERFACE9	,	\
																	INTERFACE10		\
																)					\
								)

//	implementation of XInterface with 11 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_11( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_11	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7	,	\
																	INTERFACE8	,	\
																	INTERFACE9	,	\
																	INTERFACE10	,	\
																	INTERFACE11		\
																)					\
								)

//	implementation of XInterface with 12 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_12( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12 )	\
	PRIVATE_DEFINE_XINTERFACE	(	CLASS,											\
									BASECLASS,										\
									PRIVATE_DEFINE_INTERFACE_12	(	INTERFACE1	,	\
																	INTERFACE2	,	\
																	INTERFACE3	,	\
																	INTERFACE4	,	\
																	INTERFACE5	,	\
																	INTERFACE6	,	\
																	INTERFACE7	,	\
																	INTERFACE8	,	\
																	INTERFACE9	,	\
																	INTERFACE10	,	\
																	INTERFACE11	,	\
																	INTERFACE12		\
																)					\
								)

//	implementation of XInterface with 13 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_13( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12, INTERFACE13 )	\
	PRIVATE_DEFINE_XINTERFACE_LARGE	(	CLASS,											\
										BASECLASS,										\
										PRIVATE_DEFINE_INTERFACE_12	(	INTERFACE1	,	\
																		INTERFACE2	,	\
																		INTERFACE3	,	\
																		INTERFACE4	,	\
																		INTERFACE5	,	\
																		INTERFACE6	,	\
																		INTERFACE7	,	\
																		INTERFACE8	,	\
																		INTERFACE9	,	\
																		INTERFACE10	,	\
																		INTERFACE11	,	\
																		INTERFACE12		\
																	),					\
										PRIVATE_DEFINE_INTERFACE_1	(	INTERFACE13		\
																	)					\
									)

//	implementation of XInterface with 14 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_14( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12, INTERFACE13, INTERFACE14 )	\
	PRIVATE_DEFINE_XINTERFACE_LARGE	(	CLASS,											\
										BASECLASS,										\
										PRIVATE_DEFINE_INTERFACE_12	(	INTERFACE1	,	\
																		INTERFACE2	,	\
																		INTERFACE3	,	\
																		INTERFACE4	,	\
																		INTERFACE5	,	\
																		INTERFACE6	,	\
																		INTERFACE7	,	\
																		INTERFACE8	,	\
																		INTERFACE9	,	\
																		INTERFACE10	,	\
																		INTERFACE11	,	\
																		INTERFACE12		\
																	),					\
										PRIVATE_DEFINE_INTERFACE_2	(	INTERFACE13	,	\
																		INTERFACE14		\
																	)					\
									)

//	implementation of XInterface with 15 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_15( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12, INTERFACE13, INTERFACE14, INTERFACE15 )	\
	PRIVATE_DEFINE_XINTERFACE_LARGE	(	CLASS,											\
										BASECLASS,										\
										PRIVATE_DEFINE_INTERFACE_12	(	INTERFACE1	,	\
																		INTERFACE2	,	\
																		INTERFACE3	,	\
																		INTERFACE4	,	\
																		INTERFACE5	,	\
																		INTERFACE6	,	\
																		INTERFACE7	,	\
																		INTERFACE8	,	\
																		INTERFACE9	,	\
																		INTERFACE10	,	\
																		INTERFACE11	,	\
																		INTERFACE12		\
																	),					\
										PRIVATE_DEFINE_INTERFACE_3	(	INTERFACE13	,	\
																		INTERFACE14	,	\
																		INTERFACE15		\
																	)					\
									)

//	implementation of XInterface with 16 additional interfaces for queryInterface()
#define DEFINE_XINTERFACE_16( CLASS, BASECLASS, INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12, INTERFACE13, INTERFACE14, INTERFACE15, INTERFACE16 )	\
	PRIVATE_DEFINE_XINTERFACE_LARGE	(	CLASS,											\
										BASECLASS,										\
										PRIVATE_DEFINE_INTERFACE_12	(	INTERFACE1	,	\
																		INTERFACE2	,	\
																		INTERFACE3	,	\
																		INTERFACE4	,	\
																		INTERFACE5	,	\
																		INTERFACE6	,	\
																		INTERFACE7	,	\
																		INTERFACE8	,	\
																		INTERFACE9	,	\
																		INTERFACE10	,	\
																		INTERFACE11	,	\
																		INTERFACE12		\
																	),					\
										PRIVATE_DEFINE_INTERFACE_4	(	INTERFACE13	,	\
																		INTERFACE14	,	\
																		INTERFACE15	,	\
																		INTERFACE16		\
																	)					\
									)



//*****************************************************************************************************************
//	implementation of XTypeProvider
//*****************************************************************************************************************

//	implementation of XTypeProvider without additional interface for getTypes()
//	XTypeProvider is used as the only one interface automaticly.
//	Following defines don't use XTypeProvider automaticly!!!!
#define DEFINE_XTYPEPROVIDER_0( CLASS )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_PURE(	CLASS )

//	implementation of XTypeProvider with 1 additional interface for getTypes()
#define DEFINE_XTYPEPROVIDER_1( CLASS, TYPE1 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_1	(	TYPE1			\
																)					\
									)

//	implementation of XTypeProvider with 2 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_2( CLASS, TYPE1, TYPE2 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_2	(	TYPE1	,		\
																	TYPE2			\
																)					\
									)

//	implementation of XTypeProvider with 3 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_3( CLASS, TYPE1, TYPE2, TYPE3 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_3	(	TYPE1	,		\
																	TYPE2	,		\
																	TYPE3			\
																)					\
									)

//	implementation of XTypeProvider with 4 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_4( CLASS, TYPE1, TYPE2, TYPE3, TYPE4 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_4	(	TYPE1	,		\
																	TYPE2	,		\
																	TYPE3	,		\
																	TYPE4			\
																)					\
									)

//	implementation of XTypeProvider with 5 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_5( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_5	(	TYPE1	,		\
																	TYPE2	,		\
																	TYPE3	,		\
																	TYPE4	,		\
																	TYPE5			\
																)					\
									)

//	implementation of XTypeProvider with 6 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_6( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,										\
										PRIVATE_DEFINE_TYPE_6	(	TYPE1	,		\
																	TYPE2	,		\
																	TYPE3	,		\
																	TYPE4	,		\
																	TYPE5	,		\
																	TYPE6    		\
																)            		\
									)

//	implementation of XTypeProvider with 7 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_7( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,                               		\
										PRIVATE_DEFINE_TYPE_7	(	TYPE1	,       \
																	TYPE2	,       \
																	TYPE3	,       \
																	TYPE4	,       \
																	TYPE5	,       \
																	TYPE6	,       \
																	TYPE7           \
																)                   \
									)

//	implementation of XTypeProvider with 8 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_8( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,                                      \
										PRIVATE_DEFINE_TYPE_8	(	TYPE1	,       \
																	TYPE2	,       \
																	TYPE3	,       \
																	TYPE4	,       \
																	TYPE5	,       \
																	TYPE6	,       \
																	TYPE7	,       \
																	TYPE8           \
																)                   \
									)

//	implementation of XTypeProvider with 9 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_9( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,                                      \
										PRIVATE_DEFINE_TYPE_9	(	TYPE1	,       \
																	TYPE2	,       \
																	TYPE3	,       \
																	TYPE4	,       \
																	TYPE5	,       \
																	TYPE6	,       \
																	TYPE7	,       \
																	TYPE8	,       \
																	TYPE9           \
																)                   \
									)

//	implementation of XTypeProvider with 10 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_10( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,                                      \
										PRIVATE_DEFINE_TYPE_10	(	TYPE1	,       \
																	TYPE2	,       \
																	TYPE3	,       \
																	TYPE4	,       \
																	TYPE5	,       \
																	TYPE6	,       \
																	TYPE7	,       \
																	TYPE8	,       \
																	TYPE9	,       \
																	TYPE10          \
																)                   \
									)

//	implementation of XTypeProvider with 11 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_11( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER	(	CLASS,                                      \
										PRIVATE_DEFINE_TYPE_11	(	TYPE1	,       \
																	TYPE2	,       \
																	TYPE3	,       \
																	TYPE4	,       \
																	TYPE5	,       \
																	TYPE6	,       \
																	TYPE7	,       \
																	TYPE8	,       \
																	TYPE9	,       \
																	TYPE10	,       \
																	TYPE11          \
																)                   \
									)

//	implementation of XTypeProvider with 12 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_12( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE	(	CLASS,                                  \
											PRIVATE_DEFINE_TYPE_12	(	TYPE1	,   \
																		TYPE2	,   \
																		TYPE3	,   \
																		TYPE4	,   \
																		TYPE5	,   \
																		TYPE6	,   \
																		TYPE7	,   \
																		TYPE8	,   \
																		TYPE9	,   \
																		TYPE10	,   \
																		TYPE11	,	\
																		TYPE12      \
																	)				\
										)

//	implementation of XTypeProvider with 13 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_13( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12, TYPE13 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE	(	CLASS,                                  \
											PRIVATE_DEFINE_TYPE_12	(	TYPE1	,   \
																		TYPE2	,   \
																		TYPE3	,   \
																		TYPE4	,   \
																		TYPE5	,   \
																		TYPE6	,   \
																		TYPE7	,   \
																		TYPE8	,   \
																		TYPE9	,   \
																		TYPE10	,   \
																		TYPE11	,   \
																		TYPE12      \
																	),              \
											PRIVATE_DEFINE_TYPE_1	(	TYPE13		\
																	)               \
										)

//	implementation of XTypeProvider with 14 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_14( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12, TYPE13, TYPE14 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE	(	CLASS,                                  \
											PRIVATE_DEFINE_TYPE_12	(	TYPE1	,   \
																		TYPE2	,   \
																		TYPE3	,   \
																		TYPE4	,   \
																		TYPE5	,   \
																		TYPE6	,   \
																		TYPE7	,   \
																		TYPE8	,   \
																		TYPE9	,   \
																		TYPE10	,   \
																		TYPE11	,   \
																		TYPE12      \
																	),              \
											PRIVATE_DEFINE_TYPE_2	(	TYPE13	,   \
																		TYPE14		\
																	)               \
										)

//	implementation of XTypeProvider with 15 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_15( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12, TYPE13, TYPE14, TYPE15 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE	(	CLASS,                                  \
											PRIVATE_DEFINE_TYPE_12	(	TYPE1	,   \
																		TYPE2	,   \
																		TYPE3	,   \
																		TYPE4	,   \
																		TYPE5	,   \
																		TYPE6	,   \
																		TYPE7	,   \
																		TYPE8	,   \
																		TYPE9	,   \
																		TYPE10	,   \
																		TYPE11	,   \
																		TYPE12      \
																	),              \
											PRIVATE_DEFINE_TYPE_3	(	TYPE13	,   \
																		TYPE14	,   \
																		TYPE15      \
																	)               \
										)

//	implementation of XTypeProvider with 16 additional interfaces for getTypes()
#define DEFINE_XTYPEPROVIDER_16( CLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12, TYPE13, TYPE14, TYPE15, TYPE16 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE	(	CLASS,                                  \
											PRIVATE_DEFINE_TYPE_12	(	TYPE1	,   \
																		TYPE2	,   \
																		TYPE3	,   \
																		TYPE4	,   \
																		TYPE5	,   \
																		TYPE6	,   \
																		TYPE7	,   \
																		TYPE8	,   \
																		TYPE9	,   \
																		TYPE10	,   \
																		TYPE11	,   \
																		TYPE12      \
																	),              \
											PRIVATE_DEFINE_TYPE_4	(	TYPE13	,   \
																		TYPE14	,   \
																		TYPE15	,   \
																		TYPE16      \
																	)               \
										)

//	implementation of XTypeProvider with 1 additional interface for getTypes() AND using 1 baseclass
#define DEFINE_XTYPEPROVIDER_1_WITH_BASECLASS( CLASS, BASECLASS, TYPE1 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS	(	CLASS,								\
												BASECLASS,						 	\
												PRIVATE_DEFINE_TYPE_1	(	TYPE1   \
																		)			\
											)

//	implementation of XTypeProvider with 2 additional interface for getTypes() AND using 1 baseclass
#define DEFINE_XTYPEPROVIDER_2_WITH_BASECLASS( CLASS, BASECLASS, TYPE1, TYPE2 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS	(	CLASS,									\
												BASECLASS,						 		\
												PRIVATE_DEFINE_TYPE_2	(	TYPE1	,   \
																			TYPE2		\
																		)				\
											)

//	implementation of XTypeProvider with 3 additional interface for getTypes() AND using 1 baseclass
#define DEFINE_XTYPEPROVIDER_3_WITH_BASECLASS( CLASS, BASECLASS, TYPE1, TYPE2, TYPE3 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS	(	CLASS,									\
												BASECLASS,						 		\
												PRIVATE_DEFINE_TYPE_3	(	TYPE1	,   \
																			TYPE2	,   \
																			TYPE3		\
																		)				\
											)
//	implementation of XTypeProvider with 4 additional interface for getTypes() AND using 1 baseclass
#define DEFINE_XTYPEPROVIDER_4_WITH_BASECLASS( CLASS, BASECLASS, TYPE1, TYPE2, TYPE3, TYPE4 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS	(	CLASS,									\
												BASECLASS,						 		\
												PRIVATE_DEFINE_TYPE_4	(	TYPE1	,   \
																			TYPE2	,   \
																			TYPE3	,   \
																			TYPE4		\
																		)				\
											)
//	implementation of XTypeProvider with 5 additional interface for getTypes() AND using 1 baseclass
#define DEFINE_XTYPEPROVIDER_5_WITH_BASECLASS( CLASS, BASECLASS, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5 )	\
	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS	(	CLASS,									\
												BASECLASS,						 		\
												PRIVATE_DEFINE_TYPE_5	(	TYPE1	,   \
																			TYPE2	,   \
																			TYPE3	,   \
																			TYPE4	,   \
																			TYPE5		\
																		)				\
											)

//*****************************************************************************************************************
//	implementation of XServiceInfo
//*****************************************************************************************************************

/*==================================================================================*/	\
#define	DEFINE_XSERVICEINFO_MULTISERVICE( CLASS, SERVICENAME, IMPLEMENTATIONNAME )		\
																						\
	PRIVATE_DEFINE_XSERVICEINFO( CLASS, SERVICENAME, IMPLEMENTATIONNAME )				\
	PRIVATE_DEFINE_SINGLEFACTORY( CLASS )

/*==================================================================================*/	\
#define	DEFINE_XSERVICEINFO_ONEINSTANCESERVICE( CLASS, SERVICENAME, IMPLEMENTATIONNAME )\
																						\
	PRIVATE_DEFINE_XSERVICEINFO( CLASS, SERVICENAME, IMPLEMENTATIONNAME )				\
	PRIVATE_DEFINE_ONEINSTANCEFACTORY( CLASS )

}		//	namespace framework

#endif	//	#ifndef __FRAMEWORK_MACROS_HXX_
