/*************************************************************************
 *
 *  $RCSfile: privatemacros.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_PRIVATEMACROS_HXX_
#define __FRAMEWORK_PRIVATEMACROS_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_EXCEPTION_HPP_
#include <com/sun/star/uno/Exception.hpp>
#endif

#ifndef _COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP_
#include <com/sun/star/uno/RuntimeException.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif

#ifndef _COM_SUN_STAR_UNO_TYPE_H_
#include <com/sun/star/uno/Type.h>
#endif

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif

#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryInterface.hxx>
#endif

#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	XTYPEPROVIDER					::com::sun::star::lang::XTypeProvider
#define	XSINGLESERVICEFACTORY			::com::sun::star::lang::XSingleServiceFactory

#define	OIMPLEMENTATIONID				::cppu::OImplementationId
#define	OTYPECOLLECTION					::cppu::OTypeCollection
#define	OUSTRING						::rtl::OUString

#define	EXCEPTION						::com::sun::star::uno::Exception
#define	RUNTIMEEXCEPTION				::com::sun::star::uno::RuntimeException

#define	ANY								::com::sun::star::uno::Any
#define	MUTEX							::osl::Mutex
#define	MUTEXGUARD						::osl::MutexGuard
#define	REFERENCE						::com::sun::star::uno::Reference
#define	SEQUENCE						::com::sun::star::uno::Sequence
#define	UNOTYPE							::com::sun::star::uno::Type

//_________________________________________________________________________________________________________________
//	macros for declaration and definition of uno-services
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	implementation of	XInterface::aquire()
//						XInterface::release()
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_XINTERFACE_AQUIRE_RELEASE( CLASS, BASECLASS )												\
																													\
	/*===========================================================================================================*/	\
	void SAL_CALL CLASS##::acquire() throw( RUNTIMEEXCEPTION )														\
	{																												\
		/* Don't use mutex in methods of XInterface! */																\
		BASECLASS##::acquire();																						\
	}																												\
																													\
	/*===========================================================================================================*/	\
    void SAL_CALL CLASS##::release() throw( RUNTIMEEXCEPTION )														\
	{																												\
		/* Don't use mutex in methods of XInterface! */																\
		BASECLASS##::release();																						\
	}

//*****************************************************************************************************************
//	implementation of XInterface::queryInterface() without any other interfaces!
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE_PURE( CLASS, BASECLASS )											\
																													\
	ANY SAL_CALL CLASS##::queryInterface( const UNOTYPE& aType ) throw( RUNTIMEEXCEPTION )							\
	{																												\
		/* Attention: Don't use mutex or guard in this method!!! Is a method of XInterface.	*/						\
		/* I have no own supported interfaces ...											*/						\
		/* ... ask baseclass for interfaces! 												*/						\
		return BASECLASS##::queryInterface( aType );																\
	}

//*****************************************************************************************************************
//	implementation of XInterface::queryInterface() with other interfaces!
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE( CLASS, BASECLASS, INTERFACES )									\
																													\
	ANY SAL_CALL CLASS##::queryInterface( const UNOTYPE& aType ) throw( RUNTIMEEXCEPTION )							\
	{																												\
		/* Attention: Don't use mutex or guard in this method!!! Is a method of XInterface.	*/						\
		/* Ask for my own supported interfaces ...											*/						\
		ANY aReturn	( ::cppu::queryInterface(	aType,																\
												INTERFACES															\
											)																		\
					);																								\
		/* If searched interface not supported by this class ... */													\
		if ( aReturn.hasValue() == sal_False )																		\
		{																											\
			/* ... ask baseclass for interfaces! */																	\
			aReturn = BASECLASS##::queryInterface( aType );															\
		}																											\
		/* Return result of this search. */																			\
		return aReturn;																								\
	}

//*****************************************************************************************************************
//	implementation of XInterface::queryInterface() with more then 12 other interfaces!
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE_LARGE( CLASS, BASECLASS, INTERFACES_FIRST, INTERFACES_SECOND )		\
																													\
	ANY SAL_CALL CLASS##::queryInterface( const UNOTYPE& aType ) throw( RUNTIMEEXCEPTION )							\
	{																												\
		/* Attention: Don't use mutex or guard in this method!!! Is a method of XInterface.	*/						\
		/* Ask for my own supported interfaces ...											*/						\
		ANY aReturn	( ::cppu::queryInterface(	aType,																\
												INTERFACES_FIRST													\
											)																		\
					);																								\
		/* If searched interface not supported by first group ... */												\
		if ( aReturn.hasValue() == sal_False )																		\
		{																											\
			/* ... search in second group. (cppuhelper support 12 items only!) */									\
			aReturn	= ::cppu::queryInterface(	aType,																\
					 							INTERFACES_SECOND													\
											);																		\
			/* If searched interface not supported by this class ... */												\
			if ( aReturn.hasValue() == sal_False )																	\
			{																										\
				/* ... ask baseclass for interfaces! */																\
				aReturn = BASECLASS##::queryInterface( aType );														\
			}																										\
		}																											\
		/* Return result of this search. */																			\
		return aReturn;																								\
	}

//*****************************************************************************************************************
//	implementation of XInterface
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_XINTERFACE_PURE( CLASS, BASECLASS )															\
																													\
	PRIVATE_DEFINE_XINTERFACE_AQUIRE_RELEASE( CLASS, BASECLASS )													\
	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE_PURE( CLASS, BASECLASS )

#define	PRIVATE_DEFINE_XINTERFACE( CLASS, BASECLASS, INTERFACES )													\
																													\
	PRIVATE_DEFINE_XINTERFACE_AQUIRE_RELEASE( CLASS, BASECLASS )													\
	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE( CLASS, BASECLASS, INTERFACES )

#define	PRIVATE_DEFINE_XINTERFACE_LARGE( CLASS, BASECLASS, INTERFACES_FIRST, INTERFACES_SECOND )					\
																													\
	PRIVATE_DEFINE_XINTERFACE_AQUIRE_RELEASE( CLASS, BASECLASS )													\
	PRIVATE_DEFINE_XINTERFACE_QUERYINTERFACE_LARGE( CLASS, BASECLASS, INTERFACES_FIRST, INTERFACES_SECOND )

//*****************************************************************************************************************
//	help macros to replace INTERFACES## in queryInterface() [see before]
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_INTERFACE_1( INTERFACE1 )																																						\
	INTERFACE1

#define	PRIVATE_DEFINE_INTERFACE_2( INTERFACE1, INTERFACE2 )																																			\
	PRIVATE_DEFINE_INTERFACE_1( INTERFACE1 ),																																							\
	INTERFACE2

#define	PRIVATE_DEFINE_INTERFACE_3( INTERFACE1, INTERFACE2, INTERFACE3 )																																\
	PRIVATE_DEFINE_INTERFACE_2( INTERFACE1, INTERFACE2 ),																																				\
	INTERFACE3

#define	PRIVATE_DEFINE_INTERFACE_4( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4 )																													\
	PRIVATE_DEFINE_INTERFACE_3( INTERFACE1, INTERFACE2, INTERFACE3 ),																																	\
	INTERFACE4

#define	PRIVATE_DEFINE_INTERFACE_5( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5 )																										\
	PRIVATE_DEFINE_INTERFACE_4( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4 ),																														\
	INTERFACE5

#define	PRIVATE_DEFINE_INTERFACE_6( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6 )																							\
	PRIVATE_DEFINE_INTERFACE_5( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5 ),																											\
	INTERFACE6

#define	PRIVATE_DEFINE_INTERFACE_7( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7 )																				\
	PRIVATE_DEFINE_INTERFACE_6( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6 ),																								\
	INTERFACE7

#define	PRIVATE_DEFINE_INTERFACE_8( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8 )																	\
	PRIVATE_DEFINE_INTERFACE_7( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7 ),																					\
	INTERFACE8

#define	PRIVATE_DEFINE_INTERFACE_9( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9 )														\
	PRIVATE_DEFINE_INTERFACE_8( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8 ),																		\
	INTERFACE9

#define	PRIVATE_DEFINE_INTERFACE_10( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10 )											\
	PRIVATE_DEFINE_INTERFACE_9( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9 ),															\
	INTERFACE10

#define	PRIVATE_DEFINE_INTERFACE_11( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11 )								\
	PRIVATE_DEFINE_INTERFACE_10( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10 ),												\
	INTERFACE11

#define	PRIVATE_DEFINE_INTERFACE_12( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11, INTERFACE12 )				\
	PRIVATE_DEFINE_INTERFACE_11( INTERFACE1, INTERFACE2, INTERFACE3, INTERFACE4, INTERFACE5, INTERFACE6, INTERFACE7, INTERFACE8, INTERFACE9, INTERFACE10, INTERFACE11 ),								\
	INTERFACE12

//*****************************************************************************************************************
//	implementation of XTypeProvider::getImplementationId()
//*****************************************************************************************************************

#define PRIVATE_DEFINE_XTYPEPROVIDER_ID( CLASS )																	\
																													\
	SEQUENCE< sal_Int8 > SAL_CALL CLASS##::getImplementationId() throw( RUNTIMEEXCEPTION )							\
	{																												\
		/* Create one Id for all instances of this class.												*/			\
		/* Use ethernet address to do this! (sal_True)													*/			\
		/* Optimize this method																			*/			\
		/* We initialize a static variable only one time. And we don't must use a mutex at every call!	*/			\
		/* For the first call; pID is NULL - for the second call pID is different from NULL!			*/			\
		static OIMPLEMENTATIONID* pID = NULL ;																		\
		if ( pID == NULL )																							\
		{																											\
			/* Ready for multithreading; get global mutex for first call of this method only! see before   */		\
			MUTEXGUARD aGuard( MUTEX::getGlobalMutex() );															\
			/* Control these pointer again ... it can be, that another instance will be faster then these! */		\
			if ( pID == NULL )																						\
			{																										\
				/* Create a new static ID ... */																	\
				static OIMPLEMENTATIONID aID( sal_False );															\
				/* ... and set his address to static pointer! */													\
				pID = &aID ;																						\
			}																										\
		}																											\
		return pID->getImplementationId();																			\
	}

//*****************************************************************************************************************
//	implementation of XTypeProvider::getTypes() with max. 12 interfaces!
//*****************************************************************************************************************

#define PRIVATE_DEFINE_XTYPEPROVIDER_TYPES( CLASS, TYPES )															\
																													\
	SEQUENCE< UNOTYPE > SAL_CALL CLASS##::getTypes() throw( RUNTIMEEXCEPTION )										\
	{																												\
		/* Optimize this method !										*/											\
		/* We initialize a static variable only one time.				*/											\
		/* And we don't must use a mutex at every call!					*/											\
		/* For the first call; pTypeCollection is NULL -				*/											\
		/* for the second call pTypeCollection is different from NULL!	*/											\
		static OTYPECOLLECTION* pTypeCollection = NULL ;															\
		if ( pTypeCollection == NULL )																				\
		{																											\
			/* Ready for multithreading; get global mutex for first call of this method only! see before   */		\
			MUTEXGUARD aGuard( MUTEX::getGlobalMutex() );															\
			/* Control these pointer again ... it can be, that another instance will be faster then these! */		\
			if ( pTypeCollection == NULL )																			\
			{																										\
				/* Create a static typecollection ... */															\
				static OTYPECOLLECTION aTypeCollection( TYPES );													\
				/* ... and set his address to static pointer! */													\
				pTypeCollection = &aTypeCollection ;																\
			}																										\
		}																											\
		return pTypeCollection->getTypes();																			\
	}

//*****************************************************************************************************************
//	implementation of XTypeProvider::getTypes() with more then 12 interfaces!
//*****************************************************************************************************************

#define PRIVATE_DEFINE_XTYPEPROVIDER_TYPES_LARGE( CLASS, TYPES_FIRST, TYPES_SECOND )								\
																													\
	SEQUENCE< UNOTYPE > SAL_CALL CLASS##::getTypes() throw( RUNTIMEEXCEPTION )										\
	{																												\
		/* Optimize this method !										*/											\
		/* We initialize a static variable only one time.				*/											\
		/* And we don't must use a mutex at every call!					*/											\
		/* For the first call; pTypeCollection is NULL -				*/											\
		/* for the second call pTypeCollection is different from NULL!	*/											\
		static OTYPECOLLECTION* pTypeCollection = NULL ;															\
		if ( pTypeCollection == NULL )																				\
		{																											\
			/* Ready for multithreading; get global mutex for first call of this method only! see before   */		\
			MUTEXGUARD aGuard( MUTEX::getGlobalMutex() );															\
			/* Control these pointer again ... it can be, that another instance will be faster then these! */		\
			if ( pTypeCollection == NULL )																			\
			{																										\
				/* Create two static typecollections ...				*/											\
				/* (cppuhelper support 12 items per collection only!)	*/											\
				static OTYPECOLLECTION aTypeCollection1( TYPES_FIRST								);				\
				static OTYPECOLLECTION aTypeCollection2( TYPES_SECOND, aTypeCollection1.getTypes()	);				\
				/* ... and set his address to static pointer! */													\
				pTypeCollection = &aTypeCollection2;																\
			}																										\
		}																											\
		return pTypeCollection->getTypes();																			\
	}

//*****************************************************************************************************************
//	implementation of XTypeProvider::getTypes() with using max. 12 interfaces + baseclass!
//*****************************************************************************************************************

#define PRIVATE_DEFINE_XTYPEPROVIDER_TYPES_BASECLASS( CLASS, BASECLASS, TYPES )										\
																													\
	SEQUENCE< UNOTYPE > SAL_CALL CLASS##::getTypes() throw( RUNTIMEEXCEPTION )										\
	{																												\
		/* Optimize this method !										*/											\
		/* We initialize a static variable only one time.				*/											\
		/* And we don't must use a mutex at every call!					*/											\
		/* For the first call; pTypeCollection is NULL -				*/											\
		/* for the second call pTypeCollection is different from NULL!	*/											\
		static OTYPECOLLECTION* pTypeCollection = NULL ;															\
		if ( pTypeCollection == NULL )																				\
		{																											\
			/* Ready for multithreading; get global mutex for first call of this method only! see before   */		\
			MUTEXGUARD aGuard( MUTEX::getGlobalMutex() );															\
			/* Control these pointer again ... it can be, that another instance will be faster then these! */		\
			if ( pTypeCollection == NULL )																			\
			{																										\
				/* Create two static typecollections ...				*/											\
				static OTYPECOLLECTION aTypeCollection( TYPES, BASECLASS##::getTypes() );							\
				/* ... and set his address to static pointer! */													\
				pTypeCollection = &aTypeCollection;																	\
			}																										\
		}																											\
		return pTypeCollection->getTypes();																			\
	}

//*****************************************************************************************************************
//	help macros to replace TYPES## in getTypes() [see before]
//*****************************************************************************************************************

#define	PRIVATE_DEFINE_TYPE_1( TYPE1 )																								\
	::getCppuType(( const REFERENCE< TYPE1 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_2( TYPE1, TYPE2 )																						\
	PRIVATE_DEFINE_TYPE_1( TYPE1 ),																									\
	::getCppuType(( const REFERENCE< TYPE2 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_3( TYPE1, TYPE2, TYPE3 )																				\
	PRIVATE_DEFINE_TYPE_2( TYPE1, TYPE2 ),																							\
	::getCppuType(( const REFERENCE< TYPE3 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_4( TYPE1, TYPE2, TYPE3, TYPE4 )																			\
	PRIVATE_DEFINE_TYPE_3( TYPE1, TYPE2, TYPE3 ),																					\
	::getCppuType(( const REFERENCE< TYPE4 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_5( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5 )																	\
	PRIVATE_DEFINE_TYPE_4( TYPE1, TYPE2, TYPE3, TYPE4 ),																			\
	::getCppuType(( const REFERENCE< TYPE5 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_6( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6 )															\
	PRIVATE_DEFINE_TYPE_5( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5 ),																		\
	::getCppuType(( const REFERENCE< TYPE6 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_7( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7 )													\
	PRIVATE_DEFINE_TYPE_6( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6 ),																\
	::getCppuType(( const REFERENCE< TYPE7 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_8( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8 )												\
	PRIVATE_DEFINE_TYPE_7( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7 ),														\
	::getCppuType(( const REFERENCE< TYPE8 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_9( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9 )										\
	PRIVATE_DEFINE_TYPE_8( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8 ),												\
	::getCppuType(( const REFERENCE< TYPE9 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_10( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10 )								\
	PRIVATE_DEFINE_TYPE_9( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9 ),											\
	::getCppuType(( const REFERENCE< TYPE10 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_11( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11 )						\
	PRIVATE_DEFINE_TYPE_10( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10 ),								\
	::getCppuType(( const REFERENCE< TYPE11 >*)NULL )

#define	PRIVATE_DEFINE_TYPE_12( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11, TYPE12 )				\
	PRIVATE_DEFINE_TYPE_11( TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8, TYPE9, TYPE10, TYPE11 ),						\
	::getCppuType(( const REFERENCE< TYPE12 >*)NULL )

//*****************************************************************************************************************
//	implementation of XTypeProvider
//*****************************************************************************************************************

/*===========================================================================================================*/		\
#define	PRIVATE_DEFINE_XTYPEPROVIDER_PURE( CLASS )																	\
																													\
	PRIVATE_DEFINE_XTYPEPROVIDER_ID( CLASS )																		\
	PRIVATE_DEFINE_XTYPEPROVIDER_TYPES( CLASS, ::getCppuType(( const REFERENCE< XTYPEPROVIDER >*)NULL ) )

/*===========================================================================================================*/		\
#define	PRIVATE_DEFINE_XTYPEPROVIDER( CLASS, TYPES )																\
																													\
	PRIVATE_DEFINE_XTYPEPROVIDER_ID( CLASS )																		\
	PRIVATE_DEFINE_XTYPEPROVIDER_TYPES( CLASS, TYPES )

/*===========================================================================================================*/		\
#define	PRIVATE_DEFINE_XTYPEPROVIDER_LARGE( CLASS, TYPES_FIRST, TYPES_SECOND )										\
																													\
	PRIVATE_DEFINE_XTYPEPROVIDER_ID( CLASS )																		\
	PRIVATE_DEFINE_XTYPEPROVIDER_TYPES_LARGE( CLASS, TYPES_FIRST, TYPES_SECOND )

/*===========================================================================================================*/		\
#define	PRIVATE_DEFINE_XTYPEPROVIDER_BASECLASS( CLASS, BASECLASS, TYPES )											\
																													\
	PRIVATE_DEFINE_XTYPEPROVIDER_ID( CLASS )																		\
	PRIVATE_DEFINE_XTYPEPROVIDER_TYPES_BASECLASS( CLASS, BASECLASS, TYPES )

}		//	namespace framework

//*****************************************************************************************************************
//	implementation of XServiceInfo and helper functions
//*****************************************************************************************************************

#define PRIVATE_DEFINE_XSERVICEINFO( CLASS, SERVICENAME, IMPLEMENTATIONNAME )																\
																																			\
	/*===========================================================================================================*/							\
	/* XServiceInfo																								 */							\
	/*===========================================================================================================*/							\
	OUSTRING SAL_CALL CLASS##::getImplementationName() throw( RUNTIMEEXCEPTION )															\
	{																																		\
		return impl_getStaticImplementationName();																							\
	}																																		\
																																			\
	/*===========================================================================================================*/							\
	/* XServiceInfo																								 */							\
	/*===========================================================================================================*/							\
	sal_Bool SAL_CALL CLASS##::supportsService( const OUSTRING& sServiceName ) throw( RUNTIMEEXCEPTION )									\
	{																																		\
		/* Set default return value. */																										\
		sal_Bool bReturn = sal_False ;																										\
																																			\
		/* Get names of all supported servicenames. */																						\
    	SEQUENCE< OUSTRING >	seqServiceNames	=	getSupportedServiceNames();																\
    	const OUSTRING*			pArray			=	seqServiceNames.getConstArray();														\
		sal_Int32				nCounter		=	0;																						\
		sal_Int32				nLength			=	seqServiceNames.getLength();															\
																																			\
		/* Search for right name in list. */																								\
    	while	(																															\
					( nCounter	<	nLength		)	&&																						\
					( bReturn	==	sal_False	)																							\
				)                                                                                                   						\
		{																																	\
			/* Is name was found, say "YES, SERVICE IS SUPPORTED." and break loop. */                               						\
        	if ( pArray[nCounter] == sServiceName )				  																			\
			{																																\
            	bReturn = sal_True ;																										\
			}																																\
			/* Else step to next element in list. */                                                                						\
			++nCounter;                                                                                             						\
		}																																	\
		/* Return state of search. */																										\
    	return bReturn;																														\
	}																																		\
																																			\
	/*===========================================================================================================*/							\
	/* XServiceInfo																								 */							\
	/*===========================================================================================================*/							\
	SEQUENCE< OUSTRING > SAL_CALL CLASS##::getSupportedServiceNames() throw( RUNTIMEEXCEPTION )												\
	{																																		\
		return impl_getStaticSupportedServiceNames();																						\
	}																																		\
																																			\
	/*===========================================================================================================*/							\
	/* Helper for XServiceInfo */																											\
	/*===========================================================================================================*/							\
	SEQUENCE< OUSTRING > CLASS##::impl_getStaticSupportedServiceNames()																		\
	{																																		\
    	SEQUENCE< OUSTRING > seqServiceNames( 1 );																							\
    	seqServiceNames.getArray() [0] = OUSTRING( RTL_CONSTASCII_USTRINGPARAM( SERVICENAME ) );											\
    	return seqServiceNames;																												\
	}																																		\
																																			\
	/*===========================================================================================================*/							\
	/* Helper for XServiceInfo																					 */							\
	/*===========================================================================================================*/							\
	OUSTRING CLASS##::impl_getStaticImplementationName()																					\
	{																																		\
		return OUSTRING( RTL_CONSTASCII_USTRINGPARAM( IMPLEMENTATIONNAME ) );																\
	}																																		\
																																			\
	/*===========================================================================================================*/							\
	/* Helper for registry																						 */							\
	/*===========================================================================================================*/							\
	REFERENCE< XINTERFACE > CLASS##::impl_createInstance( const REFERENCE< XMULTISERVICEFACTORY >& xServiceManager ) throw( EXCEPTION )		\
	{																																		\
		return REFERENCE< XINTERFACE >( *new CLASS##( xServiceManager ) );																	\
	}


//*****************************************************************************************************************
//	definition of helper function createFactory() for multiple services
//*****************************************************************************************************************

#define PRIVATE_DEFINE_SINGLEFACTORY( CLASS )																								\
																																			\
	REFERENCE< XSINGLESERVICEFACTORY > CLASS##::impl_createFactory( const REFERENCE< XMULTISERVICEFACTORY >& xServiceManager )				\
	{																																		\
		REFERENCE< XSINGLESERVICEFACTORY > xReturn	( cppu::createSingleFactory	(	xServiceManager									,		\
																					CLASS##::impl_getStaticImplementationName()		,		\
																					CLASS##::impl_createInstance					,		\
																					CLASS##::impl_getStaticSupportedServiceNames()			\
																				)															\
													);																						\
		return xReturn;																														\
	}

//*****************************************************************************************************************
//	definition of helper function createFactory() for one instance services
//*****************************************************************************************************************

#define PRIVATE_DEFINE_ONEINSTANCEFACTORY( CLASS )																								\
																																				\
	REFERENCE< XSINGLESERVICEFACTORY > CLASS##::impl_createFactory( const REFERENCE< XMULTISERVICEFACTORY >& xServiceManager )					\
	{																																			\
		REFERENCE< XSINGLESERVICEFACTORY > xReturn	( cppu::createOneInstanceFactory	(	xServiceManager									,	\
																							CLASS##::impl_getStaticImplementationName()		,	\
																							CLASS##::impl_createInstance					,	\
																							CLASS##::impl_getStaticSupportedServiceNames()		\
																						)														\
													);																							\
		return xReturn;																															\
	}

#endif	//	#ifndef __FRAMEWORK_PRIVATEMACROS_HXX_
