/*************************************************************************
 *
 *  $RCSfile: desktop.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_DESKTOP_HXX_
#define __FRAMEWORK_DESKTOP_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_MACROS_HXX_
#include <helper/macros.hxx>
#endif

#ifndef __FRAMEWORK_OMUTEXMEMBER_HXX_
#include <helper/omutexmember.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDESKTOPTASK_HPP_
#include <com/sun/star/frame/XDesktopTask.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_WINDOWARRANGE_HPP_
#include <com/sun/star/frame/WindowArrange.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_TERMINATIONVETOEXCEPTION_HPP_
#include <com/sun/star/frame/TerminationVetoException.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XTERMINATELISTENER_HPP_
#include <com/sun/star/frame/XTerminateListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XWINDOWARRANGER_HPP_
#include <com/sun/star/frame/XWindowArranger.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XTASK_HPP_
#include <com/sun/star/frame/XTask.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSERVICENAME_HPP_
#include <com/sun/star/lang/XServiceName.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
#include <com/sun/star/frame/XComponentLoader.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_FRAMEACTION_HPP_
#include <com/sun/star/frame/FrameAction.hpp>
#endif

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORFACTORY_HPP_
#include <com/sun/star/task/XStatusIndicatorFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XTASKSSUPPLIER_HPP_
#include <com/sun/star/frame/XTasksSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XEnumerationAccess.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	XCONTROLLER									::com::sun::star::frame::XController
#define	XDISPATCH									::com::sun::star::frame::XDispatch
#define	XDISPATCHPROVIDER							::com::sun::star::frame::XDispatchProvider
#define	XDISPATCHDESCRIPTOR							::com::sun::star::frame::XDispatchDescriptor
#define	XFRAME										::com::sun::star::frame::XFrame
#define	XFRAMES										::com::sun::star::frame::XFrames
#define	XFRAMESSUPPLIER								::com::sun::star::frame::XFramesSupplier
#define	XTERMINATELISTENER							::com::sun::star::frame::XTerminateListener
#define	XENUMERATIONACCESS                          ::com::sun::star::container::XEnumerationAccess
#define	XCOMPONENT									::com::sun::star::lang::XComponent
#define	XTASK                                       ::com::sun::star::frame::XTask
#define	PROPERTYVALUE								::com::sun::star::beans::PropertyValue
#define	XWINDOW                                     ::com::sun::star::awt::XWindow
#define	XDESKTOP									::com::sun::star::frame::XDesktop
#define	XCOMPONENTLOADER							::com::sun::star::frame::XComponentLoader
#define	XTASKSSUPPLIER								::com::sun::star::frame::XTasksSupplier
#define	XSTATUSINDICATORFACTORY						::com::sun::star::task::XStatusIndicatorFactory
#define	XFRAMEACTIONLISTENER						::com::sun::star::frame::XFrameActionListener
#define	XEVENTLISTENER								::com::sun::star::lang::XEventListener
#define	XSTATUSINDICATOR							::com::sun::star::task::XStatusIndicator
#define	XPROPERTYSETINFO							::com::sun::star::beans::XPropertySetInfo
#define	XSERVICEINFO								::com::sun::star::lang::XServiceInfo

#define	IOEXCEPTION									::com::sun::star::io::IOException
#define	ILLEGALARGUMENTEXCEPTION					::com::sun::star::lang::IllegalArgumentException

#define	OPROPERTYSETHELPER							::cppu::OPropertySetHelper
#define	OBROADCASTHELPER							::cppu::OBroadcastHelper
#define	IPROPERTYARRAYHELPER						::cppu::IPropertyArrayHelper
#define	OINTERFACECONTAINERHELPER					::cppu::OInterfaceContainerHelper
#define	OMULTITYPEINTERFACECONTAINERHELPER			::cppu::OMultiTypeInterfaceContainerHelper
#define	OWEAKOBJECT									::cppu::OWeakObject

#define	UNOURL										::com::sun::star::util::URL
#define	DISPATCHDESCRIPTOR							::com::sun::star::frame::DispatchDescriptor
#define	PROPERTY									::com::sun::star::beans::Property
#define	LOCALE										::com::sun::star::lang::Locale

//_________________________________________________________________________________________________________________
//	switches
//	Use these to de/activate some features of this implementation.
//	(for debugging or testing!)
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported definitions
//_________________________________________________________________________________________________________________

/*-************************************************************************************************************//**
	@short		implements a topframe

	@descr		This class is the root of the frames tree. He has no window and is not visible.

	@implements	XInterface
				XTypeProvider
				XServiceInfo
				XDesktop
				XComponentLoader
				XTasksSupplier
				XDispatchProvider
				XFramesSupplier
				XFrame
				XComponent
				XStatusIndicatorFactory

	@base		OMutexMember
				OBroadcastHelper
				OPropertySetHelper
				OWeakObject
*//*-*************************************************************************************************************/

class Desktop	:	public XTYPEPROVIDER			,
					public XSERVICEINFO				,
					public XDESKTOP					,
					public XCOMPONENTLOADER			,
					public XTASKSSUPPLIER			,
					public XDISPATCHPROVIDER		,
					public XFRAMESSUPPLIER			,	// => XFrame => XComponent
					public XSTATUSINDICATORFACTORY	,
					public OMutexMember				,	// Struct for right initalization of mutex member!
					public OWEAKOBJECT				,
					public OBROADCASTHELPER			,
					public OPROPERTYSETHELPER
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		standard constructor to create instance by factory
			@descr		This constructor initialize a new instance of this class by valid factory,
						and will be set valid values on his member and baseclasses.

			@seealso	-

			@param		"xFactory" is the multi service manager, which create this instance.
						The value must be different from NULL!
			@return		-

			@onerror	DBG_ASSERT in debug version or nothing in relaese version.
		*//*-*****************************************************************************************************/

	 	Desktop( const REFERENCE< XMULTISERVICEFACTORY >& xFactory );

		/*-****************************************************************************************************//**
			@short		standard destructor
			@descr		This method destruct an instance of this class and clear some member.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual	~Desktop();

		//---------------------------------------------------------------------------------------------------------
		//	XInterface, XTypeProvider, XServiceInfo + helper! (see macro.hxx)
		//---------------------------------------------------------------------------------------------------------

		DECLARE_XINTERFACE
		DECLARE_XTYPEPROVIDER
		DECLARE_XSERVICEINFO

		//---------------------------------------------------------------------------------------------------------
		//	XDesktop
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		ask desktop before terminate it
			@descr		The desktop ask his components and if all say "yes" it will destroy this components
						and return "yes" to caller of this method. By the other way, desktop will not destroy!

			@seealso	-

			@param		-
			@return		sal_True  = if all components say "yes"<BR>
						sal_False = other way

			@onerror	We return sal_False.
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL terminate() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		add a listener for terminate events
			@descr		You can add a listener, if you wish to get an event, if desktop will be terminate.

			@seealso	method removeTerminateListener()

			@param		"xListener" is a reference to the listener. His value must be valid!
			@return		-

			@onerror	No listener is added.
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addTerminateListener( const REFERENCE< XTERMINATELISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		remove a listener for terminate events
			@descr		You can remove a listener, if you don't wish to get further event for desktop termination.

			@seealso	method removeTerminateListener()

			@param		"xListener" is a reference to the listener. His value must be valid!
			@return		-

			@onerror	No listener is removed.
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeTerminateListener( const REFERENCE< XTERMINATELISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		get access to enumerations of all current components
			@descr		Attention: You will be the owner of the returned object and must delete it
						if you don't use it again.

			@seealso	class TasksAccess
			@seealso	class TasksEnumeration

			@param		-
			@return		A reference to an XEnumerationAccess-object.

			@onerror	We return a null-reference.
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XENUMERATIONACCESS > SAL_CALL getComponents() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		return the current active component
			@descr		The most current component is the window, model or the controller of the current active frame.

			@seealso	method getCurrentFrame()
			@seealso	method impl_getFrameComponent()

			@param		-
			@return		A reference to the component.

			@onerror	We return a null-reference.
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XCOMPONENT > SAL_CALL getCurrentComponent() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAME > SAL_CALL getCurrentFrame() throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	XComponentLoader
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual REFERENCE< XCOMPONENT > SAL_CALL loadComponentFromURL(	const	OUSTRING&					sURL				,
																		const	OUSTRING&					sTargetFrameName	,
																				sal_Int32					nSearchFlags		,
																		const	SEQUENCE< PROPERTYVALUE >&	seqArguments		) throw(	IOEXCEPTION				,
																																			ILLEGALARGUMENTEXCEPTION,
																																			RUNTIMEEXCEPTION		);
		//---------------------------------------------------------------------------------------------------------
		//	XTasksSupplier
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XENUMERATIONACCESS > SAL_CALL getTasks() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XTASK > SAL_CALL getActiveTask() throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	XDispatchProvider
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XDISPATCH > SAL_CALL queryDispatch(	const	UNOURL&		aURL			,
																const	OUSTRING&	sTargetFrameName,
																		sal_Int32	nSearchFlags	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual SEQUENCE< REFERENCE< XDISPATCH > > SAL_CALL queryDispatches( const SEQUENCE< DISPATCHDESCRIPTOR >& seqDescripts ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	XFramesSupplier
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAMES > SAL_CALL getFrames() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAME > SAL_CALL getActiveFrame() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setActiveFrame( const REFERENCE< XFRAME >& xFrame ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XFrame
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL initialize( const REFERENCE< XWINDOW >& xWindow ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		The ContainerWindow property is used as a VclContainer for the Component
						in this frame. So this object implements a XVclContainer interface too.
						The instantiation of the ContainerWindow is done by the derived frame class.
						The frame is the owner of its ContainerWindow.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XWINDOW > SAL_CALL getContainerWindow() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setCreator( const REFERENCE< XFRAMESSUPPLIER >& xCreator ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		The Creator is the parent frame container. If it is NULL, the frame is the uppermost one.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAMESSUPPLIER > SAL_CALL getCreator() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual OUSTRING SAL_CALL getName() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setName( const OUSTRING& sName ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		This method searches for a frame with the specified name.
						Frames may contain other frames (e.g. a frameset) and may
						be contained in other frames. This hierarchie ist searched by
						this method.
						First some special names are taken into account, i.e. "",
	 					"_self", "_top", "_active" etc. The FrameSearchFlags are ignored
						when comparing these names with aTargetFrameName, further steps are
						controlled by the FrameSearchFlags. If allowed, the name of the frame
						itself is compared with the desired one, then ( again if allowed )
						the method findFrame is called for all children of the frame.
						At last findFrame may be called for the parent frame ( if allowed ).
						If no Frame with the given name is found until the top frames container,
						a new top Frame is created, if this is allowed by a special
						FrameSearchFlag. The new Frame also gets the desired name.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAME > SAL_CALL findFrame(	const	OUSTRING&	sTargetFrameName	,
																sal_Int32	nSearchFlags		) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Returns sal_True, if this frame is a "top frame", otherwise sal_False.
						The "m_bIsFrameTop" member must be set in the ctor of the derived frame class.
    					A top frame is a member of the top frame container or a member of the
    					task frame container. Both containers can create new frames if the findFrame
    					method of their XFrame interface is called with a frame name not yet known.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL isTop() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL activate() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL deactivate() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL isActive() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL setComponent(	const	REFERENCE< XWINDOW >&		xComponentWindow	,
												const	REFERENCE< XCONTROLLER >&	xController			) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Frames are used to display components. The actual displayed component is
						held by the ComponentWindow property. If the component implements only a
						XVclComponent interface, the communication between the frame and the
						component is very restricted. Better integration is achievable through a
						XController interface.
						If the component wants other objects to be able to get information about its
						ResourceDescriptor ( e.g. for an implementation of a browse history ) it has
						to implement a XModel interface.
						This frame is the owner of the ComponentWindow.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XWINDOW > SAL_CALL getComponentWindow() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XCONTROLLER > SAL_CALL getController() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL contextChanged() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addFrameActionListener( const REFERENCE< XFRAMEACTIONLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeFrameActionListener( const REFERENCE< XFRAMEACTIONLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XComponent
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		The owner of this object calles the dispose method if the object
						should be destroyed. All other objects and components, that are registered
						as an EventListener are forced to release their references to this object.
						Furthermore this frame is removed from its parent frame container to release
						this reference. The reference attributes are disposed and released also.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL dispose() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Adds an EventListener to this object. If the dispose method is called on
						this object, the disposing method of the listener is called.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addEventListener( const REFERENCE< XEVENTLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Removes an EventListener. If another object that has registered itself as
						an EventListener is disposed it must deregister by calling this method.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeEventListener( const REFERENCE< XEVENTLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XStatusIndicatorFactory
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	    virtual REFERENCE< XSTATUSINDICATOR > SAL_CALL createStatusIndicator() throw( RUNTIMEEXCEPTION );

	//-------------------------------------------------------------------------------------------------------------
	//	protected methods
	//-------------------------------------------------------------------------------------------------------------

	protected:

		/*-****************************************************************************************************//**
			@short		reset instance, free memory and something else ...

			@descr		Use this method to reset the current instance to default values and free used memory.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_resetObject();

		//---------------------------------------------------------------------------
		//	OPropertySetHelper
		//---------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		try to convert a property value
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!
						You must try to convert the value of given propertyhandle and
						return results of this operation. This will be use to ask vetoable
						listener. If no listener have a veto, we will change value realy!
						( in method setFastPropertyValue_NoBroadcast(...) )

			@seealso	OPropertySetHelper
			@seealso	setFastPropertyValue_NoBroadcast()

			@param		"aConvertedValue"	new converted value of property
			@param		"aOldValue"			old value of property
			@param		"nHandle"			handle of property
			@param		"aValue"			new value of property

			@return		sal_True if value will be changed, sal_FALSE otherway

			@onerror	IllegalArgumentException, if you call this with an invalid argument
		*//*-*****************************************************************************************************/

		virtual sal_Bool convertFastPropertyValue(			ANY&		aConvertedValue	,
															ANY&		aOldValue		,
															sal_Int32	nHandle			,
													const	ANY&		aValue			) throw( ILLEGALARGUMENTEXCEPTION );

		/*-****************************************************************************************************//**
			@short		set value of a transient property
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!
						Handle and value are valid everyway! You must set the new value only.
						After this, baseclass send messages to all listener automaticly.

			@seealso	OPropertySetHelper

			@param      "nHandle"	handle of property to change
			@param      "aValue"	new value of property

			@return		-

			@onerror	An exception is thrown.
		*//*-*****************************************************************************************************/

		virtual void setFastPropertyValue_NoBroadcast(			sal_Int32	nHandle	,
														const	ANY&		aValue	) throw( EXCEPTION );

		/*-****************************************************************************************************//**
			@short		get value of a transient property
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!

			@seealso	OPropertySetHelper

			@param      "nHandle"	handle of property to change
			@param      "aValue"	current value of property

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual void getFastPropertyValue(	ANY&		aValue	,
											sal_Int32	nHandle	) const;

		/*-****************************************************************************************************//**
			@short      return structure and information about transient properties
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!

			@seealso	OPropertySetHelper

			@param		-

			@return		structure with property-informations

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual IPROPERTYARRAYHELPER& getInfoHelper();

		/*-****************************************************************************************************//**
			@short		return propertysetinfo
			@descr		You can call this method to get information about transient properties
						of this object.

			@seealso	OPropertySetHelper
			@seealso	XPropertySet
			@seealso	XMultiPropertySet

			@param		-

			@return		reference to object with information [XPropertySetInfo]

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual REFERENCE< XPROPERTYSETINFO > SAL_CALL getPropertySetInfo();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		REFERENCE< XCOMPONENT > impl_getFrameComponent( const REFERENCE< XFRAME >& xFrame );

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		sal_Bool impl_tryToChangeProperty(			sal_Bool	bProperty		,
											const	ANY&		aValue			,
													ANY&		aOldValue		,
													ANY&		aConvertedValue	) throw( ILLEGALARGUMENTEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		static const SEQUENCE< PROPERTY > impl_getStaticPropertyDescriptor();

	//-------------------------------------------------------------------------------------------------------------
	//	debug methods
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	#ifdef DBG_UTIL

	private:

		/*-****************************************************************************************************//**
			@short		debug-method to check incoming parameter of some other mehods of this class

			@descr		The following methods are used to check parameters for other methods
						of this class. The return value is used directly for an DBG_ASSERT(...).

			@seealso	DBG_ASSERTs in implementation!

			@param		references to checking variables

			@return		sal_False on invalid parameter<BR>
						sal_True  otherway

			@onerror	-
		*//*-*****************************************************************************************************/

	#endif	// #ifdef DBG_UTIL

	//-------------------------------------------------------------------------------------------------------------
	//	variables
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	private:

		REFERENCE< XMULTISERVICEFACTORY >			m_xFactory					;	/// reference to factory, which has create this instance
		OUSTRING									m_sName						;	/// desktop is a topframe and has a name
		OINTERFACECONTAINERHELPER					m_aChildFramesContainer		;	/// list of all child frames
		OMULTITYPEINTERFACECONTAINERHELPER			m_aListenerContainer		;	/// container for ALL Listener

		// Properties
		REFERENCE< XCOMPONENT >						m_xActiveComponent			;
		REFERENCE< XCOMPONENT >						m_xActiveFrame				;
		sal_Bool									m_bHasBeamer				;
		sal_Bool									m_bHasCommonTaskBar			;
		sal_Bool									m_bHasDesigner				;
		sal_Bool									m_bHasExplorer				;
		sal_Bool									m_bHasFunctionBar			;
		sal_Bool									m_bHasMacroBar				;
		sal_Bool									m_bHasNavigator				;
		sal_Bool									m_bHasObjectBar				;
		sal_Bool									m_bHasOptionBar				;
		sal_Bool									m_bHasStatusBar				;
		sal_Bool									m_bHasToolbar				;
		LOCALE										m_aISOLocale				;


/*
	static SfxDesktop*		pDesktop;
	SfxDesktop_Impl*		_pImp;

protected:
public:
	static SfxDesktop*		Get_Impl();
	static void				Dispose();

	// XFastPropertySet
	virtual void SAL_CALL setFastPropertyValue(sal_Int32 nHandle, const ::com::sun::star::uno::Any& aValue) throw ( ::com::sun::star::uno::RuntimeException );
	virtual ::com::sun::star::uno::Any SAL_CALL getFastPropertyValue(sal_Int32 nHandle) throw ( ::com::sun::star::uno::RuntimeException );

#if __PRIVATE
	sal_Bool 					QueryTerminate_Impl();
	void 					Terminate_Impl();
	static void 			DoFrameAction_Impl( ::com::sun::star::frame::XFrame* pFrame, ::com::sun::star::frame::FrameAction eAction );

private:
	void 					FrameAction_Impl( ::com::sun::star::frame::XFrame* pFrame, ::com::sun::star::frame::FrameAction eAction );
#endif
*/

};	//	class Desktop

}	//	namespace framework

#endif	//	#ifndef __FRAMEWORK_DESKTOP_HXX_
