/*************************************************************************
 *
 *  $RCSfile: frame.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_FRAME_HXX_
#define __FRAMEWORK_FRAME_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_MACROS_HXX_
#include <helper/macros.hxx>
#endif

#ifndef __FRAMEWORK_OMUTEXMEMBER_HXX_
#include <helper/omutexmember.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_FRAME_XBROWSEHISTORYREGISTRY_HPP_
#include <com/sun/star/frame/XBrowseHistoryRegistry.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTION_HPP_
#include <com/sun/star/frame/XDispatchProviderInterception.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTOR_HPP_
#include <com/sun/star/frame/XDispatchProviderInterceptor.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XEVENTLISTENER_HPP_
#include <com/sun/star/lang/XEventListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMEACTIONLISTENER_HPP_
#include <com/sun/star/frame/XFrameActionListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMES_HPP_
#include <com/sun/star/frame/XFrames.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATORSUPPLIER_HPP_
#include <com/sun/star/task/XStatusIndicatorSupplier.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XTOPWINDOWLISTENER_HPP_
#include <com/sun/star/awt/XTopWindowListener.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XWINDOWLISTENER_HPP_
#include <com/sun/star/awt/XWindowListener.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	XBROWSEHISTORYREGISTRY						::com::sun::star::frame::XBrowseHistoryRegistry
#define	XCONTROLLER									::com::sun::star::frame::XController
#define	XDISPATCH									::com::sun::star::frame::XDispatch
#define	XDISPATCHPROVIDER							::com::sun::star::frame::XDispatchProvider
#define	XDISPATCHPROVIDERINTERCEPTION				::com::sun::star::frame::XDispatchProviderInterception
#define	XDISPATCHPROVIDERINTERCEPTOR                ::com::sun::star::frame::XDispatchProviderInterceptor
#define	XEVENTLISTENER								::com::sun::star::lang::XEventListener
#define	XFRAME										::com::sun::star::frame::XFrame
#define	XFRAMEACTIONLISTENER						::com::sun::star::frame::XFrameActionListener
#define	XFRAMELOADER								::com::sun::star::frame::XFrameLoader
#define	XFRAMES										::com::sun::star::frame::XFrames
#define	XFRAMESSUPPLIER								::com::sun::star::frame::XFramesSupplier
#define	XLOADEVENTLISTENER							::com::sun::star::frame::XLoadEventListener
#define	XSTATUSINDICATOR							::com::sun::star::task::XStatusIndicator
#define	XSTATUSINDICATORSUPPLIER					::com::sun::star::task::XStatusIndicatorSupplier
#define	XTOPWINDOWLISTENER							::com::sun::star::awt::XTopWindowListener
#define	XWINDOW                                     ::com::sun::star::awt::XWindow
#define	XWINDOWLISTENER								::com::sun::star::awt::XWindowListener
#define	XSERVICEINFO								::com::sun::star::lang::XServiceInfo

#define	INDEXOUTOFBOUNDSEXCEPTION					::com::sun::star::lang::IndexOutOfBoundsException
#define	WRAPPEDTARGETEXCEPTION                      ::com::sun::star::lang::WrappedTargetException

#define	OINTERFACECONTAINERHELPER					::cppu::OInterfaceContainerHelper
#define	OMULTITYPEINTERFACECONTAINERHELPER			::cppu::OMultiTypeInterfaceContainerHelper
#define	OWEAKOBJECT									::cppu::OWeakObject

#define	DISPATCHDESCRIPTOR							::com::sun::star::frame::DispatchDescriptor
#define	EVENTOBJECT                                 ::com::sun::star::lang::EventObject
#define	FRAMEACTION									::com::sun::star::frame::FrameAction
#define	PROPERTYVALUE								::com::sun::star::beans::PropertyValue
#define	UNOURL										::com::sun::star::util::URL
#define	WINDOWEVENT                                 ::com::sun::star::awt::WindowEvent

//_________________________________________________________________________________________________________________
//	switches
//	Use these to de/activate some features of this implementation.
//	(for debugging or testing!)
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported definitions
//_________________________________________________________________________________________________________________

/*-************************************************************************************************************//**
	@short		implements a normal frame

	@descr		-

	@implements	XInterface
				XTypeProvider
				XServiceInfo
				XFrames
				XIndexAccess
				XElementAccess
				XFramesSupplier
				XFrame
				XComponent
				XStatusIndicatorSupplier
				XDispatchProvider
				XDispatchProviderInterception
				XBrowseHistoryRegistry
				XLoadEventListener
				XEventListener
				XWindowListener
				XTopWindowListener

	@base		OMutexMember
				OWeakObject
*//*-*************************************************************************************************************/

class Frame	:	public XTYPEPROVIDER					,
				public XSERVICEINFO						,
				public XFRAMES							,	// => XIndexAccess, XElementAccess
				public XFRAMESSUPPLIER					,	// => XFrame      , XComponent
				public XSTATUSINDICATORSUPPLIER			,
				public XDISPATCHPROVIDER				,
				public XDISPATCHPROVIDERINTERCEPTION	,
				public XBROWSEHISTORYREGISTRY			,
				public XLOADEVENTLISTENER				,	// => XEventListener
				public XWINDOWLISTENER					,
				public XTOPWINDOWLISTENER				,
				public OMutexMember						,	// Struct for right initalization of mutex member!
				public OWEAKOBJECT
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		standard constructor to create instance by factory

			@descr		This constructor initialize a new instance of this class by valid factory,
						and will be set valid values on his member and baseclasses.

			@seealso	-

			@param		"xFactory" is the multi service manager, which create this instance.
						The value must be different from NULL!

			@return		-

			@onerror	DBG_ASSERT in debug version or nothing in relaese version.
		*//*-*****************************************************************************************************/

	 	Frame( const REFERENCE< XMULTISERVICEFACTORY >& xFactory );

		/*-****************************************************************************************************//**
			@short		standard destructor

			@descr		This method destruct an instance of this class and clear some member.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual	~Frame();

		//---------------------------------------------------------------------------------------------------------
		//	XInterface, XTypeProvider, XServiceInfo
		//---------------------------------------------------------------------------------------------------------

		DECLARE_XINTERFACE
		DECLARE_XTYPEPROVIDER
		DECLARE_XSERVICEINFO

		//---------------------------------------------------------------------------------------------------------
		//	 XFrames
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL append( const REFERENCE< XFRAME >& xFrame ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		This method presents all child frames of the container that he wants to be
						visible to other object as a sequence and so implements a frame iterator.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual SEQUENCE< REFERENCE< XFRAME > > SAL_CALL queryFrames( sal_Int32 nSearchFlags ) throw( RUNTIMEEXCEPTION);

		/*-****************************************************************************************************//**
			@short		-

			@descr		This method removes the frame from its container, but doesn't call the dispose
						method of the frame. The Creator attribute of the frame is set to NULL.

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL remove( const REFERENCE< XFRAME >& xFrame ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XFramesSupplier
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAMES > SAL_CALL getFrames() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAME > SAL_CALL getActiveFrame() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setActiveFrame( const REFERENCE< XFRAME >& xFrame ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XStatusIndicatorSupplier
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	    virtual REFERENCE< XSTATUSINDICATOR > SAL_CALL getStatusIndicator() throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XDispatchProvider
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		This method searches for a dispatch for the specified DispatchDescriptor.
						The FrameSearchFlags and the FrameName of the DispatchDescriptor are
						treated as described for findFrame.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XDISPATCH > SAL_CALL queryDispatch(	const	UNOURL&		aURL			,
																const	OUSTRING&	sTargetFrameName,
																		sal_Int32	nSearchFlags	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Returns a sequence of dispatches. For details see the queryDispatch method.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual SEQUENCE< REFERENCE< XDISPATCH > > SAL_CALL queryDispatches( const SEQUENCE< DISPATCHDESCRIPTOR >& seqDescriptor ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XDispatchProviderInterception
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL registerDispatchProviderInterceptor( const REFERENCE< XDISPATCHPROVIDERINTERCEPTOR >& xInterceptor ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL releaseDispatchProviderInterceptor( const REFERENCE< XDISPATCHPROVIDERINTERCEPTOR >& xInterceptor ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XBrowseHistoryRegistry
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL updateViewData( const ANY& aValue ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL createNewEntry(	const	OUSTRING&					sURL		,
												const	SEQUENCE< PROPERTYVALUE >&	seqArguments,
												const	OUSTRING&					sTitle		) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XLoadEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadFinished( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadCancelled( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XWindowListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowResized( const WINDOWEVENT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowMoved( const WINDOWEVENT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowShown( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowHidden( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XTopWindowListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowOpened( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowClosing( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowClosed( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowMinimized( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowNormalized( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowActivated( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL windowDeactivated( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XIndexAccess
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Int32 SAL_CALL getCount() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual ANY SAL_CALL getByIndex( sal_Int32 nIndex ) throw(	INDEXOUTOFBOUNDSEXCEPTION	,
																	WRAPPEDTARGETEXCEPTION		,
																	RUNTIMEEXCEPTION			);

		//---------------------------------------------------------------------------------------------------------
		//	 XElementAccess
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual UNOTYPE SAL_CALL getElementType() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL hasElements() throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XFrame
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL initialize( const REFERENCE< XWINDOW >& xWindow ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		The ContainerWindow property is used as a VclContainer for the Component
						in this frame. So this object implements a XVclContainer interface too.
						The instantiation of the ContainerWindow is done by the derived frame class.
						The frame is the owner of its ContainerWindow.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XWINDOW > SAL_CALL getContainerWindow() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setCreator( const REFERENCE< XFRAMESSUPPLIER >& xCreator ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		The Creator is the parent frame container. If it is NULL, the frame is the uppermost one.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAMESSUPPLIER > SAL_CALL getCreator() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual OUSTRING SAL_CALL getName() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setName( const OUSTRING& sName ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		This method searches for a frame with the specified name.
						Frames may contain other frames (e.g. a frameset) and may
						be contained in other frames. This hierarchie ist searched by
						this method.
						First some special names are taken into account, i.e. "",
	 					"_self", "_top", "_active" etc. The FrameSearchFlags are ignored
						when comparing these names with aTargetFrameName, further steps are
						controlled by the FrameSearchFlags. If allowed, the name of the frame
						itself is compared with the desired one, then ( again if allowed )
						the method findFrame is called for all children of the frame.
						At last findFrame may be called for the parent frame ( if allowed ).
						If no Frame with the given name is found until the top frames container,
						a new top Frame is created, if this is allowed by a special
						FrameSearchFlag. The new Frame also gets the desired name.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XFRAME > SAL_CALL findFrame(	const	OUSTRING&	sTargetFrameName	,
																sal_Int32	nSearchFlags		) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Returns sal_True, if this frame is a "top frame", otherwise sal_False.
						The "m_bIsFrameTop" member must be set in the ctor of the derived frame class.
    					A top frame is a member of the top frame container or a member of the
    					task frame container. Both containers can create new frames if the findFrame
    					method of their XFrame interface is called with a frame name not yet known.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL isTop() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL activate() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL deactivate() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL isActive() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual sal_Bool SAL_CALL setComponent(	const	REFERENCE< XWINDOW >&		xComponentWindow	,
												const	REFERENCE< XCONTROLLER >&	xController			) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Frames are used to display components. The actual displayed component is
						held by the ComponentWindow property. If the component implements only a
						XVclComponent interface, the communication between the frame and the
						component is very restricted. Better integration is achievable through a
						XController interface.
						If the component wants other objects to be able to get information about its
						ResourceDescriptor ( e.g. for an implementation of a browse history ) it has
						to implement a XModel interface.
						This frame is the owner of the ComponentWindow.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XWINDOW > SAL_CALL getComponentWindow() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XCONTROLLER > SAL_CALL getController() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL contextChanged() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addFrameActionListener( const REFERENCE< XFRAMEACTIONLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-
			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeFrameActionListener( const REFERENCE< XFRAMEACTIONLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XComponent
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		The owner of this object calles the dispose method if the object
						should be destroyed. All other objects and components, that are registered
						as an EventListener are forced to release their references to this object.
						Furthermore this frame is removed from its parent frame container to release
						this reference. The reference attributes are disposed and released also.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL dispose() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Adds an EventListener to this object. If the dispose method is called on
						this object, the disposing method of the listener is called.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addEventListener( const REFERENCE< XEVENTLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-

			@descr		Removes an EventListener. If another object that has registered itself as
						an EventListener is disposed it must deregister by calling this method.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeEventListener( const REFERENCE< XEVENTLISTENER >& xListener ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-

			@descr		This object is forced to release all references to the interfaces given
						by the parameter Source.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	    virtual void SAL_CALL disposing( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

	//-------------------------------------------------------------------------------------------------------------
	//	protected methods
	//-------------------------------------------------------------------------------------------------------------

	protected:

		/*-****************************************************************************************************//**
			@short		reset instance, free memory and something else ...

			@descr		Use this method to reset the current instance to default values and free used memory.

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_resetObject();

		/*-****************************************************************************************************//**
			@short		get value of member m_xFactory

			@descr		We not allow direct access to this member! (not public) But sometimes the derived class
						need this reference to factory and can get it with this method.

			@seealso	member m_xFactory

			@param		-

			@return		value of member m_xFactory

			@onerror	-
		*//*-*****************************************************************************************************/

		REFERENCE< XMULTISERVICEFACTORY > impl_getFactory();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_setContainerWindow( const REFERENCE< XWINDOW >& xWindow );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_setComponentWindow( const REFERENCE< XWINDOW >& xWindow );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_setController( const REFERENCE< XCONTROLLER >& xController );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_sendFrameActionEvent( const FRAMEACTION& aAction );

		/*-****************************************************************************************************//**
			@short		-

			@descr		-

			@seealso	-

			@param		-

			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		REFERENCE< XDISPATCH > impl_queryDispatch(	const	UNOURL&		aURL				,
													const	OUSTRING&	sTargetFrameName	,
															sal_Int32	nSearchFlags		);

	//-------------------------------------------------------------------------------------------------------------
	//	debug methods
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	#ifdef DBG_UTIL

	private:

		/*-****************************************************************************************************//**
			@short		debug-method to check incoming parameter of some other mehods of this class

			@descr		The following methods are used to check parameters for other methods
						of this class. The return value is used directly for an DBG_ASSERT(...).

			@seealso	DBG_ASSERTs in implementation!

			@param		references to checking variables

			@return		sal_False on invalid parameter<BR>
						sal_True  otherway

			@onerror	-
		*//*-*****************************************************************************************************/

		sal_Bool impldbg_checkParameter_append								(	const	REFERENCE< XFRAME >&						xFrame				);
		sal_Bool impldbg_checkParameter_queryFrames							(			sal_Int32									nSearchFlags		);
		sal_Bool impldbg_checkParameter_remove								(	const	REFERENCE< XFRAME >&						xFrame				);
		sal_Bool impldbg_checkParameter_setActiveFrame						(	const	REFERENCE< XFRAME >&						xFrame				);
		sal_Bool impldbg_checkParameter_queryDispatch						(	const	UNOURL&										aURL				,
													  							const	OUSTRING&									sTargetFrameName	,
													  									sal_Int32									nSearchFlags		);
		sal_Bool impldbg_checkParameter_registerDispatchProviderInterceptor	(	const	REFERENCE< XDISPATCHPROVIDERINTERCEPTOR >&	xInterceptor		);
		sal_Bool impldbg_checkParameter_releaseDispatchProviderInterceptor	(	const	REFERENCE< XDISPATCHPROVIDERINTERCEPTOR >&	xInterceptor		);
		sal_Bool impldbg_checkParameter_updateViewData						(	const	ANY&										aValue				);
		sal_Bool impldbg_checkParameter_createNewEntry						(	const	OUSTRING&				  					sURL				,
			  																	const	SEQUENCE< PROPERTYVALUE >&					seqArguments		,
																				const	OUSTRING&									sTitle				);
		sal_Bool impldbg_checkParameter_loadFinished						(	const	REFERENCE< XFRAMELOADER >&					xLoader				);
		sal_Bool impldbg_checkParameter_loadCancelled						(	const	REFERENCE< XFRAMELOADER >&					xLoader				);
		sal_Bool impldbg_checkParameter_windowResized						(	const	WINDOWEVENT&								aEvent				);
		sal_Bool impldbg_checkParameter_windowActivated						(	const	EVENTOBJECT&								aEvent				);
		sal_Bool impldbg_checkParameter_windowDeactivated					(	const	EVENTOBJECT&								aEvent				);
		sal_Bool impldbg_checkParameter_initialize							(	const	REFERENCE< XWINDOW >&						xWindow				);
		sal_Bool impldbg_checkParameter_setCreator							(	const	REFERENCE< XFRAMESSUPPLIER >&				xCreator			);
		sal_Bool impldbg_checkParameter_setName								(	const	OUSTRING&									sName				);
		sal_Bool impldbg_checkParameter_findFrame							(	const	OUSTRING&									sTargetFrameName	,
							 															sal_Int32									nSearchFlags		);
		sal_Bool impldbg_checkParameter_setComponent						(	const	REFERENCE< XWINDOW >&						xComponentWindow	,
													  							const	REFERENCE< XCONTROLLER >&					xController			);
		sal_Bool impldbg_checkParameter_addFrameActionListener				(	const	REFERENCE< XFRAMEACTIONLISTENER >&			xListener			);
		sal_Bool impldbg_checkParameter_removeFrameActionListener			(	const	REFERENCE< XFRAMEACTIONLISTENER >&			xListener			);
		sal_Bool impldbg_checkParameter_addEventListener					(	const	REFERENCE< XEVENTLISTENER >&				xListener			);
		sal_Bool impldbg_checkParameter_removeEventListener					(	const	REFERENCE< XEVENTLISTENER >&				xListener			);
		sal_Bool impldbg_checkParameter_disposing							(	const	EVENTOBJECT&								aEvent				);

	#endif	// #ifdef DBG_UTIL

	//-------------------------------------------------------------------------------------------------------------
	//	variables
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	private:

		REFERENCE< XMULTISERVICEFACTORY >				m_xFactory				;	/// reference to factory, which has create this instance
		REFERENCE< XSTATUSINDICATOR > 		   			m_xIndicator			;	/// reference to current statusindicator
		REFERENCE< XWINDOW >							m_xContainerWindow		;	/// containerwindow of this frame for embedded components
		REFERENCE< XFRAME >								m_xActiveFrame			;	/// current avtive frame in tree
		REFERENCE< XFRAMESSUPPLIER >					m_xParent				;	/// parent of this frame
		REFERENCE< XFRAMELOADER >						m_xLoader				;	/// current working loader
		REFERENCE< XDISPATCHPROVIDERINTERCEPTOR >		m_xInterceptor			;
		REFERENCE< XWINDOW >							m_xComponentWindow		;	/// window of the actual component
		REFERENCE< XCONTROLLER >						m_xController			;	/// controller of the actual frame

		sal_Bool										m_bIsFrameActive		;	/// frame is the active one in its container
		sal_Bool										m_bIsFrameUIActive		;	/// frame is the active one in its container for UI
		sal_Bool										m_bSearchingAllowed		;	/// protect against recursion while searching in parent frames
		sal_Bool										m_bIsFrameTop			;	/// frame has no parent or the parent is a task
		sal_Bool										m_bAlreadyDisposed		;	/// protect egainst recursive dispose calls
		sal_Bool										m_bIAmWindowOwner		;	/// special frame services may own their containerwindow
		sal_Bool										m_bHasNewComponent		;	/// frame contains new ( Not-SFX ) component
		sal_Bool										m_bDontUpdateShells		;	/// don't update of SfxShells in loadFinished()
		sal_Bool										m_bConnected			;	/// due to FrameActionEvent
		sal_Bool										m_bLoading				;	/// loader at work

		OUSTRING										m_sFrameName			;	/// name of this frame
		OUSTRING										m_sLoadURL				;	/// for SFX compatibility: remember URL to load

		OMULTITYPEINTERFACECONTAINERHELPER				m_aListenerContainer	;	/// Container for ALL Listener
		OINTERFACECONTAINERHELPER						m_aChildFramesArray		;	/// array of child frames

};	// class Frame

}	// namespace framework

#endif	// #ifndef __FRAMEWORK_FRAME_HXX_
