/*************************************************************************
 *
 *  $RCSfile: framework.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_SERVICEMANAGER_HXX_
#include <classes/servicemanager.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

#ifndef _TOOLKIT_HELPER_VCLUNOHELPER_HXX_
#include <toolkit/helper/vclunohelper.hxx>
#endif

#ifndef _SVT_UNOIFACE_HXX
#include <svtools/unoiface.hxx>
#endif

#include <vcl/event.hxx>
#include <vcl/svapp.hxx>
#include <vcl/wrkwin.hxx>
#include <vcl/msgbox.hxx>

//_________________________________________________________________________________________________________________
//	const
//_________________________________________________________________________________________________________________

#define	APPLICATIONNAME				"FrameWork - Test"
#define	SERVICENAME_DESKTOP			"com.sun.star.framework.Desktop"
#define	SERVICENAME_FRAME			"com.sun.star.framework.Frame"

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

using namespace ::rtl					;
using namespace ::utl					;
using namespace ::framework				;
using namespace ::com::sun::star::uno	;
using namespace ::com::sun::star::lang	;
using namespace ::com::sun::star::frame	;
using namespace ::com::sun::star::awt	;
using namespace ::com::sun::star::beans	;

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

/*-***************************************************************************************************************/
class FrameWork : public Application
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		void Main();

};	//	class FrameWork

/*-***************************************************************************************************************/
class MainWindow : public WorkWindow
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		MainWindow(	Window*	pParent		,
					WinBits	nWinStyle	);

		//---------------------------------------------------------------------------------------------------------
		//	mouse handler
		//---------------------------------------------------------------------------------------------------------

		void MouseMove( const ::MouseEvent& aEvent );
		void MouseButtonDown( const ::MouseEvent& aEvent );
		void MouseButtonUp( const ::MouseEvent& aEvent );

		//---------------------------------------------------------------------------------------------------------
		//	key handler
		//---------------------------------------------------------------------------------------------------------

		void KeyInput( const ::KeyEvent& aEvent );
		void KeyUp( const ::KeyEvent& aEvent );

		//---------------------------------------------------------------------------------------------------------
		//	paint and resize handler
		//---------------------------------------------------------------------------------------------------------

		void Paint( const ::Rectangle& aRectangle );
		void Resize();

};

//_________________________________________________________________________________________________________________
//	definitions
//_________________________________________________________________________________________________________________

/*-***************************************************************************************************************/
MainWindow::MainWindow(	Window*	pParent		,
						WinBits	nWinStyle	)
	:	WorkWindow( pParent, nWinStyle )
{
}

/*-***************************************************************************************************************/
void MainWindow::MouseMove( const ::MouseEvent& aEvent )
{
	WorkWindow::MouseMove( aEvent );
}

/*-***************************************************************************************************************/
void MainWindow::MouseButtonDown( const ::MouseEvent& aEvent )
{
	WorkWindow::MouseButtonDown( aEvent );
}

/*-***************************************************************************************************************/
void MainWindow::MouseButtonUp( const ::MouseEvent& aEvent )
{
	WorkWindow::MouseButtonUp( aEvent );
}

/*-***************************************************************************************************************/
void MainWindow::KeyInput( const ::KeyEvent& aEvent )
{
	WorkWindow::KeyInput( aEvent );
}

/*-***************************************************************************************************************/
void MainWindow::KeyUp( const ::KeyEvent& aEvent )
{
	WorkWindow::KeyUp( aEvent );
}

/*-***************************************************************************************************************/
void MainWindow::Paint( const ::Rectangle& aRectangle )
{
	WorkWindow::Paint( aRectangle );
}

/*-***************************************************************************************************************/
void MainWindow::Resize()
{
	WorkWindow::Resize();
}

//_________________________________________________________________________________________________________________
//	global variables
//_________________________________________________________________________________________________________________

FrameWork	aFrameWork	;

//_________________________________________________________________________________________________________________
//	main
//_________________________________________________________________________________________________________________

void FrameWork::Main()
{
	MainWindow	aMainWindow( NULL, WB_APP | WB_STDWORK );

	aMainWindow.SetText( String( RTL_CONSTASCII_USTRINGPARAM( APPLICATIONNAME ) ) );
	aMainWindow.Show();

	ServiceManager aManager;
	Reference< XMultiServiceFactory >	xGlobalServiceManager = aManager.getManager();

	Reference< XDesktop > 				xDesktop				;
	Reference< XFrame >   				xFrame					;
	Reference< XMultiServiceFactory >   xFrameLoaderFactory		;
	Reference< XWindow >  				xWindow					;
	Reference< XFrameLoader >			xFrameLoader			;
	Reference< XLoadEventListener >		xListener				;

	if ( xGlobalServiceManager.is() == sal_True )
	{
		setProcessServiceFactory( xGlobalServiceManager );

	 	InitExtVclToolkit();

		xDesktop			= Reference< XDesktop >				( xGlobalServiceManager->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.framework.Desktop"				))), UNO_QUERY );
		xFrame				= Reference< XFrame >				( xGlobalServiceManager->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.framework.Frame"  				))), UNO_QUERY );
		xFrameLoaderFactory	= Reference< XMultiServiceFactory >	( xGlobalServiceManager->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.framework.FrameLoaderFactory"	))), UNO_QUERY );
		xWindow				= Reference< XWindow >				( VCLUnoHelper::GetInterface((Window*)&aMainWindow), UNO_QUERY );
		xListener			= Reference< XLoadEventListener >	( xFrame, UNO_QUERY );

		OSL_ENSHURE( !(xDesktop.is()			==sal_False), "xDesktop invalid!\n"				);
		OSL_ENSHURE( !(xFrame.is()				==sal_False), "xFrame invalid!\n"				);
		OSL_ENSHURE( !(xFrameLoaderFactory.is()	==sal_False), "xFrameLoaderFactory invalid!\n"	);
		OSL_ENSHURE( !(xWindow.is()				==sal_False), "xWindow invalid!\n"				);
		OSL_ENSHURE( !(xListener.is()			==sal_False), "xListener invalid!\n"			);

		xFrame->initialize( xWindow );

		Reference< XFramesSupplier > xFramesSupplier( xDesktop, UNO_QUERY );
		xFramesSupplier->setActiveFrame( xFrame );

		OUString sURL( RTL_CONSTASCII_USTRINGPARAM( "file///e|/p/src583a/wntmsci3/bin/bla.htm" ));
//		OUString sURL( RTL_CONSTASCII_USTRINGPARAM( "private:iexplorer" ));
		xFrameLoader = Reference< XFrameLoader >( xFrameLoaderFactory->createInstance( sURL ), UNO_QUERY );

		OSL_ENSHURE( !(xFrameLoader.is()==sal_False), "xFrameLoader invalid!\n" );

		xFrameLoader->load( xFrame, sURL, Sequence< PropertyValue >(), xListener );
	}

	Execute();
}
