/*************************************************************************
 *
 *  $RCSfile: registerbaehservices.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	includes of my own project
//_________________________________________________________________________________________________________________

//=================================================================================================================
//  Add new include to register new services.
//=================================================================================================================

#ifndef __FRAMEWORK_URLTRANSFORMER_HXX_
#include <baeh_services/urltransformer.hxx>
#endif

//=================================================================================================================

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif

#include <stdio.h>

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

using namespace ::rtl							;
using namespace ::framework						;
using namespace ::com::sun::star::uno			;
using namespace ::com::sun::star::container		;
using namespace ::com::sun::star::lang			;
using namespace ::com::sun::star::registry		;

//_________________________________________________________________________________________________________________
//	switches to de/activate special things like debug or test options.
//_________________________________________________________________________________________________________________

// If you will debug macros of this file ... you must define follow constant!
// Ths switch on another macro FWKDBG_OUT(...), which will print debug information to "stdout".

#define FWKDBG_MACROS

//_________________________________________________________________________________________________________________
//	macros
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	macro FWKDBG_OUT
//		With this macro you can print debug informations, if FWKDBG_MACROS is defined to.
//*****************************************************************************************************************
#ifdef FWKDBG_MACROS
	#define FWKDBG_OUT(OUTPUT)			printf( OUTPUT );
#else
	#define FWKDBG_OUT(OUTPUT)
#endif

//*****************************************************************************************************************
//	macro COMPONENT_INFO
//		With this macro you can write information about a service in registry.
//*****************************************************************************************************************
#define	COMPONENT_INFO(CLASS)																						\
																													\
	try																												\
	{                                                                                               				\
		/* Set default result of follow operations !!! */															\
		bReturn = sal_False;                                                                       					\
																													\
		/* Do the follow only, if given key is valid ! */															\
		if ( xKey.is() == sal_True )                                                                         		\
		{                                                                                           				\
			FWKDBG_OUT( "COMPONENT_INFO():xKey is valid\n" )														\
			/* Build new keyname	*/																				\
			sKeyName	 =	OUString( RTL_CONSTASCII_USTRINGPARAM( "/" ) );											\
			sKeyName	+=	CLASS##::impl_getStaticImplementationName();											\
			sKeyName	+=	OUString( RTL_CONSTASCII_USTRINGPARAM( "/UNO/SERVICES" ) );								\
																													\
			FWKDBG_OUT( "COMPONENT_INFO():try to register \"" )														\
			FWKDBG_OUT( OUStringToOString( sKeyName, RTL_TEXTENCODING_UTF8 ).getStr() )								\
			FWKDBG_OUT( "\"\n" )																					\
																													\
			/* Create new key with new name. */																		\
		 	xNewKey = xKey->createKey( sKeyName );                                              					\
																													\
			/* If this new key valid ... */																			\
			if ( xNewKey.is() == sal_True )                                                                    		\
			{                                                                                       				\
				FWKDBG_OUT( "COMPONENT_INFO():\txNewKey is valid\n" )												\
				/* Get information about supported services. */														\
				seqServiceNames	=	CLASS##::impl_getStaticSupportedServiceNames()	;           					\
				pArray			=	seqServiceNames.getArray()						;           					\
				nLength			=	seqServiceNames.getLength()						;           					\
				nCounter		=	0												;           					\
																													\
				/* Then set this information on this key. */														\
				for ( nCounter = 0; nCounter < nLength; ++nCounter )                                				\
				{                                                                                   				\
					FWKDBG_OUT( "COMPONENT_INFO():\t\twrite key \"" )												\
					FWKDBG_OUT( OUStringToOString( pArray[nCounter], RTL_TEXTENCODING_UTF8 ).getStr() )				\
					FWKDBG_OUT( "\" to registry\n" )																\
					xNewKey->createKey( pArray[nCounter] );                                      					\
				}                                                                                   				\
																													\
				/* Result of this operations = OK. */																\
				bReturn = sal_True ;                                                                				\
			}                                                                                       				\
		}                                                                                           				\
	}                                                                                               				\
	catch( InvalidRegistryException& )                                                             					\
	{                                                                                               				\
		FWKDBG_OUT( "COMPONENT_INFO():InvalidRegistryException detected\n" )										\
		bReturn = sal_False ;                                                                       				\
	}

//*****************************************************************************************************************
//	definition for "extern c component_getFactory()"
//*****************************************************************************************************************
#define	IF_NAME_CREATECOMPONENTFACTORY(CLASS)																		\
																													\
	/* If searched name found ... */																				\
	/* You can't add some statements before follow line ... Here can be an ELSE-statement! */						\
	if ( CLASS##::impl_getStaticImplementationName().equals( OUString::createFromAscii( pImplementationName ) ) )	\
	{																												\
		FWKDBG_OUT( "IF_NAME_CREATECOMPONENTFACTORY():\tImplementationname found ... try to create factory!\n" )	\
		/* ... then create right factory for this service.									*/						\
		/* xFactory and xServiceManager are local variables of method which use this macro.	*/						\
		xFactory = CLASS##::impl_createFactory( xServiceManager );													\
	}

//_________________________________________________________________________________________________________________
//	register functions
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	get informations about environment
//*****************************************************************************************************************
extern "C" void SAL_CALL component_getImplementationEnvironment( const	sal_Char**			ppEnvironmentTypeName	,
																 		uno_Environment**	ppEnvironment			)
{
	*ppEnvironmentTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME ;
}

//*****************************************************************************************************************
//	write component info to registry
//*****************************************************************************************************************
extern "C" sal_Bool SAL_CALL component_writeInfo(	void*	pServiceManager	,
													void*	pRegistryKey	)
{
	FWKDBG_OUT ( "Debug output for component_writeInfo macros!\n\n" )
	FWKDBG_OUT ( "component_writeInfo():\t[start]\n" )

	// Set default return value for this operation - if it failed.
	sal_Bool bReturn = sal_False ;

	if ( pRegistryKey != NULL )
	{
		FWKDBG_OUT( "component_writeInfo():\t\tpRegistryKey is valid ... enter scope\n" )

		// Define variables for following macros!
		// bReturn is set automaticly.
		Reference< XRegistryKey >		xKey( reinterpret_cast< XRegistryKey* >( pRegistryKey ) )	;
		Reference< XRegistryKey >		xNewKey														;
		Sequence< OUString >			seqServiceNames												;
		const OUString*					pArray														;
		sal_Int32						nLength														;
		sal_Int32						nCounter													;
		OUString						sKeyName													;

		//=============================================================================
		//  Add new macro line to register new services.
		//
		//	!!! ATTENTION !!!
		//		Write no ";" at end of line! (see macro definition)
		//=============================================================================
		COMPONENT_INFO( URLTransformer	)
		//=============================================================================

		FWKDBG_OUT( "component_writeInfo():\t\t... leave pRegistryKey scope\n" )
	}

	FWKDBG_OUT( "component_writeInfo():\t[end]\n" )

	// Return with result of this operation.
	return bReturn ;
}

//*****************************************************************************************************************
//	create right component factory
//*****************************************************************************************************************
extern "C" void* SAL_CALL component_getFactory(	const	sal_Char*	pImplementationName	,
														void*		pServiceManager		,
														void*		pRegistryKey		)
{
	FWKDBG_OUT( "component_getFactory():\t[start]\n" )

	// Set default return value for this operation - if it failed.
	void* pReturn = NULL ;

	if	(
			( pImplementationName	!=	NULL ) &&
			( pServiceManager		!=	NULL )
		)
	{
		FWKDBG_OUT( "component_getFactory():\t\t... enter scope - pointer are valid\n" )

		// Define variables which are used in following macros.
		Reference< XSingleServiceFactory >	xFactory																		;
		Reference< XMultiServiceFactory >	xServiceManager( reinterpret_cast< XMultiServiceFactory* >( pServiceManager ) )	;

		//=============================================================================
		//  Add new macro line to handle new service.
		//
		//	!!! ATTENTION !!!
		//		Write no ";" at end of line and dont forget "else" ! (see macro definition)
		//=============================================================================
		IF_NAME_CREATECOMPONENTFACTORY( URLTransformer	)
		else
//		IF_NAME_CREATECOMPONENTFACTORY( Frame			)
		//=============================================================================

		// Factory is valid, if service was found.
		if ( xFactory.is() == sal_True )
		{
			FWKDBG_OUT( "component_getFactory():\t\t\t... xFactory valid - service was found\n" )

			xFactory->acquire();
			pReturn = xFactory.get();
		}

		FWKDBG_OUT( "component_getFactory():\t\t... leave scope\n" )
	}

	FWKDBG_OUT( "component_getFactory():\t[end]\n" )

	// Return with result of this operation.
	return pReturn ;
}
