/*************************************************************************
 *
 *  $RCSfile: documentproperties.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//______________________________________________________________________________________________________________
//	my own includes
//______________________________________________________________________________________________________________

#ifndef __DOCUMENTPROPERTIES_HXX_
#include <documentproperties.hxx>
#endif

//______________________________________________________________________________________________________________
//	includes of other projects
//______________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_REFLECTION_XIDLREFLECTION_HPP_
#include <com/sun/star/reflection/XIdlReflection.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif

#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif

#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx>
#endif

#ifndef _CPPUHELPER_STDIDLCLASS_HXX_
#include <cppuhelper/stdidlclass.hxx>
#endif

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif

#ifndef _CPPUHELPER_COMPONENT_HXX_
#include <cppuhelper/component.hxx>
#endif

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _SOT_EXCHANGE_HXX
#include <sot/exchange.hxx>
#endif

//______________________________________________________________________________________________________________
//	includes of my own project
//______________________________________________________________________________________________________________

//______________________________________________________________________________________________________________
//	defines
//______________________________________________________________________________________________________________

// Some identifier of this implementation.
#define	IDLCLASSNAME							"DocumentProperties"							// IDL name of this class
#define	SERVICENAME								"com.sun.star.document.DocumentProperties"		// service-name of this class
#define	IMPLEMENTATIONNAME						"DocumentProperties.DocumentProperties"			// implementation-name of this class

// Some identifier for other classes or types
#define	HEADERNAME								"SfxDocumentInfo"								// Typename of fileheader
#define	SLOTNAME								"SfxDocumentInfo"								// Name of documentinfo-stream in file

// Handles for properties
// (PLEASE SORT THIS FIELD, IF YOU ADD NEW PROPERTIES!)
// We use an enum to define these handles, to use all numbers from 0 to nn and
// if you add someone, you don't must control this!
// But don't forget to change values of follow defines, if you do something with this enum!
enum
{
	HANDLE_AUTHOR					,
	HANDLE_AUTOLOADENABLED			,
	HANDLE_AUTOLOADSECS				,
	HANDLE_AUTOLOADURL				,
	HANDLE_BLINDCOPIESTO			,
	HANDLE_COPIESTO					,
	HANDLE_CREATIONDATE				,
	HANDLE_DEFAULTTARGET			,
	HANDLE_DESCRIPTION				,
	HANDLE_EDITINGCYCLES			,
	HANDLE_EDITINGDURATION			,
	HANDLE_EXTRADATA				,
	HANDLE_INREPLYTO				,
	HANDLE_ISENCRYPTED				,
	HANDLE_KEYWORDS			   		,
	HANDLE_MIMETYPE					,
	HANDLE_MODIFIEDBY				,
	HANDLE_MODIFYDATE				,
	HANDLE_NEWSGROUPS				,
	HANDLE_ORIGINAL					,
	HANDLE_PORTABLEGRAPHICS         ,
	HANDLE_PRINTDATE				,
	HANDLE_PRINTEDBY				,
	HANDLE_PRIORITY					,
	HANDLE_QUERYTEMPLATE            ,
	HANDLE_RECIPIENT				,
	HANDLE_REFERENCES				,
	HANDLE_REPLYTO					,
	HANDLE_SAVEGRAPHICSCOMPRESSED   ,
	HANDLE_SAVEORIGINALGRAPHICS     ,
	HANDLE_SAVEVERSIONONCLOSE       ,
	HANDLE_TEMPLATE					,
	HANDLE_TEMPLATECONFIG           ,
	HANDLE_TEMPLATEFILENAME			,
	HANDLE_TEMPLATEDATE				,
	HANDLE_THEME					,
	HANDLE_TITLE					,
	HANDLE_USERDATA
} ;

#define	MIN_PROPERTIES							HANDLE_AUTHOR		// Must be the number of first handle !!!
#define	MAX_PROPERTIES							HANDLE_USERDATA		// Must be the number of last  handle !!!
#define	COUNT_PROPERTIES						(MAX_PROPERTIES+1)	// Count of properties (+1, while based on 0!)

// Some default values for internal variables
#define	DEFAULT_HEADERTYPE						HEADERNAME
#define	DEFAULT_HEADERVERSION					11
#define	DEFAULT_FILECHARSET						CHARSET_DONTKNOW
#define	DEFAULT_FILEVERSION						SOFFICE_FILEFORMAT_NOW
#define	DEFAULT_FORMATID						0

// All default values for properties
#define	DEFAULT_AUTHOR							""
#define	DEFAULT_AUTOLOADENABLED					sal_False
#define	DEFAULT_AUTOLOADSECS					60
#define	DEFAULT_AUTOLOADURL						""
#define	DEFAULT_BLINDCOPIESTO					""
#define	DEFAULT_COPIESTO						""
#define	DEFAULT_DEFAULTTARGET					""
#define	DEFAULT_DESCRIPTION						""
#define	DEFAULT_EDITINGCYCLES					0
#define	DEFAULT_EDITINGDURATION					0
#define	DEFAULT_INREPLYTO						""
#define	DEFAULT_ISENCRYPTED						sal_True
#define	DEFAULT_KEYWORDS						""
#define	DEFAULT_MIMETYPE						""
#define	DEFAULT_MODIFIEDBY						""
#define	DEFAULT_NEWSGROUPS						""
#define	DEFAULT_ORIGINAL						""
#define	DEFAULT_PORTABLEGRAPHICS				sal_True
#define	DEFAULT_PRINTEDBY						""
#define	DEFAULT_PRIORITY						0
#define	DEFAULT_QUERYTEMPLATE					sal_True
#define	DEFAULT_RECIPIENT						""
#define	DEFAULT_REFERENCES						""
#define	DEFAULT_REPLYTO							""
#define	DEFAULT_SAVEGRAPHICSCOMPRESSED			sal_True
#define	DEFAULT_SAVEORIGINALGRAPHICS			sal_True
#define	DEFAULT_SAVEVERSIONONCLOSE				sal_True
#define	DEFAULT_TEMPLATE						""
#define	DEFAULT_TEMPLATECONFIG					sal_True
#define	DEFAULT_TEMPLATEFILENAME				""
#define	DEFAULT_THEME							""
#define	DEFAULT_TITLE							""
#define	DEFAULT_USERDATA						sal_True

// Some properties have a fixed size in file ...
#define FIXSIZE_TITLE							63
#define FIXSIZE_THEME							63
#define FIXSIZE_DESCRIPTION						255
#define FIXSIZE_KEYWORDS						127
#define FIXSIZE_DOCUSERKEY						19
#define	MAXCOUNT_DOCUSERKEYS					4

//______________________________________________________________________________________________________________
//	namespaces
//______________________________________________________________________________________________________________

using namespace ::std							;
using namespace ::osl							;
using namespace ::rtl							;
using namespace ::cppu							;
using namespace ::com::sun::star::uno			;
using namespace ::com::sun::star::lang			;
using namespace ::com::sun::star::reflection	;
using namespace ::com::sun::star::beans			;
using namespace ::com::sun::star::util			;
using namespace ::com::sun::star::container		;
using namespace ::com::sun::star::io			;

//______________________________________________________________________________________________________________
//	structs
//______________________________________________________________________________________________________________

// This struct handle a mimetype- and a fileversion-value and is used
// at follow static convert table.
// (see also "aStaticConvertTable[]")

struct IMPL_FormatID_MIMEType_FileVersion
{
	OUString	sMIMEType		;
	sal_Int32	nFileVersion	;

	IMPL_FormatID_MIMEType_FileVersion ( const OUString& rMIMEType, const sal_Int32& rFileVersion )
			:	sMIMEType		( rMIMEType		)
			,	nFileVersion	( rFileVersion	)
	{
	}
} ;

//______________________________________________________________________________________________________________
//	static variables
//		Often we use static variables or structures to return information, if we will not build this for every call
//		of a method. But we must use everytime a mutex or optimize these operations with ILLEGAL code ...
//		If we use these static variables, which are created only for
//______________________________________________________________________________________________________________

// Follow struct is used to convert FormatID to MIMEType and/or version of file!
// (FormatID is the index in table.)

// All values are sorted by ID. Every ID is ID from predecessor + 1.
// We use this to find right value in table without string compare.
// If one item has not MIMEType or version, use a L""-string and SOFFICE_FILEFORMAT_NOW.
// Its necessary to use ID directly as index in table.
// If you delete some lines with default-members, this algorithm will be get invalid results...!!!

static const IMPL_FormatID_MIMEType_FileVersion aStaticConvertTable[] =
{
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  0	SOT_FORMAT_SYSTEM_START							""
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  1	SOT_FORMAT_STRING								"Text"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  2	SOT_FORMAT_BITMAP								"Bitmap"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  3	SOT_FORMAT_GDIMETAFILE							"GDIMetaFile"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  4	SOT_FORMAT_PRIVATE								"Private"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  5	SOT_FORMAT_FILE									"FileName"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  6	SOT_FORMAT_FILE_LIST							"FileList"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  7	EMPTY											""
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  8	EMPTY											""
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	  9	EMPTY											""
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 10	SOT_FORMAT_RTF									"Rich Text Format"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 11	SOT_FORMATSTR_ID_DRAWING						"StarOffice Drawing Format"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 12	SOT_FORMATSTR_ID_SVXB							"SVXB (StarView Bitmap/Animation)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 13	SOT_FORMATSTR_ID_SVIM							"SVIM (StarView ImageMap)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 14	SOT_FORMATSTR_ID_XFA							"XFA (XOutDev FillAttr)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 15	SOT_FORMATSTR_ID_EDITENGINE						"EditEngineFormat"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 16	SOT_FORMATSTR_ID_INTERNALLINK_STATE				"StatusInfo vom SvxInternalLink"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 17	SOT_FORMATSTR_ID_SOLK							"SOLK (StarOffice Link)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 18	SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK				"Netscape Bookmark"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 19	SOT_FORMATSTR_ID_TREELISTBOX					"SV_LBOX_DD_FORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 20	SOT_FORMATSTR_ID_NATIVE							"Native"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 21	SOT_FORMATSTR_ID_OWNERLINK						"OwnerLink"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 22	SOT_FORMATSTR_ID_STARSERVER						"StarServerFormat"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 23	SOT_FORMATSTR_ID_STAROBJECT						"StarObjectFormat"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 24	SOT_FORMATSTR_ID_APPLETOBJECT					"Applet Object"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 25	SOT_FORMATSTR_ID_PLUGIN_OBJECT					"PlugIn Object"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starwriter"					),SOFFICE_FILEFORMAT_31	),	//	 26	SOT_FORMATSTR_ID_STARWRITER_30					"StarWriter 3.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starwriter"					),SOFFICE_FILEFORMAT_40	),	//	 27	SOT_FORMATSTR_ID_STARWRITER_40					"StarWriter 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.writer"		),SOFFICE_FILEFORMAT_50	),	//	 28	SOT_FORMATSTR_ID_STARWRITER_50					"StarWriter 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starwriter/web"				),SOFFICE_FILEFORMAT_40	),	//	 29	SOT_FORMATSTR_ID_STARWRITERWEB_40				"StarWriter/Web 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.writer/web"	),SOFFICE_FILEFORMAT_50	),	//	 30	SOT_FORMATSTR_ID_STARWRITERWEB_50				"StarWriter/Web 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starwriter"					),SOFFICE_FILEFORMAT_40	),	//	 31	SOT_FORMATSTR_ID_STARWRITERGLOB_40				"StarWriter/Global 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.writer-global"),SOFFICE_FILEFORMAT_50	),	//	 32	SOT_FORMATSTR_ID_STARWRITERGLOB_50				"StarWriter/Global 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-stardraw"					),SOFFICE_FILEFORMAT_40	),	//	 33	SOT_FORMATSTR_ID_STARDRAW						"StarDrawDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starimpress"					),SOFFICE_FILEFORMAT_40	),	//	 34	SOT_FORMATSTR_ID_STARDRAW_40					"StarDrawDocument 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.impress"		),SOFFICE_FILEFORMAT_50	),	//	 35	SOT_FORMATSTR_ID_STARIMPRESS_50					"StarImpress 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.draw"			),SOFFICE_FILEFORMAT_50	),	//	 36	SOT_FORMATSTR_ID_STARDRAW_50					"StarDraw 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starcalc"					),SOFFICE_FILEFORMAT_31	),	//	 37	SOT_FORMATSTR_ID_STARCALC						"StarCalcDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starcalc"					),SOFFICE_FILEFORMAT_40	),	//	 38	SOT_FORMATSTR_ID_STARCALC_40					"StarCalc 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.calc"			),SOFFICE_FILEFORMAT_50	),	//	 39	SOT_FORMATSTR_ID_STARCALC_50					"StarCalc 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starchart"					),SOFFICE_FILEFORMAT_31	),	//	 40	SOT_FORMATSTR_ID_STARCHART						"StarChartDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starchart"					),SOFFICE_FILEFORMAT_40	),	//	 41	SOT_FORMATSTR_ID_STARCHART_40					"StarChartDocument 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.chart"		),SOFFICE_FILEFORMAT_50	),	//	 42	SOT_FORMATSTR_ID_STARCHART_50					"StarChart 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starimage"					),SOFFICE_FILEFORMAT_31	),	//	 43	SOT_FORMATSTR_ID_STARIMAGE						"StarImageDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starimage"					),SOFFICE_FILEFORMAT_40	),	//	 44	SOT_FORMATSTR_ID_STARIMAGE_40					"StarImageDocument 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starimage"					),SOFFICE_FILEFORMAT_50	),	//	 45	SOT_FORMATSTR_ID_STARIMAGE_50					"StarImage 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starmath"					),SOFFICE_FILEFORMAT_31	),	//	 46	SOT_FORMATSTR_ID_STARMATH						"StarMath"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/x-starmath"					),SOFFICE_FILEFORMAT_40	),	//	 47	SOT_FORMATSTR_ID_STARMATH_40					"StarMathDocument 4.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/vnd.stardivision.math"			),SOFFICE_FILEFORMAT_50	),	//	 48	SOT_FORMATSTR_ID_STARMATH_50					"StarMath 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 49	SOT_FORMATSTR_ID_STAROBJECT_PAINTDOC			"StarObjectPaintDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 50	SOT_FORMATSTR_ID_FILLED_AREA					"FilledArea"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 51	SOT_FORMATSTR_ID_HTML							"HTML (HyperText Markup Language)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 52	SOT_FORMATSTR_ID_HTML_SIMPLE					"HTML Format"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 53	SOT_FORMATSTR_ID_CHAOS							"FORMAT_CHAOS"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 54	SOT_FORMATSTR_ID_CNT_MSGATTACHFILE				"CNT_MSGATTACHFILE_FORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 55	SOT_FORMATSTR_ID_BIFF_5							"Biff5"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 56	SOT_FORMATSTR_ID_BIFF__5						"Biff 5"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 57	SOT_FORMATSTR_ID_SYLK							"Sylk"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 58	SOT_FORMATSTR_ID_SYLK_BIGCAPS					"SYLK"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 59	SOT_FORMATSTR_ID_LINK							"Link"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 60	SOT_FORMATSTR_ID_DIF							"DIF"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 61	SOT_FORMATSTR_ID_STARDRAW_TABBAR				"StarDraw TabBar"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 62	SOT_FORMATSTR_ID_SONLK							"SONLK (StarOffice Navi Link)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( "application/msword"						),DEFAULT_FILEVERSION	),	//	 63	SOT_FORMATSTR_ID_MSWORD_DOC						"MSWordDoc"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 64	SOT_FORMATSTR_ID_STAR_FRAMESET_DOC				"StarFrameSetDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 65	SOT_FORMATSTR_ID_OFFICE_DOC						"OfficeDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 66	SOT_FORMATSTR_ID_NOTES_DOCINFO					"NotesDocInfo"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 67	SOT_FORMATSTR_ID_NOTES_HNOTE					"NoteshNote"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 68	SOT_FORMATSTR_ID_NOTES_NATIVE					"Native"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 69	SOT_FORMATSTR_ID_SFX_DOC						"SfxDocument"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 70	SOT_FORMATSTR_ID_EVDF							"EVDF (Explorer View Dummy Format)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 71	SOT_FORMATSTR_ID_ESDF							"ESDF (Explorer Search Dummy Format)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 72	SOT_FORMATSTR_ID_IDF							"IDF (Iconview Dummy Format)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 73	SOT_FORMATSTR_ID_EFTP							"EFTP (Explorer Ftp File)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 74	SOT_FORMATSTR_ID_EFD							"EFD (Explorer Ftp Dir)"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 75	SOT_FORMATSTR_ID_SVX_FORMFIELDEXCH				"SvxFormFieldExch"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 76	SOT_FORMATSTR_ID_EXTENDED_TABBAR				"ExtendedTabBar"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 77	SOT_FORMATSTR_ID_SBA_DATAEXCHANGE				"SBA-DATAFORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 78	SOT_FORMATSTR_ID_SBA_FIELDDATAEXCHANGE			"SBA-FIELDFORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 79	SOT_FORMATSTR_ID_SBA_PRIVATE_URL				"SBA-PRIVATEURLFORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 80	SOT_FORMATSTR_ID_SBA_TABED						"Tabed"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 81	SOT_FORMATSTR_ID_SBA_TABID						"Tabid"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 82	SOT_FORMATSTR_ID_SBA_JOIN						"SBA-JOINFORMAT"
#ifdef MAC
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 83	SOT_FORMATSTR_ID_OBJECTDESCRIPTOR				"Star OBJD"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 84	SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR				"Star LKSD"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 85	SOT_FORMATSTR_ID_EMBED_SOURCE					"Star EMBS"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 86	SOT_FORMATSTR_ID_LINK_SOURCE					"Star LNKS"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 87	SOT_FORMATSTR_ID_EMBEDDED_OBJ					"Star EMBO"
#else
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 83	SOT_FORMATSTR_ID_OBJECTDESCRIPTOR				"Star Object Descriptor"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 84	SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR				"Star Link Source Descriptor"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 85	SOT_FORMATSTR_ID_EMBED_SOURCE					"Star Embed Source"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 86	SOT_FORMATSTR_ID_LINK_SOURCE					"Star Link Source"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 87	SOT_FORMATSTR_ID_EMBEDDED_OBJ					"Star Embedded Object"
#endif
#ifdef WNT
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 88	SOT_FORMATSTR_ID_FILECONTENT					CFSTR_FILECONTENTS
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 89	SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR				CFSTR_FILEDESCRIPTOR
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 90	SOT_FORMATSTR_ID_FILENAME						CFSTR_FILENAME
#else
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 88	SOT_FORMATSTR_ID_FILECONTENT					"FileContents"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 89	SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR				"FileGroupDescriptor"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 90	SOT_FORMATSTR_ID_FILENAME						"FileName"
#endif
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 91	SOT_FORMATSTR_ID_SD_OLE							"SD-OLE"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 92	SOT_FORMATSTR_ID_EMBEDDED_OBJ_OLE				"Embedded Object"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 93	SOT_FORMATSTR_ID_EMBED_SOURCE_OLE				"Embed Source"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 94	SOT_FORMATSTR_ID_OBJECTDESCRIPTOR_OLE			"Object Descriptor"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 95	SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR_OLE			"Link Source Descriptor"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 96	SOT_FORMATSTR_ID_LINK_SOURCE_OLE				"Link Source"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 97	SOT_FORMATSTR_ID_SBA_CTRLDATAEXCHANGE			"SBA-CTRLFORMAT"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 98	SOT_FORMATSTR_ID_OUTPLACE_OBJ					"OutPlace Object"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	 99	SOT_FORMATSTR_ID_CNT_OWN_CLIP					"CntOwnClipboard"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	100	SOT_FORMATSTR_ID_INET_IMAGE						"SO-INet-Image"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	101	SOT_FORMATSTR_ID_NETSCAPE_IMAGE					"Netscape Image Format"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	102	SOT_FORMATSTR_ID_SBA_FORMEXCHANGE				"SBA_FORMEXCHANGE"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	103	SOT_FORMATSTR_ID_SBA_REPORTEXCHANGE				"SBA_REPORTEXCHANGE"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	104	SOT_FORMATSTR_ID_UNIFORMRESOURCELOCATOR			"UniformResourceLocator"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	105	SOT_FORMATSTR_ID_STARCHARTDOCUMENT_50			"StarChartDocument 5.0"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	106	SOT_FORMATSTR_ID_GRAPHOBJ						"Graphic Object"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	),	//	107	SOT_FORMATSTR_ID_DUMMY3							"SO_DUMMYFORMAT_3"
	IMPL_FormatID_MIMEType_FileVersion ( OUString::createFromAscii( DEFAULT_MIMETYPE							),DEFAULT_FILEVERSION	)	//	108	SOT_FORMATSTR_ID_DUMMY4							"SO_DUMMYFORMAT_4"
};

//______________________________________________________________________________________________________________
//	public methods start
//______________________________________________________________________________________________________________

//******************************************************************************************************************************
DocumentProperties::DocumentProperties ( const Reference< XMultiServiceFactory >& rFactory )
		// Init baseclasses first
		//	Attention:
		//		Don't change order of initialization!
		//      IMPL_OMutexContainer is a struct with a mutex as member. We can't use a mutex as member, while
		//		we must garant right initialization and a valid value of this! First initialize
		//		baseclasses and then members. And we need the mutex for other baseclasses !!!
		:	IMPL_MutexContainer		(																						)
		,	OBroadcastHelper		( ((IMPL_MutexContainer*)this)->m_aMutex												)
		,	OPropertySetHelper		( *SAL_STATIC_CAST ( OBroadcastHelperVar< OMultiTypeInterfaceContainerHelper >*, this )	)
		,	OWeakObject				(																						)
		// Init member variables
		,	m_rFactory				( rFactory																				)
		,	m_aPropertyHashTable	(																						)
{
	// Set default values on members and clear some structures.
	impl_resetObject () ;
}

//******************************************************************************************************************************
DocumentProperties::~DocumentProperties	()
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Clear memory !
	m_aPropertyHashTable.clear	(	) ;
	m_seqExtraData.realloc		( 0 ) ;
}

//******************************************************************************************************************************
//	XInterface
//******************************************************************************************************************************
Any SAL_CALL DocumentProperties::queryInterface ( const Type& rType ) throw ( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Safe impossible cases
	DBG_ASSERT ( impl_debug_checkParameter ( rType ), "DocumentProperties::queryInterface()\nInvalid parameter detected.\n" ) ;

	// Ask for my own supported interfaces ...
	Any aReturn	( ::cppu::queryInterface	(	rType										,
												static_cast< XServiceInfo*		> ( this )	,
												static_cast< XTypeProvider*		> ( this )	,
												static_cast< XNameContainer*	> ( this )	,
												static_cast< XNameReplace*		> ( this )	,
												static_cast< XNameAccess*		> ( this )	,
												static_cast< XElementAccess*	> ( this )	,
												static_cast< XPersist*			> ( this )	) ) ;

	// If searched interface supported by this class ...
	if ( aReturn.hasValue () == sal_True )
	{
		// ... return this information.
		return aReturn ;
	}
	else
	{
		// Else; ... ask baseclass for interfaces!
		return OWeakObject::queryInterface ( rType ) ;
	}
}

//******************************************************************************************************************************
//	XInterface
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::acquire () throw ( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Forward to baseclass
	OWeakObject::acquire () ;
}

//******************************************************************************************************************************
//	XInterface
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::release () throw ( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Forward to baseclass
	OWeakObject::release () ;
}

//******************************************************************************************************************************
//	XServiceInfo
//******************************************************************************************************************************
sal_Bool SAL_CALL DocumentProperties::supportsService ( const OUString& rServiceName ) throw ( RuntimeException )
{
	// Safe impossible cases
	DBG_ASSERT ( impl_debug_checkParameter ( rServiceName ), "DocumentProperties::supportsService()\nInvalid parameter detected.\n" ) ;

	// Get information about all supported services ...
	Sequence< OUString >	seqServiceNames	=	getSupportedServiceNames	()	;
	const OUString*			pArray			=	seqServiceNames.getArray	()	;
	sal_Int32				nLength			=	seqServiceNames.getLength	()	;
	sal_Int32				nCounter		=	0								;

	// If pointer not valid ... or no servicename exist ...
	if	(
			( pArray	==	(OUString*)0	)	||
			( nLength	<	1				)
		)
	{
		// ... dont work with him ... return with "no support this service".
		// (Its OK - servicename not exist!?)
		return sal_False ;
	}

	// Else - search for right service.
	for ( nCounter = 0; nCounter < nLength; nCounter++ )
	{
		// Have we found it ?
		if ( pArray[nCounter] == rServiceName )
		{
			// YES ... return result.
			return sal_True ;
		}
	}

	// NO ... return result.
	return sal_False ;
}

//******************************************************************************************************************************
//	XServiceInfo
//******************************************************************************************************************************
Sequence< OUString > SAL_CALL DocumentProperties::getSupportedServiceNames () throw ( RuntimeException )
{
	// Its the same for all instances of this class!
	// Use private and static method to get this information.
	return impl_getStaticSupportedServiceNames () ;
}

//******************************************************************************************************************************
//	XServiceInfo
//******************************************************************************************************************************
OUString SAL_CALL DocumentProperties::getImplementationName	() throw ( RuntimeException )
{
	// Its the same for all instances of this class!
	// Use private and static method to get this information.
	return impl_getStaticImplementationName () ;
}

//******************************************************************************************************************************
//	XTypeProvider
//******************************************************************************************************************************
Sequence< Type > SAL_CALL DocumentProperties::getTypes () throw ( RuntimeException )
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pTypeCollection is NULL - for the second call pTypeCollection is different from NULL!
	static OTypeCollection* pTypeCollection = (OTypeCollection*)0 ;

	if ( pTypeCollection == (OTypeCollection*)0 )
	{
		// Ready for multithreading; get global mutex for first call of this method only! see before
		MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

		// Control these pointer again ... it can be, that another instance will be faster then these!
		if ( pTypeCollection == (OTypeCollection*)0 )
		{
			// Create a static typecollection ...
			static OTypeCollection aTypeCollection	(	getCppuType ( ( Reference< XServiceInfo		>* ) 0 ) ,
														getCppuType ( ( Reference< XTypeProvider	>* ) 0 ) ,
														getCppuType ( ( Reference< XNameContainer	>* ) 0 ) ,
														getCppuType ( ( Reference< XNameReplace		>* ) 0 ) ,
														getCppuType ( ( Reference< XNameAccess		>* ) 0 ) ,
														getCppuType ( ( Reference< XElementAccess	>* ) 0 ) ,
														getCppuType ( ( Reference< XPersist			>* ) 0 ) ) ;
			// ... and set his address to static pointer!
			pTypeCollection = &aTypeCollection ;
		}
	}

	return pTypeCollection->getTypes () ;
}

//******************************************************************************************************************************
//	XTypeProvider
//******************************************************************************************************************************
Sequence< sal_Int8 > SAL_CALL DocumentProperties::getImplementationId () throw ( RuntimeException )
{
	// Create one Id for all instances of this class.
	// Use ethernet address to do this! (sal_True)

	// Optimize this method
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pID is NULL - for the second call pID is different from NULL!
	static OImplementationId* pID = (OImplementationId*)0 ;

	if ( pID == (OImplementationId*)0 )
	{
		// Ready for multithreading; get global mutex for first call of this method only! see before
		MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

		// Control these pointer again ... it can be, that another instance will be faster then these!
		if ( pID == (OImplementationId*)0 )
		{
			// Create a new static ID ...
			static OImplementationId aID ( sal_False ) ;
			// ... and set his address to static pointer!
			pID = &aID ;
		}
	}

	return pID->getImplementationId () ;
}

//******************************************************************************************************************************
//	XNameContainer
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::insertByName ( const OUString& rName, const Any& rElement ) throw ( IllegalArgumentException, ElementExistException, WrappedTargetException, RuntimeException )
{
	OUString	sValue	;
	sal_Bool	bState	;

	// Convert Any to right type (OUString) ...
	bState = ( rElement >>= sValue ) ;

	// ... and check parameter. Name must exist, value can be set!
	if	(
			( bState				==	sal_False	)	||
			( rName.getLength	()	<	1			)
		)
	{
		// Some parameter are invalid ... throw an exception.
		throw ( IllegalArgumentException () ) ;
	}

	// To get more information, see declaration of this define!!!
	#ifdef DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES

		// Size of namecontainer-properties is fixed to 19 letters in file :-)
		// Throw an exception, if values are greater!
		if	(
				( rName.getLength	() > FIXSIZE_DOCUSERKEY )	||
				( sValue.getLength	() > FIXSIZE_DOCUSERKEY )
			)
		{
			throw ( IllegalArgumentException () ) ;
		}

	#endif // DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for existing element with same name!
	IMPL_OPropertyHashTable::iterator aSearchedItem = m_aPropertyHashTable.find ( rName ) ;

	// If element already exist ...
	if ( aSearchedItem != m_aPropertyHashTable.end () )
	{
		// ... we throw an exception.
		throw ( ElementExistException () ) ;
	}

	// Element doesn't exist at this point.
	// Insert it into namecontainer...
	// Put value in hashtable. Use "rName" as key.
	m_aPropertyHashTable [ rName ] = sValue ;
}

//******************************************************************************************************************************
//	XNameContainer
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::removeByName ( const OUString& rName ) throw ( NoSuchElementException, WrappedTargetException, RuntimeException )
{
	// I don't know, if hashtable has a defaultvalue for strings !?
	// I think, "" as name is not allowed !!!
	if ( rName.getLength () < 1 )
	{
		throw ( NoSuchElementException () ) ;
	}

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for existing element with same name!
	IMPL_OPropertyHashTable::iterator aExistingElement = m_aPropertyHashTable.find ( rName ) ;

	// Element not exit.
	if ( aExistingElement == m_aPropertyHashTable.end () )
	{
		throw ( NoSuchElementException () ) ;
	}

	// Else ... Remove element from hashmap.
	m_aPropertyHashTable.erase ( rName ) ;
}

//******************************************************************************************************************************
//	XNameReplace
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::replaceByName ( const OUString& rName, const Any& rElement ) throw ( IllegalArgumentException, NoSuchElementException, WrappedTargetException, RuntimeException )
{
	OUString	sValue	;
	sal_Bool	bState	;

	// Convert Any to right type (OUString) ...
	bState = ( rElement >>= sValue ) ;

	// ... and check parameter. Name must exist, value can be set!
	if	(
			( bState				==	sal_False	)	||
			( rName.getLength	()	<	1			)
		)
	{
		// Some parameter are invalid ... throw an exception.
		throw ( IllegalArgumentException () ) ;
	}

	// To get more information, see declaration of this define!!!
	#ifdef DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES

		// Size of namecontainer-properties is fixed to 19 letters in file :-)
		// Throw an exception, if values are greater!
		if	(
				( rName.getLength	() > FIXSIZE_DOCUSERKEY )	||
				( sValue.getLength	() > FIXSIZE_DOCUSERKEY )
			)
		{
			throw ( IllegalArgumentException () ) ;
		}

	#endif // DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for existing element with same name!
	IMPL_OPropertyHashTable::iterator aExistingElement = m_aPropertyHashTable.find ( rName ) ;

	// Element not exist.
	if ( aExistingElement == m_aPropertyHashTable.end () )
	{
		throw ( NoSuchElementException () ) ;
	}

	// Element exist at this point.
	// Set new value in hashtable. Use "rName" as key.
	m_aPropertyHashTable [ rName ] = sValue ;
}

//******************************************************************************************************************************
//	XNameAccess
//******************************************************************************************************************************
Any SAL_CALL DocumentProperties::getByName ( const OUString& rName ) throw ( NoSuchElementException, WrappedTargetException, RuntimeException )
{
	// I don't know, if hashtable has a defaultvalue for strings !?
	// I think, "" as name is not allowed !!!
	if ( rName.getLength () < 1 )
	{
		throw ( NoSuchElementException () ) ;
	}

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for existing element with same name!
	IMPL_OPropertyHashTable::iterator aExistingElement = m_aPropertyHashTable.find ( rName ) ;

	// Element not exist.
	if ( aExistingElement == m_aPropertyHashTable.end () )
	{
		throw ( NoSuchElementException () ) ;
	}

	// Else; Return value.
	Any aReturn ;
	aReturn <<= m_aPropertyHashTable [ rName ] ;
	return aReturn ;
}

//******************************************************************************************************************************
//	XNameAccess
//******************************************************************************************************************************
Sequence< OUString > SAL_CALL DocumentProperties::getElementNames () throw ( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Get count of elements in hashtable.
	IMPL_OPropertyHashTable::size_type nCount = m_aPropertyHashTable.size () ;

	// There are no elements ... return with empty sequence.
	if ( nCount < 1 )
	{
		return Sequence< OUString > () ;
	}

	// There more then one elements.
	// Create new sequence for all names.
	Sequence< OUString >	seqElementNames	( nCount )						;
	OUString*				pArray			= seqElementNames.getArray ()	;

	// Safe impossible case
	// We need this pointer to work.
	DBG_ASSERT ( !( pArray == (OUString*)0 ), "DocumentProperties::getElementNames()\nI become a NULL-pointer from a sequence with more then one elements!?\n" ) ;

	// Get information about hashmap.
	IMPL_OPropertyHashTable::iterator	aStartIterator	=	m_aPropertyHashTable.begin	()	;
	IMPL_OPropertyHashTable::iterator	aEndIterator	=	m_aPropertyHashTable.end	()	;
	IMPL_OPropertyHashTable::size_type	nElement		=	0								;

	// Copy all names of hashmap elements to sequence.
	while ( aStartIterator != aEndIterator )
	{
		// Safe impossible cases
		// We have create a sequence for nCount elements!
		DBG_ASSERT ( !( nElement >= nCount ), "DocumentProperties::getElementNames()\nThere are to much elements!\n") ;

		// "first" = first item of struct IMPL_OPropertyHashTable = KEY = name !!!
		//pArray [ nElement ] = (Any*)(*aStartIterator).second ;
		pArray [ nElement ] = aStartIterator->first ;

		// Safe impossible cases !
		DBG_ASSERT ( !( pArray[nElement].getLength () < 1 ), "DocumentProperties::getElementNames()\nThere is an empty string in namecontainer! This is not allowed.\n" ) ;

		// Set pointers to next position.
		++aStartIterator	;
		++nElement			;
	}

	// Return sequence with all element names.
	return seqElementNames ;
}

//******************************************************************************************************************************
//	XNameAccess
//******************************************************************************************************************************
sal_Bool SAL_CALL DocumentProperties::hasByName ( const OUString& rName ) throw ( RuntimeException )
{
	// I don't know, if hashtable has a defaultvalue for strings !?
	// I think, "" as name is not allowed !!!
	if ( rName.getLength () < 1 )
	{
		return sal_False ;
	}

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for existing element with same name!
	IMPL_OPropertyHashTable::iterator aExistingElement = m_aPropertyHashTable.find ( rName ) ;

	if ( aExistingElement != m_aPropertyHashTable.end () )
	{
		// Element exist.
		return sal_True ;
	}
	else
	{
		// Element not exist.
		return sal_False ;
	}
}

//******************************************************************************************************************************
//	XElementAccess
//******************************************************************************************************************************
Type SAL_CALL DocumentProperties::getElementType () throw ( RuntimeException )
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pType is NULL - for the second call pType is different from NULL!
	static Type* pType = (Type*)0 ;

	if ( pType == (Type*)0 )
	{
		// Ready for multithreading
		MutexGuard aGuard ( m_aMutex ) ;

		// Control this pointer! Another instance can be faster then these!
		if ( pType == (Type*)0 )
		{
			// Create static member to hold type of elements ...
			static Type aOUStringType = getCppuType ( (OUString*)0 ) ;
			// ... and set his address to static pointer!
			pType = &aOUStringType ;
		}
	}

	// Return type of elements.
	return ( *pType ) ;
}

//******************************************************************************************************************************
//	XElementAccess
//******************************************************************************************************************************
sal_Bool SAL_CALL DocumentProperties::hasElements () throw ( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Get count of elements in hashtable.
	IMPL_OPropertyHashTable::size_type nCount = m_aPropertyHashTable.size () ;

	if ( nCount > 0 )
	{
		// Hasmap has elements.
		return sal_True  ;
	}
	else
	{
		// Hasmap has no elements.
		return sal_False ;
	}
}

//******************************************************************************************************************************
//	XPersist
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::read ( const OUString& rURL ) throw ( IOException, RuntimeException )
{
	// Safe impossible cases
	// Check more things on parameter as in release version !
	DBG_ASSERT ( impl_debug_checkParameter ( rURL ), "DocumentProperties::read()\nInvalid parameter detected.\n" ) ;

	// We can't work without a valid URL!
	// It must be a valid string AND a storage file.
	if	(
			( rURL.getLength			(								)	<	1			)	||
			( SotStorage::IsStorageFile	( impl_OUString2String ( rURL ) )	==	sal_False	)
		)
	{
		throw ( IOException () ) ;
	}

	// Open a storage to given URL.
	SotStorage aStorage ( impl_OUString2String ( rURL ), STREAM_STD_READ ) ;

	// Open a stream in storage.
	SotStorageStream* pStream = aStorage.OpenSotStream ( SLOTNAME, STREAM_STD_READ ) ;

	// We cant open a stream !?
	// We can't work ...
	if ( pStream == (SotStorageStream*)0 )
	{
		// .. throw an exception.
		throw ( IOException () ) ;
	}

	// Set default values for properties!
	impl_resetObject () ;

	// Get FormatID of storage ...
	// This value is used in "impl_readStream()" to set right MIMEType, if not exist in document!
	m_nFormatID = aStorage.GetFormat () ;

	// Load properties from stream
	impl_readStream ( *pStream ) ;	// This can throw an IO- or RuntimeException to!
}

//******************************************************************************************************************************
//	XPersist
//******************************************************************************************************************************
void SAL_CALL DocumentProperties::write ( const OUString& rURL ) throw ( IOException, RuntimeException )
{
	// Safe impossible cases
	// Check more things on parameter as in release version !
	DBG_ASSERT ( impl_debug_checkParameter ( rURL ), "DocumentProperties::write()\nInvalid parameter detected.\n" ) ;

	// We can't work without a valid URL!
	// It must be a valid string.
	if	(
			( rURL.getLength			(								)	<	1			)	||
			( SotStorage::IsStorageFile	( impl_OUString2String ( rURL ) )	==	sal_False	)
		)
	{
		throw ( IOException () ) ;
	}

	// Open a storage to given URL.
	// Attention: Dont use "STREAM_STD_WRITE" only ! It will not work. Use "STREAM_STD_READWRITE".
	SotStorage aStorage ( impl_OUString2String ( rURL ), STREAM_STD_READWRITE ) ;

	// Open a stream in storage.
	SotStorageStream* pStream = aStorage.OpenSotStream ( SLOTNAME, STREAM_STD_READWRITE ) ;

	// We cant open a stream !?
	// We can't work ...
	if ( pStream == (SotStorageStream*)0 )
	{
		// .. throw an exception.
		throw ( IOException () ) ;
	}

	// Get FormatID of storage ...
	// This value is used in "impl_writeStream()" to write right MIMEType!
	m_nFormatID = aStorage.GetFormat () ;

	// Write properties to stream
	impl_writeStream ( *pStream ) ;	// This can throw an IO- or RuntimeException to!

	// Flush written properties!!!
	// If it failed ...
	if ( aStorage.Commit () == sal_False )
	{
		// .. throw an exception.
		throw ( IOException () ) ;
	}
}

//******************************************************************************************************************************
//	public impl methods !
//	(Use to register service)
//******************************************************************************************************************************
Sequence< OUString > DocumentProperties::impl_getStaticSupportedServiceNames ()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pServiceNames is NULL - for the second call pServiceNames is different from NULL!
	Sequence< OUString >* pServiceNames = (Sequence< OUString >*)0 ;

	if ( pServiceNames == (Sequence< OUString >*)0 )
	{
		// Ready for multithreading
		MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

		// Control this pointer! Another instance can be faster then these!
		if ( pServiceNames == (Sequence< OUString >*)0 )
		{
			// Build new sequence for one item.
			static Sequence< OUString >	seqServiceNames	( 1 )							;
			OUString*					pArray			=	seqServiceNames.getArray ()	;

			// Set right servicename in sequence.
			pArray [0] = OUString::createFromAscii( SERVICENAME );

			// Set address at static pointer !
			pServiceNames = &seqServiceNames ;
		}
	}

	// Return results.
	return ( *pServiceNames ) ;
}

//******************************************************************************************************************************
//	public impl methods !
//	(Use to register service)
//******************************************************************************************************************************
OUString DocumentProperties::impl_getStaticImplementationName ()
{
	return SERVICENAME ;
}

//______________________________________________________________________________________________________________
//	public methods end
//______________________________________________________________________________________________________________

//______________________________________________________________________________________________________________
//	protected methods start
//______________________________________________________________________________________________________________

//******************************************************************************************************************************
//	OPropertySetHelper
//******************************************************************************************************************************
sal_Bool DocumentProperties::convertFastPropertyValue (	Any& rConvertedValue, Any& rOldValue, sal_Int32 nHandle, const Any& rValue ) throw ( IllegalArgumentException )
{
	//	Safe impossible cases
	DBG_ASSERT ( impl_debug_checkParameter ( rConvertedValue, rOldValue, nHandle, rValue ), "DocumentProperties::convertFastPropertyValue()\nInvalid parameter detected.\n" )

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	//	Check, if value of property will changed in method "setFastPropertyValue_NoBroadcast()".
	//	Return TRUE, if changed - else return FALSE.

	//	Attention:
	//		Method "impl_tryToChangeProperty()" can throw the IllegalArgumentException !!!

	//	Initialize state with FALSE !!!
	//	(Handle can be invalid)
	sal_Bool bReturn = sal_False ;

	switch ( nHandle )
	{
		case	HANDLE_AUTHOR					:	bReturn = impl_tryToChangeProperty ( m_sAuthor					, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_AUTOLOADENABLED			:	bReturn = impl_tryToChangeProperty ( m_bAutoloadEnabled			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_AUTOLOADSECS				:	bReturn = impl_tryToChangeProperty ( m_nAutoloadSecs			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_AUTOLOADURL				:	bReturn = impl_tryToChangeProperty ( m_sAutoloadURL				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_BLINDCOPIESTO			:	bReturn = impl_tryToChangeProperty ( m_sBlindCopiesTo			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_COPIESTO					:	bReturn = impl_tryToChangeProperty ( m_sCopiesTo				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_CREATIONDATE				:	bReturn = impl_tryToChangeProperty ( m_aCreationDate			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_DEFAULTTARGET			:	bReturn = impl_tryToChangeProperty ( m_sDefaultTarget			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_DESCRIPTION				:	bReturn = impl_tryToChangeProperty ( m_sDescription				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_EDITINGCYCLES			:	bReturn = impl_tryToChangeProperty ( m_nEditingCycles			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_EDITINGDURATION			:	bReturn = impl_tryToChangeProperty ( m_nEditingDuration			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_EXTRADATA				:	bReturn = impl_tryToChangeProperty ( m_seqExtraData				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_INREPLYTO				:	bReturn = impl_tryToChangeProperty ( m_sInReplyTo				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_ISENCRYPTED				:	bReturn = impl_tryToChangeProperty ( m_bIsEncrypted				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_KEYWORDS					:	bReturn = impl_tryToChangeProperty ( m_sKeywords				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_MIMETYPE					:	bReturn = impl_tryToChangeProperty ( m_sMIMEType				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_MODIFIEDBY				:	bReturn = impl_tryToChangeProperty ( m_sModifiedBy				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_MODIFYDATE				:	bReturn = impl_tryToChangeProperty ( m_aModifyDate				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_NEWSGROUPS				:	bReturn = impl_tryToChangeProperty ( m_sNewsgroups				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_ORIGINAL					:	bReturn = impl_tryToChangeProperty ( m_sOriginal				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_PORTABLEGRAPHICS			:	bReturn = impl_tryToChangeProperty ( m_bPortableGraphics		, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_PRINTDATE				:	bReturn = impl_tryToChangeProperty ( m_aPrintDate				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_PRINTEDBY				:	bReturn = impl_tryToChangeProperty ( m_sPrintedBy				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_PRIORITY					:	bReturn = impl_tryToChangeProperty ( m_nPriority				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_QUERYTEMPLATE			:	bReturn = impl_tryToChangeProperty ( m_bQueryTemplate			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_RECIPIENT				:	bReturn = impl_tryToChangeProperty ( m_sRecipient				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_REFERENCES				:	bReturn = impl_tryToChangeProperty ( m_sReferences				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_REPLYTO					:	bReturn = impl_tryToChangeProperty ( m_sReplyTo					, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_SAVEGRAPHICSCOMPRESSED	:	bReturn = impl_tryToChangeProperty ( m_bSaveGraphicsCompressed	, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_SAVEORIGINALGRAPHICS		:	bReturn = impl_tryToChangeProperty ( m_bSaveOriginalGraphics	, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_SAVEVERSIONONCLOSE		:	bReturn = impl_tryToChangeProperty ( m_bSaveVersionOnClose		, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_TEMPLATE					:	bReturn = impl_tryToChangeProperty ( m_sTemplate				, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_TEMPLATECONFIG			:	bReturn = impl_tryToChangeProperty ( m_bTemplateConfig			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_TEMPLATEFILENAME			:	bReturn = impl_tryToChangeProperty ( m_sTemplateFileName		, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_TEMPLATEDATE				:	bReturn = impl_tryToChangeProperty ( m_aTemplateDate			, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_THEME					:	bReturn = impl_tryToChangeProperty ( m_sTheme					, rValue, rOldValue, rConvertedValue ) ;
				 									break ;
		case	HANDLE_TITLE					:	bReturn = impl_tryToChangeProperty ( m_sTitle					, rValue, rOldValue, rConvertedValue ) ;
													break ;
		case	HANDLE_USERDATA					:	bReturn = impl_tryToChangeProperty ( m_bUserData				, rValue, rOldValue, rConvertedValue ) ;
													break ;
	}

	// Return state of operation.
	return bReturn ;
}

//******************************************************************************************************************************
//	OPropertySetHelper
//******************************************************************************************************************************
void DocumentProperties::setFastPropertyValue_NoBroadcast (	sal_Int32 nHandle, const Any& rValue ) throw ( Exception )
{
	//	Safe impossible cases
	//	OprpertySetHelper say	: "Handle and type of any value are valid at everyway!".
	//	But I say				: "It's better to control this."
	DBG_ASSERT ( impl_debug_checkParameter ( nHandle, rValue ), "DocumentProperties::setFastPropertyValue_NoBroadcast()\nInvalid parameter detected.\n" )

	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Search for right handle ... and try to set property value.
	switch ( nHandle )
	{
		case	HANDLE_AUTHOR					:	rValue >>= m_sAuthor					;
				 									break ;
		case	HANDLE_AUTOLOADENABLED			:	rValue >>= m_bAutoloadEnabled   		;
				 									break;
		case	HANDLE_AUTOLOADSECS				:	rValue >>= m_nAutoloadSecs      		;
				 									break ;
		case	HANDLE_AUTOLOADURL				:	rValue >>= m_sAutoloadURL       		;
				 									break ;
		case	HANDLE_BLINDCOPIESTO			:	rValue >>= m_sBlindCopiesTo     		;
				 									break ;
		case	HANDLE_COPIESTO					:	rValue >>= m_sCopiesTo            		;
				 									break ;
		case	HANDLE_CREATIONDATE				:	rValue >>= m_aCreationDate      		;
				 									break ;
		case	HANDLE_DEFAULTTARGET			:	rValue >>= m_sDefaultTarget     		;
				 									break ;
		case	HANDLE_DESCRIPTION				:	rValue >>= m_sDescription       		;
				 									break ;
		case	HANDLE_EDITINGCYCLES			:	rValue >>= m_nEditingCycles     		;
				 									break ;
		case	HANDLE_EDITINGDURATION			:	rValue >>= m_nEditingDuration   		;
				 									break ;
		case	HANDLE_EXTRADATA				:	rValue >>= m_seqExtraData				;
				 									break ;
		case	HANDLE_INREPLYTO				:	// This property is readonly !!!
				 									DBG_ASSERT ( FALSE, "DocumentProperties::setFastPropertyValue_NoBoradcast()\nYou will set a readonly property!\n" )
				 									//rValue >>= m_sInReplyTo				;
				 									break ;
		case	HANDLE_ISENCRYPTED				:	rValue >>= m_bIsEncrypted       		;
				 									break ;
		case	HANDLE_KEYWORDS					:	rValue >>= m_sKeywords          		;
				 									break ;
		case	HANDLE_MIMETYPE					:	// This property is readonly !!!
				 									DBG_ASSERT ( FALSE, "DocumentProperties::setFastPropertyValue_NoBoradcast()\nYou will set a readonly property!\n" )
				 									//rValue >>= m_sMIMEType				;
				 									break ;
		case	HANDLE_MODIFIEDBY				:	rValue >>= m_sModifiedBy        		;
				 									break ;
		case	HANDLE_MODIFYDATE				:	rValue >>= m_aModifyDate        		;
				 									break ;
		case	HANDLE_NEWSGROUPS				:	rValue >>= m_sNewsgroups        		;
				 									break ;
		case	HANDLE_ORIGINAL					:	rValue >>= m_sOriginal          		;
				 									break ;
		case	HANDLE_PORTABLEGRAPHICS			:	rValue >>= m_bPortableGraphics			;
				 									break ;
		case	HANDLE_PRINTDATE				:	rValue >>= m_aPrintDate         		;
				 									break ;
		case	HANDLE_PRINTEDBY				:	rValue >>= m_sPrintedBy         		;
				 									break ;
		case	HANDLE_PRIORITY					:	rValue >>= m_nPriority          		;
				 									break ;
		case	HANDLE_QUERYTEMPLATE			:	rValue >>= m_bQueryTemplate				;
				 									break ;
		case	HANDLE_RECIPIENT				:	rValue >>= m_sRecipient         		;
				 									break ;
		case	HANDLE_REFERENCES				:	rValue >>= m_sReferences        		;
				 									break ;
		case	HANDLE_REPLYTO					:	rValue >>= m_sReplyTo           		;
				 									break ;
		case	HANDLE_SAVEGRAPHICSCOMPRESSED	:	rValue >>= m_bSaveGraphicsCompressed	;
				 									break ;
		case	HANDLE_SAVEORIGINALGRAPHICS		:	rValue >>= m_bSaveOriginalGraphics		;
				 									break ;
		case	HANDLE_SAVEVERSIONONCLOSE		:	rValue >>= m_bSaveVersionOnClose		;
				 									break ;
		case	HANDLE_TEMPLATE					:	rValue >>= m_sTemplate          		;
				 									break ;
		case	HANDLE_TEMPLATECONFIG			:	rValue >>= m_bTemplateConfig       		;
				 									break ;
		case	HANDLE_TEMPLATEFILENAME			:	rValue >>= m_sTemplateFileName			;
				 									break ;
		case	HANDLE_TEMPLATEDATE				:	rValue >>= m_aTemplateDate      		;
				 									break ;
		case	HANDLE_THEME					:	rValue >>= m_sTheme             		;
				 									break ;
		case	HANDLE_TITLE					:	rValue >>= m_sTitle             		;
				 									break ;
		case	HANDLE_USERDATA					:	rValue >>= m_bUserData           		;
				 									break ;
	}
}

//******************************************************************************************************************************
//	OPropertySetHelper
//******************************************************************************************************************************
void DocumentProperties::getFastPropertyValue (	Any& rValue, sal_Int32 nHandle ) const
{
	//	Safe impossible cases
	//	OprpertySetHelper say	: "Handle is valid at everyway!".
	//	But I say				: "It's better to control this."
	DBG_ASSERT ( impl_debug_checkParameter ( rValue, nHandle ), "DocumentProperties::getFastPropertyValue()\nInvalid parameter detected.\n" )

	// Ready for multithreading
	MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

	// Search for right handle ... and try to get property value.
	switch ( nHandle )
	{
		case	HANDLE_AUTHOR					:		rValue <<= m_sAuthor            		;
				 										break ;
		case	HANDLE_AUTOLOADENABLED			:		rValue <<= m_bAutoloadEnabled   		;
				 										break;
		case	HANDLE_AUTOLOADSECS				:		rValue <<= m_nAutoloadSecs      		;
				 										break ;
		case	HANDLE_AUTOLOADURL				:		rValue <<= m_sAutoloadURL       		;
				 										break ;
		case	HANDLE_BLINDCOPIESTO			:		rValue <<= m_sBlindCopiesTo     		;
				 										break ;
		case	HANDLE_COPIESTO					:		rValue <<= m_sCopiesTo            		;
				 										break ;
		case	HANDLE_CREATIONDATE				:		rValue <<= m_aCreationDate      		;
				 										break ;
		case	HANDLE_DEFAULTTARGET			:		rValue <<= m_sDefaultTarget     		;
				 										break ;
		case	HANDLE_DESCRIPTION				:		rValue <<= m_sDescription       		;
				 										break ;
		case	HANDLE_EDITINGCYCLES			:		rValue <<= m_nEditingCycles     		;
				 										break ;
		case	HANDLE_EDITINGDURATION			:		rValue <<= m_nEditingDuration   		;
				 										break ;
		case	HANDLE_EXTRADATA				:		rValue <<= m_seqExtraData				;
				 										break ;
		case	HANDLE_INREPLYTO				:		rValue <<= m_sInReplyTo         		;
				 										break ;
		case	HANDLE_ISENCRYPTED				:		rValue <<= m_bIsEncrypted       		;
				 										break ;
		case	HANDLE_KEYWORDS					:		rValue <<= m_sKeywords          		;
				 										break ;
		case	HANDLE_MIMETYPE					:		rValue <<= m_sMIMEType          		;
				 										break ;
		case	HANDLE_MODIFIEDBY				:		rValue <<= m_sModifiedBy        		;
				 										break ;
		case	HANDLE_MODIFYDATE				:		rValue <<= m_aModifyDate        		;
				 										break ;
		case	HANDLE_NEWSGROUPS				:		rValue <<= m_sNewsgroups        		;
				 										break ;
		case	HANDLE_ORIGINAL					:		rValue <<= m_sOriginal          		;
				 										break ;
		case	HANDLE_PORTABLEGRAPHICS			:		rValue <<= m_bPortableGraphics			;
				 										break ;
		case	HANDLE_PRINTDATE				:		rValue <<= m_aPrintDate         		;
				 										break ;
		case	HANDLE_PRINTEDBY				:		rValue <<= m_sPrintedBy         		;
				 										break ;
		case	HANDLE_PRIORITY					:		rValue <<= m_nPriority          		;
				 										break ;
		case	HANDLE_QUERYTEMPLATE			:		rValue <<= m_bQueryTemplate				;
				 										break ;
		case	HANDLE_RECIPIENT				:		rValue <<= m_sRecipient         		;
				 										break ;
		case	HANDLE_REFERENCES				:		rValue <<= m_sReferences        		;
				 										break ;
		case	HANDLE_REPLYTO					:		rValue <<= m_sReplyTo           		;
				 										break ;
		case	HANDLE_SAVEGRAPHICSCOMPRESSED	:		rValue <<= m_bSaveGraphicsCompressed	;
				 										break ;
		case	HANDLE_SAVEORIGINALGRAPHICS		:		rValue <<= m_bSaveOriginalGraphics		;
				 										break ;
		case	HANDLE_SAVEVERSIONONCLOSE		:		rValue <<= m_bSaveVersionOnClose		;
				 										break ;
		case	HANDLE_TEMPLATE					:		rValue <<= m_sTemplate          		;
				 										break ;
		case	HANDLE_TEMPLATECONFIG			:		rValue <<= m_bTemplateConfig       		;
				 										break ;
		case	HANDLE_TEMPLATEFILENAME			:		rValue <<= m_sTemplateFileName			;
				 										break ;
		case	HANDLE_TEMPLATEDATE				:		rValue <<= m_aTemplateDate      		;
				 										break ;
		case	HANDLE_THEME					:		rValue <<= m_sTheme             		;
				 										break ;
		case	HANDLE_TITLE					:		rValue <<= m_sTitle             		;
				 										break ;
		case	HANDLE_USERDATA					:		rValue <<= m_bUserData           		;
				 										break ;
	}
}

//******************************************************************************************************************************
//	OPropertySetHelper
//******************************************************************************************************************************
IPropertyArrayHelper& DocumentProperties::getInfoHelper()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfoHelper is NULL - for the second call pInfoHelper is different from NULL!
	static OPropertyArrayHelper* pInfoHelper = (OPropertyArrayHelper*)0 ;

	if ( pInfoHelper == (OPropertyArrayHelper*)0 )
	{
		// Ready for multithreading
		MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

		// Control this pointer again, another instance can be faster then these!
		if ( pInfoHelper == (OPropertyArrayHelper*)0 )
		{
			// Define static member to give structure of properties to baseclass "OPropertySetHelper".
			// "impl_getStaticPropertyDescriptor" is a non exported and static funtion, who will define a static propertytable.
			static OPropertyArrayHelper aInfoHelper ( impl_getStaticPropertyDescriptor(), sal_True ) ;
			pInfoHelper = &aInfoHelper ;
		}
	}

	return ( *pInfoHelper ) ;
}

//******************************************************************************************************************************
//	OPropertySetHelper
//******************************************************************************************************************************
Reference< XPropertySetInfo > SAL_CALL DocumentProperties::getPropertySetInfo ()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfo is NULL - for the second call pInfo is different from NULL!
	static Reference< XPropertySetInfo >* pInfo = (Reference< XPropertySetInfo >*)0 ;

	if ( pInfo == (Reference< XPropertySetInfo >*)0 )
	{
		// Ready for multithreading
		MutexGuard aGuard ( Mutex::getGlobalMutex () ) ;

		// Control this pointer again, another instance can be faster then these!
		if ( pInfo == (Reference< XPropertySetInfo >*)0 )
		{
			// Create structure of propertysetinfo for baseclass "OPropertySetHelper".
			// (Use method "getInfoHelper()".)
			static Reference< XPropertySetInfo > xInfo ( createPropertySetInfo ( getInfoHelper () ) ) ;
			pInfo = &xInfo ;
		}
	}

	return ( *pInfo ) ;
}

//______________________________________________________________________________________________________________
//	protected methods end
//______________________________________________________________________________________________________________

//______________________________________________________________________________________________________________
//	private methods start
//______________________________________________________________________________________________________________

//******************************************************************************************************************************
/*--------------------------------------------------------------------------------------------------------------
	The follow methods get information about new value of a property. If value has change, we return TRUE, else FALSE.
	This is necessary to "ask" VetoableListener. If there no veto, property can change. In another way value will NOT change!
--------------------------------------------------------------------------------------------------------------*/

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const OUString& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	OUString sNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( sNewValue, rValue ) ;

	// If value change ...
	if ( sNewValue != rProperty )
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= sNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const DATETIME& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	DATETIME aNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( aNewValue, rValue ) ;

	// If "value" change ...
	// (There is no operator!= for DateTime. This is a struct !!!!....)
	if	(
			( aNewValue.HundredthSeconds	!=	rProperty.HundredthSeconds	)	||
    		( aNewValue.Seconds				!=	rProperty.Seconds			)	||
    		( aNewValue.Minutes				!=	rProperty.Minutes			)	||
    		( aNewValue.Hours				!=	rProperty.Hours				)	||
    		( aNewValue.Day					!=	rProperty.Day				)	||
    		( aNewValue.Month				!=	rProperty.Month				)	||
    		( aNewValue.Year				!=	rProperty.Year				)
		)
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= aNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const sal_Bool& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	sal_Bool bNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( bNewValue, rValue ) ;

	// If value change ...
	if ( bNewValue != rProperty )
	{
		// ... set information of change.
		// Attention:	Use setValue and getCppuBooleanType to set value in any!
		//				It's necessary, if BOOL can be int or char.
		rOldValue.setValue			( &rProperty, ::getCppuBooleanType () ) ;
		rConvertedValue.setValue	( &bNewValue, ::getCppuBooleanType () ) ;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const sal_Int16& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	sal_Int16 nNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( nNewValue, rValue ) ;

	// If value change ...
	if( nNewValue != rProperty )
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= nNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const sal_uInt16& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	sal_uInt16 nNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( nNewValue, rValue ) ;

	// If value change ...
	if( nNewValue != rProperty )
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= nNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const sal_Int32& rProperty, const Any& rValue, Any& rOldValue, Any& rConvertedValue ) throw ( IllegalArgumentException )
{
	sal_Int32 nNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( nNewValue, rValue ) ;

	// If value change ...
	if( nNewValue != rProperty )
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= nNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_tryToChangeProperty ( const Sequence< sal_Int8 >&	rProperty, const ANY& rValue, ANY& rOldValue, ANY& rConvertedValue ) throw ( IllegalArgumentException )
{
	Sequence< sal_Int8 > nNewValue ;

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	convertPropertyValue ( nNewValue, rValue ) ;

	// If value change ...
	if( nNewValue != rProperty )
	{
		// ... set information of change.
		rOldValue		<<= rProperty	;
		rConvertedValue	<<= nNewValue	;

		// Return OK - "value will be change ..."
		return sal_True  ;
	}
	else
	{
		// ... clear information of return parameter!
		rOldValue.clear			() ;
		rConvertedValue.clear	() ;

		// Return NOTHING - "value will not be change ..."
		return sal_False ;
	}
}

//******************************************************************************************************************************
void DocumentProperties::impl_readStream ( SvStream& rStream ) throw ( IOException, RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Get current version of stream and safe it !
	sal_Int32 nFileVersion = rStream.GetVersion () ;

	// If version invalid, set correct value. Use FormatID to do this!
	if ( impl_isFileVersionValid ( nFileVersion ) == sal_False )
	{
		nFileVersion = impl_FormatID2FileVersion ( m_nFormatID ) ;
	}

	// The follow 3 items are written in file format 4.0 !!!
	// Set right version on stream ...
	rStream.SetVersion ( SOFFICE_FILEFORMAT_40 ) ;

	// ... and read items.
	m_sHeaderType = impl_readOUString ( rStream ) ;
	// Is header OK ?
	if ( m_sHeaderType != HEADERNAME )
	{
		// No; Set error on stream ...
		rStream.SetError ( SVSTREAM_FILEFORMAT_ERROR ) ;
		// ... and break operation!
		throw ( IOException () ) ;
	}

	// Else; read follow elements.
	m_nHeaderVersion	= impl_readuInt16	( rStream ) ;
	m_bIsEncrypted		= impl_readBool		( rStream ) ;

	// Reset version of stream. (Reset to safed value!)
	rStream.SetVersion ( nFileVersion ) ;

	// Get information about right charset and set it on stream.
	m_eFileCharSet = (CharSet)impl_readuInt16 ( rStream ) ;
	rStream.SetStreamCharSet ( m_eFileCharSet ) ;

	// Read some properties.
	m_bPortableGraphics = impl_readBool ( rStream ) ;
	m_bQueryTemplate	= impl_readBool ( rStream ) ;

	// Read some timestamps ...
	TimeStamp aCreatedStamp		;
	TimeStamp aModifiedStamp	;
	TimeStamp aPrintedStamp 	;

	aCreatedStamp.Load	( rStream ) ;
	aModifiedStamp.Load	( rStream ) ;
	aPrintedStamp.Load	( rStream ) ;

	// ... and get date-, time- and name information.
	m_sAuthor		= impl_String2OUString ( aCreatedStamp.GetName  () ) ;
	m_sModifiedBy	= impl_String2OUString ( aModifiedStamp.GetName	() ) ;
	m_sPrintedBy 	= impl_String2OUString ( aPrintedStamp.GetName  () ) ;
	m_aCreationDate	= impl_TimeStamp2DateTime ( aCreatedStamp	) ;
	m_aModifyDate	= impl_TimeStamp2DateTime ( aModifiedStamp	) ;
	m_aPrintDate	= impl_TimeStamp2DateTime ( aPrintedStamp	) ;

	// Attention:	Follow properties have the same size everytime!
	//				Skip unreaded bytes.
	// Read title, theme, description and keywords ...
	m_sTitle		= impl_readOUString ( rStream, FIXSIZE_TITLE		) ;
	m_sTheme		= impl_readOUString ( rStream, FIXSIZE_THEME		) ;
	m_sDescription	= impl_readOUString ( rStream, FIXSIZE_DESCRIPTION	) ;
	m_sKeywords		= impl_readOUString ( rStream, FIXSIZE_KEYWORDS		) ;

	// Read user specified properties.
	// At this point we can get 4 elements only! The size in file is fixed.
	// Add strings to namecontainer.
	// (See also declaration of "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" to get more information!)

	OUString	sName		;
	OUString	sValue		;
	sal_uInt16	nCounter	;

 	for ( nCounter = 0 ; nCounter < MAXCOUNT_DOCUSERKEYS; ++nCounter )
	{
		// Get name and value of property.
		// These value have an fix size! Skip to much letters!
		sName	= impl_readOUString ( rStream, FIXSIZE_DOCUSERKEY ) ;
		sValue	= impl_readOUString ( rStream, FIXSIZE_DOCUSERKEY ) ;

		// File is corrupt! DocUserKeys must have a valid name!!!
		// Throw an exception.
		if ( sName.getLength () < 1 )
		{
			throw ( IOException () ) ;
		}

		// Insert property in namecontainer.
		Any aValue = makeAny ( sValue ) ;
		insertByName ( sName, aValue ) ;
	}

	// Read name, filename, date and time of template.
	m_sTemplate			= impl_readOUString ( rStream ) ;
	m_sTemplateFileName	= impl_readOUString ( rStream ) ;

	Date aDate ( impl_readInt32	( rStream ) ) ;
	Time aTime ( impl_readInt32	( rStream ) ) ;

    m_aTemplateDate.Day					= aDate.GetDay		() ;
    m_aTemplateDate.Month				= aDate.GetMonth	() ;
    m_aTemplateDate.Year				= aDate.GetYear		() ;
	m_aTemplateDate.HundredthSeconds	= aTime.Get100Sec	() ;
    m_aTemplateDate.Seconds				= aTime.GetSec		() ;
    m_aTemplateDate.Minutes				= aTime.GetMin		() ;
    m_aTemplateDate.Hours				= aTime.GetHour		() ;

	// OBSOLETE!!!
	// Read AND forget it :-)
	// (There are only some mailaddresses.)
	if ( rStream.GetVersion () <= SOFFICE_FILEFORMAT_40 )
	{
		sal_uInt16	nMaxCount		;
		OUString	sDummyString	;
		sal_uInt16	nDummyFlags		;

		nMaxCount = impl_readuInt16 ( rStream ) ;
		for( nCounter = 0; nCounter < nMaxCount; ++nCounter )
		{
			sDummyString	= impl_readOUString	( rStream ) ;
 			nDummyFlags		= impl_readuInt16	( rStream ) ;
		}
	}

	// Read edit time, documentnumber (if it exist !), extra data and TemplateConfig.
	m_nEditingDuration = impl_readInt32 ( rStream ) ;
	if ( m_nHeaderVersion > 4 )
	{
		m_nEditingCycles = impl_readInt16 ( rStream ) ;
	}
	m_seqExtraData		= impl_readCharSequence	( rStream ) ;
	m_bTemplateConfig	= impl_readBool			( rStream ) ;

	// Read some other properties - depends from headerversion!
	if ( m_nHeaderVersion > 5 )
	{
		m_bAutoloadEnabled	= impl_readBool		( rStream ) ;
		m_sAutoloadURL		= impl_readOUString	( rStream ) ;
		m_nAutoloadSecs		= impl_readInt32	( rStream )	;
		m_sDefaultTarget	= impl_readOUString	( rStream ) ;
	}

	if ( m_nHeaderVersion > 6 )
	{
		m_bSaveGraphicsCompressed = impl_readBool ( rStream ) ;
	}

	if ( m_nHeaderVersion > 7 )
	{
		m_bSaveOriginalGraphics = impl_readBool ( rStream ) ;
	}

	if ( m_nHeaderVersion > 8 )
	{
		m_bSaveVersionOnClose	= impl_readBool		( rStream ) ;
		m_sCopiesTo				= impl_readOUString	( rStream ) ;
		m_sOriginal				= impl_readOUString	( rStream ) ;
		m_sReferences			= impl_readOUString	( rStream ) ;
		m_sRecipient			= impl_readOUString	( rStream ) ;
		m_sReplyTo				= impl_readOUString	( rStream ) ;
		m_sBlindCopiesTo		= impl_readOUString	( rStream ) ;
		m_sInReplyTo			= impl_readOUString	( rStream ) ;
		m_sNewsgroups			= impl_readOUString	( rStream ) ;
		m_nPriority				= impl_readuInt16	( rStream ) ;
	}

	if ( m_nHeaderVersion > 9 )
	{
		m_sMIMEType	= impl_readOUString	( rStream ) ;
		// If value not exist (???) ...
		if ( m_sMIMEType.getLength () < 1 )
		{
			// ... use format-ID to set right MIMEType!
			// (m_nFormatID is set in method "read(URL)".)
			m_sMIMEType = impl_FormatID2MIMEType ( m_nFormatID ) ;
		}
	}

	if ( m_nHeaderVersion > 10 )
	{
		m_bUserData = impl_readBool ( rStream ) ;
	}

	if ( m_nHeaderVersion > 11 )
	{
		// Read rest of user specified properties.
		// Add strings to namecontainer.
		// (See also declaration of "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" to get more information!)
		// nCounter, sName and sValue are defined below!

		// First read count of properties in file ...
		sal_uInt32 nPropertiesCount = impl_readuInt32 ( rStream ) ;

		// Then read properties ...
 		for ( nCounter = 0 ; nCounter < nPropertiesCount; ++nCounter )
		{
			// Get name and value of property.
			// If "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" is defined, these properties have a fixed size,
			// but at this point we don't metter this!
			sName	= impl_readOUString ( rStream ) ;
			sValue	= impl_readOUString ( rStream ) ;

			// File is corrupt! We must have a valid name!!!
			// Throw an exception.
			if ( sName.getLength () < 1 )
			{
				throw ( IOException () ) ;
			}

			// Insert property in namecontainer.
			Any aValue = makeAny ( sValue ) ;
			insertByName ( sName, aValue ) ;
		}
	}

	// Control state of this operation !
	// We control this NOT everytime and after every reading of values from stream ...
	// but at the end of all instructions. -> PERFORMANCE !!!
	if ( rStream.GetError () != SVSTREAM_OK )
	{
		throw ( IOException () ) ;
	}
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeStream ( SvStream& rStream ) throw ( IOException, RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Get current version of stream and safe it !
	sal_Int32 nFileVersion = rStream.GetVersion () ;

	// If version invalid, set correct value. Use FormatID to do this!
	if ( impl_isFileVersionValid ( nFileVersion ) == sal_False )
	{
		nFileVersion = impl_FormatID2FileVersion ( m_nFormatID ) ;
	}

	// The follow 3 items are written in file format 4.0 !!!
	// Set right version on stream ...
	rStream.SetVersion ( SOFFICE_FILEFORMAT_40 ) ;

	// ... and write header items.
	impl_writeOUString	( rStream, m_sHeaderType	) ;
	impl_writeuInt16	( rStream, m_nHeaderVersion	) ;
	impl_writeBool		( rStream, m_bIsEncrypted	) ;

	// Reset version of stream. (Reset to safed value!)
	rStream.SetVersion ( nFileVersion ) ;

	// Set information about right charset in file and stream.
	// If we write, but don't have read before ... "m_eFileCharSet" has default value!
	// In this way, we get default charset from stream!
	if ( m_eFileCharSet == DEFAULT_FILECHARSET )
	{
		// We don't have read before. Get default charset from stream.
		m_eFileCharSet = rStream.GetStreamCharSet () ;
	}
	else
	{
		// We have read before. Use readed charset! (set it on stream)
		rStream.SetStreamCharSet ( m_eFileCharSet ) ;
	}
	// Write charset in document.
	impl_writeuInt16 ( rStream, (sal_uInt16)m_eFileCharSet ) ;

	// Write some properties.
	impl_writeBool ( rStream, m_bPortableGraphics	) ;
	impl_writeBool ( rStream, m_bQueryTemplate		) ;

	// Write some timestamps ...
	TimeStamp aCreatedStamp		= impl_DateTime2TimeStamp ( m_aCreationDate	) ;
	TimeStamp aModifiedStamp	= impl_DateTime2TimeStamp ( m_aModifyDate	) ;
	TimeStamp aPrintedStamp		= impl_DateTime2TimeStamp ( m_aPrintDate	) ;

	aCreatedStamp.SetName	( impl_OUString2String ( m_sAuthor		) ) ;
	aModifiedStamp.SetName	( impl_OUString2String ( m_sModifiedBy	) ) ;
	aPrintedStamp.SetName	( impl_OUString2String ( m_sPrintedBy	) ) ;

	aCreatedStamp.Save	( rStream ) ;
	aModifiedStamp.Save	( rStream ) ;
	aPrintedStamp.Save	( rStream ) ;

	// Attention:	Follow properties have the same size everytime!
	//				Skip not written bytes.
	// Write title, theme, description and keywords.
	impl_writeOUString ( rStream, m_sTitle		, FIXSIZE_TITLE			) ;
	impl_writeOUString ( rStream, m_sTheme		, FIXSIZE_THEME			) ;
	impl_writeOUString ( rStream, m_sDescription, FIXSIZE_DESCRIPTION	) ;
	impl_writeOUString ( rStream, m_sKeywords	, FIXSIZE_KEYWORDS		) ;

	// Write user specified properties.
	// At this point we can set 4 elements only! The size in file is fixed.
	// Get strings from namecontainer ... but don't forget the others ... they will saved sometimes later!!!
	// If there not enough items, take default values.
	// (see also declaration of "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" to get more information!)

	OUString				sName															;
	OUString				sValue															;
	Any						aValue															;
	sal_uInt16				nCounter														;
	Sequence< OUString >	seqContainerProperties	= getElementNames					()	;
	sal_uInt32				nSequenceSize			= seqContainerProperties.getLength	()	;

 	for ( nCounter = 0 ; nCounter < MAXCOUNT_DOCUSERKEYS; ++nCounter )
	{
		// Get property from namecontainer. (if someone exist...)
		if ( nCounter < nSequenceSize )
		{
			sName	=	seqContainerProperties [ nCounter ]	;
			aValue	=	getByName ( sName )					;
			aValue	>>=	sValue								;
		}
		// Else; take default values!!!
		else
		{
			// Create string like "Info 0" or "Info 1" ...
			String sTemp = "Info " ;
			sTemp += nCounter ;

			sName	= impl_String2OUString ( sTemp )	;
			sValue	= OUString()						;
		}

		// Write name and value of property.
		// These values have a fix size! Appends some blanks, if string to short.
		impl_writeOUString ( rStream, sName , FIXSIZE_DOCUSERKEY ) ;
		impl_writeOUString ( rStream, sValue, FIXSIZE_DOCUSERKEY ) ;
	}

	// Write name, filename, date and time of template.
	impl_writeOUString ( rStream, m_sTemplate			) ;
	impl_writeOUString ( rStream, m_sTemplateFileName	) ;

	Date		aDate			( m_aTemplateDate.Day	, m_aTemplateDate.Month		, m_aTemplateDate.Year										) ;
	Time		aTime			( m_aTemplateDate.Hours	, m_aTemplateDate.Minutes	, m_aTemplateDate.Seconds, m_aTemplateDate.HundredthSeconds	) ;
	::DateTime	aDateTimeObject	( aDate, aTime ) ;

	impl_writeInt32 ( rStream, aDateTimeObject.GetDate () ) ;
	impl_writeInt32 ( rStream, aDateTimeObject.GetTime () ) ;

	// OBSOLETE!!!
	// Write a size of 0 AND forget it :-)
	// (There are only some mailaddresses.)
	if ( rStream.GetVersion () <= SOFFICE_FILEFORMAT_40 )
	{
		impl_writeuInt16 ( rStream, 0 ) ;
	}

	// Write edit time, documentnumber (if it exist !), extra data and TemplateConfig.
	impl_writeInt32 ( rStream, m_nEditingDuration ) ;
	if ( m_nHeaderVersion > 4 )
	{
		impl_writeInt16 ( rStream, m_nEditingCycles ) ;
	}
	impl_writeCharSequence	( rStream, m_seqExtraData		) ;
	impl_writeBool			( rStream, m_bTemplateConfig	) ;

	// Write some other properties - depends from headerversion!
	if ( m_nHeaderVersion > 5 )
	{
		impl_writeBool		( rStream, m_bAutoloadEnabled	) ;
		impl_writeOUString	( rStream, m_sAutoloadURL		) ;
		impl_writeInt32		( rStream, m_nAutoloadSecs		) ;
		impl_writeOUString	( rStream, m_sDefaultTarget		) ;
	}

	if ( m_nHeaderVersion > 6 )
	{
		impl_writeBool ( rStream, m_bSaveGraphicsCompressed ) ;
	}

	if ( m_nHeaderVersion > 7 )
	{
		impl_writeBool ( rStream, m_bSaveOriginalGraphics ) ;
	}

	if ( m_nHeaderVersion > 8 )
	{
		impl_writeBool		( rStream, m_bSaveVersionOnClose	) ;
		impl_writeOUString	( rStream, m_sCopiesTo				) ;
		impl_writeOUString	( rStream, m_sOriginal				) ;
		impl_writeOUString	( rStream, m_sReferences			) ;
		impl_writeOUString	( rStream, m_sRecipient				) ;
		impl_writeOUString	( rStream, m_sReplyTo				) ;
		impl_writeOUString	( rStream, m_sBlindCopiesTo			) ;
		impl_writeOUString	( rStream, m_sInReplyTo				) ;
		impl_writeOUString	( rStream, m_sNewsgroups			) ;
		impl_writeuInt16	( rStream, m_nPriority				) ;
	}

	if ( m_nHeaderVersion > 9 )
	{
		// We have a open storage. This storage has a MIMEType. We have a value for MIMEType to!?
		// If these values are different, we use value of storage not of property!
		// We write a valid MIMEType at everytime ...
		// (User can't set property value - its readonly! But user can write this stream without open it !?...)
		m_sMIMEType = impl_FormatID2MIMEType ( m_nFormatID ) ;
		impl_writeOUString ( rStream, m_sMIMEType ) ;
	}

	if ( m_nHeaderVersion > 10 )
	{
		impl_writeBool ( rStream, m_bUserData ) ;
	}

	if ( m_nHeaderVersion > 11 )
	{
		if ( nSequenceSize > MAXCOUNT_DOCUSERKEYS )
		{
			// Write rest of user specified properties.
			// Get strings from namecontainer.
			// (See also declaration of "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" to get more information!)

			// First write count of properties in file ...
			// Attention: We have write 4 items as DOCUSERKEYS!

			nSequenceSize -= MAXCOUNT_DOCUSERKEYS ;
			impl_writeuInt32 ( rStream, nSequenceSize ) ;

			// Then write rest of properties ...
 			for ( nCounter = MAXCOUNT_DOCUSERKEYS; nCounter < nSequenceSize; ++nCounter )
			{
				sName	=	seqContainerProperties [ nCounter ]	;
				aValue	=	getByName ( sName )					;
				aValue	>>= sValue								;

				// Write name and value of property.
				// If "DOCUMENTPROPERTIES_SWITCH_OFF_GREATSIZE_CONTAINERPROPERTIES" is defined, these properties have a fixed size,
				// but at this point we don't metter this!
				impl_writeOUString ( rStream, sName		) ;
				impl_writeOUString ( rStream, sValue	) ;
			}
		}
	}

	// Control state of this operation !
	// We control this NOT everytime and after every writing of values in stream ...
	// but at the end of all instructions. -> PERFORMANCE !!!
	if ( rStream.GetError () != SVSTREAM_OK )
	{
		throw ( IOException () ) ;
	}
}

//******************************************************************************************************************************
OUString DocumentProperties::impl_readOUString ( SvStream& rStream, const sal_uInt16& nFixSize )
{
	String sTemp ;

	// Read string to temp. variable ...
	rStream >> sTemp ;

	// This value has a fix size in file!
	// Skip to much letters.
	if ( nFixSize > 0 )
	{
		rStream.SeekRel ( nFixSize - sTemp.Len () ) ;
	}

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readOUString()\nStream has errors!\n" ) ;
	#endif

	// ... convert it to OUString and return value.
	return impl_String2OUString ( sTemp ) ;
}

//******************************************************************************************************************************
Sequence< sal_Int8 > DocumentProperties::impl_readCharSequence ( SvStream& rStream )
{
	// Get size of follow byte array from stream.
	sal_uInt16 nSequenceSize ;
	rStream >> nSequenceSize ;

	// There are no elements ...
	if ( nSequenceSize < 1 )
	{
		// ... return without values.
		return Sequence< sal_Int8 > () ;
	}

	// Else; There are elements ...
	// Create new sequence with right size ...
	Sequence< sal_Int8 >	seqTemp	( nSequenceSize )		;
	// ... get a pointer to the array ...
	sal_Int8*				pArray	= seqTemp.getArray ()	;

	// ... and fill it with values.
	rStream.Read ( (void*)pArray, nSequenceSize ) ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readCharSequence()\nStream has errors!\n" ) ;
	#endif

	// Return the values.
	return seqTemp ;
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_readBool ( SvStream& rStream )
{
	sal_uInt8 nTemp ;

	// Read a byte from stream!
	// sal_Bool can be "int" or "unsigned char"(!!!), but there is only a byte in this file.
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readBool()\nStream has errors!\n" ) ;
	#endif

	// Check "BOOL" ... and return right value.
	if ( nTemp == 0 )
	{
		return sal_False ;
	}
	else
	{
		return sal_True  ;
	}
}

//******************************************************************************************************************************
sal_Int8 DocumentProperties::impl_readInt8 ( SvStream& rStream )
{
	sal_Int8 nTemp ;

	// Read value from stream ...
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readInt8()\nStream has errors!\n" ) ;
	#endif

	// ... and return it.
	return nTemp ;
}

//******************************************************************************************************************************
sal_Int16 DocumentProperties::impl_readInt16 ( SvStream& rStream )
{
	sal_Int16 nTemp ;

	// Read value from stream ...
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readInt16()\nStream has errors!\n" ) ;
	#endif

	// ... and return it.
	return nTemp ;
}

//******************************************************************************************************************************
sal_uInt16 DocumentProperties::impl_readuInt16 ( SvStream& rStream )
{
	sal_uInt16 nTemp ;

	// Read value from stream ...
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readuInt16()\nStream has errors!\n" ) ;
	#endif

	// ... and return it.
	return nTemp ;
}

//******************************************************************************************************************************
sal_Int32 DocumentProperties::impl_readInt32 ( SvStream& rStream )
{
	sal_Int32 nTemp ;

	// Read value from stream ...
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readInt32()\nStream has errors!\n" ) ;
	#endif

	// ... and return it.
	return nTemp ;
}

//******************************************************************************************************************************
sal_uInt32 DocumentProperties::impl_readuInt32 ( SvStream& rStream )
{
	sal_uInt32 nTemp ;

	// Read value from stream ...
	rStream >> nTemp ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_readuInt32()\nStream has errors!\n" ) ;
	#endif

	// ... and return it.
	return nTemp ;
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeOUString ( SvStream& rStream, const OUString& rOUString, const sal_uInt16& nFixSize )
{
	// Safe impossible cases.
	// There is a fix size, but value is to long !?
	DBG_ASSERT ( !(( nFixSize > 0  ) && ( rOUString.getLength () > nFixSize )), "DocumentProperties::impl_writeOUString()\nString is to long! There is a fix size for this.\n" ) ;

	// Convert OUString to String.
	String sTemp = impl_OUString2String ( rOUString ) ;

	// Truncate to much letters from string !
	// (=>see DBG_ASSERT below for debug version ... This is for a release!)
	if	(
			( nFixSize		>	0			)	&&
			( sTemp.Len ()	>	nFixSize	)
		)
	{
		sTemp.Erase ( nFixSize-1 ) ;
	}

	// Write string to stream.
	rStream << sTemp ;

	// This value has a fix size in file!
	if ( nFixSize > 0 )
	{
		// Add blanks to get a string with right size !!!
		sal_uInt16 nCounter ;
		for ( nCounter = sTemp.Len (); nCounter < nFixSize; ++nCounter )
		{
			rStream << ' ' ;
		}
	}

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeOUString()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeCharSequence ( SvStream& rStream, Sequence< sal_Int8 >& rCharSequence )
{
	// Get count of elements and save it on stream.
	sal_uInt16 nSequenceSize = rCharSequence.getLength () ;
	impl_writeuInt16 ( rStream, nSequenceSize ) ;

	// Save elements only, if some exist !
	if ( nSequenceSize > 0 )
	{
		sal_Int8* pArray = rCharSequence.getArray () ;

		rStream.Write ( (void*)pArray, nSequenceSize ) ;
	}

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeCharSequence()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeBool ( SvStream& rStream, const sal_Bool& rBool )
{
	sal_uInt8 nTemp ;

	// Check "BOOL" ... and write right value.
	if ( rBool == sal_False )
	{
		nTemp = 0 ;
		rStream << nTemp ;
	}
	else
	{
		nTemp = 1 ;
		rStream << nTemp ;
	}

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeBool()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeInt8 ( SvStream& rStream, const sal_Int8& rInt8 )
{
	rStream << rInt8 ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeInt8()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeInt16 ( SvStream& rStream, const sal_Int16& rInt16 )
{
	rStream << rInt16 ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeInt16()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeuInt16 ( SvStream& rStream, const sal_uInt16& ruInt16 )
{
	rStream << ruInt16 ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeuInt16()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeInt32 ( SvStream& rStream, const sal_Int32& rInt32 )
{
	rStream << rInt32 ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeInt32()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
void DocumentProperties::impl_writeuInt32 ( SvStream& rStream, const sal_uInt32& ruInt32 )
{
	rStream << ruInt32 ;

	#ifdef DBG_UTIL
		// Control state of this operation only in DEBUG-version!
		impl_debug_checkSvStream ( rStream, "DocumentProperties::impl_writeuInt32()\nStream has errors!\n" ) ;
	#endif
}

//******************************************************************************************************************************
OUString DocumentProperties::impl_FormatID2MIMEType ( const sal_uInt32& rFormatID )
{
	return ( aStaticConvertTable[rFormatID].sMIMEType ) ;
}

//******************************************************************************************************************************
sal_Int32 DocumentProperties::impl_FormatID2FileVersion ( const sal_uInt32& rFormatID )
{
	return ( aStaticConvertTable[rFormatID].nFileVersion ) ;
}

//******************************************************************************************************************************
sal_Bool DocumentProperties::impl_isFileVersionValid ( const sal_Int32& rFileVersion )
{
	if	(
			( rFileVersion	==	SOFFICE_FILEFORMAT_31	)	||
			( rFileVersion	==	SOFFICE_FILEFORMAT_40	)	||
			( rFileVersion	==	SOFFICE_FILEFORMAT_50	)	||
			( rFileVersion	==	SOFFICE_FILEFORMAT_NOW	)
		)
	{
		return sal_True ;
	}
	else
	{
		return sal_False ;
	}
}

//******************************************************************************************************************************
DATETIME DocumentProperties::impl_TimeStamp2DateTime ( const TimeStamp& rTimeStamp )
{
	//	Attention!
	//		We can't use a DateTime-object as type of any property with new UNO!
	//		We must use a DateTime-struct and convert the values.

	::DateTime	aDateTimeObject	;	// tools/DateTime				!!!
	DATETIME	aDateTimeStruct	;	// com/sun/star/util/DateTime	!!!

	// Get date and time ...
	aDateTimeObject = rTimeStamp.GetTime () ;
	// ... and convert DateTime-object to struct ! (copy values)
    aDateTimeStruct.HundredthSeconds	= aDateTimeObject.Get100Sec	() ;
    aDateTimeStruct.Seconds				= aDateTimeObject.GetSec	() ;
    aDateTimeStruct.Minutes				= aDateTimeObject.GetMin	() ;
    aDateTimeStruct.Hours				= aDateTimeObject.GetHour	() ;
    aDateTimeStruct.Day					= aDateTimeObject.GetDay	() ;
    aDateTimeStruct.Month				= aDateTimeObject.GetMonth	() ;
    aDateTimeStruct.Year				= aDateTimeObject.GetYear	() ;

	// Return ricght type with right values.
	return aDateTimeStruct ;
}

//******************************************************************************************************************************
TimeStamp DocumentProperties::impl_DateTime2TimeStamp ( const DATETIME& rDateTime )
{
	//	Attention!
	//		We can't use a DateTime-object as type of any property with new UNO!
	//		We must use a DateTime-struct and convert the values.

	// Get values from DateTime-struct and create a date and time instance ...
	Date aDate ( rDateTime.Day	, rDateTime.Month	, rDateTime.Year								) ;
	Time aTime ( rDateTime.Hours, rDateTime.Minutes	, rDateTime.Seconds, rDateTime.HundredthSeconds ) ;

	// ... to use it for creation of a DateTime-object ...
	::DateTime	aDateTimeObject ( aDate, aTime		) ;
	// ... and a TimeStamp!
	TimeStamp	aTimeStamp		( aDateTimeObject	) ;

	// Return converted timestamp.
	return aTimeStamp ;
}

//******************************************************************************************************************************
OUString DocumentProperties::impl_String2OUString ( const String& rString )
{
	return ( OStringToOUString ( rString.GetStr (), RTL_TEXTENCODING_MS_1252 ) ) ;
}

//******************************************************************************************************************************
String DocumentProperties::impl_OUString2String ( const OUString& rOUString	)
{
	return ( OUStringToOString ( rOUString, RTL_TEXTENCODING_MS_1252 ) ) ;
}

//******************************************************************************************************************************
void DocumentProperties::impl_resetObject ()
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	// Set default values on some internal members.
	m_sHeaderType					=	OUString::createFromAscii( DEFAULT_HEADERTYPE		)	;
	m_nHeaderVersion				=	DEFAULT_HEADERVERSION									;
	m_eFileCharSet					=	DEFAULT_FILECHARSET										;
	m_nFormatID						=	DEFAULT_FORMATID										;

	// Set default values on properties.
	m_sAuthor						=	OUString::createFromAscii( DEFAULT_AUTHOR 			)	;
	m_bAutoloadEnabled				=	DEFAULT_AUTOLOADENABLED									;
	m_nAutoloadSecs					=	DEFAULT_AUTOLOADSECS									;
	m_sAutoloadURL					=	OUString::createFromAscii( DEFAULT_AUTOLOADURL		)	;
	m_sBlindCopiesTo				=	OUString::createFromAscii( DEFAULT_BLINDCOPIESTO	)	;
	m_sCopiesTo		  				=	OUString::createFromAscii( DEFAULT_COPIESTO			)	;
	m_sDefaultTarget  				=	OUString::createFromAscii( DEFAULT_DEFAULTTARGET	)	;
	m_sDescription					=	OUString::createFromAscii( DEFAULT_DESCRIPTION		)	;
	m_nEditingCycles  				=	DEFAULT_EDITINGCYCLES									;
	m_nEditingDuration				=	DEFAULT_EDITINGDURATION									;
	m_sInReplyTo					=	OUString::createFromAscii( DEFAULT_INREPLYTO		)	;
	m_bIsEncrypted					=	DEFAULT_ISENCRYPTED										;
	m_sKeywords						=	OUString::createFromAscii( DEFAULT_KEYWORDS			)	;
	m_sMIMEType						=	OUString::createFromAscii( DEFAULT_MIMETYPE			)	;
	m_sModifiedBy					=	OUString::createFromAscii( DEFAULT_MODIFIEDBY		)	;
	m_sNewsgroups					=	OUString::createFromAscii( DEFAULT_NEWSGROUPS		)	;
	m_sOriginal						=	OUString::createFromAscii( DEFAULT_ORIGINAL			)	;
	m_bPortableGraphics				=	DEFAULT_PORTABLEGRAPHICS								;
	m_sPrintedBy					=	OUString::createFromAscii( DEFAULT_PRINTEDBY		)	;
	m_nPriority						=	DEFAULT_PRIORITY										;
	m_bQueryTemplate				=	DEFAULT_QUERYTEMPLATE									;
	m_sRecipient					=	OUString::createFromAscii( DEFAULT_RECIPIENT		)	;
	m_sReferences					=	OUString::createFromAscii( DEFAULT_REFERENCES		)	;
	m_sReplyTo						=	OUString::createFromAscii( DEFAULT_REPLYTO			)	;
	m_bSaveGraphicsCompressed		=	DEFAULT_SAVEGRAPHICSCOMPRESSED							;
	m_bSaveOriginalGraphics			=	DEFAULT_SAVEORIGINALGRAPHICS							;
	m_bSaveVersionOnClose			=	DEFAULT_SAVEVERSIONONCLOSE								;
	m_sTemplate						=	OUString::createFromAscii( DEFAULT_TEMPLATE			)	;
	m_bTemplateConfig				=	DEFAULT_TEMPLATECONFIG									;
	m_sTemplateFileName				=	OUString::createFromAscii( DEFAULT_TEMPLATEFILENAME	)	;
	m_sTheme						=	OUString::createFromAscii( DEFAULT_THEME			)	;
	m_sTitle						=	OUString::createFromAscii( DEFAULT_TITLE			)	;
	m_bUserData						=	DEFAULT_USERDATA										;

	// Reset DateTime-structures.
	impl_resetDateTime ( m_aCreationDate	) ;
	impl_resetDateTime ( m_aModifyDate		) ;
	impl_resetDateTime ( m_aPrintDate		) ;
	impl_resetDateTime ( m_aTemplateDate	) ;

	// Clear extra data sequence.
	m_seqExtraData.realloc ( 0 ) ;

	// Reset "NameContainer" !
	m_aPropertyHashTable.clear () ;
}

//******************************************************************************************************************************
void DocumentProperties::impl_resetDateTime ( DATETIME& rDateTime )
{
    rDateTime.HundredthSeconds	= 0	;
    rDateTime.Seconds			= 0	;
    rDateTime.Minutes			= 0	;
    rDateTime.Hours				= 0	;
    rDateTime.Day				= 0	;
    rDateTime.Month				= 0	;
    rDateTime.Year				= 0	;
}

//******************************************************************************************************************************
const Sequence< Property > DocumentProperties::impl_getStaticPropertyDescriptor()
{
	// Create a new static property array to initialize sequence!
	// Table of all predefined properties of this class. Its used from OPropertySetHelper-class!
	// Don't forget to change the defines (see begin of this file), if you add, change or delete a property in this list!!!
	// It's necessary for methods of OPropertyHelper.
	// ATTENTION:
	//		YOU MUST SORT FOLLOW TABLE BY NAME !!!
	static const Property pPropertys[] =
	{
		Property( OUString::createFromAscii("Author"				), HANDLE_AUTHOR				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("AutoloadEnabled"		), HANDLE_AUTOLOADENABLED		, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("AutoloadSecs"        	), HANDLE_AUTOLOADSECS			, ::getCppuType((sal_Int32*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("AutoloadURL"         	), HANDLE_AUTOLOADURL			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("BlindCopiesTo"       	), HANDLE_BLINDCOPIESTO			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("CopiesTo"              ), HANDLE_COPIESTO				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("CreationDate"        	), HANDLE_CREATIONDATE			, ::getCppuType((DATETIME*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("DefaultTarget"       	), HANDLE_DEFAULTTARGET			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Description"         	), HANDLE_DESCRIPTION			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("EditingCycles"       	), HANDLE_EDITINGCYCLES			, ::getCppuType((sal_Int16*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("EditingDuration"     	), HANDLE_EDITINGDURATION		, ::getCppuType((sal_Int32*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("ExtraData"				), HANDLE_EXTRADATA				, ::getCppuType((Sequence< sal_Int8 >*)0)	, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("InReplyTo"           	), HANDLE_INREPLYTO				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("IsEncrypted"         	), HANDLE_ISENCRYPTED			, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY),
		Property( OUString::createFromAscii("Keywords"            	), HANDLE_KEYWORDS				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("MIMEType"            	), HANDLE_MIMETYPE				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY),
		Property( OUString::createFromAscii("ModifiedBy"          	), HANDLE_MODIFIEDBY			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("ModifyDate"          	), HANDLE_MODIFYDATE			, ::getCppuType((DATETIME*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Newsgroups"          	), HANDLE_NEWSGROUPS			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Original"            	), HANDLE_ORIGINAL				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("PortableGraphics"		), HANDLE_PORTABLEGRAPHICS		, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("PrintDate"           	), HANDLE_PRINTDATE				, ::getCppuType((DATETIME*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("PrintedBy"           	), HANDLE_PRINTEDBY				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Priority"            	), HANDLE_PRIORITY				, ::getCppuType((sal_uInt16*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("QueryTemplate"			), HANDLE_QUERYTEMPLATE			, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Recipient"           	), HANDLE_RECIPIENT				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("References"          	), HANDLE_REFERENCES			, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("ReplyTo"             	), HANDLE_REPLYTO				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("SaveGraphicsCompressed"), HANDLE_SAVEGRAPHICSCOMPRESSED, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("SaveOriginalGraphics"	), HANDLE_SAVEORIGINALGRAPHICS	, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("SaveVersionOnClose"	), HANDLE_SAVEVERSIONONCLOSE	, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Template"            	), HANDLE_TEMPLATE				, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("TemplateConfig"		), HANDLE_TEMPLATECONFIG		, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("TemplateDate"        	), HANDLE_TEMPLATEDATE			, ::getCppuType((DATETIME*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("TemplateFileName"		), HANDLE_TEMPLATEFILENAME		, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Theme"               	), HANDLE_THEME					, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("Title"               	), HANDLE_TITLE					, ::getCppuType((OUString*)0)				, PropertyAttribute::TRANSIENT								),
		Property( OUString::createFromAscii("UserData"				), HANDLE_USERDATA				, ::getCppuType((sal_Bool*)0)				, PropertyAttribute::TRANSIENT								) // NO "," at last item !!!
	};
	// Use it to initialize sequence!
	static const Sequence< Property > seqPropertyDescriptor( pPropertys, COUNT_PROPERTIES );
	// Return static "PropertyDescriptor"
	return seqPropertyDescriptor ;
}

//______________________________________________________________________________________________________________
//	private methods end
//______________________________________________________________________________________________________________

//______________________________________________________________________________________________________________
//	debug methods start
//______________________________________________________________________________________________________________

/*--------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used with "DBG_ASSERT(...)" to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact Andreas Schluens [as] or add it himself !(?)
		But ... look for right testing! See using of this methods!
--------------------------------------------------------------------------------------------------------------*/

//******************************************************************************************************************************
//	used by:	queryInterface()
sal_Bool DocumentProperties::impl_debug_checkParameter ( const Type& rType )
{
	if ( &rType == (Type*)0 ) return sal_False ;

	return sal_True ;
}

//******************************************************************************************************************************
//	used by:	supportsService()
//				read()
//				write()
sal_Bool DocumentProperties::impl_debug_checkParameter ( const OUString& rOUString )
{
	if ( &rOUString	== (OUString*)0 ) return sal_False ;
	if ( rOUString	== ""			) return sal_False ;

	return sal_True ;
}

//******************************************************************************************************************************
//	used by:	convertFastPropertyValue()
sal_Bool DocumentProperties::impl_debug_checkParameter ( Any& rAny1, Any& rAny2, sal_Int32 nInt32, const Any& rAny3 )
{
	if ( &rAny1	==	(Any*)0			) return sal_False ;
	if ( &rAny2	==	(Any*)0			) return sal_False ;
	if ( &rAny3	==	(Any*)0			) return sal_False ;
	if ( nInt32	<	MIN_PROPERTIES	) return sal_False ;
	if ( nInt32	>	MAX_PROPERTIES	) return sal_False ;

	return sal_True ;
}

//******************************************************************************************************************************
//	used by:	setFastPropertyValue_NoBroadcast()
sal_Bool DocumentProperties::impl_debug_checkParameter ( sal_Int32 nInt32, const Any& rAny )
{
	if ( &rAny	==	(Any*)0			) return sal_False ;
	if ( nInt32	<	MIN_PROPERTIES	) return sal_False ;
	if ( nInt32	>	MAX_PROPERTIES	) return sal_False ;

	return sal_True ;
}

//******************************************************************************************************************************
//	used by:	getFastPropertyValue()
sal_Bool DocumentProperties::impl_debug_checkParameter ( Any& rAny, sal_Int32 nInt32 ) const
{
	if ( &rAny	==	(Any*)0			) return sal_False ;
	if ( nInt32	<	MIN_PROPERTIES	) return sal_False ;
	if ( nInt32	>	MAX_PROPERTIES	) return sal_False ;

	return sal_True ;
}

//******************************************************************************************************************************
// Don't use follow method at everytime! Only for debugging and testing
#ifdef DOCUMENTPROPERTIES_SWITCH_ON_CHECK_SVSTREAM

void DocumentProperties::impl_debug_checkSvStream ( SvStream& rStream, const String& rPosition )
{
	// Has stream errors?
	sal_uInt32 nError = rStream.GetError () ;

	if ( nError != SVSTREAM_OK )
	{
		// Yes; Format message to informize user !!!
		String sMessage = rPosition ;

		switch ( nError )
		{
//			case SVSTREAM_GENERALERROR			:	// same ID like SVSTREAM_SHARE_BUFF_EXCEEDED
			case SVSTREAM_FILE_NOT_FOUND		:	sMessage += "File not found"													;
													break ;
			case SVSTREAM_PATH_NOT_FOUND		:	sMessage += "Path not found"													;
													break ;
			case SVSTREAM_TOO_MANY_OPEN_FILES	:	sMessage += "Too many open files"												;
													break ;
			case SVSTREAM_ACCESS_DENIED			:	sMessage += "Access denied"														;
													break ;
//			case SVSTREAM_SHARING_VIOLATION		:	// same ID like SVSTREAM_SHARE_BUFF_EXCEEDED
//			case SVSTREAM_LOCKING_VIOLATION		:	// same ID like SVSTREAM_SHARE_BUFF_EXCEEDED
			case SVSTREAM_SHARE_BUFF_EXCEEDED	:	sMessage += "Sharing violation or Locking violation or Share buffer exceeded"	;
													break ;
			case SVSTREAM_INVALID_ACCESS		:	sMessage += "Invalid access"													;
													break ;
			case SVSTREAM_INVALID_HANDLE		:	sMessage += "General Error or Invalid handle"									;
													break ;
			case SVSTREAM_CANNOT_MAKE			:	sMessage += "Cannot make"														;
													break ;
			case SVSTREAM_INVALID_PARAMETER		:	sMessage += "Invalid parameter"													;
													break ;
			case SVSTREAM_READ_ERROR			:	sMessage += "Read error"														;
													break ;
			case SVSTREAM_WRITE_ERROR			:	sMessage += "Write error"														;
													break ;
			case SVSTREAM_SEEK_ERROR			:	sMessage += "Seek error"														;
													break ;
			case SVSTREAM_TELL_ERROR			:	sMessage += "Tell error"														;
													break ;
			case SVSTREAM_OUTOFMEMORY			:	sMessage += "Out of memory"														;
													break ;
			case SVSTREAM_FILEFORMAT_ERROR		:	sMessage += "Fileformat error"													;
													break ;
			case SVSTREAM_WRONGVERSION			:	sMessage += "Wrong version"														;
													break ;
			case SVSTREAM_DISK_FULL				:	sMessage += "Disk full"															;
													break ;
			default								:	sMessage += "Unknown error !!!"													;
		}

		sMessage += "\n" ;
		DBG_ASSERT ( FALSE, sMessage ) ;
	}
}

#endif // DOCUMENTPROPERTIES_SWITCH_ON_CHECK_SVSTREAM

