/*************************************************************************
 *
 *  $RCSfile: desktop.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:11:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_DESKTOP_HXX_
#include <services/desktop.hxx>
#endif

#ifndef __FRAMEWORK_TASKSACCESS_HXX_
#include <services/tasksaccess.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx>
#endif

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif

#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

using namespace ::osl										;
using namespace ::rtl										;
using namespace ::cppu										;
using namespace ::com::sun::star::uno						;
using namespace ::com::sun::star::lang						;
using namespace ::com::sun::star::frame						;
using namespace ::com::sun::star::task						;
using namespace ::com::sun::star::io						;
using namespace ::com::sun::star::beans						;
using namespace ::com::sun::star::container					;
using namespace ::com::sun::star::util						;
using namespace ::com::sun::star::awt						;

//_________________________________________________________________________________________________________________
//	non exported const
//_________________________________________________________________________________________________________________

#define	SERVICENAME								"com.sun.star.framework.Desktop"				// service-name of this class
#define	IMPLEMENTATIONNAME						"com.sun.star.comp.framework.Desktop"			// implementation-name of this class

#define	EQUAL									0												// result value for string compare

#define	PROPERTYNAME_ACTIVECOMPONENT			"ActiveComponent"								// names of properties
#define	PROPERTYNAME_ACTIVEFRAME				"ActiveFrame"
#define	PROPERTYNAME_HASBEAMER					"HasBeamer"
#define	PROPERTYNAME_HASCOMMONTASKBAR			"HasCommonTaskBar"
#define	PROPERTYNAME_HASDESIGNER				"HasDesigner"
#define	PROPERTYNAME_HASEXPLORER				"HasExplorer"
#define	PROPERTYNAME_HASFUNCTIONBAR				"HasFunctionBar"
#define	PROPERTYNAME_HASMACROBAR				"HasMacroBar"
#define	PROPERTYNAME_HASNAVIGATOR				"HasNavigator"
#define	PROPERTYNAME_HASOBJECTBAR				"HasObjectBar"
#define	PROPERTYNAME_HASOPTIONBAR				"HasOptionBar"
#define	PROPERTYNAME_HASSTATUSBAR				"HasStatusBar"
#define	PROPERTYNAME_HASTOOLBAR					"HasToolBar"
#define	PROPERTYNAME_ISOLOCALE					"ISOLocale"

#define	PROPERTYHANDLE_ACTIVECOMPONENT			1												// handle of properties
#define	PROPERTYHANDLE_ACTIVEFRAME				2
#define	PROPERTYHANDLE_HASBEAMER				3
#define	PROPERTYHANDLE_HASCOMMONTASKBAR			4
#define	PROPERTYHANDLE_HASDESIGNER				5
#define	PROPERTYHANDLE_HASEXPLORER				6
#define	PROPERTYHANDLE_HASFUNCTIONBAR			7
#define	PROPERTYHANDLE_HASMACROBAR				8
#define	PROPERTYHANDLE_HASNAVIGATOR				9
#define	PROPERTYHANDLE_HASOBJECTBAR				10
#define	PROPERTYHANDLE_HASOPTIONBAR				11
#define	PROPERTYHANDLE_HASSTATUSBAR				12
#define	PROPERTYHANDLE_HASTOOLBAR				13
#define	PROPERTYHANDLE_ISOLOCALE				14

#define	PROPERTYCOUNT							14												// count of ALL properties

//_________________________________________________________________________________________________________________
//	non exported definitions
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
Desktop::Desktop( const Reference< XMultiServiceFactory >& xFactory )
		//	Init baseclasses first
		//	Attention:
		//		Don't change order of initialization!
		//      tIMPLMutexContainer is a struct with a mutex as member. We can't use a mutex as member, while
		//		we must garant right initialization and a valid value of this! First initialize
		//		baseclasses and then members. And we need the mutex for other baseclasses !!!
		:	OMutexMember			(																						)
		,	OWeakObject				(																						)
		,	OBroadcastHelper		( ((OMutexMember*)this)->m_aMutex														)
		,	OPropertySetHelper		( *SAL_STATIC_CAST( OBroadcastHelperVar< OMultiTypeInterfaceContainerHelper >*, this )	)
		// Init member
		,	m_xFactory				( xFactory																				)
		,	m_aListenerContainer	( m_aMutex																				)
		,	m_aChildFramesContainer	( m_aMutex																				)
		// Init Properties
		,	m_bHasBeamer			( sal_True																				)
		,	m_bHasCommonTaskBar		( sal_True																				)
		,	m_bHasDesigner			( sal_True																				)
		,	m_bHasExplorer			( sal_True																				)
		,	m_bHasFunctionBar		( sal_True																				)
		,	m_bHasMacroBar			( sal_True																				)
		,	m_bHasNavigator			( sal_True																				)
		,	m_bHasObjectBar			( sal_True																				)
		,	m_bHasOptionBar			( sal_True																				)
		,	m_bHasStatusBar			( sal_True																				)
		,	m_bHasToolbar			( sal_True																				)
		,	m_aISOLocale			(																						)
{
}

//*****************************************************************************************************************
//	destructor
//*****************************************************************************************************************
Desktop::~Desktop()
{
	// Reset instance, free memory ....
	impl_resetObject();
}

//*****************************************************************************************************************
//	XInterface, XTypeProvider, XServiceInfo
//*****************************************************************************************************************
DEFINE_XINTERFACE_13					(	Desktop										,
											OWeakObject									,
											DIRECT_INTERFACE( XTypeProvider				),
											DIRECT_INTERFACE( XServiceInfo				),
											DIRECT_INTERFACE( XDesktop					),
											DIRECT_INTERFACE( XComponentLoader			),
											DIRECT_INTERFACE( XTasksSupplier			),
											DIRECT_INTERFACE( XDispatchProvider			),
											DIRECT_INTERFACE( XFramesSupplier			),
											DIRECT_INTERFACE( XStatusIndicatorFactory	),
											DIRECT_INTERFACE( XFrame					),
											DIRECT_INTERFACE( XPropertySet				),
											DIRECT_INTERFACE( XFastPropertySet			),
											DIRECT_INTERFACE( XMultiPropertySet			),
											DIRECT_INTERFACE( XComponent				)
										)

DEFINE_XTYPEPROVIDER_13					(	Desktop					,
											XTypeProvider			,
											XServiceInfo			,
											XDesktop				,
											XComponentLoader		,
											XTasksSupplier			,
											XDispatchProvider		,
											XFramesSupplier			,
											XStatusIndicatorFactory	,
											XFrame					,
											XPropertySet			,
											XFastPropertySet		,
											XMultiPropertySet		,
											XComponent
										)

DEFINE_XSERVICEINFO_ONEINSTANCESERVICE	(	Desktop				,
											SERVICENAME			,
											IMPLEMENTATIONNAME
										)

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
sal_Bool SAL_CALL Desktop::terminate() throw( RuntimeException )
{
	/*ASMUSS
		Alle Task fragen ,ob sie denn beendet werden moechten.
		Am jeweiligen controller suspend() aufrufen
		Wer keinen Controller hat wird auf jeden Fall geschlossen
	 */

	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Set default return value, if method failed.
	sal_Bool bReturn = sal_False;

	// Step over all child frames and ask they "CAN I TERMINATE?"
	OInterfaceIteratorHelper aIterator( m_aChildFramesContainer );
	while ( aIterator.hasMoreElements() == sal_True )
	{
		// ...
	}

	// Return result of this question.
	return bReturn;
}

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
void SAL_CALL Desktop::addTerminateListener( const Reference< XTerminateListener >& xListener ) throw( RuntimeException )
{
	//Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Add terminate-listener to container.
	m_aListenerContainer.addInterface( ::getCppuType( ( const Reference< XTerminateListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
void SAL_CALL Desktop::removeTerminateListener( const Reference< XTerminateListener >& xListener ) throw( RuntimeException )
{
	//Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Remove terminate-listener from container.
	m_aListenerContainer.removeInterface( ::getCppuType( ( const Reference< XTerminateListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
Reference< XEnumerationAccess > SAL_CALL Desktop::getComponents() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::getComponents()\nNot implemented yet!\n");

	//Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	return Reference< XEnumerationAccess >();
}

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
Reference< XComponent > SAL_CALL Desktop::getCurrentComponent() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Get reference to current frame ...
	// ... get component of this frame ... (It can be the window, the model or the controller.)
	Reference< XFrame >		xCurrentFrame	= getCurrentFrame();
	Reference< XComponent >	xComponent		= impl_getFrameComponent( xCurrentFrame );

	// ... and return result.
	return xComponent;
}

//*****************************************************************************************************************
//	XDesktop
//*****************************************************************************************************************
Reference< XFrame > SAL_CALL Desktop::getCurrentFrame() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Set default return value, if method failed.
	Reference< XFrame > xReturn = Reference< XFrame >();

	// Start search with the active frame (if it exist!).
	if ( m_xActiveFrame.is() == sal_True )
	{
		// The current frame is the most active frame.
		// Search from there other active frames in hierarchy.
		Reference< XFramesSupplier > xLast = Reference< XFramesSupplier >( m_xActiveFrame, UNO_QUERY );
		Reference< XFramesSupplier > xNext = Reference< XFramesSupplier >( xLast->getActiveFrame(), UNO_QUERY );

		// If a other frame in hierarchy is active to ...
		while ( xNext.is() == sal_True )
		{
			// ... safe this new one as current and try to get a other active frame.
			xLast	= xNext;
			xNext	= Reference< XFramesSupplier >( xNext->getActiveFrame(), UNO_QUERY );
		}

		// Cast current active frame to XFrame.
		xReturn = Reference< XFrame >( xNext, UNO_QUERY );
	}

	// Return result of search.
	return xReturn;
}

//*****************************************************************************************************************
//	XComponentLoader
//*****************************************************************************************************************
Reference< XComponent > SAL_CALL Desktop::loadComponentFromURL(	const	OUString&					sURL			,
																const	OUString&					sTargetFrameName,
																		sal_Int32					nSearchFlags	,
																const	Sequence< PropertyValue >&	seqArguments	) throw(	IOException				,
																																IllegalArgumentException,
																																RuntimeException		)
{
	OSL_ENSHURE( sal_False, "Desktop::loadComponentFromURL()\nNot implemented yet!\n");

	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Set default return value, if method failed.
	Reference< XComponent > xReturn = Reference< XComponent >();

/*ASMUSS

	muss neu implementiert werden.


 	SfxShell *pSh = SFX_APP();
	SfxRequest aReq( SID_OPENURL, SFX_CALLMODE_SYNCHRON, pSh->GetPool() );

	SfxAllItemSet aSet( pSh->GetPool() );
	TransformParameters( SID_OPENDOC, rArgs, aSet );
	aReq.SetArgs( aSet );

	// Falls kein Referer dabei ist
	SFX_REQUEST_ARG( aReq, pReferer, SfxStringItem, SID_REFERER, sal_False );
	if ( !pReferer )
	{
		DBG_WARNING( "loadComponent without Referer!" );
		aReq.AppendItem( SfxStringItem( SID_REFERER, String() ) );
	}

	sal_Bool bHidden = sal_False;
	aReq.AppendItem( SfxStringItem( SID_FILE_NAME, aURL ) );
	if ( rTargetFrameName.compareToAscii("_hidden") == COMPARE_EQUAL )
	{
		bHidden = sal_True;
		aReq.AppendItem( SfxBoolItem( SID_HIDDEN, sal_True ) );
		aReq.AppendItem( SfxStringItem( SID_TARGETNAME, String::CreateFromAscii( "_blank" ) ) );
	}
	else if ( rTargetFrameName.compareToAscii("_beamer") == COMPARE_EQUAL )
	{
		SfxApplication *pApp = SFX_APP();
		if ( !pApp->HasChildWindow( SID_BROWSER ) )
		{
			// Beamer nicht da
			if ( ( nSearchFlags & ::com::sun::star::frame::FrameSearchFlag::CREATE ) == 0 )
				return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > ();

			pApp->SetChildWindow( SID_BROWSER, sal_True );
			pApp->GetBindings().Invalidate( SID_BROWSER );
		}

		SfxChildWindow *pChild = pApp->GetChildWindow( SID_BROWSER );
		if ( pChild )
		{
			SfxExplorerHorizDockWnd_Impl *pBeamer = (SfxExplorerHorizDockWnd_Impl*)
				pChild->GetWindow();

			// Einen versteckten Beamer gebe ich nur raus, wenn ich zum Erzeugen
			// gen"otigt werde
			if ( pBeamer->IsAutoHide_Impl() &&
				( ( nSearchFlags & ::com::sun::star::frame::FrameSearchFlag::CREATE ) == 0 ) )
				return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > ();
			else
			{
				::com::sun::star::util::URL aDispURL;
				aDispURL.Complete = aURL;
				SfxURLTransformer aTrans ( ::utl::getProcessServiceFactory() );
				aTrans.parseStrict( aDispURL );
				::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  xFrame( pBeamer->GetFrameInterface() );
				::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  xProv( xFrame, ::com::sun::star::uno::UNO_QUERY );
				if ( xProv.is() )
				{
					::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  xDisp = xProv->queryDispatch( aDispURL, rTargetFrameName, nSearchFlags );
					xDisp->dispatch( aDispURL, rArgs );
					::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >  xRef = xFrame->getController();
					if ( !xRef.is() )
						return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xFrame->getComponentWindow(), ::com::sun::star::uno::UNO_QUERY );
					if ( xRef->getModel().is() )
						return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xRef->getModel(), ::com::sun::star::uno::UNO_QUERY );
					else
						return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xRef, ::com::sun::star::uno::UNO_QUERY );
				}
				else
					return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > ();
			}
		}
		else
			return ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > ();
	}
	else
	{
		aReq.AppendItem( SfxStringItem( SID_TARGETNAME, rTargetFrameName ) );
		aReq.AppendItem( SfxFrameItem( SID_DOCFRAME, SfxViewFrame::Current()->GetTopViewFrame() ) );
	}

	const SfxPoolItem *pRet = pSh->ExecuteSlot(aReq);
	const SfxViewFrameItem *pRet1 = PTR_CAST( SfxViewFrameItem, pRet );
	SfxFrame *pFrame=NULL;
	if ( pRet1 )
		pFrame = pRet1->GetFrame()->GetFrame();
	else
	{
		const SfxFrameItem *pRet2 = PTR_CAST( SfxFrameItem, pRet );
		if ( pRet2 && !pRet2->FrameKilled() )
			pFrame = pRet2->GetFrame();
	}

	if ( pFrame )
	{
		if ( bHidden )
			pFrame->GetCurrentDocument()->Get_Impl()->bHiddenLockedByAPI = sal_True;

		::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  xFrame = pFrame->GetFrameInterface();
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >  xCtrl = xFrame->getController();
		if ( xCtrl.is() )
		{
			::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel >  xModel = xCtrl->getModel();
			if ( xModel.is() )
				aRet = ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xModel, ::com::sun::star::uno::UNO_QUERY );
			else
				aRet = ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xCtrl, ::com::sun::star::uno::UNO_QUERY );
		}
		else
			aRet = ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >( xFrame->getComponentWindow(), ::com::sun::star::uno::UNO_QUERY );
	}
	*/
	return xReturn;
}

//*****************************************************************************************************************
//	XTasksSupplier
//*****************************************************************************************************************
Reference< XEnumerationAccess > SAL_CALL Desktop::getTasks() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Return list of current tasks.
	// Create new EnumerationAccess-object to create enumerations ....
	// Initialize this instance with a reference to the desktop and a pointer to the taskscontainer.
	Reference< XDesktop >			xThis	( (OWeakObject*)this, UNO_QUERY );
	TasksAccess*					pAccess	= new TasksAccess( xThis, &m_aChildFramesContainer );
	Reference< XEnumerationAccess >	xAccess	( (OWeakObject*)pAccess, UNO_QUERY );

	return xAccess;
}

//*****************************************************************************************************************
//	XTasksSupplier
//*****************************************************************************************************************
Reference< XTask > SAL_CALL Desktop::getActiveTask() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Get active frame and cast interface to XTask.
	return Reference< XTask >( getActiveFrame(), UNO_QUERY );
}

//*****************************************************************************************************************
//	XDispatchProvider
//*****************************************************************************************************************
Reference< XDispatch > SAL_CALL Desktop::queryDispatch(	const	URL&		aURL			,
														const	OUString&	sTargetFrameName,
																sal_Int32	nSearchFlags	) throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::queryDispatch()\nNot implemented yet!\n");

	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Set default return value, if method failed.
	Reference< XDispatch > xReturn = Reference< XDispatch >();
/*ASMUSS
	if ( sTargetFrameName.getLength() > 0 )
	{
		//ASMUSS Reference< XDispatchProvider > xProvider( SfxViewFrame::Current()->GetFrame()->GetFrameInterface(), UNO_QUERY );
		Reference< XDispatchProvider > xProvider;
		if ( xProvider.is() == sal_True )
		{
			xReturn = xProvider->queryDispatch( aURL, sTargetFrameName, nSearchFlags );
		}
	}
*/
	return xReturn;
}

//*****************************************************************************************************************
//	XDispatchProvider
//*****************************************************************************************************************
Sequence< Reference< XDispatch > > SAL_CALL Desktop::queryDispatches( const Sequence< DispatchDescriptor >& seqDescripts ) throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::queryDispatches()\nNot implemented yet!\n");
	return Sequence< Reference< XDispatch > >();
}

//*****************************************************************************************************************
//	XFramesSupplier
//*****************************************************************************************************************
Reference< XFrames > SAL_CALL Desktop::getFrames() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::getFrames()\nNot implemented yet!\n");
	return Reference< XFrames >();
}

//*****************************************************************************************************************
//	XFramesSupplier
//*****************************************************************************************************************
Reference< XFrame > SAL_CALL Desktop::getActiveFrame() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Return current active frame.
	return Reference< XFrame >( m_xActiveFrame, UNO_QUERY );
}

//*****************************************************************************************************************
//	XFramesSupplier
//*****************************************************************************************************************
void SAL_CALL Desktop::setActiveFrame( const Reference< XFrame >& xFrame ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Set new active frame on property-member as XComponent.
	m_xActiveFrame = Reference< XComponent >( xFrame, UNO_QUERY );
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::initialize( const Reference< XWindow >& xWindow ) throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::initialize()\nNot implemented yet!\n");
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
Reference< XWindow > SAL_CALL Desktop::getContainerWindow() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::getContainerWindow()\nNot implemented yet!\n");
	return Reference< XWindow >();
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::setCreator( const Reference< XFramesSupplier >& xCreator ) throw( RuntimeException )
{
	// The desktop is the topframe! He has no parent.
	OSL_ENSHURE( sal_False, "Desktop::setCreator()\nThe desktop is the topframe! He has no parent.\n" );
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
Reference< XFramesSupplier > SAL_CALL Desktop::getCreator() throw( RuntimeException )
{
	// The desktop is the topframe! He has no parent.
	OSL_ENSHURE( sal_False, "Desktop::getCreator()\nThe desktop is the topframe! He has no parent.\n" );
	return Reference< XFramesSupplier >();
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
OUString SAL_CALL Desktop::getName() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Return name of THIS frame.
	return m_sName;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::setName( const OUString& sName ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe new name of THIS frame.
	m_sName = sName;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
Reference< XFrame > SAL_CALL Desktop::findFrame(	const	OUString&	sTargetFrameName,
															sal_Int32	nSearchFlags	) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Declare variable with a default to hold return value.
	// The compiler makes better code for ONE return-statement!
	Reference< XFrame > xReturn = Reference< XFrame >();

	// Can it be this frame himself?
	if	(
			( nSearchFlags		&	FrameSearchFlag::SELF	)	&&
			( sTargetFrameName	==	m_sName					)
		)
	{
		// YES ...
		xReturn = Reference< XFrame >( (OWeakObject*)this, UNO_QUERY );
	}
	else
	// NO ...
	// It must be a children.
	if ( nSearchFlags & FrameSearchFlag::CHILDREN )
	{
		// Get a ONEWAY-list of all child frames.
		OInterfaceIteratorHelper aIterator( m_aChildFramesContainer );
		// Search in list.
		while	(
					( aIterator.hasMoreElements()	==	sal_True )	&&
					( xReturn.is()					==	sal_False)
				)
		{
			// Get next child; cast it to XFrame and compare the name.
			Reference< XFrame > xFrame( aIterator.next(), UNO_QUERY );
			if ( sTargetFrameName == xFrame->getName() )
			{
				xReturn = xFrame;
			}
		}
	}

	// Return result of this search.
	return xReturn;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
sal_Bool SAL_CALL Desktop::isTop() throw( RuntimeException )
{
	// A desktop is the topframe everytime.
	return sal_True;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::activate() throw( RuntimeException )
{
	// Desktop is active everytime! Do nothing.
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::deactivate() throw( RuntimeException )
{
	// Desktop is active everytime! Do nothing.
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
sal_Bool SAL_CALL Desktop::isActive() throw( RuntimeException )
{
	// Desktop is active everytime!
	return sal_True;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
sal_Bool SAL_CALL Desktop::setComponent(	const	Reference< XWindow >&		xComponentWindow,
				  							const	Reference< XController >&	xController		) throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::setComponent()\nNot implemented yet!\n");
	return sal_False;
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
Reference< XWindow > SAL_CALL Desktop::getComponentWindow() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::getComponentWindow()\nNot implemented yet!\n");
	return Reference< XWindow >();
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
Reference< XController > SAL_CALL Desktop::getController() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::getController()\nNot implemented yet!\n");
	return Reference< XController >();
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::contextChanged() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::contextChanged()\nNot implemented yet!\n");
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::addFrameActionListener( const Reference< XFrameActionListener >& xListener ) throw( RuntimeException )
{
	//Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Add frameaction-listener to container.
	m_aListenerContainer.addInterface( ::getCppuType( ( const Reference< XFrameActionListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	 XFrame
//*****************************************************************************************************************
void SAL_CALL Desktop::removeFrameActionListener( const Reference< XFrameActionListener >& xListener ) throw( RuntimeException )
{
	//Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Remove frameaction-listener from container.
	m_aListenerContainer.removeInterface( ::getCppuType( ( const Reference< XFrameActionListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	 XComponent
//*****************************************************************************************************************
void SAL_CALL Desktop::dispose() throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Dispose all listener and clear container.
	EventObject aDisposeEvent( (OWeakObject*)this );
	m_aListenerContainer.disposeAndClear( aDisposeEvent );
	m_aChildFramesContainer.disposeAndClear( aDisposeEvent );
}

//*****************************************************************************************************************
//	 XComponent
//*****************************************************************************************************************
void SAL_CALL Desktop::addEventListener( const Reference< XEventListener >& xListener ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Add listener to container.
	m_aListenerContainer.addInterface( ::getCppuType( ( const Reference< XEventListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	 XComponent
//*****************************************************************************************************************
void SAL_CALL Desktop::removeEventListener( const Reference< XEventListener >& xListener ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Remove listener to container.
	m_aListenerContainer.removeInterface( ::getCppuType( ( const Reference< XEventListener >*) NULL ), xListener );
}

//*****************************************************************************************************************
//	 XStatusIndicatorFactory
//*****************************************************************************************************************
Reference< XStatusIndicator > SAL_CALL Desktop::createStatusIndicator() throw( RuntimeException )
{
	OSL_ENSHURE( sal_False, "Desktop::createStatusIndicator()\nNot implemented yet!\n");
	return Reference< XStatusIndicator >();
}

//*****************************************************************************************************************
//	 protected method
//*****************************************************************************************************************
void Desktop::impl_resetObject()
{
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
sal_Bool Desktop::convertFastPropertyValue(			Any&		aConvertedValue	,
													Any&		aOldValue		,
													sal_Int32	nHandle			,
											const	Any&		aValue			) throw( IllegalArgumentException )
{
	// Ready for multithreading
	MutexGuard aGuard ( m_aMutex ) ;

	//	Safe impossible cases
//	DBG_ASSERT ( impl_debug_checkParameter ( rConvertedValue, rOldValue, nHandle, rValue ), "Desktop::convertFastPropertyValue()\nInvalid parameter detected.\n" )

	//	Check, if value of property will changed in method "setFastPropertyValue_NoBroadcast()".
	//	Return TRUE, if changed - else return FALSE.
	//	Attention:
	//		Method "impl_tryToChangeProperty()" can throw the IllegalArgumentException !!!

	//	Initialize state with FALSE !!!
	//	(Handle can be invalid)
	sal_Bool bReturn = sal_False;

	switch ( nHandle )
	{
		case PROPERTYHANDLE_ACTIVECOMPONENT		:
		case PROPERTYHANDLE_ACTIVEFRAME			:
		case PROPERTYHANDLE_ISOLOCALE			:	bReturn = sal_False; // These variables are readonly(!) and can't change.
													break;
		case PROPERTYHANDLE_HASBEAMER			:	bReturn = impl_tryToChangeProperty( m_bHasBeamer		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASCOMMONTASKBAR	:	bReturn = impl_tryToChangeProperty( m_bHasCommonTaskBar	, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASDESIGNER			:	bReturn = impl_tryToChangeProperty( m_bHasDesigner		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASEXPLORER			:	bReturn = impl_tryToChangeProperty( m_bHasExplorer		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASFUNCTIONBAR		:	bReturn = impl_tryToChangeProperty( m_bHasFunctionBar	, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASMACROBAR			:	bReturn = impl_tryToChangeProperty( m_bHasMacroBar		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASNAVIGATOR		:	bReturn = impl_tryToChangeProperty( m_bHasNavigator		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASOBJECTBAR		:	bReturn = impl_tryToChangeProperty( m_bHasObjectBar		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASOPTIONBAR		:	bReturn = impl_tryToChangeProperty( m_bHasOptionBar		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASSTATUSBAR		:	bReturn = impl_tryToChangeProperty( m_bHasStatusBar		, aValue, aOldValue, aConvertedValue );
													break;
		case PROPERTYHANDLE_HASTOOLBAR			:	bReturn = impl_tryToChangeProperty( m_bHasToolbar		, aValue, aOldValue, aConvertedValue );
													break;
	}

	// Return state of operation.
	return bReturn ;
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
void Desktop::setFastPropertyValue_NoBroadcast(			sal_Int32	nHandle	,
												const	Any&		aValue	) throw( Exception )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	//	Safe impossible cases
	//	OprpertySetHelper say	: "Handle and type of any value are valid at everyway!".
	//	But I say				: "It's better to control this."
//	DBG_ASSERT ( impl_debug_checkParameter ( nHandle, rValue ), "Desktop::setFastPropertyValue_NoBroadcast()\nInvalid parameter detected.\n" )

	// Search for right handle ... and try to set property value.
	switch ( nHandle )
	{
		case PROPERTYHANDLE_ACTIVECOMPONENT		:
		case PROPERTYHANDLE_ACTIVEFRAME			:
		case PROPERTYHANDLE_ISOLOCALE			:	OSL_ENSHURE( sal_False, "Desktop::setFastPropertyValue_NoBroadcast()\nSet of readonly property not allowed.\n" );
													break;
		case PROPERTYHANDLE_HASBEAMER			:	aValue >>= m_bHasBeamer			;
													break;
		case PROPERTYHANDLE_HASCOMMONTASKBAR	:	aValue >>= m_bHasCommonTaskBar	;
													break;
		case PROPERTYHANDLE_HASDESIGNER			:	aValue >>= m_bHasDesigner		;
													break;
		case PROPERTYHANDLE_HASEXPLORER			:	aValue >>= m_bHasExplorer		;
													break;
		case PROPERTYHANDLE_HASFUNCTIONBAR		:	aValue >>= m_bHasFunctionBar	;
													break;
		case PROPERTYHANDLE_HASMACROBAR			:	aValue >>= m_bHasMacroBar		;
													break;
		case PROPERTYHANDLE_HASNAVIGATOR		:	aValue >>= m_bHasNavigator		;
													break;
		case PROPERTYHANDLE_HASOBJECTBAR		:	aValue >>= m_bHasObjectBar		;
													break;
		case PROPERTYHANDLE_HASOPTIONBAR		:	aValue >>= m_bHasOptionBar		;
													break;
		case PROPERTYHANDLE_HASSTATUSBAR		:	aValue >>= m_bHasStatusBar		;
													break;
		case PROPERTYHANDLE_HASTOOLBAR			:	aValue >>= m_bHasToolbar		;
													break;
	}
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
void Desktop::getFastPropertyValue(	Any&		aValue	,
									sal_Int32	nHandle ) const
{
	// Ready for multithreading
	MutexGuard aGuard( Mutex::getGlobalMutex() );

	//	Safe impossible cases
	//	OprpertySetHelper say	: "Handle and type of any value are valid at everyway!".
	//	But I say				: "It's better to control this."
//	DBG_ASSERT ( impl_debug_checkParameter ( nHandle, rValue ), "Desktop::setFastPropertyValue_NoBroadcast()\nInvalid parameter detected.\n" )

	// Search for right handle ... and try to set property value.
	switch ( nHandle )
	{
		case PROPERTYHANDLE_ACTIVECOMPONENT		:   aValue <<= m_xActiveComponent	;
													break;
		case PROPERTYHANDLE_ACTIVEFRAME			:   aValue <<= m_xActiveFrame		;
													break;
		case PROPERTYHANDLE_HASBEAMER			:	aValue <<= m_bHasBeamer			;
													break;
		case PROPERTYHANDLE_HASCOMMONTASKBAR	:	aValue <<= m_bHasCommonTaskBar	;
													break;
		case PROPERTYHANDLE_HASDESIGNER			:	aValue <<= m_bHasDesigner		;
													break;
		case PROPERTYHANDLE_HASEXPLORER			:	aValue <<= m_bHasExplorer		;
													break;
		case PROPERTYHANDLE_HASFUNCTIONBAR		:	aValue <<= m_bHasFunctionBar	;
													break;
		case PROPERTYHANDLE_HASMACROBAR			:	aValue <<= m_bHasMacroBar		;
													break;
		case PROPERTYHANDLE_HASNAVIGATOR		:	aValue <<= m_bHasNavigator		;
													break;
		case PROPERTYHANDLE_HASOBJECTBAR		:	aValue <<= m_bHasObjectBar		;
													break;
		case PROPERTYHANDLE_HASOPTIONBAR		:	aValue <<= m_bHasOptionBar		;
													break;
		case PROPERTYHANDLE_HASSTATUSBAR		:	aValue <<= m_bHasStatusBar		;
													break;
		case PROPERTYHANDLE_HASTOOLBAR			:	aValue <<= m_bHasToolbar		;
													break;
		case PROPERTYHANDLE_ISOLOCALE			:	aValue <<= m_aISOLocale			;
	}
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
IPropertyArrayHelper& Desktop::getInfoHelper()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfoHelper is NULL - for the second call pInfoHelper is different from NULL!
	static OPropertyArrayHelper* pInfoHelper = NULL;

	if ( pInfoHelper == NULL )
	{
		// Ready for multithreading
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		// Control this pointer again, another instance can be faster then these!
		if ( pInfoHelper == NULL )
		{
			// Define static member to give structure of properties to baseclass "OPropertySetHelper".
			// "impl_getStaticPropertyDescriptor" is a non exported and static funtion, who will define a static propertytable.
			// "sal_True" say: Table is sorted by name.
			static OPropertyArrayHelper aInfoHelper( impl_getStaticPropertyDescriptor(), sal_True );
			pInfoHelper = &aInfoHelper;
		}
	}

	return (*pInfoHelper);
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
Reference< XPropertySetInfo > SAL_CALL Desktop::getPropertySetInfo ()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfo is NULL - for the second call pInfo is different from NULL!
	static Reference< XPropertySetInfo >* pInfo = NULL ;

	if ( pInfo == NULL )
	{
		// Ready for multithreading
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		// Control this pointer again, another instance can be faster then these!
		if ( pInfo == NULL )
		{
			// Create structure of propertysetinfo for baseclass "OPropertySetHelper".
			// (Use method "getInfoHelper()".)
			static Reference< XPropertySetInfo > xInfo( createPropertySetInfo( getInfoHelper() ) );
			pInfo = &xInfo;
		}
	}

	return (*pInfo);
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
Reference< XComponent > Desktop::impl_getFrameComponent( const Reference< XFrame >& xFrame )
{
	// Set default return value, if method failed.
	Reference< XComponent > xComponent = Reference< XComponent >();
	// Does no controller exists?
	Reference< XController > xController = xFrame->getController();
	if ( xController.is() == sal_False )
	{
		// Controller not exist - use the VCL-component.
		xComponent = Reference< XComponent >( xFrame->getComponentWindow(), UNO_QUERY );
	}
	else
	{
		// Does no model exists?
		Reference< XModel > xModel( xController->getModel(), UNO_QUERY );
		if ( xModel.is() == sal_True )
		{
			// Model exist - use the model as component.
			xComponent = Reference< XComponent >( xModel, UNO_QUERY );
		}
		else
		{
			// Model not exist - use the controller as component.
			xComponent = Reference< XComponent >( xController, UNO_QUERY );
		}
	}

	return xComponent;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
sal_Bool Desktop::impl_tryToChangeProperty(			sal_Bool	bProperty		,
											const	Any&		aValue			,
													Any&		aOldValue		,
													Any&		aConvertedValue	) throw( IllegalArgumentException )
{
	// Set default return value.
	sal_Bool bReturn = sal_False;

	// Clear information of return parameter!
	aOldValue.clear();
	aConvertedValue.clear();

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	sal_Bool bNewValue;
	convertPropertyValue( bNewValue, aValue );

	// If value change ...
	if ( bNewValue != bProperty )
	{
		// ... set information of change.
		// Attention:	Use setValue and getCppuBooleanType to set value in any!
		//				It's necessary, if BOOL can be int or char.
		aOldValue.setValue		( &bProperty, ::getCppuBooleanType() );
		aConvertedValue.setValue( &bNewValue, ::getCppuBooleanType() );
		// Return OK - "value will be change ..."
		bReturn = sal_True;
	}

	return bReturn;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
const Sequence< Property > Desktop::impl_getStaticPropertyDescriptor()
{
	// Create a new static property array to initialize sequence!
	// Table of all predefined properties of this class. Its used from OPropertySetHelper-class!
	// Don't forget to change the defines (see begin of this file), if you add, change or delete a property in this list!!!
	// It's necessary for methods of OPropertySetHelper.
	// ATTENTION:
	//		YOU MUST SORT FOLLOW TABLE BY NAME !!!

	static const Property pPropertys[] =
	{
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_ACTIVECOMPONENT	)), PROPERTYHANDLE_ACTIVECOMPONENT	, ::getCppuType((const Reference< XComponent >*)NULL)	, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_ACTIVEFRAME		)), PROPERTYHANDLE_ACTIVEFRAME		, ::getCppuType((const Reference< XComponent >*)NULL)	, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASBEAMER		)), PROPERTYHANDLE_HASBEAMER		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASCOMMONTASKBAR)), PROPERTYHANDLE_HASCOMMONTASKBAR	, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASDESIGNER		)), PROPERTYHANDLE_HASDESIGNER		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASEXPLORER		)), PROPERTYHANDLE_HASEXPLORER		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASFUNCTIONBAR	)), PROPERTYHANDLE_HASFUNCTIONBAR	, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASMACROBAR		)), PROPERTYHANDLE_HASMACROBAR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASNAVIGATOR	)), PROPERTYHANDLE_HASNAVIGATOR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASOBJECTBAR	)), PROPERTYHANDLE_HASOBJECTBAR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASOPTIONBAR	)), PROPERTYHANDLE_HASOPTIONBAR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASSTATUSBAR	)), PROPERTYHANDLE_HASSTATUSBAR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_HASTOOLBAR		)), PROPERTYHANDLE_HASTOOLBAR		, ::getBooleanCppuType()								, PropertyAttribute::TRANSIENT								),
		Property( OUString(RTL_CONSTASCII_USTRINGPARAM(PROPERTYNAME_ISOLOCALE		)), PROPERTYHANDLE_ISOLOCALE		, ::getCppuType((const Locale*)NULL)					, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY),
	};
	// Use it to initialize sequence!
	static const Sequence< Property > seqPropertyDescriptor( pPropertys, PROPERTYCOUNT );
	// Return static "PropertyDescriptor"
	return seqPropertyDescriptor ;
}

//_________________________________________________________________________________________________________________
//	debug methods
//_________________________________________________________________________________________________________________

/*-----------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact Andreas Schluens [as] or add it himself !(?)
		But ... look for right testing! See using of this methods!
-----------------------------------------------------------------------------------------------------------------*/

#ifdef DBG_UTIL
/*
//*****************************************************************************************************************
sal_Bool Desktop::impldbg_checkParameter_append( const Reference< XFrame >& xFrame )
{
	// Set default return value.
	sal_Bool bOK = sal_True;

	// Check parameter.
	if	(
			( &xFrame		==	NULL		)	||
			( xFrame.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}

	// Return result of check.
	return bOK ;
}
*/
#endif	// #ifdef DBG_UTIL

}	// namespace framework
