#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:11:09 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..

PRJNAME=			framework
TARGET=				fwk
USE_DEFFILE=		TRUE
ENABLE_EXCEPTIONS=	TRUE
NO_BSYMBOLIC=		TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk
.INCLUDE :  version.mk

.IF "$(COM)"=="ICC"
LINKFLAGS+=/SEGMENTS:1024 /PACKD:32768
.ENDIF

# --- DLL Services --------------------------------------------------------

LIB1TARGET=		$(SLB)$/$(TARGET).lib
LIB1ARCHIV=		$(LB)$/lib$(TARGET).a

LIB1FILES=		$(SLB)$/fwk_services.lib	\
				$(SLB)$/fwk_classes.lib

SHL1TARGET=		$(FRAMEWORK_TARGET)$(FRAMEWORK_MAJOR)
SHL1IMPLIB=		i$(TARGET)

SHL1LIBS=		$(LIB1TARGET)

SHL1STDLIBS=	$(CPPULIB)					\
				$(CPPUHELPERLIB)			\
				$(VOSLIB)					\
				$(SALLIB)

SHL1DEF=		$(MISC)$/$(SHL1TARGET).def

DEF1NAME=		$(SHL1TARGET)

# --- Applikation --------------------------------------------------------

APP1TARGET= 	framework

APP1OBJS=		$(SLO)$/framework.obj

APP1STDLIBS=	$(SLB)$/fwk_classes.lib		\
				$(CPPULIB)					\
				$(CPPUHELPERLIB)			\
				$(OSLLIB)					\
				$(SALLIB)					\
				$(VOSLIB)					\
				$(TOOLSLIB) 				\
				$(SVTOOLLIB)				\
				$(TKLIB)					\
				$(UNOTOOLSLIB)				\
				$(SVLIB)

APP1DEPN=		$(SLB)$/fwk_classes.lib

.IF "$(GUI)"=="WIN" || "$(GUI)"=="OS2"
APP1DEF=		$(MISC)$/framework.def
.ENDIF

# --- Exports ------------------------------------------------------

.IF "$(GUI)"=="WNT"
DEF1EXPORT1 = component_getImplementationEnvironment
DEF1EXPORT2 = component_writeInfo
DEF1EXPORT3 = component_getFactory
.ELSE
.IF "$(COM)"=="ICC"
DEF1EXPORT1 = component_getImplementationEnvironment
DEF1EXPORT2 = component_writeInfo
DEF1EXPORT3 = component_getFactory
.ELSE
DEF1EXPORT1 = _component_getImplementationEnvironment
DEF1EXPORT2 = _component_writeInfo
DEF1EXPORT3 = _component_getFactory
.ENDIF
.ENDIF

# --- Targets ------------------------------------------------------

.INCLUDE :	target.mk
