/*************************************************************************
 *
 *  $RCSfile: vcattr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_VCATTR_HXX
#define _SVX_VCATTR_HXX

#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif

#define VCPOINTER_DEFAULT		0
#define VCPOINTER_ARROW         1
#define VCPOINTER_CROSS         2
#define VCPOINTER_IBEAM         3
#define VCPOINTER_ICON          4
#define VCPOINTER_SIZE          5
#define VCPOINTER_NE_SW         6
#define VCPOINTER_N_S           7
#define VCPOINTER_NW_SE         8
#define VCPOINTER_W_E           9
#define VCPOINTER_UPARROW       10
#define VCPOINTER_HOURGLASS     11
#define VCPOINTER_NODROP        12

#define VCMULTI_SINGLE			0
#define VCMULTI_SIMPLEMULTI     1
#define VCMULTI_EXTMULTI        2

#define VCBACK_TRANSPARENT		0
#define VCBACK_OPAQUE 			1

#define VCALIGN_LEFT			0
#define VCALIGN_RIGHT           1
#define VCALIGN_CENTER       	2

#define VCBTNALIGN_LEFT			0
#define VCBTNALIGN_RIGHT 		1

#define VCCOMBO_DDLIST			0
#define VCCOMBO_COMBO			1
#define VCCOMBO_DDCOMBO			2

#define VCFORMACTION_NONE		0
#define VCFORMACTION_SUBMIT		1
#define VCFORMACTION_RESET		2

// kein automatischer Zeilenumbruch. Value des Controls enthaelt Umbrueche
#define VCWORDWRAP_OFF			0
// Automatischer Zeilenumbruch. Value des Controls enthaelt Umbrueche
#define VCWORDWRAP_HARD			1
// Automatischer Zeilenumbruch. Value des Controls enthaelt keine Umbrueche
#define VCWORDWRAP_SOFT			2

//------------------
// class VCItemPool
//------------------
class VCItemPool : public SfxItemPool
{
public:
			VCItemPool();
			~VCItemPool();
};

#ifdef _SI_VCITEMS
#include <vcalgit.hxx>
#include <vcbalgit.hxx>
#include <vccbstit.hxx>
#include <vcedit.hxx>
#include <vcfmacit.hxx>
#include <vcinliit.hxx>
#include <vcmpit.hxx>
#include <vcmselit.hxx>
#include <vcnkstit.hxx>
#include <vcurlit.hxx>
#include <vcwwit.hxx>
#endif



#endif //_VCATTR_HXX
