/*************************************************************************
 *
 *  $RCSfile: vccbbox.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _SVX_VCCBBOX_HXX
#define _SVX_VCCBBOX_HXX

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _VCTRLS_HXX //autogen
#include <vctrls.hxx>
#endif
//------------------
// class VCComboBox
//------------------
class VCComboBox : public VCControl
{
protected:
	virtual void    Create();
	INT16           nNewIndex;
#if SUPD >=350
	SvPtrarr*       pOptionsArray;
#endif

public:
	TYPEINFO();

				VCComboBox( VCContainer* pContainer, VCItemPool* pPool,
						   BOOL bReal=FALSE, VCSbxControl* pCtrl = 0  );
				~VCComboBox();

	virtual String GetClassName() const;
	virtual String  GetClassNamePlural() const;

	USHORT      GetStyle() const;

	void        SetText( const String& rText );
	String      GetText() const;
	USHORT      InsertEntry( const String& rStr, ULONG nPos=LIST_APPEND );
	USHORT      InsertEntry( const String& rStr, const String& rItemData,
							ULONG nPos=LIST_APPEND );
	void        ReplaceEntry( const String& rStr, ULONG nPos );
	void        RemoveEntry( ULONG nPos );
	String      GetEntry( ULONG nPos );
	ULONG       GetEntryCount() const;
	String      GetSelectEntry() const;
	void        Clear();

	void        SelectEntryPos( ULONG nPos, BOOL bSelect=TRUE );

	ULONG       GetEntryPos( const String& rEntry ) const;
	// Fuer JavaScript-Anbindung:
	void        SetItemData( const String& rStr, ULONG nPos ) const;
	String      GetItemData( ULONG nPos ) const;

	virtual Size    GetOptSize( OutputDevice* pOut = 0 ) const;
	virtual void    Reset();
	virtual void    SaveResetValue();
	void            SetDefaultText( const String& );
	String          GetDefaultText() const;
	void            SetDefaultChecked( USHORT, BOOL );
	USHORT          GetDefaultChecked() const;

	INT16       GetNewIndex() const { return nNewIndex; }
	void        SetNewIndex( INT16 nNewIdx ) { nNewIndex = nNewIdx; }

	// Schnittstelle fuer JScript-Options-Array
#if SUPD >=350
	SvPtrarr* GetOptions()
	{
		if( !pOptionsArray )
			CreateOptionsArray();
		return pOptionsArray;
	}
#endif
	void            CreateOptionsArray();

	void            Focus();
	void            Blur();
	virtual void	SetValue( const String& );
	virtual String	GetValue() const;
	BOOL			IsSorted() const;
};

#endif

