/*************************************************************************
 *
 *  $RCSfile: vcdrmod.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _SVX_SIVCDRMOD_HXX
#define _SVX_SIVCDRMOD_HXX

#ifndef _ERRCODE_HXX //autogen
#include <tools/errcode.hxx>
#endif

#include <svx/svdmodel.hxx>

class VCItemPool;
class VCDrawPage;
class SbxValue;
class SbxObject;
class SjJSbxObject;
class SbxArray;
class Window;

#ifndef _SI_NOVCDRAWMODEL

//-------------------
// class VCDrawModel
//-------------------

class SfxObjectShell;

class VCDrawModel : public SdrModel
{
friend class VCDrawPage;
private:
	VCItemPool*	pVCItemPool;
	USHORT	nVCFlags;

	SfxObjectShell*	pObjectShell;
	Link aURLLink;

	VCDrawModel( const VCDrawModel& );
	void operator=(const VCDrawModel& rSrcModel);
	FASTBOOL operator==(const VCDrawModel& rCmpModel) const;

public:
	TYPEINFO();

	VCDrawModel(SfxItemPool* pPool=NULL, SvPersist* pPers=NULL,
				VCItemPool* pVCPool=NULL );
	VCDrawModel(const String& rPath, SfxItemPool* pPool=NULL,
				SvPersist* pPers=NULL, VCItemPool* pVCPool=NULL );
	VCDrawModel(SfxItemPool* pPool, SvPersist* pPers, FASTBOOL bUseExtColorTable,
				VCItemPool* pVCPool=NULL );
	VCDrawModel(const String& rPath, SfxItemPool* pPool, SvPersist* pPers,
				FASTBOOL bUseExtColorTable, VCItemPool* pVCPool=NULL);
	virtual ~VCDrawModel();

	VCItemPool*  GetVCItemPool();

	// ruft SetChanged auf!! Aufgabe: Der Writer kann nicht SetChanged
	// ueberladen, da diese Funktion auch beim Umformatieren
	// des Textes (veraendert im Writer-Sinne nicht das Model!)
	// gerufen wird, und deshalb an sehr vielen Stellen abgeklemmt
	// werden muesste.
	virtual void VCDrawModelChanged( FASTBOOL bChanged = TRUE );

	SfxObjectShell* GetObjectShell() const { return pObjectShell; }
	void SetObjectShell( SfxObjectShell* pShell ) { pObjectShell = pShell; }

	virtual SdrPage*  AllocPage(FASTBOOL bMasterPage);

	// Handler-Decl in App: DECL_LINK( MyURLHandler, VCURLButton* )
	const Link&		GetURLHdl() const { return aURLLink; }
	void			SetURLHdl( const Link& rLink ) { aURLLink = rLink; }

#if SUPD < 352
	virtual ErrCode CallBasic( const String& rMacro,
		const String& rBasicName, SbxObject* pVCtrl, SbxArray* pArgs = 0,
		SbxObject* pRet = 0 );
#else
	virtual ErrCode CallBasic( const String& rMacro,
		const String& rBasicName, SbxObject* pVCtrl, SbxArray* pArgs = 0,
		SbxValue* pRet = 0 );
#endif

	virtual ErrCode CallJavaScript(
		const String& rMacro, SjJSbxObject* pJavaScriptThis = 0,
		const String* pArgs = 0, const String* pRet = 0 );

	virtual SjJSbxObject* GetJScriptDocument();
	virtual Window* GetCurDocViewWin();
};

#endif
#endif

