/*************************************************************************
 *
 *  $RCSfile: vcdrwobj.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _SVX_VCDRWOBJ_HXX
#define _SVX_VCDRWOBJ_HXX

#ifndef _VCDRWOBJ_DEFINES_ONLY

#ifndef _LINK_HXX //autogen
#include <tools/link.hxx>
#endif
#ifndef _SVDUNDO_HXX //autogen
#include "svx/svdundo.hxx"
#endif
#ifndef _SVDPAGE_HXX //autogen
#include "svx/svdpage.hxx"
#endif
#ifndef _SVX_VCSBX_HXX //autogen
#include "vcsbx.hxx"
#endif
#ifndef _SVDOBJ_HXX //autogen
#include "svx/svdobj.hxx"
#endif

class SfxPoolItem;

#else

#ifndef _TOOLS_SOALR_H
#include <tools/solar.h>
#endif

#endif

class SjJSbxObject;
class SbxValue;


#ifndef _VCDRWOBJ_DEFINES_ONLY

//--------------------------
// class VCDrwFactory
//--------------------------
class SdrObjFactory;

class VCDrwFactory
{
protected:
	Link aOldMakeObjLink;

public:
	VCDrwFactory() {}

	void SetOldMakeObjHdl( const Link& rLink ) { aOldMakeObjLink = rLink; }
	Link GetOldMakeObjHdl() const { return aOldMakeObjLink; }

	DECL_LINK( MakeObject, SdrObjFactory * );
};

//------------------
// class VCUndoItem
//------------------
class VCSbxDrawObject;

class VCUndoItem : public SdrUndoObj
{
protected:
	SfxPoolItem*	pItem;

public:
	VCUndoItem( SdrObject* pObj, const SfxPoolItem& rItem );
	~VCUndoItem();

	virtual void	Undo();
	virtual void	Redo();
};

#ifndef _SI_NOVCDRAWPAGE

//------------------
// class VCDrawPage
//------------------
class VCManager;
class StarBASIC;
class VCForm;
class VCDrawModel;
class SjJSbxArrayObject;
class SfxJSArray;

class VCDrawPage : public SdrPage
{
friend class VCSbxDrawObject;
friend class VCLinkHdl;

protected:
	StarBASIC*      pBasic;
	VCSbxFormRef    pSbxForm;
	VCManager*      pVCManager;
	String          aPageName;
	BOOL			bDeleteSbxObject;
	VCItemPool*		pPool;
	VCLinkHdl*		pLinkHdl;
	void			ImpGetLinkData( VCContainer* pContainer );
	void			ImpSetLinkData( VCContainer* pContainer );

public:
	TYPEINFO();

	VCDrawPage( VCDrawModel& rModel, StarBASIC* pBasic, FASTBOOL bMasterPage=FALSE );
	VCDrawPage( const VCDrawPage& );
	~VCDrawPage();

	void            SetName(const String& rPageName);
	const String&   GetName() const { return aPageName; }

	void			SetBasic( StarBASIC* pBas );
	StarBASIC*      GetBasic() const { return pBasic; }
	VCSbxFormRef    GetSbxForm();
	void            SetSbxForm( VCSbxFormRef pForm );

	BOOL			RequestHelp( Window* pWin, SdrView* pView,
								 const HelpEvent& rEvt );
	virtual void	RequestBasic();

	BOOL			IsDeleteSbxObject() const { return bDeleteSbxObject; }
	void			SetDeleteSbxObject( BOOL bDelete = TRUE ) { bDeleteSbxObject = bDelete; }

	virtual String	GetLinkData( const String& rLinkName );
	virtual	void	SetLinkData( const String& rLinkName, const String& rLinkData );
	virtual void	UpdateLinkData( const String& rLinkName, const String& rLinkData );

	virtual void  	WriteData(SvStream& rOut) const;
	virtual void  	ReadData(const SdrIOHeader& rHead, SvStream& rIn);
	virtual void  	SetModel(SdrModel* pNewModel);

	VCManager*      GetVCManager() const { return pVCManager; }
	virtual SdrPage* Clone() const;
};

#endif



#if defined(SI_VCDLGOBJ) || defined(_SI_VCDLGOBJ)

//-------------------------
// class VCSbxDialogObject
//-------------------------
class VCSbxDialog;
class VCSbxDialogObject : public SdrObject
{
protected:
	VCSbxDialog*    pForm;

	virtual void    NbcMove( const Size& rSize );
	virtual void    NbcResize( const Point& rRef, const Fraction& xFract, const Fraction& yFract );

public:
	TYPEINFO();

	VCSbxDialogObject( VCSbxDialog* pForm );
	~VCSbxDialogObject();

	virtual FASTBOOL Paint( ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec ) const;
	virtual FASTBOOL EndCreate( SdrDragStat& rStat, SdrCreateCmd eCmd );

	virtual SdrObject* CheckHit(const Point& rPnt,USHORT nTol,const SetOfByte*) const;
	virtual void	 TakeObjInfo( SdrObjTransformInfoRec& rInfo ) const;
	virtual void	 TakeObjNameSingul( String& rName ) const;
	virtual void	 TakeObjNamePlural( String& rName ) const;

	virtual void    RecalcBoundRect();
	virtual void    RestGeoData(const SdrObjGeoData& rGeo);

	VCSbxDialog*    GetForm() { return pForm; }

	virtual SfxItemSet* GetItemSet();
	virtual void        SetItemSet( SfxItemSet* pItemSet );
	virtual void        UpdateItem( USHORT nWhich );

	UINT32          GetObjInventor() const;
	UINT16          GetObjIdentifier() const;

	void            SetRectsDirty(FASTBOOL bNotMyself=FALSE);
};

#endif // SI_VCDLGOBJ

#endif //  _VCDRWOBJ_DEFINES_ONLY


#endif //_VCDRWOBJ_HXX
