/*************************************************************************
 *
 *  $RCSfile: vcform.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif


#ifndef _SVX_VCFORM_HXX
#define _SVX_VCFORM_HXX

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

class VCControl;
class SjJSbxObject;
class JScriptResult;
class SvxMacroTableDtor;
class VCPushButton;
class SvLockBytes;

#define FORMMETH_GET		1
#define FORMMETH_POST		2

#define BTN_RESULTTYPE_NONE			0
#define BTN_RESULTTYPE_IMAGE		1
#define BTN_RESULTTYPE_STRING		2

class VCForm
{
friend class VCControl; // Controls fuegen sich selbst in Liste ein
friend class ImpSjJScriptFormObject;	// submit/reset von JavaScript rufen

	List			aCtrlList;
	Rectangle		aRect;
	String			aURL;
	String			aName;
	USHORT			nMethod;
	String			aEncoding;
	String			aTargetName;
	String			aSubmitMacro;
	String			aResetMacro;
	String			aDummyMacro1;
	String			aDummyMacro2;

#if SUPD > 352
	SvxMacroTableDtor* pMacros;
#endif
	// gibt Anzahl der durch CR (13) getrennten Elemente zurueck;
	// 0 == String leer bzw. Control nicht angewaehlt (CheckBox,Radiobutton)
	USHORT			GetValueAsString( VCControl* pCtrl, String& rResult ) const;
	void			Encode( String& ) const;
	BOOL			Execute_Impl( VCControl* ) const;
	void			Reset_Impl( void );
	BOOL			ExecuteHandler( USHORT nHandlerId, ErrCode* pErrCode=NULL );

	// Rueckgabewert siehe BTN_RESULTTYPE_*
	USHORT 			GetButtonValue(
						VCPushButton* pButton, // any Button of Form
						VCPushButton* pPushedButton, // currently pressed Submitbutton
						Point& rImageBtnValue, String& rPushBtnValue ) const;

	// application/x-www-form-urlencoded
	String 			GetDataURLEncoded( VCControl* pSubmitButton ) const;
	// multipart/form-data
	SvLockBytes*	GetDataMultiPartEncoded( VCControl* pSubmitButton,
						String& rContentType ) const;

public:
					VCForm( const String& rURL, USHORT nMethod, const String& rEncoding, String* pName = 0 );
					VCForm();
					~VCForm();
	String 			GetData( VCControl* pSubmitButton ) const;
	BOOL 			Execute( VCControl* pSubmitButton ) const;
	BOOL			ExecuteDefault() const;
	void			Reset();

	const String& 	GetURL() const { return aURL; }
	void 			SetURL( const String& rURL ) { aURL = rURL; }
	void 			SetName( const String& );
	const String& 	GetName() const { return aName; }
	USHORT 			GetMethod() const { return nMethod; }
	void 			SetMethod( USHORT nMeth ) { nMethod = nMeth; }
	const String&	GetEncoding() const { return aEncoding; }
	void			SetEncoding( const String& rStr ) { aEncoding = rStr; }
	const String&	GetTargetName() const { return aTargetName; }
	void			SetTargetName( const String& rStr ) { aTargetName = rStr; }

	ULONG 			Count() const { return aCtrlList.Count(); }
	VCControl* 		GetControl( ULONG nCtrl ) const { return (VCControl*)aCtrlList.GetObject(nCtrl); }
	VCControl* 		GetControl( const String & aName ) const;
	BOOL 			Contains( VCControl* ) const;
	// fuer Tabsteuerung o.ae., geht _zyklisch_ ueber die Controls
	VCControl*		Next(VCControl* pStart,BOOL bReverse=FALSE,BOOL bSameType=TRUE) const;
	BOOL			IsStandardForm() const;

	friend SvStream& operator<<(SvStream& rOut, const VCForm& rCtrl);
	friend SvStream& operator>>(SvStream& rIn, VCForm& rCtrl);

	void			SetSubmitMacro( const String& rMacro ) { aSubmitMacro=rMacro; }
	const String&	GetSubmitMacro() const { return aSubmitMacro; }

	void			SetResetMacro( const String& rMacro ) { aResetMacro=rMacro; }
	const String&	GetResetMacro() const { return aResetMacro; }

	virtual void	NotifySubmit();
	virtual void	NotifyReset();

	BOOL			_NotifySubmit();
	BOOL			_NotifyReset();

	void			SetHandlers( const SvxMacroTableDtor& );
#if SUPD > 352
	const SvxMacroTableDtor& GetHandlers() const { return *pMacros; }
#endif
};



#endif //_VCFORM_HXX


