/*************************************************************************
 *
 *  $RCSfile: vcsbx.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _SVX_VCSBX_HXX
#define _SVX_VCSBX_HXX

#include <vcsbxdef.hxx>
#include <vcsbxctl.hxx>

class OutputDevice;
class Dialog;
class MouseEvent;
class KeyEvent;
class Control;
class Window;
class Bitmap;
class Point;
class Size;

/*
Defines zum Ausblenden einzelner Elemente

#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON
*/


class VCContainer;

#ifndef _SI_NOVCSBXFORM
//-----------------
// class VCSbxForm
//-----------------
class VCControl;
class VCButton;
class VCItemPool;
class SfxItemSet;


SV_DECL_REF(VCSbxForm)

class VCSbxForm : public SbxObject
{
friend class VCDrawPage;
	// wird von operator>> & VCDrawPage::SetModel() benoetigt
	void	SetPool( VCItemPool* pNewPool, BOOL bOwnsPool );
protected:
	VCContainer*		pContainer;
	VCItemPool*			pPool;
	SfxItemSet*			pItemSet;
	SfxItemSet*			pRunTimeItemSet;
	BOOL				bDeletePool;

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST( SBXCR_VC, SBXID_FORM, 1 );

		VCSbxForm( VCContainer* pContainer, VCItemPool* pPool=NULL );
		~VCSbxForm();

		virtual void	SetParent( SbxObject* pParent );

		SbxVariable*	Find( const String& rName, SbxClassType eType );
		virtual const String& GetName( SbxNameType=SbxNAME_NONE ) const;
		virtual void          SetName( const String& rName );

		VCContainer* GetVCContainer() const { return pContainer; }
		VCItemPool*  GetPool() const { return pPool; }

		SfxItemSet* 	GetItemSet() const { return pItemSet; }
		virtual void	SetItemSet( SfxItemSet* pItemSet );
		virtual void	UpdateItem( USHORT nWhich );

		virtual void	SetPos( const Point& rPos, BOOL bMoveChilds=TRUE );
		Point			GetPos() const;
		virtual void	SetSize( const Size& rSize );
		Size			GetSize() const;

		virtual void	Draw( OutputDevice* pOut );

		static VCItemPool* GetGenericVCPool();

		friend SvStream& operator<<(SvStream& rOut, const VCSbxForm& rSbxForm );
		friend SvStream& operator>>(SvStream& rIn, VCSbxForm& rSbxForm );
};

SV_IMPL_REF(VCSbxForm)


#if !defined(SI_NOOTHERFORMS) && !defined(_SI_NOOTHERFORMS)


//-------------------
// class VCSbxDialog
//-------------------
class VCSbxDialogObject;

SV_DECL_REF(VCSbxDialog)

class VCSbxDialog : public VCSbxForm
{
friend class VCSbxControl; // fuer MethodLoad (on demand load von Dialogen)

private:

#ifdef _VCSBXDIALOG_CXX
	void				MethodLoad( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodUnload( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodShow( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodHide( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodMove( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodRefresh( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				MethodSetFocus( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 				PropOutputWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 				PropOutputHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void				CreateSVDialog();
	void				DeleteSVDialog();
	void				UpdateSVDialog( USHORT nWhich=0 );
	void				SortControls();
	ErrCode				ExecuteHandler( USHORT, const MouseEvent* = 0,
							const KeyEvent* = 0 );
#endif

protected:
	VCSbxDialogObject*	pDrawObject;
	Dialog*				pDlg;
	BOOL				bTestMode;
	USHORT				nInCallBack;
	BOOL				bMarkToUnload;


	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
						TYPEINFO();
						SBX_DECL_PERSIST( SBXCR_VC, SBXID_DIALOG, 1 );

						VCSbxDialog();
						~VCSbxDialog();

	SbxVariable*		Find( const String& rName, SbxClassType eType );
	virtual BOOL 		Call( const String&, SbxArray* = NULL );

	void				SetPos( const Point& rPos, BOOL bMoveChilds=TRUE );
	void				SetSize( const Size& rSize );
	void				SetPosDefault();
	long				GetCaptionHeight() const;

	void				SetDrawObject( VCSbxDialogObject* pDrwObj );
	VCSbxDialogObject*  GetDrawObject() const { return pDrawObject; }

	virtual void		UpdateItem( USHORT nWhich );

	long				GetCurStep() const;
	void				SetCurStep( long nStep );
	BOOL				IsSVLook() const;

	virtual void 		Draw( OutputDevice* pOut );

	void				EnableTestMode( BOOL bEnable=TRUE );
	BOOL				IsTestModeEnabled() const { return bTestMode; }
	void				SnapShot( Bitmap& );
	void				SetInCallBack( BOOL bInCallBack=TRUE );
	BOOL				IsInCallBack() const;
	void				SetMarkToUnload( BOOL bMark=TRUE ) { bMarkToUnload=bMark; }
	BOOL				IsMarkToUnload() const { return bMarkToUnload; }


	Dialog*				GetDialog() const { return pDlg; }

	void				Activate();
	void				Deactivate();
	void	            GetFocus();
	void				LoseFocus();
	void				MouseButtonDown( const MouseEvent& rMEvt );
	void				MouseButtonUp( const MouseEvent& rMEvt );
	void				MouseMove( const MouseEvent& rMEvt );
	void				KeyInput( const KeyEvent& rKEvt );
	void				Resize();
	void				Load();
	void				Unload();
	void				PrepareDelete();

	friend SvStream& 	operator<<(SvStream& rOut, const VCSbxDialog& rSbxDialog );
	friend SvStream& 	operator>>(SvStream& rIn, VCSbxDialog& rSbxDialog );
};

SV_IMPL_REF( VCSbxDialog )

#endif  //SI_NOOTHERFORMS
#endif  //_SI_NOVCSBXFORM


#if !defined(SI_NOSBXCONTROLS) && !defined(_SI_NOSBXCONTROLS)


#ifndef _SI_NOVCSBXBUTTON
//-------------------
// class VCSbxButton
//-------------------
class VCSbxButton : public VCSbxControl
{
protected:
	VCSbxButton();
	~VCSbxButton();

public:
	virtual void UpdateSVControl( USHORT nWhich=0 );
};
#endif


#ifndef _SI_NOVCSBXCHECKBOX
//---------------------
// class VCSbxCheckBox
//---------------------
class VCSbxCheckBox : public VCSbxButton
{
protected:
		void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_CHECKBOX, 1 );

		VCSbxCheckBox( BOOL bReal=FALSE );
		~VCSbxCheckBox();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXRADIOBUTTON
//------------------------
// class VCSbxRadioButton
//------------------------
class VCSbxRadioButton : public VCSbxButton
{
protected:
		void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_RADIOBUTTON, 1 );

		VCSbxRadioButton( BOOL bReal=FALSE );
		~VCSbxRadioButton();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXPUSHBUTTON
//-----------------------
// class VCSbxPushButton
//-----------------------
class VCSbxPushButton : public VCSbxButton
{
protected:
		void PropValue( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );

		void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT );
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_PUSHBUTTON, 1 );

		VCSbxPushButton( BOOL bReal=FALSE );
		~VCSbxPushButton();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXSPINBUTTON
//-----------------------
// class VCSbxSpinButton
//-----------------------
class VCSbxSpinButton : public VCSbxButton
{
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_SPINBUTTON, 1 );

		VCSbxSpinButton( BOOL bReal=FALSE );
		~VCSbxSpinButton();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXFIXEDTEXT
//----------------------
// class VCSbxFixedText
//----------------------
class VCSbxFixedText : public VCSbxControl
{
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_FIXEDTEXT, 1 );

		VCSbxFixedText( BOOL bReal=FALSE );
		~VCSbxFixedText();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXGROUPBOX
//---------------------
// class VCSbxGroupBox
//---------------------
class VCSbxGroupBox : public VCSbxControl
{
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_GROUPBOX, 1 );

		VCSbxGroupBox( BOOL bReal=FALSE );
		~VCSbxGroupBox();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXLISTBOX
//--------------------
// class VCSbxListBox
//--------------------
class VCSbxListBox : public VCSbxControl
{
private:

#ifdef _VCSBXLBOX_CXX
	void 	PropList( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 	PropListCount( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropListIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 	PropItemData( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 	PropText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void    PropNewIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropSelected( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropTopIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodAddItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodClear( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodRemoveItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
#endif

protected:

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_LISTBOX, 1 );

		VCSbxListBox( BOOL bReal=FALSE );
		~VCSbxListBox();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
		virtual void DeleteSVControl();
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXCOMBOBOX
//---------------------
// class VCSbxComboBox
//---------------------
class VCSbxComboBox : public VCSbxControl
{
private:
#ifdef _VCSBXCBOX_CXX
	void	PropList( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropListCount( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropListIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 	PropItemData( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void    PropNewIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void 	PropSelLen( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropSelStart( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropSelText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodAddItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodClear( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodRemoveItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
#endif
protected:

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_COMBOBOX, 1 );

		VCSbxComboBox( BOOL bReal=FALSE );
		~VCSbxComboBox();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
		virtual void DeleteSVControl();
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXEDIT
//-----------------
// class VCSbxEdit
//-----------------
class VCSbxEdit : public VCSbxControl
{
private:
#ifdef _VCSBXEDIT_CXX
	void 	PropSelLen( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropSelStart( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropSelText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
#endif
protected:

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_EDIT, 1 );

		VCSbxEdit( BOOL bReal=FALSE );
		~VCSbxEdit();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXSCROLLBAR
//----------------------
// class VCSbxScrollBar
//----------------------
class VCSbxScrollBar : public VCSbxControl
{
	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		VCSbxScrollBar( BOOL bReal=FALSE );
		~VCSbxScrollBar();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXHSCROLLBAR
//----------------------
// class VCSbxHScrollBar
//----------------------
class VCSbxHScrollBar : public VCSbxScrollBar
{
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_HSCROLLBAR, 1 );
		VCSbxHScrollBar( BOOL bReal=FALSE );
		~VCSbxHScrollBar();
};
#endif


#ifndef _SI_NOVCSBXVSCROLLBAR
//----------------------
// class VCSbxVScrollBar
//----------------------
class VCSbxVScrollBar : public VCSbxScrollBar
{
public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_VSCROLLBAR, 1 );
		VCSbxVScrollBar( BOOL bReal=FALSE );
		~VCSbxVScrollBar();
};
#endif


#ifndef _SI_NOVCSBXPREVIEW
//--------------------
// class VCSbxPreview
//--------------------
class VCSbxPreview : public VCSbxControl
{
private:
#ifdef _VCSBXPREVIEW_CXX
	void 	PropCurrentX( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropCurrentY( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropDrawMode( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropDrawStyle( SbxVariable* pVar, SbxArray* pPar, BOOL pWrite );
	void	PropDrawWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropFillStyle( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropOutputWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropOutputHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropFontTransparent( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );

	void    MethDrawPoint( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethGetPoint( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawLine( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawLineTo( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawPolygon( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawBox( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawEllipse( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethDrawPicture( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethGetTextHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethGetTextWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethCls( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
#endif
protected:

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_PREVIEW, 1 );

		VCSbxPreview( BOOL bReal=FALSE );
		~VCSbxPreview();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif


#ifndef _SI_NOVCSBXURLBUTTON
//-----------------------
// class VCSbxURLButton
//-----------------------
class VCSbxURLButton : public VCSbxButton
{
protected:
		void PropValue( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );

		void SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT );
		virtual void Click();

public:
		TYPEINFO();
		SBX_DECL_PERSIST_NODATA( SBXCR_VC, SBXID_URLBUTTON, 1 );

		VCSbxURLButton( BOOL bReal=FALSE );
		~VCSbxURLButton();

		virtual void CreateSVControl( Window* pParent );
		virtual void UpdateSVControl( USHORT nWhich=0 );
#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl( Window*, const SfxItemSet&) const;
#endif
};
#endif

#endif // SI_NOSBXCONTROLS



#endif //_VCSBX_HXX
