/*************************************************************************
 *
 *  $RCSfile: vcsbxctl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _VC_VCSBXCONTROL_HXX
#define _VC_VCSBXCONTROL_HXX


#ifndef _SBX_SBXOBJECT_HXX //autogen
#include <svtools/sbxobj.hxx>
#endif

class Window;
class Control;
class KeyEvent;
class MouseEvent;
class OutputDevice;
class Size;
class Point;
class NotifyEvent;

class SfxItemSet;
class VCControl;

#ifdef VCL
#define TF_SI_OFF50
#endif

//-----------------------
// class VCSbxControlHdl
//-----------------------
class VCSbxControl;
class VCSbxControlHdl
{
private:
#ifdef _VCSBXCTLHDL_CXX
	DECL_LINK( Click, VCControl * );
	DECL_LINK( DblClick, VCControl * );
	DECL_LINK( GotFocus, VCControl * );
	DECL_LINK( LostFocus, VCControl * );
	DECL_LINK( KeyDown, VCControl * );
	void KeyPress( VCControl* );
	DECL_LINK( KeyUp, VCControl * );
	DECL_LINK( MouseDown, VCControl * );
	DECL_LINK( MouseMove, VCControl * );
	DECL_LINK( MouseUp, VCControl * );
	void SpinUp( VCControl* );
	void SpinDown( VCControl* );
	void Paint( VCControl* );
#endif

protected:
	VCSbxControl*	pSbxControl;

public:
	VCSbxControlHdl();

	void SetLink( VCSbxControl* pSbxControl, VCControl* pControl );
};

//--------------------
// class VCSbxControl
//--------------------

#define VCSBX_FLAG_FOCUSED	0x0001

SV_DECL_REF( VCSbxControl )
class VCSbxForm;
class Timer;
class HelpEvent;

class VCSbxControl : public SbxObject
{
friend class VCSbxButtonHdl;

private:
#if __PRIVATE
	void	MethodMove( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodRefresh( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	MethodSetFocus( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
	void	PropParent( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite );
#endif

protected:
	VCSbxControlHdl aHdl;
	VCControl*		pVCControl;
	Control*		pSVControl;
	SfxItemSet*		pRunTimeItemSet;

	void			Init();

	void	SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
					const SfxHint& rHint, const TypeId& rHT );

	void	ConvertAmpersand( String* pStr );
	void	DeleteAmpersand( String* pStr );
	void	LoadDialog();

public:
		TYPEINFO();
		SBX_DECL_PERSIST(0,0,0);

		VCSbxControl();
		~VCSbxControl();

		SbxVariable* 	 	Find( const String& rName, SbxClassType eType);
		virtual BOOL 		Call( const String&, SbxArray* = NULL );


		virtual const String& GetName( SbxNameType=SbxNAME_NONE ) const;
		virtual void          SetName( const String& rName );

		String				GetClassName() const;
		String				GetClassNamePlural() const;
		VCControl*	   		GetVCControl() const { return pVCControl; }

		virtual void		SetParent( SbxObject* pParent );
		virtual void		SetParentBetter( SbxObject* pParent );

		virtual void		CreateSVControl( Window* pParent );
		virtual void		DeleteSVControl();
		virtual void		UpdateSVControl( USHORT nWhich=0 );
		Control*			GetSVControl() { return pSVControl; }

		SfxItemSet*			GetRunTimeItemSet() const { return pRunTimeItemSet; }

		long				GetStep() const;
		void				SetStep( long nStep );
		void				UpdateStep( long nActStep );
		ULONG				GetTabPos() const;
		BOOL				IsSVLook() const;

		virtual void		Click();
		virtual void		DblClick();
		virtual void		GotFocus();
		virtual void		LostFocus();
		virtual void		KeyDown( const KeyEvent& rKEvt );
		virtual void		KeyPress( const KeyEvent& rKEvt );
		virtual void		KeyUp( const KeyEvent& rKEvt );
		virtual void		MouseDown( const MouseEvent& rMEvt );
		virtual void		MouseMove( const MouseEvent& rMEvt );
		virtual void		MouseUp( const MouseEvent& rMEvt );
		virtual void		Change();
		virtual void		Scroll();
		virtual void		SpinUp();
		virtual void		SpinDown();
		virtual void		Paint();

		BOOL				IsAutoAdjustSize() const;
		Size				GetAdjustedSizePixel( const OutputDevice* ) const;
		Point				GetAdjustedPosPixel( const OutputDevice* ) const;

		friend SvStream& operator<<(SvStream& rOut, const VCSbxControl& rSbxCtrl);
		friend SvStream& operator>>(SvStream& rIn, VCSbxControl& rSbxCtrl);

		BOOL RequestHelp( const HelpEvent& rHEvt );

#ifdef VCL
		long PreNotify( NotifyEvent& rNEvt );
		private:
		USHORT nCtrlFlags;
#endif

public:

#ifdef TF_SI_OFF50
		virtual Control* CreateVCLControl(Window*,const SfxItemSet&) const=0;
		virtual void UpdateVCLColorsAndFont( Control*, const SfxItemSet&, USHORT nWhich);
		virtual void UpdateVCLVisibleAndEnable( Control*, const SfxItemSet&, USHORT nWhich);
		BOOL	IsDesignModeActive() const;
#endif
};

SV_IMPL_REF( VCSbxControl )



#endif
