/*************************************************************************
 *
 *  $RCSfile: vcsbxdo.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef __VC_VCSBXDO_HXX
#define __VC_VCSBXDO_HXX

#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif

class SdrObjGeoData;
class SdrObjMacroHitRec;

//-----------------------
// class VCSbxDrawObject
//-----------------------

class VCControl;
class VCSbxDrawObject_Impl;
class VCSbxControlRef;
class VCSbxControl;

class VCSbxDrawObject : public SdrObject
{
	VCSbxDrawObject( const VCSbxDrawObject& );

protected:
	VCSbxDrawObject_Impl* pImpl;
	VCControl*      pVCControl;
	virtual void    NbcMove( const Size& rSize );
	virtual void NbcResize(const Point& rRef, const Fraction& xFact, const Fraction& yFact);
public:
	TYPEINFO();

	VCSbxDrawObject();
	VCSbxDrawObject( VCSbxControlRef pCtrl );
	~VCSbxDrawObject();

	virtual FASTBOOL Paint( ExtOutputDevice& rOut, const SdrPaintInfoRec& rInfoRec ) const;
	virtual FASTBOOL EndCreate( SdrDragStat& rStat, SdrCreateCmd eCmd );

	virtual void     RecalcBoundRect();

	virtual FASTBOOL HasMacro() const;
	virtual SdrObject* CheckHit(const Point& rPnt,USHORT nTol,const SetOfByte*)const;
	virtual SdrObject* CheckMacroHit(const SdrObjMacroHitRec& rRec) const;
	virtual Pointer    GetMacroPointer(const SdrObjMacroHitRec& rRec) const;

	virtual void	TakeObjInfo( SdrObjTransformInfoRec& rInfo ) const;
	virtual void	TakeObjNameSingul( String& rName ) const;
	virtual void	TakeObjNamePlural( String& rName ) const;

	VCSbxControl*   GetControl(); // { return pControl; }

	virtual SfxItemSet* GetItemSet();
	virtual void        SetItemSet( SfxItemSet* pItemSet );
	virtual void        UpdateItem( USHORT nWhich );

	UINT32          GetObjInventor() const;
	UINT16          GetObjIdentifier() const;

	void            SetRectsDirty(FASTBOOL bNotMyself=FALSE);
	virtual void    RestGeoData(const SdrObjGeoData& rGeo);

	virtual void    SetPage( SdrPage* pNewPage );
	virtual void    SetModel( SdrModel* pNewModel );

	void			InvalidateOverlayObjects( Window* pWindow );
	void			PaintOverlayObjects( ExtOutputDevice& rOut,
										 const SdrPaintInfoRec& rInfo ) const;
	BOOL			HasOverlayObjects() const;

	virtual void    WriteData(SvStream& rOut) const;
	virtual void    ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);

	virtual void    	operator=( const SdrObject& rObj );
	virtual SdrObject*  Clone() const;
	virtual SdrObject*  Clone( SdrPage* pPage, SdrModel* pModel ) const;
};


#undef pControl
#endif
