/*************************************************************************
 *
 *  $RCSfile: vctrls.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if __PRIVATE
#else
#pragma message("Do not include obsolete VControl-Headers!")
#endif

#ifndef _SVX_VCTRLS_HXX
#define _SVX_VCTRLS_HXX

#ifndef _ERRCODE_HXX //autogen
#include <tools/errcode.hxx>
#endif
#ifndef _LINK_HXX //autogen
#include <tools/link.hxx>
#endif
#ifndef _RTTI_HXX //autogen
#include <tools/rtti.hxx>
#endif

#ifndef _MAPMOD_HXX //autogen
#include <vcl/mapmod.hxx>
#endif

class String;

class SfxItemSet;
class VCImpControl;
class VCItemPool;
class VCContainer;
class VCManager;
class VCSbxDrawObject;
class Color;
class VCForm;
class Window;
class MouseEvent;
class KeyEvent;
class Font;
class OutputDevice;
class VCSbxControl;
class SjJSbxObject;
class SvPtrarr;
class SvxMacro;
class SbxArray;
class SvxMacroTableDtor;
class SbxObject;

#define VCHDL_START			0
#define VCHDL_NULL			0
#define VCHDL_ONACTION      1
#define VCHDL_ONCHANGE      2
#define VCHDL_ONCLICK       3
#define VCHDL_ONSELECT      4
#define VCHDL_ONMOUSEMOVE   5
#define VCHDL_ONGETFOCUS    6
#define VCHDL_ONLOSEFOCUS   7
#define VCHDL_ONDBLCLICK    8
#define VCHDL_ONKEYINPUT    9
#define VCHDL_ONKEYUP		10
#define VCHDL_ONKEYDOWN		11
#define VCHDL_ONMOUSEUP		12
#define VCHDL_ONMOUSEDOWN	13
#define VCHDL_ONSPINUP		14
#define VCHDL_ONSPINDOWN	15
#define VCHDL_ONSCROLL		16
#define VCHDL_ONPAINT		17
#define VCHDL_ONRESIZE		18
#define VCHDL_ONACTIVATE	19
#define VCHDL_ONDEACTIVATE	20
#define VCHDL_ONLOAD		21
#define VCHDL_ONUNLOAD		22
#define VCHDL_ONSUBMITFORM	23
#define VCHDL_ONRESETFORM	24
#define VCHDL_END           VCHDL_ONRESETFORM

//-----------------
// class VCControl
//-----------------
class VCControl
{
	friend class VCContainer;
	friend class VCManager;

protected:

	VCSbxControl*       pSbxControl;

	VCItemPool*         pPool;
	SfxItemSet*         pItemSet;
	VCContainer*        pParent;
	BOOL                bReal;
	VCImpControl*       pImpCtrl;
	VCSbxDrawObject*    pDrawObject;
	Point               aDrawOfs;
	Rectangle           aOutRect;
	Link                aClickHdlLink;
	Link                aDblClickHdlLink;
	Link                aGotFocusHdlLink;
	Link                aLostFocusHdlLink;
	Link                aKeyDownHdlLink;
	Link                aKeyPressHdlLink;
	Link                aKeyUpHdlLink;
	Link                aMouseDownHdlLink;
	Link                aMouseMoveHdlLink;
	Link                aMouseUpHdlLink;
	MouseEvent*         pActMouseEvent;
	KeyEvent*           pActKeyEvent;
	MapUnit             eOutUnit;
	USHORT              nFlags;

	virtual void    Create();
	Window*         GetWindow() const;
	void            UpdateOutRect();

	virtual void    MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void    MouseButtonUp( Window* pWindow, const MouseEvent& rMEVt );
	virtual void    MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void    KeyInput( Window* pWindow, const KeyEvent& rKEvt );

	SbxArray*		CreateSbxParams( USHORT nHandlerId );
	void			DestroySbxParams( SbxArray* );
					DECL_LINK(VCUserEvent,void*);

public:
	TYPEINFO();
					VCControl( VCContainer* pParent, VCItemPool* pPool,
							   BOOL bReal=FALSE, VCSbxControl* pCtrl =0 );
	virtual         ~VCControl();

	virtual void    SetName( const String& rName );
	String          GetName() const;

	void            SetFormName( const String& rName );
	String          GetFormName() const;

	void            SetCaption( const String& rCaption );
	String          GetCaption() const;

	void            SetTag( const String& rTag );
	String          GetTag() const;

	virtual void    SetPos( const Point& rPos );
	Point           GetPos() const;

	virtual void    SetSize( const Size& rSize );
	Size            GetSize() const;

	Size            GetMinSizePixel();

	void            SetFont( const Font& rFont );
	Font            GetFont() const;

	void            SetPrintable( BOOL );
	BOOL            IsPrintable() const;

	void            SetOutUnit( MapUnit eUnit ) { eOutUnit = eUnit; }
	MapUnit         GetOutUnit() const { return eOutUnit; }

	Point           GetDrawOfs() const { return aDrawOfs; }
	void            SetDrawOfs( const Point& rDrawOfs );

	void            SetVisible( BOOL bVisible=TRUE );
	BOOL            IsVisible() const;

	void            Enable( BOOL bEnable=TRUE );
	BOOL            IsEnabled() const;

	long            GetStep() const;
	void            SetStep( long nStep );

	void            SetParent( VCContainer* pParent );
	VCContainer*    GetParent() const;
	ULONG           GetTabPos() const;
	void            SetTabPos( ULONG nPos );

	void            SetForeColor( const Color& );
	Color           GetForeColor() const;
	void            SetBackColor( const Color& );
	Color           GetBackColor() const;

	void            Deactivate();
	void            ReActivate();

	SfxItemSet*     GetItemSet() const { return pItemSet; }
	virtual void    SetItemSet( SfxItemSet* pItemSet );
	void            SetItemSetSimple( SfxItemSet* pItemSet );
	VCItemPool*     GetPool() const { return pPool; }
	void            SetPool( VCItemPool* pNewPool );
	virtual String  GetClassName() const;
	virtual String  GetClassNamePlural() const;

	BOOL            IsReal() const { return bReal; }
	virtual BOOL    IsActionHit( const Point& rPt, long nTol );

	virtual void    Paint( Window* pWindow, const Rectangle& rRect );
	virtual void    Draw( OutputDevice* pOut );

	virtual void    UpdateItem( USHORT nWhich );

	String          GetLinkData( const String& rLinkName );
	void            SetLinkData( const String& rLinkName,
								 const String& rLinkData );
	virtual void    UpdateLinkData( const String& rLinkName,
									const String& rLinkData );

	void                SetDrawObject( VCSbxDrawObject* pDrwObj );
	VCSbxDrawObject*    GetDrawObject() const { return pDrawObject; }
	VCImpControl*       GetImpControl() const { return pImpCtrl; }
	VCSbxControl*       GetSbxControl() const { return pSbxControl; }
	void                InvalidateOverlayObjects( Window* pWindow );
	BOOL                HasOverlayObjects() const;

	MouseEvent*     GetActMouseEvent() const { return pActMouseEvent; }
	void			SetActMouseEvent( const MouseEvent* pEvt ) { pActMouseEvent = (MouseEvent*)pEvt; }
	KeyEvent*       GetActKeyEvent()   const { return pActKeyEvent; }
	void			SetActKeyEvent( const KeyEvent* pEvt ) { pActKeyEvent = (KeyEvent*)pEvt; }

	void            SetClickHdl( const Link& rLink )
						{ aClickHdlLink = rLink; }
	const Link&     GetClickHdl() const { return aClickHdlLink; }
	void            SetDblClickHdl( const Link& rLink )
						{ aDblClickHdlLink = rLink; }
	const Link&     GetDblClickHdl() const { return aDblClickHdlLink; }
	void            SetGotFocusHdl( const Link& rLink )
						{ aGotFocusHdlLink = rLink; }
	const Link&     GetGotFocusHdl() const { return aGotFocusHdlLink; }
	void            SetLostFocusHdl( const Link& rLink )
						{ aLostFocusHdlLink = rLink; }
	const Link&     GetLostFocusHdl() const { return aKeyDownHdlLink; }
	void            SetKeyDownHdl( const Link& rLink )
						{ aKeyDownHdlLink = rLink; }
	const Link&     GetKeyDownHdl() const { return aKeyDownHdlLink; }
	void            SetKeyPressHdl( const Link& rLink )
						{ aKeyPressHdlLink = rLink; }
	const Link&     GetKeyPressHdl() const { return aKeyPressHdlLink; }
	void            SetKeyUpHdl( const Link& rLink )
						{ aKeyUpHdlLink = rLink; }
	const Link&     GetKeyUpHdl() const { return aKeyUpHdlLink; }
	void            SetMouseDownHdl( const Link& rLink )
						{ aMouseDownHdlLink = rLink; }
	const Link&     GetMouseDownHdl() const { return aMouseDownHdlLink; }
	void            SetMouseMoveHdl( const Link& rLink )
						{ aMouseMoveHdlLink = rLink; }
	const Link&     GetMouseMoveHdl() const { return aMouseMoveHdlLink; }
	void            SetMouseUpHdl( const Link& rLink )
						{ aMouseUpHdlLink = rLink; }
	const Link&     GetMouseUpHdl() const { return aMouseUpHdlLink; }

	// Event Handler
	void            BasicAction();
	virtual void    Click();
	virtual void    DblClick();
	virtual void    GotFocus();
	virtual void    LostFocus();
	virtual void    KeyDown();
	virtual void    KeyPress();
	virtual void    KeyUp();
	virtual void    MouseDown();
	virtual void    MouseMove();
	virtual void    MouseUp();
	virtual void    Modified();
	virtual void    Selected();
	void            SetVCForm( VCForm* );   // 0 == Standardform
	VCForm*         GetVCForm() const;
	// Control auf den Wert setzen, den es beim letzten
	// Aufruf von SaveResetValue hatte
	virtual void    Reset();
	virtual void    SaveResetValue();

	virtual void    SetHandler( USHORT nId, const String& rMacro );
	void			SetHandler( USHORT nId, const SvxMacro& rMacro );
	void			SetHandlers( const SvxMacroTableDtor& );

	virtual String  GetHandler( USHORT nId ) const;
	const SvxMacroTableDtor& GetHandlers() const;

	const SvxMacro* GetSvxMacro( USHORT nId ) const;
	ErrCode         ExecuteHandler( USHORT nId );
	// SfxStringItems => SvxMacroItem
	static void		SetNewHandlers( SfxItemSet*, const TypeId&, BOOL bReal  );
	// SvxMacroItem => SfxStringItems
	static void		SetOldHandlers( SfxItemSet*, const TypeId&, BOOL bReal );

	void            SetFlags( USHORT _nFlags ) { nFlags = _nFlags; }
	USHORT          GetFlags() const { return nFlags; }

	virtual void	SetValue( const String& );
	virtual String	GetValue() const;

	friend SvStream& operator<<(SvStream& rOut, const VCControl& rCtrl);
	friend SvStream& operator>>(SvStream& rIn, VCControl& rCtrl);

	static String GetReferer( SbxObject* pVCObject );
};




#endif //_VCTRLS_HXX
