/*************************************************************************
 *
 *  $RCSfile: basobj.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include <ide_pch.hxx>

#pragma hdrstop

#include <basdoc.hxx>
#include <basobj.hxx>
#include <basidesh.hxx>
#include <iderdll.hxx>

BasicIDE::BasicIDE()
{
	BasicDocShell::RegisterFactory( SVX_INTERFACE_BASIDE_DOCSH );
	BasicDocShell::RegisterInterface();
	BasicIDEShell::RegisterFactory( SVX_INTERFACE_BASIDE_VIEWSH );
	BasicIDEShell::RegisterInterface();
}

BasicIDE::~BasicIDE()
{
	Destroy();
}

void BasicIDE::Create()
{
	// Durch das globale Basic-ErrorHandling folgende Situation:
	// pBasicFrame = CreateMDIFrame()
	// => Fehler im Basic waehrend CreateMDIFrame
	// => Im ErrorHdl APPEAR => pFrame noch 0 => zweites Start!

	static BOOL bCreating = FALSE;
	if ( !IDE_DLL()->GetShell() && !bCreating && SFX_APP()->HasFeature( SFX_FEATURE_BASIC_IDE ) )
	{
		bCreating = TRUE;
		BasicDocShell::Factory().DoInitFactory();
		SfxObjectShell* pDocShell = new BasicDocShell;
		pDocShell->DoInitNew( 0 );
		pDocShell->SetTitle( GetStdTitle() );
		pDocShell->SetModified( FALSE );
		StartListening( *pDocShell );

		SfxViewFrame* pBasicFrame = SFX_APP()->CreateViewFrame( *pDocShell, 0 );
		pBasicFrame->SetName( String( RTL_CONSTASCII_USTRINGPARAM( "BASIC:1" ) ) );
		bCreating = FALSE;
	}
}

void BasicIDE::Appear()
{
	if ( IDE_DLL()->GetShell() )
		IDE_DLL()->GetShell()->GetViewFrame()->ToTop();
}

void BasicIDE::Destroy()
{
	if ( IDE_DLL() && IDE_DLL()->GetShell() )
		IDE_DLL()->GetShell()->GetViewFrame()->GetDispatcher()->Execute( SID_CLOSEDOC );
}

BOOL BasicIDE::IsCreated() const
{
	return IDE_DLL()->GetShell() ? TRUE : FALSE;
}

void BasicIDE::SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
					   const SfxHint& rHint, const TypeId& rHintType )
{
	SfxSimpleHint *pHint = PTR_CAST( SfxSimpleHint, &rHint );
	if ( pHint && ( pHint->GetId() & SFX_HINT_DYING ) )
	{
		BasicIDE::GetBindings().Invalidate(SID_BASICIDE);
	}
}
