/*************************************************************************
 *
 *  $RCSfile: colwin.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#pragma hdrstop

#include "sidll.hxx"
#include "colwin.hxx"
#define ITEMID_COLOR 0
#include "isetbrw.hrc"
#include "isetbrw.hxx"

void ImplColorWindow::Resize()
{
	Size aSize = GetOutputSizePixel();
	aSize.Width()  -= 4;
	aSize.Height() -= 4;
	aValueSet.SetPosSizePixel( Point( 2, 2 ), aSize );
}

IMPL_LINK_INLINE_START( ImplColorWindow, ValueSetSelect, ValueSet *, EMPTYARG )
{
	if( aSelectHdlLink.IsSet() )
		aSelectHdlLink.Call( this );
	return 0;
}
IMPL_LINK_INLINE_END( ImplColorWindow, ValueSetSelect, ValueSet *, EMPTYARG )

ImplColorWindow::ImplColorWindow( ItemSetBrowser* pParent, WinBits nWinStyle ) :
	Window( pParent, WB_SVLOOK | WB_BORDER ),
	aValueSet( this, WB_SVLOOK | WB_ITEMBORDER | WB_NAMEFIELD )
{
	ResMgr* pSiRes = (*(SiDLL**)GetAppData(SHL_SI))->GetResMgr();
	aValueSet.InsertItem(  1, Color( COL_BLACK ),        String( ResId( STR_BLACK, pSiRes )));
	aValueSet.InsertItem(  2, Color( COL_BLUE ),         String( ResId( STR_BLUE, pSiRes   )));
	aValueSet.InsertItem(  3, Color( COL_GREEN ),        String( ResId( STR_GREEN, pSiRes  )));
	aValueSet.InsertItem(  4, Color( COL_CYAN ),         String( ResId( STR_CYAN, pSiRes  )));
	aValueSet.InsertItem(  5, Color( COL_RED ),          String( ResId( STR_RED, pSiRes    )));
	aValueSet.InsertItem(  6, Color( COL_MAGENTA ),      String( ResId( STR_MAGENTA, pSiRes  )));
	aValueSet.InsertItem(  7, Color( COL_BROWN ),        String( ResId( STR_BROWN, pSiRes  )));
	aValueSet.InsertItem(  8, Color( COL_GRAY ),         String( ResId( STR_GRAY, pSiRes  )));
	aValueSet.InsertItem(  9, Color( COL_LIGHTGRAY ),    String( ResId( STR_LIGHTGRAY, pSiRes  )));
	aValueSet.InsertItem( 10, Color( COL_LIGHTBLUE ),    String( ResId( STR_LIGHTBLUE, pSiRes  )));
	aValueSet.InsertItem( 11, Color( COL_LIGHTGREEN ),   String( ResId( STR_LIGHTGREEN, pSiRes  )));
	aValueSet.InsertItem( 12, Color( COL_LIGHTCYAN ),    String( ResId( STR_LIGHTCYAN, pSiRes  )));
	aValueSet.InsertItem( 13, Color( COL_LIGHTRED ),     String( ResId( STR_LIGHTRED, pSiRes  )));
	aValueSet.InsertItem( 14, Color( COL_LIGHTMAGENTA ), String( ResId( STR_LIGHTMAGENTA, pSiRes  )));
	aValueSet.InsertItem( 15, Color( COL_YELLOW ),       String( ResId( STR_YELLOW, pSiRes  )));
	aValueSet.InsertItem( 16, Color( COL_WHITE ),        String( ResId( STR_WHITE, pSiRes  )));

	aValueSet.SetColCount( 8 );
	aValueSet.SetSelectHdl( LINK( this, ImplColorWindow, ValueSetSelect ) );

	Size aValSize = aValueSet.CalcWindowSizePixel( Size( 12, 12 ) );
	aValSize.Width()  += 4;
	aValSize.Height() += 4;
	SetOutputSizePixel( aValSize );
	bClosing = FALSE;
	aValueSet.Show();
}

void ImplColorWindow::SetColor( const Color& rCol )
{
	aValueSet.SelectItem( (USHORT)rCol.GetColorName() + 1 );
}

Color ImplColorWindow::GetColor() const
{
	return aValueSet.GetItemColor( aValueSet.GetSelectItemId() );
}

void ImplColorWindow::LoseFocus()
{
	Window::LoseFocus();
#ifdef VCL
	if( !Application::GetFocusWindow() || !IsChild(Application::GetFocusWindow()))
#endif
		Close( FALSE );
}

void ImplColorWindow::KeyInput( const KeyEvent& rKEvt )
{
	BOOL bKeyUsed = TRUE;
	KeyCode aKeyAction = rKEvt.GetKeyCode();

	USHORT nId     = aValueSet.GetSelectItemId();
	USHORT nColVals= aValueSet.GetColCount();

	switch ( aKeyAction.GetCode() )
	{
		case KEY_RETURN:
			if ( !aKeyAction.IsShift() && !aKeyAction.IsMod1() )
			{
				aSelectHdlLink.Call( &aValueSet );
				Close();
			}
			else
				bKeyUsed = FALSE;
			break;

		case KEY_ESCAPE:
			if ( !aKeyAction.IsShift() )
				Close( TRUE );
			break;

		case KEY_LEFT:
			if( aValueSet.IsNoSelection() || (nId == 1) )
				aValueSet.SelectItem( 1 );
			else
				aValueSet.SelectItem( nId-1 );
			break;

		case KEY_RIGHT:
			if( aValueSet.IsNoSelection() || (nId >= aValueSet.GetItemCount()) )
				aValueSet.SelectItem( aValueSet.GetItemCount() );
			else
				aValueSet.SelectItem( nId+1 );
			break;

		case KEY_DOWN:
			if( aValueSet.IsNoSelection() )
				aValueSet.SelectItem( 1 );
			else
			if( nId <= nColVals )
				aValueSet.SelectItem( nId + nColVals );
			break;

		case KEY_UP:
			if( aValueSet.IsNoSelection() )
				aValueSet.SelectItem( 1 );
			else
			if( nId > nColVals )
				aValueSet.SelectItem( nId - nColVals );
			break;

		case KEY_HOME:
			aValueSet.SelectItem( 1 );
			break;

		case KEY_END:
			aValueSet.SelectItem( aValueSet.GetItemCount() );
			break;

		default:
			bKeyUsed = FALSE;
	}
	if ( !bKeyUsed )
		Window::KeyInput( rKEvt );
}

void ImplColorWindow::Close( BOOL bCanceled )
{
	if ( bClosing )
		return;
	bClosing = TRUE;
	bCancel = bCanceled;
	aClosedHdl.Call( this );
}

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/isetbrw/colwin.cxx,v 1.1.1.1 2000/09/29 11:02:38 mh Exp $

	  Source Code Control System - Update

	  $Log: colwin.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:38  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:44  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:42  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:02  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.16  2000/02/10 19:57:08  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.15  1997/11/21 16:35:00  OV
	  Headerumstellung
	

	  Rev 1.14   21 Nov 1997 17:35:00   OV
   Headerumstellung

	  Rev 1.13   06 Nov 1997 12:50:48   OV
   GetFocusWindow==0 abfragen; Includes aufgeraeumt

	  Rev 1.12   17 Sep 1997 10:45:40   OV
   #43866# VCL: Focushandling, GetColor

	  Rev 1.11   12 Jun 1996 11:57:24   OV
   si.hxx raus sidll.hxx rein

	  Rev 1.10   21 Mar 1996 11:03:20   OV
   Clooks

	  Rev 1.9   21 Dec 1995 17:42:04   TRI
   Link Umstellung

	  Rev 1.8   06 Nov 1995 16:49:18   TRI
   Change->Set

	  Rev 1.7   31 Aug 1995 09:37:52   HJS
   svxitems.hxx entfernt

	  Rev 1.6   05 Aug 1995 12:42:06   CL
   Handling verbessert

	  Rev 1.5   02 Aug 1995 18:48:00   OV
   Pragmas

	  Rev 1.4   11 Jul 1995 19:03:40   OV
   Bugfixes

	  Rev 1.3   05 Jul 1995 13:44:42   OV
   Segmentitis

	  Rev 1.2   23 Apr 1995 12:04:04   CL
   Si-ResMgr

	  Rev 1.1   04 Mar 1995 18:10:12   OV
   Cancel

	  Rev 1.0   27 Feb 1995 10:29:44   OV
   Initial revision.

*************************************************************************/


#pragma SEG_EOFMODULE

