/*************************************************************************
 *
 *  $RCSfile: isetbrw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_COLOR 0

#include <stdlib.h>  // strtol, strtoul

#ifndef _SVLBOX_HXX
#include <svtools/svlbox.hxx>
#endif
#ifndef _SFX_WHITER_HXX
#include <svtools/whiter.hxx>
#endif
#ifndef _SFXITEMPOOL_HXX
#include <svtools/itempool.hxx>
#endif
#ifndef _SVX_COLRITEM_HXX
#include <svx/colritem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _STACK_HXX
#include <tools/stack.hxx>
#endif
#ifndef _SFXRNGITEM_HXX
#include <svtools/rngitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSLSTITM_HXX
#include <svtools/slstitm.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#pragma hdrstop

#define _ISETBRW_CXX
#include "isetbrw.hxx"
#include "edctrl.hxx"
#include "medctrl.hxx"
#include "lbctrl.hxx"
#include "colwin.hxx"
#include "isetbrw.hrc"
#include "sidll.hxx"

#define CTRLID_DONTKNOW			0
#define CTRLID_SINGLEEDIT		1
#define CTRLID_MULTIEDIT		2
#define CTRLID_LISTBOX			3
#define CTRLID_COLWIN			4

#define DIST_VALUETAB_VALUE		4
#define DIST_VALUETAB_LINE		2
#define TABSET_DELTA			3

#define ENTRYHEIGHT				19
#define BTN_WINBITS				((WinBits)(WB_CLIPCHILDREN|WB_NOPOINTERFOCUS))

DECLARE_STACK(ImpParentStack,SvLBoxEntry*);
DECLARE_STACK(ImpRangeStack,SfxRangeItem*);

class ImpNodeOpen
{
public:
	BOOL			bIsOpen;				// aufgeklappt
	USHORT			nWhichId;				// WhichId
	ImpNodeOpen( USHORT nID )	// Ctor default immer zugeklappt
		{ bIsOpen=FALSE; nWhichId=nID; }
};
DECLARE_LIST(ImpNodeOpenList, ImpNodeOpen*);


BrwListEntry::~BrwListEntry()
{
	DBG_ASSERT(nItemFlags!=0xffff,"Using deleted object")
	nItemFlags = 0xffff;
}

class ImpBrwString : public SvLBoxString
{
public:

	ImpBrwString( ItemSetBrowser* pView, SvLBoxEntry* pEntry, USHORT nFlags,
		const String& rStr ) : SvLBoxString(pEntry,nFlags,rStr)
	{
	}

	virtual void Paint( const Point& rPos, SvLBox& rDev, USHORT nFlags,
		SvLBoxEntry* pEntry);
};


void ImpBrwString::Paint( const Point& rPos, SvLBox& rDev, USHORT nFlags,
	SvLBoxEntry* pEntry )
{
	// an das Control gehen, damit die SvListBox nicht invalidiert
	Font aFont=rDev.Control::GetFont();
	rDev.Control::SetFont(((ItemSetBrowser&)rDev).GetValueFont());

	Point aPos( rPos);
	aPos.X() += DIST_VALUETAB_VALUE;
	rDev.DrawText( aPos, GetText() );
	rDev.Control::SetFont( aFont );
	long nY = ((SvTreeListBox&)rDev).GetEntryHeight();
	const Size& rSize = GetSize( &rDev, pEntry );
	nY -= rSize.Height();
	nY /= 2;
	nY = (rPos.Y() - nY);
	((ItemSetBrowser&)rDev).DrawTabLine( nY );
}

__EXPORT ItemSetBrowser::ItemSetBrowser( Window* pParent, WinBits nWinStyle ) :
	SvTreeListBox( pParent, nWinStyle ),
	aValueFont( GetFont() )
{
	nCurrentWhich		= 0;
	pCurSet				= 0;
	nValueTab			= 60;
	bSettingTab			= FALSE;
	bTabSettingDisabled	= FALSE;
	bStartTabSetting	= FALSE;
	pNodeOpenList		= new ImpNodeOpenList;
	pCurSelected		= 0;
	pCurComboButton		= 0;
	pCurDotButton		= 0;
	nCurLine			= -1;

	pCurEdit			= 0;
	pCurMEdit			= 0;
	pCurLBox			= 0;
	pCurColWin			= 0;
	pCurCtrl			= 0; // 0==kein Control aktiv

	nModifyId			= 0;

	bComboListExpanded	= FALSE;
	bOpeningCtrl		= FALSE;
	nCurCtrlId			= CTRLID_DONTKNOW;
	nCurItemType		= ITEMTYPE_DONTKNOW;
	ResMgr* pSiRes = (*(SiDLL**)GetAppData(SHL_SI))->GetResMgr();
	aComboBmp = Bitmap( ResId( BMP_DROPDOWN, pSiRes ) );
	aValueFont.SetWeight( WEIGHT_NORMAL );

	if ( SvLBox::nWindowStyle & WB_SVLOOK )
	{
		bSvLook = TRUE;
		Color aBackColor( Application::GetSettings().GetStyleSettings().GetFaceColor() );
		SetBackground( Wallpaper( aBackColor ) );
		aLineColor = Color( COL_GRAY );
	}
	else
	{
		bSvLook = FALSE;
		aLineColor = Color( COL_LIGHTGRAY );
	}
	SetHighlightRange( 0, 1);
}

__EXPORT ItemSetBrowser::ItemSetBrowser( Window* pParent, const ResId& rResId ) :
	SvTreeListBox( pParent, rResId )
{
	DBG_ASSERT( 0, "ResourceCtor not implemented" );
}

__EXPORT ItemSetBrowser::~ItemSetBrowser()
{
	Clear();
	delete pCurEdit;
	delete pCurMEdit;
	delete pCurLBox;
	delete pCurColWin;
	delete pNodeOpenList;
	DeleteButtons();
}

SvLBoxEntry* __EXPORT ItemSetBrowser::CreateEntry() const
{
	return new BrwListEntry;
}

void ItemSetBrowser::DeleteButtons()
{
	DELETEZ(pCurDotButton);
	DELETEZ(pCurComboButton);
}

BOOL ItemSetBrowser::IsInAllItemSets( USHORT nWhich )
{
	SfxItemSet* pSet = (SfxItemSet*)aItemSetList.First();
	while( pSet )
	{
		if( pSet->GetItemState( nWhich ) == SFX_ITEM_UNKNOWN )
			return FALSE;
		pSet = (SfxItemSet*)aItemSetList.Next();
	}
	return TRUE;
}

BOOL ItemSetBrowser::IsDontCare( const SfxPoolItem* pItem )
{
	DBG_ASSERT(pItem,"IsDontCare:No Item")
	USHORT nWhich = pItem->Which();
	SfxItemSet* pSet = (SfxItemSet*)aItemSetList.First();
	while( pSet )
	{
		if( pSet->Get(nWhich) != *pItem )
			return TRUE;
		pSet = (SfxItemSet*)aItemSetList.Next();
	}
	return FALSE;
}

void ItemSetBrowser::IntersectSets()
{
	USHORT nWhich;

	delete pCurSet;
	pCurSet = 0;
	SfxItemSet* pSet = (SfxItemSet*)(aItemSetList.First());
	if( !pSet )
		return;
	pCurSet = new SfxItemSet( *(pSet->GetPool()) );

	if( aItemSetList.Count() == 1 )
	{

		SfxWhichIter aIter( *pSet );
		nWhich = aIter.FirstWhich();
		while( nWhich )
		{
			pCurSet->Put( pSet->Get(nWhich) );
			nWhich = aIter.NextWhich();
		}
	}
	else
	{
		SfxWhichIter aIter( *pSet );
		nWhich = aIter.FirstWhich();
		while( nWhich )
		{
			if( IsInAllItemSets( nWhich ) )
			{
				const SfxPoolItem* pCurItem = &pSet->Get( nWhich );
				pCurSet->Put( *pCurItem );
				if( IsDontCare( pCurItem ) )
					pCurSet->InvalidateItem( nWhich );
			}
			nWhich = aIter.NextWhich();
		}
	}
}

void __EXPORT ItemSetBrowser::RemoveAllItemSets()
{
	CloseCurCtrl( TRUE );
	if ( nModifyId )   //!!! HACK, weil Carsten mir im Modify das
		return; 	   // geaenderte Set nochmal an den Kopf wirft
	Clear();
	Invalidate();
}

void __EXPORT ItemSetBrowser::RemoveItemSet( SfxItemSet* pSet )
{
	if ( nModifyId )   //!!! HACK, weil Carsten mir im Modify das
		return; 	   // geaenderte Set nochmal an den Kopf wirft
	CloseCurCtrl( TRUE );
	if ( aItemSetList.Remove(pSet) == pSet )
	{
		Clear();
		IntersectSets();
		FillTree();
		if ( GetUpdateMode() )
			Invalidate();
	}
}

ULONG __EXPORT ItemSetBrowser::GetItemSetCount() const
{
	return aItemSetList.Count();
}

SfxItemSet* __EXPORT ItemSetBrowser::GetItemSet( ULONG nPos ) const
{
	return (SfxItemSet*)(aItemSetList.GetObject(nPos));
}

void __EXPORT ItemSetBrowser::SetItemSet( SfxItemSet* pSet )
{
	if ( nModifyId )   //!!! HACK, weil Carsten mir im Modify das
		return; 	   // geaenderte Set nochmal an den Kopf wirft
	CloseCurCtrl( TRUE );
	DBG_ASSERT(pSet,"SetItemSet:No Set")
	BOOL bOldUpdateMode = GetUpdateMode( );
	SetUpdateMode( FALSE );
	Clear();
	aItemSetList.Insert( pSet, LIST_APPEND );
	IntersectSets();
	FillTree();
	SetUpdateMode( bOldUpdateMode );
}

void __EXPORT ItemSetBrowser::AddItemSet( SfxItemSet* pSet )
{
	if ( nModifyId )   //!!! HACK, weil Carsten mir im Modify das
		return; 	   // geaenderte Set nochmal an den Kopf wirft
	CloseCurCtrl( TRUE );
	DBG_ASSERT(pSet,"AddItemSet:No Set")
	if ( !pCurSet )
		SetItemSet( pSet );
	else if ( aItemSetList.GetPos(pSet) == LIST_ENTRY_NOTFOUND )
	{
		BOOL bOldUpdateMode = GetUpdateMode( );
		SetUpdateMode( FALSE );
		aItemSetList.Insert( pSet, LIST_APPEND );
		IntersectSets();
		DeleteButtons();
		pCurSelected = 0;
		SvTreeListBox::Clear();
		SetEntryHeight( ENTRYHEIGHT );
		FillTree();
		SetUpdateMode( bOldUpdateMode );
	}
}

void ItemSetBrowser::UpdateRange( const SfxItemSet* pNewSet,
								  USHORT nFromWhich, USHORT nToWhich )
{
	DBG_ASSERT(pNewSet,"UpdateRange:No Set")
	DBG_ASSERT(nFromWhich<=nToWhich,"UpdateRange:From>To")
	CloseCurCtrl( TRUE );
	BrwListEntry* pEntry = (BrwListEntry*)First();

	while( pEntry )
	{
		SfxPoolItem* pItem = pEntry->GetItem();
		DBG_ASSERT( pItem!=0, "No UserData" );

		USHORT	nWhich = pItem->Which();

		if( ! pItem->ISA(SfxRangeItem) && nWhich >= nFromWhich && nWhich <= nToWhich )
		{
			const SfxPoolItem* pAnyItem = &pNewSet->Get( nWhich );
			pCurSet->Put( *pAnyItem );
			const SfxPoolItem* pClonedItem=&pCurSet->Get(nWhich); // 1.18
			pEntry->SetItem( pClonedItem ); // 1.18: pAnyItem=>pClonedItem

			String aText; // ( pAnyItem->GetValueText() );
			pAnyItem->GetPresentation(
				SFX_ITEM_PRESENTATION_COMPLETE, SFX_MAPUNIT_TWIP,
					SFX_MAPUNIT_TWIP , aText );
			SetValueText( pEntry, aText );
		}
		pEntry = (BrwListEntry*)Next( pEntry );
	}

}

void ItemSetBrowser::UpdateRange(const SfxItemSet* pNewSet,USHORT *nRangeList)
{
	DBG_ASSERT( nRangeList!=0, "UpdateRange:No RangeList" );
	CloseCurCtrl( TRUE );
	while( *nRangeList )
	{
		USHORT	nFrom = *nRangeList++;
		USHORT	nTo = *nRangeList++;
		UpdateRange( pNewSet, nFrom, nTo );
	}
}

String ItemSetBrowser::GetItemTitle( USHORT ) const
{
	String aStr;
	return aStr;
}

BOOL ItemSetBrowser::GetItemBitmap( USHORT nWhichId, Image& )
{
	return FALSE;
}

BOOL ItemSetBrowser::GetRangeBitmaps( USHORT nWhichId,
		Image& rCollapsedBmp, Image& rExpandedBmp )
{
	return FALSE;
}

void __EXPORT ItemSetBrowser::Clear()
{
	CloseCurCtrl( TRUE );
	DeleteButtons();
	pCurSelected = 0;
	SvTreeListBox::Clear();
	delete pCurSet;
	pCurSet = 0;
	aItemSetList.Clear();
	SetEntryHeight( ENTRYHEIGHT );
}

void ItemSetBrowser::FillTree()
{
	if ( !pCurSet )
		return;
	ImpParentStack	aParentStack;
	ImpRangeStack	aRangeStack;
	Image			aExpBmp;
	Image			aColBmp;
	BrwListEntry*	pEntry;

	DBG_ASSERT(GetEntryCount()==0,"TreeList not cleared!")

	SfxWhichIter		aIter( *pCurSet );
	// SfxItemSet*	pRefSet = (SfxItemSet*)aItemSetList.First();
	// DBG_ASSERT(pRefSet,"FillTree:No RefSet")

	const SfxPoolItem* pAnyItem;
	USHORT			nFirstChild=0, nLastChild=0;

	USHORT nWhich = aIter.FirstWhich();

	while( nWhich )
	{
		if( aWhichRange.IsInside( nWhich ) )
		{
			USHORT nItemFlags;

			SfxItemState eState = pCurSet->GetItemState( nWhich, TRUE, &pAnyItem);
			if( eState == SFX_ITEM_SET || eState == SFX_ITEM_DONTCARE )
			{

			if( eState == SFX_ITEM_DONTCARE )
				pAnyItem = &pCurSet->Get( nWhich ); //&pRefSet->Get( nWhich );

			String aText( GetItemTitle( nWhich ) );

			if( pAnyItem->ISA(SfxRangeItem) )
			{
				aCurInsertedValueText.Erase();

				nItemFlags = GetItemFlags( pAnyItem );
				if( !(nItemFlags & ITEMFLAG_HIDE) &&
					(aItemSetList.Count()==1 || !(nItemFlags & ITEMFLAG_HIDE_IN_MULTISEL)))
				{
					if( GetRangeBitmaps( nWhich, aExpBmp, aColBmp ) )
						pEntry = (BrwListEntry*)InsertEntry(aText,aColBmp,aExpBmp,
								aParentStack.Top() );
					else
						pEntry = (BrwListEntry*)InsertEntry(aText,aParentStack.Top());
					pEntry->SetItem( pAnyItem );
					pEntry->SetItemFlags( nItemFlags );
				}

				aParentStack.Push( pEntry );

				SfxRangeItem* pRange = (SfxRangeItem*)pAnyItem;
				aRangeStack.Push( pRange );
				nFirstChild = pRange->From();
				nLastChild = pRange->To();
			}
			else
			{
				if ( SFX_ITEM_DONTCARE != eState )
				{
					// aCurInsertedValueText = pAnyItem->GetValueText();
					pAnyItem->GetPresentation(
						SFX_ITEM_PRESENTATION_COMPLETE, SFX_MAPUNIT_TWIP,
						SFX_MAPUNIT_TWIP,
						aCurInsertedValueText );
				}
				else
					aCurInsertedValueText.Erase();

				if( aParentStack.Count() )
				{
					SfxRangeItem* pRange = aRangeStack.Top();
					nFirstChild = pRange->From();
					nLastChild = pRange->To();
					if( nWhich>=nFirstChild && nWhich<=nLastChild )
					{
						nItemFlags = GetItemFlags( pAnyItem );
						if( !(nItemFlags & ITEMFLAG_HIDE) &&
							(aItemSetList.Count()==1 ||
							!(nItemFlags & ITEMFLAG_HIDE_IN_MULTISEL)))
						{
							if( GetItemBitmap( nWhich, aColBmp ) )
								pEntry = (BrwListEntry*)InsertEntry( aText,
										aColBmp,aColBmp,aParentStack.Top() );
							else
								pEntry=(BrwListEntry*)InsertEntry(aText,aParentStack.Top());
							pEntry->SetItem( pAnyItem );
							pEntry->SetItemFlags( nItemFlags );
						}
						if( nWhich==nLastChild )
						{
							aParentStack.Pop();
							aRangeStack.Pop();
						}
					}
				}
				else
				{
					nItemFlags = GetItemFlags( pAnyItem );
					if( !(nItemFlags & ITEMFLAG_HIDE) &&
						(aItemSetList.Count()==1 ||
						!(nItemFlags & ITEMFLAG_HIDE_IN_MULTISEL)))
					{
						if( GetItemBitmap( nWhich, aColBmp ) )
							pEntry=(BrwListEntry*)InsertEntry(aText,aColBmp,aColBmp,0);
						else
							pEntry = (BrwListEntry*)InsertEntry(aText, 0 );
						pEntry->SetItem( pAnyItem );
						pEntry->SetItemFlags( nItemFlags );
					}
				}
			}
			}
		}
		nWhich = aIter.NextWhich();
	}

	if( pNodeOpenList != 0 )
	{
		pEntry = (BrwListEntry*)First();

		while( pEntry )
		{
			pAnyItem = pEntry->GetItem();

			if( IsNodeOpen( pAnyItem->Which() ) )
			{
				if( GetModel()->HasChilds( pEntry ) )
					Expand( pEntry );
			}

			if( nCurrentWhich == pAnyItem->Which() )
				Select( pEntry, TRUE );

			pEntry = (BrwListEntry*)Next( pEntry );
		}
	}
	//else
	{
		pEntry = (BrwListEntry*)First();
		if( pEntry != 0 )
		{
			if( GetModel()->HasChilds( pEntry ) )
				Expand( pEntry );
		}
	}

	if( nCurrentWhich == 0 )
	{
		pEntry = (BrwListEntry*)First();
		if( pEntry != 0 )
			Select( pEntry, TRUE );
	}
}

BOOL ItemSetBrowser::IsNodeOpen( USHORT nWhich )
{
	const ImpNodeOpen* pNode = pNodeOpenList->First();

	while( pNode )
	{
		if( pNode->nWhichId == nWhich )
			return pNode->bIsOpen;
		pNode = pNodeOpenList->Next();
	}
	return FALSE;
}

BOOL ItemSetBrowser::IsEntryInView( BrwListEntry* pEntry ) const
{
	DBG_ASSERT(pEntry,"IsEntryInView:No Entry")
	BOOL bRet = FALSE;
	if ( IsEntryVisible( pEntry ))  // alle Parents expandiert ?
	{
		Point aPos(GetEntryPos(pEntry));
		Size aSize(GetOutputSizePixel());
		if ( aPos.Y() >= 0 && aPos.Y() < aSize.Height() )
			bRet = TRUE;
	}
	return bRet;
}

BOOL ItemSetBrowser::IsEntryInView( BrwListEntry* pEntry, Rectangle& rRect) const
{
	DBG_ASSERT(pEntry,"IsEntryInView:No Entry")
	BOOL bRet = FALSE;
	if ( IsEntryVisible( pEntry ) )  // alle Parents expandiert ?
	{
		Point aPos(GetEntryPos(pEntry));
		Size aSize(GetOutputSizePixel());
		if ( aPos.Y() >= 0 && aPos.Y() < aSize.Height() )
		{
			bRet = TRUE;
			rRect.SetPos( aPos );
			rRect.SetSize( Size(aSize.Width(), GetEntryHeight() ) );
		}
	}
	return bRet;
}

void __EXPORT ItemSetBrowser::SetValueTab( long nTab )
{
	CloseCurCtrl( TRUE );
	nValueTab = nTab;
	SetTabs();
	Invalidate();
}

void __EXPORT ItemSetBrowser::SetWhichRange( const Range& rRange )
{
	CloseCurCtrl( TRUE );
	aWhichRange = rRange;

	BOOL bOldUpdateMode = GetUpdateMode( );
	SetUpdateMode( FALSE );

	EvaluateAndHideCtrl();
	DeleteButtons();
	pCurSelected = 0;
	SvTreeListBox::Clear();
	SetEntryHeight( ENTRYHEIGHT );

	FillTree();
	SetUpdateMode( bOldUpdateMode );
}

void __EXPORT ItemSetBrowser::SetTabs()
{
	SvTreeListBox::SetTabs();
	AddTab( nValueTab, 0x0400 );
}

Rectangle __EXPORT ItemSetBrowser::GetFocusRect( SvLBoxEntry* pEntry, long nLine )
{
	Rectangle aRect( SvTreeListBox::GetFocusRect( pEntry, nLine ));
	aRect.Bottom()--;  // Trennlinie nicht ueberschreiben
	return aRect;
}

void __EXPORT ItemSetBrowser::InitEntry( SvLBoxEntry* pEntry,
	const String& rString, const Image& rColl, const Image& rExp )
{
	SvTreeListBox::InitEntry(pEntry, rString, rColl, rExp);
	ImpBrwString* pString=new ImpBrwString(this,pEntry,0,aCurInsertedValueText);
	pEntry->AddItem( pString );
}

String ItemSetBrowser::GetValueText( BrwListEntry* pEntry )
{
	DBG_ASSERT(pEntry,"SetValueText:No Entry")
	SvLBoxString* pStrItem = (SvLBoxString*)(pEntry->SvLBoxEntry::GetItem((pEntry->ItemCount()-1)));
	DBG_ASSERT(pStrItem->IsA()==SV_ITEM_ID_LBOXSTRING,"No StringItem")
	return pStrItem->GetText();
}

void ItemSetBrowser::SetValueText( BrwListEntry* pEntry, const String& rStr )
{
	DBG_ASSERT(pEntry,"SetValueText:No Entry")
	SvLBoxString* pStrItem = (SvLBoxString*)(pEntry->SvLBoxEntry::GetItem((pEntry->ItemCount()-1)));
	DBG_ASSERT(pStrItem->IsA()==SV_ITEM_ID_LBOXSTRING,"No StringItem")
	pStrItem->SetText( pEntry, rStr );
	Rectangle aRect;
	if( IsEntryInView(pEntry, aRect ))
	{
		aRect.Left() = nValueTab; // nur die Value invalidieren
		aRect.Bottom()--;		  // Linien nicht invalidieren
		Invalidate( aRect );
	}
}

#define DOTBUTTON_WIDTH_PIXEL	20
#define COMBOBUTTON_WIDTH_PIXEL	16

void ItemSetBrowser::ShowButtons( BrwListEntry* pEntry )
{
	if ( !pEntry )
		return;
	Point aEntryPos = GetEntryPos( pEntry );
	nCurLine = aEntryPos.Y();
	Size aOutputSize = GetOutputSizePixel();
	aEntryPos.X() = aOutputSize.Width();
	if ( pCurComboButton )
	{
		aEntryPos.X() -= COMBOBUTTON_WIDTH_PIXEL;
		pCurComboButton->SetPosPixel( aEntryPos );
		pCurComboButton->SetClickHdl(LINK(this,ItemSetBrowser,ComboClickHdl));
		pCurComboButton->Show();
	}
	if ( pCurDotButton )
	{
		aEntryPos.X() -= DOTBUTTON_WIDTH_PIXEL;
		pCurDotButton->SetPosPixel( aEntryPos );
		pCurDotButton->SetClickHdl(LINK(this,ItemSetBrowser,DotClickHdl));
		pCurDotButton->Show();
	}
	nLineLength = aEntryPos.X() - nValueTab;
}

void __EXPORT ItemSetBrowser::SelectHdl()
{
	BrwListEntry* pNewSelected = (BrwListEntry*)GetHdlEntry();
	if( !IsSelected(pNewSelected) )
		return;
	if ( pCurSelected )
	{
		// Linien manuell zeichnen, da beim Wechsel der Selektion
		// kein PaintEvent ausgeloest wird
		PaintBorderLines( pCurSelected );
		DeleteButtons();
	}
	pCurSelected = pNewSelected;
	nCurrentWhich = pCurSelected->GetItem()->Which();
	nCurItemType = GetItemType( pCurSelected->GetItem() );
	if ( pCurSelected->HasDotButton() )
	{
		pCurDotButton = new ImageButton( this, BTN_WINBITS );
		pCurDotButton->SetText( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "..." ) ) );
		pCurDotButton->SetSizePixel(Size(DOTBUTTON_WIDTH_PIXEL,GetEntryHeight()));
	}
	if ( pCurSelected->HasComboButton() )
	{
		pCurComboButton = new ImageButton( this, BTN_WINBITS  );
		pCurComboButton->SetImage( aComboBmp );
		pCurComboButton->SetSizePixel(Size(COMBOBUTTON_WIDTH_PIXEL,GetEntryHeight()));
	}
	ShowButtons( pCurSelected );
	PaintBorderLines( pCurSelected );
	SvTreeListBox::SelectHdl();
}

void ItemSetBrowser::HideButtons()
{
	if ( pCurDotButton )
		pCurDotButton->Hide();
	if ( pCurComboButton )
		pCurComboButton->Hide();
}

void __EXPORT ItemSetBrowser::NotifyBeginScroll()
{
	EvaluateAndHideCtrl();
	HideButtons();
}

void __EXPORT ItemSetBrowser::NotifyEndScroll()
{
	ShowButtons( pCurSelected );
}

void __EXPORT ItemSetBrowser::NotifyInvalidating()
{
	HideButtons();
}

void ItemSetBrowser::PaintBorderLines( BrwListEntry* pEntry )
{
	DBG_ASSERT(pEntry,"PaintBorderLine:No Entry")
	Point aPos( GetEntryPos( pEntry ));
	Color aOldCol = GetLineColor();
	SetLineColor( bSvLook ? Color( COL_GRAY ) : Color( COL_LIGHTGRAY ) );
	Size aSize( GetOutputSizePixel() );
	long nEntryHeight = GetEntryHeight();
	Point aStartPos( 0, aPos.Y() -1 );
	Point aEndPos( aSize.Width(), aPos.Y() - 1);
	if ( aPos.Y() )
		DrawLine( aStartPos, aEndPos );
	aStartPos.Y() += nEntryHeight;
	aEndPos.Y() = aStartPos.Y();
	DrawLine( aStartPos, aEndPos );
	SetLineColor( aOldCol );
}

void __EXPORT ItemSetBrowser::Paint( const Rectangle& rRect)
{
	SvTreeListBox::Paint( rRect );
	if ( !GetEntryCount() )
		return;

	Color aOldCol = GetLineColor();
	SetLineColor( bSvLook ? Color( COL_GRAY ) : Color( COL_LIGHTGRAY ) );
	long nEntryHeight = GetEntryHeight();

	long nEndLine = rRect.Bottom();
	Point aLastEntryPos = GetEntryPos( (SvLBoxEntry*)LastVisible() );
	aLastEntryPos.Y() += nEntryHeight;
	if ( aLastEntryPos.Y() < nEndLine )
		nEndLine = aLastEntryPos.Y();

	long nStartLine = (rRect.Top() / nEntryHeight) * nEntryHeight;
	if ( nStartLine )
		nStartLine = nEntryHeight;
	nStartLine--;
	Point aStartPos( 0, nStartLine );
	Point aEndPos( GetOutputSize().Width(), nStartLine );
	for( long nLine = nStartLine; nLine <= nEndLine; nLine += nEntryHeight )
	{
		DrawLine( aStartPos, aEndPos );
		aStartPos.Y() += nEntryHeight;
		aEndPos.Y() = aStartPos.Y();
	}
	aStartPos.X() = nValueTab;
	aStartPos.Y() = rRect.Top();
	aEndPos.X() = aStartPos.X();
	aEndPos.Y() = nEndLine-1;
	DrawLine( aStartPos, aEndPos );
	if ( SvLBox::nWindowStyle & WB_SVLOOK )
	{
		SetPen( Pen( Color( COL_WHITE )));
		aStartPos.X()++;
		aEndPos.X()++;
		aEndPos.Y()--;
		DrawLine( aStartPos, aEndPos );
	}
	SetLineColor( aOldCol );
	ShowButtons( pCurSelected );
}

void __EXPORT ItemSetBrowser::Resize()
{
	if ( !bOpeningCtrl )
		EvaluateAndHideCtrl();
	HideButtons();
	SvTreeListBox::Resize();
}

USHORT ItemSetBrowser::GetItemFlags( const SfxPoolItem* pItem )
{
	USHORT nRet = 0;
	USHORT nItemType = GetItemType( pItem );
	switch( nItemType )
	{
		case ITEMTYPE_INT16:
		case ITEMTYPE_INT32:
		case ITEMTYPE_UINT16:
		case ITEMTYPE_UINT32:
			nRet = ITEMFLAG_NUMBEREDIT;
			break;

		case ITEMTYPE_BOOL:
		case ITEMTYPE_ENUM:
		case ITEMTYPE_STRINGLIST:
			nRet = ITEMFLAG_COMBOBUTTON;
			break;

		case ITEMTYPE_COLOR:
			nRet = ITEMFLAG_COMBOBUTTON;  // erstmal nicht | ITEMFLAG_STRINGEDIT;
			break;

		case ITEMTYPE_RANGE:
			nRet = ITEMFLAG_DOTBUTTON;
			break;

		case ITEMTYPE_STRING:
			nRet = ITEMFLAG_STRINGEDIT;
			break;
	}
	return nRet;
}

void __EXPORT ItemSetBrowser::MouseButtonDown( const MouseEvent& rMEvt )
{
	if ( bStartTabSetting )
	{
		// ... starten ...
		CaptureMouse();
		bSettingTab = TRUE;
		bStartTabSetting = FALSE;
		PaintTabEmphasis(nValueTab );
		return;
	}

	bTabSettingDisabled = TRUE; // falls ListBox die Mouse captured

	BrwListEntry* pEntry = (BrwListEntry*)GetEntry( rMEvt.GetPosPixel() );
	BOOL bIsInValue = (BOOL)(pEntry && rMEvt.GetPosPixel().X() >= nValueTab);
	BOOL bCallBase = FALSE;
	if ( rMEvt.GetClicks() % 2 )
	{
		if ( bIsInValue && IsSelected(pEntry))
			ValueClick( pEntry, rMEvt );
		else
			bCallBase = TRUE;
	}
	else
	{
		if ( !pModel->HasChilds(pEntry) )
		{
			if ( bIsInValue && pEntry->HasComboButton() )
				ComboButtonClick( pEntry );
			else if( nCurItemType == ITEMTYPE_BOOL )
				ToggleItemValue( pCurSelected );
			else if( bIsInValue )
				ValueClick( pEntry, rMEvt );
			else
				bCallBase = TRUE;
		}
		else
			bCallBase = TRUE;
	}
	if ( bCallBase )
		SvTreeListBox::MouseButtonDown( rMEvt );
}

void __EXPORT ItemSetBrowser::MouseButtonUp( const MouseEvent& rMEvt )
{
	bTabSettingDisabled = FALSE;
	if ( bSettingTab )
	{
		ReleaseMouse();
		SetPointer( aOldPtr );
		bSettingTab = FALSE;
		PaintTabEmphasis( nValueTab );
		nValueTab = rMEvt.GetPosPixel().X();
		SetValueTab( nValueTab );
	}
	else
		SvTreeListBox::MouseButtonUp( rMEvt );
}

void __EXPORT ItemSetBrowser::MouseMove( const MouseEvent& rMEvt )
{
	if ( bSettingTab )
	{
		PaintTabEmphasis( nValueTab ); // +DIST_VALUETAB_LINE ); // loeschen
		nValueTab = rMEvt.GetPosPixel().X(); // - DIST_VALUETAB_LINE;
		PaintTabEmphasis( nValueTab ); //+DIST_VALUETAB_LINE );
		return;
	}

	if ( !bTabSettingDisabled )
	{
		long nX = rMEvt.GetPosPixel().X();
		long nLine = nValueTab; // + DIST_VALUETAB_LINE;
		if ( nX >= nLine-TABSET_DELTA && nX <= nLine+TABSET_DELTA )
		{
			if (  !bStartTabSetting )  // ist Pointer schon umgesetzt ?
			{
				aOldPtr = GetPointer();
				SetPointer( Pointer(POINTER_HSIZEBAR) );
				bStartTabSetting = TRUE;
			}
		}
		else
		{
			if ( bStartTabSetting )
			{
				SetPointer( aOldPtr );  // restaurieren
				bStartTabSetting = FALSE;
				SvTreeListBox::MouseMove( rMEvt );
			}
		}
	}
	else
		SvTreeListBox::MouseMove( rMEvt );
}

void ItemSetBrowser::PaintTabEmphasis( long nX )
{
	RasterOp eOldOp = GetRasterOp( );
	SetRasterOp( ROP_XOR );
	Pen aOldPen = GetPen( );
	SetPen( Pen( PEN_SOLID ));
	Point aStartPos( nX, 0 );
	Point aEndPos( nX, GetOutputSizePixel().Height() );
	DrawLine( aStartPos, aEndPos );
	SetPen( aOldPen );
	SetRasterOp( eOldOp );
}

void ItemSetBrowser::CheckPos( Point& rPosPix, const Size& rSizePix)
{
	Size aSizePix( GetOutputSizePixel() );

	// Anpassung der Hoehe

	long nStartLine = rPosPix.Y();
	long nHeight = rSizePix.Height();
	long nMaxHeight = aSizePix.Height();

	if( (nStartLine + nHeight)  >  nMaxHeight )
	{
		// Objekt endet ueber dem Entry
		nStartLine = nStartLine - nHeight - GetEntryHeight();
		if ( nStartLine < 0 )
			nStartLine = 0;
	}
	rPosPix.Y() = nStartLine;
}

void ItemSetBrowser::ShowNumberEdit( BrwListEntry* pEntry )
{
	ShowStringEdit( pEntry );
}

void ItemSetBrowser::ShowStringEdit( BrwListEntry* pEntry )
{
	DBG_ASSERT(pCurSelected==pEntry,"Selected entry out of sync")
	DBG_ASSERT(pEntry,"ShowStringEdit:No Entry")
	if ( !pEntry )
		return;

	bOpeningCtrl = TRUE;

	if ( nCurCtrlId != CTRLID_DONTKNOW )
		EvaluateAndHideCtrl();

	Size aTextSize;
	long nEntryHeight	= GetEntryHeight();

	Point aEntryPos( GetEntryPos( pEntry ));
	aEntryPos.X() = nValueTab + DIST_VALUETAB_VALUE - 2;

	if ( !pCurEdit )
		pCurEdit = new ImplEdCtrl( this );
	pCurEdit->Init();

	pCurEdit->SetClosedHdl(LINK(this,ItemSetBrowser,CtrlFinishedHdl));
	pCurEdit->SetKeyActionHdl(LINK(this,ItemSetBrowser,CtrlKeyActionHdl));

	SfxPoolItem* pItem = pEntry->GetItem();
	if( pCurSet->GetItemState( pItem->Which() ) == SFX_ITEM_DONTCARE )
		pCurEdit->SetText(GetDontCareValueText(pItem->Which(), pEntry));
	else
	{
		String aStr;
		pItem->GetPresentation(	SFX_ITEM_PRESENTATION_COMPLETE,
			SFX_MAPUNIT_TWIP, SFX_MAPUNIT_TWIP, aStr );
		pCurEdit->SetText( aStr );
	}

	// not implemented
	//	if ( pEntry->GetItemFlags() & ITEMFLAG_EDITCTRL_RDONLY )
	//		pCurEdit->SetReadOnly( TRUE );

	aTextSize.Width() = GetOutputSizePixel().Width() - aEntryPos.X() - 1;
	aTextSize.Height() = nEntryHeight - 1; // -nEdCtrlOffs-2;
	pCurEdit->SetPosSizePixel( aEntryPos, aTextSize );

	nCurCtrlId = CTRLID_SINGLEEDIT;
	pCurCtrl = pCurEdit;
	Wallpaper aOldWall;
	if ( !IsSVLook() )
	{
		// damits durch das Invalidate beim Show nicht flackert
		aOldWall = pCurEdit->GetBackground();
		SetBackground();
	}
	pCurEdit->Show();
	if ( !IsSVLook() )
		pCurEdit->SetBackground( aOldWall );
	pCurEdit->GrabFocus();
	bOpeningCtrl = FALSE;
}

void ItemSetBrowser::ShowMultiEdit( BrwListEntry* pEntry )
{
	DBG_ASSERT(pCurSelected==pEntry,"Selected entry out of sync")
	DBG_ASSERT(pEntry,"No Entry")

	bOpeningCtrl = TRUE;

	if ( nCurCtrlId != CTRLID_DONTKNOW )
		EvaluateAndHideCtrl();

	if ( !pCurMEdit )
		pCurMEdit = new ImplMultiLineEdCtrl( this, WB_BORDER | WB_VSCROLL );
	pCurMEdit->Init();

	pCurMEdit->SetClosedHdl(LINK(this,ItemSetBrowser,CtrlFinishedHdl));
	pCurMEdit->SetKeyActionHdl(LINK(this,ItemSetBrowser,CtrlKeyActionHdl));

	pCurMEdit->SetText( pEntry->GetItem() );

	// not implemented
	//	if ( pEntry->GetItemFlags() & ITEMFLAG_EDITCTRL_RDONLY )
	//		pCurMEdit->SetReadOnly( TRUE );

	long nEntryHeight = GetEntryHeight();
	Point aEntryPos( GetEntryPos( pEntry ));
	aEntryPos.X() = nValueTab + DIST_VALUETAB_VALUE - 2;
	aEntryPos.Y() += nEntryHeight;
	long nWidth = GetOutputSizePixel().Width();
	nWidth -= aEntryPos.X();
	Size aSize( nWidth, nEntryHeight*5 );
	CheckPos( aEntryPos, aSize );
	pCurMEdit->SetPosSizePixel( aEntryPos, aSize );

	nCurCtrlId = CTRLID_MULTIEDIT;
	pCurCtrl = pCurMEdit;
	pCurMEdit->Show();
	pCurMEdit->GrabFocus();
	bOpeningCtrl = FALSE;
}

void ItemSetBrowser::ShowListBox( BrwListEntry* pEntry )
{
	DBG_ASSERT(pCurSelected==pEntry,"Selected entry out of sync")
	DBG_ASSERT(pEntry,"No Entry")
	bOpeningCtrl = TRUE;
	if ( nCurCtrlId != CTRLID_DONTKNOW )
		EvaluateAndHideCtrl();

	if ( !pCurLBox )
		pCurLBox = new ImplListBoxCtrl( this, WB_BORDER );
	pCurLBox->Init();

	pCurLBox->SetClosedHdl(LINK(this,ItemSetBrowser,CtrlFinishedHdl));
	pCurLBox->SetKeyActionHdl(LINK(this,ItemSetBrowser,CtrlKeyActionHdl));
	pCurLBox->SetSelectHdl(LINK(this,ItemSetBrowser,CtrlSelectHdl));

	long nEntryHeight = GetEntryHeight();
	Point aEntryPos( GetEntryPos( pEntry ));
	aEntryPos.X() = nValueTab + DIST_VALUETAB_VALUE - 2;;
	aEntryPos.Y() += nEntryHeight;
	long nWidth = GetOutputSizePixel().Width();
	nWidth -= aEntryPos.X();
	pCurLBox->SetText( pEntry->GetItem() );
	nCurSelectedListPos = pCurLBox->GetSelectEntryPos( 0 );
	USHORT nEntryCount = pCurLBox->GetEntryCount();
	if( nEntryCount )
	{
		if ( nEntryCount > 5 )
			nEntryCount = 5;
		long nLBoxHeight = GetTextHeight();
		nLBoxHeight *= nEntryCount;
		nLBoxHeight += ( nEntryCount * 2 ) + 5;
		Size aSize( nWidth, nLBoxHeight );
		CheckPos( aEntryPos, aSize );
		pCurLBox->SetPosSizePixel( aEntryPos, aSize );

		pCurCtrl = pCurLBox;
		nCurCtrlId = CTRLID_LISTBOX;
		pCurLBox->Show();
		pCurLBox->GrabFocus();
	}
	bOpeningCtrl = FALSE;
}

void ItemSetBrowser::ShowColorWindow( BrwListEntry* pEntry )
{
	DBG_ASSERT(pCurSelected==pEntry,"Selected entry out of sync")
	DBG_ASSERT(pEntry,"No Entry")
	bOpeningCtrl = TRUE;
	if ( nCurCtrlId != CTRLID_DONTKNOW )
		EvaluateAndHideCtrl();

	if ( !pCurColWin )
		pCurColWin = new ImplColorWindow( this, WB_BORDER | WB_VSCROLL);
	pCurColWin->Init();
	nCurSelectedListPos = 0xffff; // wird im ColorSelectHdl auf 0 gesetzt
	pCurColWin->SetClosedHdl(LINK(this,ItemSetBrowser,CtrlFinishedHdl));
	pCurColWin->SetKeyActionHdl(LINK(this,ItemSetBrowser,CtrlKeyActionHdl));
	pCurColWin->SetSelectHdl(LINK(this,ItemSetBrowser,CtrlSelectHdl));

	long nEntryHeight = GetEntryHeight();
	Point aEntryPos( GetEntryPos( pEntry ));
	aEntryPos.X() = nValueTab + DIST_VALUETAB_VALUE - 2;;
	aEntryPos.Y() += nEntryHeight;
	long nWidth = GetOutputSizePixel().Width();
	nWidth -= aEntryPos.X();
	Size aSize( nWidth, nEntryHeight*5 );
	CheckPos( aEntryPos, aSize );
	pCurColWin->SetPosSizePixel( aEntryPos, aSize );
	pCurColWin->SetColor( ((SvxColorItem*)(pEntry->GetItem()))->GetValue() );

	pCurCtrl = pCurColWin;
	nCurCtrlId = CTRLID_COLWIN;
	pCurColWin->Show();
	pCurColWin->GrabFocus();
	bOpeningCtrl = FALSE;
}

IMPL_LINK_INLINE_START( ItemSetBrowser, CtrlFinishedHdl, Window *, EMPTYARG )
{
	DBG_ASSERT(pCurSelected,"No selected entry")
	EvaluateAndHideCtrl();
	return 0;
}
IMPL_LINK_INLINE_END( ItemSetBrowser, CtrlFinishedHdl, Window *, EMPTYARG )

IMPL_LINK_INLINE_START( ItemSetBrowser, CtrlKeyActionHdl, Window *, pCtrl )
{
	return 0;
}
IMPL_LINK_INLINE_END( ItemSetBrowser, CtrlKeyActionHdl, Window *, pCtrl )

IMPL_LINK( ItemSetBrowser, CtrlSelectHdl, Window *, pCtrl )
{
	String aStr;
	switch( nCurCtrlId )
	{
		case CTRLID_LISTBOX:
			nCurSelectedListPos = pCurLBox->GetSelectEntryPos( 0 );
			if ( pCurLBox->IsTravelSelect() )
				SetValueText( pCurSelected, pCurLBox->GetSelectEntry());
			else
				pCurLBox->Close();
			break;

		case CTRLID_COLWIN:
			nCurSelectedListPos = 0; // es wurde eine Farbe ausgewaehlt
			aCurSelectedColor = pCurColWin->GetColor();
			pCurColWin->Close();
			break;

		default:
			DBG_ASSERT(0,"Unknown Control-Id");
	}
	return 0;
}

BOOL ItemSetBrowser::ToggleItemValue( BrwListEntry* pEntry )
{
	DBG_ASSERT(pEntry,"ToggleItemValue:No Entry")
	if( !pEntry )
		return FALSE;

	SfxPoolItem* pItem = pEntry->GetItem();
	SfxPoolItem* pNewItem = pItem->Clone();
	if ( pItem->ISA(SfxBoolItem) )
	{
		SfxBoolItem* pBool = (SfxBoolItem*)pNewItem;
		pBool->SetValue( !(pBool->GetValue()));

	}
	else if ( pItem->ISA(SfxEnumItem))
	{
		SfxEnumItem* pEnum = (SfxEnumItem*)pNewItem;
		USHORT nCurValue = pEnum->GetEnumValue();
		nCurValue++;
		if ( nCurValue >= pEnum->GetValueCount() )
			nCurValue = 0;
		pEnum->SetEnumValue( nCurValue );
	}
	else
		return FALSE;

	BOOL bChanged = SetItemValue( pNewItem->Which(), pNewItem, pEntry );
	delete pNewItem;
	return bChanged;
}

String ItemSetBrowser::GetDontCareValueText(USHORT nWhich, BrwListEntry* pEntry)
{
	DBG_ASSERT(pEntry,"DontCareText:No Entry")
	DBG_ASSERT(aItemSetList.Count()>0,"DontCareText:Empty List")
	SfxItemSet* pRefSet = (SfxItemSet*)aItemSetList.GetObject(0);
	const SfxPoolItem* pRefItem = &pRefSet->Get( nWhich );
	String aStr;
	pRefItem->GetPresentation(SFX_ITEM_PRESENTATION_COMPLETE,
		SFX_MAPUNIT_TWIP, SFX_MAPUNIT_TWIP, aStr );
	return aStr;
}

BOOL ItemSetBrowser::SetItemValue(USHORT nWhichId, const SfxPoolItem* pNewItem,
								  BrwListEntry* pEntry	)
{
	BOOL bChanged = NotifyChangingItem( nWhichId, pNewItem );
	if ( bChanged )
	{
		pCurSet->Put( *pNewItem );
		SfxItemSet* pListSet = (SfxItemSet*)aItemSetList.First();
		do  // alle Itemsets updaten
		{
			pListSet->Put( *pNewItem );
				pListSet = (SfxItemSet*)aItemSetList.Next();
		} while( pListSet );
		pEntry->SetItem( &(pCurSet->Get( nWhichId )));
		String aStr;
		pNewItem->GetPresentation(SFX_ITEM_PRESENTATION_COMPLETE,
			SFX_MAPUNIT_TWIP, SFX_MAPUNIT_TWIP, aStr);
		SetValueText( pEntry, aStr ); // pNewItem->GetValueText() );

		nModifyId = nWhichId;
		Modify();
		nModifyId = 0;
	}
	return bChanged;
}

void ItemSetBrowser::EvaluateAndHideCtrl()
{
	if( nCurCtrlId == CTRLID_DONTKNOW )
		return;
	DBG_ASSERT(pCurCtrl,"EvaluateCtrl:No Control")
	if ( !pCurCtrl )
		return;

	String aValue;
	BOOL bChangeItem = TRUE;

	SfxPoolItem* pCurItem = pCurSelected->GetItem();
	SfxPoolItem* pNewItem = pCurItem->Clone();
	USHORT nCurWhich = pCurItem->Which();

	USHORT nTempCtrlId = nCurCtrlId;
	nCurCtrlId = CTRLID_DONTKNOW;
	switch( nTempCtrlId )
	{
		case CTRLID_SINGLEEDIT:
			pCurEdit->Hide();
			if ( pCurEdit->IsCancel() )
				bChangeItem = FALSE;
			else
			{
				aValue = pCurEdit->GetText();
				bChangeItem=NotifyConvertToItemValue(pNewItem,aValue,nCurItemType);
			}
			break;

		case CTRLID_MULTIEDIT:
			bComboListExpanded = FALSE;
			pCurMEdit->Hide();
			if ( pCurMEdit->IsCancel() )
				bChangeItem = FALSE;
			else
			{
				aValue = pCurMEdit->GetText();
				bChangeItem=NotifyConvertToItemValue(pNewItem,aValue,nCurItemType);
			}
			break;

		case CTRLID_LISTBOX:
			pCurLBox->Hide();
			bComboListExpanded = FALSE;
			if ( pCurLBox->IsCancel() )
			{
				bChangeItem = FALSE;
				String aStr;
				pCurItem->GetPresentation(
					SFX_ITEM_PRESENTATION_COMPLETE, SFX_MAPUNIT_TWIP,
						SFX_MAPUNIT_TWIP , aStr );
				SetValueText( pCurSelected, aStr );
			}
			else
			{
				switch( nCurItemType )
				{
					case ITEMTYPE_ENUM:
						((SfxEnumItem*)pNewItem)->SetEnumValue(nCurSelectedListPos);
						break;
					case ITEMTYPE_BOOL:
						((SfxBoolItem*)pNewItem)->SetValue((BOOL)nCurSelectedListPos);
						break;
					case ITEMTYPE_STRING:
						((SfxStringItem*)pNewItem)->SetValue(pCurLBox->GetSelectEntry());
						break;
					default:
						DBG_ASSERT(0,"ListBox: Item type not supported");
				}
			}
			break;

		case CTRLID_COLWIN:
			pCurColWin->Hide();
			bComboListExpanded = FALSE;
			// Farbe nur uebernehmen, wenn sie geaendert wurde
			if ( pCurColWin->IsCancel() || nCurSelectedListPos==0xffff)
				bChangeItem = FALSE;
			else
				((SvxColorItem*)pNewItem)->SetValue( aCurSelectedColor );
			break;

		default:
			bChangeItem = FALSE;
			DBG_ASSERT(0,"Unknown Control-Id");
	}
	if ( !bChangeItem )
	{
		// InfoBox(this,"Cannot convert").Execute();
		if ( pCurSet->GetItemState( nCurWhich ) == SFX_ITEM_DONTCARE )
			SetValueText( pCurSelected, String() );
	}
	else
	{
		if ( !(*pCurItem == *pNewItem ) )
			SetItemValue( nCurWhich, pNewItem, pCurSelected );
	}
	delete pNewItem;
	pCurCtrl = 0;
}

void ItemSetBrowser::ValueClick(BrwListEntry* pEntry,const MouseEvent& rMEvt)
{
	USHORT nFlags = pEntry->GetItemFlags();
	if ( nFlags & ( ITEMFLAG_STRINGEDIT | ITEMFLAG_NUMBEREDIT) )
	{
		ShowStringEdit( pEntry );
		Point aPos( rMEvt.GetPosPixel() );
		aPos = LogicToPixel( aPos );
		aPos = OutputToScreenPixel( aPos );
		aPos = pCurEdit->ScreenToOutputPixel( aPos );
		MouseEvent aMEvt ( aPos, 1, rMEvt.GetMode(),
						  rMEvt.GetButtons(), rMEvt.GetModifier() );
		pCurEdit->MouseButtonDown( aMEvt );  // Cursor positionieren
		pCurEdit->MouseButtonUp( aMEvt );
	}
}

void ItemSetBrowser::ComboButtonClick( BrwListEntry* pEntry )
{
	aComboClickHdl.Call( this );
	if ( bComboListExpanded )
		EvaluateAndHideCtrl();
	else
	{
		bComboListExpanded = TRUE;
		switch( nCurItemType )
		{
			case ITEMTYPE_STRINGLIST:
				ShowMultiEdit( pEntry );
				break;
			case ITEMTYPE_ENUM:
				ShowListBox( pEntry );
				break;
			case ITEMTYPE_BOOL:
				ShowListBox( pEntry );
				pCurLBox->SetText( pEntry->GetItem() );
				break;
			case ITEMTYPE_COLOR:
				ShowColorWindow( pEntry );
				break;
			default:
				ShowListBox( pEntry );
		}
	}
}

void __EXPORT ItemSetBrowser::DotButtonClick( BrwListEntry* )
{
	aDotClickHdl.Call( this );
	SetUpdateMode( TRUE );
	Invalidate();
}

IMPL_LINK_INLINE_START( ItemSetBrowser, DotClickHdl, ImageButton *, EMPTYARG )
{
	DotButtonClick( pCurSelected );
	HideButtons();  // neu in 1.18 (23.April)
	ShowButtons( pCurSelected ); // neu in 1.18 (23.April)
	return 0;
}
IMPL_LINK_INLINE_END( ItemSetBrowser, DotClickHdl, ImageButton *, EMPTYARG )

IMPL_LINK_INLINE_START( ItemSetBrowser, ComboClickHdl, ImageButton *, EMPTYARG )
{
	ComboButtonClick( pCurSelected );
	return 0;
}
IMPL_LINK_INLINE_END( ItemSetBrowser, ComboClickHdl, ImageButton *, EMPTYARG )

void __EXPORT ItemSetBrowser::LoseFocus()
{
	SvTreeListBox::LoseFocus();
	// damit ein neu erzeugtes Control nicht gleich wieder geschlossen wird
	if ( !bOpeningCtrl )
		EvaluateAndHideCtrl();
}

BOOL ItemSetBrowser::NotifyConvertToItemValue( SfxPoolItem* pItem,
	const String& rValue, USHORT nItemType )
{
	BOOL bRet = FALSE;
	BOOL bIsUINT32 = TRUE;
	BOOL bIsINT32 = TRUE;
	const sal_Unicode* pStartPos = (const sal_Unicode*)rValue.GetBuffer();
	const sal_Unicode* pEndPos = pStartPos + rValue.Len();

	INT32 nINT32 = rValue.ToInt32();
	if ( /*pEndPtr != pEndPos || */!rValue.Len() )
		bIsINT32 = FALSE;

	UINT32 nUINT32 = rValue.ToInt64();
	if ( /*pEndPtr != pEndPos || */!rValue.Len()  )
		bIsUINT32 = FALSE;

	switch( nItemType )
	{
		case ITEMTYPE_DONTKNOW:
			break;

		case ITEMTYPE_STRING:
			((SfxStringItem*)pItem)->SetValue( rValue );
			bRet = TRUE;
			break;

		case ITEMTYPE_INT16:
			if ( bIsINT32 &&
				 (((SfxInt16Item*)pItem)->GetMin() <= (INT16)nINT32) &&
				 (((SfxInt16Item*)pItem)->GetMin() <= (INT16)nINT32) )
			{
				((SfxInt16Item*)pItem)->SetValue((INT16)nINT32);
				bRet = TRUE;
			}
			break;

		case ITEMTYPE_INT32:
			if ( bIsINT32 &&
				 (((SfxInt32Item*)pItem)->GetMin() <= nINT32) &&
				 (((SfxInt32Item*)pItem)->GetMin() <= nINT32) )
			{
				((SfxInt32Item*)pItem)->SetValue(nINT32);
				bRet = TRUE;
			}
			break;

		case ITEMTYPE_UINT16:
			if ( bIsUINT32 &&
				 (((SfxUInt16Item*)pItem)->GetMin() <= (UINT16)nUINT32) &&
				 (((SfxUInt16Item*)pItem)->GetMin() <= (UINT16)nUINT32) )
			{
				((SfxUInt16Item*)pItem)->SetValue((UINT16)nUINT32);
				bRet = TRUE;
			}
			break;

		case ITEMTYPE_UINT32:
			if ( bIsUINT32 &&
				 (((SfxUInt32Item*)pItem)->GetMin() <= nUINT32) &&
				 (((SfxUInt32Item*)pItem)->GetMin() <= nUINT32) )
			{
				((SfxUInt32Item*)pItem)->SetValue(nUINT32);
				bRet = TRUE;
			}
			break;

		case ITEMTYPE_STRINGLIST:
			((SfxStringListItem*)pItem)->SetString( rValue );
			bRet = TRUE;
			break;

		case ITEMTYPE_RANGE:
			break;

		case ITEMTYPE_COLOR:
			break;
	}
	return bRet;
}

BOOL ItemSetBrowser::NotifyChangingItem( USHORT nWhich, const SfxPoolItem* )
{
	return TRUE;
}

USHORT ItemSetBrowser::GetItemType( const SfxPoolItem* pItem )
{
	USHORT nType = ITEMTYPE_DONTKNOW;
	if ( pItem->ISA(SfxRangeItem) )
		nType = ITEMTYPE_RANGE;
	else if( pItem->ISA(SfxInt16Item) )
		nType = ITEMTYPE_INT16;
	else if( pItem->ISA(SfxUInt16Item) )
		nType = ITEMTYPE_UINT16;
	else if( pItem->ISA(SfxInt32Item) )
		nType = ITEMTYPE_INT32;
	else if( pItem->ISA(SfxUInt32Item) )
		nType = ITEMTYPE_UINT32;
	else if( pItem->ISA(SvxColorItem) )
		nType = ITEMTYPE_COLOR;
	else if( pItem->ISA(SfxBoolItem) )
		nType = ITEMTYPE_BOOL;
	else if( pItem->ISA(SfxEnumItem) )
		nType = ITEMTYPE_ENUM;
	else if( pItem->ISA(SfxStringItem) )
		nType = ITEMTYPE_STRING;
	else if( pItem->ISA(SfxStringListItem) )
		nType = ITEMTYPE_STRINGLIST;
	return nType;
}

void ItemSetBrowser::Modify()
{
	aModifyHdl.Call( this );
}

void __EXPORT ItemSetBrowser::KeyInput( const KeyEvent& rKEvt )
{
	SvTreeListBox::KeyInput(rKEvt);
	if ( pCurSelected )
	{
		KeyCode aKeyCode = rKEvt.GetKeyCode();
		if ( !pCurCtrl && rKEvt.GetCharCode() == ' ' )
		{
			if( pCurSelected->HasComboButton() )
				ComboButtonClick( pCurSelected );
			else
			if( pCurSelected->HasDotButton() )
				DotButtonClick( pCurSelected );
			else
				ValueClick( pCurSelected, MouseEvent() );
		}
		else switch ( aKeyCode.GetCode() )
		{
			case KEY_UP:
			case KEY_DOWN:
				if (  aKeyCode.IsMod2() )
				{
					if ( pCurSelected->HasComboButton() )
						ComboButtonClick( pCurSelected );
					else
						ValueClick( pCurSelected, MouseEvent() );
				}
				break;
		}
	}
}

void __EXPORT ItemSetBrowser::ExpandedHdl()
{
	BrwListEntry* pEntry  = (BrwListEntry*)GetHdlEntry();
	BOOL bOpen 			  = IsExpanded( pEntry );
	SfxPoolItem* pAnyItem = pEntry->GetItem();
	SetNodeOpen( pAnyItem->Which(), bOpen );
}

void ItemSetBrowser::SetNodeOpen( USHORT nWhich, BOOL bOpen )
{
	DBG_ASSERT(pNodeOpenList,"SetNodeOpen:No NodeList");
	ImpNodeOpen* pNode = pNodeOpenList->First();
	while( pNode )
	{
		if( pNode->nWhichId == nWhich )
		{
			pNode->bIsOpen = bOpen;
			break;
		}
		pNode = pNodeOpenList->Next();
	}
}

void ItemSetBrowser::DrawTabLine( long nY )
{
	nY--;
	Color aOldCol = GetLineColor();
	SetLineColor( bSvLook ? Color( COL_GRAY ) : Color( COL_LIGHTGRAY ) );
	Point aStartPos( nValueTab, nY );
	Point aEndPos( nValueTab, nY );
	aEndPos.Y() += GetEntryHeight();
	DrawLine( aStartPos, aEndPos );
	if ( SvLBox::nWindowStyle & WB_SVLOOK )
	{
		SetPen( Pen( Color( COL_WHITE )));
		aStartPos.X()++;
		aEndPos.X()++;
		aEndPos.Y()--;
		DrawLine( aStartPos, aEndPos );
	}
	SetLineColor( aOldCol );
}

void ItemSetBrowser::Update( USHORT nWhich )
{
	if( !pCurSet )
		return;

	const SfxPoolItem* pAnyItem;
	SfxItemState eState = pCurSet->GetItemState( nWhich, TRUE, &pAnyItem);
	// if(  eState == SFX_ITEM_DONTCARE )
	BOOL bUpdateEntry = FALSE;
	BrwListEntry* pEntry = GetListEntry( nWhich );
	if( !pEntry )
		return;

	if( aItemSetList.Count() == 1 )
	{
		pCurSet->Put( ((SfxItemSet*)aItemSetList.First())->Get(nWhich) );
		bUpdateEntry = TRUE;
	}
	else
	{
		if( IsInAllItemSets( nWhich ) )
		{
			const SfxPoolItem* pCurItem= &(((SfxItemSet*)aItemSetList.First())->Get(nWhich));
			pCurSet->Put( *pCurItem );
			if( IsDontCare( pCurItem ) )
				pCurSet->InvalidateItem( nWhich );
			bUpdateEntry = TRUE;
		}
	}
	if( bUpdateEntry )
	{
		const SfxPoolItem* pCurItem= &( pCurSet->Get(nWhich) );
		pEntry->SetItem( pCurItem );
		String aStr;
		pCurItem->GetPresentation(SFX_ITEM_PRESENTATION_COMPLETE,
			SFX_MAPUNIT_TWIP, SFX_MAPUNIT_TWIP, aStr);
		SetValueText( pEntry, aStr );
	}
}

BrwListEntry* ItemSetBrowser::GetListEntry( USHORT nWhich )
{
	BrwListEntry* pEntry = (BrwListEntry*)First();
	while( pEntry )
	{
		SfxPoolItem* pItem = pEntry->GetItem();
		if( pItem->Which() == nWhich )
			return pEntry;
		pEntry = (BrwListEntry*)Next( pEntry );
	}
	return 0;
}

void ItemSetBrowser::CloseCurCtrl( BOOL bCancel )
{
	if( !pCurCtrl )
		return;

	switch( nCurCtrlId )
	{
		case CTRLID_SINGLEEDIT:
			pCurEdit->Close( bCancel );
			break;

		case CTRLID_MULTIEDIT:
			pCurMEdit->Close( bCancel );
			break;

		case CTRLID_LISTBOX:
			pCurLBox->Close( bCancel );
			break;

		case CTRLID_COLWIN:
			pCurColWin->Close( bCancel );
			break;
	}
}

String ItemSetBrowser::GetItemDropDownData( USHORT nWhichId )
{
	String aStr = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "this\nis\na\nrecording" ) );
	return aStr;
}


