/*************************************************************************
 *
 *  $RCSfile: formdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_MACRO 11111
#ifndef _MACROPG_HXX
#include <sfx2/macropg.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif
#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SFX_SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#pragma hdrstop

#ifndef _FORMDLG_HXX
#include "formdlg.hxx"
#endif
#ifndef _FORMDLG_HRC
#include "formdlg.hrc"
#endif
#ifndef _VCFORM_HXX
#include "vcform.hxx"
#endif
#ifndef _VCONT_HXX
#include "vcont.hxx"
#endif
#ifndef _VCATTR_HXX
#include "vcattr.hxx"
#endif
#ifndef _VCTRLS_HXX
#include "vctrls.hxx"
#endif
#ifndef _SIRESID_HXX
#include "siresid.hxx"
#endif

#define NAME_MODIFIED		0x0001
#define URL_MODIFIED		0x0002
#define METHOD_MODIFIED		0x0004
#define IS_STDFORM			0x0008	// in LBox ist die Standardform selektiert
#define TARGET_MODIFIED		0x0010
#define LIST_IS_STDFORM		0x0020
#define MACROS_MODIFIED		0x0040

VCFormDialog::VCFormDialog(
	Window* pParent, const ResId & rResId,
	VCManager* pManager, const String& rCurForm ) : ModalDialog( pParent, rResId ),
	aLBFormNames( this, ResId( LB_FORMS ) ),
	aFTFormName( this, ResId( FT_NAME ) ),
	aEDFormName( this, ResId( ED_NAME ) ),
	aFTURL( this, ResId( FT_URL ) ),
	aEDURL( this, ResId( ED_URL ) ),
	aRBGet( this, ResId( RB_GET ) ),
	aRBPost( this, ResId( RB_POST ) ),
	aGBMethod( this, ResId( GB_METHOD ) ),
	aBTOK( this, ResId( BT_OK ) ),
	aBTEnd( this, ResId( BT_END ) ),
	aBTNew( this, ResId( BT_NEW ) ),
	aBTChange( this, ResId( BT_CHG ) ),
	aBTDelete( this, ResId( BT_DEL ) ),
	aBTMacros( this, ResId( BT_MACROS ) ),
	aFTTarget( this, ResId( FT_TARGET )),
	aCBTarget( this, ResId( CB_TARGET)),
	aLBEncType( this, ResId( LB_ENCTYPE)),
	aFTEncType( this, ResId( FT_ENCTYPE)),
	pMgr( pManager ),
	nState(0),
	pPool(0)
{
	FreeResource();

	pMacros = new SvxMacroTableDtor;

	aLBFormNames.SetDoubleClickHdl(LINK(this,VCFormDialog,DoubleClickHdl));
	aLBFormNames.SetSelectHdl(LINK(this,VCFormDialog,SelectHdl));
	aLBEncType.SetSelectHdl(LINK(this,VCFormDialog,SelectHdl));

	Link aModifyHdl( LINK(this,VCFormDialog,ModifyHdl ));
	aEDURL.SetModifyHdl( aModifyHdl );
	aEDFormName.SetModifyHdl( aModifyHdl );
	aCBTarget.SetModifyHdl( aModifyHdl );

	Link aClickHdl( LINK(this,VCFormDialog,ClickHdl) );
	aBTOK.SetClickHdl( aClickHdl );
	aBTEnd.SetClickHdl( aClickHdl );
	aBTNew.SetClickHdl( aClickHdl );
	aBTChange.SetClickHdl( aClickHdl );
	aBTDelete.SetClickHdl( aClickHdl );
	aRBGet.SetClickHdl( aClickHdl );
	aRBPost.SetClickHdl( aClickHdl );
	aBTMacros.SetClickHdl( aClickHdl );

	FillTargetBox();

	ULONG nCount = pMgr->FormCount();
	for( ULONG nCurForm=0; nCurForm < nCount; nCurForm++ )
		aLBFormNames.InsertEntry( pMgr->GetFormByPos(nCurForm)->GetName() );
	String aCurForm( rCurForm );
	if( !aCurForm.Len() )
		aCurForm = aLBFormNames.GetEntry( 0 );

	SetCurVCForm( aCurForm );
}

VCFormDialog::~VCFormDialog()
{
	delete pMacros;
	DeinitPool();
}

void VCFormDialog::SetCurVCForm( const String& rFormName )
{
	aLBFormNames.SelectEntry( rFormName );
	VCForm* pForm = pMgr->GetFormByName( rFormName );
	DBG_ASSERT(pForm,"Form not found");
	aEDFormName.SetText( pForm->GetName() );
	aEDURL.SetText( pForm->GetURL() );

	aCBTarget.SetText( pForm->GetTargetName() );

	USHORT nMethod = pForm->GetMethod();
	if( nMethod == FORMMETH_POST )
		aRBPost.Check();
	else
		aRBGet.Check();

	SetEncoding( pForm->GetEncoding() );

	nState = 0;
	if( rFormName.ICompare( String(SiResId(STR_STDFORM))) == COMPARE_EQUAL )
		nState |= IS_STDFORM;
	if( aLBFormNames.GetSelectEntry() == String(SiResId(STR_STDFORM)))
		nState |= LIST_IS_STDFORM;

	pMacros->DelDtor();
	*pMacros = pForm->GetHandlers();
	EnableButtons();
}

void VCFormDialog::CreateVCForm()
{
	DBG_ASSERT(nState & NAME_MODIFIED,"Formname not modified");
	String aFormName( aEDFormName.GetText() );
	VCForm* pForm = pMgr->InsertForm(aEDURL.GetText(),GetMethod(), "",&aFormName);
	pForm->SetTargetName( aCBTarget.GetText() );
	pForm->SetHandlers( *pMacros );
	pForm->SetEncoding( GetEncoding() );
	aLBFormNames.InsertEntry( aFormName );
	SetCurVCForm( aFormName );
}

void VCFormDialog::ChangeVCForm()
{
	VCForm* pForm = pMgr->GetFormByName( aLBFormNames.GetSelectEntry() );
	DBG_ASSERT(pForm,"Form not found");
	pForm->SetURL( aEDURL.GetText() );
	pForm->SetMethod( GetMethod() );
	String aNewFormName( aEDFormName.GetText() );
	pForm->SetName( aNewFormName );
	aLBFormNames.RemoveEntry( aLBFormNames.GetSelectEntry() );
	aLBFormNames.InsertEntry( aNewFormName );
	pForm->SetTargetName( aCBTarget.GetText() );
	pForm->SetHandlers( *pMacros );
	pForm->SetEncoding( GetEncoding() );
	SetCurVCForm( aNewFormName );
}

void VCFormDialog::DeleteVCForm()
{
	VCForm* pForm = pMgr->GetFormByName( aLBFormNames.GetSelectEntry() );
	DBG_ASSERT(pForm,"Form not found");

	// Controls an Standardform haengen
	String aName( String(SiResId(STR_STDFORM) ));
	VCControl* pCtrl;
	while( pCtrl = pForm->GetControl( 0 ) )
		pCtrl->SetFormName( aName );
	pMgr->RemoveAndDeleteForm( pForm );
	aLBFormNames.RemoveEntry( aLBFormNames.GetSelectEntry() );
	//HACK, da Listbox nach Remove keinen neuen Eintrag selektiert
	aLBFormNames.SelectEntry( aLBFormNames.GetEntry(0) );
	SetCurVCForm( aLBFormNames.GetSelectEntry() );
}


IMPL_LINK( VCFormDialog, DoubleClickHdl, ListBox*, pList )
{
	aClosedForm = aLBFormNames.GetSelectEntry();
	EndDialog( TRUE );
	return 0;
}

IMPL_LINK( VCFormDialog, SelectHdl, ListBox*, pList )
{
	if( pList == &aLBFormNames )
	{
		SetCurVCForm( pList->GetSelectEntry() );
		if( nState & IS_STDFORM )
			nState |= LIST_IS_STDFORM;
	}
	else
	{
		nState |= TARGET_MODIFIED;
		if( !aRBPost.IsChecked() && GetEncoding() == "multipart/form-data")
		{
			nState |= METHOD_MODIFIED;
			aRBPost.Check();
		}
		EnableButtons();
	}
	return 0;
}

IMPL_LINK( VCFormDialog, ModifyHdl, Edit*, pEdit )
{
	if( pEdit == &aEDFormName )
	{
		String aText = pEdit->GetText();
		VCForm* pForm = pMgr->GetFormByName( aText );
		if( pForm )
			nState &= ~NAME_MODIFIED;
		else
			nState |= NAME_MODIFIED;
		if( aText.ICompare( String(SiResId(STR_STDFORM))) == COMPARE_EQUAL )
			nState |= IS_STDFORM;
		else
			nState &= ~IS_STDFORM;
	}
	else if( pEdit==&aEDURL )
		nState |= URL_MODIFIED;
	else
		nState |= TARGET_MODIFIED;
	EnableButtons();
	return 0;
}

IMPL_LINK( VCFormDialog, ClickHdl, Button*, pBtn )
{
	if( pBtn == &aBTOK )
	{
		if( aBTChange.IsEnabled() )
			ChangeVCForm();
		aClosedForm = aLBFormNames.GetSelectEntry();
		EndDialog( TRUE );
	}
	else if( pBtn == &aBTEnd )
		EndDialog( FALSE );
	else if( pBtn == &aBTNew )
		CreateVCForm();
	else if( pBtn == &aBTChange )
		ChangeVCForm();
	else if( pBtn == &aBTDelete )
		DeleteVCForm();
	else if( pBtn == &aRBGet || pBtn == &aRBPost )
	{
		nState |= METHOD_MODIFIED;
		EnableButtons();
	}
	else if( pBtn == &aBTMacros )
	{
		EditMacros();
		EnableButtons();
	}
	return 0;
}


/*                      TARGET_MODIFIED
		  NAME_MODIFIED URL_MODIFIED METHOD_MODIFIED IS_STDFORM
----------------------------------------------------------------
Neu            1              *             *               *

Aendern        1              0             1               0
			   1              1             0               0
			   1              1             1               0
			   0              0             1               *
			   0			  1             0               *
			   0			  1             1               *

Loeschen       0              *             *               0

*/

void VCFormDialog::EnableButtons()
{
	USHORT nNameLen = aEDFormName.GetText().Len();
	if( !nNameLen )
	{
		aBTChange.Disable();
		aBTDelete.Disable();
		aBTNew.Disable();
		return;
	}

	// AENDERN
	if( !(nState & (IS_STDFORM|LIST_IS_STDFORM)))
	{
		if(nState & (MACROS_MODIFIED| URL_MODIFIED | METHOD_MODIFIED | NAME_MODIFIED | TARGET_MODIFIED))
			aBTChange.Enable();
		else
			aBTChange.Disable();
	}
	else
	{
		if(nState & (MACROS_MODIFIED | URL_MODIFIED | METHOD_MODIFIED | TARGET_MODIFIED))
			aBTChange.Enable();
		else
			aBTChange.Disable();
	}

	// LOESCHEN
	if( !(nState & (NAME_MODIFIED | IS_STDFORM)) )
		aBTDelete.Enable();
	else
		aBTDelete.Disable();

	// NEU
	if( nState & NAME_MODIFIED )
		aBTNew.Enable();
	else
		aBTNew.Disable();
}

USHORT VCFormDialog::GetMethod() const
{
	if( aRBPost.IsChecked() )
		return FORMMETH_POST;
	return FORMMETH_GET;
}

void VCFormDialog::FillTargetBox()
{
	SfxViewFrame* pViewFrame = SfxViewFrame::Current();
	SfxFrame* pTop = pViewFrame->GetTopFrame();
	TargetList aTargetList;
	pTop->GetTargetList( aTargetList );
	ULONG nCount = aTargetList.Count();
	for( ULONG nCur = 0; nCur < nCount; nCur++ )
		aCBTarget.InsertEntry( *aTargetList.GetObject(nCur),COMBOBOX_APPEND);
	for( nCur = 0; nCur < nCount; nCur++ )
		delete aTargetList.GetObject(nCur);
}

SfxItemInfo __READONLY_DATA aItemInfos2[] =
{
	{ 0, SFX_ITEM_POOLABLE }
};

void VCFormDialog::InitPool()
{
	pPool = new SfxItemPool(
		"VCFormDialog", SID_ATTR_MACROITEM, SID_ATTR_MACROITEM
		,&aItemInfos2[0]
	);
	ppPoolDefaults = new SfxPoolItem*;
	*ppPoolDefaults = new SvxMacroItem( SID_ATTR_MACROITEM );
	pPool->SetDefaults( ppPoolDefaults );
}

void VCFormDialog::DeinitPool()
{
	if( pPool )
	{
		delete pPool;
		SfxItemPool::ReleaseDefaults( ppPoolDefaults, 1, TRUE );
	}
}

void VCFormDialog::EditMacros()
{
	if( !pPool )
		InitPool();

	SfxItemSet aSet( *pPool, SID_ATTR_MACROITEM, SID_ATTR_MACROITEM );
	SvxMacroItem aItem( SID_ATTR_MACROITEM );
	aItem.SetMacroTable( *pMacros );
	aSet.Put( aItem );
	SfxMacroAssignDlg* pMacroDlg = new SfxMacroAssignDlg(
		GetpApp()->GetDefModalDialogParent(), aSet );
	SfxMacroTabPage* pMacroTabPage = (SfxMacroTabPage*)pMacroDlg->GetTabPage();
	if ( pMacroTabPage )
	{
		pMacroTabPage->AddEvent( "OnSubmit", VCHDL_ONSUBMITFORM );
		pMacroTabPage->AddEvent( "OnReset", VCHDL_ONRESETFORM );
		if ( pMacroDlg->Execute() == RET_OK )
		{
			nState |= MACROS_MODIFIED;
			*pMacros = ((const SvxMacroItem&)(pMacroDlg->GetOutputItemSet()->
				Get(SID_ATTR_MACROITEM))).GetMacroTable();
		}
	}
	delete pMacroDlg;
}

String VCFormDialog::GetEncoding() const
{
	return aLBEncType.GetSelectEntry();
}

void VCFormDialog::SetEncoding( const String& rEncoding )
{
	String aEnc( rEncoding );
	aEnc.ToLower();
	USHORT nPos = aLBEncType.GetEntryPos( aEnc );
	if( nPos == LISTBOX_ENTRY_NOTFOUND )
		nPos = 0;
	aLBEncType.SelectEntryPos( nPos );
}



/***************************************************************************

	   Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/formdlg.cxx,v 1.1.1.1 2000/09/29 11:02:38 mh Exp $

	  Source Code Control System - Update

	  $Log: formdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:38  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:44  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:47  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.22  2000/02/10 20:00:22  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.21  1997/11/21 16:01:30  OV
	  Headerumstellung
	

	  Rev 1.20   21 Nov 1997 17:01:30   OV
   Headerumstellung

	  Rev 1.19   23 Jul 1997 18:51:06   HJS
   includes

	  Rev 1.18   04 Jul 1997 10:56:40   OV
   #41065# Neuer EncodingType: multipart/form-data

	  Rev 1.17   30 Jun 1997 14:54:18   OV
   #41137# stat. Defaults nach dem Pool loeschen

	  Rev 1.16   07 Mar 1997 10:14:32   TRI
   Array umbenannt

	  Rev 1.15   06 Mar 1997 11:49:34   TRI
   _READONLY_DATA hinter type verschoben

	  Rev 1.14   05 Feb 1997 17:43:12   OV
   Syntax richtig

	  Rev 1.13   05 Feb 1997 17:35:40   OV
   Mussaenderung 355

	  Rev 1.12   23 Jan 1997 14:04:22   OV
   Neue Defines fuer Form-Events

	  Rev 1.11   22 Jan 1997 16:30:40   NF
   pMacros => pHandlers

	  Rev 1.10   22 Jan 1997 12:31:52   OV
   Neu: Makros

	  Rev 1.9   10 Jul 1996 10:36:52   OV
   Bei OK: Aenderungen uebernehmen

	  Rev 1.8   02 Jul 1996 14:29:06   MH
   chg: includes

	  Rev 1.7   02 Jul 1996 13:50:30   OV
   #29193# Target-Box nur einmal fuellen

	  Rev 1.6   20 Jun 1996 09:29:14   OV
   #28658# Loeschen von Forms gerichtet

	  Rev 1.5   05 Jun 1996 13:25:16   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.4   29 May 1996 12:04:40   OV
   Erweiterungen,Bugfixes,Aufraeumarbeiten

	  Rev 1.3   09 May 1996 15:19:10   OV
   Tabsteuerung,Bugfixes

	  Rev 1.2   08 May 1996 16:38:10   OV
   Bugfixes

	  Rev 1.1   06 May 1996 16:34:16   OV
   Formunterstuetzung

	  Rev 1.0   03 May 1996 14:30:00   OV
   NEU: Form-Dialog

*************************************************************************/


#pragma SEG_EOFMODULE
