/*************************************************************************
 *
 *  $RCSfile: formdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _FORMDLG_HXX
#define _FORMDLG_HXX

#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif

class VCManager;
class VCControl;
class SvxMacroTableDtor;
class SfxPoolItem;
class SvxMacroTableDtor;
class SfxItemPool;
class Window;
class ResId;

class VCFormDialog : public ModalDialog
{
	ListBox 		aLBFormNames;
	FixedText		aFTFormName;
	Edit			aEDFormName;
	FixedText		aFTURL;
	Edit			aEDURL;
	FixedText		aFTTarget;
	ComboBox		aCBTarget;
	RadioButton 	aRBGet;
	RadioButton 	aRBPost;
	GroupBox		aGBMethod;
	FixedText		aFTEncType;
	ListBox 		aLBEncType;

	OKButton		aBTOK;
	PushButton		aBTEnd;
	PushButton		aBTNew;
	PushButton		aBTChange;
	PushButton		aBTDelete;
	PushButton		aBTMacros;

	String			aClosedForm;
	SvxMacroTableDtor* pMacros;
	SfxItemPool* 	pPool; // fuer den Makro-Dialog
	SfxPoolItem**	ppPoolDefaults;
	USHORT			nState;

	DECL_LINK( DoubleClickHdl, ListBox* );
	DECL_LINK( SelectHdl, ListBox* );
	DECL_LINK( ModifyHdl, Edit* );
	DECL_LINK( ClickHdl, Button* );

	void 		EnableButtons();
	void 		InitPool();
	void 		DeinitPool();

	void 		SetCurVCForm( const String& );
	void 		CreateVCForm();
	void 		ChangeVCForm();
	void 		DeleteVCForm();
	void 		EditMacros();

	USHORT		GetMethod() const;
	String 		GetEncoding() const;
	void 		SetEncoding( const String& rEncoding );
	void 		FillTargetBox();

protected:
	VCManager*	pMgr;

public:
				VCFormDialog( Window* pParent, const ResId&, VCManager* pMgr,
					const String& rCurForm );
				~VCFormDialog();

	// aktuelle Form beim Schliessen des Dialogs per OK oder Doppelklick
	const String& GetClosedForm() const { return aClosedForm; }
};



#endif



