/*************************************************************************
 *
 *  $RCSfile: sictrls.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SICTRLS_HXX
#define _SICTRLS_HXX

#ifdef SI_VCSV_LISTBOX

#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif

#endif

#ifdef SI_VCSV_EDIT

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

#endif

#ifdef SI_VCSV_FIXEDTEXT

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#endif

#ifdef SI_VCSV_GROUPBOX

#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif

#endif

#ifdef SI_VCSV_PREVIEW

#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif

#endif

#ifdef SI_VCSV_BUTTONS

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#ifndef SV_SPIN_HXX
#include <vcl/spin.hxx>
#endif

#endif

#ifdef SI_VCSV_SCROLLBAR

#ifndef _SV_SCRBAR_HXX
#include <vcl/scrbar.hxx>
#endif

#endif

class VCListBox;
class VCControl;
class VCPushButton;
class VCCheckBox;
class VCRadioButton;
class VCEdit;
class VCSpinButton;
class VCScrollBar;
class VCComboBox;
class VCPreview;
class NotifyEvent;
class MouseEvent;
class KeyEvent;
class VCFixedText;

#ifdef SI_VCSV_LISTBOX

class VCSVListBox : public ListBox
{
protected:
	VCControl* 	pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual void DoubleClick();
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif

	virtual void Select();
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	virtual ~VCSVListBox();
	VCSVListBox( Window* pParent, VCControl* _pShell, WinBits nStyle=0 ) :
		ListBox( pParent, nStyle )
	{
		pShell = _pShell;
	}

	USHORT 	InsertEntry( const String& rEntry, USHORT nPos = LISTBOX_APPEND );
	void 	RemoveEntry( USHORT nPos );
	void    Clear();
};


class VCSVMultiListBox : public MultiListBox
{
protected:
	VCListBox* 	  pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual void DoubleClick();
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif

	virtual void Select();
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	virtual ~VCSVMultiListBox();
	VCSVMultiListBox( Window* pParent, VCListBox* _pShell, WinBits nStyle=0 ) :
		MultiListBox( pParent, nStyle )
	{
		pShell = _pShell;
	}

	USHORT 	InsertEntry( const String& rEntry, USHORT nPos = LISTBOX_APPEND );
	void 	RemoveEntry( USHORT nPos );
	void    Clear();
};


class VCSVComboBox : public ComboBox
{
protected:
	VCControl* pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void Select();
	virtual void DoubleClick();
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVComboBox( Window* pParent, VCControl* _pShell, WinBits nStyle=0 ) :
		ComboBox( pParent, nStyle )
	{
		pShell = _pShell;
	}

	virtual void Modify();
	USHORT 	InsertEntry( const String& rEntry, USHORT nPos = COMBOBOX_APPEND );
	void 	RemoveEntry( USHORT nPos );
	void	Clear();
};

#endif // SI_VCSV_LISTBOX


#ifdef SI_VCSV_EDIT

class VCSVEdit : public Edit
{
protected:
	VCEdit* pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVEdit( Window* pParent, VCEdit* _pShell, WinBits nStyle=0 ) :
		Edit( pParent, nStyle )
	{
		pShell = _pShell;
	}

	virtual void Modify();
};

class VCSVMultiLineEdit : public MultiLineEdit
{
protected:
	VCEdit* pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVMultiLineEdit( Window* pParent, VCEdit* _pShell, WinBits nStyle=0 ) :
		MultiLineEdit( pParent, nStyle )
	{
		pShell = _pShell;
	}

	virtual void Modify();
};

#endif //SI_VCSV_EDIT


#ifdef SI_VCSV_FIXEDTEXT

class VCSVFixedText : public FixedText
{
protected:
	VCFixedText* pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVFixedText( Window* pParent, VCFixedText* _pShell, WinBits nStyle ) :
		FixedText( pParent, nStyle )
	{
		pShell = _pShell;
	}
};

#endif

#ifdef SI_VCSV_GROUPBOX

class VCSVGroupBox : public GroupBox
{
protected:
	VCGroupBox* pShell;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVGroupBox( Window* pParent, VCGroupBox* _pShell ) :
		GroupBox( pParent )
	{
		pShell = _pShell;
	}
};

#endif

#ifdef SI_VCSV_PREVIEW

class VCSVPreview : public Control
{
protected:
	VCPreview* 	  pShell;
	long		  nCurrentX;
	long 		  nCurrentY;
	USHORT		  nDrawMode;
	USHORT		  nDrawStyle;
	long		  nDrawWidth;
	USHORT        nFillStyle;

#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void Paint( const Rectangle& rRect );
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVPreview( Window* pParent, VCPreview* _pShell, WinBits nStyle );


	long	GetCurrentX() const { return nCurrentX; }
	void	SetCurrentX( long nX ) { nCurrentX = nX; }
	long	GetCurrentY() const { return nCurrentY; }
	void	SetCurrentY( long nY ) { nCurrentY = nY; }
	USHORT	GetDrawMode() const { return nDrawMode; }
	void	SetDrawMode( USHORT nMode );
	USHORT	GetDrawStyle() const { return nDrawStyle; }
	void	SetDrawStyle( USHORT nStyle );
	long	GetDrawWidth() const { return nDrawWidth; }
	void	SetDrawWidth( long nWidth );
	USHORT	GetFillStyle() const { return nFillStyle; }
	void	SetFillStyle( USHORT nStyle );

	void	DrawLineTo( const Point& rPt );
	void	Cls();

	void	SetFontTransparent( BOOL );
	BOOL	GetFontTransparent() const;
};

#endif

#ifdef SI_VCSV_BUTTONS

class VCSVPushButton : public PushButton
{
protected:
	VCPushButton* pShell;

	virtual void Click();
#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVPushButton( Window* pParent, VCPushButton* _pShell, WinBits nStyle=0 ) :
		PushButton( pParent, nStyle )
	{
		pShell = _pShell;
	}
};


class VCSVCancelButton : public CancelButton
{
protected:
	VCPushButton* pShell;

	virtual void Click();
#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVCancelButton( Window* pParent, VCPushButton* _pShell, WinBits nStyle=0 ) :
		CancelButton( pParent, nStyle )
	{
		pShell = _pShell;
	}
};


class VCSVCheckBox : public CheckBox
{
protected:
	VCCheckBox* pShell;

	virtual void Click();
#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVCheckBox( Window* pParent, VCCheckBox* _pShell, WinBits nStyle=0 ) :
		CheckBox( pParent, nStyle )
	{
		pShell = _pShell;
	}
};


class VCSVRadioButton : public RadioButton
{
protected:
	VCRadioButton* pShell;

	virtual void Click();
#ifndef VCL
	virtual void MouseButtonDown( const MouseEvent& rMEvt );
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void MouseMove( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVRadioButton( Window* pParent, VCRadioButton* _pShell, WinBits nStyle=0 ) :
		RadioButton( pParent, nStyle )
	{
		pShell = _pShell;
	}
};

class VCSVSpinButton : public SpinButton
{
protected:
	VCSpinButton* 	 pShell;
	long			 nValue;
	long			 nMin;
	long			 nMax;
	long			 nChange;

	virtual void Up();
	virtual void Down();
#ifndef VCL
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVSpinButton( Window* pParent, VCSpinButton* _pShell, WinBits nStyle=0 ) :
		SpinButton( pParent, nStyle )
	{
		nValue = 0;
		nMin   = 0;
		nMax   = 0;
		nChange= 0;
		pShell = _pShell;
	}

	void	SetValue( long nVal ) { nValue = nVal; }
	long	GetValue() const { return nValue; }
	void	SetMin( long nM ) { nMin = nM; }
	long	GetMin() const { return nMin; }
	void	SetMax( long nM ) { nMax = nM; }
	long	GetMax() const { return nMax; }
	void	SetChange( long nChg ) { nChange = nChg; }
	long	GetChange() const { return nChange; }
};

#endif

#ifdef SI_VCSV_SCROLLBAR

class VCSVScrollBar : public ScrollBar
{
protected:
	VCScrollBar* pShell;

#ifndef VCL
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();
	virtual void LoseFocus();
#else
	virtual long PreNotify( NotifyEvent& rNEvt );
#endif
	virtual void Scroll();
	virtual void EndScroll();
	virtual void RequestHelp( const HelpEvent& rHEvt );

public:
	VCSVScrollBar( Window* pParent, VCScrollBar* _pShell, WinBits nStyle ) :
		ScrollBar( pParent, nStyle )
	{
		pShell = _pShell;
	}
};


#endif


#endif
