/*************************************************************************
 *
 *  $RCSfile: sidll.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SOLAR_HRC
#include <svtools/solar.hrc>
#endif
#ifndef _IMAGE_HXX
#include <vcl/image.hxx>
#endif
#pragma hdrstop

//#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SFXVIEWSH_HXX 
#include <sfx2/viewsh.hxx>
#endif

#include <vcl/virdev.hxx>

#include "vcattr.hxx"
#include "vcsbx.hxx"
#include "vcdrwobj.hxx"
#include "sidll.hxx"
#include <svx/editeng.hxx>
#include <svx/editview.hxx>
#include "vcbrw.hxx"
#include "vcattrid.hrc"
#include <svx/svxids.hrc>
#include "vcsbxfac.hxx"


DBG_NAME(SiDLL);

void SiDLL::AddSbxDlg( VCSbxDialog* pDlg )
{
	DBG_CHKTHIS(SiDLL,0);
	if( !pSbxDlgList )
		pSbxDlgList = new List;

	pSbxDlgList->Insert( pDlg, LIST_APPEND );
}

void SiDLL::RemoveSbxDlg( VCSbxDialog* pDlg )
{
	DBG_CHKTHIS(SiDLL,0);
	if( !pSbxDlgList )
		return;
	else
		pSbxDlgList->Remove( pDlg );
}

SiDLL::SiDLL() :
	pSbxDlgList(NULL),
	pActiveEdit(0),
	ppPoolDefaults(0),
	pVCItemPool(0),
	pPaintEngine(0),
	pEditPool(0),
	pButtons(0),
	bShowHiddenCtrls(FALSE),
	pVDev(0)
{
	DBG_CTOR(SiDLL,0);
	*((SiDLL**)GetAppData( SHL_SI )) = this;
	pReserved = new SiReserved;
	ByteString aResMgrName( RTL_CONSTASCII_STRINGPARAM( "basctl" ) );
	aResMgrName.Append( ByteString::CreateFromInt32( SOLARUPD ) );
	pResMgr = ResMgr::CreateResMgr(
		aResMgrName.GetBuffer(), GetpApp()->GetAppInternational().GetLanguage() );

	pFactory = new VCSbxFactory;
	SbxBase::AddFactory( pFactory );

	pDrwFactory = new VCDrwFactory;
	SdrObjFactory::InsertMakeObjectHdl( LINK( pDrwFactory, VCDrwFactory, MakeObject ) );
}

SiDLL::~SiDLL()
{
	DBG_DTOR(SiDLL,0);
	delete pResMgr;

	if( pSbxDlgList )
		delete pSbxDlgList;

	SbxBase::RemoveFactory( pFactory );
	delete pFactory;

	SdrObjFactory::RemoveMakeObjectHdl( LINK( pDrwFactory, VCDrwFactory, MakeObject ) );
	delete pDrwFactory;

	if (pVCItemPool)
		delete pVCItemPool;

	if( ppPoolDefaults )
		SfxItemPool::ReleaseDefaults(ppPoolDefaults,VCATTR_END-VCATTR_START+1,TRUE);

	delete pPaintEngine;
	delete pEditPool;
	delete pButtons;
	delete pReserved;
	delete pVDev;
}

Window* SiDLL::GetActiveWindow()
{
	SfxViewShell* pCurSh = SfxViewShell::Current();
	if ( pCurSh )
		return pCurSh->GetWindow();
    else
		return 0;
}

OutputDevice*   SiDLL::GetOutDev()
{
	if( !pVDev )
		pVDev = new VirtualDevice();
	return pVDev;
}

VCItemPool* SiDLL::GetVCItemPool()
{
	if( !pVCItemPool )
		pVCItemPool = new VCItemPool;
	return pVCItemPool;
}

USHORT SiDLL::GetSbxDlgCount() const
{
	DBG_CHKTHIS(SiDLL,0);
	if( pSbxDlgList )
		return (USHORT)pSbxDlgList->Count();
	else
		return 0;
}

VCSbxDialog* SiDLL::GetSbxDlg( USHORT n ) const
{
	DBG_CHKTHIS(SiDLL,0);
	if( pSbxDlgList )
		return (VCSbxDialog*)pSbxDlgList->GetObject( n );
	else
		return NULL;
}

// static
void SiDLL::ToggleVisibleState()
{
}

// static
void SiDLL::ShowFormDialog()
{
}

//static
void SiDLL::UpdateBrowserItem( USHORT nWhich )
{
	VCBrowser::UpdateItem( nWhich );
}


//static
void SiDLL::SetCurControl( VCControl* pControl )
{
	SiDLL* pThis = SI_DLL();
	if( pThis->pReserved->pCurControl != pControl )
	{
		pThis->pReserved->pCurControl = pControl;
		pThis->pReserved->bCurControlDeleted = FALSE;
	}
}

//static
BOOL SiDLL::IsCurControlDeleted()
{
	SiDLL* pThis = SI_DLL();
	return pThis->pReserved->bCurControlDeleted;
}

//static
void SiDLL::NotifyControlDeleted( VCControl* pControl )
{
	SiDLL* pThis = SI_DLL();
	if( pThis->pReserved->pCurControl == pControl )
	{
		pThis->pReserved->pCurControl = 0;
		pThis->pReserved->bCurControlDeleted = TRUE;
	}
}

//static
void SiDLL::NotifyControlCreated( VCControl* pControl )
{
	SiDLL* pThis = SI_DLL();
	if( pThis->pReserved->pCurControl == pControl )
	{
		pThis->pReserved->pCurControl = 0;
		pThis->pReserved->bCurControlDeleted = FALSE;
	}
}

//static
VCControl* SiDLL::GetCurControl()
{
	SiDLL* pThis = SI_DLL();
	return pThis->pReserved->pCurControl;
}

SiReserved::SiReserved()
{
	pReserved = 0;
	bCurControlDeleted = FALSE;
}



