/*************************************************************************
 *
 *  $RCSfile: sjctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef SOLAR_JAVA

//#include <sfxsj.hxx>
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif

#pragma hdrstop

#include "vcspnbtn.hxx"
#include "vcpbttn.hxx"
#include "vcscrbar.hxx"
#include "vcedit.hxx"
#include "vclbox.hxx"
#include "vccbbox.hxx"
#include "vcchkbox.hxx"
#include "vcrdbttn.hxx"
#include "vcfxtxt.hxx"
#include "vcprvw.hxx"
#include "vcgrpbox.hxx"
#include "vctrls.hxx"
#include "vcform.hxx"
#include "vcont.hxx"
#include "vcattr.hxx"
#include "sjctrl.hxx"


// Strings fuer METHOD-Property am Form-Objekt
#define FORMMETH_GET_STR	"get"
#define FORMMETH_POST_STR	"post"


/*
 * Implementation ImpSjJScriptAbstractControlObject
 * Basis-Properties bereitstellen
 */
String ImpSjJScriptControlBase::ImpGetName() const
{
	return pControl->GetName();
}

void ImpSjJScriptControlBase::ImpSetName( const String & aStrg )
{
	pControl->SetName( aStrg );
}

String ImpSjJScriptControlBase::ImpGetValue() const
{
	return pControl->GetValue();
}

void ImpSjJScriptControlBase::ImpSetValue( const String & aStrg )
{
	pControl->SetValue( aStrg );
}

ImpSjJScriptControlBase::ImpSjJScriptControlBase( VCControl* _pControl )
{
	pControl = _pControl;
}


//************************************************************************


/*
 * Implementation ImpSjJScriptButtonObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptButtonObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptButtonObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptButtonObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

void ImpSjJScriptButtonObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

String ImpSjJScriptButtonObject::getType() const
{
	return String( "button" );
}


// Methoden des Objektes
void ImpSjJScriptButtonObject::click()
{
	((VCPushButton*)pControl)->ClickButton();
}


// Events (C++ --> Java)
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptButtonObject::getOnClick_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCLICK );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptButtonObject::setOnClick_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCLICK, aMacro );
}
#endif

String ImpSjJScriptButtonObject::getOnClick() const
{
	return pControl->GetHandler( VCHDL_ONCLICK );
}

void ImpSjJScriptButtonObject::setOnClick( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCLICK, aSourceStrg );
}


void ImpSjJScriptButtonObject::onClick()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnClick() );
}

// Konstruktor
ImpSjJScriptButtonObject::ImpSjJScriptButtonObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptButtonObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptPasswordObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptPasswordObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptPasswordObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptPasswordObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptPasswordObject::getType() const
{
	return String( "password" );
}

// Eigene Properties
String ImpSjJScriptPasswordObject::getDefaultValue() const
{
	return ((VCEdit*)pControl)->GetDefaultText();
}

void ImpSjJScriptPasswordObject::setDefaultValue( const String & aStrg )
{
	((VCEdit*)pControl)->SetDefaultText( aStrg);
}

void ImpSjJScriptPasswordObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}


// Methoden des Objektes
void ImpSjJScriptPasswordObject::focus()
{
	((VCEdit*)pControl)->Focus();
}

void ImpSjJScriptPasswordObject::blur()
{
	((VCEdit*)pControl)->Blur();
}

void ImpSjJScriptPasswordObject::select()
{
	((VCEdit*)pControl)->Select();
}

// Konstruktor
ImpSjJScriptPasswordObject::ImpSjJScriptPasswordObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptPasswordObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptCheckboxObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptCheckboxObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptCheckboxObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptCheckboxObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptCheckboxObject::getType() const
{
	return String( "checkbox" );
}

// Eigene Properties
BOOL ImpSjJScriptCheckboxObject::getChecked() const
{
	return ((VCCheckBox*)pControl)->IsChecked();
}

void ImpSjJScriptCheckboxObject::setChecked( BOOL bCheck )
{
	((VCCheckBox*)pControl)->Check( bCheck );
}

BOOL ImpSjJScriptCheckboxObject::getDefaultChecked() const
{
	return ((VCCheckBox*)pControl)->GetDefaultChecked();
}

void ImpSjJScriptCheckboxObject::setDefaultChecked( BOOL bCheck )
{
	((VCCheckBox*)pControl)->SetDefaultChecked( bCheck );
}

void ImpSjJScriptCheckboxObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

// Methoden des Objektes
void ImpSjJScriptCheckboxObject::click()
{
	((VCCheckBox*)pControl)->Check( !((VCCheckBox*)pControl)->IsChecked() );
}

// Events (C++ --> Java)
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptCheckboxObject::getOnClick_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCLICK );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptCheckboxObject::setOnClick_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCLICK, aMacro );
}
#endif

String ImpSjJScriptCheckboxObject::getOnClick() const
{
	return pControl->GetHandler( VCHDL_ONCLICK );
}

void ImpSjJScriptCheckboxObject::setOnClick( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCLICK, aSourceStrg );
}

void ImpSjJScriptCheckboxObject::onClick()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnClick() );
}

// Konstruktor
ImpSjJScriptCheckboxObject::ImpSjJScriptCheckboxObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptCheckboxObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************

/*
 * Implementation ImpSjJScriptRadioArray
 */
INT32 ImpSjJScriptRadioArray::getLength() const
{
	return pMgr->GetLength();
}

// Zugriff "uber den Index
SjJSbxObject* ImpSjJScriptRadioArray::getElement( INT32 nIndex ) const
{
	SjJSbxObject* pRet = NULL;
	if( nIndex < pMgr->GetLength() )
	{
		// GetJavaWrapper nehmen!!!
		pRet = pMgr->GetElement( (USHORT)nIndex )->GetJavaWrapper();
	}
	return pRet;
}

// Zugriff "uber den Namen
// native Java-Methoden k"onnen (noch) nicht "uberladen werden
SjJSbxObject* ImpSjJScriptRadioArray::getElement_String( const String & aName ) const
{
	// Ueber String kann das Radio-Array nicht angesprochen werden
	return NULL;
}

// Konstruktor
ImpSjJScriptRadioArray::ImpSjJScriptRadioArray( VCRadioManager* _pMgr, SjJSbxObject * p )
	:SjJSbxArrayObject( p )
{
	pMgr = _pMgr;
}

//************************************************************************

/*
 * Implementation ImpSjJScriptRadioObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptRadioObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptRadioObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptRadioObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptRadioObject::getType() const
{
	return String( "radio" );
}

// Eigene Properties
BOOL ImpSjJScriptRadioObject::getChecked() const
{
	return ((VCRadioButton*)pControl)->IsChecked();
}

void ImpSjJScriptRadioObject::setChecked( BOOL bCheck )
{
	// Die anderen in der Gruppe zuruecksetzen
	if( bCheck )
	{
		VCContainer* pParent = pControl->GetParent();
		if( pParent )
			pParent->UncheckRadios( (VCRadioButton*)pControl );
	}
	((VCRadioButton*)pControl)->Check( bCheck );
}

BOOL ImpSjJScriptRadioObject::getDefaultChecked() const
{
	return ((VCRadioButton*)pControl)->GetDefaultChecked();
}

void ImpSjJScriptRadioObject::setDefaultChecked( BOOL bCheck )
{
	((VCRadioButton*)pControl)->SetDefaultChecked( bCheck );
}

void ImpSjJScriptRadioObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

// Methoden des Objektes
void ImpSjJScriptRadioObject::click()
{
	// AB 7.4.97: Auch hier andere Buttons beruecksichtigen
	setChecked( TRUE );
}


// Events (C++ --> Java)
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptRadioObject::getOnClick_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCLICK );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}
void ImpSjJScriptRadioObject::setOnClick_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCLICK, aMacro );
}
#endif

String ImpSjJScriptRadioObject::getOnClick() const
{
	return pControl->GetHandler( VCHDL_ONCLICK );
}

void ImpSjJScriptRadioObject::setOnClick( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCLICK, aSourceStrg );
}

void ImpSjJScriptRadioObject::onClick()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnClick() );
}

// Konstruktor
ImpSjJScriptRadioObject::ImpSjJScriptRadioObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptRadioObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptSelectObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptSelectObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptSelectObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptSelectObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptSelectObject::getType() const
{
	// Nach Multi- und Single-Selection unterscheiden
	if( pControl->ISA(VCListBox) )
		return String( "select-multiple" );
	else
		return String( "select-one" );
}

// Eigene Properties
INT32 ImpSjJScriptSelectObject::getLength()
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetEntryCount();
	else
		return ((VCComboBox*)pControl)->GetEntryCount();
}

INT32 ImpSjJScriptSelectObject::getSelectedIndex() const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetSelectEntryPos();
	else
	{
		// Aktuelle Auswahl als String holen
		String aEntry = ((VCComboBox*)pControl)->GetSelectEntry();

		// Da Editieren blockiert ist, muss der Eintrag existieren
		return (INT32)((VCComboBox*)pControl)->GetEntryPos( aEntry );
	}
}

void ImpSjJScriptSelectObject::setSelectedIndex( INT32 nNo )
{
	if( pControl->ISA(VCListBox) )
	{
		VCListBox* pListBox = (VCListBox*)pControl;

		// In JavaScript (Netscape) wird der Eintrag als einziger selektiert,
		// also erstmal alle zuruecksetzen
		for( ULONG i = 0 ; i < pListBox->GetEntryCount() ; i++ )
			pListBox->SelectEntryPos( i, FALSE );

		pListBox->SelectEntryPos( nNo );
	}
	else
	{
		String aEntry = ((VCComboBox*)pControl)->GetEntry( nNo );
		((VCComboBox*)pControl)->SetText( aEntry );
	}
}

// Methoden des Objektes
void ImpSjJScriptSelectObject::focus()
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->Focus();
	else
		((VCComboBox*)pControl)->Focus();
}

void ImpSjJScriptSelectObject::blur()
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->Blur();
	else
		((VCComboBox*)pControl)->Blur();
}

// Events (C++ --> Java)
//----------------------
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptSelectObject::getOnBlur_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONLOSEFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptSelectObject::setOnBlur_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptSelectObject::getOnChange_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONSELECT );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptSelectObject::setOnChange_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONSELECT, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptSelectObject::getOnFocus_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONGETFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptSelectObject::setOnFocus_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONGETFOCUS, aMacro );
}
#endif

String ImpSjJScriptSelectObject::getOnBlur() const
{
	return pControl->GetHandler( VCHDL_ONLOSEFOCUS );
}

void ImpSjJScriptSelectObject::setOnBlur( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aSourceStrg );
}

void ImpSjJScriptSelectObject::onBlur()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnBlur() );
}

String ImpSjJScriptSelectObject::getOnChange() const
{
	// ONSELECT verwenden, da sonst Probleme mit Combobox
	return pControl->GetHandler( VCHDL_ONSELECT );
}

void ImpSjJScriptSelectObject::setOnChange( const String & aSourceStrg )
{
	// ONSELECT verwenden, da sonst Probleme mit Combobox
	pControl->SetHandler( VCHDL_ONSELECT, aSourceStrg );
}

void ImpSjJScriptSelectObject::onChange()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnChange() );
}

String ImpSjJScriptSelectObject::getOnFocus() const
{
	return pControl->GetHandler( VCHDL_ONGETFOCUS );
}

void ImpSjJScriptSelectObject::setOnFocus( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONGETFOCUS, aSourceStrg );
}

void ImpSjJScriptSelectObject::onFocus()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnFocus() );
}

// SjJSbxArrayObject-Methoden
INT32 ImpSjJScriptSelectObject::getLength() const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetEntryCount();
	else
		return ((VCComboBox*)pControl)->GetEntryCount();
}

// Zugriff "uber den Index
SjJSbxObject * 	ImpSjJScriptSelectObject::getElement( INT32 nIndex ) const
{
	SjJSbxObject* pRet = NULL;

	if( nIndex < getLength() )
	{
		SvPtrarr* pOptions = NULL;
		if( pControl->ISA(VCListBox) )
			pOptions = ((VCListBox*)pControl)->GetOptions();
		else
			pOptions = ((VCComboBox*)pControl)->GetOptions();

		// option-Objekt holen
		pRet = (SjJSbxObject*)pOptions->GetObject( (USHORT)nIndex );

		if( !pRet )
		{
			// Noch kein Wrapper-Objekt da -> erzeugen
			pRet = new ImpSjJScriptOptionObject
				( pControl, pControl->GetJavaWrapper(), (USHORT)nIndex );

			// Auch in die Tabelle der ListBox/Combobox eintragen
			pOptions->Replace( pRet, (USHORT)nIndex );
		}
	}
	return pRet;
}

// Konstruktor
ImpSjJScriptSelectObject::ImpSjJScriptSelectObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptSelectObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

// zum Setzen von Eintr"agen am Objekt (zum Aufruf von Java aus) 15.1.1997
void ImpSjJScriptSelectObject::setOption
( INT32 nIndex, const String & aOptionText, const String & aOptionValue,
  BOOL bDefaultSelected, BOOL bSelected )
{
	setOptionDefaultSelected( bDefaultSelected, nIndex );
	setOptionSelected( bSelected, nIndex );
	setOptionText( aOptionText, nIndex );
	setOptionValue( aOptionValue, nIndex );
}

// Schnittstelle fuer die Properties der Option-Objekte
BOOL ImpSjJScriptSelectObject::getOptionDefaultSelected( INT32 nIndex ) const
{
	// Ist dieser Eintrag als DefaultChecked gesetzt?
	if( pControl->ISA(VCListBox) )
		return ( ((VCListBox*)pControl)->GetDefaultChecked( (USHORT)nIndex ) );
	else
		return ( getOptionText( nIndex ) == ((VCComboBox*)pControl)->GetDefaultText() );
}

void ImpSjJScriptSelectObject::setOptionDefaultSelected( BOOL bSelected, INT32 nIndex )
{
	// Diesen Eintrag als DefaultChecked setzen
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SetDefaultChecked( (USHORT)nIndex, TRUE );
	else
		((VCComboBox*)pControl)->SetDefaultText( getOptionText( nIndex ) );
}

BOOL ImpSjJScriptSelectObject::getOptionSelected( INT32 nIndex ) const
{
	// Ist dieser Eintrag in der ListBox selektiert?
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->IsEntrySelected( (ULONG)nIndex );
	else
	{
		// IsEntrySelected() gibt es nicht an Combobox
		// -> Ueber den Wrapper von der Combo-Box gehen
		ImpSjJScriptSelectObject *pSelectObject =
			(ImpSjJScriptSelectObject*)((VCComboBox*)pControl)->GetJavaWrapper();

		return ( pSelectObject->getSelectedIndex() == (INT32)nIndex );
	}
}

void ImpSjJScriptSelectObject::setOptionSelected( BOOL bSelected, INT32 nIndex )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SelectEntryPos( (ULONG)nIndex, bSelected );
	else
	{
		String aEntry = ((VCComboBox*)pControl)->GetEntry( (ULONG)nIndex );
		((VCComboBox*)pControl)->SetText( aEntry );
	}
}

String ImpSjJScriptSelectObject::getOptionText( INT32 nIndex ) const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetEntry( (ULONG)nIndex );
	else
		return ((VCComboBox*)pControl)->GetEntry( (ULONG)nIndex );
}

void ImpSjJScriptSelectObject::setOptionText( const String & sText, INT32 nIndex )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->ReplaceEntry( sText, (ULONG)nIndex );
	else
		((VCComboBox*)pControl)->ReplaceEntry( sText, (ULONG)nIndex );
}

void ImpSjJScriptSelectObject::setOptionValue( const String & sText, INT32 nIndex )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SetItemData( sText, (ULONG)nIndex );
	else
		((VCComboBox*)pControl)->SetItemData( sText, (ULONG)nIndex );
}

String ImpSjJScriptSelectObject::getOptionValue( INT32 nIndex ) const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetItemData( (ULONG)nIndex );
	else
		return ((VCComboBox*)pControl)->GetItemData( (ULONG)nIndex );
}


//************************************************************************


/*
 * Implementation ImpSjJScriptOptionObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Eigene Properties
BOOL ImpSjJScriptOptionObject::getdefaultSelected() const
{
	// Ist dieser Eintrag als DefaultChecked gesetzt?
	if( pControl->ISA(VCListBox) )
		return ( ((VCListBox*)pControl)->GetDefaultChecked( nListBoxIndex ) );
	else
	{
		String aText = getText();
		String aDefaultText = ((VCComboBox*)pControl)->GetDefaultText();
		BOOL bRet = ( aText == aDefaultText );
		return bRet;
		//return ( getText() == ((VCComboBox*)pControl)->GetDefaultText() );
	}
}

void ImpSjJScriptOptionObject::setdefaultSelected( BOOL bSelected )
{
	// Diesen Eintrag als DefaultChecked setzen
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SetDefaultChecked( nListBoxIndex, TRUE );
	else
		((VCComboBox*)pControl)->SetDefaultText( getText() );
}

INT32 ImpSjJScriptOptionObject::getIndex() const
{
	return (INT32)nListBoxIndex;
}

BOOL ImpSjJScriptOptionObject::getSelected() const
{
	// Ist dieser Eintrag in der ListBox als selektiert?
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->IsEntrySelected( (ULONG)nListBoxIndex );
	else
	{
		// IsEntrySelected() gibt es nicht an Combobox
		// -> Ueber den Wrapper von der Combo-Box gehen
		ImpSjJScriptSelectObject *pSelectObject =
			(ImpSjJScriptSelectObject*)((VCComboBox*)pControl)->GetJavaWrapper();

		return ( pSelectObject->getSelectedIndex() == (INT32)nListBoxIndex );
	}
}

void ImpSjJScriptOptionObject::setSelected( BOOL bSelected )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SelectEntryPos( (ULONG)nListBoxIndex, bSelected );
	else
		((VCComboBox*)pControl)->SelectEntryPos( (ULONG)nListBoxIndex, bSelected );
}

String ImpSjJScriptOptionObject::getText() const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetEntry( (ULONG)nListBoxIndex );
	else
		return ((VCComboBox*)pControl)->GetEntry( (ULONG)nListBoxIndex );
}

void ImpSjJScriptOptionObject::setText( const String & sText )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->ReplaceEntry( sText, (ULONG)nListBoxIndex );
	else
		((VCComboBox*)pControl)->ReplaceEntry( sText, (ULONG)nListBoxIndex );
}

void ImpSjJScriptOptionObject::setValue( const String & aStrg )
{
	if( pControl->ISA(VCListBox) )
		((VCListBox*)pControl)->SetItemData( aStrg, (ULONG)nListBoxIndex );
	else
		((VCComboBox*)pControl)->SetItemData( aStrg, (ULONG)nListBoxIndex );
}

String ImpSjJScriptOptionObject::getValue() const
{
	if( pControl->ISA(VCListBox) )
		return ((VCListBox*)pControl)->GetItemData( (ULONG)nListBoxIndex );
	else
		return ((VCComboBox*)pControl)->GetItemData( (ULONG)nListBoxIndex );
}

// Methoden des Objektes
// keine !

// Events (C++ --> Java)
//----------------------
// keine !

// Konstruktor
ImpSjJScriptOptionObject::ImpSjJScriptOptionObject( VCControl* _pControl, SjJSbxObject * p,
	USHORT _nListBoxIndex )
	:SjJScriptOptionObject( p ), ImpSjJScriptControlBase( _pControl )
{
	// pControl ist in diesem Fall kein Option-Objekt, sondern die VCListBox.
	// zu der das Option-Objekt gehrt.

	nListBoxIndex = _nListBoxIndex;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// Implementation SjJSbxFormsArray

// Konstruktor
SjJSbxFormsArray::SjJSbxFormsArray( VCManager * _pManager, SjJSbxObject * p )
	:SfxJSArray( p )
{
	pManager = _pManager;
}

// SjJSbxArrayObject-Methoden
INT32 SjJSbxFormsArray::getLength() const
{
	// Der Count ist um 1 zu hoch, weil immer eine Standard-Form angelegt wird
	// Dessen Existenz wird mit der folgenden Assertion abgesichert.
	INT32 nCount = (INT32)pManager->FormCount();
	DBG_ASSERT(nCount && pManager->GetFormByPos(0)->IsStandardForm(),
		"SjJSbxFormsArray::getLength()==0 !!!")

	// Fuer HTML richtigen Count liefern
	return nCount - 1;
}

// Zugriff "uber den Index
SjJSbxObject * SjJSbxFormsArray::getElement( INT32 nIndex ) const
{
	// Der Count ist um 1 zu hoch, weil immer eine Standard-Form angelegt wird
	// Dessen Existenz wird mit der folgenden Assertion abgesichert.
#ifdef DBG_UTIL
	INT32 nCount = (INT32)pManager->FormCount();
	DBG_ASSERT(nCount && pManager->GetFormByPos(0)->IsStandardForm(),
		"SjJSbxFormsArray::getLength()==0 !!!")
#endif
	VCForm* pForm = pManager->GetFormByPos( (ULONG)(nIndex + 1) );
	return pForm ? pForm->GetJavaWrapper() : NULL;
}

// Zugriff "uber den Namen
// native Java-Methoden k"onnen (noch) nicht "uberladen werden
SjJSbxObject * SjJSbxFormsArray::getElement_String( const String & aName ) const
{
	VCForm* pForm = pManager->GetFormByName( aName );
	return pForm ? pForm->GetJavaWrapper() : NULL;
}


//************************************************************************


/*
 * Implementation ImpSjJScriptTextObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptTextObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptTextObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptTextObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptTextObject::getType() const
{
	return String( "text" );
}

// Eigene Properties
String ImpSjJScriptTextObject::getDefaultValue() const
{
	return ((VCEdit*)pControl)->GetDefaultText();
}

void ImpSjJScriptTextObject::setDefaultValue( const String & aStrg )
{
	((VCEdit*)pControl)->SetDefaultText( aStrg );
}

void ImpSjJScriptTextObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

// Methoden des Objektes
void ImpSjJScriptTextObject::focus()
{
	((VCEdit*)pControl)->Focus();
}

void ImpSjJScriptTextObject::blur()
{
	((VCEdit*)pControl)->Blur();
}

void ImpSjJScriptTextObject::select()
{
	((VCEdit*)pControl)->Select();
}


// Events (C++ --> Java)
//----------------------
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptTextObject::getOnBlur_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONLOSEFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextObject::setOnBlur_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextObject::getOnChange_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCHANGE );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextObject::setOnChange_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCHANGE, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextObject::getOnFocus_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONGETFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextObject::setOnFocus_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONGETFOCUS, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextObject::getOnSelect_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONSELECT );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextObject::setOnSelect_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONSELECT, aMacro );
}
#endif

String ImpSjJScriptTextObject::getOnBlur() const
{
	return pControl->GetHandler( VCHDL_ONLOSEFOCUS );
}

void ImpSjJScriptTextObject::setOnBlur( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aSourceStrg );
}

void ImpSjJScriptTextObject::onBlur()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnBlur() );
}

String ImpSjJScriptTextObject::getOnChange() const
{
	return pControl->GetHandler( VCHDL_ONCHANGE );
}

void ImpSjJScriptTextObject::setOnChange( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCHANGE, aSourceStrg );
}

void ImpSjJScriptTextObject::onChange()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnChange() );
}

String ImpSjJScriptTextObject::getOnFocus() const
{
	return pControl->GetHandler( VCHDL_ONGETFOCUS );
}

void ImpSjJScriptTextObject::setOnFocus( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONGETFOCUS, aSourceStrg );
}

void ImpSjJScriptTextObject::onFocus()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnFocus() );
}

String ImpSjJScriptTextObject::getOnSelect() const
{
	return pControl->GetHandler( VCHDL_ONSELECT );
}

void ImpSjJScriptTextObject::setOnSelect( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONSELECT, aSourceStrg );
}

void ImpSjJScriptTextObject::onSelect()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnSelect() );
}

// Konstruktor
ImpSjJScriptTextObject::ImpSjJScriptTextObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptTextObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptTextObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptTextareaObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptTextareaObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptTextareaObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptTextareaObject::getType() const
{
	return String( "textarea" );		// Doku
	//return String( "text" );			// Netscape
}

// Eigene Properties
String ImpSjJScriptTextareaObject::getDefaultValue() const
{
	return ((VCEdit*)pControl)->GetDefaultText();
}

void ImpSjJScriptTextareaObject::setDefaultValue( const String & aStrg )
{
	((VCEdit*)pControl)->SetDefaultText( aStrg );
}

void ImpSjJScriptTextareaObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

// Methoden des Objektes
void ImpSjJScriptTextareaObject::focus()
{
	((VCEdit*)pControl)->Focus();
}

void ImpSjJScriptTextareaObject::blur()
{
	((VCEdit*)pControl)->Blur();
}

void ImpSjJScriptTextareaObject::select()
{
	((VCEdit*)pControl)->Select();
}


// Events (C++ --> Java)
//----------------------
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptTextareaObject::getOnBlur_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONLOSEFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextareaObject::setOnBlur_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextareaObject::getOnChange_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCHANGE );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextareaObject::setOnChange_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCHANGE, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextareaObject::getOnFocus_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONGETFOCUS );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextareaObject::setOnFocus_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONGETFOCUS, aMacro );
}

SjJScriptFunctionObject* ImpSjJScriptTextareaObject::getOnSelect_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONSELECT );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptTextareaObject::setOnSelect_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONSELECT, aMacro );
}
#endif

String ImpSjJScriptTextareaObject::getOnBlur() const
{
	return pControl->GetHandler( VCHDL_ONLOSEFOCUS );
}

void ImpSjJScriptTextareaObject::setOnBlur( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONLOSEFOCUS, aSourceStrg );
}

void ImpSjJScriptTextareaObject::onBlur()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnBlur() );
}

String ImpSjJScriptTextareaObject::getOnChange() const
{
	return pControl->GetHandler( VCHDL_ONCHANGE );
}

void ImpSjJScriptTextareaObject::setOnChange( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCHANGE, aSourceStrg );
}

void ImpSjJScriptTextareaObject::onChange()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnChange() );
}

String ImpSjJScriptTextareaObject::getOnFocus() const
{
	return pControl->GetHandler( VCHDL_ONGETFOCUS );
}

void ImpSjJScriptTextareaObject::setOnFocus( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONGETFOCUS, aSourceStrg );
}

void ImpSjJScriptTextareaObject::onFocus()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnFocus() );
}

String ImpSjJScriptTextareaObject::getOnSelect() const
{
	return pControl->GetHandler( VCHDL_ONSELECT );
}

void ImpSjJScriptTextareaObject::setOnSelect( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONSELECT, aSourceStrg );
}

void ImpSjJScriptTextareaObject::onSelect()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnSelect() );
}

// Konstruktor
ImpSjJScriptTextareaObject::ImpSjJScriptTextareaObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptTextareaObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptSubmitObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptSubmitObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptSubmitObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptSubmitObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

void ImpSjJScriptSubmitObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

String ImpSjJScriptSubmitObject::getType() const
{
	return String( "submit" );
}

// Methoden des Objektes
void ImpSjJScriptSubmitObject::click()
{
	((VCPushButton*)pControl)->ClickButton();
}


// Events (C++ --> Java)
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptSubmitObject::getOnClick_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCLICK );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptSubmitObject::setOnClick_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCLICK, aMacro );
}
#endif

String ImpSjJScriptSubmitObject::getOnClick() const
{
	return pControl->GetHandler( VCHDL_ONCLICK );
}

void ImpSjJScriptSubmitObject::setOnClick( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCLICK, aSourceStrg );
}

void ImpSjJScriptSubmitObject::onClick()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnClick() );
}

// Konstruktor
ImpSjJScriptSubmitObject::ImpSjJScriptSubmitObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptSubmitObject	( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptResetObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptResetObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptResetObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptResetObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

void ImpSjJScriptResetObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

String ImpSjJScriptResetObject::getType() const
{
	return String( "reset" );
}

// Methoden des Objektes
void ImpSjJScriptResetObject::click()
{
	((VCPushButton*)pControl)->ClickButton();
}


// Events (C++ --> Java)
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptResetObject::getOnClick_Fct() const
{
	SvxMacro* pMacro = (SvxMacro*)pControl->GetSvxMacro( VCHDL_ONCLICK );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptResetObject::setOnClick_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro aMacro( pFunctionObject, pFunctionObject->GetSource() );
	pControl->SetHandler( VCHDL_ONCLICK, aMacro );
}
#endif

String ImpSjJScriptResetObject::getOnClick() const
{
	return pControl->GetHandler( VCHDL_ONCLICK );
}

void ImpSjJScriptResetObject::setOnClick( const String & aSourceStrg )
{
	pControl->SetHandler( VCHDL_ONCLICK, aSourceStrg );
}

void ImpSjJScriptResetObject::onClick()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnClick() );
}

// Konstruktor
ImpSjJScriptResetObject::ImpSjJScriptResetObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptResetObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptHiddenObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptHiddenObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptHiddenObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptHiddenObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptHiddenObject::getType() const
{
	return String( "hidden" );
}

// Eigene Properties
void ImpSjJScriptHiddenObject::setValue( const String & aStrg )
{
	ImpSetValue( aStrg );
}

// Konstruktor
ImpSjJScriptHiddenObject::ImpSjJScriptHiddenObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptHiddenObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************


/*
 * Implementation ImpSjJScriptFileUploadObject
 */
// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
// Properties der Basis-Klasse -> durchreichen
String ImpSjJScriptFileUploadObject::getName() const
{
	//return ImpSjJScriptControlBase::getName();
	return ImpGetName();
}

void ImpSjJScriptFileUploadObject::setName( const String & aStrg )
{
	//ImpSjJScriptControlBase::setName( aStrg );
	ImpSetName( aStrg );
}

String ImpSjJScriptFileUploadObject::getValue() const
{
	//return ImpSjJScriptControlBase::getValue();
	return ImpGetValue();
}

String ImpSjJScriptFileUploadObject::getType() const
{
	return String( "file" );
}

// Konstruktor
ImpSjJScriptFileUploadObject::ImpSjJScriptFileUploadObject( VCControl* _pControl, SjJSbxObject * p )
	:SjJScriptFileUploadObject( p ), ImpSjJScriptControlBase( _pControl )
{
}

//************************************************************************

/*
 * Implementation ImpSjJScriptFormObject
 */

/*
// Hilfs-Methode, um das Wrapper-Objekt fuer ein Control zu erzeugen
SjJSbxObject* ImpSjJScriptFormObject::GetControlWrapperObject( VCControl* pControl ) const
{
	SjJSbxObject* pRet;

	// Ist es ein Radio-Button? Dann Wrapper vom Radio-Array anlegen
	VCRadioButton* pRadioButton = PTR_CAST(VCRadioButton,pControl);
	if( pRadioButton )
	{
		pRet = new ImpSjJScriptRadioArray
			( pRadioButton->GetRadioManager(), (ImpSjJScriptFormObject*)this );
	}
	else
	{
		pRet = pControl->GetJavaWrapper();
	}
	return pRet;
}
*/

// Methoden von Java --> C++ (f"ur Properties)
//--------------------------------------------
String ImpSjJScriptFormObject::getName() const
{
	return pVCForm->GetName();
}

void ImpSjJScriptFormObject::setName( const String & aStrg )
{
	pVCForm->SetName( aStrg );
}

String ImpSjJScriptFormObject::getValue() const
{
	// yyy Form
	// Property gibt es eigentlich nicht!
	// In Java Property ausbauen
	return String();
}

// Raus zum inkompatiblen
String ImpSjJScriptFormObject::getType() const
{
	// yyy Form
	// Property gibt es eigentlich nicht!
	// In Java Property ausbauen
	return String();
}

String ImpSjJScriptFormObject::getAction() const
{
	return pVCForm->GetURL();
}

void ImpSjJScriptFormObject::setAction( const String & sValue )
{
	pVCForm->SetURL( sValue );
}

String ImpSjJScriptFormObject::getEncoding() const
{
	return pVCForm->GetEncoding();
}

void ImpSjJScriptFormObject::setEncoding( const String & sValue )
{
	pVCForm->SetEncoding( sValue );
}

String ImpSjJScriptFormObject::getMethod() const
{
	USHORT nMethod = pVCForm->GetMethod();
	String aRetStr;
	if( nMethod == FORMMETH_GET )
		aRetStr = FORMMETH_GET_STR;
	else if( nMethod == FORMMETH_POST )
		aRetStr = FORMMETH_POST_STR;
	return aRetStr;
}

void ImpSjJScriptFormObject::setMethod( const String & sValue )
{
	if( sValue == FORMMETH_GET_STR )
		pVCForm->SetMethod( FORMMETH_GET );
	else if( sValue == FORMMETH_POST_STR )
		pVCForm->SetMethod( FORMMETH_POST );
}

String ImpSjJScriptFormObject::getTarget() const
{
	return pVCForm->GetTargetName();
}

void ImpSjJScriptFormObject::setTarget( const String & sValue )
{
	pVCForm->SetTargetName( sValue );
}

// SjJSbxArrayObject-Methoden
// !!! ACHTUNG: Ableitung muss noch erfolgen
// liefert die Anzahl der Elemente im Elements-Array
INT32 ImpSjJScriptFormObject::getLength() const
{
	return pVCForm->Count();
}

SjJSbxObject* ImpSjJScriptFormObject::getElement( INT32 nIndex ) const
{
	SjJSbxObject* pRet = NULL;
	VCControl* pControl = pVCForm->GetControl( (ULONG)nIndex );
	if( pControl )
		pRet = pControl->GetJavaWrapper();
	return pRet;
}

SjJSbxObject* ImpSjJScriptFormObject::getElement_String( const String & aName ) const
{
	VCControl* pControl = pVCForm->GetControl( aName );

	SjJSbxObject* pRet = NULL;

	// Ist es ein Radio-Button? Dann Wrapper vom Radio-Array anlegen
	VCRadioButton* pRadioButton = PTR_CAST(VCRadioButton,pControl);
	if( pRadioButton )
	{
		pRet = pRadioButton->GetRadioManager()->GetJavaWrapper();
	}
	else if( pControl )
	{
		pRet = pControl->GetJavaWrapper();
	}
	return pRet;
}

// Methoden des Objektes
void ImpSjJScriptFormObject::submit()
{
	pVCForm->Execute_Impl( NULL );
}

void ImpSjJScriptFormObject::reset()
{
	pVCForm->Reset_Impl();
}


// Events (C++ --> Java)
//----------------------
#if SUPD > 356 || defined(AB_EVENT_TEST)
// Neue Event-Schnittstelle mit Function-Objekten
SjJScriptFunctionObject* ImpSjJScriptFormObject::getOnSubmit_Fct() const
{
	SvxMacro* pMacro = pVCForm->GetHandlers().Get( VCHDL_ONSUBMITFORM );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptFormObject::setOnSubmit_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro* pNewMacro = new SvxMacro( pFunctionObject, pFunctionObject->GetSource() );
	SvxMacroTableDtor& rTable = (SvxMacroTableDtor&)pVCForm->GetHandlers();
	delete (SvxMacro*)rTable.Replace( VCHDL_ONSUBMITFORM, pNewMacro );
}

SjJScriptFunctionObject* ImpSjJScriptFormObject::getOnReset_Fct() const
{
	SvxMacro* pMacro = pVCForm->GetHandlers().Get( VCHDL_ONRESETFORM );
	return pMacro ? (SjJScriptFunctionObject*)pMacro->GetFunctionObject( (SjJSbxObject*)this ) : NULL;
}

void ImpSjJScriptFormObject::setOnReset_Fct( SjJScriptFunctionObject* pFunctionObject )
{
	if( !pFunctionObject )
		return;
	SvxMacro* pNewMacro = new SvxMacro( pFunctionObject, pFunctionObject->GetSource() );
	SvxMacroTableDtor& rTable = (SvxMacroTableDtor&)pVCForm->GetHandlers();
	delete (SvxMacro*)rTable.Replace( VCHDL_ONRESETFORM, pNewMacro );
}

#endif

String ImpSjJScriptFormObject::getOnSubmit() const
{
	SvxMacro* pMacro = pVCForm->GetHandlers().Get( VCHDL_ONSUBMITFORM );
//	return pMacro ? pMacro->GetMacName() : String();
	if ( pMacro )
		return pMacro->GetMacName();
	else
		return String();
	// ALT
	// return pVCForm->GetSubmitMacro();
}

void ImpSjJScriptFormObject::setOnSubmit( const String & aSourceStrg )
{
	// SPAETER mit SjJScriptFunctionObject:
	// delete pVCForm->GetHandlers()->Replace( VCHDL_ONSUBMITFORM, pNewFunctionObj );

	// ALT
	//pVCForm->SetSubmitMacro( aSourceStrg );
}

void ImpSjJScriptFormObject::onSubmit()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnSubmit() );
}

String ImpSjJScriptFormObject::getOnReset() const
{
	SvxMacro* pMacro = pVCForm->GetHandlers().Get( VCHDL_ONRESETFORM );
//	return pMacro ? pMacro->GetMacName() : String();
	if ( pMacro )
		return pMacro->GetMacName();
	else
		return String();
	// ALT:
	// return pVCForm->GetResetMacro();
}

void ImpSjJScriptFormObject::setOnReset( const String & aSourceStrg )
{
	// SPAETER mit SjJScriptFunctionObject:
	// delete pVCForm->GetHandlers()->Replace( VCHDL_ONRESETFORM, pNewFunctionObj );

	// ALT
	// pVCForm->SetResetMacro( aSourceStrg );
}

void ImpSjJScriptFormObject::onReset()
{
	// Ueberfluessig bei Verwendung der SFX-Schnittstelle
	// RunCode( getOnReset() );
}

// Konstruktor
ImpSjJScriptFormObject::ImpSjJScriptFormObject( VCForm* _pVCForm, SjJSbxObject * p )
	:SjJScriptFormObject( p )
{
	pVCForm = _pVCForm;
}

#endif


