/*************************************************************************
 *
 *  $RCSfile: vcattr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SYSTEM_HXX
#include <vcl/system.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _SFXRNGITEM_HXX
#include <svtools/rngitem.hxx>
#endif
#ifndef _VIRDEV_HXX
#include <vcl/virdev.hxx>
#endif
#ifndef _APP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#define ITEMID_MACRO 11111
#include <svtools/macitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#pragma hdrstop

#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#include "vctrls.hrc"
#define _SI_VCITEMS
#include "vcattr.hxx"
#include "vcalgit.hxx"
#include "vcbalgit.hxx"
#include "vccbstit.hxx"
#include "vcfmacit.hxx"
#include "vcinliit.hxx"
#include "vcnkstit.hxx"
#include "vcmpit.hxx"
#include "vcmselit.hxx"
#include "vcurlit.hxx"
#include "vcwwit.hxx"
#include "vcattrid.hrc"
#include "formdlg.hrc"
#include "siresid.hxx"
#include "sidll.hxx"

#if SUPD > 354

SfxItemInfo __READONLY_DATA aItemInfos[] =
{
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, 0 },					// SfxStringListItem
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE },
	{ 0, SFX_ITEM_POOLABLE }
};

#endif


TYPEINIT1_AUTOFACTORY(VCURLItem, SfxStringItem);

VCURLItem::VCURLItem( USHORT nWhich, SvStream& rStrm ) :
	SfxStringItem( nWhich, rStrm )
{
	XubString aRel;
	rStrm.ReadByteString( aRel, ::GetStoreCharSet( gsl_getSystemTextEncoding()));
	XubString aAbs = INetURLObject::RelToAbs( aRel );
	SetValue( aAbs );
}

SfxPoolItem* VCURLItem::Create(SvStream& rStream, USHORT nVersion) const
{
	XubString aRel;
	rStream.ReadByteString( aRel, ::GetStoreCharSet( gsl_getSystemTextEncoding()));
	XubString aAbs = INetURLObject::RelToAbs( aRel );
	return new VCURLItem( Which(), aAbs );
}

SvStream& VCURLItem::Store(SvStream& rStream, USHORT) const
{
	const XubString& rAbs = GetValue();
	String aRel = INetURLObject::AbsToRel( rAbs );
	rStream.WriteByteString( aRel, ::GetStoreCharSet( gsl_getSystemTextEncoding()));
	return rStream;
}

SfxPoolItem* VCURLItem::Clone( SfxItemPool* ) const
{
	return new VCURLItem( *this );
}

TYPEINIT1_AUTOFACTORY(VCComboStyleItem, SfxEnumItem);

VCComboStyleItem::VCComboStyleItem( USHORT nWhich, USHORT eStyle ) :
	SfxEnumItem( nWhich, eStyle )
{
}

SfxPoolItem* VCComboStyleItem::Clone( SfxItemPool* ) const
{
	return new VCComboStyleItem( *this );
}

SfxPoolItem* VCComboStyleItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eStyle;
	rStream >> eStyle;

	return new VCComboStyleItem( Which(), eStyle );
}

SvStream& VCComboStyleItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCComboStyleItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCComboStyleItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCCOMBO_DDCOMBO, "enum overflow!" );

	switch( nPos )
	{
		case VCCOMBO_DDLIST:   return String( SiResId( STR_COMBOSTYLE_DDLIST ) );
		case VCCOMBO_COMBO:    return String( SiResId( STR_COMBOSTYLE_COMBO ) );
		case VCCOMBO_DDCOMBO:  return String( SiResId( STR_COMBOSTYLE_DDCOMBO ) );
	}

	return String();
}

USHORT VCComboStyleItem::GetValueCount() const
{
	return (USHORT)( VCCOMBO_DDCOMBO + 1 );
}


TYPEINIT1_AUTOFACTORY(VCMousePointerItem, SfxEnumItem);

VCMousePointerItem::VCMousePointerItem( USHORT nWhich, USHORT ePointer ) :
	SfxEnumItem( nWhich, ePointer )
{
}

SfxPoolItem* VCMousePointerItem::Clone( SfxItemPool* ) const
{
	return new VCMousePointerItem( *this );
}

SfxPoolItem* VCMousePointerItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT ePointer;
	rStream >> ePointer;

	return new VCMousePointerItem( Which(), ePointer );
}

SvStream& VCMousePointerItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCMousePointerItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCMousePointerItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCPOINTER_NODROP, "enum overflow!" );

	USHORT nResId = (USHORT)STR_POINTER_DEFAULT + nPos;

	return String( SiResId( nResId ) );
}

USHORT VCMousePointerItem::GetValueCount() const
{
	return (USHORT)( VCPOINTER_NODROP + 1 );
}


TYPEINIT1_AUTOFACTORY(VCMultiSelectItem, SfxEnumItem);

VCMultiSelectItem::VCMultiSelectItem( USHORT nWhich, USHORT eMulti ) :
	SfxEnumItem( nWhich, eMulti )
{
}

SfxPoolItem* VCMultiSelectItem::Clone( SfxItemPool* ) const
{
	return new VCMultiSelectItem( *this );
}

SfxPoolItem* VCMultiSelectItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eMulti;
	rStream >> eMulti;

	return new VCMultiSelectItem( Which(), eMulti );
}

SvStream& VCMultiSelectItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCMultiSelectItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCMultiSelectItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCMULTI_EXTMULTI, "enum overflow!" );

	switch( nPos )
	{
		case VCMULTI_SINGLE:      return String( SiResId( STR_MULTISELECT_SINGLE ) );
		case VCMULTI_SIMPLEMULTI: return String( SiResId( STR_MULTISELECT_SIMPLEMULTI ) );
		case VCMULTI_EXTMULTI:    return String( SiResId( STR_MULTISELECT_EXTMULTI ) );
	}

	return String();
}

USHORT VCMultiSelectItem::GetValueCount() const
{
	return (USHORT)( VCMULTI_EXTMULTI + 1 );
}


TYPEINIT1_AUTOFACTORY(VCBackStyleItem, SfxEnumItem);

VCBackStyleItem::VCBackStyleItem( USHORT nWhich, USHORT eBackStyle ) :
	SfxEnumItem( nWhich, eBackStyle )
{
}

SfxPoolItem* VCBackStyleItem::Clone( SfxItemPool* ) const
{
	return new VCBackStyleItem( *this );
}

SfxPoolItem* VCBackStyleItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eBackStyle;
	rStream >> eBackStyle;

	return new VCBackStyleItem( Which(), eBackStyle );
}

SvStream& VCBackStyleItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCBackStyleItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCBackStyleItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCBACK_OPAQUE, "enum overflow!" );

	switch( nPos )
	{
		case VCBACK_TRANSPARENT: return String( SiResId( STR_BACKSTYLE_TRANSPARENT ) );
		case VCBACK_OPAQUE:      return String( SiResId( STR_BACKSTYLE_OPAQUE ) );
	}

	return String();
}

USHORT VCBackStyleItem::GetValueCount() const
{
	return (USHORT)( VCBACK_OPAQUE + 1 );
}



TYPEINIT1_AUTOFACTORY(VCAlignmentItem, SfxEnumItem);

VCAlignmentItem::VCAlignmentItem( USHORT nWhich, USHORT eAlignment ) :
	SfxEnumItem( nWhich, eAlignment )
{
}

SfxPoolItem* VCAlignmentItem::Clone( SfxItemPool* ) const
{
	return new VCAlignmentItem( *this );
}

SfxPoolItem* VCAlignmentItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eAlign;
	rStream >> eAlign;

	return new VCAlignmentItem( Which(), eAlign );
}

SvStream& VCAlignmentItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCAlignmentItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCAlignmentItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCALIGN_CENTER, "enum overflow!" );

	switch( nPos )
	{
		case VCALIGN_LEFT:   return String( SiResId( STR_ALIGNMENT_LEFT ) );
		case VCALIGN_RIGHT:  return String( SiResId( STR_ALIGNMENT_RIGHT ) );
		case VCALIGN_CENTER: return String( SiResId( STR_ALIGNMENT_CENTER ) );
	}

	return String();
}

USHORT VCAlignmentItem::GetValueCount() const
{
	return (USHORT)( VCALIGN_CENTER + 1 );
}


TYPEINIT1_AUTOFACTORY(VCButtonAlignmentItem, SfxEnumItem);

VCButtonAlignmentItem::VCButtonAlignmentItem( USHORT nWhich, USHORT eAlignment ) :
	SfxEnumItem( nWhich, eAlignment )
{
}

SfxPoolItem* VCButtonAlignmentItem::Clone( SfxItemPool* ) const
{
	return new VCButtonAlignmentItem( *this );
}

SfxPoolItem* VCButtonAlignmentItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eAlign;
	rStream >> eAlign;

	return new VCButtonAlignmentItem( Which(), eAlign );
}

SvStream& VCButtonAlignmentItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCButtonAlignmentItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCButtonAlignmentItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCBTNALIGN_RIGHT, "enum overflow!" );

	switch( nPos )
	{
		case VCBTNALIGN_LEFT:   return String( SiResId( STR_BTNALIGNMENT_LEFT ) );
		case VCBTNALIGN_RIGHT:  return String( SiResId( STR_BTNALIGNMENT_RIGHT ) );
	}

	return String();
}

USHORT VCButtonAlignmentItem::GetValueCount() const
{
	return (USHORT)( VCBTNALIGN_RIGHT + 1 );
}

TYPEINIT1_AUTOFACTORY(VCFormActionItem, SfxEnumItem);

VCFormActionItem::VCFormActionItem( USHORT nWhich, USHORT eAction ) :
	SfxEnumItem( nWhich, eAction )
{
}

SfxPoolItem* VCFormActionItem::Clone( SfxItemPool* ) const
{
	return new VCFormActionItem( *this );
}

SfxPoolItem* VCFormActionItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eAction;
	rStream >> eAction;

	return new VCFormActionItem( Which(), eAction );
}

SvStream& VCFormActionItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCFormActionItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCFormActionItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCFORMACTION_RESET	, "enum overflow!" );

	switch( nPos )
	{
		case VCFORMACTION_NONE:   return String( SiResId( STR_FORMACTION_NONE ) );
		case VCFORMACTION_SUBMIT: return String( SiResId( STR_FORMACTION_SUBMIT ) );
		case VCFORMACTION_RESET:  return String( SiResId( STR_FORMACTION_RESET ) );
	}
	return String();
}

USHORT VCFormActionItem::GetValueCount() const
{
	return (USHORT)( VCFORMACTION_RESET + 1 );
}


TYPEINIT1_AUTOFACTORY(VCIntegerListItem, SfxStringListItem);

void VCIntegerListItem::ConvertToNums()
{
	/* OV 8.5.1996  wg. HTML-Forms keine Beschraenkung auf Integers
	List* pList = GetList();

	String* pStr = (String*)pList->First();
	while( pStr )
	{
		*pStr = String( (short)*pStr );
		pStr = (String*)pList->Next();
	}
	*/
}

VCIntegerListItem::VCIntegerListItem( USHORT nWhich, const List* pList ) :
	SfxStringListItem( nWhich, pList )
{
	ConvertToNums();
}

VCIntegerListItem::VCIntegerListItem( USHORT nWhich, SvStream& rStream ) :
	SfxStringListItem( nWhich, rStream )
{
	ConvertToNums();
}

void VCIntegerListItem::SetString( const String& rStr )
{
	SfxStringListItem::SetString( rStr );
	ConvertToNums();
}

void VCIntegerListItem::SetEntryCount( USHORT nEntries )
{
	List* pList = GetList();

	if( pList->Count() == nEntries )
		return;

	if( nEntries > pList->Count() )
	{
		USHORT nDiff = nEntries - (USHORT)pList->Count();
		USHORT i;
		for( i=0; i < nDiff; i++ )
			pList->Insert( new String(), LIST_APPEND );
	}
	else
	{
		USHORT nDiff = ((USHORT)pList->Count()) - nEntries;
		USHORT i;
		for( i=0; i < nDiff; i++ )
			delete (String*)(pList->Remove( pList->Count()-1 ));
	}
}

SfxPoolItem* VCIntegerListItem::Clone( SfxItemPool* pPool ) const
{
	return new VCIntegerListItem( *this );
}

SfxPoolItem* VCIntegerListItem::Create( SvStream& rStream, USHORT nVersion ) const
{
	return new VCIntegerListItem( Which(), rStream );
}

int	VCIntegerListItem::operator==( const SfxPoolItem& rItem ) const
{
	return SfxStringListItem::operator==( rItem );
}


DBG_NAME(VCItemPool);

VCItemPool::VCItemPool() :
		SfxItemPool( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "VCControls" )),
					 VCATTR_START, VCATTR_END, &aItemInfos[0] )
{
	DBG_CTOR(VCItemPool,0);
	SiDLL* pDLL = SI_DLL();
	DBG_ASSERT(pDLL,"VCItemPool: No SiDLL-Object");
	SfxPoolItem** ppPoolDefaults = pDLL->ppPoolDefaults;
	if( !ppPoolDefaults )
	{
		ppPoolDefaults = new SfxPoolItem*[VCATTR_END - VCATTR_START + 1];

		Font aAppFont    = GetpApp()->GetSettings().GetStyleSettings().GetAppFont();
		Font aSystemFont = System::GetStandardFont(STDFONT_SYSTEM);
		if( !aAppFont.GetName().Len() )
		{
			aAppFont.SetSize( aSystemFont.GetSize() );
			aAppFont.SetName( aSystemFont.GetName() );
		}

		String aEmptyStr;
		VirtualDevice aDev;
		Size aSize = aDev.PixelToLogic( aAppFont.GetSize(), MAP_POINT );

		ppPoolDefaults[0] 	= new VCWordWrapItem(VCATTR_WORDWRAP_MODE);
		ppPoolDefaults[1] 	= new SfxBoolItem(VCATTR_AUTOADJUST_SIZE,FALSE);
		ppPoolDefaults[2] 	= new SfxBoolItem(VCATTR_FILEUPLOAD,FALSE);
		ppPoolDefaults[3] 	= new SfxBoolItem(VCATTR_DEFAULTCHECKED,FALSE);
		ppPoolDefaults[4] 	= new SfxStringItem(VCATTR_DEFAULTTEXT,aEmptyStr);
		ppPoolDefaults[5] 	= new SfxBoolItem(VCATTR_DEFAULTSELECTED_BOOL,FALSE);
		ppPoolDefaults[6] 	= new SfxInt32Item(VCATTR_DEFAULTSELECTED_USHORT,0);
		ppPoolDefaults[7] 	= new SfxBoolItem(VCATTR_PRINT,TRUE);
		ppPoolDefaults[8] 	= new VCURLItem(VCATTR_IMAGEURL,aEmptyStr);
		ppPoolDefaults[9] 	= new SfxStringItem(VCATTR_TARGETFRAME,aEmptyStr);
		ppPoolDefaults[10] 	= new SfxStringItem( VCATTR_FORMNAME,
												 String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Standard" )));
		ppPoolDefaults[11] 	= new VCURLItem( VCATTR_URL, aEmptyStr );
		ppPoolDefaults[12]   = new SfxInt32Item( VCATTR_INDEX );
		ppPoolDefaults[13] 	= new SfxStringItem( VCATTR_NAME, aEmptyStr );
		ppPoolDefaults[14]   = new SfxInt32Item( VCATTR_HELPCONTEXTID );
		ppPoolDefaults[15]   = new SfxStringItem( VCATTR_HELPTEXT, aEmptyStr );
		ppPoolDefaults[16]   = new VCMousePointerItem( VCATTR_MOUSEPOINTER );
		ppPoolDefaults[17]   = new SfxStringItem( VCATTR_TAG, aEmptyStr );
		ppPoolDefaults[18] 	= new SfxBoolItem( VCATTR_ENABLED, TRUE );
		ppPoolDefaults[19]   = new SfxInt32Item( VCATTR_STEP );
		ppPoolDefaults[20] 	= new SfxBoolItem( VCATTR_VISIBLE, TRUE );
		ppPoolDefaults[21] 	= new SfxInt32Item( VCATTR_LEFT );
		ppPoolDefaults[22] 	= new SfxInt32Item( VCATTR_TOP );
		ppPoolDefaults[23] 	= new SfxInt32Item( VCATTR_WIDTH );
		ppPoolDefaults[24] 	= new SfxInt32Item( VCATTR_HEIGHT );
		ppPoolDefaults[25]  = new SfxRangeItem( VCATTR_FONTRANGE, VCATTR_FONTBOLD, VCATTR_FONTUNDERLINE );
		ppPoolDefaults[26] 	= new SfxBoolItem( VCATTR_FONTBOLD );
		ppPoolDefaults[27] 	= new SfxBoolItem( VCATTR_FONTITALIC );
		ppPoolDefaults[28] 	= new SfxStringItem( VCATTR_FONTNAME, aAppFont.GetName() );
//#ifdef MAC
//		ppPoolDefaults[29] 	= new SfxInt32Item( VCATTR_FONTSIZE, 12 );	// 8 Punkt Chicago sieht zu dumm aus
//#else
		ppPoolDefaults[29] 	= new SfxInt32Item( VCATTR_FONTSIZE, 8 );
//#endif
		ppPoolDefaults[30]  = new SfxBoolItem( VCATTR_FONTSTRIKETHRU );
		ppPoolDefaults[31]  = new SfxBoolItem( VCATTR_FONTUNDERLINE );
		ppPoolDefaults[32]  = new SvxColorItem( Color( COL_WHITE ), VCATTR_BACKCOLOR );
		ppPoolDefaults[33]  = new SvxColorItem( Color( COL_BLACK ), VCATTR_FORECOLOR );
		ppPoolDefaults[34] 	= new SfxStringItem( VCATTR_CAPTION, aEmptyStr );
		ppPoolDefaults[35] 	= new SfxBoolItem( VCATTR_BORDER );
		ppPoolDefaults[36]  = new SfxInt32Item( VCATTR_TABINDEX );
		ppPoolDefaults[37]  = new SfxBoolItem( VCATTR_TABSTOP, TRUE );
		ppPoolDefaults[38]  = new SfxStringItem( VCATTR_LINK, aEmptyStr );
		ppPoolDefaults[39]  = new SfxInt32Item( VCATTR_CHANGE, 1 );
		ppPoolDefaults[40]  = new VCButtonAlignmentItem( VCATTR_BUTTONALIGNMENT );
		ppPoolDefaults[41]	= new SfxBoolItem( VCATTR_CHECKBOXVALUE );
		ppPoolDefaults[42]	= new SfxBoolItem( VCATTR_RADIOBUTTONVALUE );
		ppPoolDefaults[43]  = new SfxInt32Item( VCATTR_SPINBUTTONVALUE );
		ppPoolDefaults[44]  = new SfxInt32Item( VCATTR_SCROLLBARVALUE );
		ppPoolDefaults[45]	= new SfxInt32Item( VCATTR_MIN, 0 );
		ppPoolDefaults[46]	= new SfxInt32Item( VCATTR_MAX, 32767 );
		ppPoolDefaults[47]  = new SfxInt32Item( VCATTR_SMALLCHANGE, 1 );
		ppPoolDefaults[48]  = new SfxInt32Item( VCATTR_LARGECHANGE, 1 );
		ppPoolDefaults[49]  = new VCMultiSelectItem( VCATTR_MULTISELECT );
		ppPoolDefaults[50]  = new SfxStringListItem( VCATTR_LIST );
		ppPoolDefaults[51]  = new VCIntegerListItem( VCATTR_ITEMDATA );
		ppPoolDefaults[52]  = new SfxBoolItem( VCATTR_SORTED );
		ppPoolDefaults[53]  = new SfxStringItem( VCATTR_LISTRANGE, aEmptyStr );
		ppPoolDefaults[54]  = new VCComboStyleItem( VCATTR_COMBOSTYLE );
		ppPoolDefaults[55]  = new SfxBoolItem( VCATTR_DEFAULT );
		ppPoolDefaults[56]  = new SfxBoolItem( VCATTR_CANCEL );
		ppPoolDefaults[57]  = new SfxStringItem( VCATTR_TEXT, aEmptyStr );
//#ifdef MAC
//		ppPoolDefaults[58]  = new SfxBoolItem( VCATTR_AUTO3D, FALSE );
//#else
		ppPoolDefaults[58]  = new SfxBoolItem( VCATTR_AUTO3D, TRUE );
//#endif
		ppPoolDefaults[59]  = new SfxInt32Item( VCATTR_CURRENTSTEP );
		ppPoolDefaults[60]  = new VCBackStyleItem( VCATTR_BACKSTYLE );
		ppPoolDefaults[61]  = new SfxBoolItem( VCATTR_USEMNEMONIC, TRUE );
		ppPoolDefaults[62]  = new SfxBoolItem( VCATTR_WORDWRAP );
		ppPoolDefaults[63]  = new SfxBoolItem( VCATTR_AUTOSIZE );
		ppPoolDefaults[64]  = new VCAlignmentItem( VCATTR_ALIGNMENT );
		ppPoolDefaults[65]  = new SfxBoolItem( VCATTR_HIDESELECTION, TRUE );
		ppPoolDefaults[66]  = new SfxInt32Item( VCATTR_MAXLENGTH );
		ppPoolDefaults[67]  = new SfxBoolItem( VCATTR_MULTILINE );
		ppPoolDefaults[68]  = new SfxStringItem( VCATTR_PASSWORDCHAR, aEmptyStr );
		ppPoolDefaults[69]  = new SfxBoolItem( VCATTR_READONLY );
		ppPoolDefaults[70]  = new SfxBoolItem( VCATTR_SCROLLBARS );
		ppPoolDefaults[71]  = new SfxStringItem( VCATTR_ONACTION, aEmptyStr );
		ppPoolDefaults[72]  = new SfxStringItem( VCATTR_DBLCLICK, aEmptyStr );
		ppPoolDefaults[73]  = new SfxStringItem( VCATTR_CLICK, aEmptyStr );
		ppPoolDefaults[74]  = new SfxStringItem( VCATTR_GOTFOCUS, aEmptyStr );
		ppPoolDefaults[75]  = new SfxStringItem( VCATTR_LOSTFOCUS, aEmptyStr );
		ppPoolDefaults[76]  = new SfxStringItem( VCATTR_KEYPRESS, aEmptyStr );
		ppPoolDefaults[77]  = new SfxStringItem( VCATTR_KEYDOWN, aEmptyStr );
		ppPoolDefaults[78]  = new SfxStringItem( VCATTR_KEYUP, aEmptyStr );
		ppPoolDefaults[79]  = new SfxStringItem( VCATTR_MOUSEDOWN, aEmptyStr );
		ppPoolDefaults[80]  = new SfxStringItem( VCATTR_MOUSEMOVE, aEmptyStr );
		ppPoolDefaults[81]  = new SfxStringItem( VCATTR_MOUSEUP, aEmptyStr );
		ppPoolDefaults[82]  = new SfxStringItem( VCATTR_CHANGED, aEmptyStr );
		ppPoolDefaults[83]  = new SfxStringItem( VCATTR_SCROLL, aEmptyStr );
		ppPoolDefaults[84]  = new SfxStringItem( VCATTR_SPINUP, aEmptyStr );
		ppPoolDefaults[85]  = new SfxStringItem( VCATTR_SPINDOWN, aEmptyStr );
		ppPoolDefaults[86]  = new SfxStringItem( VCATTR_ACTIVATE, aEmptyStr );
		ppPoolDefaults[87]  = new SfxStringItem( VCATTR_DEACTIVATE, aEmptyStr );
		ppPoolDefaults[88]  = new SfxStringItem( VCATTR_LOAD, aEmptyStr );
		ppPoolDefaults[89]  = new SfxStringItem( VCATTR_UNLOAD, aEmptyStr );
		ppPoolDefaults[90]  = new SfxStringItem( VCATTR_RESIZE, aEmptyStr );
		ppPoolDefaults[91]  = new SfxStringItem( VCATTR_PAINT, aEmptyStr );
		ppPoolDefaults[92]  = new VCFormActionItem( VCATTR_FORMACTION );
		ppPoolDefaults[93]  = new SfxStringItem( VCATTR_ONSELECT,aEmptyStr  );
		ppPoolDefaults[94]  = new SfxStringItem( VCATTR_ONCLICK,aEmptyStr  );
		ppPoolDefaults[95]  = new SvxMacroItem( VCATTR_MACROS );
		pDLL->ppPoolDefaults = ppPoolDefaults;
	}
	SetDefaults( ppPoolDefaults );
}

VCItemPool::~VCItemPool()
{
	DBG_DTOR(VCItemPool,0);
}


TYPEINIT1_AUTOFACTORY(VCWordWrapItem, SfxEnumItem);

VCWordWrapItem::VCWordWrapItem( USHORT nWhich, USHORT eStyle ) :
	SfxEnumItem( nWhich, eStyle )
{
}

SfxPoolItem* VCWordWrapItem::Clone( SfxItemPool* ) const
{
	return new VCWordWrapItem( *this );
}

SfxPoolItem* VCWordWrapItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eStyle;
	rStream >> eStyle;

	return new VCWordWrapItem( Which(), eStyle );
}

SvStream& VCWordWrapItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

SfxItemPresentation VCWordWrapItem::GetPresentation( SfxItemPresentation,
							SfxMapUnit,
							SfxMapUnit,
							String &rText, const International * ) const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

String VCWordWrapItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos <= (USHORT)VCWORDWRAP_SOFT, "enum overflow!" );
	switch( nPos )
	{
		case VCWORDWRAP_OFF:   return String( SiResId( STR_WORDWRAP_OFF ) );
		case VCWORDWRAP_HARD:  return String( SiResId( STR_WORDWRAP_HARD ) );
		case VCWORDWRAP_SOFT:  return String( SiResId( STR_WORDWRAP_SOFT ) );
	}

	return String();
}

USHORT VCWordWrapItem::GetValueCount() const
{
	return (USHORT)( VCWORDWRAP_SOFT + 1 );
}


