/*************************************************************************
 *
 *  $RCSfile: vcbrw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _VC_VCSBXCONTROL_HXX
#include <vcsbxctl.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX
#include <sfx2/childwin.hxx>
#endif
#ifndef _BASEDLGS_HXX
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SFXRNGITEM_HXX
#include <svtools/rngitem.hxx>
#endif
#ifndef _SFX_SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#define ITEMID_MACRO 11111
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif
#ifndef _MACROPG_HXX
#include <sfx2/macropg.hxx>
#endif
#ifndef _TABBAR_HXX
#include <svtools/tabbar.hxx>
#endif

#ifndef _SVX_SIVCDRMOD_HXX //autogen
#include <vcdrmod.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SVDVIEW_HXX //autogen
#include <svx/svdview.hxx>
#endif


#pragma hdrstop

#define SI_VCDRAWOBJ
#define SI_VCDLGOBJ
#ifndef _SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#include "vcspnbtn.hxx"
#include "vcpbttn.hxx"
#include "vcscrbar.hxx"
#include "vcedit.hxx"
#include "vclbox.hxx"
#include "vccbbox.hxx"
#include "vcchkbox.hxx"
#include "vcrdbttn.hxx"
#include "vcfxtxt.hxx"
#include "vcprvw.hxx"
#include "vcgrpbox.hxx"
#include "basidesh.hxx"
#include <svx/impgrf.hxx>
#include "helpid.hrc"
#include "isetbrw.hxx"
#include "vctrls.hrc"
#include "vcattrid.hrc"
#include "vcattr.hxx"
#include "vcsbxdo.hxx"
#include "vcdrwobj.hxx"
#include "vcbrw.hxx"
#include "vcbrwwrp.hxx"
#include "siresid.hxx"
#include "formdlg.hxx"
#include "formdlg.hrc"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "sbxitem.hxx"
#include "vcfont.hxx"

#define TABPAGE_PROPERTIES		1
#define TABPAGE_EVENTS          2

//---------------------
// class VCItemBrowser
//---------------------
class VCItemBrowser : public ItemSetBrowser
{
protected:
	Link		aNotifyChangingItemLink;
	VCBrowser*	pOwner;
	USHORT		nChangingWhich;

			String		GetItemTitle( USHORT nWhich ) const;
	virtual USHORT		GetItemFlags( const SfxPoolItem* );

	virtual void DotButtonClick( BrwListEntry* );
	virtual BOOL NotifyChangingItem( USHORT nWhichId, const SfxPoolItem* pNew );
	void AddEvents( const TypeId&, BOOL bRealCtrl, SfxMacroTabPage* pPage );

public:
		VCItemBrowser( Window* pParent, VCBrowser* pOwner, WinBits nWinStyle = 0 );
		VCItemBrowser( Window* pParent, VCBrowser* pOwner, const ResId& rResId );

	USHORT	GetChangingWhich() { return nChangingWhich; }

	Link 	ChangeNotifyChangingItemHdl( const Link& rLink );
	virtual String GetItemDropDownData( USHORT nWhichId );
};

String VCItemBrowser::GetItemTitle( USHORT nWhich ) const
{
	return String( SiResId( nWhich-VCATTR_START+RID_ATTR_START) );
}

USHORT VCItemBrowser::GetItemFlags( const SfxPoolItem* pItem )
{
	USHORT nFlags = ItemSetBrowser::GetItemFlags( pItem );
	USHORT nWhich  = pItem->Which();
	switch( nWhich )
	{
		// hierfuer gibts jetzt das SvxMacroItem
		case VCATTR_ONACTION   :
		case VCATTR_DBLCLICK   :
		case VCATTR_CLICK	   :
		case VCATTR_GOTFOCUS   :
		case VCATTR_LOSTFOCUS  :
		case VCATTR_KEYPRESS   :
		case VCATTR_KEYDOWN    :
		case VCATTR_KEYUP      :
		case VCATTR_MOUSEDOWN  :
		case VCATTR_MOUSEMOVE  :
		case VCATTR_MOUSEUP    :
		case VCATTR_CHANGED    :
		case VCATTR_SCROLL	   :
		case VCATTR_SPINUP	   :
		case VCATTR_SPINDOWN   :
		case VCATTR_ACTIVATE   :
		case VCATTR_DEACTIVATE :
		case VCATTR_LOAD	   :
		case VCATTR_UNLOAD	   :
		case VCATTR_RESIZE	   :
		case VCATTR_PAINT	   :
		case VCATTR_ONSELECT   :
		case VCATTR_ONCLICK	   :
			nFlags |= ITEMFLAG_HIDE;
			break;

		case VCATTR_MACROS:
			nFlags = ITEMFLAG_DOTBUTTON | ITEMFLAG_HIDE_IN_MULTISEL;
			break;

		case VCATTR_NAME :
		case VCATTR_TABINDEX :
			nFlags |= ITEMFLAG_HIDE_IN_MULTISEL;
			break;

		case VCATTR_FORMNAME :
		case VCATTR_IMAGEURL :
			nFlags = ITEMFLAG_DOTBUTTON | ITEMFLAG_STRINGEDIT;
			break;

		case VCATTR_TARGETFRAME:
			nFlags = ITEMFLAG_COMBOBUTTON | ITEMFLAG_STRINGEDIT;
			break;

		case VCATTR_LEFT :
		case VCATTR_TOP :
			{
			ULONG nMark = pOwner->pView->GetMarkList().GetMarkCount();
			for( ULONG i=0; i < nMark; i++ )
			{
				SdrObject* pObj = pOwner->pView->GetMarkList().GetMark(i)->GetObj();
				if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
				{
					nFlags = 0; // Position des Dialoges ist ReadOnly
					break;
				}
			}
			}
			break;
	}
	return nFlags;
}

void VCItemBrowser::DotButtonClick( BrwListEntry* pEntry )
{
	USHORT nWhich = pEntry->GetItem()->Which();
	ULONG i;
	VCControl* pCurCtrl;

	switch( nWhich )
	{
		case VCATTR_FONTRANGE:
		{
			// Der Wert richtet sich immer nach dem ersten ItemSet,
			// also dem zuerst selektierten Object
			SfxItemSet* pItemSet = GetItemSet(0);
			if( !pItemSet )
				return;

			VCFontDialog aDlg( pItemSet );
			if( aDlg.Execute() )
			{
				SfxItemSet* pResult = aDlg.CreateVCOutputItemSet();
				ULONG nSets = GetItemSetCount();
				for( i=0; i < nSets; i++ )
				{
					SfxItemSet* pCur = GetItemSet(i);
					pCur->Put( *pResult );
				}
				delete pResult;
				SfxRangeItem& rFontRange = (SfxRangeItem&)pItemSet->Get( VCATTR_FONTRANGE );
				UpdateRange( GetItemSet(0), rFontRange.From(), rFontRange.To() );
				Modify();
			}
		}
		break;

		case VCATTR_MACROS:
		{
		if( pOwner->pView->GetMarkList().GetMarkCount() != 1)
			return;

		SdrObject* pObj = pOwner->pView->GetMarkList().GetMark(0)->GetObj();

		if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
		{
			VCSbxDrawObject* pFound = (VCSbxDrawObject*)pObj;
			pCurCtrl = pFound->GetControl()->GetVCControl();
			SfxItemSet aSet( *pCurCtrl->GetPool(), SID_ATTR_MACROITEM, SID_ATTR_MACROITEM );
			aSet.Put( (const SvxMacroItem&)pCurCtrl->GetItemSet()->Get(VCATTR_MACROS), SID_ATTR_MACROITEM);
			SfxMacroAssignDlg* pMacroDlg = new SfxMacroAssignDlg(
				GetpApp()->GetDefDialogParent(), aSet );
			SfxMacroTabPage* pMacroTabPage = (SfxMacroTabPage*)pMacroDlg->GetTabPage();
			DBG_ASSERT(pMacroTabPage,"MacroTabPage not found");
			AddEvents( pCurCtrl->Type(), pCurCtrl->IsReal(), pMacroTabPage );
			if ( pMacroDlg->Execute() == RET_OK )
			{
				const SfxItemSet* pOutSet = pMacroDlg->GetOutputItemSet();
				pCurCtrl->GetItemSet()->Put(
					pOutSet->Get(SID_ATTR_MACROITEM), VCATTR_MACROS);
				// Handler fuer alte Office-Versionen setzen
				VCControl::SetOldHandlers(
					pCurCtrl->GetItemSet(),
					pCurCtrl->Type(), pCurCtrl->IsReal() );
				((VCDrawModel*)pFound->GetModel())->VCDrawModelChanged( TRUE );
			}
			delete pMacroDlg;
		}
		else if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
		{
			VCSbxDialogObject* pFound = (VCSbxDialogObject*)pObj;
			SfxItemSet aSet( *pFound->GetItemSet()->GetPool(), SID_ATTR_MACROITEM, SID_ATTR_MACROITEM );
			aSet.Put( (const SvxMacroItem&)pFound->GetItemSet()->Get(VCATTR_MACROS), SID_ATTR_MACROITEM);
			SfxMacroAssignDlg* pMacroDlg = new SfxMacroAssignDlg(
				GetpApp()->GetDefDialogParent(), aSet );
			SfxMacroTabPage* pMacroTabPage = (SfxMacroTabPage*)pMacroDlg->GetTabPage();
			DBG_ASSERT(pMacroTabPage,"MacroTabPage not found");
			AddEvents( pObj->Type(), TRUE, pMacroTabPage );
			if ( pMacroDlg->Execute() == RET_OK )
			{
				const SfxItemSet* pOutSet = pMacroDlg->GetOutputItemSet();
				pFound->GetItemSet()->Put(
					pOutSet->Get(SID_ATTR_MACROITEM), VCATTR_MACROS);
				// Handler fuer alte Office-Versionen setzen
				VCControl::SetOldHandlers(
					pFound->GetItemSet(),
					pFound->Type(), TRUE );
				((VCDrawModel*)pFound->GetModel())->VCDrawModelChanged( TRUE );
			}
			delete pMacroDlg;


		}

		}
		break;

		default: ItemSetBrowser::DotButtonClick( pEntry );
	}
}

void VCItemBrowser::AddEvents( const TypeId& rType, BOOL bReal, SfxMacroTabPage* pPage )
{
	// PushButton, RadioButton, CheckBox

	static const USHORT pPushButtonReal[] =	{
		VCHDL_ONCLICK,		STR_ATTR_CLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		0xffff, 0xffff };

	static const USHORT pSpinButtonReal[] =	{
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONSPINUP,		STR_ATTR_SPINUP,
		VCHDL_ONSPINDOWN,	STR_ATTR_SPINDOWN,
		0xffff, 0xffff };

	// FixedText, GroupBox
	static const USHORT pFixedTextReal[] =	{
		VCHDL_ONCLICK,		STR_ATTR_CLICK,
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONMOUSEDOWN,	STR_ATTR_MOUSEDOWN,
		VCHDL_ONMOUSEMOVE,	STR_ATTR_MOUSEMOVE,
		VCHDL_ONMOUSEUP,	STR_ATTR_MOUSEUP,
		0xffff, 0xffff };

	static const USHORT pListBoxReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONSELECT,		STR_ATTR_ONSELECT,
		0xffff, 0xffff };

	static const USHORT pComboBoxReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONCHANGE,		STR_ATTR_CHANGED,
		VCHDL_ONSELECT,		STR_ATTR_ONSELECT,
		0xffff, 0xffff };

	static const USHORT pEditReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONCHANGE,		STR_ATTR_CHANGED,
		0xffff, 0xffff };

	static const USHORT pGroupBoxReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONCLICK,		STR_ATTR_CLICK,
		VCHDL_ONMOUSEDOWN,	STR_ATTR_MOUSEDOWN,
		VCHDL_ONMOUSEMOVE,	STR_ATTR_MOUSEMOVE,
		VCHDL_ONMOUSEUP,	STR_ATTR_MOUSEUP,
		0xffff, 0xffff };

	static const USHORT pScrollBarReal[] =	{
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONCHANGE,		STR_ATTR_CHANGED,
		VCHDL_ONSCROLL,		STR_ATTR_SCROLL,
		0xffff, 0xffff };

	static const USHORT pPreviewReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONCLICK,		STR_ATTR_CLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONMOUSEDOWN,	STR_ATTR_MOUSEDOWN,
		VCHDL_ONMOUSEMOVE,	STR_ATTR_MOUSEMOVE,
		VCHDL_ONMOUSEUP,	STR_ATTR_MOUSEUP,
		VCHDL_ONPAINT,		STR_ATTR_PAINT,
		VCHDL_ONRESIZE,		STR_ATTR_RESIZE,
		0xffff, 0xffff };

	static const USHORT pDialogReal[] =	{
		VCHDL_ONDBLCLICK,	STR_ATTR_DBLCLICK,
		VCHDL_ONCLICK,		STR_ATTR_CLICK,
		VCHDL_ONGETFOCUS,	STR_ATTR_GOTFOCUS,
		VCHDL_ONLOSEFOCUS,	STR_ATTR_LOSTFOCUS,
		VCHDL_ONKEYINPUT,	STR_ATTR_KEYPRESS,
		VCHDL_ONKEYDOWN,	STR_ATTR_KEYDOWN,
		VCHDL_ONKEYUP,		STR_ATTR_KEYUP,
		VCHDL_ONMOUSEDOWN,	STR_ATTR_MOUSEDOWN,
		VCHDL_ONMOUSEMOVE,	STR_ATTR_MOUSEMOVE,
		VCHDL_ONMOUSEUP,	STR_ATTR_MOUSEUP,
		VCHDL_ONACTIVATE,	STR_ATTR_ACTIVATE,
		VCHDL_ONDEACTIVATE,	STR_ATTR_DEACTIVATE,
		VCHDL_ONRESIZE,		STR_ATTR_RESIZE,
		VCHDL_ONLOAD,		STR_ATTR_LOAD,
		VCHDL_ONUNLOAD,		STR_ATTR_UNLOAD,
		0xffff, 0xffff };


	const USHORT* pHandlerList = 0;
	if( rType== TYPE(VCPushButton) || rType== TYPE(VCRadioButton) ||
		rType== TYPE(VCCheckBox))
	{
		pHandlerList = &pPushButtonReal[0];
	}
	else if( rType== TYPE(VCSpinButton))
	{
		pHandlerList = &pSpinButtonReal[0];
	}
	else if( rType== TYPE(VCFixedText))
	{
		pHandlerList = &pSpinButtonReal[0];
	}
	else if( rType== TYPE(VCGroupBox))
	{
		pHandlerList = &pGroupBoxReal[0];
	}
	else if( rType== TYPE(VCListBox))
	{
		pHandlerList = &pListBoxReal[0];
	}
	else if( rType== TYPE(VCComboBox))
	{
		pHandlerList = &pComboBoxReal[0];
	}
	else if( rType== TYPE(VCEdit))
	{
		pHandlerList = &pEditReal[0];
	}
	else if( rType== TYPE(VCScrollBar) || rType== TYPE(VCHScrollBar) ||
			 rType== TYPE(VCVScrollBar) )
	{
		pHandlerList = &pScrollBarReal[0];
	}
	else if( rType== TYPE(VCPreview) )
	{
		pHandlerList = &pPreviewReal[0];
	}
	else if( rType== TYPE(VCSbxDialogObject))
	{
		pHandlerList = &pDialogReal[0];
	}

	if( pHandlerList )
	{
		USHORT* pCur = (USHORT*)pHandlerList;
		while( *pCur != 0xffff )
		{
			USHORT nHandlerId = *pCur;
			pCur++;
			USHORT nResId = *pCur;
			pCur++;
			pPage->AddEvent( String( SiResId(nResId)), nHandlerId );
		}

	}
}

BOOL VCItemBrowser::NotifyChangingItem( USHORT nWhich, const SfxPoolItem* )
{
	nChangingWhich = nWhich;
	aNotifyChangingItemLink.Call( this );
	nChangingWhich = 0;
	return TRUE;
}

VCItemBrowser::VCItemBrowser( Window* pParent, VCBrowser* pOwn, WinBits nWinStyle ) :
	ItemSetBrowser( pParent, nWinStyle ),
	nChangingWhich(0),
	pOwner(pOwn)
{
	SetText( String( SiResId( STR_VCBRW_TITLE ) ) );
}

VCItemBrowser::VCItemBrowser( Window* pParent, VCBrowser* pOwn, const ResId& rResId ) :
	ItemSetBrowser( pParent, rResId ),
	pOwner(pOwn)
{
}

Link VCItemBrowser::ChangeNotifyChangingItemHdl( const Link& rLink )
{
	Link aOldLink = aNotifyChangingItemLink;
	aNotifyChangingItemLink = rLink;
	return aOldLink;
}

void VCBrowser::GetFocus()
{
	pBrowser->GrabFocus();
}

void VCBrowser::Paint( const Rectangle& rRect )
{
#ifndef VCL
	if( IsSVLook() )
	{
		// Rahmen um ListBox und TabBar zeichnen
		Point aPos = pBrowser->GetPosPixel();
		Point aPos2( aPos );
		const Size& rSize = pBrowser->GetOutputSizePixel();
		aPos2.X() += rSize.Width();
		aPos2.Y() += rSize.Height();

		aPos.X()--;  aPos.Y()--;
		Rectangle aRect ( aPos, aPos2 );

		Color aLight( COL_3DLIGHT );
		Color aShadow( COL_3DSHADOW );
		Pen aPen( aShadow );
		Pen aOldPen = GetPen( );
		SetPen( aPen );

		DrawLine( aRect.TopLeft(), aRect.BottomLeft() );
		DrawLine( aRect.TopLeft(), aRect.TopRight() );

		aPen.SetColor( aLight );
		SetPen( aPen );
		DrawLine( aRect.BottomRight(), aRect.TopRight() );
		DrawLine( aRect.BottomRight(), aRect.BottomLeft() );

		SetPen( aOldPen );
	}
#endif
	if( bUpdate )
	{
		if( pBrowser->GetItemSetCount() )
		{
			pBrowser->Update( VCATTR_LEFT );
			pBrowser->Update( VCATTR_TOP );
			pBrowser->Update( VCATTR_WIDTH );
			pBrowser->Update( VCATTR_HEIGHT );
		}
		else
			Update( pView );

		bUpdate = FALSE;
	}
}

void VCBrowser::Resize()
{
	long nTabHeight = 0;

	Size aSize = GetOutputSizePixel();
	aSize.Width() -= 8;
	aSize.Height()-= nTabHeight + 8;
	pBrowser->SetSizePixel( aSize );

	Point aPos2  = pBrowser->GetPosPixel();
	aPos2.Y()   += aSize.Height();
	Size  aSize2 = aSize;
	aSize2.Height() = nTabHeight;

	pBrowser->SetValueTab( 120 );
	Invalidate();
}

IMPL_LINK_INLINE_START( VCBrowser, ImpModify, VCItemBrowser *, pBrowser )
{
	Modify();
	return 0;
}
IMPL_LINK_INLINE_END( VCBrowser, ImpModify, VCItemBrowser *, pBrowser )

IMPL_LINK( VCBrowser, ImpModifyChanging, VCItemBrowser *, pBrowser )
{
	if( !pView )
		return 0;

	if( pView->GetMarkList().GetMarkCount() )
	{
		// Undo-Klammerung starten
		SdrModel* pModel = pView->GetModel();
		pModel->BegUndo();

		ULONG i;
		ULONG nMark = pView->GetMarkList().GetMarkCount();
		for( i=0; i < nMark; i++ )
		{
			USHORT nWhich = pBrowser->GetChangingWhich();

			SdrObject* pObj = pView->GetMarkList().GetMark(i)->GetObj();
			if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
			{
				SfxItemSet* pItemSet = ((VCSbxDrawObject*)pObj)->GetItemSet();
				if( nWhich )
				{
					const SfxPoolItem& rItem = pItemSet->Get( nWhich );
					VCUndoItem* pUndo = new VCUndoItem( pObj, rItem );
					pModel->AddUndo( pUndo );
				}
			}
			if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
			{
				SfxItemSet* pItemSet = ((VCSbxDrawObject*)pObj)->GetItemSet();
				if( nWhich )
				{
					const SfxPoolItem& rItem = pItemSet->Get( nWhich );
					VCUndoItem* pUndo = new VCUndoItem( pObj, rItem );
					pModel->AddUndo( pUndo );
				}
			}
		}
		// Undo Klammerung beenden
		pModel->EndUndo();
	}
	return 0;
}

void VCBrowser::Modify()
{
	if( !pView )
		return;

	USHORT nWhich = GetModifyId();
	ULONG nMarkCount = pView->GetMarkList().GetMarkCount();
	if( nMarkCount )
	{
		ULONG i;
		ULONG nMark = pView->GetMarkList().GetMarkCount();
		for( i=0; i < nMark; i++ )
		{
			SdrObject* pObj = pView->GetMarkList().GetMark(i)->GetObj();
			if( i == 0 )
				((VCDrawModel*)pObj->GetModel())->VCDrawModelChanged( TRUE );
			if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
				((VCSbxDrawObject*)pObj)->UpdateItem( nWhich );
			if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
				((VCSbxDialogObject*)pObj)->UpdateItem( nWhich );
		}
		// Title updaten
		if( nMarkCount == 1 )
		{
			if( nWhich == VCATTR_NAME )
			{
				SdrObject* pObj = pView->GetMarkList().GetMark(0)->GetObj();
				if( pObj->IsA( TYPE(VCSbxDialogObject)))
				{
					((VCSbxDialogObject*)pObj)->UpdateItem( nWhich );
					VCSbxDialog* pDlg = ((VCSbxDialogObject*)pObj)->GetForm();
					SbxItem aSbxItem( SID_BASICIDE_ARG_SBX, pDlg );
					//HACK, da SlotIds nicht exportiert!
					SfxViewFrame* pCurFrame = SfxViewFrame::Current();
					DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
					SfxDispatcher* pDispatcher = pCurFrame ? pCurFrame->GetDispatcher() : NULL;
					if( pDispatcher )
					{
						pDispatcher->Execute( SID_BASICIDE_START + 26,
							SFX_CALLMODE_SYNCHRON, &aSbxItem, 0L );
					}
				}
			}
			SetText( CreateTitle() );
		}
	}

	pView->AdjustMarkHdl();
	bUpdate = FALSE;
}

String VCBrowser::CreateTitle()
{
	String aTitle( SiResId( STR_VCBRW_TITLE ) );
	if( pView )
	{
		const SdrMarkList& rMarkList = pView->GetMarkList();
		if( rMarkList.GetMarkCount() == 1 )
		{
			aTitle += ' ';
			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
			if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
			{
				aTitle += ((VCSbxDrawObject*)pObj)->GetControl()->GetName();
				aTitle.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " (" ));
				aTitle += ((VCSbxDrawObject*)pObj)->GetControl()->GetClassName();
				aTitle += ')';
			}
			if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
			{
				aTitle += ((VCSbxDialogObject*)pObj)->GetForm()->GetName();
				aTitle.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " (" ));
				aTitle += String( SiResId(STR_CLASS_DIALOG) );
				aTitle += ')';
			}
		}
	}
	return aTitle;
}

void VCBrowser::AddItemSet( SfxItemSet* pItemSet )
{
	pBrowser->AddItemSet( pItemSet );
}

void VCBrowser::RemoveItemSet( SfxItemSet* pItemSet )
{
	pBrowser->RemoveItemSet( pItemSet );
}

void VCBrowser::RemoveAllItemSets()
{
	pBrowser->RemoveAllItemSets();
}

ULONG VCBrowser::GetItemSetCount() const
{
	return pBrowser->GetItemSetCount();
}

SfxItemSet* VCBrowser::GetItemSet( ULONG nPos ) const
{
	return pBrowser->GetItemSet( nPos );
}

USHORT VCBrowser::GetModifyId() const
{
	 return pBrowser->GetModifyId();
}

void VCBrowser:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
						const SfxHint& rHint, const TypeId& rHintType )
{
	if( rHint.IsA(TYPE(SdrHint)))
	{
		SdrHint& rSdrHint = (SdrHint&)rHint;
		if( (rSdrHint.eHint == HINT_OBJCHG) &&
			(rSdrHint.pObj->IsA( TYPE( VCSbxDrawObject ) ) ||
			 rSdrHint.pObj->IsA( TYPE( VCSbxDialogObject ) )  ) )
		{
			if( !pBrowser || !pBrowser->GetModifyId() )
			{
				bUpdate = TRUE;		// ItemSets aktualisieren
				Invalidate( Rectangle( Point(), Size(1, 1 ) ) );
			}
		}
		else
		if( ((rSdrHint.eHint == HINT_OBJINSERTED) ||
			 (rSdrHint.eHint == HINT_OBJREMOVED)    )  &&
			(rSdrHint.pObj->IsA( TYPE( VCSbxDrawObject ) ) ||
			 rSdrHint.pObj->IsA( TYPE( VCSbxDialogObject ) )  ) )
		{
			RemoveAllItemSets();
			bUpdate =TRUE;
			Invalidate( Rectangle( Point(), Size( 1, 1 ) ) );
		}
	}
}

IMPL_LINK( VCBrowser, TabBarSelect, TabBar *, EMPTYARG )
{
	nActPage = pTabBar->GetCurPageId();

	if( nActPage == TABPAGE_EVENTS )
		pBrowser->SetWhichRange( Range( VCATTR_EVENTSTART, VCATTR_EVENTEND ) );
	else
		pBrowser->SetWhichRange( Range( VCATTR_STARTPROP, VCATTR_ENDPROP ) );
	return 0;
}

VCBrowser::VCBrowser( SfxBindings* pBind, SfxChildWindow* pChild,Window* pParent ) :
	SfxFloatingWindow( pBind, pChild, pParent, WB_STDFLOATWIN | WB_3DLOOK | WB_SIZEABLE ),
	pView( NULL ),
	bUpdate( FALSE ),
	nActPage( TABPAGE_PROPERTIES )
{
	pTabBar = 0;
	SetHelpId( HID_BASICIDE_PROP_BROWSER );
#ifndef VCL
#ifdef MAC
	pBrowser = new VCItemBrowser( this, this, WB_HASBUTTONS | WB_SORT);
#else
	pBrowser = new VCItemBrowser( this, this, WB_3DLOOK | WB_HASBUTTONS | WB_SORT );
#endif
#else
	pBrowser = new VCItemBrowser( this, this, WB_3DLOOK | WB_HASBUTTONS | WB_SORT | WB_BORDER );
#endif
	pBrowser->SetNodeBitmaps( Bitmap( SiResId( BMP_VCBRW_PLUS ) ),
							  Bitmap( SiResId( BMP_VCBRW_MINUS ) ) );
	pBrowser->SetModifyHdl( LINK( this, VCBrowser, ImpModify ) );
	pBrowser->ChangeNotifyChangingItemHdl( LINK( this, VCBrowser, ImpModifyChanging ) );
	pBrowser->SetWhichRange( Range( VCATTR_STARTPROP, VCATTR_EVENTEND ) );
	pBrowser->SetHelpId( HID_BASICIDE_PROP_BROWSER_LBOX );

#ifndef MAC	// Chicago ist schon fett genug ...
	Font aFont = pBrowser->GetFont();
	aFont.SetWeight( WEIGHT_BOLD );
	pBrowser->SetFont( aFont );
#endif

	pBrowser->SetPosPixel( Point( 4, 4 ) );
	pBrowser->Show();

	SetPosSizePixel( Point( 20, 20 ), Size( 250, 400 ) );

	StartListening( *this );
}

VCBrowser::~VCBrowser()
{
	EndListening( *this );
	delete pTabBar;
	delete pBrowser;
}

void VCBrowser::SetValueTab( long nTab )
{
	pBrowser->SetValueTab( nTab );
}

void VCBrowser::Update( SdrView* pNewView )
{
	if( pView )
	{
		EndListening( *(pView->GetModel()) );
		pView = NULL;
	}

	RemoveAllItemSets();

	if( !pNewView )
		return;
	else
		pView = pNewView;

	const SdrMarkList& rMarkList = pView->GetMarkList();
	if( rMarkList.GetMarkCount() )
	{
		ULONG i;
		ULONG nMark = rMarkList.GetMarkCount();
		for( i=0; i < nMark; i++ )
		{
			SdrObject* pObj = rMarkList.GetMark(i)->GetObj();
			if( pObj->IsA( TYPE( VCSbxDrawObject ) ) ||
				pObj->IsA( TYPE( VCSbxDialogObject ) ) )
				AddItemSet( ((VCSbxDrawObject*)pObj)->GetItemSet() );
		}
	}
	else
	{
		EndListening( *(pView->GetModel()) );
		pView = NULL;
		SetText( CreateTitle() );
		return;
	}
	SetText( CreateTitle() );
	StartListening( *(pView->GetModel()) );
}

String VCItemBrowser::GetItemDropDownData( USHORT nWhich )
{
	String aStr;
	if( nWhich == VCATTR_TARGETFRAME )
	{
		SfxViewFrame* pViewFrame = SfxViewFrame::Current();
		DBG_ASSERT(pViewFrame,"ViewFrame?");
		SfxFrame* pTop = pViewFrame->GetTopFrame();
		TargetList aTargetList;
		pTop->GetTargetList( aTargetList );
		ULONG nCount = aTargetList.Count();
		ULONG nCur;
		for( nCur = 0; nCur < nCount; nCur++ )
		{
			if( aStr.Len() )
				aStr += '\n';
			aStr += *aTargetList.GetObject(nCur);
		}
		for( nCur = 0; nCur < nCount; nCur++ )
			delete aTargetList.GetObject(nCur);
	}
	return aStr;
}

SFX_IMPL_FLOATINGWINDOW(VCBrowserWrapper, SID_SHOW_BROWSER)


VCBrowserWrapper::VCBrowserWrapper(Window *pParent,
	USHORT nId, SfxBindings *pBindings, SfxChildWinInfo* pInfo) :
	SfxChildWindow(pParent, nId)
{
	pWindow = new SvxVCBrowser( pBindings, this, pParent );
	eChildAlignment = SFX_ALIGN_NOALIGNMENT;
	((SfxFloatingWindow*)pWindow)->Initialize( pInfo );

	// den Browser auf die aktuelle Selektion setzen
	SfxViewShell* pShell = SfxViewShell::Current();
	if( pShell )
	{
		if( pShell->IsA( TYPE( BasicIDEShell )) )
			((SvxVCBrowser*)pWindow)->Update( ((BasicIDEShell*)pShell)->GetCurDlgView() );
		else
		{
			SdrView* pDrawView = pShell->GetDrawView();
			if( pDrawView )
				((SvxVCBrowser*)pWindow)->Update( pDrawView );
		}
	}
}

//static
void VCBrowser::UpdateItem( USHORT nWhich )
{
	SfxViewFrame* pCurFrame = SfxViewFrame::Current();
	//DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
	SfxChildWindow* pChildWin = pCurFrame ? pCurFrame->GetChildWindow(SID_SHOW_BROWSER) : NULL;
	if( pChildWin )
	{
		VCBrowser* pBrw = (VCBrowser*)pChildWin->GetWindow();
		pBrw->pBrowser->ItemSetBrowser::Update( nWhich );
	}
}


