/*************************************************************************
 *
 *  $RCSfile: vcbrw1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif

#pragma hdrstop

#include "vcbrw.hxx"
#include <svx/svxids.hrc>
#include <sfx2/viewfrm.hxx>

BOOL SvxVCBrowser::Close()
{
	SfxBoolItem aItem( SID_SHOW_BROWSER );
	SfxViewFrame* pCurFrame = SfxViewFrame::Current();
	DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
	SfxDispatcher* pDispatcher = pCurFrame ? pCurFrame->GetDispatcher() : NULL;
	if( pDispatcher )
	{
		pDispatcher->Execute( SID_SHOW_BROWSER,
							  SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
							  &aItem, 0L );
	}
	return TRUE;
}

SvxVCBrowser::SvxVCBrowser( SfxBindings* pBind, SfxChildWindow* pChild,Window *pParent ) :
	VCBrowser( pBind, pChild, pParent )
{
}

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcbrw1.cxx,v 1.1.1.1 2000/09/29 11:02:39 mh Exp $

	  Source Code Control System - Update

	  $Log: vcbrw1.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:39  mh
	  initial import
	
	  Revision 1.2  2000/09/26 15:02:44  ab
	  SFX_DISPATCHER() removed
	
	  Revision 1.1.1.1  2000/09/18 16:11:44  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:48  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.16  1997/11/21 16:01:40  OV
	  Headerumstellung
	

	  Rev 1.15   21 Nov 1997 17:01:40   OV
   Headerumstellung

	  Rev 1.14   31 Oct 1996 22:15:46   MH
   chg: includes, defines

	  Rev 1.13   26 Jun 1996 16:49:02   PB
   * 324-Aenderungen

	  Rev 1.12   26 Jun 1996 16:07:26   PB
   * 324-Aenderungen

	  Rev 1.11   05 Jun 1996 13:25:08   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.10   30 Apr 1996 11:42:18   OV
   DOFILT_HXX undeffen

	  Rev 1.9   22 Mar 1996 00:06:50   HJS
   umstellung 311

	  Rev 1.8   05 Mar 1996 22:47:26   MH
   CLOOKS

	  Rev 1.7   31 Jan 1996 22:40:24   MH
   CLOOKS

*************************************************************************/

#pragma SEG_EOFMODULE

