/*************************************************************************
 *
 *  $RCSfile: vcdrawm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define protected public

#ifndef _SYSDEP_HXX
#include <sysdep.hxx>
#endif

#ifndef _SV_HXX
#include <sv.hxx>
#endif

#ifndef _VCTRLS_HXX
#include <vctrls.hxx>
#endif

#include <vcattrid.hrc>

#ifndef _VCATTR_HXX
#include <vcattr.hxx>
#endif

#ifndef _VCONT_HXX
#include <vcont.hxx>
#endif

#ifndef _VCTRLS_HXX
#include <vctrls.hxx>
#endif

#ifndef _VCICTRLS_HXX
#include <vcictrls.hxx>
#endif

#ifndef _MACVCTRLS_HXX
#include <MacVCtrls.hxx>
#endif


/*************************************************************************
|*
|*    PaintMacControl
|*
|*    Beschreibung		Hilfsfunktion fuer FixedText,Edit und Combobox
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void lcl_PaintMacControl(Window*			pSVControl,
							OutputDevice*	pOut,
							VCControl*		pShell)
{
	if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;

	Window* pOutWin = (Window*)pOut;

	Point aPos        = pShell->GetPos();
	Size  aSize 	  = pShell->GetSize();

	aPos += pShell->GetDrawOfs();

	aPos  = pOut->LogicToPixel( aPos, MapMode( MAP_TWIP ) );
	aSize = pOut->LogicToPixel( aSize, MapMode( MAP_TWIP ) );

	Rectangle aOutRect(aPos,aSize);

	Window* pOldParent = pSVControl->SetParent( pOutWin );
	pSVControl->SetPosSizePixel( aPos, aSize );

	pSVControl->Show();
	pSVControl->Paint(aOutRect);
	SVE_PaintChildBorder(pSVControl);

	Rect aRect;
	aRect.left  	= (short) aOutRect.Left();
	aRect.top   	= (short) aOutRect.Top();
	aRect.right 	= (short) aOutRect.Right() + 1;	// Flackert sonst ?
	aRect.bottom 	= (short) aOutRect.Bottom() + 1;

	pSVControl->SetParent( pOldParent );
	pSVControl->Hide();

	SetPort(Sysdepen::GetWindowPtr(*((Window*)pOut)));
	// ClipRect(&aRect);
	ValidRect(&aRect);
}

/*************************************************************************
|*
|*    VCImpRealFixedText::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealFixedText::Paint( OutputDevice* pOut )
{
	lcl_PaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealEdit::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealEdit::Paint( OutputDevice* pOut )
{
	lcl_PaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealComboBox::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 16.05.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealComboBox::Paint( OutputDevice* pOut )
{
	// Ist zwar kein Edit, funktioniert aber trotzdem
	lcl_PaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealSpinButton::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 25.07.95
|*    Letzte Aenderung  KH 25.07.95
|*
*************************************************************************/
void VCImpRealSpinButton::Paint( OutputDevice* pOut )
{
	lcl_PaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealListBox::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    CL 19.06.95
|*    Letzte Aenderung  CL 19.06.95
|*
*************************************************************************/
void VCImpRealListBox::Paint( OutputDevice* pOut )
{
	lcl_PaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    MacDrawTransparentGroupBox
|*
|*    Beschreibung		Analog zu Mac:Source:Control:Group.cxx
|*								  SV_Paint( GroupBox *pMe )
|*
|*    Ersterstellung    KH 21.04.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/

void MacDrawTransparentGroupBox(OutputDevice*		pOut,
								const String& 		rTitle,
								const Rectangle&	rOutRect,
								const Font&			rFont,
									  MapUnit		nOutUnit)
{
	Font aNewFont(rFont);
	aNewFont.SetAlign(ALIGN_TOP);
	Font 	anOldFont 	= pOut->SetFont( aNewFont );

	Size aTextSize = ((Window*) pOut) -> GetCtrlTextSize(rTitle);

	long HalfTextHight = aTextSize.Height() >> 1;

	Rectangle aRectFrame(rOutRect);

	Point aTextPoint = aRectFrame.TopLeft();
	aRectFrame.Top() 	+= HalfTextHight;
	aRectFrame.Bottom() -= HalfTextHight;

	// Pen immer Breite wie ein Pixel ....
	Size a1Size = pOut->LogicToLogic( Size(1,0), MAP_POINT,
			MapMode( pOut->GetMapMode().GetMapUnit() ) );

	Pen aPen(PEN_SOLID);
	aPen.SetWidth(a1Size.Width());

	// Rahmen Zeichnen

	Pen anOldPen 	 = pOut->SetPen( aPen );
	Brush anOldBrush = pOut->SetFillInBrush( BRUSH_NULL );

	if ( !rTitle.Len() )
		pOut->DrawRect( aRectFrame );
	else
	{
		Point aPoint8 = pOut->LogicToLogic(Point( 8, 0 ),MAP_POINT, nOutUnit);

		// Platz fuer den Text lassen
		Point aHelpPoint(aRectFrame.TopLeft() + aPoint8);

		pOut->DrawLine(aRectFrame.TopLeft(),	aHelpPoint);
		pOut->DrawLine(aHelpPoint
			+ aPoint8 + Point(aTextSize.Width(),0), aRectFrame.TopRight());
		// "Badewanne" malen
		pOut->DrawLine(aRectFrame.TopLeft(),	aRectFrame.BottomLeft());
		pOut->DrawLine(aRectFrame.BottomLeft(),	aRectFrame.BottomRight());
		pOut->DrawLine(aRectFrame.BottomRight(),aRectFrame.TopRight());

		String  aStrTitel(rTitle);
		aStrTitel.Insert( ' ', 0 );
		aStrTitel += ' ';

		// Und zum Schluss den Text ausgeben
		pOut->DrawText( aTextPoint + aPoint8, aStrTitel );
	}
	pOut->SetFont( anOldFont );
	pOut->SetPen( anOldPen );
	pOut->SetFillInBrush( anOldBrush );

}



/*************************************************************************
|*
|*    ImpGetButtonBmpSizePixel()
|*
|*    Beschreibung
|*    Ersterstellung    CL 27.10.94
|*    Letzte Aenderung  CL 10.02.95
|*
*************************************************************************/
Size ImpGetButtonBmpSizePixel()
{
	return Size();
}
