/*************************************************************************
 *
 *  $RCSfile: vcdrwobj.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif
#ifndef _SFXVIEW_HXX
#include <sfx2/childwin.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SVDIO_HXX
#include <svx/svdio.hxx>
#endif

//#ifndef _COLOR_HXX
#include <vcl/color.hxx>
//#endif

#pragma hdrstop

#include <svx/xflclit.hxx>
#include <svx/xlnclit.hxx>
#include "xtable.hxx"
#include "xlineit0.hxx"

#include <svx/svdobj.hxx>
#define SI_VCDRAWOBJ
#define SI_VCDLGOBJ
#define SI_VCDRAWPAGE
#define SI_VCDRAWMODEL
#define SI_VCDRAWVIEW
#include <svx/svxids.hrc>
#include "vced.hxx"
#include "vcedit.hxx"
#include "vcscrbar.hxx"
#include "vcchkbox.hxx"
#include "vcurlbtn.hxx"
#include "vcpbttn.hxx"
#include "vcrdbttn.hxx"
#include "vcspnbtn.hxx"
#include "vclbox.hxx"
#include "vcprvw.hxx"
#include "vcspnbtn.hxx"
#include "vcfxtxt.hxx"
#include "vcchkbox.hxx"
#include "vcgrpbox.hxx"
#include "vccbbox.hxx"
#include <svx/xoutx.hxx>
//#include "svdrwetc.hxx"
#include "sidll.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vcont.hxx"
#include "vctrls.hxx"
#include "vcsbx.hxx"
#include "vcsbxdo.hxx"
#include "vcdrwobj.hxx"
#include "vcdrview.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcbrw.hxx"
#include "vcictrls.hxx"
#define _SI_NOVCSPINBTENG
#define _SI_NOVCSCRBARENG
#define _SI_NOVCLBOXENG
#define _SI_NOVCDDWIN
#define _SI_NOVCCOMBOENGBASE
#define _SI_NOVCCOMBOENG
#include "vcengin.hxx"
#define _SI_NOEDITENGINES
#include "vceeng.hxx"
#include "vcform.hxx"

#ifndef _SVDORECT_HXX
#include <svx/svdorect.hxx>
#endif


class SiImportRect : public SdrRectObj
{
public:
	SiImportRect();
	virtual void ReadData(const SdrObjIOHeader& rHead, SvStream& rIn);
};

SiImportRect::SiImportRect() : SdrRectObj()
{
}

void SiImportRect::ReadData(const SdrObjIOHeader& rHead, SvStream& rIn)
{
	// SdrRectObj ueberspringen!!!!
	SdrObject::ReadData( rHead, rIn );
	SdrDownCompat aCompat( rIn, STREAM_READ );
	aRect = aOutRect;
	SfxItemSet aSet(pModel->GetItemPool());
	aSet.Put(XFillStyleItem(XFILL_SOLID));
	aSet.Put(XFillColorItem(String(), RGB_Color(COL_LIGHTRED)));
	aSet.Put(XLineStyleItem(XLINE_SOLID));
	aSet.Put(XLineColorItem(String(), RGB_Color(COL_BLACK)));
	NbcSetAttributes(aSet, FALSE);
	SetXPolyDirty();
}



class VCSbxDrawObject_Impl
{
public:
	VCSbxControlRef pControl;
};

#define VCMODEL_DELETE_POOL	0x0001

class VCLinkHdl
{
protected:
	VCDrawPage* pPage;
public:
	VCLinkHdl( VCDrawPage* p )	{ pPage = p; }

	DECL_LINK( ImpGetLinkData, VCContainer* );
	DECL_LINK( ImpSetLinkData, VCContainer* );
};

IMPL_LINK_INLINE( VCLinkHdl, ImpGetLinkData, VCContainer*, pContainer,
{
	pPage->ImpGetLinkData( pContainer );
	return 0;
}
)

IMPL_LINK_INLINE( VCLinkHdl, ImpSetLinkData, VCContainer*, pContainer,
{
	pPage->ImpSetLinkData( pContainer );
	return 0;
}
)

IMPL_LINK( VCDrwFactory, MakeObject, SdrObjFactory *, pObjFactory )
{
	if( pObjFactory->nInventor == VCSbxInventor )
	{
		if( ((pObjFactory->nIdentifier >= OBJ_CHECKBOX) &&
			(pObjFactory->nIdentifier <= OBJ_VSCROLLBAR))  ||
			pObjFactory->nIdentifier == OBJ_URLBUTTON )
		{
#if SUPD <= 395
			// Ein Control-DrawObject
			VCSbxControl*	pControl = NULL;
			VCDrawPage* 	pDrawPage= (VCDrawPage*)pObjFactory->pPage;
			VCSbxForm*		pSbxForm = NULL;
			if( pDrawPage )
				pSbxForm = (VCSbxForm*)(SbxObject*)pDrawPage->GetSbxForm();

			switch( pObjFactory->nIdentifier )
			{
				case OBJ_CHECKBOX:	   pControl = new VCSbxCheckBox();break;
				case OBJ_RADIOBUTTON:  pControl = new VCSbxRadioButton();break;
				case OBJ_PUSHBUTTON:   pControl = new VCSbxPushButton();break;
				case OBJ_SPINBUTTON:   pControl = new VCSbxSpinButton();break;
				case OBJ_FIXEDTEXT:    pControl = new VCSbxFixedText(); break;
				case OBJ_GROUPBOX:	   pControl = new VCSbxGroupBox(); break;
				case OBJ_LISTBOX:	   pControl = new VCSbxListBox(); break;
				case OBJ_COMBOBOX:	   pControl = new VCSbxComboBox(); break;
				case OBJ_EDIT:		   pControl = new VCSbxEdit(); break;
				case OBJ_HSCROLLBAR:   pControl = new VCSbxHScrollBar();break;
				case OBJ_VSCROLLBAR:   pControl = new VCSbxVScrollBar();break;
				case OBJ_URLBUTTON:    pControl = new VCSbxURLButton();break;
			}

			if( pControl )
			{
				pObjFactory->pNewObj = new VCSbxDrawObject( pControl );
				return 0;
			}
#else
			switch( pObjFactory->nIdentifier )
			{
				case OBJ_CHECKBOX:
				case OBJ_RADIOBUTTON:
				case OBJ_PUSHBUTTON:
				case OBJ_SPINBUTTON:
				case OBJ_FIXEDTEXT:
				case OBJ_GROUPBOX:
				case OBJ_LISTBOX:
				case OBJ_COMBOBOX:
				case OBJ_EDIT:
				case OBJ_HSCROLLBAR:
				case OBJ_VSCROLLBAR:
				case OBJ_URLBUTTON:
					pObjFactory->pNewObj = new SiImportRect;
			}
#endif
		}
	}
	return 0;
}

DBG_NAME(VCUndoItem);

VCUndoItem::VCUndoItem( SdrObject* pObj, const SfxPoolItem& rItem ) :
		SdrUndoObj( *pObj )
{
	DBG_CTOR(VCUndoItem,0);
	pItem = rItem.Clone();
}

VCUndoItem::~VCUndoItem()
{
	DBG_DTOR(VCUndoItem,0);
	delete pItem;
}

void VCUndoItem::Undo()
{
	DBG_CHKTHIS(VCUndoItem,0);
	SfxItemSet* pItemSet = ((VCSbxDrawObject*)pObj)->GetItemSet();
	pItemSet->Put( *pItem );
	if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
		((VCSbxDrawObject*)pObj)->UpdateItem( pItem->Which() );
	else
	if( pObj->IsA( TYPE( VCSbxDialogObject ) ) )
		((VCSbxDialogObject*)pObj)->UpdateItem( pItem->Which() );
}

void VCUndoItem::Redo()
{
	DBG_CHKTHIS(VCUndoItem,0);
}

TYPEINIT1( VCDrawPage, SdrPage );

void VCDrawPage::ImpGetLinkData( VCContainer* pContainer )
{
	String aData = GetLinkData( pContainer->GetCurrentLinkName() );
	pContainer->SetCurrentLinkData( aData );
}

void VCDrawPage::ImpSetLinkData( VCContainer* pContainer )
{
	SetLinkData( pContainer->GetCurrentLinkName(),
				 pContainer->GetCurrentLinkData() );
}

VCDrawPage::VCDrawPage( VCDrawModel& rModel, StarBASIC* pBas, FASTBOOL bMasterPage ) :
	SdrPage( rModel, bMasterPage ),
	pBasic(pBas),
	pVCManager(NULL),
	bDeleteSbxObject(TRUE),
	pLinkHdl(new VCLinkHdl(this) )
{
	if( pBasic )
		pBasic->AddRef();
	pPool = rModel.pVCItemPool; // GetVCItemPool() wuerde ggf. einen erzeugen
}

VCDrawPage::~VCDrawPage()
{
	if( pBasic && pSbxForm && pSbxForm->Type() == TYPE( VCSbxForm ) )
		pBasic->Remove( pSbxForm );

	Clear();

	if( pVCManager )
		delete pVCManager;

	if( pBasic )
		pBasic->ReleaseRef();

	delete pLinkHdl;
}

void VCDrawPage::SetName( const String& rName )
{
	aPageName = rName;
	if( pSbxForm )
		pSbxForm->SetName( aPageName );
}

void VCDrawPage::SetBasic( StarBASIC* pBas )
{
	if( pBas == pBasic )
		return;

	StarBASIC* pOldBasic = pBasic;
	pBasic = pBas;

	if( pBasic )
		pBasic->AddRef();
	if( pSbxForm )
	{
		if( pOldBasic )
			pOldBasic->Remove( pSbxForm );
		if( pBasic )
			pBasic->Insert( pSbxForm );
	}
	if( pOldBasic )
		pOldBasic->ReleaseRef();
}

VCSbxFormRef VCDrawPage::GetSbxForm()
{
	if( !pSbxForm )
	{
		pVCManager	= new VCManager();
		pVCManager->SetGetLinkDataHdl( LINK( pLinkHdl, VCLinkHdl,
												ImpGetLinkData ) );
		pVCManager->SetSetLinkDataHdl( LINK( pLinkHdl, VCLinkHdl,
												ImpSetLinkData ) );

		VCDrawModel* pMyModel = (VCDrawModel*)GetModel();
		pSbxForm = new VCSbxForm( pVCManager, pMyModel->pVCItemPool );
		pPool = pSbxForm->GetPool();
		pSbxForm->SetName( GetName() );
		if( pBasic )
			pBasic->Insert( pSbxForm );
	}

	return pSbxForm;
}

void VCDrawPage::SetSbxForm( VCSbxFormRef pNewForm )
{
	if( pBasic && pSbxForm && (pSbxForm->Type() == TYPE( VCSbxForm ) ) )
		pBasic->Remove( pSbxForm );

	pSbxForm = pNewForm;

	if( pSbxForm )
	{
		pSbxForm->SetName( GetName() );
		if( pBasic && (pSbxForm->Type() == TYPE( VCSbxForm ) ) )
			pBasic->Insert( pSbxForm );
		pPool = pSbxForm->GetPool();
	}
	else
	{
		// auf den Pool des Models zurueckschalten
		pPool = 0;
	}
}

BOOL VCDrawPage::RequestHelp( Window* pWindow, SdrView* pView,
							  const HelpEvent& rEvt )
{
	if( !pView->IsAction() )
	{
		Point aPos = rEvt.GetMousePosPixel();
		aPos = pWindow->ScreenToOutputPixel( aPos );
		aPos = pWindow->PixelToLogic( aPos );

		SdrObject* pObj;
		SdrPageView* pPV;
		if( pView->PickObj( aPos, 0, pObj, pPV ) )
		{
			// Ein Object getroffen
			if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
			{
				SfxItemSet* pItemSet = ((VCSbxDrawObject*)pObj)->GetItemSet();
				String aHelpText = ((SfxStringItem&)pItemSet->Get( VCATTR_HELPTEXT )).GetValue();
				if( !aHelpText.Len() )
				{
					// keonnen wir eine URL anzeigen?
					VCSbxDrawObject* pControl = (VCSbxDrawObject*)pObj;
					if( pControl->GetControl()->IsA(TYPE(VCSbxURLButton)))
					{
						VCURLButton* pBtn = (VCURLButton*)(pControl->GetControl()->GetVCControl());
						aHelpText = pBtn->GetURL();
						INetURLObject aUrl( aHelpText );
						aHelpText = aUrl.GetURLNoPass();
					}
				}
				if( aHelpText.Len())
				{
					// Hilfe anzeigen
					Rectangle aItemRect = pObj->GetBoundRect();
					aItemRect = pWindow->LogicToPixel( aItemRect );
					Point aPt = pWindow->OutputToScreenPixel( aItemRect.TopLeft() );
					aItemRect.Left()   = aPt.X();
					aItemRect.Top()    = aPt.Y();
					aPt = pWindow->OutputToScreenPixel( aItemRect.BottomRight() );
					aItemRect.Right()  = aPt.X();
					aItemRect.Bottom() = aPt.Y();
					if( rEvt.GetMode() == HELPMODE_BALLOON )
						Help::ShowBalloon( pWindow, aItemRect.Center(), aItemRect, aHelpText);
					else
						Help::ShowQuickHelp( pWindow, aItemRect, aHelpText );


				}
				return TRUE;
			}
		}
	}
	return FALSE;
}

void VCDrawPage::RequestBasic()
{
}

String VCDrawPage::GetLinkData( const String& rLinkName )
{
	return String();
}

void VCDrawPage::SetLinkData( const String& rLinkName, const String& rLinkData )
{
}

void VCDrawPage::UpdateLinkData( const String& rLinkName, const String& rLinkData )
{
	if( pVCManager )
		pVCManager->UpdateLinkData( rLinkName, rLinkData );
}

void VCDrawPage::WriteData( SvStream& rOut ) const
{
	CharSet eOldCharSet = rOut.GetStreamCharSet( );
	rOut.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	if( pSbxForm )
	{
		SdrDownCompat aCompat( rOut, STREAM_WRITE);
		rOut << (UINT16)1;
		UINT32 nMyVer = 0x13081961;
		rOut << nMyVer;
		rOut << *pSbxForm;
	}
	else
	{
		SdrDownCompat aCompat( rOut, STREAM_WRITE);
		rOut << (UINT16)0;
	}

	SdrPage::WriteData( rOut );

	SdrDownCompat aCompat( rOut, STREAM_WRITE);
	rOut.WriteByteString( GetName() );

	// Magic-Number schreiben, da Carsten vergessen hat,
	// eine (erhoehbare!) Versionsnummer einzubauen
	rOut << (ULONG)0x11051967;
	rOut << (ULONG)0x19670511;

	USHORT nVer = 1;
	rOut << nVer; // Versionsnummer innerhalb meines Blockes
	{
		SdrDownCompat aCompat( rOut, STREAM_WRITE);
		// VCForms speichern
		ULONG nFormCount = 0;
		if( pVCManager )
		{
			nFormCount = pVCManager->FormCount();
			rOut << nFormCount;
			for( ULONG nCurForm=0; nCurForm < nFormCount; nCurForm++ )
			{
				rOut << *(pVCManager->GetFormByPos(nCurForm));
			}
		}
		else
			rOut << nFormCount;
	}
	rOut.SetStreamCharSet( eOldCharSet );
}

void VCDrawPage::ReadData( const SdrIOHeader& rHead, SvStream& rIn )
{
	// macht JOE jetzt
	CharSet eOldCharSet = rIn.GetStreamCharSet( );
	rIn.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	{
		SdrDownCompat aCompat( rIn, STREAM_READ );
		UINT16 n;
		rIn >> n;
		if( n )
		{
			GetSbxForm();

			UINT32 nMyVer;
			rIn >> nMyVer;
			if( nMyVer == 0x13081961 )
				rIn >> *pSbxForm;
		}
	}

	// Joe liest jetzt auch die Dok-Controls ein!
	SdrPage::ReadData( rHead, rIn );

	{
		SdrDownCompat aCompat( rIn, STREAM_READ );
		String aName;
		rIn.ReadByteString( aName );
		SetName( aName );

		ULONG nMagic1=0, nMagic2=0;
		ULONG nFPos = rIn.Tell();
		// Magic-Number lesen
		rIn >> nMagic1; rIn >> nMagic2;
		if( nMagic1 == 0x11051967 && nMagic2 == 0x19670511 )
		{
			// es ist noch was da
			USHORT nVer;
			rIn >> nVer; // Versionsnummer innerhalb meines Blockes
			{
				SdrDownCompat aCompat( rIn, STREAM_READ);
				// VCForms laden
				ULONG nFormCount;
				rIn >> nFormCount;
				if( nFormCount )
				{
					// diese Dummy-Referenz  sorgt dafuer, dass ein
					// VCManager angelegt wird, falls noch keiner da ist
					VCSbxFormRef aDummyRef = VCDrawPage::GetSbxForm();
					DBG_ASSERT(pVCManager,"No VCManager!");
					for( ULONG nCurForm=0; nCurForm < nFormCount; nCurForm++ )
					{
						VCForm* pForm = new VCForm;
						rIn >> *pForm;
						pVCManager->InsertForm( pForm );
					}
				}
			}
		}
		else
			rIn.Seek( nFPos );

		// Ueber alle Controls gehen und die Dinger in ihre Forms einfuegen.
		// Das kann ich nicht im VCSbxDrawObject::ReadData machen, weil
		// die Forms dann noch nicht geladen sind!
		if( pVCManager )
		{
			ULONG nCtrlCount = pVCManager->GetChildCount();
			for( ULONG nCur=0; nCur < nCtrlCount; nCur++ )
			{
				VCControl* pVCControl = pVCManager->GetChildByPos(nCur);
				String aFormName( pVCControl->GetFormName() );
				if( aFormName.Len() )
				{
					// in eine neue Form packen, diese ggf. erzeugen
					VCForm* pForm = pVCManager->GetFormByName( aFormName );
					DBG_ASSERT(pForm,"No Form!");
					pVCControl->SetVCForm( pForm );
				}
			}
		}
	}
	rIn.SetStreamCharSet( eOldCharSet );
}

void VCSbxDrawObject::NbcMove( const Size& rSize )
{
	Rectangle aOldRect( pVCControl->GetPos(), pVCControl->GetSize() );
	SdrObject::NbcMove( rSize );

	USHORT nVCFlags = pVCControl->GetFlags();
	if( !(nVCFlags & 0x0001) )
	{
		if( pModel )
			pVCControl->SetOutUnit( pModel->GetScaleUnit() );

		pVCControl->SetDrawObject( NULL );

		Point aPos = aOutRect.TopLeft();
		aPos = OutputDevice::LogicToLogic( aPos,
			MapMode( pVCControl->GetOutUnit()), MapMode( MAP_TWIP ));

		SbxObject* pParent = pImpl->pControl->GetParent();
		if( pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
		{
			aPos -= ((VCSbxDialog*)pParent)->GetPos();
			aPos.Y() -= ((VCSbxDialog*)pParent)->GetCaptionHeight();
		}
		pVCControl->SetPos( aPos );

		pVCControl->SetDrawObject( this );
	}
	nVCFlags &= ~0x0001;
	pVCControl->SetFlags( nVCFlags );
}

void VCSbxDrawObject::NbcResize(const Point& rRef, const Fraction& xFract, const Fraction& yFract)
{
	Rectangle aOldRect( pVCControl->GetPos(), pVCControl->GetSize() );
	SdrObject::NbcResize( rRef, xFract, yFract );

	if( pModel )
		pVCControl->SetOutUnit( pModel->GetScaleUnit() );

	MapMode aMapTwip( MAP_TWIP );
	MapMode aMapOut( pVCControl->GetOutUnit() );

	pVCControl->SetDrawObject( NULL );

	Point aPos = aOutRect.TopLeft();
	aPos = OutputDevice::LogicToLogic( aPos, aMapOut, aMapTwip );

	Size aSize = aOutRect.GetSize();
	aSize = OutputDevice::LogicToLogic( aSize, aMapOut, aMapTwip );

	Size aMinSizePixel = pVCControl->GetMinSizePixel();
	Size aMinSize = Application::GetDefaultDevice()->PixelToLogic( aMinSizePixel, aMapTwip );
	BOOL bChanged = FALSE;
	if( (aMinSize.Width() > aSize.Width()) )
	{
		aSize.Width() = aMinSize.Width();
		bChanged = TRUE;
	}
	if( aMinSize.Height() > aSize.Height() )
	{
		aSize.Height() = aMinSize.Height();
		bChanged = TRUE;
	}

	if( bChanged )
	{
		Size aTSize = OutputDevice::LogicToLogic( aSize, aMapTwip, aMapOut );
		aOutRect.SetSize( aTSize );
		SetRectsDirty();
	}

	SbxObject* pParent = pImpl->pControl->GetParent();
	if( pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
	{
		aPos -= ((VCSbxDialog*)pParent)->GetPos();
		aPos.Y() -= ((VCSbxDialog*)pParent)->GetCaptionHeight();
	}
	pVCControl->SetPos( aPos );

	pVCControl->SetSize( aSize);
	pVCControl->SetDrawObject( this );
}

TYPEINIT1( VCSbxDrawObject, SdrObject );

VCSbxDrawObject::VCSbxDrawObject()
{
	pImpl = new VCSbxDrawObject_Impl;
}

VCSbxDrawObject::VCSbxDrawObject( const VCSbxDrawObject& )
{
	// not implemented
}


VCSbxDrawObject::VCSbxDrawObject( VCSbxControlRef pCtrl )
{
	pImpl = new VCSbxDrawObject_Impl;
	pImpl->pControl	= pCtrl;
	pVCControl	= pImpl->pControl->GetVCControl();

	pVCControl->SetDrawObject( this );
	SetRectsDirty();
}

VCSbxDrawObject::~VCSbxDrawObject()
{
	// Aus dem Basic-Object entfernen, da dort eine Referenz gehalten wird
	if( pPage && pPage->IsA( TYPE( VCDrawPage ) ) )
		if( ((VCDrawPage*)pPage)->IsDeleteSbxObject() )
			pImpl->pControl->SetParentBetter( NULL );

	pVCControl->SetDrawObject( NULL );
	delete pImpl;
}

FASTBOOL VCSbxDrawObject::Paint( ExtOutputDevice& rOut,
								 const SdrPaintInfoRec& rInfo ) const
{
	SbxObject* pParent = pImpl->pControl->GetParent();
	if(  pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
	{
		Point aPos = ((VCSbxDialog*)pParent)->GetPos();
		aPos.Y() += ((VCSbxDialog*)pParent)->GetCaptionHeight();
		pVCControl->SetDrawOfs( aPos );
		pVCControl->Draw( rOut.GetOutDev() );
		pVCControl->SetDrawOfs( Point() );
		// Problem: Eine GroupBox und ein anderer Control-Typ ueberlappen
		// sich. Im Paint wird u.U. zuerst der Button und dann die
		// GroupBox gezeichnet. Dies hat zur Folge, dass durch den Button
		// eine odere mehrere Kanten der GroupBox laufen.
		if( rOut.GetOutDev()->GetOutDevType() != OUTDEV_PRINTER &&
			pImpl->pControl->ISA(VCSbxGroupBox) )
			((VCSbxDrawObject*)this)->PaintOverlayObjects( rOut, rInfo );
	}
	else
		pVCControl->Draw( rOut.GetOutDev() );

	return TRUE;
}

FASTBOOL VCSbxDrawObject::EndCreate( SdrDragStat& rStat, SdrCreateCmd eCmd )
{
	BOOL bRet = SdrObject::EndCreate( rStat, eCmd );

	pVCControl->SetOutUnit( pModel->GetScaleUnit() );

	MapMode aMapOut( pModel->GetScaleUnit() );
	MapMode aMapTwip( MAP_TWIP );

	pVCControl->SetDrawObject( NULL );

	Point aPos = aOutRect.TopLeft();
	aPos = OutputDevice::LogicToLogic( aPos, aMapOut, aMapTwip );

	SbxObject* pParent = pImpl->pControl->GetParent();
	if( pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
	{
		aPos -= ((VCSbxDialog*)pParent)->GetPos();
		aPos.Y() -= ((VCSbxDialog*)pParent)->GetCaptionHeight();
	}
	pVCControl->SetPos( aPos );

	Size aSize = aOutRect.GetSize();
	aSize = OutputDevice::LogicToLogic( aSize, aMapOut, aMapTwip );

	Size aMinSizePixel = pVCControl->GetMinSizePixel();
	if( pVCControl && pVCControl->ISA(VCComboBox) )
	{
		aMinSizePixel.Height() = 28;
	}

	Size aMinSize = Application::GetDefaultDevice()->PixelToLogic( aMinSizePixel, MapMode( MAP_TWIP ) );
	BOOL bChanged = FALSE;
	if( (aMinSize.Width() > aSize.Width()) )
	{
		aSize.Width() = aMinSize.Width();
		bChanged = TRUE;
	}
	if( aMinSize.Height() > aSize.Height() )
	{
		aSize.Height() = aMinSize.Height();
		bChanged = TRUE;
	}
	if( bChanged )
	{
		Size aTSize = OutputDevice::LogicToLogic( aSize, aMapTwip, aMapOut );
		aOutRect.SetSize( aTSize );
		SetRectsDirty();
	}
	pVCControl->SetSize( aSize );
	pVCControl->SetDrawObject( this );
	return bRet;
}

void VCSbxDrawObject::RecalcBoundRect()
{
	SfxItemSet* pItemSet	= pVCControl->GetItemSet();
	SfxInt32Item aLeftItem	= (SfxInt32Item&)pItemSet->Get( VCATTR_LEFT );
	SfxInt32Item aTopItem	= (SfxInt32Item&)pItemSet->Get( VCATTR_TOP );
	SfxInt32Item aWItem 	= (SfxInt32Item&)pItemSet->Get( VCATTR_WIDTH );
	SfxInt32Item aHItem 	= (SfxInt32Item&)pItemSet->Get( VCATTR_HEIGHT );

	MapUnit eUnit;
	// HACK wg. BugId 26363; Bug wahrscheinlich in DrawingEngine;
	// wird nach Auslieferung (Apr.96) gefixt
	if( pModel )
		eUnit = pModel->GetScaleUnit();
	else
		eUnit = MAP_100TH_MM;

	MapMode aMapTwip( MAP_TWIP );
	MapMode aMapOut( eUnit );

	aOutRect = Rectangle( Point( aLeftItem.GetValue(), aTopItem.GetValue() ),
						  Size( aWItem.GetValue(), aHItem.GetValue() ) );
	aOutRect = OutputDevice::LogicToLogic( aOutRect, aMapTwip, aMapOut );

	// HACK, da Image-Buttons mit einer Groesse von 0 keinen
	// Paint-Event bekommen (0,0 => Groesse == Groesse der Grafik)
	// Die Grafik wird aber erst im Paint-Event geladen
	if( pVCControl->IsA( TYPE(VCPushButton)))
	{
		Size aSize( aOutRect.GetSize());
		if( !aSize.Width() )
			aSize.Width() = 2;
		if( !aSize.Height() )
			aSize.Height() = 2;
		aOutRect.SetSize( aSize );
	}

	SbxObject* pParent = pImpl->pControl->GetParent();
	if( pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
	{
		Point aPos = ((VCSbxDialog*)pParent)->GetPos();
		aPos.Y() += ((VCSbxDialog*)pParent)->GetCaptionHeight();
		aPos = OutputDevice::LogicToLogic( aPos, aMapTwip, aMapOut );
		aOutRect += aPos;
	}
}

FASTBOOL VCSbxDrawObject::HasMacro() const
{
	return TRUE;
}

SdrObject* VCSbxDrawObject::CheckMacroHit(const SdrObjMacroHitRec& rRec) const
{
	const Point& rPt = rRec.aPos;
	USHORT nTol = rRec.nTol;
	const SetOfByte* pSet = rRec.pVisiLayer;
	if( HasMacro() )
	{
		Point aPos = OutputDevice::LogicToLogic( rPt,
			MapMode( pModel->GetScaleUnit()),
			MapMode( MAP_TWIP ) );

		return pVCControl->IsActionHit(aPos,nTol) ? (SdrObject*)this : 0;
	}
	else
		return SdrObject::CheckMacroHit( rRec );
}

SdrObject* VCSbxDrawObject::CheckHit( const Point& rPnt, USHORT nTol,const SetOfByte* pSet ) const
{
	if( pImpl->pControl->ISA(VCSbxGroupBox))
	{
		Rectangle aROuter = aOutRect;
		aROuter.Left()	 -= nTol;
		aROuter.Right()  += nTol;
		aROuter.Top()	 -= nTol;
		aROuter.Bottom() += nTol;

		Rectangle aRInner = aOutRect;
		if( (aRInner.GetSize().Height() > (long)nTol*2) &&
			(aRInner.GetSize().Width()	> (long)nTol*2)    )
		{
			aRInner.Left()	 += nTol;
			aRInner.Right()  -= nTol;
			aRInner.Top()	 += nTol;
			aRInner.Bottom() -= nTol;
		}

		if( aROuter.IsInside( rPnt ) && !aRInner.IsInside( rPnt ) )
			return (SdrObject*)this;
		else
			return 0;
	}
	else
		return SdrObject::CheckHit( rPnt, nTol, pSet );
}

Pointer VCSbxDrawObject::GetMacroPointer(const SdrObjMacroHitRec& rRec) const
{
	VCEdit* pEdit = PTR_CAST(VCEdit,pVCControl);
	return Pointer( POINTER_REFHAND );
}

void VCSbxDrawObject::TakeObjInfo( SdrObjTransformInfoRec& rInfo ) const
{
	rInfo.bRotateFreeAllowed		= FALSE;
	rInfo.bRotate90Allowed			= FALSE;
	rInfo.bMirrorFreeAllowed		= FALSE;
	rInfo.bMirror45Allowed			= FALSE;
	rInfo.bMirror90Allowed			= FALSE;
	rInfo.bTransparenceAllowed = FALSE;
	rInfo.bGradientAllowed = FALSE;
	rInfo.bShearAllowed 			= FALSE;
	rInfo.bCanConvToPath			= FALSE;
	rInfo.bCanConvToPoly			= FALSE;
	rInfo.bCanConvToPathLineToArea	= FALSE;
	rInfo.bCanConvToPolyLineToArea	= FALSE;
}

void VCSbxDrawObject::TakeObjNameSingul( String& rName ) const
{
	rName = pImpl->pControl->GetClassName();
}

void VCSbxDrawObject::TakeObjNamePlural( String& rName ) const
{
	rName = pImpl->pControl->GetClassNamePlural();
}

SfxItemSet* VCSbxDrawObject::GetItemSet()
{
	return pVCControl->GetItemSet();
}

void VCSbxDrawObject::SetItemSet( SfxItemSet* pItemSet )
{
	pVCControl->SetItemSet( pItemSet );
}

void VCSbxDrawObject::UpdateItem( USHORT nWhich )
{
	pVCControl->UpdateItem( nWhich );

	if( nWhich == VCATTR_STEP )
		pImpl->pControl->SetStep( pVCControl->GetStep() );
}

UINT32 VCSbxDrawObject::GetObjInventor() const
{
	return VCSbxInventor;
}

UINT16 VCSbxDrawObject::GetObjIdentifier() const
{
	VCControl* pVCControl = pImpl->pControl->GetVCControl();

	if( pVCControl->IsReal() )
	{
		if( pVCControl->Type() == TYPE( VCCheckBox ) )
			return (UINT16)OBJ_DLG_CHECKBOX;
		if( pVCControl->Type() == TYPE( VCRadioButton ) )
			return (UINT16)OBJ_DLG_RADIOBUTTON;
		if( pVCControl->Type() == TYPE( VCPushButton ) )
			return (UINT16)OBJ_DLG_PUSHBUTTON;
		if( pVCControl->Type() == TYPE( VCSpinButton ) )
			return (UINT16)OBJ_DLG_SPINBUTTON;
		if( pVCControl->Type() == TYPE( VCFixedText ) )
			return (UINT16)OBJ_DLG_FIXEDTEXT;
		if( pVCControl->Type() == TYPE( VCGroupBox ) )
			return (UINT16)OBJ_DLG_GROUPBOX;
		if( pVCControl->Type() == TYPE( VCListBox ) )
			return (UINT16)OBJ_DLG_LISTBOX;
		if( pVCControl->Type() == TYPE( VCComboBox ) )
			return (UINT16)OBJ_DLG_COMBOBOX;
		if( pVCControl->Type() == TYPE( VCEdit ) )
			return (UINT16)OBJ_DLG_EDIT;
		if( pVCControl->Type() == TYPE( VCHScrollBar ) )
			return (UINT16)OBJ_DLG_HSCROLLBAR;
		if( pVCControl->Type() == TYPE( VCVScrollBar ) )
			return (UINT16)OBJ_DLG_VSCROLLBAR;
		if( pVCControl->Type() == TYPE( VCPreview ) )
			return (UINT16)OBJ_DLG_PREVIEW;
		if( pVCControl->Type() == TYPE( VCURLButton ) )
			return (UINT16)OBJ_DLG_URLBUTTON;
	}
	else
	{
		if( pVCControl->Type() == TYPE( VCCheckBox ) )
			return (UINT16)OBJ_CHECKBOX;
		if( pVCControl->Type() == TYPE( VCRadioButton ) )
			return (UINT16)OBJ_RADIOBUTTON;
		if( pVCControl->Type() == TYPE( VCPushButton ) )
			return (UINT16)OBJ_PUSHBUTTON;
		if( pVCControl->Type() == TYPE( VCSpinButton ) )
			return (UINT16)OBJ_SPINBUTTON;
		if( pVCControl->Type() == TYPE( VCFixedText ) )
			return (UINT16)OBJ_FIXEDTEXT;
		if( pVCControl->Type() == TYPE( VCGroupBox ) )
			return (UINT16)OBJ_GROUPBOX;
		if( pVCControl->Type() == TYPE( VCListBox ) )
			return (UINT16)OBJ_LISTBOX;
		if( pVCControl->Type() == TYPE( VCComboBox ) )
			return (UINT16)OBJ_COMBOBOX;
		if( pVCControl->Type() == TYPE( VCEdit ) )
			return (UINT16)OBJ_EDIT;
		if( pVCControl->Type() == TYPE( VCHScrollBar ) )
			return (UINT16)OBJ_HSCROLLBAR;
		if( pVCControl->Type() == TYPE( VCVScrollBar ) )
			return (UINT16)OBJ_VSCROLLBAR;
		if( pVCControl->Type() == TYPE( VCURLButton ) )
			return (UINT16)OBJ_URLBUTTON;
	}
	return 0;
}

void VCSbxDrawObject::SetRectsDirty( FASTBOOL bNotMySelf )
{
	SdrObject::SetRectsDirty( bNotMySelf );
}

void VCSbxDrawObject::RestGeoData( const SdrObjGeoData& rGeo )
{
	SdrObject::RestGeoData( rGeo );

	// Mit Itemset synchronisieren
	Rectangle aRect = aOutRect;

	MapMode aMapTwip( MAP_TWIP );
	MapMode aMapOut( pModel->GetScaleUnit() );

	SbxObject* pParent = pImpl->pControl->GetParent();
	if( pParent && pParent->IsA( TYPE( VCSbxDialog ) ) )
	{
		Point aPos = ((VCSbxDialog*)pParent)->GetPos();
		aPos.Y() += ((VCSbxDialog*)pParent)->GetCaptionHeight();
		aPos = OutputDevice::LogicToLogic( aPos, aMapTwip, aMapOut );
		aRect -= aPos;
	}
	aRect = OutputDevice::LogicToLogic( aRect, aMapOut, aMapTwip );
	Size aSize = aRect.GetSize();
	if( aSize.Width() )
		aSize.Width() -= 1;
	if( aSize.Height() )
		aSize.Height() -= 1;

	pVCControl->SetPos( aRect.TopLeft() );
	pVCControl->SetSize( aRect.GetSize() );
}

void VCSbxDrawObject::SetPage( SdrPage* pNewPage )
{
	SdrPage*  pOldPage	= GetPage();

	if( pOldPage == pNewPage )
		return;

	// Wenn altes und neues Model unterschiedlich sind,
	// ruft die Basisklasse SetModel() auf !!!
	SdrObject::SetPage( pNewPage );


	if( pNewPage &&
		pNewPage->IsA( TYPE( VCDrawPage )) )
	{
		pImpl->pControl->SetParentBetter( ((VCDrawPage*)pNewPage)->GetSbxForm() );
	}
	else
		pImpl->pControl->SetParentBetter( NULL );

	RecalcBoundRect();
}

void VCSbxDrawObject::SetModel( SdrModel* pNewModel )
{
	SdrObject::SetModel( pNewModel );
}

void VCSbxDrawObject::InvalidateOverlayObjects( Window* pWindow )
{
	SdrPage* pPage = GetPage();
	if( !pPage )
		return;

	ULONG nObjCount = pPage->GetObjCount();
	if( !nObjCount )
		return;

	Rectangle aMyRect = GetBoundRect();
	long i;
	for( i=(long)nObjCount-1; i >= 0; i-- )
	{
		SdrObject* pObj = pPage->GetObj( (ULONG)i );
		if( pObj == this )
			break;

		Rectangle aBoundRect = pObj->GetBoundRect();
		Rectangle aMacRect;
		if( aBoundRect.Intersection( GetBoundRect() ) != aMacRect )
			pWindow->Invalidate( aBoundRect );
	}
}

void VCSbxDrawObject::PaintOverlayObjects( ExtOutputDevice& rOut,
										   const SdrPaintInfoRec& rInfo ) const
{
	SdrPage* pPage = GetPage();
	if( !pPage )
		return;

	ULONG nObjCount = pPage->GetObjCount();
	if( !nObjCount )
		return;

	Rectangle aMyRect = GetBoundRect();
	long i;
	for( i=(long)nObjCount-1; i >= 0; i-- )
	{
		const SdrObject* pObj = pPage->GetObj( (ULONG)i );
		if( pObj == this )
			break;

		// nur wenn das Objekt sichtbar ist!
		if( rInfo.aPaintLayer.IsSet( pObj->GetLayer()) )
		{
			VCSbxDrawObject* pCur = PTR_CAST(VCSbxDrawObject,pObj);
			if( !pCur || !pCur->pImpl->pControl->ISA(VCSbxGroupBox) )
			{
				Rectangle aBoundRect = pObj->GetBoundRect();
				Rectangle aMacRect;
				if( aBoundRect.Intersection( GetBoundRect() ) != aMacRect )
					pObj->Paint( rOut, rInfo );
			}
		}
	}
}

BOOL VCSbxDrawObject::HasOverlayObjects() const
{
	SdrPage* pPage = GetPage();
	if( !pPage )
		return FALSE;

	ULONG nObjCount = pPage->GetObjCount();
	if( !nObjCount )
		return FALSE;

	Rectangle aMyRect = GetBoundRect();
	long i;
	for( i=(long)nObjCount-1; i >= 0; i-- )
	{
		SdrObject* pObj = pPage->GetObj( (ULONG)i );
		if( pObj == (VCSbxDrawObject*)this )
			break;

		Rectangle aBoundRect = pObj->GetBoundRect();
		Rectangle aMacRect;
		if( aBoundRect.Intersection( GetBoundRect() ) != aMacRect )
			return TRUE;
	}

	return FALSE;
}

void VCSbxDrawObject::WriteData(SvStream& rOut) const
{
	CharSet eOldCharSet = rOut.GetStreamCharSet( );
	rOut.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	SdrObject::WriteData( rOut );

	SdrDownCompat aCompat( rOut, STREAM_WRITE );
	UINT32 nMyVer = 0x13081961;
	rOut << nMyVer;
	rOut << *(pImpl->pControl);

	rOut.SetStreamCharSet( eOldCharSet );
}

void VCSbxDrawObject::ReadData(const SdrObjIOHeader& rHead, SvStream& rIn)
{
	CharSet eOldCharSet = rIn.GetStreamCharSet( );
	rIn.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	SdrObject::ReadData( rHead, rIn );

	pVCControl->SetOutUnit( pModel->GetScaleUnit() );

	SdrDownCompat aCompat( rIn, STREAM_READ );

	UINT32 nMyVer;
	rIn >> nMyVer;
	if( nMyVer == 0x13081961 )
		rIn >> *(pImpl->pControl);
	else
	{
		Rectangle aRect = aOutRect;
		aRect = OutputDevice::LogicToLogic( aRect,
			MapMode( pModel->GetScaleUnit() ),
			MapMode( MAP_TWIP ));

		pVCControl->SetPos( aRect.TopLeft() );
		pVCControl->SetSize( aRect.GetSize() );
	}

	rIn.SetStreamCharSet( eOldCharSet );
}

void VCSbxDrawObject::operator=( const SdrObject& rObj )
{
	SdrObject::operator=( rObj );

	if( rObj.Type() != Type() )
		return;

	VCSbxDrawObject& rOtherObj	= (VCSbxDrawObject&)rObj;
	VCSbxControl*	 pOtherCtrl = rOtherObj.GetControl();

	UINT16 nId = pOtherCtrl->GetSbxId();

	VCSbxControl* pNewCtrl = (VCSbxControl*)pOtherCtrl->Create(
								nId,
								pOtherCtrl->GetCreator() );

	SfxItemSet* pNewItemSet = pOtherCtrl->GetVCControl()->GetItemSet()
								->Clone( TRUE, pNewCtrl->GetVCControl()->GetPool() );
	pNewCtrl->GetVCControl()->SetItemSetSimple( pNewItemSet );

	pImpl->pControl->SetParentBetter( NULL );
	pImpl->pControl  = pNewCtrl;
	pVCControl= pNewCtrl->GetVCControl();
}

SdrObject* VCSbxDrawObject::Clone() const
{
	VCSbxDrawObject* pNewObj= (VCSbxDrawObject*)
		SdrObjFactory::MakeNewObject(GetObjInventor(),GetObjIdentifier(),
									NULL );
	pNewObj->SdrObject::operator=(*this);
	SfxItemSet* pNewItemSet = pImpl->pControl->GetVCControl()->GetItemSet()
		->Clone( TRUE, pImpl->pControl->GetVCControl()->GetPool() );
	pNewObj->GetControl()->GetVCControl()->SetItemSetSimple( pNewItemSet );
	return pNewObj;
}

SdrObject* VCSbxDrawObject::Clone( SdrPage* pPage, SdrModel* pModel ) const
{
	VCSbxDrawObject* pNewObj = (VCSbxDrawObject*)Clone();
	pNewObj->SetModel( pModel );
	pNewObj->SetPage( pPage );
	return pNewObj;
}

void VCSbxDialogObject::NbcMove( const Size& rSize )
{
	SdrObject::NbcMove( rSize );
	pForm->SetDrawObject(NULL);

	Point aPos = aOutRect.TopLeft();
	aPos = OutputDevice::LogicToLogic( aPos, MapMode( pModel->GetScaleUnit() ),MapMode( MAP_TWIP ));
	pForm->SetPos( aPos );
	pForm->SetDrawObject( this );
}

void VCSbxDialogObject::NbcResize(const Point& rRef, const Fraction& xFract, const Fraction& yFract)
{
	Rectangle aOldRect = aOutRect;

	SdrObject::NbcResize( rRef, xFract, yFract );
	pForm->SetDrawObject(NULL);

	MapMode aMapOut( pModel->GetScaleUnit() );
	MapMode aMapTwip( MAP_TWIP );

	Point aPos = aOutRect.TopLeft();
	aPos = OutputDevice::LogicToLogic( aPos, aMapOut, aMapTwip );

	Size aSize = aOutRect.GetSize();
	aSize = OutputDevice::LogicToLogic( aSize, aMapOut, aMapTwip );

	BOOL bMoveChilds = (aPos.X() != aOldRect.Left()) || (aPos.Y() != aOldRect.Top()) ? TRUE : FALSE;
	pForm->SetPos( aPos, bMoveChilds );
	pForm->SetSize( aSize );
	pForm->SetDrawObject( this );
}

TYPEINIT1( VCSbxDialogObject, SdrObject );

VCSbxDialogObject::VCSbxDialogObject( VCSbxDialog* pForm )
{
	VCSbxDialogObject::pForm = pForm;
	pForm->SetDrawObject( this );
}

VCSbxDialogObject::~VCSbxDialogObject()
{
}

FASTBOOL VCSbxDialogObject::Paint( ExtOutputDevice& rOut,
								   const SdrPaintInfoRec& rInfo ) const
{
	BOOL bOldClip	= rOut.GetOutDev()->IsClipRegion();
	Region aOldClip = rOut.GetOutDev()->GetClipRegion();
	rOut.GetOutDev()->SetClipRegion( Region( rInfo.aDirtyRect ) );
	pForm->Draw( rOut.GetOutDev() );
	if( bOldClip )
		rOut.GetOutDev()->SetClipRegion( aOldClip );
	else
		rOut.GetOutDev()->SetClipRegion();
	return TRUE;
}

FASTBOOL VCSbxDialogObject::EndCreate( SdrDragStat& rStat, SdrCreateCmd eCmd )
{
	BOOL bRet = SdrObject::EndCreate( rStat, eCmd );

	pForm->SetDrawObject( NULL );

	MapMode aMapOut( pModel->GetScaleUnit() );
	MapMode aMapTwip( MAP_TWIP );

	Point aPos = aOutRect.TopLeft();
	aPos = OutputDevice::LogicToLogic( aPos, aMapOut, aMapTwip );

	Size aSize = aOutRect.GetSize();
	aSize = OutputDevice::LogicToLogic( aSize, aMapOut, aMapTwip );

	pForm->SetPos( aPos );
	pForm->SetSize( aSize );
	pForm->SetDrawObject( this );

	return bRet;
}

SdrObject* VCSbxDialogObject::CheckHit( const Point& rPnt, USHORT nTol,
	const SetOfByte*  pSet ) const
{
	Rectangle aROuter = aOutRect;
	aROuter.Left()	 -= nTol;
	aROuter.Right()  += nTol;
	aROuter.Top()	 -= nTol;
	aROuter.Bottom() += nTol;

	Rectangle aRInner = aOutRect;
	if( (aRInner.GetSize().Height() > (long)nTol*2) &&
		(aRInner.GetSize().Width()	> (long)nTol*2)    )
	{
		aRInner.Left()	 += nTol;
		aRInner.Right()  -= nTol;
		aRInner.Top()	 += nTol;
		aRInner.Bottom() -= nTol;
	}

	if( aROuter.IsInside( rPnt ) && !aRInner.IsInside( rPnt ) )
		return (SdrObject*)this;
	else
		return 0;
}

void VCSbxDialogObject::TakeObjInfo( SdrObjTransformInfoRec& rInfo ) const
{
	rInfo.bRotateFreeAllowed		= FALSE;
	rInfo.bRotate90Allowed			= FALSE;
	rInfo.bMirrorFreeAllowed		= FALSE;
	rInfo.bMirror45Allowed			= FALSE;
	rInfo.bMirror90Allowed			= FALSE;
	rInfo.bTransparenceAllowed = FALSE;
	rInfo.bGradientAllowed = FALSE;
	rInfo.bShearAllowed 			= FALSE;
	rInfo.bCanConvToPath			= FALSE;
	rInfo.bCanConvToPoly			= FALSE;
	rInfo.bCanConvToPathLineToArea	= FALSE;
	rInfo.bCanConvToPolyLineToArea	= FALSE;
}

void VCSbxDialogObject::TakeObjNameSingul( String& rName ) const
{
	rName = String( SiResId( STR_CLASS_DIALOG ) );
}

void VCSbxDialogObject::TakeObjNamePlural( String& rName ) const
{
	rName = String( SiResId( STR_CLASS_DIALOGS ) );
}

void VCSbxDialogObject::RecalcBoundRect()
{
	SfxItemSet*  pItemSet	= pForm->GetItemSet();
	SfxInt32Item aLeftItem	= (SfxInt32Item&)pItemSet->Get( VCATTR_LEFT );
	SfxInt32Item aTopItem	= (SfxInt32Item&)pItemSet->Get( VCATTR_TOP );
	SfxInt32Item aWItem 	= (SfxInt32Item&)pItemSet->Get( VCATTR_WIDTH );
	SfxInt32Item aHItem 	= (SfxInt32Item&)pItemSet->Get( VCATTR_HEIGHT );

	aOutRect = Rectangle( Point( aLeftItem.GetValue(), aTopItem.GetValue() ),
						  Size( aWItem.GetValue(), aHItem.GetValue() ) );

	aOutRect = OutputDevice::LogicToLogic( aOutRect,
					MapMode( MAP_TWIP ),MapMode( pModel->GetScaleUnit() ));
}

void VCSbxDialogObject::RestGeoData( const SdrObjGeoData& rGeo )
{
	SdrObject::RestGeoData( rGeo );

	// Mit Itemset synchronisieren
	Rectangle aRect = aOutRect;

	aRect = OutputDevice::LogicToLogic( aRect,
		MapMode( pModel->GetScaleUnit() ),MapMode( MAP_TWIP ) );

	Size aSize = aRect.GetSize();
	if( aSize.Width() )
		aSize.Width() -= 1;
	if( aSize.Height() )
		aSize.Height() -= 1;

	SfxItemSet* pItemSet	= pForm->GetItemSet();
	pItemSet->Put( SfxInt32Item( VCATTR_LEFT, aOutRect.Left() ) );
	pItemSet->Put( SfxInt32Item( VCATTR_TOP, aOutRect.Top() ) );
	pItemSet->Put( SfxInt32Item( VCATTR_WIDTH, aSize.Width() ) );
	pItemSet->Put( SfxInt32Item( VCATTR_HEIGHT, aSize.Height() ) );
}

SfxItemSet* VCSbxDialogObject::GetItemSet()
{
	return pForm->GetItemSet();
}

void VCSbxDialogObject::SetItemSet( SfxItemSet* pItemSet )
{
	// Itemset merken
	pForm->SetItemSet( pItemSet );
}

void VCSbxDialogObject::UpdateItem( USHORT nWhich )
{
	pForm->UpdateItem( nWhich );
	SendRepaintBroadcast();

	if( (nWhich == VCATTR_LEFT)  ||
		(nWhich == VCATTR_TOP)	 ||
		(nWhich == VCATTR_WIDTH) ||
		(nWhich == VCATTR_HEIGHT)	)
	{
		SetRectsDirty();
		SendRepaintBroadcast();
	}
}

UINT32 VCSbxDialogObject::GetObjInventor() const
{
	return VCSbxInventor;
}

UINT16 VCSbxDialogObject::GetObjIdentifier() const
{
	return (UINT16)OBJ_DIALOG;
}

void VCSbxDialogObject::SetRectsDirty( FASTBOOL bNotMySelf )
{
	SdrObject::SetRectsDirty( bNotMySelf );
}

void VCDrawPage::SetModel(SdrModel* pNewModel)
{
	DBG_ASSERT(pNewModel,"VCDrawPage::SetModel: pNewModel==0");
	SdrModel* pOldModel = GetModel();
	SdrPage::SetModel( pNewModel );
	if( pOldModel != pNewModel )
	{
		VCItemPool* pNewPool = ((VCDrawModel*)pNewModel)->GetVCItemPool();
		if( pVCManager )
		{
			ULONG nCount = pVCManager->GetChildCount();
			for( ULONG nCur = 0; nCur < nCount; nCur++ )
			{
				VCControl* pCtrl = pVCManager->GetChildByPos( nCur );
				pCtrl->SetPool( pNewPool );
			}
		}
		if( pSbxForm && pSbxForm->Type() == TYPE(VCSbxForm) )
			pSbxForm->SetPool( pNewPool, FALSE );
	}
}

DBG_NAME(VCDrawModel);

TYPEINIT1(VCDrawModel,SdrModel);

VCDrawModel::VCDrawModel(SfxItemPool* pPool,SvPersist* pPers,
	VCItemPool* pVCPool) : SdrModel(pPool,pPers,LOADREFCOUNTS), pVCItemPool(pVCPool),
	pObjectShell(0)
{
	DBG_CTOR(VCDrawModel,0);
	if( pVCPool )
		nVCFlags = 0;
	else
		nVCFlags = VCMODEL_DELETE_POOL;
}

VCDrawModel::VCDrawModel(const String& rPath, SfxItemPool* pPool,
	SvPersist* pPers, VCItemPool* pVCPool) : SdrModel(rPath,pPool,pPers),
	pVCItemPool(pVCPool),pObjectShell(0)
{
	DBG_CTOR(VCDrawModel,0);
	if( pVCPool )
		nVCFlags = 0;
	else
		nVCFlags = VCMODEL_DELETE_POOL;
}

VCDrawModel::VCDrawModel(SfxItemPool* pPool, SvPersist* pPers,
	FASTBOOL bUseExtColorTable,	VCItemPool* pVCPool ) :
	SdrModel(pPool,pPers,bUseExtColorTable, LOADREFCOUNTS), pVCItemPool(pVCPool),
	pObjectShell(0)
{
	DBG_CTOR(VCDrawModel,0);
	if( pVCPool )
		nVCFlags = 0;
	else
		nVCFlags = VCMODEL_DELETE_POOL;
}

VCDrawModel::VCDrawModel(const String& rPath, SfxItemPool* pPool,
	SvPersist* pPers, FASTBOOL bUseExtColorTable, VCItemPool* pVCPool ) :
	SdrModel(rPath, pPool, pPers, bUseExtColorTable, LOADREFCOUNTS), pVCItemPool(pVCPool),
	pObjectShell(0)
{
	DBG_CTOR(VCDrawModel,0);
	if( pVCPool )
		nVCFlags = 0;
	else
		nVCFlags = VCMODEL_DELETE_POOL;
}

VCDrawModel::~VCDrawModel()
{
	DBG_DTOR(VCDrawModel,0);
	if( nVCFlags & VCMODEL_DELETE_POOL )
		delete pVCItemPool;
}

VCDrawModel::VCDrawModel( const VCDrawModel& )
{
	DBG_ERROR("VCDrawModel: CopyCtor not implemented");
}

void VCDrawModel::operator=(const VCDrawModel& )
{
	DBG_ERROR("VCDrawModel: operator= not implemented");
}

FASTBOOL VCDrawModel::operator==(const VCDrawModel&) const
{
	DBG_ERROR("VCDrawModel: operator== not implemented");
	return FALSE;
}

VCItemPool* VCDrawModel::GetVCItemPool()
{
	DBG_CHKTHIS(VCDrawModel,0);
	if( !pVCItemPool )
		pVCItemPool = new VCItemPool;
	return pVCItemPool;
}

SdrPage* VCDrawModel::AllocPage(FASTBOOL bMasterPage)
{
	DBG_CHKTHIS(VCDrawModel, 0);
	return new VCDrawPage(*this, NULL, bMasterPage);
}

DBG_NAME(VCDrawView);

TYPEINIT1(VCDrawView, E3dView);

VCDrawView::VCDrawView(VCDrawModel* pModel1, OutputDevice* pOut)
	: E3dView( pModel1, pOut )
{
	DBG_CTOR(VCDrawView,0);
}

VCDrawView::VCDrawView(VCDrawModel* pModel1, ExtOutputDevice* pOut)
	: E3dView( pModel1, pOut )
{
	DBG_CTOR(VCDrawView,0);
}

VCDrawView::VCDrawView(VCDrawModel* pModel1)
	: E3dView( pModel1 )
{
	DBG_CTOR(VCDrawView,0);
}

VCDrawView::~VCDrawView()
{
	DBG_DTOR(VCDrawView,0);
	SfxViewFrame* pCurFrame = SfxViewFrame::Current();
	DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
	SfxChildWindow* pChildWin = pCurFrame ? pCurFrame->GetChildWindow(SID_SHOW_BROWSER) : NULL;
	if( pChildWin )
	{
		VCBrowser* pBrw = (VCBrowser*)pChildWin->GetWindow();
		if( pBrw->GetCurView() == this )
			pBrw->Update( 0 );
	}
}

void VCDrawView::VisAreaChanged( OutputDevice* pOut )
{
	DBG_CHKTHIS(VCDrawView,0);
}

void VCDrawModel::VCDrawModelChanged( FASTBOOL bChanged )
{
	SetChanged( bChanged );
}

SdrPage* VCDrawPage::Clone() const
{
	return new VCDrawPage( *this );
}

VCDrawPage::VCDrawPage( const VCDrawPage& rPage )
	: SdrPage( rPage ),
	pBasic(0),
	pVCManager(NULL),
	bDeleteSbxObject(TRUE),
	pLinkHdl(new VCLinkHdl(this) )
{
	pPool = ((VCDrawModel*)GetModel())->pVCItemPool; // GetVCItemPool() wuerde ggf. einen erzeugen
}

ErrCode VCDrawModel::CallBasic( const String& rMacro,
	const String& rBasicName, SbxObject* pVCtrl, SbxArray* pArgs,
	SbxValue* pRet )
{
	DBG_ERROR("CallBasic not implemented");
	return 1;
}

ErrCode VCDrawModel::CallJavaScript(
	const String& rMacro, SjJSbxObject* pJavaScriptThis,
	const String* pArgs, const String* pRet )
{
	DBG_ERROR("CallJavaScript not implemented");
	return 1;
}

SjJSbxObject* VCDrawModel::GetJScriptDocument()
{
	return 0;
}

Window* VCDrawModel::GetCurDocViewWin()
{
	return 0;
}

VCSbxControl* VCSbxDrawObject::GetControl()
{
	return pImpl->pControl;
}


