/*************************************************************************
 *
 *  $RCSfile: vcengin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if SUPD > 504
#define _VCENGIN_HXX
#endif


#ifndef _VCENGIN_HXX
#define _VCENGIN_HXX

class VCManager;
class VCForm;
class VCControl;
class Window;
class VCEdit;

#ifndef _POINTR_HXX //autogen
#include <vcl/pointr.hxx>
#endif
#ifndef _GDIOBJ_HXX //autogen
#include <vcl/gdiobj.hxx>
#endif
#ifndef _COLOR_HXX //autogen
#include <vcl/color.hxx>
#endif
#ifndef _TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _SVWINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif
#ifndef _SV_FLOATWIN_HXX //autogen
#include <vcl/floatwin.hxx>
#endif

#ifdef VCL
#ifndef _FONT_HXX //autogen
#include <vcl/font.hxx>
#endif
#endif
#ifndef _SI_NOVCSPINBTENG


#ifdef VCL
// Position & Groesse im MapMode des OutputDevices
void SiDrawBorder_Impl(OutputDevice*,const Point& rPos,const Size& rSize);
void SiDrawBtnBackground_Impl( OutputDevice* pOut, const Rectangle& rButtonRect,
								BOOL bButtonIn = FALSE );
#endif

//--------------------
// VCSpinButtonEngine
//--------------------
class VCSpinButtonEngine
{
private:

#ifdef _VCSPINENG_CXX
	DECL_LINK( Timeout, Timer * );
	void		DrawSpinButton( OutputDevice* pOut );
	void		DrawUpButton( OutputDevice* pOut );
	void		DrawDnButton( OutputDevice* pOut );
	Rectangle	GetUpRect( OutputDevice* pOut );
	Rectangle	GetDnRect( OutputDevice* pOut );
#endif

protected:
	Rectangle	aUpRect;
	Rectangle	aDnRect;
	Link		aSpinUpLink;
	Link		aSpinDownLink;
	Timer		aTimer;
	Point		aPos;
	Size		aSize;
	long 		nMin;
	long		nMax;
	long		nAct;
	long		nStep;
	Window*		pActWin;
	VCControl* 	pShell;
	BOOL		bEnable:1;
	BOOL		bUpIn:1;
	BOOL		bDnIn:1;
	BOOL		bUpHit:1;
	BOOL		bDnHit:1;
	BOOL		bCalcSizes:1;

public:
	VCSpinButtonEngine( VCControl* _pShell );
	~VCSpinButtonEngine();

	void 		SetPos( const Point& rPos );
	Point       GetPos() const { return aPos; }
	void		SetSize( const Size& rSize );
	Size		GetSize() const { return aSize; }

	void		Enable( BOOL bEnable = TRUE );
	BOOL		IsEnabled() const { return bEnable; }

	void		SetMin( long nMin );
	long        GetMin() const { return nMin; }
	void        SetMax( long nMax );
	long        GetMax() const { return nMax; }
	void		SetAct( long nAct );
	long        GetAct() const { return nAct; }
	void		SetStepSize( long nSize );
	long 		GetStepSize() const { return nStep; }

	void		SetSpinDownHdl( const Link& rLink ) { aSpinDownLink = rLink; }
	const Link&	GetSpinDownHdl() const { return aSpinDownLink; }
	void		SetSpinUpHdl( const Link& rLink ) { aSpinUpLink = rLink; }
	const Link&	GetSpinUpHdl() const { return aSpinUpLink; }

	void		Paint( OutputDevice* pOut );
	void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
};

#endif

#ifndef _SI_NOVCSCRBARENG

//-------------------
// VCScrollBarEngine
//-------------------
class VCScrollBarEngine
{
private:

#ifdef _VCSCROLLENG_CXX
	DECL_LINK( Timeout, Timer * );
	void		DrawBorder( OutputDevice* pOut );
	void		DrawPgDnRect( OutputDevice* pOut );
	void		DrawPgUpRect( OutputDevice* pOut );
	void		DrawScrollBar( OutputDevice* pOut );
	void		DrawUpButton( OutputDevice* pOut );
	void		DrawDnButton( OutputDevice* pOut );
	void		DrawThumb( OutputDevice* pOut );
	void		HideThumb( OutputDevice* pOut );
	Rectangle	GetUpRect( OutputDevice* pOut );
	Rectangle	GetDnRect( OutputDevice* pOut );
	Rectangle	GetThumbRect( OutputDevice* pOut );
	Rectangle	GetPgUpRect( OutputDevice* pOut );
	Rectangle	GetPgDnRect( OutputDevice* pOut );
	BOOL 		DisableUpDnButton();
#endif

protected:
	Rectangle   aUpRect;
	Rectangle   aDnRect;
	Rectangle	aThumbRect;
	Rectangle	aPgUpRect;
	Rectangle	aPgDnRect;
	Link		aScrollHdlLink;
	Link		aEndScrollHdlLink;
	Timer		aTimer;
	Point		aMDownPos;
	Point		aPos;
	Size		aSize;
	long		nMin;
	long        nMax;
	long        nAct;
	long		nLineSize;
	long		nPageSize;
	long		nVisibleSize; // wird noch nicht ausgewertet!
	long		nMDownThumbPos;
	Window*     pActWin;
	BOOL		bHorz:1;
	BOOL		bEnable:1;
	BOOL		bUpIn:1;
	BOOL		bDnIn:1;
	BOOL        bUpHit:1;
	BOOL        bDnHit:1;
	BOOL		bPgUpIn:1;
	BOOL		bPgDnIn:1;
	BOOL        bPgUpHit:1;
	BOOL        bPgDnHit:1;
	BOOL 		bThumbIn:1;
	BOOL		bThumbHit:1;
	BOOL		bCalcSizes:1;
	BOOL		bCalcThumb:1;
	BOOL		bInPaint:1;
	BOOL		bUpDisabled:1;
	BOOL		bDnDisabled:1;

public:
	VCScrollBarEngine( BOOL bHorz=FALSE );
	~VCScrollBarEngine();

	void 		SetPos( const Point& rPos );
	Point       GetPos() const { return aPos; }
	void		SetSize( const Size& rSize );
	Size		GetSize() const { return aSize; }

	static long GetOptWidth( OutputDevice* pOut, BOOL bHorz=FALSE );

	void		Enable( BOOL bEnable = TRUE );
	BOOL		IsEnabled() const { return bEnable; }

	BOOL		IsHorz() const { return bHorz; }

	void		SetMin( long nMin );
	long        GetMin() const { return nMin; }
	void        SetMax( long nMax );
	long        GetMax() const { return nMax; }
	// return TRUE: Pfeile muessen repaintet werden
	BOOL		SetAct( long nAct );
	long        GetAct() const { return nAct; }
	void		SetPageSize( long nSize );
	long 		GetPageSize() const { return nPageSize; }
	void		SetLineSize( long nSize );
	long	 	GetLineSize() const { return nLineSize; }

	void		SetScrollHdl( const Link& rLink ) { aScrollHdlLink = rLink; }
	const Link&	GetScrollHdl() const { return aScrollHdlLink; }
	void		SetEndScrollHdl( const Link& rLink ) { aEndScrollHdlLink = rLink; }
	const Link&	GetEndScrollHdl() const { return aEndScrollHdlLink; }

	Window*		GetActWin() const { return pActWin; }
	void		Paint( OutputDevice* pOut );
	void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
};

#endif

#ifndef _SI_NOVCLBOXENG

//-----------------
// VCListBoxEngine
//-----------------
class VCDropDownWindow;

enum VCListBoxStyle {VCLISTBOX_SINGLE,VCLISTBOX_MULTIPLE_S,
					 VCLISTBOX_MULTIPLE_E};

class VCListBoxEngine
{
friend class VCDropDownWindow;
private:
#ifdef _VCLBOXENG_CXX
	void		DrawBackground( OutputDevice* pOut );
	void		DrawBorder( OutputDevice* pOut );
	void		DrawEntries( OutputDevice* pOut, BOOL bErase=TRUE,
							 ULONG nFirst=0,
							 ULONG nLast=0xFFFFFFFF );
	Rectangle	GetClientRect( OutputDevice* pOut ) const;
	void		SelectFromPos( OutputDevice* pOut, const Point& rPos ,
							   const BOOL bShiftPressed = FALSE);
	void        UpdateScrollBar(void);

	DECL_LINK( Scroll, VCScrollBarEngine * );

	void		UnselectAll (void);

	BOOL		SelectionChanged (void);

	BOOL		OneEntryIsSelected (void);
	BOOL		AnEntryIsSelected (void);

	void        SelectListboxSingle (OutputDevice* pOut, ULONG nEntry);
	void 		SelectListboxMultipleS (OutputDevice* pOut, ULONG nEntry);
	void 		SelectListboxMultipleE (OutputDevice* pOut, ULONG nEntry,
										BOOL bShiftPressed, BOOL bDraw = TRUE);

	DECL_LINK( TimerHandler, Timer * );
#endif

protected:
	void				PositionScrollBar( OutputDevice* pOut );

	VCScrollBarEngine 	aScroll;
	long				nScrollWidth;
	Point			  	aPos;
	Size				aSize;
	List*				pList;
	List*				pSelectedList; // Boolsche Liste ob Element selektiert
	Font				aFont;
	ULONG       		nFirstVis;
	ULONG				nVisible;
	Window*				pActWin; // aktuelles Fenster (fuer Abfrage in Callback)
	Link				aSelectHdlLink;
	//ULONG				nNewIndex;
	Color				aForeColor;
	Color				aBackColor;
	VCListBoxStyle		eSelectStyle;
	ULONG				nLastSelected;
	ULONG				nButtonDownEntry;
	ULONG				nLastShiftEntry;
	Point				aLastMousePos;
	AutoTimer			aTimer;
	ULONG				nToMakeVisible;

	BOOL				bCaptureScroll:1;
	BOOL				bCaptureList:1;
	BOOL				bBorder:1;
	BOOL				bSelChanged:1;
	BOOL				bEnabled:1;
	BOOL				bMouseButtonDown:1;
	BOOL				bRecalcPageSize:1;
	BOOL				bSBarSizeValid:1;
	BOOL				bSBarPosValid:1;

public:
	VCListBoxEngine(void);
	~VCListBoxEngine(void);

	void 		SetPos( const Point& rPos );
	Point       GetPos(void) const { return aPos; }
	void		SetSize( const Size& rSize );
	Size		GetSize(void) const { return aSize; }

	void		SetBorder( BOOL bBorder );
	BOOL		HasBorder(void) const { return bBorder; }

	void		SetFont( const Font& rFont );
	Font		GetFont(void) const { return aFont; }

	void		SetForeColor( const Color& rCol );
	Color		GetForeColor(void) const { return aForeColor; }
	void		SetBackColor( const Color& rCol );
	Color		GetBackColor(void) const { return aBackColor; }

	void		Enable( BOOL bEnable=TRUE );
	BOOL        IsEnabled(void) const { return bEnabled; }

	void		SetList( List* pList );
	List*		GetList(void) const { return pList; }

	void		Clear(void);
	USHORT		InsertEntry( const String& rEntry, ULONG nPos );
	void		RemoveEntry( ULONG nPos );
	void		ReplaceEntry( const String& rNewEntry, ULONG nPos );

//	void		SetNewIndex( ULONG nNew ) { nNewIndex = nNew; }
//	ULONG		GetNewIndex(void) const { return nNewIndex; }

	void        SetFirstVisible( ULONG nFirst );
	ULONG       GetFirstVisible(void) const { return nFirstVis; }
	//-32000: Invalidieren
	short		MakeVisible( OutputDevice* pOut, ULONG nEntry );

	void		SetSelectHdl( const Link& rLink )
					{ aSelectHdlLink = rLink; }
	const Link&	GetSelectHdl(void) const { return aSelectHdlLink; }

	void		SetSelectEntry( ULONG nEntry, BOOL bSelect=TRUE );
	ULONG		GetSelectEntry( ULONG nSelIndex = 0 ) const;
	BOOL		IsEntrySelected( ULONG nPos ) const;

	Window*		GetActWin (void) const {return pActWin;}

	void		Paint( OutputDevice* pOut );
	void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );

	void 		SetSelectStyle (VCListBoxStyle eStyle);
	VCListBoxStyle GetSelectStyle (void) const {return eSelectStyle;}

	Size		GetOptSize( OutputDevice* pOut ) const;
	USHORT 		GetLineCount( OutputDevice* pOut ) const;
	Size		GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const;

	// ULONG_MAX == not found
	ULONG		FindEntry( const String& rPattern, ULONG nStartEntry ) const;
};

#endif


#ifndef _SI_NOVCEDENG

//--------------
// VCEditEngine
//--------------

class VCSingleEditEngine;
class VCMultiEditEngine;
class VCEditMapper;

class VCEditEngine
{
	friend class VCEditMapper;
	friend class VCSingleEditEngine;
	friend class VCMultiEditEngine;
private:
	// wird von Single- & MultiEdit gerufen
	void Modified();
	void GotFocus();
	void LostFocus();
	void Selected();
	VCEditMapper* CreateEditEngine();

protected:
	Point			aPos;
	Size			aSize;
	String			aText;
	String			aPassWordChar;
	Color			aBackColor;
	Color			aForeColor;
	Font			aFont;
	Link			aModifyHdlLink;
	Link			aGotFocusHdlLink;
	Link			aLostFocusHdlLink;
	Link			aSelectedHdlLink;
	VCEditMapper*	pCurEdit;
	VCControl*		pShell;
	USHORT			nAlignment;
	USHORT			nMaxLen;
	USHORT			nWordWrap;
	BOOL			bBorder:1;
	BOOL			bTransparent:1;
	BOOL			bMultiLine:1;
	BOOL			bMnemonic:1;
	BOOL			bActive:1;
	BOOL			bCenterVert:1;
	BOOL			bEnabled:1;
	BOOL			bReadOnly:1;

	static void		ConvertAmpersand( String* pStr );
	static void		DeleteAmpersand( String* pStr );
	static void		MakeVisible( VCEdit* pEngine );

public:
	// VCControl erforderlich fuer Tab-Steuerung
	VCEditEngine( VCControl* pShell, BOOL bMultiLineEdit = FALSE );
	~VCEditEngine();

	void		SetPos( const Point& rPos );
	Point		GetPos() const { return aPos; }
	void		SetSize( const Size& rSize );
	Size		GetSize() const { return aSize; }

	void		SetBorder( BOOL bSetBorder ) { bBorder = bSetBorder; }
	BOOL		HasBorder() const { return bBorder; }
	void		SetTransparent( BOOL bSetTrans ) { bTransparent = bSetTrans; }
	BOOL		IsTransparent() const { return bTransparent; }
	void		SetBackColor( const Color& rCol ) { aBackColor = rCol; }
	Color		GetBackColor() const { return aBackColor; }
	void		SetForeColor( const Color& rCol ) { aForeColor = rCol; }
	Color		GetForeColor() const { return aForeColor; }
	void		SetMnemonic( BOOL bSetMnemonic ) { bMnemonic = bSetMnemonic; }
	BOOL		HasMnemonic() const { return bMnemonic; }
	void		SetMultiLine( BOOL bMultiLine );
	BOOL		IsMultiLine() const { return bMultiLine; }
	// 1 == Rechtsbuendig  2 == Zentriert
	void		SetAlignment( USHORT nAlign ) { nAlignment = nAlign; }
	USHORT		GetAlignment() const { return nAlignment; }
	void		SetMaxLen( USHORT nMax ) { nMaxLen = nMax; }
	USHORT		GetMaxLen() const { return nMaxLen; }
	void		SetReadOnly( BOOL bRO ) { bReadOnly = bRO; }
	BOOL		IsReadOnly() const { return bReadOnly; }
	void		SetPassWordChar( const String& rStr ) { aPassWordChar = rStr; }
	String		GetPassWordChar() const { return aPassWordChar; }
	void		SetActive( BOOL bAct ) { bActive = bAct; }
	BOOL		IsActive() const { return bActive; }
	BOOL		IsEnabled() const { return bEnabled; }
	void		Enable( BOOL bEnable=TRUE ); // { bEnabled = bEnable; }
	void		SetCenterVert( BOOL bCenter ) { bCenterVert = bCenter; }
	BOOL		IsCenterVert() const { return bCenterVert; }
	void		SetFont( const Font& rFont ); // { aFont = rFont; }
	Font		GetFont() const { return aFont; }
	Size 		GetOptSize( OutputDevice* ) const;
	Size 		GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const;
	Size		GetCharCountXY( OutputDevice* pOut) const;

	void		SetModifyHdl( const Link& rLink ) { aModifyHdlLink = rLink; }
	const Link&	GetModifyHdl() const { return aModifyHdlLink; }
	void		SetGotFocusHdl( const Link& rLink ) { aGotFocusHdlLink = rLink; }
	const Link&	GetGotFocusHdl() const { return aGotFocusHdlLink; }
	void		SetLostFocusHdl( const Link& rLink ) { aLostFocusHdlLink = rLink; }
	const Link&	GetLostFocusHdl() const { return aLostFocusHdlLink; }
	void		SetSelectedHdl( const Link& rLink ) { aSelectedHdlLink = rLink; }
	const Link&	GetSelectedHdl() const { return aSelectedHdlLink; }

	Window*		GetEditWin() const;

	void		SetText( const String& rText );
	String		GetText();
	void		SetSelectStart( long nStart );
	long		GetSelectStart();
	void		SetSelectLen( long nLen );
	long		GetSelectLen() const;
	String		GetSelectText() const;
	void		SetSelectText( const String& rText );
	void	    Paint( OutputDevice* pOut );
	void 		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	void 		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	void 		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	void 		KeyInput( Window* pWindow, const KeyEvent& rKEvt );

	VCEdit*		FindNext( BOOL bReverse );
	void		Focus();
	void		Blur();

	BOOL		IsModified() const;
	void		SetModifyFlag( BOOL bModified );

	void		SetWordWrap( USHORT nMode );
	USHORT		GetWordWrap() const { return nWordWrap; }

	Pointer		GetPointer( const Point& ) const;
};

#endif

#ifndef _SI_NOVCDDWIN

//------------------
// VCDropDownWindow
//------------------
class VCDropDownWindow : public
#ifndef VCL
	WorkWindow
#else
	FloatingWindow
#endif
{
protected:
	Link			aLoseFocusHdlLink;
	Link			aSelectHdlLink;
	VCListBoxEngine aList;
	SvPtrarr		aAccelArr;
	Timer			aTravelTimer;
	String			aCurTravelStr;
	void**			pOwner;
	USHORT			nFlags;
	BOOL			bAccsRemoved:1;
	BOOL			bKeyReturnEnabled:1;

	void			LoseFocus();
	void			Resize();
	DECL_LINK( Select, VCListBoxEngine * );
	void			Paint( const Rectangle& rRect );
	void			MouseButtonDown( const MouseEvent& rMEvt );
	void			MouseButtonUp( const MouseEvent& rMEvt );
	void			MouseMove( const MouseEvent& rMEvt );
	void			InsertAcc();
					DECL_LINK( KeyInputHdl, Accelerator* );

public:
	VCDropDownWindow( Window* pParent, WinBits nStyle, void** pOwner );
	~VCDropDownWindow();

	void		SetLoseFocusHdl( const Link& rLink )
					{ aLoseFocusHdlLink = rLink; }
	const Link&	GetLoseFocusHdl() const { return aLoseFocusHdlLink; }

	void		SetSelectHdl( const Link& rLink )
					{ aSelectHdlLink = rLink; }
	const Link&	GetSelectHdl() const { return aSelectHdlLink; }

	void		SetFont( const Font& rFont ) { aList.SetFont( rFont ); }
	Font		GetFont() const { return aList.GetFont(); }
	void		SetForeColor( const Color& rCol ) { aList.SetForeColor( rCol ); }
	Color		GetForeColor() const { return aList.GetForeColor(); }
	void		SetBackColor( const Color& rCol ) { aList.SetBackColor( rCol ); }
	Color		GetBackColor() const { return aList.GetBackColor(); }
	void		SetList( List* pList ) { aList.SetList( pList ); }
	List*		GetList() const { return aList.GetList(); }
	void		SetFirstVisible( ULONG nFirst ) { aList.SetFirstVisible( nFirst ); }
	ULONG		GetFirstVisible() const { return aList.GetFirstVisible(); }
	void		MakeVisible( ULONG nEntry ) { aList.MakeVisible( this, nEntry ); }
	void		SetSelectEntry( ULONG nEntry ) { aList.SetSelectEntry( nEntry ); }
	ULONG		GetSelectEntry() const { return aList.GetSelectEntry(); }
	void		RemoveAcc();
};

#endif

#ifndef _SI_NOVCCOMBOENG

//----------------------
// VCComboBoxEngineBase
//----------------------
// Datencontainer & Handle-Klasse fuer DropDownListBox, ComboBox
// und DropDownComboBox
class VCComboBoxEngineBase
{
protected:
	VCEditEngine	aEditEngine;
	Color			aForeColor;
	Color			aBackColor;
	Link			aTextModifyHdlLink;
	Link			aSelectHdlLink;
	Link			aGotFocusHdlLink;
	Link			aLostFocusHdlLink;
	String			aText;
	Point			aPos;
	Size			aSize;
	Font			aFont;
	ULONG			nSelect;
	Window* 		pActWin;
	List*			pList;		// String-Liste
	BOOL			bEnabled:1;
	BOOL			bCalcSizes:1;

	void			Clear();

public:
					VCComboBoxEngineBase();
	virtual 		~VCComboBoxEngineBase();

	void 		 SetPos( const Point& rPos );
	Point        GetPos() const { return aPos; }
	void         SetSize( const Size& rSize );
	Size		 GetSize() const { return aSize; }

	void         SetFont( const Font& rFont );
	Font		 GetFont() const { return aFont; }

	virtual void SetForeColor( const Color& rCol );
	Color		 GetForeColor() const { return aForeColor; }
	virtual void SetBackColor( const Color& rCol );
	Color		 GetBackColor() const { return aBackColor; }

	void		 Enable( BOOL bEnable=TRUE );
	BOOL		 IsEnabled() const { return bEnabled; }

	virtual void SetList( List* pList );
	List*		 GetList() const { return pList; }

	virtual void SetText( const String& rText );
	String       GetText() const { return aText; }

	virtual void SetSelectEntry( ULONG nEntry );
	ULONG		 GetSelectEntry() const { return nSelect; }

	void		 SetTextModifyHdl( const Link& rLink ) { aTextModifyHdlLink = rLink; }
	const Link&	 GetTextModifyHdl() const { return aTextModifyHdlLink; }
	void		 SetSelectHdl( const Link& rLink ) { aSelectHdlLink = rLink; }
	const Link&	 GetSelectHdl() const { return aSelectHdlLink; }
	void		 SetGotFocusHdl( const Link& rLink ) { aGotFocusHdlLink = rLink; }
	const Link&	 GetGotFocusHdl() const { return aGotFocusHdlLink; }
	void		 SetLostFocusHdl( const Link& rLink ) { aLostFocusHdlLink = rLink; }
	const Link&	 GetLostFocusHdl() const { return aLostFocusHdlLink; }

	virtual Size GetOptSize( OutputDevice* pOut ) const;

	Window*	GetActWin() const { return pActWin; }
	Window* GetActiveEditWin() const { return aEditEngine.GetEditWin(); }

	virtual void Paint( OutputDevice* pOut );
	virtual void MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};


//-------------------
// VCDDListBoxEngine
//-------------------
// DropDownListBox, Wert kann nicht editiert werden
class VCDDListBoxEngine : public VCComboBoxEngineBase
{
private:

#ifdef _VCDDLBOX_CXX
	Rectangle	GetEditRect( OutputDevice* pOut ) const;
	Rectangle   GetButtonRect( OutputDevice* pOut ) const;
	void		DrawButton( OutputDevice* pOut );
	void		ShowHideDropWin( Window* pWin );
	DECL_LINK( DropWinLoseFocus, Window * );
	DECL_LINK( DropWinSelect, Window * );
	DECL_LINK( DestroyDropWin,Timer*);
#endif

protected:
	Rectangle			aEditRect;
	Rectangle			aBtnRect;
	BOOL				bBtnIn;
	VCDropDownWindow*	pDropWin;
	Timer				aDestroyDropWinTimer;
	VCControl*			pShell;

	void				ValidateEditText();

public:
	VCDDListBoxEngine( VCControl* pShell );
	~VCDDListBoxEngine();

	virtual void SetList( List* pList );
	virtual void SetSelectEntry( ULONG nEntry );
	virtual Size GetOptSize( OutputDevice* pOut ) const;

	virtual void SetForeColor( const Color& rCol );
	virtual void SetBackColor( const Color& rCol );

	virtual void Paint( OutputDevice* pOut );
	virtual void MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseMove( Window* pWindow, const MouseEvent& rMEvt );

	// HACK, da SelectEntryPos noch nicht funktioniert
	virtual void SetText( const String& rText );
};


//------------------
// VCComboBoxEngine
//------------------
// Editierfeld mit permanent ausgeklappter ListBox
class VCComboBoxEngine : public VCComboBoxEngineBase
{
private:
#ifdef _VCCBOXENG_CXX
	Rectangle		GetEditRect( OutputDevice* pOut ) const;
	Rectangle		GetListRect( OutputDevice* pOut ) const;

	DECL_LINK( ListSelect, VCListBoxEngine * );
	DECL_LINK( EditModify, VCEditEngine * );
#endif

protected:
	Rectangle		aEditRect;
	Rectangle		aListRect;
	VCListBoxEngine aListEngine;
	VCControl*		pShell;
	BOOL 			bCaptureEdit:1;
	BOOL			bCaptureList:1;
public:
	VCComboBoxEngine(VCControl* pShell);
	~VCComboBoxEngine();

	virtual void SetList( List* pList );
	virtual void SetSelectEntry( ULONG nEntry );
	virtual Size GetOptSize( OutputDevice* pOut ) const;

	virtual void SetText( const String& rText );

	virtual void SetForeColor( const Color& rCol );
	virtual void SetBackColor( const Color& rCol );

	virtual void Paint( OutputDevice* pOut );
	virtual void MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};


//-------------------
// VCDDComboBoxEngine
//-------------------
// Editierfeld mit ausklappbarer Listbox
class VCDDComboBoxEngine : public VCComboBoxEngineBase
{
private:

#ifdef _VCDDCBOXENG_CXX
	Rectangle	GetEditRect( OutputDevice* pOut ) const;
	Rectangle   GetButtonRect( OutputDevice* pOut ) const;
	void		DrawButton( OutputDevice* pOut );
	void		ShowHideDropWin( Window* pWin );
	DECL_LINK( DropWinLoseFocus, Window * );
	DECL_LINK( DropWinSelect, Window * );
	DECL_LINK( EditModify, VCEditEngine * );
	DECL_LINK( DestroyDropWin,Timer*);
#endif

protected:
	Timer				aDestroyDropWinTimer;
	Rectangle			aEditRect;
	Rectangle			aBtnRect;
	VCControl*			pShell;
	VCDropDownWindow*	pDropWin;
	BOOL				bCaptureEdit:1;
	BOOL				bBtnIn:1;

public:
	VCDDComboBoxEngine( VCControl* pShell );
	~VCDDComboBoxEngine();

	virtual void SetList( List* pList );
	virtual void SetSelectEntry( ULONG nEntry );
	virtual Size GetOptSize( OutputDevice* pOut ) const;

	virtual void SetText( const String& rText );

	virtual void SetForeColor( const Color& rCol );
	virtual void SetBackColor( const Color& rCol );

	virtual void Paint( OutputDevice* pOut );
	virtual void MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};

#endif



#endif //_VCENGIN_HXX
