/*************************************************************************
 *
 *  $RCSfile: vcengin2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_METRIC_HXX //autogen
#include <vcl/metric.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#pragma hdrstop


#define _VCLBOXENG_CXX
#define _VCDDLBOX_CXX
#define _VCCBOXENG_CXX
#define _VCDDCBOXENG_CXX
#include "vcengin.hxx"
#include "vceeng.hxx"
#include "sidll.hxx"
#ifndef _VCTRLS_HXX
#include "vctrls.hxx"
#endif
#ifndef VCONT_HXX
#include "vcont.hxx"
#endif

#include "vcattrid.hrc"

#ifndef VCL

#ifdef MAC
typedef long LONG ;
extern void SVE_SetMininimalWidth(PopupMenu* pMenu, long nWidth);
#endif
#ifdef UNX
typedef long LONG;
#include <stdio.h>
#endif

#endif

#define DDWIN_FLAG_MUP_REC	0x0001 // mousebuttonup received

static Size GetLongestLine( OutputDevice* pOut, const Font& rFont, List* pList )
{
	Font aTempFont( pOut->GetFont());
	pOut->SetFont( rFont );
	Size aSize;
	if( pList && pList->Count() )
	{
		ULONG nCount = pList->Count();
		for( ULONG nCurStr = 0; nCurStr < nCount; nCurStr++ )
		{
			String* pStr = (String*)(pList->GetObject( nCurStr ));
			Size aTempSize( pOut->GetTextSize( *pStr ) );
			if( aTempSize.Width() > aSize.Width())
				aSize = aTempSize;
		}
	}
	else
	{
		String aStr("WWWWWWWWWWWWWWW");
		aSize = pOut->GetTextSize( aStr );
	}

	pOut->SetFont( aTempFont );
	return aSize;
}

#ifndef VCL

void VCListBoxEngine::DrawBorder( OutputDevice* pOut )
{
	if( bBorder )
	{
#if defined UNX
		Pen aOldPen = pOut->GetPen();

		Color a3DShadowColor( COL_BLACK ); // COL_3DSHADOW );
		Color a3DLightColor( COL_BLACK ); // COL_3DLIGHT );
		Pen a3DShadowPen2( a3DShadowColor, 2 );
		Pen a3DLightPen2( a3DLightColor, 2 );
		pOut->SetPen( a3DShadowPen2 );
		// vertical shadow
		pOut->DrawLine( aPos,
						Point( aPos.X(), aPos.Y()+aSize.Height() ) );
		// horizontal shadow
		pOut->DrawLine( aPos,
						Point( aPos.X()+aSize.Width(), aPos.Y() ) );
		pOut->SetPen( a3DLightPen2 );
		// vertical anti-shadow
		pOut->DrawLine( Point( aPos.X()+aSize.Width(), aPos.Y()+1 ),
						Point( aPos.X()+aSize.Width(),
							   aPos.Y()+aSize.Height() ) );
		// horizontal anti-shadow
		pOut->DrawLine( Point( aPos.X()+1, aPos.Y()+aSize.Height() ),
						Point( aPos.X()+aSize.Width(), aPos.Y()+aSize.Height() ) );

		pOut->SetPen( aOldPen );
#else
#ifdef OS2
		Color aCol( COL_3DSHADOW );
#else
		Color aCol;
#endif
		Pen   aPen( aCol );
		Pen   aOldPen   = pOut->GetPen();
		pOut->SetPen( aPen );
		Brush aOldBrush = pOut->GetFillInBrush( );
		pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

		pOut->DrawRect( Rectangle( aPos, aSize ) );

		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
#endif
	}
}
#else

void VCListBoxEngine::DrawBorder( OutputDevice* pOut )
{
	if( bBorder )
		SiDrawBorder_Impl( pOut, aPos, aSize );
}

#endif

void VCListBoxEngine::DrawBackground( OutputDevice* pOut )
{
	Pen   aOldPen   = pOut->GetPen();
	pOut->SetPen( Pen( PEN_NULL ) );
	Brush aOldBrush = pOut->GetFillInBrush();
	pOut->SetFillInBrush( Brush( aBackColor ) );

	pOut->DrawRect( Rectangle( aPos, aSize ) );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

void VCListBoxEngine::DrawEntries( OutputDevice* pOut, BOOL bErase,
								   ULONG nFirst, ULONG nLast )
{
	if( !pList || !pList->Count())
		return;

	Rectangle aRect = GetClientRect( pOut );
	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
	Size aSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );

	aRect.Left()  += 3*aSize.Width();
	aRect.Top()   += 3*aSize.Height();
	aRect.Right() -= 3*aSize.Width();
	aRect.Bottom()-= 3*aSize.Height();
	Point aTextPos  = aRect.TopLeft();

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	pOut->IntersectClipRegion( aRect );

	Font   aTempFont  = aFont;
	aTempFont.SetTransparent( TRUE );
	aTempFont.SetColor( aForeColor );

	Font   aOldFont   = pOut->GetFont();
	pOut->SetFont( aTempFont );

	Size aDevFontSize = pOut->GetTextSize( String() );
#ifndef MAC
	long nDiff        = aDevFontSize.Height() - aFont.GetSize().Height();
	if( nDiff > (aFont.GetSize().Height() / 5) )
	{
		// Wenn der Font auf dem OutputDevice mehr als 20% groesser als
		// der gewuenschte Font ist, dann versuchen wir was anderes als
		// Bitmap-Fonts

		aTempFont.SetName( String() );
		aTempFont.SetFamily( FAMILY_SWISS );
		pOut->SetFont( aTempFont );
		aDevFontSize = pOut->GetTextSize( String() );
	}
#endif

	nVisible = aRect.GetSize().Height() / aDevFontSize.Height();
	if( nToMakeVisible != 0xffffffff )
	{
		MakeVisible( pOut, nToMakeVisible );
		nToMakeVisible = 0xffffffff;
	}

	Brush  aOldBrush  = pOut->GetFillInBrush();
	Pen    aOldPen    = pOut->GetPen();
	Brush aOldBack = pOut->GetBackgroundBrush( );
	pOut->SetBackgroundBrush( Brush( aBackColor ) );

	ULONG i;
	String* pStr;
	for( i=nFirstVis; i < pList->Count(); i++ )
	{
		long nEnd = aTextPos.Y();
		if( pOut->GetOutDevType() == OUTDEV_PRINTER )
			nEnd += aDevFontSize.Height();

		if( (i > nLast) ||
			(nEnd > aRect.Bottom()) )
				break;

		if( i >= nFirst )
		{
			pStr = (String*)pList->GetObject(i);

			Rectangle aEntryRect( aTextPos,
									Size( aRect.GetSize().Width(),
										  aDevFontSize.Height() ) );

			// Hintergrund loeschen
			if( bErase && !IsEntrySelected(i) )
			{
				Brush aBrush( aBackColor );
				pOut->SetFillInBrush( aBrush );
				pOut->SetPen( Pen( PEN_NULL ) );

				pOut->DrawRect( aEntryRect );
			}

			if(IsEntrySelected(i) && bEnabled )
			{
				Brush aBrush;
				Color aCol;
				if( pOut->GetOutDevType() != OUTDEV_PRINTER )
				{
#ifndef VCL
					aCol = Color( COL_HIGHLIGHTTEXT );
					aBrush.SetColor( Color( COL_HIGHLIGHT ) );
#else
					const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
					aCol = rSettings.GetHighlightTextColor();
					aBrush.SetColor( rSettings.GetHighlightColor() );
#endif

				}
				else
				{
					aCol = Color( COL_WHITE );
					aBrush.SetColor( Color() );
				}

				pOut->SetFillInBrush( aBrush );
				pOut->SetPen( Pen( PEN_NULL ) );
				pOut->DrawRect( aEntryRect );

				Color aOldCol = aTempFont.GetColor( );
				aTempFont.SetColor( aCol );
				pOut->SetFont( aTempFont );

				pOut->DrawText( aTextPos, *pStr );

				aTempFont.SetColor( aOldCol );
				pOut->SetFont( aTempFont );

			}
			else
			{
				if( pOut->GetOutDevType() != OUTDEV_PRINTER )
				{
					USHORT nFlags = !bEnabled ? CTRLTEXT_DRAW_DISABLE : CTRLTEXT_DRAW_ENABLE;
					((Window*)pOut)->DrawCtrlText( aTextPos, *pStr, 0, STRING_LEN, nFlags );
				}
				else
					pOut->DrawText( aTextPos, *pStr );
			}

		}
		aTextPos.Y() += aDevFontSize.Height();
	}

	UpdateScrollBar();

	pOut->SetBackgroundBrush( aOldBack );

	// Bis unten loeschen
	if( bErase && (nLast == 0xFFFFFFFF) )
	{
		if( aTextPos.Y() <= aRect.Bottom() )
		{
			Rectangle aBottomRect( aTextPos.X(), aTextPos.Y(),
								   aRect.Right(), aRect.Bottom() );

			Brush aBrush( aBackColor );
			pOut->SetFillInBrush( aBrush );
			pOut->SetPen( Pen( PEN_NULL ) );

			pOut->DrawRect( aBottomRect );
		}
	}

	pOut->SetFont( aOldFont );
	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

Rectangle VCListBoxEngine::GetClientRect( OutputDevice* pOut ) const
{
	((VCListBoxEngine*)this)->PositionScrollBar( pOut );
	Rectangle aRect( aPos, aSize );

	if( (aRect.GetSize().Width()<2) || (aRect.GetSize().Height()<2) )
		return aRect;

	Size aOfs = pOut->PixelToLogic( Size( 1, 1 ) );
	if( bBorder )
	{
		aRect.Left() 	+= aOfs.Width();
		aRect.Top()  	+= aOfs.Height();
		aRect.Right()   -= aOfs.Width();
		aRect.Bottom()  -= aOfs.Height();
	}

	if( aRect.GetSize().Width() > nScrollWidth )
	{
		if( !bBorder )
			aRect.Right() -= aOfs.Width();

		aRect.Right() -= nScrollWidth;
	}

	return aRect;
}

void VCListBoxEngine::SelectFromPos( OutputDevice* pOut, const Point& rPos,
									 const BOOL bShiftPressed )
{
	DBG_ASSERT(pList,"VCListBoxEngine: Keine Liste");
	Rectangle aRect = GetClientRect( pOut );

	ULONG nEntry;
	long nY = rPos.Y() - aRect.Top();

	if( nY < 0L )
		nY = 0;
	else
	if( nY >= aRect.GetSize().Height() )
		nY = aRect.GetSize().Height()-1;

	Font aTempFont = aFont;
	Font aOldFont = pOut->GetFont( );
	pOut->SetFont( aFont );
	Size aDevFontSize = pOut->GetTextSize( String() );
#ifndef MAC
	long nDiff        = aDevFontSize.Height() - aFont.GetSize().Height();
	if( nDiff > (aFont.GetSize().Height() / 5) )
	{
		// Wenn der Font auf dem OutputDevice mehr als 20% groesser als
		// der gewuenschte Font ist, dann versuchen wir was anderes als
		// Bitmap-Fonts
		aTempFont.SetName( String() );
		aTempFont.SetFamily( FAMILY_SWISS );
		pOut->SetFont( aTempFont );
		aDevFontSize = pOut->GetTextSize( String() );
	}
#endif
	pOut->SetFont( aOldFont );

	nEntry = (nY / aDevFontSize.Height()) + nFirstVis;
	if( pList->Count() )
	{
		if( nEntry >= pList->Count() )
			nEntry = pList->Count()-1;
	}

	switch (eSelectStyle)
	{
		case VCLISTBOX_SINGLE :
			SelectListboxSingle(pOut,nEntry);
			break;

		case VCLISTBOX_MULTIPLE_S :
			SelectListboxMultipleS(pOut,nEntry);
			break;

		case VCLISTBOX_MULTIPLE_E :
			SelectListboxMultipleE(pOut,nEntry,bShiftPressed);
			break;
	}
}

IMPL_LINK( VCListBoxEngine, TimerHandler, Timer *, EMPTYARG )
{
	BOOL bTimerStop = TRUE;

	if (bCaptureList)
	{
		if (aLastMousePos.Y() > GetPos().Y() + GetSize().Height())
		{
			// Scroll down
			 if (nFirstVis + nVisible < pList -> Count())
			 {
				nFirstVis++;
				switch (eSelectStyle)
				{
					case VCLISTBOX_SINGLE :
						SetSelectEntry(nFirstVis + nVisible);
						break;

					case VCLISTBOX_MULTIPLE_E :
						SelectListboxMultipleE(pActWin,nFirstVis + nVisible,
											   TRUE,FALSE);
						break;
				}
				DrawEntries( pActWin );
				aScroll.SetAct(aScroll.GetAct() + 1);
				aScroll.Paint(pActWin);
				bTimerStop = FALSE;
			 }
		}

		if (aLastMousePos.Y() < GetPos().Y())
		{
			// Scroll up
			if (nFirstVis > 0)
			{
				nFirstVis--;
				switch (eSelectStyle)
				{
					case VCLISTBOX_SINGLE :
						SetSelectEntry(nFirstVis);
						break;

					case VCLISTBOX_MULTIPLE_E :
						SelectListboxMultipleE(pActWin,nFirstVis,TRUE,FALSE);
						break;
				}
				DrawEntries( pActWin );
				aScroll.SetAct(aScroll.GetAct() - 1);
				aScroll.Paint(pActWin);
				bTimerStop = FALSE;
			 }
		}
	}

	if (bTimerStop)
	{
		aTimer.Stop();
	}
	return 0;
}

void VCListBoxEngine::UpdateScrollBar()
{
	if( pList && pList->Count() )
	{
		if( pList->Count() > nVisible )
		{
			aScroll.SetMax( pList->Count() - nVisible );
			aScroll.SetAct( nFirstVis );
			aScroll.Enable();
			return;
		}
		else
		if( nFirstVis )
		{
			aScroll.SetMax( nFirstVis );
			aScroll.SetAct( nFirstVis );
			aScroll.Enable();
			return;
		}
	}

	aScroll.Enable(FALSE);
}

IMPL_LINK_INLINE_START( VCListBoxEngine, Scroll, VCScrollBarEngine *, EMPTYARG )
{
	nFirstVis = aScroll.GetAct();
	DrawEntries( pActWin );
	return 0;
}
IMPL_LINK_INLINE_END( VCListBoxEngine, Scroll, VCScrollBarEngine *, EMPTYARG )

void VCListBoxEngine::UnselectAll (void)
{
	if (!pSelectedList)
		return;

	for (ULONG i = 0; i < pSelectedList->Count(); i++)
		pSelectedList->Replace(NULL,i);
}

BOOL VCListBoxEngine::SelectionChanged (void)
{
	return bSelChanged;
}

BOOL VCListBoxEngine::OneEntryIsSelected (void)
{
	ULONG nCounter = 0;

	if (pSelectedList)
		for (ULONG i = 0; i < pSelectedList->Count(); i++)
			if (pSelectedList->GetObject(i))
				nCounter++;
	if (nCounter == 1)
		return TRUE;
	else
		return FALSE;
}

BOOL VCListBoxEngine::AnEntryIsSelected (void)
{

	if (pSelectedList)
		for (ULONG i = 0; i < pSelectedList->Count(); i++)
			if (pSelectedList->GetObject(i))
				return TRUE;

	return FALSE;
}

void VCListBoxEngine::SelectListboxSingle (OutputDevice* pOut, ULONG nEntry)
{
	if( !pList || nEntry >= pList->Count() )
		return;

	if( !IsEntrySelected(nEntry))
	{
		ULONG nOldSelect = GetSelectEntry();
		SetSelectEntry(nOldSelect,FALSE);
		SetSelectEntry(nEntry);
		DrawEntries( pOut, TRUE, nOldSelect, nOldSelect );
		DrawEntries( pOut, FALSE, nEntry, nEntry );
	}
}

void VCListBoxEngine::SelectListboxMultipleS (OutputDevice* pOut, ULONG nEntry)
{
	if( !IsEntrySelected(nEntry))
	{
		SetSelectEntry(nEntry);
		DrawEntries( pOut, FALSE, nEntry, nEntry );
		nButtonDownEntry = nLastShiftEntry = nEntry;
	}
	else
	{
		SetSelectEntry(nEntry,FALSE);
		DrawEntries( pOut, TRUE, nEntry, nEntry );
	}
}

void VCListBoxEngine::SelectListboxMultipleE (OutputDevice* pOut, ULONG nEntry,
											  BOOL bShiftPressed, BOOL bDraw)
{
	if (bMouseButtonDown)
	{
		if (bShiftPressed && AnEntryIsSelected())
		{
			// 1. Fall: an die bestehende Auswahl werden ein oder
			// mehrere Eintraege gehaengt.

			if (nEntry >= nLastShiftEntry &&
				nLastShiftEntry >= nButtonDownEntry)
			{
				for (ULONG i = nLastShiftEntry + 1; i <= nEntry; i++)
					SetSelectEntry(i);
				if (bDraw)
					DrawEntries( pOut, FALSE, nLastShiftEntry + 1, nEntry );
				goto done;
			}

			if (nEntry < nLastShiftEntry &&
				nLastShiftEntry <= nButtonDownEntry)
			{
				for (ULONG i = nEntry; i < nLastShiftEntry; i++)
					SetSelectEntry(i);
				if (bDraw)
					DrawEntries( pOut, FALSE, nEntry, nLastShiftEntry - 1 );
				goto done;
			}

			// 2. Fall: von der bestehenden Auswahl werden ein oder
			// mehrere Eintraege geloescht.

			if (nEntry < nLastShiftEntry &&
				nEntry >= nButtonDownEntry)
			{
				for (ULONG i = nEntry + 1; i <= nLastShiftEntry; i++)
					SetSelectEntry(i,FALSE);
				if (bDraw)
					DrawEntries( pOut, TRUE, nEntry + 1, nLastShiftEntry );
				goto done; // jaja
			}

			if (nEntry > nLastShiftEntry &&
				nEntry <= nButtonDownEntry)
			{
				for (ULONG i = nLastShiftEntry; i < nEntry; i++)
					SetSelectEntry(i,FALSE);
				if (bDraw)
					DrawEntries( pOut, TRUE, nLastShiftEntry, nEntry - 1);
				goto done; // jaja
			}

			// 3. Fall: Die Richtung wurde gewechselt.

			if (nLastShiftEntry > nButtonDownEntry &&
				nEntry < nButtonDownEntry )
			{
				ULONG i;

				for (i = nButtonDownEntry + 1; i <= nLastShiftEntry; i++)
					SetSelectEntry(i,FALSE);
				if (bDraw)
					DrawEntries( pOut, TRUE, nButtonDownEntry + 1, nLastShiftEntry );

				for (i = nEntry; i < nButtonDownEntry; i++)
					SetSelectEntry(i);
				if (bDraw)
					DrawEntries( pOut, FALSE, nEntry, nButtonDownEntry - 1);

				goto done;
			}

			if (nLastShiftEntry < nButtonDownEntry &&
				nEntry > nButtonDownEntry)
			{
				ULONG i;

				for (i = nLastShiftEntry; i < nButtonDownEntry; i++)
					SetSelectEntry(i,FALSE);
				if (bDraw)
					DrawEntries( pOut, TRUE, nLastShiftEntry, nButtonDownEntry - 1 );

				for (i = nButtonDownEntry + 1; i <= nEntry; i++)
					SetSelectEntry(i);
				if (bDraw)
					DrawEntries( pOut, FALSE, nButtonDownEntry + 1, nEntry);
			}

			done :
			nLastShiftEntry = nEntry;
		}
		else
		{
			if (!IsEntrySelected(nEntry) || !OneEntryIsSelected())
			{
				UnselectAll();
				if (pList)
					DrawEntries( pOut, TRUE, 0, pList->Count() );
				SetSelectEntry(nEntry);
				DrawEntries( pOut, FALSE, nEntry, nEntry );
			}
			nButtonDownEntry = nLastSelected = nLastShiftEntry = nEntry;
		}
	}
	else  // !bMouseButtonDown
	{
		if (IsEntrySelected(nEntry))
		{
			if (nLastSelected != nEntry)
			{
				long i;
				if (nLastSelected < nEntry)
				{
					for (i = nLastSelected; i < (long)nEntry; i++)
						SetSelectEntry(i,FALSE);
					DrawEntries( pOut, TRUE, nLastSelected, nEntry - 1 );
					nLastSelected = nEntry + 1;
				}
				else
				{
					for (i = nLastSelected; i > (long)nEntry; i--)
						SetSelectEntry(i,FALSE);
					DrawEntries( pOut, TRUE, nEntry + 1, nLastSelected );
					nLastSelected = nEntry - 1;
				}

				if (nButtonDownEntry != nEntry)
				{
					SetSelectEntry(nEntry,FALSE);
					DrawEntries( pOut, TRUE, nEntry, nEntry );
				}
				else
					nLastSelected = nEntry;

			}

		}
		else
		{
			long i;
			if (nLastSelected < nEntry)
			{
				for (i = nLastSelected; i < (long)nButtonDownEntry; i++)
					SetSelectEntry(i,FALSE);
				DrawEntries( pOut, TRUE, nLastSelected, nButtonDownEntry - 1 );
				for (i = nButtonDownEntry + 1; i < (long)nEntry; i++)
					SetSelectEntry(i);
				DrawEntries( pOut, FALSE, nButtonDownEntry + 1, nEntry - 1 );
			}
			else
			{
				for (i = nLastSelected; i > (long)nButtonDownEntry; i--)
					SetSelectEntry(i,FALSE);
				DrawEntries( pOut, TRUE, nButtonDownEntry + 1, nLastSelected );
				for (i = nButtonDownEntry - 1 ; i > (long)nEntry; i--)
					SetSelectEntry(i);
				DrawEntries( pOut, FALSE, nEntry + 1, nButtonDownEntry - 1 );
			}
			SetSelectEntry(nEntry);
			DrawEntries( pOut, FALSE, nEntry, nEntry );
			nLastSelected = nEntry;
		}
	}
}

VCListBoxEngine::VCListBoxEngine() :
	nScrollWidth(0),
	bCaptureScroll(FALSE),
	bCaptureList(FALSE),
	pList(NULL),
	pSelectedList(NULL),
	bBorder(FALSE),
	nFirstVis(0),
	nVisible(0),
	pActWin(NULL),
	bSelChanged(FALSE),
	bEnabled(TRUE),
	aForeColor( COL_BLACK ),
	aBackColor( COL_WHITE ),
	eSelectStyle(VCLISTBOX_SINGLE),
	bMouseButtonDown(FALSE),
	nButtonDownEntry(0),
	nLastShiftEntry(0),
	aLastMousePos(0,0),
	bRecalcPageSize(TRUE),
	bSBarSizeValid(FALSE),
	bSBarPosValid(FALSE),
	nToMakeVisible( 0xffffffff )
{
	aTimer.SetTimeout(10);
	aTimer.SetTimeoutHdl(LINK(this,VCListBoxEngine,TimerHandler));
	aScroll.SetScrollHdl( LINK( this, VCListBoxEngine, Scroll ) );
}

VCListBoxEngine::~VCListBoxEngine()
{
	Clear();
}

void VCListBoxEngine::SetPos( const Point& rPos )
{
//	if( aPos != rPos )  //muss getestet werden!
//	{
		aPos = rPos;
		bSBarPosValid = FALSE;
		/*
		Point aScrPos = aPos;
		aScrPos.X() = (aPos.X() + aSize.Width()-1) - nScrollWidth;
		aScroll.SetPos( aScrPos );
		*/
//	}
}

void VCListBoxEngine::SetSize( const Size& rSize )
{
//	if( aSize != rSize )
//	{
		aSize = rSize;

		/*
		Point aScrPos = aPos;
		aScrPos.X() = (aPos.X() + aSize.Width()-1) - nScrollWidth;
		aScroll.SetPos( aScrPos );

		Size aScrSize = aScroll.GetSize();
		aScrSize.Height() = rSize.Height();
		aScrSize.Width()  = nScrollWidth;
		aScroll.SetSize( aScrSize );
		*/

		bSBarSizeValid = FALSE;
		bRecalcPageSize = TRUE;
//	}

}

void VCListBoxEngine::PositionScrollBar( OutputDevice* pOut )
{
	if( !bSBarSizeValid || !bSBarPosValid )
	{
		nScrollWidth = aScroll.GetOptWidth( pOut );
		Rectangle aRect( aPos, aSize );
		Size aPix( pOut->PixelToLogic( Size(1,1)) );
		// Border ab
		aRect.Right() -= 2*aPix.Width();
		aRect.Top() += 2*aPix.Height();
		aRect.Bottom() -= 2*aPix.Height();
		aRect.Left() = aRect.Right() - nScrollWidth;

		aScroll.SetPos( aRect.TopLeft() );
		aScroll.SetSize( aRect.GetSize() );

		bSBarSizeValid = TRUE;
		bSBarPosValid = TRUE;
	}
}

void VCListBoxEngine::SetBorder( BOOL bBorder_ )
{
	bBorder = bBorder_;
	bRecalcPageSize = TRUE;
}

void VCListBoxEngine::SetFont( const Font& rFont )
{
	aFont = rFont;
	bRecalcPageSize = TRUE;
}

// ULONG_MAX == not found
ULONG VCListBoxEngine::FindEntry( const String& rPattern, ULONG nStartEntry ) const
{
	if( !pList || !pList->Count() )
		return ULONG_MAX;

	ULONG nCount = pList->Count();
	if( nStartEntry >= nCount )
		nStartEntry = 0; // round robin

	ULONG nCompareCount = nCount;
	while( nCompareCount )
	{
		String* pStr = (String*)pList->GetObject( nStartEntry );
		if( pStr )
		{
			if( pStr->ICompare( rPattern, rPattern.Len() ) == COMPARE_EQUAL)
				return nStartEntry;
		}
		nStartEntry++;
		if( nStartEntry >= nCount )
			nStartEntry = 0;

		nCompareCount--;
	}
	return ULONG_MAX;
}

void VCListBoxEngine::SetForeColor( const Color& rColor )
{
	aForeColor = rColor;
}

void VCListBoxEngine::SetBackColor( const Color& rColor )
{
	aBackColor = rColor;
}

void VCListBoxEngine::Enable( BOOL bEnable )
{
	bEnabled = bEnable;
	UpdateScrollBar();
}

void VCListBoxEngine::SetList( List* pNewList )
{
	Clear();

	if( !pNewList || !pNewList->Count() )
	{
		aScroll.Enable(FALSE);
	}
	else
	{
		pList = new List;
		pSelectedList = new List;
		ULONG i;
		for( i=0; i < pNewList->Count(); i++ )
		{
			pList->Insert( new String( *((String*)pNewList->GetObject(i)) ), LIST_APPEND );
			pSelectedList->Insert (NULL, LIST_APPEND);
		}

		if( nFirstVis >= pList->Count() )
			nFirstVis = pList->Count()-1;
	}
}

void VCListBoxEngine::Clear()
{
	if( pList )
	{
		ULONG i;
		for( i=0; i < pList->Count(); i++ )
			delete (String*)pList->GetObject( i );

		delete pList;
		pList = NULL;
	}

	if( pSelectedList )
	{
		delete pSelectedList;
		pSelectedList = NULL;
	}
}

USHORT VCListBoxEngine::InsertEntry( const String& rEntry, ULONG nPos )
{
	if( !pList )
		pList = new List;

	if (!pSelectedList)
		pSelectedList = new List;

	pList->Insert( new String( rEntry ), nPos );
	pSelectedList->Insert(NULL,nPos);
	return (USHORT)nPos;
}

void VCListBoxEngine::RemoveEntry( ULONG nPos )
{
	if( !pList )
		return;

	delete (String*)(pList->Remove( nPos ));
	pSelectedList->Remove(nPos);
}

void VCListBoxEngine::ReplaceEntry( const String& rEntry, ULONG nPos )
{
	if( !pList )
		pList = new List;

	delete (String*)(pList->Replace( new String( rEntry ), nPos ));
}

void VCListBoxEngine::SetFirstVisible( ULONG nFirst )
{
	if( !pList || !pList->Count() || !nVisible || nFirst >= pList->Count() )
	{
		nFirstVis = 0;
		return;
	}

	nFirstVis = 0;
	ULONG nCount = pList->Count();
	if( nFirst >= nCount )
		nFirst = nCount - 1;

	for( USHORT nStart = 0; nStart < nCount; nStart++ )
	{
		if( nStart <= nFirst && nStart + nVisible >= nFirst )
		{
			nFirstVis = nStart;
			break;
		}
	}
}

short VCListBoxEngine::MakeVisible( OutputDevice* pOut, ULONG nEntry )
{
	if( !pList || !pList->Count() || !nVisible || nEntry >= pList->Count() )
	{
		nToMakeVisible = nEntry;
		return 0;
	}
	nToMakeVisible = 0xffffffff;

	ULONG nCount = pList->Count();
	ULONG nLineCount = (ULONG)GetLineCount( pOut );
	if( nEntry >= nFirstVis && nEntry < nFirstVis + nLineCount )
		return 0;

	if( nEntry < nFirstVis )
		nFirstVis = nEntry;
	else
	{
		do
		{
			nFirstVis++;
		} while( nEntry > nFirstVis + nLineCount - 1);
	}
	aScroll.SetAct( nFirstVis );
	return -32000;
}

void VCListBoxEngine::SetSelectEntry( ULONG nEntry, BOOL bSelect )
{
	if (pList && nEntry < pList->Count())
	{
		if (IsEntrySelected(nEntry))
		{
			if (!bSelect)
				bSelChanged = TRUE;
		}
		else
		{
			if (bSelect)
				bSelChanged = TRUE;
		}

		if (eSelectStyle == VCLISTBOX_SINGLE)
		{
			ULONG nSelect = GetSelectEntry();
			pSelectedList->Replace(NULL,nSelect);
		}
		if (bSelect)
			pSelectedList->Replace((void *) 1L,nEntry);
		else
			pSelectedList->Replace(NULL,nEntry);


	}
}

ULONG VCListBoxEngine::GetSelectEntry( ULONG nSelIndex ) const
{
	if (pSelectedList && nSelIndex < pSelectedList->Count())
	{
		ULONG nCounter = 0;
		for (ULONG i = 0; i < pSelectedList->Count(); i++)
			if (pSelectedList->GetObject(i))
			{
				if (nCounter == nSelIndex)
					return i;
				nCounter++;
			}
	}
	return 0xffffffff;
}

BOOL VCListBoxEngine::IsEntrySelected( ULONG nPos ) const
{
	if (pSelectedList && nPos < pSelectedList->Count())
	{
		if (pSelectedList->GetObject(nPos))
			return TRUE;
		else
			return FALSE;
	}
	else
		return FALSE;
}

void VCListBoxEngine::Paint( OutputDevice* pOut )
{
	PositionScrollBar( pOut );

	if( bRecalcPageSize )
	{
		Size aTextSize = pOut->GetTextSize( "X" );
		long nPageSize = aSize.Height() / aTextSize.Height();
		aScroll.SetPageSize( nPageSize );
	}
	bRecalcPageSize = FALSE;

	DrawBackground( pOut );
	DrawBorder( pOut );
	DrawEntries( pOut );

	if( aSize.Width() > nScrollWidth )
		aScroll.Paint( pOut );
}

void VCListBoxEngine::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWin = pWindow;
	pWindow->CaptureMouse();
	if( pList && pList->Count() && rMEvt.IsLeft() )
	{
		Point aPos = rMEvt.GetPosPixel();
		Rectangle aScrollRect( aScroll.GetPos(), aScroll.GetSize() );

		if( aScrollRect.IsInside( aPos ) )
		{
			bCaptureScroll = TRUE;
			aScroll.MouseButtonDown( pWindow, rMEvt );
		}
		else
		{
			Rectangle aRect = GetClientRect( pWindow );
			if( aRect.IsInside(aPos))
			{
				BOOL bStyleChanged = FALSE;
				bCaptureList = bMouseButtonDown = TRUE;
				pWindow->CaptureMouse();
				if (rMEvt.IsMod1() && eSelectStyle == VCLISTBOX_MULTIPLE_E)
				{
					eSelectStyle = VCLISTBOX_MULTIPLE_S;
					bStyleChanged = TRUE;
				}
				SelectFromPos( pWindow, rMEvt.GetPosPixel(), rMEvt.IsShift() );
				bSelChanged = SelectionChanged();
				bMouseButtonDown = FALSE;
				if (bStyleChanged)
				{
					eSelectStyle = VCLISTBOX_MULTIPLE_E;
				}
			}
		}
	}
}

void VCListBoxEngine::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	if (rMEvt.IsLeft())
	{
		if( bCaptureScroll )
		{
			bCaptureScroll = FALSE;
			aScroll.MouseButtonUp( pWindow, rMEvt );
		}
		else
		if( bCaptureList )
		{
			bCaptureList = FALSE;
			pWindow->ReleaseMouse();
			if( aSelectHdlLink.IsSet() && bSelChanged )
			{
				aSelectHdlLink.Call( this );
				bSelChanged = FALSE;
			}
			else
				pWindow->CaptureMouse();
		}
	}
	pActWin = NULL;
}

void VCListBoxEngine::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	if (rMEvt.IsLeft())
	{
		if( bCaptureScroll )
			aScroll.MouseMove( pWindow, rMEvt );
		else
		if( bCaptureList )
		{
			BOOL bTimerStart = FALSE;
			aLastMousePos = rMEvt.GetPosPixel();
			if (aLastMousePos.Y() > GetPos().Y() + GetSize().Height())
			{
				// Scroll down;
				if (nFirstVis + nVisible < pList -> Count())
				{
					nFirstVis++;
					switch (eSelectStyle)
					{
						case VCLISTBOX_SINGLE :
							SetSelectEntry(nFirstVis + nVisible);
							break;

						case VCLISTBOX_MULTIPLE_E :
							SelectListboxMultipleE(pActWin,nFirstVis + nVisible,
												   TRUE,FALSE);
							break;
					}
					DrawEntries( pActWin );
					aScroll.SetAct(aScroll.GetAct() + 1);
					aScroll.Paint(pActWin);
					bTimerStart = TRUE;
				}
			}

			if (aLastMousePos.Y() < GetPos().Y())
			{
				// Scroll up
				if (nFirstVis > 0)
				{
					nFirstVis--;
					switch (eSelectStyle)
					{
						case VCLISTBOX_SINGLE :
							SetSelectEntry(nFirstVis);
							break;

						case VCLISTBOX_MULTIPLE_E :
							SelectListboxMultipleE(pActWin,nFirstVis,
												   TRUE,FALSE);
							break;
					}

					DrawEntries( pActWin );
					aScroll.SetAct(aScroll.GetAct() - 1);
					aScroll.Paint(pActWin);
					bTimerStart = TRUE;
				}
			}

			if (bTimerStart)
			{
				aTimer.Start();
			}

			switch (eSelectStyle)
			{
				case VCLISTBOX_SINGLE :
					SelectFromPos( pWindow, rMEvt.GetPosPixel() );
					break;
				case VCLISTBOX_MULTIPLE_E :
					if (!rMEvt.IsMod1() && !rMEvt.IsShift())
						SelectFromPos( pWindow, rMEvt.GetPosPixel() );
					break;

				case VCLISTBOX_MULTIPLE_S :
					break;

			}
			bSelChanged = SelectionChanged();

		}
		else
		{
			Point aPos = rMEvt.GetPosPixel();
			Rectangle aScrollRect( aScroll.GetPos(), aScroll.GetSize() );

			if( aScrollRect.IsInside( aPos ) )
				aScroll.MouseMove( pWindow, rMEvt );
		}
	}
}

void VCListBoxEngine::SetSelectStyle(VCListBoxStyle eStyle)
{
	eSelectStyle = eStyle;
}

void VCDropDownWindow::LoseFocus()
{
	/*
		das dropdownwindow ist ein workingwindow und darf deshalb nie
		den focus bekommen, da sonst die applikation deaktiviert wird.
		dafuer wird dieses fenster nicht von der app geclippt!
	*/
	DBG_ERROR("LoseFocus im VCDropDownWindow!!!!");
#ifndef VCL
	WorkWindow::LoseFocus();
#else
	FloatingWindow::LoseFocus();
#endif
	if( aLoseFocusHdlLink.IsSet() )
		aLoseFocusHdlLink.Call( this );
}

void VCDropDownWindow::Resize()
{
	aList.SetPos( Point() );
	Size aSize = GetOutputSizePixel();
	aSize.Width()--;
	aSize.Height()--;
	aSize = PixelToLogic( aSize );
	aList.SetSize( aSize );
	aList.SetBorder( TRUE );
}

IMPL_LINK_INLINE_START( VCDropDownWindow, Select, VCListBoxEngine *, EMPTYARG )
{
	if( aSelectHdlLink.IsSet() )
		aSelectHdlLink.Call( this );
	return 0;
}
IMPL_LINK_INLINE_END( VCDropDownWindow, Select, VCListBoxEngine *, EMPTYARG )

void VCDropDownWindow::Paint( const Rectangle& rRect )
{
	aList.Paint( this );
}

void VCDropDownWindow::MouseButtonDown( const MouseEvent& rMEvt )
{
	Rectangle aRect( GetPosPixel(), GetSizePixel() );
	Point aPosPix( rMEvt.GetPosPixel());
	aPosPix += GetPosPixel();
	if( !aRect.IsInside( aPosPix ))
	{
		if( aLoseFocusHdlLink.IsSet() )
		{
#ifdef UNX
			ReleaseMouse();
#endif
			aLoseFocusHdlLink.Call( this );
		}
		return;
	}
	Point aPos = PixelToLogic( rMEvt.GetPosPixel() );
	MouseEvent aMEvt( aPos,
					  rMEvt.GetClicks(),
					  rMEvt.GetMode(),
					  rMEvt.GetButtons(),
					  rMEvt.GetModifier() );

	aList.MouseButtonDown( this, aMEvt );
}

void VCDropDownWindow::MouseButtonUp( const MouseEvent& rMEvt )
{
//	ReleaseMouse();
	bKeyReturnEnabled = TRUE;
	if( !(nFlags & DDWIN_FLAG_MUP_REC) )
	{
		// dem Parent ein ButtonUp schicken wg. Button-Animation
		Window* pParent = GetParent();
		Point aParPosPix( rMEvt.GetPosPixel());
		aParPosPix = OutputToScreenPixel( aParPosPix );
		aParPosPix = pParent->ScreenToOutputPixel( aParPosPix );
		MouseEvent aMEvtPix(aParPosPix,1,rMEvt.GetMode(),rMEvt.GetButtons(),rMEvt.GetModifier());
		nFlags |= DDWIN_FLAG_MUP_REC;
		pParent->MouseButtonUp( aMEvtPix );
	}
	Point aPos = PixelToLogic( rMEvt.GetPosPixel() );
	MouseEvent aMEvt( aPos,
					  rMEvt.GetClicks(),
					  rMEvt.GetMode(),
					  rMEvt.GetButtons(),
					  rMEvt.GetModifier() );

	aList.MouseButtonUp( this, aMEvt );
}

void VCDropDownWindow::MouseMove( const MouseEvent& rMEvt )
{
	Rectangle aRect( GetPosPixel(), GetSizePixel() );
	Point aPosPix( rMEvt.GetPosPixel());
	aPosPix += GetPosPixel();
	if( !aRect.IsInside( aPosPix ) && !(nFlags & DDWIN_FLAG_MUP_REC))
	{
		// mousemove an den Parent schicken (fuer buttonanimation)
		Point aParPosPix( rMEvt.GetPosPixel());
		Window* pParent = GetParent();
		aParPosPix = OutputToScreenPixel( aParPosPix );
		aParPosPix = pParent->ScreenToOutputPixel( aParPosPix );
		MouseEvent aMEvtPix(aParPosPix,1,rMEvt.GetMode(),rMEvt.GetButtons(),rMEvt.GetModifier());
		pParent->MouseMove( aMEvtPix );
		return;
	}
	Point aPos = PixelToLogic( rMEvt.GetPosPixel() );
	MouseEvent aMEvt( aPos,
					  rMEvt.GetClicks(),
					  rMEvt.GetMode(),
					  rMEvt.GetButtons(),
					  rMEvt.GetModifier() );

	aList.MouseMove( this, aMEvt );
}

void VCDropDownWindow::InsertAcc()
{
	static USHORT nKeyCodes[] = {
		KEY_DOWN, KEY_UP, KEY_PAGEDOWN, KEY_PAGEUP,	KEY_RETURN, KEY_ESCAPE,
		KEY_DELETE,
		KEY_A,KEY_B,KEY_C,KEY_D,KEY_E,KEY_F,KEY_G,KEY_H,KEY_I,KEY_J,KEY_K,
		KEY_L,KEY_M,KEY_N,KEY_O,KEY_P,KEY_Q,KEY_R,KEY_S,KEY_T,KEY_U,KEY_V,
		KEY_W,KEY_X,KEY_Y,KEY_Z,
		KEY_0,KEY_1,KEY_2,KEY_3,KEY_4,KEY_5,KEY_6,KEY_7,KEY_8,KEY_9,
		0
	};

	Link aKeyInputHdl( LINK( this, VCDropDownWindow, KeyInputHdl ));
	Application* pApp = GetpApp();
	USHORT* pCurKey = nKeyCodes;
	while( *pCurKey )
	{
		Accelerator* pAcc = new Accelerator;
		pAcc->InsertItem( 1, KeyCode( *pCurKey ) );
		pAcc->PushActivateHdl( aKeyInputHdl );
		pApp->InsertAccel( pAcc, ACCEL_ALWAYS );
		aAccelArr.Insert( pAcc, aAccelArr.Count() );
		pCurKey++;
	}
	bAccsRemoved = FALSE;
}

void VCDropDownWindow::RemoveAcc()
{
	if( !bAccsRemoved )
	{
		Application* pApp = GetpApp();
		USHORT nCount = aAccelArr.Count();
		for( USHORT nCur = 0; nCur < nCount; nCur++ )
		{
			Accelerator* pAcc = (Accelerator*)aAccelArr.GetObject( nCur );
			pApp->RemoveAccel( pAcc );
			delete pAcc;
		}
		aAccelArr.Remove( 0, nCount );
		bAccsRemoved = TRUE;
	}
}

IMPL_LINK( VCDropDownWindow, KeyInputHdl, Accelerator *, pAcc )
{
	BOOL bIncludeCurrentEntry = TRUE;
	if( !aTravelTimer.IsActive() )
	{
		aCurTravelStr.Erase();
		bIncludeCurrentEntry = FALSE;
	}
	ULONG nCur = aList.GetSelectEntry();

	USHORT nId = pAcc->GetItemId( 0 );

	KeyCode aKey = pAcc->GetKeyCode( nId );
	if( aKey.GetModifier() )
		return 0;
	USHORT nCode = aKey.GetCode();
	USHORT nGroup = aKey.GetGroup();
	switch( nGroup )
	{
		case KEYGROUP_ALPHA:
		case KEYGROUP_NUM:
			{
				String aKeyStr( aKey.GetName() );
				aCurTravelStr += aKeyStr;
				ULONG nNewEntry;
				if( !bIncludeCurrentEntry )
					nNewEntry = aList.FindEntry( aCurTravelStr, nCur+1 );
				else
				{
					nNewEntry = aList.FindEntry( aCurTravelStr, nCur );
					// Schnelldurchlauf innerhalb einer Gruppe
					if( nNewEntry == ULONG_MAX && aCurTravelStr.Len() == 2 &&
						aCurTravelStr[(USHORT)0] == aCurTravelStr[(USHORT)1])
					{
						aCurTravelStr = aKeyStr;
						nNewEntry = aList.FindEntry( aCurTravelStr, nCur + 1);
					}
				}
				if( nNewEntry != ULONG_MAX )
				{
					aList.SelectListboxSingle( this, nNewEntry );
					short nScroll = aList.MakeVisible( this, nNewEntry );
					if( nScroll )
						Invalidate();
				}
				aTravelTimer.Start();
			}
			break;

		case KEYGROUP_CURSOR:
			{
			short nScroll = 0;
			if( nCode == KEY_DOWN )
			{

				aList.SelectListboxSingle( this, nCur + 1 );
				nScroll = aList.MakeVisible( this, nCur + 1 );
			}
			else if( nCode == KEY_UP )
			{
				if( nCur )
				{
					aList.SelectListboxSingle( this, nCur - 1 );
					nScroll = aList.MakeVisible( this, nCur - 1 );
				}
			}
			if( nScroll )
				Invalidate();
			}
			break;

		case KEYGROUP_MISC:
			if( nCode == KEY_RETURN )
			{
				if( bKeyReturnEnabled )
				{
					// Im Acc-Handler duerfen die Accs nicht geloescht werden!
					bAccsRemoved = TRUE;
					aLoseFocusHdlLink.Call( this );
					if( aList.aSelectHdlLink.IsSet() && aList.bSelChanged )
					{
						aList.aSelectHdlLink.Call( &aList );
						aList.bSelChanged = FALSE;
					}
					bAccsRemoved = FALSE;
				}
			}
			else if( nCode == KEY_ESCAPE )
			{
				if( bKeyReturnEnabled )
				{
					// Im Acc-Handler duerfen die Accs nicht geloescht werden!
					bAccsRemoved = TRUE;
					aLoseFocusHdlLink.Call( this );
					bAccsRemoved = FALSE;
				}
			}
			break;
	}
	return 0;
}

VCDropDownWindow::VCDropDownWindow( Window* pParent, WinBits nWinStyle, void** _pOwner ) :
#ifndef VCL
	WorkWindow( pParent, 0 ),
#else
	FloatingWindow( pParent, 0 ),
#endif
	bAccsRemoved( FALSE ),
	bKeyReturnEnabled( FALSE )
{
	pOwner = _pOwner;
	MapMode aMap = pParent->GetMapMode();
	aMap.SetOrigin( Point() );
	SetMapMode( aMap );
	aList.SetBorder( TRUE );
	aList.SetSelectHdl( LINK( this, VCDropDownWindow, Select ) );
	nFlags = 0;
	ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
	if( pImplEdit )
	{
		delete pImplEdit->pWin;
		delete pImplEdit;
	}
	pImplEdit = new ImplActiveEdit;
	pImplEdit->pThis = 0;
	pImplEdit->pWin = this;
	SI_DLL()->SetActiveEdit( pImplEdit );
	aTravelTimer.SetTimeout( 500 );
	InsertAcc();
}

VCDropDownWindow::~VCDropDownWindow()
{
	RemoveAcc();
	if( pOwner )
		*pOwner = 0;
	ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
	if(pImplEdit && pImplEdit->pWin == this)
	{
		delete pImplEdit;
		SI_DLL()->SetActiveEdit( 0 );
	}
}

VCComboBoxEngineBase::VCComboBoxEngineBase() :
	nSelect(0xFFFFFFFF),
	bCalcSizes(TRUE),
	pList(NULL),
	bEnabled(TRUE),
	aForeColor( COL_BLACK ),
	aBackColor( COL_WHITE ),
	pActWin(NULL),
	aEditEngine(0)
{
}

VCComboBoxEngineBase::~VCComboBoxEngineBase()
{
	Clear();
}

void VCComboBoxEngineBase::SetPos( const Point& rPos )
{
	aPos = rPos;
	bCalcSizes = TRUE;
}

void VCComboBoxEngineBase::SetSize( const Size& rSize )
{
	aSize = rSize;

	bCalcSizes = TRUE;
}

void VCComboBoxEngineBase::SetFont( const Font& rFont )
{
	aFont = rFont;

	bCalcSizes = TRUE;
}

void VCComboBoxEngineBase::SetForeColor( const Color& rColor )
{
	aForeColor = rColor;
}

void VCComboBoxEngineBase::SetBackColor( const Color& rColor )
{
	aBackColor = rColor;
}

void VCComboBoxEngineBase::Enable( BOOL bEnable )
{
	bEnabled = bEnable;
}

void VCComboBoxEngineBase::SetList( List* pNewList )
{
	Clear();

	if( pNewList && pNewList->Count() )
	{
		pList = new List;
		ULONG i;
		for( i=0; i < pNewList->Count(); i++ )
		{
			pList->Insert( new String( *((String*)pNewList->GetObject(i)) ), LIST_APPEND );
		}
	}
}

void VCComboBoxEngineBase::SetText( const String& rText )
{
	aText = rText;
}

void VCComboBoxEngineBase::SetSelectEntry( ULONG nEntry )
{
	nSelect = nEntry;
}

void VCComboBoxEngineBase::Paint( OutputDevice* pOut )
{
}

void VCComboBoxEngineBase::MouseButtonDown( Window* pOut,
											const MouseEvent& )
{
}

void VCComboBoxEngineBase::MouseButtonUp( Window* pOut,
										  const MouseEvent& )
{
}

void VCComboBoxEngineBase::MouseMove( Window* pOut,
									  const MouseEvent& )
{
}

Size VCComboBoxEngineBase::GetOptSize( OutputDevice* pOut ) const
{
	Size aOSize;
	return aOSize;
}

VCDDListBoxEngine::VCDDListBoxEngine( VCControl* _pShell ) :
	pShell( _pShell ),
	bBtnIn(FALSE),
	pDropWin(NULL)
{
	aEditEngine.SetActive( FALSE );
	aEditEngine.SetCenterVert( TRUE );
#ifndef VCL
#ifndef MAC
	aEditEngine.SetBorder( TRUE );
	aDestroyDropWinTimer.SetTimeoutHdl(LINK(this,VCDDListBoxEngine,DestroyDropWin));
	aDestroyDropWinTimer.SetTimeout(0);
#endif
#else
	aEditEngine.SetBorder( FALSE );
	aDestroyDropWinTimer.SetTimeoutHdl(LINK(this,VCDDListBoxEngine,DestroyDropWin));
	aDestroyDropWinTimer.SetTimeout(0);
#endif
}

#ifndef VCL
VCDDListBoxEngine::~VCDDListBoxEngine()
{
#ifndef MAC
//HACK(#37859# Das DropDown-Window kann nur asynchron geloescht werden)
//OV,20.3.97:
//	DestroyDropWin(&aDestroyDropWinTimer);
	if( pDropWin )
	{
		ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
		// wenn die Fenster unterschiedlich sind, wurde pDropWin bereits
		// von draussen geloescht
		if(pImplEdit && pImplEdit->pWin == pDropWin)
		{
			SI_DLL()->SetActiveEdit( 0 );
			delete pDropWin;
			delete pImplEdit;
		}
	}
#endif
}
#else
VCDDListBoxEngine::~VCDDListBoxEngine()
{
//HACK(#37859# Das DropDown-Window kann nur asynchron geloescht werden)
//OV,20.3.97:
//	DestroyDropWin(&aDestroyDropWinTimer);
	if( pDropWin )
	{
		ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
		// wenn die Fenster unterschiedlich sind, wurde pDropWin bereits
		// von draussen geloescht
		if(pImplEdit && pImplEdit->pWin == pDropWin)
		{
			SI_DLL()->SetActiveEdit( 0 );
			delete pDropWin;
			delete pImplEdit;
		}
	}
}
#endif

Rectangle VCDDListBoxEngine::GetButtonRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );

#ifndef VCL
#ifndef MAC
	long nWidth = VCScrollBarEngine::GetOptWidth( pOut );
	aRect.Left() = aRect.Right() - nWidth;
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size a26LogPix = pOut->LogicToLogic( Size( 26, 26 ),MAP_POINT, aTmpMapMode );
	aRect.Left() = aRect.Right() - a26LogPix.Width();
	aRect.Bottom() = aRect.Top() + a26LogPix.Height();
#endif
#else
	if( pOut->GetOutDevType() == OUTDEV_PRINTER )
	{
		long nWidth = VCScrollBarEngine::GetOptWidth( pOut );
		aRect.Left() = aRect.Right() - nWidth + 1;
		Size aPix( 1,1 );
		aPix = pOut->PixelToLogic( aPix );
		aRect.Top() += 2*aPix.Height();
		aRect.Bottom() -= 2*aPix.Height();
		aRect.Left() -= 2* aPix.Width();
		aRect.Right() -= 2* aPix.Height();
	}
	else
	{
		// In Pixeln rechnen, da wir sonst Alignment-Probleme bekommen
		aRect = pOut->LogicToPixel( aRect );
		aRect.Left() = aRect.Right() - 14 + 1;
		aRect.Top() += 2;
		aRect.Bottom() -= 2;
		aRect.Left() -= 2;
		aRect.Right() -= 2;
		aRect = pOut->PixelToLogic( aRect );
	}
#endif
	if( aRect.Left() < aPos.X() )
		aRect.Left() = aPos.X();
	return aRect;
}

Rectangle VCDDListBoxEngine::GetEditRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );

#ifndef VCL
#ifndef MAC
	aRect.Right() = aBtnRect.Left();
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size a5LogPix = pOut->LogicToLogic( Size( 5, 5 ), MAP_POINT, aTmpMapMode );
	aRect.Bottom() = aBtnRect.Bottom() - a5LogPix.Height();
#endif
#else
	// in Pixeln um Alignment-Fehler zu vermeiden
	aRect.Right() = aBtnRect.Left();
	aRect = pOut->LogicToPixel( aRect );
	// Border abziehen
	aRect.Left() += 2;
	aRect.Top() += 2;
	aRect.Bottom() -= 2;
	aRect = pOut->PixelToLogic( aRect );
#endif
	return aRect;
}

#ifndef VCL

void VCDDListBoxEngine::ShowHideDropWin( Window* pWindow )
{
#ifndef MAC
	if( aDestroyDropWinTimer.IsActive() )
		DestroyDropWin(&aDestroyDropWinTimer);
	if( !pDropWin )
	{
		pDropWin = new VCDropDownWindow( pWindow, 0, (void**)&pDropWin );
		Point aPosPixel = pWindow->LogicToPixel(
							Point( aPos.X(), aPos.Y()+aSize.Height() ) );

		pDropWin->SetLoseFocusHdl(
			LINK( this, VCDDListBoxEngine, DropWinLoseFocus ) );
		pDropWin->SetSelectHdl(
			LINK( this, VCDDListBoxEngine, DropWinSelect ) );

		short nEntries = pList ? pList->Count()+1 : 2;
		if( nEntries < 3 )
			nEntries = 3;
		if( nEntries > 8 )
			nEntries = 8;

		Size aBoxSize( aSize.Width(), aFont.GetSize().Height()*nEntries );
		aBoxSize = pWindow->LogicToPixel( aBoxSize );

		// Border draufrechnen
		aBoxSize.Height() += 2;
		aBoxSize.Width()++;
		aBoxSize.Height()++;
		aPosPixel = pWindow->OutputToScreenPixel( aPosPixel );

/* hack AppWindow
#ifndef VCL
		Size aScreenSize( System::GetScreenSizePixel() );
#else
		Size aScreenSize;
		if ( Application::GetAppWindow() )
			aScreenSize = Application::GetAppWindow()->GetOutputSizePixel();
#endif
		if( aPosPixel.Y()+aBoxSize.Height() > aScreenSize.Height())
		{
			aPosPixel.Y() -= aBoxSize.Height();
			Size aTemp = pWindow->LogicToPixel( aSize );
			aPosPixel.Y() -= aTemp.Height();
		}
*/
		pDropWin->SetPosSizePixel( aPosPixel, aBoxSize );

		pDropWin->SetFont( aFont );
		pDropWin->SetForeColor( aForeColor );
		pDropWin->SetBackColor( aBackColor );
		pDropWin->SetList( pList );
		pDropWin->SetSelectEntry( nSelect );

		pDropWin->Show();
		// ACHTUNG: Das DropWindow ist ein WorkingWindow, und darf sich
		// deshalb nicht den Focus grabben, da sonst die Applikation
		// deaktiviert wird.
		pWindow->ReleaseMouse(); //wg. OS/2!!
		if( pShell )
			((VCManager*)pShell->GetParent())->ReleaseCaptureChild();
		pDropWin->CaptureMouse();
		aGotFocusHdlLink.Call( this );
	}
	else
	{
		pDropWin->Hide();
		pDropWin->RemoveAcc();
		aDestroyDropWinTimer.Start();
		pActWin = NULL;
	}
#else
	PopupMenu* pPopupMenu = new PopupMenu();

	USHORT i;
	for (i = 1; i <= pList->Count(); i++)
		pPopupMenu->InsertItem( i, *((String*)pList->GetObject(i-1)));

	pPopupMenu->SetDefaultItem( nSelect + 1 );
	pPopupMenu->CheckItem( nSelect + 1 );

	pPopupMenu->PushSelectHdl(
		LINK( this, VCDDListBoxEngine, DropWinSelect ) );

	Point aPopupPos = pWindow->OutputToScreenPixel(pWindow->LogicToPixel(aPos));

	Size aPopupSize = pWindow->LogicToPixel(aSize);
	// Hintereingang zum setzen der PopupBreite
	SVE_SetMininimalWidth(pPopupMenu,aPopupSize.Width());
	aGotFocusHdlLink.Call( this );
	pPopupMenu->Execute(aPopupPos);
	delete pPopupMenu;
	aLostFocusHdlLink.Call( this );
#endif
}

#else

void VCDDListBoxEngine::ShowHideDropWin( Window* pWindow )
{
	if( aDestroyDropWinTimer.IsActive() )
		DestroyDropWin(&aDestroyDropWinTimer);
	if( !pDropWin )
	{
		pDropWin = new VCDropDownWindow( pWindow, 0, (void**)&pDropWin );
		Point aPosPixel = pWindow->LogicToPixel(
							Point( aPos.X(), aPos.Y()+aSize.Height() ) );

		pDropWin->SetLoseFocusHdl(
			LINK( this, VCDDListBoxEngine, DropWinLoseFocus ) );
		pDropWin->SetSelectHdl(
			LINK( this, VCDDListBoxEngine, DropWinSelect ) );

		ULONG nEntries = pList ? pList->Count()+1 : 2;
		if( nEntries < 3 )
			nEntries = 3;
		if( nEntries > 8 )
			nEntries = 8;

		Size aBoxSize( aSize.Width(), aFont.GetSize().Height()*nEntries );
		aBoxSize = pWindow->LogicToPixel( aBoxSize );

		// Border draufrechnen
		aBoxSize.Height() += 2;
		aBoxSize.Width()++;
		aBoxSize.Height()++;
		aPosPixel = pWindow->OutputToScreenPixel( aPosPixel );
/* hack AppWindow
#ifndef VCL
		Size aScreenSize( System::GetScreenSizePixel() );
#else
		Size aScreenSize;
		if ( Application::GetAppWindow() )
			aScreenSize = Application::GetAppWindow()->GetOutputSizePixel();
#endif

		if( aPosPixel.Y()+aBoxSize.Height() > aScreenSize.Height())
		{
			aPosPixel.Y() -= aBoxSize.Height();
			Size aTemp = pWindow->LogicToPixel( aSize );
			aPosPixel.Y() -= aTemp.Height();
		}
*/
		pDropWin->SetPosSizePixel( aPosPixel, aBoxSize );

		pDropWin->SetFont( aFont );
		pDropWin->SetForeColor( aForeColor );
		pDropWin->SetBackColor( aBackColor );
		pDropWin->SetList( pList );
		pDropWin->SetSelectEntry( nSelect );
		pDropWin->MakeVisible( nSelect );
		pDropWin->Show();
		// ACHTUNG: Das DropWindow ist ein WorkingWindow, und darf sich
		// deshalb nicht den Focus grabben, da sonst die Applikation
		// deaktiviert wird.
		pWindow->ReleaseMouse(); //wg. OS/2!!
		if( pShell )
			((VCManager*)pShell->GetParent())->ReleaseCaptureChild();
		pDropWin->CaptureMouse();
		aGotFocusHdlLink.Call( this );
	}
	else
	{
		pDropWin->Hide();
		pDropWin->RemoveAcc();
		aDestroyDropWinTimer.Start();
		pActWin = NULL;
	}
}
#endif

IMPL_LINK_INLINE_START( VCDDListBoxEngine, DropWinLoseFocus, Window *, EMPTYARG )
{
	// wird gerufen, wenn ausserhalb des DropWindows geklickt wird.
	// ist kein "echtes" LoseFocus!
	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();
	return 0;
}
IMPL_LINK_INLINE_END( VCDDListBoxEngine, DropWinLoseFocus, Window *, EMPTYARG )

IMPL_LINK( VCDDListBoxEngine, DropWinSelect, Window *, pWin )
{
#ifndef VCL
#ifndef MAC
	nSelect = pDropWin->GetSelectEntry();
#else
	PopupMenu* pPopUp = (PopupMenu*) pWin;
	nSelect = pPopUp->GetCurItemId() - 1;
#endif
#else
	nSelect = pDropWin->GetSelectEntry();
#endif

	String* pStr = (String*)pList->GetObject( nSelect );
	if( pStr )
	{
		aEditEngine.SetText( *pStr );
		aText = *pStr;
	}
	else
	{
		aText = String();
		aEditEngine.SetText( aText );
	}

	if (pActWin)
		aEditEngine.Paint( pActWin );

	SfxItemSet* pItemSet = pShell->GetItemSet();
	SfxStringItem aTextItem( VCATTR_TEXT, aText );
	pItemSet->Put( aTextItem );

#ifndef VCL
#ifndef MAC
	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();
#endif
#else
	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();
#endif

	if( aSelectHdlLink.IsSet() )
		aSelectHdlLink.Call( this );
	return 0;
}

void VCDDListBoxEngine::SetList( List* pList )
{
	VCComboBoxEngineBase::SetList( pList );
	if( pDropWin )
		pDropWin->SetList( pList );
	ValidateEditText();
}

void VCDDListBoxEngine::SetForeColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetForeColor( rCol );
	if( pDropWin )
		pDropWin->SetForeColor( rCol );
	aEditEngine.SetForeColor( rCol );
}

void VCDDListBoxEngine::SetBackColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetBackColor( rCol );
	if( pDropWin )
		pDropWin->SetBackColor( rCol );
	aEditEngine.SetBackColor( rCol );
}

void VCDDListBoxEngine::SetSelectEntry( ULONG nEntry )
{
	VCComboBoxEngineBase::SetSelectEntry( nEntry );
	if( pDropWin )
		pDropWin->SetSelectEntry( nEntry );
}

void VCDDListBoxEngine::Paint( OutputDevice* pOut )
{
	if( bCalcSizes )
	{
		aBtnRect  = GetButtonRect( pOut );
		aEditRect = GetEditRect( pOut );

		aEditEngine.SetPos(  aEditRect.TopLeft() );
		aEditEngine.SetSize( aEditRect.GetSize() );

		aEditEngine.Enable( bEnabled );
		aEditEngine.SetFont( aFont );

		bCalcSizes = FALSE;
	}

	aEditEngine.Paint( pOut );
	DrawButton( pOut );
#ifdef VCL
	SiDrawBorder_Impl( pOut, aPos, aSize );
#endif
}

void VCDDListBoxEngine::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWin = pWindow;

	Point aPos = rMEvt.GetPosPixel();
	Rectangle aRect( aPos, aSize );
	if( aRect.IsInside( aPos ) && !pDropWin )
	{
		bBtnIn = TRUE;
		DrawButton( pWindow );
		ShowHideDropWin( pWindow );
	}
}

void VCDDListBoxEngine::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	if( !pDropWin )
		pActWin = NULL;

	bBtnIn = FALSE;
	DrawButton( pWindow );
}

void VCDDListBoxEngine::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	Point aPos = rMEvt.GetPosPixel();
	if( aBtnRect.IsInside( aPos ) )
	{
		if( !bBtnIn )
		{
			bBtnIn = TRUE;
			DrawButton( pWindow );
		}
	}
	else
	{
		if( bBtnIn )
		{
			bBtnIn = FALSE;
			DrawButton( pWindow );
		}
	}
}

#ifndef VCL
// Berechnet die optimale Groesse der nicht aufgeklappten DDListBox
Size VCDDListBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
#ifndef MAC
	Size aOSize( VCScrollBarEngine::GetOptWidth( pOut ), 0 );
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size aOSize( pOut->LogicToLogic( Size( 26, 26 ),MAP_POINT, aTmpMapMode ));
#endif
	Size aTextSize( GetLongestLine( pOut, aFont, pList ));
	if( aOSize.Height() < aTextSize.Height())
		aOSize.Height() = aTextSize.Height();
	aOSize.Width() += aTextSize.Width();

	Size aPix( 30,4 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aOSize;
}
#else
// Berechnet die optimale Groesse der nicht aufgeklappten DDListBox
Size VCDDListBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	Size aOSize( VCScrollBarEngine::GetOptWidth( pOut ), 0 );
	Size aTextSize( GetLongestLine( pOut, aFont, pList ));
	if( aOSize.Height() < aTextSize.Height())
		aOSize.Height() = aTextSize.Height();
	aOSize.Width() += aTextSize.Width();

	Size aPix( 30,6 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aOSize;
}
#endif

void VCDDListBoxEngine::SetText( const String& rText )
{
	VCComboBoxEngineBase::SetText( rText );
	aEditEngine.SetText( aText );
	nSelect = 0xffffffff;
	if( pList )
	{
		ULONG nCount = pList->Count();
		for( ULONG nCur = 0; nCur < nCount; nCur++ )
		{
			const String* pStr = (const String*)pList->GetObject( nCur );
			if( *pStr == rText )
			{
				nSelect = nCur;
				break;
			}
		}
	}
}

void VCDDListBoxEngine::ValidateEditText()
{
	String aTmp = aEditEngine.GetText();
	if( aTmp.Len() )
	{
		BOOL bErase = FALSE;
		if( !pList )
			bErase = TRUE;
		else
		{
			ULONG nCount = pList->Count();
			bErase = TRUE;
			for( ULONG nCur = 0; nCur < nCount; nCur++ )
			{
				const String* pStr = (const String*)pList->GetObject( nCur );
				if( *pStr == aTmp )
				{
					bErase = FALSE;
					nSelect = nCur;
					break;
				}
			}
		}
		if( bErase )
		{
			nSelect = 0xffffffff;
			String aStr;
			VCComboBoxEngineBase::SetText( aStr );
			aEditEngine.SetText( aStr );
			if( GetActWin())
				aEditEngine.Paint( GetActWin() );
		}
	}
}

IMPL_LINK( VCComboBoxEngine, ListSelect, VCListBoxEngine *, EMPTYARG )
{
	nSelect = aListEngine.GetSelectEntry();

	String* pStr = (String*)pList->GetObject( nSelect );
	if( pStr )
		aEditEngine.SetText( *pStr );
	else
		aEditEngine.SetText( String() );

	if( aText != aEditEngine.GetText() )
	{
		aText = aEditEngine.GetText();

		if( pActWin )
			aEditEngine.Paint( pActWin );

		if( aTextModifyHdlLink.IsSet() )
			aTextModifyHdlLink.Call( this );
	}
	else
	{
		if( pActWin )
			aEditEngine.Paint( pActWin );
	}
	return 0;
}

IMPL_LINK( VCComboBoxEngine, EditModify, VCEditEngine *, EMPTYARG )
{
	aText = aEditEngine.GetText();

	if( aListEngine.GetSelectEntry() != 0xFFFFFFFF )
	{
		aListEngine.SetSelectEntry( 0xFFFFFFFF );
		if( aEditEngine.GetEditWin() )
			aListEngine.Paint( aEditEngine.GetEditWin()->GetParent() );
	}

	if( aTextModifyHdlLink.IsSet() )
		aTextModifyHdlLink.Call( this );
	return 0;
}

Rectangle VCComboBoxEngine::GetEditRect( OutputDevice* pOut ) const
{
	Rectangle aBoundRect( aPos, aSize );

	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
	Size aTempSize= pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
	Font aOldFont = pOut->GetFont( );
	pOut->SetFont( aFont );
	Size aTextSize   = pOut->GetTextSize( String() );
	pOut->SetFont( aOldFont );
	long nFontHeight = aTextSize.Height() + 12*aTempSize.Height();

	Rectangle aRect( aPos, Size( aSize.Width(), nFontHeight ) );
	aRect.Intersection( aBoundRect );

	return aRect;
}

#ifndef VCL
Rectangle VCComboBoxEngine::GetListRect( OutputDevice* pOut ) const
{
	Rectangle aBoundRect( aPos, aSize );

	MapMode aMap     = pOut->GetMapMode();

#if !defined(WIN) && !defined(WNT)
	Size aOfs;
#else
	Size aOfs 		 = pOut->PixelToLogic( Size( 8, 8 ),
										   MapMode( aMap.GetMapUnit() ) );
#endif

	Rectangle aRect = aBoundRect;

#ifndef MAC
	aRect.Top()   = aEditRect.Bottom();
#else
	Size a2Point = pOut->PixelToLogic( Size( 0, 2 ),
										MapMode( aMap.GetMapUnit() ) );
	aRect.Top()  = aEditRect.Bottom() + a2Point.Height();
#endif

	aRect.Left() += aOfs.Width();
	if( aRect.Left() > aRect.Right() )
		aRect.Left() = aRect.Right();

	return aRect;
}
#else
Rectangle VCComboBoxEngine::GetListRect( OutputDevice* pOut ) const
{
	Size aPix( pOut->PixelToLogic( Size(1,1)) );
	Rectangle aRect( aPos, aSize );
	aRect.Top() = aEditRect.Bottom();
	aRect.Top() += 2*aPix.Height();
	return aRect;
}
#endif

VCComboBoxEngine::VCComboBoxEngine( VCControl* pCtrl ) :
	pShell(pCtrl),
	bCaptureList(FALSE),
	bCaptureEdit(FALSE)
{
	aEditEngine.SetBorder( TRUE );
	aListEngine.SetBorder( TRUE );

	aListEngine.SetSelectHdl( LINK( this, VCComboBoxEngine, ListSelect ) );
	aEditEngine.SetModifyHdl( LINK( this, VCComboBoxEngine, EditModify ) );
}

VCComboBoxEngine::~VCComboBoxEngine()
{
}

void VCComboBoxEngine::SetList( List* pList )
{
	VCComboBoxEngineBase::SetList( pList );
	aListEngine.SetList( pList );
}

void VCComboBoxEngine::SetText( const String& rText )
{
	VCComboBoxEngineBase::SetText( rText );

	aEditEngine.SetText( aText );
}

void VCComboBoxEngine::SetForeColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetForeColor( rCol );
	aListEngine.SetForeColor( rCol );
	aEditEngine.SetForeColor( rCol );
}

void VCComboBoxEngine::SetBackColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetBackColor( rCol );
	aListEngine.SetBackColor( rCol );
	aEditEngine.SetBackColor( rCol );
}

void VCComboBoxEngine::SetSelectEntry( ULONG nEntry )
{
	VCComboBoxEngineBase::SetSelectEntry( nEntry );

	aListEngine.SetSelectEntry( nEntry );
}

void VCComboBoxEngine::Paint( OutputDevice* pOut )
{
	if( bCalcSizes )
	{
		aEditRect = GetEditRect( pOut );
		aListRect = GetListRect( pOut );

		aEditEngine.SetPos(  aEditRect.TopLeft() );
		aEditEngine.SetSize( aEditRect.GetSize() );

		aListEngine.SetPos( aListRect.TopLeft() );
		aListEngine.SetSize( aListRect.GetSize() );

		aEditEngine.Enable( bEnabled );
		aListEngine.Enable( bEnabled );

		aEditEngine.SetFont( aFont );
		aListEngine.SetFont( aFont );

		bCalcSizes = FALSE;
	}

	aEditEngine.Paint( pOut );
	aListEngine.Paint( pOut );
}

void VCComboBoxEngine::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWin = pWindow;

	Point aPos = rMEvt.GetPosPixel();
	if( aListRect.IsInside( aPos ) )
	{
		bCaptureList = TRUE;
		aListEngine.MouseButtonDown( pWindow, rMEvt );
	}
	else if( aEditRect.IsInside( aPos ) )
	{
		bCaptureEdit = TRUE;
		aEditEngine.MouseButtonDown( pWindow, rMEvt );
	}
}

void VCComboBoxEngine::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	if( bCaptureList )
	{
		bCaptureList = FALSE;
		aListEngine.MouseButtonUp( pWindow, rMEvt );
	}
	else
	if( bCaptureEdit )
	{
		bCaptureEdit = FALSE;
		aEditEngine.MouseButtonUp( pWindow, rMEvt );
	}

	pActWin = NULL;
}

void VCComboBoxEngine::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	if( bCaptureList )
		aListEngine.MouseMove( pWindow, rMEvt );
	else
	if( bCaptureEdit )
		aEditEngine.MouseMove( pWindow, rMEvt );
}

// Berechnet optimale Groesse der aufgeklappten Combobox
Size VCComboBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	Size aOSize( VCScrollBarEngine::GetOptWidth( pOut ), 0 );
	Size aTextSize( GetLongestLine( pOut, aFont, pList ));
	if( aOSize.Height() < aTextSize.Height())
		aOSize.Height() = aTextSize.Height();
	aOSize.Width() += aTextSize.Width();
	if( pList && pList->Count() )
		aOSize.Height() *= pList->Count();
	else
		aOSize.Height() += 2*aTextSize.Height();

	Size aPix( 30,4 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aOSize;
}

VCDDComboBoxEngine::VCDDComboBoxEngine( VCControl* _pShell ) :
	pShell( _pShell ),
	bBtnIn(FALSE),
	pDropWin(NULL),
	bCaptureEdit(FALSE)
{
	aEditEngine.SetCenterVert( TRUE );
#ifndef VCL
	aEditEngine.SetBorder( TRUE );
#else
	aEditEngine.SetBorder( FALSE );
#endif
	aEditEngine.SetModifyHdl( LINK( this, VCDDComboBoxEngine, EditModify ) );
#ifndef VCL
#ifndef MAC
	aDestroyDropWinTimer.SetTimeoutHdl(LINK(this,VCDDComboBoxEngine,DestroyDropWin));
	aDestroyDropWinTimer.SetTimeout(0);
#endif
#else
	aDestroyDropWinTimer.SetTimeoutHdl(LINK(this,VCDDComboBoxEngine,DestroyDropWin));
	aDestroyDropWinTimer.SetTimeout(0);
#endif
}

#ifndef VCL
VCDDComboBoxEngine::~VCDDComboBoxEngine()
{
#ifndef MAC
	//HACK(#37859# Das DropDown-Window kann nur asynchron geloescht werden)
	//OV,20.3.97:
	//	DestroyDropWin(&aDestroyDropWinTimer);
	if( pDropWin )
	{
		ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
		// wenn die Fenster unterschiedlich sind, wurde pDropWin bereits
		// von draussen geloescht
		if(pImplEdit && pImplEdit->pWin == pDropWin)
		{
			SI_DLL()->SetActiveEdit( 0 );
			delete pDropWin;
			delete pImplEdit;
		}
	}
#endif
}
#else
VCDDComboBoxEngine::~VCDDComboBoxEngine()
{
//HACK(#37859# Das DropDown-Window kann nur asynchron geloescht werden)
//OV,20.3.97:
//	DestroyDropWin(&aDestroyDropWinTimer);
	if( pDropWin )
	{
		ImplActiveEdit* pImplEdit = SI_DLL()->GetActiveEdit();
		// wenn die Fenster unterschiedlich sind, wurde pDropWin bereits
		// von draussen geloescht
		if(pImplEdit && pImplEdit->pWin == pDropWin)
		{
			SI_DLL()->SetActiveEdit( 0 );
			delete pDropWin;
			delete pImplEdit;
		}
	}
}
#endif


#ifndef VCL
Rectangle VCDDComboBoxEngine::GetButtonRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );

#ifndef MAC
	long nWidth = VCScrollBarEngine::GetOptWidth( pOut );
	aRect.Left() = aRect.Right() - nWidth;
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size aLogPix = pOut->LogicToLogic( Size( 26, 19 ),MAP_POINT ,aTmpMapMode );
	aRect.Left() = aRect.Right() - aLogPix.Width();
	aRect.Bottom() = aRect.Top() + aLogPix.Height();
#endif

	if( aRect.Left() < aPos.X() )
		aRect.Left() = aPos.X();

	return aRect;
}
#else
Rectangle VCDDComboBoxEngine::GetButtonRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );
#ifndef VCL
#ifndef MAC
	long nWidth = VCScrollBarEngine::GetOptWidth( pOut );
	aRect.Left() = aRect.Right() - nWidth;
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size a26LogPix = pOut->LogicToLogic( Size( 26, 26 ),MAP_POINT, aTmpMapMode );
	aRect.Left() = aRect.Right() - a26LogPix.Width();
	aRect.Bottom() = aRect.Top() + a26LogPix.Height();
#endif
#else
	if( pOut->GetOutDevType() == OUTDEV_PRINTER )
	{
		long nWidth = VCScrollBarEngine::GetOptWidth( pOut );
		aRect.Left() = aRect.Right() - nWidth + 1;
		Size aPix( 1,1 );
		aPix = pOut->PixelToLogic( aPix );
		aRect.Top() += 2*aPix.Height();
		aRect.Bottom() -= 2*aPix.Height();
		aRect.Left() -= 2* aPix.Width();
		aRect.Right() -= 2* aPix.Height();
	}
	else
	{
		// In Pixeln rechnen, da wir sonst Alignment-Probleme bekommen
		aRect = pOut->LogicToPixel( aRect );
		aRect.Left() = aRect.Right() - 14 + 1;
		aRect.Top() += 2;
		aRect.Bottom() -= 2;
		aRect.Left() -= 2;
		aRect.Right() -= 2;
		aRect = pOut->PixelToLogic( aRect );
	}
#endif
	if( aRect.Left() < aPos.X() )
		aRect.Left() = aPos.X();
	return aRect;
}
#endif

#ifndef VCL
Rectangle VCDDComboBoxEngine::GetEditRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );

	aRect.Right() = aBtnRect.Left();

#ifdef WIN
	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );

	Size aSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
	aRect.Right() -= aSize.Width()*8;
#elif MAC
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size a3LogPix = pOut->LogicToLogic( Size( 3, 3 ), MAP_POINT, aTmpMapMode );
	aRect.Right() -= a3LogPix.Width();
	aRect.Bottom() = aBtnRect.Bottom();
#endif

	if( aRect.Right() < aRect.Left() )
		aRect.Right() = aRect.Left();

	return aRect;
}
#else
Rectangle VCDDComboBoxEngine::GetEditRect( OutputDevice* pOut ) const
{
	Rectangle aRect( aPos, aSize );
	// in Pixeln um Alignment-Fehler zu vermeiden
	aRect.Right() = aBtnRect.Left();
	aRect = pOut->LogicToPixel( aRect );
	// Border abziehen
	aRect.Left() += 2;
	aRect.Top() += 2;
	aRect.Bottom() -= 2;
	aRect = pOut->PixelToLogic( aRect );
	return aRect;
}
#endif

#ifndef VCL
void VCDDComboBoxEngine::ShowHideDropWin( Window* pWindow )
{
#ifndef MAC
	if( aDestroyDropWinTimer.IsActive() )
		DestroyDropWin(&aDestroyDropWinTimer);
	if( !pDropWin )
	{
		pDropWin = new VCDropDownWindow( pWindow, 0, (void**)&pDropWin  );
		Point aPosPixel = pWindow->LogicToPixel(
							Point( aPos.X(), aPos.Y()+aSize.Height() ) );

		pDropWin->SetLoseFocusHdl(
			LINK( this, VCDDComboBoxEngine, DropWinLoseFocus ) );
		pDropWin->SetSelectHdl(
			LINK( this, VCDDComboBoxEngine, DropWinSelect ) );

		ULONG nEntries = pList ? pList->Count()+1 : 2;
		if( nEntries > 8 )
			nEntries = 8;
		Size aBoxSize( aSize.Width(), aFont.GetSize().Height()*nEntries );
		aBoxSize = pWindow->LogicToPixel( aBoxSize );

		// Border draufrechnen
		aBoxSize.Height() += 2;
		aBoxSize.Width()++;
		aBoxSize.Height()++;
		aPosPixel = pWindow->OutputToScreenPixel( aPosPixel );
/* hack AppWindow
#ifndef VCL
		Size aScreenSize( System::GetScreenSizePixel() );
#else
		Size aScreenSize;
		if ( Application::GetAppWindow() )
			aScreenSize = Application::GetAppWindow()->GetOutputSizePixel();
#endif
		if( aPosPixel.Y()+aBoxSize.Height() > aScreenSize.Height())
		{
			aPosPixel.Y() -= aBoxSize.Height();
			Size aTemp = pWindow->LogicToPixel( aSize );
			aPosPixel.Y() -= aTemp.Height();
		}
*/
		pDropWin->SetPosSizePixel( aPosPixel, aBoxSize );

		pDropWin->SetFont( aFont );
		pDropWin->SetList( pList );

		nSelect = 0xffffffff;
		if( pList )
		{
			String aTmp( aEditEngine.GetText() );
			ULONG nCount = pList->Count();
			for( ULONG nCur = 0; nCur < nCount; nCur++ )
			{
				const String* pStr = (const String*)pList->GetObject( nCur );
				if( *pStr == aTmp )
				{
					nSelect = nCur;
					break;
				}
			}
		}

		pDropWin->SetSelectEntry( nSelect );
		pDropWin->Show();
		// Painten, damit die ListBox die Anzahl sichtbarer
		// Eintraege berechnen kann fuer SetFirstVisible
		pDropWin->Update();
		pDropWin->SetFirstVisible( nSelect );
		// pDropWin->GrabFocus(); // njet
		pWindow->ReleaseMouse(); //wg. OS/2!!
		if( pShell )
			((VCManager*)pShell->GetParent())->ReleaseCaptureChild();
		pDropWin->CaptureMouse();
		aGotFocusHdlLink.Call( this );
	}
	else
	{
		pDropWin->Hide();
		pDropWin->RemoveAcc();
		aDestroyDropWinTimer.Start();
		pActWin = NULL;
	}
#else
	USHORT i,nFound = MENU_ITEM_NOTFOUND;

	PopupMenu* pPopupMenu = new PopupMenu();
	String anEditText(aEditEngine.GetText());

	// Sonderbehandlung wenn String nicht in Liste enthalten
	for (i = 0; i < pList->Count(); i++)
		if (anEditText == *((String*)pList->GetObject(i)))
		{
			nFound = i;
			break;
		}

	if (nFound == MENU_ITEM_NOTFOUND)
	{
		nSelect = -2;
		pPopupMenu->InsertItem( 1, anEditText);
		pPopupMenu->InsertSeparator();
	}

	for (i = 0; i < pList->Count(); i++)
		pPopupMenu->InsertItem( i + 3, *((String*)pList->GetObject(i)));

	pPopupMenu->SetDefaultItem( nSelect + 3 );
	pPopupMenu->CheckItem( nSelect + 3 );

	pPopupMenu->PushSelectHdl(
			LINK( this, VCDDComboBoxEngine, DropWinSelect ) );

	Point aButtonPos;
	aButtonPos.X() = aBtnRect.Right();
	aButtonPos.Y() = (aBtnRect.Top() + aBtnRect.Bottom()) >> 1;

	Point aPopupPos = pWindow->OutputToScreenPixel(pWindow->LogicToPixel(aBtnRect.TopLeft()));
	aGotFocusHdlLink.Call( this );
	pPopupMenu->Execute(aPopupPos);
	delete pPopupMenu;
	aLostFocusHdlLink.Call( this );
#endif
}
#else
void VCDDComboBoxEngine::ShowHideDropWin( Window* pWindow )
{
	if( aDestroyDropWinTimer.IsActive() )
		DestroyDropWin(&aDestroyDropWinTimer);
	if( !pDropWin )
	{
		pDropWin = new VCDropDownWindow( pWindow, 0, (void**)&pDropWin  );
		Point aPosPixel = pWindow->LogicToPixel(
							Point( aPos.X(), aPos.Y()+aSize.Height() ) );

		pDropWin->SetLoseFocusHdl(
			LINK( this, VCDDComboBoxEngine, DropWinLoseFocus ) );
		pDropWin->SetSelectHdl(
			LINK( this, VCDDComboBoxEngine, DropWinSelect ) );

		ULONG nEntries = pList ? pList->Count()+1 : 2;
		if( nEntries > 8 )
			nEntries = 8;
		Size aBoxSize( aSize.Width(), aFont.GetSize().Height()*nEntries );
		aBoxSize = pWindow->LogicToPixel( aBoxSize );

		// Border draufrechnen
		aBoxSize.Height() += 2;
		aBoxSize.Width()++;
		aBoxSize.Height()++;
		aPosPixel = pWindow->OutputToScreenPixel( aPosPixel );
/* hack AppWindow
#ifndef VCL
		Size aScreenSize( System::GetScreenSizePixel() );
#else
		Size aScreenSize;
		if ( Application::GetAppWindow() )
			aScreenSize = Application::GetAppWindow()->GetOutputSizePixel();
#endif
		if( aPosPixel.Y()+aBoxSize.Height() > aScreenSize.Height())
		{
			aPosPixel.Y() -= aBoxSize.Height();
			Size aTemp = pWindow->LogicToPixel( aSize );
			aPosPixel.Y() -= aTemp.Height();
		}
*/
		pDropWin->SetPosSizePixel( aPosPixel, aBoxSize );

		pDropWin->SetFont( aFont );
		pDropWin->SetList( pList );

		nSelect = 0xffffffff;
		if( pList )
		{
			String aTmp( aEditEngine.GetText() );
			ULONG nCount = pList->Count();
			for( ULONG nCur = 0; nCur < nCount; nCur++ )
			{
				const String* pStr = (const String*)pList->GetObject( nCur );
				if( *pStr == aTmp )
				{
					nSelect = nCur;
					break;
				}
			}
		}

		pDropWin->SetSelectEntry( nSelect );
		pDropWin->MakeVisible( nSelect );
		pDropWin->Show();
		// pDropWin->GrabFocus(); // njet
		pWindow->ReleaseMouse(); //wg. OS/2!!
		if( pShell )
			((VCManager*)pShell->GetParent())->ReleaseCaptureChild();
		pDropWin->CaptureMouse();
		aGotFocusHdlLink.Call( this );
	}
	else
	{
		pDropWin->Hide();
		pDropWin->RemoveAcc();
		aDestroyDropWinTimer.Start();
		pActWin = NULL;
	}
}

#endif

IMPL_LINK_INLINE_START( VCDDComboBoxEngine, DropWinLoseFocus, Window *, EMPTYARG )
{
	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();
	return 0;
}
IMPL_LINK_INLINE_END( VCDDComboBoxEngine, DropWinLoseFocus, Window *, EMPTYARG )

#ifndef VCL

IMPL_LINK( VCDDComboBoxEngine, DropWinSelect, Window *, pWin )
{
#ifndef MAC
	nSelect = pDropWin->GetSelectEntry();
#else
	PopupMenu* pPopUp = (PopupMenu*) pWin;
	nSelect = pPopUp->GetCurItemId() - 3;
#endif

	String* pStr = (String*)pList->GetObject( nSelect );
	if( pStr )
		aEditEngine.SetText( *pStr );
	// auf dem Mac bleibt der Text stehen
#ifndef MAC
	else
		aEditEngine.SetText( String() );

	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();
#endif

	if( aText != aEditEngine.GetText() )
	{
		aText = aEditEngine.GetText();
		if( pActWin )
			aEditEngine.Paint( pActWin );

	}
	else
		if( pActWin )
			aEditEngine.Paint( pActWin );

	if( pStr && aSelectHdlLink.IsSet() )
		aSelectHdlLink.Call( this );

	return 0;
}
#else
IMPL_LINK( VCDDComboBoxEngine, DropWinSelect, Window *, pWin )
{
	nSelect = pDropWin->GetSelectEntry();
	String* pStr = (String*)pList->GetObject( nSelect );
	if( pStr )
		aEditEngine.SetText( *pStr );
	// auf dem Mac bleibt der Text stehen
	else
		aEditEngine.SetText( String() );

	pDropWin->Hide();
	pDropWin->RemoveAcc();
	aDestroyDropWinTimer.Start();

	if( aText != aEditEngine.GetText() )
	{
		aText = aEditEngine.GetText();
		if( pActWin )
			aEditEngine.Paint( pActWin );
	}
	else if( pActWin )
		aEditEngine.Paint( pActWin );

	if( pStr && aSelectHdlLink.IsSet() )
		aSelectHdlLink.Call( this );
	return 0;
}
#endif

IMPL_LINK( VCDDComboBoxEngine, EditModify, VCEditEngine *, EMPTYARG )
{
	aText = aEditEngine.GetText();

	nSelect = 0xFFFFFFFF;

	if( aTextModifyHdlLink.IsSet() )
		aTextModifyHdlLink.Call( this );
	return 0;
}

void VCDDComboBoxEngine::SetList( List* pList )
{
	VCComboBoxEngineBase::SetList( pList );
	if( pDropWin )
		pDropWin->SetList( pList );
}

void VCDDComboBoxEngine::SetText( const String& rText )
{
	VCComboBoxEngineBase::SetText( rText );
	aEditEngine.SetText( aText );
}

void VCDDComboBoxEngine::SetForeColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetForeColor( rCol );
	if( pDropWin )
		pDropWin->SetForeColor( rCol );
	aEditEngine.SetForeColor( rCol );
}

void VCDDComboBoxEngine::SetBackColor( const Color& rCol )
{
	VCComboBoxEngineBase::SetBackColor( rCol );
	if( pDropWin )
		pDropWin->SetBackColor( rCol );
	aEditEngine.SetBackColor( rCol );
}

void VCDDComboBoxEngine::SetSelectEntry( ULONG nEntry )
{
	VCComboBoxEngineBase::SetSelectEntry( nEntry );
	if( pDropWin )
		pDropWin->SetSelectEntry( nEntry );
}

void VCDDComboBoxEngine::Paint( OutputDevice* pOut )
{
	if( bCalcSizes )
	{
		aBtnRect  = GetButtonRect( pOut );
		aEditRect = GetEditRect( pOut );

		aEditEngine.SetPos(  aEditRect.TopLeft() );
		aEditEngine.SetSize( aEditRect.GetSize() );

		aEditEngine.Enable( bEnabled );
		aEditEngine.SetFont( aFont );

		bCalcSizes = FALSE;
	}

	aEditEngine.Paint( pOut );
	DrawButton( pOut );
#ifdef VCL
	SiDrawBorder_Impl( pOut, aPos, aSize );
#endif
}

void VCDDComboBoxEngine::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWin = pWindow;

	Point aPos = rMEvt.GetPosPixel();
	if( aBtnRect.IsInside( aPos ) && !pDropWin )
	{
		bBtnIn = TRUE;
		DrawButton( pWindow );
		ShowHideDropWin( pWindow );
	}
	else
	if( aEditRect.IsInside( aPos ) )
	{
		bCaptureEdit = TRUE;
		aEditEngine.MouseButtonDown( pWindow, rMEvt );
	}
}

void VCDDComboBoxEngine::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	if( !pDropWin )
		pActWin = NULL;

	if( bCaptureEdit )
	{
		bCaptureEdit = FALSE;
		aEditEngine.MouseButtonUp( pWindow, rMEvt );
	}
	else
	{
		if( bBtnIn )
		{
			bBtnIn = FALSE;
			DrawButton( pWindow );
		}
	}
}

void VCDDComboBoxEngine::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	Point aPos = rMEvt.GetPosPixel();
	if( aBtnRect.IsInside( aPos ) )
	{
		if( !bBtnIn )
		{
			bBtnIn = TRUE;
			DrawButton( pWindow );
		}
	}
	else
	{
		if( bBtnIn )
		{
			bBtnIn = FALSE;
			DrawButton( pWindow );
		}

	}

	if( bCaptureEdit )
		aEditEngine.MouseMove( pWindow, rMEvt );
}


// berechnet opti,male Groesse der nicht aufgeklappten ComboBox
#ifndef VCL
Size VCDDComboBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
#ifndef MAC
	Size aOSize( VCScrollBarEngine::GetOptWidth( pOut ), 0 );
#else
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size aOSize( pOut->LogicToLogic( Size( 26, 26 ),MAP_POINT, aTmpMapMode ));
#endif
	Size aTextSize( GetLongestLine( pOut, aFont, pList ));
	if( aOSize.Height() < aTextSize.Height())
		aOSize.Height() = aTextSize.Height();
	aOSize.Width() += aTextSize.Width();

	Size aPix( 30,4 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aOSize;
}
#else
Size VCDDComboBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	Size aOSize( VCScrollBarEngine::GetOptWidth( pOut ), 0 );
	Size aTextSize( GetLongestLine( pOut, aFont, pList ));
	if( aOSize.Height() < aTextSize.Height())
		aOSize.Height() = aTextSize.Height();
	aOSize.Width() += aTextSize.Width();
	Size aPix( 30,4 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aOSize;
}
#endif

Size VCListBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	Size aOSize( GetLongestLine( pOut, aFont, pList ));
	if( pList && pList->Count() )
		aOSize.Height() *= pList->Count();
	else
		aOSize.Height() += 2*aOSize.Height();

	Size aPix( 6,2 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();
	return aSize;
}

USHORT VCListBoxEngine::GetLineCount( OutputDevice* pOut ) const
{
	String aStr("W");
	Font aTempFont( pOut->GetFont() );
	pOut->SetFont( aFont );
	Size aTextSize( pOut->GetTextSize( aStr));
	pOut->SetFont( aTempFont );
	Size aPix( 6,2 );
	aPix = pOut->PixelToLogic( aPix );
	USHORT nCount = (USHORT)((aSize.Height()-aPix.Height()) / aTextSize.Height());
	return nCount;
}

Size VCListBoxEngine::GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const
{
	String aStr("W");
	Font aTempFont( pOut->GetFont() );
	pOut->SetFont( aFont );
	Size aOSize( pOut->GetTextSize( aStr));

	aOSize.Height() *= rCharXY.Height();
	if( rCharXY.Width() == 0 )
	{
		// max. Breite des vorhandenen Textes nehmen
		Size aMaxSize( GetLongestLine( pOut, aFont, pList ));
		aOSize.Width() = aMaxSize.Width();
	}
	else
	{
		FontPitch ePitch = aFont.GetPitch();
		if( ePitch == PITCH_DONTKNOW )
		{
			FontMetric aMetric = pOut->GetFontMetric();
			ePitch = aMetric.GetPitch();
		}
		if( ePitch != PITCH_FIXED )
			aOSize.Width() = aOSize.Height();
		aOSize.Width() *= rCharXY.Width();
	}
	aOSize.Width() += aScroll.GetOptWidth( pOut );
	Size aPix( 6,2 );
	aPix = pOut->PixelToLogic( aPix );
	aOSize.Height() += aPix.Height();
	aOSize.Width() += aPix.Width();

	pOut->SetFont( aTempFont );
	return aOSize;
}

IMPL_LINK(VCDDListBoxEngine,DestroyDropWin,Timer*,pTimer)
{
	pTimer->Stop();
	if( pDropWin )
	{
		pDropWin->RemoveAcc();
		delete pDropWin;
		pDropWin = 0;
		aLostFocusHdlLink.Call( this );
	}
	return 0;
}


IMPL_LINK(VCDDComboBoxEngine,DestroyDropWin,Timer*,pTimer)
{
	pTimer->Stop();
	if( pDropWin )
	{
		pDropWin->RemoveAcc();
		delete pDropWin;
		pDropWin = 0;
		aLostFocusHdlLink.Call( this );
	}
	return 0;
}

void VCComboBoxEngineBase::Clear()
{
	if( pList )
	{
		ULONG i;
		for( i=0; i < pList->Count(); i++ )
			delete (String*)pList->GetObject( i );

		delete pList;
		pList = NULL;
	}
}


