/*************************************************************************
 *
 *  $RCSfile: vcengin2.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#if SUPD > 504
#define _VCENGIN2_HXX
#endif

#ifndef _VCENGIN2_HXX
#define _VCENGIN2_HXX

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _SV_POINTR_HXX
#include <vcl/pointr.hxx>
#endif
#ifndef _SV_CURSOR_HXX
#include <vcl/cursor.hxx>
#endif
#ifndef _SV_FONT_HXX
#include <vcl/font.hxx>
#endif
#ifndef _SV_COLOR_HXX
#include <vcl/color.hxx>
#endif


class VCControl;
class Window;
class OutputDevice;
class Point;
class Graphic;
class SfxMediumRef;
class OutputDevice;
class VCImpVirtButton;
class VCImpVirtRadioButton;
class VCImpVirtPushButton;
class VCImpVirtCheckBox;
class KeyEvent;
class MouseEvent;
class VCSbxDrawObject;

#ifndef _SI_NOVCPUSHBTENG

// DrawControl-Flags fuer Buttons
#define SI_DRAWFLAG_HIGHLIGHTED		0x0001
#define SI_DRAWFLAG_CLICKED			0x0002
#define SI_DRAWFLAG_DRAW_ALL		0xffff

class VCButtonEngine
{
protected:
	Font				aFont;
	Color				aBackColor;
	Color				aForeColor;
	Point				aPos;
	Size				aSize;
	Link				aClickLink;
	Pointer				aPointer;
	String				aCaption;
	Window*				pActWindow;
	BOOL				bLeftButtonDown;
	BOOL				bMouseInside;
	BOOL				bFocus;
	BOOL				bVisible;
	BOOL				bRecalcSize;
	BOOL				bEnable;
	BOOL				bBorder;
	BOOL				bChecked;

	virtual void		DrawBorder(OutputDevice* pOut);
	virtual void		DrawBackground(OutputDevice* pOut);
	virtual void		DrawControl(OutputDevice* pOut, USHORT nFlags=0xffff);
	Rectangle			GetClientRect( OutputDevice* ) const;
	static Size		   	ImpGetButtonBmpSizePixel();

public:

						VCButtonEngine();
	virtual				~VCButtonEngine();

	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
	virtual void 		Paint( OutputDevice* pOut );

	void 				SetPos( const Point& rPos );
	Point       		GetPos() const { return aPos; }
	void				SetSize( const Size& rSize );
	Size				GetSize() const { return aSize; }
	void				SetCaption( const String& rCaption );
	const String& 		GetCaption() const { return aCaption; }
	void				Enable( BOOL bEnable = TRUE );
	BOOL				IsEnabled() const { return bEnable; }
	void				SetBackColor( const Color& rColor );
	const Color&		GetBackColor() const { return aBackColor; }
	void				SetForeColor( const Color& rColor );
	const Color&		GetForeColor() const { return aForeColor; }
	void				SetBorder( BOOL bBorder );
	BOOL				GetBorder() const { return bBorder; }
	void				SetFont( const Font& );
	const Font&			GetFont() const { return aFont; }

	BOOL				ButtonIsIn() const { return bLeftButtonDown; }

	void				SetClickHdl( const Link& rLink ) { aClickLink = rLink; }
	const Link&			GetClickHdl() const { return aClickLink; }

	virtual Size		GetMinSizePixel() const;
	virtual Size		GetOptSize( OutputDevice* pOut ) const;

	virtual Rectangle	GetTextRect( OutputDevice* pOut, const Font& rFont ) const;
};

//--------------------
// VCPushButtonEngine
//--------------------

class VCPushButtonEngine : public VCButtonEngine
{
protected:
	Link       			aDoneLink;
	Size				aRealOutputSize;
	// Fuer ImageButtons
	String				aImageURL;
	VCControl*			pShell;
	Graphic*   			pGraphic;
	SfxMediumRef* 		prMedium;

	BOOL				bDrawingImageButton;
	BOOL				bLoadAgain;

	void				LoadImage( BOOL bAsync = TRUE );
	Size				SetImageSize( Graphic&,OutputDevice* );

	void				LoadImageButton( OutputDevice* pOut );
	void				DrawImageButton( Graphic&, OutputDevice* );

	DECL_STATIC_LINK( VCPushButtonEngine, DoneHdl, void *);
	void				DrawBorder(OutputDevice* pOut);
	void				DrawBackground(OutputDevice* pOut);
	void				DrawControl(OutputDevice* pOut, USHORT nFlags=0xffff);

public:
						VCPushButtonEngine();
						~VCPushButtonEngine();

	Rectangle			GetTextRect( OutputDevice* pOut, const Font& rFont ) const;
	Size				GetOptSize( OutputDevice* pOut ) const;
	virtual void 		Paint( OutputDevice* pOut );
	void				SetImageURL( const String&, VCControl* );
	// laedt das Image synchron & setzt ggf. die Groesse im ItemSet
	void				LoadImageSync();

	const String& 		GetImageURL() const { return aImageURL; }
	void				PurgeGraphic();
};

class VCRadioButtonEngine : public VCButtonEngine
{
	void			DrawControl(OutputDevice* pOut, USHORT nFlags=0xffff);

public:
					VCRadioButtonEngine();
					~VCRadioButtonEngine();

	Rectangle		GetTextRect( OutputDevice* pOut, const Font& rFont ) const;
	Size			GetOptSize( OutputDevice* pOut ) const;
	void			Check( BOOL bCheck );
	BOOL			IsChecked() const { return bChecked; }
};


class VCCheckBoxEngine : public VCButtonEngine
{
	void			DrawControl(OutputDevice* pOut, USHORT nFlags=0xffff);

public:
					VCCheckBoxEngine();
					~VCCheckBoxEngine();

	Rectangle		GetTextRect( OutputDevice* pOut, const Font& rFont ) const;
	Size			GetOptSize( OutputDevice* pOut ) const;
	void			Check( BOOL bCheck );
	BOOL			IsChecked() const { return bChecked; }
};

#endif



#endif //_VCENGIN2_HXX
