/*************************************************************************
 *
 *  $RCSfile: vcengin5.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <sfx2/objsh.hxx>
#endif

#pragma hdrstop

#include "vcsbxctl.hxx"
#include "vcpbttn.hxx"
#include "vcengin2.hxx"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcattrid.hrc"
#include "vcictrls.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#define _SI_VCDRAWOBJ
#include "vcsbxdo.hxx"
#include "vcdrwobj.hxx"
#include <svx/impgrf.hxx>

#ifndef _SVX_SIVCDRMOD_HXX //autogen
#include <vcdrmod.hxx>
#endif

VCButtonEngine::VCButtonEngine()
	: aForeColor( COL_RED ), aBackColor( COL_BLACK )
{
	pActWindow = 0;
	bLeftButtonDown = FALSE;
	bMouseInside = FALSE;
	bFocus = FALSE;
	bVisible = TRUE;
	bRecalcSize = TRUE;
	bEnable = TRUE;
	bChecked = FALSE;
}

VCButtonEngine::~VCButtonEngine()
{
}

void VCButtonEngine::SetCaption( const String& rCaption )
{
	aCaption = rCaption;
}

void VCButtonEngine::Paint( OutputDevice* pOut )
{
	DrawBackground( pOut );
	DrawControl( pOut );
	DrawBorder( pOut );
}

Rectangle VCButtonEngine::GetClientRect( OutputDevice* pOut) const
{
	Rectangle aRect( aPos, aSize );
	aRect = pOut->LogicToPixel( aRect, MapMode( MAP_TWIP ) );
	aRect = pOut->PixelToLogic( aRect ,MapMode( pOut->GetMapMode().GetMapUnit()));
// OV,16.1.97, NUR die MapUnit von pOut verwenden!!! Ansonsten gibts
// Probleme mit allen Devices, die nicht mit Twip arbeiten!!!
//	aRect = OutputDevice::LogicToLogic(aRect,MapMode(MAP_TWIP),pOut->GetMapMode());
	return aRect;
}

void VCButtonEngine::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	bLeftButtonDown = TRUE;
	bMouseInside    = TRUE;
	DrawControl( pWindow, SI_DRAWFLAG_HIGHLIGHTED );
}

void VCButtonEngine::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	if( bLeftButtonDown )
	{
		bLeftButtonDown = FALSE;
		bMouseInside     = FALSE;
		Rectangle aBoundRect( GetClientRect( pWindow) );
		if( aBoundRect.IsInside( rMEvt.GetPosPixel() ) )
		{
			bChecked = TRUE;
			DrawControl( pWindow, SI_DRAWFLAG_CLICKED );
			aClickLink.Call( this );
		}
		else
			DrawControl( pWindow, SI_DRAWFLAG_CLICKED );
	}
}

void VCButtonEngine::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	if( bLeftButtonDown )
	{
		BOOL bOldInside = bMouseInside;
		Rectangle aBoundRect( GetClientRect( pWindow) );
		bMouseInside = aBoundRect.IsInside( rMEvt.GetPosPixel() ) ;

		if( bOldInside != bMouseInside )
			DrawControl( pWindow, SI_DRAWFLAG_HIGHLIGHTED );
	}
}

void VCButtonEngine::KeyInput( Window* pWindow, const KeyEvent& rKEvt )
{
	static BOOL bInKeyInput = FALSE;

	if( bInKeyInput )
		return;
	else
		bInKeyInput = TRUE;

	if( rKEvt.GetKeyCode().GetCode() == KEY_SPACE )
	{
		bLeftButtonDown = TRUE;
		bMouseInside    = TRUE;
		DrawControl( pWindow );

		bLeftButtonDown = FALSE;
		bMouseInside    = FALSE;
		bChecked = TRUE;
		aClickLink.Call( this );
		DrawControl( pWindow );
	}
	bInKeyInput = FALSE;
}


void VCButtonEngine::SetPos( const Point& rPos )
{
	aPos = rPos;
}

void VCButtonEngine::SetSize( const Size& rSize )
{
	aSize = rSize;
}

void VCButtonEngine::Enable( BOOL _bEnable )
{
	bEnable = _bEnable;
}

void VCButtonEngine::SetBackColor( const Color& rColor )
{
	aBackColor = rColor;
}

void VCButtonEngine::SetForeColor( const Color& rColor )
{
	aForeColor = rColor;
}

void VCButtonEngine::SetBorder( BOOL _bBorder )
{
	bBorder = _bBorder;
}

void VCButtonEngine::SetFont( const Font& rFont )
{
	aFont = rFont;
}

//***********************************************************************
// ABHAENGIGE IMPLEMENTATIONEN
//***********************************************************************

Size VCButtonEngine::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

Rectangle VCButtonEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	Rectangle aRect;
	return aRect;
}

void VCButtonEngine::DrawControl( OutputDevice* pOut, USHORT nFlags )
{
}

GraphicFilter* GetGrfFilter();

void VCPushButtonEngine::LoadImage( BOOL bAsync )
{
	DBG_ASSERT(aImageURL.Len(),"Image-URL not set");

	if( !bAsync )
	{
		// Synchron laden
		if( prMedium->Is() )
		{
			(*prMedium)->SetDoneLink( Link() );
			prMedium->Clear();
		}

		delete pGraphic;
		pGraphic = new Graphic;
		if( LoadGraphic( aImageURL, "", *pGraphic, 0 ) )
			pGraphic->SetDefaultType();
		bLoadAgain = FALSE;
	}
	else if( !pGraphic && !prMedium->Is() )
	{
		// HACK, da ich noch keine Shell am Model haengen habe
		// VCSbxDrawObject* pObj = pShell->GetDrawObject();
		SfxObjectShell* pSh =
			((VCDrawModel*)(pShell->GetDrawObject()->GetModel()))->GetObjectShell();
		DBG_ASSERT(pSh,"DrawImageButton ohne ObjectShell");
		*prMedium = new SfxMedium( aImageURL, STREAM_STD_READ, FALSE );
		(*prMedium)->SetTransferPriority( SFX_TFPRIO_VISIBLE_HIGHRES_GRAPHIC );
		(*prMedium)->SetReferer( pSh->GetMedium()->GetName() );
		if( (*prMedium)->IsRemote() )
			pSh->RegisterTransfer( **prMedium );

		SfxMediumRef aRef = *prMedium;
		(*prMedium)->DownLoad( STATIC_LINK(this,VCPushButtonEngine,DoneHdl));
	}
}

void VCPushButtonEngine::LoadImageButton( OutputDevice* pOut )
{
	if( pGraphic && !bLoadAgain )
	{
		DrawImageButton( *pGraphic, pOut );
		return;
	}

	if( pOut->GetOutDevType() == OUTDEV_PRINTER )
	{
		LoadImage( FALSE ); // Synchron laden
		DrawImageButton( *pGraphic, pOut );
	}
	else if( !pGraphic && !prMedium->Is() )
	{
		LoadImage( TRUE ); // Asynchron laden
	}
	else if( pGraphic )
		DrawImageButton( *pGraphic, pOut );
}

#ifdef WNT
// Bug #36988: Absturz bei PNG/TIF; wahrscheinlich pTemp = ... pTemp->Clear()
#pragma optimize( "", off )
#endif

IMPL_STATIC_LINK( VCPushButtonEngine, DoneHdl, void*, EMPTYARG )
{
	DBG_ASSERT(!pThis->pGraphic,"Graphic already set");

	pThis->pGraphic		= new Graphic;
	pThis->bLoadAgain	= FALSE;
	pThis->bRecalcSize	= TRUE;
	SfxMediumRef* pTemp	= pThis->prMedium;
	SvStream*   pStream = (*pTemp)->GetInStream();
	if( pStream && !pStream->GetError() )
	{
		int nRes;
		pStream->Seek( STREAM_SEEK_TO_BEGIN );
		nRes = GetGrfFilter()->
			ImportGraphic( *pThis->pGraphic, pThis->aImageURL, *pStream );
		if( nRes != GRFILTER_OK )
			pThis->pGraphic->SetDefaultType();
	}
	else
		pThis->pGraphic->SetDefaultType();

	pTemp->Clear();
	DBG_ASSERT(pThis->pGraphic,"Graphic not set");

	// in allen Views painten
	VCControl* pCtrl = pThis->pShell;
	VCManager* pMgr  = (VCManager*)pCtrl->GetParent();
	// #41674 Vor dem Paint die Groesse berechnen
	pThis->SetImageSize( *pThis->pGraphic, pMgr->GetCtrlParent() );
	pMgr->PaintControl( pCtrl, TRUE );

	return 0;
}

#ifdef WNT
#pragma optimize( "", on )
#endif

void lcl_DrawReplacement( OutputDevice* pOut, Graphic& rGraph, const String& rText,
	const Point& rPos, const Size& rSize )
{
	//abgekupfert vom Writer (source\core\doc\notxtfrm.cxx)

	static char __READONLY_DATA sFontName[] = "Helvetica";

	static Font *pFont = 0;
	if ( !pFont )
	{
		pFont = new Font();
		pFont->SetWeight( WEIGHT_BOLD );
		pFont->SetStyleName( "" );
		pFont->SetName( sFontName );
		pFont->SetFamily( FAMILY_SWISS );
		pFont->SetTransparent( TRUE );
	}

	Color aCol( COL_RED );
	FontUnderline eUnderline = UNDERLINE_NONE;
	pFont->SetUnderline( eUnderline );
	pFont->SetColor( aCol );

	static Bitmap* pBmp = 0;
	if( !pBmp )
		pBmp = new Bitmap( SiResId( IMG_SIDEFAULTBMP ));

	rGraph.Draw( pOut, rText, *pFont, *pBmp, rPos, rSize );
}

Size VCPushButtonEngine::SetImageSize( Graphic& rGraphic,OutputDevice* pOut )
{
	Size aSize( pShell->GetSize() );
	if( !aSize.Width() || !aSize.Height() )
	{
		MapMode aMapTwip( MAP_TWIP );
		Size aGrfSize( rGraphic.GetPrefSize() );
		if( !aGrfSize.Width() || !aGrfSize.Height() )
		{
			// die Grafik hat keine Groesse!
			aSize = ((VCPushButton*)pShell)->GetOptSize( pOut );
			// in Twips umrechnen
			aSize = pOut->LogicToPixel( aSize );
			aSize = pOut->PixelToLogic( aSize, aMapTwip );
		}
		else
		{
			aGrfSize = pOut->LogicToPixel( aGrfSize, rGraphic.GetPrefMapMode() );
			aGrfSize = pOut->PixelToLogic( aGrfSize, aMapTwip );

			if( !aSize.Width() && !aSize.Height() )
				aSize = aGrfSize;
			else
			{
				float nScale, nTemp;
				if( aSize.Width() )
				{
					nScale = (float)aSize.Width() / (float)aGrfSize.Width();
					nTemp = (float)aGrfSize.Height() * nScale;
					aSize.Height() = (long)nTemp;
				}
				else
				{
					nScale = (float)aSize.Height() / (float)aGrfSize.Height();
					nTemp = (float)aGrfSize.Width() * nScale;
					aSize.Width() = (long)nTemp;
				}
			}
		}
		bDrawingImageButton = TRUE;
		// Itemset aktualisieren, damits keine Endlosrekursion gibt
		SfxItemSet* pItemSet = pShell->GetItemSet();
		SfxInt32Item aWidthAttr( VCATTR_WIDTH, aSize.Width() );
		SfxInt32Item aHeightAttr( VCATTR_HEIGHT, aSize.Height() );
		pItemSet->Put( aWidthAttr );
		pItemSet->Put( aHeightAttr );
		pShell->SetSize( aSize );
		bDrawingImageButton = FALSE;
	}
	bRecalcSize = FALSE;
	return aSize;
}

void VCPushButtonEngine::DrawImageButton( Graphic& rGraphic, OutputDevice* pOut)
{
	if( bDrawingImageButton )
		return;
	Size aSize( SetImageSize( rGraphic, pOut ) );
	MapMode aMapTwip( MAP_TWIP );
	Rectangle aBoundRect( pShell->GetPos(), aSize );
	aBoundRect += pShell->GetDrawOfs();
	aBoundRect = pOut->LogicToPixel( aBoundRect, aMapTwip );
	aBoundRect = pOut->PixelToLogic( aBoundRect,pOut->GetMapMode().GetMapUnit());

	if( rGraphic.GetType() == GRAPHIC_NONE ||
		rGraphic.GetType() == GRAPHIC_DEFAULT ||
		!rGraphic.IsSupportedGraphic() )
	{
		String aText( pShell->GetCaption());
		if( !aText.Len() )
			aText = aImageURL;
		lcl_DrawReplacement( pOut, rGraphic, aText, aBoundRect.TopLeft(), aBoundRect.GetSize() );
	}
	else
		rGraphic.Draw( pOut, aBoundRect.TopLeft(), aBoundRect.GetSize() );
}

VCPushButtonEngine::VCPushButtonEngine()
{
	pGraphic = 0;
	prMedium = new SfxMediumRef;
	bDrawingImageButton = FALSE;
	bLoadAgain = TRUE;
	bRecalcSize = TRUE;
	pShell = 0;
}

VCPushButtonEngine::~VCPushButtonEngine()
{
	delete pGraphic;
	delete prMedium;
}

void VCPushButtonEngine::PurgeGraphic()
{
	prMedium->Clear();
	DELETEZ( pGraphic );
	bLoadAgain = TRUE;
}

void VCPushButtonEngine::Paint( OutputDevice* pOut )
{
	if( !aImageURL.Len() )
		VCButtonEngine::Paint( pOut );
	else
		LoadImageButton( pOut );
}

Size VCButtonEngine::GetMinSizePixel() const
{
	return Size( 20, 10 );
}

void VCRadioButtonEngine::Check( BOOL bCheck )
{
	bChecked = bCheck;
}

void VCCheckBoxEngine::Check( BOOL bCheck )
{
	bChecked = bCheck;
}

VCRadioButtonEngine::VCRadioButtonEngine()
{
}

VCRadioButtonEngine::~VCRadioButtonEngine()
{
}

VCCheckBoxEngine::VCCheckBoxEngine()
{
}

VCCheckBoxEngine::~VCCheckBoxEngine()
{
}

void VCButtonEngine::DrawBackground( OutputDevice* pOut )
{
	if( aCaption.Len() == 0 )
		return;

	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	Brush aFillBrush( aBackColor, BRUSH_SOLID );
	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aFillBrush );

	Rectangle aRect( GetClientRect( pOut ) );
	pOut->DrawRect( aRect );

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );
}

void VCButtonEngine::DrawBorder( OutputDevice* pOut )
{
	if( bBorder )
	{
		Pen   aOldPen  = pOut->GetPen( );
		pOut->SetPen( Pen() );
		Brush aOldBrush= pOut->GetFillInBrush( );
		pOut->SetFillInBrush( Brush( BRUSH_NULL ) );
		Rectangle aRect( GetClientRect( pOut ) );
		pOut->DrawRect( aRect );
		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
	}
}

#ifndef VCL

Rectangle VCCheckBoxEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
#ifdef MAC
	return Rectangle();
#else
	Font aOldFont( pOut->GetFont( ) );
	pOut->SetFont( rFont );

	// CheckBox Text
	String aText( aCaption );
	Size   aTextSize;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		VCImpControl::ConvertAmpersand( &aText );
		aTextSize = ((Window*)pOut)->GetCtrlTextSize( aText );
	}
	else
	{
		VCImpControl::DeleteAmpersand( &aText );
		aTextSize = pOut->GetTextSize( aText );
	}

	Size   aCheckSize   = ImpGetButtonBmpSizePixel();
	// Weil die Pixel hier mit Bildschirmauflsung gerechnet sind
	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
	aCheckSize = Application::GetDefaultDevice()->PixelToLogic( aCheckSize, aMap2 );

	Rectangle aRect = GetClientRect( pOut );
	Size aXSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
	Point aXPos  = aRect.TopLeft();

#if defined(WIN) || defined(WNT)
	aXPos.X()	+= 3*aXSize.Width() + aCheckSize.Width() + (8*aXSize.Width());
#endif

#ifdef OS2
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aCheckSize = Application::GetDefaultDevice()->PixelToLogic( ImpGetButtonBmpSizePixel(), aMap2 );
	else
	{
		aCheckSize.Width() = aXSize.Width()  * 35;
		aCheckSize.Height()= aXSize.Height() * 35;
	}
	aXPos.X()	+= 3*aXSize.Width() + aCheckSize.Width() + (8*aXSize.Width());
#endif

#ifdef UNX
	aXPos.X()	+= 1 + aCheckSize.Width() + 3;
#endif

	aXPos.Y()	+= (aRect.GetSize().Height() >> 1) - (aTextSize.Height() >> 1);
	Rectangle aTextRect( aXPos, aTextSize );
	aTextRect.Intersection( aRect );

	pOut->SetFont( aOldFont );

	return aTextRect;
#endif
}

#else

Rectangle VCCheckBoxEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	Font aOldFont( pOut->GetFont( ) );
	pOut->SetFont( rFont );

	// CheckBox Text
	String aText( aCaption );
	Size   aTextSize;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		VCImpControl::ConvertAmpersand( &aText );
		aTextSize = ((Window*)pOut)->GetCtrlTextSize( aText );
	}
	else
	{
		VCImpControl::DeleteAmpersand( &aText );
		aTextSize = pOut->GetTextSize( aText );
	}

	Size   aCheckSize   = ImpGetButtonBmpSizePixel();
	// Weil die Pixel hier mit Bildschirmauflsung gerechnet sind
	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
	aCheckSize = Application::GetDefaultDevice()->PixelToLogic( aCheckSize, aMap2 );

	Rectangle aRect = GetClientRect( pOut );
	Size aXSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
	Point aXPos  = aRect.TopLeft();

	aXPos.X()	+= 3*aXSize.Width() + aCheckSize.Width() + (8*aXSize.Width());

	aXPos.Y()	+= (aRect.GetSize().Height() >> 1) - (aTextSize.Height() >> 1);
	Rectangle aTextRect( aXPos, aTextSize );
	aTextRect.Intersection( aRect );

	pOut->SetFont( aOldFont );

	return aTextRect;
}

#endif


void VCPushButtonEngine::SetImageURL( const String& rURL, VCControl* _pShell )
{
	String aURL;
	if( rURL.Len())
		aURL = INetURLObject::SmartRelToAbs( rURL );
	if( !bLoadAgain && aImageURL != aURL )
	{
		bLoadAgain = TRUE;
		DELETEZ(pGraphic);
	}
	aImageURL = aURL;
	pShell = _pShell;
}

void VCPushButtonEngine::LoadImageSync()
{
	if( !pGraphic || bLoadAgain && aImageURL.Len() )
	{
		LoadImage( FALSE );
		DBG_ASSERT( pGraphic, "Graphic not set" );
		SetImageSize( *pGraphic, NULL );
	}
}

//static
Size VCButtonEngine::ImpGetButtonBmpSizePixel()
{
#ifdef VCL

	return Size( 13, 13 ); // Size of Imagelist Bitmaps

#else


#if defined(WIN) || defined(WNT)
	Size aBitmapSize(13,13);
	return aBitmapSize;
#endif
#ifdef OS2
	Size aSize( 16,16 );
	return aSize;
#endif
#ifdef UNX
	return Size(16,16); // the size of a Motif 1.2 checkbox
#endif
#ifdef MAC
	return Size();	// Brauchen wird das ?
#endif


#endif

}


