/*************************************************************************
 *
 *  $RCSfile: vcfont.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_FONT						1024
#define ITEMID_WEIGHT					1025
#define ITEMID_POSTURE					1026
#define ITEMID_FONTHEIGHT				1027
#define ITEMID_COLOR					1028
#define ITEMID_UNDERLINE				1029
#define ITEMID_CROSSEDOUT				1030
#define ITEMID_CONTOUR					1031
#define ITEMID_SHADOWED					1032
#define ITEMID_LANGUAGE 				1033
#define ITEMID_FONTLIST 				1034

#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif

#ifndef _SFXITEMPOOL_HXX
#include <svtools/itempool.hxx>
#endif

#ifndef _SIRESID_HXX
#include <siresid.hxx>
#endif

#ifndef _SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifndef _CTRLTOOL_HXX
#include <svtools/ctrltool.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif

#pragma hdrstop

#ifndef _SVX_CHARDLG_HXX
#include <svx/chardlg.hxx>
#endif

#ifndef _VCATTRID_HRC
#include "vcattrid.hrc"
#endif

#if SUPD > 364

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif

#include "sidll.hxx"

#ifndef _SVX_FONTITEM_HXX
#include <svx/fontitem.hxx>
#endif

#ifndef _SVX_WGHTITEM_HXX
#include <svx/wghtitem.hxx>
#endif

#ifndef _SVX_POSTITEM_HXX
#include <svx/postitem.hxx>
#endif

#ifndef _SVX_FHGTITEM_HXX
#include <svx/fhgtitem.hxx>
#endif

#ifndef _SVX_COLRITEM_HXX
#include <svx/colritem.hxx>
#endif

#ifndef _SVX_UDLNITEM_HXX
#include <svx/udlnitem.hxx>
#endif

#ifndef _SVX_CRSDITEM_HXX
#include <svx/crsditem.hxx>
#endif

#ifndef _SVX_CNTRITEM_HXX
#include <svx/cntritem.hxx>
#endif

#ifndef _SVX_SHDDITEM_HXX
#include <svx/shdditem.hxx>
#endif

#ifndef _SVX_LANGITEM_HXX
#include <svx/langitem.hxx>
#endif

#ifndef _SVX_FLSTITEM_HXX
#include <svx/flstitem.hxx>
#endif

#else

#ifndef _SVX_TEXTITEM_HXX
#include "textitem.hxx"
#endif

#endif

#ifndef _VCFONT_HXX
#include "vcfont.hxx"
#endif

#ifndef _VCFONT_HRC
#include "vcfont.hrc"
#endif


SfxItemPool* VCFontDialog::pPool = 0;

// static pool defaults
//SvxFontItem				aFontDefItem_Impl;
SvxWeightItem	        aWeightDefItem_Impl;
SvxPostureItem       	aPostureDefItem_Impl;
SvxFontHeightItem	    aHeightDefItem_Impl;
SvxColorItem	       	aColorDefItem_Impl;
SvxUnderlineItem		aUnderlineDefItem_Impl;
SvxCrossedOutItem		aCrossedDefItem_Impl;
SvxContourItem			aContourDefItem_Impl;
SvxShadowedItem			aShadowedDefItem_Impl;
SvxLanguageItem			aLanguageDefItem_Impl;
// SvxFontListItem			aFontListDefItem_Impl;

SfxItemInfo __READONLY_DATA aItemInfos[] =
{
	{ SID_ATTR_CHAR_FONT,       SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_WEIGHT,     SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_POSTURE,    SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_FONTHEIGHT, SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_COLOR,      SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_UNDERLINE,  SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_STRIKEOUT,  SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_CONTOUR,    SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_SHADOWED,   SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_LANGUAGE,   SFX_ITEM_POOLABLE },
	{ SID_ATTR_CHAR_FONTLIST,   SFX_ITEM_POOLABLE },
	{ 0,0 }
};

SfxPoolItem* pStaticDefaults[] =
{
	0, //&aFontDefItem_Impl,
	&aWeightDefItem_Impl,
	&aPostureDefItem_Impl,
	&aHeightDefItem_Impl,
	&aColorDefItem_Impl,
	&aUnderlineDefItem_Impl,
	&aCrossedDefItem_Impl,
	&aContourDefItem_Impl,
	&aShadowedDefItem_Impl,
	&aLanguageDefItem_Impl,
	0 // &aFontListDefItem_Impl
};




VCFontDialog::VCFontDialog( const SfxItemSet* _pVCInputItemSet ) :
	SfxTabDialog(
		Application::GetDefDialogParent(),
		SiResId( RID_VC_FONTDIALOG ),
		CreateInputItemSet( _pVCInputItemSet ) ),
	aRiderText( SiResId( 2 ) ),
	pVCInputItemSet( _pVCInputItemSet )
{
	FreeResource();
	AddTabPage(
		ID_VC_FONTTABPAGE,
		aRiderText,
		SvxCharStdPage::Create,
		SvxCharStdPage::GetRanges );
}

VCFontDialog::~VCFontDialog()
{
	delete pInputItemSet;
	DeinitPool();
}

const SfxItemSet* VCFontDialog::CreateInputItemSet( const SfxItemSet* pSet )
{
	// wird im Ctor gerufen!
	// pPool = 0;
	pFontList = 0;
	pInputItemSet = 0;
	pFontDefItem = 0;
	InitPool();
	pInputItemSet = new SfxItemSet( *pPool, TRUE );

	String aName      = ((SfxStringItem&)pSet->Get( VCATTR_FONTNAME )).GetValue();
	long   nSize      = ((SfxInt32Item&)pSet->Get( VCATTR_FONTSIZE )).GetValue();
	BOOL   bBold      = ((SfxBoolItem&)pSet->Get( VCATTR_FONTBOLD )).GetValue();
	BOOL   bItalic    = ((SfxBoolItem&)pSet->Get( VCATTR_FONTITALIC )).GetValue();
	BOOL   bUnderLine = ((SfxBoolItem&)pSet->Get( VCATTR_FONTUNDERLINE )).GetValue();
	BOOL   bStrikeout = ((SfxBoolItem&)pSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue();

	SvxFontItem aFontItem( FAMILY_DONTKNOW, aName, String() );
	pInputItemSet->Put( aFontItem );

	if( bBold )
	{
		SvxWeightItem aWeightItem( WEIGHT_BOLD );
		pInputItemSet->Put( aWeightItem );
	}

	if( nSize )
	{
		nSize *= 20;
		SvxFontHeightItem aHeightItem( (ULONG)nSize );
		pInputItemSet->Put( aHeightItem );
	}

	if( bItalic )
	{
		SvxPostureItem aPostureItem( ITALIC_NORMAL );
		pInputItemSet->Put( aPostureItem );
	}

	if( bUnderLine )
	{
		SvxUnderlineItem aUnderlineItem( UNDERLINE_SINGLE );
		pInputItemSet->Put( aUnderlineItem );
	}

	if( bStrikeout )
	{
		SvxCrossedOutItem aCrossedOutItem( STRIKEOUT_SINGLE );
		pInputItemSet->Put( aCrossedOutItem );
	}

	pInputItemSet->DisableItem( ITEMID_COLOR );
	pInputItemSet->DisableItem( ITEMID_CONTOUR );
	pInputItemSet->DisableItem( ITEMID_SHADOWED );
	pInputItemSet->DisableItem( ITEMID_LANGUAGE );

	return pInputItemSet;
}

SfxItemSet* VCFontDialog::CreateVCOutputItemSet()
{
	const SfxItemSet* pSet = GetOutputItemSet();

	SfxItemSet* pResult = new SfxItemSet(
		*pVCInputItemSet->GetPool(),
		pVCInputItemSet->GetRanges() );

	const SvxFontItem* pFontItem = 0;
	pSet->GetItemState( ITEMID_FONT, TRUE, (const SfxPoolItem**)&pFontItem );
	if( pFontItem )
	{
		SfxStringItem aItem( VCATTR_FONTNAME, pFontItem->GetFamilyName() );
		pResult->Put( aItem );
	}

	const SvxWeightItem* pWeightItem = 0;
	pSet->GetItemState( ITEMID_WEIGHT, TRUE, (const SfxPoolItem**)&pWeightItem );
	if( pWeightItem )
	{
		BOOL bBold = pWeightItem->GetWeight() == WEIGHT_BOLD ? TRUE : FALSE;
		SfxBoolItem aItem( VCATTR_FONTBOLD, bBold );
		pResult->Put( aItem );
	}

	const SvxPostureItem* pPostureItem = 0;
	pSet->GetItemState( ITEMID_POSTURE, TRUE, (const SfxPoolItem**)&pPostureItem );
	if( pPostureItem )
	{
		BOOL bItalic = pPostureItem->GetPosture() != ITALIC_NONE ? TRUE : FALSE;
		SfxBoolItem aItem( VCATTR_FONTITALIC, bItalic );
		pResult->Put( aItem );
	}

	const SvxFontHeightItem* pFontHeightItem = 0;
	pSet->GetItemState( ITEMID_FONTHEIGHT, TRUE, (const SfxPoolItem**)&pFontHeightItem );
	if( pFontHeightItem )
	{
		SfxInt32Item aItem( VCATTR_FONTSIZE, pFontHeightItem->GetHeight() / 20 );
		pResult->Put( aItem );
	}

	const SvxUnderlineItem* pUnderlineItem = 0;
	pSet->GetItemState( ITEMID_UNDERLINE, TRUE, (const SfxPoolItem**)&pUnderlineItem );
	if( pUnderlineItem )
	{
		BOOL bUnderline = pUnderlineItem->GetUnderline() != UNDERLINE_NONE ? TRUE : FALSE;
		SfxBoolItem aItem( VCATTR_FONTUNDERLINE, bUnderline );
		pResult->Put( aItem );
	}

	const SvxCrossedOutItem* pCrossedOutItem = 0;
	pSet->GetItemState( ITEMID_CROSSEDOUT, TRUE, (const SfxPoolItem**)&pCrossedOutItem );
	if( pCrossedOutItem )
	{
		BOOL bStrikeThru = pCrossedOutItem->GetStrikeout() != STRIKEOUT_NONE ? TRUE : FALSE;
		SfxBoolItem aItem( VCATTR_FONTSTRIKETHRU, bStrikeThru );
		pResult->Put( aItem );
	}
	return pResult;
}

void VCFontDialog::InitPool()
{
	if( !pPool )
	{
		if (pStaticDefaults[0] == 0)
		{
			if( !pFontDefItem )
				pFontDefItem = new SvxFontItem;
			pStaticDefaults[ 0 ] = pFontDefItem;
		}

		if (pStaticDefaults[ITEMID_FONTLIST - ITEMID_FONT] == 0)
		{
			if( !pFontList )
				pFontList = new FontList( SI_DLL()->GetOutDev() );
			pStaticDefaults[ITEMID_FONTLIST - ITEMID_FONT] =
				new SvxFontListItem( pFontList );
		}
		pPool = new SfxItemPool( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "VCFontDialog" )),
								 ITEMID_FONT, ITEMID_FONTLIST, &aItemInfos[0] );
		pPool->FreezeIdRanges();
		pPool->SetDefaults (pStaticDefaults);
	}
}

void VCFontDialog::DeinitPool()
{
	// Den Pool muessen wir stehen lassen, da sonst der TabDialog im
	// Dtor platzt, da er ItemSets loescht, die auf den Pool zeigen.
	/*
	if( pPool )
	{
		DELETEZ(pPool);
		SfxItemPool::ReleaseDefaults(
			pStaticDefaults,
			ITEMID_FONTLIST - ITEMID_FONT );
		pStaticDefaults[ITEMID_FONTLIST - ITEMID_FONT] = 0;
		DELETEZ(pFontList);
		DELETEZ(pFontDefItem);
	*/
}

void VCFontDialog::PageCreated( USHORT nId, SfxTabPage &rPage )
{
	if( nId == ID_VC_FONTTABPAGE )
	{
		((SvxCharStdPage&)rPage).SetInfoItem(
			(SvxFontListItem&)pInputItemSet->Get(ITEMID_FONTLIST) );
	}
}


/***************************************************************************

	   Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcfont.cxx,v 1.1.1.1 2000/09/29 11:02:39 mh Exp $

	  Source Code Control System - Update

	  $Log: vcfont.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:39  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:48  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.9  2000/08/04 09:20:52  tbe
	  #77247# GetAppWindow checked in by MM
	
	  Revision 1.8  2000/05/16 12:24:54  pw
	  UNICODE review
	
	  Revision 1.7  2000/05/11 08:10:28  bm
	  unicode
	
	  Revision 1.6  2000/02/10 20:01:26  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.5  1998/09/13 12:32:52  OV
	  #55452# FontItem nicht mehr statisch
	

	  Rev 1.4   13 Sep 1998 14:32:52   OV
   #55452# FontItem nicht mehr statisch

	  Rev 1.3   21 Nov 1997 17:01:28   OV
   Headerumstellung

	  Rev 1.2   24 Oct 1997 10:06:02   TJ
   fehlende Includes fuer 371

	  Rev 1.1   24 Oct 1997 09:52:22   OV
   Fontdialog: Unbenutzte Items disablen

	  Rev 1.0   23 Oct 1997 13:19:32   OV
   Initial revision.

*************************************************************************/


#pragma SEG_EOFMODULE
