/*************************************************************************
 *
 *  $RCSfile: vcform.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <ctype.h>		// isalnum()

//svdraw
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SDR_NOVIEWS
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV

#ifndef _SVX_SIVCDRMOD_HXX //autogen
#include "vcdrmod.hxx"
#endif
#ifndef _VC_VCSBXCONTROL_HXX //autogen
#include <vcsbxctl.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXMACITEM_HXX //autogen
#include <svtools/macitem.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _INETSTRM_HXX //autogen
#include <svtools/inetstrm.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX //autogen
#include <tools/inetmsg.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _SFXFRAME_HXX //autogen
#include <sfx2/frame.hxx>
#endif
#ifndef _SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <sfx2/objsh.hxx>
#endif
#ifndef _INETTYPE_HXX //autogen wg. INetContentTypes
#include <svtools/inettype.hxx>
#endif
#pragma hdrstop

#ifndef _SVX_VCFXTXT_HXX //autogen
#include <vcfxtxt.hxx>
#endif
#ifndef _SVX_SPNBTN_HXX //autogen
#include <vcspnbtn.hxx>
#endif
#ifndef _SVX_VCLBOX_HXX //autogen
#include <vclbox.hxx>
#endif
#ifndef _SVX_VCRDBTTN_HXX //autogen
#include <vcrdbttn.hxx>
#endif
#ifndef _SVX_VCCHKBOX_HXX //autogen
#include <vcchkbox.hxx>
#endif
#ifndef _SVX_VCCBBOX_HXX //autogen
#include <vccbbox.hxx>
#endif
#ifndef _SVX_VCEDIT_HXX //autogen
#include <vcedit.hxx>
#endif
#ifndef _SVX_VCPBTTN_HXX //autogen
#include <vcpbttn.hxx>
#endif

#include <svx/svdio.hxx>
#include <siresid.hxx>
#include <vcform.hxx>
#include <vcattr.hxx>
#include <vctrls.hxx>
#include <vcictrls.hxx>
#define _SI_VCDRAWOBJ
#include <vcsbxdo.hxx>
#include <vcdrwobj.hxx>
#include <formdlg.hrc>
#ifndef _VCTRLS_HRC
#include <vctrls.hrc>
#endif

static USHORT nCurNameId = 0;

VCForm::VCForm( const String& rURL, USHORT nMeth, const String& rEnc, String* pName )
	: aURL( rURL ),
	  nMethod( nMeth ),
	  aEncoding( rEnc )
{
	if( pName )
		aName = *pName;
	if( !aName.Len() )
	{
		String aTempName( RTL_CONSTASCII_USTRINGPARAM( "__soform" ));
		nCurNameId++;
		aTempName.Append( UniString::CreateFromInt32( nCurNameId ) );
		aName = aTempName;
	}
	pMacros = new SvxMacroTableDtor;
}

VCForm::VCForm()
{
	pMacros = new SvxMacroTableDtor;
	String aTempName( RTL_CONSTASCII_USTRINGPARAM( "__soform" ));
	nCurNameId++;
	aTempName.Append( UniString::CreateFromInt32( nCurNameId ) );
	aName = aTempName;
}

VCForm::~VCForm()
{
	delete pMacros;
}

void InsertTextPart( INetMIMEMessage& rParent, const String& rName,
	const String& rData )
{
	INetMIMEMessage* pChild = new INetMIMEMessage;
	String aCntDisp( RTL_CONSTASCII_USTRINGPARAM( "form-data; name=\"" ));
	aCntDisp.Append(rName);
	aCntDisp.Append('\"');
	pChild->SetContentDisposition( aCntDisp );
	pChild->SetContentType( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "text/plain" )));
	SvMemoryStream* pStream = new SvMemoryStream;
	pStream->WriteByteStringLine( rData, gsl_getSystemTextEncoding());
	pStream->Flush();
	pStream->Seek( 0 );
	pChild->SetDocumentLB( new SvLockBytes( pStream, TRUE ) );
	rParent.AttachChild( *pChild );
}

// Rueckgabewert: FALSE==Datei nicht vorhanden oder kein Leserecht. Der
// Submitvorgang sollte abgebrochen werden.

BOOL InsertFilePart( INetMIMEMessage& rParent, const String& rName,
	const String& rFileName )
{
	if( !rFileName.Len() )
		return TRUE;

	DirEntry aDirEntry( rFileName );

	USHORT nErrorRID = 0;
	SvFileStream* pStream = 0;

	if( !aDirEntry.Exists() )
		nErrorRID = WB_ATTACHMENT_NOT_EXISTS;
	else
	{
		aDirEntry.ToAbs();
		pStream = new SvFileStream( aDirEntry.GetFull(), STREAM_READ );
		if( pStream->GetError() )
			nErrorRID = WB_CANNOT_OPEN_ATTACHMENT;
	}
	if( nErrorRID )
	{
		delete pStream;
		WarningBox aWB(GetpApp()->GetDefDialogParent(),SiResId(nErrorRID));
		String aMessText( aWB.GetMessText());
		aDirEntry.ToAbs();
		aMessText.SearchAndReplaceAscii( "%1", aDirEntry.GetFull());

		aWB.SetMessText( aMessText );
		aWB.Execute();
		return FALSE;
	}

	INetMIMEMessage* pChild = new INetMIMEMessage;
	String aCntDisp( RTL_CONSTASCII_USTRINGPARAM( "form-data; name=\"" ));
	aCntDisp.Append(rName);
	aCntDisp.Append('\"');
	aCntDisp.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "; filename=\"" ));
	aCntDisp.Append( rFileName );
	aCntDisp.Append( '\"' );
	pChild->SetContentDisposition( aCntDisp );
	INetContentType eType =
		INetContentTypes::GetContentType4Extension( aDirEntry.GetExtension() );
	pChild->SetContentType( INetContentTypes::GetContentType( eType ) );
	pChild->SetContentTransferEncoding( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "8bit" )));
	pChild->SetDocumentLB( new SvLockBytes( pStream, TRUE ) );
	rParent.AttachChild( *pChild );
	return TRUE;
}

SvLockBytes* VCForm::GetDataMultiPartEncoded( VCControl* pSubmitButton,
		String& rContentType ) const
{
	INetMIMEMessage aParent;
	aParent.EnableAttachChild( INETMSG_MULTIPART_FORM_DATA );
	BOOL bAbort = FALSE;

	ULONG nCount = aCtrlList.Count();
	for( ULONG nCurCtrl=0; nCurCtrl < nCount && !bAbort; nCurCtrl++ )
	{
		VCControl* pCtrl = (VCControl*)aCtrlList.GetObject(nCurCtrl);
		String aName( pCtrl->GetName() );

		if( pCtrl->ISA(VCPushButton) )
		{
			Point  aPosValue;
			String aTextValue;

			USHORT nValueType = GetButtonValue(
				(VCPushButton*)pCtrl, (VCPushButton*)pSubmitButton, aPosValue, aTextValue );

			if( nValueType == BTN_RESULTTYPE_STRING )
			{
				InsertTextPart( aParent, aName, aTextValue );
			}
			else if( nValueType == BTN_RESULTTYPE_IMAGE )
			{
				String aNewName( aName );
				if( aName.Len() )
					aNewName.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ".x" ));
				InsertTextPart( aParent, aNewName, UniString::CreateFromInt32(aPosValue.X()) );

				aNewName = aName;
				if( aName.Len() )
					aNewName.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ".y" ));
				InsertTextPart( aParent, aNewName, UniString::CreateFromInt32(aPosValue.Y()) );
			}
		}
		else if( pCtrl->ISA(VCEdit) && ((VCEdit*)pCtrl)->IsFileUpload() )
		{
			if( !InsertFilePart( aParent, aName, ((VCEdit*)pCtrl)->GetText()))
				bAbort = TRUE;
		}
		else
		{
			String aValue;
			USHORT nElemCount = GetValueAsString( pCtrl, aValue );
			if( nElemCount )
			{
				if( nElemCount > 1 )
				{
					for( USHORT nElem=0; nElem < nElemCount; nElem++ )
					{
						String aToken( aValue.GetToken(nElem, 13) );
						InsertTextPart( aParent, aName, aToken );
					}
				}
				else
				{
					InsertTextPart( aParent, aName, aValue );
				}
			}
		}
	}

	if( bAbort )
		return 0;

	INetMIMEMessageStream aStrmMsg;
	aStrmMsg.SetSourceMessage( &aParent );
	aStrmMsg.GenerateHeader( FALSE );

	SvMemoryStream* pOutStrm = new SvMemoryStream;
	sal_Char* pBuf = new sal_Char[ 1025 ];
	int nRead;
	while( (nRead = aStrmMsg.Read( pBuf, 1024 )) > 0)
	{
		pOutStrm->Write( pBuf, nRead );
	}
	delete[] pBuf;
	pOutStrm->Flush();
	pOutStrm->Seek( 0 );
	SvLockBytes* pResult = new SvLockBytes( pOutStrm, TRUE );

	rContentType = aParent.GetContentType();
	return pResult;
}

String VCForm::GetData( VCControl* pSubmitButton ) const
{
	return GetDataURLEncoded( pSubmitButton );
}

String VCForm::GetDataURLEncoded( VCControl* pSubmitButton ) const
{
	String aResult;
	ULONG nCount = aCtrlList.Count();
	if( nCount == 0 )
		return aResult;

	if( nMethod == FORMMETH_GET )
		aResult = '?'; // beim Posten kein Fragezeichen
	BOOL bFirst = TRUE;
	for( ULONG nCurCtrl=0; nCurCtrl < nCount; nCurCtrl++ )
	{
		VCControl* pCtrl = (VCControl*)aCtrlList.GetObject(nCurCtrl);

		if( pCtrl->Type() == TYPE(VCPushButton) )
		{
			Point  aPosValue;
			String aTextValue;
			String aValue;

			USHORT nValueType = GetButtonValue(
				(VCPushButton*)pCtrl, (VCPushButton*)pSubmitButton, aPosValue, aTextValue );

			if( nValueType == BTN_RESULTTYPE_STRING )
			{
				// Value folgenden Formats erzeugen:
				// <name>=<aTextValue>
				aValue = pCtrl->GetName();
				DBG_ASSERT(aValue.Len(),"GetButtonValue failed");
				Encode( aValue );
				aValue += '='; // darf nicht "encoded" werden!
				Encode( aTextValue );
				aValue += aTextValue;
			}
			else if( nValueType == BTN_RESULTTYPE_IMAGE )
			{
				// Value folgenden Formats erzeugen:
				// <name>.x=<aPos.X>&<name>.y=<aPos.Y>
				String aName( pCtrl->GetName() );
				Encode( aName );
				// Image-Buttons duerfen einen leeren Namen haben
				if( aName.Len() )
					aName += '.';
				aValue = aName;
				aValue.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "x=" ));
				aValue.Append( UniString::CreateFromInt32( aPosValue.X() ) );
				aValue += '&';
				aValue += aName;
				aValue.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "y=" ));
				aValue.Append( UniString::CreateFromInt32( aPosValue.Y() ) );
			}
			if( aValue.Len() )
			{
				if( !bFirst )
					aResult += '&';
				else
					bFirst = FALSE;
				aResult += aValue;
			}
		}
		else
		{
			String aValue;
			USHORT nElemCount = GetValueAsString( pCtrl, aValue );
			if( nElemCount )
			{
				String aName( pCtrl->GetName() );
				Encode( aName );

				if( nElemCount > 1 )
				{
					// Value folgenden Formats erzeugen:
					// <name>=<Token0>&<name>=<Token1>&...&<name>=<TokenN>
					// Tritt bei ListBoxen mit Mehrfachselektion auf
					for( USHORT nElem=0; nElem < nElemCount; nElem++ )
					{
						if( !bFirst )
							aResult += '&';
						else
							bFirst = FALSE;

						String aToken( aValue.GetToken(nElem, 13) );
						Encode( aToken );
						aResult += aName;
						aResult += '=';
						aResult += aToken;
					}
				}
				else
				{
					if( !bFirst )
						aResult += '&';
					else
						bFirst = FALSE;
					Encode( aValue );
					// Value folgenden Formats erzeugen:
					// <name>=<Value>
					aResult += aName;
					aResult += '=';
					aResult += aValue;
				}
			}
		}
	}
	return aResult;
}

// Der Parameter ist 0, wenn die Form keinen SubmitButton hat

BOOL VCForm::Execute( VCControl* pSubmitButton ) const
{
	if( !((VCForm*)this)->_NotifySubmit() )
		return FALSE;
	return Execute_Impl( pSubmitButton );
}

BOOL VCForm::Execute_Impl( VCControl* pSubmitButton ) const
{
	if( !aCtrlList.Count() || !aURL.Len() )
		return FALSE;

#ifndef SVX_LIGHT
	SfxObjectShell* pSh = 0;
	if( pSubmitButton )
		pSh = ((VCDrawModel*)(pSubmitButton->GetDrawObject()->GetModel()))->GetObjectShell();
	else
		pSh = ((VCDrawModel*)(((VCControl*)aCtrlList.GetObject(0))->GetDrawObject()->GetModel()))->GetObjectShell();

	SfxFrameItem aFrm( SID_DOCFRAME, SfxViewFrame::GetFirst(pSh) );
	SfxStringItem aTarget( SID_TARGETNAME, aTargetName );
	String aStrReferer;
	if( pSh )
		aStrReferer = pSh->GetMedium()->GetName();

	SfxStringItem aReferer( SID_REFERER, aStrReferer );
	SfxViewFrame* pCurFrame = SfxViewFrame::Current();
	DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
	SfxDispatcher* pDispatcher = pCurFrame ? pCurFrame->GetDispatcher() : NULL;
	if( aEncoding.EqualsIgnoreCaseAscii( "multipart/form-data" ))
	{
		String aData( GetDataURLEncoded( pSubmitButton ) );
		if( nMethod == FORMMETH_GET )
		{
			String aReqURL = aURL;
			aReqURL += aData;
			SfxStringItem aURLItem( SID_FILE_NAME, aReqURL );

			if( pDispatcher )
			{
				pDispatcher->Execute( SID_OPENURL, SFX_CALLMODE_ASYNCHRON,
										&aURLItem, &aFrm, &aTarget,
										&aReferer, 0L );
			}
		}
		else
		{
			SfxStringItem aURLItem( SID_FILE_NAME, aURL );
			SfxStringItem aPostStr( SID_POSTSTRING, aData );
			if( pDispatcher )
			{
				pDispatcher->Execute( SID_OPENURL, SFX_CALLMODE_ASYNCHRON,
										&aURLItem, &aFrm, &aTarget, &aPostStr,
										&aReferer, 0L );
			}
		}
	}
	else
	{
		String aContentType;
		SvLockBytes* pLockBytes = GetDataMultiPartEncoded( pSubmitButton,
			aContentType );
		if( !pLockBytes )
			return FALSE;
		SfxStringItem aURLItem( SID_FILE_NAME, aURL );
		SfxRefItem aDataItem( SID_POSTLOCKBYTES, pLockBytes );
#ifdef SID_CONTENTTYPE
		SfxStringItem aType( SID_CONTENTTYPE, aContentType );
#endif
		if( pDispatcher )
		{
			pDispatcher->Execute( SID_OPENURL, SFX_CALLMODE_ASYNCHRON,
									&aURLItem, &aFrm, &aTarget, &aDataItem,
									&aReferer,
#ifdef SID_CONTENTTYPE
									&aType,
#endif
									0L );
		}
	}
#endif
	return TRUE;
}

void VCForm::Reset_Impl( void )
{
	ULONG nCount = aCtrlList.Count();
	for( ULONG nCurCtrl=0; nCurCtrl < nCount; nCurCtrl++ )
	{
		VCControl* pCtrl = (VCControl*)aCtrlList.GetObject(nCurCtrl);
		pCtrl->Reset();
	}
}

BOOL VCForm::ExecuteHandler( USHORT nHandlerId, ErrCode* pErrCode )
{
	BOOL bRet = TRUE;

	// Ohne Controls kein VCDrawModel und damit kein Macro
	if( !aCtrlList.Count() )
		return FALSE;

	SvxMacro* pMacro = GetHandlers().Get( nHandlerId );
	if( !pMacro )
		return bRet;

	ErrCode eErr = 0;
	if( !pErrCode )
		pErrCode = &eErr;

	// An die ObjectShell rangraben
	VCControl* pFirstCtrl = (VCControl*)aCtrlList.GetObject(0);
	VCDrawModel* pModel = (VCDrawModel*)pFirstCtrl->GetDrawObject()->GetModel();
	SfxObjectShell* pObjShell = pModel->GetObjectShell();

	switch( pMacro->GetScriptType() )
	{
		case STARBASIC:
		{
			// Wie geht das beim Form?

			/* Uebernommen von VCControl
			SbxArray* pParams = CreateSbxParams( nHandlerId );
			// HACK(CallBasic rafft das sonst nicht)
			// TODO: Beim Import richtig setzen
			if( pMacro->GetLibName().Len() )
			{
				eErr = pModel->CallBasic( pMacro->GetMacName(), pMacro->GetLibName(),
							pSbxControl, pParams );
			}
			else
			{
				short nOldFlags = pSbxControl->GetParent()->GetFlags();
				pSbxControl->GetParent()->SetFlag( SBX_EXTSEARCH );
				pSbxControl->Call( pMacro->GetMacName() );
				pSbxControl->GetParent()->SetFlags( nOldFlags );
				eErr = 0;
			}
			DestroySbxParams( pParams );
			*/
		}
		break;

		default: DBG_ERROR("Unbekannte Sprache in ExecuteHandler");
	}
	return bRet;
}


void VCForm::SetName( const String& rName )
{
	aName = rName;
	ULONG nCount = Count();
	for( ULONG nCurCtrl=0; nCurCtrl < nCount; nCurCtrl++ )
	{
		VCControl* pCtrl = GetControl( nCurCtrl );
		DBG_ASSERT(pCtrl,"Form name not unique");
		pCtrl->SetFormName( rName );
		DBG_ASSERT(Count()==nCount,"Form name not unique");
	}
}


SvStream& operator<<(SvStream& rOut, const VCForm& rCtrl)
{
	rtl_TextEncoding eTextEnc( ::GetStoreCharSet( gsl_getSystemTextEncoding()));

	SdrDownCompat aCompat( rOut, STREAM_WRITE );
	USHORT nVer;
	if( rOut.GetVersion() > SOFFICE_FILEFORMAT_31 )
		nVer = 5;
	else
		nVer = 4;

	rOut << nVer;
	rOut.WriteByteString( rCtrl.aURL, eTextEnc );
	rOut.WriteByteString( rCtrl.aName, eTextEnc );
	rOut << rCtrl.nMethod;
	rOut.WriteByteString( rCtrl.aEncoding, eTextEnc );
	rOut.WriteByteString( rCtrl.aTargetName, eTextEnc );
	rOut.WriteByteString( rCtrl.aSubmitMacro, eTextEnc );
	rOut.WriteByteString( rCtrl.aResetMacro, eTextEnc );
	rOut.WriteByteString( rCtrl.aDummyMacro1, eTextEnc );
	rOut.WriteByteString( rCtrl.aDummyMacro2, eTextEnc );
	if( nVer > 4 )
		rCtrl.pMacros->Write( rOut );

	return rOut;
}

SvStream& operator>>(SvStream& rIn, VCForm& rCtrl)
{
	rtl_TextEncoding eTextEnc( ::GetStoreCharSet( gsl_getSystemTextEncoding()));

	SdrDownCompat aCompat( rIn, STREAM_READ );
	USHORT nVer;
	rIn >> nVer;
	rIn.ReadByteString( rCtrl.aURL, eTextEnc );
	rIn.ReadByteString( rCtrl.aName, eTextEnc );
	rIn >> rCtrl.nMethod;
	if( nVer == 1 )
	{
		USHORT nDummy;
		rIn >> nDummy;
	}
	else
		rIn.ReadByteString( rCtrl.aEncoding, eTextEnc );
	rIn.ReadByteString( rCtrl.aTargetName, eTextEnc );
	if( nVer >= 3 )
		rIn.ReadByteString( rCtrl.aSubmitMacro, eTextEnc );
	if( nVer >= 4 )
	{
		rIn.ReadByteString( rCtrl.aResetMacro, eTextEnc );
		rIn.ReadByteString( rCtrl.aDummyMacro1, eTextEnc );
		rIn.ReadByteString( rCtrl.aDummyMacro2, eTextEnc );
	}
	if( nVer >= 5 )
	{
		rCtrl.pMacros->Read( rIn );
	}
	return rIn;
}

VCControl* VCForm::GetControl( const String & aName ) const
{
	VCControl* pRet = NULL;

	// Liste durchsuchen
	ULONG nCount = aCtrlList.Count();
	for( ULONG nCurCtrl=0; nCurCtrl < nCount; nCurCtrl++ )
	{
		VCControl* pCtrl = (VCControl*)aCtrlList.GetObject(nCurCtrl);
		if( pCtrl->GetName() == aName )
			pRet = pCtrl;
	}
	return pRet;
}

BOOL VCForm::Contains( VCControl* pCtrl ) const
{
	ULONG nPos = aCtrlList.GetPos( (void*) pCtrl );
	if( nPos == LIST_ENTRY_NOTFOUND )
		return FALSE;
	return TRUE;
}


// erstmal umstaendliche Version, da noch kein virtuelles
// GetValueAsString() am VCControl

USHORT VCForm::GetValueAsString( VCControl* pCtrl, String& rResult ) const
{
	rResult.Erase();
	USHORT nElemCount = 1;

	String aCaption = pCtrl->GetCaption();
	String aTag = pCtrl->GetTag();
	String aTagCaption = aTag.Len() ? aTag : aCaption;

	DBG_ASSERT(pCtrl->Type()!=TYPE(VCPushButton),"Button in GetValueAsString");
	if( pCtrl->Type() == TYPE(VCRadioButton) )
	{
		rResult = aTagCaption;
		if( !((VCRadioButton*)pCtrl)->IsChecked() )
			nElemCount = 0;
	}
	else if( pCtrl->Type() == TYPE(VCCheckBox) )
	{
		//rResult = aTagCaption;
		if( !((VCCheckBox*)pCtrl)->IsChecked() )
			nElemCount = 0;
		else
		{
			if( aTag.Len() )
				rResult = aTag;
			else
				rResult.AssignAscii( RTL_CONSTASCII_STRINGPARAM( "on" ));
		}
	}
	else if( pCtrl->Type() == TYPE(VCSpinButton) )
		return 0;
	else if( pCtrl->Type() == TYPE(VCFixedText) )
	{
		rResult = aTagCaption;
	}
	else if( pCtrl->Type() == TYPE(VCListBox) )
	{
		VCListBox* pLBox = (VCListBox*)pCtrl;
		ULONG nCount = pLBox->GetEntryCount();
		BOOL bFirst = TRUE;
		nElemCount = 0;
		for( ULONG nCur = 0; nCur < nCount; nCur++ )
		{
			if( pLBox->IsEntrySelected( nCur ) )
			{
				if( !bFirst )
					rResult += (sal_Unicode)13;
				else
					bFirst = FALSE;
				String aTemp( pLBox->GetItemData( nCur ) );
				if( aTemp.Len() )
					rResult += aTemp;
				else
					rResult += pLBox->GetEntry( nCur );
				nElemCount++;
			}
		}
	}
	else if( pCtrl->Type() == TYPE(VCComboBox) )
	{
		rResult = ((VCComboBox*)pCtrl)->GetText();
		if( ((VCComboBox*)pCtrl)->GetStyle() == VCCOMBO_DDLIST )
		{
			String aSel( ((VCComboBox*)pCtrl)->GetSelectEntry() );
			ULONG nSelPos = ((VCComboBox*)pCtrl)->GetEntryPos( aSel );
			aSel = ((VCComboBox*)pCtrl)->GetItemData( nSelPos );
			if( aSel.Len() )
				rResult = aSel;
		}
	}
	else if( pCtrl->Type() == TYPE(VCEdit) )
	{
		rResult = ((VCEdit*)pCtrl)->GetText();
	}
	return nElemCount;
}

void VCForm::Encode( String& rString ) const
{
	String aResult;

	rString.ConvertLineEnd( LINEEND_CR );

	USHORT nStrLen = rString.Len();
	for( USHORT nCurPos=0; nCurPos < nStrLen; nCurPos++ )
	{
		sal_Unicode nChar = rString.GetChar( nCurPos );
		 
		if( ( ( ( ( nChar >= 97) && ( nChar <= 122) )   || 
			    ( ( nChar >= 65) && ( nChar <=	90) ) || 
			    ( ( nChar >= 48) && ( nChar <=	57) ) )  &&
			  nChar != ' ') || nChar > 127 )
		{
			switch( nChar )
			{
				case 13: // Zeilenumbruch
					aResult.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "%0D%0A" ));
					break;
				// Netscape Sonderbehandlung
				case '*':
				case '-':
				case '.':
				case '@':
				case '_':
					aResult.Append( nChar );
					break;
				default:
					{
					// in Hex umrechnen
					short nHi = nChar / 16;
					short nLo = nChar - (nHi*16);
					if( nHi > 9 ) nHi += 'A'-10; else nHi += '0';
					if( nLo > 9 ) nLo += 'A'-10; else nLo += '0';
					aResult += '%';
					aResult += (sal_Unicode)nHi;
					aResult += (sal_Unicode)nLo;
					}
			}
		}
		else
			aResult += (sal_Unicode)nChar;
	}
	USHORT nSearchPos = 0;
	do {
		nSearchPos = aResult.SearchAndReplace( ' ', '+', nSearchPos );
	} while( nSearchPos != STRING_NOTFOUND );
	rString = aResult;
}

void VCForm::Reset()
{
	if( _NotifyReset() )
		Reset_Impl();
}

BOOL VCForm::IsStandardForm() const
{
	String aStdFormName( SiResId(STR_STDFORM));
	if( aName == aStdFormName )
		return TRUE;
	return FALSE;
}

VCControl* VCForm::Next( VCControl* pStart, BOOL bReverse, BOOL bSameType ) const
{
	ULONG nPos = aCtrlList.GetPos( pStart );
	ULONG nCount = aCtrlList.Count();
	VCControl* pResult = 0;
	if( nPos == LIST_ENTRY_NOTFOUND )
		return 0;
	do
	{
		if( bReverse )
		{
			if( nPos )
				nPos--;
			else
				nPos = nCount - 1;
		}
		else
		{
			nPos++;
			if( nPos == nCount )
				nPos = 0;
		}
		pResult = (VCControl*)aCtrlList.GetObject( nPos );
	} while( pResult->Type()!=pStart->Type() && pResult != pStart );
	if( pResult == pStart )
		return 0;
	return pResult;
}


/*
	fuehrt ein Execute auf die Form aus, wenn es genau ein
	EditControl und maximal einen SubmitButton gibt
*/

BOOL VCForm::ExecuteDefault() const
{
	USHORT nSubmitCount=0, nEditCount=0;
	VCControl* pSubmitButton = 0;

	ULONG nCount = aCtrlList.Count();
	DBG_ASSERT(nCount,"Form is empty");
	for( ULONG nCurCtrl=0; nCurCtrl < nCount; nCurCtrl++ )
	{
		VCControl* pCtrl = (VCControl*)aCtrlList.GetObject(nCurCtrl);
		if(pCtrl->Type()==TYPE(VCPushButton) && ((VCPushButton*)pCtrl)->GetFormAction()==VCFORMACTION_SUBMIT)
		{
			if( ((VCPushButton*)pCtrl)->GetImageURL().Len() )
				nSubmitCount++; // abbrechen!
			nSubmitCount++;
			pSubmitButton = pCtrl;
			if( nSubmitCount > 1 )
				return TRUE;
		}
		else if(pCtrl->Type()==TYPE(VCEdit))
		{
			nEditCount++;
			if( nEditCount > 1 )
				return TRUE;
		}
	}
	return Execute( pSubmitButton );
}


void VCForm::NotifyReset()
{
}
void VCForm::NotifySubmit()
{
}

BOOL VCForm::_NotifySubmit()
{
	return ExecuteHandler( VCHDL_ONSUBMITFORM );
}

BOOL VCForm::_NotifyReset()
{
	return ExecuteHandler( VCHDL_ONRESETFORM );
}

void VCForm::SetHandlers( const SvxMacroTableDtor& rMacros )
{
	*pMacros = rMacros;
}

USHORT VCForm::GetButtonValue(
	VCPushButton* pButton, // any Button of Form
	VCPushButton* pPushedButton, // currently pressed Submitbutton
	Point& rImageBtnValue, String& rPushBtnValue ) const
{
	return 0;
}



