/*************************************************************************
 *
 *  $RCSfile: vcictrl1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SV_METRIC_HXX //autogen
#include <vcl/metric.hxx>
#endif
#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#pragma hdrstop

#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#include <svx/impgrf.hxx>
#include "vcalgit.hxx"
#include "vcfxtxt.hxx"
#include "vcspnbtn.hxx"
#include "vcnkstit.hxx"
#define _SI_VCITEMS
#define _SI_VCDRAWOBJ
#include "vctrls.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vcont.hxx"
#include "vcengin.hxx"
#include "vcictrls.hxx"
#define _SI_NOVCDRAWPAGE
#define _SI_NOVCDRAWVIEW
#include "vcdrwobj.hxx"

class GraphicFilter;

void VCImpControl::UpdateFromItemSet( USHORT )
{
}

// static
void VCImpControl::ConvertAmpersand( String* pStr )
{
	USHORT i;
	BOOL bTilde = FALSE;
	for (i=0; i < pStr->Len(); i++ )
	{
		if( pStr->GetChar( i ) == '&' )
		{
			if( ((i+1) < pStr->Len()) && (pStr->GetChar( (USHORT)(i+1) ) != '&') )
			{
				if( !bTilde )
				{
					pStr->SetChar( i, '~' );
					bTilde = TRUE;
				}
			}
			else
			if( ((i+1) < pStr->Len()) )
				pStr->Erase( i+1, 1 );
		}
	}
}

// static
void VCImpControl::DeleteAmpersand( String* pStr )
{
	USHORT i;
	for(i=0; i < pStr->Len(); )
	{
		if( (pStr->GetChar( i ) == '&') )
		{
			pStr->Erase( i, 1 );
			if( (i < pStr->Len()) && (pStr->GetChar( i ) == '&') )
				i++;
		}
		else
		if( (pStr->GetChar( i ) == '~') )
		{
			pStr->Erase( i, 1 );
			if( (i < pStr->Len()) && (pStr->GetChar( i ) == '~') )
				i++;
		}
		else
			i++;
	}
}

VCImpControl::VCImpControl( VCControl* pShell ) :
	pActMouseEvent(NULL),
	pActKeyEvent(NULL)
{
	VCImpControl::pShell = pShell;
}

VCImpControl::~VCImpControl()
{
}

void VCImpControl::Update( BOOL, USHORT )
{
}

void VCImpControl::UpdateValue()
{
}

Size VCImpControl::GetMinSizePixel() const
{
	return Size( 20, 10 );
}

Font VCImpControl::GetFont( OutputDevice* pOut, BOOL bWithColors ) const
{
	SfxItemSet* pItemSet = pShell->GetItemSet();
	String  aFontName   = ((SfxStringItem&)pItemSet->Get( VCATTR_FONTNAME )).GetValue();

	// ist kein Name gesetzt, wird der Font des Output-Devices genommen
	if( aFontName.Len() == 0 )
	{
		Font aFont( pOut->GetFont() );
		if( bWithColors )
		{
			aFont.SetColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );
			aFont.SetFillColor( ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue() );
		}
		return aFont;
	}

	long    nFontHeightPoint = ((SfxInt32Item&)pItemSet->Get( VCATTR_FONTSIZE )).GetValue();

	long    nFontHeightPixel = pOut->LogicToPixel( Size( 0, nFontHeightPoint ),
												   MAP_POINT ).Height();

	MapMode aMap = pOut->GetMapMode();
	MapMode aMap1( aMap.GetMapUnit() );
	long nFontHeight  = pOut->PixelToLogic( Size( 0, nFontHeightPixel ),
											aMap1 ).Height();

	// Kein MS Sans Serif auf Druckern
	if( aFontName.EqualsIgnoreCaseAscii( "MS Sans Serif" ) )
		aFontName = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Arial" ) );

	Font aFont( aFontName, Size( 0, nFontHeight ) );

	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTBOLD )).GetValue() )
		aFont.SetWeight( WEIGHT_BOLD );
	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTITALIC )).GetValue() )
		aFont.SetItalic( ITALIC_NORMAL );
	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue() )
		aFont.SetStrikeout( STRIKEOUT_SINGLE );
	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTUNDERLINE )).GetValue() )
		aFont.SetUnderline( UNDERLINE_SINGLE );

	if( bWithColors )
	{
		aFont.SetColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );
		aFont.SetFillColor( ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue() );
	}

	aFont.SetTransparent( TRUE );

	// Sonderbehandlung, damit bei kleinen Groessen kein BitmapFont verwendet wird
	if( pOut->LogicToPixel( Size( 0, nFontHeight ) ).Height() < 6 )
	{
		FontMetric aMetric = pOut->GetFontMetric( aFont );
		if( aMetric.GetType() == TYPE_RASTER )
		{
			aFont.SetName( String() );
			aFont.SetFamily( FAMILY_SWISS );
		}
	}

	return aFont;
}

void VCImpControl::Paint( OutputDevice* )
{
}

void VCImpControl::MouseButtonDown( Window*, const MouseEvent& )
{
}

void VCImpControl::MouseButtonUp( Window*, const MouseEvent& )
{
}

void VCImpControl::MouseMove( Window*, const MouseEvent& )
{
}

void VCImpControl::KeyInput( Window*, const KeyEvent& )
{
}


