/*************************************************************************
 *
 *  $RCSfile: vcictrl2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SFXSLSTITM_HXX
#include <svtools/slstitm.hxx>
#endif
#ifndef _ACCEL_HXX
#include <vcl/accel.hxx>
#endif
#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif
//#ifndef _SV_FILEDLG_HXX
//#include <svtools/filedlg.hxx>
//#endif
#ifndef _IODLG_HXX
#include <sfx2/iodlg.hxx>
#endif

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#pragma hdrstop

#define ITEMID_COLOR 0

#include "vccbbox.hxx"
#include "vcscrbar.hxx"
#include "vclbox.hxx"
#include <svx/colritem.hxx>
#define _SI_VCITEMS
#include "vctrls.hxx"
#include "vcattr.hxx"
#include "siresid.hxx"
#include "vcattrid.hrc"
#include "vctrls.hrc"
#include "vcont.hxx"
#include "vcengin.hxx"
#include "vcengin2.hxx"
#include "sidll.hxx"

#ifndef VCL

#ifdef UNX
#define private public
#define protected public
#include "vcictrls.hxx"
#undef private
#undef protected
#else
#include "vcictrls.hxx"
#endif

#else

#include "vcictrls.hxx"

#endif


// defines fuers FileUpload-Edit
// Einheiten in App-Font
#define BUTTONWIDTH_MAX 90
#define BUTTONWIDTH_MIN 5
#define DIST_EDITBUTTON	4

static long GetButtonWidthMax( const String& rCaption, OutputDevice* pOut )
{
	static long nButtonWidthMax = 0;
	static String aStr;
	if( !nButtonWidthMax || aStr != rCaption)
	{
		aStr = rCaption;
		Font aFont( GetpApp()->GetAppFont() );
		Font aOldFont( pOut->GetFont() );
		pOut->SetFont( aOldFont );
		Size aSize = pOut->GetTextSize( rCaption );
		MapMode aMap( MAP_APPFONT );
		aSize = pOut->LogicToPixel( aSize );
		aSize = pOut->PixelToLogic( aSize, aMap );
		pOut->SetFont( aOldFont );
		nButtonWidthMax = aSize.Width() + 5;
	}
	return nButtonWidthMax;
}

// LogicToLogic gibt Mumpitz zurueck
static OVAppToTwip( long n, OutputDevice* pOut )
{
	Size aSize( n,0);
	aSize = pOut->LogicToPixel( aSize, MapMode( MAP_APPFONT ));
	aSize = pOut->PixelToLogic( aSize, MapMode( MAP_TWIP ));
	return aSize.Width();
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::UpdateFromItemSet( USHORT nWhich )
{
	// Position und Groesse ueber Basisklasse
	VCImpVirtControl::UpdateFromItemSet( nWhich );

	Rectangle aRect = SI_DLL()->GetOutDev->LogicToPixel( aBoundRect,
					MapMode( MAP_TWIP ) );
	aRect = SI_DLL()->GetOutDev()->PixelToLogic( aRect,
					MapMode( pShell->GetOutUnit() ) );
	pListEngine->SetPos( aRect.TopLeft() );
	pListEngine->SetSize( aRect.GetSize() );

	SfxItemSet* pItemSet = pShell->GetItemSet();

	// Enable
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnable = ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		pListEngine->Enable( bEnable );
	}

	// Farben
	if( !nWhich || (nWhich == VCATTR_FORECOLOR) || (nWhich == VCATTR_BACKCOLOR) )
	{
		pListEngine->SetForeColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );
		pListEngine->SetBackColor( ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue() );
	}

	// Liste neu setzen
	if( !nWhich || (nWhich==VCATTR_LIST || nWhich == VCATTR_SORTED) )
	{
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		pListEngine->SetList( rItem.GetList() );

		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() && pListEngine->GetList() )
		{
			String aLinkData = pShell->GetLinkData( aLinkName );
			List* pList = pListEngine->GetList();
			ULONG i;
			for( i=0; i < pList->Count(); i++ )
			{
				if( ((String*)pList->GetObject( i ))->ICompare( aLinkData ) == COMPARE_EQUAL )
				{
					pListEngine->SetSelectEntry( (ULONG)i, TRUE );
					break;
				}
			}
			if( i == pList->Count() )
				pListEngine->SetSelectEntry( pListEngine->GetSelectEntry(), FALSE );
		}
	}

	// ItemData mit Liste synchronisieren
	if( !nWhich || (nWhich==VCATTR_ITEMDATA) || (nWhich==VCATTR_LIST) )
	{
		VCIntegerListItem* pItemData = (VCIntegerListItem*)
										pItemSet->Get( VCATTR_ITEMDATA ).Clone();
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		pItemData->SetEntryCount( (USHORT)pList->Count() );
		pItemSet->Put( *pItemData );
		delete pItemData;
	}

	// SelectStyle auswhlen
	if( !nWhich || (nWhich==VCATTR_MULTISELECT) )
	{
		USHORT eMulti = (USHORT)((VCMultiSelectItem&)pItemSet->
									Get( VCATTR_MULTISELECT )).GetValue();
		VCListBoxStyle eStyle;
		switch( eMulti )
		{
			case VCMULTI_SINGLE:		eStyle = VCLISTBOX_SINGLE; break;
			case VCMULTI_SIMPLEMULTI:	eStyle = VCLISTBOX_MULTIPLE_S; break;
			case VCMULTI_EXTMULTI:		eStyle = VCLISTBOX_MULTIPLE_E; break;
		}

		pListEngine->SetSelectStyle( eStyle );
	}
}

// ------------------------------------------------------------------------
Size VCImpVirtListBox::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalbv erstmal setzen
	pListEngine->SetFont( GetFont( pOut ) );
	return pListEngine->GetOptSize( pOut );
}

// ------------------------------------------------------------------------
USHORT VCImpVirtListBox::GetLineCount( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalbv erstmal setzen
	pListEngine->SetFont( GetFont( pOut ) );
	return pListEngine->GetLineCount( pOut );
}

// ------------------------------------------------------------------------
Size VCImpVirtListBox::GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalbv erstmal setzen
	pListEngine->SetFont( GetFont( pOut ) );
	return pListEngine->GetOptSize( rCharXY, pOut );
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtListBox, ListEngineSelect, VCListBoxEngine *, EMPTYARG )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
	{
		ULONG nSelect = pListEngine->GetSelectEntry();
		if( nSelect == 0xFFFFFFFF )
			pShell->SetLinkData( aLinkName, String() );
		else
		{
			String* pStr = (String*)(pListEngine->GetList()->GetObject(nSelect));
			pShell->SetLinkData( aLinkName, *pStr );
		}
	}

	Update( FALSE );

	pShell->Selected();
	return 0;
}

// ------------------------------------------------------------------------
VCImpVirtListBox::VCImpVirtListBox( VCControl* pShell ) :
	VCImpVirtControl( pShell ),
	pListEngine( new VCListBoxEngine )
{
	UpdateFromItemSet();
	pListEngine->SetBorder( TRUE );
	pListEngine->SetSelectHdl( LINK( this, VCImpVirtListBox, ListEngineSelect ) );
}

// ------------------------------------------------------------------------
VCImpVirtListBox::~VCImpVirtListBox()
{
	delete pListEngine;
}

// ------------------------------------------------------------------------
Size VCImpVirtListBox::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

// ------------------------------------------------------------------------
USHORT VCImpVirtListBox::InsertEntry( const String& rStr, ULONG nPos )
{
	USHORT nNewIndex = pListEngine->InsertEntry( rStr, nPos );
	Update( FALSE ); // ohne ItemSets updaten
	return nNewIndex;
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::RemoveEntry( ULONG nPos )
{
	pListEngine->RemoveEntry( nPos ); //SetNewIndex( 0xFFFFFFFF );
	Update( FALSE );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	pListEngine->ReplaceEntry( rStr, nPos );
	Update( FALSE );
}

// ------------------------------------------------------------------------
String VCImpVirtListBox::GetSelectEntry() const
{
	ULONG nEntry = pListEngine->GetSelectEntry();

	List* pList = pListEngine->GetList();

	if( pList )
	{
		String* pEntry = (String*)pList->GetObject( nEntry );
		if( pEntry )
			return *pEntry;
	}

	return String();
}

// ------------------------------------------------------------------------
ULONG VCImpVirtListBox::GetSelectEntryPos() const
{
	return pListEngine->GetSelectEntry();
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::SelectEntryPos( ULONG nPos, BOOL bSelect )
{
	pListEngine->SetSelectEntry( nPos, bSelect );
	Update( FALSE );
}

// ------------------------------------------------------------------------
BOOL VCImpVirtListBox::IsEntrySelected( ULONG nPos )
{
	return pListEngine->IsEntrySelected( nPos );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::Clear()
{
	pListEngine->Clear();
	Update( FALSE );
}

// ------------------------------------------------------------------------
ULONG VCImpVirtListBox::GetTopIndex() const
{
	return pListEngine->GetFirstVisible();
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::SetTopIndex( ULONG nIndex )
{
	pListEngine->SetFirstVisible( nIndex );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::Update( BOOL bWithItems, USHORT nUpdWhich )
{
	if( bWithItems && pShell->ISA(VCListBox) )
	{
		if( ((VCListBox*)pShell)->IsSorted() && (nUpdWhich == VCATTR_LIST || nUpdWhich == VCATTR_SORTED) )
		{
			SfxItemSet* pItemSet = pShell->GetItemSet();
			SfxStringListItem* pItem = (SfxStringListItem*)pItemSet->Get(VCATTR_LIST).Clone();
			VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->Get(VCATTR_ITEMDATA).Clone();
			pItemData->SetEntryCount( (USHORT)pItem->GetList()->Count() );
			// das sollte nochmal optimiert werden!
			pItem->Sort( TRUE, pItemData->GetList() );
			pItemSet->Put( *pItem );
			delete pItem;
			pItemSet->Put( *pItemData );
			delete pItemData;
		}
	}
	if( bWithItems )
		UpdateFromItemSet( nUpdWhich );
	VCContainer* pContainer = pShell->GetParent();
	if( pContainer && pContainer->IsA( TYPE( VCManager ) ) )
		((VCManager*)pContainer)->
			PaintControl( pShell, FALSE, pListEngine->GetActWin() );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;
	pListEngine->SetFont( GetFont( pOut ) );
	pListEngine->Paint( pOut );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::MouseButtonDown( Window* pWin, const MouseEvent& rMEvt )
{
	pActMouseEvent = (MouseEvent*)&rMEvt;
	pActWindow = pWin;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pShell->HasOverlayObjects() )
		Paint( pWin );
	pListEngine->MouseButtonDown( pWin, aEvt );
	VCImpVirtControl::MouseButtonDown( pWin, rMEvt );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::MouseButtonUp( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pListEngine->MouseButtonUp( pWin, aEvt );
	VCImpVirtControl::MouseButtonUp( pWin, rMEvt );

	pShell->InvalidateOverlayObjects( pWin );
}

// ------------------------------------------------------------------------
void VCImpVirtListBox::MouseMove( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	VCImpVirtControl::MouseMove( pWin, rMEvt );
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pListEngine->MouseMove( pWin, aEvt );
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtComboBox, TextModify, VCComboBoxEngineBase *, EMPTYARG )
{
	String aText = pComboEngine->GetText();
	SfxItemSet* pItemSet = pShell->GetItemSet();

	SfxStringItem aTextItem( VCATTR_TEXT, aText );
	pItemSet->Put( aTextItem );

	String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
		pShell->SetLinkData( aLinkName, pComboEngine->GetText() );

	Update(FALSE);
	pShell->Modified();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtComboBox,GotFocus, VCComboBoxEngineBase *, EMPTYARG  )
{
	pShell->GotFocus();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtComboBox,LostFocus, VCComboBoxEngineBase *, EMPTYARG  )
{
	pShell->LostFocus();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtComboBox, Select, VCComboBoxEngineBase *, EMPTYARG )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
	{
		ULONG nSelect = pComboEngine->GetSelectEntry();
		if( nSelect == 0xFFFFFFFF )
			pShell->SetLinkData( aLinkName, String() );
		else
		{
			String* pStr = (String*)(pComboEngine->GetList()->GetObject(nSelect));
			pShell->SetLinkData( aLinkName, *pStr );
		}
	}

	Update(FALSE);
	pShell->Selected();
	return 0;
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::UpdateFromItemSet( USHORT nWhich )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	USHORT eNewStyle = (USHORT)((VCComboStyleItem&)
								pItemSet->Get( VCATTR_COMBOSTYLE )).GetValue();

	if( (USHORT)eNewStyle != eStyle )
	{
		ULONG nOldSelect = pComboEngine->GetSelectEntry();

		eStyle = (USHORT)eNewStyle;

		delete pComboEngine;
		if( eNewStyle == VCCOMBO_DDLIST )
			pComboEngine = new VCDDListBoxEngine( pShell );
		else
		if( eNewStyle == VCCOMBO_COMBO )
			pComboEngine = new VCComboBoxEngine( pShell );
		else
			pComboEngine = new VCDDComboBoxEngine( pShell );

		pComboEngine->SetTextModifyHdl( LINK( this, VCImpVirtComboBox, TextModify ) );
		pComboEngine->SetSelectHdl( LINK( this, VCImpVirtComboBox, Select ) );
		pComboEngine->SetSelectEntry( nOldSelect );
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get(VCATTR_LIST);
		pComboEngine->SetList( rItem.GetList() );
	}

	// Position und Groesse ueber Basisklasse
	VCImpVirtControl::UpdateFromItemSet( nWhich );

	Rectangle aRect = SI_DLL()->GetOutDev()->LogicToPixel( aBoundRect,
					MapMode( MAP_TWIP ) );
	aRect = SI_DLL()->GetOutDev()->PixelToLogic( aRect,
					MapMode( pShell->GetOutUnit() ) );
	pComboEngine->SetPos( aRect.TopLeft() );
	pComboEngine->SetSize( aRect.GetSize() );

	// Enable
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnable = ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		pComboEngine->Enable( bEnable );
	}

	// Farben
	if( !nWhich || (nWhich == VCATTR_FORECOLOR) || (nWhich == VCATTR_BACKCOLOR) )
	{
		pComboEngine->SetForeColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );
		pComboEngine->SetBackColor( ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue() );
	}

	// Liste neu setzen
	if( !nWhich || (nWhich==VCATTR_LIST || nWhich == VCATTR_SORTED) )
	{
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		pComboEngine->SetList( rItem.GetList() );

		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() && pComboEngine->GetList() )
		{
			String aLinkData = pShell->GetLinkData( aLinkName );
			List* pList = pComboEngine->GetList();
			ULONG i;
			for( i=0; i < pList->Count(); i++ )
			{
				if( ((String*)pList->GetObject( i ))->ICompare( aLinkData ) == COMPARE_EQUAL )
				{
					pComboEngine->SetSelectEntry( (ULONG)i );
					break;
				}
			}
			if( i == pList->Count() )
				pComboEngine->SetSelectEntry( 0xFFFFFFFF );
		}
	}

	// ItemData mit Liste synchronisieren
	if( !nWhich || (nWhich==VCATTR_ITEMDATA) || (nWhich==VCATTR_LIST) )
	{
		VCIntegerListItem* pItemData = (VCIntegerListItem*)
										pItemSet->Get( VCATTR_ITEMDATA ).Clone();
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		pItemData->SetEntryCount( (USHORT)pList->Count() );
		pItemSet->Put( *pItemData );
		delete pItemData;
	}

	// Text aktualisieren
	if( !nWhich || nWhich == VCATTR_TEXT || nWhich == VCATTR_LINK )
	{
		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() && pShell->GetParent()->IsUpdatingLinkData() )
			pComboEngine->SetText( pShell->GetLinkData( aLinkName ) );
		else
		{
			// Text-Property bei DropDown-ListBox ignorieren
			if( eNewStyle != VCCOMBO_DDLIST )
			{
				String aStr = ((SfxStringItem&)pItemSet->Get(VCATTR_TEXT)).GetValue();
				pComboEngine->SetText( aStr );
			}
		}
	}
}

// ------------------------------------------------------------------------
VCImpVirtComboBox::VCImpVirtComboBox( VCControl* pShell ) :
	VCImpVirtControl( pShell ),
	pComboEngine( new VCDDListBoxEngine(pShell) ),
	eStyle( (USHORT)VCCOMBO_DDLIST )
{
	UpdateFromItemSet();
	pComboEngine->SetTextModifyHdl( LINK( this, VCImpVirtComboBox, TextModify ) );
	pComboEngine->SetSelectHdl( LINK( this, VCImpVirtComboBox, Select ) );
	pComboEngine->SetGotFocusHdl( LINK( this, VCImpVirtComboBox, GotFocus ) );
	pComboEngine->SetLostFocusHdl( LINK( this, VCImpVirtComboBox, LostFocus) );
}

// ------------------------------------------------------------------------
VCImpVirtComboBox::~VCImpVirtComboBox()
{
	delete pComboEngine;
}

// ------------------------------------------------------------------------
Size VCImpVirtComboBox::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

// ------------------------------------------------------------------------
String VCImpVirtComboBox::GetText() const
{
	return pComboEngine->GetText();
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::SetText( const String& rText )
{
	pComboEngine->SetText( rText );
}

// ------------------------------------------------------------------------
USHORT VCImpVirtComboBox::InsertEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem& rItem = (SfxStringListItem&)pShell->GetItemSet()->
								Get( VCATTR_LIST );
	pComboEngine->SetList( rItem.GetList() );
	Update( FALSE );
	return (USHORT)nPos;
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::RemoveEntry( ULONG nPos )
{
	SfxStringListItem& rItem = (SfxStringListItem&)pShell->GetItemSet()->
								Get( VCATTR_LIST );
	pComboEngine->SetList( rItem.GetList() );
	Update( FALSE );
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem& rItem = (SfxStringListItem&)pShell->GetItemSet()->
								Get( VCATTR_LIST );
	pComboEngine->SetList( rItem.GetList() );
	Update( FALSE );
}

// ------------------------------------------------------------------------
String VCImpVirtComboBox::GetSelectEntry() const
{
	return pComboEngine->GetText();
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::Clear()
{
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::SetStyle( USHORT eStyle )
{
	VCImpVirtComboBox::eStyle = eStyle;
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::Update( BOOL bWithItems,USHORT nUpdWhich )
{
	VCComboBox* pSh = (VCComboBox*)pShell;

	if( bWithItems && pShell->ISA(VCComboBox) )
	{
		if( pSh->IsSorted() && (nUpdWhich == VCATTR_LIST || nUpdWhich == VCATTR_SORTED) )
		{
			SfxItemSet* pItemSet = pShell->GetItemSet();
			SfxStringListItem* pItem = (SfxStringListItem*)pItemSet->Get(VCATTR_LIST).Clone();
			VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->Get(VCATTR_ITEMDATA).Clone();
			pItemData->SetEntryCount( (USHORT)pItem->GetList()->Count() );
			// das sollte nochmal optimiert werden!
			pItem->Sort( TRUE, pItemData->GetList() );
			pItemSet->Put( *pItem );
			delete pItem;
			pItemSet->Put( *pItemData );
			delete pItemData;
		}
	}

	if( pSh->GetStyle() == VCCOMBO_DDLIST )
	{
		if( pSh->GetText().Len() == 0 )
		{
			pSh->SetText( pSh->GetEntry(0) );
		}
	}
	if( bWithItems )
		UpdateFromItemSet( nUpdWhich );
	VCContainer* pContainer = pShell->GetParent();
	if( pContainer && pContainer->IsA( TYPE( VCManager ) ) )
	{
		Window* pCurWin = pComboEngine->GetActWin();
		if( !pCurWin )
		{
			pCurWin = pComboEngine->GetActiveEditWin();
			if( pCurWin )
				pCurWin = pCurWin->GetParent();
		}
		((VCManager*)pContainer)->PaintControl( pShell, FALSE, pCurWin );
	}
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;
	pComboEngine->SetFont( GetFont( pOut ) );
	pComboEngine->Paint( pOut );
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::MouseButtonDown( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pShell->HasOverlayObjects() )
		Paint( pWin );
	pComboEngine->MouseButtonDown( pWin, aEvt );
	VCImpVirtControl::MouseButtonDown( pWin, rMEvt );
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::MouseButtonUp( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pComboEngine->MouseButtonUp( pWin, aEvt );
	VCImpVirtControl::MouseButtonUp( pWin, rMEvt );

	pShell->InvalidateOverlayObjects( pWin );
}

// ------------------------------------------------------------------------
void VCImpVirtComboBox::MouseMove( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	VCImpVirtControl::MouseMove( pWin, rMEvt );
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pComboEngine->MouseMove( pWin, aEvt );
}

// ------------------------------------------------------------------------
Size VCImpVirtComboBox::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalbv erstmal setzen
	pComboEngine->SetFont( GetFont( pOut ) );
	return pComboEngine->GetOptSize( pOut );
}

// ------------------------------------------------------------------------
ULONG VCImpVirtComboBox::GetListIndex() const
{
	return pComboEngine->GetSelectEntry();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::UpdateFromItemSet( USHORT nWhich )
{
	static USHORT __READONLY_DATA pFontWhiches[] =
	{
		VCATTR_FONTNAME, VCATTR_FONTSIZE, VCATTR_FONTBOLD,
		VCATTR_FONTITALIC, VCATTR_FONTSTRIKETHRU, VCATTR_FONTUNDERLINE,
		0
	};

	// Position und Groesse ueber Basisklasse
	VCImpVirtControl::UpdateFromItemSet( nWhich );

	SetSizePos();

	SfxItemSet* pItemSet = pShell->GetItemSet();

	// Enable
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnabled = ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		pEditEngine->Enable( bEnabled );
	}

	if( !nWhich || (nWhich==VCATTR_WORDWRAP_MODE) )
	{
		USHORT nMode = ((const SfxEnumItem&)pItemSet->Get( VCATTR_WORDWRAP_MODE )).GetValue();
		pEditEngine->SetWordWrap( nMode );
	}

	// Border setzen
	if( !nWhich || (nWhich==VCATTR_BORDER) )
	{
		BOOL bBorder = ((SfxBoolItem&)pItemSet->Get( VCATTR_BORDER )).GetValue();
		pEditEngine->SetBorder( bBorder );
	}

	// Fileupload setzen
	if( !nWhich || (nWhich==VCATTR_FILEUPLOAD) )
		SetFileUpload( ((SfxBoolItem&)pItemSet->Get( VCATTR_FILEUPLOAD )).GetValue() );

	// Text setzen
	if( !nWhich || (nWhich==VCATTR_MAXLENGTH) || (nWhich==VCATTR_TEXT) )
	{
		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		String aText = ((SfxStringItem&)pItemSet->Get( VCATTR_TEXT )).GetValue();

		if( aLinkName.Len() && pShell->GetParent()->IsUpdatingLinkData() )
		{
			String aTempText = pShell->GetLinkData( aLinkName );
			if( aTempText != aText )
			{
				SfxStringItem aTextItem( VCATTR_TEXT, aTempText );
				pItemSet->Put( aTextItem );
			}
			aText = aTempText;
		}

		ULONG nMaxLen = ((SfxInt32Item&)pItemSet->Get( VCATTR_MAXLENGTH )).GetValue();
		pEditEngine->SetMaxLen( (USHORT)nMaxLen );

		if( pEditEngine->GetText() != aText )
		{
			pEditEngine->SetText( aText );
			if(aLinkName.Len() && !pShell->GetParent()->IsUpdatingLinkData())
			{
				pShell->SetLinkData( aLinkName, aText );
			}
		}
	}

	// Farben setzen
	if( !nWhich || (nWhich==VCATTR_FORECOLOR) || (nWhich==VCATTR_BACKCOLOR) )
	{
		Color aForeCol = ((SvxColorItem&)pItemSet->Get(VCATTR_FORECOLOR)).GetValue();
		Color aBackCol = ((SvxColorItem&)pItemSet->Get(VCATTR_BACKCOLOR)).GetValue();
		pEditEngine->SetForeColor( aForeCol );
		pEditEngine->SetBackColor( aBackCol );
	}

	if( !nWhich || (nWhich==VCATTR_READONLY) )
	{
		BOOL bReadOnly = ((SfxBoolItem&)pItemSet->Get( VCATTR_READONLY )).GetValue();
		pEditEngine->SetReadOnly( bReadOnly );
	}
	if( !nWhich || (nWhich==VCATTR_PASSWORDCHAR) )
	{
		String aPC = ((SfxStringItem&)pItemSet->Get( VCATTR_PASSWORDCHAR )).GetValue();
		pEditEngine->SetPassWordChar( aPC );
	}
	if( !nWhich || (nWhich==VCATTR_ALIGNMENT) )
	{
		USHORT eAlign = (USHORT)((VCAlignmentItem&)pItemSet->Get( VCATTR_ALIGNMENT )).GetValue();
		pEditEngine->SetAlignment( (USHORT)eAlign );
	}
	if( !nWhich || (nWhich==VCATTR_MULTILINE) )
	{
		BOOL bMultiLine = ((SfxBoolItem&)pItemSet->Get( VCATTR_MULTILINE )).GetValue();
		pEditEngine->SetMultiLine( bMultiLine );
		if( bMultiLine && nWhich == VCATTR_MULTILINE )
		{
#ifdef WNT
			// Beim Umschalten auf Multiline, "Courier New" setzen, da
			// dieser Font auch von Netscape in Multiline-Edits verwendet wird.
			SfxStringItem aNameItm( VCATTR_FONTNAME, "Courier New" );
			SfxInt32Item aSizeItm( VCATTR_FONTSIZE, 10 );
			SfxBoolItem aBoldItm( VCATTR_FONTBOLD, FALSE );
			SfxBoolItem aItalicItm( VCATTR_FONTITALIC, FALSE );
			SfxBoolItem aStrikeThruItm( VCATTR_FONTSTRIKETHRU, FALSE );
			SfxBoolItem aUnderlineItm( VCATTR_FONTUNDERLINE, FALSE );
			pItemSet->Put( aNameItm );
			pItemSet->Put( aSizeItm );
			pItemSet->Put( aBoldItm );
			pItemSet->Put( aItalicItm );
			pItemSet->Put( aStrikeThruItm );
			pItemSet->Put( aUnderlineItm );
#endif
			const USHORT* pWhich = pFontWhiches;
			while( *pWhich )
			{
				SiDLL::UpdateBrowserItem( *pWhich );
				pWhich++;
			}
		}
	}
}


// ------------------------------------------------------------------------
Pointer VCImpVirtEdit::GetPointer( const Point& rPosLogic ) const
{
	if( bFileUpload && aUploadRect.IsInside( rPosLogic ))
		return Pointer( POINTER_REFHAND );
	return pEditEngine->GetPointer( rPosLogic );
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtEdit, TextModify, VCEditEngine *, EMPTYARG )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	SfxStringItem aTextItem( VCATTR_TEXT, pEditEngine->GetText() );
	pItemSet->Put( aTextItem );

	String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
		pShell->SetLinkData( aLinkName, pEditEngine->GetText() );

	pShell->Modified();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtEdit, GotFocus, VCEditEngine *, EMPTYARG  )
{
	pShell->GotFocus();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtEdit, LostFocus, VCEditEngine *, EMPTYARG    )
{
	pShell->LostFocus();
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtEdit, Selected, VCEditEngine *, EMPTYARG    )
{
	pShell->Selected();
	return 0;
}

// ------------------------------------------------------------------------
VCImpVirtEdit::VCImpVirtEdit( VCControl* pShell ) :
	VCImpVirtControl( pShell ),
	pEditEngine( new VCEditEngine( pShell )),
	bLeftButtonDown(FALSE),
	bMouseInside(FALSE),
	pBrowseButton( 0 )
{
	pEditEngine->SetModifyHdl( LINK( this, VCImpVirtEdit, TextModify ) );
	pEditEngine->SetGotFocusHdl( LINK( this, VCImpVirtEdit, GotFocus ) );
	pEditEngine->SetLostFocusHdl( LINK( this, VCImpVirtEdit, LostFocus ) );
	pEditEngine->SetSelectedHdl( LINK( this, VCImpVirtEdit, Selected ) );
	UpdateFromItemSet();
}

// ------------------------------------------------------------------------
VCImpVirtEdit::~VCImpVirtEdit()
{
	delete pEditEngine;
	delete pBrowseButton;
}

// ------------------------------------------------------------------------
Size VCImpVirtEdit::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

// ------------------------------------------------------------------------
Size VCImpVirtEdit::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalb erstmal setzen
	Font aFont( GetFont( pOut ) );
	pEditEngine->SetFont( aFont );
	Size aOptSize( pEditEngine->GetOptSize( pOut ) );
	if( bFileUpload )
	{
		Size aBSize( GetButtonWidthMax( String(SiResId(STR_BROWSE)),pOut ) + DIST_EDITBUTTON, 0 );
		aBSize = pOut->LogicToPixel( aBSize, MapMode( MAP_APPFONT ) );
		aBSize = pOut->PixelToLogic( aBSize );
		aOptSize.Width() += aBSize.Width();
	}
	return aOptSize;
}


// ------------------------------------------------------------------------
Size VCImpVirtEdit::GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// der Font ist Device-abhaengig deshalbv erstmal setzen
	pEditEngine->SetFont( GetFont( pOut ) );
	Size aOptSize( pEditEngine->GetOptSize( rCharXY, pOut ) );
	if( bFileUpload )
	{
		Size aBSize( GetButtonWidthMax( String(SiResId(STR_BROWSE)),pOut ) + DIST_EDITBUTTON, 0 );
		aBSize = pOut->LogicToPixel( aBSize, MapMode( MAP_APPFONT ) );
		aBSize = pOut->PixelToLogic( aBSize );
		aOptSize.Width() += aBSize.Width();
	}
	return aOptSize;

}

// ------------------------------------------------------------------------
Size VCImpVirtEdit::GetCharCountXY( OutputDevice* pOut, const Font* pFont) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	Font aOldFont;
	if( !pFont )
		pEditEngine->SetFont( GetFont( pOut ) );
	else
	{
		aOldFont = pEditEngine->GetFont();
		pEditEngine->SetFont( *pFont );
	}
	Size aResult( pEditEngine->GetCharCountXY( pOut ) );
	if( pFont )
		pEditEngine->SetFont( aOldFont );
	return aResult;
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetSelectStart( long nStart )
{
	pEditEngine->SetSelectStart( nStart );
}

// ------------------------------------------------------------------------
long VCImpVirtEdit::GetSelectStart() const
{
	return pEditEngine->GetSelectStart();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetSelectLen( long nLen )
{
	pEditEngine->SetSelectLen( nLen );
}

// ------------------------------------------------------------------------
long VCImpVirtEdit::GetSelectLen() const
{
	return pEditEngine->GetSelectLen();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetSelectText( const String& rText )
{
	pEditEngine->SetSelectText( rText );
}

// ------------------------------------------------------------------------
String VCImpVirtEdit::GetSelectText() const
{
	return pEditEngine->GetSelectText();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;
	Font aFont( GetFont( pOut ));
	pEditEngine->SetFont( aFont );
	pEditEngine->Paint( pOut );
	if( pBrowseButton )
	{
		pBrowseButton->Paint( pOut );
	}
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	bLeftButtonDown = TRUE;
	bMouseInside    = TRUE;

	Point aPos = pWindow->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pShell->HasOverlayObjects() )
		Paint( pWindow );
	if( pBrowseButton )
	{
		if( aUploadRect.IsInside( aEvt.GetPosPixel()) )
			pBrowseButton->MouseButtonDown( pWindow, aEvt );
		else
			pEditEngine->MouseButtonDown( pWindow, aEvt );
	}
	else
		pEditEngine->MouseButtonDown( pWindow, aEvt );

	VCImpVirtControl::MouseButtonDown( pWindow, rMEvt );
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	Point aPos = pWindow->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pBrowseButton )
	{
		if( aUploadRect.IsInside( aEvt.GetPosPixel()) || pBrowseButton->ButtonIsIn() )
			pBrowseButton->MouseButtonUp( pWindow, aEvt );
		else
			pEditEngine->MouseButtonUp( pWindow, aEvt );
	}
	else
		pEditEngine->MouseButtonUp( pWindow, aEvt );

	VCImpVirtControl::MouseButtonUp( pWindow, rMEvt );

	pShell->InvalidateOverlayObjects( pWindow );
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	pActWindow = pWindow;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	VCImpVirtControl::MouseMove( pWindow, rMEvt );
	Point aPos = pWindow->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );
	if( pBrowseButton )
	{
		if( aUploadRect.IsInside( aEvt.GetPosPixel()) || pBrowseButton->ButtonIsIn() )
			pBrowseButton->MouseMove( pWindow, aEvt );
		else
			pEditEngine->MouseMove( pWindow, aEvt );
	}
	else
		pEditEngine->MouseMove( pWindow, aEvt );
}

// ------------------------------------------------------------------------
BOOL VCImpVirtEdit::IsModified() const
{
	return pEditEngine->IsModified();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetModifyFlag( BOOL bModified )
{
	pEditEngine->SetModifyFlag( bModified );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::UpdateFromItemSet( USHORT nWhich )
{
	// Position und Groesse ueber Basisklasse
	VCImpVirtControl::UpdateFromItemSet( nWhich );

	if( !nWhich ||
		(nWhich == VCATTR_LEFT) || (nWhich == VCATTR_TOP) ||
		(nWhich == VCATTR_WIDTH)|| (nWhich == VCATTR_HEIGHT) )
	{
		Rectangle aRect = SI_DLL()->GetOutDev()->LogicToPixel( aBoundRect,
						MapMode( MAP_TWIP ) );
		aRect = SI_DLL()->GetOutDev()->PixelToLogic( aRect,
						MapMode( pShell->GetOutUnit() ) );
		pScrollEngine->SetPos( aRect.TopLeft() );
		pScrollEngine->SetSize( aRect.GetSize() );
	}

	SfxItemSet* pItemSet = pShell->GetItemSet();

	if( !nWhich || (nWhich == VCATTR_ENABLED) )
	{
		BOOL bEnabled = ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		pScrollEngine->Enable( bEnabled );
	}

	if( !nWhich || (nWhich == VCATTR_MIN) || (nWhich == VCATTR_MAX) ||
		(nWhich == VCATTR_SCROLLBARVALUE) )
	{
		long nMin = ((SfxInt32Item&)pItemSet->Get( VCATTR_MIN )).GetValue();
		long nMax = ((SfxInt32Item&)pItemSet->Get( VCATTR_MAX )).GetValue();
		long nVal = ((SfxInt32Item&)pItemSet->Get( VCATTR_SCROLLBARVALUE )).GetValue();

		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() && pShell->GetParent()->IsUpdatingLinkData() )
		{
			String aVal = pShell->GetLinkData( aLinkName );
			long nTempVal = (long)aVal;
			if( nVal != nTempVal )
			{
				SfxInt32Item aValItem( VCATTR_SPINBUTTONVALUE, nTempVal );
				pItemSet->Put( aValItem );
			}
			nVal = nTempVal;
		}

		pScrollEngine->SetMin( nMin );
		pScrollEngine->SetMax( nMax );
		pScrollEngine->SetAct( nVal );
	}

	if( !nWhich || (nWhich == VCATTR_SMALLCHANGE) || (nWhich == VCATTR_LARGECHANGE) )
	{
		long nSmall = ((SfxInt32Item&)pItemSet->Get( VCATTR_SMALLCHANGE )).GetValue();
		long nLarge = ((SfxInt32Item&)pItemSet->Get( VCATTR_LARGECHANGE )).GetValue();

		pScrollEngine->SetPageSize( nLarge );
		pScrollEngine->SetLineSize( nSmall );
	}
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtScrollBar, ScrollEngineScroll, VCScrollBarEngine *, EMPTYARG )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	SfxInt32Item aValueItem( VCATTR_SCROLLBARVALUE, pScrollEngine->GetAct() );
	pItemSet->Put( aValueItem );

	String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
		pShell->SetLinkData( aLinkName, String( pScrollEngine->GetAct() ) );

	// HACK(Scrolled & Changed werden nicht unterschieden)
	// da die Engine dies noch nicht anbietet.Ein Einbau koennte Probleme
	// bei den zusammengesetzten Controls wie Multiline-Edit & ListBox
	// bringen. Deshalb erstmal zurueckgestellt.
	((VCScrollBar*)pShell)->Scrolled();
	((VCScrollBar*)pShell)->Changed();

	Update( FALSE );
	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK_INLINE_START( VCImpVirtScrollBar, ScrollEngineEndScroll, VCScrollBarEngine *, EMPTYARG )
{
	return 0;
}
IMPL_LINK_INLINE_END( VCImpVirtScrollBar, ScrollEngineEndScroll, VCScrollBarEngine *, EMPTYARG )


// ------------------------------------------------------------------------
VCImpVirtScrollBar::VCImpVirtScrollBar( VCControl* pShell ) :
	VCImpVirtControl( pShell ),
	pScrollEngine(NULL)
{
}

// ------------------------------------------------------------------------
VCImpVirtScrollBar::~VCImpVirtScrollBar()
{
	delete pScrollEngine;
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::Update( BOOL bWithItems,USHORT nUpdWhich )
{
	if( bWithItems )
		UpdateFromItemSet( nUpdWhich );
	VCContainer* pContainer = pShell->GetParent();
	if( pContainer && pContainer->IsA( TYPE( VCManager ) ) )
		((VCManager*)pContainer)->
			PaintControl( pShell, FALSE, pScrollEngine->GetActWin() );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;
	pScrollEngine->Paint( pOut );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::MouseButtonDown( Window* pWin, const MouseEvent& rMEvt )
{
	pActMouseEvent = (MouseEvent*)&rMEvt;
	pActWindow = pWin;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pShell->HasOverlayObjects() )
		Paint( pWin );
	pScrollEngine->MouseButtonDown( pWin, aEvt );
	VCImpVirtControl::MouseButtonDown( pWin, rMEvt );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::MouseButtonUp( Window* pWin, const MouseEvent& rMEvt )
{
	pActMouseEvent = (MouseEvent*)&rMEvt;
	pActWindow = pWin;
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pScrollEngine->MouseButtonUp( pWin, aEvt );
	VCImpVirtControl::MouseButtonUp( pWin, rMEvt );

	pShell->InvalidateOverlayObjects( pWin );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::MouseMove( Window* pWin, const MouseEvent& rMEvt )
{
	pActWindow = pWin;
	pActMouseEvent = (MouseEvent*)&rMEvt;
	VCImpVirtControl::MouseMove( pWin, rMEvt );
	Point aPos = pWin->LogicToPixel( rMEvt.GetPosPixel(),
					MapMode( MAP_TWIP ) );
	aPos = pWin->PixelToLogic( aPos, MapMode( pShell->GetOutUnit() ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
					 rMEvt.GetButtons(), rMEvt.GetModifier() );

	pScrollEngine->MouseMove( pWin, aEvt );
}

// ------------------------------------------------------------------------
void VCImpVirtScrollBar::KeyInput( Window* pWin, const KeyEvent& rKEvt )
{
	pScrollEngine->KeyInput( pWin, rKEvt );
}

// ------------------------------------------------------------------------
VCImpVirtHScrollBar::VCImpVirtHScrollBar( VCControl* pShell ) :
	VCImpVirtScrollBar( pShell )
{
	pScrollEngine = new VCScrollBarEngine( TRUE );
	pScrollEngine->SetScrollHdl( LINK( this, VCImpVirtScrollBar, ScrollEngineScroll ) );
	pScrollEngine->SetEndScrollHdl( LINK( this, VCImpVirtScrollBar, ScrollEngineEndScroll ) );
	UpdateFromItemSet();
}

// ------------------------------------------------------------------------
VCImpVirtHScrollBar::~VCImpVirtHScrollBar()
{
}

// ------------------------------------------------------------------------
Size VCImpVirtHScrollBar::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

// ------------------------------------------------------------------------
VCImpVirtVScrollBar::VCImpVirtVScrollBar( VCControl* pShell ) :
	VCImpVirtScrollBar( pShell )
{
	pScrollEngine = new VCScrollBarEngine( FALSE );
	pScrollEngine->SetScrollHdl( LINK( this, VCImpVirtScrollBar, ScrollEngineScroll ) );
	pScrollEngine->SetEndScrollHdl( LINK( this, VCImpVirtScrollBar, ScrollEngineEndScroll ) );
	UpdateFromItemSet();
}

// ------------------------------------------------------------------------
VCImpVirtVScrollBar::~VCImpVirtVScrollBar()
{
}

// ------------------------------------------------------------------------
Size VCImpVirtVScrollBar::GetMinSizePixel() const
{
	Size aTempSize( 10,10 );
	return aTempSize;
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::Focus()
{
	pEditEngine->Focus();
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::Blur()
{
	pEditEngine->Blur();
}

// ------------------------------------------------------------------------
IMPL_LINK( VCImpVirtEdit, BrowseClicked, void*, EMPTYARG )
{
	SfxFileDialog aDlg( GetpApp()->GetDefModalDialogParent(),
		WB_SVLOOK | WB_OPEN );
	if( aDlg.Execute())
	{
		((VCEdit*)pShell)->SetText( aDlg.GetPath() );
	}
	return 0;
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetFileUpload( BOOL bUpload )
{
	if( bUpload != bFileUpload )
	{
		bFileUpload = bUpload;
		SetSizePos();
	}
}

// ------------------------------------------------------------------------
void VCImpVirtEdit::SetSizePos()
{
	OutputDevice* pAppWin = SI_DLL()->GetOutDev();
	MapMode aMapTwip( MAP_TWIP );
	Rectangle aRect = pAppWin->LogicToPixel( aBoundRect, aMapTwip );
	aRect = pAppWin->PixelToLogic( aRect, MapMode( pShell->GetOutUnit() ) );

	Point aPos( aRect.TopLeft());
	Size aSize( aRect.GetSize() );

	pEditEngine->SetPos( aPos );
	if( !bFileUpload )
	{
		pEditEngine->SetSize( aSize );
		DELETEZ(pBrowseButton);
	}
	else
	{
		String aCaption( SiResId(STR_BROWSE ));

		long nButtonWidth = GetButtonWidthMax(aCaption,pAppWin);
		nButtonWidth += DIST_EDITBUTTON;
		nButtonWidth = OVAppToTwip( nButtonWidth, pAppWin );
		if( aSize.Width() < nButtonWidth )
		{
			aCaption = "...";
			nButtonWidth = GetButtonWidthMax(aCaption,pAppWin);
			nButtonWidth += DIST_EDITBUTTON;
			nButtonWidth = OVAppToTwip( nButtonWidth, pAppWin );
		}
		long nEditWidth = aSize.Width() - nButtonWidth;
		if( aSize.Width() < 400 || nEditWidth < 50 )
		{
			nEditWidth = aSize.Width();
			nButtonWidth = 0;
		}

		aSize.Width() = nEditWidth;
		pEditEngine->SetSize( aSize );
		if( nButtonWidth )
		{
			if( !pBrowseButton )
			{
				pBrowseButton= new VCPushButtonEngine;
				Font aFont( GetpApp()->GetAppFont() );
				aFont.SetTransparent( TRUE );
				pBrowseButton->SetFont( aFont );
			}
			aPos.X() += nEditWidth;
			long nDist = OVAppToTwip( DIST_EDITBUTTON, pAppWin);
			aPos.X() += nDist;

			pBrowseButton->SetPos( aPos );
			nButtonWidth -= nDist;
			if( nButtonWidth < 0 )
				nButtonWidth = 0;
			aSize.Width() = nButtonWidth;
			pBrowseButton->SetSize( aSize );
			pBrowseButton->SetCaption( aCaption );
			pBrowseButton->SetClickHdl(LINK(this,VCImpVirtEdit,BrowseClicked));
			aUploadRect.SetPos( aPos );
			aUploadRect.SetSize( aSize );
		}
		else
		{
			DELETEZ(pBrowseButton);
		}
	}

}



