/*************************************************************************
 *
 *  $RCSfile: vcictrls.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _VCICTRLS_HXX
#define _VCICTRLS_HXX

class VCControl;
class SfxItemSet;

#ifndef _POINTR_HXX //autogen
#include <vcl/pointr.hxx>
#endif
#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif

//--------------------
// class VCImpControl
//--------------------
class VCImpControl
{
protected:
	VCControl*		pShell;
	MouseEvent*		pActMouseEvent;
	KeyEvent*		pActKeyEvent;

	virtual void	UpdateFromItemSet( USHORT nWhich = 0 );

public:
					VCImpControl( VCControl* pShell );
	virtual			~VCImpControl();

	virtual Size	GetMinSizePixel() const;

	Font			GetFont( OutputDevice* pOut, BOOL bWithColors=TRUE ) const;
	virtual void	Update( BOOL bWithItems = TRUE, USHORT nWhich = 0 );
	virtual void	UpdateValue();

	MouseEvent*		GetActMouseEvent() const { return pActMouseEvent; }
	KeyEvent*		GetActKeyEvent() const { return pActKeyEvent; }
	void			SetActMouseEvent(MouseEvent* pEvt)  { pActMouseEvent = pEvt; }
	void			SetActKeyEvent(KeyEvent* pEvt) { pActKeyEvent = pEvt; }

	virtual void	Paint( OutputDevice* pOut );
	virtual void	MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void	MouseButtonUp( Window* pWindow, const MouseEvent& rMEVt );
	virtual void	MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void	KeyInput( Window* pWindow, const KeyEvent& rKEvt );

	static void		ConvertAmpersand( String* pStr );
	static void		DeleteAmpersand( String* pStr );
};


#if SUPD < 505
//------------------------
// class VCImpVirtControl
//------------------------
class VCImpVirtControl : public VCImpControl
{
	friend class VCControl;

protected:
	Rectangle			aBoundRect;
	Rectangle			aTextRect;
	Pointer				aPointer;
	Window*				pActWindow;
	BOOL				bLeftButtonDown;
	BOOL				bMouseInside;
	BOOL				bFocus;
	BOOL				bVisible;

	virtual void		DrawBackground( OutputDevice* pOut );
	virtual void		DrawControl( OutputDevice* pOut, USHORT nFlags = 0xffff );
	virtual void		DrawBorder( OutputDevice* pOut );

	virtual Rectangle	GetClientRect( OutputDevice* pOut ) const;
	virtual	Rectangle	GetTextRect( OutputDevice* pOut, const Font& rFont ) const;

	virtual void		UpdateFromItemSet( USHORT nWhich=0 );

public:
						VCImpVirtControl( VCControl* pShell );
	virtual				~VCImpVirtControl();

	void				Update( BOOL bWithItems=TRUE, USHORT nWhich = 0 );
	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEVt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
	Window*				GetActWindow() const { return pActWindow; }
};


class VCButtonEngine;

//-----------------------
// class VCImpVirtButton
//-----------------------
class VCImpVirtButton : public VCImpVirtControl
{
	DECL_LINK( ClickHdl, VCButtonEngine* );

protected:
	VCButtonEngine*		pButtonEngine;
	virtual Rectangle	GetClientRect( OutputDevice* pOut ) const;
	virtual Rectangle	GetTextRect( OutputDevice* pOut, const Font& rFont ) const;

public:
						VCImpVirtButton( VCControl* pShell, VCButtonEngine* );
						~VCImpVirtButton();

	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );

	virtual Size		GetOptSize( OutputDevice* pOut ) const;
	virtual void 		Paint( OutputDevice* pOut );
	virtual void		UpdateFromItemSet( USHORT nWhich=0 );

};


//----------------------------
// class VCImpVirtRadioButton
//----------------------------
class VCImpVirtRadioButton : public VCImpVirtButton
{
public:
						VCImpVirtRadioButton( VCControl* pShell );
	void				UpdateValue();
	virtual void		UpdateFromItemSet( USHORT nWhich=0 );
};


//-------------------------
// class VCImpVirtCheckBox
//-------------------------
class VCImpVirtCheckBox : public VCImpVirtButton
{
public:
						VCImpVirtCheckBox( VCControl* pShell );
	void				UpdateValue();
	virtual void		UpdateFromItemSet( USHORT nWhich=0 );
};


//---------------------------
// class VCImpVirtPushButton
//---------------------------
class VCImpVirtPushButton : public VCImpVirtButton
{
public:
						VCImpVirtPushButton( VCControl* pShell );
	void				PurgeGraphic();
	void				LoadImageSync();
	virtual void		UpdateFromItemSet( USHORT nWhich=0 );
};


//---------------------------
// class VCImpVirtSpinButton
//---------------------------
class VCSpinButtonEngine;
class VCImpVirtSpinButton : public VCImpVirtControl
{
protected:
	VCSpinButtonEngine*	pButtonEngine;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );
	void				ImplSpinned();
	DECL_LINK( SpinUpHdl, VCSpinButtonEngine * );
	DECL_LINK( SpinDownHdl, VCSpinButtonEngine * );

public:
						VCImpVirtSpinButton( VCControl* pShell );
						~VCImpVirtSpinButton();

	virtual Size		GetMinSizePixel() const;

	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
};


//--------------------------
// class VCImpVirtFixedText
//--------------------------
class VCEditEngine;
class VCImpVirtFixedText : public VCImpVirtControl
{
protected:
	VCEditEngine*		pEditEngine;
	BOOL				bLeftButtonDown;
	BOOL				bMouseInside;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );

public:
						VCImpVirtFixedText( VCControl* pShell );
						~VCImpVirtFixedText();

	virtual Size		GetMinSizePixel() const;
	virtual Size		GetOptSize( OutputDevice* pOut ) const;

	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};


//-------------------------
// class VCImpVirtGroupBox
//-------------------------
class VCImpVirtGroupBox : public VCImpVirtControl
{
protected:
	BOOL				bLeftButtonDown;
	BOOL				bMouseInside;

	virtual void		DrawBackground( OutputDevice* pOut );
	virtual Rectangle	GetTextRect( OutputDevice* pOut, const Font& rFont ) const;
	virtual void		DrawControl( OutputDevice* pOut, USHORT nFlags=0xffff );
	virtual void		DrawBorder( OutputDevice* pOut );

public:
						VCImpVirtGroupBox( VCControl* pShell );
						~VCImpVirtGroupBox();

	virtual Size		GetMinSizePixel() const;

	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};


//------------------------
// class VCImpVirtListBox
//------------------------
class VCListBoxEngine;

class VCImpVirtListBox : public VCImpVirtControl
{
protected:
	VCListBoxEngine*	pListEngine;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );
	DECL_LINK( ListEngineSelect, VCListBoxEngine * );

public:
						VCImpVirtListBox( VCControl* pShell );
						~VCImpVirtListBox();

	virtual Size		GetMinSizePixel() const;
	virtual Size		GetOptSize( OutputDevice* pOut ) const;
	Size 				GetOptSize( const Size& rCharXY, OutputDevice* pOut = 0 ) const;
	virtual USHORT 		GetLineCount( OutputDevice* pOut ) const;

	USHORT				InsertEntry( const String& rStr, ULONG nPos=LIST_APPEND );
	void				RemoveEntry( ULONG nPos );
	void				ReplaceEntry( const String& rStr, ULONG nPos );
	String				GetSelectEntry() const;
	ULONG				GetSelectEntryPos() const;
	void				SelectEntryPos( ULONG nPos, BOOL bSelect=TRUE );
	BOOL				IsEntrySelected( ULONG nPos );
	ULONG				GetTopIndex() const;
	void				SetTopIndex( ULONG nIndex );
	void				Clear();
//	ULONG				GetNewIndex() const;

	virtual void		Update( BOOL bWithItems = TRUE, USHORT nWhich = 0 );
	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};


//-------------------------
// class VCImpVirtComboBox
//-------------------------
class VCComboBoxEngineBase;
class VCImpVirtComboBox : public VCImpVirtControl
{
protected:
	VCComboBoxEngineBase*	pComboEngine;
	USHORT		    	    eStyle;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );
	DECL_LINK( TextModify, VCComboBoxEngineBase * );
	DECL_LINK( GotFocus, VCComboBoxEngineBase * );
	DECL_LINK( LostFocus, VCComboBoxEngineBase * );
	DECL_LINK( Select, VCComboBoxEngineBase * );

public:
						VCImpVirtComboBox( VCControl* pShell );
						~VCImpVirtComboBox();

	virtual Size		GetMinSizePixel() const;
	virtual Size		GetOptSize( OutputDevice* pOut ) const;

	String				GetText() const;
	void				SetText( const String& rText );
	USHORT				InsertEntry( const String& rStr, ULONG nPos=LIST_APPEND );
	void				RemoveEntry( ULONG nPos );
	void				ReplaceEntry( const String& rStr, ULONG nPos );
	String				GetSelectEntry() const;
	void				Clear();
//	ULONG				GetNewIndex() const;
	// gibt Index des zuletzt selektierten Elementes zurueck
	ULONG				GetListIndex() const;
	void				SetStyle( USHORT eStyle );
	USHORT			    GetStyle() const { return eStyle; }

	virtual void		Update( BOOL bWithItems = TRUE, USHORT nWhich = 0 );
	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
};



//---------------------
// class VCImpVirtEdit
//---------------------

class VCPushButtonEngine;

class VCImpVirtEdit : public VCImpVirtControl
{
protected:
	VCEditEngine*		pEditEngine;
	BOOL				bLeftButtonDown;
	BOOL				bMouseInside;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );
	DECL_LINK( TextModify, VCEditEngine * );
	DECL_LINK( GotFocus, VCEditEngine *  );
	DECL_LINK( LostFocus, VCEditEngine *  );
	DECL_LINK( Selected, VCEditEngine *  );
	// FileUpload-Geraffel
	DECL_LINK( BrowseClicked, void*  );
	VCPushButtonEngine* pBrowseButton;
	Rectangle			aUploadRect;
	BOOL				bFileUpload;
	void				SetFileUpload( BOOL );
	void				SetSizePos();

public:
						VCImpVirtEdit( VCControl* pShell );
						~VCImpVirtEdit();

	virtual Size		GetMinSizePixel() const;
	virtual Size		GetOptSize( OutputDevice* pOut ) const;
	virtual Size 		GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const;
	virtual Size		GetCharCountXY( OutputDevice* pOut, const Font* pFont = 0) const;

	void				SetSelectStart( long nStart );
	long				GetSelectStart() const;
	void				SetSelectLen( long nLen );
	long 				GetSelectLen() const;
	void				SetSelectText( const String& rText );
	String				GetSelectText() const;

	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );

	VCEditEngine*		GetEditEngine() const { return pEditEngine; }

	void				Focus();
	void				Blur();

	BOOL				IsModified() const;
	void				SetModifyFlag( BOOL bModified );

	Pointer				GetPointer( const Point& rPosLogic ) const;
};


//--------------------------
// class VCImpVirtScrollBar
//--------------------------
class VCScrollBarEngine;

class VCImpVirtScrollBar : public VCImpVirtControl
{
protected:
	VCScrollBarEngine*	pScrollEngine;

	virtual void		UpdateFromItemSet( USHORT nWhich = 0 );
	DECL_LINK( ScrollEngineScroll, VCScrollBarEngine * );
	DECL_LINK( ScrollEngineEndScroll, VCScrollBarEngine * );

public:
						VCImpVirtScrollBar( VCControl* pShell );
						~VCImpVirtScrollBar();

	virtual void		Update( BOOL bWithItems = TRUE, USHORT nWhich = 0 );
	virtual void 		Paint( OutputDevice* pOut );
	virtual void		MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		MouseMove( Window* pWindow, const MouseEvent& rMEvt );
	virtual void		KeyInput( Window* pWindow, const KeyEvent& rKEvt );
};

//---------------------------
// class VCImpVirtHScrollBar
//---------------------------
class VCImpVirtHScrollBar : public VCImpVirtScrollBar
{
public:
						VCImpVirtHScrollBar( VCControl* pShell );
						~VCImpVirtHScrollBar();

	virtual Size		GetMinSizePixel() const;
};

//--------------------------
// class VCImpVirtVScrollBar
//--------------------------
class VCImpVirtVScrollBar : public VCImpVirtScrollBar
{
protected:
public:
						VCImpVirtVScrollBar( VCControl* pShell );
						~VCImpVirtVScrollBar();

	virtual Size		GetMinSizePixel() const;
};

#endif

//------------------------
// class VCImpRealControl
//------------------------
class VCImpRealControl : public VCImpControl
{
protected:
	Control*		  pDlgEdControl;
#ifndef VCL
	VCImpRealControl* pCurControl;
#endif
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );

#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent ) = 0;
#endif
	Control*	 	GetDlgEdControl( Window* pParent );
	BOOL			IsSVLook() const;

public:
					VCImpRealControl( VCControl* pShell );
					~VCImpRealControl();

	virtual	void	Update( BOOL bWithItems=TRUE, USHORT nWhich = 0 );
	virtual void	Paint( OutputDevice* pOut );
	void			Hide() { if( pDlgEdControl ) pDlgEdControl->Hide(); }
	void			Show() { if( pDlgEdControl ) pDlgEdControl->Show(); }
	void			DeleteDlgEdControl();
};


//---------------------------
// class VCImpRealPushButton
//---------------------------
class VCImpRealPushButton : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealPushButton( VCControl* pShell );
					~VCImpRealPushButton();

	virtual Size		GetMinSizePixel() const;
};


//----------------------------
// class VCImpRealRadioButton
//----------------------------
class VCImpRealRadioButton : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealRadioButton( VCControl* pShell );
					~VCImpRealRadioButton();

	virtual Size		GetMinSizePixel() const;
};


//-------------------------
// class VCImpRealCheckBox
//-------------------------
class VCImpRealCheckBox : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealCheckBox( VCControl* pShell );
					~VCImpRealCheckBox();

	virtual Size		GetMinSizePixel() const;
};


//---------------------------
// class VCImpRealSpinButton
//---------------------------
class VCImpRealSpinButton : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealSpinButton( VCControl* pShell );
					~VCImpRealSpinButton();

	virtual Size	GetMinSizePixel() const;
#ifndef VCL
	virtual void	Paint( OutputDevice* pOut );
#endif
};


//--------------------------
// class VCImpRealFixedText
//--------------------------
class VCImpRealFixedText : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealFixedText( VCControl* pShell );
					~VCImpRealFixedText();

	virtual Size		GetMinSizePixel() const;

#ifndef VCL
	virtual void	Paint( OutputDevice* pOut );
#endif
};


//-------------------------
// class VCImpRealGroupBox
//-------------------------
class VCImpRealGroupBox : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealGroupBox( VCControl* pShell );
					~VCImpRealGroupBox();

	virtual Size		GetMinSizePixel() const;

	virtual void	Paint( OutputDevice* pOut );
};


//------------------------
// class VCImpRealListBox
//------------------------
class VCImpRealListBox : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealListBox( VCControl* pShell );
					~VCImpRealListBox();

	virtual Size		GetMinSizePixel() const;

	USHORT			InsertEntry( const String& rStr, ULONG nPos=LIST_APPEND );
	void			RemoveEntry( ULONG nPos );
	void			ReplaceEntry( const String& rStr, ULONG nPos );
	String			GetSelectEntry() const;
	ULONG			GetSelectEntryPos() const;
	void			SelectEntryPos( ULONG nPos, BOOL bSelect=TRUE );
	BOOL			IsEntrySelected( ULONG nPos );
	void			Clear();
#ifndef VCL
	virtual void	Paint( OutputDevice* pOut );
#endif
};


//-------------------------
// class VCImpRealComboBox
//-------------------------
class VCImpRealComboBox : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealComboBox( VCControl* pShell );
					~VCImpRealComboBox();

	virtual Size		GetMinSizePixel() const;

	String			GetText() const;
	void			SetText( const String& rText );
	USHORT			InsertEntry( const String& rStr, ULONG nPos=LIST_APPEND );
	void			RemoveEntry( ULONG nPos );
	void			ReplaceEntry( const String& rStr, ULONG nPos );
	String			GetSelectEntry() const;
	void			Clear();
#ifndef VCL
	virtual void	Paint( OutputDevice* pOut );
#endif
};

//---------------------
// class VCImpRealEdit
//---------------------
class VCImpRealEdit : public VCImpRealControl
{
protected:
	virtual void		UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
						VCImpRealEdit( VCControl* pShell );
						~VCImpRealEdit();

	virtual Size		GetMinSizePixel() const;

#ifndef VCL
	virtual void		Paint( OutputDevice* pOut );
#endif
	void				Focus();
	void				Blur();
	BOOL				IsModified() const;
	void				SetModifyFlag( BOOL bModified );
};

//--------------------------
// class VCImpRealScrollBar
//--------------------------
class VCImpRealScrollBar : public VCImpRealControl
{
protected:
	BOOL	bHorz;

	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealScrollBar( VCControl* pShell );
					~VCImpRealScrollBar();

};

//---------------------------
// class VCImpRealHScrollBar
//---------------------------
class VCImpRealHScrollBar : public VCImpRealScrollBar
{
public:
					VCImpRealHScrollBar( VCControl* pShell );
					~VCImpRealHScrollBar();

	virtual Size		GetMinSizePixel() const;
};

//---------------------------
// class VCImpRealVScrollBar
//---------------------------
class VCImpRealVScrollBar : public VCImpRealScrollBar
{
public:
					VCImpRealVScrollBar( VCControl* pShell );
					~VCImpRealVScrollBar();

	virtual Size		GetMinSizePixel() const;
};


//------------------------
// class VCImpRealPreview
//------------------------
class VCImpRealPreview : public VCImpRealControl
{
protected:
	virtual void	UpdateFromItemSet( USHORT nWhich=0 );
#ifndef TF_SI_OFF50
	virtual Window*  CreateClass( Window* pParent );
#endif

public:
					VCImpRealPreview( VCControl* pShell );
					~VCImpRealPreview();

	virtual Size		GetMinSizePixel() const;
};


#ifdef VCL

class SiControl
{
public:
	BOOL	bHasFocus;
			SiControl() : bHasFocus(FALSE)
			{}
};

#endif




#endif //_VCTICRLS_HXX
