/*************************************************************************
 *
 *  $RCSfile: vcidrawm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef VCL

#include "vcidraww.cxx"

#else


#define protected public

#ifndef _SYSDEP_HXX
#include <sysdep.hxx>
#endif

#ifndef _SV_HXX
#include <sv.hxx>
#endif

#include <svx/colritem.hxx>

#ifndef _VCATTR_HXX
#include <vcattr.hxx>
#endif

#include <vcattrid.hrc>

#ifndef _VCONT_HXX
#include <vcont.hxx>
#endif

#ifndef _VCTRLS_HXX
#include <vctrls.hxx>
#endif
#include <vcengin2.hxx>

#ifndef _VCICTRLS_HXX
#include <vcictrls.hxx>
#endif

#ifndef _SFXIPOOL_HXX
#include "sfxitems.hxx"
#endif

#ifndef _SFXINTITEM_HXX
#include "sfxipool.hxx"
#endif


/*************************************************************************/

// Unser Hintereingang zu StarView ...

extern void SVE_PaintChildBorder( Window* pWin);

/*************************************************************************
|*
|*    ImpDrawTransparentGroupBox
|*
|*    Beschreibung		Analog zu Mac:Source:Control:Group.cxx
|*								  SV_Paint( GroupBox *pMe )
|*
|*    Ersterstellung    KH 21.04.95
|*    Letzte Aenderung  DV 10.12.95
|*
*************************************************************************/

void ImpDrawTransparentGroupBox(OutputDevice*		pOut,
								const String& 		rTitle,
								const Rectangle&	rOutRect,
								const Color&		rColor,
								const Font&			rFont,
									  MapUnit		nOutUnit)
{
	Font 	anOldFont 	= pOut->GetFont();
	Font	aNewFont(rFont);

	aNewFont.SetAlign(ALIGN_TOP);
	aNewFont.SetColor(rColor);

	pOut->SetFont( aNewFont );

	Size aTextSize = ((Window*) pOut) -> GetCtrlTextSize(rTitle);

	long HalfTextHight = aTextSize.Height() >> 1;

	Rectangle aRectFrame(rOutRect);

	Point aTextPoint = aRectFrame.TopLeft();
	aRectFrame.Top() 	+= HalfTextHight;
	aRectFrame.Bottom() -= HalfTextHight;

	// Pen immer Breite wie ein Pixel ....
	Size a1Size = pOut->LogicToLogic( Size(1,0), MAP_POINT,
			MapMode( pOut->GetMapMode().GetMapUnit() ) );

	Pen aPen(rColor);
	aPen.SetWidth(a1Size.Width());

	// Rahmen Zeichnen

	Pen anOldPen 	 = pOut->GetPen();
	Brush anOldBrush = pOut->GetFillInBrush();

	pOut->SetPen( aPen );
	pOut->SetFillInBrush( BRUSH_NULL );

	if ( !rTitle.Len() )
		pOut->DrawRect( aRectFrame );
	else
	{
		Point aPoint8 = pOut->LogicToLogic(Point( 8, 0 ),MAP_POINT, nOutUnit);

		// Platz fuer den Text lassen
		Point aHelpPoint(aRectFrame.TopLeft() + aPoint8);

		pOut->DrawLine(aRectFrame.TopLeft(),	aHelpPoint);
		pOut->DrawLine(aHelpPoint
			+ aPoint8 + Point(aTextSize.Width(),0), aRectFrame.TopRight());
		// "Badewanne" malen
		pOut->DrawLine(aRectFrame.TopLeft(),	aRectFrame.BottomLeft());
		pOut->DrawLine(aRectFrame.BottomLeft(),	aRectFrame.BottomRight());
		pOut->DrawLine(aRectFrame.BottomRight(),aRectFrame.TopRight());

		String  aStrTitel(rTitle);
		aStrTitel.Insert( ' ', 0 );
		aStrTitel += ' ';

		// Und zum Schluss den Text ausgeben
		pOut->DrawText( aTextPoint + aPoint8, aStrTitel );
	}
	pOut->SetFont( anOldFont );
	pOut->SetPen( anOldPen );
	pOut->SetFillInBrush( anOldBrush );

}

/*************************************************************************
|*
|*    ImpPaintMacControl
|*
|*    Beschreibung		Hilfsfunktion fuer FixedText,Edit und Combobox
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung	DV 23.08.96
|*
*************************************************************************/
static void ImpPaintMacControl(Window*			pSVControl,
								OutputDevice*	pOut,
								VCControl*		pShell)
{
	if( pOut->GetOutDevType() != OUTDEV_WINDOW || !pSVControl)
		return;

#ifdef VCL
	VCImpRealControl* pImpCtrl = (VCImpRealControl*)pShell->GetImpControl();
	pImpCtrl->VCImpRealControl::Paint( pOut );
#else


	Point aPos        = pShell->GetPos();
	Size  aSize 	  = pShell->GetSize();

	aPos += pShell->GetDrawOfs();

	aPos  = pOut->LogicToPixel( aPos, MapMode( MAP_TWIP ) );
	aSize = pOut->LogicToPixel( aSize, MapMode( MAP_TWIP ) );

	// Origin beruecksichtigen
	aPos += pOut->LogicToPixel( Point() );

	Rectangle aOutRect(aPos,aSize);

	Window* pOldParent = pSVControl->GetParent();

	pSVControl->SetParent( (Window*) pOut );
	pSVControl->SetPosSizePixel( aPos, aSize );
	pSVControl->Show();
	pSVControl->Paint(aOutRect);

	SVE_PaintChildBorder(pSVControl);

	Rect aRect;
	aRect.left  	= (short) aOutRect.Left() -1;
	aRect.top   	= (short) aOutRect.Top() - 1;
	aRect.right 	= (short) aOutRect.Right() + 2;	// Flackert sonst ?
	aRect.bottom 	= (short) aOutRect.Bottom() + 2;

	pSVControl->SetParent( pOldParent );
	pSVControl->Hide();

	SetPort(Sysdepen::GetWindowPtr(*((Window*)pOut)));
	// ClipRect(&aRect);
	ValidRect(&aRect);
#endif
}

/*************************************************************************
|*
|*    ImpHalfColor()
|*
|*    Beschreibung	Zeichnen eine (vorhandenes) Mac-Control
|*    Ersterstellung    KH 06.10.95
|*    Letzte Aenderung  KH 06.10.95
|*
*************************************************************************/
Color ImpHalfColor(const Color& rInColor)
{
	// Schwarz is 0,0,0 und wir wollen Grau ...
	return Color(
		USHRT_MAX - ((USHRT_MAX - rInColor.GetRed()) >> 1),
		USHRT_MAX - ((USHRT_MAX - rInColor.GetGreen()) >> 1),
		USHRT_MAX - ((USHRT_MAX - rInColor.GetBlue()) >> 1));
}

#ifndef VCL

void VCImpRealControl::Paint( OutputDevice* pOut )
{
	GetSVControl((Window*)pOut);
	ImpPaintMacControl(pSVControl,pOut,pShell);

	/* Der folgende Code war einmal noetig, ist durch
	   Umstellungen in SV aber uberfluessig geworden.
	   Sollte die Unterscheidung wieder ntig werden ...
							KH

	if( !pSVControl || pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;

	Point aPos        = pShell->GetPos();
	Size  aSize 	  = pShell->GetSize();

	aPos += pShell->GetDrawOfs();

	aPos  = pOut->LogicToPixel( aPos );
	aSize = pOut->LogicToPixel( aSize );
	Rectangle aOutRect(aPos,aSize);

	Window* pOldParent = pSVControl->GetParent();

	pSVControl->SetParent( (Window*) pOut );
	pSVControl->SetPosSizePixel( aPos, aSize );

	pSVControl->Show();
	pSVControl->Paint(aOutRect);
	SVE_PaintChildBorder(pSVControl);

	Rect aRect;
	aRect.left  	= (short) aOutRect.Left() - 1;
	aRect.top   	= (short) aOutRect.Top() - 1;
	aRect.right 	= (short) aOutRect.Right() + 2;	// Flackert sonst ?
	aRect.bottom 	= (short) aOutRect.Bottom() + 2;

	pSVControl->SetParent( pOldParent );
	ValidRect(&aRect);
	pSVControl->Hide();
	*/
}
#endif

/*************************************************************************
|*
|*    VCImpRealGroupBox::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 05.03.95
|*    Letzte Aenderung  KH 06.10.95
|*
*************************************************************************/
void VCImpRealGroupBox::Paint( OutputDevice* pOut)
{
	if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;
	GetSVControl((Window*)pOut);
	if( !pSVControl )
		return;

	Rectangle aOutRect(pShell->GetPos(),
					   pShell->GetSize());

	aOutRect += pShell->GetDrawOfs();
	aOutRect = pOut->LogicToLogic( aOutRect, MAP_TWIP, pShell->GetOutUnit() );

	Size aFontSize = pSVControl->GetFont().GetSize();

	aFontSize = pOut->LogicToLogic( aFontSize, MAP_POINT, MapMode(pShell->GetOutUnit()));

	Font aNewFont(pSVControl->GetFont());
	aNewFont.SetSize(aFontSize);

	ImpDrawTransparentGroupBox( pOut,		pSVControl->GetText(),
								aOutRect, 	Color (COL_BLACK),
								aNewFont,	pShell->GetOutUnit() );

}

/*************************************************************************
|*
|*    VCImpRealListBox::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    CL 19.06.95
|*    Letzte Aenderung  CL 19.06.95
|*
*************************************************************************/
void VCImpRealListBox::Paint( OutputDevice* pOut )
{
	GetSVControl((Window*)pOut );
	ImpPaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealSpinButton::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 25.07.95
|*    Letzte Aenderung  KH 25.07.95
|*
*************************************************************************/
void VCImpRealSpinButton::Paint( OutputDevice* pOut )
{
	GetSVControl((Window*)pOut );
	ImpPaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealComboBox::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 16.05.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealComboBox::Paint( OutputDevice* pOut )
{
	// Ist zwar kein Edit, funktioniert aber trotzdem
	GetSVControl((Window*)pOut );
	ImpPaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealEdit::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealEdit::Paint( OutputDevice* pOut )
{
	GetSVControl((Window*)pOut );
	ImpPaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    VCImpRealFixedText::Paint()
|*
|*    Beschreibung
|*    Ersterstellung    KH 19.04.95
|*    Letzte Aenderung  KH 16.05.95
|*
*************************************************************************/
void VCImpRealFixedText::Paint( OutputDevice* pOut )
{
	GetSVControl((Window*)pOut );
	ImpPaintMacControl(pSVControl,pOut,pShell);
}

/*************************************************************************
|*
|*    ImpGetButtonBmpSizePixel()
|*
|*    Beschreibung
|*    Ersterstellung    CL 27.10.94
|*    Letzte Aenderung  CL 10.02.95
|*
*************************************************************************/
Size ImpGetButtonBmpSizePixel()
{
	return Size();	// Brauchen wird das ?
}

/*************************************************************************
|*
|*    ImpDrawButtonBmp()
|*
|*    Beschreibung
|*    Ersterstellung    CL 27.10.94
|*    Letzte Aenderung  CL 27.10.94
|*
*************************************************************************/
/*

	*** nur der besseren Vergleichbarkeit wegen ***

void  ImpDrawButtonBmp( OutputDevice* pOut, const Point& rPos, const Size& rSize,
						const Color& rColFore, const Color& rColBack, short nBmp )

*/

/*************************************************************************
|*
|*    VCImpVirtControl::DrawBackground()
|*
|*    Beschreibung
|*    Ersterstellung    CL 27.10.94
|*    Letzte Aenderung  DV 10.12.95
|*
*************************************************************************/
void VCImpVirtControl::DrawBackground( OutputDevice* pOut )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	Brush aFillBrush(
			  ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue(),
			  BRUSH_SOLID );

	Brush	aOldBrush = pOut->GetFillInBrush();
	Pen		aOldPen = pOut->GetPen();

	pOut->SetFillInBrush( aFillBrush );
	pOut->SetPen( Pen( PEN_NULL ) );

	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Rectangle aBounds(pOut->LogicToLogic( aBoundRect, MAP_TWIP, aMode ));

	pOut->DrawRect( aBounds );

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );
}


/*************************************************************************
|*
|*    VCImpVirtControl::DrawBorder()
|*
|*    Beschreibung
|*    Ersterstellung    CL 26.10.94
|*    Letzte Aenderung  DV 12.05.95
|*
*************************************************************************/
void VCImpVirtControl::DrawBorder( OutputDevice* pOut )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();

	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_BORDER )).GetValue() )
	{
		Color   aFColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );

		Pen   aOldPen  = pOut->GetPen();
		Brush aOldBrush= pOut->GetFillInBrush();

		pOut->SetPen( Pen() );
		pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

		MapMode aMode (pOut->GetMapMode().GetMapUnit());
		Rectangle aBounds(pOut->LogicToLogic( aBoundRect, MAP_TWIP, aMode ));

		pOut->DrawRect( aBounds );

		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
	}
}

void VCCheckBoxEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	Rectangle aClientRect = GetClientRect( pOut );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();

	pOut->SetClipRegion( Region( aClientRect ) );

	Color aFColor( aForeColor );
	if (!bEnable)
		aFColor = ImpHalfColor(aForeColor);

	Font aButtonFont( aFont ); // GetFont(pOut));

	aButtonFont.SetColor(aFColor);
	aButtonFont.SetFillColor(aBackColor);
	aButtonFont.SetAlign(ALIGN_BASELINE);

	Brush aWhiteBrush(aBackColor,BRUSH_SOLID);
	Brush aBlackBrush(aFColor,BRUSH_SOLID);

	pOut->SetFillInBrush( aWhiteBrush );

	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Size aPixel  = pOut -> LogicToLogic(Size(1,1),MAP_POINT,aMode);
	Size a3Pixel = pOut -> LogicToLogic(Size(3,3),MAP_POINT,aMode);

	// PushButton Hintergrund
	Pen aPen(aFColor);
	if (bMouseInside)
		aPen.SetWidth(aPixel.Width()*2);	// Checkbox ist Fett, wenn gedrueckt
	else
		aPen.SetWidth(aPixel.Width());

	Pen  anOldPen  = pOut->GetPen();
	Font anOldFont = pOut->GetFont();

	pOut->SetPen(aPen);
	pOut->SetFont(aButtonFont);

	Rectangle aBoundRect( aPos, aSize );
	Rectangle aBounds(pOut->LogicToLogic( aBoundRect, MAP_TWIP, aMode ));

	long nMiddle = ((aBounds.Top() + aBounds.Bottom()) >> 1) - a3Pixel.Height() *2;

	Rectangle aCheckRect(	aBounds.Left() + a3Pixel.Width() + aPixel.Width(),			// + 4
							nMiddle,													// nMiddle
							aBounds.Left() + a3Pixel.Width() * 5 ,						// + 15
							nMiddle + a3Pixel.Width() * 4 - aPixel.Width());			// nMiddle + 11

	Point aTextOrigin = aCheckRect.BottomRight();

	if (bMouseInside)	// Inset, sonst ist fetter Pen auerhalb ...
	{
		aCheckRect.Top ()	+= aPixel.Height();
		aCheckRect.Left()	+= aPixel.Width();
		aCheckRect.Bottom()	-= aPixel.Height();
		aCheckRect.Right()	-= aPixel.Width();
	}

	pOut->DrawRect( aCheckRect);

	if ( bChecked )
	{
		aPen.SetWidth(aPixel.Width());
		pOut->SetPen(aPen);
		pOut->DrawLine( aCheckRect.TopLeft(),aCheckRect.BottomRight());
		pOut->DrawLine( aCheckRect.TopRight(),aCheckRect.BottomLeft());
	}

	String aText( aCaption );
	Size aTextSize = pOut->GetTextSize( aText );

	aTextOrigin +=	Point(a3Pixel.Width() *2 , -aPixel.Height());

	pOut->DrawText( aTextOrigin, aText );

	pOut->SetFont(anOldFont);
	pOut->SetPen(anOldPen);

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

Size VCCheckBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Size a3Pixel = pOut -> LogicToLogic(Size(3,3),MAP_POINT,aMode);
	Size aCheckSize( 4*a3Pixel.Width(),0);
	aCheckSize.Height() = aCheckSize.Width();
	// abstand checkbox text
	aCheckSize.Width() += a3Pixel.Width() * 2;
	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); //GetFont(pOut) );
	Size aTextSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );
	aCheckSize.Width() += aTextSize.Width();
	if( aCheckSize.Height() < aTextSize.Height() )
		aCheckSize.Height() = aTextSize.Height();
	return aCheckSize;
}

Size VCRadioButtonEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	// siehe CheckBox::GetOptSize
	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Size a3Pixel = pOut -> LogicToLogic(Size(3,3),MAP_POINT,aMode);
	Size aCheckSize( 4*a3Pixel.Width(),0);
	aCheckSize.Height() = aCheckSize.Width();
	// abstand checkbox text
	aCheckSize.Width() += a3Pixel.Width() * 2;
	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); // GetFont(pOut) );
	Size aTextSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );
	aCheckSize.Width() += aTextSize.Width();
	if( aCheckSize.Height() < aTextSize.Height() )
		aCheckSize.Height() = aTextSize.Height();
	return aCheckSize;
}

Size VCPushButtonEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Size a10Pixel = pOut -> LogicToLogic(Size(10,10),MAP_POINT,aMode);

	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); // GetFont(pOut) );
	Size aButtonSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );

	aButtonSize.Width() += 2*a10Pixel.Width();
	aButtonSize.Height() += a10Pixel.Height();
	return aButtonSize;
}

Rectangle VCRadioButtonEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	return Rectangle();
}

void VCRadioButtonEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	Color aFColor( aForeColor );

	if (!bEnable)
		aFColor = ImpHalfColor(aFColor);

	Rectangle aClientRect = GetClientRect( pOut );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();

	pOut->SetClipRegion( Region( aClientRect ) );

	Font aButtonFont( aFont ); // GetFont(pOut));

	aButtonFont.SetColor(aFColor);
	aButtonFont.SetFillColor(aBackColor);
	aButtonFont.SetAlign(ALIGN_BASELINE);

	Brush aBackBrush(aBackColor,BRUSH_SOLID);
	Brush aForeBrush(aFColor,BRUSH_SOLID);

	pOut->SetFillInBrush( aBackBrush );

	// Umrechen bzgl Map-Mode
	MapMode aMode(pOut->GetMapMode().GetMapUnit());
	Size aPixel  = pOut -> LogicToLogic(Size(1,1), MAP_POINT,aMode);
	Size a3Pixel = pOut -> LogicToLogic(Size(3,3), MAP_POINT,aMode);

	// PushButton Hintergrund

	Rectangle aBounds(aPos, aSize);
	aBounds = pOut->LogicToLogic( aBounds, MAP_TWIP, aMode );

	long nMiddle = ((aBounds.Top() + aBounds.Bottom()) >> 1) - a3Pixel.Height() *2;

	Rectangle aRadioRect(	aBounds.Left() + a3Pixel.Width() + aPixel.Width(),			// + 4
							nMiddle,													// nMiddle
							aBounds.Left() + a3Pixel.Width() * 5 ,						// + 15
							nMiddle + a3Pixel.Width() * 4 - aPixel.Width());			// nMiddle + 11

	Point aTextOrigin = aRadioRect.BottomRight();

	Pen aPen(aFColor);
	if (bMouseInside)
	{	// Inset, sonst ist fetter Pen auerhalb ...
		aPen.SetWidth(aPixel.Width()*2);	// Radiobutton ist Fett, wenn gedrueckt
		aRadioRect.Top ()	+= aPixel.Height();
		aRadioRect.Left()	+= aPixel.Width();
		aRadioRect.Bottom()	-= aPixel.Height();
		aRadioRect.Right()	-= aPixel.Width();
	}
	else
		aPen.SetWidth(aPixel.Width());

	Pen anOldPen = pOut->GetPen();

	pOut->SetPen(aPen);
	pOut->DrawEllipse( aRadioRect);

	if ( bChecked )
	{
		pOut->SetFillInBrush( aForeBrush );
		Rectangle anInnerRect(	aRadioRect.Left() + a3Pixel .Width(),
									aRadioRect.Top() + a3Pixel.Height(),
								aRadioRect.Right() - a3Pixel .Width(),
									aRadioRect.Bottom() - a3Pixel.Height());
		pOut->DrawEllipse(anInnerRect);
	}

	Size aTextSize = pOut->GetTextSize( aCaption );
	Font anOldFont = pOut->GetFont();

	pOut->SetFont(aButtonFont);

	aTextOrigin += Point(a3Pixel.Width()*2, -aPixel.Height());

	pOut->DrawText( aTextOrigin, aCaption );
	pOut->SetFont(anOldFont);
	pOut->SetPen(anOldPen);

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

/*************************************************************************
|*
|*    Beschreibung
|*    Ersterstellung    CL 28.10.94
|*    Letzte Aenderung  KH 21.04.95
|*
*************************************************************************/
void VCPushButtonEngine::DrawBackground( OutputDevice* pOut )
{
	VCButtonEngine::DrawBackground(pOut);
}

Rectangle VCPushButtonEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	return Rectangle();
}

void VCPushButtonEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	if( aImageURL.Len() )
	{
		LoadImageButton( pOut );
		return;
	}

	Color   aFColor( aForeColor ); //((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );

	if (!bEnable)
		aFColor = ImpHalfColor(aFColor);

	BOOL 	bClip 		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();

	pOut->SetClipRegion( Region( GetClientRect( pOut ) ) );

	Font aButtonFont( aFont ); //GetFont(pOut));

	Brush aWhiteBrush(aBackColor,BRUSH_SOLID);
	Brush aBlackBrush(aFColor,BRUSH_SOLID);

	if (bMouseInside)
	{
		pOut->SetFillInBrush( aBlackBrush );
		aButtonFont.SetColor(aBackColor);
		aButtonFont.SetFillColor(aFColor);
	}
	else
	{
		pOut->SetFillInBrush( aWhiteBrush );
		aButtonFont.SetColor(aFColor);
		aButtonFont.SetFillColor(aBackColor);
	}
	// PushButton Hintergrund
	Pen  anOldPen  = pOut->GetPen();
	Font anOldFont = pOut->GetFont();

	pOut->SetPen(Pen(aFColor));
	pOut->SetFont(aButtonFont);

	Rectangle aBouttonRect(aPos, aSize);

	MapMode aMode (pOut->GetMapMode().GetMapUnit());

	aBouttonRect = pOut->LogicToLogic( aBouttonRect, MAP_TWIP, aMode );

	// Umrechen bzgl Map-Mode
	Size aPixel   = pOut -> LogicToLogic(Size(1,1), MAP_POINT,aMode);
	Size a16Pixel = pOut -> LogicToLogic(Size(16,16), MAP_POINT,aMode);

	aBouttonRect.Top()    += aPixel.Height();
	aBouttonRect.Left()   += aPixel.Width();
	aBouttonRect.Bottom() -= aPixel.Height();
	aBouttonRect.Right()  -= aPixel.Width();

	pOut->DrawRect( aBouttonRect, a16Pixel.Width() , a16Pixel.Height() );
	Size aTextSize = pOut->GetTextSize( aCaption );

	Point aTextOrigin = aBouttonRect.Center();

	aTextOrigin.X() -= aTextSize.Width()  >> 1;
	aTextOrigin.Y() -= aTextSize.Height() >> 1;

	pOut->DrawText( aTextOrigin, aCaption );

	pOut->SetFont(anOldFont);
	pOut->SetPen(anOldPen);

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

void VCPushButtonEngine::DrawBorder( OutputDevice* )
{
}

void VCImpVirtGroupBox::DrawBackground( OutputDevice* pOut )
{
}

void VCImpVirtGroupBox::DrawBorder( OutputDevice* )
{
}

Rectangle VCImpVirtGroupBox::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	return Rectangle();
}

void VCImpVirtGroupBox::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;
	if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;

	SfxItemSet* pLocalItemSet = pShell->GetItemSet();

	Color   aFColor( ((SvxColorItem&)pLocalItemSet->Get( VCATTR_FORECOLOR )).GetValue() );

	BOOL bEnabled = ((SfxBoolItem&)pLocalItemSet->Get( VCATTR_ENABLED )).GetValue();
	if (!bEnabled)
		aFColor = ImpHalfColor(aFColor);

	Rectangle aClientRect = GetClientRect( pOut );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();

	pOut->SetClipRegion( Region( aClientRect ) );

	Rectangle aOutRect = GetClientRect( pOut );

	String aText   = ((SfxStringItem&)pLocalItemSet->Get( VCATTR_CAPTION )).GetValue();

	ImpDrawTransparentGroupBox( pOut,			aText,
								aOutRect, 		aFColor,
								GetFont(pOut), 	pShell->GetOutUnit() );

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

/***************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcidrawm.cxx,v 1.1.1.1 2000/09/29 11:02:40 mh Exp $

	  Source Code Control System - Update

	  $Log: vcidrawm.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:40  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:49  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.24  1997/12/05 14:56:26  OV
	  MAC: Neue VCL-Paintroutine verwenden
	

	  Rev 1.23   05 Dec 1997 15:56:26   OV
   MAC: Neue VCL-Paintroutine verwenden

	  Rev 1.22   06 Nov 1997 12:45:58   OV
   VCL-Umstellungen

	  Rev 1.21   31 Oct 1997 17:14:20   OV
   VCL: Windows-Zeichenfunktionen auf allen Plattformen (364-inkompat); diverse VCL-Anpassungen

	  Rev 1.20   23 Sep 1997 09:15:56   OV
   #43774# Diverse Anpassungen fuer VCL

	  Rev 1.19   09 Aug 1997 11:09:14   OS
   frmitems/paraitem/textitem aufgeteilt

	  Rev 1.18   08 Aug 1997 16:08:08   RG
   Mac-Anpassung

	  Rev 1.17   10 Jan 1997 12:00:50   DV
   -mSyntaxfehler fuer MAC behoben

	  Rev 1.16   12 Dec 1996 12:37:34   OV
   Umstellung auf Button-Engines

	  Rev 1.15   23 Aug 1996 16:13:28   DV
   Offsetproblem beseitigt

	  Rev 1.14   25 Jul 1996 19:06:18   OV
   Image-Buttons

	  Rev 1.13   07 Jun 1996 14:30:20   OV
   NEU: Print-Property

	  Rev 1.12   19 Apr 1996 15:01:18   WKC
   svxitems.hxx -> textitem.hxx

	  Rev 1.11   02 Apr 1996 12:10:16   WKC
   2mal: .Width() dazu

	  Rev 1.10   07 Mar 1996 16:49:34   OV
   NEU: GetOptSize u.a

	  Rev 1.9   08 Feb 1996 13:35:48   KH
   Anpassungen nach SV ?nderungen

	  Rev 1.8   10 Dec 1995 11:22:12   DV
   Change ist ungleich Set


*************************************************************************/

#endif
