/*************************************************************************
 *
 *  $RCSfile: vcidrawu.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef VCL

#include "vcidraww.cxx"

#else

#include <sysdep.hxx>
#include <sv.hxx>

#define _SVSTDARR_ULONGS
#include <svstdarr.hxx>
#define ITEMID_COLOR 0
#include <textitem.hxx>
#include <sfxsh.hxx>
#ifndef _SFXITEMS_HXX
#include <sfxitems.hxx>
#endif
#include "vcattr.hxx"
#include "vcont.hxx"
#include "vctrls.hxx"
#include "vcictrls.hxx"
#include "vcattrid.hrc"
#include <vcengin2.hxx>

#include <stdio.h> // fprintf, stderr
#include <math.h>  // ceil()

#ifndef VCL

void VCImpRealControl::Paint( OutputDevice* pOut )
{
  if( ( pCurControl != NULL ) && ( pCurControl != this ) )
	return;

  pCurControl = this;

	if( !pSVControl || (pOut->GetOutDevType() != OUTDEV_WINDOW) )
		return;

	Window* pOutWin = (Window*)pOut;
	GetSVControl(pOutWin);

	Point aPos        = pShell->GetPos();
		  aPos       += pShell->GetDrawOfs();
		  aPos        = pOutWin->LogicToPixel( aPos );
	Size  aSize       = pOutWin->LogicToPixel( pShell->GetSize() );

	Size  aParentSize = pOutWin->GetOutputSizePixel();

	pSVControl->SetPosSizePixel( aPos, aSize );

	Sysdepen::Draw(pSVControl, pOut, aPos, aSize );

  pCurControl = NULL;
}

#endif

Size ImpGetButtonBmpSizePixel()
{
	return Size(16,16); // the size of a Motif 1.2 checkbox
}

#define BMP_CHECK	0x0000
#define BMP_RADIO   0x0001
#define BMP_HI		0x0010
#ifdef BMP_CHECKED
#undef BMP_CHECKED
#endif
#define BMP_CHECKED	0x0100

#define MTF_TGL_SHDW_WDTH 2
#define MTF_RDO_SHDW_WDTH 3

void  ImpDrawButtonBmp( OutputDevice* pOut, const Point& rPos, const Size& rSize,
						const Color& rColFore, const Color& rColBack, short nBmp )
{
	MapMode aOldMapMode = pOut->GetMapMode();
	pOut->SetMapMode( MAP_PIXEL );

	BOOL 	bClip 		= pOut->IsClipRegion();
	Region 	aOldRegion 	= pOut->GetClipRegion();
	pOut->SetClipRegion();

	Pen a3DFacePen( rColFore );

	Pen a3DDarkerFacePen; // color to be changed later
	Pen a3DLightPen; a3DLightPen.SetColor( COL_3DLIGHT );
	Pen a3DShadowPen; a3DShadowPen.SetColor( COL_3DSHADOW );
	Brush aFillInBrush( rColFore );
	Rectangle aRectangle( rPos, rSize );

	Brush aOldFillInBrush     = pOut->GetFillInBrush();
	Pen   aOldPen             = pOut->GetPen();

	if( nBmp & BMP_HI )
	{
	  // highlighted - set pen size to 2 (not very portable)
	  a3DFacePen.SetWidth( 2 );
	  a3DDarkerFacePen.SetWidth( 2 );
	  a3DLightPen.SetWidth( 2 );
	  a3DShadowPen.SetWidth( 2 );
	}
	else
	{
	  // not highlighted - set pen size to 1
	  a3DFacePen.SetWidth( 1 );
	  a3DDarkerFacePen.SetWidth( 1 );
	  a3DLightPen.SetWidth( 1 );
	  a3DShadowPen.SetWidth( 1 );
	}

	// in checked checkboxes, the fill color is slightly (15%)
	// darker than in unchecked ones
	Color a3DDarkerFaceColor( COL_SCROLLBAR );
	// and assign it to the corresponding pen
	a3DDarkerFacePen.SetColor( a3DDarkerFaceColor );

	if( ( nBmp & BMP_RADIO ) == BMP_CHECK )
	  {
		// draw a checkbox
		// background of the button
		if (nBmp & BMP_CHECKED )
		{
			aFillInBrush.SetColor( a3DDarkerFaceColor );
			pOut->SetPen( a3DDarkerFacePen );
		}
		else
		{
			aFillInBrush.SetColor( rColFore );
			pOut->SetPen( a3DFacePen );
		}
		aFillInBrush.SetStyle( BRUSH_SOLID );
		pOut->SetFillInBrush( aFillInBrush );
		Rectangle aInnerRect( Point( rPos.X()+MTF_TGL_SHDW_WDTH,
						  rPos.Y()+MTF_TGL_SHDW_WDTH ),
					  Size( rSize.Width()-MTF_TGL_SHDW_WDTH*2,
						rSize.Height()-MTF_TGL_SHDW_WDTH*2 ) );
		pOut->DrawRect( aInnerRect );

		// anti-shadow (non-checked) resp. shadow (checked)
		if( nBmp & BMP_CHECKED )
		  pOut->SetPen( a3DShadowPen );
		else
		  pOut->SetPen( a3DLightPen );
		pOut->DrawLine( rPos, Point( rPos.X()+rSize.Width()-1, rPos.Y() ) );
		pOut->DrawLine( Point( rPos.X(), rPos.Y()+1 ),
					Point( rPos.X()+rSize.Width()-2, rPos.Y()+1 ) );
		pOut->DrawLine( rPos, Point( rPos.X(),rPos.Y()+rSize.Height()-1 ) );
		pOut->DrawLine( Point( rPos.X()+1, rPos.Y() ),
					Point( rPos.X()+1, rPos.Y()+rSize.Height()-1-1) );

		// shadow (non-checked) resp. anti-shadow (checked)
		if( nBmp & BMP_CHECKED )
		  pOut->SetPen( a3DLightPen );
		else
		  pOut->SetPen( a3DShadowPen );
		pOut->DrawLine( Point( rPos.X()+1, rPos.Y()+rSize.Height()-1 ),
					Point( rPos.X()+rSize.Width()-2,
					   rPos.Y()+rSize.Height()-1 ) );
		pOut->DrawLine( Point( rPos.X()+2, rPos.Y()+rSize.Height()-1-1 ),
					Point( rPos.X()+rSize.Width()-2,
					   rPos.Y()+rSize.Height()-1-1 ) );
		pOut->DrawLine( Point( rPos.X()+rSize.Width()-1, rPos.Y()+1 ),
					Point( rPos.X()+rSize.Width()-1,
					   rPos.Y()+rSize.Height()-1 ) );
		pOut->DrawLine( Point( rPos.X()+rSize.Width()-1-1, rPos.Y()+2 ),
					Point( rPos.X()+rSize.Width()-1-1,
					   rPos.Y()+rSize.Height()-1 ) );
	  }
	if( ( nBmp & BMP_RADIO ) == BMP_RADIO )
	  {
		if( nBmp & BMP_CHECKED )
		  {
			aFillInBrush.SetColor( a3DDarkerFaceColor );
			pOut->SetPen( a3DDarkerFacePen );
		  }
		else
		  {
			aFillInBrush.SetColor( rColFore );
			pOut->SetPen( a3DFacePen );
		  }
		aFillInBrush.SetStyle( BRUSH_SOLID );
		pOut->SetFillInBrush( aFillInBrush );

		// inner diamond
		Point aDmndPtAry[] = { Point( rPos.X()+3,
						  rPos.Y()+rSize.Height()/2 ),
					   Point( rPos.X()+rSize.Width()/2,
						  rPos.Y()+3 ),
					   Point( rPos.X()+rSize.Width()-1-3,
						  rPos.Y()+rSize.Height()/2 ),
					   Point( rPos.X()+rSize.Width()/2,
						  rPos.Y()+rSize.Height()-1-3 )
					   };

		Polygon aPolygon( 4, aDmndPtAry );
		pOut->DrawPolygon( aPolygon );

		// shadow (checked) resp. anti-shadow (unchecked)
		// anti-shadow (non-checked) resp. shadow (checked)
		if( nBmp & BMP_CHECKED )
		  pOut->SetPen( a3DShadowPen );
		else
		  pOut->SetPen( a3DLightPen );

		pOut->DrawLine( Point( rPos.X(), rSize.Height()/2+1+rPos.Y()-1 ),
				Point( rSize.Width()/2+rPos.X(), rPos.Y() ) );
		pOut->DrawLine( Point( rPos.X()+1, rSize.Height()/2+1+rPos.Y()-1 ),
				Point( rSize.Width()/2+rPos.X(), rPos.Y()+1 ) );
		pOut->DrawLine( Point( rPos.X()+2, rSize.Height()/2+1+rPos.Y()-1 ),
				Point( rSize.Width()/2+rPos.X(), rPos.Y()+2 ) );

		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(), rPos.Y() ),
				Point( rPos.X()+rSize.Width()-1-1,
					   rSize.Height()/2+1+rPos.Y()-2 ) );
		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(), rPos.Y()+1 ),
				Point( rPos.X()+rSize.Width()-1-2,
					   rSize.Height()/2+1+rPos.Y()-2 ) );
		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(), rPos.Y()+2 ),
				Point( rPos.X()+rSize.Width()-1-3,
					   rSize.Height()/2+1+rPos.Y()-2 ) );

		// shadow (non-checked) resp. anti-shadow (checked)
		if( nBmp & BMP_CHECKED )
		  pOut->SetPen( a3DLightPen );
		else
		  pOut->SetPen( a3DShadowPen );

		pOut->DrawLine( Point( rPos.X()+rSize.Width()-1,
					   rSize.Height()/2+rPos.Y() ),
					Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1 ) );
		pOut->DrawLine( Point( rPos.X()+rSize.Width()-1-1,
					   rSize.Height()/2+rPos.Y() ),
					Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1-1 ) );
		pOut->DrawLine( Point( rPos.X()+rSize.Width()-1-2,
					   rSize.Height()/2+rPos.Y() ),
					Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1-2 ) );

		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1 ),
					Point( rPos.X()+1,
					   rSize.Height()/2+1+rPos.Y() ) );
		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1-1 ),
					Point( rPos.X()+2, rSize.Height()/2+1+rPos.Y() ) );
		pOut->DrawLine( Point( rSize.Width()/2+rPos.X(),
					   rPos.Y()+rSize.Height()-1-2 ),
					Point( rPos.X()+3, rSize.Height()/2+1+rPos.Y() ) );
	  }

	pOut->SetFillInBrush( aOldFillInBrush );
	pOut->SetPen( aOldPen );
	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	pOut->SetMapMode( aOldMapMode );
}

void VCImpVirtControl::DrawBackground( OutputDevice* pOut )
{
	Pen aOldPen = pOut->GetPen();
	pOut->SetPen( Pen( PEN_NULL ) );

	Brush aFillBrush(
			  ((SvxColorItem&)pShell->GetItemSet()->Get( VCATTR_BACKCOLOR )).GetValue(),
			  BRUSH_SOLID );

	Brush aOldBrush = pOut->GetFillInBrush();
	pOut->SetFillInBrush( aFillBrush );

	pOut->DrawRect( aBoundRect );

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );
}

void VCImpVirtControl::DrawBorder( OutputDevice* pOut )
{
	if( ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_BORDER )).GetValue() )
	{
		Pen   aOldPen  = pOut->GetPen();
		pOut->SetPen( Pen() );
		Brush aOldBrush= pOut->GetFillInBrush();
		pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

		pOut->DrawRect( aBoundRect );

		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
	}
}

void VCCheckBoxEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	// CheckBox Text
	Font   aXFont	= aFont; //GetFont( pOut );
	aXFont.SetTransparent( TRUE );
	Font   aOldFont = pOut->GetFont();
	pOut->SetFont( aXFont );

	String aText( aCaption );

	// compute the size of the check box
	Size aCheckSize = pOut->LogicToPixel(pOut->GetTextSize(aText));
	// size of a check box is about ceil(83%) of the text height
	// (measured from Netscape Navigator)
	aCheckSize.Height() = (long)(ceil(((float)(aCheckSize.Height())) * 0.83));
	aCheckSize.Width() = aCheckSize.Height();
	BOOL bHigh		= bLeftButtonDown && bMouseInside;

	Rectangle aClientRect = GetClientRect( pOut );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();
	pOut->SetClipRegion( Region( aClientRect ) );

	// CheckBox Grafik
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		Rectangle aRect = pOut->LogicToPixel( aClientRect );

		aRect.Left() += 1;
		aRect.Top()	 += (aRect.GetSize().Height()>>1) -
						(aCheckSize.Height()>>1);

		short nBmp = BMP_CHECK;
		if( bHigh )
			nBmp |= BMP_HI;
		if( bChecked )
			nBmp |= BMP_CHECKED;

		ImpDrawButtonBmp( pOut, aRect.TopLeft(), aCheckSize,
						  Color( COL_3DFACE ),
						  aBackColor,
						  nBmp );
	}
	else
	{
		Pen 	aOldPen  = pOut->GetPen();
		pOut->SetPen( Pen() );
		Brush   aOldBrush= pOut->GetFillInBrush();
		pOut->SetFillInBrush( Brush() );

		Rectangle aRect  = aClientRect;
		aRect.Left() 	+= 1;
		aRect.Top()  	+= (aClientRect.GetSize().Height() >> 1)
						   - (aCheckSize.Height() >> 1);
		aRect.Right()	= aRect.Left() + aCheckSize.Width();
		aRect.Bottom()  = aRect.Top() + aCheckSize.Height();
		pOut->DrawRect( aRect );

		if( bChecked )
		{
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomRight() );
			pOut->DrawLine( aRect.BottomLeft(), aRect.TopRight() );
		}

		pOut->SetFillInBrush( aOldBrush );
		pOut->SetPen( aOldPen );
	}

	Rectangle aVCTextRect = GetTextRect( pOut, aFont );
	pOut->DrawText( aVCTextRect.TopLeft(), aText );

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetFont( aOldFont );
}

Rectangle VCRadioButtonEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	Font aOldFont( pOut->GetFont( ) );
	pOut->SetFont( rFont );

	// CheckBox Text
	String aText( aCaption );
	Size   aTextSize;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		VCImpControl::ConvertAmpersand( &aText );
		aTextSize = ((Window*)pOut)->GetCtrlTextSize( aText );
	}
	else
	{
		VCImpControl::DeleteAmpersand( &aText );
		aTextSize = pOut->GetTextSize( aText );
	}

	Size   aCheckSize   = ImpGetButtonBmpSizePixel();
	// Weil die Pixel hier mit Bildschirmauflsung gerechnet sind
	MapMode aMap1( MAP_10TH_MM );
	MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
	aCheckSize = SI_DLL()->GetOutDev()->PixelToLogic( aCheckSize, aMap2 );
	Rectangle aRect = GetClientRect( pOut );
	Size aXSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
	Point aXPos  = aRect.TopLeft();
	aXPos.X()	+= 1 + aCheckSize.Width() + 3;
	aXPos.Y()	+= (aRect.GetSize().Height() >> 1) - (aTextSize.Height() >> 1);
	Rectangle aTextRect( aXPos, aTextSize );
	aTextRect.Intersection( aRect );
	pOut->SetFont( aOldFont );
	return aTextRect;
}

void VCRadioButtonEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	// RadioButton Text
	Font   aXFont	= aFont; //GetFont( pOut );
	aXFont.SetTransparent( TRUE );
	Font   aOldFont = pOut->GetFont();
	pOut->SetFont( aXFont );

	String aText( aCaption );

	Size aSize = pOut->GetTextSize( aText );

	// compute the size of the check box
	Size aCheckSize = pOut->LogicToPixel(pOut->GetTextSize(aText));
	aCheckSize.Height()++; // size of a check box is one more than the text size

	aCheckSize.Width() = aCheckSize.Height();

	BOOL bHigh		= bLeftButtonDown && bMouseInside;

	Rectangle aClientRect = GetClientRect( pOut );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();
	pOut->SetClipRegion( Region( aClientRect ) );

	// RadioButton Grafik
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		Rectangle aRect = pOut->LogicToPixel( aClientRect );

		aRect.Left() += 1;
		aRect.Top()	 += (aRect.GetSize().Height()>>1) -
						(aCheckSize.Height()>>1);

		short nBmp = BMP_RADIO;
		if( bHigh )
			nBmp |= BMP_HI;
		if( bChecked )
			nBmp |= BMP_CHECKED;

		ImpDrawButtonBmp( pOut, aRect.TopLeft(), aCheckSize,
						  Color( COL_3DFACE ),
						  aBackColor,
						  nBmp );
	}
	else
	{
		Pen 	aOldPen  = pOut->GetPen();
		pOut->SetPen( Pen() );
		Brush   aOldBrush= pOut->GetFillInBrush();
		pOut->SetFillInBrush( Brush() );

		Rectangle aRect  = aClientRect;
		aRect.Left() 	+= 1;
		aRect.Top()  	+= (aClientRect.GetSize().Height() >> 1)
						   - (aCheckSize.Height() >> 1);
		aRect.Right()	= aRect.Left() + aCheckSize.Width();
		aRect.Bottom()  = aRect.Top() + aCheckSize.Height();
		pOut->DrawRect( aRect );

		if( bChecked )
		{
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomRight() );
			pOut->DrawLine( aRect.BottomLeft(), aRect.TopRight() );
		}

		pOut->SetFillInBrush( aOldBrush );
		pOut->SetPen( aOldPen );
	}

	Rectangle aVCTextRect = GetTextRect( pOut, aFont );
	pOut->DrawText( aVCTextRect.TopLeft(), aText );

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetFont( aOldFont );
}


void VCPushButtonEngine::DrawBackground( OutputDevice* pOut )
{
}

Rectangle VCPushButtonEngine::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	Font aOldFont 	= pOut->GetFont();
	pOut->SetFont( rFont );

	String aText( aCaption );
	Size aXSize = pOut->GetTextSize( aText );

	Rectangle aRect( GetClientRect( pOut ) );
	Point aXPos = aRect.TopLeft();
	aXPos.X() += (aRect.GetSize().Width() >> 1) - (aXSize.Width() >> 1);
	aXPos.Y() += (aRect.GetSize().Height() >> 1) - (aXSize.Height() >> 1);

	Rectangle aVCTextRect( aXPos, aXSize );
	aVCTextRect.Intersection( aRect );

	pOut->SetFont( aOldFont );

	return aVCTextRect;
}

void VCPushButtonEngine::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	if( aImageURL.Len() )
	{
		LoadImageButton( pOut );
		return;
	}
	Color aLightCol( COL_3DLIGHT );
	Color aFaceCol( COL_3DFACE );
	Color aShadowCol( COL_3DSHADOW );
	Color aBlackCol;

	BOOL 	bClip 	   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	pOut->SetClipRegion(Region(GetClientRect( pOut ) ) );

	// PushButton Hintergrund
	Color a3dColor( COL_3DFACE );
	Brush aBackBrush( a3dColor, BRUSH_SOLID );
	Brush aOldBrush = pOut->GetFillInBrush();
	pOut->SetFillInBrush( aBackBrush );
	Pen   aOldPen   = pOut->GetPen();
	pOut->SetPen( Pen( PEN_NULL ) );

	Rectangle aRect( GetClientRect( pOut ) );
	pOut->DrawRect( aRect );

	// PushButton Frame
	Pen 		aPen;

	Size aOfs = pOut->PixelToLogic( Size( 1, 1 ) );

	Rectangle aRect2 = aRect;
	aRect2.Left()  += aOfs.Width();
	aRect2.Top()   += aOfs.Height();
	aRect2.Right() -= aOfs.Width();
	aRect2.Bottom()-= aOfs.Height();


	if( bLeftButtonDown && bMouseInside )
	{
		// PushButton is pressed

		aPen.SetColor( aShadowCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );
		pOut->DrawLine( aRect2.TopLeft(), aRect2.TopRight() );
		pOut->DrawLine( aRect2.TopLeft(), aRect2.BottomLeft() );

		aPen.SetColor( aLightCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect2.BottomRight(), aRect2.BottomLeft() );
		pOut->DrawLine( aRect2.BottomRight(), aRect2.TopRight() );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

	}
	else
	{
		// PushButton is not pressed

		aPen.SetColor( aLightCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );
		pOut->DrawLine( aRect2.TopLeft(), aRect2.TopRight() );
		pOut->DrawLine( aRect2.TopLeft(), aRect2.BottomLeft() );

		aPen.SetColor( aShadowCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		pOut->DrawLine( aRect2.BottomRight(), aRect2.BottomLeft() );
		pOut->DrawLine( aRect2.BottomRight(), aRect2.TopRight() );
	}

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );


	// PushButton Text
	Font    aXFont = aFont; // GetFont( pOut );
	aXFont.SetColor( Color( COL_3DTEXT ) );

	Font 	aOldFont = pOut->GetFont();
	pOut->SetFont( aXFont );

	Rectangle aVCTextRect = GetTextRect( pOut, aXFont );
	String aText( aCaption );

	if( bLeftButtonDown && bMouseInside )
		aVCTextRect.Move( aOfs.Width(), aOfs.Height() );

	pOut->DrawText( aVCTextRect.TopLeft(), aText );

	pOut->SetFont( aOldFont );


	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();
}

void VCPushButtonEngine::DrawBorder( OutputDevice* )
{
}

void VCImpVirtGroupBox::DrawBackground( OutputDevice* pOut )
{
}

void VCImpVirtGroupBox::DrawBorder( OutputDevice* )
{
}

Rectangle VCImpVirtGroupBox::GetTextRect( OutputDevice* pOut, const Font& rFont ) const
{
	Font   aOldFont = pOut->GetFont();
	pOut->SetFont( rFont );

	String aText = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
	Size aSize = pOut->GetTextSize( aText );

	Rectangle aRect( GetClientRect( pOut ) );
	Point aPos = aRect.TopLeft(); // aBoundRect.TopLeft();
	Rectangle aVCTextRect( aPos, aSize );

	Size aOfs = pOut->PixelToLogic( Size( 8, 0 ) );

	aVCTextRect.Move( aOfs.Width(), 0 );
	aVCTextRect.Intersection( aRect );

	pOut->SetFont( aOldFont );

	return aVCTextRect;
}

void VCImpVirtGroupBox::DrawControl( OutputDevice* pOut, USHORT nDrawFlags )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER && !pShell->IsPrintable())
		return;

	Rectangle aClientRect 	= GetClientRect( pOut );
	Font      aFont		= GetFont( pOut );
	Rectangle aVCTextRect  	= GetTextRect( pOut, aFont );
	Size 	  aOfs 		= pOut->PixelToLogic( Size( 2, 0 ) );
	Size      aShadowOfs    = pOut->PixelToLogic( Size( 1, 1 ) );

	BOOL 	bClip		= pOut->IsClipRegion();
	Region  aOldRegion	= pOut->GetClipRegion();
	pOut->SetClipRegion( Region( aClientRect ) );

	// Border zeichnen
	Rectangle aBorderRect = aClientRect;
	aBorderRect.Top() += aVCTextRect.GetSize().Height() >>1;

	Pen aOldPen = pOut->GetPen();
	pOut->SetPen( Pen( Color( COL_3DSHADOW ) ) );
	pOut->DrawLine( aBorderRect.TopLeft(), aBorderRect.BottomLeft() );
	pOut->DrawLine( Point( aBorderRect.Left()+aShadowOfs.Width()*2,
				   aBorderRect.Bottom()-aShadowOfs.Height() ),
				Point( aBorderRect.Right()-aShadowOfs.Width()*2,
				   aBorderRect.Bottom()-aShadowOfs.Height() ) );
	pOut->DrawLine( Point( aBorderRect.Right()-aShadowOfs.Width(),
				   aBorderRect.Bottom()-aShadowOfs.Height() ),
				Point( aBorderRect.Right()-aShadowOfs.Width(),
				   aBorderRect.Top()+aShadowOfs.Height()*2 ) );
	pOut->DrawLine( aBorderRect.TopLeft(),
			Point( aVCTextRect.Left() - aOfs.Width(),
				   aBorderRect.Top() ) );
	pOut->DrawLine( Point( aVCTextRect.Right() + aOfs.Width(),
				   aBorderRect.Top() ),
				   aBorderRect.TopRight() );

	pOut->SetPen( Pen( Color( COL_3DLIGHT ) ) );
	pOut->DrawLine( Point( aBorderRect.Left()+aShadowOfs.Width(),
				   aBorderRect.Top()+aShadowOfs.Height() ),
				Point( aBorderRect.Left()+aShadowOfs.Width(),
				   aBorderRect.Bottom()) );
	pOut->DrawLine( Point( aBorderRect.Left()+aShadowOfs.Width(),
				   aBorderRect.Bottom() ),
				Point( aBorderRect.Right(),
				   aBorderRect.Bottom() ) );
	pOut->DrawLine( aBorderRect.BottomRight(),
				Point( aBorderRect.Right(),
				   aBorderRect.Top()+aShadowOfs.Height() ) );
	pOut->DrawLine( Point( aBorderRect.Left()+aShadowOfs.Width(),
				   aBorderRect.Top()+aShadowOfs.Height() ),
				Point( aVCTextRect.Left() - aOfs.Width(),
				   aBorderRect.Top()+aShadowOfs.Height() ) );
	pOut->DrawLine( Point( aVCTextRect.Right() + aOfs.Width(),
				   aBorderRect.Top()+aShadowOfs.Height() ),
				Point( aBorderRect.Right(),
				   aBorderRect.Top()+aShadowOfs.Height()) );

	pOut->SetPen( aOldPen );

	// GroupBox Text
	Font aOldFont = pOut->GetFont();
	pOut->SetFont( aFont );

	String aText = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
	Size aSize = pOut->GetTextSize( aText );

	pOut->SetClipRegion( Region( aVCTextRect ) );

	pOut->DrawText( aVCTextRect.TopLeft(), aText );

	if( bClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetFont( aOldFont );
}

void VCImpRealGroupBox::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;
	Window* pOutWin = (Window*)pOut;
	GetSVControl(pOutWin);

	Font   aOldFont;
	Pen    aOldPen;
	Brush  aOldBrush;
	BOOL   bOldClip = pOutWin->IsClipRegion();
	Region aOldClip;

	aOldFont = pOutWin->GetFont();
	Font aFont( pSVControl->GetFont() );
	aFont.SetAlign( ALIGN_TOP );
	Size aSize = aFont.GetSize();
	aSize = pOut->PixelToLogic( aSize );
	aFont.SetSize( aSize );
	pOutWin->SetFont( aFont );

	Rectangle aBoundRect( pShell->GetPos(), pShell->GetSize() );
	aBoundRect += pShell->GetDrawOfs();
	Rectangle aRect = aBoundRect;

	Size aTextSize = pOutWin->GetTextSize( pSVControl->GetText() );
	aRect.Top() += aTextSize.Height() >> 1;

//!!!
// Zur Zeit immer SV Look
	if ( TRUE )
	{
		Color aShadowColor( COL_3DSHADOW );
		Pen   aShadowPen( aShadowColor );
		pOutWin->SetPen( aShadowPen );
		pOutWin->DrawLine( aRect.TopLeft(), Point( aRect.Right()-1, aRect.Top() ) );
		pOutWin->DrawLine( Point( aRect.Right()-1, aRect.Top() ),
						   Point( aRect.Right()-1, aRect.Bottom()-1 ) );
		pOutWin->DrawLine( Point( aRect.Right()-1, aRect.Bottom()-1 ),
						   Point( aRect.Left(), aRect.Bottom()-1 ) );
		pOutWin->DrawLine( Point( aRect.Left(), aRect.Bottom()-1 ),
						   Point( aRect.Left(), aRect.Top() ) );

		Color aLightColor( COL_3DLIGHT );
		Pen   aLightPen( aLightColor );
		pOutWin->SetPen( aLightPen );
		pOutWin->DrawLine( Point( aRect.Left()+1, aRect.Top()+1 ),
						   Point( aRect.Right(), aRect.Top()+1 ) );
		pOutWin->DrawLine( Point( aRect.Right(), aRect.Top()+1 ),
						   Point( aRect.Right(), aRect.Bottom() ) );
		pOutWin->DrawLine( Point( aRect.Right(), aRect.Bottom() ),
						   Point( aRect.Left()+1, aRect.Bottom() ) );
		pOutWin->DrawLine( Point( aRect.Left()+1, aRect.Bottom() ),
						   Point( aRect.Left()+1, aRect.Top()+1 ) );
	}
	else
	{
		Color aBlackColor( COL_BLACK );
		Pen   aBlackPen( aBlackColor );
		pOutWin->SetPen( aBlackPen );
		pOutWin->DrawRect( aRect );
	}

	aRect.Top()    = aBoundRect.Top();
	aRect.Bottom() = aRect.Top() + aTextSize.Height()-1;
	aRect.Left()  += 9;
	aRect.Right()  = min( aRect.Left() + aTextSize.Width()-1, aRect.Right() );

//!!!
//Zur Zeit immer SVLook
	if ( !TRUE )
	{
		aRect.Top()    += 3;
		aRect.Bottom() += 3;
	}

	aOldClip  = pOutWin->GetClipRegion();
	pOutWin->SetClipRegion( Region( (Rectangle)aRect ) );
	aOldBrush = pOutWin->GetFillInBrush();
	pOutWin->SetFillInBrush( pSVControl->GetBackgroundBrush() );
	Pen aNullPen( PEN_NULL );
	pOutWin->SetPen( aNullPen );
	pOutWin->DrawRect( aRect );
	pOutWin->DrawText( aRect.TopLeft(), pSVControl->GetText() );

	// Aufraeumen
	pOutWin->SetFont( aOldFont );
	pOutWin->SetPen( aOldPen );
	pOutWin->SetFillInBrush( aOldBrush );
	if( bOldClip )
		pOutWin->SetClipRegion( aOldClip );
	else
		pOutWin->SetClipRegion();
}



void VCImpRealEdit::Paint( OutputDevice* pOut )
{
	VCImpRealControl::Paint( pOut );
}

void VCImpRealComboBox::Paint( OutputDevice* pOut )
{
	VCImpRealControl::Paint( pOut );
}

void VCImpRealListBox::Paint( OutputDevice* pOut )
{
	VCImpRealControl::Paint( pOut );
}

void VCImpRealFixedText::Paint( OutputDevice* pOut )
{
	VCImpRealControl::Paint( pOut );
}

void VCImpRealSpinButton::Paint( OutputDevice* pOut )
{
	VCImpRealControl::Paint( pOut );
}

Size VCCheckBoxEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	Size aXSize( ImpGetButtonBmpSizePixel() );
	aXSize.Width() += 10; // abstand button text
	aXSize = pOut->PixelToLogic( aXSize );
	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); //GetFont(pOut) );
	Size aTextSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );
	aXSize.Width() += aTextSize.Width();
	if( aXSize.Height() < aTextSize.Height() )
		aXSize.Height() = aTextSize.Height();
	return aXSize;
}

Size VCRadioButtonEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	Size aXSize( ImpGetButtonBmpSizePixel() );
	aXSize.Width() += 10; // abstand button text
	aXSize = pOut->PixelToLogic( aXSize );
	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); //GetFont(pOut) );
	Size aTextSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );
	aXSize.Width() += aTextSize.Width();
	if( aXSize.Height() < aTextSize.Height() )
		aXSize.Height() = aTextSize.Height();
	return aXSize;
}

Size VCPushButtonEngine::GetOptSize( OutputDevice* pOut ) const
{
	DBG_ASSERT(pOut,"OutputDevice?");
	MapMode aMode (pOut->GetMapMode().GetMapUnit());
	Size a10Pixel = pOut -> LogicToLogic(Size(10,10),MAP_POINT,aMode);

	Font aTempFont( pOut->GetFont());
	pOut->SetFont( aFont ); // GetFont(pOut) );
	Size aButtonSize = pOut->GetTextSize( aCaption );
	pOut->SetFont( aTempFont );
	aButtonSize.Width() += 2*a10Pixel.Width();
	aButtonSize.Height() += a10Pixel.Height();
	return aButtonSize;
}

/**************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcidrawu.cxx,v 1.1.1.1 2000/09/29 11:02:40 mh Exp $

	  Source Code Control System - Update

	  $Log: vcidrawu.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:40  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:49  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.27  2000/08/04 09:20:53  tbe
	  #77247# GetAppWindow checked in by MM
	
	  Revision 1.26  1997/11/27 09:01:08  OV
	  #45803# GetTextRect fuer RadioButtons gerichtet
	

	  Rev 1.25   27 Nov 1997 10:01:08   OV
   #45803# GetTextRect fuer RadioButtons gerichtet

	  Rev 1.24   26 Nov 1997 15:35:20   OV
   #45632# DrawButtonBitmap: OutputDevice vollstaendig restaurieren

	  Rev 1.23   06 Nov 1997 12:46:00   OV
   VCL-Umstellungen

	  Rev 1.22   31 Oct 1997 17:14:26   OV
   VCL: Windows-Zeichenfunktionen auf allen Plattformen (364-inkompat); diverse VCL-Anpassungen

	  Rev 1.21   17 Oct 1997 17:08:26   OV
   #44746# GroupBox unter UNX gaengig gemacht

	  Rev 1.20   16 Oct 1997 15:05:46   OV
   #44714# Bugfix VCImpVirtGroupBox::GetTextRect

	  Rev 1.19   27 Sep 1997 18:48:26   MH
   chg: UNX VCL364

	  Rev 1.16   02 Jul 1997 14:06:24   OV
   #41064# OutputDevice auf Printer abfragen

	  Rev 1.15   04 Mar 1997 18:18:00   mda
   an ButtonEngines angepasst

	  Rev 1.14   12 Dec 1996 12:37:40   OV
   Umstellung auf Button-Engines

	  Rev 1.13   22 Nov 1996 10:58:58   mda
   svstdarr.hxx included

	  Rev 1.12   23 Oct 1996 07:43:18   eg
   SetBkBrush entfernt (loeste PaintEvents aus)

	  Rev 1.11   09 Aug 1996 08:05:56   mda
   sfxsh.hxx included

	  Rev 1.10   25 Jul 1996 19:06:28   OV
   Image-Buttons

	  Rev 1.9   07 Jun 1996 14:30:14   OV
   NEU: Print-Property

	  Rev 1.8   13 May 1996 14:58:02   mda
   Diverse Unix-Anpassungen
	  Revision 1.1  1996/05/11 12:36:36  mda
	  Initial revision

	  Revision 1.1  1996/05/11 10:02:33  mda
	  Initial revision


	  Rev 1.7   07 Mar 1996 16:49:22   OV
   NEU: GetOptSize u.a

	  Rev 1.6   22 Feb 1996 13:23:12   mda
   GCC

	  Rev 1.5   21 Dec 1995 14:38:14   eg
   neue Konzepte Sfx?

	  Rev 1.4   21 Dec 1995 13:59:12   eg
   Change/Set Umstellung

	  Rev 1.3   06 Nov 1995 18:11:06   TRI
   Change->Set

	  Rev 1.2   12 Oct 1995 12:18:00   MK
   Hacks gegen Abstuerze bei fehlerhaften ItemSets

	  Rev 1.1   31 Aug 1995 14:47:46   mk
   Gegen fehlende ItemSets abgesichert. (MDA)

	  Rev 1.0   11 Aug 1995 08:29:02   mk
   Initial revision.

	  Rev 1.8   03 May 1995 07:26:52   mda
   Kleine Verbesserungen

	  Rev 1.7   29 Mar 1995 11:14:12   mda
   Motif-Look von Checkbox, Groupbox, Togglebutton und Pushbutton

	  Rev 1.6   23 Mar 1995 09:11:18   mda
   weiter fuer UNIX implementiert

	  Rev 1.5   07 Mar 1995 15:19:46   mk
   Weitere Dummy-Implementationen (MDA)

	  Rev 1.4   21 Feb 1995 09:54:18   mk
   UNIX-Version aus OS/halbe gemacht (mda)

	  Rev 1.3   14 Feb 1995 22:11:32   CL
   Debug

	  Rev 1.2   13 Feb 1995 19:36:18   CL
   Lebende Controls

	  Rev 1.1   10 Feb 1995 17:01:58   CL
   Anpassung wg DlgEd

	  Rev 1.0   01 Feb 1995 12:22:28   CL
   Initial revision.

	  Rev 1.1   12 Jan 1995 09:51:10   CL
   SfxColorItem --> SvxColorItem

	  Rev 1.0   19 Dec 1994 15:35:52   CL
   Initial revision.

	  Rev 1.6   14 Dec 1994 14:07:56   CL
   Umstellung wg. StarDraw

	  Rev 1.5   06 Dec 1994 16:22:18   CL
   Erweitert

	  Rev 1.4   11 Nov 1994 17:46:52   CL
   Erweitert

	  Rev 1.3   08 Nov 1994 11:27:32   CL
   Erweitert

	  Rev 1.2   02 Nov 1994 17:56:00   CL
   temp

	  Rev 1.1   31 Oct 1994 12:40:58   CL
   Neue Controls

	  Rev 1.0   27 Oct 1994 09:09:08   CL
   Initial revision.

*************************************************************************/


#endif
