/*************************************************************************
 *
 *  $RCSfile: vcidraww.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef VCL
#define OEMRESOURCE
#include <svwin.h>
#include <sysdep.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SV_IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif
#pragma hdrstop

#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#include "vcrdbttn.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vctrls.hxx"
#include "vcictrls.hxx"
#include "vctrls.hrc"
#include "siresid.hxx"
#include "sidll.hxx"
#include "vcengin.hxx"
#include "vcengin2.hxx"


void VCImpRealGroupBox::Paint( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;
	GetDlgEdControl((Window*)pOut);
	Window* pOutWin = (Window*)pOut;
	const StyleSettings& rStyles = Application::GetSettings().GetStyleSettings();
	
	Font   aOldFont;
	Color  aOldLineColor;
	Color  aOldFillColor;
	BOOL   bOldClip = pOutWin->IsClipRegion();
	Region aOldClip;

	Font aFont( pDlgEdControl->GetFont() );
	Size aSize = aFont.GetSize();
	aSize = pOut->PixelToLogic( aSize );
	aFont.SetSize( aSize );
	aFont.SetTransparent( FALSE ); // fuer UNIX!

	if( TRUE )
	{
		Color a3DText( rStyles.GetWindowTextColor() );
		Color a3DFill( rStyles.GetFaceColor() );
		aFont.SetColor( a3DText );
		aFont.SetFillColor( a3DFill );
	}

	aFont.SetAlign( ALIGN_TOP );
	aOldFont = pOutWin->GetFont( );
	pOutWin->SetFont( aFont );

	Size aOfs = pOut->PixelToLogic( Size( 1, 1 ) );

	Rectangle aBoundRect( pShell->GetPos(), pShell->GetSize() );
	aBoundRect += pShell->GetDrawOfs();
	Rectangle aRect = aBoundRect;
	aRect = pOut->LogicToPixel( aRect, MapMode( MAP_TWIP ) );
	aRect = pOut->PixelToLogic( aRect, MapMode( pShell->GetOutUnit() ) );

	Size aTextSize( pOutWin->GetCtrlTextWidth( pDlgEdControl->GetText() ), pOutWin->GetTextHeight() );
	aRect.Top() += aTextSize.Height() >> 1;

	if ( TRUE )
	{
		Color aShadowColor( rStyles.GetShadowColor() );
		pOutWin->SetLineColor( aShadowColor );
		pOutWin->DrawLine( aRect.TopLeft(),
						   Point( aRect.Right()-aOfs.Width(), aRect.Top() ) );
		pOutWin->DrawLine( Point( aRect.Right()-aOfs.Width(), aRect.Top() ),
						   Point( aRect.Right()-aOfs.Width(),
								  aRect.Bottom()-aOfs.Height() ) );
		pOutWin->DrawLine( Point( aRect.Right()-aOfs.Width(),
								  aRect.Bottom()-aOfs.Height() ),
						   Point( aRect.Left(), aRect.Bottom()-aOfs.Height() ) );
		pOutWin->DrawLine( Point( aRect.Left(), aRect.Bottom()-aOfs.Height() ),
						   Point( aRect.Left(), aRect.Top() ) );

		Color aLightColor( rStyles.GetLightColor() );
		pOutWin->SetLineColor( aLightColor );
		pOutWin->DrawLine( Point( aRect.Left()+aOfs.Width(),
								  aRect.Top()+aOfs.Height() ),
						   Point( aRect.Right(), aRect.Top()+aOfs.Height() ) );
		pOutWin->DrawLine( Point( aRect.Right(), aRect.Top()+aOfs.Height() ),
						   Point( aRect.Right(), aRect.Bottom() ) );
		pOutWin->DrawLine( Point( aRect.Right(), aRect.Bottom() ),
						   Point( aRect.Left()+aOfs.Width(), aRect.Bottom() ) );
		pOutWin->DrawLine( Point( aRect.Left()+aOfs.Width(), aRect.Bottom() ),
						   Point( aRect.Left()+aOfs.Width(),
								  aRect.Top()+aOfs.Height() ) );
	}
	else
	{
		Color aBlackColor( COL_BLACK );
		pOutWin->SetLineColor( aBlackColor );
		pOutWin->DrawRect( aRect );
	}

	aRect.Top()    = aBoundRect.Top();
	aRect.Bottom() = aRect.Top() + aTextSize.Height()-aOfs.Height();
	aRect.Left()  += 9*aOfs.Width();
	aRect.Right()  = min( aRect.Left() + aTextSize.Width()-aOfs.Width(), aRect.Right() );

	if ( !TRUE )
	{
		aRect.Top()    += 3*aOfs.Height();
		aRect.Bottom() += 3*aOfs.Height();
	}

	aOldClip  = pOutWin->GetClipRegion( );
	pOutWin->SetClipRegion( Region( (Rectangle)aRect ) );

	if( TRUE )
	{
		Color aCol( rStyles.GetFaceColor() );
		aOldFillColor 	  = pOutWin->GetFillColor( );
		pOutWin->SetFillColor( aCol );
	}
	else
		aOldFillColor 		= pOutWin->GetFillColor();
		pOutWin->SetFillColor( pDlgEdControl->GetBackground().GetColor() );

	pOutWin->SetLineColor();
	pOutWin->DrawRect( aRect );
	BOOL bEnabled = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_ENABLED )).GetValue();

	Wallpaper aOldBack = pOutWin->GetBackground( );
	pOutWin->SetBackground( Wallpaper( pOutWin->GetFillColor() ) );

	USHORT nFlags = TEXT_DRAW_MNEMONIC;
	if( !bEnabled )
		nFlags |= TEXT_DRAW_DISABLE | TEXT_DRAW_MNEMONIC;
	else
		nFlags |= TEXT_DRAW_MNEMONIC;

	pOutWin->DrawCtrlText( aRect.TopLeft(), pDlgEdControl->GetText(),
						   0, STRING_LEN, nFlags );
	pOutWin->SetBackground( aOldBack );

	// Aufraeumen
	pOutWin->SetFont( aOldFont );
	pOutWin->SetLineColor( aOldLineColor );
	pOutWin->SetFillColor( aOldFillColor );
	if( bOldClip )
		pOutWin->SetClipRegion( aOldClip );
	else
		pOutWin->SetClipRegion();
}



