/*************************************************************************
 *
 *  $RCSfile: vciengm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef VCL

#include "vciengw.cxx"

#else

#include <solar.h>

#include <tools.hxx>
#include <sv.hxx>

#define _VCSPINENG_CXX
#define _VCSCROLLENG_CXX
#define _VCDDLBOX_CXX
#define _VCDDCBOXENG_CXX

#include "vcengin.hxx"

/*************************************************************************/

// Kommt aus VCIDRAWM.cxx

extern Color ImpHalfColor(const Color& rInColor);

/*************************************************************************
|*
|*    ImpGetPixelPen()
|*
|*    Beschreibung		Gibt zu einem gegebene Device eine ein Point breiten Pen
|*    Ersterstellung    KH 25.09.95
|*    Letzte Aenderung  KH 25.09.95
|*
*************************************************************************/
static Pen ImpGetPixelPen(OutputDevice* pOut, ColorName eColor = COL_BLACK)
{
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size 	aLogPix = pOut->LogicToLogic( Size( 1, 1 ) ,MapMode(MAP_POINT), aTmpMapMode );
	return 	Pen(eColor,aLogPix.Width());
}


/*************************************************************************
|*
|*    ImpSpinDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 16.05.95
|*    Letzte Aenderung  CL 16.05.95
|*
*************************************************************************/
void ImpSpinDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
					   const Brush& rBrush, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	MapMode aOldMap = pOut->GetMapMode();

	pOut->SetMapMode( MapMode() );
	pOut->SetClipRegion( Region( aPixRect ) );

	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen();
	Brush aOldBrush = pOut->GetFillInBrush();

	pOut->SetPen( aPen );
	pOut->SetFillInBrush( rBrush );

	if( bUp )
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()+aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()+aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()--; aPos2.Y()--;
		}
	}
	else
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()-aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()-aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()++; aPos2.Y()++;
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawUpButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 16.06.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/

void VCSpinButtonEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush();
	Pen     aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bUpIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawDnButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 16.06.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void VCSpinButtonEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush();
	Pen     aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bDnIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawSpinButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 16.06.95
|*    Letzte Aenderung  CL 16.06.95
|*
*************************************************************************/
void VCSpinButtonEngine::DrawSpinButton( OutputDevice* pOut )
{
	DrawUpButton( pOut );
	DrawDnButton( pOut );
}

/*************************************************************************
|*
|*    VCScrollBarEngine::GetOptWidth()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
long VCScrollBarEngine::GetOptWidth( OutputDevice* pOut, BOOL /* bHorz */)
{
	Size aSize(16,0);
	aSize = pOut->PixelToLogic( aSize, MapMode( pOut->GetMapMode().GetMapUnit()) );
	return aSize.Width();
}

/*************************************************************************
|*
|*    VCScrollBarEngine::DrawPgUpRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 15.06.95
|*    Letzte Aenderung  CL 15.06.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawPgUpRect( OutputDevice* pOut )
{
	Color aWhite( COL_WHITE );
	Color aBlack( COL_BLACK );
	Brush aBrush;
	if( bEnable )
	{
		aBrush.SetStyle( BRUSH_25 );
		aBrush.SetColor( aBlack );
	}
	else
		aBrush.SetColor(aWhite);

	Brush aOldBrush = pOut->GetFillInBrush();
	Pen   aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen(  Pen( PEN_NULL ) );

	pOut->DrawRect( aPgUpRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawPgDnRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 15.06.95
|*    Letzte Aenderung  CL 15.06.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawPgDnRect( OutputDevice* pOut )
{
	Color aWhite( COL_WHITE );
	Color aBlack( COL_BLACK );
	Brush aBrush;
	if( bEnable )
	{
		aBrush.SetStyle( BRUSH_25 );
		aBrush.SetColor( aBlack );
	}
	else
		aBrush.SetColor(aWhite);

	Brush aOldBrush = pOut->GetFillInBrush();
	Pen   aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgDnRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawBorder()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawBorder( OutputDevice* pOut )
{
	Pen 	aOldPen 	= pOut->GetPen();
	Brush   aOldBrush   = pOut->GetFillInBrush();

	pOut->SetPen( Pen() );
	pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

	pOut->DrawRect( Rectangle( aPos, aSize ) );

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawUpButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->LogicToLogic( Size( 2, 2 ), MAP_POINT,
		MapMode( pOut->GetMapMode().GetMapUnit() )  );

	Color	aWhite(COL_WHITE);
	Brush   aBrush(aWhite);
	Brush   aOldBrush = pOut->GetFillInBrush();
	Pen     aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush(aBrush);
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	// Eventuell clippen
	Rectangle aTempRect( aUpRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip    = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aUpRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	// Pfeile erzeugen
	Polygon aPoly(7);

	Size aSize2;	//	1/4
	aSize2.Width() = aInnerRect.GetSize().Width() >> 2;
	aSize2.Height()= aInnerRect.GetSize().Width() >> 2;

	Point aCenter = aInnerRect.Center();

	if (bHorz)
	{
		aPoly[0] = Point( aInnerRect.Left() , aInnerRect.Bottom() - aSize2.Height() );
		aPoly[1] = Point( aCenter.X() 		, aInnerRect.Bottom() - aSize2.Height() );
		aPoly[2] = Point( aCenter.X() 		, aInnerRect.Bottom() );
		aPoly[3] = Point( aInnerRect.Right(), aCenter.Y() );
		aPoly[4] = Point( aCenter.X() 		, aInnerRect.Top() );
		aPoly[5] = Point( aCenter.X() 		, aInnerRect.Top() + aSize2.Height() );
		aPoly[6] = Point( aInnerRect.Left() , aInnerRect.Top() + aSize2.Height() );
	}
	else
	{
		aPoly[0] = Point( aInnerRect.Left() + aSize2.Width(), aInnerRect.Top() );
		aPoly[1] = Point( aInnerRect.Left() + aSize2.Width(), aCenter.Y() );
		aPoly[2] = Point( aInnerRect.Left() , aCenter.Y() );
		aPoly[3] = Point( aCenter.X() , aInnerRect.Bottom() );
		aPoly[4] = Point( aInnerRect.Right() , aCenter.Y() );
		aPoly[5] = Point( aInnerRect.Right() - aSize2.Width() , aCenter.Y() );
		aPoly[6] = Point( aInnerRect.Right() - aSize2.Width() , aInnerRect.Top() );
	}

	if( bUpIn )
	{
		aBrush.SetColor(Color());
		pOut->SetFillInBrush( aBrush );
	}
	else
	{
		aBrush.SetColor(aWhite);
		pOut->SetFillInBrush( aBrush );
	}

	pOut->DrawPolygon( aPoly );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}

/*************************************************************************
|*
|*    VCScrollBarEngine::DrawDnButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->LogicToLogic( Size( 2, 2 ), MAP_POINT,
		MapMode( pOut->GetMapMode().GetMapUnit() )  );

	Color	aWhite(COL_WHITE);
	Brush   aBrush(aWhite);
	Brush   aOldBrush = pOut->GetFillInBrush();
	Pen     aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush(aBrush);
	pOut->SetPen( Pen() );

	Rectangle aInnerRect(aDnRect);

	// Eventuell clippen
	Rectangle aTempRect( aDnRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aDnRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	// Pfeile erzeugen
	Polygon aPoly(7);

	Size aSize2;	//	1/4
	aSize2.Width() = aInnerRect.GetSize().Width() >> 2;
	aSize2.Height()= aInnerRect.GetSize().Width() >> 2;

	Point aCenter = aInnerRect.Center();

	if (bHorz)
	{
		aPoly[0] = Point( aInnerRect.Right(), aInnerRect.Bottom() - aSize2.Height() );
		aPoly[1] = Point( aCenter.X() 		, aInnerRect.Bottom() - aSize2.Height() );
		aPoly[2] = Point( aCenter.X() 		, aInnerRect.Bottom() );
		aPoly[3] = Point( aInnerRect.Left() , aCenter.Y() );
		aPoly[4] = Point( aCenter.X() 		, aInnerRect.Top() );
		aPoly[5] = Point( aCenter.X() 		, aInnerRect.Top() + aSize2.Height() );
		aPoly[6] = Point( aInnerRect.Right(), aInnerRect.Top() + aSize2.Height() );
	}
	else
	{
		aPoly[0] = Point( aInnerRect.Left() + aSize2.Width(), aInnerRect.Bottom() );
		aPoly[1] = Point( aInnerRect.Left() + aSize2.Width(), aCenter.Y() );
		aPoly[2] = Point( aInnerRect.Left() , aCenter.Y() );
		aPoly[3] = Point( aCenter.X() , aInnerRect.Top() );
		aPoly[4] = Point( aInnerRect.Right() , aCenter.Y() );
		aPoly[5] = Point( aInnerRect.Right() - aSize2.Width() , aCenter.Y() );
		aPoly[6] = Point( aInnerRect.Right() - aSize2.Width() , aInnerRect.Bottom() );
	}

	if( bDnIn )
	{
		aBrush.SetColor(Color());
		pOut->SetFillInBrush( aBrush );
	}
	else
	{
		aBrush.SetColor(aWhite);
		pOut->SetFillInBrush( aBrush );
	}

	pOut->DrawPolygon( aPoly );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}

}


/*************************************************************************
|*
|*    VCScrollBarEngine::GetThumbRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 14.06.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
Rectangle VCScrollBarEngine::GetThumbRect( OutputDevice* pOut )
{
	if( !bEnable )
		return Rectangle();

	// Genug Platz ?
	long nFreeHeight;
	if( !bHorz )
		nFreeHeight = aUpRect.Top() - aDnRect.Bottom();
	else
		nFreeHeight = aUpRect.Left() - aDnRect.Right();

	if( ( !bHorz && (nFreeHeight < (aSize.Width()*2))) ||
		( bHorz && (nFreeHeight < (aSize.Height()*2)))    )
		return Rectangle();

	Point aMinPos;
	Point aMaxPos;
	if( !bHorz )
	{
		aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() );
		aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() );
	}
	else
	{
		aMinPos = Point( aDnRect.Right(), aDnRect.Top() );
		aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width(), aUpRect.Top() );
	}

	// Thumb Rectangle
	Rectangle aThumbRect( aMinPos, aUpRect.GetSize() );

	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size 	aLogPix = pOut->LogicToLogic( Size( 1, 1 ) ,MapMode(MAP_POINT), aTmpMapMode );
	// Eins kleiner, damit es nicht auf dem Rand liegt
	aThumbRect.Top() + aLogPix.Height();
	aThumbRect.Left() + aLogPix.Width();
	aThumbRect.Bottom() - aLogPix.Height();
	aThumbRect.Right() - aLogPix.Width();

	long nMaxPos = bHorz ? aMaxPos.X() : aMaxPos.Y();
	long nMinPos = bHorz ? aMinPos.X() : aMinPos.Y();
	long nActOfs=0;

	// Skalierung
	if( (nMax - nMin) != 0 )
		nActOfs = (nMaxPos-nMinPos)*(nAct-nMin) /
				  Abs(nMax - nMin );

	if( !bHorz )
		aThumbRect.Move( 0, nActOfs );
	else
		aThumbRect.Move( nActOfs, 0 );

	return aThumbRect;
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;

	if( bCalcThumb )
	{
		aThumbRect = GetThumbRect( pOut );
		aPgUpRect  = GetPgUpRect( pOut );
		aPgDnRect  = GetPgDnRect( pOut );
		bCalcThumb = FALSE;
	}

	DrawPgUpRect( pOut );
	DrawPgDnRect( pOut );

	// Umrandung malen
	Pen aOldPen = pOut->GetPen();
	Color	aWhite( COL_WHITE );
	Brush   aWhiteBrush( aWhite );
	Brush   aOldBrush = pOut->GetFillInBrush();

	pOut->SetPen( Pen() );
	pOut->SetFillInBrush( aWhiteBrush );

	pOut->DrawRect( aThumbRect );

	pOut->SetFillInBrush( aOldBrush );
	pOut->SetPen( aOldPen );
}


/*************************************************************************
|*
|*    VCScrollBarEngine::HideThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  KH 13.09.95
|*
*************************************************************************/
void VCScrollBarEngine::HideThumb( OutputDevice* pOut )
{
	// Sollte fuer MAC ueberfluessig sein ...
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawScrollBar()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawScrollBar( OutputDevice* pOut )
{
	DrawUpButton( pOut );
	DrawDnButton( pOut );
	DrawThumb( pOut );	// ruft DrawPgUpRect und DrawPgDnRect
}

/*************************************************************************
|*
|*    ImpDDComboDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    KH 06.10.95
|*    Letzte Aenderung  KH 06.10.95
|*
*************************************************************************/
/*
	******** Gibt es auf MAC nicht ********
		( ist hier damit man besser vergleichen kann)
void ImpDDComboDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
						  const Brush& rBrush )
{
}
*/

/*************************************************************************
|*
|*    ImpMacEngineDrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    KH 08.05.95
|*    Letzte Aenderung  KH 08.05.95
|*
*************************************************************************/
void ImpMacEngineDrawButton( OutputDevice* pOut ,BOOL bEnable, const Rectangle& rBtnRect )
{
	Rectangle aBtnRect = rBtnRect;

	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	MapMode aPointMode(MAP_POINT);
	Size aLogPix = pOut->LogicToLogic( Size( 1, 1 )		,aPointMode, aTmpMapMode );
	Size a4LogPix = pOut->LogicToLogic( Size( 4, 4 )	,aPointMode, aTmpMapMode );
	Size a18LogPix = pOut->LogicToLogic( Size( 18, 18 )	,aPointMode, aTmpMapMode );

	/*
	SfxItemSet* pLocalItemSet = pShell->GetItemSet();
	Color   aFColor( ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue() );
	*/
	Color   aFColor(COL_BLACK);

	if (!bEnable)
		aFColor = ImpHalfColor(aFColor);

	Pen 	aPixelPen(aFColor,aLogPix.Width());

	Brush   aBlackBrush(aFColor);
	Brush   aNullBrush(BRUSH_NULL);
	Brush   aOldBrush = pOut->GetFillInBrush();
	Pen     aOldPen   = pOut->GetPen();

	pOut->SetFillInBrush(aNullBrush);
	pOut->SetPen(aPixelPen);

	pOut -> DrawLine(rBtnRect.BottomLeft(),rBtnRect.BottomRight());
	pOut -> DrawLine(rBtnRect.BottomRight(),rBtnRect.TopRight());

	aBtnRect.Right() -= aLogPix.Width();
	aBtnRect.Bottom() -= aLogPix.Height();
	pOut -> DrawRect(aBtnRect);

	// Pfeil malen
	pOut->SetFillInBrush(aBlackBrush);

	Rectangle anArrowRect;

	anArrowRect.Left()   = rBtnRect.Right() - a18LogPix.Width();
	anArrowRect.Top()    = rBtnRect.Top()   + a4LogPix.Width();
	anArrowRect.Right()  = rBtnRect.Right() - 2 * a4LogPix.Width();
	anArrowRect.Bottom() = rBtnRect.Top()   + a18LogPix.Height() - a4LogPix.Height();

	Polygon aPoly(3);

	Point aCenter = anArrowRect.Center();

	aPoly[0] = anArrowRect.TopLeft();
	aPoly[1] = anArrowRect.TopRight();
	aPoly[2] = anArrowRect.Center();

	pOut->DrawPolygon( aPoly );

	pOut->SetPen(aOldPen);
	pOut->SetFillInBrush(aOldBrush);
}

/*************************************************************************
|*
|*    VCDDListBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 25.02.95
|*    Letzte Aenderung  KH 06.10.95
|*
*************************************************************************/
void VCDDListBoxEngine::DrawButton( OutputDevice* pOut )
{
	// Buttonrect ist ganzes Rechteck
	MapMode aTmpMapMode(pOut->GetMapMode().GetMapUnit());
	Size a19LogPix = pOut->LogicToLogic( Size( 0, 19 ),MAP_POINT, aTmpMapMode );
	Size aButtonSize = aSize;
	aButtonSize.Height() = a19LogPix.Height();

	Rectangle aButtonRect(aPos,aButtonSize);
	ImpMacEngineDrawButton(pOut,bEnabled,aButtonRect);
}

/*************************************************************************
|*
|*    VCDDComboBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 25.02.95
|*    Letzte Aenderung  KH 08.05.95
|*
*************************************************************************/
void VCDDComboBoxEngine::DrawButton( OutputDevice* pOut )
{
	ImpMacEngineDrawButton(pOut,bEnabled,aBtnRect);
}

#endif
