/*************************************************************************
 *
 *  $RCSfile: vciengo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef VCL
#include "vciengw.cxx"
#else

#include <si_pch.hxx>
#pragma hdrstop

#define _VCSPINENG_CXX
#define _VCSCROLLENG_CXX
#define _VCDDLBOX_CXX
#define _VCDDCBOXENG_CXX

#include <svwindow.hxx>
#include <vcengin.hxx>
#define GLOBALOVERFLOW
#include <segmentc.hxx>

SEG_EOFGLOBALS()


/*************************************************************************
|*
|*    ImpSpinDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 16.05.95
|*    Letzte Aenderung  CL 19.05.95
|*
*************************************************************************/
#pragma SEG_FUNCDEF(vciengo_12)

void ImpSpinDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
					   const Brush& rBrush, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect = aPixRect;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	if( bUp )
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()+aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()+aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()--; aPos2.Y()--;
		}
	}
	else
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()-aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()-aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()++; aPos2.Y()++;
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawUpButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 19.06.95
|*    Letzte Aenderung  CL 19.06.95
|*
*************************************************************************/
#pragma SEG_FUNCDEF(vciengo_01)

void VCSpinButtonEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bUpIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_02)



/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawDnButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 19.06.95
|*    Letzte Aenderung  CL 19.06.95
|*
*************************************************************************/
void VCSpinButtonEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bDnIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_03)



/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawSpinButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 19.06.95
|*    Letzte Aenderung  CL 19.06.95
|*
*************************************************************************/
void VCSpinButtonEngine::DrawSpinButton( OutputDevice* pOut )
{
	DrawUpButton( pOut );
	DrawDnButton( pOut );
}
#pragma SEG_FUNCDEF(vciengo_04)



/*************************************************************************
|*
|*    VCScrollBarEngine::GetOptWidth()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
long VCScrollBarEngine::GetOptWidth( OutputDevice* pOut, BOOL bHorz )
{
	Size aOptSize;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( !bHorz )
			aOptSize.Width() = WinQuerySysValue( HWND_DESKTOP, SV_CXVSCROLL ) - 1;
		else
			aOptSize.Width() = WinQuerySysValue( HWND_DESKTOP, SV_CYHSCROLL ) - 1;

		aOptSize = pOut->PixelToLogic( aOptSize,
						MapMode( pOut->GetMapMode().GetMapUnit() ) );
	}
	else
	{
		MapMode aMap1( MAP_10TH_MM );
		MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
		Size aSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
			aOptSize.Width() = 35*aSize.Width();
	}

	return aOptSize.Width();
}
#pragma SEG_FUNCDEF(vciengo_05)


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawPgUpRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 15.06.95
|*    Letzte Aenderung  CL 15.06.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawPgUpRect( OutputDevice* pOut )
{
	Brush aBrush;
	if( bEnable && bPgUpIn )
		aBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aBrush.SetColor( Color( COL_SCROLLBAR ) );

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgUpRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_06)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawPgDnRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 15.06.95
|*    Letzte Aenderung  CL 15.06.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawPgDnRect( OutputDevice* pOut )
{
	Brush aBrush;
	if( bEnable && bPgDnIn )
		aBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aBrush.SetColor( Color( COL_SCROLLBAR ) );

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgDnRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_07)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawBorder()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawBorder( OutputDevice* pOut )
{
	Color   aCol( COL_3DSHADOW );
	Pen		aPen( aCol );
	Pen 	aOldPen 	= pOut->GetPen( );
	pOut->SetPen( aPen );
	Brush   aOldBrush   = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

	Rectangle aRect( aPos, aSize );

	pOut->DrawRect( aRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_08)



/*************************************************************************
|*
|*    ImpScrollDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 03.03.95
|*    Letzte Aenderung  CL 03.03.95
|*
*************************************************************************/
void ImpScrollDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
						 const Brush& rBrush, BOOL bHorz, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize3;
	aSize3.Width() = aSize.Width() / 3;
	aSize3.Height()= aSize.Height() / 3;
	if( aSize3.Width() % 2 )
		aSize3.Width()++;
	if( aSize3.Height() % 2 )
		aSize3.Height()++;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect( aCenter.X() - aSize3.Width(), aCenter.Y() - aSize3.Height(),
						 aCenter.X() + aSize3.Width(), aCenter.Y() + aSize3.Height() );
	Size aTempSize4;
	aTempSize4.Width() = aTempRect.GetSize().Width() / 4;
	aTempSize4.Height()= aTempRect.GetSize().Height() / 4;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	if( bUp )
	{
		if( !bHorz )
		{
			Point aPos1( aTempRect.Left(), aTempRect.Center().Y() - aTempSize4.Height() );
			Point aPos2( aTempRect.Right(), aPos1.Y() );
			Point aPos3 = aTempRect.Center();
			aPos3.Y() += aTempSize4.Height();
			long nYEnd = aTempRect.Center().Y();
			while( aPos3.Y() >= nYEnd )
			{
				pOut->DrawLine( aPos1, aPos3 );
				pOut->DrawLine( aPos2, aPos3 );
				aPos1.X()++; aPos2.X()--;
				aPos3.Y()--;
			}
		}
		else
		{
			Point aPos1( aTempRect.Center().X() - aTempSize4.Width(), aTempRect.Top() );
			Point aPos2( aPos1.X(), aTempRect.Bottom() );
			Point aPos3 = aTempRect.Center();
			aPos3.X() += aTempSize4.Width();
			long nXEnd = aTempRect.Center().X();
			while( aPos3.X() >= nXEnd )
			{
				pOut->DrawLine( aPos1, aPos3 );
				pOut->DrawLine( aPos2, aPos3 );
				aPos1.Y()++; aPos2.Y()--;
				aPos3.X()--;
			}
		}
	}
	else
	{
		if( !bHorz )
		{
			Point aPos1( aTempRect.Left(), aTempRect.Center().Y() + aTempSize4.Height() );
			Point aPos2( aTempRect.Right(), aPos1.Y() );
			Point aPos3 = aCenter;
			aPos3.Y() -= aTempSize4.Height();
			long nYEnd = aTempRect.Center().Y();
			while( aPos3.Y() <= nYEnd )
			{
				pOut->DrawLine( aPos1, aPos3 );
				pOut->DrawLine( aPos2, aPos3 );
				aPos1.X()++; aPos2.X()--;
				aPos3.Y()++;
			}
		}
		else
		{
			Point aPos1( aTempRect.Center().X() + aTempSize4.Width(), aTempRect.Top() );
			Point aPos2( aPos1.X(), aTempRect.Bottom() );
			Point aPos3 = aTempRect.Center();
			aPos3.X() -= aTempSize4.Width();
			long nXEnd = aTempRect.Center().X();
			while( aPos3.X() <= nXEnd )
			{
				pOut->DrawLine( aPos1, aPos3 );
				pOut->DrawLine( aPos2, aPos3 );
				aPos1.Y()++; aPos2.Y()--;
				aPos3.X()++;
			}
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_09)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawUpButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	Pen 	aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetStyle( PEN_NULL );
	}

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );

	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	// Eventuell clippen
	Rectangle aTempRect( aUpRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip 	= FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aUpRect )
	{
		bClip 	 = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{	if( bUpIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpScrollDrawArrow( pOut, aInnerRect, aWhiteBrush, bHorz, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}
#pragma SEG_FUNCDEF(vciengo_0a)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawDnButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 15.06.95
|*    Letzte Aenderung  CL 15.06.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	Pen		aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetStyle( PEN_NULL );
	}

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	// Eventuell clippen
	Rectangle aTempRect( aDnRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip    = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aDnRect )
	{
		bClip	 = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bDnIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpScrollDrawArrow( pOut, aInnerRect, aWhiteBrush, bHorz, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}
#pragma SEG_FUNCDEF(vciengo_0b)



/*************************************************************************
|*
|*    VCScrollBarEngine::GetThumbRect()
|*
|*    Beschreibung
|*    Ersterstellung    CL 14.06.95
|*    Letzte Aenderung  CL 14.06.95
|*
*************************************************************************/
Rectangle VCScrollBarEngine::GetThumbRect( OutputDevice* pOut )
{
	if( !bEnable )
		return Rectangle();

	// Genug Platz ?
	long nFreeHeight;
	if( !bHorz )
		nFreeHeight = aUpRect.Top() - aDnRect.Bottom();
	else
		nFreeHeight = aUpRect.Left() - aDnRect.Right();

	if( ( !bHorz && (nFreeHeight < (aSize.Width()*2))) ||
		( bHorz && (nFreeHeight < (aSize.Height()*2)))    )
		return Rectangle();

	Point aMinPos;
	Point aMaxPos;
	Size aPixSize = pOut->PixelToLogic( Size( 1, 1 ) );
	if( !bHorz )
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() + aPixSize.Height() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() - aPixSize.Height() );
		}
		else
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() );
		}
	}
	else
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Right() + aPixSize.Width(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width() - aPixSize.Width(), aUpRect.Top() );
		}
		else
		{
			aMinPos = Point( aDnRect.Right(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width(), aUpRect.Top() );
		}
	}


	// Thumb Rectangle
	Rectangle aThumbRect( aMinPos, aUpRect.GetSize() );
	long nMaxPos = bHorz ? aMaxPos.X() : aMaxPos.Y();
	long nMinPos = bHorz ? aMinPos.X() : aMinPos.Y();
	long nActOfs=0;


	// Skalierung
	if( (nMax - nMin) != 0 )
		nActOfs = (nMaxPos-nMinPos)*(nAct-nMin) /
				  Abs(nMax - nMin );

	if( !bHorz )
		aThumbRect.Move( 0, nActOfs );
	else
		aThumbRect.Move( nActOfs, 0 );

	return aThumbRect;
}
#pragma SEG_FUNCDEF(vciengo_0c)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;

	if( bCalcThumb )
	{
		aThumbRect = GetThumbRect( pOut );
		aPgUpRect  = GetPgUpRect( pOut );
		aPgDnRect  = GetPgDnRect( pOut );
		bCalcThumb = FALSE;
	}

	// Umrandung malen
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );
	Brush   aBrush;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	pOut->DrawRect( aThumbRect );

	// Innenleben malen
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
		Rectangle aThRect = aThumbRect;

		if( !bHorz )
		{
			aThRect.Left()  += aLogPix.Width();
			aThRect.Right() -= aLogPix.Width();
		}
		else
		{
			aThRect.Top()   += aLogPix.Height();
			aThRect.Bottom()-= aLogPix.Height();
		}

		Pen     aOldPen   = pOut->GetPen( );
		pOut->SetPen( Pen( PEN_NULL ) );
		Brush   aBrush;
		aBrush.SetColor( Color( COL_3DFACE ) );
		Brush  aOldBrush = pOut->GetFillInBrush( );
		pOut->SetFillInBrush( aBrush );

		pOut->DrawRect( aThRect );

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aThRect.TopLeft(), aThRect.TopRight() );
		pOut->DrawLine( aThRect.TopLeft(), aThRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aThRect.BottomRight(), aThRect.BottomLeft() );
		pOut->DrawLine( aThRect.BottomRight(), aThRect.TopRight() );
	}

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_0d)



/*************************************************************************
|*
|*    VCScrollBarEngine::HideThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::HideThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;

	if( bCalcThumb )
	{
		aThumbRect = GetThumbRect( pOut );
		aPgUpRect  = GetPgUpRect( pOut );
		aPgDnRect  = GetPgDnRect( pOut );
		bCalcThumb = FALSE;
	}

	// Innenleben loeschen
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	Rectangle aThRect = aThumbRect;
	if( !bHorz )
	{
		aThRect.Left()  += aLogPix.Width();
		aThRect.Right() -= aLogPix.Width();
	}
	else
	{
		aThRect.Top()   += aLogPix.Height();
		aThRect.Bottom()-= aLogPix.Height();
	}

	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	Brush aBrush;
	aBrush.SetColor( Color( COL_SCROLLBAR ) );
	pOut->SetFillInBrush( aBrush );

	pOut->DrawRect( aThRect );

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( aOldPen );
}
#pragma SEG_FUNCDEF(vciengo_0e)



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawScrollBar()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawScrollBar( OutputDevice* pOut )
{
	if( !aSize.Width()  || !aSize.Height() )
		return;

	if( !bEnable )
	{
		Color   aCol( COL_SCROLLBAR );
		Pen		aPen( PEN_NULL );
		Pen 	aOldPen 	= pOut->GetPen( );
		pOut->SetPen( Pen( PEN_NULL ) );
		Brush   aOldBrush   = pOut->GetFillInBrush( );
		pOut->SetFillInBrush( Brush( aCol ) );

		Rectangle aRect( aPos, aSize );
		pOut->DrawRect( aRect );

		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
	}

	DrawUpButton( pOut );
	DrawDnButton( pOut );
	DrawThumb( pOut );
	DrawPgUpRect( pOut );
	DrawPgDnRect( pOut );
}
#pragma SEG_FUNCDEF(vciengo_0f)



/*************************************************************************
|*
|*    ImpDDComboDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 04.03.95
|*    Letzte Aenderung  CL 04.03.95
|*
*************************************************************************/
void ImpDDComboDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
						  const Brush& rBrush )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();

	aSize.Height() = aSize.Width();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect = aPixRect;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	Point aPos1( aCenter.X()-aSize3.Width()-aSize4.Width(),
				 aCenter.Y()-aSize3.Height()-aSize4.Height() );
	Point aPos2( aCenter.X()+aSize3.Width()+aSize4.Width(),
				 aCenter.Y()-aSize3.Height()-aSize4.Height() );
	Point aPos3 = aCenter;
	long nYEnd = aPos3.Y() - aSize4.Height();
	while( aPos3.Y() >= nYEnd )
	{
		pOut->DrawLine( aPos1, aPos3 );
		pOut->DrawLine( aPos2, aPos3 );
		aPos1.X()++; aPos2.X()--;
		aPos3.Y()--;
	}

	aPos1.X() = aCenter.X()-aSize3.Width()-aSize4.Width()+1;
	aPos1.Y() = aCenter.Y() + aSize4.Height()+1;
	aPos2.X() = aCenter.X()+aSize3.Width()+aSize4.Width()-1;
	aPos2.Y() = aPos1.Y();

	pOut->DrawLine( aPos1, aPos2 );

	aPos1.Y() += aSize3.Height();
	aPos2.Y() += aSize3.Height();
	pOut->DrawLine( aPos1, aPos2 );

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_10)



/*************************************************************************
|*
|*    VCDDListBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 02.03.95
|*    Letzte Aenderung  CL 02.03.95
|*
*************************************************************************/
void VCDDListBoxEngine::DrawButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	Pen		aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetColor( Color( COL_3DSHADOW ) );
	}
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );

	Rectangle aInnerRect = aBtnRect;
	pOut->DrawRect( aInnerRect );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bBtnIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.BottomLeft() );
			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	aInnerRect.Left()  += aLogPix.Width()*2;
	aInnerRect.Top()   += aLogPix.Height()*2;
	aInnerRect.Right() -= aLogPix.Width()*2;
	aInnerRect.Bottom()-= aLogPix.Height()*2;

	aBrush.SetColor( Color() );

	if( bBtnIn && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpDDComboDrawArrow( pOut, aInnerRect, aBrush );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_11)



/*************************************************************************
|*
|*    VCDDComboBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 28.02.95
|*    Letzte Aenderung  CL 28.02.95
|*
*************************************************************************/
void VCDDComboBoxEngine::DrawButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	Pen     aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetColor( Color( COL_3DSHADOW ) );
	}

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );

	Rectangle aInnerRect = aBtnRect;
	pOut->DrawRect( aInnerRect );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bBtnIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.BottomLeft() );
			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.TopRight() );

			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.BottomLeft() );
			pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	aInnerRect.Left()  += aLogPix.Width()*2;
	aInnerRect.Top()   += aLogPix.Height()*2;
	aInnerRect.Right() -= aLogPix.Width()*2;
	aInnerRect.Bottom()-= aLogPix.Height()*2;

	aBrush.SetColor( Color() );

	if( bBtnIn && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpDDComboDrawArrow( pOut, aInnerRect, aBrush );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#pragma SEG_EOFMODULE

#endif
