/*************************************************************************
 *
 *  $RCSfile: vciengu.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef VCL

#include "vciengw.cxx"

#else



#define OEMRESOURCE
#include <solar.h>
#include <sysdep.hxx>

#include <tools.hxx>
#include <sv.hxx>

#define _VCSPINENG_CXX
#define _VCSCROLLENG_CXX
#define _VCDDLBOX_CXX
#define _VCDDCBOXENG_CXX

#include "vcengin.hxx"


#define MTF_SCROLLBAR_WIDTH 15

/*************************************************************************
|*
|*    VCScrollBarEngine::GetOptWidth()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
long VCScrollBarEngine::GetOptWidth( OutputDevice* pOut, BOOL )
{
	Size aSize;
	aSize.Width() = MTF_SCROLLBAR_WIDTH; // width of a motif scrollbar

	aSize = pOut->PixelToLogic( aSize,
				MapMode( pOut->GetMapMode().GetMapUnit() ) );

	return aSize.Width();
}



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawBorder()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  MDA 11.05.96
|*
*************************************************************************/
void VCScrollBarEngine::DrawBorder( OutputDevice* pOut )
{
	Pen aOldPen = pOut->GetPen();

	Color a3DShadowColor( COL_BLACK );
	Color a3DLightColor( COL_BLACK );
	Pen a3DShadowPen2( a3DShadowColor, 1 );
	Pen a3DLightPen2( a3DLightColor, 1 );

	pOut->SetPen( a3DShadowPen2 );
	// oberer Rand
	pOut->DrawLine( aPos, Point( aPos.X()+aSize.Width(), aPos.Y() ) );
	// linker Rand
	pOut->DrawLine( aPos, Point( aPos.X(), aPos.Y()+aSize.Height() ) );

	// unter Rand
	pOut->DrawLine( Point( aPos.X(), aPos.Y()+aSize.Height() ),
					Point( aPos.X()+aSize.Width(), aPos.Y()+aSize.Height() ) );
	// rechter Rand
	pOut->DrawLine( Point( aPos.X()+aSize.Width(), aPos.Y()+aSize.Height() ),
					Point( aPos.X()+aSize.Width(), aPos.Y() ) );

	pOut->SetPen( aOldPen );
}


/*************************************************************************
|*
|*    ImpScrollDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 03.03.95
|*    Letzte Aenderung  MDA 17.03.95
|*
*************************************************************************/
void ImpScrollDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
						 const Brush& rBrush, BOOL bHorz, BOOL bUp, BOOL bIn )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Brush aOldBrush = pOut->GetFillInBrush( );
	Pen aOldPen = pOut->GetPen();

	Color a3DFaceColor( COL_3DFACE );
	Color a3DScrollBarColor( COL_SCROLLBAR );

	Brush aFaceBrush( a3DFaceColor );
	Brush aScrollBrush( a3DScrollBarColor );

	pOut->SetFillInBrush( aScrollBrush );
	pOut->DrawRect( aPixRect );

#define ARROW_SPACE	2

	Rectangle aPaintRect( aPixRect.Left()+ARROW_SPACE, aPixRect.Top()+ARROW_SPACE,
						  aPixRect.Right()-ARROW_SPACE, aPixRect.Bottom()-ARROW_SPACE );
	Point	  aCenter  = aPaintRect.Center();

	Point aTriArray[3];
	Polygon aTriPoly( 3 );
	BOOL bMoreLight = FALSE;

	if( bUp )
	{
		if( !bHorz )
		{
			// Pfeil nach unten
			aTriArray[1] = Point( aPaintRect.Left(), aPaintRect.Top()+1 );
			aTriArray[2] = Point( aPaintRect.Right(), aPaintRect.Top()+1 );
			aTriArray[0] = Point( aCenter.X(), aPaintRect.Bottom()+1 );
			bMoreLight = TRUE;
		}
		else
		{
			// Pfeil nach rechts
			aTriArray[0] = Point( aPaintRect.Right(), aCenter.Y() );
			aTriArray[2] = aPaintRect.BottomLeft();
			aTriArray[1] = aPaintRect.TopLeft();
			bMoreLight = TRUE;
		}
	}
	else
	{
		if( !bHorz )
		{
			// Pfeil nach oben
			aTriArray[0] = Point( aCenter.X(), aPaintRect.Top() );
			aTriArray[2] = aPaintRect.BottomLeft();
			aTriArray[1] = aPaintRect.BottomRight();
			bMoreLight = FALSE;
		}
		else
		{
			// Pfeil nach links
			aTriArray[0] = Point( aPaintRect.Left(), aCenter.Y() );
			aTriArray[2] = aPaintRect.TopRight();
			aTriArray[1] = aPaintRect.BottomRight();
			bMoreLight = FALSE;
		}
	}

	for( int n = 0; n < 3; n++ )
		aTriPoly.SetPoint( aTriArray[n], n );

	Color a3DLightColor( COL_3DLIGHT );
	Color a3DShadowColor( COL_3DSHADOW );
	Pen a3DFacePen( a3DFaceColor );
	Pen a3DShadowPen2( a3DShadowColor, 2 );
	Pen a3DLightPen2( a3DLightColor, 2 );

	pOut->SetPen( a3DFacePen );
	pOut->SetFillInBrush( aFaceBrush );
	pOut->DrawPolygon( aTriPoly );

	if( bMoreLight )
	{
		if( bIn )
			pOut->SetPen( a3DShadowPen2 );
		else
			pOut->SetPen( a3DLightPen2 );
	}
	else
	{
		if( bIn )
			pOut->SetPen( a3DLightPen2 );
		else
			pOut->SetPen( a3DShadowPen2 );
	}

	pOut->DrawLine( aTriArray[0], aTriArray[1] );
	pOut->DrawLine( aTriArray[1], aTriArray[2] );

	if( bMoreLight )
	{
		if( bIn )
			pOut->SetPen( a3DLightPen2 );
		else
			pOut->SetPen( a3DShadowPen2 );
	}
	else
	{
		if( bIn )
			pOut->SetPen( a3DShadowPen2 );
		else
			pOut->SetPen( a3DLightPen2 );
	}
	pOut->DrawLine( aTriArray[0], aTriArray[2] );


	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

void VCScrollBarEngine::DrawPgDnRect( OutputDevice* pOut )
{
	Brush aBrush;
#ifdef VCL
		const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
#endif

	if( bEnable && bPgDnIn )
	{
#ifdef VCL
		aBrush.SetColor( rSettings.GetShadowColor() );
#else
		aBrush.SetColor( Color( COL_3DSHADOW ) );
#endif
	}
	else
	{
#ifdef VCL
		aBrush.SetColor( rSettings.GetCheckedColor() );
#else
		aBrush.SetColor( Color( COL_SCROLLBAR ) );
#endif
	}

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgDnRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

void VCScrollBarEngine::DrawPgUpRect( OutputDevice* pOut )
{
	Brush aBrush;
#ifdef VCL
		const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
#endif

	if( bEnable && bPgUpIn )
	{
#ifdef VCL
		aBrush.SetColor( rSettings.GetShadowColor() );
#else
		aBrush.SetColor( Color( COL_3DSHADOW ) );
#endif
	}
	else
	{
#ifdef VCL
		aBrush.SetColor( rSettings.GetCheckedColor() );
#else
		aBrush.SetColor( Color( COL_SCROLLBAR ) );
#endif
	}

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgUpRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

Rectangle VCScrollBarEngine::GetThumbRect( OutputDevice* pOut )
{
	if( !bEnable )
		return Rectangle();

	// Genug Platz ?
	long nFreeHeight;
	if( !bHorz )
		nFreeHeight = aUpRect.Top() - aDnRect.Bottom();
	else
		nFreeHeight = aUpRect.Left() - aDnRect.Right();

	if( ( !bHorz && (nFreeHeight < (aSize.Width()*2))) ||
		( bHorz && (nFreeHeight < (aSize.Height()*2)))    )
		return Rectangle();

	Point aMinPos;
	Point aMaxPos;
	Size aPixSize = pOut->PixelToLogic( Size( 1, 1 ) );
	if( !bHorz )
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() + aPixSize.Height() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() - aPixSize.Height() );
		}
		else
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() );
		}
	}
	else
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Right() + aPixSize.Width(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width() - aPixSize.Width(), aUpRect.Top() );
		}
		else
		{
			aMinPos = Point( aDnRect.Right(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width(), aUpRect.Top() );
		}
	}


	// Thumb Rectangle
	Rectangle aThumbRect( aMinPos, aUpRect.GetSize() );
	long nMaxPos = bHorz ? aMaxPos.X() : aMaxPos.Y();
	long nMinPos = bHorz ? aMinPos.X() : aMinPos.Y();
	long nActOfs=0;


	// Skalierung
	if( (nMax - nMin) != 0 )
		nActOfs = (nMaxPos-nMinPos)*(nAct-nMin) /
		Abs(nMax - nMin );

	if( !bHorz )
		aThumbRect.Move( 0, nActOfs );
	else
		aThumbRect.Move( nActOfs, 0 );

	return aThumbRect;
}

void VCScrollBarEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	// Eventuell clippen
	Rectangle aTempRect( aDnRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip    = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aDnRect )
	{
		bClip	 = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	Brush   aBrush;
	Pen		aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetStyle( PEN_NULL );
	}

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );
	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, FALSE, bDnIn );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}


void VCScrollBarEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	Pen 	aPen;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		aBrush.SetColor( Color( COL_3DFACE ) );
		aPen.SetStyle( PEN_NULL );
	}

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );

	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aPen );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	// Eventuell clippen
	Rectangle aTempRect( aUpRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip 	= FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aUpRect )
	{
		bClip 	 = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, TRUE, bUpIn );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}



/*************************************************************************
|*
|*    VCScrollBarEngine::DrawThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;


	// Genug Platz ?
	long nFreeHeight = aDnRect.Top() - aUpRect.Bottom();

	if( nFreeHeight < (aSize.Width()*2) )
		return;

	Rectangle aRect( aUpRect.BottomLeft(),
					 aDnRect.TopRight() );

	// Thumb Rectangle
	Rectangle aThumbRect = aUpRect;
	aThumbRect.Move( 0, aUpRect.GetSize().Height()-1 );

//!!! Hier wird nMin immer als 0 angenommen
	long nOfs = 0;

	if( nMax )
	{
		Fraction aRange( nFreeHeight - aSize.Width(), 1 );
		Fraction aScale( nAct, nMax );

		nOfs = (long)(aRange * aScale);
	}

	aThumbRect.Move( 0, nOfs );

#ifdef VCL
	DecorationView aDecoView( pOut );
	aDecoView.DrawButton( aThumbRect, BUTTON_DRAW_NOLIGHTBORDER );
#else


	// Umrandung malen
	static Pen aDefPen;
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( aDefPen );
	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	pOut->DrawRect( aThumbRect );

	// Innenleben malen
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	aThumbRect.Left()  += aLogPix.Width();
	aThumbRect.Top()   += aLogPix.Height();
	aThumbRect.Right() -= aLogPix.Width();
	aThumbRect.Bottom()-= aLogPix.Height();

	Color a3DLightColor( COL_3DLIGHT );
	Color a3DShadowColor( COL_3DSHADOW );
	Pen a3DLightPen( a3DLightColor );
	Pen a3DShadowPen( a3DShadowColor );

	pOut->SetPen( a3DLightPen );
	pOut->DrawLine( aThumbRect.TopLeft(), aThumbRect.TopRight() );
	pOut->DrawLine( aThumbRect.TopLeft(), aThumbRect.BottomLeft() );

	pOut->SetPen( a3DShadowPen);
	pOut->DrawLine( aThumbRect.BottomRight(), aThumbRect.BottomLeft() );
	pOut->DrawLine( aThumbRect.BottomRight(), aThumbRect.TopRight() );

	aRect.Right()  -= aLogPix.Width();
	aRect.Bottom() -= aLogPix.Height();

	pOut->DrawLine( aThumbRect.BottomRight(), aThumbRect.BottomLeft() );
	pOut->DrawLine( aThumbRect.BottomRight(), aThumbRect.TopRight() );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

#endif

}


/*************************************************************************
|*
|*    VCScrollBarEngine::HideThumb()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::HideThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;

	// Genug Platz ?
	long nFreeHeight = aDnRect.Top() - aUpRect.Bottom();

	if( nFreeHeight < (aSize.Width()*2) )
		return;

	Rectangle aRect( aUpRect.BottomLeft(),
					 aDnRect.TopRight() );

	// Thumb Rectangle
	Rectangle aThumbRect = aUpRect;
	aThumbRect.Move( 0, aUpRect.GetSize().Height()-1 );

//!!! Hier wird nMin immer als 0 angenommen
	long nOfs = 0;

	if( nMax )
	{
		Fraction aRange( nFreeHeight - aSize.Width(), 1 );
		Fraction aScale( nAct, nMax );

		nOfs = (long)(aRange * aScale);
	}

	aThumbRect.Move( 0, nOfs );

	// Innenleben loeschen
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	aThumbRect.Left()  += aLogPix.Width();
	if( aThumbRect.Top() == aUpRect.Bottom() )
		aThumbRect.Top()   += aLogPix.Height();
	aThumbRect.Right() -= aLogPix.Width();
	if( aThumbRect.Bottom() == aDnRect.Top() )
		aThumbRect.Bottom()-= aLogPix.Height();

	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );
	Brush aBrush;
	aBrush.SetColor( Color( COL_SCROLLBAR ) );
	pOut->SetFillInBrush( aBrush );

	pOut->DrawRect( aThumbRect );

	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( aOldPen );
}


/*************************************************************************
|*
|*    VCScrollBarEngine::DrawScrollBar()
|*
|*    Beschreibung
|*    Ersterstellung    CL 24.02.95
|*    Letzte Aenderung  CL 24.02.95
|*
*************************************************************************/
void VCScrollBarEngine::DrawScrollBar( OutputDevice* pOut )
{
	Pen		aPen( PEN_NULL );
	Pen 	aOldPen 	= pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );
	Brush   aOldBrush   = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( Brush( Color( COL_SCROLLBAR ) ) );

	Rectangle aRect( aPos, aSize );
	pOut->DrawRect( aRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	DrawUpButton( pOut );
	DrawDnButton( pOut );
	DrawThumb( pOut );
	DrawPgUpRect( pOut );
	DrawPgDnRect( pOut );
}


/*************************************************************************
|*
|*    ImpDDComboDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    CL 04.03.95
|*    Letzte Aenderung  MDA 17.03.95
|*
*************************************************************************/
void ImpDDComboDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
			  const Brush& rBrush )
{
  Rectangle	aPixRect = rRect;
//  Point		aCenter  = aPixRect.Center();
  Size      	aSize    = aPixRect.GetSize();

  aSize.Height() = aSize.Width();

  Brush aOldBrush = pOut->GetFillInBrush( );

  Size aSize1 = pOut->PixelToLogic( Size( 1, 1 ) );
  Size aSize2 = pOut->PixelToLogic( Size( 2, 2 ) );

  Pen aOldPen = pOut->GetPen( );

  USHORT nWidth2 = aSize.Width() >> 1;

  Color a3DShadowColor( COL_3DSHADOW );
  Color a3DLightColor( COL_3DLIGHT );
  Pen a3DShadowPen2( a3DShadowColor, 2 );
  Pen a3DLightPen2( a3DLightColor, 2 );

  // Waagerechte Line unten
  pOut->SetPen( a3DShadowPen2 );
  pOut->DrawLine( Point( aPixRect.Left()+aSize1.Width(), aPixRect.Top()+aSize.Height() ),
				  Point( aPixRect.Left()+aSize.Width()-aSize1.Width(),
						 aPixRect.Top()+aSize.Height() ) );
  pOut->SetPen( a3DLightPen2 );
  pOut->DrawLine( Point( aPixRect.Left(), aPixRect.Top()+aSize.Height()-aSize1.Height() ),
				  Point( aPixRect.Left()+aSize.Width()-aSize2.Width(),
						 aPixRect.Top()+aSize.Height()-aSize1.Height() ) );

  // Triangle
  const USHORT nTriPoints = 3;
  Point aTriPtAry[] = { aPixRect.TopLeft(), // oben links
						Point( aPixRect.Left()+aSize.Width()-aSize1.Width(), aPixRect.Top() ), // oben rechts
						Point( aPixRect.Left()+nWidth2, aPixRect.Top()+aSize.Height()
														-aSize2.Height() ) // unten mitte
						};
  const Polygon aTriPolygon( nTriPoints, aTriPtAry );

  // draw inside of triangle
  Color a3DFaceColor( COL_3DFACE );
  Brush aBrush( a3DFaceColor );
  pOut->SetFillInBrush( aBrush );
  pOut->DrawPolygon( aTriPolygon );

  // draw triangle anti-shadow
  pOut->SetPen( a3DLightPen2 );
  pOut->DrawLine( aTriPtAry[0], aTriPtAry[1] );
  pOut->DrawLine( aTriPtAry[0], aTriPtAry[2] );
  // draw triangle shadow
  pOut->SetPen( a3DShadowPen2 );
  pOut->DrawLine( aTriPtAry[1], aTriPtAry[2] );

  pOut->SetPen( aOldPen );
  pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    VCDDListBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 02.03.95
|*    Letzte Aenderung  MDA 17.03.95
|*
*************************************************************************/
void VCDDListBoxEngine::DrawButton( OutputDevice *pOut )
{
  Size aLogPix = pOut->PixelToLogic( Size(1, 1) );

  Brush aBrush;
  aBrush.SetColor( Color( COL_3DFACE ) );
  Brush aOldBrush = pOut->GetFillInBrush( );
  pOut->SetFillInBrush( aBrush );

  Pen   aOldPen = pOut->GetPen( );

  Color a3DShadowColor( COL_3DSHADOW );
  Color a3DLightColor( COL_3DLIGHT );
  Pen a3DShadowPen( a3DShadowColor );
  Pen a3DLightPen( a3DLightColor );

  pOut->SetPen( a3DShadowPen );

  Rectangle aInnerRect = aBtnRect;

  pOut->DrawRect( aInnerRect );

  aInnerRect.Left()   += aLogPix.Width();
  aInnerRect.Top()    += aLogPix.Height();
  aInnerRect.Right()  -= aLogPix.Width();
  aInnerRect.Bottom() -= aLogPix.Height();

  pOut->DrawRect( aInnerRect );

  if( bBtnIn )
	{
	  pOut->SetPen( a3DShadowPen );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
  else
	{
	  pOut->SetPen( a3DLightPen );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );

	  pOut->SetPen( a3DShadowPen );
	  pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.BottomLeft() );
	  pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.TopRight() );
	}

  // Pfeile erzeugen
  aInnerRect.Left()   += aLogPix.Width()*2;
  aInnerRect.Top()    += aLogPix.Height()*2;
  aInnerRect.Right()  -= aLogPix.Width()*2;
  aInnerRect.Bottom() -= aLogPix.Height()*2;

  aBrush.SetColor( Color() );

  if( bBtnIn )
	aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );

  ImpDDComboDrawArrow( pOut, aInnerRect, aBrush );

  pOut->SetPen( aOldPen );
  pOut->SetFillInBrush( aOldBrush );
}

/*************************************************************************
|*
|*    VCDDComboBoxEngine::DrawButton()
|*
|*    Beschreibung
|*    Ersterstellung    CL 28.02.95
|*    Letzte Aenderung  MDA 17.03.95
|*
*************************************************************************/
void VCDDComboBoxEngine::DrawButton( OutputDevice* pOut )
{
  Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

  Brush   aBrush;
  aBrush.SetColor( Color( COL_3DFACE ) );
  Brush   aOldBrush = pOut->GetFillInBrush( );
  pOut->SetFillInBrush( aBrush );

  Pen     aOldPen = pOut->GetPen( );

  Color a3DShadowColor( COL_3DSHADOW );
  Color a3DLightColor( COL_3DLIGHT );
  Pen a3DShadowPen( a3DShadowColor );
  Pen a3DLightPen( a3DLightColor );

  pOut->SetPen( a3DShadowPen );

  Rectangle aInnerRect = aBtnRect;

  pOut->DrawRect( aInnerRect );

  aInnerRect.Left()   += aLogPix.Width();
  aInnerRect.Top()    += aLogPix.Height();
  aInnerRect.Right()  -= aLogPix.Width();
  aInnerRect.Bottom() -= aLogPix.Height();

  if( bBtnIn )
	{
	  pOut->SetPen( a3DShadowPen );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
  else
	{
	  pOut->SetPen( a3DLightPen );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
	  pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );

	  pOut->SetPen( a3DShadowPen );
	  pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.BottomLeft() );
	  pOut->DrawLine( aInnerRect.BottomRight(), aInnerRect.TopRight() );

	}

  // Pfeile erzeugen
  aInnerRect.Left()   += aLogPix.Width()*2;
  aInnerRect.Top()    += aLogPix.Height()*2;
  aInnerRect.Right()  -= aLogPix.Width()*2;
  aInnerRect.Bottom() -= aLogPix.Height()*2;

  aBrush.SetColor( Color() );

  if( bBtnIn )
	aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
  ImpDDComboDrawArrow( pOut, aInnerRect, aBrush );

  pOut->SetPen( aOldPen );
  pOut->SetFillInBrush( aOldBrush );
}


/*************************************************************************
|*
|*    ImpSpinDrawArrow()
|*
|*    Beschreibung
|*    Ersterstellung    MDA, 11.05.96
|*    Letzte Aenderung
|*
*************************************************************************/
#pragma SEG_FUNCDEF(vciengo_12)

void ImpSpinDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
					   const Brush& rBrush, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect = aPixRect;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	if( bUp )
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()+aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()+aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()--; aPos2.Y()--;
		}
	}
	else
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()-aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()-aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()++; aPos2.Y()++;
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}



/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawSpinButton()
|*
|*    Beschreibung
|*    Ersterstellung    MDA, 11.05.96
|*    Letzte Aenderung
|*
*************************************************************************/
void VCSpinButtonEngine::DrawSpinButton( OutputDevice* pOut )
{
	DrawUpButton( pOut );
	DrawDnButton( pOut );
}

/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawUpButton()
|*
|*    Beschreibung
|*    Ersterstellung    MDA, 11.05.96
|*    Letzte Aenderung
|*
*************************************************************************/
#pragma SEG_FUNCDEF(vciengo_01)

void VCSpinButtonEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bUpIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}
#pragma SEG_FUNCDEF(vciengo_02)



/*************************************************************************
|*
|*    VCSpinButtonEngine::DrawDnButton()
|*
|*    Beschreibung
|*    Ersterstellung    MDA, 11.06.95
|*    Letzte Aenderung
|*
*************************************************************************/
void VCSpinButtonEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bDnIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vciengu.cxx,v 1.1.1.1 2000/09/29 11:02:40 mh Exp $

	  Source Code Control System - Update

	  $Log: vciengu.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:40  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:49  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.8  1997/10/31 16:14:34  OV
	  VCL: Windows-Zeichenfunktionen auf allen Plattformen (364-inkompat); diverse VCL-Anpassungen
	

	  Rev 1.7   31 Oct 1997 17:14:34   OV
   VCL: Windows-Zeichenfunktionen auf allen Plattformen (364-inkompat); diverse VCL-Anpassungen

	  Rev 1.6   22 Oct 1997 13:24:54   OV
   #44895# Anpassungen UNX

	  Rev 1.5   16 Oct 1997 18:27:10   OV
   #44716# Anpassungen UNIX

	  Rev 1.4   13 May 1996 14:58:12   mda
   Diverse Unix-Anpassungen
	  Revision 1.4  1996/05/11 14:43:30  mda
	  Comboknopf korrigiert

	  Revision 1.3  1996/05/11 14:26:36  mda
	  SpinButton

	  Revision 1.2  1996/05/11 13:04:25  mda
	  Waagerechte Pfeile korrigiert

	  Revision 1.1  1996/05/11 12:36:36  mda
	  Initial revision

	  Revision 1.1  1996/05/11 10:02:14  mda
	  Initial revision


	  Rev 1.3   21 Mar 1996 10:56:22   OV
   Clooks & Umstellung SV311

	  Rev 1.2   21 Dec 1995 14:46:12   SV
   SV303

	  Rev 1.1   06 Nov 1995 18:11:12   TRI
   Change->Set

	  Rev 1.0   11 Aug 1995 08:29:26   mk
   Initial revision.

	  Rev 1.3   03 May 1995 07:27:36   mda
   Kleine Verbesserungen

	  Rev 1.2   23 Mar 1995 10:03:44   mda
   Dummy-Implementierung GetButtonHeight

	  Rev 1.1   23 Mar 1995 09:12:26   mda
   weiter fuer UNIX implementiert

	  Rev 1.0   03 Mar 1995 12:18:54   mk
   Initial revision.

*************************************************************************/

#endif

