/*************************************************************************
 *
 *  $RCSfile: vciengw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/




#ifndef VCL
#include <svwin.h>
#include <sv.hxx>
#endif

#pragma hdrstop

#define _VCSPINENG_CXX
#define _VCSCROLLENG_CXX
#define _VCDDLBOX_CXX
#define _VCDDCBOXENG_CXX

#include "vcengin.hxx"

static void ImpDDComboDrawArrow( OutputDevice* pOut,
	const Rectangle& rRect,  const Brush& rBrush )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
		if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect = aPixRect;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	aTempRect.Left()   = aCenter.X() - aSize4.Width();
	aTempRect.Right()  = aCenter.X() + aSize4.Width();
	aTempRect.Top()    = aCenter.Y() - aSize3.Height();
	aTempRect.Bottom() = aCenter.Y()-1;

#ifdef WIN
	pOut->DrawRect( aTempRect );
#else
	aCenter.Y() -= aTempRect.GetHeight() / 2;
	aCenter.Y()--; //etwas kopflastig
#endif

	Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y() );
	Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y() );
	while( aPos1.X() <= aPos2.X() )
	{
		pOut->DrawLine( aPos1, aPos2 );
		aPos1.X()++; aPos2.X()--;
		aPos1.Y()++; aPos2.Y()++;
	}

#ifdef WIN
	pOut->DrawLine( Point( aCenter.X() - aSize3.Width(), aPos1.Y()+1 ),
					Point( aCenter.X() + aSize3.Width(), aPos1.Y()+1 ) );
#endif

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#ifdef VCL

/*
	Border-Farben in VCL
	--------------------

	(Beispielfarben fuer W95-Darstellung "Aubergine")

	Unten innen, Rechts innen			LightBorder (Hellgruen)
	Oben innen, Links innen 			ShadowColor (Dunkelgruen)
	Oben aussen, Links aussen			DarkShadow (Schwarz)
	Rechts aussen, Unten aussen			LightColor (Hellgrau)
*/

void SiDrawBorder_Impl(
	OutputDevice* pOut,
	const Point& rPos,
	const Size& rSize,
	const Color& rOuterTop,
	const Color& rInnerTop,
	const Color& rOuterBottom,
	const Color& rInnerBottom )
{
	Rectangle 	aRect( rPos, rSize );
	Pen 		aOldPen( pOut->GetPen());
	Brush 		aOldBrush( pOut->GetFillInBrush() );
	Size 		aPix( pOut->PixelToLogic( Size(1,1) ) );
	Point		aStartPos, aEndPos;

	pOut->SetPen( Pen( rOuterTop ));

	// aussen oben
	aStartPos = aRect.TopLeft();
	aEndPos = aStartPos;
	aEndPos.X() = aRect.Right() - aPix.Width();
	pOut->DrawLine( aStartPos, aEndPos );

	// aussen links
	aEndPos = aStartPos;
	aEndPos.Y() = aRect.Bottom() - aPix.Height();
	pOut->DrawLine( aStartPos, aEndPos );

	pOut->SetPen( Pen( rInnerTop ) );

	// innen oben
	aStartPos.X() += aPix.Width();
	aStartPos.Y() += aPix.Height();
	aEndPos = aStartPos;
	aEndPos.X() = aRect.Right() - 2 * aPix.Width();
	pOut->DrawLine( aStartPos, aEndPos );

	// links innen
	aEndPos = aStartPos;
	aEndPos.Y() = aRect.Bottom() - 2*aPix.Height();
	pOut->DrawLine( aStartPos, aEndPos );

	pOut->SetPen( Pen( rOuterBottom ) );

	// unten aussen
	aStartPos = aRect.BottomRight();
	aEndPos = aStartPos;
	aEndPos.X() = aRect.Left();
	pOut->DrawLine( aStartPos, aEndPos );

	// aussen rechts
	aEndPos = aStartPos;
	aEndPos.Y() = aRect.Top();
	pOut->DrawLine( aStartPos, aEndPos );

	pOut->SetPen( Pen( rInnerBottom ) );

	// unten innen
	aStartPos.X() = aRect.Right() - aPix.Width();
	aStartPos.Y() = aRect.Bottom() - aPix.Height();
	aEndPos = aStartPos;
	aEndPos.X() = aRect.Left() + aPix.Width();
	pOut->DrawLine( aStartPos, aEndPos );

	// rechts innen
	aEndPos = aStartPos;
	aEndPos.Y() = aRect.Top() + aPix.Height();
	pOut->DrawLine( aStartPos, aEndPos );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

// Position & Groesse im MapMode des OutputDevices
void SiDrawBorder_Impl(OutputDevice* pOut,const Point& rPos,const Size& rSize)
{
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
	SiDrawBorder_Impl(
		pOut,rPos,rSize,
		rSettings.GetDarkShadowColor(),
		rSettings.GetShadowColor(),
		rSettings.GetLightColor(),
		rSettings.GetLightBorderColor() );
}

void SiDrawBtnBackground_Impl( OutputDevice* pOut, const Rectangle& rButtonRect,
	BOOL bButtonIn )
{
	Brush aOldBrush( pOut->GetFillInBrush() );
	Pen   aOldPen( pOut->GetPen() );
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	Brush aBrush;
	//??? 22.4.98
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( rSettings.GetFaceColor() );

	// Hintergrund
	pOut->SetFillInBrush( aBrush );
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		pOut->SetPen( Pen(PEN_NULL) );
	else
		pOut->SetLineColor( rSettings.GetShadowColor() );

	pOut->DrawRect( rButtonRect );

	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( !bButtonIn )
		{
			SiDrawBorder_Impl(
				pOut,rButtonRect.TopLeft(),rButtonRect.GetSize(),
				rSettings.GetLightColor(),
				rSettings.GetFaceColor(),
				rSettings.GetDarkShadowColor(),
				rSettings.GetShadowColor() );
		}
		else
		{
			SiDrawBorder_Impl(
				pOut,rButtonRect.TopLeft(),rButtonRect.GetSize(),
				rSettings.GetDarkShadowColor(),
				rSettings.GetFaceColor(),
				rSettings.GetLightColor(),
				rSettings.GetLightColor() );
		}
	}
	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

static void DrawDropDownButton(OutputDevice* pOut, const Rectangle& rButtonRect)
{
	SiDrawBtnBackground_Impl( pOut, rButtonRect );
	// Pfeil zeichnen
	Size 	aInnerSize( rButtonRect.GetSize() );
	Point 	aInnerCenter( rButtonRect.Center() );
	Rectangle aInnerRect( rButtonRect );
	aInnerRect.Top() = aInnerCenter.Y() - (aInnerSize.Width()>>1);
	aInnerRect.Bottom() = aInnerCenter.Y() + (aInnerSize.Width()>>1);
	Brush aBlackBrush;
	aBlackBrush.SetColor( Color() );
	ImpDDComboDrawArrow( pOut, aInnerRect, aBlackBrush );
}

static void DrawScrBarBtnBack( OutputDevice* pOut, const Rectangle& rButtonRect,
	BOOL bButtonIn )
{
	Brush aOldBrush( pOut->GetFillInBrush() );
	Pen   aOldPen( pOut->GetPen() );
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	Brush aBrush;
	//????
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( rSettings.GetFaceColor() );

	// Hintergrund
	pOut->SetFillInBrush( aBrush );
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		pOut->SetPen( Pen(PEN_NULL) );
	else
		pOut->SetLineColor( rSettings.GetDarkShadowColor() );

	pOut->DrawRect( rButtonRect );

	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( !bButtonIn )
		{
			SiDrawBorder_Impl(
				pOut, rButtonRect.TopLeft(), rButtonRect.GetSize(),
				rSettings.GetLightBorderColor(),
				rSettings.GetLightColor(),
				rSettings.GetDarkShadowColor(),
				rSettings.GetShadowColor() );
		}
		else
		{
			SiDrawBorder_Impl(
				pOut, rButtonRect.TopLeft(), rButtonRect.GetSize(),
				rSettings.GetDarkShadowColor(),
				rSettings.GetShadowColor(),
				rSettings.GetLightBorderColor(),
				rSettings.GetLightColor() );
		}
	}
	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#endif

void ImpSpinDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
					   const Brush& rBrush, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	if( bUp )
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()+aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()+aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()--; aPos2.Y()--;
		}
	}
	else
	{
		Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y()-aSize4.Height() );
		Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y()-aSize4.Height() );
		while( aPos1.X() <= aPos2.X() )
		{
			pOut->DrawLine( aPos1, aPos2 );
			aPos1.X()++; aPos2.X()--;
			aPos1.Y()++; aPos2.Y()++;
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#ifndef VCL

void VCSpinButtonEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bUpIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

void VCSpinButtonEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( bDnIn )
	{
		Color aCol( COL_3DSHADOW );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
		pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
	}
	else
	{
		Rectangle aRect = aInnerRect;

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
		pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

		aRect.Left()   += aLogPix.Width();
		aRect.Top()    += aLogPix.Height();
		aRect.Right()  -= aLogPix.Width();
		aRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
		pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
	}

	// Pfeile erzeugen
	if( !bEnable )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpSpinDrawArrow( pOut, aTempRect, aWhiteBrush, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#else

void VCSpinButtonEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aPix = pOut->PixelToLogic( Size( 1, 1 ) );
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	SiDrawBtnBackground_Impl( pOut, aUpRect, bUpIn );

	// Pfeile zeichnen
	Rectangle aInnerRect( aUpRect );
	if( !bEnable )
	{
		Rectangle aTempRect( aInnerRect );
		aTempRect.Move( aPix.Width(), aPix.Height() );
		Brush aLightBrush( rSettings.GetLightColor() );
		ImpSpinDrawArrow( pOut, aTempRect, aLightBrush, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( rSettings.GetDarkShadowColor() );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn )
		aInnerRect.Move( aPix.Width(), aPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, TRUE );
}

void VCSpinButtonEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aPix = pOut->PixelToLogic( Size( 1, 1 ) );
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	SiDrawBtnBackground_Impl( pOut, aDnRect, bDnIn );

	// Pfeile zeichnen
	Rectangle aInnerRect( aDnRect );
	if( !bEnable )
	{
		Rectangle aTempRect( aInnerRect );
		aTempRect.Move( aPix.Width(), aPix.Height() );
		Brush aLightBrush( rSettings.GetLightColor() );
		ImpSpinDrawArrow( pOut, aTempRect, aLightBrush, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable )
		aArrowBrush.SetColor( rSettings.GetDarkShadowColor() );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn )
		aInnerRect.Move( aPix.Width(), aPix.Height() );
	ImpSpinDrawArrow( pOut, aInnerRect, aArrowBrush, FALSE );
}

#endif


void VCSpinButtonEngine::DrawSpinButton( OutputDevice* pOut )
{
	DrawUpButton( pOut );
	DrawDnButton( pOut );
}

long VCScrollBarEngine::GetOptWidth( OutputDevice* pOut, BOOL bHorz )
{
	Size aOptSize;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
#ifndef VCL
		if( !bHorz )
			aOptSize.Width() = GetSystemMetrics( SM_CXVSCROLL ) - 1;
		else
			aOptSize.Width() = GetSystemMetrics( SM_CYHSCROLL ) - 1;
#else
		aOptSize.Width() = 14;
#endif
		aOptSize = pOut->PixelToLogic( aOptSize,
							MapMode( pOut->GetMapMode().GetMapUnit() ) );
	}
	else
	{
		MapMode aMap1( MAP_10TH_MM );
		MapMode aMap2( pOut->GetMapMode().GetMapUnit() );
		Size aSize = pOut->LogicToLogic( Size( 1, 1 ), &aMap1, &aMap2 );
			aOptSize.Width() = 35*aSize.Width();
	}
	return aOptSize.Width();
}

#ifdef VCL
static void DrawScrBarPgRect( OutputDevice* pOut, const Rectangle& rPgRect,
	BOOL bPressed )
{
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	Brush aBrush;
	if( bPressed )
		aBrush.SetColor( rSettings.GetShadowColor() );
	else
		aBrush.SetColor( rSettings.GetCheckedColor() );

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen aOldPen( pOut->GetPen() );
	pOut->SetPen( Pen( PEN_NULL ) );
	pOut->DrawRect( rPgRect );
	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#endif


void VCScrollBarEngine::DrawPgUpRect( OutputDevice* pOut )
{
#ifdef VCL
	DrawScrBarPgRect( pOut, aPgUpRect, bPgUpIn );
#else
	Brush aBrush;
	if( bEnable )
	{
		if( bPgUpIn && !bInPaint )
			aBrush.SetColor( Color( COL_3DSHADOW ) );
		else
			aBrush.SetColor( Color( COL_SCROLLBAR ) );
	}

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgUpRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
#endif
}

void VCScrollBarEngine::DrawPgDnRect( OutputDevice* pOut )
{
#ifdef VCL
	DrawScrBarPgRect( pOut, aPgDnRect, bPgDnIn );
#else
	Brush aBrush;
	if( bEnable )
	{
		if( bPgDnIn && !bInPaint )
			aBrush.SetColor( Color( COL_3DSHADOW ) );
		else
			aBrush.SetColor( Color( COL_SCROLLBAR ) );
	}

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );

	pOut->DrawRect( aPgDnRect );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
#endif
}



void VCScrollBarEngine::DrawBorder( OutputDevice* pOut )
{
	if( pOut->GetOutDevType() == OUTDEV_PRINTER )
	{
		Pen 	aOldPen 	= pOut->GetPen( );
		pOut->SetPen( Pen() );
		Brush   aOldBrush   = pOut->GetFillInBrush( );
		pOut->SetFillInBrush( Brush( BRUSH_NULL ) );

		pOut->DrawRect( Rectangle( aPos, aSize ) );

		pOut->SetFillInBrush( aOldBrush );
		pOut->SetPen( aOldPen );
	}
}

void ImpScrollDrawArrow( OutputDevice* pOut, const Rectangle& rRect,
						 const Brush& rBrush, BOOL bHorz, BOOL bUp )
{
	Rectangle aPixRect = pOut->LogicToPixel( rRect );

	Point	  aCenter  = aPixRect.Center();
	Size      aSize    = aPixRect.GetSize();
	if( aSize.Width() < aSize.Height() )
		aSize.Height() = aSize.Width();
	else
		aSize.Width() = aSize.Height();

	Size aSize2;
	aSize2.Width() = aSize.Width() >> 1;
	aSize2.Height()= aSize.Height() >> 1;

	Size aSize3;
	aSize3.Width() = aSize.Width() >> 2;
	aSize3.Height() = aSize.Height() >> 2;

	Size aSize4;
	aSize4.Width() = aSize.Width() >> 3;
	aSize4.Height() = aSize.Height() >> 3;

	BOOL   bOldClip   = pOut->IsClipRegion();
	Region aOldRegion = pOut->GetClipRegion();
	Region aTempRegion;
	if( bOldClip )
		aTempRegion = pOut->LogicToPixel( aOldRegion );
	MapMode aOldMap = pOut->GetMapMode( );
	pOut->SetMapMode( MapMode() );
	if( bOldClip )
		pOut->SetClipRegion( aTempRegion );
	pOut->IntersectClipRegion( aPixRect );

	Rectangle aTempRect;

	Brush aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( rBrush );
	Pen aPen;
	aPen.SetColor( rBrush.GetColor() );
	Pen aOldPen = pOut->GetPen( );
	pOut->SetPen( aPen );

	if( bUp )
	{
		if( !bHorz )
		{
			aTempRect.Left()   = aCenter.X() - aSize4.Width();
			aTempRect.Right()  = aCenter.X() + aSize4.Width();
			aTempRect.Top()    = aCenter.Y() - (aSize3.Height()-1);
			aTempRect.Bottom() = aCenter.Y();
#ifdef WIN
			pOut->DrawRect( aTempRect );
#else
			// unter WIN32 nur noch ein Dreieck
			aCenter.Y() -= aTempRect.GetHeight() / 2;
#endif

			Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y() );
			Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y() );
			while( aPos1.X() <= aPos2.X() )
			{
				pOut->DrawLine( aPos1, aPos2 );
				aPos1.X()++; aPos2.X()--;
				aPos1.Y()++; aPos2.Y()++;
			}
		}
		else
		{
			aTempRect.Left()  = aCenter.X()-(aSize3.Width()-1);
			aTempRect.Right() = aCenter.X();
			aTempRect.Top()   = aCenter.Y() - aSize4.Width();
			aTempRect.Bottom()= aCenter.Y() + aSize4.Width();

#ifdef WIN
			pOut->DrawRect( aTempRect );
#else
			// unter WIN32 nur noch ein Dreieck
			aCenter.X() -= aTempRect.GetWidth() / 2;
#endif

			Point aPos1( aCenter.X(), aCenter.Y()-aSize3.Height() );
			Point aPos2( aCenter.X(), aCenter.Y()+aSize3.Height() );
			while( aPos1.Y() <= aPos2.Y() )
			{
				pOut->DrawLine( aPos1, aPos2 );
				aPos1.Y()++; aPos2.Y()--;
				aPos1.X()++; aPos2.X()++;
			}
		}
	}
	else
	{
		if( !bHorz )
		{
			aTempRect.Left()  = aCenter.X() - aSize4.Width();
			aTempRect.Right() = aCenter.X() + aSize4.Width();
			aTempRect.Top()   = aCenter.Y();
			aTempRect.Bottom()= aCenter.Y()+aSize3.Height()-1;
#ifdef WIN
			pOut->DrawRect( aTempRect );
#else
			// unter WIN32 nur noch ein Dreieck
			aCenter.Y() += aTempRect.GetHeight() / 2;
#endif
			Point aPos1( aCenter.X()-aSize3.Width(), aCenter.Y() );
			Point aPos2( aCenter.X()+aSize3.Width(), aCenter.Y() );
			while( aPos1.X() <= aPos2.X() )
			{
				pOut->DrawLine( aPos1, aPos2 );
				aPos1.X()++; aPos2.X()--;
				aPos1.Y()--; aPos2.Y()--;
			}
		}
		else
		{
			aTempRect.Left()  = aCenter.X();
			aTempRect.Right() = aCenter.X()+aSize3.Width()-1;
			aTempRect.Top()   = aCenter.Y() - aSize4.Width();
			aTempRect.Bottom()= aCenter.Y() + aSize4.Width();
#ifdef WIN
			pOut->DrawRect( aTempRect );
#else
			// unter WIN32 nur noch ein Dreieck
			aCenter.X() += aTempRect.GetWidth() / 2;
#endif
			Point aPos1( aCenter.X(), aCenter.Y()-aSize3.Height() );
			Point aPos2( aCenter.X(), aCenter.Y()+aSize3.Height() );
			while( aPos1.Y() <= aPos2.Y() )
			{
				pOut->DrawLine( aPos1, aPos2 );
				aPos1.Y()++; aPos2.Y()--;
				aPos1.X()--; aPos2.X()--;
			}
		}
	}

	pOut->SetMapMode( aOldMap );
	if( bOldClip )
		pOut->SetClipRegion( aOldRegion );
	else
		pOut->SetClipRegion();

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
}

#ifndef VCL

void VCScrollBarEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );

	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	// Eventuell clippen
	Rectangle aTempRect( aUpRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip    = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aUpRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bUpIn && !bInPaint )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

			aRect.Left()   += aLogPix.Width();
			aRect.Top()    += aLogPix.Height();
			aRect.Right()  -= aLogPix.Width();
			aRect.Bottom() -= aLogPix.Height();

			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpScrollDrawArrow( pOut, aTempRect, aWhiteBrush, bHorz, TRUE );
	}

	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn && !bInPaint && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, TRUE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}

void VCScrollBarEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Brush   aBrush;
	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	// Eventuell clippen
	Rectangle aTempRect( aDnRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aDnRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	pOut->DrawRect( aInnerRect );
	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bDnIn && !bInPaint )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

			aRect.Left()   += aLogPix.Width();
			aRect.Top()    += aLogPix.Height();
			aRect.Right()  -= aLogPix.Width();
			aRect.Bottom() -= aLogPix.Height();

			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		Brush aWhiteBrush;
		aWhiteBrush.SetColor( Color( COL_3DLIGHT ) );
		ImpScrollDrawArrow( pOut, aTempRect, aWhiteBrush, bHorz, FALSE );
	}

	Brush aArrowBrush;
	if( !bEnable && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn && !bInPaint && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, FALSE );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}

#else

void VCScrollBarEngine::DrawUpButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Rectangle aInnerRect;
	aInnerRect = aUpRect;

	// Eventuell clippen
	Rectangle aTempRect( aUpRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip    = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aUpRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	DrawScrBarBtnBack( pOut, aInnerRect, bUpIn );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Bottom()-= aLogPix.Height();

	// Pfeile erzeugen
	if( (!bEnable || bUpDisabled) ) // && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
		Brush aLightBrush( rSettings.GetLightColor() );
		ImpScrollDrawArrow( pOut, aTempRect, aLightBrush, bHorz, TRUE );
	}

	Brush aArrowBrush;
	if( (!bEnable || bUpDisabled) ) //&& (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bUpIn && !bInPaint ) //&& (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, TRUE );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}

void VCScrollBarEngine::DrawDnButton( OutputDevice* pOut )
{
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );

	Rectangle aInnerRect;
	aInnerRect = aDnRect;

	// Eventuell clippen
	Rectangle aTempRect( aDnRect );
	aTempRect.Intersection( Rectangle( aPos, aSize ) );
	BOOL   bClip = FALSE;
	BOOL   bOldClip;
	Region aOldClip;
	if( aTempRect != aDnRect )
	{
		bClip    = TRUE;
		bOldClip = pOut->IsClipRegion();
		aOldClip = pOut->GetClipRegion();
		pOut->IntersectClipRegion( aTempRect );
	}

	DrawScrBarBtnBack( pOut, aInnerRect, bDnIn );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	// Pfeile erzeugen
	if( (!bEnable || bDnDisabled) ) //&& (pOut->GetOutDevType() != OUTDEV_PRINTER) )
	{
		Rectangle aTempRect = aInnerRect;
		aTempRect.Move( aLogPix.Width(), aLogPix.Height() );
		const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();
		Brush aLightBrush( rSettings.GetLightColor() );
		ImpScrollDrawArrow( pOut, aTempRect, aLightBrush, bHorz, FALSE );
	}

	Brush aArrowBrush;
	if( (!bEnable || bDnDisabled) ) //&& (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aArrowBrush.SetColor( Color( COL_3DSHADOW ) );
	else
		aArrowBrush.SetColor( Color() );

	if( bDnIn && !bInPaint ) //&& (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpScrollDrawArrow( pOut, aInnerRect, aArrowBrush, bHorz, FALSE );

	if( bClip )
	{
		if( bOldClip )
			pOut->SetClipRegion( aOldClip );
		else
			pOut->SetClipRegion();
	}
}

#endif



Rectangle VCScrollBarEngine::GetThumbRect( OutputDevice* pOut )
{
#ifndef VCL
	if( !bEnable )
		return Rectangle();
#endif

	// Genug Platz ?
	long nFreeHeight;
	if( !bHorz )
		nFreeHeight = aUpRect.Top() - aDnRect.Bottom();
	else
		nFreeHeight = aUpRect.Left() - aDnRect.Right();

#ifndef VCL
	if( ( !bHorz && (nFreeHeight < (aSize.Width()*2))) ||
		( bHorz && (nFreeHeight < (aSize.Height()*2)))    )
		return Rectangle();
#endif

	Point aMinPos;
	Point aMaxPos;
	Size aPixSize = pOut->PixelToLogic( Size( 1, 1 ) );
	if( !bHorz )
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() + aPixSize.Height() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() - aPixSize.Height() );
		}
		else
		{
			aMinPos = Point( aDnRect.Left(), aDnRect.Bottom() );
			aMaxPos = Point( aUpRect.Left(), aUpRect.Top() - aUpRect.GetSize().Height() );
		}
	}
	else
	{
		if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		{
			aMinPos = Point( aDnRect.Right() + aPixSize.Width(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width() - aPixSize.Width(), aUpRect.Top() );
		}
		else
		{
			aMinPos = Point( aDnRect.Right(), aDnRect.Top() );
			aMaxPos = Point( aUpRect.Left() - aUpRect.GetSize().Width(), aUpRect.Top() );
		}
	}


	// Thumb Rectangle
	Rectangle aThumbRect( aMinPos, aUpRect.GetSize() );

	long nMaxPos = bHorz ? aMaxPos.X() : aMaxPos.Y();
	long nMinPos = bHorz ? aMinPos.X() : aMinPos.Y();
	long nActOfs=0;

	// Skalierung
	if( (nMax - nMin) != 0 )
		nActOfs = (nMaxPos-nMinPos)*(nAct-nMin) /
				  Abs(nMax - nMin );

	if( !bHorz )
		aThumbRect.Move( 0, nActOfs );
	else
		aThumbRect.Move( nActOfs, 0 );

	return aThumbRect;
}

void VCScrollBarEngine::DrawThumb( OutputDevice* pOut )
{
	if( bCalcThumb )
	{
		aThumbRect = GetThumbRect( pOut );
		aPgUpRect  = GetPgUpRect( pOut );
		aPgDnRect  = GetPgDnRect( pOut );
		bCalcThumb = FALSE;
	}

	if( !bEnable )
	{
		#ifdef VCL
		DrawScrBarPgRect( pOut, aThumbRect, FALSE );
		#endif
		return;
	}

#ifdef VCL
	DrawScrBarBtnBack( pOut, aThumbRect, FALSE );
#else
	// Umrandung malen
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );
	Brush   aBrush;
	//???
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	pOut->DrawRect( aThumbRect );

	// Innenleben malen
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
		Rectangle aThRect = aThumbRect;
		if( !bHorz )
		{
			aThRect.Left()  += aLogPix.Width();
			aThRect.Right() -= aLogPix.Width();
		}
		else
		{
			aThRect.Top()   += aLogPix.Height();
			aThRect.Bottom()-= aLogPix.Height();
		}

		Color aCol( COL_3DLIGHT );
		Pen aPen( aCol );
		pOut->SetPen( aPen );
		pOut->DrawLine( aThRect.TopLeft(), aThRect.TopRight() );
		pOut->DrawLine( aThRect.TopLeft(), aThRect.BottomLeft() );

		aPen.SetColor( Color( COL_3DSHADOW ) );
		pOut->SetPen( aPen );
		pOut->DrawLine( aThRect.BottomRight(), aThRect.BottomLeft() );
		pOut->DrawLine( aThRect.BottomRight(), aThRect.TopRight() );

		aThRect.Left()   += aLogPix.Width();
		aThRect.Top()    += aLogPix.Height();
		aThRect.Right()  -= aLogPix.Width();
		aThRect.Bottom() -= aLogPix.Height();

		pOut->DrawLine( aThRect.BottomRight(), aThRect.BottomLeft() );
		pOut->DrawLine( aThRect.BottomRight(), aThRect.TopRight() );
	}

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
#endif
}

void VCScrollBarEngine::HideThumb( OutputDevice* pOut )
{
	if( !bEnable )
		return;

	if( bCalcThumb )
	{
		aThumbRect = GetThumbRect( pOut );
		aPgUpRect  = GetPgUpRect( pOut );
		aPgDnRect  = GetPgDnRect( pOut );
		bCalcThumb = FALSE;
	}

#ifdef VCL
	DrawScrBarPgRect( pOut, aThumbRect, FALSE );
#else

	// Innenleben loeschen
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	Rectangle aThRect = aThumbRect;
	if( !bHorz )
	{
		aThRect.Left()  += aLogPix.Width();
		aThRect.Right() -= aLogPix.Width();
	}
	else
	{
		aThRect.Top()   += aLogPix.Height();
		aThRect.Bottom()-= aLogPix.Height();
	}
	Pen   aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen( PEN_NULL ) );
	Brush aBrush;
	aBrush.SetColor( Color( COL_SCROLLBAR ) );
	pOut->SetFillInBrush( aBrush );
	pOut->DrawRect( aThRect );
	pOut->SetFillInBrush( aBrush );
	pOut->SetPen( aOldPen );
#endif
}

void VCScrollBarEngine::DrawScrollBar( OutputDevice* pOut )
{
	if( !aSize.Width()  || !aSize.Height() )
		return;

#ifndef VCL
	if( !bEnable )
	{
		Brush aOldBrush = pOut->GetFillInBrush( );
		pOut->SetFillInBrush( Brush() );
		Pen   aOldPen   = pOut->GetPen( );
		pOut->SetPen( Pen( PEN_NULL ) );
		pOut->DrawRect( Rectangle( aPos, aSize ) );
		pOut->SetPen( aOldPen );
		pOut->SetFillInBrush( aOldBrush );
	}
#endif

	DrawUpButton( pOut );
	DrawDnButton( pOut );
	DrawThumb( pOut );
	DrawPgUpRect( pOut );
	DrawPgDnRect( pOut );
}

void VCDDListBoxEngine::DrawButton( OutputDevice* pOut )
{
#ifdef VCL
	DrawDropDownButton( pOut, aBtnRect );
#else
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	Brush   aBrush;
	//???
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect = aBtnRect;
	pOut->DrawRect( aInnerRect );

	Rectangle aXX( aInnerRect );
	aXX = pOut->LogicToPixel( aXX );
	long nw=aXX.GetWidth();

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bBtnIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

			aRect.Left()   += aLogPix.Width();
			aRect.Top()    += aLogPix.Height();
			aRect.Right()  -= aLogPix.Width();
			aRect.Bottom() -= aLogPix.Height();

			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	Size  aInnerSize   = aInnerRect.GetSize();

	Point aInnerCenter = aInnerRect.Center();
	aInnerRect.Top()   = aInnerCenter.Y() - (aInnerSize.Width()>>1);
	aInnerRect.Bottom()= aInnerCenter.Y() + (aInnerSize.Width()>>1);

	Brush aBlackBrush;
	aBlackBrush.SetColor( Color() );
	if( bBtnIn & (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpDDComboDrawArrow( pOut, aInnerRect, aBlackBrush );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
#endif //VCL
}


void VCDDComboBoxEngine::DrawButton( OutputDevice* pOut )
{
#ifdef VCL
	DrawDropDownButton( pOut, aBtnRect );
#else
	Size aLogPix = pOut->PixelToLogic( Size( 1, 1 ) );
	Brush   aBrush;
	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
		aBrush.SetColor( Color( COL_3DFACE ) );
	Brush   aOldBrush = pOut->GetFillInBrush( );
	pOut->SetFillInBrush( aBrush );
	Pen     aOldPen   = pOut->GetPen( );
	pOut->SetPen( Pen() );

	Rectangle aInnerRect = aBtnRect;
	pOut->DrawRect( aInnerRect );

	aInnerRect.Left()  += aLogPix.Width();
	aInnerRect.Top()   += aLogPix.Height();
	aInnerRect.Right() -= aLogPix.Width();
	aInnerRect.Bottom()-= aLogPix.Height();

	//if( pOut->GetOutDevType() != OUTDEV_PRINTER )
	{
		if( bBtnIn )
		{
			Color aCol( COL_3DSHADOW );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.TopRight() );
			pOut->DrawLine( aInnerRect.TopLeft(), aInnerRect.BottomLeft() );
		}
		else
		{
			Rectangle aRect = aInnerRect;

			Color aCol( COL_3DLIGHT );
			Pen aPen( aCol );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.TopLeft(), aRect.TopRight() );
			pOut->DrawLine( aRect.TopLeft(), aRect.BottomLeft() );

			aPen.SetColor( Color( COL_3DSHADOW ) );
			pOut->SetPen( aPen );
			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );

			aRect.Right()  -= aLogPix.Width();
			aRect.Bottom() -= aLogPix.Height();

			pOut->DrawLine( aRect.BottomRight(), aRect.BottomLeft() );
			pOut->DrawLine( aRect.BottomRight(), aRect.TopRight() );
		}
	}

	// Pfeile erzeugen
	Size  aInnerSize   = aInnerRect.GetSize();

	Point aInnerCenter = aInnerRect.Center();
	aInnerRect.Top()   = aInnerCenter.Y() - (aInnerSize.Width()>>1);
	aInnerRect.Bottom()= aInnerCenter.Y() + (aInnerSize.Width()>>1);

	Brush aBlackBrush;
	aBlackBrush.SetColor( Color() );
	if( bBtnIn && (pOut->GetOutDevType() != OUTDEV_PRINTER) )
		aInnerRect.Move( aLogPix.Width(), aLogPix.Height() );
	ImpDDComboDrawArrow( pOut, aInnerRect, aBlackBrush );

	pOut->SetPen( aOldPen );
	pOut->SetFillInBrush( aOldBrush );
#endif
}

/*************************************************************************

	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vciengw.cxx,v 1.1.1.1 2000/09/29 11:02:40 mh Exp $

	  Source Code Control System - Update

	  $Log: vciengw.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:40  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:49  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.31  1998/04/22 16:04:22  OV
	  #46887# Sonderbehandlung Printer raus
	

	  Rev 1.30   22 Apr 1998 18:04:22   OV
   #46887# Sonderbehandlung Printer raus

	  Rev 1.29   21 Nov 1997 17:01:56   OV
   Headerumstellung

	  Rev 1.28   06 Nov 1997 19:12:20   OV
   weitere VCL-Anpassungen

	  Rev 1.27   06 Nov 1997 12:46:12   OV
   VCL-Umstellungen

	  Rev 1.26   31 Oct 1997 17:14:24   OV
   VCL: Windows-Zeichenfunktionen auf allen Plattformen (364-inkompat); diverse VCL-Anpassungen

	  Rev 1.25   29 May 1997 16:06:14   OV
   ScrollBar: Nicht painten, wenn Hoehe oder Breite 0

	  Rev 1.24   28 May 1997 16:00:18   OV
   #34418# DD-ListBoxPfeil im Windows95-Look

	  Rev 1.23   28 May 1997 15:19:30   OV
   #34418# ScrollBar-Pfeile jetzt im Windows95-Look

	  Rev 1.22   05 Jun 1996 13:24:56   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.21   11 Apr 1996 11:32:12   MH
   CLOOKS

	  Rev 1.20   21 Mar 1996 10:56:16   OV
   Clooks & Umstellung SV311

	  Rev 1.19   22 Feb 1996 13:29:38   MH
   305-Anpassung

	  Rev 1.18   06 Nov 1995 18:13:06   TRI
   Change->Set

*************************************************************************/


#pragma SEG_EOFMODULE

