/*************************************************************************
 *
 *  $RCSfile: vcirctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef VCL
#ifndef _SV_APP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <svtools/svmedit.hxx>
#endif
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif

#pragma hdrstop
#define ITEMID_COLOR 0

#define SI_VCSV_LISTBOX
#define SI_VCSV_EDIT
#define SI_VCSV_FIXEDTEXT
#define SI_VCSV_GROUPBOX
#define SI_VCSV_PREVIEW
#define SI_VCSV_BUTTONS
#define SI_VCSV_SCROLLBAR
#define _SI_VCITEMS
#define SI_VCDRAWOBJ
#define SI_VCDRAWPAGE
#define SI_VCDRAWMODEL
//#define _SI_NOVCSBXFORM
//#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
//#define _SI_NOVCSBXSPINBUTTON
//#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
//#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#include "vcsbxctl.hxx"
#include "vclbox.hxx"
#include "vccbbox.hxx"
#include <svx/colritem.hxx>
#include "vctrls.hxx"
#include "vcsbxdo.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vcont.hxx"
#include "vcictrls.hxx"
#include "vcdrwobj.hxx"
#include "sictrls.hxx"

// Gibt das zum Painten im Dialogeditor verwendete Control zurueck
Control* VCImpRealControl::GetDlgEdControl( Window* pParent )
{
	if( pDlgEdControl && pDlgEdControl->GetParent() != pParent )
	{
		DELETEZ(pDlgEdControl);
	}
	if( !pDlgEdControl )
	{
#ifndef TF_SI_OFF50
		pDlgEdControl = (Control*)CreateClass( pParent );
#else
		pDlgEdControl = pShell->GetSbxControl()->CreateVCLControl(
			pParent, *pShell->GetItemSet() );
#endif
		UpdateFromItemSet( 0 );	// alle Props neu setzen
	}
	return pDlgEdControl;
}

BOOL VCImpRealControl::IsSVLook() const
{
	SbxObject* pDlg = pShell->GetSbxControl()->GetParent();
	if( pDlg && pDlg->ISA(VCSbxDialog) )
		return ((VCSbxDialog*)pDlg)->IsSVLook();
	return TRUE;
}


void VCImpRealControl::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	SfxItemSet* pItemSet = pShell->GetItemSet();

#ifdef TF_SI_OFF50
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnable = ((const SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		{
			if( pShell->GetSbxControl()->ISA(VCSbxSpinButton))
			{
				if( bEnable )
					((VCSVSpinButton*)pDlgEdControl)->Enable();
				else
					((VCSVSpinButton*)pDlgEdControl)->Disable();
			}
			else
			{
				bEnable ? pDlgEdControl->Enable() : pDlgEdControl->Disable();
			}
		}
	}
	pShell->GetSbxControl()->UpdateVCLColorsAndFont(pDlgEdControl,*pItemSet,nWhich);
#else
	if( !nWhich || (nWhich == VCATTR_ENABLED) )
	{
		BOOL bEnabled = ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
		VCSbxDrawObject* pObj = pShell->GetDrawObject();
		if( pObj && pObj->GetControl()->IsA( TYPE( VCSbxSpinButton)))
		{
			if( bEnabled )
				((SpinButton*)pDlgEdControl)->Enable();
			else
				((SpinButton*)pDlgEdControl)->Disable();
		}
		else
		{
			bEnabled ? pDlgEdControl->Enable() : pDlgEdControl->Disable();
		}
	}
	BOOL bTransparent = FALSE;
	if( pItemSet->GetItemState( VCATTR_BACKSTYLE ) != SFX_ITEM_UNKNOWN )
	{
		USHORT eBack = (USHORT)((VCBackStyleItem&)pItemSet->
							Get( VCATTR_BACKSTYLE )).GetValue();
		if( eBack == VCBACK_TRANSPARENT )
			bTransparent = TRUE;
	}

	switch( nWhich )
	{
		case 0:
		case VCATTR_BACKCOLOR:
		case VCATTR_FORECOLOR:
		case VCATTR_BACKSTYLE:
		case VCATTR_FONTNAME:
		case VCATTR_FONTSIZE:
		case VCATTR_FONTBOLD:
		case VCATTR_FONTITALIC:
		case VCATTR_FONTSTRIKETHRU:
		case VCATTR_FONTUNDERLINE:
		{
			Font aFont;
			BOOL bSVLook = IsSVLook();
			if( !bSVLook )
			{
				//aFont = GetFont( pDlgEdControl );
				aFont = pDlgEdControl->GetFont();
				Color aForeCol = ((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue();
				Color aBackCol = ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue();
				Brush aBrush( aBackCol );
				pDlgEdControl->SetBackgroundBrush( aBrush );
				Brush aFillBrush( pDlgEdControl->GetFillInBrush() );
				aFillBrush.SetColor( aForeCol );
				aFillBrush.SetFillColor( aBackCol );
				pDlgEdControl->SetFillInBrush( aFillBrush );
				#ifndef VCL
				aFont.SetColor( aForeCol );
				aFont.SetFillColor( aBackCol );
				#else
				AllSettings aSettings( pDlgEdControl->GetSettings() );
				StyleSettings aStyleSettings( aSettings.GetStyleSettings() );
				if(pShell->GetSbxControl()->ISA(VCSbxFixedText))
				{
					aStyleSettings.SetLabelTextColor( aForeCol );
				}
				else
				{
					aStyleSettings.SetButtonTextColor( aForeCol );
				}
				// Malte kann noch keine transparenten Fonts
				if(pShell->GetSbxControl()->ISA(VCSbxEdit))
				{
					aStyleSettings.SetFieldColor( aBackCol );
				}
				aSettings.SetStyleSettings( aStyleSettings );
				pDlgEdControl->SetSettings( aSettings );
				#endif
			}
			else
			{
				aFont = GetFont( pDlgEdControl, FALSE );
				aFont.SetFillColor( Color( COL_3DFACE ) );
			}
			#ifndef VCL
			aFont.SetTransparent( bTransparent );
			#else
			aFont.SetTransparent( TRUE );
			#endif
			pDlgEdControl->SetFont( aFont );
		}
	}
#endif
}

VCImpRealControl::VCImpRealControl( VCControl* pShell ) :
	VCImpControl( pShell ),
	pDlgEdControl(NULL)
#ifndef VCL
	,pCurControl(NULL)
#endif
{
}

VCImpRealControl::~VCImpRealControl()
{
	delete pDlgEdControl;
}

void VCImpRealControl::DeleteDlgEdControl()
{
	DELETEZ(pDlgEdControl);
}

void VCImpRealControl::Update( BOOL bWithItems, USHORT nWhich )
{
	if( bWithItems )
		UpdateFromItemSet( nWhich );
	VCContainer* pContainer = pShell->GetParent();
	if( pContainer && pContainer->IsA( TYPE( VCManager ) ) )
		((VCManager*)pContainer)->PaintControl( pShell );
}

#ifndef TF_SI_OFF50

Window* VCImpRealPushButton::CreateClass( Window* pParent )
{
	return new PushButton( pParent, 0 );
}

#endif

void VCImpRealPushButton::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME)
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pDlgEdControl->SetText( aCaption );
	}
}

VCImpRealPushButton::VCImpRealPushButton( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealPushButton::~VCImpRealPushButton()
{
}

Size VCImpRealPushButton::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}


#ifndef TF_SI_OFF50

Window* VCImpRealRadioButton::CreateClass( Window* pParent )
{
	WinBits eBits = 0;
	USHORT eAlign = (USHORT)((VCButtonAlignmentItem&)pShell->GetItemSet()->
							Get( VCATTR_BUTTONALIGNMENT )).GetValue();

	if( eAlign == VCBTNALIGN_RIGHT )
		eBits |= WB_LEFTLABEL;

	return new RadioButton( pParent, eBits );
}

#endif

void VCImpRealRadioButton::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME ||
		nWhich == VCATTR_BUTTONALIGNMENT )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pDlgEdControl->SetText( aCaption );
	}

	if( !nWhich || (nWhich==VCATTR_RADIOBUTTONVALUE) )
	{
		BOOL bCheck = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_RADIOBUTTONVALUE )).GetValue();
		((RadioButton*)pDlgEdControl)->Check( bCheck );
	}
}

VCImpRealRadioButton::VCImpRealRadioButton( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealRadioButton::~VCImpRealRadioButton()
{
}

Size VCImpRealRadioButton::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

#ifndef TF_SI_OFF50

Window* VCImpRealCheckBox::CreateClass( Window* pParent )
{
	USHORT eAlign = (USHORT)((VCButtonAlignmentItem&)
								pShell->GetItemSet()->
									Get( VCATTR_BUTTONALIGNMENT )).GetValue();
	WinBits eBits = 0;
	if( eAlign == VCBTNALIGN_RIGHT )
		eBits |= WB_LEFTLABEL;

	return new CheckBox( pParent, eBits );
}

#endif

void VCImpRealCheckBox::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME ||
		nWhich == VCATTR_BUTTONALIGNMENT )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pDlgEdControl->SetText( aCaption );
	}

	if( !nWhich || (nWhich==VCATTR_CHECKBOXVALUE) )
	{
		BOOL bCheck = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_CHECKBOXVALUE )).GetValue();
		((CheckBox*)pDlgEdControl)->Check( bCheck );
	}
}

VCImpRealCheckBox::VCImpRealCheckBox( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealCheckBox::~VCImpRealCheckBox()
{
}

Size VCImpRealCheckBox::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

#ifndef TF_SI_OFF50

Window* VCImpRealSpinButton::CreateClass( Window* pParent )
{
	return new SpinButton( pParent, 0 );
}

#endif

void VCImpRealSpinButton::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );
}

VCImpRealSpinButton::VCImpRealSpinButton( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealSpinButton::~VCImpRealSpinButton()
{
}

Size VCImpRealSpinButton::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

#ifndef TF_SI_OFF50

Window* VCImpRealFixedText::CreateClass( Window* pParent )
{
	WinBits eBits = 0;

	BOOL bBorder = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_BORDER )).GetValue();
	if( bBorder )
		eBits |= WB_BORDER;

	BOOL bWordWrap = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_WORDWRAP )).GetValue();
	if( bWordWrap )
		eBits |= WB_WORDBREAK;

	USHORT eAlign = (USHORT)((VCAlignmentItem&)pShell->GetItemSet()->
							Get( VCATTR_ALIGNMENT )).GetValue();
	switch( eAlign )
	{
		case VCALIGN_LEFT:  eBits |= WB_LEFT;   break;
		case VCALIGN_RIGHT: eBits |= WB_RIGHT;  break;
		case VCALIGN_CENTER:eBits |= WB_CENTER; break;
	}

	return new FixedText( pParent, eBits );
}

#endif

void VCImpRealFixedText::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME ||
		nWhich == VCATTR_BORDER || nWhich==VCATTR_WORDWRAP ||
		 nWhich == VCATTR_ALIGNMENT )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
		if( ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_USEMNEMONIC )).GetValue() )
			ConvertAmpersand( &aCaption );
		pDlgEdControl->SetText( aCaption );
	}
}

VCImpRealFixedText::VCImpRealFixedText( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealFixedText::~VCImpRealFixedText()
{
}

Size VCImpRealFixedText::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

#ifndef TF_SI_OFF50

Window* VCImpRealGroupBox::CreateClass( Window* pParent )
{
	return new GroupBox( pParent );
}

#endif

void VCImpRealGroupBox::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pDlgEdControl->SetText( aCaption );
	}
}

VCImpRealGroupBox::VCImpRealGroupBox( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealGroupBox::~VCImpRealGroupBox()
{
}

Size VCImpRealGroupBox::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

#ifndef TF_SI_OFF50

Window* VCImpRealListBox::CreateClass( Window* pParent )
{
	WinBits eBits = WB_BORDER;
	if( ((SfxBoolItem&)pShell->GetItemSet()->Get(VCATTR_SORTED)).GetValue() )
		eBits |= WB_SORT;

	USHORT eMulti = ((VCListBox*)pShell)->GetMultiSelect();
	if( eMulti == VCMULTI_SINGLE )
		return new ListBox( pParent, eBits ); // WB_BORDER ?

	if( eMulti == VCMULTI_SIMPLEMULTI )
		eBits |= WB_SIMPLEMODE;

	return new MultiListBox( pParent, eBits );
}

#endif

void VCImpRealListBox::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME
		|| nWhich == VCATTR_MULTISELECT || nWhich == VCATTR_SORTED )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	// Eintraege setzen
	if( !nWhich || (nWhich==VCATTR_LIST) )
	{
#ifdef TF_SI_OFF50
		((VCSVListBox*)pDlgEdControl)->Clear();
#else
		((ListBox*)pDlgEdControl)->Clear();
#endif
		SfxStringListItem& rItem = (SfxStringListItem&)pShell->GetItemSet()->Get( VCATTR_LIST );
		List* pList = rItem.GetList();
		String* pStr = (String*)pList->First();
		INT16 nNewIndex = -1;
		while( pStr )
		{
			nNewIndex = (INT16)(((ListBox*)pDlgEdControl)->InsertEntry( *pStr ));
			pStr = (String*)pList->Next();
		}
		((VCListBox*)pShell)->SetNewIndex( nNewIndex );
	}

	// ItemData mit Liste synchronisieren
	if( !nWhich || (nWhich==VCATTR_LIST) || (nWhich==VCATTR_ITEMDATA) )
	{
		VCIntegerListItem* pItemData = (VCIntegerListItem*)pShell->GetItemSet()->
										Get( VCATTR_ITEMDATA ).Clone();
		SfxStringListItem& rItem = (SfxStringListItem&)pShell->GetItemSet()->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		pItemData->SetEntryCount( (USHORT)pList->Count() );
		pShell->GetItemSet()->Put( *pItemData );
		delete pItemData;
	}
}

VCImpRealListBox::VCImpRealListBox( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealListBox::~VCImpRealListBox()
{
}

Size VCImpRealListBox::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

USHORT VCImpRealListBox::InsertEntry( const String& rStr, ULONG nPos )
{
	DBG_WARNING("InsertEntry at unloaded VCImpRealListBox (autoload failed)");
	return USHRT_MAX;
}

void VCImpRealListBox::RemoveEntry( ULONG nPos )
{
	DBG_WARNING("RemoveEntry at unloaded VCImpRealListBox (autoload failed)");
}

void VCImpRealListBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	DBG_WARNING("ReplaceEntry at unloaded VCImpRealListBox (autoload failed)");
}

String VCImpRealListBox::GetSelectEntry() const
{
	DBG_WARNING("GetSelectEntry at unloaded VCImpRealListBox (autoload failed)");
	return String();
}

ULONG VCImpRealListBox::GetSelectEntryPos() const
{
	DBG_WARNING("GetSelectEntryPos at unloaded VCImpRealListBox (autoload failed)");
	ULONG nSelect = 0xFFFFFFFF;
	return nSelect;
}

void VCImpRealListBox::SelectEntryPos( ULONG nPos, BOOL bSelect )
{
	DBG_WARNING("SelectEntryPos at unloaded VCImpRealListBox (autoload failed)");
}

BOOL VCImpRealListBox::IsEntrySelected( ULONG nPos )
{
	DBG_WARNING("IsEntrySelected at unloaded VCImpRealListBox (autoload failed)");
	return FALSE;
}

void VCImpRealListBox::Clear()
{
	DBG_WARNING("Clear at unloaded VCImpRealListBox (autoload failed)");
}

#ifndef TF_SI_OFF50

Window* VCImpRealComboBox::CreateClass( Window* pParent )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();
	USHORT eStyle = (USHORT)((VCComboStyleItem&)
			pItemSet->Get( VCATTR_COMBOSTYLE )).GetValue();

	WinBits eBits = 0;
	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_SORTED )).GetValue() )
		eBits |= WB_SORT;

	if( eStyle == VCCOMBO_DDLIST )
		return new ListBox( pParent, eBits | WB_DROPDOWN );

	if( eStyle == VCCOMBO_COMBO )
		return new ComboBox( pParent, eBits );

	return new ComboBox( pParent, eBits | WB_DROPDOWN );
}

#endif

void VCImpRealComboBox::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_FONTNAME ||
		nWhich == VCATTR_MULTISELECT || nWhich == VCATTR_SORTED ||
		nWhich == VCATTR_COMBOSTYLE )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	SfxItemSet* pItemSet = pShell->GetItemSet();

	VCImpRealControl::UpdateFromItemSet( nWhich );

	USHORT eStyle = (USHORT)((VCComboStyleItem&)
				pItemSet->Get( VCATTR_COMBOSTYLE )).GetValue();

	// Eintraege setzen
	if( !nWhich || (nWhich==VCATTR_LIST) )
	{

		if( eStyle == (USHORT)VCCOMBO_DDLIST )
			((VCSVListBox*)pDlgEdControl)->Clear();
		else
			((ComboBox*)pDlgEdControl)->Clear();

		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		String* pStr = (String*)pList->First();
		INT16 nNewIndex = -1;
		while( pStr )
		{
			if( eStyle == (USHORT)VCCOMBO_DDLIST )
				nNewIndex = (INT16)(((ListBox*)pDlgEdControl)->InsertEntry( *pStr ));
			else
				nNewIndex = (INT16)(((ComboBox*)pDlgEdControl)->InsertEntry( *pStr ));
			pStr = (String*)pList->Next();
		}
		((VCComboBox*)pShell)->SetNewIndex( nNewIndex );
	}

	// Text
	if( !nWhich || (nWhich==VCATTR_TEXT) )
	{
		String aText = ((SfxStringItem&)pItemSet->Get( VCATTR_TEXT )).GetValue();
		if( eStyle != (USHORT)VCCOMBO_DDLIST )
			((ComboBox*)pDlgEdControl)->SetText( aText );
	}

	// ItemData mit Liste synchronisieren
	if( !nWhich || (nWhich==VCATTR_LIST) || (nWhich==VCATTR_ITEMDATA) )
	{
		VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->
										Get( VCATTR_ITEMDATA ).Clone();
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		pItemData->SetEntryCount( (USHORT)pList->Count() );
		pItemSet->Put( *pItemData );
		delete pItemData;
	}

	if( IsSVLook() )
	{
		switch( nWhich )
		{
			case 0:
			case VCATTR_BACKCOLOR:
			case VCATTR_FORECOLOR:
			case VCATTR_BACKSTYLE:
			case VCATTR_FONTNAME:
			case VCATTR_FONTSIZE:
			case VCATTR_FONTBOLD:
			case VCATTR_FONTITALIC:
			case VCATTR_FONTSTRIKETHRU:
			case VCATTR_FONTUNDERLINE:
			{
				Font aFont = pDlgEdControl->GetFont();
				aFont.SetFillColor( Application::GetSettings().GetStyleSettings().GetWorkspaceColor() );
				pDlgEdControl->SetFont( aFont );
			}
		}
	}
}

VCImpRealComboBox::VCImpRealComboBox( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealComboBox::~VCImpRealComboBox()
{
}

Size VCImpRealComboBox::GetMinSizePixel() const
{
	USHORT eStyle = (USHORT)((VCComboStyleItem&)
			pShell->GetItemSet()->Get( VCATTR_COMBOSTYLE )).GetValue();
	if( eStyle == (USHORT)VCCOMBO_COMBO )
		return VCImpControl::GetMinSizePixel();
	if( !pDlgEdControl )
	{
		DBG_WARNING("GetMinSizePixel: SVControl not set");
		return VCImpControl::GetMinSizePixel();
	}
	else
	{
		Size aSize = pDlgEdControl->GetSizePixel();
		//!!!OV da StarView sich fuer die Hoehe nicht interessiert,
		// die vom DlgEditor vorgegebene Mindesthoehe benutzen
		// aSize.Width() = 0;
		aSize.Width() = VCImpControl::GetMinSizePixel().Width();
		return aSize;
	}
}

String VCImpRealComboBox::GetText() const
{
	DBG_WARNING("GetText at unloaded VCImpRealComboBox (autoload failed)");
	return String();
}

void VCImpRealComboBox::SetText( const String& rText )
{
	DBG_WARNING("SetText at unloaded VCImpRealComboBox (autoload failed)");
}

USHORT VCImpRealComboBox::InsertEntry( const String& rStr, ULONG nPos )
{
	USHORT nNewIndex = USHRT_MAX;
	DBG_WARNING("InsertEntry at unloaded VCImpRealComboBox (autoload failed)");
	return nNewIndex;
}

void VCImpRealComboBox::RemoveEntry( ULONG nPos )
{
	DBG_WARNING("RemoveEntry at unloaded VCImpRealComboBox (autoload failed)");
}

void VCImpRealComboBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	DBG_WARNING("ReplaceEntry at unloaded VCImpRealComboBox (autoload failed)");
}

String VCImpRealComboBox::GetSelectEntry() const
{
	DBG_WARNING("GetSelectEntry at unloaded VCImpRealComboBox (autoload failed)");
	return String();
}

void VCImpRealComboBox::Clear()
{
	DBG_WARNING("Clear at unloaded VCImpRealComboBox (autoload failed)");
}

#ifndef TF_SI_OFF50

Window* VCImpRealEdit::CreateClass( Window* pParent )
{
	SfxItemSet* pItemSet = pShell->GetItemSet();
	WinBits eBits = 0;

	BOOL bBorder = ((SfxBoolItem&)pItemSet->Get( VCATTR_BORDER )).GetValue();
	if( bBorder )
		eBits = WB_BORDER;

	USHORT eAlign = (USHORT)((VCAlignmentItem&)pItemSet->
							Get( VCATTR_ALIGNMENT )).GetValue();
	switch( eAlign )
	{
		case VCALIGN_LEFT:  eBits |= WB_LEFT;   break;
		case VCALIGN_RIGHT: eBits |= WB_RIGHT;  break;
		case VCALIGN_CENTER:eBits |= WB_CENTER; break;
	}

	if( ((SfxStringItem&)pItemSet->Get( VCATTR_PASSWORDCHAR )).GetValue().Len() )
		eBits |= WB_PASSWORD;

	if( ((SfxBoolItem&)pItemSet->Get( VCATTR_MULTILINE )).GetValue() )
	{
		nStyle |= WB_IGNORETAB;
		if( ((SfxBoolItem&)pItemSet->Get( VCATTR_SCROLLBARS )).GetValue() )
		{
			eBits |= WB_HSCROLL;
			eBits |= WB_VSCROLL;
		}
		return new MultiLineEdit( pParent, eBits );
	}
	return new Edit( pParent, eBits );
}

#endif

void VCImpRealEdit::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	switch( nWhich )
	{
		case VCATTR_AUTO3D:
		case VCATTR_FONTNAME:
		case VCATTR_BORDER:
		case VCATTR_MULTILINE:
		case VCATTR_PASSWORDCHAR:
		case VCATTR_ALIGNMENT:
		case VCATTR_TABSTOP:
		case VCATTR_READONLY:
		case VCATTR_WORDWRAP:
		case VCATTR_SCROLLBARS:
		{
			DELETEZ(pDlgEdControl);
			return;
		}
	}
	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_TEXT) )
	{
		String aText = ((SfxStringItem&)pShell->GetItemSet()->Get( VCATTR_TEXT )).GetValue();
		((Edit*)pDlgEdControl)->SetText( aText );
	}

	if( !nWhich || (nWhich==VCATTR_MAXLENGTH) )
	{
		USHORT nMaxLen = (USHORT)((SfxInt32Item&)pShell->GetItemSet()->
							Get( VCATTR_MAXLENGTH )).GetValue();
		if( nMaxLen )
			((Edit*)pDlgEdControl)->SetMaxTextLen( nMaxLen );
		else
			((Edit*)pDlgEdControl)->SetMaxTextLen();
	}

	if( IsSVLook() )
	{
		switch( nWhich )
		{
			case 0:
			case VCATTR_BACKCOLOR:
			case VCATTR_FORECOLOR:
			case VCATTR_BACKSTYLE:
			case VCATTR_FONTNAME:
			case VCATTR_FONTSIZE:
			case VCATTR_FONTBOLD:
			case VCATTR_FONTITALIC:
			case VCATTR_FONTSTRIKETHRU:
			case VCATTR_FONTUNDERLINE:
			{
				Font aFont = pDlgEdControl->GetFont();
				aFont.SetFillColor( Application::GetSettings().GetStyleSettings().GetWorkspaceColor() );
				pDlgEdControl->SetFont( aFont );
			}
		}
	}
}

VCImpRealEdit::VCImpRealEdit( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealEdit::~VCImpRealEdit()
{
}

Size VCImpRealEdit::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

VCImpRealScrollBar::VCImpRealScrollBar( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
}

VCImpRealScrollBar::~VCImpRealScrollBar()
{
}

#ifndef TF_SI_OFF50

Window* VCImpRealScrollBar::CreateClass( Window* pParent )
{
	WinBits eBits = WB_VSCROLL;
	if( bHorz )
		eBits = WB_HSCROLL;
	return new ScrollBar( pParent, eBits );
}

#endif

void VCImpRealScrollBar::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich == VCATTR_MIN) || (nWhich == VCATTR_MAX) )
	{
		long nMin = ((SfxInt32Item&)pShell->GetItemSet()->
						Get( VCATTR_MIN )).GetValue();
		long nMax = ((SfxInt32Item&)pShell->GetItemSet()->
						Get( VCATTR_MAX )).GetValue();
#ifndef VCL
		((ScrollBar*)pDlgEdControl)->SetRange( Range( (short)nMin, (short)nMax ) );
#else
		((ScrollBar*)pDlgEdControl)->SetRangeMax( nMax - nMin );
#endif
	}
	if( !nWhich || (nWhich == VCATTR_SCROLLBARVALUE) )
	{
		long nVal = ((SfxInt32Item&)pShell->GetItemSet()->
						Get( VCATTR_SCROLLBARVALUE )).GetValue();

#ifndef VCL
		((ScrollBar*)pDlgEdControl)->SetThumbPos( (short)nVal );
#else
		long nMin = ((SfxInt32Item&)pShell->GetItemSet()->Get(VCATTR_MIN)).GetValue();
		((ScrollBar*)pDlgEdControl)->SetThumbPos( nVal - nMin );
#endif
	}
}

VCImpRealHScrollBar::VCImpRealHScrollBar( VCControl* pShell ) :
	VCImpRealScrollBar( pShell )
{
	bHorz = TRUE;
}

VCImpRealHScrollBar::~VCImpRealHScrollBar()
{
}

Size VCImpRealHScrollBar::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

VCImpRealVScrollBar::VCImpRealVScrollBar( VCControl* pShell ) :
	VCImpRealScrollBar( pShell )
{
	bHorz = FALSE;
}

VCImpRealVScrollBar::~VCImpRealVScrollBar()
{
}

Size VCImpRealVScrollBar::GetMinSizePixel() const
{
	Size aTempSize( 10, 10 );
	return aTempSize;
}

#ifndef TF_SI_OFF50

Window* VCImpRealPreview::CreateClass( Window* pParent )
{
	BOOL bBorder = ((SfxBoolItem&)pShell->GetItemSet()->Get( VCATTR_BORDER )).GetValue();
	WinBits eBits = 0;
	if( bBorder )
		eBits |= WB_BORDER;
	return new Control( pParent, eBits );
}

#endif

void VCImpRealPreview::UpdateFromItemSet( USHORT nWhich )
{
	if( !pDlgEdControl )
		return;

	if( nWhich == VCATTR_AUTO3D || nWhich == VCATTR_BORDER )
	{
		DELETEZ(pDlgEdControl);
		return;
	}

	VCImpRealControl::UpdateFromItemSet( nWhich );

	if( !nWhich || (nWhich==VCATTR_BACKCOLOR) )
	{
		Color aBackCol = ((SvxColorItem&)pShell->GetItemSet()->Get( VCATTR_BACKCOLOR )).GetValue();
		pDlgEdControl->SetBackground( Wallpaper( aBackCol ) );
	}
}

VCImpRealPreview::VCImpRealPreview( VCControl* pShell ) :
	VCImpRealControl( pShell )
{
	UpdateFromItemSet();
}

VCImpRealPreview::~VCImpRealPreview()
{
}

Size VCImpRealPreview::GetMinSizePixel() const
{
	return VCImpControl::GetMinSizePixel();
}

void VCImpRealEdit::Focus()
{
	DBG_ERROR("VCImpRealEdit::Focus() not implemented");
}

void VCImpRealEdit::Blur()
{
	DBG_ERROR("VCImpRealEdit::Blur() not implemented");
}

BOOL VCImpRealEdit::IsModified() const
{
	if( !pDlgEdControl )
		return FALSE;
	return ((Edit*)pDlgEdControl)->IsModified();
}

void VCImpRealEdit::SetModifyFlag( BOOL bModify )
{
	DBG_WARNING("SetModifyFlag at unloaded VCImpRealEdit (autoload failed)");
}

#ifdef VCL

void VCImpRealControl::Paint( OutputDevice* pOut )
{
if( pOut->GetOutDevType() != OUTDEV_WINDOW )
		return;
	Window* pOutWin = (Window*)pOut;
	Control* pCtrl = GetDlgEdControl( pOutWin );
	Rectangle aRect( pShell->GetPos(), pShell->GetSize() );
	aRect += pShell->GetDrawOfs();
	aRect = pOutWin->LogicToPixel( aRect );
	pCtrl->SetPosSizePixel( aRect.TopLeft(), aRect.GetSize() );
	pCtrl->Show();
	pCtrl->Update();
	pCtrl->SetParentUpdateMode( FALSE );
	pCtrl->Hide();
	pCtrl->SetParentUpdateMode( TRUE );
}

#endif


#pragma SEG_EOFMODULE


