/*************************************************************************
 *
 *  $RCSfile: vcont.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif

#pragma hdrstop

#include "vcrdbttn.hxx"
#include "vcgrpbox.hxx"
#include "vcont.hxx"
#include "vctrls.hxx"
#include "vcattr.hxx"
#include "formdlg.hrc"
#include "vcattrid.hrc"
#include "vcform.hxx"
#include "vcictrls.hxx"
#include "siresid.hxx"
#include "vcsbx.hxx"
#include "sidll.hxx"

TYPEINIT0( VCContainer );

BOOL VCContainer::HasName( const String& rName ) const
{
	VCControl* pChild = (VCControl*)((VCContainer*)this)->aChildList.First();
	while( pChild )
	{
		if( pChild->GetName() == rName )
			return TRUE;

		pChild = (VCControl*)((VCContainer*)this)->aChildList.Next();
	}

	return FALSE;
}

String VCContainer::GetUniqueName( VCControl* pChild )
{
	SfxItemSet* pItemSet = pChild->GetItemSet();

	USHORT n = 0;
	String aClassName = pChild->GetClassName();
	String aName;
	do
	{
		aName = aClassName;
		aName.Append( UniString::CreateFromInt32( ++n ) );
	}while( HasName( aName ) );

	return aName;
}

VCControl* VCContainer::GetGroupBox( VCControl* pActControl )
{
	ULONG nPos = aChildList.GetCurPos();

	// Ist das uebergebene Control in einer GroupBox ?
	VCControl* pGroupBox = NULL;
	VCControl* pControl = (VCControl*)aChildList.First();

	Rectangle  aActRect( pActControl->GetPos(), pActControl->GetSize() );
	while( pControl )
	{
		if( pControl->Type() == TYPE( VCGroupBox ) )
		{
			Rectangle aGroupRect( pControl->GetPos(), pControl->GetSize() );
			if( aGroupRect.IsInside( aActRect ) )
			{
				pGroupBox = pControl;
				break;
			}
		}
		pControl = (VCControl*)aChildList.Next();
	}

	aChildList.Seek( nPos );
	return pGroupBox;
}

void VCContainer::UncheckRadios( VCRadioButton* pActRadio )
{
	ULONG nActPos = aChildList.GetPos( pActRadio );
	if( nActPos == LIST_ENTRY_NOTFOUND )
		return;

	VCControl* pActGroup = GetGroupBox( pActRadio );

	if( pActGroup )
	{
		// Gruppenzugehoerigkeit ueber Frame-Control
		Rectangle aGroupRect( pActGroup->GetPos(), pActGroup->GetSize() );
		VCControl* pControl = (VCControl*)aChildList.First();
		while( pControl )
		{
			if( (pControl != pActRadio) &&
				(pControl->Type() == TYPE( VCRadioButton )) )
			{
				Rectangle aActRect( pControl->GetPos(), pControl->GetSize() );
				if( ((VCRadioButton*)pControl)->IsChecked() &&
					aGroupRect.IsInside( aActRect ) 		   )
						((VCRadioButton*)pControl)->Check( FALSE );
			}

			pControl = (VCControl*)aChildList.Next();
		}
	}
	else if( pActRadio->GetName().Len() )	// AB 10.3.97, nur wenn Name vorhanden
	{
		// Gruppenzugehoerigkeit ueber Namen des Controls (HTML-Import)

		/*
		VCControl* pControl = (VCControl*)aChildList.First();
		while( pControl )
		{
			if( (pControl != pActRadio) &&
				(pControl->Type() == TYPE( VCRadioButton )) )
			{
				if( ((VCRadioButton*)pControl)->IsChecked() &&
					(pActGroup == GetGroupBox( pControl ))		)
						((VCRadioButton*)pControl)->Check( FALSE );
			}

			pControl = (VCControl*)aChildList.Next();
		}
		*/
		String aActName = pActRadio->GetName();
		VCControl* pControl = (VCControl*)aChildList.First();
		while( pControl )
		{
			if( (pControl != pActRadio) &&
				(pControl->Type() == TYPE( VCRadioButton )) &&
				(pControl->GetName() == aActName))
			{
				if( ((VCRadioButton*)pControl)->IsChecked() &&
					(pActGroup == GetGroupBox( pControl ))		)
						((VCRadioButton*)pControl)->Check( FALSE );
			}

			pControl = (VCControl*)aChildList.Next();
		}
	}
}

void VCContainer::UncheckButFirstRadios( VCGroupBox* pGroup )
{
	// Ersten gecheckten der GroupBox suchen
	VCControl* pFirstRadio = NULL;

	Rectangle aGroupRect( pGroup->GetPos(), pGroup->GetSize() );

	VCControl* pControl = (VCControl*)aChildList.First();
	while( pControl )
	{
		if( pControl->Type() == TYPE( VCRadioButton ) )
		{
			Rectangle aActRect( pControl->GetPos(), pControl->GetSize() );
			if( aGroupRect.IsInside( aActRect ) &&
				((VCRadioButton*)pControl)->IsChecked() )
			{
				pFirstRadio = pControl;
				break;
			}
		}

		pControl = (VCControl*)aChildList.Next();
	}

	// Keine Radios in der Gruppe, alse nix zu tun
	if( !pFirstRadio )
		return;

	// Weitersuchen und ausschalten
	pControl = (VCControl*)aChildList.Next();
	while( pControl )
	{
		if( pControl->Type() == TYPE( VCRadioButton ) )
		{
			Rectangle aActRect( pControl->GetPos(), pControl->GetSize() );
			if( ((VCRadioButton*)pControl)->IsChecked() &&
				aGroupRect.IsInside( aActRect ) 		   )
					((VCRadioButton*)pControl)->Check( FALSE );
		}
		pControl = (VCControl*)aChildList.Next();
	}
}

VCContainer::VCContainer() :
	pWindow(NULL),
	nFlags(0)
{
}

VCContainer::~VCContainer()
{
	// Die folgende Schleife sieht nicht grade optimal aus
	// mnuss aber so bleiben, da SetParent() ein RemoveChild ausloest,
	// was wiederum den aktuellen Eintrag in der Liste entfernt
	while( aChildList.First() )
	{
		VCControl* pCtrl = (VCControl*)aChildList.First();
		pCtrl->SetParent( NULL );
	}

	if( pWindow )
		delete pWindow;
}

void VCContainer::InsertChild( VCControl* pChild, ULONG nPos )
{
	SfxItemSet* pItemSet = pChild->GetItemSet();

	if( nFlags & VCCONT_IMPORTING )
	{
		// "Hochgeschwindigkeitsimport"
		if( !pChild->GetName().Len() )
		{
			String aUniqueName = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Control" ) );
			aUniqueName.Append( UniString::CreateFromInt32( nUniqueId ) );
			nUniqueId++;
			// Namen vergeben
			pChild->SetName( aUniqueName );
			pChild->SetCaption( aUniqueName );
		}
	}
	else
	{
		if( pChild->ISA(VCRadioButton) )
		{
			pChild->SetName( GetUniqueName( pChild ) );
			if( !pChild->GetCaption().Len() )
				pChild->SetCaption( pChild->GetName() );
		}
		else if( !pChild->GetName().Len() || HasName( pChild->GetName() ) )
		{
			// Namen vergeben
			pChild->SetName( GetUniqueName( pChild ) );
			if( !pChild->GetCaption().Len() )
				pChild->SetCaption( pChild->GetName() );
		}
	}

	aChildList.Insert( pChild, nPos );

	ULONG nTabPos = nPos;
	if( nTabPos > (aChildList.Count()-1) )
		nTabPos = aChildList.Count()-1;
	pChild->SetTabPos( nTabPos );
}

void VCContainer::RemoveChild( VCControl* pChild )
{
	aChildList.Remove( pChild );
	UpdateAllTabPos();
}

void VCContainer::MoveChild( VCControl* pChild, ULONG nNewPos )
{
	VCControl* p = (VCControl*)aChildList.Remove( (void*)pChild );
	aChildList.Insert( p, nNewPos );
	UpdateAllTabPos();
}

void VCContainer::UpdateAllTabPos()
{
	ULONG nCount = aChildList.Count();
	if( nCount )
	{
		List aList( (USHORT)nCount );
		ULONG nCur;
		for( nCur=0; nCur < nCount; nCur++ )
			aList.Insert( (void*)aChildList.GetObject( nCur ), LIST_APPEND );
		// Bubble sort
		BOOL bExch = 1;
		while( bExch )
		{
			bExch = FALSE;
			for( nCur = 0; nCur < nCount-1; nCur++ )
			{
				VCControl* pCur = (VCControl*)aList.GetObject( nCur );
				VCControl* pNext = (VCControl*)aList.GetObject( nCur+1 );
				if( pCur->GetTabPos() > pNext->GetTabPos() )
				{
					bExch = TRUE;
					aList.Replace( pCur, nCur+1 );
					aList.Replace( pNext, nCur );
				}
			}
		}
		aChildList.Clear();
		for( nCur=0; nCur < nCount; nCur++ )
		{
			VCControl* pCur = (VCControl*)aList.GetObject( nCur );
			pCur->SetTabPos( nCur );
			aChildList.Insert( (void*)pCur, LIST_APPEND );
		}
	}
}

ULONG VCContainer::GetChildPos( VCControl* pChild ) const
{
	return aChildList.GetPos( pChild );
}

VCControl* VCContainer::GetChildByPos( ULONG nPos )
{
	return (VCControl*)aChildList.GetObject( nPos );
}

VCControl* VCContainer::GetChildByName( const String& rName, BOOL bCase )
{
	VCControl* pChild = (VCControl*)aChildList.First();
	while( pChild )
	{
		if( bCase )
		{
			if( pChild->GetName() == rName )
				return pChild;
		}
		else
		if( rName.Equals( pChild->GetName() ) )
			return pChild;

		pChild = (VCControl*)aChildList.Next();
	}

	return NULL;
}

Window* VCContainer::GetCtrlParent()
{
	if( !pWindow )
	{
		WinBits nWinBits = WB_3DLOOK;
		VCControl* pCtrl = (VCControl*)aChildList.First();
		if( pCtrl )
		{
			VCSbxControl* pSbxCtrl = pCtrl->GetSbxControl();
			if( pSbxCtrl && pSbxCtrl->GetParent()
				&& pSbxCtrl->GetParent()->ISA(VCSbxDialog) )
			{
				if( !((VCSbxDialog*)pSbxCtrl->GetParent())->IsSVLook() )
					nWinBits = 0;
			}
		}
		pWindow = new WorkWindow( NULL, nWinBits );
	}

	return pWindow;
}

void VCContainer::SetSVLook( BOOL bSVLook )
{
	if( pWindow )
		return;

	BOOL bHasOldWin = pWindow ? TRUE : FALSE;

	VCControl* pChild = 0;
	if( bHasOldWin )
	{
		pChild = (VCControl*)aChildList.First();
		while( pChild )
		{
			pChild->Deactivate();
			pChild = (VCControl*)aChildList.Next();
		}
	}

	delete pWindow;
	WinBits nSVLook = bSVLook ? WB_3DLOOK : 0;
	pWindow = new WorkWindow( NULL, nSVLook );

	// Childlist clonen, da durch ReActivate (->UpdateItem) die
	// Reihenfolge der Controls geaendert werden kann.
	if( bHasOldWin )
	{
		List aList;
		pChild = (VCControl*)aChildList.First();
		while( pChild )
		{
			aList.Insert(pChild, LIST_APPEND );
			pChild = (VCControl*)aChildList.Next();
		}

		pChild = (VCControl*)aList.First();
		while( pChild )
		{
			pChild->ReActivate();
			pChild = (VCControl*)aList.Next();
		}
	}
}

void VCContainer::SetCurrentLinkData( const String& rLinkData )
{
	aLinkData = rLinkData;
}

String VCContainer::GetLinkData( const String& rLinkName )
{
	String aTempStr;
	if( aGetLinkDataHdlLink.IsSet() )
	{
		aLinkName = rLinkName;
		aGetLinkDataHdlLink.Call( this );
		aTempStr = aLinkData;
		aLinkName = String();
		aLinkData = String();
	}
	return aTempStr;
}

// aktualisiert applikationsspezifischen Link
void VCContainer::SetLinkData( const String& rLinkName,
								 const String& rLinkData )
{
	String aTempStr;
	if( aSetLinkDataHdlLink.IsSet() )
	{
		aLinkName = rLinkName;
		aLinkData = rLinkData;
		aSetLinkDataHdlLink.Call( this );
		aLinkName = String();
		aLinkData = String();

		// WARUM? Und warum mit leeren Strings? (Bugid 45359)
		// UpdateLinkData( rLinkName, rLinkData );
	}
}

// aktualisiert SI-Controls aus den Links; wird von App gerufen
void VCContainer::UpdateLinkData( const String& rLinkName,
								  const String& rLinkData )
{
	// Alle Control benachrichtigen
	BOOL bOld = (nFlags & VCCONT_UPDATING_LINKS) ? TRUE : FALSE;
	nFlags |= VCCONT_UPDATING_LINKS;
	VCControl* pChild = (VCControl*)aChildList.First();
	while( pChild )
	{
		pChild->UpdateLinkData( rLinkName, rLinkData );
		pChild = (VCControl*)aChildList.Next();
	}
	if( !bOld )
		nFlags &= ~VCCONT_UPDATING_LINKS;
}

TYPEINIT1( VCManager, VCContainer );

VCManager::VCManager() :
	pCaptureChild(NULL),
	pWinList(NULL),
	bInPaint(FALSE)
{
	String aStdFormName( SiResId(STR_STDFORM));
	String aEmptyStr;
	InsertForm( aEmptyStr, FORMMETH_GET, aEmptyStr, &aStdFormName );
}

VCManager::~VCManager()
{
	if( pWinList )
		delete pWinList;
	ULONG nCount = aFormList.Count();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
		delete (VCForm*)aFormList.GetObject(nCur);
	aFormList.Clear(); // sic! (wg. VCControl::SetParent in ::~VCContainer
}

void VCManager::PaintControl( VCControl* pCtrl, BOOL bPaintNow,
							  Window* pNotDrawWin )
{
	if( !pWinList || !pWinList->Count() )
		return;

	Window* pWin = (Window*)pWinList->First();
	Rectangle aRect( pCtrl->GetPos(), pCtrl->GetSize() );
	aRect = pWin->LogicToPixel( aRect, MapMode( MAP_TWIP ) );
	aRect = pWin->PixelToLogic( aRect, MapMode( pWin->GetMapMode().GetMapUnit() ) );
	while( pWin )
	{
		if( pWin != pNotDrawWin )
		{
			if( !bPaintNow )
				pWin->Invalidate( aRect );
			else
				pCtrl->Paint( pWin, Rectangle() );
		}

		pWin = (Window*)pWinList->Next();
	}
}

void VCManager::Paint( Window* pWindow, const Rectangle& rRect )
{
	if( bInPaint )
		return;

	bInPaint = TRUE;

	pWindow->Push();

	if( (VCControl*)aChildList.Count() )
	{
		VCControl* pControl = (VCControl*)aChildList.First();
		while( pControl )
		{
			Rectangle aBoundRect( pControl->GetPos(), pControl->GetSize() );
			if( aBoundRect.IsOver( rRect ) &&
				pControl->IsVisible() )
				pControl->Paint( pWindow, rRect );

			pControl = (VCControl*)aChildList.Next();
		}
	}
	pWindow->Pop();
	bInPaint = FALSE;
}

void VCManager::MouseButtonDown( Window* pWindow, const MouseEvent& rMEvt )
{
	long nTol = pWindow->PixelToLogic( Size( 3, 0 ) ).Width();
	pCaptureChild = 0;
	VCControl* pControl = (VCControl*)aChildList.First();
	while( pControl )
	{
		Point aPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
		aPos = pWindow->LogicToPixel( aPos, MapMode( pWindow->GetMapMode().GetMapUnit() ) );
		aPos = pWindow->PixelToLogic( aPos, MapMode( MAP_TWIP ) );
		if( pControl->IsActionHit( aPos, nTol ) &&
			pControl->IsVisible() &&
			pControl->IsEnabled()	 )
		{
			MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
							 rMEvt.GetButtons(), rMEvt.GetModifier() );
			pControl->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );
			pWindow->CaptureMouse();
			pCaptureChild = pControl;
			SiDLL::SetCurControl( pControl );
			pControl->MouseButtonDown( pWindow, aEvt );
			if( SiDLL::IsCurControlDeleted())
			{
				return;
			}
			SiDLL::SetCurControl( 0 );
			pControl->GetImpControl()->SetActMouseEvent( 0 );;
			return;
		}

		pControl = (VCControl*)aChildList.Next();
	}
}

void VCManager::MouseButtonDown( Window* pWindow, VCControl* pControl, const MouseEvent& rMEvt )
{
	Point aPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
	aPos = pWindow->LogicToPixel( aPos, MapMode( pWindow->GetMapMode().GetMapUnit() ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( MAP_TWIP ) );
	pCaptureChild = 0;
	if( pControl->IsVisible() )
	{
		pWindow->CaptureMouse();
		pCaptureChild = pControl;
		if( pControl->IsEnabled() )
		{
			MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
							 rMEvt.GetButtons(), rMEvt.GetModifier() );
			pControl->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );

			SiDLL::SetCurControl( pControl );
			pControl->MouseButtonDown( pWindow, aEvt );
			if( SiDLL::IsCurControlDeleted())
				return;
			SiDLL::SetCurControl( 0 );

			pControl->GetImpControl()->SetActMouseEvent( 0 );
		}
	}
}

void VCManager::MouseButtonUp( Window* pWindow, const MouseEvent& rMEvt )
{
	// beim Verschieben per D&D hakelt es sonst
	if( pCaptureChild && !pCaptureChild->GetSbxControl()->GetParent() )
		pCaptureChild = 0;

	Point aPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
	aPos = pWindow->LogicToPixel( aPos, MapMode( pWindow->GetMapMode().GetMapUnit() ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( MAP_TWIP ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
						rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pCaptureChild )
	{
		pWindow->ReleaseMouse();
		if( pCaptureChild->IsEnabled() )
		{
			pCaptureChild->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );

			SiDLL::SetCurControl( pCaptureChild );
			pCaptureChild->MouseButtonUp( pWindow, aEvt );
			if( SiDLL::IsCurControlDeleted())
				return;
			SiDLL::SetCurControl( 0 );
			// ST: 40009
			if ( pCaptureChild )
				pCaptureChild->GetImpControl()->SetActMouseEvent( 0 );
		}
		pCaptureChild = NULL;
		return;
	}

	long nTol = pWindow->PixelToLogic( Size( 3, 0 ) ).Width();

	VCControl* pControl = (VCControl*)aChildList.First();
	while( pControl )
	{
		if( pControl->IsActionHit( aPos, nTol ) &&
			pControl->IsVisible() &&
			pControl->IsEnabled()	 )
		{
			pControl->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );
			pControl->MouseButtonUp( pWindow, aEvt );
			pControl->GetImpControl()->SetActMouseEvent( 0 );
			return;
		}
		pControl = (VCControl*)aChildList.Next();
	}
}

void VCManager::MouseMove( Window* pWindow, const MouseEvent& rMEvt )
{
	// beim Verschieben per D&D hakelt es sonst
	if( pCaptureChild && !pCaptureChild->GetSbxControl()->GetParent() )
		pCaptureChild = 0;

	Point aPos = pWindow->PixelToLogic( rMEvt.GetPosPixel() );
	aPos = pWindow->LogicToPixel( aPos, MapMode( pWindow->GetMapMode().GetMapUnit() ) );
	aPos = pWindow->PixelToLogic( aPos, MapMode( MAP_TWIP ) );

	MouseEvent aEvt( aPos, rMEvt.GetClicks(), rMEvt.GetMode(),
						rMEvt.GetButtons(), rMEvt.GetModifier() );

	if( pCaptureChild && pCaptureChild->IsEnabled() )
	{
		pCaptureChild->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );
		pCaptureChild->MouseMove( pWindow, aEvt );
		// pCaptureChild kann 0 sein, falls ein MouseMove-Handler die
		// Kontrolle abgibt (Reschedule, in Basic: Wait). In diesem Fall
		// kann innerhalb des Events ein MouseButtonUp zuschlagen, in dessen
		// Handler pCaptureChild auf 0 gesetzt wird.
		if( pCaptureChild )
			pCaptureChild->GetImpControl()->SetActMouseEvent( 0 );
		return;
	}

	long nTol = pWindow->PixelToLogic( Size( 3, 0 ) ).Width();

	VCControl* pControl = (VCControl*)aChildList.First();
	while( pControl )
	{
		if( pControl->IsActionHit( aPos, nTol ) &&
			pControl->IsVisible() &&
			pControl->IsEnabled()	 )
		{
			pControl->GetImpControl()->SetActMouseEvent( (MouseEvent*)&aEvt );
			pControl->MouseMove( pWindow, aEvt );
			pControl->GetImpControl()->SetActMouseEvent( 0 );
			return;
		}
		pControl = (VCControl*)aChildList.Next();
	}
}

void VCManager::KeyInput( Window* pWindow, const KeyEvent& rKEvt )
{
	//n.y.i.
}

void VCManager::LoseFocus( Window* )
{
	// Todo: Sonderbehandlung SpinButton, ScrollBar bei laufendem Timer

}

// wird von App gerufen
void VCManager::AddWindow( Window* pWindow )
{
	if( !pWinList )
		pWinList = new List;
	pWinList->Insert( (void*)pWindow, LIST_APPEND );
}

// wird von App gerufen
void VCManager::RemoveWindow( Window* pWindow )
{
	if( !pWinList )
		return;
	pWinList->Remove( (void*)pWindow );
}

VCForm* VCManager::GetVCForm( const VCControl* pCtrl )
{
	DBG_ASSERT(pCtrl,"Control==0");
	String aName( pCtrl->GetFormName() );
	VCForm* pForm = GetFormByName( aName );
	if( pForm && pForm->Contains( (VCControl*)pCtrl ))
		return pForm;
	return 0;
}

VCForm* VCManager::InsertForm( const String& rURL, USHORT nMethod, const String& rEncryption, String* pName )
{
// /* OV, 16.1.97: Namen muessen nicht mehr eindeutig sein
// OV; 14.05.97: Bei doppeltem Namen mit Laenge ungleich 0, vorherige Form
// loeschen, da sonst mit StarOffice erstellte Forms, die den Standardnamen
// "Standard" haben nicht funktionieren
//	(wg. VCControl::SetForm( const String& rName ))
// siehe BugId 39950
	if( pName && pName->Len() )
	{
		// wenn Form mit gleichem Namen schon vorhanden, dann die
		// alte Form loeschen (kann bei Form "Standard" passieren!)
		VCForm* pTest = GetFormByName( *pName );
		if( pTest )
			RemoveAndDeleteForm( pTest );
	}
// */
	VCForm* pForm = new VCForm( rURL, nMethod, rEncryption, pName );
	aFormList.Insert( pForm, LIST_APPEND );
	if( !pName )
	{
		String aStr = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Form" ) );
		aStr.Append( UniString::CreateFromInt32( aFormList.Count()-1 ) );
		pForm->SetName( aStr );
	}
	return pForm;
}

VCForm* VCManager::GetFormByName( const String& rName ) const
{
	ULONG nFormCount = aFormList.Count();
	for( ULONG nCurForm=0; nCurForm < nFormCount; nCurForm++ )
	{
		VCForm* pForm = (VCForm*)aFormList.GetObject( nCurForm );
		String aTmpName( rName ), aTmpFormName( pForm->GetName() );
		aTmpName.ToLowerAscii();
		aTmpFormName.ToLowerAscii();
		if( aTmpName == aTmpFormName )
			return pForm;
	}
	return 0;
}

void VCManager::InsertForm( VCForm* pForm )
{
	DBG_ASSERT(aFormList.GetPos((void*)pForm )==LIST_ENTRY_NOTFOUND,"Form already in list");
	// wenn Form mit gleichem Namen schon vorhanden, dann die
	// alte Form loeschen (kann bei Form "Standard" passieren!)
	VCForm* pTest = GetFormByName( pForm->GetName() );
	if( pTest )
		RemoveAndDeleteForm( pTest );
	aFormList.Insert( pForm, LIST_APPEND );
}

void VCManager::RemoveAndDeleteForm( VCForm* pForm )
{
	aFormList.Remove( (void*)pForm );
	delete pForm;
}

static void FillFrameList( List* pList, SfxFrame* pFrame )
{
	USHORT nCount = pFrame->GetChildFrameCount();
	for( USHORT nCurChild = 0; nCurChild < nCount; nCurChild++ )
	{
		SfxFrame* pCurChild = pFrame->GetChildFrame( nCurChild );
		pList->Insert( pCurChild, LIST_APPEND );
		if( pCurChild->GetChildFrameCount())
			FillFrameList( pList, pCurChild );
	}
}

//static
List* VCManager::CreateFrameList()
{
	List* pList = new List;
	SfxViewFrame* pViewFrame = SfxViewFrame::Current();
	if( pViewFrame )
	{
		SfxFrame* pStartFrame = pViewFrame->GetFrame();
		while( pStartFrame->GetParentFrame() )
			pStartFrame = pStartFrame->GetParentFrame();
		pList->Insert( pStartFrame, LIST_APPEND );
		FillFrameList( pList, pStartFrame );
	}
	return pList;
}

/***************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcont.cxx,v 1.1.1.1 2000/09/29 11:02:40 mh Exp $

	  Source Code Control System - Update

	  $Log: vcont.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:40  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:49  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.93  2000/05/16 12:29:50  pw
	  UNICODE review
	
	  Revision 1.92  2000/05/11 14:14:53  pw
	  UNICODE
	
	  Revision 1.91  2000/02/10 20:01:54  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.90  1999/11/03 16:48:58  hr
	  #65293#: for-scope
	
	  Revision 1.89  1998/10/29 12:05:48  OV
	  #54233# noch mehr altes Zeug raus
	

	  Rev 1.88   29 Oct 1998 13:05:48   OV
   #54233# noch mehr altes Zeug raus

	  Rev 1.87   12 Oct 1998 18:13:14   OV
   #54233# Alte Virt-Controls raus

	  Rev 1.86   21 Nov 1997 17:02:18   OV
   Headerumstellung

	  Rev 1.85   17 Nov 1997 15:36:56   OV
   #45559# InsertChild: Dlg-RadioButtons einen neuen Namen geben

	  Rev 1.84   10 Nov 1997 15:04:06   OV
   #45359# SetLinkData: Kein CallBack in das Control, da die Funktion vom Control gerufen wurde!

	  Rev 1.83   10 Nov 1997 13:59:56   OV
   #42205# Neu: GetFocus (kompat)

	  Rev 1.82   06 Nov 1997 12:45:42   OV
   VCL-Umstellungen

	  Rev 1.81   20 Oct 1997 17:47:06   OV
   #44463#,#44467#,#44468# IsUpdatingLinkData

	  Rev 1.80   25 Aug 1997 16:11:10   OV
   #43084# SetSVLook: ParentWin immer erzeugen, um bei GetCtrlParent nicht im Trueben zu fischen

	  Rev 1.79   28 Jul 1997 16:45:14   MH
   chg: header

	  Rev 1.78   22 Jul 1997 12:25:02   OV
   Controls koennen im Makrohandler geloescht werden

	  Rev 1.77   03 Jul 1997 13:03:40   OV
   #41226# CaptureChild und CaptureMouse vor Aufruf des Controls

	  Rev 1.76   15 May 1997 19:42:54   ST
   fix: #40009# Absturz bei Button zweimal klicken

	  Rev 1.75   14 May 1997 20:48:12   OV
   #39950# Formnamen <Standard> richtig verarbeiten

	  Rev 1.74   07 Apr 1997 16:36:20   OV
   #35611# pCaptureChild zuruecksetzen, wenn Control keinen Sbx-Parent hat

	  Rev 1.73   07 Apr 1997 10:47:22   OV
   #35756# Reschedule im MouseMove-Event ueberleben

	  Rev 1.72   10 Mar 1997 12:16:00   AB
   JScript: Radios ohne Namen sind keine Gruppe

	  Rev 1.71   11 Feb 1997 13:58:26   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.70   16 Jan 1997 11:09:22   OV
   Formnamen muessen nicht mehr eindeutig sein

	  Rev 1.69   15 Jan 1997 19:22:48   NF
   Mussnderungen ...

	  Rev 1.68   15 Jan 1997 10:36:08   OV
   GetVCForm vereinfacht

	  Rev 1.67   11 Dec 1996 16:21:16   AB
   ifdef SOLAR_JAVA ergaenzt

	  Rev 1.66   11 Dec 1996 13:03:04   AB
   Fehler korrigiert

	  Rev 1.65   11 Dec 1996 12:58:10   AB
   JavaScript Forms-Array implementiert

	  Rev 1.64   13 Nov 1996 12:32:28   OV
   Namenssetzung RadioButton

	  Rev 1.63   31 Oct 1996 22:15:44   MH
   chg: includes, defines

	  Rev 1.62   25 Jul 1996 19:06:26   OV
   Image-Buttons

	  Rev 1.61   02 Jul 1996 14:29:02   MH
   chg: includes

	  Rev 1.60   17 Jun 1996 19:49:16   DV
   menu define rein

*************************************************************************/

#pragma SEG_EOFMODULE
