/*************************************************************************
 *
 *  $RCSfile: vcsbx.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _Sb_SBSTDOBJ1_HXX //autogen
#include <basic/sbstdobj.hxx>
#endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

//************** Steht nur platt auf s: ******************
//#include <stdobj1.hxx>

#pragma hdrstop

#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#define _VCSBXCTLHDL_CXX
#define SI_SBXCONTROLS
#include "vcattr.hxx"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "vcsbxfac.hxx"
#include "vcdrwobj.hxx"
#include "sidll.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcattrid.hrc"
#include "vcictrls.hxx"

VCSbxForm* pActForm = NULL;

TYPEINIT1( VCSbxForm, SbxObject );

VCSbxFactory::VCSbxFactory()
{
}

SbxBase* VCSbxFactory::Create( UINT16 nSbxId, UINT32 nCreator )
{
	if( nCreator == SBXCR_VC )
	{
		switch( nSbxId )
		{
			case SBXID_DIALOG:
				return new VCSbxDialog();
			case SBXID_PUSHBUTTON:
				return new VCSbxPushButton( TRUE );
			case SBXID_VIRT_PUSHBUTTON:
				return new VCSbxPushButton( FALSE );
			case SBXID_CHECKBOX:
				return new VCSbxCheckBox( TRUE );
			case SBXID_VIRT_CHECKBOX:
				return new VCSbxCheckBox( FALSE );
			case SBXID_RADIOBUTTON:
				return new VCSbxRadioButton( TRUE );
			case SBXID_VIRT_RADIOBUTTON:
				return new VCSbxRadioButton( FALSE );
			case SBXID_SPINBUTTON:
				return new VCSbxSpinButton( TRUE );
			case SBXID_URLBUTTON:
				return new VCSbxURLButton( TRUE );
			case SBXID_VIRT_SPINBUTTON:
				return new VCSbxSpinButton( FALSE );
			case SBXID_FIXEDTEXT:
				return new VCSbxFixedText( TRUE );
			case SBXID_VIRT_FIXEDTEXT:
				return new VCSbxFixedText( FALSE );
			case SBXID_GROUPBOX:
				return new VCSbxGroupBox( TRUE );
			case SBXID_VIRT_GROUPBOX:
				return new VCSbxGroupBox( FALSE );
			case SBXID_LISTBOX:
				return new VCSbxListBox( TRUE );
			case SBXID_VIRT_LISTBOX:
				return new VCSbxListBox( FALSE );
			case SBXID_COMBOBOX:
				return new VCSbxComboBox( TRUE );
			case SBXID_VIRT_COMBOBOX:
				return new VCSbxComboBox( FALSE );
			case SBXID_EDIT:
				return new VCSbxEdit( TRUE );
			case SBXID_VIRT_EDIT:
				return new VCSbxEdit( FALSE );
			case SBXID_HSCROLLBAR:
				return new VCSbxHScrollBar( TRUE );
			case SBXID_VIRT_HSCROLLBAR:
				return new VCSbxHScrollBar( FALSE );
			case SBXID_VSCROLLBAR:
				return new VCSbxVScrollBar( TRUE );
			case SBXID_VIRT_VSCROLLBAR:
				return new VCSbxVScrollBar( FALSE );
			case SBXID_PREVIEW:
				return new VCSbxPreview( TRUE );
		}
	}
	return NULL;
}

SbxObject* VCSbxFactory::CreateObject( const String& rClassName )
{
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_DIALOG ) ) ) )
		return new VCSbxDialog();
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_CHECKBOX ) ) ) )
		return new VCSbxCheckBox( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_RADIOBUTTON ) ) ) )
		return new VCSbxRadioButton( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_PUSHBUTTON ) ) ) )
		return new VCSbxPushButton( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_SPINBUTTON ) ) ) )
		return new VCSbxSpinButton( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_FIXEDTEXT ) ) ) )
		return new VCSbxFixedText( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_GROUPBOX ) ) ) )
		return new VCSbxFixedText( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_LISTBOX ) ) ) )
		return new VCSbxListBox( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_COMBOBOX ) ) ) )
		return new VCSbxComboBox( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_EDIT ) ) ) )
		return new VCSbxEdit( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_HSCROLLBAR ) ) ) )
		return new VCSbxHScrollBar( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_VSCROLLBAR ) ) ) )
		return new VCSbxVScrollBar( TRUE );
	else
	if( rClassName.EqualsIgnoreCaseAscii( String( SiResId( STR_CLASS_PREVIEW ) ) ) )
		return new VCSbxPreview( TRUE );
	else
		return NULL;
}

VCSbxForm::VCSbxForm( VCContainer* pContainer, VCItemPool* pItemPool ) :
	SbxObject( String( SiResId( STR_CLASS_FORM ) ) ),
	pItemSet(NULL),
	pRunTimeItemSet(NULL),
	pPool( pItemPool ),
	bDeletePool(FALSE)
{
	SetFlags( SBX_READWRITE | SBX_DONTSTORE | SBX_EXTSEARCH );

	VCSbxForm::pContainer = pContainer;
	if( !pPool )
	{
		pPool = new VCItemPool;
		pPool->FreezeIdRanges();
		bDeletePool = TRUE;
	}
	//GetObjects()->ResetSorted();
}

VCSbxForm::~VCSbxForm()
{
	if( GetParent() )
		EndListening( GetParent()->GetBroadcaster() );

	if( pItemSet )
		delete pItemSet;

	// Alle Subobjecte schon hier aus der Form entfernen, damit der Pool
	// nicht vor den Objekten geloescht wird
	ULONG nCount = GetObjects()->Count();

	// HACK, wir haben hier noch eine Leiche im Keller!
	// die Assertion in der Schleife sollte uns aber helfen, den
	// Bug zu finden
	ULONG nInitialCount = nCount;
	while( nCount && nInitialCount )
	{
		SbxVariable* pObj = GetObjects()->Get( 0 );
		DBG_ASSERT( pObj->IsA( TYPE( VCSbxControl ) ), "Is sich nix Control !!!" );
		((VCSbxControl*)pObj)->SetParentBetter( NULL );
		// DBG_ASSERT(nCount<GetObjects()->Count(),"Object not removed");
		nCount = GetObjects()->Count();
		nInitialCount--;
	}

	if( bDeletePool )
		delete pPool;
}

void VCSbxForm::SetParent( SbxObject* pNewParent )
{
	if( GetParent() )
		EndListening( GetParent()->GetBroadcaster() );
	SbxObject::SetParent( pNewParent );
	if( pNewParent )
	{
		if( pNewParent->IsA( TYPE( StarBASIC ) ) )
			StartListening( GetParent()->GetBroadcaster() );
	}
}

SbxVariable* VCSbxForm::Find( const String& rName, SbxClassType eType )
{
	// Schon in der Basisklasse ?
	SbxVariable* p = SbxObject::Find( rName, eType );

	SfxItemSet* pItemSet = VCSbxForm::pItemSet;
	if( pRunTimeItemSet )
		pItemSet = pRunTimeItemSet;

	if( !p && pItemSet &&
		((eType == SbxCLASS_PROPERTY) || (eType == SbxCLASS_DONTCARE)) )
	{
		USHORT      nItems = pItemSet->TotalCount();
		USHORT      i;

		for( i=0; i < nItems; i++ )
		{
			USHORT nWhich            = pItemSet->GetWhichByPos( i );
			if( nWhich > VCATTR_ENDPROP )
				break;

			const SfxPoolItem& rItem = pItemSet->Get( nWhich );
			String aName             = String( SiResId( nWhich-VCATTR_START+RID_ATTR_START) );
			if( aName.EqualsIgnoreCaseAscii( rName ) )
			{
				p = Make( aName, SbxCLASS_PROPERTY, SbxVARIANT );
				p->SetUserData( nWhich );
				p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
				break;
			}
		}
	}

	return p;
}

void VCSbxForm::SetName( const String& rName )
{
	SbxObject::SetName( rName );
	if( pItemSet )
	{
		SfxStringItem aName( VCATTR_NAME, rName );
		pItemSet->Put( aName );
	}
}

const String& VCSbxForm::GetName( SbxNameType eType ) const
{
	return SbxObject::GetName( eType );
}

void VCSbxForm:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( !pItemSet )
	{
		SbxObject:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
		return;
	}

	if( pHint )
	{
		SbxVariable* pVar   = pHint->GetVar();
		SbxArray*    pPar   = pVar->GetParameters();
		USHORT       nWhich = (USHORT)pVar->GetUserData();

		if( !nWhich || (pHint->GetId() == SBX_HINT_INFOWANTED) )
		{
			SbxObject:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}


		SfxItemSet*  pItemSet = VCSbxForm::pItemSet;
		if( pRunTimeItemSet )
			pItemSet = pRunTimeItemSet;

		if( (pHint->GetId() == SBX_HINT_DATACHANGED) )
		{
			SfxPoolItem* pItem = pItemSet->Get( nWhich ).Clone();

			if( nWhich == VCATTR_FONTRANGE )
			{
				SbStdFont* pFont = (SbStdFont*)pVar->GetObject();
				SfxBoolItem   aBold( VCATTR_FONTBOLD, pFont->IsBold() );
				SfxBoolItem   aItalic( VCATTR_FONTITALIC, pFont->IsItalic() );
				SfxBoolItem   aStrikeThrough( VCATTR_FONTSTRIKETHRU, pFont->IsStrikeThrough() );
				SfxBoolItem   aUnderline( VCATTR_FONTUNDERLINE, pFont->IsUnderline() );
				SfxInt32Item  aSize( VCATTR_FONTSIZE, pFont->GetSize() );
				SfxStringItem aName( VCATTR_FONTNAME, pFont->GetName() );
				pItemSet->Put( aBold );
				pItemSet->Put( aItalic );
				pItemSet->Put( aStrikeThrough );
				pItemSet->Put( aUnderline );
				pItemSet->Put( aSize );
				pItemSet->Put( aName );
			}
			else
			if( pItem->IsA( TYPE( SfxStringItem ) ) )
			{
				String aStr( pVar->GetString() );
				((SfxStringItem*)pItem)->SetValue( aStr );
			}
			else
			if( pItem->IsA( TYPE( SfxInt16Item ) ) )
				((SfxInt16Item*)pItem)->SetValue( pVar->GetInteger() );
			else
			if( pItem->IsA( TYPE( SfxInt32Item ) ) )
				((SfxInt32Item*)pItem)->SetValue( (long)pVar->GetLong() );
			else
			if( pItem->IsA( TYPE( SfxBoolItem ) ) )
				((SfxBoolItem*)pItem)->SetValue( (BOOL)pVar->GetBool() );
			else
			if( pItem->IsA( TYPE( SvxColorItem ) ) )
			{
				ULONG  nRGB  = (ULONG)pVar->GetLong();
				#ifndef VCL
				USHORT nRed  = (USHORT) (nRGB >> 8) & 0x0000FF00;
				USHORT nGreen= (USHORT)  nRGB       & 0x0000FF00;
				USHORT nBlue = (USHORT) (nRGB << 8) & 0x0000FF00;
				((SvxColorItem*)pItem)->SetValue( Color( (UINT8)nRed, (UINT8)nGreen, (UINT8)nBlue ) );
				#else
				UINT8 nRed = COLORDATA_RED(nRGB);
				UINT8 nGreen = COLORDATA_GREEN(nRGB);
				UINT8 nBlue = COLORDATA_BLUE(nRGB);
				((SvxColorItem*)pItem)->SetValue( Color( nRed,nGreen,nBlue) );
				#endif
			}

			pItemSet->Put( *pItem );
			UpdateItem( pItem->Which() );

			delete pItem;
		}
		else
		if( (pHint->GetId() == SBX_HINT_DATAWANTED) )
		{
			SfxPoolItem* pItem = pItemSet->Get( nWhich ).Clone();

			String aStr;
			if( pItem->IsA( TYPE( SfxStringItem ) ) )
			{
				aStr = ((SfxStringItem*)pItem)->GetValue();
				pVar->PutString( aStr );
			}
			else
			if( pItem->IsA( TYPE( SfxInt16Item ) ) )
				pVar->PutInteger( ((SfxInt16Item*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SfxInt32Item ) ) )
				pVar->PutLong( ((SfxInt32Item*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SfxBoolItem ) ) )
				pVar->PutBool( ((SfxBoolItem*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SvxColorItem ) ) )
			{
				Color aCol = ((SvxColorItem*)pItem)->GetValue();
				#ifndef VCL
				ULONG nRed  = aCol.GetRed() >> 8;
				ULONG nGreen= aCol.GetGreen() >> 8;
				ULONG nBlue = aCol.GetBlue() >> 8;
				ULONG nRGB  = (nRed << 16) | (nGreen << 8) | nBlue;
				#else
				ULONG nRGB = aCol.GetRGBColor();
				#endif
				pVar->PutLong( nRGB );
			}
			else
			if( nWhich == VCATTR_FONTRANGE )
			{
				BOOL 	bBold			= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTBOLD )).GetValue();
				BOOL 	bItalic			= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTITALIC )).GetValue();
				BOOL 	bStrikeThrough	= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue();
				BOOL 	bUnderline		= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTUNDERLINE )).GetValue();
				USHORT 	nSize			= (USHORT)((SfxInt32Item&)pItemSet->Get( VCATTR_FONTSIZE )).GetValue();
				String	aName			= ((SfxInt32Item&)pItemSet->Get( VCATTR_FONTNAME )).GetValue();

				SbxObjectRef xFontObj = new SbStdFont;
				SbStdFont*   pFont = (SbStdFont*)(SbxObject*)xFontObj;
				pFont->SetBold( bBold );
				pFont->SetItalic( bItalic );
				pFont->SetStrikeThrough( bStrikeThrough );
				pFont->SetUnderline( bUnderline );
				pFont->SetSize( nSize );
				pFont->SetName( aName );

				pVar->PutObject( xFontObj );
			}

			delete pItem;
		}
	}
}

void VCSbxForm::SetItemSet( SfxItemSet* pNewSet )
{
	if( pItemSet )
	{
		delete pItemSet;
		pItemSet = pNewSet;
	}
}

void VCSbxForm::UpdateItem( USHORT nWhich )
{
}

void VCSbxForm::SetPos( const Point& rPos, BOOL )
{
	SfxInt32Item aLeftAttr( VCATTR_LEFT, rPos.X() );
	SfxInt32Item aTopAttr( VCATTR_TOP, rPos.Y() );
	pItemSet->Put( aLeftAttr );
	pItemSet->Put( aTopAttr );
}

void VCSbxForm::SetSize( const Size& rSize )
{
	SfxInt32Item aWidthAttr( VCATTR_WIDTH, rSize.Width() );
	SfxInt32Item aHeightAttr( VCATTR_HEIGHT, rSize.Height() );
	pItemSet->Put( aWidthAttr );
	pItemSet->Put( aHeightAttr );
}

Point VCSbxForm::GetPos() const
{
	long nX = ((SfxInt32Item&)pItemSet->Get( VCATTR_LEFT )).GetValue();
	long nY = ((SfxInt32Item&)pItemSet->Get( VCATTR_TOP )).GetValue();

	return Point( nX, nY );
}

Size VCSbxForm::GetSize() const
{
	long nWidth  = ((SfxInt32Item&)pItemSet->Get( VCATTR_WIDTH )).GetValue();
	long nHeight = ((SfxInt32Item&)pItemSet->Get( VCATTR_HEIGHT )).GetValue();

	return Size( nWidth, nHeight );
}

void VCSbxForm::Draw( OutputDevice* )
{
}

BOOL VCSbxForm::LoadPrivateData( SvStream& rStream, USHORT nVersion )
{
	CharSet eOldcharSet = rStream.GetStreamCharSet( );
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	pActForm = this;

	UINT32 nMyVer;
	rStream >> nMyVer;
	if( nMyVer != 0x13081961 )
	{
		rStream.SetStreamCharSet( eOldcharSet );
		return TRUE;
	}

	// Form hat einen eigenen Pool
	if( !bDeletePool )
	{
		// der Pool gehoert nicht der Form. Also abklemmen
		// und privaten Pool setzen
		pPool = new VCItemPool;
		pPool->FreezeIdRanges();
		bDeletePool = TRUE;
	}
	GetPool()->Load( rStream );

	rStream.SetStreamCharSet( eOldcharSet );
	return TRUE;
}

BOOL VCSbxForm::StorePrivateData( SvStream& rStream ) const
{
	CharSet eOldCharSet = rStream.GetStreamCharSet();
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	UINT32 nMyVer = 0x13081961L;

	rStream << nMyVer;
	SfxItemPool* pTmpPool = GetPool();
	if( rStream.GetVersion() == SOFFICE_FILEFORMAT_31 )
		pTmpPool->SetStoringRange( VCATTR_URL, VCATTR_EVENTEND );
	pTmpPool->Store( rStream );
	pTmpPool->SetStoringRange( pTmpPool->GetFirstWhich(), pTmpPool->GetLastWhich() );
	rStream.SetStreamCharSet( eOldCharSet );
	return TRUE;
}

SvStream& operator<<(SvStream& rOut, const VCSbxForm& rSbxForm)
{
	CharSet eOldCharSet = rOut.GetStreamCharSet( );
	rOut.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	UINT32 nMyVer = 0x13081961;
	rOut << nMyVer;

	if( rSbxForm.bDeletePool )
	{
		rOut << (UINT16)1;
		rSbxForm.GetPool()->Store( rOut );
	}
	else
		rOut << (UINT16)0;

	rOut.SetStreamCharSet( eOldCharSet );
	return rOut;
}

SvStream& operator>>(SvStream& rIn, VCSbxForm& rSbxForm)
{
	CharSet eOldCharSet = rIn.GetStreamCharSet( );
	rIn.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	UINT32 nMyVer;
	rIn >> nMyVer;

	if( nMyVer == 0x13081961 )
	{
		UINT16 nPoolThere;
		rIn >> nPoolThere;
		if( nPoolThere == 1 )
		{
			if( !rSbxForm.bDeletePool )
			{
				// die Form zeigt noch auf einen globalen Pool,
				// der ihr nicht gehoert. Deshalb vor dem Laden
				// den Pool abklemmen.
				rSbxForm.pPool = new VCItemPool;
				rSbxForm.pPool->FreezeIdRanges();
				rSbxForm.bDeletePool = TRUE;
			}
			rSbxForm.GetPool()->Load( rIn );
		}
	}
	else
	{
		rIn.SeekRel( -(long)sizeof( nMyVer ) );
		if( !rSbxForm.bDeletePool )
		{
			VCItemPool* pPool = new VCItemPool;
			pPool->FreezeIdRanges();
			rSbxForm.SetPool( pPool, TRUE );
		}
		rSbxForm.GetPool()->Load( rIn );
	}

	rIn.SetStreamCharSet( eOldCharSet );
	return rIn;
}

VCItemPool* VCSbxForm::GetGenericVCPool()
{
	return (*(SiDLL**)GetAppData( SHL_SI ))->GetVCItemPool();
}

IMPL_LINK_INLINE_START( VCSbxControlHdl, Click, VCControl *, pControl )
{
	pSbxControl->Click();
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, Click, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, DblClick, VCControl *, pControl )
{
	pSbxControl->DblClick();
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, DblClick, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, GotFocus, VCControl *, pControl )
{
	pSbxControl->GotFocus();
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, GotFocus, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, LostFocus, VCControl *, pControl )
{
	pSbxControl->LostFocus();
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, LostFocus, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, KeyDown, VCControl *, pControl )
{
	KeyEvent aKeyEvent;
	pSbxControl->KeyDown( aKeyEvent );
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, KeyDown, VCControl *, pControl )

void VCSbxControlHdl::KeyPress( VCControl* pControl )
{
	KeyEvent aKeyEvent;
	pSbxControl->KeyPress( aKeyEvent );
}

IMPL_LINK_INLINE_START( VCSbxControlHdl, KeyUp, VCControl *, pControl )
{
	KeyEvent aKeyEvent;
	pSbxControl->KeyUp( aKeyEvent );
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, KeyUp, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, MouseDown, VCControl *, pControl )
{
	pSbxControl->MouseDown( *(pControl->GetImpControl()->GetActMouseEvent()) );
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, MouseDown, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, MouseMove, VCControl *, pControl )
{
	pSbxControl->MouseMove( *(pControl->GetImpControl()->GetActMouseEvent()) );
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, MouseMove, VCControl *, pControl )

IMPL_LINK_INLINE_START( VCSbxControlHdl, MouseUp, VCControl *, pControl )
{
	pSbxControl->MouseUp( *(pControl->GetImpControl()->GetActMouseEvent()) );
	return 0;
}
IMPL_LINK_INLINE_END( VCSbxControlHdl, MouseUp, VCControl *, pControl )

void VCSbxControlHdl::SpinUp( VCControl* pControl )
{
	pSbxControl->SpinUp();
}

void VCSbxControlHdl::SpinDown( VCControl* pControl )
{
	pSbxControl->SpinDown();
}

void VCSbxControlHdl::Paint( VCControl* pControl )
{
	pSbxControl->Paint();
}

VCSbxControlHdl::VCSbxControlHdl() :
	pSbxControl(NULL)
{
}

void VCSbxControlHdl::SetLink( VCSbxControl* pSbxCtrl, VCControl* pControl )
{
	pSbxControl = pSbxCtrl;

	pControl->SetClickHdl( LINK( this, VCSbxControlHdl, Click ) );
	pControl->SetDblClickHdl( LINK( this, VCSbxControlHdl, DblClick ) );
	pControl->SetGotFocusHdl( LINK( this, VCSbxControlHdl, GotFocus ) );
	pControl->SetLostFocusHdl( LINK( this, VCSbxControlHdl, LostFocus ) );
	pControl->SetKeyDownHdl( LINK( this, VCSbxControlHdl, KeyDown ) );
	pControl->SetKeyUpHdl( LINK( this, VCSbxControlHdl, KeyUp ) );
	pControl->SetMouseDownHdl( LINK( this, VCSbxControlHdl, MouseDown ) );
	pControl->SetMouseMoveHdl( LINK( this, VCSbxControlHdl, MouseMove ) );
	pControl->SetMouseUpHdl( LINK( this, VCSbxControlHdl, MouseUp ) );
}

void VCSbxForm::SetPool( VCItemPool* pNewPool, BOOL bOwnsPool )
{
	DBG_ASSERT(pNewPool,"VCSbxForm::SetPool: pNewPool==0");
	if( pNewPool != pPool )
	{
		// ItemSet umhaengen
		if( pItemSet )
		{
			SfxItemSet* pOldSet = pItemSet;
			pItemSet = pItemSet->Clone( TRUE, pNewPool );
			delete pOldSet;
		}
		if( bDeletePool )
			delete pPool;
		pPool = pNewPool;
		bDeletePool = bOwnsPool;
	}
}


