/*************************************************************************
 *
 *  $RCSfile: vcsbx1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __SBX_SBXMETHOD_HXX
#include <svtools/sbxmeth.hxx>
#endif
#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

#if SUPD > 364

#ifndef _SB_SBSTDOBJ1_HXX
#include <basic/sbstdobj.hxx>
#endif

#else

#ifndef _SB_SBSTDOBJ1_HXX
#include <stdobj1.hxx>
#endif

#endif

#ifndef _CTRL_HXX
#include <vcl/ctrl.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SFXHELP_HXX
#include <sfx2/sfxhelp.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif

#ifndef _SVDMODEL_HXX //autogen
#include <svx/svdmodel.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#pragma hdrstop
#define ITEMID_COLOR 0

#define SI_VCSV_BUTTONS
#include "vclbox.hxx"
#include "vccbbox.hxx"
#define _VCSBXCTL_CXX
#define _VCSBXDIALOG_CXX
#define _SI_VCITEMS
#define SI_VCDRAWOBJ
#define SI_VCDRAWPAGE
#define SI_VCDRAWMODEL
//#define _SI_NOVCSBXFORM
//#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
//#define _SI_NOVCSBXPUSHBUTTON
//#define _SI_NOVCSBXSPINBUTTON
//#define _SI_NOVCSBXFIXEDTEXT
//#define _SI_NOVCSBXGROUPBOX
//#define _SI_NOVCSBXLISTBOX
//#define _SI_NOVCSBXCOMBOBOX
//#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
//#define _SI_NOVCSBXPREVIEW
//#define _SI_NOVCSBXURLBUTTON
#include <svx/colritem.hxx>
#include "vcattr.hxx"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "vcdrwobj.hxx"
#include "vcsbxdo.hxx"
#include "sidll.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcattrid.hrc"
#include "vcictrls.hxx"
#include "vcprvw.hxx"
#include "sictrls.hxx"
#include <svx/svdlayer.hxx>

extern VCSbxForm* pActForm;

TYPEINIT1( VCSbxControl, SbxObject );

void VCSbxControl::Init()
{
	SfxItemSet* pItemSet = pVCControl->GetItemSet();
	String aName = ((SfxStringItem&)pItemSet->Get( VCATTR_NAME )).GetValue();
	SetName( aName );

	// In die Form einfuegen
	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		if( GetParent()->IsA( TYPE( VCSbxDialog ) ) )
			pVCControl->SetStep( ((VCSbxDialog*)GetParent())->GetCurStep() );
		((VCSbxForm*)GetParent())->VCPtrInsert( this );
	}

	aHdl.SetLink( this, pVCControl );
}

void VCSbxControl::ConvertAmpersand( String* pStr )
{
	pStr->SearchAndReplaceAll( '&', '~' );
}

void VCSbxControl::DeleteAmpersand( String* pStr )
{
	pStr->EraseAllChars( '&' );
	pStr->EraseAllChars( '~' );
}

VCSbxControl::VCSbxControl() :
	SbxObject( String( RTL_CONSTASCII_USTRINGPARAM( "Control" ) ) ),
	pSVControl(NULL),
	pRunTimeItemSet(NULL),
	pVCControl(NULL)
#ifdef VCL
	,nCtrlFlags(0)
#endif
{
	// Name Property selbst verarbeiten
	SbxVariable* p = Find( String( SiResId( STR_ATTR_NAME ) ),
						   SbxCLASS_PROPERTY );
	DBG_ASSERT( p, "Keine Name Property" );
	p->SetUserData( VCATTR_NAME );

	p = Find( String( RTL_CONSTASCII_USTRINGPARAM( "Parent" ) ), SbxCLASS_PROPERTY );
	DBG_ASSERT( p, "Keine Parent Property" );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_PARENT );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Move" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_MOVE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Refresh" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_REFRESH );
}


VCSbxControl::~VCSbxControl()
{
	// Aus der Form entfernen
	if( GetParent() )
		GetParent()->Remove( this );
	DeleteSVControl();
	delete pVCControl;
}


String VCSbxControl::GetClassName() const
{
	return pVCControl->GetClassName();
}


String VCSbxControl::GetClassNamePlural() const
{
	return pVCControl->GetClassNamePlural();
}

void VCSbxControl::SetParent( SbxObject* pNewParent )
{
	if( pNewParent )
	{
		// Pool auf die neue Form umschalten
		if( pNewParent->IsA( TYPE( VCSbxForm ) ) )
		{
			pVCControl->SetPool( ((VCSbxForm*)pNewParent)->GetPool() );
			pVCControl->SetParent( ((VCSbxForm*)pNewParent)->GetVCContainer() );
			// TabIndex setzen
			ULONG nTabPos = ((VCSbxForm*)pNewParent)->GetVCContainer()->GetChildCount();
			pVCControl->UpdateItem( 0 );
		}
		else
		{
			pVCControl->SetPool( VCSbxForm::GetGenericVCPool() );
			pVCControl->SetParent( NULL );
		}
	}
	else
	{
		pVCControl->SetPool( VCSbxForm::GetGenericVCPool() );
		pVCControl->SetParent( NULL );
	}
	SbxObject::SetParent( pNewParent );
}

void VCSbxControl::SetParentBetter( SbxObject* pNewParent )
{
	SbxObject* pOldParent = GetParent();
	if( pOldParent == pNewParent )
		return;

	if( pNewParent )
	{
		// Dies wird beim anschliessenden Aufruf von SetParent)
		// nochmal ausgefuehrt.
		// Hier steht es nur, damit beim Einfuegen das Control
		// schon einen eindeutigen Namen vom VCContainer bekommen
		// hat
		if( pNewParent->IsA( TYPE( VCSbxForm ) ) )
		{
			pVCControl->SetPool( ((VCSbxForm*)pNewParent)->GetPool() );
			pVCControl->SetParent( ((VCSbxForm*)pNewParent)->GetVCContainer() );
			pVCControl->UpdateItem( 0 );
		}

		pNewParent->VCPtrInsert( this );
	}

	if( pOldParent )
	{
		// pOldParent->Remove( this );
		pOldParent->VCPtrRemove( this );
	}
}

SbxVariable* VCSbxControl::Find( const String& rName, SbxClassType eType )
{
	// Schon in der Basisklasse
	SbxVariable* p = SbxObject::Find( rName, eType );

	if( !p &&
		((eType == SbxCLASS_PROPERTY) || (eType == SbxCLASS_DONTCARE )) )
	{
		SfxItemSet* pItemSet = pVCControl->GetItemSet();
		USHORT      nItems = pItemSet->TotalCount();
		USHORT      i;

		if( pRunTimeItemSet )
			pItemSet = pRunTimeItemSet;

		for( i=0; i < nItems; i++ )
		{
			USHORT nWhich            = pItemSet->GetWhichByPos( i );
			const SfxPoolItem& rItem = pItemSet->Get( nWhich );
			String aName             = String( SiResId( nWhich-VCATTR_START+RID_ATTR_START) );
			if( aName.EqualsIgnoreCaseAscii( rName ) )
			{
				p = Make( aName, SbxCLASS_PROPERTY, SbxVARIANT );
				p->SetUserData( nWhich );
				p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
				break;
			}
		}
	}
	return p;
}

void VCSbxControl::SetName( const String& rName )
{
	SfxStringItem aItem( VCATTR_NAME, rName );
	pVCControl->GetItemSet()->Put( aItem );
	SbxObject::SetName( rName );
}

const String& VCSbxControl::GetName( SbxNameType eType ) const
{
	return ((SfxStringItem&)pVCControl->GetItemSet()->Get(VCATTR_NAME)).GetValue();
}

void VCSbxControl:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		SbxVariable* pVar   = pHint->GetVar();
		SbxArray*    pPar   = pVar->GetParameters();
		USHORT       nWhich = (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( !nWhich || (pHint->GetId() == SBX_HINT_INFOWANTED) )
		{
			SbxObject:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		// Methoden verwalten
		if( pVar->IsA( TYPE( SbxMethod ) ) &&
			(pHint->GetId() == SBX_HINT_DATAWANTED) )
		{
			switch( nWhich )
			{
				case VCMETH_MOVE:		MethodMove( pVar, pPar, FALSE ); return;
				case VCMETH_REFRESH:	MethodRefresh( pVar, pPar, FALSE ); return;
				case VCMETH_SETFOCUS:	MethodSetFocus( pVar, pPar, FALSE ); return;
			}
		}

		// Interne Properties
		switch( nWhich )
		{
			case VCATTR_IMP_PARENT:			PropParent( pVar, pPar, bWrite ); return;
		}

		SfxItemSet*  pItemSet = pVCControl->GetItemSet();
		if( pRunTimeItemSet )
			pItemSet = pRunTimeItemSet;

		SfxPoolItem* pItem = pItemSet->Get( nWhich ).Clone();

		if( pHint->GetId() == SBX_HINT_DATACHANGED )
		{
			if( pRunTimeItemSet )
			{
				switch( nWhich )
				{
					case VCATTR_STEP:
					case VCATTR_TABINDEX:
					case VCATTR_CANCEL:
					case VCATTR_DEFAULT:
					case VCATTR_TABSTOP:
					case VCATTR_AUTO3D:
					case VCATTR_NAME:
					case VCATTR_WORDWRAP:
					case VCATTR_WORDWRAP_MODE:
					case VCATTR_MULTILINE:
					case VCATTR_SCROLLBARS:
						StarBASIC::Error( SbERR_PROP_READONLY );
						break;
				}
			}

			if( nWhich == VCATTR_FONTRANGE )
			{
				SbStdFont* pFont = (SbStdFont*)pVar->GetObject();
				SfxBoolItem   aBold( VCATTR_FONTBOLD, pFont->IsBold() );
				SfxBoolItem   aItalic( VCATTR_FONTITALIC, pFont->IsItalic() );
				SfxBoolItem   aStrikeThrough( VCATTR_FONTSTRIKETHRU, pFont->IsStrikeThrough() );
				SfxBoolItem   aUnderline( VCATTR_FONTUNDERLINE, pFont->IsUnderline() );
				SfxInt32Item  aSize( VCATTR_FONTSIZE, pFont->GetSize() );
				SfxStringItem aName( VCATTR_FONTNAME, pFont->GetName() );
				pItemSet->Put( aBold );
				pItemSet->Put( aItalic );
				pItemSet->Put( aStrikeThrough );
				pItemSet->Put( aUnderline );
				pItemSet->Put( aSize );
				pItemSet->Put( aName );
			}
			else
			if( pItem->IsA( TYPE( SfxStringItem ) ) )
			{
				String aStr( pVar->GetString() );
				((SfxStringItem*)pItem)->SetValue( aStr );
			}
			else
			if( pItem->IsA( TYPE( SfxInt16Item ) ) )
				((SfxInt16Item*)pItem)->SetValue( pVar->GetInteger() );
			else
			if( pItem->IsA( TYPE( SfxInt32Item ) ) )
				((SfxInt32Item*)pItem)->SetValue( (long)pVar->GetLong() );
			else
			if( pItem->IsA( TYPE( SfxBoolItem ) ) )
				((SfxBoolItem*)pItem)->SetValue( pVar->GetBool() );
			else
			if( pItem->IsA( TYPE( SvxColorItem ) ) )
			{
				ULONG  nRGB  = (ULONG)pVar->GetLong();
				#ifndef VCL
				USHORT nRed  = (USHORT) (nRGB >> 8) & 0x0000FF00;
				USHORT nGreen= (USHORT)  nRGB        & 0x0000FF00;
				USHORT nBlue = (USHORT) (nRGB << 8) & 0x0000FF00;
				((SvxColorItem*)pItem)->SetValue( Color( (UINT8)nRed, (UINT8)nGreen, (UINT8)nBlue ) );
				#else
				UINT8 nRed = COLORDATA_RED(nRGB);
				UINT8 nGreen = COLORDATA_GREEN(nRGB);
				UINT8 nBlue = COLORDATA_BLUE(nRGB);
				((SvxColorItem*)pItem)->SetValue( Color( nRed,nGreen,nBlue) );
				#endif
			}
			else
			if( nWhich == VCATTR_MOUSEPOINTER )
			{
				USHORT ePointer = (USHORT)pVar->GetInteger();
				((VCMousePointerItem*)pItem)->SetValue( ePointer );
			}

			pItemSet->Put( *pItem );

			// Liste mit ItemData synchronisieren
			if( (nWhich == VCATTR_LIST) || (nWhich == VCATTR_ITEMDATA) )
			{
				VCIntegerListItem* pItemData = (VCIntegerListItem*)
												pItemSet->Get(nWhich).Clone();
				List* pList = ((VCIntegerListItem*)pItem)->GetList();
				pItemData->SetEntryCount( (INT16)pList->Count() );
				pItemSet->Put( *pItemData );
				delete pItemData;
			}

			if( !pRunTimeItemSet )
				pVCControl->UpdateItem( nWhich );
			else
				UpdateSVControl( pItem->Which() );
		}
		else
		if( pHint->GetId() == SBX_HINT_DATAWANTED )
		{
			if( pItem->IsA( TYPE( SfxStringItem ) ) )
				pVar->PutString( ((SfxStringItem*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SfxInt16Item ) ) )
				pVar->PutInteger( ((SfxInt16Item*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SfxInt32Item ) ) )
				pVar->PutLong( ((SfxInt32Item*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SfxBoolItem ) ) )
				pVar->PutBool( ((SfxBoolItem*)pItem)->GetValue() );
			else
			if( pItem->IsA( TYPE( SvxColorItem ) ) )
			{
				Color aCol = ((SvxColorItem*)pItem)->GetValue();
				#ifndef VCL
				ULONG nRed  = aCol.GetRed() >> 8;
				ULONG nGreen= aCol.GetGreen() >> 8;
				ULONG nBlue = aCol.GetBlue() >> 8;
				ULONG nRGB  = (nRed << 16) | (nGreen << 8) | nBlue;
				#else
				ULONG nRGB = aCol.GetRGBColor();
				#endif
				pVar->PutLong( nRGB );
			}
			else
			if( nWhich == VCATTR_FONTRANGE )
			{
				BOOL 	bBold			= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTBOLD )).GetValue();
				BOOL 	bItalic			= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTITALIC )).GetValue();
				BOOL 	bStrikeThrough	= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue();
				BOOL 	bUnderline		= ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTUNDERLINE )).GetValue();
				USHORT 	nSize			= (USHORT)((SfxInt32Item&)pItemSet->Get( VCATTR_FONTSIZE )).GetValue();
				String	aName			= ((SfxInt32Item&)pItemSet->Get( VCATTR_FONTNAME )).GetValue();

				SbxObjectRef xFontObj = new SbStdFont;
				SbStdFont*   pFont = (SbStdFont*)(SbxObject*)xFontObj;
				pFont->SetBold( bBold );
				pFont->SetItalic( bItalic );
				pFont->SetStrikeThrough( bStrikeThrough );
				pFont->SetUnderline( bUnderline );
				pFont->SetSize( nSize );
				pFont->SetName( aName );

				pVar->PutObject( xFontObj );
			}
			else
			if( pItem->IsA( TYPE( SfxEnumItem ) ) )
				pVar->PutInteger( ((SfxEnumItem*)pItem)->GetValue() );
		}

		delete pItem;
	}
}

void VCSbxControl::MethodMove( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( !pPar || (pPar->Count() < 2) || (pPar->Count() > 5) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	USHORT nArgs = pPar->Count();

	SfxItemSet* pItemSet = pVCControl->GetItemSet();
	if( pRunTimeItemSet )
		pItemSet = pRunTimeItemSet;

	SfxInt32Item aItem( VCATTR_LEFT, pPar->Get(1)->GetInteger() );
	pItemSet->Put( aItem );

	if( nArgs > 2 )
	{
		SfxInt32Item aItem( VCATTR_TOP, pPar->Get(2)->GetInteger() );
		pItemSet->Put( aItem );
	}
	if( nArgs > 3 )
	{
		SfxInt32Item aItem( VCATTR_WIDTH, pPar->Get(3)->GetInteger() );
		pItemSet->Put( aItem );
	}
	if( nArgs > 4 )
	{
		SfxInt32Item aItem( VCATTR_HEIGHT, pPar->Get(4)->GetInteger() );
		pItemSet->Put( aItem );
	}

	if( !pRunTimeItemSet )
	{
		pVCControl->SetItemSet( pVCControl->GetItemSet() );
		SdrObject* pDrawObj = pVCControl->GetDrawObject();
	}
	else
	{
		// X,Y bzw WIDTH,HEIGHT werden jeweils zusammen refreshed
		UpdateSVControl( VCATTR_LEFT );
		UpdateSVControl( VCATTR_WIDTH );
	}
}

void VCSbxControl::MethodRefresh( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
	if( pSVControl )
		pSVControl->Invalidate();
}

void VCSbxControl::MethodSetFocus( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	if( pSVControl )
		pSVControl->GrabFocus();
	else
	{
		if( pVCControl->ISA(VCListBox))
			((VCListBox*)pVCControl)->Focus();
		else if( pVCControl->ISA(VCComboBox))
			((VCComboBox*)pVCControl)->Focus();
		else if( pVCControl->ISA(VCEdit))
			((VCEdit*)pVCControl)->Focus();
	}
}

void VCSbxControl::PropParent( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	pVar->PutObject( GetParent() );
}

void VCSbxControl::CreateSVControl( Window* pParent )
{
	pRunTimeItemSet = pVCControl->GetItemSet()->Clone();
}

void VCSbxControl::DeleteSVControl()
{
	if( pVCControl->IsReal() && pVCControl->GetImpControl() )
	{
		((VCImpRealControl*)pVCControl->GetImpControl())->DeleteDlgEdControl();
	}
	DELETEZ(pRunTimeItemSet);
	DELETEZ(pSVControl);
}

void VCSbxControl::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl || !pRunTimeItemSet )
		return;

	BOOL bAutoAdjust = IsAutoAdjustSize();

	// Position setzen
	if( !nWhich || (nWhich==VCATTR_LEFT) || (nWhich==VCATTR_TOP) )
	{
		Point aPos;
		if( !bAutoAdjust )
		{
			long nX = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LEFT )).GetValue();
			long nY = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_TOP )).GetValue();

			aPos = SI_DLL()->GetOutDev()->
							 LogicToPixel( Point( nX, nY ), MapMode( MAP_TWIP ) );
		}
		else
			aPos = GetAdjustedPosPixel( pSVControl );

		pSVControl->SetPosPixel( aPos );
	}

	// Groesse setzen
	if( !nWhich || (nWhich==VCATTR_WIDTH) || (nWhich==VCATTR_HEIGHT) )
	{
		Size aSize;
		if( !bAutoAdjust )
		{
			long nWidth = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_WIDTH )).GetValue();
			long nHeight= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_HEIGHT )).GetValue();
			aSize = SI_DLL()->GetOutDev()->
							LogicToPixel( Size( nWidth, nHeight ), MapMode( MAP_TWIP ) );
		}
		else
			aSize = GetAdjustedSizePixel( pSVControl );
		pSVControl->SetSizePixel( aSize );
	}

#ifdef TF_SI_OFF50
	UpdateVCLVisibleAndEnable( pSVControl, *pRunTimeItemSet, nWhich );
#else
	// Visible setzen
	if( !nWhich || (nWhich==VCATTR_VISIBLE) )
	{
		BOOL bVisible = ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_VISIBLE )).GetValue();
		if( bVisible )
			pSVControl->Show();
		else
			pSVControl->Hide();
	}
	// Enable setzen
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnable = ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_ENABLED )).GetValue();
		{
			if( IsA( TYPE( VCSbxSpinButton)))
			{
				if( bEnable )
					((SpinButton*)pSVControl)->Enable();
				else
					((SpinButton*)pSVControl)->Disable();
			}
			else
			{
				bEnable ? pSVControl->Enable() : pSVControl->Disable();
			}
		}
	}
#endif

	// Hilfetext und Id setzen
	if( !nWhich || (nWhich==VCATTR_HELPTEXT) || (nWhich==VCATTR_HELPCONTEXTID) )
	{
		long   nHelpId  = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_HELPCONTEXTID )).GetValue();
		String aHelpText= ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_HELPTEXT )).GetValue();
		pSVControl->SetHelpId( (ULONG)nHelpId );
		pSVControl->SetQuickHelpText( aHelpText );
		// bei gesetzter HelpId gilt das HilfeFile!
		//if( !nHelpId )
			pSVControl->SetHelpText( aHelpText );
	}

	// Mousepointer setzen
	if( !nWhich || (nWhich==VCATTR_MOUSEPOINTER) )
	{
		USHORT ePointer = (USHORT)((VCMousePointerItem&)pRunTimeItemSet->
									Get(VCATTR_MOUSEPOINTER)).GetValue();

		PointerStyle eSVPointer;
		switch( ePointer )
		{
			case VCPOINTER_DEFAULT:
			case VCPOINTER_ARROW:      eSVPointer = POINTER_ARROW; break;
			case VCPOINTER_CROSS:      eSVPointer = POINTER_CROSS; break;
			case VCPOINTER_IBEAM:      eSVPointer = POINTER_TEXT;  break;
			case VCPOINTER_ICON:       eSVPointer = POINTER_ARROW; break;
			case VCPOINTER_SIZE:       eSVPointer = POINTER_MOVE;  break;
			case VCPOINTER_NE_SW:      eSVPointer = POINTER_NESIZE; break;
			case VCPOINTER_N_S:        eSVPointer = POINTER_HSPLIT;   break;
			case VCPOINTER_NW_SE:      eSVPointer = POINTER_SESIZE; break;
			case VCPOINTER_W_E:        eSVPointer = POINTER_VSPLIT;   break;
			case VCPOINTER_UPARROW:    eSVPointer = POINTER_REFHAND;  break;
			case VCPOINTER_HOURGLASS:  eSVPointer = POINTER_WAIT;     break;
			case VCPOINTER_NODROP:     eSVPointer = POINTER_NOTALLOWED;break;
		}

		if( ePointer == VCPOINTER_DEFAULT )
		{
			// in VCL kann ein gesetzter Pointer nicht mehr auf default
			// zurueckgesetzt werden
			// pSVControl->SetPointer( Pointer() );
		}
		else
			pSVControl->SetPointer( Pointer( eSVPointer ) );
#ifdef VCL
		pSVControl->EnableChildPointerOverwrite();
#endif
	}


#ifdef TF_SI_OFF50

	UpdateVCLColorsAndFont( pSVControl, *pRunTimeItemSet, nWhich );

#else
	BOOL bTransparent = FALSE;
	if( pRunTimeItemSet->GetItemState( VCATTR_BACKSTYLE ) != SFX_ITEM_UNKNOWN )
	{
		USHORT eBack = (USHORT)((VCBackStyleItem&)pRunTimeItemSet->
								Get( VCATTR_BACKSTYLE )).GetValue();
		if( eBack == VCBACK_TRANSPARENT )
			bTransparent = TRUE;
	}
	// Farben setzen
	if( !nWhich ||
		(nWhich==VCATTR_BACKCOLOR) ||
		(nWhich==VCATTR_FORECOLOR) ||
		(nWhich==VCATTR_BACKSTYLE)    )
	{
		if( !IsSVLook() || ISA(VCSbxPreview) )
		{
			Font  aFont = pSVControl->GetFont();
			Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
			Color aBackCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_BACKCOLOR )).GetValue();
			Brush aBackBrush( aBackCol );
			pSVControl->SetBackgroundBrush( aBackBrush );
			Brush aFillBrush( pSVControl->GetFillInBrush() );
			aFillBrush.SetColor( aForeCol );
			aFillBrush.SetFillColor( aBackCol );
			pSVControl->SetFillInBrush( aFillBrush );

			Pen aPen( pSVControl->GetPen() );
			aPen.SetColor( aForeCol );
			pSVControl->SetPen( aPen );

			#ifdef VCL
			AllSettings aSettings( pSVControl->GetSettings() );
			StyleSettings aStyleSettings( aSettings.GetStyleSettings() );
			#endif

			#ifdef VCL
			// Malte kann noch keine transparenten Fonts
			if( ISA(VCSbxEdit) )
				aStyleSettings.SetFieldColor( aBackCol );
			#endif

			if( pRunTimeItemSet->GetItemState( VCATTR_FORECOLOR ) != SFX_ITEM_UNKNOWN )
			{
				aFont.SetTransparent( bTransparent );
				#ifndef VCL
				aFont.SetColor( aForeCol );
				aFont.SetFillColor( aBackCol );
				#else
				if(ISA(VCSbxFixedText))
					aStyleSettings.SetLabelTextColor( aForeCol );
				else
					aStyleSettings.SetButtonTextColor( aForeCol );
				#endif
			}
			#ifdef VCL
			aSettings.SetStyleSettings( aStyleSettings );
			pSVControl->SetSettings( aSettings );
			#endif
			pSVControl->SetFont( aFont );
		}
	}
	// Font setzen
	if( !nWhich || (nWhich==VCATTR_FONTRANGE) ||
		(nWhich==VCATTR_FONTNAME) || (nWhich==VCATTR_FONTSIZE) ||
		(nWhich==VCATTR_FONTBOLD)  || (nWhich==VCATTR_FONTITALIC) ||
		(nWhich==VCATTR_FONTSTRIKETHRU) || (nWhich==VCATTR_FONTUNDERLINE) )
	{
		Font aFont = pSVControl->GetFont();
		const String& rFontName = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_FONTNAME )).GetValue();
		if( rFontName.Len() )
		{
			aFont.SetName( rFontName );

			// Groessenberechnung siehe auch vcictrl1.cxx ::GetFont
			long nFontHeightPoint = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_FONTSIZE)).GetValue();
			long nFontHeightPixel = pSVControl->LogicToPixel(Size(0,nFontHeightPoint),MAP_POINT).Height();
			MapMode aMap( pSVControl->GetMapMode().GetMapUnit() );
			long nFontHeight = pSVControl->PixelToLogic( Size(0,nFontHeightPixel),
													aMap ).Height();
			aFont.SetSize( Size(0,nFontHeight) );
			#ifndef VCL
			aFont.SetTransparent( bTransparent );
			#else
			aFont.SetTransparent( TRUE );
			#endif
			if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_FONTBOLD )).GetValue() )
				aFont.SetWeight( WEIGHT_BOLD );
			else
			#ifndef OS2
				aFont.SetWeight( WEIGHT_NORMAL );
			#else
				aFont.SetWeight( WEIGHT_DONTKNOW );
			#endif
			if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_FONTITALIC )).GetValue() )
				aFont.SetItalic( ITALIC_NORMAL );
			else
				aFont.SetItalic( ITALIC_NONE );
			if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue() )
				aFont.SetStrikeout( STRIKEOUT_SINGLE );
			else
				aFont.SetStrikeout( STRIKEOUT_NONE );
			if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_FONTUNDERLINE )).GetValue() )
				aFont.SetUnderline( UNDERLINE_SINGLE );
			else
				aFont.SetUnderline( UNDERLINE_NONE );
		}
		pSVControl->SetFont( aFont );
	}
#endif //ifdef TF_SI_OFF50
}

long VCSbxControl::GetStep() const
{
	return pVCControl->GetStep();
}

void VCSbxControl::SetStep( long nStep )
{
	pVCControl->SetStep( nStep );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxDialog ) ) )
		UpdateStep( ((VCSbxDialog*)GetParent())->GetCurStep() );
}

void VCSbxControl::UpdateStep( long nCurStep )
{
	if( pRunTimeItemSet && pSVControl )
	{
		long nStep = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_STEP )).GetValue();

		if( nCurStep )
		{
			if( nStep && (nStep != nCurStep) )
				pSVControl->Hide();
			else
			if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_VISIBLE )).GetValue() )
				pSVControl->Show();
		}
		else
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_VISIBLE )).GetValue() )
			pSVControl->Show();
	}
	else
	{
		SfxItemSet* pItemSet = pVCControl->GetItemSet();
		long nStep = ((SfxInt32Item&)pItemSet->Get( VCATTR_STEP )).GetValue();

		VCSbxDrawObject* pDrawObj = pVCControl->GetDrawObject();
		if( !pDrawObj )
			return;

		if( nCurStep )
		{
			SdrLayerAdmin& rLayerAdmin = pDrawObj->GetModel()->GetLayerAdmin();
			SdrLayerID      nLayerId   = rLayerAdmin.GetLayerID( String( RTL_CONSTASCII_USTRINGPARAM( "VCHiddenLayer" ) ), FALSE );
			if( nStep && (nStep != nCurStep) )
				pDrawObj->SetLayer( nLayerId );
			else
				pDrawObj->SetLayer( 0 );
		}
		else
				pDrawObj->SetLayer( 0 );
	}
}

ULONG VCSbxControl::GetTabPos() const
{
	return pVCControl->GetTabPos();
}

void VCSbxControl::Click()
{
	DBG_ERROR("VCSbxControl::Click wird gerufen");
}

void VCSbxControl::DblClick()
{
	DBG_ERROR("VCSbxControl::DblClick wird gerufen");
}

void VCSbxControl::GotFocus()
{
	DBG_ERROR("VCSbxControl::GotFocus wird gerufen");
}

void VCSbxControl::LostFocus()
{
	DBG_ERROR("VCSbxControl::LostFocus wird gerufen");
}

void VCSbxControl::KeyDown( const KeyEvent& rKEvt )
{
	DBG_ERROR("VCSbxControl::KeyDown wird gerufen");
}

void VCSbxControl::KeyPress( const KeyEvent& rKEvt )
{
	DBG_ERROR("VCSbxControl::KeyDown wird gerufen");
}

void VCSbxControl::KeyUp( const KeyEvent& rKEvt )
{
	DBG_ERROR("VCSbxControl::KeyUp wird gerufen");
}

void VCSbxControl::MouseDown( const MouseEvent& rMEvt )
{
	DBG_ERROR("VCSbxControl::MouseDown wird gerufen");
}

void VCSbxControl::MouseMove( const MouseEvent& rMEvt )
{
	DBG_ERROR("VCSbxControl::MouseMove wird gerufen");
}

void VCSbxControl::MouseUp( const MouseEvent& rMEvt )
{
	DBG_ERROR("VCSbxControl::MouseUp wird gerufen");
}

void VCSbxControl::Change()
{
	DBG_ERROR("VCSbxControl::Change wird gerufen");
}

void VCSbxControl::Scroll()
{
	DBG_ERROR("VCSbxControl::Scroll wird gerufen");
}

void VCSbxControl::SpinUp()
{
	DBG_ERROR("VCSbxControl::SpinUp wird gerufen");
}

void VCSbxControl::SpinDown()
{
	DBG_ERROR("VCSbxControl::SpinDown wird gerufen");
}

void VCSbxControl::Paint()
{
	DBG_ERROR("VCSbxControl::Paint wird gerufen");
}

BOOL VCSbxControl::LoadPrivateData( SvStream& rStream, USHORT )
{
	// Pool auf die neue Form umschalten
	// Insert darf hier nicht gemacht werden, weils schon
	// beim Laden passiert

	CharSet eOldCharSet = rStream.GetStreamCharSet( );
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	pVCControl->SetPool( pActForm->GetPool() );
	pVCControl->SetParent( pActForm->GetVCContainer() );

	UINT32 nMyVer;
	rStream >> nMyVer;
	if( nMyVer != 0x13081961 )
	{
		pVCControl->SetSize( Size( 700, 500 ) );
		rStream.SetStreamCharSet( eOldCharSet );
		return TRUE;
	}

	rStream >> *pVCControl;
	// HACK: Wegen der chaotischen Update-Ablaeufe innerhalb SIs muss
	// der Fontname nach dem Laden ein explizites Update erfahren, weil:
	// Fontnamen koennen leer sein. Dies bedeutet, dass der Originalfont
	// des Controls verwendet werden soll. Durch Updates (ausgeloest u.a.
	// von SetParent()), wurde aber bereits der Original-Font geaendert.
	// Das Setzen eines leeren Fontnamens bewirkt also nichts mehr.
	// UpdateItem mit der WhichId VCATTR_FONTNAME bewirkt, dass das
	// Control durch ein neues ersetzt und komplett initialisiert wird
	// (Performance-Leak!!!!)
	pVCControl->UpdateItem( VCATTR_FONTNAME );

	rStream.SetStreamCharSet( eOldCharSet );
	return TRUE;
}

BOOL VCSbxControl::StorePrivateData( SvStream& rStream ) const
{
	CharSet eOldCharSet = rStream.GetStreamCharSet( );
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	UINT32 nMyVer = 0x13081961;
	rStream << nMyVer;
	rStream << *pVCControl;

	rStream.SetStreamCharSet( eOldCharSet );
	return TRUE;
}

SvStream& operator<<(SvStream& rOut, const VCSbxControl& rSbxCtrl)
{
	CharSet eOldCharSet = rOut.GetStreamCharSet( );
	rOut.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );
	rOut << *rSbxCtrl.pVCControl;
	rOut.SetStreamCharSet( eOldCharSet );

	return rOut;
}

SvStream& operator>>(SvStream& rIn, VCSbxControl& rSbxCtrl)
{
	CharSet eOldCharSet = rIn.GetStreamCharSet( );
	rIn.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );
	rIn >> *rSbxCtrl.pVCControl;
	rIn.SetStreamCharSet( eOldCharSet );

	return rIn;
}

BOOL VCSbxControl::Call( const String& rName, SbxArray* pPar )
{
	SfxApplication* pApp=SFX_APP();
	pApp->EnterBasicCall();
	// Haben wir ein Basic, wenn nicht dann besorgen
	SbxObject* p = this;
	BOOL bBasFound = FALSE;
	while( (p = p->GetParent()) != NULL )
		if( p->IsA( TYPE( StarBASIC ) ) )
		{
			bBasFound = TRUE;
			break;
		}

	if( !bBasFound )
	{
		SdrObject* pDrawObj = pVCControl->GetDrawObject();
		if( pDrawObj )
		{
			SdrPage* pPage = pDrawObj->GetPage();
			if( pPage && (pPage->IsA( TYPE( VCDrawPage ) ) ) )
			{
				((VCDrawPage*)pPage)->RequestBasic();
				p = this;
				while( (p = p->GetParent()) != NULL )
					if( p->IsA( TYPE( StarBASIC ) ) )
						break;
			}
		}
	}

	VCSbxDialog* pParent = NULL;
	if( GetParent()->IsA( TYPE( VCSbxDialog ) ) )
		pParent = (VCSbxDialog*)GetParent();

	if( pParent )
		pParent->SetInCallBack();

	String aMacro( rName );
	// ist der Name voll qualifiziert?
	if( aMacro.GetTokenCount( '.' ) == 3 )
	{
		xub_StrLen nLast = 0;
		String aLibName = aMacro.GetToken( 0, '.', nLast );
		String aModul = aMacro.GetToken( 0, '.', nLast );
		aMacro.Erase( 0, nLast );
	}

	BOOL bRet;
	if( p )
		bRet = p->Call( aMacro, pPar );
	else
		bRet = SbxObject::Call( aMacro,pPar);

	if( pParent )
		pParent->SetInCallBack(FALSE);

	pApp->LeaveBasicCall();
	return bRet;
}

void VCSbxControl::LoadDialog()
{
	if( !pRunTimeItemSet && pVCControl->IsReal() )
	{
		SbxObject* pParent = GetParent();
		if( pParent && pParent->IsA( TYPE(VCSbxDialog) ) )
		{
			((VCSbxDialog*)pParent)->CreateSVDialog();
			((VCSbxDialog*)pParent)->UpdateSVDialog();
		}
	}
}

BOOL VCSbxControl::IsAutoAdjustSize() const
{
	if( pVCControl->IsReal() )
	{
		const VCSbxDialog* pDlg = (const VCSbxDialog*)GetParent();
		if( pDlg )
			return ((const SfxBoolItem&)pDlg->GetItemSet()->Get(VCATTR_AUTOADJUST_SIZE)).GetValue();
	}
	return FALSE;
}

Size VCSbxControl::GetAdjustedSizePixel(const OutputDevice* pOut ) const
{
	Size aSize;
	if( pRunTimeItemSet )
	{
		long nWidth = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_WIDTH )).GetValue();
		long nHeight= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_HEIGHT )).GetValue();
		aSize.Width() = nWidth;
		aSize.Height() = nHeight;
	}
	else
		aSize = pVCControl->GetSize();

#ifndef WIN
		Fraction aFracX( 1, 26 );
#else
		Fraction aFracX( 1, 23 );
#endif
	Fraction aFracY( 1, 24 );
	MapMode aMap( MAP_APPFONT, Point(), aFracX, aFracY );
	aSize = pOut->LogicToPixel( aSize, aMap );
	return aSize;
}

Point VCSbxControl::GetAdjustedPosPixel(const OutputDevice* pOut ) const
{
	Point aPos;
	if( pRunTimeItemSet )
	{
		long nLeft = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LEFT )).GetValue();
		long nTop = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_TOP )).GetValue();
		aPos.X() = nLeft;
		aPos.Y() = nTop;
	}
	else
		aPos = pVCControl->GetPos();

#ifndef WIN
			Fraction aFracX( 1, 26 );
#else
			Fraction aFracX( 1, 23 );
#endif
	Fraction aFracY( 1, 24 );
	MapMode aMap( MAP_APPFONT, Point(), aFracX, aFracY );
	aPos = pOut->LogicToPixel( aPos, aMap );
	return aPos;
}

BOOL VCSbxControl::RequestHelp( const HelpEvent& rHEvt )
{
	if( (rHEvt.GetMode() & HELPMODE_CONTEXT) && GetParent() )
	{
		SbxInfoRef rInfo = GetParent()->GetInfo();
		INT32 nHelpId = ((const SfxInt32Item&)
			(GetRunTimeItemSet()->Get(VCATTR_HELPCONTEXTID))).GetValue();

		if( rInfo.Is() && rInfo->GetHelpFile().Len() && nHelpId )
		{
			ByteString aStrTmp( rInfo->GetHelpFile(), RTL_TEXTENCODING_ASCII_US );
			SfxHelp::ShowHelp( nHelpId, TRUE, aStrTmp.GetBuffer() );
			return TRUE;
		}
	}
	return FALSE;
}

BOOL VCSbxControl::IsSVLook() const
{
	const SbxObject* pDlg = GetParent();
	if( pDlg && pDlg->ISA(VCSbxDialog) )
		return ((VCSbxDialog*)pDlg)->IsSVLook();
	return TRUE;

}

#ifdef VCL

long VCSbxControl::PreNotify( NotifyEvent& rNEvt )
{
	if( IsDesignModeActive() )
		return 0;

	Window* pWin = rNEvt.GetWindow();

	MouseEvent* pMouseEvent = (MouseEvent*)rNEvt.GetMouseEvent();
	KeyEvent* pKeyEvent = (KeyEvent*)rNEvt.GetKeyEvent();

	switch( rNEvt.GetType() )
	{
		case EVENT_MOUSEBUTTONDOWN:
			pVCControl->GetImpControl()->SetActMouseEvent( pMouseEvent );
			pVCControl->MouseDown();
			if( pVCControl->ISA(VCPreview) || pVCControl->ISA(VCEdit) )
			{
				if( pMouseEvent->GetClicks() > 1 )
					pVCControl->DblClick();
				else
					pVCControl->Click();
			}
			break;

		case EVENT_MOUSEBUTTONUP:
			pVCControl->GetImpControl()->SetActMouseEvent( pMouseEvent );
			pVCControl->MouseUp();
			break;

		case EVENT_MOUSEMOVE:
			pVCControl->GetImpControl()->SetActMouseEvent( pMouseEvent );
			pVCControl->MouseMove();
			break;

		case EVENT_KEYINPUT:
			pVCControl->GetImpControl()->SetActKeyEvent( pKeyEvent );
			pVCControl->KeyDown();
			pVCControl->KeyPress();
			pVCControl->KeyUp();
			break;

		case EVENT_GETFOCUS:
			if( !(nCtrlFlags & VCSBX_FLAG_FOCUSED) )
			{
				nCtrlFlags |= VCSBX_FLAG_FOCUSED;
				pVCControl->GotFocus();
			}
			break;

		case EVENT_LOSEFOCUS:
			if( nCtrlFlags & VCSBX_FLAG_FOCUSED )
			{
				nCtrlFlags &= (~VCSBX_FLAG_FOCUSED);
				pVCControl->LostFocus();
			}
			break;
	}
	return 0;
}

#endif


#ifdef TF_SI_OFF50

void VCSbxControl::UpdateVCLColorsAndFont( Control* pVCLControl, const SfxItemSet& rSet, USHORT nWhich)
{
	BOOL bTransparent = FALSE;
	BOOL bGroupBox = ISA(VCSbxGroupBox);
	BOOL bListComboBox = ISA(VCSbxListBox) || ISA(VCSbxComboBox);

	if( !bGroupBox )
	{
		if( rSet.GetItemState( VCATTR_BACKSTYLE ) != SFX_ITEM_UNKNOWN )
		{
			USHORT eBack =
				(USHORT)((const VCBackStyleItem&)rSet.Get( VCATTR_BACKSTYLE )).GetValue();
			if( eBack == VCBACK_TRANSPARENT )
				bTransparent = TRUE;
		}
	}
	else
	{
		bTransparent = TRUE;
	}

	// Farben setzen
	switch( nWhich )
	{
		case 0:
		case VCATTR_BACKCOLOR :
		case VCATTR_FORECOLOR :
		case VCATTR_BACKSTYLE :
		{
			if( !IsSVLook() || ISA(VCSbxPreview) )
			{
				Font  aFont = pVCLControl->GetFont();
				Color aForeCol = ((const SvxColorItem&)rSet.Get( VCATTR_FORECOLOR )).GetValue();
				Color aBackCol = ((const SvxColorItem&)rSet.Get( VCATTR_BACKCOLOR )).GetValue();
				if( !bGroupBox )
				{
					pVCLControl->SetBackground( Wallpaper( aBackCol ) );

					pVCLControl->SetFillColor( aBackCol );
					pVCLControl->SetLineColor( aForeCol );
				}

				#ifdef VCL
				AllSettings aSettings( pVCLControl->GetSettings() );
				StyleSettings aStyleSettings( aSettings.GetStyleSettings() );
				#endif

				#ifdef VCL
				// Malte kann noch keine transparenten Fonts
				if( ISA(VCSbxEdit) )
					aStyleSettings.SetFieldColor( aBackCol );
				if( ISA(VCSbxListBox) )
					aStyleSettings.SetWorkspaceColor( aBackCol );
				#endif

				if( rSet.GetItemState( VCATTR_FORECOLOR ) != SFX_ITEM_UNKNOWN )
				{
					aFont.SetTransparent( bTransparent );
					#ifndef VCL
						aFont.SetColor( aForeCol );
						aFont.SetFillColor( aBackCol );
					#else
						if( bGroupBox || ISA(VCSbxFixedText) )
							aStyleSettings.SetLabelTextColor( aForeCol );
					else
						aStyleSettings.SetButtonTextColor( aForeCol );
					#endif
				}
				#ifdef VCL
				aSettings.SetStyleSettings( aStyleSettings );
				//Childs sollen Settings erben!
				pVCLControl->SetSettings( aSettings /* , TRUE */ );
				#endif
				pVCLControl->SetFont( aFont );
			}
		}
	}

	// Font setzen
	switch( nWhich )
	{
		case 0:
		case VCATTR_FONTRANGE :
		case VCATTR_FONTNAME :
		case VCATTR_FONTSIZE :
		case VCATTR_FONTBOLD :
		case VCATTR_FONTITALIC :
		case VCATTR_FONTSTRIKETHRU :
		case VCATTR_FONTUNDERLINE :
		case VCATTR_BACKCOLOR:
		case VCATTR_FORECOLOR:
		case VCATTR_BACKSTYLE:
		{
			Font aFont;
			if( bListComboBox )
				aFont = pVCLControl->GetControlFont();
			else
				aFont = pVCLControl->GetFont();
			const String& rFontName = ((const SfxStringItem&)rSet.Get( VCATTR_FONTNAME )).GetValue();
			if( rFontName.Len() )
			{
				aFont.SetName( rFontName );
				// Groessenberechnung siehe auch vcictrl1.cxx ::GetFont
				long nFontHeightPoint = ((const SfxInt32Item&)rSet.Get( VCATTR_FONTSIZE)).GetValue();
				// SetControlFont erwartet die Groesse in Punkten
				if( !bListComboBox )
				{
					long nFontHeightPixel =
							pVCLControl->LogicToPixel(Size(0,nFontHeightPoint),MAP_POINT).Height();
					MapMode aMap( pVCLControl->GetMapMode().GetMapUnit() );
					long nFontHeight =
							pVCLControl->PixelToLogic( Size(0,nFontHeightPixel), aMap ).Height();
					aFont.SetSize( Size(0,nFontHeight) );
				}
				else
					aFont.SetSize( Size( 0, nFontHeightPoint ));


				#ifndef VCL
					aFont.SetTransparent( bTransparent );
				#else
					aFont.SetTransparent( TRUE );
				#endif
				if( ((const SfxBoolItem&)rSet.Get( VCATTR_FONTBOLD )).GetValue() )
					aFont.SetWeight( WEIGHT_BOLD );
				else
				{
					#ifndef OS2
						aFont.SetWeight( WEIGHT_NORMAL );
					#else
						aFont.SetWeight( WEIGHT_DONTKNOW );
					#endif
				}
				if( ((const SfxBoolItem&)rSet.Get( VCATTR_FONTITALIC )).GetValue() )
					aFont.SetItalic( ITALIC_NORMAL );
				else
					aFont.SetItalic( ITALIC_NONE );
				if( ((const SfxBoolItem&)rSet.Get( VCATTR_FONTSTRIKETHRU )).GetValue() )
					aFont.SetStrikeout( STRIKEOUT_SINGLE );
				else
					aFont.SetStrikeout( STRIKEOUT_NONE );
				if( ((const SfxBoolItem&)rSet.Get( VCATTR_FONTUNDERLINE )).GetValue() )
					aFont.SetUnderline( UNDERLINE_SINGLE );
				else
					aFont.SetUnderline( UNDERLINE_NONE );
			}
			if( bListComboBox )
				pVCLControl->SetControlFont( aFont );
			else
				pVCLControl->SetFont( aFont );
		}
	}
}

void VCSbxControl::UpdateVCLVisibleAndEnable( Control* pVCLControl, const SfxItemSet& rSet, USHORT nWhich)
{
	// Visible setzen
	if( !nWhich || (nWhich==VCATTR_VISIBLE) )
	{
		BOOL bVisible = ((const SfxBoolItem&)rSet.Get(VCATTR_VISIBLE)).GetValue();
		if( bVisible )
			pVCLControl->Show();
		else
			pVCLControl->Hide();
	}

	// Enable setzen
	if( !nWhich || (nWhich==VCATTR_ENABLED) )
	{
		BOOL bEnable = ((const SfxBoolItem&)rSet.Get( VCATTR_ENABLED )).GetValue();
		{
			if( IsA( TYPE( VCSbxSpinButton)))
			{
				if( bEnable )
					((VCSVSpinButton*)pVCLControl)->Enable();
				else
					((VCSVSpinButton*)pVCLControl)->Disable();
			}
			else
			{
				bEnable ? pVCLControl->Enable() : pVCLControl->Disable();
			}
		}
	}
}

BOOL VCSbxControl::IsDesignModeActive() const
{
	if( pVCControl->IsReal() )
	{
		if( !pRunTimeItemSet )
			return TRUE;
	}
	return FALSE;
}

#endif


