/*************************************************************************
 *
 *  $RCSfile: vcsbxbtn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _SFX_SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _SVX_SIVCDRMOD_HXX //autogen
#include <vcdrmod.hxx>
#endif

#pragma hdrstop

#define SI_VCSV_BUTTONS

#include "vcpbttn.hxx"
#include "vcrdbttn.hxx"
#include "vcspnbtn.hxx"
#include "vcurlbtn.hxx"
#include "vcchkbox.hxx"
#define _SI_VCITEMS
//#define _SI_NOVCSBXFORM
//#define _SI_NOVCSBXBUTTON
//#define _SI_NOVCSBXCHECKBOX
//#define _SI_NOVCSBXRADIOBUTTON
//#define _SI_NOVCSBXPUSHBUTTON
//#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
//#define _SI_NOVCSBXURLBUTTON
#define _SI_NOVCDRAWPAGE
#define _SI_NOVCDRAWVIEW
#define _SI_VCDRAWOBJ
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "vcsbxdo.hxx"
#include "siresid.hxx"
#include "vcdrwobj.hxx"
#include "vctrls.hrc"
#include "sidll.hxx"
#include "vcictrls.hxx"
#include "sictrls.hxx"

void VCSVPushButton::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		PushButton::RequestHelp( rHEvt );
}

//--------------------------------------------------------------------------
void VCSVSpinButton::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		SpinButton::RequestHelp( rHEvt );
}

//--------------------------------------------------------------------------
void VCSVRadioButton::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		RadioButton::RequestHelp( rHEvt );
}

//--------------------------------------------------------------------------
void VCSVCheckBox::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		CheckBox::RequestHelp( rHEvt );
}

//--------------------------------------------------------------------------
void VCSVCancelButton::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		CancelButton::RequestHelp( rHEvt );
}

//--------------------------------------------------------------------------
void VCSVPushButton::Click()
{
	pShell->Click();
}

//--------------------------------------------------------------------------
#ifndef VCL

void VCSVPushButton::MouseButtonDown( const MouseEvent& rMEvt )
{
	PushButton::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
}

//--------------------------------------------------------------------------
void VCSVPushButton::MouseButtonUp( const MouseEvent& rMEvt )
{
	PushButton::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//--------------------------------------------------------------------------
void VCSVPushButton::MouseMove( const MouseEvent& rMEvt )
{
	PushButton::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

//--------------------------------------------------------------------------
void VCSVPushButton::KeyInput( const KeyEvent& rKEvt )
{
	PushButton::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//--------------------------------------------------------------------------
void VCSVPushButton::GetFocus()
{
	pShell->GotFocus();
}

//--------------------------------------------------------------------------
void VCSVPushButton::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVPushButton::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = PushButton::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//--------------------------------------------------------------------------
void VCSVCancelButton::Click()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->Click();
	CancelButton::Click();
}

//--------------------------------------------------------------------------

#ifndef VCL

void VCSVCancelButton::MouseButtonDown( const MouseEvent& rMEvt )
{
	CancelButton::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
}

//--------------------------------------------------------------------------
void VCSVCancelButton::MouseButtonUp( const MouseEvent& rMEvt )
{
	CancelButton::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//--------------------------------------------------------------------------
void VCSVCancelButton::MouseMove( const MouseEvent& rMEvt )
{
	CancelButton::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}


//--------------------------------------------------------------------------
void VCSVCancelButton::KeyInput( const KeyEvent& rKEvt )
{
	CancelButton::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//--------------------------------------------------------------------------
void VCSVCancelButton::GetFocus()
{
	pShell->GotFocus();
}

//--------------------------------------------------------------------------
void VCSVCancelButton::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVCancelButton::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = CancelButton::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//--------------------------------------------------------------------------
void VCSVCheckBox::Click()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		// Neuen Status im ItemSet ablegen
		SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
		SfxBoolItem aCheckItem( VCATTR_CHECKBOXVALUE, IsChecked() );
		pItemSet->Put( aCheckItem );

		pShell->Click();
	}
}

//--------------------------------------------------------------------------

#ifndef VCL

void VCSVCheckBox::MouseButtonDown( const MouseEvent& rMEvt )
{
	CheckBox::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
}

//--------------------------------------------------------------------------
void VCSVCheckBox::MouseButtonUp( const MouseEvent& rMEvt )
{
	CheckBox::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//--------------------------------------------------------------------------
void VCSVCheckBox::MouseMove( const MouseEvent& rMEvt )
{
	CheckBox::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}


//--------------------------------------------------------------------------
void VCSVCheckBox::KeyInput( const KeyEvent& rKEvt )
{
	CheckBox::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//--------------------------------------------------------------------------
void VCSVCheckBox::GetFocus()
{
	pShell->GotFocus();
}

//--------------------------------------------------------------------------
void VCSVCheckBox::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVCheckBox::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = CheckBox::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//--------------------------------------------------------------------------
void VCSVRadioButton::Click()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		// Neuen Status im ItemSet ablegen
		SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
		SfxBoolItem aCheckItem( VCATTR_RADIOBUTTONVALUE, IsChecked() );
		pItemSet->Put( aCheckItem );

		pShell->Click();
	}
}

//--------------------------------------------------------------------------

#ifndef VCL

void VCSVRadioButton::MouseButtonDown( const MouseEvent& rMEvt )
{
	RadioButton::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( rMEvt.GetClicks() == 2 )
	{
		pShell->DblClick();
	}
}

//--------------------------------------------------------------------------
void VCSVRadioButton::MouseButtonUp( const MouseEvent& rMEvt )
{
	RadioButton::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//--------------------------------------------------------------------------
void VCSVRadioButton::MouseMove( const MouseEvent& rMEvt )
{
	RadioButton::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

//--------------------------------------------------------------------------
void VCSVRadioButton::KeyInput( const KeyEvent& rKEvt )
{
	RadioButton::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//--------------------------------------------------------------------------
void VCSVRadioButton::GetFocus()
{
	pShell->GotFocus();
}

//--------------------------------------------------------------------------
void VCSVRadioButton::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVRadioButton::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = RadioButton::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//--------------------------------------------------------------------------
void VCSVSpinButton::Up()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		long nTemp = nValue;

		nValue += nChange;
		if( nValue > nMax )
			nValue = nMax;

		// Neuen Value im ItemSet ablegen
		SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
		SfxInt32Item aValueItem( VCATTR_SPINBUTTONVALUE, nValue );
		pItemSet->Put( aValueItem );

		if( nValue < nTemp )
			pShell->SpinnedDown();
		else
		if( nValue > nTemp )
			pShell->SpinnedUp();
	}
}

//--------------------------------------------------------------------------
void VCSVSpinButton::Down()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		long nTemp = nValue;

		nValue -= nChange;
		if( nValue < nMin )
			nValue = nMin;

		// Neuen Value im ItemSet ablegen
		SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
		SfxInt32Item aValueItem( VCATTR_SPINBUTTONVALUE, nValue );
		pItemSet->Put( aValueItem );

		if( nValue < nTemp )
			pShell->SpinnedDown();
		else
		if( nValue > nTemp )
			pShell->SpinnedUp();
	}
}

//--------------------------------------------------------------------------
#ifndef VCL

void VCSVSpinButton::KeyInput( const KeyEvent& rKEvt )
{
	SpinButton::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//--------------------------------------------------------------------------
void VCSVSpinButton::GetFocus()
{
	pShell->GotFocus();
}

//--------------------------------------------------------------------------
void VCSVSpinButton::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVSpinButton::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = SpinButton::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//--------------------------------------------------------------------------
VCSbxButton::VCSbxButton()
{
	//Methoden registrieren
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
}

//--------------------------------------------------------------------------
VCSbxButton::~VCSbxButton()
{
}

//--------------------------------------------------------------------------
void VCSbxButton::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );
}

TYPEINIT1( VCSbxCheckBox, VCSbxControl );

//--------------------------------------------------------------------------
void VCSbxCheckBox:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if( (nWhich == VCATTR_CHECKBOXVALUE) && !bWrite && pSVControl )
		{
			// Vor Behandlung ItemSet auf Stand bringen
			SfxBoolItem aCheckItem( VCATTR_CHECKBOXVALUE,
									((CheckBox*)pSVControl)->IsChecked() );
			pRunTimeItemSet->Put( aCheckItem );
		}

		VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

//--------------------------------------------------------------------------
VCSbxCheckBox::VCSbxCheckBox( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_CHECKBOX ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCCheckBox( pForm->GetVCContainer(), pForm->GetPool(),
								   bReal, this );
	}
	else
		pVCControl = new VCCheckBox( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCATTR_CHECKBOXVALUE );
}

//--------------------------------------------------------------------------
VCSbxCheckBox::~VCSbxCheckBox()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxCheckBox::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	USHORT eAlign =
		(USHORT)((const VCButtonAlignmentItem&)rSet.Get( VCATTR_BUTTONALIGNMENT )).GetValue();

	return new VCSVCheckBox( pParent, (VCCheckBox*)pVCControl, nStyle );
}

#endif

//--------------------------------------------------------------------------
void VCSbxCheckBox::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	USHORT eAlign = (USHORT)((VCButtonAlignmentItem&)
							   pRunTimeItemSet->
									Get( VCATTR_BUTTONALIGNMENT )).GetValue();
	if( eAlign == VCBTNALIGN_RIGHT )
		nStyle |= WB_LEFTLABEL;

	pSVControl = new VCSVCheckBox( pParent, (VCCheckBox*)pVCControl, nStyle );
#endif
}

//--------------------------------------------------------------------------
void VCSbxCheckBox::UpdateSVControl( USHORT nWhich )
{
	// Position, Groesse und Caption werden durch Basisklasse gesetzt
	VCSbxButton::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}

	// Value setzen
	((VCSVCheckBox*)pSVControl)->
		Check( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_CHECKBOXVALUE )).GetValue() );
}

TYPEINIT1( VCSbxRadioButton, VCSbxControl );

//--------------------------------------------------------------------------
void VCSbxRadioButton:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							   const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if( (nWhich == VCATTR_RADIOBUTTONVALUE) && !bWrite && pSVControl )
		{
			// Vor Behandlung ItemSet auf Stand bringen
			SfxBoolItem aCheckItem( VCATTR_RADIOBUTTONVALUE,
									((RadioButton*)pSVControl)->IsChecked() );
			pRunTimeItemSet->Put( aCheckItem );
		}
		VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

//--------------------------------------------------------------------------
VCSbxRadioButton::VCSbxRadioButton( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_RADIOBUTTON ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCRadioButton( pForm->GetVCContainer(), pForm->GetPool(),
									  bReal, this );
	}
	else
		pVCControl = new VCRadioButton( NULL, VCSbxForm::GetGenericVCPool(), bReal,this );

	Init();

	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCATTR_RADIOBUTTONVALUE );
}

//--------------------------------------------------------------------------
VCSbxRadioButton::~VCSbxRadioButton()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxRadioButton::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	USHORT eAlign =
		(USHORT)((const VCButtonAlignmentItem&)rSet.Get( VCATTR_BUTTONALIGNMENT )).GetValue();

	return new VCSVRadioButton( pParent, (VCRadioButton*)pVCControl, nStyle );
}

#endif

//--------------------------------------------------------------------------
void VCSbxRadioButton::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	USHORT eAlign = (USHORT)((VCButtonAlignmentItem&)
							   pRunTimeItemSet->
									Get( VCATTR_BUTTONALIGNMENT )).GetValue();
	if( eAlign == VCBTNALIGN_RIGHT )
		nStyle |= WB_LEFTLABEL;

	pSVControl = new VCSVRadioButton( pParent, (VCRadioButton*)pVCControl, nStyle );
#endif
}

//--------------------------------------------------------------------------
void VCSbxRadioButton::UpdateSVControl( USHORT nWhich )
{
	// Position, Groesse und Caption werden durch Basisklasse gesetzt
	VCSbxButton::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}

	// Value setzen
	if( !nWhich || (nWhich==VCATTR_RADIOBUTTONVALUE) )
	{
		// HACK, hier muessen eigentlich alle anderen Radiobuttons
		// der Gruppe zurueckgesetzt werden. Da die Value-Property
		// beim Auslesen aber immer das SV-Control benutzt, ist dies
		// nicht unbedingt notwendig (ein CL-Hack!!!!!!)
		((VCSVRadioButton*)pSVControl)->
			Check( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_RADIOBUTTONVALUE )).GetValue() );
	}
}


TYPEINIT1( VCSbxPushButton, VCSbxControl );

//--------------------------------------------------------------------------
void VCSbxPushButton::PropValue( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	// Wie bei VB immer FALSE returnen
	pVar->PutBool( FALSE );
}

//--------------------------------------------------------------------------
void VCSbxPushButton:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							  const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if( nWhich == VCATTR_IMP_VALUE )
			PropValue( pVar, pPar, bWrite );
		else
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

//--------------------------------------------------------------------------
VCSbxPushButton::VCSbxPushButton( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_PUSHBUTTON ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCPushButton( pForm->GetVCContainer(), pForm->GetPool(),
									 bReal, this );
	}
	else
		pVCControl = new VCPushButton( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_VALUE );
}

//--------------------------------------------------------------------------
VCSbxPushButton::~VCSbxPushButton()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxPushButton::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_DEFAULT )).GetValue() )
		nStyle |= WB_DEFBUTTON;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	Control* pResult;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_CANCEL )).GetValue() )
		pResult = new VCSVCancelButton( pParent, (VCPushButton*)pVCControl, nStyle );
	else
		pResult = new VCSVPushButton( pParent, (VCPushButton*)pVCControl, nStyle );
	return pResult;
}

#endif

//--------------------------------------------------------------------------
void VCSbxPushButton::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_DEFAULT )).GetValue() )
		nStyle |= WB_DEFBUTTON;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_CANCEL )).GetValue() )
		pSVControl = new VCSVCancelButton( pParent, (VCPushButton*)pVCControl, nStyle );
	else
		pSVControl = new VCSVPushButton( pParent, (VCPushButton*)pVCControl, nStyle );
#endif
}

//--------------------------------------------------------------------------
void VCSbxPushButton::UpdateSVControl( USHORT nWhich )
{
	// Position, Groesse und Caption werden durch Basisklasse gesetzt
	VCSbxButton::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}

#if 0
	// umschalten von Cancel, Default erlaubt StarView nicht
	if( nWhich == VCATTR_CANCEL || nWhich == VCATTR_DEFAULT )
	{
		// CreateSVControl( pSVControl->GetParent() );
		Window* _pCtrlParent = pSVControl->GetParent();
		delete pSVControl;
		WinBits nStyle = 0;
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_DEFAULT )).GetValue() )
			nStyle |= WB_DEFBUTTON;
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
			nStyle |= WB_TABSTOP;
#ifdef VCL
		else
			nStyle |= WB_NOTABSTOP;
#endif
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_CANCEL )).GetValue() )
			pSVControl = new VCSVCancelButton( _pCtrlParent, (VCPushButton*)pVCControl, nStyle );
		else
			pSVControl = new VCSVPushButton( _pCtrlParent, (VCPushButton*)pVCControl, nStyle );

		UpdateSVControl( 0 );
		pSVControl->Show();
	}
#endif

}


TYPEINIT1( VCSbxSpinButton, VCSbxControl );

//--------------------------------------------------------------------------
VCSbxSpinButton::VCSbxSpinButton( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_SPINBUTTON ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCSpinButton( pForm->GetVCContainer(), pForm->GetPool(),
									 bReal, this );
	}
	else
		pVCControl = new VCSpinButton( NULL, VCSbxForm::GetGenericVCPool(), bReal, this  );

	Init();

	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_SPINBUTTONVALUE );
}

//--------------------------------------------------------------------------
VCSbxSpinButton::~VCSbxSpinButton()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxSpinButton::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = WB_REPEAT;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	return new VCSVSpinButton( pParent, (VCSpinButton*)pVCControl, nStyle );
}

#endif

//--------------------------------------------------------------------------
void VCSbxSpinButton::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = WB_REPEAT;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	pSVControl = new VCSVSpinButton( pParent, (VCSpinButton*)pVCControl, nStyle );
#endif
}

//--------------------------------------------------------------------------
void VCSbxSpinButton::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position, Groesse und Caption werden durch Basisklasse gesetzt
	VCSbxButton::UpdateSVControl( nWhich );

	// Min, Max und Value setzen
	if( !nWhich || (nWhich == VCATTR_MIN) )
	{
		long nMin = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_MIN )).GetValue();
		((VCSVSpinButton*)pSVControl)->SetMin( (short)nMin );
	}

	if( !nWhich || (nWhich == VCATTR_MAX) )
	{
		long nMax = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_MAX )).GetValue();
		((VCSVSpinButton*)pSVControl)->SetMax( (short)nMax );
	}

	if( !nWhich || (nWhich == VCATTR_CHANGE) )
	{
		long nChange = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_CHANGE )).GetValue();
		((VCSVSpinButton*)pSVControl)->SetChange( (short)nChange );
	}

	if( !nWhich || (nWhich == VCATTR_SPINBUTTONVALUE) )
	{
		long nVal = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_SPINBUTTONVALUE )).GetValue();
		((VCSVSpinButton*)pSVControl)->SetValue( (short)nVal );
	}
}

TYPEINIT1( VCSbxURLButton, VCSbxButton );

//--------------------------------------------------------------------------
void VCSbxURLButton:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							  const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if( nWhich == VCATTR_IMP_VALUE )
			PropValue( pVar, pPar, bWrite );
		else
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

//--------------------------------------------------------------------------
VCSbxURLButton::VCSbxURLButton( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_URLBUTTON ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCURLButton( pForm->GetVCContainer(), pForm->GetPool(),
									 bReal, this );
	}
	else
		pVCControl = new VCURLButton( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_VALUE );
}

//--------------------------------------------------------------------------
VCSbxURLButton::~VCSbxURLButton()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxURLButton::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_DEFAULT )).GetValue() )
		nStyle |= WB_DEFBUTTON;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	return new VCSVPushButton( pParent, (VCPushButton*)pVCControl, nStyle );
}

#endif

//--------------------------------------------------------------------------
void VCSbxURLButton::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_DEFAULT )).GetValue() )
		nStyle |= WB_DEFBUTTON;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif
	pSVControl = new VCSVPushButton( pParent, (VCPushButton*)pVCControl, nStyle );
#endif
}

//--------------------------------------------------------------------------
void VCSbxURLButton::UpdateSVControl( USHORT nWhich )
{
	// Position, Groesse und Caption werden durch Basisklasse gesetzt
	VCSbxButton::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}
}

//--------------------------------------------------------------------------
void VCSbxURLButton::PropValue( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}
	// Wie bei VB immer FALSE returnen
	pVar->PutBool( FALSE );
}

//--------------------------------------------------------------------------
void VCSbxURLButton::Click()
{
	BOOL bLinkCalled = FALSE;
	VCControl* pVCControl = GetVCControl();
	VCSbxDrawObject* pDrawObject = pVCControl->GetDrawObject();
	if( pDrawObject )
	{
		VCDrawModel* pModel = (VCDrawModel*)pDrawObject->GetModel();
		const Link& rLink = pModel->GetURLHdl();
		if( rLink.IsSet())
		{
			rLink.Call( this );
			bLinkCalled = TRUE;
		}
	}
	if( !bLinkCalled )
	{
#ifndef SVX_LIGHT
		SfxStringItem aURL( SID_FILE_NAME, ((VCURLButton*)pVCControl)->GetURL() );
		SfxFrameItem aFrm( SID_DOCFRAME, SfxViewFrame::Current() );
		const SfxStringItem& rTarget=(const SfxStringItem&)
			(pVCControl->GetItemSet()->Get(VCATTR_TARGETFRAME));
		SfxStringItem aTarget( SID_TARGETNAME, rTarget.GetValue() );
		SfxViewFrame* pCurFrame = SfxViewFrame::Current();
		DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
		SfxDispatcher* pDispatcher = pCurFrame ? pCurFrame->GetDispatcher() : NULL;
		if( pDispatcher )
		{
			pDispatcher->Execute( SID_OPENURL, SFX_CALLMODE_ASYNCHRON,
								  &aURL, &aFrm, &aTarget, 0L );
		}
#endif
	}
}

/**************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxbtn.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxbtn.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.2  2000/09/26 15:02:44  ab
	  SFX_DISPATCHER() removed
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.71  2000/05/16 12:24:14  pw
	  UNICODE review
	
	  Revision 1.70  2000/05/11 14:15:37  pw
	  UNICODE
	
	  Revision 1.69  1998/10/12 16:14:38  OV
	  #54233# Alte Virt-Controls raus
	

	  Rev 1.68   12 Oct 1998 18:14:38   OV
   #54233# Alte Virt-Controls raus

	  Rev 1.67   05 Feb 1998 14:59:46   HJS
   includes

	  Rev 1.66   01 Dec 1997 10:25:14   TJ
   include

	  Rev 1.65   21 Nov 1997 17:02:08   OV
   Headerumstellung

	  Rev 1.64   07 Nov 1997 13:06:54   OV
   weitere VCL-Umstellungen

	  Rev 1.63   06 Nov 1997 12:46:10   OV
   VCL-Umstellungen

	  Rev 1.62   31 Oct 1997 11:05:20   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.61   29 Oct 1997 14:34:34   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.60   24 Oct 1997 11:01:04   OV
   #44268# VCL: WB_NOTABSTOP setzen

	  Rev 1.59   20 Oct 1997 17:46:40   OV
   #44463#,#44467#,#44468# LinkDaten richtig behandeln

	  Rev 1.58   09 Oct 1997 13:02:36   OV
   #44270# MouseEvents in die richtigen Handler routen

	  Rev 1.57   09 Sep 1997 17:31:30   OV
   #43661# Anbindung des Hilfesystems

	  Rev 1.56   30 Jul 1997 13:50:54   MH
   chg: header

	  Rev 1.55   28 Jul 1997 16:43:12   MH
   chg: header

	  Rev 1.54   11 Jul 1997 16:29:10   OV
   Default,Cancel zur Laufzeit umschaltbar (nicht aktiv)

	  Rev 1.53   02 Apr 1997 21:54:42   MH
   chg: headerfile umstellungen

	  Rev 1.52   11 Feb 1997 13:59:22   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.51   10 Dec 1996 14:16:18   OV
   Umstellung auf SvxMacroItem

	  Rev 1.50   22 Nov 1996 19:46:10   OV
   JavaScript-Unterstuetzung

	  Rev 1.49   05 Nov 1996 14:27:28   OV
   Link am Model rufen

	  Rev 1.48   31 Oct 1996 22:15:46   MH
   chg: includes, defines

	  Rev 1.47   07 Aug 1996 12:59:28   OV
   UpdateSVControl: WhichId beachten

	  Rev 1.46   02 Jul 1996 14:29:04   MH
   chg: includes

	  Rev 1.45   26 Jun 1996 16:49:02   PB
   * 324-Aenderungen

	  Rev 1.44   26 Jun 1996 16:07:26   PB
   * 324-Aenderungen

*************************************************************************/

#pragma SEG_EOFMODULE
