/*************************************************************************
 *
 *  $RCSfile: vcsbxdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXHELP_HXX
#include <sfx2/sfxhelp.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SBXDEF_HXX
#include <svtools/sbxdef.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#define ITEMID_MACRO	11111
#include <svtools/macitem.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif

#ifndef _SVX_SIVCDRMOD_HXX //autogen
#include <vcdrmod.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#pragma hdrstop

#define _VCSBXDIALOG_CXX
#define SI_VCDLGOBJ
#define SI_VCDRAWPAGE
#define SI_VCDRAWMODEL
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON

#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#include "sidll.hxx"
#include "vcattr.hxx"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "vcdrwobj.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcattrid.hrc"
#include "vcictrls.hxx"
#include "vcprvw.hxx"
#include "vcedit.hxx"
#include "vcmpit.hxx"
#include <basobj.hxx>

static sal_Char cVCSbxDialogCheck;

class VCSVModelessDialog : public ModelessDialog
{
protected:
	VCSbxDialog*	pSbxDialog;
	void			Activate();
	void			Deactivate();
	void			GetFocus();
	void			LoseFocus();
	void			MouseButtonDown( const MouseEvent& rEvt );
	void			MouseButtonUp( const MouseEvent& rEvt );
	void			MouseMove( const MouseEvent& rEvt );
	void			KeyInput( const KeyEvent& rEvt );
	void			Resize();
	BOOL			Close();
	virtual void	RequestHelp( const HelpEvent& rHEvt );
#ifdef VCL
	virtual long	PreNotify( NotifyEvent& rNEvt );
#endif
	short 			nOldSbxFlags;

public:
	VCSVModelessDialog( Window* pParent, VCSbxDialog* pDlg, WinBits nStyle=0 ) :
		ModelessDialog( pParent, nStyle )
	{
		pSbxDialog = pDlg;
		nOldSbxFlags = pDlg->GetFlags();
		pDlg->SetFlags( nOldSbxFlags | SBX_NO_MODIFY );
	}
	~VCSVModelessDialog();
};

//------------------------------------------------------------------------

void VCSVModelessDialog::Activate()
{
	SbxInfoRef rInfo = pSbxDialog->GetInfo();
	if( rInfo.Is() )
		SfxHelp::SetCustomHelpFile( rInfo->GetHelpFile() );
	pSbxDialog->Activate();
}

//------------------------------------------------------------------------

void VCSVModelessDialog::Deactivate()
{
	SfxHelp::SetCustomHelpFile( String() );
	pSbxDialog->Deactivate();
}

//------------------------------------------------------------------------
VCSVModelessDialog::~VCSVModelessDialog()
{
	pSbxDialog->SetFlags( nOldSbxFlags );
}

//------------------------------------------------------------------------
void VCSVModelessDialog::GetFocus()
{
	pSbxDialog->GetFocus();
}

//------------------------------------------------------------------------
void VCSVModelessDialog::LoseFocus()
{
	pSbxDialog->LoseFocus();
}

//------------------------------------------------------------------------
void VCSVModelessDialog::MouseButtonDown( const MouseEvent& rMEvt )
{
	ModelessDialog::MouseButtonDown( rMEvt );
	pSbxDialog->MouseButtonDown( rMEvt );
}

//------------------------------------------------------------------------
void VCSVModelessDialog::MouseButtonUp( const MouseEvent& rMEvt )
{
	ModelessDialog::MouseButtonUp( rMEvt );
	pSbxDialog->MouseButtonUp( rMEvt );
}

//------------------------------------------------------------------------
void VCSVModelessDialog::MouseMove( const MouseEvent& rMEvt )
{
	ModelessDialog::MouseMove( rMEvt );
	pSbxDialog->MouseMove( rMEvt );
}

//------------------------------------------------------------------------
void VCSVModelessDialog::KeyInput( const KeyEvent& rKEvt )
{
	ModelessDialog::KeyInput( rKEvt );

	pSbxDialog->KeyInput( rKEvt );
}

//------------------------------------------------------------------------
void VCSVModelessDialog::Resize()
{
	pSbxDialog->Resize();
}

//------------------------------------------------------------------------
BOOL VCSVModelessDialog::Close()
{
	if( (GetParent() == SI_DLL()->GetActiveWindow()) &&
		!GetParent()->IsEnabled() )
		GetParent()->Enable();

	return ModelessDialog::Close();
}

void VCSVModelessDialog::RequestHelp( const HelpEvent& rHEvt )
{
	if( (rHEvt.GetMode() & HELPMODE_CONTEXT) )
	{
		SbxInfoRef rInfo = pSbxDialog->GetInfo();
		if( rInfo.Is() && rInfo->GetHelpFile().Len() && rInfo->GetHelpId() )
		{
			ByteString aStrTmp( rInfo->GetHelpFile(), RTL_TEXTENCODING_ASCII_US );
			SfxHelp::ShowHelp( rInfo->GetHelpId(), TRUE, aStrTmp.GetBuffer() );
			return;
		}

	}
	ModelessDialog::RequestHelp( rHEvt );
}

#ifdef VCL

long VCSVModelessDialog::PreNotify( NotifyEvent& rNEvt )
{
	long nResult = ModelessDialog::PreNotify( rNEvt );
	return nResult;
}

#endif


TYPEINIT1( VCSbxDialog, VCSbxForm )

void VCSbxDialog::CreateSVDialog()
{
	if( pDlg )
		DeleteSVDialog();

	pRunTimeItemSet = pItemSet->Clone();

	// Per Default vom System positionieren lassen Pos = (-1,-1)
	SfxInt32Item aItm( VCATTR_LEFT, -1 );
	pRunTimeItemSet->Put( aItm );
	aItm.SetWhich( VCATTR_TOP );
	pRunTimeItemSet->Put( aItm );

	long nX = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LEFT )).GetValue();
	long nY	= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_TOP )).GetValue();

	BOOL    bSVLook = ((SfxBoolItem&)pRunTimeItemSet->Get(VCATTR_AUTO3D)).GetValue();
	WinBits nSVLook = 0;
	if( bSVLook )
		nSVLook = WB_3DLOOK;

	Window* pParent = SI_DLL()->GetActiveWindow();
	pDlg = new VCSVModelessDialog( pParent, this, WB_STDMODELESS | nSVLook );

	// Damit wir spaeter unsere Dialoge erkennen koennen
	pDlg->SetData( &cVCSbxDialogCheck );

	// Controls zusammenholen
	USHORT nCount = GetObjects()->Count();
	USHORT nCreated;
	long nCurStep = ((SfxInt32Item&)pRunTimeItemSet->Get(VCATTR_CURRENTSTEP)).GetValue();
	for( nCreated=0; nCreated < nCount; )
	{
		for( USHORT j=0; j < nCount; j++ )
		{
			VCSbxControl* pObj = (VCSbxControl*)GetObjects()->Get( j );
			if( pObj->ISA(VCSbxControl) )
			{
				if( pObj->GetTabPos() == nCreated )
				{
					pObj->CreateSVControl( pDlg );
					pObj->UpdateSVControl();
					pObj->UpdateStep( nCurStep );
					nCreated++;
					break;
				}
			}
		}
	}

	USHORT ePointer = (USHORT)((VCMousePointerItem&)pRunTimeItemSet->
		Get(VCATTR_MOUSEPOINTER)).GetValue();

	PointerStyle eSVPointer;
	switch( ePointer )
	{
		case VCPOINTER_DEFAULT:
		case VCPOINTER_ARROW:      eSVPointer = POINTER_ARROW; break;
		case VCPOINTER_CROSS:      eSVPointer = POINTER_CROSS; break;
		case VCPOINTER_IBEAM:      eSVPointer = POINTER_TEXT;  break;
		case VCPOINTER_ICON:       eSVPointer = POINTER_ARROW; break;
		case VCPOINTER_SIZE:       eSVPointer = POINTER_MOVE;  break;
		case VCPOINTER_NE_SW:      eSVPointer = POINTER_NESIZE; break;
		case VCPOINTER_N_S:        eSVPointer = POINTER_HSPLIT;   break;
		case VCPOINTER_NW_SE:      eSVPointer = POINTER_SESIZE; break;
		case VCPOINTER_W_E:        eSVPointer = POINTER_VSPLIT;   break;
		case VCPOINTER_UPARROW:    eSVPointer = POINTER_REFHAND;  break;
		case VCPOINTER_HOURGLASS:  eSVPointer = POINTER_WAIT;     break;
		case VCPOINTER_NODROP:     eSVPointer = POINTER_NOTALLOWED;break;
	}

	if( ePointer == VCPOINTER_DEFAULT )
		pDlg->SetPointer( Pointer() );
	else
		pDlg->SetPointer( Pointer( eSVPointer ) );
	//pDlg->EnableChildPointerOverwrite();
}

void VCSbxDialog::DeleteSVDialog()
{
	if( pDlg )
	{
		//pDlg->Hide();
		MethodHide( 0,0,FALSE );
		// Basic-Eventhandler rufen
		Unload();
		// wurde Dialog durch Unload-Makro geloescht? (rekursives unload)
		if( pDlg )
		{
			// Haben wir einen Basic-Dialog als Child ?
			USHORT i;
#ifndef VCL
			USHORT nChilds = pDlg->GetChildCount();
			for( i=0; i < nChilds; i++ )
			{
				// Ein Basic-Dialog ?
				// Dann zerstoeren wir ihn nicht
				if( pDlg->GetChild(i)->GetData() == &cVCSbxDialogCheck )
				{
					SetMarkToUnload( TRUE );
					return;
				}
			}
#else
			Window* pWindow = pDlg->GetWindow( WINDOW_OVERLAP );
			Window* pOverlap = pWindow->GetWindow( WINDOW_FIRSTOVERLAP );
			while ( pOverlap )
			{
				Window* pClient = pOverlap->GetWindow( WINDOW_CLIENT );
				if( pClient && pClient->GetData() == &cVCSbxDialogCheck )
				{
					SetMarkToUnload( TRUE );
					return;
				}
				pOverlap = pOverlap->GetWindow( WINDOW_NEXT );
			}
#endif
			delete pRunTimeItemSet;
			pRunTimeItemSet = NULL;

			USHORT nCount = GetObjects()->Count();
			for( i=0; i < nCount; i++ )
			{
				SbxVariable* pObj = GetObjects()->Get( i );
				DBG_ASSERT( pObj->IsA( TYPE( VCSbxControl ) ), "Is sich nix Control !!!" );
				((VCSbxControl*)pObj)->DeleteSVControl();
			}

			delete pDlg;
			pDlg = NULL;
		}
	}

	SetMarkToUnload( FALSE );
}

void VCSbxDialog::UpdateSVDialog( USHORT nWhich )
{
	if( !pDlg )
		return;

	// Basic-Eventhandler rufen
	Load();

	// Position setzen
	if( !nWhich || (nWhich==VCATTR_LEFT) || (nWhich==VCATTR_TOP) )
	{
		if( (pRunTimeItemSet->GetItemState( VCATTR_LEFT ) == SFX_ITEM_SET) ||
			(pRunTimeItemSet->GetItemState( VCATTR_TOP )  == SFX_ITEM_SET)    )
		{
			long nX = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LEFT )).GetValue();
			long nY	= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_TOP )).GetValue();
			// Position -1,-1 ==> System-Default nehmen
			if( nX != -1 && nY != -1 )
			{
				Point aPt = SI_DLL()->GetOutDev()->
								LogicToPixel( Point( nX, nY ), MapMode( MAP_TWIP ) );
				pDlg->SetPosPixel( aPt );
			}
		}
	}

	// Groesse setzen
	if( !nWhich || (nWhich==VCATTR_WIDTH) || (nWhich==VCATTR_HEIGHT) )
	{
		const OutputDevice* pOut = SI_DLL()->GetOutDev();
		long nWidth = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_WIDTH )).GetValue();
		long nHeight= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_HEIGHT )).GetValue();
		if( !nWidth && !nHeight )
		{
			// Dieser Fall tritt auf, wenn im Verwalten-Dialog der BasicIDE
			// ein neuer Dialog eingefuegt und dann angezeigt wird, ohne ihn
			// vorher im Dialogeditor bearbeitet zu haben
			// siehe vcdlged/vced.cxx::Paint
			Size aDefaultSize( 400, 300 );
			aDefaultSize = pOut->PixelToLogic( aDefaultSize, MapMode(MAP_TWIP) );
			nWidth = aDefaultSize.Width();
			nHeight = aDefaultSize.Height();
		}

		Size aSize( nWidth, nHeight-GetCaptionHeight() );
		if( !((const SfxBoolItem&)pRunTimeItemSet->Get(VCATTR_AUTOADJUST_SIZE)).GetValue())
		{
			aSize = pOut->LogicToPixel( aSize, MapMode( MAP_TWIP ) );
		}
		else
		{
#ifndef WIN
			Fraction aFracX( 1, 26 );
#else
			Fraction aFracX( 1, 23 );
#endif
			Fraction aFracY( 1, 24 );
			MapMode aMap( MAP_APPFONT, Point(), aFracX, aFracY );
			aSize = pOut->LogicToPixel( aSize, aMap );
		}
		pDlg->SetOutputSizePixel( aSize );
	}

	// Farben setzen
	if( !nWhich ||
		(nWhich==VCATTR_BACKCOLOR) ||
		(nWhich==VCATTR_FORECOLOR) ||
		(nWhich==VCATTR_BACKSTYLE)    )
	{
		BOOL bSVLook = ((SfxBoolItem&)pRunTimeItemSet->Get(VCATTR_AUTO3D)).GetValue();
		if( !bSVLook )
		{
			Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
			Color aBackCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_BACKCOLOR )).GetValue();

			pDlg->SetBackground( Wallpaper( aBackCol ) );

			pDlg->SetFillColor( aBackCol );
		}
	}

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		pDlg->SetText( aCaption );
	}

	// Hilfetext und Id setzen
	if( !nWhich || (nWhich==VCATTR_HELPTEXT) || (nWhich==VCATTR_HELPCONTEXTID) )
	{
		long nHelpId  = 0; //((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_HELPCONTEXTID )).GetValue();
		String aHelpText= ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_HELPTEXT )).GetValue();
		SbxInfoRef rInfo = GetInfo();
		if( rInfo.Is() )
			nHelpId = rInfo->GetHelpId();
		pDlg->SetHelpId( (ULONG)nHelpId );
		pDlg->SetHelpText( aHelpText );
	}
}

void VCSbxDialog::MethodShow( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	// Falls noch nicht geladen, jetzt tun
	if( IsMarkToUnload() )
		DeleteSVDialog();
	if( !pDlg )
	{
		CreateSVDialog();
		UpdateSVDialog();
	}

	// In die Liste der aktiven Dialoge aufnehmen
	SiDLL* pSiDLL = (SiDLL*)(*GetAppData( SHL_SI ));
	pSiDLL->AddSbxDlg( this );

	// Erstmal nur als modalen Dialog
	Window* pOldParent = GetpApp()->GetDefDialogParent();
	GetpApp()->SetDefDialogParent( pDlg );
	pDlg->Show();
	Window* pAppWin = SI_DLL()->GetActiveWindow();
	pAppWin->EnableInput( FALSE, TRUE );
	BasicIDE::IncBasicDialogCount();
	while( pDlg && pDlg->IsVisible() )
	{
		GetpApp()->Yield();
#if 0
		if( pAppWin->IsInputEnabled())
			pAppWin->EnableInput( FALSE, TRUE );
#endif
	}
	BasicIDE::DecBasicDialogCount();
	pAppWin->EnableInput( TRUE, TRUE );
	GetpApp()->SetDefDialogParent( pOldParent );

	// Aus der Liste der aktiven Dialoge entfernen
	pSiDLL->RemoveSbxDlg( this );

	// Wenn fuer Unload vorgemerkt, dann loeschen
	if( IsMarkToUnload() )
		DeleteSVDialog();
}

void VCSbxDialog::MethodHide( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	if( pDlg )
	{
		GetpApp()->SetDefDialogParent( pDlg->GetParent() );
#if 1
		pDlg->Hide();
#else

#if !defined(WNT) && !defined(OS2) && !defined(WIN)
		pDlg->Hide();
#else
		// Sonderbehandlung: Verhindern, dass eine im Hintergrund liegende
		// Applikation beim Hide des Dialoges in den Vordergrund kommt.
		// Dies tritt ein, wenn der Parent des Dialoges 'disabelt' oder
		// unsichtbar ist.
		Window* pParent = pDlg->GetParent();
		if( pParent && (!pParent->IsEnabled() || !pParent->IsVisible()))
		{
			if( pParent->IsVisible() )
			{
				pParent->Enable();
				pDlg->Hide();
			}
			else
			{
				pDlg->Hide();
				SiDLL* pSiDLL = (SiDLL*)(*GetAppData( SHL_SI ));
				USHORT nDlgCount = pSiDLL->GetSbxDlgCount();
				// DBG_ASSERT(nDlgCount>=1,"Bad dialog count");
				// Liste von hinten aufrollen
				while( nDlgCount )
				{
					VCSbxDialog* pCurDlg = pSiDLL->GetSbxDlg(nDlgCount-1);
					Dialog* pCurSVDlg = pCurDlg->GetDialog();
					if( pCurSVDlg && pCurSVDlg != pDlg && pCurSVDlg->IsVisible() )
					{
						pCurSVDlg->Enable();
						pCurSVDlg->GrabFocus();
						break;
					}
					nDlgCount--;
				}
				// haben wir einen Dialog gefunden?
				if( !nDlgCount )
				{
					// nein, deshalb das Applikationsfenster aktivieren
					SI_DLL()->GetActiveWindow()->Enable();
					SI_DLL()->GetActiveWindow()->GrabFocus();
				}
			}
		}
		else
			pDlg->Hide();
#endif

#endif // #if 1
	}
}

void VCSbxDialog::MethodLoad( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	if( !pDlg )
	{
		CreateSVDialog();
		UpdateSVDialog();
	}
}

void VCSbxDialog::MethodUnload( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	if( !pDlg )
		return;

	if( IsInCallBack() )
	{
		SetMarkToUnload();
		MethodHide( 0,0,FALSE );
		// pDlg->Hide();
	}
	else
		DeleteSVDialog();
}

void VCSbxDialog::MethodMove( SbxVariable* pVar, SbxArray* pPar, BOOL )
{
	if( !pPar || (pPar->Count() < 2) || (pPar->Count() > 5) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	USHORT nArgs = pPar->Count();

	if( !pRunTimeItemSet )
		return;

	SfxInt32Item aItem( VCATTR_LEFT, pPar->Get(1)->GetInteger() );
	pRunTimeItemSet->Put( aItem );

	if( nArgs > 2 )
	{
		SfxInt32Item aItem( VCATTR_TOP, pPar->Get(2)->GetInteger() );
		pRunTimeItemSet->Put( aItem );
	}
	if( nArgs > 3 )
	{
		SfxInt32Item aItem( VCATTR_WIDTH, pPar->Get(3)->GetInteger() );
		pRunTimeItemSet->Put( aItem );
	}
	if( nArgs > 4 )
	{
		SfxInt32Item aItem( VCATTR_HEIGHT, pPar->Get(4)->GetInteger() );
		pRunTimeItemSet->Put( aItem );
	}

	// X,Y bzw WIDTH,HEIGHT werden jeweils zusammen refreshed
	UpdateSVDialog( VCATTR_LEFT );
	UpdateSVDialog( VCATTR_WIDTH );
}

void VCSbxDialog::MethodRefresh( SbxVariable*, SbxArray*, BOOL )
{
}

void VCSbxDialog::MethodSetFocus( SbxVariable*, SbxArray* pPar, BOOL )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
	if( pDlg )
	{
		pDlg->GrabFocus();
	}
}

void VCSbxDialog::SortControls()
{
	// Controls zusammenholen
	USHORT nCount = GetObjects()->Count();
	USHORT i, nMarker = 0;
	BOOL   bChanged;

	if( nCount < 2 )
		return;

	do
	{
		bChanged = FALSE;
		for( i=nMarker; i < nCount-1; i++ )
		{
			SbxVariableRef xObj1 = GetObjects()->Get(i);
			SbxVariableRef xObj2 = GetObjects()->Get(i+1);

			DBG_ASSERT( xObj1->IsA( TYPE( VCSbxControl ) ) , "Is sich nix Control !!!" );
			DBG_ASSERT( xObj2->IsA( TYPE( VCSbxControl ) ) , "Is sich nix Control !!!" );

			if( ((VCSbxControl*)(SbxVariable*)xObj1)->GetTabPos() >
				((VCSbxControl*)(SbxVariable*)xObj2)->GetTabPos()   )
			{
				GetObjects()->Put( xObj2, i );
				GetObjects()->Put( xObj1, i+1 );
				nMarker  = i;
				bChanged = TRUE;
			}
		}
	}while( bChanged );
}

VCSbxDialog::VCSbxDialog() :
	VCSbxForm( new VCContainer ),
	pDrawObject(NULL),
	pDlg(NULL),
	bTestMode(FALSE),
	nInCallBack(0),
	bMarkToUnload(FALSE)
{
	aClassName = String( SiResId( STR_CLASS_DIALOG ) );

	SetFlags( SBX_READWRITE );

	// Dialoge im Gegensatz zu Doc-Containern (Forms) nicht "durchsichtig"
	ResetFlag( SBX_EXTSEARCH );

	pItemSet = new SfxItemSet( *pPool,
							   VCATTR_NAME, VCATTR_NAME,
							   VCATTR_HELPTEXT, VCATTR_TAG,
							   VCATTR_LEFT, VCATTR_HEIGHT,
							   VCATTR_BACKCOLOR, VCATTR_CAPTION,
							   VCATTR_AUTO3D, VCATTR_CURRENTSTEP,
							   VCATTR_DBLCLICK, VCATTR_MOUSEUP,
							   VCATTR_ACTIVATE, VCATTR_RESIZE,
							   VCATTR_MACROS, VCATTR_MACROS,
							   VCATTR_AUTOADJUST_SIZE, VCATTR_AUTOADJUST_SIZE,
							   NULL );

	// Name Property selbst verarbeiten
	SbxVariable* p = Find( String( SiResId( STR_ATTR_NAME ) ),
						   SbxCLASS_PROPERTY );
	DBG_ASSERT( p, "Keine Name Property" );
	p->SetUserData( VCATTR_NAME );
	p->SetFlag( SBX_DONTSTORE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "OutputWidth" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_OUTPUTWIDTH );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "OutputHeight" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_OUTPUTHEIGHT );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Show" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SHOW );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Hide" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_HIDE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Load" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_LOAD );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Unload" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_UNLOAD );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Move" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_MOVE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
}

VCSbxDialog::~VCSbxDialog()
{
	if( pDlg )
		DeleteSVDialog();


	// Alle Subobjecte schon hier aus der Form entfernen, damit der Pool
	// nicht vor den Objekten geloescht wird
	USHORT nCount = GetObjects()->Count();
	for( USHORT nCur=0; nCur < nCount; nCur++ )
	{
		SbxVariable* pObj = GetObjects()->Get( 0 );
		DBG_ASSERT( pObj->IsA( TYPE( VCSbxControl ) ), "Is sich nix Control !!!" );
		// SetParentBetter removed Objekte ausm Array
		((VCSbxControl*)pObj)->SetParentBetter( NULL );
	}

	delete pContainer;
}

SbxVariable* VCSbxDialog::Find( const String& rName, SbxClassType eType )
{
	return VCSbxForm::Find( rName, eType );
}

void VCSbxDialog:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						  const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_BASICSTOP )
		{
			if( !IsTestModeEnabled() )
				DeleteSVDialog();
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArrayRef  pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		// Methoden verwalten
		if( pVar->IsA( TYPE( SbxMethod ) ) &&
			(pHint->GetId() == SBX_HINT_DATAWANTED) )
		{
			switch( nWhich )
			{
				case VCMETH_SHOW:	MethodShow( pVar, pPar, FALSE ); return;
				case VCMETH_HIDE:	MethodHide( pVar, pPar, FALSE ); return;
				case VCMETH_LOAD:	MethodLoad( pVar, pPar, FALSE ); return;
				case VCMETH_UNLOAD: MethodUnload( pVar, pPar, FALSE ); return;
				case VCMETH_MOVE:   MethodMove( pVar, pPar, FALSE ); return;
				case VCMETH_SETFOCUS: MethodSetFocus( pVar, pPar, FALSE ); return;
			}
		}

		// interne Properties
		switch( nWhich )
		{
			case VCATTR_IMP_OUTPUTWIDTH:	PropOutputWidth( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_OUTPUTHEIGHT:	PropOutputHeight( pVar, pPar, bWrite ); return;
		}

		// Der Rest fuer die Basisklasse
		VCSbxForm:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );

		if( bWrite && nWhich == VCATTR_CURRENTSTEP )
		{
			// Zusaetzlich Controls verwalten
			SfxItemSet* pItemSet = VCSbxForm::pItemSet;
			if( pRunTimeItemSet )
				pItemSet = pRunTimeItemSet;
			long nCurStep = ((SfxInt32Item&)pItemSet->Get( VCATTR_CURRENTSTEP )).GetValue();

			USHORT nCount = GetObjects()->Count();
			USHORT i;
#ifdef VCL
			for( i=0; i < nCount; i++ )
			{
				VCSbxControl* pObj = (VCSbxControl*)GetObjects()->Get( i );
				pObj->UpdateStep( nCurStep );
			}
#endif
			for( i=0; i < nCount; i++ )
			{
				SbxVariable* pObj = GetObjects()->Get( i );
				DBG_ASSERT( pObj->IsA( TYPE( VCSbxControl ) ), "Is sich nix Control !!!" );
				((VCSbxControl*)pObj)->UpdateStep( nCurStep );
			}
			return;
		}

	}
}

void VCSbxDialog::SetPos( const Point& rPos, BOOL bMoveChilds )
{
	if( pDrawObject )
		pDrawObject->SendRepaintBroadcast();

	Point aOldPos = GetPos();
	Point aMove;
	aMove.X() = rPos.X() - aOldPos.X();
	aMove.Y() = rPos.Y() - aOldPos.Y();
	VCSbxForm::SetPos( rPos );

	// Childs mitnehmen
	if( bMoveChilds )
	{
		ULONG nChilds = pContainer->GetChildCount();
		Rectangle aOldDlgRect( aOldPos, GetSize() );
		for( ULONG i=0; i < nChilds; i++ )
		{
			VCControl* pCtrl = pContainer->GetChildByPos( i );

			Point aPos  	= pCtrl->GetPos();
			Point aTempPos	= aPos;
			aTempPos	   += aOldPos;
			Size  aSize= pCtrl->GetSize();

			// Wenn die Objekte drin sind, regelt sich alles ueber den Offset
			// Sonst muss die Summe aus Offset und Position gleich gehalten werden
			if( !aOldDlgRect.IsInside( Rectangle( aTempPos, aSize ) ) )
			{
				aPos -= aMove;
				pCtrl->SetPos( aPos );
			}
			else
				pCtrl->SetPos( aPos );
			// Hack as Hack can. Brauchen wir im Office 5.0 nicht mehr? Flag wird ausgewertet
			// in vcdrwobj.cxx::nbcmove
			// pCtrl->SetFlags( pCtrl->GetFlags() | 0x0001 );
		}
	}

	if( pDrawObject )
	{
		pDrawObject->SetRectsDirty();
		pDrawObject->SendRepaintBroadcast();
	}
}

void VCSbxDialog::SetSize( const Size& rSize )
{
	if( pDrawObject )
		pDrawObject->SendRepaintBroadcast();

	VCSbxForm::SetSize( rSize );

	if( pDrawObject )
	{
		pDrawObject->SetRectsDirty();
		pDrawObject->SendRepaintBroadcast();
	}
}

void VCSbxDialog::SetPosDefault()
{
	pItemSet->ClearItem( VCATTR_LEFT );
	pItemSet->ClearItem( VCATTR_TOP );
}

long VCSbxDialog::GetCaptionHeight() const
{
	return 240;    //240 Twips
}

void VCSbxDialog::Draw( OutputDevice* pOut )
{
	Color aOldLineColor( pOut->GetLineColor() );
	Color aOldFillColor( pOut->GetFillColor() );
	Font aOldFont( pOut->GetFont() );
	const StyleSettings& rSettings = pOut->GetSettings().GetStyleSettings();

	pOut->SetLineColor( Color( COL_BLACK ) );
	pOut->SetFillColor();

	Font aFont( GetpApp()->GetSettings().GetStyleSettings().GetAppFont() );
	aFont.SetSize( pOut->PixelToLogic( aFont.GetSize(), MapMode( MAP_TWIP ) ) );
	aFont.SetTransparent( TRUE );
	pOut->SetFont( aFont );

	SfxItemSet* pItemSet = VCSbxForm::pItemSet;
	if( pRunTimeItemSet )
		pItemSet = pRunTimeItemSet;

	String  aCaption( ((SfxStringItem&)pItemSet->Get( VCATTR_CAPTION )).GetValue() );
	long aTextWidth( pOut->GetTextWidth( aCaption ) );
	long nCaptionHeight = GetCaptionHeight();

	Point aPos( GetPos() );
	Size  aSize( GetSize() );
	Point aTextPos;
	aTextPos.X() = aPos.X() + (aSize.Width()>>1) - (aTextWidth>>1);
	aTextPos.Y() = aPos.Y()+1;
	pOut->DrawRect( Rectangle( aPos, Size( aSize.Width(), nCaptionHeight ) ) );
	pOut->DrawText( aTextPos, aCaption );

	BOOL bAuto3D = ((SfxBoolItem&)pItemSet->Get( VCATTR_AUTO3D )).GetValue();

	if( bAuto3D )
		pOut->SetFillColor( rSettings.GetFaceColor() );
	else
	{
		Color aBackCol = ((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue();
		pOut->SetFillColor( aBackCol );
	}

	aPos.Y() += nCaptionHeight + 1;
	aSize.Height() -= nCaptionHeight + 2;
	pOut->DrawRect( Rectangle( aPos, aSize ) );

	pOut->SetLineColor( aOldLineColor );
	pOut->SetFillColor( aOldFillColor );
	pOut->SetFont( aOldFont );
}

void VCSbxDialog::EnableTestMode( BOOL bEnable )
{
	if( bEnable == bTestMode )
		return;

	bTestMode = bEnable;

	if( bEnable )
	{
		CreateSVDialog();
		UpdateSVDialog();

		Window* pOldParent = GetpApp()->GetDefDialogParent();
		GetpApp()->SetDefDialogParent( pDlg );
		pDlg->Show();
		SI_DLL()->GetActiveWindow()->EnableInput( FALSE, TRUE );
		while( pDlg && pDlg->IsVisible() )
	{
			GetpApp()->Yield();
	}
		SI_DLL()->GetActiveWindow()->EnableInput( TRUE, TRUE );

		pDlg->Hide();
		GetpApp()->SetDefDialogParent( pOldParent );

		// Und gleich wieder in die Tonne
		DeleteSVDialog();
		bTestMode = FALSE;
	}
	else
		DeleteSVDialog();
}

void VCSbxDialog::SnapShot( Bitmap& rBmp )
{
	CreateSVDialog();
	UpdateSVDialog();
	pDlg->Show();
	pDlg->Update();
	rBmp = pDlg->SnapShot();
	pDlg->Hide();
	DeleteSVDialog();
}

void VCSbxDialog::Activate()
{
	ExecuteHandler( VCHDL_ONACTIVATE );
}

void VCSbxDialog::Deactivate()
{
	ExecuteHandler( VCHDL_ONDEACTIVATE );
}

void VCSbxDialog::GetFocus()
{
	ExecuteHandler( VCHDL_ONGETFOCUS );
}

void VCSbxDialog::LoseFocus()
{
	ExecuteHandler( VCHDL_ONLOSEFOCUS );
}

void VCSbxDialog::MouseButtonDown( const MouseEvent& rMEvt )
{
	ExecuteHandler( VCHDL_ONMOUSEDOWN, &rMEvt );
	if( rMEvt.GetClicks() == 2 )
		ExecuteHandler( VCHDL_ONDBLCLICK );
}

void VCSbxDialog::MouseMove( const MouseEvent& rMEvt )
{
	ExecuteHandler( VCHDL_ONMOUSEMOVE, &rMEvt );
}

void VCSbxDialog::MouseButtonUp( const MouseEvent& rMEvt )
{
	ExecuteHandler( VCHDL_ONMOUSEUP, &rMEvt );
}

void VCSbxDialog::KeyInput( const KeyEvent& rKEvt )
{
	ExecuteHandler( VCHDL_ONKEYINPUT, 0, &rKEvt );
}

void VCSbxDialog::Resize()
{
	ExecuteHandler( VCHDL_ONRESIZE );
}

void VCSbxDialog::Load()
{
	ExecuteHandler( VCHDL_ONLOAD );
}

void VCSbxDialog::Unload()
{
	ExecuteHandler( VCHDL_ONUNLOAD );
}

void VCSbxDialog::SetDrawObject( VCSbxDialogObject* pDrwObj )
{
	pDrawObject = pDrwObj;
}

void VCSbxDialog::UpdateItem( USHORT nWhich )
{
	SfxItemSet* pItemSet = VCSbxForm::pItemSet;
	if( pRunTimeItemSet )
		pItemSet = pRunTimeItemSet;

	// SV-Look geaendert
	if( !nWhich || (nWhich == VCATTR_AUTO3D) )
	{
		// Container umschalten
		BOOL bSVLook = ((SfxBoolItem&)pItemSet->Get( VCATTR_AUTO3D )).GetValue();
		pContainer->SetSVLook( bSVLook );
		if( nWhich == VCATTR_AUTO3D )
		{
			USHORT nCount = GetObjects()->Count();
			for( USHORT i=0; i < nCount; i++ )
			{
				VCSbxControl* pObj = (VCSbxControl*)GetObjects()->Get( i );
				if( pObj->GetVCControl() )
					pObj->GetVCControl()->GetImpControl()->Update( TRUE, nWhich );
			}
		}
	}

	// CurrentStep
	if( (!nWhich || (nWhich == VCATTR_CURRENTSTEP)) && pDrawObject )
	{
		// Zusaetzlich Controls verwalten
		long nCurStep = ((SfxInt32Item&)pItemSet->Get( VCATTR_CURRENTSTEP )).GetValue();

		USHORT nCount = GetObjects()->Count();
		USHORT i;
		for( i=0; i < nCount; i++ )
		{
			SbxVariable* pObj = GetObjects()->Get( i );
			DBG_ASSERT( pObj->IsA( TYPE( VCSbxControl ) ), "Is sich nix Control !!!" );
			((VCSbxControl*)pObj)->UpdateStep( nCurStep );
		}
	}

	if( nWhich == VCATTR_NAME )
	{
		String aName = ((SfxStringItem&)pItemSet->Get( VCATTR_NAME )).GetValue();
		SetName( aName );
	}

	if( pRunTimeItemSet )
		UpdateSVDialog( nWhich );
}

long VCSbxDialog::GetCurStep() const
{
	if( pRunTimeItemSet )
		return ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_CURRENTSTEP )).GetValue();
	else
		return ((SfxInt32Item&)pItemSet->Get( VCATTR_CURRENTSTEP )).GetValue();
}

void VCSbxDialog::SetCurStep( long nStep )
{
	SfxInt32Item aItem( VCATTR_CURRENTSTEP, nStep );
	if( pRunTimeItemSet )
		pRunTimeItemSet->Put( aItem );
	else
		pItemSet->Put( aItem );

	UpdateItem( VCATTR_CURRENTSTEP );
}

BOOL VCSbxDialog::IsSVLook() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_AUTO3D )).GetValue();
}

BOOL VCSbxDialog::LoadPrivateData( SvStream& rStream, USHORT nVersion )
{
	CharSet eOldCharSet = rStream.GetStreamCharSet( );
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	BOOL bRet = VCSbxForm::LoadPrivateData( rStream, nVersion );

	if( bRet )
	{
		UINT32 nMyVer;
		rStream >> nMyVer;
		if( nMyVer != 0x13081961 )
		{
			rStream.SetStreamCharSet( eOldCharSet );
			return TRUE;
		}

		pItemSet->Load( rStream );
		VCControl::SetNewHandlers( pItemSet, Type(), TRUE );
		UpdateItem(0);
	}

	rStream.SetStreamCharSet( eOldCharSet );
	return bRet;
}

BOOL VCSbxDialog::StorePrivateData( SvStream& rStream ) const
{
	CharSet eOldCharSet = rStream.GetStreamCharSet( );
	rStream.SetStreamCharSet( RTL_TEXTENCODING_MS_1252 );

	// alte Handler muessen vor dem Speichern des Pools gesetzt werden!
	VCControl::SetOldHandlers( pItemSet, Type(), TRUE );
	BOOL bRet = VCSbxForm::StorePrivateData( rStream );

	if( bRet )
	{
		UINT32 nMyVer = 0x13081961;
		rStream << nMyVer;
		pItemSet->Store( rStream );
	}

	((VCSbxDialog*)this)->SortControls();

	rStream.SetStreamCharSet( eOldCharSet );
	return bRet;
}

SvStream& operator<<(SvStream& rOut, const VCSbxDialog& rSbxDialog)
{
	DBG_ASSERT( FALSE, "Eintritt verboten!!!" );
	return rOut;
}

SvStream& operator>>(SvStream& rIn, VCSbxDialog& rSbxDialog)
{
	DBG_ASSERT( FALSE, "Eintritt verboten!!!" );
	return rIn;
}

void VCSbxDialog::SetInCallBack( BOOL bInCallBack )
{
	if( bInCallBack )
		nInCallBack++;
	else
	if( nInCallBack )
		nInCallBack--;
}

BOOL VCSbxDialog::IsInCallBack() const
{
	if( nInCallBack )
		return TRUE;
	else
		return FALSE;
}

BOOL VCSbxDialog::Call( const String& rName, SbxArray* pPar )
{
	// Haben wir ein Basic, wenn nicht dann besorgen
	SbxObject* p = this;
	BOOL bBasFound = FALSE;
	while( (p = p->GetParent()) != NULL )
		if( p->IsA( TYPE( StarBASIC ) ) )
		{
			bBasFound = TRUE;
			break;
		}

	if( !bBasFound )
	{
		if( pDrawObject )
		{
			SdrPage* pPage = pDrawObject->GetPage();
			if( pPage && (pPage->IsA( TYPE( VCDrawPage ) ) ) )
				((VCDrawPage*)pPage)->RequestBasic();
		}
	}

	SetInCallBack( TRUE );

	String aMacro( rName );
	// ist der Name voll qualifiziert?
	if( aMacro.GetTokenCount( '.' ) == 3 )
	{
		xub_StrLen nLast = 0;
		String aLibName = aMacro.GetToken( 0, '.', nLast );
		String aModul = aMacro.GetToken( 0, '.', nLast );
		aMacro.Erase( 0, nLast );
	}

	BOOL bRet = SbxObject::Call( aMacro, pPar );
	SetInCallBack( FALSE );
	return bRet;
}


ErrCode VCSbxDialog::ExecuteHandler( USHORT nHandlerId,
	const MouseEvent* pMEvt, const KeyEvent* pKEvt )
{
	SfxItemSet* pItemSet = VCSbxForm::pItemSet;
	if( pRunTimeItemSet )
		pItemSet = pRunTimeItemSet;

	ErrCode eErr = 0;
	if( pItemSet && pItemSet->GetItemState(VCATTR_MACROS) != SFX_ITEM_UNKNOWN)
	{
		const SvxMacroItem& rItm = (const SvxMacroItem&)(pItemSet->Get(VCATTR_MACROS));
		if( !rItm.HasMacro( nHandlerId ) )
			return eErr;
		const SvxMacro& rMacro = rItm.GetMacro( nHandlerId );

		if( rMacro.GetScriptType() != STARBASIC )
			return eErr;  // Dialoge gibts nur in Basic

		String aReferer( VCControl::GetReferer( this ) );
		SfxApplication* pApp = SFX_APP();
		if ( aReferer.Len() && !pApp->IsSecureURL( INetURLObject( "macro:" ), &aReferer ) )
		{
			ErrorHandler::HandleError( ERRCODE_IO_ACCESSDENIED );
			return ERRCODE_IO_ACCESSDENIED;
		}

		VCDrawModel* pModel = pDrawObject ? (VCDrawModel*)pDrawObject->GetModel() : 0;
		SbxArray* pArray = 0;

		if( pMEvt )
		{
			pArray = new SbxArray;
			SbxVariable* pButtons = new SbxVariable;
			INT16       nButtons = 0;
			if( pMEvt->IsLeft() )  nButtons += 1;
			if( pMEvt->IsRight())  nButtons += 2;
			if( pMEvt->IsMiddle()) nButtons += 4;
			pButtons->PutInteger( nButtons );

			SbxVariable* pShift = new SbxVariable;
			INT16       nShift = 0;
			if( pMEvt->IsShift() ) nShift += 1;
			if( pMEvt->IsMod1() )  nShift += 2;
			if( pMEvt->IsMod2() )  nShift += 4;
			pShift->PutInteger( nShift );

			Point aPos = pMEvt->GetPosPixel();
			aPos = SI_DLL()->GetOutDev()->PixelToLogic( aPos, MapMode( MAP_TWIP ) );

			SbxVariable* pX = new SbxVariable;
			pX->PutInteger( (INT16)aPos.X() );

			SbxVariable* pY = new SbxVariable;
			pY->PutInteger( (INT16)aPos.Y() );

			pArray->Put( pButtons, 1 );
			pArray->Put( pShift, 2 );
			pArray->Put( pX, 3 );
			pArray->Put( pY, 4 );
		}
		else if( pKEvt )
		{
			pArray = new SbxArray;

			SbxVariable* pKeyCode = new SbxVariable;
			pKeyCode->PutInteger( (INT16)pKEvt->GetKeyCode().GetCode() );
			SbxVariable* pShift = new SbxVariable;
			INT16 nShift = 0;
			if( pKEvt->GetKeyCode().IsShift() ) nShift += 1;
			if( pKEvt->GetKeyCode().IsMod1() )  nShift += 2;
			if( pKEvt->GetKeyCode().IsMod2() )  nShift += 4;
			pShift->PutInteger( nShift );

			pArray->Put( pKeyCode, 1 );
			pArray->Put( pShift, 2 );
		}

		SetInCallBack( TRUE );
		if( pModel && pModel->GetObjectShell() && rMacro.GetLibName().Len() )
		{
			SfxObjectShell* pObjShell = pModel->GetObjectShell();
			eErr = pObjShell->CallBasic(
						rMacro.GetMacName(),
						rMacro.GetLibName(),
						this, pArray );
		}
		else
		{
			short nOldSbxFlags = GetFlags();
			SetFlags( nOldSbxFlags | SBX_EXTSEARCH );
			Call( rMacro.GetMacName(), pArray );
			SetFlags( nOldSbxFlags );
		}
		SetInCallBack( FALSE );
	}
	return eErr;
}

void VCSbxDialog::PropOutputWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}
	Size aSize;
	if( pDlg )
	{
		aSize.Width() = pDlg->GetOutputSize().Width();
		aSize = pDlg->PixelToLogic( aSize, MapMode( MAP_TWIP ));
	}
	pVar->PutLong( aSize.Width() );
}

void VCSbxDialog::PropOutputHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}
	Size aSize;
	if( pDlg )
	{
		aSize.Height() = pDlg->GetOutputSize().Height();
		aSize = pDlg->PixelToLogic( aSize, MapMode( MAP_TWIP ));
	}
	pVar->PutLong( aSize.Height() );
}

void VCSbxDialog::PrepareDelete()
{
	USHORT nCount = GetObjects()->Count();
	for( USHORT i=0; i < nCount; i++ )
	{
		VCSbxControl* pObj = (VCSbxControl*)GetObjects()->Get( i );
		((VCImpRealControl*)pObj->GetVCControl()->GetImpControl())->DeleteDlgEdControl();
	}
}

/************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxdlg.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxdlg.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.126  2000/08/04 09:20:53  tbe
	  #77247# GetAppWindow checked in by MM
	
	  Revision 1.125  2000/05/16 12:24:25  pw
	  UNICODE review
	
	  Revision 1.124  2000/05/11 14:15:45  pw
	  UNICODE
	
	  Revision 1.123  2000/02/10 20:02:03  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.122  1999/06/10 07:27:50  MH
	  chg: SFX_APP
	

	  Rev 1.121   10 Jun 1999 09:27:50   MH
   chg: SFX_APP

	  Rev 1.120   24 Mar 1999 14:40:28   MT
   #63710# BasicDialogCount

	  Rev 1.119   04 Mar 1999 18:32:38   MBA
   #62839#: parent fuer BasicDocs TopWindow

	  Rev 1.118   03 Mar 1999 17:18:06   OV
   #62752# VcSbxDialog::Notify > Aktualisierung des CurrentStep nur bei Schreibzugriff

	  Rev 1.117   27 Nov 1998 12:36:58   OV
   #59525# ExecuteHandler: IsSecureURL nicht mit leerem Referer rufen

	  Rev 1.116   06 Aug 1998 09:50:52   OV
   #50862# Dialoghintergrundfarbe im Designmodus aus System

	  Rev 1.115   30 Jul 1998 14:39:36   OV
   #50899# Dialog::SetPos Control-Flags nicht manipulieren

	  Rev 1.114   29 Jul 1998 19:54:06   OV
   #51089# Pointer nicht den Kindern vererben!

	  Rev 1.113   29 Jul 1998 12:14:16   OV
   #53676# MethodHide: Sonderbehandlung Fokushandling raus, da Kollision mit VCL-Logik

	  Rev 1.112   28 Jul 1998 14:05:20   OV
   #51089# MousePointer in Dialog setzen

	  Rev 1.111   27 Feb 1998 18:22:42   OV
   #46884# DlgEdControls vor dem Loeschen des Parents abraeumen

	  Rev 1.110   05 Feb 1998 14:40:50   HJS
   includes

	  Rev 1.109   01 Dec 1997 10:21:16   TJ
   include

	  Rev 1.108   27 Nov 1997 12:59:38   OV
   #45823# Neue Props: OutputSize, OutputHeight

	  Rev 1.107   21 Nov 1997 17:02:04   OV
   Headerumstellung

	  Rev 1.106   14 Nov 1997 10:40:56   OV
   #45393# SetCustomHelpFile an SfxHelp rufen

	  Rev 1.105   31 Oct 1997 11:05:12   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.104   29 Oct 1997 14:34:36   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.103   27 Oct 1997 15:05:56   OV
   #45110 HelpIds aus der SbxInfo setzen

	  Rev 1.102   23 Oct 1997 19:16:30   OV
   #44519# SVLook-Umschaltung an Controls notifien

	  Rev 1.101   23 Sep 1997 14:42:36   OV
   #43930# VCL: DisableInput statt Disable verwenden

*************************************************************************/


#pragma SEG_EOFMODULE
