/*************************************************************************
 *
 *  $RCSfile: vcsbxed.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef VCL
#include <svtools/svmedit.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif

#pragma hdrstop

#define _SI_VCITEMS
#define _VCSBXEDIT_CXX
//#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
//#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON
#define SI_VCSV_EDIT

#include "vcattr.hxx"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "siresid.hxx"
#include "vcattrid.hrc"
#include "vctrls.hrc"
#include "vcictrls.hxx"
#include "sictrls.hxx"

void VCSVEdit::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		Edit::RequestHelp( rHEvt );
}

void VCSVMultiLineEdit::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		MultiLineEdit::RequestHelp( rHEvt );
}

#ifndef VCL

void VCSVEdit::MouseButtonDown( const MouseEvent& rMEvt )
{
	Edit::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();

	if( rMEvt.GetClicks() == 2 )
		pShell->DblClick();
	else
		pShell->Click();
}

//------------------------------------------------------------------------

void VCSVEdit::MouseButtonUp( const MouseEvent& rMEvt )
{
	Edit::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}


//------------------------------------------------------------------------
void VCSVEdit::MouseMove( const MouseEvent& rMEvt )
{
	Edit::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVEdit::KeyInput( const KeyEvent& rKEvt )
{
	Edit::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	// der Text wird erst beim ersten Zugriff im ItemSet abgelegt
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//------------------------------------------------------------------------
void VCSVEdit::GetFocus()
{
	pShell->GotFocus();
}


//------------------------------------------------------------------------
void VCSVEdit::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVEdit::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = Edit::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
void VCSVEdit::Modify()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->Modified();
}

//------------------------------------------------------------------------

#ifndef VCL

void VCSVMultiLineEdit::MouseButtonDown( const MouseEvent& rMEvt )
{
	MultiLineEdit::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( rMEvt.GetClicks() == 2 )
		pShell->DblClick();
	else
		pShell->Click();
}


//------------------------------------------------------------------------
void VCSVMultiLineEdit::MouseButtonUp( const MouseEvent& rMEvt )
{
	MultiLineEdit::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}


//------------------------------------------------------------------------
void VCSVMultiLineEdit::MouseMove( const MouseEvent& rMEvt )
{
	MultiLineEdit::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#else

long VCSVMultiLineEdit::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = MultiLineEdit::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVMultiLineEdit::KeyInput( const KeyEvent& rKEvt )
{
	MultiLineEdit::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	// der Text wird erst beim ersten Zugriff im ItemSet abgelegt
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//------------------------------------------------------------------------
void VCSVMultiLineEdit::GetFocus()
{
	pShell->GotFocus();
}


//------------------------------------------------------------------------
void VCSVMultiLineEdit::LoseFocus()
{
	pShell->LostFocus();
}

#endif

//------------------------------------------------------------------------
void VCSVMultiLineEdit::Modify()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->Modified();
}

TYPEINIT1( VCSbxEdit, VCSbxControl );

void VCSbxEdit::PropSelLen( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		if( pVar->GetInteger() < 0 )
		{
			StarBASIC::Error( SbxERR_BAD_PROP_VALUE );
			return;
		}


		if( pSVControl )
		{
			Selection aSel = ((Edit*)pSVControl)->GetSelection();
#if SUPD > 364
			aSel.Justify();
#endif
			aSel.Max() = aSel.Min() + (USHORT)pVar->GetInteger();
			((Edit*)pSVControl)->SetSelection( aSel );
		}
		else
			((VCEdit*)pVCControl)->SetSelectLen( (long)pVar->GetInteger() );
	}
	else
	{
		if( pSVControl )
		{
			SfxItemSet* pSet = pRunTimeItemSet;
			if( !pSet )
				pSet = pVCControl->GetItemSet();
			BOOL bMulti = ((const SfxBoolItem&)pSet->Get(VCATTR_MULTILINE)).GetValue();
			Selection aSel;
			if( !bMulti )
				aSel = ((Edit*)pSVControl)->GetSelection();
			else
				aSel = ((MultiLineEdit*)pSVControl)->GetSelection();
#if SUPD > 364
			aSel.Justify();
#endif
			pVar->PutInteger( (short)aSel.Len() );
		}
		else
			pVar->PutInteger( (INT16)((VCEdit*)pVCControl)->GetSelectLen() );
	}
}

void VCSbxEdit::PropSelStart( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		if( pSVControl )
		{
			Selection aSel = ((Edit*)pSVControl)->GetSelection();
#if SUPD > 364
			aSel.Justify();
#endif
			USHORT nLen = (USHORT)aSel.Len();
			aSel.Min() = (USHORT)pVar->GetInteger();
			aSel.Max() = aSel.Min() + nLen;
			((Edit*)pSVControl)->SetSelection( aSel );
		}
		else
			((VCEdit*)pVCControl)->SetSelectStart( (long)pVar->GetInteger() );
	}
	else
	{
		if( pSVControl )
		{
			SfxItemSet* pSet = pRunTimeItemSet;
			if( !pSet )
				pSet = pVCControl->GetItemSet();
			BOOL bMulti = ((const SfxBoolItem&)pSet->Get(VCATTR_MULTILINE)).GetValue();
			Selection aSel;
			if( !bMulti )
				aSel = ((Edit*)pSVControl)->GetSelection();
			else
				aSel = ((MultiLineEdit*)pSVControl)->GetSelection();
#if SUPD > 364
			aSel.Justify();
#endif
			pVar->PutInteger( (short)aSel.Min() );
		}
		else
			pVar->PutInteger( (INT16)((VCEdit*)pVCControl)->GetSelectStart() );
	}
}

void VCSbxEdit::PropSelText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		if( pSVControl )
		{
			String aOldText = ((VCSVEdit*)pSVControl)->GetText();
			String aNewText( pVar->GetString() );
			aNewText.ConvertLineEnd( LINEEND_CRLF );
			((VCSVEdit*)pSVControl)->ReplaceSelected( aNewText );
			if( aOldText != ((VCSVEdit*)pSVControl)->GetText() )
				((VCSVEdit*)pSVControl)->Modify();
		}
		else
		{
			String aOldText = ((VCEdit*)pVCControl)->GetText();
			((VCEdit*)pVCControl)->SetSelectText( pVar->GetString() );
			if( aOldText != ((VCEdit*)pVCControl)->GetText() )
			{
//!!! Modify rufen !!!
			}
		}

	}
	else
	{
		if( pSVControl )
		{
			SfxItemSet* pSet = pRunTimeItemSet;
			if( !pSet )
				pSet = pVCControl->GetItemSet();
			BOOL bMulti = ((const SfxBoolItem&)pSet->Get(VCATTR_MULTILINE)).GetValue();
			if( !bMulti )
				pVar->PutString( ((Edit*)pSVControl)->GetSelected() );
			else
				pVar->PutString( ((MultiLineEdit*)pSVControl)->GetSelected() );
		}
		else
			pVar->PutString( ((VCEdit*)pVCControl)->GetSelectText() );
	}
}


void VCSbxEdit::PropText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	DBG_ASSERT(!bWrite,"PropText with bWrite==TRUE");
	SfxItemSet* pSet = pRunTimeItemSet;
	if( !pSet )
		pSet = pVCControl->GetItemSet();

	if( pSVControl )
	{
		// Wert im ItemSet ablegen
		SfxStringItem aTextItem( VCATTR_TEXT, ((Edit*)pSVControl)->GetText() );
		pSet->Put( aTextItem );
		pVar->PutString( aTextItem.GetValue() );
	}
	else
	{
		String aText( ((const SfxStringItem&)pSet->Get(VCATTR_TEXT)).GetValue());
		VCEdit::Convert( aText, ((VCEdit*)pVCControl)->GetWordWrap() );
		pVar->PutString( aText );
	}
}

void VCSbxEdit:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
						const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if( nWhich == VCATTR_IMP_SELLEN )
			PropSelLen( pVar, pPar, bWrite );
		else
		if( nWhich == VCATTR_IMP_SELSTART )
			PropSelStart( pVar, pPar,bWrite );
		else
		if( nWhich == VCATTR_IMP_SELTEXT )
			PropSelText( pVar, pPar, bWrite );
		else
		if( !bWrite && nWhich == VCATTR_TEXT )
			PropText( pVar, pPar, bWrite );
		else
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

VCSbxEdit::VCSbxEdit( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_EDIT ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCEdit( pForm->GetVCContainer(), pForm->GetPool(),
							   bReal, this );
	}
	else
		pVCControl = new VCEdit( NULL, VCSbxForm::GetGenericVCPool(), bReal,this );

	Init();

	// Properties einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelLength" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELLEN );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelStart" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELSTART );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelText" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELTEXT );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
}

VCSbxEdit::~VCSbxEdit()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxEdit::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;

	if( ((const SfxBoolItem&)rSet.Get( VCATTR_BORDER )).GetValue() )
		nStyle |= WB_BORDER;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((const SfxStringItem&)rSet.Get( VCATTR_PASSWORDCHAR )).GetValue().Len() )
		nStyle |= WB_PASSWORD;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_READONLY )).GetValue() )
		nStyle |= WB_READONLY;

	// Alignment
	USHORT eAlign = (USHORT)((const VCAlignmentItem&)rSet.
							Get( VCATTR_ALIGNMENT )).GetValue();
	switch( eAlign )
	{
		case VCALIGN_LEFT:	 nStyle |= WB_LEFT;  break;
		case VCALIGN_RIGHT:  nStyle |= WB_RIGHT; break;
		case VCALIGN_CENTER: nStyle |= WB_CENTER;break;
	}

	Control* pResult;

	// MultiLine
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_MULTILINE )).GetValue() )
	{
		nStyle |= WB_IGNORETAB;
		if( ((const SfxBoolItem&)rSet.Get( VCATTR_SCROLLBARS )).GetValue() )
		{
			nStyle |= WB_HSCROLL;
			nStyle |= WB_VSCROLL;
		}

		BOOL bWordWrap = ((const SfxBoolItem&)rSet.Get(VCATTR_WORDWRAP)).GetValue();
		if( bWordWrap )
		{
			nStyle |= WB_WORDBREAK;
			nStyle &= ~(WB_HSCROLL);
		}
		pResult = new VCSVMultiLineEdit( pParent, (VCEdit*)pVCControl, nStyle );
	}
	else
		pResult = new VCSVEdit( pParent, (VCEdit*)pVCControl, nStyle );

	return pResult;
}

#endif

void VCSbxEdit::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;

	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_BORDER )).GetValue() )
		nStyle |= WB_BORDER;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_PASSWORDCHAR )).GetValue().Len() )
		nStyle |= WB_PASSWORD;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_READONLY )).GetValue() )
		nStyle |= WB_READONLY;

	// Alignment
	USHORT eAlign = (USHORT)((VCAlignmentItem&)pRunTimeItemSet->
							Get( VCATTR_ALIGNMENT )).GetValue();
	switch( eAlign )
	{
		case VCALIGN_LEFT:	 nStyle |= WB_LEFT;  break;
		case VCALIGN_RIGHT:  nStyle |= WB_RIGHT; break;
		case VCALIGN_CENTER: nStyle |= WB_CENTER;break;
	}

	// MultiLine
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_MULTILINE )).GetValue() )
	{
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_SCROLLBARS )).GetValue() )
		{
			nStyle |= WB_HSCROLL;
			nStyle |= WB_VSCROLL;
		}

		BOOL bWordWrap = ((SfxBoolItem&)pRunTimeItemSet->Get(VCATTR_WORDWRAP)).GetValue();
		if( bWordWrap )   nStyle |= WB_WORDBREAK;
		pSVControl = new VCSVMultiLineEdit( pParent, (VCEdit*)pVCControl, nStyle );
	}
	else
		pSVControl = new VCSVEdit( pParent, (VCEdit*)pVCControl, nStyle );
#endif
}

void VCSbxEdit::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_TEXT) )
	{
		String aText = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_TEXT )).GetValue();
		aText.ConvertLineEnd();
		if( nWhich==VCATTR_TEXT )
		{
			if( ((Edit*)pSVControl)->GetText() != aText )
			{
				((VCSVEdit*)pSVControl)->SetText( aText );
				((VCSVEdit*)pSVControl)->Modify();
			}
		}
		else
			((Edit*)pSVControl)->SetText( aText );
	}

	// MaxLength setzen
	if( !nWhich || (nWhich==VCATTR_MAXLENGTH) )
	{
		USHORT nMaxLength = (USHORT)((SfxInt32Item&)pRunTimeItemSet->
								Get( VCATTR_MAXLENGTH )).GetValue();
		if( nMaxLength )
			((Edit*)pSVControl)->SetMaxTextLen( nMaxLength );
		else
			((Edit*)pSVControl)->SetMaxTextLen();
	}
}

/**************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxed.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxed.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.60  2000/05/11 14:15:51  pw
	  UNICODE
	
	  Revision 1.59  1998/05/13 12:30:04  OV
	  #50137# MultilineEdit mit WB_IGNORETAB
	

	  Rev 1.58   13 May 1998 14:30:04   OV
   #50137# MultilineEdit mit WB_IGNORETAB

	  Rev 1.57   04 May 1998 09:51:12   OV
   #46417# PropSelText,PropSelLen,PropSelStart: Auf MultiLineEdit casten

	  Rev 1.56   08 Jan 1998 13:05:00   OV
   Selection des Edits 'Justify'en

	  Rev 1.55   21 Nov 1997 17:02:22   OV
   Headerumstellung

	  Rev 1.54   07 Nov 1997 13:06:38   OV
   weitere VCL-Umstellungen

	  Rev 1.53   06 Nov 1997 12:46:14   OV
   VCL-Umstellungen

	  Rev 1.52   31 Oct 1997 11:06:04   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.51   29 Oct 1997 14:34:44   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.50   24 Oct 1997 11:01:56   OV
   #44268# VCL: WB_NOTABSTOP setzen

	  Rev 1.49   09 Oct 1997 15:05:18   OV
   #44282# Caption-Property aus SBX-Objekt entfernt

	  Rev 1.48   08 Oct 1997 15:18:22   OV
   #44287# PropSelText: Lineends konvertieren

	  Rev 1.47   23 Sep 1997 09:45:04   OV
   #43774# Diverse Anpassungen fuer VCL

	  Rev 1.46   19 Sep 1997 11:01:58   OV
   #43999# Wordwrap fuer Multiline-Edits

	  Rev 1.45   09 Sep 1997 17:32:22   OV
   #43661# Anbindung des Hilfesystems

	  Rev 1.44   04 Aug 1997 11:39:48   TRI
   VCL: includes

	  Rev 1.43   29 May 1997 16:05:08   OV
   #35122# Wordwrap in Doc-Multiline-Edits

	  Rev 1.42   11 Feb 1997 13:59:06   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.41   08 Jan 1997 17:31:08   OV
   Diverse Bugfixes

	  Rev 1.40   10 Dec 1996 14:16:48   OV
   Umstellung auf SvxMacroItem

	  Rev 1.39   22 Nov 1996 19:46:24   OV
   JavaScript-Unterstuetzung

	  Rev 1.38   16 Oct 1996 21:18:22   MH
   chg: includes

	  Rev 1.37   05 Jun 1996 13:24:44   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.36   25 Mar 1996 18:06:26   OV
   #26346# PropText

*************************************************************************/


#pragma SEG_EOFMODULE

