/*************************************************************************
 *
 *  $RCSfile: vcsbxfix.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _GRAPH_HXX
#include <vcl/graph.hxx>
#endif
#if SUPD > 364
#ifndef _SB_SBSTDOBJ1_HXX
#include <basic/sbstdobj.hxx>
#endif
#else
#include <stdobj1.hxx>
#endif
#ifndef _POLY_HXX
#include <vcl/poly.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif

#pragma hdrstop
#define ITEMID_COLOR 0

#define _SI_VCITEMS
#define _VCSBXPREVIEW_CXX
//#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
// #define _SI_NOVCSBXFIXEDTEXT
// #define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
//#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON
#define SI_VCSV_FIXEDTEXT
#define SI_VCSV_GROUPBOX
#define SI_VCSV_PREVIEW

#include "vcgrpbox.hxx"
#include "vcfxtxt.hxx"
#include "vcprvw.hxx"
#include <svx/colritem.hxx>
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcictrls.hxx"
#include "sictrls.hxx"


void VCSVFixedText::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		FixedText::RequestHelp( rHEvt );
}

void VCSVGroupBox::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		GroupBox::RequestHelp( rHEvt );
}

void VCSVPreview::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		Control::RequestHelp( rHEvt );
}

#ifndef VCL

void VCSVFixedText::MouseButtonDown( const MouseEvent& rMEvt )
{
	FixedText::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( rMEvt.GetClicks() == 2)
		pShell->DblClick();
	else
		pShell->Click();
}

//------------------------------------------------------------------------

void VCSVFixedText::MouseButtonUp( const MouseEvent& rMEvt )
{
	FixedText::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVFixedText::MouseMove( const MouseEvent& rMEvt )
{
	FixedText::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#else

long VCSVFixedText::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = FixedText::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif


#ifndef VCL

void VCSVGroupBox::MouseButtonDown( const MouseEvent& rMEvt )
{
	GroupBox::MouseButtonDown( rMEvt );

	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( rMEvt.GetClicks() == 2)
		pShell->DblClick();
	else
		pShell->Click();
}

//------------------------------------------------------------------------
void VCSVGroupBox::MouseButtonUp( const MouseEvent& rMEvt )
{
	GroupBox::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVGroupBox::MouseMove( const MouseEvent& rMEvt )
{
	GroupBox::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#else

long VCSVGroupBox::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = GroupBox::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------

#ifndef VCL

void VCSVPreview::MouseButtonDown( const MouseEvent& rMEvt )
{
	Control::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( rMEvt.GetClicks() == 2)
		pShell->DblClick();
	else
		pShell->Click();
}

//------------------------------------------------------------------------

void VCSVPreview::MouseButtonUp( const MouseEvent& rMEvt )
{
	Control::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVPreview::MouseMove( const MouseEvent& rMEvt )
{
	Control::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

//------------------------------------------------------------------------
void VCSVPreview::GetFocus()
{
	pShell->GotFocus();
}

//------------------------------------------------------------------------
void VCSVPreview::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVPreview::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = Control::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVPreview::KeyInput( const KeyEvent& rKEvt )
{
	Control::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}
#endif

//------------------------------------------------------------------------
void VCSVPreview::Paint( const Rectangle& rRect )
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->ExecuteHandler( VCHDL_ONPAINT );
}

//------------------------------------------------------------------------
VCSVPreview::VCSVPreview( Window* pParent, VCPreview* _pShell, WinBits nStyle ) :
	Control( pParent, nStyle )
{
	pShell = _pShell;

	nCurrentX = nCurrentY = 0;
	nDrawMode = 13;
	nDrawStyle= 0;
	nDrawWidth= 1;
	nFillStyle= 1;

	SetFillColor();
}

//------------------------------------------------------------------------
void VCSVPreview::SetDrawMode( USHORT nMode )
{
	nDrawMode = nMode;

	RasterOp eROP;

	switch( nMode )
	{
		case 13: eROP = ROP_OVERPAINT; break;
		case 6:  eROP = ROP_INVERT; break;
#ifndef VCL
		case 9:  eROP = ROP_AND; break;
		case 15: eROP = ROP_OR; break;
		case 7:  eROP = ROP_XOR; break;
		case 10: eROP = ROP_NXOR; break;
#else
		case 7:  eROP = ROP_XOR; break;
		case 10: eROP = ROP_XOR; break;
#endif
		default:
			eROP = ROP_OVERPAINT; break;
	}

	SetRasterOp( eROP );
}
#pragma SEG_FUNCDEF(vcsbxfix_0f)


//------------------------------------------------------------------------
void VCSVPreview::SetDrawStyle( USHORT nStyle )
{
	if( nStyle == 5 )
		SetLineColor();
}

//------------------------------------------------------------------------
void VCSVPreview::SetDrawWidth( long nWidth )
{
}

//------------------------------------------------------------------------
void VCSVPreview::SetFillStyle( USHORT nStyle )
{
	if( nStyle == 1 )
		SetFillColor();
}

//------------------------------------------------------------------------
void VCSVPreview::DrawLineTo( const Point& rPt )
{
	DrawLine( Point( nCurrentX, nCurrentY ), rPt );
	nCurrentX = rPt.X();
	nCurrentY = rPt.Y();
}

//------------------------------------------------------------------------
void VCSVPreview::Cls()
{
	Color aOldFillColor = GetFillColor( );
	Color aOldLineColor = GetLineColor( );
	SetFillColor( GetBackground().GetColor() );
	SetLineColor();

	EnableMapMode( FALSE );
	DrawRect( Rectangle( Point(), GetOutputSizePixel() ) );
	EnableMapMode( TRUE );

	SetFillColor( aOldFillColor );
	SetLineColor( aOldLineColor );
}

void VCSVPreview::SetFontTransparent( BOOL bTrans )
{
	Font aFont( GetFont() );
	if( aFont.IsTransparent() != bTrans )
	{
		aFont.SetTransparent( bTrans );
		SetFont( aFont );
	}
}

BOOL VCSVPreview::GetFontTransparent() const
{
	return GetFont().IsTransparent();
}

TYPEINIT1( VCSbxFixedText, VCSbxControl );

VCSbxFixedText::VCSbxFixedText( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_FIXEDTEXT ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCFixedText( pForm->GetVCContainer(), pForm->GetPool(),
									bReal, this );
	}
	else
		pVCControl = new VCFixedText( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();
}

VCSbxFixedText::~VCSbxFixedText()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxFixedText::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;

	BOOL bBorder  = ((const SfxBoolItem&)rSet.Get( VCATTR_BORDER )).GetValue();
	BOOL bWordWrap = ((const SfxBoolItem&)rSet.Get( VCATTR_WORDWRAP )).GetValue();

	if( bBorder )
		nStyle |= WB_BORDER;
	if( bWordWrap )
		nStyle |= WB_WORDBREAK;

	USHORT eAlign =
		(USHORT)((const VCAlignmentItem&)rSet.Get( VCATTR_ALIGNMENT )).GetValue();

	switch( eAlign )
	{
		case VCALIGN_LEFT:  nStyle |= WB_LEFT;  break;
		case VCALIGN_RIGHT: nStyle |= WB_RIGHT; break;
		case VCALIGN_CENTER:nStyle |= WB_CENTER;break;
	}

	Control *pResult = new VCSVFixedText( pParent, (VCFixedText*)pVCControl, nStyle );
	return pResult;
}

#endif


void VCSbxFixedText::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	BOOL bBorder  = ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_BORDER )).GetValue();
	BOOL bWordWrap = ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_WORDWRAP )).GetValue();

	USHORT eAlign = (USHORT)((VCAlignmentItem&)pRunTimeItemSet->
							Get( VCATTR_ALIGNMENT )).GetValue();
	WinBits nStyle = 0;
	if( bBorder )     nStyle |= WB_BORDER;
	if( bWordWrap )   nStyle |= WB_WORDBREAK;
	switch( eAlign )
	{
		case VCALIGN_LEFT:  nStyle |= WB_LEFT;  break;
		case VCALIGN_RIGHT: nStyle |= WB_RIGHT; break;
		case VCALIGN_CENTER:nStyle |= WB_CENTER;break;
	}

	pSVControl = new VCSVFixedText( pParent, (VCFixedText*)pVCControl, nStyle );
#endif
}

void VCSbxFixedText::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_USEMNEMONIC )).GetValue() )
			ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}
}


TYPEINIT1( VCSbxGroupBox, VCSbxControl );

VCSbxGroupBox::VCSbxGroupBox( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_GROUPBOX ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCGroupBox( pForm->GetVCContainer(), pForm->GetPool(),
								   bReal, this );
	}
	else
		pVCControl = new VCGroupBox( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();
}

VCSbxGroupBox::~VCSbxGroupBox()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxGroupBox::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	return new VCSVGroupBox( pParent, (VCGroupBox*)pVCControl );
}

#endif

void VCSbxGroupBox::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else
	pSVControl = new VCSVGroupBox( pParent, (VCGroupBox*)pVCControl );
#endif
}

void VCSbxGroupBox::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;


#ifdef OS2
	Font  aOrgFont = pSVControl->GetFont();
	Brush aOrgBrush= pSVControl->GetBackgroundBrush();
#endif

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	// Caption Text setzen
	if( !nWhich || (nWhich==VCATTR_CAPTION) )
	{
		String aCaption = ((SfxStringItem&)pRunTimeItemSet->Get( VCATTR_CAPTION )).GetValue();
		ConvertAmpersand( &aCaption );
		pSVControl->SetText( aCaption );
	}

#ifdef OS2
	Font aFont = pSVControl->GetFont();
	aFont.SetFillColor( aOrgFont.GetFillColor() );
	pSVControl->SetFont( aFont );
	pSVControl->SetBackgroundBrush( aOrgBrush );
#endif
}


TYPEINIT1( VCSbxPreview, VCSbxControl );

void VCSbxPreview::PropCurrentX( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetCurrentX() );
	else
		((VCSVPreview*)pSVControl)->SetCurrentX( pVar->GetInteger() );
}

void VCSbxPreview::PropCurrentY( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetCurrentY() );
	else
		((VCSVPreview*)pSVControl)->SetCurrentY( pVar->GetInteger() );
}

void VCSbxPreview::PropDrawMode( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetDrawMode() );
	else
		((VCSVPreview*)pSVControl)->SetDrawMode( (USHORT)pVar->GetInteger() );
}

void VCSbxPreview::PropDrawStyle( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetDrawStyle() );
	else
		((VCSVPreview*)pSVControl)->SetDrawStyle( (USHORT)pVar->GetInteger() );
}

void VCSbxPreview::PropDrawWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetDrawWidth() );
	else
		((VCSVPreview*)pSVControl)->SetDrawWidth( pVar->GetInteger() );
}

void VCSbxPreview::PropFillStyle( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutInteger( (INT16)((VCSVPreview*)pSVControl)->GetFillStyle() );
	else
		((VCSVPreview*)pSVControl)->SetFillStyle( (USHORT)pVar->GetInteger() );
}

void VCSbxPreview::PropOutputWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	pVar->PutInteger( (INT16)pSVControl->GetOutputSize().Width() );
}

void VCSbxPreview::PropOutputHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	pVar->PutInteger( (INT16)pSVControl->GetOutputSize().Height() );
}

void VCSbxPreview::PropFontTransparent( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !bWrite )
		pVar->PutBool( (BOOL)((VCSVPreview*)pSVControl)->GetFontTransparent() );
	else
		((VCSVPreview*)pSVControl)->SetFontTransparent( pVar->GetBool() );
}

void VCSbxPreview::MethDrawPoint( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 3 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	pSVControl->DrawPixel( Point( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger() ) );
}

void VCSbxPreview::MethGetPoint( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 3 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	Color aCol = pSVControl->GetPixel( Point( pPar->Get(1)->GetInteger(),
											  pPar->Get(2)->GetInteger() ) );
#ifdef VCL
	ULONG nRGB  = aCol.GetRGBColor();
#else
	ULONG nRed  = aCol.GetRed() >> 8;
	ULONG nGreen= aCol.GetGreen() >> 8;
	ULONG nBlue = aCol.GetBlue() >> 8;
	ULONG nRGB  = (nRed << 16) | (nGreen << 8) | nBlue;
#endif
	pVar->PutLong( nRGB );
}

void VCSbxPreview::MethDrawLine( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 5 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
	Color aOldCol( pSVControl->GetLineColor() );
	pSVControl->SetLineColor( aForeCol );

	pSVControl->DrawLine( Point( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger() ),
					 Point( pPar->Get(3)->GetInteger(), pPar->Get(4)->GetInteger() ) );
	pSVControl->SetLineColor( aOldCol );
}

void VCSbxPreview::MethDrawLineTo( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 3 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
	Color aOldCol( pSVControl->GetLineColor() );
	pSVControl->SetLineColor( aForeCol );
	((VCSVPreview*)pSVControl)->DrawLineTo( Point( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger() ) );
	pSVControl->SetLineColor( aOldCol );
}

void VCSbxPreview::MethDrawPolygon( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() < 3 ) || !(pPar->Count() % 2) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
	Color aOldCol( pSVControl->GetLineColor() );
	pSVControl->SetLineColor( aForeCol );

	USHORT nPar   = pPar->Count();
	USHORT nPoints= (pPar->Count()-1) / 2;
	Polygon aPoly( nPoints );

	USHORT i, n;
	for( i=0, n=1; i < nPoints; i++, n += 2 )
		aPoly[i] = Point( pPar->Get(n)->GetInteger(), pPar->Get(n+1)->GetInteger() );

	pSVControl->DrawPolygon( aPoly );
	pSVControl->SetLineColor( aOldCol );
}

void VCSbxPreview::MethDrawBox( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 5 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
//	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
//	Color aOldCol( pSVControl->GetFillColor() );
//	pSVControl->SetFillColor( aForeCol );
	pSVControl->DrawRect( Rectangle( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger(),
								pPar->Get(3)->GetInteger(), pPar->Get(4)->GetInteger() ) );
//	pSVControl->SetFillColor( aOldCol );
}

void VCSbxPreview::MethDrawEllipse( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 5 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
	Color aOldCol( pSVControl->GetLineColor() );
	pSVControl->SetLineColor( aForeCol );

	pSVControl->DrawEllipse( Rectangle( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger(),
								   pPar->Get(3)->GetInteger(), pPar->Get(4)->GetInteger() ) );
	pSVControl->SetLineColor( aOldCol );
}

void VCSbxPreview::MethDrawText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || pPar->Count() < 4 || pPar->Count() > 5 )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}
	short nOldOrientation;
	Font aFont( pSVControl->GetFont());
	if( pPar->Count() > 4 )
	{
		nOldOrientation = aFont.GetOrientation();
		aFont.SetOrientation( pPar->Get(4)->GetInteger() );
		pSVControl->SetFont( aFont );
	}

	Color aForeCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_FORECOLOR )).GetValue();
	Color aOldCol( pSVControl->GetTextColor() );
	pSVControl->SetTextColor( aForeCol );

	pSVControl->DrawText( Point( pPar->Get(1)->GetInteger(), pPar->Get(2)->GetInteger() ),
					 pPar->Get(3)->GetString() );
	if( pPar->Count() > 4 )
	{
		aFont.SetOrientation( nOldOrientation );
		pSVControl->SetFont( aFont );
	}
	pSVControl->SetTextColor( aOldCol );
}

void VCSbxPreview::MethGetTextWidth( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 2 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	long aWidth = pSVControl->GetTextWidth( pPar->Get(1)->GetString() );
	pVar->PutInteger( (INT16)aWidth );
}

void VCSbxPreview::MethGetTextHeight( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 2 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	long aHeight = pSVControl->GetTextHeight();
	pVar->PutInteger( (INT16)aHeight );
}

void VCSbxPreview::MethCls( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( pPar && (pPar->Count() > 1 ) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	((VCSVPreview*)pSVControl)->Cls();
}

void VCSbxPreview::MethDrawPicture( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() < 2) || (pPar->Count() > 6) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	SbxObject* pObj = (SbxObject*)pPar->Get(1)->GetObject();
	if( !pObj || !pObj->IsA( TYPE( SbStdPicture ) ) )
	{
		StarBASIC::Error( SbERR_BAD_ARGUMENT );
		return;
	}

	SbStdPicture* 	pPic = (SbStdPicture*)pObj;
	Graphic 		aGrf = pPic->GetGraphic();

	if( pPar->Count() == 2 )
		aGrf.Draw( pSVControl, Point() );
	else
	{
		long x1 = pPar->Get(2)->GetInteger();
		long y1 = pPar->Get(3) ? pPar->Get(3)->GetInteger() : 0;
		long x2 = pPar->Get(4) ? pPar->Get(4)->GetInteger() : 0;
		long y2 = pPar->Get(5) ? pPar->Get(5)->GetInteger() : 0;
		Size aSize;
		if( (x2>x1) && (y2>y1) )
		{
			aSize.Width() = x2-x1;
			aSize.Height()= y2-y1;
		}

		if( aSize.Width() && aSize.Height() )
			aGrf.Draw( pSVControl, Point( x1, y1 ), Size( x2-x1, y2-y1 ) );
		else
			aGrf.Draw( pSVControl, Point( x1, y1 ) );
	}
}

void VCSbxPreview:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		// Methoden
		switch( nWhich )
		{
		   case VCMETH_DRAWPOINT:			MethDrawPoint( pVar, pPar, bWrite ); return;
		   case VCMETH_GETPOINT:			MethGetPoint( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWLINE:			MethDrawLine( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWLINETO:			MethDrawLineTo( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWPOLYGON:			MethDrawPolygon( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWBOX:				MethDrawBox( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWELLIPSE:			MethDrawEllipse( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWTEXT:			MethDrawText( pVar, pPar, bWrite ); return;
		   case VCMETH_GETTEXTHEIGHT:		MethGetTextHeight( pVar, pPar, bWrite ); return;
		   case VCMETH_GETTEXTWIDTH:		MethGetTextWidth( pVar, pPar, bWrite ); return;
		   case VCMETH_CLS:					MethCls( pVar, pPar, bWrite ); return;
		   case VCMETH_DRAWPICTURE:			MethDrawPicture( pVar, pPar, bWrite ); return;
		}

		// Interne Properties
		switch( nWhich )
		{
			case VCATTR_IMP_CURRENTX:		PropCurrentX( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_CURRENTY:		PropCurrentY( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_DRAWMODE:		PropDrawMode( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_DRAWSTYLE:		PropDrawStyle( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_DRAWWIDTH:		PropDrawWidth( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_FILLSTYLE:		PropFillStyle( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_OUTPUTWIDTH:	PropOutputWidth( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_OUTPUTHEIGHT:	PropOutputHeight( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_FONTTRANSPARENT: PropFontTransparent( pVar, pPar, bWrite ); return;
		}
		VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

VCSbxPreview::VCSbxPreview( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_PREVIEW ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCPreview( pForm->GetVCContainer(), pForm->GetPool(),
								  bReal, this );
	}
	else
		pVCControl = new VCPreview( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Properties
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "CurrentX" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_CURRENTX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "CurrentY" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_CURRENTY );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawMode" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_DRAWMODE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawStyle" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_DRAWSTYLE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawWidth" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_DRAWWIDTH );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "FillStyle" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_FILLSTYLE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "OutputWidth" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_OUTPUTWIDTH );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "OutputHeight" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_OUTPUTHEIGHT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "FontTransparent" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_FONTTRANSPARENT );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawPoint" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWPOINT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "GetPoint" ) ), SbxCLASS_METHOD, SbxLONG );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_GETPOINT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawLine" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWLINE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawLineTo" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWLINETO );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawPolygon" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWPOLYGON );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawBox" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWBOX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawEllipse" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWELLIPSE );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawText" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWTEXT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "GetTextHeight" ) ), SbxCLASS_METHOD, SbxINTEGER );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_GETTEXTHEIGHT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "GetTextWidth" ) ), SbxCLASS_METHOD, SbxINTEGER );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_GETTEXTWIDTH );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Cls" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_CLS );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "DrawPicture" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_DRAWPICTURE );
}

VCSbxPreview::~VCSbxPreview()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxPreview::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((const SfxBoolItem&)rSet.Get( VCATTR_BORDER )).GetValue() )
		nStyle |= WB_BORDER;

	return new VCSVPreview( pParent, (VCPreview*)pVCControl, nStyle );
}

#endif

void VCSbxPreview::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else
	WinBits nStyle = 0;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	BOOL bBorder  = ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_BORDER )).GetValue();
	if( bBorder )
		nStyle |= WB_BORDER;

	pSVControl = new VCSVPreview( pParent, (VCPreview*)pVCControl, nStyle );
#endif
}

void VCSbxPreview::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	pSVControl->SetMapMode( MapMode( MAP_TWIP ) );

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	// Background im Gegensatz zu den anderen auch bei
	// SVLook setzbar
	if( !nWhich || (nWhich==VCATTR_BACKCOLOR) )
	{
		Color aCol = ((SvxColorItem&)pRunTimeItemSet->Get( VCATTR_BACKCOLOR )).GetValue();
		pSVControl->SetBackground( Wallpaper( aCol ) );
	}

}

/****************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxfix.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxfix.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:03  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.68  2000/05/16 12:24:00  pw
	  UNICODE review
	
	  Revision 1.67  2000/05/11 14:15:59  pw
	  UNICODE
	
	  Revision 1.66  2000/02/10 20:02:08  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.65  1998/10/27 11:10:40  OV
	  #55967# SetFillStyle: Sonderbehandlung fuer SOLID, da dieser Stil keinen sichtbaren Hintergrund hat
	

	  Rev 1.64   27 Oct 1998 12:10:40   OV
   #55967# SetFillStyle: Sonderbehandlung fuer SOLID, da dieser Stil keinen sichtbaren Hintergrund hat

	  Rev 1.63   06 May 1998 13:50:24   OV
   #50042# MethDrawBox: Keine FillColor setzen

	  Rev 1.62   04 May 1998 16:10:08   TRI
   includes geaendert

	  Rev 1.61   30 Apr 1998 16:30:38   OV
   #46482# #46481# #46479# Umstellung VCL-Aenderungen

	  Rev 1.60   22 Jan 1998 12:14:44   PB
   chg: includes

	  Rev 1.59   27 Nov 1997 16:02:16   OV
   Preview: DrawText mit optionalem Winkel

	  Rev 1.58   21 Nov 1997 17:01:54   OV
   Headerumstellung

	  Rev 1.57   07 Nov 1997 15:26:08   OV
   #45407# VCL-Anpassung Color & Bugfix in MethGetPoint

	  Rev 1.56   07 Nov 1997 13:06:16   OV
   weitere VCL-Umstellungen

	  Rev 1.55   06 Nov 1997 12:46:00   OV
   VCL-Umstellungen

	  Rev 1.54   31 Oct 1997 11:05:38   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.53   29 Oct 1997 14:34:34   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.52   24 Oct 1997 10:57:52   OV
   #44268# VCL: WB_NOTABSTOP setzen

	  Rev 1.51   01 Oct 1997 11:25:50   OV
   #44280# CreateSVControl: WinBits richtig setzen

	  Rev 1.50   12 Sep 1997 10:21:18   OS
   ITEMID_* definiert

	  Rev 1.49   09 Sep 1997 17:31:18   OV
   #43661# Anbindung des Hilfesystems

	  Rev 1.48   26 Aug 1997 11:31:38   TRI
   VCL Anpassungen

	  Rev 1.47   19 Aug 1997 10:29:38   OV
   #42232# Preview: Fontgroesse: MapMode-Beruecksichtigug in Basisklasse

	  Rev 1.46   09 Aug 1997 11:10:16   OS
   frmitems/paraitem/textitem aufgeteilt

	  Rev 1.45   28 Jul 1997 16:45:12   MH
   chg: header

	  Rev 1.44   21 Jul 1997 12:47:12   OV
   #41512# Preview: Fontgroesse in Twips umrechnen

	  Rev 1.43   11 Jun 1997 17:02:54   OV
   #40616# Neue Prop fuer Preview: FontTransparent

	  Rev 1.42   09 Jun 1997 15:35:00   OV
   #40519# VCSbxPreview::UpdateSVControl: MapMode vor Aufruf der Basisklasse setzen

	  Rev 1.41   11 Feb 1997 13:59:34   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.40   10 Dec 1996 14:17:26   OV
   Umstellung auf SvxMacroItem

	  Rev 1.39   22 Nov 1996 19:46:10   OV
   JavaScript-Unterstuetzung

	  Rev 1.38   14 Oct 1996 10:22:36   OV
   Word-Wrap setzen

	  Rev 1.37   05 Jun 1996 13:24:34   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.36   21 Mar 1996 10:55:50   OV
   Clooks & Umstellung SV311

	  Rev 1.35   29 Feb 1996 16:57:46   TRI
   CLOOKS

	  Rev 1.34   14 Feb 1996 11:20:18   OV
   #25307# Dialog bei erstem Schreibzugriff laden

*************************************************************************/


#pragma SEG_EOFMODULE

