/*************************************************************************
 *
 *  $RCSfile: vcsbxlst.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#pragma hdrstop

#define SI_VCSV_LISTBOX

#define _SI_VCITEMS
#define _VCSBXLBOX_CXX
#define _VCSBXCBOX_CXX
//#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
// #define _SI_NOVCSBXLISTBOX
// #define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
#define _SI_NOVCSBXSCROLLBAR
#define _SI_NOVCSBXHSCROLLBAR
#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON
#include "vclbox.hxx"
#include "vccbbox.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "siresid.hxx"
#include "vcictrls.hxx"
#include "vctrls.hrc"
#include "sictrls.hxx"

void VCSVListBox::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		ListBox::RequestHelp( rHEvt );
}
void VCSVMultiListBox::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		MultiListBox::RequestHelp( rHEvt );
}
void VCSVComboBox::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		ComboBox::RequestHelp( rHEvt );
}

VCSVListBox::~VCSVListBox()
{
	Clear();
}

#ifndef VCL

void VCSVListBox::MouseButtonDown( const MouseEvent& rMEvt )
{
	ListBox::MouseButtonDown( rMEvt );
#ifdef MAC
	// nicht fuer ScrollBars (#41513)
	if( rMEvt.GetPosPixel().X() >= (GetSizePixel().Width() - 16) )
		return;
#endif
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( !(rMEvt.GetClicks() % 2))
		pShell->DblClick();
}

//------------------------------------------------------------------------
void VCSVListBox::MouseButtonUp( const MouseEvent& rMEvt )
{
	ListBox::MouseButtonUp( rMEvt );
#ifdef MAC
	// nicht fuer ScrollBars (#41513)
	if( rMEvt.GetPosPixel().X() >= (GetSizePixel().Width() - 16) )
		return;
#endif
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVListBox::MouseMove( const MouseEvent& rMEvt )
{
	ListBox::MouseMove( rMEvt );
#ifdef MAC
	// nicht fuer ScrollBars (#41513)
	if( rMEvt.GetPosPixel().X() >= (GetSizePixel().Width() - 16) )
		return;
#endif
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVListBox::KeyInput( const KeyEvent& rKEvt )
{
	ListBox::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}
#endif

#ifdef VCL
void VCSVListBox::DoubleClick()
{
	MouseEvent aMouseEvent;
	pShell->GetImpControl()->SetActMouseEvent( &aMouseEvent );
	pShell->DblClick();
}
#endif

//------------------------------------------------------------------------
#ifndef VCL

void VCSVListBox::GetFocus()
{
	pShell->GotFocus();
}

//------------------------------------------------------------------------
void VCSVListBox::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVListBox::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = ListBox::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif


//------------------------------------------------------------------------
void VCSVListBox::Select()
{
	ListBox::Select();
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		//HACK, da bei DD-Listen Get/LoseFocus nicht gerufen werden
		BOOL bDDList = FALSE;
		if( pShell && pShell->ISA(VCComboBox) && ((VCComboBox*)pShell)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		{
			bDDList = TRUE;
			pShell->GotFocus();
		}
		pShell->Selected();
		if( bDDList )
			pShell->LostFocus();
	}
}

//------------------------------------------------------------------------
USHORT VCSVListBox::InsertEntry( const String& rEntry, USHORT nPos )
{
	return ListBox::InsertEntry( rEntry, nPos );
}

//------------------------------------------------------------------------
void VCSVListBox::RemoveEntry( USHORT nPos )
{
	String* pData = (String*)GetEntryData( nPos );
	delete pData;
	ListBox::RemoveEntry( nPos );
}

//------------------------------------------------------------------------
void VCSVListBox::Clear()
{
	USHORT nCount = GetEntryCount();
	for( USHORT nCur = 0; nCur < nCount; nCur++ )
	{
		String* pData = (String*)GetEntryData( nCur );
		delete pData;
	}
	ListBox::Clear();
}

//------------------------------------------------------------------------

VCSVMultiListBox::~VCSVMultiListBox()
{
	Clear();
}

#ifndef VCL

void VCSVMultiListBox::MouseButtonDown( const MouseEvent& rMEvt )
{
	MultiListBox::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
	if( !(rMEvt.GetClicks() % 2))
		pShell->DblClick();
}

//------------------------------------------------------------------------
void VCSVMultiListBox::MouseButtonUp( const MouseEvent& rMEvt )
{
	MultiListBox::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVMultiListBox::MouseMove( const MouseEvent& rMEvt )
{
	MultiListBox::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#endif

#ifdef VCL
void VCSVMultiListBox::DoubleClick()
{
	MouseEvent aMouseEvent;
	pShell->GetImpControl()->SetActMouseEvent( &aMouseEvent );
	pShell->DblClick();
}
#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVMultiListBox::KeyInput( const KeyEvent& rKEvt )
{
	MultiListBox::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}
#endif

//------------------------------------------------------------------------

#ifndef VCL

void VCSVMultiListBox::GetFocus()
{
	pShell->GotFocus();
}

//------------------------------------------------------------------------
void VCSVMultiListBox::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVMultiListBox::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = MultiListBox::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
void VCSVMultiListBox::Select()
{
	MultiListBox::Select();
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->Selected();
}

//------------------------------------------------------------------------
USHORT VCSVMultiListBox::InsertEntry( const String& rEntry, USHORT nPos )
{
	return MultiListBox::InsertEntry( rEntry, nPos );
}

//------------------------------------------------------------------------
void VCSVMultiListBox::RemoveEntry( USHORT nPos )
{
	String* pData = (String*)GetEntryData( nPos );
	delete pData;
	MultiListBox::RemoveEntry( nPos );
}

//------------------------------------------------------------------------
void VCSVMultiListBox::Clear()
{
	USHORT nCount = GetEntryCount();
	for( USHORT nCur = 0; nCur < nCount; nCur++ )
	{
		String* pData = (String*)GetEntryData( nCur );
		delete pData;
	}
	MultiListBox::Clear();
}

//------------------------------------------------------------------------

#ifndef VCL

void VCSVComboBox::MouseButtonDown( const MouseEvent& rMEvt )
{
	ComboBox::MouseButtonDown( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseDown();
}

//------------------------------------------------------------------------
void VCSVComboBox::MouseButtonUp( const MouseEvent& rMEvt )
{
	ComboBox::MouseButtonUp( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseUp();
}

//------------------------------------------------------------------------
void VCSVComboBox::MouseMove( const MouseEvent& rMEvt )
{
	ComboBox::MouseMove( rMEvt );
	pShell->GetImpControl()->SetActMouseEvent( (MouseEvent*)&rMEvt );
	pShell->MouseMove();
}

#endif

//------------------------------------------------------------------------
#ifndef VCL
void VCSVComboBox::KeyInput( const KeyEvent& rKEvt )
{
	ComboBox::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}
#endif

//------------------------------------------------------------------------

#ifndef VCL

void VCSVComboBox::GetFocus()
{
	pShell->GotFocus();
}

//------------------------------------------------------------------------
void VCSVComboBox::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVComboBox::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = ComboBox::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
void VCSVComboBox::Select()
{
	ComboBox::Select();
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->Selected();
}

void VCSVComboBox::DoubleClick()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
		pShell->DblClick();
}


//------------------------------------------------------------------------
void VCSVComboBox::Modify()
{
	if( !pShell->GetSbxControl()->IsDesignModeActive() )
	{
		// Wert im ItemSet ablegen
		SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
		SfxStringItem aTextItem( VCATTR_TEXT, GetText() );
		pItemSet->Put( aTextItem );
		pShell->Modified();
	}
}

//------------------------------------------------------------------------
USHORT VCSVComboBox::InsertEntry( const String& rEntry, USHORT nPos )
{
	return ComboBox::InsertEntry( rEntry, nPos );
}

//------------------------------------------------------------------------
void VCSVComboBox::RemoveEntry( USHORT nPos )
{
	ComboBox::RemoveEntry( nPos );
}

//------------------------------------------------------------------------
void VCSVComboBox::Clear()
{
	ComboBox::Clear();
}

TYPEINIT1( VCSbxListBox, VCSbxControl );

void VCSbxListBox::DeleteSVControl()
{
	VCSbxControl::DeleteSVControl();
}

void VCSbxComboBox::DeleteSVControl()
{
	VCSbxControl::DeleteSVControl();
}


void VCSbxListBox::PropList( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar )
	{
		StarBASIC::Error( SbERR_NOT_OPTIONAL );
		return;
	}

	VCListBox*    pList 	= (VCListBox*)pVCControl;
	ULONG 		  nPos 		= pPar->Get(1)->GetInteger();
	ULONG         nCount;
	if( pSVControl )
		nCount = ((ListBox*)pSVControl)->GetEntryCount();
	else
		nCount = pList->GetEntryCount();

	if( bWrite )
	{
		INT16 nNewIndex = -1;
		if( nPos > nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		if( nPos == nCount )
		{
			if( pSVControl )
				nNewIndex = (INT16)(((ListBox*)pSVControl)->InsertEntry(pVar->GetString()));
			else
				nNewIndex = (INT16)(((VCListBox*)pList)->InsertEntry(pVar->GetString()));
		}
		else
		{
			if( pSVControl )
			{
				((VCSVListBox*)pSVControl)->RemoveEntry( (USHORT)nPos );
				nNewIndex = (INT16)(((ListBox*)pSVControl)->InsertEntry(pVar->GetString(),(USHORT)nPos));
			}
			else
			{
				((VCListBox*)pList)->ReplaceEntry( pVar->GetString(), nPos );
				nNewIndex = (INT16)nPos;
			}
		}
		// am VCControl nNewIndex setzen
		pList->SetNewIndex( nNewIndex );
	}
	else
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl )
				pVar->PutString( ((ListBox*)pSVControl)->GetEntry( (USHORT)nPos ) );
			else
				pVar->PutString( pList->GetEntry( nPos ) );
		}
	}
}

void VCSbxListBox::PropListCount( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	if( pSVControl )
	{
		short nEntry = (short)((ListBox*)pSVControl)->GetEntryCount();
		pVar->PutInteger( nEntry );
	}
	else
	{
		VCListBox* pList = (VCListBox*)pVCControl;
		pVar->PutInteger( (short)pList->GetEntryCount() );
	}
}

void VCSbxListBox::PropText( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	if( pSVControl )
		pVar->PutString( ((ListBox*)pSVControl)->GetSelectEntry() );
	else
		pVar->PutString( ((VCListBox*)pVCControl)->GetSelectEntry() );

}

void VCSbxListBox::PropItemData( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar )
	{
		StarBASIC::Error( SbERR_NOT_OPTIONAL );
		return;
	}

	VCListBox*    pList 	= (VCListBox*)pVCControl;
	ULONG 		  nPos 		= pPar->Get(1)->GetInteger();
	ULONG         nCount;
	if( pSVControl )
		nCount = ((ListBox*)pSVControl)->GetEntryCount();
	else
		nCount = pList->GetEntryCount();

	if( bWrite )
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl )
			{
				String* pEntryData = (String*)((ListBox*)pSVControl)->GetEntryData((USHORT)nPos);
				delete pEntryData;
				pEntryData = new String( pVar->GetInteger() );
				((ListBox*)pSVControl)->SetEntryData( (USHORT)nPos, pEntryData );
			}
			else
			{
				DBG_ASSERT(!pRunTimeItemSet,"Runtime itemset without real control");
				SfxItemSet* pItemSet = pVCControl->GetItemSet();

				VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->
												Get( VCATTR_ITEMDATA ).Clone();
				pItemData->SetEntryCount( (USHORT)nCount );
				List* pList = pItemData->GetList();
				String* pOldStr = (String*)pList->GetObject( nPos );
				pList->Replace( new String( pVar->GetInteger() ), nPos );
				delete pOldStr;
				pItemSet->Put( *pItemData );
				delete pItemData;
			}
		}
	}
	else
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl )
			{
				String* pEntryData = (String*)((ListBox*)pSVControl)->GetEntryData((USHORT)nPos);
				pVar->PutInteger( (short)pEntryData->ToInt32() );
			}
			else
			{
				DBG_ASSERT(!pRunTimeItemSet,"Runtime itemset without real control");
				SfxItemSet* pItemSet = pVCControl->GetItemSet();

				VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->
												Get( VCATTR_ITEMDATA ).Clone();
				pItemData->SetEntryCount( (USHORT)nCount );
				List* pList = pItemData->GetList();

				String aStr = *(String*)pList->GetObject( nPos );
				pVar->PutInteger( (short)aStr.ToInt32() );
				delete pItemData;
			}
		}
	}
}

void VCSbxListBox::PropNewIndex( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}
	pVar->PutInteger( ((VCListBox*)pVCControl)->GetNewIndex() );
}

void VCSbxListBox::PropListIndex( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		INT16 nIdx = pVar->GetInteger();
		String aLinkData;
		if( pSVControl )
		{
			((ListBox*)pSVControl)->SelectEntryPos( nIdx );
			if( nIdx >= 0 )
				aLinkData = ((ListBox*)pSVControl)->GetEntry( (USHORT)nIdx );
		}
		else
		{
			((VCListBox*)pVCControl)->SelectEntryPos( nIdx );
			if( nIdx >= 0 )
				aLinkData = ((VCListBox*)pVCControl)->GetEntry( (ULONG)nIdx );
		}

		SfxItemSet* pSet = pRunTimeItemSet;
		if( !pSet )
			pSet = pVCControl->GetItemSet();
		String aLinkName = ((SfxStringItem&)pSet->Get( VCATTR_LINK )).GetValue();
		pVCControl->SetLinkData( aLinkName, aLinkData );
	}
	else
	{
		if( pSVControl )
			pVar->PutInteger( ((ListBox*)pSVControl)->GetSelectEntryPos() );
		else
			pVar->PutInteger( (short)((VCListBox*)pVCControl)->GetSelectEntryPos() );
	}
}

void VCSbxListBox::PropSelected( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar )
	{
		StarBASIC::Error( SbERR_NOT_OPTIONAL );
		return;
	}

	VCListBox* pList = (VCListBox*)pVCControl;
	INT16	   nPos  = pPar->Get(1)->GetInteger();

	ULONG nCount;
	if( pSVControl )
		nCount = ((ListBox*)pSVControl)->GetEntryCount();
	else
		nCount = pList->GetEntryCount();

	if( bWrite )
	{
		if( nPos < 0 || (ULONG)nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			String aLinkData;
			if( pSVControl )
			{
				((ListBox*)pSVControl)->SelectEntryPos( (USHORT)nPos, pVar->GetBool() );
				aLinkData = ((ListBox*)pSVControl)->GetEntry( (USHORT)nPos );
			}
			else
			{
				pList->SelectEntryPos( nPos, pVar->GetBool() );
				aLinkData = pList->GetEntry( nPos );
			}
			SfxItemSet* pSet = pRunTimeItemSet;
			if( !pSet )
				pSet = pVCControl->GetItemSet();
			String aLinkName = ((SfxStringItem&)pSet->Get( VCATTR_LINK )).GetValue();
			pVCControl->SetLinkData( aLinkName, aLinkData );
		}
	}
	else
	{
		if( (ULONG)nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl )
				pVar->PutBool( ((ListBox*)pSVControl)->IsEntryPosSelected( (USHORT)nPos ) );
			else
				pVar->PutBool( pList->IsEntrySelected( nPos ) );
		}
	}
}

void VCSbxListBox::PropTopIndex( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( bWrite )
	{
		if( pSVControl )
			((ListBox*)pSVControl)->SetTopEntry( pVar->GetInteger() );
		else
			((VCListBox*)pVCControl)->SetTopIndex( (ULONG)pVar->GetInteger() );
	}
	else
	{
		if( pSVControl )
			pVar->PutInteger( ((ListBox*)pSVControl)->GetTopEntry() );
		else
			pVar->PutInteger( (short)((VCListBox*)pVCControl)->GetTopIndex() );
	}
}

void VCSbxListBox::MethodAddItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	USHORT nParCount = 0;
	if( pPar )
		nParCount = pPar->Count();
	if( nParCount < 2 || nParCount > 3 )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCListBox* pList 	= (VCListBox*)pVCControl;
	String	   aEntry	= pPar->Get(1)->GetString();
	ULONG nCount;
	if( pSVControl )
		nCount = ((ListBox*)pSVControl)->GetEntryCount();
	else
		nCount = pList->GetEntryCount();

	ULONG nPos;
	if( nParCount > 2 )
		nPos = pPar->Get(2)->GetInteger();
	else
		// keine Einfuegeposition angegeben: hinten anhaengen
		nPos = nCount;

	if( nPos > nCount )
		StarBASIC::Error( SbERR_BAD_INDEX );
	else
	{
		INT16 nNewIndex;
		if( pSVControl )
		{
			nNewIndex = (INT16)(((ListBox*)pSVControl)->InsertEntry( aEntry,(USHORT)nPos));
			((ListBox*)pSVControl)->SetEntryData( nNewIndex, new String );
		}
		else
			nNewIndex = (INT16)(((VCListBox*)pList)->InsertEntry(aEntry,(USHORT)nPos));
		pList->SetNewIndex( nNewIndex );
	}
}

void VCSbxListBox::MethodClear( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCListBox* pList = (VCListBox*)pVCControl;

	if( pSVControl )
		((VCSVListBox*)pSVControl)->Clear(); // raeumt ItemData ab
	else
		pList->Clear();
}

void VCSbxListBox::MethodRemoveItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( pPar && pPar->Count() > 2 )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCListBox* pList 	= (VCListBox*)pVCControl;
	ULONG nCount;
	if( pSVControl )
		nCount = ((ListBox*)pSVControl)->GetEntryCount();
	else
		nCount = pList->GetEntryCount();

	if( !nCount )
		return;

	ULONG nPos;
	if( pPar )
		nPos = pPar->Get(1)->GetInteger();
	else
	{
		nPos = pList->GetSelectEntryPos();
		if( nPos == 0xffffffff )
			return;
	}
	if( nPos >= nCount )
		StarBASIC::Error( SbERR_BAD_INDEX );
	else
	{
		if( pSVControl )
		{
			((VCSVListBox*)pSVControl)->RemoveEntry( (USHORT)nPos );
		}
		else
			((VCListBox*)pList)->RemoveEntry( (USHORT)nPos );
	}
}

VCSbxListBox::VCSbxListBox( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_LISTBOX ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCListBox( pForm->GetVCContainer(), pForm->GetPool(),
								  bReal, this );
	}
	else
		pVCControl = new VCListBox( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Properties einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "ListCount" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_LISTCOUNT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "ListIndex" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_LISTINDEX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Text" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_TEXT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "NewIndex" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_NEWINDEX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Selected" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELECTED );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "TopIndex" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_TOPINDEX );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "AddItem" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_ADDITEM );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Clear" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_CLEAR );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "RemoveItem" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_REMOVEITEM );
}

VCSbxListBox::~VCSbxListBox()
{
}

void VCSbxListBox :: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl :: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite ||
		   nWhich == VCMETH_ADDITEM ||  nWhich == VCMETH_CLEAR ||
		   nWhich == VCMETH_REMOVEITEM
		)
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		// Methoden
		switch( nWhich )
		{
		   case VCMETH_ADDITEM:			MethodAddItem( pVar, pPar, bWrite ); return;
		   case VCMETH_CLEAR:			MethodClear( pVar, pPar, bWrite ); return;
		   case VCMETH_REMOVEITEM:		MethodRemoveItem( pVar, pPar, bWrite ); return;
		}

		// Interne Propteries
		switch( nWhich )
		{
			case VCATTR_LIST:			PropList( pVar, pPar, bWrite ); return;
			case VCATTR_ITEMDATA:		PropItemData( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_LISTCOUNT:  PropListCount( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_LISTINDEX:	PropListIndex( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_TEXT:		PropText( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_NEWINDEX:	PropNewIndex( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_SELECTED:	PropSelected( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_TOPINDEX:   PropTopIndex( pVar, pPar, bWrite ); return;
		}

		// Sonderbehandlung fuer ReadOnly Properties
		if( bWrite )
		{
			if( nWhich == VCATTR_MULTISELECT )
			{
				StarBASIC::Error( SbERR_PROP_READONLY );
				return;
			}
		}

		VCSbxControl :: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

#ifdef TF_SI_OFF50

Control* VCSbxListBox::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = WB_BORDER;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((const SfxBoolItem&)rSet.Get( VCATTR_SORTED )).GetValue() )
		nStyle |= WB_SORT;

	Control* pResult;
	USHORT nMultiSelect =
		(USHORT)((const VCMultiSelectItem&)rSet.Get(VCATTR_MULTISELECT)).GetValue();

	if( nMultiSelect == VCMULTI_SINGLE )
		pResult = new VCSVListBox( pParent, pVCControl, nStyle );
	else
	{
		if( nMultiSelect != VCMULTI_SIMPLEMULTI )
			nStyle |= WB_SIMPLEMODE;
		pResult = new VCSVMultiListBox( pParent, (VCListBox*)pVCControl, nStyle );
	}
	return pResult;
}

#endif


void VCSbxListBox::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );

#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else
	WinBits nStyle = WB_BORDER;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_SORTED )).GetValue() )
		nStyle |= WB_SORT;

	if( ((VCListBox*)pVCControl)->GetMultiSelect() == VCMULTI_SINGLE )
		pSVControl = new VCSVListBox( pParent, pVCControl, nStyle );
	else
	{
		if( ((VCListBox*)pVCControl)->GetMultiSelect() != VCMULTI_SIMPLEMULTI )
			nStyle |= WB_SIMPLEMODE;
		pSVControl = new VCSVMultiListBox( pParent, (VCListBox*)pVCControl, nStyle );
	}
#endif
}

void VCSbxListBox::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	USHORT eMulti = ((VCListBox*)pVCControl)->GetMultiSelect();

	// Liste setzen
	if( !nWhich || (nWhich==VCATTR_LIST) )
	{
		SfxStringListItem& rItem = (SfxStringListItem&)pRunTimeItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();

		VCIntegerListItem& rItemData = (VCIntegerListItem&)pRunTimeItemSet->Get( VCATTR_ITEMDATA );
		List* pItemDataList = rItemData.GetList();

		((VCSVListBox*)pSVControl)->Clear(); // raeumt auch ItemData ab!

		USHORT nCount = (USHORT)pList->Count();
		INT16 nNewIndex = -1;
		String aEmptyStr;
		for( USHORT nCur = 0; nCur < nCount; nCur++ )
		{
			const String* pStr = (String*)pList->GetObject( nCur );
			if( eMulti == VCMULTI_SINGLE )
				nNewIndex = (INT16)(((VCSVListBox*)pSVControl)->InsertEntry(*pStr));
			else
				nNewIndex = (((VCSVMultiListBox*)pSVControl)->InsertEntry(*pStr));
			const String* pItemData = (const String*)pItemDataList->GetObject( nCur );
			if( !pItemData )
				pItemData = &aEmptyStr;
			((ListBox*)pSVControl)->SetEntryData( nNewIndex, new String( *pItemData ) );
		}
		((VCListBox*)pVCControl)->SetNewIndex( nNewIndex );
	}

	if( !nWhich )
		((VCListBox*)pVCControl)->SetNewIndex( -1 );
}


TYPEINIT1( VCSbxComboBox, VCSbxControl );


void VCSbxComboBox::PropList( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar )
	{
		StarBASIC::Error( SbERR_NOT_OPTIONAL );
		return;
	}

	VCComboBox*    pList 	= (VCComboBox*)pVCControl;
	ULONG 		   nPos 	= pPar->Get(1)->GetInteger();
	ULONG          nCount   = pList->GetEntryCount();

	VCSVListBox*   pSVList  = NULL;
	VCSVComboBox*  pSVCombo = NULL;

	if( pList->GetStyle() == (USHORT)VCCOMBO_DDLIST )
	{
		pSVList = (VCSVListBox*)pSVControl;
		if( pSVList )
			nCount = pSVList->GetEntryCount();
	}
	else
	{
		pSVCombo = (VCSVComboBox*)pSVControl;
		if( pSVCombo )
			nCount = pSVCombo->GetEntryCount();
	}


	if( bWrite )
	{
		INT16 nNewIndex = -1;
		if( nPos > nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		if( nPos == nCount )
		{
			if( pSVList )
				nNewIndex = (INT16)(pSVList->InsertEntry( pVar->GetString()));
			else
			if( pSVCombo )
				nNewIndex = (INT16)(pSVCombo->InsertEntry( pVar->GetString()));
			else
				nNewIndex = (INT16)(pList->InsertEntry( pVar->GetString()));
		}
		else
		{
			pList->ReplaceEntry( pVar->GetString(), nPos );
			nNewIndex = (INT16)nPos;
			if( pSVList )
			{
				pSVList->RemoveEntry( (USHORT)nPos );
				nNewIndex = (INT16)(pSVList->InsertEntry(pVar->GetString(),(USHORT)nPos));
			}
			else
			if( pSVCombo )
			{
				pSVCombo->RemoveEntry( (USHORT)nPos );
				nNewIndex = (INT16)(pSVCombo->InsertEntry(pVar->GetString(),(USHORT)nPos));
			}
		}

		pList->SetNewIndex( nNewIndex );

	}
	else
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVList )
				pVar->PutString( pSVList->GetEntry( (USHORT)nPos ) );
			else
			if( pSVCombo )
				pVar->PutString( pSVCombo->GetEntry( (USHORT)nPos ) );
			else
				pVar->PutString( pList->GetEntry( (USHORT)nPos ) );
		}
	}
}

void VCSbxComboBox::PropListCount( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	ListBox*  pSVList   = NULL;
	ComboBox* pSVCombo  = NULL;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (ListBox*)pSVControl;
	else
		pSVCombo = (ComboBox*)pSVControl;

	short nEntry=0;

	if( pSVList )
		nEntry = (short)pSVList->GetEntryCount();
	else
	if( pSVCombo )
		nEntry = (short)pSVCombo->GetEntryCount();
	else
		nEntry = (short)((VCComboBox*)pVCControl)->GetEntryCount();

	pVar->PutInteger( nEntry );
}

void VCSbxComboBox::PropListIndex( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	ListBox*  pSVList = NULL;
	ComboBox* pSVCombo= NULL;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (ListBox*)pSVControl;
	else
		pSVCombo = (ComboBox*)pSVControl;

	if( bWrite )
	{
		String aLinkData;

		if( pSVList )
		{
			INT16 nPos = pVar->GetInteger();
			pSVList->SelectEntryPos( (USHORT)nPos );
			aLinkData = pSVList->GetEntry( (USHORT)nPos );
		}
		else
		if( pSVCombo )
		{
			String aEntry = pSVCombo->GetEntry( pVar->GetInteger() );
			pSVCombo->SetText( aEntry );
			aLinkData = aEntry;
		}
		else
		{
			String aEntry =
				((VCComboBox*)pVCControl)->GetEntry( pVar->GetInteger() );
			((VCComboBox*)pVCControl)->SetText( aEntry );
			aLinkData = aEntry;
		}

		SfxItemSet* pSet = pRunTimeItemSet;
		if( !pSet )
			pSet = pVCControl->GetItemSet();
		String aLinkName = ((SfxStringItem&)pSet->Get( VCATTR_LINK )).GetValue();
		pVCControl->SetLinkData( aLinkName, aLinkData );
	}
	else
	{
		if( !pSVList && !pSVCombo )
		{
			// ist ein Dokument-Control
		}
		else
		{
			if( pSVList )
				pVar->PutInteger( pSVList->GetSelectEntryPos() );
			else
			if( pSVCombo )
				pVar->PutInteger( (short)pSVCombo->GetEntryPos( pSVCombo->GetText() ) );
			else
				pVar->PutInteger( ((VCComboBox*)pVCControl)->GetSelectEntry().ToInt32() );
		}
	}
}

void VCSbxComboBox::PropItemData( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar )
	{
		StarBASIC::Error( SbERR_NOT_OPTIONAL );
		return;
	}

	VCComboBox*   pList 	= (VCComboBox*)pVCControl;
	ULONG 		  nPos 		= pPar->Get(1)->GetInteger();
	ULONG         nCount;

	BOOL bIsDDList = pList->GetStyle()==(USHORT)VCCOMBO_DDLIST ? TRUE : FALSE;
	if( pSVControl )
	{
		if( bIsDDList )
			nCount = ((ListBox*)pSVControl)->GetEntryCount();
		else
			nCount = ((ComboBox*)pSVControl)->GetEntryCount();
	}
	else
		nCount = pList->GetEntryCount();

	if( bWrite )
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl && bIsDDList )
			{
				String* pEntryData = (String*)((ListBox*)pSVControl)->GetEntryData((USHORT)nPos);
				delete pEntryData;
				pEntryData = new String( pVar->GetInteger() );
				((ListBox*)pSVControl)->SetEntryData( (USHORT)nPos, pEntryData );
			}
			else
			{
				SfxItemSet* pItemSet = pRunTimeItemSet;
				if( !pItemSet )
					pItemSet = pVCControl->GetItemSet();

				VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->
												Get( VCATTR_ITEMDATA ).Clone();
				pItemData->SetEntryCount( (USHORT)nCount );
				List* pList = pItemData->GetList();
				String* pOldStr = (String*)pList->GetObject( nPos );
				pList->Replace( new String( pVar->GetInteger() ), nPos );
				delete pOldStr;
				pItemSet->Put( *pItemData );
				delete pItemData;
			}
		}
	}
	else
	{
		if( nPos >= nCount )
			StarBASIC::Error( SbERR_BAD_INDEX );
		else
		{
			if( pSVControl && bIsDDList )
			{
				String* pEntryData = (String*)((ListBox*)pSVControl)->GetEntryData((USHORT)nPos);
				pVar->PutInteger( (short)pEntryData->ToInt32() );
			}
			else
			{
				SfxItemSet* pItemSet = pRunTimeItemSet;
				if( !pItemSet )
					pItemSet = pVCControl->GetItemSet();

				VCIntegerListItem* pItemData = (VCIntegerListItem*)pItemSet->
												Get( VCATTR_ITEMDATA ).Clone();
				pItemData->SetEntryCount( (USHORT)nCount );
				List* pList = pItemData->GetList();

				String aStr = *(String*)pList->GetObject( nPos );
				pVar->PutInteger( (short)aStr.ToInt32() );
				delete pItemData;
			}
		}
	}
}

void VCSbxComboBox::PropText( SbxVariable* pVar, SbxArray* pArgs, BOOL bWrite )
{
	DBG_ASSERT(pVCControl,"No VCControl");
	USHORT nStyle = ((VCComboBox*)pVCControl)->GetStyle();
	if( bWrite && nStyle == (USHORT)VCCOMBO_DDLIST )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}

	ListBox*  pSVList   = NULL;
	ComboBox* pSVCombo  = NULL;

	SfxItemSet* pItemSet = pRunTimeItemSet;
	if( !pItemSet )
		pItemSet = pVCControl->GetItemSet();

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (ListBox*)pSVControl;
	else
		pSVCombo = (ComboBox*)pSVControl;

	if( !bWrite )
	{
		if( pSVList )
			pVar->PutString( pSVList->GetSelectEntry() );
		else
		if( pSVCombo )
			pVar->PutString( pSVCombo->GetText() );
		else
			pVar->PutString( ((VCComboBox*)pVCControl)->GetSelectEntry() );
	}
	else
	{
		if( pSVCombo )
			pSVCombo->SetText( pVar->GetString());
		SfxStringItem aStrItem( VCATTR_TEXT, pVar->GetString());
		pItemSet->Put( aStrItem );
		pVCControl->UpdateItem( VCATTR_TEXT );
	}
}

void VCSbxComboBox::PropNewIndex( SbxVariable* pVar, SbxArray*, BOOL bWrite )
{
	if( bWrite )
	{
		StarBASIC::Error( SbERR_PROP_READONLY );
		return;
	}
	pVar->PutInteger( ((VCComboBox*)pVCControl)->GetNewIndex() );
}

void VCSbxComboBox::PropSelLen( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		return;

	if( bWrite )
	{
		if( pVar->GetInteger() < 0 )
		{
			StarBASIC::Error( SbERR_BAD_PROP_VALUE );
			return;
		}

		if( pSVControl )
		{
			Selection aSel = ((ComboBox*)pSVControl)->GetSelection();
			aSel.Max() = aSel.Min() + (USHORT)pVar->GetInteger();
			((ComboBox*)pSVControl)->SetSelection( aSel );
		}
		else
		{
			return;
		}

	}
	else
	{
		if( pSVControl )
		{
			Selection aSel = ((ComboBox*)pSVControl)->GetSelection();
			pVar->PutInteger( (short)aSel.Len() );
		}
		else
		{
			return;
		}
	}
}

void VCSbxComboBox::PropSelStart( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		return;

	if( bWrite )
	{
		if( pSVControl )
		{
			Selection aSel = ((ComboBox*)pSVControl)->GetSelection();
			USHORT nLen = (USHORT)aSel.Len();
			aSel.Min() = (USHORT)pVar->GetInteger();
			aSel.Max() = aSel.Min() + nLen;
			((ComboBox*)pSVControl)->SetSelection( aSel );
		}
		else
		{
			return;
		}

	}
	else
	{
		if( pSVControl )
		{
			Selection aSel = ((ComboBox*)pSVControl)->GetSelection();
			pVar->PutInteger( (short)aSel.Min() );
		}
		else
		{
			return;
		}
	}
}

void VCSbxComboBox::PropSelText( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		return;

	if( bWrite )
	{
		if( pSVControl )
		{
			String aOldText = ((VCSVComboBox*)pSVControl)->GetText();
			((VCSVComboBox*)pSVControl)->ReplaceSelected( pVar->GetString() );
			if( aOldText != ((VCSVComboBox*)pSVControl)->GetText() )
				((VCSVComboBox*)pSVControl)->Modify();
		}
		else
			return;

	}
	else
	{
		if( pSVControl )
			pVar->PutString( ((ComboBox*)pSVControl)->GetSelected() );
		else
		{
			return;
		}
	}
}

void VCSbxComboBox::MethodAddItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	USHORT nParCount = 0;
	if( pPar )
		nParCount = pPar->Count();
	if( nParCount < 2 || nParCount > 3 )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCComboBox*    pCombo 	= (VCComboBox*)pVCControl;
	String		  aEntry	= pPar->Get(1)->GetString();

	VCSVListBox*  pSVList   = NULL;
	VCSVComboBox* pSVCombo  = NULL;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (VCSVListBox*)pSVControl;
	else
		pSVCombo = (VCSVComboBox*)pSVControl;


	ULONG nCount;
	if( pSVList )
		nCount = pSVList->GetEntryCount();
	else
	if( pSVCombo )
		nCount = pSVCombo->GetEntryCount();
	else
		nCount = pCombo->GetEntryCount();

	ULONG nPos;
	if( nParCount > 2 )
		nPos = pPar->Get(2)->GetInteger();
	else
		// keine Einfuegeposition angegeben: hinten anhaengen
		nPos = nCount;


	if( nPos > nCount )
		StarBASIC::Error( SbERR_BAD_INDEX );
	else
	{
		INT16 nNewIndex;
		if( pSVList )
		{
			nNewIndex = (INT16)(pSVList->InsertEntry( aEntry, (USHORT)nPos ));
			pSVList->SetEntryData( nNewIndex, new String );
		}
		else if( pSVCombo )
			nNewIndex = (INT16)(pSVCombo->InsertEntry( aEntry,(USHORT) nPos ));
		else
			nNewIndex = (INT16)(pCombo->InsertEntry( aEntry, nPos ));
		pCombo->SetNewIndex( nNewIndex );
	}
}

void VCSbxComboBox::MethodClear( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( pPar && (pPar->Count() > 1) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCComboBox*    pCombo 	= (VCComboBox*)pVCControl;
	VCSVListBox*  pSVList   = NULL;
	VCSVComboBox* pSVCombo  = NULL;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (VCSVListBox*)pSVControl;
	else
		pSVCombo = (VCSVComboBox*)pSVControl;

	if( pSVList )
		pSVList->Clear();
	else if( pSVCombo )
		pSVCombo->Clear();
	else
		pCombo->Clear();
}

void VCSbxComboBox::MethodRemoveItem( SbxVariable* pVar, SbxArray* pPar, BOOL bWrite )
{
	if( !pPar || (pPar->Count() != 2) )
	{
		StarBASIC::Error( SbERR_BAD_NUMBER_OF_ARGS );
		return;
	}

	VCComboBox*    	pCombo 		= (VCComboBox*)pVCControl;
	ULONG 			nPos 		= pPar->Get(1)->GetInteger();
	VCSVListBox*  	pSVList   = NULL;
	VCSVComboBox* 	pSVCombo  = NULL;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVList = (VCSVListBox*)pSVControl;
	else
		pSVCombo = (VCSVComboBox*)pSVControl;

	ULONG nCount;
	if( pSVList )
		nCount = pSVList->GetEntryCount();
	else if( pSVCombo )
		nCount = pSVCombo->GetEntryCount();
	else
		nCount = pCombo->GetEntryCount();

	if( !nCount )
		return;

	if( nPos >= nCount )
		StarBASIC::Error( SbERR_BAD_INDEX );
	else
	{
		if( pSVList )
			pSVList->RemoveEntry( (USHORT)nPos );
		else if( pSVCombo )
			pSVCombo->RemoveEntry( (USHORT)nPos );
		else
			pCombo->RemoveEntry( (USHORT)nPos );
	}
}

VCSbxComboBox::VCSbxComboBox( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_COMBOBOX ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCComboBox( pForm->GetVCContainer(), pForm->GetPool(),
								   bReal, this );
	}
	else
		pVCControl = new VCComboBox( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();

	// Properties einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "ListCount" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_LISTCOUNT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "ListIndex" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_LISTINDEX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Text" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_TEXT );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "NewIndex" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READ | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_NEWINDEX );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelLength" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELLEN );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelStart" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELSTART );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SelText" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_IMP_SELTEXT );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "AddItem" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_ADDITEM );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Clear" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_CLEAR );
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "RemoveItem" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_REMOVEITEM );
}

VCSbxComboBox::~VCSbxComboBox()
{
}

void VCSbxComboBox:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
							const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}

		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite ||
		   nWhich == VCMETH_ADDITEM ||  nWhich == VCMETH_CLEAR ||
		   nWhich == VCMETH_REMOVEITEM
		)
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		// Methoden
		switch( nWhich )
		{
			case VCMETH_ADDITEM:		MethodAddItem( pVar, pPar, bWrite ); return;
			case VCMETH_CLEAR:			MethodClear( pVar, pPar, bWrite ); return;
			case VCMETH_REMOVEITEM:		MethodRemoveItem( pVar, pPar, bWrite ); return;
		}

		// Interne Properties
		switch( nWhich )
		{
			case VCATTR_LIST:			PropList( pVar, pPar, bWrite ); return;
			case VCATTR_ITEMDATA:		PropItemData( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_LISTCOUNT:	PropListCount( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_LISTINDEX:	PropListIndex( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_TEXT:		PropText( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_NEWINDEX:	PropNewIndex( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_SELLEN:		PropSelLen( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_SELSTART:	PropSelStart( pVar, pPar, bWrite ); return;
			case VCATTR_IMP_SELTEXT:	PropSelText( pVar, pPar, bWrite ); return;

		}

		// Sonderbehandlung fuer ReadOnly Properties
		if( bWrite )
		{
			if( (nWhich == VCATTR_MULTISELECT) ||
				(nWhich == VCATTR_COMBOSTYLE)  )
			{
				StarBASIC::Error( SbERR_PROP_READONLY );
				return;
			}
		}

		VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

#ifdef TF_SI_OFF50

Control* VCSbxComboBox::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = 0;

	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((const SfxBoolItem&)rSet.Get( VCATTR_SORTED )).GetValue() )
		nStyle |= WB_SORT;

	Control* pResult;
	USHORT nComboStyle =
		(USHORT)((const VCComboStyleItem&)rSet.Get(VCATTR_COMBOSTYLE)).GetValue();

	if( nComboStyle == VCCOMBO_DDLIST )
		pResult = new VCSVListBox( pParent, pVCControl, nStyle | WB_DROPDOWN );
	else
	if( nComboStyle == VCCOMBO_COMBO )
		pResult = new VCSVComboBox( pParent, pVCControl, nStyle );
	else
		pResult = new VCSVComboBox( pParent, pVCControl, nStyle | WB_DROPDOWN );
	return pResult;
}
#endif


void VCSbxComboBox::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	// ItemSet clonen
	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = 0;

	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_SORTED )).GetValue() )
		nStyle |= WB_SORT;

	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
		pSVControl = new VCSVListBox( pParent, pVCControl, nStyle | WB_DROPDOWN );
	else
	if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_COMBO )
		pSVControl = new VCSVComboBox( pParent, pVCControl, nStyle );
	else
		pSVControl = new VCSVComboBox( pParent, pVCControl, nStyle | WB_DROPDOWN );
#endif
}

void VCSbxComboBox::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	SfxItemSet* pItemSet = pVCControl->GetItemSet();

	// Liste setzen
	if( !nWhich || (nWhich==VCATTR_LIST) )
	{
		SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
		List* pList = rItem.GetList();
		String* pStr = (String*)pList->First();

		if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
			((VCSVListBox*)pSVControl)->Clear(); // raeumt ItemData ab
		else
			((VCSVComboBox*)pSVControl)->Clear();

		INT16 nNewIndex = -1;
		VCIntegerListItem& rItemData = (VCIntegerListItem&)pRunTimeItemSet->Get( VCATTR_ITEMDATA );
		List* pItemDataList = rItemData.GetList();

		String aEmptyStr;
		ULONG nCount = pList->Count();
		for( ULONG nCur = 0; nCur < nCount; nCur++ )
		{
			String* pStr = (String*)pList->GetObject(nCur);
			if( ((VCComboBox*)pVCControl)->GetStyle() == (USHORT)VCCOMBO_DDLIST )
			{
				nNewIndex = (INT16)(((ListBox*)pSVControl)->InsertEntry( *pStr ));
				String* pItemData = (String*)pItemDataList->GetObject(nCur);
				if( !pItemData )
					pItemData = &aEmptyStr;
				((ListBox*)pSVControl)->SetEntryData(nNewIndex,new String(*pItemData));
			}
			else
				nNewIndex = (INT16)(((ComboBox*)pSVControl)->InsertEntry( *pStr ));

			pStr = (String*)pList->Next();
		}
		((VCComboBox*)pVCControl)->SetNewIndex( nNewIndex );
	}

	// Text setzen
	if( !nWhich || (nWhich==VCATTR_TEXT) )
	{
		if( ((VCComboBox*)pVCControl)->GetStyle() != (USHORT)VCCOMBO_DDLIST )
		{
			String aText = ((SfxStringItem&)pItemSet->Get( VCATTR_TEXT )).GetValue();
			if( nWhich==VCATTR_TEXT )
			{
				if( ((ComboBox*)pSVControl)->GetText() != aText )
				{
					((VCSVComboBox*)pSVControl)->SetText( aText );
					((VCSVComboBox*)pSVControl)->Modify();
				}
			}
			else
				((ComboBox*)pSVControl)->SetText( aText );
		}
	}

	if( !nWhich )
		((VCComboBox*)pVCControl)->SetNewIndex( -1 );
}


/**************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxlst.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxlst.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:04  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.76  2000/05/11 14:16:09  pw
	  UNICODE
	
	  Revision 1.75  2000/02/10 20:02:12  hr
	  #70473# changes for unicode ( patched by automated patchtool )
	
	  Revision 1.74  1998/10/12 16:14:00  OV
	  #54233# Alte Virt-Controls raus
	

	  Rev 1.73   12 Oct 1998 18:14:00   OV
   #54233# Alte Virt-Controls raus

	  Rev 1.72   21 Nov 1997 17:01:40   OV
   Headerumstellung

	  Rev 1.71   07 Nov 1997 13:06:28   OV
   weitere VCL-Umstellungen

	  Rev 1.70   06 Nov 1997 12:45:50   OV
   VCL-Umstellungen

	  Rev 1.69   31 Oct 1997 11:05:54   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.68   29 Oct 1997 14:34:48   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.67   25 Oct 1997 18:59:38   OV
   #44418# Workaround fuer fehlendes Get/LoseFocus

	  Rev 1.66   24 Oct 1997 14:57:56   OV
   #44418# VCL: PreNotify an List & ComboBox ueberladen

	  Rev 1.65   24 Oct 1997 11:02:44   OV
   #44268# VCL: WB_NOTABSTOP setzen

	  Rev 1.64   20 Oct 1997 17:46:30   OV
   #44463#,#44467#,#44468# LinkDaten richtig behandeln

	  Rev 1.63   08 Oct 1997 15:19:12   OV
   #44219# Bugfix in Verwaltung der ItemDaten

	  Rev 1.62   23 Sep 1997 09:18:26   OV
   #43774# Diverse Anpassungen fuer VCL

	  Rev 1.61   09 Sep 1997 17:32:02   OV
   #43661# Anbindung des Hilfesystems

	  Rev 1.60   09 Sep 1997 14:28:36   OV
   #43636# ComboBox: SV-Doppelklick-Hdl routen

	  Rev 1.59   28 Jul 1997 16:47:08   MH
   chg: header

	  Rev 1.58   09 Jul 1997 16:01:10   OV
   #41513# Mac/ListBox: MausEvents auf ScrollBar ignorieren

	  Rev 1.57   25 Jun 1997 11:00:32   OV
   #40970# Bei nicht gesetzten ItemDaten einen Leerstring setzen

	  Rev 1.56   04 Jun 1997 16:07:22   OV
   #38467# Real-List/ComboBox: Bei Sortierung die ItemDaten synchronisieren

	  Rev 1.55   25 Mar 1997 15:12:00   OV
   alle Doppelklicks erkennen

	  Rev 1.54   11 Feb 1997 14:00:00   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.53   10 Dec 1996 14:16:26   OV
   Umstellung auf SvxMacroItem

	  Rev 1.52   22 Nov 1996 19:46:22   OV
   JavaScript-Unterstuetzung

	  Rev 1.51   16 Oct 1996 21:18:24   MH
   chg: includes

	  Rev 1.50   31 Jul 1996 13:09:38   OV
   GetNewIndex sauber implementiert

	  Rev 1.49   05 Jun 1996 13:24:32   OV
   Clooks, Bugfixes, Erweiterungen

	  Rev 1.48   30 Mar 1996 17:09:46   OV
   #26289# Text-Prop jetzt auch in Makros ReadWrite

*************************************************************************/


#pragma SEG_EOFMODULE

