/*************************************************************************
 *
 *  $RCSfile: vcsbxscr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif

#pragma hdrstop

#define SI_VCSV_SCROLLBAR

#include "vcscrbar.hxx"
//#define _SI_NOVCSBXFORM
#define _SI_NOVCSBXBUTTON
#define _SI_NOVCSBXCHECKBOX
#define _SI_NOVCSBXRADIOBUTTON
#define _SI_NOVCSBXPUSHBUTTON
#define _SI_NOVCSBXSPINBUTTON
#define _SI_NOVCSBXFIXEDTEXT
#define _SI_NOVCSBXGROUPBOX
#define _SI_NOVCSBXLISTBOX
#define _SI_NOVCSBXCOMBOBOX
#define _SI_NOVCSBXEDIT
//#define _SI_NOVCSBXSCROLLBAR
//#define _SI_NOVCSBXHSCROLLBAR
//#define _SI_NOVCSBXVSCROLLBAR
#define _SI_NOVCSBXPREVIEW
#define _SI_NOVCSBXURLBUTTON
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vctrls.hxx"
#include "vcont.hxx"
#include "vcsbx.hxx"
#include "siresid.hxx"
#include "vctrls.hrc"
#include "vcictrls.hxx"
#include "sictrls.hxx"

void VCSVScrollBar::RequestHelp( const HelpEvent& rHEvt )
{
	if( !pShell->GetSbxControl()->RequestHelp( rHEvt ) )
		ScrollBar::RequestHelp( rHEvt );
}

//------------------------------------------------------------------------

#ifndef VCL

void VCSVScrollBar::KeyInput( const KeyEvent& rKEvt )
{
	ScrollBar::KeyInput( rKEvt );
	pShell->GetImpControl()->SetActKeyEvent( (KeyEvent*)&rKEvt );
	pShell->KeyDown();
	pShell->KeyPress();
	pShell->KeyUp();
}

//------------------------------------------------------------------------
void VCSVScrollBar::GetFocus()
{
	pShell->GotFocus();
}

//------------------------------------------------------------------------
void VCSVScrollBar::LoseFocus()
{
	pShell->LostFocus();
}

#else

long VCSVScrollBar::PreNotify( NotifyEvent& rNEvt )
{
	long nRet = ScrollBar::PreNotify( rNEvt );
	pShell->GetSbxControl()->PreNotify( rNEvt );
	return nRet;
}

#endif

//------------------------------------------------------------------------
void VCSVScrollBar::Scroll()
{
	SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
	INT32 nThumb = GetThumbPos();
	INT32 nMin;
#ifdef VCL
	nMin = (INT32)((SfxInt32Item&)pItemSet->Get( VCATTR_MIN )).GetValue();
#else
	nMin = 0;
#endif
	SfxInt32Item aValueItem( VCATTR_SCROLLBARVALUE, nThumb + nMin );
	pItemSet->Put( aValueItem );
	pShell->Scrolled();
}

//------------------------------------------------------------------------
void VCSVScrollBar::EndScroll()
{
	SfxItemSet* pItemSet = pShell->GetSbxControl()->GetRunTimeItemSet();
	INT32 nThumb = GetThumbPos();
	INT32 nMin;
#ifdef VCL
	nMin = (INT32)((SfxInt32Item&)pItemSet->Get( VCATTR_MIN )).GetValue();
#else
	nMin = 0;
#endif
	SfxInt32Item aValueItem( VCATTR_SCROLLBARVALUE, nThumb + nMin );
	pItemSet->Put( aValueItem );
	pShell->Changed();
}


TYPEINIT1( VCSbxScrollBar, VCSbxControl );


VCSbxScrollBar::VCSbxScrollBar( BOOL bReal )
{
	// Value Property einspiegeln
	SbxVariable* p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "Value" ) ), SbxCLASS_PROPERTY, SbxVARIANT );
	p->SetFlags( SBX_READWRITE | SBX_DONTSTORE );
	p->SetUserData( VCATTR_SCROLLBARVALUE );

	//Methoden registrieren
	p = Make( String( RTL_CONSTASCII_USTRINGPARAM( "SetFocus" ) ), SbxCLASS_METHOD, SbxEMPTY );
	p->SetFlag( SBX_DONTSTORE );
	p->SetUserData( VCMETH_SETFOCUS );
}

VCSbxScrollBar::~VCSbxScrollBar()
{
}

#ifdef TF_SI_OFF50

Control* VCSbxScrollBar::CreateVCLControl( Window* pParent, const SfxItemSet& rSet) const
{
	WinBits nStyle = WB_DRAG;
	if( ((const SfxBoolItem&)rSet.Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( ISA(VCSbxHScrollBar) )
		nStyle |= WB_HSCROLL | WB_GROUP;
	else
		nStyle |= WB_VSCROLL | WB_GROUP;

	return new VCSVScrollBar( pParent, (VCScrollBar*)pVCControl, nStyle );
}

#endif

void VCSbxScrollBar::CreateSVControl( Window* pParent )
{
	DeleteSVControl();

	VCSbxControl::CreateSVControl( pParent );
#ifdef TF_SI_OFF50
	pSVControl = CreateVCLControl( pParent, *pRunTimeItemSet );
#else

	WinBits nStyle = WB_DRAG;
	if( ((SfxBoolItem&)pRunTimeItemSet->Get( VCATTR_TABSTOP )).GetValue() )
		nStyle |= WB_TABSTOP;
#ifdef VCL
	else
		nStyle |= WB_NOTABSTOP;
#endif

	if( IsA( TYPE( VCSbxHScrollBar ) ) )
		nStyle |= WB_HSCROLL | WB_GROUP;
	else
		nStyle |= WB_VSCROLL | WB_GROUP;

	pSVControl = new VCSVScrollBar( pParent, (VCScrollBar*)pVCControl, nStyle );
#endif
}

void VCSbxScrollBar::UpdateSVControl( USHORT nWhich )
{
	if( !pSVControl )
		return;

	// Position und Groesse werden durch Basisklasse gesetzt
	VCSbxControl::UpdateSVControl( nWhich );

	// Min, Max, SmallChange, LargeChange und Value setzen
	long nLarge= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LARGECHANGE )).GetValue();

	VCSVScrollBar* pScroll = (VCSVScrollBar*)pSVControl;

	if( !nWhich || (nWhich == VCATTR_MIN) || (nWhich == VCATTR_MAX) )
	{
		long nMin  = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_MIN )).GetValue();
		long nMax  = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_MAX )).GetValue();
#ifndef VCL
		pScroll->SetRange( Range( (short)nMin, (short)nMax ) );
#else
		if( nMin < nMax && nMax - nMin > 0 )
			pScroll->SetRangeMax( nMax - nMin );
#endif
	}

	if( !nWhich || (nWhich == VCATTR_SMALLCHANGE) )
	{
		long nSmall= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_SMALLCHANGE )).GetValue();
		pScroll->SetLineSize( nSmall );
	}

	if( !nWhich || (nWhich == VCATTR_LARGECHANGE) )
	{
		long nLarge= ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_LARGECHANGE )).GetValue();
		pScroll->SetPageSize( nLarge );
	}

	if( !nWhich || (nWhich == VCATTR_SCROLLBARVALUE) )
	{
		INT32 nVal = ((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_SCROLLBARVALUE )).GetValue();
		INT32 nMin;
#ifdef VCL
		nMin = (INT32)((SfxInt32Item&)pRunTimeItemSet->Get( VCATTR_MIN )).GetValue();
#else
		nMin = 0;
#endif
		pScroll->SetThumbPos( nVal - nMin );
	}
}

TYPEINIT1( VCSbxHScrollBar, VCSbxScrollBar );

VCSbxHScrollBar::VCSbxHScrollBar( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_HSCROLLBAR ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCHScrollBar( pForm->GetVCContainer(), pForm->GetPool(),
									 bReal, this );
	}
	else
		pVCControl = new VCHScrollBar( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();
}

VCSbxHScrollBar::~VCSbxHScrollBar()
{
}

TYPEINIT1( VCSbxVScrollBar, VCSbxScrollBar );

VCSbxVScrollBar::VCSbxVScrollBar( BOOL bReal )
{
	aClassName = String( SiResId( STR_CLASS_VSCROLLBAR ) );

	if( GetParent() && GetParent()->IsA( TYPE( VCSbxForm ) ) )
	{
		VCSbxForm* pForm = (VCSbxForm*)GetParent();
		pVCControl = new VCVScrollBar( pForm->GetVCContainer(), pForm->GetPool(),
									 bReal, this );
	}
	else
		pVCControl = new VCVScrollBar( NULL, VCSbxForm::GetGenericVCPool(), bReal, this );

	Init();
}

VCSbxVScrollBar::~VCSbxVScrollBar()
{
}

void VCSbxScrollBar:: SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCT,
	const SfxHint& rHint, const TypeId& rHT )
{
	const SbxHint* pHint = PTR_CAST( SbxHint, &rHint );

	if( pHint )
	{
		if( pHint->GetId() == SBX_HINT_INFOWANTED )
		{
			VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
			return;
		}
		SbxVariable* pVar 	= pHint->GetVar();
		SbxArray*    pPar 	= pVar->GetParameters();
		USHORT       nWhich	= (USHORT)pVar->GetUserData();
		BOOL		 bWrite = pHint->GetId() == SBX_HINT_DATACHANGED;

		if( bWrite )
			LoadDialog(); // bei erstem Schreibzugriff den Dialog laden

		if((nWhich == VCATTR_SCROLLBARVALUE) && bWrite && pSVControl )
		{
			long nNewThumbPos = (long)pVar->GetLong();
			SfxInt32Item aValueItem( VCATTR_SCROLLBARVALUE, nNewThumbPos );
			pRunTimeItemSet->Put( aValueItem );
		}
		VCSbxControl:: SFX_NOTIFY( rBC, rBCT, rHint, rHT );
	}
}

/***************************************************************************
	  Source Code Control System - Header

	  $Header: /cvs/oo/script/basctl/source/si/vcsbxscr.cxx,v 1.1.1.1 2000/09/29 11:02:41 mh Exp $

	  Source Code Control System - Update

	  $Log: vcsbxscr.cxx,v $
	  Revision 1.1.1.1  2000/09/29 11:02:41  mh
	  initial import
	
	  Revision 1.1.1.1  2000/09/18 16:11:45  hr
	  initial import
	
	  Revision 1.2  2000/09/08 14:03:50  willem.vandorp
	  Header and footer replaced
	
	  Revision 1.1.1.1  2000/09/04 07:26:04  tbe
	  basicide, isetbrw, si, vcdlged moved from svx to basctl
	
	  Revision 1.34  2000/05/11 14:17:59  pw
	  UNICODE
	
	  Revision 1.33  1997/11/21 16:02:12  OV
	  Headerumstellung
	

	  Rev 1.32   21 Nov 1997 17:02:12   OV
   Headerumstellung

	  Rev 1.31   07 Nov 1997 13:05:52   OV
   weitere VCL-Umstellungen

	  Rev 1.30   06 Nov 1997 12:45:56   OV
   VCL-Umstellungen

	  Rev 1.29   31 Oct 1997 11:05:30   OV
   Anpassungen VCL (364-inkompat)

	  Rev 1.28   29 Oct 1997 14:34:50   OV
   VCL: Umstellung auf PreNotify (inkompat)

	  Rev 1.27   24 Oct 1997 10:58:50   OV
   #44268# VCL: WB_NOTABSTOP setzen

	  Rev 1.26   09 Oct 1997 16:09:10   OV
   #44372# ScrollBar::SetRange an VCL angepasst

	  Rev 1.25   01 Oct 1997 11:25:14   OV
   #44280# CreateSVControl: WinBits richtig setzen

	  Rev 1.24   09 Sep 1997 17:31:50   OV
   #43661# Anbindung des Hilfesystems

	  Rev 1.23   28 Jul 1997 16:45:12   MH
   chg: header

	  Rev 1.22   01 Apr 1997 17:09:06   MH
   chg: header

	  Rev 1.21   11 Feb 1997 13:59:50   OV
   Tastatur-/KeyEvents richtig setzen

	  Rev 1.20   10 Dec 1996 14:16:22   OV
   Umstellung auf SvxMacroItem

	  Rev 1.19   22 Nov 1996 19:46:12   OV
   JavaScript-Unterstuetzung

	  Rev 1.18   16 Oct 1996 21:18:22   MH
   chg: includes

	  Rev 1.17   05 Jun 1996 13:24:54   OV
   Clooks, Bugfixes, Erweiterungen

*************************************************************************/


#pragma SEG_EOFMODULE

