/*************************************************************************
 *
 *  $RCSfile: vctrls.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFX_SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SFX_FCONTNR_HXX
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX
#include <sfx2/docfilt.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <sfx2/docfile.hxx>
#endif
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <sfx2/objsh.hxx>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#define ITEMID_MACRO 11111
#include <svtools/macitem.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SB_SBSTAR_HXX
#include <basic/sbstar.hxx>
#endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#pragma hdrstop

#include "vcurlit.hxx"
#include "vcfmacit.hxx"
#include "vcnkstit.hxx"
#include "vced.hxx"
#include "vcbutton.hxx"
#include "vcedit.hxx"
#include "vccbbox.hxx"
#include "vcchkbox.hxx"
#include "vcfxtxt.hxx"
#include "vcgrpbox.hxx"
#include "vclbox.hxx"
#include "vcpbttn.hxx"
#include "vcrdbttn.hxx"
#include "vcscrbar.hxx"
#include "vcspnbtn.hxx"
#include "vcurlbtn.hxx"
#define ITEMID_COLOR 0
#include <svx/colritem.hxx>
#define SI_VCDRAWOBJ
#define SI_VCDLGOBJ
#define _SI_VCITEMS
#include "sidll.hxx"
#include "vctrls.hxx"
#include "vcattr.hxx"
#include "vcattrid.hrc"
#include "vcdrwobj.hxx"
#include "vcictrls.hxx"
#include "vcont.hxx"
#include "vcsbxdo.hxx"
#include "vctrls.hrc"
#include "siresid.hxx"
#include "formdlg.hrc"
#include "vcform.hxx"

static MouseEvent* pCurMouseEvent = 0;

TYPEINIT0( VCControl );

void VCControl::Create()
{
}

void VCControl::MouseButtonDown( Window* pWindow, const MouseEvent& rEvt )
{
	if( pImpCtrl )
		pImpCtrl->MouseButtonDown( pWindow, rEvt );
}

void VCControl::MouseButtonUp( Window* pWindow, const MouseEvent& rEvt )
{
	if( pImpCtrl )
		pImpCtrl->MouseButtonUp( pWindow, rEvt );
}

void VCControl::MouseMove( Window* pWindow, const MouseEvent& rEvt )
{
	if( pImpCtrl )
		pImpCtrl->MouseMove( pWindow, rEvt );
}

void VCControl::KeyInput( Window* pWindow, const KeyEvent& rEvt )
{
	if( pImpCtrl )
		pImpCtrl->KeyInput( pWindow, rEvt );
}

Window* VCControl::GetWindow() const
{
	return NULL;
}

void VCControl::UpdateOutRect()
{
	aOutRect = Rectangle( GetPos(), GetSize() );
	aOutRect.Move( aDrawOfs.X(), aDrawOfs.Y() );
}

VCControl::VCControl( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
	VCSbxControl* _pCtrl ) :
	pPool(pPool),
	pItemSet(NULL),
	pImpCtrl(NULL),
	pDrawObject(NULL),
	pActMouseEvent(NULL),
	pActKeyEvent(NULL),
	eOutUnit( MAP_TWIP ),
	//pJavaWrapper( 0 ),
	pSbxControl( _pCtrl ),
	nFlags( 0 )
{
	VCControl::bReal   = bReal;
	VCControl::pParent = pParent;
	SiDLL::NotifyControlCreated( this );
}

VCControl::~VCControl()
{
	SiDLL::NotifyControlDeleted( this );
	if( pParent )
		pParent->RemoveChild( this );
	if( pImpCtrl )
		delete pImpCtrl;
	delete pItemSet;
}

String VCControl::GetName() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_NAME )).GetValue();
}

void VCControl::SetName( const String& rName )
{
	SfxStringItem aItem( VCATTR_NAME, rName );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_NAME );
	SiDLL::UpdateBrowserItem( VCATTR_NAME );
}

String VCControl::GetFormName() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_FORMNAME )).GetValue();
}

void VCControl::SetFormName( const String& rName )
{
	String aStr( rName );
	SfxStringItem aItem( VCATTR_FORMNAME, aStr );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_FORMNAME );
	SiDLL::UpdateBrowserItem( VCATTR_FORMNAME );
}

String VCControl::GetCaption() const
{
	if( pItemSet->GetItemState( VCATTR_CAPTION ) != SFX_ITEM_UNKNOWN )
		return ((SfxStringItem&)pItemSet->Get( VCATTR_CAPTION )).GetValue();
	else
	if( pItemSet->GetItemState( VCATTR_TEXT ) != SFX_ITEM_UNKNOWN )
		return ((SfxStringItem&)pItemSet->Get( VCATTR_TEXT )).GetValue();
	else
		return String();
}

void VCControl::SetCaption( const String& rName )
{
	if( pItemSet->GetItemState( VCATTR_CAPTION ) != SFX_ITEM_UNKNOWN )
	{
		SfxStringItem aItem( VCATTR_CAPTION, rName );
		pItemSet->Put( aItem );
		UpdateItem( VCATTR_CAPTION );
		SiDLL::UpdateBrowserItem( VCATTR_CAPTION );
	}
	else
	if( pItemSet->GetItemState( VCATTR_TEXT ) != SFX_ITEM_UNKNOWN )
	{
		SfxStringItem aItem( VCATTR_TEXT, rName );
		pItemSet->Put( aItem );
		UpdateItem( VCATTR_TEXT );
		SiDLL::UpdateBrowserItem( VCATTR_TEXT );
	}
}

String VCControl::GetTag() const
{
	if( pItemSet->GetItemState( VCATTR_TAG ) != SFX_ITEM_UNKNOWN )
		return ((SfxStringItem&)pItemSet->Get( VCATTR_TAG )).GetValue();
	else
		return String();
}

void VCControl::SetTag( const String& rName )
{
	if( pItemSet->GetItemState( VCATTR_TAG ) != SFX_ITEM_UNKNOWN )
	{
		SfxStringItem aItem( VCATTR_TAG, rName );
		pItemSet->Put( aItem );
		UpdateItem( VCATTR_TAG );
		SiDLL::UpdateBrowserItem( VCATTR_TAG );
	}
}

void VCControl::SetPos( const Point& rPos )
{
	if( pDrawObject )
		pDrawObject->SendRepaintBroadcast();

	Rectangle aOldRect( aOutRect );

	SfxInt32Item aLeftAttr( VCATTR_LEFT, rPos.X() );
	SfxInt32Item aTopAttr( VCATTR_TOP, rPos.Y() );
	pItemSet->Put( aLeftAttr );
	pItemSet->Put( aTopAttr );

//!!! Hier muss noch in Pixel umgerechnet werden
	if( pImpCtrl && pParent )
	{
		pImpCtrl->Update( TRUE, VCATTR_LEFT );
		pImpCtrl->Update( TRUE, VCATTR_TOP );
	}
	UpdateOutRect();

	if( pDrawObject )
	{
		pDrawObject->SetRectsDirty();
		pDrawObject->SendRepaintBroadcast();
		if( pDrawObject->GetUserCall() )
			pDrawObject->GetUserCall()->Changed( *pDrawObject, SDRUSERCALL_MOVEONLY,
				aOldRect );
	}
	SiDLL::UpdateBrowserItem( VCATTR_LEFT );
	SiDLL::UpdateBrowserItem( VCATTR_TOP );
}

Point VCControl::GetPos() const
{
	long nX = ((SfxInt32Item&)pItemSet->Get( VCATTR_LEFT )).GetValue();
	long nY = ((SfxInt32Item&)pItemSet->Get( VCATTR_TOP )).GetValue();

	return Point( nX, nY );
}

void VCControl::SetSize( const Size& rSize )
{
	if( pDrawObject )
		pDrawObject->SendRepaintBroadcast();

	Rectangle aOldRect( aOutRect );

	SfxInt32Item aWidthAttr( VCATTR_WIDTH, rSize.Width() );
	SfxInt32Item aHeightAttr( VCATTR_HEIGHT, rSize.Height() );
	pItemSet->Put( aWidthAttr );
	pItemSet->Put( aHeightAttr );

// Hier muss noch in Pixel umgerechnet werden
	if( pImpCtrl && pParent )
	{
		pImpCtrl->Update( TRUE, VCATTR_WIDTH );
		pImpCtrl->Update( TRUE, VCATTR_HEIGHT );
	}
	UpdateOutRect();

	if( pDrawObject )
	{
		pDrawObject->SetRectsDirty();
		pDrawObject->SendRepaintBroadcast();
		if( pDrawObject->GetUserCall() )
			pDrawObject->GetUserCall()->Changed( *pDrawObject, SDRUSERCALL_RESIZE,
				aOldRect );
	}
	SiDLL::UpdateBrowserItem( VCATTR_WIDTH );
	SiDLL::UpdateBrowserItem( VCATTR_HEIGHT );
}

Size VCControl::GetSize() const
{
	long nWidth  = ((SfxInt32Item&)pItemSet->Get( VCATTR_WIDTH )).GetValue();
	long nHeight = ((SfxInt32Item&)pItemSet->Get( VCATTR_HEIGHT )).GetValue();

	return Size( nWidth, nHeight );
}

Size VCControl::GetMinSizePixel()
{
	return pImpCtrl->GetMinSizePixel();
}

void VCControl::SetDrawOfs( const Point& rDrawOfs )
{
	aDrawOfs = rDrawOfs;

	UpdateOutRect();
}

void VCControl::SetVisible( BOOL bVisible )
{
	SfxBoolItem aVisibleAttr( VCATTR_VISIBLE, bVisible );
	pItemSet->Put( aVisibleAttr );

	if( pImpCtrl && pParent )
		pImpCtrl->Update();
	SiDLL::UpdateBrowserItem( VCATTR_VISIBLE );
}

BOOL VCControl::IsVisible() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_VISIBLE )).GetValue();
}

void VCControl::Enable( BOOL bEnable )
{
	SfxBoolItem aEnableAttr( VCATTR_ENABLED, bEnable );
	pItemSet->Put( aEnableAttr );

	if( pImpCtrl && pParent )
		pImpCtrl->Update();
}

BOOL VCControl::IsEnabled() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_ENABLED )).GetValue();
}

long VCControl::GetStep() const
{
	return ((SfxInt32Item&)pItemSet->Get( VCATTR_STEP )).GetValue();
}

void VCControl::SetStep( long nStep )
{
	SfxInt32Item aItem( VCATTR_STEP, nStep );
	pItemSet->Put( aItem );
	SiDLL::UpdateBrowserItem( VCATTR_STEP );
}

void VCControl::SetParent( VCContainer* pNewParent )
{
	if( pParent == pNewParent )
		return;

	if( pParent )
		pParent->RemoveChild( this );

	pParent = pNewParent;

	if( pNewParent )
		pNewParent->InsertChild( this );


	if( !pNewParent )
	{
		delete pImpCtrl;
		pImpCtrl = NULL;
	}
	if( pNewParent )
	{
		Create();
		SetFormName(String());
	}
}

VCContainer* VCControl::GetParent() const
{
	return pParent;
}

void VCControl::SetTabPos( ULONG nPos )
{
	SfxInt32Item aItem( VCATTR_TABINDEX, nPos );
	pItemSet->Put( aItem );
	SiDLL::UpdateBrowserItem( VCATTR_TABINDEX );
}

ULONG VCControl::GetTabPos() const
{
	return ((SfxInt32Item&)pItemSet->Get( VCATTR_TABINDEX )).GetValue();
}

void VCControl::Deactivate()
{
	if( pImpCtrl )
	{
		delete pImpCtrl;
		pImpCtrl = NULL;
	}
}

void VCControl::ReActivate()
{
	if( !pImpCtrl )
	{
		Create();
		UpdateItem( 0 );
		if( pDrawObject )
			pDrawObject->SendRepaintBroadcast();
	}
}

void VCControl::SetItemSetSimple( SfxItemSet* pParamItemSet )
{
	if( pItemSet != pParamItemSet )
	{
		delete pItemSet;
		pItemSet = pParamItemSet;
	}
}

void VCControl::SetItemSet( SfxItemSet* pParamItemSet )
{
	if( pDrawObject )
		pDrawObject->SendRepaintBroadcast();

	SetItemSetSimple( pParamItemSet );

	if( pImpCtrl && pParent )
		pImpCtrl->Update();

	UpdateOutRect();

	if( pDrawObject )
	{
		pDrawObject->SetRectsDirty();
		pDrawObject->SendRepaintBroadcast();
	}
}

void VCControl::SetPool( VCItemPool* pNewPool )
{
	if( !pNewPool || (pPool == pNewPool) )
		return;

	// ItemSet umhaengen
	SfxItemSet* pOldSet = pItemSet;
	pItemSet = pItemSet->Clone( TRUE, pNewPool );
	delete pOldSet;

	pPool = pNewPool;
}

String VCControl::GetClassName() const
{
	return String();
}

String VCControl::GetClassNamePlural() const
{
	return String();
}

BOOL VCControl::IsActionHit( const Point& rPt, long )
{
	return aOutRect.IsInside( rPt );
}

void VCControl::Paint( Window* pWindow, const Rectangle& rRect )
{
	if( pImpCtrl )
		pImpCtrl->Paint( pWindow );
}

void VCControl::Draw( OutputDevice* pOut )
{
	if( pImpCtrl )
		pImpCtrl->Paint( pOut );
}

void VCControl::UpdateItem( USHORT nWhich )
{
	Rectangle aOldRect( aOutRect );

	if( pDrawObject )
	{
		VCDrawModel* pModel = (VCDrawModel*)(pDrawObject->GetModel());
		if( pModel )
		{
			pModel->VCDrawModelChanged( TRUE );
			SdrHint aHint( *pDrawObject );
			aHint.SetNeedRepaint( FALSE );
			pModel->Broadcast( aHint );
		}

		pDrawObject->SendRepaintBroadcast();
	}

	if( pImpCtrl && pParent )
		pImpCtrl->Update( TRUE, nWhich );

	UpdateOutRect();

	if( pDrawObject )
	{
		if( !nWhich  ||
			(nWhich == VCATTR_LEFT)   ||
			(nWhich == VCATTR_TOP)    ||
			(nWhich == VCATTR_WIDTH)  ||
			(nWhich == VCATTR_HEIGHT)    )
			pDrawObject->SetRectsDirty();
		{
			pDrawObject->SendRepaintBroadcast();
			if( pDrawObject->GetUserCall() )
			{
				pDrawObject->GetUserCall()->Changed( *pDrawObject, SDRUSERCALL_RESIZE,
					aOldRect );
			}
		}
	}

	// 25.3.97: Tabindex nur bei echten Controls
	// Todo: HTML-Import: TabPos richtig setzen (sonst Cursortravelling
	// in Forms falsch)
	if( (!nWhich || (nWhich == VCATTR_TABINDEX)) && pParent )
		pParent->MoveChild( this,
				(ULONG)((SfxInt32Item&)pItemSet->Get( VCATTR_TABINDEX )).GetValue() );

	// TODO: In VCURLButton::UpdateItem verschieben
	// nicht bei nWhich == 0, da nur bei Aenderungen ueber Browser notwendig
	if( nWhich == VCATTR_URL )
	{
		const String& rURL = ((VCURLItem&)pItemSet->Get(VCATTR_URL)).GetValue();
		if( rURL.Len() && rURL.GetChar( 0 ) != sal_Unicode( '#' ))
		{
			INetURLObject aURLObj;
			aURLObj.SetSmartURL( rURL );
			pItemSet->Put( VCURLItem( VCATTR_URL, aURLObj.GetMainURL()));
		}
		else
			pItemSet->Put( VCURLItem( VCATTR_URL, rURL ));
	}
}

String VCControl::GetLinkData( const String& rName )
{
	if( pParent )
		return pParent->GetLinkData( rName );
	else
		return String();
}

void VCControl::SetLinkData( const String& rLinkName,
							 const String& rLinkData )
{
	if( pParent )
		pParent->SetLinkData( rLinkName, rLinkData );
}

void VCControl::UpdateLinkData( const String& rLinkName,
								const String& rLinkData )
{
	String aStr = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
	if( aStr.CompareIgnoreCaseToAscii( rLinkName ) == COMPARE_EQUAL )
		pImpCtrl->Update();
}

void VCControl::SetDrawObject( VCSbxDrawObject* pDrwObj )
{
	pDrawObject = pDrwObj;
}

void VCControl::InvalidateOverlayObjects( Window* pWindow )
{
	if( pDrawObject )
		pDrawObject->InvalidateOverlayObjects( pWindow );
}

BOOL VCControl::HasOverlayObjects() const
{
	if( pDrawObject )
		return pDrawObject->HasOverlayObjects();
	else
		return FALSE;
}

SbxArray* VCControl::CreateSbxParams( USHORT nHandlerId )
{
	SbxArray* pArray = 0;
	const MouseEvent* _pActMouseEvent = pImpCtrl->GetActMouseEvent();
	const KeyEvent* _pActKeyEvent = pImpCtrl->GetActKeyEvent();
	// Nullen, damits gleich kracht
	pActKeyEvent = 0;
	pActMouseEvent = 0;
	switch( nHandlerId )
	{
		case VCHDL_ONMOUSEUP:
		case VCHDL_ONMOUSEDOWN:
		case VCHDL_ONMOUSEMOVE:
		{
			pArray = new SbxArray;
			SbxVariable* pButtons = new SbxVariable;
			INT16       nButtons = 0;
			if( _pActMouseEvent->IsLeft() )  nButtons += 1;
			if( _pActMouseEvent->IsRight())  nButtons += 2;
			if( _pActMouseEvent->IsMiddle()) nButtons += 4;
			pButtons->PutInteger( nButtons );

			SbxVariable* pShift = new SbxVariable;
			INT16       nShift = 0;
			if( _pActMouseEvent->IsShift() ) nShift += 1;
			if( _pActMouseEvent->IsMod1() )  nShift += 2;
			if( _pActMouseEvent->IsMod2() )  nShift += 4;
			pShift->PutInteger( nShift );

			Point aPos = _pActMouseEvent->GetPosPixel();
			aPos = SI_DLL()->GetOutDev()->PixelToLogic( aPos, MapMode( MAP_TWIP ) );

			SbxVariable* pX = new SbxVariable;
			pX->PutInteger( (INT16)aPos.X() );

			SbxVariable* pY = new SbxVariable;
			pY->PutInteger( (INT16)aPos.Y() );

			pArray->Put( pButtons, 1 );
			pArray->Put( pShift, 2 );
			pArray->Put( pX, 3 );
			pArray->Put( pY, 4 );
		}
		break;

		case VCHDL_ONKEYUP:
		case VCHDL_ONKEYDOWN:
		{
			pArray = new SbxArray;

			SbxVariable* pKeyCode = new SbxVariable;
			pKeyCode->PutInteger( (INT16)_pActKeyEvent->GetKeyCode().GetCode() );
			SbxVariable* pShift = new SbxVariable;
			INT16 nShift = 0;
			if( _pActKeyEvent->GetKeyCode().IsShift() ) nShift += 1;
			if( _pActKeyEvent->GetKeyCode().IsMod1() )  nShift += 2;
			if( _pActKeyEvent->GetKeyCode().IsMod2() )  nShift += 4;
			pShift->PutInteger( nShift );

			pArray->Put( pKeyCode, 1 );
			pArray->Put( pShift, 2 );

		}
		break;

		case VCHDL_ONKEYINPUT:
		{
			pArray = new SbxArray;
			SbxVariable* pAscii = new SbxVariable;
			pAscii->PutInteger( _pActKeyEvent->GetCharCode() );
			pArray->Put( pAscii, 1 );
		}
		break;

		case VCHDL_ONPAINT:
		case VCHDL_ONRESIZE:
		case VCHDL_ONACTIVATE:
		case VCHDL_ONDEACTIVATE:
		case VCHDL_ONLOAD:
		case VCHDL_ONUNLOAD:
			break;
	}
	return pArray;
}

void VCControl::DestroySbxParams( SbxArray* pParams )
{
	// aufraeumen
	if( pParams )
	{
		USHORT nCount = pParams->Count();
		for( USHORT nCur = 0; nCur < nCount; nCur++ )
		{
			SbxVariable* pParam = pParams->Get( nCur );
			pParam->ReleaseRef();
		}
		pParams->ReleaseRef();
	}
}

//static
String VCControl::GetReferer( SbxObject* pControl )
{
	String aReferer;
	SdrObject* pDrawObject = 0;
	SfxApplication* pApp=SFX_APP();
	if( pControl )
	{
		if( pControl->ISA(VCSbxControl))
			pDrawObject = ((VCSbxControl*)pControl)->GetVCControl()->GetDrawObject();
		else if( pControl->ISA(VCSbxDialog))
			pDrawObject = (SdrObject*)((VCSbxDialog*)pControl)->GetDrawObject();

		if( pDrawObject )
		{
			VCDrawModel* pModel = (VCDrawModel*)pDrawObject->GetModel();
			// das DrawModel des Dialog-Editors hat keine ObjectShell
			// wir muessen dann ueber das Basic gehen. (BugId 46352)
			if( pModel && pModel->GetObjectShell() )
			{
				aReferer = pModel->GetObjectShell()->GetMedium()->GetName();
				return aReferer;
			}
		}

		// ohne Basic kein Referer
		SbxObject* pBasic = pControl;
		BOOL bBasFound = FALSE;
		while( (pBasic = pBasic->GetParent()) != NULL )
		{
			if( pBasic->ISA(StarBASIC) )
			{
				bBasFound = TRUE;
				break;
			}
		}
		if( !bBasFound )
		{
			if( pDrawObject )
			{
				SdrPage* pPage = pDrawObject->GetPage();
				if( pPage && (pPage->IsA( TYPE( VCDrawPage ) ) ) )
				{
					pApp->EnterBasicCall();
					((VCDrawPage*)pPage)->RequestBasic();
					pApp->LeaveBasicCall();
				}
				else
				{
					DBG_ERROR("Basic not found: Calling IsSecureURL with empty URL");
					return aReferer;
				}

			}
			else
			{
				DBG_ERROR("Basic not found: Calling IsSecureURL with empty URL");
				return aReferer;
			}
		}

		/*
		if( !bBasFound )
		{
			while( pControl && !pControl->ISA(StarBASIC) && pControl->GetParent())
			{
				pControl = pControl->GetParent();
			}
		}
		else
			pControl = pBasic;


		if( pControl )
		{
			SbxVariableRef xDocProp = pControl->Find( String( RTL_CONSTASCII_USTRINGPARAM( "ThisDocument" )), SbxCLASS_DONTCARE );
			if( xDocProp.Is() )
			{
				SbxObjectRef xDocObj = (SbxObject*)xDocProp->GetObject();
				if( xDocObj.Is() )
				{
					SfxObjectShellRef xDoc = (SfxObjectShell*)
								((SfxShellObject*)&xDocObj)->GetShell();
					if ( xDoc->HasName() )
						aReferer = xDoc->GetMedium()->GetName();
				}
			}
		}
		*/
		if( aReferer.Len() )
		{
			INetURLObject aURLObj;
			aURLObj.SetSmartURL( aReferer );
			aReferer = aURLObj.GetMainURL();
		}
	}
	return aReferer;
}

ErrCode VCControl::ExecuteHandler( USHORT nHandlerId )
{
	const SvxMacro* pMacro = GetSvxMacro( nHandlerId );
	if( !pMacro )
		return 0;

	String aReferer = GetReferer( pSbxControl );

	ErrCode eErr = 0;

	if( pSbxControl->GetParent() && pMacro->GetMacName().Len() )
	{
		SfxApplication* pApp = SFX_APP();
		if ( aReferer.Len() && !pApp->IsSecureURL( INetURLObject( pMacro->GetMacName() ), &aReferer ) )
		{
			ErrorHandler::HandleError( ERRCODE_IO_ACCESSDENIED );
			return ERRCODE_IO_ACCESSDENIED;
		}
		SbxArray* pParams = CreateSbxParams( nHandlerId );
		short nOldFlags = pSbxControl->GetParent()->GetFlags();
		pSbxControl->GetParent()->SetFlag( SBX_EXTSEARCH );
		pSbxControl->Call( pMacro->GetMacName(), pParams );
		if( SiDLL::IsCurControlDeleted() )
			return 0;
		pSbxControl->GetParent()->SetFlags( nOldFlags );
		eErr = 0;
	}
	return eErr;
}

void VCControl::BasicAction()
{
	ExecuteHandler( VCHDL_ONACTION );
}

void VCControl::Click()
{
	// pImpCtrl->GetActMouseEvent() ist 0, wenn Click per Hand aufgerufen wird
	if( Type() == TYPE(VCPushButton) && pImpCtrl->GetActMouseEvent())
	{
		::pCurMouseEvent = new MouseEvent( *pImpCtrl->GetActMouseEvent() );
		Application::PostUserEvent(LINK(this,VCControl,VCUserEvent),(void*)0);
		return;
	}

	if( Type() == TYPE( VCRadioButton ) )
	{
		// Die anderen in der Gruppe zuruecksetzen
		if( pParent )
			pParent->UncheckRadios( (VCRadioButton*)this );
	}
	//DBG_ASSERT(SiDLL::GetCurControl()==this,"Current control not registered");
	ExecuteHandler( VCHDL_ONCLICK );
	//if( SiDLL::IsCurControlDeleted() )
	//	return;

	if( Type() == TYPE( VCPushButton ) )
	{
		((VCPushButton*)this)->FormAction();
	}
}

void VCControl::DblClick()
{
	ExecuteHandler( VCHDL_ONDBLCLICK );
}

void VCControl::GotFocus()
{
	ExecuteHandler( VCHDL_ONGETFOCUS );
}

void VCControl::LostFocus()
{
	// Bei JavaScript wird zusaetzlich ein ONCHANGE ausgeloest, wenn es
	// sich um ein Edit-Control handelt, das modifiziert ist.
	if( ISA(VCEdit) )
	{
		VCEdit* pThisEdit = (VCEdit*)this;
		if( pThisEdit->IsModified() )
		{
			// JavaScript-ONCHANGE?
			const SvxMacro* pMacro = GetSvxMacro( VCHDL_ONCHANGE );
			if( pMacro && pMacro->GetScriptType() == JAVASCRIPT )
			{
				// ONCHANGE-Handler rufen und Modify-Flag loeschen
				ExecuteHandler( VCHDL_ONCHANGE );
				pThisEdit->SetModifyFlag( FALSE );
			}
		}
	}

	// ONLOSEFOCUS immer ausloesen
	ExecuteHandler( VCHDL_ONLOSEFOCUS );
}

void VCControl::KeyDown()
{
	ExecuteHandler( VCHDL_ONKEYDOWN );
}

void VCControl::KeyPress()
{
	ExecuteHandler( VCHDL_ONKEYINPUT );
}

void VCControl::KeyUp()
{
	ExecuteHandler( VCHDL_ONKEYUP );
}

void VCControl::MouseDown()
{
	ExecuteHandler( VCHDL_ONMOUSEDOWN );
}

void VCControl::MouseMove()
{
	ExecuteHandler( VCHDL_ONMOUSEMOVE );
}

void VCControl::MouseUp()
{
	ExecuteHandler( VCHDL_ONMOUSEUP );
}

SvStream& operator<<(SvStream& rOut, const VCControl& rCtrl)
{
	SfxItemSet* pItemSet = rCtrl.GetItemSet();
	SfxItemPool* pPool = pItemSet->GetPool();
	if( rOut.GetVersion() == SOFFICE_FILEFORMAT_31 )
		pPool->SetStoringRange( VCATTR_URL, VCATTR_EVENTEND );
	pItemSet->Store( rOut );
	pPool->SetStoringRange( pPool->GetFirstWhich(), pPool->GetLastWhich() );
	return rOut;
}

SvStream& operator>>(SvStream& rIn, VCControl& rCtrl)
{
	SfxItemSet* pSet = rCtrl.GetItemSet()->Clone( FALSE, rCtrl.GetPool() );
	pSet->Load( rIn );
	VCControl::SetNewHandlers( pSet, rCtrl.Type(), rCtrl.IsReal() );
	if( pSet->GetItemState( VCATTR_FORMNAME ) != SFX_ITEM_UNKNOWN )
	{
		SfxStringItem aFrmNameItem = (const SfxStringItem&)(pSet->Get(VCATTR_FORMNAME));
		String aStr = aFrmNameItem.GetValue();
		if( aStr.Len() == 0 )
		{
			aStr = String( SiResId(STR_STDFORM) );
			aFrmNameItem.SetValue( aStr );
			pSet->Put( aFrmNameItem );
		}
	}
	rCtrl.SetItemSet( pSet );
	rCtrl.SaveResetValue();
	return rIn;
}

TYPEINIT1( VCButton, VCControl );

VCButton::VCButton( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
	VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
}

VCButton::~VCButton()
{
}

void VCButton::SetText( const String& rText )
{
	SetCaption( rText );
}

String VCButton::GetText() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_CAPTION )).GetValue();
}

TYPEINIT1( VCPushButton, VCButton );

void VCPushButton::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealPushButton( this );
}

VCPushButton::VCPushButton( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCButton( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_FONTUNDERLINE,
								   VCATTR_CAPTION, VCATTR_CAPTION,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_DEFAULT, VCATTR_CANCEL,
								   VCATTR_CLICK, VCATTR_MOUSEUP,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );
	Create();
	if( pParent )
		pParent->InsertChild( this );
	UpdateOutRect();
}

VCPushButton::~VCPushButton()
{
}

String VCPushButton::GetClassName() const
{
	return String( SiResId( STR_CLASS_PUSHBUTTON ) );
}

String VCPushButton::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_PUSHBUTTONS ) );
}

Size VCPushButton::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

void VCPushButton::SetFormAction( USHORT nAction )
{
	VCFormActionItem aItem( VCATTR_FORMACTION, nAction );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_FORMACTION );
	SiDLL::UpdateBrowserItem( VCATTR_FORMACTION );
}

USHORT VCPushButton::GetFormAction() const
{
	return ((VCFormActionItem&)pItemSet->Get( VCATTR_FORMACTION )).GetValue();
}

void VCPushButton::PurgeGraphic()
{
}

void VCPushButton::SetValue( const String& rValue )
{
	SetText( rValue );
}

String VCPushButton::GetValue() const
{
	return GetText();
}

TYPEINIT1( VCRadioButton, VCButton );

void VCRadioButton::Reset()
{
	Check( GetDefaultChecked() );
}

void VCRadioButton::SaveResetValue()
{
	SetDefaultChecked( IsChecked() );
}

void VCRadioButton::SetDefaultChecked( BOOL b)
{
	SfxBoolItem aItem( VCATTR_DEFAULTCHECKED, b );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_DEFAULTCHECKED );
	SiDLL::UpdateBrowserItem( VCATTR_DEFAULTCHECKED );
}

BOOL VCRadioButton::GetDefaultChecked() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_DEFAULTCHECKED )).GetValue();
}

void VCRadioButton::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealRadioButton( this );
}

VCRadioButton::VCRadioButton( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCButton( pParent, pPool, bReal, _pCtrl ),
	pRadioMgr( 0 )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_CAPTION,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_RADIOBUTTONVALUE, VCATTR_RADIOBUTTONVALUE,
								   VCATTR_CLICK, VCATTR_MOUSEUP,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCRadioButton::~VCRadioButton()
{
	if( pRadioMgr )
	{
		pRadioMgr->Remove( this );
		if( !pRadioMgr->GetLength() )
			delete pRadioMgr;
	}
}

String VCRadioButton::GetClassName() const
{
	return String( SiResId( STR_CLASS_RADIOBUTTON ) );
}

String VCRadioButton::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_RADIOBUTTONS ) );
}

BOOL VCRadioButton::IsChecked() const
{
	String aLinkName = ((SfxStringItem&)pItemSet->
						Get( VCATTR_LINK )).GetValue();
	if( aLinkName.Len() )
	{
		String aLinkData = ((VCRadioButton*)this)->GetLinkData( aLinkName );
		if( (aLinkData.CompareIgnoreCaseToAscii( "TRUE" ) == COMPARE_EQUAL) ||
			(aLinkData.ToInt32() != 0L) )
			return TRUE;
		else
			return FALSE;
	}
	else
		return ((SfxBoolItem&)pItemSet->Get( VCATTR_RADIOBUTTONVALUE )).GetValue();
}

void VCRadioButton::Check( BOOL bCheck )
{
	if( bCheck != IsChecked() )
	{
		SfxBoolItem aCheck( VCATTR_RADIOBUTTONVALUE, bCheck );
		pItemSet->Put( aCheck );

		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() )
			SetLinkData( aLinkName, bCheck ?
						 String( RTL_CONSTASCII_USTRINGPARAM( "TRUE" )) :
						 String( RTL_CONSTASCII_USTRINGPARAM( "FALSE" )));

		if( pImpCtrl && pParent )
			pImpCtrl->UpdateValue();

		if( aCheck.GetValue() && pParent )
			pParent->UncheckRadios( this );
	}
}

Size VCRadioButton::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

void VCRadioButton::SetName( const String& rName )
{
	String aOldName( GetName());
	VCControl::SetName( rName );
	if( aOldName != rName )
	{
		if( pRadioMgr )
		{
			pRadioMgr->Remove( this );
			if( !pRadioMgr->GetLength())
				 delete pRadioMgr;
			pRadioMgr = 0;
		}
		if( rName.Len())
		{
			GetRadioManager();
			pRadioMgr->Add( this );
		}
	}
}

void VCRadioButton::FindRadioManager()
{
	String aMyName( GetName() );
	ULONG nCount = pParent->GetChildCount();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
	{
		VCControl* pCtrl = pParent->GetChildByPos( nCur );
		if(pCtrl != this && pCtrl->IsA(TYPE(VCRadioButton)) && pCtrl->GetName()==aMyName)
		{
			// nicht GetRadioManager wegen moeglicher Endlosschleife
			pRadioMgr = ((VCRadioButton*)pCtrl)->pRadioMgr;
			DBG_ASSERT(pRadioMgr,"RadioManager not set");
			return;
		}
	}
	pRadioMgr = new VCRadioManager();
}

void VCRadioButton::SetValue( const String& rValue )
{
	SetTag( rValue );
}

String VCRadioButton::GetValue() const
{
	String aValue( GetTag() );
	if( !aValue.Len() )
		aValue = GetCaption();
	return aValue;
}

VCRadioManager::VCRadioManager()
{
	pVCRadioButtons = new SvPtrarr;
	//pJavaWrapper = 0;
}

VCRadioManager::~VCRadioManager()
{
	DBG_ASSERT(pVCRadioButtons->Count()==0,"RadioManager not empty");
#ifdef DBG_UTIL
	DELETEZ(pVCRadioButtons);
#else
	delete pVCRadioButtons;
#endif
}

USHORT VCRadioManager::GetLength() const
{
	return pVCRadioButtons->Count();
}

VCRadioButton* VCRadioManager::GetElement( USHORT nIndex ) const
{
	return (VCRadioButton*)pVCRadioButtons->GetObject( nIndex );
}

void VCRadioManager::Add( VCRadioButton* pButton )
{
	DBG_ASSERT(pVCRadioButtons->GetPos(pButton)==0xffff,"RadioMgr: Already in List");
	pVCRadioButtons->Insert( pButton, pVCRadioButtons->Count());
}

void VCRadioManager::Remove( VCRadioButton* pButton )
{
	USHORT nPos = pVCRadioButtons->GetPos(pButton);
	DBG_ASSERT(nPos!=0xffff,"RadioMgr: Not in List");
	pVCRadioButtons->Remove( nPos );
}

TYPEINIT1( VCCheckBox, VCButton );

void VCCheckBox::Reset()
{
	Check( GetDefaultChecked() );
}

void VCCheckBox::SaveResetValue()
{
	SetDefaultChecked( IsChecked() );
}

void VCCheckBox::SetDefaultChecked( BOOL b)
{
	SfxBoolItem aItem( VCATTR_DEFAULTCHECKED, b );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_DEFAULTCHECKED );
	SiDLL::UpdateBrowserItem( VCATTR_DEFAULTCHECKED );
	Check( b );
}

BOOL VCCheckBox::GetDefaultChecked() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_DEFAULTCHECKED )).GetValue();
}

void VCCheckBox::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealCheckBox( this );
}

VCCheckBox::VCCheckBox( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCButton( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_CAPTION,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_CHECKBOXVALUE, VCATTR_CHECKBOXVALUE,
								   VCATTR_CLICK, VCATTR_MOUSEUP,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCCheckBox::~VCCheckBox()
{
}

String VCCheckBox::GetClassName() const
{
	return String( SiResId( STR_CLASS_CHECKBOX ) );
}

String VCCheckBox::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_CHECKBOXES ) );
}

Size VCCheckBox::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

void VCCheckBox::SetValue( const String& rValue )
{
	SetTag( rValue );
}

String VCCheckBox::GetValue() const
{
	String aValue( GetTag() );
	if( !aValue.Len() )
		aValue = GetCaption();
	return aValue;
}

TYPEINIT1( VCURLButton, VCButton );

void VCURLButton::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealPushButton( this );
}

VCURLButton::VCURLButton( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCButton( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_TARGETFRAME, VCATTR_TARGETFRAME,
								   VCATTR_URL, VCATTR_URL,
								   VCATTR_NAME, VCATTR_FONTUNDERLINE,
								   VCATTR_CAPTION, VCATTR_CAPTION,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   NULL );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCURLButton::~VCURLButton()
{
}

String VCURLButton::GetClassName() const
{
	return String( SiResId( STR_CLASS_URLBUTTON ) );
}

String VCURLButton::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_URLBUTTONS ) );
}

// wird von Dok-URL-Button gerufen
void VCURLButton::Click()
{
	BOOL bLinkCalled = FALSE;
	if( pDrawObject )
	{
		VCDrawModel* pModel = (VCDrawModel*)pDrawObject->GetModel();
		const Link& rLink = pModel->GetURLHdl();
		if( rLink.IsSet())
		{
			pActMouseEvent = pImpCtrl->GetActMouseEvent();
			rLink.Call( this );
			pActMouseEvent = 0;
			bLinkCalled = TRUE;
		}
	}
	if( !bLinkCalled )
	{
#ifndef SVX_LIGHT
		BOOL bShift;
		BOOL bCtrl;

		DBG_ASSERT(pImpCtrl,"ImpControl not set");
		if( pImpCtrl->GetActMouseEvent() )
		{
			bShift = pImpCtrl->GetActMouseEvent()->IsShift();
			bCtrl = pImpCtrl->GetActMouseEvent()->IsMod1();
		}
		else
		{
			bShift = FALSE;
			bCtrl = FALSE;
		}

		SfxStringItem aURL( SID_FILE_NAME, GetURL() );
		SfxFrameItem aFrm( SID_DOCFRAME, SfxViewFrame::Current() );
		const SfxStringItem& rTarget=(const SfxStringItem&)
			(pItemSet->Get(VCATTR_TARGETFRAME));
		SfxStringItem aTarget( SID_TARGETNAME, rTarget.GetValue() );
		const SfxFilter* pFilter = SfxExecutableFilterContainer::GetDownloadFilter();
		SfxStringItem aFilterItem( SID_FILTER_NAME, pFilter->GetName() );
		SfxViewFrame* pCurFrame = SfxViewFrame::Current();
		DBG_ASSERT( pCurFrame != NULL, "No current view frame!" );
		SfxDispatcher* pDispatcher = pCurFrame ? pCurFrame->GetDispatcher() : NULL;
		if( !bCtrl )
		{
			if( pDispatcher )
			{
				pDispatcher->Execute( SID_OPENURL,
					SFX_CALLMODE_ASYNCHRON,
					&aURL, &aFrm,
					&aTarget,
					bShift ? &aFilterItem : 0L,
					0L );
			}
		}
		else
		{
			if( pDispatcher )
			{
				pDispatcher->Execute( SID_OPENURL,
					SFX_CALLMODE_ASYNCHRON,
					&aURL, bShift ? &aFilterItem : 0L,
					0L );
			}
		}
#endif
	}
}

String VCURLButton::GetURL() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_URL )).GetValue();
}

void VCURLButton::SetURL( const String& rURL )
{
	VCURLItem aItem( VCATTR_URL, rURL );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_URL );
	SiDLL::UpdateBrowserItem( VCATTR_URL );
}

Size VCURLButton::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

void VCControl::SetFont( const Font& rFont )
{
	DBG_ASSERT(pItemSet,"No ItemSet");

	if( pItemSet->GetItemState( VCATTR_FONTNAME ) != SFX_ITEM_UNKNOWN )
	{
		// wer einen Fontnamen hat, hat auch die anderen Properties
		SfxStringItem aNameItem( VCATTR_FONTNAME, rFont.GetName() );
		SfxInt32Item  aSizeItem( VCATTR_FONTSIZE, rFont.GetSize().Height() );
		SfxBoolItem   aBoldItem( VCATTR_FONTBOLD );
		SfxBoolItem   aItalicItem( VCATTR_FONTITALIC );
		SfxBoolItem   aUnderlineItem( VCATTR_FONTUNDERLINE );
		SfxBoolItem   aStrikeoutItem( VCATTR_FONTSTRIKETHRU );

		if( rFont.GetWeight() > WEIGHT_NORMAL )
			aBoldItem.SetValue( TRUE );
		if( rFont.GetItalic() != ITALIC_NONE )
			aItalicItem.SetValue( TRUE );
		if( rFont.GetUnderline() != UNDERLINE_NONE )
			aUnderlineItem.SetValue( TRUE );
		if( rFont.GetStrikeout() != STRIKEOUT_NONE )
			aStrikeoutItem.SetValue( TRUE );

		pItemSet->Put( aNameItem );
		pItemSet->Put( aSizeItem );
		pItemSet->Put( aBoldItem );
		pItemSet->Put( aItalicItem );
		pItemSet->Put( aUnderlineItem );
		pItemSet->Put( aStrikeoutItem );

		// alles Updaten
		UpdateItem( 0 );
		SiDLL::UpdateBrowserItem( VCATTR_FONTNAME );
		SiDLL::UpdateBrowserItem( VCATTR_FONTSIZE );
		SiDLL::UpdateBrowserItem( VCATTR_FONTBOLD );
		SiDLL::UpdateBrowserItem( VCATTR_FONTITALIC );
		SiDLL::UpdateBrowserItem( VCATTR_FONTUNDERLINE );
		SiDLL::UpdateBrowserItem( VCATTR_FONTSTRIKETHRU );
	}
}

Font VCControl::GetFont() const
{
	//HACK   RAUSKOPIERT AUS VCBRW.CXX
	Font         aFont;

	if( !pItemSet )
		return aFont;

	String aName      = ((SfxStringItem&)pItemSet->Get( VCATTR_FONTNAME )).GetValue();
	long   nSize      = ((SfxInt32Item&)pItemSet->Get( VCATTR_FONTSIZE )).GetValue();
	BOOL   bBold      = ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTBOLD )).GetValue();
	BOOL   bItalic    = ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTITALIC )).GetValue();
	BOOL   bUnderLine = ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTUNDERLINE )).GetValue();
	BOOL   bStrikeout = ((SfxBoolItem&)pItemSet->Get( VCATTR_FONTSTRIKETHRU )).GetValue();

	aFont.SetName( aName );
	aFont.SetSize( Size( 0, nSize*10 ) );
	if( bBold )
		aFont.SetWeight( WEIGHT_BOLD );
	if( bItalic )
		aFont.SetItalic( ITALIC_NORMAL );
	if( bUnderLine )
		aFont.SetUnderline( UNDERLINE_SINGLE );
	if( bStrikeout )
		aFont.SetStrikeout( STRIKEOUT_SINGLE );

	return aFont;
}

void VCControl::SetForeColor( const Color& rColor )
{
	if( pItemSet->GetItemState( VCATTR_FORECOLOR ) != SFX_ITEM_UNKNOWN )
	{
		SvxColorItem aCol( rColor, VCATTR_FORECOLOR );
		pItemSet->Put( aCol );
		UpdateItem( VCATTR_FORECOLOR );
		SiDLL::UpdateBrowserItem( VCATTR_FORECOLOR );
	}
}

Color VCControl::GetForeColor() const
{
	Color aCol(((SvxColorItem&)pItemSet->Get( VCATTR_FORECOLOR )).GetValue());
	return aCol;
}

void VCControl::SetBackColor( const Color& rColor )
{
	if( pItemSet->GetItemState( VCATTR_BACKCOLOR ) != SFX_ITEM_UNKNOWN )
	{
		SvxColorItem aCol( rColor,VCATTR_BACKCOLOR  );
		pItemSet->Put( aCol );
		UpdateItem( VCATTR_BACKCOLOR );
		SiDLL::UpdateBrowserItem( VCATTR_BACKCOLOR );
	}
}

Color VCControl::GetBackColor() const
{
	Color aCol(((SvxColorItem&)pItemSet->Get( VCATTR_BACKCOLOR )).GetValue());
	return aCol;
}

void VCControl::SetVCForm( VCForm* pNewForm )
{
}

VCForm* VCControl::GetVCForm() const
{
	return 0;
}

void VCPushButton::FormAction()
{
}

void VCControl::Reset()
{
}

void VCControl::SaveResetValue()
{
}

void VCControl::SetHandler( USHORT nId, const String& rMacro )
{
	SvxMacro aMacro( rMacro, String(), JAVASCRIPT );
	SetHandler( nId, aMacro );
}

void VCControl::SetHandlers( const SvxMacroTableDtor& rMacros )
{
	if( pItemSet && pItemSet->GetItemState(VCATTR_MACROS) != SFX_ITEM_UNKNOWN)
	{
		SvxMacroItem aItem( VCATTR_MACROS );
		aItem.SetMacroTable( rMacros );
		pItemSet->Put( aItem );
	}
}

const SvxMacroTableDtor& VCControl::GetHandlers() const
{
	DBG_ASSERT(pItemSet,"ItemSet not set");
	const SvxMacroItem& rItm = (const SvxMacroItem&)(pItemSet->Get(VCATTR_MACROS));
	return rItm.GetMacroTable();
}

String VCControl::GetHandler( USHORT nId ) const
{
	String aResult;
	if( pItemSet && pItemSet->GetItemState(VCATTR_MACROS) != SFX_ITEM_UNKNOWN)
	{
		const SvxMacroItem& rItm = (const SvxMacroItem&)(pItemSet->Get(VCATTR_MACROS));
		if( rItm.HasMacro( nId ) )
		{
			const SvxMacro& rMacro = rItm.GetMacro( nId );
			aResult = rMacro.GetMacName();
		}
	}
	return aResult;
}

void VCControl::SetHandler( USHORT nId, const SvxMacro& rMacro)
{
	if( pItemSet && pItemSet->GetItemState(VCATTR_MACROS) != SFX_ITEM_UNKNOWN)
	{
		SvxMacroItem aItem( VCATTR_MACROS );
		aItem.SetMacroTable( ((const SvxMacroItem&)pItemSet->Get( VCATTR_MACROS)).GetMacroTable() );
		aItem.SetMacro( nId, rMacro );
		pItemSet->Put( aItem );
	}
}

const SvxMacro* VCControl::GetSvxMacro( USHORT nId ) const
{
	if( pItemSet && pItemSet->GetItemState(VCATTR_MACROS) != SFX_ITEM_UNKNOWN)
	{
		const SvxMacroItem& rItm = (const SvxMacroItem&)(pItemSet->Get(VCATTR_MACROS));
		if( rItm.HasMacro( nId ) )
			return &rItm.GetMacro( nId );
	}
	return 0;
}

void VCPushButton::SetImageURL_Impl( const String& rURL, BOOL bAsync )
{
	VCURLItem aItem( VCATTR_IMAGEURL, rURL );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_IMAGEURL );
	SiDLL::UpdateBrowserItem( VCATTR_IMAGEURL );
}

void VCPushButton::SetImageURL( const String& rURL )
{
	SetImageURL_Impl( rURL, TRUE );
}

void VCPushButton::SetImageURL( const String& rURL, BOOL bAsync )
{
	SetImageURL_Impl( rURL, bAsync );
}

String VCPushButton::GetImageURL() const
{
	return ((VCURLItem&)pItemSet->Get( VCATTR_IMAGEURL )).GetValue();
}

void VCControl::SetPrintable( BOOL bPrintable )
{
	SfxBoolItem aItem( VCATTR_PRINT, bPrintable );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_PRINT );
	SiDLL::UpdateBrowserItem( VCATTR_PRINT );
}

BOOL VCControl::IsPrintable() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_PRINT )).GetValue();
}

void VCURLButton::SetTargetFrame( const String&  rTarget)
{
	SfxStringItem aItem( VCATTR_TARGETFRAME, rTarget );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_TARGETFRAME );
	SiDLL::UpdateBrowserItem( VCATTR_TARGETFRAME );
}

const String& VCURLButton::GetTargetFrame() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_TARGETFRAME )).GetValue();
}

void VCFixedText::SetBackStyle( USHORT nStyle )
{
	VCBackStyleItem aItem( VCATTR_BACKSTYLE, nStyle );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_BACKSTYLE );
	SiDLL::UpdateBrowserItem( VCATTR_BACKSTYLE );
}

USHORT VCFixedText::GetBackStyle() const
{
	return ((VCBackStyleItem&)pItemSet->Get( VCATTR_BACKSTYLE )).GetValue();
}

void VCFixedText::SetValue( const String& rValue )
{
	SetCaption( rValue );
}

String VCFixedText::GetValue() const
{
	return GetCaption();
}

void VCPushButton::ClickButton()
{
	Click();
}

void VCControl::Modified()
{
	// In JavaScript wird ein ONCHANGE bei einem Edit-Control nur im Zusammenhang mit einem
	// ONLOSEFOCUS ausgeloest,
	if( ISA(VCEdit) )
	{
		const SvxMacro* pMacro = GetSvxMacro( VCHDL_ONCHANGE );
		if( pMacro && pMacro->GetScriptType() == JAVASCRIPT )
		{
			// kein ONCHANGE-Handler rufen, aber Modify-Flag setzen
			((VCEdit*)this)->SetModifyFlag( TRUE );
			return;
		}
	}

	// Event ausloesen
	ExecuteHandler( VCHDL_ONCHANGE );
}

void VCControl::Selected()
{
	ExecuteHandler( VCHDL_ONSELECT );
}

static const USHORT pId2WhichMap[ VCHDL_END-VCHDL_START+1] = {
	0,
	VCATTR_ONACTION, 		// #define VCHDL_ONACTION      1
	VCATTR_CHANGED, 		// #define VCHDL_ONCHANGE      2
	VCATTR_CLICK, 			// #define VCHDL_ONCLICK       3
	VCATTR_ONSELECT, 		// #define VCHDL_ONSELECT      4
	VCATTR_MOUSEMOVE, 		// #define VCHDL_ONMOUSEMOVE   5
	VCATTR_GOTFOCUS, 		// #define VCHDL_ONGETFOCUS    6
	VCATTR_LOSTFOCUS, 		// #define VCHDL_ONLOSEFOCUS   7
	VCATTR_DBLCLICK, 		// #define VCHDL_ONDBLCLICK    8
	VCATTR_KEYPRESS, 		// #define VCHDL_ONKEYINPUT    9
	VCATTR_KEYUP, 			// #define VCHDL_ONKEYUP		10
	VCATTR_KEYDOWN, 		// #define VCHDL_ONKEYDOWN		11
	VCATTR_MOUSEUP, 		// #define VCHDL_ONMOUSEUP		12
	VCATTR_MOUSEDOWN, 		// #define VCHDL_ONMOUSEDOWN	13
	VCATTR_SPINUP, 			// #define VCHDL_ONSPINUP		14
	VCATTR_SPINDOWN, 		// #define VCHDL_ONSPINDOWN	15
	VCATTR_SCROLL, 			// #define VCHDL_ONSCROLL		16
	VCATTR_PAINT, 			// #define VCHDL_ONPAINT		17
	VCATTR_RESIZE, 			// #define VCHDL_ONRESIZE		18
	VCATTR_ACTIVATE,
	VCATTR_DEACTIVATE,
	0,0,                     // VCHDL_ONSUBMITFORM, VCHDL_ONRESETFORM
	0,0
};

BOOL lcl_IsMacroSet( USHORT nEvent, const SvxMacroItem& rItem )
{
	if( rItem.HasMacro( nEvent ) )
	{
		if( rItem.GetMacro( nEvent ).GetMacName().Len())
			return TRUE;
	}
	return FALSE;
}

// SfxStringItems => SvxMacroItem
void VCControl::SetNewHandlers( SfxItemSet* pItemSet, const TypeId& rType,
	BOOL bReal )
{
	if( pItemSet->GetItemState( VCATTR_MACROS ) == SFX_ITEM_UNKNOWN )
		return;

	// Umstaendlich, weil das MacroItem keinen Copy-Ctor hat
	SvxMacroItem aItem( VCATTR_MACROS );
	aItem.SetMacroTable( ((const SvxMacroItem&)pItemSet->Get( VCATTR_MACROS)).GetMacroTable() );
	BOOL bChanged = FALSE;
	for( USHORT nHdl = VCHDL_START; nHdl <= VCHDL_END; nHdl++ )
	{
		USHORT nWhich;
		if( nHdl == VCHDL_ONSELECT )
		{
			if( rType == TYPE(VCListBox) )
				nWhich = VCATTR_ONCLICK; //VCATTR_ONCLICK=>VCHDL_ONSELECT
			else if( rType == TYPE(VCComboBox) )
				nWhich = VCATTR_CHANGED;
			else
				nWhich = pId2WhichMap[ nHdl ];
		}
		else
			nWhich = pId2WhichMap[ nHdl ];

		BOOL bSet = ( nWhich && pItemSet->GetItemState( nWhich ) != SFX_ITEM_UNKNOWN );
		if( !bSet && nWhich == VCATTR_ONCLICK )
		{
			//#38607#
			nWhich = VCATTR_CLICK;
			bSet = ( pItemSet->GetItemState(VCATTR_CLICK) != SFX_ITEM_UNKNOWN );
		}
		if( bSet )
		{
			if( !lcl_IsMacroSet( nHdl, aItem ))
			{
				const SfxStringItem& rItm = (const SfxStringItem&)pItemSet->Get(nWhich);
				if( rItm.GetValue().Len() )
				{
					SvxMacro aMacro( rItm.GetValue(), String(), STARBASIC );
					aItem.SetMacro( nHdl, aMacro );
					bChanged = TRUE;
				}
			}
		}
	}
	if( bChanged )
		pItemSet->Put( aItem, VCATTR_MACROS );

}

// SvxMacroItem => SfxStringItems
void VCControl::SetOldHandlers( SfxItemSet* pItemSet, const TypeId& rType,
	BOOL bReal )
{
	if( pItemSet->GetItemState( VCATTR_MACROS ) == SFX_ITEM_UNKNOWN )
		return;

	const SvxMacroItem& rItem =(const SvxMacroItem&)pItemSet->Get( VCATTR_MACROS);
	for( USHORT nHdl = VCHDL_START; nHdl <= VCHDL_END; nHdl++ )
	{
		USHORT nWhich = pId2WhichMap[ nHdl ];

		if( pItemSet->GetItemState(nWhich) != SFX_ITEM_UNKNOWN )
		{
			String aMacro;
			if( nWhich && rItem.HasMacro(nHdl) )
			{
				const SvxMacro& rMacro = rItem.GetMacro( nHdl );
				if( rMacro.GetScriptType()  == STARBASIC )
					aMacro = rMacro.GetMacName();
			}
			pItemSet->Put( SfxStringItem( nWhich, aMacro ));
		}
	}
}

void VCControl::SetValue( const String& )
{
}

String VCControl::GetValue() const
{
	String aStr;
	return aStr;
}

IMPL_LINK(VCControl, VCUserEvent, void*, pArg)
{
	SiDLL::SetCurControl( this );
	pImpCtrl->SetActMouseEvent( ::pCurMouseEvent );
	ExecuteHandler( VCHDL_ONCLICK );
	if( SiDLL::IsCurControlDeleted() )
	{
		DELETEZ(::pCurMouseEvent);
		return 0;
	}
	((VCPushButton*)this)->FormAction();
	DELETEZ(::pCurMouseEvent);
	return 0;
}


