/*************************************************************************
 *
 *  $RCSfile: vctrls2.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _POINTR_HXX
#include <vcl/pointr.hxx>
#endif
#include <sfx2/objsh.hxx>

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#pragma hdrstop

#include "vcspnbtn.hxx"
#include "vcfxtxt.hxx"
#include "vcscrbar.hxx"
#include "vccbbox.hxx"
#include "vclbox.hxx"
#include "vcprvw.hxx"
#include "vcchkbox.hxx"
#include "vcedit.hxx"
#include "vcgrpbox.hxx"
#include "vcmselit.hxx"
#include "vcinliit.hxx"
#include "vccbstit.hxx"
#include "vcwwit.hxx"
#define _SI_VCITEMS
#include "vcattr.hxx"
#include "vctrls.hxx"
#include "vcattrid.hrc"
#include "vcictrls.hxx"
#include "vcont.hxx"
#include "vcdrwobj.hxx"
#include "vctrls.hrc"
#include "siresid.hxx"
#include "sidll.hxx"
#include "vcform.hxx"

BOOL VCCheckBox::IsChecked() const
{
	String aLinkName = ((SfxStringItem&)pItemSet->
						Get( VCATTR_LINK )).GetValue();

	if( aLinkName.Len() )
	{
		String aLinkData = ((VCCheckBox*)this)->GetLinkData( aLinkName );
		if( (aLinkData.CompareIgnoreCaseToAscii( "TRUE" ) == COMPARE_EQUAL) ||
			(aLinkData.ToInt32() != 0L)  )
			return TRUE;
		else
			return FALSE;
	}
	else
		return ((SfxBoolItem&)pItemSet->Get( VCATTR_CHECKBOXVALUE )).GetValue();
}

void VCCheckBox::Check( BOOL bCheck )
{
	if( bCheck != IsChecked() )
	{
		SfxBoolItem aCheck( VCATTR_CHECKBOXVALUE, bCheck );
		pItemSet->Put( aCheck );

		String aLinkName = ((SfxStringItem&)pItemSet->Get( VCATTR_LINK )).GetValue();
		if( aLinkName.Len() )
			SetLinkData( aLinkName, bCheck ?
						 String( RTL_CONSTASCII_USTRINGPARAM( "TRUE" )) :
						 String( RTL_CONSTASCII_USTRINGPARAM( "FALSE" )));

		if( pImpCtrl && pParent )
			pImpCtrl->Update();
	}
}

TYPEINIT1( VCSpinButton, VCButton );

void VCSpinButton::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealSpinButton( this );
}

VCSpinButton::VCSpinButton( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCButton( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_HEIGHT,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_CHANGE, VCATTR_CHANGE,
								   VCATTR_SPINBUTTONVALUE, VCATTR_SPINBUTTONVALUE,
								   VCATTR_MIN, VCATTR_MAX,
								   VCATTR_GOTFOCUS, VCATTR_KEYUP,
								   VCATTR_SPINUP, VCATTR_SPINDOWN,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );
	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCSpinButton::~VCSpinButton()
{
}

String VCSpinButton::GetClassName() const
{
	return String( SiResId( STR_CLASS_SPINBUTTON ) );
}

String VCSpinButton::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_SPINBUTTONS ) );
}

void VCSpinButton::SpinnedUp()
{
	ExecuteHandler( VCHDL_ONSPINUP );
}

void VCSpinButton::SpinnedDown()
{
	ExecuteHandler( VCHDL_ONSPINDOWN );
}

#if SUPD > 364

ErrCode VCSpinButton::SpinnedUpWithErr()
{
	return ExecuteHandler( VCHDL_ONSPINUP );
}

ErrCode VCSpinButton::SpinnedDownWithErr()
{
	return ExecuteHandler( VCHDL_ONSPINDOWN );
}

#endif

TYPEINIT1( VCFixedText, VCControl );

void VCFixedText::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealFixedText( this );
}

VCFixedText::VCFixedText( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_TABINDEX,
								   VCATTR_BACKSTYLE, VCATTR_WORDWRAP,
								   VCATTR_ALIGNMENT, VCATTR_ALIGNMENT,
								   VCATTR_DBLCLICK, VCATTR_CLICK,

								   VCATTR_MOUSEDOWN, VCATTR_MOUSEUP,
								   NULL );
	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCFixedText::~VCFixedText()
{
}

String VCFixedText::GetClassName() const
{
	return String( SiResId( STR_CLASS_FIXEDTEXT ) );
}

String VCFixedText::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_FIXEDTEXTS ) );
}

Size VCFixedText::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

TYPEINIT1( VCGroupBox, VCControl );

void VCGroupBox::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealGroupBox( this );
}

VCGroupBox::VCGroupBox( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_NAME,
								   VCATTR_TAG, VCATTR_FONTUNDERLINE,
								   VCATTR_FORECOLOR, VCATTR_CAPTION,
								   VCATTR_TABINDEX, VCATTR_TABINDEX,
								   VCATTR_DBLCLICK, VCATTR_CLICK,
								   VCATTR_MOUSEDOWN, VCATTR_MOUSEUP,
#ifndef VCL
								   VCATTR_MACROS, VCATTR_MACROS,
#endif
								   NULL );
	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCGroupBox::~VCGroupBox()
{
}

String VCGroupBox::GetClassName() const
{
	return String( SiResId( STR_CLASS_GROUPBOX ) );
}

String VCGroupBox::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_GROUPBOXES ) );
}

BOOL VCGroupBox::IsActionHit( const Point& rPt, long nTol )
{
	if( !aOutRect.IsInside( rPt ) )
		return FALSE;

	Rectangle aRect = aOutRect;
	aRect.Left()  += nTol;
	aRect.Top()   += nTol;
	aRect.Right() -= nTol;
	aRect.Bottom()-= nTol;

	if( aRect.IsInside( rPt ) )
		return FALSE;
	else
		return TRUE;
}

void VCGroupBox::SetPos( const Point& rPos )
{
	VCControl::SetPos( rPos );

	// Alle bis auf ersten Radio in der Gruppe zuruecksetzen
	if( pParent )
		pParent->UncheckButFirstRadios( this );
}

void VCGroupBox::SetSize( const Size& rSize )
{
	VCControl::SetSize( rSize );

	// Alle bis auf ersten Radio in der Gruppe zuruecksetzen
	if( pParent )
		pParent->UncheckButFirstRadios( this );
}

void VCGroupBox::SetItemSet( SfxItemSet* pItemSet )
{
	VCControl::SetItemSet( pItemSet );

	// Alle bis auf ersten Radio in der Grupper zuruecksetzen
	if( pParent )
		pParent->UncheckButFirstRadios( this );
}

void VCGroupBox::UpdateItem( USHORT nWhich )
{
	VCControl::UpdateItem( nWhich );

	// Alle bis auf ersten Radio in der Grupper zuruecksetzen
	if( pParent )
		pParent->UncheckButFirstRadios( this );
}

TYPEINIT1( VCListBox, VCControl );

USHORT VCListBox::InitResetArr()
{
	USHORT nCount;
	if( !pResetSelectedEntries )
	{
		nCount = (USHORT)GetEntryCount() + 1;
		pResetSelectedEntries = new USHORT[ nCount ];
		memset( pResetSelectedEntries, 0, nCount*sizeof(USHORT) );
		pResetSelectedEntries[ nCount -1 ] = 0xffff;
	}
	else
	{
		nCount = 0;
		USHORT* pCur = pResetSelectedEntries;
		while( *pCur != 0xffff )
		{
			nCount++;
			pCur++;
		}
	}
	return nCount;
}

void VCListBox::Reset()
{
	ULONG nCount = GetEntryCount();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
		SelectEntryPos( nCur, FALSE );
	if( pResetSelectedEntries )
	{
		USHORT* pCur = pResetSelectedEntries;
		ULONG nCur = 0;
		while( *pCur != 0xffff )
		{
			if( *pCur )
				SelectEntryPos( nCur, TRUE );
			pCur++;
			nCur++;
		}
	}
}

void VCListBox::SaveResetValue()
{
	DELETEZ(pResetSelectedEntries);
	InitResetArr();
	pResetSelectedEntries = new USHORT[ GetEntryCount() + 1];
	USHORT* pCur = pResetSelectedEntries;
	ULONG nCount = GetEntryCount();
	for( ULONG nCur=0; nCur < nCount; nCur++, pCur++ )
	{
		if( IsEntrySelected( nCur ) )
			*pCur = 1;
		else
			*pCur = 0;
	}
	*pCur = 0xffff;
}

void VCListBox::SetDefaultChecked( USHORT nEntry, BOOL bChecked )
{
	USHORT nCount = InitResetArr();
	if( nCount > nEntry )
		pResetSelectedEntries[ nEntry ] = bChecked ? 1 : 0;
}

USHORT VCListBox::GetDefaultChecked() const
{
	return FALSE;
}

BOOL VCListBox::IsSorted() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_SORTED )).GetValue();
}

BOOL VCListBox::GetDefaultChecked( USHORT nEntry ) const
{
	USHORT nCount = ((VCListBox*)this)->InitResetArr();
	if( nCount > nEntry )
		return pResetSelectedEntries[ nEntry ] ? TRUE : FALSE;
	return FALSE;
}

ULONG VCListBox::GetSelectEntryCount() const
{
	ULONG nSelCount = 0;
	ULONG nCount = GetEntryCount();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
	{
		if( IsEntrySelected( nCur ) )
			nSelCount++;
	}
	return nSelCount;
}

void VCListBox::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealListBox( this );
}

VCListBox::VCListBox( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl ),
	pResetSelectedEntries(0),
	pOptionsArray(NULL)
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_FORECOLOR,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_MULTISELECT, VCATTR_SORTED,
								   VCATTR_DBLCLICK, VCATTR_MOUSEUP,
								   VCATTR_ONSELECT, VCATTR_ONSELECT,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	SfxStringListItem aStrList( VCATTR_LIST );
	pItemSet->Put( aStrList );
	Create();
	if( pParent )
		pParent->InsertChild( this );
	UpdateOutRect();
}

VCListBox::~VCListBox()
{
	delete pResetSelectedEntries;
	delete pOptionsArray;
}

// Neue Methode, um SetValue() fuer JavaScript bereit zu stellen
void VCListBox::SetItemData( const String& rStr, ULONG nPos ) const
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	delete (String*)(pList->Replace( pStr, nPos ));
	pItemSet->Put( *pItem );
	delete pItem;
}


void VCListBox::Focus()
{
	// koennen wir momentan mit ListBoxen nicht
}

void VCListBox::Blur()
{
	// koennen wir momentan mit ListBoxen nicht
}


void VCListBox::CreateOptionsArray()
{
	pOptionsArray = new SvPtrarr;

	// Objekte eintragen
	USHORT nCount = (USHORT)GetEntryCount();
	// mit Nullen aufplustern
	for( USHORT i = 0 ; i < nCount ; i++ )
		pOptionsArray->Insert( (void*)0, pOptionsArray->Count());
}

String VCListBox::GetClassName() const
{
	return String( SiResId( STR_CLASS_LISTBOX ) );
}

String VCListBox::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_LISTBOXES ) );
}

USHORT VCListBox::InsertEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();

	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	pList->Insert( pStr, nPos );

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
							pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	pItemData->SetEntryCount( (USHORT)pList->Count() );

	USHORT nNewIndex;

	pItemSet->Put( *pItem );
	delete pItem;
	pItemSet->Put( *pItemData );
	delete pItemData;

	nNewIndex = ((VCImpRealListBox*)pImpCtrl)->InsertEntry( rStr, nPos );
	return nNewIndex;
}

void VCListBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	delete (String*)(pList->Replace( pStr, nPos ));
	pItemSet->Put( *pItem );
	delete pItem;

	((VCImpRealListBox*)pImpCtrl)->ReplaceEntry( rStr, nPos );
}

void VCListBox::RemoveEntry( ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	delete (String*)(pList->Remove( nPos ));
	pItemSet->Put( *pItem );
	delete pItem;

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
								   pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	pItemData->SetEntryCount( (USHORT)pList->Count() );
	pItemSet->Put( *pItemData );
	delete pItemData;

	((VCImpRealListBox*)pImpCtrl)->RemoveEntry( nPos );
}

String VCListBox::GetEntry( ULONG nPos )
{
	SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );

	List* pList = rItem.GetList();
	String* pStr = (String*)(pList->GetObject( nPos ));
	if( pStr )
		return String( *pStr );
	return String();
}

String VCListBox::GetSelectEntry() const
{
	return ((VCImpRealListBox*)pImpCtrl)->GetSelectEntry();
}

ULONG VCListBox::GetSelectEntryPos() const
{
		return ((VCImpRealListBox*)pImpCtrl)->GetSelectEntryPos();
}

void VCListBox::SelectEntryPos( ULONG nPos, BOOL bSelect )
{
		((VCImpRealListBox*)pImpCtrl)->SelectEntryPos( nPos, bSelect );
}

BOOL VCListBox::IsEntrySelected( ULONG nPos ) const
{
		return ((VCImpRealListBox*)pImpCtrl)->IsEntrySelected( nPos );
}

void VCListBox::Clear()
{
	SfxStringListItem aItem( VCATTR_LIST );
	pItemSet->Put( aItem );

	VCIntegerListItem aItemData( VCATTR_ITEMDATA );
	pItemSet->Put( aItemData );

	if( pParent )
		((VCImpRealListBox*)pImpCtrl)->Update();
}

ULONG VCListBox::GetTopIndex() const
{
	return 0;
}

void VCListBox::SetTopIndex( ULONG nIndex )
{
}

USHORT VCListBox::GetMultiSelect() const
{
	return (USHORT)((VCMultiSelectItem&)pItemSet->
				Get( VCATTR_MULTISELECT )).GetValue();
}

ULONG VCListBox::GetEntryCount() const
{
	SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
	return rItem.GetList()->Count();
}

Size VCListBox::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

Size VCListBox::GetOptSize( const Size& rCharXY, OutputDevice* pOut) const
{
	Size aSize;
	return aSize;
}

USHORT VCListBox::GetLineCount( OutputDevice* pOut) const
{
	return 0;
}

void VCListBox::SetMultiSelect( USHORT eSelectMode )
{
	VCMultiSelectItem aSelectItem( VCATTR_MULTISELECT, eSelectMode );
	pItemSet->Put( aSelectItem );
	pImpCtrl->Update( TRUE, VCATTR_MULTISELECT );
	SiDLL::UpdateBrowserItem( VCATTR_MULTISELECT );
}

TYPEINIT1( VCComboBox, VCControl );

void VCComboBox::Reset()
{
	// wild zusammengehackt, da das Combobox-Interface noch nicht
	// ausgereift ist!!!!
	String aResetText( GetDefaultText() );
	ULONG nResetValue = (ULONG)aResetText.ToInt32();
	if( GetStyle() == VCCOMBO_DDLIST )
	{
		if( nResetValue != LIST_ENTRY_NOTFOUND )
		{
			SelectEntryPos( nResetValue  );
			SetText( GetEntry( nResetValue ));
		}
		else
			SetText(String());
		UpdateItem( VCATTR_TEXT );
	}
	else
	{
		if( GetText() != aResetText )
		{
			SetText( aResetText );
			UpdateItem( VCATTR_TEXT );
		}
	}
}

void VCComboBox::SetDefaultText( const String& rText)
{
	SfxStringItem aItem( VCATTR_DEFAULTTEXT, rText );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_DEFAULTTEXT );
	SiDLL::UpdateBrowserItem( VCATTR_DEFAULTTEXT );
}

String VCComboBox::GetDefaultText() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_DEFAULTTEXT )).GetValue();
}

BOOL VCComboBox::IsSorted() const
{
	return ((SfxBoolItem&)pItemSet->Get( VCATTR_SORTED )).GetValue();
}

void VCComboBox::SaveResetValue()
{
	String aResetText;
	if( GetStyle() == VCCOMBO_DDLIST )
		aResetText = String::CreateFromInt32( GetEntryPos( GetSelectEntry() ) );
	else
		aResetText = GetText();
	SetDefaultText( aResetText );
}

void VCComboBox::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealComboBox( this );
}

VCComboBox::VCComboBox( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
#if SUPD >=350
	,pOptionsArray(NULL)
#endif
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_FORECOLOR,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_LIST, VCATTR_COMBOSTYLE,
								   VCATTR_TEXT, VCATTR_TEXT,
								   VCATTR_DBLCLICK, VCATTR_KEYUP,
								   VCATTR_ONSELECT, VCATTR_ONSELECT,
								   VCATTR_CHANGED, VCATTR_CHANGED,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	SfxStringListItem aStrList( VCATTR_LIST );
	pItemSet->Put( aStrList );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCComboBox::~VCComboBox()
{
	delete pOptionsArray;
}

// Neue Methode, um SetValue() fuer JavaScript bereit zu stellen
void VCComboBox::SetItemData( const String& rStr, ULONG nPos ) const
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	pList->Replace( pStr, nPos );
	pItemSet->Put( *pItem );
	delete pItem;
}

void VCComboBox::SetDefaultChecked( USHORT, BOOL )
{
	DBG_ERROR("VCComboBox::SetDefaultChecked(USHORT,BOOL) not implemented");
}

USHORT VCComboBox::GetDefaultChecked() const
{
	DBG_ERROR("VCComboBox::GetDefaultChecked() not implemented");
	return FALSE;
}

void VCComboBox::Focus()
{
	// koennen wir momentan mit ComboBoxen nicht
	DBG_ERROR("VCComboBox::Focus() not implemented");

}

void VCComboBox::Blur()
{
	// koennen wir momentan mit ComboBoxen nicht
}

void VCComboBox::CreateOptionsArray()
{
#if SUPD >=350
	pOptionsArray = new SvPtrarr;

	// Objekte eintragen
	USHORT nCount = (USHORT)GetEntryCount();
	// mit Nullen aufplustern
	for( USHORT i = 0 ; i < nCount ; i++ )
		pOptionsArray->Insert( (void*)0, pOptionsArray->Count());
#endif
}

String VCComboBox::GetClassName() const
{
	return String( SiResId( STR_CLASS_COMBOBOX ) );
}

String VCComboBox::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_COMBOBOXES ) );
}

USHORT VCComboBox::GetStyle() const
{
	USHORT eStyle = (USHORT)((VCComboStyleItem&)
							pItemSet->Get( VCATTR_COMBOSTYLE )).GetValue();
	return eStyle;
}

String VCComboBox::GetText() const
{
	return ((VCImpRealComboBox*)pImpCtrl)->GetText();
}

void VCComboBox::SetText( const String& rText )
{
	((VCImpRealComboBox*)pImpCtrl)->SetText( rText );
	SiDLL::UpdateBrowserItem( VCATTR_TEXT );
}

USHORT VCComboBox::InsertEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	pList->Insert( pStr, nPos );

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
									pItemSet->Get( VCATTR_ITEMDATA ).Clone();

	pItemData->SetEntryCount( (USHORT)pList->Count() );

	USHORT nNewIndex;

	pItemSet->Put( *pItem );
	delete pItem;
	pItemSet->Put( *pItemData );
	delete pItemData;

	nNewIndex = ((VCImpRealComboBox*)pImpCtrl)->InsertEntry( rStr, nPos );
	return nNewIndex;
}

void VCComboBox::ReplaceEntry( const String& rStr, ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	delete (String*)(pList->Replace( pStr, nPos ));
	pItemSet->Put( *pItem );
	delete pItem;

	((VCImpRealComboBox*)pImpCtrl)->ReplaceEntry( rStr, nPos );
}

void VCComboBox::RemoveEntry( ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	delete (String*)(pList->Remove( nPos ));
	pItemSet->Put( *pItem );
	delete pItem;

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
									pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	pItemData->SetEntryCount( (USHORT)pList->Count() );
	pItemSet->Put( *pItemData );
	delete pItemData;

	((VCImpRealComboBox*)pImpCtrl)->RemoveEntry( nPos );
}

String VCComboBox::GetEntry( ULONG nPos )
{
	SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );

	List* pList = rItem.GetList();
	String* pStr = (String*)(pList->GetObject( nPos ));
	if( pStr )
		return String( *pStr );
	return String();
}

String VCComboBox::GetSelectEntry() const
{
	return ((VCImpRealComboBox*)pImpCtrl)->GetSelectEntry();
}

void VCComboBox::Clear()
{
	SfxStringListItem aItem( VCATTR_LIST );
	pItemSet->Put( aItem );

	VCIntegerListItem aDataItem( VCATTR_ITEMDATA );
	pItemSet->Put( aDataItem );

	if( pParent )
		((VCImpRealComboBox*)pImpCtrl)->Update();
}

ULONG VCComboBox::GetEntryCount() const
{
	SfxStringListItem& rItem = (SfxStringListItem&)pItemSet->Get( VCATTR_LIST );
	return rItem.GetList()->Count();
}

Size VCComboBox::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

void VCComboBox::SelectEntryPos( ULONG nPos, BOOL bSelect )
{
	DBG_ERROR("VCComboBox::SelectEntryPos(ULONG,BOOL) not implemented");
}

void VCComboBox::SetValue( const String& )
{
}

String VCComboBox::GetValue() const
{
	return VCControl::GetValue();
}

TYPEINIT1( VCEdit, VCControl );

void VCEdit::Reset()
{
	String aDefaultText( GetDefaultText() );
	if( aDefaultText != GetText() )
		SetText( aDefaultText );
}

void VCEdit::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealEdit( this );
}

VCEdit::VCEdit( VCContainer* pParent, VCItemPool* pPool, BOOL bReal ,
VCSbxControl* _pCtrl) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_FORECOLOR,
								   VCATTR_BORDER, VCATTR_TABSTOP,
								   VCATTR_TEXT, VCATTR_TEXT,
								   VCATTR_ALIGNMENT, VCATTR_ALIGNMENT,
								   VCATTR_WORDWRAP, VCATTR_WORDWRAP,
								   VCATTR_MAXLENGTH, VCATTR_SCROLLBARS,
								   VCATTR_DBLCLICK, VCATTR_CHANGED,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	// Per Default mit Rahmen
	SfxBoolItem aBorder( VCATTR_BORDER, TRUE );
	pItemSet->Put( aBorder );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

void VCEdit::SetDefaultText( const String& rText)
{
	SfxStringItem aItem( VCATTR_DEFAULTTEXT, rText );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_DEFAULTTEXT );
	SiDLL::UpdateBrowserItem( VCATTR_DEFAULTTEXT );
}

String VCEdit::GetDefaultText() const
{
	return ((SfxStringItem&)pItemSet->Get( VCATTR_DEFAULTTEXT )).GetValue();
}

void VCEdit::SaveResetValue()
{
	SetDefaultText( GetText() );
}

void VCEdit::Focus()
{
	((VCImpRealEdit*)pImpCtrl)->Focus();
}

void VCEdit::Blur()
{
	((VCImpRealEdit*)pImpCtrl)->Blur();
}

void VCEdit::Select()
{
	DBG_ERROR("VCEdit::Select() for real controls not implemented");
}

VCEdit::~VCEdit()
{
}

String VCEdit::GetClassName() const
{
	return String( SiResId( STR_CLASS_EDIT ) );
}

String VCEdit::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_EDITS ) );
}

void VCEdit::SetText( const String& rText )
{
	pItemSet->Put( SfxStringItem( VCATTR_TEXT, rText ) );
	if( pImpCtrl && pParent )
		pImpCtrl->Update( TRUE, VCATTR_TEXT );
	SiDLL::UpdateBrowserItem( VCATTR_TEXT );
}

//static
void VCEdit::Convert( String& rText, USHORT nWordWrap )
{
	if( nWordWrap == VCWORDWRAP_SOFT )
	{
		rText.ConvertLineEnd( LINEEND_CR );
		USHORT nIndex = 0;
		while( nIndex != STRING_NOTFOUND )
			nIndex = rText.SearchAndReplace( '\r', ' ', nIndex );
	}
}

String VCEdit::GetText() const
{
	String aStr( ((SfxStringItem&)pItemSet->Get( VCATTR_TEXT )).GetValue() );
	Convert( aStr, GetWordWrap() );
	return aStr;
}

void VCEdit::SetMaxLen( ULONG nMaxLen )
{
	pItemSet->Put( SfxInt32Item( VCATTR_MAXLENGTH, (long)nMaxLen ) );
	if( pImpCtrl && pParent )
		pImpCtrl->Update( TRUE, VCATTR_MAXLENGTH );
	SiDLL::UpdateBrowserItem( VCATTR_MAXLENGTH );
}

ULONG VCEdit::GetMaxLen() const
{
	return (ULONG)((SfxInt32Item&)pItemSet->Get( VCATTR_MAXLENGTH )).GetValue();
}

void VCEdit::SetSelectStart( long nStart )
{
}

long VCEdit::GetSelectStart() const
{
	return 0;
}

void VCEdit::SetSelectLen( long nLen )
{
}

long VCEdit::GetSelectLen() const
{
		return 0;
}

void VCEdit::SetSelectText( const String& rText )
{
}

String VCEdit::GetSelectText() const
{
	return String();
}

void VCEdit::SetPasswordChar( sal_Unicode cPass )
{
	DBG_ASSERT(pItemSet,"VCEdit: No ItemSet");
	DBG_ASSERT(pImpCtrl,"VCEdit: No ImpControl");

	String aStr;
	if( cPass )
		aStr = cPass;

	SfxStringItem aPwdItem( VCATTR_PASSWORDCHAR, aStr );
	pItemSet->Put( aPwdItem );
	pImpCtrl->Update( TRUE, VCATTR_PASSWORDCHAR );
	SiDLL::UpdateBrowserItem( VCATTR_PASSWORDCHAR );
}

sal_Unicode VCEdit::GetPasswordChar() const
{
	DBG_ASSERT(pItemSet,"VCEdit: No ItemSet");
	DBG_ASSERT(pImpCtrl,"VCEdit: No ImpControl");

	const SfxStringItem& rPwdItem = (const SfxStringItem&)(pItemSet->Get( VCATTR_PASSWORDCHAR ));
	const String& rPwd = rPwdItem.GetValue();
	sal_Unicode cPass;
	if( rPwd.Len() )
		cPass = rPwd.GetChar( 0 );
	else
		cPass = 0;
	return cPass;
}

void VCEdit::SetMultiLine( BOOL bMultiLine )
{
	SfxBoolItem aItem( VCATTR_MULTILINE, bMultiLine );
	pItemSet->Put( aItem );
	UpdateItem( VCATTR_MULTILINE );
	SiDLL::UpdateBrowserItem( VCATTR_MULTILINE );
}

BOOL VCEdit::IsMultiLine() const
{
	const SfxBoolItem& rItem = (const SfxBoolItem&)(pItemSet->Get( VCATTR_MULTILINE));
	return rItem.GetValue();
}

Size VCEdit::GetOptSize( OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

Size VCEdit::GetOptSize( const Size& rCharXY, OutputDevice* pOut ) const
{
	Size aSize;
	return aSize;
}

Size VCEdit::GetCharCountXY( OutputDevice* pOut, const Font* pFont ) const
{
	Size aSize;
	return aSize;
}

void VCEdit::SetValue( const String& rValue )
{
	SetText( rValue );
}

String VCEdit::GetValue() const
{
	return GetText();
}


BOOL VCEdit::IsModified() const
{
	return ((VCImpRealEdit*)pImpCtrl)->IsModified();
}

void VCEdit::SetModifyFlag( BOOL bModified )
{
	((VCImpRealEdit*)pImpCtrl)->SetModifyFlag( bModified );
}

void VCEdit::SetWordWrap( USHORT nMode )
{
	VCWordWrapItem aWordWrapItem( VCATTR_WORDWRAP_MODE, nMode );
	pItemSet->Put( aWordWrapItem );
	pImpCtrl->Update( TRUE, VCATTR_WORDWRAP_MODE );
}

USHORT VCEdit::GetWordWrap() const
{
	const VCWordWrapItem& rItem = (const VCWordWrapItem&)pItemSet->Get(VCATTR_WORDWRAP_MODE);
	return rItem.GetValue();
}


TYPEINIT1( VCScrollBar, VCControl );

VCScrollBar::VCScrollBar( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_HEIGHT,
								   VCATTR_TABINDEX, VCATTR_TABSTOP,
								   VCATTR_SCROLLBARVALUE, VCATTR_LARGECHANGE,
								   VCATTR_GOTFOCUS, VCATTR_KEYUP,
								   VCATTR_CHANGED, VCATTR_SCROLL,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );
}

VCScrollBar::~VCScrollBar()
{
}

void VCScrollBar::Scrolled()
{
	ExecuteHandler( VCHDL_ONSCROLL );
}

void VCScrollBar::Changed()
{
	ExecuteHandler( VCHDL_ONCHANGE );
}

TYPEINIT1( VCHScrollBar, VCScrollBar );

void VCHScrollBar::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealHScrollBar( this );
}

VCHScrollBar::VCHScrollBar( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCScrollBar( pParent, pPool, bReal, _pCtrl )
{
	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCHScrollBar::~VCHScrollBar()
{
}

String VCHScrollBar::GetClassName() const
{
	return String( SiResId( STR_CLASS_HSCROLLBAR ) );
}

String VCHScrollBar::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_HSCROLLBARS ) );
}


TYPEINIT1( VCVScrollBar, VCScrollBar );

void VCVScrollBar::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealVScrollBar( this );
}

VCVScrollBar::VCVScrollBar( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCScrollBar( pParent, pPool, bReal, _pCtrl )
{
	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCVScrollBar::~VCVScrollBar()
{
}

String VCVScrollBar::GetClassName() const
{
	return String( SiResId( STR_CLASS_VSCROLLBAR ) );
}

String VCVScrollBar::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_VSCROLLBARS ) );
}

TYPEINIT1( VCPreview, VCControl );

void VCPreview::Create()
{
	delete pImpCtrl;
	pImpCtrl = new VCImpRealPreview( this );
}

VCPreview::VCPreview( VCContainer* pParent, VCItemPool* pPool, BOOL bReal,
VCSbxControl* _pCtrl ) :
	VCControl( pParent, pPool, bReal, _pCtrl )
{
		pItemSet = new SfxItemSet( *pPool,
								   VCATTR_NAME, VCATTR_HELPTEXT,
								   VCATTR_TAG, VCATTR_STEP,
								   VCATTR_LEFT, VCATTR_FORECOLOR,
								   VCATTR_BORDER, VCATTR_TABSTOP,
								   VCATTR_DBLCLICK, VCATTR_MOUSEUP,
								   VCATTR_RESIZE, VCATTR_PAINT,
								   VCATTR_MACROS, VCATTR_MACROS,
								   NULL );

	Create();

	if( pParent )
		pParent->InsertChild( this );

	UpdateOutRect();
}

VCPreview::~VCPreview()
{
}

String VCPreview::GetClassName() const
{
	return String( SiResId( STR_CLASS_PREVIEW ) );
}

String VCPreview::GetClassNamePlural() const
{
	return String( SiResId( STR_CLASS_PREVIEWS ) );
}

ULONG VCListBox::GetEntryPos( const String& rEntry ) const
{
	const SfxStringListItem& rItem = (const SfxStringListItem&)(pItemSet->Get(VCATTR_LIST));
	List* pList = ((SfxStringListItem&)rItem).GetList();
	ULONG nCount = pList->Count();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
	{
		String* pStr = (String*)(pList->GetObject( nCur ));
		if( *pStr == rEntry )
			return nCur;
	}
	return LIST_ENTRY_NOTFOUND;
}

String VCListBox::GetItemData( ULONG nPos ) const
{
	const VCIntegerListItem& rItem = (const VCIntegerListItem&)pItemSet->Get(VCATTR_ITEMDATA);
	List* pList = ((SfxStringListItem&)rItem).GetList();
	String* pStr = (String*)(pList->GetObject(nPos) );
	String aStr;
	if( pStr )
		aStr = *pStr;
	return aStr;
}

ULONG VCComboBox::GetEntryPos( const String& rEntry ) const
{
	const SfxStringListItem& rItem = (const SfxStringListItem&)pItemSet->Get(VCATTR_LIST);
	List* pList = ((SfxStringListItem&)rItem).GetList();
	ULONG nCount = pList->Count();
	for( ULONG nCur=0; nCur < nCount; nCur++ )
	{
		String* pStr = (String*)(pList->GetObject( nCur ));
		if( *pStr == rEntry )
			return nCur;
	}
	return LIST_ENTRY_NOTFOUND;
}

String VCComboBox::GetItemData( ULONG nPos ) const
{
	const VCIntegerListItem& rItem = (const VCIntegerListItem&)pItemSet->Get(VCATTR_ITEMDATA);
	List* pList = ((SfxStringListItem&)rItem).GetList();
	String* pStr = (String*)(pList->GetObject(nPos) );
	String aStr;
	if( pStr )
		aStr = *pStr;
	return aStr;
}

USHORT VCListBox::InsertEntry( const String& rStr, const String& rData,
	ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();

	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	pList->Insert( pStr, nPos );
	pItemSet->Put( *pItem );
	delete pItem;

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
							pItemSet->Get( VCATTR_ITEMDATA ).Clone();
	List* pItemDataList = pItemData->GetList();
	String* pDataStr = new String( rData );
	pItemDataList->Insert( pDataStr, nPos );

	pItemSet->Put( *pItemData );
	delete pItemData;

	USHORT nNewIndex;
	nNewIndex = ((VCImpRealListBox*)pImpCtrl)->InsertEntry( rStr, nPos );
	return nNewIndex;
}

USHORT VCComboBox::InsertEntry( const String& rStr, const String& rData,
	ULONG nPos )
{
	SfxStringListItem* pItem = (SfxStringListItem*)
								pItemSet->Get( VCATTR_LIST ).Clone();
	List* pList = pItem->GetList();
	String* pStr = new String( rStr );
	pList->Insert( pStr, nPos );
	pItemSet->Put( *pItem );
	delete pItem;

	VCIntegerListItem* pItemData = (VCIntegerListItem*)
									pItemSet->Get( VCATTR_ITEMDATA ).Clone();

	List* pItemDataList = pItemData->GetList();
	String* pDataStr = new String( rData );
	pItemDataList->Insert( pDataStr, nPos );
	pItemSet->Put( *pItemData );
	delete pItemData;

	USHORT nNewIndex;
	nNewIndex = ((VCImpRealComboBox*)pImpCtrl)->InsertEntry( rStr, nPos );
	return nNewIndex;
}

void VCEdit::SetFileUpload( BOOL b)
{
}

BOOL VCEdit::IsFileUpload() const
{
	return FALSE;
}

