/*************************************************************************
 *
 *  $RCSfile: vcedfac.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 11:02:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define _SI_NOVCDRAWVIEW
#define _SI_VCDRAWOBJ
#include "vcsbx.hxx"
#include "vcsbxdo.hxx"
#include "vced.hxx"
#include "vcedfac.hxx"

VCDlgEditFactory::VCDlgEditFactory( VCDlgEditor* pDlgEd )
{
	pDlgEditor = pDlgEd;
}

IMPL_LINK( VCDlgEditFactory, MakeObject, SdrObjFactory *, pObjFactory )
{
	if( (pObjFactory->nInventor == VCSbxInventor) &&
		(pObjFactory->nIdentifier >=OBJ_DLG_CHECKBOX) &&
		(pObjFactory->nIdentifier <= OBJ_DLG_URLBUTTON)    )
	{
		// Ein Control-DrawObject
		VCSbxControl* 	pControl = NULL;

		VCSbxDialog*    pSbxForm = pDlgEditor->GetVCSbxForm();
		StarBASIC*		pBasic   = pDlgEditor->GetBasic();


		switch( pObjFactory->nIdentifier )
		{
			case OBJ_DLG_CHECKBOX:
				 pControl = new VCSbxCheckBox( TRUE );
				 break;
			case OBJ_DLG_RADIOBUTTON:
				 pControl = new VCSbxRadioButton( TRUE );
				 break;
			case OBJ_DLG_PUSHBUTTON:
				 pControl = new VCSbxPushButton( TRUE );
				 break;
			case OBJ_DLG_SPINBUTTON:
				 pControl = new VCSbxSpinButton( TRUE );
				 break;
			case OBJ_DLG_FIXEDTEXT:
				 pControl = new VCSbxFixedText( TRUE );
				 break;
			case OBJ_DLG_GROUPBOX:
				 pControl = new VCSbxGroupBox( TRUE );
				 break;
			case OBJ_DLG_LISTBOX:
				 pControl = new VCSbxListBox( TRUE );
				 break;
			case OBJ_DLG_COMBOBOX:
				 pControl = new VCSbxComboBox( TRUE );
				 break;
			case OBJ_DLG_EDIT:
				 pControl = new VCSbxEdit( TRUE );
				 break;
			case OBJ_DLG_HSCROLLBAR:
				 pControl = new VCSbxHScrollBar( TRUE );
				 break;
			case OBJ_DLG_VSCROLLBAR:
				 pControl = new VCSbxVScrollBar( TRUE );
				 break;
			case OBJ_DLG_PREVIEW:
				 pControl = new VCSbxPreview( TRUE );
				 break;
			case OBJ_DLG_URLBUTTON:
				 pControl = new VCSbxURLButton( TRUE );
				 break;
		}

		if( pControl )
		{
			pObjFactory->pNewObj = new VCSbxDrawObject( pControl );
			return 0;
		}
	}

	if( aOldMakeObjLink.IsSet() )
		aOldMakeObjLink.Call( pObjFactory );
	return 0;
}

#pragma SEG_EOFMODULE

