/*************************************************************************
 *
 *  $RCSfile: marshal.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:28:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <com/sun/star/uno/Sequence.hxx>

typedef struct _uno_Environment uno_Environment;	
struct remote_Interface;
//struct rtl_String;

typedef void ( SAL_CALL * extractOidCallback ) (
	remote_Interface *pRemoteI,
	rtl_uString **ppOid ,
	rtl_uString **ppType );

namespace bridges_remote
{	
class Marshal
{
public:
	Marshal( sal_Bool bIsLittleEndian,
			 uno_Environment *pEnvRemote = 0,
			 extractOidCallback callback= 0 ,
			 sal_Int32 nStartMarshalingAt = 0 );
	Marshal(
		sal_Bool bIsLittleEndian ,
		const ::com::sun::star::uno::Sequence< sal_Int8 > &seqFixedSized );

	void pack( void *pSource , const ::com::sun::star::uno::Type &rType );
	void pack( void *pSource , typelib_TypeDescription *pType );

	// Used only to pack protocol dependend 
	void packByteSequence( sal_Int8 *pBuffer , sal_Int32 nSize );
	
	::com::sun::star::uno::Sequence < sal_Int8 > remove();

	inline sal_Int32 getPos()
		{ return m_pos - m_base; }
	
private:
	inline void align( sal_Int32 nToAlign );
	inline void ensureAdditionalMem( sal_Int32 nMemToAdd );
	
	::com::sun::star::uno::Sequence < sal_Int8 > m_seqData;
	sal_Bool m_nStartMarshalingAt;
	sal_Bool m_bIsLittleEndian;
	sal_Int8 *m_pos;
	sal_Int8 *m_base;
	extractOidCallback m_callback;
	uno_Environment *m_pEnvRemote;
};


template < class C >
inline void operator <<= (Marshal & r,  C& value)
{
	r.pack( &value, getCppuType( &value ) );
}

}
