/*************************************************************************
 *
 *  $RCSfile: connectionWrapper.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:28:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <string.h>

#include <osl/diagnose.h>


#include <connectionWrapper.hxx>

#include <jvmHelp.hxx>

using namespace ::com::sun::star::java;
using namespace ::com::sun::star::uno;

using namespace ::rtl;

namespace UNO_LB_JAVA_NAMESPACE 
{
	void SAL_CALL ConnectionWrapper_acquire(remote_Connection * blb) {
		++ ((ConnectionWrapper *)blb)->_refCount;
	}
	
	void SAL_CALL ConnectionWrapper_release (remote_Connection * blb) {
		if(!-- ((ConnectionWrapper *)blb)->_refCount)
			delete (ConnectionWrapper *)blb;
	}

	sal_Int32 SAL_CALL ConnectionWrapper_read(remote_Connection * blb, sal_Int8 *pDest, sal_Int32 nSize) {
		ConnectionWrapper * pC = (ConnectionWrapper *)blb;
		jint jiRes = -1;

		try {
			JVMThreadAttach jvm(pC->_pJavaVM, pC->_xJavaThreadRegister_11);
			
			try {
				jobjectArray joDest = jvm._pJNIEnv->NewObjectArray(1, pC->_jcByteArray, 0);                                       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 1"), Reference<XInterface>());
				jvm._pJNIEnv->SetObjectArrayElement(joDest, 0, jvm._pJNIEnv->NewByteArray(10));									  if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 2"), Reference<XInterface>());
				
				jiRes = jvm._pJNIEnv->CallIntMethod(pC->_joConnection, pC->_jmConnection_read, joDest, (jint)nSize);		      if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 3"), Reference<XInterface>());
				
				jbyteArray jaDest = reinterpret_cast<jbyteArray>(jvm._pJNIEnv->GetObjectArrayElement(joDest, 0));				  if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 4"), Reference<XInterface>());
			
				jbyte * pBytes = jvm._pJNIEnv->GetByteArrayElements(jaDest, NULL);												  if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 5"), Reference<XInterface>());
				memcpy(pDest, pBytes, jiRes * sizeof(sal_Int8));
				jvm._pJNIEnv->ReleaseByteArrayElements(jaDest, pBytes, 0);														  if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 6"), Reference<XInterface>());
			}
			catch(RuntimeException & runtimeException) {
				if(jvm._pJNIEnv->ExceptionOccurred()) {
					jvm._pJNIEnv->ExceptionDescribe();
					jvm._pJNIEnv->ExceptionClear();
				}

				throw runtimeException;
			}
		}
		catch(RuntimeException &) {
			osl_trace("ConnectionWrapper_read - runtimeException occurred\n");
			jiRes = -1;
		}

		return (sal_Int32)jiRes;
	}

	sal_Int32 SAL_CALL ConnectionWrapper_write(remote_Connection * blb, const sal_Int8 *pSource, sal_Int32 nSize) {
		ConnectionWrapper * pC = (ConnectionWrapper *)blb;

		try {
			JVMThreadAttach jvm(pC->_pJavaVM, pC->_xJavaThreadRegister_11);
		
			try {
				jbyteArray jaSource = jvm._pJNIEnv->NewByteArray(nSize);													   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 7"), Reference<XInterface>());
				jbyte * pBytes = jvm._pJNIEnv->GetByteArrayElements(jaSource, NULL);										   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 8"), Reference<XInterface>());
				memcpy(pBytes, pSource, nSize * sizeof(jbyte));
				jvm._pJNIEnv->ReleaseByteArrayElements(jaSource, pBytes, 0);												   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 9"), Reference<XInterface>());
				
				jvm._pJNIEnv->CallVoidMethod(pC->_joConnection, pC->_jmConnection_write, jaSource, (jint)nSize);			   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 10"), Reference<XInterface>());
			}
			catch(RuntimeException & runtimeException) {
				if(jvm._pJNIEnv->ExceptionOccurred()) {
					jvm._pJNIEnv->ExceptionDescribe();
					jvm._pJNIEnv->ExceptionClear();
				}
				
				throw runtimeException;
			}
		}
		catch(RuntimeException &) {
			osl_trace("ConnectionWrapper_read - runtimeException occurred\n");
			nSize = -1;
		}
		
		return nSize;
	}

	void SAL_CALL ConnectionWrapper_flush(remote_Connection * blb) {
		ConnectionWrapper * pC = (ConnectionWrapper *)blb;

		JVMThreadAttach jvm(pC->_pJavaVM, pC->_xJavaThreadRegister_11);
		jvm._pJNIEnv->CallVoidMethod(pC->_joConnection, pC->_jmConnection_flush);
		if(jvm._pJNIEnv->ExceptionOccurred()) {
			jvm._pJNIEnv->ExceptionDescribe();
			jvm._pJNIEnv->ExceptionClear();
		}
	}

	void SAL_CALL ConnectionWrapper_close(remote_Connection * blb) {
		ConnectionWrapper * pC = (ConnectionWrapper *)blb;

		JVMThreadAttach jvm(pC->_pJavaVM, pC->_xJavaThreadRegister_11);
		jvm._pJNIEnv->CallVoidMethod(pC->_joConnection, pC->_jmConnection_close);
		if(jvm._pJNIEnv->ExceptionOccurred()) {
			jvm._pJNIEnv->ExceptionDescribe();
			jvm._pJNIEnv->ExceptionClear();
		}
	}
	
	ConnectionWrapper::ConnectionWrapper(JavaVM * pJavaVM, const Reference<XJavaThreadRegister_11> & xJavaThreadRegister_11, jobject joConnection) throw(RuntimeException)
		: _refCount(0),
		  _pJavaVM(pJavaVM),
		  _xJavaThreadRegister_11(xJavaThreadRegister_11)
	{
//  		if(!pJavaVM	|| !xJavaThreadRegister_11.is() || !joConnection)
//  			throw RuntimeException(OUString::createFromAscii("hier 11"), Reference<XInterface>());

		acquire = ConnectionWrapper_acquire;
		release = ConnectionWrapper_release;
		read = ConnectionWrapper_read;
		write = ConnectionWrapper_write;
		flush = ConnectionWrapper_flush;
		close = ConnectionWrapper_close;
		  
		JVMThreadAttach jvm(pJavaVM, xJavaThreadRegister_11);

		_jcByteArray = jvm._pJNIEnv->FindClass("[B");																	       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 12"), Reference<XInterface>());
		_jcByteArray = reinterpret_cast<jclass>(jvm._pJNIEnv->NewGlobalRef(reinterpret_cast<jobject>(_jcByteArray)));		   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 13"), Reference<XInterface>());

		jclass jcConnection = jvm._pJNIEnv->FindClass("com/sun/star/connection/XConnection");								   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 14"), Reference<XInterface>());

		_jmConnection_read  = jvm._pJNIEnv->GetMethodID(jcConnection, "read", "([[BI)I");									   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 15"), Reference<XInterface>());
//  		_jmConnection_read  = reinterpret_cast<jmethodID>(jvm._pJNIEnv->NewGlobalRef(reinterpret_cast<jobject>(_jmConnection_read)));
		_jmConnection_write = jvm._pJNIEnv->GetMethodID(jcConnection, "write", "([B)V");								       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 16"), Reference<XInterface>());
//  		_jmConnection_write = reinterpret_cast<jmethodID>(jvm._pJNIEnv->NewGlobalRef(reinterpret_cast<jobject>(_jmConnection_write)));
		_jmConnection_flush = jvm._pJNIEnv->GetMethodID(jcConnection, "flush", "()V");									       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 17"), Reference<XInterface>());
//  		_jmConnection_flush = reinterpret_cast<jmethodID>(jvm._pJNIEnv->NewGlobalRef(reinterpret_cast<jobject>(_jmConnection_flush)));
		_jmConnection_close = jvm._pJNIEnv->GetMethodID(jcConnection, "close", "()V");									       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 18"), Reference<XInterface>());
//  		_jmConnection_close = reinterpret_cast<jmethodID>(jvm._pJNIEnv->NewGlobalRef(reinterpret_cast<jobject>(_jmConnection_close)));

		_joConnection = jvm._pJNIEnv->NewGlobalRef(joConnection);														       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 19"), Reference<XInterface>());
	}

	ConnectionWrapper::~ConnectionWrapper() throw(RuntimeException) {
		JVMThreadAttach jvm(_pJavaVM, _xJavaThreadRegister_11);
		
		jvm._pJNIEnv->DeleteGlobalRef(_joConnection);																	       if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 20"), Reference<XInterface>());

		jvm._pJNIEnv->DeleteGlobalRef(reinterpret_cast<jobject>(_jmConnection_read));										   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 21"), Reference<XInterface>());
		jvm._pJNIEnv->DeleteGlobalRef(reinterpret_cast<jobject>(_jmConnection_write));										   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 22"), Reference<XInterface>());
		jvm._pJNIEnv->DeleteGlobalRef(reinterpret_cast<jobject>(_jmConnection_flush));										   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 23"), Reference<XInterface>());
		jvm._pJNIEnv->DeleteGlobalRef(reinterpret_cast<jobject>(_jmConnection_close));										   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 24"), Reference<XInterface>());

		jvm._pJNIEnv->DeleteGlobalRef(_jcByteArray);																		   if(jvm._pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("hier 25"), Reference<XInterface>());
	}



}
