/*************************************************************************
 *
 *  $RCSfile: java_uno_mapping.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:28:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "jni.h"


#include <string.h>

#include <osl/diagnose.h>
#include <osl/interlck.h>

#include <rtl/ustring>
#include <rtl/process.h>

#include <uno/mapping.hxx>

#ifdef LINUX
#undef minor
#undef major
#endif

#include <com/sun/star/uno/Reference.hxx>

#include <com/sun/star/connection/XConnection.hpp>

#include <com/sun/star/java/XJavaMapper.hpp>
#include <com/sun/star/java/XJavaVM.hpp>
#include <com/sun/star/java/XJavaThreadRegister_11.hpp>

#include <bridges/remote/context.h>
#include <bridges/remote/remote.h>

#include <cppuhelper/factory.hxx>

#include "jthreadpool.hxx"
#include "connectionWrapper.hxx"
#include "java_uno_mapping.hxx"

using namespace ::com::sun::star::connection;
using namespace ::com::sun::star::java;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::registry;
using namespace ::com::sun::star::io;

using namespace ::cppu;
using namespace ::rtl;

namespace UNO_LB_JAVA_NAMESPACE 
{
	void java_Mapping_init(java_Mapping * pJava_mapping, 
						   uno_Environment * pFrom,
						   uno_Environment * pUNO_Environment) throw(RuntimeException)
	{
		pJava_mapping->_pMapper = NULL;
		pJava_mapping->_refCount = 1; // is one time acquire

  		JavaVM * pJavaVM = (JavaVM *)pFrom->pContext;

  		JNIEnv * pJNIEnv;


//  		fprintf(stderr, "blabla --- %p\n", pFrom->pContext);

//  		JNIEnv * pJNIEnv = (JNIEnv *)pFrom->pContext;
//    		JavaVM * pJavaVM;
//  		pJNIEnv->GetJavaVM(&pJavaVM);

		Reference< XJavaThreadRegister_11 > xJavaThreadRegister_11;


		pJavaVM->AttachCurrentThread((void **)&pJNIEnv, (void *)NULL);
//    		xJavaThreadRegister_11->registerThread();

//  		if( ! javaloader_initNativeThreadPool( pJNIEnv, xJavaThreadRegister_11 ) )
//    		{
//    			throw RuntimeException(
//    				OUString::createFromAscii( "native threadpool couldn't be initialzed" ),
//    				Reference< XInterface > () );
//    		}

		const char * pServiceName = "com.sun.star.comp.JavaMapper";


		typelib_TypeDescription *pInterface_Type = 0;
		getCppuType((Reference<XJavaMapper> *)0).getDescription(&pInterface_Type);




		remote_Connection * pRemote_Connection = NULL;

		try {
		  jclass jcServiceManager = pJNIEnv->FindClass("com/sun/star/comp/servicemanager/ServiceManager");				     if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 26"), Reference<XInterface>());
		  jmethodID jmServiceManager_init = pJNIEnv->GetMethodID(jcServiceManager, "<init>", "()V");					     if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 27"), Reference<XInterface>());
		  jobject joServiceManager = pJNIEnv->NewObject(jcServiceManager, jmServiceManager_init);						     if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 28"), Reference<XInterface>());

		  // we need to register the need services
		  static const char * neededServices[] = {
			  "com.sun.star.comp.servicemanager.ServiceManager",
			  "com.sun.star.comp.loader.JavaLoader",
			  "com.sun.star.lib.uno.bridges.java_remote.java_remote_bridge",
			  "com.sun.star.comp.connections.PipedConnection",
			  "com.sun.star.comp.connections.ConstantInstanceProvider",
			  "com.sun.star.comp.bridge.JavaMapper"
		  };

		  jclass jcString = pJNIEnv->FindClass("java/lang/String");                                                          if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 29"), Reference<XInterface>());
		  jobjectArray jaNeededServices = pJNIEnv->NewObjectArray(sizeof(neededServices) / sizeof(char *), jcString, NULL);  if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 30"), Reference<XInterface>());
		  for(int i = 0; i < sizeof(neededServices) / sizeof(char *); ++ i) {
			  pJNIEnv->SetObjectArrayElement(jaNeededServices, i, pJNIEnv->NewStringUTF(neededServices[i]));                 if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 31"), Reference<XInterface>());
		  }
		
		  jmethodID jmServiceManager_addFactories = pJNIEnv->GetMethodID(jcServiceManager, 
																		 "addFactories", 
																		 "([Ljava/lang/String;)V");                          if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 32"), Reference<XInterface>());

		  pJNIEnv->CallVoidMethod(joServiceManager, jmServiceManager_addFactories, jaNeededServices);						 if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 33"), Reference<XInterface>());

		// 
		  jmethodID jmServiceManager_createInstanceWithArguments = pJNIEnv->GetMethodID(jcServiceManager, 
																						"createInstanceWithArguments", 
																						"(Ljava/lang/String;[Ljava/lang/Object;)Ljava/lang/Object;"); if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 34"), Reference<XInterface>());

		  // create an instance of our special inprocess connection
		  jmethodID jmServiceManager_createInstance = pJNIEnv->GetMethodID(jcServiceManager, 
																		   "createInstance", 
																		   "(Ljava/lang/String;)Ljava/lang/Object;");        if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 35"), Reference<XInterface>());

		  jstring jsConnectionName = pJNIEnv->NewStringUTF("com.sun.star.connection.PipedConnection");					   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 36"), Reference<XInterface>());
		  jobject joConnection_nativeSide = pJNIEnv->CallObjectMethod(joServiceManager, 
																	  jmServiceManager_createInstance, 
																	  jsConnectionName);                                     if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 37"), Reference<XInterface>());

		  jclass jcObject = pJNIEnv->FindClass("java/lang/Object");														   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 38"), Reference<XInterface>());
		  jobjectArray jaArgs = pJNIEnv->NewObjectArray(1, jcObject, joConnection_nativeSide);							   
		  jobject joConnection_javaSide = pJNIEnv->CallObjectMethod(joServiceManager, 
																	jmServiceManager_createInstanceWithArguments, 
																	jsConnectionName, jaArgs);							   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 39"), Reference<XInterface>());

		  // create an constant service provider with java servicemanager
		  jstring jsInstanceProvider = pJNIEnv->NewStringUTF("com.sun.star.comp.connection.InstanceProvider");			   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 40"), Reference<XInterface>());
		  jobject joInstanceProvider = pJNIEnv->CallObjectMethod(joServiceManager, 
																 jmServiceManager_createInstance, 
																 jsInstanceProvider);										   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 41"), Reference<XInterface>());
		  
		  jclass jcInstanceProvider = pJNIEnv->FindClass("com/sun/star/comp/connections/ConstantInstanceProvider");        if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 62"), Reference<XInterface>());
		  jmethodID jmInstanceProvider_setInstance = pJNIEnv->GetMethodID(jcInstanceProvider, "setInstance", "(Ljava/lang/String;)V");
		                                                                                                                   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 61"), Reference<XInterface>());
		  jstring jsServiceName = pJNIEnv->NewStringUTF(pServiceName);			                                           if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 60"), Reference<XInterface>());
		  pJNIEnv->CallVoidMethod(joInstanceProvider, jmInstanceProvider_setInstance, jsServiceName);

		  // create the bridge factory && the bridge
		  jaArgs = pJNIEnv->NewObjectArray(3, jcObject, NULL);															   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 42"), Reference<XInterface>());

		  pJNIEnv->SetObjectArrayElement(jaArgs, 0, pJNIEnv->NewStringUTF("urp"));										   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 43"), Reference<XInterface>());
//  		  pJNIEnv->SetObjectArrayElement(jaArgs, 0, pJNIEnv->NewStringUTF("iiop"));										   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 43"), Reference<XInterface>());
          //pJNIEnv->SetObjectArrayElement(jaArgs, 0, pJNIEnv->NewStringUTF("urp"));										   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 43"), Reference<XInterface>());
		  pJNIEnv->SetObjectArrayElement(jaArgs, 1, joConnection_javaSide);												   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 44"), Reference<XInterface>());
		  pJNIEnv->SetObjectArrayElement(jaArgs, 2, joInstanceProvider);													   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 45"), Reference<XInterface>());
		
		  jstring jsBridgeComponent = pJNIEnv->NewStringUTF("com.sun.star.bridge.Bridge");						   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 46"), Reference<XInterface>());
		  jobject joBridge = pJNIEnv->CallObjectMethod(joServiceManager, 
													   jmServiceManager_createInstanceWithArguments, 
													   jsBridgeComponent, 
													   jaArgs);															   if(pJNIEnv->ExceptionOccurred()) throw RuntimeException(OUString::createFromAscii("error - 47"), Reference<XInterface>());

		  pRemote_Connection = new ConnectionWrapper(pJavaVM, xJavaThreadRegister_11, joConnection_nativeSide);
		}
		catch(RuntimeException & runtimeException) {
		  if(pJNIEnv->ExceptionOccurred()) {
			pJNIEnv->ExceptionDescribe();
			pJNIEnv->ExceptionClear();
		  }
		  
		  throw runtimeException;
		}
		catch(Exception & exception) {
		  if(pJNIEnv->ExceptionOccurred()) {
			pJNIEnv->ExceptionDescribe();
			pJNIEnv->ExceptionClear();
		  }
		  
		  throw exception;
		}

//  		xJavaThreadRegister_11->revokeThread();
//  		if(!xJavaThreadRegister_11->isThreadAttached())
//  			pJavaVM->DetachCurrentThread();


		//
		// everything is prepared to map an initial object from remote (java) to here
		//
		char buffer[256];
		sprintf(buffer, "java-uno-bridge - mapping: %p", pJava_mapping);

		OUString idStr(OUString::createFromAscii(buffer));

        OUString protocolName(RTL_CONSTASCII_USTRINGPARAM("urp"));
        //OUString protocolName(RTL_CONSTASCII_USTRINGPARAM("remote"));

		OUString dcpStr(RTL_CONSTASCII_USTRINGPARAM("the description string"));
		remote_Context * pRemote_Context = remote_createContext(pRemote_Connection, idStr.pData, dcpStr.pData, protocolName.pData, NULL);	   if(!pRemote_Context) throw RuntimeException(OUString::createFromAscii("error - 48"), Reference<XInterface>());

		uno_Environment * pRemote_Environment = NULL;

		uno_getEnvironment(&pRemote_Environment, protocolName.pData, pRemote_Context);											   if(!pRemote_Environment) throw RuntimeException(OUString::createFromAscii("error - 49"), Reference<XInterface>());



  		OUString remoteO(OUString::createFromAscii(pServiceName));

		typelib_InterfaceTypeDescription *pType = 0;
		getCppuType((Reference <XInterface> *) 0).getDescription((typelib_TypeDescription **) & pType) ;				   if(!pType) throw RuntimeException(OUString::createFromAscii("error - 51"), Reference<XInterface>());

		remote_Interface *pRemoteI = 0;

		  fprintf(stderr, "########################\n");

		pRemote_Context->getRemoteInstance(pRemote_Environment,
										   &pRemoteI,
										   remoteO.pData,
 										   pType->aBase.pWeakRef);																		   if(!pRemoteI) throw RuntimeException(OUString::createFromAscii("error - 52"), Reference<XInterface>());


		Mapping remote_uno(pRemote_Environment, pUNO_Environment, OUString());

		uno_Interface * xInterface = (uno_Interface *)remote_uno.mapInterface(pRemoteI, pType);                            if(!xInterface) throw RuntimeException(OUString::createFromAscii("error - 54"), Reference<XInterface>());

        typelib_InterfaceMemberTypeDescription *pMemberType = 0;		

        {
            typelib_InterfaceTypeDescription *pInterfaceType = 0;
            getCppuType( (Reference < XInterface > *) 0 ).getDescription( 
                (typelib_TypeDescription **) &pInterfaceType );

		    if(pInterfaceType->aBase.bComplete)
		    {
			    typelib_typedescription_complete( (typelib_TypeDescription **) &pInterfaceType );
    		}

//  		    if(0 == pInterfaceType->nMapFunctionIndexToMemberIndex )
//  		    {
//  			    typelib_typedescription_initTables( (typelib_TypeDescription *) pInterfaceType );
//      		}

	    	typelib_typedescriptionreference_getDescription(
		    	(typelib_TypeDescription **) &(pMemberType) ,
			    pInterfaceType->ppAllMembers[0] );

            typelib_typedescription_release( ( typelib_TypeDescription * ) pInterfaceType );
        }


/*        typelib_InterfaceMethodTypeDescription * pMethod = 0;
		{
			typelib_Parameter_Init aParameters[1];
			OUString paraName(RTL_CONSTASCII_USTRINGPARAM("aType"));
			aParameters[0].pParamName = paraName.pData;
			aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_TYPE;
			OUString typeName(RTL_CONSTASCII_USTRINGPARAM("type"));
			aParameters[0].pTypeName = typeName.pData;
			aParameters[0].bIn = sal_True;
			aParameters[0].bOut = sal_False;

			OUString runtimeException(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));
			rtl_uString * pExceptions[1];
			pExceptions[0] = runtimeException.pData;

			OUString methodName(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface::queryInterface"));
			OUString any(RTL_CONSTASCII_USTRINGPARAM("any"));
			typelib_typedescription_newInterfaceMethod( &pMethod,
														0, sal_False,
														methodName.pData, 
														(typelib_TypeClass)::com::sun::star::uno::TypeClass_ANY, any.pData,
														1, aParameters,
														1, pExceptions );
			typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
		}
*/

		void * args[] = {&pInterface_Type};

		uno_Any any = {NULL, NULL};
			
		uno_Any exc;
		uno_Any * pExc = &exc;
			
		xInterface->pDispatcher(xInterface, 
								(typelib_TypeDescription *)pMemberType, 
								&any, 
								(void **)&args, 
								&pExc);

        typelib_typedescription_release( (typelib_TypeDescription *) pMemberType );

  		// important: release what we got
		xInterface->release(xInterface);
		pRemoteI->release(pRemoteI);
  		pRemote_Context->aBase.release(reinterpret_cast<uno_Context *>(pRemote_Context));


		pJava_mapping->_pMapper = *(uno_Interface **)any.pData;
	}

	void SAL_CALL java_Mapping_acquire(uno_Mapping * pUno_mapping) 
	{
		java_Mapping * pJava_mapping = (java_Mapping *)pUno_mapping;

		++ pJava_mapping->_refCount;
	}

	void SAL_CALL java_Mapping_release(uno_Mapping * pUno_mapping)
	{
//  		java_Mapping * pJava_mapping = (java_Mapping *)pUno_mapping;

//  		-- pJava_mapping->_refCount;
//  		if(!pJava_mapping->_refCount)
//  		{
//  			pJava_mapping->_pMapper->release(pJava_mapping->_pMapper);

//  			uno_revokeMapping(pUno_mapping);
//  		}
	}

	void SAL_CALL java_Mapping_free(uno_Mapping * pUno_mapping)
	{
		free(pUno_mapping);
	}


	static const OUString exception(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.Exception"));
	static const OUString runtimeException(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.RuntimeException"));

	/**
	 * maps an interface from java jni (jobject) to binary uno
	 */
	void SAL_CALL java_Mapping_mapInterface_from(uno_Mapping * pMapping,
												 void ** ppOut, 
												 void * pInterface,
												 typelib_InterfaceTypeDescription * pInterfaceTypeDescr)
	{
		java_Mapping * java_mapping = (java_Mapping *)pMapping;
			
		typelib_InterfaceMethodTypeDescription * pMethod = 0;
		{
			typelib_Parameter_Init aParameters[2];
			const OUString paraName(RTL_CONSTASCII_USTRINGPARAM("objectId"));
			aParameters[0].pParamName = paraName.pData;
			aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_LONG;
			const OUString typeName(RTL_CONSTASCII_USTRINGPARAM("long"));
			aParameters[0].pTypeName = typeName.pData;
			aParameters[0].bIn = sal_True;
			aParameters[0].bOut = sal_False;

			OUString paraName2(RTL_CONSTASCII_USTRINGPARAM("typeName"));
			aParameters[1].pParamName = paraName2.pData;
			aParameters[1].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_STRING;
			OUString typeName2(RTL_CONSTASCII_USTRINGPARAM("string"));
			aParameters[1].pTypeName = typeName2.pData;
			aParameters[1].bIn = sal_True;
			aParameters[1].bOut = sal_False;
			rtl_uString * pExceptions[2];

			pExceptions[0] = exception.pData;
			pExceptions[1] = runtimeException.pData;

			OUString methodName(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.java.XJavaMapper::mapIntToObject"));
			OUString interface(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface"));
			typelib_typedescription_newInterfaceMethod( &pMethod,
														3, sal_False,
														methodName.pData,
														(typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE, interface.pData,
														2, aParameters,
														2, pExceptions );
			typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
		}
		

		jobject joObject = (jobject)pInterface;
		OUString className(pInterfaceTypeDescr->aBase.pTypeName);

		void * args[] = {&joObject, &className};

		uno_Any any;
		uno_Any * pAny = &any;

		uno_Any exc;
		uno_Any * pExc = &exc;
			
			
		java_mapping->_pMapper->pDispatcher(java_mapping->_pMapper, 
											(typelib_TypeDescription *)pMethod, 
											ppOut, 
											(void **)&args, 
											&pExc);


	}


	/**
	 * maps an interface from binary uno to java jni (jobject)
	 */
	void SAL_CALL java_Mapping_mapInterface_to(uno_Mapping * pMapping,
											   void ** ppOut, void * pInterface,
											   typelib_InterfaceTypeDescription * pInterfaceTypeDescr)
	{
		java_Mapping * pJava_mapping = (java_Mapping *)pMapping;

		typelib_InterfaceMethodTypeDescription * pMethod = 0;
		{
			typelib_Parameter_Init aParameters[1];

			const OUString paraName(RTL_CONSTASCII_USTRINGPARAM("xInterface"));
			aParameters[0].pParamName = paraName.pData;
			aParameters[0].eTypeClass = (typelib_TypeClass)::com::sun::star::uno::TypeClass_INTERFACE;

			const OUString typeName(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.uno.XInterface"));
			aParameters[0].pTypeName = typeName.pData;
			aParameters[0].bIn = sal_True;
			aParameters[0].bOut = sal_False;

			rtl_uString * pExceptions[2];
			pExceptions[0] = exception.pData;
			pExceptions[1] = runtimeException.pData;


			const OUString methodName(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.java.XJavaMapper::mapObjectToInt"));
			const OUString sLong(RTL_CONSTASCII_USTRINGPARAM("long"));
			typelib_typedescription_newInterfaceMethod( &pMethod,
														4, sal_False,
														methodName.pData,
														(typelib_TypeClass)::com::sun::star::uno::TypeClass_LONG, sLong.pData,
														1, aParameters,
														2, pExceptions );
			typelib_typedescription_register( (typelib_TypeDescription**)&pMethod );
		}

  		void * args[] = {&pInterface};

		sal_Int32 out;

		uno_Any exc;
		uno_Any * pExc = &exc;

		pJava_mapping->_pMapper->pDispatcher(pJava_mapping->_pMapper, 
											 (typelib_TypeDescription *)pMethod, 
											 &out, 
											 (void **)&args, 
											 &pExc);

		*ppOut = (uno_Interface *)out;
	}
}

