/*************************************************************************
 *
 *  $RCSfile: conversion.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:28:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <stdio.h>

#include <bridges/remote/context.h>

#include <bridges/remote/bridgeimpl.hxx>

namespace com { namespace sun {  namespace star { namespace uno {
class Mapping;
}} } }


namespace bridges_remote
{
	class OWriterThread;
	class OReaderThread;
}

struct Mapping;
struct iiop_BridgeImpl : public remote_BridgeImpl
{	
	bridges_remote::OWriterThread *m_pWriter;
	bridges_remote::OReaderThread *m_pReader;
	oslInterlockedCount	m_nRequestId;
	oslCondition m_cndCloseConnectionReceived;
	::osl::Mutex m_mutex;
	FILE *m_pLogFile;
};


namespace bridges_remote {
//  void SAL_CALL convertRemote2Uno( typelib_TypeDescription *pType,
//  								 void **pSourceAndDest,
//  								 ::com::sun::star::uno::Mapping & map );
//  void SAL_CALL convertUno2Remote( typelib_TypeDescription *pType,
//  								 void **pSourceAndDest,
//  								 ::com::sun::star::uno::Mapping & map );

void SAL_CALL dispatchRequestServerSide( void *pThreadSpecificData );
void SAL_CALL sendRequestClientSide(
	uno_Environment * pEnvRemote, 
	typelib_TypeDescription * pMemberType,
	rtl_uString *pOid,
	typelib_InterfaceTypeDescription *pInterfaceType,
	void * pReturn,
	void * pArgs[],
	uno_Any ** ppException );

//  void SAL_CALL dispatchSendQueryInterface(
//  	uno_Environment *pEnvRemote,
//  	remote_Interface **ppRemoteI,
//  	rtl_uString *pOid ,
//  	typelib_InterfaceTypeDescription *pInterfaceType
//  	);
	
//  void SAL_CALL dispatchCreateRemoteStubCallback (
//  	remote_Interface **ppRemoteI,
//  	rtl_uString *pOid ,
//  	rtl_uString *psType,
//  	uno_Environment *pEnvRemote );

inline sal_Bool my_str_equalsWithLength( sal_Char *pString1 , sal_Int32 nLength,
										 sal_Unicode *pString2 , sal_Int32 nLength2 )
{
	
	if( nLength == nLength2 )
	{
		for( sal_Int32 i = nLength -1 ; i >= 0 ; i -- )
		{
			if( ((sal_Unicode)pString1[i]) != pString2[i] )
			{
				return sal_False;
			}
		}
		return sal_True;
	}
	return sal_False;
}


}
