/*************************************************************************
 *
 *  $RCSfile: test.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:28:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include<stdio.h>

#ifdef UNIX
#include <unistd.h>
#endif


#include <jni.h>

#include <uno/environment.h>
#include <uno/dispatcher.h>
#include <uno/mapping.hxx>

#include <com/sun/star/uno/Reference.hxx>

#include <cppuhelper/servicefactory.hxx>

#include <com/sun/star/java/XJavaMapper.hpp>

using namespace ::com::sun::star::java;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::uno;

using namespace ::cppu;

using namespace ::rtl;


extern "C" jint my_vfprintf(FILE *fp, const char *format, va_list args)
{
	return vfprintf(stderr, format, args);
}

char * props[] = {"java.compiler=NONE", NULL};

int SAL_CALL main(void) 
{
	JDK1_1InitArgs vm_args;

	JNI_GetDefaultJavaVMInitArgs(&vm_args); 
	vm_args.debugging = JNI_TRUE;
	vm_args.debugPort = 1199;

	vm_args.properties = props;
	vm_args.vfprintf = my_vfprintf;

	vm_args.classpath = getenv("CLASSPATH");

	fprintf(stderr, "CLASSPATH: %s\n", vm_args.classpath);

	JavaVM *p_vm = NULL;
	JNIEnv *p_env = NULL;

   	JNI_CreateJavaVM(&p_vm, &p_env, &vm_args); 
	fprintf(stderr, "... java vm created vm:%p env:%p\n", p_vm, p_env);
	getchar();

	jclass jcConnector = p_env->FindClass("com/sun/star/comp/connections/Connector");
	jobject joConnector = p_env->AllocObject(jcConnector);




	uno_Environment * pJava_environment = NULL;
	uno_Environment * pUno_environment = NULL;
	
	fprintf(stderr, "get java env and init it with jvm...\n");
	
	OUString sJava(RTL_CONSTASCII_USTRINGPARAM("java"));
	uno_getEnvironment(&pJava_environment, sJava.pData, p_vm);

	OUString sCppu_current_lb_name(RTL_CONSTASCII_USTRINGPARAM(CPPU_CURRENT_LANGUAGE_BINDING_NAME));
  	uno_getEnvironment(&pUno_environment, sCppu_current_lb_name.pData, NULL);

	try 
	{
 		fprintf(stderr, "get curr->java mapping and map an object...\n");
		Mapping curr_java(pUno_environment, pJava_environment);
		
		const char * applicatrdb = getenv("APPLICATRDB");
		OUString osApplicatrdb(OUString::createFromAscii(applicatrdb));
		fprintf(stderr, "Applicat: %s\n", applicatrdb);

		Reference<XMultiServiceFactory> smgr = createRegistryServiceFactory( osApplicatrdb, OUString() );

		Reference<XInterface> xInterface = smgr->createInstance(OUString::createFromAscii("com.sun.star.connection.Connector"));
		fprintf( stderr, "connector : %d\n" , xInterface.is() );
		
		typelib_InterfaceTypeDescription * pXConnector_Type = 0;
		getCppuType((Reference<XInterface> *) 0).getDescription((typelib_TypeDescription **) & pXConnector_Type);
		jobject joConnector_cpp = (jobject)curr_java.mapInterface(xInterface.get(), getCppuType((Reference<XInterface> *) 0));
		
		fprintf(stderr, "object is mapped, now call on it...\n");
		
		
		jclass jcObject = p_env->FindClass("java/lang/Object");
		jmethodID jmObject_hashCode = p_env->GetMethodID(jcObject, "hashCode", "()I");
		jint jiHash = p_env->CallIntMethod(joConnector_cpp, jmObject_hashCode);
		
		fprintf(stderr, "hash value of jni object is: hash:%i p:%p\n", jiHash, joConnector_cpp);
	}
	catch(Exception & exception) {
		OString message(OUStringToOString(exception.Message, RTL_TEXTENCODING_ASCII_US));

		fprintf(stderr, "exception: %s\n", message.getStr());
	}

	{
		fprintf(stderr, "get java->curr mapping and map an object...\n");
		Mapping java_curr(pJava_environment, pUno_environment);
		
		typelib_InterfaceTypeDescription * pType = 0;
		getCppuType((Reference<XJavaMapper> *) 0).getDescription((typelib_TypeDescription **) & pType);
		
		XInterface * xConnector = (XInterface *)java_curr.mapInterface(joConnector, pType);
		
		fprintf(stderr, "object is mapped, now call on it...\n", xConnector);
		xConnector->queryInterface(getCppuType((Reference<XJavaMapper> *)0));
		fprintf(stderr, "... ok\n", xConnector);
	}

//  	p_vm->DestroyJavaVM();

   	_exit(0);
		
	return 0;
}
