/*************************************************************************
 *
 *  $RCSfile: provider.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/**************************************************************************
								TODO
 **************************************************************************

 *************************************************************************/

#ifndef __STL_USE_NEWALLOC
#define __STL_USE_NEWALLOC 1
#endif
#ifndef __HASH_MAP__
#include <stl/hash_map>
#endif

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTCREATIONNOTIFIER_HPP_
#include <com/sun/star/ucb/XContentCreationNotifier.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XPROPERTYSETREGISTRYFACTORY_HPP_
#include <com/sun/star/ucb/XPropertySetRegistryFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONFIGMANAGER_HPP_
#include <com/sun/star/frame/XConfigManager.hpp>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#include "provider.hxx"

#ifndef _CONTENT_HXX
#include "content.hxx"
#endif
#ifndef _ID_HXX
#include "id.hxx"
#endif

#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTSYS_HXX
#include "cntsys.hxx"
#endif
#ifndef _CNTVNODE_HXX /* CntViewBase */
#include "cntvnode.hxx"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif

using namespace rtl;
using namespace cppu;
using namespace com::sun::star::beans;
using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace com::sun::star::registry;
using namespace com::sun::star::ucb;
using namespace com::sun::star::frame;

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#define PROPSET_REGISTRY_FILE_NAME "dynprops.rdb"

//=========================================================================
//
// ContentMap_Impl.
//
//=========================================================================

struct equalString_Impl
{
	bool operator()( const OUString& rKey11, const OUString& rKey22 ) const
  	{
  		return !!( rKey11 == rKey22 );
  	}
};

struct hashString_Impl
{
	size_t operator()( const OUString & rName ) const
	{
		return rName.hashCode();
	}
};

//=========================================================================
typedef NAMESPACE_STD( hash_map )
<
	OUString,
	ChaosContent*,
	hashString_Impl,
	equalString_Impl
>
ContentMap_Impl;

//=========================================================================
//
// class Contents_Impl.
//
//=========================================================================

// This is here to get a working forward declaration in provider.hxx!
class Contents_Impl : public ContentMap_Impl {};

//=========================================================================
//=========================================================================
//
// ChaosContentProvider Implementation.
//
//=========================================================================
//=========================================================================

ChaosContentProvider::ChaosContentProvider(
						const Reference< XMultiServiceFactory >& rXSMgr )
: m_xSMgr( rXSMgr ),
  m_pContents( new Contents_Impl )
{
	// Pass Service Manager to CHAOS.
	CntRootNodeMgr::setProcessServiceManager( rXSMgr );

	// Initialize CHAOS.
	CntSystem::Initialize();
}

//=========================================================================
// virtual
ChaosContentProvider::~ChaosContentProvider()
{
	// Deinitialize CHAOS.
	CntSystem::Deinitialize();

	delete m_pContents;
}

//=========================================================================
//
// XInterface methods.
//
//=========================================================================

XINTERFACE_IMPL_7( ChaosContentProvider,
				   XTypeProvider,
				   XServiceInfo,
				   XEventListener,
				   XContentProvider,
				   XContentIdentifierFactory,
				   XContentCreator,
				   XChaosURLManager );

//=========================================================================
//
// XTypeProvider methods.
//
//=========================================================================

XTYPEPROVIDER_IMPL_7( ChaosContentProvider,
				   	  XTypeProvider,
				   	  XServiceInfo,
					  XEventListener,
				   	  XContentProvider,
				   	  XContentIdentifierFactory,
				   	  XContentCreator,
					  XChaosURLManager );

//=========================================================================
//
// XServiceInfo methods.
//
//=========================================================================

#if 0

	// Problem: This code must be callable from Office-setup, where CHAOS
	//          is not fully functional, because of missing configuration
	//          data.

XSERVICEINFO_IMPL_0( ChaosContentProvider,
					 OUString::createFromAscii( "ChaosContentProvider" ) )
{
	sal_Bool bRet = CntSystem::Initialize();

	if ( !bRet )
	{
		DBG_ERROR( "ChaosContentProvider::getSupportedServiceNames_Static() "
				   "- CHAOS not initialized!" );
	}

	ULONG nCount = bRet ? CNT_RNM()->FactoryCount() : 0;

	OUString* pNames = new OUString[ nCount + 1 ];

	// Static service name.
	pNames[ 0 ] =
		OUString::createFromAscii( "com.sun.star.ucb.ChaosContentProvider" );

	ULONG nArrPos = 1;

	// Dynamic service names according to CHAOS services.
	for ( ULONG n = 0; n < nCount; ++n )
	{
		CntNodeFactory* pFac = CNT_RNM()->GetFactory( n );

		// Filter out internal factories.
		if ( !pFac->GetId() )
			continue;

		UniString aScheme( pFac->GetExternalScheme() );
		aScheme.SearchAndReplace( INET_VENDOR_SCHEME_PREFIX, "" );

		if ( !aScheme.Len() )
			continue;

		UniString aService( "com.sun.star.ucb." );
		aService += aScheme.Copy( 0, aScheme.Len() - 1 );

		UniString aWild( pFac->GetWildCard() );
		if ( aWild.GetChar( aWild.Len() - 1 ) != '*' )
		{
			// To avoid duplicates ( "file:///*" <-> "file:///*.sdb" )
			xub_StrLen nTokens = aWild.GetTokenCount( '*' );
			if ( nTokens )
			{
				UniString aTrailer( aWild.GetToken( nTokens - 1 , '*' ) );
				if ( aTrailer.Len() )
				{
					if ( aTrailer.GetChar( 0 ) != '.' )
						aTrailer.Insert( '.', 0 );

					aService += aTrailer;
				}
			}
		}

		pNames[ nArrPos ] = aService;
		nArrPos++;
	}

	Sequence< OUString > aSNS( pNames, nArrPos );
	delete [] pNames;

	CntSystem::Deinitialize();

	return aSNS;
}

#else

XSERVICEINFO_IMPL_1( ChaosContentProvider,
					 OUString::createFromAscii(
					 			"ChaosContentProvider" ),
					 OUString::createFromAscii(
						 		"com.sun.star.ucb.ChaosContentProvider" ) );

#endif

//=========================================================================
//
// Service factory implementation.
//
//=========================================================================

ONE_INSTANCE_SERVICE_FACTORY_IMPL( ChaosContentProvider );

//=========================================================================
//
// XEventListener methods.
//
//=========================================================================

// virtual
void SAL_CALL ChaosContentProvider::disposing( const EventObject& Source )
	throw( RuntimeException )
{
	if ( Source.Source == m_xBroker )
	{
		// Release UCB. UCB holds a reference on 'this' and 'this' holds
		// a reference on UCB ( cyclic reference )!
		m_xBroker.clear();
	}
}

//=========================================================================
//
// XContentProvider methods.
//
//=========================================================================

// virtual
Reference< XContent > SAL_CALL ChaosContentProvider::queryContent(
						const Reference< XContentIdentifier >& Identifier )
	throw( IllegalIdentifierException, RuntimeException )
{
	return queryContent_Impl( Identifier, NULL, NULL );
}

//=========================================================================
// virtual
sal_Int32 SAL_CALL ChaosContentProvider::compareContentIds(
								const Reference< XContentIdentifier >& Id1,
								const Reference< XContentIdentifier >& Id2 )
	throw( RuntimeException )
{
	// Try to get CHAOS-View-URL's from the identifiers - otherwise
	// take content identifier strings.

	OUString aURL1;

	Reference< XViewIdentifier > xViewId1( Id1, UNO_QUERY );
	if ( xViewId1.is() )
		aURL1 = xViewId1->getViewURL( sal_False );
	else
		aURL1 = Id1->getContentIdentifier();

	OUString aURL2;

	Reference< XViewIdentifier > xViewId2( Id2, UNO_QUERY );
	if ( xViewId2.is() )
		aURL2 = xViewId2->getViewURL( sal_False );
	else
		aURL2 = Id2->getContentIdentifier();

	// Compare the two strings...
	return aURL1.compareTo( aURL2 );;
}

//=========================================================================
//
// XContentIdentifierFactory methods.
//
//=========================================================================

// virtual
Reference< XContentIdentifier > SAL_CALL
		ChaosContentProvider::createContentIdentifier(
											const OUString& ContentId )
	throw( RuntimeException )
{
	// Hier kein weiterer Check des strings. Im Normalfall hat der UCB
	// "this" schon anhand des provider schemes selektiert.

	return Reference< XContentIdentifier >(
						new ChaosContentIdentifier( m_xSMgr, ContentId ) );
}

//=========================================================================
//
// XContentCreator methods.
//
//=========================================================================

// virtual
Sequence< ContentInfo > SAL_CALL
		ChaosContentProvider::queryCreatableContentsInfo()
	throw( RuntimeException )
{
	const CntItemListItem& rListItem =
				(const CntItemListItem&)CntSystem::Get( WID_CREATE_NEW );

	USHORT nCount = rListItem.Count();
	if ( !nCount )
		return Sequence< ContentInfo >();

	Sequence< ContentInfo > aSeq( nCount );

	for ( USHORT n = 0; n < nCount; ++n )
	{
		ContentInfo& rInfo = aSeq.getArray()[ n ];

		const CntItemListItem& rCurr =
						(const CntItemListItem&)(rListItem)[ n ];

		const INetContentType eType = (const INetContentType)
				ITEM_VALUE( CntUInt16Item, *rCurr.Get( WID_FACTORY_NO ) );
		UniString aType( INetContentTypes::GetContentType( eType ) );

		// Transform internal ".chaos" type prefix to official vendor scheme.
		aType.SearchAndReplace(
				UniString::CreateFromAscii(
					RTL_CONSTASCII_STRINGPARAM( CHAOS_TYPE_PREFIX ) ),
				UniString::CreateFromAscii(
					RTL_CONSTASCII_STRINGPARAM( APP_VENDOR_TYPE_PREFIX ) ) );

		rInfo.Type = aType;

		if ( ITEM_VALUE( CntUInt16Item, *rCurr.Get( WID_CREATION_FLAGS ) )
				& CNT_CREATION_FLAG_TITLE )
		{
			Sequence< Property > aProps( 1 );
			aProps.getArray()[ 0 ] = Property(
										OUString::createFromAscii( "Title" ),
										WID_TITLE,
										getCppuType(
											static_cast<
												const rtl::OUString * >( 0 ) ),
										PropertyAttribute::BOUND
										| PropertyAttribute::MAYBEVOID
										| PropertyAttribute::MAYBEDEFAULT );
			rInfo.Properties = aProps;
		}

		rInfo.Attributes = 0;
	}

	return aSeq;
}

//=========================================================================
// virtual
Reference< XContent > SAL_CALL
		ChaosContentProvider::createNewContent(	const ContentInfo& Info )
	throw( RuntimeException )
{
	if ( !Info.Type.getLength() )
		return Reference< XContent >();

	// Get WID_CREATE_NEW item corresponding to Info.Type...

	const CntItemListItem* pItem = NULL;
	const CntItemListItem& rListItem =
				(const CntItemListItem&)CntSystem::Get( WID_CREATE_NEW );

	// Transform official vendor scheme prefix to internal ".chaos" type.
	UniString aType( Info.Type );
	aType.SearchAndReplace(
			UniString::CreateFromAscii(
				RTL_CONSTASCII_STRINGPARAM( APP_VENDOR_TYPE_PREFIX ) ),
			UniString::CreateFromAscii(
				RTL_CONSTASCII_STRINGPARAM( CHAOS_TYPE_PREFIX ) ) );

	INetContentType eType = INetContentTypes::GetContentType( aType );

	USHORT nCount = rListItem.Count();
	for( USHORT n = 0; n < nCount; ++n )
	{
		const CntItemListItem& rCurr = (const CntItemListItem&)rListItem[ n ];

		INetContentType eCurrType = (INetContentType)
				ITEM_VALUE( CntUInt16Item, *rCurr.Get( WID_FACTORY_NO ) );

		if ( eCurrType == eType )
		{
			// Gotcha!
			pItem = &rCurr;
			break;
		}

		pItem = NULL;
	}

	if ( !pItem )
		return Reference< XContent >();

	CntAnchorRef xNew( new CntAnchor( NULL, CNT_RNM()->createNew( *pItem ) ) );
	if ( !xNew.Is() || xNew->GetError() )
		return Reference< XContent >();

	return queryContent( NULL, xNew );
}

//=========================================================================
//
// XChaosURLManager methods.
//
//=========================================================================

// virtual
sal_Bool SAL_CALL ChaosContentProvider::isViewURL( const OUString& URL )
	throw( RuntimeException )
{
	return CntAnchor::IsViewURL( UniString( URL ) );
}

//=========================================================================
// virtual
OUString SAL_CALL ChaosContentProvider::toViewURL(
			const OUString& RootViewURL, const OUString& ServiceURL )
	throw( RuntimeException )
{
	return OUString( UniString( CntAnchor::ToViewURL(
				UniString( RootViewURL ), UniString( ServiceURL ) ) ) );
}

//=========================================================================
// virtual
Reference< XContentIdentifier >
SAL_CALL ChaosContentProvider::queryContentIdentifier( const OUString& URL )
	throw( RuntimeException )
{
	if ( CntViewBase::IsViewURL( UniString( URL ) ) )
	{
		return Reference< XContentIdentifier >(
							new ChaosContentIdentifier( m_xSMgr, URL ) );
	}

	// No View-URL.
	return Reference< XContentIdentifier >();
}

//=========================================================================
// virtual
sal_Bool SAL_CALL ChaosContentProvider::toServiceURL( OUString& URL )
	throw( RuntimeException )
{
	UniString aURL( URL );
	sal_Bool bRet = CntAnchor::ToServiceURL( aURL );
	URL = aURL;
	return bRet;
}

//=========================================================================
// virtual
sal_Bool SAL_CALL ChaosContentProvider::toPresentationURL( OUString& URL )
	throw( RuntimeException )
{
	UniString aURL( URL );
	sal_Bool bRet = CntAnchor::ToPresentationURL( aURL );
	URL = aURL;
	return bRet;
}

//=========================================================================
//
// Non-Interface methods.
//
//=========================================================================

Reference< XContentProviderManager > ChaosContentProvider::getBroker()
{
	if ( !m_xBroker.is() )
	{
		//@@@ The broker service should be created using
		// createInstanceWithArguments(), specifing whether and how the
		// broker should be configured.  Not supplying these arguments implies
		// that the broker service must already be instantiated and configured
		// when this call is made:
		m_xBroker = Reference< XContentProviderManager >(
			m_xSMgr->createInstance(
				OUString::createFromAscii(
					"com.sun.star.ucb.UniversalContentBroker" ) ), UNO_QUERY );

		DBG_ASSERT( m_xBroker.is(),
					"ChaosContentProvider::getBroker - No UCB service!" )

		// Holding the broker creates a cyclic reference, because it holds
		// it providers!!! So register self at UCB to get informed if the
		// UCB wishes to be destroyed.
		// See ChaosContentProvider::disposing(...)

		Reference< XComponent > xComponent( m_xBroker, UNO_QUERY );
		if ( xComponent.is() )
			xComponent->addEventListener( this );
	}
	return m_xBroker;
}

//=========================================================================
Reference< XPropertySetRegistry > ChaosContentProvider::getPropertySetRegistry()
{
	if ( !m_xPropsReg.is() )
	{
		Reference< XPropertySetRegistryFactory > xRegFac(
				m_xSMgr->createInstance(
					OUString::createFromAscii( "com.sun.star.ucb.Store" ) ),
				UNO_QUERY );

		DBG_ASSERT( xRegFac.is(),
					"ChaosContentProvider::getPropertySetRegistry - "
					"No UCB-Store service!" )

		Reference< XSimpleRegistry > xCfgReg(
				m_xSMgr->createInstance(
					OUString::createFromAscii(
							   "com.sun.star.config.SpecialConfigManager" ) ),
				UNO_QUERY );

		DBG_ASSERT( xCfgReg.is(),
					"ChaosContentProvider::getPropertySetRegistry - "
					"No ConfigManager service!" )

		Reference< XConfigManager > xCfgMgr;
		if ( xCfgReg.is() )
			xCfgMgr = Reference< XConfigManager >( xCfgReg, UNO_QUERY );

		DBG_ASSERT( xCfgMgr.is(),
					"ChaosContentProvider::getPropertySetRegistry - "
					"No XConfigManager!" )

		if ( xRegFac.is() && xCfgReg.is() && xCfgMgr.is() )
		{
			OUString aRegURL;

			try
			{
				Reference< XRegistryKey > xRegistryKey(	xCfgReg->getRootKey() );
				if ( xRegistryKey.is() )
					xRegistryKey = xRegistryKey->openKey(
						OUString::createFromAscii( "Directories/Storage-Dir") );

				if ( xRegistryKey.is() )
					aRegURL = xRegistryKey->getStringValue();
			}
			catch ( InvalidRegistryException& )
			{
			}

			aRegURL = xCfgMgr->substituteVariables( aRegURL );

			DBG_ASSERT( aRegURL.getLength(),
						"ChaosContentProvider::getPropertySetRegistry - "
						"Unable to get Store-directory!" )

			if ( aRegURL.getLength() )
			{
				// Convert path to a URL.
				osl::FileBase::normalizePath( aRegURL, aRegURL );
				osl::FileBase::getFileURLFromNormalizedPath( aRegURL, aRegURL );

				OUString aLastChar( aRegURL.copy( aRegURL.getLength() - 1 ) );
				OUString aTmpOWStr = OUString::createFromAscii ( "/" );
				if ( aLastChar != aTmpOWStr )
					aRegURL += aTmpOWStr;

				aRegURL +=
					OUString::createFromAscii( PROPSET_REGISTRY_FILE_NAME );

				// Open/create a registry.
				m_xPropsReg = xRegFac->createPropertySetRegistry( aRegURL );

				DBG_ASSERT( m_xPropsReg.is(),
							"ChaosContentProvider::getPropertySetRegistry - "
							"Error opening registry!" )
			}
		}
	}
	return m_xPropsReg;
}

//=========================================================================
Reference< XContent > ChaosContentProvider::queryContent(
							ChaosContent* pParent, CntAnchor* pAnchor )
	throw( IllegalIdentifierException, RuntimeException )
{
	Reference< XContentIdentifier > xId(
						new ChaosContentIdentifier( m_xSMgr, *pAnchor ) );
	return queryContent_Impl( xId, pParent, pAnchor );
}

//=========================================================================
void ChaosContentProvider::addContent( ChaosContent* pContent )
{
	vos::OGuard aGuard( m_aMutex );

	const OUString aURL( pContent->getAnchor()->GetViewURL( FALSE ) );

#ifdef DBG_UTIL
	Contents_Impl::const_iterator it = m_pContents->find( aURL );
	if ( it != m_pContents->end() )
		DBG_ERROR( "ChaosContentProvider::addContent - Already registered!" );
#endif

	(*m_pContents)[ aURL ] = pContent;
}

//=========================================================================
void ChaosContentProvider::removeContent( ChaosContent* pContent )
{
	vos::OGuard aGuard( m_aMutex );

	const OUString aURL( pContent->getAnchor()->GetViewURL( FALSE ) );
	removeContent( aURL );
}

//=========================================================================
void ChaosContentProvider::removeContent( const OUString& rURL )
{
	vos::OGuard aGuard( m_aMutex );

	Contents_Impl::iterator it = m_pContents->find( rURL );

	DBG_ASSERT( it != m_pContents->end(),
				"ChaosContentProvider::removeContent - Not registered!" );

	if ( it != m_pContents->end() )
		m_pContents->erase( it );
}

//=========================================================================
Reference< XContent > ChaosContentProvider::queryContent_Impl(
								const Reference< XContentIdentifier >& xId,
								ChaosContent* pParent,
								CntAnchor* pAnchor )
	throw( IllegalIdentifierException, RuntimeException )
{
	vos::OGuard aGuard( m_aMutex );

	// Check, if a content with given id already exists...

	OUString aURL;
	Reference< XViewIdentifier > xViewId( xId, UNO_QUERY );
	if ( xViewId.is() )
		aURL = xViewId->getViewURL( sal_False );
	else
		aURL = xId->getContentIdentifier();

	Reference< XContent > xContent;

	Contents_Impl::const_iterator it = m_pContents->find( aURL );
	if ( it != m_pContents->end() )
	{
		// Already there. Return it.
		xContent = (*it).second;
	}
	else
	{
		// Create a new content. Note that the content will insert itself
		// into m_pContents by calling addContent(...) from it's ctor.

		xContent = new ChaosContent( m_xSMgr, this, xId, pParent, pAnchor );

		if ( !xContent->getIdentifier().is() )
			throw IllegalIdentifierException();

		// Let UCB announce the new content.
		Reference< XContentCreationNotifier > xNotifier(
													getBroker(), UNO_QUERY );
		if ( xNotifier.is() )
			xNotifier->fireContentCreationEvent( xContent );
	}

	return xContent;
}

