/*************************************************************************
 *
 *  $RCSfile: tasks.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TASKS_HXX
#define _TASKS_HXX

#ifndef _COM_SUN_STAR_UCB_XPROPERTYTASK_HPP_
#include <com/sun/star/ucb/XPropertyTask.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDTASK_HPP_
#include <com/sun/star/ucb/XCommandTask.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif

#ifndef _CPPUMACS_HXX
#include "cppumacs.hxx"
#endif

namespace com { namespace sun { namespace star {
	namespace beans { struct PropertyChangeEvent;
					  struct Property; }
	namespace ucb 	{ class XResultAcceptor; }
} } }

class ChaosPropertyTaskProxy;

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class ChaosContent;
class ChaosTaskBase;
class ResultSupplier_Impl;

//=========================================================================

class ChaosCommandTask :
				public cppu::OWeakObject,
				public com::sun::star::lang::XTypeProvider,
				public com::sun::star::lang::XComponent,
				public com::sun::star::ucb::XCommandTask,
				public SfxListener
{
	com::sun::star::uno::Reference< com::sun::star::lang::XMultiServiceFactory > m_xSMgr;
	com::sun::star::ucb::Command m_aCommand;
	ChaosTaskBase*				 m_pImpl;
	ResultSupplier_Impl*		 m_pResultSupplier;
	sal_Bool					 m_bSearchCommand;

public:
	ChaosCommandTask(
			const com::sun::star::uno::Reference<
				com::sun::star::lang::XMultiServiceFactory >& rxSMgr,
			ChaosContent* pOwner,
			const com::sun::star::ucb::Command& rCommand,
			const com::sun::star::uno::Reference<
				com::sun::star::ucb::XResultAcceptor >& rxAcceptor,
			const com::sun::star::uno::Reference<
				com::sun::star::ucb::XContentTaskEnvironment >& rxEnv );
	virtual ~ChaosCommandTask();

	// XInterface
	XINTERFACE_DECL()

	// XTypeProvider
	XTYPEPROVIDER_DECL()

	// XComponent
    virtual void SAL_CALL dispose()
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL addEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& Listener )
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL removeEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& Listener )
		throw( com::sun::star::uno::RuntimeException );

	// XCommandTask
    virtual com::sun::star::ucb::Command SAL_CALL
	getCommand()
		throw( com::sun::star::uno::RuntimeException );

	// XContentTask
    virtual void SAL_CALL
	start()
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL
	execute()
		throw( com::sun::star::uno::Exception, com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL
	abort()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::ucb::ContentTaskStatus SAL_CALL
	getStatus()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::ucb::XContentTaskEnvironment > SAL_CALL
	getEnvironment()
		throw( com::sun::star::uno::RuntimeException );

	// SfxListener
	virtual void Notify( SfxBroadcaster& rBC, const SfxHint& rHint );

	// Non-interface nethods
	inline com::sun::star::ucb::Command const & accessCommand() const
	{ return m_aCommand; }
};

//=========================================================================

class ChaosPropertyTask :
				public cppu::OWeakObject,
				public com::sun::star::lang::XTypeProvider,
				public com::sun::star::lang::XComponent,
				public com::sun::star::ucb::XPropertyTask
{
friend class ChaosPropertyTaskProxy;

	com::sun::star::uno::Reference< com::sun::star::lang::XMultiServiceFactory > m_xSMgr;
	com::sun::star::ucb::PropertyTaskType m_eType;
	com::sun::star::uno::Sequence< com::sun::star::ucb::PropertyValueInfo > m_aProps;
	com::sun::star::uno::Sequence< com::sun::star::beans::PropertyValue >* m_pUcbProps;
	ChaosTaskBase*	m_pImpl;

private:
	sal_Bool isChaosProperty( const rtl::OUString& rName,
							  sal_Int32& rHandle );
	sal_Bool isUcbProperty  ( const rtl::OUString& rName,
							  sal_Int32 nHandle,
							  com::sun::star::beans::PropertyValue& rProperty );
	sal_Bool getPropertyValues();
	sal_Bool setPropertyValues( sal_Bool bSynchronous );
	void run( sal_Bool bSynchronous );
    void propertyChange( const com::sun::star::beans::PropertyChangeEvent& evt );

public:
	ChaosPropertyTask(
			const com::sun::star::uno::Reference<
				com::sun::star::lang::XMultiServiceFactory >& rxSMgr,
			ChaosContent* pOwner,
			const com::sun::star::uno::Reference<
				com::sun::star::ucb::XContentTaskEnvironment >& aEnv,
		   	com::sun::star::ucb::PropertyTaskType Type,
			const com::sun::star::uno::Sequence<
				com::sun::star::beans::PropertyValue >& Properties );
	ChaosPropertyTask(
			const com::sun::star::uno::Reference<
				com::sun::star::lang::XMultiServiceFactory >& rxSMgr,
			ChaosContent* pOwner,
			const com::sun::star::uno::Reference<
				com::sun::star::ucb::XContentTaskEnvironment >& aEnv,
			const com::sun::star::uno::Sequence<
				com::sun::star::beans::Property >& Properties );
	ChaosPropertyTask(
			const com::sun::star::uno::Reference<
				com::sun::star::lang::XMultiServiceFactory >& rxSMgr,
			ChaosContent* pOwner,
			const com::sun::star::uno::Reference<
				com::sun::star::ucb::XContentTaskEnvironment >& aEnv,
			com::sun::star::ucb::PropertyTaskType Type,
			const com::sun::star::uno::Sequence< rtl::OUString >& Properties,
			const com::sun::star::uno::Sequence< com::sun::star::uno::Any >& Values );
	virtual ~ChaosPropertyTask();

	// XInterface
	XINTERFACE_DECL()

	// XTypeProvider
	XTYPEPROVIDER_DECL()

	// XComponent
    virtual void SAL_CALL dispose()
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL addEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& Listener )
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL removeEventListener( const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& Listener )
		throw( com::sun::star::uno::RuntimeException );

	// XPropertyTask
    virtual com::sun::star::ucb::PropertyTaskType SAL_CALL
	getType()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Sequence< com::sun::star::ucb::PropertyValueInfo > SAL_CALL
	getProperties()
		throw( com::sun::star::uno::RuntimeException );

	// XContentTask
    virtual void SAL_CALL
	start()
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL
	execute()
		throw( com::sun::star::uno::Exception, com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL
	abort()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::ucb::ContentTaskStatus SAL_CALL
	getStatus()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::ucb::XContentTaskEnvironment > SAL_CALL
	getEnvironment()
		throw( com::sun::star::uno::RuntimeException );
};

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_TASKS_HXX */
