/*************************************************************************
 *
 *  $RCSfile: valueset.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/**************************************************************************
								TODO
 **************************************************************************

 *************************************************************************/

#ifndef _COM_SUN_STAR_SCRIPT_XTYPECONVERTER_HPP_
#include <com/sun/star/script/XTypeConverter.hpp>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#include "valueset.hxx"

using namespace com::sun::star::beans;
using namespace com::sun::star::container;
using namespace com::sun::star::io;
using namespace com::sun::star::lang;
using namespace com::sun::star::script;
using namespace com::sun::star::sdbc;
using namespace com::sun::star::uno;
using namespace com::sun::star::util;
using namespace rtl;

using namespace chaos;

//=========================================================================
//
// Welcome to the macro hell...
//
//=========================================================================

#define GETVALUE_IMPL_TYPE( _type_, _cppu_type_ ) 							\
																			\
	vos::OGuard aGuard( m_aMutex );                                         \
																			\
	_type_ aValue = _type_();	/* default ctor	*/							\
																			\
	if ( ( columnIndex < 1 ) || ( columnIndex > m_aValues.getLength() ) )   \
	{                                                                       \
		DBG_ERROR( "PropertyValueSet - index out of range!" );              \
		m_bPossiblyTheLastValueWasNull = sal_True;                          \
	}                                                                       \
	else                                                                    \
	{                                                                       \
		const Any& rValue                                                   \
					= m_aValues.getConstArray()[ columnIndex - 1 ].Value;	\
		m_bPossiblyTheLastValueWasNull = !( rValue >>= aValue );            \
																			\
		if ( m_bPossiblyTheLastValueWasNull )                               \
		{                                                                   \
			Reference< XTypeConverter > xConverter = getTypeConverter();    \
			if ( xConverter.is() )                                          \
			{                                                               \
				try                                                         \
				{                                                           \
					Any aConvertedValue                                     \
						= xConverter->convertTo( rValue, _cppu_type_ ); 	\
					m_bPossiblyTheLastValueWasNull                          \
										= !( aConvertedValue >>= aValue );	\
				}                                                           \
				catch ( IllegalArgumentException )							\
				{                                                           \
					m_bPossiblyTheLastValueWasNull = sal_True;              \
				}                                                           \
				catch ( CannotConvertException )                            \
				{                                                           \
					m_bPossiblyTheLastValueWasNull = sal_True;              \
				}                                                           \
			}                                                               \
		}                                                                   \
	}																		\
	return aValue;

#define GETVALUE_IMPL( _type_ )												\
	GETVALUE_IMPL_TYPE( _type_,												\
						getCppuType( static_cast< const _type_ * >( 0 ) ) ) \

//=========================================================================
//=========================================================================
//
// PropertyValueSet Implementation.
//
//=========================================================================
//=========================================================================

PropertyValueSet::PropertyValueSet(
					const Reference< XMultiServiceFactory >& rxSMgr,
					const Sequence< PropertyValue >& rValues )
: m_xSMgr( rxSMgr ),
  m_aValues( rValues ),
  m_bPossiblyTheLastValueWasNull( sal_False ),
  m_bTriedToGetTypeConverter( sal_False )
{
}

//=========================================================================
// virtual
PropertyValueSet::~PropertyValueSet()
{
}

//=========================================================================
//
// XInterface methods.
//
//=========================================================================

XINTERFACE_IMPL_3( PropertyValueSet,
				   XTypeProvider,
				   XRow,
				   XColumnLocate );

//=========================================================================
//
// XTypeProvider methods.
//
//=========================================================================

XTYPEPROVIDER_IMPL_3( PropertyValueSet,
					  XTypeProvider,
				   	  XRow,
					  XColumnLocate );

//=========================================================================
//
// XRow methods.
//
//=========================================================================

// virtual
sal_Bool SAL_CALL PropertyValueSet::wasNull()
	throw( SQLException, RuntimeException )
{
	// This method can not be implemented correctly!!! Imagine different
	// threads doing a getXYZ - wasNull calling sequence on the same
	// implementation object...
	return m_bPossiblyTheLastValueWasNull;
}

//=========================================================================
// virtual
OUString SAL_CALL PropertyValueSet::getString( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( OUString );
}

//=========================================================================
// virtual
sal_Bool SAL_CALL PropertyValueSet::getBoolean( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL_TYPE( sal_Bool, getCppuBooleanType() );
}

//=========================================================================
// virtual
sal_Int8 SAL_CALL PropertyValueSet::getByte( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( sal_Int8 );
}

//=========================================================================
// virtual
sal_Int16 SAL_CALL PropertyValueSet::getShort( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( sal_Int16 );
}

//=========================================================================
// virtual
sal_Int32 SAL_CALL PropertyValueSet::getInt( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( sal_Int32 );
}

//=========================================================================
// virtual
sal_Int64 SAL_CALL PropertyValueSet::getLong( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( sal_Int64 );
}

//=========================================================================
// virtual
float SAL_CALL PropertyValueSet::getFloat( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( float );
}

//=========================================================================
// virtual
double SAL_CALL PropertyValueSet::getDouble( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( double );
}

//=========================================================================
// virtual
Sequence< sal_Int8 > SAL_CALL
PropertyValueSet::getBytes( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Sequence< sal_Int8 > );
}

//=========================================================================
// virtual
Date SAL_CALL PropertyValueSet::getDate( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Date );
}

//=========================================================================
// virtual
Time SAL_CALL PropertyValueSet::getTime( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Time );
}

//=========================================================================
// virtual
DateTime SAL_CALL PropertyValueSet::getTimestamp( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( DateTime );
}

//=========================================================================
// virtual
Reference< XInputStream > SAL_CALL
PropertyValueSet::getBinaryStream( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XInputStream > );
}

//=========================================================================
// virtual
Reference< XInputStream > SAL_CALL
PropertyValueSet::getCharacterStream( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XInputStream > );
}

//=========================================================================
// virtual
Any SAL_CALL PropertyValueSet::getObject(
									sal_Int32 columnIndex,
	   				 			 	const Reference< XNameAccess >& typeMap )
	throw( SQLException, RuntimeException )
{
	vos::OGuard aGuard( m_aMutex );

	Any aValue;
	if ( ( columnIndex < 1 ) || ( columnIndex > m_aValues.getLength() ) )
	{
		DBG_ERROR( "PropertyValueSet - index out of range!" );
		m_bPossiblyTheLastValueWasNull = sal_True;
	}
	else
	{
		m_bPossiblyTheLastValueWasNull = sal_False;
		aValue = m_aValues.getConstArray()[ columnIndex - 1 ].Value;
	}

	return aValue;
}

//=========================================================================
// virtual
Reference< XRef > SAL_CALL PropertyValueSet::getRef( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XRef > );
}

//=========================================================================
// virtual
Reference< XBlob > SAL_CALL PropertyValueSet::getBlob( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XBlob > );
}

//=========================================================================
// virtual
Reference< XClob > SAL_CALL PropertyValueSet::getClob( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XClob > );
}

//=========================================================================
// virtual
Reference< XArray > SAL_CALL PropertyValueSet::getArray( sal_Int32 columnIndex )
	throw( SQLException, RuntimeException )
{
	GETVALUE_IMPL( Reference< XArray > );
}

//=========================================================================
//
// XColumnLocate methods.
//
//=========================================================================

// virtual
sal_Int32 SAL_CALL PropertyValueSet::findColumn( const OUString& columnName )
	throw( SQLException, RuntimeException )
{
	vos::OGuard aGuard( m_aMutex );

	if ( columnName.getLength() )
	{
		sal_Int32 nCount = m_aValues.getLength();
		const PropertyValue* pValues = m_aValues.getConstArray();
		for ( sal_Int32 n = 0; n < nCount; ++n )
		{
			if ( pValues[ n ].Name.equals( columnName ) )
				return sal_Int32( n + 1 ); // Index is 1-based.
		}
	}
	return 0;
}

//=========================================================================
//
// Non-instance methods.
//
//=========================================================================

const Reference< XTypeConverter >& PropertyValueSet::getTypeConverter()
{
	vos::OGuard aGuard( m_aMutex );

	if ( !m_bTriedToGetTypeConverter && !m_xTypeConverter.is() )
	{
		m_bTriedToGetTypeConverter = sal_True;
		m_xTypeConverter = Reference< XTypeConverter >(
								m_xSMgr->createInstance(
									OUString::createFromAscii(
										"com.sun.star.script.Converter" ) ),
								UNO_QUERY );

		DBG_ASSERT( m_xTypeConverter.is(),
					"PropertyValueSet::getTypeConverter() - "
					"Service 'com.sun.star.script.Converter' n/a!" );
	}
	return m_xTypeConverter;
}

