/*************************************************************************
 *
 *  $RCSfile: cntreg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:19:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTRNMGR_HXX
#include <cntrnmgr.hxx>
#endif

#ifndef _CNTSTGND_HXX
#include <cntstgnd.hxx>
#endif
#ifndef _CNTVNODE_HXX
#include <cntvnode.hxx>
#endif
#ifndef _CNTHTTP_HXX
#include <cnthttp.hxx>
#endif
#ifndef _CHAOS_IMAP_HXX
#include <imap.hxx>
#endif
#ifndef _CNTNEWS_HXX
#include <cntnews.hxx>
#endif
#ifndef _CNTPOP3_HXX
#include <cntpop3.hxx>
#endif
#ifndef _CNTOUT_HXX
#include <cntout.hxx>
#endif
#ifndef _CNTVIM_HXX
#include <cntvim.hxx>
#endif
#ifndef _CNTNFTP_HXX
#include <cntnftp.hxx>
#endif
#ifndef _CNTSRCHF_HXX
#include <cntsrchf.hxx>
#endif
#ifndef _CNTTRASH_HXX
#include <cnttrash.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//=========================================================================
// Registration of factories
//
// Every node class can define and register own factories in its
// implementation of CNT_NODE_SUBCLASS_IMPL(...) macro. By calling it's
// static method Register() here (which will be automatically generated by
// that macro), the registration of that node factories will be done.
//
//=========================================================================

//----------------------------------------------------------------------------
// static
void CntRootNodeMgr::RegisterFactories()
{
	// Register CHAOS core node factories.

	CntRootStorageNode::Register();
	CntViewStorageNode::Register();
	CntStorageNode::Register();
	CntViewNode::Register();

	// Register service node factories.

	CntHTTPRootNode::Register();
	CntIMAPAcntNode::Register();
	CntIMAPMboxNode::Register();
	CntNewsBoxNode::Register();
	CntNewsGroupNode::Register();
	CntOutTrayNode::Register();
	CntPOP3Node::Register();
	CntVIMNode::Register();
	CntVIMInboxNode::Register();
	CntVIMBBoardBoxNode::Register();
	CntVIMBBoardNode::Register();
	CntFTPBoxNode::Register();
	CntFTPFolderNode::Register();
	CntSearchFolderNode::Register();
	CntSearchFolderLocListNode::Register();
	CntTrashCanNode::Register();
	CntTrashNode::Register();
}

//=========================================================================
// Lazy initialization
//
// This method will be called after lazy init timeout occures. This happens
//	1) once after system initialization and
//	2) always after going "online".
//
//=========================================================================

//----------------------------------------------------------------------------
// static
void CntRootNodeMgr::LazyInitialize()
{
}

