/*************************************************************************
 *
 *  $RCSfile: mbxformt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <limits>

#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef TOOLS_INETMIME_HXX
#include <tools/inetmime.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _CNTRANGE_HXX
#include <cntrange.hxx>
#endif
#ifndef _CNTXREF_HXX
#include <cntxref.hxx>
#endif
#ifndef _ILSTITEM_HXX
#include <ilstitem.hxx>
#endif
#ifndef _CHAOS_MBXFORMT_HXX
#include <mbxformt.hxx>
#endif

#undef max // defined by <tools/solar.h>
#undef min // defined by <tools/solar.h>

namespace unnamed_chaos_mbxformt {} using namespace unnamed_chaos_mbxformt;
	// unnamed namespaces don't work well yet...

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//============================================================================
//
//  CntMBXChars
//
//============================================================================

// static
sal_uInt8 const CntMBXChars::aCharsRFC822[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, QSTR, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		COPN, CCLS, ATOM, ATOM, SPCL, ATOM, SPCL, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, SPCL, SPCL, SPCL, ATOM, SPCL, ATOM, // 89:;<=>?
		SPCL, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, DOPN, ESCP, DCLS, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsMIME[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, QSTR, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		COPN, CCLS, ATOM, ATOM, SPCL, ATOM, ATOM, SPCL, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, SPCL, SPCL, SPCL, SPCL, SPCL, SPCL, // 89:;<=>?
		SPCL, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, DOPN, ESCP, DCLS, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsBoundary[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, ATOM, //  !"#$%&'
		ATOM, ATOM, OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, OTHR, OTHR, ATOM, OTHR, ATOM, // 89:;<=>?
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, ATOM, // XYZ[\]^_
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsBody[256]
	= { ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, POLF, ATOM, ATOM, POCR, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, CTLZ, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsRanges[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, //  !"#$%&'
		COPN, CCLS, OTHR, OTHR, SPCL, SPCL, OTHR, OTHR, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // 89:;<=>?
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // @ABCDEFG
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // HIJKLMNO
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // PQRSTUVW
		OTHR, OTHR, OTHR, OTHR, ESCP, OTHR, OTHR, OTHR, // XYZ[\]^_
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // `abcdefg
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // hijklmno
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // pqrstuvw
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsText[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsSText[256]
	= { ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, LWSP, POLF, ATOM, ATOM, POCR, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, CTLZ, ATOM, ATOM, ATOM, ATOM, ATOM,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, SPCL, ATOM, SPCL, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsEToken[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, OTHR, OTHR, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		OTHR, OTHR, ATOM, ATOM, OTHR, ATOM, OTHR, OTHR, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, OTHR, OTHR, OTHR, SPCL, OTHR, SPCL, // 89:;<=>?
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsEText[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, SPCL, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsRFC822NUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, QSTR, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		COPN, CCLS, ATOM, ATOM, SPCL, ATOM, SPCL, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, SPCL, SPCL, SPCL, ATOM, SPCL, ATOM, // 89:;<=>?
		SPCL, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, DOPN, ESCP, DCLS, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsMIMENUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, QSTR, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		COPN, CCLS, ATOM, ATOM, SPCL, ATOM, ATOM, SPCL, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, SPCL, SPCL, SPCL, SPCL, SPCL, SPCL, // 89:;<=>?
		SPCL, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, DOPN, ESCP, DCLS, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsBoundaryNUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, ATOM, //  !"#$%&'
		ATOM, ATOM, OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, OTHR, OTHR, ATOM, OTHR, ATOM, // 89:;<=>?
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, ATOM, // XYZ[\]^_
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsBodyNUL[256]
	= { ZERO, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, POLF, ATOM, ATOM, POCR, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, CTLZ, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsRangesNUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, //  !"#$%&'
		COPN, CCLS, OTHR, OTHR, SPCL, SPCL, OTHR, OTHR, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // 89:;<=>?
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // @ABCDEFG
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // HIJKLMNO
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // PQRSTUVW
		OTHR, OTHR, OTHR, OTHR, ESCP, OTHR, OTHR, OTHR, // XYZ[\]^_
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // `abcdefg
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // hijklmno
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // pqrstuvw
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsTextNUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsSTextNUL[256]
	= { ZERO, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, LWSP, POLF, ATOM, ATOM, POCR, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, CTLZ, ATOM, ATOM, ATOM, ATOM, ATOM,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, SPCL, ATOM, SPCL, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // xyz{|}~
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM,
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsETokenNUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, OTHR, OTHR, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		OTHR, OTHR, ATOM, ATOM, OTHR, ATOM, OTHR, OTHR, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, OTHR, OTHR, OTHR, SPCL, OTHR, SPCL, // 89:;<=>?
		OTHR, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, OTHR, OTHR, OTHR, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsETextNUL[256]
	= { ZERO, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, LWSP, POLF, OTHR, OTHR, POCR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		LWSP, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, //  !"#$%&'
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // ()*+,-./
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // 01234567
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, SPCL, // 89:;<=>?
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // @ABCDEFG
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // HIJKLMNO
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // PQRSTUVW
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // XYZ[\]^_
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // `abcdefg
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // hijklmno
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, // pqrstuvw
		ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, ATOM, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
// static
sal_uInt8 const CntMBXChars::aCharsPlain[256]
	= { OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, CTLZ, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, //  !"#$%&'
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // ()*+,-./
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // 01234567
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // 89:;<=>?
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // @ABCDEFG
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // HIJKLMNO
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // PQRSTUVW
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // XYZ[\]^_
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // `abcdefg
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // hijklmno
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // pqrstuvw
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, // xyz{|}~
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR,
		OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR, OTHR };

//============================================================================
//
//  CntMBXAtom
//
//============================================================================

CntMBXAtom::~CntMBXAtom()
{
	delete m_pLeft;
	delete m_pRight;
}

//============================================================================
//
//  CntMBXAtomTable
//
//============================================================================

CntMBXAtom const & CntMBXAtomTable::insert(ByteString const & rName,
										   ByteString const & rCanonic,
										   sal_uInt32 nKey)
{
	CntMBXAtom ** pAtom = &m_pRoot;
	while (*pAtom)
		if ((*pAtom)->m_aName == rName)
		{
			DBG_ASSERT(nKey == DYNAMIC_KEY || nKey == (*pAtom)->m_nKey,
					   "CntMBXAtomTable::insert(): Equal names & diff keys");
			return **pAtom;
		}
		else
			pAtom = rName < (*pAtom)->m_aName ? &(*pAtom)->m_pLeft :
		                                        &(*pAtom)->m_pRight;
	*pAtom = new CntMBXAtom(rName, rCanonic, nKey);
	return **pAtom;
}

//============================================================================
CntMBXAtomTable::CntMBXAtomTable(): m_pRoot(0)
{
	insert("base64", "base64", ATOM_BASE64);
	insert("bcc", "bcc", ATOM_BCC);
	insert("cc", "cc", ATOM_CC);
	insert("chaos", "CHAOS", ATOM_CHAOS);
	insert("comments", "Comments", ATOM_COMMENTS);
	insert("completely-locally-sent", "Completely-Locally-Sent",
		   ATOM_COMPLETELY_LOCALLY_SENT);
	insert("confirmed", "Confirmed", ATOM_CONFIRMED);
	insert("content-base", "Content-Base", ATOM_CONTENT_BASE);
	insert("content-description", "Content-Description",
		   ATOM_CONTENT_DESCRIPTION);
	insert("content-disposition", "Content-Disposition",
		   ATOM_CONTENT_DISPOSITION);
	insert("content-id", "Content-ID", ATOM_CONTENT_ID);
	insert("content-location", "Content-Location", ATOM_CONTENT_LOCATION);
	insert("content-transfer-encoding", "Content-Transfer-Encoding",
		   ATOM_CONTENT_TRANSFER_ENCODING);
	insert("content-type", "Content-Type", ATOM_CONTENT_TYPE);
	insert("copy", "COPY", ATOM_COPY);
	insert("date", "Date", ATOM_DATE);
	insert("external-error", "External-Error", ATOM_EXTERNAL_ERROR);
	insert("from", "From", ATOM_FROM);
	insert("group", "Group", ATOM_GROUP);
	insert("hidden", "hidden", ATOM_HIDDEN);
	insert("in-reply-to", "In-Reply-To", ATOM_IN_REPLY_TO);
	insert("keywords", "Keywords", ATOM_KEYWORDS);
	insert("mapi", "MAPI", ATOM_MAPI);
	insert("marked", "Marked", ATOM_MARKED);
	insert("mbox", "MBOX", ATOM_MBOX);
	insert("message", "message", ATOM_MESSAGE);
	insert("message-id", "Message-ID", ATOM_MESSAGE_ID);
	insert("messagebox", "messagebox", ATOM_MESSAGEBOX);
	insert("mime-version", "MIME-Version", ATOM_MIME_VERSION);
	insert("news", "News", ATOM_NEWS);
	insert("newsbox", "newsbox", ATOM_NEWSBOX);
	insert("newsgroups", "Newsgroups", ATOM_NEWSGROUPS);
	insert("nntp", "NNTP", ATOM_NNTP);
	insert("no", "no", ATOM_NO);
	insert("nonrecoverable-local-error", "Nonrecoverable-Local-Error",
		   ATOM_NONRECOVERABLE_LOCAL_ERROR);
	insert("partially-locally-sent", "Partially-Locally-Sent",
		   ATOM_PARTIALLY_LOCALLY_SENT);
	insert("password", "Password", ATOM_PASSWORD);
	insert("protocol", "Protocol", ATOM_PROTOCOL);
	insert("quoted-printable", "quoted-printable", ATOM_QUOTED_PRINTABLE);
	insert("read", "Read", ATOM_READ);
	insert("received", "Received", ATOM_RECEIVED);
	insert("recoverable-local-error", "Recoverable-Local-Error",
		   ATOM_RECOVERABLE_LOCAL_ERROR);
	insert("references", "References", ATOM_REFERENCES);
	insert("reply", "Reply", ATOM_REPLY);
	insert("reply-code", "Reply-Code", ATOM_REPLY_CODE);
	insert("reply-to", "Reply-To", ATOM_REPLY_TO);
	insert("return-path", "Return-path", ATOM_RETURN_PATH);
	insert("sender", "Sender", ATOM_SENDER);
	insert("server", "Server", ATOM_SERVER);
	insert("smtp", "SMTP", ATOM_SMTP);
	insert("state", "State", ATOM_STATE);
	insert("subject", "Subject", ATOM_SUBJECT);
	insert("subscribed", "Subscribed", ATOM_SUBSCRIBED);
	insert("to", "To", ATOM_TO);
	insert("tries", "Tries", ATOM_TRIES);
	insert("user", "User", ATOM_USER);
	insert("vim", "VIM", ATOM_VIM);
	insert("waiting-confirmation", "Waiting-Confirmation",
		   ATOM_WAITING_CONFIRMATION);
	insert("written", "Written", ATOM_WRITTEN);
	insert("x-chaos-marked", "X-CHAOS-Marked", ATOM_X_CHAOS_MARKED);
	insert("x-chaos-read", "X-CHAOS-Read", ATOM_X_CHAOS_READ);
	insert("x-chaos-recipients", "X-CHAOS-Recipients",
		   ATOM_X_CHAOS_RECIPIENTS);
	insert("x-chaos-size", "X-CHAOS-Size", ATOM_X_CHAOS_SIZE);
	insert("x-mailer", "X-Mailer", ATOM_X_MAILER);
	insert("x-mozilla-status", "X-Mozilla-Status", ATOM_X_MOZILLA_STATUS);
	insert("x-priority", "X-Priority", ATOM_X_PRIORITY);
	insert("xref", "Xref", ATOM_XREF);
	insert("yes", "yes", ATOM_YES);
}

//============================================================================
//
//  CntMBXScanner
//
//============================================================================

inline ErrCode CntMBXScanner::seekBack(ULONG nPos)
{
	ULONG nNewBufferStart;
	ULONG nNewBufferLen;
	ErrCode nError = seek(nPos, nNewBufferStart, nNewBufferLen);
	if (nError != ERRCODE_NONE)
		return nError;
	m_nBufferStart = nNewBufferStart;
	m_pBufferPointer = m_pBuffer + (nPos - m_nBufferStart);
	m_pBufferEnd = m_pBuffer + nNewBufferLen;
	return ERRCODE_NONE;
}

//============================================================================
ErrCode CntMBXScanner::checkBodyEnd(ULONG nOffset)
{
	if (m_eSourceFormat != FORMAT_OUTLOOK_EXPRESS)
	{
		static sal_Char const aFrom1[5] = { 'F', 'R', 'O', 'M', '\t' };
		static sal_Char const aFrom2[5] = { 'f', 'r', 'o', 'm', ' ' };
		for (int i = 0; i < 5; ++i)
			if (m_pBufferPointer + nOffset + i < m_pBufferEnd)
			{
				if (m_pBufferPointer[nOffset + i] != aFrom1[i]
					&& m_pBufferPointer[nOffset + i] != aFrom2[i])
					return ERRCODE_NONE;
			}
			else
			{
				ByteString aText;
				ErrCode nError = readBlock(m_nBufferStart
										       + (m_pBufferEnd - m_pBuffer),
										   5 - i, aText, false);
				if (nError != ERRCODE_NONE)
					return nError;
				if (aText.Len() < 5 - i)
					return ERRCODE_NONE;
				sal_Char const * pTextChar = aText.GetBuffer();
				for (; i < 5; ++i)
				{
					if (*pTextChar != aFrom1[i] && *pTextChar != aFrom2[i])
						return ERRCODE_NONE;
					++pTextChar;
				}
			}
		m_nScanBodyEnd = m_nBufferStart + (m_pBufferPointer - m_pBuffer)
			                 + nOffset;
		setScanBodyBufferEnd();
	}
	return ERRCODE_NONE;
}

//============================================================================
void CntMBXScanner::setBodyEnd()
{
	m_nScanBodyEnd = m_nBufferStart + (m_pBufferPointer - m_pBuffer);
	setScanBodyBufferEnd();
}

//============================================================================
void CntMBXScanner::deinit()
{
	while (m_nSavedTokenCount-- != 0)
	{
		removeMark(m_nSavedTokenStart[m_nStackBottom]);
		m_nStackBottom = (m_nStackBottom + 1) % MAX_BACK_UP;
	}
}

//============================================================================
ErrCode CntMBXScanner::determineSourceFormat(SourceFormat & rFormat)
{
	if (!m_bSourceFormatDetermined)
	{
		ByteString aTag;
		ErrCode nError = readBlock(0, 4, aTag, true);
		if (nError != ERRCODE_NONE)
			return nError;

		m_bSourceFormatDetermined = true;
		m_eSourceFormat = aTag == "JMF6" ? FORMAT_OUTLOOK_EXPRESS :
			                               FORMAT_GENERAL;
	}

	rFormat = m_eSourceFormat;
	return ERRCODE_NONE;
}

//============================================================================
ErrCode CntMBXScanner::scan(CntMBXToken & rToken, CntMBXAtomTable & rTable,
							sal_uInt8 const * pChars, ScanMode eMode,
							ScanBodyMode eScanBody)
{
	bool bMark;
	if (m_nBackedTokenCount)
	{
		int nBackedPos = (m_nStackBottom
						         + (m_nSavedTokenCount - m_nBackedTokenCount))
			                 % MAX_BACK_UP;

		if (eScanBody != SCAN_BODY_INIT
			&& m_pSavedTokenAtomTable[nBackedPos] == &rTable
			&& m_pSavedTokenChars[nBackedPos] == pChars
			&& m_eSavedTokenMode[nBackedPos] == eMode)
		{
			rToken = m_aSavedToken[nBackedPos];
			--m_nBackedTokenCount;
			return ERRCODE_NONE;
		}

		ErrCode nError = seekBack(m_nSavedTokenStart[nBackedPos]);
		if (nError != ERRCODE_NONE)
			return nError;
		m_nSavedTokenCount -= m_nBackedTokenCount;
		while (--m_nBackedTokenCount)
		{
			nBackedPos = (nBackedPos + 1) % MAX_BACK_UP;
			removeMark(m_nSavedTokenStart[nBackedPos]);
		}
		bMark = false;
	}
	else
		bMark = true;

	ULONG nScanStart = m_nBufferStart + (m_pBufferPointer - m_pBuffer);
	if (bMark)
		addMark(nScanStart);

	enum State { STATE_INIT, STATE_LWSP, STATE_LWSP_PRCR, STATE_LWSP_POCR,
				 STATE_LWSP_CRLF, STATE_ATOM, STATE_QSTR, STATE_QSTR_ESCP,
				 STATE_QSTR_ESCP_CTLZ, STATE_QSTR_PRCR, STATE_QSTR_POCR,
				 STATE_QSTR_CRLF, STATE_QSTR_CTLZ, STATE_DOPN,
				 STATE_DOPN_ESCP, STATE_DOPN_ESCP_CTLZ, STATE_DOPN_PRCR,
				 STATE_DOPN_POCR, STATE_DOPN_CRLF, STATE_DOPN_CTLZ,
				 STATE_COPN, STATE_COPN_ESCP, STATE_COPN_ESCP_CTLZ,
				 STATE_COPN_PRCR, STATE_COPN_POCR, STATE_COPN_CRLF,
				 STATE_COPN_CTLZ, STATE_PRCR, STATE_POCR, STATE_CRLF,
				 STATE_CTLZ };

	ULONG nTokenStart;
	ULONG nInnerStart;
	ByteString aCanonic;
	bool bBroken = false;
	sal_Char cTemp;
	ULONG nLevel = 0;
	ErrCode nError = ERRCODE_NONE;
	for (State eState = STATE_INIT;;)
	{
		if (m_pBufferPointer >= m_pBufferEnd)
		{
			ULONG nNewBufferStart = m_nBufferStart
				                        + (m_pBufferEnd - m_pBuffer);
			ULONG nNewBufferLen;
			nError = readBuffer(nNewBufferStart, nNewBufferLen);
			if (nError != ERRCODE_NONE)
				goto done;
			m_nBufferStart = nNewBufferStart;
			m_pBufferPointer = m_pBuffer;
			m_pBufferEnd = m_pBuffer + nNewBufferLen;
			if (m_nScanBodyEnd != ULONG(-1))
				setScanBodyBufferEnd();
		}

		switch (eState)
		{
			case STATE_INIT:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_LWSP)
							aCanonic = *m_pBufferPointer;
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_LWSP;
						break;

					case CntMBXChars::SPCL:
					case CntMBXChars::DCLS:
					case CntMBXChars::CCLS:
					case CntMBXChars::ESCP:
						rToken = CntMBXToken(CntMBXToken::TYPE_SPECIAL,
											 *m_pBufferPointer++);
						goto done;

					case CntMBXChars::ATOM:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_ATOM;
						break;

					case CntMBXChars::QSTR:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						if (eMode & CANONIC_QSTR)
							aCanonic.Erase();
						eState = STATE_QSTR;
						break;

					case CntMBXChars::DOPN:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic.Erase();
						eState = STATE_DOPN;
						break;

					case CntMBXChars::COPN:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer - m_pBuffer);
						++m_pBufferPointer;
						eState = STATE_COPN;
						break;

					case CntMBXChars::PRCR:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_PRCR;
						break;

					case CntMBXChars::PRLF:
					case CntMBXChars::OTHR:
						rToken = CntMBXToken(CntMBXToken::TYPE_OTHER,
											 *m_pBufferPointer++);
						goto done;

					case CntMBXChars::POCR:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_POCR;
						break;

					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						if (eMode & FOLDED_LWSP)
						{
							nTokenStart = m_nBufferStart
								              + (m_pBufferPointer++
												     - m_pBuffer);
							eState = STATE_CRLF;
						}
						else
						{
							rToken = CntMBXToken(CntMBXToken::TYPE_CRLF,
												 *m_pBufferPointer++);
							if (eScanBody != SCAN_BODY_NO)
							{
								nError = checkBodyEnd(0);
								if (nError != ERRCODE_NONE)
									goto done;
							}
							goto done;
						}
						break;

					case CntMBXChars::CTLZ:
						nTokenStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
						rToken = CntMBXToken(CntMBXToken::TYPE_ZERO,
											 ByteString());
						goto done;

					case CLASS_END:
						rToken = CntMBXToken(CntMBXToken::TYPE_END,
											 ByteString());
						goto done;
				}
				break;

			case STATE_LWSP:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_LWSP)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						break;

					case CntMBXChars::PRCR:
						eState = STATE_LWSP_PRCR;
						goto folded;

					case CntMBXChars::POCR:
						eState = STATE_LWSP_POCR;
						goto folded;

					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						eState = STATE_LWSP_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(1);
							if (nError != ERRCODE_NONE)
								goto done;
						}
				folded:
						if (eMode & FOLDED_LWSP)
						{
							nInnerStart = m_nBufferStart
							                  + (m_pBufferPointer++
												     - m_pBuffer);
							break;
						}
					default:
						if (eMode & SKIP_LWSP)
							eState = STATE_INIT;
						else
						{
							ByteString aValue;
							nError = readToken(nTokenStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken = CntMBXToken(CntMBXToken::TYPE_LWSP,
												 aValue,
												 eMode & CANONIC_LWSP ?
												     aCanonic : aValue);
							goto done;
						}
						break;
				}
				break;

			case STATE_LWSP_PRCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::PRLF:
						++m_pBufferPointer;
						eState = STATE_LWSP_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					default:
						if (eMode & SKIP_LWSP)
						{
							ByteString aValue;
							nError = readToken(nInnerStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken = CntMBXToken(CntMBXToken::TYPE_OTHER,
												 aValue);
						}
						else
						{
							nError = seekBack(nInnerStart);
							if (nError != ERRCODE_NONE)
								goto done;
							ByteString aValue;
							nError = readToken(nTokenStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken = CntMBXToken(CntMBXToken::TYPE_LWSP,
												 aValue,
												 eMode & CANONIC_LWSP ?
												     aCanonic : aValue);
						}
						goto done;
				}
				break;

			case STATE_LWSP_POCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::POLF:
						++m_pBufferPointer;
					default:
						eState = STATE_LWSP_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;
				}
				break;

			case STATE_LWSP_CRLF:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_LWSP)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						eState = STATE_LWSP;
						break;

					default:
						if (eMode & SKIP_LWSP)
						{
							ByteString aValue;
							nError = readToken(nInnerStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken = CntMBXToken(CntMBXToken::TYPE_CRLF,
												 aValue);
						}
						else
						{
							nError = seekBack(nInnerStart);
							if (nError != ERRCODE_NONE)
								goto done;
							ByteString aValue;
							nError = readToken(nTokenStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken = CntMBXToken(CntMBXToken::TYPE_LWSP,
												 aValue,
												 eMode & CANONIC_LWSP ?
												     aCanonic : aValue);
						}
						goto done;
				}
				break;

			case STATE_ATOM:
				switch (getClass(pChars))
				{
					case CntMBXChars::ATOM:
						++m_pBufferPointer;
						break;

					default:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						aCanonic = aValue;
						if (eMode & CANONIC_ATOM)
							aCanonic.ToLowerAscii();
						rToken = CntMBXToken(CntMBXToken::TYPE_ATOM, aValue,
											 aCanonic,
											 eMode & HASH_ATOM ?
											     &rTable.insert(aCanonic,
																aValue) :
											     0);
						goto done;
					}
				}
				break;

			case STATE_QSTR:
				switch (getClass(pChars))
				{
					case CntMBXChars::QSTR:
					{
						++m_pBufferPointer;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken
							= CntMBXToken(bBroken ?
										      CntMBXToken::TYPE_BROKEN_QSTR :
										      CntMBXToken::TYPE_QSTR,
										  aValue,
										  eMode & CANONIC_QSTR ? aCanonic :
										                         aValue);
						goto done;
					}

					case CntMBXChars::ESCP:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_ESCP;
						break;

					case CntMBXChars::PRCR:
						if (eMode & CANONIC_QSTR)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_PRCR;
						break;

					case CntMBXChars::POCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_POCR;
						break;

					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					case CntMBXChars::CTLZ:
						if (eMode & CANONIC_QSTR)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_QSTR,
											 aValue,
											 eMode & CANONIC_QSTR ? aCanonic :
											                        aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_QSTR)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						break;
				}
				break;

			case STATE_QSTR_ESCP:
				switch (getClass(pChars))
				{
					case CntMBXChars::CTLZ:
						if (eMode & CANONIC_QSTR)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_QSTR_ESCP_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						if (eMode & CANONIC_QSTR)
							aCanonic += aValue.GetChar(aValue.Len() - 1);
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_QSTR,
											 aValue,
											 eMode & CANONIC_QSTR ? aCanonic :
											                        aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_QSTR)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						eState = STATE_QSTR;
						break;
				}
				break;

			case STATE_QSTR_ESCP_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						if (eMode & CANONIC_QSTR)
							aCanonic += aValue.GetChar(aValue.Len() - 1);
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_QSTR,
											 aValue,
											 eMode & CANONIC_QSTR ? aCanonic :
											                        aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_QSTR)
							aCanonic += cTemp;
						eState = STATE_QSTR;
						break;
				}
				break;

			case STATE_QSTR_PRCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::PRLF:
						++m_pBufferPointer;
						eState = STATE_QSTR_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					default:
						if (eMode & CANONIC_QSTR)
							aCanonic += cTemp;
						bBroken = true;
						eState = STATE_QSTR;
						break;
				}
				break;

			case STATE_QSTR_POCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::POLF:
						++m_pBufferPointer;
					default:
						eState = STATE_QSTR_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;
				}
				break;

			case STATE_QSTR_CRLF:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_QSTR)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						eState = STATE_QSTR;
						break;

					default:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_QSTR,
											 aValue,
											 eMode & CANONIC_QSTR ? aCanonic :
											                        aValue);
						goto done;
					}
				}
				break;

			case STATE_QSTR_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_QSTR,
											 aValue,
											 eMode & CANONIC_QSTR ? aCanonic :
											                        aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_QSTR)
							aCanonic += cTemp;
						eState = STATE_QSTR;
						break;
				}
				break;

			case STATE_DOPN:
				switch (getClass(pChars))
				{
					case CntMBXChars::DOPN:
						bBroken = true;
					default:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						break;

					case CntMBXChars::DCLS:
					{
						++m_pBufferPointer;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(
							         bBroken ?
									     CntMBXToken::TYPE_BROKEN_DOMAINLIT :
									     CntMBXToken::TYPE_DOMAINLIT,
									 aValue,
									 eMode & CANONIC_DOMAINLIT ? aCanonic :
									                             aValue);
						goto done;
					}

					case CntMBXChars::ESCP:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_ESCP;
						break;

					case CntMBXChars::PRCR:
						if (eMode & CANONIC_DOMAINLIT)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_PRCR;
						break;

					case CntMBXChars::POCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_POCR;
						break;

					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						nInnerStart = m_nBufferStart
							             + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					case CntMBXChars::CTLZ:
						if (eMode & CANONIC_DOMAINLIT)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken
							= CntMBXToken(CntMBXToken::TYPE_BROKEN_DOMAINLIT,
										  aValue,
										  eMode & CANONIC_DOMAINLIT ?
										      aCanonic : aValue);
						goto done;
					}
				}
				break;

			case STATE_DOPN_ESCP:
				switch (getClass(pChars))
				{
					case CntMBXChars::CTLZ:
						if (eMode & CANONIC_DOMAINLIT)
							cTemp = *m_pBufferPointer;
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_DOPN_ESCP_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += aValue.GetChar(aValue.Len() - 1);
						rToken
							= CntMBXToken(CntMBXToken::TYPE_BROKEN_DOMAINLIT,
										  aValue,
										  eMode & CANONIC_DOMAINLIT ?
										      aCanonic : aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += *m_pBufferPointer;
						++m_pBufferPointer;
						eState = STATE_DOPN;
						break;
				}
				break;

			case STATE_DOPN_ESCP_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += aValue.GetChar(aValue.Len() - 1);
						rToken
							= CntMBXToken(CntMBXToken::TYPE_BROKEN_DOMAINLIT,
										  aValue,
										  eMode & CANONIC_DOMAINLIT ?
										      aCanonic : aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += cTemp;
						eState = STATE_DOPN;
						break;
				}
				break;

			case STATE_DOPN_PRCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::PRLF:
						++m_pBufferPointer;
						eState = STATE_DOPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					default:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += cTemp;
						bBroken = true;
						eState = STATE_DOPN;
						break;
				}
				break;

			case STATE_DOPN_POCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::POLF:
						++m_pBufferPointer;
					default:
						eState = STATE_DOPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;
				}
				break;

			case STATE_DOPN_CRLF:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += cTemp;
						++m_pBufferPointer;
						eState = STATE_DOPN;
						break;

					default:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken
							= CntMBXToken(CntMBXToken::TYPE_BROKEN_DOMAINLIT,
										  aValue,
										  eMode & CANONIC_DOMAINLIT ?
										      aCanonic : aValue);
						goto done;
					}
				}
				break;

			case STATE_DOPN_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken
							= CntMBXToken(CntMBXToken::TYPE_BROKEN_DOMAINLIT,
										  aValue,
										  eMode & CANONIC_DOMAINLIT ?
										      aCanonic : aValue);
						goto done;
					}

					default:
						if (eMode & CANONIC_DOMAINLIT)
							aCanonic += cTemp;
						eState = STATE_DOPN;
						break;
				}
				break;

			case STATE_COPN:
				switch (getClass(pChars))
				{
					case CntMBXChars::COPN:
						++m_pBufferPointer;
						++nLevel;
						break;

					case CntMBXChars::CCLS:
						++m_pBufferPointer;
						if (nLevel != 0)
							--nLevel;
						else if (!bBroken && eMode & SKIP_COMMENTS)
							eState = STATE_INIT;
						else
						{
							ByteString aValue;
							nError = readToken(nTokenStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken
								= CntMBXToken(
									  bBroken ?
									      CntMBXToken::TYPE_BROKEN_COMMENT :
									      CntMBXToken::TYPE_COMMENT,
									  aValue);
							goto done;
						}
						break;

					case CntMBXChars::ESCP:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_ESCP;
						break;

					case CntMBXChars::PRCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_PRCR;
						break;

					case CntMBXChars::POCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_POCR;
						break;

					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					case CntMBXChars::CTLZ:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_COMMENT,
											 aValue);
						goto done;
					}

					default:
						++m_pBufferPointer;
						break;
				}
				break;

			case STATE_COPN_ESCP:
				switch (getClass(pChars))
				{
					case CntMBXChars::CTLZ:
						nInnerStart = m_nBufferStart
							              + (m_pBufferPointer++ - m_pBuffer);
						eState = STATE_COPN_ESCP_CTLZ;
						break;

					case CntMBXChars::ZERO:
						if (eScanBody != SCAN_BODY_NO)
							setBodyEnd();
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_COMMENT,
											 aValue);
						goto done;
					}

					default:
						++m_pBufferPointer;
						eState = STATE_COPN;
						break;
				}
				break;

			case STATE_COPN_ESCP_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_COMMENT,
											 aValue);
						goto done;
					}

					default:
						eState = STATE_COPN;
						break;
				}
				break;

			case STATE_COPN_PRCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::PRLF:
						++m_pBufferPointer;
						eState = STATE_COPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;

					default:
						bBroken = true;
						eState = STATE_COPN;
						break;
				}
				break;

			case STATE_COPN_POCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::POLF:
						++m_pBufferPointer;
					default:
						eState = STATE_COPN_CRLF;
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						break;
				}
				break;

			case STATE_COPN_CRLF:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						++m_pBufferPointer;
						eState = STATE_COPN;
						break;

					default:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_COMMENT,
											 aValue);
						goto done;
					}
				}
				break;

			case STATE_COPN_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						nError = seekBack(nInnerStart);
						if (nError != ERRCODE_NONE)
							goto done;
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_BROKEN_COMMENT,
											 aValue);
						goto done;
					}

					default:
						eState = STATE_COPN;
						break;
				}
				break;

			case STATE_PRCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::PRLF:
						++m_pBufferPointer;
						if (eMode & FOLDED_LWSP)
							eState = STATE_CRLF;
						else
						{
							ByteString aValue;
							nError = readToken(nTokenStart, aValue);
							if (nError != ERRCODE_NONE)
								goto done;
							rToken
							 = CntMBXToken(CntMBXToken::TYPE_CRLF, aValue);
							if (eScanBody != SCAN_BODY_NO)
							{
								nError = checkBodyEnd(0);
								if (nError != ERRCODE_NONE)
									goto done;
							}
							goto done;
						}
						break;

					default:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_OTHER, aValue);
						goto done;
					}
				}
				break;

			case STATE_POCR:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & FOLDED_LWSP)
						{
							if (eMode & CANONIC_LWSP)
								aCanonic = *m_pBufferPointer;
							++m_pBufferPointer;
							eState = STATE_LWSP;
							break;
						}
					default:
				state_pocr_default_case:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_CRLF, aValue);
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						goto done;
					}

					case CntMBXChars::POLF:
						++m_pBufferPointer;
						if (eMode & FOLDED_LWSP)
							eState = STATE_CRLF;
						else
							goto state_pocr_default_case;
						break;
				}
				break;

			case STATE_CRLF:
				switch (getClass(pChars))
				{
					case CntMBXChars::LWSP:
						if (eMode & CANONIC_LWSP)
							aCanonic = *m_pBufferPointer;
						++m_pBufferPointer;
						eState = STATE_LWSP;
						break;

					default:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_CRLF, aValue);
						if (eScanBody != SCAN_BODY_NO)
						{
							nError = checkBodyEnd(0);
							if (nError != ERRCODE_NONE)
								goto done;
						}
						goto done;
					}
				}
				break;

			case STATE_CTLZ:
				switch (getClass(pChars))
				{
					case CLASS_END:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_END, aValue);
						goto done;
					}

					default:
					{
						ByteString aValue;
						nError = readToken(nTokenStart, aValue);
						if (nError != ERRCODE_NONE)
							goto done;
						rToken = CntMBXToken(CntMBXToken::TYPE_OTHER, aValue);
						goto done;
					}
				}
				break;
		}
	}

 done:
	if (nError == ERRCODE_NONE)
	{
		int nStackPos;
		if (m_nSavedTokenCount < MAX_BACK_UP)
			nStackPos = (m_nStackBottom + m_nSavedTokenCount++) % MAX_BACK_UP;
		else
		{
			nStackPos = m_nStackBottom;
			m_nStackBottom = (m_nStackBottom + 1) % MAX_BACK_UP;

			removeMark(m_nSavedTokenStart[nStackPos]);
		}
		m_pSavedTokenAtomTable[nStackPos] = &rTable;
		m_pSavedTokenChars[nStackPos] = pChars;
		m_eSavedTokenMode[nStackPos] = eMode;
		m_aSavedToken[nStackPos] = rToken;
		m_nSavedTokenStart[nStackPos] = nScanStart;
	}
	else
		removeMark(nScanStart);

	return nError;
}

//============================================================================
bool CntMBXScanner::backUp()
{
	if (m_nBackedTokenCount >= m_nSavedTokenCount)
		return false;

	++m_nBackedTokenCount;
	return true;
}

//============================================================================
bool CntMBXScanner::backUpNoEnd()
{
	if (m_nBackedTokenCount >= m_nSavedTokenCount)
		return false;
	CntMBXToken::Type eType
		= m_aSavedToken[(m_nStackBottom
						         + (m_nSavedTokenCount - m_nBackedTokenCount
									    - 1))
					        % MAX_BACK_UP].
	          getType();
	if (eType == CntMBXToken::TYPE_ZERO || eType == CntMBXToken::TYPE_END)
		return false;

	++m_nBackedTokenCount;
	return true;
}

//============================================================================
bool CntMBXScanner::peekSaved(unsigned nIndex, CntMBXToken const ** pToken,
							  CntMBXAtomTable const ** pAtomTable,
							  sal_uInt8 const ** pChars,
							  ScanMode const ** pMode)
{
	if (unsigned(m_nSavedTokenCount - m_nBackedTokenCount) <= nIndex)
		return false;

	int nPos = (m_nStackBottom + m_nSavedTokenCount - m_nBackedTokenCount
				        + MAX_BACK_UP - nIndex)
		           % MAX_BACK_UP;
	if (pToken)
		*pToken = m_aSavedToken + nPos;
	if (pAtomTable)
		*pAtomTable = m_pSavedTokenAtomTable[nPos];
	if (pChars)
		*pChars = m_pSavedTokenChars[nPos];
	if (pMode)
		*pMode = m_eSavedTokenMode + nPos;
	return true;
}

//============================================================================
//
//  CntMBXStringScanner
//
//============================================================================

// virtual
ErrCode CntMBXStringScanner::readBuffer(ULONG nStart, ULONG & rLen)
{
	if (nStart < m_aString.Len())
	{
		m_pBuffer = const_cast< sal_Char * >(m_aString.GetBuffer()) + nStart;
		rLen = m_aString.Len() - nStart;
	}
	else
	{
		m_pBuffer = 0;
		rLen = 0;
	}
	return ERRCODE_NONE;
}

//============================================================================
// virtual
ErrCode CntMBXStringScanner::readBlock(ULONG nStart, xub_StrLen nLen,
									   ByteString & rBlock, bool)
{
	if (nStart < m_aString.Len())
		rBlock = m_aString.Copy(xub_StrLen(nStart), nLen);
	else
		rBlock.Erase();
	return ERRCODE_NONE;
}

//============================================================================
// virtual
ErrCode CntMBXStringScanner::seek(ULONG nPos, ULONG & rBufferStart,
								  ULONG & rBufferLen)
{
	if (nPos > m_aString.Len())
		return ERRCODE_IO_CANTSEEK;

	m_pBuffer = const_cast< sal_Char * >(m_aString.GetBuffer());
	rBufferStart = 0;
	rBufferLen = m_aString.Len();
	return ERRCODE_NONE;
}

//============================================================================
// virtual
CntMBXStringScanner::~CntMBXStringScanner()
{
	deinit();
	m_aString.ReleaseBufferAccess();
}

//============================================================================
//
//  CntMBXStreamScanner
//
//============================================================================

// virtual
ErrCode CntMBXStreamScanner::readBuffer(ULONG nStart, ULONG & rLen)
{
	if (!m_pBuffer)
		m_pBuffer = new sal_Char[BUFFER_SIZE];

	m_nStreamBufferStart = nStart;
	m_rStream.Seek(m_nOffset + m_nStreamBufferStart);
	m_nStreamBufferLen = m_rStream.Read(m_pBuffer, BUFFER_SIZE);
	rLen = m_nStreamBufferLen;
	return m_rStream.GetError();
}

//============================================================================
// virtual
ErrCode CntMBXStreamScanner::readBlock(ULONG nStart, xub_StrLen nLen,
									   ByteString & rBlock, bool bPeek)
{
	if (nStart >= m_nStreamBufferStart
		&& nStart - m_nStreamBufferStart + nLen <= m_nStreamBufferLen)
	{
		rBlock = ByteString(m_pBuffer + (nStart - m_nStreamBufferStart),
							nLen);
		return ERRCODE_NONE;
	}

	if (bPeek)
		m_rStream.AddMark(m_nOffset + nStart);

	m_rStream.Seek(m_nOffset + nStart);
	sal_Char * pData = new sal_Char[nLen];
	rBlock = ByteString(pData, xub_StrLen(m_rStream.Read(pData, nLen)));
	delete[] pData;

	if (bPeek)
	{
		m_rStream.Seek(m_nOffset + nStart);
		m_rStream.RemoveMark(m_nOffset + nStart);
	}

	return m_rStream.GetError();
}

//============================================================================
// virtual
void CntMBXStreamScanner::addMark(ULONG nPos)
{
	m_rStream.AddMark(m_nOffset + nPos);
}

//============================================================================
// virtual
void CntMBXStreamScanner::removeMark(ULONG nPos)
{
	m_rStream.RemoveMark(m_nOffset + nPos);
}

//============================================================================
// virtual
ErrCode CntMBXStreamScanner::seek(ULONG nPos, ULONG & rBufferStart,
								  ULONG & rBufferLen)
{
	if (nPos >= m_nStreamBufferStart
		&& nPos - m_nStreamBufferStart < m_nStreamBufferLen)
	{
		rBufferStart = m_nStreamBufferStart;
		rBufferLen = m_nStreamBufferLen;
		return ERRCODE_NONE;
	}

	if (!m_pBuffer)
		m_pBuffer = new sal_Char[BUFFER_SIZE];

	m_nStreamBufferStart = nPos;
	m_rStream.Seek(m_nOffset + m_nStreamBufferStart);
	m_nStreamBufferLen = m_rStream.Read(m_pBuffer, BUFFER_SIZE);
	rBufferStart = m_nStreamBufferStart;
	rBufferLen = m_nStreamBufferLen;
	return m_rStream.GetError();
}

//============================================================================
CntMBXStreamScanner::CntMBXStreamScanner(SvStream & rTheStream):
	m_rStream(rTheStream),
	m_nOffset(rTheStream.Tell()),
	m_nStreamBufferStart(0),
	m_nStreamBufferLen(0)
{
	init();
}

//============================================================================
// virtual
CntMBXStreamScanner::~CntMBXStreamScanner()
{
	delete[] m_pBuffer;
	deinit();
}

//============================================================================
// virtual
ULONG CntMBXStreamScanner::getInputSize()
{
	// Assume that a stream that returns a non zero ID can freely seek:
	return m_rStream.IsA() ? m_rStream.Seek(STREAM_SEEK_TO_END) - m_nOffset :
		                     ULONG(-1);
}

//============================================================================
//
//  CntMBXVersion
//
//============================================================================

TYPEINIT0(CntMBXVersion)

//============================================================================
//
//  CntMBXVersion0
//
//============================================================================

TYPEINIT1(CntMBXVersion0, CntMBXVersion)

//============================================================================
//
//  CntMBXFormat
//
//============================================================================

ByteString CntMBXFormat::translateWord(ByteString const & rWord)
{
	bool bQuoted = false;
	INetMIMEStringOutputSink aSink;
	for (xub_StrLen i = 0; i < rWord.Len(); ++i)
	{
		sal_Char c = rWord.GetChar(i);
		switch (CntMBXChars(CntMBXChars::aCharsRFC822).getClass(c))
		{
			case CntMBXChars::ATOM:
				if (bQuoted)
					aSink << c;
				break;

			case CntMBXChars::QSTR:
			case CntMBXChars::ESCP:
			case CntMBXChars::PRCR:
			case CntMBXChars::POCR:
			case CntMBXChars::POLF:
			case CntMBXChars::SNCR:
				if (!bQuoted)
				{
					bQuoted = true;
					aSink << '"';
					aSink.write(rWord, 0, i);
				}
				aSink << '\\' << c;
				break;

			default:
				if (!bQuoted)
				{
					bQuoted = true;
					aSink << '"';
					aSink.write(rWord, 0, i);
				}
				aSink << c;
				break;
		}
	}
	if (bQuoted)
	{
		aSink << '"';
		return aSink.takeBuffer();
	}
	else
		return rWord;
}

//============================================================================
UniString CntMBXFormat::translateXref(UniString const & rHost,
									  CntItemListItem const & rList)
{
	INetMIMEUnicodeOutputSink aSink;
	for (USHORT i = 0; i < rList.Count(); ++i)
		if (CntCrossReferenceItem const * pItem
			    = PTR_CAST(CntCrossReferenceItem, &rList[i]))
		{
			aSink << ' ';
			ByteString aGroup = ByteString(pItem->GetGroup(),
										   RTL_TEXTENCODING_UTF8);
				// is this correct? @@@
			xub_StrLen nStart = 0;
			bool bQuoted = false;
			ByteString aQuotedText;
			bool bDot = true;
			for (xub_StrLen i = nStart; i < aGroup.Len(); ++i)
			{
				sal_Char c = aGroup.GetChar(i);
				switch (CntMBXChars(CntMBXChars::aCharsRFC822).getClass(c))
				{
					case CntMBXChars::ATOM:
						if (bQuoted)
							aQuotedText += c;
						bDot = false;
						break;

					case CntMBXChars::QSTR:
					case CntMBXChars::ESCP:
					case CntMBXChars::PRCR:
					case CntMBXChars::POCR:
					case CntMBXChars::POLF:
					case CntMBXChars::SNCR:
						if (!bQuoted)
						{
							bQuoted = true;
							aQuotedText = '"';
							aQuotedText += aGroup.Copy(nStart, i - nStart);
						}
						aQuotedText += '\\';
						aQuotedText += c;
						bDot = false;
						break;

					case CntMBXChars::SPCL:
						if (c == '.' && !bDot && i + 1 < aGroup.Len())
						{
							if (bQuoted)
								aSink << aQuotedText << '"';
							else
								aSink.write(aGroup, nStart, i);
							aSink << '.';
							nStart = i + 1;
							bQuoted = false;
							aQuotedText.Erase();
							bDot = true;
							break;
						}
					default:
						if (!bQuoted)
						{
							bQuoted = true;
							aQuotedText = '"';
							aQuotedText += aGroup.Copy(nStart, i - nStart);
						}
						aQuotedText += c;
						bDot = false;
						break;
				}
			}
			if (bQuoted)
			{
				aSink << aQuotedText << '"';
			}
			else
				aSink.write(aGroup, nStart, aGroup.Len());
			aSink << ':';
			INetMIME::writeUnsigned(aSink, pItem->GetIndex());
		}
	UniString aResult(rHost);
	aResult += aSink.takeBuffer();
	return aResult;
}

//============================================================================
ByteString CntMBXFormat::translateRanges(CntRangesItem const & rRanges)
{
	INetMIMEStringOutputSink aSink;
	for (USHORT i = 0; i < rRanges.Count(); ++i)
	{
		if (i > 0)
			aSink << ", ";
		ULONG nStart;
		ULONG nEnd;
		rRanges.GetRange(i, nStart, nEnd);
		INetMIME::writeUnsigned(aSink, nStart);
		if (nStart != nEnd)
		{
			aSink << '-';
			INetMIME::writeUnsigned(aSink, nEnd);
		}
	}
	return aSink.takeBuffer();
}

//============================================================================
ByteString CntMBXFormat::translateRFC822AddrSpec(UniString const & rLocalPart,
												 UniString const & rDomain)
{
	INetMIMEStringOutputSink aSink;
	{for (xub_StrLen nPos = 0;;)
	{
		xub_StrLen nDot = rLocalPart.Search('.', nPos);
		if (nDot == STRING_NOTFOUND)
			nDot = rLocalPart.Len();
		aSink << translateWord(rLocalPart.Copy(nPos, nDot - nPos));
		if (nDot == rLocalPart.Len())
			break;
		aSink << '.';
		nPos = nDot + 1;
	}}
	aSink << '@';
	{for (xub_StrLen nPos = 0;;)
	{
		xub_StrLen nDot = rDomain.Search('.', nPos);
		if (nDot == STRING_NOTFOUND)
			nDot = rDomain.Len();
		bool bDomainLiteral = nPos == nDot;
		INetMIMEStringOutputSink aSubDomain;
		sal_Unicode const * pEnd = rDomain.GetBuffer() + nDot;
		for (sal_Unicode const * p = rDomain.GetBuffer() + nPos; p != pEnd;)
		{
			sal_Unicode c = *p++;
			if (c == '\x0A' || c == '\x0D' || c >= '[' && c <= ']')
			{
				bDomainLiteral = true;
				aSubDomain << '\\';
			}
			else if (!INetMIME::isVisible(c) || c == ' ' || c == '"'
					 || c == '(' || c == ')' || c == ',' || c == '.'
					 || c >= ':' && c <= '<' || c == '>' || c == '@')
				bDomainLiteral = true;
			INetMIME::writeUTF8(aSubDomain, c);
		}
		if (bDomainLiteral)
			aSink << '[';
		aSink << aSubDomain.takeBuffer();
		if (bDomainLiteral)
			aSink << ']';
		if (nDot == rDomain.Len())
			break;
		aSink << '.';
		nPos = nDot + 1;
	}}
	return aSink.takeBuffer();
}

//============================================================================
namespace unnamed_chaos_mbxformt {

template< typename T >
bool parseNumericFieldBody_Impl(T const * pBegin, T const * pEnd, bool bHex,
								bool bLeadingZeroes, sal_uInt32 & rValue)
{
	// Parse a RFC 822 header field body containing an unsigned decimal 32-bit
	// value:
	//
	// body = LWSC
	//        (("0" / (%x31-39 *DIGIT))  ; !bHex, !bLeadingZeroes
	//             / 1*DIGIT  ; !bHex, bLeadingZeroes
	//             / ("0" / ((%x31-39 / "A" / "B" / "C" / "D" / "E" / "F")
	//                           *HEXDIG))
	//                   ; bHex == true, bLeadingZeroes == false
	//             / 1*HEXDIG  ; bHex, bLeadingZeroes
	//        )  ; in the (decimal) range [0..4294967295]
	//        LWSC
	// LWSC = [linear-white-space / comment]

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pBegin, pEnd);
	return
		(bHex ? INetMIME::scanUnsignedHex(pBegin, pEnd, bLeadingZeroes,
										  rValue) :
		        INetMIME::scanUnsigned(pBegin, pEnd, bLeadingZeroes, rValue))
		&& INetMIME::skipLinearWhiteSpaceComment(pBegin, pEnd) == pEnd;
}

}

//============================================================================
bool CntMBXFormat::parseNumericFieldBody(ByteString const & rBody, bool bHex,
										 bool bLeadingZeroes,
										 sal_uInt32 & rValue)
{
	return parseNumericFieldBody_Impl(rBody.GetBuffer(),
									  rBody.GetBuffer() + rBody.Len(), bHex,
									  bLeadingZeroes, rValue);
}

//============================================================================
bool CntMBXFormat::parseNumericFieldBody(UniString const & rBody, bool bHex,
										 bool bLeadingZeroes,
										 sal_uInt32 & rValue)
{
	return parseNumericFieldBody_Impl(rBody.GetBuffer(),
									  rBody.GetBuffer() + rBody.Len(), bHex,
									  bLeadingZeroes, rValue);
}

//============================================================================
namespace unnamed_chaos_mbxformt {

template< typename T >
bool parseDateTimeFieldBody_Impl(T const * pBegin, T const * pEnd,
								 DateTime & rDateTime)
{
	// Parse a RFC 1123, RFC 822 <date-time> header field body (with mildly
	// relaxed rules):
	//
	// body = LWSC
	//        [("MON" / "TUE" / "WED" / "THU" / "FRI" / "SAT" / "SUN") LWSC
	//             "," LWSC]
	//        1*2DIGIT  ; day
	//        LWSC
	//        ("JAN" / "FEB" / "MAR" / "APR" / "MAY" / "JUN" / "JUL"/ "AUG"
	//             / "SEP" / "OCT" / "NOV" / "DEC")
	//        LWSC
	//        2*DIGIT  ; year
	//        LWSC
	//        1*2DIGIT ":" 2DIGIT [":" 2DIGIT]  ; hour, min, sec
	//        LWSC
	//        ("UT" / "GMT" / "EST" / "EDT" / "CST" / "CDT" / "MST" / "MDT"
	//             / "PST" / "PDT" / ALPHA / (("+" / "-") 4DIGIT))
	//        LWSC
	// LWSC = [linear-white-space / comment]

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pBegin, pEnd);
	T const * pTokenEnd = INetMIME::scanAtom(pBegin, pEnd);
	if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "mon")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "tue")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "wed")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "thu")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "fri")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "sat")
		|| INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "sun"))
	{
		pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
		if (pBegin == pEnd || *pBegin++ != ',')
			return false;

		pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
		pTokenEnd = INetMIME::scanAtom(pBegin, pEnd);
	}

	sal_uInt32 nValue;
	if (pTokenEnd - pBegin > 2
		|| !INetMIME::scanUnsigned(pBegin, pTokenEnd, true, nValue)
		|| pBegin != pTokenEnd)
		return false;
	rDateTime.SetDay(USHORT(nValue));

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
	pTokenEnd = INetMIME::scanAtom(pBegin, pEnd);
	if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "jan"))
		rDateTime.SetMonth(1);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "feb"))
		rDateTime.SetMonth(2);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "mar"))
		rDateTime.SetMonth(3);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "apr"))
		rDateTime.SetMonth(4);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "may"))
		rDateTime.SetMonth(5);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "jun"))
		rDateTime.SetMonth(6);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "jul"))
		rDateTime.SetMonth(7);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "aug"))
		rDateTime.SetMonth(8);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "sep"))
		rDateTime.SetMonth(9);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "oct"))
		rDateTime.SetMonth(10);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "nov"))
		rDateTime.SetMonth(11);
	else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "dec"))
		rDateTime.SetMonth(12);
	else
		return false;

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
	pTokenEnd = pBegin;
	if (!INetMIME::scanUnsigned(pTokenEnd, pEnd, true, nValue)
		|| pTokenEnd - pBegin > 2)
		return false;
	if (nValue < 100)
	{
		USHORT nCurrentYear = Date().GetYear();
		USHORT nCurrentCentury = nCurrentYear / 100;
		nCurrentYear %= 100;
		if (nCurrentYear < 50)
			if (nValue <= nCurrentYear)
				nValue += nCurrentCentury * 100;
			else if (nValue < nCurrentYear + 50)
				nValue += nCurrentCentury * 100;
			else
				nValue += (nCurrentCentury - 1) * 100;
		else
			if (nValue >= nCurrentYear)
				nValue += nCurrentCentury * 100;
			else if (nValue >= nCurrentYear - 50)
				nValue += nCurrentCentury * 100;
			else
				nValue += (nCurrentCentury + 1) * 100;
	}
	if (nValue > std::numeric_limits< USHORT >::max())
		return false;
	rDateTime.SetYear(USHORT(nValue));

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
	pTokenEnd = pBegin;
	if (!INetMIME::scanUnsigned(pTokenEnd, pEnd, true, nValue)
		|| pTokenEnd - pBegin > 2)
		return false;
	rDateTime.SetHour(USHORT(nValue));

	pBegin = pTokenEnd;
	if (pBegin == pEnd || *pBegin++ != ':')
		return false;

	pTokenEnd = pBegin;
	if (!INetMIME::scanUnsigned(pTokenEnd, pEnd, true, nValue)
		|| pTokenEnd - pBegin != 2)
		return false;
	rDateTime.SetMin(USHORT(nValue));

	pBegin = pTokenEnd;
	if (pBegin != pEnd && *pBegin == ':')
	{
		pBegin++;
		pTokenEnd = pBegin;
		if (!INetMIME::scanUnsigned(pTokenEnd, pEnd, true, nValue)
			|| pTokenEnd - pBegin != 2)
			return false;
		rDateTime.SetSec(USHORT(nValue));
	}

	pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
	if (pBegin != pEnd)
	{
		pTokenEnd = INetMIME::scanAtom(pBegin, pEnd);
		if (!(INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "ut")
			  || INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "gmt")
			  || pTokenEnd - pBegin == 1 && INetMIME::isAlpha(*pBegin)))
			if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "edt"))
				rDateTime -= Time(4, 0);
			else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "est")
					 || INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "cdt"))
				rDateTime -= Time(5, 0);
			else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "cst")
					 || INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "mdt"))
				rDateTime -= Time(6, 0);
			else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "mst")
					 || INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "pdt"))
				rDateTime -= Time(7, 0);
			else if (INetMIME::equalIgnoreCase(pBegin, pTokenEnd, "pst"))
				rDateTime -= Time(8, 0);
			else if (pTokenEnd - pBegin == 5
					 && (*pBegin == '+' || *pBegin == '-')
					 && INetMIME::scanUnsigned(pBegin, pTokenEnd, true,
											   nValue)
					 && pBegin == pTokenEnd)
				if (pBegin[-5] == '+')
					rDateTime += Time(nValue / 100, nValue % 100);
				else
					rDateTime -= Time(nValue / 100, nValue % 100);
			else
				return false;

		pBegin = INetMIME::skipLinearWhiteSpaceComment(pTokenEnd, pEnd);
	}
	return true;
}

}

//============================================================================
bool CntMBXFormat::parseDateTimeFieldBody(ByteString const & rBody,
										  DateTime & rDateTime)
{
	return parseDateTimeFieldBody_Impl(rBody.GetBuffer(),
									   rBody.GetBuffer() + rBody.Len(),
									   rDateTime);
}

//============================================================================
bool CntMBXFormat::parseDateTimeFieldBody(UniString const & rBody,
										  DateTime & rDateTime)
{
	return parseDateTimeFieldBody_Impl(rBody.GetBuffer(),
									   rBody.GetBuffer() + rBody.Len(),
									   rDateTime);
}

//============================================================================
void CntMBXFormat::decomposeDomainAndPort(UniString const & rDomainAndPort,
										  UniString & rDomain, USHORT & rPort)
{
	xub_StrLen nColonPos = rDomainAndPort.Search(':');
	if (nColonPos == STRING_NOTFOUND)
	{
		rDomain = rDomainAndPort;
		rPort = 0;
	}
	else
	{
		rDomain = rDomainAndPort.Copy(0, nColonPos);
		rPort = rDomainAndPort.Copy(nColonPos + 1).ToInt32();
	}
}

//============================================================================
UniString CntMBXFormat::getLocalServerName(UniString const & rDomainAndPort)
{
	xub_StrLen i = 0;
	while (i < rDomainAndPort.Len() && rDomainAndPort.GetChar(i) != '.'
		   && rDomainAndPort.GetChar(i) != ':')
		++i;
	return rDomainAndPort.Copy(0, i);
}

