/*************************************************************************
 *
 *  $RCSfile: cntanchr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTANCHR_HXX
#define _CNTANCHR_HXX 1

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#define CNT_COMPONENT_LIST "ComponentList"

class SfxPoolItem;

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntAnchor;
class PosEntryFinder;

class EntryData
{
	CntAnchor  **_ppAnchors;
	short		 _nDepth;

public:
				 EntryData( CntAnchor* pAnchor,
				 			CntAnchor* pRoot );
				~EntryData();

	int			 Compare( const EntryData *pCompare ) const;
	CntAnchor	*GetAnchor( short nDepth = 0 ) const;
	short		 GetDepth() const { return _nDepth; }

	friend class PosEntryFinder;
};

#define TRIGGER_CHECKING 50
#define COLLECTING_TIMER_INTERVAL_START 750
#define COLLECTING_TIMER_INTERVAL 5000

class PosEntryFinder
{
	List		*_pEntries;
	CntAnchor	*_pBroadcaster;

public:
				 PosEntryFinder( CntAnchor *pBroadcaster );
				~PosEntryFinder();

	CntAnchor	*GetEntryAtPos( ULONG nPos ) const;
	ULONG		 FindPos( EntryData *pData, BOOL &rFound ) const;
	ULONG		 FindPos( EntryData *pData, long nStart, long nEnd ) const;
	ULONG		 FindNext( EntryData *pData, long nStart ) const;
	ULONG		 InsertAnchor( CntAnchor *pNew );
	ULONG		 RemoveAnchor( CntAnchor *pAnchor );
	void		 MoveAnchor( CntAnchor *pAnchor );
	void		 ChangeAnchorPos( CntAnchor *pAnchor,
								  SfxPoolItem *pChangedItem,
								  BOOL bLast = FALSE );
	ULONG		 Expand( CntAnchor *pAnchor, ULONG &rPos, BOOL bRecursive );
	void		 Collapse( CntAnchor *pAnchor, ULONG nStartPos, ULONG &rCount, BOOL bRecursive );
	void		 ReSort();
	ULONG		 Count() const { return _pEntries ? _pEntries->Count() : 0;}
};

#if defined TF_UCB
}
#endif // TF_UCB


#endif
