/*************************************************************************
 *
 *  $RCSfile: cntmsgnd.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTMSGNODE_HXX
#define _CNTMSGNODE_HXX 1

#ifndef _CNTDOCND_HXX
#include <cntdocnd.hxx>
#endif

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

//=========================================================================

class CntMessageNode : public CntDocumentNode
{
private:
	BOOL						_bIsLocked;

								CntMessageNode( const CntMessageNode& ); // n.i.
	CntMessageNode&				operator=( const CntMessageNode& ); // n.i.

public:
								TYPEINFO();
								CNT_NODE_SUBCLASS_DECL();

								CntMessageNode( const USHORT *pRanges = NULL );
	virtual 					~CntMessageNode();

	virtual FASTBOOL			IsItemFlag( USHORT nWID, USHORT nFlag ) const;

	virtual const SfxPoolItem*	ExecuteJob( CntNodeJob *pJob );

	BOOL 						GetIsLocked() const	{ return _bIsLocked; }
	BOOL						SetIsLocked( BOOL bNew );
};

#if defined TF_UCB
}
#endif // TF_UCB


#endif /* !_CNTMSGNODE_HXX */
