/*************************************************************************
 *
 *  $RCSfile: cntpool.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTPOOL_HXX
#define _CNTPOOL_HXX 1

#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif

namespace rtl {
	class OUString;
}

namespace com { namespace sun { namespace star { namespace uno {
	class Type;
} } } }

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class  CntWhich2PropList;
struct CntWhich2PropEntry;

//=========================================================================

#define CNT_POOL() ( CntItemPool::Get() )

//=========================================================================

struct CntItemMapEntry
{
	const char*	pName;
	USHORT      nWhich;
	USHORT      nAttributes;
	const com::sun::star::uno::Type& (*pGetCppuType)(); // UNO3 type info.

	BOOL IsProperty() const { return ( nAttributes != 0 ); }
	BOOL IsFunction() const { return !IsProperty(); }
};

class CntItemMap
{
	ULONG 			 	   _nCount;
	CntWhich2PropList* 	   _pWhichList;
	const CntItemMapEntry* _pPropMap;

private:
	void InsertInWhichList_Impl( CntWhich2PropEntry* pEntry );

public:
	CntItemMap( const CntItemMapEntry* pPropMap );
	~CntItemMap();

	ULONG Count() const { return _nCount; }

	const CntItemMapEntry* GetObject ( ULONG nIndex ) const;
	const CntItemMapEntry* Prop2Which( const UniString& rProp ) const;
	const CntItemMapEntry* Which2Prop( USHORT nWhich ) const;
};

//=========================================================================

class CntItemPool: public SfxItemPool
{
	static CntItemPool* _pThePool;
	USHORT              _nRefs;

protected:
	CntItemPool();
	virtual ~CntItemPool();

public:
	static CntItemPool* Get() { return _pThePool; }
	static CntItemPool* Acquire();
	static USHORT 		Release();

	SfxItemPresentation	GetPresentation(
								const SfxPoolItem&	rItem,
								SfxItemPresentation ePresentation,
								SfxMapUnit			ePresentationMetric,
								XubString&			rText,
								const International * = 0 ) const;
	virtual const SfxPoolItem& Put( const SfxPoolItem&, USHORT nWhich = 0 );

	// StarONE support...
	static const CntItemMap* GetItemMap();
};

#if defined TF_UCB
}
#endif // TF_UCB


#endif
