/*************************************************************************
 *
 *  $RCSfile: cnttrash.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTTRASH_HXX
#define _CNTTRASH_HXX

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _CNTBASE_HXX
#include <cntbase.hxx>
#endif
#ifndef _CNTNODE_HXX
#include <cntnode.hxx>
#endif

namespace com { namespace sun { namespace star { namespace ucb {
	class XContentIdentifier;
	class XCommandProcessor;
} } } }

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntTrashCanNode_Impl;
class CntTrashNode_Impl;

//=========================================================================
#define CNT_TRASHCAN_URL URL_PREFIX_PRIV_SOFFICE "trashcan:///"
#define UCB_TRASHCAN_URL INET_VENDOR_SCHEME_PREFIX "trashcan:///"

//=========================================================================

class CntTrashCanNode : public CntNode
{
private:
	CntTrashCanNode_Impl* _pImpl;

	// Forbiddden and not implemented.
	CntTrashCanNode( const CntTrashCanNode& );
	// Forbiddden and not implemented.
	CntTrashCanNode& operator=( const CntTrashCanNode& );

public:
	TYPEINFO();
	CNT_NODE_SUBCLASS_DECL();

	CntTrashCanNode( const USHORT *pRanges = NULL );
	virtual	~CntTrashCanNode();

	CntTrashCanNode_Impl & getImpl() { return *_pImpl; }

	virtual const SfxPoolItem* ExecuteJob( CntNodeJob *pJob );
	virtual void Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
	virtual void SetConnMode( CntConnMode eNewConnMode );
	virtual FASTBOOL IsItemFlag( USHORT nWhich, USHORT nFlag ) const;

	static BOOL IsTrashable( CntNode* pNode );
	static BOOL Trash( CntNode* pNode );

	static void
	trashContent(const com::sun::star::uno::Reference<
				           com::sun::star::ucb::XCommandProcessor > &
				     rProperties,
				 const com::sun::star::uno::Reference<
				           com::sun::star::ucb::XContentIdentifier > &
				     rIdentifier);
};

//=========================================================================

class CntTrashNode : public CntNode
{
private:
	CntTrashNode_Impl* _pImpl;

	// Forbiddden and not implemented.
	CntTrashNode( const CntTrashNode& );
	// Forbiddden and not implemented.
	CntTrashNode& operator=( const CntTrashNode& );

public:
	TYPEINFO();
	CNT_NODE_SUBCLASS_DECL();

	CntTrashNode( const USHORT *pRanges = NULL );
	virtual	~CntTrashNode();

	virtual CntNode* Initialize( CntNode* pParent, const String& rNodeURL );

	virtual const SfxPoolItem* ExecuteJob( CntNodeJob *pJob );
	virtual void Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
};

#if defined TF_UCB
}
#endif // TF_UCB


#endif /* !_CNTTRASH_HXX */

