/*************************************************************************
 *
 *  $RCSfile: cntwmitm.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTWMITM_HXX
#define _CNTWMITM_HXX

#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

//=========================================================================

#define CNT_WHO_IS_MASTER_COUNT 3

enum CntWhoIsMaster {
	CNT_SERVER_IS_MASTER,
	CNT_CLIENT_IS_MASTER,
	CNT_NONE_IS_MASTER
};

//=========================================================================
class CntWhoIsMasterItem : public CntEnumItem
{
public:
	TYPEINFO();

	CntWhoIsMasterItem(
		USHORT nWhich = WID_WHO_IS_MASTER,
		CntWhoIsMaster eMaster = CNT_NONE_IS_MASTER);

	virtual SfxPoolItem    *Clone(SfxItemPool* pPool = NULL) const;
	virtual SfxPoolItem    *Create(SvStream &rStream, USHORT nVersion) const;
	virtual SvStream       &Store(SvStream &rStream, USHORT nVersion) const;
	virtual SfxItemPresentation GetPresentation(
		SfxItemPresentation ePresentation,
		SfxMapUnit          eCoreMetric,
		SfxMapUnit          ePresentationMetric,
		XubString           &rText,
		const International * = 0 ) const;

	virtual USHORT          GetValueCount(void) const;
	virtual String          GetValueTextByPos(USHORT nPos) const;

	CntWhoIsMasterItem      &operator=(const CntWhoIsMasterItem& rMaster)
	{
		SetValue(rMaster.GetValue());
		return *this;
	}

	virtual	BOOL PutValue  ( const com::sun::star::uno::Any& rVal,
						     BYTE nMemberId = 0 );
	virtual	BOOL QueryValue( com::sun::star::uno::Any& rVal,
							 BYTE nMemberId = 0 ) const;
};

#if defined TF_UCB
}
#endif // TF_UCB

#endif
