/*************************************************************************
 *
 *  $RCSfile: cntcmitm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef __SBX_SBXVARIABLE_HXX //autogen
#include <svtools/sbxvar.hxx>
#endif

#include <cntcmitm.hxx>

#ifndef _CNTRIDS_HRC
#include <cntrids.hrc>
#endif
#ifndef _CNTRESID_HXX
#include <cntresid.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//============================================================================
//
// CntConnModeItem Implementation.
//
//============================================================================

TYPEINIT1_AUTOFACTORY( CntConnModeItem, CntEnumItem );

//----------------------------------------------------------------------------
CntConnModeItem::CntConnModeItem( USHORT nWhich, CntConnMode eMode )
	: CntEnumItem( nWhich, eMode )
{
}

//----------------------------------------------------------------------------
SfxPoolItem* CntConnModeItem::Clone( SfxItemPool* ) const
{
	return new CntConnModeItem( *this );
}

//----------------------------------------------------------------------------
SfxPoolItem* CntConnModeItem::Create( SvStream& rStream, USHORT ) const
{
	USHORT eStyle;
	rStream >> eStyle;

	return new CntConnModeItem( Which(), (CntConnMode)eStyle );
}

//----------------------------------------------------------------------------
SvStream& CntConnModeItem::Store( SvStream& rStream, USHORT ) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

//----------------------------------------------------------------------------
SfxItemPresentation CntConnModeItem::GetPresentation( SfxItemPresentation,
													  SfxMapUnit,
													  SfxMapUnit,
													  XubString &rText,
													  const International * )
	const
{
	rText = GetValueTextByPos( GetValue() );
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

//----------------------------------------------------------------------------
String CntConnModeItem::GetValueTextByPos( USHORT nPos ) const
{
	DBG_ASSERT( nPos < CNT_CONNMODE_COUNT, "enum overflow!" );
	return String( CntResId( RID_CNTCONNMODE_START + nPos ) );
}

//----------------------------------------------------------------------------
USHORT CntConnModeItem::GetValueCount() const
{
	return CNT_CONNMODE_COUNT;
}

//----------------------------------------------------------------------------
int	CntConnModeItem::HasBoolValue() const
{
	return TRUE;
}

//----------------------------------------------------------------------------
BOOL CntConnModeItem::GetBoolValue() const
{
	return CNT_CONN_MODE_ONLINE == GetValue();
}

//----------------------------------------------------------------------------
void CntConnModeItem::SetBoolValue( BOOL bVal )
{
	SetValue( bVal ? CNT_CONN_MODE_ONLINE : CNT_CONN_MODE_OFFLINE );

}

//----------------------------------------------------------------------------
// virtual
BOOL CntConnModeItem::PutValue( const com::sun::star::uno::Any& rVal,
						   		BYTE nMemberId )
{
	sal_Int16 nValue;
	if ( rVal >>= nValue )
	{
		CntEnumItem::SetValue( nValue );
		return TRUE;
	}

	DBG_ERROR( "CntConnModeItem::PutValue - Wrong type!" );
	return FALSE;
}

//----------------------------------------------------------------------------
// virtual
BOOL CntConnModeItem::QueryValue( com::sun::star::uno::Any& rVal,
							 	  BYTE nMemberId ) const
{
	sal_Int16 nValue = CntEnumItem::GetValue();
	rVal <<= nValue;
	return TRUE;
}

