/*************************************************************************
 *
 *  $RCSfile: cntwmitm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifndef _CNTWMITM_HXX
#include <cntwmitm.hxx>
#endif

#ifndef _CNTRIDS_HRC
#include <cntrids.hrc>
#endif
#ifndef _CNTRESID_HXX
#include <cntresid.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//============================================================================
//
// CntWhoIsMasterItem Implementation.
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntWhoIsMasterItem, CntEnumItem);

//============================================================================
CntWhoIsMasterItem::CntWhoIsMasterItem(USHORT nWhich, CntWhoIsMaster eMaster)
	: CntEnumItem(nWhich, eMaster)
{
}

//============================================================================
SfxPoolItem *CntWhoIsMasterItem::Clone(SfxItemPool*) const
{
	return new CntWhoIsMasterItem(*this);
}

//============================================================================
SfxPoolItem *CntWhoIsMasterItem::Create(SvStream &rStream, USHORT nVersion) const
{
	USHORT eMaster;
	rStream >> eMaster;

	return new CntWhoIsMasterItem(Which(), (CntWhoIsMaster)eMaster);
}

//============================================================================
SvStream &CntWhoIsMasterItem::Store(SvStream &rStream, USHORT nVersion) const
{
	rStream << (USHORT)GetValue();
	return rStream;
}

//============================================================================
SfxItemPresentation CntWhoIsMasterItem::GetPresentation(
	SfxItemPresentation,
	SfxMapUnit,
	SfxMapUnit,
	XubString &rText,
	const International * ) const
{
	rText = GetValueTextByPos(GetValue());
	return SFX_ITEM_PRESENTATION_COMPLETE;
}

//============================================================================
String CntWhoIsMasterItem::GetValueTextByPos(USHORT nPos) const
{
	DBG_ASSERT( nPos < CNT_WHO_IS_MASTER_COUNT, "enum overflow!" );
#ifdef RID_CNT_WHO_IS_MASTER_START
	return String(CntResId(RID_CNT_WHO_IS_MASTER_START + nPos));
#else
	return String();
#endif
}

//============================================================================
USHORT CntWhoIsMasterItem::GetValueCount(void) const
{
	return CNT_WHO_IS_MASTER_COUNT;
}

//============================================================================
// virtual
BOOL CntWhoIsMasterItem::PutValue( const com::sun::star::uno::Any& rVal,
						   		   BYTE nMemberId )
{
	sal_Int16 nValue;
	if ( rVal >>= nValue )
	{
		CntEnumItem::SetValue( nValue );
		return TRUE;
	}

	DBG_ERROR( "CntWhoIsMasterItem::PutValue - Wrong type!" );
	return FALSE;
}

//============================================================================
// virtual
BOOL CntWhoIsMasterItem::QueryValue( com::sun::star::uno::Any& rVal,
							 	  	 BYTE nMemberId ) const
{
	sal_Int16 nValue = CntEnumItem::GetValue();
	rVal <<= nValue;
	return TRUE;
}

