/*************************************************************************
 *
 *  $RCSfile: cntxref.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#include <cntxref.hxx>

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

/*========================================================================
 *
 * CntCrossReferenceItem Implementation.
 *
 *======================================================================*/
/*
 * CntCrossReferenceItem.
 */
TYPEINIT1_AUTOFACTORY (CntCrossReferenceItem, SfxPoolItem);

CntCrossReferenceItem::CntCrossReferenceItem (USHORT nId, SvStream& rStrm,
											  USHORT nVersion)
	: SfxPoolItem (nId)
{
	readUnicodeString(rStrm, _aGroup, nVersion >= 1);
	rStrm >> _nIndex;
}

/*
 * operator==
 */
int CntCrossReferenceItem::operator== (const SfxPoolItem& rItem) const
{
	const CntCrossReferenceItem& rOther = (const CntCrossReferenceItem&)rItem;

	return ((_aGroup == rOther._aGroup) && (_nIndex == rOther._nIndex));
}

/*
 * GetVersion.
 */
USHORT CntCrossReferenceItem::GetVersion(USHORT) const
{
	return 1; // because it uses SfxPoolItem::read/writeUnicodeString()
}

/*
 * Clone.
 */
SfxPoolItem* CntCrossReferenceItem::Clone (SfxItemPool *pPool) const
{
	return new CntCrossReferenceItem (*this);
}

/*
 * Create.
 */
SfxPoolItem* CntCrossReferenceItem::Create (
	SvStream& rStrm, USHORT nVersion) const
{
	return new CntCrossReferenceItem (Which(), rStrm, nVersion);
}

/*
 * Store.
 */
SvStream& CntCrossReferenceItem::Store (
	SvStream& rStrm, USHORT nVersion) const
{
	writeUnicodeString(rStrm, _aGroup);
	rStrm << _nIndex;

	return rStrm;
}

