/*************************************************************************
 *
 *  $RCSfile: slstitem.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef CHAOS_SLSTITEM_HXX
#include <slstitem.hxx>
#endif

//============================================================================
//
//  CntStringListItem
//
//============================================================================

TYPEINIT1(CntStringListItem, SfxStringListItem)

//============================================================================
CntStringListItem::CntStringListItem(USHORT nWhich, SvStream & rStream,
									 USHORT nVersion):
	SfxStringListItem(nWhich)
{
	sal_Int32 nCount = 0;
	rStream >> nCount;
	while (nCount-- > 0)
	{
		UniString * p = new UniString;
		readUnicodeString(rStream, *p, nVersion >= 1);
		GetList()->Insert(p, LIST_APPEND);
	}
}

//============================================================================
// virtual
int CntStringListItem::operator ==(SfxPoolItem const & rItem) const
{
	return rItem.ISA(CntStringListItem)
		   && this->SfxStringListItem::operator ==(rItem);
}

//============================================================================
// virtual
USHORT CntStringListItem::GetVersion(USHORT) const
{
	return 1; // because we use read/writeUnicodeString()
}

//============================================================================
// virtual
SfxPoolItem * CntStringListItem::Create(SvStream & rStream, USHORT nVersion)
	const
{
	return new CntStringListItem(Which(), rStream, nVersion);
}

//============================================================================
// virtual
SvStream & CntStringListItem::Store(SvStream & rStream, USHORT) const
{
	sal_Int32 nCount = GetList()->Count();
	rStream << nCount;
	for (sal_Int32 i = 0; i < nCount; ++i)
		writeUnicodeString(rStream,
						   *static_cast< UniString * >(GetList()->
													       GetObject(i)));
	return rStream;
}

//============================================================================
// virtual
SfxPoolItem * CntStringListItem::Clone(SfxItemPool *) const
{
	return new CntStringListItem(*this);
}

