/*************************************************************************
 *
 *  $RCSfile: chttpdog.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTHTTPDOG_HXX
#define _CNTHTTPDOG_HXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_THREAD_HXX
#include <vos/thread.hxx>
#endif
#ifndef _VOS_CONDITN_HXX
#include <vos/conditn.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif

#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif

struct CntHTTPCacheEntry;

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntStorageNode;

DECLARE_LIST(CntHTTPCacheList, CntHTTPCacheEntry*)

/*========================================================================
 *
 * CntHTTPWatchDog Interface.
 *
 *======================================================================*/
class CntHTTPWatchDog :
	public NAMESPACE_VOS(OThread),
	public SfxListener
{
private:
	/** Representation.
	*/
	CntStorageNode            *m_pCache;
	NAMESPACE_VOS(OMutex)     *m_pLock;
	NAMESPACE_VOS(OCondition)  m_aCond;
	CntHTTPCacheList           m_aList;
	ULONG                      m_nSize;
	ULONG                      m_nSizeLimit;
	BOOL                       m_bKeepExpired;

	/** Working method.
	*/
	virtual void SAL_CALL run (void);

	void collect (void);
	void cleanup (void);

	/** Not implemented.
	*/
	CntHTTPWatchDog (const CntHTTPWatchDog& rOther);
	CntHTTPWatchDog& operator= (const CntHTTPWatchDog& rOther);

public:
	CntHTTPWatchDog (void);
	virtual ~CntHTTPWatchDog (void);

	void activate (
		CntStorageNode        *pCache,
		NAMESPACE_VOS(OMutex) *pLock        = NULL,
		ULONG                  nSizeLimit   = (ULONG)(-1),
		BOOL                   bKeepExpired = FALSE);

	virtual void Notify (SfxBroadcaster &rBC, const SfxHint &rHint);
};

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_CNTHTTPDOG_HXX */

