/*************************************************************************
 *
 *  $RCSfile: chttpget.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CHTTPGET_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX
#include <tools/inetmsg.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif

#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXHINT_HXX
#include <svtools/hint.hxx>
#endif
#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _LCKBITEM_HXX
#include <svtools/lckbitem.hxx>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif
#ifndef _SVTOOLS_STRMADPT_HXX
#include <svtools/strmadpt.hxx>
#endif

#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP
#include <com/sun/star/io/XOutputStream.hpp>
#endif

#ifndef _INET_MACROS_HXX
#include <inet/macros.hxx>
#endif
#ifndef _INET_HTTPWRAP_HXX
#include <inet/httpwrap.hxx>
#endif
#ifndef _INETHTTP_HXX
#include <inet/inethttp.hxx>
#endif

#ifndef _CNTBASE_HXX
#include "cntbase.hxx"
#endif
#ifndef _CNTHTTPIMP_HXX
#include "chttpimp.hxx"
#endif
#ifndef _CNTCOOK_HXX
#include "cntcook.hxx"
#endif
#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTNODE_HXX
#include "cntnode.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _DHDRITEM_HXX
#include "dhdritem.hxx"
#endif

#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

using namespace com::sun::star::io;
using namespace com::sun::star::uno;

#ifdef _CHAOS_STORNODE_REF
SV_IMPL_REF(CntStorageNode);
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

#ifdef CHTTPIMP_EXPERIMENTAL_CACHESTREAM
#ifndef _CACHESTR_HXX
#include <tools/cachestr.hxx>
#endif
#endif /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

/*========================================================================
 *
 * CntHTTP... internals.
 *
 *======================================================================*/
#define CHTTPIMP_CACHE_LOCK(mutex) if ((mutex)) (mutex)->acquire()
#define CHTTPIMP_CACHE_UNLOCK(mutex) if ((mutex)) (mutex)->release()

#ifndef ITEMSET_ITEM
#define ITEMSET_ITEM(T, a, b) ((const T&)((a)->SfxItemSet::Get((b))))
#endif

#ifndef ITEMSET_ITEM_DATETIME
#define ITEMSET_ITEM_DATETIME(a, b) ITEMSET_ITEM(SfxDateTimeItem, (a), (b))
#endif

#ifndef ITEMSET_VALUE_DATETIME
#define ITEMSET_VALUE_DATETIME(a, b) \
    (ITEMSET_ITEM_DATETIME((a),(b)).GetDateTime())
#endif

/*
 * CntDirtyItemSet ranges.
 */
CHTTPDOC_DIR_RANGES_IMPL (aDocDirRanges_Impl);

/*========================================================================
 *
 * EXPERIMENTAL: CntHTTPResponseStream_Impl.
 *
 *======================================================================*/
#if 0  /* EXP */

class CntHTTPStream_Impl : public SvStream
{
	virtual ULONG GetData (void *pData, ULONG nSize) const;
	virtual ULONG PutData (const void *pData, ULONG nSize);
	virtual void  FlushData (void);

	virtual ULONG SeekPos (ULONG nPos);
	virtual void  SetSize (ULONG nSize);

public:
	CntHTTPStream_Impl (void);
	virtual ~CntHTTPStream_Impl (void);
};

CntHTTPStream_Impl::CntHTTPStream_Impl (void)
	: SvStream()
{
	SvStream::bIsWritable = TRUE;
}

CntHTTPStream_Impl::~CntHTTPStream_Impl (void)
{
	SvStream::bIsWritable = FALSE;
}

#endif /* EXP */

/*========================================================================
 *
 * CntHTTPCacheLockBytes.
 *
 *======================================================================*/
class CntHTTPCacheLockBytes : public SvAsyncLockBytes
{
	CntStorageNodeRef m_xCache;

public:
	inline CntHTTPCacheLockBytes (
		CntStorageNode *pCache, SvStream *pStrm, BOOL bOwner = FALSE);
	virtual ~CntHTTPCacheLockBytes (void);

	virtual void Terminate (void);
};

inline CntHTTPCacheLockBytes::CntHTTPCacheLockBytes (
	CntStorageNode *pCache, SvStream *pStrm, BOOL bOwner)
	: SvAsyncLockBytes (pStrm, bOwner),
	  m_xCache         (pCache)
{
}

CntHTTPCacheLockBytes::~CntHTTPCacheLockBytes (void)
{
}

void CntHTTPCacheLockBytes::Terminate (void)
{
	SvAsyncLockBytes::Terminate();
}

SV_DECL_IMPL_REF(CntHTTPCacheLockBytes);

/*========================================================================
 *
 * DeliverDocument_Impl.
 *
 *======================================================================*/
static void DeliverDocument_Impl (
	const SvLockBytesRef &rxDocLB,
	const Reference< com::sun::star::uno::XInterface > &rxIfc)
{
	if (rxDocLB.Is())
	{
		Reference< XActiveDataSink > xSink (rxIfc, UNO_QUERY);
		if (xSink.is())
		{
			xSink->setInputStream (Reference< XInputStream > (
				new SvLockBytesInputStream (rxDocLB)));
			return;
		}

		Reference< XOutputStream > xStrm (rxIfc, UNO_QUERY);
		if (xStrm.is())
		{
			Sequence<sal_Int8> aBuffer (16384);
			ErrCode        	   eErrCode = ERRCODE_NONE;
			sal_uInt32         n = 0, k = 0;

			eErrCode = rxDocLB->ReadAt (n, aBuffer.getArray(), 16384, &k);
			while ((eErrCode == ERRCODE_NONE) && (k > 0))
			{
				aBuffer.realloc (sal_Int32(k));
				xStrm->writeBytes (aBuffer);
				aBuffer.realloc (16384);

				n += k;
				k  = 0;

				eErrCode = rxDocLB->ReadAt (n, aBuffer.getArray(), 16384, &k);
			}

			xStrm->closeOutput();
			return;
		}
	}
}

/*========================================================================
 *
 * ShouldUseCache_Impl.
 *
 *======================================================================*/
static BOOL ShouldUseCache_Impl (
	const CntHTTPJob_Impl &rJob,
	const INetURLObject   &rUrl,
	const INetHTTPMessage &rMsg)
{
	const CntOpenModeItem *pItem =
		PTR_CAST(CntOpenModeItem, rJob.GetJob()->GetRequest());
	if (pItem)
	{
		Reference<XOutputStream> xOutputStream (
			pItem->getDataSink(), UNO_QUERY);
		if (xOutputStream.is())
			return FALSE;
	}
	return (rJob.GetParent()->ShouldUseCache (rUrl, rMsg));
}

/*========================================================================
 *
 * CntHTTPGetJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPGetJob_Impl.
 */
CntHTTPGetJob_Impl::CntHTTPGetJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPRequestJob_Impl (pJob, pParent),
	  m_pCache      (NULL),
	  m_bNeedHeader (FALSE),
	  m_bNeedCookie (FALSE)
{
}

/*
 * ~CntHTTPGetJob_Impl.
 */
CntHTTPGetJob_Impl::~CntHTTPGetJob_Impl (void)
{
}

/*
 * queryDeliverDocument.
 */
BOOL CntHTTPGetJob_Impl::queryDeliverDocument (CntHTTPVerifyMode eMode)
{
	// Check context.
	if (eMode == CNTHTTP_VERIFY_ALWAYS)
		return FALSE;

	// Acquire cache access.
	NAMESPACE_VOS(OMutex) *pLock = GetParent()->GetCacheLock();
	CHTTPIMP_CACHE_LOCK (pLock);

	// Setup DocumentHead URL.
	String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aHeadURL += m_aReqURI;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

	// Check for already cached document.
	UINT32 nAttrib = 0;
	ErrCode eErrCode = m_pCache->attrib (aHeadName, 0, 0, nAttrib);
	if (eErrCode != ERRCODE_NONE)
	{
		// Release cache lock and leave.
		CHTTPIMP_CACHE_UNLOCK (pLock);
		return FALSE;
	}

	// Check for invalidated document.
	if ((CHTTPIMP_IS_INVALID(nAttrib)) && (eMode != CNTHTTP_VERIFY_NEVER))
	{
		// Release cache lock and leave.
		CHTTPIMP_CACHE_UNLOCK (pLock);
		return FALSE;
	}

	// Obtain DocumentHead itemset.
	CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
		aDocDirRanges_Impl, aHeadName, STREAM_STD_READ));
	DBG_ASSERTWARNING(
		xDirSet.Is(), "CntHTTPGetJob_Impl: OpenItemSet() failed");
	if (!xDirSet.Is())
	{
		// Inconsistent. Invalidate Document.
		InvalidateDocument (*m_pCache, m_aReqURI);

		// Release cache lock and leave.
		CHTTPIMP_CACHE_UNLOCK (pLock);
		return FALSE;
	}

	if (eMode == CNTHTTP_VERIFY_ONCE)
	{
		// Obtain last document update time.
		const DateTime &rLastUpdate = ITEMSET_VALUE_DATETIME(
			xDirSet, WID_LAST_UPDATE);

		// Check against startup time.
		if (rLastUpdate < GetParent()->GetStartupTime())
		{
			// Release cache lock and leave.
			CHTTPIMP_CACHE_UNLOCK (pLock);
			return FALSE;
		}
	}

	// Check for redirection.
	if (CHTTPIMP_IS_REDIRECT(nAttrib))
	{
		// Redirection. Obtain DocumentHeader.
		CntDocHeaderRef xHdr (ITEMSET_VALUE(
			xDirSet, CntDocHeaderItem, WID_DOCUMENT_HEADER));
		if (!xHdr.Is())
		{
			// Release cache lock and leave.
			CHTTPIMP_CACHE_UNLOCK (pLock);
			return FALSE;
		}

		// Check for Location header field.
		ULONG i, n = xHdr->GetHeaderCount();
		for (i = 0; i < n; i++)
		{
			if (xHdr->GetHeaderName(i).CompareIgnoreCaseToAscii(
				"Location") == COMPARE_EQUAL)
			{
				// Obtain new location.
				String aLocation (xHdr->GetHeaderValue(i));

				// Re-initialize document node.
				setRedirectURL (aLocation);

				// Release document itemset and cache lock.
				xDirSet.Clear();
				CHTTPIMP_CACHE_UNLOCK (pLock);

				// Check redirected document.
				return queryDeliverDocument (eMode);
			}
		}
	}

	// Obtain document node.
	CntNodeRef xDocNode (GetJob()->GetSubject());
	if (xDocNode.Is())
	{
		// Deliver document attributes.
		if (nAttrib & CNTDIRENTRY_ATTRIB_VISITED)
			xDocNode->Put (CntBoolItem (WID_IS_READ, TRUE));
		if (nAttrib & CNTDIRENTRY_ATTRIB_MARKED)
			xDocNode->Put (CntBoolItem (WID_IS_MARKED, TRUE));

		// Release document itemset and cache lock.
		SfxItemSet aDirSet (*xDirSet);
		xDirSet.Clear();

		// Release cache lock and deliver document.
		CHTTPIMP_CACHE_UNLOCK (pLock);
		deliverDocument (aDirSet);
	}
	return xDocNode.Is();
}

/*
 * deliverDocument.
 */
void CntHTTPGetJob_Impl::deliverDocument (const SfxItemSet &rPropSet)
{
	// Obtain document node.
	CntNodeRef xDocNode (GetJob()->GetSubject());
	if (xDocNode.Is())
	{
		// The document stream.
		CntHTTPCacheLockBytesRef xDocLB;

		// Obtain document size.
		ULONG nDocSize = ITEMSET_VALUE_UINT32 (&rPropSet, WID_DOCUMENT_SIZE);

		// Obtain cache node.
		CntStorageNodeRef xCache (GetJob()->GetCacheNode());
		if (xCache.Is())
		{
			// Acquire cache access.
			NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

			// Obtain document stream.
			String aBodyURL (S2U (CHTTPIMP_DOCUMENT_BODY_PREFIX));
			aBodyURL += m_aReqURI;
			String aBodyName (CHTTPIMP_SHORT_NAME(aBodyURL));

			SvStream *pStrm = xCache->openStream (aBodyName, STREAM_STD_READ);
			DBG_ASSERTWARNING(
				pStrm, "CntHTTPGetJob_Impl::deliverDocument(): no Stream");
			if (pStrm)
			{
				// Initialize document stream.
				xDocLB = new CntHTTPCacheLockBytes (xCache, pStrm, TRUE);
				xDocLB->Seek (nDocSize);
				xDocLB->Terminate();
			}
		}

		// Deliver document stream.
		if (xDocLB.Is())
		{
			const CntOpenModeItem *pItem =
				PTR_CAST(CntOpenModeItem, GetJob()->GetRequest());
			if (pItem)
				DeliverDocument_Impl (&*xDocLB, pItem->getDataSink());
			xDocNode->Put (SfxLockBytesItem (WID_DOCUMENT_BODY, xDocLB));
		}

#ifdef DBG_UTIL_PRIVATE
		String aTrace ("DOC: ");
		aTrace += ITEMSET_VALUE_STRING (xDocNode, WID_REAL_URL);
		aTrace += " (Body: ";
		aTrace += (ULONG)(ITEMSET_VALUE(
			xDocNode, SfxLockBytesItem, WID_DOCUMENT_BODY));
		aTrace += ')';
		_TRACE(aTrace);
#endif /* DBG_UTIL_PRIVATE */

		// Deliver document properties.
		xDocNode->Put (rPropSet);
	}
}

/*
 * prepareRequest.
 */
BOOL CntHTTPGetJob_Impl::prepareRequest (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg) const
{
	// Common initialization.
	CntHTTPRequestJob_Impl::prepareRequest (rReqUrl, rReqMsg);

	// Obtain cache node.
	CntStorageNodeRef xCache (GetJob()->GetCacheNode());
	if (xCache.Is())
	{
		// Acquire cache access.
		NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

		// Obtain DocumentHeader.
		CntDocHeaderRef xHdr (NULL);
		if (GetDocumentHeader (m_aReqURI, *xCache, xHdr))
		{
			// Check for Last-Modified header field.
			ULONG i, n = xHdr->GetHeaderCount();
			for (i = 0; i < n; i++)
			{
				if (xHdr->GetHeaderName(i).CompareIgnoreCaseToAscii (
					"Last-Modified") == COMPARE_EQUAL)
				{
					// Make request a 'Conditional-GET'.
					String aLastModified (xHdr->GetHeaderValue(i));
					m_pReqMsg->SetIfModifiedSince (aLastModified);
					break;
				}
			}
		}
	}

	// Accept.
	rReqMsg.SetAccept (S2U ("image/png, image/*, */*"));

	// Done.
	return TRUE;
}

/*
 * prepareResponse.
 */
BOOL CntHTTPGetJob_Impl::prepareResponse (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg,
	INetHTTPMessage     &rResMsg) const
{
	// Create response document stream.
	SvLockBytesRef xDocLB;

#ifdef CHTTPIMP_EXPERIMENTAL_CACHESTREAM

	// Create cache stream.
	SvCacheStream *pStrm = new SvCacheStream (4 << 10);
	pStrm->SetFilenameHdl (
		LINK (this, CntHTTPRequestJob_Impl, SwapOutHandler));
	xDocLB = new SvAsyncLockBytes (pStrm, TRUE);

#else /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

	const CntOpenModeItem *pItem =
		PTR_CAST(CntOpenModeItem, GetJob()->GetRequest());
	if (pItem)
	{
		Reference< XOutputStream > xOutputStream (pItem->getDataSink(),
												  UNO_QUERY);
		if (xOutputStream.is())
		{
			// Direct response to provided OutputStream.
			xDocLB = new SvOutputStreamOpenLockBytes (xOutputStream);
		}
	}

	if (!xDocLB.Is())
	{
		CntStorageNodeRef xCache (GetJob()->GetCacheNode());
		if (xCache.Is())
		{
			// Acquire cache access.
			NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

			// Create DocumentBody stream.
			String aBodyURL (S2U (CHTTPIMP_DOCUMENT_BODY_PREFIX));
			aBodyURL.AppendAscii (CHTTPIMP_RESPONSE_PREFIX);
			aBodyURL += rReqUrl.GetMainURL();
			String aBodyName (CHTTPIMP_SHORT_NAME(aBodyURL));

			SvStream *pStrm = xCache->openStream (
				aBodyName,
				STREAM_READWRITE | STREAM_TRUNC | STREAM_SHARE_DENYWRITE);
			DBG_ASSERTWARNING(
				pStrm, "CntHTTPGetJob_Impl::prepareResponse(): no Stream");
			if (pStrm)
			{
				ErrCode eErrCode = xCache->attrib (
					aBodyName, 0, CNTDIRENTRY_ATTRIB_HIDDEN);
				DBG_ASSERTWARNING(
					eErrCode == ERRCODE_NONE,
					"CntHTTPGetJob_Impl::prepareResponse(): not hidden");

				rResMsg.SetDocumentName (aBodyName);
				xDocLB = new CntHTTPCacheLockBytes (xCache, pStrm, TRUE);
			}
		}
	}

	if (!xDocLB.Is())
	{
		// Create memory stream.
		xDocLB = new SvAsyncLockBytes (new SvMemoryStream(), TRUE);
	}

#endif /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

	rResMsg.SetDocumentLB (xDocLB);

	// Finish preparation.
	return CntHTTPRequestJob_Impl::prepareResponse (
		rReqUrl, rReqMsg, rResMsg);
}

/*
 * SwapOutHandler.
 */
#ifdef CHTTPIMP_EXPERIMENTAL_CACHESTREAM

IMPL_LINK (CntHTTPGetJob_Impl, SwapOutHandler, SvCacheStream*, pStrm)
{
	if (pStrm == NULL)
		return 0;

	CntStorageNode *pCache = GetJob()->GetCacheNode();
	if (pCache == NULL)
		return 0;

	// Create DocumentBody stream.
	String aBodyURL (S2U (CHTTPIMP_DOCUMENT_BODY_PREFIX));
	aBodyURL += m_aReqURI;
	String aBodyName (CHTTPIMP_SHORT_NAME(aBodyURL));

	SvStream *pSwap = pCache->openStream (
		aBodyName, STREAM_READWRITE | STREAM_TRUNC | STREAM_SHARE_DENYWRITE);
	DBG_ASSERT(
		pSwap, "CntHTTPGetJob_Impl::SwapOutHandler(): no Stream");
	if (pSwap)
		pCache->attrib (aBodyName, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

	pStrm->SetSwapStream (pSwap);
	return 0;
}

#endif /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

/*
 * StoreResponse.
 */
void CntHTTPGetJob_Impl::StoreResponse (
	const String       &rResURL,
	INetHTTPMessage    &rResMsg,
	CntStorageNode     &rCache,
	CntStoreItemSetRef &rxDirSet)
{
	// Acquire cache access.
	NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

	// Obtain DocumentHead itemset.
	String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
	aHeadURL += rResURL;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

	rxDirSet = rCache.openItemSet (
		aDocDirRanges_Impl, aHeadName, STREAM_STD_READWRITE);
	DBG_ASSERTWARNING(
		rxDirSet.Is(), "CntHTTPGetJob_Impl: openItemSet() failed");
	if (rxDirSet.Is())
	{
		// Check ResponseHeader.
		if (m_bNeedHeader)
		{
			// Mark DocumentHead available.
			m_bNeedHeader = FALSE;

			// Store LastUpdate.
			DateTime aNow;
			aNow.ConvertToUTC();

			rxDirSet->Put (SfxDateTimeItem (
				WID_LAST_UPDATE, aNow));

			// Store ContentType (or default).
			String aContentType (rResMsg.GetContentType());
			if (aContentType.Len() == 0)
			{
				aContentType.AssignAscii (CONTENT_TYPE_STR_X_CNT_HTTPFILE);
				rResMsg.SetContentType (aContentType);
			}
			rxDirSet->Put (CntContentTypeItem (
				WID_CONTENT_TYPE, aContentType));

			// Store DocumentHeader.
			CntDocHeaderRef xHead (new CntDocHeader (rResMsg));
			xHead->SetDocumentLB (NULL);

			rxDirSet->Put (CntDocHeaderItem (
				WID_DOCUMENT_HEADER, xHead));
		}
	}
}

/*
 * Execute.
 */
const SfxPoolItem* CntHTTPGetJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntHTTPJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntHTTPGetJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntHTTPGetJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		Finished (STATE_ERROR);
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntHTTPGetJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			Finished (STATE_ERROR);
			return NULL;
		}

		// Obtain request URI.
		setRequestURL();

		// Check request.
		USHORT nWhich = pReq->Which();
		if ((nWhich == WID_OPEN) || (nWhich == WID_UPDATE))
		{
			if (queryDeliverDocument (GetParent()->GetVerifyMode()))
			{
				// Delivered from cache.
				m_eState = STATE_DONE;
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			// Offline. Notify caller.
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into job log and finish.
			pJob->Log();
			Finished();
			return NULL;
		}

		// Initialize request message.
		delete m_pReqMsg;
		m_pReqMsg = new INetHTTPMessage;
		if (!prepareRequest (m_aReqURL, *m_pReqMsg))
		{
			// Failure.
			Finished (STATE_ERROR);
			return NULL;
		}

		// Next state.
		m_eState = STATE_REQUEST;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_REQUEST)
	{
		// Initiate document load. Obtain Wrapper.
		NAMESPACE_INET(INetHTTPWrapper) *pWrapper;
		if (!GetParent()->GetWrapper (pWrapper))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPGetJob_Impl::Execute(): no HTTP wrapper");
			Finished (STATE_ERROR);
			return NULL;
		}

		// Create GetRequest.
		NAMESPACE_VOS(ORef)<NAMESPACE_INET(INetHTTPGetRequest)> xRequest;
		if (!pWrapper->newHTTPGetRequest (xRequest))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPGetJob_Impl::Execute(): no HTTP request");
			Finished (STATE_ERROR);
			return NULL;
		}
		m_xRequest = &*xRequest;

		// Initialize response message.
		delete m_pResMsg;
		m_pResMsg = new INetHTTPMessage;
		if (!prepareResponse (m_aReqURL, *m_pReqMsg, *m_pResMsg))
		{
			// Failure.
			m_xRequest.unbind();
			Finished (STATE_ERROR);
			return NULL;
		}

		// Start document load.
		m_bNeedHeader = m_bNeedCookie = TRUE;
		m_eState = STATE_RESPONSE;
		if (pReq->Which() == WID_SYNCHRONIZE)
		{
			if (!xRequest->reloadDocument (
				m_aReqURI, *m_pReqMsg, *m_pResMsg, ExecuteCallback, this))
			{
				// Failure.
				m_xRequest.unbind();
				Finished (STATE_ERROR);
				return NULL;
			}
		}
		else
		{
			if (!xRequest->loadDocument (
				m_aReqURI, *m_pReqMsg, *m_pResMsg, ExecuteCallback, this))
			{
				// Failure.
				m_xRequest.unbind();
				Finished (STATE_ERROR);
				return NULL;
			}
		}

		// Wait for next callback.
		return NULL;
	}

	if (m_eState == STATE_DONE)
	{
		// Finished.
		Finished();
		return NULL;
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntHTTPGetJob_Impl::ExecuteHandler (
	NAMESPACE_INET(INetHTTPRequest) *pRequest,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntHTTPGetJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	DBG_ASSERTWARNING(
		m_xRequest == pRequest,
		"CntHTTPGetJob_Impl::ExecuteHandler(): wrong pRequest");
	if (!(m_xRequest == pRequest))
		return;

	// Check callback reason.
	if (nReplyCode == request::REPLY_RESPONSE_WAIT)
	{
		// Deliver current DocumentSize.
		CntHTTPRequestJob_Impl::ExecuteHandler (
			pRequest, nReplyCode, pReplyText);

		// Check ResponseHeader.
		if (m_bNeedHeader && m_xRequest.isValid() &&
			m_xRequest->isResponseHeaderParsed())
		{
			// Check RequestStatus.
			int nStatusCode = m_xRequest->getStatusCode();

			if ((nStatusCode     == request::REPLY_09) ||
				(nStatusCode/100 == 2                    )    )
			{
				// Check for Cookies.
				if (m_bNeedCookie)
				{
					// Mark Cookies done.
					m_bNeedCookie = FALSE;

					// SetCookie.
					GetParent()->SetCookie (m_aReqURL, *m_pResMsg, pJob);
					if (pJob->IsCancelled() || pJob->IsDone())
						return;
				}

				// Store response DocumentHead itemset.
				String aURL (S2U (CHTTPIMP_RESPONSE_PREFIX));
				aURL += m_aReqURI;

				CntStoreItemSetRef xDirSet;
				StoreResponse (aURL, *m_pResMsg, *m_pCache, xDirSet);
				if (xDirSet.Is())
				{
					// Release DocumentHead itemset.
					SfxItemSet aDirSet (*xDirSet);
					xDirSet.Clear();

					// Deliver DocumentHead itemset.
					pJob->GetSubject()->Put (aDirSet);
					if (pJob->IsCancelled() || pJob->IsDone())
						return;
				}
			}
		}
	}
	else if ((nReplyCode     == request::REPLY_09) ||
			 (nReplyCode/100 == 2                    )    )
	{
		// Check for Cookies.
		if (m_bNeedCookie)
		{
			// Mark Cookies done.
			m_bNeedCookie = FALSE;

			// SetCookie.
			GetParent()->SetCookie (m_aReqURL, *m_pResMsg, pJob);
			if (pJob->IsCancelled() || pJob->IsDone())
				return;
		}

		// Store response DocumentHead itemset.
		String aURL (S2U (CHTTPIMP_RESPONSE_PREFIX));
		aURL += m_aReqURI;

		CntStoreItemSetRef xDirSet;
		StoreResponse (aURL, *m_pResMsg, *m_pCache, xDirSet);
		if (xDirSet.Is())
		{
			// Store final DocumentSize.
			xDirSet->Put (CntUInt32Item (
				WID_DOCUMENT_SIZE, m_pResMsg->GetDocumentSize()));

			// Release DocumentHead itemset.
			SfxItemSet aDirSet (*xDirSet);
			xDirSet.Clear();

			// Deliver DocumentHead itemset.
			pJob->GetSubject()->Put (aDirSet);
			if (pJob->IsCancelled() || pJob->IsDone())
				return;
		}

		// Replace current document with response document.
		ReplaceDocument (*m_pCache, m_aReqURI);

		if (!(ShouldUseCache_Impl (*this, m_aReqURL, *m_pResMsg)))
		{
			// Acquire cache access.
			NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

			// Invalidate response document.
			InvalidateDocument (*m_pCache, m_aReqURI);
		}

		// Modified document. Notify caller.
		pJob->GetSubject()->Broadcast (CntNodeHint (
			pJob->GetSubject(), CNT_ACTION_MODIFIED, pJob));

		// Done.
		Finished();
	}
	else if (nReplyCode/100 == 3)
	{
		// Handle Multiple Choices (3xx) Reply.
		if ((nReplyCode == request::REPLY_MOVED_PERMANENT) ||
			(nReplyCode == request::REPLY_MOVED_TEMPORARY)    )
		{
			if (m_pResMsg->GetLocation().Len())
			{
				// Check for Cookies.
				if (m_bNeedCookie)
				{
					// Mark Cookies done.
					m_bNeedCookie = FALSE;

					// SetCookie.
					GetParent()->SetCookie (m_aReqURL, *m_pResMsg, pJob);
					if (pJob->IsCancelled() || pJob->IsDone())
						return;
				}

				// Store response DocumentHead itemset.
				String aURL (S2U (CHTTPIMP_RESPONSE_PREFIX));
				aURL += m_aReqURI;

				CntStoreItemSetRef xDirSet;
				StoreResponse (aURL, *m_pResMsg, *m_pCache, xDirSet);
				if (xDirSet.Is())
				{
					// Store final DocumentSize.
					xDirSet->Put (CntUInt32Item (
						WID_DOCUMENT_SIZE, m_pResMsg->GetDocumentSize()));

					// Release DocumentHead itemset.
					xDirSet.Clear();
				}

				// Replace current document with response document.
				ReplaceDocument (*m_pCache, m_aReqURI);

				// Check for cacheable (permanent) redirection.
				if ((nReplyCode == request::REPLY_MOVED_PERMANENT) &&
					(ShouldUseCache_Impl (*this, m_aReqURL, *m_pResMsg)))
				{
					// Acquire cache access.
					NAMESPACE_VOS(OGuard) aGuard (
						GetParent()->GetCacheLock());

					// Mark as redirection.
					String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
					aHeadURL += m_aReqURI;
					String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

					m_pCache->attrib (
						aHeadName, 0, CHTTPIMP_ATTRIB_REDIRECT);
				}
				else
				{
					// Acquire cache access.
					NAMESPACE_VOS(OGuard) aGuard (
						GetParent()->GetCacheLock());

					// Invalidate response document.
					InvalidateDocument (*m_pCache, m_aReqURI);
				}

				// Obtain new location.
				String aLocation (m_pResMsg->GetLocation());

				// Cleanup current request.
				m_xRequest.unbind();
				DELETEZ (m_pReqMsg);
				DELETEZ (m_pResMsg);

				// Re-initialize document node.
				setRedirectURL (aLocation);

				// Restart.
				m_eState = STATE_NONE;
				GetRootNode()->RescheduleJob (pJob);
				return;
			}

			// Done.
			Finished();
		}
		else if (nReplyCode == request::REPLY_NOT_MODIFIED)
		{
			// Acquire cache access.
			NAMESPACE_VOS(OMutex) *pLock = GetParent()->GetCacheLock();
			CHTTPIMP_CACHE_LOCK (pLock);

			// Invalidate response document.
			String aURL (S2U (CHTTPIMP_RESPONSE_PREFIX));
			aURL += m_aReqURI;

			InvalidateDocument (*m_pCache, aURL);

			// Obtain DocumentHead itemset.
			aURL.AssignAscii (CHTTPIMP_DOCUMENT_HEAD_PREFIX);
			aURL += m_aReqURI;
			String aName (CHTTPIMP_SHORT_NAME(aURL));

			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aDocDirRanges_Impl, aName, STREAM_STD_READWRITE));
			DBG_ASSERTWARNING(
				xDirSet.Is(),
				"CntHTTPGetJob_Impl::ExecuteHandler(): no ItemSet");
			if (xDirSet.Is())
			{
				// Store LastUpdate.
				DateTime aNow;
				aNow.ConvertToUTC();

				xDirSet->Put (SfxDateTimeItem (
					WID_LAST_UPDATE, aNow));

				// Release document itemset.
				SfxItemSet aDirSet (*xDirSet);
				xDirSet.Clear();

				// Release cache lock and deliver document.
				CHTTPIMP_CACHE_UNLOCK (pLock);
				deliverDocument (aDirSet);
			}
			else
			{
				// Release cache lock and deliver document.
				CHTTPIMP_CACHE_UNLOCK (pLock);
				queryDeliverDocument();
			}

			// Done.
			Finished();
		}
		else
		{
			// Unknown.
			Finished();
		}
	}
	else
	{
		// Call base request handler.
		CntHTTPRequestJob_Impl::ExecuteHandler (
			pRequest, nReplyCode, pReplyText);
	}
}

/*
 * Notify.
 */
void CntHTTPGetJob_Impl::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		// Check for abort.
		if (pJob->IsCancelled())
		{
			// Obtain document node.
			CntNodeRef xDocNode (pJob->GetSubject());
			if (xDocNode.Is())
			{
				// Release current document.
				xDocNode->Put (SfxLockBytesItem (WID_DOCUMENT_BODY, NULL));
				xDocNode.Clear();
			}
		}
	}
	CntHTTPRequestJob_Impl::Notify (rBC, rHint);
}

/*========================================================================
 *
 * CntHTTPHeadJob_Impl implementation.
 *
 *======================================================================*/
#if 0  /* NYI */

/*
 * CntHTTPHeadJob_Impl.
 */
CntHTTPHeadJob_Impl::CntHTTPHeadJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPRequestJob_Impl (pJob, pParent),
	  m_pCache               (NULL),
	  m_pHeadReq             (NULL),
	  m_bNeedHeader          (FALSE)
{
}

/*
 * ~CntHTTPHeadJob_Impl.
 */
CntHTTPHeadJob_Impl::~CntHTTPHeadJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntHTTPHeadJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntHTTPJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	if (pJob == NULL)
		return NULL;

	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq == NULL)
		return NULL;

	// Initialize.
	if (!pJob->IsRescheduled())
	{
		// Obtain request URI.
		SetRequestURL();

		// ...
		m_pReqMsg = InitRequestMessage(...);
		m_pResMsg = InitResponseMessage(...);
		if (m_pResMsg == NULL)
		{
			// Failure.
			pJob->Done();
			return NULL;
		}

		// Reschedule for delayed header load.
		GetRootNode()->RescheduleJob (pJob);
	}

	// Initiate header load. Obtain Wrapper.
	NAMESPACE_INET(INetHTTPWrapper) *pWrapper = GetParent()->GetWrapper();
	DBG_ASSERT(
		pWrapper, "CntHTTPHeadJob_Impl: GetWrapper() failed");
	if (pWrapper == NULL)
	{
		// Failure.
		pJob->Done();
		return NULL;
	}

	// Create HeadRequest.
	if (!pWrapper->newHTTPHeadRequest (m_pHeadReq))
	{
		// Failure.
		DBG_ERRORFILE ("CntHTTPHeadJob_Impl: CreateHTTPHeadRequest() failed");
		pJob->Cancel();
		return NULL;
	}

	// Check and apply any ProxyPolicy.
	ApplyProxyPolicy (m_aReqURL, *m_pHeadReq);

	// Start header load.
	if (!m_pHeadReq->ReloadHeader (
		m_aReqURI, *m_pReqMsg, *m_pResMsg, ExecuteCallback, this))
	{
		// Failure.
		DELETEZ (m_pHeadReq);
		pJob->Done();
		return NULL;
	}

	// Wait for ExecuteCallback.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntHTTPHeadJob_Impl::ExecuteHandler (
	INetCoreHTTPRequest *pRequest, int nReplyCode, String *pReplyText)
{
	//...
	CntHTTPRequestJob_Impl::ExecuteHandler (
		pRequest, nReplyCode, pReplyText);
}

/*
 * Notify.
 */
void CntHTTPHeadJob_Impl::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntHTTPRequestJob_Impl::Notify (rBC, rHint);
}

#endif /* NYI */

