/*************************************************************************
 *
 *  $RCSfile: chttpimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTHTTPIMP_HXX
#define _CNTHTTPIMP_HXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef _REF_HXX
#include <tools/ref.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif
#ifndef _VOS_THREAD_HXX
#include <vos/thread.hxx>
#endif
#ifndef _VOS_REF_HXX
#include <vos/ref.hxx>
#endif

#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXHINT_HXX
#include <svtools/hint.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif
#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif

#ifndef _INET_MACROS_HXX
#include <inet/macros.hxx>
#endif
#ifndef _INET_CONFIG_HXX
#include <inet/inetcfg.hxx>
#endif

#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTCOOK_HXX
#include "cntcook.hxx"
#endif
#ifndef _CHAOS_HTTPITEM_HXX
#include "httpitem.hxx"
#endif

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

#ifndef _CHAOS_STORNODE_REF
#define _CHAOS_STORNODE_REF
class CntStorageNode;
SV_DECL_REF(CntStorageNode)
#endif

class CntNode;
class CntNodeJobQueue;
class CntStoreItemSet;
class CntStoreItemSetRef;
class CntDocHeaderRef;

class CntHTTPWatchDog;

#if defined TF_UCB
}
#endif // TF_UCB

#ifdef _USE_NAMESPACE
namespace inet {
#endif

class INetHTTPWrapper;
class INetHTTPRequest;
class INetHTTPGetRequest;
class INetHTTPHeadRequest;
class INetHTTPPostRequest;
class INetHTTPPutRequest;

#ifdef _USE_NAMESPACE
}
#endif

class INetMessage;
class INetHTTPMessage;

#undef  CHTTPIMP_EXPERIMENTAL_CACHESTREAM
#ifdef  CHTTPIMP_EXPERIMENTAL_CACHESTREAM
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
class SvCacheStream;
#endif /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

/*========================================================================
 *
 * class CntHTTP... common internals.
 *
 *======================================================================*/
#define CNTHTTP_ROOT_URL "private:httpcache"

#define CHTTPIMP_DOCUMENT_HEAD_PREFIX "head:"
#define CHTTPIMP_DOCUMENT_BODY_PREFIX "body:"

#define CHTTPIMP_RESPONSE_PREFIX "tmp:"
#define CHTTPIMP_OBSOLETE_PREFIX "obs:"

#define CHTTPIMP_SHORT_NAME(a) (CntStorageNode::makeShortName((a)))

#define CHTTPIMP_JOBQUEUE_MIN      2          /*  2 queues */
#define CHTTPIMP_SIZELIMIT_DEFAULT (10 << 20) /* 10 MByte  */

#define CHTTPIMP_ATTRIB_INVALID \
    CNTDIRENTRY_ATTRIB_MARKEDFORDELETE

#define CHTTPIMP_IS_INVALID(a) \
	(( ((a) & CNTDIRENTRY_ATTRIB_MARKED) != CNTDIRENTRY_ATTRIB_MARKED) && \
	 ( ((a) & CHTTPIMP_ATTRIB_INVALID  ) == CHTTPIMP_ATTRIB_INVALID  )    )

#define CHTTPIMP_ATTRIB_REDIRECT \
    (CHTTPIMP_ATTRIB_INVALID | CNTDIRENTRY_ATTRIB_MARKED)

#define CHTTPIMP_IS_REDIRECT(a) \
	(((a) & CHTTPIMP_ATTRIB_REDIRECT) == CHTTPIMP_ATTRIB_REDIRECT)

#ifndef CNTDIRENTRY_ATTRIB_VISITED
#define CNTDIRENTRY_ATTRIB_VISITED CNTDIRENTRY_ATTRIB_USER1
#endif

#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

#ifndef COPYCTOR_API
#define COPYCTOR_API(C) C (const C&); C& operator= (const C&)
#endif

#ifndef ITEMSET_VALUE_STRING
#define ITEMSET_VALUE_STRING(a, b) ITEMSET_VALUE((a), CntStringItem, (b))
#endif

#ifndef ITEMSET_VALUE_UINT32
#define ITEMSET_VALUE_UINT32(a, b) ITEMSET_VALUE((a), CntUInt32Item, (b))
#endif

inline UniString S2U (const sal_Char *pszAscii)
{
	return UniString::CreateFromAscii (pszAscii);
}

/*
 * CntHTTPRootNode: CntStoreItemSet Ranges.
 */
#define CHTTPBOX_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_SIZE,                  WID_SIZE, \
	WID_HTTP_CONNECTION_LIMIT, WID_HTTP_CONNECTION_LIMIT, \
	WID_HTTP_COOKIE_MANAGER,   WID_HTTP_COOKIE_MANAGER, \
	WID_SIZE_LIMIT,            WID_SIZE_LIMIT, \
	WID_HTTP_KEEP_EXPIRED,     WID_HTTP_KEEP_EXPIRED, \
	WID_HTTP_VERIFY_MODE,      WID_HTTP_VERIFY_MODE, \
	WID_HTTP_NOCACHE_LIST,     WID_HTTP_NOCACHE_LIST, \
	0 \
};

#define CHTTPBOX_USER_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_HTTP_COOKIE_MANAGER,   WID_HTTP_COOKIE_MANAGER, \
	0 \
};

/*
 * CntHTTPDocumentNode: CntStoreItemSet Ranges.
 */
#define CHTTPDOC_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_CONTENT_TYPE,    WID_CONTENT_TYPE, \
	WID_LAST_UPDATE,     WID_LAST_UPDATE, \
	WID_DOCUMENT_HEADER, WID_DOCUMENT_HEADER, \
	WID_DOCUMENT_SIZE,   WID_DOCUMENT_SIZE, \
	0 \
};

/*=======================================================================
 *
 * Debug trace environment.
 *
 *=====================================================================*/
#ifdef DBG_UTIL_PRIVATE
#include <stdio.h>

#if (defined(WIN) || defined(WNT) || defined(OS2))
#define _TRACELOGNAME "c:\\cnthttp.log"
#elif (defined(UNX))
#define _TRACELOGNAME "/tmp/cnthttp.log"
#else
#define _TRACELOGNAME "cnthttp.log"
#endif

#ifdef WIN
#define _TRACELOGFORMAT "%ls\n"
#else
#define _TRACELOGFORMAT "%s\n"
#endif /* WIN */

#define _TRACE(a) \
{ \
	FILE *fp = fopen (_TRACELOGNAME, "a+"); \
	if (fp) \
	{ \
		fprintf (fp, _TRACELOGFORMAT, (const char *)((a))); \
		fclose (fp); \
	} \
}

#else
#define _TRACE(a)
#endif /* DBG_UTIL_PRIVATE */

/*========================================================================
 *
 * CntHTTPRootNode_Impl interface.
 *
 *======================================================================*/
class CntHTTPRootNode_Impl
{
	/** Representation.
	*/
	CntNode                         *m_pParent;
	CntHTTPWatchDog                 *m_pWatchDog;
	NAMESPACE_VOS(OMutex)           *m_pLock;

	NAMESPACE_INET(INetHTTPWrapper) *m_pWrapper;
	NAMESPACE_VOS(ORef)<NAMESPACE_INET(INetConfig)> m_xConfig;

	DateTime                         m_aStartupTime;
	String                           m_aNoCacheList;
	CntConnMode                      m_eConnMode;
	CntHTTPVerifyMode                m_eVerifyMode;
	ULONG                            m_nJobQueueLimit;
	ULONG                            m_nSizeLimit;
	BOOL                             m_bKeepExpired;

	/** Job Management.
	*/
	void InsertJob (
		CntNodeJobList *pJobList, CntNodeJob *pJob, ULONG nIndex);

	/** MustEnqueueJob (when sequential execution required).
	*/
	BOOL MustEnqueueJob (
		CntNodeJobList *pJobList, CntNodeJob *pJob);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPRootNode_Impl);

public:
	CntHTTPRootNode_Impl (CntNode *pParent);
	virtual ~CntHTTPRootNode_Impl (void);

	CntNode*               GetParent (void) const { return m_pParent; }
	NAMESPACE_VOS(OMutex)* GetCacheLock (void) { return m_pLock; }
	CntStoreItemSet*       GetBoxDirItemSet (CntStorageNode *pBoxDir) const;

	/** StartupTime.
	*/
	const DateTime& GetStartupTime (void) const { return m_aStartupTime; }
	void            SetStartupTime (const DateTime& rStartupTime)
	{
		m_aStartupTime = rStartupTime;
	}

	/** NoCacheList.
	*/
	const String& GetNoCacheList (void) const { return m_aNoCacheList; }
	void          SetNoCacheList (const String& rNoCacheList)
	{
		m_aNoCacheList = rNoCacheList;
	}

	BOOL ShouldUseCache (
		const INetURLObject   &rUrl,
		const INetHTTPMessage &rMsg) const;

	/** ConnMode.
	*/
	CntConnMode GetConnMode (void) const { return m_eConnMode; }
	void        SetConnMode (CntConnMode eConnMode);

	/** VerifyMode.
	*/
	CntHTTPVerifyMode GetVerifyMode (void) const
	{
		if (m_eConnMode == CNT_CONN_MODE_ONLINE)
			return m_eVerifyMode;
		else
			return CNTHTTP_VERIFY_NEVER;
	}

	void SetVerifyMode (USHORT eMode)
	{
		m_eVerifyMode = (CntHTTPVerifyMode)eMode;
	}

	/** JobQueueLimit.
	*/
	ULONG GetJobQueueLimit (void) const { return m_nJobQueueLimit; }
	void  SetJobQueueLimit (ULONG nLimit)
	{
		m_nJobQueueLimit = max (nLimit, CHTTPIMP_JOBQUEUE_MIN);
	}

	/** SizeLimit.
	*/
	ULONG GetSizeLimit (void) const { return m_nSizeLimit; }
	void  SetSizeLimit (ULONG nLimit)
	{
		m_nSizeLimit = nLimit;
	}

	/** KeepExpired.
	*/
	BOOL GetKeepExpired (void) const { return m_bKeepExpired; }
	void SetKeepExpired (BOOL bKeepExpired = TRUE)
	{
		m_bKeepExpired = bKeepExpired;
	}

	/** Priority, EnqueueJob, DequeueJob.
	*/
	USHORT Priority (CntNodeJob *pJob);
	CntNodeJob* EnqueueJob (
		CntNodeJobQueue *pJobQueue, CntNodeJob *pJob);
	CntNodeJob* DequeueJob (
		CntNodeJobQueue *pJobQueue, CntNodeJob *pJob);

	/** Config, Wrapper.
	*/
	sal_Bool GetConfig (
		NAMESPACE_VOS(ORef)<NAMESPACE_INET(INetConfig)> &rxConfig);
	sal_Bool GetWrapper (
		NAMESPACE_INET(INetHTTPWrapper) *&rpWrapper);

	/** Cookie processing.
	*/
	String GetCookie (
		const INetURLObject &rURL,
		CntNodeJob          *pJob = NULL);

	void SetCookie (
		const INetURLObject &rURL,
		const INetMessage   &rMsg,
		CntNodeJob          *pJob = NULL);

	BOOL SetCookie (
		const INetURLObject &rURL,
		const String        &rCookieField,
		CntHTTPCookie       &rCookie);
};

/*========================================================================
 *
 * CntHTTPJobCookiePolicy_Impl interface.
 *
 *======================================================================*/
class CntHTTPJobCookiePolicy_Impl : public CntHTTPCookiePolicy
{
	/** Representation.
	*/
	CntNodeJobRef m_xJob;

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPJobCookiePolicy_Impl);

public:
	CntHTTPJobCookiePolicy_Impl (CntNodeJob *pJob = NULL);
	virtual ~CntHTTPJobCookiePolicy_Impl (void);

	/** CookiePolicy implementation.
	*/
	virtual BOOL shouldAcceptCookie (
		const String &rUrl,
		List         &rCookieList);

	virtual BOOL shouldUseCookie (
		const String &rUrl,
		List         &rCookieList);
};

/*========================================================================
 *
 * CntHTTPJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPJob_Impl : public SfxListener, public SvRefBase
{
	/** Representation.
	*/
	CntNodeJobRef         m_xJob;
	CntHTTPRootNode_Impl *m_pParent;

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPJob_Impl);

protected:
	/** Destruction (via SvRefBase).
	*/
	virtual ~CntHTTPJob_Impl (void);

	/** Broadcast (notify master job client).
	*/
	void Broadcast (const SfxHint& rHint);

	/** Result (notify master job client).
	*/
	void Result (CntNode *pResult, CntAction eAction);

public:
	/** Construction.
	*/
	CntHTTPJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);

	/** Context.
	*/
	CntNodeJob*           GetJob      (void) const { return m_xJob; }
	CntHTTPRootNode_Impl* GetParent   (void) const { return m_pParent; }

	CntNode*              GetRootNode (void) const
	{
		return m_pParent->GetParent();
	}

	/** Execution.
	*/
	virtual const SfxPoolItem* Execute (void) = 0;

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

SV_DECL_IMPL_REF (CntHTTPJob_Impl);

/*========================================================================
 *
 * CntHTTPRequestJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPRequestJob_Impl : public CntHTTPJob_Impl
{
	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPRequestJob_Impl);

protected:
	/** Destruction (via SvRefBase).
	*/
	virtual ~CntHTTPRequestJob_Impl (void);

	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_REQUEST,
		STATE_RESPONSE,
		STATE_DONE,
		STATE_ERROR
	};

	/** Request URI.
	*/
	INetURLObject       m_aReqURL;
	String              m_aReqURI;

	void setRequestURL  (void);
	void setRedirectURL (const String &rLocation);

	/** Request.
	*/
	typedef NAMESPACE_INET(INetHTTPRequest) request;
	NAMESPACE_VOS(ORef)<request> m_xRequest;

	/** Request and Response message containers.
	*/
	INetHTTPMessage *m_pReqMsg;
	INetHTTPMessage *m_pResMsg;

	/** Request state and progress.
	*/
	State            m_eState;
	USHORT           m_nHintId;

	void Finished (State eState = STATE_DONE);

	/** Message container initialization.
	*/
	virtual BOOL prepareRequest (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg) const;

	virtual BOOL prepareResponse (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg,
		INetHTTPMessage     &rResMsg) const;

	/** Document header retrieval from cache.
	*/
	BOOL GetDocumentHeader (
		const String    &rReqURI,
		CntStorageNode  &rCache,
		CntDocHeaderRef &rxDocHdr) const;

	/** Document manipulation.
	*/
	BOOL InvalidateDocument (
		CntStorageNode& rCache,
		const String&   rURL) const;

	void RenameDocument (
		CntStorageNode& rCache,
		const String&   rOldURL,
		const String&   rNewURL) const;

	void ReplaceDocument (
		CntStorageNode& rCache,
		const String&   rUrl) const;

	/** Apply INetProxyPolicy (and Authorization) to Request.
	*/
	void ApplyProxyAuthorization (
		const INetURLObject &rURL,
		INetHTTPMessage     &rReqMsg) const;

	/** Authentication.
	*/
	BOOL GetBasicAuthentication (
		const String& rChallenge,
		String&       rRealm) const;

	BOOL SetBasicAuthentication (
		const String& rUsername,
		const String& rPassword,
		String&       rCredential) const;

	/** Request callback.
	*/
	static sal_Bool ExecuteCallback (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData);

	/** Basic request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

public:
	/** Construction.
	*/
	CntHTTPRequestJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);

	/** Execution.
	*/
	virtual const SfxPoolItem* Execute (void) = 0;

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*========================================================================
 *
 * CntHTTPGetJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPGetJob_Impl : public CntHTTPRequestJob_Impl
{
	/** Representation.
	*/
	CntStorageNode *m_pCache;
	BOOL            m_bNeedHeader : 1;
	BOOL            m_bNeedCookie : 1;

	/** Document check and delivery.
	*/
	BOOL queryDeliverDocument (
		CntHTTPVerifyMode eVerifyMode = CNTHTTP_VERIFY_NEVER);

	void deliverDocument (
		const SfxItemSet &rPropSet);

	/** Request initialization.
	*/
	virtual BOOL prepareRequest (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg) const;

	virtual BOOL prepareResponse (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg,
		INetHTTPMessage     &rResMsg) const;

#ifdef CHTTPIMP_EXPERIMENTAL_CACHESTREAM
	DECL_LINK (SwapOutHandler, SvCacheStream*);
#endif /* CHTTPIMP_EXPERIMENTAL_CACHESTREAM */

	/** Response persistence.
	*/
	void StoreResponse (
		const String       &rResURL,
		INetHTTPMessage    &rResMsg,
		CntStorageNode     &rCache,
		CntStoreItemSetRef &rxDirSet);

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 ReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPGetJob_Impl);

public:
	CntHTTPGetJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);
	virtual ~CntHTTPGetJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*========================================================================
 *
 * CntHTTPHeadJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPHeadJob_Impl : public CntHTTPRequestJob_Impl
{
	/** Representation.
	*/
	CntStorageNode *m_pCache;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 ReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPHeadJob_Impl);

public:
	CntHTTPHeadJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);
	virtual ~CntHTTPHeadJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*========================================================================
 *
 * CntHTTPPostJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPPostJob_Impl : public CntHTTPRequestJob_Impl
{
	/** Representation.
	*/
	CntNodeJobRef m_xSubJob;
	BOOL          m_bNeedCookie : 1;

	/** Request initialization.
	*/
	virtual BOOL prepareRequest (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg) const;

	virtual BOOL prepareResponse (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg,
		INetHTTPMessage     &rResMsg) const;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 ReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPPostJob_Impl);

public:
	CntHTTPPostJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);
	virtual ~CntHTTPPostJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*========================================================================
 *
 * CntHTTPPutJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPPutJob_Impl : public CntHTTPRequestJob_Impl
{
	/** Representation.
	*/
	BOOL m_bNeedCookie : 1;

	/** Request initialization.
	*/
	virtual BOOL prepareRequest (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg) const;

	virtual BOOL prepareResponse (
		const INetURLObject &rReqUrl,
		INetHTTPMessage     &rReqMsg,
		INetHTTPMessage     &rResMsg) const;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetHTTPRequest) *pRequest,
		sal_Int32 ReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPPutJob_Impl);

public:
	CntHTTPPutJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);
	virtual ~CntHTTPPutJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*========================================================================
 *
 * CntHTTPDeleteJob_Impl interface.
 *
 *======================================================================*/
class CntHTTPDeleteJob_Impl :
	public CntHTTPJob_Impl,
	public NAMESPACE_VOS(OThread)
{
	/** Representation.
	*/
	CntStorageNode        *m_pCache;
	NAMESPACE_VOS(OMutex) *m_pLock;

	/** Working method.
	*/
	virtual void SAL_CALL run (void);

	/** Not implemented.
	*/
	COPYCTOR_API(CntHTTPDeleteJob_Impl);

public:
	CntHTTPDeleteJob_Impl (
		CntNodeJob           *pJob,
		CntHTTPRootNode_Impl *pParent);
	virtual ~CntHTTPDeleteJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_CNTHTTPIMP_HXX */

