/*************************************************************************
 *
 *  $RCSfile: chttpput.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CHTTPPUT_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX
#include <tools/inetmsg.hxx>
#endif
#ifndef _TIME_HXX
#include <tools/time.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif
#ifndef _VOS_THREAD_HXX
#include <vos/thread.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXHINT_HXX
#include <svtools/hint.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _LCKBITEM_HXX
#include <svtools/lckbitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif

#ifndef _INET_HTTPWRAP_HXX
#include <inet/httpwrap.hxx>
#endif
#ifndef _INETHTTP_HXX
#include <inet/inethttp.hxx>
#endif

#ifndef _CNTBASE_HXX
#include "cntbase.hxx"
#endif
#ifndef _CNTHTTPIMP_HXX
#include "chttpimp.hxx"
#endif
#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTNODE_HXX
#include "cntnode.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _DHDRITEM_HXX
#include "dhdritem.hxx"
#endif
#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif
#ifndef _CHAOS_STRMITEM_HXX
#include "strmitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _CHAOS_STORNODE_REF
SV_IMPL_REF(CntStorageNode);
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*========================================================================
 *
 * CntHTTP... internals.
 *
 *======================================================================*/
#define CNTHTTP_CACHE_LOCK()   if (m_pLock) m_pLock->acquire()
#define CNTHTTP_CACHE_UNLOCK() if (m_pLock) m_pLock->release()

/*
 * CntDirtyItemSet ranges.
 */
CHTTPDOC_DIR_RANGES_IMPL (aDocDirRanges_Impl);

/*========================================================================
 *
 * CntHTTPPostJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPPostJob_Impl.
 */
CntHTTPPostJob_Impl::CntHTTPPostJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPRequestJob_Impl (pJob, pParent),
	  m_xSubJob     (NULL),
	  m_bNeedCookie (FALSE)
{
}

/*
 * ~CntHTTPPostJob_Impl.
 */
CntHTTPPostJob_Impl::~CntHTTPPostJob_Impl (void)
{
}

/*
 * prepareRequest.
 */
BOOL CntHTTPPostJob_Impl::prepareRequest (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg) const
{
	// Obtain document node.
	CntNodeRef xDocNode (GetJob()->GetSubject());
	DBG_ASSERT(
		xDocNode.Is(), "CntHTTPPostJob_Impl::prepareRequest(): no Subject");
	if (!xDocNode.Is())
		return FALSE;

	// Obtain document body.
	SvLockBytesRef xDocLB;

	const CntInStreamItem *pItem =
		PTR_CAST(CntInStreamItem, GetJob()->GetRequest());
	if (pItem)
		xDocLB = new SvLockBytes (pItem->tryToAcquireStream());
	else
		xDocLB = ITEMSET_VALUE(xDocNode, SfxLockBytesItem, WID_DOCUMENT_BODY);
	DBG_ASSERT(
		xDocLB.Is(), "CntHTTPPostJob_Impl::prepareRequest(): no Document");
	if (!xDocLB.Is())
		return FALSE;

	// Obtain document size.
	ULONG nDocSize = 0;

	SvLockBytesStat aStat;
	if (xDocLB->Stat (&aStat, SVSTATFLAG_DEFAULT) == ERRCODE_NONE)
		nDocSize = aStat.nSize;
	else
		return FALSE;

	// Obtain content type.
	String aContentType (ITEMSET_VALUE(
		xDocNode, CntContentTypeItem, WID_CONTENT_TYPE));
	if ((aContentType.Len() == 0) || (aContentType.CompareToAscii (
		CONTENT_TYPE_STR_X_CNT_DOCUMENT) == COMPARE_EQUAL))
		aContentType.AssignAscii ("application/x-www-form-urlencoded");

	// Common initialization.
	CntHTTPRequestJob_Impl::prepareRequest (rReqUrl, rReqMsg);

	// Entity.
	rReqMsg.SetDocumentLB    (xDocLB);
	rReqMsg.SetDocumentSize  (nDocSize);
    rReqMsg.SetContentLength ( String::CreateFromInt32(nDocSize) );
	rReqMsg.SetContentType   (aContentType);

	// Accept.
	rReqMsg.SetAccept (S2U ("image/png, image/*, */*"));

	// Done.
	return TRUE;
}

/*
 * prepareResponse.
 */
BOOL CntHTTPPostJob_Impl::prepareResponse (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg,
	INetHTTPMessage     &rResMsg) const
{
	// Response document (not cacheable).
	rResMsg.SetDocumentLB (new SvAsyncLockBytes (new SvMemoryStream, TRUE));
	rResMsg.SetDocumentName (String());

	// Finish.
	return CntHTTPRequestJob_Impl::prepareResponse (
		rReqUrl, rReqMsg, rResMsg);
}

/*
 * Execute.
 */
const SfxPoolItem* CntHTTPPostJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntHTTPJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntHTTPPostJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntHTTPPostJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		Finished (STATE_ERROR);
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain request URI.
		setRequestURL();

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			// Offline. Notify caller.
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Not transactable (temporary DocumentBody).
			Finished (STATE_ERROR);
			return NULL;
		}

		// Initialize request message.
		delete m_pReqMsg;
		m_pReqMsg = new INetHTTPMessage;
		if (!prepareRequest (m_aReqURL, *m_pReqMsg))
		{
			// Failure.
			Finished (STATE_ERROR);
			return NULL;
		}

		// Next state.
		m_eState = STATE_REQUEST;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_REQUEST)
	{
		// Initiate document posting. Obtain Wrapper.
		NAMESPACE_INET(INetHTTPWrapper) *pWrapper;
		if (!GetParent()->GetWrapper (pWrapper))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPPostJob_Impl::Execute(): no HTTP wrapper");
			Finished (STATE_ERROR);
			return NULL;
		}

		// Create PostRequest.
		NAMESPACE_VOS(ORef)<NAMESPACE_INET(INetHTTPPostRequest)> xRequest;
		if (!pWrapper->newHTTPPostRequest (xRequest))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPPostJob_Impl::Execute(): no HTTP request");
			Finished (STATE_ERROR);
			return NULL;
		}
		m_xRequest = &*xRequest;

		// Initialize response message.
		delete m_pResMsg;
		m_pResMsg = new INetHTTPMessage;
		if (!prepareResponse (m_aReqURL, *m_pReqMsg, *m_pResMsg))
		{
			// Failure.
			m_xRequest.unbind();
			Finished (STATE_ERROR);
			return NULL;
		}

		// Start document posting.
		m_bNeedCookie = TRUE;
		m_eState = STATE_RESPONSE;
		if (!xRequest->postDocument (
			m_aReqURI, *m_pReqMsg, *m_pResMsg, ExecuteCallback, this))
		{
			// Failure.
			m_xRequest.unbind();
			Finished (STATE_ERROR);
			return NULL;
		}

		// Wait for next callback.
		return NULL;
	}

	if (m_eState == STATE_DONE)
	{
		// Check for SubJob.
		if (m_xSubJob.Is())
		{
			if (m_xSubJob->IsCancelled())
			{
				Finished (STATE_ERROR);
				return NULL;
			}
			m_xSubJob.Clear();
		}

		// Finished.
		Finished();
		return NULL;
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntHTTPPostJob_Impl::ExecuteHandler (
	NAMESPACE_INET(INetHTTPRequest) *pRequest,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntHTTPPostJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	DBG_ASSERT(
		m_xRequest == pRequest,
		"CntHTTPPostJob_Impl::ExecuteHandler(): wrong pRequest");
	if (!(m_xRequest == pRequest))
		return;

	// Check callback reason.
	if ((0 <= nReplyCode) && (nReplyCode < 400))
	{
		// Check for Cookies.
		if (m_bNeedCookie)
		{
			// Mark Cookies done.
			m_bNeedCookie = FALSE;

			// SetCookie.
			GetParent()->SetCookie (m_aReqURL, *m_pResMsg, pJob);
			if (pJob->IsCancelled() || pJob->IsDone())
				return;
		}

		// Check for redirection.
		const SfxPoolItem *pReq = pJob->GetRequest();
		if ((nReplyCode == request::REPLY_MOVED_PERMANENT) ||
			(nReplyCode == request::REPLY_MOVED_TEMPORARY)    )
		{
			// POST request redirected into GET request.
			String aLocation (m_pResMsg->GetLocation());
			if (aLocation.Len())
			{
				// Cleanup current request.
				m_xRequest.unbind();
				DELETEZ (m_pReqMsg);
				DELETEZ (m_pResMsg);

				// Re-initialize document node.
				setRedirectURL (aLocation);

				// Setup SubJob.
				m_xSubJob = new CntNodeJob (
					pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
				CntHTTPJob_Impl *pJobImpl =
					new CntHTTPGetJob_Impl (m_xSubJob, GetParent());

				// Start SubJob.
				StartListening (*m_xSubJob);
				GetRootNode()->RescheduleJob (m_xSubJob);
				return;
			}
		}

		// Obtain DocumentNode.
		CntNode *pDocNode = pJob->GetSubject();
		if (pDocNode)
		{
			// Check Expires header field.
			if (m_pResMsg->GetExpires().Len() == 0)
			{
				// Force immediate expiration (response not cacheable).
				m_pResMsg->SetExpires (S2U ("0"));
			}

			// Obtain final DocumentSize.
			ULONG nDocSize = m_pResMsg->GetDocumentSize();
			if (nDocSize > 0)
			{
				// Deliver ContentType (or default).
				String aContentType (m_pResMsg->GetContentType());
				if (aContentType.Len() == 0)
				{
					aContentType.AssignAscii (CONTENT_TYPE_STR_X_CNT_HTTPFILE);
					m_pResMsg->SetContentType (aContentType);
				}

				pDocNode->Put (CntContentTypeItem (
					WID_CONTENT_TYPE, aContentType));
			}

			// Deliver DocumentHeader.
			CntDocHeaderRef xHead (new CntDocHeader (*m_pResMsg));
			xHead->SetDocumentLB (NULL);

			pDocNode->Put (CntDocHeaderItem (WID_DOCUMENT_HEADER, xHead));
			xHead.Clear();

			// Deliver final DocumentSize.
			pDocNode->Put (CntUInt32Item (WID_DOCUMENT_SIZE, nDocSize));
		}

		// Obtain CacheNode.
		CntStorageNode *pCache = pJob->GetCacheNode();
		if (pCache)
		{
			// Replace current document with response document.
			ReplaceDocument (*pCache, m_aReqURI);

			// Acquire cache access.
			NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

			// Invalidate document (response not cacheable).
			InvalidateDocument (*pCache, m_aReqURI);
		}

		// Done.
		Finished();
	}
	else
	{
		// Call base request handler.
		CntHTTPRequestJob_Impl::ExecuteHandler (
			pRequest, nReplyCode, pReplyText);
	}
}

/*
 * Notify.
 */
void CntHTTPPostJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			m_eState = STATE_DONE;
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	CntHTTPRequestJob_Impl::Notify (rBC, rHint);
}

/*========================================================================
 *
 * CntHTTPPutJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPPutJob_Impl.
 */
CntHTTPPutJob_Impl::CntHTTPPutJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPRequestJob_Impl (pJob, pParent),
	  m_bNeedCookie          (FALSE)
{
}

/*
 * ~CntHTTPPutJob_Impl.
 */
CntHTTPPutJob_Impl::~CntHTTPPutJob_Impl (void)
{
}

#if 0  /* IDEA */
/*
 * StoreDocument.
 */
BOOL CntHTTPPutJob_Impl::StoreDocument (
	CntNode        *pDocNode,
	CntStorageNode *pCache,
	const String&  rUrl)
{
	// Check context.
	if ((pDocNode == NULL) || (pCache == NULL) || (rUrl.Len() == 0))
		return FALSE;

	// Obtain content type.
	String aContentType (
		ITEMSET_VALUE (pDocNode, CntContentTypeItem, WID_CONTENT_TYPE));
	if ((aContentType.Len() == 0) || (aContentType.Compare (
		CONTENT_TYPE_STR_X_CNT_DOCUMENT) == COMPARE_EQUAL))
		aContentType = "application/octet-stream";

	// Obtain document body.
	SvLockBytes *pDocLB =
		ITEMSET_VALUE (pDocNode, SfxLockBytesItem, WID_DOCUMENT_BODY);
	if (pDocLB == NULL)
		return FALSE;

	// Obtain document size.
	ULONG nDocSize =
		ITEMSET_VALUE (pDocNode, CntUInt32Item, WID_DOCUMENT_SIZE);
	if (nDocSize == 0)
	{
		SvLockBytesStat aStat;
		if (pDocLB->Stat (&aStat, SVSTATFLAG_DEFAULT) != ERRCODE_NONE)
			return FALSE;

		if (aStat.nSize > 0)
			nDocSize = aStat.nSize;
		else
			return FALSE;
	}

	// Create DocumentHead itemset.
	String aHeadUrl (CHTTPIMP_CREATION_PREFIX);
	aHeadUrl += CHTTPIMP_DOCUMENT_HEAD_PREFIX;
	aHeadUrl += rUrl;
	String aHeadName (CHTTPIMP_SHORT_NAME(aHeadUrl));

	CntStoreItemSetRef xDirSet = pCache->openItemSet (
		aDocDirRanges_Impl, aHeadName, STREAM_STD_READWRITE);
	DBG_ASSERT (pDirSet, "PutJob_Impl: OpenItemSet() failed");
	if (!xDirSet.Is())
		return FALSE;

	xDirSet->Put (CntContentTypeItem (WID_CONTENT_TYPE, aContentType));
	xDirSet->Put (CntUInt32Item (WID_DOCUMENT_SIZE, nDocSize));

	xDirSet.Clear();

	// Create DocumentBody stream.
	String aBodyUrl (CHTTPIMP_CREATION_PREFIX);
	aBodyUrl += CHTTPIMP_DOCUMENT_BODY_PREFIX;
	aBodyUrl += rUrl;
	String aBodyName (CHTTPIMP_SHORT_NAME(aBodyUrl));

	SvStream *pStrm = pCache->openStream (
		aBodyName, STREAM_READWRITE | STREAM_TRUNC | STREAM_SHARE_DENYWRITE);
	DBG_ASSERT (pStrm, "CntHTTPPutJob_Impl: OpenStream() failed");
	if (pStrm == NULL)
		return FALSE;

	SvStream aDocStrm (pDocLB);
	*pStrm << aDocStrm;
	delete pStrm;

	// Check for already cached document.
	String aBodyURL (CHTTPIMP_DOCUMENT_BODY_PREFIX);
	aBodyURL += rUrl;

	UINT8 nAttrib = pCache->Attrib (aBodyURL);
	if (nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN)
	{
		// Rename current document.
		aURL = CHTTPIMP_OBSOLETE_PREFIX;
		aURL += m_aReqURI;

		RenameDocument (*pCache, m_aReqURI, aURL);

		// Invalidate obsolete document.
		InvalidateDocument (*pCache, aURL);
	}
}
#endif /* IDEA */

/*
 * prepareRequest.
 */
BOOL CntHTTPPutJob_Impl::prepareRequest (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg) const
{
	// Obtain document node.
	CntNodeRef xDocNode (GetJob()->GetSubject());
	DBG_ASSERT(
		xDocNode.Is(), "CntHTTPPutJob_Impl::prepareRequest(): no Subject");
	if (!xDocNode.Is())
		return FALSE;

	// Obtain document body.
	SvLockBytesRef xDocLB;

	const CntInStreamItem *pItem =
		PTR_CAST(CntInStreamItem, GetJob()->GetRequest());
	if (pItem)
		xDocLB = new SvLockBytes (pItem->tryToAcquireStream());
	else
		xDocLB = ITEMSET_VALUE(xDocNode, SfxLockBytesItem, WID_DOCUMENT_BODY);
	DBG_ASSERT(
		xDocLB.Is(), "CntHTTPPutJob_Impl::prepareRequest(): no Document");
	if (!xDocLB.Is())
		return FALSE;

	// Obtain document size.
	ULONG nDocSize = 0;

	SvLockBytesStat aStat;
	if (xDocLB->Stat (&aStat, SVSTATFLAG_DEFAULT) == ERRCODE_NONE)
		nDocSize = aStat.nSize;
	else
		return FALSE;

	// Obtain content type.
	String aContentType (ITEMSET_VALUE(
		xDocNode, CntContentTypeItem, WID_CONTENT_TYPE));
	if ((aContentType.Len() == 0) || (aContentType.CompareToAscii (
		CONTENT_TYPE_STR_X_CNT_DOCUMENT) == COMPARE_EQUAL))
		aContentType.AssignAscii ("application/octet-stream");

	// Base initialization.
	CntHTTPRequestJob_Impl::prepareRequest (rReqUrl, rReqMsg);

	// Entity.
	rReqMsg.SetDocumentLB    (xDocLB);
	rReqMsg.SetDocumentSize  (nDocSize);
    rReqMsg.SetContentLength ( String::CreateFromInt32(nDocSize) );
	rReqMsg.SetContentType   (aContentType);

	// Done.
	return TRUE;
}

/*
 * prepareResponse.
 */
BOOL CntHTTPPutJob_Impl::prepareResponse (
	const INetURLObject &rReqUrl,
	INetHTTPMessage     &rReqMsg,
	INetHTTPMessage     &rResMsg) const
{
	// Response document (not cacheable).
	rResMsg.SetDocumentLB (new SvAsyncLockBytes (new SvMemoryStream, TRUE));
	rResMsg.SetDocumentName (String());

	// Finish.
	return CntHTTPRequestJob_Impl::prepareResponse (
		rReqUrl, rReqMsg, rResMsg);
}

/*
 * Execute.
 */
const SfxPoolItem* CntHTTPPutJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntHTTPJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntHTTPPutJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntHTTPPutJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		Finished (STATE_ERROR);
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain request URI.
		setRequestURL();

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			// Offline. Notify caller.
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Not transactable (temporary DocumentBody).
			Finished (STATE_ERROR);
			return NULL;
		}

		// Initialize request message.
		delete m_pReqMsg;
		m_pReqMsg = new INetHTTPMessage;
		if (!prepareRequest (m_aReqURL, *m_pReqMsg))
		{
			// Failure.
			Finished (STATE_ERROR);
			return NULL;
		}

		// Next state.
		m_eState = STATE_REQUEST;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_REQUEST)
	{
		// Initiate document storage. Obtain Wrapper.
		NAMESPACE_INET(INetHTTPWrapper) *pWrapper;
		if (!GetParent()->GetWrapper (pWrapper))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPPutJob_Impl::Execute(): no HTTP wrapper");
			Finished (STATE_ERROR);
			return NULL;
		}

		// Create PutRequest.
		NAMESPACE_VOS(ORef)<NAMESPACE_INET(INetHTTPPutRequest)> xRequest;
		if (!pWrapper->newHTTPPutRequest (xRequest))
		{
			// Failure.
			DBG_ERRORFILE ("CntHTTPPutJob_Impl::Execute(): no HTTP request");
			Finished (STATE_ERROR);
			return NULL;
		}
		m_xRequest = &*xRequest;

		// Initialize response message.
		delete m_pResMsg;
		m_pResMsg = new INetHTTPMessage;
		if (!prepareResponse (m_aReqURL, *m_pReqMsg, *m_pResMsg))
		{
			// Failure.
			m_xRequest.unbind();
			Finished (STATE_ERROR);
			return NULL;
		}

		// Start document storage.
		m_bNeedCookie = TRUE;
		m_eState = STATE_RESPONSE;
		if (!xRequest->storeDocument (
			m_aReqURI, *m_pReqMsg, *m_pResMsg, ExecuteCallback, this))
		{
			// Failure.
			m_xRequest.unbind();
			Finished (STATE_ERROR);
			return NULL;
		}

		// Wait for next callback.
		return NULL;
	}

	if (m_eState == STATE_DONE)
	{
		// Finished.
		Finished();
		return NULL;
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntHTTPPutJob_Impl::ExecuteHandler (
	NAMESPACE_INET(INetHTTPRequest) *pRequest,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntHTTPPutJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	DBG_ASSERT(
		m_xRequest == pRequest,
		"CntHTTPPutJob_Impl::ExecuteHandler(): wrong pRequest");
	if (!(m_xRequest == pRequest))
		return;

	// Check callback reason.
	if ((0 <= nReplyCode) && (nReplyCode < 400))
	{
		// Check for Cookies.
		if (m_bNeedCookie)
		{
			// Mark Cookies done.
			m_bNeedCookie = FALSE;

			// SetCookie.
			GetParent()->SetCookie (m_aReqURL, *m_pResMsg, pJob);
			if (pJob->IsCancelled() || pJob->IsDone())
				return;
		}

		// Obtain DocumentNode.
		CntNode *pDocNode = pJob->GetSubject();
		if (pDocNode)
		{
			// Obtain final DocumentSize.
			ULONG nDocSize = m_pResMsg->GetDocumentSize();
			if (nDocSize > 0)
			{
				// Deliver ContentType (or default).
				String aContentType (m_pResMsg->GetContentType());
				if (aContentType.Len() == 0)
				{
					aContentType.AssignAscii (CONTENT_TYPE_STR_X_CNT_HTTPFILE);
					m_pResMsg->SetContentType (aContentType);
				}

				pDocNode->Put (CntContentTypeItem (
					WID_CONTENT_TYPE, aContentType));
			}

			// Deliver DocumentHeader.
			CntDocHeaderRef xHead (new CntDocHeader (*m_pResMsg));
			xHead->SetDocumentLB (NULL);

			pDocNode->Put (CntDocHeaderItem (WID_DOCUMENT_HEADER, xHead));
			xHead.Clear();

			// Deliver final DocumentSize.
			pDocNode->Put (CntUInt32Item (WID_DOCUMENT_SIZE, nDocSize));
		}

		// Obtain CacheNode.
		CntStorageNode *pCache = pJob->GetCacheNode();
		if (pCache)
		{
			// Replace current document with response document.
			ReplaceDocument (*pCache, m_aReqURI);

			// Acquire cache access.
			NAMESPACE_VOS(OGuard) aGuard (GetParent()->GetCacheLock());

			// Invalidate document (response not cacheable).
			InvalidateDocument (*pCache, m_aReqURI);
		}

		// Check for success.
		if (nReplyCode/100 == 2)
		{
			// Notify caller.
			Result (pDocNode, CNT_ACTION_INSERTED);
		}

		// Done.
		Finished();
	}
	else
	{
		// Call base request handler.
		CntHTTPRequestJob_Impl::ExecuteHandler (
			pRequest, nReplyCode, pReplyText);
	}
}

/*
 * Notify.
 */
void CntHTTPPutJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntHTTPRequestJob_Impl::Notify (rBC, rHint);
}

/*========================================================================
 *
 * CntHTTPDeleteJob_Impl implementation.
 *
 *======================================================================*/
/*
 * CntHTTPDeleteJob_Impl.
 */
CntHTTPDeleteJob_Impl::CntHTTPDeleteJob_Impl (
	CntNodeJob *pJob, CntHTTPRootNode_Impl *pParent)
	: CntHTTPJob_Impl (pJob, pParent),
	  m_pCache        (NULL),
	  m_pLock         (NULL)
{
}

/*
 * ~CntHTTPDeleteJob_Impl.
 */
CntHTTPDeleteJob_Impl::~CntHTTPDeleteJob_Impl (void)
{
}

/*
 * run.
 */
void SAL_CALL CntHTTPDeleteJob_Impl::run (void)
{
	setPriority (TPriority_BelowNormal);

	CntStorageIterator it (0, CNTDIRENTRY_ATTRIB_HIDDEN);

	CNTHTTP_CACHE_LOCK();
	m_pCache->iter(it);
	CNTHTTP_CACHE_UNLOCK();

	while (!it.eof() && schedule())
	{
		CNTHTTP_CACHE_LOCK();

		ErrCode eErrCode = m_pCache->attrib (
			(*it).m_pszName,
			CNTDIRENTRY_ATTRIB_MARKED,
			CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
		if (eErrCode == ERRCODE_NONE)
		{
			// Setup body URL.
			String aBodyUrl (S2U (CHTTPIMP_DOCUMENT_BODY_PREFIX));
			aBodyUrl += String ((*it).m_pszName).Copy(5);

			// Remove body stream.
			eErrCode = m_pCache->remove (aBodyUrl);
			if ((eErrCode == ERRCODE_NONE        ) ||
				(eErrCode == ERRCODE_IO_NOTEXISTS)    )
			{
				// Remove head itemset.
				m_pCache->remove ((*it).m_pszName);
			}
		}

		m_pCache->iter(it);
		CNTHTTP_CACHE_UNLOCK();
	}

	if (schedule())
	{
		// Rebuild (compact).
		CNTHTTP_CACHE_LOCK();
		ErrCode eErrCode = ((CntRootStorageNode*)m_pCache)->rebuild();
		CNTHTTP_CACHE_UNLOCK();

		// Reschedule job (trigger completion).
		GetRootNode()->RescheduleJob (GetJob());
	}
}

/*
 * Execute.
 */
const SfxPoolItem* CntHTTPDeleteJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntHTTPJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntHTTPDeleteJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntHTTPDeleteJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (!pJob->IsRescheduled())
	{
		// Check request.
		USHORT nWhich = pReq->Which();
		if (nWhich == WID_CLEAN_CACHE)
		{
			// Initialize cache cleanup.
			m_pCache = pJob->GetCacheNode();
			m_pLock  = GetParent()->GetCacheLock();

			// Create worker thread (reschedules job when complete).
			if (create())
				return NULL;
		}
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntHTTPDeleteJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Job finished.
			USHORT nWhich = pJob->GetRequest()->Which();
			if (nWhich == WID_CLEAN_CACHE)
			{
				// Terminate thread.
				terminate();
				if (getIdentifier() != getCurrentIdentifier())
					join();
			}
		}
	}
	CntHTTPJob_Impl::Notify (rBC, rHint);
}

