/*************************************************************************
 *
 *  $RCSfile: cnewsbox.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CNEWSBOX_CXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _EINF_HXX
#include <tools/errinf.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif

#ifndef _CNTNEWSIMP_HXX
#include "cnewsimp.hxx"
#endif
#ifndef _CNTRANGE_HXX
#include "cntrange.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif

#ifndef _CNTVWITM_HXX
#define ITEMID_CNT_FOLDER_VIEWMODE 	WID_FOLDERVIEW_MODE
#define ITEMID_CNT_VIEW_DESCRIPTION WID_VIEW_DESCRIPTION
#include "cntvwitm.hxx"
#endif

#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif

#ifndef _CNTMBITM_HXX
#include <cntmbitm.hxx>
#endif
#ifndef _ILSTITEM_HXX
#include <ilstitem.hxx>
#endif
#ifndef _CNTXREF_HXX
#include <cntxref.hxx>
#endif

#ifndef CHAOS_FLSTITEM_HXX
#include <flstitem.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
using namespace rtl;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntNewsBox... Internals.
 *
 *=====================================================================*/
#define NEWSBOX_STATE_FINISH() \
{ \
	m_ePrev  = m_eState; \
	m_eState = NEWSBOX_STATE_DONE; \
	m_eNext  = NEWSBOX_STATE_NONE; \
}

/*
 * CntStoreItemSet Ranges.
 */
CNEWSGRP_USER_RANGES_IMPL (aGrpUserRanges_Impl);
CNEWSMSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*=======================================================================
 *
 * CntNewsBoxOpenJob (obsolete) Implementation.
 *
 *=====================================================================*/
#if 0  /* OLD */

class()
{
	/** GroupUpdateMode.
	*/
	enum GroupUpdateMode
	{
		UPDATE_NONE       = 0,
		UPDATE_INHERITING = 1, // inheriting update parameters from box
		UPDATE_ENABLED    = 2, // private, enabled update parameters
		UPDATE_DISABLED   = 4, // private, disabled update parameters
		UPDATE_ALL = UPDATE_INHERITING | UPDATE_ENABLED | UPDATE_DISABLED
	};

	BOOL             _bUpdateBox;
	GroupUpdateMode	 _eUpdateGrp;
	BOOL             _bUpdateCurGrp;
}
Init()
{
	// Determine Box and Group update modes.
	_bUpdateBox = (GetParent()->GetConnMode() == CNT_CONN_MODE_ONLINE);
	_eUpdateGrp = _bUpdateBox ? UPDATE_ALL : UPDATE_NONE;

	switch (pReq->Which())
	{
		case WID_OPEN:
		case WID_SEARCH:
			if (_bUpdateBox
				&& !ITEMSET_VALUE(pClient, CntBoolItem,
								  WID_FLAG_UPDATE_ON_OPEN))
			{
				_bUpdateBox = FALSE;
				_eUpdateGrp = UPDATE_NONE;
			}
			break;

		case WID_UPDATE:
			if (pReq->ISA(CntUpdateItem))
				_eUpdateGrp
					= GroupUpdateMode(_eUpdateGrp & UPDATE_INHERITING);
			break;
	}
}
PerGroup()
{
	if (!_eUpdateGrp)
		_bUpdateCurGrp = FALSE;
	else if (_eUpdateGrp == UPDATE_ALL)
		_bUpdateCurGrp = TRUE;
	else
	{
		GroupUpdateMode eCurGroup = UPDATE_NONE;
		const CntAnchor * pBoxAnchor
			= PTR_CAST(CntAnchor, pJob->GetClient());
		if (pBoxAnchor)
		{
			String aBoxViewURL(pBoxAnchor->GetViewURL(TRUE));
			if (aBoxViewURL.Len())
			{
				String aGroupServiceURL(_aBoxURL);

				if (!aGroupServiceURL ||
					aGroupServiceURL.GetChar(aGroupServiceURL.Len()-1) != '/')
					aGroupServiceURL += '/';
				aGroupServiceURL += _aGroupList.GetObject(0)->aGroupName;

				String aGroupViewURL (
					CntAnchor::ToViewURL (aBoxViewURL, aGroupServiceURL));

				CntAnchorRef xGroupViewAnchor (
					new CntAnchor(0, aGroupViewURL));

				BOOL bGroupUpdateEnabled = ITEMSET_VALUE(
					xGroupViewAnchor, CntBoolItem, WID_UPDATE_ENABLED);
				if (bGroupUpdateEnabled
					== ITEMSET_VALUE(pBoxAnchor,
									 CntBoolItem,
									 WID_UPDATE_ENABLED)
					&& xGroupViewAnchor->
					Get(WID_AUTOUPDATE_INTERVAL)
					== pBoxAnchor->
					Get(WID_AUTOUPDATE_INTERVAL))
					eCurGroup = UPDATE_INHERITING;
				else
					eCurGroup
						= bGroupUpdateEnabled ?
						UPDATE_ENABLED : UPDATE_DISABLED;
			}
		}
		_bUpdateCurGrp = ((eCurGroup & _eUpdateGrp) > 0);
	}
}

#endif /* OLD */

/*=======================================================================
 *
 * CntNewsBoxJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxJob_Impl.
 */
CntNewsBoxJob_Impl::CntNewsBoxJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pCache        (NULL),
	  m_pViewData     (NULL),
	  m_eViewMode     (CNT_VIEW_SUBSCRIBED_FOLDERS),
	  m_nWhich        (0)
{
}

/*
 * ~CntNewsBoxJob_Impl.
 */
CntNewsBoxJob_Impl::~CntNewsBoxJob_Impl (void)
{
}

/*
 * Initialize.
 */
BOOL CntNewsBoxJob_Impl::Initialize (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxJob_Impl::Initialize(): no Job");
	if (pJob == NULL)
		return FALSE;

	// Determine request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT(
		pReq, "CntNewsBoxJob_Impl::Initialize(): no Request");
	if (pReq)
		m_nWhich = pReq->Which();
	else
		return FALSE;

	// Obtain Cache node.
	m_pCache = pJob->GetCacheNode();
	DBG_ASSERT(
		m_pCache, "CntNewsBoxJob_Impl::Initialize(): no Cache");
	if (m_pCache == NULL)
		return FALSE;

	// Obtain View node.
	m_pViewData = pJob->GetViewDataNode();
	DBG_ASSERT(
		m_pViewData, "CntNewsBoxJob_Impl::Initialize(): no ViewData");
	if (m_pViewData == NULL)
		return FALSE;

	// Obtain ViewMode.
	m_eViewMode = ITEMSET_VALUE(
		pJob->GetClient(), CntFolderViewModeItem, WID_FOLDERVIEW_MODE);

	// Done.
	return TRUE;
}

/*
 * Find.
 */
CntNewsGroupListEntry* CntNewsBoxJob_Impl::Find (
	const OUString   &rGroupName,
	CntNewsGroupList &rList,
	ULONG            &rIndex)
{
	ULONG n = rList.Count();
	for (rIndex = 0; rIndex < n; rIndex++)
	{
		CntNewsGroupListEntry *pEntry = rList.GetObject (rIndex);
		if (rGroupName.equals (pEntry->m_aGroupName)) return pEntry;
	}
	rIndex = LIST_ENTRY_NOTFOUND;
	return NULL;
}

/*
 * Update.
 */
ULONG CntNewsBoxJob_Impl::Update (
	CntNodeRef &rxDirNode, const CntNewsGroupListEntry &rEntry)
{
	// Initialize.
	ULONG nNewArticleCount = 0;
	DBG_ASSERT(
		m_pCache, "CntNewsBoxJob_Impl::Update(): no Cache");
	if (m_pCache == NULL)
		return nNewArticleCount;

	// Check group directory existence.
	String aDirName (rEntry.m_aGroupName);
	aDirName += sal_Unicode('/');

	ErrCode eErrCode = m_pCache->attrib (aDirName, 0, 0);
	if (eErrCode != ERRCODE_NONE)
		return nNewArticleCount;

	// Obtain group DirectoryNode.
	String aGroupURL (OWN_URL (m_pCache));
	CNEWSIMP_CONCAT_URLPATH (aGroupURL, rEntry.m_aGroupName);

	rxDirNode = m_pCache->Query (aGroupURL);
	if (!rxDirNode.Is())
		return nNewArticleCount;

	// Update ServerRanges, KnownRanges and KnownCount.
	CntRangesItem aNewServerRanges (WID_SERVER_RANGES);

	ULONG nNewFirst = rEntry.m_nFirstArticleNumber;
	ULONG nNewLast  = rEntry.m_nLastArticleNumber;
	if (nNewFirst > nNewLast)
		nNewFirst = nNewLast = 0;

	if (nNewFirst && nNewLast)
	{
		// Obtain current KnownRanges and KnownCount.
		const CntRangesItem &rKnownRanges =
			(const CntRangesItem&)(rxDirNode->Get(WID_KNOWN_RANGES));
		ULONG nKnownCount = rKnownRanges.TotalCount();

		if (nKnownCount)
		{
			ULONG nOldLast = rKnownRanges.TotalMax();
			if (nNewLast > nOldLast)
			{
				// NewArticleCount estimate.
				nNewArticleCount = nNewLast - nOldLast;
				nKnownCount += nNewArticleCount;

				// Store new KnownRanges.
				CntRangesItem aKnownRanges (rKnownRanges);
				aKnownRanges.InsertRange (nOldLast, nNewLast);
				rxDirNode->Put (aKnownRanges);
			}
		}
		else
		{
			// No group overview, yet. Use ServerRanges estimates.
			const CntRangesItem &rServerRanges =
				(const CntRangesItem&)(rxDirNode->Get(WID_SERVER_RANGES));
			nKnownCount = rServerRanges.TotalCount();

			if (nKnownCount)
			{
				ULONG nOldLast = rServerRanges.TotalMax();
				if (nNewLast > nOldLast)
				{
					// NewArticleCount estimate.
					nNewArticleCount = nNewLast - nOldLast;
					nKnownCount += nNewArticleCount;
				}
			}
		}

		// Insert new ServerRanges.
		aNewServerRanges.InsertRange (nNewFirst, nNewLast);

		// Store new KnownCount.
		rxDirNode->Put (CntUInt32Item (
			WID_TOTALCONTENTCOUNT, nKnownCount));
	}

	// Store new ServerRanges.
	rxDirNode->Put (aNewServerRanges);

	// Return NewArticleCount.
	return nNewArticleCount;
}

/*
 * QueryResult.
 */
BOOL CntNewsBoxJob_Impl::QueryResult (
	CntNodeRef &rxDirNode, const String &rGroupName)
{
	// Check DirNode.
	if (!rxDirNode.Is())
		return FALSE;

	// Check ViewMode.
	if (m_eViewMode != CNT_VIEW_ACTIVE_FOLDERS)
		return TRUE;

	// Obtain KnownCount.
	ULONG nKnownCount = ITEMSET_VALUE_UINT32(
		rxDirNode, WID_TOTALCONTENTCOUNT);

	// Obtain MarkCount and SeenCount.
	ULONG nMarkCount = 0, nSeenCount = 0;
	if (nKnownCount > 0)
	{
		CntStorageNodeRef xUserData (GetJob()->GetUserDataNode());
		if (xUserData.Is())
		{
			CntStoreItemSetRef xUserSet (xUserData->openItemSet (
				aGrpUserRanges_Impl, rGroupName, STREAM_STD_READ));
			if (xUserSet.Is())
			{
				// Obtain MarkCount and SeenCount.
				nMarkCount = ITEMSET_VALUE_UINT32(
					xUserSet, WID_MARKED_DOCUMENT_COUNT);
				nSeenCount = ITEMSET_VALUE_UINT32(
					xUserSet, WID_SEENCONTENTCOUNT);
			}
		}
	}

	// Result when active.
	return ((nKnownCount > nSeenCount) || (nMarkCount > 0));
}

/*=======================================================================
 *
 * CntNewsBoxOpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxOpenJob_Impl.
 */
CntNewsBoxOpenJob_Impl::CntNewsBoxOpenJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsBoxJob_Impl (pJob, pParent),
	  m_pLoadJob (NULL),
	  m_pIter    (NULL),
	  m_nCount   (0),
	  m_nHintId  (0),
	  m_eState   (NEWSBOX_STATE_NONE)
{
}

/*
 * ~CntNewsBoxOpenJob_Impl.
 */
CntNewsBoxOpenJob_Impl::~CntNewsBoxOpenJob_Impl (void)
{
	delete m_pIter;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsBoxOpenJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxOpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == NEWSBOX_STATE_NONE)
	{
		// Initialize base.
		if (!Initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		if (rList.Count() == 0)
		{
			// Not available. Check LoadJob.
			if (m_pLoadJob != NULL)
			{
				// Already have been here. LoadJob failed.
				pJob->Cancel();
				return NULL;
			}

			// Setup CntNewsLoadListJob.
			m_pLoadJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(),
				*(pJob->GetRequest()));

			CntNewsLoadListJob_Impl *pLoadJob =
				new CntNewsLoadListJob_Impl (m_pLoadJob, GetParent());

			// Start child job.
			StartListening (*m_pLoadJob);
			GetRootNode()->RescheduleJob (m_pLoadJob);
			return NULL;
		}

		// Obtain View itemset.
		CntStoreItemSetRef xViewSet (
			GetParent()->GetBoxViewItemSet (m_pViewData));
		if (xViewSet.Is())
		{
			// Obtain total (subscribed) count.
			ULONG nTotal = ITEMSET_VALUE_UINT32(
				xViewSet, WID_SUBSCRNEWSGROUPCOUNT);
			xViewSet.Clear();

			// Create Progress.
			m_nHintId = CntStatusBarHint::CreateHintId();
			Broadcast (CntStatusBarHint (
				m_nHintId, 1, nTotal,
				String (CntResId (RID_NEWS_LOADING_NEWSGROUPS))));
		}

		// Initialize GroupList iteration.
		if (m_eViewMode == CNT_VIEW_ALL_FOLDERS)
		{
			// Iterate cached folders.
			m_pIter = new CntStorageIterator (
				CNTSTORE_ATTRIB_ISDIR, 0);
			m_pCache->iter (*m_pIter);
		}
		else
		{
			// Iterate subscribed folders.
			m_pIter = new CntStorageIterator (
				CNTDIRENTRY_ATTRIB_SUBSCRIBED,
				CNTDIRENTRY_ATTRIB_HIDDEN | CNTSTORE_ATTRIB_ISDIR);
			m_pViewData->iter (*m_pIter);
		}
		m_nCount = 0;
		m_eState = NEWSBOX_STATE_GROUPLIST;
	}

	// Process (subscribed) GroupList.
	if (m_eState == NEWSBOX_STATE_GROUPLIST)
	{
		while (!m_pIter->eof())
		{
			// Setup group directory URL.
			String aGroupURL (OWN_URL (m_pCache));
			CNEWSIMP_CONCAT_URLPATH (aGroupURL, (**m_pIter).m_pszName);

			// Obtain group directory node.
			CntNodeRef xDirNode (m_pCache->Query (aGroupURL));
			if (QueryResult (xDirNode, (**m_pIter).m_pszName))
			{
				// Feed GroupNode with available data.
				CntNodeRef xNode (xDirNode->GetReferedNode());

				xNode->Put (
					CntStringItem (WID_TITLE, (**m_pIter).m_pszName));
				xNode->Put (
					xDirNode->Get (WID_TOTALCONTENTCOUNT));

				// Notify caller.
				pJob->Result (xNode);
				if (m_nWhich == WID_SEARCH)
					pJob->ResultSearchMatch (xNode);
			}

			// Next.
			m_nCount++;
			if (m_eViewMode == CNT_VIEW_ALL_FOLDERS)
				m_pCache->iter (*m_pIter);
			else
				m_pViewData->iter (*m_pIter);

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Check for Progress.
				if (m_nHintId)
				{
					// Notify caller (ProgressSet).
					Broadcast (CntStatusBarHint (m_nHintId, m_nCount));
				}

				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Finished.
		m_eState = NEWSBOX_STATE_DONE;
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntNewsBoxOpenJob_Impl::Notify (
	SfxBroadcaster &rBC, const SfxHint &rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == m_pLoadJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// LoadListJob finished.
			EndListening (*m_pLoadJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Our job is finished here.
			EndListening (*pJob);

			// Cleanup.
			if (m_nHintId)
			{
				// Notify caller (ProgressEnd).
				Broadcast (CntStatusBarHint (m_nHintId));
			}
		}
	}
	CntNewsBoxJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsBoxUpdateJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxUpdateJob_Impl.
 */
CntNewsBoxUpdateJob_Impl::CntNewsBoxUpdateJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsBoxJob_Impl (pJob, pParent),
	  m_pMailer          (NULL),
	  m_pListJob         (NULL),
	  m_aGroupList       (1024, 256, 256),
	  m_aLastUpdate      (Date(0), Time(0)),
	  m_bModified        (FALSE),
	  m_eState           (NEWSBOX_STATE_NONE),
	  m_ePrev            (NEWSBOX_STATE_NONE),
	  m_eNext            (NEWSBOX_STATE_NONE)
{
}

/*
 * ~CntNewsBoxUpdateJob_Impl.
 */
CntNewsBoxUpdateJob_Impl::~CntNewsBoxUpdateJob_Impl (void)
{
	ULONG n = m_aGroupList.Count();
	for (ULONG i = 0; i < n; i++)
		delete m_aGroupList.GetObject(i);
	m_aGroupList.Clear();
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsBoxUpdateJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxUpdateJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == NEWSBOX_STATE_NONE)
	{
		// Initialize base.
		if (!Initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Online. Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		if (rList.Count() == 0)
		{
			// Not available. Check LoadJob.
			if (m_pListJob != NULL)
			{
				// Already have been here. LoadJob failed.
				pJob->Cancel();
				return NULL;
			}

			// Setup a CntNewsLoadListJob.
			m_pListJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(),
				*(pJob->GetRequest()));

			CntNewsLoadListJob_Impl *pLoadJob =
				new CntNewsLoadListJob_Impl (m_pListJob, GetParent());

			// Start child job.
			StartListening (*m_pListJob);
			GetRootNode()->RescheduleJob (m_pListJob);
			return NULL;
		}

		// Reset ListJob.
		m_pListJob = NULL;

		// Obtain Box itemset.
		CntStoreItemSetRef xBoxSet (
			GetParent()->GetBoxDirItemSet (m_pCache));
		DBG_ASSERT(
			xBoxSet.Is(), "CntNewsBoxUpdateJob_Impl::Execute(): no BoxSet");
		if (xBoxSet.Is())
		{
			// Obtain LastUpdate.
			const SfxDateTimeItem &rItem =
				(const SfxDateTimeItem&)(xBoxSet->Get(WID_LAST_UPDATE));
			m_aLastUpdate = rItem.GetDateTime();

			// Release Box itemset.
			xBoxSet.Clear();
		}

		// Initialize GroupList iteration.
		if (m_eViewMode == CNT_VIEW_ALL_FOLDERS)
		{
			// Iterate cached folders.
			m_pIter = new CntStorageIterator (
				CNTSTORE_ATTRIB_ISDIR, 0);
			m_pCache->iter (*m_pIter);
		}
		else
		{
			// Iterate subscribed folders.
			m_pIter = new CntStorageIterator (
				CNTDIRENTRY_ATTRIB_SUBSCRIBED,
				CNTDIRENTRY_ATTRIB_HIDDEN | CNTSTORE_ATTRIB_ISDIR);
			m_pViewData->iter (*m_pIter);
		}

		// Obtain an INetCoreMailer.
		m_pMailer = GetParent()->GetMailer();
		if (m_pMailer->NewsIsOpen())
		{
			m_ePrev  = m_eState;
			m_eState = NEWSBOX_STATE_OPEN;
			m_eNext  = NEWSBOX_STATE_SELECT;
		}
		else
		{
			m_ePrev  = m_eState;
			m_eState = NEWSBOX_STATE_CLOSE;
			m_eNext  = NEWSBOX_STATE_OPEN;
		}
	}

	// Jump into state machine.
	ExecuteCallback (m_pMailer, SERVICE_READY, NULL, this);
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsBoxUpdateJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxUpdateJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case NEWSBOX_STATE_CLOSE:
				if (nReplyCode/100 == 2)
				{
					// Connection closed.
					m_ePrev  = m_eState;
					m_eState = NEWSBOX_STATE_OPEN;
					m_eNext  = NEWSBOX_STATE_SELECT;

					// Setup a CntNewsOpenJob.
					CntNodeJob *pChild = new CntNodeJob (
						pJob, pJob->GetClient(), pJob->GetSubject(),
						*(pJob->GetRequest()));

					CntNewsOpenJob_Impl *pOpenJob =
						new CntNewsOpenJob_Impl (pChild, GetParent());
					pOpenJob->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start OpenJob.
					GetRootNode()->RescheduleJob (pChild);
					return;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_AUTHINFO:
				if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup a CntNewsAuthJob.
					CntNodeJob *pChild = new CntNodeJob (
						pJob, pJob->GetClient(), pJob->GetSubject(),
						*(pJob->GetRequest()));

					CntNewsAuthJob_Impl *pAuthJob =
						new CntNewsAuthJob_Impl (pChild, GetParent());
					pAuthJob->SetReplyText (pReplyText);
					pAuthJob->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start AuthenticateJob.
					GetRootNode()->RescheduleJob (pChild);
					return;
				}
				else if (nReplyCode == AUTHINFO_ACCEPTED)
				{
					// Ok, resume previous state.
					m_eState = m_ePrev;
					m_ePrev  = NEWSBOX_STATE_AUTHINFO;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_OPEN:
				if (nReplyCode/100 == 2)
				{
					if (!m_pIter->eof())
					{
						// Select current group.
						m_ePrev  = m_eState;
						m_eState = NEWSBOX_STATE_SELECT;
						m_eNext  = NEWSBOX_STATE_OPEN;

						m_aGroupListEntry.initialize();
						m_aGroupListEntry.m_aGroupName = (**m_pIter).m_pszName;

						if (pMailer->NewsSelectGroup (
							m_aGroupListEntry,
							CntNewsJob_Impl::ExecuteCallback, this))
						{
							// Wait for next callback.
							return;
						}
						else
						{
							// Failure.
							NEWSBOX_STATE_FINISH();
						}
					}
					else
					{
						// Check LastUpdate.
						if (m_aLastUpdate.IsValid())
						{
							// Obtain NewGroupsList since LastUpdate.
							m_ePrev  = m_eState;
							m_eState = NEWSBOX_STATE_GROUPLIST;
							m_eNext  = NEWSBOX_STATE_DONE;

							if (pMailer->NewsNewGroupsList (
								m_aLastUpdate, m_aGroupList,
								CntNewsJob_Impl::ExecuteCallback, this))
							{
								// Wait for next callback.
								return;
							}
							else
							{
								// Failure.
								NEWSBOX_STATE_FINISH();
							}
						}
						else
						{
							// Finished.
							NEWSBOX_STATE_FINISH();
						}
					}
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_SELECT:
				if (nReplyCode/100 == 2)
				{
					// Update current group.
					CntNodeRef xDirNode;
					ULONG nNewArticles = Update (xDirNode, m_aGroupListEntry);
					if (QueryResult (xDirNode, (**m_pIter).m_pszName))
					{
						// Feed GroupNode with available data.
						CntNodeRef xNode (xDirNode->GetReferedNode());

						xNode->Put (
							CntStringItem (WID_TITLE, (**m_pIter).m_pszName));
						xNode->Put (
							xDirNode->Get (WID_TOTALCONTENTCOUNT));

						// Notify caller.
						pJob->Result (xNode);
						if (nNewArticles)
						{
							// New Articles available.
							CntUpdateResult aResult;

							aResult.aTargetURL   = OWN_URL (xNode);
							aResult.nNewMessages = nNewArticles;

							Broadcast (CntUpdateHint (&aResult));

							// Mark group not read.
							xNode->Put (CntBoolItem (WID_IS_READ, FALSE));
						}
					}

					// Obtain next group.
					if (m_eViewMode == CNT_VIEW_ALL_FOLDERS)
						m_pCache->iter (*m_pIter);
					else
						m_pViewData->iter (*m_pIter);

					m_ePrev  = m_eState;
					m_eState = NEWSBOX_STATE_OPEN;
					m_eNext  = NEWSBOX_STATE_SELECT;
				}
				else if (nReplyCode == NO_SUCH_GROUP)
				{
					// Obtain GroupList.
					CntNewsGroupList &rList = GetParent()->GetGroupList();

					ULONG nIndex = LIST_ENTRY_NOTFOUND;
					CntNewsGroupListEntry *pEntry =
						Find (m_aGroupListEntry.m_aGroupName, rList, nIndex);
					if (pEntry)
					{
						// Mark group as removed.
						pEntry->m_nFlags &= ~CNTDIRENTRY_ATTRIB_NEW;
						pEntry->m_nFlags |=  CNTDIRENTRY_ATTRIB_REMOVED;

						m_bModified = TRUE;
					}

					// Obtain next group.
					if (m_eViewMode == CNT_VIEW_ALL_FOLDERS)
						m_pCache->iter (*m_pIter);
					else
						m_pViewData->iter (*m_pIter);

					m_ePrev  = m_eState;
					m_eState = NEWSBOX_STATE_OPEN;
					m_eNext  = NEWSBOX_STATE_SELECT;

					nReplyCode = SERVICE_READY;
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = NEWSBOX_STATE_OPEN;
					m_eState = NEWSBOX_STATE_AUTHINFO;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_GROUPLIST:
				if (nReplyCode/100 == 2)
				{
					// Obtain current GroupList.
					CntNewsGroupList &rList = GetParent()->GetGroupList();

					// Append NewGroupsList.
					while (m_aGroupList.Count())
					{
						CntNewsGroupListEntry *pEntry = m_aGroupList.Remove();
						pEntry->m_nFlags |= CNTDIRENTRY_ATTRIB_NEW;

						ULONG nIndex = LIST_ENTRY_NOTFOUND;
						if (Find (pEntry->m_aGroupName, rList, nIndex))
						{
							// Cleanup redundant entry.
							delete pEntry;
						}
						else
						{
							// Insert new entry.
							rList.Insert (pEntry, LIST_APPEND);
							m_bModified = TRUE;
						}
					}

					// Obtain Box itemset.
					CntStoreItemSetRef xBoxSet (
						GetParent()->GetBoxDirItemSet (m_pCache));
					if (xBoxSet.Is())
					{
						// Save new LastUpdate.
						xBoxSet->Put (SfxDateTimeItem (
							WID_LAST_UPDATE, DateTime()));

						// Release Box itemset.
						xBoxSet.Clear();
					}

					// Finish.
					NEWSBOX_STATE_FINISH();
				}
				else if (nReplyCode == TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = NEWSBOX_STATE_OPEN;
					m_eState = NEWSBOX_STATE_AUTHINFO;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_DONE:
				if (nReplyCode/100 == 2)
				{
					if (m_bModified)
					{
						// Setup a CntNewsSaveListJob.
						m_pListJob = new CntNodeJob (
							pJob, pJob->GetClient(), pJob->GetSubject(),
							*(pJob->GetRequest()));

						CntNewsSaveListJob_Impl *pSaveJob =
							new CntNewsSaveListJob_Impl (
								m_pListJob, GetParent());

						// Start child job.
						StartListening (*m_pListJob);
						GetRootNode()->RescheduleJob (m_pListJob);
						return;
					}

					// Finish.
					pJob->Done();
				}
				else
				{
					// Fail.
					pJob->Cancel();
				}
				return;

			default: // NEWSBOX_STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntNewsBoxUpdateJob_Impl::Notify (
	SfxBroadcaster &rBC, const SfxHint &rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == m_pListJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// ListJob finished.
			EndListening (*m_pListJob);

			// Mark GroupList clean.
			m_bModified = FALSE;

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Our job is finished here.
			EndListening (*pJob);

			// Cleanup.
			if (m_pMailer)
			{
				if ((m_eState != NEWSBOX_STATE_DONE) &&
					(m_eState != NEWSBOX_STATE_NONE)    )
				{
					// Cancelled while busy.
					m_pMailer->NewsAbortConnection();
				}
			}
		}
	}
	CntNewsBoxJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsBoxSyncJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxSyncJob_Impl.
 */
CntNewsBoxSyncJob_Impl::CntNewsBoxSyncJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsBoxJob_Impl (pJob, pParent),
	  m_pMailer          (NULL),
	  m_pStrm            (NULL),
	  m_pLoadJob         (NULL),
	  m_aGroupList       (1024, 256, 256), /* BlkSiz, InitSiz, ReSiz */
	  m_nGroupListCount  (0),
	  m_nStartCount      (0),
	  m_nTotalCount      (0),
	  m_nHintId          (0),
	  m_ePrev            (NEWSBOX_STATE_NONE),
	  m_eState           (NEWSBOX_STATE_NONE),
	  m_eNext            (NEWSBOX_STATE_NONE)
{
}

/*
 * ~CntNewsBoxSyncJob_Impl.
 */
CntNewsBoxSyncJob_Impl::~CntNewsBoxSyncJob_Impl (void)
{
	ULONG n = m_aGroupList.Count();
	for (ULONG i = 0; i < n; i++)
		delete (m_aGroupList.GetObject(i));
	m_aGroupList.Clear();
	delete m_pStrm;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsBoxSyncJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxSyncJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == NEWSBOX_STATE_NONE)
	{
		// Initialize base.
		if (!Initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Online. Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		m_nStartCount = rList.Count();

		if ((m_nStartCount == 0) && (m_pLoadJob == NULL))
		{
			// Setup a CntNewsLoadListJob.
			m_pLoadJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(),
				*(pJob->GetRequest()));

			CntNewsLoadListJob_Impl *pLoadJob =
				new CntNewsLoadListJob_Impl (m_pLoadJob, GetParent());

			// Start child job.
			StartListening (*m_pLoadJob);
			GetRootNode()->RescheduleJob (m_pLoadJob);
			return NULL;
		}

		// Open GroupList stream.
		m_pStrm = m_pCache->openStream (S2U("NEWSBOXLIST"), STREAM_READWRITE);
		DBG_ASSERT(
			m_pStrm, "CntNewsBoxSyncJob_Impl::Execute(): no Stream");
		if (m_pStrm == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain Box itemset.
		CntStoreItemSetRef xBoxSet (
			GetParent()->GetBoxDirItemSet (m_pCache));
		DBG_ASSERT(
			xBoxSet.Is(), "CntNewsBoxSyncJob_Impl::Execute(): no BoxSet");
		if (xBoxSet.Is())
		{
			// Save StartCount as TotalCount.
			xBoxSet->Put (CntUInt32Item (
				WID_TOTALCONTENTCOUNT, m_nStartCount));

			// Release Box itemset.
			xBoxSet.Clear();
		}

		// Obtain GroupList.
		m_pMailer = GetParent()->GetMailer();
		m_ePrev   = m_eState;

		if (m_pMailer->NewsIsOpen())
		{
			m_eState = NEWSBOX_STATE_OPEN;
			m_eNext  = NEWSBOX_STATE_GROUPLIST;
		}
		else
		{
			m_eState = NEWSBOX_STATE_CLOSE;
			m_eNext  = NEWSBOX_STATE_OPEN;
		}
	}

	// Jump into state machine.
	ExecuteCallback (m_pMailer, SERVICE_READY, NULL, this);
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsBoxSyncJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxSyncJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case NEWSBOX_STATE_CLOSE:
				if (nReplyCode/100 == 2)
				{
					// Connection closed.
					m_ePrev  = m_eState;
					m_eState = m_eNext;
					if (m_eState == NEWSBOX_STATE_OPEN)
					{
						// Setup child job (CntNewsOpenJob).
						CntNodeJob *pChild = new CntNodeJob (
							pJob,
							pJob->GetClient(),
							pJob->GetSubject(),
							*(pJob->GetRequest()));

						CntNewsOpenJob_Impl *pOpenJob =
							new CntNewsOpenJob_Impl (pChild, GetParent());
						pOpenJob->SetCallback (
							CntNewsJob_Impl::ExecuteCallback, this);

						// Establish new connection.
						m_eNext = NEWSBOX_STATE_GROUPLIST;
						GetRootNode()->RescheduleJob (pChild);
						return;
					}
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_AUTHINFO:
				if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup child job (CntNewsAuthJob).
					CntNodeJob *pChild = new CntNodeJob (
						pJob, pJob->GetClient(), pJob->GetSubject(),
						*(pJob->GetRequest()));

					CntNewsAuthJob_Impl *pAuthJob =
						new CntNewsAuthJob_Impl (pChild, GetParent());
					pAuthJob->SetReplyText (pReplyText);
					pAuthJob->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start AuthenticateJob.
					GetRootNode()->RescheduleJob (pChild);
					return;
				}
				else if (nReplyCode == AUTHINFO_ACCEPTED)
				{
					// Ok, resume previous state.
					m_eState = m_ePrev;
					m_ePrev  = NEWSBOX_STATE_AUTHINFO;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_OPEN:
				if (nReplyCode/100 == 2)
				{
					// Cleanup GroupList.
					ULONG n = m_aGroupList.Count();
					for (ULONG i = 0; i < n; i++)
						delete (m_aGroupList.GetObject(i));
					m_aGroupList.Clear();
					m_nGroupListCount = 0;

					// Set TransferCallback.
					if (!pMailer->NewsSetTransferCallback (
						CntNewsJob_Impl::ExecuteCallback, this))
					{
						// Failure.
						NEWSBOX_STATE_FINISH();
						break;
					}

					// Obtain GroupList.
					m_ePrev  = m_eState;
					m_eState = NEWSBOX_STATE_GROUPLIST;
					m_eNext  = NEWSBOX_STATE_DONE;

					if (!pMailer->NewsGroupList (
						m_aGroupList,
						CntNewsJob_Impl::ExecuteCallback, this))
					{
						if (m_eState == NEWSBOX_STATE_GROUPLIST)
						{
							// Failure.
							NEWSBOX_STATE_FINISH();
							break;
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_GROUPLIST:
				if (nReplyCode/100 == 2)
				{
					// GroupList finished.
					ULONG nStartTicks = Time::GetSystemTicks();
					if (m_nGroupListCount == 0)
					{
						// Setup StatusText.
						m_nGroupListCount = m_aGroupList.Count();

						String aStatusStr (
							CntResId (RID_NEWS_TRANSFERING_NEWSGROUPS));
						aStatusStr.SearchAndReplace (
							S2U("$(ARG1)"),
							UniString::CreateFromInt32 (m_nGroupListCount));

						// ShowStatusText.
						m_nHintId = (USHORT)(-1);
						Broadcast (CntStatusBarHint (aStatusStr));

						// Initialize cache iteration.
						if (m_nGroupListCount < m_nStartCount)
							m_nGroupListCount = m_nStartCount;

						// Reset TotalCount (will be redetermined).
						m_pStrm->SetStreamSize(0);
						m_nTotalCount = 0;
					}

					// Synchronize GroupList.
					CntNewsGroupList &rList = GetParent()->GetGroupList();
					while (m_nTotalCount < rList.Count())
					{
						// Obtain known group.
						CntNewsGroupListEntry *pKnown =
							rList.GetObject (m_nTotalCount);

						ULONG nIndex = LIST_ENTRY_NOTFOUND;
						CntNewsGroupListEntry *pEntry =
							Find (pKnown->m_aGroupName, m_aGroupList, nIndex);
						if (pEntry != NULL)
						{
							// Save old attributes.
							ULONG nAttrib = pKnown->m_nFlags;
							nAttrib &= CNEWSIMP_GROUP_ATTRIB;

							// Update known group.
							*pKnown = *pEntry;
							pKnown->m_nFlags |= nAttrib;

							CntNodeRef xNode;
							Update (xNode, *pKnown);

							// Cleanup.
							m_aGroupList.Remove (nIndex);
							delete pEntry;
						}
						else
						{
							// Mark group as deleted.
							pKnown->m_nFlags &= ~CNTDIRENTRY_ATTRIB_NEW;
							pKnown->m_nFlags |=  CNTDIRENTRY_ATTRIB_REMOVED;
						}

						*m_pStrm << *pKnown;
						m_nTotalCount++;

						// Check elapsed time (be nice).
						if (Nice (nStartTicks))
							return;
					}

					// Process (remaining) GroupList.
					while (m_aGroupList.Count())
					{
						// Insert new group.
						CntNewsGroupListEntry *pEntry = m_aGroupList.Remove();
						if (m_nStartCount)
							pEntry->m_nFlags |= CNTDIRENTRY_ATTRIB_NEW;
						rList.Insert (pEntry, LIST_APPEND);

						// Append to GroupList.
						*m_pStrm << *pEntry;
						m_nTotalCount++;

						// Check elapsed time (be nice).
						if (Nice (nStartTicks))
							return;
					}

					// Cleanup.
					DELETEZ (m_pStrm);

					// Update Box itemset.
					CntStoreItemSetRef xBoxSet (
						GetParent()->GetBoxDirItemSet (m_pCache));
					DBG_ASSERT(
						xBoxSet.Is(), "CntNewsBoxSyncJob_Impl: no BoxSet");
					if (xBoxSet.Is())
					{
						// TotalCount.
						xBoxSet->Put (CntUInt32Item (
							WID_TOTALCONTENTCOUNT, m_nTotalCount));

						// LastUpdate.
						xBoxSet->Put (SfxDateTimeItem (
							WID_LAST_UPDATE, DateTime()));

						// Update Box.
						GetRootNode()->Put (*xBoxSet);
					}

					// Done.
					NEWSBOX_STATE_FINISH();
				}
				else if (nReplyCode == TRANSFER_WAIT)
				{
					// Setup StatusText.
					String aStatusStr (
						CntResId (RID_NEWS_TRANSFERING_NEWSGROUPS));
					aStatusStr.SearchAndReplace (
						S2U("$(ARG1)"),
						UniString::CreateFromInt32 (m_aGroupList.Count()));

					// ShowStatusText.
					m_nHintId = (USHORT)(-1);
					Broadcast (CntStatusBarHint (aStatusStr));

					// Wait for next callback.
					return;
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = NEWSBOX_STATE_OPEN;
					m_eState = NEWSBOX_STATE_AUTHINFO;
				}
				else
				{
					// Failure.
					if (pReplyText)
						pJob->SetError (*new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, *pReplyText));

					NEWSBOX_STATE_FINISH();
				}
				break;

			case NEWSBOX_STATE_DONE:
				// Done.
				pJob->Done();
				return;

			default: // NEWSBOX_STATE_NONE.
				return;
		}
	}
}

/*
 * Nice.
 */
BOOL CntNewsBoxSyncJob_Impl::Nice (ULONG nStartTicks)
{
	// Check elapsed time.
	ULONG nTicks = Time::GetSystemTicks();
	if ((nTicks - nStartTicks) <= CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
		return FALSE;

	// Provide some progress.
	if (m_nHintId == (USHORT)(-1))
	{
		// Remove StatusText.
		m_nHintId = 0;
		Broadcast (CntStatusBarHint (String()));

		// Create Progress.
		m_nHintId = CntStatusBarHint::CreateHintId();

		Broadcast (CntStatusBarHint (
			m_nHintId, 1, m_nGroupListCount,
			String (CntResId (RID_NEWS_LOADING_NEWSGROUPS))));
	}

	// Set Progress.
	Broadcast (CntStatusBarHint (m_nHintId, m_nTotalCount));

	// Be nice.
	GetRootNode()->RescheduleJob (GetJob());
	return TRUE;
}

/*
 * Notify.
 */
void CntNewsBoxSyncJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == m_pLoadJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// LoadListJob finished.
			EndListening (*m_pLoadJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}

	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Our job is finished here.
			EndListening (*pJob);

			// Cleanup.
			if (m_pMailer)
			{
				m_pMailer->NewsSetTransferCallback (NULL, NULL);

				if ((m_eState != NEWSBOX_STATE_DONE) &&
					(m_eState != NEWSBOX_STATE_NONE)    )
				{
					// Cancelled while busy.
					m_pMailer->NewsAbortConnection();
				}
			}

			if (m_nHintId)
			{
				if (m_nHintId == (USHORT)(-1))
				{
					// Remove StatusText.
					Broadcast (CntStatusBarHint (String()));
				}
				else
				{
					// Remove Progress.
					Broadcast (CntStatusBarHint (m_nHintId));
				}
				m_nHintId = 0;
			}
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsBoxGetListJob_Impl Implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxGetListJob_Impl.
 */
CntNewsBoxGetListJob_Impl::CntNewsBoxGetListJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pLoadJob      (NULL),
	  m_pFolderList   (NULL),
	  m_pViewData     (NULL),
	  m_nTotalCount   (0),
	  m_bSubscribedOnly(SAL_STATIC_CAST(const CntFolderListItem *,
										pJob->GetRequest())->
						  getCommand()
						 == CntFolderListItem::GET_SUBSCRIBED)
{
}

/*
 * ~CntNewsBoxGetListJob_Impl.
 */
CntNewsBoxGetListJob_Impl::~CntNewsBoxGetListJob_Impl (void)
{
	if (m_pFolderList)
	{
		ULONG n = m_pFolderList->Count();
		for (ULONG i = 0; i < n; i++)
			delete ((CntFolderEntry *)(m_pFolderList->GetObject(i)));
		DELETEZ (m_pFolderList);
	}
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsBoxGetListJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxGetListJob_Impl::Execute(): no pJob");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_pFolderList == NULL)
	{
		// Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		if (rList.Count() == 0)
		{
			// Not available. Check LoadJob.
			if (m_pLoadJob != NULL)
			{
				// Already have been here. LoadJob failed.
				pJob->Cancel();
				return NULL;
			}

			// Initialize LastUpdate.
			DateTime aLastUpdate (Date(0), Time(0));

			// Obtain Box itemset.
			CntStoreItemSetRef xBoxSet (
				GetParent()->GetBoxDirItemSet (pJob->GetCacheNode()));
			if (xBoxSet.Is())
			{
				// Obtain LastUpdate.
				const SfxDateTimeItem& rItem =
					(const SfxDateTimeItem&)(xBoxSet->Get(WID_LAST_UPDATE));
				aLastUpdate = rItem.GetDateTime();

				// Release Box itemset.
				xBoxSet.Clear();
			}

			// Check LastUpdate.
			if (!aLastUpdate.IsValid())
			{
				// No successful LastUpdate. Check for Offline mode.
				CntConnMode eConnMode = GetParent()->GetConnMode();
				if (eConnMode == CNT_CONN_MODE_OFFLINE)
				{
					if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
					{
						// Job cancelled.
						return NULL;
					}
					eConnMode = GetParent()->GetConnMode();
				}

				// Check for Transacted mode.
				if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
				{
					// Insert into log and finish.
					pJob->Log();
					pJob->Done();
					return NULL;
				}

				// Online. Setup a CntNewsBoxSyncJob.
				m_pLoadJob = new CntNodeJob (
					pJob, pJob->GetClient(), pJob->GetSubject(),
					*(pJob->GetRequest())); // SfxVoidItem (WID_SYNCHRONIZE));

				CntNewsBoxSyncJob_Impl *pSyncJob =
					new CntNewsBoxSyncJob_Impl (m_pLoadJob, GetParent());
			}
			else
			{
				// Successful LastUpdate. Setup a CntNewsLoadListJob.
				m_pLoadJob = new CntNodeJob (
					pJob, pJob->GetClient(), pJob->GetSubject(),
					*(pJob->GetRequest()));

				CntNewsLoadListJob_Impl *pLoadJob =
					new CntNewsLoadListJob_Impl (m_pLoadJob, GetParent());
			}

			// Start child job.
			StartListening (*m_pLoadJob);
			GetRootNode()->RescheduleJob (m_pLoadJob);
			return NULL;
		}

		// Initialize GroupList iteration.
		m_pViewData   = pJob->GetViewDataNode();
		m_pFolderList = new CntFolderList;
		m_nTotalCount = 0;
	}

	// Load FolderList from GroupList and ViewNode.
	CntNewsGroupList &rList = GetParent()->GetGroupList();
	while (m_nTotalCount < rList.Count())
	{
		// Obtain GroupList entry.
		CntNewsGroupListEntry *pEntry = rList.GetObject(m_nTotalCount++);

		UINT32 nAttrib = 0;
		m_pViewData->attrib (pEntry->m_aGroupName, 0, 0, nAttrib);
		BOOL bSubscribed = (nAttrib & CNTDIRENTRY_ATTRIB_SUBSCRIBED) != 0;
		if (bSubscribed || !m_bSubscribedOnly)
		{
			// Create FolderEntry.
			CntFolderEntry *pFolderEntry =
				new CntFolderEntry (pEntry->m_aGroupName);

			// Setup FolderFlags from group attributes.
			USHORT nFlags  = 0;

			if (pEntry->m_nFlags & CNTDIRENTRY_ATTRIB_NEW)
				nFlags |= CNTFOLDER_NEW;
			if (pEntry->m_nFlags & CNTDIRENTRY_ATTRIB_REMOVED)
				nFlags |= CNTFOLDER_REMOVED;

			if (bSubscribed)
				nFlags |= CNTFOLDER_SUBSCR;

			pFolderEntry->SetFlags (nFlags);

			// Insert FolderEntry into FolderList.
			m_pFolderList->Insert (pFolderEntry);
		}

		// Check elapsed time.
		ULONG nTicks = Time::GetSystemTicks();
		if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
		{
			// Be nice.
			GetRootNode()->RescheduleJob (pJob);
			return NULL;
		}
	}

	// Put FolderList into Box (don't delete, owner changed).
	GetRootNode()->Put (CntFolderListItem (
		WID_NEWS_GROUPLIST, m_pFolderList));
	m_pFolderList = NULL;

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntNewsBoxGetListJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == m_pLoadJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// LoadJob finished.
			EndListening (*m_pLoadJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
			return;
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsBoxPutListJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxPutListJob_Impl.
 */
CntNewsBoxPutListJob_Impl::CntNewsBoxPutListJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pListJob      (NULL),
	  m_pFolderList   (NULL),
	  m_pCache        (NULL),
	  m_pViewData     (NULL),
	  m_nTotalCount   (0),
	  m_nSubscrCount  (0)
{
}

/*
 * ~CntNewsBoxPutListJob_Impl.
 */
CntNewsBoxPutListJob_Impl::~CntNewsBoxPutListJob_Impl (void)
{
	if (m_pFolderList)
	{
		ULONG n = m_pFolderList->Count();
		for (ULONG i = 0; i < n; i++)
			delete ((CntFolderEntry *)(m_pFolderList->GetObject(i)));
		DELETEZ (m_pFolderList);
	}
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsBoxPutListJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsBoxPutListJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	const CntFolderListItem * pReq
	 = SAL_STATIC_CAST(const CntFolderListItem *, pJob->GetRequest());
	DBG_ASSERT(
		pReq, "CntNewsBoxPutListJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_pFolderList == NULL)
	{
		// Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		if (rList.Count() == 0)
		{
			// Not available. Check LoadJob.
			if (m_pListJob != NULL)
			{
				// Already have been here. ListJob failed.
				pJob->Cancel();
				return NULL;
			}

			// Setup a CntNewsLoadListJob.
			m_pListJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(),
				*(pJob->GetRequest()));

			CntNewsLoadListJob_Impl *pLoadJob =
				new CntNewsLoadListJob_Impl (m_pListJob, GetParent());

			// Start child job.
			StartListening (*m_pListJob);
			GetRootNode()->RescheduleJob (m_pListJob);
			return NULL;
		}

		// Check request.
		m_pFolderList = pReq->takeList();
		if (m_pFolderList == NULL)
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Remember basic things.
		m_aBoxURL   = OWN_URL(GetRootNode());
		m_pCache    = pJob->GetCacheNode();
		m_pViewData = pJob->GetViewDataNode();
		m_pListJob  = NULL;

		// Initialize total and subscribed group counts.
		m_nTotalCount  = 0;
		m_nSubscrCount = 0;
	}

	// Obtain ViewMode.
	USHORT eViewMode = ITEMSET_VALUE(
		pJob->GetClient(), CntFolderViewModeItem, WID_FOLDERVIEW_MODE);

	// Process FolderList.
	CntNewsGroupList &rList = GetParent()->GetGroupList();
	while (m_nTotalCount < rList.Count())
	{
		CntNewsGroupListEntry *pEntry = rList.GetObject (m_nTotalCount++);

		ULONG nIndex;
		if (m_pFolderList->find (pEntry->m_aGroupName, String(), nIndex))
		{
			CntFolderEntry *pFolderEntry = m_pFolderList->Remove (nIndex);

			// Update GroupList entry.
			USHORT nFlags = pFolderEntry->GetFlags();
			if (nFlags & CNTFOLDER_DO_PURGE)
				nFlags = CNTFOLDER_DO_PURGE;

			if (nFlags & CNTFOLDER_NEW)
				pEntry->m_nFlags |= CNTDIRENTRY_ATTRIB_NEW;
			else
				pEntry->m_nFlags &= ~CNTDIRENTRY_ATTRIB_NEW;

			if (nFlags & CNTFOLDER_REMOVED)
				pEntry->m_nFlags |= CNTDIRENTRY_ATTRIB_REMOVED;
			else
				pEntry->m_nFlags &= ~CNTDIRENTRY_ATTRIB_REMOVED;

			// Update ViewItemSet.
			if (nFlags & CNTFOLDER_SUBSCR)
			{
				Subscribe (*pEntry);
				m_nSubscrCount++;
			}
			else
			{
				m_pViewData->remove (*pFolderEntry);
			}

			// Update group instance.
			String aGroupURL (m_aBoxURL);
			CNEWSIMP_CONCAT_URLPATH (aGroupURL, *pFolderEntry);

			BOOL bNeedInstance =
				((nFlags & CNTFOLDER_DO_PURGE) || (nFlags & CNTFOLDER_SUBSCR));
			CntNodeRef xGroup (
				GetRootNode()->Query (aGroupURL, bNeedInstance));
			if (xGroup.Is())
			{
				if (nFlags & CNTFOLDER_DO_PURGE)
				{
					xGroup->InsertJob (new CntNodeJob (
						pJob, xGroup, xGroup, SfxVoidItem (WID_PURGE)));
					rList.Remove (--m_nTotalCount);
					delete pEntry;
				}

				if (nFlags & CNTFOLDER_SUBSCR)
				{
					xGroup->Put (CntStringItem (WID_TITLE, *pFolderEntry));
					pJob->Result (xGroup, CNT_ACTION_INSERTED);
				}
				else
				{
					if (eViewMode != CNT_VIEW_ALL_FOLDERS)
						pJob->Result (xGroup, CNT_ACTION_REMOVED);
				}
			}

			// Cleanup current entry.
			delete pFolderEntry;
		}

		// Check elapsed time.
		ULONG nTicks = Time::GetSystemTicks();
		if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
		{
			// Be nice.
			GetRootNode()->RescheduleJob (pJob);
			return NULL;
		}
	}

	// Check SaveJob.
	if (m_pListJob == NULL)
	{
		// Setup a CntNewsSaveListJob.
		m_pListJob = new CntNodeJob (
			pJob, pJob->GetClient(), pJob->GetSubject(),
			*(pJob->GetRequest()));

		CntNewsSaveListJob_Impl *pSaveJob =
			new CntNewsSaveListJob_Impl (m_pListJob, GetParent());

		// Start child job.
		StartListening (*m_pListJob);
		GetRootNode()->RescheduleJob (m_pListJob);
		return NULL;
	}

	// Update BoxItemSet and Box.
	CntStoreItemSetRef xBoxSet (
		GetParent()->GetBoxDirItemSet (pJob->GetCacheNode()));
	if (xBoxSet.Is())
	{
		xBoxSet->Put (CntUInt32Item (
			WID_TOTALCONTENTCOUNT, m_nTotalCount));
		GetRootNode()->Put (*xBoxSet);

		xBoxSet.Clear();
	}

	// Update BoxViewItemSet and Client.
	CntStoreItemSetRef xViewSet (
		GetParent()->GetBoxViewItemSet (m_pViewData));
	if (xViewSet.Is())
	{
		xViewSet->Put (CntUInt32Item (
			WID_SUBSCRNEWSGROUPCOUNT, m_nSubscrCount));
		pJob->GetViewDataTarget()->CntInterface::Put (*xViewSet);

		xViewSet.Clear();
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Subscribe.
 */
void CntNewsBoxPutListJob_Impl::Subscribe (
	const CntNewsGroupListEntry &rEntry)
{
	// Check for already subscribed.
	UINT32 nAttrib = 0;
	m_pViewData->attrib (rEntry.m_aGroupName, 0, 0, nAttrib);
	if (nAttrib & CNTDIRENTRY_ATTRIB_SUBSCRIBED)
		return;

	// Create ViewData entry.
	nAttrib  = CNTDIRENTRY_ATTRIB_SUBSCRIBED;
	nAttrib |= CNTDIRENTRY_ATTRIB_CREATE;
	m_pViewData->attrib (rEntry.m_aGroupName, 0, nAttrib);

	// Check for already created.
	String aDirName (rEntry.m_aGroupName);
	aDirName += sal_Unicode('/');

	ErrCode eErrCode = m_pCache->attrib (aDirName, 0, 0);
	if (eErrCode != ERRCODE_IO_NOTEXISTS)
		return;

	// Create new directory node.
	String aDirURL (OWN_URL (m_pCache));
	CNEWSIMP_CONCAT_URLPATH (aDirURL, rEntry.m_aGroupName);

	CntNodeRef xDirNode (m_pCache->Query (aDirURL));
	if (xDirNode.Is())
	{
		// Initialize directory node.
		CntRangesItem aServerRanges (WID_SERVER_RANGES);
		if (rEntry.m_nArticleCount)
		{
			aServerRanges.InsertRange (
				rEntry.m_nFirstArticleNumber,
				rEntry.m_nLastArticleNumber);
		}
		xDirNode->Put (aServerRanges);
		xDirNode->Put (CntUInt32Item (
			WID_TOTALCONTENTCOUNT, rEntry.m_nArticleCount));
	}
}

/*
 * Notify.
 */
void CntNewsBoxPutListJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == m_pListJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// LoadJob finished.
			EndListening (*m_pListJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
			return;
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

