/*************************************************************************
 *
 *  $RCSfile: cnewsgrp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CNEWSGRP_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#ifndef _CNTNEWSIMP_HXX
#include "cnewsimp.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTMMITM_HXX
#include "cntmmitm.hxx"
#endif
#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CNTRANGE_HXX
#include "cntrange.hxx"
#endif

#ifndef _CNTVWITM_HXX
#define ITEMID_CNT_MSG_VIEWMODE WID_MESSAGEVIEW_MODE
#include "cntvwitm.hxx"
#endif

#ifndef _CNTXREF_HXX
#include "cntxref.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
#endif

#ifndef WID_SHOW_MSGS_HAS_LIMIT
#define WID_SHOW_MSGS_HAS_LIMIT WID_SHOW_MSGS_HAS_TIMELIMIT
#endif
#ifndef WID_SHOW_MSGS_LIMIT
#define WID_SHOW_MSGS_LIMIT     WID_SHOW_MSGS_TIMELIMIT
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet)
#endif

/*=======================================================================
 *
 * CntNewsGroup... Internals.
 *
 *=====================================================================*/
/*
 * CntDirtyItemSet Ranges.
 */
CNEWSGRP_DIR_RANGES_IMPL (aGrpDirRanges_Impl);
CNEWSGRP_USER_RANGES_IMPL (aGrpUserRanges_Impl);

CNEWSMSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*=======================================================================
 *
 * CntNewsGroupJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupJob_Impl.
 */
CntNewsGroupJob_Impl::CntNewsGroupJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pDirNode      (NULL),
	  m_pGroup        (NULL)
{
}

/*
 * ~CntNewsGroupJob_Impl.
 */
CntNewsGroupJob_Impl::~CntNewsGroupJob_Impl (void)
{
}

/*
 * initialize.
 */
BOOL CntNewsGroupJob_Impl::initialize (void)
{
	// Obtain DirectoryNode.
	m_pDirNode = GetJob()->GetDirectoryNode (FALSE);
	if (m_pDirNode == NULL)
		return FALSE;

	// Obtain Subject.
	m_pGroup = GetJob()->GetSubject();
	if (m_pGroup)
		m_aGroupName = ITEMSET_VALUE_STRING (m_pGroup, WID_TITLE);
	else
		return FALSE;

	// Restore OwnProperties.
	m_pGroup->Put (m_pDirNode->Get(WID_TOTALCONTENTCOUNT));
	m_pGroup->Put (m_pDirNode->Get(WID_SERVER_RANGES));
	m_pGroup->Put (m_pDirNode->Get(WID_KNOWN_RANGES));

	// Seen and Marked Ranges.
	CntStorageNode *pUserData = GetJob()->GetUserDataNode();
	if (pUserData)
	{
		CntStoreItemSetRef xUserSet (pUserData->openItemSet (
			aGrpUserRanges_Impl, m_aGroupName, STREAM_STD_READ));
		if (xUserSet.Is())
			m_pGroup->Put (*xUserSet);
	}

	// Done.
	return TRUE;
}

/*
 * updateArticle.
 */
void CntNewsGroupJob_Impl::updateArticle (
	CntNode              &rNode,
	const SfxItemSet     &rPropSet,
	const CntRangesItem &rSeenRanges,
	const CntRangesItem &rMarkRanges,
	ULONG                nIndex)
{
	// Update properties.
	rNode.Put (rPropSet);

	// Update 'Seen' property.
	BOOL bSeen = rSeenRanges.IsWithinRanges (nIndex);
	rNode.Put (CntBoolItem (WID_IS_READ, bSeen), WID_IS_READ);

	// Update 'Marked' property.
	BOOL bMark = rMarkRanges.IsWithinRanges (nIndex);
	rNode.Put (CntBoolItem (WID_IS_MARKED, bMark), WID_IS_MARKED);

	// Check message body state.
	if (rNode.GetItemState (WID_MESSAGEBODY, FALSE) == SFX_ITEM_DISABLED)
	{
		// Check StoreMode and MessageBody.
		if (queryDownload())
		{
			// Check message body availability.
			CntStorageNodeRef xCache (GetJob()->GetCacheNode());
			if (CntNewsMessage_Impl::queryAvailable (rNode, xCache))
			{
				// Enable message body.
				rNode.ClearItem (WID_MESSAGEBODY);
			}
		}
		else
		{
			// Enable message body.
			rNode.ClearItem (WID_MESSAGEBODY);
		}
	}
}

/*
 * update (Ranges and Counters).
 */
void CntNewsGroupJob_Impl::update (const CntRangesItem &rKnownRanges)
{
	// Update KnownCount and KnownRanges.
	CntUInt32Item aKnownCount (
		WID_TOTALCONTENTCOUNT, rKnownRanges.TotalCount());
	ULONG nKnown = aKnownCount.GetValue();

	m_pDirNode->Put (aKnownCount);
	m_pDirNode->Put (rKnownRanges);

	m_pGroup->Put (aKnownCount);
	m_pGroup->Put (rKnownRanges);

	// Obtain SeenRanges.
	CntRangesItem aSeenRanges (
		(const CntRangesItem&)(m_pGroup->Get (WID_READ_RANGES)));
	ULONG nSeen = aSeenRanges.TotalCount();
	if (nSeen)
	{
		ULONG nLast = rKnownRanges.TotalMax();
		if (aSeenRanges.TotalMax() > nLast)
			nLast = aSeenRanges.TotalMax();

		// Determine NotKnownRanges.
		CntRangesItem *pNotKnown = rKnownRanges.GetDifferenceRanges(1, nLast);
		if (pNotKnown)
		{
			// Update SeenRanges.
			aSeenRanges.SubtractRanges (*pNotKnown);

			// Update SeenCount.
			CntUInt32Item aSeenCount (
				WID_SEENCONTENTCOUNT, aSeenRanges.TotalCount());
			nSeen = aSeenCount.GetValue();

			// Update UserData itemset.
			CntStoreItemSetRef xUserSet (openUserDataItemSet());
			if (xUserSet.Is())
			{
				xUserSet->Put (aSeenCount);
				xUserSet->Put (aSeenRanges);
			}

			// Update GroupNode.
			m_pGroup->Put (aSeenCount);
			m_pGroup->Put (aSeenRanges);

			// Cleanup.
			delete pNotKnown;
		}
	}

	// Update 'Seen' property (empty group defined as seen).
	BOOL bSeen = ((nKnown > 0) ? (nSeen == nKnown) : TRUE);
	m_pGroup->Put (CntBoolItem (WID_IS_READ, bSeen));
}

/*
 * openUserDataItemSet.
 */
CntStoreItemSet* CntNewsGroupJob_Impl::openUserDataItemSet (void)
{
	CntStorageNode *pUserData = GetJob()->GetUserDataNode();
	if (pUserData == NULL)
		return NULL;

	if (pUserData->IsDummy())
		return NULL;

	return pUserData->openItemSet (
		aGrpUserRanges_Impl, m_aGroupName, STREAM_STD_READWRITE);
}

/*=======================================================================
 *
 * CntNewsGroupOpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupOpenJob_Impl.
 */
CntNewsGroupOpenJob_Impl::CntNewsGroupOpenJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsGroupJob_Impl (pJob, pParent),
	  m_xSubJob            (NULL),
	  m_pKnownRanges       (NULL),
	  m_pViewRanges        (NULL),
	  m_nDone              (0),
	  m_nLimit             ((ULONG)(~0)),
	  m_nHintId            (0),
	  m_eState             (STATE_NONE)
{
}

/*
 * ~CntNewsGroupOpenJob_Impl.
 */
CntNewsGroupOpenJob_Impl::~CntNewsGroupOpenJob_Impl (void)
{
	delete m_pViewRanges;
	delete m_pKnownRanges;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsGroupOpenJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsGroupOpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntNewsGroupOpenJob::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Initialize base.
		if (!initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check KnownRanges and ServerRanges.
		const CntRangesItem& rKnownRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES));
		const CntRangesItem& rServerRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_SERVER_RANGES));
		if (!(rKnownRanges.TotalCount() || rServerRanges.TotalCount()))
		{
			// Nothing do to.
			pJob->Done();
			return NULL;
		}

		// Setup KnownRanges working copy.
		if (rKnownRanges.TotalCount())
			m_pKnownRanges = new CntRangesItem (rKnownRanges);
		else
			m_pKnownRanges = new CntRangesItem (rServerRanges);

		// Seen and Marked Ranges.
		const CntRangesItem &rSeenRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_READ_RANGES));
		const CntRangesItem &rMarkRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_MARK_RANGES));

		// Determine ViewMode and Limit.
		USHORT eViewMode = CNT_VIEW_ALL_ARTICLES;
		if (pJob->GetClient())
		{
			// Obtain client settings.
			CntInterface *pClient = pJob->GetClient();

			eViewMode = ITEMSET_VALUE(
				pClient, CntMsgViewModeItem, WID_MESSAGEVIEW_MODE);

			if (ITEMSET_VALUE_BOOL(pClient, WID_SHOW_MSGS_HAS_LIMIT))
				m_nLimit = ITEMSET_VALUE_UINT16(pClient, WID_SHOW_MSGS_LIMIT);
		}

		// Initialize ViewRanges.
		switch (eViewMode)
		{
			case CNT_VIEW_MARKED_AND_UNREAD_ARTICLES:
				m_pViewRanges = new CntRangesItem (*m_pKnownRanges);
				m_pViewRanges->SubtractRanges (rSeenRanges);
				m_pViewRanges->AddRanges (rMarkRanges);
				break;

			case CNT_VIEW_UNREAD_ARTICLES:
				m_pViewRanges = new CntRangesItem (*m_pKnownRanges);
				m_pViewRanges->SubtractRanges (rSeenRanges);
				break;

			case CNT_VIEW_READ_ARTICLES:
				m_pViewRanges = new CntRangesItem (rSeenRanges);
				break;

			case CNT_VIEW_MARKED_ARTICLES:
				m_pViewRanges = new CntRangesItem (rMarkRanges);
				break;

			default: // CNT_VIEW_ALL_ARTICLES.
				m_pViewRanges = new CntRangesItem (*m_pKnownRanges);
				break;
		}

		// Observe client's Limit.
		ULONG nTotal = m_pViewRanges->TotalCount();
		if (nTotal > m_nLimit)
			nTotal = m_nLimit;
		if (nTotal > 0)
		{
			// Notify caller (ProgressStart).
			m_nHintId = CntStatusBarHint::CreateHintId();
			Broadcast (CntStatusBarHint (
				m_nHintId, 1, nTotal,
				String (CntResId (RID_PROT_LOADING_MESSAGES))));
		}

		// Next state.
		m_eState = STATE_OPEN;
		m_pGroup->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_OPEN)
	{
		// Root URL.
		String aRootURL (OWN_URL (GetRootNode()));

		// Seen and Marked Ranges.
		CntRangesItem aSeenRanges (
			(const CntRangesItem&)(m_pGroup->Get(WID_READ_RANGES)));
		CntRangesItem aMarkRanges (
			(const CntRangesItem&)(m_pGroup->Get(WID_MARK_RANGES)));

		// Process ViewRanges.
		while ((m_pViewRanges->Count() > 0) && (m_nLimit > m_nDone))
		{
			// Obtain most recent ArticleNumber.
			ULONG nIndex = m_pViewRanges->TotalMax();
			m_pViewRanges->RemoveRange (nIndex, nIndex);
			m_nDone++;

			// Obtain article's directory itemset.
			String aNumberURL ('M');
			aNumberURL += nIndex;

			CntStoreItemSetRef xDirSet (m_pDirNode->openItemSet (
				aMsgDirRanges_Impl, aNumberURL, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Setup message URL.
				const String &rMID = ITEMSET_VALUE_STRING(
					xDirSet, WID_MESSAGE_ID);

				String aMsgURL (aRootURL);
				CNEWSIMP_CONCAT_URLPATH (aMsgURL, rMID);

				// Create message node.
				CntNodeRef xNode (GetRootNode()->Query (aMsgURL));
				if (xNode.Is())
				{
					// Feed node with data.
					updateArticle (
						*xNode, *xDirSet, aSeenRanges, aMarkRanges, nIndex);

					// Announce message mode.
					Result (xNode);
				}

				// Cleanup.
				xDirSet.Clear();
			}
			else
			{
				// In KnownRange but not in Directory, i.e. need XOVER.
				m_pKnownRanges->RemoveRange (nIndex, nIndex);
			}

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller (ProgressSet).
				Broadcast (CntStatusBarHint (m_nHintId, m_nDone));

				// Be nice.
				m_pGroup->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Cleanup.
		DELETEZ (m_pViewRanges);
		if (m_nHintId)
		{
			// Notify caller (ProgressEnd).
			Broadcast (CntStatusBarHint (m_nHintId));
			m_nHintId = 0;
		}

		// Next state.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_ONLINE)
		{
			// Update articles.
			m_eState = STATE_UPDATE;
		}
		else
		{
			// Update Ranges and Counters.
			if (m_pKnownRanges)
				update (*m_pKnownRanges);

			// Finish.
			m_eState = STATE_DONE;
		}
		DELETEZ (m_pKnownRanges);
	}

	if (m_eState == STATE_UPDATE)
	{
		// Check for SubJob.
		if (!m_xSubJob.Is())
		{
			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), m_pGroup, *pReq);
			CntNewsJob_Impl *pJobImpl =
				new CntNewsGroupUpdateJob_Impl (m_xSubJob, GetParent());

			// Queue SubJob.
			StartListening (*m_xSubJob);
			GetRootNode()->InsertJob (m_xSubJob);
			return NULL;
		}
		else
		{
			// Check SubJob result.
			if (m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Cleanup.
			m_xSubJob.Clear();
		}

		// Next state.
		m_eState = STATE_DONE;
	}

	if (m_eState == STATE_DONE)
	{
		// Finished.
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * Notify.
 */
void CntNewsGroupOpenJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			m_pGroup->RescheduleJob (GetJob());
		}
		return;
	}
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (m_nHintId)
			{
				// Notify caller (ProgessEnd).
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}

			if (m_pKnownRanges)
			{
				// Update Ranges and Counters.
				update (*m_pKnownRanges);
				DELETEZ (m_pKnownRanges);
			}
		}
	}
	CntNewsGroupJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsGroupUpdateJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupUpdateJob_Impl.
 */
CntNewsGroupUpdateJob_Impl::CntNewsGroupUpdateJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsGroupJob_Impl (pJob, pParent),
	  m_pMailer            (NULL),
	  m_pMessage           (NULL),
	  m_pKnownRanges       (NULL),
	  m_nLimit             ((ULONG)(~0)),
	  m_nHintId            (0),
	  m_eState             (STATE_NONE),
	  m_ePrev              (STATE_NONE)
{
}

/*
 * ~CntNewsGroupUpdateJob_Impl.
 */
CntNewsGroupUpdateJob_Impl::~CntNewsGroupUpdateJob_Impl (void)
{
	delete m_pKnownRanges;
	delete m_pMessage;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsGroupUpdateJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsGroupUpdateJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntNewsGroupUpdateJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Initialize base.
		if (!initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT(
			m_pMailer, "CntNewsGroupUpdateJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Next state.
		m_eState = STATE_UPDATE;
	}

	if (m_eState == STATE_UPDATE)
	{
		// Obtain current KnownRanges.
		CntRangesItem aKnownRanges (
			(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES)));
		ULONG nKnown = aKnownRanges.TotalCount();

		// Obtain most recent ArticleNumber.
		ULONG nIndex = aKnownRanges.TotalMax();
		while (nIndex)
		{
			// Check article existence.
			String aUrl ('M');
			aUrl += nIndex;

			if (m_pDirNode->attrib (aUrl, 0, 0) == ERRCODE_IO_NOTEXISTS)
			{
				// In KnownRange but not in Directory, i.e. need XOVER.
				aKnownRanges.RemoveRange (nIndex, nIndex);

				// Obtain next recent ArticleNumber.
				nIndex = aKnownRanges.TotalMax();
			}
			else
			{
				// Already exists.
				nIndex = 0;
			}
		}

		// Check resulting KnownCount.
		if (!(nKnown == aKnownRanges.TotalCount()))
		{
			// Update KnownCount and KnownRanges.
			nKnown = aKnownRanges.TotalCount();
			CntUInt32Item aKnownCount (WID_TOTALCONTENTCOUNT, nKnown);

			// m_pDirNode->Put (aKnownCount);
			m_pDirNode->Put (aKnownRanges);

			// m_pGroup->Put (aKnownCount);
			m_pGroup->Put (aKnownRanges);
		}

		// Check client settings.
		CntInterface *pClient = pJob->GetClient();
		if (pClient)
		{
			// Obtain Limit.
			if (ITEMSET_VALUE_BOOL (pClient, WID_SHOW_MSGS_HAS_LIMIT))
				m_nLimit = ITEMSET_VALUE_UINT16 (pClient, WID_SHOW_MSGS_LIMIT);
		}

		// Next state.
		m_ePrev = m_eState;
		if (m_pMailer->NewsIsOpen())
			m_eState = STATE_OPEN;
		else
			m_eState = STATE_CLOSED;
	}

	// Jump into state machine.
	ExecuteHandler (m_pMailer, SERVICE_READY, NULL);
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsGroupUpdateJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsGroupUpdateJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return;
	}

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_CLOSED:
				if (nReplyCode/100 == 2)
				{
					// Next state.
					m_ePrev  = m_eState;
					m_eState = STATE_OPEN;

					// Setup OpenJob.
					CntNodeJobRef xSubJob (new CntNodeJob (
						pJob, pJob->GetClient(), m_pGroup, *pReq));

					CntNewsOpenJob_Impl *pJobImpl =
						new CntNewsOpenJob_Impl (xSubJob, GetParent());
					pJobImpl->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start OpenJob.
					GetRootNode()->RescheduleJob (xSubJob);
					return;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_AUTH:
				if (nReplyCode/100 == 2)
				{
					// Resume previous state.
					m_eState = m_ePrev;
					m_ePrev  = STATE_AUTH;

					// Try again.
					GetRootNode()->RescheduleJob (pJob);
					return;
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup AuthJob.
					CntNodeJobRef xSubJob (new CntNodeJob (
						pJob, pJob->GetClient(), m_pGroup, *pReq));

					CntNewsAuthJob_Impl *pJobImpl =
						new CntNewsAuthJob_Impl (xSubJob, GetParent());
					pJobImpl->SetReplyText (pReplyText);
					pJobImpl->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start AuthJob.
					GetRootNode()->RescheduleJob (xSubJob);
					return;
				}
				else if (nReplyCode == PERMISSION_DENIED)
				{
					// Previous authentication failed.
					CntNodeRef xRoot (GetRootNode());

					const String &rAccount =
						ITEMSET_VALUE_STRING(xRoot, WID_ACCOUNT);

					if (!(rAccount == m_aGroupName))
					{
						CNT_RNM()->RemoveLoginInfo (OWN_URL (xRoot));

						xRoot->Put (CntStringItem (WID_USERNAME, String()));
						xRoot->Put (CntStringItem (WID_PASSWORD, String()));
						xRoot->Put (CntStringItem (WID_ACCOUNT, m_aGroupName));
					}

					// Authenticate.
					nReplyCode = AUTHINFO_REQUIRED;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_OPEN:
				if (nReplyCode/100 == 2)
				{
					// Next state.
					m_ePrev  = m_eState;
					m_eState = STATE_SELECT;

					// Setup GroupEntry.
					m_aGroupEntry.initialize();
					m_aGroupEntry.m_aGroupName = m_aGroupName;

					// Select group.
					if (!pMailer->NewsSelectGroup (
						m_aGroupEntry,
						CntNewsJob_Impl::ExecuteCallback, this))
					{
						// Failure. Notify caller.
						if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_SELECT:
				if (nReplyCode/100 == 2)
				{
					// Check GroupEntry.
					ULONG nFirst = m_aGroupEntry.m_nFirstArticleNumber =
						VOS_MAX (1, m_aGroupEntry.m_nFirstArticleNumber);
					ULONG nLast = m_aGroupEntry.m_nLastArticleNumber =
						VOS_MAX (0, m_aGroupEntry.m_nLastArticleNumber);
					if (m_aGroupEntry.m_nArticleCount == 0)
						m_aGroupEntry.m_nArticleCount = (nLast + 1) - nFirst;

					// Update ServerRanges.
					CntRangesItem aServerRanges (WID_SERVER_RANGES);
					if (m_aGroupEntry.m_nArticleCount)
					{
						aServerRanges.InsertRange (
							m_aGroupEntry.m_nFirstArticleNumber,
							m_aGroupEntry.m_nLastArticleNumber);
					}
					m_pDirNode->Put (aServerRanges);

					// Check for cache synchronization.
					CntNodeJobRef xSubJob (NULL);
					xSubJob = queryArticleCleanup (aServerRanges);
					if (xSubJob.Is())
					{
						// Queue article cleanup Job.
						GetRootNode()->InsertJob (xSubJob);
					}
					xSubJob = queryArticleDownload (aServerRanges);
					if (xSubJob.Is())
					{
						// Queue article download Job.
						GetRootNode()->InsertJob (xSubJob);
					}
					xSubJob.Clear();

					// Obtain current KnownRanges.
					delete m_pKnownRanges;
					m_pKnownRanges = new CntRangesItem (
						(const CntRangesItem&)
						(m_pGroup->Get(WID_KNOWN_RANGES)));

					// Determine 1st unknown article number.
					if (pReq->Which() == WID_SYNCHRONIZE)
						nFirst = 1;
					else
						nFirst = 1 + m_pKnownRanges->TotalMax();

					if (nFirst > 1)
						m_nLimit = (ULONG)(~0);
					if (nFirst > m_aGroupEntry.m_nFirstArticleNumber)
						m_aGroupEntry.m_nFirstArticleNumber = nFirst;

					if (m_aGroupEntry.m_nArticleCount && (nFirst <= nLast))
					{
						// Create new message container.
						delete m_pMessage;
						m_pMessage = m_pMailer->CreateINetCoreNewsMessage();

						// Notify caller (ProgressStart).
						m_nHintId = CntStatusBarHint::CreateHintId();
						Broadcast (CntStatusBarHint (
							m_nHintId,
							m_aGroupEntry.m_nFirstArticleNumber,
							m_aGroupEntry.m_nLastArticleNumber,
							String (CntResId (RID_NEWS_LOADING_ARTICLES))));

						// Next state.
						m_ePrev  = m_eState;
						m_eState = STATE_OVERVIEW;

						// Obtain article overview.
						if (!pMailer->NewsArticleHeadOverview (
							m_aGroupEntry.m_nFirstArticleNumber,
							m_aGroupEntry.m_nLastArticleNumber,
							*m_pMessage,
							CntNewsJob_Impl::ExecuteCallback, this))
						{
							// Failure. Notify caller.
							if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
							{
								// Try again.
								m_eState = STATE_OPEN;
								GetRootNode()->RescheduleJob (pJob);
							}
						}

						// Wait for next callback.
						return;
					}
					else
					{
						// No more articles.
						m_ePrev  = m_eState;
						m_eState = STATE_DONE;
					}
				}
				else if ((nReplyCode == PERMISSION_DENIED) ||
						 (nReplyCode == AUTHINFO_REQUIRED)    )
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = STATE_OPEN;
					m_eState = STATE_AUTH;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_OVERVIEW:
				if (nReplyCode == TRANSFER_OVERVIEW)
				{
					// Obtain ArticleNumber (TRANSER_OVERVIEW special).
					ULONG nIndex = *((ULONG*)pReplyText);

					// Notify caller (ProgressSet).
					Broadcast (CntStatusBarHint (m_nHintId, nIndex));

					// Store Article.
					CntCrossReferenceItem aXref (
						WID_NEWS_XREF, m_aGroupName, nIndex);
					CntStoreItemSetRef xDirSet (storeArticle (
						*m_pMessage, aXref));
					if (xDirSet.Is())
					{
						// Insert into KnownRanges.
						if (m_pKnownRanges)
							m_pKnownRanges->InsertRange (nIndex, nIndex);

						if (m_aGroupEntry.m_nArticleCount)
							m_aGroupEntry.m_nArticleCount--;
						if (m_aGroupEntry.m_nArticleCount < m_nLimit)
						{
							// Setup MessageURL.
							String aUrl (OWN_URL (GetRootNode()));
							aUrl += m_pMessage->GetMessageID();

							CntNodeRef xNode (GetRootNode()->Query(aUrl));
							if (xNode.Is())
							{
								// Seen and Marked Ranges.
								const CntRangesItem &rSeenRanges =
									(const CntRangesItem&)
									(m_pGroup->Get(WID_READ_RANGES));
								const CntRangesItem &rMarkRanges =
									(const CntRangesItem&)
									(m_pGroup->Get(WID_MARK_RANGES));

								// Feed node with data.
								updateArticle (
									*xNode, *xDirSet,
									rSeenRanges, rMarkRanges, nIndex);

								// Announce message mode.
								Result (xNode);
							}
						}
					}

					// Cleanup message.
					String aClean;
					m_pMessage->SetMessageID (aClean);
					m_pMessage->SetBytes (aClean);
					m_pMessage->SetDate (aClean);
					m_pMessage->SetFrom (aClean);
					m_pMessage->SetReferences (aClean);
					m_pMessage->SetSubject (aClean);
					m_pMessage->SetXref (aClean);

					// Wait for next callback.
					return;
				}
				else if (nReplyCode == TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else if ((nReplyCode == PERMISSION_DENIED) ||
						 (nReplyCode == AUTHINFO_REQUIRED)    )
				{
					// Check Progress.
					if (m_nHintId)
					{
						// Notify caller (ProgressEnd).
						Broadcast (CntStatusBarHint (m_nHintId));
						m_nHintId = 0;
					}

					// Setup state to resume and Authenticate.
					m_ePrev  = STATE_OPEN;
					m_eState = STATE_AUTH;
				}
				else
				{
					// Finished.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (nReplyCode/100 == 2)
				{
					// Finished.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
					pJob->Done();
				}
				else
				{
					// Finished.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
					pJob->Cancel();
				}
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * queryArticleCleanup.
 */
CntNodeJob* CntNewsGroupUpdateJob_Impl::queryArticleCleanup (
	const CntRangesItem &rServerRanges)
{
	// Obtain request.
	const SfxPoolItem *pReq = GetJob()->GetRequest();
	if (pReq == NULL)
		return NULL;

	// Check request.
	USHORT nWhich = pReq->Which();
	if (!((nWhich == WID_UPDATE) || (nWhich == WID_SYNCHRONIZE)))
		return NULL;

	// Obtain current KnownRanges.
	const CntRangesItem &rKnownRanges =
		(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES));

	// Check for deleted articles.
	ULONG nPrevMin = rKnownRanges.TotalMin();
	ULONG nNextMin = rServerRanges.TotalMin();
	if (!((0 < nPrevMin) && (nPrevMin < nNextMin)))
		return NULL;

	// Setup article cleanup Job.
	CntRangesItem aDeleteRanges (WID_CLEAN_CACHE);
	aDeleteRanges.InsertRange (nPrevMin, nNextMin - 1);

	CntNodeJob *pJob = new CntNodeJob (
		NULL, GetJob()->GetClient(), m_pGroup, aDeleteRanges);

	CntNewsJob_Impl *pJobImpl =
		new CntNewsGroupDeleteJob_Impl (pJob, GetParent());
	pJob->SetRequestData (pJobImpl);

	// Done.
	return pJob;
}

/*
 * queryArticleDownload.
 */
CntNodeJob* CntNewsGroupUpdateJob_Impl::queryArticleDownload (
	const CntRangesItem &rServerRanges)
{
	// Obtain request.
	const SfxPoolItem *pReq = GetJob()->GetRequest();
	if (pReq == NULL)
		return NULL;

	// Check request.
	USHORT nWhich = pReq->Which();
	if (!((nWhich == WID_UPDATE) || (nWhich == WID_SYNCHRONIZE)))
		return NULL;

	// Check for article download.
	if (!(rServerRanges.TotalCount() && queryDownload()))
		return NULL;

	// Setup article download Job.
	CntNodeJob *pJob = new CntNodeJob (
		NULL, GetJob()->GetClient(), m_pGroup, rServerRanges);

	CntNewsJob_Impl *pJobImpl =
		new CntNewsGroupLoadJob_Impl (pJob, GetParent());
	pJob->SetRequestData (pJobImpl);

	// Done.
	return pJob;
}

/*
 * storeArticle.
 */
CntStoreItemSet* CntNewsGroupUpdateJob_Impl::storeArticle (
	const INetCoreNewsMessage   &rMessage,
	const CntCrossReferenceItem &rXref)
{
	// Check MessageID.
	const String &rMID = rMessage.GetMessageID();
	if (rMID.Len() == 0)
		return NULL;

	// Create message itemset.
	CntStoreItemSet *pDirSet = m_pDirNode->openItemSet (
		aMsgDirRanges_Impl, rMID, STREAM_STD_READWRITE);
	if (pDirSet == NULL)
		return NULL;

	// Create hidden link from Number to MessageID.
	String aNumberURL ('M');
	aNumberURL += rXref.GetIndex();
	m_pDirNode->link (rMID, aNumberURL);

	// Store message properties.
	CntNewsMessage_Impl::updateProperties (
		*pDirSet, rMessage, rXref, GetJob()->GetCacheNode());

	// Done.
	return pDirSet;
}

/*
 * Notify.
 */
void CntNewsGroupUpdateJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (pJob->IsCancelled())
			{
				if (m_eState != STATE_NONE)
				{
					// Abort connection.
					if (m_pMailer)
						m_pMailer->NewsAbortConnection();

					// Force into idle state.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
				}
			}

			if (m_nHintId)
			{
				// Notify caller (ProgessEnd).
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}

			if (m_pKnownRanges)
			{
				// Update Ranges and Counters.
				update (*m_pKnownRanges);
				DELETEZ (m_pKnownRanges);
			}
		}
	}
	CntNewsGroupJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsGroupLoadJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupLoadJob_Impl.
 */
CntNewsGroupLoadJob_Impl::CntNewsGroupLoadJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsGroupJob_Impl (pJob, pParent),
	  m_pMailer     (NULL),
	  m_pMessage    (NULL),
	  m_pCache      (NULL),
	  m_pInitRanges (NULL),
	  m_pLoadRanges (NULL),
	  m_aLoadLimit  (Date(0), Time(0)),
	  m_nLoadCount  (0),
	  m_eState      (STATE_NONE),
	  m_ePrev       (STATE_NONE)
{
}

/*
 * ~CntNewsGroupLoadJob_Impl.
 */
CntNewsGroupLoadJob_Impl::~CntNewsGroupLoadJob_Impl (void)
{
	delete m_pInitRanges;
	delete m_pLoadRanges;
	delete m_pMessage;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsGroupLoadJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsGroupLoadJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const CntRangesItem *pReq = PTR_CAST (CntRangesItem, pJob->GetRequest());
	DBG_ASSERT (pReq, "CntNewsGroupLoadJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Initialize base.
		if (!initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntNewsGroupLoadJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Setup InitRanges.
		if (ITEMSET_VALUE_BOOL (GetRootNode(), WID_STORE_MARKED))
		{
			const CntRangesItem &rMarkRanges =
				(const CntRangesItem&)(m_pGroup->Get(WID_MARK_RANGES));
			m_pInitRanges = rMarkRanges.GetIntersectRanges (*pReq);
		}
		else
		{
			const CntRangesItem &rKnownRanges =
				(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES));
			m_pInitRanges = rKnownRanges.GetIntersectRanges (*pReq);
		}
#if 0   /* JUST AN IDEA */
		if (m_pInitRanges)
		{
			// Include MarkRanges.
			const CntRangesItem &rMarkRanges =
				(const CntRangesItem&)(m_pGroup->Get(WID_MARK_RANGES));
			m_pInitRanges->AddRanges (rMarkRanges);
		}
#endif  /* JUST AN IDEA */

		// Check for article download.
		if (!(m_pInitRanges && m_pInitRanges->TotalCount() && queryDownload()))
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}
		m_pLoadRanges = new CntRangesItem (pReq->Which());

		// Check Limit.
		if (ITEMSET_VALUE_BOOL (GetRootNode(), WID_STORE_MSGS_HAS_TIMELIMIT))
		{
			// Obtain Limit.
			m_aLoadLimit  = DateTime();
			m_aLoadLimit -= (long)(ITEMSET_VALUE_UINT16(
				GetRootNode(), WID_STORE_MSGS_TIMELIMIT));
		}

		// Ensure nonblocking bulk operation.
		m_eState = STATE_ITER;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_ITER)
	{
		// Obtain Root URL.
		const String &rRootUrl = OWN_URL (GetRootNode());

		// Determine LoadRanges from InitRanges.
		while (m_pInitRanges->TotalCount())
		{
			ULONG nIndex = m_pInitRanges->TotalMin();
			m_pInitRanges->RemoveRange (nIndex, nIndex);

			UniString aNumberUrl (sal_Unicode('M'));
			aNumberUrl += UniString::CreateFromInt32 (nIndex);

			CntStoreItemSetRef xDirSet (m_pDirNode->openItemSet (
				aMsgDirRanges_Impl, aNumberUrl, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Check download conditions.
				const SfxDateTimeItem &rProp =
					(const SfxDateTimeItem&)(xDirSet->Get(WID_DATE_CREATED));
				if (m_aLoadLimit < rProp.GetDateTime())
				{
					// Obtain MessageID.
					const String &rMID = ITEMSET_VALUE_STRING(
						xDirSet, WID_MESSAGE_ID);

					// Setup message body URL.
					String aBodyUrl (rRootUrl);
					CNEWSIMP_CONCAT_URLPATH (aBodyUrl, rMID);
					aBodyUrl.AppendAscii (".body");

					// Check message body existence.
					ErrCode eErrCode = m_pCache->attrib (aBodyUrl, 0, 0);
					if (eErrCode == ERRCODE_IO_NOTEXISTS)
					{
						// Insert into LoadRanges.
						m_pLoadRanges->InsertRange (nIndex, nIndex);
					}
				}
			}

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Next state.
		m_ePrev = m_eState;
		if ((m_nLoadCount = m_pLoadRanges->TotalCount()) > 0)
			m_eState = STATE_LOAD;
		else
			m_eState = STATE_DONE;
	}

	if (m_eState == STATE_LOAD)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT(
			m_pMailer, "CntNewsGroupLoadJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Next state.
		m_ePrev = m_eState;
		if (m_pMailer->NewsIsOpen())
			m_eState = STATE_OPEN;
		else
			m_eState = STATE_CLOSED;
	}

	// Jump into state machine.
	ExecuteHandler (m_pMailer, SERVICE_READY, NULL);
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsGroupLoadJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsGroupLoadJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT(
		pReq, "CntNewsGroupLoadJob_Impl::ExecuteHandler(): no Request");
	if (pReq == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_CLOSED:
				if (nReplyCode/100 == 2)
				{
					// Next state.
					m_ePrev  = m_eState;
					m_eState = STATE_OPEN;

					// Setup OpenJob.
					CntNodeJobRef xSubJob (new CntNodeJob (
						pJob, pJob->GetClient(), m_pGroup, *pReq));

					CntNewsOpenJob_Impl *pJobImpl =
						new CntNewsOpenJob_Impl (xSubJob, GetParent());
					pJobImpl->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start OpenJob.
					GetRootNode()->RescheduleJob (xSubJob);
					return;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_AUTH:
				if (nReplyCode/100 == 2)
				{
					// Resume previous state.
					m_eState = m_ePrev;
					m_ePrev  = STATE_AUTH;

					// Try again.
					GetRootNode()->RescheduleJob (pJob);
					return;
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup AuthJob.
					CntNodeJobRef xSubJob (new CntNodeJob (
						pJob, pJob->GetClient(), m_pGroup, *pReq));

					CntNewsAuthJob_Impl *pJobImpl =
						new CntNewsAuthJob_Impl (xSubJob, GetParent());
					pJobImpl->SetReplyText (pReplyText);
					pJobImpl->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start AuthJob.
					GetRootNode()->RescheduleJob (xSubJob);
					return;
				}
				else if (nReplyCode == PERMISSION_DENIED)
				{
					// Previous authentication failed.
					CntNodeRef xRoot (GetRootNode());

					const String &rAccount =
						ITEMSET_VALUE_STRING(xRoot, WID_ACCOUNT);

					if (!(rAccount == m_aGroupName))
					{
						CNT_RNM()->RemoveLoginInfo (OWN_URL (xRoot));

						xRoot->Put (CntStringItem (WID_USERNAME, String()));
						xRoot->Put (CntStringItem (WID_PASSWORD, String()));
						xRoot->Put (CntStringItem (WID_ACCOUNT, m_aGroupName));
					}

					// Authenticate.
					nReplyCode = AUTHINFO_REQUIRED;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_OPEN:
				if (nReplyCode/100 == 2)
				{
					// Next state.
					m_ePrev  = m_eState;
					m_eState = STATE_SELECT;

					// Setup GroupEntry.
					m_aGroupEntry.initialize();
					m_aGroupEntry.m_aGroupName = m_aGroupName;

					// Select group.
					if (!pMailer->NewsSelectGroup (
						m_aGroupEntry,
						CntNewsJob_Impl::ExecuteCallback, this))
					{
						// Failure. Notify caller.
						if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
						{
							// Try again.
							m_eState = STATE_LOAD;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_SELECT:
				if (nReplyCode/100 == 2)
				{
					// Check for remaining articles.
					if (m_pLoadRanges->TotalCount())
					{
						// Next state.
						m_ePrev  = m_eState;
						m_eState = STATE_ARTICLE;

						// Initialize article download.
						initDownload (*pMailer, m_pMessage);

						// Retrieve article (by number).
						if (!pMailer->NewsArticle (
							m_pLoadRanges->TotalMax(), *m_pMessage,
							CntNewsJob_Impl::ExecuteCallback, this))
						{
							// Failure. Notify caller.
							if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
							{
								// Try again.
								m_eState = STATE_LOAD;
								GetRootNode()->RescheduleJob (pJob);
							}
						}

						// Wait for next callback.
						return;
					}
					else
					{
						// No more articles.
						m_ePrev  = m_eState;
						m_eState = STATE_DONE;
					}
				}
				else if ((nReplyCode == PERMISSION_DENIED) ||
						 (nReplyCode == AUTHINFO_REQUIRED)    )
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = STATE_OPEN;
					m_eState = STATE_AUTH;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_ARTICLE:
				if (nReplyCode/100 == 2)
				{
					// Show article download status.
					showDownload (*pMailer);

					// Remove article from LoadRanges.
					ULONG nIndex = m_pLoadRanges->TotalMax();
					m_pLoadRanges->RemoveRange (nIndex, nIndex);

					// Save article.
					CntCrossReferenceItem aXref (
						WID_NEWS_XREF, m_aGroupName, nIndex);
					saveDownload (*pMailer, *m_pMessage, aXref);

					// Next state.
					m_ePrev  = m_eState;
					m_eState = STATE_SELECT;
				}
				else if (nReplyCode == TRANSFER_WAIT)
				{
					// Show article download status.
					showDownload (*pMailer);

					// Wait for next callback.
					return;
				}
				else if ((nReplyCode == NO_SUCH_ARTICLE_NUMBER) ||
						 (nReplyCode == NO_SUCH_ARTICLE       )    )
				{
					// Remove article from LoadRanges.
					ULONG nIndex = m_pLoadRanges->TotalMax();
					m_pLoadRanges->RemoveRange (nIndex, nIndex);

					// Download next article.
					m_ePrev  = m_eState;
					m_eState = STATE_SELECT;

					nReplyCode = SERVICE_READY;
				}
				else if ((nReplyCode == PERMISSION_DENIED) ||
						 (nReplyCode == AUTHINFO_REQUIRED)    )
				{
					// Setup state to resume and Authenticate.
					m_ePrev  = STATE_OPEN;
					m_eState = STATE_AUTH;
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (nReplyCode/100 == 2)
				{
					// Finished.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
					pJob->Done();
				}
				else
				{
					// Failure.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
					pJob->Cancel();
				}
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * initDownload.
 */
void CntNewsGroupLoadJob_Impl::initDownload (
	INetCoreMailer       &rMailer,
	INetCoreNewsMessage *&rpMessage)
{
	// Initialize download stream.
	CntNewsMessage_Impl::initDownload (rMailer, rpMessage, m_pCache);

	// Set transfer callback.
	rMailer.NewsSetTransferCallback (
		CntNewsJob_Impl::ExecuteCallback, this);
}

/*
 * clearDownload.
 */
void CntNewsGroupLoadJob_Impl::clearDownload (
	INetCoreMailer      &rMailer,
	INetCoreNewsMessage &rMessage)
{
	// Clear transfer callback.
	rMailer.NewsSetTransferCallback (NULL, NULL);

	// Cleanup download stream.
	CntNewsMessage_Impl::cleanupDownload (rMessage, m_pCache);
}

/*
 * saveDownload.
 */
BOOL CntNewsGroupLoadJob_Impl::saveDownload (
	INetCoreMailer              &rMailer,
	INetCoreNewsMessage         &rMessage,
	const CntCrossReferenceItem &rXref)
{
	// Clear transfer callback.
	rMailer.NewsSetTransferCallback (NULL, NULL);

	// Check MessageID.
	const String &rMID = rMessage.GetMessageID();
	if (rMID.Len() == 0)
	{
		// Failure. Cleanup download stream.
		CntNewsMessage_Impl::cleanupDownload (rMessage, m_pCache);
		return FALSE;
	}

	// Obtain message itemset.
	CntStoreItemSetRef xDirSet (m_pDirNode->openItemSet (
		aMsgDirRanges_Impl, rMID, STREAM_STD_READWRITE));
	if (xDirSet.Is())
	{
		// Store message properties.
		CntNewsMessage_Impl::updateProperties (
			*xDirSet, rMessage, rXref, m_pCache);

		// Cleanup.
		xDirSet.Clear();
	}

	// Setup body URL.
	String aBodyUrl (OWN_URL (GetRootNode()));
	CNEWSIMP_CONCAT_URLPATH (aBodyUrl, rMID);
	aBodyUrl.AppendAscii (".body");

	// Store download.
	if (CntNewsMessage_Impl::storeDownload (rMessage, aBodyUrl, m_pCache))
	{
		// Force message body storage.
		CntMessageBodyItem aBody (WID_MESSAGEBODY, aBodyUrl);
		aBody.Get (m_pCache, m_pMailer, TRUE);

		// Finished.
		return TRUE;
	}
	return FALSE;
}

/*
 * showDownload.
 */
void CntNewsGroupLoadJob_Impl::showDownload (INetCoreMailer &rMailer)
{
	// Setup StatusText.
	String aStatusText (CntResId (
		RID_PROT_TRANSFERING_MESSAGE_I_OF_N));
	aStatusText.SearchAndReplace (
		S2U("$(ARG1)"),
		UniString::CreateFromInt32 (
			(m_nLoadCount + 1) - m_pLoadRanges->TotalCount()));
	aStatusText.SearchAndReplace (
		S2U("$(ARG2)"),
		UniString::CreateFromInt32 (m_nLoadCount));
	aStatusText.SearchAndReplace (
		S2U("$(ARG3)"),
		UniString::CreateFromInt32 (rMailer.NewsGetTransferCount()));

	// Notify caller (ShowStatusText).
	m_nHintId = (USHORT)(~0);
	Broadcast (CntStatusBarHint (aStatusText));
}

/*
 * Notify.
 */
void CntNewsGroupLoadJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (pJob->IsCancelled())
			{
				if (m_eState != STATE_NONE)
				{
					// Abort connection.
					if (m_pMailer)
						m_pMailer->NewsAbortConnection();

					// Force into idle state.
					m_ePrev  = m_eState;
					m_eState = STATE_NONE;
				}
			}

			if (m_pMailer && m_pMessage)
				clearDownload (*m_pMailer, *m_pMessage);

			if (m_nHintId)
			{
				// Notify caller (RemoveStatusText).
				Broadcast (CntStatusBarHint (String()));
				m_nHintId = 0;
			}
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsGroupDeleteJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupDeleteJob_Impl.
 */
CntNewsGroupDeleteJob_Impl::CntNewsGroupDeleteJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsGroupJob_Impl (pJob, pParent),
	  m_pCache             (NULL),
	  m_pKnownRanges       (NULL),
	  m_pDeleteRanges      (NULL),
	  m_nCount             (0),
	  m_nHintId            (0),
	  m_eState             (STATE_NONE)
{
}

/*
 * ~CntNewsGroupDeleteJob_Impl.
 */
CntNewsGroupDeleteJob_Impl::~CntNewsGroupDeleteJob_Impl (void)
{
	delete m_pDeleteRanges;
	delete m_pKnownRanges;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsGroupDeleteJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsGroupDeleteJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntNewsGroupDeleteJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Initialize base.
		if (!initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntNewsGroupDeleteJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain KnownRanges.
		const CntRangesItem &rKnownRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES));

		// Initialize DeleteRanges.
		const CntRangesItem *pReqRanges = PTR_CAST(CntRangesItem, pReq);
		if (pReqRanges)
		{
			// Delete requested ranges only.
			m_pDeleteRanges = rKnownRanges.GetIntersectRanges(*pReqRanges);
		}
		else
		{
			// Delete whole group.
			m_pDeleteRanges = new CntRangesItem (rKnownRanges);
		}

		if (m_pDeleteRanges)
		{
			// Observe MarkRanges.
			const CntRangesItem& rMarkRanges =
				(const CntRangesItem&)(m_pGroup->Get(WID_MARK_RANGES));
			m_pDeleteRanges->SubtractRanges (rMarkRanges);
		}

		// Check remaining DeleteRanges.
		if (!(m_pDeleteRanges && m_pDeleteRanges->TotalCount()))
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Initialize article removal.
		m_pKnownRanges = new CntRangesItem (rKnownRanges);

		// Notify caller (ProgressStart).
		m_nHintId = CntStatusBarHint::CreateHintId();
		Broadcast (CntStatusBarHint (
			m_nHintId, 1, m_pDeleteRanges->TotalCount(),
			String (CntResId (RID_PROT_REMOVING_MESSAGES))));

		// Ensure nonblocking bulk operation.
		m_eState = STATE_ITER;
		m_pGroup->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_ITER)
	{
		// Obtain root URL.
		const String &rRootURL = OWN_URL(GetRootNode());

		// Remove articles from group.
		while (m_pDeleteRanges && m_pDeleteRanges->Count())
		{
			// Obtain article number.
			ULONG nArticleNumber = m_pDeleteRanges->TotalMax();
			m_pDeleteRanges->RemoveRange (nArticleNumber, nArticleNumber);

			String aNumberURL ('M');
			aNumberURL += nArticleNumber;

			// Obtain article's directory itemset.
			CntStoreItemSetRef xDirSet (m_pDirNode->openItemSet (
				aMsgDirRanges_Impl, aNumberURL, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Obtain MessageID.
				const String &rMID = ITEMSET_VALUE_STRING(
					xDirSet, WID_MESSAGE_ID);

				// Setup message URL.
				String aMsgURL (rRootURL);
				CNEWSIMP_CONCAT_URLPATH (aMsgURL, rMID);

				// Check message node.
				CntNodeRef xNode (GetRootNode()->Query (aMsgURL, FALSE));
				if (xNode.Is())
					xNode->Broadcast (
						CntNodeHint (xNode, CNT_ACTION_DELETED, pJob));

				// Remove primary link (via MessageID).
				m_pDirNode->remove (rMID);

				// Remove secondary link (via ArticleNumber).
				m_pDirNode->remove (aNumberURL);

				// Check cache node.
				if (m_pCache)
				{
					// Setup message body URL.
					String aBodyURL (aMsgURL);
					aBodyURL.AppendAscii (".body");

					// Remove message body.
					m_pCache->remove (aBodyURL);
				}
			}

			// Remove from KnownRanges.
			m_pKnownRanges->RemoveRange (nArticleNumber, nArticleNumber);
			m_nCount++;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller (ProgressSet).
				Broadcast (CntStatusBarHint (m_nHintId, m_nCount));

				// Be nice.
				m_pGroup->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Next state.
		m_eState = STATE_DONE;
	}

	// Done.
	pJob->Done();

	// Leave.
	return NULL;
}

/*
 * Notify.
 */
void CntNewsGroupDeleteJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Job finished.
			EndListening (*pJob);
			if (m_nHintId)
			{
				// Notify caller (ProgressEnd).
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}

			if (m_pKnownRanges)
			{
				update (*m_pKnownRanges);
				DELETEZ (m_pKnownRanges);
			}
		}
	}
	CntNewsGroupJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsGroupMarkJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupMarkJob_Impl.
 */
CntNewsGroupMarkJob_Impl::CntNewsGroupMarkJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsGroupJob_Impl (pJob, pParent),
	  m_pActionRanges      (NULL),
	  m_pResultRanges      (NULL),
	  m_eState             (STATE_NONE)
{
}

/*
 * ~CntNewsGroupMarkJob_Impl.
 */
CntNewsGroupMarkJob_Impl::~CntNewsGroupMarkJob_Impl (void)
{
	delete m_pActionRanges;
	delete m_pResultRanges;
}

/*
 * queryAction.
 */
BOOL CntNewsGroupMarkJob_Impl::queryAction (
	const CntBoolItem  &rRequest,
	CntRangesItem     *&rpActionRanges,
	CntRangesItem     *&rpResultRanges)
{
	// Initialize [out] parameters.
	rpActionRanges = NULL;
	rpResultRanges = NULL;

	// Check request.
	USHORT nWhich = 0;
	if (rRequest.Which() == WID_IS_MARKED)
		nWhich = WID_MARK_RANGES;
	if (rRequest.Which() == WID_IS_READ)
		nWhich = WID_READ_RANGES;
	if (nWhich == 0)
		return sal_False;

	// Obtain Ranges and Count.
	const CntRangesItem& rRanges =
		(const CntRangesItem&)(m_pGroup->Get(nWhich));
	ULONG nCount = rRanges.TotalCount();

	// Check whether any action is required.
	if (rRequest.GetValue())
	{
		// Set. Compare KnownRanges and Ranges.
		const CntRangesItem& rKnownRanges =
			(const CntRangesItem&)(m_pGroup->Get(WID_KNOWN_RANGES));
		if (rKnownRanges.Count())
		{
			if (!(rKnownRanges == rRanges))
			{
				// Copy KnownRanges to ResultRanges.
				rpResultRanges = new CntRangesItem (rKnownRanges);
				rpResultRanges->SetWhich (nWhich);
				nCount = rpResultRanges->TotalCount();
			}
		}
		else
		{
			// Empty KnownRanges. Use ServerRanges instead.
			const CntRangesItem& rServerRanges =
				(const CntRangesItem&)(m_pGroup->Get(WID_SERVER_RANGES));
			if (!(rServerRanges == rRanges))
			{
				// Copy ServerRanges to ResultRanges.
				rpResultRanges = new CntRangesItem (rServerRanges);
				rpResultRanges->SetWhich (nWhich);
				nCount = rpResultRanges->TotalCount();
			}
		}
	}
	else
	{
		// Unset. Check article count.
		if (nCount > 0)
		{
			// Create empty ResultRanges.
			rpResultRanges = new CntRangesItem (nWhich);
			nCount = 0;
		}
	}

	// Check result.
	if (rpResultRanges)
	{
		// Create ActionRanges.
		if (nCount > rRanges.TotalCount())
			rpActionRanges = rpResultRanges->GetSubtractRanges (rRanges);
		else
			rpActionRanges = rRanges.GetSubtractRanges (*rpResultRanges);
	}
	return (!!rpResultRanges);
}

/*
 * executeRequest.
 */
BOOL CntNewsGroupMarkJob_Impl::executeRequest (
	const CntBoolItem &rRequest,
	CntRangesItem     &rRanges)
{
	// Initialize.
	String aRootUrl (OWN_URL (GetRootNode()));

	// Iterate.
	ULONG nStartTicks = Time::GetSystemTicks();
	while (rRanges.Count())
	{
		// ...
		ULONG nIndex = rRanges.TotalMin();
		rRanges.RemoveRange (nIndex, nIndex);

		// ...
		String aUrl ('M');
		aUrl += nIndex;

		CntStoreItemSetRef xDirSet (m_pDirNode->openItemSet (
			aMsgDirRanges_Impl, aUrl, STREAM_STD_READ));
		if (xDirSet.Is())
		{
			aUrl = aRootUrl;
			CNEWSIMP_CONCAT_URLPATH(
				aUrl, ITEMSET_VALUE_STRING(xDirSet, WID_MESSAGE_ID));

			CntNodeRef xNode (GetRootNode()->Query (aUrl, FALSE));
			if (xNode.Is())
				xNode->Put (rRequest, rRequest.Which());
		}

		// Check elapsed time.
		ULONG nTicks = Time::GetSystemTicks();
		if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
		{
			// Be nice.
			return sal_True;
		}
	}

	// Done.
	return sal_False;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsGroupMarkJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsGroupMarkJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const CntBoolItem *pReq = PTR_CAST (CntBoolItem, pJob->GetRequest());
	DBG_ASSERT (pReq, "CntNewsGroupMarkJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Initialize base.
		if (!initialize())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Next state.
		if (queryAction (*pReq, m_pActionRanges, m_pResultRanges))
			m_eState = STATE_ITER;
		else
			m_eState = STATE_DONE;

		// Ensure nonblocking bulk operation.
		m_pGroup->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_ITER)
	{
		// Check ActionRanges.
		if (m_pActionRanges)
		{
			// Execute.
			if (executeRequest (*pReq, *m_pActionRanges))
			{
				// Be nice.
				m_pGroup->RescheduleJob (pJob);
				return NULL;
			}

			// Cleanup.
			DELETEZ (m_pActionRanges);
		}

		// Finish.
		m_eState = STATE_DONE;
	}

	if (m_eState == STATE_DONE)
	{
		// Check ResultRanges.
		if (m_pResultRanges)
		{
			// Setup result count.
			CntUInt32Item aResultItem;
			if (pReq->Which() == WID_IS_MARKED)
				aResultItem.SetWhich (WID_MARKED_DOCUMENT_COUNT);
			if (pReq->Which() == WID_IS_READ)
				aResultItem.SetWhich (WID_SEENCONTENTCOUNT);
			aResultItem.SetValue (m_pResultRanges->TotalCount());

			// Update GroupUserData itemset (need not exist).
			CntStoreItemSetRef xUserSet (openUserDataItemSet());
			if (xUserSet.Is())
			{
				xUserSet->Put (*m_pResultRanges);
				xUserSet->Put (aResultItem);
			}

			// Update GroupNode.
			m_pGroup->Put (*m_pResultRanges);
			m_pGroup->Put (aResultItem);

			// Cleanup.
			DELETEZ (m_pResultRanges);
		}

		// Done.
		m_pGroup->Put (*pReq);
		pJob->Done();
	}
	
	// Leave.
	return NULL;
}

/*
 * Notify.
 */
void CntNewsGroupMarkJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNewsGroupJob_Impl::Notify (rBC, rHint);
}

