/*************************************************************************
 *
 *  $RCSfile: cnewsimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CNEWSIMP_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif

#ifndef _INET_WRAPPER_HXX
#include <inet/wrapper.hxx>
#endif

#ifndef _CNTNEWSIMP_HXX
#include "cnewsimp.hxx"
#endif
#ifndef _CNTAPI_HXX
#include "cntapi.hxx"
#endif
#ifndef _CNTINET_HXX
#include "cntinet.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTCMITM_HXX
#include "cntcmitm.hxx"
#endif
#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CNTXREF_HXX
#include "cntxref.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif
#ifndef _CHAOS_MBXFORMT_HXX
#include <mbxformt.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntNewsImp... internals.
 *
 *=====================================================================*/
CNEWSBOX_DIR_RANGES_IMPL (aBoxDirRanges_Impl);
CNEWSBOX_VIEW_RANGES_IMPL (aBoxViewRanges_Impl);

CNEWSGRP_DIR_RANGES_IMPL (aGrpDirRanges_Impl);
CNEWSMSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*=======================================================================
 *
 * CntNewsBoxNode_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxNode_Impl.
 */
CntNewsBoxNode_Impl::CntNewsBoxNode_Impl (
	CntNode *pParent, CntConnMode eConnMode)
	: m_pParent      (pParent),
	  m_eConnMode    (eConnMode),
	  m_bInitialized (FALSE),
	  m_aGroupList   (1024, 256, 256),
	  m_pMailer      (NULL)
{
#ifdef DBG_UTIL_PRIVATE
	String aTrace ("CntNewsBoxNode_Impl::Ctor: ");
	aTrace += (ULONG)m_pParent;
	_TRACE (aTrace);
#endif /* DBG_UTIL_PRIVATE */
}

/*
 * ~CntNewsBoxNode_Impl.
 */
CntNewsBoxNode_Impl::~CntNewsBoxNode_Impl (void)
{
#ifdef DBG_UTIL_PRIVATE
	String aTrace ("CntNewsBoxNode_Impl::Dtor: ");
	aTrace += (ULONG)m_pParent;
	_TRACE (aTrace);
#endif /* DBG_UTIL_PRIVATE */

	if (m_pMailer)
	{
		m_pMailer->NewsAbortConnection();
		delete m_pMailer;
	}

	ULONG n = m_aGroupList.Count();
	for (ULONG i = 0; i < n; i++)
		delete (m_aGroupList.GetObject(i));
	m_aGroupList.Clear();
}

/*
 * Initialize.
 */
BOOL CntNewsBoxNode_Impl::Initialize (CntNodeJob *pJob)
{
	if (!m_bInitialized)
	{
		// Restore Box properties from BoxCache storage.
		CntStorageNode *pCache = pJob->GetCacheNode();

		const SfxPoolItem* pItem = NULL;
		if (pCache->GetItemState (WID_SERVERNAME, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem(WID_SERVERNAME, String()));

		pItem = NULL;
		if (pCache->GetItemState (WID_USERNAME, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem(WID_USERNAME, String()));

		pItem = NULL;
		if (pCache->GetItemState (WID_PASSWORD, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem(WID_PASSWORD, String()));

		m_pParent->Put (pCache->Get(WID_MESSAGE_STOREMODE));
		m_pParent->Put (pCache->Get(WID_STORE_MSGS_HAS_TIMELIMIT));
		m_pParent->Put (pCache->Get(WID_STORE_MSGS_TIMELIMIT));
		m_pParent->Put (pCache->Get(WID_STORE_MARKED));

		// Check for Servername.
		String aServername (ITEMSET_VALUE_STRING (m_pParent, WID_SERVERNAME));
		if (aServername.Len() == 0)
		{
			// Obtain servername from box URL.
			INetURLObject aBoxURL (OWN_URL (m_pParent));
			aServername  = aBoxURL.GetHost();
			USHORT nPort = aBoxURL.GetPort();
			if (nPort)
			{
				aServername += sal_Unicode(':');
				aServername += UniString::CreateFromInt32 (nPort);
			}

			m_pParent->Put (CntStringItem (
				WID_SERVERNAME, aServername));
		}

		// Done.
		m_bInitialized = TRUE;
	}
	return m_bInitialized;
}

/*
 * SetConnMode.
 */
void CntNewsBoxNode_Impl::SetConnMode (CntConnMode eConnMode)
{
	if (m_eConnMode != eConnMode)
	{
		// Accept new connection mode.
		m_eConnMode = eConnMode;

		// Check for 'Session' end.
		if ((m_eConnMode != CNT_CONN_MODE_ONLINE) && (m_pMailer != NULL))
		{
			// Initiate CntNewsCloseJob_Impl execution.
			CntNodeJobRef xJob (new CntNodeJob (
				NULL, m_pParent, m_pParent,
				CntConnModeItem (WID_CONNECTION_MODE, m_eConnMode)));

			CntNewsCloseJob_Impl *pJobImpl =
				new CntNewsCloseJob_Impl (xJob, this);
			xJob->SetRequestData (pJobImpl);

			// Queue job at parent.
			m_pParent->InsertJob (xJob);
		}
	}
}

/*
 * GetMailer.
 */
INetCoreMailer* CntNewsBoxNode_Impl::GetMailer (void)
{
	if (m_pMailer == NULL)
	{
		NAMESPACE_INET(INetWrapper) *pWrapper;
		if (CNT_RNM()->getINetWrapper (pWrapper))
		{
			CntINetConfig::load (pWrapper, CNT_RNM()->GetIniManager());

			pWrapper->newINetCoreMailer (m_pMailer);
			DBG_ASSERT (m_pMailer, "GetMailer: newINetCoreMailer() failed");
		}
	}
	return m_pMailer;
}

/*
 * PutMailer.
 */
void CntNewsBoxNode_Impl::PutMailer (INetCoreMailer *pMailer)
{
	if ((pMailer == m_pMailer) && (m_pMailer != NULL))
	{
		// Disconnect and release Mailer.
		m_pMailer->NewsAbortConnection();
		DELETEZ (m_pMailer);
	}
}

/*
 * GetBoxDirItemSet.
 */
CntStoreItemSet* CntNewsBoxNode_Impl::GetBoxDirItemSet (
	CntStorageNode *pBoxDir) const
{
	CntStoreItemSet *pBoxSet = NULL;
	if (pBoxDir && !pBoxDir->IsDummy())
	{
		UniString aName (S2U ("NEWSBOXDATA"));

		pBoxSet = pBoxDir->openItemSet (
			aBoxDirRanges_Impl, aName,
			STREAM_STD_READWRITE | STREAM_NOCREATE);
		if (pBoxSet == NULL)
		{
			// Create new (hidden) BoxDirItemSet.
			pBoxDir->attrib (
				aName, 0,
				CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN);

			pBoxSet = pBoxDir->openItemSet (
				aBoxDirRanges_Impl, aName, STREAM_STD_READWRITE);
		}
	}
	return pBoxSet;
}

/*
 * GetBoxViewItemSet.
 */
CntStoreItemSet* CntNewsBoxNode_Impl::GetBoxViewItemSet (
	CntStorageNode *pViewData) const
{
	CntStoreItemSet *pViewSet = NULL;
	if (pViewData && !pViewData->IsDummy())
	{
		UniString aName (S2U ("NEWSBOXDATA"));

		pViewSet = pViewData->openItemSet (
			aBoxViewRanges_Impl, aName,
			STREAM_STD_READWRITE | STREAM_NOCREATE);
		if (pViewSet == NULL)
		{
			// Create new (hidden) BoxViewItemSet.
			pViewData->attrib (
				aName, 0,
				CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN);

			pViewSet = pViewData->openItemSet (
				aBoxViewRanges_Impl, aName, STREAM_STD_READWRITE);
		}
	}
	return pViewSet;
}

/*
 * GetBoxClient.
 */
CntInterface* CntNewsBoxNode_Impl::GetBoxClient (CntNodeJob *pJob) const
{
	if (pJob->GetSubject() == m_pParent)
	{
		// Box itself.
		return pJob->GetClient();
	}
	else
	{
		// Group or Message. Find parent.
		CntAnchor *pClient = PTR_CAST (CntAnchor, pJob->GetClient());
		while (pClient)
		{
			CntNode *pNode = pClient->GetNode();
			if (pNode && (pNode->GetMostReferedNode() == m_pParent))
				return pClient;
			else
				pClient = pClient->GetParent();
		}
	}
	return NULL;
}

/*
 * LoadMessageBodyItem.
 */
BOOL CntNewsBoxNode_Impl::LoadMessageBodyItem (
	CntNode *pMessageNode, CntStorageNode *pCacheNode)
{
	if (pMessageNode == NULL) return FALSE;

	const CntMessageBodyItem *pBodyItem = NULL;
	pMessageNode->GetItemState (
		WID_MESSAGEBODY, FALSE, (const SfxPoolItem **)(&pBodyItem));
	if (pBodyItem && pBodyItem->Get()) return TRUE;

	if (pCacheNode == NULL) return FALSE;
	String aBodyURL (OWN_URL (pMessageNode));
	aBodyURL.AppendAscii (".body");

	UINT32 nAttrib = 0;
	pCacheNode->attrib (aBodyURL, 0, 0, nAttrib);
	if (!(nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN)) return FALSE;

	CntMessageBodyItem aBodyItem (WID_MESSAGEBODY, aBodyURL);
	if (aBodyItem.Get (pCacheNode, GetMailer()))
		return (pMessageNode->Put (aBodyItem) != NULL);
	else
		return FALSE;
}

/*=======================================================================
 *
 * CntNewsBox_Impl implementation.
 *
 *=====================================================================*/
/*
 * queryDirectory.
 */
CntStorageNode* CntNewsBox_Impl::queryDirectory (
	const CntStorageNodeRef &rxCache,
	const String            &rDirName,
	BOOL                     bCreate)
{
	CntStorageNode *pDirNode = NULL;
	if (rxCache.Is() && !rxCache->IsDummy() && rDirName.Len())
	{
		String aDirUrl (OWN_URL (rxCache));
		CNEWSIMP_CONCAT_URLPATH (aDirUrl, rDirName);

		pDirNode = (CntStorageNode *)(rxCache->Query (aDirUrl, bCreate));
	}
	return pDirNode;
}

/*=======================================================================
 *
 * CntNewsGroup_Impl implementation.
 *
 *=====================================================================*/
/*
 * queryDownload.
 */
BOOL CntNewsGroup_Impl::queryDownload (const CntStorageNodeRef &rxDirNode)
{
	for (CntNode *pNode = rxDirNode; pNode; pNode = pNode->GetParent())
	{
		const SfxPoolItem *pItem = NULL;
		if (pNode->GetItemState (WID_MESSAGE_STOREMODE, TRUE, &pItem)
			>= SFX_ITEM_SET)
		{
			USHORT eMode = ITEM_VALUE (CntMsgStoreModeItem, *pItem);
			return (eMode == CNT_MESSAGE_STOREMODE_LOCAL);
		}
	}
	return FALSE;
}

/*=======================================================================
 *
 * CntNewsMessage_Impl implementation.
 *
 *=====================================================================*/
/*
 * queryAvailable.
 */
BOOL CntNewsMessage_Impl::queryAvailable (
	const CntNode           &rNode,
	const CntStorageNodeRef &rxCache)
{
	UINT32 nAttrib = 0;
	if (rxCache.Is())
	{
		String aUrl (OWN_URL (&rNode));
		aUrl.AppendAscii (".body");
		rxCache->attrib (aUrl, 0, 0, nAttrib);
	}
	return ((nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN) > 0);
}

/*
 * initDownload.
 */
void CntNewsMessage_Impl::initDownload (
	INetCoreMailer          &rMailer,
	INetCoreNewsMessage    *&rpMessage,
	const CntStorageNodeRef &rxCache)
{
	// Create message container.
	delete rpMessage;
	rpMessage = rMailer.CreateINetCoreNewsMessage();

	// Check cache node.
	if (rxCache.Is())
	{
		// Setup data stream URL.
		String aDataUrl (rxCache->CreateInterimURL());
		rpMessage->SetDocumentFilename (aDataUrl);

		// Create data stream.
		SvStream *pStrm = rxCache->openStream (
			aDataUrl, STREAM_READWRITE | STREAM_TRUNC);
		DBG_ASSERTWARNING(
			pStrm, "CntNewsMessage_Impl::initDownload(): no Stream");
		if (pStrm)
		{
			// Mark data stream hidden.
			rxCache->attrib (aDataUrl, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

			// Set data stream.
			rpMessage->SetDocumentStream (pStrm);
		}
	}
}

/*
 * cleanupDownload.
 */
void CntNewsMessage_Impl::cleanupDownload (
	INetCoreNewsMessage     &rMessage,
	const CntStorageNodeRef &rxCache)
{
	// Cleanup data stream.
	SvStream *pStrm = rMessage.GetDocumentStream();
	rMessage.SetDocumentStream (NULL);
	delete pStrm;

	// Check for data stream removal.
	if (rxCache.Is())
	{
		String aDataUrl (rMessage.GetDocumentFilename());
		if (aDataUrl.Len())
		{
			rMessage.SetDocumentFilename (String());
			rxCache->remove (aDataUrl);
		}
	}
}

/*
 * storeDownload.
 */
BOOL CntNewsMessage_Impl::storeDownload (
	INetCoreNewsMessage     &rMessage,
	const String            &rBodyUrl,
	const CntStorageNodeRef &rxCache)
{
	// Check context.
	if (!rBodyUrl.Len() || !rxCache.Is())
	{
		// Failure. Remove download stream.
		cleanupDownload (rMessage, rxCache);
		return FALSE;
	}

	// Cleanup download (w/o stream removal).
	String aDataUrl (rMessage.GetDocumentFilename());
	rMessage.SetDocumentFilename (String());
	cleanupDownload (rMessage, rxCache);

	// Create body stream.
	SvStream *pStrm = rxCache->openStream (
		rBodyUrl, STREAM_READWRITE | STREAM_TRUNC);
	DBG_ASSERTWARNING(
		pStrm, "CntNewsMessage_Impl::storeDownload(): no Stream");
	if (pStrm == NULL)
	{
		// Failure. Remove download stream.
		rxCache->remove (aDataUrl);
		return FALSE;
	}

	// Write body stream.
	*pStrm << (USHORT)(CNT_MESSAGEBODY_NEWS_DATA);
	pStrm->WriteByteString (aDataUrl, RTL_TEXTENCODING_UTF8);
	*pStrm << rMessage;

	delete pStrm;

	// Mark body stream hidden.
	rxCache->attrib (rBodyUrl, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

	// Done.
	return TRUE;
}

/*
 * updateProperties.
 */
void CntNewsMessage_Impl::updateProperties (
	SfxItemSet                  &rPropSet,
	const INetCoreNewsMessage   &rMessage,
	const CntCrossReferenceItem &rXref,
	const CntStorageNodeRef     &rxCache)
{
	// Check MessageID.
	const String &rMID = rMessage.GetMessageID();
	DBG_ASSERTWARNING(
		rMID.Len(), "CntNewsMessage_Impl::updateProperties(): no MessageID");
	if (rMID.Len() == 0)
		return;

	// Store overview.
	rPropSet.Put (CntNameItem   (WID_FROM, rMessage.GetFrom()));
	rPropSet.Put (CntStringItem (WID_TITLE, rMessage.GetSubject()));
	rPropSet.Put (CntStringItem (WID_MESSAGE_ID, rMID));
	rPropSet.Put (CntStringItem (WID_REFERENCES, rMessage.GetReferences()));
	rPropSet.Put (CntStringItem (WID_NEWSGROUPS, rMessage.GetNewsgroups()));

	// Check Priority.
	if (rMessage.GetXPriority().Len())
	{
		// Store Priority.
		CntPriorityItem aPriority (WID_PRIORITY, rMessage.GetXPriority());
		rPropSet.Put (aPriority);
	}

	// Check Creation date.
	DateTime aDateTime (Date(0), Time(0));
	if (rMessage.ParseDateField (rMessage.GetDate(), aDateTime, aDateTime))
	{
		// Convert message DateTime to local timezone.
		aDateTime.ConvertToLocalTime();

		// Store Creation date.
		rPropSet.Put (SfxDateTimeItem (WID_DATE_CREATED, aDateTime));
	}

	// Check Bytes header.
	if (rMessage.GetBytes().Len())
	{
		// Store DocumentSize.
		ULONG nBytes = (ULONG)(rMessage.GetBytes().ToInt32());
		rPropSet.Put (CntUInt32Item (WID_SIZE, nBytes));
	}

	// Check Xref header.
	const String &rField = rMessage.GetXref();
	if (rField.Len())
	{
		// Create new CrossReference list.
		CntItemListItem aXrefList (WID_NEWS_XREFLIST);

		xub_StrLen i, n = rField.GetTokenCount (' ');
		for (i = 1; i < n; i++)
		{
			CntCrossReferenceItem aItem (WID_NEWS_XREF);
			String aXref (rField.GetToken (i, ' '));

			aItem.SetGroup (aXref.GetToken (0, ':'));
			aItem.SetIndex ((ULONG)(aXref.GetToken (1, ':').ToInt32()));

			if (aItem.GetGroup().Len() && aItem.GetIndex())
				aXrefList.Append (new CntCrossReferenceItem (aItem));
		}
		rPropSet.Put (aXrefList);

		if (rxCache.Is())
		{
			// Update remaining CrossReferences.
			updateCrossReferences (rMID, rXref, aXrefList, rxCache);
		}
	}
	else
	{
		// Update existing CrossReference list.
		const CntItemListItem &rXrefList =
			(const CntItemListItem&)(rPropSet.Get(WID_NEWS_XREFLIST));

		USHORT i = 0, n = rXrefList.Count();
		while ((i < n) && (!(rXref == rXrefList[i]))) i++;
		if (i == n)
		{
			// Append additional CrossReference.
			CntItemListItem aXrefList (rXrefList);
			aXrefList.Append (new CntCrossReferenceItem (rXref));
			rPropSet.Put (aXrefList);
		}
	}

	// Check Newsgroups header.
	String aNewsgroups (rMessage.GetNewsgroups());
	if (!aNewsgroups.Len())
	{
		// Obtain CrossReference list.
		const CntItemListItem &rXrefList =
			(const CntItemListItem&)(rPropSet.Get(WID_NEWS_XREFLIST));

		// Setup Newsgroups header.
		USHORT i = 0, n = rXrefList.Count();
		for (i = 0; i < n; i++)
		{
			// Obtain current cross reference.
			const CntCrossReferenceItem &rItem =
				(const CntCrossReferenceItem&)(rXrefList[i]);

			// Append current group.
			if (aNewsgroups.Len())
				aNewsgroups += sal_Unicode(',');
			aNewsgroups += rItem.GetGroup();
		}

		// Store Newsgroups header.
		rPropSet.Put (CntStringItem (WID_NEWSGROUPS, aNewsgroups));
	}
}

/*
 * updateCrossReferences.
 */
void CntNewsMessage_Impl::updateCrossReferences (
	const String                &rMessageID,
	const CntCrossReferenceItem &rXref,
	const CntItemListItem       &rXrefList,
	const CntStorageNodeRef     &rxCache)
{
	// Check context.
	DBG_ASSERT(
		rXrefList.Which() == WID_NEWS_XREFLIST,
		"CntNewsMessage_Impl::updateCrossReferences(): no XrefList");
	if (!(rXrefList.Which() == WID_NEWS_XREFLIST))
		return;
	if (!rxCache.Is())
		return;

	// Update CrossReference list.
	USHORT i = 0, n = rXrefList.Count();
	for (i = 0; i < n; i++)
	{
		// Obtain current cross reference.
		const CntCrossReferenceItem &rItem =
			(const CntCrossReferenceItem&)(rXrefList[i]);
		if (!(rItem.GetGroup() == rXref.GetGroup()))
		{
			// Find GroupDirectory StorageNode.
			CntStorageNodeRef xDirNode (
				CntNewsBox_Impl::queryDirectory (rxCache, rItem.GetGroup()));
			if (xDirNode.Is())
			{
				// Update message itemset.
				CntStoreItemSetRef xDirSet (xDirNode->openItemSet (
					aMsgDirRanges_Impl, rMessageID, STREAM_STD_READWRITE));
				if (xDirSet.Is())
					xDirSet->Put (rXrefList);
			}
		}
	}
}

/*=======================================================================
 *
 * CntNewsJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsJob_Impl.
 */
CntNewsJob_Impl::CntNewsJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: SfxListener (),
	  m_xJob      (pJob),
	  m_pParent   (pParent)
{
	if (m_xJob.Is())
	{
		AddRef();
		m_xJob->SetRequestData (this);
		StartListening (*m_xJob);
	}
}

/*
 * ~CntNewsJob_Impl.
 */
CntNewsJob_Impl::~CntNewsJob_Impl (void)
{
	if (m_xJob.Is())
	{
		EndListening (*m_xJob);
		m_xJob->SetRequestData (NULL);
		m_xJob.Clear();
	}
}

/*
 * Broadcast.
 */
void CntNewsJob_Impl::Broadcast (const SfxHint &rHint)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Broadcast (rHint);
	}
}

/*
 * Result.
 */
void CntNewsJob_Impl::Result (CntNode *pResult, CntAction eAction)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Result (pResult, eAction);

		const SfxPoolItem *pReq = pJob->GetRequest();
		if (pReq && (pReq->Which() == WID_SEARCH))
			pJob->ResultSearchMatch (pResult);
	}
}

/*
 * ExecuteCallback.
 */
sal_Bool CntNewsJob_Impl::ExecuteCallback (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData)
{
	// Check context.
	CntNewsJob_Impl *pThis = (CntNewsJob_Impl *)pData;
	DBG_ASSERT(
		pThis, "CntNewsJob_Impl::ExecuteCallback(): no pThis");
	if (pThis == NULL)
		return sal_False;

	// Handle callback reason.
	pThis->AddRef();
	pThis->ExecuteHandler (pMailer, nReplyCode, pReplyText);
	pThis->ReleaseRef();

	// Wait for next callback.
	return sal_True;
}

/*
 * ExecuteHandler (noop).
 */
void CntNewsJob_Impl::ExecuteHandler (
	INetCoreMailer*, sal_Int32, const sal_Char*)
{
}

/*
 * Notify.
 */
void CntNewsJob_Impl::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xJob))
	{
		if (m_xJob->IsCancelled() || m_xJob->IsDone())
		{
			// Our job is finished here.
			EndListening (*m_xJob);
			ReleaseRef();
		}
	}
}

/*=======================================================================
 *
 * CntNewsOpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsOpenJob_Impl.
 */
CntNewsOpenJob_Impl::CntNewsOpenJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pMailer       (NULL),
	  m_pfnCB         (NULL),
	  m_pDataCB       (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * CntNewsOpenJob_Impl.
 */
CntNewsOpenJob_Impl::~CntNewsOpenJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsOpenJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsOpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain mailer. Determine next state.
		m_pMailer = GetParent()->GetMailer();
		if (m_pMailer->NewsIsOpen())
			m_eState = STATE_DONE;
		else
			m_eState = STATE_CLOSED;

		// Jump into state machine.
		ExecuteHandler (m_pMailer, SERVICE_READY, NULL);
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsOpenJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsOpenJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT(
		pReq, "CntNewsOpenJob_Impl::ExecuteHandler(): no Request");
	if (pReq == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_CLOSED:
				if (nReplyCode/100 == 2)
				{
					// Connection closed. Obtain Servername.
					String aHost;
					USHORT nPort;

					String aEndpoint (ITEMSET_VALUE_STRING(
						GetRootNode(), WID_SERVERNAME));
					CntMBXFormat::decomposeDomainAndPort (
						aEndpoint, aHost, nPort);

					// Notify caller (ShowStatusText).
					String aStatusText (CntResId (
						RID_PROT_CONNECTING_TO_SERVER));
					aStatusText.SearchAndReplace (S2U ("$(ARG1)"), aEndpoint);

					Broadcast (CntStatusBarHint (aStatusText));

					// Establish new connection.
					m_eState = STATE_OPEN;
					if (!m_pMailer->NewsOpenConnection (
						aHost, nPort, CntNewsJob_Impl::ExecuteCallback, this))
					{
						// Failure. Remove StatusText.
						Broadcast (CntStatusBarHint (String()));

						// Notify caller.
						ErrCode eErrCode = *(new TwoStringErrorInfo (
							ERRCODE_CHAOS_SERVER_CONNECT_FAILURE,
							S2U ("NNTP"), aEndpoint));
						if (!pJob->SetError (eErrCode))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_OPEN:
				if (nReplyCode/100 == 2)
				{
					// Connection established. Remove StatusText.
					Broadcast (CntStatusBarHint (String()));

					// Next state.
					m_eState = STATE_MODE;

					if (!m_pMailer->NewsModeReader (
						CntNewsJob_Impl::ExecuteCallback, this))
					{
						// Notify caller.
						if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure. Remove StatusText.
					Broadcast (CntStatusBarHint (String()));

					ErrCode eErrCode = ERRCODE_CHAOS_CONNECT_FAILURE;
					if (pReplyText)
					{
						// Setup ErrorInfo. @@@ ASCII @@@
						eErrCode = *(new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, S2U(pReplyText)));
					}
					else
					{
						// Setup ErrorInfo.
						String aEndpoint (ITEMSET_VALUE_STRING(
							GetRootNode(), WID_SERVERNAME));

						eErrCode = *(new TwoStringErrorInfo (
							ERRCODE_CHAOS_SERVER_CONNECT_FAILURE,
							S2U ("NNTP"), aEndpoint));
					}

					// Notify caller.
					if (!pJob->SetError (eErrCode))
					{
						// Try again.
						m_eState = STATE_NONE;
						GetRootNode()->RescheduleJob (pJob);
					}

					// Wait for next callback.
					return;
				}
				break;

			case STATE_MODE:
				if ((nReplyCode == PERMISSION_DENIED) ||
					(nReplyCode == AUTHINFO_REQUIRED)    )
				{
					// Request authentication.
					nReplyCode = AUTHINFO_REQUIRED;

					// Next state.
					m_eState = STATE_AUTH;
				}
				else
				{
					// Report success.
					nReplyCode = SERVICE_READY;

					// Next state.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_AUTH:
				if (nReplyCode/100 == 2)
				{
					// Resume previous state.
					m_eState = STATE_OPEN;

					// Try again...
				}
				else if (nReplyCode == AUTHINFO_REQUIRED)
				{
					// Setup AuthJob.
					CntNodeJobRef xSubJob (new CntNodeJob (
						pJob, pJob->GetClient(), pJob->GetSubject(), *pReq));

					CntNewsAuthJob_Impl *pJobImpl =
						new CntNewsAuthJob_Impl (xSubJob, GetParent());
					pJobImpl->SetReplyText (pReplyText);
					pJobImpl->SetCallback (
						CntNewsJob_Impl::ExecuteCallback, this);

					// Start AuthJob.
					GetRootNode()->RescheduleJob (xSubJob);
					return;
				}
				else if (nReplyCode == PERMISSION_DENIED)
				{
					// Previous authentication failed.
					CntNodeRef xRoot (GetRootNode());
					CNT_RNM()->RemoveLoginInfo (OWN_URL (xRoot));

					xRoot->Put (CntStringItem (WID_USERNAME, String()));
					xRoot->Put (CntStringItem (WID_PASSWORD, String()));
					xRoot->Put (CntStringItem (WID_ACCOUNT, String()));

					// Authenticate.
					nReplyCode = AUTHINFO_REQUIRED;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (m_pfnCB)
				{
					// Notify caller.
					INetCoreMailerCallback *pfnCallback = m_pfnCB;
					m_pfnCB = NULL;

					(pfnCallback)(pMailer, nReplyCode, pReplyText, m_pDataCB);
				}

				if ((nReplyCode/100 != 2) && (m_pMailer != NULL))
				{
					// Open job failed. Close connection.
					m_pMailer->NewsAbortConnection();
				}

				// Done.
				m_eState = STATE_NONE;
				pJob->Done();
				break;

			default: // STATE_NONE
				return;
		}
	}
}

/*
 * Notify.
 */
void CntNewsOpenJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled())
		{
			// Open job cancelled. Close connection.
			if (m_pMailer)
				m_pMailer->NewsAbortConnection();

			// Notify caller.
			INetCoreMailerCallback *pfnCallback = m_pfnCB;
			m_pfnCB = NULL;

			if (pfnCallback) (pfnCallback) (
				m_pMailer, INETCORENNTP_REPLY_CONNECT_ERROR, NULL, m_pDataCB);
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsAuthJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsAuthJob_Impl.
 */
CntNewsAuthJob_Impl::CntNewsAuthJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pMailer       (NULL),
	  m_pfnCB         (NULL),
	  m_pDataCB       (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntNewsAuthJob_Impl.
 */
CntNewsAuthJob_Impl::~CntNewsAuthJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsAuthJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsAuthJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();

		// Jump into state machine.
		ExecuteHandler (
			m_pMailer, AUTHINFO_REQUIRED, m_aReplyText.GetBuffer());
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsAuthJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntNewsAuthJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Authenticate.
	while (1)
	{
		if (nReplyCode == AUTHINFO_REQUIRED)
		{
			// Obtain Username and Password.
			CntNodeRef xRoot (GetRootNode());

			String aUsername (ITEMSET_VALUE_STRING (xRoot, WID_USERNAME));
			String aPassword (ITEMSET_VALUE_STRING (xRoot, WID_PASSWORD));

			// Authenticate.
			if (!pMailer->NewsAuthenticate (
				aUsername, aPassword, CntNewsJob_Impl::ExecuteCallback, this))
			{
				// Failure. Notify caller.
				UniString aReplyText (S2U (pReplyText)); // @@@ ASCII @@@
				if (!pJob->SetError (
					ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE, &aReplyText, xRoot))
				{
					// Try again.
					m_eState = STATE_NONE; // @@@ STATE_USER @@@
					xRoot->RescheduleJob (pJob);
				}
			}

			// Wait for next callback.
			return;
		}
		else if (nReplyCode == MORE_AUTHINFO_REQUIRED)
		{
			// More Authinfo required (missing password).
			CntNodeRef xRoot (GetRootNode());
			UniString  aReplyText (S2U (pReplyText)); // @@@ ASCII @@@
			if (!pJob->SetError (
				ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE, &aReplyText, xRoot))
			{
				// Obtain Password.
				String aPassword (ITEMSET_VALUE_STRING (xRoot, WID_PASSWORD));

				// Authenticate.
				if (!pMailer->NewsAuthenticatePassword (
					aPassword, CntNewsJob_Impl::ExecuteCallback, this))
				{
					// Try again.
					m_eState = STATE_NONE; // @@@ STATE_PASS @@@
					GetRootNode()->RescheduleJob (pJob);
				}
			}

			// Wait for next callback.
			return;
		}
		else
		{
			// Authinfo accepted or rejected. Notify caller.
			INetCoreMailerCallback *pfnCallback = m_pfnCB;
			m_pfnCB = NULL;

			if (pfnCallback) (pfnCallback) (
				pMailer, nReplyCode, pReplyText, m_pDataCB);

			// Done.
			pJob->Done();
			return;
		}
	}
}

/*
 * Notify.
 */
void CntNewsAuthJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (pJob->IsCancelled())
			{
				// Notify caller.
				INetCoreMailerCallback *pfnCallback = m_pfnCB;
				m_pfnCB = NULL;

				if (pfnCallback) (pfnCallback) (
					m_pMailer, AUTHINFO_REJECTED, NULL, m_pDataCB);
			}
			m_eState = STATE_DONE;
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsCloseJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsCloseJob_Impl.
 */
CntNewsCloseJob_Impl::CntNewsCloseJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pMailer       (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntNewsCloseJob_Impl.
 */
CntNewsCloseJob_Impl::~CntNewsCloseJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsCloseJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsCloseJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Check mailer.
		if (!GetParent()->HasMailer())
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Close connection gracefully.
		m_eState = STATE_CLOSE;

		m_pMailer = GetParent()->GetMailer();
		if (m_pMailer->NewsCloseConnection (
			CntNewsJob_Impl::ExecuteCallback, this))
		{
			// Wait for next callback.
			return NULL;
		}
		else
		{
			// Failure. Abort connection.
			m_eState = STATE_DONE;
		}
	}

	if (m_eState == STATE_DONE)
	{
		// Release mailer and finish.
		GetParent()->PutMailer (m_pMailer);
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntNewsCloseJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	if (m_eState == STATE_CLOSE)
	{
		// Connection closed.
		m_eState = STATE_DONE;

		// Finish asynchronously.
		GetRootNode()->RescheduleJob (GetJob());
	}
}

/*
 * Notify.
 */
void CntNewsCloseJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsLoadListJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsLoadListJob_Impl.
 */
CntNewsLoadListJob_Impl::CntNewsLoadListJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pCache        (NULL),
	  m_pIter         (NULL),
	  m_pStrm         (NULL),
	  m_eState        (STATE_NONE),
	  m_nHintId       (0)
{
}

/*
 * ~CntNewsLoadListJob_Impl.
 */
CntNewsLoadListJob_Impl::~CntNewsLoadListJob_Impl (void)
{
	delete m_pIter;
	delete m_pStrm;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsLoadListJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsLoadListJob_Impl::Execute(): no pJob");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntNewsLoadListJob_Impl::Execute(): no pCache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Open GroupList stream.
		UniString aName (S2U ("NEWSBOXLIST"));
		m_pStrm = m_pCache->openStream (
			aName, STREAM_READ | STREAM_NOCREATE);
		if (m_pStrm)
		{
			// Determine stream size.
			ULONG nSize = m_pStrm->Seek (STREAM_SEEK_TO_END);
			if (nSize == 0)
			{
				// Nothing to do.
				pJob->Done();
				return NULL;
			}

			// Setup Progress.
			m_nHintId = CntStatusBarHint::CreateHintId();
			Broadcast (CntStatusBarHint (
				m_nHintId, 1, nSize,
				String (CntResId (RID_NEWS_LOADING_NEWSGROUPS))));

			// Initialize GroupList load.
			m_pStrm->Seek (STREAM_SEEK_TO_BEGIN);
			m_eState = STATE_LOAD;
		}
		else
		{
			// Backward compatibel. Convert to GroupList stream.
			m_pStrm = m_pCache->openStream (
				aName, STREAM_READWRITE | STREAM_TRUNC);
			DBG_ASSERT(
				m_pStrm, "CntNewsLoadListJob_Impl::Execute(): no Stream");
			if (m_pStrm == NULL)
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}
			m_pCache->attrib (aName, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

			// Initialize DirList iteration.
			m_pIter  = new CntStorageIterator (
				CNTSTORE_ATTRIB_ISDIR, 0);
			m_eState = STATE_DIRLIST;
		}
	}

	// Load GroupList from stream.
	if (m_eState == STATE_LOAD)
	{
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		while (!m_pStrm->IsEof())
		{
			// Load entry.
			CntNewsGroupListEntry *pEntry = new CntNewsGroupListEntry;
			*m_pStrm >> *pEntry;

			if (!m_pStrm->IsEof() && pEntry->m_aGroupName.getLength())
				rList.Insert (pEntry, LIST_APPEND);
			else
				delete pEntry;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller (ProgressSet).
				ULONG nDone = m_pStrm->Tell();
				Broadcast (CntStatusBarHint (m_nHintId, nDone));

				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}
		}

		// Notify caller.
		ULONG nDone = m_pStrm->Tell();
		Broadcast (CntStatusBarHint (m_nHintId, nDone));

		// Cleanup and finish.
		DELETEZ (m_pStrm);
		m_eState = STATE_DONE;
	}

	// Process DirectoryNode list.
	if (m_eState == STATE_DIRLIST)
	{
		// Obtain GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		String aCacheURL (OWN_URL (m_pCache));

		// Iterate.
		m_pCache->iter (*m_pIter);
		while (!m_pIter->eof())
		{
			// Initialize a GroupList entry.
			CntNewsGroupListEntry *pEntry = new CntNewsGroupListEntry;
			pEntry->initialize();
			rList.Insert (pEntry, LIST_APPEND);

			pEntry->m_aGroupName = (**m_pIter).m_pszName;
			pEntry->m_nFlags     = (**m_pIter).m_nAttrib;

			// Obtain group itemset.
			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aGrpDirRanges_Impl, pEntry->m_aGroupName, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Obtain directory node.
				String aGroupURL (aCacheURL);
				CNEWSIMP_CONCAT_URLPATH (aGroupURL, pEntry->m_aGroupName);

				CntNodeRef xDirNode (m_pCache->Query (aGroupURL));
				if (xDirNode.Is())
				{
					// Move properties.
					xDirNode->Put (xDirSet->Get (WID_TOTALCONTENTCOUNT));
					xDirNode->Put (xDirSet->Get (WID_SERVER_RANGES));
					xDirNode->Put (xDirSet->Get (WID_KNOWN_RANGES));

					// Release directory node.
					xDirNode.Clear();
				}

				// Setup GroupList entry.
				const CntRangesItem& rRanges =
					(const CntRangesItem&)(xDirSet->Get(WID_SERVER_RANGES));

				pEntry->m_nFirstArticleNumber = rRanges.TotalMin();
				pEntry->m_nLastArticleNumber  = rRanges.TotalMax();

				pEntry->m_nArticleCount = ITEMSET_VALUE(
					xDirSet, CntUInt32Item, WID_TOTALCONTENTCOUNT);

				// Release itemset.
				xDirSet.Clear();
			}

			// Save GroupList entry.
			*m_pStrm << *pEntry;

			// Cleanup obsolete itemset.
			m_pCache->remove (pEntry->m_aGroupName);

			// Next.
			m_pCache->iter (*m_pIter);
		}

		// Cleanup and initialize GroupList iteration.
		delete m_pIter;
		m_pIter = new CntStorageIterator (
			0, CNTDIRENTRY_ATTRIB_HIDDEN | CNTSTORE_ATTRIB_ISDIR);
		m_eState = STATE_GROUPLIST;
	}

	// Process GroupList.
	if (m_eState == STATE_GROUPLIST)
	{
		// Obtain GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();

		// Iterate.
		m_pCache->iter (*m_pIter);
		while (!m_pIter->eof())
		{
			// Obtain group itemset.
			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aGrpDirRanges_Impl, (**m_pIter).m_pszName, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Initialize a GroupList entry.
				CntNewsGroupListEntry *pEntry = new CntNewsGroupListEntry;
				pEntry->initialize();
				rList.Insert (pEntry, LIST_APPEND);

				pEntry->m_aGroupName = (**m_pIter).m_pszName;
				pEntry->m_nFlags     = (**m_pIter).m_nAttrib;

				// Setup GroupListEntry.
				const CntRangesItem& rRanges =
					(const CntRangesItem&)(xDirSet->Get(WID_SERVER_RANGES));

				pEntry->m_nFirstArticleNumber = rRanges.TotalMin();
				pEntry->m_nLastArticleNumber  = rRanges.TotalMax();

				pEntry->m_nArticleCount = ITEMSET_VALUE_UINT32(
					xDirSet, WID_TOTALCONTENTCOUNT);

				// Save GroupList entry.
				*m_pStrm << *pEntry;

				// Release itemset.
				xDirSet.Clear();
			}

			// Cleanup obsolete itemset.
			m_pCache->remove ((**m_pIter).m_pszName);

			// Next.
			m_pCache->iter (*m_pIter);
		}

		// Cleanup and finish.
		DELETEZ (m_pIter);
		m_eState = STATE_DONE;
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntNewsLoadListJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (pJob->IsCancelled())
			{
				// Cleanup.
				CntNewsGroupList &rList = GetParent()->GetGroupList();
				for (ULONG i = 0; i < rList.Count(); i++)
					delete rList.GetObject(i);
				rList.Clear();
			}
			if (m_nHintId)
			{
				// ProgressEnd.
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsSaveListJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntNewsSaveListJob_Impl.
 */
CntNewsSaveListJob_Impl::CntNewsSaveListJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl (pJob, pParent),
	  m_pStrm         (NULL),
	  m_nDone         (0),
	  m_nHintId       (0)
{
}

/*
 * ~CntNewsSaveListJob_Impl.
 */
CntNewsSaveListJob_Impl::~CntNewsSaveListJob_Impl (void)
{
	delete m_pStrm;
}

/*
 * Execute.
 */
const SfxPoolItem* CntNewsSaveListJob_Impl::Execute (void)
{
	// Ensure clean destruction.
	CntNewsJob_ImplRef xThis (this);

	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntNewsSaveListJob_Impl::Execute(): no pJob");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_nHintId == 0)
	{
		// Check GroupList.
		CntNewsGroupList &rList = GetParent()->GetGroupList();
		if (rList.Count() == 0)
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Check cache node.
		CntStorageNode *pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			pCache, "CntNewsSaveListJob_Impl::Execute(): no Cache");
		if (pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Open GroupList stream.
		m_pStrm = pCache->openStream (
			S2U("NEWSBOXLIST"), STREAM_READWRITE | STREAM_TRUNC);
		DBG_ASSERT(
			m_pStrm, "CntNewsSaveListJob_Impl::Execute(): no Stream");
		if (m_pStrm == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Setup Progress.
		m_nHintId = CntStatusBarHint::CreateHintId();

#ifdef RID_NEWS_STORING_NEWSGROUPS
		Broadcast (CntStatusBarHint (
			m_nHintId, 1, rList.Count(),
			String (CntResId (RID_NEWS_STORING_NEWSGROUPS))));
#else
		Broadcast (CntStatusBarHint (
			m_nHintId, 1, rList.Count(),
			String (CntResId (RID_NEWS_LOADING_NEWSGROUPS))));
#endif

		// Initialize GroupList iteration.
		m_nDone = 0;
	}

	// Save GroupList.
	CntNewsGroupList &rList = GetParent()->GetGroupList();
	while (m_nDone < rList.Count())
	{
		// Save current entry.
		CntNewsGroupListEntry *pEntry = rList.GetObject (m_nDone++);
		if (pEntry->m_aGroupName.getLength())
			*m_pStrm << *pEntry;

		// Check elapsed time.
		if ((m_nDone % 100) == 0)
		{
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CNTNEWSJOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller.
				Broadcast (CntStatusBarHint (m_nHintId, m_nDone));

				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
			}
		}
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntNewsSaveListJob_Impl::Notify (
	SfxBroadcaster &rBC, const SfxHint &rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);
			if (m_nHintId)
			{
				// ProgressEnd.
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}
		}
	}
	CntNewsJob_Impl::Notify (rBC, rHint);
}

