/*************************************************************************
 *
 *  $RCSfile: cnewsimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTNEWSIMP_HXX
#define _CNTNEWSIMP_HXX "$Revision: 1.1.1.1 $"

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif

#ifndef _INETCOREMAIL_HXX
#include <inet/inetmail.hxx>
#endif

#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif
#ifndef _CNTMMITM_HXX
#include "cntmmitm.hxx"
#endif
#ifndef _CNTRANGE_HXX
#include "cntrange.hxx"
#endif
#ifndef _CNTXREF_HXX
#include "cntxref.hxx"
#endif

class CntBoolItem;
class CntNewsBoxMessageCachingPolicy;

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntItemListItem;
class CntMessageBodyItem;
class CntExport;
class CntFolderList;
class CntImport;
class CntMBXAtomTable;
class CntMBXBodyScanner;
class CntMBXToken;

SV_DECL_IMPL_REF(CntStorageNode);

/*=======================================================================
 *
 * Debug trace environment.
 *
 *=====================================================================*/
#ifdef DBG_UTIL_PRIVATE
#include <stdio.h>

#if (defined(WIN) || defined(WNT) || defined(OS2))
#define _TRACELOGNAME "c:\\cntnews.log"
#elif (defined(UNX))
#define _TRACELOGNAME "/tmp/cntnews.log"
#else
#define _TRACELOGNAME "cntnews.log"
#endif

#ifdef WIN
#define _TRACELOGFORMAT "%ls\n"
#else
#define _TRACELOGFORMAT "%s\n"
#endif /* WIN */

#define _TRACE(a) \
{ \
	FILE *fp = fopen (_TRACELOGNAME, "a+"); \
	if (fp) \
	{ \
		fprintf (fp, _TRACELOGFORMAT, (const char *)((a))); \
		fclose (fp); \
	} \
}

#else
#define _TRACE(a)
#endif /* DBG_UTIL_PRIVATE */

/*=======================================================================
 *
 * class CntNews... common internals.
 *
 *=====================================================================*/
#ifndef CNTDIRENTRY_ATTRIB_SUBSCRIBED /* ViewNode */
#define CNTDIRENTRY_ATTRIB_SUBSCRIBED CNTDIRENTRY_ATTRIB_USER1
#endif

#ifndef CNTDIRENTRY_ATTRIB_NEW /* CacheNode */
#define CNTDIRENTRY_ATTRIB_NEW CNTDIRENTRY_ATTRIB_USER1
#endif

#ifndef CNTDIRENTRY_ATTRIB_REMOVED /* CacheNode */
#define CNTDIRENTRY_ATTRIB_REMOVED CNTDIRENTRY_ATTRIB_MARKEDFORDELETE
#endif

#define CNTNEWSJOB_RESCHEDULE_TIMELIMIT 250 /* 250 msec */

#define CNEWSIMP_CONCAT_URLPATH(base,path) \
    if ((base).GetChar((base).Len() - 1) != '/') \
		(base).Append(sal_Unicode('/')); \
    (base).Append(UniString((path)));

#define CNEWSIMP_TRIM_URLPATH(path) \
    ((path).EraseLeadingAndTrailingChars(sal_Unicode('/')))

#define CNEWSIMP_GROUP_ATTRIB \
    (CNTDIRENTRY_ATTRIB_NEW | CNTDIRENTRY_ATTRIB_REMOVED)

#define AUTHINFO_ACCEPTED      (INETCORENNTP_REPLY_AUTHINFO_ACCEPTED)
#define AUTHINFO_REQUIRED      (INETCORENNTP_REPLY_AUTHINFO_REQUIRED)
#define MORE_AUTHINFO_REQUIRED (INETCORENNTP_REPLY_MORE_AUTHINFO_REQUIRED)
#define AUTHINFO_REJECTED      (INETCORENNTP_REPLY_AUTHINFO_REJECTED)

#define SERVICE_READY          (INETCORENNTP_REPLY_SERVICE_READY)
#define SERVIVE_DISCONTINUED   (INETCORENNTP_REPLY_SERVICE_DISCONTINUED)

#define NO_SUCH_GROUP          (INETCORENNTP_REPLY_NO_SUCH_GROUP)
#define NO_SUCH_ARTICLE_NUMBER (INETCORENNTP_REPLY_NO_SUCH_ARTICLE_NUMBER)
#define NO_SUCH_ARTICLE        (INETCORENNTP_REPLY_NO_SUCH_ARTICLE)

#define PERMISSION_DENIED      (INETCORENNTP_REPLY_PERMISSION_DENIED)

#define TRANSFER_OVERVIEW      (INETCORENNTP_REPLY_TRANSFER_OVERVIEW)
#define TRANSFER_WAIT          (INETCORENNTP_REPLY_TRANSFER_WAIT)

#ifndef COPYCTOR_API
#define COPYCTOR_API(C) C (const C&); C& operator= (const C&)
#endif

#ifndef ITEMSET_VALUE_BOOL
#define ITEMSET_VALUE_BOOL(a, b) ITEMSET_VALUE((a), CntBoolItem, (b))
#endif

#ifndef ITEMSET_VALUE_STRING
#define ITEMSET_VALUE_STRING(a, b) ITEMSET_VALUE((a), CntStringItem, (b))
#endif

#ifndef ITEMSET_VALUE_UINT16
#define ITEMSET_VALUE_UINT16(a, b) ITEMSET_VALUE((a), CntUInt16Item, (b))
#endif

#ifndef ITEMSET_VALUE_UINT32
#define ITEMSET_VALUE_UINT32(a, b) ITEMSET_VALUE((a), CntUInt32Item, (b))
#endif

inline UniString S2U (const sal_Char *pszAscii)
{
	return UniString::CreateFromAscii (pszAscii);
}

/*
 * CntNewsBoxNode: CntStoreItemSet Ranges.
 */
#define CNEWSBOX_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_TOTALCONTENTCOUNT, WID_TOTALCONTENTCOUNT, \
	WID_LAST_UPDATE,       WID_LAST_UPDATE, \
	0 \
};

#define CNEWSBOX_VIEW_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_SUBSCRNEWSGROUPCOUNT, WID_SUBSCRNEWSGROUPCOUNT, \
	0 \
};

/*
 * CntNewsGroupNode: CntStoreItemSet Ranges.
 */
#define CNEWSGRP_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_TOTALCONTENTCOUNT, WID_TOTALCONTENTCOUNT, \
	WID_KNOWN_RANGES,      WID_KNOWN_RANGES, \
	WID_SERVER_RANGES,     WID_SERVER_RANGES, \
	0 \
};

#define CNEWSGRP_USER_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_SEENCONTENTCOUNT,      WID_MARK_RANGES, \
	WID_MARKED_DOCUMENT_COUNT, WID_MARKED_DOCUMENT_COUNT, \
	0 \
};

/*
 * CntMessageNode: CntStoreItemSet Ranges.
 */
#define CNEWSMSG_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_PRIORITY,      WID_PRIORITY, \
	WID_MESSAGE_ID,    WID_MESSAGE_ID, \
	WID_FROM,          WID_TITLE, \
	WID_REFERENCES,    WID_REFERENCES, \
	WID_NEWSGROUPS,    WID_NEWS_XREFLIST, \
	WID_DATE_CREATED,  WID_DATE_CREATED, \
	WID_SIZE,          WID_SIZE, \
	WID_ACTION_LIST,   WID_ACTION_LIST, \
	0 \
};

/*
 * CntNewsGroupListEntry.
 */
struct CntNewsGroupListEntry : public INetCoreNNTPGroupListEntry
{
	void initialize (void)
	{
		m_aGroupName = NAMESPACE_RTL(OUString)();
		m_nArticleCount = 0;
		m_nFirstArticleNumber = 0;
		m_nLastArticleNumber = 0;
		m_nFlags = 0;
	}

	friend SvStream& operator<< (
		SvStream &rStrm, const CntNewsGroupListEntry &rThis)
	{
		rStrm.WriteByteString (rThis.m_aGroupName, RTL_TEXTENCODING_UTF8);
		rStrm << rThis.m_nArticleCount;
		rStrm << rThis.m_nFirstArticleNumber;
		rStrm << rThis.m_nLastArticleNumber;
		rStrm << rThis.m_nFlags;
		return rStrm;
	}

	friend SvStream& operator>> (
		SvStream &rStrm, CntNewsGroupListEntry &rThis)
	{
		rThis.initialize();

		UniString aGroupName;
		rStrm.ReadByteString (aGroupName, RTL_TEXTENCODING_UTF8);
		rThis.m_aGroupName = NAMESPACE_RTL(OUString)(aGroupName);

		rStrm >> rThis.m_nArticleCount;
		rStrm >> rThis.m_nFirstArticleNumber;
		rStrm >> rThis.m_nLastArticleNumber;
		rStrm >> rThis.m_nFlags;
		return rStrm;
	}
};

/*
 * CntNewsGroupList.
 */
class CntNewsGroupList : public List
{
public:
	CntNewsGroupList (
		USHORT _nBlockSize, USHORT _nInitSize, USHORT _nResize)
		: List (_nBlockSize, _nInitSize, _nResize) {}

	void Insert (CntNewsGroupListEntry *p, ULONG nIndex)
	{
		List::Insert (p, nIndex);
	}

	CntNewsGroupListEntry* Remove (void)
	{
		return (CntNewsGroupListEntry *)List::Remove();
	}

	CntNewsGroupListEntry* Remove (ULONG nIndex)
	{
		return (CntNewsGroupListEntry *)List::Remove(nIndex);
	}

	CntNewsGroupListEntry* GetObject (ULONG nIndex)
	{
		return (CntNewsGroupListEntry *)List::GetObject(nIndex);
	}
};

/*=======================================================================
 *
 * CntNewsBoxNode_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxNode_Impl
{
	/** Representation.
	*/
	CntNode                        *m_pParent;
	CntConnMode                     m_eConnMode;
	BOOL                            m_bInitialized;

	CntNewsGroupList                m_aGroupList;
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxNode_Impl);

public:
	CntNewsBoxNode_Impl (
		CntNode     *pParent,
		CntConnMode  eConnMode = CNT_CONN_MODE_ONLINE);
	~CntNewsBoxNode_Impl (void);

	CntNode* GetParent (void) const { return m_pParent; }

	BOOL IsInitialized (void) const { return m_bInitialized; }
	BOOL Initialize (CntNodeJob *pJob);

	CntConnMode GetConnMode (void) const { return m_eConnMode; }
	void        SetConnMode (CntConnMode eConnMode);

	NAMESPACE_INET(INetCoreMailer)* GetMailer (void);
	void PutMailer (NAMESPACE_INET(INetCoreMailer) *pMailer);
	BOOL HasMailer (void) const { return (!!m_pMailer); }

	CntNewsGroupList& GetGroupList (void) { return m_aGroupList; }

	CntStoreItemSet*  GetBoxDirItemSet  (CntStorageNode *pBoxDir) const;
	CntStoreItemSet*  GetBoxViewItemSet (CntStorageNode *pViewData) const;

	CntInterface*     GetBoxClient (CntNodeJob *pJob) const;

	BOOL LoadMessageBodyItem (
		CntNode *pMessageNode, CntStorageNode *pCacheNode);
};

class CntNewsBox_Impl
{
public:
	/** queryDirectory.
	*/
	static CntStorageNode* queryDirectory (
		const CntStorageNodeRef &rxCache,
		const String            &rDirName,
		BOOL                     bCreate = TRUE);
};

class CntNewsGroup_Impl
{
public:
	/** queryDownload.
	*/
	static BOOL queryDownload (
		const CntStorageNodeRef &rxDirNode);
};

class CntNewsMessage_Impl
{
	static void updateCrossReferences (
		const String                &rMessageID,
		const CntCrossReferenceItem &rXref,
		const CntItemListItem       &rXrefList,
		const CntStorageNodeRef     &rxCache);

public:
#if 0  /* NYI */
	static const USHORT m_aStoreRanges[] =
	{
		WID_PRIORITY,      WID_PRIORITY,
		WID_MESSAGE_ID,    WID_MESSAGE_ID,
		WID_FROM,          WID_TITLE,
		WID_REFERENCES,    WID_REFERENCES,
		WID_NEWSGROUPS,    WID_NEWS_XREFLIST,
		WID_DATE_CREATED,  WID_DATE_CREATED,
		WID_SIZE,          WID_SIZE,
		WID_ACTION_LIST,   WID_ACTION_LIST,
		0
	};
#endif /* NYI */

	static BOOL queryAvailable (
		const CntNode           &rNode,
		const CntStorageNodeRef &rxCache);

	static void initDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage           *&rpMessage,
		const CntStorageNodeRef        &rxCache);

	static void cleanupDownload (
		INetCoreNewsMessage     &rMessage,
		const CntStorageNodeRef &rxCache);

	static BOOL storeDownload (
		INetCoreNewsMessage     &rMessage,
		const String            &rBodyUrl,
		const CntStorageNodeRef &rxCache);

	static BOOL queryStoreDownload (
		const INetCoreNewsMessage &rMessage,
		const CntStorageNodeRef   &rxCache);

	static void updateProperties (
		SfxItemSet                  &rPropSet,
		const INetCoreNewsMessage   &rMessage,
		const CntCrossReferenceItem &rXref,
		const CntStorageNodeRef     &rxCache);

};

/*=======================================================================
 *
 * CntNewsJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsJob_Impl : public SfxListener, public SvRefBase
{
	/** Representation.
	*/
	CntNodeJobRef        m_xJob;
	CntNewsBoxNode_Impl *m_pParent;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsJob_Impl);

protected:
	/** Broadcast (notify master job client).
	*/
	void Broadcast (
		const SfxHint& rHint);

	/** Result (notify master job client).
	*/
	void Result (
		CntNode   *pResult,
		CntAction  eAction = CNT_ACTION_INSERTED);

	/** Request callback.
	*/
	static sal_Bool ExecuteCallback (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData);

	/** Base request handler (noop).
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer)*, sal_Int32, const sal_Char*);

public:
	CntNewsJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsJob_Impl (void);

	CntNodeJob*          GetJob    (void) const { return m_xJob; }
	CntNewsBoxNode_Impl* GetParent (void) const { return m_pParent; }

	CntNode*             GetRootNode (void) const
	{
		return m_pParent->GetParent();
	}

	virtual const SfxPoolItem* Execute (void) = 0;

	virtual void Notify (SfxBroadcaster &rBC, const SfxHint& rHint);
};

SV_DECL_IMPL_REF (CntNewsJob_Impl);

/*=======================================================================
 *
 * CntNewsOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsOpenJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CLOSED,
		STATE_OPEN,
		STATE_AUTH,
		STATE_MODE,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer)         *m_pMailer;
	NAMESPACE_INET(INetCoreMailerCallback) *m_pfnCB;
	void                                   *m_pDataCB;
	State                                   m_eState;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsOpenJob_Impl);

public:
	CntNewsOpenJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsOpenJob_Impl (void);

	void SetCallback (
		NAMESPACE_INET(INetCoreMailerCallback) *pfnCallback, void *pData)
	{
		m_pfnCB   = pfnCallback;
		m_pDataCB = pData;
	}

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsAuthJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsAuthJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer)         *m_pMailer;
	NAMESPACE_INET(INetCoreMailerCallback) *m_pfnCB;
	void                                   *m_pDataCB;
	ByteString                              m_aReplyText;
	State                                   m_eState;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsAuthJob_Impl);

public:
	CntNewsAuthJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsAuthJob_Impl (void);

	void SetCallback (
		NAMESPACE_INET(INetCoreMailerCallback) *pfnCallback, void *pData)
	{
		m_pfnCB   = pfnCallback;
		m_pDataCB = pData;
	}

	void SetReplyText (const sal_Char *pReplyText)
	{
		m_aReplyText.Assign (pReplyText);
	}

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsCloseJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsCloseJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CLOSE,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	State                           m_eState;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsCloseJob_Impl);

public:
	CntNewsCloseJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsCloseJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsLoadListJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsLoadListJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_LOAD,
		STATE_DIRLIST,
		STATE_GROUPLIST,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode     *m_pCache;
	CntStorageIterator *m_pIter;
	SvStream           *m_pStrm;
	State               m_eState;
	USHORT              m_nHintId;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsLoadListJob_Impl);

public:
	CntNewsLoadListJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsLoadListJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsSaveListJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsSaveListJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	SvStream *m_pStrm;
	ULONG     m_nDone;
	USHORT    m_nHintId;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsSaveListJob_Impl);

public:
	CntNewsSaveListJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsSaveListJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * class CntNewsBoxJob common internals.
 *
 *=====================================================================*/
/*
 * CntNewsBoxState.
 */
enum CntNewsBoxState
{
	NEWSBOX_STATE_NONE,
	NEWSBOX_STATE_CLOSE,
	NEWSBOX_STATE_OPEN,
	NEWSBOX_STATE_AUTHINFO,
	NEWSBOX_STATE_GROUPLIST,
	NEWSBOX_STATE_SELECT,
	NEWSBOX_STATE_DONE
};

/*=======================================================================
 *
 * CntNewsBoxJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxJob_Impl : public CntNewsJob_Impl
{
	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxJob_Impl);

protected:
	/** Representation.
	*/
	CntStorageNode *m_pCache;
	CntStorageNode *m_pViewData;
	USHORT          m_eViewMode;
	USHORT          m_nWhich;

	/** Initialize (two-phase construction).
	*/
	BOOL Initialize (void);

	/** Find.
	*/
	CntNewsGroupListEntry* Find (
		const NAMESPACE_RTL(OUString) &rGroupName,
		CntNewsGroupList              &rList,
		ULONG                         &rIndex);

	/** Update.
	*/
	ULONG Update (
		CntNodeRef                  &rxDirNode,
		const CntNewsGroupListEntry &rEntry);

	/** QueryResult.
	*/
	BOOL QueryResult (
		CntNodeRef   &rxDirNode,
		const String &rGroupName);

public:
	CntNewsBoxJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxJob_Impl (void);
};

/*=======================================================================
 *
 * CntNewsBoxOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxOpenJob_Impl : public CntNewsBoxJob_Impl
{
	/** Representation.
	*/
	CntNodeJob         *m_pLoadJob;
	CntStorageIterator *m_pIter;
	ULONG               m_nCount;
	USHORT              m_nHintId;
	CntNewsBoxState     m_eState;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxOpenJob_Impl);

public:
	CntNewsBoxOpenJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxOpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxUpdateJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxUpdateJob_Impl : public CntNewsBoxJob_Impl
{
	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	CntStorageIterator             *m_pIter;

	CntNodeJob                     *m_pListJob;
	CntNewsGroupList                m_aGroupList;
	CntNewsGroupListEntry           m_aGroupListEntry;
	DateTime                        m_aLastUpdate;
	BOOL                            m_bModified : 1;

	CntNewsBoxState                 m_eState;
	CntNewsBoxState                 m_ePrev;
	CntNewsBoxState                 m_eNext;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxUpdateJob_Impl);

public:
	CntNewsBoxUpdateJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxUpdateJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxSyncJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxSyncJob_Impl : public CntNewsBoxJob_Impl
{
	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	SvStream                       *m_pStrm;
	CntNodeJob                     *m_pLoadJob;

	CntNewsGroupList                m_aGroupList;
	ULONG                           m_nGroupListCount;
	ULONG                           m_nStartCount;
	ULONG                           m_nTotalCount;
	USHORT                          m_nHintId;

	CntNewsBoxState                 m_eState;
	CntNewsBoxState                 m_ePrev;
	CntNewsBoxState                 m_eNext;

	/** Specifiy request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Implementation.
	*/
	BOOL Nice (ULONG nStartTicks);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxSyncJob_Impl);

public:
	CntNewsBoxSyncJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxSyncJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxGetListJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxGetListJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	CntNodeJob     *m_pLoadJob;
	CntFolderList  *m_pFolderList;
	CntStorageNode *m_pViewData;
	ULONG           m_nTotalCount;
	BOOL			m_bSubscribedOnly;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxGetListJob_Impl);

public:
	CntNewsBoxGetListJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxGetListJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxPutListJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxPutListJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	CntNodeJob     *m_pListJob;
	CntFolderList  *m_pFolderList;
	CntStorageNode *m_pCache;
	CntStorageNode *m_pViewData;
	String          m_aBoxURL;
	ULONG           m_nTotalCount;
	ULONG           m_nSubscrCount;

	/** Subscribe.
	*/
	void Subscribe (
		const CntNewsGroupListEntry &rEntry);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxPutListJob_Impl);

public:
	CntNewsBoxPutListJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxPutListJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsGroupJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupJob_Impl : public CntNewsJob_Impl
{
	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupJob_Impl);

protected:
	/** Representation.
	*/
	CntStorageNode *m_pDirNode;
	CntNode        *m_pGroup;
	String          m_aGroupName;

	/** initialize (two-phase construction).
	*/
	BOOL initialize (void);

	/** updateArticle.
	 */
	void updateArticle (
		CntNode             &rNode,
		const SfxItemSet    &rPropSet,
		const CntRangesItem &rSeenRanges,
		const CntRangesItem &rMarkRanges,
		ULONG                nIndex);

	/** update.
	*/
	void update (
		const CntRangesItem &rKnownRanges);

	/** openUserDataItemSet (writeable).
	*/
	CntStoreItemSet* openUserDataItemSet (void);

	/** queryDownload.
	*/
	BOOL queryDownload (void)
	{
		return CntNewsGroup_Impl::queryDownload (m_pDirNode);
	}

public:
	CntNewsGroupJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupJob_Impl (void);
};

/*=======================================================================
 *
 * CntNewsGroupOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupOpenJob_Impl : public CntNewsGroupJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_OPEN,
		STATE_UPDATE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef  m_xSubJob;
	CntRangesItem *m_pKnownRanges;
	CntRangesItem *m_pViewRanges;
	ULONG          m_nDone;
	ULONG          m_nLimit;
	USHORT         m_nHintId;
	State          m_eState;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupOpenJob_Impl);

public:
	CntNewsGroupOpenJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupOpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsGroupUpdateJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupUpdateJob_Impl : public CntNewsGroupJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_UPDATE,
		STATE_CLOSED,
		STATE_AUTH,
		STATE_OPEN,
		STATE_SELECT,
		STATE_OVERVIEW,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNewsGroupListEntry           m_aGroupEntry;
	CntRangesItem                  *m_pKnownRanges;

	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	ULONG                           m_nLimit;
	USHORT                          m_nHintId;

	State                           m_eState;
	State                           m_ePrev;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** queryArticleCleanup.
	 */
	CntNodeJob* queryArticleCleanup (
		const CntRangesItem &rServerRanges);

	/** queryArticleDownload.
	 */
	CntNodeJob* queryArticleDownload (
		const CntRangesItem &rServerRanges);

	/** storeArticle.
	*/
	CntStoreItemSet* storeArticle (
		const INetCoreNewsMessage   &rMessage,
		const CntCrossReferenceItem &rXref);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupUpdateJob_Impl);

public:
	CntNewsGroupUpdateJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupUpdateJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsGroupLoadJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupLoadJob_Impl : public CntNewsGroupJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_ITER,
		STATE_LOAD,
		STATE_CLOSED,
		STATE_AUTH,
		STATE_OPEN,
		STATE_SELECT,
		STATE_ARTICLE,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	CntStorageNode                 *m_pCache;
	CntRangesItem                  *m_pInitRanges;
	CntRangesItem                  *m_pLoadRanges;
	CntNewsGroupListEntry           m_aGroupEntry;
	DateTime                        m_aLoadLimit;
	ULONG                           m_nLoadCount;

	USHORT                          m_nHintId;
	State                           m_eState;
	State                           m_ePrev;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Implementation.
	 */
	void initDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage           *&rpMessage);
	void clearDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage            &rMessage);

	BOOL saveDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage            &rMessage,
		const CntCrossReferenceItem    &rXref);
	void showDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupLoadJob_Impl);

public:
	CntNewsGroupLoadJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupLoadJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsGroupDeleteJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupDeleteJob_Impl : public CntNewsGroupJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_ITER,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode *m_pCache;
	CntRangesItem  *m_pKnownRanges;
	CntRangesItem  *m_pDeleteRanges;
	ULONG           m_nCount;
	USHORT          m_nHintId;
	State           m_eState;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupDeleteJob_Impl);

public:
	CntNewsGroupDeleteJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupDeleteJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsGroupMarkJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsGroupMarkJob_Impl : public CntNewsGroupJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_ITER,
		STATE_DONE
	};

	/** Representation.
	*/
	CntRangesItem *m_pActionRanges;
	CntRangesItem *m_pResultRanges;
	State          m_eState;

	/** Implementation.
	 */
	BOOL queryAction (
		const CntBoolItem &rRequest,
		CntRangesItem    *&rpActionRanges,
		CntRangesItem    *&rpResultRanges);

	BOOL executeRequest (
		const CntBoolItem &rRequest,
		CntRangesItem     &rRanges);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsGroupMarkJob_Impl);

public:
	CntNewsGroupMarkJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsGroupMarkJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsMsgOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsMsgOpenJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE,
		STATE_CLOSED,
		STATE_AUTH,
		STATE_OPEN,
		STATE_SELECT,
		STATE_ARTICLE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode                 *m_pCache;
	CntNode                        *m_pDocNode;
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	CntCrossReferenceItem           m_aXref;
	CntNewsGroupListEntry           m_aGroupEntry;

	USHORT                          m_nHintId;
	State                           m_eState;
	State                           m_ePrev;

	/** Specific request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Implementation.
	*/
	void initDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage           *&rpMessage);
	void clearDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage            &rMessage);

	BOOL queryDownload (
		const String &rNewsgroups);
	BOOL saveDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage            &rMessage,
		const CntCrossReferenceItem    &rXref);

	void showDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsMsgOpenJob_Impl);

public:
	CntNewsMsgOpenJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsMsgOpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsMsgMarkJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsMsgMarkJob_Impl : public CntNewsJob_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_MARK,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode *m_pUserData;
	State           m_eState;

	/** Implementation.
	*/
	void updateGroup (
		const CntCrossReferenceItem &rXref,
		const CntBoolItem           &rProp);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsMsgMarkJob_Impl);

public:
	CntNewsMsgMarkJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsMsgMarkJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxImportJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxImportJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	enum State { STATE_LIST, STATE_INIT, STATE_RUNNING };

	SvStream                       * m_pStream;
	CntImport                      * m_pImport;
	USHORT                           m_nHintID;
	String                           m_aHostName;
	String                           m_aBoxURL;
	CntNewsBoxMessageCachingPolicy * m_pPolicy;
	CntMBXBodyScanner              * m_pNewsboxScanner;
	String                           m_aGroupName;

	String                           m_aLastGroupName;
	CntNodeRef                       m_xLastGroupDir;
	CntNodeRef                       m_xLastGroupNode;
	CntStoreItemSetRef               m_xLastGroupUserSet;

	BOOL                             m_bLastGroupKnownRangesSet;
	CntRangesItem                    m_aLastGroupKnownRanges;
	BOOL                             m_bLastGroupKnownRangesModified;

	BOOL                             m_bLastGroupReadRangesSet;
	CntRangesItem                    m_aLastGroupReadRanges;
	BOOL                             m_bLastGroupReadRangesModified;

	BOOL                             m_bLastGroupMarkedRangesSet;
	CntRangesItem                    m_aLastGroupMarkedRanges;
	BOOL                             m_bLastGroupMarkedRangesModified;

	State							 m_eState;
	CntNewsGroupList			   * m_pGroupList;
	CntNodeJob					   * m_pLoadJob;

	String                           m_sFileName;
	bool                             m_bMessageFound;

	void updateLastGroup();
	void finishLastGroup();

	ErrCode handleNewsboxGroup (
		CntMBXToken & rToken);
	ErrCode handleNewsboxReadMarked (
		BOOL bRead, CntMBXToken & rToken);
	ErrCode handleNewsboxSubscribed (
		CntMBXToken & rToken);
	void handleMessage (
		const SfxItemSet & rItems, const String & rMessageID);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxImportJob_Impl);

public:
	CntNewsBoxImportJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);
	virtual ~CntNewsBoxImportJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntNewsBoxExportJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsBoxExportJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	CntNodeRef            m_xGroupDirectory;
	CntNodeRef            m_xMessageNode;
	CntNodeJobRef         m_xOpenJob;
	String                m_aGroupName;
	SvStream            * m_pStream;
	CntExport           * m_pExport;
	CntStorageIterator  * m_pIterator;
	CntStorageIterator  * m_pGroupIterator;
	UINT32                m_nProgress;
	USHORT                m_nHintID;
	BOOL                  m_bWriteNewsbox;
	BOOL				  m_bIgnoreOffline;

	DECL_LINK(errorHandler, CntErrorData *);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsBoxExportJob_Impl);

public:
	inline CntNewsBoxExportJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

inline CntNewsBoxExportJob_Impl::CntNewsBoxExportJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent)
	: CntNewsJob_Impl(pJob, pParent),
	  m_pStream(0),
	  m_nHintID(0),
	  m_pExport(0),
	  m_nProgress(0),
	  m_bWriteNewsbox(FALSE),
	  m_pIterator(0),
	  m_pGroupIterator(0),
	  m_bIgnoreOffline(FALSE)
{}

/*=======================================================================
 *
 * CntNewsMsgExportJob_Impl interface.
 *
 *=====================================================================*/
class CntNewsMsgExportJob_Impl : public CntNewsJob_Impl
{
	/** Representation.
	*/
	CntNodeJobRef m_xOpenJob;
	SvStream    * m_pStream;
	CntExport   * m_pExport;
	USHORT        m_nHintID;

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsMsgExportJob_Impl);

public:
	inline CntNewsMsgExportJob_Impl (
		CntNodeJob *pJob, CntNewsBoxNode_Impl *pParent);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

inline CntNewsMsgExportJob_Impl::CntNewsMsgExportJob_Impl (
	CntNodeJob *pJob, CntNewsBoxNode_Impl * pParent)
	: CntNewsJob_Impl(pJob, pParent),
	  m_pStream(0),
	  m_pExport(0),
	  m_nHintID(0)
{}

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_CNTNEWSIMP_HXX */

