/*************************************************************************
 *
 *  $RCSfile: cnthttp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CNTHTTP_CXX "$Revision: 1.1.1.1 $"

#ifndef _OSL_INTERLCK_H_
#include <osl/interlck.h>
#endif

#ifndef _VOS_MACROS_HXX
#include <vos/macros.hxx>
#endif
#ifndef _VOS_MUTEX_HXX
#include <vos/mutex.hxx>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX
#include <tools/inetmsg.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _LCKBITEM_HXX
#include <svtools/lckbitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif

#ifndef _CNTBASE_HXX
#include "cntbase.hxx"
#endif
#ifndef _CNTHTTP_HXX
#include "cnthttp.hxx"
#endif
#ifndef _CNTHTTPIMP_HXX
#include "chttpimp.hxx"
#endif
#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTDOCND_HXX
#include "cntdocnd.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CNTCMITM_HXX
#include "cntcmitm.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CNTIDS_HRC
#include "cntids.hrc"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif

#ifndef _CHAOS_HTTPITEM_HXX
#include "httpitem.hxx"
#endif
#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*========================================================================
 *
 * CntHTTPDocumentNode interface.
 *
 *======================================================================*/
class CntHTTPDocumentNode : public CntDocumentNode
{
	/** Representation.
	*/
	oslInterlockedCount m_nRefCount;

	/** Not implemented.
	*/
	CntHTTPDocumentNode (const CntHTTPDocumentNode& rOther);
	CntHTTPDocumentNode& operator= (const CntHTTPDocumentNode& rOther);

public:
	TYPEINFO();
	CNT_NODE_SUBCLASS_DECL();

	CntHTTPDocumentNode (const USHORT *pRanges = NULL);
	virtual ~CntHTTPDocumentNode (void);

	virtual CntNode* Initialize (
		CntNode *pParent, const String& rNodeURL);

	virtual FASTBOOL IsItemFlag (USHORT nWhich, USHORT nFlag) const;

	virtual const SfxPoolItem* InsertJob (CntNodeJob *pJob);
};

/*========================================================================
 *
 * CntHTTPRootNode internals.
 *
 *======================================================================*/
/*
 * Ranges.
 */
static USHORT __READONLY_DATA aCntHTTPRootRanges_Impl[] =
{
	WID_CHAOS_START, WID_CHAOS_END,
	0
};

/*
 * GetDataWhich_Impl.
 */
static USHORT __READONLY_DATA pGetDataWhich_Impl[] =
{
	WID_SIZE,
	WID_SIZE_LIMIT,
	WID_HTTP_CONNECTION_LIMIT,
	WID_HTTP_KEEP_EXPIRED,
	WID_HTTP_VERIFY_MODE,
	WID_HTTP_NOCACHE_LIST,
	0
};

/*========================================================================
 *
 * CntHTTPRootNode implementation.
 *
 *======================================================================*/
/*
 * CntHTTPRootNode.
 */
TYPEINIT1_AUTOFACTORY (CntHTTPRootNode, CntNode);

CntHTTPRootNode::CntHTTPRootNode (void)
	: CntNode (aCntHTTPRootRanges_Impl),
	  m_pImpl (NULL)
{
	// class CntHTTPRootNode defaults.
	CntDefaults *pClassDefs = GetDefaults();
	if (pClassDefs == NULL)
	{
		// Create new class defaults.
		pClassDefs = new CntDefaults (*this, aCntHTTPRootRanges_Impl);

		// Set ContentType.
		pClassDefs->Put (CntContentTypeItem (
			WID_CONTENT_TYPE, CONTENT_TYPE_X_CNT_HTTPBOX));

		// Set ...
		pClassDefs->Put (CntBoolItem (WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put (CntBoolItem (WID_FLAG_HAS_MESSAGES, TRUE));

		// Store class defaults.
		SetDefaults (pClassDefs);
	}
	CntInterface::SetParent (pClassDefs);

	// Create implementation instance.
	m_pImpl = new CntHTTPRootNode_Impl (this);
}

/*
 * ~CntHTTPRootNode.
 */
CntHTTPRootNode::~CntHTTPRootNode (void)
{
	delete m_pImpl;
}

/*
 * Register.
 */
CNT_NODE_SUBCLASS_IMPL(CntHTTPRootNode)
{
	// Register ourself at root node manager.
	UniString aPattern (S2U (CNTHTTP_ROOT_URL));
	aPattern += sal_Unicode ('*');

	CntNodeFactory *pFac = new CntNodeFactory (
		aPattern, UniString (sal_Unicode ('#')),
		StaticType(), CONTENT_TYPE_X_CNT_HTTPBOX);
	CntRootNodeMgr::InsertFactory (pFac);

	// Register possible children.
	UniString aDelim;
	pFac = new CntNodeFactory (
		S2U ("#http://*"), aDelim,
		TYPE (CntHTTPDocumentNode), CONTENT_TYPE_X_CNT_DOCUMENT,
		CNT_CREATION_FLAG_HIDDEN);
	InsertFactory (pFac);

#ifdef SOLAR_SSL
	pFac = new CntNodeFactory (
		S2U ("#https://*"), aDelim,
		TYPE (CntHTTPDocumentNode), CONTENT_TYPE_X_CNT_DOCUMENT,
		CNT_CREATION_FLAG_HIDDEN);
	InsertFactory (pFac);
#endif /* SOLAR_SSL */

	pFac = new CntNodeFactory (
		S2U ("#ftp://*"), aDelim,
		TYPE (CntHTTPDocumentNode), CONTENT_TYPE_X_CNT_DOCUMENT,
		CNT_CREATION_FLAG_HIDDEN);
	InsertFactory (pFac);

	pFac = new CntNodeFactory (
		S2U ("#proxy://*"), aDelim,
		TYPE (CntHTTPDocumentNode), CONTENT_TYPE_X_CNT_DOCUMENT,
		CNT_CREATION_FLAG_HIDDEN);
	InsertFactory (pFac);
}

/*
 * JobArrived.
 */
const SfxPoolItem* CntHTTPRootNode::JobArrived (CntNodeJob *pJob)
{
	CntNode *pSubject = pJob->GetSubject();
	DBG_ASSERT (pSubject, "CntHTTPRootNode::JobArrived(): no Subject");
	if (pSubject && pSubject->ISA(CntHTTPDocumentNode))
	{
		// Acquire exclusive access.
		NAMESPACE_VOS(OGuard) aGuard (getMutex());

		// Obtain JobQueue.
		CntNodeJobQueue *pJobQueue = GetJobQueue();
		DBG_ASSERT(
			pJobQueue, "CntHTTPRootNode::JobArrived(): no JobQueue");
		if (pJobQueue)
		{
			CntNodeJob *pNextJob = m_pImpl->EnqueueJob (pJobQueue, pJob);
#ifdef DBG_UTIL_PRIVATE
			if (pNextJob)
			{
				String aTrace ("EXE: ");
				aTrace += ITEMSET_VALUE_STRING(
					pNextJob->GetSubject(), WID_REAL_URL);
				aTrace += " (Prio: ";
				aTrace += m_pImpl->Priority (pNextJob);
				aTrace += ')';
				_TRACE(aTrace);
			}
#endif /* DBG_UTIL_PRIVATE */
			if (pNextJob)
				new CntJobRescheduler (this, pNextJob);
			return NULL;
		}
	}
	return CntNode::JobArrived (pJob);
}

/*
 * JobFinished.
 */
BOOL CntHTTPRootNode::JobFinished (CntNodeJob *pJob)
{
	CntNode *pSubject = pJob->GetSubject();
	DBG_ASSERT (pSubject, "CntHTTPRootNode::JobFinished(): no Subject");
	if (pSubject && pSubject->ISA(CntHTTPDocumentNode))
	{
		// Acquire exclusive access.
		NAMESPACE_VOS(OGuard) aGuard (getMutex());

		// Obtain JobQueue.
		CntNodeJobQueue *pJobQueue = GetJobQueue();
		DBG_ASSERT(
			pJobQueue, "CntHTTPRootNode::JobFinished(): no JobQueue");
		if (pJobQueue)
		{
			CntNodeJob *pNextJob = m_pImpl->DequeueJob (pJobQueue, pJob);
#ifdef DBG_UTIL_PRIVATE
			if (pNextJob)
			{
				String aTrace ("SCH: ");
				aTrace += ITEMSET_VALUE_STRING(
					pNextJob->GetSubject(), WID_REAL_URL);
				aTrace += " (Prio: ";
				aTrace += m_pImpl->Priority (pNextJob);
				aTrace += ')';
				_TRACE(aTrace);
			}
#endif /* DBG_UTIL_PRIVATE */
			if (pNextJob)
				new CntJobRescheduler (this, pNextJob);
			return TRUE;
		}
	}
	return CntNode::JobFinished (pJob);
}

/*
 * ExecuteJob.
 */
const SfxPoolItem* CntHTTPRootNode::ExecuteJob (CntNodeJob *pJob)
{
	// Check RequestData.
	CntHTTPJob_Impl *pJobImpl = (CntHTTPJob_Impl *)(pJob->GetRequestData());
	if (pJobImpl)
	{
		// Execute rescheduled CntHTTPJob_Impl.
		return pJobImpl->Execute();
	}

	// Check Subject.
	CntNode *pSubject = pJob->GetSubject();
	if (pSubject == this)
	{
		// Job for ourselfs.
		const SfxPoolItem *pReq = pJob->GetRequest();
		switch (pReq->Which())
		{
			case WID_GETDATA:
				if (pJob->GetCacheNode())
				{
					NAMESPACE_VOS(OGuard) aGuard (m_pImpl->GetCacheLock());

					CntStoreItemSetRef xBoxSet =
						m_pImpl->GetBoxDirItemSet (pJob->GetCacheNode());
					if (xBoxSet.Is())
					{
						const USHORT *pWhich = pGetDataWhich_Impl;
						while (*pWhich)
						{
							Put (xBoxSet->Get(*pWhich), *pWhich);
							pWhich++;
						}

						USHORT nWhich = WID_HTTP_COOKIE_MANAGER;
						if (GetItemState(nWhich, FALSE) < SFX_ITEM_SET)
						{
							// Restore CookieManager once, only.
							Put (xBoxSet->Get(nWhich), nWhich);
						}
					}
				}
				break;

			case WID_PUTDATA:
				if (pJob->GetCacheNode())
				{
					NAMESPACE_VOS(OGuard) aGuard (m_pImpl->GetCacheLock());

					CntStoreItemSetRef xBoxSet =
						m_pImpl->GetBoxDirItemSet (pJob->GetCacheNode());

					const CntItemListItem *pListItem =
						(const CntItemListItem *)pReq;

					USHORT i, n = pListItem->Count();
					for (i = 0; i < n; i++)
					{
						const SfxPoolItem& rItem = (*pListItem)[i];
						USHORT nWhich = rItem.Which();

						Put (rItem, nWhich);
						if (xBoxSet.Is())
							xBoxSet->Put (rItem, nWhich);
					}
				}
				break;

			case WID_SIZE:
			case WID_SIZE_LIMIT:
			case WID_HTTP_CONNECTION_LIMIT:
			case WID_HTTP_COOKIE_MANAGER:
			case WID_HTTP_KEEP_EXPIRED:
			case WID_HTTP_VERIFY_MODE:
			case WID_HTTP_NOCACHE_LIST: // SetProperty instead of PutData.
				if (pJob->GetCacheNode())
				{
					// SetProperty.
					Put (*pReq, pReq->Which());

					// StoreProperty.
					NAMESPACE_VOS(OGuard) aGuard (m_pImpl->GetCacheLock());

					CntStoreItemSetRef xBoxSet (
						m_pImpl->GetBoxDirItemSet (pJob->GetCacheNode()));
					if (xBoxSet.Is())
						xBoxSet->Put (*pReq);

					pJob->Done();
					return NULL;
				}
				break;

			case WID_CONNECTION_MODE:
				if (m_pImpl)
				{
					// Set connection mode.
					CntConnMode eConnMode =
						(CntConnMode)(ITEM_VALUE (CntConnModeItem, *pReq));
					m_pImpl->SetConnMode (eConnMode);

					// Done.
					pJob->Done();
					return NULL;
				}
				break;

			case WID_CLEAN_CACHE:
				if (pJob->GetCacheNode())
				{
					// Setup.
					pJobImpl = new CntHTTPDeleteJob_Impl (pJob, m_pImpl);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			default:
				break;
		}
		return CntNode::ExecuteJob (pJob);
	}
	else if (pSubject->ISA(CntHTTPDocumentNode))
	{
		// Execute job on behalf of a CntHTTPDocumentNode.
		const SfxPoolItem *pReq = pJob->GetRequest();
		switch (pReq->Which())
		{
			case WID_OPEN:        // GET
			case WID_UPDATE:      // GET or Conditional-GET
			case WID_SYNCHRONIZE: // GET with Pragma: no-cache
				if (pJob->GetCacheNode())
				{
					// Setup.
					pJobImpl = new CntHTTPGetJob_Impl (pJob, m_pImpl);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_INSERT: // PUT
				if (pJob->GetCacheNode())
				{
					// Setup.
					pJobImpl = new CntHTTPPutJob_Impl (pJob, m_pImpl);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_HTTP_POST:
				if (pJob->GetCacheNode())
				{
					// Setup.
					pJobImpl = new CntHTTPPostJob_Impl (pJob, m_pImpl);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_HTTP_GET_COOKIE:
				if (pJob->GetCacheNode())
				{
					INetURLObject aUrlObj (ITEMSET_VALUE_STRING(
						pSubject, WID_REAL_URL));

					String aCookie (m_pImpl->GetCookie (aUrlObj));
					pSubject->Put (CntStringItem (WID_HTTP_COOKIE, aCookie));

					pJob->Done();
					return NULL;
				}
				break;

			case WID_HTTP_SET_COOKIE:
				if (pJob->GetCacheNode())
				{
					INetURLObject aUrlObj (ITEMSET_VALUE_STRING(
						pSubject, WID_REAL_URL));

					INetMessage aMsg;
					aMsg.SetHeaderField (
						S2U("Set-Cookie"),
						ITEM_VALUE(CntStringItem, *pReq));

					m_pImpl->SetCookie (aUrlObj, aMsg);

					pJob->Done();
					return NULL;
				}
				break;

			default:
				break;
		}
		return CntNode::ExecuteJob (pJob);
	}
	else
	{
		// Forward to base class.
		return CntNode::ExecuteJob (pJob);
	}
}

/*
 * Put.
 */
const SfxPoolItem* CntHTTPRootNode::Put (
	const SfxPoolItem& rProp, USHORT nWhich)
{
	// Set property.
	switch (nWhich)
	{
		case WID_SIZE_LIMIT:
			m_pImpl->SetSizeLimit (
				ITEM_VALUE (CntUInt32Item, rProp));
			break;

		case WID_HTTP_CONNECTION_LIMIT:
			m_pImpl->SetJobQueueLimit (
				1 + ITEM_VALUE (CntByteItem, rProp));
			break;

		case WID_HTTP_KEEP_EXPIRED:
			m_pImpl->SetKeepExpired (
				ITEM_VALUE (CntBoolItem, rProp));
			break;

		case WID_HTTP_VERIFY_MODE:
			m_pImpl->SetVerifyMode (
				ITEM_VALUE (CntHTTPVerifyModeItem, rProp));
			break;

		case WID_HTTP_NOCACHE_LIST:
			m_pImpl->SetNoCacheList (
				ITEM_VALUE (CntStringItem, rProp));
			break;

		default:
			break;
	}
	return CntNode::Put (rProp, nWhich);
}

/*
 * Notify.
 */
void CntHTTPRootNode::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNode::Notify (rBC, rHint);
}

/*
 * SetConnMode.
 */
void CntHTTPRootNode::SetConnMode (CntConnMode eConnMode)
{
	DBG_ASSERT(m_pImpl, "CntHTTPRootNode::m_pImpl");
	if (m_pImpl)
		m_pImpl->SetConnMode (eConnMode);
}

/*========================================================================
 *
 * CntHTTPDocumentNode internals.
 *
 *======================================================================*/
/*
 * Ranges (CntDocumentNode + HTTP).
 */
static USHORT __READONLY_DATA aCntHTTPDocRanges_Impl[] =
{
	WID_TITLE,           WID_TITLE,
	WID_ALL_START,       WID_SYNCHRONIZE,
	WID_INSERT,          WID_UPDATE,
	WID_USERNAME,        WID_SERVERNAME,
	WID_UNDELETE,        WID_REOPEN,
	WID_PROPERTYLIST,    WID_PROPERTYLIST,
	WID_DOCUMENT_HEADER, WID_DOCUMENT_SIZE,
	WID_ACCOUNT,         WID_ACCOUNT,
	WID_HTTP_POST,       WID_HTTP_POST,
	WID_HTTP_REFERER,    WID_HTTP_REFERER,
	WID_HTTP_GET_COOKIE, WID_HTTP_COOKIE,
	0
};

/*
 * CntStoreItemSet ranges.
 */
CHTTPDOC_DIR_RANGES_IMPL(aDocDirRanges_Impl);

/*========================================================================
 *
 * CntHTTPDocumentNode implementation.
 *
 *======================================================================*/
/*
 * CntHTTPDocumentNode.
 */
TYPEINIT1_AUTOFACTORY (CntHTTPDocumentNode, CntDocumentNode);

CntHTTPDocumentNode::CntHTTPDocumentNode (const USHORT *pRanges)
	: CntDocumentNode (pRanges ? pRanges : aCntHTTPDocRanges_Impl),
	  m_nRefCount     (0)
{
	// class CntHTTPDocumentNode defaults.
	CntDefaults *pClassDefs = GetDefaults();
	if (pClassDefs == NULL)
	{
		// Create new class defaults.
		pClassDefs = new CntDefaults (
			*this, aCntHTTPDocRanges_Impl, CntDocumentNode::GetDefaults());

		// Set defaults for a document.
		pClassDefs->Put (CntContentTypeItem (
			WID_CONTENT_TYPE, CONTENT_TYPE_X_CNT_DOCUMENT));
		pClassDefs->Put (CntBoolItem (WID_FLAG_IS_DOCUMENT, TRUE));

		// Disable unwanted items in [WID_ALL_START, WID_ALL_END].
		pClassDefs->DisableItem (WID_CUT);
		pClassDefs->DisableItem (WID_COPY);
		pClassDefs->DisableItem (WID_PASTE);

		// Erase Username and Password.
		pClassDefs->Put (CntStringItem (WID_USERNAME, String()));
		pClassDefs->Put (CntStringItem (WID_PASSWORD, String()));

		// Store class defaults.
		SetDefaults (pClassDefs);
	}
	CntInterface::SetParent (pClassDefs);
}

/*
 * ~CntHTTPDocumentNode.
 */
CntHTTPDocumentNode::~CntHTTPDocumentNode (void)
{
}

/*
 * Register.
 */
CNT_NODE_SUBCLASS_IMPL (CntHTTPDocumentNode)
{
	// Nothing to do.
}

/*
 * Initialize.
 */
CntNode* CntHTTPDocumentNode::Initialize (
	CntNode *pParent, const String& rNodeURL)
{
	CntNode *pNode = CntDocumentNode::Initialize (pParent, rNodeURL);
	if (pNode)
	{
		String aOwnUrl (OWN_URL (this));
		Put (CntStringItem (WID_REAL_URL, aOwnUrl.GetToken ((USHORT)1, '#')));
	}
	return pNode;
}

/*
 * IsItemFlag.
 */
FASTBOOL CntHTTPDocumentNode::IsItemFlag (USHORT nWhich, USHORT nFlag) const
{
	switch (nFlag)
	{
		case CNT_ITEM_AUTO_OWNPROP: // Never.
			return FALSE;

		default:
			break;
	}
	return CntDocumentNode::IsItemFlag (nWhich, nFlag);
}

/*
 * InsertJob.
 */
const SfxPoolItem* CntHTTPDocumentNode::InsertJob (CntNodeJob *pJob)
{
	const SfxPoolItem *pReq = pJob->GetRequest();
	USHORT nWhich = pReq->Which();
	switch (nWhich)
	{
		case WID_GETDATA: // Load Property Job.
			if (pJob->GetCacheNode())
			{
				// Obtain DocumentHead URL.
				String aHeadURL (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
				aHeadURL += THIS_ITEM_VALUE (CntStringItem, WID_REAL_URL);
				String aHeadName (CHTTPIMP_SHORT_NAME(aHeadURL));

				// Obtain document attributes.
				CntStorageNode *pCache  = pJob->GetCacheNode();
				UINT32          nAttrib = 0;

				ErrCode eErrCode = pCache->attrib (aHeadName, 0, 0, nAttrib);
				if (eErrCode == ERRCODE_NONE)
				{
					// Check for Marked and Visited.
					if (nAttrib & CNTDIRENTRY_ATTRIB_MARKED)
						Put (CntBoolItem (WID_IS_MARKED, TRUE));

					if (nAttrib & CNTDIRENTRY_ATTRIB_VISITED)
						Put (CntBoolItem (WID_IS_READ, TRUE));

					// Obtain DocumentHead itemset.
					CntStoreItemSetRef xDirSet = pCache->openItemSet (
						aDocDirRanges_Impl, aHeadName, STREAM_STD_READ);
					if (xDirSet.Is())
						Put (*xDirSet);
				}

				// Done.
				pJob->Done();
				return NULL;
			}
			break;

		case WID_IS_MARKED: // Store Property Job.
		case WID_IS_READ:
			if (pJob->GetCacheNode())
			{
				// Obtain DocumentHead URL.
				String aHeadUrl (S2U (CHTTPIMP_DOCUMENT_HEAD_PREFIX));
				aHeadUrl += THIS_ITEM_VALUE (CntStringItem, WID_REAL_URL);
				String aHeadName (CHTTPIMP_SHORT_NAME(aHeadUrl));

				// Setup document attribute.
				CntStorageNode *pCache  = pJob->GetCacheNode();
				UINT32          nAttrib = 0;

				if (nWhich == WID_IS_MARKED)
					nAttrib |= CNTDIRENTRY_ATTRIB_MARKED;
				if (nWhich == WID_IS_READ)
					nAttrib |= CNTDIRENTRY_ATTRIB_VISITED;

				// Mark document.
				BOOL bMark = ITEM_VALUE (CntBoolItem, *pReq);
				if (bMark)
					pCache->attrib (aHeadName, 0, nAttrib);
				else
					pCache->attrib (aHeadName, nAttrib, 0);

				// Done.
				Put (*pReq, nWhich);
				pJob->Done();
				return NULL;
			}
			break;

		case WID_HTTP_REFERER: // Set Property Job.
		case WID_CONTENT_TYPE:
		case WID_DOCUMENT_BODY:
			Put (*pReq, nWhich);
			pJob->Done();
			return NULL;

		case WID_OPEN: // Acquire.
			if (osl_incrementInterlockedCount (&m_nRefCount) <= 0)
			{
				// Release document body.
				ClearItem (WID_DOCUMENT_BODY);
			}
			break;

		case WID_CLOSE: // Release.
			if (pReq->ISA(CntInt32Item))
			{
				// Check for multiple release.
				oslInterlockedCount n = ITEM_VALUE(CntInt32Item, *pReq);
				while (n > 0)
				{
					n -= 1;
					if (osl_decrementInterlockedCount (&m_nRefCount) <= 0)
					{
						// Release document body.
						ClearItem (WID_DOCUMENT_BODY);

						// Finished.
						break;
					}
				}
			}
			else
			{
				if (osl_decrementInterlockedCount (&m_nRefCount) <= 0)
				{
					// Release document body.
					ClearItem (WID_DOCUMENT_BODY);
				}
			}
			pJob->Done();
			return NULL;

		default:
			break;
	}
	return CntDocumentNode::InsertJob (pJob);
}

