/*************************************************************************
 *
 *  $RCSfile: cntnews.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _OSL_INTERLCK_H_
#include <osl/interlck.h>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX //autogen
#include <svtools/ctypeitm.hxx>
#endif

#ifndef _CNTNEWS_HXX
#include "cntnews.hxx"
#endif
#ifndef _CNTNEWSIMP_HXX
#include "cnewsimp.hxx"
#endif

#ifndef _CNTDEFS_HXX
#include "cntdefs.hxx"
#endif
#ifndef _CNTAPI_HXX
#include "cntapi.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTMSGND_HXX
#include "cntmsgnd.hxx"
#endif
#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CNTCMITM_HXX
#include "cntcmitm.hxx"
#endif
#ifndef _CNTSDITM_HXX
#include "cntsditm.hxx"
#endif

#ifndef _CNTVWITM_HXX
#define ITEMID_CNT_FOLDER_VIEWMODE 	WID_FOLDERVIEW_MODE
#define ITEMID_CNT_VIEW_DESCRIPTION WID_VIEW_DESCRIPTION
#include "cntvwitm.hxx"
#endif

#ifndef _CNTTHRD_HXX
#include "cntthrd.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _SORTITEM_HXX
#include "sortitem.hxx"
#endif
#ifndef _ULSTITEM_HXX
#include "ulstitem.hxx"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif
#ifndef _CNTRANGE_HXX
#include "cntrange.hxx"
#endif
#ifndef _CNTXREF_HXX
#include "cntxref.hxx"
#endif
#ifndef _CHAOS_SILITEM_HXX
#include "silitem.hxx"
#endif
#ifndef _RCPNITEM_HXX
#include "rcpnitem.hxx"
#endif
#ifndef _LAYITEM_HXX
#include "layitem.hxx"
#endif

#ifndef _CHAOS_INIMGR_HXX
#include <inimgr.hxx>
#endif

#ifndef CHAOS_FLSTITEM_HXX
#include <flstitem.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntNewsMessageNode interface.
 *
 *=====================================================================*/
class CntNewsMessageNode : public CntMessageNode
{
	/** Representation.
	*/
	oslInterlockedCount m_nRefCount;

	/** Implementation.
	*/
	void GetData_Impl (CntStorageNode *pCache);

	/** Not implemented.
	*/
	COPYCTOR_API (CntNewsMessageNode);

public:
	TYPEINFO();
	CNT_NODE_SUBCLASS_DECL();

	CntNewsMessageNode (const USHORT *pRanges = NULL);
	virtual ~CntNewsMessageNode (void);

	virtual CntNode* Initialize (
		CntNode *pParent, const String &rNodeURL);

	virtual FASTBOOL IsItemFlag (USHORT nWhich, USHORT nFlag) const;

	virtual const SfxPoolItem* InsertJob (CntNodeJob *pJob);

	virtual const SfxPoolItem* Put (
		const SfxPoolItem &rProp, USHORT nWhich);
};

/*=======================================================================
 *
 * CntNews... internals.
 *
 *=====================================================================*/
/*
 * Box Ranges.
 */
static USHORT __READONLY_DATA aNewsBoxRanges_Impl[] =
{
	WID_REPLY_TO,                WID_REPLY_TO,
	WID_FROM,                    WID_TITLE,
	WID_ALL_START,               WID_COPY,
	WID_RENAME,                  WID_VIEW_DESCRIPTION,
	WID_FOLDER_START,            WID_CREATE_NEW,
	WID_UPDATE,                  WID_MESSAGEVIEW_MODE,
	WID_SORTING,                 WID_SUBSCRNEWSGROUPCOUNT,
	WID_FLAG_SUPPORTMODE,        WID_KNOWN_RANGES,
	WID_READ_RANGES,             WID_NEWSSEND_SERVERNAME,
	WID_SMTP_GATEWAY,            WID_MESSAGE_STOREMODE,
	WID_OUTMSGEXTERNALSTATE,     WID_BOXEXT_END,
	WID_SHOW_MSGS_HAS_TIMELIMIT, WID_PURGE,
	WID_SEARCH,                  WID_BOXALL_END2,
	WID_ACCOUNT,                 WID_ACCOUNT,
	WID_TARGET_FRAMES,           WID_EXPORT,
	WID_VIEW_START,              WID_VIEW_END,
	WID_FLAG_UPDATE_ON_OPEN,     WID_FLAG_UPDATE_ON_OPEN,
	WID_VIEW2_START,             WID_VIEW2_END,
	WID_FOLDER_START2,           WID_FOLDER_END2,
	WID_VIEW3_START,             WID_VIEW3_END,
	WID_STORE_MARKED,			 WID_STORE_MARKED,
	WID_SEND_FORMATS,			 WID_SEND_COPY_TARGET,
	0
};

/*
 * CreateNew WhichPairTable.
 */
static USHORT __READONLY_DATA pCreateNewWhich_Impl[] =
{
	WID_SEND_PUBLIC_PROT_ID,		WID_SEND_PRIVATE_PROT_ID,
	WID_SEND_PUBLIC_OUTBOXPROPS,    WID_SEND_PRIVATE_OUTBOXPROPS,
	WID_SEND_SERVERNAME,            WID_SEND_USERNAME,
	WID_SEND_PASSWORD,              WID_SEND_REPLY_TO_DEFAULT,
	WID_SEND_FROM_DEFAULT,			WID_SEND_VIM_POPATH,
	WID_SEND_FORMATS,				WID_SEND_COPY_TARGET,
	0
};

/*
 * CntStoreItemSet Ranges.
 */
CNEWSGRP_USER_RANGES_IMPL (aGrpUserRanges_Impl);
CNEWSMSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*
 * GetSendInfo_Impl.
 */
static String GetSendInfo_Impl (const CntInterface &rClient, USHORT nWhich)
{
	if (!ITEMSET_VALUE_BOOL (&rClient, WID_SEND_PUBLIC_OUTBOXPROPS))
	{
		const String* pInfo =
			((const CntSendInfoListItem&)
			 (rClient.Get(nWhich))).findEntry (CNT_OUTMSG_PROTOCOL_NNTP);
		if (pInfo)
			return *pInfo;
	}
	return String();
}

/*
 * QueryExchange_Impl.
 */
static CntNode* QueryExchange_Impl (CntNode *pThis, const String &rHost)
{
	CntNode *pNode = NULL;
	if (pThis->IsDummy() || rHost.Len())
	{
		String aUrl (S2U ("news://"));

		String aHost (rHost);
		if (!aHost.Len())
			aHost = ITEMSET_VALUE_STRING (pThis, WID_SERVERNAME);
		aUrl += INetURLObject::encodeHostPort (
			aHost, INetURLObject::ENCODE_ALL);
		if (aHost.Len())
			aUrl += sal_Unicode('/');

		pNode = CNT_RNM()->Query (aUrl);
		if (pNode == pThis)
			pNode = NULL;
	}
	return pNode;
}

/*=======================================================================
 *
 * CntNewsBoxNode implementation.
 *
 *=====================================================================*/
/*
 * CntNewsBoxNode.
 */
TYPEINIT1_AUTOFACTORY (CntNewsBoxNode, CntNode);

CntNewsBoxNode::CntNewsBoxNode (void)
	: CntNode (aNewsBoxRanges_Impl)
{
	// class CntNewsBoxNode defaults.
	CntDefaults *pClassDefs = GetDefaults();
	if (pClassDefs == NULL)
	{
		// Create new class defaults.
		pClassDefs = new CntDefaults (*this, aNewsBoxRanges_Impl);

		// Set ContentType.
		pClassDefs->Put (CntContentTypeItem (
			WID_CONTENT_TYPE, CONTENT_TYPE_X_CNT_NEWSBOX));

		// Set Explorer/Browser relevant items.
		pClassDefs->Put (CntBoolItem (WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put (CntBoolItem (WID_FLAG_HAS_FOLDER, TRUE));

		pClassDefs->Put (CntUShortListItem (
			WID_RENAME,
			WID_TITLE, 0));
		pClassDefs->Put (CntUShortListItem (
			WID_FLD_COLUMN_INFO,
			WID_TITLE, 0));

		CntViewColumnsListItem aColumnDefs (
			WID_VIEW_COLS_BEAMER,
			WID_TITLE,     DEF_WIDTH_TITLE_MAIL,
			WID_IS_MARKED, DEF_WIDTH_IS_MARKED,
			WID_IS_READ,   DEF_WIDTH_IS_READ,
			0);

		pClassDefs->Put (aColumnDefs);
		pClassDefs->Put (aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put (aColumnDefs, WID_VIEW_COLS_FLDWIN);

		pClassDefs->Put (CntFolderViewModeItem (
			WID_FOLDERVIEW_MODE, CNT_VIEW_SUBSCRIBED_FOLDERS));

		// Set property tab pages wanted.
		pClassDefs->Put (CntIdentifierListItem (
			WID_PROPERTYLIST,
			CNT_TABPAGE_GENERAL,
			CNT_TABPAGE_RECV_NNTP,
			CNT_TABPAGE_MAIL_NEWS_SEND,
			CNT_TABPAGE_RULES,
			CNT_TABPAGE_SUBSCRIBE,
			CNT_TABPAGE_VIEW_PROPERTIES,
			CNT_TABPAGE_CONTENT_PROPERTIES,
			CNT_TABPAGE_BACKGROUND,
			CNT_TABPAGE_FONT,
		 	0));

		// Set threading item.
		CntThreadingItem aThrItem (WID_THREADING);
		aThrItem.Append (CntThreadingInfo (
			CNT_THREADING_BY_PARENTPATH, WID_FLAG_IS_FOLDER,
			WID_TITLE, WID_TITLE, '.', WID_TITLE));
		pClassDefs->Put (aThrItem);
		pClassDefs->Put (CntBoolItem (WID_THREADED, FALSE));

		// Set sort item.
		CntSortingItem aSortingDefs(WID_SORTING);
		aSortingDefs.Append (CntSortingInfo (WID_TITLE, TRUE));

		pClassDefs->Put (aSortingDefs);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		// Set OutTray-wanted item.
		pClassDefs->Put (CntBoolItem (WID_OUTTRAY_WANTED, TRUE));

		pClassDefs->Put (CntMsgStoreModeItem (WID_MESSAGE_STOREMODE));

		// Store class defaults.
		SetDefaults (pClassDefs);
	}
	CntInterface::SetParent (pClassDefs);

	// Set current DefaultServer into class defaults.
	CntIniManager *pIniMgr = CNT_RNM()->GetIniManager();
	if (pIniMgr)
	{
		pClassDefs->Put (CntStringItem (
			WID_SERVERNAME, pIniMgr->getEntry (CNT_KEY_INET_NNTPSERVER)));
	}

	// Create implementation instance.
	m_pImp = new CntNewsBoxNode_Impl (this);
}

/*
 * ~CntNewsBoxNode.
 */
CntNewsBoxNode::~CntNewsBoxNode (void)
{
	delete m_pImp;
}

/*
 * Register.
 */
CNT_NODE_SUBCLASS_IMPL (CntNewsBoxNode)
{
	// Register ourself at root node manager.
	CntNodeFactory *pFac = new CntNodeFactory (
		S2U ("news://*"), UniString (sal_Unicode('/')),
		StaticType(), CONTENT_TYPE_X_CNT_NEWSBOX,
		CNT_CREATION_FLAG_PROPERTIES, HID_CHAOS_NEW_NEWS_BOX );
	CntRootNodeMgr::InsertFactory (pFac);

	// Register possible children.
	pFac = new CntNodeFactory (
		S2U ("/<*@*>"), UniString(),
		TYPE (CntNewsMessageNode), CONTENT_TYPE_X_CNT_MESSAGE,
		(CNT_CREATION_FLAG_MESSAGEDOC | CNT_CREATION_FLAG_SENDMESSAGE),
		HID_CHAOS_NEW_NEWS_MSG);
	InsertFactory (pFac);

	pFac = new CntNodeFactory (
		S2U ("/*"), UniString(),
		TYPE (CntNewsGroupNode), CONTENT_TYPE_X_CNT_NEWSGROUP);
	InsertFactory (pFac);
}

/*
 * InsertJob.
 */
const SfxPoolItem* CntNewsBoxNode::InsertJob (CntNodeJob *pJob)
{
	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq->Which() == WID_OPEN)
	{
		// Check subject.
		CntNode *pSubject = pJob->GetSubject();
		if (pSubject->ISA(CntNewsMessageNode))
		{
			if (m_pImp->Initialize(pJob))
			{
				// Check message body.
				CntStorageNode *pCache = pJob->GetCacheNode();

				String aUrl (OWN_URL (pSubject));
				aUrl.AppendAscii (".body");

				UINT32 nAttrib = 0;
				pCache->attrib (aUrl, 0, 0, nAttrib);
				if (nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN)
				{
					// Check for immediate execution.
					CntMessageBodyItem aItem (WID_MESSAGEBODY, aUrl);
					if (aItem.Get (pCache, m_pImp->GetMailer()))
					{
						// Load message body.
						pSubject->Put (aItem);

						// Finished.
						pJob->Done();
						return NULL;
					}
				}
			}
		}
	}
	return CntNode::InsertJob (pJob);
}

/*
 * ExecuteJob.
 */
const SfxPoolItem* CntNewsBoxNode::ExecuteJob (CntNodeJob *pJob)
{
	// Check Job.
	if (pJob->IsCanceled() || pJob->IsDone())
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Check RequestData.
	CntNewsJob_Impl *pJobImpl = (CntNewsJob_Impl *)(pJob->GetRequestData());
	if (pJobImpl)
	{
		// Execute rescheduled CntNewsJob_Impl.
		return pJobImpl->Execute();
	}

	// Check Subject.
	CntNode *pSubject = pJob->GetSubject();
	if (pSubject == this)
	{
		// Job for ourselfs.
		const SfxPoolItem *pReq = pJob->GetRequest();
		switch (pReq->Which())
		{
			case WID_CREATE_NEW:
				if (pJob->GetClient())
				{
					// Create empty message node.
					CntNodeItem *pNodeItem =
						(CntNodeItem *)(CntNode::ExecuteJob(pJob));
					if (pNodeItem == NULL)
						return NULL;

					CntNode *pNode = pNodeItem->GetValue();
					if (pNode == NULL)
						return pNodeItem;

					// Obtain client.
					CntInterface *pClient = pJob->GetClient();
					if (pClient == NULL)
						return pNodeItem;

					// Feed node with client defaults.
					String aSender (GetSendInfo_Impl (
						*pClient, WID_SEND_FROM_DEFAULT));
					if (aSender.Len())
						pNode->Put (CntNameItem (WID_FROM, aSender));

					String aReply (GetSendInfo_Impl (
						*pClient, WID_SEND_REPLY_TO_DEFAULT));
					if (aReply.Len())
						pNode->Put (CntStringItem (WID_REPLY_TO, aReply));

					const USHORT *pWhich = pCreateNewWhich_Impl;
					while (*pWhich)
					{
						pNode->Put (pClient->Get (*pWhich));
						pWhich++;
					}

					// Done.
					return pNodeItem;
				}
				break;

			case WID_GETDATA:
				if (!m_pImp->IsInitialized())
				{
					// Restore box itemset.
					CntStoreItemSetRef xBoxSet (
						m_pImp->GetBoxDirItemSet (pJob->GetCacheNode()));
					if (xBoxSet.Is())
					{
						Put (*xBoxSet);
						xBoxSet.Clear();
					}

					// Check for ViewData.
					CntStorageNode *pViewData = pJob->GetViewDataNode();
					if (pViewData)
					{
						// Restore ViewData itemset.
						CntStoreItemSetRef xViewSet (
							m_pImp->GetBoxViewItemSet (pViewData));
						if (xViewSet.Is())
						{
							// Check for yet unknown SubscribedCount.
							ULONG nSubscr = ITEMSET_VALUE_UINT32(
								xViewSet, WID_SUBSCRNEWSGROUPCOUNT);
							if (nSubscr == (ULONG)(-1))
							{
								// Set to zero.
								xViewSet->Put (CntUInt32Item (
									WID_SUBSCRNEWSGROUPCOUNT, 0));
							}
							pJob->GetViewDataTarget()->CntInterface::Put (
								*xViewSet);
						}
					}
				}
				break;

			case WID_PUTDATA:
				if (m_pImp->Initialize (pJob))
				{
					// Extract Servername.
					const CntItemListItem *pListItem =
						(const CntItemListItem *)pReq;
					const SfxPoolItem *pItem = NULL;

					String aServername;
					pItem = pListItem->Get (WID_SERVERNAME);
					if (pItem)
						aServername = ITEM_VALUE (CntStringItem, *pItem);

					// Check for exchange.
					CntNodeRef xNode (QueryExchange_Impl (this, aServername));
					if (xNode.Is())
					{
						// Exchanging identity.
						pJob->Broadcast (CntNodeHint (
							xNode, CNT_ACTION_EXCHANGED, pJob));

						// Done.
						pJob->Done();
						return NULL;
					}

					// Extract GroupList.
					pItem = pListItem->Get (WID_NEWS_GROUPLIST);
					if (pItem)
					{
						// Feed back into client (creates GroupList job).
						pJob->GetClient()->Put (*pItem);
					}
				}
				break;

			case WID_CONNECTION_MODE:
				if (m_pImp->Initialize (pJob))
				{
					// Set connection mode.
					CntConnMode eConnMode =
						(CntConnMode)(ITEM_VALUE(CntConnModeItem, *pReq));
					m_pImp->SetConnMode (eConnMode);

					// Done.
					pJob->Done();
					return NULL;
				}
				break;

			case WID_SERVERNAME:
				if (m_pImp->Initialize(pJob))
				{
					// Check for exchange.
					CntNodeRef xNode (QueryExchange_Impl (
						this, ITEM_VALUE (CntStringItem, *pReq)));
					if (xNode.Is())
					{
						// Exchanging identity.
						pJob->Broadcast (CntNodeHint (
							xNode, CNT_ACTION_EXCHANGED, pJob));

						// Done.
						pJob->Done();
						return NULL;
					}
				}
				break;

			case WID_NEWS_GROUPLIST:
				if (m_pImp->Initialize(pJob))
				{
					// Check for exchange.
					CntNodeRef xNode (QueryExchange_Impl (this, String()));
					if (xNode.Is())
					{
						// No CNT_ACTION_EXCHANGED, yet. Do it now.
						pJob->Broadcast (CntNodeHint (
							xNode, CNT_ACTION_EXCHANGED, pJob));

						// Done.
						pJob->Done();
						return NULL;
					}

					// Setup. Check for ...(Get|Put)ListJob.
					if (SAL_STATIC_CAST(const CntFolderListItem *, pReq)->
						  getCommand()
						 == CntFolderListItem::SET)
						pJobImpl= new CntNewsBoxPutListJob_Impl(pJob, m_pImp);
					else
						pJobImpl= new CntNewsBoxGetListJob_Impl(pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_SEARCH:
				if (m_pImp->Initialize (pJob))
				{
					const CntSearchData &rData =
						ITEM_VALUE(CntSearchDataItem, *pReq);
					if (rData.DoSearchFirstLevel())
					{
						// Setup.
						pJobImpl = new CntNewsBoxOpenJob_Impl (pJob, m_pImp);
						pJob->SetRequestData (pJobImpl);

						// Execute.
						return pJobImpl->Execute();
					}
					else
					{
						// Not supported.
						pJob->Cancel();
						return NULL;
					}
				}
				break;

			case WID_OPEN:
				if (m_pImp->Initialize (pJob))
				{
					CntConnMode eConnMode = m_pImp->GetConnMode();
					BOOL bUpdate = (eConnMode == CNT_CONN_MODE_ONLINE);

					CntInterface *pClient = pJob->GetClient();
					bUpdate &= ITEMSET_VALUE_BOOL(
						pClient, WID_FLAG_UPDATE_ON_OPEN);

					// Setup.
					if (bUpdate)
						pJobImpl = new CntNewsBoxUpdateJob_Impl (pJob, m_pImp);
					else
						pJobImpl = new CntNewsBoxOpenJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_UPDATE:
				if (m_pImp->Initialize (pJob))
				{
					// Setup.
					pJobImpl = new CntNewsBoxUpdateJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_SYNCHRONIZE:
				if (m_pImp->Initialize (pJob))
				{
					// Setup.
					pJobImpl = new CntNewsBoxSyncJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_IMPORT:
				if (m_pImp->Initialize(pJob))
				{
					// Setup.
					pJobImpl = new CntNewsBoxImportJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_EXPORT:
				if (m_pImp->Initialize(pJob))
				{
					// Setup.
					pJobImpl = new CntNewsBoxExportJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			default:
				break;
		}
		return CntNode::ExecuteJob (pJob);
	}
	else if (pSubject->ISA(CntNewsMessageNode))
	{
		// Execute job on behalf of a CntNewsMessageNode.
		const SfxPoolItem *pReq = pJob->GetRequest();
		switch (pReq->Which())
		{
			case WID_OPEN:
				if (m_pImp->Initialize(pJob))
				{
					// Setup.
					pJobImpl = new CntNewsMsgOpenJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_IS_READ:
			case WID_IS_MARKED:
				if (m_pImp->Initialize(pJob))
				{
					// Setup.
					pJobImpl = new CntNewsMsgMarkJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			case WID_EXPORT:
				if (m_pImp->Initialize(pJob))
				{
					// Setup.
					pJobImpl = new CntNewsMsgExportJob_Impl (pJob, m_pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				break;

			default:
				break;
		}
		return CntNode::ExecuteJob (pJob);
	}
	else
	{
		// Forward to base class.
		return CntNode::ExecuteJob (pJob);
	}
}

/*
 * Notify.
 */
void CntNewsBoxNode::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNode::Notify (rBC, rHint);
}

/*
 * SetConnMode.
 * (Called by RootNodeMgr after global mode change).
 */
void CntNewsBoxNode::SetConnMode (CntConnMode eNewConnMode)
{
	m_pImp->SetConnMode (eNewConnMode);
}

/*=======================================================================
 *
 * CntNewsGroupNode internals.
 *
 *=====================================================================*/
/*
 * Group Ranges.
 */
static USHORT __READONLY_DATA aNewsGroupRanges_Impl[] =
{
	WID_TITLE,                   WID_TITLE,
	WID_ALL_START,               WID_OPEN,
	WID_CUT,                     WID_COPY,
	WID_HAS_DATA,                WID_UPDATE,
	WID_DUMMY_PROPFOLDERVIEW1,   WID_FLD_COLUMN_INFO,
	WID_MESSAGEVIEW_MODE,        WID_FOLDER_END,
	WID_AUTOUPDATE_INTERVAL,     WID_UPDATE_ENABLED,
	WID_MESSAGE_STOREMODE,       WID_MESSAGE_STOREMODE,
	WID_SERVER_RANGES,           WID_SERVER_RANGES,
	WID_SHOW_MSGS_HAS_TIMELIMIT, WID_SHOW_MSGS_TIMELIMIT,
	WID_PROPERTYLIST,            WID_PROPERTYLIST,
	WID_CLEAN_CACHE,             WID_SEARCH,
	WID_MARKED_DOCUMENT_COUNT,   WID_MARKED_DOCUMENT_COUNT,
	WID_VIEW_START,              WID_VIEW_END,
	WID_SET_AS_DEFAULT,          WID_VIEW2_END,
	WID_FOLDER_START2,           WID_FOLDER_END2,
	WID_VIEW3_START,             WID_VIEW3_END,
	0
};

/*=======================================================================
 *
 * CntNewsGroupNode implementation.
 *
 *=====================================================================*/
/*
 * CntNewsGroupNode.
 */
TYPEINIT1_AUTOFACTORY (CntNewsGroupNode, CntNode);

CntNewsGroupNode::CntNewsGroupNode (void)
	: CntNode (aNewsGroupRanges_Impl)
{
	// Obtain class defaults.
	CntDefaults *pClassDefs = GetDefaults();
	if (pClassDefs == NULL)
	{
		// Create class defaults.
		pClassDefs = new CntDefaults (*this, aNewsGroupRanges_Impl);

		// Set ContentType.
		pClassDefs->Put (CntContentTypeItem (
			WID_CONTENT_TYPE, CONTENT_TYPE_X_CNT_NEWSGROUP));

		// Set Explorer/Browser relevant items.
		pClassDefs->Put (CntBoolItem (WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put (CntBoolItem (WID_FLAG_HAS_MESSAGES, TRUE));

		// Set LayoutItem
		pClassDefs->Put (CntLayoutItem (
			WID_VIEW_LAYOUT_FLDWIN, LAYOUT_MAILNEWS));

		CntViewColumnsListItem aColumnDefs (
			WID_VIEW_COLS_BEAMER,
			WID_FROM,         DEF_WIDTH_FROM,
			WID_TITLE,        DEF_WIDTH_TITLE_MAIL,
			WID_IS_MARKED,    DEF_WIDTH_IS_MARKED,
			WID_IS_READ,      DEF_WIDTH_IS_READ,
			WID_DATE_CREATED, DEF_WIDTH_DATE_CREATED,
			0);

		pClassDefs->Put (aColumnDefs);
		pClassDefs->Put (aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put (aColumnDefs, WID_VIEW_COLS_FLDWIN);

		// Set property tab pages wanted.
		pClassDefs->Put (CntIdentifierListItem (
			WID_PROPERTYLIST,
			CNT_TABPAGE_GENERAL,
			CNT_TABPAGE_RULES,
			CNT_TABPAGE_VIEW_PROPERTIES,
			CNT_TABPAGE_HEADER,
			CNT_TABPAGE_CONTENT_PROPERTIES,
			CNT_TABPAGE_BACKGROUND,
			CNT_TABPAGE_FONT,
			0));

		// Set threading item.
		CntThreadingItem aThrItem (WID_THREADING);
		aThrItem.Append (CntThreadingInfo (
			CNT_THREADING_BY_PARENTCHAIN, WID_FLAG_IS_MESSAGE,
			WID_REFERENCES, WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append (CntThreadingInfo (
			CNT_THREADING_BY_PROPVALUE, WID_FLAG_IS_MESSAGE,
			WID_TITLE, WID_TITLE));
		pClassDefs->Put (aThrItem);
		pClassDefs->Put (CntBoolItem (WID_THREADED, TRUE));

		// Set sorting item.
		CntSortingItem aSortingDefs (WID_SORTING);
		aSortingDefs.Append (CntSortingInfo (WID_DATE_CREATED, FALSE));
		aSortingDefs.Append (CntSortingInfo (WID_TITLE, TRUE));

		pClassDefs->Put (aSortingDefs);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put (aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		// Store class defaults.
		SetDefaults (pClassDefs);
	}
	CntInterface::SetParent (pClassDefs);
}

/*
 * ~CntNewsGroupNode.
 */
CntNewsGroupNode::~CntNewsGroupNode (void)
{
}

/*
 * Register.
 */
CNT_NODE_SUBCLASS_IMPL (CntNewsGroupNode)
{
	/*
	 * Register a dummy factory (pattern never matches).
	 * Helps execute WID_CREATE_NEW directly from CntNewsGroupNode.
	 */
	CntNodeFactory *pFac = new CntNodeFactory (
		String(), String(),
		TYPE (CntNewsMessageNode), CONTENT_TYPE_X_CNT_MESSAGE,
		(CNT_CREATION_FLAG_MESSAGEDOC | CNT_CREATION_FLAG_SENDMESSAGE),
		HID_CHAOS_NEW_NEWS_MSG);
	InsertFactory (pFac);
}

/*
 * Initialize.
 */
CntNode* CntNewsGroupNode::Initialize (
	CntNode *pParent, const String &rNodeURL)
{
	CntNode *pNode = CntNode::Initialize (pParent, rNodeURL);
	if (pNode)
	{
		// Store GroupName as Title.
		INetURLObject aURL (OWN_URL (this));
		String aGroupName (aURL.GetURLPath());
		CNEWSIMP_TRIM_URLPATH (aGroupName);

		Put (CntStringItem (WID_TITLE, aGroupName), WID_TITLE);
	}
	return pNode;
}

/*
 * InsertJob.
 */
const SfxPoolItem* CntNewsGroupNode::InsertJob (CntNodeJob *pJob)
{
	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	switch (pReq->Which())
	{
		case WID_COMPONENT_COMMAND:
			// Not implemented.
			pJob->Done();
			return NULL;

		default:
			break;
	}

	// Forward to base class.
	return CntNode::InsertJob (pJob);
}

/*
 * ExecuteJob.
 */
const SfxPoolItem* CntNewsGroupNode::ExecuteJob (CntNodeJob *pJob)
{
	// Obtain implementation instance.
	CntNewsBoxNode_Impl *pImp = ((CntNewsBoxNode *)(GetParent()))->GetpImp();
	if (!pImp->IsInitialized() && !pImp->Initialize(pJob))
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Check Job.
	if (pJob->IsCanceled() || pJob->IsDone())
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Check RequestData.
	CntNewsJob_Impl *pJobImpl = (CntNewsJob_Impl *)(pJob->GetRequestData());
	if (pJobImpl)
	{
		// Execute rescheduled CntNewsJob_Impl.
		return pJobImpl->Execute();
	}

	// Check Request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	switch (pReq->Which())
	{
		case WID_CREATE_NEW:
			if (pJob->GetClient())
			{
				// Create empty message node.
				CntNodeItem *pNodeItem =
					(CntNodeItem *)(CntNode::ExecuteJob (pJob));
				if (pNodeItem == NULL)
					return NULL;

				CntNode *pNode = pNodeItem->GetValue();
				if (pNode == NULL)
					return pNodeItem;

				// Feed node with group data.
				const String &rGroupName =
					THIS_ITEM_VALUE (CntStringItem, WID_TITLE);
				pNode->Put (CntStringItem (
					WID_NEWSGROUPS, rGroupName));

				// Obtain client.
				CntAnchor *pView = PTR_CAST (CntAnchor, pJob->GetClient());
				if (pView == NULL)
					return pNodeItem;

				// Feed node with box data.
				CntAnchorRef xBoxView (
					new CntAnchor (0, pView->GetRootViewURL()));
				if (!xBoxView.Is())
					return pNodeItem;

				String aSender (GetSendInfo_Impl (
					*xBoxView, WID_SEND_FROM_DEFAULT));
				if (aSender.Len())
					pNode->Put (CntNameItem (WID_FROM, aSender));

				String aReply (GetSendInfo_Impl (
					*xBoxView, WID_SEND_REPLY_TO_DEFAULT));
				if (aReply.Len())
					pNode->Put (CntStringItem (WID_REPLY_TO, aReply));

				const USHORT *pWhich = pCreateNewWhich_Impl;
				while (*pWhich)
				{
					pNode->Put (xBoxView->Get (*pWhich));
					pWhich++;
				}

				// Done.
				return pNodeItem;
			}
			break;

		case WID_GETDATA:
			if (pJob->GetCacheNode (FALSE))
			{
				// Obtain Group properties.
				const String &rGroupName =
					THIS_ITEM_VALUE (CntStringItem, WID_TITLE);

				CntStorageNode *pDirNode = pJob->GetDirectoryNode (FALSE);
				if (pDirNode)
				{
					// Restore OwnProperties.
					Put (pDirNode->Get (WID_TOTALCONTENTCOUNT));
					Put (pDirNode->Get (WID_KNOWN_RANGES));
					Put (pDirNode->Get (WID_SERVER_RANGES));

					const SfxPoolItem *pItem = NULL;
					if (pDirNode->GetItemState (
						WID_MESSAGE_STOREMODE, FALSE, &pItem)
						>= SFX_ITEM_SET)
						Put (*pItem);
				}

				// Seen, Mark and KnownCount.
				ULONG nSeen = 0, nMark = 0;
				ULONG nKnown = THIS_ITEM_VALUE(
					CntUInt32Item, WID_TOTALCONTENTCOUNT);
				if (nKnown == 0)
				{
					const CntRangesItem& rServerRanges =
						(const CntRangesItem&)(Get (WID_SERVER_RANGES));
					nKnown = rServerRanges.TotalCount();
				}

				// UserData itemset.
				CntStorageNode *pUserData = pJob->GetUserDataNode (FALSE);
				if (pUserData)
				{
					CntStoreItemSetRef xUserSet (pUserData->openItemSet (
						aGrpUserRanges_Impl, rGroupName, STREAM_STD_READ));
					if (xUserSet.Is())
					{
						Put (*xUserSet);
						nSeen = ITEMSET_VALUE(
							xUserSet, CntUInt32Item, WID_SEENCONTENTCOUNT);

						const CntRangesItem& rMarkRanges =
							(const CntRangesItem&)
							(xUserSet->Get(WID_MARK_RANGES));
						nMark = rMarkRanges.TotalCount();
					}
					xUserSet.Clear();
				}

				// Seen and marked attributes.
				if (nKnown)
				{
					Put (CntBoolItem (WID_IS_READ,   (nSeen == nKnown)));
					Put (CntBoolItem (WID_IS_MARKED, (nMark == nKnown)));
				}
				else
				{
					// Empty group defined as seen, but not marked.
					Put (CntBoolItem (WID_IS_READ,   TRUE ));
					Put (CntBoolItem (WID_IS_MARKED, FALSE));
				}

				// ViewData attributes.
				CntStorageNode *pViewData = pJob->GetViewDataNode (FALSE);
				if (pViewData)
				{
					UINT32 nAttrib = 0;
					pViewData->attrib (rGroupName, 0, 0, nAttrib);
					if (nAttrib & CNTDIRENTRY_ATTRIB_SUBSCRIBED)
					{
						pJob->GetViewDataTarget ()->CntInterface::Put (
							CntBoolItem (WID_FLAG_SUBSCRIBED, TRUE),
							WID_FLAG_SUBSCRIBED);
					}
				}
			}
			break;

		case WID_SEARCH:
			if (GetParent())
			{
				const CntSearchData &rData =
					ITEM_VALUE(CntSearchDataItem, *pReq);
				if (rData.DoSearchFirstLevel())
				{
					// Setup.
					pJobImpl = new CntNewsGroupOpenJob_Impl (pJob, pImp);
					pJob->SetRequestData (pJobImpl);

					// Execute.
					return pJobImpl->Execute();
				}
				else
				{
					// Not supported.
					pJob->Done();
					return NULL;
				}
			}
			break;

		case WID_OPEN:
			if (GetParent())
			{
				// Setup.
				pJobImpl = new CntNewsGroupOpenJob_Impl (pJob, pImp);
				pJob->SetRequestData (pJobImpl);

				// Execute.
				return pJobImpl->Execute();
			}
			break;

		case WID_UPDATE:
		case WID_SYNCHRONIZE:
			if (GetParent())
			{
				// Setup.
				pJobImpl = new CntNewsGroupUpdateJob_Impl (pJob, pImp);
				pJob->SetRequestData (pJobImpl);

				// Forward to parent.
				GetParent()->InsertJob (pJob);
				return NULL;
			}
			break;

		case WID_PURGE:
		case WID_CLEAN_CACHE:
			if (GetParent())
			{
				// Setup.
				pJobImpl = new CntNewsGroupDeleteJob_Impl (pJob, pImp);
				pJob->SetRequestData (pJobImpl);

				// Execute.
				return pJobImpl->Execute();
			}
			break;

		case WID_IS_READ:
		case WID_IS_MARKED:
			if (GetParent())
			{
				// Setup.
				pJobImpl = new CntNewsGroupMarkJob_Impl (pJob, pImp);
				pJob->SetRequestData (pJobImpl);

				// Execute.
				return pJobImpl->Execute();
			}
			break;

		case WID_FLAG_SUBSCRIBED:
			if (pJob->GetViewDataNode())
			{
				CntInterface *pClient = pJob->GetClient();
				if (!(pClient->Get(WID_FLAG_SUBSCRIBED) == *pReq))
				{
					// Update GroupViewData itemset.
					String aGroupName (THIS_ITEM_VALUE(
						CntStringItem, WID_TITLE));

					CntStorageNode *pViewData = pJob->GetViewDataNode();

					UINT32 nAttrib = 0;
					pViewData->attrib (aGroupName, 0, 0, nAttrib);
					nAttrib &= CNTDIRENTRY_ATTRIB_SUBSCRIBED;

					BOOL bSubscribed = ((const CntBoolItem *)pReq)->GetValue();
					if (bSubscribed)
					{
						if (nAttrib == 0) nAttrib = CNTDIRENTRY_ATTRIB_CREATE;
						nAttrib |= CNTDIRENTRY_ATTRIB_SUBSCRIBED;
					}
					else
					{
						nAttrib &= (UINT32)(~CNTDIRENTRY_ATTRIB_SUBSCRIBED);
					}
					if (nAttrib)
						pViewData->attrib (aGroupName, 0, nAttrib);
					else
						pViewData->remove (aGroupName);

					// Update GroupNode client.
					pJob->GetViewDataTarget ()->CntInterface::Put (
						*pReq, pReq->Which());

					// Update SubscribedCount.
					ULONG nSubscrCount = 0;

					// Obtain BoxViewItemSet.
					CntStoreItemSetRef xViewSet (
						pImp->GetBoxViewItemSet (pViewData));
					if (xViewSet.Is())
					{
						nSubscrCount = ITEMSET_VALUE_UINT32(
							xViewSet, WID_SUBSCRNEWSGROUPCOUNT);
						if (bSubscribed)
							nSubscrCount++;
						else if (nSubscrCount)
							nSubscrCount--;

						// Update ViewSet and Client.
						xViewSet->Put (CntUInt32Item (
							WID_SUBSCRNEWSGROUPCOUNT, nSubscrCount));
					}

					// Obtain BoxClient.
					CntInterface *pBoxClient = pImp->GetBoxClient (pJob);
					if (pBoxClient)
					{
						// Update BoxClient.
						pJob->GetViewDataTarget (pBoxClient)
							->CntInterface::Put (
								CntUInt32Item (
									WID_SUBSCRNEWSGROUPCOUNT, nSubscrCount),
								WID_SUBSCRNEWSGROUPCOUNT);

						// Check BoxClient's CntFolderViewMode.
						USHORT eViewMode = ITEMSET_VALUE(
							pBoxClient, CntFolderViewModeItem,
							WID_FOLDERVIEW_MODE);
						if (eViewMode != CNT_VIEW_ALL_FOLDERS)
						{
							// Remove unsubscribed group.
							if (!bSubscribed)
								pJob->Result (this, CNT_ACTION_REMOVED);
						}
					}
				}

				// Done.
				pJob->Done();
				return NULL;
			}
			break;

		default:
			break;
	}
	return CntNode::ExecuteJob (pJob);
}

/*
 * Notify.
 */
void CntNewsGroupNode::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNode::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntNewsMessageNode implementation.
 *
 *=====================================================================*/
/*
 * CntNewsMessageNode.
 */
TYPEINIT1_AUTOFACTORY (CntNewsMessageNode, CntMessageNode);

CntNewsMessageNode::CntNewsMessageNode (const USHORT *pRanges)
	: CntMessageNode (pRanges),
	  m_nRefCount    (0)
{
	// Disable unwanted items in [WID_ALL_START, WID_ALL_END].
	DisableItem (WID_DELETE);

	// Disable message body (enabled at runtime).
	DisableItem (WID_MESSAGEBODY);
}

/*
 * ~CntNewsMessageNode.
 */
CntNewsMessageNode::~CntNewsMessageNode (void)
{
}

/*
 * Register.
 */
CNT_NODE_SUBCLASS_IMPL (CntNewsMessageNode)
{
	// Nothing to do.
}

/*
 * Initialize.
 */
CntNode* CntNewsMessageNode::Initialize (
	CntNode *pParent, const String &rNodeURL)
{
	CntNode *pNode = CntMessageNode::Initialize (pParent, rNodeURL);
	if (pNode)
	{
		// Store MessageID.
		INetURLObject aOwnUrl (OWN_URL (this));
		CntStringItem aProp (WID_MESSAGE_ID, aOwnUrl.GetMsgId());
		Put (aProp, aProp.Which());
	}
	return pNode;
}

/*
 * IsItemFlag.
 */
FASTBOOL CntNewsMessageNode::IsItemFlag (USHORT nWhich, USHORT nFlag) const
{
	switch (nFlag)
	{
		case CNT_ITEM_AUTO_OWNPROP: // Never.
			return FALSE;
		default:
			break;
	}
	return CntMessageNode::IsItemFlag (nWhich, nFlag);
}

/*
 * GetData_Impl.
 * NOTE: Message itemset NOT in cache (but in group directory).
 */
void CntNewsMessageNode::GetData_Impl (CntStorageNode *pCache)
{
	if (pCache)
	{
		// Obtain message itemset.
		String aMsgID (THIS_ITEM_VALUE (CntStringItem, WID_MESSAGE_ID));

		CntStoreItemSetRef xDirSet (pCache->openItemSet (
			aMsgDirRanges_Impl, aMsgID, STREAM_STD_READ));
		if (xDirSet.Is())
		{
			// Load message itemset.
			CntInterface::Put (*xDirSet);
			xDirSet.Clear();
		}

		// Check message body state.
		if (GetItemState (WID_MESSAGEBODY, FALSE) == SFX_ITEM_DISABLED)
		{
			// Check message body availability.
			if (CntNewsMessage_Impl::queryAvailable (*this, pCache))
			{
				// Enable message body.
				ClearItem (WID_MESSAGEBODY);
			}
		}
	}
}

/*
 * InsertJob.
 */
const SfxPoolItem* CntNewsMessageNode::InsertJob (CntNodeJob *pJob)
{
	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	switch (pReq->Which())
	{
		case WID_GETDATA: // Load Property Job.
			if (pJob->GetCacheNode())
			{
				// Obtain message itemset.
				GetData_Impl (pJob->GetCacheNode());

				// Done.
				pJob->Done();
				return NULL;
			}
			break;

		case WID_OPEN: // Acquire Property Job.
			if (osl_incrementInterlockedCount (&m_nRefCount) <= 0)
			{
				// Release message body.
				ClearItem (WID_MESSAGEBODY);
				pJob->Done();
				return NULL;
			}
			else
			{
				// Obtain message itemset.
				GetData_Impl (pJob->GetCacheNode());

				// Check for immediate execution.
				const CntMessageBodyItem *pItem = NULL;
				GetItemState (
					WID_MESSAGEBODY, FALSE, (const SfxPoolItem**)&pItem);
				if (pItem && pItem->Get())
				{
					// Message body already loaded.
					pJob->Done();
					return NULL;
				}
			}
			break;

		case WID_CLOSE: // Release Property Job.
			if (pReq->ISA(CntInt32Item))
			{
				// Check for multiple release.
				oslInterlockedCount n = ITEM_VALUE(CntInt32Item, *pReq);
				while (n > 0)
				{
					n -= 1;
					if (osl_decrementInterlockedCount (&m_nRefCount) <= 0)
					{
						// Release message body.
						ClearItem (WID_MESSAGEBODY);

						// Finished.
						break;
					}
				}
			}
			else
			{
				// Single release.
				if (osl_decrementInterlockedCount (&m_nRefCount) <= 0)
				{
					// Release message body.
					ClearItem (WID_MESSAGEBODY);
				}
			}
			pJob->Done();
			return NULL;

		case WID_ACTION_LIST: // Store Property Job.
			if (pJob->GetCacheNode())
			{
				// Obtain message itemset.
				CntStorageNode *pCache = pJob->GetCacheNode();
				String aMsgID (THIS_ITEM_VALUE(
					CntStringItem, WID_MESSAGE_ID));

				CntStoreItemSetRef xDirSet (pCache->openItemSet (
					aMsgDirRanges_Impl,
					aMsgID, STREAM_READWRITE | STREAM_NOCREATE));
				if (xDirSet.Is())
				{
					// Update message itemset.
					xDirSet->Put (*pReq);
					xDirSet.Clear();
				}

				// Done.
				Put (*pReq, pReq->Which());
				pJob->Done();
				return NULL;
			}
			break;

		case WID_COMPONENT_COMMAND:
			// Not implemented.
			pJob->Done();
			return NULL;

		default:
			break;
	}

	// Forward to base class.
	return CntMessageNode::InsertJob (pJob);
}

/*
 * Put.
 */
const SfxPoolItem* CntNewsMessageNode::Put (
	const SfxPoolItem &rProp, USHORT nWhich)
{
	if (GetParent())
	{
		switch (nWhich)
		{
			case WID_MESSAGEBODY:
				if (GetItemState (nWhich, FALSE) == SFX_ITEM_DISABLED)
					ClearItem (nWhich);
				break;
			default:
				break;
		}
	}
	return CntInterface::Put (rProp, nWhich);
}

