/*************************************************************************
 *
 *  $RCSfile: cntsfimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <functional>
#include <hash_map>
#include <limits>
#include <utility>

#ifndef _COM_SUN_STAR_SDBC_XCLOSEABLE_HPP_
#include <com/sun/star/sdbc/XCloseable.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XRESULTSET_HPP_
#include <com/sun/star/sdbc/XResultSet.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_CONTENTACTION_HPP_
#include <com/sun/star/ucb/ContentAction.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDPROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTACCESS_HPP_
#include <com/sun/star/ucb/XContentAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIERFACTORY_HPP_
#include <com/sun/star/ucb/XContentIdentifierFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDER_HPP_
#include <com/sun/star/ucb/XContentProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTTASK_HPP_
#include <com/sun/star/ucb/XContentTask.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTTASKENVIRONMENT_HPP_
#include <com/sun/star/ucb/XContentTaskEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_SEARCHINFO_HPP_
#include <com/sun/star/ucb/SearchInfo.hpp>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#ifndef _CNTJOB_HXX
#include <cntjob.hxx>
#endif
#ifndef _CNTRANGE_HXX
#include <cntrange.hxx>
#endif
#ifndef _CNTRNMGR_HXX
#include <cntrnmgr.hxx>
#endif
#ifndef _CNTRULES_HXX
#include <cntrules.hxx>
#endif
#ifndef _CNTSTGND_HXX
#include <cntstgnd.hxx>
#endif
#ifndef _CNTXREF_HXX
#include <cntxref.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <cstritem.hxx>
#endif
#ifndef _ILSTITEM_HXX
#include <ilstitem.hxx>
#endif
#ifndef _CHAOS_MBXFORMT_HXX
#include <mbxformt.hxx>
#endif
#ifndef _RCPNITEM_HXX
#include <rcpnitem.hxx>
#endif
#ifndef CHAOS_SLSTITEM_HXX
#include <slstitem.hxx>
#endif
#ifndef _CHAOS_STORITEM_HXX
#include <storitem.hxx>
#endif
#ifndef CHAOS_TASKBASE_HXX
#include <taskbase.hxx>
#endif
#ifndef CHAOS_THRDTASK_HXX
#include <thrdtask.hxx>
#endif
#ifndef CHAOS_UCBSRVC_HXX
#include <ucbsrvc.hxx>
#endif
#ifndef _ULSTITEM_HXX
#include <ulstitem.hxx>
#endif

#ifndef _CHAOS_CNTSFIMP_HXX
#include <cntsfimp.hxx>
#endif

#undef max // defined in <tools/solar.h>...
#undef min // defined in <tools/solar.h>...

namespace unnamed_chaos_cntsfimp {} using namespace unnamed_chaos_cntsfimp;
    // unnamed namespaces don't work well yet

using namespace chaos;
using namespace com::sun::star;

SV_IMPL_REF(CntStoreItemSet);

//============================================================================
namespace unnamed_chaos_cntsfimp {

/** An attribute used for the search folder directory data item set.
 */
enum { CNTDIRENTRY_ATTRIB_SEARCH_FIRST_OPEN = CNTDIRENTRY_ATTRIB_USER1 };

/** An attribute used for search folder result item sets.
 */
enum { CNTDIRENTRY_ATTRIB_SEARCH_PRESENT = CNTDIRENTRY_ATTRIB_USER1 };

/** The name of the search folder directory data item set.
 */
#define DATA_NAME "DATA"

//============================================================================
struct StringHash: public std::unary_function< rtl::OUString, size_t >
{
	inline size_t operator ()(rtl::OUString const & rString) const
	{ return size_t(rString.hashCode()); }
};

//============================================================================
typedef std::hash_map< rtl::OUString const, bool, StringHash,
	                   std::equal_to< rtl::OUString > >
ResultList;

}

//============================================================================
class CntSearchFolderResultList_Impl
{
	ResultList m_aList;

public:
	ResultList & get() { return m_aList; }
};

//============================================================================
namespace unnamed_chaos_cntsfimp {

class Reconstructor
{
	CntNodeRef m_xSavedGroupDirNode;
	CntNodeRef m_xSavedBoxUserNode;
	String m_aSavedGroupUserID;
	CntStoreItemSetRef m_xSavedGroupUserSet;

public:
	CntNodeRef const & getGroupDirNode(String const & rGroupDirURL);

	CntStoreItemSetRef const & getGroupUserSet(String const & rBoxUserURL,
											   String const & rGroupUserID);
};

//============================================================================
class Task: public ThreadTask
{
	uno::Reference< uno::XInterface > m_xUCB;
	CntSearchFolderImpl & m_rSearchFolder;

protected:
	uno::Reference< ucb::XContent > reconstruct(rtl::OUString const & rURL,
												Reconstructor * pRec);

	CntSearchFolderImpl & getSearchFolder() { return m_rSearchFolder; }

	inline uno::Reference< uno::XInterface > getUCB();

	void result(sal_Int32 nAction,
				uno::Reference< ucb::XContent > const & rContent);

	void addCriteriaToColumns(USHORT nWID);

	inline Task(CntNodeJob & rJob, CntSearchFolderImpl & rTheSearchFolder);

public:
	uno::Reference< ucb::XContentTask > getContentTask();
};

inline uno::Reference< uno::XInterface > Task::getUCB()
{
	if (!m_xUCB.is())
		m_xUCB = CntUCB::get();
	return m_xUCB;
}

inline Task::Task(CntNodeJob & rJob, CntSearchFolderImpl & rTheSearchFolder):
	ThreadTask(rJob, *rJob.GetSubject()), m_rSearchFolder(rTheSearchFolder)
{}

//============================================================================
class OpenTask: public Task
{
	CntStorageIterator m_aCacheIter;
	Reconstructor m_aRec;
	ResultList::const_iterator m_aListIter;
	CntStorageNode * m_pCache;
	bool m_bInitialized;
	bool m_bUpdate;

	virtual SfxPoolItem const * execute();

public:
	OpenTask(CntNodeJob & rJob, CntSearchFolderImpl & rSearchFolder):
		Task(rJob, rSearchFolder), m_bInitialized(false) {}
};

//============================================================================
class CommandEnvironment: public cppu::OWeakObject,
						  public ucb::XCommandEnvironment
{
	uno::Reference< task::XInteractionHandler > m_xInteractionHandler;

public:
	CommandEnvironment(uno::Reference< task::XInteractionHandler > const &
					       rTheInteractionHandler):
		m_xInteractionHandler(rTheInteractionHandler) {}

    virtual uno::Any SAL_CALL queryInterface(uno::Type const & rType)
		throw (uno::RuntimeException);

	virtual void SAL_CALL acquire() throw (uno::RuntimeException)
	{ OWeakObject::acquire(); }

	virtual void SAL_CALL release() throw (uno::RuntimeException)
	{ OWeakObject::release(); }

    virtual uno::Reference< task::XInteractionHandler > SAL_CALL
	getInteractionHandler() throw (uno::RuntimeException)
	{ return m_xInteractionHandler; }

    virtual uno::Reference< ucb::XProgressHandler > SAL_CALL
	getProgressHandler() throw (uno::RuntimeException) { return 0; }
};

//============================================================================
class UpdateTask: public Task
{
	enum State { STATE_INIT, STATE_SEARCH, STATE_REMOVE };

	uno::Reference< ucb::XCommandEnvironment > m_xCommandEnvironment;
	uno::Reference< sdbc::XResultSet > m_xResultSet;
	uno::Reference< ucb::XContentAccess > m_xContentAccess;
	CntSearchData * m_pData;
	CntStorageNode * m_pCache;
	sal_uInt32 m_nOldTotal;
	sal_uInt32 m_nMax;
	sal_uInt32 m_nNewCount;
	sal_uInt32 m_nNewTotal;
	sal_uInt32 m_nLocationIter;
	State m_eState;
	bool m_bRemove;
	bool m_bExactTotal;

	bool notifyResult(uno::Reference< ucb::XContent > const & rContent);

	void updateTotalCount();

	virtual SfxPoolItem const * execute();

	virtual void finished(bool bCanceled);

public:
	inline UpdateTask(CntNodeJob & rJob, CntSearchFolderImpl & rSearchFolder);

	virtual ~UpdateTask() { delete m_pData; }
};

inline UpdateTask::UpdateTask(CntNodeJob & rJob,
							  CntSearchFolderImpl & rSearchFolder):
	Task(rJob, rSearchFolder),
	m_pData(0),
	m_pCache(0),
	m_bRemove(false),
	m_nOldTotal(0),
	m_nNewTotal(0),
	m_bExactTotal(true),
	m_eState(STATE_INIT)
{}

//============================================================================
/** A ranges array for the search folder directory data item set.
 */
USHORT const aDirectoryItemSetRanges[]
    = { WID_TOTALCONTENTCOUNT, WID_TOTALCONTENTCOUNT, 0 };

}

//============================================================================
//
//  CntSearchFolderImpl
//
//============================================================================

void CntSearchFolderImpl::createStorageData(CntStorageNode & rDirectory)
{
	CntStoreItemSetRef
		xDataSet(rDirectory.
				     openItemSet(aDirectoryItemSetRanges,
								 String::CreateFromAscii(
									 RTL_CONSTASCII_STRINGPARAM(DATA_NAME)),
								 STREAM_STD_WRITE));
	if (xDataSet.Is())
	{
		rDirectory.attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
			                                          DATA_NAME)),
						  0,
						  CNTDIRENTRY_ATTRIB_HIDDEN
						      | CNTDIRENTRY_ATTRIB_SEARCH_FIRST_OPEN);
		xDataSet->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT, 0));
	}
}

//============================================================================
CntSearchFolderImpl::~CntSearchFolderImpl()
{
	delete m_pResultList;
}

//============================================================================
void CntSearchFolderImpl::initialize(CntNodeJob & rJob)
{
	if (m_bInitialized)
		return;
	m_bInitialized = true;

	if (!m_rSearchFolderNode.IsDummy())
	{
		CntStorageNode * pDirectory = rJob.GetCacheNode(false);
		if (pDirectory)
		{
			m_rSearchFolderNode.Put(pDirectory->Get(WID_SEARCH_CRITERIA));
			m_rSearchFolderNode.Put(pDirectory->Get(WID_SEARCH_LOCATIONS));
			m_rSearchFolderNode.Put(pDirectory->Get(WID_SEARCH_RECURSIVE));
			m_rSearchFolderNode.Put(pDirectory->Get(WID_SEARCH_FOLDER_VIEW));
			m_rSearchFolderNode.Put(pDirectory->
									    Get(WID_SEARCH_DOCUMENT_VIEW));
			m_rSearchFolderNode.Put(pDirectory->Get(WID_SEARCH_INDIRECTIONS));
			CntStoreItemSetRef
				xDataSet(pDirectory->
						     openItemSet(aDirectoryItemSetRanges,
										 String::CreateFromAscii(
											 RTL_CONSTASCII_STRINGPARAM(
												 DATA_NAME)),
										 STREAM_STD_READ));
			if (xDataSet.Is())
				m_rSearchFolderNode.Put(xDataSet->Get(WID_TOTALCONTENTCOUNT));
			else
			{
				createStorageData(*pDirectory);
				m_rSearchFolderNode.Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
													  0));
			}
		}
		else
		{
			m_pResultList = new CntSearchFolderResultList_Impl;
			m_rSearchFolderNode.Put(CntUInt32Item(WID_TOTALCONTENTCOUNT, 0));
		}
	}
}

//============================================================================
void CntSearchFolderImpl::forceStorageFile(String const & rFolderURL)
{
	String aStorageURL(RTL_CONSTASCII_USTRINGPARAM(STG_PROTOCOL_CACHE));
	aStorageURL += rFolderURL;
	CntNodeRef xDirectory(CntRootNodeMgr::Get()->Query(aStorageURL));
	if (xDirectory.Is()
		&& static_cast< CntStorageNode * >(&xDirectory)->
		           attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
					                                  DATA_NAME)),
						  0, 0)
		       == ERRCODE_IO_NOTEXISTS)
		createStorageData(*static_cast< CntStorageNode * >(&xDirectory));
}

//============================================================================
String const & CntSearchFolderImpl::getUniqueID()
{
	if (m_aUniqueID.Len() == 0)
	{
		DateTime aCurDateTime;
		m_aUniqueID = String::CreateFromInt64(aCurDateTime.GetDate());
		m_aUniqueID += String::CreateFromInt32(aCurDateTime.GetTime());
		m_aUniqueID
			+= String::CreateFromInt64(reinterpret_cast< sal_uInt32 >(this));
	}
	return m_aUniqueID;
}

//============================================================================
SfxPoolItem const * CntSearchFolderImpl::execInsertSearchLocation(CntNodeJob &
																      rJob)
{
	String aURL(ITEMSET_VALUE(rJob.GetClient(), CntStringItem, WID_TITLE));
	List const * pOldList
	    = static_cast< CntStringListItem const * >(
			      &m_rSearchFolderNode.Get(WID_SEARCH_LOCATIONS))->
		      GetList();
	if (pOldList)
		for (sal_uInt32 i = 0; i < pOldList->Count(); ++i)
			if (aURL == *reinterpret_cast< String const * >(pOldList->
													       GetObject(i)))
			{
				rJob.Done();
				return 0;
			}
	List aNewList;
	if (pOldList)
		for (sal_uInt32 i = 0; i < pOldList->Count(); ++i)
			aNewList.Insert(new String(*reinterpret_cast< String const * >(
				                            pOldList->GetObject(i))),
							LIST_APPEND);
	aNewList.Insert(new String(aURL), LIST_APPEND);
	CntAnchorRef xAnchor(new CntAnchor(0, &m_rSearchFolderNode));
	xAnchor->Put(CntStringListItem(WID_SEARCH_LOCATIONS, &aNewList));
	while (aNewList.Count() > 0)
		delete static_cast< String * >(aNewList.Remove(aNewList.Count() - 1));
	rJob.Done();
	return 0;
}

//============================================================================
SfxPoolItem const * CntSearchFolderImpl::execOpen(CntNodeJob & rJob)
{
	return (new OpenTask(rJob, *this))->run();
}

//============================================================================
SfxPoolItem const * CntSearchFolderImpl::execUpdate(CntNodeJob & rJob)
{
	return (new UpdateTask(rJob, *this))->run();
}

//============================================================================
//
//  Reconstructor
//
//============================================================================

CntNodeRef const & Reconstructor::getGroupDirNode(String const & rGroupDirURL)
{
	if (m_xSavedGroupDirNode.Is()
		|| OWN_URL(m_xSavedGroupDirNode) != rGroupDirURL)
		m_xSavedGroupDirNode = CntRootNodeMgr::Get()->Query(rGroupDirURL);
	return m_xSavedGroupDirNode;
}

//============================================================================
CntStoreItemSetRef const & Reconstructor::getGroupUserSet(String const &
														      rBoxUserURL,
														  String const &
														      rGroupUserID)
{
	if (m_xSavedBoxUserNode.Is()
		|| OWN_URL(m_xSavedBoxUserNode) != rBoxUserURL)
	{
		m_xSavedBoxUserNode = CntRootNodeMgr::Get()->Query(rBoxUserURL);
		m_aSavedGroupUserID.Erase();
		m_xSavedGroupUserSet = 0;
	}
	if (m_xSavedBoxUserNode.Is() && m_aSavedGroupUserID != rGroupUserID)
	{
		m_xSavedGroupUserSet
			= static_cast< CntStorageNode * >(&m_xSavedBoxUserNode)->
			      openItemSet(rGroupUserID);
		if (m_xSavedGroupUserSet.Is())
			m_aSavedGroupUserID = rGroupUserID;
	}
	return m_xSavedGroupUserSet;
}

//============================================================================
//
//  Task
//
//============================================================================

uno::Reference< ucb::XContent > Task::reconstruct(rtl::OUString const & rURL,
												  Reconstructor * pRec)
{
	rtl::OUString aContentID = rURL;
	CntNodeRef xNode;
	if (pRec)
	{
		String aTheURL(rURL);
		if (aTheURL.EqualsAscii("x-nntp+id://", 0,
								RTL_CONSTASCII_LENGTH("x-nntp+id://")))
		{
			xub_StrLen nFirstSlash
				= aTheURL.Search('/', RTL_CONSTASCII_LENGTH("x-nntp+id://"));
			if (nFirstSlash != STRING_NOTFOUND)
			{
				xub_StrLen nSecondSlash = aTheURL.Search('/',
														 nFirstSlash + 1);
				if (nSecondSlash != STRING_NOTFOUND)
				{
					xub_StrLen nThirdSlash = aTheURL.Search('/',
															nSecondSlash + 1);
					if (nThirdSlash != STRING_NOTFOUND)
					{
						String aArticleURL(RTL_CONSTASCII_USTRINGPARAM(
							                   "news://"));
						aArticleURL += aTheURL.Copy(12, nFirstSlash - 11);
						aArticleURL += '<';
						aArticleURL += aTheURL.Copy(nThirdSlash + 1);
						aArticleURL += '>';
						aContentID = aArticleURL;

						xNode = CntRootNodeMgr::Get()->Query(aArticleURL);
						if (xNode.Is())
						{
							String aArticleNumber(aTheURL, nSecondSlash + 1,
												  nThirdSlash - nSecondSlash
												      - 1);

							sal_Unicode const * p
								= aArticleNumber.GetBuffer();
							sal_Unicode const * pEnd
								= p + aArticleNumber.Len();
							sal_uInt32 nNumber;
							bool bNumericArticleNumber
								= INetMIME::scanUnsigned(p, pEnd, true,
														 nNumber)
								  && p == pEnd;

							String aGroupDirURL(RTL_CONSTASCII_USTRINGPARAM(
								                    STG_PROTOCOL_CACHE
													    "news://"));
							aGroupDirURL += aTheURL.Copy(12,
														 nSecondSlash - 12);
							CntNodeRef xGroupDirNode(pRec->getGroupDirNode(
								                               aGroupDirURL));
							if (xGroupDirNode.Is())
							{
								String aID('<');
								aID += aTheURL.Copy(nThirdSlash + 1);
								aID += '>';
								CntStoreItemSetRef
									xMsgDirSet(
										static_cast< CntStorageNode * >(
											    &xGroupDirNode)->
										    openItemSet(aID,
														STREAM_STD_READ));
								if (xMsgDirSet.Is())
									xNode->Put(*xMsgDirSet);
								else if (bNumericArticleNumber)
								{
									aID.AssignAscii(
										    RTL_CONSTASCII_STRINGPARAM("M:"));
									aID += aArticleNumber;
									xMsgDirSet
										= static_cast< CntStorageNode * >(
											      &xGroupDirNode)->
										      openItemSet(aID,
														  STREAM_STD_READ);
									if (xMsgDirSet.Is())
										xNode->Put(*xMsgDirSet);
								}
							}

							if (bNumericArticleNumber)
							{
								String
									aBoxUserURL(RTL_CONSTASCII_USTRINGPARAM(
										            STG_PROTOCOL_USER
													    "news://"));
								aBoxUserURL += aTheURL.Copy(12,
															nFirstSlash - 11);
								CntStoreItemSetRef
									xGroupUserSet(
										pRec->
										    getGroupUserSet(
												aBoxUserURL,
												aTheURL.Copy(nFirstSlash + 1,
															 nSecondSlash
														         - nFirstSlash
														         - 1)));
								if (xGroupUserSet.Is())
								{
									xNode->
										Put(CntBoolItem(
											    WID_IS_READ,
												static_cast
												    < CntRangesItem const * >(
														&xGroupUserSet->
													   Get(WID_READ_RANGES))->
												    IsWithinRanges(nNumber)));
									xNode->
										Put(CntBoolItem(
											    WID_IS_MARKED,
												static_cast
												    < CntRangesItem const * >(
														&xGroupUserSet->
													   Get(WID_MARK_RANGES))->
												    IsWithinRanges(nNumber)));
								}
							}
						}
					}
				}
			}
		}
	}

	uno::Reference< ucb::XContentProvider >
		xProvider(getUCB(), uno::UNO_QUERY);
	uno::Reference< ucb::XContentIdentifierFactory >
		xIDFactory(getUCB(), uno::UNO_QUERY);
	uno::Reference< ucb::XContentIdentifier > xID;
	if (xIDFactory.is())
		xID = xIDFactory->createContentIdentifier(aContentID);
	uno::Reference< ucb::XContent > xContent;
	if (xProvider.is() && xID.is())
		try
		{
			xContent = xProvider->queryContent(xID);
		}
		catch (ucb::IllegalIdentifierException) {}
	return xContent;
}

//============================================================================
void Task::result(sal_Int32 nAction,
				  uno::Reference< ucb::XContent > const & rContent)
{
	if (rContent.is() && getJob().getTaskBase())
	{
		uno::Reference< ucb::XContent >
			xParent(getJob().getTaskBase()->getContent());
		uno::Reference< ucb::XContentIdentifier > xParentID;
		if (xParent.is())
			xParentID = xParent->getIdentifier();
		getJob().getTaskBase()->notifyContentEvent(nAction, rContent,
												   xParentID);
	}
}

//============================================================================
void Task::addCriteriaToColumns(USHORT nWID)
{
	CntViewColumnsListItem const & rOldColumns
		= *static_cast< CntViewColumnsListItem const * >(
			   &getJob().GetClient()->Get(nWID));
	CntViewColumnsListItem * pNewColumns = 0;
	CntViewColumnsListItem const * pColumns = &rOldColumns;
	CntNodeRuleSet const & rCriteria
		= static_cast< CntRuleSetItem const * >(
			      &getJob().GetSubject()->Get(WID_SEARCH_CRITERIA))->
		      GetRuleSet();
	for (sal_uInt32 i = 0; i < rCriteria.RuleCount(); ++i)
	{
		CntNodeRule const * pRule = rCriteria.GetRule(i);
		for (sal_uInt32 j = 0; j < pRule->TermCount(); ++j)
		{
			USHORT nColumnWID = pRule->GetTerm(j)->GetPropertySID();
			for (USHORT k = 0;; k += 2)
				if (k == pColumns->Count())
				{
					if (!pNewColumns)
					{
						pNewColumns = new CntViewColumnsListItem(rOldColumns);
						pColumns = pNewColumns;
					}
					pNewColumns->Append(nColumnWID);
					SfxPoolItem const & rType
						= getJob().GetClient()->GetPool()->
						      GetDefaultItem(nColumnWID);
					USHORT nWidth = DEF_WIDTH_FROM;
					if (!rType.ISA(CntUnencodedStringItem))
						if (rType.ISA(CntBoolItem))
							nWidth = DEF_WIDTH_IS_MARKED;
						else if (rType.ISA(SfxDateTimeItem))
							nWidth = DEF_WIDTH_DATE_CREATED;
						else if (rType.ISA(CntUInt16Item)
								 || rType.ISA(CntUInt32Item))
							nWidth = DEF_WIDTH_DOCUMENT_SIZE;
						else if (rType.ISA(CntPriorityItem))
							nWidth = DEF_WIDTH_PRIORITY;
						else if (rType.ISA(CntRecipientListItem))
							nWidth = DEF_WIDTH_RECIPIENTLIST;
					pNewColumns->Append(nWidth);
					break;
				}
				else if ((*pColumns)[k] == nColumnWID)
					break;
		}
	}
	if (pNewColumns)
	{
		if (!getJob().GetViewDataNode())
		{
			CntAnchor * pAnchor = PTR_CAST(CntAnchor, getJob().GetClient());
			CntNode * pNode = pAnchor ? pAnchor->GetNode() :
				                        PTR_CAST(CntNode,
												 getJob().GetClient());
			if (pNode)
				pNode->CntInterface::Put(*pNewColumns, nWID);
		}
		else
			getJob().GetClient()->Put(*pNewColumns);
		delete pNewColumns;
	}
}

//============================================================================
uno::Reference< ucb::XContentTask > Task::getContentTask()
{
	if (getJob().getTaskBase())
		return getJob().getTaskBase()->getContentTask();
	return 0;
}

//============================================================================
//
//  OpenTask
//
//============================================================================

// virtual
SfxPoolItem const * OpenTask::execute()
{
	if (!m_bInitialized)
	{
		if (getSearchFolder().getResultList())
		{
			m_pCache = 0;
			m_bUpdate = false;
			m_aListIter = getSearchFolder().getResultList()->get().begin();
		}
		else
		{
			m_pCache = getJob().GetCacheNode();
			if (!m_pCache)
			{
				cancel();
				return 0;
			}
			UINT32 nAttrib = 0;
			m_pCache->
				attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
					       DATA_NAME)),
					   0, 0, nAttrib);
			m_pCache->
				attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
					       DATA_NAME)),
					   CNTDIRENTRY_ATTRIB_SEARCH_FIRST_OPEN, 0);
			m_bUpdate = (nAttrib & CNTDIRENTRY_ATTRIB_SEARCH_FIRST_OPEN) != 0;
		}

		if (CntAnchor * pAnchor = PTR_CAST(CntAnchor, getJob().GetClient()))
			pAnchor->SetInitSubAnchors();

		addCriteriaToColumns(WID_VIEW_COLS_BEAMER);
		addCriteriaToColumns(WID_VIEW_COLS_FILEDLG);
		addCriteriaToColumns(WID_VIEW_COLS_FLDWIN);

		m_bInitialized = true;
		reschedule();
		return 0;
	}

	startTimeSlice();
	if (m_pCache)
		for (;;)
		{
			String aID(m_pCache->iter(m_aCacheIter));
			if (m_aCacheIter.eof())
				break;
			result(ucb::ContentAction::INSERTED, reconstruct(aID, &m_aRec));
			if (checkTimeSliceExhausted())
			{
				reschedule();
				return 0;
			}
		}
	else
		while (m_aListIter != getSearchFolder().getResultList()->get().end())
		{
			result(ucb::ContentAction::INSERTED,
				   reconstruct(m_aListIter->first, &m_aRec));
			++m_aListIter;
			if (checkTimeSliceExhausted())
			{
				reschedule();
				return 0;
			}
		}

	done();
	if (m_bUpdate
		|| ITEMSET_VALUE(getJob().GetClient(), CntBoolItem,
						 WID_FLAG_UPDATE_ON_OPEN))
		getJob().GetClient()->Put(SfxVoidItem(WID_UPDATE));
	return 0;
}

//============================================================================
//
//  CommandEnvironment
//
//============================================================================

// virtual
uno::Any SAL_CALL CommandEnvironment::queryInterface(uno::Type const & rType)
	throw (uno::RuntimeException)
{
	uno::Any
		aRet(cppu::queryInterface(rType,
								  static_cast< ucb::XCommandEnvironment * >(
									  this)));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

//============================================================================
//
//  UpdateTask
//
//============================================================================

bool UpdateTask::notifyResult(uno::Reference< ucb::XContent > const &
							      rContent)
{
	rtl::OUString aID;
	uno::Reference< ucb::XContentIdentifier >
		xIdentifier(rContent->getIdentifier());
	if (xIdentifier.is())
		aID = xIdentifier->getContentIdentifier();

	// If the URL is of the (by RFC 1738 illegal!) form
	//  "news://" <host> [":" <port>] "/<" <message-id> ">"
	// change it into
	//  "x-nntp+id://" <host> [":" <port>] "/" <newsgroup-name> "/"
	//   <article-number> "/" <message-id>
	// to be able to reconstruct the message from the News Service's storages
	// later on:
	if (xIdentifier.is()
		&& xIdentifier->getContentProviderScheme().compareToAscii("news") == 0
		&& aID.getStr()[aID.getLength() - 1] == '>')
	{
		String aInternalURL(aID);
		CntNodeRef xNode(CntRootNodeMgr::Get()->Query(aInternalURL, false));
		if (xNode.Is())
		{
			xub_StrLen nSlash = aInternalURL.SearchAscii("/<", 7);
			if (nSlash != STRING_NOTFOUND)
			{
				aInternalURL.Erase(aInternalURL.Len() - 1);
				aInternalURL.Erase(nSlash + 1, 1);
				CntItemListItem const & rXref
					= *static_cast< CntItemListItem const * >(
						   &xNode->Get(WID_NEWS_XREFLIST));
				if (rXref.Count() > 0)
				{
					CntCrossReferenceItem const & rRef
						= *static_cast< CntCrossReferenceItem const * >(
							   &rXref[0]);
					aInternalURL.
						Insert(String::CreateFromInt64(rRef.GetIndex()),
							   nSlash);
					aInternalURL.Insert('/', nSlash);
					aInternalURL.Insert(rRef.GetGroup(), nSlash);
				}
				else
				{
					CntMBXAtomTable aAtomTable;
					CntMBXStringScanner
						aScanner(ByteString(ITEMSET_VALUE(xNode,
														  CntStringItem,
														  WID_NEWSGROUPS),
											RTL_TEXTENCODING_UTF8));
					ByteString aGroup;
					for (;;)
					{
						CntMBXToken aToken;
						if (aScanner.scan(aToken, aAtomTable))
							break;
						switch (aToken.getType())
						{
							case CntMBXToken::TYPE_ATOM:
								aGroup += aToken.getAtom()->getName();
								break;

							case CntMBXToken::TYPE_SPECIAL:
								switch (aToken.getCharValue())
								{
									case '.':
										aGroup += '.';
										break;

									default:
										goto done;
								}
								break;

							case CntMBXToken::TYPE_END:
								goto done;
						}
					}
				done:
					aInternalURL.InsertAscii("/-", nSlash);
					aInternalURL.InsertAscii(aGroup.GetBuffer(), nSlash);
				}

				aInternalURL.Insert('/', nSlash);
				aInternalURL.
					ReplaceAscii(0, 4,
								 RTL_CONSTASCII_STRINGPARAM("x-nntp+id"));
				aID = aInternalURL;
			}
		}
	}

	bool bPresent;
	if (aID.getLength() == 0)
		bPresent = false;
	else if (m_pCache)
	{
		bPresent = m_pCache->attrib(aID, 0, 0) == ERRCODE_NONE;
		m_pCache->attrib(aID, 0,
						 m_bRemove ? CNTDIRENTRY_ATTRIB_CREATE
						                 | CNTDIRENTRY_ATTRIB_SEARCH_PRESENT :
						             CNTDIRENTRY_ATTRIB_CREATE);
	}
	else
	{
		std::pair< ResultList::iterator, bool >
			aInsert(getSearchFolder().getResultList()->
					    get().insert(std::pair< rtl::OUString const, bool >(
							             aID, m_bRemove)));
		if (aInsert.second)
			bPresent = false;
		else
		{
			aInsert.first->second = m_bRemove;
			bPresent = true;
		}
	}
	if (!bPresent)
		++m_nNewTotal;

	bool bContinue = bPresent && !m_bRemove || ++m_nNewCount < m_nMax;
	result(ucb::ContentAction::INSERTED, rContent);

	if (!bContinue)
		m_bExactTotal = !m_bRemove;
	return bContinue;
}

//============================================================================
void UpdateTask::updateTotalCount()
{
	if (m_bExactTotal ? m_nNewTotal != m_nOldTotal :
		                m_nNewTotal > m_nOldTotal)
	{
		if (m_pCache)
		{
			CntStoreItemSetRef
				xItemSet(m_pCache->openItemSet(aDirectoryItemSetRanges,
											   String::CreateFromAscii(
												   RTL_CONSTASCII_STRINGPARAM(
													   DATA_NAME)),
											   STREAM_STD_WRITE));
			if (xItemSet.Is())
				xItemSet->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
											m_nNewTotal));
		}
		getJob().GetSubject()->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
												 m_nNewTotal));
	}
}

//============================================================================
// virtual
SfxPoolItem const * UpdateTask::execute()
{
	switch (m_eState)
	{
		case STATE_INIT:
		{
			if (!getSearchFolder().getResultList())
			{
				m_pCache = getJob().GetCacheNode(false);
				if (!m_pCache)
				{
					cancel();
					return 0;
				}
				m_pCache->
					attrib(String::CreateFromAscii(
						       RTL_CONSTASCII_STRINGPARAM(DATA_NAME)),
						   CNTDIRENTRY_ATTRIB_SEARCH_FIRST_OPEN, 0);
			}

			bool bUpdate = getJob().GetRequest()->Which() == WID_UPDATE;
			m_nOldTotal = ITEMSET_VALUE(getJob().GetSubject(), CntUInt32Item,
										WID_TOTALCONTENTCOUNT);
			m_nNewTotal = m_nOldTotal;
			m_nMax = ITEMSET_VALUE(getJob().GetClient(), CntBoolItem,
								   WID_SHOW_MSGS_HAS_TIMELIMIT) ?
				         ITEMSET_VALUE(getJob().GetClient(), CntUInt16Item,
									   WID_SHOW_MSGS_TIMELIMIT) :
				         std::numeric_limits< sal_uInt32 >::max();
			if (bUpdate && m_nOldTotal >= m_nMax)
			{
				done();
				break;
			}

			List const * pLocations
				= static_cast< CntStringListItem const * >(
					      &getJob().GetSubject()->Get(WID_SEARCH_LOCATIONS))->
				      GetList();
			CntNodeRuleSet const & rCriteria
				= static_cast< CntRuleSetItem const * >(
					      &getJob().GetSubject()->Get(WID_SEARCH_CRITERIA))->
				      GetRuleSet();
			if (bUpdate
				&& (pLocations->Count() == 0 || rCriteria.RuleCount() == 0))
			{
				done();
				break;
			}

			CntNodeRuleSet * pCopiedCriteria = new CntNodeRuleSet;
			for (sal_uInt32 i = 0; i < rCriteria.RuleCount(); ++i)
			{
				CntNodeRule const * pRule = rCriteria.GetRule(i);
				DBG_ASSERT(pRule->GetAction() == CNT_NODE_ACTION_NONE
						   || pRule->GetAction() == CNT_NODE_ACTION_SHOW,
						   "UpdateTask::Execute(): Bad rule");
				CntNodeRule * pCopiedRule
					= new CntNodeRule(pCopiedCriteria, CNT_NODE_ACTION_SHOW);
				for (sal_uInt32 j = 0; j < pRule->TermCount(); ++j)
					pCopiedRule->
						InsertTerm(new CntNodeRuleTerm(*pRule->GetTerm(j)));
				pCopiedCriteria->InsertRule(pCopiedRule);
			}

			m_pData
				= new CntSearchData(pCopiedCriteria,
									ITEMSET_VALUE(getJob().GetSubject(),
												  CntBoolItem,
												  WID_SEARCH_RECURSIVE) ?
									    CntSearchData::RECURS_DEEP :
									    CntSearchData::RECURS_ONE_LEVEL,
									true,
									ITEMSET_VALUE(getJob().GetSubject(),
												  CntBoolItem,
												  WID_SEARCH_FOLDER_VIEW)
									    != false,
									ITEMSET_VALUE(getJob().GetSubject(),
												  CntBoolItem,
												  WID_SEARCH_DOCUMENT_VIEW)
									    != false,
									ITEMSET_VALUE(getJob().GetSubject(),
												  CntBoolItem,
												  WID_SEARCH_INDIRECTIONS)
									    != false);

			uno::Reference< ucb::XContentTask >
				xContentTask(getContentTask());
			uno::Reference< ucb::XContentTaskEnvironment >
				xContentTaskEnvironment;
			if (xContentTask.is())
				xContentTaskEnvironment = xContentTask->getEnvironment();
			uno::Reference< task::XInteractionHandler > xHandler;
			if (xContentTaskEnvironment.is())
				xHandler = xContentTaskEnvironment->getInteractionHandler();
			m_xCommandEnvironment = new CommandEnvironment(xHandler);

			m_nNewCount = bUpdate ? m_nOldTotal : 0;
			m_bRemove = !bUpdate;

			if (CntAnchor * pAnchor
				    = PTR_CAST(CntAnchor, getJob().GetClient()))
				pAnchor->SetInitSubAnchors();

			addCriteriaToColumns(WID_VIEW_COLS_BEAMER);
			addCriteriaToColumns(WID_VIEW_COLS_FILEDLG);
			addCriteriaToColumns(WID_VIEW_COLS_FLDWIN);

			if (pLocations->Count() == 0)
				m_eState = STATE_REMOVE;
			else
			{
				m_bExactTotal = false;
				m_nLocationIter = 0;
				m_eState = STATE_SEARCH;
			}

			reschedule();
			break;
		}

		case STATE_SEARCH:
			startTimeSlice();
			for(;;)
			{
				if (!m_xResultSet.is())
				{
					List const * pLocations
						= static_cast< CntStringListItem const * >(
							      &getJob().GetSubject()->
								       Get(WID_SEARCH_LOCATIONS))->
						      GetList();
					if (m_nLocationIter >= pLocations->Count())
					{
						m_eState = STATE_REMOVE;
						reschedule();
						break;
					}
					String aURL(*reinterpret_cast< String const * >(
						             pLocations->
									     GetObject(m_nLocationIter++)));

					uno::Reference< ucb::XContentIdentifierFactory >
						xIDFactory(getUCB(), uno::UNO_QUERY);
					uno::Reference< ucb::XContentIdentifier > xID;
					if (xIDFactory.is())
						xID = xIDFactory->createContentIdentifier(aURL);
					uno::Reference< ucb::XContentProvider >
						xProvider(getUCB(), uno::UNO_QUERY);
					uno::Reference< ucb::XCommandProcessor > xProcessor;
					if (xProvider.is() && xID.is())
						try
						{
							xProcessor
								= uno::Reference< ucb::XCommandProcessor >(
									  xProvider->queryContent(xID),
									  uno::UNO_QUERY);
						}
						catch (ucb::IllegalIdentifierException)
						{
							// handleError(exception)
						}

					if (xProcessor.is())
					{
						ucb::Command aCommand;
						aCommand.Name
							= rtl::OUString::createFromAscii("search");
						aCommand.Handle = -1;
						ucb::SearchInfo aInfo;
						m_pData->queryValue(aInfo);
						aCommand.Argument <<= aInfo;
						uno::Any aResult;
						try
						{
							aResult
								= xProcessor->execute(aCommand, 0,
													  m_xCommandEnvironment);
						}
						catch (uno::Exception) //@@@
						{
							// handleError(exception)
						}
						aResult >>= m_xResultSet;
					}

					m_xContentAccess = uno::Reference< ucb::XContentAccess >(
						                   m_xResultSet, uno::UNO_QUERY);
					if (!(m_xResultSet.is() && m_xContentAccess.is()))
					{
						m_xResultSet = 0;
						m_xContentAccess = 0;
						// handleError(...)
					}

					if (checkTimeSliceExhausted())
					{
						reschedule();
						break;
					}
				}

				if (m_xResultSet.is())
				{
					bool bNext = false;
					try
					{
						bNext = !m_xResultSet->next();
					}
					catch (sdbc::SQLException)
					{
						// handleError(exception)
					}

					if (bNext)
					{
						uno::Reference< ucb::XContent >
							xContent(m_xContentAccess->queryContent());
						if (xContent.is())
						{
							if (!notifyResult(xContent))
							{
								{
									uno::Reference< sdbc::XCloseable >
										xCloseable(m_xResultSet,
												   uno::UNO_QUERY);
									if (xCloseable.is())
										try
										{
											xCloseable->close();
										}
										catch (sdbc::SQLException) {}
								}

								m_xResultSet = 0;
								m_xContentAccess = 0;
								m_eState = STATE_REMOVE;
								break;
							}
						}
						else
						{
							// handleError(...)
						}
					}
					else
					{
						m_xResultSet = 0;
						m_xContentAccess = 0;
					}

					if (checkTimeSliceExhausted())
					{
						reschedule();
						break;
					}
				}
			}
			break;

		case STATE_REMOVE:
			if (m_bRemove)
			{
				if (m_pCache)
					for (CntStorageIterator aIter;;)
					{
						String aID(m_pCache->iter(aIter));
						if (aIter.eof())
							break;
						if (!((*aIter).m_nAttrib
							      & CNTDIRENTRY_ATTRIB_SEARCH_PRESENT))
						{
							result(ucb::ContentAction::REMOVED,
								   reconstruct(aID, 0));
							m_pCache->remove(aID);
							--m_nNewTotal;
						}
						else
							m_pCache->
								attrib(aID, CNTDIRENTRY_ATTRIB_SEARCH_PRESENT,
									   0);
					}
				else
					for (ResultList::iterator
							 aIter(getSearchFolder().getResultList()->
							           get().begin());
						 aIter != getSearchFolder().getResultList()->
							          get().end();)
						if (aIter->second)
						{
							aIter->second = false;
							++aIter;
						}
						else
						{
							result(ucb::ContentAction::REMOVED,
								   reconstruct(aIter->first, 0));
							ResultList::iterator aNext(aIter);
							++aNext;
							getSearchFolder().getResultList()->
								get().erase(aIter);
							aIter = aNext;
							--m_nNewTotal;
						}
				m_bExactTotal = true;
			}
			updateTotalCount();
			done();
			break;
	}
	return 0;
}

//============================================================================
// virtual
void UpdateTask::finished(bool bCanceled)
{
	if (bCanceled)
	{
		m_xResultSet = 0;
		m_xContentAccess = 0;
		if (m_bRemove)
			if (m_pCache)
				for (CntStorageIterator
						 aIter(CNTDIRENTRY_ATTRIB_SEARCH_PRESENT);;)
				{
					String aID(m_pCache->iter(aIter));
					if (aIter.eof())
						break;
					m_pCache->attrib(aID,
									 CNTDIRENTRY_ATTRIB_SEARCH_PRESENT, 0);
				}
			else
				for (ResultList::iterator
						 aIter(getSearchFolder().getResultList()->
							       get().begin());
					 aIter != getSearchFolder().getResultList()->get().end();
					 ++aIter)
					aIter->second = false;
		updateTotalCount();
	}
}

