/*************************************************************************
 *
 *  $RCSfile: cntsrchf.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif

#ifndef _CASTMACS_HXX
#include <castmacs.hxx>
#endif
#ifndef _CNTJOB_HXX
#include <cntjob.hxx>
#endif
#ifndef _CNTRNMGR_HXX
#include <cntrnmgr.hxx>
#endif
#ifndef _CNTSRCHF_HXX
#include <cntsrchf.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <cstritem.hxx>
#endif
#ifndef _ILSTITEM_HXX
#include <ilstitem.hxx>
#endif
#ifndef CHAOS_SLSTITEM_HXX
#include <slstitem.hxx>
#endif
#ifndef _SORTITEM_HXX
#include <sortitem.hxx>
#endif
#ifndef CHAOS_THRDTASK_HXX
#include <thrdtask.hxx>
#endif
#ifndef _ULSTITEM_HXX
#include <ulstitem.hxx>
#endif

#ifndef _CHAOS_CNTSFIMP_HXX
#include <cntsfimp.hxx>
#endif

using namespace chaos;

//============================================================================
class CntSearchFolderDropNode_Impl: public CntNode
{
public:
	TYPEINFO();

	CNT_NODE_SUBCLASS_DECL();

	CntSearchFolderDropNode_Impl();

	virtual const SfxPoolItem * InsertJob(CntNodeJob * pJob);
};

//============================================================================
USHORT __READONLY_DATA aCntSearchFolderRanges[]
 = { WID_MESSAGE_ID, WID_MESSAGE_ID,
	 WID_TITLE, WID_TITLE,
	 WID_ALL_START, WID_COPY,
	 WID_RENAME, WID_VIEW_DESCRIPTION,
	 WID_SYNCHRONIZE, WID_CREATE_NEW,
	 WID_UPDATE, WID_UPDATE,
	 WID_DUMMY_PROPFOLDERVIEW1, WID_DUMMY_PROPFOLDERVIEW1,
	 WID_MSG_COLUMN_INFO, WID_FLD_COLUMN_INFO,
	 WID_SORTING, WID_SORTING,
	 WID_FLAG_SUPPORTMODE, WID_TOTALCONTENTCOUNT,
	 WID_LAST_MSGID, WID_LAST_UID,
	 WID_SHOW_MSGS_HAS_TIMELIMIT, WID_SHOW_MSGS_TIMELIMIT,
	 WID_MSG_COLUMN_WIDTHS, WID_PROPERTYLIST,
	 WID_SEARCH_CRITERIA, WID_SEARCH_DOCUMENT_VIEW,
	 WID_VIEWDATA, WID_VIEWDATA,
	 WID_VIEW_START, WID_VIEW_END,
	 WID_FLAG_UPDATE_ON_OPEN, WID_FLAG_UPDATE_ON_OPEN,
	 WID_VIEW2_START, WID_VIEW2_END,
	 WID_FOLDER_START2,	WID_FOLDER_END2,
	 WID_VIEW3_START, WID_VIEW3_END,
	 WID_SEARCH_INDIRECTIONS, WID_SEARCH_INDIRECTIONS, 0 };

//============================================================================
USHORT __READONLY_DATA aCntSearchFolderDropRanges[]
 = { WID_TITLE, WID_TITLE,
	 WID_HAS_DATA, WID_FLAG_HAS_MESSAGES, 0 };

//============================================================================
//
//  class CntSearchFolderNode
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntSearchFolderNode, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntSearchFolderNode)
{
	CntRootNodeMgr::InsertFactory(
		new CntNodeFactory(String::CreateFromAscii(
			                   RTL_CONSTASCII_STRINGPARAM(
								   URL_PREFIX_PRIV_SOFFICE
								       "searchfolder://*")),
						   '/', TYPE(CntSearchFolderNode),
						   CONTENT_TYPE_X_CNT_SEARCHBOX,
						   CNT_CREATION_FLAG_PROPERTIES,
						   HID_CHAOS_NEW_SEARCH));

	// Dummy factory for drag 'n' drop (must come first to support D&D code
	// in sfx2/expchaos):
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM("/drop")),
									 String(),
									 TYPE(CntSearchFolderDropNode_Impl),
									 CONTENT_TYPE_X_CNT_SEARCHBOX,
									 CNT_CREATION_FLAG_HIDDEN));

	// Factory for 'location list' node:
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM(
											 "/locations/*")),
									 '/', TYPE(CntSearchFolderLocListNode),
									 CONTENT_TYPE_X_CNT_SEARCHBOX,
									 CNT_CREATION_FLAG_HIDDEN));
}

//============================================================================
CntSearchFolderNode::CntSearchFolderNode(): CntNode(aCntSearchFolderRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, aCntSearchFolderRanges);
		pClassDefs->Put(CntUShortListItem(WID_RENAME, WID_TITLE, 0));
		pClassDefs->Put(CntContentTypeItem(WID_CONTENT_TYPE,
									       CONTENT_TYPE_X_CNT_SEARCHBOX));

		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put(CntBoolItem(WID_FLAG_HAS_MESSAGES, TRUE));

		CntViewColumnsListItem
		 aColumns(WID_VIEW_COLS_BEAMER,
				  WID_TITLE, DEF_WIDTH_TITLE_FSYS,
				  WID_CONTENT_TYPE, DEF_WIDTH_CONTENT_TYPE,
				  WID_REAL_URL, DEF_WIDTH_TRASH_ORIGIN, 0);
		pClassDefs->Put(aColumns);
		pClassDefs->Put(aColumns, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put(aColumns, WID_VIEW_COLS_FLDWIN);
		CntSortingItem aSorting(WID_VIEW_SORT_BEAMER);
		aSorting.Append(CntSortingInfo(WID_TITLE, TRUE));
		aSorting.Append(CntSortingInfo(WID_CONTENT_TYPE, TRUE));
		aSorting.Append(CntSortingInfo(WID_REAL_URL, TRUE));
		pClassDefs->Put(aSorting);
		pClassDefs->Put(aSorting, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put(aSorting, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put(aSorting, WID_VIEW_SORT_FLDWIN_ICON);

		CntStringListItem aHeaderConfig(WID_HEADER_CONFIG);
		aHeaderConfig.
			SetString(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
				                                  "t\nNonRFC-Title\001b\n"
												      "From:\nDate:\n"
												      "NonRFC-Size\n"
												      "Comments:\nKeywords:\n"
												      "NonRFC-UserFields")));
		pClassDefs->Put(aHeaderConfig);

		pClassDefs->Put(CntIdentifierListItem(WID_PROPERTYLIST,
										      CNT_TABPAGE_GENERAL,
										      CNT_TABPAGE_SEARCH_CRITERIA,
										      CNT_TABPAGE_SEARCH_LOCATIONS,
										      CNT_TABPAGE_DESCRIPTION,
										      CNT_TABPAGE_BACKGROUND,
										      CNT_TABPAGE_FONT, 0));

		pClassDefs->Put(CntBoolItem(WID_SEARCH_FOLDER_VIEW, TRUE));

		pClassDefs->Put(CntBoolItem(WID_FLAG_UPDATE_ON_OPEN, FALSE));
	}
	CntInterface::SetParent(pClassDefs);

	m_pImpl = new CntSearchFolderImpl(*this);
}

//============================================================================
// virtual
CntSearchFolderNode::~CntSearchFolderNode()
{
	delete m_pImpl;
}

//============================================================================
// virtual
FASTBOOL CntSearchFolderNode::IsItemFlag(USHORT nWID, USHORT nFlag) const
{
	if (nFlag == CNT_ITEM_SYNCHRON)
		switch (nWID)
		{
			case WID_SORTING:
			case WID_SEARCH:
			case WID_VIEW_COLS_BEAMER:
			case WID_VIEW_COLS_FILEDLG:
			case WID_VIEW_COLS_FLDWIN:
				return TRUE;
		}
	return CntNode::IsItemFlag(nWID, nFlag);
}

//============================================================================
// virtual
const SfxPoolItem * CntSearchFolderNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetRequestData())
		return static_cast< ThreadTask * >(pJob->GetRequestData())->run();

	m_pImpl->initialize(*pJob);

	if (pJob->GetSubject() == this)
	{
		switch (pJob->GetRequest()->Which())
		{
			case WID_PUTDATA:
			{
				const CntItemListItem & rList
				 = *INSECURE_DYNAMIC_CAST(const CntItemListItem *,
										  pJob->GetRequest());

				{for (USHORT i = 0; i < rList.Count();)
				{
					const SfxPoolItem & rItem = rList[i];
					if (rItem.Which() == WID_MESSAGE_ID)
					{
						m_pImpl->setUniqueID(ITEM_VALUE(CntStringItem,
														rItem));
						CONST_CAST(CntItemListItem &, rList).Remove(i);
					}
					else
						++i;
				}}

				if (IsDummy())
				{
					String
						aURL(RTL_CONSTASCII_USTRINGPARAM(
							     URL_PREFIX_PRIV_SOFFICE "searchfolder://"));
					aURL += m_pImpl->getUniqueID();
					aURL += '/';
					CntNodeRef xNode = CntRootNodeMgr::Get()->Query(aURL);
					if (xNode.Is())
					{
						m_pImpl->forceStorageFile(aURL);
						pJob->Result(xNode, CNT_ACTION_EXCHANGED);
						pJob->Done();
						return 0;
					}
				}

				CntItemListItem aLocListViewData(WID_PUTDATA);
				for (USHORT i = 0; i < rList.Count();)
				{
					const SfxPoolItem & rItem = rList[i];
					BOOL bRemove = FALSE;
					switch (rItem.Which())
					{
						case WID_SEARCH_CRITERIA:
						case WID_SEARCH_LOCATIONS:
						case WID_SEARCH_RECURSIVE:
						case WID_SEARCH_FOLDER_VIEW:
						case WID_SEARCH_DOCUMENT_VIEW:
						case WID_SEARCH_INDIRECTIONS:
							// These items are all flagged as
							// CNT_ITEM_AUTO_OWNPROP, so we must check whether
							// a storage file is used, since
							// CntNode::ExecuteJob() would always create one:
							if (!pJob->GetDirectoryNode(FALSE))
							{
								Put(rItem);
								bRemove = TRUE;
							}
							break;

						case WID_TITLE:
						case WID_SHOW_MSGS_HAS_TIMELIMIT:
						case WID_SHOW_MSGS_TIMELIMIT:
							// The search dialog puts these items (all of
							// which are flagged as CNT_ITEM_AUTO_VIEWPROP)
							// into an anchor refering this search folder node
							// without any view data storage in between, so
							// those items must be stored in this node:
							if (!pJob->GetViewDataNode())
							{
								Put(rItem);
								bRemove = TRUE;
							}
							break;

						case WID_VIEW_COLS_FILEDLG:
						case WID_VIEW_SORT_FILEDLG:
							// The search locations tab page transports
							// WID_VIEW_COLS_FILEDLG and WID_VIEW_SORT_FILEDLG
							// items directed to the
							// CntSearchFolderLocListNode's view node in a
							// WID_PUTDATA directed to this node:
							aLocListViewData.Append(rItem.Clone());
							bRemove = TRUE;
							break;
					}
					if (bRemove)
						CONST_CAST(CntItemListItem &, rList).Remove(i);
					else
						++i;
				}
				if (aLocListViewData.Count())
				{
					String aLocListURL(OWN_URL(this));
					aLocListURL.
						AppendAscii(RTL_CONSTASCII_STRINGPARAM("locations/"));

					String
					 aBoxViewURL
					  (OWN_URL(INSECURE_DYNAMIC_CAST(CntAnchor *,
													 pJob->GetClient())));
					if (CntAnchor::IsViewURL(aBoxViewURL))
						aLocListURL
						 = CntAnchor::ToViewURL(aBoxViewURL, aLocListURL);

					CntAnchorRef
					 xLocListViewAnchor(new CntAnchor(0, aLocListURL, FALSE));
					xLocListViewAnchor->Put(aLocListViewData);
					xLocListViewAnchor = 0;
				}

				break;
			}

			case WID_OPEN:
				return m_pImpl->execOpen(*pJob);

			case WID_UPDATE:
			case WID_SYNCHRONIZE:
				return m_pImpl->execUpdate(*pJob);

			case WID_MESSAGE_ID:
				m_pImpl->setUniqueID(ITEM_VALUE(CntStringItem,
												*pJob->GetRequest()));
				pJob->Done();
				return 0;

			case WID_SEARCH_CRITERIA:
			case WID_SEARCH_LOCATIONS:
			case WID_SEARCH_RECURSIVE:
			case WID_SEARCH_FOLDER_VIEW:
			case WID_SEARCH_DOCUMENT_VIEW:
			case WID_SEARCH_INDIRECTIONS:
				// These items are all flagged as CNT_ITEM_AUTO_OWNPROP, so we
				// must check whether a storage file is used, since
				// CntNode::ExecuteJob() would always create one:
				if (pJob->GetDirectoryNode(FALSE))
					break;
				Put(*pJob->GetRequest());
				pJob->Done();
				return 0;

			case WID_TITLE:
			case WID_SHOW_MSGS_HAS_TIMELIMIT:
			case WID_SHOW_MSGS_TIMELIMIT:
				// The search dialog puts these items (all of which are
				// flagged as CNT_ITEM_AUTO_VIEWPROP) into an anchor refering
				// this search folder node without any view data storage in
				// between, so those items must be stored in this node:
				if (!pJob->GetViewDataNode())
					Put(*pJob->GetRequest());
				break;
		}
	}
	else if (pJob->GetSubject()->ISA(CntSearchFolderDropNode_Impl))
		switch (pJob->GetRequest()->Which())
		{
			case WID_INSERT:
				return m_pImpl->execInsertSearchLocation(*pJob);
		}

	return CntNode::ExecuteJob(pJob);
}

//============================================================================
//
//  class CntSearchFolderDropNode_Impl
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntSearchFolderDropNode_Impl, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntSearchFolderDropNode_Impl)
{}

//============================================================================
CntSearchFolderDropNode_Impl::CntSearchFolderDropNode_Impl():
	CntNode(aCntSearchFolderDropRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, aCntSearchFolderDropRanges);
		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_DOCUMENT, TRUE));
	}
	CntInterface::SetParent(pClassDefs);
}

//============================================================================
// virtual
const SfxPoolItem * CntSearchFolderDropNode_Impl::InsertJob(CntNodeJob * pJob)
{
	if (pJob->GetRequest()->Which() == WID_INSERT)
		return GetRootNode()->InsertJob(pJob);
	else
		return CntNode::InsertJob(pJob);
}

