/*************************************************************************
 *
 *  $RCSfile: cntvim.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _TOOLS_INTN_HXX
#include <tools/intn.hxx>
#endif

#ifndef _CASTMACS_HXX
#include <castmacs.hxx>
#endif
#ifndef _CNTJOB_HXX
#include <cntjob.hxx>
#endif
#ifndef _CNTMSGNODE_HXX
#include <cntmsgnd.hxx>
#endif
#ifndef _CNTRNMGR_HXX
#include <cntrnmgr.hxx>
#endif
#ifndef _CNTSTGND_HXX
#include <cntstgnd.hxx>
#endif
#ifndef _CNTVIM_HXX
#include <cntvim.hxx>
#endif
#ifndef _CNTVWITM_HXX
#include <cntvwitm.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <cstritem.hxx>
#endif
#ifndef CHAOS_FLSTITEM_HXX
#include <flstitem.hxx>
#endif
#ifndef _ILSTITEM_HXX
#include <ilstitem.hxx>
#endif
#ifndef _CHAOS_INIMGR_HXX
#include <inimgr.hxx>
#endif
#ifndef _LAYITEM_HXX
#include <layitem.hxx>
#endif
#ifndef _SORTITEM_HXX
#include <sortitem.hxx>
#endif
#ifndef _RCPNITEM_HXX
#include <rcpnitem.hxx>
#endif
#ifndef _THRDITEM_HXX
#include <thrditem.hxx>
#endif
#ifndef _ULSTITEM_HXX
#include <ulstitem.hxx>
#endif

#ifndef _CHAOS_CVIMIMP_HXX
#include <cvimimp.hxx>
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//============================================================================
static const USHORT anCntVIMBoxNodeRanges[]
 = { WID_REPLY_TO, WID_REPLY_TO,
	 WID_FROM, WID_TITLE,
	 WID_DEFAULT, WID_COPY,
	 WID_RENAME, WID_VIEW_DESCRIPTION,
	 WID_FOLDER_START, WID_CREATE_NEW,
	 WID_UPDATE, WID_UPDATE,
	 WID_DUMMY_PROPFOLDERVIEW1, WID_FLD_COLUMN_INFO,
	 WID_SORTING, WID_SORTING,
	 WID_FLAG_SUPPORTMODE, WID_PASSWORD,
	 WID_MAILSEND_USERNAME, WID_MAILSEND_PASSWORD,
	 WID_FROM_DEFAULT, WID_CONNECTION_MODE,
	 WID_OUTMSGEXTERNALSTATE, WID_BOXEXT_END,
	 WID_LAST_MSGID, WID_LAST_UID,
	 WID_MSG_COLUMN_WIDTHS, WID_PURGE,
	 WID_SEARCH, WID_BOXALL_END2,
	 WID_VIEW_START, WID_VIEW_END,
	 WID_FLAG_UPDATE_ON_OPEN, WID_FLAG_UPDATE_ON_OPEN,
	 WID_VIEW2_START, WID_VIEW2_END,
	 WID_FOLDER_START2,	WID_FOLDER_END2,
	 WID_VIEW3_START, WID_VIEW3_END,
	 WID_SEND_FORMATS, WID_SEND_COPY_TARGET, 0 };

static const USHORT anCntVIMInboxNodeRanges[]
 = { WID_TITLE, WID_TITLE,
	 WID_ALL_START, WID_OPEN,
	 WID_HAS_DATA, WID_CREATE_NEW,
	 WID_UPDATE, WID_UPDATE,
	 WID_DUMMY_PROPFOLDERVIEW1, WID_FLD_COLUMN_INFO,
	 WID_MESSAGEVIEW_MODE, WID_SUBSCRNEWSGROUPCOUNT,
	 WID_FLAG_SUPPORTMODE, WID_FOLDER_END,
	 WID_AUTOUPDATE_INTERVAL, WID_UPDATE_ENABLED,
	 WID_MESSAGE_STOREMODE, WID_BOXEXT_END,
	 WID_LAST_MSGID, WID_LAST_UID,
	 WID_MSG_COLUMN_WIDTHS, WID_SEND_VIM_POPATH,
	 WID_SEARCH, WID_BOXALL_END2,
	 WID_VIEW_START, WID_VIEW_END,
	 WID_VIEW2_START, WID_VIEW2_END,
	 WID_FOLDER_START2,	WID_FOLDER_END2,
	 WID_VIEW3_START, WID_VIEW3_END, 0 };

static const USHORT anCntVIMBBoardBoxNodeRanges[]
 = { WID_TITLE, WID_TITLE,
	 WID_ALL_START, WID_OPEN,
	 WID_HAS_DATA, WID_VIEW_DESCRIPTION,
	 WID_FOLDER_START, WID_CREATE_NEW,
	 WID_UPDATE, WID_UPDATE,
	 WID_DUMMY_PROPFOLDERVIEW1, WID_FOLDERVIEW_MODE,
	 WID_SORTING, WID_SORTING,
	 WID_SUBSCRNEWSGROUPCOUNT, WID_SUBSCRNEWSGROUPCOUNT,
	 WID_FLAG_SUPPORTMODE, WID_PREPARE_MOVE,
	 WID_AUTOUPDATE_INTERVAL, WID_UPDATE_ENABLED,
	 WID_NEWS_GROUPLIST, WID_MESSAGE_STOREMODE,
	 WID_OUTMSGEXTERNALSTATE, WID_BOXEXT_END,
	 WID_LAST_MSGID, WID_LAST_UID,
	 WID_STORE_MSGS_HAS_TIMELIMIT, WID_SEND_VIM_POPATH,
	 WID_SEARCH, WID_BOXALL_END2,
	 WID_VIEW_START, WID_VIEW_END,
	 WID_VIEW2_START, WID_VIEW2_END,
	 WID_FOLDER_START2,	WID_FOLDER_END2,
	 WID_VIEW3_START, WID_VIEW3_END, 0 };

static const USHORT anCntVIMBBoardNodeRanges[]
 = { WID_TITLE, WID_TITLE,
	 WID_ALL_START, WID_OPEN,
	 WID_HAS_DATA, WID_CREATE_NEW,
	 WID_UPDATE, WID_UPDATE,
	 WID_DUMMY_PROPFOLDERVIEW1, WID_FLD_COLUMN_INFO,
	 WID_MESSAGEVIEW_MODE, WID_FOLDER_END,
	 WID_AUTOUPDATE_INTERVAL, WID_UPDATE_ENABLED,
	 WID_OUTMSGEXTERNALSTATE, WID_BOXEXT_END,
	 WID_LAST_MSGID, WID_LAST_UID,
	 WID_MSG_COLUMN_WIDTHS, WID_SEND_VIM_POPATH,
	 WID_CLEAN_CACHE, WID_LOCALBASE,
	 WID_VIEW_START, WID_VIEW_END,
	 WID_SET_AS_DEFAULT, WID_VIEW2_END,
	 WID_FOLDER_START2,	WID_FOLDER_END2,
	 WID_VIEW3_START, WID_VIEW3_END, 0 };

//============================================================================
//
//  class CntVIMNode
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntVIMNode, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntVIMNode)
{
	CntRootNodeMgr::InsertFactory(
		new CntNodeFactory(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
			                                           "vim://*")),
						   '/', StaticType(), CONTENT_TYPE_X_CNT_VIMBOX,
						   CNT_CREATION_FLAG_PROPERTIES,
						   HID_CHAOS_NEW_VIM_BOX));
	InsertFactory(
		new CntNodeFactory(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
			                                           "/inbox/*")),
						   '/', TYPE(CntVIMInboxNode),
						   CONTENT_TYPE_X_CNT_VIMINBOX));
	InsertFactory(
		new CntNodeFactory(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
			                                           "/newsgroups/*")),
						   '/', TYPE(CntVIMBBoardBoxNode),
						   CONTENT_TYPE_X_CNT_VIMBBOARDBOX));

	// Register dummy factory for creating new messages at the VIM box node:
	InsertFactory(new CntNodeFactory(String(), String(), TYPE(CntMessageNode),
									 CONTENT_TYPE_X_CNT_MESSAGE,
									 CNT_CREATION_FLAG_MESSAGEDOC
									  | CNT_CREATION_FLAG_SENDMESSAGE,
									 HID_CHAOS_NEW_VIM_MSG));
}

//============================================================================
CntVIMNode::CntVIMNode(): CntNode(anCntVIMBoxNodeRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, anCntVIMBoxNodeRanges);

		pClassDefs->Put(CntContentTypeItem(WID_CONTENT_TYPE,
									       CONTENT_TYPE_X_CNT_VIMBOX));

		pClassDefs->Put(CntUShortListItem(WID_RENAME, WID_TITLE, 0));

		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put(CntBoolItem(WID_FLAG_HAS_FOLDER, TRUE));
		pClassDefs->Put(CntUShortListItem(WID_FLD_COLUMN_INFO, WID_TITLE, 0));
		pClassDefs->Put(CntUShortListItem(WID_MSG_COLUMN_INFO, WID_TITLE,
										  WID_IS_MARKED, WID_IS_READ, 0));

		CntViewColumnsListItem aColumnDefs(WID_VIEW_COLS_BEAMER,
										   WID_TITLE, DEF_WIDTH_TITLE_MAIL,
										   WID_IS_MARKED, DEF_WIDTH_IS_MARKED,
										   WID_IS_READ, DEF_WIDTH_IS_READ, 0);
		pClassDefs->Put(aColumnDefs);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FLDWIN);

		pClassDefs->Put(CntIdentifierListItem(WID_PROPERTYLIST,
										      CNT_TABPAGE_GENERAL,
										      CNT_TABPAGE_RECV_VIM,
										      CNT_TABPAGE_MAIL_NEWS_SEND,
										      CNT_TABPAGE_CONTENT_PROPERTIES,
										      CNT_TABPAGE_BACKGROUND,
										      CNT_TABPAGE_FONT, 0));

		CntThreadingItem aThrItem(WID_THREADING);
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_IN_REPLY_TO,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_REFERENCES,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PROPVALUE,
										 WID_FLAG_IS_MESSAGE, WID_TITLE,
										 WID_TITLE));

		pClassDefs->Put(CntUInt16Item(WID_SEND_PUBLIC_PROT_ID,
									  CNT_OUTMSG_PROTOCOL_VIM));
		pClassDefs->Put(CntUInt16Item(WID_SEND_PRIVATE_PROT_ID,
									  CNT_OUTMSG_PROTOCOL_VIM));

		pClassDefs->Put(aThrItem);

		CntSortingItem aSortingDefs(WID_SORTING);
		aSortingDefs.Append(CntSortingInfo(WID_USER_SORT_CRITERIUM, TRUE));
		pClassDefs->Put(aSortingDefs);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		pClassDefs->Put(CntBoolItem(WID_OUTTRAY_WANTED, TRUE));
	}
	CntInterface::SetParent(pClassDefs);

	m_pImp = new CntVIMNodeImp(this);
}

//============================================================================
// virtual
CntVIMNode::~CntVIMNode()
{
	delete m_pImp;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetSubject() == this)
		switch (pJob->GetRequest()->Which())
		{
			case WID_OPEN:
			case WID_UPDATE:
			case WID_SYNCHRONIZE:
			case WID_SEARCH:
				m_pImp->Initialize(*pJob);
				m_pImp->Open(pJob->GetRequest()->Which(), pJob);
				return 0;

			case WID_GETDATA:
				m_pImp->Initialize(*pJob);
				break;

			case WID_PUTDATA:
			{
				// After an exchange, the new box does not get a WID_GETDATA,
				// but a WID_PUTDATA, so it is initialized here (and for an
				// already initialized or dummy box this call does no harm):
				m_pImp->Initialize(*pJob);

				const CntItemListItem * pListItem
				 = PTR_CAST(CntItemListItem, pJob->GetRequest());
				if (pListItem)
				{
					for (USHORT i = pListItem->Count(); i;)
					{
						const SfxPoolItem & rItem = (*pListItem)[--i];

						if (rItem.Which() == WID_USERNAME)
						{
							const SfxPoolItem * pUserItem;
							if (GetItemState(WID_USERNAME, FALSE, &pUserItem)
								 < SFX_ITEM_SET
								|| rItem != *pUserItem)
							{
								String aURL(RTL_CONSTASCII_USTRINGPARAM(
									            "vim://"));
								aURL += INetURLObject::encode(
									        ITEM_VALUE(CntStringItem, rItem),
											INetURLObject::PART_VIM, '=',
											INetURLObject::ENCODE_ALL);
								aURL += '/';
								CntNodeRef xBox(CNT_RNM()->Query(aURL));
								if (xBox.Is() && &xBox != this)
								{
									pJob->Result(xBox, CNT_ACTION_EXCHANGED);
									pJob->Done();
									return 0;
								}
							}
						}
					}
				}
				break;
			}

			case WID_CREATE_NEW:
			{
				CntNodeItem * pMsg
				 = INSECURE_DYNAMIC_CAST(CntNodeItem *,
										 CntNode::ExecuteJob(pJob));
				CntVIMNodeImp::createNewMessage(pMsg, pJob, FALSE, String());
				return pMsg;
			}
		}

	return CntNode::ExecuteJob(pJob);
}

//============================================================================
// virtual
void CntVIMNode::SetConnMode(CntConnMode eConnMode)
{
	m_pImp->SetConnMode(eConnMode);

	// It would be nice to be able to show the bulletin board box now if this
	// is the first time the VIM box goes online (and therefore the earliest
	// possible moment to find out if bulletin boards are supported), but
	// there is no job available, so this seems impossible...
}

//============================================================================
//
//  class CntVIMInboxNode
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntVIMInboxNode, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntVIMInboxNode)
{
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM("/*")),
									 String(), TYPE(CntMessageNode),
									 CONTENT_TYPE_X_CNT_MESSAGE,
									 CNT_CREATION_FLAG_MESSAGEDOC
									  | CNT_CREATION_FLAG_SENDMESSAGE,
									 HID_CHAOS_NEW_VIM_MSG));
}

//============================================================================
CntVIMInboxNode::CntVIMInboxNode(): CntNode(anCntVIMInboxNodeRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, anCntVIMInboxNodeRanges);

		pClassDefs->Put(CntContentTypeItem(WID_CONTENT_TYPE,
									       CONTENT_TYPE_X_CNT_VIMINBOX));
		pClassDefs->
		 Put(CntStringItem(WID_TITLE,
						   INetContentTypes::GetPresentation
						    (CONTENT_TYPE_X_CNT_VIMINBOX,
							 CntRootNodeMgr::GetIniManager()->
							  getInternational().GetLanguage())));

		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put(CntBoolItem(WID_FLAG_HAS_MESSAGES, TRUE));
		CntViewColumnsListItem
		 aColumnDefs(WID_VIEW_COLS_BEAMER,
					 WID_FROM, DEF_WIDTH_FROM,
					 WID_TITLE, DEF_WIDTH_TITLE_MAIL,
					 WID_IS_MARKED, DEF_WIDTH_IS_MARKED,
					 WID_IS_READ, DEF_WIDTH_IS_READ,
					 WID_DATE_CREATED, DEF_WIDTH_DATE_CREATED,
					 WID_PRIORITY, DEF_WIDTH_PRIORITY, 0);
		pClassDefs->Put(aColumnDefs);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FLDWIN);

		pClassDefs->Put(CntIdentifierListItem(WID_PROPERTYLIST,
										      CNT_TABPAGE_GENERAL,
										      CNT_TABPAGE_RULES,
										      CNT_TABPAGE_VIEW_PROPERTIES,
										      CNT_TABPAGE_HEADER,
										      CNT_TABPAGE_CONTENT_PROPERTIES,
										      CNT_TABPAGE_BACKGROUND,
										      CNT_TABPAGE_FONT,
										      0));

		CntThreadingItem aThrItem(WID_THREADING);
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_IN_REPLY_TO,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_REFERENCES,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PROPVALUE,
										 WID_FLAG_IS_MESSAGE, WID_TITLE,
										 WID_TITLE));
		pClassDefs->Put(aThrItem);

		CntSortingItem aSortingDefs(WID_SORTING);
		aSortingDefs.Append(CntSortingInfo(WID_DATE_CREATED, FALSE));
		aSortingDefs.Append(CntSortingInfo(WID_TITLE, TRUE));
		pClassDefs->Put(aSortingDefs);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		pClassDefs->Put(CntBoolItem(WID_VIEW_MODE_FLDWIN, TRUE));
		pClassDefs->Put(CntLayoutItem(WID_VIEW_LAYOUT_FLDWIN,
									  LAYOUT_MAILNEWS));

		pClassDefs->Put(CntStringItem(WID_USER_SORT_CRITERIUM, '0'));
	}
	CntInterface::SetParent(pClassDefs);

	m_pImp = new CntVIMInboxNodeImp(this);
}

//============================================================================
// virtual
CntVIMInboxNode::~CntVIMInboxNode()
{
	delete m_pImp;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMInboxNode::JobArrived(CntNodeJob * pJob)
{
	if (!pJob->GetSubject()->ISA(CntMessageNode))
		return CntNode::JobArrived(pJob);

	ULONG nCount = JobCount();
	for (ULONG i = 0; i < nCount; ++i)
		if (GetJob(i)->GetSubject() == pJob->GetSubject())
			return CntNode::JobArrived(pJob);

	EnqueueJob(pJob);
	return DoExecuteJob(pJob);
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMInboxNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetSubject() == this)
		switch (pJob->GetRequest()->Which())
		{
			case WID_OPEN:
			case WID_UPDATE:
			case WID_SYNCHRONIZE:
			case WID_SEARCH:
				m_pImp->Initialize(*pJob);
				m_pImp->Open(pJob);
				return 0;

			case WID_GETDATA:
				m_pImp->Initialize(*pJob);
				break;

			case WID_CREATE_NEW:
			{
				CntNodeItem * pMsg
				 = INSECURE_DYNAMIC_CAST(CntNodeItem *,
										 CntNode::ExecuteJob(pJob));
				CntVIMNodeImp::createNewMessage(pMsg, pJob, FALSE, String());
				return pMsg;
			}

			case WID_IS_READ:
			case WID_IS_MARKED:
				m_pImp->Initialize(*pJob);
				m_pImp->Flag(pJob);
				return 0;

			case WID_MESSAGE_STOREMODE:
				m_pImp->Initialize(*pJob);
				if (ITEM_VALUE(CntBoolItem, *pJob->GetRequest())
					 != THIS_ITEM_VALUE(CntBoolItem, WID_MESSAGE_STOREMODE))
					m_pImp->changeMsgStoreMode(*pJob);
				break;
		}
	else
	{
		CntMessageNode * pMsg = PTR_CAST(CntMessageNode, pJob->GetSubject());
		if (pMsg)
			switch (pJob->GetRequest()->Which())
			{
				case WID_OPEN:
					m_pImp->Initialize(*pJob);
					m_pImp->OpenMsg(pMsg, pJob);
					return 0;

				case WID_GETDATA:
					m_pImp->InitMessage(pJob, pMsg);
					break;

				case WID_DELETE:
					DBG_ASSERT
					 (!ITEMSET_VALUE(pMsg, CntBoolItem, WID_IS_MARKED),
					  "CntVIMInboxNode::ExecuteJob(): Delete marked msg");

					m_pImp->Initialize(*pJob);
					m_pImp->DeleteMsg(pMsg, pJob);
					return 0;

				case WID_UNDELETE:
					m_pImp->Initialize(*pJob);
					m_pImp->UndeleteMessage(pMsg, pJob);
					pJob->Done();
					return 0;

				case WID_IS_READ:
				case WID_IS_MARKED:
					m_pImp->Initialize(*pJob);
					m_pImp->
					 MarkMsg(pMsg,
							 *INSECURE_DYNAMIC_CAST(const CntBoolItem *,
													pJob->GetRequest()),
							 pJob);
					return 0;

				case WID_ACTION_LIST:
					m_pImp->Initialize(*pJob);
					m_pImp->
					 SetMsgActionList
					  (*pMsg,
					   *INSECURE_DYNAMIC_CAST(const CntActionListItem *,
											  pJob->GetRequest()),
					   *pJob);
					return 0;
			}
	}

	return CntNode::ExecuteJob(pJob);
}

//============================================================================
//
//  class CntVIMBBoardBoxNode
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntVIMBBoardBoxNode, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntVIMBBoardBoxNode)
{
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM("/*/*")),
									 '/', TYPE(CntVIMBBoardNode),
									 CONTENT_TYPE_X_CNT_VIMBBOARD));

	// Register dummy factory for creating new messages at the VIM box node:
	InsertFactory(new CntNodeFactory(String(), String(), TYPE(CntMessageNode),
									 CONTENT_TYPE_X_CNT_MESSAGE,
									 CNT_CREATION_FLAG_MESSAGEDOC
									  | CNT_CREATION_FLAG_SENDMESSAGE,
									 HID_CHAOS_NEW_VIM_MSG));
}

//============================================================================
CntVIMBBoardBoxNode::CntVIMBBoardBoxNode():
	CntNode(anCntVIMBBoardBoxNodeRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, anCntVIMBBoardBoxNodeRanges);

		pClassDefs->Put(CntContentTypeItem(WID_CONTENT_TYPE,
									       CONTENT_TYPE_X_CNT_VIMBBOARDBOX));
		pClassDefs->
		 Put(CntStringItem
			  (WID_TITLE,
			   INetContentTypes::GetPresentation
			    (CONTENT_TYPE_X_CNT_VIMBBOARDBOX,
				 CntRootNodeMgr::GetIniManager()->
				  getInternational().GetLanguage())));

		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put(CntBoolItem(WID_FLAG_HAS_FOLDER, TRUE));
		pClassDefs->Put(CntUShortListItem(WID_FLD_COLUMN_INFO, WID_TITLE, 0));
		CntViewColumnsListItem aColumnDefs(WID_VIEW_COLS_BEAMER,
									  WID_TITLE, DEF_WIDTH_TITLE_MAIL,
									  WID_IS_MARKED, DEF_WIDTH_IS_MARKED,
									  WID_IS_READ, DEF_WIDTH_IS_READ, 0);
		pClassDefs->Put(aColumnDefs);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FLDWIN);

		pClassDefs->Put(CntFolderViewModeItem(WID_FOLDERVIEW_MODE,
											  CNT_VIEW_SUBSCRIBED_FOLDERS));

		pClassDefs->Put(CntIdentifierListItem(WID_PROPERTYLIST,
										      CNT_TABPAGE_GENERAL,
										      CNT_TABPAGE_SUBSCRIBE,
										      CNT_TABPAGE_VIEW_PROPERTIES,
										      CNT_TABPAGE_CONTENT_PROPERTIES,
							  			      CNT_TABPAGE_BACKGROUND,
										      CNT_TABPAGE_FONT,
										      0));

		CntThreadingItem aThrItem(WID_THREADING);
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_IN_REPLY_TO,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_REFERENCES,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PROPVALUE,
										 WID_FLAG_IS_MESSAGE, WID_TITLE,
										 WID_TITLE));
		pClassDefs->Put(aThrItem);

		CntSortingItem aSortingDefs(WID_SORTING);
		aSortingDefs.Append(CntSortingInfo(WID_TITLE, TRUE));
		pClassDefs->Put(aSortingDefs);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		pClassDefs->Put(CntBoolItem(WID_VIEW_MODE_FLDWIN, FALSE));

		pClassDefs->Put(CntStringItem(WID_USER_SORT_CRITERIUM, '1'));
	}
	CntInterface::SetParent(pClassDefs);

	m_pImp = new CntVIMBBoardBoxNodeImp(*this);
}

//============================================================================
// virtual
CntVIMBBoardBoxNode::~CntVIMBBoardBoxNode()
{
	delete m_pImp;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMBBoardBoxNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetSubject() == this)
		switch (pJob->GetRequest()->Which())
		{
			case WID_OPEN:
				// Filter out any useless opening of messages:
				if (ITEM_VALUE(CntOpenModeItem, *pJob->GetRequest())
					 == CNT_OPEN_MESSAGES)
				{
					pJob->Done();
					return 0;
				}
				// fall through is ok
			case WID_UPDATE:
			case WID_SYNCHRONIZE:
			case WID_SEARCH:
				m_pImp->Initialize(*pJob, FALSE);
				m_pImp->Open(pJob);
				return 0;

			case WID_GETDATA:
				m_pImp->Initialize(*pJob, TRUE);
				break;

			case WID_PUTDATA:
			{
				const CntItemListItem & rList
				 = *INSECURE_DYNAMIC_CAST(const CntItemListItem *,
										  pJob->GetRequest());
				for (USHORT i = 0; i < rList.Count(); ++i)
					if (rList[i].Which() == WID_NEWS_GROUPLIST
						&& SAL_STATIC_CAST(const CntFolderListItem *,
										   &rList[i])->
						     getCommand()
						    == CntFolderListItem::SET)
						m_pImp->UpdateBBoardList(SAL_STATIC_CAST
												   (const CntFolderListItem *,
													&rList[i])->
												  takeList(),
												 pJob);
				break;
			}

			case WID_NEWS_GROUPLIST:
				m_pImp->Initialize(*pJob, FALSE);
				if (SAL_STATIC_CAST(const CntFolderListItem *,
									pJob->GetRequest())->
					  getCommand()
					 == CntFolderListItem::SET)
				{
					m_pImp->UpdateBBoardList(SAL_STATIC_CAST
											   (const CntFolderListItem *,
												pJob->GetRequest())->
											  takeList(),
											 pJob);
					pJob->Done();
				}
				else
					m_pImp->SupplyBBoardList(pJob);
				return 0;

			case WID_CREATE_NEW:
			{
				CntNodeItem * pMsg
				 = INSECURE_DYNAMIC_CAST(CntNodeItem *,
										 CntNode::ExecuteJob(pJob));
				CntVIMNodeImp::createNewMessage(pMsg, pJob, TRUE, String());
				return pMsg;
			}

			case WID_FOLDERVIEW_MODE:
				m_pImp->Initialize(*pJob, FALSE);
				m_pImp->ViewModeChange(pJob);
				break;

			case WID_IS_READ:
				m_pImp->Initialize(*pJob, FALSE);
				m_pImp->FlagRead(pJob);
				return 0;

			case WID_MESSAGE_STOREMODE:
				m_pImp->Initialize(*pJob, FALSE);
				if (ITEM_VALUE(CntBoolItem, *pJob->GetRequest())
					 != THIS_ITEM_VALUE(CntBoolItem, WID_MESSAGE_STOREMODE))
					m_pImp->changeMsgStoreMode(*pJob);
				break;
		}

	return CntNode::ExecuteJob(pJob);
}

//============================================================================
//
//  class CntVIMBBoardNode
//
//============================================================================

TYPEINIT1_AUTOFACTORY(CntVIMBBoardNode, CntNode);

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntVIMBBoardNode)
{
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM("/*")),
									 String(), TYPE(CntMessageNode),
									 CONTENT_TYPE_X_CNT_MESSAGE,
									 CNT_CREATION_FLAG_MESSAGEDOC
									  | CNT_CREATION_FLAG_SENDMESSAGE,
									 HID_CHAOS_NEW_VIM_BOX));
}

//============================================================================
CntVIMBBoardNode::CntVIMBBoardNode(): CntNode(anCntVIMBBoardNodeRanges)
{
	CntDefaults * pClassDefs = GetDefaults();
	if (!pClassDefs)
	{
		pClassDefs = new CntDefaults(*this, anCntVIMBBoardNodeRanges);

		pClassDefs->Put(CntContentTypeItem(WID_CONTENT_TYPE,
									       CONTENT_TYPE_X_CNT_VIMBBOARD));

		pClassDefs->Put(CntBoolItem(WID_FLAG_IS_FOLDER, TRUE));
		pClassDefs->Put(CntBoolItem(WID_FLAG_HAS_MESSAGES, TRUE));
		CntViewColumnsListItem
		 aColumnDefs(WID_VIEW_COLS_BEAMER,
					 WID_FROM, DEF_WIDTH_FROM,
					 WID_TITLE, DEF_WIDTH_TITLE_MAIL,
					 WID_IS_MARKED, DEF_WIDTH_IS_MARKED,
					 WID_IS_READ, DEF_WIDTH_IS_READ,
					 WID_DATE_CREATED, DEF_WIDTH_DATE_CREATED,
					 WID_PRIORITY, DEF_WIDTH_PRIORITY, 0);
		pClassDefs->Put(aColumnDefs);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FILEDLG);
		pClassDefs->Put(aColumnDefs, WID_VIEW_COLS_FLDWIN);

		pClassDefs->Put(CntIdentifierListItem(WID_PROPERTYLIST,
										      CNT_TABPAGE_GENERAL,
										      CNT_TABPAGE_RULES,
										      CNT_TABPAGE_VIEW_PROPERTIES,
										      CNT_TABPAGE_HEADER,
										      CNT_TABPAGE_CONTENT_PROPERTIES,
							   			      CNT_TABPAGE_BACKGROUND,
										      CNT_TABPAGE_FONT,
										      0));

		CntThreadingItem aThrItem(WID_THREADING);
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_IN_REPLY_TO,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PARENTCHAIN,
										 WID_FLAG_IS_MESSAGE, WID_REFERENCES,
										 WID_MESSAGE_ID, '<', WID_TITLE));
		aThrItem.Append(CntThreadingInfo(CNT_THREADING_BY_PROPVALUE,
										 WID_FLAG_IS_MESSAGE, WID_TITLE,
										 WID_TITLE));
		pClassDefs->Put(aThrItem);

		CntSortingItem aSortingDefs(WID_SORTING);
		aSortingDefs.Append(CntSortingInfo(WID_DATE_CREATED, FALSE));
		aSortingDefs.Append(CntSortingInfo(WID_TITLE, TRUE));
		pClassDefs->Put(aSortingDefs);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_BEAMER);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FILEDLG);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS);
		pClassDefs->Put(aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON);

		pClassDefs->Put(CntBoolItem(WID_VIEW_MODE_FLDWIN, TRUE));
		pClassDefs->Put(CntLayoutItem(WID_VIEW_LAYOUT_FLDWIN,
									  LAYOUT_MAILNEWS));
	}
	CntInterface::SetParent(pClassDefs);

	m_pImp = new CntVIMBBoardNodeImp(this);
}

//============================================================================
// virtual
CntVIMBBoardNode::~CntVIMBBoardNode()
{
	delete m_pImp;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMBBoardNode::JobArrived(CntNodeJob * pJob)
{
	if (!pJob->GetSubject()->ISA(CntMessageNode))
		return CntNode::JobArrived(pJob);

	ULONG nCount = JobCount();
	for (ULONG i = 0; i < nCount; ++i)
		if (GetJob(i)->GetSubject() == pJob->GetSubject())
			return CntNode::JobArrived(pJob);

	EnqueueJob(pJob);
	return DoExecuteJob(pJob);
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMBBoardNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetSubject() == this)
	{
		switch (pJob->GetRequest()->Which())
		{
			case WID_OPEN:
			case WID_UPDATE:
			case WID_SYNCHRONIZE:
			case WID_SEARCH:
				m_pImp->Initialize(*pJob);
				m_pImp->Open(pJob);
				return 0;

			case WID_GETDATA:
			{
				m_pImp->Initialize(*pJob);

				// Put subscribed flag into anchor:
				CntStorageNode * pViewData = pJob->GetViewDataNode();
				if (pViewData)
				{
					UINT32 nAttrib = 0;
					pViewData->
						attrib(INetURLObject::encode(
							       THIS_ITEM_VALUE(CntStringItem, WID_TITLE),
								   INetURLObject::PART_VIM, '=',
								   INetURLObject::ENCODE_ALL),
							   0, 0, nAttrib);
					pJob->GetViewDataTarget()->
					 CntInterface::Put
					  (CntBoolItem
					    (WID_FLAG_SUBSCRIBED,
						 CAST_TO_BOOL(nAttrib
									   & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED)),
					   WID_FLAG_SUBSCRIBED);
				}
				break;
			}

			case WID_CREATE_NEW:
			{
				m_pImp->Initialize(*pJob);

				CntNodeItem * pMsg
				 = INSECURE_DYNAMIC_CAST(CntNodeItem *,
										 CntNode::ExecuteJob(pJob));
				CntVIMNodeImp::createNewMessage(pMsg, pJob, TRUE,
												THIS_ITEM_VALUE(CntStringItem,
																WID_TITLE));
				return pMsg;
			}

			case WID_IS_READ:
			case WID_IS_MARKED:
				m_pImp->Initialize(*pJob);
				m_pImp->Flag(pJob);
				return 0;

			case WID_FLAG_SUBSCRIBED:
				m_pImp->Initialize(*pJob);
				m_pImp->SubscribedStatusChange(pJob);
				break;

			case WID_CLEAN_CACHE:
				m_pImp->Initialize(*pJob);
				m_pImp->CleanCache(pJob);
				return 0;
		}
	}
	else
	{
		CntMessageNode * pMsg = PTR_CAST(CntMessageNode, pJob->GetSubject());
		if (pMsg)
			switch (pJob->GetRequest()->Which())
			{
				case WID_OPEN:
					m_pImp->Initialize(*pJob);
					m_pImp->OpenMsg(pMsg, pJob);
					return 0;

				case WID_GETDATA:
					m_pImp->InitMessage(pJob, pMsg);
					break;

				case WID_IS_READ:
				case WID_IS_MARKED:
					m_pImp->Initialize(*pJob);
					m_pImp->
					 MarkMsg(pMsg,
							 *INSECURE_DYNAMIC_CAST(const CntBoolItem *,
													pJob->GetRequest()),
							 pJob);
					return 0;
			}
	}

	return CntNode::ExecuteJob(pJob);
}

