/*************************************************************************
 *
 *  $RCSfile: cpop3box.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CPOP3BOX_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _EINF_HXX
#include <tools/errinf.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#ifndef _CNTPOP3IMP_HXX
#include "cpop3imp.hxx"
#endif
#ifndef _CNTMMITM_HXX
#include "cntmmitm.hxx"
#endif

#ifndef _CNTVWITM_HXX
#define ITEMID_CNT_MSG_VIEWMODE WID_MESSAGEVIEW_MODE
#include "cntvwitm.hxx"
#endif

#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif

#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntPOP3Box... Internals.
 *
 *=====================================================================*/
/*
 * CntStoreItemSet ranges.
 */
CPOP3MSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

#ifdef DBG_UTIL_PRIVATE

/*
 * __trace_datetime.
 */
String __trace_datetime (const DateTime &rDate)
{
	String aTrace;
	aTrace += rDate.GetDay();   aTrace += '-';
	aTrace += rDate.GetMonth(); aTrace += '-';
	aTrace += rDate.GetYear();  aTrace += ' ';
	aTrace += rDate.GetHour();  aTrace += ':';
	aTrace += rDate.GetMin();   aTrace += ':';
	aTrace += rDate.GetSec();
	return aTrace;
}

/*
 * __trace_message.
 */
String __trace_message (
	const CntPOP3ListEntry_Impl &rEntry,
	const INetCoreNewsMessage   &rMessage)
{
	String aTrace;
	aTrace += rEntry.m_nIndex;                   aTrace += '\t';
	aTrace += __trace_datetime (rEntry.m_aDate); aTrace += '\t';
	aTrace += rMessage.GetTo();                  aTrace += '\t';
	aTrace += rMessage.GetFrom();                aTrace += '\t';
	aTrace += rMessage.GetSubject();             aTrace += '\t';
	aTrace += rMessage.GetMessageID();
	return aTrace;
}

#endif /* DBG_UTIL_PRIVATE */

/*=======================================================================
 *
 * CntPOP3BoxOpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3BoxOpenJob_Impl.
 */
CntPOP3BoxOpenJob_Impl::CntPOP3BoxOpenJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob   (NULL),
	  m_pCache    (NULL),
	  m_pUserData (NULL),
	  m_pIter     (NULL),
	  m_nIter     (0),
	  m_nInclMask (0),
	  m_nExclMask (0),
	  m_nHintId   (0),
	  m_eState    (STATE_NONE)
{
}

/*
 * ~CntPOP3BoxOpenJob_Impl.
 */
CntPOP3BoxOpenJob_Impl::~CntPOP3BoxOpenJob_Impl (void)
{
	delete m_pIter;
}

/*
 * queryResult.
 */
CntNode* CntPOP3BoxOpenJob_Impl::queryResult (
	const String &rUrl, UINT32 nAttrib)
{
	// Setup message URL.
	String aMsgURL (m_aRootURL);
	CPOP3IMP_CONCAT_URLPATH (aMsgURL, rUrl);

	// Query a CntMessageNode.
	CntNode *pNode = GetRootNode()->Query (aMsgURL);
	if ((pNode == NULL) || pNode->IsInserted())
		return pNode;

	// Obtain message itemset.
	CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
		aMsgDirRanges_Impl, rUrl, STREAM_STD_READ));
	if (xDirSet.Is())
	{
		// Deliver message itemset.
		pNode->Put (*xDirSet);
		xDirSet.Clear();

		// Check message body.
		if (CntPOP3Message_Impl::queryAvailable (*pNode, m_pCache))
			pNode->ClearItem (WID_MESSAGEBODY);
	}

	// Set UserData attributes.
	BOOL bSeen   = (nAttrib & CNTDIRENTRY_ATTRIB_UNSEEN) ? 0 : 1;
	BOOL bMarked = (nAttrib & CNTDIRENTRY_ATTRIB_MARKED) ? 1 : 0;

	pNode->Put (CntBoolItem (WID_IS_READ, bSeen));
	pNode->Put (CntBoolItem (WID_IS_MARKED, bMarked));

	// Done.
	return pNode;
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3BoxOpenJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3BoxOpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT(
		pReq, "CntPOP3BoxOpenJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3BoxOpenJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3BoxOpenJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Determine (view mode dependent) iteration mask and state.
		USHORT eViewMode = ITEMSET_VALUE(
			pJob->GetClient(), CntMsgViewModeItem, WID_MESSAGEVIEW_MODE);
		switch (eViewMode)
		{
			case CNT_VIEW_MARKED_AND_UNREAD_ARTICLES:
				m_nInclMask = (CNTDIRENTRY_ATTRIB_MARKED |
							   CNTDIRENTRY_ATTRIB_UNSEEN   );
				m_eState = STATE_USER;
				break;

			case CNT_VIEW_MARKED_ARTICLES:
				m_nInclMask = CNTDIRENTRY_ATTRIB_MARKED;
				m_eState = STATE_USER;
				break;

			case CNT_VIEW_UNREAD_ARTICLES:
				m_nInclMask = CNTDIRENTRY_ATTRIB_UNSEEN;
				m_eState = STATE_USER;
				break;

			case CNT_VIEW_READ_ARTICLES:
				m_nExclMask = CNTDIRENTRY_ATTRIB_UNSEEN;
				m_eState = STATE_CACHE;
				break;

			default: // CNT_VIEW_ALL_ARTICLES.
				m_eState = STATE_CACHE;
				break;
		}

		// Complete exclude mask.
		m_nExclMask |= CNTDIRENTRY_ATTRIB_HIDDEN;
		m_nExclMask |= CNTDIRENTRY_ATTRIB_MARKEDFORDELETE;
		m_nExclMask |= CNTDIRENTRY_ATTRIB_DELETEONCLIENT;

		// Initialize iteration.
		m_aRootURL = OWN_URL (GetRootNode());
		m_pIter = new CntStorageIterator (m_nInclMask, m_nExclMask);
		m_nIter = 0;

		// Notify caller (ProgressStart).
		ULONG nTotal = ITEMSET_VALUE(
			GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);
		if (nTotal)
		{
			m_nHintId = CntStatusBarHint::CreateHintId();
			Broadcast (CntStatusBarHint (
				m_nHintId, 1, nTotal,
				String (CntResId (RID_PROT_LOADING_MESSAGES))));
		}
	}

	if (m_eState == STATE_CACHE)
	{
		// Cache node iteration.
		m_pCache->iter (*m_pIter);
		while (!m_pIter->eof())
		{
			// Obtain UserData attributes, too.
			UINT32 nAttrib = 0;
			m_pUserData->attrib ((**m_pIter).m_pszName, 0, 0, nAttrib);
			if (!(nAttrib & m_nExclMask))
			{
				// Process current message.
				CntNodeRef xNode (queryResult (
					(**m_pIter).m_pszName, nAttrib));
				if (xNode.Is())
					Result (xNode);
			}
			m_nIter++;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller (ProgressSet).
				Broadcast (CntStatusBarHint (m_nHintId, m_nIter));

				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}

			// Next.
			m_pCache->iter (*m_pIter);
		}

		// Next state.
		m_eState = STATE_UPDATE;
	}

	if (m_eState == STATE_USER)
	{
		// UserData node iteration.
		m_pUserData->iter (*m_pIter);
		while (!m_pIter->eof())
		{
			// Process current message.
			CntNodeRef xNode (queryResult (
				(**m_pIter).m_pszName, (**m_pIter).m_nAttrib));
			if (xNode.Is())
				Result (xNode);
			m_nIter++;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
			{
				// Notify caller (ProgressSet).
				Broadcast (CntStatusBarHint (m_nHintId, m_nIter));

				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}

			// Next.
			m_pUserData->iter (*m_pIter);
		}

		// Next state.
		m_eState = STATE_UPDATE;
	}

	if (m_eState == STATE_UPDATE)
	{
		// Check for SubJob.
		if (!m_xSubJob.Is())
		{
			// Cleanup iteration.
			if (m_nHintId)
			{
				// Notify caller (ProgressEnd).
				Broadcast (CntStatusBarHint (m_nHintId));
				m_nHintId = 0;
			}
			DELETEZ (m_pIter);

			// Check for UpdateOnOpen.
			BOOL bUpdateOnOpen = ITEMSET_VALUE(
				pJob->GetClient(), CntBoolItem, WID_FLAG_UPDATE_ON_OPEN);

			CntConnMode eConnMode = GetParent()->GetConnMode();
			bUpdateOnOpen &= (eConnMode == CNT_CONN_MODE_ONLINE);

			if (bUpdateOnOpen)
			{
				// Setup SubJob.
				m_xSubJob = new CntNodeJob (
					pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
				CntPOP3Job_Impl *pJobImpl =
					new CntPOP3BoxUpdateJob_Impl (m_xSubJob, GetParent());

				// Start SubJob.
				StartListening (*m_xSubJob);
				GetRootNode()->RescheduleJob (m_xSubJob);
				return NULL;
			}
		}
		else
		{
			// Check SubJob result.
			if (m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Cleanup.
			m_xSubJob.Clear();
		}

		// Next state.
		m_eState = STATE_DONE;
	}

	if (m_eState == STATE_DONE)
	{
		// Finished.
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * Notify.
 */
void CntPOP3BoxOpenJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3BoxUpdateJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3BoxUpdateJob_Impl.
 */
CntPOP3BoxUpdateJob_Impl::CntPOP3BoxUpdateJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob         (NULL),
	  m_pCache          (NULL),
	  m_pUserData       (NULL),
	  m_pMailer         (NULL),
	  m_pMessage        (NULL),
	  m_aLast           (0),
	  m_pNewest         (NULL),
	  m_pOldest         (NULL),
	  m_nIndex          (0),
	  m_eState          (STATE_NONE),
	  m_eDirection      (DIRECTION_NONE),
	  m_bStoreLocal     (FALSE),
	  m_bDeleteOnServer (FALSE)
{
}

/*
 * ~CntPOP3BoxUpdateJob_Impl.
 */
CntPOP3BoxUpdateJob_Impl::~CntPOP3BoxUpdateJob_Impl (void)
{
	delete m_pMessage;
}

/*
 * queryAvailable.
 */
CntPOP3BoxUpdateJob_Impl::Availability
CntPOP3BoxUpdateJob_Impl::queryAvailable (CntPOP3ListEntry_Impl &rEntry)
{
	if (rEntry.m_aUniqueID.Len() || rEntry.m_aMsgID.Len())
	{
		String aUID (rEntry.m_aUniqueID);
		if (aUID.Len())
		{
			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aMsgDirRanges_Impl, aUID, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				const SfxDateTimeItem &rDate =
					(const SfxDateTimeItem&)(xDirSet->Get(WID_DATE_CREATED));
				rEntry.m_aDate = rDate.GetDateTime();

				rEntry.m_aMsgID = ITEMSET_VALUE(
					xDirSet, CntStringItem, WID_MESSAGE_ID);
				rEntry.m_nSize = ITEMSET_VALUE(
					xDirSet, CntUInt32Item, WID_SIZE);

				if (aUID.CompareTo (m_aLast.m_aUniqueID) == COMPARE_EQUAL)
					return AVAIL_LASTKNOWN;
				else
					return AVAIL_KNOWN;
			}

			if (aUID.CompareTo (m_aLast.m_aUniqueID) == COMPARE_EQUAL)
				return AVAIL_LASTKNOWN;
		}

		String aMID (rEntry.m_aMsgID);
		if (aMID.Len())
		{
			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aMsgDirRanges_Impl, aMID, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				const SfxDateTimeItem &rDate =
					(const SfxDateTimeItem&)(xDirSet->Get(WID_DATE_CREATED));
				rEntry.m_aDate = rDate.GetDateTime();

				rEntry.m_aUniqueID = ITEMSET_VALUE(
					xDirSet, CntStringItem, WID_UNIQUE_ID);
				rEntry.m_nSize = ITEMSET_VALUE(
					xDirSet, CntUInt32Item, WID_SIZE);

				if (aMID.CompareTo (m_aLast.m_aMsgID) == COMPARE_EQUAL)
					return AVAIL_LASTKNOWN;
				else
					return AVAIL_KNOWN;
			}

			if (aMID.CompareTo (m_aLast.m_aMsgID) == COMPARE_EQUAL)
				return AVAIL_LASTKNOWN;
		}
		return AVAIL_UNKNOWN;
	}
	return AVAIL_DONTKNOW;
}

/*
 * queryDownload.
 */
BOOL CntPOP3BoxUpdateJob_Impl::queryDownload (
	CntPOP3ListEntry_Impl &rEntry, INetCoreNewsMessage &rMessage)
{
	if (m_bStoreLocal)
	{
		String aDataUrl;
		if (rEntry.m_aUniqueID.Len())
			aDataUrl += rEntry.m_aUniqueID;
		else
			aDataUrl += rEntry.m_aMsgID;
		aDataUrl.AppendAscii (".data");

		SvStream *pDataStrm = m_pCache->openStream (
			aDataUrl, STREAM_READWRITE | STREAM_TRUNC);
		if (pDataStrm)
		{
			m_pCache->attrib (aDataUrl, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

			rMessage.SetDocumentStream (pDataStrm);
			rMessage.SetDocumentFilename (aDataUrl);

			return TRUE;
		}
	}
	return FALSE;
}

/*
 * queryResult.
 */
CntNode* CntPOP3BoxUpdateJob_Impl::queryResult (
	CntPOP3ListEntry_Impl &rEntry, INetCoreNewsMessage &rMessage)
{
	// Make overview available.
	CntStoreItemSetRef xDirSet (
		CntPOP3Message_Impl::storeAvailable (rEntry, rMessage, m_pCache));
	if (xDirSet.Is())
	{
		// Create UserData entry.
		m_pUserData->attrib (
			rEntry.m_aMsgID, 0,
			(CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_UNSEEN));

		// Update KnownContentCount.
		CntStoreItemSetRef xBoxSet (GetParent()->GetBoxItemSet (m_pCache));
		if (xBoxSet.Is())
		{
			ULONG nKnown = ITEMSET_VALUE(
				xBoxSet, CntUInt32Item, WID_TOTALCONTENTCOUNT);

			CntUInt32Item aKnown (WID_TOTALCONTENTCOUNT, nKnown + 1);
			xBoxSet->Put (aKnown);

			GetRootNode()->Put (aKnown);
			GetRootNode()->Put (CntBoolItem (WID_IS_READ, FALSE));
		}

		// Setup message URL.
		String aMsgURL (OWN_URL (GetRootNode()));
		CPOP3IMP_CONCAT_URLPATH (aMsgURL, rEntry.m_aMsgID);

		// Create message node.
		CntNode *pNode = GetRootNode()->Query (aMsgURL);
		if (pNode)
		{
			// Deliver message itemset.
			pNode->Put (*xDirSet);

			// Check message body.
			if (CntPOP3Message_Impl::queryAvailable (*pNode, m_pCache))
				pNode->ClearItem (WID_MESSAGEBODY);
		}
		return pNode;
	}
	return NULL;
}

/*
 * storeDownload.
 */
BOOL CntPOP3BoxUpdateJob_Impl::storeDownload (
	CntPOP3ListEntry_Impl &rEntry, INetCoreNewsMessage &rMessage)
{
	// Store body stream.
	String aUrl (OWN_URL (GetRootNode()));
	CPOP3IMP_CONCAT_URLPATH (aUrl, rEntry.m_aMsgID);
	if (CntPOP3Message_Impl::storeDownload (aUrl, rMessage, m_pCache))
	{
		// Setup body URL.
		aUrl.AppendAscii (".body");

		// Force MessageBody storage.
		CntMessageBodyItem aBodyItem (WID_MESSAGEBODY, aUrl);
		aBodyItem.Get (m_pCache, m_pMailer, TRUE);
		return TRUE;
	}

	// Cleanup data stream.
	CntPOP3Message_Impl::cleanupDownload (rMessage, m_pCache);
	return FALSE;
}

/*
 * showStatusText.
 */
void CntPOP3BoxUpdateJob_Impl::showStatusText (ULONG nDone, ULONG nTotal)
{
	// Check Done range.
	if ((nDone > nTotal) && (nTotal > 0))
		nDone = nTotal;

	// Setup DoneText.
	UniString aDoneText (UniString::CreateFromInt32 (nDone));
	if (nTotal)
	{
		aDoneText += sal_Unicode('/');
		aDoneText += UniString::CreateFromInt32 (nTotal);
	}

	// Setup StatusText.
	String aStatusText (CntResId (RID_PROT_TRANSFERING_MESSAGE));
	aStatusText.SearchAndReplace (S2U ("$(ARG1)"), aDoneText);

	// Notify caller.
	Broadcast (CntStatusBarHint (aStatusText));
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3BoxUpdateJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3BoxUpdateJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntPOP3BoxUpdateJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3BoxUpdateJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3BoxUpdateJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Next state.
		m_eState = STATE_CLOSE;
	}

	if (m_eState == STATE_CLOSE)
	{
		// Check SubJob.
		if (!m_xSubJob.Is())
		{
			// Obtain mailer.
			m_pMailer = GetParent()->GetMailer();
			DBG_ASSERT(
				m_pMailer, "CntPOP3BoxUpdateJob_Impl::Execute(): no Mailer");
			if (m_pMailer == NULL)
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Check for connection still open.
			if (m_pMailer->RecvIsOpen())
			{
				// Setup SubJob.
				m_xSubJob = new CntNodeJob (
					pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
				CntPOP3Job_Impl *pJobImpl =
					new CntPOP3CloseJob_Impl (m_xSubJob, GetParent());

				// Start SubJob.
				StartListening (*m_xSubJob);
				GetRootNode()->RescheduleJob (m_xSubJob);
				return NULL;
			}
		}
		else
		{
			// Check SubJob result.
			if (m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Cleanup.
			m_xSubJob.Clear();
			m_pMailer = NULL;
		}

		// Next state.
		m_eState = STATE_OPEN;
	}

	if (m_eState == STATE_OPEN)
	{
		// Check SubJob.
		if (!m_xSubJob.Is())
		{
			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
			CntPOP3Job_Impl *pJobImpl =
				new CntPOP3OpenJob_Impl (m_xSubJob, GetParent());

			// Start SubJob.
			StartListening (*m_xSubJob);
			GetRootNode()->RescheduleJob (m_xSubJob);
			return NULL;
		}
		else
		{
			// Check SubJob result.
			if (m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Cleanup.
			m_xSubJob.Clear();
		}

		// Initialize next state.
		CntPOP3List_Impl &rList = GetParent()->GetList();
		if (rList.Count())
		{
			// Obtain mailer.
			m_pMailer = GetParent()->GetMailer();
			DBG_ASSERT(
				m_pMailer, "CntPOP3BoxUpdateJob_Impl::Execute(): no Mailer");
			if (m_pMailer == NULL)
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Check for UniqueIdList availability.
			CntPOP3ListEntry_Impl *pEntry = rList.GetObject(0);
			if (!(pEntry && pEntry->m_aUniqueID.Len()))
			{
				// Obtain most recent entry.
				m_aLast.m_aUniqueID = ITEMSET_VALUE(
					GetRootNode(), CntStringItem, WID_LAST_UID);
				m_aLast.m_aMsgID = ITEMSET_VALUE(
					GetRootNode(), CntStringItem, WID_LAST_MSGID);
			}

			// Obtain StoreMode and DeleteOnServer.
			USHORT eStoreMode = ITEMSET_VALUE(
				GetRootNode(), CntMsgStoreModeItem, WID_MESSAGE_STOREMODE);
			m_bStoreLocal = (eStoreMode == CNT_MESSAGE_STOREMODE_LOCAL);

			m_bDeleteOnServer = ITEMSET_VALUE(
				GetRootNode(), CntBoolItem, WID_DELETE_ON_SERVER);
			m_bDeleteOnServer &= m_bStoreLocal;

			// Jump into state machine.
			m_eState = STATE_LIST;
			ExecuteCallback (m_pMailer, INETCOREPOP3_REPLY_OK, NULL, this);
			return NULL;
		}

		// Finished.
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3BoxUpdateJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntPOP3BoxUpdateJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_LIST:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					CntPOP3List_Impl &rList = GetParent()->GetList();
					if (m_eDirection == DIRECTION_NONE)
					{
						// Determine update direction.
						if (m_pNewest == NULL)
						{
							// Obtain (supposed) newest entry.
							m_nIndex  = rList.Count();
							m_pNewest = rList.GetObject (m_nIndex - 1);

							// Check availability.
							Availability result = queryAvailable (*m_pNewest);
							if (result != AVAIL_KNOWN)
							{
								if (result == AVAIL_LASTKNOWN)
									m_eState = STATE_UPDATE;
								else
									m_eState = STATE_LOAD;
							}
						}
						else if (m_pOldest == NULL)
						{
							// Obtain (supposed) oldest entry.
							m_nIndex  = 1;
							m_pOldest = rList.GetObject (m_nIndex - 1);

							// Check availability.
							Availability result = queryAvailable (*m_pOldest);
							if (result != AVAIL_KNOWN)
							{
								if (result == AVAIL_LASTKNOWN)
									m_eState = STATE_UPDATE;
								else
									m_eState = STATE_LOAD;
							}
						}
						else
						{
							// Setup update direction.
							if (m_pOldest->m_aDate <= m_pNewest->m_aDate)
							{
								// top-down.
								m_nIndex     = rList.Count();
								m_eDirection = DIRECTION_N_TO_1;
							}
							else
							{
								// bottom-up.
								m_nIndex     = 1;
								m_eDirection = DIRECTION_1_TO_N;
							}
						}
					}
					else
					{
						// Obtain next index.
						if (m_eDirection == DIRECTION_N_TO_1)
							m_nIndex -= 1;
						else
							m_nIndex += 1;

						// Check current index.
						if ((1 < m_nIndex) && (m_nIndex < rList.Count()))
						{
							// Obtain current entry.
							CntPOP3ListEntry_Impl *e =
								GetParent()->GetListEntry (m_nIndex - 1);

							// Check availability.
							Availability result = queryAvailable (*e);
							if (result != AVAIL_KNOWN)
							{
								if (result == AVAIL_LASTKNOWN)
									m_eState = STATE_UPDATE;
								else
									m_eState = STATE_LOAD;
							}
						}
						else
						{
							// Finished.
							m_eState = STATE_UPDATE;
						}
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_LOAD:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);

					// Check availability.
					Availability result = queryAvailable (*e);
					if (result == AVAIL_DONTKNOW)
					{
						// Dontknow. Obtain MessageID.
						m_pMessage = m_pMailer->CreateINetCoreNewsMessage();
						m_eState = STATE_HEAD;

						if (!m_pMailer->RecvMailHead (
							e->m_nIndex, *m_pMessage,
							ExecuteCallback, this))
						{
							if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
							{
								// Try again.
								m_eState = STATE_OPEN;
								GetRootNode()->RescheduleJob (pJob);
							}
						}

						// Wait for next callback.
						return;
					}
					else if (result == AVAIL_UNKNOWN)
					{
						// Not yet known. Obtain message.
						m_pMessage = m_pMailer->CreateINetCoreNewsMessage();
						if (queryDownload (*e, *m_pMessage))
						{
							// Retrieve mail.
							m_eState = STATE_MAIL;

							m_pMailer->RecvSetTransferCallback (
								ExecuteCallback, this);

							if (!m_pMailer->RecvMail (
								e->m_nIndex, *m_pMessage,
								ExecuteCallback, this))
							{
								if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
								{
									// Try again.
									m_eState = STATE_OPEN;
									GetRootNode()->RescheduleJob (pJob);
								}
							}
						}
						else
						{
							// Retrieve overview.
							m_eState = STATE_HEAD;

							if (!m_pMailer->RecvMailHead (
								e->m_nIndex, *m_pMessage,
								ExecuteCallback, this))
							{
								if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
								{
									// Try again.
									m_eState = STATE_OPEN;
									GetRootNode()->RescheduleJob (pJob);
								}
							}
						}

						// Wait for next callback.
						return;
					}
					else
					{
						// Already known.
						m_eState = STATE_LIST;
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_HEAD:
				if (nReplyCode >= 0)
				{
					nReplyCode = INETCOREPOP3_REPLY_OK;

					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);
					if (e->m_nSize == 0)
						e->m_nSize = GetParent()->GetMsgSize (pReplyText);

					// Check MessageID.
					if (e->m_aMsgID.Len() == 0)
					{
						// Obtain MessageID.
						String aMsgID;
						if (GetParent()->ReplaceInvalidMsgID (
							m_pMessage->GetMessageID(), aMsgID))
						{
							// Replace invalid MessageID.
							m_pMessage->SetMessageID (aMsgID);
						}
						e->m_aMsgID = m_pMessage->GetMessageID();
					}

					// Verify availability.
					Availability result = queryAvailable (*e);
#ifdef DBG_UTIL_PRIVATE
					if (result != AVAIL_UNKNOWN)
					{
						String aTrace (__trace_message (*e, *m_pMessage));
						_TRACE(aTrace);
					}
#endif /* DBG_UTIL_PRIVATE */
					if (result == AVAIL_UNKNOWN)
					{
						// New mail.
						if (queryDownload (*e, *m_pMessage))
						{
							// Retrieve mail.
							m_eState = STATE_MAIL;

							m_pMailer->RecvSetTransferCallback (
								ExecuteCallback, this);

							if (!m_pMailer->RecvMail (
								e->m_nIndex, *m_pMessage,
								ExecuteCallback, this))
							{
								if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
								{
									// Try again.
									m_eState = STATE_OPEN;
									GetRootNode()->RescheduleJob (pJob);
								}
							}

							// Wait for next callback.
							return;
						}
						else
						{
							// Create new message node.
							CntNodeRef xNode (
								queryResult (*e, *m_pMessage));
							if (xNode.Is())
								Result (xNode);
						}
					}

					// Cleanup.
					DELETEZ (m_pMessage);

					// Next.
					m_eState = STATE_LIST;
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_MAIL:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Clear TransferCallback.
					m_pMailer->RecvSetTransferCallback (NULL, NULL);

					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);
					if (e->m_nSize == 0)
						e->m_nSize = GetParent()->GetMsgSize (pReplyText);
					if (e->m_nSize == 0)
						e->m_nSize = m_pMailer->RecvGetTransferCount();

					// Check MessageID.
					if (e->m_aMsgID.Len() == 0)
					{
						// Obtain MessageID.
						String aMsgID;
						if (GetParent()->ReplaceInvalidMsgID (
							m_pMessage->GetMessageID(), aMsgID))
						{
							// Replace invalid MessageID.
							m_pMessage->SetMessageID (aMsgID);
						}
						e->m_aMsgID = m_pMessage->GetMessageID();
					}

					// Store download and notify caller.
					storeDownload (*e, *m_pMessage);
					showStatusText (e->m_nSize, e->m_nSize);

					// Verify availability.
					Availability result = queryAvailable (*e);
#ifdef DBG_UTIL_PRIVATE
					if (result != AVAIL_UNKNOWN)
					{
						String aTrace (__trace_message (*e, *m_pMessage));
						_TRACE(aTrace);
					}
#endif /* DBG_UTIL_PRIVATE */
					if (result == AVAIL_UNKNOWN)
					{
						// New mail. Create new message node.
						CntNodeRef xNode (
							queryResult (*e, *m_pMessage));
						if (xNode.Is())
							Result (xNode);
					}

					// Cleanup.
					DELETEZ (m_pMessage);

					// Check for DeleteOnServer.
					if (m_bDeleteOnServer)
					{
						// Delete from server.
						m_eState = STATE_DELETE;

						if (!m_pMailer->RecvDeleteMail (
							e->m_nIndex, ExecuteCallback, this))
						{
							if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
							{
								// Try again.
								m_eState = STATE_OPEN;
								GetRootNode()->RescheduleJob (pJob);
							}
						}

						// Wait for next callback.
						return;
					}
					else
					{
						// Next.
						m_eState = STATE_LIST;
					}
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);

					// Notify caller.
					ULONG n = m_pMailer->RecvGetTransferCount();
					showStatusText (n, e->m_nSize);

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DELETE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);

					// Mark as DeletedOnServer.
					m_pCache->attrib (
						e->m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONSERVER);

					// Next.
					m_eState = STATE_LIST;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_UPDATE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Check update direction.
					if (m_eDirection != DIRECTION_NONE)
					{
						// Obtain box itemset.
						CntStoreItemSetRef xDirSet (
							GetParent()->GetBoxItemSet (m_pCache));
						if (xDirSet.Is())
						{
							// Obtain most recent index.
							CntPOP3List_Impl &rList = GetParent()->GetList();
							if (m_eDirection == DIRECTION_N_TO_1)
								m_nIndex = rList.Count();
							else
								m_nIndex = 1;

							// Update most recent entry.
							CntPOP3ListEntry_Impl *e =
								rList.GetObject (m_nIndex - 1);

							xDirSet->Put (CntStringItem (
								WID_LAST_UID, e->m_aUniqueID));
							xDirSet->Put (CntStringItem (
								WID_LAST_MSGID, e->m_aMsgID));

							GetRootNode()->Put (*xDirSet);
							xDirSet.Clear();
						}
					}

					// Next state.
					m_eState = STATE_DONE;
					if (m_bStoreLocal)
					{
						// Can (must) close connection.
						if (!m_pMailer->RecvCloseConnection (
							ExecuteCallback, this))
						{
							if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
							{
								// Try again.
								m_eState = STATE_OPEN;
								GetRootNode()->RescheduleJob (pJob);
							}
						}

						// Wait for next callback.
						return;
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Finished.
					pJob->Done();
					m_eState = STATE_NONE;
				}
				else
				{
					// Failure.
					pJob->Cancel();
					m_eState = STATE_NONE;
				}
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntPOP3BoxUpdateJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*pJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Finished.
			EndListening (*pJob);

			// Check for abort.
			if (pJob->IsCancelled())
			{
				// Job has been canceled.
				if (m_pMailer)
					m_pMailer->RecvAbortConnection();

				// Finish.
				m_eState = STATE_NONE;
			}

			if (m_pMessage)
			{
				// Cleanup data stream.
				CntPOP3Message_Impl::cleanupDownload (*m_pMessage, m_pCache);
				DELETEZ (m_pMessage);
			}

			// RemoveStatusText.
			Broadcast (CntStatusBarHint (String()));
		}
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3BoxSyncJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3BoxSyncJob_Impl.
 */
CntPOP3BoxSyncJob_Impl::CntPOP3BoxSyncJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob       (NULL),
	  m_pCache        (NULL),
	  m_pUserData     (NULL),
	  m_pIter         (NULL),
	  m_nIter         (0),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3BoxSyncJob_Impl.
 */
CntPOP3BoxSyncJob_Impl::~CntPOP3BoxSyncJob_Impl (void)
{
	delete m_pIter;
}

/*
 * find.
 */
CntPOP3ListEntry_Impl* CntPOP3BoxSyncJob_Impl::find (const String &rMsgID)
{
	CntPOP3List_Impl &rList  = GetParent()->GetList();
	CntPOP3ListEntry_Impl *e = NULL;

	ULONG i = 0, n = rList.Count();
	while (i < n)
	{
		e = rList.GetObject(i++);
		if (rMsgID.CompareTo (e->m_aMsgID) == COMPARE_EQUAL)
			break;
	}
	return e;
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3BoxSyncJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3BoxSyncJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntPOP3SyncJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3BoxSyncJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3BoxSyncJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Next state.
		m_eState = STATE_DELETE;
	}

	if (m_eState == STATE_DELETE)
	{
		// Check iterator.
		if (m_pIter == NULL)
		{
			// Initialize cache node iteration.
			UINT32 nInclMask = 0;
			nInclMask |= CNTDIRENTRY_ATTRIB_DELETEONCLIENT;

			m_pIter = new CntStorageIterator (nInclMask, 0);
			m_nIter = 0;
		}

		// Iterate.
		m_pCache->iter (*m_pIter);
		while (!m_pIter->eof())
		{
			m_pCache->remove ((**m_pIter).m_pszName);
			m_nIter++;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
			{
				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}

			// Next.
			m_pCache->iter (*m_pIter);
		}

		// Next state.
		DELETEZ (m_pIter);
		m_eState = STATE_UPDATE;
	}

	if (m_eState == STATE_UPDATE)
	{
		// Check for SubJob.
		if (!m_xSubJob.Is())
		{
			// Reset most recent information.
			GetRootNode()->Put (CntStringItem (WID_LAST_UID, String()));
			GetRootNode()->Put (CntStringItem (WID_LAST_MSGID, String()));

			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
			CntPOP3Job_Impl *pJobImpl =
				new CntPOP3BoxUpdateJob_Impl (m_xSubJob, GetParent());

			// Start SubJob.
			StartListening (*m_xSubJob);
			GetRootNode()->RescheduleJob (m_xSubJob);
			return NULL;
		}
		else
		{
			// Check SubJob result.
			if (m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Cleanup.
			m_xSubJob.Clear();
		}

		// Next state.
		DELETEZ (m_pIter);
		m_eState = STATE_CACHE;
	}

	if (m_eState == STATE_CACHE)
	{
		// Check iterator.
		if (m_pIter == NULL)
		{
			// Initialize cache node iteration.
			UINT32 nExclMask = 0;
			nExclMask |= CNTDIRENTRY_ATTRIB_HIDDEN;
			nExclMask |= CNTDIRENTRY_ATTRIB_MARKEDFORDELETE;
			nExclMask |= CNTDIRENTRY_ATTRIB_DELETEONCLIENT;

			m_pIter = new CntStorageIterator (0, nExclMask);
			m_nIter = 0;
		}

		// Iterate.
		m_pCache->iter (*m_pIter);
		while (!m_pIter->eof())
		{
#if 0  /* PERFORMANCE */
			CntPOP3ListEntry_Impl *e = find ((**m_pIter).m_pszName);
			if (e == NULL)
			{
			}
#endif /* PERFORMANCE */
			m_nIter++;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
			{
				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}

			// Next.
			m_pCache->iter (*m_pIter);
		}

		// Update Box: KnownContentCount.
		CntUInt32Item aKnownCount (WID_TOTALCONTENTCOUNT, m_nIter);
		GetRootNode()->Put (aKnownCount);

		CntStoreItemSetRef xDirSet (GetParent()->GetBoxItemSet (m_pCache));
		if (xDirSet.Is())
		{
			xDirSet->Put (aKnownCount);
			xDirSet.Clear();
		}

		// Next state.
		DELETEZ (m_pIter);
		m_eState = STATE_USER;
	}

	if (m_eState == STATE_USER)
	{
		// Check iterator.
		if (m_pIter == NULL)
		{
			// Initialize UserData node iteration.
			UINT32 nInclMask = 0;
			nInclMask |= CNTDIRENTRY_ATTRIB_UNSEEN;

			UINT32 nExclMask = 0;
			nExclMask |= CNTDIRENTRY_ATTRIB_HIDDEN;
			nExclMask |= CNTDIRENTRY_ATTRIB_MARKEDFORDELETE;

			m_pIter = new CntStorageIterator (nInclMask, nExclMask);
			m_nIter = ITEMSET_VALUE(
				GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);
		}

		// Iterate.
		m_pUserData->iter (*m_pIter);
		while (!m_pIter->eof() && m_nIter)
		{
			// ...
			if ((**m_pIter).m_nAttrib & CNTDIRENTRY_ATTRIB_UNSEEN)
				m_nIter--;

			// Check elapsed time.
			ULONG nTicks = Time::GetSystemTicks();
			if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
			{
				// Be nice.
				GetRootNode()->RescheduleJob (pJob);
				return NULL;
			}

			// Next.
			m_pUserData->iter (*m_pIter);
		}

		// Update Box: SeenContentCount.
		CntUInt32Item aSeenCount (WID_SEENCONTENTCOUNT, m_nIter);
		GetRootNode()->Put (aSeenCount);

		CntStoreItemSetRef xUserSet (
			GetParent()->GetUserItemSet (m_pUserData));
		if (xUserSet.Is())
		{
			xUserSet->Put (aSeenCount);
			xUserSet.Clear();
		}

		// Next state.
		DELETEZ (m_pIter);
		m_eState = STATE_DONE;
	}

	if (m_eState == STATE_DONE)
	{
		// Finished.
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * Notify.
 */
void CntPOP3BoxSyncJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3BoxMarkJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3BoxMarkJob_Impl.
 */
CntPOP3BoxMarkJob_Impl::CntPOP3BoxMarkJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pCache        (NULL),
	  m_pUserData     (NULL),
	  m_pIter         (NULL)
{
}

/*
 * ~CntPOP3BoxMarkJob_Impl.
 */
CntPOP3BoxMarkJob_Impl::~CntPOP3BoxMarkJob_Impl (void)
{
	delete m_pIter;
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3BoxMarkJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntPOP3BoxMarkJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	const CntBoolItem *pReq = (const CntBoolItem *)(pJob->GetRequest());
	DBG_ASSERT(
		pReq, "CntPOP3BoxMarkJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	ULONG nStartTicks = Time::GetSystemTicks();
	if (m_pIter == NULL)
	{
		// Check current state.
		if (*pReq == GetRootNode()->Get (pReq->Which()))
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3BoxMarkJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3BoxMarkJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Initialize cache iteration.
		UINT32 nExclMask = 0;
		nExclMask |= CNTDIRENTRY_ATTRIB_HIDDEN;
		nExclMask |= CNTDIRENTRY_ATTRIB_MARKEDFORDELETE;

		m_pIter = new CntStorageIterator (0, nExclMask);
		m_aBoxURL = OWN_URL (GetRootNode());
	}

	// Mark all messages.
	m_pCache->iter (*m_pIter);
	while (!m_pIter->eof())
	{
		// Process current message.
		GetParent()->SetMsgUserFlag (m_pUserData, (**m_pIter).m_pszName, *pReq);

		// Setup message URL.
		String aMsgURL (m_aBoxURL);
		CPOP3IMP_CONCAT_URLPATH (aMsgURL, (**m_pIter).m_pszName);

		// Update message node.
		CntNodeRef xNode (GetRootNode()->Query (aMsgURL, FALSE));
		if (xNode.Is())
			xNode->Put (*pReq);

		// Done with current message.
		ULONG nTicks = Time::GetSystemTicks();
		if ((nTicks - nStartTicks) > CPOP3JOB_RESCHEDULE_TIMELIMIT)
		{
			// Be nice.
			GetRootNode()->RescheduleJob (pJob);
			return NULL;
		}

		// Next.
		m_pCache->iter (*m_pIter);
	}

	// Check SeenContentCount.
	if (pReq->Which() == WID_IS_READ)
	{
		// Update SeenContentCount.
		ULONG nTotal = ITEMSET_VALUE(
			GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);

		CntUInt32Item aSeenItem (
			WID_SEENCONTENTCOUNT, pReq->GetValue() ? nTotal : 0);
		GetRootNode()->Put (aSeenItem);

		CntStoreItemSetRef xUserSet (
			GetParent()->GetUserItemSet (m_pUserData));
		if (xUserSet.Is())
			xUserSet->Put (aSeenItem);
	}

	// Finished.
	GetRootNode()->Put (*pReq);
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntPOP3BoxMarkJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

