/*************************************************************************
 *
 *  $RCSfile: cpop3imp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CPOP3IMP_CXX "$Revision: 1.1.1.1 $"

#ifndef _OSL_INTERLCK_H_
#include <osl/interlck.h>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _TOOLS_INETMSG_HXX
#include <tools/inetmsg.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#ifndef _INET_WRAPPER_HXX
#include <inet/wrapper.hxx>
#endif

#ifndef _CNTPOP3IMP_HXX
#include "cpop3imp.hxx"
#endif
#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTINET_HXX
#include "cntinet.hxx"
#endif
#ifndef _CNTCMITM_HXX
#include "cntcmitm.hxx"
#endif
#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CNTMMITM_HXX
#include "cntmmitm.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CHAOS_MBXFORMT_HXX
#include "mbxformt.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif
#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF(CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntPOP3Node_Impl internals.
 *
 *=====================================================================*/
/*
 * CntStoreItemSet ranges.
 */
CPOP3BOX_DIR_RANGES_IMPL (aBoxDirRanges_Impl);
CPOP3BOX_USER_RANGES_IMPL (aBoxUserRanges_Impl);
CPOP3MSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*=======================================================================
 *
 * CntPOP3Node_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3Node_Impl.
 */
CntPOP3Node_Impl::CntPOP3Node_Impl (
	CntNode *pParent, CntConnMode eConnMode)
	: m_pParent      (pParent),
	  m_pMailer      (NULL),
	  m_nRefCount    (0),
	  m_eConnMode    (eConnMode),
	  m_bInitialized (FALSE)
{
}

/*
 * ~CntPOP3Node_Impl.
 */
CntPOP3Node_Impl::~CntPOP3Node_Impl (void)
{
	if (m_pMailer)
	{
		m_pMailer->RecvCloseConnection (NULL, NULL);
		delete m_pMailer;
	}

	ULONG i = 0, n = m_aList.Count();
	while (i < n)
		delete (m_aList.GetObject(i++));
	m_aList.Clear();
}

/*
 * Initialize.
 */
BOOL CntPOP3Node_Impl::Initialize (CntNodeJob *pJob)
{
	if (!m_bInitialized)
	{
		// Restore Box properties from Cache storage.
		CntStorageNode *pCache = pJob->GetCacheNode();
		DBG_ASSERT (pCache, "CntPOP3Node_Impl::Initialize(): no Cache");
		if (pCache == NULL)
			return FALSE;

		const SfxPoolItem* pItem = NULL;
		if (pCache->GetItemState (WID_SERVERNAME, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem (WID_SERVERNAME, String()));

		pItem = NULL;
		if (pCache->GetItemState (WID_USERNAME, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem (WID_USERNAME, String()));

		pItem = NULL;
		if (pCache->GetItemState (WID_PASSWORD, TRUE, &pItem)
			> SFX_ITEM_DEFAULT)
			m_pParent->Put (*pItem);
		else
			m_pParent->Put (CntStringItem (WID_PASSWORD, String()));

		m_pParent->Put (pCache->Get (WID_MESSAGE_STOREMODE));
		m_pParent->Put (pCache->Get (WID_DELETE_ON_SERVER));

		// Check for Servername.
		String aServername (ITEMSET_VALUE(
			m_pParent, CntStringItem, WID_SERVERNAME));
		if (aServername.Len() == 0)
		{
			// Obtain servername from box URL.
			INetURLObject aBoxURL (OWN_URL (m_pParent));

			aServername  = aBoxURL.GetHost();
			USHORT nPort = aBoxURL.GetPort();
			if (nPort)
			{
				aServername += sal_Unicode(':');
				aServername += UniString::CreateFromInt32 (nPort);
			}

			m_pParent->Put (CntStringItem (WID_SERVERNAME, aServername));
		}

		// Feed BoxDirectory and UserData itemsets into BoxNode.
		ULONG nTotal = 0;
		CntStoreItemSetRef xDirSet (GetBoxItemSet (pJob->GetDirectoryNode()));
		if (xDirSet.Is())
		{
			nTotal = ITEMSET_VALUE(
				xDirSet, CntUInt32Item, WID_TOTALCONTENTCOUNT);
			m_pParent->Put (*xDirSet);
			xDirSet.Clear();
		}

		ULONG nSeen = 0;
		CntStoreItemSetRef xUserSet (GetUserItemSet (pJob->GetUserDataNode()));
		if (xUserSet.Is())
		{
			nSeen = ITEMSET_VALUE(
				xUserSet, CntUInt32Item, WID_SEENCONTENTCOUNT);
			if (nSeen > nTotal)
			{
				nSeen = nTotal;
				xUserSet->Put (CntUInt32Item (WID_SEENCONTENTCOUNT, nSeen));
			}
			m_pParent->Put (*xUserSet);
			xUserSet.Clear();
		}

		m_pParent->Put (CntBoolItem (WID_IS_READ, (nSeen == nTotal)));

		// Done.
		m_bInitialized = TRUE;
	}
	return m_bInitialized;
}

/*
 * acquire.
 */
void CntPOP3Node_Impl::acquire (void)
{
	if (osl_incrementInterlockedCount (&m_nRefCount) <= 0)
	{
		// Logout and disconnect.
		close();
	}
}

/*
 * release.
 */
void CntPOP3Node_Impl::release (oslInterlockedCount n)
{
	while (n > 0)
	{
		n -= 1;
		if (osl_decrementInterlockedCount (&m_nRefCount) <= 0)
		{
			// Logout and disconnect.
			close();

			// Finished.
			break;
		}
	}
}

/*
 * close.
 */
void CntPOP3Node_Impl::close (void)
{
	if (m_pMailer)
	{
		// Initialize CntPOP3CloseJob_Impl execution.
		CntNodeJob *pJob = new CntNodeJob (
			NULL, m_pParent, m_pParent,
			CntConnModeItem (WID_CONNECTION_MODE, m_eConnMode));

		CntPOP3Job_Impl *pJobImpl =
			new CntPOP3CloseJob_Impl (pJob, this);
		pJob->SetRequestData (pJobImpl);

		// Insert job at parent.
		m_pParent->InsertJob (pJob);
	}
}

/*
 * SetConnMode.
 */
void CntPOP3Node_Impl::SetConnMode (CntConnMode eConnMode)
{
	if (m_eConnMode != eConnMode)
	{
		// Accept new connection mode.
		m_eConnMode = eConnMode;

		// Check for 'Session' end.
		if (m_eConnMode != CNT_CONN_MODE_ONLINE)
		{
			// Logout and disconnect.
			close();
		}
	}
}

/*
 * GetMailer.
 */
INetCoreMailer* CntPOP3Node_Impl::GetMailer (void)
{
	if (m_pMailer == NULL)
	{
		NAMESPACE_INET(INetWrapper) *pWrapper;
		if (CNT_RNM()->getINetWrapper (pWrapper))
		{
			CntINetConfig::load (pWrapper, CNT_RNM()->GetIniManager());

			pWrapper->newINetCoreMailer (m_pMailer);
			DBG_ASSERT (m_pMailer, "GetMailer: NewINetCoreMailer() failed");
		}
	}
	return m_pMailer;
}

/*
 * PutMailer.
 */
void CntPOP3Node_Impl::PutMailer (INetCoreMailer *pMailer)
{
	if ((pMailer == m_pMailer) && (m_pMailer != NULL))
	{
		// Disconnect and release Mailer.
		m_pMailer->RecvCloseConnection (NULL, NULL);
		DELETEZ (m_pMailer);
	}
}

/*
 * GetBoxItemSet.
 */
CntStoreItemSet* CntPOP3Node_Impl::GetBoxItemSet (CntStorageNode *pBoxDir)
{
	// Check context.
	if ((pBoxDir == NULL) || pBoxDir->IsDummy())
		return NULL;

	// Open directory itemset.
	CntStoreItemSet *pBoxSet = pBoxDir->openItemSet (
		aBoxDirRanges_Impl, S2U ("INBOXDATA"),
		STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (pBoxSet == NULL)
	{
		// Create new INBOXDATA itemset.
		UniString aName (S2U ("INBOXDATA"));

		pBoxDir->attrib (aName, 0,
			CNTDIRENTRY_ATTRIB_HIDDEN | CNTDIRENTRY_ATTRIB_CREATE);
		pBoxSet = pBoxDir->openItemSet (
			aBoxDirRanges_Impl, aName, STREAM_STD_READWRITE);

		// Initialize itemset.
		if (pBoxSet)
			pBoxSet->Put (CntUInt32Item (WID_TOTALCONTENTCOUNT, 0));
	}
	return pBoxSet;
}

/*
 * GetUserItemSet.
 */
CntStoreItemSet* CntPOP3Node_Impl::GetUserItemSet (CntStorageNode *pUserData)
{
	// Check context.
	if ((pUserData == NULL) || pUserData->IsDummy())
		return NULL;

	// Open userdata itemset.
	CntStoreItemSet *pUserSet = pUserData->openItemSet (
		aBoxUserRanges_Impl, S2U ("INBOXDATA"),
		STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (pUserSet == NULL)
	{
		// Create new INBOXDATA itemset.
		UniString aName (S2U ("INBOXDATA"));

		pUserData->attrib (aName, 0,
			CNTDIRENTRY_ATTRIB_HIDDEN | CNTDIRENTRY_ATTRIB_CREATE);
		pUserSet = pUserData->openItemSet (
			aBoxUserRanges_Impl, aName, STREAM_STD_READWRITE);

		// Initialize itemset.
		if (pUserSet)
			pUserSet->Put (CntUInt32Item (WID_SEENCONTENTCOUNT, 0));
	}
	return pUserSet;
}

/*
 * GetMsgSize.
 */
ULONG CntPOP3Node_Impl::GetMsgSize (const sal_Char *pReplyText) const
{
	ByteString aReplyText (pReplyText);
	if (aReplyText.GetTokenCount(' ') > 1)
	{
		ByteString aSize (aReplyText.GetToken (1, ' '));
		if (aSize.IsNumericAscii())
			return (ULONG)(aSize.ToInt32());
	}
	return 0;
}

/*
 * ReplaceInvalidMsgID.
 */
BOOL CntPOP3Node_Impl::ReplaceInvalidMsgID (
	const String& rInMsgID, String& rOutMsgID) const
{
	// Check InMsgId syntax.
	WildCard aPattern (S2U ("<*@*>"));
	if (!aPattern.Matches (rInMsgID))
	{
		// Check for no Message-ID at all.
		if (rInMsgID.Len() == 0)
		{
			// Create new (interim) Message-ID.
			INetURLObject aTmpURL (m_pParent->CreateInterimURL());

			rOutMsgID.Assign (sal_Unicode('<'));
			rOutMsgID += aTmpURL.GetURLPath().Copy(1);
			rOutMsgID += sal_Unicode('@');
			rOutMsgID += aTmpURL.GetHost();
			rOutMsgID += sal_Unicode('>');

			// Done with replacement.
			return TRUE;
		}
		else
		{
			// Let's start with what we have.
			rOutMsgID = rInMsgID;
			rOutMsgID.EraseLeadingChars (' ');
		}

		// Check for invalid parts.
		xub_StrLen nPos = 0;
		if (rOutMsgID.Search('<') == STRING_NOTFOUND)
		{
			if (rOutMsgID.GetChar(nPos) != '<')
			{
				// Insert missing opening bracket.
				rOutMsgID.Insert ('<', nPos);
			}
		}

		if (rOutMsgID.Search ('@') == STRING_NOTFOUND)
		{
			// Missing "@host.domain" part. Cut off closing bracket.
			nPos = rOutMsgID.Search ('>');
			if (nPos < rOutMsgID.Len()) rOutMsgID.Erase (nPos);

			// Append box servername.
			rOutMsgID += sal_Unicode('@');
			rOutMsgID += ITEMSET_VALUE(
				m_pParent, CntStringItem, WID_SERVERNAME);
		}

		if (rOutMsgID.Search ('>') == STRING_NOTFOUND)
		{
			// Append closing bracket.
			rOutMsgID += sal_Unicode('>');
		}

		// Cut off leading and trailing garbage
		xub_StrLen nBegin = rOutMsgID.Search ('<');
		rOutMsgID.Erase (0, nBegin);
		xub_StrLen nEnd   = rOutMsgID.Search ('>');
		rOutMsgID.Erase (nEnd + 1);

		// Done with replacements.
		return TRUE;
	}

	// Done w/o replacement, i.e. valid syntax.
	return FALSE;
}

/*
 * SetMsgUserFlag.
 */
void CntPOP3Node_Impl::SetMsgUserFlag (
	CntStorageNode    *pUserData,
	const String      &rMsgID,
	const CntBoolItem &rFlag) const
{
	// Skip MarkedForDelete messages.
	UINT32 nAttrib = 0, nRemove = 0;

	pUserData->attrib (rMsgID, 0, 0, nAttrib);
	if (nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE) return;

	// Extract supported flags.
	nAttrib &= (CNTDIRENTRY_ATTRIB_MARKED | CNTDIRENTRY_ATTRIB_UNSEEN);

	// Check for SeenFlag.
	if (rFlag.Which() == WID_IS_READ)
	{
		if (rFlag.GetValue())
		{
			// Seen.
			nRemove = CNTDIRENTRY_ATTRIB_UNSEEN;
			nAttrib &= (UINT32)(~CNTDIRENTRY_ATTRIB_UNSEEN);
		}
		else
		{
			// Unseen.
			if (nAttrib == 0) nAttrib = CNTDIRENTRY_ATTRIB_CREATE;
			nAttrib |= CNTDIRENTRY_ATTRIB_UNSEEN;
		}
	}

	// Check for MarkedFlag.
	if (rFlag.Which() == WID_IS_MARKED)
	{
		if (rFlag.GetValue())
		{
			// Marked.
			if (nAttrib == 0) nAttrib = CNTDIRENTRY_ATTRIB_CREATE;
			nAttrib |= CNTDIRENTRY_ATTRIB_MARKED;
		}
		else
		{
			// Unmarked.
			nRemove = CNTDIRENTRY_ATTRIB_MARKED;
			nAttrib &= (UINT8)(~CNTDIRENTRY_ATTRIB_MARKED);
		}
	}

	// Update attributes.
	UINT32 nResult = 0;
	if (nAttrib || nRemove)
		pUserData->attrib (rMsgID, nRemove, nAttrib, nResult);
	nResult &= (CNTDIRENTRY_ATTRIB_MARKED | CNTDIRENTRY_ATTRIB_UNSEEN);

	// Remove entry when no attributes left.
	if (nResult == 0)
		pUserData->remove (rMsgID);
}

/*
 * LoadMessageBodyItem.
 */
BOOL CntPOP3Node_Impl::LoadMessageBodyItem (
	CntNode        *pMessageNode,
	CntStorageNode *pCacheNode)
{
	if (pMessageNode == NULL)
		return FALSE;

	const CntMessageBodyItem *pBodyItem = NULL;
	pMessageNode->GetItemState (
		WID_MESSAGEBODY, FALSE, (const SfxPoolItem **)(&pBodyItem));
	if (pBodyItem && pBodyItem->Get())
		return TRUE;

	if (pCacheNode == NULL) return FALSE;
	String aBodyURL (OWN_URL (pMessageNode));
	aBodyURL.AppendAscii (".body");

	UINT32 nAttrib = 0;
	pCacheNode->attrib (aBodyURL, 0, 0, nAttrib );
	if (!(nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN))
		return FALSE;

	CntMessageBodyItem aBodyItem (WID_MESSAGEBODY, aBodyURL);
	if (aBodyItem.Get (pCacheNode, GetMailer()))
		return (pMessageNode->Put (aBodyItem) != NULL);
	else
		return FALSE;
}

/*=======================================================================
 *
 * CntPOP3Message_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntStoreItemSet Ranges.
 */
#if 0  /* EXP */
const USHORT CntPOP3Message_Impl::m_pStoreRanges[] =
{
	WID_PRIORITY,     WID_PRIORITY,
	WID_IN_REPLY_TO,  WID_TITLE,
	WID_REFERENCES,   WID_REFERENCES,
	WID_DATE_CREATED, WID_DATE_CREATED,
	WID_UNIQUE_ID,    WID_UNIQUE_ID,
	WID_SIZE,         WID_SIZE,
	WID_ACTION_LIST,  WID_ACTION_LIST,
	0
};
#endif /* EXP */

/*
 * queryAvailable.
 */
BOOL CntPOP3Message_Impl::queryAvailable (
	const CntNode           &rNode,
	const CntStorageNodeRef &rxCache)
{
	USHORT eStoreMode = CNT_MESSAGE_STOREMODE_REMOTE;
	if (rxCache.Is())
	{
		eStoreMode = ITEMSET_VALUE(
			rxCache, CntMsgStoreModeItem, WID_MESSAGE_STOREMODE);
		if (eStoreMode == CNT_MESSAGE_STOREMODE_LOCAL)
		{
			String aUrl (OWN_URL (&rNode));
			aUrl.AppendAscii (".body");

			UINT32 nAttrib = 0;
			rxCache->attrib (aUrl, 0, 0, nAttrib);
			return ((nAttrib & CNTDIRENTRY_ATTRIB_HIDDEN) > 0 );
		}
	}
	return (eStoreMode == CNT_MESSAGE_STOREMODE_REMOTE);
}

/*
 * storeAvailable.
 */
CntStoreItemSet* CntPOP3Message_Impl::storeAvailable (
	CntPOP3ListEntry_Impl   &rEntry,
	INetCoreNewsMessage     &rMessage,
	const CntStorageNodeRef &rxCache)
{
	// Check cache node.
	if (!rxCache.Is())
		return NULL;

	// Obtain message itemset.
	CntStoreItemSet *pDirSet = rxCache->openItemSet (
		aMsgDirRanges_Impl, rEntry.m_aMsgID, STREAM_READWRITE);
	if (!pDirSet)
		return NULL;

	// Store UniqueID link.
	ErrCode eErrCode = rxCache->link (
		rEntry.m_aMsgID, rEntry.m_aUniqueID);
	if (eErrCode == ERRCODE_NONE)
		pDirSet->Put (CntStringItem (WID_UNIQUE_ID, rEntry.m_aUniqueID));

	// Store ListEntry.
	pDirSet->Put (CntStringItem (WID_MESSAGE_ID, rEntry.m_aMsgID));
	pDirSet->Put (CntUInt32Item (WID_SIZE, rEntry.m_nSize));

	// Check creation date.
	if (rMessage.ParseDateField (
		rMessage.GetDate(), rEntry.m_aDate, rEntry.m_aDate))
	{
		// Store creation date.
		rEntry.m_aDate.ConvertToLocalTime();
		pDirSet->Put (SfxDateTimeItem (WID_DATE_CREATED, rEntry.m_aDate));
	}

	// Store message headers.
	pDirSet->Put (CntNameItem (
		WID_FROM, rMessage.GetFrom()));
	pDirSet->Put (CntStringItem (
		WID_TO, rMessage.GetTo()));
	pDirSet->Put (CntStringItem (
		WID_CC, rMessage.GetCC()));
	pDirSet->Put (CntStringItem (
		WID_TITLE, rMessage.GetSubject()));
	pDirSet->Put (CntStringItem (
		WID_REFERENCES, rMessage.GetReferences()));
	pDirSet->Put (CntStringItem (
		WID_IN_REPLY_TO, rMessage.GetInReplyTo()));
	pDirSet->Put (CntPriorityItem (
		WID_PRIORITY, rMessage.GetXPriority()));

	// Done.
	return pDirSet;
}

/*
 * initDownload.
 */
void CntPOP3Message_Impl::initDownload (
	INetCoreMailer          &rMailer,
	INetCoreNewsMessage    *&rpMessage,
	const CntStorageNodeRef &rxCache)
{
	// Create message container.
	delete rpMessage;
	rpMessage = rMailer.CreateINetCoreNewsMessage();

	// Check cache node.
	if (rxCache.Is())
	{
		// Setup data stream URL.
		String aDataUrl (rxCache->CreateInterimURL());
		rpMessage->SetDocumentFilename (aDataUrl);

		// Create data stream.
		SvStream *pStrm = rxCache->openStream (
			aDataUrl, STREAM_READWRITE | STREAM_TRUNC);
		DBG_ASSERTWARNING(
			pStrm, "CntPOP3Message_Impl::initDownload(): no Stream");
		if (pStrm)
		{
			// Mark data stream hidden.
			rxCache->attrib (aDataUrl, 0, CNTDIRENTRY_ATTRIB_HIDDEN);

			// Set data stream.
			rpMessage->SetDocumentStream (pStrm);
		}
	}
}

/*
 * storeDownload.
 */
BOOL CntPOP3Message_Impl::storeDownload (
	const String            &rUrl,
	INetCoreNewsMessage     &rMessage,
	const CntStorageNodeRef &rxCache)
{
	// Check for message body data.
	String aDataUrl (rMessage.GetDocumentFilename());
	if (aDataUrl.Len())
	{
		// Cleanup data stream.
		SvStream *pStrm = rMessage.GetDocumentStream();
		rMessage.SetDocumentStream (NULL);
		DELETEZ (pStrm);

		// Check for body stream storage.
		if (rxCache.Is())
		{
			// Obtain body stream.
			String aBodyUrl (rUrl);
			aBodyUrl.AppendAscii (".body");

			pStrm = rxCache->openStream (aBodyUrl, STREAM_READWRITE);
			if (pStrm)
			{
				// Store body stream.
				*pStrm << CNT_MESSAGEBODY_NEWS_DATA;
				pStrm->WriteByteString (aDataUrl, RTL_TEXTENCODING_UTF8);
				*pStrm << rMessage;
				delete pStrm;

				// Hide body stream.
				rxCache->attrib (aBodyUrl, 0, CNTDIRENTRY_ATTRIB_HIDDEN);
				return TRUE;
			}
		}
	}
	return FALSE;
}

/*
 * cleanupDownload.
 */
void CntPOP3Message_Impl::cleanupDownload (
	INetCoreNewsMessage     &rMessage,
	const CntStorageNodeRef &rxCache)
{
	// Cleanup data stream.
	SvStream *pStrm = rMessage.GetDocumentStream();
	rMessage.SetDocumentStream (NULL);
	delete pStrm;

	// Check for data stream removal.
	if (rxCache.Is())
	{
		String aDataUrl (rMessage.GetDocumentFilename());
		if (aDataUrl.Len())
		{
			rMessage.SetDocumentFilename (String());
			rxCache->remove (aDataUrl);
		}
	}
}

/*=======================================================================
 *
 * CntPOP3Job_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3Job_Impl.
 */
CntPOP3Job_Impl::CntPOP3Job_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: SfxListener(),
	  m_xJob     (pJob),
	  m_pParent  (pParent)
{
	if (m_xJob.Is())
	{
		AddRef();
		m_xJob->SetRequestData (this);
		StartListening (*m_xJob);
	}
}

/*
 * ~CntPOP3Job_Impl.
 */
CntPOP3Job_Impl::~CntPOP3Job_Impl (void)
{
	if (m_xJob.Is())
	{
		EndListening (*m_xJob);
		m_xJob->SetRequestData (NULL);
	}
}

/*
 * ExecuteCallback.
 */
sal_Bool CntPOP3Job_Impl::ExecuteCallback (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData)
{
	// Check context.
	CntPOP3Job_Impl *pThis = (CntPOP3Job_Impl*)pData;
	DBG_ASSERT(
		pThis, "CntPOP3Job_Impl::ExecuteCallback(): no pThis");
	if (pThis == NULL)
		return sal_False;

	// Handle callback reason.
	pThis->AddRef();
	pThis->ExecuteHandler (pMailer, nReplyCode, pReplyText);
	pThis->ReleaseRef();

	// Wait for next callback.
	return sal_True;
}

/*
 * ExecuteHandler (noop).
 */
void CntPOP3Job_Impl::ExecuteHandler (
	INetCoreMailer*, sal_Int32, const sal_Char*)
{
}

/*
 * Broadcast.
 */
void CntPOP3Job_Impl::Broadcast (const SfxHint& rHint)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Broadcast (rHint);
	}
}

/*
 * Result.
 */
void CntPOP3Job_Impl::Result (CntNode *pResult, CntAction eAction)
{
	if (m_xJob.Is())
	{
		CntNodeJob *pJob = m_xJob;
		while (pJob->GetParent())
			pJob = pJob->GetParent();
		pJob->Result (pResult, eAction);

		const SfxPoolItem *pReq = pJob->GetRequest();
		if (pReq && (pReq->Which() == WID_SEARCH))
			pJob->ResultSearchMatch (pResult);
	}
}

/*
 * Notify.
 */
void CntPOP3Job_Impl::Notify (SfxBroadcaster &rBC, const SfxHint &rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xJob))
	{
		if (m_xJob->IsCancelled() || (m_xJob->IsDone()))
		{
			// Our job is finished here.
			EndListening (*m_xJob);
			ReleaseRef();
		}
	}
}

/*=======================================================================
 *
 * CntPOP3OpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3OpenJob_Impl.
 */
CntPOP3OpenJob_Impl::CntPOP3OpenJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pMailer       (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3OpenJob_Impl.
 */
CntPOP3OpenJob_Impl::~CntPOP3OpenJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3OpenJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3OpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT (m_pMailer, "CntPOP3OpenJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check connection.
		if (m_pMailer->RecvIsOpen())
		{
			// Connection established.
			if (m_pMailer->RecvIsLoggedIn())
			{
				// Session established.
				pJob->Done();
				return NULL;
			}
			m_eState = STATE_OPEN;
		}
		else
		{
			// Connection closed.
			m_pMailer->RecvAbortConnection();
			m_eState = STATE_CLOSE;
		}

		// Cleanup.
		CntPOP3List_Impl &rList = GetParent()->GetList();
		ULONG i = 0, n = rList.Count();
		while (i < n)
			delete (rList.GetObject(i++));
		rList.Clear();
	}

	// Jump into state machine.
	ExecuteCallback (m_pMailer, INETCOREPOP3_REPLY_OK, NULL, this);
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3OpenJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3OpenJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_CLOSE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Connection closed. Obtain Host and Port.
					String aHost;
					USHORT nPort;

					String aEndpoint (ITEMSET_VALUE(
						GetRootNode(), CntStringItem, WID_SERVERNAME));
					CntMBXFormat::decomposeDomainAndPort (
						aEndpoint, aHost, nPort);

					// Notify caller (ShowStatusText).
					String aStatusText (CntResId (
						RID_PROT_CONNECTING_TO_SERVER));
					aStatusText.SearchAndReplace (S2U("$(ARG1)"), aEndpoint);
					Broadcast (CntStatusBarHint (aStatusText));

					// Establish new connection.
					m_eState = STATE_OPEN;
					if (!m_pMailer->RecvOpenConnection (
						aHost, nPort, ExecuteCallback, this))
					{
						// Failure. Remove StatusText.
						Broadcast (CntStatusBarHint (String()));

						// Notify caller.
						ErrCode eErrCode = *(new TwoStringErrorInfo (
							ERRCODE_CHAOS_SERVER_CONNECT_FAILURE,
							S2U("POP3"), aEndpoint));
						if (!pJob->SetError (eErrCode))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure. Abort connection.
					m_pMailer->RecvAbortConnection();

					// Try again.
					m_eState = STATE_NONE;
					GetRootNode()->RescheduleJob (GetJob());
				}
				break;

			case STATE_OPEN:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain Username and Password.
					String aUsername (ITEMSET_VALUE(
						GetRootNode(), CntStringItem, WID_USERNAME));
					String aPassword (ITEMSET_VALUE(
						GetRootNode(), CntStringItem, WID_PASSWORD));

					// Notify caller (ShowStatusText).
					String aStatusText (CntResId (
						RID_PROT_SENDING_LOGIN_INFORMATION));
					Broadcast (CntStatusBarHint (aStatusText));

					// Login.
					m_eState = STATE_LOGIN;
					if (!m_pMailer->RecvLogin (
						aUsername, aPassword, ExecuteCallback, this))
					{
						// Failure. Remove StatusText.
						Broadcast (CntStatusBarHint (String()));

						// Notify caller.
						if (!pJob->SetError (
							ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE,
							NULL, GetRootNode()))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure. Remove StatusText.
					Broadcast (CntStatusBarHint (String()));

					// Notify caller.
					ErrCode eErrCode = ERRCODE_CHAOS_CONNECT_FAILURE;
					if (pReplyText)
					{
						// Setup ErrorInfo.
						eErrCode = *(new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, *pReplyText));
					}
					else
					{
						// Setup ErrorInfo.
						String aEndpoint (ITEMSET_VALUE(
							GetRootNode(), CntStringItem, WID_SERVERNAME));

						eErrCode = *(new TwoStringErrorInfo (
							ERRCODE_CHAOS_SERVER_CONNECT_FAILURE,
							S2U("POP3"), aEndpoint));
					}
					if (!pJob->SetError (eErrCode))
					{
						// Try again.
						m_eState = STATE_NONE;
						GetRootNode()->RescheduleJob (pJob);
					}

					// Wait for next callback.
					return;
				}
				break;

			case STATE_LOGIN:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Receive UniqueIdList.
					m_eState = STATE_UIDL;
					if (!m_pMailer->RecvUniqueIdList (
						m_aList, ExecuteCallback, this))
					{
						// Failure. Remove StatusText.
						Broadcast (CntStatusBarHint (String()));

						// Notify caller.
						if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
						{
							// Abort connection.
							m_pMailer->RecvAbortConnection();

							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure. Remove StatusText.
					Broadcast (CntStatusBarHint (String()));

					// Check connection.
					if (m_pMailer->RecvIsOpen())
					{
						// Notify caller. // @@@ ASCII @@@
						UniString aReplyText (S2U (pReplyText));
						if (!pJob->SetError (
							ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE,
							&aReplyText, GetRootNode()))
						{
							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}
					else
					{
						// Connection closed. Try again.
						m_eState = STATE_NONE;
						GetRootNode()->RescheduleJob (pJob);
					}

					// Wait for next callback.
					return;
				}
				break;

			case STATE_UIDL:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Process UniqueIdList.
					CntPOP3List_Impl      &rList  = GetParent()->GetList();
					CntPOP3ListEntry_Impl *pEntry = NULL;

					for (ULONG i = 0; i < m_aList.Count(); i++)
					{
						String *pUID = (String *)(m_aList.GetObject(i));

						pEntry = new CntPOP3ListEntry_Impl (i + 1, *pUID);
						rList.Insert (pEntry, LIST_APPEND);

						delete pUID;
					}
					m_aList.Clear();

					// Finished.
					m_eState = STATE_DONE;
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_ERROR)
				{
					// No UniqueIdList available. Receive MailList.
					m_eState = STATE_LIST;
					if (!m_pMailer->RecvMailList (
						m_aList, ExecuteCallback, this))
					{
						// Failure. Remove StatusText.
						Broadcast (CntStatusBarHint (String()));

						// Notify caller.
						if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
						{
							// Abort connection.
							m_pMailer->RecvAbortConnection();

							// Try again.
							m_eState = STATE_NONE;
							GetRootNode()->RescheduleJob (pJob);
						}
					}

					// Wait for next callback.
					return;
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_LIST:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Process MailList.
					CntPOP3List_Impl      &rList  = GetParent()->GetList();
					CntPOP3ListEntry_Impl *pEntry = NULL;

					for (ULONG i = 0; i < m_aList.Count(); i++)
					{
						CoreMailListEntry *pCoreEntry =
							(CoreMailListEntry *)(m_aList.GetObject(i));

						pEntry = new CntPOP3ListEntry_Impl (
							pCoreEntry->m_nIndex, pCoreEntry->m_nSize);
						rList.Insert (pEntry, LIST_APPEND);

						delete pCoreEntry;
					}
					m_aList.Clear();

					// Finished.
					m_eState = STATE_DONE;
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Finished.
					m_eState = STATE_NONE;
					GetJob()->Done();
				}
				else
				{
					// Failure.
					m_eState = STATE_NONE;
					GetJob()->Cancel();
				}
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntPOP3OpenJob_Impl::Notify (
	SfxBroadcaster &rBC, const SfxHint &rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled())
		{
			// Abort connection.
			if (m_pMailer)
				m_pMailer->RecvAbortConnection();

			// Check state.
			if (m_eState == STATE_UIDL)
			{
				// Cleanup UniqueIdList.
				for (ULONG i = 0; i < m_aList.Count(); i++)
					delete ((String *)(m_aList.GetObject(i)));
				m_aList.Clear();
			}
			if (m_eState == STATE_LIST)
			{
				// Cleanup MailList.
				for (ULONG i = 0; i < m_aList.Count(); i++)
					delete ((CoreMailListEntry *)(m_aList.GetObject(i)));
				m_aList.Clear();
			}

			// Force into idle state.
			m_eState = STATE_NONE;
		}
		if (pJob->IsDone())
		{
			// Job finished.
			EndListening (*pJob);

			// Remove StatusText.
			Broadcast (CntStatusBarHint (String()));
		}
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3IndexJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3IndexHint_Impl.
 */
TYPEINIT1 (CntPOP3IndexHint_Impl, SfxHint);

/*
 * CntPOP3IndexJob_Impl.
 */
CntPOP3IndexJob_Impl::CntPOP3IndexJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob       (NULL),
	  m_pMailer       (NULL),
	  m_pMessage      (NULL),
	  m_aEntry        (0),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3IndexJob_Impl.
 */
CntPOP3IndexJob_Impl::~CntPOP3IndexJob_Impl (void)
{
	delete m_pMessage;
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3IndexJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3IndexJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntPOP3IndexJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		CntStorageNode *pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			pCache, "CntPOP3IndexJob_Impl::Execute(): no Cache");
		if (pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain message node.
		CntNode *pSubject = pJob->GetSubject();
		DBG_ASSERT(
			pSubject, "CntPOP3IndexJob_Impl::Execute(): no Subject");
		if (pSubject == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain MessageID.
		m_aEntry.m_aMsgID =
			ITEMSET_VALUE (pSubject, CntStringItem, WID_MESSAGE_ID);
		DBG_ASSERT(
			m_aEntry.m_aMsgID.Len(),
			"CntPOP3IndexJob_Impl::Execute(): empty MessageID");
		if (m_aEntry.m_aMsgID.Len() == 0)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain message itemset.
		CntStoreItemSetRef xDirSet (pCache->openItemSet (
			aMsgDirRanges_Impl, m_aEntry.m_aMsgID, STREAM_STD_READ));
		if (xDirSet.Is())
		{
			// Setup ListEntry.
			m_aEntry.m_nSize = ITEMSET_VALUE(
				xDirSet, CntUInt32Item, WID_SIZE);
			m_aEntry.m_aUniqueID = ITEMSET_VALUE(
				xDirSet, CntStringItem, WID_UNIQUE_ID);

			// Release itemset.
			xDirSet.Clear();
		}

		// Obtain message index.
		m_eState = STATE_OPEN;
	}

	if (m_eState == STATE_OPEN)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT(
			m_pMailer, "CntPOP3IndexJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check connection.
		if (m_pMailer->RecvIsOpen() && m_pMailer->RecvIsLoggedIn())
		{
			// Connection established.
			m_xSubJob.Clear();

			// Initialize next state.
			CntPOP3List_Impl &rList = GetParent()->GetList();
			m_aEntry.m_nIndex = rList.Count();

			if (m_aEntry.m_aUniqueID.Len())
				m_eState = STATE_UIDL;
			else
				m_eState = STATE_LIST;

			// Jump into state machine.
			ExecuteCallback (m_pMailer, INETCOREPOP3_REPLY_OK, NULL, this);
			return NULL;
		}
		else
		{
			// Check for SubJob.
			if (m_xSubJob.Is() && m_xSubJob->IsCancelled())
			{
				// Failure.
				pJob->Cancel();
				return NULL;
			}

			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
			CntPOP3Job_Impl *pJobImpl =
				new CntPOP3OpenJob_Impl (m_xSubJob, GetParent());

			// Start child job.
			StartListening (*m_xSubJob);
			GetRootNode()->RescheduleJob (m_xSubJob);
			return NULL;
		}
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3IndexJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntPOP3IndexJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_UIDL:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain current index.
					ULONG i = m_aEntry.m_nIndex;
					if (i > 0)
					{
						// Check current entry.
						CntPOP3ListEntry_Impl *e =
							GetParent()->GetListEntry (i - 1);
						if (e->m_aUniqueID == m_aEntry.m_aUniqueID)
						{
							// Finished.
							m_aEntry.m_nIndex = e->m_nIndex;
							m_eState = STATE_DONE;
						}
						else
						{
							// Continue.
							m_aEntry.m_nIndex = i - 1;
							m_eState = STATE_UIDL;
						}
					}
					else
					{
						// Not found.
						m_eState = STATE_DONE;
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_LIST:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain current index.
					ULONG i = m_aEntry.m_nIndex;
					if (i > 0)
					{
						// Check current entry.
						CntPOP3ListEntry_Impl *e =
							GetParent()->GetListEntry (i - 1);
						if (e->m_aMsgID.Len())
						{
							// Check MessageID.
							if (e->m_aMsgID == m_aEntry.m_aMsgID)
							{
								// Finished.
								m_aEntry.m_nIndex = e->m_nIndex;
								m_eState = STATE_DONE;
							}
							else
							{
								// Continue.
								m_aEntry.m_nIndex = i - 1;
								m_eState = STATE_LIST;
							}
						}
						else
						{
							// Obtain MessageID from overview.
							m_pMessage =
								m_pMailer->CreateINetCoreNewsMessage();

							m_aEntry.m_nIndex = e->m_nIndex;
							m_eState = STATE_OVERVIEW;

							if (!m_pMailer->RecvMailHead (
								m_aEntry.m_nIndex, *m_pMessage,
								ExecuteCallback, this))
							{
								// Notify caller.
								if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
								{
									// Try again.
									m_eState = STATE_OPEN;
									GetRootNode()->RescheduleJob (pJob);
								}
							}

							// Wait for next callback.
							return;
						}
					}
					else
					{
						// Not found.
						m_eState = STATE_DONE;
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_OVERVIEW:
				if (nReplyCode >= 0)
				{
					nReplyCode = INETCOREPOP3_REPLY_OK;

					// Obtain current index.
					ULONG i = m_aEntry.m_nIndex;
					if (i > 0)
					{
						// Obtain current entry.
						CntPOP3ListEntry_Impl *e =
							GetParent()->GetListEntry (i - 1);

						// Check MessageID.
						String aNewMsgID;
						if (GetParent()->ReplaceInvalidMsgID (
							m_pMessage->GetMessageID(), aNewMsgID))
						{
							// Replace invalid MessageID.
							m_pMessage->SetMessageID (aNewMsgID);
						}
						e->m_aMsgID = m_pMessage->GetMessageID();

						// Check MessageSize.
						if (e->m_nSize == 0)
						{
							// Determine size from ReplyText.
							e->m_nSize = GetParent()->GetMsgSize (pReplyText);
						}

						// Cleanup and continue.
						DELETEZ (m_pMessage);
						m_eState = STATE_LIST;
					}
					else
					{
						// Not found.
						m_eState = STATE_DONE;
					}
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Obtain current index. Notify caller.
					ULONG i = m_aEntry.m_nIndex;
					pJob->Broadcast (CntPOP3IndexHint_Impl (i));

					// Finished.
					m_eState = STATE_NONE;
					pJob->Done();
				}
				else
				{
					// Failure.
					m_eState = STATE_NONE;
					pJob->Cancel();
				}
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntPOP3IndexJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// Child job finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3CloseJob_Impl.
 *
 *=====================================================================*/
/*
 * CntPOP3CloseJob_Impl.
 */
CntPOP3CloseJob_Impl::CntPOP3CloseJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pMailer       (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3CloseJob_Impl.
 */
CntPOP3CloseJob_Impl::~CntPOP3CloseJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3CloseJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Check mailer.
		if (!GetParent()->HasMailer())
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Close connection gracefully.
		m_eState = STATE_CLOSE;

		m_pMailer = GetParent()->GetMailer();
		if (m_pMailer->RecvCloseConnection (
			CntPOP3Job_Impl::ExecuteCallback, this))
		{
			// Wait for next callback.
			return NULL;
		}
		else
		{
			// Failure. Abort connection.
			m_eState = STATE_DONE;
		}
	}

	if (m_eState == STATE_DONE)
	{
		// Release mailer and finish.
		if (pReq->Which() == WID_CONNECTION_MODE)
		{
			CntConnMode eConnMode =
				(CntConnMode)(ITEM_VALUE(CntConnModeItem, *pReq));
			if (eConnMode != CNT_CONN_MODE_ONLINE)
				GetParent()->PutMailer (m_pMailer);
		}
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3CloseJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	if (m_eState == STATE_CLOSE)
	{
		// Connection closed.
		m_eState = STATE_DONE;

		// Finish asynchronously.
		GetRootNode()->RescheduleJob (GetJob());
	}
}

/*
 * Notify.
 */
void CntPOP3CloseJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

