/*************************************************************************
 *
 *  $RCSfile: cpop3imp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTPOP3IMP_HXX
#define _CNTPOP3IMP_HXX "$Revision: 1.1.1.1 $"

#ifndef _OSL_INTERLCK_H_
#include <osl/interlck.h>
#endif

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif
#ifndef _REF_HXX
#include <tools/ref.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif
#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXHINT_HXX
#include <svtools/hint.hxx>
#endif

#ifndef _INETCOREMAIL_HXX
#include <inet/inetmail.hxx>
#endif

#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CNTNODE_HXX
#include "cntnode.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif

#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

class CntBoolItem;
class CntPOP3BoxMessageCachingPolicy;

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntExport;
class CntImport;
class CntMBXBodyScanner;
class CntMBXToken;

SV_DECL_IMPL_REF(CntStorageNode);

/*=======================================================================
 *
 * Debug trace environment.
 *
 *=====================================================================*/
#ifdef DBG_UTIL_PRIVATE
#include <stdio.h>

#if (defined(WIN) || defined(WNT) || defined(OS2))
#define _TRACELOGNAME "c:\\cntpop3.log"
#elif (defined(UNX))
#define _TRACELOGNAME "/tmp/cntpop3.log"
#else
#define _TRACELOGNAME "cntpop3.log"
#endif

#ifdef WIN
#define _TRACELOGFORMAT "%ls\n"
#else
#define _TRACELOGFORMAT "%s\n"
#endif /* WIN */

#define _TRACE(a) \
{ \
	FILE *fp = fopen (_TRACELOGNAME, "a+"); \
	if (fp) \
	{ \
		fprintf (fp, _TRACELOGFORMAT, (const char *)((a))); \
		fclose (fp); \
	} \
}

#else
#define _TRACE(a)
#endif /* DBG_UTIL_PRIVATE */

/*=======================================================================
 *
 * class CntPOP3... common internals.
 *
 *=====================================================================*/
#ifndef COPYCTOR_API
#define COPYCTOR_API(C) C (const C&); C& operator= (const C&)
#endif

#ifndef CNTDIRENTRY_ATTRIB_DELETEONSERVER /* BoxDirectory */
#define CNTDIRENTRY_ATTRIB_DELETEONSERVER CNTDIRENTRY_ATTRIB_USER1
#endif

#ifndef CNTDIRENTRY_ATTRIB_DELETEONCLIENT /* BoxDirectory */
#define CNTDIRENTRY_ATTRIB_DELETEONCLIENT CNTDIRENTRY_ATTRIB_USER2
#endif

#ifndef CNTDIRENTRY_ATTRIB_UNSEEN /* UserData */
#define CNTDIRENTRY_ATTRIB_UNSEEN CNTDIRENTRY_ATTRIB_USER1
#endif

#ifndef WID_UNIQUE_ID /* MsgDirRanges */
#define WID_UNIQUE_ID WID_LAST_UID
#endif

#define CPOP3JOB_RESCHEDULE_TIMELIMIT 200 /* [msec] */

#define CPOP3IMP_CONCAT_URLPATH(base,path) \
{ \
    if ((base).GetChar((base).Len() - 1) != '/') (base) += '/'; \
	(base) += (path); \
}

inline UniString S2U (const sal_Char *pszAscii)
{
	return UniString::CreateFromAscii (pszAscii);
}

/*
 * CntPOP3BoxNode: CntStoreItemSet Ranges.
 */
#define CPOP3BOX_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_TOTALCONTENTCOUNT, WID_TOTALCONTENTCOUNT, \
	WID_LAST_MSGID,        WID_LAST_UID, \
	0 \
};

#define CPOP3BOX_USER_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_SEENCONTENTCOUNT, WID_SEENCONTENTCOUNT, \
	0 \
};

/*
 * CntPOP3MessageNode: CntStoreItemSet Ranges.
 */
#define CPOP3MSG_DIR_RANGES_IMPL(a) \
static const USHORT a[] = \
{ \
	WID_PRIORITY,     WID_PRIORITY, \
	WID_IN_REPLY_TO,  WID_TITLE, \
	WID_REFERENCES,   WID_REFERENCES, \
	WID_DATE_CREATED, WID_DATE_CREATED, \
	WID_UNIQUE_ID,    WID_UNIQUE_ID, \
	WID_SIZE,         WID_SIZE, \
	WID_ACTION_LIST,  WID_ACTION_LIST, \
	0 \
};

/*=======================================================================
 *
 * CntPOP3List_Impl.
 *
 *=====================================================================*/
struct CntPOP3ListEntry_Impl
{
	/** Representation.
	*/
	ULONG    m_nIndex;
	ULONG    m_nSize;
	DateTime m_aDate;
	String   m_aMsgID;
	String   m_aUniqueID;

	/** Construction.
	*/
	CntPOP3ListEntry_Impl (ULONG nIndex, ULONG nSize = 0)
		: m_nIndex (nIndex),
		  m_nSize  (nSize),
		  m_aDate  (Date(0), Time(0))
	{}

	CntPOP3ListEntry_Impl (ULONG nIndex, const String& rUniqueID)
		: m_nIndex    (nIndex),
		  m_nSize     (0),
		  m_aDate     (Date(0), Time(0)),
		  m_aUniqueID (rUniqueID)
	{}
};

DECLARE_LIST (CntPOP3List_Impl, CntPOP3ListEntry_Impl*)

typedef INetCorePOP3MailListEntry CoreMailListEntry;

/*=======================================================================
 *
 * CntPOP3Node_Impl interface.
 *
 *=====================================================================*/
class CntPOP3Node_Impl
{
	CntNode                        *m_pParent;
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	oslInterlockedCount             m_nRefCount;
	CntPOP3List_Impl                m_aList;

	CntConnMode                     m_eConnMode;
	BOOL                            m_bInitialized;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3Node_Impl);

public:
	CntPOP3Node_Impl (
		CntNode     *pParent,
		CntConnMode  eConnMode = CNT_CONN_MODE_ONLINE);
	~CntPOP3Node_Impl (void);

	CntNode*         GetParent (void) const { return m_pParent; }

	BOOL             IsInitialized (void) const { return m_bInitialized; }
	BOOL             Initialize (CntNodeJob *pJob);

	void             acquire (void);
	void             release (oslInterlockedCount n = 1);
	void             close   (void);

	CntConnMode      GetConnMode (void) const { return m_eConnMode; }
	void             SetConnMode (CntConnMode eConnMode);

	NAMESPACE_INET(INetCoreMailer)* GetMailer (void);
	void PutMailer (NAMESPACE_INET(INetCoreMailer) *pMailer);
	BOOL HasMailer (void) const { return (!!m_pMailer); }

	CntPOP3List_Impl&      GetList (void) { return m_aList; }
	CntPOP3ListEntry_Impl* GetListEntry (ULONG nIndex)
	{
		return m_aList.GetObject(nIndex);
	}

	CntStoreItemSet* GetBoxItemSet  (CntStorageNode *pBoxDir);
	CntStoreItemSet* GetUserItemSet (CntStorageNode *pUserData);

	ULONG GetMsgSize (const sal_Char *pReplyText) const;

	BOOL ReplaceInvalidMsgID (
		const String& rInMsgID, String& rOutMsgID) const;

	void SetMsgUserFlag (
		CntStorageNode    *pUserData,
		const String      &rMsgID,
		const CntBoolItem &rFlag) const;

	BOOL LoadMessageBodyItem (
		CntNode        *pMessageNode,
		CntStorageNode *pCacheNode);
};

class CntPOP3Message_Impl
{
public:
	/** queryAvailable.
	 */
	static BOOL queryAvailable (
		const CntNode           &rNode,
		const CntStorageNodeRef &rxCache);

	/** storeAvailable.
	 */
	static CntStoreItemSet* storeAvailable (
		CntPOP3ListEntry_Impl   &rEntry,
		INetCoreNewsMessage     &rMessage,
		const CntStorageNodeRef &rxCache);

	/** initDownload.
	 */
	static void initDownload (
		NAMESPACE_INET(INetCoreMailer) &rMailer,
		INetCoreNewsMessage           *&rpMessage,
		const CntStorageNodeRef        &rxCache);

	/** storeDownload.
	 */
	static BOOL storeDownload (
		const String            &rUrl,
		INetCoreNewsMessage     &rMessage,
		const CntStorageNodeRef &rxCache);

	/** cleanupDownload.
	 */
	static void cleanupDownload (
		INetCoreNewsMessage     &rMessage,
		const CntStorageNodeRef &rxCache);
};

/*=======================================================================
 *
 * CntPOP3Job_Impl interface.
 *
 *=====================================================================*/
class CntPOP3Job_Impl : public SfxListener, public SvRefBase
{
	/** Representation.
	*/
	CntNodeJobRef     m_xJob;
	CntPOP3Node_Impl *m_pParent;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3Job_Impl);

protected:
	/** Broadcast (notify master job client).
	*/
	void Broadcast (
		const SfxHint& rHint);

	/** Result (notify master job client).
	*/
	void Result (
		CntNode   *pResult,
		CntAction  eAction = CNT_ACTION_INSERTED);

	/** Request callback.
	*/
	static sal_Bool ExecuteCallback (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText, void *pData);

	/** Base request handler (noop).
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer)*, sal_Int32, const sal_Char*);

public:
	CntPOP3Job_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3Job_Impl (void);

	CntNodeJob*       GetJob (void) const { return m_xJob; }
	CntPOP3Node_Impl* GetParent (void) const { return m_pParent; }

	CntNode*          GetRootNode (void) const
	{
		return m_pParent->GetParent();
	}

	virtual const SfxPoolItem* Execute (void) = 0;

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3OpenJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3OpenJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CLOSE,
		STATE_OPEN,
		STATE_LOGIN,
		STATE_UIDL,
		STATE_LIST,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	List                            m_aList;
	State                           m_eState;

	/** Request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API(CntPOP3OpenJob_Impl);

public:
	CntPOP3OpenJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3OpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster &rBC, const SfxHint &rHint);
};

/*=======================================================================
 *
 * CntPOP3IndexHint_Impl interface.
 *
 *=====================================================================*/
class CntPOP3IndexHint_Impl : public SfxHint
{
	/** Representation.
	*/
	ULONG m_nIndex;

public:
	TYPEINFO();

	CntPOP3IndexHint_Impl (ULONG nIndex = 0)
		: m_nIndex (nIndex)
	{}

	ULONG GetValue (void) const { return m_nIndex; }
};

/*=======================================================================
 *
 * CntPOP3IndexJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3IndexJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_OPEN,
		STATE_UIDL,
		STATE_LIST,
		STATE_OVERVIEW,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef                   m_xSubJob;
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	CntPOP3ListEntry_Impl           m_aEntry;
	State                           m_eState;

	/** Request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3IndexJob_Impl);

public:
	CntPOP3IndexJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3IndexJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3CloseJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3CloseJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CLOSE,
		STATE_DONE
	};

	/** Representation.
	*/
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	State                           m_eState;

	/** Request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3CloseJob_Impl);

public:
	CntPOP3CloseJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3CloseJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxOpenJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CACHE,
		STATE_USER,
		STATE_UPDATE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef       m_xSubJob;
	CntStorageNode     *m_pCache;
	CntStorageNode     *m_pUserData;

	CntStorageIterator *m_pIter;
	UINT32              m_nIter;
	UINT32              m_nInclMask;
	UINT32              m_nExclMask;

	String              m_aRootURL;
	USHORT              m_nHintId;
	State               m_eState;

	/** queryResult.
	*/
	CntNode* queryResult (
		const String &rUrl, UINT32 nAttrib);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxOpenJob_Impl);

public:
	CntPOP3BoxOpenJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3BoxOpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxUpdateJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxUpdateJob_Impl : public CntPOP3Job_Impl
{
	/** Direction.
	*/
	enum Direction
	{
		DIRECTION_NONE = 0,
		DIRECTION_1_TO_N,
		DIRECTION_N_TO_1
	};

	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_CLOSE,
		STATE_OPEN,
		STATE_LIST,
		STATE_LOAD,
		STATE_HEAD,
		STATE_MAIL,
		STATE_DELETE,
		STATE_UPDATE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef                   m_xSubJob;
	CntStorageNode                 *m_pCache;
	CntStorageNode                 *m_pUserData;

	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	CntPOP3ListEntry_Impl           m_aLast;
	CntPOP3ListEntry_Impl          *m_pNewest;
	CntPOP3ListEntry_Impl          *m_pOldest;
	ULONG                           m_nIndex;

	State                           m_eState;
	Direction                       m_eDirection;
	BOOL                            m_bStoreLocal     : 1;
	BOOL                            m_bDeleteOnServer : 1;

	/** Availability.
	*/
	enum Availability
	{
		AVAIL_DONTKNOW = 0,
		AVAIL_UNKNOWN,
		AVAIL_KNOWN,
		AVAIL_LASTKNOWN
	};

	Availability queryAvailable (
		CntPOP3ListEntry_Impl &rEntry);

	/** Download.
	*/
	BOOL queryDownload (
		CntPOP3ListEntry_Impl &rEntry,
		INetCoreNewsMessage   &rMessage);

	BOOL storeDownload (
		CntPOP3ListEntry_Impl &rEntry,
		INetCoreNewsMessage   &rMessage);

	/** queryResult.
	*/
	CntNode* queryResult (
		CntPOP3ListEntry_Impl &rEntry,
		INetCoreNewsMessage   &rMessage);

	/** showStatusText.
	*/
	void showStatusText (
		ULONG nDone, ULONG nTotal);

	/** RequestHandler.
	*/
	void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxUpdateJob_Impl);

public:
	CntPOP3BoxUpdateJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3BoxUpdateJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxSyncJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxSyncJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_DELETE,
		STATE_UPDATE,
		STATE_CACHE,
		STATE_USER,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef       m_xSubJob;
	CntStorageNode     *m_pCache;
	CntStorageNode     *m_pUserData;
	CntStorageIterator *m_pIter;
	ULONG               m_nIter;
	State               m_eState;

	/** find.
	*/
	CntPOP3ListEntry_Impl* find (const String &rMsgID);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxSyncJob_Impl);

public:
	CntPOP3BoxSyncJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3BoxSyncJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxMarkJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxMarkJob_Impl : public CntPOP3Job_Impl
{
	/** Representation.
	*/
	CntStorageNode     *m_pCache;
	CntStorageNode     *m_pUserData;
	CntStorageIterator *m_pIter;
	String              m_aBoxURL;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxMarkJob_Impl);

public:
	CntPOP3BoxMarkJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3BoxMarkJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3MsgOpenJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3MsgOpenJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_OPEN,
		STATE_INDEX,
		STATE_MAIL,
		STATE_DELETE,
		STATE_CLOSE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef                   m_xSubJob;
	CntStorageNode                 *m_pCache;
	CntStorageNode                 *m_pUserData;

	NAMESPACE_INET(INetCoreMailer) *m_pMailer;
	INetCoreNewsMessage            *m_pMessage;

	String                          m_aMsgID;
	ULONG                           m_nIndex;
	State                           m_eState;

	BOOL                           _bOffline : 1;
	BOOL                           _bDeleteOnServer : 1;
	BOOL                           _bUpdate : 1;

	/** storeDownload.
	*/
	void storeDownload (
		CntPOP3ListEntry_Impl &rEntry,
		INetCoreNewsMessage   &rMessage);

	/** showStatusText.
	*/
	void showStatusText (
		ULONG nDone, ULONG nTotal);

	/** Request handler.
	*/
	void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3MsgOpenJob_Impl);

public:
	CntPOP3MsgOpenJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3MsgOpenJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3MsgMarkJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3MsgMarkJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_MARK,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode *m_pUserData;
	State           m_eState;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3MsgMarkJob_Impl);

public:
	CntPOP3MsgMarkJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3MsgMarkJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3MsgDeleteJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3MsgDeleteJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_OPEN,
		STATE_INDEX,
		STATE_DELETE,
		STATE_CLOSE,
		STATE_LOCAL,
		STATE_DONE
	};

	/** Representation.
	*/
	CntNodeJobRef                   m_xSubJob;
	CntStorageNode                 *m_pCache;
	CntStorageNode                 *m_pUserData;
	NAMESPACE_INET(INetCoreMailer) *m_pMailer;

	String                          m_aMsgID;
	ULONG                           m_nIndex;
	State                           m_eState;

	/** Request handler.
	*/
	virtual void ExecuteHandler (
		NAMESPACE_INET(INetCoreMailer) *pMailer,
		sal_Int32 nReplyCode, const sal_Char *pReplyText);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3MsgDeleteJob_Impl);

public:
	CntPOP3MsgDeleteJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3MsgDeleteJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3MsgRestoreJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3MsgRestoreJob_Impl : public CntPOP3Job_Impl
{
	/** State.
	*/
	enum State
	{
		STATE_NONE = 0,
		STATE_RESTORE,
		STATE_DONE
	};

	/** Representation.
	*/
	CntStorageNode *m_pCache;
	CntStorageNode *m_pUserData;
	String          m_aMsgID;
	State           m_eState;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3MsgRestoreJob_Impl);

public:
	CntPOP3MsgRestoreJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3MsgRestoreJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxImportJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxImportJob_Impl: public CntPOP3Job_Impl
{
	/** Representation.
	*/
	SvStream                       * m_pStream;
	CntImport                      * m_pImport;
	CntPOP3BoxMessageCachingPolicy * m_pPolicy;
	CntMBXBodyScanner              * m_pPOP3BoxScanner;
	String                           m_sFileName;
	bool                             m_bMessageFound;

	String                           m_aBoxURL;
	USHORT                           m_nHintID;
	BOOL                             m_bCreateMessageID;

	/** Implementation.
	*/
	ErrCode handlePOP3BoxHidden (CntMBXToken & rToken);
	void    handleMessage (
		CntNode          * pMessageNode,
		const SfxItemSet & rItems,
		const String     & rMessageID);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxImportJob_Impl);

public:
	CntPOP3BoxImportJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);
	virtual ~CntPOP3BoxImportJob_Impl (void);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

/*=======================================================================
 *
 * CntPOP3BoxExportJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3BoxExportJob_Impl: public CntPOP3Job_Impl
{
	/** Representation.
	*/
	CntNodeRef           m_xMessageNode;
	CntNodeJobRef        m_xOpenJob;
	SvStream           * m_pStream;
	CntExport          * m_pExport;
	CntStorageIterator * m_pIterator;
	UINT32               m_nProgress;
	USHORT               m_nHintID;
	BOOL                 m_bWritePOP3Box;
	BOOL				 m_bIgnoreOffline;

	DECL_LINK(errorHandler, CntErrorData *);

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3BoxExportJob_Impl);

public:
	inline CntPOP3BoxExportJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

inline CntPOP3BoxExportJob_Impl::CntPOP3BoxExportJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pStream(0),
	  m_nHintID(0),
	  m_pExport(0),
	  m_nProgress(0),
	  m_bWritePOP3Box(FALSE),
	  m_pIterator(0),
	  m_bIgnoreOffline(FALSE)
{}

/*=======================================================================
 *
 * CntPOP3MsgExportJob_Impl interface.
 *
 *=====================================================================*/
class CntPOP3MsgExportJob_Impl: public CntPOP3Job_Impl
{
	/** Representation.
	*/
	CntNodeJobRef m_xOpenJob;
	SvStream    * m_pStream;
	CntExport   * m_pExport;
	BOOL          m_bProgress;

	/** Not implemented.
	*/
	COPYCTOR_API (CntPOP3MsgExportJob_Impl);

public:
	inline CntPOP3MsgExportJob_Impl (
		CntNodeJob *pJob, CntPOP3Node_Impl *pParent);

	virtual const SfxPoolItem* Execute (void);

	virtual void  Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

inline CntPOP3MsgExportJob_Impl::CntPOP3MsgExportJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl * pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pStream(0),
	  m_pExport(0),
	  m_bProgress(FALSE)
{}

/*=======================================================================
 *
 * The End.
 *
 *=====================================================================*/

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_CNTPOP3IMP_HXX */

