/*************************************************************************
 *
 *  $RCSfile: cpop3msg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _CPOP3MSG_CXX "$Revision: 1.1.1.1 $"

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _EINF_HXX
#include <tools/errinf.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif

#ifndef _CNTPOP3IMP_HXX
#include "cpop3imp.hxx"
#endif
#ifndef _CNTMMITM_HXX
#include "cntmmitm.hxx"
#endif
#ifndef _CNTMBITM_HXX
#include "cntmbitm.hxx"
#endif
#ifndef _CNTVWITM_HXX
#include "cntvwitm.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _CNTRESID_HXX
#include "cntresid.hxx"
#endif
#ifndef _PROCHAOS_HRC
#include "prochaos.hrc"
#endif
#ifndef _CHAOS_STORITEM_HXX
#include "storitem.hxx"
#endif

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

#ifdef _USE_NAMESPACE
using namespace inet;
#endif

#ifdef _CHAOS_STORITEM_REF
SV_IMPL_REF (CntStoreItemSet);
#endif

/*=======================================================================
 *
 * CntPOP3Msg... internals.
 *
 *=====================================================================*/
/*
 * CntStoreItemSet ranges.
 */
CPOP3MSG_DIR_RANGES_IMPL (aMsgDirRanges_Impl);

/*=======================================================================
 *
 * CntPOP3MsgOpenJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3MsgOpenJob_Impl.
 */
CntPOP3MsgOpenJob_Impl::CntPOP3MsgOpenJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob       (NULL),
	  m_pCache        (NULL),
	  m_pUserData     (NULL),
	  m_pMailer       (NULL),
	  m_pMessage      (NULL),
	  m_nIndex        (0),
	  m_eState        (STATE_NONE),
	  _bOffline        (FALSE),
	  _bDeleteOnServer (FALSE),
	  _bUpdate         (FALSE)
{
}

/*
 * ~CntPOP3MsgOpenJob_Impl.
 */
CntPOP3MsgOpenJob_Impl::~CntPOP3MsgOpenJob_Impl (void)
{
	delete m_pMessage;
}

/*
 * storeDownload.
 */
void CntPOP3MsgOpenJob_Impl::storeDownload (
	CntPOP3ListEntry_Impl &rEntry, INetCoreNewsMessage &rMessage)
{
	// Check subject.
	CntNode *pSubject = GetJob()->GetSubject();
	if (pSubject)
	{
		// Store headers.
		CntStoreItemSetRef xDirSet (
			CntPOP3Message_Impl::storeAvailable (rEntry, rMessage, m_pCache));
		if (xDirSet.Is())
		{
			// Feed headers into subject.
			pSubject->Put (*xDirSet);
			xDirSet.Clear();
		}

		// Store body stream.
		String aUrl (OWN_URL (pSubject));
		if (CntPOP3Message_Impl::storeDownload (aUrl, rMessage, m_pCache))
		{
			// Setup body URL.
			aUrl.AppendAscii (".body");

			// Feed body into subject.
			CntMessageBodyItem aBodyItem (WID_MESSAGEBODY, aUrl);
			aBodyItem.Get (m_pCache, m_pMailer, _bOffline);
			pSubject->Put (aBodyItem, aBodyItem.Which());
		}
	}

	// Cleanup data stream.
	CntPOP3Message_Impl::cleanupDownload (rMessage, m_pCache);
}

/*
 * showStatusText.
 */
void CntPOP3MsgOpenJob_Impl::showStatusText (ULONG nDone, ULONG nTotal)
{
	// Check Done range.
	if ((nDone > nTotal) && (nTotal > 0))
		nDone = nTotal;

	// Setup DoneText.
	UniString aDoneText (UniString::CreateFromInt32 (nDone));
	if (nTotal)
	{
		aDoneText += sal_Unicode('/');
		aDoneText += UniString::CreateFromInt32 (nTotal);
	}

	// Setup StatusText.
	String aStatusText (CntResId (RID_PROT_TRANSFERING_MESSAGE));
	aStatusText.SearchAndReplace (S2U ("$(ARG1)"), aDoneText);

	// Notify caller.
	Broadcast (CntStatusBarHint (aStatusText));
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3MsgOpenJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3MsgOpenJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const SfxPoolItem *pReq = pJob->GetRequest();
	DBG_ASSERT (pReq, "CntPOP3MsgOpenJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain message node.
		CntNode *pSubject = pJob->GetSubject();
		DBG_ASSERT(
			pSubject, "CntPOP3MsgOpenJob_Impl::Execute(): no Subject");
		if (pSubject == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain MessageID.
		m_aMsgID  = ITEMSET_VALUE (pSubject, CntStringItem, WID_MESSAGE_ID);
		DBG_ASSERT(
			m_aMsgID.Len(),
			"CntPOP3MsgOpenJob_Impl::Execute(): empty MessageID");
		if (m_aMsgID.Len() == 0)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3MsgOpenJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3MsgOpenJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for Offline mode.
		CntConnMode eConnMode = GetParent()->GetConnMode();
		if (eConnMode == CNT_CONN_MODE_OFFLINE)
		{
			if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
			{
				// Job cancelled.
				return NULL;
			}
			eConnMode = GetParent()->GetConnMode();
		}

		// Check for Transacted mode.
		if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
		{
			// Insert into log and finish.
			pJob->Log();
			pJob->Done();
			return NULL;
		}

		// Online.
		m_eState = STATE_OPEN;

		// Obtain StoreMode and DeleteOnServer.
		USHORT eStoreMode = ITEMSET_VALUE(
			GetRootNode(), CntMsgStoreModeItem, WID_MESSAGE_STOREMODE);
		_bOffline = (eStoreMode == CNT_MESSAGE_STOREMODE_LOCAL);

		_bDeleteOnServer = ITEMSET_VALUE(
			GetRootNode(), CntBoolItem, WID_DELETE_ON_SERVER);
		_bDeleteOnServer &= _bOffline;
	}

	if (m_eState == STATE_OPEN)
	{
		// Check SubJob.
		if (!m_xSubJob.Is())
		{
			// Initialize index.
			m_nIndex = 0;

			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
			CntPOP3Job_Impl *pJobImpl =
				new CntPOP3IndexJob_Impl (m_xSubJob, GetParent());

			// Start child job.
			StartListening (*m_xSubJob);
			GetRootNode()->RescheduleJob (m_xSubJob);
			return NULL;
		}

		// Check SubJob result.
		if (m_xSubJob->IsCancelled())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		if (m_nIndex == 0)
		{
			// Not found. Mark message as deleted on server.
			m_pCache->attrib (m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONSERVER);

			// Notify caller.
			pJob->SetError (ERRCODE_CHAOS_MESSAGE_NOT_FOUND);

			// Finish.
			pJob->Cancel();
			return NULL;
		}

		// Retrieve mail by index.
		m_xSubJob.Clear();
		m_eState = STATE_INDEX;
	}

	if (m_eState == STATE_INDEX)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT(
			m_pMailer, "CntPOP3MsgOpenJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Create message data stream.
		CntPOP3Message_Impl::initDownload (
			*m_pMailer, m_pMessage, m_pCache);
		if (!m_pMessage->GetDocumentStream())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Retrieve mail.
		m_eState = STATE_MAIL;
		m_pMailer->RecvSetTransferCallback (ExecuteCallback, this);

		if (!m_pMailer->RecvMail (
			m_nIndex, *m_pMessage, ExecuteCallback, this))
		{
			// Notify caller.
			if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
			{
				// Try again.
				m_eState = STATE_OPEN;
				GetRootNode()->RescheduleJob (pJob);
			}
		}
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3MsgOpenJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3MsgOpenJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_MAIL:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Clear transfer callback.
					m_pMailer->RecvSetTransferCallback (NULL, NULL);

					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);
					if (e->m_nSize == 0)
						e->m_nSize = GetParent()->GetMsgSize (pReplyText);
					if (e->m_nSize == 0)
						e->m_nSize = m_pMailer->RecvGetTransferCount();
					e->m_aMsgID = m_aMsgID;

					// Notify caller.
					showStatusText (e->m_nSize, e->m_nSize);

					// Store download and cleanup.
					storeDownload (*e, *m_pMessage);
					DELETEZ (m_pMessage);

					// Check for DeleteOnServer flag.
					if (_bDeleteOnServer)
					{
						// Delete current entry from server.
						m_eState = STATE_DELETE;
						if (m_pMailer->RecvDeleteMail (
							m_nIndex, ExecuteCallback, this))
						{
							// Ok, wait for next callback.
							return;
						}
						else
						{
							// Failure.
							m_eState = STATE_DONE;
						}
					}
					else
					{
						// Done.
						m_eState = STATE_DONE;
					}
				}
				else if (nReplyCode == INETCOREPOP3_REPLY_TRANSFER_WAIT)
				{
					// Obtain current entry.
					CntPOP3ListEntry_Impl *e =
						GetParent()->GetListEntry (m_nIndex - 1);

					// Notify caller.
					ULONG n = m_pMailer->RecvGetTransferCount();
					showStatusText (n, e->m_nSize);

					// Wait for next callback.
					return;
				}
				else
				{
					// Failure.
					if (pReplyText)
					{
						// Notify caller.
						pJob->SetError (*(new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, *pReplyText)));
					}
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DELETE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Remember to enter UPDATE state.
					_bUpdate = TRUE;

					// Mark message as deleted from server.
					m_pCache->attrib (
						m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONSERVER);

					// Done.
					m_eState = STATE_DONE;
				}
				else
				{
					// Failure.
					if (pReplyText)
					{
						// Notify caller.
						pJob->SetError (*(new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, *pReplyText)));
					}
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				// Clear transfer callback.
				m_pMailer->RecvSetTransferCallback (NULL, NULL);

				// Remove StatusText.
				Broadcast (CntStatusBarHint (String()));

				// Check for UPDATE state or OFFLINE mode.
				if (_bUpdate || _bOffline)
				{
					m_pMailer->RecvCloseConnection (NULL, NULL);
					_bUpdate = FALSE;
				}

				// Done.
				m_eState = STATE_NONE;
				pJob->Done();
				break;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntPOP3MsgOpenJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (rHint.ISA(CntPOP3IndexHint_Impl))
		{
			// Obtain message index.
			m_nIndex = ((const CntPOP3IndexHint_Impl&)rHint).GetValue();
		}

		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}

	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			if (pJob->IsCancelled())
			{
				// Job has been cancelled.
				if (m_pMailer)
					m_pMailer->RecvAbortConnection();

				// Finish.
				m_eState = STATE_NONE;
			}

			if (m_pMessage)
			{
				// Cleanup data stream.
				CntPOP3Message_Impl::cleanupDownload (*m_pMessage, m_pCache);
				DELETEZ (m_pMessage);
			}
		}
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3MsgMarkJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3MsgMarkJob_Impl.
 */
CntPOP3MsgMarkJob_Impl::CntPOP3MsgMarkJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pUserData     (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3MsgMarkJob_Impl.
 */
CntPOP3MsgMarkJob_Impl::~CntPOP3MsgMarkJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3MsgMarkJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3MsgMarkJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const CntBoolItem *pReq =
		(const CntBoolItem *)(pJob->GetRequest());
	DBG_ASSERT(
		pReq, "CntPOP3MsgMarkJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain subject.
		CntNode *pSubject = pJob->GetSubject();
		DBG_ASSERT(
			pSubject, "CntPOP3MsgMarkJob_Impl::Execute(): no Subject");
		if (pSubject == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for attribute change.
		if (*pReq == pSubject->Get (pReq->Which()))
		{
			// Nothing to do.
			pJob->Done();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3MsgMarkJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Ensure nonblocking bulk operation.
		m_eState = STATE_MARK;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_MARK)
	{
		// Obtain subject.
		CntNode *pSubject = pJob->GetSubject();
		if (pReq->Which() == WID_IS_READ)
		{
			// Update Box: SeenContentCount.
			CntStoreItemSetRef xUserSet (
				GetParent()->GetUserItemSet (m_pUserData));
			if (xUserSet.Is())
			{
				ULONG nSeen = ITEMSET_VALUE(
					xUserSet, CntUInt32Item, WID_SEENCONTENTCOUNT);
				if (pReq->GetValue())
					nSeen = nSeen + 1;
				else
					nSeen = ((nSeen > 0) ? nSeen - 1 : 0 );

				CntUInt32Item aSeenCount (WID_SEENCONTENTCOUNT, nSeen);
				xUserSet->Put (aSeenCount);

				GetRootNode()->Put (aSeenCount);
			}

			// Update Box: SeenFlag.
			ULONG nKnown = ITEMSET_VALUE(
				GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);
			ULONG nSeen = ITEMSET_VALUE(
				GetRootNode(), CntUInt32Item, WID_SEENCONTENTCOUNT);
			GetRootNode()->Put (CntBoolItem (WID_IS_READ, (nSeen == nKnown)));
		}

		// Update message itemset.
		String aMsgID (ITEMSET_VALUE(
			pSubject, CntStringItem, WID_MESSAGE_ID));
		GetParent()->SetMsgUserFlag (m_pUserData, aMsgID, *pReq);

		// Update message node.
		pSubject->Put (*pReq);

		// Finish.
		m_eState = STATE_DONE;
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntPOP3MsgMarkJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3MsgDeleteJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3MsgDeleteJob_Impl.
 */
CntPOP3MsgDeleteJob_Impl::CntPOP3MsgDeleteJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_xSubJob       (NULL),
	  m_pCache        (NULL),
	  m_pUserData     (NULL),
	  m_pMailer       (NULL),
	  m_nIndex        (0),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3MsgDeleteJob_Impl.
 */
CntPOP3MsgDeleteJob_Impl::~CntPOP3MsgDeleteJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3MsgDeleteJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3MsgDeleteJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check request.
	const CntBoolItem *pReq = (const CntBoolItem *)(pJob->GetRequest());
	DBG_ASSERT (pReq, "CntPOP3MsgDeleteJob_Impl::Execute(): no Request");
	if (pReq == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain message node.
		CntNode *pSubject = pJob->GetSubject();
		DBG_ASSERT(
			pSubject, "CntPOP3MsgDeleteJob_Impl::Execute(): no Subject");
		if (pSubject == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check marked flag.
		if (ITEMSET_VALUE (pSubject, CntBoolItem, WID_IS_MARKED))
		{
			// Don't delete marked message.
			pJob->Cancel();
			return NULL;
		}

		// Obtain MessageID.
		m_aMsgID = ITEMSET_VALUE (pSubject, CntStringItem, WID_MESSAGE_ID);
		DBG_ASSERT(
			m_aMsgID.Len(),
			"CntPOP3MsgDeleteJob_Impl::Execute(): empty MessageID");
		if (m_aMsgID.Len() == 0)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3MsgDeleteJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3MsgDeleteJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check for remote deletion.
		BOOL bRemote = ITEMSET_VALUE(
			GetRootNode(), CntBoolItem, WID_DELETE_ON_SERVER);
		bRemote &= pReq->GetValue();
		if (bRemote)
		{
			UINT32 nAttrib = 0;
			m_pCache->attrib (m_aMsgID, 0, 0, nAttrib);
			bRemote &= (!(nAttrib & CNTDIRENTRY_ATTRIB_DELETEONSERVER));
		}

		// Determine initial state.
		m_eState = STATE_LOCAL;
		if (bRemote)
		{
			// Check for Offline mode.
			CntConnMode eConnMode = GetParent()->GetConnMode();
			if (eConnMode == CNT_CONN_MODE_OFFLINE)
			{
				if (pJob->SetError (ERRCODE_CHAOS_OFFLINE))
				{
					// Job cancelled.
					return NULL;
				}
				eConnMode = GetParent()->GetConnMode();
			}

			// Check for Transacted mode.
			if (eConnMode == CNT_CONN_MODE_OFFLINE_TRANSACTED)
			{
				// Insert into log and finish.
				pJob->Log();
				pJob->Done();
				return NULL;
			}

			// Online.
			m_eState = STATE_OPEN;
		}

		// Ensure nonblocking bulk operation.
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_OPEN)
	{
		// Check SubJob.
		if (!m_xSubJob.Is())
		{
			// Initialize index.
			m_nIndex = 0;

			// Setup SubJob.
			m_xSubJob = new CntNodeJob (
				pJob, pJob->GetClient(), pJob->GetSubject(), *pReq);
			CntPOP3Job_Impl *pJobImpl =
				new CntPOP3IndexJob_Impl (m_xSubJob, GetParent());

			// Start child job.
			StartListening (*m_xSubJob);
			GetRootNode()->RescheduleJob (m_xSubJob);
			return NULL;
		}

		// Check SubJob result.
		if (m_xSubJob->IsCancelled())
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}
		m_xSubJob.Clear();

		if (m_nIndex)
		{
			// Delete mail by index.
			m_eState = STATE_INDEX;
		}
		else
		{
			// Not found. Mark as deleted on server.
			m_pCache->attrib (
				m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONSERVER);

			// Delete mail local.
			m_eState = STATE_LOCAL;
		}
	}

	if (m_eState == STATE_INDEX)
	{
		// Obtain mailer.
		m_pMailer = GetParent()->GetMailer();
		DBG_ASSERT(
			m_pMailer, "CntPOP3MsgDeleteJob_Impl::Execute(): no Mailer");
		if (m_pMailer == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Delete mail.
		m_eState = STATE_DELETE;
		if (!m_pMailer->RecvDeleteMail (
			m_nIndex, ExecuteCallback, this))
		{
			if (!pJob->SetError (ERRCODE_IO_UNKNOWN))
			{
				// Try again.
				m_eState = STATE_OPEN;
				GetRootNode()->RescheduleJob (pJob);
			}
		}
	}

	if (m_eState == STATE_LOCAL)
	{
		// Check for trashed message.
		UINT32 nAttrib = 0;
		m_pCache->attrib (m_aMsgID, 0, 0, nAttrib);
		if (!(nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE))
		{
			// Obtain KnownContentCount.
			ULONG nKnown = ITEMSET_VALUE(
				GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);
			CntStoreItemSetRef xDirSet (
				GetParent()->GetBoxItemSet (m_pCache));
			if (xDirSet.Is())
			{
				nKnown = ITEMSET_VALUE(
					xDirSet, CntUInt32Item, WID_TOTALCONTENTCOUNT);
			}
			nKnown = ((nKnown > 0) ? nKnown - 1 : 0);

			// Update Box: KnownContentCount.
			CntUInt32Item aKnownCount (WID_TOTALCONTENTCOUNT, nKnown);
			GetRootNode()->Put (aKnownCount);
			if (xDirSet.Is())
				xDirSet->Put (aKnownCount);
			xDirSet.Clear();

			// Obtain SeenContentCount.
			ULONG nSeen = ITEMSET_VALUE(
				GetRootNode(), CntUInt32Item, WID_SEENCONTENTCOUNT);
			CntStoreItemSetRef xUserSet (
				GetParent()->GetUserItemSet (m_pUserData));
			if (xUserSet.Is())
			{
				nSeen = ITEMSET_VALUE(
					xUserSet, CntUInt32Item, WID_SEENCONTENTCOUNT);
			}
			nSeen = min (nSeen, nKnown + 1);

			// Check SeenFlag.
			UINT32 nUserAttrib = 0;
			m_pUserData->attrib (m_aMsgID, 0, 0, nUserAttrib);
			if (!(nUserAttrib & CNTDIRENTRY_ATTRIB_UNSEEN))
			{
				// Update Box: SeenContentCount.
				nSeen = ((nSeen > 0) ? nSeen - 1 : 0);

				CntUInt32Item aSeenCount (WID_SEENCONTENTCOUNT, nSeen);
				GetRootNode()->Put (aSeenCount);
				if (xUserSet.Is())
					xUserSet->Put (aSeenCount);
			}
			xUserSet.Clear();

			// Update Box: SeenFlag.
			BOOL bSeen = (nSeen == nKnown);
			GetRootNode()->Put (CntBoolItem (WID_IS_READ, bSeen));
		}

		// Delete message from Cache and UserData.
		if (pReq->GetValue())
		{
			// Destroyed. Remove body from Cache.
			String aBodyURL (OWN_URL (pJob->GetSubject()));
			aBodyURL.AppendAscii (".body");
			m_pCache->remove (aBodyURL);

			// Remove itemset from Cache.
			CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
				aMsgDirRanges_Impl, m_aMsgID, STREAM_STD_READ));
			if (xDirSet.Is())
			{
				// Obtain UniqueID.
				String aUniqueID (ITEMSET_VALUE(
					xDirSet, CntStringItem, WID_UNIQUE_ID));
				xDirSet.Clear();

				// Remove secondary link.
				if (aUniqueID.Len())
					m_pCache->remove (aUniqueID);

				// Check for existence on server.
				if (nAttrib & CNTDIRENTRY_ATTRIB_DELETEONSERVER)
				{
					// Remove from client, too.
					m_pCache->remove (m_aMsgID);
				}
				else
				{
					// Mark as deleted on client.
					m_pCache->attrib (
						m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONCLIENT);
					delete m_pCache->openStream (
						m_aMsgID, STREAM_READWRITE | STREAM_TRUNC);
					if (aUniqueID.Len())
						m_pCache->rename (m_aMsgID, aUniqueID);
				}
			}

			// Remove itemset from UserData.
			m_pUserData->remove (m_aMsgID);
		}
		else
		{
			// Trashed. Mark message for delete.
			m_pCache->attrib (
				m_aMsgID, 0, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
			m_pUserData->attrib (
				m_aMsgID, 0, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
		}

		// Done.
		Result (pJob->GetSubject(), CNT_ACTION_DELETED);
		pJob->Done();
	}

	// Leave.
	return NULL;
}

/*
 * ExecuteHandler.
 */
void CntPOP3MsgDeleteJob_Impl::ExecuteHandler (
	INetCoreMailer *pMailer,
	sal_Int32 nReplyCode, const sal_Char *pReplyText)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT (pJob, "CntPOP3MsgDeleteJob_Impl::ExecuteHandler(): no Job");
	if (pJob == NULL)
		return;

	// Jump into state machine.
	while (1)
	{
		switch (m_eState)
		{
			case STATE_DELETE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Message deleted on server.
					m_pCache->attrib (
						m_aMsgID, 0, CNTDIRENTRY_ATTRIB_DELETEONSERVER);

					// Check next job to do.
					m_eState = STATE_CLOSE;

					CntNodeJob *pNextJob = GetRootNode()->GetNextJob();
					if (pNextJob == NULL)
					{
						// Will be idle afterwards. Close connection.
						if (m_pMailer->RecvCloseConnection (
							ExecuteCallback, this))
						{
							// Ok, wait for next callback.
							return;
						}
						else
						{
							// Failure.
							m_eState = STATE_DONE;
						}
					}
					else
					{
						// Another job to do. Check request.
						const SfxPoolItem *pNextReq = pNextJob->GetRequest();
						if ((pNextReq->Which() == WID_DELETE))
						{
							// Bulk deletion...
							break;
						}
						else
						{
							// Need POP3 UPDATE state. Close connection.
							if (m_pMailer->RecvCloseConnection (
								ExecuteCallback, this))
							{
								// Ok, wait for next callback.
								return;
							}
							else
							{
								// Failure.
								m_eState = STATE_DONE;
							}
						}
					}
				}
				else
				{
					// Failure.
					m_eState = STATE_DONE;
					if (pReplyText)
					{
						// Notify caller.
						pJob->SetError (*(new StringErrorInfo (
							ERRCODE_CHAOS_SERVER_ERROR, *pReplyText)));
					}
				}
				break;

			case STATE_CLOSE:
				if (nReplyCode == INETCOREPOP3_REPLY_OK)
				{
					// Connection closed. Restart for local deletion.
					m_eState = STATE_LOCAL;
					GetRootNode()->RescheduleJob (pJob);
					return;
				}
				else
				{
					// Close failure.
					m_eState = STATE_DONE;
				}
				break;

			case STATE_DONE:
				// Done.
				m_eState = STATE_NONE;
				pJob->Done();
				return;

			default: // STATE_NONE.
				return;
		}
	}
}

/*
 * Notify.
 */
void CntPOP3MsgDeleteJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntNodeJob *pJob = PTR_CAST (CntNodeJob, &rBC);
	if ((pJob != NULL) && (pJob == &m_xSubJob))
	{
		if (rHint.ISA(CntPOP3IndexHint_Impl))
		{
			// Obtain message index.
			m_nIndex = ((const CntPOP3IndexHint_Impl&)rHint).GetValue();
		}
		if (pJob->IsCancelled() || pJob->IsDone())
		{
			// SubJob finished.
			EndListening (*m_xSubJob);

			// Restart parent job.
			GetRootNode()->RescheduleJob (GetJob());
		}
		return;
	}

	if ((pJob != NULL) && (pJob == GetJob()))
	{
		if (pJob->IsCancelled())
		{
			// Job has been cancelled.
			if (m_pMailer)
				m_pMailer->RecvAbortConnection();

			// Finish.
			m_eState = STATE_NONE;
		}
	}
	CntPOP3Job_Impl::Notify (rBC, rHint);
}

/*=======================================================================
 *
 * CntPOP3MsgRestoreJob_Impl implementation.
 *
 *=====================================================================*/
/*
 * CntPOP3MsgRestoreJob_Impl.
 */
CntPOP3MsgRestoreJob_Impl::CntPOP3MsgRestoreJob_Impl (
	CntNodeJob *pJob, CntPOP3Node_Impl *pParent)
	: CntPOP3Job_Impl (pJob, pParent),
	  m_pCache        (NULL),
	  m_pUserData     (NULL),
	  m_eState        (STATE_NONE)
{
}

/*
 * ~CntPOP3MsgRestoreJob_Impl.
 */
CntPOP3MsgRestoreJob_Impl::~CntPOP3MsgRestoreJob_Impl (void)
{
}

/*
 * Execute.
 */
const SfxPoolItem* CntPOP3MsgRestoreJob_Impl::Execute (void)
{
	// Check context.
	CntNodeJob *pJob = GetJob();
	DBG_ASSERT(
		pJob, "CntPOP3MsgRestoreJob_Impl::Execute(): no Job");
	if (pJob == NULL)
		return NULL;

	// Check subject.
	CntNode *pSubject = pJob->GetSubject();
	DBG_ASSERT(
		pSubject, "CntPOP3MsgRestoreJob_Impl::Execute(): no Subject");
	if (pSubject == NULL)
	{
		// Failure.
		pJob->Cancel();
		return NULL;
	}

	// Initialize.
	if (m_eState == STATE_NONE)
	{
		// Obtain cache node.
		m_pCache = pJob->GetCacheNode();
		DBG_ASSERT(
			m_pCache, "CntPOP3MsgRestoreJob_Impl::Execute(): no Cache");
		if (m_pCache == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain UserData node.
		m_pUserData = pJob->GetUserDataNode();
		DBG_ASSERT(
			m_pUserData, "CntPOP3MsgRestoreJob_Impl::Execute(): no UserData");
		if (m_pUserData == NULL)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Obtain MessageID.
		m_aMsgID = ITEMSET_VALUE(
			pSubject, CntStringItem, WID_MESSAGE_ID);
		DBG_ASSERT(
			m_aMsgID.Len(),
			"CntPOP3MsgRestoreJob_Impl::Execute(): no MessageID");
		if (m_aMsgID.Len() == 0)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Check message itemset.
		UINT32 nAttrib = 0;
		if (m_pCache->attrib (m_aMsgID, 0, 0, nAttrib) != ERRCODE_NONE)
		{
			// Failure.
			pJob->Cancel();
			return NULL;
		}

		// Ensure nonblocking bulk operation.
		m_eState = STATE_RESTORE;
		GetRootNode()->RescheduleJob (pJob);
		return NULL;
	}

	if (m_eState == STATE_RESTORE)
	{
		// Restore message itemset.
		CntStoreItemSetRef xDirSet (m_pCache->openItemSet (
			aMsgDirRanges_Impl, m_aMsgID, STREAM_STD_READ));
		if (xDirSet.Is())
		{
			// Feed into message node.
			pSubject->Put (*xDirSet);
			xDirSet.Clear();

			// Remove MarkedForDelete attribute.
			String aBodyUrl (OWN_URL (pSubject));
			aBodyUrl.AppendAscii (".body");

			m_pCache->attrib (
				m_aMsgID, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE, 0);
			m_pCache->attrib (
				aBodyUrl, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE, 0);
		}

		// Obtain KnownContentCount.
		ULONG nKnown = ITEMSET_VALUE(
			GetRootNode(), CntUInt32Item, WID_TOTALCONTENTCOUNT);
		nKnown += 1;

		// Update Box: KnownContentCount.
		xDirSet = GetParent()->GetBoxItemSet (m_pCache);
		if (xDirSet.Is())
		{
			xDirSet->Put (CntUInt32Item (WID_TOTALCONTENTCOUNT, nKnown));
			xDirSet.Clear();
		}
		GetRootNode()->Put (CntUInt32Item (WID_TOTALCONTENTCOUNT, nKnown));

		// Obtain SeenContentCount.
		ULONG nSeen = ITEMSET_VALUE(
			GetRootNode(), CntUInt32Item, WID_SEENCONTENTCOUNT);

		// Remove UserData MarkedForDelete attribute.
		UINT32 nAttrib = 0;
		ErrCode eErrCode = m_pUserData->attrib (
			m_aMsgID, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE, 0, nAttrib);
		if ((eErrCode == ERRCODE_NONE) || (eErrCode == ERRCODE_IO_NOTEXISTS))
		{
			// Recover MarkFlag and SeenFlag.
			BOOL bMarked =
				(nAttrib & CNTDIRENTRY_ATTRIB_MARKED) ? TRUE : FALSE;
			BOOL bSeen =
				(nAttrib & CNTDIRENTRY_ATTRIB_UNSEEN) ? FALSE : TRUE;
			if (bSeen)
			{
				// Update Box: SeenContentCount.
				nSeen += 1;
				CntStoreItemSetRef xUserSet (
					GetParent()->GetUserItemSet (m_pUserData));
				if (xUserSet.Is())
				{
					xUserSet->Put (CntUInt32Item (
						WID_SEENCONTENTCOUNT, nSeen));
					xUserSet.Clear();
				}
				GetRootNode()->Put (CntUInt32Item (
					WID_SEENCONTENTCOUNT, nSeen));
			}

			// Feed into message node.
			pSubject->Put (CntBoolItem (WID_IS_MARKED, bMarked));
			pSubject->Put (CntBoolItem (WID_IS_READ, bSeen));
		}

		// Update Box: SeenFlag.
		GetRootNode()->Put (CntBoolItem (WID_IS_READ, (nSeen == nKnown)));

		// Check for inserted message.
		if (!pSubject->IsInserted())
			GetRootNode()->Inserted (pSubject, pJob);

		// Finish.
		m_eState = STATE_DONE;
	}

	// Done.
	pJob->Done();
	return NULL;
}

/*
 * Notify.
 */
void CntPOP3MsgRestoreJob_Impl::Notify (
	SfxBroadcaster& rBC, const SfxHint& rHint)
{
	CntPOP3Job_Impl::Notify (rBC, rHint);
}
