/*************************************************************************
 *
 *  $RCSfile: cvimimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _INETCOREMAIL_HXX
#include <inet/inetmail.hxx>
#endif
#ifndef _INET_WRAPPER_HXX
#include <inet/wrapper.hxx>
#endif
#ifndef _DATETIMEITEM_HXX
#include <svtools/dateitem.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _FSYS_HXX
#include <tools/fsys.hxx>
#endif
#ifndef _TOOLS_INTN_HXX
#include <tools/intn.hxx>
#endif

#ifndef _ALSTITEM_HXX
#include <alstitem.hxx>
#endif
#ifndef _CASTMACS_HXX
#include <castmacs.hxx>
#endif
#ifndef _CNTAPI_HXX
#include <cntapi.hxx>
#endif
#ifndef _CNTJOB_HXX
#include <cntjob.hxx>
#endif
#ifndef _CNTMBITM_HXX
#include <cntmbitm.hxx>
#endif
#ifndef _CNTMMITM_HXX
#include <cntmmitm.hxx>
#endif
#ifndef _CNTMSGNODE_HXX
#include <cntmsgnd.hxx>
#endif
#ifndef _CNTNODE_HXX
#include <cntnode.hxx>
#endif
#ifndef _CNTRESID_HXX
#include <cntresid.hxx>
#endif
#ifndef _CNTRNMGR_HXX
#include <cntrnmgr.hxx>
#endif
#ifndef _CNTSDITM_HXX
#include <cntsditm.hxx>
#endif
#ifndef _CNTSTGND_HXX
#include <cntstgnd.hxx>
#endif
#ifndef _CNTVIM_HXX
#include <cntvim.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <cstritem.hxx>
#endif
#ifndef CHAOS_FLSTITEM_HXX
#include <flstitem.hxx>
#endif
#ifndef _CHAOS_INIMGR_HXX
#include <inimgr.hxx>
#endif
#ifndef _PROCHAOS_HRC
#include <prochaos.hrc>
#endif
#ifndef _RCPNITEM_HXX
#include <rcpnitem.hxx>
#endif
#ifndef _CHAOS_SILITEM_HXX
#include <silitem.hxx>
#endif
#ifndef _CHAOS_STORITEM_HXX
#include <storitem.hxx>
#endif
#ifndef CHAOS_THRDTASK_HXX
#include <thrdtask.hxx>
#endif

#ifndef _CHAOS_CVIMBOX_HXX
#include <cvimbox.hxx>
#endif
#ifndef _CHAOS_CVIMIMP_HXX
#include <cvimimp.hxx>
#endif
#ifndef _CHAOS_VIMWRAP_HXX
#include <vimwrap.hxx>
#endif

using namespace chaos;

//============================================================================
// Some WIDs and CNTDIRENTRY_ATTRIBs:

// A WID that must lie within CntVIMNode and account directory item set
// ranges:
#define WID_VIM_BBOARDSSUPPORTED WID_NEWSGROUPCOUNT

// WIDs that must lie within CntVIMContainerNode and container directory item
// set ranges:
#define WID_VIM_HIGHESTMSGREFIDPART1 WID_NEWSGROUPCOUNT
#define WID_VIM_HIGHESTMSGREFIDPART2 WID_ARTICLECOUNT

// A WID that must lie within CntVIMContainerNode and container user data item
// set ranges:
#define WID_VIM_MARKEDCONTENTCOUNT WID_SUBSCRNEWSGROUPCOUNT

// A WID that must lie within CntVIMBBoardBoxNode and bulletin box directory
// item set ranges:
#define WID_VIM_BBOARDLISTPRESENT WID_NEWSGROUPCOUNT

// WIDs that must lie within bulletin box view data item set ranges:
#define WID_VIM_SUBSCRSEENCONTENTCOUNT WID_SEENCONTENTCOUNT

// WIDs that must lie within CntMessageNode and message directory item set
// ranges:
#define WID_VIM_MSGREFIDPART1 WID_REPLY_TO
#define WID_VIM_MSGREFIDPART2 WID_IN_REPLY_TO

// Attributes used for bulletin board entries in bulletin box directory
// storages:
#define CNTDIRENTRY_ATTRIB_VIM_NEW CNTDIRENTRY_ATTRIB_USER1
#define CNTDIRENTRY_ATTRIB_VIM_REMOVED CNTDIRENTRY_ATTRIB_USER2

// Attributes used for message entries in container directory storages:
#define CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY CNTDIRENTRY_ATTRIB_USER1
#define CNTDIRENTRY_ATTRIB_VIM_INTERNALLYUNREAD CNTDIRENTRY_ATTRIB_USER2

// An attribute used for message entries in user data storages:
#define CNTDIRENTRY_ATTRIB_VIM_UNSEEN CNTDIRENTRY_ATTRIB_USER1

//============================================================================
#define CNT_VIM_IBOX_URL_PART "inbox/"
#define CNT_VIM_BBOX_URL_PART "newsgroups/"
#define CNT_VIM_DATA_SET_ID "/data"
#define CNT_VIM_IBOX_DATA_SET_ID "inbox/data"
#define CNT_VIM_BBOX_DATA_SET_ID "newsgroups/data"
#define CNT_VIM_MESG_BODY_ID_SUFFIX "/body"
#define CNT_VIM_BBOARDLIST_FILENAME "ccbbdlst.txt"

//============================================================================
enum CntVIMBBoardsSupported { CNT_VIM_BBOARDS_UNKNOWN, CNT_VIM_BBOARDS_YES,
							  CNT_VIM_BBOARDS_NO };

//============================================================================
class CntVIMCntrOpenTask_Impl: public ThreadTask
{
	enum CacheBodiesType { CACHE_NONE, CACHE_SOME, CACHE_ALL };

	enum ViewFilterType { FILTER_NONE, FILTER_CLEAR, FILTER_SET };

	enum Progress { PROGRESS_NONE, PROGRESS_TEXT, PROGRESS_VALUE };

	CntNode & m_rCntrNode;
	CntVIMContainerNodeImp & m_rCntr;
	CntVIMNodeImp & m_rAcnt;
	USHORT m_nWhich;
	BOOL m_bOnline;
	CacheBodiesType m_eCacheBodies;
	BOOL m_bClearExpiredBodies;
	Date m_aKeepSinceDate;
	ViewFilterType m_eViewFilter;
	UINT32 m_nViewFilterAttrib;
	ULONG m_nSearchFilterType;
	ByteString m_aSearchFilterString;
	CntVIMDateRange m_aSearchFilterDate;
	const void * m_pSearchFilterData;
	ULONG m_nSearchFilterDataLen;
	CntVIMMessageContainer * m_pContainer;
	UINT32 m_nTotalMesgs;
	BOOL m_bSeekPastKnown;
	BOOL m_bIterateFromEnd;
	BOOL m_bFirst;
	CntStorageIterator * m_pIterator;
	CntStorageNode * m_pCache;
	CntStorageNode * m_pDirectory;
	CntStorageNode * m_pUserData;
	String m_aCntrURL;
	UINT32 m_nMesgCount;
	USHORT m_nProgressID;
	UINT32 m_nNewMesgs;
	BOOL m_bWaitingHeaders;
	BOOL m_bWaitingBody;
	CntStoreItemSetRef m_xMsgDirSet;
	CntNodeRef m_xMsgNode;
	Progress m_eProgress;
	BOOL m_bInitialized;

	static void translate(const DateTime & rDate, CntVIMDate & rVIMDate);

	void createMesgNode(const String & aMesgID, const String & aMesgURL,
						BOOL bValidMesgRefID, CntStoreItemSet * pDirSet);

	void clearProgress();

	virtual const SfxPoolItem * execute();

	virtual void finished(bool bCanceled);

public:
	inline CntVIMCntrOpenTask_Impl(CntNodeJob & rJob,
								   CntNode & rTheCntrNode,
								   CntVIMContainerNodeImp & rTheCntr,
								   CntVIMNodeImp & rTheAcnt);
};

inline
CntVIMCntrOpenTask_Impl::CntVIMCntrOpenTask_Impl(CntNodeJob & rJob,
												 CntNode & rTheCntrNode,
												 CntVIMContainerNodeImp &
												  rTheCntr,
												 CntVIMNodeImp & rTheAcnt):
	ThreadTask(rJob, rTheCntrNode),
	m_rCntrNode(rTheCntrNode),
	m_rCntr(rTheCntr),
	m_rAcnt(rTheAcnt),
	m_pContainer(0),
	m_pIterator(0),
	m_bWaitingHeaders(FALSE),
	m_bWaitingBody(FALSE),
	m_eProgress(PROGRESS_NONE),
	m_bInitialized(FALSE)
{}

//============================================================================
class CntVIMCntrFlagTask_Impl: public ThreadTask
{
	CntNode & m_rCntrNode;
	CntVIMContainerNodeImp & m_rCntr;
	UINT32 nTotalCount;
	const CntBoolItem * pFlag;
	USHORT m_nHintID;
	String aContainerURL;
	CntStorageNode * pDirectory;
	CntStorageNode * pUserData;
	CntStorageIterator * m_pIterator;
	UINT32 nProcessedCount;
	UINT32 nChangedCount;
	BOOL m_bInitialized;

	virtual const SfxPoolItem * execute();

	virtual void finished(bool bCanceled);

public:
	inline CntVIMCntrFlagTask_Impl(CntNodeJob & rJob,
								   CntNode & rTheCntrNode,
								   CntVIMContainerNodeImp & rTheCntr);
};

inline
CntVIMCntrFlagTask_Impl::CntVIMCntrFlagTask_Impl(CntNodeJob & rJob,
												 CntNode & rTheCntrNode,
												 CntVIMContainerNodeImp &
												  rTheCntr):
	ThreadTask(rJob, rTheCntrNode),
	m_rCntrNode(rTheCntrNode),
	m_rCntr(rTheCntr),
	m_nHintID(0),
	m_pIterator(0),
	m_bInitialized(FALSE)
{}

//============================================================================
class CntVIMMesgOpenTask_Impl: public ThreadTask
{
	CntNode & m_rCntrNode;
	CntVIMContainerNodeImp & m_rCntr;
	CntMessageNode * m_pMsgNode;
	BOOL m_bWaiting;

	virtual const SfxPoolItem * execute();

	virtual void finished(bool bCanceled);

public:
	inline CntVIMMesgOpenTask_Impl(CntNodeJob & rJob,
								   CntNode & rTheCntrNode,
								   CntVIMContainerNodeImp & rTheCntr,
								   CntMessageNode * pTheMsgNode);
};

inline
CntVIMMesgOpenTask_Impl::CntVIMMesgOpenTask_Impl(CntNodeJob & rJob,
												 CntNode & rTheCntrNode,
												 CntVIMContainerNodeImp &
												  rTheCntr,
												 CntMessageNode *
												  pTheMsgNode):
	ThreadTask(rJob, rTheCntrNode),
	m_rCntrNode(rTheCntrNode),
	m_rCntr(rTheCntr),
	m_pMsgNode(pTheMsgNode),
	m_bWaiting(FALSE)
{}

//============================================================================
class CntVIMBBoxTask_Impl: public ThreadTask
{
protected:
	CntVIMBBoxTask_Impl(CntNodeJob & rJob, CntNode & rExecNode):
		ThreadTask(rJob, rExecNode) {}

public:
	using ThreadTask::StartListening;
};

//============================================================================
class CntVIMBboxOpenTask_Impl: public CntVIMBBoxTask_Impl
{
	enum Progress { PROGRESS_NONE, PROGRESS_TEXT, PROGRESS_VALUE };

	CntNode & rBBoardBoxNode;
	CntVIMBBoardBoxNodeImp & rBBoardBoxNodeImp;
	USHORT nWhich;
	const CntSearchData * pSearchData;
	CntStorageNode * pDirectory;
	CntStorageNode * pViewData;
	BOOL bViewAll;
	BOOL bOnline;
	BOOL bNoListYet;
	CntFolderList * m_pList;
	String aBBoardBoxURL;
	UINT32 nTotalCount;
	CntStorageNode * pIterStorage;
	UINT32 nMaxProcess;
	USHORT nHintID;
	UINT32 nProcessed;
	CntStorageIterator * m_pIterator;
	BOOL bStartSecondPhase;
	BOOL bCanceledChildren;
	BOOL m_bInitialized;
	Progress m_eProgress;

	void clearProgress();

	virtual const SfxPoolItem * execute();

	virtual void notification(SfxBroadcaster & rBroadcaster,
							  const SfxHint & rHint);

	virtual void finished(bool bCanceled);

public:
	inline CntVIMBboxOpenTask_Impl(CntNodeJob & rJob,
								   CntNode & rTheBBoardBoxNode,
								   CntVIMBBoardBoxNodeImp &
								    rTheBBoardBoxNodeImp);
};

inline
CntVIMBboxOpenTask_Impl::CntVIMBboxOpenTask_Impl(CntNodeJob & rJob,
												 CntNode & rTheBBoardBoxNode,
												 CntVIMBBoardBoxNodeImp &
												  rTheBBoardBoxNodeImp):
	CntVIMBBoxTask_Impl(rJob, rBBoardBoxNode),
	rBBoardBoxNode(rTheBBoardBoxNode),
	rBBoardBoxNodeImp(rTheBBoardBoxNodeImp),
	m_pList(0),
	m_pIterator(0),
	m_bInitialized(FALSE),
	m_eProgress(PROGRESS_NONE)
{}

//============================================================================
class CntVIMBboxReadTask_Impl: public CntVIMBBoxTask_Impl
{
	CntNode & rBBoardBoxNode;
	CntVIMBBoardBoxNodeImp & rBBoardBoxNodeImp;
	const CntBoolItem * pRequest;
	CntStorageNode * pDirectory;
	CntStorageNode * pViewData;
	BOOL bViewAll;
	UINT32 nMaxProcess;
	USHORT m_nHintID;
	UINT32 nProcessed;
	String aBBoardBoxURL;
	CntStorageNode * pIterStorage;
	CntStorageIterator * m_pIterator;
	BOOL bCanceledChildren;
	BOOL m_bInitialized;

	virtual const SfxPoolItem * execute();

	virtual void notification(SfxBroadcaster & rBroadcaster,
							  const SfxHint & rHint);

	virtual void finished(bool bCanceled);

public:
	inline CntVIMBboxReadTask_Impl(CntNodeJob & rJob,
								   CntNode & rTheBBoardBoxNode,
								   CntVIMBBoardBoxNodeImp &
								    rTheBBoardBoxNodeImp);
};

inline
CntVIMBboxReadTask_Impl::CntVIMBboxReadTask_Impl(CntNodeJob & rJob,
												 CntNode & rTheBBoardBoxNode,
												 CntVIMBBoardBoxNodeImp &
												  rTheBBoardBoxNodeImp):
	CntVIMBBoxTask_Impl(rJob, rBBoardBoxNode),
	rBBoardBoxNode(rTheBBoardBoxNode),
	rBBoardBoxNodeImp(rTheBBoardBoxNodeImp),
	m_nHintID(0),
	m_pIterator(0),
	m_bInitialized(FALSE)
{}

//============================================================================
// A function that can be called by a node executing pJob to insert a job into
// pChild, which must be a child of the respective node:
static void lcl_insertChildJob(CntNodeJob & rJob, CntNode & rChildNode,
							   const SfxPoolItem & rRequest,
							   CntVIMBBoxTask_Impl * pListener = 0);

//============================================================================
// Ranges arrays:

// Ranges for CntVIMNode data directory item sets:
USHORT __READONLY_DATA aCntVIMBoxDirectoryItemSetRanges[]
 = { WID_VIM_BBOARDSSUPPORTED, WID_VIM_BBOARDSSUPPORTED, 0 };
	  // i.e., WID_NEWSGROUPCOUNT, WID_NEWSGROUPCOUNT,

// Ranges for CntVIMInbox/BBoardNode data directory item sets:
USHORT __READONLY_DATA aCntVIMContainerDirectoryItemSetRanges[]
 = { WID_TOTALCONTENTCOUNT, WID_VIM_HIGHESTMSGREFIDPART2, 0 };
	  // i.e., WID_TOTALCONTENTCOUNT, WID_ARTICLECOUNT,

// Ranges for CntVIMInbox/BBoardNode data user data item sets:
USHORT __READONLY_DATA aCntVIMContainerUserDataItemSetRanges[]
 = { WID_VIM_MARKEDCONTENTCOUNT, WID_VIM_MARKEDCONTENTCOUNT,
	  // i.e., WID_SUBSCRNEWSGROUPCOUNT, WID_SUBSCRNEWSGROUPCOUNT,
	 WID_SEENCONTENTCOUNT, WID_SEENCONTENTCOUNT, 0 };

// Ranges for CntMessageNode data directory item sets:
USHORT __READONLY_DATA aCntVIMMessageDirectoryItemSetRanges[]
 = { WID_PRIORITY, WID_PRIORITY,
	 WID_VIM_MSGREFIDPART1, WID_TITLE, // i.e., WID_REPLY_TO, WID_TITLE,
	 WID_NEWSGROUPS, WID_NEWSGROUPS,
	 WID_DATE_CREATED, WID_DATE_CREATED,
	 WID_ACTION_LIST, WID_ACTION_LIST, 0 };

// Ranges for CntVIMBBoardBoxNode data directory item sets:
USHORT __READONLY_DATA aCntVIMBBoardBoxDirectoryItemSetRanges[]
 = { WID_TOTALCONTENTCOUNT, WID_VIM_BBOARDLISTPRESENT, 0 };
	  // i.e., WID_TOTALCONTENTCOUNT, WID_NEWSGROUPCOUNT,

// Ranges for CntVIMBBoardBoxNode data user data item sets:
USHORT __READONLY_DATA aCntVIMBBoardBoxUserDataItemSetRanges[]
 = { WID_SEENCONTENTCOUNT, WID_SEENCONTENTCOUNT, 0 };

// Ranges for CntVIMBBoardBoxNode data view data item sets:
USHORT __READONLY_DATA aCntVIMBBoardBoxViewDataItemSetRanges[]
 = { WID_SUBSCRNEWSGROUPCOUNT, WID_SUBSCRNEWSGROUPCOUNT,
	 WID_VIM_SUBSCRSEENCONTENTCOUNT, WID_VIM_SUBSCRSEENCONTENTCOUNT, 0 };
	  // i.e., WID_SEENCONTENTCOUNT, WID_SEENCONTENTCOUNT,

//============================================================================
// Special VIM dates:
const DateTime aMinVIMDate(Date(1, 1, 1980), Time(0, 0));
const DateTime aMaxVIMDate(Date(31, 12, 2079), Time(23, 59, 59, 99));

//============================================================================
SV_IMPL_REF(CntStoreItemSet);

//============================================================================
// static
void lcl_insertChildJob(CntNodeJob & rJob, CntNode & rChildNode,
						const SfxPoolItem & rRequest,
						CntVIMBBoxTask_Impl * pListener)
{
	CntAnchorRef xChildAnchor;

	// Try to find a child anchor:
	CntAnchor * pBoxAnchor = PTR_CAST(CntAnchor, rJob.GetClient());
	if (pBoxAnchor)
	{
		ULONG nChildAnchorCount = pBoxAnchor->SubAnchorCount();
		for (ULONG i = 0; i < nChildAnchorCount; ++i)
		{
			CntAnchor * pSomeChildAnchor = (*pBoxAnchor)[i];
			if (pSomeChildAnchor->GetNode()->GetMostReferedNode()
				 == &rChildNode)
			{
				xChildAnchor = pSomeChildAnchor;
				break;
			}
		}
	}

	// If no child anchor was found, create one:
	if (!xChildAnchor.Is())
	{
		String aRootViewURL(pBoxAnchor->GetRootViewURL(TRUE));
		if (aRootViewURL.Len())
		{
			String aChildViewURL(CntAnchor::ToViewURL(aRootViewURL,
													  OWN_URL(&rChildNode)));
			if (aChildViewURL.Len())
				xChildAnchor = new CntAnchor(pBoxAnchor, aChildViewURL);
		}
	}
	if (!xChildAnchor.Is())
		xChildAnchor = new CntAnchor(pBoxAnchor, &rChildNode);

	// If the child anchor is really fresh, it has not yet received a
	// WID_GETDATA job, so give it one now:
	xChildAnchor->Put(SfxVoidItem(WID_GETDATA));

	// Create the job and insert it into the child node:
	CntNodeJob * pChildJob = new CntNodeJob(&rJob, &xChildAnchor, &rChildNode,
											rRequest);
	if (pListener)
		pListener->StartListening(*pChildJob);
	rChildNode.InsertJob(pChildJob);
}

//============================================================================
//
//  class CntVIMNodeImp
//
//============================================================================

CntStoreItemSet * CntVIMNodeImp::OpenDirectoryItemSet(CntStorageNode *
													   pDirectory)
{
	DBG_ASSERT(bInitialized,
			   "CntVIMNodeImp::OpenDirectoryItemSet(): Not init");

	if (!pDirectory)
		return 0;

	CntStoreItemSet * pItemSet
		= pDirectory->
		      openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
				                                      CNT_VIM_DATA_SET_ID)),
						  STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), recreate it
		// from the node's data:
		pDirectory->
			attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
				                               CNT_VIM_DATA_SET_ID)),
				   0, CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet = pDirectory->openItemSet(aCntVIMBoxDirectoryItemSetRanges,
										   String::CreateFromAscii(
											   RTL_CONSTASCII_STRINGPARAM(
												   CNT_VIM_DATA_SET_ID)));
		if (pItemSet)
			pItemSet->Put(pParent->Get(WID_VIM_BBOARDSSUPPORTED));
	}
	else
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_VIM_BBOARDSSUPPORTED)
				    == pParent->Get(WID_VIM_BBOARDSSUPPORTED),
				   "CntVIMNodeImp::OpenDirectoryItemSet(): Bad storage");
	return pItemSet;
}

//============================================================================
BOOL CntVIMNodeImp::OpenVIMSession(CntNodeJob * pJob, BOOL bAutoRetry) const
{
	if (pMailbox->isInitialized())
		return FALSE;

	pJob->Broadcast
	       (CntStatusBarHint(CntResId(RID_PROT_SENDING_LOGIN_INFORMATION)));
	for (;;)
		switch (pMailbox->initialize
				           (ITEMSET_VALUE(pParent, CntStringItem,
										  WID_VIM_POPATH),
							ITEMSET_VALUE(pParent, CntStringItem,
										  WID_USERNAME),
							ITEMSET_VALUE(pParent, CntStringItem,
										  WID_PASSWORD),
							pJob, FALSE))
		{
			case CntVIMMailbox::OK:
				pJob->Broadcast(CntStatusBarHint(String()));
				return FALSE;

			case CntVIMMailbox::LOGIN_ERROR:
			{
				String aErrorStatus(pMailbox->getStatus().getStatusText());
				if (pJob->SetError(ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE,
								   &aErrorStatus,
								   pJob->GetSubject()->GetRootNode()))
				{
					pJob->Broadcast(CntStatusBarHint(String()));
					return FALSE;
				}
				if (!bAutoRetry)
				{
					pJob->Broadcast(CntStatusBarHint(String()));
					return TRUE;
				}
				break;
			}

			case CntVIMMailbox::OTHER_ERROR:
				pJob->Broadcast(CntStatusBarHint(String()));
				pJob->Cancel();
				return FALSE;
		}
}

//============================================================================
// static
BOOL CntVIMNodeImp::hasOpenJob(CntNode & rNode)
{
	ULONG nCount = rNode.JobCount();
	for (ULONG i = 0; i < nCount; ++i)
	{
		const SfxPoolItem & rRequest = *rNode.GetJob(i)->GetRequest();
		switch (rRequest.Which())
		{
			case WID_OPEN:
			{
				CntOpenMode eJobMode
				 = CntOpenMode(ITEM_VALUE(CntOpenModeItem, rRequest));
				if (eJobMode == CNT_OPEN_ALL || eJobMode == CNT_OPEN_MESSAGES)
					return TRUE;
				break;
			}

			case WID_UPDATE:
				if (!rRequest.ISA(CntUpdateItem))
					return TRUE;
				break;

			case WID_SYNCHRONIZE:
				return TRUE;
		}
	}
	return FALSE;
}

//============================================================================
CntVIMNodeImp::CntVIMNodeImp(CntNode * pTheParent):
	pParent(pTheParent), pMailbox(new CntVIMMailbox()), bInitialized(FALSE)
{}

//============================================================================
CntVIMNodeImp::~CntVIMNodeImp()
{
	delete pMailbox;
}

//============================================================================
void CntVIMNodeImp::Initialize(CntNodeJob & rJob)
{
	if (!bInitialized)
	{
		CntStorageNode * pDirectory = rJob.GetCacheNode();
		if (pDirectory && !pDirectory->IsDummy())
		{
			const SfxPoolItem * pItem;
			if (pDirectory->GetItemState(WID_USERNAME, FALSE, &pItem)
				 == SFX_ITEM_SET)
				pParent->Put(*pItem);
			if (pDirectory->GetItemState(WID_PASSWORD, FALSE, &pItem)
				 == SFX_ITEM_SET)
				pParent->Put(*pItem);
			pParent->Put(pDirectory->Get(WID_VIM_POPATH));

			// Create a directory item set, if necessary, and put it into the
			// node:
			CntStoreItemSetRef
				xItemSet(pDirectory->
						     openItemSet(String::CreateFromAscii(
								             RTL_CONSTASCII_STRINGPARAM(
												 CNT_VIM_DATA_SET_ID)),
										 STREAM_STD_READ));
			UINT32 nContentCount;
			if (!xItemSet.Is())
			{
				pDirectory->
					attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
						                               CNT_VIM_DATA_SET_ID)),
						   0,
						   CNTDIRENTRY_ATTRIB_CREATE
						       | CNTDIRENTRY_ATTRIB_HIDDEN);
				xItemSet = pDirectory->
					           openItemSet(aCntVIMBoxDirectoryItemSetRanges,
										   String::CreateFromAscii(
											   RTL_CONSTASCII_STRINGPARAM(
												   CNT_VIM_DATA_SET_ID)));
				if (xItemSet.Is())
					xItemSet->Put(CntUInt32Item(WID_VIM_BBOARDSSUPPORTED,
												CNT_VIM_BBOARDS_UNKNOWN));
				nContentCount = 1;
			}
			else
				nContentCount
				 = ITEMSET_VALUE(xItemSet, CntUInt32Item,
								 WID_VIM_BBOARDSSUPPORTED)
				     == CNT_VIM_BBOARDS_YES ?
				    2 : 1;
			if (xItemSet.Is())
			{
				pParent->Put(*xItemSet);
				xItemSet = 0;
			}

			pParent->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT, nContentCount));

			bInitialized = TRUE;
		}
	}
}

//============================================================================
CntVIMNodeImp::OnlineMode CntVIMNodeImp::CheckOnline(BOOL bMustGoOnline,
													 CntNodeJob * pJob,
													 BOOL bAutoRetry)
{
	if (!bInitialized)
	{
		// The job might be a job for a sub node of the VIM box node, so the
		// directory node for the VIM box node must be some anchestor of the
		// directory node available through the job:
		CntStorageNode * pDirectory = pJob->GetDirectoryNode();
		while (pDirectory && pDirectory->GetMostReferedNode() != pParent)
			pDirectory = PTR_CAST(CntStorageNode, pDirectory->GetParent());
		if (pDirectory)
			Initialize(*pJob);
	}

	if (bInitialized && bOnline)
	{
		if (OpenVIMSession(pJob, bAutoRetry))
			return ONLINE_RETRY;
	}
	else if (bMustGoOnline && !pJob->SetError(ERRCODE_CHAOS_OFFLINE))
		pJob->Cancel();
	return bOnline ? ONLINE_YES : ONLINE_NO;
}

//============================================================================
void CntVIMNodeImp::Open(USHORT nWhich, CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "CntVIMNodeImp::Open(): Not init");

	const CntSearchData * pSearchData;
	if (nWhich == WID_SEARCH)
	{
		pSearchData = &ITEM_VALUE(CntSearchDataItem, *pJob->GetRequest());
		if (!pSearchData->DoSearchFirstLevel())
		{
			pJob->Done();
			return;
		}
	}

	if (CheckOnline(nWhich == WID_UPDATE || nWhich == WID_SYNCHRONIZE, pJob,
					FALSE)
		 == ONLINE_RETRY)
	{
		pParent->RescheduleJob(pJob);
		return;
	}
	if (pJob->IsCancelled())
		return;

	String aBoxServiceURL(OWN_URL(pParent));
	if (aBoxServiceURL.GetChar(aBoxServiceURL.Len() - 1) != '/')
		aBoxServiceURL += '/';
	String aBoxViewURL(INSECURE_DYNAMIC_CAST(CntAnchor *, pJob->GetClient())->
					    GetViewURL(TRUE));

	// Create the inbox node:
	String aInboxURL(aBoxServiceURL);
	aInboxURL.AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_IBOX_URL_PART));
	CntNodeRef xInboxNode(pParent->Query(aInboxURL));
	if (xInboxNode.Is())
	{
		CntAnchorRef
		 xInboxAnchor(aBoxViewURL.Len() ?
					   new CntAnchor(INSECURE_DYNAMIC_CAST(CntAnchor *,
														   pJob->GetClient()),
									 CntAnchor::ToViewURL(aBoxViewURL,
														  aInboxURL)) :
					   new CntAnchor(INSECURE_DYNAMIC_CAST(CntAnchor *,
														   pJob->GetClient()),
									 xInboxNode));
		xInboxAnchor->Put(SfxVoidItem(WID_GETDATA));
		xInboxAnchor = 0;

		if (nWhich == WID_OPEN)
			pJob->Result(xInboxNode, CNT_ACTION_INSERTED);
	}

	// Check if bulletin boards are supported:
	CntVIMBBoardsSupported eSupported
	 = CntVIMBBoardsSupported(ITEMSET_VALUE(pParent, CntUInt32Item,
											WID_VIM_BBOARDSSUPPORTED));
	BOOL bAnnounceBBoardBox;
	if (eSupported == CNT_VIM_BBOARDS_UNKNOWN && bOnline)
	{
		eSupported
		 = pMailbox->isCCMail() ? CNT_VIM_BBOARDS_YES : CNT_VIM_BBOARDS_NO;
		CntUInt32Item aSupportedItem(WID_VIM_BBOARDSSUPPORTED, eSupported);
		CntStoreItemSetRef
		 xDirectorySet(OpenDirectoryItemSet(pJob->GetDirectoryNode()));
		if (xDirectorySet.Is())
		{
			xDirectorySet->Put(aSupportedItem);
			xDirectorySet = 0;
		}
		pParent->Put(aSupportedItem);
		pParent->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT, 2));
		bAnnounceBBoardBox = TRUE;
	}
	else
		bAnnounceBBoardBox = nWhich == WID_OPEN;

	// Create the bulletin board box node, if supported:
	CntNodeRef xBBoardBoxNode;
	if (eSupported == CNT_VIM_BBOARDS_YES)
	{
		String aBBoardBoxURL(aBoxServiceURL);
		aBBoardBoxURL.
			AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_BBOX_URL_PART));
		xBBoardBoxNode = pParent->Query(aBBoardBoxURL);
		if (xBBoardBoxNode.Is())
		{
			CntAnchorRef
			 xBBoardBoxAnchor
			  (aBoxViewURL.Len() ?
			   new CntAnchor(INSECURE_DYNAMIC_CAST(CntAnchor *,
												   pJob->GetClient()),
							 CntAnchor::ToViewURL(aBoxViewURL,
												  aBBoardBoxURL)) :
			   new CntAnchor(INSECURE_DYNAMIC_CAST(CntAnchor *,
												   pJob->GetClient()),
							 xBBoardBoxNode));
			xBBoardBoxAnchor->Put(SfxVoidItem(WID_GETDATA));
			xBBoardBoxAnchor = 0;

			if (bAnnounceBBoardBox)
				pJob->Result(xBBoardBoxNode, CNT_ACTION_INSERTED);
		}
	}

	switch (nWhich)
	{
		case WID_OPEN:
			if (bOnline && xInboxNode.Is() && getUpdateOnOpenMode(*pJob)
				&& !hasOpenJob(*xInboxNode))
				lcl_insertChildJob(*pJob, *xInboxNode,
								   SfxVoidItem(WID_UPDATE));
			break;

		case WID_UPDATE:
		case WID_SYNCHRONIZE:
		{
			const SfxPoolItem * pRequest = pJob->GetRequest();
			if (xInboxNode.Is())
				lcl_insertChildJob(*pJob, *xInboxNode, *pRequest);
			if (xBBoardBoxNode.Is())
				lcl_insertChildJob(*pJob, *xBBoardBoxNode, *pRequest);
			break;
		}

		case WID_SEARCH:
			if (xInboxNode.Is())
				lcl_insertChildJob
				 (*pJob, *xInboxNode,
				  CntSearchDataItem(WID_SEARCH,
									CntSearchData(*pSearchData, TRUE)));
			if (xBBoardBoxNode.Is())
				lcl_insertChildJob
				 (*pJob, *xBBoardBoxNode,
				  CntSearchDataItem(WID_SEARCH,
									CntSearchData(*pSearchData, TRUE)));
			break;
	}

	pJob->Done();
}

//============================================================================
// static
void CntVIMNodeImp::createNewMessage(CntNodeItem * pMsgNodeItem,
									 CntNodeJob * pJob, BOOL bNews,
									 const String & rNewsGroups)
{
	if (!pMsgNodeItem)
	{
		DBG_ERROR("CntVIMNodeImp::createNewMessage(): No message node item");
		return;
	}
	CntNode * pMsgNode = pMsgNodeItem->GetValue();
	if (!pMsgNode)
	{
		DBG_ERROR("CntVIMNodeImp::createNewMessage(): No message node");
		return;
	}
	CntAnchor * pJobAnchor = PTR_CAST(CntAnchor, pJob->GetClient());
	if (!pJobAnchor)
	{
		DBG_ERROR("CntVIMNodeImp::createNewMessage(): No anchor");
		return;
	}

	CntAnchorRef xRootAnchor(new CntAnchor(0, pJobAnchor->GetRootViewURL()));

	// If private resp. public (in the case of news) messages use the settings
	// from the IMAP account (instead of the settings from the out box),
	// preset the 'from' and 'reply-to' fields with the settings for the
	// selected protocol:
	if (!ITEMSET_VALUE(xRootAnchor, CntBoolItem,
					   bNews ?
					    WID_SEND_PUBLIC_OUTBOXPROPS :
					    WID_SEND_PRIVATE_OUTBOXPROPS))
	{
		CntOutMsgProtocolType nProtocol
		 = CntOutMsgProtocolType(ITEMSET_VALUE(xRootAnchor, CntUInt16Item,
											   bNews ?
											    WID_SEND_PUBLIC_OUTBOXPROPS :
											    WID_SEND_PRIVATE_PROT_ID));
		const String * pInfo
		 = INSECURE_DYNAMIC_CAST(const CntSendInfoListItem *,
								 &xRootAnchor->Get(WID_SEND_FROM_DEFAULT))->
		    findEntry(nProtocol);
		if (pInfo)
			pMsgNode->Put(CntNameItem(WID_FROM, *pInfo));
		pInfo
		 = INSECURE_DYNAMIC_CAST(const CntSendInfoListItem *,
								 &xRootAnchor->
								   Get(WID_SEND_REPLY_TO_DEFAULT))->
		    findEntry(nProtocol);
		if (pInfo)
			pMsgNode->Put(CntNameItem(WID_REPLY_TO, *pInfo));
	}

	pMsgNode->Put(xRootAnchor->Get(WID_SEND_PUBLIC_PROT_ID));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_PRIVATE_PROT_ID));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_PUBLIC_OUTBOXPROPS));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_PRIVATE_OUTBOXPROPS));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_SERVERNAME));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_USERNAME));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_PASSWORD));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_REPLY_TO_DEFAULT));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_FROM_DEFAULT));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_VIM_POPATH));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_FORMATS));
	pMsgNode->Put(xRootAnchor->Get(WID_SEND_COPY_TARGET));

	if (bNews && rNewsGroups.Len())
		pMsgNode->Put(CntStringItem(WID_NEWSGROUPS, rNewsGroups));
}

//============================================================================
BOOL CntVIMNodeImp::getUpdateOnOpenMode(const CntNodeJob & rJob) const
{
	const CntAnchor * pAnchor = PTR_CAST(CntAnchor, rJob.GetClient());
	if (pAnchor)
	{
		CntAnchorRef
		 xRootViewAnchor(new CntAnchor(0, pAnchor->GetRootViewURL()));
		return
		 ITEMSET_VALUE(xRootViewAnchor, CntBoolItem, WID_FLAG_UPDATE_ON_OPEN);
	}
	else
		return ITEMSET_VALUE(pParent, CntBoolItem, WID_FLAG_UPDATE_ON_OPEN);
}

//============================================================================
//
//  class CntVIMContainerNodeImp
//
//============================================================================

// static
String CntVIMContainerNodeImp::DateString(const DateTime & rDate)
{
	String aStr;
	if (rDate.GetDay() < 10) aStr += '0';
	aStr += rDate.GetDay();
	aStr += ' ';
	const char pMonths[12][4] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
								  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
	aStr.AppendAscii(pMonths[rDate.GetMonth() - 1], 3);
	aStr += ' ';
	aStr += rDate.GetYear();
	aStr += ' ';
	if (rDate.GetHour() < 10) aStr += '0';
	aStr += rDate.GetHour();
	aStr += ':';
	if (rDate.GetMin() < 10) aStr += '0';
	aStr += rDate.GetMin();
	aStr += ':';
	if (rDate.GetSec() < 10) aStr += '0';
	aStr += rDate.GetSec();
	return aStr;
}

//============================================================================
inet::INetCoreMailer * CntVIMContainerNodeImp::GetMailer()
{
	if (!pSavedMailer)
	{
		NAMESPACE_INET(INetWrapper) *pWrapper;
		if (CNT_RNM()->getINetWrapper (pWrapper))
			pWrapper->newINetCoreMailer (pSavedMailer);
	}
	return pSavedMailer;
}

//============================================================================
CntVIMContainerNodeImp::FindResult CntVIMContainerNodeImp::GetMsgRefID
                                    (SfxItemSet * pItems, BOOL bPutIntoItems,
									 const String & rMsgID,
									 UINT32 & rMsgRefIDPart1,
									 UINT32 & rMsgRefIDPart2,
									 CntNodeJob * pJob, BOOL bMustFind)
{
	DBG_ASSERT(pItems || rMsgID.Len(),
			   "CntVIMContainerNodeImp::GetMsgRefID(): Bad args");

	if (pItems)
	{
		const SfxPoolItem * pItem;
		if (pItems->GetItemState(WID_VIM_MSGREFIDPART1, FALSE, &pItem)
			 == SFX_ITEM_SET)
		{
			const CntStringItem * pMsgRefIDPart1Item = PTR_CAST(CntStringItem,
																pItem);
			if (pMsgRefIDPart1Item)
			{
				rMsgRefIDPart1
					= UINT32(pMsgRefIDPart1Item->GetValue().ToInt64());
				rMsgRefIDPart2 = UINT32(ITEMSET_VALUE(pItems, CntStringItem,
													  WID_VIM_MSGREFIDPART2).
										    ToInt64());
				return FOUND;
			}
		}
	}

	if (!OpenContainer(pJob))
		return ERROR;
	if (!pContainer->findMessage(rMsgID, rMsgRefIDPart1, rMsgRefIDPart2,
								 pJob, !bMustFind))
		return pContainer->getStatus().isOK() ? NOT_FOUND : ERROR;

	if (pItems && bPutIntoItems)
	{
		// Store the values for faster retrival next time:
		CntStringItem aMsgRefIDPart1Item(WID_VIM_MSGREFIDPART1,
										 rMsgRefIDPart1);
		CntStringItem aMsgRefIDPart2Item(WID_VIM_MSGREFIDPART2,
										 rMsgRefIDPart2);
		pItems->Put(aMsgRefIDPart1Item);
		pItems->Put(aMsgRefIDPart2Item);
	}

	return FOUND;
}

//============================================================================
// virtual
CntVIMContainerNodeImp::~CntVIMContainerNodeImp()
{
	if (pSavedMailer)
	{
		pSavedMailer->RecvCloseConnection(0, 0);
		delete pSavedMailer;
	}
	delete pContainer;
}

//============================================================================
void CntVIMContainerNodeImp::DeleteMessageFromStorage(BOOL bDeletePhysical,
													  BOOL bKeepFlag,
													  CntStorageNode * pCache,
													  CntStorageNode *
													   pDirectory,
													  CntStorageNode *
													   pUserData,
													  const String & rMsgID,
													  const String & rMsgURL)
{
	// Create message body URL:
	String aBodyURL(rMsgURL);
	aBodyURL.
		AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_MESG_BODY_ID_SUFFIX));

	if (bDeletePhysical)
	{
		// Delete message body data from cache:
		pCache->remove(aBodyURL);

		// Delete message data from directory and user data:
		pDirectory->remove(rMsgID);
		pUserData->remove(rMsgURL);

		// But if not deleted from the VIM message container, keep a flag in
		// the directory (otherwise, the message might reappear at
		// WID_UPDATE):
		if (bKeepFlag)
			pDirectory->attrib(rMsgID, 0,
							   CNTDIRENTRY_ATTRIB_CREATE
							    | CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY);
	}
	else
	{
		// Mark message (body) data for deletion:
		pCache->attrib(aBodyURL, 0, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
		pDirectory->attrib(rMsgID, 0, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
		pUserData->attrib(rMsgURL, 0, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE);
	}
}

//============================================================================
// virtual
void CntVIMContainerNodeImp::Initialize(CntNodeJob & rJob,
										CntVIMNodeImp * pTheVIMBoxNodeImp)
{
	DBG_ASSERT(!bInitialized, "VIM container node initialized twice");
	DBG_ASSERT(aUserDataItemSetName.Len() > 0, "No user data item set name");

	CntStorageNode * pDirectory = rJob.GetDirectoryNode();
	if (pDirectory)
	{
		if (IsInbox())
			pParent->Put(pDirectory->Get(WID_DELETE_ON_SERVER));

		// Create a directory item set, if necessary, and put it into the
		// node:
		CntStoreItemSetRef
			xItemSet(pDirectory->openItemSet(String::CreateFromAscii(
				                                 RTL_CONSTASCII_STRINGPARAM(
													 CNT_VIM_DATA_SET_ID)),
									 STREAM_STD_READ));
		if (!xItemSet.Is())
		{
			pDirectory->
				attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
					                               CNT_VIM_DATA_SET_ID)),
					   0,
					   CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN);
			xItemSet = pDirectory->
				           openItemSet(aCntVIMContainerDirectoryItemSetRanges,
									   String::CreateFromAscii(
										   RTL_CONSTASCII_STRINGPARAM(
											   CNT_VIM_DATA_SET_ID)));
			if (xItemSet.Is())
			{
				xItemSet->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT, 0));
				xItemSet->Put(CntUInt32Item
							   (WID_VIM_HIGHESTMSGREFIDPART1,
								CntVIMMessageContainer::SEEK_BEGIN));
				xItemSet->Put(CntUInt32Item
							   (WID_VIM_HIGHESTMSGREFIDPART2,
								CntVIMMessageContainer::SEEK_BEGIN));
			}
		}
		if (xItemSet.Is())
			pParent->Put(*xItemSet);
	}

	CntStorageNode * pUserData = rJob.GetUserDataNode();
	if (pUserData)
	{
		// Create a user data item set, if necessary, and put it into the
		// node:
		CntStoreItemSetRef
		 xItemSet(pUserData->openItemSet(aUserDataItemSetName,
										 STREAM_STD_READ));
		if (!xItemSet.Is())
		{
			pUserData->attrib(aUserDataItemSetName, 0,
							  CNTDIRENTRY_ATTRIB_CREATE
							   | CNTDIRENTRY_ATTRIB_HIDDEN);
			xItemSet
			 = pUserData->openItemSet(aCntVIMContainerUserDataItemSetRanges,
									  aUserDataItemSetName);
			if (xItemSet.Is())
			{
				xItemSet->Put(CntUInt32Item(WID_VIM_MARKEDCONTENTCOUNT, 0));
				xItemSet->Put(CntUInt32Item(WID_SEENCONTENTCOUNT, 0));
			}
		}
		if (xItemSet.Is())
			pParent->Put(*xItemSet);
	}

	// Restore node's read/marked flags:
	UINT32 nTotal
	 = ITEMSET_VALUE(pParent, CntUInt32Item, WID_TOTALCONTENTCOUNT);
	pParent->Put(CntBoolItem(WID_IS_READ,
							 ITEMSET_VALUE(pParent, CntUInt32Item,
										   WID_SEENCONTENTCOUNT)
							  == nTotal));
	pParent->Put(CntBoolItem(WID_IS_MARKED,
							 nTotal
							 && ITEMSET_VALUE(pParent, CntUInt32Item,
											  WID_VIM_MARKEDCONTENTCOUNT)
							     == nTotal));

	pVIMBoxNodeImp = pTheVIMBoxNodeImp;
}

//============================================================================
CntStoreItemSet *
 CntVIMContainerNodeImp::OpenDirectoryItemSet(CntStorageNode * pDirectory)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	if (!pDirectory)
		return 0;

	CntStoreItemSet * pItemSet
		= pDirectory->
		      openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
				                                      CNT_VIM_DATA_SET_ID)),
						  STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), recreate it
		// from the node's data:
		pDirectory->
			attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
				                               CNT_VIM_DATA_SET_ID)),
				   0, CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet
			= pDirectory->openItemSet(aCntVIMContainerDirectoryItemSetRanges,
									  String::CreateFromAscii(
										  RTL_CONSTASCII_STRINGPARAM(
											  CNT_VIM_DATA_SET_ID)));
		if (pItemSet)
		{
			pItemSet->Put(pParent->Get(WID_TOTALCONTENTCOUNT));
			pItemSet->Put(pParent->Get(WID_VIM_HIGHESTMSGREFIDPART1));
			pItemSet->Put(pParent->Get(WID_VIM_HIGHESTMSGREFIDPART2));
		}
	}
	else
	{
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_TOTALCONTENTCOUNT)
				    == pParent->Get(WID_TOTALCONTENTCOUNT),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_VIM_HIGHESTMSGREFIDPART1)
				    == pParent->Get(WID_VIM_HIGHESTMSGREFIDPART1),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_VIM_HIGHESTMSGREFIDPART2)
				    == pParent->Get(WID_VIM_HIGHESTMSGREFIDPART2),
				   "Storage corrupted");
	}
	return pItemSet;
}

//============================================================================
CntStoreItemSet * CntVIMContainerNodeImp::OpenUserDataItemSet(CntStorageNode *
															   pUserData)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	if (!pUserData)
		return 0;

	CntStoreItemSet * pItemSet = pUserData->openItemSet(aUserDataItemSetName,
														STREAM_STD_READWRITE
														 | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), recreate it
		// from the node's data:
		pUserData->attrib(aUserDataItemSetName, 0,
						  CNTDIRENTRY_ATTRIB_CREATE
						   | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet
		 = pUserData->openItemSet(aCntVIMContainerUserDataItemSetRanges,
								  aUserDataItemSetName);
		if (pItemSet)
		{
			pItemSet->Put(pParent->Get(WID_VIM_MARKEDCONTENTCOUNT));
			pItemSet->Put(pParent->Get(WID_SEENCONTENTCOUNT));
		}
	}
	else
	{
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_VIM_MARKEDCONTENTCOUNT)
				    == pParent->Get(WID_VIM_MARKEDCONTENTCOUNT),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_SEENCONTENTCOUNT)
				    == pParent->Get(WID_SEENCONTENTCOUNT),
				   "Storage corrupted");
	}
	return pItemSet;
}

//============================================================================
// static
CntStoreItemSet *
 CntVIMContainerNodeImp::OpenMessageDirectoryItemSet(CntStorageNode *
													  pDirectory,
													 const String & rMsgID,
													 CntNode * pMsgNode)
{
	if (!pDirectory)
		return 0;

	CntStoreItemSet * pItemSet
	 = pDirectory->openItemSet(rMsgID,
							   STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
		if (pMsgNode)
		{
			// If no item set available (i.e., storage corrupted), recreate it
			// from the node's data if available:
			pDirectory->attrib(rMsgID, 0,
							   CNTDIRENTRY_ATTRIB_CREATE
							    | CNTDIRENTRY_ATTRIB_HIDDEN);
			pItemSet
			 = pDirectory->openItemSet(aCntVIMMessageDirectoryItemSetRanges,
									   rMsgID);
			if (pItemSet)
				pItemSet->Put(*pMsgNode);
		}
		else
		{
			DBG_ERROR("Message's directory storage not available");
		}
	else if (pMsgNode)
	{
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_PRIORITY) == pMsgNode->Get(WID_PRIORITY),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_MESSAGE_ID)
				    == pMsgNode->Get(WID_MESSAGE_ID),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_BCC) == pMsgNode->Get(WID_BCC),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_CC) == pMsgNode->Get(WID_CC),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_TO) == pMsgNode->Get(WID_TO),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_FROM) == pMsgNode->Get(WID_FROM),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_TITLE) == pMsgNode->Get(WID_TITLE),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_NEWSGROUPS)
				    == pMsgNode->Get(WID_NEWSGROUPS),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_DATE_CREATED)
				    == pMsgNode->Get(WID_DATE_CREATED),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_ACTION_LIST)
				    == pMsgNode->Get(WID_ACTION_LIST),
				   "Storage corrupted");
	}
	return pItemSet;
}

//============================================================================
// static
String CntVIMContainerNodeImp::GetMsgIDFromURL(const String & rMsgURL)
{
	xub_StrLen i;
	for (i = rMsgURL.Len(); i > 0 && rMsgURL.GetChar(i - 1) != '/'; --i);
	return String(rMsgURL, i, rMsgURL.Len() - i);
}

//============================================================================
void CntVIMContainerNodeImp::UpdateMessageCounts(CntNodeJob * pJob,
												 const Change & rTotalChange,
												 const Change & rSeenChange,
												 const Change & rMarkedChange)
{
	// Update WID_TOTALCONTENTCOUNT:
	UINT32 nTotalCount
	 = ITEMSET_VALUE(pParent, CntUInt32Item, WID_TOTALCONTENTCOUNT);
	BOOL bTotalHasChanged = rTotalChange.HasChanged();
	if (bTotalHasChanged)
	{
		UINT32 nNewTotalCount = rTotalChange.IsAbsolute() ?
			                     rTotalChange.GetValue() :
			                     nTotalCount + rTotalChange.GetValue();
		if (INT32(nNewTotalCount) < 0)
			nNewTotalCount = 0;
		if (nNewTotalCount == nTotalCount)
			bTotalHasChanged = FALSE;
		else
		{
			nTotalCount = nNewTotalCount;
			CntUInt32Item aTotalItem(WID_TOTALCONTENTCOUNT, nNewTotalCount);
			CntStoreItemSetRef
			 xDirectorySet(OpenDirectoryItemSet(pJob->GetDirectoryNode()));
			if (xDirectorySet.Is())
			{
				xDirectorySet->Put(aTotalItem);
				xDirectorySet = 0;
			}
			pParent->Put(aTotalItem);
		}
	}

	if (bTotalHasChanged || rSeenChange.HasChanged())
	{
		// Update WID_SEENCONTENTCOUNT:
		UINT32 nSeenCount
		 = ITEMSET_VALUE(pParent, CntUInt32Item, WID_SEENCONTENTCOUNT);
		if (rSeenChange.HasChanged())
		{
			UINT32 nNewSeenCount = rSeenChange.IsAbsolute() ?
				                    rSeenChange.GetValue() :
				                    nSeenCount + rSeenChange.GetValue();
			if (INT32(nNewSeenCount) < 0)
				nNewSeenCount = 0;
			else if (nNewSeenCount > nTotalCount)
				nNewSeenCount = nTotalCount;
			if (nNewSeenCount != nSeenCount)
			{
				nSeenCount = nNewSeenCount;
				CntUInt32Item aSeenItem(WID_SEENCONTENTCOUNT, nSeenCount);
				CntStoreItemSetRef
				 xUserDataSet(OpenUserDataItemSet(pJob->GetUserDataNode()));
				if (xUserDataSet.Is())
				{
					xUserDataSet->Put(aSeenItem);
					xUserDataSet = 0;
				}
				pParent->Put(aSeenItem);
			}
		}

		// Update WID_IS_READ:
		BOOL bIsSeen = nSeenCount == nTotalCount;
		if (bIsSeen != ITEMSET_VALUE(pParent, CntBoolItem, WID_IS_READ))
		{
			pParent->Put(CntBoolItem(WID_IS_READ, bIsSeen));
			SeenStatusChanged(pJob, bIsSeen);
		}
	}

	if (bTotalHasChanged || rMarkedChange.HasChanged())
	{
		// Update WID_VIM_MARKEDCONTENTCOUNT:
		UINT32 nMarkedCount
		 = ITEMSET_VALUE(pParent, CntUInt32Item, WID_VIM_MARKEDCONTENTCOUNT);
		if (rMarkedChange.HasChanged())
		{
			UINT32 nNewMarkedCount = rMarkedChange.IsAbsolute() ?
				                      rMarkedChange.GetValue() :
				                      nMarkedCount + rMarkedChange.GetValue();
			if (INT32(nNewMarkedCount) < 0)
				nNewMarkedCount = 0;
			else if (nNewMarkedCount > nTotalCount)
				nNewMarkedCount = nTotalCount;
			if (nNewMarkedCount != nMarkedCount)
			{
				nMarkedCount = nNewMarkedCount;
				CntUInt32Item aMarkedItem(WID_VIM_MARKEDCONTENTCOUNT,
										  nMarkedCount);
				CntStoreItemSetRef
				 xUserDataSet(OpenUserDataItemSet(pJob->GetUserDataNode()));
				if (xUserDataSet.Is())
				{
					xUserDataSet->Put(aMarkedItem);
					xUserDataSet = 0;
				}
				pParent->Put(aMarkedItem);
			}
		}

		// Update WID_IS_MARKED:
		BOOL bIsMarked = nTotalCount && nMarkedCount == nTotalCount;
		if (bIsMarked != ITEMSET_VALUE(pParent, CntBoolItem, WID_IS_MARKED))
			pParent->Put(CntBoolItem(WID_IS_MARKED, bIsMarked));
	}
}

//============================================================================
void CntVIMContainerNodeImp::SetMessageFlag(USHORT nWhich, BOOL bFlag,
											CntStorageNode * pUserData,
											const String & rMsgURL)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	UINT32 nSetMask = 0;
	UINT32 nUnsetMask = 0;
	if (nWhich == WID_IS_READ)
		if (bFlag)
			nUnsetMask = CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
		else
			nSetMask = CNTDIRENTRY_ATTRIB_CREATE
				        | CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
	else // WID_IS_MARKED
		if (bFlag)
			nSetMask = CNTDIRENTRY_ATTRIB_CREATE | CNTDIRENTRY_ATTRIB_MARKED;
		else
			nUnsetMask = CNTDIRENTRY_ATTRIB_MARKED;

	// Update attributes (but release the user data if no longer needed):
	UINT32 nAttrib;
	if (pUserData->attrib(rMsgURL, 0, 0, nAttrib) == ERRCODE_NONE
		&& !(((nAttrib & ~nUnsetMask) | nSetMask)
			  & ~CNTDIRENTRY_ATTRIB_CREATE))
		pUserData->remove(rMsgURL);
	else
		pUserData->attrib(rMsgURL, nUnsetMask, nSetMask);
}

//============================================================================
BOOL CntVIMContainerNodeImp::NotifyMessageRead(CntNodeJob * pJob,
											   const String & rMsgID,
											   CntNode * pMsgNode)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	// Check if message is indeed read for the first time:
	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	if (pDirectory
		&& pDirectory->attrib(rMsgID, 0, 0)
		    & CNTDIRENTRY_ATTRIB_VIM_INTERNALLYUNREAD)
	{
		BOOL bOnline = pVIMBoxNodeImp->CheckOnline(FALSE, pJob)
			            == CntVIMNodeImp::ONLINE_YES;
		if (pJob->IsCancelled())
			return FALSE;

		if (bOnline)
		{
			UINT32 nMsgRefIDPart1, nMsgRefIDPart2;
			switch (GetMsgRefID(pMsgNode, TRUE, rMsgID, nMsgRefIDPart1,
								nMsgRefIDPart2, pJob, FALSE))
			{
				case NOT_FOUND:
					// Message no longer available in VIM container:
					return TRUE;

				case ERROR:
					pJob->Cancel();
					return FALSE;
			}
			if (!OpenContainer(pJob))
			{
				pJob->Cancel();
				return FALSE;
			}
			if (!pContainer->notifyMessageRead(nMsgRefIDPart1, nMsgRefIDPart2,
											   pJob))
			{
				pJob->Cancel();
				return FALSE;
			}
			pDirectory->attrib(rMsgID,
							   CNTDIRENTRY_ATTRIB_VIM_INTERNALLYUNREAD, 0);
		}
		else
		{
			// Once transactions are available, it would be a good idea to use
			// one here...
		}
	}

	return TRUE;
}

//============================================================================
void CntVIMContainerNodeImp::Open(CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	ThreadTask * pTask = static_cast< ThreadTask * >(pJob->GetRequestData());
	if (!pTask)
		pTask = new CntVIMCntrOpenTask_Impl(*pJob, *pParent, *this,
											*pVIMBoxNodeImp);
	pTask->run();
}

//============================================================================
void CntVIMContainerNodeImp::Flag(CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	ThreadTask * pTask = static_cast< ThreadTask * >(pJob->GetRequestData());
	if (!pTask)
		pTask = new CntVIMCntrFlagTask_Impl(*pJob, *pParent, *this);
	pTask->run();
}

//============================================================================
void CntVIMContainerNodeImp::InitMessage(CntNodeJob * pJob,
										 CntNode * pMsgNode)
{
	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	if (pDirectory)
	{
		String
		 aID(CntVIMContainerNodeImp::GetMsgIDFromURL(OWN_URL(pMsgNode)));
		CntStoreItemSetRef
		 xItemSet(CntVIMContainerNodeImp::OpenMessageDirectoryItemSet
				   (pDirectory, aID));
		if (xItemSet.Is())
			pMsgNode->Put(*xItemSet);
	}

	CntStorageNode * pUserData = pJob->GetUserDataNode();
	if (pUserData)
	{
		String aID(OWN_URL(pMsgNode));
		UINT32 nAttrib = 0;
		pUserData->attrib(aID, 0, 0, nAttrib);
		pMsgNode->Put(CntBoolItem(WID_IS_READ,
								  !(nAttrib
									 & CNTDIRENTRY_ATTRIB_VIM_UNSEEN)));
		pMsgNode->
		 Put(CntBoolItem(WID_IS_MARKED,
						 CAST_TO_BOOL(nAttrib & CNTDIRENTRY_ATTRIB_MARKED)));
	}

	setMsgBodyState(*pMsgNode, pJob->GetCacheNode());
}

//============================================================================
void CntVIMContainerNodeImp::setMsgBodyState(CntNode & rMsg,
											 CntStorageNode * pCache)
{
	if (rMsg.GetItemState(WID_MESSAGEBODY, FALSE) != SFX_ITEM_SET)
	{
		BOOL bAvail;
		if (DoCacheMessageBodies())
			if (pCache)
			{
				String aCacheBodyID(OWN_URL(&rMsg));
				aCacheBodyID.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
					                         CNT_VIM_MESG_BODY_ID_SUFFIX));
				bAvail
				 = pCache->attrib(aCacheBodyID, 0, 0) != ERRCODE_IO_NOTEXISTS;
			}
			else
				bAvail = FALSE;
		else
			bAvail = TRUE;

		if (bAvail)
			rMsg.ClearItem(WID_MESSAGEBODY);
		else
			rMsg.DisableItem(WID_MESSAGEBODY);
	}
}

//============================================================================
void CntVIMContainerNodeImp::OpenMsg(CntMessageNode * pMsgNode,
									 CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	ThreadTask * pTask = static_cast< ThreadTask * >(pJob->GetRequestData());
	if (!pTask)
		pTask = new CntVIMMesgOpenTask_Impl(*pJob, *pParent, *this, pMsgNode);
	pTask->run();
}

//============================================================================
BOOL CntVIMContainerNodeImp::createMessageBodyItem(CntNodeJob & rJob,
												   CntStoreItemSet *
												    pMsgDirSet,
												   CntNode * pMsgNode,
												   BOOL bCacheBody,
												   BOOL bMustLoad)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	SfxItemSet * pSet;
	if (pMsgDirSet)
		pSet = pMsgDirSet;
	else
		pSet = pMsgNode;
	if (!pSet)
		return FALSE;

	// Look for a cached message body:
	String aMsgID(ITEMSET_VALUE(pSet, CntStringItem, WID_MESSAGE_ID));
	String aBodyName(OWN_URL(pParent));
	if (aBodyName.GetChar(aBodyName.Len() - 1) != '/')
		aBodyName += '/';
	aBodyName += aMsgID;
	aBodyName.
		AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_MESG_BODY_ID_SUFFIX));
	CntStorageNode * pCache = rJob.GetCacheNode();
	if (pCache)
	{
		SvStream * pStream = pCache->openStream(aBodyName, STREAM_STD_READ);
		if (pStream)
		{
			delete pStream;
			CntMessageBodyItem aBodyItem(WID_MESSAGEBODY, aBodyName);
			aBodyItem.Get(pCache, GetMailer());

			if (pMsgDirSet)
			{
				pMsgDirSet->Put(aBodyItem);
				if (pMsgNode
					&& pMsgNode->GetItemState(WID_MESSAGEBODY, FALSE)
					    == SFX_ITEM_DISABLED)
					pMsgNode->ClearItem(WID_MESSAGEBODY);
			}
			else
			{
				if (pMsgNode->GetItemState(WID_MESSAGEBODY, FALSE)
					 == SFX_ITEM_DISABLED)
					pMsgNode->ClearItem(WID_MESSAGEBODY);
				pMsgNode->Put(aBodyItem);
			}

			if (pContainer)
				pContainer->cancelExecution();
			return FALSE;
		}
	}

	// Check for online status:
	if (pVIMBoxNodeImp->CheckOnline(bMustLoad, &rJob)
		 == CntVIMNodeImp::ONLINE_NO)
	{
		if (pContainer)
			pContainer->cancelExecution();
		if (bMustLoad)
			rJob.Cancel();
		return FALSE;
	}
	if (rJob.IsCancelled())
	{
		if (pContainer)
			pContainer->cancelExecution();
		return FALSE;
	}

	// Open the VIM message:
	UINT32 nMsgRefIDPart1, nMsgRefIDPart2;
	if (GetMsgRefID(pSet, !pMsgDirSet, aMsgID, nMsgRefIDPart1,
					nMsgRefIDPart2, &rJob, bMustLoad)
		 != FOUND)
	{
		if (pContainer)
			pContainer->cancelExecution();
		if (bMustLoad)
			rJob.Cancel();
		return FALSE;
	}
	if (!OpenContainer(&rJob))
	{
		if (pContainer)
			pContainer->cancelExecution();
		rJob.Cancel();
		return FALSE;
	}
	CntVIMMessageBody * pVIMBody = 0;
	switch (pContainer->openMessage(nMsgRefIDPart1, nMsgRefIDPart2, &rJob,
									pVIMBody))
	{
		case CntVIMMessageContainer::EXECUTE_ERROR:
			delete pVIMBody;
			rJob.Cancel();
			return FALSE;

		case CntVIMMessageContainer::EXECUTE_WAITING:
			delete pVIMBody;
			return TRUE;

		case CntVIMMessageContainer::EXECUTE_DONE:
			if (!pVIMBody)
			{
				rJob.Cancel();
				return FALSE;
			}
			break;
	}

	// Create a MIME message and fill in its header fields:
	inet::INetCoreMailer * pMailer = GetMailer();
	INetCoreNewsMessage * pMIMEMsg = pMailer->CreateINetCoreNewsMessage();
	pMIMEMsg->SetBCC(ITEMSET_VALUE(pSet, CntStringItem, WID_BCC));
	pMIMEMsg->SetCC(ITEMSET_VALUE(pSet, CntStringItem, WID_CC));
	const SfxPoolItem * pItem;
	if (pSet->GetItemState(WID_DATE_CREATED, FALSE, &pItem) == SFX_ITEM_SET)
	{
		const SfxDateTimeItem * pDateItem = PTR_CAST(SfxDateTimeItem, pItem);
		if (pDateItem)
			pMIMEMsg->SetDate(DateString(pDateItem->GetDateTime()));
	}
	pMIMEMsg->SetFrom(ITEMSET_VALUE(pSet, CntNameItem, WID_FROM));
	pMIMEMsg->SetMessageID(aMsgID);
	pMIMEMsg->SetSubject(ITEMSET_VALUE(pSet, CntStringItem, WID_TITLE));
	if (pSet->GetItemState(WID_TO, FALSE, &pItem) == SFX_ITEM_SET)
		pMIMEMsg->SetTo(ITEM_VALUE(CntStringItem, *pItem));
	else
		pMIMEMsg->SetNewsgroups(ITEMSET_VALUE(pSet, CntStringItem,
											  WID_NEWSGROUPS));
	pMIMEMsg->SetXPriority(INSECURE_DYNAMIC_CAST(const CntPriorityItem &,
												 pSet->Get(WID_PRIORITY)).
						    GetValueText());

	ULONG nItemCount;
	if (!pVIMBody->startItemIteration(nItemCount, &rJob))
	{
		delete pMIMEMsg;
		delete pVIMBody;
		rJob.Cancel();
		return FALSE;
	}
	switch (nItemCount)
	{
		case 0:
			// If the message has no items, create an empty body:
			pMIMEMsg->SetDocumentStream(new SvMemoryStream(0, 0,
														   STREAM_READ));
			break;

		case 1:
		{
			// If the message has exactly one item, make it the message body:
			CntVIMMessageItem * pVIMItem = pVIMBody->getNextItem(&rJob);
			if (pVIMItem)
			{
				pMIMEMsg->SetContentType(pVIMItem->getContentType());
				String aFileName = pVIMItem->getName();
				if (aFileName.Len())
				{
					String aDesc(RTL_CONSTASCII_USTRINGPARAM("filename=\""));
					aDesc += aFileName;
					aDesc += '"';
					pMIMEMsg->SetContentDescription(aDesc);
				}
				pMIMEMsg->SetDocumentStream(pVIMItem->takeDataStream());
				delete pVIMItem;
			}
			else
			{
				delete pMIMEMsg;
				delete pVIMBody;
				rJob.Cancel();
				return FALSE;
			}
			break;
		}

		default:
			// If the message has multiple items, make them into child MIME
			// messages:
			pMIMEMsg->EnableAttachChild();
			{for (ULONG i = 0; i < nItemCount; ++i)
			{
				CntVIMMessageItem * pVIMItem = pVIMBody->getNextItem(&rJob);
				if (pVIMItem)
				{
					INetCoreNewsMessage * pMIMEChild
						= pMailer->CreateINetCoreNewsMessage();
					pMIMEChild->SetContentType(pVIMItem->getContentType());
					String aFileName = pVIMItem->getName();
					if (aFileName.Len())
					{
						String
							aDesc(RTL_CONSTASCII_USTRINGPARAM("filename=\""));
						aDesc += aFileName;
						aDesc += '"';
						pMIMEChild->SetContentDescription(aDesc);
					}
					pMIMEChild->SetDocumentStream(pVIMItem->takeDataStream());
					pMIMEMsg->AttachChild(*pMIMEChild);
					delete pVIMItem;
				}
				else
				{
					delete pMIMEMsg;
					delete pVIMBody;
					rJob.Cancel();
					return FALSE;
				}
			}}
			break;
	}

	delete pVIMBody;

	CntMessageBodyItem aBodyItem(WID_MESSAGEBODY, aBodyName);
	aBodyItem.Set(pMIMEMsg, bCacheBody ? pCache : 0);

	if (pMsgDirSet)
	{
		pMsgDirSet->Put(aBodyItem);
		if (pMsgNode
			&& pMsgNode->GetItemState(WID_MESSAGEBODY, FALSE)
			    == SFX_ITEM_DISABLED)
			pMsgNode->ClearItem(WID_MESSAGEBODY);
	}
	else
	{
		if (pMsgNode->GetItemState(WID_MESSAGEBODY, FALSE)
			 == SFX_ITEM_DISABLED)
			pMsgNode->ClearItem(WID_MESSAGEBODY);
		pMsgNode->Put(aBodyItem);
	}

	// If messages are kept locally and shall be removed from the server, do
	// that now:
	if (bCacheBody && DoDeleteMessagesFromServer())
		pContainer->deleteMessage(nMsgRefIDPart1, nMsgRefIDPart2, &rJob);

	return FALSE;
}

//============================================================================
void CntVIMContainerNodeImp::MarkMsg(CntMessageNode * pMsg,
									 const CntBoolItem & rFlagItem,
									 CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	USHORT nWhich = rFlagItem.Which();
	if (rFlagItem != pMsg->Get(nWhich))
	{
		// Update message's storage and message node:
		BOOL bFlag = rFlagItem.GetValue();
		SetMessageFlag(nWhich, bFlag, pJob->GetUserDataNode(), OWN_URL(pMsg));
		pMsg->Put(rFlagItem);

		// Update container's counts and flags:
		UpdateMessageCounts(pJob, RelativeChange(0),
							RelativeChange(nWhich == WID_IS_READ ?
										    bFlag ? 1 : -1 : 0),
							RelativeChange(nWhich == WID_IS_MARKED ?
										    bFlag ? 1 : -1 : 0));

		// Tell VIM about messages that are read for the first time:
		if (nWhich == WID_IS_READ && bFlag
			&& !NotifyMessageRead(pJob,
								  ITEMSET_VALUE(pMsg, CntStringItem,
												WID_MESSAGE_ID),
								  pMsg))
			return;
	}

	pJob->Done();
}

//============================================================================
void CntVIMContainerNodeImp::SetMsgActionList(CntMessageNode & rMsg,
											  const CntActionListItem &
											   rActionList,
											  CntNodeJob & rJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	if (rActionList != rMsg.Get(WID_ACTION_LIST))
	{
		CntStoreItemSetRef
		 xMsgDirSet(OpenMessageDirectoryItemSet(rJob.GetDirectoryNode(),
												ITEMSET_VALUE(&rMsg,
															  CntStringItem,
															  WID_MESSAGE_ID),
												&rMsg));
		if (xMsgDirSet.Is())
			xMsgDirSet->Put(rActionList);
		rMsg.Put(rActionList);
	}

	rJob.Done();
}

//============================================================================
void CntVIMContainerNodeImp::DeleteMsg(CntMessageNode * pMsg,
									   CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	BOOL bDeletePhysical = ITEM_VALUE(CntBoolItem, *pJob->GetRequest());
	BOOL bDeleteOnServer
	 = ITEMSET_VALUE(pParent, CntBoolItem, WID_DELETE_ON_SERVER);

	// Delete message on server, if appropriate (and if the message is still
	// available in the VIM container):
	String aMsgID(ITEMSET_VALUE(pMsg, CntStringItem, WID_MESSAGE_ID));
	if (bDeleteOnServer)
	{
		BOOL bOnline = pVIMBoxNodeImp->CheckOnline(FALSE, pJob)
		                == CntVIMNodeImp::ONLINE_YES;
		if (pJob->IsCancelled())
			return;

		if (bOnline)
		{
			UINT32 nMsgRefIDPart1, nMsgRefIDPart2;
			switch (GetMsgRefID(pMsg, TRUE, aMsgID, nMsgRefIDPart1,
								nMsgRefIDPart2, pJob, FALSE))
			{
				case FOUND:
					if (!OpenContainer(pJob))
					{
						pJob->Cancel();
						return;
					}
					pContainer->deleteMessage(nMsgRefIDPart1, nMsgRefIDPart2,
											  pJob);
					break;

				case ERROR:
					pJob->Cancel();
					return;
			}
		}
		else
		{
			// Once transcactions are available it would be a good idea to use
			// one here...
		}
	}

	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	CntStorageNode * pUserData = pJob->GetUserDataNode();
	String aMsgURL(OWN_URL(pMsg));

	// If the message was not already marked as deleted (which would be the
	// case if it was first moved to the trash and now deleted from the
	// trash), update container's counts and flags:
	UINT32 nAttrib;
	if (pDirectory->attrib(aMsgID, 0, 0, nAttrib) == ERRCODE_NONE
		&& !(nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE))
		UpdateMessageCounts(pJob, RelativeChange(-1),
							RelativeChange
							 (pUserData->attrib(aMsgURL, 0, 0, nAttrib)
							   == ERRCODE_NONE
							  && nAttrib & CNTDIRENTRY_ATTRIB_VIM_UNSEEN ?
							   0 : -1),
							RelativeChange(0));

	DeleteMessageFromStorage(bDeletePhysical, !bDeleteOnServer,
							 pJob->GetCacheNode(), pDirectory, pUserData,
							 aMsgID, aMsgURL);
	pJob->Result(pMsg, CNT_ACTION_DELETED);
	pJob->Done();
}

//============================================================================
void CntVIMContainerNodeImp::UndeleteMessage(CntMessageNode * pMsgNode,
											 CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM container node not initialized");

	// Restore cache components:
	String aMsgURL(OWN_URL(pMsgNode));
	String aBodyURL(aMsgURL);
	aBodyURL.
		AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_MESG_BODY_ID_SUFFIX));
	pJob->GetCacheNode()->attrib(aBodyURL, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE,
								 0);

	// Restore directory components:
	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	String aMsgID(GetMsgIDFromURL(aMsgURL));
	pDirectory->attrib(aMsgID, CNTDIRENTRY_ATTRIB_MARKEDFORDELETE, 0);
	CntStoreItemSetRef
	 xItemSet(OpenMessageDirectoryItemSet(pDirectory, aMsgID));
	if (xItemSet.Is())
	{
		pMsgNode->Put(*xItemSet);
		xItemSet = 0;
	}
	// An 'else' branch would be useful: cancel the undelete because the
	// storage is corrupted, use 'dummy' data (that might be overwritten with
	// data from the VIM server later on), or connect to the VIM server
	// immediately to get the correct data.

	// Restore user data components:
	UINT32 nAttrib = 0;
	pJob->GetUserDataNode()->attrib(aMsgURL,
									CNTDIRENTRY_ATTRIB_MARKEDFORDELETE, 0,
									nAttrib);
	BOOL bSeen = !(nAttrib & CNTDIRENTRY_ATTRIB_VIM_UNSEEN);
	BOOL bMarked = CAST_TO_BOOL(nAttrib & CNTDIRENTRY_ATTRIB_MARKED);
	pMsgNode->Put(CntBoolItem(WID_IS_READ, bSeen));
	pMsgNode->Put(CntBoolItem(WID_IS_MARKED, bMarked));

	// Update container's counts and flags:
	UpdateMessageCounts(pJob, RelativeChange(1),
						RelativeChange(bSeen ? 1 : 0),
						RelativeChange(bMarked ? 1 : 0));

	pJob->Result(pMsgNode);
}

//============================================================================
void CntVIMContainerNodeImp::changeMsgStoreMode(CntNodeJob & rJob)
{
	DBG_ASSERT(bInitialized,
			   "CntVIMContainerNodeImp::changeMsgStoreMode(): Not init");

	BOOL bStoreLocal = ITEM_VALUE(CntMsgStoreModeItem, *rJob.GetRequest())
	                    == CNT_MESSAGE_STOREMODE_LOCAL;
	for (ULONG i = 0; i < pParent->SubNodeCount(); ++i)
	{
		CntNode & rMesgNode
		 = *INSECURE_DYNAMIC_CAST(CntMessageNode *, pParent->GetSubNode(i));
		if (bStoreLocal)
		{
			const SfxPoolItem * pMesgBody;
			if (rMesgNode.GetItemState(WID_MESSAGEBODY, FALSE, &pMesgBody)
				 == SFX_ITEM_SET)
			{
				INetCoreNewsMessage * pMessage
				 = INSECURE_DYNAMIC_CAST(const CntMessageBodyItem *,
										 pMesgBody)->
				    Get();
				if (pMessage)
				{
					CntStorageNode * pCacheNode = rJob.GetCacheNode();
					if (pCacheNode)
					{
						String aBodyStreamID(OWN_URL(&rMesgNode));
						aBodyStreamID.
							AppendAscii(RTL_CONSTASCII_STRINGPARAM(
								            CNT_VIM_MESG_BODY_ID_SUFFIX));
						if (pCacheNode->attrib(aBodyStreamID, 0, 0)
							 == ERRCODE_IO_NOTEXISTS)
						{
							SvStream * pMesgBodyCacheStream
							 = pCacheNode->openStream(aBodyStreamID,
													  STREAM_STD_WRITE);
							if (pMesgBodyCacheStream)
							{
								*pMesgBodyCacheStream << CNT_MESSAGEBODY_NEWS;
								CntMessageBodyItem::StoreMessage
								                     (*pMesgBodyCacheStream,
													  *pMessage);
								delete pMesgBodyCacheStream;

								pCacheNode->attrib(aBodyStreamID, 0,
												   CNTDIRENTRY_ATTRIB_HIDDEN);
							}
						}
					}
				}
			}
			else
			{
				CntStorageNode * pCacheNode = rJob.GetCacheNode();
				if (pCacheNode)
				{
					String aBodyStreamID(OWN_URL(&rMesgNode));
					aBodyStreamID.
						AppendAscii(RTL_CONSTASCII_STRINGPARAM(
							            CNT_VIM_MESG_BODY_ID_SUFFIX));
					if (pCacheNode->attrib(aBodyStreamID, 0, 0)
						 == ERRCODE_IO_NOTEXISTS)
					{
						// HACK: force a change notification from the
						// following DisableItem():
						rMesgNode.Put(CntMessageBodyItem(WID_MESSAGEBODY,
														 String()));

						rMesgNode.DisableItem(WID_MESSAGEBODY);
					}
				}
			}
		}
		else if (rMesgNode.GetItemState(WID_MESSAGEBODY, FALSE)
				  == SFX_ITEM_DISABLED)
			rMesgNode.ClearItem(WID_MESSAGEBODY);
	}
}

//============================================================================
//
//  class CntVIMCntrOpenTask_Impl
//
//============================================================================

// static
void CntVIMCntrOpenTask_Impl::translate(const DateTime & rDate,
										CntVIMDate & rVIMDate)
{
	const DateTime * pTheDate = rDate < aMinVIMDate ?
	                             &aMinVIMDate :
	                            rDate > aMaxVIMDate ?
	                             &aMaxVIMDate : &rDate;
	rVIMDate.Zone = VIMSEL_LOCAL;
	rVIMDate.Date = pTheDate->GetDay() | pTheDate->GetMonth() << 8
	                 | UINT32(pTheDate->GetYear()) << 16;
	rVIMDate.Time = pTheDate->Get100Sec() | pTheDate->GetSec() << 8
		             | UINT32(pTheDate->GetMin()) << 16
		             | UINT32(pTheDate->GetHour()) << 24;
}

//============================================================================
void CntVIMCntrOpenTask_Impl::createMesgNode(const String & aMesgID,
											 const String & aMesgURL,
											 BOOL bValidMesgRefID,
											 CntStoreItemSet * pDirSet)
{
	CntNodeRef xMesgNode(m_rCntrNode.Query(aMesgURL));
	if (xMesgNode.Is())
	{
		xMesgNode->DisableItem(WID_EXPORT);
		if (!m_rCntr.IsInbox())
			xMesgNode->DisableItem(WID_DELETE);

		CntStoreItemSetRef xDirectorySet(pDirSet);
		if (!xDirectorySet.Is())
			xDirectorySet
			 = CntVIMContainerNodeImp::OpenMessageDirectoryItemSet
			                            (m_pDirectory, aMesgID);
		if (xDirectorySet.Is())
		{
			if (!bValidMesgRefID)
			{
				xDirectorySet->ClearItem(WID_VIM_MSGREFIDPART1);
				xDirectorySet->ClearItem(WID_VIM_MSGREFIDPART2);
			}
			xMesgNode->Put(*xDirectorySet);
			xDirectorySet = 0;
		}

		UINT32 nAttrib = 0;
		m_pUserData->attrib(aMesgURL, 0, 0, nAttrib);
		xMesgNode->Put(CntBoolItem(WID_IS_READ,
								   !(nAttrib
									  & CNTDIRENTRY_ATTRIB_VIM_UNSEEN)));
		xMesgNode->
		 Put(CntBoolItem(WID_IS_MARKED,
						 CAST_TO_BOOL(nAttrib & CNTDIRENTRY_ATTRIB_MARKED)));

		m_rCntr.setMsgBodyState(*xMesgNode, m_pCache);

		getJob().Result(xMesgNode, CNT_ACTION_INSERTED);
		if (m_nWhich == WID_SEARCH)
		{
			const CntSearchData & rData = ITEM_VALUE(CntSearchDataItem,
													 *getJob().GetRequest());
			if (rData.Matches(*xMesgNode,
							  CntRootNodeMgr::GetIniManager()->
							   getInternational()))
				getJob().ResultSearchMatch(xMesgNode, CNT_SEARCH_MATCH_YES,
										 TRUE);
		}
	}
}

//============================================================================
void CntVIMCntrOpenTask_Impl::clearProgress()
{
	switch (m_eProgress)
	{
		case PROGRESS_TEXT:
			getJob().Broadcast(CntStatusBarHint(String()));
			break;

		case PROGRESS_VALUE:
			getJob().Broadcast(CntStatusBarHint(m_nProgressID));
			break;
	}
	m_eProgress = PROGRESS_NONE;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMCntrOpenTask_Impl::execute()
{
	if (!m_bInitialized)
	{
		m_nWhich = getJob().GetRequest()->Which();

		const CntSearchData * pSearchData;
		if (m_nWhich == WID_UPDATE)
		{
			// If this is a WID_UPDATE job that is a child job of (a child job
			// of) a 'blinker driven' WID_UPDATE job, and if this node's
			// update parameters differ from it's parent's, ignore the job:
			if (getJob().GetParent() && getJob().GetRequest()->ISA(CntUpdateItem)
				&& (getJob().GetParent()->GetClient()->Get(WID_UPDATE_ENABLED)
					 != getJob().GetClient()->Get(WID_UPDATE_ENABLED)
					|| getJob().GetParent()->
					     GetClient()->Get(WID_AUTOUPDATE_INTERVAL)
					    != getJob().GetClient()->Get(WID_AUTOUPDATE_INTERVAL)))
			{
				done();
				return 0;
			}
		}
		else if (m_nWhich == WID_SEARCH)
		{
			const CntSearchDataItem * pSearchDataItem
			 = PTR_CAST(CntSearchDataItem, getJob().GetRequest());
			if (pSearchDataItem)
			{
				pSearchData = &pSearchDataItem->GetValue();
				if (pSearchData->DoSearchBase()
					&& pSearchData->Matches(m_rCntrNode,
											CntRootNodeMgr::GetIniManager()->
											 getInternational()))
					getJob().ResultSearchMatch(&m_rCntrNode,
											 CNT_SEARCH_MATCH_YES, TRUE);
				if (!pSearchData->DoSearchFirstLevel())
				{
					done();
					return 0;
				}
			}
		}

		m_bOnline
		 = (m_nWhich != WID_OPEN && m_nWhich != WID_SEARCH
			|| m_rAcnt.getUpdateOnOpenMode(getJob()))
		       && m_rAcnt.CheckOnline(m_nWhich == WID_UPDATE
									  || m_nWhich == WID_SYNCHRONIZE,
									  &getJob())
		           == CntVIMNodeImp::ONLINE_YES;
		if (getJob().IsCancelled())
			return 0;

		m_eCacheBodies
		 = (m_nWhich == WID_OPEN && m_rCntr.IsInbox()
			|| m_nWhich == WID_UPDATE || m_nWhich == WID_SYNCHRONIZE)
		   && m_rCntr.DoCacheMessageBodies() ?
		    CACHE_ALL : CACHE_NONE;
		UINT16 nLimit = m_rCntr.GetMessageExpirationLimit();
		if (nLimit)
		{
			if (m_eCacheBodies == CACHE_ALL)
				m_eCacheBodies = CACHE_SOME;
			m_bClearExpiredBodies = m_nWhich == WID_UPDATE
			                        || m_nWhich == WID_SYNCHRONIZE;
			m_aKeepSinceDate = Date() - nLimit;
		}
		else
			m_bClearExpiredBodies = FALSE;

		if (m_bOnline)
		{
			// Open VIM message container:
			m_pContainer = m_rCntr.OpenContainer(&getJob());
			if (!m_pContainer)
			{
				cancel();
				return 0;
			}

			// For WID_OPEN, WID_UPDATE, and WID_SEARCH, use (only) stored
			// messages if there are no new messages in the VIM message
			// container (but try hard to find out about new messages only for
			// WID_UPDATE):
			if (m_nWhich != WID_SYNCHRONIZE
				&& !m_pContainer->queryNewMessages(m_nWhich == WID_UPDATE,
												   &getJob()))
				if (m_nWhich == WID_UPDATE && !m_bClearExpiredBodies)
				{
					done();
					return 0;
				}
				else
					m_bOnline = FALSE;
		}

		m_nTotalMesgs = ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
									  WID_TOTALCONTENTCOUNT);

		if (m_nWhich == WID_SYNCHRONIZE)
		{
			m_bSeekPastKnown = m_pContainer->canSeekForMsgRefID();
			m_bIterateFromEnd = FALSE;
			switch (m_bSeekPastKnown ?
					 m_pContainer->
					  startHeaderIteration(CntVIMMessageContainer::SEEK_BEGIN,
										   CntVIMMessageContainer::SEEK_BEGIN,
										   &getJob()) :
					 m_pContainer->startHeaderIteration(FALSE))
			{
				case CntVIMMessageContainer::EXECUTE_ERROR:
					cancel();
					return 0;

				case CntVIMMessageContainer::EXECUTE_WAITING:
					m_bWaitingHeaders = TRUE;
					break;
			}
			m_pIterator = new CntStorageIterator(UINT32(-1));
			m_nTotalMesgs *= 2;
		}
		else if (m_bOnline)
		{
			m_bSeekPastKnown = m_pContainer->canSeekForMsgRefID();
			if (m_bSeekPastKnown)
			{
				switch (m_pContainer->
						 startHeaderIteration
						  (ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
										 WID_VIM_HIGHESTMSGREFIDPART1),
						   ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
										 WID_VIM_HIGHESTMSGREFIDPART2),
						   &getJob()))
				{
					case CntVIMMessageContainer::EXECUTE_ERROR:
						cancel();
						return 0;

					case CntVIMMessageContainer::EXECUTE_WAITING:
						m_bWaitingHeaders = TRUE;
						break;
				}
			}
			else
			{
				m_bIterateFromEnd = m_pContainer->canIterateFromEnd(&getJob());
				if (getJob().IsCancelled())
					return 0;
				switch (m_pContainer->startHeaderIteration(m_bIterateFromEnd))
				{
					case CntVIMMessageContainer::EXECUTE_ERROR:
						cancel();
						return 0;

					case CntVIMMessageContainer::EXECUTE_WAITING:
						m_bWaitingHeaders = TRUE;
						break;
				}
				m_bFirst = TRUE;
				if (!m_bIterateFromEnd
					&& (m_nWhich != WID_UPDATE || m_bClearExpiredBodies))
					m_nTotalMesgs *= 2;
			}
			if (m_nWhich != WID_UPDATE || m_bClearExpiredBodies)
				m_pIterator = new CntStorageIterator();
		}
		else
			m_pIterator = new CntStorageIterator();

		// Hardwire any seen/marked filters, and for WID_SEARCH, hardwire a
		// VIM message container filter:
		m_eViewFilter = FILTER_NONE;
		m_nSearchFilterType = VIMSEL_NO_FILTER;
		m_pSearchFilterData = 0;
		m_nSearchFilterDataLen = 0;
		if (m_nWhich != WID_SEARCH
			|| pSearchData->DoObeyDocViewRestrictions())
			switch (ITEMSET_VALUE(getJob().GetClient(), CntMsgViewModeItem,
								  WID_MESSAGEVIEW_MODE))
			{
				case CNT_VIEW_UNREAD_ARTICLES:
					m_eViewFilter = FILTER_SET;
					m_nViewFilterAttrib = CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
					break;

				case CNT_VIEW_READ_ARTICLES:
					m_eViewFilter = FILTER_CLEAR;
					m_nViewFilterAttrib = CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
					break;

				case CNT_VIEW_MARKED_ARTICLES:
					m_eViewFilter = FILTER_SET;
					m_nViewFilterAttrib = CNTDIRENTRY_ATTRIB_MARKED;
					break;

				case CNT_VIEW_MARKED_AND_UNREAD_ARTICLES:
					m_eViewFilter = FILTER_SET;
					m_nViewFilterAttrib = CNTDIRENTRY_ATTRIB_MARKED
					                       | CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
					break;

				default: // CNT_VIEW_ALL_ARTICLES
					m_eViewFilter = FILTER_NONE;
					break;
			}
		else if (m_bOnline && m_rCntr.IsInbox()
				 && m_rAcnt.GetMailbox()->isCCMail())
		{
			CntSearchData::StringRelType eStringRel;
			String aFilterString;
			bool bRegexp;
			if (pSearchData->HasSingleStringConstraint(WID_FROM, &eStringRel,
													   &aFilterString, 0,
													   &bRegexp)
				&& eStringRel == CntSearchData::STRING_EQUAL && !bRegexp)
			{
				m_aSearchFilterString
					= ByteString(aFilterString,
								 m_rAcnt.GetMailbox()->getTextEncoding());
				m_nSearchFilterType = VIMSEL_FROM;
				m_pSearchFilterData = m_aSearchFilterString.GetBuffer();
				m_nSearchFilterDataLen = m_aSearchFilterString.Len();
			}
			else if (pSearchData->HasSingleStringConstraint(WID_TITLE,
															&eStringRel,
															&aFilterString, 0,
															&bRegexp)
					 && eStringRel == CntSearchData::STRING_CONTAINS
					 && !bRegexp)
			{
				m_aSearchFilterString
					= ByteString(aFilterString,
								 m_rAcnt.GetMailbox()->getTextEncoding());
				m_nSearchFilterType = VIMSEL_SUBJECT;
				m_pSearchFilterData = m_aSearchFilterString.GetBuffer();
				m_nSearchFilterDataLen = m_aSearchFilterString.Len();
			}
			else
			{
				CntSearchData::DateRelType eDateRel;
				Date aDate;
				if (pSearchData->HasSingleDateConstraint(WID_DATE_CREATED,
														 &eDateRel, &aDate))
					switch (eDateRel)
					{
						case CntSearchData::DATE_EQUAL:
							m_nSearchFilterType = VIMSEL_DATE;
							translate(DateTime(aDate, Time(0, 0)),
									  m_aSearchFilterDate.Start);
							translate(DateTime(aDate, Time(23, 59, 59, 99)),
									  m_aSearchFilterDate.Stop);
							m_pSearchFilterData = &m_aSearchFilterDate;
							m_nSearchFilterDataLen
							 = sizeof m_aSearchFilterDate;
							break;

						case CntSearchData::DATE_LESS_EQUAL:
							m_nSearchFilterType = VIMSEL_DATE;
							translate(aMinVIMDate, m_aSearchFilterDate.Start);
							translate(DateTime(aDate, Time(23, 59, 59, 99)),
									  m_aSearchFilterDate.Stop);
							m_pSearchFilterData = &m_aSearchFilterDate;
							m_nSearchFilterDataLen
							 = sizeof m_aSearchFilterDate;
							break;

						case CntSearchData::DATE_GREATER_EQUAL:
							m_nSearchFilterType = VIMSEL_DATE;
							translate(DateTime(aDate, Time(0, 0)),
									  m_aSearchFilterDate.Start);
							translate(aMaxVIMDate, m_aSearchFilterDate.Stop);
							m_pSearchFilterData = &m_aSearchFilterDate;
							m_nSearchFilterDataLen
							 = sizeof m_aSearchFilterDate;
							break;
					}
			}
		}

		m_pCache = getJob().GetCacheNode();
		m_pDirectory = getJob().GetDirectoryNode();
		m_pUserData = getJob().GetUserDataNode();

		m_aCntrURL = OWN_URL(&m_rCntrNode);
		if (m_aCntrURL.GetChar(m_aCntrURL.Len() - 1) != '/')
			m_aCntrURL += '/';

		if (m_nTotalMesgs)
		{
			m_eProgress = PROGRESS_VALUE;
			m_nMesgCount = 0;
			m_nProgressID = CntStatusBarHint::CreateHintId();
			getJob().
			 Broadcast(CntStatusBarHint(m_nProgressID, 0, m_nTotalMesgs,
										CntResId(RID_PROT_LOADING_MESSAGES)));
		}
		else
		{
			m_eProgress = PROGRESS_TEXT;
			getJob().
			 Broadcast(CntStatusBarHint(CntResId(RID_PROT_LOADING_MESSAGES)));
		}
		m_nNewMesgs = 0;

		m_bInitialized = TRUE;
	}

	if (m_bWaitingHeaders)
	{
		switch (m_nWhich == WID_SYNCHRONIZE ?
				 m_bSeekPastKnown ?
				  m_pContainer->
				   startHeaderIteration(CntVIMMessageContainer::SEEK_BEGIN,
										CntVIMMessageContainer::SEEK_BEGIN,
										&getJob()) :
				  m_pContainer->startHeaderIteration(FALSE) :
				 m_bSeekPastKnown ?
				  m_pContainer->
				   startHeaderIteration
				    (ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
								   WID_VIM_HIGHESTMSGREFIDPART1),
					 ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
								   WID_VIM_HIGHESTMSGREFIDPART2),
					 &getJob()) :
				  m_pContainer->startHeaderIteration(m_bIterateFromEnd))
		{
			case CntVIMMessageContainer::EXECUTE_ERROR:
				cancel();
				return 0;

			case CntVIMMessageContainer::EXECUTE_WAITING:
				reschedule();
				return 0;

			case CntVIMMessageContainer::EXECUTE_DONE:
				m_bWaitingHeaders = FALSE;
				break;
		}
	}

	startTimeSlice();

	// Iterate through storage (WID_OPEN, WID_UPDATE, and WID_SEARCH):
	if (m_pIterator && m_nWhich != WID_SYNCHRONIZE)
	{
		for (;;)
		{
			String aMsgID(m_pDirectory->iter(*m_pIterator));
			if (aMsgID.Len() == 0)
				break;

			String aMsgURL(m_aCntrURL);
			aMsgURL += aMsgID;

			// Ignore messages that are deleted:
			UINT32 nAttrib;
			if (m_pDirectory->attrib(aMsgID, 0, 0, nAttrib) == ERRCODE_NONE
				&& !(nAttrib
					  & (CNTDIRENTRY_ATTRIB_MARKEDFORDELETE
						  | CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY)))
			{
				if (m_eViewFilter == FILTER_NONE
					|| BOOL_CAST(m_pUserData->attrib(aMsgURL, 0, 0, nAttrib)
								  == ERRCODE_NONE
								 && nAttrib & m_nViewFilterAttrib)
					    == (m_eViewFilter == FILTER_SET))
					createMesgNode(aMsgID, aMsgURL, !m_rCntr.IsInbox(), 0);

				if (m_bClearExpiredBodies)
				{
					CntStoreItemSetRef
					 xMsgItems
					  (CntVIMContainerNodeImp::OpenMessageDirectoryItemSet
					    (m_pDirectory, aMsgID));
					if (xMsgItems.Is())
					{
						const SfxPoolItem * pItem;
						if (xMsgItems->GetItemState(WID_DATE_CREATED, FALSE,
													&pItem)
							 == SFX_ITEM_SET)
						{
							const SfxDateTimeItem * pDateItem
							 = PTR_CAST(SfxDateTimeItem, pItem);
							if (pDateItem
								&& Date(pDateItem->GetDateTime().GetDate())
								    < m_aKeepSinceDate)
							{
								String aBodyName(aMsgURL);
								aBodyName.
									AppendAscii(
										RTL_CONSTASCII_STRINGPARAM(
											CNT_VIM_MESG_BODY_ID_SUFFIX));
								m_pCache->remove(aBodyName);
							}
						}
					}
				}

				++m_nMesgCount;
			}

			if (checkTimeSliceExhausted())
			{
				if (m_eProgress == PROGRESS_VALUE)
					getJob().Broadcast(CntStatusBarHint(m_nProgressID,
													  m_nMesgCount));

				reschedule();
				return 0;
			}
		}

		delete m_pIterator;
		m_pIterator = 0;
	}

	// Iterate through VIM message container:
	if (m_bOnline)
	{
		for (;;)
		{
			if (m_bWaitingBody)
			{
				m_bWaitingBody
				 = m_rCntr.createMessageBodyItem(getJob(), m_xMsgDirSet,
												 m_xMsgNode, TRUE, FALSE);
				if (getJob().IsCancelled())
					return 0;
				if (m_bWaitingBody)
				{
					reschedule();
					return 0;
				}
				m_xMsgDirSet = 0;
				m_xMsgNode = 0;
				++m_nMesgCount;
			}

			CntVIMMessageHeader * pHeader
			 = m_pContainer->getNextHeader(&getJob(), m_nSearchFilterType,
										   m_pSearchFilterData,
										   m_nSearchFilterDataLen);
			if (!pHeader)
				if (m_rAcnt.GetMailbox()->getStatus().isOK())
					break;
				else
				{
					// An error occured:
					cancel();
					return 0;
				}

			BOOL bNewMsg = FALSE;

			// If seeking past the highest known message is possible, store
			// any new message as the currently highest one; otherwise, if
			// iterating from the end, store the first message encountered as
			// the highest one:
			if (m_bSeekPastKnown || m_bIterateFromEnd && m_bFirst)
			{
				CntUInt32Item aHighestRefIDPart1(WID_VIM_HIGHESTMSGREFIDPART1,
												 pHeader->getRefIDPart1());
				CntUInt32Item aHighestRefIDPart2(WID_VIM_HIGHESTMSGREFIDPART2,
												 pHeader->getRefIDPart2());
				CntStoreItemSetRef
				 xDirectorySet(m_rCntr.OpenDirectoryItemSet(m_pDirectory));
				if (xDirectorySet.Is())
				{
					xDirectorySet->Put(aHighestRefIDPart1);
					xDirectorySet->Put(aHighestRefIDPart2);
					xDirectorySet = 0;
				}
				m_rCntrNode.Put(aHighestRefIDPart1);
				m_rCntrNode.Put(aHighestRefIDPart2);
				m_bFirst = FALSE;
			}

			// Get message ID:
			String aMsgID(pHeader->getUniqueID());

			// Ignore messages that are marked for deletion:
			UINT32 nDirectoryAttrib;
			if (m_pDirectory->attrib(aMsgID, 0, 0, nDirectoryAttrib)
				 == ERRCODE_NONE
				&& (nDirectoryAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE
					|| m_nWhich != WID_SYNCHRONIZE
					   && nDirectoryAttrib
					       & CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY))
			{
				// And if iterating from the end, stop when the 'old' messages
				// have been reached:
				if (m_bIterateFromEnd)
					break;
			}
			else
			{
				String aMsgURL(m_aCntrURL);
				aMsgURL += aMsgID;

				UINT32 nUserDataAttrib;
				if (nDirectoryAttrib & CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY)
					// Recreate locally deleted messages (WID_SYNCHRONIZE):
					m_pDirectory->
					 attrib(aMsgID, CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY, 0);
				else
				{
					// Try to open message's directory item set:
					m_xMsgDirSet
					 = m_pDirectory->openItemSet(aMsgID,
												 STREAM_STD_READWRITE
												  | STREAM_NOCREATE);
					if (m_xMsgDirSet.Is())
					{
						// If iterating from the end, stop when the 'old'
						// messages have been reached:
						if (m_bIterateFromEnd)
						{
							m_xMsgDirSet = 0;
							break;
						}

						if (m_pUserData->attrib(aMsgURL, 0, 0,
												nUserDataAttrib)
							 != ERRCODE_NONE)
							nUserDataAttrib = 0;
					}
				}

				if (!m_xMsgDirSet.Is())
				{
					m_xMsgDirSet
					 = m_pDirectory->
						openItemSet(aCntVIMMessageDirectoryItemSetRanges,
									aMsgID);
					if (m_xMsgDirSet.Is())
					{
						m_xMsgDirSet->
						 Put(CntPriorityItem(WID_PRIORITY,
											 pHeader->getPriority()));
						m_xMsgDirSet->Put(CntStringItem(WID_MESSAGE_ID,
														aMsgID));
						m_xMsgDirSet->Put(CntStringItem(WID_BCC,
														pHeader->getBCC()));
						m_xMsgDirSet->Put(CntStringItem(WID_CC,
														pHeader->getCC()));
						m_xMsgDirSet->
						 Put(CntStringItem(m_rCntr.IsInbox() ?
										    WID_TO : WID_NEWSGROUPS,
										   pHeader->getTo()));
						m_xMsgDirSet->Put(CntNameItem(WID_FROM,
													  pHeader->getFrom()));
						m_xMsgDirSet->
						 Put(CntStringItem(WID_TITLE, pHeader->getSubject()));
						if (pHeader->isDatePresent())
							m_xMsgDirSet->
							 Put(SfxDateTimeItem(WID_DATE_CREATED,
												 pHeader->getDate()));
					}

					// Store initial user data:
					nUserDataAttrib = CNTDIRENTRY_ATTRIB_CREATE
						               | CNTDIRENTRY_ATTRIB_VIM_UNSEEN;
					m_pUserData->attrib(aMsgURL, 0, nUserDataAttrib);

					// For a new message, increment TotalContentCount:
					bNewMsg = TRUE;
				}

				// Update the actual state of the VIM-internal data stored in
				// the message's directory itemset:
				if (m_xMsgDirSet.Is())
				{
					m_xMsgDirSet->
					 Put(CntStringItem(WID_VIM_MSGREFIDPART1,
									   pHeader->getRefIDPart1()));
					m_xMsgDirSet->
					 Put(CntStringItem(WID_VIM_MSGREFIDPART2,
									   pHeader->getRefIDPart2()));
				}
				if (pHeader->getInternallyUnread())
					m_pDirectory->
					 attrib(aMsgID, 0,
							CNTDIRENTRY_ATTRIB_VIM_INTERNALLYUNREAD);
				else
					m_pDirectory->
					 attrib(aMsgID, CNTDIRENTRY_ATTRIB_VIM_INTERNALLYUNREAD,
							0);

				delete pHeader;

				if ((bNewMsg || m_nWhich == WID_OPEN
					 || m_nWhich == WID_SEARCH)
					&& (m_eViewFilter == FILTER_NONE
						|| BOOL_CAST(nUserDataAttrib & m_nViewFilterAttrib)
					        == (m_eViewFilter == FILTER_SET)))
					createMesgNode(aMsgID, aMsgURL, TRUE, m_xMsgDirSet);
				if (bNewMsg)
					++m_nNewMesgs;

				// Load message body into cache, if appropriate:
				if ((bNewMsg || m_nWhich == WID_SYNCHRONIZE)
					&& m_eCacheBodies != CACHE_NONE && m_xMsgDirSet.Is())
				{
					BOOL bDoCache;
					if (m_eCacheBodies == CACHE_SOME)
					{
						const SfxPoolItem * pItem;
						if (m_xMsgDirSet->GetItemState(WID_DATE_CREATED,
													   FALSE, &pItem)
							 == SFX_ITEM_SET)
						{
							const SfxDateTimeItem * pDateItem
							 = PTR_CAST(SfxDateTimeItem, pItem);
							bDoCache
							 = pDateItem
							   && Date(pDateItem->GetDateTime().GetDate())
								   < m_aKeepSinceDate;
						}
						else
							bDoCache = TRUE;
					}
					else
						bDoCache = TRUE;
					if (bDoCache)
					{
						m_xMsgNode = m_rCntrNode.Query(aMsgURL, FALSE);
						m_bWaitingBody
						 = m_rCntr.createMessageBodyItem(getJob(), m_xMsgDirSet,
														 m_xMsgNode, TRUE,
														 FALSE);
						if (getJob().IsCancelled())
							return 0;
						if (m_bWaitingBody)
						{
							if (m_eProgress == PROGRESS_VALUE)
								getJob().
								 Broadcast(CntStatusBarHint(m_nProgressID,
															m_nMesgCount));

							reschedule();
							return 0;
						}
					}
				}

				++m_nMesgCount;
			}

			m_xMsgDirSet = 0;
			m_xMsgNode = 0;

			if (checkTimeSliceExhausted())
			{
				if (m_eProgress == PROGRESS_VALUE)
					getJob().Broadcast(CntStatusBarHint(m_nProgressID,
													  m_nMesgCount));

				reschedule();
				return 0;
			}
		}
	}

	// Iterate through storage (WID_SYNCHRONIZE):
	if (m_pIterator)
	{
		for (;;)
		{
			String aMsgID(m_pDirectory->iter(*m_pIterator));
			if (aMsgID.Len() == 0)
				break;

			UINT32 nAttrib;
			if (m_pDirectory->attrib(aMsgID, 0, 0, nAttrib) == ERRCODE_NONE)
				if (nAttrib & CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY)
					m_pDirectory->remove(aMsgID);
				else if (!(nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE))
					++m_nMesgCount;

			if (checkTimeSliceExhausted())
			{
				if (m_eProgress == PROGRESS_VALUE)
					getJob().Broadcast(CntStatusBarHint(m_nProgressID,
													  m_nMesgCount));

				reschedule();
				return 0;
			}
		}

		delete m_pIterator;
		m_pIterator = 0;
	}

	m_rCntr.
	 UpdateMessageCounts(&getJob(),
						 CntVIMContainerNodeImp::RelativeChange(m_nNewMesgs),
						 CntVIMContainerNodeImp::RelativeChange(0),
						 CntVIMContainerNodeImp::RelativeChange(0));

	// If this is a WID_UPDATE job and there were new messages, find out if
	// this job is a child job of a (possibly auto update) WID_UPDATE job at
	// the VIM box or (for bboards) the bboard box node; if it is, broadcast
	// the number of new messages:
	if (m_nWhich == WID_UPDATE && m_nNewMesgs)
	{
		CntNodeJob * pUpdateJob = m_rCntr.GetUpdateJob(&getJob());
		if (pUpdateJob)
		{
			CntUpdateResult aResult;
			aResult.aTargetURL = m_aCntrURL;
			aResult.nNewMessages = m_nNewMesgs;
			pUpdateJob->Broadcast(CntUpdateHint(&aResult));
		}
	}

	clearProgress();
	done();
	return 0;
}

//============================================================================
// virtual
void CntVIMCntrOpenTask_Impl::finished(bool bCanceled)
{
	if (bCanceled)
	{
		if ((m_bWaitingHeaders || m_bWaitingBody) && m_pContainer)
			m_pContainer->cancelExecution();
		m_xMsgDirSet = 0;
		m_xMsgNode = 0;
		delete m_pIterator;
		if (m_bInitialized)
			m_rCntr.
				UpdateMessageCounts(&getJob(),
									CntVIMContainerNodeImp::RelativeChange(
										m_nNewMesgs),
									CntVIMContainerNodeImp::RelativeChange(0),
									CntVIMContainerNodeImp::RelativeChange(
										0));
		clearProgress();
	}
}

//============================================================================
//
//  class CntVIMCntrFlagTask_Impl
//
//============================================================================

// virtual
const SfxPoolItem * CntVIMCntrFlagTask_Impl::execute()
{
	if (!m_bInitialized)
	{
		// Do nothing if the container is empty:
		nTotalCount = ITEMSET_VALUE(&m_rCntrNode, CntUInt32Item,
									WID_TOTALCONTENTCOUNT);
		if (!nTotalCount)
		{
			done();
			return 0;
		}

		// Get the flag value:
		pFlag = (const CntBoolItem *) getJob().GetRequest();

		// Start progress bar:
		m_nHintID = CntStatusBarHint::CreateHintId();
		getJob().
		 Broadcast(CntStatusBarHint(m_nHintID, 0, nTotalCount,
									CntResId(pFlag->Which() == WID_IS_READ ?
											  pFlag->GetValue() ?
											   RID_PROT_READING_MESSAGES :
											   RID_PROT_UNREADING_MESSAGES :
											  pFlag->GetValue() ?
											   RID_PROT_MARKING_MESSAGES :
											   RID_PROT_UNMARKING_MESSAGES)));

		// Get the container URL to build message URLs from it later on:
		aContainerURL = OWN_URL(&m_rCntrNode);
		if (aContainerURL.GetChar(aContainerURL.Len() - 1) != '/')
			aContainerURL += '/';

		// Get box directory and user data storages:
		pDirectory = getJob().GetDirectoryNode();
		pUserData = getJob().GetUserDataNode();

		m_pIterator = new CntStorageIterator();

		nProcessedCount = 0;
		nChangedCount = 0;

		m_bInitialized = TRUE;
	}

	startTimeSlice();
	for (;;)
	{
		String aMsgID(pDirectory->iter(*m_pIterator));
		if (aMsgID.Len() == 0)
			break;

		UINT32 nAttrib;
		if (pDirectory->attrib(aMsgID, 0, 0, nAttrib) == ERRCODE_NONE
			&& !(nAttrib
				  & (CNTDIRENTRY_ATTRIB_MARKEDFORDELETE
					  | CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY)))
		{
			// Update message node if message's flag changes:
			String aMsgURL(aContainerURL);
			aMsgURL += aMsgID;
			UINT32 nAttrib = 0;
			pUserData->attrib(aMsgURL, 0, 0, nAttrib);
			BOOL bWasFlaged
			 = pFlag->Which() == WID_IS_READ ?
			    !(nAttrib & CNTDIRENTRY_ATTRIB_VIM_UNSEEN) :
			    CAST_TO_BOOL(nAttrib & CNTDIRENTRY_ATTRIB_MARKED);
			if (bWasFlaged != pFlag->GetValue())
			{
				CntNodeRef xMsgNode(m_rCntrNode.Query(aMsgURL, FALSE));
				if (xMsgNode.Is())
					xMsgNode->Put(*pFlag);
				m_rCntr.SetMessageFlag(pFlag->Which(), pFlag->GetValue(),
									   pUserData, aMsgURL);
				++nChangedCount;

				// Synchronize nProcessedCount in case an error occurs:
				++nProcessedCount;

				// Tell VIM about messages read for the first time:
				if (pFlag->Which() == WID_IS_READ && pFlag->GetValue()
					&& !m_rCntr.NotifyMessageRead(&getJob(), aMsgID, xMsgNode))
				{
					// An error occured:
					cancel();
					return 0;
				}
			}
			else
				++nProcessedCount;
		}

		if (checkTimeSliceExhausted())
		{
			// Increase progress bar:
			getJob().Broadcast(CntStatusBarHint(m_nHintID, nProcessedCount));

			reschedule();
			return 0;
		}
	}
	delete m_pIterator;
	m_pIterator = 0;

	if (pFlag->Which() == WID_IS_READ)
		m_rCntr.
		 UpdateMessageCounts
		  (&getJob(), CntVIMContainerNodeImp::AbsoluteChange(nProcessedCount),
		   CntVIMContainerNodeImp::AbsoluteChange(pFlag->GetValue() ?
												   nProcessedCount : 0),
		   CntVIMContainerNodeImp::RelativeChange(0));
	else
		m_rCntr.
		 UpdateMessageCounts
		  (&getJob(), CntVIMContainerNodeImp::AbsoluteChange(nProcessedCount),
		   CntVIMContainerNodeImp::RelativeChange(0),
		   CntVIMContainerNodeImp::AbsoluteChange(pFlag->GetValue() ?
												   nProcessedCount : 0));

	// Terminate progress bar:
	getJob().Broadcast(CntStatusBarHint(m_nHintID));
	done();
	return 0;
}

//============================================================================
// virtual
void CntVIMCntrFlagTask_Impl::finished(bool bCanceled)
{
	if (bCanceled)
	{
		delete m_pIterator;
		if (m_bInitialized && nProcessedCount)
			m_rCntr.
				UpdateMessageCounts(&getJob(),
									CntVIMContainerNodeImp::RelativeChange(0),
									CntVIMContainerNodeImp::RelativeChange(
										pFlag->Which() != WID_IS_READ ?
										    0 :
										pFlag->GetValue() ?
										    nChangedCount :
										    -long(nChangedCount)),
									CntVIMContainerNodeImp::RelativeChange(
										pFlag->Which() != WID_IS_MARKED ?
										    0 :
										pFlag->GetValue() ?
										    nChangedCount :
										    -long(nChangedCount)));
		if (m_nHintID)
			getJob().Broadcast(CntStatusBarHint(m_nHintID));
	}
}

//============================================================================
//
//  class CntVIMInboxNodeImp
//
//============================================================================

CntVIMInboxNodeImp::CntVIMInboxNodeImp(CntNode * pTheParent):
	CntVIMContainerNodeImp(pTheParent)
{
	aUserDataItemSetName.
		AssignAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_IBOX_DATA_SET_ID));
}

//============================================================================
// virtual
void CntVIMInboxNodeImp::Initialize(CntNodeJob & rJob)
{
	if (!bInitialized)
	{
		pParent->Put(CntStringItem(WID_TITLE,
								   INetContentTypes::GetPresentation
								    (CONTENT_TYPE_X_CNT_VIMINBOX,
									 CntRootNodeMgr::GetIniManager()->
									  getInternational().GetLanguage())));

		CntStorageNode * pDirectory = rJob.GetDirectoryNode();
		if (pDirectory)
			pParent->Put(pDirectory->Get(WID_MESSAGE_STOREMODE));

		CntVIMContainerNodeImp::Initialize(rJob,
										   &((CntVIMNode *)
											  pParent->GetParent())->
										    getImplementation());
		bInitialized = TRUE;
	}
}

//============================================================================
// virtual
BOOL CntVIMInboxNodeImp::DoDeleteMessagesFromServer() const
{
	DBG_ASSERT(bInitialized, "VIM inbox node not initialized");

	return ITEMSET_VALUE(pParent, CntBoolItem, WID_DELETE_ON_SERVER);
}

//============================================================================
// virtual
BOOL CntVIMInboxNodeImp::DoCacheMessageBodies() const
{
	DBG_ASSERT(bInitialized, "VIM inbox node not initialized");

	return ITEMSET_VALUE(pParent, CntMsgStoreModeItem, WID_MESSAGE_STOREMODE)
		    == CNT_MESSAGE_STOREMODE_LOCAL;
}

//============================================================================
// virtual
CntVIMMessageContainer * CntVIMInboxNodeImp::OpenContainer(CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM inbox node not initialized");

	if (!pContainer)
	{
		pContainer = pVIMBoxNodeImp->GetMailbox()->getInbox();
		if (!pContainer->open(pJob))
		{
			delete pContainer;
			pContainer = 0;
		}
	}
	return pContainer;
}

//============================================================================
// virtual
BOOL CntVIMInboxNodeImp::IsOpenSubJob(CntNodeJob * pJob)
{
	return pJob->GetParent()
		   && pJob->GetParent()->GetRequest()->Which() == WID_OPEN;
}

//============================================================================
// virtual
CntNodeJob * CntVIMInboxNodeImp::GetUpdateJob(CntNodeJob * pJob)
{
	DBG_ASSERT(pJob->GetRequest()->Which() == WID_UPDATE,
			   "Non WID_UPDATE job in GetUpdateJob");

	return pJob->GetParent()
		   && pJob->GetParent()->GetRequest()->Which() == WID_UPDATE ?
		    pJob->GetParent() : 0;
}

//============================================================================
//
//  class CntVIMBBoardNodeImp
//
//============================================================================

CntVIMBBoardNodeImp::CntVIMBBoardNodeImp(CntNode * pTheParent):
	CntVIMContainerNodeImp(pTheParent)
{}

//============================================================================
// virtual
void CntVIMBBoardNodeImp::Initialize(CntNodeJob & rJob)
{
	if (!bInitialized)
	{
		// Get the quoted bboard name from the URL:
		String aURL(OWN_URL(pParent));
		xub_StrLen nLen = aURL.Len();
		xub_StrLen i;
		for (i = nLen - 2; aURL.GetChar(i) != '/'; --i);
		m_aQuotedName
			= aURL.Copy(i + 1,
						nLen - i - (aURL.GetChar(nLen - 1) == '/' ? 2 : 1));

		aUserDataItemSetName = m_aQuotedName;
		aUserDataItemSetName.
			AppendAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID));

		if (pParent->GetItemState(WID_TITLE, FALSE) < SFX_ITEM_SET)
			pParent->
				Put(CntStringItem(WID_TITLE,
								  INetURLObject::decode(
									  m_aQuotedName, '=',
									  INetURLObject::DECODE_WITH_CHARSET)));

		CntVIMContainerNodeImp::Initialize(rJob,
										   &((CntVIMNode *)
											  pParent->
											   GetParent()->GetParent())->
										     getImplementation());
		bInitialized = TRUE;
	}
}

//============================================================================
// virtual
BOOL CntVIMBBoardNodeImp::DoCacheMessageBodies() const
{
	DBG_ASSERT(bInitialized, "VIM bulletin board node not initialized");

	return ITEMSET_VALUE(pParent->GetParent(), CntMsgStoreModeItem,
						 WID_MESSAGE_STOREMODE)
		    == CNT_MESSAGE_STOREMODE_LOCAL;
}

//============================================================================
// virtual
UINT16 CntVIMBBoardNodeImp::GetMessageExpirationLimit() const
{
	DBG_ASSERT(bInitialized, "VIM bulletin board node not initialized");

	CntNode * pBBoardBoxNode = pParent->GetParent();
	return
	 ITEMSET_VALUE(pBBoardBoxNode, CntBoolItem,
				   WID_STORE_MSGS_HAS_TIMELIMIT) ?
	  ITEMSET_VALUE(pBBoardBoxNode, CntUInt16Item, WID_STORE_MSGS_TIMELIMIT) :
	  0;
}

//============================================================================
// virtual
void CntVIMBBoardNodeImp::SeenStatusChanged(CntNodeJob * pJob, BOOL bIsSeen)
{
	// Find out if the bboard is subscribed by looking in the view data
	// storage (pJob might be a job for the bboard or for a message; if in
	// both cases the job can supply the view data storage, this method seems
	// the best way to access the subscription information---better than
	// looking for WID_FLAG_SUBSCRIBED in the bboard's anchor):
	CntStorageNode * pViewData = pJob->GetViewDataNode();
	UINT32 nAttrib;
	BOOL bSubscribed
	 = pViewData
	   && pViewData->attrib(m_aQuotedName, 0, 0, nAttrib) == ERRCODE_NONE
	   && nAttrib & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED;

	CntVIMBBoardBoxNode * pBBoardBoxNode = PTR_CAST(CntVIMBBoardBoxNode,
													pParent->GetParent());
	if (pBBoardBoxNode)
		pBBoardBoxNode->
		 getImplementation().UpdateBBoardCounts(pJob,
												CntVIMBBoardBoxNodeImp::STAY,
												bIsSeen, !bIsSeen,
												bSubscribed, bSubscribed);
	else
		DBG_ERROR("BBoard node parent must be bboard box node");
}

//============================================================================
// virtual
CntVIMMessageContainer * CntVIMBBoardNodeImp::OpenContainer(CntNodeJob *)
{
	DBG_ASSERT(bInitialized, "VIM bulletin board node not initialized");

	if (!pContainer)
		pContainer
		 = pVIMBoxNodeImp->
		    GetMailbox()->getBulletinBoard(ITEMSET_VALUE(pParent,
														 CntStringItem,
														 WID_TITLE));
	return pContainer;
}

//============================================================================
// virtual
BOOL CntVIMBBoardNodeImp::IsOpenSubJob(CntNodeJob * pJob)
{
	return pJob->GetParent()
		   && (pJob->GetParent()->GetRequest()->Which() == WID_OPEN
			   || pJob->GetParent()->GetRequest()->Which() == WID_UPDATE
			      && pJob->GetParent()->GetParent()
			      && pJob->GetParent()->GetParent()->GetRequest()->Which()
			          == WID_OPEN);
}

//============================================================================
// virtual
CntNodeJob * CntVIMBBoardNodeImp::GetUpdateJob(CntNodeJob * pJob)
{
	DBG_ASSERT(pJob->GetRequest()->Which() == WID_UPDATE,
			   "Non WID_UPDATE job in GetUpdateJob");

	return pJob->GetParent()
		   && pJob->GetParent()->GetRequest()->Which() == WID_UPDATE ?
		    pJob->GetParent()->GetParent()
		    && pJob->GetParent()->GetParent()->GetRequest()->Which()
		        == WID_UPDATE ?
		     pJob->GetParent()->GetParent() : pJob->GetParent() :
		    0;
}

//============================================================================
void CntVIMBBoardNodeImp::SubscribedStatusChange(CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM bulletin board node not initialized");

	// Check if anything really changed:
	BOOL bSubscribed = ITEM_VALUE(CntBoolItem, *pJob->GetRequest());
	CntInterface * pClient = pJob->GetClient();
	if (ITEMSET_VALUE(pClient, CntBoolItem, WID_FLAG_SUBSCRIBED)
		 == bSubscribed)
		return;

	// Update bboard's subscription entry in view data storage:
	CntStorageNode * pViewData = pJob->GetViewDataNode();
	if (pViewData)
		if (bSubscribed)
			pViewData->attrib(m_aQuotedName, 0,
							  CNTDIRENTRY_ATTRIB_CREATE
							   | CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED);
		else
			pViewData->remove(m_aQuotedName);

	// Determine parent's view mode:
	CntFolderViewMode eViewMode;
	CntAnchor * pAnchor = PTR_CAST(CntAnchor, pClient);
	if (pAnchor && (pAnchor = pAnchor->GetParent()))
	{
		DBG_ASSERT(pAnchor->GetNode()->GetMostReferedNode()
				    == pParent->GetParent(),
				   "Anchor missmatch");
		eViewMode
		 = CntFolderViewMode(ITEMSET_VALUE(pAnchor, CntFolderViewModeItem,
										   WID_FOLDERVIEW_MODE));
	}
	else
		eViewMode = CNT_VIEW_ALL_FOLDERS;

	// Remove this node if it should not be shown:
	if (eViewMode == CNT_VIEW_SUBSCRIBED_FOLDERS && !bSubscribed
		|| eViewMode == CNT_VIEW_ACTIVE_FOLDERS
		   && (!bSubscribed
			   || ITEMSET_VALUE(pParent, CntUInt32Item, WID_TOTALCONTENTCOUNT)
			       == ITEMSET_VALUE(pParent, CntUInt32Item,
									WID_SEENCONTENTCOUNT)))
		pJob->Result(pParent, CNT_ACTION_REMOVED);

	// Update the bboard box's counts and seen flag:
	CntVIMBBoardBoxNode * pBBoardBoxNode = PTR_CAST(CntVIMBBoardBoxNode,
													pParent->GetParent());
	if (pBBoardBoxNode)
	{
		BOOL bSeen = ITEMSET_VALUE(pParent, CntBoolItem, WID_IS_READ);
		pBBoardBoxNode->
		 getImplementation().
		  UpdateBBoardCounts(pJob, CntVIMBBoardBoxNodeImp::STAY, bSeen, bSeen,
							 bSubscribed,
							 ITEMSET_VALUE(pClient, CntBoolItem,
										   WID_FLAG_SUBSCRIBED));
	}
}

//============================================================================
void CntVIMBBoardNodeImp::CleanCache(CntNodeJob * pJob)
{
	DBG_ASSERT(bInitialized, "VIM bulletin board node not initialized");

	CntStorageNode * pCache = pJob->GetCacheNode();
	if (!pCache)
	{
		pJob->Cancel();
		return;
	}
	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	if (!pDirectory)
	{
		pJob->Cancel();
		return;
	}
	CntStorageNode * pUserData = pJob->GetUserDataNode();
	if (!pUserData)
	{
		pJob->Cancel();
		return;
	}

	String aContainerURL(OWN_URL(pParent));
	if (aContainerURL.GetChar(aContainerURL.Len() - 1) != '/')
		aContainerURL += '/';

	UINT32 nSeenCount = 0;
	UINT32 nMarkedCount = 0;
	CntStorageIterator aIterator;
	for (;;)
	{
		String aMsgID(pDirectory->iter(aIterator));
		if (aMsgID.Len() == 0)
			break;

		UINT32 nAttrib;
		if (pDirectory->attrib(aMsgID, 0, 0, nAttrib) == ERRCODE_NONE
			&& !(nAttrib
				  & (CNTDIRENTRY_ATTRIB_MARKEDFORDELETE
					  | CNTDIRENTRY_ATTRIB_VIM_DELETEDLOCALLY)))
		{
			String aMsgURL(aContainerURL);
			aMsgURL += aMsgID;

			if (pUserData->attrib(aMsgURL, 0, 0, nAttrib) == ERRCODE_NONE
				&& nAttrib & CNTDIRENTRY_ATTRIB_MARKED)
			{
				if (!(nAttrib & CNTDIRENTRY_ATTRIB_VIM_UNSEEN))
					++nSeenCount;
				++nMarkedCount;
			}
			else
			{
				DeleteMessageFromStorage(TRUE, FALSE, pCache, pDirectory,
										 pUserData, aMsgID, aMsgURL);
				CntNodeRef xMsgNode(pParent->Query(aMsgURL, FALSE));
				if (xMsgNode.Is())
					pJob->Result(xMsgNode, CNT_ACTION_DELETED);
			}
		}
	}

	UpdateMessageCounts(pJob, AbsoluteChange(nMarkedCount),
						AbsoluteChange(nSeenCount),
						AbsoluteChange(nMarkedCount));
	pJob->Done();
}

//============================================================================
//
//  class CntVIMBBoardBoxNodeImp
//
//============================================================================

void CntVIMBBoardBoxNodeImp::Initialize(CntNodeJob & rJob, BOOL bView)
{
	if (!m_bInitialized)
	{
		m_rBBoardBoxNode.
		 Put(CntStringItem(WID_TITLE,
						   INetContentTypes::GetPresentation
						    (CONTENT_TYPE_X_CNT_VIMBBOARDBOX,
							 CntRootNodeMgr::GetIniManager()->
							  getInternational().GetLanguage())));

		CntStorageNode * pDirectory = rJob.GetDirectoryNode();
		if (pDirectory)
		{
			m_rBBoardBoxNode.Put(pDirectory->Get(WID_MESSAGE_STOREMODE));
			m_rBBoardBoxNode.Put(pDirectory->
								  Get(WID_STORE_MSGS_HAS_TIMELIMIT));
			m_rBBoardBoxNode.Put(pDirectory->Get(WID_STORE_MSGS_TIMELIMIT));

			CntStoreItemSetRef
				xDirectorySet(pDirectory->
							      openItemSet(String::CreateFromAscii(
									              RTL_CONSTASCII_STRINGPARAM(
													  CNT_VIM_DATA_SET_ID)),
											  STREAM_STD_READ));
			if (!xDirectorySet.Is())
			{
				pDirectory->
					attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
						                               CNT_VIM_DATA_SET_ID)),
						   0,
						   CNTDIRENTRY_ATTRIB_CREATE
						       | CNTDIRENTRY_ATTRIB_HIDDEN);
				xDirectorySet
					= pDirectory->
					      openItemSet(aCntVIMBBoardBoxDirectoryItemSetRanges,
									  String::CreateFromAscii(
										  RTL_CONSTASCII_STRINGPARAM(
											  CNT_VIM_DATA_SET_ID)));
				if (xDirectorySet.Is())
				{
					xDirectorySet->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
													 0));
					xDirectorySet->
					 Put(CntUInt32Item(WID_VIM_BBOARDLISTPRESENT, FALSE));
				}
			}
			if (xDirectorySet.Is())
				m_rBBoardBoxNode.Put(*xDirectorySet);
		}

		CntStorageNode * pUserData = rJob.GetUserDataNode();
		if (pUserData)
		{
			CntStoreItemSetRef
				xUserDataSet(pUserData->
							     openItemSet(
									 String::CreateFromAscii(
										 RTL_CONSTASCII_STRINGPARAM(
											 CNT_VIM_BBOX_DATA_SET_ID)),
									 STREAM_STD_READ));
			if (!xUserDataSet.Is())
			{
				pUserData->attrib(String::CreateFromAscii(
					                  RTL_CONSTASCII_STRINGPARAM(
										  CNT_VIM_BBOX_DATA_SET_ID)),
								  0,
								  CNTDIRENTRY_ATTRIB_CREATE
								      | CNTDIRENTRY_ATTRIB_HIDDEN);
				xUserDataSet
					= pUserData->
					      openItemSet(aCntVIMBBoardBoxUserDataItemSetRanges,
									  String::CreateFromAscii(
										  RTL_CONSTASCII_STRINGPARAM(
											  CNT_VIM_BBOX_DATA_SET_ID)));
				if (xUserDataSet.Is())
					xUserDataSet->Put(CntUInt32Item(WID_SEENCONTENTCOUNT, 0));
			}
			if (xUserDataSet.Is())
				m_rBBoardBoxNode.Put(*xUserDataSet);
		}

		m_bInitialized = TRUE;
	}

	if (bView)
	{
		BOOL bViewAll
		 = ITEMSET_VALUE(rJob.GetClient(), CntFolderViewModeItem,
						 WID_FOLDERVIEW_MODE)
		    == CNT_VIEW_ALL_FOLDERS;

		UINT32 nSubscribedCount;
		BOOL bSubscribedRead;
		CntStorageNode * pViewData = rJob.GetViewDataNode();
		if (pViewData)
		{
			CntStoreItemSetRef
			 xViewDataSet(pViewData->openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)),
												 STREAM_STD_READ));
			if (xViewDataSet.Is())
			{
				nSubscribedCount = ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
												 WID_SUBSCRNEWSGROUPCOUNT);
				if (!bViewAll)
					bSubscribedRead
					 = ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
									 WID_VIM_SUBSCRSEENCONTENTCOUNT)
						== nSubscribedCount;
			}
			else
			{
				pViewData->attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)), 0,
								  CNTDIRENTRY_ATTRIB_CREATE
								   | CNTDIRENTRY_ATTRIB_HIDDEN);
				xViewDataSet
				 = pViewData->openItemSet
					           (aCntVIMBBoardBoxViewDataItemSetRanges,
								String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)));
				if (xViewDataSet.Is())
				{
					xViewDataSet->Put(CntUInt32Item(WID_SUBSCRNEWSGROUPCOUNT,
													0));
					xViewDataSet->Put(CntUInt32Item
									   (WID_VIM_SUBSCRSEENCONTENTCOUNT, 0));
				}
				nSubscribedCount = 0;
				bSubscribedRead = TRUE;
			}
		}
		else
		{
			nSubscribedCount = 0;
			bSubscribedRead = TRUE;
		}

		rJob.GetViewDataTarget()->
		 CntInterface::Put(CntUInt32Item(WID_SUBSCRNEWSGROUPCOUNT,
										 nSubscribedCount),
						   WID_SUBSCRNEWSGROUPCOUNT);
		rJob.GetViewDataTarget()->
		 CntInterface::Put(CntBoolItem
						    (WID_IS_READ,
							 bViewAll ?
							  ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item,
											WID_TOTALCONTENTCOUNT)
							   == ITEMSET_VALUE(&m_rBBoardBoxNode,
												CntUInt32Item,
												WID_SEENCONTENTCOUNT) :
							  bSubscribedRead),
						   WID_IS_READ);
	}
}

//============================================================================
CntStoreItemSet *
 CntVIMBBoardBoxNodeImp::OpenDirectoryItemSet(CntStorageNode * pDirectory)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	if (!pDirectory)
		return 0;

	CntStoreItemSet * pItemSet
	 = pDirectory->openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)),
							   STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), recreate it
		// from the node's data:
		pDirectory->attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)), 0,
						   CNTDIRENTRY_ATTRIB_CREATE
						    | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet
		 = pDirectory->openItemSet(aCntVIMBBoardBoxDirectoryItemSetRanges,
								   String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)));
		if (pItemSet)
		{
			pItemSet->Put(m_rBBoardBoxNode.Get(WID_TOTALCONTENTCOUNT));
			pItemSet->Put(m_rBBoardBoxNode.Get(WID_VIM_BBOARDLISTPRESENT));
		}
	}
	else
	{
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_TOTALCONTENTCOUNT)
				    == m_rBBoardBoxNode.Get(WID_TOTALCONTENTCOUNT),
				   "Storage corrupted");
		DBG_ASSERT(pItemSet->Get(WID_VIM_BBOARDLISTPRESENT)
				    == m_rBBoardBoxNode.Get(WID_VIM_BBOARDLISTPRESENT),
				   "Storage corrupted");
	}
	return pItemSet;
}

//============================================================================
CntStoreItemSet * CntVIMBBoardBoxNodeImp::OpenUserDataItemSet(CntStorageNode *
															   pUserData)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	if (!pUserData)
		return 0;

	CntStoreItemSet * pItemSet
	 = pUserData->openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_BBOX_DATA_SET_ID)),
							  STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), recreate it
		// from the node's data:
		pUserData->attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_BBOX_DATA_SET_ID)), 0,
						  CNTDIRENTRY_ATTRIB_CREATE
						   | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet
		 = pUserData->openItemSet(aCntVIMBBoardBoxUserDataItemSetRanges,
								  String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_BBOX_DATA_SET_ID)));
		if (pItemSet)
			pItemSet->Put(m_rBBoardBoxNode.Get(WID_SEENCONTENTCOUNT));
	}
	else
		// For debugging purposes, check storage values against node values:
		DBG_ASSERT(pItemSet->Get(WID_SEENCONTENTCOUNT)
				    == m_rBBoardBoxNode.Get(WID_SEENCONTENTCOUNT),
				   "Storage corrupted");
	return pItemSet;
}

//============================================================================
// static
CntStoreItemSet * CntVIMBBoardBoxNodeImp::OpenViewDataItemSet(CntStorageNode *
															   pViewData)
{
	if (!pViewData)
		return 0;

	CntStoreItemSet * pItemSet
	 = pViewData->openItemSet(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)),
							  STREAM_STD_READWRITE | STREAM_NOCREATE);
	if (!pItemSet)
	{
		// If no item set available (i.e., storage corrupted), create an
		// 'empty' one:
		DBG_ERROR("Storage corrupted");

		pViewData->attrib(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)), 0,
						  CNTDIRENTRY_ATTRIB_CREATE
						   | CNTDIRENTRY_ATTRIB_HIDDEN);
		pItemSet
		 = pViewData->openItemSet(aCntVIMBBoardBoxViewDataItemSetRanges,
								  String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CNT_VIM_DATA_SET_ID)));
		if (pItemSet)
		{
			pItemSet->Put(CntUInt32Item(WID_SUBSCRNEWSGROUPCOUNT, 0));
			pItemSet->Put(CntUInt32Item(WID_VIM_SUBSCRSEENCONTENTCOUNT, 0));
		}
	}
	return pItemSet;
}

//============================================================================
void CntVIMBBoardBoxNodeImp::UpdateBBoardCounts(CntNodeJob * pJob,
												ChangeState eTotalChange,
												BOOL bIsSeen, BOOL bWasSeen,
												BOOL bIsSubscribed,
												BOOL bWasSubscribed)
{
	CntNode * pSubject = pJob->GetSubject();

	UINT32 nTotalCount
	 = ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item, WID_TOTALCONTENTCOUNT);
	if (eTotalChange != STAY)
	{
		// The subject of pJob might be this bboard box node, a bboard node,
		// or a message node; therefore, the directory storage supplied by the
		// job might be the bboard box's directory storage or a bboard's
		// directory storage, but the bboard box's directory storage is wanted
		// here:
		CntStorageNode * pDirectory = pJob->GetDirectoryNode();
		if (pSubject != &m_rBBoardBoxNode)
		{
			DBG_ASSERT(pDirectory->GetParent()->GetMostReferedNode()
					    == &m_rBBoardBoxNode,
					   "Directory storage missmatch");

			pDirectory = (CntStorageNode *) pDirectory->GetParent();
		}

		if (eTotalChange == INCREMENT)
			++nTotalCount;
		else if (nTotalCount)
			--nTotalCount;
		CntUInt32Item aTotalItem(WID_TOTALCONTENTCOUNT, nTotalCount);
		CntStoreItemSetRef xDirectorySet(OpenDirectoryItemSet(pDirectory));
		if (xDirectorySet.Is())
		{
			xDirectorySet->Put(aTotalItem);
			xDirectorySet = 0;
		}
		m_rBBoardBoxNode.Put(aTotalItem);
	}

	UINT32 nSeenCount
	 = ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item, WID_SEENCONTENTCOUNT);
	if (bIsSeen != bWasSeen)
	{
		nSeenCount += bIsSeen ? 1 : -1;
		CntUInt32Item aSeenItem(WID_SEENCONTENTCOUNT, nSeenCount);
		CntStoreItemSetRef
		 xUserDataSet(OpenUserDataItemSet(pJob->GetUserDataNode()));
		if (xUserDataSet.Is())
		{
			xUserDataSet->Put(aSeenItem);
			xUserDataSet = 0;
		}
		m_rBBoardBoxNode.Put(aSeenItem);
	}

	UINT32 nOldSubscribedCount = 0;
	UINT32 nNewSubscribedCount = 0;
	UINT32 nSubscrSeenCount;
	CntStorageNode * pViewData = pJob->GetViewDataNode();
	BOOL bHasViewDataSet = FALSE;
	if (pViewData)
	{
		CntStoreItemSetRef xViewDataSet(OpenViewDataItemSet(pViewData));
		if (xViewDataSet.Is())
		{
			bHasViewDataSet = TRUE;

			// Update WID_SUBSCRNEWSGROUPCOUNT:
			nOldSubscribedCount = ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
												WID_SUBSCRNEWSGROUPCOUNT);
			if (bIsSubscribed == bWasSubscribed)
				nNewSubscribedCount = nOldSubscribedCount;
			else
			{
				nNewSubscribedCount
				 = bIsSubscribed ?
				    nOldSubscribedCount < nTotalCount ?
				     nOldSubscribedCount + 1 : nTotalCount :
				    INT32(nOldSubscribedCount) > 0 ?
				     nOldSubscribedCount - 1 : 0;
				if (nNewSubscribedCount != nOldSubscribedCount)
					xViewDataSet->Put(CntUInt32Item(WID_SUBSCRNEWSGROUPCOUNT,
													nNewSubscribedCount));
			}

			// Update WID_VIM_SUBSCRSEENCONTENTCOUNT:
			nSubscrSeenCount = ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
											 WID_VIM_SUBSCRSEENCONTENTCOUNT);
			if (bIsSeen && bIsSubscribed && !(bWasSeen && bWasSubscribed))
				xViewDataSet->
				 Put(CntUInt32Item(WID_VIM_SUBSCRSEENCONTENTCOUNT,
								   ++nSubscrSeenCount));
			else if (bWasSeen && bWasSubscribed
					 && !(bIsSeen && bIsSubscribed))
				xViewDataSet->
				 Put(CntUInt32Item(WID_VIM_SUBSCRSEENCONTENTCOUNT,
								   --nSubscrSeenCount));
		}
	}

	// Get the bboard box's client:
	CntInterface * pClient = 0;
	if (pSubject == &m_rBBoardBoxNode)
		pClient = pJob->GetClient();
	else if (pSubject->ISA(CntVIMBBoardNode))
	{
		CntAnchor * pAnchor = PTR_CAST(CntAnchor, pJob->GetClient());
		if (pAnchor)
		{
			DBG_ASSERT(!pAnchor->GetParent()
					   || !pAnchor->GetParent()->GetNode()
					   || pAnchor->
					        GetParent()->GetNode()->GetMostReferedNode()
					       == &m_rBBoardBoxNode,
					   "Anchor missmatch");

			pClient = pAnchor->GetParent();
		}
	}
	else
	{
		DBG_ASSERT(pSubject->ISA(CntMessageNode), "Illegal subject");

		CntAnchor * pAnchor = PTR_CAST(CntAnchor, pJob->GetClient());
		if (pAnchor)
		{
			pAnchor = pAnchor->GetParent();
			if (pAnchor)
			{
				DBG_ASSERT
				 (!pAnchor->GetNode()
				  || pAnchor->GetNode()->GetMostReferedNode()->GetParent()
				      == &m_rBBoardBoxNode,
				  "Anchor missmatch");
				DBG_ASSERT
				 (!pAnchor->GetParent() || !pAnchor->GetParent()->GetNode()
				  || pAnchor->GetParent()->GetNode()->GetMostReferedNode()
				      == &m_rBBoardBoxNode,
				  "Anchor missmatch");

				pClient = pAnchor->GetParent();
			}
		}
	}

	if (pClient)
	{
		if (nNewSubscribedCount != nOldSubscribedCount)
			pJob->GetViewDataTarget(pClient)->
			 CntInterface::Put(CntUInt32Item(WID_SUBSCRNEWSGROUPCOUNT,
											 nNewSubscribedCount),
							   WID_SUBSCRNEWSGROUPCOUNT);

		BOOL bBoxSeen = (pViewData && bHasViewDataSet ?
						  ITEMSET_VALUE(pClient, CntFolderViewModeItem,
										WID_FOLDERVIEW_MODE)
						   == CNT_VIEW_ALL_FOLDERS :
						  TRUE) ?
		                 nTotalCount == nSeenCount :
		                 nNewSubscribedCount == nSubscrSeenCount;
		if (bBoxSeen != ITEMSET_VALUE(pClient, CntBoolItem, WID_IS_READ))
			pJob->GetViewDataTarget(pClient)->
			 CntInterface::Put(CntBoolItem(WID_IS_READ, bBoxSeen),
							   WID_IS_READ);
	}
}

//============================================================================
CntFolderList * CntVIMBBoardBoxNodeImp::LoadBBoardList()
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	DirEntry aPOPath(ITEMSET_VALUE(m_rBBoardBoxNode.GetParent(),
								   CntStringItem, WID_VIM_POPATH));

	// First, try to load a list stored in a file whose name is
	// CNT_VIM_BBOARDLIST_FILENAME in the Office's cache directory:
	DirEntry aFile(CNT_RNM()->GetCacheDirectory());
	aFile += DirEntry(String::CreateFromAscii(
		                  RTL_CONSTASCII_STRINGPARAM(
							  CNT_VIM_BBOARDLIST_FILENAME)));
	CntFolderList * pList = CntVIMMailbox::parseBBoardList(aFile.GetFull(),
														   aPOPath);

	if (!pList)
	{
		// Next, try to load a list stored in a file whose name is
		// CNT_VIM_BBOARDLIST_FILENAME in the directory specified by the VIM
		// box node's WID_VIM_POPATH:
		aFile = aPOPath;
		aFile += DirEntry(String::CreateFromAscii(
			                  RTL_CONSTASCII_STRINGPARAM(
								  CNT_VIM_BBOARDLIST_FILENAME)));
		pList = CntVIMMailbox::parseBBoardList(aFile.GetFull(), aPOPath);
	}

	return pList;
}

//============================================================================
void CntVIMBBoardBoxNodeImp::SupplyBBoardList(CntNodeJob * pJob)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	CntFolderList * pList = 0;
	sal_Bool bSubscribedOnly = SAL_STATIC_CAST(const CntFolderListItem *,
											   pJob->GetRequest())->
	                             getCommand()
	                            == CntFolderListItem::GET_SUBSCRIBED;

	if (ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item,
					  WID_VIM_BBOARDLISTPRESENT))
	{
		// Use list already present in directory storage:
		CntStorageNode * pDirectory = pJob->GetDirectoryNode();
		if (pDirectory)
		{
			CntStorageNode * pViewData = pJob->GetViewDataNode();
			pList = new CntFolderList;
			CntStorageIterator aIterator;
			for (;;)
			{
				String aQuotedName(pDirectory->iter(aIterator));
				if (aQuotedName.Len() == 0)
					break;

				UINT32 nAttrib;
				if (pDirectory->attrib(aQuotedName, 0, 0, nAttrib)
					 == ERRCODE_NONE
					&& !(nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE))
				{
					CntFolderEntry * pEntry
						= new CntFolderEntry(
							      INetURLObject::decode(
									  aQuotedName, '=',
									  INetURLObject::DECODE_WITH_CHARSET));
					sal_Bool bSubscribed
					 = pViewData
					   && !pViewData->attrib(aQuotedName, 0, 0, nAttrib)
					   && nAttrib & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED;
					if (bSubscribed || !bSubscribedOnly)
					{
						USHORT nFlags = bSubscribed ? CNTFOLDER_SUBSCR : 0;
						UINT32 nDirectoryAttrib;
						if (pDirectory->attrib(aQuotedName, 0, 0,
											   nDirectoryAttrib)
							 == ERRCODE_NONE)
							if (nDirectoryAttrib & CNTDIRENTRY_ATTRIB_VIM_NEW)
							{
								DBG_ASSERT
								 (!(nDirectoryAttrib
									 & CNTDIRENTRY_ATTRIB_VIM_REMOVED),
								  "BBoard both new and removed");
								nFlags |= CNTFOLDER_NEW;
							}
							else if (nDirectoryAttrib
									  & CNTDIRENTRY_ATTRIB_VIM_REMOVED)
								nFlags |= CNTFOLDER_REMOVED;
						pEntry->SetFlags(nFlags);
						pList->Insert(pEntry);
					}
				}
			}
		}
	}
	else
	{
		pList = LoadBBoardList();
		if (pList)
		{
			// Remember that list is now present:
			CntUInt32Item aPresent(WID_VIM_BBOARDLISTPRESENT, TRUE);
			CntStorageNode * pDirectory = pJob->GetDirectoryNode();
			CntStoreItemSetRef
			 xDirectorySet(OpenDirectoryItemSet(pDirectory));
			if (xDirectorySet.Is())
			{
				xDirectorySet->Put(aPresent);
				xDirectorySet = 0;
			}
			m_rBBoardBoxNode.Put(aPresent);

			// Put list entries into directory storage and update bboard box's
			// counts and seen flag:
			for (ULONG i = pList->Count(); i > 0;)
			{
				CntFolderEntry * pEntry = pList->GetObject(i - 1);
				pDirectory->
					attrib(INetURLObject::encode(*pEntry,
												 INetURLObject::PART_VIM, '=',
												 INetURLObject::ENCODE_ALL),
						   0, CNTDIRENTRY_ATTRIB_CREATE);
				UpdateBBoardCounts(pJob, INCREMENT, TRUE, FALSE, FALSE,
								   FALSE);

				if (bSubscribedOnly && !pEntry->IsSubscribed())
					delete pList->Remove(i - 1);
				else
				{
					pEntry->SetFlags(CNTFOLDER_NEW);
					--i;
				}
			}
		}
		else
		{
			DirEntry aFile(CNT_RNM()->GetCacheDirectory());
			aFile += DirEntry(String::CreateFromAscii(
				                  RTL_CONSTASCII_STRINGPARAM(
									  CNT_VIM_BBOARDLIST_FILENAME)));
			String aArg(aFile.GetFull());
			aArg.AppendAscii(RTL_CONSTASCII_STRINGPARAM(", "));
			aFile = ITEMSET_VALUE(m_rBBoardBoxNode.GetParent(), CntStringItem,
								  WID_VIM_POPATH);
			aFile += DirEntry(String::CreateFromAscii(
				                  RTL_CONSTASCII_STRINGPARAM(
									  CNT_VIM_BBOARDLIST_FILENAME)));
			aArg += aFile.GetFull();
			pJob->SetError(*new StringErrorInfo
						         (ERRCODE_CHAOS_NO_VIM_BBOARDLIST, aArg));
		}
	}

	m_rBBoardBoxNode.Put(CntFolderListItem(WID_NEWS_GROUPLIST,
										   pList ? pList :
										           new CntFolderList));
	pJob->Done();
}

//============================================================================
void CntVIMBBoardBoxNodeImp::UpdateBBoardList(CntFolderList * pList,
											  CntNodeJob * pJob)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	CntFolderViewMode eViewMode
	 = CntFolderViewMode(ITEMSET_VALUE(pJob->GetClient(),
									   CntFolderViewModeItem,
									   WID_FOLDERVIEW_MODE));
	CntStorageNode * pDirectory = pJob->GetDirectoryNode();
	CntStorageNode * pViewData = pJob->GetViewDataNode();
	CntAnchor * pAnchor = PTR_CAST(CntAnchor, pJob->GetClient());
	String aBBoardBoxURL(OWN_URL(&m_rBBoardBoxNode));
	if (aBBoardBoxURL.GetChar(aBBoardBoxURL.Len() - 1) != '/')
		aBBoardBoxURL += '/';

	ULONG nCount = pList->Count();
	for (ULONG i = nCount; i > 0;)
	{
		CntFolderEntry * pBBoard = pList->Remove(--i);

		String aQuotedName(INetURLObject::encode(*pBBoard,
												 INetURLObject::PART_VIM, '=',
												 INetURLObject::ENCODE_ALL));

		USHORT nFlags = pBBoard->GetFlags();
		DBG_ASSERT((nFlags & (CNTFOLDER_NEW | CNTFOLDER_REMOVED))
				    != (CNTFOLDER_NEW | CNTFOLDER_REMOVED),
				   "BBoard both new and removed");

		// Process bboards that have changed from unsubscribed to subscribed
		// or vice versa:
		UINT32 nAttrib;
		ErrCode nError = pViewData->attrib(aQuotedName, 0, 0, nAttrib);
		if (nFlags & CNTFOLDER_SUBSCR)
		{
			if (!nError && !(nAttrib & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED)
				|| nError == ERRCODE_IO_NOTEXISTS)
			{
				// Get the bboard node, initialize it, and get its seen
				// status:
				String aBBoardURL(aBBoardBoxURL);
				aBBoardURL += aQuotedName;
				aBBoardURL += '/';
				CntNodeRef xBBoardNode(m_rBBoardBoxNode.Query(aBBoardURL));
				if (xBBoardNode.Is())
				{
					xBBoardNode->Put(CntStringItem(WID_TITLE, *pBBoard));
					lcl_insertChildJob(*pJob, *xBBoardNode,
									   SfxVoidItem(WID_GETDATA));
					BOOL bSeen
					 = ITEMSET_VALUE(xBBoardNode, CntBoolItem, WID_IS_READ);

					// Update the bboard box's data:
					pViewData->attrib(aQuotedName, 0,
									  CNTDIRENTRY_ATTRIB_CREATE
									   | CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED);
					UpdateBBoardCounts(pJob, STAY, bSeen, bSeen, TRUE, FALSE);

					if (eViewMode != CNT_VIEW_ACTIVE_FOLDERS || !bSeen)
					{
						// Search for an anchor for the bboard, and if one is
						// found, put the new WID_FLAG_SUBSCRIBED value into
						// it:
						if (pAnchor)
						{
							ULONG nCount = pAnchor->SubAnchorCount();
							for (ULONG i = 0; i < nCount; ++i)
							{
								CntAnchor * pSubAnchor = (*pAnchor)[i];
								if (pSubAnchor->
									  GetNode()->GetMostReferedNode()
									 == &xBBoardNode)
								{
									pJob->GetViewDataTarget(pSubAnchor)->
									 CntInterface::Put(CntBoolItem
													    (WID_FLAG_SUBSCRIBED,
														 TRUE),
													   WID_FLAG_SUBSCRIBED);
									break;
								}
							}
						}

						// If only (some of the) subscribed bboard's are
						// shown, it might be necessary to insert the bboard
						// now---if all bboard's are shown, the bboard is
						// already inserted, anyway:
						if (eViewMode == CNT_VIEW_SUBSCRIBED_FOLDERS
							|| eViewMode == CNT_VIEW_ACTIVE_FOLDERS && !bSeen)
							pJob->Result(xBBoardNode, CNT_ACTION_INSERTED);
					}
				}
			}
		}
		else if (nError == ERRCODE_NONE
				 && nAttrib & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED)
		{
			// Get the bboard node, initialize it, and get its seen status:
			String aBBoardURL(aBBoardBoxURL);
			aBBoardURL += aQuotedName;
			aBBoardURL += '/';
			CntNodeRef xBBoardNode(m_rBBoardBoxNode.Query(aBBoardURL));
			if (xBBoardNode.Is())
			{
				xBBoardNode->Put(CntStringItem(WID_TITLE, *pBBoard));
				lcl_insertChildJob(*pJob, *xBBoardNode,
								   SfxVoidItem(WID_GETDATA));
				BOOL bSeen
				 = ITEMSET_VALUE(xBBoardNode, CntBoolItem, WID_IS_READ);

				// Update the bboard box's data:
				if (nAttrib & ~(CNTDIRENTRY_ATTRIB_CREATE
								 | CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED))
					pViewData->attrib(aQuotedName,
									  CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED, 0);
				else
					pViewData->remove(aQuotedName);
				UpdateBBoardCounts(pJob, STAY, bSeen, bSeen, FALSE, TRUE);

				if (eViewMode == CNT_VIEW_ALL_FOLDERS)
				{
					// Search for an anchor for the bboard, and if one is
					// found, the new WID_FLAG_SUBSCRIBED value is put into
					// it:
					if (pAnchor)
					{
						ULONG nCount = pAnchor->SubAnchorCount();
						for (ULONG i = 0; i < nCount; ++i)
						{
							CntAnchor * pSubAnchor = (*pAnchor)[i];
							if (pSubAnchor->GetNode()->GetMostReferedNode()
								 == &xBBoardNode)
							{
								pJob->GetViewDataTarget(pSubAnchor)->
								 CntInterface::Put(CntBoolItem
												    (WID_FLAG_SUBSCRIBED,
													 FALSE),
												   WID_FLAG_SUBSCRIBED);
								break;
							}
						}
					}
				}
				else
					// If only (some of the) subscribed bboard's are shown, it
					// might be necessary to remove the bboard now:
					pJob->Result(xBBoardNode, CNT_ACTION_REMOVED);
			}
		}

		// Check if the bboards 'new' flag has been reset:
		if (!(nFlags & CNTFOLDER_NEW))
			pDirectory->attrib(aQuotedName, CNTDIRENTRY_ATTRIB_VIM_NEW, 0);

		delete pBBoard;
	}
	delete pList;
}

//============================================================================
void CntVIMBBoardBoxNodeImp::Open(CntNodeJob * pJob)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	ThreadTask * pTask = static_cast< ThreadTask * >(pJob->GetRequestData());
	if (!pTask)
		pTask = new CntVIMBboxOpenTask_Impl(*pJob, m_rBBoardBoxNode, *this);
	pTask->run();
}

//============================================================================
void CntVIMBBoardBoxNodeImp::FlagRead(CntNodeJob * pJob)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	ThreadTask * pTask = static_cast< ThreadTask * >(pJob->GetRequestData());
	if (!pTask)
		pTask = new CntVIMBboxReadTask_Impl(*pJob, m_rBBoardBoxNode, *this);
	pTask->run();
}

//============================================================================
void CntVIMBBoardBoxNodeImp::ViewModeChange(CntNodeJob * pJob)
{
	DBG_ASSERT(m_bInitialized, "VIM bulletin board box node not initialized");

	// Update anchor's WID_IS_READ according to the new view mode:
	CntStorageNode * pViewData = pJob->GetViewDataNode();
	BOOL bSeen;
	if (!pViewData
		|| ITEM_VALUE(CntFolderViewModeItem, *pJob->GetRequest())
		    == CNT_VIEW_ALL_FOLDERS)
		bSeen = ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item,
							  WID_TOTALCONTENTCOUNT)
			     == ITEMSET_VALUE(&m_rBBoardBoxNode, CntUInt32Item,
								  WID_SEENCONTENTCOUNT);
	else
	{
		CntStoreItemSetRef xViewDataSet(OpenViewDataItemSet(pViewData));
		bSeen = xViewDataSet.Is()
		        && ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
								 WID_SUBSCRNEWSGROUPCOUNT)
		            == ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
									 WID_VIM_SUBSCRSEENCONTENTCOUNT);
	}
	CntInterface * pClient = pJob->GetClient();
	if (bSeen != ITEMSET_VALUE(pJob->GetClient(), CntBoolItem, WID_IS_READ))
		pJob->GetViewDataTarget()->CntInterface::Put(CntBoolItem(WID_IS_READ,
																 bSeen),
													 WID_IS_READ);
}

//============================================================================
void CntVIMBBoardBoxNodeImp::changeMsgStoreMode(CntNodeJob & rJob)
{
	DBG_ASSERT(m_bInitialized,
			   "CntVIMBBoardBoxNodeImp::changeMsgStoreMode(): Not init");

	for (ULONG i = 0; i < m_rBBoardBoxNode.SubNodeCount(); ++i)
		INSECURE_DYNAMIC_CAST(CntVIMBBoardNode *,
							  m_rBBoardBoxNode.GetSubNode(i))->
		 getImplementation().changeMsgStoreMode(rJob);
}

//============================================================================
//
//  class CntVIMMesgOpenTask_Impl
//
//============================================================================

// virtual
const SfxPoolItem * CntVIMMesgOpenTask_Impl::execute()
{
	BOOL bCacheBody;
	if (m_rCntr.DoCacheMessageBodies())
	{
		UINT16 nLimit = m_rCntr.GetMessageExpirationLimit();
		bCacheBody = !nLimit
		             || Date(((const SfxDateTimeItem &)
							   m_pMsgNode->Get(WID_DATE_CREATED)).
							  GetDateTime().GetDate())
		                 >= Date() - nLimit;
	}
	else
		bCacheBody = FALSE;

	// Look for a message body in the message node's item set:
	const SfxPoolItem * pItem;
	if (m_pMsgNode->GetItemState(WID_MESSAGEBODY, FALSE, &pItem)
		 == SFX_ITEM_SET)
	{
		const CntMessageBodyItem * pBodyItem = PTR_CAST(CntMessageBodyItem,
														pItem);
		if (pBodyItem)
		{
			// If message bodys shall be kept locally, but this one isn't
			// (because the user switched from not keeping locally to keeping
			// locally or increased the time limit for storing messages after
			// the last visit to this body), cache it now:
			if (bCacheBody)
			{
				CntStorageNode * pCache = getJob().GetCacheNode();
				if (pCache)
				{
					String aBodyName(OWN_URL(m_pMsgNode));
					aBodyName.AppendAscii(RTL_CONSTASCII_STRINGPARAM(
						                      CNT_VIM_MESG_BODY_ID_SUFFIX));
					SvStream * pStream
					 = pCache->openStream(aBodyName, STREAM_STD_READ);
					if (pStream)
						delete pStream;
					else
						CONST_CAST(CntMessageBodyItem *, pBodyItem)->
						 Set(pBodyItem->Get(), pCache);
				}
			}

			done();
			return 0;
		}
	}

	m_bWaiting = m_rCntr.createMessageBodyItem(getJob(), 0, m_pMsgNode,
											   bCacheBody, TRUE);
	if (m_bWaiting)
		reschedule();
	else
		done();
	return 0;
}

//============================================================================
// virtual
void CntVIMMesgOpenTask_Impl::finished(bool bCanceled)
{
	if (bCanceled)
	{
		if (m_bWaiting && m_rCntr.GetContainer())
			m_rCntr.GetContainer()->cancelExecution();
	}
}

//============================================================================
//
//  class CntVIMBboxOpenTask_Impl
//
//============================================================================

void CntVIMBboxOpenTask_Impl::clearProgress()
{
	switch (m_eProgress)
	{
		case PROGRESS_TEXT:
			getJob().Broadcast(CntStatusBarHint(String()));
			break;

		case PROGRESS_VALUE:
			getJob().Broadcast(CntStatusBarHint(nHintID));
			break;
	}
	m_eProgress = PROGRESS_NONE;
}

//============================================================================
// virtual
const SfxPoolItem * CntVIMBboxOpenTask_Impl::execute()
{
	if (!m_bInitialized)
	{
		nWhich = getJob().GetRequest()->Which();

		BOOL bObeyFolderViewRestrictions = TRUE;
		if (nWhich == WID_UPDATE)
		{
			// If this is a WID_UPDATE job that is a child job of a 'blinker
			// driven' WID_UPDATE at the VIM box node, and if this node's
			// update parameters differ from the VIM box one's, ignore the
			// job:
			if (getJob().GetParent() && getJob().GetRequest()->ISA(CntUpdateItem)
				&& (getJob().GetParent()->GetClient()->Get(WID_UPDATE_ENABLED)
					 != getJob().GetClient()->Get(WID_UPDATE_ENABLED)
					|| getJob().GetParent()->
					     GetClient()->Get(WID_AUTOUPDATE_INTERVAL)
					    != getJob().GetClient()->Get(WID_AUTOUPDATE_INTERVAL)))
			{
				done();
				return 0;
			}
		}
		else if (nWhich == WID_SEARCH)
		{
			const CntSearchDataItem * pSearchDataItem
			 = PTR_CAST(CntSearchDataItem, getJob().GetRequest());
			if (pSearchDataItem)
			{
				pSearchData = &pSearchDataItem->GetValue();
				if (pSearchData->DoSearchBase()
					&& pSearchData->Matches(rBBoardBoxNode,
											CntRootNodeMgr::GetIniManager()->
											 getInternational()))
					getJob().ResultSearchMatch(&rBBoardBoxNode,
											 CNT_SEARCH_MATCH_YES, TRUE);
				if (!pSearchData->DoSearchFirstLevel())
				{
					done();
					return 0;
				}

				bObeyFolderViewRestrictions
				 = pSearchData->DoObeyFolderViewRestrictions();
			}
			else
			{
				done();
				return 0;
			}
		}

		pDirectory = getJob().GetDirectoryNode();
		pViewData = bObeyFolderViewRestrictions ?
		             getJob().GetViewDataNode() : 0;
		bViewAll = !pViewData
		           || ITEMSET_VALUE(getJob().GetClient(), CntFolderViewModeItem,
									WID_FOLDERVIEW_MODE)
		               == CNT_VIEW_ALL_FOLDERS;

		// Get online status:
		CntVIMNode * pVIMNode
		 = INSECURE_DYNAMIC_CAST(CntVIMNode *, rBBoardBoxNode.GetParent());
		bOnline
		 = (nWhich != WID_OPEN && nWhich != WID_SEARCH
			|| pVIMNode->getImplementation().getUpdateOnOpenMode(getJob()))
		   && pVIMNode->
		        getImplementation().CheckOnline(nWhich == WID_UPDATE
												|| nWhich == WID_SYNCHRONIZE,
												&getJob())
		       == CntVIMNodeImp::ONLINE_YES;
		if (getJob().IsCancelled())
			return 0;

		// For WID_OPEN or WID_SEARCH in online mode, if no list of available
		// bulletin boards is yet present, create one; for WID_UPDATE and
		// WID_SYNCHRONIZE, get a new list of available bulletin boards,
		// anyway:
		bNoListYet = bOnline
		             && !ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
									   WID_VIM_BBOARDLISTPRESENT);
		if (bNoListYet || nWhich == WID_UPDATE || nWhich == WID_SYNCHRONIZE)
		{
			m_pList = rBBoardBoxNodeImp.LoadBBoardList();

			// If not list is yet present and the user chose not to specify
			// one, do nothing:
			if (!m_pList && bNoListYet)
			{
				done();
				return 0;
			}
		}

		aBBoardBoxURL = OWN_URL(&rBBoardBoxNode);
		if (aBBoardBoxURL.GetChar(aBBoardBoxURL.Len() - 1) != '/')
			aBBoardBoxURL += '/';
		nTotalCount = ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
									WID_TOTALCONTENTCOUNT);

		// Start processing of already known bboards:
		if (bNoListYet)
			bStartSecondPhase = TRUE;
		else
		{
			if (bViewAll
				|| (nWhich == WID_UPDATE || nWhich == WID_SYNCHRONIZE)
				   && m_pList)
			{
				pIterStorage = pDirectory;
				nMaxProcess = ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
											WID_TOTALCONTENTCOUNT);
			}
			else
			{
				pIterStorage = pViewData;
				CntStoreItemSetRef
				 xViewDataSet(CntVIMBBoardBoxNodeImp::OpenViewDataItemSet
							   (pViewData));
				nMaxProcess
				 = xViewDataSet.Is() ?
					ITEMSET_VALUE(&xViewDataSet, CntUInt32Item,
								  WID_SUBSCRNEWSGROUPCOUNT) :
					0;
			}
			if (nMaxProcess)
			{
				m_eProgress = PROGRESS_VALUE;
				nHintID = CntStatusBarHint::CreateHintId();
				getJob().
				 Broadcast
				  (CntStatusBarHint(nHintID, 0, nMaxProcess,
									CntResId(RID_NEWS_LOADING_NEWSGROUPS)));
				nProcessed = 0;
			}
			else
			{
				m_eProgress = PROGRESS_TEXT;
				getJob().
				 Broadcast
				  (CntStatusBarHint(CntResId(RID_NEWS_LOADING_NEWSGROUPS)));
			}
			m_pIterator = new CntStorageIterator();
		}

		bCanceledChildren = FALSE;

		m_bInitialized = TRUE;
	}

	// Process any bboards already known:
	if (m_pIterator)
	{
		startTimeSlice();
		for (;;)
		{
			// Cancel whole WID_UPDATE or WID_SYNCHRONIZE job if any child job
			// has been canceled:
			if (bCanceledChildren && nWhich != WID_OPEN)
			{
				cancel();
				return 0;
			}

			// Process only one child job per time:
			if (getJob().ChildJobCount())
			{
				reschedule();
				return 0;
			}

			String aQuotedName(pIterStorage->iter(*m_pIterator));
			if (aQuotedName.Len() == 0)
				break;

			String aName(INetURLObject::decode(
				             aQuotedName, '=',
							 INetURLObject::DECODE_WITH_CHARSET));
			UINT32 nAttrib;
			if (bViewAll
				|| pViewData->attrib(aQuotedName, 0, 0, nAttrib)
				    == ERRCODE_NONE
				   && nAttrib & CNTDIRENTRY_ATTRIB_VIM_SUBSCRIBED)
			{
				String aBBoardURL(aBBoardBoxURL);
				aBBoardURL += aQuotedName;
				aBBoardURL += '/';
				CntNodeRef xBBoardNode(rBBoardBoxNode.Query(aBBoardURL));
				if (xBBoardNode.Is())
				{
					xBBoardNode->Put(CntStringItem(WID_TITLE, aName));
					if (nWhich == WID_OPEN)
						getJob().Result(xBBoardNode, CNT_ACTION_INSERTED);

					if (!bCanceledChildren)
						switch (nWhich)
						{
							case WID_OPEN:
								if (bOnline)
									lcl_insertChildJob
									 (getJob(), *xBBoardNode,
									  SfxVoidItem(WID_UPDATE), this);
								break;

							case WID_UPDATE:
							case WID_SYNCHRONIZE:
								lcl_insertChildJob(getJob(), *xBBoardNode,
												   *getJob().GetRequest(),
												   this);
								break;

							case WID_SEARCH:
								lcl_insertChildJob
								 (getJob(), *xBBoardNode,
								  CntSearchDataItem
								   (WID_SEARCH,
									CntSearchData(*pSearchData, TRUE)),
								  this);
								break;
						}
				}
			}

			if (m_eProgress == PROGRESS_VALUE)
				getJob().Broadcast(CntStatusBarHint(nHintID, ++nProcessed));

			if (m_pList)
			{
				ULONG nPos;
				if (m_pList->find(aName, String(), nPos))
					m_pList->Remove(nPos);
				else
				{
					DBG_ASSERT(!bNoListYet, "Inconsistent bboard list");
					UINT32 nAttrib;
					if (nWhich == WID_SYNCHRONIZE
						&& pDirectory->attrib(aQuotedName, 0, 0, nAttrib)
						    == ERRCODE_NONE
						&& !(nAttrib & CNTDIRENTRY_ATTRIB_VIM_REMOVED))
					{
						pDirectory->attrib(aQuotedName,
										   CNTDIRENTRY_ATTRIB_VIM_NEW,
										   CNTDIRENTRY_ATTRIB_VIM_REMOVED);
						getJob().
						 Broadcast(CntFolderStateHint(1, CNTFOLDER_REMOVED));
					}
				}
			}

			if (checkTimeSliceExhausted())
			{
				reschedule();
				return 0;
			}
		}

		delete m_pIterator;
		m_pIterator = 0;
		bStartSecondPhase = TRUE;
		clearProgress();
	}

	// Start creation of any bboards left in the new list:
	if (bStartSecondPhase)
	{
		if (m_pList)
		{
			nMaxProcess = m_pList->Count();
			if (nMaxProcess == 0)
			{
				delete m_pList;
				m_pList = 0;
			}
			else
			{
				m_eProgress = PROGRESS_VALUE;
				nHintID = CntStatusBarHint::CreateHintId();
				getJob().
				 Broadcast
				  (CntStatusBarHint(nHintID, 0, nMaxProcess,
									CntResId(RID_PROT_INSERTING_NEWSGROUPS)));
				nProcessed = 0;
			}
		}
		bStartSecondPhase = FALSE;
	}

	// Create any bboards left in the new list:
	if (m_pList)
	{
		startTimeSlice();
		while (nProcessed < nMaxProcess)
		{
			// Cancel whole job if any child job has been canceled:
			if (bCanceledChildren && nWhich != WID_OPEN)
			{
				cancel();
				return 0;
			}

			// Process only one child job per time:
			if (getJob().ChildJobCount())
			{
				reschedule();
				return 0;
			}

			++nProcessed;

			CntFolderEntry * pBBoard
			 = m_pList->Remove(nMaxProcess - nProcessed);

			// Insert new bboards and update bboard box's counts and seen
			// flag:
			String
				aQuotedName(INetURLObject::encode(*pBBoard,
												  INetURLObject::PART_VIM,
												  '=',
												  INetURLObject::ENCODE_ALL));
			pDirectory->attrib(aQuotedName, 0,
							   bNoListYet ?
							    CNTDIRENTRY_ATTRIB_CREATE :
							    CNTDIRENTRY_ATTRIB_CREATE
							     | CNTDIRENTRY_ATTRIB_VIM_NEW);
			if (!bNoListYet)
				getJob().Broadcast(CntFolderStateHint(1, CNTFOLDER_NEW));

			rBBoardBoxNodeImp.
			 UpdateBBoardCounts(&getJob(), CntVIMBBoardBoxNodeImp::INCREMENT,
								TRUE, FALSE, FALSE, FALSE);

			if (bViewAll)
			{
				// Create the bboard node (WID_TITLE must be set very early
				// for proper sorting in the explorer) and keep a reference on
				// it so that after resulting the node it is still available:
				String aBBoardURL(aBBoardBoxURL);
				aBBoardURL += aQuotedName;
				aBBoardURL += '/';
				CntNodeRef xBBoardNode(rBBoardBoxNode.Query(aBBoardURL));
				if (xBBoardNode.Is())
				{
					xBBoardNode->Put(CntStringItem(WID_TITLE, *pBBoard));
					getJob().Result(xBBoardNode, CNT_ACTION_INSERTED);

					if (!bCanceledChildren)
						switch (nWhich)
						{
							case WID_OPEN:
								if (bOnline)
									lcl_insertChildJob
									 (getJob(), *xBBoardNode,
									  SfxVoidItem(WID_UPDATE), this);
								break;

							case WID_UPDATE:
							case WID_SYNCHRONIZE:
								lcl_insertChildJob(getJob(), *xBBoardNode,
												   *getJob().GetRequest(),
												   this);
								break;

							case WID_SEARCH:
								lcl_insertChildJob
								 (getJob(), *xBBoardNode,
								  CntSearchDataItem
								   (WID_SEARCH,
									CntSearchData(*pSearchData, TRUE)),
								  this);
								break;
						}
				}
			}

			getJob().Broadcast(CntStatusBarHint(nHintID, nProcessed));
			if (checkTimeSliceExhausted())
			{
				reschedule();
				return 0;
			}
		}

		if (bNoListYet)
		{
			// Remember that list is now present:
			CntUInt32Item aPresent(WID_VIM_BBOARDLISTPRESENT, TRUE);
			CntStoreItemSetRef
			 xDirectorySet(rBBoardBoxNodeImp.
						    OpenDirectoryItemSet(pDirectory));
			if (xDirectorySet.Is())
			{
				xDirectorySet->Put(aPresent);
				xDirectorySet = 0;
			}
			rBBoardBoxNode.Put(aPresent);
		}
		delete m_pList;
		m_pList = 0;
		clearProgress();
	}

	done();
	return 0;
}

//============================================================================
// virtual
void CntVIMBboxOpenTask_Impl::notification(SfxBroadcaster & rBroadcaster,
										   const SfxHint & rHint)
{
	CntNodeJob * pSubJob = PTR_CAST(CntNodeJob, &rBroadcaster);
	if (pSubJob && pSubJob->GetParent() == &getJob())
	{
		if (rHint.ISA(CntStatusHint))
		{
			if (STATIC_CAST(const CntStatusHint *, &rHint)->GetStatus()
				    == CNT_STATUS_ERROR
				&& STATIC_CAST(const CntStatusHint *, &rHint)->GetError()
				       == ERRCODE_ABORT)
			{
				EndListening(*pSubJob);
				bCanceledChildren = TRUE;
			}
		}
		else if (rHint.ISA(CntVIMStatusHint))
		{
			EndListening(*pSubJob);
			if (!bCanceledChildren)
			{
				bCanceledChildren = TRUE;
				while (getJob().ChildJobCount())
					getJob().GetChildJob(0)->Cancel();
			}
		}
		return;
	}
}

//============================================================================
// virtual
void CntVIMBboxOpenTask_Impl::finished(bool bCanceled)
{
	if (bCanceled)
	{
		delete m_pIterator;

		if (m_bInitialized && bNoListYet)
		{
			ULONG nCount = m_pList->Count();
			if (nCount > 0)
			{
				// Put remaining list entries into directory storage and
				// update bboard box's counts and seen flag:
				for (ULONG i = nCount; i > 0;)
				{
					CntFolderEntry * pBBoard = m_pList->Remove(--i);

					pDirectory->attrib(INetURLObject::encode(
						                   *pBBoard, INetURLObject::PART_VIM,
										   '=', INetURLObject::ENCODE_ALL),
									   0, CNTDIRENTRY_ATTRIB_CREATE);
					rBBoardBoxNodeImp.
						UpdateBBoardCounts(&getJob(),
										   CntVIMBBoardBoxNodeImp::INCREMENT,
										   TRUE, FALSE, FALSE, FALSE);
					delete pBBoard;
				}

				// Increase WID_TOTALCONTENTCOUNT:
				CntUInt32Item aTotalItem(WID_TOTALCONTENTCOUNT,
										 nTotalCount + nCount);
				CntStoreItemSetRef
					xDirectorySet(rBBoardBoxNodeImp.
								      OpenDirectoryItemSet(pDirectory));
				if (xDirectorySet.Is())
				{
					xDirectorySet->Put(aTotalItem);
					xDirectorySet = 0;
				}
				rBBoardBoxNode.Put(aTotalItem);
			}

			// Remember that list is now present:
			CntUInt32Item aPresent(WID_VIM_BBOARDLISTPRESENT, TRUE);
			CntStoreItemSetRef
				xDirectorySet(rBBoardBoxNodeImp.
							      OpenDirectoryItemSet(pDirectory));
			if (xDirectorySet.Is())
			{
				xDirectorySet->Put(aPresent);
				xDirectorySet = 0;
			}
			rBBoardBoxNode.Put(aPresent);
		}
		delete m_pList;
		clearProgress();
	}
}

//============================================================================
//
//  class CntVIMBboxReadTask_Impl
//
//============================================================================

// virtual
const SfxPoolItem * CntVIMBboxReadTask_Impl::execute()
{
	if (!m_bInitialized)
	{
		pRequest = (const CntBoolItem *) getJob().GetRequest();

		pDirectory = getJob().GetDirectoryNode();
		pViewData = getJob().GetViewDataNode();

		// Determine view mode:
		bViewAll = !pViewData
		           || ITEMSET_VALUE(getJob().GetClient(), CntFolderViewModeItem,
									WID_FOLDERVIEW_MODE)
		               == CNT_VIEW_ALL_FOLDERS;

		// Check if request is already satisfied:
		UINT32 nSeenCount;
		if (bViewAll)
		{
			nMaxProcess = ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
										WID_TOTALCONTENTCOUNT);
			nSeenCount = ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
									   WID_SEENCONTENTCOUNT);
		}
		else
		{
			CntStoreItemSetRef
			 xViewDataSet(CntVIMBBoardBoxNodeImp::OpenViewDataItemSet
						   (pViewData));
			nMaxProcess = xViewDataSet.Is() ?
			               ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
										 WID_SUBSCRNEWSGROUPCOUNT) :
			               0;
			nSeenCount = xViewDataSet.Is() ?
			              ITEMSET_VALUE(xViewDataSet, CntUInt32Item,
										WID_VIM_SUBSCRSEENCONTENTCOUNT) :
			              0;
		}
		if (nSeenCount == (pRequest->GetValue() ? nMaxProcess : 0))
		{
			if (pRequest->GetValue())
				getJob().GetViewDataTarget()->CntInterface::Put(*pRequest,
															  WID_IS_READ);
			done();
			return 0;
		}
		if (nMaxProcess < nSeenCount) // corrupted storage...
			nMaxProcess = nSeenCount;

		// Start progress bar:
		m_nHintID = CntStatusBarHint::CreateHintId();
		getJob().
		 Broadcast(CntStatusBarHint(m_nHintID, 0, nMaxProcess,
									CntResId(pRequest->GetValue() ?
											  RID_PROT_READING_MESSAGES :
											  RID_PROT_UNREADING_MESSAGES)));
		nProcessed = 0;

		// Get bboard box URL:
		aBBoardBoxURL = OWN_URL(&rBBoardBoxNode);
		if (aBBoardBoxURL.GetChar(aBBoardBoxURL.Len() - 1) != '/')
			aBBoardBoxURL += '/';

		pIterStorage = bViewAll ? pDirectory : pViewData;
		m_pIterator = new CntStorageIterator();

		bCanceledChildren = FALSE;

		m_bInitialized = TRUE;
	}

	startTimeSlice();
	for (;;)
	{
		// Cancel whole job if any child job has been canceled:
		if (bCanceledChildren)
		{
			cancel();
			return 0;
		}

		String aQuotedName(pIterStorage->iter(*m_pIterator));
		if (aQuotedName.Len() == 0)
			break;

		// Ignore any bboards that are marked for deletion:
		UINT32 nAttrib;
		if (pIterStorage->attrib(aQuotedName, 0, 0, nAttrib) == ERRCODE_NONE
			&& !(nAttrib & CNTDIRENTRY_ATTRIB_MARKEDFORDELETE))
		{
			String aBBoardURL(aBBoardBoxURL);
			aBBoardURL += aQuotedName;
			aBBoardURL += '/';
			CntNodeRef xBBoardNode(rBBoardBoxNode.Query(aBBoardURL));
			if (xBBoardNode.Is())
				lcl_insertChildJob(getJob(), *xBBoardNode, *pRequest, this);

			getJob().Broadcast(CntStatusBarHint(m_nHintID, ++nProcessed));
		}

		if (checkTimeSliceExhausted())
		{
			reschedule();
			return 0;
		}
	}
	delete m_pIterator;
	m_pIterator = 0;

	// This is a good place to correct WID_TOTALCONTENTCOUNT or
	// WID_SUBSCRNEWSGROUPCOUNT that is possibly wrong due to corrupted
	// storages; WID_SEENCONTENTCOUNT or WID_VIM_SUBSCRSEENCONTENTCOUNT and
	// the bboard box client's WID_IS_READ can only be set to definite values
	// if the job's request is to flag the bboards as read, because if the
	// bboard box contains only bboards that have no messages, flagging the
	// bboard box as unread will not succeed:
	if (nMaxProcess != nProcessed)
	{
		if (bViewAll)
		{
			CntUInt32Item aTotalItem(WID_TOTALCONTENTCOUNT, nProcessed);
			CntStoreItemSetRef
			 xDirectorySet(rBBoardBoxNodeImp.
						    OpenDirectoryItemSet(pDirectory));
			if (xDirectorySet.Is())
			{
				xDirectorySet->Put(aTotalItem);
				xDirectorySet = 0;
			}
			rBBoardBoxNode.Put(aTotalItem);
		}
		else
		{
			CntUInt32Item aSubscribedItem(WID_SUBSCRNEWSGROUPCOUNT,
										  nProcessed);
			CntStoreItemSetRef
			 xViewDataSet(CntVIMBBoardBoxNodeImp::OpenViewDataItemSet
						   (pViewData));
			if (xViewDataSet.Is())
			{
				xViewDataSet->Put(aSubscribedItem);
				xViewDataSet = 0;
			}
			getJob().
			 GetViewDataTarget()->CntInterface::Put(aSubscribedItem,
													WID_SUBSCRNEWSGROUPCOUNT);
		}
	}
	if (pRequest->GetValue())
	{
		if (bViewAll)
		{
			UINT32 nSeenCount = ITEMSET_VALUE(&rBBoardBoxNode, CntUInt32Item,
											  WID_SEENCONTENTCOUNT);
			if (nSeenCount != nProcessed)
			{
				CntUInt32Item aSeenItem(WID_SEENCONTENTCOUNT, nProcessed);
				CntStoreItemSetRef
				 xUserDataSet(rBBoardBoxNodeImp.
							   OpenUserDataItemSet(getJob().GetUserDataNode()));
				if (xUserDataSet.Is())
				{
					xUserDataSet->Put(aSeenItem);
					xUserDataSet = 0;
				}
				rBBoardBoxNode.Put(aSeenItem);
			}
		}
		else
		{
			CntStoreItemSetRef
			 xViewDataSet(CntVIMBBoardBoxNodeImp::OpenViewDataItemSet
						   (pViewData));
			if (xViewDataSet.Is())
			{
				xViewDataSet->
				 Put(CntUInt32Item(WID_VIM_SUBSCRSEENCONTENTCOUNT,
								   nProcessed));
				xViewDataSet = 0;
			}
		}
		getJob().GetViewDataTarget()->CntInterface::Put(*pRequest, WID_IS_READ);
	}

	getJob().Broadcast(CntStatusBarHint(m_nHintID));
	done();
	return 0;
}

//============================================================================
// virtual
void CntVIMBboxReadTask_Impl::notification(SfxBroadcaster & rBroadcaster,
										   const SfxHint & rHint)
{
	CntNodeJob * pSubJob = PTR_CAST(CntNodeJob, &rBroadcaster);
	if (pSubJob && pSubJob->GetParent() == &getJob())
	{
		if (rHint.ISA(CntStatusHint))
		{
			if (STATIC_CAST(const CntStatusHint *, &rHint)->GetStatus()
				    == CNT_STATUS_ERROR
				&& STATIC_CAST(const CntStatusHint *, &rHint)->GetError()
				       == ERRCODE_ABORT)
			{
				EndListening(*pSubJob);
				bCanceledChildren = TRUE;
			}
			else if (rHint.ISA(CntVIMStatusHint))
			{
				EndListening(*pSubJob);
				if (!bCanceledChildren)
				{
					bCanceledChildren = TRUE;
					while (getJob().ChildJobCount())
						getJob().GetChildJob(0)->Cancel();
				}
			}
		}
		return;
	}
}

//============================================================================
// virtual
void CntVIMBboxReadTask_Impl::finished(bool bCanceled)
{
	if (bCanceled)
	{
		delete m_pIterator;
		if (m_nHintID)
			getJob().Broadcast(CntStatusBarHint(m_nHintID));
	}
}

