/*************************************************************************
 *
 *  $RCSfile: sflocnds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_BEANS_PROPERY_HPP_
#include <com/sun/star/beans/Property.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDPROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENT_HPP_
#include <com/sun/star/ucb/XContent.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIER_HPP_
#include <com/sun/star/ucb/XContentIdentifier.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIERFACTORY_HPP_
#include <com/sun/star/ucb/XContentIdentifierFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDER_HPP_
#include <com/sun/star/ucb/XContentProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XINTERFACE_HPP_
#include <com/sun/star/uno/XInterface.hpp>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX
#include <svtools/ctypeitm.hxx>
#endif

#ifndef _CNTJOB_HXX
#include <cntjob.hxx>
#endif
#ifndef _CNTNODE_HXX
#include <cntnode.hxx>
#endif
#ifndef _CNTPOOL_HXX
#include <cntpool.hxx>
#endif
#ifndef _CNTSRCHF_HXX
#include <cntsrchf.hxx>
#endif
#ifndef _CSTRITEM_HXX
#include <cstritem.hxx>
#endif
#ifndef CHAOS_SLSTITEM_HXX
#include <slstitem.hxx>
#endif
#ifndef _SORTITEM_HXX
#include <sortitem.hxx>
#endif
#ifndef CHAOS_THRDTASK_HXX
#include <thrdtask.hxx>
#endif
#ifndef CHAOS_UCBSRVC_HXX
#include <ucbsrvc.hxx>
#endif
#ifndef _ULSTITEM_HXX
#include <ulstitem.hxx>
#endif

namespace unnamed_chaos_sflocnds {} using namespace unnamed_chaos_sflocnds;
    // unnamed namespaces don't work well yet

using namespace chaos;
using namespace com::sun::star;

//============================================================================
namespace unnamed_chaos_sflocnds {

class OpenTask: public ThreadTask
{
	List const * m_pList;
	ULONG m_nIndex;

	virtual SfxPoolItem const * execute();

public:
	OpenTask(CntNodeJob & rJob):
		ThreadTask(rJob, *rJob.GetSubject()), m_pList(0) {}
};

//============================================================================
class SyncTask: public ThreadTask
{
	enum State { INITIALIZE, FIRST_PASS, SECOND_PASS };

	List m_aWorkList;
	List const * m_pNewList;
	ULONG m_nIndex;
	State m_eState;

	virtual SfxPoolItem const * execute();

public:
	SyncTask(CntNodeJob & rJob):
		ThreadTask(rJob, *rJob.GetSubject()), m_eState(INITIALIZE) {}

	virtual ~SyncTask();
};

//============================================================================
class LocNode: public CntNode
{
public:
	LocNode();

	TYPEINFO();

	CNT_NODE_SUBCLASS_DECL();

	virtual SfxPoolItem const * ExecuteJob(CntNodeJob * pJob);

	void copyData(String const & rLocURL);
};

//============================================================================
USHORT const aLocListNodeRanges[]
    = { WID_TO, WID_TO,
		WID_OPEN, WID_OPEN,
		WID_OWN_URL, WID_OWN_URL,
		WID_REFERED_URL, WID_FLAG_IS_FOLDER,
		WID_CREATE_NEW, WID_CREATE_NEW,
		WID_SORTING, WID_SORTING,
		WID_TOTALCONTENTCOUNT, WID_TOTALCONTENTCOUNT,
		WID_SEARCH_LOCATIONS, WID_SEARCH_LOCATIONS,
		WID_VIEW_COLS_FILEDLG, WID_VIEW_COLS_FILEDLG,
		WID_VIEW_SORT_FILEDLG, WID_VIEW_SORT_FILEDLG, 0 };

//============================================================================
USHORT const aLocNodeRanges[]
	= { WID_PRIORITY, WID_PRIORITY,
		WID_SEEN_STATUS, WID_RECIPIENTLIST,
		WID_DELETE, WID_PASTE,
		WID_CONTENT_TYPE, WID_OWN_URL,
		WID_FLAG_READONLY, WID_FLAG_IS_FOLDER,
		WID_FLAG_IS_DOCUMENT, WID_FLAG_IS_DOCUMENT,
		WID_DATE_CREATED, WID_VIEW_DESCRIPTION,
		WID_FLAG_SUPPORTMODE, WID_REPLY_TO_DEFAULT,
		WID_OUTMSGEXTERNALSTATE, WID_OUTMSGEXTERNALSTATE,
		WID_SERVER_RANGES, WID_LAST_UID,
		WID_SEND_PUBLIC_PROT_ID, WID_SEND_VIM_POPATH,
		WID_LOCALBASE, WID_FSYS_DISKSPACE_LEFT,
		WID_KEYWORDS, WID_FSYS_FLAGS,
		WID_WHO_IS_MASTER, WID_WHO_IS_MASTER,
		WID_MARKED_DOCUMENT_COUNT, WID_FOLDER_COUNT,
		WID_TRASHCAN_FLAG_AUTODELETE, WID_TRASHCAN_FLAG_CONFIRMEMPTY,
		WID_REAL_NAME, WID_REAL_NAME,
		WID_SEND_FORMATS, WID_SEND_COPY_TARGET, 0 };

USHORT const aLocNodeCopyRanges[]
    = { WID_PRIORITY, WID_PRIORITY,
		WID_SEEN_STATUS, WID_RECIPIENTLIST,
		WID_CONTENT_TYPE, WID_CONTENT_TYPE,
		WID_FLAG_READONLY, WID_FLAG_READONLY,
		WID_FLAG_IS_FOLDER, WID_FLAG_IS_FOLDER,
		WID_FLAG_IS_DOCUMENT, WID_FLAG_IS_DOCUMENT,
		WID_DATE_CREATED, WID_VIEW_DESCRIPTION,
		WID_FLAG_SUPPORTMODE, WID_MARK_RANGES,
		WID_OUTTRAY_WANTED, WID_REPLY_TO_DEFAULT,
		WID_OUTMSGEXTERNALSTATE, WID_OUTMSGEXTERNALSTATE,
		WID_SERVER_RANGES, WID_LAST_UID,
		WID_SEND_PUBLIC_PROT_ID, WID_SEND_VIM_POPATH,
		WID_LOCALBASE, WID_FSYS_DISKSPACE_LEFT,
		WID_KEYWORDS, WID_FSYS_FLAGS,
		WID_WHO_IS_MASTER, WID_WHO_IS_MASTER,
		WID_MARKED_DOCUMENT_COUNT, WID_FOLDER_COUNT,
		WID_TRASHCAN_FLAG_AUTODELETE, WID_TRASHCAN_FLAG_CONFIRMEMPTY,
		WID_REAL_NAME, WID_REAL_NAME,
		WID_SEND_FORMATS, WID_SEND_COPY_TARGET, 0 };

}

//============================================================================
//
//  CntSearchFolderLocListNode
//
//============================================================================

CntSearchFolderLocListNode::CntSearchFolderLocListNode():
	CntNode(aLocListNodeRanges)
{
	CntDefaults * pDefaults = GetDefaults();
	if (!pDefaults)
	{
		pDefaults = new CntDefaults(*this, aLocListNodeRanges);
		pDefaults->Put(CntBoolItem(WID_FLAG_IS_FOLDER, true));
		pDefaults->Put(CntViewColumnsListItem(WID_VIEW_COLS_FILEDLG,
											  WID_TITLE, 216,
											  WID_CONTENT_TYPE, 90,
											  WID_DATE_MODIFIED, 130, 0));
		CntSortingItem aSorting(WID_VIEW_SORT_FILEDLG);
		aSorting.Append(CntSortingInfo(WID_TITLE));
		pDefaults->Put(aSorting);
	}
	CntInterface::SetParent(pDefaults);
}

//============================================================================
TYPEINIT1_AUTOFACTORY(CntSearchFolderLocListNode, CntSearchFolderNode)

//============================================================================
CNT_NODE_SUBCLASS_IMPL(CntSearchFolderLocListNode)
{
	InsertFactory(new CntNodeFactory(String::CreateFromAscii(
		                                 RTL_CONSTASCII_STRINGPARAM("/*")),
									 String(), TYPE(LocNode),
									 CONTENT_TYPE_X_CNT_SEARCHBOX,
									 CNT_CREATION_FLAG_HIDDEN));
}

//============================================================================
// virtual
SfxPoolItem const * CntSearchFolderLocListNode::ExecuteJob(CntNodeJob * pJob)
{
	if (pJob->GetRequestData())
		return
			reinterpret_cast< ThreadTask * >(pJob->GetRequestData())->run();

	switch (pJob->GetRequest()->Which())
	{
		case WID_OPEN:
			return (new OpenTask(*pJob))->run();

		case WID_SEARCH_LOCATIONS:
			return (new SyncTask(*pJob))->run();

		case WID_TO:
		{
			String aLocURL(static_cast< CntStringItem const * >(
				                   pJob->GetRequest())->
						       GetValue());
			if (add(aLocURL))
			{
				Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
								  static_cast< CntUInt32Item const * >(
									          &Get(WID_TOTALCONTENTCOUNT))->
								          GetValue()
							          + 1));
				CntNodeRef xLocNode(Query(createLocNodeURL(aLocURL)));
				if (LocNode * pTheLocNode = PTR_CAST(LocNode, &xLocNode))
				{
					pTheLocNode->copyData(aLocURL);
					pJob->Result(pTheLocNode);
				}
			}
			pJob->Done();
			return 0;
		}
	}
	return CntNode::ExecuteJob(pJob);
}

//============================================================================
String CntSearchFolderLocListNode::createLocNodeURL(String const & rLocURL)
	const
{
	String aLocNodeURL(OWN_URL(this));
	if (aLocNodeURL.Len() > 0
		&& aLocNodeURL.GetChar(aLocNodeURL.Len() - 1) != '/')
		aLocNodeURL += '/';
	aLocNodeURL += INetURLObject::encode(rLocURL, INetURLObject::PART_VIM,
										 '=', INetURLObject::ENCODE_ALL);
	return aLocNodeURL;
}

//============================================================================
BOOL CntSearchFolderLocListNode::add(String const & rLocURL)
{
	List const * pOldList = static_cast< CntStringListItem const * >(
									&Get(WID_SEARCH_LOCATIONS))->
		                        GetList();
	{for (ULONG i = 0; i < pOldList->Count(); ++i)
		if (rLocURL == *static_cast< String * >(pOldList->GetObject(i)))
			return false;
	}
	CntStringListItem aNewItem(WID_SEARCH_LOCATIONS);
	List * pNewList = aNewItem.GetList();
	{for (ULONG i = 0; i < pOldList->Count(); ++i)
		pNewList->
			Insert(new String(*static_cast< String * >(pOldList->
													       GetObject(i))),
				   LIST_APPEND);
	}
	pNewList->Insert(new String(rLocURL), LIST_APPEND);
	Put(aNewItem);
	return true;
}

//============================================================================
BOOL CntSearchFolderLocListNode::remove(String const & rLocURL)
{
	List const * pOldList = static_cast< CntStringListItem const * >(
									&Get(WID_SEARCH_LOCATIONS))->
		                        GetList();
	for (ULONG i = 0; i < pOldList->Count(); ++i)
		if (rLocURL == *static_cast< String * >(pOldList->GetObject(i)))
		{
			CntStringListItem aNewItem(WID_SEARCH_LOCATIONS);
			List * pNewList = aNewItem.GetList();
			for (ULONG j = 0; j < pOldList->Count(); ++j)
				if (j != i)
					pNewList->Insert(new String(*static_cast< String * >(
						                             pOldList->GetObject(j))),
									 LIST_APPEND);
			Put(aNewItem);
			return true;
		}
	return false;
}

//============================================================================
//
//  OpenTask
//
//============================================================================

// virtual
SfxPoolItem const * OpenTask::execute()
{
	if (!m_pList)
	{
		m_pList = static_cast< CntStringListItem const * >(
			              &getJob().GetSubject()->Get(WID_SEARCH_LOCATIONS))->
			          GetList();
		m_nIndex = 0;
	}
	startTimeSlice();
	while (m_nIndex < m_pList->Count())
	{
		String
			aLocURL(*static_cast< String * >(m_pList->GetObject(m_nIndex++)));
		CntNodeRef
			xLocNode(getJob().GetSubject()->
					     Query(static_cast< CntSearchFolderLocListNode * >(
							           getJob().GetSubject())->
							       createLocNodeURL(aLocURL)));
		if (LocNode * pTheLocNode = PTR_CAST(LocNode, &xLocNode))
		{
			pTheLocNode->copyData(aLocURL);
			getJob().Result(pTheLocNode);
		}
		if (checkTimeSliceExhausted())
		{
			reschedule();
			return 0;
		}
	}
	done();
	return 0;
}

//============================================================================
//
//  SyncTask
//
//============================================================================

// virtual
SfxPoolItem const * SyncTask::execute()
{
	startTimeSlice();
	switch (m_eState)
	{
		case INITIALIZE:
		{
			List const * pOldList
				= static_cast< CntStringListItem const * >(
					      &getJob().GetSubject()->Get(WID_SEARCH_LOCATIONS))->
				      GetList();
			for (ULONG i = 0; i < pOldList->Count(); ++i)
				m_aWorkList.Insert(new String(*static_cast< String * >(
					                               pOldList->GetObject(i))),
								   LIST_APPEND);
			getJob().GetSubject()->Put(*getJob().GetRequest());
			m_pNewList
				= static_cast< CntStringListItem const * >(
					      &getJob().GetSubject()->Get(WID_SEARCH_LOCATIONS))->
				      GetList();
			getJob().GetSubject()->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
													 m_pNewList->Count()));
			m_nIndex = 0;
			m_eState = FIRST_PASS;
		}
		case FIRST_PASS:
			while (m_nIndex < m_aWorkList.Count())
			{
				String aLocURL(*static_cast< String * >(
					                m_aWorkList.GetObject(m_nIndex++)));
				bool bPresent = false;
				for (ULONG i = 0; i < m_pNewList->Count(); ++i)
					if (aLocURL
						    == *static_cast< String * >(m_pNewList->
														    GetObject(i)))
					{
						bPresent = true;
						break;
					}
				if (!bPresent)
				{
					CntNodeRef
						xLocNode(
							getJob().GetSubject()->
							    Query(
									static_cast<
									           CntSearchFolderLocListNode * >(
										    getJob().GetSubject())->
									    createLocNodeURL(aLocURL),
									false));
					if (xLocNode.Is())
						getJob().Result(xLocNode, CNT_ACTION_DELETED);
				}
				if (checkTimeSliceExhausted())
				{
					reschedule();
					return 0;
				}
			}
			m_nIndex = 0;
			m_eState = SECOND_PASS;
		default: // SECOND_PASS
			while (m_nIndex < m_pNewList->Count())
			{
				String aLocURL(*static_cast< String * >(
					                m_pNewList->GetObject(m_nIndex++)));
				bool bPresent = false;
				for (ULONG i = 0; i < m_aWorkList.Count(); ++i)
					if (aLocURL
						    == *static_cast< String * >(m_aWorkList.
														    GetObject(i)))
					{
						bPresent = true;
						break;
					}
				if (!bPresent)
				{
					CntNodeRef
						xLocNode(
							getJob().GetSubject()->
							    Query(
									static_cast<
									           CntSearchFolderLocListNode * >(
										    getJob().GetSubject())->
									    createLocNodeURL(aLocURL)));
					if (LocNode * pTheLocNode = PTR_CAST(LocNode, &xLocNode))
					{
						pTheLocNode->copyData(aLocURL);
						getJob().Result(pTheLocNode);
					}
				}
				if (checkTimeSliceExhausted())
				{
					reschedule();
					return 0;
				}
			}
			done();
			return 0;
	}
}

//============================================================================
// virtual
SyncTask::~SyncTask()
{
	while (m_aWorkList.Count() > 0)
		delete static_cast< String * >(m_aWorkList.Remove(m_aWorkList.Count()
														      - 1));
}

//============================================================================
//
//  LocNode
//
//============================================================================

LocNode::LocNode(): CntNode(aLocNodeRanges)
{
	CntDefaults * pDefaults = GetDefaults();
	if (!pDefaults)
	{
		pDefaults = new CntDefaults(*this, aLocNodeRanges);
		pDefaults->DisableItem(WID_CUT);
		pDefaults->DisableItem(WID_COPY);
		pDefaults->DisableItem(WID_PASTE);
	}
	CntInterface::SetParent(pDefaults);
}

//============================================================================
TYPEINIT1_AUTOFACTORY(LocNode, CntSearchFolderLocListNode)

//============================================================================
CNT_NODE_SUBCLASS_IMPL(LocNode)
{}

//============================================================================
// virtual
SfxPoolItem const * LocNode::ExecuteJob(CntNodeJob * pJob)
{
	switch (pJob->GetRequest()->Which())
	{
		case WID_INSERT:
			if (CntSearchFolderLocListNode * pListNode
				    = PTR_CAST(CntSearchFolderLocListNode, GetParent()))
			{
				String aLocURL(static_cast< CntStringItem const * >(
					                   &pJob->GetClient()->Get(WID_TITLE))->
							       GetValue());
				if (pListNode->add(aLocURL))
				{
					pListNode->
						Put(CntUInt32Item(
							    WID_TOTALCONTENTCOUNT,
								static_cast< CntUInt32Item const * >(
									        &pListNode->
											     Get(WID_TOTALCONTENTCOUNT))->
								        GetValue()
								    + 1));
					CntNodeRef
						xLocNode(pListNode->
								     Query(pListNode->
										       createLocNodeURL(aLocURL)));
					if (xLocNode.Is())
					{
						if (LocNode * pTheLocNode
							    = PTR_CAST(LocNode, &xLocNode))
							pTheLocNode->copyData(aLocURL);
						pJob->Result(xLocNode);
					}
				}
				pJob->Done();
			}
			else
				pJob->Cancel();
			return 0;

		case WID_DELETE:
			if (CntSearchFolderLocListNode * pListNode
				    = PTR_CAST(CntSearchFolderLocListNode, GetParent()))
			{
				String aLocNodeURL(OWN_URL(this));
				xub_StrLen nStart = aLocNodeURL.Len();
				while (nStart > 0 && aLocNodeURL.GetChar(nStart - 1) != '/')
					--nStart;
				if (!pListNode->
					     remove(INetURLObject::decode(
							        aLocNodeURL.Copy(nStart), '=',
									INetURLObject::DECODE_WITH_CHARSET)))
				{
					pJob->Cancel();
					return 0;
				}
				UINT32 nCount
					= static_cast< CntUInt32Item const * >(
						      &pListNode->Get(WID_TOTALCONTENTCOUNT))->
					      GetValue();
				if (nCount > 0)
					pListNode->Put(CntUInt32Item(WID_TOTALCONTENTCOUNT,
												 nCount - 1));
				pJob->Result(this, CNT_ACTION_DELETED);
				pJob->Done();
			}
			else
				pJob->Cancel();
			return 0;
	}
	return CntNode::ExecuteJob(pJob);
}

//============================================================================
void LocNode::copyData(String const & rLocURL)
{
	SfxItemSet aItems(*GetPool(), aLocNodeCopyRanges);

	uno::Reference< uno::XInterface > xUCB(CntUCB::get());
	uno::Reference< ucb::XContentIdentifierFactory >
		xIDFactory(xUCB, uno::UNO_QUERY);
	uno::Reference< ucb::XContentIdentifier > xID;
	if (xIDFactory.is())
		xID = xIDFactory->createContentIdentifier(rLocURL);
	uno::Reference< ucb::XContentProvider > xProvider(xUCB, uno::UNO_QUERY);
	uno::Reference< ucb::XContent > xContent;
	if (xProvider.is() && xID.is())
		try
		{
			xContent = xProvider->queryContent(xID);
		}
		catch (ucb::IllegalIdentifierException) {}

	uno::Reference< ucb::XCommandProcessor >
		xProcessor(xContent, uno::UNO_QUERY);
	if (xProcessor.is())
	{
		CntItemMap const * pMap = CntItemPool::Get()->GetItemMap();
		uno::Sequence< beans::Property > aProperties;
		for (USHORT const * p = aLocNodeCopyRanges; *p; p += 2)
			for (USHORT i = p[0]; i <= p[1]; ++i)
			{
				CntItemMapEntry const * pEntry = pMap->Which2Prop(i);
				if (pEntry && pEntry->IsProperty())
				{
					aProperties.realloc(aProperties.getLength() + 1);
					aProperties[aProperties.getLength() - 1].Name
						= rtl::OUString::createFromAscii(pEntry->pName);
					aProperties[aProperties.getLength() - 1].Handle = -1;
				}
			}
		ucb::Command aCommand;
		aCommand.Name = rtl::OUString::createFromAscii("getPropertyValues");
		aCommand.Handle = -1;
		aCommand.Argument <<= aProperties;
		uno::Any aResult;
		try
		{
			aResult = xProcessor->execute(aCommand, 0, 0);
		}
		catch (uno::Exception) {} //@@@
		uno::Reference< sdbc::XRow > xValues;
		if (aResult >>= xValues)
			for (sal_Int32 i = 0; i < aProperties.getLength(); ++i)
			{
				uno::Any aValue;
				bool bValid = false;
				try
				{
					aValue = xValues->getObject(i + 1, 0);
					bValid = !xValues->wasNull();
				}
				catch (sdbc::SQLException) {}
				if (bValid)
				{
					CntItemMapEntry const * pEntry
						= pMap->Prop2Which(aProperties[i].Name);
					if (pEntry)
					{
						SfxPoolItem * pItem
							= CntItemPool::Get()->
							      GetDefaultItem(pEntry->nWhich).Clone();
						if (pItem->PutValue(aValue))
							aItems.Put(*pItem);
					}
				}
			}
	}

	String aPresentationURL(rLocURL);
	CntAnchor::ToPresentationURL(aPresentationURL);

	switch (static_cast< CntContentTypeItem const * >(
		            &aItems.Get(WID_CONTENT_TYPE))->
			    GetEnumValue())
	{
		case CONTENT_TYPE_X_CNT_FTPFOLDER:
		case CONTENT_TYPE_X_CNT_FTPFILE:
		case CONTENT_TYPE_X_CNT_FTPLINK:
		{
			String aTitle(static_cast< CntStringItem const * >(
				                  &aItems.Get(WID_TITLE))->
						      GetValue());
			if (aTitle.Len() > 0)
			{
				aTitle.AppendAscii(RTL_CONSTASCII_STRINGPARAM(" ["));
				aTitle += aPresentationURL;
				aTitle += ']';
				aItems.Put(CntStringItem(WID_TITLE, aTitle));
			}
			break;
		}

		case CONTENT_TYPE_X_CNT_FSYSFOLDER:
		case CONTENT_TYPE_X_CNT_FSYSFILE:
		{
			String aTitle(static_cast< CntStringItem const * >(
				                  &aItems.Get(WID_TITLE))->
						      GetValue());
			if (aTitle.Len() > 0)
			{
				aTitle.AppendAscii(RTL_CONSTASCII_STRINGPARAM(" ["));
				aTitle += INetURLObject(aPresentationURL).PathToFileName();
				aTitle += ']';
				aItems.Put(CntStringItem(WID_TITLE, aTitle));
			}
			break;
		}
	}

	if (aItems.GetItemState(WID_CONTENT_TYPE, false) != SFX_ITEM_SET)
		aItems.Put(CntContentTypeItem(WID_CONTENT_TYPE,
									  CONTENT_TYPE_UNKNOWN));
	if (aItems.GetItemState(WID_TITLE, false) != SFX_ITEM_SET)
		aItems.Put(CntStringItem(WID_TITLE, aPresentationURL));
	if (aItems.GetItemState(WID_REAL_URL) != SFX_ITEM_SET)
	{
		String aServiceURL(rLocURL);
		if (CntAnchor::ToServiceURL(aServiceURL))
			aItems.Put(CntStringItem(WID_REAL_URL, aServiceURL));
	}

	Put(aItems);
}

