/*************************************************************************
 *
 *  $RCSfile: vimwrap.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CHAOS_VIMWRAP_HXX
#define _CHAOS_VIMWRAP_HXX

#ifndef _SOLAR_H //autogen
#include <tools/solar.h>
#endif

//============================================================================
// Library Names

#if defined WNT
#define CNT_VIM_LIBRARY_NAME "VIM32.DLL"
#define CNT_VIM_LIBRARY_RES CNT_VIM_LIBRARY_NAME
#elif defined OS2
#define CNT_VIM_LIBRARY_NAME "VIM32"
#define CNT_VIM_ALT_LIBRARY_NAME "VIM"
#define CNT_VIM_LIBRARY_RES CNT_VIM_LIBRARY_NAME "/" CNT_VIM_ALT_LIBRARY_NAME
#else // WNT, OS2
#define CNT_VIM_LIBRARY_NAME "libvim.so"
#define CNT_VIM_LIBRARY_RES CNT_VIM_LIBRARY_NAME
#endif // WNT, OS2

//============================================================================
// Linkage

#if defined OS2
#define CNT_VIM_FN _System *
#define CNT_VIM_PTR
#define CNT_VIM_ALT_LINKAGE
#define CNT_VIM_ALT_FN * _Far16 _Pascal
#define CNT_VIM_ALT_PTR _Seg16
#else // OS2
#define CNT_VIM_FN *
#define CNT_VIM_PTR
#endif // OS2

//============================================================================
// Function Names

#if defined OS2
#define CNT_VIM_FN_CLOSEMESSAGE "VIMCLOSEMESSAGE"
#define CNT_VIM_FN_CLOSEMESSAGECONTAINER "VIMCLOSEMESSAGECONTAINER"
#define CNT_VIM_FN_CLOSESESSION "VIMCLOSESESSION"
#define CNT_VIM_FN_CREATEMESSAGE "VIMCREATEMESSAGE"
#define CNT_VIM_FN_ENUMERATEMESSAGEHEADERATTRS								 \
	"VIMENUMERATEMESSAGEHEADERATTRS"
#define CNT_VIM_FN_ENUMERATEMESSAGEITEMS "VIMENUMERATEMESSAGEITEMS"
#define CNT_VIM_FN_ENUMERATEMESSAGERECIPIENTS "VIMENUMERATEMESSAGERECIPIENTS"
#define CNT_VIM_FN_ENUMERATEMESSAGES "VIMENUMERATEMESSAGES"
#define CNT_VIM_FN_GETDEFAULTSESSIONINFO "VIMGETDEFAULTSESSIONINFO"
#define CNT_VIM_FN_GETMESSAGEHEADER "VIMGETMESSAGEHEADER"
#define CNT_VIM_FN_GETMESSAGEITEM "VIMGETMESSAGEITEM"
#define CNT_VIM_FN_INITIALIZE "VIMINITIALIZE"
#define CNT_VIM_FN_MARKMESSAGEASREAD "VIMMARKMESSAGEASREAD"
#define CNT_VIM_FN_OPENMESSAGE "VIMOPENMESSAGE"
#define CNT_VIM_FN_OPENMESSAGECONTAINER "VIMOPENMESSAGECONTAINER"
#define CNT_VIM_FN_OPENSESSION "VIMOPENSESSION"
#define CNT_VIM_FN_QUERYCAPABILITY "VIMQUERYCAPABILITY"
#define CNT_VIM_FN_QUERYNEWMESSAGES "VIMQUERYNEWMESSAGES"
#define CNT_VIM_FN_REMOVEMESSAGE "VIMREMOVEMESSAGE"
#define CNT_VIM_FN_SENDMESSAGE "VIMSENDMESSAGE"
#define CNT_VIM_FN_SETMESSAGEHEADER "VIMSETMESSAGEHEADER"
#define CNT_VIM_FN_SETMESSAGEITEM "VIMSETMESSAGEITEM"
#define CNT_VIM_FN_SETMESSAGERECIPIENT "VIMSETMESSAGERECIPIENT"
#define CNT_VIM_FN_STATUSTEXT "VIMSTATUSTEXT"
#define CNT_VIM_FN_TERMINATE "VIMTERMINATE"
#else // OS2
#define CNT_VIM_FN_CLOSEMESSAGE "VIMCloseMessage"
#define CNT_VIM_FN_CLOSEMESSAGECONTAINER "VIMCloseMessageContainer"
#define CNT_VIM_FN_CLOSESESSION "VIMCloseSession"
#define CNT_VIM_FN_CREATEMESSAGE "VIMCreateMessage"
#define CNT_VIM_FN_ENUMERATEMESSAGEHEADERATTRS								 \
	"VIMEnumerateMessageHeaderAttrs"
#define CNT_VIM_FN_ENUMERATEMESSAGEITEMS "VIMEnumerateMessageItems"
#define CNT_VIM_FN_ENUMERATEMESSAGERECIPIENTS "VIMEnumerateMessageRecipients"
#define CNT_VIM_FN_ENUMERATEMESSAGES "VIMEnumerateMessages"
#define CNT_VIM_FN_GETDEFAULTSESSIONINFO "VIMGetDefaultSessionInfo"
#define CNT_VIM_FN_GETMESSAGEHEADER "VIMGetMessageHeader"
#define CNT_VIM_FN_GETMESSAGEITEM "VIMGetMessageItem"
#define CNT_VIM_FN_INITIALIZE "VIMInitialize"
#define CNT_VIM_FN_MARKMESSAGEASREAD "VIMMarkMessageAsRead"
#define CNT_VIM_FN_OPENMESSAGE "VIMOpenMessage"
#define CNT_VIM_FN_OPENMESSAGECONTAINER "VIMOpenMessageContainer"
#define CNT_VIM_FN_OPENSESSION "VIMOpenSession"
#define CNT_VIM_FN_QUERYCAPABILITY "VIMQueryCapability"
#define CNT_VIM_FN_QUERYNEWMESSAGES "VIMQueryNewMessages"
#define CNT_VIM_FN_REMOVEMESSAGE "VIMRemoveMessage"
#define CNT_VIM_FN_SENDMESSAGE "VIMSendMessage"
#define CNT_VIM_FN_SETMESSAGEHEADER "VIMSetMessageHeader"
#define CNT_VIM_FN_SETMESSAGEITEM "VIMSetMessageItem"
#define CNT_VIM_FN_SETMESSAGERECIPIENT "VIMSetMessageRecipient"
#define CNT_VIM_FN_STATUSTEXT "VIMStatusText"
#define CNT_VIM_FN_TERMINATE "VIMTerminate"
#endif // OS2

//============================================================================
// Requirements

#define CNT_VIM_VERSION_REQUIRED 100

#if defined OS2
#define CNT_VIM_CHARSETS VIMSEL_CP850, VIMSEL_CP437, VIMSEL_CP1252
#else // OS2
#define CNT_VIM_CHARSETS VIMSEL_CP1252, VIMSEL_CP850, VIMSEL_CP437
#endif // OS2

//============================================================================
// Defines

#define VIM_CURRENT_VERSION 100

#define VIMSEL_ADDRESS 1
#define VIMSEL_ADMINISTRATOR 2
#define VIMSEL_ALL_NOTE_PARTS_SUPP 3
#define VIMSEL_APP_DEFINED 4
#define VIMSEL_APPLESINGLE 5
#define VIMSEL_ATTACH 6
#define VIMSEL_ATTACH_DIRS 7
#define VIMSEL_ATTACH_TYPE_SUPP 8
#define VIMSEL_BCC 9
#define VIMSEL_CC 10
#define VIMSEL_CCMAIL 11
#define VIMSEL_CERTIFIER 12
#define VIMSEL_CLASS 13
#define VIMSEL_COMMENTS 14
#define VIMSEL_CONVERSATION_ID 15
#define VIMSEL_CP1252 16
#define VIMSEL_CP437 17
#define VIMSEL_CP850 18
#define VIMSEL_DATE 19
#define VIMSEL_DELIVERY_DATE 20
#define VIMSEL_DELIVERY_REPORT 21
#define VIMSEL_DISPLAY_NAME 22
#define VIMSEL_DRAFT 23
#define VIMSEL_ENCRYPT 24
#define VIMSEL_ENCRYPT_WITH_KEY 25
#define VIMSEL_ENTITY 26
#define VIMSEL_EXPIRATION_DATE 27
#define VIMSEL_FAILED 28
#define VIMSEL_FAILURE_CODE 29
#define VIMSEL_FAILURE_REASON 30
#define VIMSEL_FAX 31
#define VIMSEL_FIRST_NAME 32
#define VIMSEL_FORWARD 33
#define VIMSEL_FROM 34
#define VIMSEL_FROM_NAME 35
#define VIMSEL_FULL 36
#define VIMSEL_GMT 37
#define VIMSEL_GROUP 38
#define VIMSEL_IMAG 39
#define VIMSEL_IN_REPLY_TO 40
#define VIMSEL_ISTRING 41
#define VIMSEL_KEYWORD 42
#define VIMSEL_LAST_NAME 43
#define VIMSEL_LMBCS 44
#define VIMSEL_LOCAL 45
#define VIMSEL_MAX_SUBJECT_LEN 46
#define VIMSEL_MAX_TEXT_LEN 47
#define VIMSEL_MAX_TYPE_LEN 48
#define VIMSEL_MHS 49
#define VIMSEL_MIDDLE_NAME 50
#define VIMSEL_MOVIE 51
#define VIMSEL_MSGMGR 52
#define VIMSEL_NAME 53
#define VIMSEL_NAME_REQUIRED 54
#define VIMSEL_NATIVE 55
#define VIMSEL_NESTED_MSG 56
#define VIMSEL_NESTING_DEPTH 57
#define VIMSEL_NO_FILTER 58
#define VIMSEL_NONDELIVERY_CONTENTS 59
#define VIMSEL_NONDELIVERY_REPORT 60
#define VIMSEL_NOT_SUPPORTED 61
#define VIMSEL_NOTE_PART 62
#define VIMSEL_NOTES 63
#define VIMSEL_NSTD_DERIVED_FORWRDS 64
#define VIMSEL_NSTD_DERIVED_REPLIES 65
#define VIMSEL_OCE 66
#define VIMSEL_PARTIAL 67
#define VIMSEL_PASS_REQUIRED 68
#define VIMSEL_PATH_REQUIRED 69
#define VIMSEL_PICT 70
#define VIMSEL_PRIORITY 71
#define VIMSEL_PRODUCT 72
#define VIMSEL_RDN 73
#define VIMSEL_READ_DATE 74
#define VIMSEL_RECIPIENT 75
#define VIMSEL_REF 76
#define VIMSEL_REPLY 77
#define VIMSEL_RESPOND_BY 78
#define VIMSEL_RETURN_RECEIPT 79
#define VIMSEL_RTF 80
#define VIMSEL_SAVE 81
#define VIMSEL_SENSITIVITY 82
#define VIMSEL_SENT 83
#define VIMSEL_SIGN 84
#define VIMSEL_SIGNER 85
#define VIMSEL_SORT_ORDER 86
#define VIMSEL_SORTED_LASTNAME 87
#define VIMSEL_SORTED_NAME 88
#define VIMSEL_SORTED_RDN 89
#define VIMSEL_STYLED 90
#define VIMSEL_SUBJECT 91
#define VIMSEL_SUBJECT_LEN 92
#define VIMSEL_SUBTREE 93
#define VIMSEL_SUCCEEDED 94
#define VIMSEL_SUPP_WITH_CONV 95
#define VIMSEL_SUPP_WITHOUT_CONV 96
#define VIMSEL_TO 97
#define VIMSEL_TYPE 98
#define VIMSEL_UNICODE 99
#define VIMSEL_UNIQUE_MSG_ID 100
#define VIMSEL_UNKNOWN_RECIP_TYPE 101
#define VIMSEL_UNKNOWN_SORT 102
#define VIMSEL_UNREAD_MAIL 103
#define VIMSEL_UNSORTED 104
#define VIMSEL_UNWRAPPED_TEXT 105
#define VIMSEL_VERSION 106
#define VIMSEL_X400 107
#define VIMSEL_X500 108
#define VIMSEL_IMPLEMENTATION_VERSION 272

#define VIM_DLR "VIM_DLR"
#define VIM_FAX "VIM_FAX"
#define VIM_IMAG "VIM_IMAG"
#define VIM_MAIL "VIM_MAIL"
#define VIM_MOVIE "VIM_MOVIE"
#define VIM_NDLR "VIM_NDLR"
#define VIM_PICT "VIM_PICT"
#define VIM_PRIVATE "VIM_PRIVATE"
#define VIM_PUBLIC "VIM_PUBLIC"
#define VIM_RTF "VIM_RTF"
#define VIM_RTRC "VIM_RTRC"
#define VIM_STYLED "VIM_STYLED"
#define VIM_TEXT "VIM_TEXT"
#define VIM_UNWRAPPED_TEXT "VIM_UNWRAPPED_TEXT"

#define VIM_FALSE 0
#define VIM_TRUE 1

#define VIM_LOW_PRIORITY 0
#define VIM_NORMAL_PRIORITY 1
#define VIM_HIGH_PRIORITY 2

#define VIM_HISTORY 1

#define VIM_INHERIT_CONTENTS 2
#define VIM_ALL_RECIPIENTS 4

#define VIM_UNREADONLY 1

#define VIM_NORMAL_SENS 0
#define VIM_PRIVATE_SENS 1
#define VIM_PERSONAL_SENS 2
#define VIM_CO_CONFID_SENS 3
#define VIM_APP_DEF_SENS 16384

#define VIM_EXTRACT_REF 1

#define VIM_SKIP_RECIP (USHORT(-1))

#define VIM_UNKNOWN_DATE (ULONG(-1))
#define VIM_UNKNOWN_TIME (ULONG(-1))

#define VIMSTS_SUCCESS 0
#define VIMSTS_FAILURE 1
#define VIMSTS_FATAL 2
#define VIMSTS_ALL_PARAMS_REQUIRED 3
#define VIMSTS_ATTACHMENT_NOT_FOUND 4
#define VIMSTS_BAD_PARAM 5
#define VIMSTS_BUF_TOO_SMALL 6
#define VIMSTS_CONV_NOT_SUPPORTED 7
#define VIMSTS_INSUFFICIENT_MEMORY 8
#define VIMSTS_INVALID_CONFIGURATION 9
#define VIMSTS_INVALID_OBJECT 10
#define VIMSTS_INVALID_PASSWORD 11
#define VIMSTS_INVALID_SELECTOR 12
#define VIMSTS_INVALID_SIGNATURE 13
#define VIMSTS_NAME_EXISTS 14
#define VIMSTS_NAME_NOT_FOUND 15
#define VIMSTS_NOT_SUPPORTED 16
#define VIMSTS_NO_COMMON_CERTIFICATES 17
#define VIMSTS_NO_DEFAULT 18
#define VIMSTS_NO_MATCH 19
#define VIMSTS_NO_SIGNATURE 20
#define VIMSTS_NO_SUCH_ATTRIBUTE 21
#define VIMSTS_OPEN_FAILURE 22
#define VIMSTS_PASS_REQUIRED 23
#define VIMSTS_READ_FAILURE 24
#define VIMSTS_UNSUP_TYPE 25
#define VIMSTS_UNSUP_VERSION 26
#define VIMSTS_WRITE_FAILURE 27

//============================================================================
// Data Types

extern "C"
{
	struct CntVIMRef
	{
		ULONG Ref[2];
	};

	struct CntVIMEnumRef
	{
		ULONG Ref[2];
	};

	struct CntVIMDistinguishedName
	{
		ULONG Type;
		sal_Char AddressBook[256];
		sal_Char Value[1024];
	};

	struct CntVIMAddress
	{
		ULONG Type;
		sal_Char Value[1024];
	};

	struct CntVIMRecipient
	{
		ULONG Type;
		CntVIMDistinguishedName DName;
		CntVIMAddress Address;
	};

	struct CntVIMAttrDesc
	{
		ULONG Attr;
		ULONG Size;
		void * CNT_VIM_PTR Buffer;
	};

	struct CntVIMItemDesc
	{
		ULONG Class;
		sal_Char Type[64];
		sal_Char Name[256];
		sal_Char Path[256];
		ULONG Size;
		CntVIMRef Ref;
	};

	struct CntVIMBuffFileDesc
	{
		ULONG Size;
		void * CNT_VIM_PTR Buffer;
		ULONG Offset;
		sal_Char * CNT_VIM_PTR FileName;
	};

	struct CntVIMDate
	{
		ULONG Zone;
		ULONG Date;
		ULONG Time;
	};

	struct CntVIMDateRange
	{
		CntVIMDate Start;
		CntVIMDate Stop;
	};

	typedef USHORT (CNT_VIM_FN CntVIMFnSendCallback)(void * CNT_VIM_PTR,
													 ULONG,
													 CntVIMRecipient *
													  CNT_VIM_PTR,
													 USHORT,
													 CntVIMRecipient *
													  CNT_VIM_PTR,
													 USHORT * CNT_VIM_PTR);

#if defined CNT_VIM_ALT_LINKAGE
	struct CntVIMAltAttrDesc
	{
		ULONG Attr;
		ULONG Size;
		void * CNT_VIM_ALT_PTR Buffer;
	};

	struct CntVIMAltBuffFileDesc
	{
		ULONG Size;
		void * CNT_VIM_ALT_PTR Buffer;
		ULONG Offset;
		sal_Char * CNT_VIM_ALT_PTR FileName;
	};

	typedef USHORT (CNT_VIM_ALT_FN CntVIMAltFnSendCallback)(void *
															 CNT_VIM_ALT_PTR,
															ULONG,
															CntVIMRecipient *
															 CNT_VIM_ALT_PTR,
															USHORT,
															CntVIMRecipient *
															 CNT_VIM_ALT_PTR,
															USHORT *
															 CNT_VIM_ALT_PTR);
#endif // CNT_VIM_ALT_LINKAGE
}

//============================================================================
// Macros

inline USHORT VIM_STATUS(ULONG nStatus)
{
	return USHORT(nStatus & 0xFFFF);
}

inline void VIM_UND_REF(CntVIMEnumRef & rRef)
{
	rRef.Ref[0] = 0;
	rRef.Ref[1] = 0;
}

//============================================================================
// Function Prototypes

extern "C"
{
	typedef ULONG (CNT_VIM_FN CntVIMFnCloseMessage)
		(void * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnCloseMessageContainer)
		(void * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnCloseSession)
		(void * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnCreateMessage)
		(void * CNT_VIM_PTR, sal_Char * CNT_VIM_PTR,
		 void * CNT_VIM_PTR * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnEnumerateMessageHeaderAttrs)
		(void * CNT_VIM_PTR, ULONG, CntVIMEnumRef * CNT_VIM_PTR, long, USHORT,
		 sal_Char * CNT_VIM_PTR, USHORT * CNT_VIM_PTR, USHORT * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnEnumerateMessageItems)
		(void * CNT_VIM_PTR, CntVIMEnumRef * CNT_VIM_PTR, long,
		 USHORT * CNT_VIM_PTR, CntVIMItemDesc * CNT_VIM_PTR, ULONG,
		 void * CNT_VIM_PTR, USHORT * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnEnumerateMessageRecipients)
		(void * CNT_VIM_PTR, ULONG, CntVIMEnumRef * CNT_VIM_PTR, long, USHORT,
		 CntVIMAttrDesc * CNT_VIM_PTR, USHORT * CNT_VIM_PTR,
		 USHORT * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnEnumerateMessages)
		(void * CNT_VIM_PTR, CntVIMEnumRef * CNT_VIM_PTR, long, USHORT,
		 CntVIMAttrDesc * CNT_VIM_PTR, USHORT * CNT_VIM_PTR, ULONG,
		 void * CNT_VIM_PTR, ULONG, USHORT * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnGetDefaultSessionInfo)
		(USHORT, sal_Char * CNT_VIM_PTR, USHORT, sal_Char * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnGetEntityName)
		(void * CNT_VIM_PTR, CntVIMDistinguishedName * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnGetMessageHeader)
		(void * CNT_VIM_PTR, USHORT, CntVIMAttrDesc * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnGetMessageItem)
		(void * CNT_VIM_PTR, CntVIMRef, sal_Char * CNT_VIM_PTR, ULONG,
		 CntVIMBuffFileDesc * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnInitialize)();

	typedef ULONG (CNT_VIM_FN CntVIMFnMarkMessageAsRead)
		(void * CNT_VIM_PTR, CntVIMRef);

	typedef ULONG (CNT_VIM_FN CntVIMFnOpenMessage)
		(void * CNT_VIM_PTR, CntVIMRef, sal_Char * CNT_VIM_PTR,
		 void * CNT_VIM_PTR * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnOpenMessageContainer)
		(void * CNT_VIM_PTR, sal_Char * CNT_VIM_PTR,
		 void * CNT_VIM_PTR * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnOpenSession)
		(sal_Char * CNT_VIM_PTR, sal_Char * CNT_VIM_PTR,
		 sal_Char * CNT_VIM_PTR, ULONG, ULONG,
		 void * CNT_VIM_PTR * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnQueryCapability)
		(ULONG, USHORT, void * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnQueryNewMessages)
		(void * CNT_VIM_PTR, USHORT * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnRemoveMessage)
		(void * CNT_VIM_PTR, CntVIMRef);

	typedef ULONG (CNT_VIM_FN CntVIMFnSendMessage)
		(void * CNT_VIM_PTR, void * CNT_VIM_PTR, CntVIMFnSendCallback);

	typedef ULONG (CNT_VIM_FN CntVIMFnSetMessageHeader)
		(void * CNT_VIM_PTR, ULONG, USHORT, void * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnSetMessageItem)
		(void * CNT_VIM_PTR, ULONG, sal_Char * CNT_VIM_PTR, ULONG,
		 sal_Char * CNT_VIM_PTR, CntVIMBuffFileDesc * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnSetMessageRecipient)
		(void * CNT_VIM_PTR, ULONG, CntVIMRecipient * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnStatusText)
		(void * CNT_VIM_PTR, ULONG, USHORT, sal_Char * CNT_VIM_PTR, USHORT,
		 sal_Char * CNT_VIM_PTR);

	typedef ULONG (CNT_VIM_FN CntVIMFnTerminate)();

#if defined CNT_VIM_ALT_LINKAGE
	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnCloseMessage)
		(void * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnCloseMessageContainer)
		(void * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnCloseSession)
		(void * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnCreateMessage)
		(void * CNT_VIM_ALT_PTR, sal_Char * CNT_VIM_ALT_PTR,
		 void * CNT_VIM_ALT_PTR * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnEnumerateMessageHeaderAttrs)
		(void * CNT_VIM_ALT_PTR, ULONG, CntVIMEnumRef * CNT_VIM_ALT_PTR, long,
		 USHORT, sal_Char * CNT_VIM_ALT_PTR, USHORT * CNT_VIM_ALT_PTR,
		 USHORT * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnEnumerateMessageItems)
		(void * CNT_VIM_ALT_PTR, CntVIMEnumRef * CNT_VIM_ALT_PTR, long,
		 USHORT * CNT_VIM_ALT_PTR, CntVIMItemDesc * CNT_VIM_ALT_PTR, ULONG,
		 void * CNT_VIM_ALT_PTR, USHORT * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnEnumerateMessageRecipients)
		(void * CNT_VIM_ALT_PTR, ULONG, CntVIMEnumRef * CNT_VIM_ALT_PTR, long,
		 USHORT, CntVIMAltAttrDesc * CNT_VIM_ALT_PTR,
		 USHORT * CNT_VIM_ALT_PTR, USHORT * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnEnumerateMessages)
		(void * CNT_VIM_ALT_PTR, CntVIMEnumRef * CNT_VIM_ALT_PTR, long,
		 USHORT, CntVIMAltAttrDesc * CNT_VIM_ALT_PTR,
		 USHORT * CNT_VIM_ALT_PTR, ULONG, void * CNT_VIM_ALT_PTR, ULONG,
		 USHORT * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnGetDefaultSessionInfo)
		(USHORT, sal_Char * CNT_VIM_ALT_PTR, USHORT,
		 sal_Char * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnGetEntityName)
		(void * CNT_VIM_ALT_PTR, CntVIMDistinguishedName * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnGetMessageHeader)
		(void * CNT_VIM_ALT_PTR, USHORT, CntVIMAltAttrDesc * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnGetMessageItem)
		(void * CNT_VIM_ALT_PTR, CntVIMRef, sal_Char * CNT_VIM_ALT_PTR, ULONG,
		 CntVIMAltBuffFileDesc * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnInitialize)();

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnMarkMessageAsRead)
		(void * CNT_VIM_ALT_PTR, CntVIMRef);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnOpenMessage)
		(void * CNT_VIM_ALT_PTR, CntVIMRef, sal_Char * CNT_VIM_ALT_PTR,
		 void * CNT_VIM_ALT_PTR * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnOpenMessageContainer)
		(void * CNT_VIM_ALT_PTR, sal_Char * CNT_VIM_ALT_PTR,
		 void * CNT_VIM_ALT_PTR * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnOpenSession)
		(sal_Char * CNT_VIM_ALT_PTR, sal_Char * CNT_VIM_ALT_PTR,
		 sal_Char * CNT_VIM_ALT_PTR, ULONG, ULONG,
		 void * CNT_VIM_ALT_PTR * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnQueryCapability)
		(ULONG, USHORT, void * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnQueryNewMessages)
		(void * CNT_VIM_ALT_PTR, USHORT * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnRemoveMessage)
		(void * CNT_VIM_ALT_PTR, CntVIMRef);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnSendMessage)
		(void * CNT_VIM_ALT_PTR, void * CNT_VIM_ALT_PTR,
		 CntVIMAltFnSendCallback);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnSetMessageHeader)
		(void * CNT_VIM_ALT_PTR, ULONG, USHORT, void * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnSetMessageItem)
		(void * CNT_VIM_ALT_PTR, ULONG, sal_Char * CNT_VIM_ALT_PTR, ULONG,
		 sal_Char * CNT_VIM_ALT_PTR, CntVIMAltBuffFileDesc * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnSetMessageRecipient)
		(void * CNT_VIM_ALT_PTR, ULONG, CntVIMRecipient * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnStatusText)
		(void * CNT_VIM_ALT_PTR, ULONG, USHORT, sal_Char * CNT_VIM_ALT_PTR,
		 USHORT, sal_Char * CNT_VIM_ALT_PTR);

	typedef ULONG (CNT_VIM_ALT_FN CntVIMAltFnTerminate)();
#endif // CNT_VIM_ALT_LINKAGE
}

//============================================================================
// cc:Mail Export Program

#if defined WNT
#define CNT_VIM_EXPORT_PROGRAM "EXPORT.EXE"
#elif defined OS2
#define CNT_VIM_EXPORT_PROGRAM "EXPORT2.EXE"
#else // WNT, OS2
#define CNT_VIM_EXPORT_PROGRAM "export"
#endif // WNT, OS2

#endif // _CHAOS_VIMWRAP_HXX

