/*************************************************************************
 *
 *  $RCSfile: cnttrash.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UCB_XCOMMANDPROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIER_HPP_
#include <com/sun/star/ucb/XContentIdentifier.hpp>
#endif
#ifndef _SVTOOLS_CENUMITM_HXX
#include <svtools/cenumitm.hxx>
#endif
#ifndef _SVTOOLS_CINTITEM_HXX
#include <svtools/cintitem.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX //autogen
#include <svtools/ctypeitm.hxx>
#endif
#ifndef _TOOLS_INTN_HXX
#include <tools/intn.hxx>
#endif

#include <cnttrash.hxx>

#ifndef _CTRSHIMP_HXX
#include "ctrshimp.hxx"
#endif

#ifndef _CNTRNMGR_HXX
#include "cntrnmgr.hxx"
#endif
#ifndef _CNTVNODE_HXX
#include "cntvnode.hxx"
#endif
#ifndef _CNTSTGND_HXX
#include "cntstgnd.hxx"
#endif
#ifndef _CNTJOB_HXX
#include "cntjob.hxx"
#endif
#ifndef _CSTRITEM_HXX
#include "cstritem.hxx"
#endif
#ifndef _SORTITEM_HXX
#include "sortitem.hxx"
#endif
#ifndef _ULSTITEM_HXX
#include "ulstitem.hxx"
#endif
#ifndef _CNTVWITM_HXX
#include "cntvwitm.hxx"
#endif
#ifndef _ILSTITEM_HXX
#include "ilstitem.hxx"
#endif
#ifndef _CHAOS_INIMGR_HXX
#include <inimgr.hxx>
#endif
#ifndef CHAOS_SLSTITEM_HXX
#include <slstitem.hxx>
#endif
#ifndef CHAOS_TFRMITEM_HXX
#include <tfrmitem.hxx>
#endif

#ifndef _CNTMMITM_HXX
#include <cntmmitm.hxx>
#endif

using namespace com::sun::star::ucb;
using namespace com::sun::star::uno;

#if defined TF_UCB
using namespace chaos;
#endif // TF_UCB

//============================================================================

// RTTI
TYPEINIT1_AUTOFACTORY( CntTrashCanNode, CntNode );
TYPEINIT1_AUTOFACTORY( CntTrashNode, CntNode );

//============================================================================

// Ranges arrays
USHORT __READONLY_DATA aCntTrashCanNodeRanges_Impl[] =
{
	WID_TITLE,					WID_TITLE,
	WID_ALL_START,				WID_OPEN,
	// No WID_DELETE
	WID_CUT,					WID_VIEW_DESCRIPTION,
	// No WID_IS_READ - WID_SYNCHRONIZE
	WID_CREATE_NEW,				WID_UPDATE,
	// No WID_IMPORT - WID_MESSAGEVIEW_MODE
	WID_SORTING,				WID_SORTING,
	// No WID_THREADED - WID_FLAG_SUBSCRIBED
	WID_FLAG_SUPPORTMODE,		WID_TOTALCONTENTCOUNT,
	// No WID_NEWSGROUPCOUNT - WID_FOLDER_END
	WID_AUTOUPDATE_INTERVAL,    WID_UPDATE_ENABLED,
	WID_STORE_TIMELIMITED,      WID_PROPERTYLIST,
	WID_TARGET_URL,				WID_TARGET_URL,
	WID_TRASHCAN_START,			WID_TRASHCAN_END,
	WID_TARGET_FRAMES,			WID_TARGET_FRAMES,
	WID_VIEW_START,				WID_VIEW_END,
	WID_VIEW2_START, 			WID_VIEW2_END,
	WID_FOLDER_START2,		 	WID_FOLDER_END2,
	WID_VIEW3_START, 			WID_VIEW3_END,
	0
};

USHORT __READONLY_DATA aCntTrashNodeRanges_Impl[] =
{
	WID_TITLE,					WID_TITLE,
	WID_DELETE,					WID_DELETE,
	WID_GETDATA,                WID_REAL_URL,
	WID_REFERED_URL,			WID_VIEW_DESCRIPTION,
	WID_PROPERTYLIST,			WID_PROPERTYLIST,
	WID_SIZE,					WID_SIZE,
	WID_TARGET_URL,				WID_TARGET_URL,
	WID_FSYS_FLAGS,				WID_FSYS_FLAGS,
	WID_TRASH_START,			WID_TRASH_END,
	0
};

//============================================================================
//
//  CntTrashCanNode Implementation.
//
//============================================================================

CNT_NODE_SUBCLASS_IMPL( CntTrashCanNode )
{
	// Register ourself at root node manager.
	CntNodeFactory *pFac = new CntNodeFactory(
				UniString::CreateFromAscii(
					RTL_CONSTASCII_STRINGPARAM(
						URL_PREFIX_PRIV_SOFFICE "trashcan:///*" ) ), '#',
				StaticType(), CONTENT_TYPE_X_CNT_TRASHBOX,
				CNT_CREATION_FLAG_HIDDEN /* CNT_CREATION_FLAG_PROPERTIES */ );
	CntRootNodeMgr::InsertFactory( pFac );

	// Register possible children.
	pFac = new CntNodeFactory(
				UniString::CreateFromAscii(
					RTL_CONSTASCII_STRINGPARAM( "#*" ) ), UniString(),
				TYPE( CntTrashNode ), CONTENT_TYPE_X_CNT_TRASH,
				CNT_CREATION_FLAG_HIDDEN );
	InsertFactory( pFac );
}

//============================================================================
CntTrashCanNode::CntTrashCanNode( const USHORT *pRanges )
: CntNode( pRanges ? pRanges : aCntTrashCanNodeRanges_Impl ),
  _pImpl( NULL )
{
	// class CntTrashCanNode defaults
	CntDefaults *pClassDefs = GetDefaults();
	if ( pClassDefs == NULL )
	{
		// Create new class defaults
		pClassDefs = new CntDefaults( *this, aCntTrashCanNodeRanges_Impl );

		// Set ContentType.
		pClassDefs->Put( CntContentTypeItem( WID_CONTENT_TYPE,
											 CONTENT_TYPE_X_CNT_TRASHBOX ) );

		// Set default title.
		pClassDefs->Put( CntStringItem(	WID_TITLE,
										INetContentTypes::GetPresentation(
											CONTENT_TYPE_X_CNT_TRASHBOX,
											CntRootNodeMgr::GetIniManager()->
											 getInternational().GetLanguage())));

		pClassDefs->Put( CntBoolItem( WID_FLAG_IS_FOLDER, TRUE ) );
		pClassDefs->Put( CntBoolItem( WID_FLAG_IS_DOCUMENT, FALSE ) );
		pClassDefs->Put( CntBoolItem( WID_FLAG_HAS_MESSAGES, TRUE ) );

		// Set properties that are "renamable".
		pClassDefs->Put( CntUShortListItem(	WID_RENAME,
											WID_TITLE, 0 ) );

		// Set Explorer/Beamer relevant items.
		CntViewColumnsListItem aColumnDefs( WID_VIEW_COLS_FILEDLG,
			WID_TITLE, DEF_WIDTH_TITLE_MAIL,
			WID_CONTENT_TYPE, DEF_WIDTH_CONTENT_TYPE,
			WID_DOCUMENT_SIZE, DEF_WIDTH_DOCUMENT_SIZE,
			WID_DATE_CREATED, DEF_WIDTH_DATE_CREATED,
			WID_TRASH_ORIGIN, DEF_WIDTH_TRASH_ORIGIN,
			0);
		pClassDefs->Put( aColumnDefs, WID_VIEW_COLS_FILEDLG );
		pClassDefs->Put( aColumnDefs, WID_VIEW_COLS_BEAMER );
		pClassDefs->Put( aColumnDefs, WID_VIEW_COLS_FLDWIN );

		CntSortingItem aSortingDefs( WID_VIEW_SORT_BEAMER );
		aSortingDefs.Append( CntSortingInfo( WID_TITLE, TRUE ) );
		aSortingDefs.Append( CntSortingInfo( WID_DATE_CREATED, FALSE ) );
		pClassDefs->Put( aSortingDefs );
		pClassDefs->Put( aSortingDefs, WID_VIEW_SORT_FILEDLG );
		pClassDefs->Put( aSortingDefs, WID_VIEW_SORT_FLDWIN_DETAILS );
		pClassDefs->Put( aSortingDefs, WID_VIEW_SORT_FLDWIN_ICON );

		// Setup this ugly Header-Config-Thing :(
		CntStringListItem aHdrCfg( WID_HEADER_CONFIG );
		String aStr( 't' );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "NonRFC-Title\001b" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "From:" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "Date:" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "NonRFC-Size" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "Comments:" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "Keywords:" ) );
		aStr += _CR;
		aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "NonRFC-UserFields" ) );

		aHdrCfg.SetString( aStr );
		pClassDefs->Put(aHdrCfg);

		// Set property tab pages wanted.
		pClassDefs->Put( CntIdentifierListItem(	WID_PROPERTYLIST,
											    CNT_TABPAGE_GENERAL,
											    CNT_TABPAGE_TRASHCAN_OPTIONS,
											    CNT_TABPAGE_BACKGROUND,
											    CNT_TABPAGE_FONT,
											    0 ) );

		// Target frames.
		pClassDefs->Put( CntTargetFrameItem( WID_TARGET_FRAMES,
				UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM(
					"_beamer" ) ),  /* Select => if folder => beamer   */
				UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM(
					"_top" ) ), 	/* double click => do desired behaviour */
				UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM(
					"_blank" ) ) ) ); /* CTRL click => new task         */


		// Auto-update.
		pClassDefs->Put(
			CntBoolItem  ( WID_UPDATE_ENABLED, FALSE ) );
		pClassDefs->Put(
			CntUInt32Item( WID_AUTOUPDATE_INTERVAL, 60 * 60 ) ); // 1 hour.
	}
	CntInterface::SetParent( pClassDefs );

	// I'm never moveable / copyable
	DisableItem( WID_CUT );
	DisableItem( WID_COPY );

	// Create implementation instance.
	_pImpl = new CntTrashCanNode_Impl( this );
}

//============================================================================
// virtual
CntTrashCanNode::~CntTrashCanNode()
{
	delete _pImpl;
}

//============================================================================
//virtual
const SfxPoolItem* CntTrashCanNode::ExecuteJob( CntNodeJob *pJob )
{
	const SfxPoolItem * pReq = pJob->GetRequest();
	USHORT nWhich = pReq->Which();

	DBG_ASSERT( pJob->GetSubject() == this,
				"CntTrashCanNode::ExecuteJob - Strange subject!" );

	switch ( nWhich )
	{
		case WID_GETDATA:
			_pImpl->Initialize( pJob );
			break;

		case WID_PUTDATA:
		{
			_pImpl->Initialize( pJob );
			_pImpl->PutData( pJob );

			const SfxPoolItem* pItem =	( (const CntItemListItem*)
						pJob->GetRequest() )->Get( WID_STORE_TIMELIMITED );
			if ( pItem )
			{
				// Enable/disable auto-update.
				BOOL bState = ITEM_VALUE( CntBoolItem, *pItem );
				pJob->GetClient()->Put(
							CntBoolItem( WID_UPDATE_ENABLED, bState ) );
			}
			break;
		}

		case WID_TRASHCAN_FLAG_AUTODELETE:
		case WID_TRASHCAN_FLAG_CONFIRMEMPTY:
			_pImpl->Initialize( pJob );
			_pImpl->SetProperty( pJob );
			break;

		case WID_STORE_TIMELIMITED:
		{
			_pImpl->Initialize( pJob );

			// Enable/disable auto-update.
			BOOL bState = ITEM_VALUE( CntBoolItem, *pJob->GetRequest() );
			pJob->GetClient()->Put( CntBoolItem( WID_UPDATE_ENABLED, bState ) );

			break;
		}

		case WID_OPEN:
		case WID_UPDATE:
//		case WID_SEARCH:
 			_pImpl->Initialize( pJob );
			return _pImpl->Open( pJob );

		case WID_DELETE:
		case WID_TRASHCAN_EMPTY_TRASH:
			_pImpl->Initialize( pJob );
			return _pImpl->Empty( pJob );

		default:
			break;
	}

	// Forward unfinished jobs.
	return CntNode::ExecuteJob( pJob );
}

//============================================================================
// virtual
void CntTrashCanNode::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
	if ( rHint.ISA( CntStatusHint ) )
	{
		const CntStatusHint* pStatusHint = (const CntStatusHint*)&rHint;
		if ( pStatusHint->GetRequest()->Which() == WID_TRASHCAN_EMPTY_TRASH )
		{
			switch ( pStatusHint->GetStatus() )
			{
				case CNT_STATUS_ERROR:
					if ( pStatusHint->GetError() == ERRCODE_ABORT )
					{
						if ( THIS_ITEM_VALUE( CntUInt32Item,
											  WID_TOTALCONTENTCOUNT ) )
						{
							// (Re-)Enable menu item "Empty...". After
							// selecting "Empty" on TrashCan, this item
							// was disabled.
							ClearItem( WID_TRASHCAN_EMPTY_TRASH );
						}
					}
					break;

				default:
					break;
			}
		}
	}

 	CntNode::Notify( rBC, rHint );
}

//============================================================================
// virtual
void CntTrashCanNode::SetConnMode( CntConnMode eNewConnMode )
{
	CntNode::SetConnMode( eNewConnMode );
}

//============================================================================
// virtual
FASTBOOL CntTrashCanNode::IsItemFlag( USHORT nWhich, USHORT nFlag ) const
{
	switch( nWhich )
	{
		case WID_AUTOUPDATE_INTERVAL :
		case WID_UPDATE_ENABLED :
			if( nFlag == CNT_ITEM_AUTO_VIEWPROP )
				return FALSE;
			else if( nFlag == CNT_ITEM_AUTO_OWNPROP )
				return TRUE;

			break;

		default:
			break;
	}

	return CntNode::IsItemFlag( nWhich, nFlag );
}

//============================================================================
//static
BOOL CntTrashCanNode::IsTrashable( CntNode* pNode )
{
	if ( !pNode )
		return FALSE;

	// 1) Nodes, which have no WID_UNDELETE in it's ranges, cannot be trashed.
	if ( pNode->GetItemState( WID_UNDELETE, TRUE ) < SFX_ITEM_DEFAULT )
		return FALSE;

	// 2) CntTrash(Can)Node's never can be trashed.
	CntNode* pCurr = pNode;
	while ( pCurr )
	{
		if ( pCurr->ISA( CntTrashNode ) || pCurr->ISA( CntTrashCanNode ) )
			return FALSE;

		pCurr = pCurr->GetReferedNode();
	}

	// 3) Storage (SCS) files never can be trashed.
	if ( pNode->ISA( CntRootStorageNode ) )
	{
		String aURL = OWN_URL( pNode );
		CntStorageNode::Own2FileURL( aURL );
		String aExt = aURL.Copy( aURL.Len() - 3 ).ToLowerAscii();
		if ( aExt.EqualsAscii( STG_NOTVIEW_FILE_EXTENSION ) )
			return FALSE;
	}

// Todo: Files, die schom im Trash-Verzeicnis sind...

	String aURL( UniString::CreateFromAscii(
					RTL_CONSTASCII_STRINGPARAM( STG_PROTOCOL_CACHE ) ) );
	aURL.AppendAscii( CNT_TRASHCAN_URL );

	if ( CntStorageNode::StorageFileExists( aURL ) )
	{
		// Cache file exists.
		CntAnchorRef xTrash( new CntAnchor( NULL, aURL, FALSE ) );
		if ( !xTrash->GetError() )
		{
			xTrash->Put( SfxVoidItem( WID_GETDATA ) );

			// 4) If no view to TrashCan exists, nothing can be trashed.
			if ( !ITEMSET_VALUE( &xTrash, CntUInt32Item,
						         WID_REFERER_COUNT ) )
				return FALSE;

			// 5) If "auto empty" is set, nothing can be trashed.
			if ( ITEMSET_VALUE( &xTrash, CntBoolItem,
								WID_TRASHCAN_FLAG_AUTODELETE ) )
				return FALSE;

			// Trashable!
			return TRUE;
		}
	}

	return FALSE;
}

//============================================================================
//static
BOOL CntTrashCanNode::Trash( CntNode* pNode )
{
	DBG_ASSERT( !pNode->ISA( CntTrashNode ),
	            "CntTrashCanNode::Trash - node is a CntTrashNode!" );

	CntAnchorRef xTrash( new CntAnchor( NULL,
										UniString::CreateFromAscii(
											RTL_CONSTASCII_STRINGPARAM(
												CNT_TRASHCAN_URL ) ),
										FALSE ) );

	const CntItemListItem* pListItem =
				(const CntItemListItem*)&( xTrash->Get( WID_CREATE_NEW ) );

	const CntAnchorItem* pNewAnchorItem = NULL;

	USHORT nCount = pListItem->Count();
	for( USHORT n = 0; n < nCount; ++n )
	{
		const CntItemListItem& rCurr = (CntItemListItem&)(*pListItem)[ n ];
		USHORT nType =
				ITEM_VALUE( CntUInt16Item, *rCurr.Get( WID_FACTORY_NO ) );
		if ( nType == CONTENT_TYPE_X_CNT_TRASH )
		{
			String aURL;
			if ( pNode->IsRootNode() )
			{
				// Special handling for view root nodes...
				aURL = OWN_URL( pNode );
				if ( !CntViewBase::IsRootViewURL( aURL ) )
					aURL.Erase();
			}

			if ( !aURL.Len() )
				aURL = OWN_URL( pNode->GetMostReferedNode() );

			// Clone original item before modification!
			CntItemListItem aCreateItem( rCurr );
			aCreateItem.Append( new CntStringItem( WID_TITLE, aURL ) );
			pNewAnchorItem = (const CntAnchorItem*)xTrash->Put( aCreateItem );
		}
	}

	if ( !pNewAnchorItem )
		return FALSE;

	CntAnchorRef xNewAnchor( pNewAnchorItem->GetValue() );
	xNewAnchor->Put( SfxVoidItem( WID_INSERT ) );

	delete (SfxPoolItem*) pNewAnchorItem;

	return TRUE;
}

//============================================================================
//static
void CntTrashCanNode::trashContent(const Reference< XCommandProcessor > &
								       rProperties,
								   const Reference< XContentIdentifier > &
								       rIdentifier)
{
	CntAnchorRef xTrashCan = new CntAnchor(0,
										   UniString::CreateFromAscii(
										   	RTL_CONSTASCII_STRINGPARAM(
	  											CNT_TRASHCAN_URL)),
										   false);
	const CntItemListItem * pList
		= static_cast< const CntItemListItem * >(&xTrashCan->
												      Get(WID_CREATE_NEW));
	for (sal_uInt16 i = 0; i < pList->Count(); ++i)
	{
		const CntItemListItem * pItem
			= static_cast< const CntItemListItem * >(&(*pList)[i]);
		if (ITEM_VALUE(CntUInt16Item, *pItem->Get(WID_FACTORY_NO))
			    == CONTENT_TYPE_X_CNT_TRASH)
		{
			CntItemListItem aCreateItem(*pItem);
			if (rIdentifier.is())
				aCreateItem.
					Append(new CntStringItem(WID_TITLE,
											 rIdentifier->
												     getContentIdentifier()));
			const CntAnchorItem * pAnchorItem
				= static_cast< const CntAnchorItem * >(xTrashCan->
													       Put(aCreateItem));
			if (pAnchorItem != 0)
			{
				pAnchorItem->GetValue()->
					Put(CntTrashInsertItem_Impl(WID_INSERT, rProperties));
				delete pAnchorItem;
			}
			break;
		}
	}
}

//============================================================================
//
//  CntTrashNode Implementation.
//
//============================================================================

CNT_NODE_SUBCLASS_IMPL( CntTrashNode )
{
	// No factories to register.
}

//============================================================================
CntTrashNode::CntTrashNode( const USHORT *pRanges )
: CntNode( pRanges ? pRanges : aCntTrashNodeRanges_Impl ),
  _pImpl( NULL )
{
	// class CntTrashNode defaults
	CntDefaults *pClassDefs = GetDefaults();
	if ( pClassDefs == NULL )
	{
		// Create new class defaults
		pClassDefs = new CntDefaults( *this, aCntTrashNodeRanges_Impl );

		// Set ContentType.
		pClassDefs->Put( CntContentTypeItem( WID_CONTENT_TYPE,
											 CONTENT_TYPE_X_CNT_TRASH ) );

		// Set Explorer/Browser relevant items.
		pClassDefs->Put( CntBoolItem( WID_FLAG_IS_FOLDER, FALSE ) );
		pClassDefs->Put( CntBoolItem( WID_FLAG_IS_DOCUMENT, TRUE ) );

		// Set property tab pages wanted.
		pClassDefs->Put( CntIdentifierListItem(	WID_PROPERTYLIST,
											    CNT_TABPAGE_GENERAL,
											    0 ) );
	}
	CntInterface::SetParent( pClassDefs );

	// Create implementation instance.
	_pImpl = new CntTrashNode_Impl(this);
}

//============================================================================
// virtual
CntNode* CntTrashNode::Initialize( CntNode* pParent, const String& rNodeURL )
{
	CntNode* pRet = CntNode::Initialize( pParent, rNodeURL );

	_pImpl->Initialize();

	return pRet;
}

//============================================================================
// virtual
CntTrashNode::~CntTrashNode()
{
	delete _pImpl;
}

//============================================================================
//virtual
const SfxPoolItem* CntTrashNode::ExecuteJob( CntNodeJob *pJob )
{
	const SfxPoolItem * pReq = pJob->GetRequest();
	USHORT nWhich = pReq->Which();
	switch ( nWhich )
	{
		case WID_GETDATA:
			_pImpl->Initialize( pJob );
			break;

		case WID_INSERT:
			return _pImpl->Insert( pJob );

		case WID_DELETE:
			return _pImpl->Destroy( pJob );

		case WID_TRASH_RESTORE:
			return _pImpl->Restore( pJob );

		default:
			break;
	}

	// Forward unfinished jobs.
	return CntNode::ExecuteJob( pJob );
}

//============================================================================
// virtual
void CntTrashNode::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
 	CntNode::Notify( rBC, rHint );
}


