/*************************************************************************
 *
 *  $RCSfile: ctrshimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CTRSHIMP_HXX
#define _CTRSHIMP_HXX

#ifndef _COM_SUN_STAR_UCB_XCOMMANDROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif

#ifndef _CNTBASE_HXX
#include <cntbase.hxx>
#endif

namespace com { namespace sun { namespace star { namespace ucb {
	class XContent;
} } } }

#if defined TF_UCB
namespace chaos {
#endif // TF_UCB

class CntTrashCanNode;
class CntTrashNode;
class CntNodeJob;
class CntStorageNode;

//=============================================================================

// Redifined WID's.
#define WID_STORE_TIMELIMITED 	WID_STORE_MSGS_HAS_TIMELIMIT
#define WID_STORE_TIMELIMIT		WID_STORE_MSGS_TIMELIMIT
#define WID_DATE_TRASHED		WID_DATE_CREATED

//============================================================================
class CntTrashInsertItem_Impl: public SfxVoidItem
{
	com::sun::star::uno::Reference< com::sun::star::ucb::XCommandProcessor >
	    m_xProperties;

public:
	TYPEINFO();

	CntTrashInsertItem_Impl(
		    USHORT nWhich,
			const com::sun::star::uno::Reference<
			          com::sun::star::ucb::XCommandProcessor > &
		        rProperties):
		SfxVoidItem(nWhich), m_xProperties(rProperties) {}

	virtual SfxPoolItem * Clone(SfxItemPool * = 0) const
	{ return new CntTrashInsertItem_Impl(*this); }

	const com::sun::star::uno::Reference<
	          com::sun::star::ucb::XCommandProcessor > &
	getProperties() const
	{ return m_xProperties; }
};

//=============================================================================
class CntTrashCanNode_Impl
{
private:
	com::sun::star::uno::Reference< com::sun::star::uno::XInterface > m_xUCB;
	CntTrashCanNode* _pNode;
	BOOL     		 _bInitialized;

	// Forbiddden and not implemented.
	CntTrashCanNode_Impl( const CntTrashCanNode_Impl& );
	// Forbiddden and not implemented.
	CntTrashCanNode_Impl& operator=( const CntTrashCanNode_Impl& );

public:
	CntTrashCanNode_Impl(CntTrashCanNode * pTheNode):
		_pNode(pTheNode), _bInitialized(false) {}

	CntTrashCanNode* GetNode() const { return _pNode; }

	void Initialize( CntNodeJob* pJob );

	// Jobs.
	const SfxPoolItem* PutData	  ( CntNodeJob* pJob );
	const SfxPoolItem* SetProperty( CntNodeJob* pJob );
	const SfxPoolItem* Open   	  ( CntNodeJob* pJob );
	const SfxPoolItem* Empty  	  ( CntNodeJob* pJob );

	com::sun::star::uno::Reference< com::sun::star::ucb::XContent >
	queryUCBContent(const rtl::OUString & rURL);
};

//=============================================================================

class CntTrashNode_Impl
{
private:
	CntTrashNode* _pNode;
	String		  _aRelatedURL;
	BOOL     	  _bInitialized;

	// Forbiddden and not implemented.
	CntTrashNode_Impl( const CntTrashNode_Impl& );
	// Forbiddden and not implemented.
	CntTrashNode_Impl& operator=( const CntTrashNode_Impl& );

public:
	CntTrashNode_Impl( CntTrashNode *pNode ):
		_pNode( pNode ), _bInitialized( sal_False ) {}

	CntTrashNode* GetNode() const { return _pNode; }
	const String& GetRestoreURL() const { return _aRelatedURL; }

	BOOL Inserted(CntStorageNode * pDir,
				  const com::sun::star::uno::Reference<
				            com::sun::star::ucb::XCommandProcessor > &
				      rProperties);
	BOOL Removed ( CntStorageNode* pDir );

	void SetMarkedForDestroy( BOOL bSet, CntNodeJob* pJob );

	void Initialize();
	void Initialize( CntNodeJob* pJob );

	// Jobs.
	const SfxPoolItem* Insert ( CntNodeJob* pJob );
	const SfxPoolItem* Restore( CntNodeJob* pJob );
	const SfxPoolItem* Destroy( CntNodeJob* pJob );
};

#if defined TF_UCB
}
#endif // TF_UCB

#endif /* !_CTRSHIMP_HXX */

