/*************************************************************************
 *
 *  $RCSfile: ucbdistributor.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:20:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UCB_UCBDISTRIBUTOR_HXX_
#include <ucbdistributor.hxx>
#endif

#ifndef _COM_SUN_STAR_BRIDGE_XUNOURLRESOLVER_HPP_
#include <com/sun/star/bridge/XUnoUrlResolver.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XREMOTECONTENTPROVIDERACCEPTOR_HPP_
#include <com/sun/star/ucb/XRemoteContentProviderAcceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XINTERFACE_HPP_
#include <com/sun/star/uno/XInterface.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XNAMINGSERVICE_HPP_
#include <com/sun/star/uno/XNamingService.hpp>
#endif
#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_ 
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _VOS_DIAGNOSE_H_ 
#include <vos/diagnose.hxx>
#endif

using namespace com::sun::star;
using namespace chaos_ucb;

//============================================================================
//
//  UcbDistributor
//
//============================================================================

inline
UcbDistributor::Data::Data(
	uno::Reference< ucb::XRemoteContentProviderAcceptor > const &
	    rTheAcceptor,
	rtl::OUString const & rTheIdentifier):
	m_xAcceptor(rTheAcceptor),
	m_aIdentifier(rTheIdentifier)
{}

//============================================================================
UcbDistributor::UcbDistributor(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory):
	m_xFactory(rTheFactory)
{
	VOS_ASSERT(m_xFactory.is());
}

//============================================================================
// virtual
uno::Any SAL_CALL UcbDistributor::queryInterface(uno::Type const & rType)
	throw (uno::RuntimeException)
{
	uno::Any
		aRet(cppu::queryInterface(
			     rType,
				 static_cast< lang::XServiceInfo * >(this),
				 static_cast< lang::XTypeProvider * >(this),
				 static_cast< ucb::XRemoteContentProviderDistributor * >(
					 this)));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

//============================================================================
// virtual
void SAL_CALL UcbDistributor::acquire() throw ()
{
	OWeakObject::acquire();
}

//============================================================================
// virtual
void SAL_CALL UcbDistributor::release() throw ()
{
	OWeakObject::release();
}

//============================================================================
// virtual
rtl::OUString SAL_CALL UcbDistributor::getImplementationName()
	throw (uno::RuntimeException)
{
	return getImplementationName_Static();
}

//============================================================================
// virtual
sal_Bool SAL_CALL UcbDistributor::supportsService(rtl::OUString const &
												      rServiceName)
	throw (uno::RuntimeException)
{
	uno::Sequence< rtl::OUString > aNames(getSupportedServiceNames_Static());
	for (sal_Int32 i = 0; i < aNames.getLength(); ++i)
		if (aNames[i] == rServiceName)
			return true;
	return false;
}

//============================================================================
// virtual
uno::Sequence< rtl::OUString > SAL_CALL
UcbDistributor::getSupportedServiceNames() throw (uno::RuntimeException)
{
	return getSupportedServiceNames_Static();
}

//============================================================================
// virtual
uno::Sequence< uno::Type > SAL_CALL UcbDistributor::getTypes()
	throw (uno::RuntimeException)
{
	static cppu::OTypeCollection * pCollection = 0;
	if (!pCollection)
	{
		osl::MutexGuard aGuard(osl::Mutex::getGlobalMutex());
		if (!pCollection)
		{
			static cppu::OTypeCollection
				aTheCollection(
					getCppuType(
						static_cast< uno::Reference< lang::XServiceInfo >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference< lang::XTypeProvider >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference<
						              ucb::XRemoteContentProviderDistributor >
						                 const * >(
							0)));
			pCollection = &aTheCollection;
		}
	}
	return pCollection->getTypes();
}

//============================================================================
// virtual
uno::Sequence< sal_Int8 > SAL_CALL UcbDistributor::getImplementationId()
	throw (uno::RuntimeException)
{
	static cppu::OImplementationId * pID = 0;
	if (!pID)
	{
		osl::MutexGuard aGuard(osl::Mutex::getGlobalMutex());
		if (!pID)
		{
			static cppu::OImplementationId aTheID(false);
			pID = &aTheID;
		}
	}
	return pID->getImplementationId();
}

//============================================================================
// virtual
sal_Bool SAL_CALL
UcbDistributor::connectToRemoteAcceptor(rtl::OUString const & rUrl,
										rtl::OUString const & rIdentifier)
	throw (connection::NoConnectException,
		   connection::ConnectionSetupException,
		   lang::IllegalArgumentException,
		   uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	HashMap::iterator aIt(m_aMap.find(rUrl));
	if (aIt != m_aMap.end())
		return false;

	uno::Reference< bridge::XUnoUrlResolver > xResolver;
	try
	{
		xResolver
			= uno::Reference< bridge::XUnoUrlResolver >(
				  m_xFactory->
				      createInstance(
						  rtl::OUString::createFromAscii(
							  "com.sun.star.bridge.UnoUrlResolver")),
				  uno::UNO_QUERY);
	}
	catch (uno::RuntimeException const &) { throw; }
	catch (uno::Exception const &) {}
	if (!xResolver.is())
		throw uno::RuntimeException();
			// no service, or service lacks interface

	//@@@ Currently, the soffice.exe resolves a url
	// "uno:<connection>;<protocol>;StarOffice.ServiceManager" to an
	// XNamingService, but the ucb.exe resolves a url
	// "uno:<connection>;<protocol>;UCB.Factory" to an XMultiServiceFactory.
	// In the long run, both should resolve the urls to
	// XMultiServiceFactories, and then the following hack can be removed.
	// (It might then also be possible to use urls like
	// "uno:<connection>;<protocol>;com.sun.star.ucb.
	// RemoteContentProviderAcceptor" and save an extra step.)
	uno::Reference< uno::XInterface > xResolved(xResolver->resolve(rUrl));
	uno::Reference< uno::XNamingService >
		xResolvedNaming(xResolved, uno::UNO_QUERY);
	uno::Reference< lang::XMultiServiceFactory >
		xResolvedFactory(xResolved, uno::UNO_QUERY);
	VOS_ENSURE(!(xResolvedNaming.is() && xResolvedFactory.is()),
			   "UcbDistributor::connectToRemoteAcceptor(): Hack won't work");

	uno::Reference< lang::XMultiServiceFactory > xRemoteFactory;
	if (xResolvedNaming.is())
	{
		try
		{
			xRemoteFactory
				= uno::Reference< lang::XMultiServiceFactory >(
					  xResolvedNaming->
				          getRegisteredObject(
							  rtl::OUString(
								  RTL_CONSTASCII_USTRINGPARAM(
									  "StarOffice.ServiceManager"))),
					  uno::UNO_QUERY);
		}
		catch (uno::RuntimeException const &) { throw; }
		catch (uno::Exception const &) {}
	}
	else if (xResolvedFactory.is())
	{
		try
		{
			xRemoteFactory
				= uno::Reference< lang::XMultiServiceFactory >(
					  xResolvedFactory->
				          createInstance(
							  rtl::OUString(
								  RTL_CONSTASCII_USTRINGPARAM(
									  "com.sun.star.lang.ServiceManager"))),
					  uno::UNO_QUERY);
		}
		catch (uno::RuntimeException const &) { throw; }
		catch (uno::Exception const &) {}
	}
	if (!xRemoteFactory.is())
		return false;

	uno::Reference< ucb::XRemoteContentProviderAcceptor > xAcceptor;
	try
	{
		xAcceptor
			= uno::Reference< ucb::XRemoteContentProviderAcceptor >(
				  xRemoteFactory->
				      createInstance(
						  rtl::OUString(
							  RTL_CONSTASCII_USTRINGPARAM(
								  "com.sun.star.ucb."
								      "RemoteContentProviderAcceptor"))),
				  uno::UNO_QUERY);
	}
	catch (uno::RuntimeException const &) { throw; }
	catch (uno::Exception const &) {}

	if (!(xAcceptor.is()
		  && xAcceptor->
		         addRemoteContentProvider(rIdentifier,
										  m_xFactory,
										  uno::Sequence< rtl::OUString >())))
		return false;

	m_aMap.insert(HashMap::value_type(rUrl, Data(xAcceptor, rIdentifier)));
	return true;
}

//============================================================================
// virtual
sal_Bool SAL_CALL
UcbDistributor::disconnectFromRemoteAcceptor(rtl::OUString const & rUrl)
	throw (uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	HashMap::iterator aIt(m_aMap.find(rUrl));
	if (aIt == m_aMap.end())
		return false;

	bool bSuccess = true;
	Data & rData = aIt->second;
	if (rData.m_xAcceptor.is())
		bSuccess
			= rData.m_xAcceptor->
			          removeRemoteContentProvider(rData.m_aIdentifier)
			      != false;

	m_aMap.erase(aIt);
	return bSuccess;
}

//============================================================================
// virtual
void SAL_CALL
UcbDistributor::disconnectFromAll()
	throw (uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	HashMap::iterator aEnd(m_aMap.end());
	for (HashMap::iterator aIt(m_aMap.begin()); aIt != aEnd; ++aIt)
	{
		Data & rData = aIt->second;
		if (rData.m_xAcceptor.is())
			rData.m_xAcceptor->
				removeRemoteContentProvider(rData.m_aIdentifier);

		m_aMap.erase(aIt);
	}
}

//============================================================================
// static
rtl::OUString UcbDistributor::getImplementationName_Static()
{
	return rtl::OUString::createFromAscii("chaos_ucb::UcbDistributor");
}

//============================================================================
// static
uno::Sequence< rtl::OUString >
UcbDistributor::getSupportedServiceNames_Static()
{
	uno::Sequence< rtl::OUString > aNames(1);
	aNames[0] = rtl::OUString::createFromAscii(
		            "com.sun.star.ucb.RemoteContentProviderDistributor");
	return aNames;
}

//============================================================================
// static
uno::Reference< lang::XSingleServiceFactory >
UcbDistributor::createServiceFactory(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory)
{
	return uno::Reference< lang::XSingleServiceFactory >(
		       cppu::createOneInstanceFactory(
				   rTheFactory,
				   getImplementationName_Static(),
				   createInstance,
				   getSupportedServiceNames_Static()));
}

//============================================================================
// static
uno::Reference< uno::XInterface > SAL_CALL
UcbDistributor::createInstance(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory)
{
	return
		static_cast< uno::XWeak * >(static_cast< cppu::OWeakObject * >(
			                            new UcbDistributor(rTheFactory)));
}

