/*************************************************************************
 *
 *  $RCSfile: ucbdistributor.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:20:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UCB_UCBDISTRIBUTOR_HXX_
#define _UCB_UCBDISTRIBUTOR_HXX_

#include <cstddef>
#include <functional>
#include <hash_map>

#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XREMOTECONTENTPROVIDERDISTRIBUTOR_HPP_
#include <com/sun/star/ucb/XRemoteContentProviderDistributor.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_ 
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_ 
#include <com/sun/star/uno/Sequence.h>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_ 
#include <cppuhelper/weak.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_ 
#include <osl/mutex.hxx>
#endif
#ifndef _RTL_USTRING_HXX_ 
#include <rtl/ustring.hxx>
#endif
#ifndef _SAL_TYPES_H_ 
#include <sal/types.h>
#endif

namespace com { namespace sun { namespace star {
	namespace lang {
		class XMultiServiceFactory;
		class XSingleServiceFactory;
	}
	namespace ucb { class XRemoteContentProviderAcceptor; }
	namespace uno { class XInterface; }
} } }

//============================================================================
namespace chaos_ucb {

class UcbDistributor:
		public cppu::OWeakObject,
		public com::sun::star::lang::XServiceInfo,
		public com::sun::star::lang::XTypeProvider,
		public com::sun::star::ucb::XRemoteContentProviderDistributor
{
public:
	UcbDistributor(
		com::sun::star::uno::Reference<
		        com::sun::star::lang::XMultiServiceFactory > const &
		    rTheFactory);

	//========================================================================
	// com::sun::star::uno::XInterface:

	virtual com::sun::star::uno::Any SAL_CALL
	queryInterface(com::sun::star::uno::Type const & rType)
		throw (com::sun::star::uno::RuntimeException);

    virtual void SAL_CALL acquire() throw ();

    virtual void SAL_CALL release() throw ();

	//========================================================================
	// com::sun::star::lang::XServiceInfo:

    virtual rtl::OUString SAL_CALL getImplementationName()
		throw (com::sun::star::uno::RuntimeException);

    virtual sal_Bool SAL_CALL supportsService(rtl::OUString const &
											      rServiceName)
		throw (com::sun::star::uno::RuntimeException);

    virtual com::sun::star::uno::Sequence< rtl::OUString > SAL_CALL
	getSupportedServiceNames() throw (com::sun::star::uno::RuntimeException);

	//========================================================================
	// com::sun::star::lang::XTypeProvider:

    virtual
	com::sun::star::uno::Sequence< com::sun::star::uno::Type > SAL_CALL
	getTypes() throw (com::sun::star::uno::RuntimeException);

    virtual com::sun::star::uno::Sequence< sal_Int8 > SAL_CALL
	getImplementationId() throw (com::sun::star::uno::RuntimeException);

	//========================================================================
	// com::sun::star::ucb::XRemoteContentProviderDistributor:

	virtual sal_Bool SAL_CALL
	connectToRemoteAcceptor(rtl::OUString const & rUrl,
							rtl::OUString const & rIdentifier)
		throw (com::sun::star::connection::NoConnectException,
			   com::sun::star::connection::ConnectionSetupException,
			   com::sun::star::lang::IllegalArgumentException,
			   com::sun::star::uno::RuntimeException);

	virtual sal_Bool SAL_CALL
	disconnectFromRemoteAcceptor(rtl::OUString const & rUrl)
		throw (com::sun::star::uno::RuntimeException);

	virtual void SAL_CALL
	disconnectFromAll()
		throw (com::sun::star::uno::RuntimeException);

	//========================================================================
	// Service Implementation:

	static rtl::OUString getImplementationName_Static();

	static com::sun::star::uno::Sequence< rtl::OUString >
	getSupportedServiceNames_Static();

	static
	com::sun::star::uno::Reference<
	    com::sun::star::lang::XSingleServiceFactory >
	createServiceFactory(
		com::sun::star::uno::Reference<
		        com::sun::star::lang::XMultiServiceFactory > const &
		    rTheFactory);

	static
	com::sun::star::uno::Reference< com::sun::star::uno::XInterface > SAL_CALL
	createInstance(
		com::sun::star::uno::Reference<
		        com::sun::star::lang::XMultiServiceFactory > const &
		    rTheFactory);

private:
	struct Data
	{
		com::sun::star::uno::Reference<
		        com::sun::star::ucb::XRemoteContentProviderAcceptor >
		    m_xAcceptor;
		rtl::OUString m_aIdentifier;

		inline
		Data(com::sun::star::uno::Reference<
			     com::sun::star::ucb::XRemoteContentProviderAcceptor > const &
			     rTheAcceptor,
			 rtl::OUString const & rTheIdentifier);
	};

	struct StringHash:
		public std::unary_function< rtl::OUString const, size_t >
	{
		inline size_t operator ()(rtl::OUString const & rString) const
		{ return size_t(rString.hashCode()); }
	};

	typedef std::hash_map< rtl::OUString, Data, StringHash > HashMap;

	HashMap m_aMap;
	osl::Mutex m_aMutex;
	com::sun::star::uno::Reference<
	        com::sun::star::lang::XMultiServiceFactory >
	    m_xFactory;
};

}

#endif // _UCB_UCBDISTRIBUTOR_HXX_

