/*************************************************************************
 *
 *  $RCSfile: rmtpaid.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UCPRMT_RMTPAID_HXX_
#define _UCPRMT_RMTPAID_HXX_

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_ 
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _SAL_TYPES_H_ 
#include <sal/types.h>
#endif

namespace com { namespace sun { namespace star { namespace ucb {
	class XContentProviderManager;
	class XRemoteContentProviderAcceptor;
} } } }

//============================================================================
namespace ucprmt {

/** The implementation id for class ucprmt::ProviderAcceptor.

	@descr  This is static so that it can easily be accessed from different
	libraries; and the overhead of 16 bytes per translation unit isn't too
	big.
 */
static sal_Int8 const aProviderAcceptorImplementationId[]
	= { sal_Int8(0x76), sal_Int8(0x64), sal_Int8(0x87), sal_Int8(0x00),
		sal_Int8(0x65), sal_Int8(0x46), sal_Int8(0x11), sal_Int8(0xD4),
		sal_Int8(0x9F), sal_Int8(0xB5), sal_Int8(0x00), sal_Int8(0x50),
		sal_Int8(0x04), sal_Int8(0x52), sal_Int8(0x6A), sal_Int8(0xAD) };

//============================================================================
/** A function to set a ucprmt::ProviderAcceptor's external Ucb.

	@descr  The first parameter must be a ucprmt::ProviderAcceptor.
 */
typedef
void
SetExternalUcb(
	com::sun::star::uno::Reference<
	    com::sun::star::ucb::XRemoteContentProviderAcceptor > const &,
	com::sun::star::uno::Reference<
	    com::sun::star::ucb::XContentProviderManager > const &);

}

#endif // _UCPRMT_RMTPAID_HXX_

