/*************************************************************************
 *
 *  $RCSfile: cunobrok.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_UCB_CONTENTPROVIDERSERVICEINFO2_HPP_
#include <com/sun/star/ucb/ContentProviderServiceInfo2.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDER_HPP_
#include <com/sun/star/ucb/XContentProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDERMANAGER_HPP_
#include <com/sun/star/ucb/XContentProviderManager.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XREMOTECONTENTPROVIDERACCEPTOR_HPP_
#include <com/sun/star/ucb/XRemoteContentProviderAcceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XREMOTECONTENTPROVIDERDISTRIBUTOR_HPP_
#include <com/sun/star/ucb/XRemoteContentProviderDistributor.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _UCBHELPER_CONFIGUREUCB_HXX_
#include <ucbhelper/configureucb.hxx>
#endif
#ifndef _UCBHELPER_REGISTERUCB_HXX_
#include <ucbhelper/registerucb.hxx>
#endif
#ifndef _VOS_DIAGNOSE_H_ 
#include <vos/diagnose.hxx>
#endif

#ifndef _UCPRMT_RMTPAID_HXX_
#include <rmtpaid.hxx>
#endif

#ifndef _CHAOS_UCB_REMOTEACCESSMANAGER_HXX_
#include <remoteaccessmanager.hxx>
#endif

#include <vos/channel.hxx>
#include <vos/mutex.hxx>
#include <vos/thread.hxx>

#include <cppuhelper/implbase1.hxx>

#include <list>

#include "cunobrok.hxx"
#include <stdio.h>

using namespace vos;
using namespace rtl;
using namespace std;
using namespace ::cppu;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::ucb;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::bridge;
using namespace ::com::sun::star::connection;

/*****************************************************************************

	implementation class declarations

*****************************************************************************/
namespace chaos_ucb {

class OInstanceProvider :
	public OWeakObject,
	public XInstanceProvider
{
public:
	OInstanceProvider( const Reference < XInterface > & rInitialObject  );
public:
	// XInterface
	Any	        SAL_CALL queryInterface( const Type & aType);
	void 		SAL_CALL acquire() 						 { OWeakObject::acquire(); }
	void 		SAL_CALL release() 						 { OWeakObject::release(); }

public:
	// XConnectCallback
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL
	getInstance( const ::rtl::OUString& sObjectName )
		throw( ::com::sun::star::container::NoSuchElementException,
			   ::com::sun::star::uno::RuntimeException);

	Reference < XInterface > m_rInitialObject;
};

OInstanceProvider::OInstanceProvider( const Reference < XInterface  > & rInitialObject  ) :
	m_rInitialObject( rInitialObject )
{
}

Any OInstanceProvider::queryInterface( const  Type & aType )
{
	Any a = ::cppu::queryInterface( aType ,
									SAL_STATIC_CAST( XInstanceProvider * , this ) );
	if( a.hasValue() )
	{
		return a;
	}
	return OWeakObject::queryInterface( aType );
}

::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >
OInstanceProvider::getInstance( const ::rtl::OUString& sObjectName )
	throw(::com::sun::star::container::NoSuchElementException,
		  ::com::sun::star::uno::RuntimeException)
{
	if( sObjectName == OUString( RTL_CONSTASCII_USTRINGPARAM( "UCB.Factory" ) ) )
	{
		return m_rInitialObject;
	}
	else if( sObjectName == OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.portal.InstallUser" ) ) )
	{
		return utl::getProcessServiceFactory()->createInstance( 
			OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.portal.InstallUser" ) ) );
	}
	
#ifdef DEBUG
	OString o = "unknown object name : ";
	o += OUStringToOString( sObjectName , RTL_TEXTENCODING_ASCII_US );
	OSL_ENSHURE( 0 , o.pData->buffer );
#endif
	return Reference< XInterface > ();
}


// ---------------------------------------------------------------------------

class OneInstanceFactory : public WeakImplHelper1< XMultiServiceFactory >
{
public:
	OneInstanceFactory( const Reference< XMultiServiceFactory > &xMgr );
	~OneInstanceFactory();
public:
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL
	          createInstance( const ::rtl::OUString& aServiceSpecifier )
		throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException) ;
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL
	          createInstanceWithArguments(
				  const ::rtl::OUString& ServiceSpecifier,
				  const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& Arguments )
		throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL
	          getAvailableServiceNames(  )
		throw(::com::sun::star::uno::RuntimeException);

private:
	
	std::vector< ucb::ContentProviderRegistrationInfo > m_aRegisteredProviders;	
	Reference< XContentProviderManager >           m_xProvMgr;
	Reference< XContentProviderManager >           m_xRemoteAccessManager;
	Reference< XContentProvider >                  m_xRemoteAccessUcp;
	Reference< XRemoteContentProviderAcceptor >    m_xProviderAcceptor;
	Reference< XRemoteContentProviderDistributor > m_xDistributor;
	Reference< XMultiServiceFactory>               m_xMgr;
};

OneInstanceFactory::OneInstanceFactory(
	const Reference< XMultiServiceFactory > &xMgr ) :
	m_xMgr( xMgr )
{}

OneInstanceFactory::~OneInstanceFactory()
{
	
	//////////////////////////////////////////////////////////////////////
	// Shutdown.
	//////////////////////////////////////////////////////////////////////
	
	if (m_xDistributor.is())
		m_xDistributor->disconnectFromAll();
	
	ucb::deregisterFromUcb(m_xRemoteAccessManager, m_aRegisteredProviders);
}



Reference< XInterface > OneInstanceFactory::createInstance(
	const ::rtl::OUString& aServiceSpecifier )
	throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException)
{
	Reference<XInterface> xRet;
	if( aServiceSpecifier == OUString::createFromAscii( "com.sun.star.lang.ServiceManager" ) )
	{
		if( !m_xProvMgr.is() )
		{
			
			//////////////////////////////////////////////////////////////////////
			// Configure and hold UniversalContentBroker service.
			//////////////////////////////////////////////////////////////////////
			
			// Create unconfigured Ucb:
			Sequence< Any > aArgs(1);
			aArgs[0] <<= sal_False;
			m_xProvMgr = Reference< XContentProviderManager >(
				m_xMgr->createInstanceWithArguments(
					OUString::createFromAscii(
						"com.sun.star.ucb.UniversalContentBroker" ),
					aArgs ),
				UNO_QUERY );
			if ( !m_xProvMgr.is() )
			{
				fprintf( stderr, "Error creating UCB service!\n" );
				return xRet;
			}
			
			if ( !::ucb::configureUcb( 
				m_xProvMgr, m_xMgr, OUString::createFromAscii(
					UCBHELPER_CONFIGURATION_KEY_LOCAL ) ) )
			{
				fprintf( stderr, "Error configuring UCB!\n" );
				return xRet;
			}
			
			//////////////////////////////////////////////////////////////////////
			// Configure and hold RemoteAccessContentProvider service.
			//////////////////////////////////////////////////////////////////////
			// THIS SECTION CAN BE REMOVED ONCE THE WEBSERVER NO LONGER NEEDS ITS
			// REMOTE ACCESS UCP IN ANOTHER PROCESS...
			
			// Create an object that will hold references to all the registered
			// instances of the Remote Access Ucp (normally, the Ucb would hold
			// references to them, but in this case the instances are not registered
			// at the Ucb):
			m_xRemoteAccessManager = new chaos_ucb::RemoteAccessManager;

			// The 'stand alone' Remote Access Ucp is used by the WebServer, which
			// has no Ucb of its own.  Since this is a single instance service, it
			// must not also be registered at the Ucb above!
			try
			{
				m_xRemoteAccessUcp
				= Reference< XContentProvider >( m_xMgr->createInstance(
					OUString::createFromAscii( "com.sun.star.ucb.RemoteAccessContentProvider")),
												 UNO_QUERY);
			}
			catch (RuntimeException const &) { throw; }
			catch (Exception const &) {}
			VOS_ASSERT( m_xRemoteAccessUcp.is());
			
			//@@@ Register the process local Ucb at the Remote Access Ucp:
			Sequence< ContentProviderServiceInfo2 > aProviders(1);
			aProviders[0].Service
			= OUString::createFromAscii(
				"com.sun.star.ucb.RemoteAccessContentProvider");
			aProviders[0].Scheme = OUString::createFromAscii(".*");
			aProviders[0].ReplaceExisting = false;
			aProviders[0].Arguments
			= OUString::createFromAscii("uno:SELF;urp;UCB.Factory");
			ucb::registerAtUcb(m_xRemoteAccessManager, m_xMgr, aProviders,
							   &m_aRegisteredProviders);
		
			//////////////////////////////////////////////////////////////////////
			// Configure and hold RemoteContentProviderAcceptor service.
			//////////////////////////////////////////////////////////////////////
			// THIS SECTION CAN BE REMOVED ONCE THE WEBSERVER NO LONGER NEEDS ITS
			// REMOTE ACCESS UCP IN ANOTHER PROCESS...
			
			// The RemoteContentProviderAcceptor service (actually, it's
			// ucprmt::ProviderAcceptor implementation) must be configured so that it
			// registers the external Ucbs only at the 'stand alone' Remote Access
			// Ucp, not at the Ucb:
			try
			{
				m_xProviderAcceptor
				= Reference< XRemoteContentProviderAcceptor >(
					m_xMgr->createInstance(
						OUString::createFromAscii(
							"com.sun.star.ucb.RemoteContentProviderAcceptor")),
					UNO_QUERY);
			}
			catch (RuntimeException const &) { throw; }
			catch (Exception const &) {}
			ucprmt::SetExternalUcb * pSetExternalUcb = 0;
			Reference< XUnoTunnel > xTunnel(m_xProviderAcceptor, UNO_QUERY);
			if (xTunnel.is())
			{
				sal_Int64 nSomething
				= xTunnel->
				getSomething(
					Sequence< sal_Int8 >(
						ucprmt::aProviderAcceptorImplementationId,
						sizeof ucprmt::aProviderAcceptorImplementationId));
				if (nSomething != 0)
				pSetExternalUcb
				= reinterpret_cast< ucprmt::SetExternalUcb * >(nSomething);
			}
			if (pSetExternalUcb)
				pSetExternalUcb(m_xProviderAcceptor, m_xRemoteAccessManager);
		
			//////////////////////////////////////////////////////////////////////
			// Configure and hold UniversalContentBroker service.
			//////////////////////////////////////////////////////////////////////
			
			try
			{
				m_xDistributor
				= Reference< XRemoteContentProviderDistributor >(
					m_xMgr->
					createInstance(
						OUString::createFromAscii(
							"com.sun.star.ucb."
							"RemoteContentProviderDistributor")),
					UNO_QUERY);
			}
			catch (RuntimeException const &) { throw; }
			catch (Exception const &) {}
		}
		return m_xMgr;
	}
	return Reference< XInterface > ();
}


Reference< XInterface > OneInstanceFactory::createInstanceWithArguments(
	const ::rtl::OUString& ServiceSpecifier,
	const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& Arguments )
	throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException)
{
	if( ! Arguments.getLength() )
	{
		return createInstance( ServiceSpecifier );
	}
	return Reference< XInterface >();
}

Sequence< ::rtl::OUString > OneInstanceFactory::getAvailableServiceNames(  )
		throw(::com::sun::star::uno::RuntimeException)
{
	OUString aName( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.lang.ServiceManager" ) );
	return Sequence< OUString > ( &aName, 1);
}



UnoBrokerThread::UnoBrokerThread(
	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &rSMgr)
{
	m_rInitialObject = ( OWeakObject * ) new OneInstanceFactory( rSMgr);

	Reference< XInterface > x = rSMgr->createInstance(
			OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.connection.Connector" ) ) );

	m_rConnector = Reference< XConnector > ( x , UNO_QUERY );
	x = rSMgr->createInstance(
 		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.bridge.BridgeFactory" ) ) );

	m_rBridgeFactory = Reference< XBridgeFactory > ( x, UNO_QUERY );
}

UnoBrokerThread::~UnoBrokerThread()
{

}

void SAL_CALL UnoBrokerThread::run()
{
	sal_Bool bFirstConnectionAccepted = sal_False;

	OSecurity userSecurity;

#ifdef ENABLEUNICODE
	OUString userIdent;
    userSecurity.getUserIdent(userIdent);

	OUString resourceName( OUString::createFromAscii( "ucb_" ) );
#else
	sal_Char userIdent[512];
    userSecurity.getUserIdent(userIdent, 512);

	OString resourceName("ucb_");
#endif

	resourceName = resourceName + userIdent;

	ORef<OChannelBroker> rBroker = OChannelBroker::getGlobalChannelBroker();
	ORef<OChannel> rChannel;

	while (schedule())
	{
		OChannelBroker::TError error = rBroker->accept(rChannel, resourceName, NULL, m_pTimeout);
		if (error == OChannelBroker::NoError)
		{
			bFirstConnectionAccepted = sal_True;
			OString sParameter( "channel,Resource=" );
			sParameter += OString::valueOf( ( sal_Int64 ) &rChannel , 10 );

			Reference < XConnection > rConnection =
				m_rConnector->connect( OStringToOUString( sParameter , RTL_TEXTENCODING_ASCII_US )  );

			if( rConnection.is() )
			{
				// Bridge object exists until first object is mapped !
				Reference< XBridge > rBridge = m_rBridgeFactory->createBridge(
					OUString(),
					OUString( RTL_CONSTASCII_USTRINGPARAM( "urp" ) ),
					rConnection,
					(XInstanceProvider *) new OInstanceProvider( m_rInitialObject ) );
			}

		}
		if( OChannelBroker::Timeout == error && ! bFirstConnectionAccepted )
		{
			terminate();
		}
	}

}

void SAL_CALL UnoBrokerThread::onTerminated()
{
}

//-------------------------------------------------------------

OAcceptorThread::OAcceptorThread(
	const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &rSMgr,
	const ::rtl::OUString &sAcceptorDescription ) :
	m_rSMgr( rSMgr ),
	m_sAcceptorDescription( sAcceptorDescription )
{
	m_rInitialObject = ( OWeakObject * ) new OneInstanceFactory( rSMgr);
}

void SAL_CALL OAcceptorThread::run()
{
	Reference < XInterface > rX = m_rSMgr->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.connection.Acceptor" ) ) );
	m_rAcceptor = Reference < XAcceptor > ( rX , UNO_QUERY );
	
	rX = m_rSMgr->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.bridge.BridgeFactory" ) ) );
	Reference < XBridgeFactory > rBridgeFacrory( rX , UNO_QUERY );
	
	OSL_ASSERT( m_rAcceptor.is() && rBridgeFacrory.is() );
	if ( m_rAcceptor.is() && rBridgeFacrory.is() )
	{
		sal_Int32 nIndex = m_sAcceptorDescription.indexOf( (sal_Unicode) ';' );
		if( -1 == nIndex )
		{
			// wrong format
			return;
		}
		OUString sConnection = m_sAcceptorDescription.copy( 0 , nIndex ).trim();
		nIndex++;
		
		sal_Int32 nIndex2 = m_sAcceptorDescription.indexOf( (sal_Unicode) ';' , nIndex );
		if( -1 == nIndex2 )
		{
			nIndex2 = m_sAcceptorDescription.getLength();
		}
		OUString sProtocol   = m_sAcceptorDescription.copy( nIndex, nIndex2 - nIndex );
		
		while ( schedule() )
		{
			try
			{
				Reference < XConnection > rConnection = m_rAcceptor->accept( sConnection );
				if( !rConnection.is() )
					break;
				
				// Bridge object exists until first object is mapped !
				Reference< XBridge > rBridge = rBridgeFacrory->createBridge(
					OUString(),
					sProtocol,
					rConnection,
					(XInstanceProvider *) new OInstanceProvider( m_rInitialObject ) );
			}
			catch( ConnectionSetupException & e )
			{
				OString sError = "ConnectionSetupException : ";
				sError += OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US );
				sError += "\nAccepting cancelled";

				OSL_ENSHURE( 0 , sError.getStr() );
				break;
			}
			catch( IllegalArgumentException & e )
			{
				OString sError = "OAcceptorThread: IllegalArgumentException : ";
				sError += OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US );
				sError += "\n";
				sError += OUStringToOString( m_sAcceptorDescription, RTL_TEXTENCODING_ASCII_US );

				sError += "\nAccepting cancelled";

				OSL_ENSHURE( 0 , sError.getStr() );
				break;
			}

		}
	}
}

void SAL_CALL OAcceptorThread::terminate()
{
	OThread::terminate();
	if( m_rAcceptor.is() )
	{
		m_rAcceptor->stopAccepting();
#ifndef LINUX
		// The accepting thread does not return on linux
		join();
#endif
	}
}

void SAL_CALL OAcceptorThread::onTerminated()
{
}

}
