/*************************************************************************
 *
 *  $RCSfile: cunobrok.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include <vos/thread.hxx>

#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#include <com/sun/star/connection/XConnector.hpp>
#include <com/sun/star/connection/XAcceptor.hpp>
#include <com/sun/star/bridge/XBridgeFactory.hpp>

namespace chaos_ucb {


class UnoBrokerThread : public ::vos::OThread
{

public:

	UnoBrokerThread(
		const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &rSMgr);
	~UnoBrokerThread();

	void setTimeout(TimeValue* pTimeout)
		{
			m_pTimeout = pTimeout;
		}

protected:

	virtual void SAL_CALL run();
	virtual void SAL_CALL onTerminated();

private:
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > m_rInitialObject;
	::com::sun::star::uno::Reference< ::com::sun::star::connection::XConnector > m_rConnector;
	::com::sun::star::uno::Reference< ::com::sun::star::bridge::XBridgeFactory > m_rBridgeFactory;
	sal_Bool 				m_bWaitForObject;
	TimeValue* 				m_pTimeout;
};


/*****************
 * This thread is used, when application is started as appserver
 * Note : No security is checked, every user may connect to the application !
 *****************/
class OAcceptorThread : public ::vos::OThread
{
public:

	OAcceptorThread(
		const ::com::sun::star::uno::Reference<
		      ::com::sun::star::lang::XMultiServiceFactory > &rSMgr,
		const ::rtl::OUString &sAcceptorParameter);

	
	virtual void SAL_CALL run();
	virtual void SAL_CALL onTerminated();

	virtual void SAL_CALL terminate();

private:

	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > m_rInitialObject;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > m_rSMgr;
	::com::sun::star::uno::Reference< ::com::sun::star::connection::XAcceptor  > m_rAcceptor;
	::rtl::OUString m_sAcceptorDescription;
};

}

