/*************************************************************************
 *
 *  $RCSfile: ucbmain.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/**************************************************************************
								TODO
 **************************************************************************

 *************************************************************************/

#include <string.h>
#include <stdio.h>
#include <vector>

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef _RTL_USTRING_HXX
#include <rtl/ustring.hxx>
#endif
#ifndef _VOS_TIMER_HXX_
#include <vos/timer.hxx>
#endif
#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include <cppuhelper/servicefactory.hxx>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _UNOTOOLS_REGPATHHELPER_HXX_
#include <unotools/regpathhelper.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif



#include "cunobrok.hxx"

using namespace vos;
using namespace rtl;
using namespace cppu;
using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace com::sun::star::bridge;
using namespace com::sun::star::registry;

//=============================================================================
//
// main.
//
//=============================================================================

#ifdef WNT
#	define MAIN _cdecl main
#else
#	define MAIN main
#endif

#ifdef SOLARIS
extern "C"
{
	void ChangeGlobalInit();
}
#endif

int MAIN
(
	int			 nArgC,
	const char** sArgV
)
{
#ifdef SOLARIS
	// Voodoo stuff...
	ChangeGlobalInit();
#endif

  	fprintf( stdout, "\n" );
  	fprintf( stdout, "\t\t\tUniversal Content Broker (UCB)\n" );
  	fprintf( stdout, "\t\t\t------------------------------\n" );
  	fprintf( stdout, "\n" );
  	fprintf( stdout, "Initializing...\n" );

//	fprintf( stdout, "Application: %s\n", sArgV[ 0 ] );
//	fprintf( stdout, "Parameters: %u\n", nArgC );

	sal_Bool bStartedFromDaemon = sal_True;

	OUString aConnection
		= OUString::createFromAscii( "socket,host=0,port=8121" );
	OUString aProtocol
		= OUString::createFromAscii( "urp" );

	if ( nArgC > 1 )
	{
		OUString aProt;
		OUString aConn;

//		fprintf( stdout, "Parameter:\n" );
		for ( int i = 1; i < nArgC; i++ )
		{
//			fprintf( stdout, "%s\n", sArgV[ i ] );
			if ( strcmp( sArgV[ i ], "-w" ) == 0 )
			{
				fprintf( stdout, "Waiting. Press [Enter] to continue.\n" );

				fgetc( stdin );

				fprintf( stdout, "Continuing...\n" );
			}
			else if ( strcmp( sArgV[ i ], "-standalone" ) == 0 )
			{
				bStartedFromDaemon = sal_False;
			}
			else if ( strncmp( sArgV[ i ], "-connection=", 12 ) == 0 )
			{
				aConn = OUString( sArgV[ i ], strlen( sArgV[ i ] ),
								  RTL_TEXTENCODING_ASCII_US )
						  .replaceAt( 0, 12, OUString() );
			}
			else if ( strncmp( sArgV[ i ], "-protocol=", 10 ) == 0 )
			{
				aProt = OUString( sArgV[ i ], strlen( sArgV[ i ] ),
								  RTL_TEXTENCODING_ASCII_US )
						  .replaceAt( 0, 10, OUString() );
			}
		}

		if ( !bStartedFromDaemon )
		{
			if ( aProt.getLength() )
				aProtocol = aProt;

			if ( aConn.getLength() )
				aConnection = aConn;
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Initialize local Service Manager and basic services.
	//////////////////////////////////////////////////////////////////////

	Reference< XMultiServiceFactory > xSMgr;
	try
	{
		xSMgr = cppu::createRegistryServiceFactory(
			utl::getPathToSystemRegistry(), OUString(), sal_True );
	}
	catch ( com::sun::star::uno::Exception )
	{
		fprintf( stderr, "Error creating RegistryServiceFactory!\n" );
		return 1;
	}

	utl::setProcessServiceFactory( xSMgr );

	//////////////////////////////////////////////////////////////////////
	// Copy installation.
	//////////////////////////////////////////////////////////////////////

	Any aAny;
	Reference< XInterface > xRef =  xSMgr->createInstanceWithArguments(
				OUString::createFromAscii( "com.sun.star.portal.InstallUser" ),
				Sequence< Any >( &aAny, 1 ) );

	//////////////////////////////////////////////////////////////////////
	// Start service.
	//////////////////////////////////////////////////////////////////////

	if ( bStartedFromDaemon )
	{
		::chaos_ucb::UnoBrokerThread broker( xSMgr );

		TTimeValue t( 10, 0 );

		broker.create();

  		fprintf( stdout, "Started.\n" );

		broker.join();

  		fprintf( stdout, "Exiting...\n" );
	}
	else
	{
		//////////////////////////////////////////////////////////////////////
		// Create connection broker and let him accept incoming calls.
		//////////////////////////////////////////////////////////////////////

		OUString
		aConnDescr	= aConnection;
		aConnDescr += OUString::createFromAscii( ";" );
		aConnDescr += aProtocol;
		aConnDescr += OUString::createFromAscii( ";" );

		::chaos_ucb::OAcceptorThread acceptor(
			xSMgr,
			aConnDescr );

		acceptor.create();

  		fprintf( stdout, "Started.\n" );

//		fgetc( stdin );
		acceptor.join();

		fprintf( stdout , "Terminating...\n" );

		acceptor.terminate();

  		fprintf( stdout, "Exiting...\n" );
	}

	Reference< XComponent > xCompSMgr( xSMgr, UNO_QUERY );
	if ( xCompSMgr.is() )
		xCompSMgr->dispose();

	return 0;
}
