/*************************************************************************
 *
 *  $RCSfile: filrow.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FILROW_HXX_
#define _FILROW_HXX_
#endif

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XTYPECONVERTER_HPP_
#include <com/sun/star/script/XTypeConverter.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDER_HPP_
#include <com/sun/star/ucb/XContentProvider.hpp>
#endif

namespace fileaccess {

	class shell;

	class XRow_impl:
		public cppu::OWeakObject,
		public com::sun::star::sdbc::XRow
	{
	public:
		XRow_impl( shell* pShell,const com::sun::star::uno::Sequence< com::sun::star::uno::Any >& __m_aValueMap );
		~XRow_impl();

		virtual com::sun::star::uno::Any SAL_CALL
		queryInterface( 
			const com::sun::star::uno::Type& aType ) 
			throw( com::sun::star::uno::RuntimeException);
  
		virtual void SAL_CALL
		acquire( 
			void ) 
			throw( com::sun::star::uno::RuntimeException);
  
		virtual void SAL_CALL
		release(
			void ) 
			throw( com::sun::star::uno::RuntimeException);
  
		virtual sal_Bool SAL_CALL
		wasNull(
			void )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException );
	  
		virtual rtl::OUString SAL_CALL
		getString( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual sal_Bool SAL_CALL
		getBoolean( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
	  
		virtual sal_Int8 SAL_CALL
		getByte( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual sal_Int16 SAL_CALL
		getShort( 
			sal_Int32 columnIndex ) 
			throw( 
				com::sun::star::sdbc::SQLException, 
				com::sun::star::uno::RuntimeException );
  
		virtual sal_Int32 SAL_CALL
		getInt( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException,
				   com::sun::star::uno::RuntimeException );
  
		virtual sal_Int64 SAL_CALL
		getLong( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException,
				   com::sun::star::uno::RuntimeException );
  
		virtual float SAL_CALL
		getFloat( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual double SAL_CALL
		getDouble( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
		
		virtual com::sun::star::uno::Sequence< sal_Int8 > SAL_CALL
		getBytes(
			sal_Int32 columnIndex )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::util::Date SAL_CALL
		getDate( 
			sal_Int32 columnIndex )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::util::Time SAL_CALL
		getTime(
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::util::DateTime SAL_CALL
		getTimestamp( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::io::XInputStream > SAL_CALL
		getBinaryStream( 
			sal_Int32 columnIndex )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::io::XInputStream > SAL_CALL
		getCharacterStream( 
			sal_Int32 columnIndex )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Any SAL_CALL
		getObject( 
			sal_Int32 columnIndex, 
			const com::sun::star::uno::Reference< com::sun::star::container::XNameAccess >& typeMap )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::sdbc::XRef > SAL_CALL
		getRef( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::sdbc::XBlob > SAL_CALL
		getBlob( 
			sal_Int32 columnIndex )
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::sdbc::XClob > SAL_CALL
		getClob( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
		virtual com::sun::star::uno::Reference< com::sun::star::sdbc::XArray > SAL_CALL
		getArray( 
			sal_Int32 columnIndex ) 
			throw( com::sun::star::sdbc::SQLException, 
				   com::sun::star::uno::RuntimeException);
  
	private:
		vos::OMutex                                                              m_aMutex;
		com::sun::star::uno::Sequence< com::sun::star::uno::Any >                m_aValueMap;
		sal_Bool                                                                 m_nWasNull;
		shell*                                                                   m_pMyShell;
		com::sun::star::uno::Reference< com::sun::star::ucb::XContentProvider >  m_xProvider;
		com::sun::star::uno::Reference< com::sun::star::script::XTypeConverter > m_xTypeConverter;
	};

} // end namespace fileaccess
