/*************************************************************************
 *
 *  $RCSfile: rmtpacc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UCPRMT_RMTPACC_HXX_
#include <rmtpacc.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_CONTENTPROVIDERSERVICEINFO2_HPP_
#include <com/sun/star/ucb/ContentProviderServiceInfo2.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDERMANAGER_HPP_
#include <com/sun/star/ucb/XContentProviderManager.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_ 
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _UCBHELPER_REGISTERUCB_HXX_
#include <ucbhelper/registerucb.hxx>
#endif
#ifndef _RTL_MEMORY_H_
#include <rtl/memory.h>
#endif
#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#ifndef _UCPRMT_RMTPAID_HXX_
#include <rmtpaid.hxx>
#endif

using namespace com::sun;
using namespace com::sun::star;
using namespace ucprmt;

//============================================================================
//
//  ProviderAcceptor
//
//============================================================================

inline
ProviderAcceptor::Data::Data(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory):
	m_xFactory(rTheFactory)
{}

//============================================================================
ProviderAcceptor::ProviderAcceptor(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory):
	m_xFactory(rTheFactory),
	m_bExternalUcb(false)
{
	VOS_ASSERT(m_xFactory.is());
}

//============================================================================
// virtual
uno::Any SAL_CALL ProviderAcceptor::queryInterface(uno::Type const & rType)
	throw (uno::RuntimeException)
{
	uno::Any
		aRet(cppu::queryInterface(
			     rType,
				 static_cast< lang::XServiceInfo * >(this),
				 static_cast< lang::XTypeProvider * >(this),
				 static_cast< star::ucb::XRemoteContentProviderAcceptor * >(
					 this),
				 static_cast< star::ucb::XRemoteContentProviderSupplier * >(
					 this),
				 static_cast< lang::XUnoTunnel * >(this)));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

//============================================================================
// virtual
void SAL_CALL ProviderAcceptor::acquire() throw ()
{
	OWeakObject::acquire();
}

//============================================================================
// virtual
void SAL_CALL ProviderAcceptor::release() throw ()
{
	OWeakObject::release();
}

//============================================================================
// virtual
rtl::OUString SAL_CALL ProviderAcceptor::getImplementationName()
	throw (uno::RuntimeException)
{
	return rtl::OUString::createFromAscii(getImplementationName_static());
}

//============================================================================
// virtual
sal_Bool SAL_CALL ProviderAcceptor::supportsService(rtl::OUString const &
													    rServiceName)
	throw (uno::RuntimeException)
{
	uno::Sequence< rtl::OUString > aNames(getSupportedServiceNames_static());
	for (sal_Int32 i = 0; i < aNames.getLength(); ++i)
		if (aNames[i] == rServiceName)
			return true;
	return false;
}

//============================================================================
// virtual
uno::Sequence< rtl::OUString > SAL_CALL
ProviderAcceptor::getSupportedServiceNames() throw (uno::RuntimeException)
{
	return getSupportedServiceNames_static();
}

//============================================================================
// virtual
uno::Sequence< uno::Type > SAL_CALL ProviderAcceptor::getTypes()
	throw (uno::RuntimeException)
{
	static cppu::OTypeCollection * pCollection = 0;
	if (!pCollection)
	{
		osl::MutexGuard aGuard(osl::Mutex::getGlobalMutex());
		if (!pCollection)
		{
			static cppu::OTypeCollection
				aTheCollection(
					getCppuType(
						static_cast< uno::Reference< lang::XServiceInfo >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference< lang::XTypeProvider >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference<
						           star::ucb::XRemoteContentProviderAcceptor >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference<
						           star::ucb::XRemoteContentProviderSupplier >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference< lang::XUnoTunnel >
						                 const * >(
							0)));
			pCollection = &aTheCollection;
		}
	}
	return pCollection->getTypes();
}

//============================================================================
// virtual
uno::Sequence< sal_Int8 > SAL_CALL ProviderAcceptor::getImplementationId()
	throw (uno::RuntimeException)
{
	return
		uno::Sequence< sal_Int8 >(aProviderAcceptorImplementationId,
								  sizeof aProviderAcceptorImplementationId);
}

//============================================================================
// virtual
sal_Bool SAL_CALL
ProviderAcceptor::addRemoteContentProvider(
	rtl::OUString const & rIdentifier,
	uno::Reference< lang::XMultiServiceFactory > const & rFactory,
	uno::Sequence< rtl::OUString > const & rTemplates)
	throw (uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	std::pair< HashMap::iterator, bool >
		aInsert(m_aMap.insert(HashMap::value_type(rIdentifier,
												  Data(rFactory))));
	if (!aInsert.second)
		return false;

	if (!m_bExternalUcb && m_aMap.size() == 1)
	{
		VOS_ASSERT(!m_xUcb.is());
		try
		{
			m_xUcb
				= uno::Reference< star::ucb::XContentProviderManager >(
					  m_xFactory->
				          createInstance(
							  rtl::OUString::createFromAscii(
								  "com.sun.star.ucb.UniversalContentBroker")),
					  uno::UNO_QUERY);
		}
		catch (uno::RuntimeException const &) { throw; }
		catch (uno::Exception const &) {}
	}

	//@@@ Register the remote ucb on appropriate url templates:
	rtl::OUStringBuffer aTemplate;
	aTemplate.appendAscii(RTL_CONSTASCII_STRINGPARAM("\"file://"));
	sal_Unicode const * p = rIdentifier.getStr();
	sal_Unicode const * pEnd = p + rIdentifier.getLength();
	while (p != pEnd)
	{
		sal_Unicode c = *p++;
		switch (c)
		{
			case '"':
			case '\\':
				aTemplate.append(sal_Unicode('\\'));
			default:
				aTemplate.append(c);
				break;
		}
	}
	aTemplate.appendAscii(RTL_CONSTASCII_STRINGPARAM(
		                      "\"(([/?#].*)?)->\"file://\"\\1"));
	uno::Sequence< star::ucb::ContentProviderServiceInfo2 > aProviders(1);
	aProviders[0].Service
		= rtl::OUString::createFromAscii(
			  "com.sun.star.ucb.RemoteAccessContentProvider");
	aProviders[0].Scheme = aTemplate.makeStringAndClear();
	aProviders[0].ReplaceExisting = false;
	aProviders[0].Arguments
		= rtl::OUString::createFromAscii("uno:FACTORY,id=");
	aProviders[0].Arguments += rIdentifier; //@@@ encode!
	aProviders[0].Arguments
		+= rtl::OUString::createFromAscii(";urp;UCB.Factory");

	::ucb::registerAtUcb(m_xUcb, m_xFactory, aProviders,
						 &aInsert.first->second.m_aProviders);
	return true;
}

//============================================================================
// virtual
sal_Bool SAL_CALL
ProviderAcceptor::removeRemoteContentProvider(rtl::OUString const &
											      rIdentifier)
	throw (uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	HashMap::iterator aIt(m_aMap.find(rIdentifier));
	if (aIt == m_aMap.end())
		return false;

	::ucb::deregisterFromUcb(m_xUcb, aIt->second.m_aProviders);
	m_aMap.erase(aIt);
	if (!m_bExternalUcb && m_aMap.size() == 0)
		m_xUcb = 0;
	return true;
}

//============================================================================
// virtual
uno::Reference< lang::XMultiServiceFactory > SAL_CALL
ProviderAcceptor::queryRemoteContentProvider(rtl::OUString const &
											     rIdentifier)
	throw (uno::RuntimeException)
{
	osl::MutexGuard aGuard(m_aMutex);

	HashMap::iterator aIt(m_aMap.find(rIdentifier));
	if (aIt == m_aMap.end())
		return 0;
	else
		return aIt->second.m_xFactory;
}

//============================================================================
// virtual
sal_Int64 SAL_CALL
ProviderAcceptor::getSomething(uno::Sequence< sal_Int8 > const & rIdentifier)
	throw (uno::RuntimeException)
{
	return (rIdentifier.getLength()
			    == sizeof aProviderAcceptorImplementationId
			&& rtl_compareMemory(aProviderAcceptorImplementationId,
								 rIdentifier.getConstArray(),
								 sizeof aProviderAcceptorImplementationId)
			       == 0) ?
		       reinterpret_cast< sal_Int64 >(setExternalUcb) : 0;
		// hope that reinterpret_cast< sal_Int64 >(&setExternalUcb) == 0 is
		// always false...
}

//============================================================================
// static
sal_Char const * ProviderAcceptor::getImplementationName_static()
{
	return "ucprmt::ProviderAcceptor";
}

//============================================================================
// static
uno::Sequence< rtl::OUString >
ProviderAcceptor::getSupportedServiceNames_static()
{
	uno::Sequence< rtl::OUString > aNames(1);
	aNames[0] = rtl::OUString::createFromAscii(
		            "com.sun.star.ucb.RemoteContentProviderAcceptor");
	return aNames;
}

//============================================================================
// static
uno::Reference< uno::XInterface > SAL_CALL
ProviderAcceptor::createInstance(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory)
{
	return
		static_cast< uno::XWeak * >(static_cast< cppu::OWeakObject * >(
			                            new ProviderAcceptor(rTheFactory)));
}

//============================================================================
// static
void
ProviderAcceptor::setExternalUcb(
	uno::Reference< star::ucb::XRemoteContentProviderAcceptor > const &
	    rAcceptor,
	uno::Reference< star::ucb::XContentProviderManager > const & rUcb)
{
	VOS_ASSERT(rAcceptor.is());
	ProviderAcceptor * pThis
		= static_cast< ProviderAcceptor * >(rAcceptor.get());

	VOS_ASSERT(pThis->m_bExternalUcb || !pThis->m_xUcb.is());
	pThis->m_xUcb = rUcb;
	pThis->m_bExternalUcb = true;
}

