/*************************************************************************
 *
 *  $RCSfile: rmtprov.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UCPRMT_RMTPROV_HXX_
#include <rmtprov.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_ 
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_ 
#include <osl/mutex.hxx>
#endif
#ifndef _RTL_USTRING_HXX_ 
#include <rtl/ustring.hxx>
#endif

#ifndef _UCPRMT_RMTCONN_HXX_
#include <rmtconn.hxx>
#endif

using namespace com::sun;
using namespace com::sun::star;
using namespace ucprmt;

//============================================================================
//
//  ContentProvider
//
//============================================================================

ContentProvider::ContentProvider(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory):
	m_xFactory(rTheFactory),
	m_xConnectionMap(new ConnectionMap(rTheFactory))
{
	VOS_ASSERT(m_xFactory.is());
}

//============================================================================
// virtual
uno::Any SAL_CALL ContentProvider::queryInterface(uno::Type const & rType)
	throw (uno::RuntimeException)
{
	uno::Any
		aRet(cppu::queryInterface(
			     rType,
				 static_cast< lang::XServiceInfo * >(this),
				 static_cast< lang::XTypeProvider * >(this),
				 static_cast< star::ucb::XContentProvider * >(this),
				 static_cast< star::ucb::XParameterizedContentProvider * >(
					 this)));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

//============================================================================
// virtual
void SAL_CALL ContentProvider::acquire() throw ()
{
	OWeakObject::acquire();
}

//============================================================================
// virtual
void SAL_CALL ContentProvider::release() throw ()
{
	OWeakObject::release();
}

//============================================================================
// virtual
rtl::OUString SAL_CALL ContentProvider::getImplementationName()
	throw (uno::RuntimeException)
{
	return rtl::OUString::createFromAscii(getImplementationName_static());
}

//============================================================================
// virtual
sal_Bool SAL_CALL ContentProvider::supportsService(rtl::OUString const &
												       rServiceName)
	throw (uno::RuntimeException)
{
	uno::Sequence< rtl::OUString > aNames(getSupportedServiceNames_static());
	for (sal_Int32 i = 0; i < aNames.getLength(); ++i)
		if (aNames[i] == rServiceName)
			return true;
	return false;
}

//============================================================================
// virtual
uno::Sequence< rtl::OUString > SAL_CALL
ContentProvider::getSupportedServiceNames() throw (uno::RuntimeException)
{
	return getSupportedServiceNames_static();
}

//============================================================================
// virtual
uno::Sequence< uno::Type > SAL_CALL ContentProvider::getTypes()
	throw (uno::RuntimeException)
{
	static cppu::OTypeCollection * pCollection = 0;
	if (!pCollection)
	{
		osl::MutexGuard aGuard(osl::Mutex::getGlobalMutex());
		if (!pCollection)
		{
			static cppu::OTypeCollection
				aTheCollection(
					getCppuType(
						static_cast< uno::Reference< lang::XServiceInfo >
						                 const * >(
							0)),
					getCppuType(
						static_cast< uno::Reference< lang::XTypeProvider >
						                 const * >(
							0)),
					getCppuType(
						static_cast<
						        uno::Reference<
						            star::ucb::XContentProvider > const * >(
							0)),
					getCppuType(
						static_cast<
						        uno::Reference<
						 star::ucb::XParameterizedContentProvider > const * >(
							0)));
			pCollection = &aTheCollection;
		}
	}
	return pCollection->getTypes();
}

//============================================================================
// virtual
uno::Sequence< sal_Int8 > SAL_CALL ContentProvider::getImplementationId()
	throw (uno::RuntimeException)
{
	static cppu::OImplementationId * pID = 0;
	if (!pID)
	{
		osl::MutexGuard aGuard(osl::Mutex::getGlobalMutex());
		if (!pID)
		{
			static cppu::OImplementationId aTheID(false);
			pID = &aTheID;
		}
	}
	return pID->getImplementationId();
}

//============================================================================
// virtual
uno::Reference< star::ucb::XContent >
ContentProvider::queryContent(
	uno::Reference< star::ucb::XContentIdentifier > const & rIdentifier)
	throw (star::ucb::IllegalIdentifierException, uno::RuntimeException)
{
	vos::ORef< Connection > xConnection = m_xConnectionMap->find(rIdentifier);
	if (!xConnection.isValid())
		throw star::ucb::IllegalIdentifierException();

	return xConnection->queryContent(rIdentifier);
}

//============================================================================
// virtual
sal_Int32
ContentProvider::compareContentIds(
	uno::Reference< star::ucb::XContentIdentifier > const & rId1,
	uno::Reference< star::ucb::XContentIdentifier > const & rId2)
	throw (uno::RuntimeException)
{
	vos::ORef< Connection > xConnection1;
	vos::ORef< Connection > xConnection2;
	{
		osl::MutexGuard aGuard(m_xConnectionMap->getMutex());
		xConnection1 = m_xConnectionMap->find(rId1);
		xConnection2 = m_xConnectionMap->find(rId2);
	}

	if (xConnection1.isValid() && xConnection1.isEqualBody(xConnection2))
		return xConnection1->compareContentIds(rId1, rId2);

	rtl::OUString aURI1;
	if (rId1.is())
		aURI1 = rId1->getContentIdentifier();
	rtl::OUString aURI2;
	if (rId2.is())
		aURI2 = rId2->getContentIdentifier();
	return aURI1.compareTo(aURI2);
}

//============================================================================
// virtual
uno::Reference< star::ucb::XContentProvider > SAL_CALL
ContentProvider::registerInstance(rtl::OUString const & rTemplate,
								  rtl::OUString const & rArguments,
								  sal_Bool bReplaceExisting)
	throw (lang::IllegalArgumentException, uno::RuntimeException)
{
	if (rArguments.getLength() == 0)
		return this;

	vos::ORef< Connection >
		xConnection(m_xConnectionMap->getConnection(rArguments));
	if (!xConnection.isValid())
		throw lang::IllegalArgumentException();

	if (xConnection->addLocalURITemplate(rTemplate,
										 bReplaceExisting != false))
		return xConnection.getBodyPtr();
	else
		return 0;
}

//============================================================================
// virtual
uno::Reference< star::ucb::XContentProvider > SAL_CALL
ContentProvider::deregisterInstance(rtl::OUString const & rTemplate,
									rtl::OUString const & rArguments)
	throw (lang::IllegalArgumentException, uno::RuntimeException)
{
	if (rArguments.getLength() == 0)
		return this;

	vos::ORef< Connection >
		xConnection(m_xConnectionMap->getConnection(rArguments));
	if (!xConnection.isValid())
		throw lang::IllegalArgumentException();

	if (xConnection->removeLocalURITemplate(rTemplate))
		return xConnection.getBodyPtr();
	else
		return 0;
}

//============================================================================
// static
sal_Char const * ContentProvider::getImplementationName_static()
{
	return "ucprmt::ContentProvider";
}

//============================================================================
// static
uno::Sequence< rtl::OUString >
ContentProvider::getSupportedServiceNames_static()
{
	uno::Sequence< rtl::OUString > aNames(1);
	aNames[0] = rtl::OUString::createFromAscii(
		            "com.sun.star.ucb.RemoteAccessContentProvider");
	return aNames;
}

//============================================================================
// static
uno::Reference< uno::XInterface > SAL_CALL
ContentProvider::createInstance(
	uno::Reference< lang::XMultiServiceFactory > const & rTheFactory)
{
	return static_cast< uno::XWeak * >(static_cast< cppu::OWeakObject * >(
		                                   new ContentProvider(rTheFactory)));
}

