/*************************************************************************
 *
 *  $RCSfile: NeonInputStream.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _NEONINPUTSTREAM_HXX_
#define _NEONINPUTSTREAM_HXX_

#include <cppuhelper/weak.hxx>
#include <sal/types.h>
#include <rtl/ustring.hxx>
#include <com/sun/star/io/XInputStream.hpp>


namespace webdav_ucp
{

// -------------------------------------------------------------------
// NeonInputStream
// A simple XInputStream implementation provided specifically for use
// by the DAVSession::GET method.
// -------------------------------------------------------------------
class NeonInputStream : public ::com::sun::star::io::XInputStream,
						public ::cppu::OWeakObject
{
	private:
		::rtl::OUString	mInputBuffer;
		sal_Int32		mLen;
		sal_Int32		mPos;

	public:
				 NeonInputStream( void );
		virtual ~NeonInputStream();

		// Add some data to the end of the stream
		void AddToStream( const char * inBuf, sal_Int32 inLen );

	// XInterface
	virtual com::sun::star::uno::Any SAL_CALL queryInterface(
										const ::com::sun::star::uno::Type & type )
							throw( ::com::sun::star::uno::RuntimeException );

	virtual void SAL_CALL acquire( void )
							throw ( ::com::sun::star::uno::RuntimeException )
								{ OWeakObject::acquire(); }

	virtual void SAL_CALL release( void )
							throw( ::com::sun::star::uno::RuntimeException )
								{ OWeakObject::release(); }


	// XInputStream
	virtual sal_Int32 SAL_CALL readBytes(
	  		::com::sun::star::uno::Sequence< sal_Int8 > & aData,
			sal_Int32 nBytesToRead )
				throw( ::com::sun::star::io::NotConnectedException,
			   		   ::com::sun::star::io::BufferSizeExceededException,
			   		   ::com::sun::star::io::IOException,
			   		   ::com::sun::star::uno::RuntimeException );

	virtual sal_Int32 SAL_CALL readSomeBytes(
    		::com::sun::star::uno::Sequence< sal_Int8 > & aData,
			sal_Int32 nMaxBytesToRead )
        		throw( ::com::sun::star::io::NotConnectedException,
               		   ::com::sun::star::io::BufferSizeExceededException,
               		   ::com::sun::star::io::IOException,
               		   ::com::sun::star::uno::RuntimeException );

	virtual void SAL_CALL skipBytes( sal_Int32 nBytesToSkip )
        		throw( ::com::sun::star::io::NotConnectedException,
               		   ::com::sun::star::io::BufferSizeExceededException,
               		   ::com::sun::star::io::IOException,
               		   ::com::sun::star::uno::RuntimeException );

	virtual sal_Int32 SAL_CALL available( void )
        		throw( ::com::sun::star::io::NotConnectedException,
               		   ::com::sun::star::io::BufferSizeExceededException,
               		   ::com::sun::star::uno::RuntimeException );

	virtual void SAL_CALL closeInput( void )
        		throw( ::com::sun::star::io::NotConnectedException,
               		   ::com::sun::star::io::IOException,
               		   ::com::sun::star::uno::RuntimeException )
					{};
};

}; // namespace webdav_ucp
#endif // _NEONINPUTSTREAM_HXX_
