/*************************************************************************
 *
 *  $RCSfile: authinteraction.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONABORT_HPP_
#include <com/sun/star/task/XInteractionAbort.hpp>
#endif

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONRETRY_HPP_
#include <com/sun/star/task/XInteractionRetry.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_AUTHENTICATIONREQUEST_HPP_
#include <com/sun/star/ucb/AuthenticationRequest.hpp>
#endif

#ifndef _COM_SUN_STAR_UCB_REMEMBERAUTHENTICATION_HPP_
#include <com/sun/star/ucb/RememberAuthentication.hpp>
#endif

#ifndef _COM_SUN_STAR_UCB_XINTERACTIONSUPPLYAUTHENTICATION_HPP_
#include <com/sun/star/ucb/XInteractionSupplyAuthentication.hpp>
#endif
#ifndef _LOGINERR_HXX
#include <svtools/loginerr.hxx>
#endif


#include <authinteraction.hxx>

using namespace com::sun::star::task;
using namespace com::sun::star::ucb;
using namespace com::sun::star::uno;
using rtl::OUString;

using namespace webdav_ucp;



//============================================================================
class InteractionAbort_Impl: public InteractionContinuation_Impl,
			     public XInteractionAbort
{
public:
  InteractionAbort_Impl(const vos::ORef<InteractionRequest_Impl> &
			rRequest):
    InteractionContinuation_Impl(rRequest) {}

  virtual com::sun::star::uno::Any SAL_CALL queryInterface(const com::sun::star::uno::Type & rType);
  virtual void SAL_CALL acquire() { OWeakObject::acquire(); }
  virtual void SAL_CALL release() { OWeakObject::release(); }
  virtual void SAL_CALL select() { recordSelection(); }
};

//============================================================================
class InteractionRetry_Impl: public InteractionContinuation_Impl,
			     public XInteractionRetry
{
public:
  InteractionRetry_Impl(const vos::ORef<InteractionRequest_Impl> &
			rRequest):
    InteractionContinuation_Impl(rRequest) {}

  virtual com::sun::star::uno::Any SAL_CALL queryInterface(const com::sun::star::uno::Type & rType);
  virtual void SAL_CALL acquire() { OWeakObject::acquire(); }
  virtual void SAL_CALL release() { OWeakObject::release(); }
  virtual void SAL_CALL select() { recordSelection(); }
};

//============================================================================
class InteractionSupplyAuthentication_Impl:
	public InteractionContinuation_Impl,
	public XInteractionSupplyAuthentication
{

public:
  InteractionSupplyAuthentication_Impl
  (const vos::ORef<InteractionRequest_Impl> & rRequest);

  virtual com::sun::star::uno::Any SAL_CALL queryInterface(const com::sun::star::uno::Type & rType);
  virtual void SAL_CALL acquire() { OWeakObject::acquire(); }
  virtual void SAL_CALL release() { OWeakObject::release(); }

  virtual void SAL_CALL select() { recordSelection(); }
  virtual sal_Bool SAL_CALL canSetRealm() { return sal_False; }
  virtual void SAL_CALL setRealm(const OUString &) {};
  virtual sal_Bool SAL_CALL canSetUserName() { return sal_True; }
  virtual void SAL_CALL setUserName(const OUString & rTheUserName);
  virtual sal_Bool SAL_CALL canSetPassword() { return sal_True; }
  virtual void SAL_CALL setPassword(const OUString & rThePassword);

  virtual Sequence<RememberAuthentication>
  SAL_CALL getRememberPasswordModes(RememberAuthentication & rDefault);

  virtual void SAL_CALL setRememberPassword(RememberAuthentication
					    eTheRemember);

  virtual sal_Bool SAL_CALL canSetAccount() { return sal_False; }

  virtual void SAL_CALL setAccount(const OUString & rTheAccount) {};

  virtual Sequence<RememberAuthentication>
  SAL_CALL getRememberAccountModes(RememberAuthentication & rDefault)
    { return getRememberPasswordModes(rDefault); }

  virtual void SAL_CALL setRememberAccount(RememberAuthentication
					   eTheRemember)
    { setRememberPassword(eTheRemember); }

};




//============================================================================
//
//  class InteractionRequest_Impl
//
//============================================================================

InteractionRequest_Impl::InteractionRequest_Impl(
		const rtl::OUString& serverName,
		const rtl::OUString& realm,
		rtl::OUStringBuffer& userName,
		rtl::OUStringBuffer& password )
  : _serverName(serverName), _realm(realm), _userName(userName),
	_password(password)
{}

//============================================================================
// virtual
Any SAL_CALL
InteractionRequest_Impl::queryInterface(const com::sun::star::uno::Type & rType)
{
  Any aRet = cppu::queryInterface(rType,
				  static_cast< XInteractionRequest * >(this));
  return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

//============================================================================
// virtual
Any SAL_CALL InteractionRequest_Impl::getRequest()
{
  AuthenticationRequest request;

  request.ServerName = _serverName;

  request.HasRealm = _realm.getLength() > 0;
  if (request.HasRealm)
    request.Realm = _realm;

  request.HasUserName = sal_True;
  request.UserName = OUString(_userName);
  request.HasPassword = sal_True;
  request.Password = OUString(_password);

  return makeAny(request);
}

//============================================================================
// virtual
Sequence<Reference<XInteractionContinuation> >
SAL_CALL InteractionRequest_Impl::getContinuations()
{
  Sequence< Reference<XInteractionContinuation> > aContinuations(3);
  sal_Int32 nLength = 0;
  aContinuations[nLength++] = new InteractionAbort_Impl(this);
  aContinuations[nLength++] = new InteractionRetry_Impl(this);
  aContinuations[nLength++] = new InteractionSupplyAuthentication_Impl(this);
  return aContinuations;
}


//============================================================================
//
//  class InteractionAbort_Impl
//
//============================================================================

// virtual
Any SAL_CALL
InteractionAbort_Impl::queryInterface(const com::sun::star::uno::Type & rType)
{
	Any aRet = cppu::queryInterface(rType,
						static_cast< XInteractionContinuation * >(this),
	   					static_cast< XInteractionAbort * >(this));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}



//============================================================================
//
//  class InteractionRetry_Impl
//
//============================================================================

// virtual
Any SAL_CALL
InteractionRetry_Impl::queryInterface(const com::sun::star::uno::Type & rType)
{
	Any aRet = cppu::queryInterface(rType,
						static_cast< XInteractionContinuation * >(this),
	   					static_cast< XInteractionRetry * >(this));
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}


//============================================================================
//
//  class InteractionSupplyAuthentication_Impl
//
//============================================================================

InteractionSupplyAuthentication_Impl::InteractionSupplyAuthentication_Impl
(const vos::ORef<InteractionRequest_Impl> & rRequest):
  InteractionContinuation_Impl(rRequest)
{
}

// virtual
Any SAL_CALL
InteractionSupplyAuthentication_Impl::queryInterface(const com::sun::star::uno::Type & rType)
{
  Any aRet = cppu::queryInterface(rType,
				  static_cast< XInteractionContinuation * >(this),
				  static_cast< XInteractionSupplyAuthentication * >(this));
  return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}



//============================================================================
// virtual
void SAL_CALL
InteractionSupplyAuthentication_Impl::setUserName(const OUString &
						  rTheUserName)
{
  m_xRequest->setUserName(rTheUserName);
}

//============================================================================
// virtual
void SAL_CALL
InteractionSupplyAuthentication_Impl::setPassword(const OUString & rThePassword)
{
  m_xRequest->setPassword(rThePassword);
}

//============================================================================
// virtual
Sequence<RememberAuthentication> SAL_CALL
InteractionSupplyAuthentication_Impl::getRememberPasswordModes
(RememberAuthentication & rDefault)
{
  Sequence<RememberAuthentication> aModes(1);
  aModes[0] = RememberAuthentication_NO;
  rDefault = RememberAuthentication_NO;
  return aModes;
}

//============================================================================
// virtual
void SAL_CALL InteractionSupplyAuthentication_Impl::setRememberPassword
(RememberAuthentication eTheRemember)
{

}


