#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:13:11 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=chaos
TARGET=unotypes
.INCLUDE :  $(PRJ)$/util$/makefile.pmk
AUTOSEG=true

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=$(OUT)$/inc

UNOTYPES=\
	com.sun.star.beans.PropertyAttribute \
	com.sun.star.beans.PropertySetInfoChange \
	com.sun.star.beans.PropertyValue \
	com.sun.star.beans.XFastPropertySet \
	com.sun.star.beans.XPropertiesChangeNotifier \
	com.sun.star.beans.XPropertyAccess \
	com.sun.star.beans.XPropertyContainer \
	com.sun.star.beans.XPropertySet \
	com.sun.star.beans.XPropertySetInfoChangeNotifier \
	com.sun.star.bridge.XBridgeFactory \
	com.sun.star.chaos.Action \
	com.sun.star.chaos.ColumnConfig \
	com.sun.star.chaos.ContentType \
	com.sun.star.chaos.ExportURLInfo \
	com.sun.star.chaos.IconPosInfo \
	com.sun.star.chaos.MenuDescriptor \
	com.sun.star.chaos.ThreadingInfo \
	com.sun.star.chaos.WallPaper \
	com.sun.star.chaos.XAnchor \
	com.sun.star.chaos.XAnchorFactory \
	com.sun.star.chaos.XCommandExecutor \
	com.sun.star.chaos.XDataContainer \
	com.sun.star.chaos.XInteractionHandlerSupplier \
	com.sun.star.chaos.XMailReminder \
	com.sun.star.chaos.XSystem \
	com.sun.star.connection.XConnector \
	com.sun.star.connection.XAcceptor \
	com.sun.star.container.XIndexAccess \
	com.sun.star.container.XNameAccess \
	com.sun.star.container.XSet \
	com.sun.star.document.XStandaloneDocumentInfo \
	com.sun.star.frame.XConfigManager \
	com.sun.star.frame.XDesktop \
	com.sun.star.hierarchy.XContentHierarchy \
	com.sun.star.io.XActiveDataSink \
	com.sun.star.io.XInputStream \
	com.sun.star.io.XOutputStream \
	com.sun.star.io.XSeekable \
	com.sun.star.lang.XComponent \
	com.sun.star.lang.XInitialization \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XServiceInfo \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.lang.XTypeProvider \
	com.sun.star.loader.XImplementationLoader \
	com.sun.star.registry.XImplementationRegistration \
	com.sun.star.registry.XRegistryKey \
	com.sun.star.registry.XSimpleRegistry \
	com.sun.star.sdbc.ColumnValue \
	com.sun.star.sdbc.DataType \
	com.sun.star.sdbc.XCloseable \
	com.sun.star.sdbc.XColumnLocate \
	com.sun.star.sdbc.XResultSet \
	com.sun.star.sdbc.XResultSetMetaData \
	com.sun.star.sdbc.XResultSetMetaDataSupplier \
	com.sun.star.sdbc.XRow \
	com.sun.star.task.InteractionClassification \
	com.sun.star.task.XInteractionAbort \
	com.sun.star.task.XInteractionApprove \
	com.sun.star.task.XInteractionContinuation \
	com.sun.star.task.XInteractionDisapprove \
	com.sun.star.task.XInteractionHandler \
	com.sun.star.task.XInteractionRequest \
	com.sun.star.task.XInteractionRetry \
	com.sun.star.ucb.AlreadyInitializedException \
	com.sun.star.ucb.AuthenticationRequest \
	com.sun.star.ucb.InsertCommandArgument \
	com.sun.star.io.XActiveDataStreamer \
	com.sun.star.io.XStream \
	com.sun.star.ucb.CHAOSProgressStart \
	com.sun.star.ucb.Command \
	com.sun.star.ucb.CommandInfoChange \
	com.sun.star.ucb.ContentAction \
	com.sun.star.ucb.ContentProviderServiceInfo2 \
	com.sun.star.ucb.ContentResultSetCapability \
	com.sun.star.ucb.ContentTaskStatus \
	com.sun.star.ucb.Cookie \
	com.sun.star.ucb.CookiePolicy \
	com.sun.star.ucb.CookieRequest \
	com.sun.star.ucb.CrossReference \
	com.sun.star.ucb.DocumentHeaderField \
	com.sun.star.ucb.ExportStreamInfo \
	com.sun.star.ucb.FetchError \
	com.sun.star.ucb.FetchResult \
	com.sun.star.ucb.FolderList \
	com.sun.star.ucb.ServiceNotFoundException \
	com.sun.star.ucb.HandleCookiesRequest \
	com.sun.star.ucb.InteractiveBadTransferURLException \
	com.sun.star.ucb.InteractiveCHAOSException \
	com.sun.star.ucb.InteractiveIOException \
	com.sun.star.ucb.InteractiveNetworkConnectException \
	com.sun.star.ucb.InteractiveNetworkException \
	com.sun.star.ucb.InteractiveNetworkGeneralException \
	com.sun.star.ucb.InteractiveNetworkOffLineException \
	com.sun.star.ucb.InteractiveNetworkReadException \
	com.sun.star.ucb.InteractiveNetworkResolveNameException \
	com.sun.star.ucb.InteractiveNetworkWriteException \
	com.sun.star.ucb.IOErrorCode \
	com.sun.star.ucb.ListActionType \
	com.sun.star.ucb.OpenCommandArgument2 \
	com.sun.star.ucb.PostCommandArgument \
	com.sun.star.ucb.OpenMode \
	com.sun.star.ucb.RecipientInfo \
	com.sun.star.ucb.RememberAuthentication \
	com.sun.star.ucb.ResultSetException \
	com.sun.star.ucb.RuleSet \
	com.sun.star.ucb.SearchCommandArgument \
	com.sun.star.ucb.SearchInfo \
	com.sun.star.ucb.SendInfo \
	com.sun.star.ucb.SendMediaTypes \
	com.sun.star.ucb.ServiceNotFoundException \
	com.sun.star.ucb.SortingInfo \
	com.sun.star.ucb.TransferInfo \
	com.sun.star.ucb.TransferResult \
	com.sun.star.ucb.WelcomeDynamicResultSetStruct \
	com.sun.star.ucb.XCachedContentResultSetFactory \
	com.sun.star.ucb.XCachedContentResultSetStubFactory \
	com.sun.star.ucb.XCachedDynamicResultSetFactory \
	com.sun.star.ucb.XCachedDynamicResultSetStubFactory \
	com.sun.star.ucb.XChaosURLManager \
	com.sun.star.ucb.XChildrenPropertiesChangeNotifier \
	com.sun.star.ucb.XCommandInfoChangeNotifier \
	com.sun.star.ucb.AlreadyInitializedException \
	com.sun.star.ucb.XCachedDynamicResultSetStubFactory \
	com.sun.star.ucb.XSourceInitialization \
	com.sun.star.ucb.XCommandProcessor \
	com.sun.star.ucb.XCommandTask \
	com.sun.star.ucb.XCommandTaskProcessor \
	com.sun.star.ucb.XContent \
	com.sun.star.ucb.XContentAccess \
	com.sun.star.ucb.XContentCreationNotifier \
	com.sun.star.ucb.XContentCreator \
	com.sun.star.ucb.XContentEventListener \
	com.sun.star.ucb.XContentIdentifier \
	com.sun.star.ucb.XContentIdentifierFactory \
	com.sun.star.ucb.XContentIdentifierMapping \
	com.sun.star.ucb.XContentProvider \
	com.sun.star.ucb.XContentProviderConfiguration \
	com.sun.star.ucb.XContentProviderConfigurationManager \
	com.sun.star.ucb.XContentProviderFactory \
	com.sun.star.ucb.XContentProviderManager \
	com.sun.star.ucb.XContentProviderSupplier \
	com.sun.star.ucb.XContentTaskClient \
	com.sun.star.ucb.XContentTaskEnvironment \
	com.sun.star.ucb.XContentTransmitter \
	com.sun.star.ucb.XDynamicResultSet \
	com.sun.star.ucb.XFetchProvider \
	com.sun.star.ucb.XFetchProviderForContentAccess \
	com.sun.star.ucb.XInteractionCookieHandling \
	com.sun.star.ucb.XInteractionSupplyAuthentication \
	com.sun.star.ucb.XParameterizedContentProvider \
	com.sun.star.ucb.XPersistentPropertySet \
	com.sun.star.ucb.XPropertyMatcher \
	com.sun.star.ucb.XPropertyMatcherFactory \
	com.sun.star.ucb.XPropertySetRegistry \
	com.sun.star.ucb.XPropertySetRegistryFactory \
	com.sun.star.ucb.XPropertyTask \
	com.sun.star.ucb.XPropertyTaskProcessor \
	com.sun.star.ucb.XRecycler \
	com.sun.star.ucb.XRemoteContentProviderAcceptor \
	com.sun.star.ucb.XRemoteContentProviderDistributor \
	com.sun.star.ucb.XRemoteContentProviderSupplier \
	com.sun.star.ucb.XSortedDynamicResultSetFactory \
	com.sun.star.ucb.XTrashCan \
	com.sun.star.ucb.XViewIdentifier \
	com.sun.star.uno.TypeClass \
	com.sun.star.uno.XInterface \
	com.sun.star.uno.XWeak \
	com.sun.star.util.Date \
	com.sun.star.util.DateTime \
	com.sun.star.util.DateTimeRange \
	com.sun.star.util.XModifyBroadcaster \
	com.sun.star.util.XModifyListener

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

