#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:13:11 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=chaos
TARGET=cnt
RESTARGET=$(TARGET)

.INCLUDE :  $(PRJ)$/util$/makefile.pmk

AUTOSEG=true
USE_LDUMP2=TRUE

#chaos.hid generieren
#!IFNDEF header
GEN_HID=TRUE
#!ENDIF

# --- Settings -----------------------------------------------------
NO_BSYMBOLIC=TRUE

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Allgemein ----------------------------------------------------

LIB1TARGET= $(SLB)$/chaos.lib
LIB1FILES=	\
    $(SLB)$/core.lib        \
    $(SLB)$/items.lib       \
    $(SLB)$/protocol.lib    \
    $(SLB)$/store.lib	    \
    $(SLB)$/trashcan.lib    \
    $(SLB)$/imexport.lib    \
    $(SLB)$/imap.lib        \
    $(SLB)$/cnt2ucb.lib

# --- Shared-Library -----------------------------------------------

SHL1TARGET= cnt$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= ichaos
SHL1STDLIBS=	$(INETLIBSH) $(SVLLIB) $(TOOLSLIB) $(STORELIB) $(VOSLIB) $(SALLIB)
SHL1STDLIBS+=	$(CPPULIB) $(CPPUHELPERLIB) $(UCBHELPERLIB)

SHL1DEF=    $(MISC)$/$(SHL1TARGET).def
SHL1LIBS=   $(LIB1TARGET)

# --- Def-File ---------------------------------------------------------

DEF1NAME    =$(SHL1TARGET)
DEF1DEPN    =$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =chaos
DEF1DES     =Universal Content Broker
DEF1EXPORT1 =component_getImplementationEnvironment
DEF1EXPORT2 =component_writeInfo
DEF1EXPORT3 =component_getFactory

# --- Resources --------------------------------------------------------

RESLIB1NAME=$(RESTARGET)
RESLIB1SRSFILES=\
	$(SRS)$/core.srs \
	$(SRS)$/protocol.srs

# --- Targets ----------------------------------------------------------

.INCLUDE :  target.mk

# --- Filter -----------------------------------------------------------

$(MISC)$/$(SHL1TARGET).flt: chaos.flt
	@echo ------------------------------
	@echo Making: $@
	@+$(TYPE) chaos.flt > $@
.IF "$(COM)"=="MSC"
	@echo __CT>>$@
	@echo ??_5>>$@
	@echo ??_7>>$@
	@echo ??_8>>$@
	@echo ??_9>>$@
	@echo ??_C>>$@
	@echo ??_E>>$@
	@echo ??_F>>$@
	@echo ??_G>>$@
	@echo ??_H>>$@
	@echo ??_I>>$@
	@echo TerminationVetoException>>$@
	@echo ::UsrException>>$@
	@echo ::Exception>>$@
.ENDIF # MSC
.IF "$(GUI)"=="WNT"
	@echo ?CreateType@>>$@
.ENDIF # WNT
