/*************************************************************************
 *
 *  $RCSfile: demohttp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX
#include <tools/resmgr.hxx>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

#ifndef _SV_HELP_HXX
#include <vcl/help.hxx>
#endif

#ifndef _SV_TOOLBOX_HXX
#include <vcl/toolbox.hxx>
#endif

#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SVEDIT_HXX
#include <svtools/svmedit.hxx>
#endif

#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif

#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif

#ifndef _SFXHINT_HXX
#include <svtools/hint.hxx>
#endif

#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif

#ifndef _LCKBITEM_HXX
#include <svtools/lckbitem.hxx>
#endif

#ifndef _LOGINERR_HXX
#include <svtools/loginerr.hxx>
#endif

#ifndef _CNTWIDS_HRC
#include <svtools/cntwids.hrc>
#endif

#ifndef _CNTSYS_HXX
#include <chaos/cntsys.hxx>
#endif

#ifndef _CNTAPI_HXX
#include <chaos/cntapi.hxx>
#endif

#ifndef _CNTVWITM_HXX
#include <chaos/cntvwitm.hxx>
#endif

#ifndef _CSTRITEM_HXX
#include <chaos/cstritem.hxx>
#endif

#ifndef _DHDRITEM_HXX
#include <chaos/dhdritem.hxx>
#endif

#ifndef _ILSTITEM_HXX
#include <chaos/ilstitem.hxx>
#endif

#include <ctype.h>

#if (defined(WNT) && defined(PROFILE))

extern "C" {
	void StartCAP (void);
	void StopCAP  (void);
	void DumpCAP  (void);
}

#endif /* PROFILE */

/*========================================================================
 *
 * CntHTMLOutputStream Interface.
 *
 *=======================================================================*/
enum CntHTLinkType
{
	CNTHTML_LINK_HREF,
	CNTHTML_LINK_FRMSRC,
	CNTHTML_LINK_IMGSRC,
	CNTHTML_LINK_MAPSRC
};

struct CntHTLink
{
	CntHTLinkType m_eType;
	String        m_aURL;

	CntHTLink (CntHTLinkType eType, const String& rURL)
		: m_eType (eType), m_aURL (rURL) {}
};

class CntHTMLOutputStream
{
	/** StreamState.
	*/
	enum StreamState
	{
		CNTHTML_STREAM_SBRA,
		CNTHTML_STREAM_FBRA,
		CNTHTML_STREAM_FKET,
		CNTHTML_STREAM_FSCRIPT
	};

	/** Representation.
	*/
	List           m_aHTLinks;
	SvMemoryStream m_aBuffer;
	USHORT         m_nBra;
	USHORT         m_nKet;
	StreamState    m_eState;

	/** Implementation.
	*/
	BOOL compare (const char *a, const char *b, ULONG n);
	void writeLine (const char *pData, ULONG nSize);

	// Not implemented.
	CntHTMLOutputStream (const CntHTMLOutputStream& rOther);
	CntHTMLOutputStream& operator= (const CntHTMLOutputStream& rOther);

public:
	CntHTMLOutputStream (void);
	~CntHTMLOutputStream (void);

	const List& getHTLinks (void) const;

	void write (const char *pData, ULONG nSize);
};

/*========================================================================
 *
 * CntHTMLOutputStream Implementation.
 *
 *=======================================================================*/
/*
 * CntHTMLOutputStream.
 */
CntHTMLOutputStream::CntHTMLOutputStream (void)
	: m_nBra   (0),
	  m_nKet   (0),
	  m_eState (CNTHTML_STREAM_SBRA)
{
}

/*
 * ~CntHTMLOutputStream.
 */
CntHTMLOutputStream::~CntHTMLOutputStream (void)
{
	ULONG n = m_aHTLinks.Count();
	for (ULONG i = 0; i < n; i++)
	{
		CntHTLink *pLink = (CntHTLink *)(m_aHTLinks.GetObject(i));
		delete pLink;
	}
	m_aHTLinks.Clear();
}

/*
 * getHTLinks.
 */
const List& CntHTMLOutputStream::getHTLinks (void) const
{
	return m_aHTLinks;
}

/*
 * write.
 */
void CntHTMLOutputStream::write (const char *pData, ULONG nSize)
{
	const char *pStop = pData + nSize;
	while (pData < pStop)
	{
		if (m_eState == CNTHTML_STREAM_FSCRIPT)
		{
			if (*pData == '<')
				writeLine (pData, pStop - pData);
			pData++;
		}
		else if (m_eState == CNTHTML_STREAM_FKET)
		{
			m_nBra = m_nKet = 0;
			m_eState = CNTHTML_STREAM_SBRA;

			m_aBuffer << '\0';
			writeLine (
				(const char *)(m_aBuffer.GetData()),
				m_aBuffer.Tell() - 1);
			m_aBuffer.Seek (STREAM_SEEK_TO_BEGIN);
		}
		else if (m_eState == CNTHTML_STREAM_FBRA)
		{
			if (*pData == '<')
				m_nBra++;
			if (*pData == '>')
				m_nKet++;

			if (m_nBra == m_nKet)
				m_eState = CNTHTML_STREAM_FKET;

			m_aBuffer << *pData++;
		}
		else if (*pData == '<')
		{
			m_nBra++;
			m_eState = CNTHTML_STREAM_FBRA;
			m_aBuffer << *pData++;
		}
		else
		{
			pData++;
		}
	}
}

/*
 * writeLine.
 */
void CntHTMLOutputStream::writeLine (const char *pData, ULONG nSize)
{
	if (*pData++ == '<')
	{
		switch (tolower (*pData))
		{
			case 'a':
				if (compare (pData, "a href=\"", 8))
				{
					String aURL (pData + 8);
					USHORT nPos = aURL.Search ('\"');
					if (nPos != STRING_NOTFOUND)
					{
						String aLinkURL (aURL.Copy (0, nPos));
						CntHTLink *pLink = new CntHTLink (
							CNTHTML_LINK_HREF, aLinkURL);
						m_aHTLinks.Insert (pLink, LIST_APPEND);
					}
				}
				break;

			case 'b':
				if (compare (pData, "body ", 5))
				{
					String aURL (pData + 5);
					aURL.ToLower();

					USHORT nPos = aURL.Search ("background=\"");
					if (nPos != STRING_NOTFOUND)
					{
						String aStr (aURL.Copy (nPos + 12));
						nPos = aStr.Search ('\"');
						if (nPos != STRING_NOTFOUND)
						{
							String aLinkURL (aStr.Copy (0, nPos));
							CntHTLink *pLink = new CntHTLink (
								CNTHTML_LINK_IMGSRC, aLinkURL);
							m_aHTLinks.Insert (pLink, LIST_APPEND);
						}
					}
				}
				break;

			case 'f':
				if (compare (pData, "frame src=\"", 11))
				{
					String aURL (pData + 11);
					USHORT nPos = aURL.Search ('\"');
					if (nPos != STRING_NOTFOUND)
					{
						String aLinkURL (aURL.Copy (0, nPos));
						CntHTLink *pLink = new CntHTLink (
							CNTHTML_LINK_FRMSRC, aLinkURL);
						m_aHTLinks.Insert (pLink, LIST_APPEND);
					}
				}
				break;

			case 'i':
				if (compare (pData, "img src=\"", 9))
				{
					String aURL (pData + 9);
					USHORT nPos = aURL.Search ('\"');
					if (nPos != STRING_NOTFOUND)
					{
						String aLinkURL (aURL.Copy (0, nPos));
						CntHTLink *pLink = new CntHTLink (
							CNTHTML_LINK_IMGSRC, aLinkURL);
						m_aHTLinks.Insert (pLink, LIST_APPEND);
					}
				}
				break;

			case 's':
				if (compare (pData, "script", 6))
				{
					m_eState = CNTHTML_STREAM_FSCRIPT;
					return;
				}
				break;

			case '/':
				if (compare (pData, "/script", 7))
				{
					m_eState = CNTHTML_STREAM_SBRA;
					return;
				}
				break;

			default:
				break;
		}
	}
}

/*
 * compare.
 */
BOOL CntHTMLOutputStream::compare (const char *a, const char *b, ULONG n)
{
	while (n-- > 0)
	{
		if (!(*a && *b && (tolower (*a) == tolower (*b)))) return FALSE;
		a++;
		b++;
	}
	return TRUE;
}

/*========================================================================
 *
 * CntHTTPDemoFactory Interface.
 *
 *=======================================================================*/
#define CNTHTTP_ROOT_URL "private:httpcache"

class CntHTTPDemo;
DECLARE_LIST(CntHTTPDemoList, CntHTTPDemo*);

class CntHTTPDemoFactory :
	public SfxListener,
	public SvRefBase
{
	/** Representation.
	*/
	MultiLineEdit   *m_pOutEdit;
	CntAnchorRef    m_xRoot;
	CntHTTPDemoList m_aList;

public:
	CntHTTPDemoFactory (MultiLineEdit *pOutEdit);
	virtual ~CntHTTPDemoFactory (void);

	CntHTTPDemo* CreateHTTPDemo (void);
	CntAnchor*   CreateNew (void);
	void         CleanCache (void);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

SV_DECL_IMPL_REF(CntHTTPDemoFactory);

/*========================================================================
 *
 * CntHTTPDemo Interface.
 *
 *=======================================================================*/
class CntHTTPDemo :
	public SfxBroadcaster,
	public SfxListener,
	public SvRefBase
{
	/** Representation.
	*/
	CntHTTPDemoFactory *m_pFactory;
	CntAnchorRef       m_xRoot;
	MultiLineEdit      *m_pOutEdit;

	CntAnchorRef       m_xAnchor;
	SvLockBytesRef     m_xLockBytes;
	String             m_aContentType;
	ULONG              m_nContentLength;
	ULONG              m_nStartTicks;

	BOOL               m_bBrowse;
	BOOL               m_bReload;

public:
	CntHTTPDemo (
		CntHTTPDemoFactory *pFactory,
		CntAnchor          *pRoot,
		MultiLineEdit      *pOutEdit);
	virtual ~CntHTTPDemo (void);

	void LoadDocument (
		const String& rURL, BOOL bBrowse = FALSE, BOOL bReload = FALSE);
	void LoadDocumentLinks (
		const String& rURL, const List& rHTLinks);
	void UpdateDocument (
		const String& rURL);
	void StoreDocument (
		const String& rURL, const String& rFilename);

	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

SV_DECL_IMPL_REF (CntHTTPDemo);

class CntHTTPDemoHint : public SfxHint
{
	/** Representation.
	*/
	CntHTTPDemo *m_pDemo;

	/** Not implemented.
	*/
	CntHTTPDemoHint (const CntHTTPDemoHint& rOther);
	CntHTTPDemoHint& operator= (const CntHTTPDemoHint& rOther);

public:
	TYPEINFO();

	CntHTTPDemoHint (CntHTTPDemo *pDemo) : m_pDemo (pDemo) {}

	CntHTTPDemo* GetHTTPDemo (void) const { return m_pDemo; }
};

TYPEINIT1 (CntHTTPDemoHint, SfxHint);

/*========================================================================
 *
 * CntHTTPDemoFactory Implementation.
 *
 *=======================================================================*/
/*
 * CntHTTPDemoFactory.
 */
CntHTTPDemoFactory::CntHTTPDemoFactory (MultiLineEdit *pOutEdit)
	: m_pOutEdit (pOutEdit)
{
	String aURL (".cache:");
	aURL += CNTHTTP_ROOT_URL;

	m_xRoot = new CntAnchor (NULL, aURL);
	m_xRoot->Put (SfxVoidItem (WID_GETDATA));

	BYTE nLimit =
		((const SfxByteItem&)
		 (m_xRoot->Get(WID_HTTP_CONNECTION_LIMIT))).GetValue();
	if (nLimit < 4)
	{
		CntItemListItem aListItem (WID_PUTDATA);
		aListItem.Append (new SfxByteItem (WID_HTTP_CONNECTION_LIMIT, 4));

		m_xRoot->Put (aListItem);
	}
}

/*
 * ~CntHTTPDemoFactory.
 */
CntHTTPDemoFactory::~CntHTTPDemoFactory (void)
{
	ULONG i = 0, n = m_aList.Count();
	while (i < n)
	{
		CntHTTPDemo *pDemo = m_aList.GetObject(i++);
		if (pDemo)
		{
			EndListening (*pDemo);
			pDemo->ReleaseRef();
		}
	}

	m_aList.Clear();
	m_xRoot = NULL;
}

/*
 * CreateHTTPDemo.
 */
CntHTTPDemo* CntHTTPDemoFactory::CreateHTTPDemo (void)
{
	CntHTTPDemo *pDemo = new CntHTTPDemo (this, &m_xRoot, m_pOutEdit);
	pDemo->AddRef();

	m_aList.Insert (pDemo, LIST_APPEND);
	StartListening (*pDemo);

	return pDemo;
}

/*
 * CreateNew.
 */
CntAnchor* CntHTTPDemoFactory::CreateNew (void)
{
	const CntItemListItem& rFactoryList =
		(const CntItemListItem&)(m_xRoot->Get(WID_CREATE_NEW));

	USHORT i, n = rFactoryList.Count();
	for (i = 0; i < n; i++)
	{
		const SfxPoolItem& rItem = rFactoryList[i];
		if (rItem.Which() == WID_CREATE_NEW)
		{
			const CntAnchorItem *pNew =
				(const CntAnchorItem *)(m_xRoot->Put (rItem, rItem.Which()));
			if (pNew)
				return pNew->GetValue();
		}
	}
	return NULL;
}

/*
 * CleanCache.
 */
void CntHTTPDemoFactory::CleanCache (void)
{
	m_xRoot->Put (SfxVoidItem (WID_CLEAN_CACHE));
}

/*
 * Notify.
 */
void CntHTTPDemoFactory::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	if (rHint.ISA (CntHTTPDemoHint))
	{
		CntHTTPDemo *pDemo = ((const CntHTTPDemoHint&)rHint).GetHTTPDemo();
		if (m_aList.Remove (pDemo))
		{
			EndListening (*pDemo);
			pDemo->ReleaseRef();
		}

		// CntHTTPDemoHint done.
		return;
	}
}

/*========================================================================
 *
 * CntHTTPDemo Implementation.
 *
 *=======================================================================*/
#define OPEN_ANCHOR(xAnchor, nWhich) \
{ \
	if ((xAnchor).Is()) \
	{ \
		StartListening (*(xAnchor)); \
		(xAnchor)->Put (CntOpenModeItem ((nWhich), CNT_OPEN_MESSAGE)); \
	} \
}

#define UPDATE_ANCHOR(xAnchor) \
{ \
	if ((xAnchor).Is()) \
	{ \
		StartListening (*(xAnchor)); \
		(xAnchor)->Put (SfxVoidItem (WID_UPDATE)); \
	} \
}

#define RELEASE_ANCHOR(xAnchor) \
{ \
	if ((xAnchor).Is()) \
	{ \
		EndListening (*(xAnchor)); \
		(xAnchor) = NULL; \
	} \
}

/*
 * CntHTTPDemo.
 */
CntHTTPDemo::CntHTTPDemo (
	CntHTTPDemoFactory *pFactory,
	CntAnchor          *pRoot,
	MultiLineEdit      *pOutEdit)
	: m_pFactory       (pFactory),
	  m_xRoot          (pRoot),
	  m_pOutEdit       (pOutEdit),
	  m_nContentLength (0),
	  m_nStartTicks    (0),
	  m_bBrowse        (FALSE),
	  m_bReload        (FALSE)
{
	if (m_xRoot.Is())
		StartListening (*m_xRoot);
}

/*
 * ~CntHTTPDemo.
 */
CntHTTPDemo::~CntHTTPDemo (void)
{
	m_xLockBytes = NULL;
	RELEASE_ANCHOR (m_xAnchor);
	RELEASE_ANCHOR (m_xRoot);
}

/*
 * LoadDocument.
 */
void CntHTTPDemo::LoadDocument (
	const String& rURL, BOOL bBrowse, BOOL bReload)
{
	if (rURL.Len())
	{
		String aReqURI (CNTHTTP_ROOT_URL);
		aReqURI += '#';
		aReqURI += rURL;

		m_bBrowse = bBrowse;
		m_bReload = bReload;

		m_xLockBytes = NULL;
		m_nContentLength = 0;
		m_aContentType.Erase();
		RELEASE_ANCHOR (m_xAnchor);

		m_xAnchor = new CntAnchor (&m_xRoot, aReqURI);
		m_nStartTicks = Time::GetSystemTicks();
		OPEN_ANCHOR (m_xAnchor, m_bReload ? WID_SYNCHRONIZE : WID_OPEN);
	}
}

/*
 * LoadDocumentLinks.
 */
void CntHTTPDemo::LoadDocumentLinks (
	const String& rURL, const List& rHTLinks)
{
	INetURLObject aBaseURL (rURL);
	INetURLObject aLinkURL;

	ULONG n = rHTLinks.Count();
	for (ULONG i = 0; i < n; i++)
	{
		CntHTLink *pLink = (CntHTLink *)(rHTLinks.GetObject(i));
		if (pLink->m_eType != CNTHTML_LINK_HREF)
		{
			aBaseURL.GetNewAbsURL (pLink->m_aURL, &aLinkURL);
			if (aLinkURL.GetProtocol() == INET_PROT_HTTP)
			{
				CntHTTPDemo *pDemo = m_pFactory->CreateHTTPDemo();
				pDemo->LoadDocument (
					aLinkURL.GetMainURL(),
					pLink->m_eType == CNTHTML_LINK_FRMSRC,
					m_bReload);
			}
		}
	}
}

/*
 * UpdateDocument.
 */
void CntHTTPDemo::UpdateDocument (const String& rURL)
{
	if (rURL.Len())
	{
		String aReqURI (CNTHTTP_ROOT_URL);
		aReqURI += '#';
		aReqURI += rURL;

		m_bBrowse = FALSE;
		m_bReload = FALSE;

		m_xLockBytes = NULL;
		m_nContentLength = 0;
		m_aContentType.Erase();
		RELEASE_ANCHOR (m_xAnchor);

		m_xAnchor = new CntAnchor (&m_xRoot, aReqURI);
		m_nStartTicks = Time::GetSystemTicks();
		UPDATE_ANCHOR (m_xAnchor);
	}
}

/*
 * StoreDocument.
 */
void CntHTTPDemo::StoreDocument (
	const String& rURL, const String& rFilename)
{
	if (rURL.Len())
	{
		m_xAnchor = m_pFactory->CreateNew();
		if (m_xAnchor.Is())
		{
			// ...
			SvFileStream *pStrm = new SvFileStream (
				rFilename, STREAM_STD_READ);
			if (pStrm->IsOpen())
			{
				String aReqURI (CNTHTTP_ROOT_URL);
				aReqURI += '#';
				aReqURI += rURL;

				m_xAnchor->Put (CntStringItem (WID_OWN_URL, aReqURI));

				pStrm->Seek (STREAM_SEEK_TO_END);
				m_xAnchor->Put (SfxUInt32Item (
					WID_DOCUMENT_SIZE, pStrm->Tell()));
				pStrm->Seek (STREAM_SEEK_TO_BEGIN);

				m_xAnchor->Put (SfxLockBytesItem (
					WID_DOCUMENT_BODY, new SvLockBytes (pStrm, TRUE)));

				m_xAnchor->Put (CntStringItem (
					WID_CONTENT_TYPE, "text/plain"));

				// Store document.
				m_bBrowse = FALSE;
				m_bReload = FALSE;

				m_nContentLength = 0;
				m_aContentType.Erase();
				m_xLockBytes.Clear();

				StartListening (*m_xAnchor);
				m_nStartTicks = Time::GetSystemTicks();
#if 1
				m_xAnchor->Put (SfxVoidItem (WID_INSERT));
#else
				m_xAnchor->Put (SfxVoidItem (WID_HTTP_POST));
#endif
			}
			else
			{
				// No document to store.
				delete pStrm;
				m_xAnchor = NULL;
			}
		}
	}
}

/*
 * Notify.
 */
void CntHTTPDemo::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
	if (rHint.ISA (SfxItemChangedHint))
	{
		const SfxPoolItem& rItem =
			((const SfxItemChangedHint&)rHint).GetNewItem();

		switch (rItem.Which())
		{
			case WID_OWN_URL:
				if (m_xAnchor.Is())
				{
					// OwnURL changed (Redirection).
					String aReqURI (
						((const CntStringItem&)rItem).GetValue());
					if (aReqURI.Len())
					{
					}
				}
				break;

			case WID_CONTENT_TYPE: // ContentType changed.
				m_aContentType =
					((const CntStringItem&)rItem).GetValue();
				break;

			case WID_DOCUMENT_HEADER: // DocHeader changed.
				if (m_xAnchor.Is())
				{
					CntDocHeader *pHead =
						((const CntDocHeaderItem&)rItem).GetValue();
					if (pHead)
					{
						ULONG n = pHead->GetHeaderCount();
						for (ULONG i = 0; i < n; i++)
						{
							String aField (pHead->GetHeaderName(i));
							aField += ": ";
							aField += pHead->GetHeaderValue(i);
							aField += "\r\n";

							if (aField.Len())
							{
							}
						}
					}
				}
				break;

			case WID_DOCUMENT_BODY: // Document changed.
				m_xLockBytes =
					((const SfxLockBytesItem&)rItem).GetValue();
				if (m_xLockBytes.Is())
				{
					SvLockBytesStat aStat;
					m_xLockBytes->Stat (&aStat, SVSTATFLAG_DEFAULT);
					if (aStat.nSize)
					{
					}
				}
				break;

			case WID_DOCUMENT_SIZE: // Document size changed.
				m_nContentLength =
					((const SfxUInt32Item&)rItem).GetValue();
				if (m_xAnchor.Is())
				{
#ifndef PROFILE
					ULONG nTicks = Time::GetSystemTicks();
					String aOutStr = m_pOutEdit->GetText();

					String aURL (m_xAnchor->GetServiceURL());

					aOutStr += "\n>>> ";
					aOutStr += aURL.GetToken ((USHORT)1, '#');
					aOutStr += " <<< ";
					aOutStr += m_nContentLength;
					aOutStr += " [Bytes] in ";
					aOutStr += (nTicks - m_nStartTicks);
					aOutStr += " [ms] (change)\n";

					m_pOutEdit->SetText (aOutStr.ConvertLineEnd());
#endif /* PROFILE */
				}
				break;

			default: // Ignored.
				break;
		}

		// SfxItemChangedHint done.
		return;
	}

	if (rHint.ISA (CntStatusHint))
	{
		const CntStatusHint& rStatusHint = (const CntStatusHint&)rHint;

		const SfxPoolItem *pReq = rStatusHint.GetRequest();
		if (pReq == NULL)
			return;

		USHORT nWhich = pReq->Which();
		switch (nWhich)
		{
			case WID_OPEN:
			case WID_UPDATE:
			case WID_SYNCHRONIZE:
			case WID_INSERT:
			case WID_HTTP_POST:
				break;

			default:
				return;
		}

		const CntStatus eStatus = rStatusHint.GetStatus();
		if (eStatus == CNT_STATUS_STARTED)
		{
			m_nStartTicks = Time::GetSystemTicks();

			// Done.
			return;
		}

		if (eStatus == CNT_STATUS_DONE)
		{
			if (m_xAnchor.Is())
			{
				if (!m_aContentType.Len())
				{
					m_aContentType = ITEMSET_VALUE(
						m_xAnchor, CntStringItem, WID_CONTENT_TYPE);
				}

				if (!m_xLockBytes.Is())
				{
					m_xLockBytes = ITEMSET_VALUE(
						m_xAnchor, SfxLockBytesItem, WID_DOCUMENT_BODY);
				}

				if (!m_nContentLength)
				{
					m_nContentLength = ITEMSET_VALUE(
						m_xAnchor, SfxUInt32Item, WID_DOCUMENT_SIZE);
				}

				ULONG nTicks = Time::GetSystemTicks();
				String aOutStr = m_pOutEdit->GetText();

				String aURL (m_xAnchor->GetServiceURL());

				aOutStr += "\n>>> ";
				aOutStr += aURL.GetToken ((USHORT)1, '#');
				aOutStr += " <<< ";
				aOutStr += m_nContentLength;
				aOutStr += " [Bytes] in ";
				aOutStr += (nTicks - m_nStartTicks);
				aOutStr += " [ms] (done)\n";

				CntHTMLOutputStream aTarget;
				if (m_aContentType.Len() && m_xLockBytes.Is())
				{
					SvStream aStrm (&m_xLockBytes);
					char     pBuffer[1024 + 1];
					ULONG    n = 0;

					aStrm.SetBufferSize(0);

					if (m_aContentType.ICompare ("text", 4) == COMPARE_EQUAL)
					{
						m_bBrowse &= (m_aContentType.ICompare (
							"text/html", 9) == COMPARE_EQUAL);

						while ((n = aStrm.Read (pBuffer, 1024)) > 0)
						{
							if (m_bBrowse)
								aTarget.write (pBuffer, n);

							pBuffer[n] = '\0';
#ifndef PROFILE
							aOutStr += pBuffer;
#endif /* PROFILE */
						}

						// Mark as visited.
						m_xAnchor->Put (SfxBoolItem (WID_IS_READ, TRUE));
					}
					else
					{
						while ((n = aStrm.Read (pBuffer, 1024)) > 0)
							continue;
					}
				}

				m_pOutEdit->SetText (aOutStr.ConvertLineEnd());

				if (m_bBrowse)
				{
					String aURL (m_xAnchor->GetServiceURL());
					LoadDocumentLinks (
						aURL.GetToken ((USHORT)1, '#'),
						aTarget.getHTLinks());
				}
			}

			// Finished.
			CntHTTPDemoRef xThis = this;
			Broadcast (CntHTTPDemoHint (this));

			// Done.
			return;
		}

		if (eStatus == CNT_STATUS_ERROR)
		{
			ErrCode eErrCode = (ErrCode)(rStatusHint.GetError());

			switch (eErrCode)
			{
				case ERRCODE_CHAOS_HTTP_COOKIE_REQUEST:
				case ERRCODE_CHAOS_LOGIN_FAILURE_RECEIVE:
				case ERRCODE_CHAOS_OFFLINE:
					// Handled by CntRootNodeMgr::HandleError().
					break;

				default:
					break;
			}

			// Done.
			return;
		}

		// CntStatusHint done.
		return;
	}

	if (rHint.ISA (CntAnchorHint))
	{
		const CntAnchorHint& rAnchorHint = (const CntAnchorHint&)rHint;

		const CntAction eAction  = rAnchorHint.GetAction();
		CntAnchor       *pAnchor = rAnchorHint.GetAnchor();

		if (pAnchor == &m_xAnchor)
		{
			switch (eAction)
			{
				case CNT_ACTION_MODIFIED:
					// Update result: document modified.
					break;

				default:
					break;
			}
		}
		else if (pAnchor == &m_xRoot)
		{
			// Notification from parent (ignored).
			return;
		}
		else
		{
			// Notification from new anchor.
			switch (eAction)
			{
				case CNT_ACTION_INSERTED: // StoreDocument done.
					m_xAnchor = pAnchor;
					break;

				default:
					break;
			}
		}

		// CntAnchorHint done.
		return;
	}
}

/*========================================================================
 *
 * MyWin.
 *
 *=======================================================================*/
#define MYWIN_ITEMID_CLEAR    1
#define MYWIN_ITEMID_LOAD     2
#define MYWIN_ITEMID_RELOAD   3
#define MYWIN_ITEMID_UPDATE   4
#define MYWIN_ITEMID_BROWSE   5
#define MYWIN_ITEMID_REBROWSE 6
#define MYWIN_ITEMID_CLEANUP  7
#define MYWIN_ITEMID_TEST     8

class MyWin : public WorkWindow
{
private:
	ToolBox               *m_pTool;
	Edit                  *m_pCmdEdit;
	MultiLineEdit         *m_pOutEdit;

	CntHTTPDemoFactoryRef m_xDemoFactory;

public:
	MyWin (Window *pParent, WinBits nWinStyle);
	virtual ~MyWin (void);

	void Resize (void);
	DECL_LINK (ToolBarHandler, ToolBox*);
};

/*
 * MyWin.
 */
MyWin::MyWin (Window *pParent, WinBits nWinStyle)
	: WorkWindow (pParent, nWinStyle),
	  m_pTool    (NULL),
	  m_pOutEdit (NULL)
{
	// ToolBox.
	m_pTool = new ToolBox (this, WB_SVLOOK | WB_BORDER);

	m_pTool->InsertItem  (MYWIN_ITEMID_CLEAR, "Clear");
	m_pTool->SetHelpText (MYWIN_ITEMID_CLEAR, "Clear the Output Window");
	m_pTool->InsertSeparator();

	m_pTool->InsertItem  (MYWIN_ITEMID_LOAD, "Load");
	m_pTool->SetHelpText (MYWIN_ITEMID_LOAD, "Load Document");
	m_pTool->InsertItem  (MYWIN_ITEMID_RELOAD, "Reload");
	m_pTool->SetHelpText (MYWIN_ITEMID_RELOAD, "Reload Document");
	m_pTool->InsertSeparator();

	m_pTool->InsertItem  (MYWIN_ITEMID_UPDATE, "Update");
	m_pTool->SetHelpText (MYWIN_ITEMID_UPDATE, "Update Document");
	m_pTool->InsertSeparator();

	m_pTool->InsertItem  (MYWIN_ITEMID_BROWSE, "Browse");
	m_pTool->SetHelpText (MYWIN_ITEMID_BROWSE, "Load Document and Links");
	m_pTool->InsertItem  (MYWIN_ITEMID_REBROWSE, "ReBrowse");
	m_pTool->SetHelpText (MYWIN_ITEMID_REBROWSE, "Reload Document and Links");
	m_pTool->InsertSeparator();

	m_pTool->InsertItem  (MYWIN_ITEMID_CLEANUP, "Cleanup");
	m_pTool->SetHelpText (MYWIN_ITEMID_CLEANUP, "Cleanup Document Cache");
	m_pTool->InsertSeparator();

	m_pTool->InsertItem  (MYWIN_ITEMID_TEST, "Test");
	m_pTool->SetHelpText (MYWIN_ITEMID_TEST, "Perform programmed Test");

	m_pTool->SetClickHdl (LINK (this, MyWin, ToolBarHandler));
	m_pTool->Show();

	// Edit.
	m_pCmdEdit = new Edit (this);
	m_pCmdEdit->SetReadOnly (FALSE);
	m_pCmdEdit->SetText ("http://rabbit.stardiv.de/");
	m_pCmdEdit->Show();

	// MultiLineEdit.
	m_pOutEdit = new MultiLineEdit (this, WB_HSCROLL | WB_VSCROLL | WB_BORDER);
	m_pOutEdit->SetReadOnly (TRUE);
	m_pOutEdit->Show();

	// CntHTTPDemoFactory.
	m_xDemoFactory = new CntHTTPDemoFactory (m_pOutEdit);
}

/*
 * ~MyWin.
 */
MyWin::~MyWin (void)
{
	m_xDemoFactory = NULL;

	delete m_pTool;
	delete m_pCmdEdit;
	delete m_pOutEdit;
}

/*
 * Resize.
 */
void MyWin::Resize (void)
{
	Size aWinSize = GetOutputSizePixel();
	int nWinW = aWinSize.Width();
	int nWinH = aWinSize.Height();

	int nBoxH = m_pTool->CalcWindowSizePixel().Height();

	m_pTool->SetPosSizePixel (
		Point (0, 0),
		Size  (nWinW, nBoxH));

	m_pCmdEdit->SetPosSizePixel (
		Point (0, nBoxH),
		Size  (nWinW, nBoxH));

	m_pOutEdit->SetPosSizePixel (
		Point (0, nBoxH + nBoxH),
		Size  (nWinW, nWinH - (nBoxH + nBoxH)));
}

/*
 * ToolBarHandler.
 */
IMPL_LINK (MyWin, ToolBarHandler, ToolBox*, pToolBox)
{
	USHORT nItemId = pToolBox->GetCurItemId();
	String aCmdLine = m_pCmdEdit->GetText();

	switch (nItemId)
	{
		case MYWIN_ITEMID_CLEAR:
			m_pOutEdit->SetText ('\0');
			break;

		case MYWIN_ITEMID_LOAD:
		case MYWIN_ITEMID_RELOAD:
			if (aCmdLine.Len())
			{
				CntHTTPDemo *pDemo = m_xDemoFactory->CreateHTTPDemo();
				pDemo->LoadDocument (
					aCmdLine, FALSE, nItemId == MYWIN_ITEMID_RELOAD);
			}
			break;

		case MYWIN_ITEMID_UPDATE:
			if (aCmdLine.Len())
			{
				CntHTTPDemo *pDemo = m_xDemoFactory->CreateHTTPDemo();
				pDemo->UpdateDocument (aCmdLine);
			}
			break;

		case MYWIN_ITEMID_BROWSE:
		case MYWIN_ITEMID_REBROWSE:
			if (aCmdLine.Len())
			{
				CntHTTPDemo *pDemo = m_xDemoFactory->CreateHTTPDemo();
				pDemo->LoadDocument (
					aCmdLine, TRUE, nItemId == MYWIN_ITEMID_REBROWSE);
			}
			break;

		case MYWIN_ITEMID_CLEANUP:
			m_xDemoFactory->CleanCache();
			break;

		case MYWIN_ITEMID_TEST:
			if (aCmdLine.Len())
			{
				CntHTTPDemo *pDemo = m_xDemoFactory->CreateHTTPDemo();
				pDemo->StoreDocument (aCmdLine, "cnt502mi.dll");
			}
			break;

		default: // Ignored.
			break;
	}
	return 0;
}

/*========================================================================
 *
 * MyApp.
 *
 *=======================================================================*/
class MyApp : public Application, public SfxListener
{
public:
	virtual void Main (void);
	virtual void Notify (SfxBroadcaster& rBC, const SfxHint& rHint);
};

MyApp aMyApp;

/*
 * Main.
 */
void MyApp::Main (void)
{
	Help::EnableBalloonHelp();

	SfxIniManager aIniMgr ("demohttp", "DemoHTTP", NULL);

	aIniMgr.Set ("$(prog)/config", SFX_KEY_CONFIG_DIR);
	aIniMgr.Set ("$(prog)/store" , SFX_KEY_STORAGE_DIR);

	aIniMgr.Set ("192.109.83.75", SFX_KEY_INET_DNS);

	aIniMgr.Set ("1", SFX_KEY_INET_PROXYTYPE); /* 0 == OFF, 1 == ON */
	aIniMgr.Set ("*.stardiv.de", SFX_KEY_INET_NOPROXY);

	aIniMgr.Set ("ftpproxy.stardiv.de", SFX_KEY_INET_FTPPROXYNAME);
	aIniMgr.Set ("3128", SFX_KEY_INET_FTPPROXYPORT);

	//aIniMgr.Set ("wwwproxy.stardiv.de", SFX_KEY_INET_HTTPPROXYNAME);
	//aIniMgr.Set ("3128", SFX_KEY_INET_HTTPPROXYPORT);

	aIniMgr.Set ("wwwproxy.stardiv.de", SFX_KEY_INET_SECURITYPROXYNAME);
	aIniMgr.Set ("3128", SFX_KEY_INET_SECURITYPROXYPORT);

	aIniMgr.Set ("172.17.1.213", SFX_KEY_INET_SOCKSPROXYNAME);
	// aIniMgr.Set ("192.109.83.74", SFX_KEY_INET_SOCKSPROXYNAME);
	aIniMgr.Set ("1080", SFX_KEY_INET_SOCKSPROXYPORT);

	ResMgr aResMgr ("workben.res");

	CntSystem::SetIniManager (&aIniMgr);
	CntSystem::SetResManager (&aResMgr);
	CntSystem::Initialize();

	CntSystem *pChaos = CNT_SYS();
	if (pChaos)
		StartListening (*pChaos);

	MyWin *pMyWin = new MyWin (NULL, WB_APP | WB_STDWORK);
	pMyWin->SetText ("DemoHTTP ($Revision: 1.1.1.1 $)");
	pMyWin->Show();

#if (defined(WNT) && defined(PROFILE))
	StartCAP();
#endif /* PROFILE */

	EnterMultiThread (TRUE);
	Execute();
	EnterMultiThread (FALSE);

#if (defined(WNT) && defined(PROFILE))
	StopCAP();
	DumpCAP();
#endif /* PROFILE */

	delete pMyWin;
	if (pChaos)
		EndListening (*pChaos);
	CntSystem::Deinitialize();
}

/*
 * Notify.
 */
void MyApp::Notify (SfxBroadcaster& rBC, const SfxHint& rHint)
{
#if 0  /* NYI */
	if (rHint.ISA (Cnt))
	{
	}
#endif /* NYI */

	if (rHint.ISA (CntLoginErrorHint))
	{
		const CntLoginErrorHint& rErrorHint =
			(const CntLoginErrorHint&)rHint;

		LoginErrorInfo& rErrorInfo = rErrorHint.GetErrorInfo();
#if 1   /* @@@ */
		rErrorInfo.SetUserName ("office");
		rErrorInfo.SetPassword ("cebit96");

		rErrorInfo.SetResult (ERRCODE_BUTTON_OK);
#endif  /* @@@ */

		// CntLoginErrorHint done.
		return;
	}
}

