#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:13:11 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..\..

PRJNAME=CHAOS
TARGET=workben
LIBTARGET=NO

# --- Settings ---

.INCLUDE : svpre.mk
.INCLUDE : settings.mk
.INCLUDE : sv.mk

ENVCFLAGS+= -D__STL_USE_NEWALLOC

.IF "$(COM)" == "ICC"
ENVCFLAGS+= -D_STD_NO_NAMESPACE -D_VOS_NO_NAMESPACE
.ENDIF # ICC

# --- Files ---

.IF "$(depend)" != ""
CXXFILES=	demohttp.cxx
OBJFILES=	$(OBJ)$/demohttp.obj
.ENDIF # depend

SRSFILES=	$(SRS)$/core.srs	\
			$(SRS)$/protocol.srs
#			$(SRS)$/store.srs

#
# DEMOHTTP
#
APP1TARGET=	demohttp
APP1OBJS=	$(OBJ)$/demohttp.obj
APP1RES=	$(RES)$/workben.res

APP1STDLIBS=$(TOOLSLIB)		\
			$(VOSLIB)		\
			$(SVLIB)		\
			$(SVTOOLLIB)	\
			$(INETLIBSH)	\
			$(LB)$/ichaos.lib

APP1DEPN=	$(L)$/itools.lib	\
			$(L)$/ivos.lib		\
			$(L)$/svtool.lib	\
			$(L)$/inetdll.lib	\
			$(LB)$/ichaos.lib

.IF "$(VCL)" == ""
APP1DEPN+=	$(L)$/sv.lib
.ELSE
APP1DEPN+=	$(L)$/ivcl.lib
.ENDIF # VCL

APP1DEF=	$(MISC)\$(APP1TARGET).def

.IF "$(GUI)" == "WNT"

.IF "$(VCL)" == ""
APP1STDLIBS+= isv.lib
.ENDIF # VCL

APP1STDLIBS+= libcmt.lib

.ENDIF # WNT

APP2TARGET=	perfopen
APP2OBJS=	$(OBJ)$/perfopen.obj
APP2RES=	$(RES)$/workben.res

APP2STDLIBS=$(TOOLSLIB)		\
			$(VOSLIB)		\
			$(SVLIB)		\
			$(SVTOOLLIB)	\
			$(INETLIBSH)	\
			$(LB)$/ichaos.lib

APP2DEPN=	$(L)$/itools.lib	\
			$(L)$/ivos.lib		\
			$(L)$/svtool.lib	\
			$(L)$/inetdll.lib	\
			$(LB)$/ichaos.lib

.IF "$(VCL)" == ""
APP2DEPN+=	$(L)$/sv.lib
.ELSE
APP2DEPN+=	$(L)$/ivcl.lib
.ENDIF # VCL

APP2DEF=	$(MISC)\$(APP2TARGET).def

.IF "$(GUI)" == "WNT"

.IF "$(VCL)" == ""
APP2STDLIBS+= isv.lib
.ENDIF # VCL

.ENDIF # WNT

# --- Targets ---

.INCLUDE : target.mk

# --- OS2 ---

.IF "$(GUI)" == "OS2"

$(MISC)\$(APP1TARGET).def:
    echo    NAME            $(APP1TARGET) WINDOWAPI      >$@
    echo    DESCRIPTION     'Testprogram'               >>$@
    echo    STUB            'os2STUB.EXE'               >>$@
    echo    EXETYPE         OS2                         >>$@
    echo    PROTMODE                                    >>$@
    echo    CODE            LOADONCALL                  >>$@
    echo    DATA            PRELOAD MULTIPLE            >>$@
    echo    HEAPSIZE        8192                        >>$@
    echo    STACKSIZE       32768                       >>$@

.ENDIF # OS2

