
'-------------------------------------------------------------------------
' CHAOS StarONE-API Demo
'
' This program:
' - creates a new persitent view to a News Server
' - gets the group listing from the News Server
' - subscribes to some groups on the Server
'
' Also shown here is how to handle asynchronous actions using callbacks.
'-------------------------------------------------------------------------

dim NewsBoxAnchor as Object
dim CHAOS as Object

Sub Main

' get CHAOS-System-Object
CHAOS = createUNOService( "com.sun.star.chaos.System" )

' create anchor to file system folder where news-box shall be created.
FolderAnchor = CHAOS.createAnchor( "file:///d|/apps/win32/office/explorer/" )

' create persistent news-box-entry in file system
NewsBoxAnchor = FolderAnchor.create( ".chaos/news-box" )

' setup news-box
NewsBoxAnchor.Title = "News (sdnews)"
NewsBoxAnchor.ServerName = "sdnews"

' insert new-box (Shows it in Explorer etc.)
Status = createUnoListener( "Callback_", "com.sun.star.chaos.XStatusCallback" )
NewsBoxAnchor.execute( "insert", 0, Status )

' get group list from Server (asynchronous action, which may take some time)
NewsBoxAnchor.execute( "synchronize", 0, Status )

End Sub

'---------------------------------------------------------------
' XStatusCallback::started
'---------------------------------------------------------------
Sub Callback_started( Event )
msgbox "Started: " + Event.Name
End Sub

'---------------------------------------------------------------
' XStatusCallback::done
'---------------------------------------------------------------
Sub Callback_done( Event )

msgbox "Done: " + Event.Name

if Event.Name = "synchronize" then

' "synchronize" was done - now the group list is available...

' subscribe to some newsgroups
CHAOS.createAnchor(	MakeViewURL( NewsBoxAnchor, "news://sdnews/_sd.abt.dev.apichanges" ) ).IsSubscribed = 1
CHAOS.createAnchor(	MakeViewURL( NewsBoxAnchor, "news://sdnews/_sd.abt.dev.misc" ) ).IsSubscribed = 1

end if

End Sub

'---------------------------------------------------------------
' XStatusCallback::canceled
'---------------------------------------------------------------
Sub Callback_canceled( Event )
msgbox "Canceled: " + Event.Name
End Sub

'---------------------------------------------------------------
' make a view URL from an anchor and a URL
'---------------------------------------------------------------
Function MakeViewURL( aAnchor, aURL ) as String
MakeViewURL = aAnchor.URL + "#" + aURL
End Function

