
'-------------------------------------------------------------------------
' CHAOS StarONE-API Demo
'
' This program creates and sends a text message via a CHAOS OutTray.
'-------------------------------------------------------------------------

Sub Main

' Get the CHAOS System object.
CHAOS  = createUNOService( "com.sun.star.chaos.System" )

' Get 1st OutTray from the list of all OutTray objects known by the system.
Views = CHAOS.getViews( "", ".chaos/out-box" )

if isNull( Views ) = false then

' Create an anchor for the OutTray.
OutTrayAnchor = CHAOS.createAnchor( Views( 0 ) )

' Create a new message at the OutTray.
MessageAnchor = OutTrayAnchor.create( ".chaos/message" )

' Fill header elements of the new message.
MessageAnchor.Title = inputbox( "Subject:", "New Message", "StarONE Test" )
MessageAnchor.MessageTo = inputbox( "To (email address):", "New Message", MessageAnchor.MessageFrom )

' Create and fill a DataContainer for the message body.
Body = createUNOService( "com.sun.star.chaos.DataContainer" )
Body.ContentType = "text/plain"
Body.DataURL = inputbox( "URL of text file containing message text:", "New Message", "file:///c|/config.sys" )

' Set the message body.
MessageAnchor.MessageBody = Body

' Insert the new message into OutTray - This will send it.
' Note: "insert" is always called on the new object itself, not at its parent.
Status = createUnoListener( "CallBack_", "com.sun.star.chaos.XStatusCallback" )
MessageAnchor.execute( "insert", 0, Status )

else

msgBox "No OutTray!"

end if

End Sub

'---------------------------------------------------------------
' XStatusCallback::started
'---------------------------------------------------------------
Sub Callback_started( Event )

End Sub

'---------------------------------------------------------------
' XStatusCallback::done
'---------------------------------------------------------------
Sub Callback_done( Event )

End Sub

'---------------------------------------------------------------
' XStatusCallback::canceled
'---------------------------------------------------------------
Sub Callback_canceled( Event )

End Sub
