/*************************************************************************
 *
 *  $RCSfile: demostor.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _DEMOSTOR_CXX "$Revision: 1.1.1.1 $"

#define _DEMOSTOR_FILENAME        "demostor.dat"
#define _DEMOSTOR_DUMPNAME        "demostor.dmp"

#define _DEMOSTOR_SUBFOLDER_DEPTH 3
#define _DEMOSTOR_SUBFOLDER_KEY   100000

#define _DEMOSTOR_BUFSIZ          4096 /* 4096, 1024 */
#define _DEMOSTOR_LOOPS           1000 /* 1000, 4000 */

#define _DEMOSTOR_WRITE           1
#define _DEMOSTOR_TRUNC           1
#define _DEMOSTOR_DUMP            0

#ifndef _CNTSTOR_HXX
#include "..\..\source\inc\cntstor.hxx"
// #include "cntstor.hxx"
#endif

#ifndef _GLOBNAME_HXX
#include <tools/globname.hxx>
#endif

#if (defined(WNT) && defined(PROFILE))

extern "C" {
	void StartCAP (void);
	void StopCAP  (void);
	void DumpCAP  (void);
}

#else

#ifndef _TIME_HXX
#include <tools/time.hxx>
#endif

#endif /* PROFILE */

void EnterMultiThread (int);

#include <stdio.h>

/*
 * folder.
 */
void folder (SvLockBytesRef xLockBytes, ULONG nDepth)
{
	CntStoreFolderRef xFolder = new CntStoreFolder (xLockBytes);
	xLockBytes = NULL;

	// Open.
#ifndef PROFILE
	ULONG nStartTicks = Time::GetSystemTicks();
#endif /* PROFILE */

	SvGlobalName aSetId (
		0x61f63db0, 0x398a, 0x11d1,
		0x97, 0x64, 0x00, 0xa0,
		0x24, 0x3d, 0x2f, 0xfe);

#if ((_DEMOSTOR_WRITE == 1) && (_DEMOSTOR_TRUNC == 1))
	xFolder->open (
		(STREAM_STD_READWRITE | STREAM_TRUNC), CNTSTORE_RECORDSIZE_1K);

	xFolder->setGlobalName (aSetId);
#else
	xFolder->open (STREAM_STD_READWRITE);

	SvGlobalName aGetId;
	xFolder->getGlobalName (aGetId);
	if (!(aGetId == aSetId))
		return;
#endif /* (_WRITE && _TRUNC) */

#ifndef PROFILE
	ULONG nTicks = Time::GetSystemTicks();
	printf ("Open(%d): %d[ms]\n",
			_DEMOSTOR_SUBFOLDER_DEPTH - nDepth,
			nTicks - nStartTicks);
#endif /* PROFILE */

	if (xFolder->isValid())
	{
		// Buffer.
		char pBuffer[_DEMOSTOR_BUFSIZ] = "Hello World";
		pBuffer[_DEMOSTOR_BUFSIZ - 2] = 'B';
		pBuffer[_DEMOSTOR_BUFSIZ - 1] = '\0';

 		// Folder.
#ifndef PROFILE
		ULONG nStartTicks = Time::GetSystemTicks();
#endif /* PROFILE */

		for (ULONG nKey = 0; nKey < _DEMOSTOR_LOOPS; nKey++)
		{
			ErrCode eErrCode = ERRCODE_NONE;
			CntStoreKey *pKey = NULL;

#if (_DEMOSTOR_TRUNC == 1)
			eErrCode = xFolder->acquire (
				pKey, nKey + 1, STREAM_STD_READWRITE | STREAM_TRUNC);
#else
			eErrCode = xFolder->acquire (
				pKey, nKey + 1, STREAM_STD_READWRITE);
#endif /* _TRUNC */
			if (eErrCode != ERRCODE_NONE)
				break;

			ULONG   nDone = 0;
#if (_DEMOSTOR_WRITE == 1)
			eErrCode = xFolder->write (
				*pKey, 1, pBuffer, sizeof(pBuffer), nDone);
#else
			eErrCode = xFolder->read (
				*pKey, 1, pBuffer, sizeof(pBuffer), nDone);
#endif /* _WRITE */
			xFolder->release (pKey);

			if (eErrCode != ERRCODE_NONE)
				break;

#ifndef PROFILE
			if (((nKey + 1) % (_DEMOSTOR_LOOPS/10)) == 0)
			{
				ULONG nTicks = Time::GetSystemTicks();
				printf ("%d: %12.4g\n", nKey + 1,
						(double)(nTicks-nStartTicks)/(double)(nKey+1));
			}
#endif /* PROFILE */
		}

#ifndef PROFILE
		ULONG nTicks = Time::GetSystemTicks();
		printf ("Total(%d): %d[ms]\n",
				_DEMOSTOR_SUBFOLDER_DEPTH - nDepth,
				nTicks - nStartTicks);
#endif /* PROFILE */
	}

	if (nDepth)
	{
		// SubFolder.
		CntStoreLockBytesRef xLB = new CntStoreLockBytes (
			xFolder, _DEMOSTOR_SUBFOLDER_KEY, STREAM_STD_READWRITE);

		folder (&xLB, nDepth - 1);
		xLB = NULL;
	}
	xFolder = NULL;
}

/*
 * main.
 */
int main (int argc, char **argv)
{
	EnterMultiThread (1);

#if (defined(WNT) && defined(PROFILE))
	StartCAP();
#else
	ULONG nStartTicks = Time::GetSystemTicks();
#endif /* PROFILE */

	SvFileStream *pStrm = new SvFileStream (
		_DEMOSTOR_FILENAME, STREAM_STD_READWRITE);
	pStrm->SetBufferSize (0);

	SvLockBytesRef xLockBytes = new SvLockBytes (pStrm, TRUE);

	folder (&xLockBytes, _DEMOSTOR_SUBFOLDER_DEPTH);

#if (_DEMOSTOR_DUMP == 1)

	CntStoreFolderRef xFolder = new CntStoreFolder (&xLockBytes);
	xFolder->open (STREAM_STD_READ);
	if (xFolder->isValid())
	{
		SvFileStream aDmpStrm (
			_DEMOSTOR_DUMPNAME, STREAM_STD_WRITE);
		xFolder->dump (aDmpStrm);
	}
	xFolder = NULL;

#endif /* _DUMP */

	xLockBytes = NULL;

#if (defined(WNT) && defined(PROFILE))
	StopCAP();
	DumpCAP();
#else
	ULONG nTicks = Time::GetSystemTicks();
	printf ("Total: %d[ms]\n", nTicks - nStartTicks);
#endif /* PROFILE */

	return 0;
}

