/*************************************************************************
 *
 *  $RCSfile: confupdateimpl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONFIGMGR_API_UPDATEACCESSIMPL_HXX_
#include "confupdateimpl.hxx"
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _UTL_SEQUENCE_HXX_
#include <unotools/sequence.hxx>
#endif

//........................................................................
namespace configmgr
{
//........................................................................

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::util;
using namespace ::com::sun::star::script;
using namespace ::cppu;
using namespace ::rtl;
using namespace ::osl;

//========================================================================
//= service infos
//========================================================================

const AsciiServiceName aUpdateAccessServices[] = 
{
	"com.sun.star.configuration.ConfigurationUpdateAccess", 
	"com.sun.star.configuration.ConfigurationAccess", 
	NULL
};

const AsciiServiceName aContainerServices[] = 
{
	"com.sun.star.configuration.ConfigurationUpdateAccess",
	"com.sun.star.configuration.ConfigurationAccess",
	"com.sun.star.configuration.ConfigurationContainer",
	NULL
};

const ServiceInfo aUpdateAccessRootSI =
{ 
	"com.sun.star.configuration.configmgr.OUpdateAccessRoot", 
	aUpdateAccessServices
};

const ServiceInfo aUpdateAccessElementSI =
{ 
	"com.sun.star.configuration.configmgr.OUpdateAccessElement", 
	aUpdateAccessServices
};

const ServiceInfo aInnerSetNodeSI =
{ 
	"com.sun.star.configuration.configmgr.OInnerSetNode", 
	aContainerServices
};

const ServiceInfo aInnerSetElementSI =
{ 
	"com.sun.star.configuration.configmgr.OInnerSetElement", 
	aUpdateAccessServices
};

const ServiceInfo aSetElementAndNodeSI =
{ 
	"com.sun.star.configuration.configmgr.OSetElementAndNode", 
	aContainerServices
};

const ServiceInfo aSetNodeUpdateRootSI =
{ 
	"com.sun.star.configuration.configmgr.OSetNodeUpdateRoot", 
	aContainerServices
};

//========================================================================
//= OUpdateAccessRoot
//========================================================================

//------------------------------------------------------------------------
OUpdateAccessRoot::OUpdateAccessRoot(	TreeRef _pTree, const ConfigurationName& _rName, 
										const ::vos::ORef< IRefCountedTreeProvider >& _rUpdater,
										const ::vos::ORef< IRefCountedTemplateProvider >& _rTemplateFactory,
										IConfigBroadcaster& _rEventSource,
										const Reference< XTypeConverter >& _rxConverter)
	:ServiceComponentImpl(&aUpdateAccessRootSI)
	,HierarchyUpdateRootGroup(ServiceComponentImpl::rBHelper, _pTree, _rName, _rUpdater, _rTemplateFactory, _rEventSource, _rxConverter)
{
}

//------------------------------------------------------------------------
void SAL_CALL OUpdateAccessRoot::disposing()
{
	HierarchyUpdateRootGroup::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OUpdateAccessRoot::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = HierarchyUpdateRootGroup::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OUpdateAccessRoot::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		HierarchyUpdateRootGroup::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OUpdateAccessRoot::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OUpdateAccessRoot::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OUpdateAccessRoot::createElement : invalid path !");
	TreeRef pNode = _rPath.back();
	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(this, _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(this, _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();

	return pReturn;
}


//========================================================================
//= OUpdateAccessElement
//========================================================================

//------------------------------------------------------------------------
OUpdateAccessElement::OUpdateAccessElement(HierarchyUpdateRoot* _pUpdateRoot, SubtreeChange* _pModifications, const TreePath& _rRelativeLocation)
	:ServiceComponentImpl(&aUpdateAccessElementSI)
	,HierarchyUpdateElementGroup(ServiceComponentImpl::rBHelper, _pUpdateRoot, _pModifications, _rRelativeLocation)
{
}

//------------------------------------------------------------------------
void SAL_CALL OUpdateAccessElement::disposing()
{
	HierarchyUpdateElementGroup::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OUpdateAccessElement::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = HierarchyUpdateElementGroup::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OUpdateAccessElement::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		HierarchyUpdateElementGroup::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OUpdateAccessElement::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OUpdateAccessElement::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OUpdateAccessElement::createElement : invalid path !");
	TreeRef pNode = _rPath.back();

	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(getUpdateRoot(), _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(getUpdateRoot(), _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();
	return pReturn;
}

//========================================================================
//= OInnerSetNode
//========================================================================
//------------------------------------------------------------------------
OInnerSetNode::OInnerSetNode(HierarchyUpdateRoot* _pUpdateRoot, SubtreeChange* _pModifications, const TreePath& _rRelativeLocation)
	:ServiceComponentImpl(&aInnerSetNodeSI)
	,OSetNodeUpdateElement(ServiceComponentImpl::rBHelper, _pUpdateRoot, _pModifications, _rRelativeLocation)
{
}

//------------------------------------------------------------------------
void SAL_CALL OInnerSetNode::disposing()
{
	// TODO: Is this the correct Sequence ?
	OSetNodeUpdateElement::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OInnerSetNode::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = OSetNodeUpdateElement::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OInnerSetNode::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		OSetNodeUpdateElement::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OInnerSetNode::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OInnerSetNode::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OInnerSetNode::createElement : invalid path !");
	TreeRef pNode = _rPath.back();

	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(getUpdateRoot(), _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(getUpdateRoot(), _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();
	return pReturn;
}

//------------------------------------------------------------------------
OFloatableNode* OInnerSetNode::createFloatingElement(const TreePath& _rCompleteThisPath, ::std::auto_ptr<ISubtree> _rFloatingSubtree)
{
	OSL_ENSHURE(_rFloatingSubtree.get(), "OInnerSetNode::createFloatingElement : invalid floating tree !");
	OFloatableNode* pReturn = NULL;

	if (_rFloatingSubtree->isSetNode())
		// the new node is a set node itself
		pReturn = new OSetElementAndNode(m_sContainerTemplateName, _rFloatingSubtree, _rCompleteThisPath, _rFloatingSubtree->getChildTemplateName(), getUpdateRoot());
	else
		pReturn = new OInnerSetElement(m_sContainerTemplateName, getUpdateRoot(), _rCompleteThisPath, _rFloatingSubtree);

	if (pReturn)
	{
		pReturn->acquire();
		pReturn->Init();
	}
	return pReturn;
}

//========================================================================
//= OInnerSetElement
//========================================================================
//------------------------------------------------------------------------
OInnerSetElement::OInnerSetElement(const ::rtl::OUString& _rTemplateName, HierarchyUpdateRoot* _pUpdateRoot, const TreePath& _rSetPath, ::std::auto_ptr<ISubtree> _pTemplateInstance)
	:ServiceComponentImpl(&aInnerSetElementSI)
	,OFloatableGroup(ServiceComponentImpl::rBHelper, _rTemplateName, _rSetPath, _pTemplateInstance, _pUpdateRoot)
{
}

//------------------------------------------------------------------------
void SAL_CALL OInnerSetElement::disposing()
{
	// TODO: Is this the correct Sequence ?
	OFloatableGroup::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OInnerSetElement::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = OFloatableGroup::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OInnerSetElement::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		OFloatableGroup::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OInnerSetElement::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OInnerSetElement::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OInnerSetElement::createElement : invalid path !");
	TreeRef pNode = _rPath.back();

	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(getUpdateRoot(), _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(getUpdateRoot(), _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();
	return pReturn;
}

//========================================================================
//= OSetElementAndNode
//========================================================================
//------------------------------------------------------------------------
OSetElementAndNode::OSetElementAndNode(
				const ::rtl::OUString& _rElementTemplateName,
				::std::auto_ptr<ISubtree> _pTemplateInstance,
				const TreePath& _rSetPath,
				const ::rtl::OUString& _rContainerTemplateName,
				HierarchyUpdateRoot* _pUpdateRoot)
	:ServiceComponentImpl(&aSetElementAndNodeSI)
	,OFloatableSetNode(ServiceComponentImpl::rBHelper, _rElementTemplateName, _pTemplateInstance, _rSetPath, _rContainerTemplateName, _pUpdateRoot)
{
}

//------------------------------------------------------------------------
void SAL_CALL OSetElementAndNode::disposing()
{
	// TODO: Is this the correct Sequence ?
	OFloatableSetNode::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OSetElementAndNode::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = OFloatableSetNode::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OSetElementAndNode::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		OFloatableSetNode::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OSetElementAndNode::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OSetElementAndNode::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OSetElementAndNode::createElement : invalid path !");
	TreeRef pNode = _rPath.back();
	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(getUpdateRoot(), _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(getUpdateRoot(), _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();
	return pReturn;
}

//------------------------------------------------------------------------
OFloatableNode* OSetElementAndNode::createFloatingElement(const TreePath& _rCompleteThisPath, ::std::auto_ptr<ISubtree> _rFloatingSubtree)
{
	OSL_ENSHURE(_rFloatingSubtree.get(), "OSetElementAndNode::createFloatingElement : invalid floating tree !");
	OFloatableNode* pReturn = NULL;

	if (_rFloatingSubtree->isSetNode())
	{
		// the new node is a set node itself
		pReturn = new OSetElementAndNode(m_sContainerTemplateName, _rFloatingSubtree, _rCompleteThisPath, _rFloatingSubtree->getChildTemplateName(), getUpdateRoot());

		// notice that in this case there are 3 different template names involved :
		// 1. we are a node which's parent is a set (derived from OFloatableNode)
		// 2. we're a set node ourself (derived from OSetNode)
		// 3. the to-be-created element is a set node, too (cause it's child template name is not empty)
		//
		// only 2. and 3. are relevant for creating the new element, 2. is m_sContainerTemplateName,
		// 3. is _rFloatingSubtree->getChildTemplateName(). 1. would be m_sChildTemplateName ....
	}
	else
		pReturn = new OInnerSetElement(m_sContainerTemplateName, getUpdateRoot(), _rCompleteThisPath, _rFloatingSubtree);

	if (pReturn)
	{
		pReturn->acquire();
		pReturn->Init();
	}
	return pReturn;
}

//========================================================================
//= OSetNodeUpdateRoot
//========================================================================
//------------------------------------------------------------------------
OSetNodeUpdateRoot::OSetNodeUpdateRoot(
		ServiceInfo const* pDerivedServiceInfo,
		TreeRef _pTree, const ConfigurationName& _rName, 
		const ::vos::ORef< IRefCountedTreeProvider >& _rUpdater,
		const ::vos::ORef< IRefCountedTemplateProvider >& _rTemplateFactory, 
		const ::rtl::OUString& _rContainerTemplateName,
		IConfigBroadcaster& rEventSource_,
		const Reference< XTypeConverter >& _rxConverter
	)
	:ServiceComponentImpl(pDerivedServiceInfo)
	,ORootSetNode(ServiceComponentImpl::rBHelper, _rName, _pTree, _rContainerTemplateName, _rTemplateFactory, _rUpdater, rEventSource_, _rxConverter)
{
}
//------------------------------------------------------------------------

OSetNodeUpdateRoot::OSetNodeUpdateRoot(
		TreeRef _pTree, const ConfigurationName& _rName, 
		const ::vos::ORef< IRefCountedTreeProvider >& _rUpdater,
		const ::vos::ORef< IRefCountedTemplateProvider >& _rTemplateFactory, 
		const ::rtl::OUString& _rContainerTemplateName,
		IConfigBroadcaster& rEventSource_,
		const Reference< XTypeConverter >& _rxConverter
	)
	:ServiceComponentImpl(&aSetNodeUpdateRootSI)
	,ORootSetNode(ServiceComponentImpl::rBHelper, _rName, _pTree, _rContainerTemplateName, _rTemplateFactory, _rUpdater, rEventSource_, _rxConverter)
{
}

//------------------------------------------------------------------------
void SAL_CALL OSetNodeUpdateRoot::disposing()
{
	// TODO: Is this the correct Sequence ?
	ORootSetNode::disposing();
	ServiceComponentImpl::disposing();
}

//------------------------------------------------------------------------
Any SAL_CALL OSetNodeUpdateRoot::queryInterface(Type const& _rType) throw (RuntimeException)
{
	Any aReturn = ORootSetNode::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = ServiceComponentImpl::queryInterface(_rType);
	return aReturn;
}

//------------------------------------------------------------------------
Sequence< Type > SAL_CALL OSetNodeUpdateRoot::getTypes() throw (RuntimeException)
{
	return ::utl::concatSequences(
		ORootSetNode::getTypes(),
		ServiceComponentImpl::getTypes()
	);
}

//------------------------------------------------------------------------
Sequence< sal_Int8 > SAL_CALL OSetNodeUpdateRoot::getImplementationId() throw (RuntimeException)
{
	static OImplementationId aId;
	return aId.getImplementationId();
}

//------------------------------------------------------------------------
HierarchyUpdateBase* OSetNodeUpdateRoot::createElement(SubtreeChange* _pModifications, const TreePath& _rPath)
{
	OSL_ENSHURE(_rPath.size(), "OSetNodeUpdateRoot::createElement : invalid path !");
	TreeRef pNode = _rPath.back();
	HierarchyUpdateElement* pReturn = NULL;
	if (pNode->isSetNode())
		pReturn = new OInnerSetNode(this, _pModifications, _rPath);
	else
		pReturn = new OUpdateAccessElement(this, _pModifications, _rPath);

	pReturn->acquire();
	pReturn->Init();
	return pReturn;
}

//------------------------------------------------------------------------
OFloatableNode* OSetNodeUpdateRoot::createFloatingElement(const TreePath& _rCompleteThisPath, ::std::auto_ptr<ISubtree> _rFloatingSubtree)
{
	OSL_ENSHURE(_rFloatingSubtree.get(), "OSetNodeUpdateRoot::createFloatingElement : invalid floating tree !");
	OFloatableNode* pReturn = NULL;

	if (_rFloatingSubtree->isSetNode())
		// the new node is a set node itself
		pReturn = new OSetElementAndNode(m_sContainerTemplateName, _rFloatingSubtree, _rCompleteThisPath, _rFloatingSubtree->getChildTemplateName(), this);
	else
		pReturn = new OInnerSetElement(m_sContainerTemplateName, this, _rCompleteThisPath, _rFloatingSubtree);

	if (pReturn)
	{
		pReturn->acquire();
		pReturn->Init();
	}
	return pReturn;
}

//........................................................................
} // namespace configmgr
//........................................................................


