/*************************************************************************
 *
 *  $RCSfile: useradminimpl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "useradminimpl.hxx"

#ifndef CONFIGMGR_USERADMIN_HXX_
#include "useradmin.hxx"
#endif
#ifndef _CONFIGMGR_TREEACTIONS_HXX_
#include "treeactions.hxx"
#endif

namespace configmgr
{
	const AsciiServiceName aUserContainerServices[] = 
	{
		"com.sun.star.configuration.UserAdministration",
		"com.sun.star.configuration.ConfigurationUpdateAccess",
		"com.sun.star.configuration.ConfigurationAccess",
		"com.sun.star.configuration.ConfigurationContainer",
		NULL
	};

	const ServiceInfo aUserAdminSI =
	{ 
		"com.sun.star.configuration.configmgr.OUserAdminRoot", 
		aUserContainerServices
	};

//========================================================================
//= OUserAdminRoot
//========================================================================
	OUserAdminRoot::OUserAdminRoot(
			TreeRef _pTree,
			const ConfigurationName& _rName,
			const ::vos::ORef< IRefCountedTreeProvider >& _rUpdater,
			const ::vos::ORef< IRefCountedTemplateProvider >& _rTemplateFactory,
			const ::rtl::OUString& _rContainerTemplateName,
			IConfigBroadcaster& rEventSource_,
			const ::com::sun::star::uno::Reference< ::com::sun::star::script::XTypeConverter >& _rxConverter
			)
	: OSetNodeUpdateRoot(&aUserAdminSI, _pTree, _rName, _rUpdater, _rTemplateFactory, _rContainerTemplateName, rEventSource_, _rxConverter)
	{
		m_bAllowUnescaped = sal_True;
	}
	//--------------------------------------------------------------------------
	std::auto_ptr<AddNode> OUserAdminRoot::createAddTransaction(OFloatableNode& rAddedNode_, ::rtl::OUString const& sNewName_)
	{
		std::auto_ptr<AddNode> aSimpleAdd(OSetNodeUpdateRoot::createAddTransaction(rAddedNode_,sNewName_));

		// build an AddUser from the information it holds
		OSL_ENSHURE(aSimpleAdd.get(), "Cannot create addUser transaction - Could not create a simple AddNode transaction");

		AddNode* pAddUser = aSimpleAdd.get() ? new AddUser(aSimpleAdd->releaseAddedNode(), aSimpleAdd->getNodeName()) : 0;
		
		return std::auto_ptr<AddNode>(pAddUser);
	}


//========================================================================
//= counting addUsers
//========================================================================
	void OChangeActionCounter::handle(AddNode const& aAddNode)
	{
		++nAdds; 
		if (aAddNode.ISA(AddUser))
			++nAddUsers;
	}

} // namespace configmgr

