/*************************************************************************
 *
 *  $RCSfile: configmodule.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CONFIGMGR_MODULE_HXX_
#define CONFIGMGR_MODULE_HXX_

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif
#ifndef _CONFIGMGR_COMMONTYPES_HXX_
#include "commontypes.hxx"
#endif

namespace com {	namespace sun {	namespace star {

	namespace lang		{ class XMultiServiceFactory; }			
	namespace script	{ class XTypeConverter; }	

}	}	}

namespace configmgr
{
	namespace css = ::com::sun::star;
	namespace uno = css::uno;
	namespace lang = css::lang;
	namespace script = css::script;

	class ConfigurationProvider;
	class IConfigSession;
	class ConnectionSettings;

	class Module
	{
		uno::WeakReference<lang::XMultiServiceFactory > m_aServiceManager;
		uno::Reference<script::XTypeConverter>		m_aConverter;
		IConfigSession*								m_aSession;
		ConfigurationProvider*						m_aProvider;
	public:
		Module(uno::Reference< lang::XMultiServiceFactory > const& rServiceManager);
		~Module();

		ConnectionSettings getConnectionData() const;

		IConfigSession*	connect();
		IConfigSession*	connect(ConnectionSettings const& aSettings, SettingsOverride const& _rSettings);
		IConfigSession*	connect(ConnectionSettings const& aSettings);
		void			disconnect() { disconnect(m_aSession); }
		void			disconnect(IConfigSession*);

		ConfigurationProvider* getProvider() const { return m_aProvider; }
		IConfigSession*	getSession() const			{ return m_aSession; }

		uno::Reference< script::XTypeConverter > getConverter() const; 
		lang::XMultiServiceFactory* getServiceManager() const;

		void newProvider(ConfigurationProvider* );
		void disposing(ConfigurationProvider* );
	private:
		Module(Module&);
		void operator=(Module&);
	};
};

#endif CONFIGMGR_MODULE_HXX_


