/*************************************************************************
 *
 *  $RCSfile: dataexport.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CONFIGMGR_API_DATA_EXPORT_HXX_
#define CONFIGMGR_API_DATA_EXPORT_HXX_

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase3.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_IO_XDATAIMPORTER_HDL_
#include <com/sun/star/io/XDataExporter.hpp>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XEXTENDEDDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>
#endif

#include <com/sun/star/container/XNameAccess.hpp>

#include "xmlformater.hxx"

namespace configmgr
{
	// borrow from confsvccomponent.hxx
	typedef sal_Char const * AsciiServiceName;
	struct ServiceInfo
	{
		AsciiServiceName implementationName;
		AsciiServiceName const * serviceNames;
	};


	class ConfigurationProvider;
	namespace uno  = ::com::sun::star::uno;
	namespace lang = ::com::sun::star::lang;
	namespace io  = ::com::sun::star::io;
	// namespace util = ::com::sun::star::util;


	class ODataExport : public ::cppu::WeakImplHelper3<lang::XInitialization,lang::XServiceInfo,io::XDataExporter>
	{
		osl::Mutex m_aMutex;

	public:
		static const ServiceInfo staticServiceInfo;
	protected:
		uno::Reference< lang::XMultiServiceFactory > m_xMSF; // the service provider used for creating the instance
		uno::Reference< sax::XDocumentHandler > m_xWriter;
		uno::Sequence<rtl::OUString> m_sPathSeq;
		rtl::OUString m_sPackageName;

		AnyToXMLDocument m_aDocConverter;
		
		void handleNameAccess( uno::Reference<com::sun::star::container::XNameAccess> &_rxNameAccess);
	public:
		ODataExport(const uno::Reference< lang::XMultiServiceFactory > &xMSF)
				:m_xMSF(xMSF),
				 m_aMutex()
			{
			}
		
		// XInitialization
		virtual void SAL_CALL initialize( const uno::Sequence< uno::Any >& aArguments ) throw(uno::Exception, uno::RuntimeException);

		// XServiceInfo
		virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw(uno::RuntimeException);
		virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName ) throw(uno::RuntimeException);
		virtual uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(  ) throw(uno::RuntimeException);

		uno::Sequence< rtl::OUString > getServiceNames(ServiceInfo const* pInfo  ) throw(uno::RuntimeException);
		sal_Int32 countServices(ServiceInfo const* aInfo);

		// XDataExporter
		virtual void SAL_CALL exportData( const uno::Reference< io::XOutputStream >& aOutputStream,
										  const uno::Reference< lang::XComponent >& Component,
										  const uno::Reference< io::XDataTransferEventListener >& aListener )
			throw(uno::RuntimeException);
		virtual void SAL_CALL cancel() throw(uno::RuntimeException);


		// Exporter
		void writeStart() throw (sax::SAXException);
	};

} // namespace configmgr


#endif // CONFIGMGR_API_DATA_EXPORT_HXX_
