/*************************************************************************
 *
 *  $RCSfile: localsession.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONFIGMGR_LOCAL_LOCAL_HXX_
#define _CONFIGMGR_LOCAL_LOCAL_HXX_


#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XPARSER_HPP_
#include <com/sun/star/xml/sax/XParser.hpp>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XEXTENDEDDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>
#endif

#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif

#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif

#ifndef _CONFIGMGR_SESSION_CONFIGSESSION_HXX_
#include "configsession.hxx"
#endif
#ifndef _CONFIGMGR_FILEHELPER_HXX_
#include "filehelper.hxx"
#endif

#include <stl/vector>

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

namespace configmgr 
{
	namespace css = com::sun::star;
	namespace uno = css::uno;
	namespace io =  com::sun::star::io;
	namespace sax = css::xml::sax;
	namespace lang= css::lang;
	

	class LocalSession : public IConfigSession
	{
		::osl::Mutex				m_aMutex;				/// multi-thread access safety
		TSessionError               m_eError;

		uno::Reference< lang::XMultiServiceFactory > m_xServiceProvider;

		rtl::OUString m_aModuleName;
		std::vector<rtl::OUString> m_aFilterVector;

		rtl::OUString m_aRootPath;
		StatusInfo    m_aStatus;

		void cutPath(const rtl::OUString &_rPath);
		rtl::OUString createFileURL(const rtl::OUString& aModuleName) const;

	public:
		LocalSession(const uno::Reference< lang::XMultiServiceFactory >& _rxServiceProvider);
		
		virtual ~LocalSession() { }
		virtual TSessionError getError() const {return m_eError;}
		virtual sal_Int32   getConnectionError() const {return m_eError;}
		virtual void    setListener(const ::vos::ORef< ISessionListener >& _pListener) {}
		
		virtual void    startListening( const uno::Sequence< ::rtl::OUString >& _rNodes,
										const ::vos::ORef< IRequestCallback >& _rHandler) {}
		virtual void    stopListening( const uno::Sequence< ::rtl::OUString >& _rNodes,
									   const ::vos::ORef< IRequestCallback >& _rHandler) {}
		virtual void    stopAllListening( const ::vos::ORef< IRequestCallback >& _rHandler) {}
		
		virtual void    openNode(const ::rtl::OUString& _rNodePath,
								 sal_Int32 _nLevel,
								 const ::vos::ORef< IOpenObjectCallback >& _rHandler);
		virtual void    closeNode(const ::rtl::OUString& _rNodeId,
								  const ::vos::ORef< IRequestCallback >& _rHandler);
		virtual void    getNode(const ::rtl::OUString& _rNodePath,
								const ::vos::ORef< IOpenObjectCallback >& _rHandler);
		virtual void    updateNode(const ::rtl::OUString& _rNodeId,
								   const ::rtl::OUString& _rNodePath,
								   IDOMNodeDataProvider* _pNodeWriter,
								   const ::vos::ORef< IDataRequestCallback >& _rHandler);
		virtual void    addNode(const ::rtl::OUString& _rNodeId,
								const ::rtl::OUString& _rParentNodeAccessor,
								IDOMNodeDataProvider* _pNodeWriter,
								const ::vos::ORef< IRequestCallback >& _rHandler);
		virtual void    addUser(const ::rtl::OUString& _rUser,
								IDOMNodeDataProvider* _pNodeWriter,
								const ::vos::ORef< IRequestCallback >& _rHandler,
								const ::rtl::OUString& _rNodeId = ::rtl::OUString());
		virtual void    deleteNode(const ::rtl::OUString& _rNodeId,
								   const ::rtl::OUString& _rNodePath,
								   const ::vos::ORef< IRequestCallback >& _rHandler);

		sal_Bool open(const ::rtl::OUString& _rFilename);
		void     close(const ::vos::ORef< IRequestCallback >& _rHandler);
		sal_Bool isOpen();

	};
// -----------------------------------------------------------------------------

	class XMLFilter

	{
	protected:
		enum State {
			UNKNOWN_ELEMENT,
			FORWARDING_DATA,
			JUMP_OVER
		};
		State m_eState, m_ePushedState;
		std::vector<rtl::OUString>   m_aNameStack;
		std::vector< rtl::OUString > m_aFilterVector;

		XMLFilter(const std::vector< rtl::OUString > &aFilterVector);
	};

// -----------------------------------------------------------------------------

	typedef ::cppu::WeakImplHelper1<sax::XDocumentHandler> CmDocumentHandler_BASE;

	class XMLWriteFilter : public CmDocumentHandler_BASE,
						   public XMLFilter
	{
		uno::Reference< sax::XDocumentHandler > m_xWriter;         // the service object for writing XML code
		uno::Reference< sax::XParser >          m_xReader;         // the service object for reading/parsing XML code

		sal_Int32 m_nIgnoreLevel;

		std::vector< rtl::OUString > m_aInsertFilter;
		sal_Bool bInserted;
		IDOMNodeDataProvider*        m_pNodeWriter;

	public:
		XMLWriteFilter(const uno::Reference< sax::XDocumentHandler > &xWriter,
					   const uno::Reference< sax::XParser >          &xReader,
					   const std::vector<rtl::OUString> &aFilterVector,
					   IDOMNodeDataProvider* _pNodeWriter);
		
		// DECLARE_UNO3_DEFAULTS(XMLWriteFilter, CmDocumentHandler_BASE);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const rtl::OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const rtl::OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const rtl::OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const rtl::OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const rtl::OUString& aTarget,
													const rtl::OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
		
		static sal_Int32 run(const rtl::OUString &_aFromURL,
							 const rtl::OUString &_aToURL,
							 const uno::Reference< lang::XMultiServiceFactory >& _rxServiceProvider,
							 const std::vector<rtl::OUString> &aFilterVector,
							 IDOMNodeDataProvider* _pNodeWriter,
							 /* [OUT] */ rtl::OUString &sError);

	};


// -----------------------------------------------------------------------------

	class XMLReadFilter : public CmDocumentHandler_BASE,
						  public XMLFilter
	{
		uno::Reference< sax::XDocumentHandler > m_xWriter;         // the service object for writing XML code

		sal_Int32 m_nElementDepth;
		sal_Int32 m_nIgnoreLevel;
	public:
		XMLReadFilter::XMLReadFilter( const uno::Reference< sax::XDocumentHandler > &xWriter,
									  const std::vector<rtl::OUString> &aFilterVector );

		// DECLARE_UNO3_DEFAULTS(XMLReadFilter, CmDocumentHandler_BASE);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const rtl::OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const rtl::OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const rtl::OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const rtl::OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const rtl::OUString& aTarget,
													const rtl::OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
		
		static sal_Int32 run(const rtl::OUString &_aFromURL,
							 const uno::Reference< lang::XMultiServiceFactory >& _rxServiceProvider,
							 const std::vector<rtl::OUString> &aFilterVector,
							 const uno::Reference< sax::XDocumentHandler > &xWriter,
							 /* [OUT] */ rtl::OUString &sError);
	};
// -----------------------------------------------------------------------------
	class XMLRemoveFilter : public CmDocumentHandler_BASE,
							public XMLFilter
	{
		uno::Reference< sax::XDocumentHandler > m_xWriter;         // the service object for writing XML code
		uno::Reference< sax::XParser >          m_xReader;         // the service object for reading/parsing XML code

		sal_Int32 m_nIgnoreLevel;
		bool m_bDropNextCartReturn;				 // next characters() won't write whitespaces
	public:
		XMLRemoveFilter(const uno::Reference< sax::XDocumentHandler > &xWriter,
						const uno::Reference< sax::XParser >          &xReader,
						const std::vector<rtl::OUString> &aFilterVector);
		
		// DECLARE_UNO3_DEFAULTS(XMLRemoveFilter, CmDocumentHandler_BASE);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const rtl::OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const rtl::OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const rtl::OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const rtl::OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const rtl::OUString& aTarget,
													const rtl::OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
		

		static sal_Int32 run(const rtl::OUString &_aFromURL,
							 const rtl::OUString &_aToURL,
							 const uno::Reference< lang::XMultiServiceFactory >& _rxServiceProvider,
							 const std::vector<rtl::OUString> &aFilterVector,
							 /* [OUT] */ rtl::OUString &sError);
	};
} // namespace configmgr

#endif
