/*************************************************************************
 *
 *  $RCSfile: strconverter.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONFIGMGR_STRCONVERTER_HXX_
#define _CONFIGMGR_STRCONVERTER_HXX_

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase1.hxx>
#endif

#ifndef _CONFIGMGR_MISC_ATTRIBUTES_HXX_
#include "attributes.hxx"
#endif

#ifndef _CONFIGMGR_SAXTOOLS_HXX_
#include "saxtools.hxx"
#endif

namespace configmgr 
{
	::rtl::OUString changeToComSunStarPath(const ::rtl::OUString &aPath);
	::rtl::OUString mapTo(const rtl::OUString& aFrom, bool bToNew);

	namespace sax = com::sun::star::xml::sax;
	namespace uno = com::sun::star::uno;
	
	typedef ::cppu::WeakImplHelper1< sax::XDocumentHandler > OValueConverter_Base;

	// class to convert some old Element-Tags, values, Attributes, Parameters to new one.
	class OValueConverter : public OValueConverter_Base
	{
		uno::Reference< sax::XDocumentHandler >	m_xMasterHandler;	// same as got from m_aMasterCallback->getDataReader
																// (in read mode) or the writer to forward to
																// (in write mode)
		bool m_bConvertToNew;					 // true: convert to new values (use old server with new format)
												 // else: convert to old values (use new values with old server)
		sal_Int32 m_nElementDepth;
	public:
		OValueConverter(const uno::Reference< sax::XDocumentHandler > &xHandler, bool convertToNew);
		~OValueConverter();
		// IInterface
		virtual void SAL_CALL acquire(  ) throw () { OValueConverter_Base::acquire(); }
		virtual void SAL_CALL release(  ) throw () { OValueConverter_Base::release(); }

		// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const uno::Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator( const uno::Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, uno::RuntimeException);
	};
}

#endif
