/*************************************************************************
 *
 *  $RCSfile: xmltreebuilder.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/* PLEASE DON'T DELETE ANY COMMENT LINES, ALSO IT'S UNNECESSARY. */

#ifndef _CONFIGMGR_XMLTREEBUILDER_HXX
#define _CONFIGMGR_XMLTREEBUILDER_HXX

#ifndef _COM_SUN_STAR_SCRIPT_XTYPECONVERTER_HPP_
#include <com/sun/star/script/XTypeConverter.hpp>
#endif
#ifndef _CONFIGMGR_SESSION_CONFIGSESSION_HXX_
#include "configsession.hxx"
#endif
#ifndef CONFIGMGR_CMTREEMODEL_HXX
#include "cmtreemodel.hxx"
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XEXTENDEDDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#include <stl/vector>
#include <stl/stack>
#include <stl/memory>

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif

#ifndef _UTL_STLTYPES_HXX_
#include <unotools/stl_types.hxx>
#endif

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _OSL_CONDITN_HXX_
#include<osl/conditn.hxx>
#endif


#include <com/sun/star/container/XNameAccess.hpp>

FORWARD_DECLARE_INTERFACE(script,XTypeConverter)

namespace configmgr
{
	namespace star		= ::com::sun::star;
	namespace uno		= ::com::sun::star::uno;
	namespace sax		= ::com::sun::star::xml::sax;
	namespace script	= ::com::sun::star::script;
	namespace lang		= ::com::sun::star::lang;
	namespace container	= ::com::sun::star::container;

	using ::rtl::OUString;

	class Subtree;

	typedef ::cppu::WeakImplHelper1<sax::XExtendedDocumentHandler> CmExtendedDocumentHandler_BASE;

	class CmExtendedDocumentAdapter:
		public CmExtendedDocumentHandler_BASE
	{
		// long live java, this is an AdapterClass
	public:

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException) = 0;
		//
		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException) = 0;
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException) =0;
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException) =0;
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException) =0;



		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);

		// XExtendedDocumentHandler
		virtual void SAL_CALL startCDATA(void) throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endCDATA(void) throw(uno::RuntimeException);
		virtual void SAL_CALL comment(const OUString& sComment)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL allowLineBreak(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL unknown(const OUString& sString)
			throw(sax::SAXException, uno::RuntimeException);
	};





// -----------------------------------------------------------------------------
/*
	TYPE            |  Node
	----------------|-----------------------
	group (default) |  Subtree[group]
	set             |  Subtree[set]

	boolean         |  value[bool]
	short           |  value[int16]
	int             |  value[int32]
	long            |  value[int64]
	double          |  value[double]
	string          |  value[OUString]
	binary          |  value[sequence<int8>]

	derived="list"    sequence<...>
*/
// -----------------------------------------------------------------------------
	class XMLTreeChangeListBuilder;
	class XMLFileImport;
	// Stack to hold a pointer for the subtree
	struct XMLNode
	{
		sal_Bool  bGroup;
		sal_Bool  bValue;
		sal_Bool  bSetState;					 // State for SET Mode
		XMLNode() : bGroup(false), bValue(false), bSetState(false){}
	};


// -----------------------------------------------------------------------------
	class DataConverter
	{
		// TypeConverter is used for converting type into string values
		uno::Reference< script::XTypeConverter > m_xTypeConverter;

	public:
		// DataRepresentation for one Element
		// it's possible, that the data representation needs more than one xml element
		class DataRep {
		public:
			OUString m_aName;
			OUString m_aType;
			OUString m_aEncoding;
			sal_Bool m_bIsAList;
			sal_Bool m_bValueIsNull;
			std::vector<OUString> m_aStringList;
			std::vector<OUString> m_aDefaultStringList;
			void clear() {
				m_aName = OUString();
				m_aType = OUString();
				m_aEncoding = OUString();
				m_bIsAList = false;
				m_aStringList.clear();
				m_aDefaultStringList.clear();
				m_bValueIsNull = false;
			}
			DataRep() { clear(); }
		};
		DataRep m_aDataRep;

		DataConverter(const uno::Reference< script::XTypeConverter > &xTC)
				:m_xTypeConverter(xTC){}
		
		sal_Bool convertBinaryStringToAny(const OUString &aStr,
										  uno::Sequence<sal_Int8> *aBinarySeq);
		sal_Bool convertDataRepresentationToAny(const DataRep& aDataRep,
												uno::Any& anAny, uno::Any& aDefaultAny);

	};

// -----------------------------------------------------------------------------
	class XMLDocumentWithDone : public ::cppu::WeakImplHelper1<sax::XDocumentHandler>
	{
		sal_Int32       m_nElementDepth;
	public:
		XMLDocumentWithDone()
				: m_nElementDepth(0)
			{}
		
		virtual void createResult(const uno::Reference<container::XNameAccess> &xNameAccess) = 0;
		virtual bool needLastEndElementCall() =0;

		// ok, ok, dirty (i call it simple) but i need only one methode to deliver this parameter
		// if we use it more, i will change this funktion.
		virtual void setParameter( const uno::Sequence< uno::Any >& aArguments) {
				// POST: Should overloaded if need.
		}
		
		void inc() {++m_nElementDepth;}
		sal_Int32 dec()
			{
				--m_nElementDepth;
				return m_nElementDepth;
			}
	};

// -----------------------------------------------------------------------------
	class XMLTreeBuilder :
		public IOpenObjectCallback,
		public star::lang::XUnoTunnel,
		public DataConverter,
		public XMLDocumentWithDone
	{
		// std::auto_ptr<Subtree> m_pRoot;
		std::auto_ptr<INode>	m_pRoot;
		sal_Bool m_bValueOnly;					 // true, if only a Value is in m_pRoot
		::osl::Mutex			m_aBuildGuard;	// necessary since our wait methods have a timeout

		// Member for XML tracking
		// enum {
		// 	GROUP, TYPE, SET
		// };


		enum State {
			NODE_TYPE_STARTED,
			VALUE_TYPE_STARTED,
			VALUE_SET_STARTED,
			NAME_STARTED,
			DATA_EXPECTED,
			DATA,
			DATA_DONE,
			DATA_DEFAULT,
			DATA_ITEM,
			DATA_ITEM_DONE,
			DATA_ITEM_DEFAULT,
			ELEMENT_EXPECTED,
			VALUE_TYPE_DONE
		};

		// transitions in startElement(Name, Attributes)            						  Attributes
		// 						  node  value data  data_item  nodefault  default       Name
        // 	(0) ELEMENT_EXPECTED   1      2|3  	-       -        -           -            3    data="..." goto 5; derive="..." goto 4
        // 	(1) NODE_TYPE_STARTED  -      12  	-       -        -           -            -
        // 	(2) VALUE_TYPE_STARTED -      -   	-       -        -           -            -    derive="list" goto 4; else goto 5
        // 	(3) NAME_STARTED       -      -   	-       -        -           -            -    class="group" goto 1; type="..." goto 2
        // 	(4) DATA_EXPECTED      -      -   	6       9        -           -            -
        // 	(5) VALUE_TYPE_DONE    -      -   	-       -        -           -            - END
        // 	(6) DATA               -      -   	-       -        10          -            -
        // 	(7) DATA_DONE          -      -   	-       -        5           8            -
        // 	(8) DATA_DEFAULT       -      -   	-       -        -           -            - END
        // 	(9) DATA_ITEM          -      -   	-       -        -           -            - END
		// (10) DATA_ITEM_DONE     -      -   	-       -        5           11           -
		// (11) DATA_ITEM_DEFAULT  -      -   	-       -        -           -            - END


		// transitions in endElement
		//                      DATA_DONE  DATA_DEFAULT DATA_ITEM_DONE DATA_ITEM_DEFAULT VALUE_DONE DATA DATA_ITEM
		// (0) epsilon              1          3             1               4               2        3     4
		// (1) VALUE_DONE
		// (2) VALUE_EXPECTED
		// (3) DATA_DONE
		// (4) DATA_ITEM_DONE

		State m_eState;
		OUString m_sStateChangeElement;
		OUString m_sInstanceName;


		struct XMLNodeSubtree : public XMLNode
		{
			Subtree *pSubtree;
			XMLNodeSubtree() : pSubtree(NULL){}
		};

		std::stack< XMLNodeSubtree, std::vector<XMLNodeSubtree> > m_aXMLNodeStack;

		::rtl::OUString			m_sSubtreeId;

		XMLTreeBuilder(std::auto_ptr<Subtree> pSubtree, const uno::Reference< script::XTypeConverter >& _rxTypeConverter);
		friend XMLTreeChangeListBuilder;
		friend XMLFileImport;

	protected:
		osl::Condition			m_aCondition;
		StatusInfo				m_aStatus;

		OUString 				m_aCurrentCharacters;


		uno::Reference<sax::XLocator> m_xLocator;
#ifdef DBG_UTIL
		sal_Int32                     m_nLine;
#endif
		rtl::OString LineWarning(const rtl::OString& aWarn); // add a Line:(xyz) the given String

		void rootSubtree(std::auto_ptr<Subtree> aSubtree);

	public:
#ifdef PRIVAT_DEBUG
		void setDone() {m_aCondition.set();}	 // This function is only for testing
#endif
		XMLTreeBuilder(const uno::Reference< script::XTypeConverter >& _rxTypeConverter);
		virtual ~XMLTreeBuilder();

		std::auto_ptr<Subtree> waitToResponse(TimeValue* _pTimeout = NULL);
		std::auto_ptr<INode>   waitToResponseForINode(TimeValue* _pTimeout = NULL);

		// void setTypeConverter(const uno::Reference< script::XTypeConverter >& _rxTypeConverter) { m_xTypeConverter = _rxTypeConverter; }

		StatusInfo getCallResult() const { return m_aStatus; }

		// OWeakObject
		/*
		  Any SAL_CALL queryInterface( const Type &aType ) {return OWeakObject::queryInterface();}
		  void SAL_CALL acquire() { OWeakObject::acquire(); }
		  void SAL_CALL release() { OWeakObject::release(); }
		*/
		DECLARE_UNO3_AGG_DEFAULTS(XMLTreeBuilder, XMLDocumentWithDone);

		// void *getImplementation(Reflection *p)
		// { return OWeakObject::getImplementation(p); }

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException){}
		
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException){}
		

		// IRequestCallback
		virtual void acknowledged(sal_Int32 _nTransId);
		virtual void failed(sal_Int32 _nErrorCode);
		virtual void done(const StatusInfo& _rStatus);

		// IDataRequestCallback
		virtual	uno::Reference< sax::XDocumentHandler > getDataReader() { return uno::Reference< sax::XDocumentHandler >(this); }

		// IOpenObjectCallback
		virtual	void gotObjectId(const ::rtl::OUString& _rId);

		// com::sun::star::lang::XUnoTunnel
		virtual sal_Int64 SAL_CALL getSomething( const uno::Sequence< sal_Int8 >& aIdentifier ) throw(uno::RuntimeException);
		static uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

		virtual void createResult(const uno::Reference<container::XNameAccess> &xNameAccess);
		virtual bool needLastEndElementCall() {return true;}
	};




// ------------------------- XML TreeChangeList Builder -------------------------
	class XMLTreeChangeListBuilder : public ::cppu::WeakImplHelper1<sax::XDocumentHandler>
	{
		enum State {
			UNKNOWN_ELEMENT,
			FORWARDING_DATA,
			VALUE_TYPE_STARTED,
			NODE_TYPE_STARTED,
			VALUE_DONE,
			REMOVE_MODE,
			ELEMENT_EXPECTED
		};
		State m_eState;
		State m_ePushedState;					 // single stack for State

		std::auto_ptr<XMLTreeBuilder> m_pCurrentValueReader;
		Subtree        *m_pCurrentSubtree;
		sal_Int32       m_nElementDepth;

		TreeChangeList* m_pTreeChangeList;
		SubtreeChange*  m_pSubtreeChange;
		OUString m_sPathToRoot;

		struct XMLNodeChange : public XMLNode
		{
			Change *pChange;
			XMLNodeChange() : pChange(NULL){}
		};
		OUString m_sInstanceName;
		OUString m_sModeValue;

		std::stack< XMLNodeChange, std::vector<XMLNodeChange> > m_aXMLNodeStack;
		uno::Reference< script::XTypeConverter > m_xTypeConverter;
	public:
		XMLTreeChangeListBuilder(const uno::Reference< script::XTypeConverter >& _rxTypeConverter, TreeChangeList* p);

		// DECLARE_UNO3_AGG_DEFAULTS(XMLTreeChangeListBuilder, XMLTreeBuilder);

		sal_Bool waitToResponseChange(TimeValue* _pTimeout = NULL);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException){}
		
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException){}
		

		// not used
		virtual void createResult(const uno::Reference<container::XNameAccess> &xNameAccess) {}
	};


// ------------------------- XML TreeChangeList Builder -------------------------
	class XMLDataExtractor : public ::cppu::WeakImplHelper1<sax::XDocumentHandler>
	{
		uno::Reference< lang::XMultiServiceFactory > m_xServiceFactory;
		uno::Reference< script::XTypeConverter > m_xTypeConverter;

		uno::Reference< sax::XDocumentHandler > m_xDataReceiver;
		uno::Reference< uno::XInterface > m_xRoot;

		sal_Int32 m_nElementDepth;
		enum State {
			ELEMENT_EXPECTED,
			UNKNOWN_ELEMENT,
			FORWARDING_DATA
		};
		State m_eState;

	public:
		XMLDataExtractor(const uno::Reference< script::XTypeConverter >& _rxTypeConverter,
						 const uno::Reference< lang::XMultiServiceFactory > &xMSF )
				:m_xServiceFactory(xMSF),
				 m_xTypeConverter(_rxTypeConverter)
			{}

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
	};


// -----------------------------------------------------------------------------
	class XMLFileImport : public XMLDocumentWithDone
	{
		
		enum State {
			UNKNOWN_ELEMENT,
			FORWARDING_DATA,
			VALUE_TYPE_STARTED,
			VALUE_SET_STARTED,
			NODE_TYPE_STARTED,
			VALUE_DONE,
			REMOVE_MODE,
			ELEMENT_EXPECTED
		};
		State m_eState;
		State m_ePushedState;					 // single stack for State

		vos::ORef<XMLDocumentWithDone> m_pCurrentValueReader;
		std::stack<vos::ORef<XMLDocumentWithDone>, vector<vos::ORef<XMLDocumentWithDone> > > m_aValueReaderStack;
		sal_Int32       m_nElementDepth;

		struct XMLNodeChange : public XMLNode
		{
			Change *pChange;
			XMLNodeChange() : pChange(NULL){}
		};
		OUString m_sInstanceName;
		OUString m_sModeValue;

		uno::Reference< script::XTypeConverter > m_xTypeConverter;
		uno::Reference< lang::XMultiServiceFactory > m_xServiceFactory;
		uno::Reference< container::XNameAccess > m_xNameAccess;
		uno::Reference< uno::XInterface > m_xRoot;

		OUString m_sStartName;
		OUString m_sRootPath;

		bool m_bSomethingToCommit;
		std::stack< uno::Reference<container::XNameAccess>, std::vector< uno::Reference<container::XNameAccess> > > m_aXNameAccessStack;

	public:
		XMLFileImport(const uno::Reference< script::XTypeConverter >& _rxTypeConverter,
					  const uno::Reference< container::XNameAccess >& _xNameAccess,
					  const uno::Reference< lang::XMultiServiceFactory > &xMSF,
					  const uno::Reference< uno::XInterface > &xRoot);


		// DECLARE_UNO3_AGG_DEFAULTS(XMLFileImport, XMLDocumentWithDone);

		sal_Bool waitToResponseChange(TimeValue* _pTimeout = NULL);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);

		virtual void createResult(const uno::Reference<container::XNameAccess> &xNameAccess);
	private:
		// Parameter for createResult
		rtl::OUString m_aName;
		uno::Reference<uno::XInterface> m_xInterface;
		sal_Bool m_bIsNewObject;

	public:
		virtual bool needLastEndElementCall() {return false;}
		virtual void setParameter(const uno::Sequence< uno::Any >& aArguments);
	};



// -----------------------------------------------------------------------------
	class XMLSetTreatment : public XMLDocumentWithDone
	{
		
		enum State {
			UNKNOWN_ELEMENT,
			FORWARDING_DATA,
			VALUE_TYPE_STARTED,
			VALUE_SET_STARTED,
			NODE_TYPE_STARTED,
			VALUE_DONE,
			REMOVE_MODE,
			ELEMENT_EXPECTED
		};
		State m_eState;
		State m_ePushedState;					 // single stack for State
		
		vos::ORef<XMLDocumentWithDone> m_pCurrentValueReader;
		std::stack<vos::ORef<XMLDocumentWithDone>, vector<vos::ORef<XMLDocumentWithDone> > > m_aValueReaderStack;
		sal_Int32       m_nElementDepth;
		
		uno::Reference< script::XTypeConverter > m_xTypeConverter;
		uno::Reference< lang::XMultiServiceFactory > m_xServiceFactory;
		uno::Reference< container::XNameAccess > m_xNameAccess;
		uno::Reference< uno::XInterface > m_xRoot;
		
		OUString m_sName;
		
	public:
		XMLSetTreatment(const uno::Reference< script::XTypeConverter >& _rxTypeConverter,
						const uno::Reference< container::XNameAccess >& _xNameAccess,
						const uno::Reference< lang::XMultiServiceFactory > &xMSF,
						const uno::Reference< uno::XInterface > &xRoot);
		
		// DECLARE_UNO3_AGG_DEFAULTS(XMLSetTreatment, XMLDocumentWithDone);
		
		// sal_Bool waitToResponseChange(TimeValue* _pTimeout = NULL);
		
		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
			throw (sax::SAXException, uno::RuntimeException);
		
		virtual void SAL_CALL endDocument(void)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL startElement(const OUString& aName,
										   const uno::Reference< sax::XAttributeList > &xAttribs)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL endElement(const OUString& aName)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL characters(const OUString& aChars)
			throw(sax::SAXException, uno::RuntimeException);
		
		virtual void SAL_CALL ignorableWhitespace(const OUString& aWhitespaces)
			throw(sax::SAXException, uno::RuntimeException);
		
		virtual void SAL_CALL processingInstruction(const OUString& aTarget,
													const OUString& aData)
			throw(sax::SAXException, uno::RuntimeException);
		virtual void SAL_CALL setDocumentLocator(const uno::Reference< sax::XLocator > &xLocator)
			throw(sax::SAXException, uno::RuntimeException);
		
		virtual void createResult(const uno::Reference<container::XNameAccess> &xNameAccess);
	private:
		// Parameter for createResult
		// rtl::OUString m_aName;
		// uno::Reference<uno::XInterface> m_xInterface;
		
	public:
		virtual bool needLastEndElementCall() {return false;}
		virtual void setParameter( const uno::Sequence< uno::Any >& aArguments );
	};
		
		
		
	} // namespace configmgr
#endif /* Header double load protection */
	
	
