/*************************************************************************
 *
 *  $RCSfile: remotesession.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>

#ifndef _CONFIGMGR_SESSION_REMOTESESSION_HXX_
#include "remotesession.hxx"
#endif
#ifndef _CONFIGMGR_MISC_ATTRIBUTES_HXX_
#include "attributes.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_RECEIVETHREAD_HXX_
#include "receivethread.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_ENVELOPESTREAM_HXX_
#include "envelopestream.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_REDIRECTOR_HXX_
#include "redirector.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_RS_TYPES_HXX_
#include "rs_types.hxx"
#endif
#ifndef CONFIGMGR_CONFNAME_HXX_
#include "confname.hxx"
#endif
#ifndef _CONFIGMGR_SAXTOOLS_HXX_
#include "saxtools.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_PORTALSTREAM_HXX_
#include "portalstream.hxx"
#endif
#ifndef _CONFIGMGR_SESSION_SOCKETSTREAM_HXX_
#include "socketstream.hxx"
#endif
#ifndef _CONFIGMGR_TRACER_HXX_
#include "tracer.hxx"
#endif
#ifndef CONFIGMGR_API_ENCODENAME_HXX_
#include "encodename.hxx"
#endif

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif
#ifndef _VOS_CONDITN_HXX_
#include <vos/conditn.hxx>
#endif
#ifndef _DAEMONS_PORTALCONNECT_HXX_
#include <daemons/PortalConnect.hxx>
#endif

#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XCANCELLABLE_HPP_
#include <com/sun/star/util/XCancellable.hpp>
#endif


#ifndef __STLPORT_LIMITS
#include <stl/limits>
#endif

#include "strconverter.hxx"

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::xml;
using namespace ::com::sun::star::io;
using namespace ::com::sun::star::util;
using namespace ::vos;
using namespace ::std;
using namespace ::osl;

//..........................................................................
namespace configmgr
{
//..........................................................................

#if defined(_IMPLICIT_USERPROFILE_USER_NAME_) || defined(_ADMIN_WRITES_DEFAULT_TAGS_)
static const ::rtl::OUString	s_sAdministrator = ::rtl::OUString::createFromAscii("Administrator/");
static const ::rtl::OUString	s_sUserProfileClientAccess = ::rtl::OUString::createFromAscii("org.openoffice.UserProfile");
#endif

#if defined(_ENCODE_USER_NAMES_)
#define USERNAME_ENCODE(s)	unnamed_encodename::encode(s)
#else
#define USERNAME_ENCODE(s)	s
#endif


#ifdef DBG_UTIL
	typedef ::cppu::WeakImplHelper2< sax::XDocumentHandler, XActiveDataSource > OLayoutRefiner_Base;
	/** a simple layout "refiner" which insertes some whitespaces for every startElement/endElement
		<BR>
		not really perfect :), as for instance no linebreaks in whitespaces which the caller inserts
		are recognized (we would have to insert tabs there), but sufficient for our purposes
	*/
	class OLayoutRefiner : public OLayoutRefiner_Base
	{
	protected:
		Reference< sax::XDocumentHandler >	m_xMasterWriter;
		Reference< XActiveDataSource >		m_xMasterSource;
		sal_Int32							m_nElementDepth;

		enum ACTION	{ STARTELEMENT, CHARACTERS, ENDELEMENT };
		ACTION								m_eLastAction;

	public:
		OLayoutRefiner(const Reference< sax::XDocumentHandler >& _rxMasterWriter) : m_xMasterWriter(_rxMasterWriter), m_xMasterSource(_rxMasterWriter, UNO_QUERY), m_nElementDepth(0), m_eLastAction(ENDELEMENT) { }

	// XActiveDataSource
		virtual void SAL_CALL setOutputStream( const ::com::sun::star::uno::Reference< ::com::sun::star::io::XOutputStream >& aStream ) throw(::com::sun::star::uno::RuntimeException) { m_xMasterSource->setOutputStream(aStream); }
		virtual ::com::sun::star::uno::Reference< ::com::sun::star::io::XOutputStream > SAL_CALL getOutputStream(  ) throw(::com::sun::star::uno::RuntimeException) { return m_xMasterSource->getOutputStream(); }

	// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, RuntimeException) { m_xMasterWriter->startDocument(); }
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, RuntimeException) { m_xMasterWriter->endDocument(); }
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException) { m_xMasterWriter->ignorableWhitespace(aWhitespaces); }
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException) { m_xMasterWriter->processingInstruction(aTarget, aData); }
		virtual void SAL_CALL setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException) { m_xMasterWriter->setDocumentLocator(xLocator); }
	};
	//--------------------------------------------------------------------------
	void SAL_CALL OLayoutRefiner::startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException)
	{
		{
			sal_Unicode* pWS = new sal_Unicode[m_nElementDepth + 1];
			sal_Unicode* pFill = pWS;
			*pFill = '\n'; ++pFill;
			for (sal_Int32 i=0; i<m_nElementDepth; ++i, ++pFill)
				*pFill = '\t';
			m_xMasterWriter->ignorableWhitespace(::rtl::OUString(pWS, m_nElementDepth + 1));
			delete pWS;
		}

		++m_nElementDepth;
		m_xMasterWriter->startElement(aName, xAttribs);
		m_eLastAction = STARTELEMENT;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OLayoutRefiner::endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException)
	{
		--m_nElementDepth;
		if (CHARACTERS != m_eLastAction)
		{
			sal_Unicode* pWS = new sal_Unicode[m_nElementDepth + 1];
			sal_Unicode* pFill = pWS;
			*pFill = '\n'; ++pFill;
			for (sal_Int32 i=0; i<m_nElementDepth; ++i, ++pFill)
				*pFill = '\t';
			m_xMasterWriter->ignorableWhitespace(::rtl::OUString(pWS, m_nElementDepth + 1));
			delete pWS;
		}
		m_xMasterWriter->endElement(aName);
		m_eLastAction = ENDELEMENT;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OLayoutRefiner::characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException)
	{
		m_xMasterWriter->characters(aChars);
		m_eLastAction = CHARACTERS;
	}
#endif
#if defined(_REMOTE_PATH_TRANSLATION_) || defined(_ENCODE_USER_NAMES_)
	//==========================================================================
	//= OFakeDataRootPath
	//==========================================================================
	/** an object which can be used as IOpenObjectCallback, IDataRequestCallback or IDOMNodeDataProvider
		and fakes - on all read or write requests - the top level element written to or read from the
		belonging XDocumentHandler interface.
	*/
	typedef ::cppu::WeakImplHelper1< sax::XDocumentHandler > OFakeDataRootPath_Base;
	class OFakeDataRootPath
			:public IOpenObjectCallback
			,public IDOMNodeDataProvider
			,public OFakeDataRootPath_Base
	{
	protected:
		IDOMNodeDataProvider*				m_pMasterDataProvider;
		ORef< IOpenObjectCallback >			m_aMasterCallback;
		ORef< IDataRequestCallback >		m_aMasterCallback_Base;
		Reference< sax::XDocumentHandler >	m_xMasterHandler;	// same as got from m_aMasterCallback->getDataReader
																// (in read mode) or the writer to forward to
																// (in write mode)
		sal_Int32							m_nElementDepth;
		sal_Bool							m_bDidIt;			// just for debugging reasons
		::rtl::OUString						m_sFakedName;

	public:
		OFakeDataRootPath(const ORef< IOpenObjectCallback >& _rMasterCallback, const ::rtl::OUString& _rTopLevelElementFakedName);
		OFakeDataRootPath(const ORef< IDataRequestCallback >& _rMasterCallback, const ::rtl::OUString& _rTopLevelElementFakedName);
		OFakeDataRootPath(IDOMNodeDataProvider* _pMasterProvider, const ::rtl::OUString& _rTopLevelElementFakedName);

		// IOpenObjectCallback
		virtual	void	gotObjectId(const ::rtl::OUString& _rId);

		// IDataRequestCallback
		virtual	Reference< sax::XDocumentHandler > getDataReader();

		// IRequestCallback
		virtual		void acknowledged(sal_Int32 _nTransId);
		virtual		void failed(sal_Int32 _nErrorCode);
		virtual		void done(const StatusInfo& _rStatus);

		// IInterface
		virtual void SAL_CALL acquire(  ) throw () { OFakeDataRootPath_Base::acquire(); }
		virtual void SAL_CALL release(  ) throw () { OFakeDataRootPath_Base::release(); }

		// IDOMNodeDataProvider
		virtual void	writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException);
	};

	//--------------------------------------------------------------------------
	OFakeDataRootPath::OFakeDataRootPath(const ORef< IOpenObjectCallback >& _rMasterCallback, const ::rtl::OUString& _rTopLevelElementFakedName)
		:m_aMasterCallback_Base(_rMasterCallback.getBodyPtr())
		,m_aMasterCallback(_rMasterCallback)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
		,m_sFakedName(_rTopLevelElementFakedName)
		,m_pMasterDataProvider(NULL)
	{
		OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		if (m_sFakedName.getLength() && ('/' == m_sFakedName.getStr()[0]))
		{
			m_sFakedName = m_sFakedName.copy(1);
			OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		}
		OSL_ENSHURE(-1 == m_sFakedName.indexOf('/'), "OFakeDataRootPath::OFakeDataRootPath : invalid fake name (should not contain slashes) !");
	}

	//--------------------------------------------------------------------------
	OFakeDataRootPath::OFakeDataRootPath(const ORef< IDataRequestCallback >& _rMasterCallback, const ::rtl::OUString& _rTopLevelElementFakedName)
		:m_aMasterCallback_Base(_rMasterCallback)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
		,m_sFakedName(_rTopLevelElementFakedName)
		,m_pMasterDataProvider(NULL)
	{
		OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		if (m_sFakedName.getLength() && ('/' == m_sFakedName.getStr()[0]))
		{	// cut the leading slash
			m_sFakedName = m_sFakedName.copy(1);
			OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		}
		OSL_ENSHURE(-1 == m_sFakedName.indexOf('/'), "OFakeDataRootPath::OFakeDataRootPath : invalid fake name (should not contain slashes) !");
	}

	//--------------------------------------------------------------------------
	OFakeDataRootPath::OFakeDataRootPath(IDOMNodeDataProvider* _pMasterProvider, const ::rtl::OUString& _rTopLevelElementFakedName)
		:m_pMasterDataProvider(_pMasterProvider)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
		,m_sFakedName(_rTopLevelElementFakedName)
	{
		OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		if (m_sFakedName.getLength() && ('/' == m_sFakedName.getStr()[0]))
		{	// cut the leading slash
			m_sFakedName = m_sFakedName.copy(1);
			OSL_ENSHURE(m_sFakedName.getLength() > 0, "OFakeDataRootPath::OFakeDataRootPath : invalid fake name !");
		}
		OSL_ENSHURE(-1 == m_sFakedName.indexOf('/'), "OFakeDataRootPath::OFakeDataRootPath : invalid fake name (should not contain slashes) !");
	}

	//--------------------------------------------------------------------------
	void OFakeDataRootPath::acknowledged(sal_Int32 _nTransId)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeDataRootPath::acknowledged : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->acknowledged(_nTransId);
	}

	//--------------------------------------------------------------------------
	void OFakeDataRootPath::failed(sal_Int32 _nErrorCode)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeDataRootPath::failed : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->failed(_nErrorCode);
	}

	//--------------------------------------------------------------------------
	void OFakeDataRootPath::done(const StatusInfo& _rStatus)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeDataRootPath::done : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->done(_rStatus);
	}

	//--------------------------------------------------------------------------
	void OFakeDataRootPath::gotObjectId(const ::rtl::OUString& _rId)
	{
		OSL_ENSHURE(m_aMasterCallback.isValid(), "OFakeDataRootPath::gotObjectId : have no OpenObjectCallback !");
		if (m_aMasterCallback.isValid())
			m_aMasterCallback->gotObjectId(_rId); 
	}

	//--------------------------------------------------------------------------
	void OFakeDataRootPath::writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler)
	{
		OSL_ENSHURE(m_pMasterDataProvider, "OFakeDataRootPath::writeNodeData : not working as writer !");
		if (m_pMasterDataProvider && _rHandler.is())
		{
			OSL_ENSHURE(!m_xMasterHandler.is(), "OFakeDataRootPath::writeNodeData : already set an handler !");
			Reference< sax::XDocumentHandler > xOldHandler(m_xMasterHandler);
			m_xMasterHandler = _rHandler;
			m_pMasterDataProvider->writeNodeData(this);
			m_xMasterHandler = xOldHandler;
		}
	}

	//--------------------------------------------------------------------------
	Reference< sax::XDocumentHandler > OFakeDataRootPath::getDataReader()
	{
		m_xMasterHandler = m_aMasterCallback_Base->getDataReader();
		return this;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::startDocument() throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->startDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::endDocument() throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->endDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::startElement(const ::rtl::OUString& _rName, const Reference< sax::XAttributeList >& _rxAttribs ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
		{
			if (!m_nElementDepth)
			{	// it's the first element, we have to fake the name
				OSL_ENSHURE(!m_bDidIt, "OFakeDataRootPath::startElement : there should only be one top level element !");

				m_xMasterHandler->startElement(m_sFakedName, _rxAttribs);

				m_bDidIt = sal_True;
			}
			else
				m_xMasterHandler->startElement(_rName, _rxAttribs);
		}
		++m_nElementDepth;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::endElement(const ::rtl::OUString& _rName) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
		{
			if (1 == m_nElementDepth)
			{
				m_xMasterHandler->endElement(m_sFakedName);
			}
			else
				m_xMasterHandler->endElement(_rName);
		}
		--m_nElementDepth;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::characters(const ::rtl::OUString& _rChars) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->characters(_rChars);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::ignorableWhitespace(const ::rtl::OUString& _rWhitespaces) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->ignorableWhitespace(_rWhitespaces);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::processingInstruction(const ::rtl::OUString& _rTarget, const ::rtl::OUString& _rData ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->processingInstruction(_rTarget, _rData);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeDataRootPath::setDocumentLocator(const Reference< sax::XLocator >& _rxLocator ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->setDocumentLocator(_rxLocator);
	}

#endif

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------



	//==========================================================================
	//= OFakeValueConverter
	//==========================================================================
	/** an object which can be used as IOpenObjectCallback, IDataRequestCallback or IDOMNodeDataProvider
		and fakes - on all read or write requests

		all old Server elementname, valuenames attributenames to the new one
	*/

	typedef ::cppu::WeakImplHelper1< sax::XDocumentHandler > OFakeValueConverter_Base;
	class OFakeValueConverter
			:public IOpenObjectCallback
			,public IDOMNodeDataProvider
			,public OFakeValueConverter_Base
	{
	protected:
		IDOMNodeDataProvider*				m_pMasterDataProvider;
		ORef< IOpenObjectCallback >			m_aMasterCallback;
		ORef< IDataRequestCallback >		m_aMasterCallback_Base;
		Reference< sax::XDocumentHandler >	m_xMasterHandler;	// same as got from m_aMasterCallback->getDataReader
																// (in read mode) or the writer to forward to
																// (in write mode)
		sal_Int32							m_nElementDepth;
		sal_Bool							m_bDidIt;			// just for debugging reasons

		bool m_bConvertToNew;					 // true: convert to new values (use old server with new format)
												 // else: convert to old values (use new values with old server)
	public:
		OFakeValueConverter(const ORef< IOpenObjectCallback >& _rMasterCallback);
		OFakeValueConverter(const ORef< IDataRequestCallback >& _rMasterCallback);
		OFakeValueConverter(IDOMNodeDataProvider* _pMasterProvider);

		// IOpenObjectCallback
		virtual	void	gotObjectId(const ::rtl::OUString& _rId);

		// IDataRequestCallback
		virtual	Reference< sax::XDocumentHandler > getDataReader();

		// IRequestCallback
		virtual		void acknowledged(sal_Int32 _nTransId);
		virtual		void failed(sal_Int32 _nErrorCode);
		virtual		void done(const StatusInfo& _rStatus);

		// IInterface
		virtual void SAL_CALL acquire(  ) throw () { OFakeValueConverter_Base::acquire(); }
		virtual void SAL_CALL release(  ) throw () { OFakeValueConverter_Base::release(); }

		// IDOMNodeDataProvider
		virtual void	writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException);
	};

	//--------------------------------------------------------------------------
	OFakeValueConverter::OFakeValueConverter(const ORef< IOpenObjectCallback >& _rMasterCallback)
		:m_aMasterCallback_Base(_rMasterCallback.getBodyPtr())
		,m_aMasterCallback(_rMasterCallback)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
		,m_pMasterDataProvider(NULL)
	{
		// PRE: openNode, getNode
		m_bConvertToNew = true;
	}

	//--------------------------------------------------------------------------
	OFakeValueConverter::OFakeValueConverter(const ORef< IDataRequestCallback >& _rMasterCallback)
		:m_aMasterCallback_Base(_rMasterCallback)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
		,m_pMasterDataProvider(NULL)
	{
		// PRE: updateNode (read)
		m_bConvertToNew = true;
	}

	//--------------------------------------------------------------------------
	OFakeValueConverter::OFakeValueConverter(IDOMNodeDataProvider* _pMasterProvider)
		:m_pMasterDataProvider(_pMasterProvider)
		,m_nElementDepth(0)
		,m_bDidIt(sal_False)
	{
		// PRE: updateNode (write), addNode (write)
		m_bConvertToNew = false;				 // convert to old
	}

	//--------------------------------------------------------------------------
	void OFakeValueConverter::acknowledged(sal_Int32 _nTransId)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeValueConverter::acknowledged : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->acknowledged(_nTransId);
	}

	//--------------------------------------------------------------------------
	void OFakeValueConverter::failed(sal_Int32 _nErrorCode)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeValueConverter::failed : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->failed(_nErrorCode);
	}

	//--------------------------------------------------------------------------
	void OFakeValueConverter::done(const StatusInfo& _rStatus)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OFakeValueConverter::done : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->done(_rStatus);
	}

	//--------------------------------------------------------------------------
	void OFakeValueConverter::gotObjectId(const ::rtl::OUString& _rId)
	{
		OSL_ENSHURE(m_aMasterCallback.isValid(), "OFakeValueConverter::gotObjectId : have no OpenObjectCallback !");
		if (m_aMasterCallback.isValid())
			m_aMasterCallback->gotObjectId(_rId); 
	}

	//--------------------------------------------------------------------------
	void OFakeValueConverter::writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler)
	{
		OSL_ENSHURE(m_pMasterDataProvider, "OFakeValueConverter::writeNodeData : not working as writer !");
		if (m_pMasterDataProvider && _rHandler.is())
		{
			OSL_ENSHURE(!m_xMasterHandler.is(), "OFakeValueConverter::writeNodeData : already set an handler !");
			Reference< sax::XDocumentHandler > xOldHandler(m_xMasterHandler);
			m_xMasterHandler = _rHandler;
			m_pMasterDataProvider->writeNodeData(this);
			m_xMasterHandler = xOldHandler;
		}
	}

	//--------------------------------------------------------------------------
	Reference< sax::XDocumentHandler > OFakeValueConverter::getDataReader()
	{
		m_xMasterHandler = m_aMasterCallback_Base->getDataReader();
		return this;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::startDocument() throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->startDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::endDocument() throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->endDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::startElement(const ::rtl::OUString& _rName, const Reference< sax::XAttributeList >& _xAttrList ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
		{
			sal_Int16 nAttrCount = _xAttrList.is() ? _xAttrList->getLength() : 0;
			if (nAttrCount > 0)
			{
				// create a new AttributList
				AttributeListImpl *pList = new AttributeListImpl;
				Reference< sax::XAttributeList > rList( (sax::XAttributeList *) pList , UNO_QUERY );

				for( sal_Int16 i=0; i < nAttrCount; i++ )
				{
					OUString aParamName( _xAttrList->getNameByIndex( i ) );
					OUString aXMLType( _xAttrList->getTypeByIndex( i ) );
					OUString aParamValue( _xAttrList->getValueByIndex( i ) );
					
					
					pList->addAttribute( mapTo(aParamName, m_bConvertToNew),
										 aXMLType,
										 mapTo(aParamValue, m_bConvertToNew)); // write value to stream	
				}
				m_xMasterHandler->startElement(mapTo(_rName, m_bConvertToNew), rList);
			}
			else
			{
				m_xMasterHandler->startElement(mapTo(_rName, m_bConvertToNew), _xAttrList);
			}
		}
		++m_nElementDepth;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::endElement(const ::rtl::OUString& _rName) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->endElement(mapTo(_rName, m_bConvertToNew));
		--m_nElementDepth;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::characters(const ::rtl::OUString& _rChars) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->characters(_rChars);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::ignorableWhitespace(const ::rtl::OUString& _rWhitespaces) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->ignorableWhitespace(_rWhitespaces);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::processingInstruction(const ::rtl::OUString& _rTarget, const ::rtl::OUString& _rData ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->processingInstruction(_rTarget, _rData);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OFakeValueConverter::setDocumentLocator(const Reference< sax::XLocator >& _rxLocator ) throw(sax::SAXException, RuntimeException)
	{
		if (m_xMasterHandler.is())
			m_xMasterHandler->setDocumentLocator(_rxLocator);
	}






#ifdef _ENCODE_USER_NAMES_
	typedef ::cppu::WeakImplHelper1< sax::XDocumentHandler > OUserNameDecoder_Base;
	/** a class which decodes user names which are returned from the server when opening com.sun.star.UserProfile
		as toplevel node.
	*/
	class OUserNameDecoder
			:public OUserNameDecoder_Base
			,public IOpenObjectCallback
	{
	protected:
		Reference< sax::XDocumentHandler >	m_xMasterHandler;
		ORef< IOpenObjectCallback >			m_aMasterCallback;
		ORef< IDataRequestCallback >		m_aMasterCallback_Base;
		sal_Int32							m_nDepth;

	public:
		OUserNameDecoder(const ORef< IOpenObjectCallback >& _rMasterCallback);
		OUserNameDecoder(const ORef< IDataRequestCallback >& _rMasterCallback);

		// IOpenObjectCallback
		virtual	void	gotObjectId(const ::rtl::OUString& _rId);

		// IDataRequestCallback
		virtual	Reference< sax::XDocumentHandler > getDataReader();

		// IRequestCallback
		virtual		void acknowledged(sal_Int32 _nTransId);
		virtual		void failed(sal_Int32 _nErrorCode);
		virtual		void done(const StatusInfo& _rStatus);

		// IInterface
		virtual void SAL_CALL acquire(  ) throw () { OUserNameDecoder_Base::acquire(); }
		virtual void SAL_CALL release(  ) throw () { OUserNameDecoder_Base::release(); }

		// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException);
	};

	//--------------------------------------------------------------------------
	OUserNameDecoder::OUserNameDecoder(const ORef< IOpenObjectCallback >& _rMasterCallback)
		:m_aMasterCallback_Base(_rMasterCallback.getBodyPtr())
		,m_aMasterCallback(_rMasterCallback)
		,m_nDepth(NULL)
	{
	}

	//--------------------------------------------------------------------------
	OUserNameDecoder::OUserNameDecoder(const ORef< IDataRequestCallback >& _rMasterCallback)
		:m_aMasterCallback_Base(_rMasterCallback)
		,m_nDepth(NULL)
	{
	}

	//--------------------------------------------------------------------------
	void OUserNameDecoder::acknowledged(sal_Int32 _nTransId)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OUserNameDecoder::acknowledged : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->acknowledged(_nTransId);
	}

	//--------------------------------------------------------------------------
	void OUserNameDecoder::failed(sal_Int32 _nErrorCode)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OUserNameDecoder::failed : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->failed(_nErrorCode);
	}

	//--------------------------------------------------------------------------
	void OUserNameDecoder::done(const StatusInfo& _rStatus)
	{
		OSL_ENSHURE(m_aMasterCallback_Base.isValid(), "OUserNameDecoder::done : not working as a reader !");
		if (m_aMasterCallback_Base.isValid())
			m_aMasterCallback_Base->done(_rStatus);
	}

	//--------------------------------------------------------------------------
	void OUserNameDecoder::gotObjectId(const ::rtl::OUString& _rId)
	{
		OSL_ENSHURE(m_aMasterCallback.isValid(), "OUserNameDecoder::gotObjectId : have no OpenObjectCallback !");
		if (m_aMasterCallback.isValid())
			m_aMasterCallback->gotObjectId(_rId); 
	}

	//--------------------------------------------------------------------------
	Reference< sax::XDocumentHandler > OUserNameDecoder::getDataReader()
	{
		OSL_ENSHURE(!m_xMasterHandler.is(), "OUserNameDecoder::getDataReader : already called !");
		m_xMasterHandler = m_aMasterCallback_Base->getDataReader();
		return this;
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::startDocument(  ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::startDocument : no handler !");
		m_xMasterHandler->startDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::endDocument(  ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::endDocument : no handler !");
		m_xMasterHandler->endDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::startElement( const ::rtl::OUString& _rName, const Reference< sax::XAttributeList >& _rxAttribs ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::startElement : no handler !");
		++m_nDepth;
		if (2 == m_nDepth)
		{
			// level 2 nodes are user names
			bool bValidEncodedName(false);
			m_xMasterHandler->startElement(unnamed_encodename::decode(_rName, bValidEncodedName), _rxAttribs);
			OSL_ENSHURE(bValidEncodedName, "OUserNameDecoder::endElement : read a invalid name (could not decode) !");
		}
		else
			m_xMasterHandler->startElement(_rName, _rxAttribs);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::endElement( const ::rtl::OUString& _rName ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::endElement : no handler !");
		--m_nDepth;
		if (1 == m_nDepth)
		{
			// the user name ends
			bool bValidEncodedName(false);
			m_xMasterHandler->endElement(unnamed_encodename::decode(_rName, bValidEncodedName));
		}
		else
			m_xMasterHandler->endElement(_rName);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::characters : no handler !");
		m_xMasterHandler->characters(aChars);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::ignorableWhitespace : no handler !");
		m_xMasterHandler->ignorableWhitespace(aWhitespaces);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::processingInstruction : no handler !");
		m_xMasterHandler->processingInstruction(aTarget, aData);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OUserNameDecoder::setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OUserNameDecoder::setDocumentLocator : no handler !");
		m_xMasterHandler->setDocumentLocator(xLocator);
	}
#endif
#ifdef _ADMIN_WRITES_DEFAULT_TAGS_
	typedef ::cppu::WeakImplHelper1< sax::XDocumentHandler > OValueTagTranslator_Base;
	/** a class which acts as forwarder for a <type>IOpenObjectCallback</type> or <type>IDOMNodeDataProvider</type>
		and removes the value tags within leaf nodes
	*/
	class OValueTagTranslator
			:public OValueTagTranslator_Base
			,public IDOMNodeDataProvider
	{
	protected:
		Reference< sax::XDocumentHandler >	m_xMasterHandler;
		IDOMNodeDataProvider*				m_pMasterDataProvider;
		sal_Int32							m_nLeafDepth;			/// depth within an element recognized as leaf
		sal_Bool							m_bTranslating;			/** reliable when m_nLeafDepth > 0, which means we're
																		within a leaf and found a value tag we translated
																	*/

	public:
		OValueTagTranslator(IDOMNodeDataProvider* _pMasterWriter);

		// IDOMNodeDataProvider
		virtual void	writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler);

		// XDocumentHandler
		virtual void SAL_CALL startDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endDocument(  ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL startElement( const ::rtl::OUString& aName, const Reference< sax::XAttributeList >& xAttribs ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL endElement( const ::rtl::OUString& aName ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException);
		virtual void SAL_CALL setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException);
	};

	//--------------------------------------------------------------------------
	OValueTagTranslator::OValueTagTranslator(IDOMNodeDataProvider* _pMasterWriter)
		:m_nLeafDepth(0)
		,m_pMasterDataProvider(_pMasterWriter)
		,m_bTranslating(sal_False)
	{
	}

	//--------------------------------------------------------------------------
	void OValueTagTranslator::writeNodeData(const Reference< sax::XDocumentHandler >& _rHandler)
	{
		OSL_ENSHURE(m_pMasterDataProvider, "OValueTagTranslator::writeNodeData : not working as writer !");
		if (m_pMasterDataProvider && _rHandler.is())
		{
			OSL_ENSHURE(!m_xMasterHandler.is(), "OValueTagTranslator::writeNodeData : already set an handler !");
			Reference< sax::XDocumentHandler > xOldHandler(m_xMasterHandler);
			m_xMasterHandler = _rHandler;
			m_pMasterDataProvider->writeNodeData(this);
			m_xMasterHandler = xOldHandler;
		}
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::startDocument(  ) throw(sax::SAXException, RuntimeException)
	{
		m_xMasterHandler->startDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::endDocument(  ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::endDocument : no handler !");
		m_xMasterHandler->endDocument();
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::startElement( const ::rtl::OUString& _rName, const Reference< sax::XAttributeList >& _rxAttribs ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::startElement : no handler !");
		if (!m_nLeafDepth && _rxAttribs.is())
		{
			// if the element has an attribute "type", it's a leaf
			static const ::rtl::OUString sTypeAttrib = ::rtl::OUString::createFromAscii("type");
			static const ::rtl::OUString sTypeAttribAlternative = ::rtl::OUString::createFromAscii("Type");
			static const ::rtl::OUString sTypeAttribSetValue = ::rtl::OUString::createFromAscii("set");

			::rtl::OUString sElementValue = _rxAttribs->getValueByName(sTypeAttrib);
			if (!sElementValue.getLength())
				sElementValue = _rxAttribs->getValueByName(sTypeAttribAlternative);

			if (sElementValue.getLength() && !sElementValue.equalsIgnoreCase(sTypeAttribSetValue))
			{	// jupp ... we found a leaf
				m_nLeafDepth = 1;
			}
		}
		else if (m_nLeafDepth >= 1)
		{
			++m_nLeafDepth;

			if (2 == m_nLeafDepth)
			{
				static const ::rtl::OUString sValueTag = ::rtl::OUString::createFromAscii("value");
				static const ::rtl::OUString sDefaultValueTag = ::rtl::OUString::createFromAscii("defaultvalue");
				if (_rName.equalsIgnoreCase(sValueTag))
				{	// it's the value tag we want to translate
					m_xMasterHandler->startElement(sDefaultValueTag, _rxAttribs);
					m_bTranslating = sal_True;
					return;
				}
				m_bTranslating = sal_False;
			}
		}

		m_xMasterHandler->startElement(_rName, _rxAttribs);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::endElement( const ::rtl::OUString& _rName ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::endElement : no handler !");
		if (m_nLeafDepth)
		{	// we're within a leaf
			--m_nLeafDepth;
			if ((1 == m_nLeafDepth) && m_bTranslating)
			{	// the currently ending tag is the first one after the leaf tag, which means
				// it must be the value tag itself
				OSL_ENSHURE(_rName.equalsIgnoreCase(::rtl::OUString::createFromAscii("value")),
					"OValueTagTranslator::endElement : inconsistence !");
				static const ::rtl::OUString sDefaultValueTag = ::rtl::OUString::createFromAscii("defaultvalue");
				m_xMasterHandler->endElement(sDefaultValueTag);
				return;
			}
		}

		m_xMasterHandler->endElement(_rName);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::characters( const ::rtl::OUString& aChars ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::characters : no handler !");
		m_xMasterHandler->characters(aChars);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::ignorableWhitespace( const ::rtl::OUString& aWhitespaces ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::ignorableWhitespace : no handler !");
		if (0 == m_nLeafDepth)
			m_xMasterHandler->ignorableWhitespace(aWhitespaces);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::processingInstruction( const ::rtl::OUString& aTarget, const ::rtl::OUString& aData ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::processingInstruction : no handler !");
		m_xMasterHandler->processingInstruction(aTarget, aData);
	}

	//--------------------------------------------------------------------------
	void SAL_CALL OValueTagTranslator::setDocumentLocator( const Reference< sax::XLocator >& xLocator ) throw(sax::SAXException, RuntimeException)
	{
		OSL_ENSHURE(m_xMasterHandler.is(), "OValueTagTranslator::setDocumentLocator : no handler !");
		m_xMasterHandler->setDocumentLocator(xLocator);
	}
#endif


static const ::rtl::OUString sStringType(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("string")));
static const ::rtl::OUString sNodePathName(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("nodePath")));
static const ::rtl::OUString sParentNodePathName(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("parentNodePath")));
static const ::rtl::OUString sNodeName(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("node")));
static const ::rtl::OUString sUserName(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("userName")));
static const ::rtl::OUString sUpdateNameParam(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("changedNode")));
static const ::rtl::OUString sAddNameParam(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("nodeToAdd")));
static const ::rtl::OUString sIntegerType(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("int")));
static const ::rtl::OUString sGenericStringData(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("CDATA")));

//==========================================================================
//= OWaitForOpenSession
//==========================================================================
/** an class born for only one reason : be the callback for an openSession
	request on a remote config server, thus making it possible to make this
	request synchronous instead of asynchronous
*/
class OWaitForOpenSession : public IOpenObjectCallback
{
protected:
	oslInterlockedCount		m_refCount;

public:
	enum STATE { WAITING, ACKNOWLEDGED, FAILED, DONE };

protected:
	Mutex			m_aMutex;
	sal_Int32		m_nSessionId;		/// the id as got via the IOpenObjectCallback interface
	sal_Int32		m_nConnError;		/// the error code as got from <method>failed</method>
	STATE			m_eState;			/// the current state
	StatusInfo		m_aStatus;			/// the status as got in done, if this was ever called
	OCondition		m_aWaitCond;		/// used for waiting for the done call

public:
	OWaitForOpenSession() : m_nSessionId(-1),m_eState(WAITING) { m_aWaitCond.reset(); }

	sal_Bool	isFinished() { MutexGuard aG(m_aMutex); return (FAILED == m_eState) || (DONE == m_eState); }
	STATE		getState() { return m_eState; }
	sal_Int32	getSessionId() { return m_nSessionId; }
	sal_Int32	getConnError() { return m_nConnError; }
	StatusInfo	getStatus() { return m_aStatus; }

	sal_Bool	waitForResponse(const TimeValue* pTimeout = NULL)
	{
		return (ICondition::result_ok == m_aWaitCond.wait(pTimeout));
	}

	// IOpenObjectCallback
	virtual	void	gotObjectId(const ::rtl::OUString& _rId) { MutexGuard aG(m_aMutex); m_nSessionId = _rId.toInt32(); }

	// IDataRequestCallback
	virtual		Reference< sax::XDocumentHandler > getDataReader() { return NULL; }

	// IRequestCallback
	virtual		void acknowledged(sal_Int32 _nTransId) { MutexGuard aG(m_aMutex); m_eState = ACKNOWLEDGED; }
	virtual		void failed(sal_Int32 _nErrorCode) { MutexGuard aG(m_aMutex); m_eState = FAILED; m_aWaitCond.set(); }
	virtual		void done(const StatusInfo& _rStatus) { MutexGuard aG(m_aMutex); m_aStatus = _rStatus; m_eState = DONE; m_aWaitCond.set(); }

	// IInterface
    virtual void SAL_CALL acquire(  ) throw () { osl_incrementInterlockedCount(&m_refCount); }
    virtual void SAL_CALL release(  ) throw () { if (!osl_decrementInterlockedCount(&m_refCount)) delete this; }
};

//==========================================================================
//= OWaitForCloseSession
//==========================================================================
/** an class born for only one reason : be the callback for an closeSession
	request on a remote config server
*/
class OWaitForCloseSession : public IRequestCallback
{
protected:
	oslInterlockedCount		m_refCount;

public:
	enum STATE { WAITING, ACKNOWLEDGED, FAILED, DONE };

protected:
	Mutex			m_aMutex;
	STATE			m_eState;			/// the current state
	StatusInfo		m_aStatus;			/// the status as got in done, if this was ever called
	ORef< IRequestCallback >
					m_aMasterCallback;	/// in addition to our own handling we forward all calls to this master
	ORemoteSession*	m_pSession;			/// to be notified after the request is fullfilled

public:
	OWaitForCloseSession(ORemoteSession* m_pSession, const ORef< IRequestCallback >& _rMasterCB);

	sal_Bool	isFinished() { MutexGuard aG(m_aMutex); return (FAILED == m_eState) || (DONE == m_eState); }
	STATE		getState() { return m_eState; }
	StatusInfo	getStatus() { return m_aStatus; }

	// IRequestCallback
	virtual		void acknowledged(sal_Int32 _nTransId);
	virtual		void failed(sal_Int32 _nErrorCode);
	virtual		void done(const StatusInfo& _rStatus);

	// IInterface
    virtual void SAL_CALL acquire(  ) throw (::com::sun::star::uno::RuntimeException) { osl_incrementInterlockedCount(&m_refCount); }
    virtual void SAL_CALL release(  ) throw (::com::sun::star::uno::RuntimeException) { if (!osl_decrementInterlockedCount(&m_refCount)) delete this; }
};

//--------------------------------------------------------------------------
OWaitForCloseSession::OWaitForCloseSession(ORemoteSession* _pSession, const ORef< IRequestCallback >& _rMasterCB)
	:m_pSession(_pSession)
	,m_aMasterCallback(_rMasterCB)
	,m_eState(WAITING)
{
}

//--------------------------------------------------------------------------
void OWaitForCloseSession::acknowledged(sal_Int32 _nTransId)
{
	MutexGuard aG(m_aMutex);
	m_eState = ACKNOWLEDGED;
	if (m_aMasterCallback.isValid())
		m_aMasterCallback->acknowledged(_nTransId);
}

//--------------------------------------------------------------------------
void OWaitForCloseSession::failed(sal_Int32 _nErrorCode)
{
	MutexGuard aG(m_aMutex);
	m_eState = FAILED;
	if (m_aMasterCallback.isValid())
		m_aMasterCallback->failed(_nErrorCode);
}

//--------------------------------------------------------------------------
void OWaitForCloseSession::done(const StatusInfo& _rStatus)
{
	MutexGuard aG(m_aMutex);
	m_aStatus = _rStatus;
	m_eState = DONE;
	if (m_aMasterCallback.isValid())
		m_aMasterCallback->done(_rStatus);

	// notify the session, if the close operation was successfull
	if (_rStatus.nCode == 0)
		m_pSession->implCloseSuccessfull();
}

//==========================================================================
//= ORemoteSession
//==========================================================================
#define ENTER()	\
	::osl::MutexGuard aGuard(m_aMutex);	\
	m_eSessionError = E_None;
	
#define ENTER_FULL_CHECK(methodname, handler)	\
	::osl::MutexGuard aGuard(m_aMutex);	\
	m_eSessionError = E_None;	\
	if (!isConnected())	\
	{	\
		OSL_ENSHURE(sal_False, "ORemoteSession::"#methodname" : not connected !");	\
		CFG_TRACE_ERROR("remote session: calling %s while not beeing connected", #methodname);	\
		if (handler.isValid())	\
			handler->failed(E_NotConnected);	\
		m_eSessionError = E_NotConnected;	\
		return;	\
	}	\
	if (!isOpen())	\
	{	\
		OSL_ENSHURE(sal_False, "ORemoteSession::"#methodname" : not opened !");	\
		CFG_TRACE_ERROR("remote session: calling %s while not beeing open", #methodname);	\
		if (handler.isValid())	\
			handler->failed(E_NotOpen);	\
		m_eSessionError = E_NotOpen;	\
		return;	\
	}

#define CATCH_HANDLE_EXCEPTIONS()	\
	catch (sax::SAXException&)	\
	{	\
		m_eSessionError = E_WrongFormat;	\
		return;	\
	}	\
	catch (RuntimeException&)	\
	{	\
		m_eSessionError = E_Unknown;	\
		return;	\
	}
	
#define CATCH_HANDLE_EXCEPTIONS_RET(retval)	\
	catch (sax::SAXException& e)	\
	{	\
		CFG_TRACE_ERROR("remote session: caught a SAX exception, message: %s", OUSTRING2ASCII(e.Message));	\
		m_eSessionError = E_WrongFormat;	\
		return retval;	\
	}	\
	catch (RuntimeException& e)	\
	{	\
		CFG_TRACE_ERROR("remote session: caught a runtime exception, message: %s", OUSTRING2ASCII(e.Message));	\
		m_eSessionError = E_Unknown;	\
		return retval;	\
	}
	
//--------------------------------------------------------------------------
ORemoteSession::ORemoteSession(const Reference< XMultiServiceFactory >& _rxServiceProvider)
	:m_nSessionId(-1)
	,m_eConnectionError((sal_Int32)ISocketTypes::E_None)
	,m_eSessionError(E_None)
	,m_pServerConnection(NULL)
	,m_pLastUsedTransId(NULL)
	,m_pInterpreter(NULL)
	,m_pTimeout(NULL)
{
	// initialize the (client side) transaction id
	const sal_Unicode aInitialId[] = { 'R', '0', '0', '0', '0' };
	rtl_uString_newFromStr_WithLength(&m_pLastUsedTransId, aInitialId, sizeof(aInitialId) / sizeof(aInitialId[0]));
		// automatically acquired once

	// create the writer and the parser we want to use
	m_xWriter = Reference< sax::XDocumentHandler >(_rxServiceProvider->createInstance(
			::rtl::OUString::createFromAscii("com.sun.star.xml.sax.Writer")),
			UNO_QUERY);

	m_xReader = Reference< sax::XParser >(_rxServiceProvider->createInstance(
			::rtl::OUString::createFromAscii("com.sun.star.xml.sax.Parser")),
			UNO_QUERY);

	// check them for usability
	m_xWriterSource = Reference< XActiveDataSource >(m_xWriter, UNO_QUERY);
	if (!m_xWriterSource.is())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::ORemoteSession : no or invalid SAX XML Writer !");
		m_eSessionError = E_Invalid;
		return;
	}

	if (!m_xReader.is())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::ORemoteSession : no or invalid SAX XML Parser !");
		m_eSessionError = E_Invalid;
		return;
	}

//#ifdef DBG_UTIL
//	m_xWriter = new OLayoutRefiner(m_xWriter);
//#endif
}

//--------------------------------------------------------------------------
sal_Bool ORemoteSession::connectToPortal(const ::vos::ORef< ::daemons::IPortalConnector >& _rConnector,
										 const ::rtl::OUString& _rServer,
										 sal_Int32 _nPort,
										 const ::rtl::OUString& _rUser,
										 const ::rtl::OUString& _rPassword,
										 const TimeValue* _pTimeout)
{
	ENTER();

	CFG_TRACE_INFO("remote session: trying to open a connection via PortalConnect");

	if (!m_xWriterSource.is() || !m_xReader.is())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::connectToPortal : have no XML helper components (parser/writer) !");
		m_eSessionError = E_Invalid;
		return sal_False;
	}

	if (!_rConnector.isValid())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::connectToPortal : invalid connector !");
		m_eSessionError = E_Invalid;
		return sal_False;
	}

	::vos::ORef< ::daemons::IConnection > aConnection;
	::rtl::OUString sService(RTL_CONSTASCII_USTRINGPARAM("configuration"));
	::daemons::RC eConnResult(::daemons::E_None);
	::rtl::OUString sServer;
	if (_rServer.getLength())
	{
		sServer = _rServer;
		sServer += ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(":"));
		sServer += ::rtl::OUString::valueOf(_nPort);
		eConnResult = _rConnector->connectToService(_rUser, _rPassword, sServer, sService, aConnection);
	}
	else
	{
		::rtl::OUString sUser;			// no user
		::rtl::ByteSequence aTicket;	// no ticket	-> together this means use the user currently logged on on the
										//					portal running on the local machine
		eConnResult = _rConnector->connectToService(sUser, aTicket, sServer, sService, aConnection);
	}

	if (::daemons::E_None != eConnResult)
	{
		CFG_TRACE_ERROR_NI("remote session: connectToService failed");
		OSL_ENSHURE(sal_False, "ORemoteSession::connectToPortal : connection refused !");
		m_eSessionError = E_ConnectionError;
		m_eConnectionError = (sal_Int32)eConnResult;
		return sal_False;
	}

	if (!aConnection.isValid())
	{
		CFG_TRACE_ERROR_NI("remote session: got an invalid connection");
		OSL_ENSHURE(sal_False, "ORemoteSession::connectToPortal : invalid IConnection !");
		m_eSessionError = E_Invalid;
		return sal_False;
	}

	// a wrapper for the output to the socket stream
	CFG_TRACE_INFO_NI("remote session: creating the output stream wrapper");
	m_xOutputStream = new OEnvelopeOutputStream<OPortalOutputStream, ::daemons::IConnection>(aConnection.getBodyPtr());

	// the interpreter for the parsed xml stream
	CFG_TRACE_INFO_NI("remote session: creating the response redirector");
	m_pInterpreter = new OResponseRedirector();
	m_pInterpreter->acquire();
	m_xReader->setDocumentHandler(m_pInterpreter);

	// start an reader thread for the socket stream
	CFG_TRACE_INFO_NI("remote session: creating the input stream wrapper and the receive thread");
	m_pReaderThread = new OReceiveThread(new OEnvelopeInputStream<OPortalInputStream, ::daemons::IConnection>(aConnection.getBodyPtr()), m_xReader);
	m_pReaderThread->create();

	if (_pTimeout)
		m_pTimeout = new TimeValue(*_pTimeout);
	else
	{
		m_pTimeout = new TimeValue;
		m_pTimeout->Seconds = 30;
		m_pTimeout->Nanosec = 0;
	}

#if defined(_IMPLICIT_USERPROFILE_USER_NAME_) || defined(_ADMIN_WRITES_DEFAULT_TAGS_)
	m_sCurrentUser = _rUser;
	m_sCurrentUser += ConfigurationName::stringDelimiter();
#endif

	// now we have the connection ...
	CFG_TRACE_INFO_NI("remote session: all fine, have the portal connection");
	m_nSessionId = 1;
	return sal_True;
}

//--------------------------------------------------------------------------
sal_Bool ORemoteSession::connect(const ::rtl::OUString& _rDottedAddress, sal_Int32 _nPort, const TimeValue* _pTimeout)
{
	CFG_TRACE_INFO("remote session: trying to connect to server %s, port %i", OUSTRING2ASCII(_rDottedAddress), _nPort);

	ENTER();

	if (!m_xWriterSource.is() || !m_xReader.is())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::connect : have no XML helper components (parser/writer) !");
		m_eSessionError = E_Invalid;
		return sal_False;
	}

	// create the socket for the basic connection to the registry server
	m_pServerConnection = new OConnectorSocket;
	m_pServerConnection->create(ISocketTypes::TType_Stream, ISocketTypes::TFamily_Inet, ISocketTypes::TProtocol_Ip);
	if (!m_pServerConnection->isValid())
	{
		CFG_TRACE_INFO("remote session: no socket connection available");

		m_eConnectionError = (sal_Int32)m_pServerConnection->getError();
		m_eSessionError = E_ConnectionError;
		delete m_pServerConnection;
		m_pServerConnection = NULL;
		return sal_False;
	}

	m_eConnectionError = (sal_Int32)ISocketTypes::E_None;

	// collect connection information
	OInetSocketAddr aAddress(_rDottedAddress, _nPort);

	// connect to the server
	ISocketTypes::TResult eConnectResult = m_pServerConnection->connect(aAddress, _pTimeout);
	switch (eConnectResult)
	{
		case ISocketTypes::TResult_Error:
		{
			CFG_TRACE_INFO("remote session: a generic error occured");
			m_eConnectionError = (sal_Int32)m_pServerConnection->getError();
		}
		break;
		case ISocketTypes::TResult_TimedOut:
			{
			CFG_TRACE_INFO("remote session: a timeout occured");
			m_eConnectionError = (sal_Int32)ISocketTypes::E_TimedOut;
		}
		break;
		case ISocketTypes::TResult_Interrupted:
		{
			CFG_TRACE_INFO("remote session: the request was interrupted");
			m_eConnectionError = (sal_Int32)ISocketTypes::E_ConnAborted;
		}
		break;
		case ISocketTypes::TResult_InProgress:
		{
			OSL_ENSHURE(sal_False, "ORemoteSession::connect : TResult_InProgress while connecting should never happen, me thinks !");
			m_eConnectionError = (sal_Int32)ISocketTypes::E_InProgress;
		}
		break;
	}

	if ((sal_Int32)ISocketTypes::E_None != m_eConnectionError)
	{
		CFG_TRACE_ERROR("remote session: could not connect ...");
		m_eSessionError = E_ConnectionError;
		delete m_pServerConnection;
		m_pServerConnection = NULL;
		return sal_False;
	}

	CFG_TRACE_INFO_NI("remote session: all fine, have the socket");
	// a wrapper for the output to the socket stream
	m_xOutputStream = new OEnvelopeOutputStream<OSocketOutputStream, ::vos::OConnectorSocket>(m_pServerConnection);

	// the interpreter for the parsed xml stream
	m_pInterpreter = new OResponseRedirector();
	m_pInterpreter->acquire();
	m_xReader->setDocumentHandler(m_pInterpreter);

	// start an reader thread for the socket stream
	m_pReaderThread = new OReceiveThread(new OEnvelopeInputStream<OSocketInputStream, ::vos::OConnectorSocket>(m_pServerConnection), m_xReader);
	m_pReaderThread->create();

	if (_pTimeout)
		m_pTimeout = new TimeValue(*_pTimeout);

	// now we have the connection ...
	return sal_True;
}

//--------------------------------------------------------------------------
void ORemoteSession::implDisconnect()
{
	CFG_TRACE_INFO("remote session: disconnecting");
	try
	{
		m_xWriter->endDocument();
			// see the according startDocument call for a comment on this
	}
	catch (sax::SAXException&)
	{
	}

	if (m_pReaderThread)
	{
		// kill the reader thread
		m_pReaderThread->terminateBlocking();
			// will free all resources and terminate the thread, returnes when the thread is really finished.
			// the thread object will be deleted upon return
		m_pReaderThread = NULL;
	}

	if (m_pInterpreter)
	{
		m_pInterpreter->release();
		m_pInterpreter = NULL;
	}

	if (m_xOutputStream.is())
	{
		Reference< XCancellable > xCancel(m_xOutputStream, UNO_QUERY);
		OSL_ENSHURE(xCancel.is(), "ORemoteSession::implDisconnect : invalid output stream !");
		if (xCancel.is())
			xCancel->cancel();
			// if the stream would be a simple SocketOutputStream instead of an EnvelopeOutputStream,
			// we would have to do an closeOutput
		m_xOutputStream = NULL;
	}

	delete m_pTimeout;
	m_pTimeout = NULL;

	// kill the socket
	// (do this after killing the thread and the output stream, as they may access the socket)
	if (m_pServerConnection)
	{	// (only if not working as portal session)
		m_pServerConnection->close();
		delete m_pServerConnection;
		m_pServerConnection = NULL;
	}
}

//--------------------------------------------------------------------------
ORemoteSession::~ORemoteSession()
{
	{
		::osl::MutexGuard aGuard(m_aMutex);

		// close if necessary
		if (isOpen())
			kill();

		// disconnect if necessary
		if (isConnected())
			implDisconnect();

		// kill the transaction id string
		rtl_uString_release(m_pLastUsedTransId);

		// TODO : think about real thread safety of this destructor
	}
	delete m_pTimeout;
}

//--------------------------------------------------------------------------
void ORemoteSession::openNode(const ::rtl::OUString& _rNodeAccessor, sal_Int32 _nLevel, const ::vos::ORef< IOpenObjectCallback >& _rHandler)
{
	ENTER_FULL_CHECK(openNode, _rHandler);

	// convert org.openoffice. to com.sun.star.
	::rtl::OUString rNodeAccessor = changeToComSunStarPath(_rNodeAccessor);

	OSL_ENSHURE(_nLevel >= 0, "ORemoteSession::openNode : invalid level count !");
	OSL_ENSHURE(rNodeAccessor.getLength(), "ORemoteSession::openNode : invalid node path !");

	::vos::ORef< IOpenObjectCallback > aRealHandler(_rHandler);

	// split into path and user
	::rtl::OUString	sNodePath, sUser;
	sal_Bool bHaveUserOverride = splitNodeAccessor(rNodeAccessor, sNodePath, sUser);
	if (bHaveUserOverride)
		CFG_TRACE_INFO_NI("remote session: opening a node (%s) for user %s", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(sUser));
	else
		CFG_TRACE_INFO_NI("remote session: opening the node %s", OUSTRING2ASCII(sNodePath));


	// start the envelope
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("openNode"), bHaveUserOverride ? 3 : 2);

	// do some hacks ...
#ifdef _REMOTE_PATH_TRANSLATION_
	::rtl::OUString sUntranslated(sNodePath);
	translateNodePath(sNodePath, CLIENT_SIDE, READ);

	if (aRealHandler.isValid())
	{
		sal_Int32 nSeparator = sUntranslated.lastIndexOf('/');
		if (sUntranslated.getLength() - 1 == nSeparator)
			nSeparator = sUntranslated.lastIndexOf('/', sUntranslated.getLength() - 1);

		if (nSeparator <= 0)	// no '/' or just the very root
			// the client side node path has depth 1, so we have to fake the name of the top level element the
			// server will return
			aRealHandler.bind(new OFakeDataRootPath(aRealHandler, rNodeAccessor));
	}
#endif
	// for debugging, wait until break, set next statement
	// while (1);
	// volatile int dummy = 0;

	if (aRealHandler.isValid())
		//! Converter
		aRealHandler.bind(new OFakeValueConverter(aRealHandler));

#ifdef _ENCODE_USER_NAMES_
	if (aRealHandler.isValid())
		aRealHandler.bind(new OUserNameDecoder(aRealHandler));
#endif

	if (aRealHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, aRealHandler);
	writeStringParameter(sStringType, sNodePathName, sNodePath);

	writeStringParameter(sIntegerType, ::rtl::OUString::createFromAscii("numLevels"), ::rtl::OUString::valueOf(_nLevel));

	if (bHaveUserOverride)
		writeStringParameter(sStringType, sUserName, USERNAME_ENCODE(sUser));

	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::closeNode(const ::rtl::OUString& _rNodeId, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	CFG_TRACE_INFO("remote session: closing node with id %s", OUSTRING2ASCII(_rNodeId));
	ENTER_FULL_CHECK(closeNode, _rHandler);

	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("closeNode"), 1);

	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);
	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("nodeId"), _rNodeId);
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::getNode(const ::rtl::OUString& _rNodeAccessor, const ::vos::ORef< IOpenObjectCallback >& _rHandler)
{
	ENTER_FULL_CHECK(getNode, _rHandler);

	// convert org.openoffice. to com.sun.star.
	::rtl::OUString rNodeAccessor = changeToComSunStarPath(_rNodeAccessor);

	::vos::ORef< IOpenObjectCallback > aRealHandler(_rHandler);

	// split into path and user
	::rtl::OUString	sNodePath, sUser;
	sal_Bool bHaveUserOverride = splitNodeAccessor(rNodeAccessor, sNodePath, sUser);
	if (bHaveUserOverride)
		CFG_TRACE_INFO_NI("remote session: getting a node (%s) for user %s", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(sUser));
	else
		CFG_TRACE_INFO_NI("remote session: getting the node %s", OUSTRING2ASCII(sNodePath));

	// open the envelope
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("getNode"), bHaveUserOverride ? 2 : 1);

	// do some hacks
#ifdef _REMOTE_PATH_TRANSLATION_
	::rtl::OUString sUntranslated(sNodePath);
	translateNodePath(sNodePath, CLIENT_SIDE, READ);

	if (aRealHandler.isValid())
	{
		sal_Int32 nSeparator = sUntranslated.lastIndexOf('/');
		if (sUntranslated.getLength() - 1 == nSeparator)
			nSeparator = sUntranslated.lastIndexOf('/', sUntranslated.getLength() - 1);

		ORef< IOpenObjectCallback > aRealHandler(aRealHandler);
		if (nSeparator <= 0)	// no '/' or just the very root
			// the client side node path has depth 1, so we have to fake the name of the top level element the
			// server will return
			aRealHandler.bind(new OFakeDataRootPath(aRealHandler, rNodeAccessor));
	}
#endif
	if (aRealHandler.isValid())
		//! Converter
		aRealHandler.bind(new OFakeValueConverter(aRealHandler));
	
	if (aRealHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, aRealHandler);
	writeStringParameter(sStringType, sNodePathName, sNodePath);
	if (bHaveUserOverride)
		writeStringParameter(sIntegerType, sUserName, USERNAME_ENCODE(sUser));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::updateNode(const ::rtl::OUString& _rNodeId, const ::rtl::OUString& _rNodeAccessor,
		IDOMNodeDataProvider* _pNodeWriter, const ::vos::ORef< IDataRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(updateNode, _rHandler);

	// convert org.openoffice. to com.sun.star.
	::rtl::OUString rNodeAccessor = changeToComSunStarPath(_rNodeAccessor);

	OSL_ENSHURE(_pNodeWriter != NULL, "ORemoteSession::updateNode : invalid data provider !");

	Reference< sax::XDocumentHandler > xAutoFakeObjectDelete;

	// split into path and user
	::rtl::OUString	sNodePath, sUser;
	sal_Bool bHaveUserOverride = splitNodeAccessor(rNodeAccessor, sNodePath, sUser);
	if (bHaveUserOverride)
		CFG_TRACE_INFO_NI("remote session: updating a node (%s) for user %s", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(sUser));
	else
		CFG_TRACE_INFO_NI("remote session: updating the node %s", OUSTRING2ASCII(sNodePath));

#ifdef _ADMIN_WRITES_DEFAULT_TAGS_
	::rtl::OUString sModuleName = *ConfigurationName(sNodePath).begin();
	OSL_ENSHURE(sModuleName.getLength(), "ORemoteSession::updateNode : invalid module name !");
#endif

	::vos::ORef< IDataRequestCallback > aRealHandler(_rHandler);
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("updateNode"), bHaveUserOverride ? 4 : 3);

#ifdef _REMOTE_PATH_TRANSLATION_
	::rtl::OUString sUntranslated(sNodePath);
	// perhaps we have to fake the root of the data data the server may return (on an unsuccessfull update)
	translateNodePath(sNodePath, CLIENT_SIDE, WRITE);

	// if the orginal (untranslated path) contains only one level, we have to fake the top level elements which are
	// transported through the XDocumentHandler interfaces
	sal_Bool bOriginalPathOneLevel = sal_False;
	sal_Int32 nSeparator = sUntranslated.lastIndexOf('/');
	if (sUntranslated.getLength() - 1 == nSeparator)
		nSeparator = sUntranslated.lastIndexOf('/', sUntranslated.getLength() - 1);
	bOriginalPathOneLevel = (nSeparator <= 0);	// no '/' or just the very root

	if (aRealHandler.isValid())
		if (bOriginalPathOneLevel)
		{
			CFG_TRACE_INFO("remote session: adding a translator for the top level element of the may-be-returned tree");

			aRealHandler = new OFakeDataRootPath(aRealHandler, rNodeAccessor);

		}
#endif
	//! convert old (vaue) to new (cfg:value)
	if (aRealHandler.isValid())
	 	aRealHandler.bind(new OFakeValueConverter(aRealHandler));

	if (aRealHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, aRealHandler);

	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("nodeId"), _rNodeId);
	writeStringParameter(sStringType, sNodePathName, sNodePath);

#ifdef _ADMIN_WRITES_DEFAULT_TAGS_
	// when writing as admin
	if (_pNodeWriter && (m_sCurrentUser.equalsIgnoreCase(s_sAdministrator)))
		// and not writing for a foreign user
		if (!bHaveUserOverride)
			// and not writing into a user profile
			if (sModuleName != s_sUserProfileClientAccess)
				// translate value tags into defaultvalue tags
				_pNodeWriter = new OValueTagTranslator(_pNodeWriter);
#endif

#ifdef _REMOTE_PATH_TRANSLATION_
	// the same (root element name) fake as above, this time for the root element the writer is going to write
	if (_pNodeWriter)
		if (bOriginalPathOneLevel)
		{
			CFG_TRACE_INFO("remote session: adding a translator for the top level element of the to-be-written tree");
			// in write mode, the new element the writer should use is the last element of the translated path
			ConfigurationName aTranslated(sNodePath);
			OFakeDataRootPath* pFakeWriter = new OFakeDataRootPath(_pNodeWriter, aTranslated.localName());
// #error
			xAutoFakeObjectDelete = pFakeWriter;
			_pNodeWriter = pFakeWriter;
		}

#endif
	//! convert new to old
	if (_pNodeWriter)
		_pNodeWriter = new OFakeValueConverter(_pNodeWriter);

	if (_pNodeWriter)
		writeNodeParameter(_pNodeWriter, sUpdateNameParam);
	if (bHaveUserOverride)
		writeStringParameter(sIntegerType, sUserName, USERNAME_ENCODE(sUser));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::addNode(const ::rtl::OUString& _rNodeId, const ::rtl::OUString& _rNodeAccessor, IDOMNodeDataProvider* _pNodeWriter, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(addNode, _rHandler);

	// convert org.openoffice. to com.sun.star.
	::rtl::OUString rNodeAccessor = changeToComSunStarPath(_rNodeAccessor);

	OSL_ENSHURE(rNodeAccessor.indexOf(getUserAdminAccessor()) < 0,
				"Adding a user requires an 'addUser', not a addNode");

	// split into path and user
	::rtl::OUString	sNodePath, sUser;
	sal_Bool bHaveUserOverride = splitNodeAccessor(rNodeAccessor, sNodePath, sUser);
	if (bHaveUserOverride)
		CFG_TRACE_INFO_NI("remote session: adding a node (%s) for user %s (node id used: %s)", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(sUser), OUSTRING2ASCII(_rNodeId));
	else
		CFG_TRACE_INFO_NI("remote session: adding the node %s (node id used: %s)", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(_rNodeId));

#ifdef _ADMIN_WRITES_DEFAULT_TAGS_
	::rtl::OUString sModuleName = *ConfigurationName(sNodePath).begin();
	OSL_ENSHURE(sModuleName.getLength(), "ORemoteSession::addNode : invalid module name !");
#endif

#ifdef _REMOTE_PATH_TRANSLATION_
	translateNodePath(sNodePath, CLIENT_SIDE, WRITE);
#endif

	OSL_ENSHURE(_pNodeWriter != NULL, "ORemoteSession::addNode : invalid data provider !");

	::rtl::OUString sClientId;
	sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("addNode"), bHaveUserOverride ? 4 : 3);

	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);

	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("nodeId"), _rNodeId);
	writeStringParameter(sStringType, sParentNodePathName, sNodePath);

	if (_pNodeWriter)
	{
#ifdef _ADMIN_WRITES_DEFAULT_TAGS_
	// when writing as admin
	if (_pNodeWriter && (m_sCurrentUser.equalsIgnoreCase(s_sAdministrator)))
		// and not writing for a foreign user
		if (!bHaveUserOverride)
			// and not writing into a user profile
			if (sModuleName != s_sUserProfileClientAccess)
				// translate value tags into defaultvalue tags
				_pNodeWriter = new OValueTagTranslator(_pNodeWriter);
#endif

	//! convert new to old
	if (_pNodeWriter)
		_pNodeWriter = new OFakeValueConverter(_pNodeWriter);

#ifdef _NO_ADDNODE_REDUNDANCE_
		::vos::ORef< OTreeRootTagKiller > xRedundanceKiller = new OTreeRootTagKiller(_pNodeWriter, OUString());
		writeNodeParameter(xRedundanceKiller.getBodyPtr(), sAddNameParam);
#else
		writeNodeParameter(_pNodeWriter, sAddNameParam);
#endif
	}

	if (bHaveUserOverride)
		writeStringParameter(sStringType, sUserName, USERNAME_ENCODE(sUser));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::addUser(const ::rtl::OUString& _rUser, IDOMNodeDataProvider* _pNodeWriter, const ::vos::ORef< IRequestCallback >& _rHandler, const ::rtl::OUString& _rNodeId)
{
	ENTER_FULL_CHECK(addUser, _rHandler);

	// special path
	::rtl::OUString	sNodePath(RTL_CONSTASCII_USTRINGPARAM("Root/UserProfile"));
	if (false)
	{
		sNodePath = ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("org.openoffice.UserProfile"));
	}

#ifdef _REMOTE_PATH_TRANSLATION_
//	translateNodePath(sNodePath, CLIENT_SIDE, WRITE);
#endif

	OSL_ENSHURE(_pNodeWriter != NULL, "ORemoteSession::addUser : invalid data provider !");
	
	bool bHaveNodeId = _rNodeId.getLength() != 0;

	::rtl::OUString sClientId;

	sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("addUser"), bHaveNodeId ? 4 : 3);

	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);

	if (bHaveNodeId)
		writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("nodeId"), _rNodeId);
	writeStringParameter(sStringType, sUserName, USERNAME_ENCODE(_rUser));
	writeStringParameter(sStringType, sParentNodePathName, sNodePath);

	Reference< sax::XDocumentHandler > xFakeObjectAutoDelete;

	if (_pNodeWriter)
	{
#ifdef _NO_ADDNODE_REDUNDANCE_
		::vos::ORef< OTreeRootTagKiller > xRedundanceKiller = new OTreeRootTagKiller(_pNodeWriter, OUString());
		_pNodeWriter = xRedundanceKiller.getBodyPtr();
#endif

#ifdef _ENCODE_USER_NAMES_
		// the first element of the to-be-written stream is the user name, which has to be encoded
		::vos::ORef< OFakeDataRootPath > xFakeUserName = new OFakeDataRootPath(_pNodeWriter, USERNAME_ENCODE(_rUser));
		_pNodeWriter = xFakeUserName.getBodyPtr();
#endif

		//! Converter new to old
		if (_pNodeWriter)
			_pNodeWriter = new OFakeValueConverter(_pNodeWriter);

		writeNodeParameter(_pNodeWriter, sAddNameParam);
	}

	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::deleteNode(const ::rtl::OUString& _rNodeId, const ::rtl::OUString& _rNodeAccessor, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(deleteNode, _rHandler);

	// convert org.openoffice. to com.sun.star.
	::rtl::OUString rNodeAccessor = changeToComSunStarPath(_rNodeAccessor);

	// split into path and user
	::rtl::OUString	sNodePath, sUser;
	sal_Bool bHaveUserOverride = splitNodeAccessor(rNodeAccessor, sNodePath, sUser);
	if (bHaveUserOverride)
		CFG_TRACE_INFO_NI("remote session: deleting a node (%s) for user %s (node id used: %s)", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(sUser), OUSTRING2ASCII(_rNodeId));
	else
		CFG_TRACE_INFO_NI("remote session: deleting the node %s (node id used: %s)", OUSTRING2ASCII(sNodePath), OUSTRING2ASCII(_rNodeId));

#ifdef _REMOTE_PATH_TRANSLATION_
	translateNodePath(sNodePath, CLIENT_SIDE, WRITE);
#endif

	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("deleteNode"), bHaveUserOverride ? 3 : 2);

	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);
	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("nodeId"), _rNodeId);
	writeStringParameter(sStringType, sNodePathName, sNodePath);
	if (bHaveUserOverride)
		writeStringParameter(sIntegerType, sUserName, USERNAME_ENCODE(sUser));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
::rtl::OUString ORemoteSession::openEnvelopedRequest(const ::rtl::OUString& _rRequestName, sal_Int32 _nParamCount)
{
	// no mutex guarding, this is a protected method which has to be called from within guarded methods
	// only

	OSL_ENSHURE(m_xWriter.is(), "ORemoteSession::openEnvelopedRequest : no writer !");

	// TODO : string optimizations : either some central place to store the ascii versions, or even hold
	// the unicode versions in a central place

	::rtl::OUString sRequest(::rtl::OUString::createFromAscii("request"));
	::rtl::OUString sTransaction(::rtl::OUString::createFromAscii("transaction"));
	::rtl::OUString sEmptyString;

	// generate a new id
	::rtl::OUString sClientId;
	nextRequestTransId(sClientId);

	// attribute container
	AttributeListImpl* pAttributes = new AttributeListImpl;
	Reference< sax::XAttributeList > xAttribs = pAttributes;

	try
	{
		// propagate the output stream to the XML generator
		m_xWriterSource->setOutputStream(m_xOutputStream);
		m_xWriter->startDocument();

		// <envelope>
		m_xWriter->startElement(::rtl::OUString::createFromAscii("envelope"), xAttribs);

		// <header>
		m_xWriter->startElement(::rtl::OUString::createFromAscii("header"), xAttribs);

		// <transaction type="request" name="..." clientId="..." serverId=""/>
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("type"), sGenericStringData, sRequest);
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("name"), sGenericStringData, _rRequestName);
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("clientId"), sGenericStringData, sClientId);
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("serverId"), sGenericStringData, sEmptyString);
		m_xWriter->startElement(sTransaction, xAttribs);
		m_xWriter->endElement(sTransaction);
		pAttributes->clear();

		// </header>
		m_xWriter->endElement(::rtl::OUString::createFromAscii("header"));

		// <body>
		m_xWriter->startElement(::rtl::OUString::createFromAscii("body"), xAttribs);

		// <params total="...">
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("total"), sGenericStringData, ::rtl::OUString::valueOf(_nParamCount));
		m_xWriter->startElement(::rtl::OUString::createFromAscii("params"), xAttribs);
		pAttributes->clear();
	}
	CATCH_HANDLE_EXCEPTIONS_RET(::rtl::OUString());

	return sClientId;
}

//--------------------------------------------------------------------------
void ORemoteSession::closeEnvelopedRequest()
{
	// no mutex guarding, this is a protected method which has to be called from within guarded methods
	// only

	OSL_ENSHURE(m_xWriter.is(), "ORemoteSession::closeEnvelopedRequest : no writer !");

	try
	{
		m_xWriter->endElement(::rtl::OUString::createFromAscii("params"));
		m_xWriter->endElement(::rtl::OUString::createFromAscii("body"));
		m_xWriter->endElement(::rtl::OUString::createFromAscii("envelope"));
		m_xWriter->characters(::rtl::OUString::createFromAscii("\n\n"));
		m_xWriter->endDocument();
	}
	CATCH_HANDLE_EXCEPTIONS();
}

//--------------------------------------------------------------------------
sal_Bool ORemoteSession::open(const ::rtl::OUString& _rUser, const ::rtl::OUString& _rPwd)
{
	CFG_TRACE_INFO("remote session: opening a session for user %s", OUSTRING2ASCII(_rUser));

	ENTER();
	if (!isConnected())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::open : You have to call \"connect\" before opening a session !");
		m_eSessionError = E_NotConnected;
		return sal_False;
	}

	// a callback for the open request to the server
	OWaitForOpenSession* pWaitObject = new OWaitForOpenSession;
	ORef< IOpenObjectCallback > aKeepAlive = pWaitObject;

	// open the envelope
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("openSession"), 2);
	// register the callback
	m_pInterpreter->registerCallback(sClientId, aKeepAlive);
	// write the params, which currently are the user and the (not encrypted) password
	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("userName"), _rUser);
	writeStringParameter(sStringType, ::rtl::OUString::createFromAscii("password"), _rPwd);
	// close the envelope, which will trigger the transaction
	closeEnvelopedRequest();

	TimeValue aTimeout;
	aTimeout.Seconds = 30;
	aTimeout.Nanosec = 0;
	pWaitObject->waitForResponse(m_pTimeout ? m_pTimeout : &aTimeout);

	if (!pWaitObject->isFinished())
	{
		CFG_TRACE_ERROR("remote session: something went wrong, conn status %i, server returned %s", pWaitObject->getConnError(), OUSTRING2ASCII(pWaitObject->getStatus().sMessage));

		// though the request could not be finished, send an closeSession, just in case the
		// request is fullfilled just at this moment
		kill();
		m_eSessionError = E_TimedOut;
		return sal_False;
	}

	sal_Bool bSuccess = OWaitForOpenSession::DONE == pWaitObject->getState();
	m_nSessionId = bSuccess ? pWaitObject->getSessionId() : -1;

	CFG_TRACE_INFO_NI("remote session: got a session id of %i", m_nSessionId);

	if (!bSuccess)
	{
		m_eSessionError = E_ConnectionError;
		m_eConnectionError = pWaitObject->getConnError();
	}
	else
	{
#if defined(_IMPLICIT_USERPROFILE_USER_NAME_) || defined(_ADMIN_WRITES_DEFAULT_TAGS_)
		m_sCurrentUser = _rUser;
		m_sCurrentUser += ConfigurationName::stringDelimiter();
#endif
	}

	return bSuccess;
}

//--------------------------------------------------------------------------
void ORemoteSession::kill()
{
	CFG_TRACE_INFO("remote session: killing the current session");

	ENTER();
	if (!isConnected())
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::kill : not connected !");
		m_eSessionError = E_NotConnected;
		return;
	}

	// cancel all oustanding transactions
	if (isOpen())
		cancelAllTrans();

	// reset the interpreter
	if (m_pInterpreter)
		m_pInterpreter->reset();

	// send a closeSession request
	sal_Bool bAmAdministrator = m_sCurrentUser.equalsIgnoreCase(s_sAdministrator);
	openEnvelopedRequest(::rtl::OUString::createFromAscii("closeSession"), bAmAdministrator ? 1 : 0);
	if (bAmAdministrator)
		writeStringParameter(sIntegerType, ::rtl::OUString::createFromAscii("sessionId"), ::rtl::OUString::valueOf(m_nSessionId));
	closeEnvelopedRequest();

	// clear the node listener
	m_pInterpreter->setNotificationHandler(NULL);
		// (should have been done by the reset, anyway)

	// reset the session id, indicating that we're closed
	m_nSessionId = -1;
}

//--------------------------------------------------------------------------
void ORemoteSession::close(const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER();
	CFG_TRACE_INFO("remote session: closing the current session");
	if (!isConnected())
	{
		CFG_TRACE_WARNING("remote session: not connected !");
		OSL_ENSHURE(sal_False, "ORemoteSession::close : not connected !");
		return;
	}

	// a callback for the close request to the server
	OWaitForCloseSession* pWaitObject = new OWaitForCloseSession(this, _rHandler);
	ORef< IRequestCallback > aKeepAlive = pWaitObject;

	// so nothing can be sent from now on
	m_nSessionId = -1;

	// open the envelope
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("closeSession"), 0);
	// register the callback
	m_pInterpreter->registerCallback(sClientId, aKeepAlive);
	// close the envelope, which will trigger the transaction
	closeEnvelopedRequest();

	// TODO : if the object dies while this asynchronous close is pending, the OWaitForCloseSession object would call into
	// a dead object .... which probably will crash
}

//--------------------------------------------------------------------------
void ORemoteSession::implCloseSuccessfull()
{
	::osl::MutexGuard aGuard(m_aMutex);

	// reset the interpreter
	if (m_pInterpreter)
		m_pInterpreter->reset();

	// clear the node listener
	m_pInterpreter->setNotificationHandler(NULL);
		// (should have been done by the reset, anyway)

	m_nSessionId = -1;
}

//--------------------------------------------------------------------------
void ORemoteSession::writeStringParameter(const ::rtl::OUString& _rTypeDesc, const ::rtl::OUString& _rParamName, const ::rtl::OUString& _rValue)
{
	// no mutex guarding, this is a protected method which has to be called from within guarded methods
	// only

	OSL_ENSHURE(m_xWriter.is(), "ORemoteSession::writeStringParameter : no writer !");

	// attribute container
	AttributeListImpl* pAttributes = new AttributeListImpl;
	Reference< sax::XAttributeList > xAttribs = pAttributes;

	try
	{
		// <data type="...">
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("type"), sGenericStringData, _rTypeDesc);
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("name"), sGenericStringData, _rParamName);
		m_xWriter->startElement(::rtl::OUString::createFromAscii("data"), xAttribs);
		pAttributes->clear();

		// <value>...</value>
		m_xWriter->startElement(::rtl::OUString::createFromAscii("value"), xAttribs);
		m_xWriter->characters(_rValue);
		m_xWriter->endElement(::rtl::OUString::createFromAscii("value"));

		// </data>
		m_xWriter->endElement(::rtl::OUString::createFromAscii("data"));
	}
	CATCH_HANDLE_EXCEPTIONS();
}

//--------------------------------------------------------------------------
void ORemoteSession::writeNodeParameter(IDOMNodeDataProvider* _pProvider, const ::rtl::OUString& _rNameParamValue)
{
	// no mutex guarding, this is a protected method which has to be called from within guarded methods
	// only

	OSL_ENSHURE(m_xWriter.is(), "ORemoteSession::writeNodeParameter : no writer !");

	// attribute container
	AttributeListImpl* pAttributes = new AttributeListImpl;
	Reference< sax::XAttributeList > xAttribs = pAttributes;

	try
	{
		// <data type="...">
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("type"), sGenericStringData, sNodeName);
		pAttributes->addAttribute(::rtl::OUString::createFromAscii("name"), sGenericStringData, _rNameParamValue);
		m_xWriter->startElement(::rtl::OUString::createFromAscii("data"), xAttribs);
		pAttributes->clear();

		// <value>...</value>
		m_xWriter->startElement(::rtl::OUString::createFromAscii("value"), xAttribs);
		_pProvider->writeNodeData(Reference< sax::XDocumentHandler >(m_xWriter.get()));
			// TODO : think about exception handling for this single call .... maybe we don't want the excpetions
			// thrown by the provider to leave this method ...
		m_xWriter->endElement(::rtl::OUString::createFromAscii("value"));

		// </data>
		m_xWriter->endElement(::rtl::OUString::createFromAscii("data"));
	}
	CATCH_HANDLE_EXCEPTIONS();
}

//--------------------------------------------------------------------------
void ORemoteSession::nextRequestTransId(::rtl::OUString& _rId)
{
	OSL_ENSHURE(1 == m_pLastUsedTransId->refCount,
		"ORemoteSession::nextRequestTransId : invalid ref count of the transaction id !");
		// if you assign m_pLastUsedTransId to an ::rtl::OUString an call this method before
		// destroying that string, this assertion will fail. This is important as if some foreign string
		// references the characters, we could dou heavy damage with modifying them here.

	// TODO : for performance reasons : think about removing the following code which copies the string data.
	// Normally it should never be necessary ...
	if (1 != m_pLastUsedTransId->refCount)
	{	// create a new implobject to work with
		rtl_uString* pNewObject = NULL;
		rtl_uString_newFromString(&pNewObject, m_pLastUsedTransId);
			// acquired automatically
		rtl_uString_release(m_pLastUsedTransId);
		m_pLastUsedTransId = pNewObject;
	}

	// the algorithm for generating new ids is quite simple :
	// for each id the first character is an 'R' (like request)
	// followed by n*4 characters from [0..9, A..Z], where n is a sal_Int32 of at least 1.
	// So there are about 16^(2^31) ~= 2^(100.000.000.000) (or something like that :)
	// valid ids, which should be sufficient.

	sal_Unicode* pLoop = m_pLastUsedTransId->buffer + m_pLastUsedTransId->length - 1;
	for (sal_Int32 i = m_pLastUsedTransId->length - 1; i >= 0; --i, --pLoop)
	{
		if ('R' == *pLoop)	// terminator, we have an overflow
		{
			// we've used all digits we have, so append new ones
			rtl_uString* pNewObject = NULL;
			rtl_uString_new_WithLength(&pNewObject, m_pLastUsedTransId->length + 4);
				// acquired automatically

			sal_Int32 j;
			sal_Unicode* pCopyLoop = pNewObject->buffer;
			// the first character is the terminator character
			*pCopyLoop = 'R';
			++pCopyLoop;
			// 4 new '0' characters + the remainings in 
			for (j=1; j<pNewObject->length; ++j, ++pCopyLoop)
				*pCopyLoop = '0';

			// now we have a new string describing our ids
			rtl_uString_release(m_pLastUsedTransId);
			m_pLastUsedTransId = pNewObject;

			// and the increment is done, so break
			break;
		}
		else
		{
			if ('F' == *pLoop)	// digit overflow
				*pLoop = '0';	// no break, continue with the previous character
			else
			{
				if ('9' == *pLoop)
					*pLoop = 'A';
				else
					++*pLoop;
				break;			// the increment is done, no need to visit the other characters
			}
		}
	}

	// unfortunally the transaction ids live much longer than any single method call in this class
	// lasts, which means that if we would use m_pLastUsedTransId for the ::rtl::OUString's, we would
	// have no chance to control the acquire/release calls with our mutex, so we would be heavyly unsafe.
	// Thus we have to copy the data in m_pLastUsedTransId.

	_rId = ::rtl::OUString(m_pLastUsedTransId->buffer, m_pLastUsedTransId->length);
}

//--------------------------------------------------------------------------
void ORemoteSession::setListener(const ::vos::ORef< ISessionListener >& _rListener)
{
	::osl::MutexGuard aGuard(m_aMutex);
	if (!isOpen())	// implies isConnected
	{
		OSL_ENSHURE(sal_False, "ORemoteSession::setListener : no listeners allowed if no session is open !");
		return;
	}

	m_pInterpreter->setNotificationHandler(_rListener);
}

//--------------------------------------------------------------------------
void ORemoteSession::startListening(const ::com::sun::star::uno::Sequence< ::rtl::OUString >& _rNodes, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(startListening, _rHandler);

#ifdef _REMOTE_PATH_TRANSLATION_
	// if we do path translation, we have to  send a requestNotify for each single path, so we're able
	// to translate the notification paths back
	::rtl::OUString sClientId;
	::rtl::OUString sNodePath;
	const ::rtl::OUString* pNodePath = _rNodes.getConstArray();
	for (sal_Int32 i=0; i<_rNodes.getLength(); ++i, ++pNodePath)
	{
		sNodePath = *pNodePath;
		translateNodePath(sNodePath, CLIENT_SIDE, WRITE);
		sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("requestNotify"), _rNodes.getLength());

		// add to the translation table
		m_pInterpreter->addNotificationPathTranslation(sClientId, *pNodePath, sNodePath);

		if (_rHandler.isValid())
			m_pInterpreter->registerCallback(sClientId, _rHandler);
		writeStringParameter(sStringType, sNodePathName, sNodePath);
		closeEnvelopedRequest();
	}
#else
	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("requestNotify"), _rNodes.getLength());
	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);

	const ::rtl::OUString* pNodePath = _rNodes.getConstArray();
	for (sal_Int32 i=0; i<_rNodes.getLength(); ++i, ++pNodePath)
		writeStringParameter(sStringType, sNodePathName, *pNodePath);

	closeEnvelopedRequest();
#endif
}

//--------------------------------------------------------------------------
void ORemoteSession::stopListening(const ::com::sun::star::uno::Sequence< ::rtl::OUString >& _rNodes, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(stopListening, _rHandler);

	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("cancelNotify"), _rNodes.getLength());
	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);

	const ::rtl::OUString* pNodePath = _rNodes.getConstArray();
	for (sal_Int32 i=0; i<_rNodes.getLength(); ++i, ++pNodePath)
		writeStringParameter(sStringType, sNodePathName, *pNodePath);

	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::stopAllListening(const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(stopAllListening, _rHandler);

	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("cancelNotify"), 1);
	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);
	writeStringParameter(sStringType, sNodePathName, ::rtl::OUString::createFromAscii("ALL"));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::cancelTrans(sal_Int32 _nTransId, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(cancelTrans, _rHandler);

	::rtl::OUString sClientId = openEnvelopedRequest(::rtl::OUString::createFromAscii("cancelTrans"), 1);
	if (_rHandler.isValid())
		m_pInterpreter->registerCallback(sClientId, _rHandler);
	writeStringParameter(sIntegerType, ::rtl::OUString::createFromAscii("clientId"), ::rtl::OUString::valueOf(_nTransId));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
void ORemoteSession::cancelNodeTrans(const ::rtl::OUString& _rNodeAccessor, const ::vos::ORef< IRequestCallback >& _rHandler)
{
	ENTER_FULL_CHECK(cancelNodeTrans, _rHandler);

}

//--------------------------------------------------------------------------
void ORemoteSession::cancelAllTrans()
{
	ENTER_FULL_CHECK(cancelAllTrans, ORef< IRequestCallback >());

	openEnvelopedRequest(::rtl::OUString::createFromAscii("cancelTrans"), 0);
	writeStringParameter(sStringType, sNodePathName, ::rtl::OUString::createFromAscii("ALL"));
	closeEnvelopedRequest();
}

//--------------------------------------------------------------------------
sal_Bool ORemoteSession::splitNodeAccessor(const ::rtl::OUString& _rNodeAccessor, ::rtl::OUString& _rNodePath, ::rtl::OUString& _rUser)
{
	sal_Bool bHasUser = IConfigSession::splitNodeAccessor(_rNodeAccessor, _rNodePath, _rUser);

	// now check for special access to the base of all user profiles
	::rtl::OUString const sCheckUserAdmin =  getUserAdminAccessor();

	// the next line is just intended to save some work 
	if (bHasUser && _rNodeAccessor.indexOf(sCheckUserAdmin)==0)
	{
		_rUser = ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("TOPLEVEL"));
		_rNodePath = ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("org.openoffice.UserProfile")); // should not be star specific ??
		_rNodePath += _rNodeAccessor.copy(sCheckUserAdmin.getLength());
		// bHasUser = true;
	}
	else
		OSL_ENSHURE(_rNodeAccessor.indexOf(sCheckUserAdmin) == -1,
					"Invalid nodeAccessor: special user admin root accessor is embedded"); 

	return bHasUser;

}

#ifdef _OPEN_COMPONENT_NODES_ONLY_
//--------------------------------------------------------------------------
sal_Bool ORemoteSession::confirmOpenNode(::rtl::OUString& _sNodePath, sal_Int32& _nDepth)
{
	// NOTICE : all this stuff does not work if somebody gives us an path in the old notation (Root/ApplProfile/Star
	// instead of com.sun.star).

	// at the moment, the server is unable to open nodes which are not at level 1 ....

	ConfigurationName aRequestedName(_sNodePath);
	if (1 == aRequestedName.depth())
		return sal_True;

	while (aRequestedName.depth() > 1)
	{
		aRequestedName = aRequestedName.getParentName();
		if (COMPLETE_SUBTREE != _nDepth)
			++_nDepth;
	}
	_sNodePath = aRequestedName.fullName();

	return sal_False;
}
#endif

#ifdef _REMOTE_PATH_TRANSLATION_
//--------------------------------------------------------------------------
static const ::rtl::OUString	s_sComSunStarPrefix = ::rtl::OUString::createFromAscii("org.openoffice");
static const sal_Char*			s_pComSunStarPrefix = "org.openoffice";
static const ::rtl::OUString	s_sServerSideRoot = ::rtl::OUString::createFromAscii("Root/ApplProfile/openoffice");
static const sal_Char*			s_pServerSideRoot = "Root/ApplProfile/openoffice";
static const ::rtl::OUString	s_sFirstLevelUnderProfile = ::rtl::OUString::createFromAscii("openoffice/");
static const ::rtl::OUString	s_sDotSeparator = ::rtl::OUString::createFromAscii(".");
static const ::rtl::OUString	s_sApplicationProfile  = ::rtl::OUString::createFromAscii("ApplProfile/");
static const ::rtl::OUString	s_sUserProfile = s_sApplicationProfile; /*::rtl::OUString::createFromAscii("UserApplPreference/");*/
static const ::rtl::OUString	s_sServerLevel1Root = ::rtl::OUString::createFromAscii("Root/");
static const ::rtl::OUString	s_sUserProfileServerAccess = s_sUserProfileClientAccess; /* ::rtl::OUString::createFromAscii("Root/UserProfile"); */

void ORemoteSession::translateNodePath(::rtl::OUString& _rPath, PATH_ORIGIN _eOrigin, PATH_USAGE _eUsage)
{
	CFG_TRACE_INFO("remote session: translating a node path, origin: %s, used for: %s access",
		CLIENT_SIDE == _eOrigin ? "proxy" : "server",
		READ == _eUsage ? "read" : "write");
	CFG_TRACE_INFO_NI("remote session: old value: %s", OUSTRING2ASCII(_rPath));

	ConfigurationName aParser(_rPath);
	ConfigurationName::Iterator aElement = aParser.end();
	ConfigurationName::Iterator aStopAt = aElement;

	if (!aParser.isRelative())
	{
		aParser = aParser.relativeTo(ConfigurationName());
		_rPath = aParser.fullName();
	}

#ifdef _IMPLICIT_USERPROFILE_USER_NAME_
	if (CLIENT_SIDE == _eOrigin)
	{
		aElement = aParser.begin();
		OSL_ENSHURE(aParser.end() != aElement, "ORemoteSession::translateNodePath : invalid path !");
			// should have at least depth 1 ...
		if (*aElement == s_sUserProfileClientAccess)
		{
			_rPath = s_sUserProfileServerAccess;
			_rPath += ConfigurationName::stringDelimiter();
			// erase the trailing slash in the user name
			_rPath = ConfigurationName(_rPath).fullName();

			aStopAt = aParser.end();
			while (++aElement != aStopAt)
				(_rPath += ConfigurationName::stringDelimiter()) += *aElement;
		}
	}
#endif

#ifdef _SIMULATE_COMPONENT_DOTS_
	if (CLIENT_SIDE == _eOrigin)
	{
		// translate "com.sun.star.Office" into "com.sun.star/Office"
		aParser = ConfigurationName(_rPath);
		aElement = aParser.begin();
		if (0 == aElement->indexOf(s_sComSunStarPrefix))
		{
			if (0 != aElement->indexOf(s_sUserProfileClientAccess))
			{	// do not translate if the user profile is beeing accessed
				_rPath = aElement->copy(0, s_sComSunStarPrefix.getLength());
				_rPath += aElement->copy(s_sComSunStarPrefix.getLength()).replace('.', '/');

				aStopAt = aParser.end();
				while (++aElement != aStopAt)
					(_rPath += ConfigurationName::stringDelimiter()) += *aElement;
			}
		}
	}
	else
	{
		aParser = ConfigurationName(_rPath);
		aElement = aParser.begin();
		_rPath = *aElement;
		_rPath += s_sDotSeparator;
		++aElement;
		_rPath += *aElement;
		aStopAt = aParser.end();
		while (++aElement != aStopAt)
			(_rPath += ConfigurationName::stringDelimiter()) += *aElement;
		// TODO : we would need a translation table here ... without it, we have no chance to decide how many
		// slashes should be replaced by dots (at the moment, only the first slash is replaced)
	}
#endif
#ifdef _IMPLICIT_USERPROFILE_USER_NAME_
	if (SERVER_SIDE == _eOrigin)
	{	// replace Root/UserProfile with com.sun.star.UserProfile
		if (0 == _rPath.indexOf(s_sUserProfileServerAccess))
		{
			sal_Int32 nRemainingPos = s_sUserProfileServerAccess.getLength();
			if (_rPath.getLength() > nRemainingPos)
				if (_rPath.getStr()[nRemainingPos] == '/')
					++nRemainingPos;
			if (_rPath.indexOf(m_sCurrentUser, nRemainingPos))
			{
				nRemainingPos += m_sCurrentUser.getLength();
				if (_rPath.getLength() > nRemainingPos)
					if (_rPath.getStr()[nRemainingPos] == '/')
						++nRemainingPos;

				_rPath = ConfigurationName(s_sUserProfileClientAccess, _rPath.copy(nRemainingPos)).fullName();
			}
		}
	}
#endif

	CFG_TRACE_INFO_NI("remote session: translated value: %s", OUSTRING2ASCII(_rPath));
}
#endif

//..........................................................................
}	// namespace configmgr
//..........................................................................

/**************************************************************************
 history:
	$Log: remotesession.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:13:42  hr
	initial import
	
	Revision 1.57  2000/09/15 09:51:52  willem.vandorp
	OpenOffice header added
	
	Revision 1.56  2000/09/13 14:40:48  dg
	conversion from com.sun.star to org.openoffice
	
	Revision 1.55  2000/09/06 09:28:52  lla
	local write always in new format
	
	Revision 1.54  2000/09/05 14:56:45  lla
	changes in old to new mappings
	
	Revision 1.53  2000/09/05 09:24:32  lla
	OFakeValueConverter to convert old XML Files to new one
	Converter to change org.openoffice path names to com.sun.star for old server
	
	Revision 1.52  2000/08/28 13:24:35  fs
	#78218# remember the user name in connectToPortal
	
	Revision 1.51  2000/08/24 08:48:19  fs
	traces
	
	Revision 1.50  2000/08/21 15:31:17  fs
	#77895# implDisconnect: don't access m_pServerConnection if NULL
	
	Revision 1.49  2000/08/20 15:03:21  obr
	#77370# server name should contain port
	
	Revision 1.48  2000/08/20 12:47:00  fs
	#77860# close: reset m_nSessionId before sending the envelope
	
	Revision 1.47  2000/08/18 16:48:57  fs
	#77803# user name en-/decoding
	
	Revision 1.46  2000/08/14 17:53:41  fs
	#77593# enable connecting to a remote portal
	
	Revision 1.45  2000/08/14 12:44:59  jb
	#77568# New service UserAdministration. Allows to invoke 'addUser' transactions
	
	Revision 1.44  2000/08/13 10:29:23  fs
	#77367# fake a session id for a portal session
	
	Revision 1.43  2000/08/11 09:04:28  fs
	#77367# changed signature of implWrite
	
	Revision 1.42  2000/08/11 08:41:05  fs
	#77367# envelope streams are now teplate classes
	
	Revision 1.41  2000/08/09 19:03:38  fs
	wrong trace type in openSession
	
	Revision 1.40  2000/08/09 18:54:14  fs
	implemented some tracing / removed some obsolete stuff
	
	Revision 1.39  2000/08/08 08:57:56  fs
	#77367#
	
	Revision 1.38  2000/08/07 17:39:25  fs
	OFakeDataRootPath : use the node accessor, not the node path !
	
	Revision 1.37  2000/08/07 13:34:16  fs
	no _IMPLICIT_USERPROFILE_USER_NAME_ anymore
	
	Revision 1.36  2000/08/07 11:59:47  lla
	OTreeRootTagKiller checks his invariant
	
	Revision 1.35  2000/08/07 07:43:05  fs
	adjusted connectToPortal
	
	Revision 1.34  2000/08/06 11:13:14  fs
	connectToPortal
	
	Revision 1.33  2000/08/04 15:56:11  willem.vandorp
	Header and footer replaced
	
	Revision 1.32  2000/08/04 09:27:39  fs
	adjustments
	
	Revision 1.31  2000/08/04 07:17:53  fs
	no special server side user profile path anymore
	
	Revision 1.30  2000/08/03 10:35:10  fs
	oops .... admin default tags for admin layer, not user layer access (flipped a bit)
	
	Revision 1.29  2000/08/03 08:43:42  fs
	adjustments for admin update
	
	Revision 1.28  2000/08/02 19:17:30  fs
	_ADMIN_WRITES_DEFAULT_TAGS_
	
	Revision 1.27  2000/08/02 14:14:12  fs
	node id is string now
	
	Revision 1.26  2000/07/31 17:31:03  fs
	use the user name in UserProfile accesses
	
	Revision 1.25  2000/07/28 10:40:47  fs
	adjustments for accessing foreign user data
	
	Revision 1.24  2000/07/27 18:25:39  fs
	adjustments to the latest server version
	
	Revision 1.23  2000/07/27 13:20:26  fs
	new user param for node related methods / adjustments to server 3
	
	Revision 1.22  2000/07/26 12:07:08  fs
	removed one line which was intended for the next server version
	
	Revision 1.21  2000/07/26 12:03:04  fs
	moved AddNodeRedundanceKiller to saxtools.hxx
	
	Revision 1.20  2000/07/21 17:47:16  fs
	use the OValueTagKiller in updates for removing tags the writer provides
	
	Revision 1.19  2000/07/20 12:07:20  fs
	timeout handling
	
	Revision 1.18  2000/07/20 09:00:08  fs
	OListMerger : slightly modified the format of lists
	
	Revision 1.17  2000/07/19 16:23:28  fs
	_REMERGE_VALUE_LISTS_ / OListMerger
	
	Revision 1.16  2000/07/19 13:51:50  fs
	typo
	
	Revision 1.15  2000/07/17 17:37:55  fs
	path translation for com.sun.star.UserProfile
	
	Revision 1.14  2000/07/14 16:00:12  fs
	OValueTagKiller / translateNodePath as member
	
	Revision 1.13  2000/07/14 13:36:15  jb
	Adjusted throw specs on acquire/release to nothrow
	
	Revision 1.12  2000/07/13 18:45:05  fs
	confirmOpenNode
	
	Revision 1.11  2000/07/13 16:48:08  fs
	adjustments for addNode (no node name redundance)
	
	Revision 1.10  2000/07/10 14:22:14  fs
	translateNodePath no class member anymore
	
	Revision 1.9  2000/07/07 16:43:49  fs
	removed some old defines
	
	Revision 1.8  2000/07/05 09:05:49  fs
	new server adjustments
	
	Revision 1.7  2000/07/04 09:24:38  fs
	node path translation
	
	Revision 1.6  2000/07/02 11:15:22  fs
	assertion
	
	Revision 1.5  2000/06/28 07:47:07  fs
	adjustments
	
	Revision 1.4  2000/06/26 07:02:32  fs
	changed the thread handling
	
	Revision 1.3  2000/06/23 11:40:13  fs
	adjustments
	
	Revision 1.2  2000/06/23 08:51:23  fs
	adjustments
	
	Revision 1.1  2000/06/21 06:39:23  fs
	remote config sessions
	

	Revision 1.0 15.06.00 09:12:25  fs
/**************************************************************************/

