/*************************************************************************
 *
 *  $RCSfile: sessionfactory.cxx,v $
 *
 *  $Revision: 1.1.2.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/10/02 19:10:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>
#include "sessionfactory.hxx"

#ifndef _CONFIGMGR_COMMONTYPES_HXX_
#include "commontypes.hxx"
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_RUNTIMEEXCEPTION_HPP_
#include <com/sun/star/uno/RuntimeException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONNECTION_CONNECTIONSETUPEXCEPTION_HPP_
#include <com/sun/star/connection/ConnectionSetupException.hpp>
#endif

#ifndef _OSL_TYPES_H_
#include <osl/types.h>
#endif
#ifndef _OSL_PROFILE_HXX_
#include <osl/profile.hxx>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _RTL_STRING_HXX_
#include <rtl/string.hxx>
#endif

#ifndef _OSL_MODULE_H_
#include <osl/module.h>
#endif

#ifndef __SGI_STL_MEMORY
#include <stl/memory>
#endif

#if SUPD==605
#include <pconnect.hxx>
#else
#ifndef _DAEMONS_PORTALCONNECT_HXX_
#include <daemons/PortalConnect.hxx>
#endif
#endif

#ifndef _CONFIGMGR_SESSION_REMOTESESSION_HXX_
#include "remotesession.hxx"
#endif
#ifndef _CONFIGMGR_TRACER_HXX_
#include "tracer.hxx"
#endif

#include "localsession.hxx"

namespace configmgr
{
#define SETTING_USER		::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("user"))
#define SETTING_PASSWORD	::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("password"))
#define SETTING_SERVER		::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("server"))
#define SETTING_PORT		::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("port"))
#define SETTING_TIMEOUT		::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("timeout"))
#define SETTING_ROOTPATH	::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("rootpath"))


	using ::rtl::OUString;
	typedef char const* AsciiString;

	const sal_Int32 cDefaultPort = 0;
	AsciiString const cDefaultTimeout	= "5000";

	AsciiString const cRemoteSessionSection = "RemoteRegistry";
		AsciiString const cRemoteServerName = "Server";
		AsciiString const cRemoteTimeout	= "Timeout";
	AsciiString const cUserSection			= "Authentication";
		AsciiString const cUserName			= "User";
		AsciiString const cPassword			= "Password";

	static rtl::OUString const workAroundOStringLimitation(rtl::OString const& aString)
	{ return OUString::createFromAscii(aString); }

	IConfigSession* createRemoteSession(
			::osl::Profile* _pProfile, ::rtl::OUString const& aFileSystemContext,
			uno::Reference<lang::XMultiServiceFactory> const& aServiceMgr,
			SettingsOverride const& _rSettings)
	{
		// for simplicity, we want to use the [] operator which requires a non-const settings object
		SettingsOverride aSettings(_rSettings);

		::rtl::OUString sUser, sPassword;

		// ------------------------------
		// the user : may be a settings override named "user" or a profile entry in "Authentication/User"
		if (!(aSettings[SETTING_USER] >>= sUser) && _pProfile)
		{
			rtl::OString sUserTmp( _pProfile->readString(
									cUserSection, 
									cUserName, 
									rtl::OString() 
								) );
			sUser = OUString(sUserTmp, sUserTmp.getLength(), RTL_TEXTENCODING_ASCII_US);
		}
#ifdef DBG_UTIL
		aSettings.erase(aSettings.find(SETTING_USER));
#endif

		// ------------------------------
		// the password : may be a settings override named "password" or a profile entry in "Authentication/Password"
		if (!(aSettings[SETTING_PASSWORD] >>= sPassword) && _pProfile)
		{
			rtl::OString sPwdTemp ( _pProfile->readString(
									cUserSection, 
									cPassword, 
									rtl::OString() 
								) );
			sPassword = OUString(sPwdTemp, sPwdTemp.getLength(), RTL_TEXTENCODING_ASCII_US);
		}
#ifdef DBG_UTIL
		aSettings.erase(aSettings.find(SETTING_PASSWORD));
#endif

		// ------------------------------
		// the server name and the port are merged into one entry in the profile, or they may be two separate settings
		::rtl::OUString sServer;
		sal_Int32 nPort = 0;

		if ((!(aSettings[SETTING_SERVER] >>= sServer) || !(aSettings[SETTING_PORT] >>= nPort)) && _pProfile)
		{	// at least one of the two params was not overwritten in the settings, so we need the string from the profile
			rtl::OString sServerAndPort( _pProfile->readString(
									cRemoteSessionSection, 
									cRemoteServerName, 
									rtl::OString() 
							)	);
			::rtl::OUString sSNP(sServerAndPort.getStr(), sServerAndPort.getLength(), RTL_TEXTENCODING_ASCII_US);

			const int nColon = sSNP.lastIndexOf(':');
			if (!sServer.getLength())
			{	// the server was not overwritten by the settings
				if (-1 != nColon)
					sServer = sSNP.copy(0, nColon);
				else
					sServer = sSNP;
			}
			if ((0 == nPort) && (-1 != nColon))
				// the port was not overwritten, and the profile contains a port specification
				nPort = workAroundOStringLimitation(sServerAndPort.copy(nColon+1)).toInt32();
		}
#ifdef DBG_UTIL
		if (aSettings.end() != aSettings.find(SETTING_SERVER))
			aSettings.erase(aSettings.find(SETTING_SERVER));
		if (aSettings.end() != aSettings.find(SETTING_PORT))
			aSettings.erase(aSettings.find(SETTING_PORT));
#endif

		if (!sServer.getLength())
		{
			CFG_TRACE_INFO("session factory: no server specified for the remote session, defaulting to localhost !");
			sServer = ::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("localhost"));
		}
		if (0 == nPort)
		{
			CFG_TRACE_INFO("session factory: no port specified for the remote session, defaulting to 1024 !");
			nPort = 1024;
		}

		// ------------------------------
		// the timeout : maybe a setting called "timeout" or a profile string
		TimeValue const* pTimeout = NULL; // so we can have no timeout at all
		TimeValue aTimeout = { 0, 0 };

		sal_Int32 nTimeoutMilliSeconds = 0;	// no timeout at all
		if (!(aSettings[SETTING_TIMEOUT] >>= nTimeoutMilliSeconds) && _pProfile)
		{
			rtl::OString sTimeout( _pProfile->readString(
									cRemoteSessionSection, 
									cRemoteTimeout, 
									cDefaultTimeout 
							)	);

			if (sTimeout.getLength() != 0)
				nTimeoutMilliSeconds = workAroundOStringLimitation(sTimeout).toInt32();
		}

		if (nTimeoutMilliSeconds > 0)
		{
			aTimeout.Seconds += nTimeoutMilliSeconds / 1000;
			aTimeout.Nanosec += 1000 * 1000 * (nTimeoutMilliSeconds % 1000);
			pTimeout = &aTimeout;
		}
#ifdef DBG_UTIL
		aSettings.erase(aSettings.find(SETTING_TIMEOUT));
#endif

#ifdef DBG_UTIL
		OSL_ENSHURE(0 == aSettings.size(), "createRemoteSession : unused (unknown) parameters deteceted !");
#endif

		// ------------------------------
		// got all params ... create and connect
		std::auto_ptr<ORemoteSession> pSession( new ORemoteSession(aServiceMgr) );

		sal_Bool bOpen = pSession->connect(sServer, nPort, pTimeout) &&
						 pSession->open(sUser, sPassword);
		if (!bOpen)
			throw com::sun::star::connection::ConnectionSetupException(OUString::createFromAscii("Unable to connect to the configuration registry server."),0);

		return pSession.release();
	}

// -----------------------------------------------------------------------------
	typedef void * (SAL_CALL * portalConnect_EntryPoint)( );

	IConfigSession* createPortalSession(
			::osl::Profile* _pProfile, ::rtl::OUString const& aFileSystemContext,
			uno::Reference<lang::XMultiServiceFactory> const& aServiceMgr,
			SettingsOverride const& _rSettings)
	{
		// for simplicity, we want to use the [] operator which requires a non-const settings object
		SettingsOverride aSettings(_rSettings);

#ifdef WIN32
		static const sal_Char* pLibrary = "portal.dll";	
#else
#if defined(UNX) || defined (MAC)
		static const sal_Char* pLibrary = "libportal.so";	
#else
#error "unknown plattform"
#endif
#endif
		::rtl::OUString sPortalLibrary = ::rtl::OUString::createFromAscii(pLibrary);
		oslModule hPortalLib = osl_loadModule( sPortalLibrary.pData, SAL_LOADMODULE_LAZY | SAL_LOADMODULE_GLOBAL );
		if (!hPortalLib)
			throw ::com::sun::star::connection::ConnectionSetupException(OUString(RTL_CONSTASCII_USTRINGPARAM("Configuration bootstrap error. Unable to load the library ")) += sPortalLibrary, NULL);

		void* pEntryPoint;

		OUString aPortalConnectEntryPoint(RTL_CONSTASCII_USTRINGPARAM("_getPortalConnector"));
		if (!(pEntryPoint = osl_getSymbol( hPortalLib, aPortalConnectEntryPoint.pData )))
		{
			osl_unloadModule(hPortalLib);
			throw ::com::sun::star::connection::ConnectionSetupException(OUString(RTL_CONSTASCII_USTRINGPARAM("Configuration bootstrap error. Unable to find the necessary symbols in ")) += sPortalLibrary, NULL);
		}

		void* pConnector = (*((portalConnect_EntryPoint)(pEntryPoint)))();
		::vos::ORef< ::daemons::IPortalConnector > xConnector =
			static_cast< ::daemons::IPortalConnector* >(pConnector);

		if (!xConnector.isValid())
		{
			osl_unloadModule(hPortalLib);
			throw ::com::sun::star::connection::ConnectionSetupException(OUString(RTL_CONSTASCII_USTRINGPARAM("Configuration bootstrap error. Unable to connect to the portal services.")), NULL);
		}

		// was aquired once by getPortalConnector so it could be transported as void pointer
		xConnector->release();

		std::auto_ptr<ORemoteSession> pSession( new ORemoteSession(aServiceMgr) );

		// ------------------------------
		// the timeout : maybe a setting called "timeout" or a profile string
		TimeValue const* pTimeout = NULL; // so we can have no timeout at all
		TimeValue aTimeout = { 0, 0 };

		sal_Int32 nTimeoutMilliSeconds = 0;	// no timeout at all
		if (!(aSettings[SETTING_TIMEOUT] >>= nTimeoutMilliSeconds) && _pProfile)
		{
			rtl::OString sTimeout( _pProfile->readString(
									cRemoteSessionSection, 
									cRemoteTimeout, 
									cDefaultTimeout 
							)	);

			if (sTimeout.getLength() != 0)
				nTimeoutMilliSeconds = workAroundOStringLimitation(sTimeout).toInt32();
		}

		if (nTimeoutMilliSeconds > 0)
		{
			aTimeout.Seconds += nTimeoutMilliSeconds / 1000;
			aTimeout.Nanosec += 1000 * 1000 * (nTimeoutMilliSeconds % 1000);
			pTimeout = &aTimeout;
		}
#ifdef DBG_UTIL
		aSettings.erase(aSettings.find(SETTING_TIMEOUT));
#endif

		// the server/port/user/password
		// TODO : extract them from the profile if not found in the override
		::rtl::OUString sServer, sUser, sPassword;
		sal_Int32 nPort=0;
		aSettings[SETTING_SERVER] >>= sServer;
		aSettings[SETTING_USER] >>= sUser;
		aSettings[SETTING_PASSWORD] >>= sPassword;
		aSettings[SETTING_PORT] >>= nPort;

		if (!pSession->connectToPortal(xConnector, sServer, nPort, sUser, sPassword, pTimeout))
			throw ::com::sun::star::connection::ConnectionSetupException(OUString::createFromAscii("Could not establish the connection to the portal's configuration service."), NULL);

		return pSession.release();
	}

// -----------------------------------------------------------------------------

	IConfigSession* createLocalSession(
			::osl::Profile* _pProfile, ::rtl::OUString const& aFileSystemContext,
			uno::Reference<lang::XMultiServiceFactory> const& aServiceMgr,
			SettingsOverride const& _rSettings)
	{
		// for simplicity, we want to use the [] operator which requires a non-const settings object
		SettingsOverride aSettings(_rSettings);

		::rtl::OUString sRootPath;

		// ------------------------------
		// the rootpath : may be a settings override named "rootpath" or a profile entry in "LocalRegistry/rootpath"
		if (!(aSettings[SETTING_ROOTPATH] >>= sRootPath) && _pProfile)
		{
			static const AsciiString cLocalRegSection = "LocalRegistry";
			static const AsciiString cRootPath = "rootpath";
			static const ::rtl::OString sRootPath_Ascii(cRootPath);

			rtl::OString sRootPathTmp( _pProfile->readString( cLocalRegSection, 
														 cRootPath, 
														 rtl::OString() 
														 )	);

			sRootPath = ::rtl::OUString(sRootPathTmp.getStr(), sRootPathTmp.getLength(), RTL_TEXTENCODING_ASCII_US); 
		}
#ifdef DBG_UTIL
		aSettings.erase(aSettings.find(SETTING_ROOTPATH));
#endif

		if (aFileSystemContext.getLength())
		{
			OUString sAbsPath;
			if (sRootPath.getLength() == 0)
				sRootPath = aFileSystemContext; // what else can we do ?

			else if (osl::File::getAbsolutePath(aFileSystemContext, sRootPath, sAbsPath) == osl::File::E_None)
				sRootPath = sAbsPath; 
		}

		OSL_ENSHURE( sRootPath.getLength(), "No configuration root path available");

#ifdef DBG_UTIL
		OSL_ENSHURE(0 == aSettings.size(), "createLocalSession : unused (unknown) parameters deteceted !");
#endif

		// create it .. and connect
		std::auto_ptr<LocalSession> pLocal( new LocalSession(aServiceMgr) );
		sal_Bool bOpen = pLocal->open(sRootPath);
		if (!bOpen)
			throw uno::Exception(OUString(RTL_CONSTASCII_USTRINGPARAM("Configuration: Could not find ")) += sRootPath,0);

		return pLocal.release();
	}
}


