/*************************************************************************
 *
 *  $RCSfile: xmlformater.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:13:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stl/vector>

#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include <cppuhelper/servicefactory.hxx>
#endif
#include <cppuhelper/implbase1.hxx>


#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>

#include <com/sun/star/io/XOutputStream.hpp>
#include <com/sun/star/io/XActiveDataSource.hpp>

#include <rtl/ustring.hxx>

#ifndef _COM_SUN_STAR_SCRIPT_CANNOTCONVERTEXCEPTION_HDL_
#include <com/sun/star/script/CannotConvertException.hdl>
#endif

#include <com/sun/star/uno/Any.hxx>

#include <osl/diagnose.h>
#include "cmtree.hxx"
#include "attributes.hxx"
#include "typeconverter.hxx"
#include "xmlformater.hxx"
#ifndef _CONFIGMGR_TRACER_HXX_
#include "tracer.hxx"
#endif

#ifndef _CONFIGMGR_SERVER_VERSION_HXX_
#include "server_version.hxx"
#endif

using namespace vos;
using namespace com::sun::star::io;
using namespace com::sun::star::lang;
using namespace com::sun::star::uno;
using namespace com::sun::star::xml::sax;
using namespace rtl;
using namespace std;

/*========================================================================
 *
 * XML Export
 *
 *=======================================================================*/

#define ERR_SWG_WRITE_ERROR 1

#include <unotools/streamwrap.hxx>
#include "cmtree.hxx"

#define ASCII(x) OUString::createFromAscii(x)	
namespace configmgr
{
	namespace uno = com::sun::star::uno;
	using ::rtl::OUString;

// -----------------------------------------------------------------------------
// Real implementation of XML Export for CM

// -----------------------------------------------------------------------------
	CmXMLFormater::CmXMLFormater(const SubtreeChange* _pChanges,
								 const uno::Reference< script::XTypeConverter >& _rConverter)
			:m_pChanges(_pChanges) 
	{
		OSL_ENSHURE(m_pChanges, "CmXMLFormater::CmXMLFormater : invalid changes tree !");
		m_aDocConverter.setConverter(_rConverter);
	}

// -----------------------------------------------------------------------------
	void CmXMLFormater::SetHandler(const Reference< XDocumentHandler > &rHandler) throw(SAXException)
	{
		m_xHandler = rHandler;
		OSL_ENSHURE(m_xHandler.is(), "CmXMLFormater::SetHandler : invalid handler, won't write anything !");
		if (m_xHandler.is())
		{
			m_aDocConverter.setHandler(m_xHandler);
			WriteSubtreeChanges();
		}
	}
	

// -----------------------------------------------------------------------------
sal_Bool CmXMLFormater::WriteSubtreeChanges() throw(SAXException)
{
	sal_Bool bBack = sal_False;
//	DON'T START AN DOCUMENT, WE'RE DEEP WITHIN AN DOCUMENT ALREADY - WE JUST SUPPLY A SMALL PART
#ifdef PRIVAT_DEBUG
	m_xHandler->startDocument();
#endif

/* DON'T WRITE A XML HEADER
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList> rList( (XAttributeList *) pList , UNO_QUERY );

	//! MUST SOMETHING OTHER THAN characters, with NO char replace

	m_xHandler->unknown("<!DOCTYPE ConfigurationManagement PUBLIC \"-//IETF//DTD UNKNOWN/ConfigurationManagement XML//EN\"\n"
			   "\"http://www.unknown.org/internet-drafts/draft-many-cfgmgnt-xmldoc-01.txt\">");

	m_xHandler->ignorableWhitespace("");
	m_xHandler->comment(" (c) Sun Microsystems, Inc. created by StarOffice");
	m_xHandler->ignorableWhitespace("");

	pList->addAttribute( ASCII("path"),
						 ASCII("CDATA"),
						 m_aTreeChangeList.pathToRoot); // write value to stream

	OUString aCFGName(OUString::createFromAscii("envelope"));
	m_xHandler->startElement(aCFGName, rList);
	m_xHandler->ignorableWhitespace("");
*/

	handle(*m_pChanges);

/* DON'T WRITE A XML HEADER
	// </iCalendar>
	m_xHandler->endElement(aCFGName);
	m_xHandler->ignorableWhitespace("");
*/

#ifdef PRIVAT_DEBUG
	m_xHandler->endDocument();
#endif
	return bBack;
}



// -----------------------------------------------------------------------------
void CmXMLFormater::handle(ValueNode const& _rNode)
{
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );

	bool bSeq;
	Type aType = getBasicType(_rNode.getValueType(), bSeq);
	if (aType == getBinaryType())
	{
		pList->addAttribute( ATTR_TYPE,
							 XML_CDATA,
							 TYPE_BINARY);

		pList->addAttribute( ATTR_ENCODING,
							 XML_CDATA,
							 ATTR_ENCODING_HEX);
	}
	else
	{
		pList->addAttribute( ATTR_TYPE,
							 XML_CDATA,
							 toTypeName(aType.getTypeClass()));

		if (bSeq)
		{
			pList->addAttribute( ATTR_DERIVED,
								 XML_CDATA,
								 ATTR_DERIVED_LIST);
		}
	}

	OUString aNodeName(_rNode.getName());

	m_xHandler->startElement(aNodeName, rList);

	m_aDocConverter.writeValue(_rNode.getValue());
	
	m_xHandler->endElement(aNodeName);
	m_xHandler->ignorableWhitespace(OUString());
}

// -----------------------------------------------------------------------------
void CmXMLFormater::handle(ISubtree const& _rTree)
{
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );

	OUString aNodeName(_rTree.getName());

	if (_rTree.isSetNode())
	{
		pList->addAttribute( ATTR_TYPE,
							 XML_CDATA,
							 TYPE_SET);
	}

	OUString aSetName(_rTree.getChildTemplateName());
	if (aSetName.getLength() > 0)
	{
		pList->addAttribute( ATTR_INSTANCE,
							 XML_CDATA,
							 aSetName);

		//! LLA: NodeAttributes won't be written, must be done in the near future
	}
	
	m_xHandler->startElement(aNodeName, rList);
	m_xHandler->ignorableWhitespace(OUString());

	_rTree.forEachChild(*this);

	m_xHandler->endElement(aNodeName);
	m_xHandler->ignorableWhitespace(OUString());
}


// ---------------------------------- Changes ----------------------------------
void CmXMLFormater::handle(ValueChange const& aValueNode)
{
	// POST: handle a ValueChange
	OUString aNodeName(aValueNode.getNodeName());

	m_aDocConverter.startElement(aNodeName, aValueNode.getNewValue());
	m_aDocConverter.writeValue(aValueNode.getNewValue());
#ifndef _NO_OLD_VALUES_ON_UPDATE_
	m_aDocConverter.writeAny(aValueNode.getOldValue(), "oldvalue");
#endif
	m_aDocConverter.endElement(aNodeName);
}

// -----------------------------------------------------------------------------
void CmXMLFormater::handle(AddNode const& aAddNode)
{
	// POST: handle an AddNode
	// write the INode
	INode* pNewNode = aAddNode.getAddedNode();
	if (!pNewNode)
	{
		pNewNode = aAddNode.getAddedNode_unsafe();
		OSL_ENSHURE(pNewNode, "CmXMLFormater::handle : added an empty node ?");
		CFG_TRACE_WARNING("xml formatter: Formatting 'AddNode' change that doesn't own its node");
	}

	if (pNewNode)
		pNewNode->dispatch(*this);
}

// -----------------------------------------------------------------------------
void CmXMLFormater::handle(RemoveNode const& aRemoveNode)
{
	// POST: handle a RemoveNode
	OSL_ENSHURE(0, "Removenode not really ready yet.");

	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );

	pList->addAttribute( ATTR_NAME,
						 XML_CDATA,
						 aRemoveNode.getNodeName()); // write value to stream

	OUString aNodeName(OUString::createFromAscii("removenode"));

	m_xHandler->startElement(aNodeName, rList);
	m_xHandler->ignorableWhitespace(OUString());

	m_xHandler->endElement(aNodeName);
	m_xHandler->ignorableWhitespace(OUString());
}

// -----------------------------------------------------------------------------
void CmXMLFormater::handle(SubtreeChange const& aSubtree)
{
	// POST: handle each SubtreeChange
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );

	OUString aNodeName(aSubtree.getNodeName());
	m_xHandler->startElement(aNodeName, rList);
	m_xHandler->ignorableWhitespace(OUString());

	aSubtree.forEachChange(*this);

	m_xHandler->endElement(aNodeName);
	m_xHandler->ignorableWhitespace(OUString());
}

// -----------------------------------------------------------------------------
#define WRITE_SEQUENCE(SEQ_TYPE) \
	{ \
		Sequence<SEQ_TYPE> aData; \
		/* OSL_ASSERT(aType = ::getCppuType(aData.getArray()) );*/ \
		if (aValue >>= aData) { \
			for(int i=0;i<aData.getLength();i++) \
			{ \
				writeValue(makeAny(aData[i])); \
			} \
			bRet = true; \
		} \
	}

// -----------------------------------------------------------------------------

void AnyToXMLDocument::startElement(const rtl::OUString &aName, const uno::Any& aElement)
{
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );

	// Typetest
	bool bSeq;
	Type aType = getBasicType(aElement.getValueType(), bSeq);
	if (aType == getBinaryType())
	{
		pList->addAttribute( ATTR_TYPE,
							 XML_CDATA,
							 TYPE_BINARY);

		pList->addAttribute( ATTR_ENCODING,
							 XML_CDATA,
							 ATTR_ENCODING_HEX);
	}
	else
	{
		if (aElement.getValueTypeClass() != TypeClass_INTERFACE)
		{
			pList->addAttribute( ATTR_TYPE,
								 XML_CDATA,
								 toTypeName(aType.getTypeClass()));
			if (bSeq)
			{
				pList->addAttribute( ATTR_DERIVED,
									 XML_CDATA,
									 ATTR_DERIVED_LIST);
			}
		}
	}
	
	m_xHandler->startElement(aName, rList);
	m_xHandler->ignorableWhitespace(OUString());
}
// -----------------------------------------------------------------------------
void AnyToXMLDocument::endElement(const rtl::OUString &aName)
{
	m_xHandler->endElement(aName);
	m_xHandler->ignorableWhitespace(OUString());
}

// -----------------------------------------------------------------------------
sal_Bool AnyToXMLDocument::writeValue(const Any& aValue, const OUString & _aElementName)
{
	// PRE: a ValueNode pointer
	// POST: write the content of the valuenode as string

	sal_Bool bRet = sal_True;
	AttributeListImpl *pList = new AttributeListImpl;
	Reference< XAttributeList > rList( (XAttributeList *) pList , UNO_QUERY );
	
	OUString aValueTag(_aElementName);
	// never write the value in the attribute list

	bool bSeq;
	Type aType = getBasicType(aValue.getValueType(), bSeq);

	if (!bSeq)
	{
		m_xHandler->startElement(aValueTag, rList);
		if (aType == getBinaryType())
		{
			// write a hex value
			OUString aHexStr;
			Sequence<sal_Int8> aBinarySeq;
			if (aValue >>= aBinarySeq)
			{
				sal_Int8 *pBinarySeq = aBinarySeq.getArray();
				sal_Int32 nLength = aBinarySeq.getLength();
				sal_Char *pHexField = new sal_Char[nLength * 2 + 1];
				sal_Char *pHex = pHexField;
				for (sal_Int32 nPos = 0;nPos < nLength;nPos++) {
					
					sal_Int8 n1 = (pBinarySeq[nPos] & 0xf0) >> 4;
					if (n1 >= 0 && n1 <= 9)
						n1 += '0';
					else
						n1 += 'a' - 10;
					
					*pHex++ = n1;
					
					sal_Int8 n2 = (pBinarySeq[nPos] & 0x0f);
					if (n2 >= 0 && n2 <= 9)
						n2 += '0';
					else
						n2 += 'a' - 10;
					
					*pHex++ = n2;
				}
				*pHex++ = 0;
				aHexStr = ASCII(pHexField);
				delete [] pHexField;
			}
			m_xHandler->characters(aHexStr);
		}
		else
		{
			// write a simple value type
			::rtl::OUString sStringRepresentation;
			try 
			{
				sStringRepresentation = toString(m_xTypeConverter, aValue);
			}
			catch (com::sun::star::script::CannotConvertException e)
			{
				CFG_TRACE_INFO("xml formatter: leave value could not be converted to a string, not writing a value");
				bRet = false;
			}
			try
			{
				if (sStringRepresentation.getLength())
					m_xHandler->characters(sStringRepresentation);
			}
			catch (com::sun::star::xml::sax::SAXException& e)
			{
				CFG_TRACE_INFO("xml formatter: caught a SAX exception");
				bRet = false;
			}
		}
		m_xHandler->endElement(aValueTag);
		m_xHandler->ignorableWhitespace(OUString());
	}
	else
	{
		// Write a Sequence
		switch(aType.getTypeClass())
		{
		case TypeClass_BOOLEAN:
			WRITE_SEQUENCE(sal_Bool);
			break;
		case staruno::TypeClass_SHORT:
			WRITE_SEQUENCE(sal_Int16);
			break;
		case staruno::TypeClass_LONG:  
			WRITE_SEQUENCE(sal_Int32);
			break;
		case staruno::TypeClass_HYPER:
			WRITE_SEQUENCE(sal_Int64);
			break;
		case staruno::TypeClass_DOUBLE:
			WRITE_SEQUENCE(double);
			break;
		case staruno::TypeClass_STRING:
			WRITE_SEQUENCE(OUString);
			break;
		default:
			bRet = false;
		}
	}

	return bRet;
}


} // namespace configmgr
#undef ASCII

