/*************************************************************************
 *
 *  $RCSfile: CFunctions.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//--------------------------------------------------------------------------
#ifndef _CONNECTIVITY_ODBC_OFUNCTIONS_HXX_
#include "odbc/OFunctions.hxx"
#endif
#ifndef _CONNECTIVITY_OTERRO_CFUNCTIONS_HXX_
#include "oterro/CFunctions.hxx"
#endif

// Implib-Definitionen fuer ODBC-DLL/shared library:

using namespace connectivity;

SQLRETURN  connectivity::oterro::AllocHandle(SQLSMALLINT HandleType,SQLHANDLE InputHandle,SQLHANDLE *	OutputHandlePtr)
{
	SQLRETURN nRet = 0;
	switch(HandleType)
	{
	case SQL_HANDLE_ENV:
		nRet = OSQLAllocEnv(OutputHandlePtr);
		break;
	case SQL_HANDLE_DBC:
		nRet = OSQLAllocConnect(InputHandle,OutputHandlePtr);
		break;
	case SQL_HANDLE_STMT:
		nRet = OSQLAllocStmt(InputHandle,OutputHandlePtr);
		break;
	case SQL_HANDLE_DESC:

		break;
	}
	return nRet;
}
// -------------------------------------------------------------------------
SQLRETURN connectivity::oterro::FreeHandle(SQLSMALLINT			HandleType,
										SQLHANDLE				Handle)
{
	switch (HandleType) 
	{
	   case SQL_HANDLE_ENV: return OSQLFreeEnv(Handle);
	   case SQL_HANDLE_DBC: return OSQLFreeConnect(Handle);
	   case SQL_HANDLE_STMT: return OSQLFreeStmt(Handle, SQL_DROP);
	   default: // return SQL_ERROR, SQLSTATE HY092 ("Invalid attribute/option identifier")
		   ;
	}
	return SQL_ERROR;
}
// -------------------------------------------------------------------------
SQLRETURN connectivity::oterro::SetConnectAttr(SQLHDBC		ConnectionHandle,
						SQLINTEGER		Attribute,
						SQLPOINTER		ValuePtr,
						SQLINTEGER		StringLength)
{
	return OSQLSetConnectOption(ConnectionHandle,Attribute,(sal_Int32)(sal_Int32*)ValuePtr);
}
// -------------------------------------------------------------------------
SQLRETURN connectivity::oterro::GetConnectAttr(SQLHDBC		ConnectionHandle,
						SQLINTEGER		Attribute,
						SQLPOINTER		ValuePtr,
						SQLINTEGER		BufferLength,
						SQLINTEGER*		StringLength)
{
	return OSQLGetConnectOption(ConnectionHandle,Attribute,ValuePtr);
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::CloseCursor(SQLHSTMT			StatementHandle)
{
	return OSQLFreeStmt(StatementHandle, SQL_CLOSE);
}
// -------------------------------------------------------------------------
SQLRETURN connectivity::oterro::SetStmtAttr(	SQLHSTMT		StatementHandle,
											SQLINTEGER		Attribute,
											SQLPOINTER		ValuePtr,
											SQLINTEGER		StringLength)
{
	return OSQLSetStmtOption(StatementHandle,Attribute,(sal_Int32)(sal_Int32*)ValuePtr);
}
// -------------------------------------------------------------------------
SQLRETURN connectivity::oterro::GetStmtAttr(	SQLHSTMT		StatementHandle,
											SQLINTEGER		Attribute,
											SQLPOINTER		ValuePtr,
											SQLINTEGER		BufferLength,
											SQLINTEGER*		StringLength)
{
	return OSQLGetStmtOption(StatementHandle,Attribute,ValuePtr);
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::ColAttribute(SQLHSTMT			StatementHandle,
						SQLUSMALLINT		ColumnNumber,
						SQLUSMALLINT		FieldIdentifier,
						SQLPOINTER			CharacterAttributePtr,
						SQLSMALLINT			BufferLength,
						SQLSMALLINT *		StringLengthPtr,
						SQLPOINTER			NumericAttributePtr)
{
	SQLUSMALLINT nNewFieldIdentifier = FieldIdentifier;
	switch(FieldIdentifier)
	{
	case SQL_DESC_COUNT:
		nNewFieldIdentifier = SQL_COLUMN_COUNT;
		break;
	case SQL_DESC_NAME:
		nNewFieldIdentifier = SQL_COLUMN_NAME;
		break;
	case SQL_DESC_NULLABLE:
		nNewFieldIdentifier = SQL_COLUMN_NULLABLE;
		break;
	case SQL_DESC_PRECISION:
	case SQL_DESC_LENGTH:
		{
			SQLCHAR *		ColumnName=NULL;
			SQLSMALLINT		BufferLength=0;
			SQLSMALLINT 	NameLengthPtr;
			SQLSMALLINT 	DataTypePtr;
			SQLSMALLINT 	DecimalDigitsPtr;
			SQLSMALLINT 	NullablePtr;
			return N3SQLDescribeCol(StatementHandle,ColumnNumber,ColumnName,      
																 BufferLength,    
																 &NameLengthPtr,   
																 &DataTypePtr,     
																 (SQLUINTEGER *)NumericAttributePtr,   
																 &DecimalDigitsPtr,
																 &NullablePtr);
		}
	case SQL_DESC_TYPE:
		{
			SQLCHAR *		ColumnName=NULL;
			SQLSMALLINT		BufferLength=0;
			SQLSMALLINT 	NameLengthPtr;
			SQLUINTEGER 	ColumnSizePtr;
			SQLSMALLINT 	DecimalDigitsPtr;
			SQLSMALLINT 	NullablePtr;
			return N3SQLDescribeCol(StatementHandle,ColumnNumber,ColumnName,      
																 BufferLength,    
																 &NameLengthPtr,   
																 (SQLSMALLINT *)NumericAttributePtr,     
																 &ColumnSizePtr,   
																 &DecimalDigitsPtr,
																 &NullablePtr);
		}		
	case SQL_DESC_SCALE:
		{
			SQLCHAR *		ColumnName=NULL;
			SQLSMALLINT		BufferLength=0;
			SQLSMALLINT 	NameLengthPtr;
			SQLSMALLINT 	DataTypePtr;
			SQLUINTEGER 	ColumnSizePtr;
			SQLSMALLINT 	NullablePtr;
			return N3SQLDescribeCol(StatementHandle,ColumnNumber,ColumnName,      
																 BufferLength,    
																 &NameLengthPtr,   
																 &DataTypePtr,     
																 &ColumnSizePtr,   
																 (SQLSMALLINT *)NumericAttributePtr,
																 &NullablePtr);
		}
	case SQL_DESC_UNNAMED:
	case SQL_DESC_BASE_COLUMN_NAME:
		{
			SQLSMALLINT 	DataTypePtr;
			SQLUINTEGER 	ColumnSizePtr;
			SQLSMALLINT 	DecimalDigitsPtr;
			SQLSMALLINT 	NullablePtr;
			return N3SQLDescribeCol(StatementHandle,ColumnNumber,(SQLCHAR *)CharacterAttributePtr,      
																 BufferLength,    
																 StringLengthPtr,   
																 &DataTypePtr,     
																 &ColumnSizePtr,   
																 &DecimalDigitsPtr,
																 &NullablePtr);
	
		}
	}
	return OSQLColAttributes(StatementHandle,ColumnNumber,nNewFieldIdentifier, CharacterAttributePtr, BufferLength, StringLengthPtr,(sal_Int32*) NumericAttributePtr);
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::FetchScroll(	SQLHSTMT			StatementHandle,
												SQLSMALLINT			FetchOrientation,
												SQLINTEGER			FetchOffset)
{
	SQLUINTEGER *     RowCountPtr = NULL;
	SQLUSMALLINT *     RowStatusArray = NULL;
	return OSQLExtendedFetch(StatementHandle,FetchOrientation,FetchOffset,RowCountPtr,RowStatusArray);
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::EndTran(	SQLSMALLINT				HandleType,
													SQLHANDLE				Handle,
													SQLSMALLINT				CompletionType)
{
	switch (HandleType) 
	{
	case SQL_HANDLE_ENV:return OSQLTransact(Handle, SQL_NULL_HDBC, CompletionType);
	case SQL_HANDLE_DBC:return OSQLTransact(SQL_NULL_HENV, Handle, CompletionType);
	default: // return SQL_ERROR, SQLSTATE HY092 ("Invalid attribute/option identifier")
		;
	}

	return SQL_ERROR;
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::GetDiagRec(	SQLSMALLINT			HandleType,
													SQLHANDLE			Handle,
													SQLSMALLINT			RecNumber,
													SQLCHAR *			Sqlstate,
													SQLINTEGER *		NativeErrorPtr,
													SQLCHAR *			MessageText,
													SQLSMALLINT			BufferLength,
													SQLSMALLINT *		TextLengthPtr)
{
	switch (HandleType) 
	{
	case SQL_HANDLE_ENV:
		return OSQLError(Handle,NULL,NULL,Sqlstate,NativeErrorPtr,MessageText,BufferLength,TextLengthPtr);
	case SQL_HANDLE_DBC:
		return OSQLError(NULL,Handle,NULL,Sqlstate,NativeErrorPtr,MessageText,BufferLength,TextLengthPtr);
	default:
		return OSQLError(NULL,NULL,Handle,Sqlstate,NativeErrorPtr,MessageText,BufferLength,TextLengthPtr);
	}
}
// -------------------------------------------------------------------------
SQLRETURN  connectivity::oterro::GetInfo(	SQLHDBC			ConnectionHandle,
													SQLUSMALLINT	InfoType,
													SQLPOINTER		InfoValuePtr,
													SQLSMALLINT		BufferLength,
													SQLSMALLINT *	StringLengthPtr)
{
	switch(InfoType)
	{
		case SQL_MAX_DRIVER_CONNECTIONS:	InfoType = SQL_ACTIVE_CONNECTIONS; break; 
		case SQL_MAX_CONCURRENT_ACTIVITIES: InfoType = SQL_ACTIVE_STATEMENTS; break; 
		case SQL_MAX_SCHEMA_NAME_LEN:		InfoType = SQL_MAX_OWNER_NAME_LEN; break; 
		case SQL_MAX_CATALOG_NAME_LEN:		InfoType = SQL_MAX_QUALIFIER_NAME_LEN; break; 
		case SQL_INTEGRITY:					InfoType = SQL_ODBC_SQL_OPT_IEF; break; 
		case SQL_SCHEMA_TERM:				InfoType = SQL_OWNER_TERM; break; 
		case SQL_SCHEMA_USAGE:				InfoType = SQL_OWNER_USAGE; break; 
		case SQL_CATALOG_LOCATION:			InfoType = SQL_QUALIFIER_LOCATION; break; 
		case SQL_CATALOG_NAME_SEPARATOR:	InfoType = SQL_QUALIFIER_NAME_SEPARATOR; break; 
		case SQL_CATALOG_TERM:				InfoType = SQL_QUALIFIER_TERM; break; 
		case SQL_CATALOG_USAGE:				InfoType = SQL_QUALIFIER_USAGE; break; 
		
		case SQL_AGGREGATE_FUNCTIONS: 
			*(sal_Int32*)InfoValuePtr = SQL_AF_ALL | SQL_AF_AVG | SQL_AF_COUNT | SQL_AF_DISTINCT | SQL_AF_MAX | SQL_AF_MIN | SQL_AF_SUM;
			break;
		case SQL_DROP_VIEW: 
			*(sal_Int32*)InfoValuePtr = SQL_DV_DROP_VIEW;
			break;

		case SQL_CREATE_VIEW:
			*(sal_Int32*)InfoValuePtr = SQL_CV_CREATE_VIEW;
			break;

		case SQL_ACTIVE_ENVIRONMENTS:
		case SQL_DROP_ASSERTION: 
		case SQL_DROP_CHARACTER_SET: 
		case SQL_ALTER_DOMAIN: 
		case SQL_DROP_COLLATION: 
		case SQL_DROP_DOMAIN: 
		case SQL_DROP_SCHEMA: 
		case SQL_ASYNC_MODE: 
		case SQL_DROP_TABLE: 
		case SQL_BATCH_ROW_COUNT: 
		case SQL_DROP_TRANSLATION: 
		case SQL_BATCH_SUPPORT: 
		
		case SQL_CATALOG_NAME: 
		case SQL_DYNAMIC_CURSOR_ATTRIBUTES1: 
		case SQL_COLLATION_SEQ: 
		case SQL_DYNAMIC_CURSOR_ATTRIBUTES2: 
		case SQL_CONVERT_INTERVAL_YEAR_MONTH: 
		case SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1: 
		case SQL_CONVERT_INTERVAL_DAY_TIME: 
		case SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2: 
		case SQL_CREATE_ASSERTION: 
		case SQL_INFO_SCHEMA_VIEWS: 
		case SQL_CREATE_CHARACTER_SET: 
		case SQL_INSERT_STATEMENT: 
		case SQL_CREATE_COLLATION: 
		case SQL_KEYSET_CURSOR_ATTRIBUTES1: 
		case SQL_CREATE_DOMAIN: 
		case SQL_KEYSET_CURSOR_ATTRIBUTES2: 
		case SQL_CREATE_SCHEMA: 
		case SQL_MAX_ASYNC_CONCURRENT_STATEMENTS: 
		case SQL_CREATE_TABLE: 
		case SQL_MAX_IDENTIFIER_LEN: 
		case SQL_CREATE_TRANSLATION: 
		case SQL_PARAM_ARRAY_ROW_COUNTS: 
		case SQL_CURSOR_SENSITIVITY: 
		case SQL_PARAM_ARRAY_SELECTS: 
		case SQL_DDL_INDEX: 
		case SQL_STATIC_CURSOR_ATTRIBUTES1: 
		case SQL_DESCRIBE_PARAMETER: 
		case SQL_STATIC_CURSOR_ATTRIBUTES2: 
		case SQL_DM_VER: 
		case SQL_XOPEN_CLI_YEAR: 
		case SQL_DRIVER_HDESC: 
			*(sal_Int32*)InfoValuePtr = 0;
			return 0;
			break;
	}
	return OSQLGetInfo(ConnectionHandle,InfoType,InfoValuePtr,BufferLength,StringLengthPtr);
}
// -------------------------------------------------------------------------
sal_Bool connectivity::oterro::LoadLibrary_OTERRO(::rtl::OUString &_rPath)
{
	static sal_Bool bLoaded = sal_False;
	static oslModule pODBCso = NULL;

	if (bLoaded)
		return TRUE;

#if defined(WIN) || defined(WNT)
	_rPath += ::rtl::OUString::createFromAscii("OT10_32.DLL");
#else
	return sal_False;
#endif

	pODBCso = osl_loadModule( _rPath.pData,SAL_LOADMODULE_NOW );
	if( !pODBCso)
		return sal_False;

	if( ( connectivity::oterro::pOtSQLAllocConnect	=	(TOSQLAllocConnect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLAllocConnect").pData )) == NULL )
		return sal_False;
	if( ( connectivity::oterro::pOtSQLAllocEnv	=	(TOSQLAllocEnv)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLAllocEnv").pData )) == NULL )
		return sal_False;
	if( ( connectivity::oterro::pOtSQLAllocStmt	=	(TOSQLAllocStmt)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLAllocStmt").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLAllocHandle	= AllocHandle;	
	
	if( ( connectivity::pODBC3SQLConnect		=	(T3SQLConnect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLConnect").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLDriverConnect =	(T3SQLDriverConnect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLDriverConnect").pData )) == NULL )
		return sal_False;

	if( ( connectivity::oterro::pOtSQLGetInfo		=	(TOSQLGetInfo)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetInfo").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLGetInfo		=	GetInfo;

	if( ( connectivity::pODBC3SQLGetTypeInfo	=	(T3SQLGetTypeInfo)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetTypeInfo").pData )) == NULL )
		return sal_False;
	
	if( ( connectivity::oterro::pOtSQLSetConnectOption =	(TOSQLSetConnectOption)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLSetConnectOption").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLSetConnectAttr	= SetConnectAttr;
	
	if( ( connectivity::oterro::pOtSQLGetConnectOption =	(TOSQLGetConnectOption)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetConnectOption").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLGetConnectAttr	= GetConnectAttr;

	if( ( connectivity::oterro::pOtSQLSetStmtOption	=	(TOSQLSetStmtOption)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLSetStmtOption").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLSetStmtAttr	= SetStmtAttr;

	if( ( connectivity::oterro::pOtSQLGetStmtOption	=	(TOSQLGetStmtOption)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetStmtOption").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLGetStmtAttr	= GetStmtAttr;

	if( ( connectivity::pODBC3SQLPrepare		=	(T3SQLPrepare)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLPrepare").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLBindParameter =	(T3SQLBindParameter)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLBindParameter").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLSetCursorName =	(T3SQLSetCursorName)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLSetCursorName").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLExecute		=	(T3SQLExecute)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLExecute").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLExecDirect	=	(T3SQLExecDirect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLExecDirect").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLDescribeParam =   (T3SQLDescribeParam)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLDescribeParam").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLNumParams		=	(T3SQLNumParams)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLNumParams").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLParamData		=	(T3SQLParamData)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLParamData").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLPutData		=	(T3SQLPutData)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLPutData").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLRowCount		=	(T3SQLRowCount)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLRowCount").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLNumResultCols =	(T3SQLNumResultCols)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLNumResultCols").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLDescribeCol	=	(T3SQLDescribeCol)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLDescribeCol").pData )) == NULL )
		return sal_False;

	if( ( connectivity::oterro::pOtSQLColAttributes =	(TOSQLColAttributes)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLColAttributes").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLColAttribute = ColAttribute;

	if( ( connectivity::pODBC3SQLBindCol		=	(T3SQLBindCol)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLBindCol").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLFetch			=	(T3SQLFetch)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLFetch").pData )) == NULL )
		return sal_False;

	if( ( connectivity::oterro::pOtSQLExtendedFetch	=	(TOSQLExtendedFetch)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLExtendedFetch").pData )) == NULL )
		return sal_False;					
	connectivity::pODBC3SQLFetchScroll	= FetchScroll;

	if( ( connectivity::pODBC3SQLGetData		=	(T3SQLGetData)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetData").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLSetPos		=	(T3SQLSetPos)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLSetPos").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLMoreResults	=	(T3SQLMoreResults)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLMoreResults").pData )) == NULL )
		return sal_False;

	if( ( connectivity::oterro::pOtSQLError	=	(TOSQLError)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLError").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLGetDiagRec	=	GetDiagRec;

	if( ( connectivity::pODBC3SQLColumnPrivileges = (T3SQLColumnPrivileges)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLColumnPrivileges").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLColumns		=	(T3SQLColumns)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLColumns").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLForeignKeys	=	(T3SQLForeignKeys)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLForeignKeys").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLPrimaryKeys	=	(T3SQLPrimaryKeys)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLPrimaryKeys").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLProcedureColumns =  (T3SQLProcedureColumns)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLProcedureColumns").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLProcedures	=	(T3SQLProcedures)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLProcedures").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLSpecialColumns =  (T3SQLSpecialColumns)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLSpecialColumns").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLStatistics	=   (T3SQLStatistics)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLStatistics").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLTablePrivileges =	(T3SQLTablePrivileges)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLTablePrivileges").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLTables		=   (T3SQLTables)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLTables").pData )) == NULL )
		return sal_False;					
	if( ( connectivity::pODBC3SQLFreeStmt		=	(T3SQLFreeStmt)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return sal_False;
	
	connectivity::pODBC3SQLCloseCursor	= CloseCursor;

	if( ( connectivity::pODBC3SQLCancel		=	(T3SQLCancel)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLCancel").pData )) == NULL )
		return sal_False;

	if( ( oterro::pOtSQLTransact =	(TOSQLTransact)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLTransact").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLEndTran		= EndTran;

	if( ( connectivity::pODBC3SQLDisconnect	=	(T3SQLDisconnect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLDisconnect").pData )) == NULL )
		return sal_False;
	
	if( ( connectivity::oterro::pOtSQLFreeConnect	=	(TOSQLFreeConnect)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLFreeConnect").pData )) == NULL )
		return sal_False;
	if( ( connectivity::oterro::pOtSQLFreeEnv	=	(TOSQLFreeEnv)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLFreeEnv").pData )) == NULL )
		return sal_False;
	if( ( connectivity::oterro::pOtSQLFreeStmt	=	(TOSQLFreeStmt)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return sal_False;
	connectivity::pODBC3SQLFreeHandle	= FreeHandle;

	if( ( connectivity::pODBC3SQLGetCursorName	=	(T3SQLGetCursorName)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLGetCursorName").pData )) == NULL )
		return sal_False;
	if( ( connectivity::pODBC3SQLNativeSql	=	(T3SQLNativeSql)osl_getSymbol(pODBCso, ::rtl::OUString::createFromAscii("SQLNativeSql").pData )) == NULL )
		return sal_False;

	return sal_True;
}
// -------------------------------------------------------------------------

connectivity::oterro::TOSQLAllocConnect connectivity::oterro::pOtSQLAllocConnect;
connectivity::oterro::TOSQLAllocEnv		connectivity::oterro::pOtSQLAllocEnv;
connectivity::oterro::TOSQLAllocStmt	connectivity::oterro::pOtSQLAllocStmt;

connectivity::oterro::TOSQLGetConnectOption	connectivity::oterro::pOtSQLGetConnectOption;
connectivity::oterro::TOSQLSetConnectOption	connectivity::oterro::pOtSQLSetConnectOption;

connectivity::oterro::TOSQLGetStmtOption connectivity::oterro::pOtSQLGetStmtOption;
connectivity::oterro::TOSQLSetStmtOption connectivity::oterro::pOtSQLSetStmtOption;

connectivity::oterro::TOSQLFreeConnect	connectivity::oterro::pOtSQLFreeConnect;
connectivity::oterro::TOSQLFreeEnv		connectivity::oterro::pOtSQLFreeEnv;
connectivity::oterro::TOSQLFreeStmt		connectivity::oterro::pOtSQLFreeStmt;

connectivity::oterro::TOSQLColAttributes connectivity::oterro::pOtSQLColAttributes;
connectivity::oterro::TOSQLExtendedFetch connectivity::oterro::pOtSQLExtendedFetch;
connectivity::oterro::TOSQLTransact		connectivity::oterro::pOtSQLTransact;

connectivity::oterro::TOSQLError connectivity::oterro::pOtSQLError;
connectivity::oterro::TOSQLGetInfo connectivity::oterro::pOtSQLGetInfo;

