/*************************************************************************
 *
 *  $RCSfile: CFunctions.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CONNECTIVITY_OTERRO_CFUNCTIONS_HXX_
#define _CONNECTIVITY_OTERRO_CFUNCTIONS_HXX_

namespace connectivity
{
	namespace oterro
	{
		
		SQLRETURN  AllocHandle(SQLSMALLINT HandleType,SQLHANDLE InputHandle,SQLHANDLE *	OutputHandlePtr);
		SQLRETURN SetConnectAttr(SQLHDBC		ConnectionHandle,
													SQLINTEGER		Attribute,
													SQLPOINTER		ValuePtr,
													SQLINTEGER		StringLength);
		SQLRETURN GetConnectAttr(SQLHDBC		ConnectionHandle,
													SQLINTEGER		Attribute,
													SQLPOINTER		ValuePtr,
													SQLINTEGER		BufferLength,
													SQLINTEGER*		StringLength);

		SQLRETURN SetStmtAttr(	SQLHSTMT		StatementHandle,
													SQLINTEGER		Attribute,
													SQLPOINTER		ValuePtr,
													SQLINTEGER		StringLength);
		SQLRETURN GetStmtAttr(	SQLHSTMT		StatementHandle,
													SQLINTEGER		Attribute,
													SQLPOINTER		ValuePtr,
													SQLINTEGER		BufferLength,
													SQLINTEGER*		StringLength);
		SQLRETURN  FreeHandle(SQLSMALLINT			HandleType,
							SQLHANDLE				Handle);

		SQLRETURN  ColAttribute(SQLHSTMT			StatementHandle,
													SQLUSMALLINT		ColumnNumber,
													SQLUSMALLINT		FieldIdentifier,
													SQLPOINTER			CharacterAttributePtr,
													SQLSMALLINT			BufferLength,
													SQLSMALLINT *		StringLengthPtr,
													SQLPOINTER			NumericAttributePtr);

		SQLRETURN  FetchScroll(	SQLHSTMT			StatementHandle,
													SQLSMALLINT			FetchOrientation,
													SQLINTEGER			FetchOffset);
		SQLRETURN  EndTran(	SQLSMALLINT				HandleType,
													SQLHANDLE				Handle,
													SQLSMALLINT				CompletionType);

		SQLRETURN  CloseCursor(SQLHSTMT			StatementHandle);
		SQLRETURN  GetDiagRec(	SQLSMALLINT			HandleType,
													SQLHANDLE			Handle,
													SQLSMALLINT			RecNumber,
													SQLCHAR *			Sqlstate,
													SQLINTEGER *		NativeErrorPtr,
													SQLCHAR *			MessageText,
													SQLSMALLINT			BufferLength,
													SQLSMALLINT *		TextLengthPtr);

		SQLRETURN  GetInfo(	SQLHDBC			ConnectionHandle,
													SQLUSMALLINT	InfoType,
													SQLPOINTER		InfoValuePtr,
													SQLSMALLINT		BufferLength,
													SQLSMALLINT *	StringLengthPtr);

		sal_Bool LoadLibrary_OTERRO(::rtl::OUString &_rPath);

		typedef RETCODE  (SQL_API  *TOSQLAllocConnect) (HENV henv , HDBC FAR * phdbc);
		extern TOSQLAllocConnect pOtSQLAllocConnect;
		#define OSQLAllocConnect(a,b) (*pOtSQLAllocConnect)(a,b)

		typedef RETCODE  (SQL_API  *TOSQLAllocEnv) (HENV FAR * phenv);
		extern TOSQLAllocEnv pOtSQLAllocEnv;
		#define OSQLAllocEnv(a) (*pOtSQLAllocEnv)(a)

		typedef RETCODE  (SQL_API  *TOSQLAllocStmt) (HDBC hdbc , HSTMT FAR * phstmt);
		extern TOSQLAllocStmt pOtSQLAllocStmt;
		#define OSQLAllocStmt(a,b) (*pOtSQLAllocStmt)(a,b)

		typedef RETCODE  (SQL_API  *TOSQLGetConnectOption) (HDBC hdbc , UWORD fOption , PTR pvParam);
		extern TOSQLGetConnectOption pOtSQLGetConnectOption;
		#define OSQLGetConnectOption(a,b,c) (*pOtSQLGetConnectOption)(a,b,c)

		typedef RETCODE  (SQL_API  *TOSQLSetConnectOption) (HDBC hdbc , UWORD fOption , UDWORD vParam);
		extern TOSQLSetConnectOption pOtSQLSetConnectOption;
		#define OSQLSetConnectOption(a,b,c) (*pOtSQLSetConnectOption)(a,b,c)

		typedef RETCODE  (SQL_API  *TOSQLGetStmtOption) (HSTMT hstmt , UWORD fOption , PTR pvParam);
		extern TOSQLGetStmtOption pOtSQLGetStmtOption;
		#define OSQLGetStmtOption(a,b,c) (*pOtSQLGetStmtOption)(a,b,c)

		typedef RETCODE  (SQL_API  *TOSQLSetStmtOption) (HSTMT hstmt , UWORD fOption , UDWORD vParam);
		extern TOSQLSetStmtOption pOtSQLSetStmtOption;
		#define OSQLSetStmtOption(a,b,c) (*pOtSQLSetStmtOption)(a,b,c)

		typedef RETCODE  (SQL_API  *TOSQLFreeConnect) (HDBC hdbc);
		extern TOSQLFreeConnect pOtSQLFreeConnect;
		#define OSQLFreeConnect(a) (*pOtSQLFreeConnect)(a)

		typedef RETCODE  (SQL_API  *TOSQLFreeEnv) (HENV henv);
		extern TOSQLFreeEnv pOtSQLFreeEnv;
		#define OSQLFreeEnv(a) (*pOtSQLFreeEnv)(a)

		typedef RETCODE  (SQL_API  *TOSQLFreeStmt) (HSTMT hstmt , UWORD fOption);
		extern TOSQLFreeStmt pOtSQLFreeStmt;
		#define OSQLFreeStmt(a,b) (*pOtSQLFreeStmt)(a,b)

		typedef RETCODE  (SQL_API  *TOSQLColAttributes) (HSTMT hstmt , UWORD icol , UWORD fDescType , PTR rgbDesc , SWORD cbDescMax , SWORD FAR * pcbDesc , SDWORD FAR * pfDesc);
		extern TOSQLColAttributes pOtSQLColAttributes;
		#define OSQLColAttributes(a,b,c,d,e,f,g) (*pOtSQLColAttributes)(a,b,c,d,e,f,g)

		typedef RETCODE  (SQL_API  *TOSQLExtendedFetch) (HSTMT hstmt , UWORD fFetchType , SDWORD irow , UDWORD FAR * pcrow , UWORD FAR * rgfRowStatus);
		extern TOSQLExtendedFetch pOtSQLExtendedFetch;
		#define OSQLExtendedFetch(a,b,c,d,e) (*pOtSQLExtendedFetch)(a,b,c,d,e)

		typedef RETCODE  (SQL_API  *TOSQLTransact) (HENV henv , HDBC hdbc , UWORD fType);
		extern TOSQLTransact pOtSQLTransact;
		#define OSQLTransact(a,b,c) (*pOtSQLTransact)(a,b,c)

		typedef RETCODE  (SQL_API  *TOSQLError) (HENV henv , HDBC hdbc , HSTMT hstmt , UCHAR FAR * szSqlState , SDWORD FAR * pfNativeError , UCHAR FAR * szErrorMsg , SWORD cbErrorMsgMax , SWORD FAR * pcbErrorMsg);
		extern TOSQLError pOtSQLError;
		#define OSQLError(a,b,c,d,e,f,g,h) (*pOtSQLError)(a,b,c,d,e,f,g,h)

		typedef RETCODE  (SQL_API  *TOSQLGetInfo) (HDBC hdbc , UWORD fInfoType , PTR rgbInfoValue , SWORD cbInfoValueMax , SWORD FAR * pcbInfoValue);
		extern TOSQLGetInfo pOtSQLGetInfo;
		#define OSQLGetInfo(a,b,c,d,e) (*pOtSQLGetInfo)(a,b,c,d,e)
	}
}

#endif // _CONNECTIVITY_OTERRO_CFUNCTIONS_HXX_

