/*************************************************************************
 *
 *  $RCSfile: VCatalog.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONNECTIVITY_SDBCX_CATALOG_HXX_
#define _CONNECTIVITY_SDBCX_CATALOG_HXX_

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

#ifndef _COM_SUN_STAR_SDBCX_XTABLESSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XTablesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XVIEWSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XViewsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XUSERSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XUsersSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XGROUPSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XGroupsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XCONNECTION_HPP_
#include <com/sun/star/sdbc/XConnection.hpp>
#endif
#ifndef _UNOTOOLS_PROPERTY_ARRAY_HELPER_HXX_
#include <unotools/proparrhlp.hxx>
#endif
#ifndef _CPPUHELPER_COMPBASE5_HXX_
#include <cppuhelper/compbase5.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _CONNECTIVITY_COMMONTOOLS_HXX_
#include "CommonTools.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_COLLECTION_HXX_
#include "sdbcx/VCollection.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_TABLE_HXX_
#include "sdbcx/VTable.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_VIEW_HXX_
#include "sdbcx/VView.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_GROUP_HXX_
#include "sdbcx/VGroup.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_USER_HXX_
#include "sdbcx/VUser.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_COLUMN_HXX_
#include "sdbcx/VColumn.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_KEY_HXX_
#include "sdbcx/VKey.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_INDEX_HXX_
#include "sdbcx/VIndex.hxx"
#endif
#ifndef _CONNECTIVITY_OSUBCOMPONENT_HXX_
#include "OSubComponent.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_IREFRESHABLE_HXX_
#include "sdbcx/IRefreshable.hxx"
#endif

namespace connectivity
{
	namespace sdbcx
	{
		namespace starsdbc	= ::com::sun::star::sdbc;
		namespace starsdbcx	= ::com::sun::star::sdbcx;
		namespace staruno	= ::com::sun::star::uno;
		namespace starcnt	= ::com::sun::star::container;
		namespace starlang	= ::com::sun::star::lang;

		typedef ::cppu::WeakComponentImplHelper5< starsdbcx::XTablesSupplier,
												  starsdbcx::XViewsSupplier,
												  starsdbcx::XUsersSupplier,
												  starsdbcx::XGroupsSupplier,
												  starlang::XServiceInfo> OCatalog_BASE;

		
		class OCatalog :	public OCatalog_BASE,
							public IRefreshableGroups,
							public IRefreshableUsers,
							public connectivity::OSubComponent<OCatalog>
		{
			friend class connectivity::OSubComponent<OCatalog>;
		protected:

			::osl::Mutex	m_aMutex;

			OCollection*		m_pTables;
			OCollection*		m_pViews;
			OCollection*		m_pGroups;
			OCollection*		m_pUsers;

		public:
			DECLARE_CTY_ACQUIRE( OCatalog_BASE);

			OCatalog(const staruno::Reference< starsdbc::XConnection> &_xConnection);
			virtual ~OCatalog();

			DECLARE_SERVICE_INFO();

			virtual void refreshTables()	= 0;
			virtual void refreshViews()		= 0;
			// ::cppu::OComponentHelper
			virtual void SAL_CALL disposing(void);
			// XInterface
			virtual staruno::Any SAL_CALL queryInterface( const staruno::Type & rType ) throw(staruno::RuntimeException)
			{
				return 	OCatalog_BASE::queryInterface(rType);
			}
			void SAL_CALL release() throw(staruno::RuntimeException);
			// XTablesSupplier
			virtual staruno::Reference< starcnt::XNameAccess > SAL_CALL getTables(  ) throw(staruno::RuntimeException);
			// XViewsSupplier
			virtual staruno::Reference< starcnt::XNameAccess > SAL_CALL getViews(  ) throw(staruno::RuntimeException);
			// XUsersSupplier
			virtual staruno::Reference< starcnt::XNameAccess > SAL_CALL getUsers(  ) throw(staruno::RuntimeException);
			// XGroupsSupplier
			virtual staruno::Reference< starcnt::XNameAccess > SAL_CALL getGroups(  ) throw(staruno::RuntimeException);

		};
	}
}

#endif // _CONNECTIVITY_SDBCX_CATALOG_HXX_

