/*************************************************************************
 *
 *  $RCSfile: VTable.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CONNECTIVITY_SDBCX_TABLE_HXX_
#define _CONNECTIVITY_SDBCX_TABLE_HXX_

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

#ifndef _COM_SUN_STAR_SDBCX_XDATADESCRIPTORFACTORY_HPP_
#include <com/sun/star/sdbcx/XDataDescriptorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XCOLUMNSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XINDEXESSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XIndexesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XKEYSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XKeysSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XRENAME_HPP_
#include <com/sun/star/sdbcx/XRename.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XALTERTABLE_HPP_
#include <com/sun/star/sdbcx/XAlterTable.hpp>
#endif
#ifndef _UNOTOOLS_PROPERTY_ARRAY_HELPER_HXX_
#include <unotools/proparrhlp.hxx>
#endif
#ifndef _CPPUHELPER_COMPBASE8_HXX_
#include <cppuhelper/compbase8.hxx>
#endif
#ifndef _CONNECTIVITY_COMMONTOOLS_HXX_
#include "CommonTools.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_COLLECTION_HXX_
#include "sdbcx/VCollection.hxx"
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _CONNECTIVITY_SDBCX_IREFRESHABLE_HXX_
#include "sdbcx/IRefreshable.hxx"
#endif
#ifndef _CONNECTIVITY_SDBCX_DESCRIPTOR_HXX_
#include "sdbcx/VDescriptor.hxx"
#endif

namespace connectivity
{
	namespace sdbcx
	{
		namespace starsdbc		= ::com::sun::star::sdbc;
		namespace starsdbcx		= ::com::sun::star::sdbcx;
		namespace staruno		= ::com::sun::star::uno;
		namespace starbeans		= ::com::sun::star::beans;
		namespace starcontainer	= ::com::sun::star::container;
		namespace starlang		= ::com::sun::star::lang;

		typedef ::cppu::WeakComponentImplHelper8< starsdbcx::XDataDescriptorFactory,
												  starsdbcx::XColumnsSupplier,
												  starsdbcx::XIndexesSupplier,
												  starsdbcx::XKeysSupplier,
												  starsdbcx::XRename,
												  starsdbcx::XAlterTable,
												  starcontainer::XNamed,
												  starlang::XServiceInfo> OTable_BASE;

		
		class OTable :	public OBaseMutex,
						public OTable_BASE,
						public IRefreshableColumns,
						public ::utl::OPropertyArrayUsageHelper<OTable>,
						public ODescriptor
		{
		protected:
			::rtl::OUString m_CatalogName;	
			::rtl::OUString m_SchemaName;	
			::rtl::OUString m_Description;	
			::rtl::OUString m_Type;			

			OCollection*	m_pIndexes;
			OCollection*	m_pKeys;
			OCollection*	m_pColumns;

			using OTable_BASE::rBHelper;
			// OPropertyArrayUsageHelper
			virtual ::cppu::IPropertyArrayHelper* createArrayHelper( ) const;
			// OPropertySetHelper
			virtual ::cppu::IPropertyArrayHelper & SAL_CALL getInfoHelper();
		public:
			DECLARE_CTY_DEFAULTS( OTable_BASE);

			OTable();
			OTable( const ::rtl::OUString& _Name,			
					const ::rtl::OUString& _Type,
					const ::rtl::OUString& _Description = ::rtl::OUString(),
					const ::rtl::OUString& _SchemaName = ::rtl::OUString(),
					const ::rtl::OUString& _CatalogName = ::rtl::OUString());

			virtual ~OTable()
			{
				delete m_pIndexes;
				delete m_pKeys;
				delete m_pColumns;
			}

			DECLARE_SERVICE_INFO();
			//XInterface
			virtual staruno::Any SAL_CALL queryInterface( const staruno::Type & rType ) throw(staruno::RuntimeException);
			//XTypeProvider
			virtual staruno::Sequence< staruno::Type > SAL_CALL getTypes(  ) throw(staruno::RuntimeException);

			// ODescriptor
			virtual void construct();

			virtual void refreshKeys()		= 0;
			virtual void refreshIndexes()	= 0;

			// ::cppu::OComponentHelper
			virtual void SAL_CALL disposing(void);
			// XPropertySet
			virtual staruno::Reference< starbeans::XPropertySetInfo > SAL_CALL getPropertySetInfo(  ) throw(staruno::RuntimeException)
			{
				return ::cppu::OPropertySetHelper::createPropertySetInfo(getInfoHelper());
			}

			// XDataDescriptorFactory
			virtual staruno::Reference< starbeans::XPropertySet > SAL_CALL createDataDescriptor( void ) throw(staruno::RuntimeException);
			// XColumnsSupplier
			virtual staruno::Reference< starcontainer::XNameAccess > SAL_CALL getColumns(  ) throw(staruno::RuntimeException);
			// XIndexesSupplier
			virtual staruno::Reference< starcontainer::XNameAccess > SAL_CALL getIndexes(  ) throw(staruno::RuntimeException);
			// XKeysSupplier
			virtual staruno::Reference< starcontainer::XIndexAccess > SAL_CALL getKeys(  ) throw(staruno::RuntimeException);
			// XRename
			virtual void SAL_CALL rename( const ::rtl::OUString& newName ) throw(starsdbc::SQLException, starcontainer::ElementExistException, staruno::RuntimeException);
			// XAlterTable
			virtual void SAL_CALL alterColumnByName( const ::rtl::OUString& colName, const staruno::Reference< starbeans::XPropertySet >& descriptor ) throw(starsdbc::SQLException, starcontainer::NoSuchElementException, staruno::RuntimeException);
			virtual void SAL_CALL alterColumnByIndex( sal_Int32 index, const staruno::Reference< starbeans::XPropertySet >& descriptor ) throw(starsdbc::SQLException, ::com::sun::star::lang::IndexOutOfBoundsException, staruno::RuntimeException);

			// XNamed
			virtual ::rtl::OUString SAL_CALL getName(  ) throw(staruno::RuntimeException)
			{
				return m_SchemaName + ::rtl::OUString::createFromAscii(".") + m_Name;
			}
			virtual void SAL_CALL setName( const ::rtl::OUString& aName ) throw(staruno::RuntimeException)
			{}
		};
	}
}

#endif // _CONNECTIVITY_SDBCX_TABLE_HXX_

