/*************************************************************************
 *
 *  $RCSfile: sqlscan.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CONNECTIVITY_SQLSCAN_HXX
#define _CONNECTIVITY_SQLSCAN_HXX

#include <stdarg.h>

#ifndef _DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _STRING_HXX //autogen wg. String
#include <tools/string.hxx>
#endif

namespace connectivity
{
	class OParseContext;
	//==========================================================================
	//= OSQLScanner
	//==========================================================================
	/** Scanner for SQL92
	*/
	class OSQLScanner
	{		
		OParseContext*	m_pContext;					// context for parse, knows all international stuff
		ByteString		m_sStatement;			    // statement to parse
		String			m_sErrorMessage;		   
		
		xub_StrLen		m_nCurrentPos;             // next position to read from the statement
		sal_Bool		m_bInternational;		   // do we have a statement which may uses 
		sal_Int32		m_nRule;				   // rule to be set	

	public:
		OSQLScanner();
		~OSQLScanner();

		virtual int SQLyygetc(void);
		virtual void SQLyyerror(char *fmt);
		virtual void output(int) { DBG_ERROR("Internal error in sdblex.l: output not possible"); }
		virtual void ECHO(void) { DBG_ERROR("Internal error in sdblex.l: ECHO not possible"); }
		virtual int getInternationalTokenID(const char* sToken) const;
		
		// setting the new information before scanning
		void prepareScan(const String & rNewStatement, OParseContext* pContext, sal_Bool bInternational);
		const String& getErrorMessage() const {return m_sErrorMessage;}

		int SQLlex();
		// set this as scanner for flex
		void setScanner(sal_Bool _bNull=sal_False);
		// rules settings
		void SetRule(int nRule) {m_nRule = nRule;}
		int	GetCurrentRule() const;
		int	GetGERRule() const;
		int	GetENGRule() const;
		int	GetSQLRule() const;
		int	GetDATERule() const;
		int	GetSTRINGRule() const;
	};
}

#endif
