/*************************************************************************
 *
 *  $RCSfile: ModuleContext.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CONNECTIVITY_MODULECONTEXT_HXX_
#include "ModuleContext.hxx"
#endif
#ifndef _CONNECTIVITY_PROPERTYIDS_HXX_
#include "propertyids.hxx"
#endif

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

namespace connectivity
{
// -------------------------------------------------------------------------
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_QUERYTIMEOUT			, "QueryTimeOut");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_MAXFIELDSIZE			, "MaxFieldSize");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_MAXROWS				, "MaxRows");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CURSORNAME			, "CursorName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_RESULTSETCONCURRENCY	, "ResultSetConcurrency");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_RESULTSETTYPE			, "ResultSetType");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FETCHDIRECTION		, "FetchDirection");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FETCHSIZE				, "FetchSize");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ESCAPEPROCESSING		, "EscapeProcessing");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_USEBOOKMARKS			, "UseBookmarks");

IMPLEMENT_CONSTASCII_USTRING(PROPERTY_NAME,					"Name");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TYPE,					"Type");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TYPENAME,				"TypeName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PRECISION,			"Precision");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_SCALE,				"Scale");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISNULLABLE,			"IsNullable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISAUTOINCREMENT,		"IsAutoIncrement");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISROWVERSION,			"IsRowVersion");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DESCRIPTION,			"Description");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DEFAULTVALUE,			"DefaultValue");

IMPLEMENT_CONSTASCII_USTRING(PROPERTY_REFERENCEDTABLE,		"ReferencedTable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_UPDATERULE,			"UpdateRule");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DELETERULE,			"DeleteRule");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CATALOG,				"Catalog");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISUNIQUE,				"IsUnique");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISPRIMARYKEYINDEX,	"IsPrimaryKeyIndex");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISCLUSTERED,			"IsClustered");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISASCENDING,			"IsAscending");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_SCHEMANAME,			"SchemaName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CATALOGNAME,			"CatalogName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_COMMAND,				"Command");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CHECKOPTION,			"CheckOption");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PASSWORD,				"Password");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_REFERENCEDCOLUMN,		"ReferencedColumn");

IMPLEMENT_CONSTASCII_USTRING(STAT_INVALID_INDEX,			"Invalid descriptor index");

IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FUNCTION,				"Function");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TABLENAME,			"TableName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_REALNAME,				"RealName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DBASEPRECISIONCHANGED,"DbasePrecisionChanged");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISCURRENCY,			"IsCurrency");

IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISBOOKMARKABLE,		"IsBookmarkable");

// --------------------------------------------------------------------------------
sal_Int32		ModuleContext::m_nCount		= 0;
::osl::Mutex	ModuleContext::m_aMutex;
// --------------------------------------------------------------------------------
void ModuleContext::AddRef()
{
	::osl::MutexGuard aGuard(m_aMutex);
	++m_nCount;
}
// --------------------------------------------------------------------------------
void ModuleContext::ReleaseRef()
{
	::osl::MutexGuard aGuard(m_aMutex);
	--m_nCount;
}
// --------------------------------------------------------------------------------
::rtl::OUString ModuleContext::ReadResource(sal_Int16 _nId)
{
	OSL_ENSHURE(m_nCount,"ModuleContext::ReadResource: No AddRef called before!");
	return ::rtl::OUString();
}
}

