/*************************************************************************
 *
 *  $RCSfile: pseudo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:14:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef _OSL_INTERLOCK_H_
#include <osl/interlck.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _TYPELIB_TYPEDESCRIPTION_H_
#include <typelib/typedescription.h>
#endif
#ifndef _UNO_DISPATCHER_H_
#include <uno/dispatcher.h>
#endif
#ifndef _UNO_ENVIRONMENT_H_
#include <uno/environment.h>
#endif
#ifndef _UNO_MAPPING_H_
#include <uno/mapping.h>
#endif
#ifndef _UNO_LBNAMES_H_
#include <uno/lbnames.h>
#endif

using namespace rtl;


namespace pseudo_uno
{

//==================================================================================================
struct pseudo_Mapping : public uno_Mapping
{
	oslInterlockedCount		nRef;
	
	uno_Environment *		pFrom;
	uno_Environment *		pTo;
	
	pseudo_Mapping( uno_Environment * pFrom_, uno_Environment * pTo_ );
	~pseudo_Mapping();
};

//==== a uno pseudo proxy =============================================================================
struct pseudo_unoInterfaceProxy : public uno_Interface
{
	oslInterlockedCount					nRef;
	pseudo_Mapping *					pPseudoMapping;
	
	// mapping information
	uno_Interface *						pUnoI; // wrapped interface
	typelib_InterfaceTypeDescription *	pTypeDescr;
	OUString							oid;
	
	// ctor
	inline pseudo_unoInterfaceProxy( pseudo_Mapping * pPseudoMapping_,
									 uno_Interface * pUnoI_,
									 typelib_InterfaceTypeDescription * pTypeDescr_,
									 const OUString & rOId_ );
};
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_unoInterfaceProxy_dispatch(
	uno_Interface * pUnoI, 
	const typelib_TypeDescription * pMemberType,
	void * pReturn,
	void * pArgs[],
	uno_Any ** ppException )
{
	pseudo_unoInterfaceProxy * pThis = static_cast< pseudo_unoInterfaceProxy * >( pUnoI );
	(*pThis->pUnoI->pDispatcher)( pThis->pUnoI, pMemberType, pReturn, pArgs, ppException );
}

//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_unoInterfaceProxy_free( uno_Environment * pEnv, void * pProxy )
{
	pseudo_unoInterfaceProxy * pThis =
		static_cast< pseudo_unoInterfaceProxy * >(
			reinterpret_cast< uno_Interface * >( pProxy ) );
	OSL_ASSERT( pEnv == pThis->pPseudoMapping->pTo );
	
	(*pThis->pPseudoMapping->pFrom->revokeInterface)( pThis->pPseudoMapping->pFrom, pThis->pUnoI );
	(*pThis->pUnoI->release)( pThis->pUnoI );
	typelib_typedescription_release( (typelib_TypeDescription *)pThis->pTypeDescr );
	(*pThis->pPseudoMapping->release)( pThis->pPseudoMapping );
	
#ifdef DEBUG
	*(int *)pProxy = 0xdeadbabe;
#endif
	delete pThis;
}
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_unoInterfaceProxy_acquire( uno_Interface * pUnoI )
{
	if (1 == osl_incrementInterlockedCount( &static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->nRef ))
	{
		// rebirth of proxy zombie
		// register at uno env
		void * pThis = static_cast< uno_Interface * >( pUnoI );
		(*static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->pPseudoMapping->pTo->registerProxyInterface)(
			static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->pPseudoMapping->pTo,
			&pThis, pseudo_unoInterfaceProxy_free,
			static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->oid.pData,
			static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->pTypeDescr );
		OSL_ASSERT( pThis == static_cast< uno_Interface * >( pUnoI ) );
	}
}
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_unoInterfaceProxy_release( uno_Interface * pUnoI )
{
	if (! osl_decrementInterlockedCount( & static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->nRef ))
	{
		// revoke from uno env on last release
		(*static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->pPseudoMapping->pTo->revokeInterface)(
			static_cast< pseudo_unoInterfaceProxy * >( pUnoI )->pPseudoMapping->pTo, pUnoI );
	}
}
//__________________________________________________________________________________________________
inline pseudo_unoInterfaceProxy::pseudo_unoInterfaceProxy(
	pseudo_Mapping * pPseudoMapping_, uno_Interface * pUnoI_,
	typelib_InterfaceTypeDescription * pTypeDescr_, const OUString & rOId_ )
	: nRef( 1 )
	, pPseudoMapping( pPseudoMapping_ )
	, pUnoI( pUnoI_ )
	, pTypeDescr( pTypeDescr_ )
	, oid( rOId_ )
{
	(*pPseudoMapping->acquire)( pPseudoMapping );
	typelib_typedescription_acquire( (typelib_TypeDescription *)pTypeDescr );
	(*pPseudoMapping->pFrom->registerInterface)(
		pPseudoMapping->pFrom, reinterpret_cast< void ** >( &pUnoI ), oid.pData, pTypeDescr );
	(*pUnoI->acquire)( pUnoI );
	
	// uno_Interface
	uno_Interface::acquire = pseudo_unoInterfaceProxy_acquire;
	uno_Interface::release = pseudo_unoInterfaceProxy_release;
	uno_Interface::pDispatcher = pseudo_unoInterfaceProxy_dispatch;
}

//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_Mapping_mapInterface(
	uno_Mapping * pMapping, void ** ppOut,
	void * pUnoI, typelib_InterfaceTypeDescription * pTypeDescr )
{
	OSL_ASSERT( ppOut && pTypeDescr );
	if (*ppOut)
	{
		(*reinterpret_cast< uno_Interface * >( *ppOut )->release)(
			reinterpret_cast< uno_Interface * >( *ppOut ) );
		*ppOut = 0;
	}
	if (pUnoI && pTypeDescr)
	{
		// get object id of uno interface to be wrapped
		rtl_uString * pOId = 0;
		(*static_cast< pseudo_Mapping * >( pMapping )->pFrom->getObjectIdentifier)(
			static_cast< pseudo_Mapping * >( pMapping )->pFrom, &pOId, pUnoI );
		OSL_ASSERT( pOId );
		
		if (pOId)
		{
			// try to get any known interface from target environment
			(*static_cast< pseudo_Mapping * >( pMapping )->pTo->getRegisteredInterface)(
				static_cast< pseudo_Mapping * >( pMapping )->pTo, ppOut, pOId, pTypeDescr );
			if (! *ppOut) // no existing interface, register new proxy interface
			{
				// try to publish a new proxy (ref count initially 1)
				void * pProxy = new pseudo_unoInterfaceProxy(
					static_cast< pseudo_Mapping * >( pMapping ),
					reinterpret_cast< uno_Interface * >( pUnoI ), pTypeDescr, pOId );
				
				// proxy may be exchanged during registration
				(*static_cast< pseudo_Mapping * >( pMapping )->pTo->registerProxyInterface)(
					static_cast< pseudo_Mapping * >( pMapping )->pTo,
					&pProxy, pseudo_unoInterfaceProxy_free, pOId, pTypeDescr );
				
				*ppOut = pProxy;
			}
			rtl_uString_release( pOId );
		}
	}
}
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_Mapping_free( uno_Mapping * pMapping )
{
	delete static_cast< pseudo_Mapping * >( pMapping );
}
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_Mapping_acquire( uno_Mapping * pMapping )
{
	if (1 == osl_incrementInterlockedCount( & static_cast< pseudo_Mapping * >( pMapping )->nRef ))
	{
		OUString aMappingPurpose( RTL_CONSTASCII_USTRINGPARAM("pseudo") );
		uno_registerMapping( &pMapping,
							 pseudo_Mapping_free,
							 static_cast< pseudo_Mapping * >( pMapping )->pFrom,
							 static_cast< pseudo_Mapping * >( pMapping )->pTo,
							 aMappingPurpose.pData );
	}
}
//--------------------------------------------------------------------------------------------------
static void SAL_CALL pseudo_Mapping_release( uno_Mapping * pMapping )
{
	if (! osl_decrementInterlockedCount( & static_cast< pseudo_Mapping * >( pMapping )->nRef ))
	{
		uno_revokeMapping( pMapping );
	}
}

//__________________________________________________________________________________________________
pseudo_Mapping::pseudo_Mapping( uno_Environment * pFrom_, uno_Environment * pTo_ )
	: nRef( 1 )
	, pFrom( pFrom_ )
	, pTo( pTo_ )
{
	(*pFrom->acquire)( pFrom );
	(*pTo->acquire)( pTo );
	//
	uno_Mapping::acquire = pseudo_Mapping_acquire;
	uno_Mapping::release = pseudo_Mapping_release;
	uno_Mapping::mapInterface = pseudo_Mapping_mapInterface;
}
//__________________________________________________________________________________________________
pseudo_Mapping::~pseudo_Mapping()
{
	(*pTo->release)( pTo );
	(*pFrom->release)( pFrom );
}

}

//##################################################################################################
extern "C" SAL_DLLEXPORT void SAL_CALL uno_initEnvironment( uno_Environment * pUnoEnv )
{
	OSL_ENSHURE( sal_False, "### no impl: unexpected call!" );
}
//##################################################################################################
extern "C" SAL_DLLEXPORT void SAL_CALL uno_ext_getMapping(
	uno_Mapping ** ppMapping, uno_Environment * pFrom, uno_Environment * pTo )
{
	OSL_ASSERT( ppMapping && pFrom && pTo );
	if (ppMapping && pFrom && pTo)
	{
		uno_Mapping * pMapping = 0;
		
		if (0 == rtl_ustr_ascii_compare( pFrom->pTypeName->buffer, UNO_LB_UNO ) &&
			0 == rtl_ustr_ascii_compare( pTo->pTypeName->buffer, UNO_LB_UNO ))
		{
			OUString aMappingPurpose( RTL_CONSTASCII_USTRINGPARAM("pseudo") );
			pMapping = new pseudo_uno::pseudo_Mapping( pFrom, pTo ); // ref count is initially 1
			uno_registerMapping( &pMapping, pseudo_uno::pseudo_Mapping_free,
								 pFrom, pTo, aMappingPurpose.pData );
		}
		
		if (*ppMapping)
			(*(*ppMapping)->release)( *ppMapping );
		*ppMapping = pMapping;
	}
}


