/*************************************************************************
 *
 *  $RCSfile: CIndex.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:15:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef DBACCESS_INDEX_HXX_
#include "CIndex.hxx"
#endif
#ifndef DBACCESS_INDEXCOLUMNS_HXX_
#include "CIndexColumns.hxx"
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XRESULTSET_HPP_
#include <com/sun/star/sdbc/XResultSet.hpp>
#endif
#ifndef _DBA_CORE_TABLE_HXX_
#include "table.hxx"
#endif
#ifndef _DBASHARED_STRINGCONSTANTS_HRC_
#include "stringconstants.hrc"
#endif

using namespace dbaccess;
using namespace connectivity;
using namespace connectivity::sdbcx;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
//	using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::lang;
// -------------------------------------------------------------------------
ODBIndex::ODBIndex(	ODBTable* _pTable) : connectivity::sdbcx::OIndex(sal_True)
				 , m_pTable(_pTable)
{
	construct();
	::std::vector< ::rtl::OUString> aVector;
	m_pColumns	= new OIndexColumns(this,m_aMutex,aVector);
}
// -------------------------------------------------------------------------
ODBIndex::ODBIndex(	ODBTable* _pTable,
				const ::rtl::OUString& _Name,
				const ::rtl::OUString& _Catalog,
				sal_Bool _isUnique,
				sal_Bool _isPrimaryKeyIndex,
				sal_Bool _isClustered
				) : connectivity::sdbcx::OIndex(_Name,
								  _Catalog,
								  _isUnique,
								  _isPrimaryKeyIndex,
								  _isClustered,sal_True)
				,m_pTable(_pTable)
{
	construct();
	refreshColumns();
}
// -------------------------------------------------------------------------

void ODBIndex::refreshColumns()
{
	if(!m_pTable)
		return;

	::rtl::OUString aSchema,aTable;
	m_pTable->getPropertyValue(PROPERTY_SCHEMANAME)	>>= aSchema;
	m_pTable->getPropertyValue(PROPERTY_NAME)		>>= aTable;

	::std::vector< ::rtl::OUString> aVector;
	Reference< XResultSet > xResult = m_pTable->getConnection()->getMetaData()->getIndexInfo(
		m_pTable->getPropertyValue(PROPERTY_CATALOGNAME),
		aSchema,aTable,sal_False,sal_False);

	if(xResult.is())
	{
        Reference< XRow > xRow(xResult,UNO_QUERY);
		::rtl::OUString aColName;
		while(xResult->next())
		{
			if(xRow->getString(6) == m_Name)
			{
				aColName = xRow->getString(9);
				if(!xRow->wasNull())
					aVector.push_back(aColName);
			}
		}
	}
	if(m_pColumns)
		delete m_pColumns;
	m_pColumns	= new OIndexColumns(this,m_aMutex,aVector);
}
