/*************************************************************************
 *
 *  $RCSfile: RowSetValue.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:15:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include "RowSetValue.hxx"
#endif

using namespace dbaccess;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::util;

ORowSetValue& ORowSetValue::operator=(const ORowSetValue& _rRH)
{
	if(&_rRH == this)
		return *this;

	free();

	m_bBound	= _rRH.m_bBound;
	m_bNull		= _rRH.m_bNull;
	m_eTypeKind	= _rRH.m_eTypeKind;
	if(!m_bNull)
	{
		switch(_rRH.m_eTypeKind)
		{
		case DataType::CHAR:
		case DataType::VARCHAR:
			m_aValue.m_pString = _rRH.m_aValue.m_pString;
			rtl_uString_acquire(m_aValue.m_pString);
			break;
		case DataType::DOUBLE:
		case DataType::FLOAT:
		case DataType::REAL:
		case DataType::DECIMAL:
		case DataType::NUMERIC:
			m_aValue.m_pValue	= new double(*(double*)_rRH.m_aValue.m_pValue);
			break;
		case DataType::DATE:
			m_aValue.m_pValue	= new Date(*(Date*)_rRH.m_aValue.m_pValue);
			break;
		case DataType::TIME:
			m_aValue.m_pValue	= new Time(*(Time*)_rRH.m_aValue.m_pValue);
			break;
		case DataType::TIMESTAMP:
			m_aValue.m_pValue	= new DateTime(*(DateTime*)_rRH.m_aValue.m_pValue);
			break;
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:				 
			m_aValue.m_pValue	= new Sequence<sal_Int8>(*(Sequence<sal_Int8>*)_rRH.m_aValue.m_pValue);
			break;
		case DataType::BIT:
			m_aValue.m_bBool	= _rRH.m_aValue.m_bBool;
			break;
		case DataType::TINYINT:
		case DataType::SMALLINT:
		case DataType::INTEGER:
			m_aValue.m_nInt32 = _rRH.m_aValue.m_nInt32;
			break;
		case DataType::LONGVARCHAR:
			m_aValue.m_nInt32 = _rRH.m_aValue.m_nInt32;
			break;
		default:
			OSL_ASSERT("Invalid type!");
		}
	}

	return *this;
}
// -------------------------------------------------------------------------

ORowSetValue& ORowSetValue::operator=(const Date& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new Date(_rRH);
		m_eTypeKind = ::com::sun::star::sdbc::DataType::DATE;
	}
	else
		*(Date*)m_aValue.m_pValue = _rRH;

	m_bNull = sal_False;
	return *this;
}
// -------------------------------------------------------------------------
ORowSetValue& ORowSetValue::operator=(const Time& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new Time(_rRH);
		m_eTypeKind = ::com::sun::star::sdbc::DataType::TIME;
	}
	else
		*(Time*)m_aValue.m_pValue = _rRH;

	m_bNull = sal_False;
	return *this;
}
// -------------------------------------------------------------------------
ORowSetValue& ORowSetValue::operator=(const DateTime& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new DateTime(_rRH);
		m_eTypeKind = ::com::sun::star::sdbc::DataType::TIMESTAMP;
	}
	else
		*(DateTime*)m_aValue.m_pValue = _rRH;

	m_bNull = sal_False;

	return *this;
}
// -------------------------------------------------------------------------

ORowSetValue& ORowSetValue::operator=(const ::rtl::OUString& _rRH)
{
	free();
	m_bNull = sal_False;

	m_aValue.m_pString = _rRH.pData;
	rtl_uString_acquire(m_aValue.m_pString);
	m_eTypeKind = DataType::VARCHAR;

	return *this;
}
// -------------------------------------------------------------------------

ORowSetValue& ORowSetValue::operator=(const double& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new double(_rRH);
		m_eTypeKind = ::com::sun::star::sdbc::DataType::DOUBLE;
	}
	else
		*(double*)m_aValue.m_pValue = _rRH;

	m_bNull = sal_False;
	return *this;
}
// -------------------------------------------------------------------------

ORowSetValue& ORowSetValue::operator=(const sal_Int32& _rRH)
{
	m_bNull = sal_False;
	m_aValue.m_nInt32 = _rRH;
	m_eTypeKind = ::com::sun::star::sdbc::DataType::INTEGER;
	return *this;
}
// -------------------------------------------------------------------------

ORowSetValue& ORowSetValue::operator=(const sal_Bool _rRH)
{
	m_bNull = sal_False;
	m_aValue.m_bBool = _rRH;
	m_eTypeKind = ::com::sun::star::sdbc::DataType::BIT;
	return *this;
}
// -------------------------------------------------------------------------
ORowSetValue& ORowSetValue::operator=(const sal_Int64& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new sal_Int64(_rRH);
		m_eTypeKind = ::com::sun::star::sdbc::DataType::DOUBLE;
	}
	else
		*(sal_Int64*)m_aValue.m_pValue = _rRH;
	m_bNull = sal_False;
	
	return *this;
}
// -------------------------------------------------------------------------
ORowSetValue& ORowSetValue::operator=(const ::com::sun::star::uno::Sequence<sal_Int8>& _rRH)
{
	if(m_bNull)
	{
		m_aValue.m_pValue = new ::com::sun::star::uno::Sequence<sal_Int8>(_rRH);
		
	}
	else
		*(::com::sun::star::uno::Sequence<sal_Int8>*)m_aValue.m_pValue = _rRH;

	m_bNull = sal_False;
	
	return *this;
}
// -------------------------------------------------------------------------
ORowSetValue& ORowSetValue::operator=(const ::com::sun::star::uno::Any& _rAny)
{
	m_eTypeKind = DataType::OBJECT;
	if(m_bNull)
		m_aValue.m_pValue = new Any(_rAny);
	else
		*(Any*)m_aValue.m_pValue = _rAny;

	m_bNull = sal_False;
	
	return *this;
}
// -------------------------------------------------------------------------

sal_Bool operator==(const Date& _rLH,const Date& _rRH)
{
	return _rLH.Day == _rRH.Day && _rLH.Month == _rRH.Month && _rLH.Year == _rRH.Year;
}
// -------------------------------------------------------------------------

sal_Bool operator==(const Time& _rLH,const Time& _rRH)
{
	return _rLH.Minutes == _rRH.Minutes && _rLH.Hours == _rRH.Hours && _rLH.Seconds == _rRH.Seconds && _rLH.HundredthSeconds == _rRH.HundredthSeconds;
}
// -------------------------------------------------------------------------

sal_Bool operator==(const DateTime& _rLH,const DateTime& _rRH)
{
	return _rLH.Day == _rRH.Day && _rLH.Month == _rRH.Month && _rLH.Year == _rRH.Year &&
		_rLH.Minutes == _rRH.Minutes && _rLH.Hours == _rRH.Hours && _rLH.Seconds == _rRH.Seconds && _rLH.HundredthSeconds == _rRH.HundredthSeconds;
}
// -------------------------------------------------------------------------

ORowSetValue::operator==(const ORowSetValue& _rRH) const
{
	if(m_eTypeKind != _rRH.m_eTypeKind)
		return sal_False;

	sal_Bool bRet = sal_False;
	switch(m_eTypeKind)
	{
		case DataType::VARCHAR:
		case DataType::CHAR:
		{
			::rtl::OUString aVal1(m_aValue.m_pString);
			::rtl::OUString aVal2(_rRH.m_aValue.m_pString);
			bRet = aVal1 == aVal2;
			break;
		}
		case DataType::DOUBLE:
		case DataType::FLOAT:
		case DataType::REAL:
		case DataType::DECIMAL:
		case DataType::NUMERIC:
			bRet = *(double*)m_aValue.m_pValue == *(double*)_rRH.m_aValue.m_pValue;
			break;
		case DataType::TINYINT:
		case DataType::SMALLINT:
		case DataType::INTEGER:
			bRet = m_aValue.m_nInt32 == _rRH.m_aValue.m_nInt32;
			break;
		case DataType::BIT:
			bRet = m_aValue.m_bBool == _rRH.m_aValue.m_bBool;
			break;
		case DataType::DATE:
			bRet = *(Date*)m_aValue.m_pValue == *(Date*)_rRH.m_aValue.m_pValue;
			break;
		case DataType::TIME:
			bRet = *(Time*)m_aValue.m_pValue == *(Time*)_rRH.m_aValue.m_pValue;
			break;
		case DataType::TIMESTAMP:
			bRet = *(DateTime*)m_aValue.m_pValue == *(DateTime*)_rRH.m_aValue.m_pValue;
			break;
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
			bRet = sal_False;
			break;
	}
	return bRet;
}
// -------------------------------------------------------------------------
Any ORowSetValue::makeAny() const
{
	Any rValue;
	switch(getTypeKind())
	{
		case ::com::sun::star::sdbc::DataType::CHAR:
		case ::com::sun::star::sdbc::DataType::VARCHAR:
			rValue <<= (::rtl::OUString)m_aValue.m_pString;
			break;
		case ::com::sun::star::sdbc::DataType::DOUBLE:
		case ::com::sun::star::sdbc::DataType::FLOAT:
		case ::com::sun::star::sdbc::DataType::REAL:
		case ::com::sun::star::sdbc::DataType::DECIMAL:
		case ::com::sun::star::sdbc::DataType::NUMERIC:
			rValue <<= *(double*)m_aValue.m_pValue;
			break;
		case ::com::sun::star::sdbc::DataType::DATE:
			rValue <<= *(Date*)m_aValue.m_pValue;
			break;
		case ::com::sun::star::sdbc::DataType::TIME:
			rValue <<= *(Time*)m_aValue.m_pValue;
			break;
		case ::com::sun::star::sdbc::DataType::TIMESTAMP:
			rValue <<= *(DateTime*)m_aValue.m_pValue;
			break;
		case ::com::sun::star::sdbc::DataType::BINARY:
		case ::com::sun::star::sdbc::DataType::VARBINARY:
		case ::com::sun::star::sdbc::DataType::LONGVARBINARY:
			rValue <<= *(::com::sun::star::uno::Sequence<sal_Int8>*)m_aValue.m_pValue;
			break;
		case ::com::sun::star::sdbc::DataType::OBJECT:
			rValue = getAny();
			break;
	}
	return rValue;
}
/*------------------------------------------------------------------------

	$Log: RowSetValue.cxx,v $
	Revision 1.1.1.1  2000/09/19 00:15:38  hr
	initial import
	
	Revision 1.2  2000/09/18 14:52:47  willem.vandorp
	OpenOffice header added.
	
	Revision 1.1  2000/09/01 15:25:09  oj
	rowset addon
	
	Revision 1.0 25.07.2000 16:52:15  oj
------------------------------------------------------------------------*/

