/*************************************************************************
 *
 *  $RCSfile: registryhelper.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:15:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DBA_CORE_REGISTRYHELPER_HXX_
#define _DBA_CORE_REGISTRYHELPER_HXX_

#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif

//==========================================================================
//= ORegistryLevelEnumeration - enumeration access for all sub keys of a
//=								a specified registry key
//==========================================================================
class ORegistryLevelEnumeration
{
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > >	m_aElements;
	sal_Int32								m_nCurPos;

public:
	ORegistryLevelEnumeration(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > & _rxLevel);

	sal_Bool	hasMoreElements() const;
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > 	nextElement();

private:
	void implSeekNext();
};

//==========================================================================
//= helper functions for safe reading writing of single key values
//==========================================================================

sal_Bool readValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, ::rtl::OUString& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool readValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, ::com::sun::star::uno::Sequence< ::rtl::OUString >& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool readValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Int32& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool readValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Int16& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool readValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Bool& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool writeValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, const ::rtl::OUString& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool writeValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, const ::com::sun::star::uno::Sequence< ::rtl::OUString >& _rValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool writeValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Int32 _nValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool writeValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Int16 _nValue) throw (::com::sun::star::uno::RuntimeException);
sal_Bool writeValue(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey, const ::rtl::OUString& _rKeyName, sal_Bool _nValue) throw (::com::sun::star::uno::RuntimeException);

sal_Bool writeOrDelete(
	const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey,
	const ::rtl::OUString& _rKeyName,
	const ::rtl::OUString& _rValue);
sal_Bool writeOrDelete(
	const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey,
	const ::rtl::OUString& _rKeyName,
	sal_Bool _bValue);
sal_Bool writeOrDelete(
	const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey,
	const ::rtl::OUString& _rKeyName,
	sal_Int32 _nValue);
sal_Bool writeOrDelete(
	const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey,
	const ::rtl::OUString& _rKeyName,
	sal_Int16 _nValue);

void deleteKey(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxParent, const ::rtl::OUString& _rKeyName) throw (::com::sun::star::uno::RuntimeException);
sal_Bool openKey(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& /* [in] */ _rxParent,
				 const ::rtl::OUString& /* [in] */ _rKeyName,
				 ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& /* [out] */ _rxKey,
				 sal_Bool /* [in] */ _bCreateIfNeccessary);

//==========================================================================
//= additional helper functions
//==========================================================================
/** get a name for a to-be-created key under the given parent key.
	@param		_rxParentKey		the parent key whereunder the new key is to be created
	@param		_rBase				the base of the new name, the new name will be generated by appending a
									number to the base until the name got is unique
	@return							a name suggestion for the new key or en empty string, if no free name could be found
*/
::rtl::OUString getUniqueKeyName(::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxParentKey, ::rtl::OUString& _rBase);

/** get the name of the given registry key relative to it's parent. (it's more than a getKeyName).
	@param		_rxKey		the registry key which's relative nae you want to know
	@return					the requested name
*/
::rtl::OUString getShortKeyName(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey);

/** get the names of the children of the given registry key relative to it's parent. (it's more than a getKeyNames).
	@param		_rxKey		the registry key which's childrens names you're interested in
	@return					the requested name sequence
*/
::com::sun::star::uno::Sequence< ::rtl::OUString > getShortChildKeyNames(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >& _rxKey);

#endif // _DBA_CORE_REGISTRYHELPER_HXX_

