/*************************************************************************
 *
 *  $RCSfile: stream.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <propset.hxx>

#ifndef __STARDIV_UNO_IO_STREAM_HXX__
#include <stardiv/uno/io/stream.hxx>
#endif

#include <svtools/svtoxstr.hxx>

#ifndef __STARDIV_UNO_LANG_INIT_HXX__
#include <stardiv/uno/lang/init.hxx>
#endif

#ifndef __STARDIV_UNO_LANG_FACTORY_HXX__
#include <stardiv/uno/lang/factory.hxx>
#endif



class OAddressBookInputStream : public UsrObject, public XInputStream, public XInitialization
{
public:
	SMART_UNO_DECLARATION( OAddressBookInputStream, UsrObject );
	static XInterfaceRef createInstance( const XMultiServiceFactoryRef& xFact ) {
		return *new OAddressBookInputStream( xFact ); }

	OAddressBookInputStream( const XMultiServiceFactoryRef& xMgr ) : 
		m_xMgr( xMgr ), m_pStream( 0 ) {}
	~OAddressBookInputStream() { delete m_pStream; }
	
	static XIdlClassRef getStaticIdlClass();
	Sequence<XIdlClassRef>	getIdlClasses();
	virtual BOOL queryInterface( Uik aUik, XInterfaceRef & rOut );

	virtual INT32 readBytes(Sequence< BYTE >& aData, INT32 nBytesToRead)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) ) 
		{
			return m_xInput->readBytes( aData, nBytesToRead );
		}
	
    virtual INT32 readSomeBytes(Sequence< BYTE >& aData, INT32 nMaxBytesToRead)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) )
		{
			return m_xInput->readSomeBytes( aData, nMaxBytesToRead );
		}
	
    virtual void  skipBytes(INT32 nBytesToSkip)
		THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) )
		{
			m_xInput->skipBytes( nBytesToSkip );
		}
	
    virtual INT32 available(void)
		THROWS( (NotConnectedException, UsrSystemException) )
		{
			return m_xInput->available();
		}
	
    virtual void  closeInput(void)
		THROWS( (NotConnectedException, UsrSystemException) )
		{
			m_xInput->closeInput();
		}
	
	virtual void initialize( const Sequence<UsrAny>& rArgs );

private:
	XInputStreamRef m_xInput;
	SvFileStream*  m_pStream;
	XMultiServiceFactoryRef m_xMgr;
};
