/*************************************************************************
 *
 *  $RCSfile: fieldwin.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _BIB_FIELDWIN_HXX
#include "fieldwin.hxx"
#endif

#ifndef _COM_SUN_STAR_SDB_COMMANDTYPE_HPP_
#include <com/sun/star/sdb/CommandType.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBCX_XCOLUMNSSUPPLIER_HPP_
#include <com/sun/star/sdbcx/XColumnsSupplier.hpp>
#endif

//#ifndef _COM_SUN_STAR_FORM_XBOUNDCOMPONENT_HPP_
//#include <com/sun/star/form/XBoundComponent.hpp>
//#endif
//#ifndef _COM_SUN_STAR_FORM_XLOADLISTENER_HPP_
//#include <com/sun/star/form/XLoadListener.hpp>
//#endif
//#ifndef _COM_SUN_STAR_FORM_NAVIGATIONBARMODE_HPP_
//#include <com/sun/star/form/NavigationBarMode.hpp>
//#endif
//#ifndef _COM_SUN_STAR_FORM_LISTSOURCETYPE_HPP_
//#include <com/sun/star/form/ListSourceType.hpp>
//#endif
//#ifndef _COM_SUN_STAR_FORM_TABULATORCYCLE_HPP_
//#include <com/sun/star/form/TabulatorCycle.hpp>
//#endif
//#ifndef _COM_SUN_STAR_FORM_XBOUNDCONTROL_HPP_
//#include <com/sun/star/form/XBoundControl.hpp>
//#endif

#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif
#ifndef _SVX_FMEXCH_HXX
#include "bibexch.hxx"
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif

#ifndef _SV_DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif

#include "bibprop.hrc"
#include "bibresid.hxx"
#include "bibprop.hrc"
#include "bibmod.hxx"
#include "bib.hrc"

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::form;
using namespace ::com::sun::star::container;

#define C2U(cChar) OUString::createFromAscii(cChar)

const long STD_WIN_POS_X = 50;
const long STD_WIN_POS_Y = 50;

const long STD_WIN_SIZE_X = 120;
const long STD_WIN_SIZE_Y = 150;

const long MIN_WIN_SIZE_X = 50;
const long MIN_WIN_SIZE_Y = 50;

const long LISTBOX_BORDER = 2;

//==================================================================
// class BibFieldListBox
//==================================================================

//------------------------------------------------------------------------------
BibFieldListBox::BibFieldListBox( BibFieldWin* pParent )
	:SvTreeListBox( pParent, WB_HASBUTTONS|WB_BORDER )
	,pTabWin( pParent )
{
	String aString;
	for( sal_uInt16 i=1; i<11; i++ )
	{
		aString = String::CreateFromAscii("Feld ");
		aString += String(i);
		InsertEntry( aString );
	}
}

//------------------------------------------------------------------------------
BibFieldListBox::~BibFieldListBox()
{
}

//------------------------------------------------------------------------------
void BibFieldListBox::Command(const CommandEvent& rEvt)
{
	switch (rEvt.GetCommand())
	{
		case COMMAND_STARTDRAG:
		{
			EndSelection();
			Pointer aMovePtr( POINTER_COPYDATA ),
					aCopyPtr( POINTER_COPYDATA ),
					aLinkPtr( POINTER_LINKDATA );

			String aCopyData = pTabWin->GetDatabaseName();
			aCopyData	+= char(11);
			aCopyData	+= pTabWin->GetObjectName();
			aCopyData	+= char(11);
			aCopyData	+= String(pTabWin->GetObjectType());
			aCopyData	+= char(11);

			SvLBoxEntry* pFirstSelected = FirstSelected();
			if( pFirstSelected )
				aCopyData += GetEntryText( pFirstSelected );

			BibFieldExchRef xFieldExch = new BibFieldExch(aCopyData);
			DragManager::ExecuteDrag( xFieldExch, DRAG_LINKABLE | DRAG_COPYABLE );
		}	break;
		default:
			Window::Command( rEvt );
	}
}


//========================================================================
// class BibFieldWin
//========================================================================

//-----------------------------------------------------------------------
BibFieldWin::BibFieldWin(Window* pParent)
			:FloatingWindow(pParent, WinBits(WB_STDMODELESS|WB_SIZEABLE))
			,nObjectType(0)
{
	SetBackgroundBrush( Brush( Color( COL_GRAY ) ) );
	pListBox = new BibFieldListBox( this );
	pListBox->Show();
	SetSizePixel(Size(STD_WIN_SIZE_X,STD_WIN_SIZE_Y));
}

//-----------------------------------------------------------------------
BibFieldWin::~BibFieldWin()
{
	delete pListBox;
}

//-----------------------------------------------------------------------
void BibFieldWin::Resize()
{
	Point aPos = GetPosPixel();
	Size aSize = GetOutputSizePixel();

	//////////////////////////////////////////////////////////////////////

	// Groesse der form::component::ListBox anpassen
	Point aLBPos = Point( LISTBOX_BORDER, LISTBOX_BORDER );
	Size aLBSize( aSize );
	aLBSize.Width() -= (2*LISTBOX_BORDER);
	aLBSize.Height() -= (2*LISTBOX_BORDER);

	pListBox->SetPosSizePixel( aLBPos, aLBSize );
}

//-----------------------------------------------------------------------
void BibFieldWin::Update(const uno::Reference< XForm > & xForm)
{
	// form::component::ListBox loeschen
	pListBox->Clear();
	String aTitle(BibResId(RID_BIB_STR_FIELDSELECTION));
	SetText(aTitle);

	uno::Reference< sdbcx::XColumnsSupplier >  xSupplyCols(xForm, UNO_QUERY);
	uno::Reference< XNameAccess >  xFields;
	if (xSupplyCols.is())
		xFields = uno::Reference< XNameAccess > (xSupplyCols->getColumns(), UNO_QUERY);
	DBG_ASSERT(xFields.is(), "BibFieldWin::Update : invalid row set (has no columns) !");
	uno::Sequence<rtl::OUString> aNames = xFields->getElementNames();
	sal_Int32 nFieldsCount = aNames.getLength();
	const rtl::OUString* pNames = aNames.getConstArray();

	for (sal_Int32 i=0; i<nFieldsCount; i++)
		pListBox->InsertEntry(pNames[i]);

	uno::Reference< XPropertySet >  xSet(xForm, UNO_QUERY);

	// Prefix setzen
	String  aPrefix;
	String  aPrefixes( BibResId(RID_BIB_STR_TABWIN_PREFIX) );


	// Datenbank und Tabellennamen setzen
	aObjectName		= String(*(OUString*)xSet->getPropertyValue(C2U("Command")).getValue());
	aDatabaseName	= String(*(OUString*)xSet->getPropertyValue(C2U("DataSourceName")).getValue());
	cppu::enum2int( nObjectType,  xSet->getPropertyValue(C2U("CommandType")));
	sal_Bool bEscapeProcessing = *(sal_Bool*)xSet->getPropertyValue(C2U("UseEscapeProcessing")).getValue();
	switch( nObjectType )
	{
		case sdb::CommandType::TABLE:
			aPrefix = aPrefixes.GetToken(0);
			break;
		case sdb::CommandType::QUERY:
			aPrefix = aPrefixes.GetToken(1);
			break;
		default:
			aPrefix = aPrefixes.GetToken(bEscapeProcessing ? 2 : 3);
			break;
	}

	// Titel setzen
	aTitle.AppendAscii(" ");
	aTitle += aPrefix;
	aTitle.AppendAscii(" ");
	aTitle += aObjectName;
	SetText( aTitle );
}



