/*************************************************************************
 *
 *  $RCSfile: registry.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_IO_XMARKABLESTREAM_HPP_
#include <com/sun/star/io/XMarkableStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif

#include <svtools/iniprop.hxx>
#include <svtools/iniman.hxx>

#ifndef _SV_LSTBOX_HXX //autogen wg. form::component::ListBox
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_EDIT_HXX //autogen wg. Edit
#include <vcl/edit.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_ASSERT
#include <tools/debug.hxx>
#endif
#ifndef SVTOOLS_URIHELPER_HXX
#include <svtools/urihelper.hxx>
#endif

#include "registry.hxx"
#include "bibmod.hxx"

using namespace rtl;
using namespace ::com::sun::star;
using namespace beans;
using namespace uno;
using namespace lang;
using namespace registry;

#define C2U(cChar) OUString::createFromAscii(cChar)


BibRegistryKey::BibRegistryKey(const Reference< XRegistryKey > & aRegKey)
{
	xRegistryKey=aRegKey;
}

Type BibRegistryKey::giveClassType(RegistryValueType eValueType)
{
	Type aType;
	switch(eValueType)
	{
		case	RegistryValueType_LONG:
			aType = ::getCppuType((const sal_Int32*)0);
		break;
		case	RegistryValueType_STRING:
			aType = ::getCppuType((const OUString*)0);
		break;
		case	RegistryValueType_LONGLIST:
			aType = ::getCppuType((Sequence<sal_Int32>*)0);
		break;
		case	RegistryValueType_STRINGLIST:
			aType = ::getCppuType((Sequence<rtl::OUString>*)0);
		break;
		case	RegistryValueType_BINARY:
			aType = ::getCppuType((Reference<io::XPersistObject>*)0);
		break;
		default:
			aType = ::getVoidCppuType();
		break;
	}

	return aType;
}
RegistryValueType BibRegistryKey::giveValueType(const Any& rValue)
{
	const Type aValueType = rValue.getValueType();
	TypeClass eType = aValueType.getTypeClass();

	RegistryValueType eValueType;

	switch(eType)
	{
		case	TypeClass_LONG:
					eValueType=RegistryValueType_LONG;
					break;

		case	TypeClass_STRING:
					eValueType=RegistryValueType_STRING;
					break;

		case	TypeClass_SEQUENCE:
					if( aValueType == ::getCppuType((Sequence<rtl::OUString>*)0))

					{
						eValueType=RegistryValueType_STRINGLIST;
					}
					else if( aValueType == ::getCppuType((Sequence<sal_Int32>*)0))

					{
						eValueType=RegistryValueType_LONGLIST;
					}

					break;

		case	TypeClass_INTERFACE:
					if( aValueType == ::getCppuType((Reference<io::XPersistObject>*)0))
					{
						eValueType=RegistryValueType_BINARY;
					}
					else
					{
						eValueType=RegistryValueType_NOT_DEFINED;
					}
					break;

		default:
					eValueType=RegistryValueType_NOT_DEFINED;
					break;
	}

	return eValueType;
}

// XRegistryKey
rtl::OUString BibRegistryKey::getKeyName() throw( RuntimeException )
{
	return xRegistryKey->getKeyName();
}
sal_Bool BibRegistryKey::isReadOnly() throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->isReadOnly();
}
sal_Bool BibRegistryKey::isValid() throw( RuntimeException )
{
	return xRegistryKey->isValid();
}
RegistryKeyType	BibRegistryKey::getKeyType(const rtl::OUString& rKeyName) throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->getKeyType(rKeyName);
}
RegistryValueType BibRegistryKey::getValueType() throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->getValueType();
}
sal_Int32 BibRegistryKey::getLongValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getLongValue();
}
void BibRegistryKey::setLongValue(sal_Int32 value) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setLongValue(value);
}
Sequence< sal_Int32 > BibRegistryKey::getLongListValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getLongListValue();
}
void BibRegistryKey::setLongListValue(const Sequence< sal_Int32 >& seqValue) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setLongListValue(seqValue);
}
rtl::OUString BibRegistryKey::getAsciiValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getAsciiValue();
}
void BibRegistryKey::setAsciiValue(const rtl::OUString& value) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setAsciiValue(value);
}
Sequence< rtl::OUString > BibRegistryKey::getAsciiListValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getAsciiListValue();
}
void BibRegistryKey::setAsciiListValue(const Sequence< rtl::OUString >& seqValue) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setAsciiListValue(seqValue);
}
rtl::OUString	BibRegistryKey::getStringValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getStringValue();
}
void BibRegistryKey::setStringValue(const rtl::OUString& value) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setStringValue(value);
}
Sequence< rtl::OUString > BibRegistryKey::getStringListValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getStringListValue();
}
void BibRegistryKey::setStringListValue(const Sequence< rtl::OUString >& seqValue) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setStringListValue(seqValue);
}
Sequence< sal_Int8 >	BibRegistryKey::getBinaryValue() throw( registry::InvalidRegistryException, registry::InvalidValueException, RuntimeException )
{
	return xRegistryKey->getBinaryValue();
}
void BibRegistryKey::setBinaryValue(const Sequence< sal_Int8 >& value) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->setBinaryValue(value);
}
Reference< XRegistryKey > 	BibRegistryKey::openKey(const rtl::OUString& aKeyName) throw( registry::InvalidRegistryException, RuntimeException )
{
	Reference< XRegistryKey > 	aRegKey=xRegistryKey->openKey(aKeyName);
	if(aRegKey.is())
		return new BibRegistryKey(aRegKey);
	else
		return aRegKey;
}
Reference< XRegistryKey > 	BibRegistryKey::createKey(const rtl::OUString& aKeyName) throw( registry::InvalidRegistryException, RuntimeException )
{
	return new BibRegistryKey(xRegistryKey->createKey(aKeyName));
}
void BibRegistryKey::closeKey() throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->closeKey();
}
void BibRegistryKey::deleteKey(const rtl::OUString& rKeyName) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->deleteKey(rKeyName);
}

Sequence< Reference< XRegistryKey >  > BibRegistryKey::openKeys() throw( registry::InvalidRegistryException, RuntimeException )
{
	Sequence< Reference< XRegistryKey >  > aSeqKeys=xRegistryKey->openKeys();
	const Reference< XRegistryKey > * pRegKey=aSeqKeys.getConstArray();
	sal_Int32 nCount=aSeqKeys.getLength();

	Sequence< Reference< XRegistryKey >  > aSeqRegKeys(nCount);
	Reference< XRegistryKey >  * pBibKey = aSeqRegKeys.getArray();


	for(sal_Int32 i=0; i< nCount; i++)
	{
		*pBibKey=new BibRegistryKey( pRegKey[i]);
	}

	return aSeqRegKeys;
}

Sequence< rtl::OUString > BibRegistryKey::getKeyNames() throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->getKeyNames();
}
sal_Bool BibRegistryKey::createLink(const rtl::OUString& aLinkName, const rtl::OUString& aLinkTarget) throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->createLink(aLinkName,aLinkTarget);
}
void BibRegistryKey::deleteLink(const rtl::OUString& rLinkName) throw( registry::InvalidRegistryException, RuntimeException )
{
	xRegistryKey->deleteLink(rLinkName);
}
rtl::OUString	BibRegistryKey::getLinkTarget(const rtl::OUString& rLinkName) throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->getLinkTarget(rLinkName);
}
rtl::OUString	BibRegistryKey::getResolvedName(const rtl::OUString& aKeyName) throw( registry::InvalidRegistryException, RuntimeException )
{
	return xRegistryKey->getResolvedName(aKeyName);
}

Reference< XPropertySetInfo >  BibRegistryKey::getPropertySetInfo() throw( RuntimeException )
{
	return new BibRegistryKeyInfo((XRegistryKey*) this);
}

void BibRegistryKey::setPropertyValue(const rtl::OUString& aName, const Any& aValue) throw( UnknownPropertyException, beans::PropertyVetoException, IllegalArgumentException, WrappedTargetException, RuntimeException )
{
	RegistryValueType eValueType=giveValueType(aValue);

	Reference< XRegistryKey >  aRegKey=xRegistryKey->openKey(aName);

	if(!aRegKey.is())
		aRegKey=xRegistryKey->createKey(aName);

	const Type aValueType = aValue.getValueType();
	TypeClass eType = aValueType.getTypeClass();

	switch(eType)
	{
		case	TypeClass_LONG:
		aRegKey->setLongValue(*(sal_Int32*)aValue.getValue());
		break;

		case	TypeClass_STRING:
		aRegKey->setStringValue(*(OUString*)aValue.getValue());
		break;

		case	TypeClass_SEQUENCE:
		if( aValueType == ::getCppuType((Sequence<rtl::OUString>*)0))
		{
			Sequence<rtl::OUString>	StringSeq = *(Sequence<rtl::OUString>*)aValue.getValue();
			aRegKey->setStringListValue(StringSeq);
		}
		else if( aValueType == ::getCppuType((Sequence<sal_Int32>*)0))
		{
			Sequence<sal_Int32>  LongSeq = *(Sequence<sal_Int32>*)aValue.getValue();
			aRegKey->setLongListValue(LongSeq);
		}
		break;
		case	TypeClass_INTERFACE:
		if( aValueType == ::getCppuType((Reference<io::XPersistObject>*)0))
		{
			Reference< io::XPersistObject >  xPersistObject= *(Reference< io::XPersistObject > *) aValue.getValue();
			object2Registry(aRegKey, xPersistObject);
		}
		break;
	}

}

Any BibRegistryKey::getPropertyValue(const rtl::OUString& aName) throw( UnknownPropertyException, WrappedTargetException, RuntimeException )
{
	Any aValue;

	Reference< XRegistryKey >  aRegKey=xRegistryKey->openKey(aName);

	if(!aRegKey.is())
		aRegKey=xRegistryKey->createKey(aName);



	RegistryValueType eValueType=aRegKey->getValueType();

	switch(eValueType)
	{
		case	RegistryValueType_LONG:
					aValue <<= (sal_Int32)aRegKey->getLongValue();
					break;

		case	RegistryValueType_STRING:
					aValue <<= aRegKey->getStringValue();
					break;

		case	RegistryValueType_LONGLIST:
					{
						Sequence<sal_Int32> aSeq=aRegKey->getLongListValue();
						aValue.setValue(&aSeq, ::getCppuType((Sequence<sal_Int32>*)0));
					}
					break;

		case	RegistryValueType_STRINGLIST:
					{
						Sequence<rtl::OUString> aSeq=aRegKey->getStringListValue();
						aValue.setValue(&aSeq, ::getCppuType((Sequence<rtl::OUString>*)0));
					}
					break;

		case	RegistryValueType_BINARY:

					Reference< io::XPersistObject >  xPersistObject= registry2Object(aRegKey);
					aValue.setValue(&xPersistObject,::getCppuType((Reference<io::XPersistObject>*)0));
					break;
	}
	return aValue;
}


void BibRegistryKey::addPropertyChangeListener(const rtl::OUString& aPropertyName,
	const Reference< XPropertyChangeListener > & xListener)
		throw( UnknownPropertyException, WrappedTargetException, RuntimeException )
{
}
void BibRegistryKey::removePropertyChangeListener(const rtl::OUString& aPropertyName, const Reference< XPropertyChangeListener > & aListener) throw( UnknownPropertyException, WrappedTargetException, RuntimeException )
{
}
void BibRegistryKey::addVetoableChangeListener(const rtl::OUString& PropertyName, const Reference< XVetoableChangeListener > & aListener) throw( UnknownPropertyException, WrappedTargetException, RuntimeException )
{
}
void BibRegistryKey::removeVetoableChangeListener(const rtl::OUString& PropertyName, const Reference< XVetoableChangeListener > & aListener) throw( UnknownPropertyException, WrappedTargetException, RuntimeException )
{
}


Reference< io::XPersistObject >  BibRegistryKey::registry2Object(const Reference< XRegistryKey > & rKey) const
{
	Reference< io::XPersistObject >  aObject;
	try
	{
		uno::Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();

		Sequence< sal_Int8 > aSeqBytes= rKey->getBinaryValue();
		Reference< io::XOutputStream >  xOutputStream(xMgr->createInstance(C2U("com.sun.star.io.Pipe")), UNO_QUERY );

		xOutputStream->writeBytes(aSeqBytes);
		Reference< io::XInputStream >  xInputStream(xOutputStream, UNO_QUERY );

		Reference< io::XMarkableStream >  xMarkableStream(xMgr->createInstance(C2U("com.sun.star.io.MarkableInputStream")), UNO_QUERY );
		Reference< io::XActiveDataSink >  xMarkableDataSink(xMarkableStream,UNO_QUERY );
		xMarkableDataSink->setInputStream(xInputStream);
		Reference< io::XInputStream >  xMarkableInputStream(xMarkableStream, UNO_QUERY );

		Reference< io::XObjectInputStream >  xObjInputStream(xMgr->createInstance(C2U("com.sun.star.io.ObjectInputStream")), UNO_QUERY );
		Reference< io::XActiveDataSink >  xObjInputDataSink(xObjInputStream, UNO_QUERY );

		xObjInputDataSink->setInputStream(xMarkableInputStream);

		aObject=xObjInputStream->readObject();

		xOutputStream->closeOutput();
		xInputStream->closeInput();
	}
	catch(...)
	{
		DBG_ERROR("::Data2Registry: something went wrong !");
	}

	return aObject;
}

void BibRegistryKey::object2Registry(	const Reference< XRegistryKey > & rKey,const Reference< io::XPersistObject > & rObject)const
{
	try
	{
		uno::Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();
		Reference< io::XObjectOutputStream >  xObjOutputStream(
			xMgr->createInstance(C2U("com.sun.star.io.ObjectOutputStream")), UNO_QUERY );
		Reference< io::XActiveDataSource >  xObjOutputDataSource(xObjOutputStream, UNO_QUERY );

		Reference< io::XMarkableStream >  xMarkableStream(xMgr->createInstance(C2U("com.sun.star.io.MarkableOutputStream")), UNO_QUERY );
		Reference< io::XActiveDataSource >  xMarkableDataSource(xMarkableStream,UNO_QUERY );

		Reference< io::XOutputStream >  xOutputStream(xMgr->createInstance(C2U("com.sun.star.io.Pipe")), UNO_QUERY );

		xMarkableDataSource->setOutputStream(xOutputStream);

		Reference< io::XOutputStream >  xMarkableOutputStream(xMarkableDataSource,UNO_QUERY);
		xObjOutputDataSource->setOutputStream(xMarkableOutputStream);
		xObjOutputStream->writeObject(rObject);

		Reference< io::XInputStream >  xInputStream(xOutputStream, UNO_QUERY );

		sal_Int32 nCount=xInputStream->available();

		Sequence< sal_Int8 > aSeqBytes(nCount);
		sal_Int32 nRead= xInputStream->readBytes(aSeqBytes,nCount);
		rKey->setBinaryValue(aSeqBytes);
		xOutputStream->closeOutput();
		xInputStream->closeInput();
	}
	catch(...)
	{
		DBG_ERROR("::Data2Registry: something went wrong !");
	}
}


BibRegistryKeyInfo::BibRegistryKeyInfo(const Reference< XRegistryKey > & rKey)
{
	xBibRegistryKey=rKey;
}

// XPropertySetInfo
Sequence< beans::Property > BibRegistryKeyInfo::getProperties() throw( RuntimeException )
{

	Sequence< rtl::OUString > aNameSeq=xBibRegistryKey->getKeyNames();
	sal_Int32 nCount=aNameSeq.getLength();

	Sequence< beans::Property > aPropSeq(nCount);

	beans::Property* pProp = aPropSeq.getArray();
	const rtl::OUString* pName = aNameSeq.getConstArray();

	sal_Int32 i=0;

	while(i<nCount)
	{
		i++;
		Reference< XRegistryKey >  aRegKey=xBibRegistryKey->openKey(*pName);

		pProp->Name=*pName;
		pProp->Type = BibRegistryKey::giveClassType(aRegKey->getValueType());
		pProp->Attributes=PropertyAttribute::MAYBEVOID;
		pProp++;
		pName++;
		aRegKey->closeKey();
	}

	return aPropSeq;
}
Property BibRegistryKeyInfo::getPropertyByName(const rtl::OUString& aName) throw( UnknownPropertyException, RuntimeException )
{
	beans::Property aProp;

	Reference< XRegistryKey >  aRegKey = xBibRegistryKey->openKey(aName);
	aProp.Name = aName;
	aProp.Type = BibRegistryKey::giveClassType(aRegKey->getValueType());
	aProp.Attributes = PropertyAttribute::MAYBEVOID;
	aRegKey->closeKey();

	return aProp;
}

sal_Bool BibRegistryKeyInfo::hasPropertyByName(const rtl::OUString& aName) throw( RuntimeException )
{
	sal_Bool bRet=sal_False;
	Sequence< rtl::OUString > aNameSeq=xBibRegistryKey->getKeyNames();
	sal_Int32 nCount=aNameSeq.getLength();

	sal_Int32 i=0;

	const rtl::OUString* pName = aNameSeq.getConstArray();

	while(i<nCount)
	{
		i++;
		if(*pName==aName)
		{
			bRet=sal_True;
			break;
		}
	}
	return bRet;
}
//XInterface

BibRegistry::BibRegistry()
{
	InitRegistry();
}

BibRegistry::~BibRegistry()
{
	if(xRegistry.is())
		xRegistry->close();
}

void BibRegistry::InitRegistry()
{
	try
	{

		uno::Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();
		Reference< container::XNameAccess >  xSettings( xMgr->createInstance(C2U("com.sun.star.frame.Settings") ), UNO_QUERY );
		Any aSettings=xSettings->getByName( C2U("PathSettings") );
		Reference< XPropertySet >  xProps=*(Reference< XPropertySet > *) aSettings.getValue();

		Any aAnyPath=xProps->getPropertyValue( C2U("UserConfig") );
		rtl::OUString aPath = *(OUString*)aAnyPath.getValue();
		xRegistry = Reference< XSimpleRegistry > (xMgr->createInstance(C2U("com.sun.star.registry.SimpleRegistry") ), UNO_QUERY );
		if( !xRegistry.is() )
			return;
		aPath = URIHelper::SmartRelToAbs( aPath );
		aPath += C2U("/Bibuidat.rdb" );
		INetURLObject aEntry( aPath );
		xRegistry->open(aEntry.GetFull(), sal_False, sal_True );

	}
	catch(...)
	{
		DBG_ERROR("Exception in BibRegistry::InitRegistry")
	}
}

rtl::OUString	BibRegistry::getURL() throw( RuntimeException )
{
	rtl::OUString aURL;

	if(xRegistry.is())
		aURL=xRegistry->getURL();

	return aURL;
}
void BibRegistry::open(const rtl::OUString& rURL, sal_Bool bReadOnly, sal_Bool bCreate) throw( registry::InvalidRegistryException, RuntimeException )
{
	if(xRegistry.is())
		xRegistry->open(rURL,bReadOnly,bCreate);
}

sal_Bool BibRegistry::isValid() throw( RuntimeException )
{
	if(xRegistry.is())
		return xRegistry->isValid();
	else
		return sal_False;
}
void BibRegistry::close() throw( registry::InvalidRegistryException, RuntimeException )
{
	if(xRegistry.is())
		xRegistry->close();
}
void BibRegistry::destroy() throw( registry::InvalidRegistryException, RuntimeException )
{
	if(xRegistry.is())
		xRegistry->destroy();
}

sal_Bool BibRegistry::isReadOnly(void) throw( registry::InvalidRegistryException, RuntimeException )
{
	if(xRegistry.is())
		return xRegistry->isReadOnly();
	else
		return sal_True;
}
void BibRegistry::mergeKey(const rtl::OUString& aKeyName, const rtl::OUString& aUrl) throw( registry::InvalidRegistryException, registry::MergeConflictException, RuntimeException )
{
	if(xRegistry.is())
		xRegistry->mergeKey(aKeyName,aUrl);
}

Reference< XRegistryKey > 	BibRegistry::getRootKey() throw( registry::InvalidRegistryException, RuntimeException )
{
	Reference< XRegistryKey >  xRoot;

	if(xRegistry.is())
	{
		xRoot=new BibRegistryKey(xRegistry->getRootKey());
	}
	return xRoot;
}

Reference< XRegistryKey > 	BibRegistry::openSectionKey(const rtl::OUString& rName)
{
	return openSectionSubKey(getRootKey(),rName);
}

Reference< XRegistryKey >  BibRegistry::openSectionSubKey(const Reference< XRegistryKey > & rKey,const rtl::OUString& aName)
{
	Reference< XRegistryKey > 	aKeyRef;

	try
	{
		aKeyRef = rKey->openKey( aName );
		if( !aKeyRef.is() ) aKeyRef = rKey->createKey( aName );
	}

	catch(...)
	{
		DBG_ERROR("::openSectionSubKey: something went wrong !");
	}

	return aKeyRef;
}




