/*************************************************************************
 *
 *  $RCSfile: viewsect.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_AWT_XCONTROLMODEL_HPP_
#include <com/sun/star/awt/XControlModel.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XBOUNDCOMPONENT_HPP_
#include <com/sun/star/form/XBoundComponent.hpp>
#endif
#ifndef _TOOLKIT_UNOHLP_HXX
#include <toolkit/helper/vclunohelper.hxx>
#endif

#ifndef _SV_EXCHANGE_HXX //autogen wg. Exchange
#include <vcl/exchange.hxx>
#endif

#ifndef _DTRANS_HXX //autogen wg. SvDataObject
#include <so3/dtrans.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_ERROR
#include <tools/debug.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen wg. Application
#include <vcl/svapp.hxx>
#endif

#ifndef _TOOLS_INTN_HXX //autogen wg. International
#include <tools/intn.hxx>
#endif
#ifndef _SV_SOUND_HXX //autogen wg. Sound
#include <vcl/sound.hxx>
#endif

#include "datman.hxx"
#include "viewsect.hxx"
#include "sections.hrc"
#include "bibresid.hxx"
#include "bibmod.hxx"
#include "bibexch.hxx"
#include "bibprop.hrc"

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::beans;
#define C2U(cChar) OUString::createFromAscii(cChar)

#define LABEL_OFFSET  20

BibControlContainer::BibControlContainer(Window* pParent,BibDataManager* pDM,
										 WinBits nStyle):
	DockingWindow(pParent,nStyle | WB_DIALOGCONTROL),
	aFixedText(this),
	nLabelWidth(LABEL_OFFSET),
	pDatMan(pDM)
{
	aFixedText.SetPosPixel(Point(LABEL_OFFSET,2));
	aFixedText.Show();

	aCtrContainer = VCLUnoHelper::CreateControlContainer(this);
}

BibControlContainer::~BibControlContainer()
{
	if ( xControl.is() )
	{
		aCtrContainer->removeControl(xControl);
		xControl->dispose();
	}
}

long BibControlContainer::PreNotify( NotifyEvent& rNEvt )
{
	if(rNEvt.GetType() == EVENT_LOSEFOCUS)
	{
		try
		{
			uno::Reference< form::XBoundComponent >  xBound = uno::Reference< form::XBoundComponent > (xControl, UNO_QUERY);

			if (!xBound.is())
				xBound  = uno::Reference< form::XBoundComponent > (xCtrModel, UNO_QUERY);

			// Commit erfolgreich
			if (xBound->commit())
			{
				//pDatMan->saveRecord();
				return DockingWindow::PreNotify(rNEvt);
			}
		}
		catch(...)
		{
		}
		Sound::Beep();
		return sal_True;
	}
	return DockingWindow::PreNotify(rNEvt);
}

void BibControlContainer::Resize()
{
	Size aSize = GetOutputSizePixel();

	long nCtrWidth = aSize.Width()-nLabelWidth;
	aSize.Width() = nLabelWidth;
	aFixedText.SetSizePixel(aSize);

	if(xCtrWin.is())
	{
		xCtrWin->setPosSize(nLabelWidth, 0, nCtrWidth,aSize.Height(), awt::PosSize::SIZE);
	}
}


void BibControlContainer::SetLabel(const String& aStr)
{
	aFixedText.SetText(aStr);
}

String BibControlContainer::GetLabel()
{
	return aFixedText.GetText();
}

void BibControlContainer::SetLabelWidth(long nWidth)
{
	nLabelWidth=nWidth+LABEL_OFFSET;


	Size aSize = GetOutputSizePixel();

	long nCtrWidth = aSize.Width()-nLabelWidth;
	aSize.Width() = nLabelWidth;
	aFixedText.SetSizePixel(aSize);

	if(xCtrWin.is())
	{
		xCtrWin->setPosSize(nLabelWidth, 0, nCtrWidth
				,aSize.Height(), awt::PosSize::POSSIZE);
	}
}

long BibControlContainer::GetLabelWidth()
{
	return nLabelWidth-LABEL_OFFSET;
}


void BibControlContainer::createXControl(const uno::Reference< awt::XControlModel > & xGModel)
{
	xCtrModel=xGModel;

	if( aCtrContainer.is())
	{
		//uno::Reference< XServiceManager >  xMgr  = getGlobalServiceManager();
	uno::Reference< lang::XMultiServiceFactory >  xMgr = utl::getProcessServiceFactory();

		if ( xCtrModel.is() && xMgr.is())
		{
			uno::Reference< XPropertySet >  xPropSet( xCtrModel, UNO_QUERY );

			if ( xPropSet.is())
			{
				uno::Reference< XPropertySetInfo >  xPropInfo = xPropSet->getPropertySetInfo();
				if(xPropInfo->hasPropertyByName(FM_PROP_TEXT))
				{
					xPropSet->addPropertyChangeListener(FM_PROP_TEXT, this);
				}
				else if(xPropInfo->hasPropertyByName(FM_PROP_VALUE))
				{
					xPropSet->addPropertyChangeListener(FM_PROP_VALUE, this);
				}

				uno::Any aAny = xPropSet->getPropertyValue( C2U("DefaultControl") );
				rtl::OUString aControlName = *(OUString*)aAny.getValue();

				xControl=uno::Reference< awt::XControl > (xMgr->createInstance( aControlName ), UNO_QUERY );
				if ( xControl.is() )
				{
					xControl->setModel( xCtrModel);
				}
			}

			if ( xControl.is() )
			{
				// Peer als Child zu dem FrameWindow
				aCtrContainer->addControl(C2U("Bla"), xControl);
				xCtrWin=uno::Reference< awt::XWindow > (xControl, UNO_QUERY );
				xCtrWin->setVisible( sal_True );
				xControl->setDesignMode(sal_False);
				Size aSize = GetOutputSizePixel();
				xCtrWin->setPosSize(nLabelWidth, 0, aSize.Width()-nLabelWidth,
									aSize.Height(), awt::PosSize::POSSIZE);
			}
		}
	}
}

void BibControlContainer::disposing( const EventObject& Source )
{
	try
	{
		if ( xCtrModel.is())
		{
			uno::Reference< XPropertySet >  aPropSet(xCtrModel, UNO_QUERY );
			aPropSet->removePropertyChangeListener(FM_PROP_VALUE, this);
		}

	}
	catch(...)
	{
		DBG_ERROR("::propertyChange: something went wrong !");
	}

}

void BibControlContainer::propertyChange(const beans::PropertyChangeEvent& evt) throw( uno::RuntimeException )
{
	try
	{
		if(evt.PropertyName == FM_PROP_VALUE ||
			evt.PropertyName == FM_PROP_TEXT)
		{
			//pDatMan->editRecord();
		}
	}
	catch(...)
	{
		DBG_ERROR("::propertyChange: something went wrong !");
	}
}

//===================================================================

long nLineHeight = 0;

BibViewSection::BibViewSection(Window* pParent,BibDataManager*	pDM,  WinBits nStyle):
	SplitWindow(pParent, nStyle | WB_NOSPLITDRAW ),
	pDatMan(pDM),
	nStdLabelWidth(0),
	nNextID(1)
{
	if(!nLineHeight)
	{
		ListBox aListBox(this, WB_DROPDOWN);

		aListBox.SetPosSizePixel(Point(0,0),Size(100,100));
		nLineHeight=aListBox.GetSizePixel().Height();
		//nLineHeight+=5;
	}
//	SetAlign(WINDOWALIGN_LEFT);
	EnableDrop();

	DockingWindow* pWindow=new DockingWindow(this);

	InsertItem( 30000,pWindow,50,0, 0, SWIB_RELATIVESIZE);
}

BibViewSection::~BibViewSection()
{
	sal_uInt16 nCount= GetItemCount();

	for(short i=nCount-1; i>= 0;i--)
	{
		sal_uInt16 nID=GetItemId(i);
		DockingWindow* pWindow=(DockingWindow*)GetItemWindow(nID);
		if(pWindow!=NULL)
		{
			RemoveItem(nID);
			delete pWindow;
		}
		else
		{
			sal_uInt16 nSetCount= GetItemCount(nID);
			for(short j=nSetCount-1; i>= 0;i--)
			{
				sal_uInt16 nChildID=GetItemId(j,nID);
				DockingWindow* pWindow=(DockingWindow*)GetItemWindow(nID);
				if(pWindow!=NULL)
				{
					RemoveItem(nID);
					delete pWindow;
				}
			}
			RemoveItem(nID);
		}
	}
}
void BibViewSection::Resize()
{
	SplitWindow::Resize();
}

static sal_uInt32 nFormat = 0;

sal_Bool BibViewSection::Drop( const DropEvent& rEvt )
{
	try
	{
		if (!nFormat)
			 nFormat = Exchange::RegisterFormatName(BIB_FIELD_EXCH);

		SvDataObjectRef xDataObj = SvDataObject::PasteDragServer( rEvt );
		SvData aData(nFormat);
		xDataObj->GetData( &aData );
		String aDataExchStr;
		if (!aData.GetData(aDataExchStr))
			return sal_False;

		// SBA_FIELDEXCHANGE_FORMAT
		// "Datenbankname";"Tabellen/QueryName";1/0(fuer Tabelle/Abfrage);"Feldname"
		String aDatabaseName = aDataExchStr.GetToken(0,sal_Unicode(11));
		String aObjectName	 = aDataExchStr.GetToken(1,sal_Unicode(11));
		sal_uInt16 nObjectType	 = aDataExchStr.GetToken(2,sal_Unicode(11)).ToInt32();
		String aFieldName	 = aDataExchStr.GetToken(3,sal_Unicode(11));

		if (!aFieldName.Len() || !aObjectName.Len() || !aDatabaseName.Len() ||
			aObjectName!= String(pDatMan->getActiveDataTable()))
			return sal_False;

		sal_uInt16 nID=GetItemId(GetPointerPosPixel());

		sal_uInt16 nPos= GetItemPos(nID);

		BibControlContainer* pControl= new BibControlContainer(this,pDatMan,0);

		uno::Reference< awt::XControlModel >  aModel = pDatMan->loadControlModel(aFieldName);
		pControl->createXControl(aModel);

		long nTextWidth = pControl->GetTextWidth(aFieldName) + 5;

		if(nTextWidth > nStdLabelWidth)
		{
			nStdLabelWidth = nTextWidth;
			UpdateLabelWidth(nStdLabelWidth);
		}
		else
			nTextWidth = nStdLabelWidth;

		String aString=Application::GetAppInternational().Upper(aFieldName.Copy(0,1));
		aString+=Application::GetAppInternational().Lower(aFieldName.Copy(1));
		pControl->SetLabel(aString);
		pControl->SetLabelWidth(nTextWidth);
		if(nID!=30000)
		{
			sal_uInt16 nSetId;
			sal_Bool bFlag=GetSet(nID, nSetId, nPos);
			InsertItem( nNextID,pControl,50,nPos, nSetId);
			SetSplitSize(nNextID++, 0);
		}
		else
		{
			//SWIB_FIXED,SWIB_RELATIVESIZE,SWIB_PERCENTSIZE,SWIB_COLSET,SWIB_INVISIBLE

			InsertItem( nNextID,NULL,nLineHeight,nPos, 0, SWIB_FIXED | SWIB_COLSET);
			SetSplitSize(nNextID, 0);
			sal_uInt16 nSetId = nNextID;
			nNextID++;
			InsertItem( nNextID,pControl,50,0, nSetId, 0);
			SetSplitSize(nNextID++, 0);
		}

	}
	catch(...)
	{
		DBG_ERROR("BibViewSection::Drop: something went wrong !");
		return sal_False;
	}
	return sal_True;
}

sal_Bool BibViewSection::QueryDrop( const DropEvent& rEvt )
{
	try
	{
		if (!nFormat)
			 nFormat = Exchange::RegisterFormatName(BIB_FIELD_EXCH);

		SvDataObjectRef xDataObj = SvDataObject::PasteDragServer( rEvt );
		SvData aData(nFormat);
		xDataObj->GetData( &aData );
		String aDataExchStr;
		if (!aData.GetData(aDataExchStr))
			return sal_False;

		// SBA_FIELDEXCHANGE_FORMAT
		// "Datenbankname";"Tabellen/QueryName";1/0(fuer Tabelle/Abfrage);"Feldname"
		String aDatabaseName = aDataExchStr.GetToken(0,sal_Unicode(11));
		String aObjectName	 = aDataExchStr.GetToken(1,sal_Unicode(11));
		sal_uInt16 nObjectType	 = aDataExchStr.GetToken(2,sal_Unicode(11)).ToInt32();
		String aFieldName	 = aDataExchStr.GetToken(3,sal_Unicode(11));

		if (!aFieldName.Len() || !aObjectName.Len() || !aDatabaseName.Len() ||
			aObjectName!= String(pDatMan->getActiveDataTable()))
			return sal_False;
	}
	catch(...)
	{
		DBG_ERROR("BibViewSection::QueryDrop: something went wrong !");
		return sal_False;
	}
	return sal_True;

}

long BibViewSection::PreNotify( NotifyEvent& rNEvt )
{
	if(rNEvt.GetType() == EVENT_COMMAND)
	{
		int bla=5;
	}
	else if(rNEvt.GetType() == EVENT_QUERYDROP)
	{
		DropEvent*	pDrop=rNEvt.GetDropEvent();
		rNEvt.SetReturnValue(QueryDrop(*pDrop));
		return sal_True;
	}
	else if(rNEvt.GetType() == EVENT_DROP)
	{
		DropEvent*	pDrop=rNEvt.GetDropEvent();

		rNEvt.SetReturnValue(Drop(*pDrop));
		return sal_True;
	}
	return SplitWindow::PreNotify(rNEvt );
}

void BibViewSection::UpdateLabelWidth(long nLabelWidth)
{
	sal_uInt16 nCount= GetItemCount();

	for(short i=nCount-1; i>= 0;i--)
	{
		sal_uInt16 nID=GetItemId(i);
		DockingWindow* pWindow=(DockingWindow*)GetItemWindow(nID);
		if(pWindow==NULL)
		{
			sal_uInt16 nSetCount= GetItemCount(nID);
			for(short j=nSetCount-1; j>= 0;j--)
			{
				sal_uInt16 nChildID=GetItemId(j,nID);
				BibControlContainer* pControl =
					(BibControlContainer*) GetItemWindow(nChildID);
				if(pControl!=NULL)
				{
					pControl->SetLabelWidth(nLabelWidth);
				}
			}
		}
	}
}


