#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:47 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..
PRJNAME=extensions

TARGET=hierarchy

ENABLE_EXCEPTIONS=TRUE
USE_DEFFILE=TRUE
LIBTARGET=NO

# --- Settings ----------------------------------

.INCLUDE : settings.mk

# --- Types -------------------------------------


#UNOUCRRDB=$(PRJ)$/..$/api$/wntmsci3.ucb$/ucr$/api.db
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCRDEP=$(UNOUCRRDB)


UNOUCROUT=$(OUT)$/inc$/$(PRJNAME)$/$(TARGET)
INCPRE+=$(UNOUCROUT)

# --- Types -------------------------------------

UNOTYPES=\
	com.sun.star.hierarchy.XDynamicHierarchy			\
	com.sun.star.hierarchy.XMultiContentMerger			\
	com.sun.star.hierarchy.XHierarchyProvider			\
	com.sun.star.hierarchy.XHierarchyRegistry			\
	com.sun.star.hierarchy.XContentHierarchy			\
	com.sun.star.hierarchy.XLineInputStream				\
	com.sun.star.ucb.XPropertySetRegistry				\
	com.sun.star.ucb.XPropertySetRegistryFactory		\
	com.sun.star.beans.XPropertyContainer				\
	com.sun.star.beans.XPropertyChangeListener			\
	com.sun.star.beans.XMultiPropertySet				\
	com.sun.star.ucb.XContent							\
	com.sun.star.ucb.ContentAction						\
	com.sun.star.ucb.ContentEvent						\
	com.sun.star.ucb.XCommandTaskProcessor				\
	com.sun.star.ucb.XPropertyTaskProcessor				\
	com.sun.star.ucb.XContentTask						\
	com.sun.star.ucb.XCommandTask						\
	com.sun.star.ucb.XPropertyTask						\
	com.sun.star.ucb.XContentTaskClient					\
	com.sun.star.ucb.XContentTaskEnvironment			\
	com.sun.star.ucb.ContentTaskStatus					\
	com.sun.star.ucb.XCommandInfo						\
	com.sun.star.ucb.XContentIdentifier					\
	com.sun.star.ucb.XContentIdentifierFactory			\
	com.sun.star.ucb.XContentCreator					\
	com.sun.star.ucb.XContentProviderManager			\
	com.sun.star.ucb.XContentProvider					\
	com.sun.star.ucb.XResultAcceptor					\
	com.sun.star.task.XInteractionApprove				\
	com.sun.star.task.XInteractionDisapprove			\
	com.sun.star.task.XInteractionAbort					\
	com.sun.star.task.XInteractionRetry					\
	com.sun.star.util.DateTime							\
	com.sun.star.lang.XSingleServiceFactory				\
	com.sun.star.lang.XMultiServiceFactory				\
	com.sun.star.lang.XInitialization					\
	com.sun.star.lang.XComponent						\
	com.sun.star.lang.XServiceInfo						\
    com.sun.star.lang.ServiceNotRegisteredException		\
	com.sun.star.beans.XPropertySet						\
	com.sun.star.beans.XMultiPropertySet				\
	com.sun.star.beans.XFastPropertySet					\
	com.sun.star.beans.PropertyAttribute				\
    com.sun.star.frame.XConfigManager					\
	com.sun.star.registry.XRegistryKey					\
	com.sun.star.registry.XSimpleRegistry				\
	com.sun.star.registry.XImplementationRegistration	\
	com.sun.star.loader.XImplementationLoader			\
	com.sun.star.container.XSet							\
	com.sun.star.container.XIndexAccess					\
	com.sun.star.io.XConnectable						\
	com.sun.star.io.XInputStream						\
	com.sun.star.io.XOutputStream						\
	com.sun.star.uno.XWeak								\
	com.sun.star.uno.TypeClass

# --- Files -------------------------------------

SLO1FILES=\
	$(SLO)$/taskwrapper.obj \
	$(SLO)$/encode.obj \
	$(SLO)$/flatany.obj \
	$(SLO)$/hierarchy.obj			\
	$(SLO)$/hierarchy_helper.obj	\
	$(SLO)$/hierarchy_service.obj

SLO2FILES=\
	$(SLO)$/desktopregistry.obj


SLOFILES=$(SLO2FILES) $(SLO1FILES)
#SLOFILES=$(SLO1FILES)

# --- Library -----------------------------------

SHL1TARGET=$(TARGET)
SHL1OBJS=$(SLO1FILES)
SHL1STDLIBS= \
		$(CPPUHELPERLIB)	\
		$(CPPULIB)			\
		$(USRLIB)			\
		$(VOSLIB)			\
		$(SALLIB) 

SHL1DEPN=makefile.mk
SHL1DEF=$(MISC)$/$(SHL1TARGET).def
DEF1NAME=$(SHL1TARGET)
DEF1EXPORTFILE=exports.dxp

# -----------------------------------------------

SHL2TARGET=deskreg
SHL2OBJS=$(SLO2FILES)
SHL2STDLIBS= \
		$(CPPUHELPERLIB)	\
		$(CPPULIB)			\
		$(VOSLIB)			\
		$(SALLIB) 

SHL2DEPN=makefile.mk
SHL2DEF=$(MISC)$/$(SHL2TARGET).def
DEF2NAME=$(SHL2TARGET)
DEF2EXPORTFILE=exports.dxp

# --- Targets ----------------------------------

.INCLUDE : target.mk
