/*************************************************************************
 *
 *  $RCSfile: configmanager.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: pb $ $Date: 2000/09/22 06:59:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_______________________________________________________________________________________________________________________
//	my own include
//_______________________________________________________________________________________________________________________

#ifndef _EXTENSIONS_CONFIGMANAGER_HXX_
#include "configmanager.hxx"
#endif

//_______________________________________________________________________________________________________________________
//	includes of other projects
//_______________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX
#include <tools/resmgr.hxx>
#endif

#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>	// Locale to LanguageType
#endif

#ifndef _SV_SYSTEM_HXX
#include <vcl/system.hxx>
#endif

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif

#ifndef _RTL_USTRBUF_HXX_
#include <rtl/ustrbuf.hxx>
#endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

//_______________________________________________________________________________________________________________________
//	namespaces
//_______________________________________________________________________________________________________________________

using namespace ::osl						;
using namespace ::rtl						;
using namespace ::cppu						;
using namespace ::vos						;
using namespace ::com::sun::star::uno		;
using namespace ::com::sun::star::registry	;
using namespace ::com::sun::star::lang		;
using namespace ::com::sun::star::frame		;
using namespace ::com::sun::star::beans		;
using namespace ::com::sun::star::util		;

namespace com{
	namespace sun{
		namespace star{
			namespace comp{
				namespace extensions{
					namespace inimanager{

//_______________________________________________________________________________________________________________________
//	defines
//_______________________________________________________________________________________________________________________

#define MAX_NAMELENGTH							1024																// max. size of buffer to get name of application
#define	UNCPATHSEPERATOR						sal_Unicode(0x002F)													// Seperator of UNC-path-variables as unicode [ '/' => 2Fh ]

#define	DEFAULT_SSYSTEMPATHINSTALL				OUString()															// Default values to initialize AND reset members
#define	DEFAULT_SSYSTEMPATHPROGRAM				OUString()
#define	DEFAULT_SSYSTEMPATHUSER					OUString()
#define	DEFAULT_SURLINSTALL						OUString()
#define	DEFAULT_SURLPROGRAM						OUString()
#define	DEFAULT_SURLUSER						OUString()
#define	DEFAULT_ELANGUAGETYPE                	LANGUAGE_DONTKNOW
#define	DEFAULT_XROOTKEY						Reference< XRegistryKey >()

// Identification of these service
#define	SERVICENAME								OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.config.ConfigManager"			))
#define	IMPLEMENTATIONNAME						OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.comp.extensions.ConfigManager"	))

#define	KEYNAME_BOOKMARKDIR						OUString(RTL_CONSTASCII_USTRINGPARAM("Directories/Bookmark-Dir"	))	// keyname of bookmark directory	[soffice.ini]
#define	KEYNAME_WORKDIR							OUString(RTL_CONSTASCII_USTRINGPARAM("Directories/Work-Path"	))	// keyname of work directory    	[soffice.ini]
#define	KEYNAME_EXPLORERDIR						OUString(RTL_CONSTASCII_USTRINGPARAM("Directories/Explorer"		))	// keyname of explorer directory	[soffice.ini]
#define	KEYNAME_LANGUAGETYPE					OUString(RTL_CONSTASCII_USTRINGPARAM("User/Language"			))	// keyname of language type     	[soffice.ini]
#define	RELATIV_DIRNAME_USER					OUString(RTL_CONSTASCII_USTRINGPARAM("user"						))	// Name of directory "user" relativ to install root of application

#define	SIGN_STARTVARIABLE						OUString(RTL_CONSTASCII_USTRINGPARAM("$("						))	// Sign a string to substitute like $(inst)
#define	SIGN_ENDVARIABLE						OUString(RTL_CONSTASCII_USTRINGPARAM(")"						))	// Sign a string to substitute like $(inst)

#define	SUBSTITUTE_INST							OUString(RTL_CONSTASCII_USTRINGPARAM("$(inst)"					))	// Strings to compare with a substring of given text in substituteVariables()
#define	SUBSTITUTE_PROG							OUString(RTL_CONSTASCII_USTRINGPARAM("$(prog)"					))
#define	SUBSTITUTE_USER							OUString(RTL_CONSTASCII_USTRINGPARAM("$(user)"					))
#define	SUBSTITUTE_INSTURL						OUString(RTL_CONSTASCII_USTRINGPARAM("$(insturl)"				))
#define	SUBSTITUTE_PROGURL						OUString(RTL_CONSTASCII_USTRINGPARAM("$(progurl)"				))
#define	SUBSTITUTE_USERURL						OUString(RTL_CONSTASCII_USTRINGPARAM("$(userurl)"				))
#define	SUBSTITUTE_PATH							OUString(RTL_CONSTASCII_USTRINGPARAM("$(path)"					))
#define	SUBSTITUTE_LANG							OUString(RTL_CONSTASCII_USTRINGPARAM("$(lang)"					))
#define	SUBSTITUTE_LANGID						OUString(RTL_CONSTASCII_USTRINGPARAM("$(langid)"				))
#define	SUBSTITUTE_SYSLANGID					OUString(RTL_CONSTASCII_USTRINGPARAM("$(syslangid)"				))
#define	SUBSTITUTE_BMKDIRURL					OUString(RTL_CONSTASCII_USTRINGPARAM("$(bmkdirurl)"				))
#define	SUBSTITUTE_WORKDIRURL					OUString(RTL_CONSTASCII_USTRINGPARAM("$(workdirurl)"			))
#define	SUBSTITUTE_EXPLDIRURL					OUString(RTL_CONSTASCII_USTRINGPARAM("$(expldirurl)"			))
#define	SUBSTITUTE_VLANG						OUString(RTL_CONSTASCII_USTRINGPARAM("$(vlang)"					))

// Length of SUBSTITUTE_... to replace it with real values.
#define	REPLACELENGTH_INST						7
#define	REPLACELENGTH_PROG						7
#define	REPLACELENGTH_USER						7
#define	REPLACELENGTH_INSTURL					10
#define	REPLACELENGTH_PROGURL					10
#define	REPLACELENGTH_USERURL					10
#define	REPLACELENGTH_PATH						7
#define	REPLACELENGTH_LANG						7
#define	REPLACELENGTH_LANGID					9
#define	REPLACELENGTH_SYSLANGID					12
#define	REPLACELENGTH_BMKDIRURL					12
#define	REPLACELENGTH_WORKDIRURL				13
#define	REPLACELENGTH_EXPLDIRURL				13
#define	REPLACELENGTH_VLANG						8

#define	STRINGFOUND								0																	// OUstring::compare..() returns 0, if string was found

// Strings to replace $(vlang)
#define	REPLACEMENT_ARABIC						OUString(RTL_CONSTASCII_USTRINGPARAM("arabic"				))
#define	REPLACEMENT_CZECH						OUString(RTL_CONSTASCII_USTRINGPARAM("czech"				))
#define	REPLACEMENT_DANISH						OUString(RTL_CONSTASCII_USTRINGPARAM("danish"				))
#define	REPLACEMENT_DUTCH						OUString(RTL_CONSTASCII_USTRINGPARAM("dutch"				))
#define	REPLACEMENT_ENGLISH						OUString(RTL_CONSTASCII_USTRINGPARAM("english"				))
#define	REPLACEMENT_FINNISH						OUString(RTL_CONSTASCII_USTRINGPARAM("finnish"				))
#define	REPLACEMENT_FRENCH						OUString(RTL_CONSTASCII_USTRINGPARAM("french"				))
#define	REPLACEMENT_GERMAN						OUString(RTL_CONSTASCII_USTRINGPARAM("german"				))
#define	REPLACEMENT_GREEK						OUString(RTL_CONSTASCII_USTRINGPARAM("greek"				))
#define	REPLACEMENT_HEBREW						OUString(RTL_CONSTASCII_USTRINGPARAM("hebrew"				))
#define	REPLACEMENT_ITALIAN						OUString(RTL_CONSTASCII_USTRINGPARAM("italian"				))
#define	REPLACEMENT_JAPANESE					OUString(RTL_CONSTASCII_USTRINGPARAM("japanese"				))
#define	REPLACEMENT_KOREAN						OUString(RTL_CONSTASCII_USTRINGPARAM("korean"				))
#define	REPLACEMENT_POLISH						OUString(RTL_CONSTASCII_USTRINGPARAM("polish"				))
#define	REPLACEMENT_RUSSIAN						OUString(RTL_CONSTASCII_USTRINGPARAM("russian"				))
#define	REPLACEMENT_SLOVAK						OUString(RTL_CONSTASCII_USTRINGPARAM("slovak"				))
#define	REPLACEMENT_SPANISH						OUString(RTL_CONSTASCII_USTRINGPARAM("spanish"				))
#define	REPLACEMENT_SWEDISH						OUString(RTL_CONSTASCII_USTRINGPARAM("swedish"				))
#define	REPLACEMENT_TURKISH						OUString(RTL_CONSTASCII_USTRINGPARAM("turkish"				))
#define	REPLACEMENT_NORWEGIAN					OUString(RTL_CONSTASCII_USTRINGPARAM("norwegian"			))
#define	REPLACEMENT_HUNGARIAN					OUString(RTL_CONSTASCII_USTRINGPARAM("hungarian"			))
#define	REPLACEMENT_BULGARIAN					OUString(RTL_CONSTASCII_USTRINGPARAM("bulgarian"			))
#define	REPLACEMENT_CHINESE_TRADITIONAL			OUString(RTL_CONSTASCII_USTRINGPARAM("chinese_traditional"	))
#define	REPLACEMENT_CHINESE_SIMPLIFIED			OUString(RTL_CONSTASCII_USTRINGPARAM("chinese_simplified"	))
#define	REPLACEMENT_PORTUGUESE					OUString(RTL_CONSTASCII_USTRINGPARAM("portuguese"			))

//_______________________________________________________________________________________________________________________
//	macros
//_______________________________________________________________________________________________________________________

//_______________________________________________________________________________________________________________________
//	constructor
//_______________________________________________________________________________________________________________________

ConfigManager::ConfigManager( const Reference< XMultiServiceFactory >& xFactory )
	: INIManager			( xFactory						)
	, m_sSystemInstallPath	( DEFAULT_SSYSTEMPATHINSTALL	)
	, m_sSystemProgramPath	( DEFAULT_SSYSTEMPATHPROGRAM 	)
	, m_sSystemUserPath		( DEFAULT_SSYSTEMPATHUSER 		)
	, m_sURLInstallPath		( DEFAULT_SURLINSTALL 			)
	, m_sURLProgramPath		( DEFAULT_SURLPROGRAM 			)
	, m_sURLUserPath   		( DEFAULT_SURLUSER 				)
	, m_eLanguageType		( DEFAULT_ELANGUAGETYPE			)
	, m_xRootKey			( DEFAULT_XROOTKEY				)
{
	// Set reference of this instance at ProfileCache-member in INIManager.
	INIManager::impl_setConfigManagerReference( static_cast< XInterface* >( static_cast< XConfigManager* >( this ) ) );

	// Listen for comming disposing messages, to close already opened file and send remove listener!!!
    Reference< XComponent > xComponent = Reference< XComponent >( xFactory, UNO_QUERY );
	if ( xComponent.is() )
	{
		xComponent->addEventListener( static_cast< XEventListener* >( this ) );
	}
}

//_______________________________________________________________________________________________________________________
//	destructor
//_______________________________________________________________________________________________________________________

ConfigManager::~ConfigManager()
{
}

//_______________________________________________________________________________________________________________________
//	XConfigManager
//_______________________________________________________________________________________________________________________

OUString SAL_CALL ConfigManager::substituteVariables( const OUString& sText ) throw( RuntimeException )
{
	// Make this scope ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_substituteVariables( sText ), "ConfigManager::substituteVariables()\nInvalid parameter detected!\n" );

	if ( isValid () == sal_False )
	{
		// Object not valid ... do nothing!
		return sText ;
	}

	// Don't work at parameter-string directly. Copy it.
	OUString		sWorkText	= sText;

	// Search for first occure of "$(...".
	sal_Int32		nPosition	= sWorkText.indexOf( SIGN_STARTVARIABLE );	// = first position of "$(" in string
	sal_Int32		nLength		= 0;										// = count of letters from "$(" to ")" in string

	// Have we found any variable like "$(...)"?
	if ( nPosition != -1 )
	{
		// Yes; Get length of found variable.
		// If no ")" was found - nLength is set to 0 by default! see before.
		sal_Int32 nEndPosition = sWorkText.indexOf( SIGN_ENDVARIABLE, nPosition );
		if ( nEndPosition != -1 )
		{
			nLength = nEndPosition-nPosition;
			nLength++; // First index in string is 0!
		}
	}

	// Is there something for replace ?
	while	(
				( nPosition	!=	-1	)	&&
				( nLength	>	 0	)
			)
	{
		// YES; Get the next variable for replace.
		OUString	sReplacement												;
		OUString	sSubString	  	=	sWorkText.copy( nPosition, nLength )	;
		sal_Int32	nReplaceLength	=	0										;

		sSubString = sSubString.toLowerCase();

		// -------------------------------------------------------------------------------------------------------------------
		// $(inst) - directory of the master (server) installation
		if ( sSubString == SUBSTITUTE_INST )
		{
			nReplaceLength	=	REPLACELENGTH_INST		;
			sReplacement	=	m_sSystemInstallPath	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(user) - directory of the user installation (== dir of soffice.ini)
		if ( sSubString == SUBSTITUTE_USER )
		{
			nReplaceLength	=	REPLACELENGTH_USER		;
			sReplacement	=	m_sSystemUserPath		;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(prog) - directory of the executable file
		if ( sSubString == SUBSTITUTE_PROG )
		{
			nReplaceLength	=	REPLACELENGTH_PROG		;
			sReplacement	=	m_sSystemProgramPath	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(insturl) - directory of the master (server) installation as URL
		if ( sSubString == SUBSTITUTE_INSTURL )
		{
			nReplaceLength	=	REPLACELENGTH_INSTURL	;
			sReplacement	=	m_sURLInstallPath		;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(userurl) - directory of the user installation (== dir of soffice.ini)
		if ( sSubString == SUBSTITUTE_USERURL )
		{
			nReplaceLength	=	REPLACELENGTH_USERURL	;
			sReplacement	=	m_sURLUserPath			;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(progurl) - directory of the executable file as URL
		if ( sSubString == SUBSTITUTE_PROGURL )
		{
			nReplaceLength	=	REPLACELENGTH_PROGURL	;
			sReplacement	=	m_sURLProgramPath		;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(path)
		if ( sSubString == SUBSTITUTE_PATH )
		{
			nReplaceLength	=	REPLACELENGTH_PATH								;
			sReplacement	=	OUString::createFromAscii( getenv( "path" ) )	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(lang) - language dependent directory with LanguageId used as directory name
		if ( sSubString == SUBSTITUTE_LANG )
		{
			nReplaceLength	=	REPLACELENGTH_LANG					 								;
			sReplacement	=	OUString::createFromAscii( ResMgr::GetLang( m_eLanguageType, 0 ) )	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(langid) - LanguageType of the application as string (for example "1031")
		if ( sSubString == SUBSTITUTE_LANGID )
		{
   			nReplaceLength	=	REPLACELENGTH_LANGID								;
   			sReplacement	=	OUString::valueOf( (sal_uInt16)m_eLanguageType )	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(syslangid) - LanguageType of the system as string (for example "1031")
		if ( sSubString == SUBSTITUTE_SYSLANGID )
		{
    		nReplaceLength	=	REPLACELENGTH_SYSLANGID									;
    		sReplacement	=	OUString::valueOf( (sal_uInt16)System::GetLanguage() )	;
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(bmkdirurl) - URL of the path to the bookmarks directory
		if ( sSubString == SUBSTITUTE_BMKDIRURL )
		{
			// Open key in file.
			Reference< XRegistryKey > xKey = m_xRootKey->openKey( KEYNAME_BOOKMARKDIR );

			// Safe impossible cases
			// We must replace this text ... but we can't do it. There is no valid value.
			DBG_ASSERT( !( xKey.is() == sal_False ), "ConfigManager::substituteVariables()\nCan't open key \"Directories/Bookmark-Dir\"!\n" );

			// Do nothing, if key not exist. (RELEASE)
			if ( xKey.is() == sal_True )
			{
				// Read value of key ...
				// (Don't forget to substitute variables at the value of reading key !!!)
				OUString sValue = xKey->getStringValue();
				// YOU MUST CLOSE KEY AT THIS POINT!!!
				// A Key hold an reference on THIS INIManager!
				xKey->closeKey();
				xKey = Reference< XRegistryKey >();

				nReplaceLength	=	REPLACELENGTH_BMKDIRURL			;
				sReplacement	=	substituteVariables( sValue )	;
			}
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(workdirurl) - URL of the path to the working directory
		if ( sSubString == SUBSTITUTE_WORKDIRURL )
		{
			// Open key in file.
			Reference< XRegistryKey > xKey = m_xRootKey->openKey( KEYNAME_WORKDIR );

			// Safe impossible cases
			// We must replace this text ... but we can't do it. There is no valid value.
			DBG_ASSERT( !( xKey.is() == sal_False ), "ConfigManager::substituteVariables()\nCan't open key \"Directories/Work-Path\"!\n" );

			// Do nothing, if key not exist. (RELEASE)
			if ( xKey.is() == sal_True )
			{
				// Read value of key ...
				// (Don't forget to substitute variables at the value of reading key !!!)
				OUString sValue = xKey->getStringValue();
				// YOU MUST CLOSE KEY AT THIS POINT!!!
				// A Key hold an reference on THIS INIManager!
				xKey->closeKey();
				xKey = Reference< XRegistryKey >();

				nReplaceLength	=	REPLACELENGTH_WORKDIRURL		;
				sReplacement	=	substituteVariables( sValue )	;
			}
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(expldirurl) - URL of the path to the explorer directory
		if ( sSubString == SUBSTITUTE_EXPLDIRURL )
		{
			// Open key in file.
			Reference< XRegistryKey > xKey = m_xRootKey->openKey( KEYNAME_EXPLORERDIR );

			// Safe impossible cases
			// We must replace this text ... but we can't do it. There is no valid value.
			DBG_ASSERT( !( xKey.is() == sal_False ), "ConfigManager::substituteVariables()\nCan't open key \"Directories/Explorer\"!\n" );

			// Do nothing, if key not exist. (RELEASE)
			if ( xKey.is() == sal_True )
			{
				// Read value of key ...
				// (Don't forget to substitute variables at the value of reading key !!!)
				OUString sValue = xKey->getStringValue();
				// YOU MUST CLOSE KEY AT THIS POINT!!!
				// A Key hold an reference on THIS INIManager!
				xKey->closeKey () ;
				xKey = Reference< XRegistryKey >  () ;

				nReplaceLength	=	REPLACELENGTH_EXPLDIRURL		;
				sReplacement	=	substituteVariables( sValue )	;

				/* HACK ------------------------------------------------------------------------------------- */
				// Dieser Eintrag steht in der INI-Datei als SystemPfad und nicht als URL.
				// => Konvertieren - Das sollte sich aber bald aendern!
				OUString sUNCTemp ;
				OUString sURLTemp ;
				FileBase::normalizePath( sReplacement, sUNCTemp );
				FileBase::getFileURLFromNormalizedPath( sUNCTemp, sURLTemp );
				sReplacement = sURLTemp ;
				/* HACK ------------------------------------------------------------------------------------- */
			}
		}
		else
		// -------------------------------------------------------------------------------------------------------------------
		// $(vlang) - language dependent directory with english language name as directory name
		if ( sSubString == SUBSTITUTE_VLANG )
		{
			nReplaceLength = REPLACELENGTH_VLANG ;
			switch ( m_eLanguageType )
			{
				case LANGUAGE_ARABIC				:
				case LANGUAGE_ARABIC_IRAQ			:
				case LANGUAGE_ARABIC_EGYPT			:
				case LANGUAGE_ARABIC_LIBYA			:
				case LANGUAGE_ARABIC_ALGERIA		:
				case LANGUAGE_ARABIC_MOROCCO		:
				case LANGUAGE_ARABIC_TUNISIA		:
				case LANGUAGE_ARABIC_OMAN			:
				case LANGUAGE_ARABIC_YEMEN			:
				case LANGUAGE_ARABIC_SYRIA			:
				case LANGUAGE_ARABIC_JORDAN			:
				case LANGUAGE_ARABIC_LEBANON		:
				case LANGUAGE_ARABIC_KUWAIT			:
				case LANGUAGE_ARABIC_UAE			:
				case LANGUAGE_ARABIC_BAHRAIN		:
				case LANGUAGE_ARABIC_QATAR			:	sReplacement = REPLACEMENT_ARABIC;
														break ;

				case LANGUAGE_CZECH					:	sReplacement = REPLACEMENT_CZECH;
														break ;

				case LANGUAGE_DANISH				:	sReplacement = REPLACEMENT_DANISH;
														break ;

				case LANGUAGE_DUTCH					:
				case LANGUAGE_DUTCH_BELGIAN			:	sReplacement = REPLACEMENT_DUTCH;
														break ;

				case LANGUAGE_ENGLISH				:
				case LANGUAGE_ENGLISH_AUS			:
				case LANGUAGE_ENGLISH_CAN			:
				case LANGUAGE_ENGLISH_NZ			:
				case LANGUAGE_ENGLISH_EIRE			:
				case LANGUAGE_ENGLISH_SAFRICA		:
				case LANGUAGE_ENGLISH_JAMAICA		:
				case LANGUAGE_ENGLISH_CARRIBEAN		:
				case LANGUAGE_ENGLISH_BELIZE		:
				case LANGUAGE_ENGLISH_TRINIDAD		:
				case LANGUAGE_ENGLISH_ZIMBABWE		:
				case LANGUAGE_ENGLISH_PHILIPPINES	:
				case LANGUAGE_ENGLISH_US			:
				case LANGUAGE_ENGLISH_UK			:	sReplacement = REPLACEMENT_ENGLISH;
														break ;

				case LANGUAGE_FINNISH				:	sReplacement = REPLACEMENT_FINNISH;
														break ;

				case LANGUAGE_FRENCH				:
				case LANGUAGE_FRENCH_BELGIAN		:
				case LANGUAGE_FRENCH_CANADIAN		:
				case LANGUAGE_FRENCH_SWISS			:
				case LANGUAGE_FRENCH_LUXEMBOURG		:
				case LANGUAGE_FRENCH_MONACO			:	sReplacement = REPLACEMENT_FRENCH;
														break ;

				case LANGUAGE_GERMAN				:
				case LANGUAGE_GERMAN_SWISS			:
				case LANGUAGE_GERMAN_AUSTRIAN		:
				case LANGUAGE_GERMAN_LUXEMBOURG		:
				case LANGUAGE_GERMAN_LIECHTENSTEIN	:	sReplacement = REPLACEMENT_GERMAN;
														break ;

				case LANGUAGE_GREEK					:	sReplacement = REPLACEMENT_GREEK;
														break ;

				case LANGUAGE_HEBREW				:	sReplacement = REPLACEMENT_HEBREW;
														break ;

				case LANGUAGE_ITALIAN				:
				case LANGUAGE_ITALIAN_SWISS			:	sReplacement = REPLACEMENT_ITALIAN;
														break ;

				case LANGUAGE_JAPANESE				:	sReplacement = REPLACEMENT_JAPANESE;
														break ;

				case LANGUAGE_KOREAN				:
				case LANGUAGE_KOREAN_JOHAB			:	sReplacement = REPLACEMENT_KOREAN;
														break ;

				case LANGUAGE_POLISH				:	sReplacement = REPLACEMENT_POLISH;
														break ;

				case LANGUAGE_RUSSIAN				:	sReplacement = REPLACEMENT_RUSSIAN;
														break ;

				case LANGUAGE_SLOVAK				:	sReplacement = REPLACEMENT_SLOVAK;
														break ;

				case LANGUAGE_SPANISH				:
				case LANGUAGE_SPANISH_MEXICAN		:
				case LANGUAGE_SPANISH_MODERN		:
				case LANGUAGE_SPANISH_GUATEMALA	 	:
				case LANGUAGE_SPANISH_COSTARICA	 	:
				case LANGUAGE_SPANISH_PANAMA		:
				case LANGUAGE_SPANISH_DOMINICAN_REPUBLIC:
				case LANGUAGE_SPANISH_VENEZUELA		:
				case LANGUAGE_SPANISH_COLOMBIA		:
				case LANGUAGE_SPANISH_PERU			:
				case LANGUAGE_SPANISH_ARGENTINA		:
				case LANGUAGE_SPANISH_ECUADOR		:
				case LANGUAGE_SPANISH_CHILE			:
				case LANGUAGE_SPANISH_URUGUAY		:
				case LANGUAGE_SPANISH_PARAGUAY		:
				case LANGUAGE_SPANISH_BOLIVIA		:
				case LANGUAGE_SPANISH_EL_SALVADOR	:
				case LANGUAGE_SPANISH_HONDURAS		:
				case LANGUAGE_SPANISH_NICARAGUA		:
				case LANGUAGE_SPANISH_PUERTO_RICO	:	sReplacement = REPLACEMENT_SPANISH;
														break ;

				case LANGUAGE_SWEDISH				:
				case LANGUAGE_SWEDISH_FINLAND		:	sReplacement = REPLACEMENT_SWEDISH;
														break ;

				case LANGUAGE_TURKISH				:	sReplacement = REPLACEMENT_TURKISH;
														break ;

				case LANGUAGE_NORWEGIAN				:
				case LANGUAGE_NORWEGIAN_BOKMAL		:
				case LANGUAGE_NORWEGIAN_NYNORSK		:	sReplacement = REPLACEMENT_NORWEGIAN;
														break ;

				case LANGUAGE_HUNGARIAN				:	sReplacement = REPLACEMENT_HUNGARIAN;
														break ;

				case LANGUAGE_BULGARIAN				:	sReplacement = REPLACEMENT_BULGARIAN;
														break ;

				case LANGUAGE_CHINESE_TRADITIONAL	:	sReplacement = REPLACEMENT_CHINESE_TRADITIONAL;
														break ;

				case LANGUAGE_CHINESE_SIMPLIFIED	:	sReplacement = REPLACEMENT_CHINESE_SIMPLIFIED;
														break ;

				case LANGUAGE_PORTUGUESE			:
				case LANGUAGE_PORTUGUESE_BRAZILIAN	:	sReplacement = REPLACEMENT_PORTUGUESE;
														break ;

				default								:	// fallback english!?
														DBG_ASSERT( sal_False, "ConfigManager::substituteVariables()\nLanguage unknown. Default value is obsolete!\n" );
														//sReplacement = REPLACEMENT_ENGLISH;
														break ;
			}
		}

		// Have we found something to replace?
		if ( nReplaceLength > 0 )
		{
			// Yes ... then do it.
			sWorkText = sWorkText.replaceAt( nPosition, nReplaceLength, sReplacement );
		}
		else
		{
			// Safe impossible cases
			// Unknown variable was found! We have detected "$(...)" but don't know his meaning.
			DBG_ASSERT( sal_False, "ConfigManager::substituteVariables()\nUnknown variable was found!\n" );
			// Skim unknown variable.
			nPosition += nLength;
		}

		// Step after replaced text!
		// If no text was replaced (unknown variable!), length of sReplacement is 0 ... and we don't step then.
		nPosition += sReplacement.getLength() ;

		// We must control index in string before call something at OUString!
		// The OUString-implementation don't do it for us :-( but the result is not defined otherwise.
		if ( nPosition+1 > sWorkText.getLength() )
		{
			// Position is out of range.
			// Break loop!
			nPosition	= -1 ;
			nLength		=  0 ;
		}
		else
		{
			// Else; Position is valid.
			// Search for next variable to replace.
			nPosition = sWorkText.indexOf( SIGN_STARTVARIABLE, nPosition );
			// Have we found any variable like "$(...)"?
			if ( nPosition != -1 )
			{
				// Yes; Get length of found variable.
				// If no ")" was found - nLength must set to 0!
				// see before while-condition before!
				nLength	= 0;
				sal_Int32 nEndPosition = sWorkText.indexOf( SIGN_ENDVARIABLE, nPosition );
				if ( nEndPosition != -1 )
				{
					nLength = nEndPosition-nPosition;
					nLength++; // First index in string is 0!
				}
			}
		}
	}

	// Return text with replaced substrings.
	return sWorkText ;
}

//_______________________________________________________________________________________________________________________
//	XConfigManager
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::addPropertyChangeListener(	const	OUString&								sKeyName	,
														const	Reference< XPropertyChangeListener >&	xListener	) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_addPropertyChangeListener( sKeyName, xListener ), "ConfigManager::addPropertyChangeListener()\nInvalid parameter detected!\n" );

	// Forward to "INIManager::impl_addPropertyChangeListener ()"
	INIManager::impl_addPropertyChangeListener( sKeyName, xListener );
}

//_______________________________________________________________________________________________________________________
//	XConfigManager
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::removePropertyChangeListener(	const	OUString&								sKeyName	,
															const	Reference< XPropertyChangeListener >&	xListener	) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_removePropertyChangeListener( sKeyName, xListener ), "ConfigManager::removePropertyChangeListener()\nInvalid parameter detected!\n" );

	// Forward to "INIManager::impl_removePropertyChangeListener ()"
	INIManager::impl_removePropertyChangeListener( sKeyName, xListener );
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::open(	const	OUString&	rURL		,
											sal_Bool	bReadOnly	,
											sal_Bool	bCreate		) throw(	InvalidRegistryException	,
																				RuntimeException			)
{
	// Forward to INIManager
	// Parameter are tested there to!
	INIManager::open( rURL, bReadOnly, bCreate );

	// If "open()" failed ... an exception is throwed !!!
	// And if no exception throwed, object is valid ...

	// Make this scope ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// File is open ...
	// Get information about environment!
	// This is used for "substituteVariables" (keys like $(...)).
	// Call follow method only, if INI-file is realy open !
	impl_resetObject();
	impl_initVariables();
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::close() throw(	InvalidRegistryException	,
											RuntimeException			)
{
	// Forward to INIManager
	INIManager::close();

	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Reset object
	impl_resetObject();
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::destroy() throw(	InvalidRegistryException	,
												RuntimeException			)
{
	// Forward to INIManager
	INIManager::destroy();

	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Reset object
	impl_resetObject();
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::flush() throw( InvalidRegistryException, RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Forward to INIManager
	INIManager::impl_flush();
}

//_______________________________________________________________________________________________________________________
//	XMoifyBroadcaster
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::addModifyListener( const Reference< XModifyListener >& xListener ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_addModifyListener( xListener ), "ConfigManager::addModifyListener()\nInvalid parameter detected!\n" );

	// Forward to "INIManager->ProfileCache::impl_addModifyListener ()" !!!
	INIManager::impl_addModifyListener( xListener );
}

//_______________________________________________________________________________________________________________________
//	XModifyBroadcaster
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::removeModifyListener( const Reference< XModifyListener >& xListener ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_removeModifyListener( xListener ), "ConfigManager::removeModifyListener()\nInvalid parameter detected!\n" );

	// Forward to "INIManager->ProfileCache::impl_removeModifyListener ()" !!!
	INIManager::impl_removeModifyListener( xListener );
}

//_______________________________________________________________________________________________________________________
//	XEventListener
//_______________________________________________________________________________________________________________________

void SAL_CALL ConfigManager::disposing ( const EventObject& aEvent ) throw( RuntimeException )
{
	// Ready for multithreading
	MutexGuard aGuard( m_aMutex );

	// Safe impossible cases, for which method is not defined.
	DBG_ASSERT( impl_checkParameter_disposing( aEvent ), "ConfigManager::disposing()\nInvalid parameter detected!\n" );

	// Done listen for disposing messages.
	Reference< XMultiServiceFactory >&	rFactory	=	INIManager::impl_getFactoryReference();
    Reference< XComponent > 			xFactory	=	Reference< XComponent >( rFactory, UNO_QUERY );
	if ( xFactory.is() )
	{
		xFactory->removeEventListener( static_cast< XEventListener* >( this ) );
	}

	// We must close file at every time and remove all listener!
	// Remove all listener first.
	// (Listener are forwarded and handled in class "ProfileCache" ... and a instance of
	//  these is a member of class "INIManager". Forward this operation to "ProfileCache"!)
	EventObject aEventSource( (OWeakObject*)this );
	INIManager::impl_disposing( aEventSource );

	// Close file; clear memory and reset this instance to!
	ConfigManager::close();
}

//________________________________________________________________________________________________________
//	XInterface
//________________________________________________________________________________________________________

Any SAL_CALL ConfigManager::queryInterface( const Type& aType ) throw( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Ask for my own supported interfaces ...
	Any aReturn	( ::cppu::queryInterface	(	aType									   ,
									   			static_cast< XConfigManager		*> ( this ),
									   			static_cast< XModifyBroadcaster	*> ( this ),
									   			static_cast< XEventListener		*> ( this )
											)
				);

	// If searched interface not supported by this class ...
	if ( aReturn.hasValue() == sal_False )
	{
		//  ... ask baseclass for interfaces!
		return INIManager::queryInterface( aType ) ;
	}

	return aReturn ;
}

//________________________________________________________________________________________________________
//	XInterface
//________________________________________________________________________________________________________

void SAL_CALL ConfigManager::acquire() throw( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Forward to baseclass
	INIManager::acquire();
}

//________________________________________________________________________________________________________
//	XInterface
//________________________________________________________________________________________________________

void SAL_CALL ConfigManager::release() throw( RuntimeException )
{
	// Attention:
	//	Don't use mutex or guard in this method!!! Is a method of XInterface.

	// Forward to baseclass
	INIManager::release();
}

//________________________________________________________________________________________________________
//	XTypeProvider
//________________________________________________________________________________________________________

Sequence< Type > SAL_CALL ConfigManager::getTypes() throw( RuntimeException )
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pTypeCollection is NULL - for the second call pTypeCollection is different from NULL!
	static OTypeCollection* pTypeCollection = NULL ;

	if ( pTypeCollection == NULL )
	{
		// Ready for multithreading; get global mutex for first call of this method only! see before
		MutexGuard aGuard( Mutex::getGlobalMutex() );

		// Control these pointer again ... it can be, that another instance will be faster then these!
		if ( pTypeCollection == NULL )
		{
			// Create a static typecollection ...
			static OTypeCollection aTypeCollection(	::getCppuType(( const Reference< XServiceInfo		>*)NULL ) ,
												  	::getCppuType(( const Reference< XTypeProvider		>*)NULL ) ,
												  	::getCppuType(( const Reference< XSimpleRegistry	>*)NULL ) ,
												  	::getCppuType(( const Reference< XConfigManager		>*)NULL ) ,
												  	::getCppuType(( const Reference< XModifyBroadcaster	>*)NULL ) ,
												  	::getCppuType(( const Reference< XEventListener		>*)NULL ) ) ;

			// ... and set his address to static pointer!
			pTypeCollection = &aTypeCollection ;
		}
	}

	return pTypeCollection->getTypes() ;
}

//________________________________________________________________________________________________________
//	XServiceInfo
//________________________________________________________________________________________________________

OUString SAL_CALL ConfigManager::getImplementationName() throw( RuntimeException )
{
	return impl_getStaticImplementationName();
}

//________________________________________________________________________________________________________
//	XServiceInfo
//________________________________________________________________________________________________________

Sequence< OUString > SAL_CALL ConfigManager::getSupportedServiceNames() throw( RuntimeException )
{
	return impl_getStaticSupportedServiceNames();
}

//________________________________________________________________________________________________________
//	public impl. and static method to register service
//________________________________________________________________________________________________________

Sequence< OUString > SAL_CALL ConfigManager::impl_getStaticSupportedServiceNames()
{
	// Normaly, i don't use mutex in "impl"-methods.
	// But this one is called from register functions to!
	// And there is no chance to do this ...

	// Ready for multithreading
	MutexGuard aGuard( Mutex::getGlobalMutex() );

    Sequence< OUString > seqServiceNames( 1 );
    seqServiceNames.getArray() [0] = SERVICENAME ;

    return seqServiceNames ;
}

//________________________________________________________________________________________________________
//	public impl. and static method to register service
//________________________________________________________________________________________________________

OUString SAL_CALL ConfigManager::impl_getStaticImplementationName()
{
	// Normaly, i don't use mutex in "impl"-methods.
	// But this one is called from register functions to!
	// And there is no chance to do this ...

	// Ready for multithreading
	MutexGuard aGuard( Mutex::getGlobalMutex() );

	return IMPLEMENTATIONNAME ;
}

//________________________________________________________________________________________________________
//	private method
//________________________________________________________________________________________________________

void ConfigManager::impl_resetObject()
{
	// Reset static variables and flags
	m_sSystemInstallPath	= DEFAULT_SSYSTEMPATHINSTALL	;
	m_sSystemProgramPath	= DEFAULT_SSYSTEMPATHPROGRAM	;
	m_sSystemUserPath		= DEFAULT_SSYSTEMPATHUSER		;
	m_sURLInstallPath		= DEFAULT_SURLINSTALL			;
	m_sURLProgramPath		= DEFAULT_SURLPROGRAM			;
	m_sURLUserPath			= DEFAULT_SURLUSER				;
	m_eLanguageType			= DEFAULT_ELANGUAGETYPE			;

	if ( m_xRootKey.is() )
	{
		m_xRootKey->closeKey();
		m_xRootKey = DEFAULT_XROOTKEY;
	}
}

//________________________________________________________________________________________________________
//	private method
//________________________________________________________________________________________________________

void ConfigManager::impl_initVariables()
{
	// Safe impossible cases
	// Call of this method is only allowed, if an ini-file is open and these instance is valid!
	DBG_ASSERT( !(isValid()==sal_False), "ConfigManager::impl_initVariables()\nCall this method only, if an ini-file is open!\n" );

	// First, we need the name and path of this application! (soffice.exe? ImpressPlayer? ectpp.)
	OStartupInfo				aInfo						;
	OStartupInfo::TStartupError	eState						;
	OUString					sUNCApplicationName			;

	eState = aInfo.getExecutableFile( sUNCApplicationName );

	// Do the follow only, if this application name well known!
	DBG_ASSERT( !(eState != osl_Process_E_None), "ConfigManager::impl_initVariables()\nCan't get name of application!\n" );
	if ( eState == osl_Process_E_None )
	{
		OUString sUNCProgramPath;
		OUString sUNCInstallPath;
		OUString sUNCUserPath	;

		// Get path of application.
		sal_Int32 nPosition = sUNCApplicationName.lastIndexOf( UNCPATHSEPERATOR );
		if ( nPosition > 1 )
		{
            sUNCProgramPath = sUNCApplicationName.copy( 0, nPosition );
		}

		// Get parent directory of program path.
        nPosition = sUNCProgramPath.lastIndexOf( UNCPATHSEPERATOR );
		if ( nPosition > 1 )
		{
            sUNCInstallPath = sUNCProgramPath.copy( 0, nPosition );
		}

		// Set user path to path of opened ini file.
		FileBase::getNormalizedPathFromFileURL( m_sURL, sUNCUserPath );
        nPosition = sUNCUserPath.lastIndexOf( UNCPATHSEPERATOR );
		if ( nPosition > 1 )
		{
            sUNCUserPath = sUNCUserPath.copy( 0, nPosition );
		}

		// Convert all path variables to URL.
		FileBase::getFileURLFromNormalizedPath( sUNCProgramPath	, m_sURLProgramPath	);
		FileBase::getFileURLFromNormalizedPath( sUNCInstallPath	, m_sURLInstallPath	);
		FileBase::getFileURLFromNormalizedPath( sUNCUserPath	, m_sURLUserPath	);

		// Convert all path variables to host notation.
		FileBase::getSystemPathFromNormalizedPath( sUNCProgramPath	, m_sSystemProgramPath	);
		FileBase::getSystemPathFromNormalizedPath( sUNCInstallPath	, m_sSystemInstallPath	);
		FileBase::getSystemPathFromNormalizedPath( sUNCUserPath		, m_sSystemUserPath		);
	}

	// Get rootkey for all following operations on INI-file! (better performance!)
	m_xRootKey = getRootKey();

	// Safe impossible cases
	// We cant work without rootkey!
	DBG_ASSERT( !(m_xRootKey.is() == sal_False), "ConfigManager::impl_initVariables()\nCant get rootkey ... cant work without them!\n" );

	// We will not switch to another language at runtime!
	// We read the languagetype ONLY for one time and save it.
	// Read value from INI-file.
	Reference< XRegistryKey > xKey = m_xRootKey->openKey( KEYNAME_LANGUAGETYPE );
	if ( xKey.is() == sal_True )
	{
		// Locale is well known!
		// Get value and switch on substitution of $(lang), $(langid) ...
		OUString sLocale = xKey->getStringValue();
		m_eLanguageType = ConvertIsoStringToLanguage( sLocale, '_' );
		xKey->closeKey();
		xKey = Reference< XRegistryKey >();
	}
}

//________________________________________________________________________________________________________
//	debug and check methods
//________________________________________________________________________________________________________

#ifdef _DEBUG

//________________________________________________________________________________________________________
//	check parameter of substitueVariables()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_substituteVariables( const OUSTRING& sText )
{
	// Variables invalid.
	if ( &sText == NULL ) return sal_False ;	// Reference == NULL-pointer !!??

	// Variables are OK.
	return sal_True ;
}

//________________________________________________________________________________________________________
//	check parameter of addPropertyChangeListener()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_addPropertyChangeListener(	const	OUSTRING&								sKeyName	,
		 																const	REFERENCE< XPROPERTYCHANGELISTENER >&	xListener	)
{
	// Variables invalid.
	if ( &sKeyName				==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( &xListener				==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( sKeyName.getLength()	<	1			) return sal_False ;	// Listener for invalid key
	if ( xListener.is()			==	sal_False	) return sal_False ;	// invalid Listener

	// Variables are OK.
	return sal_True ;
}

//________________________________________________________________________________________________________
//	check parameter of removePropertyChangeListener()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_removePropertyChangeListener(	const	OUSTRING&								sKeyName	,
																			const	REFERENCE< XPROPERTYCHANGELISTENER >&	xListener	)
{
	// Variables invalid.
	if ( &sKeyName				==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( &xListener				==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( sKeyName.getLength()	<	1			) return sal_False ;	// Listener for invalid key
	if ( xListener.is()			==	sal_False	) return sal_False ;	// invalid Listener

	// Variables are OK.
	return sal_True ;
}

//________________________________________________________________________________________________________
//	check parameter of addModifyListener()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_addModifyListener( const REFERENCE< XMODIFYLISTENER >& xListener )
{
	// Variables invalid.
	if ( &xListener	   		==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( xListener.is()		==	sal_False	) return sal_False ;	// invalid Listener

	// Variables are OK.
	return sal_True ;
}

//________________________________________________________________________________________________________
//	check parameter of removeModifyListener()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_removeModifyListener( const REFERENCE< XMODIFYLISTENER >& xListener )
{
	// Variables invalid.
	if ( &xListener	   		==	NULL		) return sal_False ;	// Reference == NULL-pointer
	if ( xListener.is()		==	sal_False	) return sal_False ;	// invalid Listener

	// Variables are OK.
	return sal_True ;
}

//________________________________________________________________________________________________________
//	check parameter of disposing()
//________________________________________________________________________________________________________

sal_Bool ConfigManager::impl_checkParameter_disposing( const EVENTOBJECT& aEvent )
{
	// Variables invalid.
	if ( &aEvent	==	NULL	) return sal_False ;	// Reference == NULL-pointer

	// Variables are OK.
	return sal_True ;
}

#endif // #ifdef _DEBUG

     } // namespace inimanager
    } // namespace extensions
   } // namespace comp
  } // namespace star
 } // namespace sun
} // namespace com
