#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:47 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=			extensions
TARGET=				imr
LIBTARGET=			NO
USE_LDUMP2=			TRUE
USE_DEFFILE=		TRUE
ENABLE_EXCEPTIONS=	TRUE
BOOTSTRAP_SERVICE=      TRUE

# --- Settings -----------------------------------------------------
.INCLUDE :	$(PRJ)$/util$/makefile.pmk


# --- Files --------------------------------------------------------

UNOUCRDEP=		$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=		$(SOLARBINDIR)$/applicat.rdb

.IF "$(BOOTSTRAP_SERVICE)" == "TRUE"
UNOUCROUT=		$(OUT)$/inc$/comprehensive
INCPRE+=		$(OUT)$/inc$/comprehensive
CPPUMAKERFLAGS+=	-C
.ELSE
UNOUCROUT=		$(OUT)$/inc
INCPRE+=		$(OUT)$/inc
.ENDIF

UNOTYPES=		\
				com.sun.star.registry.RegistryKeyType			\
				com.sun.star.registry.XRegistryKey              \
				com.sun.star.registry.RegistryValueType         \
				com.sun.star.registry.InvalidRegistryException  \
				com.sun.star.registry.XSimpleRegistry           \
				com.sun.star.lang.XTypeProvider                 \
				com.sun.star.uno.XWeak							\
				com.sun.star.beans.PropertyAttribute			\
				com.sun.star.beans.PropertyValues				\
				com.sun.star.beans.XFastPropertySet				\
				com.sun.star.beans.XMultiPropertySet			\
				com.sun.star.beans.XPropertyAccess				\
				com.sun.star.beans.XPropertyChangeListener		\
				com.sun.star.beans.XPropertyContainer			\
				com.sun.star.beans.XPropertyState				\
				com.sun.star.beans.XPropertySet                 \
				com.sun.star.beans.XPropertyStateChangeListener	\
				com.sun.star.container.XSet						\
				com.sun.star.frame.XConfigManager				\
				com.sun.star.lang.XComponent					\
				com.sun.star.lang.XEventListener				\
				com.sun.star.lang.XServiceName					\
				com.sun.star.lang.XServiceInfo					\
				com.sun.star.lang.XMultiServiceFactory			\
				com.sun.star.lang.XSingleServiceFactory			\
				com.sun.star.registry.InvalidValueException		\
				com.sun.star.uno.TypeClass						\
				com.sun.star.util.XModifiable					\
				com.sun.star.util.XModifyListener				\
  				com.sun.star.lang.XTypeProvider


SLOFILES=		\
				$(SLO)$/profilecache.obj			\
				$(SLO)$/rootkey.obj					\
				$(SLO)$/sectionkey.obj				\
				$(SLO)$/entrykey.obj				\
				$(SLO)$/inimanager.obj				\
				$(SLO)$/configmanager.obj			\
				$(SLO)$/specialconfigmanager.obj	\
				$(SLO)$/iniregister.obj

LIB1TARGET=		$(SLB)$/$(TARGET).lib
LIB1OBJFILES=	$(SLOFILES)

SHL1TARGET=		$(TARGET)$(UPD)$(DLLPOSTFIX)

SHL1STDLIBS=	\
				$(CPPULIB)	 		\
				$(CPPUHELPERLIB)	\
				$(VOSLIB) 	 		\
				$(SALLIB) 	 		\
				$(OSLLIB) 	 		\
				$(TOOLSLIB)

SHL1DEPN=		makefile.mk
SHL1LIBS=		$(LIB1TARGET)
SHL1DEF=		$(MISC)$/$(SHL1TARGET).def

DEF1NAME=		$(SHL1TARGET)
DEF1EXPORTFILE=	exports.dxp


# --- Targets ------------------------------------------------------
.INCLUDE :	target.mk
.INCLUDE :	$(PRJ)$/util$/target.pmk
