/*************************************************************************
 *
 *  $RCSfile: specialconfigmanager.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_______________________________________________________________________________________________________________________
//	my own include
//_______________________________________________________________________________________________________________________

#ifndef _EXTENSIONS_SPECIALCONFIGMANAGER_HXX_
#include "specialconfigmanager.hxx"
#endif

//_______________________________________________________________________________________________________________________
// includes of other projects
//_______________________________________________________________________________________________________________________

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

//_______________________________________________________________________________________________________________________
// includes of my project
//_______________________________________________________________________________________________________________________

//_______________________________________________________________________________________________________________________
//	defines
//_______________________________________________________________________________________________________________________

#define	SERVICENAME 					"com.sun.star.config.SpecialConfigManager"
#define	IMPLEMENTATIONNAME				"com.sun.star.comp.extensions.SpecialConfigManager"

//_______________________________________________________________________________________________________________________
//	macros
//_______________________________________________________________________________________________________________________

//_______________________________________________________________________________________________________________________
//	namespaces
//_______________________________________________________________________________________________________________________

using namespace ::rtl						;
using namespace ::osl						;
using namespace ::vos						;
using namespace	::com::sun::star::uno		;
using namespace	::com::sun::star::lang		;
using namespace	::com::sun::star::registry	;

namespace com{
	namespace sun{
		namespace star{
			namespace comp{
				namespace extensions{
					namespace inimanager{

//_______________________________________________________________________________________________________________________
//	constructor
//_______________________________________________________________________________________________________________________

SpecialConfigManager::SpecialConfigManager( const Reference< XMultiServiceFactory >& xFactory )
	: ConfigManager( xFactory )
{
	// We make an AUTO-OPEN ! User can't use method open directly.
	// Search for right INI-file ...

	OUString sUNCFileName ;
	OProfile::getProfileName( sUNCFileName, OUString::createFromAscii( "soffice" ), OUString::createFromAscii( STAROFFICE_SVERSION_KEY ) );

	// Convert UNC-filename to URL.
	OUString sURL ;
	FileBase::getFileURLFromNormalizedPath( sUNCFileName, sURL );

	// Open this file.
	sal_Bool bReadOnly	= sal_False	;
	sal_Bool bCreate	= sal_False	;

	ConfigManager::open( sURL, bReadOnly, bCreate );

	// For AUTO-CLOSE see "ConfigManager::disposing()".
}

//_______________________________________________________________________________________________________________________
//	destructor
//_______________________________________________________________________________________________________________________

SpecialConfigManager::~SpecialConfigManager()
{
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL SpecialConfigManager::open(	const	OUString&	sURL		,
													sal_Bool	bReadOnly	,
													sal_Bool	bCreate		) throw(	InvalidRegistryException	,
																						RuntimeException			)
{
	// Overloaded method to deactivate operation!
	// This instance make an auto-open at soffice.ini!
	DBG_ASSERT( sal_False, "SpecialConfigManager::open()\nDon't call this method at this special object! We make an auto-open at soffice.ini!\n" );
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL SpecialConfigManager::close() throw(	InvalidRegistryException	,
													RuntimeException			)
{
	// Overloaded method to deactivate operation!
	// This instance make an auto-open at soffice.ini!
}

//_______________________________________________________________________________________________________________________
//	XSimpleRegistry
//_______________________________________________________________________________________________________________________

void SAL_CALL SpecialConfigManager::destroy() throw(	InvalidRegistryException	,
														RuntimeException			)
{
	// Overloaded method to deactivate operation!
	// Don't delete soffic.ini!
	DBG_ASSERT( sal_False, "SpecialConfigManager::destroy()\nDon't call this method at this special object! You can't destroy soffice.ini!\n" );
}

//________________________________________________________________________________________________________
//	XServiceInfo
//________________________________________________________________________________________________________

OUString SAL_CALL SpecialConfigManager::getImplementationName() throw( RuntimeException )
{
	return SpecialConfigManager::impl_getStaticImplementationName();
}

//________________________________________________________________________________________________________
//	XServiceInfo
//________________________________________________________________________________________________________

Sequence< OUString > SAL_CALL SpecialConfigManager::getSupportedServiceNames() throw( RuntimeException )
{
	return SpecialConfigManager::impl_getStaticSupportedServiceNames();
}

//________________________________________________________________________________________________________
//	public impl. and static method to register service
//________________________________________________________________________________________________________

Sequence< OUString > SpecialConfigManager::impl_getStaticSupportedServiceNames()
{
	// Ready for multithreading
	MutexGuard aGuard( Mutex::getGlobalMutex() );

    Sequence< OUString > seqServiceNames( 1 );
    seqServiceNames.getArray() [0] = OUString::createFromAscii( SERVICENAME );

    return seqServiceNames ;
}

//________________________________________________________________________________________________________
//	public impl. and static method to register service
//________________________________________________________________________________________________________

OUString SpecialConfigManager::impl_getStaticImplementationName()
{
	// Ready for multithreading
	MutexGuard aGuard( Mutex::getGlobalMutex() );

	return OUString::createFromAscii( IMPLEMENTATIONNAME );
}

     } // namespace inimanager
    } // namespace extensions
   } // namespace comp
  } // namespace star
 } // namespace sun
} // namespace com
