/*************************************************************************
 *
 *  $RCSfile: specialconfigmanager.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_SPECIALCONFIGMANAGER_HXX_
#define _EXTENSIONS_SPECIALCONFIGMANAGER_HXX_

//_______________________________________________________________________________________________________________________
//	includes of other projects
//_______________________________________________________________________________________________________________________

//_______________________________________________________________________________________________________________________
//	includes of my own project
//_______________________________________________________________________________________________________________________

#ifndef _EXTENSIONS_CONFIGMANAGER_HXX_
#include "configmanager.hxx"
#endif

//_______________________________________________________________________________________________________________________
//	defines and namespaces :-)
//_______________________________________________________________________________________________________________________

namespace com{
	namespace sun{
		namespace star{
			namespace comp{
				namespace extensions{
					namespace inimanager{

#define	XMULTISERVICEFACTORY		::com::sun::star::lang::XMultiServiceFactory
#define	OUSTRING					::rtl::OUString
#define	INVALIDREGISTRYEXCEPTION	::com::sun::star::registry::InvalidRegistryException
#define	RUNTIMEEXCEPTION			::com::sun::star::uno::RuntimeException
#define	ANY							::com::sun::star::uno::Any
#define	REFERENCE					::com::sun::star::uno::Reference
#define	SEQUENCE					::com::sun::star::uno::Sequence
#define	UNOTYPE						::com::sun::star::uno::Type

//_______________________________________________________________________________________________________________________
//	class declarations
//_______________________________________________________________________________________________________________________

class SpecialConfigManager	: public ConfigManager
{

//_______________________________________________________________________________________________________________________
//	public methods
//_______________________________________________________________________________________________________________________

public:

	//____________________________________________________________________________________________________
	//	constructor / destructor
	//____________________________________________________________________________________________________

	/**___________________________________________________________________________________________________
		@short		-
		@descr		-

		@seealso	-

		@param		-

		@return		-

		@onerror	-
	*/

	SpecialConfigManager( const REFERENCE< XMULTISERVICEFACTORY >& xFactory );

	/**___________________________________________________________________________________________________
		@short		-
		@descr		-

		@seealso	-

		@param		-

		@return		-

		@onerror	-
	*/

	virtual	~SpecialConfigManager();

	//____________________________________________________________________________________________________
	//	XSimpleRegistry
	//____________________________________________________________________________________________________

	/**___________________________________________________________________________________________________
		@short		-
		@descr		-

		@seealso	-

		@param		-

		@return		-

		@onerror	-
	*/

    virtual void SAL_CALL open(	const	OUSTRING&	sURL		,
										sal_Bool	bReadOnly	,
										sal_Bool	bCreate		) throw(	INVALIDREGISTRYEXCEPTION	,
																			RUNTIMEEXCEPTION			);

	/**___________________________________________________________________________________________________
		@short		-
		@descr		-

		@seealso	-

		@param		-

		@return		-

		@onerror	-
	*/

    virtual void SAL_CALL close() throw(	INVALIDREGISTRYEXCEPTION	,
											RUNTIMEEXCEPTION			);

	/**___________________________________________________________________________________________________
		@short		-
		@descr		-

		@seealso	-

		@param		-

		@return		-

		@onerror	-
	*/

    virtual void SAL_CALL destroy() throw(	INVALIDREGISTRYEXCEPTION	,
											RUNTIMEEXCEPTION			);

	//____________________________________________________________________________________________________
	//	XServiceInfo
	//____________________________________________________________________________________________________

	/**___________________________________________________________________________________________________
		@short
		@descr

		@seealso

		@param

		@return

		@onerror
	*/

	virtual OUSTRING SAL_CALL getImplementationName() throw( RUNTIMEEXCEPTION );

	/**___________________________________________________________________________________________________
		@short
		@descr

		@seealso

		@param

		@return

		@onerror
	*/

    virtual SEQUENCE< OUSTRING > SAL_CALL getSupportedServiceNames() throw( RUNTIMEEXCEPTION );

	//____________________________________________________________________________________________________
	//	public impl. and static methods to register service
	//____________________________________________________________________________________________________

	/**___________________________________________________________________________________________________
		@short
		@descr

		@seealso

		@param

		@return

		@onerror
	*/

	static SEQUENCE< OUSTRING > impl_getStaticSupportedServiceNames();

	/**___________________________________________________________________________________________________
		@short
		@descr

		@seealso

		@param

		@return

		@onerror
	*/

	static OUSTRING impl_getStaticImplementationName();

//_______________________________________________________________________________________________________________________
//	protected methods
//_______________________________________________________________________________________________________________________

protected:

//_______________________________________________________________________________________________________________________
//	private methods
//_______________________________________________________________________________________________________________________

private:

//_______________________________________________________________________________________________________________________
//	private variables
//_______________________________________________________________________________________________________________________

private:

};	// class SpecialConfigManager

     } // namespace inimanager
    } // namespace extensions
   } // namespace comp
  } // namespace star
 } // namespace sun
} // namespace com

#endif	// #ifndef _EXTENSIONS_SPECIALCONFIGMANAGER_HXX_
