#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:48 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..$/..

ENABLE_EXCEPTIONS=TRUE

PRJNAME=extensions
TARGET=opc
USE_LDUMP2=TRUE
PRJINC=..$/..

# --- Settings -----------------------------------------------------
.INCLUDE :	$(PRJ)$/util$/makefile.pmk

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=$(OUT)$/inc

UNOTYPES=	\
	com.sun.star.container.NoSuchElementException \
	com.sun.star.container.XElementAccess \
	com.sun.star.container.XNameAccess \
	com.sun.star.installation.ProtDlgRes \
	com.sun.star.installation.protocols \
	com.sun.star.installation.XInstallationCheck \
	com.sun.star.installation.XProtocolHandlerCheck \
	com.sun.star.lang.ArrayIndexOutOfBoundsException \
	com.sun.star.lang.IllegalAccessException \
	com.sun.star.lang.IllegalArgumentException \
	com.sun.star.lang.IndexOutOfBoundsException \
	com.sun.star.lang.WrappedTargetException \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XServiceInfo \
	com.sun.star.lang.XServiceName \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.reflection.FieldAccessMode \
	com.sun.star.reflection.InvocationTargetException \
	com.sun.star.reflection.MethodMode \
	com.sun.star.reflection.ParamInfo \
	com.sun.star.reflection.ParamMode \
	com.sun.star.reflection.XIdlArray \
	com.sun.star.reflection.XIdlClass \
	com.sun.star.reflection.XIdlField \
	com.sun.star.reflection.XIdlMember \
	com.sun.star.reflection.XIdlMethod \
	com.sun.star.registry.InvalidRegistryException \
	com.sun.star.registry.InvalidValueException \
	com.sun.star.registry.MergeConflictException \
	com.sun.star.registry.RegistryKeyType \
	com.sun.star.registry.XRegistryKey \
	com.sun.star.registry.XSimpleRegistry \
	com.sun.star.uno.Exception \
	com.sun.star.uno.RuntimeException \
	com.sun.star.uno.TypeClass \
	com.sun.star.uno.Uik \
	com.sun.star.uno.XAdapter \
	com.sun.star.uno.XInterface \
	com.sun.star.uno.XReference \
	com.sun.star.uno.XWeak \


#build all resources with sparc
SRC1FILES = protdlg.src
SRS1NAME = opc
RESLIB1NAME = opc
RESLIB1SRSFILES = $(SRS)$/$(SRS1NAME).srs

.IF "$(GUI)"=="WNT" || "$(GUI)"=="OS2"

# --- ProtocolHandlerCheck ---------------------------------

SLOFILES = 	$(SLO)$/protdlg.obj \
			$(SLO)$/protchk.obj

EXCEPTIONS1FILES= $(SLO)$/protchk.obj

SHL1TARGET= $(TARGET)$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= i$(TARGET)

SHL1STDLIBS= \
	$(ONELIB) \
	$(UNOLIB) \
	$(VOSLIB) \
	$(TOOLSLIB) \
    $(VCLLIB) \
    $(SVXLIB) \
    $(SVTOOLLIB) \
    $(CPPUHELPERLIB)	\
   	$(CPPULIB) 			\
	$(SALLIB)

.IF "$(GUI)"=="WNT"
SHL1STDLIBS+= advapi32.lib shell32.lib
SHL1OBJS= $(SLO)$/regtools.obj
.ENDIF

SHL1LIBS= $(SLB)$/$(TARGET).lib
SHL1DEF= $(MISC)$/$(SHL1TARGET).def


DEF1NAME= $(SHL1TARGET)
DEF1DEPN= $(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME= $(TARGET)

#DEF1EXPORT1= exService_getFactory
#DEF1EXPORT2= exService_writeRegEntry

.ENDIF # WNT || OS2

# --- Targets ------------------------------------------------------
.INCLUDE : target.mk
.INCLUDE : $(PRJ)$/util$/target.pmk

# --- Filter -------------------------------------------------------
$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	@echo ------------------------------
	@echo Making: $@
	@echo WEP>$@
	@echo LIBMAIN>>$@
	@echo LibMain>>$@
	@echo _Impl>>$@
	@echo _alloc>>$@
	@echo malloc>>$@
	@echo _lower_bound>>$@
	@echo _stl_prime>>$@
	@echo _CT>>$@
	@echo _TI1>>$@
	@echo _TI2>>$@
	@echo _TI3>>$@
	@echo @>>$@
	@echo exService_>>$@
	@echo XProtocolHandlerCheck>>$@

