/*************************************************************************
 *
 *  $RCSfile: installuser.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>

#include <vos/diagnose.hxx>

#ifndef _COM_SUN_STAR_CONTAINER_XHIERARCHICALNAMEACCESS_HPP_
#include <com/sun/star/container/XHierarchicalNameAccess.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMEREPLACE_HPP_
#include <com/sun/star/container/XNameReplace.hpp>
#endif

#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_XCHANGESBATCH_HPP_
#include <com/sun/star/util/XChangesBatch.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif

#include <cppuhelper/implbase1.hxx>
#include <cppuhelper/factory.hxx>
#include <vos/process.hxx>
#include <osl/file.hxx>
#include <tools/fsys.hxx>

using namespace osl;
using namespace vos;
using namespace std;
using namespace rtl;
using namespace cppu;
using namespace com::sun::star::util;
using namespace com::sun::star::registry;
using namespace com::sun::star::container;
using namespace com::sun::star::uno;
using namespace com::sun::star::lang;

namespace extensions {
namespace installuser {
	
	class InstallUser : public WeakImplHelper1< XInitialization >
	{
		Reference< XMultiServiceFactory > m_xMgr;
	public:
		InstallUser( const Reference< XMultiServiceFactory > & xMgr );
		virtual ~InstallUser();
		
		// XInitialization
		virtual void SAL_CALL initialize( const Sequence< Any >& aArguments ) throw(Exception, RuntimeException);
		
	};

// @@@ leading slash doesn't work, but should according to FS.
//#define HIERARCHY_ROOT_DB_KEY	"/com.sun.star.ucb.Hierarchy/Root"
#define HIERARCHY_ROOT_DB_KEY	"com.sun.star.UserProfile"


InstallUser::InstallUser( const Reference< XMultiServiceFactory > & xMgr ) 
	: m_xMgr( xMgr )
{
}
	
InstallUser::~InstallUser()
{
}

void SAL_CALL InstallUser::initialize( const Sequence< Any >& aArguments ) throw(Exception, RuntimeException)
{
	try
	{
		sal_Bool bInstalled = FALSE;
		OStartupInfo aInfo;
		
		OUString aTargetPath;
		sal_Int32 nCount = aInfo.getCommandArgCount();
		OUString aComp( RTL_CONSTASCII_USTRINGPARAM( "-userid" ) );
		OUString aArg;
		for(;nCount--;)
		{
			aInfo.getCommandArg( nCount, aArg );
			if( !aArg.compareTo( aComp, aComp.len() ) )
			{
				sal_Int32 nPos = aArg.indexOf( '[' );
				sal_Int32 nEndpos = aArg.lastIndexOf( ']' );
				if( nPos != -1 && nEndpos != -1 )
					aTargetPath = aArg.copy( nPos + 1, nEndpos - nPos - 1 );
				break;
			}
		}
		if( !aTargetPath.len() ) 
		{
			VOS_ENSURE( sal_False,
						"No user target path -> No copy of template installation" );
			return;
		}

		FileBase::normalizePath( aTargetPath, aTargetPath );
		OUString aTest( aTargetPath );
		aTest += OUString( RTL_CONSTASCII_USTRINGPARAM( "/user" ) );
		DirectoryItem aItem;
		DirectoryItem::get( aTest, aItem );
		FileStatus aStatus( 
			FileStatusMask_Validate | osl_FileStatus_Mask_FileName );
		aItem.getFileStatus( aStatus );
		if( aStatus.isValid( osl_FileStatus_Mask_FileName ) )
			bInstalled = TRUE;
		
		Reference< XMultiServiceFactory > xConfigProvider;
//  		Reference< XMultiServiceFactory > xConfigProvider = Reference< XMultiServiceFactory >(
//  			m_xMgr->createInstance(
//  				OUString::createFromAscii(
//  					"com.sun.star.configuration.ConfigurationProvider" ) ),
//  			UNO_QUERY );
		
//  		if ( xConfigProvider.is() )
//  		{
//  			try
//  			{
//  				Sequence< Any > aArguments( 1 );
//  				aArguments[ 0 ]
//  					<<= OUString::createFromAscii( HIERARCHY_ROOT_DB_KEY );
				
//  				Reference< XHierarchicalNameAccess > xRootHierAccess(
//  					xConfigProvider->createInstanceWithArguments(
//  						OUString::createFromAscii(
//  							"com.sun.star.configuration.ConfigurationAccess" ),
//  						aArguments ),
//  					UNO_QUERY );
				
//  				VOS_ENSURE( xRootHierAccess.is(),
//  							"HierarchyEntry::hasData - No root!" );
			
//  				OUString aCompletedKey = OUString::createFromAscii( "Office/InstCompleted" ) ;
//  				Any aValue = xRootHierAccess->getByHierarchicalName( aCompletedKey );
//  				if( !(aValue >>= bInstalled ))
//  					throw Exception() ;
//  			}
//  			catch ( Exception& )
//  			{
				
//  				VOS_ENSURE( sal_False,
//  							"Could not find configuration, will copy user installation anyway" );
//  			}
//  		}
		
		
		if( !bInstalled )
		{
			// Install from template directory
			
			OUString aBuffer;
			OUString aSourcePath;

			aInfo.getExecutableFile( aSourcePath );
			sal_Int32 nPos = aSourcePath.lastIndexOf( '/' );
			if( nPos != -1 ) aSourcePath = aSourcePath.copy( 0, nPos );
			OUString aRelative( RTL_CONSTASCII_USTRINGPARAM( "../UserProfiles/01" ) );
			FileBase::getAbsolutePath( aSourcePath, aRelative, aBuffer );
			aSourcePath = aBuffer;
			
			
			
			
//  				aValue = xRootHierAccess->getByHierarchicalName( OUString::createFromAscii( "Office/InstallPath" ) );
//  				OUString aTargetPath;
//  				aValue >>= aTargetPath;
//  				FileBase::normalizePath( aTargetPath, aTargetPath );

			
//  				aValue = xRootHierAccess->getByHierarchicalName( OUString::createFromAscii( "Portal/InstallPath" ) );
//  				OUString aSourcePath;
//  				aValue >>= aSourcePath;
//  				FileBase::normalizePath( aSourcePath, aSourcePath );
//  				FileBase::getAbsolutePath( 
//  					aSourcePath, OUString::createFromAscii( "UserProfiles/01" ), aSourcePath );
			
			
			FileBase::getSystemPathFromNormalizedPath( aSourcePath, aSourcePath );
			FileBase::getSystemPathFromNormalizedPath( aTargetPath, aTargetPath );
			
			OString aByteSource( aSourcePath, aSourcePath.len(), RTL_TEXTENCODING_ASCII_US );
			OString aByteTarget( aTargetPath, aTargetPath.len(), RTL_TEXTENCODING_ASCII_US );
			
			fprintf( stderr, "%s -> %s\n", (const char*) aByteSource, (const char*) aByteTarget );
			
			
			DirEntry aTargetDirEntry( aByteTarget );
			if (!aTargetDirEntry.GetPath().Exists())		// if full-last doesnt exists, create it (with 777)
				aTargetDirEntry.GetPath().MakeDir();
			
			// copy recursive
			if( FileCopier( 
				DirEntry( aByteSource ), DirEntry( aByteTarget ) ).Execute(
					FSYS_ACTION_COPYFILE | FSYS_ACTION_RECURSIVE) != FSYS_ERR_OK )
				throw Exception();
			
			
			
			
			if( xConfigProvider.is() )
			{
				
				Reference< XChangesBatch > xUpdater(
					xConfigProvider->createInstanceWithArguments(
						OUString::createFromAscii(
							"com.sun.star.configuration.ConfigurationUpdateAccess" ), aArguments ), UNO_QUERY );
				Reference< XHierarchicalNameAccess > xNameAccess( xUpdater, UNO_QUERY );
				Any aAnyNode = xNameAccess->getByHierarchicalName( OUString::createFromAscii( "Office" ) );
				Reference< XInterface> xNode;
				if( !(aAnyNode >>= xNode ) )
					throw Exception();
				Reference< XNameReplace > xReplacer( xNode, UNO_QUERY );
				xReplacer->replaceByName( 
					OUString::createFromAscii( "InstCompleted" ), makeAny( sal_Bool( true ) ) );
				xUpdater->commitChanges();
			}
		}
	}
	
	catch ( RuntimeException& )
	{
		throw;
	}
	catch ( Exception& )
	{
		// createInstance, createInstanceWithArguments

		VOS_ENSURE( sal_False,
					"HierarchyEntry::hasData - caught Exception!" );
	}
}

} // namespace
} // namespace

static Reference< XInterface > SAL_CALL InstallUser_create( const Reference< XMultiServiceFactory > & xMgr )
{
	return Reference< XInterface >( *new ::extensions::installuser::InstallUser( xMgr ) );
}

/*
 * component info
 */
extern "C"
{
//==================================================================================================
void SAL_CALL component_getImplementationEnvironment(
	const sal_Char ** ppEnvTypeName, uno_Environment ** ppEnv )
{
	*ppEnvTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
}
//==================================================================================================
sal_Bool SAL_CALL component_writeInfo(
	void * pServiceManager, void * pRegistryKey )
{
	if (pRegistryKey)
	{
		try
		{
			reinterpret_cast< XRegistryKey * >( pRegistryKey )->createKey(
				OUString::createFromAscii( 
					"/com.sun.star.portal.InstallUser/UNO/SERVICES/com.sun.star.portal.InstallUser" ) );
			return sal_True;
		}
		catch (InvalidRegistryException &)
		{
			OSL_ENSHURE( sal_False, "### InvalidRegistryException!" );
		}
	}
	return sal_False;
}
//==================================================================================================
void * SAL_CALL component_getFactory(
	const sal_Char * pImplName, void * pServiceManager, void * pRegistryKey )
{
	void * pRet = 0;
	
	if (pServiceManager && rtl_str_compare( pImplName, "com.sun.star.portal.InstallUser" ) == 0)
	{
		OUString aServiceName( OUString::createFromAscii( "com.sum.star.portal.InstallUser" ) );
		Reference< XSingleServiceFactory > xFactory( cppu::createSingleFactory(
			reinterpret_cast< XMultiServiceFactory * >( pServiceManager ),
			OUString::createFromAscii( pImplName ),
			InstallUser_create, Sequence< OUString >( &aServiceName, 1 ) ) );
		
		if (xFactory.is())
		{
			xFactory->acquire();
			pRet = xFactory.get();
		}
	}
	
	return pRet;
}
}

