#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:50 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..

PRJPCH=

PRJNAME=extensions
TARGET=pgp

USE_LDUMP2=TRUE
USE_DEFFILE=TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  $(PRJ)$/util$/makefile.pmk

PGPSTDLIBS=	\
	$(CPPUHELPERLIB)	\
	$(CPPULIB)			\
	$(SALLIB)

# ------------------------------------------------------------------
# pgp 5.5
# ------------------------------------------------------------------

.IF "$(GUI)"=="WNT"

PGP55=		55
PGP55LIBS=	\
	pgp55cd.lib		\
	pgp55rd.lib		\
	pgpphras.lib	\
	pgpsdk.lib

LIB1TARGET=		$(SLB)$/$(TARGET)$(PGP55).lib
LIB1FILES=		$(SLB)$/pgpimpl.lib $(SLB)$/pgpui55.lib

SHL1TARGET= 	$(TARGET)$(PGP55)$(DLLPOSTFIX)
SHL1IMPLIB=		i$(TARGET)$(PGP55)

SHL1STDLIBS=	$(PGPSTDLIBS)
SHL1STDLIBS+=	$(PGP55LIBS)

SHL1DEPN=
SHL1LIBS=		$(LIB1TARGET)
SHL1DEF=		$(MISC)$/$(SHL1TARGET).def

DEF1NAME=		$(SHL1TARGET)
DEF1EXPORTFILE=	exports.dxp

.ENDIF # WNT

# ------------------------------------------------------------------
# pgp 6.0
# ------------------------------------------------------------------

.IF "$(GUI)" == "WNT"

PGP60=		60
PGP60LIBS=	\
	pgp60cl.lib	\
	pgp60sdk.lib

LIB2TARGET=		$(SLB)$/$(TARGET)$(PGP60).lib
LIB2FILES=		$(SLB)$/pgpimpl.lib $(SLB)$/pgpui60.lib

SHL2TARGET=		$(TARGET)$(PGP60)$(DLLPOSTFIX)
SHL2IMPLIB=		i$(TARGET)$(PGP60)

SHL2STDLIBS=	$(PGPSTDLIBS)
SHL2STDLIBS+=	$(PGP60LIBS)

SHL2DEPN=
SHL2OBJS=		$(SLO)$/pgpdll60.obj
SHL2LIBS=		$(LIB2TARGET)
SHL2DEF=		$(MISC)$/$(SHL2TARGET).def

DEF2NAME=		$(SHL2TARGET)
DEF2EXPORTFILE=	exports.dxp

.ENDIF # WNT

# ------------------------------------------------------------------
# pgp 6.5
# ------------------------------------------------------------------

.IF "$(GUI)" == "WNT"

PGP65=		65
PGP65LIBS=	\
	pgp65cl.lib	\
	pgp65sdk.lib

LIB3TARGET=		$(SLB)$/$(TARGET)$(PGP65).lib
LIB3FILES=		$(SLB)$/pgpimpl.lib $(SLB)$/pgpui65.lib

SHL3TARGET=		$(TARGET)$(PGP65)$(DLLPOSTFIX)
SHL3IMPLIB=		i$(TARGET)$(PGP65)

SHL3STDLIBS=	$(PGPSTDLIBS)
SHL3STDLIBS+=	$(PGP65LIBS)

SHL3DEPN=
SHL3OBJS=		$(SLO)$/pgpdll65.obj
SHL3LIBS=		$(LIB3TARGET)
SHL3DEF=		$(MISC)$/$(SHL3TARGET).def

DEF3NAME=		$(SHL3TARGET)
DEF3EXPORTFILE=	exports.dxp

.ENDIF # WNT

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk
.INCLUDE :  $(PRJ)$/util$/target.pmk

