/*************************************************************************
 *
 *  $RCSfile: pldemo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:16:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
#include <vcl/wrkwin.hxx>
#include <vcl/svapp.hxx>
#include <tools/urlobj.hxx>
#include <tools/debug.hxx>
#include <svtools/ownlist.hxx>
#include <svtools/unoiface.hxx>

#include <stardiv/uno/awt/vcllstnr.hxx>
#include <stardiv/uno/awt/toolkit.hxx>
#include <stardiv/uno/repos/serinfo.hxx>

#include <stardiv/uno/awt/graphics.hxx>
#include <stardiv/plugin/plugin.hxx>

#include <plugin/filesource.hxx>

//==================================================================================================
class Listener_Impl
	: public UsrObject
	, public XMouseListener
	, public XMouseMotionListener
	, public XKeyListener
	, public XWindowListener
	, public XFocusListener
	, public XPaintListener
{
public:
	SMART_UNO_DECLARATION( Listener_Impl, UsrObject );

	virtual BOOL		queryInterface( Uik aUik, XInterfaceRef& rOut );

	// XMouseListener
	virtual void		mousePressed( const VclMouseEvent& evt );
	virtual void		mouseReleased( const VclMouseEvent& evt );
	virtual void		mouseEntered( const VclMouseEvent& evt );
	virtual void		mouseExited( const VclMouseEvent& evt );

	// XMouseMotionListener
	virtual void		mouseDragged( const VclMouseEvent& evt );
	virtual void		mouseMoved( const VclMouseEvent& evt );

	// XKeyListener
	virtual void		keyPressed( const VclKeyEvent& evt );
	virtual void		keyReleased( const VclKeyEvent& evt );

	// XFocusListener
	virtual void		focusGained( const FocusEvent& evt );
	virtual void		focusLost( const FocusEvent& evt );

	// XWindowListener
	virtual void		windowResized( const WindowEvent& evt );
	virtual void		windowMoved( const WindowEvent& evt );
	virtual void		windowShown( const EventObject& evt );
	virtual void		windowHidden( const EventObject& evt );

	// XPaintListener
	virtual void		windowPaint( const PaintEvent& evt );
	
	// XEventListener
	virtual void		disposing( const EventObject& evt );
};

//--------------------------------------------------------------------------------------------------
SMART_UNO_IMPLEMENTATION( Listener_Impl, UsrObject );

//--------------------------------------------------------------------------------------------------
BOOL Listener_Impl::queryInterface( Uik aUik, XInterfaceRef& rOut )
{
	if (aUik == XMouseListener::getSmartUik())
		rOut = (XMouseListener*)this;
	else if (aUik == XMouseMotionListener::getSmartUik())
		rOut = (XMouseMotionListener*)this;
	else if (aUik == XWindowListener::getSmartUik())
		rOut = (XWindowListener*)this;
	else if (aUik == XFocusListener::getSmartUik())
		rOut = (XFocusListener*)this;
	else if (aUik == XKeyListener::getSmartUik())
		rOut = (XKeyListener*)this;
	else if (aUik == XPaintListener::getSmartUik())
		rOut = (XPaintListener*)this;
	else if (aUik == ((XEventListener*)NULL)->getSmartUik())
		rOut = (XEventListener*)(XMouseListener*)this;
	else
		UsrObject::queryInterface( aUik, rOut );

	return rOut.is();
}

//--------------------------------------------------------------------------------------------------
// XMouseListener
void Listener_Impl::mousePressed( const VclMouseEvent& evt )	{}
void Listener_Impl::mouseReleased( const VclMouseEvent& evt )	{}
void Listener_Impl::mouseEntered( const VclMouseEvent& evt )	{}
void Listener_Impl::mouseExited( const VclMouseEvent& evt )		{}

// XMouseMotionListener
void Listener_Impl::mouseDragged( const VclMouseEvent& evt )	{}
void Listener_Impl::mouseMoved( const VclMouseEvent& evt )		{}

// XKeyListener
void Listener_Impl::keyPressed( const VclKeyEvent& evt )		{}
void Listener_Impl::keyReleased( const VclKeyEvent& evt )		{}

// XFocusListener
void Listener_Impl::focusGained( const FocusEvent& evt )		{}
void Listener_Impl::focusLost( const FocusEvent& evt )			{}

// XWindowListener
void Listener_Impl::windowResized( const WindowEvent& evt )		{}
void Listener_Impl::windowMoved( const WindowEvent& evt )		{}
void Listener_Impl::windowShown( const EventObject& evt )		{}
void Listener_Impl::windowHidden( const EventObject& evt )		{}

// XPaintListener
void Listener_Impl::windowPaint( const PaintEvent& evt )
{
	if (evt.Source.is())
	{
		XControlRef xControl( evt.Source, USR_QUERY );
		if (xControl.is())
		{
			XDeviceRef xDev( xControl->getPeer(), USR_QUERY );
			XGraphicsRef xGraphics = xDev->createGraphics();
			xGraphics->drawLine( 0, 0, 200, 200 );
			xGraphics->drawLine( 200, 0, 0, 200 );
		}
	}
}

// XEventListener
void Listener_Impl::disposing( const EventObject& evt )		{}

//==================================================================================================
class PluginApplication_Impl
	: public Application
{
public:
    virtual void        Main();
    virtual void        ShowStatusText( const XubString& rText );

public:
						PluginApplication_Impl()		{}
	
private:
	void				init();
	void				deinit();

private:
	XInterfaceRef		_xListener;
	XControlRef			_xPdfControl;
	XControlRef			_xMpgControl;
	XPluginRef			_xPdfPlugin;
	XPluginRef			_xMpgPlugin;
	XPluginManagerRef	_xManager;
	
	WorkWindow*			_pWorkWin;
};

PluginApplication_Impl g_App;

#ifdef __MWERKS__
Application* pApp = &g_App;
#endif


//--------------------------------------------------------------------------------------------------
void PluginApplication_Impl::Main()
{
//  	void TestErrcodes();
//  	TestErrcodes();
	
	EnterMultiThread();
	SetAppName( "PluginDemo" );
	EnableSVLook();
	createAndSetDefaultServiceManager();
	// !!!
	InitExtVclToolkit();
	RegisterUnoServices();

	void registerPluginService( const XServiceManagerRef& );
	registerPluginService( getGlobalServiceManager() );

	init();
	
	Execute();

	deinit();
}

//--------------------------------------------------------------------------------------------------
void PluginApplication_Impl::init()
{
	_xListener = XInterfaceRef( (UsrObject*)new Listener_Impl() );
	
	_pWorkWin = new WorkWindow( NULL, WB_APP | WB_STDWORK );
	_pWorkWin->Show();
	XWindowPeerRef xParent = _pWorkWin->GetComponentInterface();
	//
	XServiceManagerRef xMgr		= getGlobalServiceManager();
	XInterfaceRef xInst			= xMgr->createInstance( L"stardiv.plugin.PluginManager" );
	xInst->queryInterface( XPluginManager::getSmartUik(), _xManager );
	Sequence<PluginDescription> aPlugins = _xManager->getPluginDescriptions();
	XPluginContextRef xContext = _xManager->createPluginContext();

	// start plugin
	const PluginDescription* pDescr = aPlugins.getConstArray();
	for ( USHORT nPos = aPlugins.getLen(); nPos--; )
	{
 		if (pDescr[nPos].Mimetype == L"application/pdf")
 		{
 			_xPdfPlugin = _xManager->createPlugin(
 				xContext,
 				PluginMode_FULL,
 				Sequence<UString>(),
 				Sequence<UString>(),
 				pDescr[nPos]
 				);
        }
#ifdef OS2
        else if( pDescr[nPos].Mimetype == L"toolkit/clock" )
#else
        else if( pDescr[nPos].Mimetype == L"video/mpeg" )
#endif
		{
			_xMpgPlugin = _xManager->createPlugin(
				xContext,
				PluginMode_FULL,
				Sequence<UString>(),
				Sequence<UString>(),
				pDescr[nPos]
				);
		}
	}
	XDataSourceRef pdfSource = new FileSource(
#ifdef UNX
		"/home2/usr/pl/HOWTO/pgpr.pdf"
#elif defined WNT
		"i:\\misc\\plugin.ns\\pgpr.pdf"
#elif defined OS2
		"d:\\docu\\pgpr.pdf"
#endif
		);
	XDataSourceRef mpgSource = new FileSource(
#ifdef UNX
		"/home2/usr/pl/HOWTO/test.mpg"
#elif defined WNT
		"i:\\misc\\plugin.ns\\test.mpg"
#elif defined OS2
		"d:\\docu\\basketbl.avi"
#endif

		);

	XToolkitRef xToolkit( xMgr->createInstance( L"stardiv.uno.awt.Toolkit" ), USR_QUERY );

	if ( _xPdfPlugin.is() && _xPdfPlugin->queryInterface( XControl::getSmartUik(), _xPdfControl ))
	{
		_xPdfControl->createPeer( xToolkit, xParent );
		XWindowRef xWin( _xPdfControl, USR_QUERY );
		xWin->setPosSize( 50, 50, 400, 400, WINDOW_POSSIZE_ALL );
		xWin->setVisible( TRUE );
		_xPdfPlugin->provideNewStream(
			UString(L"application/pdf"),
			pdfSource,
#ifdef UNX
			UString(L"/home2/usr/pl/HOWTO/pgpr.pdf"),
#elif defined WNT
			UString(L"i:\\misc\\plugin.ns\\pgpr.pdf"),
#elif defined OS2
			UString(L"d:\\docu\\pgpr.pdf"),
#endif
			1409710, 0, TRUE );
	}
	if ( _xMpgPlugin.is() && _xMpgPlugin->queryInterface( XControl::getSmartUik(), _xMpgControl ))
	{
		_xMpgControl->createPeer( xToolkit, xParent );
		XWindowRef xWin( _xMpgControl, USR_QUERY );
		xWin->setPosSize( 500, 50, 400, 400, WINDOW_POSSIZE_ALL );
		xWin->setVisible( TRUE );
		_xMpgPlugin->provideNewStream(
#ifdef OS2
			UString(L"toolkit/clock"),
#else
			UString(L"video/mpeg"),
#endif
			mpgSource,
#ifdef UNX
			L"/home2/usr/pl/HOWTO/test.mpg",
#elif defined WNT
			L"i:\\misc\\plugin.ns\\test.mpg",
#elif defined OS2
			L"d:\\docu\\clocl.clk",
#endif
			0, 0, FALSE );
    }
	if( _xPdfPlugin.is() )
	{
		XControlModelRef xModel = _xPdfControl->getModel();
		if( xModel.is () )
		{
			XPropertySetRef xProperty;
			xModel->queryInterface( XPropertySet::getSmartUik(), xProperty );
			if( xProperty.is() )
			{
				UsrAny aAny;
#ifdef UNX
				aAny.setString( L"/home2/usr/pl/HOWTO/conduit.pdf" );
#elif defined WNT
				aAny.setString( L"x:\\pl\\conduit.pdf" );
#elif defined OS2
				aAny.setString( L"d:\\docu\\conduit.pdf" );
#endif
                xProperty->setPropertyValue( L"URL", aAny );
			}
		}
    }

#ifdef OS2
    if( _xMpgPlugin.is() )
	{
		XControlModelRef xModel = _xMpgControl->getModel();
		if( xModel.is () )
		{
			XPropertySetRef xProperty;
			xModel->queryInterface( XPropertySet::getSmartUik(), xProperty );
			if( xProperty.is() )
			{
				UsrAny aAny;
				aAny.setString( L"d:\\docu\\clock.clk" );
//				xProperty->setPropertyValue( L"URL", aAny );
			}
		}
	}
#endif

}

//--------------------------------------------------------------------------------------------------
void PluginApplication_Impl::deinit()
{
	_xPdfPlugin = XPluginRef();
	_xMpgPlugin = XPluginRef();
	_xMpgControl->dispose();
	_xPdfControl->dispose();
	_xPdfControl = XControlRef();
	_xMpgControl = XControlRef();
	_xListener = XInterfaceRef();
	
	_pWorkWin->Hide();
	delete _pWorkWin;
}

//--------------------------------------------------------------------------------------------------
void PluginApplication_Impl::ShowStatusText( const XubString& rStatus )
{
	Application::GetAppWindow()->SetText( rStatus );
}


