/*************************************************************************
#*
#*  $RCSfile: PropertyInfoReg.cxx,v $
#*
#*  LogicalContentPropertyInfoProviderRegistration
#*
#*  Ersterstellung      RS 07.02.2000
#*
#*  Letzte Aenderung    $Author: hr $ $Date: 2000/09/18 16:16:52 $
#*
#*  $Revision: 1.1.1.1 $
#*
#*  $Source: /cvs/oo/util/extensions/source/propertyinfo/PropertyInfoReg.cxx,v $
#*
#*  Copyright (c) 1999 Sun Microsystems Inc.
#*
#*************************************************************************/


#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif

#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif

#include <uno/dispatcher.h> // declaration of generic uno interface
#include <uno/mapping.hxx> // mapping stuff
#include <cppuhelper/queryinterface.hxx> // helper for queryInterface() impl
#include <cppuhelper/factory.hxx> // helper for component factory
#include "PropertyInfo.hxx"

using namespace com::sun::star::registry;
using namespace cppu;


//---------------------------------------------------------------------------

Reference< XInterface > createPropertyInfoService(
	const Reference< XMultiServiceFactory >& xMgr )
{
	return SAL_STATIC_CAST( OWeakObject *, new OPropertyInfoProviderService(  xMgr ) );
}


//---------------------------------------------------------------------------

extern "C" sal_Bool SAL_CALL writeComponentInfo( uno_Interface* pXUnoKey )
{
	if( pXUnoKey )
	{
		Mapping aUno2Current( UNO_LB_UNO, CPPU_CURRENT_LANGUAGE_BINDING_NAME );
		if( aUno2Current.is() )
		{
			XRegistryKey* pKey = (XRegistryKey*)aUno2Current.mapInterface(
				pXUnoKey,  ::getCppuType((const Reference< XRegistryKey >*)0)
				);
			if( pKey )
			{
				Reference< XRegistryKey > xKey( pKey );
				pKey->release();
				Reference< XRegistryKey > xNewKey = xKey->createKey(
					L"/com.sun.star.extensions.StandardContentPropertyInfo/UNO/SERVICES/com.sun.star.hierarchy.LogicalContentPropertyInfo" );
				return sal_True;
			}
		}
	}
	return sal_False;
}

//---------------------------------------------------------------------------

extern "C" uno_Interface* SAL_CALL createComponentFactory(
	const sal_Unicode* pImplementationName,
	uno_Interface* pXUnoSMgr,
	uno_Interface* pXUnoKey
	)
{
	uno_Interface* pRet = 0;

	Mapping aUno2Current( UNO_LB_UNO, CPPU_CURRENT_LANGUAGE_BINDING_NAME );
	Mapping aCurrent2Uno( CPPU_CURRENT_LANGUAGE_BINDING_NAME, UNO_LB_UNO );

	if( aCurrent2Uno.is() && aUno2Current.is() )
	{
		Reference< XMultiServiceFactory > xMgr;
		if( pXUnoSMgr )
		{
			XMultiServiceFactory* pSF = (XMultiServiceFactory*)aUno2Current.mapInterface( pXUnoSMgr, ::getCppuType( (const Reference< XMultiServiceFactory >*)0 ) );
			if( pSF )
			{
				xMgr = pSF;
				pSF->release();
			}
		}

		if( ! rtl_ustr_ascii_compare( pImplementationName, "com.sun.star.extensions.StandardContentPropertyInfo" ) )
		{
			OUString				aServiceName( L"com.sun.star.hierarchy.LogicalContentPropertyInfo" );
			Sequence< OUString >	aServiceNameList( &aServiceName, 1 );

			Reference< XSingleServiceFactory > xFactory( createSingleFactory( xMgr, pImplementationName, createPropertyInfoService, aServiceNameList ) );
			if( xFactory.is() )
				pRet = (uno_Interface*)aCurrent2Uno.mapInterface( xFactory.get(), ::getCppuType( (const Reference< XSingleServiceFactory >*) 0 ) );
		}

	}

	return pRet;
}

/************************************************************************

      $Log: PropertyInfoReg.cxx,v $
      Revision 1.1.1.1  2000/09/18 16:16:52  hr
      initial import

      Revision 1.1  2000/02/24 17:12:33  rs
      XLogicalContentPropertyService


*************************************************************************/

