#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:53 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..
PRJNAME=extensions
TARGET=syn

UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
ENABLE_EXCEPTIONS=TRUE
USE_DEFFILE=TRUE

# --- Settings ----------------------------------

.INCLUDE :	$(PRJ)$/util$/makefile.pmk

# --- Types -------------------------------------

UNOTYPES=\
	com.sun.star.registry.XRegistryKey							\
	com.sun.star.io.XInputStream								\
	com.sun.star.io.XOutputStream								\
	com.sun.star.bridge.XConnectionClientSide					\
	com.sun.star.container.XIndexAccess							\
	com.sun.star.container.XSet									\
	com.sun.star.lang.XComponent								\
	com.sun.star.lang.XInitialization							\
	com.sun.star.lang.XMultiServiceFactory						\
	com.sun.star.lang.XSingleServiceFactory						\
	com.sun.star.loader.XImplementationLoader					\
	com.sun.star.registry.XImplementationRegistration			\
	com.sun.star.registry.XRegistryKey							\
	com.sun.star.registry.XSimpleRegistry						\
	com.sun.star.task.XInteractionHandler						\
	com.sun.star.ucb.CHAOSProgressStart							\
	com.sun.star.ucb.ContentAction								\
	com.sun.star.ucb.XCommandTaskProcessor						\
	com.sun.star.ucb.XContentIdentifierFactory					\
	com.sun.star.ucb.XContentProviderManager					\
	com.sun.star.ucb.XContentProviderServiceRegistry			\
	com.sun.star.ucb.XPropertyTaskProcessor						\
	com.sun.star.ucb.XContentCreator							\
	com.sun.star.ucb.XContentCreationListener					\
	com.sun.star.ucb.XContentCreationNotifier					\
	com.sun.star.ucb.XResultAcceptor							\
	com.sun.star.ucb.OpenCommandArgument						\
	com.sun.star.chaos.OpenMode									\
	com.sun.star.uno.TypeClass									\
	com.sun.star.uno.XInterface									\
	com.sun.star.uno.XWeak										\
	com.sun.star.sync.SyncScheme								\
	com.sun.star.sync.SyncElement								\
	com.sun.star.sync.SyncInfo									\
	com.sun.star.sync.SyncEvent									\
	com.sun.star.sync.SyncAction								\
	com.sun.star.sync.SyncMode									\
	com.sun.star.sync.SyncOptions								\
	com.sun.star.sync.SyncType									\
	com.sun.star.sync.XSyncCollector							\
	com.sun.star.sync.XSynchronizer	

# --- Files -------------------------------------

CXXFILES=	syncuno.cxx				\
			synccont.cxx			\
			syncbase.cxx			\
			synccoll.cxx			\
			synchron.cxx			

SLOFILES=	$(SLO)$/syncuno.obj		\
			$(SLO)$/synccont.obj	\
			$(SLO)$/syncbase.obj	\
			$(SLO)$/synccoll.obj	\
			$(SLO)$/synchron.obj	

# --- Library -----------------------------------

SHL1TARGET=$(TARGET)$(UPD)$(DLLPOSTFIX)
SHL1OBJS=$(SLOFILES)
SHL1STDLIBS=\
	$(CPPULIB)			\
	$(CPPUHELPERLIB)	\
	$(VOSLIB)			\
	$(SALLIB)			\
	$(TOOLSLIB)			\
	$(UCBHELPERLIB)	

.IF "$(GUI)" == "UNX"
SHL1STDLIBS += -lbdb
.ENDIF

.IF "$(GUI)" == "WNT"
SHL1STDLIBS += $(LIBPRE)$(SOLARLIBDIR)$/libbdb.lib
.ENDIF

SHL1DEPN=
SHL1IMPLIB=	i$(SHL1TARGET)
SHL1LIBS=	$(SLB)$/$(TARGET).lib
SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

DEF1NAME=$(SHL1TARGET)
DEF1EXPORTFILE=exports.dxp

# --- Targets ----------------------------------

.INCLUDE : target.mk
