#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:53 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..
PRJNAME=extensions
TARGET=vfs
LIBTARGET=NO
USE_DEFFILE=TRUE

ENABLE_EXCEPTIONS=TRUE
TARGETTYPE=GUI

# --- Settings ----------------------------------

.INCLUDE : settings.mk

# --- Types -------------------------------------


UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb

UNOUCROUT=$(OUT)$/inc$/$(PRJNAME)$/$(TARGET)
INCPRE+=$(UNOUCROUT)

# --- Types -------------------------------------

UNOTYPES=\
	com.sun.star.hierarchy.XLineInputStream				\
	com.sun.star.hierarchy.XContentHierarchy			\
	com.sun.star.ucb.XContent							\
	com.sun.star.ucb.ContentAction						\
	com.sun.star.ucb.ContentEvent						\
	com.sun.star.ucb.OpenCommandArgument				\
	com.sun.star.ucb.XCommandTaskProcessor				\
	com.sun.star.ucb.XPropertyTaskProcessor				\
	com.sun.star.ucb.XContentTask						\
	com.sun.star.ucb.XCommandTask						\
	com.sun.star.ucb.XPropertyTask						\
	com.sun.star.ucb.XContentTaskClient					\
	com.sun.star.ucb.XContentTaskEnvironment			\
	com.sun.star.ucb.ContentTaskStatus					\
	com.sun.star.ucb.XCommandInfo						\
	com.sun.star.ucb.XContentIdentifier					\
	com.sun.star.ucb.XContentIdentifierFactory			\
	com.sun.star.ucb.XContentCreator					\
	com.sun.star.ucb.XContentProvider					\
	com.sun.star.ucb.InteractiveIOException				\
	com.sun.star.task.XInteractionApprove				\
	com.sun.star.task.XInteractionDisapprove			\
	com.sun.star.task.XInteractionAbort					\
	com.sun.star.task.XInteractionRetry					\
	com.sun.star.util.DateTime							\
	com.sun.star.lang.XSingleServiceFactory				\
	com.sun.star.lang.XMultiServiceFactory				\
	com.sun.star.lang.XInitialization					\
	com.sun.star.beans.XPropertySet						\
	com.sun.star.beans.XMultiPropertySet				\
	com.sun.star.beans.XFastPropertySet					\
	com.sun.star.beans.PropertyAttribute				\
	com.sun.star.registry.XRegistryKey					\
	com.sun.star.registry.XSimpleRegistry				\
	com.sun.star.loader.XImplementationLoader			\
	com.sun.star.registry.XImplementationRegistration	\
	com.sun.star.container.XSet							\
	com.sun.star.lang.XComponent						\
	com.sun.star.container.XIndexAccess					\
	com.sun.star.io.XConnectable						\
	com.sun.star.io.XInputStream						\
	com.sun.star.io.XOutputStream						\
	com.sun.star.io.XSeekable							\
	com.sun.star.io.XMarkableStream						\
	com.sun.star.io.XActiveDataSource					\
	com.sun.star.io.XActiveDataSink						\
	com.sun.star.io.XActiveDataControl					\
	com.sun.star.uno.XWeak								\
	com.sun.star.uno.TypeClass

# --- Files -------------------------------------

SLOFILES= 	$(SLO)$/vfscontent.obj 				\
			$(SLO)$/vfscontentprovider.obj		\
			$(SLO)$/vfsfoldercontent.obj	   	\
			$(SLO)$/vfsrootcontent.obj	   		\
			$(SLO)$/vfsfilecontent.obj	   		\
			$(SLO)$/vfsfilecontentstream.obj	\
			$(SLO)$/vfspropertytask.obj			\
			$(SLO)$/vfsregistration.obj			\
			$(SLO)$/vfscommandtask.obj			\
 			$(SLO)$/vfshelper.obj

# --- Library -----------------------------------

LIB1TARGET=$(SLB)$/virtfs.lib
LIB1OBJFILES=$(SLOFILES)

SHL1DEPN=makefile.mk
SHL1TARGET=$(TARGET)$(UPD)$(DLLPOSTFIX)
SHL1LIBS=$(LIB1TARGET) $(SLB)/ucbhelper.lib
SHL1STDLIBS=$(USRLIB)	 	\
			$(UNOLIB)	 	\
			$(VOSLIB) 	 	\
			$(SALLIB) 	 	\
        	$(CPPUHELPERLIB)\
        	$(CPPULIB)		\
			$(STORELIB)		\
			$(TOOLSLIB)
SHL1DEF=$(MISC)$/$(SHL1TARGET).def
DEF1EXPORTFILE=$(TARGET).dxp 
DEF1NAME=$(SHL1TARGET)

# --- Files -------------------------------------

APP1DEPN=$(LIB1TARGET)
APP1TARGET  = testvfs
APP1OBJS    = $(OBJ)$/testvfs.obj
APP1LIBS = $(LIB1TARGET) $(SLB)/ucbhelper.lib
APP1STDLIBS = \
        $(CPPUHELPERLIB)			\
        $(CPPULIB)					\
        $(VOSLIB)					\
        $(VCLLIB)					\
        $(TOOLSLIB)					\
        $(SVTOOLLIB)					\
        $(SO2LIB)					\
        $(STORELIB)					\
        $(SOTLIB)					\
        $(SALLIB)


# --- Targets ----------------------------------

.INCLUDE : target.mk

