#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:16:54 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

#.UNDEF PRJPCH

PRJNAME=extension
TARGET=test
USE_LDUMP2=TRUE
ENABLE_EXCEPTIONS=TRUE
TARGETTYPE=CUI

# --- Settings -----------------------------------------------------

.INCLUDE :  $(PRJ)$/util$/makefile.pmk

# ------------------------------------------------------------------

CXXFILES= \
            testjavavm.cxx \
            testpgpfactory.cxx

SLOFILES= \
            $(SLO)$/testjavavm.obj \
            $(SLO)$/testpgpfactory.obj


LIB1TARGET= 	$(SLB)$/b$(TARGET).lib
LIB1OBJFILES=  	$(SLO)$/testjavavm.obj

SHL1TARGET= etl$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= ietl
SHL1STDLIBS= $(ONELIB) $(USRLIB) $(TOOLSLIB) $(OSLLIB) $(UNOLIB) $(VOSLIB)


#.IF "$(GUI)"=="WNT"
#SHL1STDLIBS+=$(LIBCIMT)
#.ENDIF

SHL1LIBS=	$(LIB1TARGET)
SHL1DEPN=	$(LIB1TARGET)
SHL1DEF=	$(MISC)$/$(SHL1TARGET).def
DEF1NAME	=$(SHL1TARGET)
			 
DEF1DEPN	=$(MISC)$/etl$(UPD)$(DLLPOSTFIX).flt $(SLO)$/testjavavm.obj
DEFLIB1NAME =b$(TARGET)
DEF1DES 	=ExtensionsJavaVM - TestDll

# ------------------------------------------------------------------

LIB2TARGET= 	$(SLB)$/pgftest.lib
LIB2OBJFILES=  	$(SLO)$/testpgpfactory.obj

SHL2TARGET= tpf$(UPD)$(DLLPOSTFIX)
SHL2IMPLIB= itpf
SHL2STDLIBS= $(ONELIB) $(USRLIB) $(TOOLSLIB) $(OSLLIB) $(UNOLIB) $(VOSLIB)

#.IF "$(GUI)"=="WNT"
#SHL1STDLIBS+=$(LIBCIMT)
#.ENDIF

SHL2LIBS=	$(LIB2TARGET)
SHL2DEPN=	$(LIB2TARGET)
SHL2DEF=	$(MISC)$/$(SHL2TARGET).def
DEF2NAME	=$(SHL2TARGET)
			 
DEF2DEPN	=$(MISC)$/tpf$(UPD)$(DLLPOSTFIX).flt $(SLO)$/testpgpfactory.obj
DEFLIB2NAME =pgftest
DEF2DES 	=ExtensionsPGPFactory - TestDll

# ------------------------------------------------------------------

APP2TARGET=	servicetest
APP2OBJS=	$(OBJ)$/servicetest.obj
APP2STDLIBS=$(TOOLSLIB)		\
			$(VCLLIB)		\
			$(ONELIB)		\
			$(USRLIB)		\
			$(UNOLIB)		\
			$(VOSLIB)		\
			$(OSLLIB)		\
			$(RTLLIB)		\
			itpf.lib

.IF "$(GUI)"=="WNT" || "$(GUI)"=="OS2"
APP2STDLIBS+=ietl.lib
.ELSE
APP2STDLIBS+=-lietl$(UPD)$(DLLPOSTFIX)
.ENDIF

APP2DEF=	$(MISC)$/$(APP2TARGET).def

# --- Targets ------------------------------------------------------

#.INCLUDE :  target.mk

.IF "$(depend)" == ""
ALL: \
	ALLTAR
.ELSE
ALL: \
	ALLDEP
.ENDIF

.INCLUDE :  target.mk

# --- SO2-Filter-Datei ---


$(MISC)$/etl$(UPD)$(DLLPOSTFIX).flt:
	@echo ------------------------------
	@echo Making: $@
	@echo WEP>$@
	@echo LIBMAIN>>$@
	@echo LibMain>>$@
.IF "$(GUI)" != "UNX"
	@echo AVException>>$@
	@echo AVUsrException>>$@
.ENDIF

$(MISC)$/tpf$(UPD)$(DLLPOSTFIX).flt:
	@echo ------------------------------
	@echo Making: $@
	@echo WEP>$@
	@echo LIBMAIN>>$@
	@echo LibMain>>$@
.IF "$(GUI)" != "UNX"
	@echo AVException>>$@
	@echo AVUsrException>>$@
.ENDIF


