#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1 $
#
#   last change: $Author: csaba.borbola $ $Date: 2000/09/29 10:24:27 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************


PRJ=..$/..

PRJNAME=3rdparty
TARGET=neon
LIBTARGET=NO

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

# Mac OS 9 cannot handle Unix style paths
.IF "$(OS)" == "MACOS"
CFLAGS+=-I$(shell $(UNIX2MACPATH) ..)
.ELSE
CFLAGS+=-I..
.ENDIF

CDEFS+=-DHAVE_CONFIG_H

SLOFILES= \
	$(SLO)$/base64.obj \
	$(SLO)$/dates.obj \
	$(SLO)$/dav_207.obj \
	$(SLO)$/dav_basic.obj \
	$(SLO)$/dav_locks.obj \
	$(SLO)$/dav_props.obj \
	$(SLO)$/hip_xml.obj \
	$(SLO)$/http_auth.obj \
	$(SLO)$/http_basic.obj \
	$(SLO)$/http_cookies.obj \
	$(SLO)$/http_request.obj \
	$(SLO)$/http_utils.obj \
	$(SLO)$/md5.obj \
	$(SLO)$/neon_i18n.obj \
	$(SLO)$/snprintf.obj \
	$(SLO)$/socket.obj \
	$(SLO)$/strcasecmp.obj \
	$(SLO)$/string_utils.obj \
	$(SLO)$/uri.obj \
	$(SLO)$/xalloc.obj


LIB1TARGET=$(SLB)$/$(TARGET).lib
LIB1ARCHIV=$(LB)$/lib$(TARGET).a
LIB1OBJFILES=$(SLOFILES)

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk
