/*************************************************************************
 *
 *  $RCSfile: Image.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _FRM_IMAGE_HXX_
#include "Image.hxx"
#endif

#ifndef _COM_SUN_STAR_FORM_XSUBMIT_HPP_
#include <com/sun/star/form/XSubmit.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_SYSTEMPOINTER_HPP_
#include <com/sun/star/awt/SystemPointer.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_FORMCOMPONENTTYPE_HPP_
#include <com/sun/star/form/FormComponentType.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_ACTIONEVENT_HPP_
#include <com/sun/star/awt/ActionEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XACTIONLISTENER_HPP_
#include <com/sun/star/awt/XActionListener.hpp>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif

#ifndef _USR_SMARTCONV_HXX_
#include "conversion.hxx"
#endif
#ifndef _FRM_SERVICES_HXX_
#include "services.hxx"
#endif

#ifndef _UTL_CONTAINER_HXX_
#include <unotools/container.hxx>
#endif

//.........................................................................
namespace frm
{
//.........................................................................

	namespace starframe = ::com::sun::star::frame;

//==================================================================
// OImageControl
//==================================================================
//------------------------------------------------------------------------------
staruno::Sequence<staruno::Type> OImageControl::_getTypes()
{
	static staruno::Sequence<staruno::Type> aTypes;
	if (!aTypes.getLength())
	{
		// my base class
		staruno::Sequence<staruno::Type> aBaseClassTypes = OControl::_getTypes();

		staruno::Sequence<staruno::Type> aOwnTypes(2);
		staruno::Type* pOwnTypes = aOwnTypes.getArray();
		pOwnTypes[0] = getCppuType((staruno::Reference<starbeans::XPropertyChangeListener>*)NULL);
		pOwnTypes[1] = getCppuType((staruno::Reference<starform::XApproveActionBroadcaster>*)NULL);

		aTypes = concatSequences(aBaseClassTypes, aOwnTypes);
	}
	return aTypes;
}

//------------------------------------------------------------------------------
OImageControl::OImageControl(const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory, const ::rtl::OUString& _aService)
				:OControl(_rxFactory, _aService)
				,m_aApproveActionListeners(m_aMutex)
				,m_aActionListeners(m_aMutex)
				,m_pThread(NULL)
{
}

//------------------------------------------------------------------------------
OImageControl::~OImageControl()
{
	if (!OComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

// UNO Anbindung
//------------------------------------------------------------------------------
staruno::Any SAL_CALL OImageControl::queryAggregation(const staruno::Type& _rType) throw (staruno::RuntimeException)
{
	staruno::Any aReturn;

	aReturn = OControl::queryAggregation(_rType);
	if (!aReturn.hasValue())
		aReturn = ::cppu::queryInterface(_rType
			,static_cast<starform::XApproveActionBroadcaster*>(this)
			,static_cast<starbeans::XPropertyChangeListener*>(this)
		);

	return aReturn;
}

// starform::XApproveActionBroadcaster
//------------------------------------------------------------------------------
void OImageControl::addApproveActionListener(
		const staruno::Reference<starform::XApproveActionListener>& l) throw( staruno::RuntimeException )
{
	m_aApproveActionListeners.addInterface(l);
}

//------------------------------------------------------------------------------
void OImageControl::removeApproveActionListener(
		const staruno::Reference<starform::XApproveActionListener>& l) throw( staruno::RuntimeException )
{
	m_aApproveActionListeners.removeInterface(l);
}

// OComponentHelper
//------------------------------------------------------------------------------
void OImageControl::disposing()
{
	starlang::EventObject aEvt(static_cast<staruno::XWeak*>(this));
	m_aApproveActionListeners.disposeAndClear(aEvt);
	m_aActionListeners.disposeAndClear(aEvt);

	{
		::osl::MutexGuard aGuard( m_aMutex );
		if( m_pThread )
		{
			m_pThread->release();
			m_pThread = NULL;
		}
	}

	OControl::disposing();
}

//------------------------------------------------------------------------------
void OImageControl::propertyChange( const starbeans::PropertyChangeEvent& rEvt )
	throw( staruno::RuntimeException )
{
	staruno::Reference<starawt::XWindowPeer>  xPeer(getPeer());
	if (!xPeer.is())
		return;

	// Wenn eine starutil::URL gesetzt worden ist, muss die Hand angezeigt werden
	if( ( rEvt.PropertyName == PROPERTY_TARGET_URL ) &&
		( rEvt.NewValue.getValueType().getTypeClass() == ::com::sun::star::uno::TypeClass_STRING ) )
	{

		staruno::Reference<starawt::XPointer> xPoint(
			m_xServiceFactory->createInstance(SRV_AWT_POINTER), staruno::UNO_QUERY);
		if (xPoint.is())
			if (getString(rEvt.NewValue).getLength())
				xPoint->setType(starawt::SystemPointer::REFHAND);
			else
				xPoint->setType(starawt::SystemPointer::ARROW);

		xPeer->setPointer(xPoint);
	}
}

// starawt::XControl
//------------------------------------------------------------------------------
void SAL_CALL OImageControl::createPeer(const staruno::Reference<starawt::XToolkit>& _rxToolkit, const staruno::Reference<starawt::XWindowPeer>& Parent) throw( staruno::RuntimeException )
{
	OControl::createPeer(_rxToolkit, Parent);
	staruno::Reference<starawt::XWindowPeer>  xPeer = getPeer();

	// Pointer umsetzen
	if (!xPeer.is())
		return;

	staruno::Reference<starbeans::XFastPropertySet>  xSet(getModel(), staruno::UNO_QUERY);
	if (xSet.is())
	{
		// ist eine TargetUrl gesetzt, wird die Refhand verwendet
		if (getString(xSet->getFastPropertyValue(PROPERTY_ID_TARGET_URL)).getLength())
		{
			staruno::Reference<starawt::XPointer> xPoint(
				m_xServiceFactory->createInstance(SRV_AWT_POINTER), staruno::UNO_QUERY);
			if (xPoint.is())
				xPoint->setType(starawt::SystemPointer::REFHAND);
			xPeer->setPointer(xPoint);
		}
	}

	// dem ImageProducer einen neuen Consumer bekannt geben
	staruno::Reference<starform::XImageProducerSupplier>  xImgSrc(getModel(), staruno::UNO_QUERY);
	if (!xImgSrc.is())
		return;

	staruno::Reference<starawt::XImageProducer>  xImgProd = xImgSrc->getImageProducer();
	staruno::Reference<starawt::XImageConsumer>  xImgCons(xPeer, staruno::UNO_QUERY);

	xImgProd->addConsumer(xImgCons);
	xImgProd->startProduction();
}

//------------------------------------------------------------------------------
sal_Bool OImageControl::setModel(const staruno::Reference<starawt::XControlModel>& Model)
{
	staruno::Reference<starbeans::XPropertySet>  xSet(getModel(), staruno::UNO_QUERY);
	if (xSet.is())
		xSet->removePropertyChangeListener(PROPERTY_TARGET_URL, this);

	sal_Bool bRes = OControl::setModel(Model);
	if (bRes)
	{
		xSet = staruno::Reference<starbeans::XPropertySet> (Model, staruno::UNO_QUERY);
		if (xSet.is())
			xSet->addPropertyChangeListener(PROPERTY_TARGET_URL, this);
	}
	return bRes;
}

//------------------------------------------------------------------------------
staruno::Reference< starframe::XModel >  OImageControl::getXModel(const InterfaceRef& xIface) const
{
	staruno::Reference< starframe::XModel >  xModel(xIface, staruno::UNO_QUERY);
	if (xModel.is())
		return xModel;
	else
	{
		staruno::Reference<starcontainer::XChild>  xChild(xIface, staruno::UNO_QUERY);
		if (xChild.is())
		{
			InterfaceRef  xParent = xChild->getParent();
			return getXModel(xParent);
		}
		else
			return NULL;
	}
}

//------------------------------------------------------------------------------
// Diese Methode wird auch aus einem Thread gerufen und muss deshalb
// thread-safe sein.
void OImageControl::actionPerformed_Impl(sal_Bool bNotifyListener, const starawt::MouseEvent& rEvt)
{
	if( bNotifyListener )
	{
		sal_Bool bCanceled = sal_False;
		::cppu::OInterfaceIteratorHelper aIter(m_aApproveActionListeners);
		starlang::EventObject aEvt(static_cast<staruno::XWeak*>(this));
		while( !bCanceled && aIter.hasMoreElements() )
		{
			staruno::XInterface *pNext = aIter.next();
			// Jede approveAction-Methode muss thread-safe sein!!!
			if( !((starform::XApproveActionListener*)pNext)->approveAction(aEvt) )
				bCanceled = sal_True;
		}

		if (bCanceled)
			return;
	}

	// Ob der Rest des Codes Thread-Safe ist weiss man nicht genau. Deshalb
	// wird das meiste bei gelocktem Solar-Mutex erledigen.
	staruno::Reference<starbeans::XPropertySet>  xSet;
	InterfaceRef  xParent;
	starform::FormButtonType eButtonType;
	{
		::vos::OGuard aGuard( Application::GetSolarMutex() );

		// Parent holen
		staruno::Reference<starform::XFormComponent>  xComp(getModel(), staruno::UNO_QUERY);
		if (!xComp.is())
			return;

		xParent = xComp->getParent();
		if (!xParent.is())
			return;

		// Welchen ButtonType haben wir?
		if (!query_interface((::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >)xComp, xSet))
			return;
		eButtonType = *(starform::FormButtonType*)xSet->getPropertyValue(PROPERTY_BUTTONTYPE).getValue();
	}

	switch (eButtonType)
	{
		case starform::FormButtonType_RESET:
		{
			// reset-Methoden muessen thread-safe sein!
			staruno::Reference<starform::XReset>  xReset(xParent, staruno::UNO_QUERY);
			if (!xReset.is())
				return;

			xReset->reset();
		}
		break;

		case starform::FormButtonType_SUBMIT:
		{
			// submit-Methoden muessen thread-safe sein!
			staruno::Reference<starform::XSubmit>  xSubmit(xParent, staruno::UNO_QUERY);
			if (!xSubmit.is())
				return;

			xSubmit->submit(this, rEvt);
		}
		break;

		case starform::FormButtonType_URL:
		{
			::vos::OGuard aGuard( Application::GetSolarMutex() );

			staruno::Reference< starframe::XModel >  xModel = getXModel(xParent);
			if (!xModel.is())
				return;

			///////////////////////////////////////////////////////////////////////
			// Jetzt starutil::URL ausfuehren
			staruno::Reference< starframe::XController >  xController = xModel->getCurrentController();
			if (!xController.is())
				return;

			staruno::Reference< starframe::XFrame >  xFrame = xController->getFrame();
			if( !xFrame.is() )
				return;

			starutil::URL aURL;
			aURL.Complete =
				getString(xSet->getPropertyValue(PROPERTY_TARGET_URL));

			staruno::Reference<starutil::XURLTransformer>
				xTransformer(m_xServiceFactory->createInstance(
					::rtl::OUString::createFromAscii("com.sun.star.util.URLTransformer")), staruno::UNO_QUERY);

			if (xTransformer.is())
				xTransformer->parseSmart( aURL, ::rtl::OUString::createFromAscii(INET_FILE_SCHEME) );

			::rtl::OUString aTargetFrame;
			xSet->getPropertyValue(PROPERTY_TARGET_FRAME) >>= aTargetFrame;

			staruno::Reference< starframe::XDispatch >  xDisp = staruno::Reference< starframe::XDispatchProvider > (xFrame,staruno::UNO_QUERY)->queryDispatch( aURL, aTargetFrame,
					starframe::FrameSearchFlag::SELF | starframe::FrameSearchFlag::PARENT |
					starframe::FrameSearchFlag::SIBLINGS | starframe::FrameSearchFlag::CREATE );

			staruno::Sequence<starbeans::PropertyValue> aArgs(1);
			starbeans::PropertyValue& rProp = aArgs.getArray()[0];
			rProp.Name = ::rtl::OUString::createFromAscii("Referer");
			rProp.Value <<= xModel->getURL();

			if (xDisp.is())
				xDisp->dispatch( aURL, aArgs );
		}	break;
		default:
		{
				// notify the action listeners for a push button
			starawt::ActionEvent aEvt(static_cast<staruno::XWeak*>(this), m_aActionCommand);
			NOTIFY_LISTENERS(m_aActionListeners, starawt::XActionListener, actionPerformed, aEvt);
		}
	}
}


//==================================================================
// OImageModel
//==================================================================
//------------------------------------------------------------------------------
staruno::Sequence<staruno::Type> OImageModel::_getTypes()
{
	static staruno::Sequence<staruno::Type> aTypes;
	if (!aTypes.getLength())
	{
		// my base class
		staruno::Sequence<staruno::Type> aBaseClassTypes = OControlModel::_getTypes();

		staruno::Sequence<staruno::Type> aOwnTypes(1);
		staruno::Type* pOwnTypes = aOwnTypes.getArray();
		pOwnTypes[0] = getCppuType((staruno::Reference<starform::XImageProducerSupplier>*)NULL);

		aTypes = concatSequences(aBaseClassTypes, aOwnTypes);
	}
	return aTypes;
}

//------------------------------------------------------------------
OImageModel::OImageModel(
					const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory,
					const ::rtl::OUString& _rUnoControlModelTypeName,
					const ::rtl::OUString& rDefault)
			  :OControlModel(_rxFactory, _rUnoControlModelTypeName, rDefault)
			  ,OPropertyChangeListener(m_aMutex)
			  ,m_pProducer(new ImageProducer)
			  ,m_pMedium(NULL)
			  ,m_bDownloading(sal_False)
			  ,m_bProdStarted(sal_False)
{
	increment(m_refCount);
#if SUPD<583
	// ---------------------------------------------------------------------
	// needed as long as the ImageProducer is implemented within the old api
	convertIFace(static_cast<XImageProducer*>(m_pProducer), m_xProducer);
	// ---------------------------------------------------------------------
#else
	m_xProducer = m_pProducer;
#endif

	m_eButtonType = starform::FormButtonType_PUSH;
	
	if (m_xAggregateSet.is())
	{
		OPropertyChangeMultiplexer* pMultiplexer = new OPropertyChangeMultiplexer(this, m_xAggregateSet);
		pMultiplexer->addProperty(PROPERTY_IMAGE_URL);
	}
	decrement(m_refCount);
}

//------------------------------------------------------------------------------
OImageModel::~OImageModel()
{
	if (!OComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
	DBG_ASSERT(m_pMedium == NULL, "OImageModel::~OImageModel : leaving a memory leak ...");
		// spaetestens im dispose sollte das aufgeraeumt worden sein
}

// OComponentHelper
//------------------------------------------------------------------------------
void OImageModel::disposing()
{
	OControlModel::disposing();
	if (m_pMedium)
	{
		delete m_pMedium;
		m_pMedium = NULL;
	}

	m_xProducer = NULL;
}

//------------------------------------------------------------------------------
staruno::Any SAL_CALL OImageModel::queryAggregation(const staruno::Type& _rType) throw (staruno::RuntimeException)
{
	staruno::Any aReturn;

	aReturn = OControlModel::queryAggregation(_rType);
	if (!aReturn.hasValue())
		aReturn = ::cppu::queryInterface(_rType
			,static_cast<starform::XImageProducerSupplier*>(this)
		);

	return aReturn;
}

//------------------------------------------------------------------------------
void OImageModel::getFastPropertyValue(staruno::Any& rValue, sal_Int32 nHandle) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_BUTTONTYPE		: rValue <<= m_eButtonType; break;
		case PROPERTY_ID_TARGET_URL		: rValue <<= m_sTargetURL; break;
		case PROPERTY_ID_TARGET_FRAME	: rValue <<= m_sTargetFrame; break;
		default:
			OControlModel::getFastPropertyValue(rValue, nHandle);
	}
}

//------------------------------------------------------------------------------
void OImageModel::setFastPropertyValue_NoBroadcast(sal_Int32 nHandle, const staruno::Any& rValue)
{
	switch (nHandle)
	{
		case PROPERTY_ID_BUTTONTYPE :
			DBG_ASSERT(isA(rValue, static_cast<starform::FormButtonType*>(NULL)), "OImageModel::setFastPropertyValue_NoBroadcast : invalid type !" );
			rValue >>= m_eButtonType;
			break;

		case PROPERTY_ID_TARGET_URL :
			DBG_ASSERT(rValue.getValueType().getTypeClass() == staruno::TypeClass_STRING, "OImageModel::setFastPropertyValue_NoBroadcast : invalid type !" );
			rValue >>= m_sTargetURL;
			break;

		case PROPERTY_ID_TARGET_FRAME :
			DBG_ASSERT(rValue.getValueType().getTypeClass() == staruno::TypeClass_STRING, "OImageModel::setFastPropertyValue_NoBroadcast : invalid type !" );
			rValue >>= m_sTargetFrame;
			break;

		default:
			OControlModel::setFastPropertyValue_NoBroadcast(nHandle, rValue);
	}
}

//------------------------------------------------------------------------------
sal_Bool OImageModel::convertFastPropertyValue(staruno::Any& rConvertedValue, staruno::Any& rOldValue, sal_Int32 nHandle, const staruno::Any& rValue)
							throw( starlang::IllegalArgumentException )
{
	switch (nHandle)
	{
		case PROPERTY_ID_BUTTONTYPE :
		{
			if (!isA(rValue, static_cast<starform::FormButtonType*>(NULL)))
			{
				throw starlang::IllegalArgumentException();
			}

			starform::FormButtonType eVal;
			rValue >>= eVal;
			if (eVal != m_eButtonType)
			{
				rConvertedValue = rValue;
				rOldValue <<= m_eButtonType;
				return sal_True;
			}
			return sal_False;
		}
		break;

		case PROPERTY_ID_TARGET_URL :
			return tryPropertyValue(rConvertedValue, rOldValue, rValue, m_sTargetURL);

		case PROPERTY_ID_TARGET_FRAME :
			return tryPropertyValue(rConvertedValue, rOldValue, rValue, m_sTargetFrame);

		default:
			return OControlModel::convertFastPropertyValue(rConvertedValue, rOldValue, nHandle, rValue);
	}
}

//------------------------------------------------------------------------------
void OImageModel::StartProduction()
{
	ImageProducer *pImgProd = GetImageProducer();
	if (m_pMedium->GetErrorCode()==0)
	{
		SvStream* pStream = m_pMedium->GetInStream();

		pImgProd->SetImage(*pStream);
		pImgProd->startProduction();
		m_bProdStarted = sal_True;
	}
	else
	{
		pImgProd->SetImage(String());
		delete m_pMedium;
		m_pMedium = 0;
		m_bDownloading = sal_False;
	}
}

//------------------------------------------------------------------------------
void OImageModel::SetURL( const ::rtl::OUString& rURL )
{
	if (m_pMedium || !rURL.len())
	{
		// Den Stream am Producer freigeben, bevor das Medium geloscht wird.
		GetImageProducer()->SetImage(String());
		delete m_pMedium;
		m_pMedium = NULL;
	}

	if (rURL.len())
	{
		if (m_pMedium)
			delete m_pMedium;

		m_pMedium = new SfxMedium(rURL, STREAM_STD_READ, sal_False);
		m_pMedium->SetTransferPriority(SFX_TFPRIO_VISIBLE_HIGHRES_GRAPHIC);
		m_pMedium->SetDataAvailableLink(
				STATIC_LINK(this, OImageModel, DataAvailableLink));

		// Das starframe::XModel suchen, um an die Object-Shell oder zumindest den
		// Referer zu gelangen.
		// Das Model findet man allerdings nur beim Laden von HTML-Dokumenten
		// und dann, wenn die starutil::URL in einem bereits geladenen Dokument
		// geaendert wird. Waehrend des Ladens kommt man nicht an das
		// Model ran.
		staruno::Reference< starframe::XModel >  xModel;
		InterfaceRef  xIfc( *this );
		while( !xModel.is() && xIfc.is() )
		{
			staruno::Reference<starcontainer::XChild>  xChild( xIfc, staruno::UNO_QUERY );
			xIfc = xChild->getParent();
			query_interface(xIfc, xModel);
		}

		// Die Object-Shell suchen, indem wir
		// ueber alle Object-Shells iterieren und deren starframe::XModel mit dem
		// eigenen vergleichen. Als Optimierung probieren wir aber erstmal
		// die aktuelle Object-Shell.
		// wir unser starframe::XModel mit dem aller Object
		SfxObjectShell *pObjSh = 0;

		if( xModel.is() )
		{
			SfxObjectShell *pTestObjSh = SfxObjectShell::Current();
			if( pTestObjSh )
			{
#if SUPD<583
				staruno::Reference< starframe::XModel >  xTestModel;
				convertIFace(pTestObjSh->GetModel(), xTestModel);
#else
				staruno::Reference< starframe::XModel >  xTestModel = pTestObjSh->GetModel();
#endif
				if( xTestModel == xModel )
					pObjSh = pTestObjSh;
			}
			if( !pObjSh )
			{
				SfxObjectShell *pTestObjSh = SfxObjectShell::GetFirst();
				while( !pObjSh && pTestObjSh )
				{
#if SUPD<583
					staruno::Reference< starframe::XModel > xTestModel;
					convertIFace( pTestObjSh->GetModel(), xTestModel );
#else
					staruno::Reference< starframe::XModel > xTestModel = pTestObjSh->GetModel();
#endif
					if( xTestModel == xModel )
						pObjSh = pTestObjSh;
					else
						pTestObjSh = SfxObjectShell::GetNext( *pTestObjSh );
				}
			}
		}

#ifdef USE_REGISTER_TRANSFER
		if( pObjSh )
		{
			// Medium registrieren, damit abgebrochen werden kann
			pObjSh->RegisterTransfer( *m_pMedium );

			// Target-Frame uebertragen, damit auch javascript:-URLs
			// "geladen" werden koennen.
			const SfxMedium *pShMedium = pObjSh->GetMedium();
			if( pShMedium )
				m_pMedium->SetLoadTargetFrame(pShMedium->GetLoadTargetFrame());
		}
		else
		{
			// Keine Object-Shell, aber ein Medium? Dann uebernehmen wir
			// zumindest den Referer.
			if( xModel.is() )
			{
				::rtl::OUString sReferer( xModel->getURL() );
				if( sReferer.len() )
					m_pMedium->SetReferer( OUStringToString(sReferer, CHARSET_SYSTEM) );
			}

			// Keinen Eintrag im Roter Button Menu
			m_pMedium->SetDontCreateCancellable();
		}
#else
		if( pObjSh )
		{
			m_pMedium->SetUsesCache( !pObjSh->IsReloading() );

			// Target-Frame uebertragen, damit auch javascript:-URLs
			// "geladen" werden koennen.
			const SfxMedium *pShMedium = pObjSh->GetMedium();
			if( pShMedium )
				m_pMedium->SetLoadTargetFrame(pShMedium->GetLoadTargetFrame());
		}

		if( xModel.is() )
		{
			::rtl::OUString sReferer( xModel->getURL() );
			if( sReferer.len() )
				m_pMedium->SetReferer( sReferer );
		}

		// Keinen Eintrag im Roter Button Menu
		m_pMedium->SetDontCreateCancellable();
#endif

		// Downloading-Flag auf sal_True setzen. Es werden dann auch
		// Data-Available-Links, wenn wir in den Pending-Staus gelangen.
		m_bDownloading = sal_True;
		m_bProdStarted = sal_False;

		// Download anstossen (Achtung: Kann auch synchron sein).
		m_pMedium->DownLoad(STATIC_LINK(this, OImageModel, DownloadDoneLink));
	}
	else
	{
		GetImageProducer()->startProduction();
	}
}

//------------------------------------------------------------------------------
void OImageModel::DataAvailable()
{
	if (!m_bProdStarted)
		StartProduction();

	GetImageProducer()->NewDataAvailable();
}

//------------------------------------------------------------------------------
void OImageModel::DownloadDone()
{
	DataAvailable();
	m_bDownloading = sal_False;
}

//------------------------------------------------------------------------------
IMPL_STATIC_LINK( OImageModel, DownloadDoneLink, void*, EMPTYARG )
{
	pThis->DownloadDone();
	return 0;
}

//------------------------------------------------------------------------------
IMPL_STATIC_LINK( OImageModel, DataAvailableLink, void*, EMPTYARG )
{
	pThis->DataAvailable();
	return 0;
}

//------------------------------------------------------------------------------
void OImageModel::_propertyChanged( const starbeans::PropertyChangeEvent& rEvt )
	throw( staruno::RuntimeException )
{
	// Wenn eine starutil::URL gesetzt worden ist, muss die noch an den ImageProducer
	// weitergereicht werden.
	::osl::MutexGuard aGuard(m_aMutex);
	SetURL( getString(rEvt.NewValue) );
}

//==================================================================
// OImageControlThread_Impl
//==================================================================
//------------------------------------------------------------------
starlang::EventObject* OImageControlThread_Impl::cloneEvent( const starlang::EventObject* _pEvt ) const
{
	return new starlang::EventObject( *_pEvt );
}

//------------------------------------------------------------------
void OImageControlThread_Impl::processEvent( ::cppu::OComponentHelper *pCompImpl,
											   const starlang::EventObject* pEvt,
											   const staruno::Reference<starawt::XControl>&,
											   sal_Bool )
{
	((OImageControl *)pCompImpl)->actionPerformed_Impl( sal_True, *(starawt::MouseEvent *)pEvt );
}

//.........................................................................
}	// namespace frm
//.........................................................................

