/*************************************************************************
 *
 *  $RCSfile: Image.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _FRM_IMAGE_HXX_
#define _FRM_IMAGE_HXX_

#ifndef _FORMS_FORMCOMPONENT_HXX_
#include "FormComponent.hxx"
#endif

#ifndef _FRM_EVENT_THREAD_HXX_
#include "EventThread.hxx"
#endif

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _UNOTOOLS_PROPERTY_MULTIPLEX_HXX_
#include <unotools/propmultiplex.hxx>
#endif
#ifndef _PRODUCE_HXX
#include <svtools/imgprod.hxx>
#endif

#ifndef _COM_SUN_STAR_FORM_XIMAGEPRODUCERSUPPLIER_HPP_
#include <com/sun/star/form/XImageProducerSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_FORMBUTTONTYPE_HPP_
#include <com/sun/star/form/FormButtonType.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XAPPROVEACTIONLISTENER_HPP_
#include <com/sun/star/form/XApproveActionListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XAPPROVEACTIONBROADCASTER_HPP_
#include <com/sun/star/form/XApproveActionBroadcaster.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

class SfxMedium;

//.........................................................................
namespace frm
{
//.........................................................................

//==================================================================
// OImageModel
//==================================================================
class OImageModel : public starform::XImageProducerSupplier,
					  public OControlModel,
					  public OPropertyChangeListener
{
protected:
	starform::FormButtonType	m_eButtonType;		// Art des Buttons (push,submit,reset)
	::rtl::OUString				m_sTargetURL;		// starutil::URL fuer den starutil::URL-Button
	::rtl::OUString				m_sTargetFrame;		// TargetFrame zum Oeffnen

// ImageProducer stuff
	SfxMedium*						m_pMedium;			// Download-Medium
	sal_Bool						m_bDownloading : 1;	// laeuft ein Download?
	sal_Bool 						m_bProdStarted : 1;
	staruno::Reference<starawt::XImageProducer>  	m_xProducer;
	ImageProducer*									m_pProducer;

	DECL_STATIC_LINK( OImageModel, DataAvailableLink, void* );
	DECL_STATIC_LINK( OImageModel, DownloadDoneLink, void* );

	inline ImageProducer* GetImageProducer() { return m_pProducer; }

	void StartProduction();
	void SetURL(const ::rtl::OUString& rURL);
	void DataAvailable();
	void DownloadDone();
	// void SetDefaultGraphic(sal_Bool bDefect, const ::rtl::OUString& rURL);

	staruno::Sequence<staruno::Type> _getTypes();

public:
	OImageModel(
		const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory,
		const ::rtl::OUString& _rUnoControlModelTypeName,
		const ::rtl::OUString& _rDefault);
	~OImageModel();

	// UNO Anbindung
	DECLARE_UNO3_AGG_DEFAULTS(OImageModel, OControlModel);
	virtual staruno::Any SAL_CALL queryAggregation(const staruno::Type& _rType) throw(staruno::RuntimeException);

// OComponentHelper
	virtual void SAL_CALL disposing();

// starform::XImageProducerSupplier
	virtual staruno::Reference<starawt::XImageProducer> SAL_CALL getImageProducer() { return m_xProducer; }

// OPropertySetHelper
	virtual void SAL_CALL getFastPropertyValue(staruno::Any& rValue, sal_Int32 nHandle ) const;
	virtual void SAL_CALL setFastPropertyValue_NoBroadcast(sal_Int32 nHandle, const staruno::Any& rValue);

	virtual sal_Bool SAL_CALL convertFastPropertyValue(staruno::Any& rConvertedValue, staruno::Any& rOldValue, sal_Int32 nHandle, const staruno::Any& rValue )
		throw(starlang::IllegalArgumentException);

// OPropertyChangeListener
	virtual void _propertyChanged(const starbeans::PropertyChangeEvent&) throw(staruno::RuntimeException);
};

//==================================================================
// OImageControl
//==================================================================
class OImageControl: public starform::XApproveActionBroadcaster,
					   public starbeans::XPropertyChangeListener,
					   public OControl
{
	friend class OImageControlThread_Impl;

protected:
	::cppu::OInterfaceContainerHelper
		m_aApproveActionListeners,
		m_aActionListeners;
	::rtl::OUString m_aActionCommand;

	OImageControlThread_Impl *m_pThread;

public:
	OImageControl(
		const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory,
		const ::rtl::OUString& _aService);
	virtual ~OImageControl();

// UNO Anbindung
	DECLARE_UNO3_AGG_DEFAULTS(OImageControl, OControl);
	virtual staruno::Any SAL_CALL queryAggregation(const staruno::Type& _rType) throw(staruno::RuntimeException);

// OComponentHelper
	virtual void SAL_CALL disposing();

// starform::XApproveActionBroadcaster
	virtual void SAL_CALL addApproveActionListener(const staruno::Reference<starform::XApproveActionListener>& _rxListener)
		throw(staruno::RuntimeException);
	virtual void SAL_CALL removeApproveActionListener(const staruno::Reference<starform::XApproveActionListener>& _rxListener)
		throw(staruno::RuntimeException);

// starawt::XControl
	virtual void SAL_CALL createPeer(const staruno::Reference<starawt::XToolkit>& _rToolkit, const staruno::Reference<starawt::XWindowPeer>& Parent) throw(staruno::RuntimeException);
	virtual sal_Bool SAL_CALL setModel(const staruno::Reference<starawt::XControlModel>& Model);

// starbeans::XPropertyChangeListener
	virtual void SAL_CALL propertyChange( const starbeans::PropertyChangeEvent& ) throw(staruno::RuntimeException);

protected:
	staruno::Reference< ::com::sun::star::frame::XModel >  getXModel(const InterfaceRef& xIface) const;

	virtual void actionPerformed_Impl( sal_Bool bNotifyListener, const starawt::MouseEvent& rEvt = starawt::MouseEvent());

	staruno::Sequence<staruno::Type> _getTypes();
};

//==================================================================
// OImageControlThread_Impl
//==================================================================
class OImageControlThread_Impl: public OComponentEventThread
{
protected:

	// Die folgende Methode wrrd gerufen um das Event unter Beruecksichtigung
	// seines Typs zu duplizieren
	virtual starlang::EventObject* cloneEvent( const starlang::EventObject* _pEvt ) const;

	// Ein Event bearbeiten. Der Mutex ist dabei nicht gelockt, pCompImpl
	// bleibt aber in jedem Fall gueltig.
	virtual void processEvent( ::cppu::OComponentHelper *pCompImpl,
							   const starlang::EventObject*,
							   const staruno::Reference<starawt::XControl>&,
							   sal_Bool );

public:
	OImageControlThread_Impl( OImageControl *pControl ) :
		OComponentEventThread( pControl )
	{}

	void addEvent() { starlang::EventObject aEvt; OComponentEventThread::addEvent( &aEvt ); }
};

//.........................................................................
}	// namespace frm
//.........................................................................

#endif // _FRM_IMAGE_HXX_

