/*************************************************************************
 *
 *  $RCSfile: InternationalHack.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _INTERNATIONAL_HACK_HXX_
#include "InternationalHack.hxx"
#endif
#ifndef _FRM_PROPERTY_HXX_
#include "property.hxx"
#endif
#ifndef _FRM_SERVICES_HXX_
#include "services.hxx"
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _FRM_STRINGS_HXX_
#include "strings.hxx"
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _UTL_SEQUENCE_HXX_
#include <unotools/sequence.hxx>
#endif
#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif
using namespace utl;

//.........................................................................
namespace frm
{
//.........................................................................

// =======================================================================
// =======================================================================
// properties used in this service
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_DATEFORMAT_LOC, "DateFormat" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_DATESEP, "DateSeparator" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISDATEDAYLEADZERO, "IsDateDayLeadingZero" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISDATEMONTHLEADZERO, "IsDateMonthLeadingZero" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISDATECENTURY, "IsDateCentury" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISTIMELEADZERO, "IsTimeLeadingZero" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_IS12HOURFORMAT, "Is12HourTimeFormat" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_TIMESEP, "TimeSeparator" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_TIME100SECSEP, "Time100SecSeparator" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_TIMEAM, "TimeAM" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_TIMEPM, "TimePM" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_TIMESTRING, "TimeString" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISNUMTHSEP, "IsNumberThousandSeparator" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_NUMTHSEP, "NumberThousandSep" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_NUMDECSEP, "NumberDecimalSeparator" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISNUMLEADZERO, "IsNumberLeadingZero" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_ISNUMTRAILZERO, "IsNumberTrailingZeros" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_NUMBERDIGITS, "NumberDigits" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRPOSFORMAT, "CurrencyPositiveFormat" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRNEGFORMAT, "CurrencyNegativeFormat" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRDIGITS, "CurrencyDigits" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRSYMBOL, "CurrencySymbol" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRBANKSYMBOL, "CurrencyBankSymbol" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRSYMBOL2, "CurrencySymbol2" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRBANKSYMBOL2, "CurrencyBankSymbol2" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_CURRZEROCHAR, "CurrencyZeroChar" );
IMPLEMENT_CONSTASCII_USTRING( PROPERTY_LISTSEPARATOR, "ListSeparator" );


#define PROPERTY_ID_DATEFORMAT_LOC		1
#define PROPERTY_ID_DATESEP				2
#define PROPERTY_ID_ISDATEDAYLEADZERO	3
#define PROPERTY_ID_ISDATEMONTHLEADZERO	4
#define PROPERTY_ID_ISDATECENTURY		5
#define PROPERTY_ID_ISTIMELEADZERO		6
#define PROPERTY_ID_IS12HOURFORMAT		7
#define PROPERTY_ID_TIMESEP				8
#define PROPERTY_ID_TIME100SECSEP		9
#define PROPERTY_ID_TIMEAM				10
#define PROPERTY_ID_TIMEPM				11
#define PROPERTY_ID_TIMESTRING			12
#define PROPERTY_ID_ISNUMTHSEP			13
#define PROPERTY_ID_NUMTHSEP			14
#define PROPERTY_ID_NUMDECSEP			15
#define PROPERTY_ID_ISNUMLEADZERO		16
#define PROPERTY_ID_ISNUMTRAILZERO		17
#define PROPERTY_ID_NUMBERDIGITS		18
#define PROPERTY_ID_CURRPOSFORMAT		19
#define PROPERTY_ID_CURRNEGFORMAT		20
#define PROPERTY_ID_CURRDIGITS			21
#define PROPERTY_ID_CURRSYMBOL			22
#define PROPERTY_ID_CURRBANKSYMBOL		23
#define PROPERTY_ID_CURRSYMBOL2			24
#define PROPERTY_ID_CURRBANKSYMBOL2		25
#define PROPERTY_ID_CURRZEROCHAR		26
#define PROPERTY_ID_LISTSEPARATOR		27


// =======================================================================
// -----------------------------------------------------------------------
OInternationalInfo::OInternationalInfo()
	:OPropertySetHelper(m_aBroadcastHelper)
	,m_aBroadcastHelper(m_aMutex)
	,m_aGod(Application::GetAppInternational())
{
}

// -----------------------------------------------------------------------
OInternationalInfo::~OInternationalInfo()
{
}

//------------------------------------------------------------------
InterfaceRef SAL_CALL OInternationalInfo_CreateInstance(const staruno::Reference<starlang::XMultiServiceFactory>& _rxFactory)
{
	return *(new OInternationalInfo());
}

//------------------------------------------------------------------------------
staruno::Sequence< sal_Int8 > SAL_CALL OInternationalInfo::getImplementationId(  ) throw(staruno::RuntimeException)
{
	return OImplementationIds::getImplementationId(getTypes());
}

// -----------------------------------------------------------------------
staruno::Sequence<staruno::Type> SAL_CALL OInternationalInfo::getTypes(  ) throw(staruno::RuntimeException)
{
	staruno::Sequence<staruno::Type> aTypes(3);
	aTypes.getArray()[0] = ::getCppuType(static_cast<staruno::Reference<starbeans::XMultiPropertySet>*>(NULL));
	aTypes.getArray()[1] = ::getCppuType(static_cast<staruno::Reference<starbeans::XFastPropertySet>*>(NULL));
	aTypes.getArray()[2] = ::getCppuType(static_cast<staruno::Reference<starbeans::XPropertySet>*>(NULL));

	return concatSequences(aTypes, OInternationalInfoBase::getTypes());
}

// -----------------------------------------------------------------------
staruno::Any SAL_CALL OInternationalInfo::queryInterface(const staruno::Type& _rType) throw (staruno::RuntimeException)
{
	staruno::Any aReturn;

	aReturn = OInternationalInfoBase::queryInterface(_rType);
	if (!aReturn.hasValue())
		aReturn = OPropertySetHelper::queryInterface(_rType);

	return aReturn;
}

// -----------------------------------------------------------------------
::rtl::OUString OInternationalInfo::getImplementationName() throw( staruno::RuntimeException )
{
	return ::rtl::OUString::createFromAscii("com.sun.star.sba.OInternationalInfo");
}

// -----------------------------------------------------------------------
sal_Bool OInternationalInfo::supportsService(const ::rtl::OUString& ServiceName) throw( staruno::RuntimeException )
{
	staruno::Sequence< ::rtl::OUString > aSupported(getSupportedServiceNames());
	const ::rtl::OUString* pArray = aSupported.getConstArray();
	for (sal_Int32 i = 0; i < aSupported.getLength(); ++i, ++pArray)
		if (pArray->equals(ServiceName))
			return sal_True;
	return sal_False;
}

// -----------------------------------------------------------------------
StringSequence OInternationalInfo::getSupportedServiceNames() throw( staruno::RuntimeException )
{
	StringSequence aServices(1);
	aServices.getArray()[0] = FRM_SUN_INTERNATIONAL_INFO;
	return aServices;
}

// -----------------------------------------------------------------------
staruno::Reference<starbeans::XPropertySetInfo>  OInternationalInfo::getPropertySetInfo() throw( staruno::RuntimeException )
{
	staruno::Reference<starbeans::XPropertySetInfo>  xInfo( createPropertySetInfo( getInfoHelper() ) );
	return xInfo;
}

// -----------------------------------------------------------------------
::cppu::IPropertyArrayHelper& OInternationalInfo::getInfoHelper()
{
	return *const_cast<OInternationalInfo*>(this)->getArrayHelper();
}

//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper* OInternationalInfo::createArrayHelper( ) const
{
	BEGIN_PROPERTY_ARRAY_HELPER(27)
		DECL_PROP2(CURRBANKSYMBOL,		::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(CURRBANKSYMBOL2,		::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(CURRDIGITS,			sal_Int16,			TRANSIENT,	READONLY);
		DECL_PROP2(CURRNEGFORMAT,		sal_Int16,			TRANSIENT,	READONLY);
		DECL_PROP2(CURRPOSFORMAT,		sal_Int16,			TRANSIENT,	READONLY);
		DECL_PROP2(CURRSYMBOL,			::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(CURRSYMBOL2,			::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(CURRZEROCHAR,		::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(DATEFORMAT_LOC,		sal_Int16,			TRANSIENT,	READONLY);
		DECL_PROP2(DATESEP,				::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(IS12HOURFORMAT,		sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISDATECENTURY,		sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISDATEDAYLEADZERO,	sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISDATEMONTHLEADZERO,	sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISNUMLEADZERO,		sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISNUMTHSEP,			sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISNUMTRAILZERO,		sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(ISTIMELEADZERO,		sal_Bool,			TRANSIENT,	READONLY);
		DECL_PROP2(LISTSEPARATOR,		::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(NUMDECSEP,			::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(NUMBERDIGITS,		sal_Int16,			TRANSIENT,	READONLY);
		DECL_PROP2(NUMTHSEP,			::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(TIME100SECSEP,		::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(TIMEAM,				::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(TIMEPM,				::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(TIMESEP,				::rtl::OUString,	TRANSIENT,	READONLY);
		DECL_PROP2(TIMESTRING,			::rtl::OUString,	TRANSIENT,	READONLY);
	END_PROPERTY_ARRAY_HELPER();
}

// -----------------------------------------------------------------------
void OInternationalInfo::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue ) throw( staruno::Exception )
{
	throw starlang::IllegalArgumentException();
		// we haven't any writeable props
}

// -----------------------------------------------------------------------
sal_Bool OInternationalInfo::convertFastPropertyValue( staruno::Any& rConvertedValue, staruno::Any& rOldValue, sal_Int32 nHandle, const staruno::Any& rValue) throw( starlang::IllegalArgumentException )
{
	throw starlang::IllegalArgumentException();
		// we haven't any writeable props
}

// -----------------------------------------------------------------------
void OInternationalInfo::getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_DATEFORMAT_LOC:
			switch (m_aGod.GetDateFormat())
			{
				case MDY:	rValue <<= (sal_Int16)0; break;
				case DMY:	rValue <<= (sal_Int16)1; break;
				case YMD:	rValue <<= (sal_Int16)2; break;
			}
			break;
		case PROPERTY_ID_DATESEP:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetDateSep()));
			break;
		case PROPERTY_ID_ISDATEDAYLEADZERO:
			rValue <<= (sal_Bool)m_aGod.IsDateDayLeadingZero();
			break;
		case PROPERTY_ID_ISDATEMONTHLEADZERO:
			rValue <<= (sal_Bool)m_aGod.IsDateMonthLeadingZero();
			break;
		case PROPERTY_ID_ISDATECENTURY:
			rValue <<= (sal_Bool)m_aGod.IsDateCentury();
			break;
		case PROPERTY_ID_ISTIMELEADZERO:
			rValue <<= (sal_Bool)m_aGod.IsTimeLeadingZero();
			break;
		case PROPERTY_ID_IS12HOURFORMAT:
			rValue <<= (sal_Bool)(m_aGod.GetTimeFormat() == HOUR_12);
			break;
		case PROPERTY_ID_TIMESEP:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetTimeSep()));
			break;
		case PROPERTY_ID_TIME100SECSEP:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetTime100SecSep()));
			break;
		case PROPERTY_ID_TIMEAM:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetTimeAM()));
			break;
		case PROPERTY_ID_TIMEPM:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetTimePM()));
			break;
		case PROPERTY_ID_TIMESTRING:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetTimeStr()));
			break;
		case PROPERTY_ID_ISNUMTHSEP:
			rValue <<= (sal_Bool)m_aGod.IsNumThousandSep();
			break;
		case PROPERTY_ID_NUMTHSEP:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetNumThousandSep()));
			break;
		case PROPERTY_ID_NUMDECSEP:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetNumDecimalSep()));
			break;
		case PROPERTY_ID_ISNUMLEADZERO:
			rValue <<= (sal_Bool)m_aGod.IsNumLeadingZero();
			break;
		case PROPERTY_ID_ISNUMTRAILZERO:
			rValue <<= (sal_Bool)m_aGod.IsNumTrailingZeros();
			break;
		case PROPERTY_ID_NUMBERDIGITS:
			rValue <<= (sal_Int16)(m_aGod.GetNumDigits());
			break;
		case PROPERTY_ID_CURRPOSFORMAT:
			rValue <<= (sal_Int16)(m_aGod.GetCurrPositiveFormat());
			break;
		case PROPERTY_ID_CURRNEGFORMAT:
			rValue <<= (sal_Int16)(m_aGod.GetCurrNegativeFormat());
			break;
		case PROPERTY_ID_CURRDIGITS:
			rValue <<= (sal_Int16)(m_aGod.GetCurrDigits());
			break;
		case PROPERTY_ID_CURRSYMBOL:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetCurrSymbol()));
			break;
		case PROPERTY_ID_CURRBANKSYMBOL:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetCurrBankSymbol()));
			break;
		case PROPERTY_ID_CURRSYMBOL2:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetCurrSymbol2()));
			break;
		case PROPERTY_ID_CURRBANKSYMBOL2:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetCurrBankSymbol2()));
			break;
		case PROPERTY_ID_CURRZEROCHAR:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetCurrZeroChar()));
			break;
		case PROPERTY_ID_LISTSEPARATOR:
			rValue <<= ::rtl::OUString(UniString(m_aGod.GetListSep()));
			break;
	}
}

// -----------------------------------------------------------------------
void OInternationalInfo::setLocale(const starlang::Locale& _rLoc) throw( staruno::RuntimeException )
{
	LanguageType eNewType = ConvertIsoNamesToLanguage(UniString(_rLoc.Language), UniString(_rLoc.Country));
	m_aGod = International(eNewType);
}

// -----------------------------------------------------------------------
starlang::Locale OInternationalInfo::getLocale() throw( staruno::RuntimeException )
{
	UniString sLanguage, sCountry;
	ConvertLanguageToIsoNames(m_aGod.GetLanguage(), sLanguage, sCountry);
	return starlang::Locale(sLanguage, sCountry, ::rtl::OUString());
}

//.........................................................................
}	// namespace frm
//.........................................................................


