/*************************************************************************
 *
 *  $RCSfile: defines.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_DEFINES_HXX_
#define __FRAMEWORK_DEFINES_HXX_

//_________________________________________________________________________________________________________________
//	includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_MACROS_GENERIC_HXX_
#include <macros/generic.hxx>
#endif

//_________________________________________________________________________________________________________________
//	used servicenames by framework
//_________________________________________________________________________________________________________________

#define	SERVICENAME_FRAME									DECLARE_ASCII("com.sun.star.frame.Frame"							)
#define	SERVICENAME_DESKTOP									DECLARE_ASCII("com.sun.star.frame.Desktop"							)
#define	SERVICENAME_TASK									DECLARE_ASCII("com.sun.star.frame.Task"								)
#define	SERVICENAME_FRAMELOADERFACTORY						DECLARE_ASCII("com.sun.star.frame.FrameLoaderFactory"				)
#define	SERVICENAME_URLTRANSFORMER	  						DECLARE_ASCII("com.sun.star.util.URLTransformer"					)
#define	SERVICENAME_PLUGINFRAME								DECLARE_ASCII("com.sun.star.mozilla.Plugin"							)
#define	SERVICENAME_BRIDGEFACTORY							DECLARE_ASCII("com.sun.star.bridge.BridgeFactory"					)
#define	SERVICENAME_SPECIALCONFIGMANAGER					DECLARE_ASCII("com.sun.star.config.SpecialConfigManager"			)
#define	SERVICENAME_INIMANAGER								DECLARE_ASCII("com.sun.star.config.INIManager"						)
#define	SERVICENAME_MEDIATYPEDETECTIONHELPER				DECLARE_ASCII("com.sun.star.frame.MediaTypeDetectionHelper"			)
#define	SERVICENAME_LOGINDIALOG								DECLARE_ASCII("com.sun.star.framework.LoginDialog"					)
#define	SERVICENAME_CONFIGURATION							DECLARE_ASCII("com.sun.star.configuration.ConfigurationRegistry"	)
#define	SERVICENAME_VCLTOOLKIT								DECLARE_ASCII("com.sun.star.awt.Toolkit"							)
#define SERVICENAME_SIMPLEREGISTRY							DECLARE_ASCII("com.sun.star.registry.SimpleRegistry"				)
#define	SERVICENAME_NESTEDREGISTRY							DECLARE_ASCII("com.sun.star.registry.NestedRegistry"				)
#define SERVICENAME_GENERICFRAMELOADER						DECLARE_ASCII("com.sun.star.comp.office.FilterDetect"     			)

//_________________________________________________________________________________________________________________
//	used implementationnames by framework
//_________________________________________________________________________________________________________________

#define	IMPLEMENTATIONNAME_FRAME							DECLARE_ASCII("com.sun.star.comp.framework.Frame"					)
#define	IMPLEMENTATIONNAME_DESKTOP							DECLARE_ASCII("com.sun.star.comp.framework.Desktop"					)
#define	IMPLEMENTATIONNAME_TASK								DECLARE_ASCII("com.sun.star.comp.framework.Task"					)
#define	IMPLEMENTATIONNAME_FRAMELOADERFACTORY				DECLARE_ASCII("com.sun.star.comp.framework.FrameLoaderFactory"		)
#define	IMPLEMENTATIONNAME_URLTRANSFORMER					DECLARE_ASCII("com.sun.star.comp.framework.URLTransformer"			)
#define	IMPLEMENTATIONNAME_PLUGINFRAME						DECLARE_ASCII("com.sun.star.comp.framework.PluginFrame"				)
#define	IMPLEMENTATIONNAME_GENERICFRAMELOADER				DECLARE_ASCII("com.sun.star.comp.office.FrameLoader"				)
#define	IMPLEMENTATIONNAME_MEDIATYPEDETECTIONHELPER			DECLARE_ASCII("com.sun.star.comp.framework.MediaTypeDetectionHelper")
#define	IMPLEMENTATIONNAME_LOGINDIALOG						DECLARE_ASCII("com.sun.star.framework.LoginDialog"					)

//_________________________________________________________________________________________________________________
//	Some other global defines for ouer project
//_________________________________________________________________________________________________________________

#define	INSTANCENAME_PLUGINFACTORY							DECLARE_ASCII("PluginFactory")				// specifier to create a plugin on a pluginfactory
#define	STRINGEQUAL											0				   							// compare result, if two strings are equal
#define	PROTECTION_OFF										sal_False		   							// used for boolean variables to protect parts of code against recursive calls
#define	PROTECTION_ON										sal_True
#define	VALID												sal_True									// Mapped state informations for better code-reading!
#define	INVALID												sal_False
#define	FEATUREDESCRIPTOR_LOADSTATE							DECLARE_ASCII("loadFinishedOrCancelled")	// status event mapped from load event of frame loader

// Some values to unmask FrameSearchFlags on an sal_Int32 (not defined for unsigned values!)
#define	UNMASK_PARENT										0xFFFFFFFE
#define	UNMASK_SELF											0xFFFFFFFD
#define	UNMASK_CHILDREN										0xFFFFFFFB
#define	UNMASK_CREATE                                       0xFFFFFFF7
#define	UNMASK_SIBLINGS                                     0xFFFFFFEF
#define	UNMASK_TASKS                                        0xFFFFFFDF

// Values for special frame search ... sTargetFrameName of findFrame() or queryDispatch() or loadComponentFromURL()
#define	FRAMETYPE_SELF										DECLARE_ASCII("_self"		)	// The frame himself is searched.
#define	FRAMETYPE_PARENT									DECLARE_ASCII("_parent"		)	// The direct parent frame is searched.
#define	FRAMETYPE_TOP										DECLARE_ASCII("_top"		)	// Search at ouer parents for the first task (if any exist) or a frame without a parent.
#define	FRAMETYPE_BLANK										DECLARE_ASCII("_blank"		)	// Create a new frame.
/* not used in the moment!
#define	FRAMETYPE_DOCUMENT									DECLARE_ASCII("_document"	)
#define	FRAMETYPE_BEAMER									DECLARE_ASCII("_beamer"		)
#define	FRAMETYPE_EXPLORER									DECLARE_ASCII("_explorer"	)
#define	FRAMETYPE_PARTWINDOW								DECLARE_ASCII("_partwindow"	)
*/

// Types of arguments for dispatch()/queryDispatch()
// Used as identifier of properties of a registered frame loader too.
#define	ARGUMENT_DETECTSERVICE								DECLARE_ASCII("DetectService"	)	// [string]
#define	ARGUMENT_EXTENSION									DECLARE_ASCII("Extension"		)	// [string]
#define	ARGUMENT_FILTERNAME									DECLARE_ASCII("FilterName"		)	// [string]
#define	ARGUMENT_FLAGS										DECLARE_ASCII("Flags"			)	// [int]
#define	ARGUMENT_FORMAT										DECLARE_ASCII("Format"			)
#define	ARGUMENT_INPUTSTREAM								DECLARE_ASCII("InputStream"		)	// [stream]
#define	ARGUMENT_MIMETYPE									DECLARE_ASCII("ContentType"		)
#define	ARGUMENT_PATTERN									DECLARE_ASCII("Pattern"			)
#define	ARGUMENT_POSTDATA									DECLARE_ASCII("PostData"		)
#define	ARGUMENT_REFERRER									DECLARE_ASCII("Referer"			)	// [string]	"Referer" is not wrong! Its for compatibility with old code!
#define	ARGUMENT_OPENFLAGS									DECLARE_ASCII("OpenFlags"		)	// [int]
#define	ARGUMENT_READONLY									DECLARE_ASCII("ReadOnly"		)	// [bool]
/*
// These defines are not used yet ...
// If you enable something - don't forget to define suitable MASK_xxx below!
#define	ARGUMENT_ASTEMPLATE									DECLARE_ASCII("AsTemplate"	)
#define	ARGUMENT_OPENVIEW									DECLARE_ASCII("OpenNewView"	)
#define	ARGUMENT_VIEWID										DECLARE_ASCII("ViewId"		)
#define	ARGUMENT_PLUGINMODE									DECLARE_ASCII("PluginMode"	)
#define	ARGUMENT_POSTSTRING									DECLARE_ASCII("PostString"	)
#define	ARGUMENT_FRAMENAME									DECLARE_ASCII("FrameName"	)
#define	ARGUMENT_POSSIZE									DECLARE_ASCII("PosSize"		)
#define	ARGUMENT_CHARACTERSET								DECLARE_ASCII("CharacterSet")
*/

// Mask values to validate state of entry values for RegistryCache or extracted arguments for FrameLoaderFactory!
// (see nValidMask member of corresponding structures for further informations!)
// Attention: Not every struct use all of these masks!
#define	MASK_DETECTSERVICE									0x00000001L	// = ----------1
#define	MASK_EXTENSION										0x00000002L	// = ---------1-
#define	MASK_FILTERNAME										0x00000004L	// = --------1--
#define	MASK_FLAGS											0x00000008L	// = -------1---
#define	MASK_FORMAT											0x00000010L	// = ------1----
#define	MASK_INPUTSTREAM									0x00000020L	// = -----1-----
#define	MASK_MIMETYPE										0x00000040L	// = ----1------
#define	MASK_PATTERN										0x00000080L	// = ---1-------
#define	MASK_POSTDATA										0x00000100L	// = --1--------
#define	MASK_REFERRER										0x00000200L	// = -1---------
#define	MASK_READONLY										0x00000400L	// = 1----------

// This enum can be used to set differnt active states of frames, tasks.
enum eACTIVESTATE
{
	INACTIVE		,	// I'am not a member of active path in tree and i don't have the focus.
	ACTIVE			,	// I'am in the middle of an active path in tree and i don't have the focus.
	FOCUS				// I have the focus now. I must a member of an active path!
};

// Value names for ARGMENT_FLAGS (see before)
#define	FILTERFLAGNAME_IMPORT								DECLARE_ASCII("Import"			)
#define	FILTERFLAGNAME_EXPORT								DECLARE_ASCII("Export"			)
#define	FILTERFLAGNAME_INTERNAL								DECLARE_ASCII("Internal"		)
#define	FILTERFLAGNAME_TEMPLATE								DECLARE_ASCII("Template"		)
#define	FILTERFLAGNAME_TEMPLATEPATH							DECLARE_ASCII("TemplatePath"	)
#define	FILTERFLAGNAME_OWN									DECLARE_ASCII("Own"				)
#define	FILTERFLAGNAME_ALIEN								DECLARE_ASCII("Alien"			)
#define	FILTERFLAGNAME_ASYNCHRON							DECLARE_ASCII("Asynchron"		)
#define	FILTERFLAGNAME_READONLY								DECLARE_ASCII("Readonly"		)
#define	FILTERFLAGNAME_USESOPTIONS							DECLARE_ASCII("UsesOptions"		)
#define	FILTERFLAGNAME_NOTINSTALLED							DECLARE_ASCII("NotInstalled"	)
#define	FILTERFLAGNAME_CONSULTSERVICE						DECLARE_ASCII("ConsultService"	)
#define	FILTERFLAGNAME_NOTINCHOOSER							DECLARE_ASCII("NotInChooser"	)
#define	FILTERFLAGNAME_NOTINFILEDIALOG						DECLARE_ASCII("NotInFileDialog"	)
#define	FILTERFLAGNAME_PACKED								DECLARE_ASCII("Packed"			)
#define	FILTERFLAGNAME_SILENTEXPORT							DECLARE_ASCII("SilentExport"	)
#define	FILTERFLAGNAME_BROWSERPREFERED						DECLARE_ASCII("BrowserPrefered"	)
#define	FILTERFLAGNAME_PREFERED								DECLARE_ASCII("Prefered"		)

// Values for ARGMENT_FLAGS (see before)
#define	FILTERFLAG_IMPORT									0x00000001L
#define	FILTERFLAG_EXPORT									0x00000002L
#define	FILTERFLAG_TEMPLATE									0x00000004L
#define	FILTERFLAG_INTERNAL									0x00000008L
#define	FILTERFLAG_TEMPLATEPATH								0x00000010L
#define	FILTERFLAG_OWN										0x00000020L
#define	FILTERFLAG_ALIEN									0x00000040L
#define	FILTERFLAG_USESOPTIONS								0x00000080L
#define	FILTERFLAG_NOTINFILEDIALOG							0x00001000L
#define	FILTERFLAG_NOTINCHOOSER								0x00002000L
#define	FILTERFLAG_ASYNCHRON								0x00004000L
#define	FILTERFLAG_READONLY									0x00010000L
#define	FILTERFLAG_NOTINSTALLED								0x00020000L
#define	FILTERFLAG_CONSULTSERVICE							0x00040000L
#define	FILTERFLAG_PACKED									0x00100000L
#define	FILTERFLAG_SILENTEXPORT								0x00200000L
#define	FILTERFLAG_BROWSERPREFERED							0x00400000L
#define	FILTERFLAG_PREFERED									0x10000000L

#endif	//	#ifndef __FRAMEWORK_DEFINES_HXX_
