/*************************************************************************
 *
 *  $RCSfile: odesktopdispatcher.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_HELPER_ODESKTOPDISPATCHER_HXX_
#define __FRAMEWORK_HELPER_ODESKTOPDISPATCHER_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_CLASSES_TASKCREATOR_HXX_
#include <classes/taskcreator.hxx>
#endif

#ifndef __FRAMEWORK_SERVICES_FRAME_HXX_
#include <services/frame.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_GENERIC_HXX_
#include <macros/generic.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XINTERFACE_HXX_
#include <macros/xinterface.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XTYPEPROVIDER_HXX_
#include <macros/xtypeprovider.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_DEBUG_HXX_
#include <macros/debug.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_URL_HPP_
#include <com/sun/star/util/URL.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_DISPATCHDESCRIPTOR_HPP_
#include <com/sun/star/frame/DispatchDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XSTATUSLISTENER_HPP_
#include <com/sun/star/frame/XStatusListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XSTATUSLISTENER_HPP_
#include <com/sun/star/frame/XStatusListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XTASK_HPP_
#include <com/sun/star/frame/XTask.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_FEATURESTATEEVENT_HPP_
#include <com/sun/star/frame/FeatureStateEvent.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_H_
#include <cppuhelper/interfacecontainer.h>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	ANY												::com::sun::star::uno::Any
#define	DISPATCHDESCRIPTOR								::com::sun::star::frame::DispatchDescriptor
#define	FEATURESTATEEVENT								::com::sun::star::frame::FeatureStateEvent
#define	MUTEX											::osl::Mutex
#define	OMULTITYPEINTERFACECONTAINERHELPERVAR			::cppu::OMultiTypeInterfaceContainerHelperVar
#define	OWEAKOBJECT										::cppu::OWeakObject
#define	PROPERTYVALUE									::com::sun::star::beans::PropertyValue
#define	REFERENCE										::com::sun::star::uno::Reference
#define	RUNTIMEEXCEPTION								::com::sun::star::uno::RuntimeException
#define	UNOTYPE											::com::sun::star::uno::Type
#define	UNOURL											::com::sun::star::util::URL
#define	WEAKREFERENCE									::com::sun::star::uno::WeakReference
#define	XDESKTOP                                        ::com::sun::star::frame::XDesktop
#define	XDISPATCH										::com::sun::star::frame::XDispatch
#define	XLOADEVENTLISTENER								::com::sun::star::frame::XLoadEventListener
#define	XSTATUSLISTENER									::com::sun::star::frame::XStatusListener
#define	XTASK											::com::sun::star::frame::XTask
#define	XTYPEPROVIDER									::com::sun::star::lang::XTypeProvider

//_________________________________________________________________________________________________________________
//	exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported definitions
//_________________________________________________________________________________________________________________

/*-************************************************************************************************************//**
	We must support loading of different URL with different loader in different tasks simultaniously.
	In loadFinished() or loadCancelled() we need some informations to distinguish between these different "threads".
	This is the reason to implement this dynamicly list.
*//*-*************************************************************************************************************/

struct tIMPL_LoaderTaskBinding
{
	REFERENCE< XFRAMELOADER >		xLoader	;
	REFERENCE< XTASK >				xTask	;
	UNOURL							aURL	;
};

typedef std::vector< tIMPL_LoaderTaskBinding > tIMPL_TaskList;

/*-************************************************************************************************************//**
	We must save informations about our listener and URL for listening.
	We implement this as a hashtable for strings.
*//*-*************************************************************************************************************/

struct tIMPL_StringHashCode
{
	size_t operator()(const OUSTRING& sString) const
	{
		return sString.hashCode();
	}
};

typedef OMULTITYPEINTERFACECONTAINERHELPERVAR<	OUSTRING			,
												tIMPL_StringHashCode,
												std::equal_to< OUSTRING > > tIMPL_ListenerHashContainer;

/*-************************************************************************************************************//**
	@short			helper for desktop only(!) to create new tasks on demand for dispatches
	@descr			Use this class as member only! Never use it as baseclass.
					XInterface will be ambigous and we hold a weakreference to ouer OWNER - not to ouer SUPERCLASS!

	@implements		XInterface
					XDispatch
					XLoadEventListener
					XEventListener
					XStatusListener
					[ XDebugging if TEST_TREE is defined! ]
	@base			OWeakObject

	@devstatus		deprecated
*//*-*************************************************************************************************************/

//class ODesktopDispatcher:   DERIVE_FROM_XSPECIALDEBUGINTERFACE		// => These macro will expand to nothing, if no testmode is set in debug.h!
class ODesktopDispatcher	:	public XTYPEPROVIDER				,
								public XDISPATCH					,
								public XLOADEVENTLISTENER			,	// => XEventListener
								public XSTATUSLISTENER				,
								public OWEAKOBJECT
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		standard ctor
			@descr		These initialize a new instance of ths class with needed informations for work.
						We share the mutex with ouer owner implementation and hold a weakreference to it.

			@seealso	using at owner

			@param		"xFactory"	, reference to servicemanager for creation of new services
			@param		"xOwner"	, reference to our owner, the Desktop
			@param		"aMutex"	, reference to shared mutex of owner
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	 	ODesktopDispatcher(	const	REFERENCE< XMULTISERVICEFACTORY >&	xFactory	,
							const	REFERENCE< XDESKTOP >&				xOwner		,
									MUTEX&								aMutex		);


		//---------------------------------------------------------------------------------------------------------
		//	XInterface
		//---------------------------------------------------------------------------------------------------------

		DECLARE_XINTERFACE
		DECLARE_XTYPEPROVIDER
//		DECLARE_XSPECIALDEBUGINTERFACE	// => These macro will expand to nothing, if no testmode is set in debug.h!

		//---------------------------------------------------------------------------------------------------------
		//	XDispatch
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short      dispatch URL with arguments
			@descr		-

			@seealso	-

			@param		"aURL"			, URL to dispatch.
			@param		"seqArguments"	, list of optional arguments.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL dispatch(	const	UNOURL&						aURL			,
										const	SEQUENCE< PROPERTYVALUE >&	seqProperties	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short      add listener for state events
			@descr		-

			@seealso	-

			@param		"xControl"	, reference to a valid listener for state events.
			@param		"aURL"		, URL about listener will be informed, if something occured.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addStatusListener(	const	REFERENCE< XSTATUSLISTENER >&	xControl,
													const	UNOURL&							aURL	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short      remove listener for state events
			@descr		-

			@seealso	-

			@param		"xControl"	, reference to a valid listener.
			@param		"aURL"		, URL on which listener has registered.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeStatusListener(	const	REFERENCE< XSTATUSLISTENER >&	xControl,
													const	UNOURL&							aURL	) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XLoadEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadFinished( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadCancelled( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void SAL_CALL disposing( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XStatusListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL statusChanged( const FEATURESTATEEVENT& aEvent ) throw( RUNTIMEEXCEPTION );

	//-------------------------------------------------------------------------------------------------------------
	//	protected methods
	//-------------------------------------------------------------------------------------------------------------

	protected:

		/*-****************************************************************************************************//**
			@short		standard destructor
			@descr		This method destruct an instance of this class and clear some member.
						This method is protected, because its not allowed to use an instance of this class as a member!
						You MUST use a pointer.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual	~ODesktopDispatcher();

		/*-****************************************************************************************************//**
			@short		reset instance to default values, release references and free memory
			@descr		There are two ways to delete an instance of this class.<BR>
						1) delete with destructor<BR>
						2) dispose from parent or factory ore ...<BR>
						This method do the same for both ways! It free used memory and release references ...

			@seealso	destructor ODispatchProvider()

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual void impl_resetObject();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL impl_dispatchSystemTask(	const	UNOURL&						aURL			,
														const	SEQUENCE< PROPERTYVALUE >&	seqProperties	) throw( RUNTIMEEXCEPTION );
    	virtual void SAL_CALL impl_dispatchBrowserTask(	const	UNOURL&						aURL			,
														const	SEQUENCE< PROPERTYVALUE >&	seqProperties	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_sendStatusEvent(	const	OUSTRING&	sURL				,
											sal_Bool	bLoadingSuccessful	);

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		 tIMPL_TaskList::iterator impl_searchLoader( const REFERENCE< XFRAMELOADER >& xLoader );

	//-------------------------------------------------------------------------------------------------------------
	//	debug methods
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		debug-method to check incoming parameter of some other mehods of this class
			@descr		The following methods are used to check parameters for other methods
						of this class. The return value is used directly for an ASSERT(...).

			@seealso	ASSERTs in implementation!

			@param		references to checking variables
			@return		sal_False on invalid parameter<BR>
						sal_True  otherway

			@onerror	-
		*//*-*****************************************************************************************************/

	#ifdef ENABLE_ASSERTIONS

	private:

		sal_Bool impldbg_checkParameter_ODesktopDispatcher	(	const	REFERENCE< XMULTISERVICEFACTORY >&	xFactory		,
																const	REFERENCE< XDESKTOP >&				xOwner			,
																		MUTEX&								aMutex			);
    	sal_Bool impldbg_checkParameter_dispatch			(	const	UNOURL&								aURL			,
																const	SEQUENCE< PROPERTYVALUE >&			seqArguments	);
    	sal_Bool impldbg_checkParameter_addStatusListener	(	const	REFERENCE< XSTATUSLISTENER >&		xControl		,
																const	UNOURL&								aURL			);
    	sal_Bool impldbg_checkParameter_removeStatusListener(	const	REFERENCE< XSTATUSLISTENER >&		xControl		,
																const	UNOURL&								aURL			);
		sal_Bool impldbg_checkParameter_loadFinished		(	const	REFERENCE< XFRAMELOADER >&			xLoader			);
		sal_Bool impldbg_checkParameter_loadCancelled		(	const	REFERENCE< XFRAMELOADER >&			xLoader			);
		sal_Bool impldbg_checkParameter_disposing			(	const	EVENTOBJECT&						aEvent			);
    	sal_Bool impldbg_checkParameter_statusChanged		(	const	FEATURESTATEEVENT&					aEvent			);

	#endif	// #ifdef ENABLE_ASSERTIONS

	//-------------------------------------------------------------------------------------------------------------
	//	variables
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	private:

		MUTEX&									m_aMutex			;	/// shared mutex with owner instance
		WEAKREFERENCE< XDESKTOP >				m_xOwnerWeak		;	/// weakreference to owner (Don't use a hard reference. Owner can't delete us then!)
		REFERENCE< XMULTISERVICEFACTORY >		m_xFactory			;	/// factory shared with our owner to create new services!
		tIMPL_TaskList                          m_aTaskList			;	/// List with bindings between loader, task and loaded URL
		tIMPL_ListenerHashContainer				m_aListenerContainer;	/// hash table for listener at specified URLs
		TaskCreator								m_aTaskCreator		;	/// Helper to create new system tasks or plugin frames

};		//	class ODesktopDispatcher

}		//	namespace framework

#endif	//	#ifndef __FRAMEWORK_HELPER_ODESKTOPDISPATCHER_HXX_
