/*************************************************************************
 *
 *  $RCSfile: odispatchprovider.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_HELPER_ODISPATCHPROVIDER_HXX_
#define __FRAMEWORK_HELPER_ODISPATCHPROVIDER_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_SERVICES_FRAME_HXX_
#include <services/frame.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_GENERIC_HXX_
#include <macros/generic.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XINTERFACE_HXX_
#include <macros/xinterface.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XTYPEPROVIDER_HXX_
#include <macros/xtypeprovider.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_DEBUG_HXX_
#include <macros/debug.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_LANG_XTYPEPROVIDER_HPP_
#include <com/sun/star/lang/XTypeProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_URL_HPP_
#include <com/sun/star/util/URL.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_DISPATCHDESCRIPTOR_HPP_
#include <com/sun/star/frame/DispatchDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XSTATUSLISTENER_HPP_
#include <com/sun/star/frame/XStatusListener.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_H_
#include <cppuhelper/interfacecontainer.h>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	ANY												::com::sun::star::uno::Any
#define	DISPATCHDESCRIPTOR								::com::sun::star::frame::DispatchDescriptor
#define	MUTEX											::osl::Mutex
#define	OMULTITYPEINTERFACECONTAINERHELPERVAR			::cppu::OMultiTypeInterfaceContainerHelperVar
#define	OWEAKOBJECT										::cppu::OWeakObject
#define	PROPERTYVALUE									::com::sun::star::beans::PropertyValue
#define	REFERENCE										::com::sun::star::uno::Reference
#define	RUNTIMEEXCEPTION								::com::sun::star::uno::RuntimeException
#define	UNOTYPE											::com::sun::star::uno::Type
#define	UNOURL											::com::sun::star::util::URL
#define	WEAKREFERENCE									::com::sun::star::uno::WeakReference
#define	XDISPATCH										::com::sun::star::frame::XDispatch
#define	XDISPATCHPROVIDER								::com::sun::star::frame::XDispatchProvider
#define	XLOADEVENTLISTENER								::com::sun::star::frame::XLoadEventListener
#define	XSTATUSLISTENER									::com::sun::star::frame::XStatusListener
#define	XTYPEPROVIDER									::com::sun::star::lang::XTypeProvider

//_________________________________________________________________________________________________________________
//	exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	exported definitions
//_________________________________________________________________________________________________________________

/*-************************************************************************************************************//**
	Use OMultiTypeInterfaceContainerHelperVar-template to create new class to get a container
	to combine string values with listeners.
*//*-*************************************************************************************************************/

struct IMPL_hashCode
{
	size_t operator()(const OUSTRING& sString) const
	{
		return sString.hashCode();
	}
};

typedef OMULTITYPEINTERFACECONTAINERHELPERVAR<	OUSTRING				  ,
												IMPL_hashCode			  ,
												std::equal_to< OUSTRING > > IMPL_ListenerContainerHelper ;

/*-************************************************************************************************************//**
	@short			implement a helper for XDispatchProvider and XDispatch interfaces
	@descr			Use this class as member only! Never use it as baseclass.
					XInterface will be ambigous and we hold a weakreference to ouer OWNER - not to ouer SUPERCLASS!

	@implements		XInterface
					XDispatchProvider
					XDispatch
					XLoadEventListener
					[ XDebugging if TEST_TREE is defined! ]
	@base			OWeakObject

	@devstatus		deprecated
*//*-*************************************************************************************************************/

//class ODispatchProvider	:   DERIVE_FROM_XSPECIALDEBUGINTERFACE		// => These macro will expand to nothing, if no testmode is set in debug.h!
class ODispatchProvider	:	public XTYPEPROVIDER				,
							public XDISPATCHPROVIDER			,
							public XDISPATCH					,
							public XLOADEVENTLISTENER			,
							public OWEAKOBJECT
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		standard ctor
			@descr		These initialize a new instance of ths class with needed informations for work.
						We share the mutex with ouer owner implementation and hold a weakreference to it.

			@seealso	using at owner

			@param		"aMutex", reference to shared mutex of owner.
			@param		"pFrame", pointer to owner-implementation for special access!
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	 	ODispatchProvider(	const	REFERENCE< XMULTISERVICEFACTORY >&	xFactory	,
							const	REFERENCE< XFRAME >&				xOwner		,
									MUTEX&								aMutex		);


		//---------------------------------------------------------------------------------------------------------
		//	XInterface
		//---------------------------------------------------------------------------------------------------------

		DECLARE_XINTERFACE
		DECLARE_XTYPEPROVIDER
//		DECLARE_XSPECIALDEBUGINTERFACE	// => These macro will expand to nothing, if no testmode is set in debug.h!

		//---------------------------------------------------------------------------------------------------------
		//	XDispatchProvider
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short      search a dispatcher for given URL
			@descr		If no interceptor is set on owner, we search for right frame and dispatch URL to it.
						If no frame was found, we do nothing.

			@seealso	-

			@param		"aURL"				, URL to dispatch.
			@param		"sTargetFrameName"	, name of searched frame.
			@param		"nSearchFlags"		, flags for searching.
			@return		A reference a dispatcher for these URL (if someone was found!).

			@onerror	We return a NULL-reference.
		*//*-*****************************************************************************************************/

    	virtual REFERENCE< XDISPATCH > SAL_CALL queryDispatch(	const	UNOURL&		aURL				,
																const	OUSTRING&	sTargetFrameName	,
																		sal_Int32	nSearchFlags		) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short      search dispatcher for more the one URL
			@descr		Call this method, if you search dispatcher for more then one URL at the same time.
						( But these mode is not supported yet! )

			@seealso	-

			@param		"seqDescripts", descriptor to search more then one dispatcher.
			@return		A list of founded dispatcher. (if somewhere exist!)

			@onerror	An empty list is returned.
		*//*-*****************************************************************************************************/

    	virtual SEQUENCE< REFERENCE< XDISPATCH > > SAL_CALL queryDispatches( const SEQUENCE< DISPATCHDESCRIPTOR >& seqDescripts ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	XDispatch
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short      dispatch URL with arguments
			@descr		This class implement XDispatch interface to.
						We search a frame loader, load the document and get result events about state of loading from it.
						This state we map to a FeatureStateEvent and send it to all our listener.

			@seealso	method loadFinished()
			@seealso	method loadCancelled()

			@param		"aURL"			, URL to dispatch.
			@param		"seqArguments"	, list of optional arguments.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL dispatch(	const	UNOURL&						aURL			,
										const	SEQUENCE< PROPERTYVALUE >&	seqProperties	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short      add listener for state events
			@descr		-

			@seealso	-

			@param		"xControl"	, reference to a valid listener for state events.
			@param		"aURL"		, URL about listener will be informed, if something occured.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL addStatusListener(	const	REFERENCE< XSTATUSLISTENER >&	xControl,
													const	UNOURL&							aURL	) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short      remove listener
			@descr		-

			@seealso	-

			@param		"xControl"	, reference to a valid listener.
			@param		"aURL"		, URL on which listener has registered.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL removeStatusListener(	const	REFERENCE< XSTATUSLISTENER >&	xControl,
													const	UNOURL&							aURL	) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XLoadEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		callback to get information about successfuly loading
			@descr		We get an event about successfuly loading and must map this to a state event.
						Somewhere can listening for this event to get this information.

			@seealso	method dispatch()
			@seealso	interface XStatusListener

			@param		"xLoader"	;	loader which send us this event.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadFinished( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		callback to get information about failed loading
			@descr		We get an event about failed loading and must map this to a state event.
						Somewhere can listening for this event to get this information.

			@seealso	method dispatch()
			@seealso	interface XStatusListener

			@param		"xLoader"	;	loader which send us this event.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL loadCancelled( const REFERENCE< XFRAMELOADER >& xLoader ) throw( RUNTIMEEXCEPTION );

		//---------------------------------------------------------------------------------------------------------
		//	 XEventListener
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		clear this object
			@descr		User of this object must dispose() us to free memory, references and something else.
						We use a helper method to do this. Programmer can forget this and we must do this by himself
						at destructor!

			@seealso	destructor
			@seealso	method impl_resetObject()

			@param		"aEvent"	;	describe the source of this event and should be the owner of this object.
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void SAL_CALL disposing( const EVENTOBJECT& aEvent ) throw( RUNTIMEEXCEPTION );

	//-------------------------------------------------------------------------------------------------------------
	//	protected methods
	//-------------------------------------------------------------------------------------------------------------

	protected:

		/*-****************************************************************************************************//**
			@short		standard destructor
			@descr		This method destruct an instance of this class and clear some member.
						This method is protected, because its not allowed to use an instance of this class as a member!
						You MUST use a pointer.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual	~ODispatchProvider();

		/*-****************************************************************************************************//**
			@short		reset instance to default values, release references and free memory
			@descr		There are two ways to delete an instance of this class.<BR>
						1) delete with destructor<BR>
						2) dispose from parent or factory ore ...<BR>
						This method do the same for both ways! It free used memory and release references ...

			@seealso	destructor ODispatchProvider()

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual void impl_resetObject();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		send status event to all registered listener
			@descr		Somewhere can register itself as listener to get information about successfuly or failed loading.
						We map this information from XLoadEventListener to XStatusListener interfaces!

			@seealso	method loadFinished()
			@seealso	method loadCancelled()

			@param		"sURL"					;	URL, which was loaded
			@param		"bLoadingSuccessful"	;	state of loading
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_sendStatusEvent(	const	OUSTRING&	sURL				,
											sal_Bool	bLoadingSuccessful	);

	//-------------------------------------------------------------------------------------------------------------
	//	debug methods
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		debug-method to check incoming parameter of some other mehods of this class
			@descr		The following methods are used to check parameters for other methods
						of this class. The return value is used directly for an ASSERT(...).

			@seealso	ASSERTs in implementation!

			@param		references to checking variables
			@return		sal_False on invalid parameter<BR>
						sal_True  otherway

			@onerror	-
		*//*-*****************************************************************************************************/

	#ifdef ENABLE_ASSERTIONS

	private:

		sal_Bool impldbg_checkParameter_ODispatchProvider	(	const	REFERENCE< XMULTISERVICEFACTORY >&	xFactory		,
																const	REFERENCE< XFRAME >&				xOwner			,
																		MUTEX&								aMutex			);
		sal_Bool impldbg_checkParameter_queryDispatch		(	const	UNOURL&								aURL			,
																const	OUSTRING&							sTargetFrameName,
																		sal_Int32							nSearchFlags	);
    	sal_Bool impldbg_checkParameter_queryDispatches		(	const	SEQUENCE< DISPATCHDESCRIPTOR >&		seqDescripts	);
    	sal_Bool impldbg_checkParameter_dispatch			(	const	UNOURL&								aURL			,
																const	SEQUENCE< PROPERTYVALUE >&			seqArguments	);
    	sal_Bool impldbg_checkParameter_addStatusListener	(	const	REFERENCE< XSTATUSLISTENER >&		xControl		,
																const	UNOURL&								aURL			);
    	sal_Bool impldbg_checkParameter_removeStatusListener(	const	REFERENCE< XSTATUSLISTENER >&		xControl		,
																const	UNOURL&								aURL			);
		sal_Bool impldbg_checkParameter_loadFinished		(	const	REFERENCE< XFRAMELOADER >&			xLoader			);
		sal_Bool impldbg_checkParameter_loadCancelled		(	const	REFERENCE< XFRAMELOADER >&			xLoader			);
		sal_Bool impldbg_checkParameter_disposing			(	const	EVENTOBJECT&						aEvent			);

	#endif	// #ifdef ENABLE_ASSERTIONS

	//-------------------------------------------------------------------------------------------------------------
	//	variables
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	private:

		MUTEX&									m_aMutex			;	/// shared mutex with owner instance
		WEAKREFERENCE< XFRAME >					m_xOwnerWeak		;	/// weakreference to owner (Don't use a hard reference. Owner can't delete us then!)
		REFERENCE< XMULTISERVICEFACTORY >		m_xFactory			;	/// factory shared with our owner to create new services!
		REFERENCE< XFRAMELOADER >				m_xLoader			;	/// current working loader (if we don't loading anything, loader is not set!)
		IMPL_ListenerContainerHelper			m_aListenerContainer;	/// Container to combine listeners and URLs.
		OUSTRING								m_sURL				;	/// URL for current active loader

};		//	class ODispatchProvider

}		//	namespace framework

#endif	//	#ifndef __FRAMEWORK_HELPER_ODISPATCHPROVIDER_HXX_
