/*************************************************************************
 *
 *  $RCSfile: pluginframe.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_HELPER_OPLUGINFRAMEDISPATCHER_HXX_
#include <helper/opluginframedispatcher.hxx>
#endif

#ifndef __FRAMEWORK_BAEHSERVICES_PLUGINFRAME_HXX_
#include <baeh_services/pluginframe.hxx>
#endif

#ifndef __FRAMEWORK_DEFINES_HXX_
#include <defines.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif

#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _TOOLKIT_HELPER_VCLUNOHELPER_HXX_
#include <toolkit/helper/vclunohelper.hxx>
#endif

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

/* HACK for translateToInternal */
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
/* HACK for translateToInternal */

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

using namespace ::com::sun::star::awt		;
using namespace ::com::sun::star::beans		;
using namespace ::com::sun::star::frame		;
using namespace ::com::sun::star::io		;
using namespace ::com::sun::star::lang		;
using namespace ::com::sun::star::mozilla	;
using namespace ::com::sun::star::registry	;
using namespace ::com::sun::star::uno		;
using namespace ::com::sun::star::util		;
using namespace ::cppu						;
using namespace ::osl						;
using namespace ::rtl						;

//_________________________________________________________________________________________________________________
//	non exported const
//_________________________________________________________________________________________________________________

#define	DEFAULT_XPLUGININSTANCEPEER			Reference< XPluginInstancePeer >()
#define	DEFAULT_XPLUGINWINDOWPEER			Reference< XPluginWindowPeer >()
#define	DEFAULT_SEQPROPERTIES				Sequence< PropertyValue >()
#define	DEFAULT_AURL						URL()
#define	DEFAULT_BILOAD						sal_False
#define	DEFAULT_BIHAVEDOCUMENT				sal_False
#define	REFERRERVALUE						DECLARE_ASCII( "private:user"				)
#define	PACKAGENAME_PORTAL					DECLARE_ASCII( "com.sun.star.Portal"		)
#define	KEYNAME_HTTPLOADBALANCING_HOST		DECLARE_ASCII( "HTTPLoadbalancing/Host"		)
#define	KEYNAME_HTTPLOADBALANCING_PORT		DECLARE_ASCII( "HTTPLoadbalancing/Port"		)
#define	KEYNAME_WEBAPPS_PORTAL_PREFIXPATH	DECLARE_ASCII( "WebApps/Portal/PrefixPath"	)

//_________________________________________________________________________________________________________________
//	non exported definitions
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
cIMPL_MainThreadExecutor::cIMPL_MainThreadExecutor(	eIMPL_PluginCommand		eCommand		,
													PlugInFrame*			pPluginInstance	)
	:	m_eCommand				( eCommand				)
	,	m_pPluginInstance		( pPluginInstance		)
	,	m_aPlatformWindowHandle	( Any()					)
	,	m_bEmbedded				( sal_False				)
{
}

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
cIMPL_MainThreadExecutor::cIMPL_MainThreadExecutor(			eIMPL_PluginCommand		eCommand				,
															PlugInFrame*			pPluginInstance			,
													const	Any&					aPlatformWindowHandle	,
															sal_Bool				bEmbedded				)
	:	m_eCommand				( eCommand				)
	,	m_pPluginInstance		( pPluginInstance		)
	,	m_aPlatformWindowHandle	( aPlatformWindowHandle	)
	,	m_bEmbedded				( bEmbedded				)
{
}

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
cIMPL_MainThreadExecutor::cIMPL_MainThreadExecutor(			eIMPL_PluginCommand			eCommand		,
															PlugInFrame*				pPluginInstance	,
													const   OUString&					sMIMEDescription,
													const	OUString&					sURL		    ,
													const	Reference< XInputStream >&	xStream     	,
													const	Any&						aSessionId		)
	:	m_eCommand				( eCommand			)
	,   m_pPluginInstance       ( pPluginInstance 	)
	,	m_sMIMEDescription		( sMIMEDescription	)
	,	m_sURL	                ( sURL				)
	,	m_xStream				( xStream			)
	,   m_aSessionId            ( aSessionId		)
{
}

//*****************************************************************************************************************
//	protected method
//*****************************************************************************************************************
sal_Int32 cIMPL_MainThreadExecutor::doIt()
{
	// Look for given command and forward call to right impl method of given instance!
	// We don't need any mutex here. Calledmethods must protected by himself.
	try
	{
		switch ( m_eCommand )
		{
			//-----------------------------------------------------------------------------------------------------
			case START			:	{
										if( m_pPluginInstance != NULL )
										{
											m_pPluginInstance->implcb_start();
										}
										break;
									}
			//-----------------------------------------------------------------------------------------------------
			case STOP			:	{
										if( m_pPluginInstance != NULL )
										{
											m_pPluginInstance->implcb_stop();
										}
										break;
									}
			//-----------------------------------------------------------------------------------------------------
			case CREATEWINDOW	:	{
										if( m_pPluginInstance != NULL )
										{
											m_pPluginInstance->implcb_createWindow( m_aPlatformWindowHandle, m_bEmbedded );
										}
										break;
									}
			//-----------------------------------------------------------------------------------------------------
			case DESTROY		:	{
										if( m_pPluginInstance != NULL )
										{
											m_pPluginInstance->implcb_destroy();
										}
										break;
			                        }
			//-----------------------------------------------------------------------------------------------------
 		   case NEWSTREAM       :   {
	 		                           if( m_pPluginInstance != NULL )
		                          	   {
                           				   m_pPluginInstance->implcb_newStream( m_sMIMEDescription, m_sURL, m_xStream, m_aSessionId );
                         			   }
									   break;
		                            }
			//-----------------------------------------------------------------------------------------------------
		   case NEWURL          :   {
			                           if( m_pPluginInstance != NULL )
									   {
										   m_pPluginInstance->implcb_newURL( m_sMIMEDescription, m_sURL, m_aSessionId );
									   }
									   break;
		                            }
			//-----------------------------------------------------------------------------------------------------
			default				:	{
										LOG_ASSERT( sal_False, "cIMPL_MainThreadExecutor::doIt()\nCommand multiplexer of PlugInFrame has unknown command detected!\n" )
										break;
									}
		}
	}
	catch( RuntimeException& )
	{
		// We have detected a runtime exception ... all interface methods of XPluginInstance can throw this ... but
		// I don't know how I can do it from here!
		LOG_ASSERT( sal_False, "cIMPL_MainThreadExecutor::doIt()\nCommand multiplexer of PlugInFrame has RuntimeException catched ! ...\n" )
	}

	return 0;
}

//*****************************************************************************************************************
//	constructor
//*****************************************************************************************************************
PlugInFrame::PlugInFrame( const Reference< XMultiServiceFactory >& xFactory )
		//	Init baseclasses first
		:	Task					( xFactory							)
		// Init member
		,	m_xPlugInInstancePeer	( DEFAULT_XPLUGININSTANCEPEER		)
		,	m_xPlugInWindowPeer		( DEFAULT_XPLUGINWINDOWPEER			)
		,	m_seqProperties			( DEFAULT_SEQPROPERTIES				)
		,	m_aURL					( DEFAULT_AURL						)
		,	m_bILoad				( DEFAULT_BILOAD					)
		,	m_bIHaveDocument		( DEFAULT_BIHAVEDOCUMENT			)
{
	// Overwrite these property of task!
	m_bIsPlugIn = sal_True;
}

//*****************************************************************************************************************
//	destructor
//*****************************************************************************************************************
PlugInFrame::~PlugInFrame()
{
}

//*****************************************************************************************************************
//	XInterface, XTypeProvider, XServiceInfo
//*****************************************************************************************************************

DEFINE_XINTERFACE_2						(	PlugInFrame									,
											Task										,
											DIRECT_INTERFACE(XInitialization			),
											DIRECT_INTERFACE(XPluginInstance			)
										)

DEFINE_XTYPEPROVIDER_2_WITH_BASECLASS	(	PlugInFrame					,
											Task		   				,
											XInitialization				,
											XPluginInstance
										)

DEFINE_XSERVICEINFO_MULTISERVICE		(	PlugInFrame						,
											SERVICENAME_PLUGINFRAME			,
											IMPLEMENTATIONNAME_PLUGINFRAME
										)

//*****************************************************************************************************************
//	XInitialization
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::initialize( const Sequence< Any >& seqArguments ) throw(	Exception			,
																					RuntimeException	)
{
	// Be sure - all calls of this method must free his own mutex, if it the same as i use!!!???
	// impl_tryToLoadDocument() is asynchron ...
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::initialize()" )
	// Safe impossible cases
	// Method is not defined for all incoming parameters.
	LOG_ASSERT( impldbg_checkParameter_initialize( seqArguments ), "PlugInFrame::initialize()\nInvalid parameter detected.\n" )

	// Our plugin need information about his parent!
	// If someone dispatch anything to this plugin instance, he will create a new window and load the content.
	// Then he must append himself to our frame tree !!! => Thats why he need a valid reference to the desktop
	// as parent to do this.
	// We can giv him these reference, because the desktop MUST BE a OneInstance-Service!
	// If we instanciate a ne reference, we share the only one desktop object with others.
	Reference< XFramesSupplier > xDesktop( m_xFactory->createInstance( SERVICENAME_DESKTOP ), UNO_QUERY );
	// Safe impossible cases
	// The desktop must exist at this point or we have created a new one, because we have called creation of OneInstanceService at first.
	LOG_ASSERT( !(xDesktop.is()==sal_False), "PlugInFrame::PlugInFrame()\nThere is no valid desktop as parent for our new plugin!\n" )
	// Append frame at parent.
	// This will set desktop as parent automaticly!
	Reference< XFrames > xFramesHelper = xDesktop->getFrames();
	xFramesHelper->append( Reference< XFrame >( static_cast< OWeakObject* >( this ), UNO_QUERY ) );
	// In special debug mode only(!) ... log current tree state in file.
//	LOG_TREE( xDesktop )

    // We accept two arguments for initializing only.
	// It must be a reference of XPluginInstancePeer first and one of XPluginWindowPeer as second!
	// We check it in impldbg_checkParameter... function in debug version.
	// In release version it must be true!
	seqArguments[0] >>= m_xPlugInInstancePeer	;
	seqArguments[1] >>= m_xPlugInWindowPeer		;

	if( m_xPlugInDispatcher.is() == sal_False )
	{
		// Initialize a new dispatchhelper-object to handle dispatches PRIVATE!
		// We have already a helper in our baseclass (!), but to forward special dispatches we must have a special one too.
		// We forward "_blank"/CREATE and "_self"/""/SELF to the plugin dll and the webserver. And we will get it back from these programs
		// sometimes later if it's a staroffice url. Otherwise the browser open it by himself!
		//		PlugInFrame::m_xPlugInDispatcher	=> send to browser
		//		Frame::m_xDispatchHelper			=> load component for sended and recieved url (!)
		OPlugInFrameDispatcher* pDispatchHelper = new OPlugInFrameDispatcher( m_xFactory, m_aMutex, this, m_xPlugInInstancePeer );
		m_xPlugInDispatcher = Reference< XDispatchProvider >( (OWeakObject*)pDispatchHelper, UNO_QUERY );
		// Safe impossible cases
		// We can't work without these helper!
		LOG_ASSERT( !(m_xPlugInDispatcher.is()==sal_False), "PlugInFrame::initialize()\nDispatchHelper is not valid. XDispatchProvider and XDispatch are not supported!\n" )
	}

	impl_tryToLoadDocument();
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::start() throw( RuntimeException )
{
	// Synchronize call with main thread.
	cIMPL_MainThreadExecutor aForward( START, this );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_start() throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::implcb_start()" )
	// If we are ready to work ... or somewhere has reactivated us (browser history!) ...
	if( m_xContainerWindow.is() == sal_True )
	{
		// ... we must show us.
//		m_xContainerWindow->setVisible( sal_True );
	}
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::stop() throw( RuntimeException )
{
	// Synchronize call with main thread.
	cIMPL_MainThreadExecutor aForward( STOP, this );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_stop() throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::implcb_stop()" )
	// If somewhere has deactivated us (browser history!) ...
	if( m_xContainerWindow.is() == sal_True )
	{
		// ... we must hide us.
		m_xContainerWindow->setVisible( sal_False );
	}
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::destroy() throw( RuntimeException )
{
	// Synchronize call with main thread.
	cIMPL_MainThreadExecutor aForward( DESTROY, this );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_destroy() throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::implcb_destroy()" )
	// Reset working state to DESTROYED.
	m_bIHaveDocument = sal_False;
	// Then we must close us as task.
	// This will close all childs and remove this plugin-task-frame from our parent ... the desktop!

	// Don't show any dialogs, errors or something else at close!
	// We save changed documents in every way. If saving failed ... it doesnt matter!
	// Don't forget to enable dialogs after closing again.
	Application::EnableDialogCancel( sal_True  );
	Task::close();
	Application::EnableDialogCancel( sal_False );
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::createWindow(	const	Any&		aPlatformWindowHandle,
								 					sal_Bool	bEmbedded			) throw( RuntimeException )
{
	// Synchronize call with main thread.
	cIMPL_MainThreadExecutor aForward( CREATEWINDOW, this, aPlatformWindowHandle, bEmbedded );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_createWindow(	const	Any&		aPlatformWindowHandle,
								 						sal_Bool	bEmbedded			) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::implcb_createWindow()" )
	// Safe impossible cases
	// Method is not defined for all incoming parameters.
	LOG_ASSERT( impldbg_checkParameter_createWindow( aPlatformWindowHandle, bEmbedded ), "PlugInFrame::implcb_createWindow()\nInvalid parameter detected.\n" )

	// Create a new remote rvp workwindow, get information from it and set it on our plugin dll.
	// The initiylize THIS frame with the new created window and try to load the document in it.
	WorkWindow* pWorkWindow				= new WorkWindow( NULL, aPlatformWindowHandle );
	Any			aReturnWindowDescriptor	= pWorkWindow->GetSystemDataAny();

	m_xPlugInWindowPeer->setChildWindow( aReturnWindowDescriptor );
	Frame::initialize( VCLUnoHelper::GetInterface( pWorkWindow ) );
	impl_tryToLoadDocument();
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::newStream(	const	OUString&					sMIMEDescription,
										const	OUString&					sURL			,
										const	Reference< XInputStream >&	xStream			,
										const	Any&						aSessionId		) throw( RuntimeException )
{
	// Synchronize call with main thread.
	cIMPL_MainThreadExecutor aForward( NEWSTREAM, this , sMIMEDescription , sURL , xStream , aSessionId );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_newStream(	const	OUString&					sMIMEDescription,
												const	OUString&					sURL			,
												const	Reference< XInputStream >&	xStream			,
												const	Any&						aSessionId		) throw( RuntimeException )
{
	// Be sure - all calls of this method must free his own mutex, if it the same as i use!!!???
	// impl_tryToLoadDocument() is asynchron ...
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::newStream()" )
	// Safe impossible cases
	// Method is not defined for all incoming parameters.
	LOG_ASSERT( impldbg_checkParameter_newStream( sMIMEDescription, sURL, xStream ), "PlugInFrame::newStream()\nInvalid parameter detected.\n" )
	// In special debug mode you can log parameter in file!
	LOG_PARAMETER_NEWSTREAM( m_sName, sMIMEDescription, sURL, xStream, aSessionId )

	/* HACK _______________________________________________________________________________________________________
	 	Bis am URLTransformer eine Method zum Rueckwandeln einer PraesentationURL nach interner Darstellung
	 	existiert mu hier per Hand gewandelt werden!
	 */

	UniString sExternalURL = sURL;
	UniString sInternalURL;
	INetURLObject::translateToInternal( sExternalURL, sInternalURL );

	LOG_URLRECEIVE( m_sName, "newStream", sExternalURL, sInternalURL )

	/* HACK _______________________________________________________________________________________________________*/

	// Save all informations for try to load the stream.
	// Creation of window is asynchron and we must collect all needed informations
	// before loading.
	// Pack parameter in sequence and safe given URL.
	// (Attention: Add a referrer to parameter list every time. Sfx need it so!)
	m_seqProperties.realloc( 4 );
	m_seqProperties[0].Name	  =	ARGUMENT_MIMETYPE		;
	m_seqProperties[0].Value<<=	sMIMEDescription		;
	m_seqProperties[1].Name	  =	ARGUMENT_INPUTSTREAM	;
	m_seqProperties[1].Value<<=	xStream					;
	m_seqProperties[2].Name	  =	ARGUMENT_REFERRER		;
	m_seqProperties[2].Value<<=	REFERRERVALUE			;
	m_seqProperties[3].Name	  =	ARGUMENT_READONLY		;
	m_seqProperties[3].Value<<=	sal_True				;
	m_aURL.Complete = sInternalURL;

	impl_tryToLoadDocument();
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::newURL(	const	OUString&	sMIMEDescription,
									const	OUString&	sURL			,
									const	Any&		aSessionId		) throw( RuntimeException )
{
	cIMPL_MainThreadExecutor aForward( NEWURL, this, sMIMEDescription, sURL, Reference< XInputStream >(), aSessionId );
	aForward.execute();
}

//-----------------------------------------------------------------------------------------------------------------
void SAL_CALL PlugInFrame::implcb_newURL(	const	OUString&	sMIMEDescription,
											const	OUString&	sURL			,
											const	Any&		aSessionId		) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::newURL()" )
	// Safe impossible cases
	// Method is not defined for all incoming parameters.
	LOG_ASSERT( impldbg_checkParameter_newURL( sMIMEDescription, sURL ), "PlugInFrame::newURL()\nInvalid parameter detected.\n" )
	// In special debug mode you can log parameter in file!
	LOG_PARAMETER_NEWURL( m_sName, sMIMEDescription, sURL, aSessionId )

	/* HACK _______________________________________________________________________________________________________
	 	Bis am URLTransformer eine Method zum Rueckwandeln einer PraesentationURL nach interner Darstellung
	 	existiert mu hier per Hand gewandelt werden!
	 */

	UniString sExternalURL = sURL;
	UniString sInternalURL;
	INetURLObject::translateToInternal( sExternalURL, sInternalURL );

	LOG_URLRECEIVE( m_sName, "newURL", sExternalURL, sInternalURL )

	/* HACK _______________________________________________________________________________________________________*/

	// Save all informations for try to load the URL.
	// Creation of window is asynchron and we must collect all needed informations
	// before loading.
	// Pack parameter in sequence and safe given URL.
	// (Attention: Add a referrer to parameter list every time. Sfx need it so!)
	m_seqProperties.realloc( 2 );
	m_seqProperties[0].Name	  =	ARGUMENT_MIMETYPE	;
	m_seqProperties[0].Value<<=	sMIMEDescription	;
	m_seqProperties[1].Name	  =	ARGUMENT_REFERRER	;
	m_seqProperties[1].Value<<=	REFERRERVALUE		;
	m_aURL.Complete = sInternalURL;

	impl_tryToLoadDocument();
}

//*****************************************************************************************************************
//	XPluginInstance
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::getHttpServerURL(	OUString&	sHost	,
												sal_uInt16&	nPort	,
												OUString&	sPrefix	) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::getHttpServerURL()" )
	// Safe impossible cases
	// Method is not defined for all incoming parameters.
	LOG_ASSERT( impldbg_checkParameter_getHttpServerURL( sHost, nPort, sPrefix ), "PlugInFrame::getHttpServerUR()\nInvalid parameter detected.\n" )

	// First reset incoming references and set default values if follow operations failed!
	sHost	=	OUString()	;
	nPort	=	0			;
	sPrefix	=	OUString()	;

	// Catch all exceptions of configuration management!
	// We return our default values if something is wrong.
	try
	{
		// Get reference to our configuration managemenet.
		Reference< XSimpleRegistry > xPortalPackage( m_xFactory->createInstance( SERVICENAME_CONFIGURATION ), UNO_QUERY );
		LOG_ASSERT( !(xPortalPackage.is()==sal_False), "PlugInFrame::getHttpServerURL()\nConfiguration management not registered ...!?\n" )
		if( xPortalPackage.is() == sal_True )
		{
			// Try to open right package and get full access to it.
			// (Open it readonly and don't create it, if it not exist!)
			xPortalPackage->open( PACKAGENAME_PORTAL, sal_True, sal_False );
			Reference< XRegistryKey > xRootKey = xPortalPackage->getRootKey();
			LOG_ASSERT( !(xPortalPackage->isValid()==sal_False), "PlugInFrame::getHttpServerURL()\nOpen of package \"com.sun.star.Portal\" failed.\n" )
			LOG_ASSERT( !(xRootKey.is()==sal_False), "PlugInFrame::getHttpServerURL()\nCant get rootkey of portal package.\n" )
			if( xRootKey.is() == sal_True )
			{
				// Read values from configuration management to fill return variables.
				// Don't check type of values! We know ... STRING, LONG, STRING!!!
				// If an exception is thrown, something has changed in our configuration and we return our default values.
				Reference< XRegistryKey > xEntry = xRootKey->openKey( KEYNAME_HTTPLOADBALANCING_HOST );
				if( xEntry.is() == sal_True )
				{
					sHost = xEntry->getStringValue();
					xEntry->closeKey();
				}
				xEntry = xRootKey->openKey( KEYNAME_HTTPLOADBALANCING_PORT );
				if( xEntry.is() == sal_True )
				{
					nPort = xEntry->getLongValue();
					xEntry->closeKey();
				}
				xEntry = xRootKey->openKey( KEYNAME_WEBAPPS_PORTAL_PREFIXPATH );
				if( xEntry.is() == sal_True )
				{
					sPrefix = xEntry->getStringValue();
					xEntry->closeKey();
				}
				xRootKey->closeKey();
			}
			xPortalPackage->close();
		}
	}
	catch( InvalidRegistryException& )
	{
		LOG_ASSERT( sal_False, "PlugInFrame::getHttpServerURL()\nInvalidRegistryException catched ...\n" )
		// Reset return values. It can be we have set some of it before exception was thrown!
		sHost	=	OUString()	;
		nPort	=	0			;
		sPrefix	=	OUString()	;
	}
	catch( RuntimeException& )
	{
		LOG_ASSERT( sal_False, "PlugInFrame::getHttpServerURL()\nRuntimeException catched ...\n" )
	}
}

//*****************************************************************************************************************
//	XDispatchProvider
//*****************************************************************************************************************
Reference< XDispatch > SAL_CALL PlugInFrame::queryDispatch(	const	URL&	 	aURL			,
										   					const	OUString&	sTargetFrameName,
										   							sal_Int32	nSearchFlags	) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "OPlugInFrameDispatcher::queryDispatch()" )
	// Safe impossible cases
	// Method not defined for all incoming parameter.
	LOG_ASSERT( impldbg_checkParameter_queryDispatch( aURL, sTargetFrameName, nSearchFlags ), "OPlugInFrameDispatcher::queryDispatch()\nInvalid parameter detected.\n" )

	// Set default return value.
	Reference< XDispatch > xReturn;

	// An interceptor can break our path to dispatch queries!
	// Is there an interceptor set on this instance?
	if ( m_xInterceptor.is() == sal_True )
	{
		// Yes; Then forward query to this instance and set results for return.
		xReturn = m_xInterceptor->queryDispatch( aURL, sTargetFrameName, nSearchFlags );
	}
	else
	{
		// Else we can use our own dispatch helper.
		xReturn = m_xPlugInDispatcher->queryDispatch( aURL, sTargetFrameName, nSearchFlags );
	}
	// Return result of query.
	return xReturn;
}

//*****************************************************************************************************************
//	XDispatchProvider
//*****************************************************************************************************************
Sequence< Reference< XDispatch > > SAL_CALL PlugInFrame::queryDispatches( const Sequence< DispatchDescriptor >& seqDescripts ) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::queryDispatches()" )
	// Safe impossible cases
	// Method not defined for all incoming parameter.
	LOG_ASSERT( impldbg_checkParameter_queryDispatches( seqDescripts ), "PlugInFrame::queryDispatch()\nInvalid parameter detected.\n" )

	// Set default return value.
	Sequence< Reference< XDispatch > > seqReturn;

	// An interceptor can break our path to dispatch queries!
	// Is there an interceptor set on this instance?
	if ( m_xInterceptor.is() == sal_True )
	{
		// Yes; Then forward query to this instance and set results for return.
		seqReturn = m_xInterceptor->queryDispatches( seqDescripts );
	}
	else
	{
		// Else we can use our own dispatch helper.
		seqReturn = m_xPlugInDispatcher->queryDispatches( seqDescripts );
	}
	// Return result of query.
	return seqReturn;
}

//*****************************************************************************************************************
//	 XDispatchProviderInterception
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::registerDispatchProviderInterceptor( const Reference< XDispatchProviderInterceptor >& xInterceptor ) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::registerDispatchProviderInterceptor()" )
	// Safe impossible cases
	LOG_ASSERT( impldbg_checkParameter_registerDispatchProviderInterceptor( xInterceptor ), "PlugInFrame::registerDispatchProviderInterceptor()\nInvalid parameter detected.\n" )

	if ( m_xInterceptor.is() )
	{
		// There is already an interceptor; the new one will become it as master.
		xInterceptor->setSlaveDispatchProvider		( Reference< XDispatchProvider >( m_xInterceptor, UNO_QUERY ) );
		m_xInterceptor->setMasterDispatchProvider	( Reference< XDispatchProvider >( xInterceptor	, UNO_QUERY ) );
	}
	else
	{
		// It is the first interceptor; pass own dispatch provider as a slave.
		xInterceptor->setSlaveDispatchProvider( m_xPlugInDispatcher );
	}

	// Set the new interceptor at frame.
	// Frame is the master of the first interceptor.
	m_xInterceptor = xInterceptor;
	m_xInterceptor->setMasterDispatchProvider( this );
}

//*****************************************************************************************************************
//	 XDispatchProviderInterception
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::releaseDispatchProviderInterceptor( const Reference< XDispatchProviderInterceptor >& xInterceptor ) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::releaseDispatchProviderInterceptor()" )
	// Safe impossible cases
	LOG_ASSERT( impldbg_checkParameter_releaseDispatchProviderInterceptor( xInterceptor ), "PlugInFrame::releaseDispatchProviderInterceptor()\nInvalid parameter detected.\n" )

	// Get slave and master of given interceptor.
	Reference< XDispatchProvider >				xSlave	( xInterceptor->getSlaveDispatchProvider()	, UNO_QUERY );
	Reference< XDispatchProviderInterceptor >	xMaster	( xInterceptor->getMasterDispatchProvider()	, UNO_QUERY );

	if ( xMaster.is() == sal_True )
	{
		// Old master may be an interceptor too, must be reconnected.
		if ( xSlave.is() == sal_True )
		{
			xMaster->setSlaveDispatchProvider( xSlave );
		}
		else
		{
			xMaster->setSlaveDispatchProvider( m_xPlugInDispatcher );
		}
	}

	// Unchain the interceptor that has to be removed.
	xInterceptor->setSlaveDispatchProvider( Reference< XDispatchProvider >() );
	xInterceptor->setMasterDispatchProvider( Reference< XDispatchProvider >() );

	if ( m_xInterceptor == xInterceptor )
	{
		// First interceptor was removed; its old slave will become the new interceptor.
		m_xInterceptor = Reference< XDispatchProviderInterceptor >( xSlave, UNO_QUERY );
	}
}

//*****************************************************************************************************************
//	 XStatusListener
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::statusChanged( const FeatureStateEvent& aEvent ) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::statusChanged()" )
	// Safe impossible cases
	LOG_ASSERT( impldbg_checkParameter_statusChanged( aEvent ), "PlugInFrame::statusChanged()\nInvalid parameter detected.\n" )

	// Is message for me ?
	if( aEvent.FeatureDescriptor == FEATUREDESCRIPTOR_LOADSTATE )
	{
		// Loading was successful.
		if( aEvent.IsEnabled == sal_True )
		{
			// Then we must forward the information about finished loading to browser!
			// Send a reference to an object for scripting to browser.
			// We use these object for it, because it's the most flexibility object we can send.
			// How can recipient distinguish between loadFinished() and loadCancelled() ... ?!
			// It's easy ... on loadFinished() we send a valid reference ...
			// on loadCancelled() we do nothing!
			m_xPlugInInstancePeer->enableScripting( static_cast< OWeakObject* >( this ), m_xFactory );
			// Reset state for loading.
			m_bILoad			=	sal_False	;
			m_bIHaveDocument	=	sal_True	;
		}
		// Loading was cancelled.
		else
		{
			// Reset state for loading.
			m_bILoad			=	sal_False	;
			m_bIHaveDocument	=	sal_False	;
		}
		// We have the result of loading ... we can remove us as listener for status events of our dispatch helper.
		Reference< XDispatch > xDispatcher( m_xDispatchHelper, UNO_QUERY );
		xDispatcher->removeStatusListener( static_cast< XStatusListener* >( this ), m_aURL );
	}
}

//*****************************************************************************************************************
//	 XEventListener
//*****************************************************************************************************************
void SAL_CALL PlugInFrame::disposing( const EventObject& aEvent ) throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "PlugInFrame::disposing()" )
	// Reset our member to default values.
	m_bILoad				=	DEFAULT_BILOAD					;
	m_bIHaveDocument		=	DEFAULT_BIHAVEDOCUMENT			;
	m_xPlugInInstancePeer	=	DEFAULT_XPLUGININSTANCEPEER		;
	m_xPlugInWindowPeer		=	DEFAULT_XPLUGINWINDOWPEER		;
	m_seqProperties			=	DEFAULT_SEQPROPERTIES			;
	m_aURL					=	DEFAULT_AURL					;
	// Don't forget to reset member of our baseclasses too!
	Task::disposing( aEvent );
}

//*****************************************************************************************************************
//	 private method
//*****************************************************************************************************************
void PlugInFrame::impl_tryToLoadDocument()
{
	// Some things at these class working asynchron! We get all needed informations at different times.
	// If we have all informations ...
	if	(
			( m_bILoad						==	sal_False	)	&&
			( m_aURL.Complete.getLength()	>	0			)	&&
			( m_xContainerWindow.is()		==	sal_True	)	&&
			( m_xParent.is()				==	sal_True	)
		)
	{
		// ... we can load the specified document.
		// But first we must initialize these instance append it as child frame of our parent - the desktop!
		// Attention: Don't show our window yet. We must be READY first.
		// If method start() called at us we can show our window!

		m_xParent->setActiveFrame( Reference< XFrame >( static_cast< OWeakObject* >( this ), UNO_QUERY ) );
		Reference< XDispatch > xDispatcher( m_xDispatchHelper, UNO_QUERY );
		xDispatcher->addStatusListener( static_cast< XStatusListener* >( this ), m_aURL );
		xDispatcher->dispatch( m_aURL, m_seqProperties );

		// Now we have all needed informations, are a member of our frame tree and have load the document ...
		// We wait for any impl_loadFinished() calls to enable scripting at brwoser.
		// For next time we set our state to "LOADING".
		m_bILoad = sal_True;
	}
	else
	{
		// Else; We don't have all neccessary informations for right working.
		m_bILoad = sal_False;
	}
}

//_________________________________________________________________________________________________________________
//	debug methods
//_________________________________________________________________________________________________________________

/*-----------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact the autor or add it himself !(?)
		But ... look for right testing! See using of this methods!
-----------------------------------------------------------------------------------------------------------------*/

#ifdef ENABLE_ASSERTIONS

//*****************************************************************************************************************
// We accept two arguments only and it must be reference of XPluginInstancePeer and XPluginWindowPeer for communication with the browser!
sal_Bool PlugInFrame::impldbg_checkParameter_initialize( const Sequence< Any >& seqArguments)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &seqArguments						==	NULL														)	||
			( seqArguments.getLength()			!=	2															)	||
			( seqArguments[0].getValueType()	!=	::getCppuType((const Reference< XPluginInstancePeer >*)NULL))	||
			( seqArguments[1].getValueType()	!=	::getCppuType((const Reference< XPluginWindowPeer >*)NULL)	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_createWindow(	const	ANY&		aPlatformWindowHandle,
												   		 			sal_Bool	bEmbedded			 )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aPlatformWindowHandle == NULL )	||
			(
				( bEmbedded	!=	sal_True	)	&&
				( bEmbedded	!=	sal_False	)
			)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_newStream(	const	OUSTRING&					sMIMEDescription,
														const	OUSTRING&					sURL			,
														const	REFERENCE< XINPUTSTREAM >&	xStream			)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &sMIMEDescription				==	NULL		)	||
			( &sURL							==	NULL		)	||
			( &xStream						==	NULL		)	||
			( sMIMEDescription.getLength()	<	1			)	||
			( sURL.getLength()				<	1			)	||
			( xStream.is()					==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_newURL(	const	OUSTRING&	sMIMEDescription,
														const	OUSTRING&	sURL			)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &sMIMEDescription				==	NULL		)	||
			( &sURL							==	NULL		)	||
			( sMIMEDescription.getLength()	<	1			)	||
			( sURL.getLength()				<	1			)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
// These variables are "out" parameter! Check for valid pointer only - not for valid values!
sal_Bool PlugInFrame::impldbg_checkParameter_getHttpServerURL(		OUString&	sHost	,
																	sal_uInt16&	nPort	,
																	OUString&	sPrefix	)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &sHost	==	NULL	)	||
			( &nPort	==	NULL	)	||
			( &sPrefix	==	NULL	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_queryDispatch(	const	URL&	 	aURL			,
															const	OUString&	sTargetFrameName,
																	sal_Int32	nSearchFlags	)
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aURL							==	NULL		)	||
			( aURL.Complete.getLength()		<	1			)	||
			( &sTargetFrameName				==	NULL		)	||
			// sTargetFrameName can be ""!
			(
				( 	 nSearchFlags != FrameSearchFlag::AUTO		  )	&&
				( !( nSearchFlags &  FrameSearchFlag::PARENT	) )	&&
				( !( nSearchFlags &  FrameSearchFlag::SELF		) )	&&
				( !( nSearchFlags &  FrameSearchFlag::CHILDREN	) )	&&
				( !( nSearchFlags &  FrameSearchFlag::CREATE	) )	&&
				( !( nSearchFlags &  FrameSearchFlag::SIBLINGS	) )	&&
				( !( nSearchFlags &  FrameSearchFlag::TASKS		) )	&&
				( !( nSearchFlags &  FrameSearchFlag::ALL		) )	&&
				( !( nSearchFlags &  FrameSearchFlag::GLOBAL	) )
			)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_queryDispatches( const Sequence< DispatchDescriptor >& seqDescriptor )
{
	// Set default return value.
	sal_Bool bOK = sal_True;

	// Check parameter.
	if	(
			( &seqDescriptor			==	NULL	)	||
			( seqDescriptor.getLength()	<	1		)
		)
	{
		bOK = sal_False ;
	}

	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_statusChanged( const FeatureStateEvent& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aEvent								==	NULL	)	||
			( aEvent.FeatureDescriptor.getLength()	<	1		)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_disposing( const EventObject& aEvent )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &aEvent				==	NULL		)	||
			( aEvent.Source.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_registerDispatchProviderInterceptor( const Reference< XDispatchProviderInterceptor >& xInterceptor )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &xInterceptor		==	NULL		)	||
			( xInterceptor.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool PlugInFrame::impldbg_checkParameter_releaseDispatchProviderInterceptor( const Reference< XDispatchProviderInterceptor >& xInterceptor )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &xInterceptor		==	NULL		)	||
			( xInterceptor.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

#endif	//	#ifdef ENABLE_ASSERTIONS

}		//	namespace framework
