/*************************************************************************
 *
 *  $RCSfile: logindialog.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_LOGINDIALOG_LOGINDIALOG_HXX_
#include <logindialog.hxx>
#endif

#ifndef __FRAMEWORK_DEFINES_HXX_
#include <defines.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif

//_________________________________________________________________________________________________________________
//	includes of other projects
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _VOS_PROFILE_HXX_
#include <vos/profile.hxx>
#endif

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif

#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

using namespace ::com::sun::star::awt			;
using namespace ::com::sun::star::beans			;
using namespace ::com::sun::star::lang			;
using namespace ::com::sun::star::registry		;
using namespace ::com::sun::star::uno			;
using namespace ::cppu							;
using namespace ::osl							;
using namespace ::rtl							;
using namespace ::vos							;

//_________________________________________________________________________________________________________________
//	non exported const
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	non exported definitions
//_________________________________________________________________________________________________________________

//_________________________________________________________________________________________________________________
//	declarations
//_________________________________________________________________________________________________________________

//*****************************************************************************************************************
//	constructor cIMPL_Dialog
//*****************************************************************************************************************
cIMPL_Dialog::cIMPL_Dialog()
	:	ModalDialog				( NULL, impl_getResId( RID_DLG_LOGIN	))
	,	m_imageHeader			( this, impl_getResId( RID_FI_HEADER 	))
	,	m_textLoginText			( this, impl_getResId( RID_FT_LOGINTEXT	))
	,	m_textUserName			( this, impl_getResId( RID_FT_USERNAME	))
	,	m_textPassword			( this, impl_getResId( RID_FT_PASSWORD	))
	,	m_textServer			( this, impl_getResId( RID_FT_SERVER 	))
	,	m_editUserName			( this, impl_getResId( RID_ED_USERNAME	))
	,	m_editPassword			( this, impl_getResId( RID_ED_PASSWORD	))
	,	m_comboServer			( this, impl_getResId( RID_CB_SERVER 	))
	,	m_buttonOK				( this, impl_getResId( RID_PB_OK 		))
	,	m_buttonCancel			( this, impl_getResId( RID_PB_CANCEL 	))
{
	// Initialize ressources.
	FreeResource();
	m_textLoginText.SetStyle( m_textLoginText.GetStyle() ^ WB_WORDBREAK );
}

//*****************************************************************************************************************
//	destructor cIMPL_Dialog
//*****************************************************************************************************************
cIMPL_Dialog::~cIMPL_Dialog()
{
	// Deinitialize something.
	Close();
	Flush();
}

//*****************************************************************************************************************
//	public method
//*****************************************************************************************************************
void cIMPL_Dialog::setValues( const tIMPL_DialogData& aDataSet )
{
	m_aDataSet = aDataSet;
	// Set user name and his password
	m_editUserName.SetText( m_aDataSet.sUserName );
	m_editPassword.SetText( m_aDataSet.sPassword );
	// initialize server list
	m_aDataSet.seqServerList = aDataSet.seqServerList;
	sal_Int32 nCount = m_aDataSet.seqServerList.getLength();
	for( sal_Int32 nServer=0; nServer<nCount; ++nServer )
	{
		m_comboServer.InsertEntry( m_aDataSet.seqServerList[nServer] );
	}
	m_comboServer.SetText( m_comboServer.GetEntry( m_aDataSet.nActiveServer-1 ) ); // First index of nActiveServer is 1 ... but list start at 0!
	// set initial focus to right field
	m_editUserName.GrabFocus();
}

//*****************************************************************************************************************
//	public method
//*****************************************************************************************************************
tIMPL_DialogData cIMPL_Dialog::getValues()
{
	// Copy user properties to data set.
	m_aDataSet.sUserName = m_editUserName.GetText();
	m_aDataSet.sPassword = m_editPassword.GetText();
	// Get current selected item from "Server" - combobox
	OUString	sSelectedServer	= m_comboServer.GetText();
	sal_uInt16	nSelectedNumber	= m_comboServer.GetEntryPos( (XubString)sSelectedServer );
	if( nSelectedNumber == COMBOBOX_ENTRY_NOTFOUND )
	{
		// User has created a new entry!
		// We must add it to our history.
		sal_Int32 nBeforeCount = m_aDataSet.seqServerList.getLength();
		m_aDataSet.seqServerList.realloc( nBeforeCount+1 );
		m_aDataSet.seqServerList[nBeforeCount] = sSelectedServer;
	}
	// Now we can search for our active element in list.
	m_aDataSet.nActiveServer = 1; // Set fallback if search failed.
	sal_Int16 nCount = m_aDataSet.seqServerList.getLength();
	for( sal_Int16 nSearchEntry=0; nSearchEntry<nCount; ++nSearchEntry )
	{
		if( m_aDataSet.seqServerList[nSearchEntry] == sSelectedServer )
		{
			m_aDataSet.nActiveServer = nSearchEntry+1; // First index is 0!
			break;
		}
	}
	// Return values.
	return m_aDataSet;
}
/*
//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
Sequence< OUString > cIMPL_Dialog::impl_checkServerHistory( const Sequence< OUString >& seqHistory )
{
	// Copy all NEW server entries from given list to return list.
	// New entries are the last ones.
	// zB.	nCount				=	15
	//		MAX_SERVERHISTORY	=	10
	//	=>	old server			=	1..5
	//	=>	new server			=	6..15

	// First copy old list to new list! If maximum not reached we don't must do anything!
	Sequence< OUString > seqReturnList( seqHistory );
	// Control count of old list. If maximum is reached we must delete some entries.
	sal_Int32 nCount = seqHistory.getLength();
	if( nCount > MAX_SERVERHISTORY )
	{
		// Forget current new list and resize it to allowed maximum.
		seqReturnList.realloc( MAX_SERVERHISTORY );
		// Calc start point in old list to copy newest server only.
		sal_Int32 nItem			= nCount-MAX_SERVERHISTORY;
		sal_Int32 nDestination	= 0;
		for( sal_Int32 nSource=nItem; nSource<nCount; ++nSource )
		{
			seqReturnList[nDestination] = seqHistory[nSource];
			++nDestination;
		}
	}
	// Return new server list.
	return seqReturnList;
}
*/

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
ResId cIMPL_Dialog::impl_getResId( sal_uInt32 nId )
{
	// If our ressource member not initialized we must create a new one.
	static ResMgr* pRessourceManager = ResMgr::CreateResMgr( "lgd" MAKE_NUMSTR(SUPD) );
	// Ask our ressource member to get right ressource for given ID.
	return ResId( nId, pRessourceManager );
}

//*****************************************************************************************************************
//	constructor LoginDialog
//*****************************************************************************************************************
LoginDialog::LoginDialog( const Reference< XMultiServiceFactory >& xFactory )
		//	Init baseclasses first
		//	Attention:
		//		Don't change order of initialization!
		//      OMutexMember is a struct with a mutex as member. We can't use a mutex as member, while
		//		we must garant right initialization and a valid value of this! First initialize
		//		baseclasses and then members. And we need the mutex for other baseclasses !!!
		:	OMutexMember		(																						)
		,	OBroadcastHelper	( ((OMutexMember*)this)->m_aMutex														)
		,	OPropertySetHelper	( *SAL_STATIC_CAST( OBroadcastHelperVar< OMultiTypeInterfaceContainerHelper >*, this )	)
		,	OWeakObject			(																						)
		// Init member
		,	m_xFactory			( xFactory		)
		,	m_bInExecuteMode	( sal_False		)
{
	// Initialize this object.
	impl_openProfile();

//	ResMgr* pRessourceManager = CREATEVERSIONRESMGR( lgd );
//	Resource::SetResManager( pRessourceManager );

	OGuard aGuard( Application::GetSolarMutex() );
	m_pDialog = new cIMPL_Dialog;
}

//*****************************************************************************************************************
//	destructor
//*****************************************************************************************************************
LoginDialog::~LoginDialog()
{
	// Deinitialize important ressources.
	impl_closeProfile();
	// Forget servicemanager and let him die.
	if( m_xFactory.is() == sal_True )
	{
		Reference< XMultiServiceFactory >();
	}
	OGuard	aGuard( Application::GetSolarMutex() );
	if( m_pDialog != NULL )
	{
		delete m_pDialog;
	}
}

//*****************************************************************************************************************
//	XInterface, XTypeProvider, XServiceInfo
//*****************************************************************************************************************

DEFINE_XINTERFACE_6					(	LoginDialog							,
										OWeakObject							,
										DIRECT_INTERFACE(XTypeProvider		),
										DIRECT_INTERFACE(XServiceInfo		),
										DIRECT_INTERFACE(XDialog			),
										DIRECT_INTERFACE(XPropertySet		),
										DIRECT_INTERFACE(XFastPropertySet	),
										DIRECT_INTERFACE(XMultiPropertySet	)
									)

DEFINE_XTYPEPROVIDER_6				(	LoginDialog			,
										XTypeProvider		,
										XServiceInfo		,
										XDialog				,
										XPropertySet		,
										XFastPropertySet	,
										XMultiPropertySet
									)
/*
DEFINE_XSERVICEINFO_ONEINSTANCESERVICE	(	LoginDialog						,
											SERVICENAME_LOGINDIALOG			,
											IMPLEMENTATIONNAME_LOGINDIALOG
										)
*/
DEFINE_XSERVICEINFO_MULTISERVICE	(	LoginDialog						,
										SERVICENAME_LOGINDIALOG			,
										IMPLEMENTATIONNAME_LOGINDIALOG
									)

// Attention: If you have enabled any testmode different from TEST_NOTHING => you have declared XDebugging-interface automaticly!
// Bhere is no macro to define and implement the right methods. You are the only one, who know - how you will use this mechanism.
// It exist a macro to switch on or off your implementation only.
// SERVICEDEBUG_ENABLED must be defined, to activate your code!

//#ifdef SERVICEDEBUG_ENABLED

	// Debug mechanism for services is not used in this implementation.
	// This define will expand to nothing if SERVICEDEBUG_ENABLED unknown!
	// But if you will implement your own code - activate this define before ... and deactivate follow line.
//	DEFINE_EMPTY_XSPECIALDEBUGINTERFACE( LoginDialog )

//#endif // #ifdef SERVICEDEBUG_ENABLED

//*****************************************************************************************************************
//	XDialog
//*****************************************************************************************************************
void SAL_CALL LoginDialog::setTitle( const OUString& sTitle ) throw( RuntimeException )
{
	LOG_ASSERT( sal_False, "LoginDialog::setTitle()Not implemented yet!\n" );
}

//*****************************************************************************************************************
//	XDialog
//*****************************************************************************************************************
OUString SAL_CALL LoginDialog::getTitle() throw( RuntimeException )
{
	LOG_ASSERT( sal_False, "LoginDialog::getTitle()Not implemented yet!\n" );
	return OUString();
}

//*****************************************************************************************************************
//	XDialog
//*****************************************************************************************************************
sal_Int16 SAL_CALL LoginDialog::execute() throw( RuntimeException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "LoginDialog::execute()" )
	// Use SolarMutex for threadsafe code too!
	OGuard aSolarGuard( Application::GetSolarMutex() );

	// Set values on dialog and show him.
	// If user say "OK" set changed values on internal member, otherwise do nothing!
	// Return result of operation to caller.
	m_pDialog->setValues( m_aPropertySet );
	sal_Int16 nReturn = m_pDialog->Execute();
	if( nReturn == 1 )
	{
		m_aPropertySet = m_pDialog->getValues();
	}
	return nReturn;
}

//*****************************************************************************************************************
//	XDialog
//*****************************************************************************************************************
void SAL_CALL LoginDialog::endExecute() throw( RuntimeException )
{
	LOG_ASSERT( sal_False, "LoginDialog::endExecute()Not implemented yet!\n" )
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
sal_Bool SAL_CALL LoginDialog::convertFastPropertyValue(		Any&		aConvertedValue	,
				  												Any&		aOldValue		,
																sal_Int32	nHandle			,
														const	Any&		aValue			) throw( IllegalArgumentException )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "LoginDialog::convertFastPropertyValue()" )

	//	Check, if value of property will changed in method "setFastPropertyValue_NoBroadcast()".
	//	Return TRUE, if changed - else return FALSE.
	//	Attention:
	//		Method "impl_tryToChangeProperty()" can throw the IllegalArgumentException !!!

	//	Initialize state with FALSE !!!
	//	(Handle can be invalid)
	sal_Bool bReturn = sal_False;

	switch ( nHandle )
	{
		case PROPERTYHANDLE_CONNECTIONTYPE			:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.sConnectionType, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_PASSWORD				:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.sPassword, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_PLAIN					:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.nPortPlain, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_SECURE					:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.nPortSecure, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_COMPRESSEDSECURE		:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.nPortCompressedSecure, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_COMPRESSED				:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.nPortCompressed, aValue, aOldValue, aConvertedValue );
														}
														break;
		case PROPERTYHANDLE_SERVER					:   {
															if( m_aPropertySet.seqServerList.getLength() < 1 )
															{
																// If current server history empty, we must call our impl method with an empty value.
																// We have no valid list and a valid index in it ...
																bReturn = impl_tryToChangeProperty( OUString(), aValue, aOldValue, aConvertedValue );
															}
															else
															{
																// In this case we can use our current server list and our index.
																LOG_ASSERT( !(m_aPropertySet.nActiveServer<1 || m_aPropertySet.nActiveServer>m_aPropertySet.seqServerList.getLength()), "LoginDialog::convertFastPropertyValue()\nActiveServer out of range!\n" )
																bReturn = impl_tryToChangeProperty( m_aPropertySet.seqServerList[m_aPropertySet.nActiveServer-1], aValue, aOldValue, aConvertedValue );
															}
														}
														break;
		case PROPERTYHANDLE_SERVERHISTORY			:   {
															LOG_ASSERT( sal_False, "LoginDialog::convertFastPropertyValue()\nCan't change readonly property!\n" )
														}
														break;
		case PROPERTYHANDLE_USERNAME				:	{
															bReturn = impl_tryToChangeProperty( m_aPropertySet.sUserName, aValue, aOldValue, aConvertedValue );
														}
														break;
	}

	// Return state of operation.
	return bReturn ;
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
void SAL_CALL LoginDialog::setFastPropertyValue_NoBroadcast(			sal_Int32	nHandle	,
			   													const	Any&		aValue	) throw( Exception )
{
	// Ready for multithreading
	LOCK_MUTEX( aGuard, m_aMutex, "LoginDialog::setFastPropertyValue_NoBroadCast()" )

	// Search for right handle ... and try to set property value.
	switch ( nHandle )
	{
		case PROPERTYHANDLE_CONNECTIONTYPE			:	{
															aValue >>= m_aPropertySet.sConnectionType;
														}
														break;
		case PROPERTYHANDLE_PASSWORD				:	{
															aValue >>= m_aPropertySet.sPassword;
														}
														break;
		case PROPERTYHANDLE_PLAIN					:	{
															aValue >>= m_aPropertySet.nPortPlain;
														}
														break;
		case PROPERTYHANDLE_SECURE					:	{
															aValue >>= m_aPropertySet.nPortSecure;
														}
														break;
		case PROPERTYHANDLE_COMPRESSEDSECURE		:	{
															aValue >>= m_aPropertySet.nPortCompressedSecure;
														}
														break;
		case PROPERTYHANDLE_COMPRESSED				:	{
															aValue >>= m_aPropertySet.nPortCompressed;
														}
														break;
		case PROPERTYHANDLE_SERVER					:   {
															OUString sValue;
															aValue >>= sValue;
															impl_addServerToHistory( m_aPropertySet.seqServerList, m_aPropertySet.nActiveServer, sValue );
														}
														break;
		case PROPERTYHANDLE_SERVERHISTORY			:   {
															LOG_ASSERT( sal_False, "LoginDialog::setFastPropertyValue_NoBroadcast()\nCan't change readonly property!\n" )
														}
														break;
		case PROPERTYHANDLE_USERNAME				:	{
															aValue >>= m_aPropertySet.sUserName;
														}
														break;
	}
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
void SAL_CALL LoginDialog::getFastPropertyValue(	Any&		aValue	,
			  										sal_Int32	nHandle ) const
{
	// Ready for multithreading
	LOCK_GLOBALMUTEX( aGuard, "LoginDialog::getFastPropertyValue()" )

	// Search for right handle ... and try to set property value.
	switch ( nHandle )
	{
		case PROPERTYHANDLE_CONNECTIONTYPE			:	{
															aValue <<= m_aPropertySet.sConnectionType;
														}
														break;
		case PROPERTYHANDLE_PASSWORD				:	{
															aValue <<= m_aPropertySet.sPassword;
														}
														break;
		case PROPERTYHANDLE_PLAIN					:	{
															aValue <<= m_aPropertySet.nPortPlain;
														}
														break;
		case PROPERTYHANDLE_SECURE					:	{
															aValue <<= m_aPropertySet.nPortSecure;
														}
														break;
		case PROPERTYHANDLE_COMPRESSEDSECURE		:	{
															aValue <<= m_aPropertySet.nPortCompressedSecure;
														}
														break;
		case PROPERTYHANDLE_COMPRESSED				:	{
															aValue <<= m_aPropertySet.nPortCompressed;
														}
														break;
		case PROPERTYHANDLE_SERVER					:   {
															LOG_ASSERT( !(m_aPropertySet.nActiveServer<1 || m_aPropertySet.nActiveServer>m_aPropertySet.seqServerList.getLength()), "LoginDialog::getFastPropertyValue()\nActiveServer out of range!\n" )
															aValue <<= m_aPropertySet.seqServerList[m_aPropertySet.nActiveServer-1];
														}
														break;
		case PROPERTYHANDLE_SERVERHISTORY			:   {
															aValue <<= m_aPropertySet.seqServerList;
														}
														break;
		case PROPERTYHANDLE_USERNAME				:	{
															aValue <<= m_aPropertySet.sUserName;
														}
														break;
	}
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
IPropertyArrayHelper& SAL_CALL LoginDialog::getInfoHelper()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfoHelper is NULL - for the second call pInfoHelper is different from NULL!
	static OPropertyArrayHelper* pInfoHelper = NULL;

	if ( pInfoHelper == NULL )
	{
		// Ready for multithreading
		LOCK_GLOBALMUTEX( aGuard, "LoginDialog::getInfoHelper()" )
		// Control this pointer again, another instance can be faster then these!
		if ( pInfoHelper == NULL )
		{
			// Define static member to give structure of properties to baseclass "OPropertySetHelper".
			// "impl_getStaticPropertyDescriptor" is a non exported and static funtion, who will define a static propertytable.
			// "sal_True" say: Table is sorted by name.
			static OPropertyArrayHelper aInfoHelper( impl_getStaticPropertyDescriptor(), sal_True );
			pInfoHelper = &aInfoHelper;
		}
	}

	return (*pInfoHelper);
}

//*****************************************************************************************************************
//	OPropertySetHelper
//*****************************************************************************************************************
Reference< XPropertySetInfo > SAL_CALL LoginDialog::getPropertySetInfo()
{
	// Optimize this method !
	// We initialize a static variable only one time. And we don't must use a mutex at every call!
	// For the first call; pInfo is NULL - for the second call pInfo is different from NULL!
	static Reference< XPropertySetInfo >* pInfo = NULL ;

	if ( pInfo == NULL )
	{
		// Ready for multithreading
		LOCK_GLOBALMUTEX( aGuard, "LoginDialog::getPropertySetInfo()" )
		// Control this pointer again, another instance can be faster then these!
		if ( pInfo == NULL )
		{
			// Create structure of propertysetinfo for baseclass "OPropertySetHelper".
			// (Use method "getInfoHelper()".)
			static Reference< XPropertySetInfo > xInfo( createPropertySetInfo( getInfoHelper() ) );
			pInfo = &xInfo;
		}
	}

	return (*pInfo);
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
const Sequence< Property > LoginDialog::impl_getStaticPropertyDescriptor()
{
	// Create a new static property array to initialize sequence!
	// Table of all predefined properties of this class. Its used from OPropertySetHelper-class!
	// Don't forget to change the defines (see begin of this file), if you add, change or delete a property in this list!!!
	// It's necessary for methods of OPropertySetHelper.
	// ATTENTION:
	//		YOU MUST SORT FOLLOW TABLE BY NAME !!!

	static const Property pPropertys[] =
	{
		Property( PROPERTYNAME_CONNECTIONTYPE	, PROPERTYHANDLE_CONNECTIONTYPE		, ::getCppuType((const OUString*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_PASSWORD			, PROPERTYHANDLE_PASSWORD			, ::getCppuType((const OUString*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_SERVER			, PROPERTYHANDLE_SERVER				, ::getCppuType((const OUString*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_SERVERHISTORY	, PROPERTYHANDLE_SERVERHISTORY		, ::getCppuType((const Sequence< OUString >*)NULL)	, PropertyAttribute::TRANSIENT | PropertyAttribute::READONLY	),
		Property( PROPERTYNAME_USERNAME			, PROPERTYHANDLE_USERNAME			, ::getCppuType((const OUString*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_COMPRESSED		, PROPERTYHANDLE_COMPRESSED			, ::getCppuType((const sal_Int32*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_COMPRESSEDSECURE	, PROPERTYHANDLE_COMPRESSEDSECURE	, ::getCppuType((const sal_Int32*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_PLAIN			, PROPERTYHANDLE_PLAIN				, ::getCppuType((const sal_Int32*)NULL)				, PropertyAttribute::TRANSIENT									),
		Property( PROPERTYNAME_SECURE			, PROPERTYHANDLE_SECURE				, ::getCppuType((const sal_Int32*)NULL)				, PropertyAttribute::TRANSIENT									),
	};
	// Use it to initialize sequence!
	static const Sequence< Property > seqPropertyDescriptor( pPropertys, PROPERTYCOUNT );
	// Return static "PropertyDescriptor"
	return seqPropertyDescriptor ;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
sal_Bool LoginDialog::impl_tryToChangeProperty(	const	OUString&	sProperty		,
												const	Any&		aValue			,
														Any&		aOldValue		,
														Any&		aConvertedValue	) throw( IllegalArgumentException )
{
	// Set default return value.
	sal_Bool bReturn = sal_False;

	// Clear information of return parameter!
	aOldValue.clear();
	aConvertedValue.clear();

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	OUString sNewValue;
	convertPropertyValue( sNewValue, aValue );

	// If value change ...
	if ( sNewValue != sProperty )
	{
		// ... set information of change.
		aOldValue.setValue		( &sProperty, ::getCppuType((const OUString*)NULL) );
		aConvertedValue.setValue( &sNewValue, ::getCppuType((const OUString*)NULL) );
		// Return OK - "value will be change ..."
		bReturn = sal_True;
	}

	return bReturn;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
sal_Bool LoginDialog::impl_tryToChangeProperty(	const	Sequence< OUString >&	seqProperty		,
												const	Any&					aValue			,
														Any&					aOldValue		,
														Any&					aConvertedValue	) throw( IllegalArgumentException )
{
	// Set default return value.
	sal_Bool bReturn = sal_False;

	// Clear information of return parameter!
	aOldValue.clear();
	aConvertedValue.clear();

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	Sequence< OUString > seqNewValue;
	convertPropertyValue( seqNewValue, aValue );

	// If value change ...
	if ( seqNewValue != seqProperty )
	{
		// ... set information of change.
		aOldValue.setValue		( &seqProperty, ::getCppuType((const Sequence< OUString >*)NULL) );
		aConvertedValue.setValue( &seqNewValue, ::getCppuType((const Sequence< OUString >*)NULL) );
		// Return OK - "value will be change ..."
		bReturn = sal_True;
	}

	return bReturn;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
sal_Bool LoginDialog::impl_tryToChangeProperty(	const	sal_Int32&	nProperty		,
												const	Any&		aValue			,
														Any&		aOldValue		,
														Any&		aConvertedValue	) throw( IllegalArgumentException )
{
	// Set default return value.
	sal_Bool bReturn = sal_False;

	// Clear information of return parameter!
	aOldValue.clear();
	aConvertedValue.clear();

	// Get new value from any.
	// IllegalArgumentException() can be thrown!
	sal_Int32 nNewValue;
	convertPropertyValue( nNewValue, aValue );

	// If value change ...
	if ( nNewValue != nProperty )
	{
		// ... set information of change.
		aOldValue.setValue		( &nProperty, ::getCppuType((const sal_Int32*)NULL) );
		aConvertedValue.setValue( &nNewValue, ::getCppuType((const sal_Int32*)NULL) );
		// Return OK - "value will be change ..."
		bReturn = sal_True;
	}

	return bReturn;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
void LoginDialog::impl_openProfile()
{
	// First search for our configuration file.
 	OUString					sINIUNC			;
 	OUString					sApplicationUNC	;
	OStartupInfo				aInfo			;

	if ( aInfo.getExecutableFile( sApplicationUNC ) == osl_Process_E_None )
	{
		sal_Int32 nPosition = sApplicationUNC.lastIndexOf( UNCPATHSEPERATOR );
		if ( nPosition > 1 )
		{
            sINIUNC = sApplicationUNC.copy( 0, nPosition );
		}
		sINIUNC += OUString(UNCPATHSEPERATOR);
		sINIUNC += ININAME;
		FileBase::getFileURLFromNormalizedPath( sINIUNC, m_sINIURL );
		// Use INIManager service to read and write profile.
		m_xINIManager = Reference< XSimpleRegistry >( m_xFactory->createInstance( SERVICENAME_INIMANAGER ), UNO_QUERY );
		LOG_ASSERT( !(m_xINIManager.is()==sal_False), "LoginDialog::impl_openProfile()Servicename of INIManager unknown. Cant work so!\n" )
		if( m_xINIManager.is() == sal_True )
		{
			// Open profile for reading and writing.
			// I think we can create it, if it not exist.
			// open( filename, openItReadonly, createIfNotExist )
			m_xINIManager->open( m_sINIURL, sal_False, sal_True );
			LOG_ASSERT( !(m_xINIManager->isValid()==sal_False), "LoginDialog::impl_openProfile()INIManager not valid.\n" )
			if( m_xINIManager->isValid() == sal_True )
			{
				// Get full access to content of profile.
				m_xRootKey = m_xINIManager->getRootKey();
				LOG_ASSERT( !(m_xRootKey.is()==sal_False), "LoginDialog::impl_openProfile()Can't get rootkey. Have no access to profile!\n" )
				if( m_xRootKey.is() == sal_True )
				{
					// Set default values on properties, if follow reading from profile failed!
					m_aPropertySet.sUserName		=	OUString();
					m_aPropertySet.sPassword		=   OUString();
					m_aPropertySet.seqServerList.realloc( 0 );
					m_aPropertySet.nActiveServer	=	1;
					// Fill property set with values from profile.
					// Get user name.
					Reference< XRegistryKey > xKey = m_xRootKey->openKey( KEY_USERNAME );
					if( xKey.is() == sal_True )
					{
						m_aPropertySet.sUserName = xKey->getStringValue();
						xKey->closeKey();
					}
					// Get history for server.
					xKey = m_xRootKey->openKey( SECTION_SERVERHISTORY );
					if( xKey.is() == sal_True )
					{
						Sequence< Reference< XRegistryKey > > seqKeyList = xKey->openKeys();
						sal_Int32 nCount = seqKeyList.getLength();
						for( sal_Int32 nServer=0; nServer<nCount; ++nServer )
						{
							xKey = seqKeyList[nServer];
							LOG_ASSERT( !(xKey.is()==sal_False), "LoginDialog::impl_openProfile()\nINIManager return invalid keylist of section \"ServerHistory\".\n" )
							impl_addServerToHistory( m_aPropertySet.seqServerList, m_aPropertySet.nActiveServer, xKey->getStringValue() );
							xKey->closeKey();
						}
					}
					// Get number of active server ( Is the last selected one in combobox "Server". )
					xKey = m_xRootKey->openKey( KEY_ACTIVESERVER );
					if( xKey.is() == sal_True )
					{
						OUString	sValue				= xKey->getStringValue();
						sal_Int32	nActiveServer		= sValue.toInt32();
						if	(
								( nActiveServer	>	0											)	&&
								( nActiveServer	<=	m_aPropertySet.seqServerList.getLength()	)
							)
						{
							m_aPropertySet.nActiveServer = nActiveServer;
						}
						xKey->closeKey();
					}
					// Get connection informations.
					// Get type of it.
					xKey = m_xRootKey->openKey( KEY_CONNECTIONTYPE );
					if( xKey.is() == sal_True )
					{
						m_aPropertySet.sConnectionType = xKey->getStringValue();
						xKey->closeKey();
					}
					// Get values for different supported ports for connection.
					xKey = m_xRootKey->openKey( KEY_PLAIN );
					if( xKey.is() == sal_True )
					{
						OUString	sValue	= xKey->getStringValue();
						sal_Int32	nPort	= sValue.toInt32();
						m_aPropertySet.nPortPlain = nPort;
						xKey->closeKey();
					}
					xKey = m_xRootKey->openKey( KEY_SECURE );
					if( xKey.is() == sal_True )
					{
						OUString	sValue	= xKey->getStringValue();
						sal_Int32	nPort	= sValue.toInt32();
						m_aPropertySet.nPortSecure = nPort;
						xKey->closeKey();
					}
					xKey = m_xRootKey->openKey( KEY_COMPRESSEDSECURE );
					if( xKey.is() == sal_True )
					{
						OUString	sValue	= xKey->getStringValue();
						sal_Int32	nPort	= sValue.toInt32();
						m_aPropertySet.nPortCompressedSecure = nPort;
						xKey->closeKey();
					}
					xKey = m_xRootKey->openKey( KEY_COMPRESSED );
					if( xKey.is() == sal_True )
					{
						OUString	sValue	= xKey->getStringValue();
						sal_Int32	nPort	= sValue.toInt32();
						m_aPropertySet.nPortCompressed = nPort;
						xKey->closeKey();
					}
				}
			}
		}
	}
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
void LoginDialog::impl_closeProfile()
{
	if( m_xRootKey.is() == sal_True )
	{
		// First remove old entries! We write ALL properties with new values.
		m_xRootKey->deleteKey( SECTION_GLOBAL			);
		m_xRootKey->deleteKey( SECTION_DEFAULTPORTS		);
		m_xRootKey->deleteKey( SECTION_SERVERHISTORY	);
		// First safe current values of our property set.
		// Set user name.
		Reference< XRegistryKey > xKey = m_xRootKey->createKey( KEY_USERNAME );
		if( xKey.is() == sal_True )
		{
			xKey->setStringValue( m_aPropertySet.sUserName );
			xKey->closeKey();
		}
		// Set number of active server ( Is the last selected one in combobox "Server". )
		xKey = m_xRootKey->createKey( KEY_ACTIVESERVER );
		if( xKey.is() == sal_True )
		{
			OUString sValue = OUString::valueOf( (sal_Int32)m_aPropertySet.nActiveServer );
			xKey->setStringValue( sValue );
			xKey->closeKey();
		}
		// Set history for server.
		sal_Int32 nCount = m_aPropertySet.seqServerList.getLength();
		for( sal_Int32 nServer=0; nServer<nCount; ++nServer )
		{
			OUString sKeyName;
			sKeyName	 = KEY_SERVER_X;
			sKeyName	+= OUString::valueOf( (sal_Int32)(nServer+1) );
			xKey		 = m_xRootKey->createKey( sKeyName );
			if( xKey.is() == sal_True )
			{
				xKey->setStringValue( m_aPropertySet.seqServerList[nServer] );
				xKey->closeKey();
			}
		}
		// Set parameter for connection.
		// Set type of connection.
		xKey = m_xRootKey->createKey( KEY_CONNECTIONTYPE );
		if( xKey.is() == sal_True )
		{
			xKey->setStringValue( m_aPropertySet.sConnectionType );
			xKey->closeKey();
		}
		// Set ports of different connection points.
		xKey = m_xRootKey->createKey( KEY_PLAIN );
		if( xKey.is() == sal_True )
		{
			OUString sValue = OUString::valueOf( (sal_Int32)m_aPropertySet.nPortPlain );
			xKey->setStringValue( sValue );
			xKey->closeKey();
		}
		xKey = m_xRootKey->createKey( KEY_SECURE );
		if( xKey.is() == sal_True )
		{
			OUString sValue = OUString::valueOf( (sal_Int32)m_aPropertySet.nPortSecure );
			xKey->setStringValue( sValue );
			xKey->closeKey();
		}
		xKey = m_xRootKey->createKey( KEY_COMPRESSEDSECURE );
		if( xKey.is() == sal_True )
		{
			OUString sValue = OUString::valueOf( (sal_Int32)m_aPropertySet.nPortCompressedSecure );
			xKey->setStringValue( sValue );
			xKey->closeKey();
		}
		xKey = m_xRootKey->createKey( KEY_COMPRESSED );
		if( xKey.is() == sal_True )
		{
			OUString sValue = OUString::valueOf( (sal_Int32)m_aPropertySet.nPortCompressed );
			xKey->setStringValue( sValue );
			xKey->closeKey();
		}

		// Close rootkey! Do it before you close ini file.
		m_xRootKey->closeKey();
		m_xRootKey = Reference< XRegistryKey >();
	}
	// Close ini file.
	if( m_xINIManager.is() == sal_True )
	{
		m_xINIManager->close();
		m_xINIManager = Reference< XSimpleRegistry >();
	}
	m_sINIURL								=	OUString()	;
	m_aPropertySet.sUserName				=	OUString()	;
	m_aPropertySet.sPassword				=   OUString()	;
	m_aPropertySet.nActiveServer			=	1			;
	m_aPropertySet.seqServerList.realloc( 0 )				;
	m_aPropertySet.sConnectionType			=	OUString()	;
	m_aPropertySet.nPortPlain				=	0			;
	m_aPropertySet.nPortSecure				=	0			;
	m_aPropertySet.nPortCompressedSecure	=	0			;
	m_aPropertySet.nPortCompressed			=	0			;
}

//*****************************************************************************************************************
//	private method
//*****************************************************************************************************************
void LoginDialog::impl_addServerToHistory(			SEQUENCE< OUSTRING >&	seqHistory		,
													sal_Int32&				nActiveServer	,
											const	OUSTRING&				sServer			)
{
	if( sServer.getLength() > 0 )
	{
		// If history full we must delete old entries.
		// These are the first entries of list. We append ne server at the end of list.
		sal_Int32 nCount = seqHistory.getLength();
		if( nCount >= MAX_SERVERHISTORY )
		{
			sal_Int32 nDestination	= 0								;
			sal_Int32 nSource		= nCount-(MAX_SERVERHISTORY-1)	; // -1 ... we need place for new item!
			while( nSource < MAX_SERVERHISTORY )
			{
				seqHistory[nDestination] = seqHistory[nSource];
				++nDestination	;
				++nSource		;
			}
			nCount = (MAX_SERVERHISTORY-1); // -1 ... we need place for new item!
		}
		// Check for already existing entries in list. If value not exist add it to history.
		sal_Bool	bAlreadyExist	= sal_False	;
		sal_Int32	nPosition		= 0			;
		while	(
					( nPosition		<	nCount		)	&&
					( bAlreadyExist	==	sal_False	)
				)
		{
			if( seqHistory[nPosition] == sServer )
			{
				bAlreadyExist = sal_True;
			}
			++nPosition;
		}
		if( bAlreadyExist == sal_False )
		{
			// If new server not already exist in list we must add him!
			seqHistory.realloc( nCount+1 );
			seqHistory[nCount] = sServer;
			nActiveServer = nCount+1;
		}
		else
		{
			// Else; Entrie already exist ... but we have copyied all other entries from position n+1 to n.
			// Last element is double now! We must delete it. => realloc sequence
			seqHistory.realloc( nCount );
		}
	}
}

//_________________________________________________________________________________________________________________
//	debug methods
//_________________________________________________________________________________________________________________

/*-----------------------------------------------------------------------------------------------------------------
	The follow methods checks the parameter for other functions. If a parameter or his value is non valid,
	we return "sal_False". (else sal_True) This mechanism is used to throw an ASSERT!

	ATTENTION

		If you miss a test for one of this parameters, contact Andreas Schluens [as] or add it himself !(?)
		But ... look for right testing! See using of this methods!
-----------------------------------------------------------------------------------------------------------------*/

#ifdef ENABLE_ASSERTIONS

//*****************************************************************************************************************
sal_Bool LoginDialog::impldbg_checkParameter_LoginDialog( const Reference< XMultiServiceFactory >& xFactory )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &xFactory		==	NULL		)	||
			( xFactory.is()	==	sal_False	)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

//*****************************************************************************************************************
sal_Bool LoginDialog::impldbg_checkParameter_setTitle( const OUString& sTitle )
{
	// Set default return value.
	sal_Bool bOK = sal_True;
	// Check parameter.
	if	(
			( &sTitle				==	NULL	)	||
			( sTitle.getLength()	<	1		)
		)
	{
		bOK = sal_False ;
	}
	// Return result of check.
	return bOK ;
}

#endif	//	#ifdef ENABLE_ASSERTIONS

}		//	namespace framework
