/*************************************************************************
 *
 *  $RCSfile: logindialog.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:29:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_LOGINDIALOG_LOGINDIALOG_HXX_
#define __FRAMEWORK_LOGINDIALOG_LOGINDIALOG_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_HELPER_OMUTEXMEMBER_HXX_
#include <helper/omutexmember.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_GENERIC_HXX_
#include <macros/generic.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_DEBUG_HXX_
#include <macros/debug.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XINTERFACE_HXX_
#include <macros/xinterface.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XTYPEPROVIDER_HXX_
#include <macros/xtypeprovider.hxx>
#endif

#ifndef __FRAMEWORK_MACROS_XSERVICEINFO_HXX_
#include <macros/xserviceinfo.hxx>
#endif

#include <logindialog.hrc>

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_AWT_XDIALOG_HPP_
#include <com/sun/star/awt/XDialog.hpp>
#endif

#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif

#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif

#ifndef _COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP_
#include <com/sun/star/lang/IllegalArgumentException.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTY_HPP_
#include <com/sun/star/beans/Property.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

#ifndef _SV_COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

#ifndef _SV_MOREBTN_HXX
#include <vcl/morebtn.hxx>
#endif

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

namespace framework{

#define	ANY									::com::sun::star::uno::Any
#define	EXCEPTION							::com::sun::star::uno::Exception
#define	ILLEGALARGUMENTEXCEPTION			::com::sun::star::lang::IllegalArgumentException
#define	IPROPERTYARRAYHELPER				::cppu::IPropertyArrayHelper
#define	OBROADCASTHELPER					::cppu::OBroadcastHelper
#define	OPROPERTYSETHELPER					::cppu::OPropertySetHelper
#define	OUSTRING							::rtl::OUString
#define	OWEAKOBJECT							::cppu::OWeakObject
#define	PROPERTY							::com::sun::star::beans::Property
#define	REFERENCE							::com::sun::star::uno::Reference
#define	RUNTIMEEXCEPTION					::com::sun::star::uno::RuntimeException
#define	SEQUENCE							::com::sun::star::uno::Sequence
#define	XDIALOG								::com::sun::star::awt::XDialog
#define	XMULTISERVICEFACTORY				::com::sun::star::lang::XMultiServiceFactory
#define	XPROPERTYSETINFO					::com::sun::star::beans::XPropertySetInfo
#define	XREGISTRYKEY						::com::sun::star::registry::XRegistryKey
#define	XSERVICEINFO						::com::sun::star::lang::XServiceInfo
#define	XSIMPLEREGISTRY						::com::sun::star::registry::XSimpleRegistry
#define	XTYPEPROVIDER						::com::sun::star::lang::XTypeProvider

//_________________________________________________________________________________________________________________
//	exported const
//_________________________________________________________________________________________________________________

#ifdef WNT
	#define	ININAME								DECLARE_ASCII("login.ini")
#elif defined UNIX
	#define	ININAME								DECLARE_ASCII("loginrc")
#else
	#error "name of login profile unknown!"
#endif

#define	UNCPATHSEPERATOR						sal_Unicode(0x002F)
#define	MAX_SERVERHISTORY						10

//	Use follow keys in follow order.
//	[Global]
//	UserName=as
//	ActiveServer=2
//	ConnectionType=compressed_secure
//
//	[DefaultPorts]
//	plain=8081
//	secure=8082
//	compressed_secure=8083
//	compressed=8084
//
//	[ServerHistory]
//	Server_1=localhost
//	Server_2=munch:7202
//	Server_3=www.xxx.com:8000

#define	SECTION_GLOBAL							DECLARE_ASCII("Global"							)
#define	SECTION_DEFAULTPORTS					DECLARE_ASCII("DefaultPorts"					)
#define	SECTION_SERVERHISTORY					DECLARE_ASCII("ServerHistory"					)
#define	KEY_USERNAME							DECLARE_ASCII("Global/UserName"					)
#define	KEY_ACTIVESERVER						DECLARE_ASCII("Global/ActiveServer"				)
#define	KEY_CONNECTIONTYPE						DECLARE_ASCII("Global/ConnectionType"			)
#define	KEY_PLAIN								DECLARE_ASCII("DefaultPorts/plain"				)
#define	KEY_SECURE								DECLARE_ASCII("DefaultPorts/secure"				)
#define	KEY_COMPRESSEDSECURE					DECLARE_ASCII("DefaultPorts/compressed_secure"	)
#define	KEY_COMPRESSED							DECLARE_ASCII("DefaultPorts/compressed"			)
#define	KEY_SERVER_X							DECLARE_ASCII("ServerHistory/Server_"			)

#define	PROPERTYNAME_CONNECTIONTYPE				DECLARE_ASCII("ConnectionType"					)
#define	PROPERTYNAME_PASSWORD					DECLARE_ASCII("Password"						)
#define	PROPERTYNAME_SERVER						DECLARE_ASCII("Server"							)
#define	PROPERTYNAME_SERVERHISTORY				DECLARE_ASCII("ServerHistory"					)
#define	PROPERTYNAME_USERNAME					DECLARE_ASCII("UserName"						)
#define	PROPERTYNAME_COMPRESSED					DECLARE_ASCII("compressed"						)
#define	PROPERTYNAME_COMPRESSEDSECURE			DECLARE_ASCII("compressed_secure"				)
#define	PROPERTYNAME_PLAIN						DECLARE_ASCII("plain"							)
#define	PROPERTYNAME_SECURE						DECLARE_ASCII("secure"							)

#define	PROPERTYHANDLE_CONNECTIONTYPE			1
#define	PROPERTYHANDLE_PASSWORD					2
#define	PROPERTYHANDLE_SERVER					3
#define	PROPERTYHANDLE_SERVERHISTORY			4
#define	PROPERTYHANDLE_USERNAME					5
#define	PROPERTYHANDLE_COMPRESSED				6
#define	PROPERTYHANDLE_COMPRESSEDSECURE			7
#define	PROPERTYHANDLE_PLAIN					8
#define	PROPERTYHANDLE_SECURE					9

#define	PROPERTYCOUNT							9

//_________________________________________________________________________________________________________________
//	exported definitions
//_________________________________________________________________________________________________________________

struct tIMPL_DialogData
{
	OUSTRING				sUserName				;
	OUSTRING				sPassword				;
	SEQUENCE< OUSTRING >	seqServerList			;
	sal_Int32				nActiveServer			;
	OUSTRING				sConnectionType			;
	sal_Int32				nPortPlain				;
	sal_Int32				nPortSecure				;
	sal_Int32				nPortCompressedSecure	;
	sal_Int32				nPortCompressed			;

	// default ctor to initialize empty structure.
	tIMPL_DialogData()
		:	sUserName				( OUSTRING()			)
		,	sPassword				( OUSTRING()			)
		,	seqServerList			( SEQUENCE< OUSTRING >())
		,	nActiveServer			( 1						)
		,	sConnectionType			( OUSTRING()			)
		,	nPortPlain				( 0						)
		,	nPortSecure				( 0						)
		,	nPortCompressedSecure	( 0						)
		,	nPortCompressed			( 0						)
	{
	}

	// copy ctor to initialize structure with values from another one.
	tIMPL_DialogData( const tIMPL_DialogData& aCopyDataSet )
		:	sUserName				( aCopyDataSet.sUserName				)
		,	sPassword				( aCopyDataSet.sPassword				)
		,	seqServerList			( aCopyDataSet.seqServerList			)
		,	nActiveServer			( aCopyDataSet.nActiveServer			)
		,	sConnectionType			( aCopyDataSet.sConnectionType			)
		,	nPortPlain				( aCopyDataSet.nPortPlain				)
		,	nPortSecure				( aCopyDataSet.nPortSecure				)
		,	nPortCompressedSecure	( aCopyDataSet.nPortCompressedSecure	)
		,	nPortCompressed			( aCopyDataSet.nPortCompressed			)
	{
	}

	// assignment operator to cop values from another struct to this one.
	tIMPL_DialogData& operator=( const tIMPL_DialogData& aCopyDataSet )
	{
		sUserName				= aCopyDataSet.sUserName				;
		sPassword				= aCopyDataSet.sPassword				;
		seqServerList			= aCopyDataSet.seqServerList			;
		nActiveServer			= aCopyDataSet.nActiveServer			;
		sConnectionType			= aCopyDataSet.sConnectionType			;
		nPortPlain				= aCopyDataSet.nPortPlain				;
		nPortSecure				= aCopyDataSet.nPortSecure				;
		nPortCompressedSecure	= aCopyDataSet.nPortCompressedSecure	;
		nPortCompressed			= aCopyDataSet.nPortCompressed			;
		return *this;
	}
};

/*-************************************************************************************************************//**
	@short		implements an "private inline" dialog class used by follow class LoginDialog to show the dialog
	@descr		This is a VCL- modal dialog and not threadsafe! We use it as private definition in the context of login dialog only!

	@implements	-

	@base		ModalDialog
*//*-*************************************************************************************************************/

class cIMPL_Dialog	:	public ModalDialog
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		/*-****************************************************************************************************//**
			@short		default ctor
			@descr		This ctor initialize the dialog, load ressources but not set values on edits or check boxes!
						These is implemented by setValues() on the same class.

			@seealso	method setValues()

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		cIMPL_Dialog();

		/*-****************************************************************************************************//**
			@short		default dtor
			@descr		This dtor deinitialize the dialog and free all used ressources.
						But you can't get the values of the dialog. Use getValues() to do this.

			@seealso	method getValues()

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		~cIMPL_Dialog();

		/*-****************************************************************************************************//**
			@short		set new values on dialog to show
			@descr		Use this to initialize the dialg with new values for showing before execute.

			@seealso	method getValues()

			@param		"aDataSet"; struct of variables to set it on dialog controls
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void setValues( const tIMPL_DialogData& aDataSet );

		/*-****************************************************************************************************//**
			@short		get current values from dialog controls
			@descr		Use this if you will get all values of dialog after execute.

			@seealso	method setValues()

			@param		"aDataSet"; struct of variables filled by dialog
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		tIMPL_DialogData getValues();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		get a ressource for given id from right ressource file
			@descr		This dialog need his own ressource. We can't use the global ressource manager!
						We must use our own.

			@seealso	method setValues()

			@param		"aDataSet"; struct of variables filled by dialog
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		static ResId impl_getResId( sal_uInt32 nId );

	//-------------------------------------------------------------------------------------------------------------
	//	private member
	//-------------------------------------------------------------------------------------------------------------

	private:

		FixedImage			m_imageHeader			;
		FixedText			m_textLoginText			;
		FixedText       	m_textUserName			;
		FixedText       	m_textPassword			;
		FixedText       	m_textServer			;
		Edit            	m_editUserName			;
		Edit            	m_editPassword			;
		ComboBox        	m_comboServer			;
		OKButton        	m_buttonOK				;
		CancelButton    	m_buttonCancel			;
		tIMPL_DialogData	m_aDataSet				;
};

/*-************************************************************************************************************//**
	@short

	@descr		-

	@implements	XInterface
				XTypeProvider
				XServiceInfo
				XDialog

	@base		OMutexMember
				OWeakObject
*//*-*************************************************************************************************************/

//class LoginDialog	:	DERIVE_FROM_XSPECIALDEBUGINTERFACE		// => These macro will expand to nothing, if no testmode is set in debug.h!
class LoginDialog	:	public XTYPEPROVIDER				,
						public XSERVICEINFO					,
						public XDIALOG						,
						public OMutexMember					,	// Order of baseclasses is neccessary for right initialization!
						public OBROADCASTHELPER				,
						public OPROPERTYSETHELPER			,
						public OWEAKOBJECT
{
	//-------------------------------------------------------------------------------------------------------------
	//	public methods
	//-------------------------------------------------------------------------------------------------------------

	public:

		//---------------------------------------------------------------------------------------------------------
		//	constructor / destructor
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

	 	LoginDialog( const REFERENCE< XMULTISERVICEFACTORY >& sFactory );

		/*-****************************************************************************************************//**
			@short		-
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual	~LoginDialog();

		//---------------------------------------------------------------------------------------------------------
		//	XInterface, XTypeProvider, XServiceInfo
		//---------------------------------------------------------------------------------------------------------

		DECLARE_XINTERFACE
		DECLARE_XTYPEPROVIDER
		DECLARE_XSERVICEINFO
//		DECLARE_XSPECIALDEBUGINTERFACE	// => These macro will expand to nothing, if no testmode is set in debug.h!

		//---------------------------------------------------------------------------------------------------------
		//	XDialog
		//---------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		set new title of dialog
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL setTitle( const OUSTRING& sTitle ) throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		return the current title of this dialog
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual OUSTRING SAL_CALL getTitle() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		show the dialog and return user reaction
			@descr		If user close dialog with OK we return -1 else
						user has cancelled this dialog and we return 0.
						You can use this return value directly as boolean.

			@seealso	-

			@param		-
			@return		-1; if cancelled
			@return		0; if closed with OK

			@onerror	We return -1(FALSE).
		*//*-*****************************************************************************************************/

    	virtual sal_Int16 SAL_CALL execute() throw( RUNTIMEEXCEPTION );

		/*-****************************************************************************************************//**
			@short		not implemented yet!
			@descr		-

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

    	virtual void SAL_CALL endExecute() throw( RUNTIMEEXCEPTION );

	//-------------------------------------------------------------------------------------------------------------
	//	protected methods
	//-------------------------------------------------------------------------------------------------------------

	protected:

		//---------------------------------------------------------------------------
		//	OPropertySetHelper
		//---------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		try to convert a property value
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!
						You must try to convert the value of given propertyhandle and
						return results of this operation. This will be use to ask vetoable
						listener. If no listener have a veto, we will change value realy!
						( in method setFastPropertyValue_NoBroadcast(...) )

			@seealso	class OPropertySetHelper
			@seealso	method setFastPropertyValue_NoBroadcast()
			@seealso	method impl_tryToChangeProperty()

			@param		"aConvertedValue"	new converted value of property
			@param		"aOldValue"			old value of property
			@param		"nHandle"			handle of property
			@param		"aValue"			new value of property
			@return		sal_True if value will be changed, sal_FALSE otherway

			@onerror	IllegalArgumentException, if you call this with an invalid argument
		*//*-*****************************************************************************************************/

		virtual sal_Bool SAL_CALL convertFastPropertyValue(			ANY&		aConvertedValue	,
								  									ANY&		aOldValue		,
																	sal_Int32	nHandle			,
															const	ANY&		aValue			) throw( ILLEGALARGUMENTEXCEPTION );

		/*-****************************************************************************************************//**
			@short		set value of a transient property
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!
						Handle and value are valid everyway! You must set the new value only.
						After this, baseclass send messages to all listener automaticly.

			@seealso	OPropertySetHelper

			@param      "nHandle"	handle of property to change
			@param      "aValue"	new value of property
			@return		-

			@onerror	An exception is thrown.
		*//*-*****************************************************************************************************/

		virtual void SAL_CALL setFastPropertyValue_NoBroadcast(			sal_Int32	nHandle	,
							  									const	ANY&		aValue	) throw( EXCEPTION );

		/*-****************************************************************************************************//**
			@short		get value of a transient property
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!

			@seealso	OPropertySetHelper

			@param      "nHandle"	handle of property to change
			@param      "aValue"	current value of property
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual void SAL_CALL getFastPropertyValue(	ANY&		aValue	,
							  						sal_Int32	nHandle	) const;

		/*-****************************************************************************************************//**
			@short      return structure and information about transient properties
			@descr		This method is calling from helperclass "OPropertySetHelper".
						Don't use this directly!

			@seealso	OPropertySetHelper

			@param		-
			@return		structure with property-informations

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual IPROPERTYARRAYHELPER& SAL_CALL getInfoHelper();

		/*-****************************************************************************************************//**
			@short		return propertysetinfo
			@descr		You can call this method to get information about transient properties
						of this object.

			@seealso	OPropertySetHelper
			@seealso	XPropertySet
			@seealso	XMultiPropertySet

			@param		-
			@return		reference to object with information [XPropertySetInfo]

			@onerror	-
		*//*-*****************************************************************************************************/

		virtual REFERENCE< XPROPERTYSETINFO > SAL_CALL getPropertySetInfo();

	//-------------------------------------------------------------------------------------------------------------
	//	private methods
	//-------------------------------------------------------------------------------------------------------------

	private:

		/*-****************************************************************************************************//**
			@short		return table of all supported properties
			@descr		We need this table to initialize our helper baseclass OPropertySetHelper

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		const SEQUENCE< PROPERTY > impl_getStaticPropertyDescriptor();

		/*-****************************************************************************************************//**
			@short		helper method to check if a property will change his value
			@descr		Is neccessary for vetoable listener mechanism of OPropertySethelper.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		sal_Bool impl_tryToChangeProperty(	const	OUSTRING&				sProperty		,
											const	ANY&					aValue			,
													ANY&					aOldValue		,
													ANY&					aConvertedValue	) throw( ILLEGALARGUMENTEXCEPTION );

		sal_Bool impl_tryToChangeProperty(	const	SEQUENCE< OUSTRING >&	seqProperty		,
											const	ANY&					aValue			,
													ANY&					aOldValue		,
													ANY&					aConvertedValue	) throw( ILLEGALARGUMENTEXCEPTION );

		sal_Bool impl_tryToChangeProperty(	const	sal_Int32&				nProperty		,
											const	ANY&					aValue			,
													ANY&					aOldValue		,
													ANY&					aConvertedValue	) throw( ILLEGALARGUMENTEXCEPTION );

		/*-****************************************************************************************************//**
			@short		search and open profile
			@descr		This method search and open the ini file. It initialize some member too.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_openProfile();

		/*-****************************************************************************************************//**
			@short		close profile and free some member
			@descr		This method close current opened ini file and deinitialize some member too.

			@seealso	-

			@param		-
			@return		-

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_closeProfile();

		/*-****************************************************************************************************//**
			@short		check current server history
			@descr		Our current server history implementation can handle 10 elements as maximum.
						If more then 10 elements exist; old ones will be deleted.

			@seealso	-

			@param		"seqHistory"; current history
			@return		Sequence< OUString >; checked and repaired history

			@onerror	-
		*//*-*****************************************************************************************************/

		void impl_addServerToHistory(			SEQUENCE< OUSTRING >&	seqHistory		,
												sal_Int32&				nActiveServer	,
										const	OUSTRING&				sServer			);

	//-------------------------------------------------------------------------------------------------------------
	//	debug methods
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

		/*-****************************************************************************************************//**
			@short		debug-method to check incoming parameter of some other mehods of this class
			@descr		The following methods are used to check parameters for other methods
						of this class. The return value is used directly for an ASSERT(...).

			@seealso	ASSERTs in implementation!

			@param		references to checking variables
			@return		sal_False on invalid parameter<BR>
						sal_True  otherway

			@onerror	-
		*//*-*****************************************************************************************************/

	#ifdef ENABLE_ASSERTIONS

	private:

		sal_Bool impldbg_checkParameter_LoginDialog	(	const	REFERENCE< XMULTISERVICEFACTORY >&	xFactory	);
		sal_Bool impldbg_checkParameter_setTitle	(	const	OUSTRING&							sTitle		);

	#endif	// #ifdef ENABLE_ASSERTIONS

	//-------------------------------------------------------------------------------------------------------------
	//	variables
	//	(should be private everyway!)
	//-------------------------------------------------------------------------------------------------------------

	private:

		REFERENCE< XMULTISERVICEFACTORY >		m_xFactory			;	/// reference to factory, which has created this instance
		OUSTRING								m_sINIURL			;	/// full qualified path to profile as file URL
		REFERENCE< XSIMPLEREGISTRY >			m_xINIManager		;	/// manager for full access to ini file
		REFERENCE< XREGISTRYKEY >				m_xRootKey			;	/// cached rootkey for faster access to profile content
		sal_Bool								m_bInExecuteMode	;	/// protection against setting of properties during showing of dialog
		cIMPL_Dialog*							m_pDialog			;	/// VCL dialog
		tIMPL_DialogData						m_aPropertySet		;

};		//	class LoginDialog

}		//	namespace framework

#endif	//	#ifndef __FRAMEWORK_LOGINDIALOG_LOGINDIALOG_HXX_
