/*************************************************************************
 *
 *  $RCSfile: chlist.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>


#ifndef WIN
#include <svunzip.h>
#endif


#ifndef _VCL_APPTYPES_HXX //autogen
#include <vcl/apptypes.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVTDEMO_HXX //autogen
#include <svtools/svtdemo.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _DOWNLOAD_HXX //autogen
#include <tools/download.hxx>
#endif
#ifndef _AGAPI_HXX //autogen
#include <tools/agapi.hxx>
#endif
#include <svtools/agprop.hxx>
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#ifndef _TOOLS_RESID_HXX //autogen
#include <tools/resid.hxx>
#endif
#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#include "chlist.hxx"
#include "getchobj.hxx"
#include "channel.hxx"
#include "chagent.hxx"
#include "chtuner.hxx"

#include "chanapi.hxx"

// #include <sjagent.hxx>

#include "agapidll.hxx"

#include "strings.hrc"

#define CHANNEL_INIFILE_NAME			"channel"
#define CHANNEL_INIFILE_CHANNEL_GRP		"CHANNELS"

#define CHANNEL_INIFILE_AGENT			"agent"
#define CHANNEL_INIFILE_AGENT_GRP		"AGENTS"

#ifdef DEBUG
#define DEF_TIMER_INTERVAL				15000	// milli sekunden
#define DEF_AGENT_UPD_CHANNEL_PERIODE   30		// sekunden
#else
#define DEF_TIMER_INTERVAL				15000	// milli sekunden
#define DEF_AGENT_UPD_CHANNEL_PERIODE   21600	// sekunden
#endif

AgentType _ParseAgType(const String& rType)
{
	AgentType eAgType = AG_TYP_DONTKNOW;

	if( rType.ICompare(STR_AG_TYP_DLL) == COMPARE_EQUAL )
		eAgType = AG_TYP_DLL;
	else
	if( rType.ICompare(STR_AG_TYP_BASIC) == COMPARE_EQUAL )
		eAgType = AG_TYP_BASIC;
	else
	if( rType.ICompare(STR_AG_TYP_JAVA) == COMPARE_EQUAL )
		eAgType = AG_TYP_JAVA;

	return eAgType;
}

///////////////////////////////////////////////////////////////////////////////
//
//
NotifyItem::NotifyItem( ChannelItem* pItem, short nGMTOff, ULONG nLastDate,
						ULONG nLastTime, const INetURLObject& rChObjURL,
						const String& rChName) :
	pChItem			( pItem ),
	nGMTOffset		( nGMTOff ),
	nDateLastUpd	( nLastDate ),
	nTimeLastUpd	( nLastTime ),
	aChObjURL		( rChObjURL ),
	aChName			( rChName )
{
}

///////////////////////////////////////////////////////////////////////////////
//
//
NotifyItem::~NotifyItem()
{
}

///////////////////////////////////////////////////////////////////////////////
//
//
const String& NotifyItem::GetChAgentName() const
{
	return pChItem->GetChannelAgentName();
}

///////////////////////////////////////////////////////////////////////////////
//
//
ChannelList::ChannelList(const String& rAgentPath)
{
	pResMgr 		= (*(ResMgr**)GetAppData(SHL_APP1));

	aAgentPath		= rAgentPath;
	pChannelList 	= new ChannelItemList;
	pAgentList		= new ChannelAgentItemList;
	pNotifyList		= new NotifyList;
	pGetChObjList	= new GetChObjList;

	pUiAgentList	= NULL;
	pChannelTuner	= NULL;
	pBTXDecoder		= NULL;
	xINetSession 	= 0;

	aTimer.SetTimeoutHdl( LINK(this,ChannelList,CheckChannels) );
	aTimer.SetTimeout( DEF_TIMER_INTERVAL );

	ReadChannelList();
	ReadAgentList();
}

///////////////////////////////////////////////////////////////////////////////
//
//
ChannelList::~ChannelList()
{
	// ChannelList
	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		delete pItem;
	}
	delete pChannelList;

	// AgentList
	for( USHORT x = 0; x < pAgentList->Count(); ++x )
	{
		ChannelAgentItem* pItem = pAgentList->GetObject(x);
		if( pItem->IsActive() )
			pItem->GetChApi()->ShutDownAgent();
		delete pItem;
	}
	delete pAgentList;

	// NotifyList
	for( USHORT y = 0; y < pNotifyList->Count(); ++y )
	{
		NotifyItem* pItem = pNotifyList->GetObject(y);
		delete pItem;
	}
	delete pNotifyList;

	// GetChObjList
	for( USHORT z = 0; z < pGetChObjList->Count(); ++z )
	{
		GetChannelObj* pObj = pGetChObjList->GetObject(z);
		delete pObj;
	}
	delete pGetChObjList;

	DeleteUiAgentList();

	if( xINetSession )
		xINetSession.Clear();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetINetSession(INetSession* pNewSess)
{
	xINetSession = pNewSess;
	if( pChannelTuner )
		pChannelTuner->SetINetSession( xINetSession );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetBTXDecoder(Downloader* pDecoder)
{
	pBTXDecoder	= pDecoder;
	if( pChannelTuner )
		pChannelTuner->SetBTXDecoder( pBTXDecoder );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetTimerInterval( ULONG nNew )
{
	aTimer.SetTimeout( nNew );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::StartCheckChannels()
{
	aTimer.Start();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::StopCheckChannels()
{
	aTimer.Stop();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::DeleteUiAgentList()
{
	if( pUiAgentList )
	{
		for( USHORT a = 0; a < pUiAgentList->Count(); ++a )
		{
			UiAgentItem* pObj = pUiAgentList->GetObject(a);
			delete pObj;
		}
		delete pUiAgentList;
	}
	pUiAgentList = NULL;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::CheckAgentNow(const String& rAgName, BOOL bCheckGOD)
{
	ChannelAgentItem* pAgentItem = GetAgentItemByName(rAgName);
	if( !pAgentItem )
	{
		DBG_ASSERT( !this, "Agenten konnte nicht gefunden werden!" );
		CancelBTX();
		return;
	}

	String aAgentName( pAgentItem->GetChAgentName() );
	String aGODChannelName( aAgentName );
	aGODChannelName += "Update";

	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		if( (!bCheckGOD && pItem->GetChannelAgentName() == aAgentName) ||
			(bCheckGOD && pItem->GetChannelName() == aGODChannelName) )
		{
			SendItemToTuner(pItem);
			break;
		}
	}
}

IMPL_LINK(ChannelList, CheckBTXFinishHdl, void*, pPtr )
{
	String aFilename;
	DirEntry aEntry;

	if( pPtr )
	{
		aFilename = ((String*)pPtr)->GetStr();
		aEntry = aFilename;
		aEntry.GetFull();

		if( pNotifyList->Count() )
		{
			for( USHORT y = 0; y < pNotifyList->Count(); ++y )
			{
				NotifyItem* pItem = pNotifyList->GetObject(y);
				for( USHORT nAgIdx = 0; nAgIdx < pAgentList->Count(); ++nAgIdx )
				{
					ChannelAgentItem* pAgent = pAgentList->GetObject(nAgIdx);
					if( pAgent->GetChAgentName() == pItem->GetChAgentName() )
					{
						pAgent->SetBTXShutDownCallBack(
							LINK(this,ChannelList,CheckBTXFinishHdl) );
						NotifyAgent( pAgent, y );
						return 0;
					}
				}
			}
		}
	}

	BTXResponse aResponse;

	aResponse.nJobId			= JOBID_UPDATE_AGENT;
	aResponse.bFinish			= TRUE;
	aResponse.nTransferStatus	= DOWNLOAD_SUCCESS;
	aResponse.aLocalFileName	= "";
	aCheckFinishHdl.Call( &aResponse );

	return 1;
}

void ChannelList::CancelBTX()
{
	BTXResponse aResponse;

	aResponse.nJobId			= JOBID_CHECK_TRANSMITTER;
	aResponse.bFinish			= TRUE;
	aResponse.nTransferStatus	= DOWNLOAD_ERROR;
	aResponse.aLocalFileName	= "";
	aCheckFinishHdl.Call( &aResponse );
}

///////////////////////////////////////////////////////////////////////////////
//
//
UiAgentList* ChannelList::GetUiAgentList()
{
	if( pUiAgentList )
		DeleteUiAgentList();

	pUiAgentList = new UiAgentList;

	for( USHORT x = 0; x < pAgentList->Count(); ++x )
	{
		ChannelAgentItem* pAgItem = pAgentList->GetObject(x);
		ChannelItem* pChItem = NULL;
		for( USHORT i = 0; i < pChannelList->Count(); ++i )
		{
			ChannelItem* pI = pChannelList->GetObject(i);
			if( pI->GetChannelAgentName() == pAgItem->GetChAgentName() )
			{
				pChItem = pI;
				break;
			}
		}
		if( !pChItem )
			continue;

		UiAgentItem* pNew = new UiAgentItem;

		pNew->aName			= pAgItem->GetChAgentName();
		pNew->aUpdPeriode	= pChItem->GetUpdatePeriode();
		pNew->aLastDataDate	= DateTime( Date(pChItem->GetLastSuccUpdDate()),
								  Time(pChItem->GetLastSuccUpdTime()) );
		pNew->aLastUpdDate	= pAgItem->GetLastCheckDate();
		pNew->bUnregister	= FALSE;
		pNew->bIsEnabled	= pAgItem->IsEnabled();

		pUiAgentList->Insert( pNew, LIST_APPEND );
	}
	return pUiAgentList;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::JoinUiAgentList()
{
	BOOL bTimerStop = aTimer.IsActive();
	if( bTimerStop )
		aTimer.Stop();

	for( USHORT i = 0; i < pUiAgentList->Count(); ++i )
	{
		UiAgentItem* pUIItem = pUiAgentList->GetObject(i);
		ChannelAgentItem* pAgent = (ChannelAgentItem*) GetAgentItemByName( pUIItem->aName );

		if( pUIItem->bIsEnabled != pAgent->IsEnabled() )
		{
			pAgent->SetEnabled( pUIItem->bIsEnabled );
			SetEnabledAgent( pAgent );
		}

		// VOSICHT; muss hier immer das letzte Statement sein!
		if( pUIItem->bUnregister )
			DeleteAgentItem( pAgent );
	}

	if( bTimerStop )
		aTimer.Start();
}

///////////////////////////////////////////////////////////////////////////////
//
//
ChannelItem* ChannelList::GetChannelItemByName(const String& rName)
{
	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		if( pItem->GetChannelName() == rName )
			return pItem;
	}
	return NULL;
}

///////////////////////////////////////////////////////////////////////////////
//
//
ChannelAgentItem* ChannelList::GetAgentItemByName(const String& rName)
{
	for( USHORT i = 0; i < pAgentList->Count(); ++i )
	{
		ChannelAgentItem* pItem = pAgentList->GetObject(i);
		if( pItem->GetChAgentName() == rName )
			return pItem;
	}
	return NULL;
}

///////////////////////////////////////////////////////////////////////////////
//
//
IMPL_LINK( ChannelList, CheckChannels, void*, pTmp )
{
	if( !xINetSession ||
		!aNotifyPermissionHdl.IsSet() ||
		!aNotifyPermissionHdl.Call(this) )
		return 0;

	// Check Channels
	Time aActTime;
	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		DBG_ASSERT( pItem, "UUps, habe kein ChannelItem" );

		Time aItemTime;
		Time aItemUpdPeriode(0, 0, pItem->GetUpdatePeriode());

		aItemTime.SetTime( pItem->GetLastTimerTick() );
		aItemTime += aItemUpdPeriode;

		if( aActTime > aItemTime )
		{
			pItem->SetLastTimerTick(aActTime.GetTime());
			// gibt es einen enableden Agenten fuer diesen Kanal?
			// durch den Vergleich auf den AgentNamen ist auch der
			// GOD Channel fuer den Agenten lahmgelegt!
			for( USHORT nI = 0; nI < pAgentList->Count(); ++nI )
			{
				ChannelAgentItem* pAgent = pAgentList->GetObject(nI);
				if( pAgent->IsEnabled() &&
					pAgent->GetChAgentName() == pItem->GetChannelAgentName() )
				{
					SendItemToTuner(pItem);
					break;
				}
			}
		}
	}

	DoNotifyAgents();
	return 1;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::DoNotifyAgents()
{
	if( pNotifyList->Count() )
	{
		for( USHORT y = 0; y < pNotifyList->Count(); ++y )
		{
			NotifyItem* pItem = pNotifyList->GetObject(y);
			for( USHORT nAgIdx = 0; nAgIdx < pAgentList->Count(); ++nAgIdx )
			{
				ChannelAgentItem* pAgent = pAgentList->GetObject(nAgIdx);
				if( pAgent->GetChAgentName() == pItem->GetChAgentName() )
				{
					NotifyAgent( pAgent, y );
					if ( pNotifyList->GetObject(y) != pItem )
						break;
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SubscribeNewAgent(const INetURLObject& rURL)
{
	if( rURL.GetProtocol() == INET_PROT_NOT_VALID ||
		!rURL.HasParam() )
	{
		DBG_ASSERT( !this, "falsche Subscribe URL" );

		BTXResponse aResponse;
		aResponse.nJobId 			= JOBID_DOWNLOAD_AGENT;
		aResponse.bFinish 			= TRUE;
		aResponse.nTransferStatus 	= DOWNLOAD_ERROR;
		aResponse.aLocalFileName 	= String();

		aCheckFinishHdl.Call( &aResponse );

		return;
	}

	// pruefen ob Pfad angelegt.
	DirEntry aEntry( aAgentPath );
	aEntry.ToAbs();
	if( !aEntry.Exists() )
		aEntry.MakeDir();

	String	aParam( rURL.GetParam() );
	BOOL	bEntryOK = TRUE;
	USHORT	nDelimTok = 0;
	USHORT	nTokCount = aParam.GetTokenCount(';');

	String aSubscribe = aParam.GetToken(0, ';', nDelimTok);

	String aAgName = aParam.GetToken(0, ';', nDelimTok);
	if( !aAgName.Len() )
		bEntryOK = FALSE;

	String aType = aParam.GetToken(0, ';', nDelimTok);
	if( !aType.Len() )
		bEntryOK = FALSE;

	// es gibt nur drei Pflichtfelder
	if( nTokCount > 3 )
	{
		USHORT nSVVersion = aParam.GetToken(0, ';', nDelimTok);
		if( nSVVersion != SOLARUPD )
		{
			String aMsg( ResId(STR_CHA_AGENT_INCOMPAT, pResMgr) );
			String aAppName( Application::GetAppWindow()->GetText() );

			aMsg.SearchAndReplace( "%1", aAgName );
			aMsg.SearchAndReplace( "%2", aAppName );

			InfoBox aInfoBox(NULL, aMsg);
			aInfoBox.Execute();

			return;
		}
	}

	// wird der Agent event. gerade downgeloadet?
	for( USHORT nIdx = 0; nIdx < pGetChObjList->Count(); ++nIdx )
	{
		GetChannelObj* pObj = pGetChObjList->GetObject(nIdx);
		String aObjParam = pObj->GetURL().GetParam();
		USHORT nTok = 0;
		String aObjName = aParam.GetToken(1, ';', nTok);
		if( aObjName == aAgName )
		{
			String aErr = String( ResId(STR_CHA_AG_IN_DOWNLOAD, pResMgr) );
			aErr.SearchAndReplace( "%1", aAgName );
			aErr.SearchAndReplace( "%2", rURL.GetHost() );
			InfoBox aInfoBox(NULL, aErr);
			aInfoBox.Execute();
			return;
		}
	}

	// Try & Buy
	if( SvDemo::IsInited() )
	{
		SvDemoKind eKind = SvDemo::GetDemoKind( "TestVersion" );
		if( eKind != SFX_DEMOKIND_FULL &&
#if defined(OS2) || defined (WIN)
			aAgName.ICompare( "OUpdate" ) == COMPARE_EQUAL )
#else
			aAgName.ICompare( "StarOffice Onlineupdate" ) == COMPARE_EQUAL )
#endif
		{
			String aErr = String( ResId(STR_CHA_NO_TRY_BUY, pResMgr) );
			InfoBox aInfoBox(NULL, aErr);
			aInfoBox.Execute();
			return;
		}
	}

	aEntry += aAgName;
	aEntry.ToAbs();
	if( !aEntry.Exists() )
		aEntry.MakeDir();

	ChannelAgentItem* pItem = GetAgentItemByName(aAgName);

	if( aType.ICompare("STARTIT") == COMPARE_EQUAL && pItem)
	{
		if( !pItem->IsActive() )
		{
			if( !StartAgent(pItem) )
			{
				DBG_ASSERT( !this, "konnte Agent nicht starten" );
				CancelBTX();
				return;
			}
			else
				pItem->SetIsActive(TRUE);
			pItem->GetApi()->InitAgent();
		}
		return;
	}

	if( pItem )
	{
		String aMsg( ResId(STR_CHA_AGENT_ALREADY_INSTALLED, pResMgr) );
		aMsg.SearchAndReplace( "%1", aAgName );

		InfoBox aInfoBox( Application::GetAppWindow(), aMsg );
		aInfoBox.Execute();
		return;
	}
	else
	{
		String aMsg;

		if( rURL.GetProtocol() == INET_PROT_FIF ||
			rURL.GetProtocol() == INET_PROT_CEPT )
			aMsg = String( ResId(STR_CHA_SERVER_WANT_INSTALL_BTX, pResMgr) );
		else
			aMsg = String( ResId(STR_CHA_SERVER_WANT_INSTALL, pResMgr) );

		aMsg.SearchAndReplace( "%1", rURL.GetHost() );
		aMsg.SearchAndReplace( "%2", aAgName );

		if( QueryBox(Application::GetAppWindow(), WB_YES_NO, aMsg).Execute() == RET_NO )
			return;
	}

	AgentType eAgType = _ParseAgType(aType);
	if( !bEntryOK || eAgType == AG_TYP_DONTKNOW )
	{
		DBG_ASSERT( !this, "falsche Subscribe URL" );
		return;
	}

	INetURLObject aObj( rURL.GetMainURL() );
	ULONG nFlag = aObj.GetURLFlags();
	nFlag ^= INET_HAS_PARAM; // tja, ich bin der URL Meister
	aObj.SetURLFlags(nFlag);
	aObj.SetParam("");

	aEntry += aObj.GetLastName();
	aEntry.ToAbs();

	ChannelAgentItem* pNew = new ChannelAgentItem;

	INetURLObject aLocation;
	aLocation.SetSmartProtocol( INET_PROT_FILE );
	aLocation.SetURL( aEntry.GetFull(), FALSE );

	pNew->SetChannelAgentType	( eAgType	  );
	pNew->SetChAgentName		( aAgName	  );
	pNew->SetLocation			( aLocation   );
	pNew->SetLastSuccUpdDate	( 0xffffffff  );
	pNew->SetLastSuccUpdTime	( 0xffffffff  );
	pNew->SetAgentSourceURL		( aObj 		  );

	GetChannelObj* pGetObj = new GetChannelObj(xINetSession);

	if( aObj.GetProtocol() == INET_PROT_FIF ||
		aObj.GetProtocol() == INET_PROT_CEPT )
		pGetObj->SetBTXDecoder(pBTXDecoder);


	pGetChObjList->Insert( pGetObj, LIST_APPEND );

	pGetObj->SetShowStatus( TRUE );
	pGetObj->SetUserData( (void*)pNew );
	pGetObj->SetCallBackHdl(LINK(this,ChannelList,GetChannelObjNotify));

	pGetObj->Download( aObj.GetMainURL(), aEntry.GetFull(), TRUE );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::UpdateAgent( ChannelAgentItem* pAgent, ULONG nNotifyItemIdx )
{
	BOOL bTimerStop = aTimer.IsActive();
	if( bTimerStop )
		aTimer.Stop();

	if( pAgent->IsActive() )
	{
		pAgent->GetChApi()->ShutDownAgent();
		pAgent->SetRestartAfterUpdate(TRUE);
	}

	NotifyItem* pNotifyItem = pNotifyList->GetObject(nNotifyItemIdx);

	String aMsg( ResId(STR_CHA_AGENT_UPDATE, pResMgr) );
	aMsg.SearchAndReplace( "%1", pAgent->GetChAgentName() );

	if( QueryBox(Application::GetAppWindow(), WB_YES_NO, aMsg).Execute() == RET_YES )
	{
		pAgent->SetIsInUpdate(TRUE);

		// Vorsicht, jetzt die Zeit des LastSucc AgentUpdate
		pAgent->SetLastSuccUpdDate(pNotifyItem->GetDateLastUpd());
		pAgent->SetLastSuccUpdTime(pNotifyItem->GetTimeLastUpd());

		// ... und auch den GOD Channel anpassen.
		ChannelItem* pChannel = pNotifyItem->GetChannelItem();
		pChannel->SetLastSuccUpdDate(pNotifyItem->GetDateLastUpd());
		pChannel->SetLastSuccUpdTime(pNotifyItem->GetTimeLastUpd());


		GetChannelObj* pGetObj = new GetChannelObj(xINetSession);

		if( pNotifyItem->GetChannelObjURL().GetProtocol() == INET_PROT_FIF ||
			pNotifyItem->GetChannelObjURL().GetProtocol() == INET_PROT_CEPT )
			pGetObj->SetBTXDecoder(pBTXDecoder);

		pGetObj->SetShowStatus( TRUE );
		pGetObj->SetUserData( (void*)pAgent );
		pGetObj->SetCallBackHdl(LINK(this,ChannelList,GetChannelObjNotify));

		pGetChObjList->Insert( pGetObj, LIST_APPEND );

		pGetObj->Download( pNotifyItem->GetChannelObjURL(),
						   pAgent->GetLocation().PathToFileName(),
						   TRUE );

		pNotifyList->Remove(pNotifyItem);
		delete pNotifyItem;
	}
	else
	{
		if( pNotifyItem->GetChannelObjURL().GetProtocol() == INET_PROT_FIF ||
			pNotifyItem->GetChannelObjURL().GetProtocol() == INET_PROT_CEPT )
			CancelBTX();	// kein deinstall vom Agenten bei BTX
		else
			DeleteAgentItem( pAgent );
	}

	if( bTimerStop )
		aTimer.Start();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::NotifyAgent( ChannelAgentItem* pAgent, ULONG nNotifyItemIdx )
{
	NotifyItem* pItem = pNotifyList->GetObject(nNotifyItemIdx);
	BOOL bIsGodNotify = pItem->GetChannelItem()->GetAgentUpdChannel();

	if( pAgent->IsInUpdate() )
	{
		if( bIsGodNotify )
		{
			pNotifyList->Remove(nNotifyItemIdx);
			delete pItem;
		}
		return;
	}

	// ist es kein ChannelAgentUpdateNotify muessen wir schauen, ob event. ein
	// ChannelAgentUpdateNotify fuer den Agent in der NotifyList steht, um ihn
	// vorher auszufuehren.
	if( !bIsGodNotify )
	{
		for( USHORT i = 0; i < pNotifyList->Count(); ++i )
		{
			ChannelItem* pChItem = pNotifyList->GetObject(i)->GetChannelItem();
			if( pAgent->GetChAgentName() == pChItem->GetChannelAgentName() &&
				pChItem->GetAgentUpdChannel() )
			{
				UpdateAgent( pAgent, i );
				return;
			}
		}
	}
	else
	{
		UpdateAgent( pAgent, nNotifyItemIdx );
		return;
	}

	if( !pAgent->IsActive() )
	{
		if( !StartAgent(pAgent) )
		{
			DBG_ASSERT( !this, "konnte Agent nicht starten" );
			CancelBTX();
			return;
		}
		else
			pAgent->SetIsActive( TRUE );
		pAgent->GetApi()->InitAgent();
	}
	if( pAgent->GetApi()->NewDataPermission(pItem->GetChannelItem()->GetChannelName()) )
	{
		pAgent->SetChObjDate(pItem->GetDateLastUpd());
		pAgent->SetChObjTime(pItem->GetTimeLastUpd());
		pAgent->SetActiveChannel( pItem->GetChannelItem() );

		pAgent->GetApi()->NewData( pItem->GetChannelItem()->GetChannelName(),
								   pItem->GetChannelObjURL() );

		pNotifyList->Remove(nNotifyItemIdx);
		delete pItem;
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
BOOL ChannelList::StartAgent(ChannelAgentItem* pAgent)
{
	switch( pAgent->GetChannelAgentType() )
	{
		case AG_TYP_DLL: {
			AgentApiDll* pApiDll = new AgentApiDll( pAgent );
			pAgent->SetApi( pApiDll );
			break;
		}

		case AG_TYP_JAVA: {
			CreateChannelAgentProperty aAppProp( CHANNEL_AGENT_JAVA, pAgent );
			GetpApp()->Property( aAppProp );

			AgentApi* pApiJava = aAppProp.GetAgent();
			pAgent->SetApi( pApiJava );

			break;
		}

		case AG_TYP_BASIC: {
			CreateChannelAgentProperty aAppProp( CHANNEL_AGENT_BASIC, pAgent );
			GetpApp()->Property( aAppProp );

			AgentApi* pApiBasic = aAppProp.GetAgent();
			pAgent->SetApi( pApiBasic );

			break;
		}

		case AG_TYP_DONTKNOW:
		default: {
			DBG_ASSERT(!this, "kenne AgentType nicht!" );
			break;
		}
	}

	if( !pAgent->GetApi()->StartAgent() )
	{
		AgentApi* pApi = pAgent->GetApi();
		delete pApi;
		pAgent->SetApi( NULL );
		return FALSE;
	}
	ChannelApi* pChApi = new ChannelApi( pAgent, xINetSession, this	);
	pAgent->SetChApi( pChApi );

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SendItemToTuner(ChannelItem* pItem)
{
	INetProtocol eProt = pItem->GetTransmitter().GetProtocol();
	if( eProt == INET_PROT_FIF || eProt == INET_PROT_CEPT )
	{
		if( !pBTXDecoder ) {
			DBG_ASSERT( !this, "FIF o. CEPT, aber kein BTXDecoder gesetzt!" );
			return;
		}
	}
	else if( eProt != INET_PROT_FILE && !xINetSession )
	{
		String aMsg( ResId(STR_CHA_NO_INET, pResMgr) );
		InfoBox aBox( NULL, aMsg );
		aBox.Execute();
		return;
	}

	if( !pChannelTuner )
	{
		pChannelTuner = new ChannelTuner( xINetSession, this );
		pChannelTuner->SetBTXDecoder( pBTXDecoder );
	}
	pChannelTuner->RequestChannel(pItem, LINK(this,ChannelList,CheckBTXFinishHdl) );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::NotifyTransmitterMsg(const String& rStr)
{
	BOOL	bEntryOK = TRUE;
	USHORT 	nTok = 0;

	String	aGMTOffset;
	String	aTmpDateTime;
	String	aChObjURL;
	String	aChName;

	aGMTOffset = rStr.GetToken(0, ';', nTok);
	if( !aGMTOffset.Len() )
		bEntryOK = FALSE;
	aTmpDateTime = rStr.GetToken(0, ';', nTok);
	if( !aTmpDateTime.Len() )
		bEntryOK = FALSE;
	aChObjURL = rStr.GetToken(0, ';', nTok);
	if( !aChObjURL.Len() )
		bEntryOK = FALSE;
	aChName = rStr.GetToken(0, ';', nTok);
	if( !aChName.Len() )
		bEntryOK = FALSE;

	if( !bEntryOK )
	{
		DBG_ASSERT( !this, "keine gueltige Antwort vom Transmitter" );
		return;
	}

	Date aDate;
	Time aTime;
	if( !ParseDateTime(aTmpDateTime, aDate, aTime) )
	{
		DBG_ASSERT( !this, "falsches DateTime Format vom Transmitter" );
		return;
	}
	DateTime aTransmitterTime( aDate, aTime );


	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		if( pItem->GetChannelName() == aChName )
		{
			BOOL bInsert = TRUE;

			// Prfung's Datum ins INIFile eintragen, egal ob neuer oder nicht,
			// natuerlich nicht fuer die Goetter
			if( !pItem->GetAgentUpdChannel() )
			{
				ChannelAgentItem* pAgItem = GetAgentItemByName( pItem->GetChannelAgentName() );
				if( pAgItem )
				{
					pAgItem->SetLastCheckDate( DateTime() );
					WriteAgentItem( pAgItem );
				}
			}

			// steht event. schon in der Notifylist und man muss schauen
			// ob wir jetzt etwas neueres haben.
			for( USHORT x = 0; x < pNotifyList->Count(); ++x )
			{
				NotifyItem* pNotifyItem = pNotifyList->GetObject(x);
				if( pNotifyItem->GetChAgentName() == pItem->GetChannelAgentName() &&
					pNotifyItem->GetChannelName() == aChName )
				{
					bInsert = FALSE;
					DateTime aLastNotiyTime( Date(pNotifyItem->GetDateLastUpd()),
										   Time(pNotifyItem->GetTimeLastUpd()) );
					if(	aLastNotiyTime < aTransmitterTime )
					{
						pNotifyItem->SetDateLastUpd( aDate.GetDate() );
						pNotifyItem->SetTimeLastUpd( aTime.GetTime() );
					}
					break;
				}
			}

			if( !bInsert )
				continue;

			DateTime aLastSuccTime( Date(pItem->GetLastSuccUpdDate()),
						   Time(pItem->GetLastSuccUpdTime()) );

			if( aLastSuccTime < aTransmitterTime )
			{
				INetURLObject aChObj( aChObjURL );
				NotifyItem* pNew = new NotifyItem( pItem, aGMTOffset, aDate.GetDate(),
							aTime.GetTime(), aChObj, aChName );
				pNotifyList->Insert( pNew, (ULONG)0 );
				DoNotifyAgents();
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
BOOL ChannelList::ParseDateTime(const String& rSrc, Date& rDate, Time& rTime)
{
	BOOL	bEntryOK = TRUE;
	USHORT 	nTok = 0;

	// Date
	String aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rDate.SetDay( (USHORT) aTemp );

	aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rDate.SetMonth( (USHORT) aTemp );

	aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rDate.SetYear( (USHORT) aTemp );

	// Time
	aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rTime.SetHour( (USHORT) aTemp );

	aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rTime.SetMin( (USHORT) aTemp );

	aTemp = rSrc.GetToken(0, ':', nTok);
	if( !aTemp.Len() )
		bEntryOK = FALSE;
	rTime.SetSec( (USHORT) aTemp );
	rTime.Set100Sec( 0 );

	return bEntryOK;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::DeleteAgentItem(ChannelAgentItem* pItem)
{
	if( !pItem )
		return;
	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_AGENT);
	Config aCfg(aCfgFileName);

	aCfg.SetGroup(CHANNEL_INIFILE_AGENT_GRP);
	aCfg.DeleteKey( pItem->GetChAgentName() );

	if( pItem->IsActive() )
	{
		pItem->GetChApi()->ShutDownAgent();
		while( pItem->IsActive() )
			Application::Reschedule();
	}

	String aGODChannelName = pItem->GetChAgentName();
	aGODChannelName += "Update";

	// zugehoerigen Channel und GOD loeschen
	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pChItem = pChannelList->GetObject(i);
		if( pChItem->GetChannelName() == aGODChannelName )
		{
			pChannelList->Remove( pChItem );
			delete pChItem;
		} else if( pChItem->GetChannelAgentName() == pItem->GetChAgentName() )
		{
			DeleteChannelItem( pChItem );
		}
	}

	// event. Notifys vom GOD Channel loeschen
	for( USHORT x = 0; x < pNotifyList->Count(); ++x )
	{
		NotifyItem* pNotify = pNotifyList->GetObject(x);
		if( pNotify->GetChannelName() == aGODChannelName )
		{
			pNotifyList->Remove( pNotify );
			delete pNotify;
		}
	}

	if( pItem->GetLocation().GetProtocol() == INET_PROT_FILE )
	{
		DirEntry aEntry( pItem->GetLocation().PathToFileName() );
		DirEntry aPathEntry( aEntry.GetPath() );

		if( pItem->GetChAgentName() == aPathEntry.GetName() &&
			aPathEntry.Exists() )
		{
			// wenn das Verzeichnis, in dem der Agent installiert wurde,
			// genauso heisst wie der Agent haben wir 'CC2'. Es wird im
			// Gegensatz zu 'CC1' das komplette Unterverzeichnis geloescht!
			aPathEntry.Kill( FSYS_ACTION_RECURSIVE );
		}
		else
			aEntry.Kill();
	}

	pAgentList->Remove( pItem );
	delete pItem;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::DeleteChannelItem(ChannelItem* pItem)
{
	if( !pItem )
		return;

	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_NAME);
	Config aCfg(aCfgFileName);

	aCfg.SetGroup(CHANNEL_INIFILE_CHANNEL_GRP);
	aCfg.DeleteKey( pItem->GetChannelName() );

	// event. Notifys fuer diesen Channel lschen.
	for( USHORT i = 0; i < pNotifyList->Count(); ++i )
	{
		NotifyItem* pNotify = pNotifyList->GetObject(i);
		if( pItem->GetChannelName() == pNotify->GetChannelName() )
		{
			pNotifyList->Remove( pNotify );
			delete pNotify;
		}
	}

	pChannelList->Remove( pItem );
	delete pItem;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::RegisterNewChannelItem(ChannelItem* pItem)
{
	if( !pItem )
		return;
	pChannelList->Insert( pItem );
	WriteChannelItem( pItem );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetLastSuccUpdAgent(ChannelAgentItem* pChAgent)
{
	if( !pChAgent )
		return;
	WriteAgentItem( pChAgent );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetEnabledAgent(ChannelAgentItem* pChAgent)
{
	if( !pChAgent )
		return;
	WriteAgentItem( pChAgent );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::SetLastSuccUpdChannel(ChannelAgentItem* pChAgent)
{
	Date aDate(pChAgent->GetChObjDate());
	Time aTime(pChAgent->GetChObjTime());

	for( USHORT i = 0; i < pChannelList->Count(); ++i )
	{
		ChannelItem* pItem = pChannelList->GetObject(i);
		if( !pItem->GetAgentUpdChannel() &&
			pItem->GetChannelAgentName() == pChAgent->GetChAgentName() )
		{
			pItem->SetLastSuccUpdDate(aDate.GetDate());
			pItem->SetLastSuccUpdTime(aTime.GetTime());
			WriteChannelItem(pItem);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::WriteAgentItem(ChannelAgentItem* pChAgent)
{
	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_AGENT);
	Config aCfg(aCfgFileName);
	aCfg.SetGroup(CHANNEL_INIFILE_AGENT_GRP);

	Date	aDate(pChAgent->GetLastSuccUpdDate());
	Time	aTime(pChAgent->GetLastSuccUpdTime());
	String	aLine;
	char	pDateTimeBuf[255];
	char	pLastCheckDateTimeBuf[255];

	sprintf( pDateTimeBuf, ";%d:%d:%d:%d:%d:%d;",
				aDate.GetDay(), aDate.GetMonth(), aDate.GetYear(),
				aTime.GetHour(), aTime.GetMin(), aTime.GetSec() );

	sprintf( pLastCheckDateTimeBuf, ";%d:%d:%d:%d:%d:%d",
				pChAgent->GetLastCheckDate().GetDay(),
				pChAgent->GetLastCheckDate().GetMonth(),
				pChAgent->GetLastCheckDate().GetYear(),
				pChAgent->GetLastCheckDate().GetHour(),
				pChAgent->GetLastCheckDate().GetMin(),
				pChAgent->GetLastCheckDate().GetSec() );

	aLine += pChAgent->GetChannelAgentType() == AG_TYP_DLL ? STR_AG_TYP_DLL :
			 pChAgent->GetChannelAgentType() == AG_TYP_BASIC ? STR_AG_TYP_BASIC :
			 pChAgent->GetChannelAgentType() == AG_TYP_JAVA ? STR_AG_TYP_JAVA : "";
	aLine += ";";
	aLine += pChAgent->GetLocation().GetMainURL();
	aLine += pDateTimeBuf;
	aLine += pChAgent->GetSource().GetMainURL();
	aLine += ";";
	aLine += pChAgent->IsEnabled() ? "1" : "0";
	aLine += pLastCheckDateTimeBuf;

	aCfg.WriteKey( pChAgent->GetChAgentName(), aLine );
}


///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::WriteChannelItem(ChannelItem* pItem)
{
	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_NAME);
	Config aCfg(aCfgFileName);
	aCfg.SetGroup(CHANNEL_INIFILE_CHANNEL_GRP);

	Date	aDate(pItem->GetLastSuccUpdDate());
	Time	aTime(pItem->GetLastSuccUpdTime());
	String	aLine;
	char	pDateTimeBuf[255];

	sprintf( pDateTimeBuf, ";%d:%d:%d:%d:%d:%d;", aDate.GetDay(), aDate.GetMonth(),
			 aDate.GetYear(), aTime.GetHour(), aTime.GetMin(), aTime.GetSec() );

	aLine += pItem->GetTransmitter().GetMainURL();
	aLine += ";";
	aLine += pItem->GetChannel();
	aLine += ";";
	aLine += pItem->GetUpdatePeriode();
	aLine += pDateTimeBuf;
	aLine += pItem->GetChannelAgentName();

	aCfg.WriteKey( pItem->GetChannelName(), aLine );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::ReadAgentList()
{
	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_AGENT);
	Config aCfg(aCfgFileName);
	aCfg.SetGroup(CHANNEL_INIFILE_AGENT_GRP);

	USHORT nKeyCnt = aCfg.GetKeyCount();
	if( !nKeyCnt )
		return;

	for( USHORT i = 0; i < nKeyCnt; ++i )
	{
		BOOL   bEntryOK 	= TRUE;
		String aAgName		= aCfg.GetKeyName(i);
		String aLine		= aCfg.ReadKey(i);
		USHORT	nTokCount	= aLine.GetTokenCount(';');
		USHORT nDelimTok	= 0;

		String aTyp = aLine.GetToken(0, ';', nDelimTok);
		if( !aTyp.Len() )
			bEntryOK = FALSE;

		String aLocationURL = aLine.GetToken(0, ';', nDelimTok);
		if( !aLocationURL.Len() )
			bEntryOK = FALSE;

		String aLastSuccUpd = aLine.GetToken(0, ';', nDelimTok);
		if( !aLastSuccUpd.Len() )
			bEntryOK = FALSE;

		String aSource = aLine.GetToken(0, ';', nDelimTok);
		if( !aSource.Len() )
			bEntryOK = FALSE;

		if( !bEntryOK )
		{
			DBG_ASSERT( !this, "Fehlerhafter Eintrag in AgentList" );
			continue;
		}

		BOOL bEnabled = TRUE;
		if( nTokCount > 4 ) // Version 2 Agent Enabled oder nicht?
		{
			USHORT nVal = aLine.GetToken(0, ';', nDelimTok);
			if( nVal == 0 )
				bEnabled = FALSE;
		}

		DateTime aLastCheck(Date(0,0,0), Time(0,0));
		if( nTokCount > 5 ) // Version 2 LastCheckDate
		{
			String aLastCheckStr = aLine.GetToken(0, ';', nDelimTok);
			Date aLastCheckDate;
			Time aLastCheckTime;

			if( ParseDateTime(aLastCheckStr, aLastCheckDate, aLastCheckTime) )
				aLastCheck = DateTime( aLastCheckDate, aLastCheckTime );
		}

		AgentType eAgType = _ParseAgType(aTyp);
		if( eAgType == AG_TYP_DONTKNOW )
		{
			DBG_ASSERT( !this, "Fehlerhafter AgentType in AgentList" );
			continue;
		}

		Date aDate;
		Time aTime;
		if( !ParseDateTime(aLastSuccUpd, aDate, aTime) )
		{
			DBG_ASSERT( !this, "Fehlerhafter DATE/TIME Eintrag in AgentList" );
			continue;
		}

		ChannelAgentItem* pNew = new ChannelAgentItem;

		// somit koennen vom Setup 'normale' Pfadangaben installiert werden,
		// die hier zu File URL gewandelt werden!
		INetURLObject aTmpURL;
		aTmpURL.SetSmartProtocol( INET_PROT_FILE );
		aTmpURL.SetURL( aLocationURL, FALSE );

		pNew->SetChannelAgentType	( eAgType			);
		pNew->SetChAgentName		( aAgName			);
		pNew->SetLocation			( aTmpURL			);
		pNew->SetLastSuccUpdDate	( aDate.GetDate()	);
		pNew->SetLastSuccUpdTime	( aTime.GetTime()	);
		pNew->SetLastCheckDate		( aLastCheck		);
		pNew->SetSource				( aSource			);
		pNew->SetEnabled			( bEnabled 			);
		pNew->SetIsActive			( FALSE 			);

		pAgentList->Insert( pNew, LIST_APPEND );
		MakeGodChannel(pNew);
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::MakeGodChannel(ChannelAgentItem* pAgent)
{
	ChannelItem* pGodChannel = new ChannelItem;

	INetURLObject aObj( pAgent->GetSource() );
	String aTransmitter( INetURLObject::GetScheme(aObj.GetProtocol()) );
	aTransmitter += aObj.GetHost();

	String aUpdChannelName = pAgent->GetChAgentName();
	aUpdChannelName += "Update";

	pGodChannel->SetTransmitter		( aTransmitter );
	pGodChannel->SetChannel			( aObj.GetURLPath() );
	pGodChannel->SetChannelName		( aUpdChannelName );
	pGodChannel->SetChannelAgentName( pAgent->GetChAgentName() );
	pGodChannel->SetUpdatePeriode 	( DEF_AGENT_UPD_CHANNEL_PERIODE );
	pGodChannel->SetLastTimerTick	( 0L );
	pGodChannel->SetLastSuccUpdDate	( pAgent->GetLastSuccUpdDate() );
	pGodChannel->SetLastSuccUpdTime	( pAgent->GetLastSuccUpdTime() );

	pGodChannel->SetAgentUpdChannel( TRUE );
	pChannelList->Insert( pGodChannel, LIST_APPEND );
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::ReadChannelList()
{
	String aCfgFileName = Config::GetConfigName(aAgentPath,
						  CHANNEL_INIFILE_NAME);
	Config aCfg(aCfgFileName);
	aCfg.SetGroup(CHANNEL_INIFILE_CHANNEL_GRP);

	USHORT nKeyCnt = aCfg.GetKeyCount();
	if( !nKeyCnt )
		return;

	for( USHORT i = 0; i < nKeyCnt; ++i )
	{
		BOOL   bEntryOK 	= TRUE;
		String aChName		= aCfg.GetKeyName(i);
		String aLine		= aCfg.ReadKey(i);
		USHORT nDelimTok	= 0;

		String aTrans = aLine.GetToken(0, ';', nDelimTok);
		if( !aTrans.Len() )
			bEntryOK = FALSE;

		String aChannel = aLine.GetToken(0, ';', nDelimTok);
//		if( !aChannel.Len() )
//			bEntryOK = FALSE;

		String aUpdPeriod = aLine.GetToken(0, ';', nDelimTok);
		if( !aUpdPeriod.Len() )
			bEntryOK = FALSE;

		String aLastSucc = aLine.GetToken(0, ';', nDelimTok);
		if( !aLastSucc.Len() )
			bEntryOK = FALSE;

		String aChAgName = aLine.GetToken(0, ';', nDelimTok);
		if( !aChAgName.Len() )
			bEntryOK = FALSE;

		if( !bEntryOK )
		{
			DBG_ASSERT( !this, "Fehlerhafter Eintrag in ChannelList" );
			continue;
		}

		Date aDate;
		Time aTime;
		if( !ParseDateTime(aLastSucc, aDate, aTime) )
		{
			DBG_ASSERT( !this, "Fehlerhafter DATE/TIME Eintrag in ChannelList" );
			continue;
		}

		ChannelItem* pNew = new ChannelItem;

		pNew->SetTransmitter		( aTrans 			);
		pNew->SetChannel			( aChannel			);
		pNew->SetChannelName		( aChName			);
		pNew->SetChannelAgentName	( aChAgName			);
		pNew->SetUpdatePeriode 		( (ULONG)aUpdPeriod );
		pNew->SetLastTimerTick		( 0L 				);
		pNew->SetLastSuccUpdDate	( aDate.GetDate()	);
		pNew->SetLastSuccUpdTime	( aTime.GetTime()	);

		pChannelList->Insert( pNew, LIST_APPEND );
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
IMPL_LINK(ChannelList, CloseChannelObjEvt, void*, pTmp)
{
	for( USHORT i = 0; i < pGetChObjList->Count(); ++i )
	{
		GetChannelObj* pObj = pGetChObjList->GetObject(i);
		if( pObj->CanCloseIt() )
		{
			pGetChObjList->Remove(i);
			delete pObj;
			break;
		}
	}
	return 1;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void ChannelList::EnumFilesCallBack(char *pFile, void *pObject)
{
	StringList* pList = (StringList*)pObject;
	String* pNew = new String( pFile );
	pList->Insert( pNew );
}

#define HIDE_SVUNZIP
#if defined(UNX) && defined(HIDE_SVUNZIP)

#include <vos/diagnose.hxx>
#include <vos/module.hxx>

extern "C" {
typedef int SVUnzipE_type( const char* pZipFilePath, const char* pPattern,
						   UnzipEnumFilesCallBack*, void* pExtraData);
typedef int SVUnzip_type(  const char* pZipFilePath, const char* pDestPath,
						   const char* pFlags,
						   UnzipCallBack *pCallBackFunc );
BOOL InitUnzip();
}

BOOL           bOnce = InitUnzip();
SVUnzip_type  *pSVUnzip;
SVUnzipE_type *pSVUnzipEnumFiles;

BOOL InitUnzip()
{
	XubString  aZipName;
	OModule  *pUnzipLib;

	aZipName  = "libzip";
	aZipName += String( SUPD );
	aZipName += __DLLEXTENSION;

	pUnzipLib = new OModule;
	if( !pUnzipLib->load( aZipName ) )
	{
		fprintf (stderr, "Can't load Zip-library %s\n", (const char*) aZipName);
		delete pUnzipLib;
		abort();
	}

	pSVUnzip          = (SVUnzip_type*) pUnzipLib->getSymbol ("SVUnzip");
	pSVUnzipEnumFiles = (SVUnzipE_type*)pUnzipLib->getSymbol ("SVUnzipEnumFiles");
	if( !pSVUnzip || !pSVUnzipEnumFiles )
	{
		fprintf (stderr, "Can't load symbols from Zip-library %s\n", (const char*) aZipName);
		delete pUnzipLib;
		abort();
	}

	return TRUE;
}

#define SVUnzip pSVUnzip
#define SVUnzipEnumFiles pSVUnzipEnumFiles

#endif // UNX && HIDE_SVUNZIP

void ChannelList::UnZipAgent(ChannelAgentItem* pAgent)
{
#ifndef WIN
	StringList*	 pList		= new StringList;
	DirEntry	 aZipFile	( pAgent->GetLocation().PathToFileName() );

	aZipFile.ToAbs();

	int nError = SVUnzipEnumFiles( aZipFile.GetFull(), "",
				 (UnzipEnumFilesCallBack*)ChannelList::EnumFilesCallBack, pList);

	DirEntry aOldCWD;
	aOldCWD.ToAbs();
	aZipFile.SetCWD(TRUE);

	for( USHORT nIdx = 0; nIdx < pList->Count(); ++nIdx )
	{
		nError = SVUnzip( aZipFile.GetFull(),
						  (String)*(pList->GetObject(nIdx)),
						  "qqo",
						  NULL );
	}
	aOldCWD.SetCWD(TRUE);
	aZipFile.Kill();

	aZipFile.CutExtension();
	switch( pAgent->GetChannelAgentType() )
	{
		case AG_TYP_DLL: {
#ifdef UNX
			aZipFile.SetExtension("so");
#else
			aZipFile.SetExtension("dll");
#endif
			break;
		}

		case AG_TYP_JAVA: {
			aZipFile.SetExtension("class");
			break;
		}

		case AG_TYP_BASIC: {
			aZipFile.SetExtension("sdw");
			break;
		}

		case AG_TYP_DONTKNOW:
		default: {
			DBG_ASSERT(!this, "kenne AgentType nicht!" );
			break;
		}
	}

	INetURLObject aObj;
	aObj.SetSmartURL( aZipFile.GetFull() );

	pAgent->SetLocation( aObj );

	for( USHORT nListIdx = 0; nListIdx < pList->Count(); ++nListIdx )
		delete pList->GetObject( nListIdx );
	delete pList;
#else
	DBG_ASSERT( !this, "no SVUnzip support for W16" );
#endif
}

///////////////////////////////////////////////////////////////////////////////
//
//
IMPL_LINK(ChannelList, GetChannelObjNotify, GetChannelObj*, pGetChObj)
{
	for( USHORT i = 0; i < pGetChObjList->Count(); ++i )
		if( pGetChObjList->GetObject(i) == pGetChObj )
		{
			GetChannelObj* pObj = pGetChObjList->GetObject(i);
			ChannelAgentItem* pAgent = (ChannelAgentItem*)pObj->GetUserData();

			if( (pObj->GetURL().GetProtocol() == INET_PROT_FIF ||
				pObj->GetURL().GetProtocol() == INET_PROT_CEPT) &&
				(pObj->GetBTXError() != DOWNLOAD_SUCCESS) )
			{	// BTX-CallBack
				BTXResponse aResponse;

				aResponse.nJobId			= JOBID_DOWNLOAD_AGENT;
				aResponse.bFinish			= TRUE;
				aResponse.nTransferStatus	= pObj->GetBTXError();
				aResponse.aLocalFileName	= pAgent->GetLocation().PathToFileName();

				aCheckFinishHdl.Call( &aResponse );
				return 1;
			}

			String aExtension = pAgent->GetLocation().GetFileExtension();

			if( aExtension.ICompare("ZIP") == COMPARE_EQUAL )
				UnZipAgent( pAgent );

			if( pAgent->GetLastSuccUpdDate() == 0xffffffff &&
				pAgent->GetLastSuccUpdTime() == 0xffffffff )
			{
				// installation eines neuen Agent
				if( !StartAgent( pAgent ) )
				{
					DBG_ASSERT( !this, "frisch gezogener Agent laesst sich nicht starten" );
					pObj->SetCloseIt( TRUE );
					CancelBTX();
					Application::PostUserEvent(LINK(this, ChannelList, CloseChannelObjEvt));
					break;
				}

				pAgent->GetApi()->RegisterChannels();
				pAgent->GetApi()->RegisterUpdateTransmitter();
				pAgent->GetChApi()->ShutDownAgent();

				Date aDate;
				Time aTime;
				pAgent->SetLastSuccUpdDate( aDate.GetDate()	);
				pAgent->SetLastSuccUpdTime( aTime.GetTime()	);

				WriteAgentItem( pAgent );
				pAgentList->Insert( pAgent, LIST_APPEND );
				MakeGodChannel( pAgent );

				String aMsg( ResId(STR_CHA_AGENT_SUCC_INSTALLED, pResMgr) );
				aMsg.SearchAndReplace( "%1", pAgent->GetChAgentName() );
				InfoBox aInfoBox( Application::GetAppWindow(), aMsg );
				aInfoBox.Execute();

				if( pObj->GetURL().GetProtocol() == INET_PROT_FIF ||
					pObj->GetURL().GetProtocol() == INET_PROT_CEPT )
				{	// BTX-CallBack
					BTXResponse aResponse;

					aResponse.nJobId			= JOBID_DOWNLOAD_AGENT;
					aResponse.bFinish			= TRUE;
					aResponse.nTransferStatus	= pObj->GetBTXError();
					aResponse.aLocalFileName	= pAgent->GetLocation().PathToFileName();

					aCheckFinishHdl.Call( &aResponse );
				}
				else
				{
					for( USHORT i = 0; i < pChannelList->Count(); ++i )
					{
						ChannelItem* pItem = pChannelList->GetObject(i);
						if( pAgent->GetChAgentName() == pItem->GetChannelAgentName() )
							SendItemToTuner(pItem);
					}
				}

				pObj->SetCloseIt( TRUE );
				Application::PostUserEvent(LINK(this, ChannelList, CloseChannelObjEvt));
			}
			else
			{
				// Update eines vorhandenen Agent
				pAgent->SetIsInUpdate( FALSE );
				SetLastSuccUpdAgent( pAgent );

				if( pObj->GetURL().GetProtocol() == INET_PROT_FIF ||
					pObj->GetURL().GetProtocol() == INET_PROT_CEPT )
				{	// BTX-CallBack
					BTXResponse aResponse;

					aResponse.nJobId 			= JOBID_UPDATE_AGENT;
					aResponse.bFinish 			= TRUE;
					aResponse.nTransferStatus 	= pObj->GetBTXError();
					aResponse.aLocalFileName 	= pAgent->GetLocation().PathToFileName();

					aCheckFinishHdl.Call( &aResponse );
				}


				if( pAgent->RestartAfterUpdate() )
				{
					pAgent->SetRestartAfterUpdate(FALSE);
					ChannelItem* pItem = pAgent->GetActiveChannel();

					// LastUpdate eine Sekunde zurueck um ein Update zu erzwingen.
//					Time aTime( pItem->GetLastSuccUpdTime() );
//					Time aSubTime(0, 0, 1, 0);
//					aTime -= aSubTime;
//					pItem->SetLastSuccUpdTime(aTime.GetTime());
				}

				pObj->SetCloseIt( TRUE );
				Application::PostUserEvent(LINK(this, ChannelList, CloseChannelObjEvt));

				String aMsg( ResId(STR_CHA_AGENT_SUCC_UPDATED, pResMgr) );
				aMsg.SearchAndReplace( "%1", pAgent->GetChAgentName() );
				InfoBox aInfoBox( Application::GetAppWindow(), aMsg );
				aInfoBox.Execute();
			}
			break;
		}

	return 1;
}
