#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:30:11 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..

PRJNAME=goodies
TARGET=crypt
LIBTARGET=NO

PROJECTPCH=
PROJECTPCHSOURCE=

USE_DEFFILE=TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk

# --- Files --------------------------------------------------------

CXXFILES=\
	crypt.cxx

OBJFILES=\
	$(OBJ)$/crypt.obj

SLOFILES=\
	$(SLO)$/crypt.obj

LIB1TARGET =$(SLB)$/$(TARGET).lib
LIB1OBJFILES  =$(SLOFILES)

LIB2TARGET =$(LB)$/$(TARGET).lib
LIB2OBJFILES=$(OBJFILES)

SHL1TARGET= crp$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= icrp

SHL1DEPN=	$(L)$/itools.lib
SHL1LIBS=	$(LIB1TARGET) $(L)$/ivos.lib
SHL1BASE=	0x1c000000

.IF "$(GUI)" != "UNX"
SHL1OBJS=	$(SLO)$/crypt.obj
.ENDIF

SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

.IF "$(GUI)"!="WNT"
DEF1NAME	=$(SHL1TARGET)
DEF1DEPN	=$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =$(TARGET)
DEF1DES 	=Crypt_DLL
.ENDIF

# ------------------------------------------------------------------
# WindowsNT
# ------------------------------------------------------------------

.IF "$(GUI)" == "WNT"

.IF "$(COM)" == "BLC"
SHL1STDLIBS=itools.lib
.ELSE
SHL1STDLIBS=itools.lib gdi32.lib advapi32.lib comdlg32.lib \
				 uuid.lib ole32.lib shell32.lib winspool.lib

.IF "$(GVER)" == "W40"
SHL1STDLIBS+=comctl32.lib
.ENDIF
.ENDIF
.ENDIF
# ------------------------------------------------------------------
# Windows
# ------------------------------------------------------------------

.IF "$(GUI)" == "WIN"

.IF "$(COM)"=="MSC"
.IF "$(debug)" != ""
LINK=n:\bin\optlinks\optlinks
LINKFLAGS=$(LINKFLAGS) /IGN /COD /NOCV
.ELSE
LINK=n:\s70\bin\link
.ENDIF
.ENDIF

.IF "$(COM)" == "BLC"
SHL1STDLIBS=itools.lib
.ELSE
.IF "$(COM)" == "WTC"
SHL1STDLIBS=libr itools.lib libr commdlg.lib libr shell.lib
.ELSE
SHL1STDLIBS=itools.lib commdlg.lib shell.lib
.ENDIF
.ENDIF
.ENDIF
# ------------------------------------------------------------------
# OS2 + UNX + MAC
# ------------------------------------------------------------------

.IF "$(GUI)" == "OS2" || "$(GUI)" == "UNX"  || "$(GUI)" == "MAC"

SHL1STDLIBS=$(TOOLSLIB)
.ENDIF

# --- Targets -------------------------------------------------------

.IF "$(depend)" != ""

ALL:	ALLDEP

.ELSE

.IF "$(COM)"=="WTC"
ALL:		$(LIB1TARGET)						\
			$(MISC)$/$(SHL1TARGET).flt			\
			$(MISC)$/$(SHL1TARGET).def			\
			$(BIN)$/$(SHL1TARGET).dll			\
			ALLTAR
.ELSE

ALL:		$(LIB1TARGET)						\
			$(LIB2TARGET)						\
			$(MISC)$/$(SHL1TARGET).flt			\
			ALLTAR

.ENDIF
.ENDIF


$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	@echo --------------------------------------------
	@echo Filter-Datei erstellen
	@echo WEP>$@
	@echo LIBMAIN>>$@
	@echo LibMain>>$@
	@echo Impl>>$@
	@echo Dbg>>$@

.IF "$(GUI)"=="WNT"

$(MISC)$/$(SHL1TARGET).def: makefile.mk $(MISC)$/$(SHL1TARGET).flt
	@echo -------------------------------------------
	@echo DEF-File erstellen
    @echo LIBRARY     $(DLLNAME)                   >$@
    @echo DESCRIPTION 'Crypt_DLL'                >>$@
    @echo DATA                READ WRITE NONSHARED >>$@
    @echo EXPORTS                                  >>$@
    @echo     cryptit                        >>$@

.ENDIF



# --- Targets -------------------------------------------------------

.INCLUDE :  target.mk

