/*************************************************************************
 *
 *  $RCSfile: ecgm.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _ECGM_HXX_
#define _ECGM_HXX_

// ------------------------------------------------------------------------

#include <tools/debug.hxx>

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XMASTERPAGESSUPPLIER_HPP_
#include <com/sun/star/drawing/XMasterPagesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGE_HPP_
#include <com/sun/star/drawing/XDrawPage.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGESSUPPLIER_HPP_
#include <com/sun/star/drawing/XDrawPagesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGES_HPP_
#include <com/sun/star/drawing/XDrawPages.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#include <rtl/ustring>
#include <vcl/poly.hxx>
#include <vcl/graph.hxx>
#include <vcl/bmpacc.hxx>
#include <vcl/gradient.hxx>
#include <tools/list.hxx>
#include <tools/stream.hxx>
#include <svtools/fltcall.hxx>
#ifndef	__STARDIV_ONE_FRAME_XSTATIND_HXX__
#endif

// ------------------------------------------------------------------------

struct GroupEntry
{
		sal_uInt32					mnCurrentPos;
		sal_uInt32					mnCount;
		::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > 			mXIndexAccess;
								GroupEntry( ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > & rIndex )
								{
									mXIndexAccess = rIndex;
									mnCount =mXIndexAccess->getCount();
									mnCurrentPos = 0;
								};
								GroupEntry( sal_uInt32 nCount )
								{
									mnCount = nCount;
									mnCurrentPos = 0;
								};
								~GroupEntry(){};
};

// ------------------------------------------------------------------------

class GroupTable
{
		sal_uInt32					mnIndex;
		sal_uInt32					mnCurrentGroupEntry;
		sal_uInt32					mnMaxGroupEntry;
		sal_uInt32					mnGroupsClosed;
		GroupEntry**			mpGroupEntry;

		void					ImplResizeGroupTable( sal_uInt32 nEntrys );

	public:

		sal_uInt32					GetCurrentGroupIndex() const { return mnIndex; };
		sal_uInt32					GetCurrentGroupLevel() const { return mnCurrentGroupEntry - 1; };
		::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > &		GetCurrentGroupAccess() const { return mpGroupEntry[  mnCurrentGroupEntry - 1 ]->mXIndexAccess; };
		sal_uInt32					GetGroupsClosed();
		void					ResetGroupTable( sal_uInt32 nCount );
		void					ClearGroupTable();
		void					EnterGroup( ::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexAccess > & rIndex );
		sal_Bool					GetNextGroupEntry();
								GroupTable();
								~GroupTable();

};

// ------------------------------------------------------------------------

class CGMWriter : public GroupTable
{
		sal_Bool					mbStatus;
		SvStream*				mpFileOut;
		SvMemoryStream*			mpOut;

		::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > 				mXModel;
		::com::sun::star::uno::Reference< ::com::sun::star::task::XStatusIndicator > 		mXStatusIndicator;

		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > 	mXServiceManager;
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > 	mXServiceProvider;

		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPagesSupplier > 	mXDrawPagesSupplier;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XMasterPagesSupplier > 	mXMasterPagesSupplier;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPages > 			mXDrawPages;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPages > 			mXMasterPages;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPage > 			mXDrawPage;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShapeDescriptor > 		mXShapeDesc;

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > 			mXPagePropSet;
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  		mXPropSet;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShapes > 				mXShapes;
		::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > 				mXShape;
		ByteString					mType;

	 ::com::sun::star::uno::Any					mAny;
	 ::com::sun::star::awt::Size				maShapeSize;
	 ::com::sun::star::awt::Point				maShapePosition;
	 ::com::sun::star::awt::Size				maPageSize;
		sal_Int32					mnMaxLength;

		int						mnPages;
		int						mnCurrentPage;

		sal_Bool					ImplGetPropertyValue( const UniString& rString );
		sal_Bool					ImplGetPropertyValue( const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rXPropSet, const UniString& rString );
		sal_Bool					ImplGetPageByIndex( sal_uInt32 nIndex, sal_Bool bMaster = sal_False );
		sal_Bool					ImplGetShapeByIndex( sal_uInt32 nIndex, sal_Bool bGroup = sal_False );
		void					ImplScanPage();
		sal_Bool					ImplWriteLineBundle( sal_Bool bEdgeBundle = sal_False );
		sal_Bool					ImplWriteFillBundle( sal_Bool bEdgeBundle = sal_True );
		void					ImplCreatePolyPolygon( sal_Bool bClosed );
		void					ImplWritePolygon( Polygon&, sal_Bool bClosed );
		void					ImplWriteDesc( int nClass, int nID );
		sal_Bool					ImplWriteGlobalHeader();
		void					ImplWriteDouble( const double& rDouble );
		void					ImplWriteVDCInt( sal_Int32 nNumb );
		void					ImplWritePoint( const ::com::sun::star::awt::Point& rPoint, sal_Bool bMap = sal_True );
	 ::com::sun::star::awt::Size					ImplMapSize( const ::com::sun::star::awt::Size& );
	 ::com::sun::star::awt::Point					ImplMapPoint( const ::com::sun::star::awt::Point& rPoint );

	public:
								CGMWriter( ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > &, SvStream&, ::com::sun::star::uno::Reference< ::com::sun::star::task::XStatusIndicator > & );
								~CGMWriter();
		void					Write();
		sal_Bool					IsValid() const { return mbStatus; };
};


#endif
