/*************************************************************************
 *
 *  $RCSfile: dlgipcd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop
#include <tools/ref.hxx>
#include "dlgipcd.hxx"
#include "dlgipcd.hrc"
#include "strings.hrc"

/*************************************************************************
|*
|* Ctor
|*
\************************************************************************/

DlgIPCD::DlgIPCD( FltCallDialogParameter& rPara ) :
			ModalDialog			( rPara.pWindow, ResId( DLG_IMPORT_PCD, rPara.pResMgr ) ),
			aRbtBase16			( this, ResId( RBT_BASE16 ) ),
			aRbtBase4 			( this, ResId( RBT_BASE4 ) ),
			aRbtBase  			( this, ResId( RBT_BASE ) ),
			aGrpResolution  	( this, ResId( GRP_RESOLUTION ) ),
			aBtnOK				( this, ResId( BTN_OK ) ),
			aBtnCancel			( this, ResId( BTN_CANCEL ) ),
			aBtnHelp			( this, ResId( BTN_HELP ) ),
			pConfig				( rPara.pCfg ),
			pMgr				( rPara.pResMgr )
{
	FreeResource();

	// Config-Parameter lesen
	pConfig->Update();
	UniString aKStr( ResId( KEY, pMgr ) );
	ByteString aStr = pConfig->ReadKey( ByteString( aKStr, RTL_TEXTENCODING_UTF8 ) );
	UniString aB16Str( ResId( STR_BASE16, pMgr ) );
	UniString aB4Str( ResId( STR_BASE4, pMgr ) );

	if( aB16Str.CompareToAscii( aStr.GetBuffer(), aStr.Len() ) == COMPARE_EQUAL )
		aRbtBase16.Check();
	else if( aB4Str.CompareToAscii( aStr.GetBuffer(), aStr.Len() ) == COMPARE_EQUAL )
		aRbtBase4.Check();
	else
		aRbtBase.Check();

	aBtnOK.SetClickHdl( LINK( this, DlgIPCD, OK ) );
}

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

DlgIPCD::~DlgIPCD()
{
}

/*************************************************************************
|*
|* Speichert eingestellte Werte in ini-Datei
|*
\************************************************************************/

IMPL_LINK( DlgIPCD, OK, void *, EMPTYARG )
{
	// Config-Parameter schreiben
	String aStr;
	if( aRbtBase16.IsChecked() )
		aStr = String( ResId( STR_BASE16, pMgr ) );
	else if( aRbtBase4.IsChecked() )
		aStr = String( ResId( STR_BASE4, pMgr ) );
	else
		aStr = String( ResId( STR_BASE, pMgr ) );

	UniString aKeyStr( ResId( KEY, pMgr ) );
	pConfig->WriteKey( ByteString( aKeyStr, RTL_TEXTENCODING_UTF8 ), ByteString( aStr, RTL_TEXTENCODING_UTF8 ) );
	pConfig->Flush();

	EndDialog( RET_OK );

	return 0;
}



