/*************************************************************************
 *
 *  $RCSfile: ctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <docobj.h>
#if _MSC_VER < 1200
#include <wtypes.h>
#include "msdev6.inc/exmisc.hxx"		// msdev6 cut/paste
#include "msdev6.inc/exdispid.h"
#include "msdev6.inc/mshtmcid.h"
#else
#include <exdisp.h>
#include <exdispid.h>
#include <mshtmcid.h>
#include <mshtmhst.h>
#endif

#undef TRANSPARENT
//#include <tools/urlobj.hxx>

//#include <tools/debug.hxx>
//
//#include <vcl/window.hxx>
//#include <vcl/syschild.hxx>
//#include <tools/svwin.h>
//#include <vcl/sysdata.hxx>
//#include <toolkit/unoiface.hxx>
//
//#include <usr/uno.hxx>
//#include <usr/ustring.hxx>

#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMES_HXX_
#include <com/sun/star/frame/XFrames.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_WINDOWATTRIBUTE_HPP_
#include <com/sun/star/awt/WindowAttribute.hpp>
#endif


#undef WIN32
#ifndef _COM_SUN_STAR_AWT_XSYSTEMDEPENDENTWINDOWPEER_HPP_
#include <com/sun/star/awt/XSystemDependentWindowPeer.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_INVALIDATESTYLE_HPP_
#include <com/sun/star/awt/InvalidateStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_SYSTEMDEPENDENT_HPP_
#include <com/sun/star/lang/SystemDependent.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_NOSUCHELEMENTEXCEPTION_HPP_
#include <com/sun/star/container/NoSuchElementException.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_URL_HPP_
#include <com/sun/star/util/URL.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_IOEXCEPTION_HPP_
#include <com/sun/star/io/IOException.hpp>
#endif

#ifndef _RTL_PROCESS_H_
#include <rtl/process.h>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef __SGI_STL_INTERNAL_LIST_H
#include <stl/stl_list.h>
#endif
#ifndef _RTL_UUID_H_
#include <rtl/uuid.h>
#endif


#include <sal/types.h>

#include <ie/ctrl.hxx>

#include "helpid.hrc"
#include "extdisp.hxx"

using namespace com::sun::star::uno;
using namespace com::sun::star::frame;
using namespace com::sun::star::lang;
using namespace com::sun::star::util;
using namespace com::sun::star::beans;
using namespace com::sun::star::container;
using namespace com::sun::star::io;
using namespace com::sun::star::awt;
using namespace com::sun::star::task;
using namespace rtl;
using namespace osl;

//#if _MSC_VER < 1200
extern "C" const GUID CGID_MSHTML; // ????
//#endif
sal_Bool _parseFileNameFromURL( const OUString & rURL, OUString & rFileName );




IExplorerController_Impl::IExplorerController_Impl( const OUString & rReferer, const Reference<XMultiServiceFactory>& rMSF )
	: _pIWebBrowser2( NULL )
	, _pWBContainer( NULL )
	, _bFirstFrame( sal_True )
	, _bIsDisposed( sal_False )
	, _aReferer( rReferer )
	, m_multiServiceFactory(rMSF)
	, _aListeners( *Mutex::getGlobalMutex())
{
	++s_nOpenBrowsers;
	OSL_ENSHURE( (s_nOpenBrowsers > 0), "### illegal count!");
	updateDummySocket();
	
	::OleInitialize(NULL);
}
//__________________________________________________________________________________________________
IExplorerController_Impl::~IExplorerController_Impl()
{
	OSL_ENSHURE( _bIsDisposed, "### iexplorer controller was not disposed!" );
	if (! _bIsDisposed)
		dispose();
	
	::OleUninitialize();
	::CoFreeUnusedLibraries();	

	if (! --s_nOpenBrowsers)
		releaseDummySocket(); // assure that no socket is held when last browser disappears
	OSL_ENSHURE( (s_nOpenBrowsers >= 0), "### illegal count!" );
}

//##################################################################################################
//#### XController #################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::attachModel( const Reference< XModel >& xModel ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return sal_False;
}
//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::suspend( sal_Bool bSuspend ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return sal_True;
}
//__________________________________________________________________________________________________
Any IExplorerController_Impl::getViewData(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return Any();
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::restoreViewData( const Any& Data ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
}
//__________________________________________________________________________________________________
Reference< XFrame > IExplorerController_Impl::getFrame(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return _xFrame;
}
//__________________________________________________________________________________________________
Reference< XModel > IExplorerController_Impl::getModel(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return (XModel *)this;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::frameAction( const FrameActionEvent& rEvent ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );

	switch (rEvent.Action)
	{
	case FrameAction_COMPONENT_ATTACHED:
	case FrameAction_COMPONENT_REATTACHED:
	case FrameAction_FRAME_ACTIVATED:
//		if (_xChildWin)
//			_xChildWin->GrabFocus();
//  		// global command state
//  		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Offline") ), get_GlobalOffline(), sal_True );
//		updateDummySocket();
		break;
	case FrameAction_FRAME_DEACTIVATING:
	case FrameAction_COMPONENT_DETACHING:
//		if (_xChildWin)
//			_xChildWin->LoseFocus();
		break;
	}
}

//__________________________________________________________________________________________________
void IExplorerController_Impl::attachFrame( const Reference< XFrame >& xFrame ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	if (_xFrame.is())
	{
		_xFrame->removeEventListener( (XEventListener *)(XFocusListener *)this );
		_xFrame = Reference< XFrame>();
	}
	
	if (xFrame.is())
	{
		// ContainerWindow des Frames
		Reference<XWindow> _xParent = xFrame->getContainerWindow();

		if (_xChildWin.is())
		{
			// todo
//  			_pChildWin->SetParent( pParent );
			OSL_ENSHURE( sal_False, "### unexpected for now!" );
		}
		else // create new ie window
		{
			Reference<XToolkit> xToolkit( m_multiServiceFactory->createInstance(
				OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.awt.Toolkit") ) ), UNO_QUERY );

			::com::sun::star::awt::Rectangle aRect( _xParent->getPosSize() );
			WindowDescriptor aDescr;
			aDescr.Type = WindowClass_TOP;
			aDescr.WindowServiceName = OUString( RTL_CONSTASCII_USTRINGPARAM("systemchildwindow") );
			aDescr.Parent = Reference<XWindowPeer>( _xParent, UNO_QUERY );
			aDescr.ParentIndex = -1;
			aDescr.Bounds = aRect;
			aDescr.WindowAttributes = WindowAttribute::SHOW | WindowAttribute::SYSTEMDEPENDENT;
			
			_xChildWin = Reference<XWindow>( xToolkit->createWindow( aDescr ), UNO_QUERY );
			
			Reference<XSystemDependentWindowPeer> xDep( _xChildWin, UNO_QUERY );
			Sequence< sal_Int8> aProcessId( 16 );
			rtl_getGlobalProcessId( (sal_uInt8 *)aProcessId.getArray() );
#if (UDK_MAJOR == 0 && UDK_MINOR == 9 && UDK_MICRO == 1) || SUPD <= 582
			Any aAny( xDep->getWindowHandle( aProcessId, SystemDependent::WIN32 ) );
#else
			Any aAny( xDep->getWindowHandle( aProcessId, SystemDependent::SYSTEM_WIN32 ) );
#endif
			OSL_ENSHURE( *(HWND *)aAny.getValue(), "no window handle!" );

			_pWBContainer = new Container_Impl( *(HWND *)aAny.getValue(), this, (IDispatch*)this );
	
			if (! _pWBContainer)
			{
				Reference< XComponent> xComp( _xChildWin, UNO_QUERY );
				if (xComp.is())
					xComp->dispose();
				_xChildWin = Reference<XWindow>();
				return;
			}
			if (FAILED(_pWBContainer->CreateBrowserOC( (IDispatch *)this )))
			{
				_pWBContainer->shutdown();
				_xChildWin.clear();
				return;
			}
			
			_pIWebBrowser2= _pWBContainer->getWebBrowser(); // allready AddRef'ed
			OSL_ENSHURE( _pIWebBrowser2, "### Cannot retrieve IWebBrowser2 from Container!" );

//			_xChildWin->setPosSize( 0, 0, aRect.Width, aRect.Height, PosSize::SIZE );
//			_pWBContainer->setPosSize( 0, 0, aRect.Width, aRect.Height );
		}
		
		xFrame->setComponent( _xChildWin, static_cast< XController * >( this ) );
//  		_xChildWin->setVisible( sal_True );
		::com::sun::star::awt::Rectangle aRect( _xParent->getPosSize() );
		_xChildWin->setPosSize( 0, 0, aRect.Width, aRect.Height, PosSize::SIZE );
		_pWBContainer->setPosSize( 0, 0, aRect.Width, aRect.Height );
//  		_xChildWin->setVisible( sal_True );
 		_xChildWin->addWindowListener( static_cast< XWindowListener * >( this ) );

		// get Status Indicator of Frame
		Reference<XStatusIndicatorSupplier> xSupplier( xFrame, UNO_QUERY);
		OSL_ENSHURE( xSupplier.is(), "### cannot get StatusSupplier!" );
		_xStatusIndicator = xSupplier->getStatusIndicator();
		OSL_ENSHURE( xSupplier.is(), "### cannot get StatusIndicator!" );
		
		xFrame->addEventListener( (XEventListener *)(XFocusListener *)this );
		xFrame->addFrameActionListener( (XFrameActionListener *)this );
		
		Reference<XWindowPeer>( _xChildWin, UNO_QUERY )->invalidate( InvalidateStyle::UPDATE );		
	}
	_xFrame = xFrame;
	_bFirstFrame = sal_True;
}

//__________________________________________________________________________________________________
Reference< XDispatch > IExplorerController_Impl::queryDispatch( const URL& rURL, const OUString& aTargetFrameName, sal_Int32 nSearchFlags ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	if (!_bIsDisposed && rURL.Protocol.compareToAscii( ".uno:" ) == 0)
	{
		const OUString & rPath = rURL.Path;
		
		if (_xFrame.is() && _xFrame->isTop() &&
			(rPath.compareToAscii( "BrowseForward") == 0 ||
			 rPath.compareToAscii( "BrowseBackward") == 0))
		{
			return (XDispatch *)this;
		}
		
		if (rPath.compareToAscii( "Save" ) == 0			  ||
			rPath.compareToAscii( "SaveAs" ) == 0			  ||
			rPath.compareToAscii( "Properties" ) == 0		  ||
			rPath.compareToAscii( "PageSetup" ) == 0		  ||
			rPath.compareToAscii( "Print" ) == 0			  ||
			rPath.compareToAscii( "PrintDefault" ) == 0	  ||
//  		 rPath.compareToAscii( "Offline" ) == 0		  ||
			rPath.compareToAscii( "Reload" ) == 0			  ||
			rPath.compareToAscii( "EditDoc" ) == 0			  ||
			rPath.compareToAscii( "Cut" ) == 0				  ||
			rPath.compareToAscii( "Copy" ) == 0			  ||
			rPath.compareToAscii( "Paste" ) == 0			  ||
			rPath.compareToAscii( "SelectAll" ) == 0		  ||
			rPath.compareToAscii( "SearchDialog" ) == 0	  ||
			rPath.compareToAscii( "SourceView" ) == 0		  ||
//  		 rPath.compareToAscii( "JavaConsole" ) == 0	  ||
			rPath.compareToAscii( "Title" ) == 0			  ||
			rPath.compareToAscii( "CurrentURL" ) == 0		  ||
			rPath.compareToAscii( "Cancel" ) == 0)
		{
			return (XDispatch *)this;
		}
	}
	return Reference< XDispatch >();
}
//__________________________________________________________________________________________________
Sequence<Reference<XDispatch > > IExplorerController_Impl::queryDispatches( const Sequence<DispatchDescriptor >& aDescripts ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	sal_uInt32 nPos = aDescripts.getLength();
	Sequence<Reference<XDispatch > > aRet( nPos );
	
	const DispatchDescriptor * pDescripts = aDescripts.getConstArray();
	Reference<XDispatch> * pRet = aRet.getArray();
	
	for ( ; nPos--; )
	{
		const DispatchDescriptor & rDescr = pDescripts[nPos];
		pRet[nPos] = queryDispatch( rDescr.FeatureURL, rDescr.FrameName, rDescr.SearchFlags );
	}
	return aRet;
}

//##################################################################################################
//#### XComponent ##################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
void IExplorerController_Impl::dispose() throw (RuntimeException) 
{
	if (_bIsDisposed)
		return;
	_bIsDisposed = sal_True;

	// tell all listeners to release this object
	EventObject aEvent;
	aEvent.Source = *this;

	_aListeners.disposeAndClear(aEvent);
	
	typedef map< Reference<XStatusListener>, StatusDispatch >::iterator IT;
	for( IT iter= _aStatusListeners.begin(); iter != _aStatusListeners.end(); ++iter )
	{
		iter->second.xListener->disposing( aEvent );
		iter->second.xListener.clear();
	}
	Reference<XEventListener> xListener( static_cast<XEventListener *>( 
		static_cast<XFrameActionListener*>(this)) );	// zur Selbsterhaltung
	if (_xFrame.is())
	{
		if (_xStatusIndicator.is())
		{
			_xStatusIndicator->end();
			_xStatusIndicator = 0;
		}
		_xFrame->removeFrameActionListener( (XFrameActionListener *)this );
		_xFrame->removeEventListener( xListener );
	}

	if (_pWBContainer)
	{
		if (_pIWebBrowser2)
			_pIWebBrowser2->Release();
		_pWBContainer->shutdown();
	}
	// alloziiertes ChildWindow wird von Frame abgeraeumt

	_xFrame = 0;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::addEventListener( const Reference< XEventListener >& xListener ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	if (_bIsDisposed)
		return;
	
	OSL_ENSHURE( xListener.is(), "### received null listener!" );

	// create a new Reference and insert into listener array
	_aListeners.addInterface( xListener );
	
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::removeEventListener( const Reference<XEventListener >& aListener ) throw(RuntimeException)
{
	// ignore remove...() calls if we are in dispose() call disposing all listeners... ;)
	if (_bIsDisposed)
		return;
	
	OSL_ENSHURE( aListener.is(), "### received null listener!" );

	_aListeners.removeInterface( aListener);
}

//##################################################################################################
//#### XEventListener ##############################################################################
//##################################################################################################

//__________________________________________________________________________________________________
void IExplorerController_Impl::disposing( const EventObject& Source ) throw(RuntimeException)
{
	// check if this is _MY_ frame
	if (_xFrame.is() && Source.Source.is() && _xFrame.operator==( Source.Source ))
	{
		dispose();		// dispose whole controller
	}
}

//##################################################################################################
//#### XDispatch ###################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
void IExplorerController_Impl::addStatusListener( const Reference< XStatusListener >& xControl, const URL& aURL ) throw(RuntimeException)
{
	// ignore add...() calls if we are in dispose() call, disposing all listeners... ;)
	if (_bIsDisposed)
		return;
	
	OSL_ENSHURE( xControl.is(), "### received null listener!" );
	
	// create a new StatusDispatch object and add to the listener map
	StatusDispatch stat( aURL, xControl );
	_aStatusListeners[xControl]= stat;
	
	FeatureStateEvent aStatusEvent;
	aStatusEvent.Source		= (XDispatch *)this;
	aStatusEvent.FeatureURL	= aURL;
	// default disable all
	aStatusEvent.IsEnabled	= sal_False;
	aStatusEvent.Requery	= sal_False;
	
	xControl->statusChanged( aStatusEvent );
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::removeStatusListener( const Reference< XStatusListener >& xControl, const URL& aURL ) throw(RuntimeException) 
{
	// ignore remove...() calls if we are in dispose() call, disposing all listeners... ;)
	if (_bIsDisposed)
		return;
	
	// search listener array for given listener
	typedef map< Reference<XStatusListener>, StatusDispatch >::iterator IT;
	IT iter= _aStatusListeners.find( xControl);
	if( iter != _aStatusListeners.end() &&
		iter->second.aURL.Complete == aURL.Complete )
	{
		_aStatusListeners.erase(iter);
	}
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::dispatch( const URL & rURL, const Sequence< PropertyValue > & rArgs )
	throw (RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	if (rURL.Protocol.compareToAscii( ".uno:" ) == 0)
	{
		const OUString & rPath = rURL.Path;

		if (rPath.compareToAscii( "BrowseBackward" ) == 0)
			_pIWebBrowser2->GoBack();
		else if (rPath.compareToAscii( "BrowseForward" ) == 0)
			_pIWebBrowser2->GoForward();
		else if (rPath.compareToAscii( "Cancel" ) == 0)
			stop();

		else if (rPath.compareToAscii( "Reload" ) == 0)
		{
			VARIANTARG va;
			::VariantInit( &va );
			V_VT( &va )	= VT_I4;
			V_I4( &va )	= REFRESH_COMPLETELY;
			_pIWebBrowser2->Refresh2( &va );
			::VariantClear( &va );
		}

		else if (rPath.compareToAscii( "EditDoc" ) == 0)
		{
			// edit doc in new frame
			dispatchURL( m_multiServiceFactory, _xFrame,
						 OUString( RTL_CONSTASCII_USTRINGPARAM("_blank" ) ),
						 getURL(), _aReferer, sal_False );
		}
		
		else if (rPath.compareToAscii( "Save" ) == 0)
			execCmd( NULL, OLECMDID_SAVE );
		else if (rPath.compareToAscii( "SaveAs" ) == 0)
			execCmd( NULL, OLECMDID_SAVEAS );
		else if (rPath.compareToAscii( "PageSetup" ) == 0)
			execCmd( NULL, OLECMDID_PAGESETUP );
		else if (rPath.compareToAscii( "Print" ) == 0)
			execCmd( NULL, OLECMDID_PRINT );
		else if (rPath.compareToAscii( "PrintDefault" ) == 0) // sollte auf "sofortiges" Drucken geaendert werden
			execCmd( NULL, OLECMDID_PRINT );
		else if (rPath.compareToAscii( "Properties" ) == 0)
			execCmd( NULL, OLECMDID_PROPERTIES );
		else if (rPath.compareToAscii( "Cut" ) == 0)
			execCmd( NULL, OLECMDID_CUT );
		else if (rPath.compareToAscii( "Copy" ) == 0)
			execCmd( NULL, OLECMDID_COPY );
		else if (rPath.compareToAscii( "Paste" ) == 0)
			execCmd( NULL, OLECMDID_PASTE );
		else if (rPath.compareToAscii( "SelectAll" ) == 0)
			execCmd( NULL, OLECMDID_SELECTALL );
		else if (rPath.compareToAscii( "SearchDialog" ) == 0) // eigener Men"upunkt
			execCmd( &CGID_MSHTML, IDM_FIND );
		else if (rPath.compareToAscii( "SourceView" ) == 0)
			execCmd( &CGID_MSHTML, IDM_VIEWSOURCE );
//  		else if (rPath.compareToAscii( "Offline" ) == 0)	// toggle offline status
//  		{
//  			put_GlobalOffline( !get_GlobalOffline() );
//  			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Offline") ),
//  		get_GlobalOffline(), sal_True );
//  		}
//  		else if (rPath.compareToAscii( "JavaConsole" ) == 0)
//  		{
//  		}

		else
			OSL_ENSHURE( sal_False, "### unknown command URL!" );
	}
	else
	{
		OSL_ENSHURE( sal_False,"### dispatch() unexpected URL! => navigating" );
		navigate( rURL.Complete, rArgs );
	}
}

//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::fireCommandStatus( const OUString & rCommand, sal_Bool bEnabled, sal_Bool bCheckedItem )const
{
	URL aURL;
	aURL.Protocol		= OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:") );
	aURL.Path			= rCommand;

	FeatureStateEvent aStatusEvent;
	aStatusEvent.Source		    = (XDispatch *)this;
	aURL.Complete				= (OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:") ) += rCommand).getStr();
	aStatusEvent.FeatureURL		= aURL;
	aStatusEvent.IsEnabled		= (bCheckedItem || bEnabled);
	aStatusEvent.Requery		= sal_False;

	// wenn es ein CheckedItem ist, dann wird bEnabled als Haekchenstatus genommen
	// Status als bool impliziert ein CheckedItem
	if (bCheckedItem)
		aStatusEvent.State.setValue( &bEnabled, ::getCppuBooleanType() );

	typedef map< Reference<XStatusListener>, StatusDispatch >::const_iterator IT;
	for( IT iter= _aStatusListeners.begin(); iter != _aStatusListeners.end(); ++iter )
	{
		if( iter->second.aURL.Path == rCommand )
			iter->second.xListener->statusChanged( aStatusEvent );
	}
}
//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::fireCommandStatus( const OUString & rCommand, const OUString & rOptText ) const
{
	URL aURL;
	aURL.Protocol		= OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:") );
	aURL.Path			= rCommand;

	FeatureStateEvent aStatusEvent;
	aStatusEvent.Source		    = (XDispatch *)this;
	aURL.Complete				= (OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:") ) += rCommand).getStr();
	aStatusEvent.FeatureURL		= aURL;
	aStatusEvent.IsEnabled		= sal_True;
	aStatusEvent.Requery		= sal_False;
	aStatusEvent.State <<= rOptText;

	typedef map< Reference<XStatusListener>, StatusDispatch >::const_iterator IT;
	for( IT iter= _aStatusListeners.begin(); iter != _aStatusListeners.end(); ++iter )
	{
		if( iter->second.aURL.Path == rCommand )
			iter->second.xListener->statusChanged( aStatusEvent );
	}

}

//##################################################################################################
//#### XModel ######################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::attachResource( const OUString & rURL, const Sequence<PropertyValue > & rArgs )
	throw (RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return sal_False;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::connectController( const Reference<XController> & xController )
	throw (RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::disconnectController( const Reference<XController> & xController )
	throw (RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
}
//__________________________________________________________________________________________________
OUString IExplorerController_Impl::getURL(void)
	throw (RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return getURL( _pIWebBrowser2 );
}
//--------------------------------------------------------------------------------------------------
OUString IExplorerController_Impl::getURL( IWebBrowser2 * pWebBrowser )
{
	BSTR zURL = NULL;
	if (pWebBrowser && SUCCEEDED(pWebBrowser->get_LocationURL( &zURL )) && zURL)
	{
		OUString aRet( zURL );
		::SysFreeString( zURL );
		return correctURL( aRet );
	}
	OSL_ENSHURE(sal_False, "### cannot retrieve current url!" );
	return OUString();
}
//--------------------------------------------------------------------------------------------------
OUString & IExplorerController_Impl::correctURL( OUString & rURL )
{
	sal_Int32 nPos;
	if (rURL.search( OUString( RTL_CONSTASCII_USTRINGPARAM("res://") ) ) == 0 &&
		(nPos = rURL.search( OUString( RTL_CONSTASCII_USTRINGPARAM("#http://") ) )) >= 0)
	{
		// extract error url
		rURL = rURL.copy( nPos + 1, rURL.len() - nPos - 2 ); // skip last '/'
	}
	else if (rURL.search( OUString( RTL_CONSTASCII_USTRINGPARAM("file://") ) ) == 0 &&
			 rURL.len() > 8 && rURL[7] != '/' && rURL[8] != '|')
	{
		// insert two more '/' for non local file url
		rURL = OUString( RTL_CONSTASCII_USTRINGPARAM("file:////") ) + rURL.copy( 7 );
	}
	return rURL;
}
//__________________________________________________________________________________________________
Sequence< com::sun::star::beans::PropertyValue > IExplorerController_Impl::getArgs(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return _aArgs;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::lockControllers(  ) throw(RuntimeException) 
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::unlockControllers(  ) throw(RuntimeException) 
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
}
//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::hasControllersLocked(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return sal_False;
}
//__________________________________________________________________________________________________
Reference<XController > IExplorerController_Impl::getCurrentController(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return (XController *)this;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::setCurrentController( const Reference< XController >& xController ) throw(NoSuchElementException, RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	OSL_ENSHURE( sal_False,"### controller cannot be set!" );
}
//__________________________________________________________________________________________________
Reference< XInterface > IExplorerController_Impl::getCurrentSelection(  ) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	return Reference<XInterface>();
}

//##################################################################################################
//#### XScreenCursor ###############################################################################
//##################################################################################################

//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::screenDown(void) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	OSL_ENSHURE( _pWBContainer, "### no olecontainer!" );
	return (_pWBContainer ? _pWBContainer->scrollScreen( sal_True ) : sal_False);
}
//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::screenUp(void) throw(RuntimeException)
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	OSL_ENSHURE( _pWBContainer, "### no olecontainer!" );
	return (_pWBContainer ? _pWBContainer->scrollScreen( sal_False ) : sal_False);
}

//##################################################################################################
//#### XStorable ###################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::hasLocation(void) throw(RuntimeException)
{
	OUString aLoc( getLocation() );
	return aLoc.len() > 0;
}
//__________________________________________________________________________________________________
OUString IExplorerController_Impl::getLocation(void)throw(RuntimeException)
{
	OUString aRet;
	IPersistFile * pFile = getIPersistFile();
	if (pFile)
	{
		LPOLESTR pStr;
		if (SUCCEEDED(pFile->GetCurFile( &pStr )))
		{
			aRet.operator=( pStr );
			IMalloc * pMalloc;
			if (SUCCEEDED(::CoGetMalloc( 1, &pMalloc )))
			{
				pMalloc->Free( pStr );
				pMalloc->Release();
			}
		}
		pFile->Release();
	}
	return aRet;
}
//__________________________________________________________________________________________________
sal_Bool IExplorerController_Impl::isReadonly(void) throw(RuntimeException)
{
	return sal_True;
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::store(void) throw( IOException,RuntimeException)
{
	OUString aLoc( getLocation() );
	if (aLoc.getLength() > 0)
	{
		IPersistFile * pFile = getIPersistFile();
		if (pFile)
		{
			if (SUCCEEDED(pFile->Save( NULL, sal_True )))
				pFile->SaveCompleted( aLoc.getStr() );
			pFile->Release();
		}
	}
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::storeAsURL( const OUString & rURL, const Sequence<PropertyValue >& rArgs )
		throw( IOException,RuntimeException)
{
	OUString aFileName;
	if (parseFileNameFromURL( rURL, aFileName ))
	{
		IPersistFile * pFile = getIPersistFile();
		if (pFile)
		{
			if (SUCCEEDED(pFile->Save( aFileName.getStr(), sal_True )))
				pFile->SaveCompleted( aFileName.getStr() );
			pFile->Release();
		}
	}
}
//__________________________________________________________________________________________________
void IExplorerController_Impl::storeToURL( const OUString & rURL, const Sequence<PropertyValue >& rArgs )
	throw( IOException,RuntimeException)
{
	OUString aFileName;
	if (parseFileNameFromURL( rURL, aFileName ))
	{
		IPersistFile * pFile = getIPersistFile();
		if (pFile)
		{
			pFile->Save( aFileName.getStr(), sal_False );
			pFile->Release();
		}
	}
}
//--------------------------------------------------------------------------------------------------
IPersistFile * IExplorerController_Impl::getIPersistFile(void) const
{
	IPersistFile * pFile = NULL;
	IDispatch * pDisp;
	if (_pIWebBrowser2 && SUCCEEDED(_pIWebBrowser2->get_Document( &pDisp )) && pDisp)
	{
		pDisp->QueryInterface( IID_IPersistFile, (void **)&pFile );
		pDisp->Release();
	}
	OSL_ENSHURE( pFile, "### cannot retrieve IPersistFile from document!" );
	return pFile;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::parseFileNameFromURL( const OUString & rURL, OUString & rFileName )
{
	return _parseFileNameFromURL( rURL, rFileName);
}

//##################################################################################################
//#### XUnoTunnel ########################################################################################
//##################################################################################################

sal_Int64 IExplorerController_Impl::getSomething( const Sequence< sal_Int8 >& aIdentifier ) 
		throw(RuntimeException)
{
	if( aIdentifier.getLength() == 16
		&& 0 == rtl_compareMemory( getUnoTunnelId().getConstArray(), aIdentifier.getConstArray(), 16 ) )
	{
		return (sal_Int64)this;
	}
	return 0;
}
//##################################################################################################
//#### XWindowListener #############################################################################
//##################################################################################################
void IExplorerController_Impl::windowResized( const WindowEvent& e ) throw(RuntimeException)
{
	if( _xChildWin.is())
		_pWBContainer->setPosSize( 0, 0, e.Width, e.Height );
//		_xChildWin->setPosSize(0, 0, e.Width, e.Height, PosSize::SIZE );

}
void IExplorerController_Impl::windowMoved( const WindowEvent& e ) throw(RuntimeException)
{
}
void IExplorerController_Impl::windowShown( const EventObject& e ) throw(RuntimeException)
{
}
void IExplorerController_Impl::windowHidden( const EventObject& e ) throw(RuntimeException)
{
}



//##################################################################################################
//#### MISC ########################################################################################
//##################################################################################################

//--------------------------------------------------------------------------------------------------
Reference<XPropertySet> IExplorerController_Impl::getTaskProperties(void) const
{
	return ((_xFrame.is() && _xFrame->isTop())
			? Reference<XPropertySet>( _xFrame->getCreator(), UNO_QUERY )
			: Reference<XPropertySet>());
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::hasFocus(void) const
{
//	return (_pChildWin && _pChildWin->HasFocus());
	return sal_True;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::isDesktop(void) const
{
	Reference<XPropertySet> xProps( getTaskProperties() );
	sal_Bool val;
	xProps->getPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("IsDesktop") ) ) >>= val;
	return xProps.is() && val;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::isTopLevel( IWebBrowser2 * pTestWB ) const
{
	OSL_ENSHURE( pTestWB && _pIWebBrowser2, "### haaarrgghh: null pointer attack!" );
	
	// get_TopLevelContainer() does not function right, always returns false!

	sal_Bool bRet = sal_False;
	
	IUnknown * pTestUnk;
	if (pTestWB && SUCCEEDED(pTestWB->QueryInterface( IID_IUnknown, (void **)&pTestUnk )) && pTestUnk)
	{
		IUnknown * pTopUnk;
		if (_pIWebBrowser2 && SUCCEEDED(_pIWebBrowser2->QueryInterface( IID_IUnknown, (void **)&pTopUnk)) && pTopUnk)
		{
			bRet = (pTopUnk == pTestUnk);
			pTopUnk->Release();
		}
		pTestUnk->Release();
	}
	
	return bRet;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::targetFrameIsTopLevel( IWebBrowser2 * pSourceFrameWB,
													  const OUString & rTargetFrameName ) const
{
	OSL_ENSHURE( pSourceFrameWB, "### illegal WB!" );

	sal_Bool bTargetFrameIsTop = sal_False;

	if (isTopLevel( pSourceFrameWB ))
	{
		bTargetFrameIsTop = (rTargetFrameName.compareToAscii( "_top" ) == 0	||
							 rTargetFrameName.compareToAscii( "_parent" ) == 0	||
							 // "", _self, same name
							 rTargetFrameName.compareToAscii( "_self" ) == 0	||
							 !rTargetFrameName.len()		||
							 rTargetFrameName == _xFrame->getName());
	}
	else
	{
		bTargetFrameIsTop = (rTargetFrameName.compareToAscii( "_top" ) == 0	||
							 rTargetFrameName.compareToAscii( "_parent" ) == 0	|| // wischiewaschie
							 // or must have exactly same name != "" ("" means _SAME_ frame!)
							 (rTargetFrameName.len() && rTargetFrameName == _xFrame->getName()));
		// !!! currently wischiewaschie test if [_parent] >= _xFrame->getName()
	}
	
	return bTargetFrameIsTop;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::hasDocument( IWebBrowser2 * pWB )
{
	OSL_ENSHURE( pWB, "### illegal WB!" );
	IDispatch * pDoc = NULL;
	return (pWB && SUCCEEDED(pWB->get_Document( &pDoc )) && pDoc && pDoc->Release());
}


// XUnoTunnel -------------------------------------------------------------------------------------
// generate a uniqueId
const Sequence< sal_Int8 > & IExplorerController_Impl::getUnoTunnelId()
{
    static Sequence< sal_Int8 > * pSeq = 0;
    if( !pSeq )
    {
        MutexGuard aGuard( Mutex::getGlobalMutex() );
        if( !pSeq )
        {
            static Sequence< sal_Int8 > aSeq( 16 );
            rtl_createUuid( (sal_uInt8*)aSeq.getArray(), 0, sal_True );
			pSeq= & aSeq;
        }

    }
    return *pSeq;
}



