/*************************************************************************
 *
 *  $RCSfile: idisp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <docobj.h>
#include <wininet.h>
#if _MSC_VER < 1200
#include <wtypes.h>
#include "msdev6.inc/exmisc.hxx"
#include "msdev6.inc/exdispid.h"
#include "msdev6.inc/mshtmcid.h"
#else
#include <exdisp.h>
#include <exdispid.h>
#include <mshtmcid.h>
#include <mshtmhst.h>
#endif

//#include <tools/debug.hxx>
#include <osl/socket.h>
//#include <vcl/stdtext.hxx>
//#include <sfx2/urltrans.hxx>

//#include <tools/urlobj.hxx>
//#include <usr/services.hxx>

#ifndef _COM_SUN_STAR_AWT_POINT_HPP_
#include <com/sun/star/awt/Point.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XTASKSSUPPLIER_HPP_
#include <com/sun/star/frame/XTasksSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDESKTOPTASK_HPP_
#include <com/sun/star/frame/XDesktopTask.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_WINDOWARRANGE_HPP_
#include <com/sun/star/frame/WindowArrange.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_TERMINATIONVETOEXCEPTION_HPP_
#include <com/sun/star/frame/TerminationVetoException.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XTERMINATELISTENER_HPP_
#include <com/sun/star/frame/XTerminateListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XWINDOWARRANGER_HPP_
#include <com/sun/star/frame/XWindowArranger.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XTASK_HPP_
#include <com/sun/star/frame/XTask.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFILTERDETECT_HPP_
#include <com/sun/star/frame/XFilterDetect.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#include <osl/diagnose.h>
#include "metric.hxx"
//#include <ie/iewebb.hxx>
#include <ie/ctrl.hxx>

using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace com::sun::star::frame;
using namespace com::sun::star::beans;
using namespace com::sun::star::util;
using namespace com::sun::star::awt;
//#include <iectrl.hxx>

extern "C" const GUID CGID_MSHTML; // ????

void _showServiceNotAvailableError( void* pParent, OUString& name, sal_Bool error);

// helper macros
#define SETDISPPARAMS(dp, numArgs, pvArgs, numNamed, pNamed)	\
	{	\
		(dp).cArgs				= numArgs;		\
		(dp).rgvarg				= pvArgs;		\
		(dp).cNamedArgs			= numNamed;		\
		(dp).rgdispidNamedArgs	= pNamed;		\
	}

#define SETNOPARAMS(dp) SETDISPPARAMS(dp, 0, NULL, NULL)
//

//##################################################################################################
//#### IUnknown ####################################################################################
//##################################################################################################

//__________________________________________________________________________________________________
STDMETHODIMP IExplorerController_Impl::QueryInterface( THIS_ REFIID riid, LPVOID FAR * ppvObj )
{
	if (::IsEqualIID( riid, IID_IDispatch )		||
		::IsEqualIID( riid, IID_IUnknown )		||
		::IsEqualIID( riid, DIID_DWebBrowserEvents2 ))
	{
		AddRef();
		*ppvObj = (IDispatch *)this;
	}
	else
		*ppvObj = NULL;

	return *ppvObj ? S_OK : E_NOINTERFACE;
}
//__________________________________________________________________________________________________
STDMETHODIMP_(ULONG) IExplorerController_Impl::AddRef(VOID)
{
//	OWeakObject::acquire();
//	return OWeakObject::m_refCount.referenced();
	acquire();
//	return cppu::OWeakObject::m_refCount;
//	return 1;
//	return ::cppu::WeakImplHelper8<XUnoTunnel,
//								XDispatch,
//								XDispatchProvider, 
//								XFrameActionListener, 
//								XController, 
//								XModel, 
//								XStorable, 
//								::com::sun::star::view::XScreenCursor>::OWeakAggObject::m_refCount;
	return m_refCount;

}
//__________________________________________________________________________________________________
STDMETHODIMP_(ULONG) IExplorerController_Impl::Release(VOID)
{
//	UINT32 nRef = OWeakObject::m_refCount.referenced();
	sal_uInt32 nRef = OWeakObject::m_refCount;
	OWeakObject::release();
	return --nRef;
}

//##################################################################################################
//#### IDispatch ###################################################################################
//##################################################################################################
//__________________________________________________________________________________________________
STDMETHODIMP IExplorerController_Impl::GetIDsOfNames(
	REFIID riid, LPOLESTR FAR * rgszNames, UINT cNames, LCID lcid, DISPID FAR * rgdispid )
{
	return E_NOTIMPL;
}
//__________________________________________________________________________________________________
STDMETHODIMP IExplorerController_Impl::GetTypeInfoCount( UINT FAR * pctinfo )
{
	return E_NOTIMPL;
}
//__________________________________________________________________________________________________
STDMETHODIMP IExplorerController_Impl::GetTypeInfo( UINT itinfo, LCID lcid,
													ITypeInfo FAR * FAR * pptinfo )
{
	return E_NOTIMPL;
}
//__________________________________________________________________________________________________
STDMETHODIMP IExplorerController_Impl::Invoke(
	DISPID           dispidMember,
	REFIID           riid,
	LCID             lcid,
	WORD             wFlags,
	DISPPARAMS FAR * pdispparams,
	VARIANT    FAR * pvarResult,
	EXCEPINFO  FAR * pExcepInfo,
	UINT       FAR * puArgErr )
{
	unsigned int uArgErr;
	HRESULT		 hresult;
	VARIANTARG	 varg;
	VARIANT		 varResultDummy;
	
	VARIANTARG * vargs = pdispparams->rgvarg;

    // Make sure the wFlags are valid.
	if (! (wFlags & DISPATCH_METHOD))
		return E_INVALIDARG;

	// This object only exposes a "default" interface.
	if (! IsEqualIID( riid, IID_NULL ))
		return DISP_E_UNKNOWNINTERFACE;

    // It simplifies the following code if the caller
    // ignores the return value.    if (puArgErr == NULL)
	puArgErr = &uArgErr;
	if (pvarResult == NULL)
		pvarResult = &varResultDummy;
	// Assume the return type is void, unless otherwise is found.
	::VariantInit( pvarResult );
	
    switch (dispidMember)
	{
	case DISPID_NEWWINDOW2:		// sent when a new window should be created
	{
		OSL_ENSHURE( (vargs[0].vt == (VT_BOOL | VT_BYREF)), "### unexpected parameter type!" );
		OSL_ENSHURE( (vargs[1].vt == (VT_DISPATCH | VT_BYREF)), "### unexpected parameter type!" );
		
		sal_Bool bCancel = sal_True;

		// load empty explorer component in new Frame, return IDispatch interface
		// !!! could be wrong referrer !!!
		Reference<XComponent> xComponent( loadComponentFromURL(m_multiServiceFactory, OUString::createFromAscii("private:iexplorer"), getURL() /*referrer*/ ) );
		
		IWebBrowser2 * pIWebBrowser2;
		IExplorerController_Impl * pController;
		Reference<XUnoTunnel> aTunnel( xComponent, UNO_QUERY);

		if (xComponent.is() && aTunnel.is() && (pController= (IExplorerController_Impl*)aTunnel->getSomething( getUnoTunnelId())))	

//			(pController = (IExplorerController_Impl *)xComponent->getImplementation( IExplorerController_Impl_getReflection() )) &&
//			SUCCEEDED(pController->get_WebBrowser( &pIWebBrowser2 )) && pIWebBrowser2)
		{
			if( SUCCEEDED( pController->get_WebBrowser( &pIWebBrowser2)))
			{
				bCancel = FAILED(pIWebBrowser2->QueryInterface(
					IID_IDispatch, (void **)V_DISPATCHREF( &vargs[1] ) ));
				pIWebBrowser2->Release();
			}
		}
		*V_BOOLREF( &vargs[0] ) = bCancel;
	}
	break;

	case DISPID_COMMANDSTATECHANGE:		// command states; +toolbar
	{
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 0, VT_I4, &varg, puArgErr )))
			return hresult;
		CommandStateChangeConstants nVal = (CommandStateChangeConstants)V_I4( &varg );
		::VariantClear( &varg );
		
		if (nVal == CSC_NAVIGATEFORWARD)
		{
			::VariantInit( &varg );
			if (FAILED(hresult = DispGetParam( pdispparams, 1, VT_BOOL, &varg, puArgErr )))
				return hresult;
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("BrowseForward") ), V_BOOL( &varg ) );
			::VariantClear( &varg );
		}
		else if (nVal == CSC_NAVIGATEBACK)
		{
			::VariantInit( &varg );
			if (FAILED(hresult = DispGetParam( pdispparams, 1, VT_BOOL, &varg, puArgErr )))
				return hresult;
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("BrowseBackward") ), V_BOOL( &varg ) );
			::VariantClear( &varg );
		}
		else if (nVal == CSC_UPDATECOMMANDS)	// other commands
		{
			sal_Bool bSaveAsStatus = queryCmdStatus( NULL, OLECMDID_SAVEAS );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("SaveAs") ), bSaveAsStatus );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("EditDoc") ), bSaveAsStatus );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Save") ), queryCmdStatus( NULL, OLECMDID_SAVE ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("PageSetup") ), queryCmdStatus( NULL, OLECMDID_PAGESETUP ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Print") ), queryCmdStatus( NULL, OLECMDID_PRINT ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("PrintDefault") ), queryCmdStatus( NULL, OLECMDID_PRINT ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Properties") ), queryCmdStatus( NULL, OLECMDID_PROPERTIES ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cut") ), queryCmdStatus( NULL, OLECMDID_CUT ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Copy") ), queryCmdStatus( NULL, OLECMDID_COPY ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Paste") ), queryCmdStatus( NULL, OLECMDID_PASTE ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("SelectAll") ), queryCmdStatus( NULL, OLECMDID_SELECTALL ) );
			//
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Reload") ), queryCmdStatus( &CGID_MSHTML, IDM_REFRESH ) ); // hmm?
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("SearchDialog") ), queryCmdStatus( &CGID_MSHTML, IDM_FIND ) );
			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("SourceView") ), queryCmdStatus( &CGID_MSHTML, IDM_VIEWSOURCE ) );

//  			// Offline state has to be polled, so if this does not catch most Offline status
//  			// changes, it might be better to fire current Offline state on each invoke()...
//  			fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Offline") ), get_GlobalOffline(), sal_True );
			updateDummySocket();
		}
	}
	break;

	case DISPID_PROPERTYCHANGE:			// sent when the PutProperty method is called
		// properties only changed on InternetExplorer object...
	break;

	// ==== Progress and Status Indication ====
	case DISPID_DOWNLOADBEGIN:
	{
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cancel") ), sal_True );
		_xStatusIndicator->start( _aCurrentStatusText, 1000 );
		_xStatusIndicator->setValue( 0 );
	}
	break;
	case DISPID_DOWNLOADCOMPLETE:		// download complete => stop progress indication
	{
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cancel") ), sal_False );
		_xStatusIndicator->end();
		_xStatusIndicator->reset();
	}
	break;
	case DISPID_STATUSTEXTCHANGE:
	{
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 0, VT_BSTR, &varg, puArgErr )))
			return hresult;
		_aCurrentStatusText = OUString( V_BSTR( &varg ) );
		::VariantClear( &varg );

		_xStatusIndicator->setText( _aCurrentStatusText );
	}
	break;
	case DISPID_PROGRESSCHANGE:			// sent when download progress is updated
	{
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 0, VT_I4, &varg, puArgErr )))
			return hresult;
		LONG nProgress = V_I4( &varg );
		::VariantClear( &varg );

		float fPercentage = 1.0;
		if (nProgress >= 0)
		{
			::VariantInit( &varg );
			if (FAILED(hresult = DispGetParam( pdispparams, 1, VT_I4, &varg, puArgErr )))
				return hresult;
			LONG nProgressMax = V_I4( &varg );
			::VariantClear( &varg );
			
			if (nProgressMax > nProgress)
				fPercentage = ((float)nProgress) / nProgressMax;
		}
		_xStatusIndicator->setValue( fPercentage * 1000 );
	}
	break;

	case DISPID_TITLECHANGE:	// sent when the document title changes
	{
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 0, VT_BSTR, &varg, puArgErr )))
			return hresult;
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Title") ), OUString( V_BSTR( &varg ) ) );
		::VariantClear( &varg );
	}
	break;

	case DISPID_NAVIGATECOMPLETE2:
	{// UIActivate new document; in async, this is sent when we have enough to show
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 1, VT_BSTR, &varg, puArgErr )))
			return hresult;
		OUString aURL( V_BSTR( &varg ) );
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("CurrentURL") ), correctURL( aURL ) );
		::VariantClear( &varg );
	}
	break;

	case DISPID_BEFORENAVIGATE2:
	{// this is sent before navigation to give a chance to abort; hyperlink clicked on

		// cancel flag
		OSL_ENSHURE( (vargs[0].vt == (VT_BOOL | VT_BYREF)), "### unexpected parameter type!" );
		sal_Bool bCancel = sal_False;

		// url to navigate to
		::VariantInit( &varg );
		if (FAILED(hresult = DispGetParam( pdispparams, 1, VT_BSTR, &varg, puArgErr )))
			return hresult;
		OUString aDestURL( V_BSTR( &varg ) );
		correctURL( aDestURL );
		::VariantClear( &varg );
		
		// optional target frame name to navigate to
		::VariantInit( &varg );
		OUString aTargetFrame;
		if (SUCCEEDED(DispGetParam( pdispparams, 3, VT_BSTR, &varg, puArgErr )))
			aTargetFrame = OUString( V_BSTR( &varg ) );
		::VariantClear( &varg );

		// current wb object
		OSL_ENSHURE( (vargs[6].vt == VT_DISPATCH), "### unexpected parameter type!" );
		IWebBrowser2 * pCurrentWB = NULL;
		IDispatch * pWBDisp = V_DISPATCH( &vargs[6] );
		if (!pWBDisp || FAILED(hresult = pWBDisp->QueryInterface( IID_IWebBrowser2, (void **)&pCurrentWB)) || !pCurrentWB)
			return hresult;

		sal_Bool bFrameHasDocument   = hasDocument( pCurrentWB );
		sal_Bool bSOFrameHasDocument = hasDocument( _pIWebBrowser2 );

		// check desktop
		if (bFrameHasDocument && // not on first desktop load
			isDesktop())
		{
			// load in SO frame if target frame is top level
			bCancel = targetFrameIsTopLevel( pCurrentWB, aTargetFrame );
		}
		
		if (! bCancel) // check url
		{
			Reference<XFilterDetect> xDetect( _xFrame, UNO_QUERY );
			bCancel = (xDetect.is() && !xDetect->useExternBrowser( aDestURL ));
		}
		
		if (bCancel) // load url in _new_ frame or recycle
		{
			bCancel = dispatchURL( m_multiServiceFactory,_xFrame,
								   (bSOFrameHasDocument ? OUString( RTL_CONSTASCII_USTRINGPARAM("_blank") ) : OUString()),
								   aDestURL, getURL( pCurrentWB ) /*referrer*/ );
		}

		if (_bFirstFrame && _xChildWin.is())
		{
			_xChildWin->setVisible( !bCancel );
			_bFirstFrame = sal_False;
		}
		
		// SO frame referer correction load in new top level frame => EditDoc
		if (!bCancel && bSOFrameHasDocument &&
			targetFrameIsTopLevel( pCurrentWB, aTargetFrame ))
		{
			_aReferer = getURL();
		}
		
		pCurrentWB->Release();
		
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cancel") ), !bCancel );
		*V_BOOLREF( &vargs[0] ) = bCancel;
	}
	break;

	case DISPID_DOCUMENTCOMPLETE:   // new document goes ReadyState_Complete
		break;
	case DISPID_ONVISIBLE:		// sent when the window goes visible/hidden
		break;
		
// ==== deprecated ====
	case DISPID_BEFORENAVIGATE:
	case DISPID_FRAMEBEFORENAVIGATE:
	case DISPID_NAVIGATECOMPLETE:
	case DISPID_NEWWINDOW:
	case DISPID_FRAMENAVIGATECOMPLETE:
	case DISPID_FRAMENEWWINDOW:
		OSL_ENSHURE( sal_False, "### IE deprecated events received!" );
		break;
	}
	
	return S_OK;
}

//##################################################################################################
//#### WBContainer #################################################################################
//##################################################################################################

//--------------------------------------------------------------------------------------------------
// called on scripting window.close => wndproc of ole container
void IExplorerController_Impl::shutdown(void)
{
	if (! _bIsDisposed)
	{
		OSL_ENSHURE( _xFrame.is(), "### no frame!" );
		Reference<XTask> xTask( _xFrame->getCreator(), UNO_QUERY );
		
		OSL_ENSHURE( xTask.is(), "### no task which is creator of frame!" );
		if (xTask.is())
			xTask->close();
	}
}
//--------------------------------------------------------------------------------------------------
// called in response to IOleInplaceSite::OnPosRectChange()
void IExplorerController_Impl::setPosSize( long nX, long nY, long nWidth, long nHeight )
{
	Reference<XPropertySet> xProps( getTaskProperties() );
	if (xProps.is())
	{
		Any aVal;
		aVal <<= sal_True ;
		xProps->setPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("IsFloating") ), aVal );

		Point aPos;
		Any aAny( xProps->getPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("Position") ) ) );
		if (aAny.getValue())
			aAny >>= aPos;
		if (nX >= 0)
			aPos.X=  nX;
		if (nY >= 0)
			aPos.Y= nY ;

//		aAny.setValue( &aPos, Point_getReflection() );
		aAny <<= aPos;
		xProps->setPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("Position") ), aAny );

		Size aSize;
		aAny = xProps->getPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("Size") ) );
		if (aAny.getValue())
			aAny >>=aSize; 
		if (nWidth > 0)
			aSize.Width= nWidth ;
		if (nHeight > 0)
			aSize.Height= nHeight ;
		
//		aAny.setValue( &aSize, Size_getReflection() );
		aAny <<= aSize;
		xProps->setPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("Size") ), aAny );
	}
}
//--------------------------------------------------------------------------------------------------
// only called on ole container
sal_Bool IExplorerController_Impl::scrollScreen( sal_Bool bDown )
{
	OSL_ENSHURE( sal_False, "### unexpected call: IExplorerController_Impl::scrollBy()!" );
	return sal_False;
}
//--------------------------------------------------------------------------------------------------
// only called on ole container
void IExplorerController_Impl::activate(void)
{
	OSL_ENSHURE( sal_False ,"### unexpected call: IExplorerController_Impl::activate()!" );
}
//--------------------------------------------------------------------------------------------------
// only called on ole container
void IExplorerController_Impl::deactivate(void)
{
	OSL_ENSHURE( sal_False,"### unexpected call: IExplorerController_Impl::deactivate()!" );
}
//--------------------------------------------------------------------------------------------------
// called on newly created Component to obtain IWebBrowser2 interface
HRESULT IExplorerController_Impl::get_WebBrowser( IWebBrowser2 ** ppWB )
{
	OSL_ENSHURE( _pWBContainer && ppWB, "### no olecontainer or null pointer !" );

	HRESULT hr= E_FAIL;
	if( _pIWebBrowser2 )
	{
		*ppWB = _pIWebBrowser2;
		_pIWebBrowser2->AddRef();
		hr= S_OK;
	}
	return hr;
}

//##################################################################################################
//#### MISC ########################################################################################
//##################################################################################################

//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::navigate( const OUString & rURL, const Sequence<PropertyValue > & rArgs )
{
	OSL_ENSHURE( !_bIsDisposed, "### component was already disposed!" );
	
	OSL_ENSHURE( _pIWebBrowser2, "### no IWebBrowser2 interface!" );
	if (! _pIWebBrowser2)
		return sal_False;
	
	// save args
	_aArgs = rArgs;
	
	_aCurrentStatusText = OUString();
	fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cancel") ), sal_True );
	
	BSTR zURL = ::SysAllocString( rURL.getStr() );
	VARIANT * pvPostData = NULL;
	
	// extract PostString/ PostData
	const PropertyValue * pProps = _aArgs.getConstArray();
	for ( sal_uInt32 nPos = _aArgs.getLength(); nPos--; )
	{
		const PropertyValue & rProp = pProps[nPos];
		if (rProp.Name == OUString( RTL_CONSTASCII_USTRINGPARAM("PostData") ))
		{
			// source data
			const Sequence<sal_uInt8 > & rBytes = *(const Sequence<sal_uInt8 > *)rProp.Value.getValue();
			const sal_uInt8 * pData = rBytes.getConstArray();
			sal_uInt32 nLen = rBytes.getLength();

			sal_uInt8 * pDest;
			// init variant safearray and copy data
			::VariantInit( pvPostData = new VARIANT() );
			pvPostData->vt = VT_ARRAY;
			
			if (SUCCEEDED(::SafeArrayAccessData(
				V_ARRAY( pvPostData ) = ::SafeArrayCreateVector( VT_UI1, 0, nLen ), (void **)&pDest )))
			{
				for ( ; nLen--; )
					pDest[nLen] = pData[nLen];
				::SafeArrayUnaccessData( V_ARRAY( pvPostData ) );
			}
			break;
		}
		else if (rProp.Name == OUString( RTL_CONSTASCII_USTRINGPARAM("PostString") ))
		{
			// source data
			OString aStr( OUStringToOString( *(OUString*)rProp.Value.getValue(), RTL_TEXTENCODING_ISO_8859_1 ) );

			const char * pData = aStr.getStr();
			sal_uInt32 nLen = aStr.getLength();

			sal_uInt8 * pDest;
			// init variant safearray and copy data
			::VariantInit( pvPostData = new VARIANT() );
			pvPostData->vt = VT_ARRAY;
			
			if (SUCCEEDED(::SafeArrayAccessData(
				V_ARRAY( pvPostData ) = ::SafeArrayCreateVector( VT_UI1, 0, nLen ), (void **)&pDest )))
			{
				for ( ; nLen--; )
					pDest[nLen] = pData[nLen];
				::SafeArrayUnaccessData( V_ARRAY( pvPostData ) );
			}
			break;
		}
	}
	
	_bFirstFrame = sal_True;
	
	sal_Bool bRet = SUCCEEDED(_pIWebBrowser2->Navigate( zURL, NULL, NULL, pvPostData, NULL ));
	OSL_ENSHURE( bRet, "### IWebBrowser2::Navigate() failed!" );

	// release all call data
	if (pvPostData)
	{
		::VariantClear( pvPostData );
		delete pvPostData;
	}
	::SysFreeString( zURL );

	return bRet;
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::stop(void) const
{
	sal_Bool bRet = sal_False;
	
	OSL_ENSHURE( _pIWebBrowser2, "### no IWebBrowser2 interface!" );
	if (_pIWebBrowser2)
	{
		bRet = SUCCEEDED(_pIWebBrowser2->Stop());
		fireCommandStatus( OUString( RTL_CONSTASCII_USTRINGPARAM("Cancel") ), sal_False );
	}
	OSL_ENSHURE( bRet, "### IWebBrowser2::Stop() failed!" );
	return bRet;
}

//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::execCmd( const GUID * pguidCmdGroup, DWORD nCmdId, sal_Bool bExecOnDocument ) const
{
	IUnknown * pUnk = _pIWebBrowser2;
	if (bExecOnDocument)
	{
		IDispatch * pDisp;
		if (_pIWebBrowser2 && SUCCEEDED(_pIWebBrowser2->get_Document( &pDisp )) && pDisp)
			pUnk = pDisp;
		else
			pUnk = NULL;
	}

	IOleCommandTarget * pOCT;
	if (pUnk && SUCCEEDED(pUnk->QueryInterface( IID_IOleCommandTarget, (void **)&pOCT )) && pOCT)
	{
		pOCT->Exec( pguidCmdGroup, nCmdId, OLECMDEXECOPT_DODEFAULT, NULL, NULL );
		pOCT->Release();
	}
#if DEBUG
	else
		OSL_ENSHURE( sal_False, "### execCmd(): cannot QI IID_IOleCommandTarget!" );
#endif
}
//--------------------------------------------------------------------------------------------------
sal_Bool IExplorerController_Impl::queryCmdStatus( const GUID * pguidCmdGroup, DWORD nCMDID, sal_Bool bQueryOnDocument ) const
{
	IUnknown * pUnk = _pIWebBrowser2;
	if (bQueryOnDocument)
	{
		IDispatch * pDisp;
		if (!_pIWebBrowser2 || FAILED(_pIWebBrowser2->get_Document( &pDisp )))
		{
			OSL_ENSHURE( sal_False, "### queryCmd() failed!" );
			return sal_False;
		}
		pUnk = pDisp;
	}
	
	sal_Bool bRet = sal_False;
	IOleCommandTarget * pOCT;
	if (pUnk && SUCCEEDED(pUnk->QueryInterface( IID_IOleCommandTarget, (void **)&pOCT )))
	{
		OLECMD aOLECMD;
		aOLECMD.cmdID = nCMDID;
		if (SUCCEEDED(pOCT->QueryStatus( pguidCmdGroup, 1, &aOLECMD, NULL )))
		{
			bRet = ((aOLECMD.cmdf & OLECMDF_SUPPORTED) &&
					(aOLECMD.cmdf & (OLECMDF_LATCHED | OLECMDF_ENABLED)));
		}
		pOCT->Release();
	}
	return bRet;
}

//==================================================================================================
sal_Int32		IExplorerController_Impl::s_nOpenBrowsers    = 0;
oslSocket	IExplorerController_Impl::s_hDummySocket	 = NULL;

//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::holdDummySocket(void)
{
	if (! s_hDummySocket)
	{
		s_hDummySocket = osl_createSocket( osl_Socket_FamilyInet,
										   osl_Socket_TypeDgram,
										   osl_Socket_ProtocolIp );
		OSL_ENSHURE( s_hDummySocket, "### cannot create dummy socket!" );
	}
}
//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::releaseDummySocket(void)
{
	if (s_hDummySocket)
	{
		osl_destroySocket( s_hDummySocket );
		s_hDummySocket = NULL;
	}
}
//--------------------------------------------------------------------------------------------------
void IExplorerController_Impl::updateDummySocket(void)
{
	DWORD dwState = 0, dwSize = sizeof(DWORD);
	if (::InternetQueryOption( NULL, INTERNET_OPTION_CONNECTED_STATE, &dwState, &dwSize ))
	{
		if ((dwState & INTERNET_STATE_CONNECTED) != 0)
			holdDummySocket();
		else
			releaseDummySocket();
	}
}

//==================================================================================================
sal_Bool dispatchURL( Reference<XMultiServiceFactory> xFactory, const Reference<XFrame> & xFrame, const OUString & rTargetFrameName, const OUString & rURL,
					 const Sequence<PropertyValue > & rArgs )
{
	OSL_ENSHURE( xFrame.is(), "### no frame given!" );
	if (! xFrame.is())
		return sal_False;
	
//	Reference<XMultiServiceFactory> xFac( cppu::getProcessServiceManager() );
//	OSL_ENSHURE( xFactory.is(), "### cannot get process service manager!" );
	
	Reference<XURLTransformer> xTrans( xFactory->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.util.URLTransformer") ) ), UNO_QUERY );
	if (xTrans.is())
	{
		URL aURL;
		aURL.Complete = rURL;
		xTrans->parseStrict( aURL );

		Reference<XDispatchProvider> xDispatchProvider( xFrame, UNO_QUERY );
		OSL_ENSHURE( xDispatchProvider.is(), "### cannot get dispatch provider inteface!" );
		Reference<XDispatch> xDispatch( xDispatchProvider->queryDispatch( aURL, rTargetFrameName, 0) );
		OSL_ENSHURE( xDispatch.is(), "### cannot get dispatch interface!" );
		if (xDispatch.is())
		{
			xDispatch->dispatch( aURL, rArgs );
			return sal_True;
		}
	}
	else
//		ShowServiceNotAvailableError( NULL, "com.sun.star.util.URLTransformer", sal_True );
		_showServiceNotAvailableError( (void*) NULL, OUString::createFromAscii("com.sun.star.util.URLTransformer"), sal_True);

//=============================================================================================================
	
	return sal_False;
}

//==================================================================================================
sal_Bool dispatchURL( Reference<XMultiServiceFactory> xFactory,const Reference<XFrame> & xFrame, const OUString & rTargetFrameName, const OUString & rURL,
				  const OUString & rReferrer, sal_Bool bReadOnly )
{
	// !ReadOnly is optional!
	
	Sequence<PropertyValue > aProps( (bReadOnly ? 1 : 2) );
	PropertyValue * pProps = aProps.getArray();
	// Referrer
	pProps[0].Name = OUString::createFromAscii("Referer");
//	pProps[0].Value.setString( rReferrer );
	pProps[0].Value <<= rReferrer;
	if (! bReadOnly)
	{
		// ReadOnly
		pProps[1].Name = OUString::createFromAscii("ReadOnly");
//		pProps[1].Value.setsal_Bool( sal_False );
		pProps[1].Value <<= sal_False;
	} // else default behaviour for url
	
	return dispatchURL( xFactory, xFrame, rTargetFrameName, rURL, aProps );
}

//==================================================================================================
Reference<XComponent> loadComponentFromURL( Reference<XMultiServiceFactory> xFactory, 
										const OUString & rURL, const OUString & rReferrer )
{
//	Reference<XMultiServiceFactory> xFac( cppu::getProcessServiceManager() );
	OSL_ENSHURE( xFactory.is(), "### cannot get process service manager!" );

	Reference<XComponentLoader> xLoad( xFactory->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.frame.Desktop") ) ), UNO_QUERY );
	if (xLoad.is())
	{
		Sequence<PropertyValue > aProps( 1 );
		PropertyValue & rProp = *aProps.getArray();
		// Referrer
		rProp.Name = OUString::createFromAscii("Referer");
		rProp.Value <<= rReferrer;

		return xLoad->loadComponentFromURL( rURL, OUString::createFromAscii("_blank"), 0, aProps );
	}
	else
//		ShowServiceNotAvailableError( NULL, "com.sun.star.frame.Desktop", sal_True );
		_showServiceNotAvailableError( (void*) NULL, OUString::createFromAscii("com.sun.star.frame.Desktop"), sal_True);

//=============================================================================================================
	
	return Reference<XComponent>();
}



