/*************************************************************************
 *
 *  $RCSfile: other.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/* This file contains some code that needs vcl or tools headers.
	Those headers use old type declarations (data, interfaces). If
	they were included in e.g. ctrl.cxx  then all interfaces would
	had to be fully qualified.

*/	

#include <rtl/ustring.hxx>

#ifdef UDK
  #include <osl/diagnose.h>
#else
  #include <vcl/stdtext.hxx>
  #include <tools/resmgr.hxx>
  #include <tools/fsys.hxx>
  #include <tools/urlobj.hxx>
#endif


using namespace rtl;


void _showServiceNotAvailableError( void* pParent, OUString& name, sal_Bool error)
{
#ifdef UDK
	OSL_TRACE("service not available");
#else
	ShowServiceNotAvailableError( (Window*)pParent, name.getStr(), error );
#endif
}


OUString _getFileNameFromResMgr( OUString& resource)
{
#ifdef UDK
  return OUString();
#else
	static ResMgr * pResManager = NULL;
	if (! pResManager )
	{
		pResManager = ResMgr::CreateResMgr( OUStringToOString(resource.getStr(), RTL_TEXTENCODING_ISO_8859_1 ));
	}
	return pResManager->GetFileName();
#endif
}




OUString _getOUStringFromResId( int id)
{	
	return OUString::valueOf((sal_Int32)id);
}

OUString _getNameFromDirEntry( OUString fileName)
{
#ifdef UDK
  return OUString::createFromAscii("resource\\ie56801.res");
#else
	DirEntry aEntry( fileName );
	return aEntry.GetName();
#endif
}

sal_Bool _parseFileNameFromURL( const OUString & rURL, OUString & rFileName )
{
#ifdef UDK
	rFileName = rURL;
	return sal_True;
#else
	INetURLObject aURL( rURL.getStr() );
	if (aURL.GetProtocol() == INET_PROT_FILE)
	{
		rFileName =  aURL.GetFull().GetBuffer();
		return sal_True;
	}
	return sal_False;
#endif
}
