/*************************************************************************
 *
 *  $RCSfile: olecontr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:30:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//  #include <windows.h>
//  #include <windowsx.h>

//typedef unsigned short wchar_t;

#include <wchar.h>
#include <tchar.h>
#include <crtdbg.h>
#include <shlobj.h>
#include <docobj.h>
#include <servprov.h>
#include <exdisp.h>
#include <olectl.h>
#include <urlmon.h>
#include <stdio.h>
#include <wininet.h>
#include <exdisp.h>
#include <mshtml.h>
#include <mshtmhst.h>
#include <mshtmcid.h>
#include <mshtml.h>

#include <ie/olecontr.hxx>
#include <ie/ctrl.hxx>

#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif



#define CCHMAXURL           INTERNET_MAX_URL_LENGTH
#define NElems(a)  (sizeof a / sizeof a[0])

// move (translate) the rectangle by (dx, dy)
inline VOID MoveRect(LPRECT prc, int dx, int dy)
{
    prc->left	+= dx;
    prc->right	+= dx;
    prc->top	+= dy;
    prc->bottom	+= dy;
}

// debugging functions
#ifdef _DEBUG

#define _SIDE_ASSERT(b)     _ASSERT(b)
#define _SIDE_ASSERTE(b)    _ASSERTE(b)
#else
#define _SIDE_ASSERT(b)     (b)
#define _SIDE_ASSERTE(b)    (b)
#endif  // !_DEBUG

// macros used to reduce verbiage in RECT handling.
#define WIDTH(r)  ((r).right - (r).left)
#define HEIGHT(r) ((r).bottom - (r).top)

// max size for LoadString.
const ULONG MAX_ERR_STR_SIZE = 512;

// string constants
const WCHAR g_awchHostName[] = L"WebBrowser OC Container";
const WCHAR g_awchHTML[]	 = L"HTML";

//
static HINSTANCE s_hInstance = NULL;
//
Container_Impl* Container_Impl::s_pCurrentContainer	= NULL;
HHOOK Container_Impl::s_hAcceleratorHook			= NULL;
//


//=================================================================================================
BOOL APIENTRY DllMain( HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
  	{
  	case DLL_THREAD_ATTACH:
  	case DLL_THREAD_DETACH:
		break;
		
  	case DLL_PROCESS_ATTACH:
		s_hInstance = (HINSTANCE)hModule;

		Container_Impl::s_pCurrentContainer	= NULL;
		Container_Impl::s_hAcceleratorHook	= NULL;

		WNDCLASSEX wndclass;
		wndclass.cbSize			= sizeof(WNDCLASSEX);
		wndclass.style			= 0;
		wndclass.lpfnWndProc	= (WNDPROC)Container_Impl::WndProc;
		wndclass.cbClsExtra		= 0;
		wndclass.cbWndExtra		= 0;
		wndclass.hInstance		= s_hInstance;
		wndclass.hIcon			= ::LoadIcon( NULL, IDI_APPLICATION );
		wndclass.hCursor		= ::LoadCursor( NULL, IDC_ARROW );
		wndclass.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
		wndclass.lpszMenuName	= NULL;
		wndclass.lpszClassName	= _T("IE OleContainer Frame");
		wndclass.hIconSm		= NULL;
		::RegisterClassEx( &wndclass );
		break;
  	case DLL_PROCESS_DETACH:
		Container_Impl::s_pCurrentContainer = NULL;
		if (Container_Impl::s_hAcceleratorHook)
		{
			// deinitialize message queue
			::UnhookWindowsHookEx( Container_Impl::s_hAcceleratorHook );
			Container_Impl::s_hAcceleratorHook = NULL;
		}

		::UnregisterClass( _T("IE OleContainer Frame"), s_hInstance );
		break;
    }
	
	return TRUE;
}

//-------------------------------------------------------------------------------------------------
sal_Bool Container_Impl::scrollScreen( sal_Bool bDown )
{
	sal_Bool bRet = FALSE;
	long nViewHeight, nScrollHeight, nScrollTop;
	
	IDispatch * pDisp = NULL;
	if (_pIWebBrowser2 && SUCCEEDED(_pIWebBrowser2->get_Document( &pDisp )) && pDisp)
	{
		IHTMLDocument2 * pDoc = NULL;
		if (SUCCEEDED(pDisp->QueryInterface( IID_IHTMLDocument2, (void**)&pDoc )) && pDoc)
		{
			IHTMLElement * pBody = NULL;
			if (SUCCEEDED(pDoc->get_body( &pBody )) && pBody)
			{
				IHTMLTextContainer * pTextCont = NULL;
				if (SUCCEEDED(pBody->get_offsetHeight( & nViewHeight )) &&
					SUCCEEDED(pBody->QueryInterface( IID_IHTMLTextContainer, (void**)&pTextCont )) && pTextCont)
				{
					if (SUCCEEDED(pTextCont->get_scrollHeight( & nScrollHeight )) &&
						SUCCEEDED(pTextCont->get_scrollTop( & nScrollTop )))
					{
						long nScrollAmount = (nViewHeight > 20 ? (nViewHeight - 10) : nViewHeight);
						
						if (bDown)
						{
							if ((nScrollHeight - nScrollTop) > nViewHeight)
							{
								bRet = SUCCEEDED(pTextCont->put_scrollTop(
									nScrollTop + nScrollAmount ));
							}
						}
						else
						{
							if (nScrollTop > 0)
							{
								bRet = SUCCEEDED(pTextCont->put_scrollTop(
									nScrollTop < nViewHeight ? 0 : (nScrollTop - nScrollAmount) ));
							}
						}
					}
					pTextCont->Release();
				}
				pBody->Release();
			}
			pDoc->Release();
		}
		pDisp->Release();
	}
	return bRet;
}

//-------------------------------------------------------------------------------------------------
void Container_Impl::setPosSize( sal_Int32 nX, sal_Int32 nY, sal_Int32 nWidth, sal_Int32 nHeight )
{
	RECT aRECT;
	aRECT.left			   = nX;		// is 0
	aRECT.top			   = nY;		// is 0
	aRECT.right			   = nX + nWidth;
	aRECT.bottom		   = nY + nHeight;
	SetSize( &aRECT, TRUE );
}

//-------------------------------------------------------------------------------------------------
IWebBrowser2 * Container_Impl::getWebBrowser()
{
	if (_pIWebBrowser2)
	{
		_pIWebBrowser2->AddRef();
		return _pIWebBrowser2;
	}
	return 0;
}
//-------------------------------------------------------------------------------------------------
void Container_Impl::activate()
{
	s_pCurrentContainer = this;
	if (! s_hAcceleratorHook)		// no existing message hook?
	{
		// init message hook
		s_hAcceleratorHook = ::SetWindowsHookEx( WH_GETMESSAGE,
												 Container_Impl::AcceleratorMsgProc,
												 ::GetModuleHandle( NULL ),
												 ::GetWindowThreadProcessId( _hWndFrame, NULL ) );
		_ASSERT( s_hAcceleratorHook );
	}

    // go ahead and UI activate it.  This will cause it to QI for our
    // IOleInPlaceFrame and call SetActiveObject, which we will store
    // in m_pActiveObj
    HRESULT hr;
    RECT rc;
    _GetDoVerbRect( &rc ); // get rect for firing verbs.
	if (SUCCEEDED(hr = _pOO->DoVerb( OLEIVERB_UIACTIVATE, 0, &_CS, 0, GetFrameWindow(), &rc )) &&
		_pActiveObj)
	{
		_pActiveObj->OnFrameWindowActivate( TRUE );
		_pActiveObj->OnDocWindowActivate( TRUE );
	}
}

//-------------------------------------------------------------------------------------------------
void Container_Impl::deactivate()
{
	if (_pActiveObj)
	{
		_pActiveObj->OnFrameWindowActivate( FALSE );
		_pActiveObj->OnDocWindowActivate( FALSE );
	}

	s_pCurrentContainer = NULL;
	if (s_hAcceleratorHook)
	{
		// deinitialize message hook
		::UnhookWindowsHookEx( s_hAcceleratorHook );
		s_hAcceleratorHook = NULL;
	}
}

//+--------------------------------------------------------------------------
//
//  Member:     Container_Impl::Container_Impl
//
//  Synopsis:   ctor for the OLE Controls container class.
//
//  Arguments:  [hWnd] -- hWnd for the main browser
//
//----------------------------------------------------------------------------
#pragma warning(disable:4355) // this used in initialization list
Container_Impl::Container_Impl( const HWND hWndBrowser, IExplorerController_Impl* pController, IDispatch* pExt )
	: _hWndBrowser(hWndBrowser)
    , _CS(this)
//  	, _OCS(this)
//  	, _AS(this)
    , _IPF(this)
    , _IPS(this)
    , _OCtr(this)
    , _OCT(this)
	, m_DocHostUIHandler(this, pExt)
    , _pActiveObj( NULL )
    , _Ref( 1 )	 // !
    , _pUnk( NULL )
	, _pIWebBrowser2( NULL )
    , _pOC( NULL )
    , _pVO( NULL )
    , _pOO( NULL )
    , _pIPO( NULL )
    , _state( OS_PASSIVE )
    , _dwMiscStatus( 0 )
    , _fModelessEnabled( TRUE )
	, m_pController( pController )
	, _aWBCookie( 0 )
{
    InitPixelsPerInch(); // initialize the HIMETRIC routines
}
#pragma warning(default:4355)


//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::shutdown
//
//  Synopsis:   cleanup all the OLE stuff.
//
//----------------------------------------------------------------------------
void Container_Impl::shutdown()
{
	deactivate();

	// unadivse event sink
	IConnectionPointContainer * pConnCtr;
	if (_aWBCookie && _pIWebBrowser2 &&
		SUCCEEDED(_pIWebBrowser2->QueryInterface( IID_IConnectionPointContainer, (void **)&pConnCtr )))
	{
		IConnectionPoint * pConnPt;
		if (SUCCEEDED(pConnCtr->FindConnectionPoint( DIID_DWebBrowserEvents2, &pConnPt )))
		{
			pConnPt->Unadvise( _aWBCookie );
			pConnPt->Release();
		}
		pConnCtr->Release();
	}
	
    if (_pIWebBrowser2)
        _pIWebBrowser2->Release();
    if (_pOC)
        _pOC->Release();
    if (_pIPO)
    {
        _ASSERTE(_state == OS_UIACTIVE || _state == OS_INPLACE);
        if (_state == OS_UIACTIVE)
        {
            _pIPO->UIDeactivate();
            // _state = OS_INPLACE; // for documentation purposes
        }

        _pIPO->InPlaceDeactivate();
        // _state = OS_RUNNING;
    }
    if (_pVO)
    {
//          // kill the advisory connection
//          _pVO->SetAdvise( DVASPECT_CONTENT, 0, 0 );
        _pVO->Release();
    }
    if (_pOO)
    {
        _pOO->Close( OLECLOSE_NOSAVE );
        _pOO->SetClientSite( NULL );
        _pOO->Release();
    }
    if (_pUnk)
        _pUnk->Release();

    _ASSERTE( !_pActiveObj );

	_pIWebBrowser2 = NULL;
    _pOC		   = NULL;
    _pIPO		   = NULL;
    _pActiveObj	   = NULL;
    _pVO		   = NULL;
    _pOO		   = NULL;
    _pUnk		   = NULL;
    _state		   = OS_PASSIVE;
	_aWBCookie	   = 0;

	// free myself
	Release();
}


//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::AddRef
//
//  Synopsis:   bump refcount up on container.  Note that all the
//              interfaces handed out delegate to this one.
//
//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) Container_Impl::AddRef(VOID)
{
    return ++_Ref;
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::Release
//
//  Synopsis:   decrement the refcount on container, and delete when it
//              hits 0 - note that all the interfaces handed out delegate
//              to this one.
//
//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) Container_Impl::Release(VOID)
{
    if (! --_Ref)
    {
        delete this;
		return 0;
    }
	else
	{
		return _Ref;
	}
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::QueryInterface
//
//  Synopsis:   this is where we hand out all the interfaces.  All the
//              interfaces delegate back to this.
//
//  Arguments:  [riid] -- IID of interface desired.
//              [ppv]  -- interface returned.
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP Container_Impl::QueryInterface( REFIID riid, LPVOID FAR * ppv )
{
    *ppv = NULL;
    IUnknown* pUnk;

    if (::IsEqualIID( riid, IID_IOleClientSite ))
        pUnk = &_CS;
//      if (::IsEqualIID( riid, IID_IOleControlSite ))
//          pUnk = &_OCS;
//      else if (::IsEqualIID( riid, IID_IAdviseSink ))
//          pUnk = &_AS;
    else if (::IsEqualIID( riid, IID_IUnknown ))
        pUnk = (IUnknown*)this;
    else if (::IsEqualIID( riid, IID_IOleInPlaceFrame ) ||
             ::IsEqualIID( riid, IID_IOleInPlaceUIWindow ))
        pUnk = &_IPF;
    else if (::IsEqualIID( riid, IID_IOleInPlaceSite ))
        pUnk = &_IPS;
    else if (::IsEqualIID( riid, IID_IOleCommandTarget ))
        pUnk = &_OCT;
	else if (::IsEqualIID( riid, IID_IDocHostUIHandler))
		pUnk = & m_DocHostUIHandler;
    else
        return E_NOINTERFACE;

    pUnk->AddRef();
    *ppv = pUnk;
    return S_OK;
}


//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::CreateBrowserOC
//
//  Synopsis:   Creates an instance of the Web Browser OC, embedding it in
//              our container.  QIs for all the relevant pointers and
//              transitions the control to the UIActive state.
//
//              [hAccelBrowser] - HACCEL for the main browser wnd - so
//                                COleInPlaceFrame::TranslateAccelerator()
//                                can call ::TranslateAccelerator() on it.
//
//----------------------------------------------------------------------------
HRESULT Container_Impl::CreateBrowserOC( IDispatch * pSink )
{
    HRESULT hr;
    RECT rc;
    LPSHELLFOLDER pSF = NULL;

    // create the OC
	CLSID aClassId;
	if (FAILED(hr = ::CLSIDFromProgID( L"Shell.Explorer", &aClassId )))
		return hr;

	if (FAILED(hr = ::CoCreateInstance( aClassId, 0, CLSCTX_INPROC_SERVER,
										IID_IUnknown, (void**)&_pUnk )))
		return hr;

    _state = OS_RUNNING;

	// create separate window
	HWND hFrame = ::CreateWindowEx( 0, _T("IE OleContainer Frame"), _T("IE OleContainer Frame"),
									WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
									0, 0, 0, 0,
									_hWndBrowser, NULL, s_hInstance, this );
	SetFrameWindow( hFrame );
    // GetFrameWindow() also asserts that hwnd ::IsWindow()
    _ASSERTE(GetFrameWindow());

    // get the View object - although we rarely draw the OC thru this.
    // since we immediately transition it to the UIActive state, it
    // usually draws itself through its own wndproc.
	if (FAILED(hr = _pUnk->QueryInterface( IID_IViewObject, (void**)&_pVO )))
		return hr;

    // get the IOleObject pointer - the main interface through which
    // we handle the basic OLE object state transition stuff
    // for the Web Browser OC
	if (FAILED(hr = _pUnk->QueryInterface( IID_IOleObject, (void**)&_pOO )))
		return hr;

    // get status bits on the OC - we're not currently doing anything
    // with them.
	if (FAILED(hr = _pOO->GetMiscStatus( DVASPECT_CONTENT, &_dwMiscStatus )))
		return hr;

    // set our client site into the oleobject
	if (FAILED(hr = _pOO->SetClientSite( &_CS )))
		return hr;

    // set our advise sink into the view object, so we
    // get notifications that we need to redraw.
//	if (FAILED(hr = _pVO->SetAdvise( DVASPECT_CONTENT, 0, &_AS )))
//		return hr;

    // standard OLE protocol stuff.
	if (FAILED(hr = ::OleSetContainedObject( _pUnk, TRUE )))
		return hr;

    // ditto
	if (FAILED(hr = _pOO->SetHostNames( g_awchHostName, 0 )))
		return hr;

    // get the IWebBrowser interface - we can drive the OC late-bound,
    // but it's a lot easier (and higher performance, to some degree) to
    // do so early bound.
	if (FAILED(hr = _pUnk->QueryInterface( IID_IWebBrowser2, (void**)&_pIWebBrowser2 )))
		return hr;
	_pIWebBrowser2->put_RegisterAsBrowser( VARIANT_TRUE );
	_pIWebBrowser2->put_RegisterAsDropTarget( VARIANT_TRUE );

    // get the IOleControl interface; although we use it for very little.
	if (FAILED(hr = _pUnk->QueryInterface( IID_IOleControl, (void**)&_pOC )))
		return hr;

    // transition the control to the inplace-active state - it will have
    // an hWnd after it returns from DoVerb, and will begin drawing
    // itself.

    _GetDoVerbRect( &rc ); // get rect for firing verbs.

	if (FAILED(hr = _pOO->DoVerb( OLEIVERB_INPLACEACTIVATE, 0, &_CS, 0, GetFrameWindow(), &rc )))
		return hr;

//      // go ahead and UI activate it.  This will cause it to QI for our
//      // IOleInPlaceFrame and call SetActiveObject, which we will store
//      // in m_pActiveObj
//  	if (FAILED(hr = _pOO->DoVerb( OLEIVERB_UIACTIVATE, 0, &_CS, 0, GetFrameWindow(), &rc )))
//  		return hr;

	// advise sink
	IConnectionPointContainer * pConnCtr;
	if (SUCCEEDED(hr = _pIWebBrowser2->QueryInterface( IID_IConnectionPointContainer, (void **)&pConnCtr )))
	{
		IConnectionPoint * pConnPt;
		if (SUCCEEDED(hr = pConnCtr->FindConnectionPoint( DIID_DWebBrowserEvents2, &pConnPt )))
		{
			pConnPt->Advise( pSink, &_aWBCookie );
			pConnPt->Release();
		}
		pConnCtr->Release();
	}

	return hr;
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::GetSize
//
//  Synopsis:   returns the size, in pixels, of the WebBrowser OC.
//
//  Arguments:  [prc] --  returned size.
//
//----------------------------------------------------------------------------
HRESULT Container_Impl::GetSize( LPRECT prc )
{
    _ASSERTE( _pOO );
    HRESULT hr;

    // if we're inplace active, just ask the frame window.
    if (_state >= OS_INPLACE)
    {
        _ASSERTE( _pIPO );
        ::GetClientRect( GetFrameWindow(), prc );
        hr = S_OK;
    }
    else  // not inplace active - probably this is never hit.
    {
        SIZEL sizel;
        hr = _pOO->GetExtent( DVASPECT_CONTENT, &sizel );
        if (! hr)
        {
            prc->left	= 0;
            prc->top	= 0;
            prc->right	= ::HPixFromHimetric( sizel.cx );
            prc->bottom = ::VPixFromHimetric( sizel.cy );
        }
    }
    return hr;
}

//----------------------------------------------------------------------------
HRESULT Container_Impl::_SetExtent( LPRECT prc )
{
    SIZEL sizel;
    HRESULT hr;

    sizel.cx = ::HimetricFromHPix( prc->right - prc->left );
    sizel.cy = ::HimetricFromVPix( prc->bottom - prc->top );

    _ASSERTE( _pOO );

	if (FAILED(hr = _pOO->SetExtent( DVASPECT_CONTENT, &sizel )))
		return hr;

    if (FAILED(hr = _pOO->GetExtent( DVASPECT_CONTENT, &sizel )))
		return hr;

    prc->right	= ::HPixFromHimetric( sizel.cx );
    prc->bottom = ::VPixFromHimetric( sizel.cy );

	return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::SetSize
//
//  Synopsis:   sets the size of the WebBrowser OC space (the HTML area)
//
//  Effects:    if fMoveFrameWindow is TRUE, then it moves the whole
//              framewindow around, otherwise, it just readjusts how much
//              of the framewindow space is used by the OC itself.
//              In reality, what happens is that the OC calls us to
//              set some border space (although at this writing it still
//              is setting BORDERWIDTHS of 0,0,0,0), we allow that
//              much space, then call IOleInPlaceObject->SetObjectRects
//              to resize the object to whatever's left.
//              Otherwise, if the object is not yet active, we just
//              call IOleObject::SetExtent().
//
//  Arguments:  [prc]              -- size to set object to
//              [fMoveFrameWindow] -- is the hwnd size changing, or just
//                                    the object within?
//
//
//----------------------------------------------------------------------------
HRESULT Container_Impl::SetSize( LPRECT prc, BOOL fMoveFrameWindow )
{
    HRESULT hr;
    RECT rcClient, rcExtent;

	// get client coords.
    rcClient = *prc;
    ::MoveRect( &rcClient, -rcClient.left, -rcClient.top );

    if (fMoveFrameWindow)
    {
        ::SetWindowPos( GetFrameWindow(), 0, prc->left, prc->top,
						prc->right - prc->left, prc->bottom - prc->top,
						SWP_NOZORDER | SWP_NOACTIVATE );

		if (_pActiveObj)
            _pActiveObj->ResizeBorder( &rcClient, &_IPF, TRUE );
    }

    // subtract off any tools the client has around .
//    _AdjustForTools(&rcClient);

    rcExtent = rcClient;
	if (FAILED(hr = _SetExtent( &rcExtent )))
		return hr;

    // now we need to call SetObjectRects
	if (_pIPO && _state >= OS_INPLACE)
		hr = _pIPO->SetObjectRects( &rcExtent, &rcClient );

	return hr;
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::SetFocus
//
//  Synopsis:   transfers focus from framewindow to the current
//              in-place active object.  Per OLE Compound Document spec.
//
//----------------------------------------------------------------------------
LRESULT Container_Impl::SetFocus(VOID)
{
    HWND hWnd = NULL;
    LPOLEINPLACEACTIVEOBJECT pAO = GetIPAObject();

    if (pAO)
    {
        if (! pAO->GetWindow( &hWnd ))
        {
            if (hWnd && !::IsWindow( hWnd ))
                hWnd = NULL;
        }
    }

    // if no inplaceactive object, set focus to frame window.
    if (! hWnd)
        hWnd = GetFrameWindow();

    ::SetFocus( hWnd );
    return 0;
}

//#############################################################################
// IDocHostUIHandler Methods
// Class CDocHostUIHandler
//-----------------------------------------------------------------------------
CDocHostUIHandler::CDocHostUIHandler(Container_Impl* pCtr, IDispatch* pExt):
			m_pContainer(pCtr)
{
	
	m_externalDispatch= pExt;
	if(pExt)
		pExt->AddRef();
}

CDocHostUIHandler::~CDocHostUIHandler()
{
	if(m_externalDispatch)
		m_externalDispatch->Release();
}

STDMETHODIMP CDocHostUIHandler::QueryInterface(REFIID riid, LPVOID FAR * ppv)
{
    return m_pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CDocHostUIHandler::AddRef(VOID)
{
    return m_pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CDocHostUIHandler::Release(VOID)
{
    return m_pContainer->Release();
}
// MSHTML requests to display its context menu
STDMETHODIMP CDocHostUIHandler::ShowContextMenu(DWORD dwID, POINT* pptPosition, IUnknown* pCommandTarget, IDispatch* pDispatchObjectHit)
{
	//	HRESULT hr = m_bAllowContextMenu ? S_FALSE : S_OK;
	return S_FALSE;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called at initialisation to find UI styles from container
STDMETHODIMP CDocHostUIHandler::GetHostInfo(DOCHOSTUIINFO* pInfo)
{
	if (pInfo == NULL)
		return E_POINTER;

	pInfo->dwFlags = DOCHOSTUIFLAG_NO3DBORDER;
	pInfo->dwDoubleClick = DOCHOSTUIDBLCLK_DEFAULT;

	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Allows the host to replace the IE4/MSHTML menus and toolbars. 
STDMETHODIMP CDocHostUIHandler::ShowUI(DWORD dwID, IOleInPlaceActiveObject* pActiveObject, IOleCommandTarget* pCommandTarget, IOleInPlaceFrame* pFrame, IOleInPlaceUIWindow* pDoc)
{
	//	HRESULT hr = m_bAllowShowUI ? S_FALSE : S_OK;
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called when IE4/MSHTML removes its menus and toolbars. 
STDMETHODIMP CDocHostUIHandler::HideUI()
{
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Notifies the host that the command state has changed. 
STDMETHODIMP CDocHostUIHandler::UpdateUI()
{
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called from the IE4/MSHTML implementation of IOleInPlaceActiveObject::EnableModeless
STDMETHODIMP CDocHostUIHandler::EnableModeless(BOOL fEnable)
{
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called from the IE4/MSHTML implementation of IOleInPlaceActiveObject::OnDocWindowActivate
STDMETHODIMP CDocHostUIHandler::OnDocWindowActivate(BOOL fActivate)
{
	return S_OK; 
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called from the IE4/MSHTML implementation of IOleInPlaceActiveObject::OnFrameWindowActivate. 
STDMETHODIMP CDocHostUIHandler::OnFrameWindowActivate(BOOL fActivate)
{
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called from the IE4/MSHTML implementation of IOleInPlaceActiveObject::ResizeBorder.
STDMETHODIMP CDocHostUIHandler::ResizeBorder(LPCRECT prcBorder, IOleInPlaceUIWindow* pUIWindow, BOOL fFrameWindow)
{
	return S_OK;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called by IE4/MSHTML when IOleInPlaceActiveObject::TranslateAccelerator or IOleControlSite::TranslateAccelerator is called. 
STDMETHODIMP CDocHostUIHandler::TranslateAccelerator(LPMSG lpMsg, const GUID* pguidCmdGroup, DWORD nCmdID)
{
	return S_FALSE;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Returns the registry key under which IE4/MSHTML stores user preferences. 
// Returns S_OK if successful, or S_FALSE otherwise. If S_FALSE, IE4/MSHTML will default to its own user options.
STDMETHODIMP CDocHostUIHandler::GetOptionKeyPath(BSTR* pbstrKey, DWORD dwReserved)
{
	HRESULT hr = S_FALSE;
	if (pbstrKey == NULL)
		return E_POINTER;
	*pbstrKey = NULL;
	return hr;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called by IE4/MSHTML when it is being used as a drop target to allow the host to supply an alternative IDropTarget
STDMETHODIMP CDocHostUIHandler::GetDropTarget(IDropTarget* pDropTarget, IDropTarget** ppDropTarget)
{
	HRESULT hr = E_NOTIMPL;
	if (ppDropTarget == NULL)
		return E_POINTER;
	*ppDropTarget = NULL;
	return hr;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called by IE4/MSHTML to obtain the host's IDispatch interface
STDMETHODIMP CDocHostUIHandler::GetExternal(IDispatch** ppDispatch)
{
	HRESULT hr = E_NOINTERFACE;
	if (ppDispatch == NULL)
		return E_POINTER;
	*ppDispatch = NULL;

	// return the IDispatch we have for extending the object Model
	*ppDispatch= m_externalDispatch;
	(*ppDispatch)->AddRef();
	//	m_spExternalDispatch.CopyTo(ppDispatch);
	//		hr = S_OK;
	//	}
	return hr;
}

//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called by IE4/MSHTML to allow the host an opportunity to modify the URL to be loaded
STDMETHODIMP CDocHostUIHandler::TranslateUrl(DWORD dwTranslate, OLECHAR* pchURLIn, OLECHAR** ppchURLOut)
{
	HRESULT hr = S_FALSE;
	if (ppchURLOut == NULL)
		return E_POINTER;
	*ppchURLOut = NULL;
	return hr;
}
//+++ IDocHostUIHandler +++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Called on the host by IE4/MSHTML to allow the host to replace IE4/MSHTML's data object.
// This allows the host to block certain clipboard formats or support additional clipboard formats. 
STDMETHODIMP CDocHostUIHandler::FilterDataObject(IDataObject* pDO, IDataObject** ppDORet)
{
	HRESULT hr = S_FALSE;
	if (ppDORet == NULL)
		return E_POINTER;
	*ppDORet = NULL;
	return hr;
}



//  //+---------------------------------------------------------------------------
//  //
//  //  Class:      CAdviseSink implementations
//  //
//  //  Purpose:    to implement IAdviseSink for Container_Impl
//  //
//  //  Notes:      we don't do much with this interface - it's required
//  //              for contractual reasons only.
//  //
//  //----------------------------------------------------------------------------
//  STDMETHODIMP CAdviseSink::QueryInterface(REFIID riid, LPVOID FAR * ppv)
//  {
//      return _pContainer->QueryInterface( riid, ppv );
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(ULONG) CAdviseSink::AddRef(VOID)
//  {
//      return _pContainer->AddRef();
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(ULONG) CAdviseSink::Release(VOID)
//  {
//      return _pContainer->Release();
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(VOID) CAdviseSink::OnDataChange( LPFORMATETC pFEIn, LPSTGMEDIUM pSTM )
//  {
//  }

//  //+---------------------------------------------------------------------------
//  //
//  //  Member:     CAdviseSink::OnViewChange
//  //
//  //  Synopsis:   IAdviseSink::OnViewChange() - we do get called with this
//  //              occasionally, but it appears that we're better off just
//  //              letting the control's wndproc paint it.
//  //              Calling this was causing extra flicker.
//  //
//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(VOID)	CAdviseSink::OnViewChange( DWORD dwAspect, LONG lIndex )
//  {
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(VOID)	CAdviseSink::OnRename( LPMONIKER pmk )
//  {
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(VOID)	CAdviseSink::OnSave(VOID)
//  {
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(VOID)	CAdviseSink::OnClose(VOID)
//  {
//  }


//+---------------------------------------------------------------------------
//
//  Class:      COleClientSite ()
//
//  Purpose:    our implementation of IOleClientSite
//
//  Interface:  COleClientSite         -- ctor
//              QueryInterface         -- gimme an interface!
//              AddRef                 -- bump up refcount
//              Release                -- bump down refcount
//              SaveObject             -- returns E_FAIL
//              GetMoniker             -- E_NOTIMPL
//              GetContainer           -- returns our COleContainer impl
//              ShowObject             -- just say OK
//              OnShowWindow           -- just say OK
//              RequestNewObjectLayout -- E_NOTIMPL
//
//  Notes:      probably the most important thing our IOleClientSite
//              implementation does is hand off our IOleContainer
//              implementation when GetContainer() is called.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::QueryInterface(REFIID riid, LPVOID FAR * ppv)
{
    return _pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) COleClientSite::AddRef(VOID)
{
    return _pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) COleClientSite::Release(VOID)
{
    return _pContainer->Release();
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::SaveObject
//
//  Synopsis:   not implemented - makes no sense in this scenario.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::SaveObject(VOID)
{
    return E_FAIL;
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::GetMoniker
//
//  Synopsis:   Not yet implemented; never will be implemented.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::GetMoniker( DWORD dwAssign, DWORD dwWhich, LPMONIKER FAR * ppmk )
{
    *ppmk = NULL;
    return E_NOTIMPL;
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::GetContainer
//
//  Synopsis:   returns our implementation of IOleContainer.  For some
//              reason, unless we do this, frames don't work.  Note that
//              our IOleContainer implementation is stubbed out with
//              E_NOTIMPL (it seems kind of silly to implement this for
//              a container with one embedding).  But it turns out the
//              WebBrowser OC has a bug in it's error handling - it
//              QIs for IOleContainer, then QIs from that for
//              IQueryService.  In truth, we'll hand out our implementation
//              of IQueryService, from any interface - we're easy :).
//              We *want* to provide every service the OC asks for.
//              Anyway, when it can't get IOleContainer, the OC's failure
//              path seems to be constructed in such a way that frames
//              don't work thereafter.
//
//  Arguments:  [ppCtr] -- returned IOleContainer
//
//  Returns:    S_OK.  Never fails.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::GetContainer( LPOLECONTAINER FAR * ppCtr )
{
    *ppCtr = &_pContainer->_OCtr;
    (*ppCtr)->AddRef();

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::ShowObject
//
//  Synopsis:   IOleClientSite::ShowObject implementation.  To quote the docs:
//              "Tells the container to position the object so it is visible
//              to the user. This method ensures that the container itself
//              is visible and not minimized."
//
//              In short, we ignore it.  We're not going to un-minimize
//              the container on the embeddings' whim :).
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::ShowObject(VOID)
{
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::OnShowWindow
//
//  Synopsis:   fine with us, return S_OK.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::OnShowWindow(int bShow)
{
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     COleClientSite::RequestNewObjectLayout
//
//  Synopsis:   not being called by WebBrower OC, so do not implement.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleClientSite::RequestNewObjectLayout(VOID)
{
    return E_NOTIMPL;
}


//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::QueryInterface(REFIID riid, LPVOID FAR * ppv)
//  {
//      return _pContainer->QueryInterface( riid, ppv );
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(ULONG) COleControlSite::AddRef(VOID)
//  {
//      return _pContainer->AddRef();
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP_(ULONG) COleControlSite::Release(VOID)
//  {
//      return _pContainer->Release();
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::OnControlInfoChanged(VOID)
//  {
//  	return S_OK;
//  }
        
//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::LockInPlaceActive( /* [in] */ BOOL fLock )
//  {
//  	return E_NOTIMPL;
//  }
        
//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::GetExtendedControl( /* [out] */ IDispatch __RPC_FAR *__RPC_FAR *ppDisp )
//  {
//  	return E_NOTIMPL;
//  }
        
//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::TransformCoords( /* [out][in] */ POINTL __RPC_FAR *pPtlHimetric,
//  											   /* [out][in] */ POINTF __RPC_FAR *pPtfContainer,
//  											   /* [in] */ DWORD dwFlags )
//  {
//  	return E_NOTIMPL;
//  }
        
//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::TranslateAccelerator( /* [in] */ MSG __RPC_FAR *pMsg,
//  													/* [in] */ DWORD grfModifiers )
//  {
//  	return S_FALSE;
//  }
        
//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::OnFocus( /* [in] */ BOOL fGotFocus )
//  {
//  	return S_OK;
//  }

//  //----------------------------------------------------------------------------
//  STDMETHODIMP COleControlSite::ShowPropertyFrame(VOID)
//  {
//  	return E_NOTIMPL;
//  }


//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::QueryInterface( REFIID riid, LPVOID FAR * ppv )
{
    return _pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CInPlaceFrame::AddRef(VOID)
{
    return _pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CInPlaceFrame::Release(VOID)
{
    return _pContainer->Release();
}

// IOleWindow stuff

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::GetWindow
//
//  Synopsis:   returns frame window
//
//  Arguments:  [phwnd] -- place to return window
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::GetWindow( HWND * phwnd )
{
    _ASSERTE( phwnd );

    // this can never fail if we've gotten this far.
    *phwnd = _pContainer->GetFrameWindow();
    _ASSERTE( *phwnd );

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::ContextSensitiveHelp
//
//  Synopsis:   This is not implemented by design - this is for
//              the SHift+F1 context sensitive help mode and Esc
//              to exit.  Esc is already being used in the main
//              accelerator table to mean 'stop browsing' to be
//              like IE3.  We do not do help this way.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::ContextSensitiveHelp( BOOL fEnterMode )
{
    return E_NOTIMPL;
}

// IOleInPlaceUIWindow stuff

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::GetBorder
//
//  Synopsis:   IOleInPlaceFrame::GetBorder() - let's us restrict where
//              the server can put tools.  We don't care, they can put
//              them anywhere.
//
//  Arguments:  [lprectBorder] -- return border info in here.
//
//  Returns:    S_OK always with entire frame client rect -
//              we place no restrictions.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::GetBorder( LPRECT lprectBorder )
{
//    return INPLACE_E_NOTOOLSPACE;
    // we have no restrictions about where the server can put tools.
    ::GetClientRect( _pContainer->GetFrameWindow(), lprectBorder );

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::RequestBorderSpace
//
//  Synopsis:   IOleInPlaceFrame::RequestBorderSpace()
//              inplace object actually requests border space - if
//              we can satisfy the request, we return S_OK, otherwise
//              INPLACE_E_NOTOOLSPACE.  It doesn't actually use the
//              borderspace until it calls
//              IOleInPlaceFrame::SetBorderSpace().  This is used for
//              negotiation.
//
//  Arguments:  [pborderwidths] -- structure (actually a RECT) that is
//                                 interpreted differently from a RECT.
//                                 The left.top.bottom.right members
//                                 represent space on each of our four
//                                 borders the server would like to use.
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::RequestBorderSpace( LPCBORDERWIDTHS pborderwidths )
{
    RECT rc;
    RECT rcBorder = *pborderwidths;

    if (GetBorder( &rc ))
        return INPLACE_E_NOTOOLSPACE;

    if (rcBorder.left + rcBorder.right > WIDTH(rc) ||
        rcBorder.top + rcBorder.bottom > HEIGHT(rc))
        return INPLACE_E_NOTOOLSPACE;

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::SetBorderSpace
//
//  Synopsis:   Sets border space for tools - for some reason, the
//              WebBrowser OC always calls this with a pborderwidths
//              consisting of four zeros - it never actually uses any
//              border space (sigh).  Well, the code is here for this
//              to work.  We do a SetSize() to relayout stuff when
//              it does this.
//
//  Arguments:  [pborderwidths] --  space the OC wants to use.
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::SetBorderSpace( LPCBORDERWIDTHS pborderwidths )
{
    RECT rc;

    if (RequestBorderSpace( pborderwidths ))
        return OLE_E_INVALIDRECT;

    // we get the entire client space to pass to setSize().
    ::GetClientRect( _pContainer->GetFrameWindow(), &rc );
//	m_pCtr->m_rcToolSpace = *pborderwidths;

    return _pContainer->SetSize( &rc, FALSE );
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::SetActiveObject
//
//  Synopsis:   IOleInPlaceFrame::SetActiveObject().  The server calls
//              this normally whenever it transitions to the UIActive
//              state.  There can only be one UIActive object at a time.
//              This UIACtive object is represented by its
//              IOleInPlaceActiveObject implementation.  We call this
//              object's implementation of TranslateAccelerator() right
//              in the main message loop to give the current embedding
//              first shot at keyboard messages.
//
//              Normally, this is only called when the container transitions
//              an object to UIActive by calling
//              IOleObject::DoVerb(OLEIVERB_UIACTIVE) for the object,
//              transitioning all the other objects (we don't have any :))
//              to OS_INPLACE (if they're OLEMISC_ACTIVATEWHENVISIBLE is set)
//              or even just OS_RUNNING.
//
//              But the MSJ container only has *one* embedding, the Web
//              Browser OC.  And this OC keeps calling this thing all the time,
//              every time it navigates to a new site (new docobject, I guess),
//              *and*, after the first time it navgs to a new site, whenever
//              the user clicks on the HTML region.
//
//  Effects:    sets a new active object in m_pActiveObj.  Releases the
//              old one, if any.
//
//  Arguments:  [pActiveObject] -- new active object
//              [pszObjName]    -- name of object - we don't use this.
//
//  Returns:    S_OK always.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::SetActiveObject( IOleInPlaceActiveObject* pActiveObject,
											 LPCOLESTR pszObjName )
{
    // reset the toolspace rect in case the last inplacactive object
    // forgot to.
	// m_pCtr->_ResetToolSpace();

    // if it was already set, save it so we can release
    // it.  We don't want to release it before we addref
    // the new one in case they're the same thing.
    LPOLEINPLACEACTIVEOBJECT pOld = _pContainer->_pActiveObj;

    _pContainer->_pActiveObj = pActiveObject;
    if (pActiveObject)
    {
        _ASSERTE( OS_UIACTIVE == _pContainer->GetState() );
        _pContainer->_pActiveObj->AddRef();
    }

    if (pOld)
        pOld->Release();

    return S_OK;
}

// IOleInPlaceFrame stuff
//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::InsertMenus
//
//  Synopsis:   OC calling us when it wants to do menu negotiation
//              It calls us with a blank hmenu that we're supposed to
//              add items to and fille out the OLEMENUGROUPWIDTHS
//              structure to let it know what we did.
//              We're not adding items to it currently.
//
//  Arguments:  [hmenuShared] -- menu to append to
//              [pMGW]        -- OLEMENUGROUPWIDTHS struct to fill out.
//
//  Returns:    S_OK
//
//
//  Note:       OC doesn't call this.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::InsertMenus( HMENU hmenuShared, LPOLEMENUGROUPWIDTHS pMGW )
{
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::SetMenu
//
//  Synopsis:   This is the OC calling the container asking us to
//              set the shared menu in its frame.  We're supposed to
//              use the HOLEMENU object passed in and the
//              hWndActiveObject to call OleSetMenuDescriptor() so
//              that OLE can do message filtering and route WM_COMMAND
//              messages.
//
//              Bottom line - the WebBrowser OC only calls this once with
//                            a 0 HMENU.  If this changes, fix this code
//                            to do menu negotiation if desired.
//
//
//  Arguments:  [hmenuShared]      --  shared menu.
//              [holemenu]         --  ole menu descriptor thingy
//              [hwndActiveObject] --  hwnd of server who's merging menus
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::SetMenu( HMENU hmenuShared, HOLEMENU holemenu, HWND hwndActiveObject )
{
    _ASSERTE( !hmenuShared );  // only called once with 0
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::RemoveMenus
//
//  Synopsis:   IOleInPlaceFrame::RemoveMenus(), this is where the
//              server gives us a chance to remove all our items from
//              the hMenu.  We're not adding any, so we don't remove any.
//
//  Arguments:  [hmenuShared] -- menu to clean up.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::RemoveMenus( HMENU hmenuShared )
{
    // we aren't adding anything to this thing anyway.
    return S_OK;
}


//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::SetStatusText
//
//  Synopsis:   called by the WebBrowser OC to put text in our status
//              text area.
//
//  Returns:    HRESULT
//
//  Arguments:  [pszStatusText] -- text to display
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::SetStatusText( LPCOLESTR pszStatusText )
{
	return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::EnableModeless
//
//  Synopsis:   this is called by the embedding to let us know it's
//              putting up a modal dialog box - we should 'grey' out
//              any of our modeless dialogs.  It delegates to
//              Container_Impl::EnableModeless()
//
//  Arguments:  [fEnable] -- enable or disable.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::EnableModeless( BOOL fEnable )
{
    return _pContainer->EnableModeless( fEnable );
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::EnableModeless
//
//  Synopsis:   delegated to from CInPlaceFrame::EnableModeless().
//              always returns S_OK - we don't have any modeless
//              dialogs (yet).
//
//  Arguments:  [fEnable] -- enable or disable.
//
//  Returns:    S_OK
//
//----------------------------------------------------------------------------
HRESULT Container_Impl::EnableModeless( BOOL fEnable )
{
    _fModelessEnabled = fEnable;  // in case anyone wants to know.
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceFrame::TranslateAccelerator
//
//  Synopsis:   The current active object's
//              IOleInPlaceActiveObject::TranslateAccelerator() is being
//              called at the top of our main message loop.  If it
//              does *not* want to handle a message, it will call
//              this method of ours to pass the keyboard message back to
//              us.  We call ::TranslateAccelerator on the global main
//              haccel, and, if it's handled (by returning TRUE - 1),
//              we indicate it's handled by returning S_OK (0 :).
//              On the other hand, if it's *not* handled, we return
//              S_FALSE.
//
//  Arguments:  [lpmsg] -- keyboard msg to handle
//              [wID]   -- command identifier value - per spec.
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceFrame::TranslateAccelerator( LPMSG lpmsg, WORD wID )
{
    // note this should never be called - only local servers
    // (out of process) should call this by using
    // OleTranslateAccelerator().
    return _pContainer->_TransAccelerator( lpmsg, wID );
}

//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::_TransAccelerator
//
//  Synopsis:   handle accelerator messages coming from
//              either IOleInplaceFrame::TranslateAccelerator, or
//              IOleControlSite::TranslateAccelerator.
//
//  Effects:    forwards them to the main accelerator table.
//
//  Arguments:  [lpmsg] -- keyboard msg.
//              [wID]   -- per spec.
//
//  Returns:    S_OK if we handled it, S_FALSE otherwise.
//
//----------------------------------------------------------------------------
HRESULT Container_Impl::_TransAccelerator( LPMSG lpmsg, WORD wID )
{
    // the docs suggest that this method might need to return E_INVALIDARG.
    // anyway, this is defensive.  If the WebBrowser OC
    // calls us with an 0 ptr, we just return error
    if (! lpmsg)
        return E_INVALIDARG;

    // forward the keystroke to the main accelerator table, if you have one.
    // if you handle it, say S_OK.

#if 0
    // this sample has no main accelerator table.
    if (::TranslateAccelerator( GetMainWindow(), GetMainAccel(), lpmsg ))
    {
        return S_OK;      // we handled it
    }
    else
#endif
    {
        return S_FALSE;   // we didn't.
    }
}

//+---------------------------------------------------------------------------
//
//  Class:      CInPlaceSite ()
//
//  Purpose:    IOleInPlaceSite implementation.
//
//  Interface:  CInPlaceSite         -- ctor
//              QueryInterface       -- get a new interface
//              AddRef               -- bump ref count
//              Release              -- decrement ref count
//              GetWindow            -- returns frame window
//              ContextSensitiveHelp -- not implemented by design
//              CanInPlaceActivate   -- returns S_OK.
//              OnInPlaceActivate    -- caches IOleInPlaceObject ptr
//              OnUIActivate         -- returns S_OK  - sets state
//              GetWindowContext     -- returns IOleInPlaceFrame,
//                                              IOleInPlaceUIWindow,
//                                              PosRect and ClipRect
//              Scroll               -- not implemented ever
//              OnUIDeactivate       -- kills objmenu
//              OnInPlaceDeactivate  -- releases cached IOleInPlaceObject
//              DiscardUndoState     -- returns S_OK
//              DeactivateAndUndo    -- deactivates in place active object
//              OnPosRectChange      -- never implemented.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::QueryInterface( REFIID riid, LPVOID FAR * ppv )
{
    return _pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CInPlaceSite::AddRef(VOID)
{
    return _pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CInPlaceSite::Release(VOID)
{
    return _pContainer->Release();
}


// IOleWindow stuff

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::GetWindow
//
//  Synopsis:   returns frame window.
//
//  Arguments:  [phwnd] -- return window *here*
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::GetWindow( HWND* phwnd )
{
    // just reuse the CInPlaceFrame impl
    return _pContainer->_IPF.GetWindow( phwnd );
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::ContextSensitiveHelp
//
//  Synopsis:   This is not implemented by design - this is for
//              the SHift+F1 context sensitive help mode and Esc
//              to exit.  Esc is already being used in the main
//              accelerator table to mean 'stop browsing' to be
//              like IE3.  We do not do help this way.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::ContextSensitiveHelp( BOOL fEnterMode )
{
    return E_NOTIMPL;
}

// IOleInPlaceSite stuff

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::CanInPlaceActivate
//
//  Synopsis:   just say yes.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::CanInPlaceActivate(VOID)
{
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::OnInPlaceActivate
//
//  Synopsis:   caches the IOleInPlaceObject pointer.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::OnInPlaceActivate(VOID)
{
    HRESULT hr = _pContainer->_pOO->QueryInterface(
								IID_IOleInPlaceObject, (void**)&_pContainer->_pIPO );

	if (SUCCEEDED( hr ))
        _pContainer->SetState( OS_INPLACE );

    return hr;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::OnUIActivate
//
//  Synopsis:   just sets state bit
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::OnUIActivate(VOID)
{
    _pContainer->SetState( OS_UIACTIVE );
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::GetWindowContext
//
//  Synopsis:   returns a bunch of interfaces and positioning interface
//              the inplace-active object needs to do its thang.
//
//  Arguments:  [ppFrame]     -- return our IOleInPlaceFrame implementation
//              [ppDoc]       -- return our IOleInPlaceUIWindow impl.
//              [prcPosRect]  -- position info
//              [prcClipRect] -- clip info - same as pos info for this case
//              [pFrameInfo]  -- return 0 - inproc object doesn't use this.
//
//  Notes:      note that ppFrame and ppDoc are really just the same
//              object because we're an SDI app.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::GetWindowContext(
	IOleInPlaceFrame **ppFrame, IOleInPlaceUIWindow **ppDoc, LPRECT prcPosRect,
	LPRECT prcClipRect, LPOLEINPLACEFRAMEINFO pFrameInfo )
{
    // get the frame
    HRESULT hr = _pContainer->QueryInterface( IID_IOleInPlaceFrame, (void**)ppFrame );
    _ASSERTE( SUCCEEDED(hr) );

    // return the frame again :) - this is all per-spec.
    hr = _pContainer->QueryInterface( IID_IOleInPlaceUIWindow, (void**)ppDoc );
    _ASSERTE( SUCCEEDED(hr) );

    // get the clip and pos rect - same for this application.
    HWND hWnd = _pContainer->GetMainWindow();
    _ASSERTE( hWnd );
    HWND hWndFrame = _pContainer->GetFrameWindow();

    ::GetClientRect( hWndFrame, prcPosRect );
    ::MapWindowPoints( hWndFrame, hWnd, (LPPOINT)prcPosRect, 2 );
    *prcClipRect = *prcPosRect;

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::Scroll
//
//  Synopsis:   never implement this for WebBrowser OC.  This has
//              nothing to do with the scrollbars you see on the HTML.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::Scroll( SIZE scrollExtent )
{
    return E_NOTIMPL;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::OnUIDeactivate
//
//  Synopsis:   set state bits
//
//  Arguments:  [fUndoable] -- not used
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::OnUIDeactivate( BOOL fUndoable )
{
	_pContainer->SetState( OS_INPLACE );
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::OnInPlaceDeactivate
//
//  Synopsis:   releases the IOleInPlaceObject pointer we were
//              caching for the object, and sets state to OS_RUNNING.
//              Also fires the OLEIVERB_DISCARDUNDOSTATE at the control
//              to tell it to release any undo state it's holding onto.
//              I very much doubt the WebBrowser OC has any undo state,
//              but, this is the protocol.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::OnInPlaceDeactivate(VOID)
{
    RECT rc;

    if (_pContainer->_pIPO)
    {
		_pContainer->_pIPO->Release();
		_pContainer->SetState( OS_RUNNING );
		_pContainer->_pIPO = NULL;
    }

    if (_pContainer->_pOO)
    {
		_pContainer->_GetDoVerbRect( &rc ); // get rect for firing verbs.
		_pContainer->_pOO->DoVerb( OLEIVERB_DISCARDUNDOSTATE,
            0, &_pContainer->_CS, 0, _pContainer->GetFrameWindow(), 0 );
    }

    return S_OK;
}


//+---------------------------------------------------------------------------
//
//  Member:     Container_Impl::_GetDoVerbRect
//
//  Synopsis:   whenever firing DoVerb(), we need a rect for the object
//              that describes the area for the object in parent client coords.
//
//  Arguments:  [prc] -- rect returned.
//
//----------------------------------------------------------------------------
VOID Container_Impl::_GetDoVerbRect( LPRECT prc )
{
    _ASSERTE( _hWndBrowser && _hWndFrame );
    ::GetClientRect( GetFrameWindow(), prc );
    ::MapWindowPoints( GetFrameWindow(), GetMainWindow(), (LPPOINT)prc, 2 );
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::DiscardUndoState
//
//  Synopsis:   just say OK - we don't hold any undo state for
//              object.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::DiscardUndoState(VOID)
{
    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::DeactivateAndUndo
//
//  Synopsis:   absolutely minimum implementation of deactivateandundo.
//              just calls IOleInPlaceObject::InPlaceDeactivate().
//
//  Returns:    S_OK always.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::DeactivateAndUndo(VOID)
{
    if (_pContainer->_pIPO)
        _pContainer->_pIPO->InPlaceDeactivate();

    return S_OK;
}

//+---------------------------------------------------------------------------
//
//  Member:     CInPlaceSite::OnPosRectChange
//
//  Synopsis:   never implement this.
//
//----------------------------------------------------------------------------
STDMETHODIMP CInPlaceSite::OnPosRectChange( LPCRECT lprcPosRect )
{
//	_ASSERT( _pContainer && _pContainer->_pController && lprcPosRect );

//	if (_pContainer && _pContainer->_pController )
//		_pContainer->_pController->setPosSize( lprcPosRect->left, lprcPosRect->top,
//											   WIDTH( *lprcPosRect ), HEIGHT( *lprcPosRect ) );

    return S_OK;
}



//+---------------------------------------------------------------------------
//
//  Class:      COleContainer ()
//
//  Purpose:    our implementation of IOleContainer.  does nothing.  But the
//              WebBrowser OC needs to see it or frames don't work - bug in
//              their error path.
//
//----------------------------------------------------------------------------
STDMETHODIMP COleContainer::QueryInterface( REFIID riid, LPVOID FAR * ppv )
{
    return _pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) COleContainer::AddRef(VOID)
{
    return _pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) COleContainer::Release(VOID)
{
    return _pContainer->Release();
}

//----------------------------------------------------------------------------
STDMETHODIMP COleContainer::EnumObjects( DWORD grfFlags, IEnumUnknown **ppenum )
{
    _ASSERTE( FALSE );   // never called
    return E_NOTIMPL;
}

//----------------------------------------------------------------------------
STDMETHODIMP COleContainer::LockContainer( BOOL fLock )
{
    _ASSERTE( FALSE );  // never called
    return S_OK;
}

//----------------------------------------------------------------------------
STDMETHODIMP COleContainer::ParseDisplayName(
	IBindCtx *pbc, LPOLESTR pszDisplayName, ULONG *pchEaten, IMoniker** ppmkOut )
{
    return E_NOTIMPL;
}

//+---------------------------------------------------------------------------
//
//  Class:      CCommandTarget ()
//
//  Purpose:    IOleCommandTarget.  It turns out the WebBrowser OC
//              communicates some of its status messages by calling
//              IOleCommandTarget->Exec(OLECMDID_SETPROGRESSTEXT);
//
//  Interface:  CCommandTarget -- ctor
//              QueryInterface -- gimme an interface
//              AddRef         -- bump up refcount
//              Release        -- release refcount
//              QueryStatus    -- what cmds do you support?
//              Exec           -- execute a command.
//
//----------------------------------------------------------------------------
STDMETHODIMP CCommandTarget::QueryInterface( REFIID riid, LPVOID FAR * ppv )
{
    return _pContainer->QueryInterface( riid, ppv );
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CCommandTarget::AddRef(VOID)
{
    return _pContainer->AddRef();
}

//----------------------------------------------------------------------------
STDMETHODIMP_(ULONG) CCommandTarget::Release(VOID)
{
    return _pContainer->Release();
}

//+---------------------------------------------------------------------------
//
//  Member:     CCommandTarget::QueryStatus
//
//  Synopsis:   queries for what commands we support.  We only support
//              the OLECMDID_SETPROGRESSTEXT command.
//
//  Arguments:  [pguidCmdGroup] -- should be 0
//              [cCmds]         -- number of commands
//              [aCmds]         -- array of commands
//              [pCmdText]      -- returned status text - we set this to 0.
//
//  Returns:    S_OK - always succeeds.
//
//----------------------------------------------------------------------------
STDMETHODIMP CCommandTarget::QueryStatus( const GUID* pguidCmdGroup, ULONG cCmds,
										  OLECMD aCmds[], OLECMDTEXT* pCmdText )
{
    if (! pguidCmdGroup)
		return OLECMDERR_E_NOTSUPPORTED;

	return OLECMDERR_E_UNKNOWNGROUP;
}

//+---------------------------------------------------------------------------
//
//  Member:     CCommandTarget::Exec
//
//  Synopsis:   execute a command.  We only support OLECMDID_SETPROGRESSTEXT.
//
//  Arguments:  [pguidCmdGroup] --  should be 0
//              [nCmdID]        --  cmd ID
//              [nCmdexecopt]   --  not used
//              [pVarIn]        --  this has the text to display
//              [pVarOut]       --  not used
//
//  Returns:    HRESULT
//
//----------------------------------------------------------------------------
STDMETHODIMP CCommandTarget::Exec( const GUID * pguidCmdGroup, DWORD nCmdID, DWORD nCmdexecopt,
								   LPVARIANTARG pVarIn, LPVARIANTARG pVarOut )
{
    if (! pguidCmdGroup)
		return OLECMDERR_E_NOTSUPPORTED;

//      if (::IsEqualIID( *pguidCmdGroup, CGID_Explorer ))
//  	{
//  	}
//      else if (::IsEqualIID( *pguidCmdGroup, CGID_ShellDocView ))
//  	{
//  	}
//  	else
//  	{
//  	}

	return OLECMDERR_E_UNKNOWNGROUP;
}


//==================================================================================================
LRESULT CALLBACK Container_Impl::AcceleratorMsgProc( int code, WPARAM wParam, LPARAM lParam )
{
	if (code >= 0 && lParam)
	{
		MSG* pMsg = (MSG*)lParam;
		LPOLEINPLACEACTIVEOBJECT pIPAO;
		
		if (s_pCurrentContainer && (pIPAO = s_pCurrentContainer->GetIPAObject()) &&
			pIPAO->TranslateAccelerator( pMsg ) == S_OK)
		{
			// handled message
			pMsg->message = WM_NULL;
			pMsg->wParam = 0;
			pMsg->lParam = 0;
			// exit hook chaining
			return 0;
		}
	}

	return ::CallNextHookEx( s_hAcceleratorHook, code, wParam, lParam );
}

//+---------------------------------------------------------------------------
//
// Member:     Container_Impl::WndProc, static
//
// Synopsis:   wndproc for the frame.
//
//----------------------------------------------------------------------------
LRESULT CALLBACK Container_Impl::WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	Container_Impl* pCtr;
	
	switch (msg)
	{
	case WM_CREATE:
		::SetWindowLong( hWnd, GWL_USERDATA, (LONG)((LPCREATESTRUCT)lParam)->lpCreateParams );
		return TRUE;
	case WM_DESTROY:
		::SetWindowLong( hWnd, GWL_USERDATA, 0 );
		break;

		// on window.close()
	case WM_PARENTNOTIFY:
		if (LOWORD(wParam) == WM_DESTROY &&
			(pCtr = (Container_Impl*)::GetWindowLong( hWnd, GWL_USERDATA )) &&
			pCtr->m_pController)
		{
			pCtr->m_pController->shutdown();
			break;
		}

	default:
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	}

    return FALSE;
}


