#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:31:17 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=INET
TARGET=imaptest
LIBTARGET=NO

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

CXXFILES=   imaptest.cxx
OBJFILES=   $(OBJ)$/imaptest.obj
SRS1NAME=   imaptest
SRC1FILES=  imaptest.src

#
# IMAPTEST
#

APP1TARGET= $(TARGET)
APP1OBJS=   $(OBJFILES)
APPSTDLIBS=itools.lib svtool.lib svmem.lib ivcl.lib iosl.lib ivos.lib $(ONELIB)\
			$(SLB)$/inetcore.lib $(SLB)$/inetmisc.lib $(SLB)$/inetimp.lib \
			$(SLB)$/inetimap.lib $(SLB)$/crypto.lib $(SLB)$/ssldlg.lib $(SLB)$/inetapi.lib \
			$(SLB)$/inetcach.lib $(SLB)$/inetui.lib
APP1DEPN=   $(L)/itools.lib $(L)/svtool.lib $(L)/ivcl.lib $(L)/iosl.lib $(L)/ivos.lib\
			$(SLB)$/inetcore.lib $(SLB)$/inetmisc.lib $(SLB)$/inetimp.lib \
			$(SLB)$/inetimap.lib $(SLB)$/crypto.lib $(SLB)$/ssldlg.lib $(SLB)$/inetapi.lib \
			$(SLB)$/inetcach.lib $(SLB)$/inetui.lib
APP1DEF=    $(MISC)$/$(APP1TARGET).def
SRSFILES=	$(SRS)$/imaptest.srs
APP1RES=	$(RES)$/imaptest.res

.IF "$(GUI)" == "WNT"
APP1STDLIBS=$(APPSTDLIBS) ivcl.lib iosl.lib advapi32.lib
.ENDIF

.IF "$(GUI)" == "OS2"
APP1STDLIBS=$(APPSTDLIBS) ivcl.lib iosl.lib
.ENDIF

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

# ------------------------------------------------------------------
# Windows
# ------------------------------------------------------------------

.IF "$(GUI)" == "WIN"

$(MISC)$/$(APP1TARGET).def:
    echo  NAME          $(APP1TARGET)                       >$@
    echo  DESCRIPTION   'Testprogramm'                     >>$@
    echo  EXETYPE       WINDOWS                            >>$@
    echo  STUB          'winSTUB.EXE'                      >>$@
    echo  PROTMODE                                         >>$@
    echo  CODE          PRELOAD MOVEABLE DISCARDABLE       >>$@
    echo  DATA          PRELOAD MOVEABLE MULTIPLE          >>$@
    echo  HEAPSIZE      8192                               >>$@
    echo  STACKSIZE     32768                              >>$@

.ENDIF

# ------------------------------------------------------------------
# OS2
# ------------------------------------------------------------------

.IF "$(GUI)" == "OS2"

$(MISC)$/$(APP1TARGET).def:
    echo  NAME          $(APP1TARGET) WINDOWAPI             >$@
    echo  DESCRIPTION   'Testprogramm'                     >>$@
.IF "$(COM)"=="MTW"
    echo  PROTMODE                                         >>$@
    echo  CODE          LOADONCALL                         >>$@
    echo  DATA          PRELOAD MULTIPLE                   >>$@
    echo  HEAPSIZE      32768                              >>$@
    echo  STACKSIZE     32768                              >>$@
.ELSE
.IF "$(COM)" != "BLC"
    echo  STUB          'os2STUB.EXE'                      >>$@
.ENDIF
    echo  EXETYPE       OS2                                >>$@
    echo  PROTMODE                                         >>$@
    echo  CODE          LOADONCALL                         >>$@
    echo  DATA          PRELOAD MULTIPLE                   >>$@
    echo  HEAPSIZE      8192                               >>$@
    echo  STACKSIZE     32768                              >>$@
.ENDIF

.ENDIF
