/*************************************************************************
 *
 *  $RCSfile: plugtest.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:31:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _PLUGTEST_HXX
#define _PLUGTEST_HXX

#ifndef _SVWINDOW_HXX
#include <svwindow.hxx>
#endif

#define TRACE_VERSION	"0.01"
#define MAX_ENTRYS		500

#define BUTTON_LOAD		1
#define BUTTON_STOP		2
#define BUTTON_NODOWN	3
#define BUTTON_READONLY	4
#define BUTTON_ASYNC	5
#define BUTTON_FULL		6
#define BUTTON_EMBED	7
#define BUTTON_TRACE	8
#define BUTTON_LIST		9
#define BUTTON_URL		10

class MyWin;
class PlugWin;

//=============================================================================
class MyApp : public Application
{
public:
    void Main( int, char* [] );
};

//=============================================================================
class URLEdit : public Edit
{
	MyWin*	pMaster;
public:
					URLEdit( MyWin* pWin );
	virtual void	KeyInput( const KeyEvent& rKEvent );
};

//=============================================================================
class SpyWin : public DockingWindow
{
	PlugWin*		pPlugWin;

	MultiLineEdit*	pEdit;
	ListBox*		pList;
public:
			SpyWin(Window* pParent, WinBits nWinBits,PlugWin* pPlug);
			~SpyWin();

	void			Resize();

	void			StartNewPlug();

	void			ShowPlugTrace();
	void			ShowPlugList();

	DECL_LINK( SpyHdl, char* );
};

//=============================================================================
class PlugWin : public DockingWindow
{
	INetWrapper*	pINetWrapper;
	INetSessionRef	xSession;
	PlugInManager* 	pManager;

	SpyWin*			pSpyWin;
	Window*			pPlug;
	PlugInMode		eMode;

	BOOL 			bNoDown;
	BOOL			bAsReadOnly;
	BOOL			bAsync;
public:
			PlugWin(Window* pParent, WinBits nWinBits, Window* pHdlPar);
			~PlugWin();

	void			Resize();

	void			SetSpyWin( SpyWin* pNew ) { pSpyWin = pNew; }
	PlugInManager*	GetManager() const  { return pManager; }
	Window*			GetPlug() const { return pPlug; }

	void 			SetPlugInMode( PlugInMode eNewMode ) { eMode = eNewMode; }

	void			SetNoDown()	{ bNoDown = TRUE; }
	void 			ClearNoDown() { bNoDown = FALSE; }

	void 			SetReadOnly()	{ bAsReadOnly = TRUE; }
	void 			ClearReadOnly() { bAsReadOnly = FALSE; }

	void 			SetAsync()		{ bAsync = TRUE; }
	void 			ClearAsync()	{ bAsync = FALSE; }

	void			LoadPlugIn( INetURLObject& rURL );
	void			StopRunningPlug();
};

//=============================================================================
class MyWin : public WorkWindow
{
	SplitWindow*	pMainWin;
	PlugWin*		pPlugWin;
	SpyWin*			pSpyWin;

	ToolBox*		pBox;
	URLEdit*		pURL;
	StatusBar*		pStatus;
public:
            MyWin( Window* pParent, WinBits nWinStyle );
			~MyWin();

	void    Resize();
    void    KeyInput( const KeyEvent& rKEvt );

	DECL_LINK( InfoHdl, String* );
	DECL_LINK( GetURLHdl, String* );
	DECL_LINK( StatusHdl, PlugInLoadStatus* );
	DECL_LINK( SelectHdl, ToolBox* );

	void	LoadFromServer( String& rURLString );
};

#endif

