/*************************************************************************
 *
 *  $RCSfile: svdem.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:31:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_HELP_HXX
#include <vcl/help.hxx>
#endif

#ifndef _SV_MENU_HXX
#include <vcl/menu.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

#ifndef NOOLDSV
#include <vcl/system.hxx>
#endif

#ifndef _INETWRAP_HXX
#include "inetwrap.hxx"
#endif

#ifndef _INETFILE_HXX
#include "inetfile.hxx"
#endif

#ifndef _INETSESS_HXX
#include "inetsess.hxx"
#endif

#ifndef _INETMAIN_HXX
#include "inetmain.hxx"
#endif

// -----------------------------------------------------------------------

class MyApp : public Application
{
public:
    virtual void Main (
#ifndef VCL
		int, char* []
#endif /* VCL */
	);
};

// -----------------------------------------------------------------------

MyApp aMyApp;

// -----------------------------------------------------------------------

class MyWin : public WorkWindow
{
    PopupMenu   aBookmarkMenu;
    String      aURL;

public:
                MyWin( Window* pParent, WinBits nWinStyle );

    void        Paint( const Rectangle& );
    void        MouseButtonDown( const MouseEvent& rMEvt );

                DECL_LINK( AddBookmarkHdl, INetFileDialog* );
                DECL_LINK( GetBookmarkHdl, INetFileDialog* );
};

// -----------------------------------------------------------------------

void MyApp::Main (
#ifndef VCL
	int, char* []
#endif /* VCL */
)
{
    EnableSVLook();
#ifndef NOOLDSV
    SetAppFont( System::GetStandardFont( STDFONT_APP ) );
#endif /* NOOLDSV */
    Help::EnableContextHelp();
    Help::EnableExtHelp();
    Help::EnableQuickHelp();
    Help aHelp;
    SetHelp( &aHelp );

    MyWin aMainWin( NULL, WB_APP | WB_STDWORK );

    aMainWin.SetText( "Star-View - Workbench" );
    aMainWin.Show();

    Execute();
}

// -----------------------------------------------------------------------

MyWin::MyWin( Window* pParent, WinBits nWinStyle ) :
            WorkWindow( pParent, nWinStyle )
{
    aBookmarkMenu.InsertItem( 1, "ftp://ftp.stardiv.de" );
    aBookmarkMenu.InsertItem( 2, "ftp://ftp.stardiv.de/bin/" );
    aBookmarkMenu.InsertItem( 3, "ftp://rabbit.stardiv.de" );
    aBookmarkMenu.InsertItem( 4, "ftp://rabbit.stardiv.de/bin/" );
    aBookmarkMenu.InsertItem( 5, "ftp://th.stardiv.de" );
    aBookmarkMenu.InsertItem( 6, "ftp://th.stardiv.de/bin/" );
}

// -----------------------------------------------------------------------

void MyWin::Paint( const Rectangle& )
{
    DrawText( Point( 10, 10 ), aURL );
}

// -----------------------------------------------------------------------

void MyWin::MouseButtonDown( const MouseEvent& rMEvt )
{
    INetWrapper* pWrapper = new INetWrapper;
    INetSession* pSession = pWrapper->NewINetSession();

    if ( !pSession )
    {
        InfoBox( this, "keine Session" ).Execute();
        delete pWrapper;
        return;
    }

    INetFileDialog* pDlg;
    if ( rMEvt.IsLeft() )
        pDlg = pWrapper->NewINetFileDialog( this, WB_OPEN | WB_STDMODAL | WB_SVLOOK );
    else
        pDlg = pWrapper->NewINetFileDialog( this, WB_SAVEAS | WB_STDMODAL | WB_SVLOOK );

    pDlg->SetSession( pSession );
    CheckBox* pBtn1 = new CheckBox( pDlg );
    pBtn1->SetText( "Nur lesen" );
    pBtn1->Show();
    PushButton* pBtn2 = new PushButton( pDlg );
    pBtn2->SetText( "Filesystem" );
    pBtn2->Show();

    pDlg->SetBookmarkMenu( &aBookmarkMenu );
    pDlg->SetAddBookmarkHdl( LINK( this, MyWin, AddBookmarkHdl ) );
    pDlg->SetGetBookmarkHdl( LINK( this, MyWin, GetBookmarkHdl ) );
    pDlg->AddURL( "ftp://ftp.stardiv.de" );
    pDlg->AddURL( "ftp://ftp.stardiv.de/bin/" );
    pDlg->AddURL( "ftp://rabbit.stardiv.de" );
    pDlg->AddURL( "ftp://rabbit.stardiv.de/bin/" );
    pDlg->AddFilter( "Alle Dateien", "*" );
    pDlg->AddFilter( "ASCII", "*.txt" );
    pDlg->AddFilter( "StarWriter", "*.sdw" );
    if ( pDlg->Execute() )
    {
        if ( pDlg->GetFtpConnection() )
            delete pDlg->GetFtpConnection();
        aURL = pDlg->GetURL();
        Invalidate();
    }

    delete pBtn1;
    delete pBtn2;
    delete pDlg;
    delete pSession;
    delete pWrapper;
}

// -----------------------------------------------------------------------

IMPL_LINK( MyWin, AddBookmarkHdl, INetFileDialog*, pDlg )
{
    String aPath = pDlg->GetURL();
    if ( aPath.Len() )
    {
        PopupMenu* pMenu = pDlg->GetBookmarkMenu();
        BOOL bFound = FALSE;
        for ( USHORT i = 0; i < pMenu->GetItemCount(); i++ )
        {
            if ( pMenu->GetItemText( i+1 ) == aPath )
            {
                bFound = TRUE;
                break;
            }
        }
        if ( !bFound )
            pMenu->InsertItem( pMenu->GetItemCount()+1, pDlg->GetURL() );
    }

    return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( MyWin, GetBookmarkHdl, INetFileDialog*, pDlg )
{
    PopupMenu* pMenu = pDlg->GetBookmarkMenu();
    pDlg->SetURL( pMenu->GetItemText( pDlg->GetBookmarkId() ) );
    return 0;
}
