/*************************************************************************
 *
 *  $RCSfile: Bootstrap.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:27:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

package com.sun.star.comp.bootstrap;


import com.sun.star.comp.loader.JavaLoader;

import com.sun.star.lang.XInitialization;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XSingleServiceFactory;

import com.sun.star.loader.CannotActivateFactoryException;
import com.sun.star.loader.XImplementationLoader;

import com.sun.star.registry.XSimpleRegistry;

import com.sun.star.uno.UnoRuntime;


public class Bootstrap {
	public static XMultiServiceFactory createDefaultRegistrayServiceFactory() throws CannotActivateFactoryException, com.sun.star.uno.Exception {
		XImplementationLoader xImplementationLoader = new JavaLoader();

		Object smgr_fac   = xImplementationLoader.activate("com.sun.star.comp.servicemanager.ServiceManager", null, "file:///usr/local/kr/JavaUNO/jurt/unxlngi3.pro/class", null) ;
		Object simreg_fac = xImplementationLoader.activate("com.sun.star.comp.simpleregistry.SimpleRegistry", null, "file:///usr/local/kr/JavaUNO/jurt/unxlngi3.pro/class", null) ;

		Object smgr = ((XSingleServiceFactory)UnoRuntime.queryInterface(XSingleServiceFactory.class, smgr_fac)).createInstance();
		Object simreg = ((XSingleServiceFactory)UnoRuntime.queryInterface(XSingleServiceFactory.class, simreg_fac)).createInstance();

		XSimpleRegistry simreg_xSimpleRegistry = (XSimpleRegistry)UnoRuntime.queryInterface(XSimpleRegistry.class, simreg);
		simreg_xSimpleRegistry.open("file:///usr/local/kr/test.reg", false, true);

		XInitialization smgr_xInitialization = (XInitialization)UnoRuntime.queryInterface(XInitialization.class, smgr);
		smgr_xInitialization.initialize(new Object[]{simreg_xSimpleRegistry});


		return (XMultiServiceFactory)UnoRuntime.queryInterface(XMultiServiceFactory.class, smgr);
	}
}


