/*************************************************************************
 *
 *  $RCSfile: IMessage.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:27:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

package com.sun.star.lib.uno.environments.remote;


import java.io.IOException;
import java.io.OutputStream;

/**
 * The purpose of this class is to be an abstraction
 * for messages for remote communication.
 * <p>
 * @version 	$Revision: 1.1.1.1 $ $ $Date: 2000/09/18 15:27:52 $
 * @author 	    Kay Ramme
 * @since       UDK1.0
 */
public interface IMessage {
	/**
	 * Gets the operation name of this message.
	 *<p>
	 * @return  the name of the operation or null if it is a reply
	 */
	String getOperation();

	/**
	 * Gets the thread id of the message.
	 *<p>
	 * @return  the thread id
	 */
	ThreadID getThreadID();

	/**
	 * Gets the interface of the target object.
	 *<p>
	 * @return  the interface
	 */
	Class getInterface();

	/**
	 * Determines if the message is synchron or asynchron
	 *<p>
	 * @return  <code>true</code>, if synchron else <code>false</code>
	 */
	boolean isSynchron();

	/**
	 * Determines if the message an exceptions
	 *<p>
	 * @return  <code>true</code>, if exceptions else <code>false</code>
	 */
	boolean isException();

	/**
	 * Gets the oid of the target object
	 *<p>
	 * @return  the oid
	 */
	String getOid();

	/**
	 * Gets the data of the request or reply
	 *<p>
	 * @return  the result, if it is a reply
	 * @param   params    the in parameters if it is a request otherwiese the out parameters
	 */
	Object getData(Object params[][]) throws Exception;
}


