/*************************************************************************
 *
 *  $RCSfile: SCalc.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:27:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


package com.sun.star.demo;


import com.sun.star.bridge.XUnoUrlResolver;

// base interface
import com.sun.star.uno.XInterface;

// access the implementations via names
import com.sun.star.comp.servicemanager.ServiceManager;


import com.sun.star.lang.XMultiServiceFactory;

import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XInterface;
import com.sun.star.uno.XNamingService;


// staroffice interfaces to provide desktop and componentloader
// and components i.e. spreadsheets, writerdocs etc.
import com.sun.star.frame.XDesktop;
import com.sun.star.frame.XComponentLoader;

// additional classes required for testcase
//  import com.sun.star.sheet.*;
//  import com.sun.star.container.*;
//  import com.sun.star.table.*;
//  import com.sun.star.beans.*;
//  import com.sun.star.style.*;
//  import com.sun.star.lang.*;
//  import com.sun.star.text.*;
//  import com.sun.star.chart.*;
//  import com.sun.star.document.*;

import com.sun.star.frame.XDesktop;

import com.sun.star.sheet.XSpreadsheetDocument;
import com.sun.star.sheet.XSpreadsheet;
import com.sun.star.container.XIndexAccess;
import com.sun.star.table.XCellRange;
import com.sun.star.sheet.XCellRangeAddressable;
import com.sun.star.table.CellRangeAddress;
import com.sun.star.table.XTableChartsSupplier;
import com.sun.star.table.XTableCharts;
import com.sun.star.container.XNameAccess;
import com.sun.star.document.XEmbeddedObjectSupplier;
import com.sun.star.chart.XChartDocument;
import com.sun.star.chart.XDiagram;
import com.sun.star.beans.XPropertySet;
import com.sun.star.lang.XComponent;
import com.sun.star.beans.PropertyValue;
import com.sun.star.sheet.XSpreadsheetDocument;
import com.sun.star.table.XCell;
import com.sun.star.text.XText;
import com.sun.star.text.XTextCursor;

import com.sun.star.sheet.XSpreadsheets;
import com.sun.star.table.XTableChart;

import com.sun.star.bridge.XBridgeFactory;
import com.sun.star.bridge.XBridge;

import com.sun.star.awt.Rectangle;

public class SCalc  {
	static String neededServices[] = new String[] {
		"com.sun.star.comp.servicemanager.ServiceManager",
		"com.sun.star.comp.loader.JavaLoader",
		"com.sun.star.comp.connections.Connector",
		"com.sun.star.comp.bridgefactory.BridgeFactory",
		"com.sun.star.comp.urlresolver.UrlResolver"
	};


	static public void main(String args[]) throws com.sun.star.lang.IndexOutOfBoundsException{
		if(args.length != 1)	{
			System.err.println("usage : SCalc uno:connection;protocol;objectName");
			System.exit(-1);
		}

		XMultiServiceFactory xMSF = null;
		String connectStr=""; 
		XSpreadsheetDocument myDoc = null;
		XCell oCell = null;
		

		// create connection(s) and get multiservicefactory
		System.out.println( "getting MultiServiceFactory" );  

		try {
			xMSF = connect(args[0]);
		} catch( Exception Ex ) {
			System.out.println( "Couldn't get MSF"+ Ex );
		}
	    
	    
		//Open document

		//Calc
   
		System.out.println("Opening an empty Calc document");
		myDoc = openCalc(xMSF);
    
		XSpreadsheet oSheet=null;
    
		try {
			System.out.println("Getting spreadsheet") ;
			XSpreadsheets oSheets = myDoc.getSheets() ;
			XIndexAccess oIndexSheets = (XIndexAccess) UnoRuntime.queryInterface(XIndexAccess.class, oSheets);
			oSheet = (XSpreadsheet) oIndexSheets.getByIndex(0);
		  		  
		} catch (Exception e) {
			System.out.println("Couldn't get Sheet " +e);
		}
	
	
	
		System.out.println("Creating the Header") ;
	
		insertIntoCell(1,0,"JAN",oSheet);
		insertIntoCell(2,0,"FEB",oSheet);
		insertIntoCell(3,0,"MAR",oSheet);
		insertIntoCell(4,0,"APR",oSheet);
		insertIntoCell(5,0,"MAI",oSheet);
		insertIntoCell(6,0,"JUN",oSheet);
		insertIntoCell(7,0,"JUL",oSheet);
		insertIntoCell(8,0,"AUG",oSheet);
		insertIntoCell(9,0,"SEP",oSheet);
		insertIntoCell(10,0,"OCT",oSheet);
		insertIntoCell(11,0,"NOV",oSheet);
		insertIntoCell(12,0,"DEC",oSheet);
		insertIntoCell(13,0,"SUM",oSheet);
	
	
		System.out.println("Fill the lines");
	
		insertIntoCell(0,1,"Smith",oSheet);
		insertIntoCell2(1,1,"42",oSheet,"V");
		insertIntoCell2(2,1,"58.9",oSheet,"V");
		insertIntoCell2(3,1,"-66.5",oSheet,"V");
		insertIntoCell2(4,1,"43.4",oSheet,"V");
		insertIntoCell2(5,1,"44.5",oSheet,"V");
		insertIntoCell2(6,1,"45.3",oSheet,"V");
		insertIntoCell2(7,1,"-67.3",oSheet,"V");
		insertIntoCell2(8,1,"30.5",oSheet,"V");
		insertIntoCell2(9,1,"23.2",oSheet,"V");
		insertIntoCell2(10,1,"-97.3",oSheet,"V");
		insertIntoCell2(11,1,"22.4",oSheet,"V");
		insertIntoCell2(12,1,"23.5",oSheet,"V");
		insertIntoCell2(13,1,"=SUM(B2:M2)",oSheet,"");

    
		insertIntoCell(0,2,"Jones",oSheet);
		insertIntoCell2(1,2,"21",oSheet,"V");
		insertIntoCell2(2,2,"40.9",oSheet,"V");
		insertIntoCell2(3,2,"-57.5",oSheet,"V");
		insertIntoCell2(4,2,"-23.4",oSheet,"V");
		insertIntoCell2(5,2,"34.5",oSheet,"V");
		insertIntoCell2(6,2,"59.3",oSheet,"V");
		insertIntoCell2(7,2,"27.3",oSheet,"V");
		insertIntoCell2(8,2,"-38.5",oSheet,"V");
		insertIntoCell2(9,2,"43.2",oSheet,"V");
		insertIntoCell2(10,2,"57.3",oSheet,"V");
		insertIntoCell2(11,2,"25.4",oSheet,"V");
		insertIntoCell2(12,2,"28.5",oSheet,"V");
		insertIntoCell2(13,2,"=SUM(B3:M3)",oSheet,"");


		insertIntoCell(0,3,"Brown",oSheet);
		insertIntoCell2(1,3,"31.45",oSheet,"V");
		insertIntoCell2(2,3,"-20.9",oSheet,"V");
		insertIntoCell2(3,3,"-117.5",oSheet,"V");
		insertIntoCell2(4,3,"23.4",oSheet,"V");
		insertIntoCell2(5,3,"-114.5",oSheet,"V");
		insertIntoCell2(6,3,"115.3",oSheet,"V");
		insertIntoCell2(7,3,"-171.3",oSheet,"V");
		insertIntoCell2(8,3,"89.5",oSheet,"V");
		insertIntoCell2(9,3,"41.2",oSheet,"V");
		insertIntoCell2(10,3,"71.3",oSheet,"V");
		insertIntoCell2(11,3,"25.4",oSheet,"V");
		insertIntoCell2(12,3,"38.5",oSheet,"V");
		insertIntoCell2(13,3,"=SUM(A4:L4)",oSheet,""); 


		// insert a chart
    
		Rectangle oRect = new Rectangle();
		oRect.X = 500;
		oRect.Y = 3000;
		oRect.Width = 25000;
		oRect.Height = 11000;
    
		XCellRange oRange = (XCellRange)UnoRuntime.queryInterface(XCellRange.class, oSheet);
		XCellRange myRange = oRange.getCellRangeByName("A1:n4");
		XCellRangeAddressable oRangeAddr = (XCellRangeAddressable)UnoRuntime.queryInterface(XCellRangeAddressable.class, myRange);
		CellRangeAddress myAddr = oRangeAddr.getRangeAddress();

		CellRangeAddress[] oAddr = new CellRangeAddress[1];
		oAddr[0] = myAddr;
		XTableChartsSupplier oSupp = (XTableChartsSupplier)UnoRuntime.queryInterface(XTableChartsSupplier.class, oSheet);
    
		XTableChart oChart = null;
    
		System.out.println("Insert Chart");

		XTableCharts oCharts = oSupp.getCharts();
		oCharts.addNewByName("Example", oRect, oAddr, true, true);
	
		// Change some of the diagramm properties
	
		try {
			oChart = (XTableChart) ((XNameAccess) UnoRuntime.queryInterface(XNameAccess.class, oCharts)).getByName("Example");
			XEmbeddedObjectSupplier oEOS = (XEmbeddedObjectSupplier) UnoRuntime.queryInterface(XEmbeddedObjectSupplier.class, oChart);
			XInterface oInt = oEOS.getEmbeddedObject();
			XChartDocument xChart = (XChartDocument) UnoRuntime.queryInterface(XChartDocument.class,oInt);
			XDiagram oDiag = (XDiagram) xChart.getDiagram();
			System.out.println("Change Diagramm to 3D");
			XPropertySet oCPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oDiag );
			oCPS.setPropertyValue("Dim3D", new Boolean(true));
			System.out.println("Change the title");
//  	  Thread.sleep(200);
			XPropertySet oTPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, xChart.getTitle() );
			oTPS.setPropertyValue("String","The new title");
			//oDiag.Dim3D();
		} catch (Exception e){
			System.out.println("Changin Properties failed "+e);
		}
	 
	 
	
		//System.out.println("done");	    

//  	System.err.println("#### Calls over all:" + com.sun.star.lib.uno.environments.java.Proxy.__calls);

        System.exit(0);


	} // finish method main

	public static XMultiServiceFactory connect(String unoUrl)
		throws com.sun.star.uno.Exception, 
		com.sun.star.uno.RuntimeException, Exception {

		XMultiServiceFactory xMSF = null;
		// initial serviceManager
		ServiceManager serviceManager = new ServiceManager();
		serviceManager.addFactories( neededServices );

		// create a connector, so that it can contact the office
		Object  resolver  = serviceManager.createInstance("com.sun.star.bridge.UnoUrlResolver" );
		XUnoUrlResolver resolver_xUnoUrlResolver = (XUnoUrlResolver)UnoRuntime.queryInterface(XUnoUrlResolver.class, resolver);

  		Object rInitialObject = resolver_xUnoUrlResolver.resolve(unoUrl);


		XNamingService rName = (XNamingService)UnoRuntime.queryInterface(XNamingService.class, rInitialObject);

		if(rName != null) {
			System.err.println( "got the remote naming service !" );
			Object rXsmgr = rName.getRegisteredObject("StarOffice.ServiceManager" );

			xMSF = (XMultiServiceFactory)UnoRuntime.queryInterface( XMultiServiceFactory.class, rXsmgr);
		}

		return xMSF;
	} /// finish connect

	public static XSpreadsheetDocument openCalc(XMultiServiceFactory oMSF) {
    

		//define variables
		XInterface oInterface;
		XDesktop oDesktop;
		XComponentLoader oCLoader;
		XSpreadsheetDocument oDoc = null;
		XComponent aDoc = null;

		try {

			oInterface = (XInterface) oMSF.createInstance( "com.sun.star.frame.Desktop" );
			oDesktop = ( XDesktop ) UnoRuntime.queryInterface( XDesktop.class, oInterface );
			oCLoader = ( XComponentLoader ) UnoRuntime.queryInterface( XComponentLoader.class, oDesktop );
			PropertyValue [] szEmptyArgs = new PropertyValue [0];
			String doc = "private:factory/scalc";
			aDoc = oCLoader.loadComponentFromURL(doc, "_blank", 0, szEmptyArgs );
			oDoc = (XSpreadsheetDocument) UnoRuntime.queryInterface(XSpreadsheetDocument.class, aDoc);

		} // end of try 

		catch(Exception e){

			System.out.println(" Exception " + e);

		} // end of catch


		return oDoc;
	}//end of openCalc
  
	public static void insertIntoCell(int CellX, int CellY, String theText, XSpreadsheet TT1) throws com.sun.star.lang.IndexOutOfBoundsException {
 
		XCell oCell = TT1.getCellByPosition(CellX, CellY);
		XText oTableText = (XText) UnoRuntime.queryInterface(XText.class, TT1.getCellByPosition(CellX, CellY));
    
		//create a cursor object
		XTextCursor oC = oTableText.createTextCursor();
    
		XPropertySet oTPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oC );
		XPropertySet oCPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oCell );

		try {    
			oCPS.setPropertyValue("IsCellBackgroundTransparent", new Boolean(false));
			oCPS.setPropertyValue("CellBackColor",new Integer(6710932));
			oTPS.setPropertyValue("CharColor",new Integer(16777215));
      
		} catch (Exception e) {
     
			System.out.println("Can't change colors (insertIntoCell) " + e);     
     
		}

    
		//inserting some Text
		oTableText.insertString( oC, theText, true );
  
	} // end of insertIntoCell
 
	public static void insertIntoCell2(int CellX, int CellY, String theValue, XSpreadsheet TT1, String flag) throws com.sun.star.lang.IndexOutOfBoundsException {
 
		XCell oCell = TT1.getCellByPosition(CellX, CellY);
    
		//create a cursor object
    
		XPropertySet oCPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oCell );

		try {    
			oCPS.setPropertyValue("IsCellBackgroundTransparent", new Boolean(false));
			oCPS.setPropertyValue("CellBackColor",new Integer(13421823));
		} catch (Exception e) {
     
			System.out.println("Can't change colors (insertIntoCell2) " + e);
     
		}

    
		//inserting some Text
		if (flag.equals("V")) {oCell.setValue((new Float(theValue)).floatValue());}
		else {oCell.setFormula(theValue);}
  
	} // end of insertIntoCell  
  
} // finish class SCalc
