/*************************************************************************
 *
 *  $RCSfile: SDraw.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:27:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


package com.sun.star.demo;

//  import tools.*;

// base interface
import com.sun.star.uno.XInterface;


import com.sun.star.bridge.XUnoUrlResolver;
// access the implementations via names
import com.sun.star.comp.servicemanager.ServiceManager;


import com.sun.star.lang.XMultiServiceFactory;

import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XInterface;
import com.sun.star.uno.XNamingService;


// staroffice interfaces to provide desktop and componentloader
// and components i.e. spreadsheets, writerdocs etc.
import com.sun.star.frame.XDesktop;
import com.sun.star.frame.XComponentLoader;

// additional classes required for testcase
import com.sun.star.sheet.*;
import com.sun.star.container.*;
import com.sun.star.table.*;
import com.sun.star.beans.*;
import com.sun.star.style.*;
import com.sun.star.lang.*;
import com.sun.star.drawing.*;
import com.sun.star.awt.*;


import com.sun.star.bridge.XBridgeFactory;
import com.sun.star.bridge.XBridge;

public class SDraw  {
	static long waitValue = 2000;  

	static String neededServices[] = new String[] {
		"com.sun.star.comp.servicemanager.ServiceManager",
		"com.sun.star.comp.loader.JavaLoader",
		"com.sun.star.comp.connections.Connector",
		"com.sun.star.comp.bridgefactory.BridgeFactory",
		"com.sun.star.comp.urlresolver.UrlResolver"
	};


	public static void main(String args[]) {
		if(args.length != 1)	{
			System.err.println("usage : SCalc uno:connection;protocol;objectName");
			System.exit(-1);
		}

		XMultiServiceFactory xMSF = null;
		String connectStr=""; 
		XComponent xDrawDoc = null;
		XDrawPage oObj = null;
		XShape oShape = null;
		XShape oShape1 = null;    
		XShapes oShapes = null;
		

		// create connection(s) and get multiservicefactory
		System.out.println( "getting MultiServiceFactory" );  

		try {
			xMSF = connect(args[0]);
		} catch( Exception Ex ) {
			System.out.println( "Couldn't get MSF"+ Ex );
		}
	    
	    
		//Open document

		//Draw
   
		System.out.println("Opening an empty Draw document");
		xDrawDoc = openDraw(xMSF);
    
		// get the drawpage of drawing here
		try {
			System.out.println( "getting Drawpage" );
			XDrawPagesSupplier oDPS = (XDrawPagesSupplier) UnoRuntime.queryInterface(XDrawPagesSupplier.class,xDrawDoc);
			XDrawPages oDPn = oDPS.getDrawPages();
			XIndexAccess oDPi = (XIndexAccess) UnoRuntime.queryInterface(XIndexAccess.class,oDPn);
			oObj = (XDrawPage) UnoRuntime.queryInterface( XDrawPage.class , oDPi.getByIndex(0) );
		} catch ( Exception e ) {
			System.out.println( "Couldn't create document"+ e );
			e.printStackTrace();
		}
	 
		//waitMoment();
		
		//put something on the drawpage
		System.out.println( "inserting some Shapes" );
		oShapes = (XShapes) UnoRuntime.queryInterface(XShapes.class,oObj);
		oShapes.add(createShape(xDrawDoc,2000,1500,1000,1000,"Line",0));
		//waitMoment();
		oShapes.add(createShape(xDrawDoc,3000,4500,15000,1000,"Ellipse",16711680));
		//waitMoment();
		oShapes.add(createShape(xDrawDoc,5000,3500,7500,5000,"Rectangle",6710932));
		//waitMoment();
	
	
		oShape = createShape(xDrawDoc,15000,17500,2000,12000,"Rectangle", 13421823);
		oShapes.add(oShape);	
		//waitMoment();
		XPropertySet oSPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oShape);
		System.out.println("Add a Shadow"); 
		try { 
        
			oSPS.setPropertyValue("Shadow",new Boolean(true));
      
		} catch (Exception e) {
     
			System.out.println("Can't add Shadow " + e);     
     
		}

	    
       
		//System.out.println("done");	    

		System.exit(0);


	} // finish method main
	
	public static XMultiServiceFactory connect(String unoUrl)
		throws com.sun.star.uno.Exception, 
		com.sun.star.uno.RuntimeException, Exception {

		XMultiServiceFactory xMSF = null;
		// initial serviceManager
		ServiceManager serviceManager = new ServiceManager();
		serviceManager.addFactories( neededServices );

		// create a connector, so that it can contact the office
		Object  resolver  = serviceManager.createInstance("com.sun.star.bridge.UnoUrlResolver" );
		XUnoUrlResolver resolver_xUnoUrlResolver = (XUnoUrlResolver)UnoRuntime.queryInterface(XUnoUrlResolver.class, resolver);

  		Object rInitialObject = resolver_xUnoUrlResolver.resolve(unoUrl);


		XNamingService rName = (XNamingService)UnoRuntime.queryInterface(XNamingService.class, rInitialObject);

		if(rName != null) {
			System.err.println( "got the remote naming service !" );
			Object rXsmgr = rName.getRegisteredObject("StarOffice.ServiceManager" );

			xMSF = (XMultiServiceFactory)UnoRuntime.queryInterface( XMultiServiceFactory.class, rXsmgr);
		}

		return xMSF;
	} /// finish connect

	public static XComponent openDraw(XMultiServiceFactory oMSF) {
    

		//define variables
		XInterface oInterface;
		XDesktop oDesktop;
		XComponentLoader oCLoader;
		XComponent aDoc = null;

		try {

			oInterface = (XInterface) oMSF.createInstance( "com.sun.star.frame.Desktop" );
			oDesktop = ( XDesktop ) UnoRuntime.queryInterface( XDesktop.class, oInterface );
			oCLoader = ( XComponentLoader ) UnoRuntime.queryInterface( XComponentLoader.class, oDesktop );
			PropertyValue [] szEmptyArgs = new PropertyValue [0];
			String doc = "private:factory/sdraw";
			aDoc = oCLoader.loadComponentFromURL(doc, "_blank", 0, szEmptyArgs );

		} // end of try 

		catch(Exception e){

			System.out.println(" Exception " + e);

		} // end of catch


		return aDoc;
	}//end of openDraw
  
	public static XShape createShape(XComponent oDoc, int height, int width, int x, int y, String kind, int col) {
		//possible values for kind are 'Ellipse', 'Line' and 'Rectangle'
		Size size = new Size();
		Point position = new Point();
		XShape oShape = null;

		//get MSF
		XMultiServiceFactory oDocMSF = (XMultiServiceFactory) UnoRuntime.queryInterface( XMultiServiceFactory.class, oDoc );

		try{
			Object oInt = oDocMSF.createInstance("com.sun.star.drawing."+kind+"Shape");
			oShape = (XShape)UnoRuntime.queryInterface( XShape.class, oInt );
			size.Height = height;
			size.Width = width;
			position.X = x;
			position.Y = y;
			oShape.setSize(size);
			oShape.setPosition(position);

		} catch ( Exception e ) {
			// Some exception occures.FAILED
			System.out.println( "Couldn't create instance "+ e );
		}
	 
		XPropertySet oSPS = (XPropertySet)UnoRuntime.queryInterface( XPropertySet.class, oShape);
     
		try { 
        
			oSPS.setPropertyValue("FillColor",new Integer(col));
      
		} catch (Exception e) {
     
			System.out.println("Can't change colors " + e);     
     
		}


		return oShape;

	}  
    

	public static void waitMoment() {
 
		try {
    
			Thread.sleep(waitValue);
      
		} catch (Exception e) {
			System.out.println("Can't sleep " + e);
		}

 
	}
  
  
} // finish class SDraw
