/*************************************************************************
 *
 *  $RCSfile: UcbDemo.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:27:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


package com.sun.star.demo;

import com.sun.star.bridge.XBridge;
import com.sun.star.bridge.XBridgeFactory;

import com.sun.star.comp.servicemanager.ServiceManager;

import com.sun.star.connection.XConnector;
import com.sun.star.connection.XConnection;

import com.sun.star.lang.XMultiServiceFactory;

import com.sun.star.ucb.XContentCreator;

import com.sun.star.uno.UnoRuntime;

public class UcbDemo {
	static String neededServices[] = new String[] {
		"com.sun.star.comp.servicemanager.ServiceManager",
		"com.sun.star.comp.loader.JavaLoader",
		"com.sun.star.comp.connections.Connector",
		"com.sun.star.comp.bridgefactory.BridgeFactory"
	};

	static public void main(String args[]) throws Exception {
		if(args.length != 1)	{
			System.err.println("usage : SCalc uno:connection;protocol;objectName");
			System.exit(-1);
		}

		String conDcp = null;
		String protDcp = null;
		String rootOid = null;

		String dcp = args[0];
		
		if(dcp.indexOf(';') == -1) {// use old style
			conDcp = dcp;
			protDcp = "iiop";
			rootOid = "classic_uno";
		}
		else { // new style
			int index = dcp.indexOf(':');
			String url = dcp.substring(0, index).trim();
			dcp = dcp.substring(index + 1).trim();

			index = dcp.indexOf(';');
			conDcp = dcp.substring(0, index).trim();
			dcp = dcp.substring(index + 1).trim();

			index = dcp.indexOf(';');
			protDcp = dcp.substring(0, index).trim();
			dcp = dcp.substring(index + 1).trim();

			rootOid = dcp.trim().trim();
		}


		// create connection(s) and get multiservicefactory
		System.out.println( "getting MultiServiceFactory" );  


		XMultiServiceFactory xMSF = null;
		// initial serviceManager
		ServiceManager serviceManager = new ServiceManager();
		serviceManager.addFactories(neededServices);

		// create a connector, so that it can contact the office
		Object  connector  = serviceManager.createInstance( "com.sun.star.connection.Connector" );
		XConnector connector_xConnector = (XConnector)UnoRuntime.queryInterface( XConnector.class, connector );

		// connect to the office
		XConnection xConnection = connector_xConnector.connect(conDcp);

		XBridgeFactory xBridgeFactory = (XBridgeFactory)UnoRuntime.queryInterface(XBridgeFactory.class, serviceManager.createInstance("com.sun.star.bridge.BridgeFactory"));
		XBridge xBridge = xBridgeFactory.createBridge(conDcp + ";" + protDcp, protDcp, xConnection, null);

  		Object rsm = xBridge.getInstance(rootOid);
		System.err.println("rsm:" + rsm);
		XMultiServiceFactory xMultiServiceFactory_rsm = (XMultiServiceFactory)UnoRuntime.queryInterface(XMultiServiceFactory.class, rsm);
		System.err.println("xMultiServiceFactory_rsm:" + xMultiServiceFactory_rsm);

		Object ucb_sm = xMultiServiceFactory_rsm.createInstance("com.sun.star.lang.ServiceManager");
		System.err.println("ucb_sm:" + ucb_sm);
		XMultiServiceFactory xMultiServiceFactory_ucb_sm = (XMultiServiceFactory)UnoRuntime.queryInterface(XMultiServiceFactory.class, ucb_sm);
		System.err.println("xMultiServiceFactory_ucb_sm:" + xMultiServiceFactory_ucb_sm);

		Object ucb = xMultiServiceFactory_ucb_sm.createInstance("com.sun.star.ucb.UniversalContentBroker");
		System.err.println("the ucb:" + ucb);


		XContentCreator xContentCreator = (XContentCreator)UnoRuntime.queryInterface(XContentCreator.class, ucb);
		System.err.println("the xContentCreator:" + xContentCreator);
	}
}
