#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 15:27:55 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..$/..$/..$/..$/..

PRJNAME := jurt
PACKAGE := com$/sun$/star$/lib$/uno$/protocols
TARGET  := test_com_sun_star_lib_uno_protocols

# --- Settings -----------------------------------------------------

.INCLUDE : $(PRJ)$/util$/makefile.pmk

# Files --------------------------------------------------------


APPLICATRDB := $(SOLARBINDIR)$/applicat.rdb

INTERFACES=$(MISC)$/interfaces.rdb

UNOUCRDEP=$(APPLICATRDB)
UNOUCRRDB=$(APPLICATRDB)  $(INTERFACES)

UNOUCROUT=$(OUT)$/inc

RDB := $(APPLICATRDB) $(INTERFACES)




GENJAVAFILES= \
	$(MISC)$/java$/test$/BEnum.java					\
	$(MISC)$/java$/test$/InterfaceStruct.java		\
	$(MISC)$/java$/test$/PrimitiveStruct.java		\
	$(MISC)$/java$/test$/PrimitiveSeqStruct.java	\
	$(MISC)$/java$/test$/NestedStruct.java			\
	$(MISC)$/java$/test$/NestedSeqStruct.java		\
	$(MISC)$/java$/test$/XTestInterface.java	


JAVACLASSFILES= \
	$(CLASSDIR)$/$(PACKAGE)$/TestObject.class		\
	$(CLASSDIR)$/$(PACKAGE)$/TestBridge.class		\
	$(CLASSDIR)$/$(PACKAGE)$/InstanceProvider.class	\
	$(CLASSDIR)$/$(PACKAGE)$/Marshaling_Test.class	\
	$(CLASSDIR)$/$(PACKAGE)$/Protocol_Test.class

TYPES={$(subst,.class, $(subst,$/,.  $(subst,$(CLASSDIR)$/,-T  $(GENJAVACLASSFILES))))}
#GENJAVAFILES = {$(subst,.class,.java $(subst,$/class, $(GENJAVACLASSFILES)))}
JAVAFILES= $(subst,$(CLASSDIR)$/$(PACKAGE)$/, $(subst,.class,.java $(JAVACLASSFILES))) $(GENJAVAFILES) 

JARFILES = sandbox.jar 

# --- Targets ------------------------------------------------------

.IF "$(depend)" == ""
ALL : $(GENJAVAFILES) ALLTAR 
.ELSE
ALL: ALLDEP
.ENDIF


$(GENJAVAFILES): $(INTERFACES)

%.java:
	javamaker -BUCR -O$(MISC)$/java $(subst,$(MISC)$/java$/,-T  $*) $(RDB)


XCLASSPATH:=$(XCLASSPATH):$(CLASSDIR)$/japi



$(INTERFACES) : interfaces.idl 
	unoidl -Burd $(UNOIDLINC) -OH$(OUT)$/ucr$/$(IDLPACKAGE) interfaces.idl 
	regmerge $(INTERFACES) /UCR $(OUT)$/ucr$/$(IDLPACKAGE)$/interfaces.urd


.INCLUDE :  target.mk

