/*************************************************************************
 *
 *  $RCSfile: lngprops.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:31:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _LINGU_LNGPROPS_HHX_
#define _LINGU_LNGPROPS_HHX_

#define UPN_IS_GERMAN_PRE_REFORM		"IsGermanPreReform"

// UNO property names for SpellChecker
#define UPN_IS_SPELL_UPPER_CASE			"IsSpellUpperCase"
#define UPN_IS_SPELL_WITH_DIGITS		"IsSpellWithDigits"
#define UPN_IS_SPELL_CAPITALIZATION		"IsSpellCapitalization"

// UNO property names for Hyphenator
#define UPN_HYPH_MIN_LEADING			"HyphMinLeading"
#define UPN_HYPH_MIN_TRAILING			"HyphMinTrailing"
#define UPN_HYPH_MIN_WORD_LENGTH		"HyphMinWordLength"

// UNO property names for OtherLingu (foreign Linguistik)
#define UPN_IS_STANDARD_HYPHENATOR		"IsStandardHyphenator"
#define UPN_IS_STANDARD_SPELL_CHECKER	"IsStandardSpellChecker"
#define UPN_IS_STANDARD_THESAURUS		"IsStandardThesaurus"
#define UPN_OTHER_LINGU_INDEX			"OtherLinguIndex"

// UNO property names for Lingu
// (those not covered by the SpellChecker, Hyphenator and OtherLingu properties
// and more likely used in documents only)
#define UPN_DEFAULT_LANGUAGE			"DefaultLanguage"
#define UPN_DEFAULT_LOCALE				"DefaultLocale"
#define UPN_IS_HYPH_AUTO				"IsHyphAuto"
#define UPN_IS_HYPH_SPECIAL				"IsHyphSpecial"
#define UPN_IS_SPELL_AUTO				"IsSpellAuto"
#define UPN_IS_SPELL_HIDE				"IsSpellHide"
#define UPN_IS_SPELL_IN_ALL_LANGUAGES	"IsSpellInAllLanguages"
#define UPN_IS_SPELL_SPECIAL			"IsSpellSpecial"
#define UPN_IS_WRAP_REVERSE				"IsWrapReverse"

// WIDs for property names
#define WID_IS_SPELL_UPPER_CASE			 0
#define WID_IS_SPELL_WITH_DIGITS		 1
#define WID_IS_SPELL_CAPITALIZATION		 2
#define WID_HYPH_MIN_LEADING			 3
#define WID_HYPH_MIN_TRAILING			 4
#define WID_HYPH_MIN_WORD_LENGTH		 5
#define WID_IS_STANDARD_HYPHENATOR		 6
#define WID_IS_STANDARD_SPELL_CHECKER	 7
#define WID_IS_STANDARD_THESAURUS		 8
#define WID_OTHER_LINGU_INDEX			 9
#define WID_DEFAULT_LANGUAGE			10
#define WID_IS_HYPH_AUTO				11
#define WID_IS_HYPH_SPECIAL				12
#define WID_IS_HYPH_WITH_REQUEST		13
#define WID_IS_HYPH_WRAP_AROUND			14
#define WID_IS_SPELL_AUTO				15
#define WID_IS_SPELL_HIDE				16
#define WID_IS_SPELL_IN_ALL_LANGUAGES	17
#define WID_IS_SPELL_SPECIAL			18
#define WID_IS_SPELL_WRAP_AROUND		19
#define WID_IS_WRAP_REVERSE				20
#define WID_IS_GERMAN_PRE_REFORM		21
#define WID_DEFAULT_LOCALE				22

#endif


