/*************************************************************************
 *
 *  $RCSfile: appimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFF_APPIMP_HXX
#define _OFF_APPIMP_HXX

#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif

#include <tools/string.hxx>

#ifndef _COM_SUN_STAR_LINGUISTIC_XSPELLCHECKER1_HPP_
#include <com/sun/star/linguistic/XSpellChecker1.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XHYPHENATOR_HPP_
#include <com/sun/star/linguistic/XHyphenator.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XDICTIONARYLIST_HPP_
#include <com/sun/star/linguistic/XDictionaryList.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUISTIC_XTHESAURUS_HPP_
#include <com/sun/star/linguistic/XThesaurus.hpp>
#endif

class OfaHtmlOptions;
class OfaAutoCorrCfg;
class BasicIDE;
class XColorTable;
class XOutdevItemPool;
class SpellNotifier;
class Config;
class SfxBroadcaster;
class OfaFilterOptions;
class OfaTabAppearanceCfg;

// struct OfficeData_Impl ------------------------------------------------

class OfficeData_Impl : public SfxListener
{
	friend class OfficeApplication;
	OfaHtmlOptions*		pHtmlOptions;
	OfaAutoCorrCfg*		pAutoCorrCfg;
	::com::sun::star::uno::Reference<
		::com::sun::star::linguistic::XThesaurus > 		xThesaurus;
	::com::sun::star::uno::Reference<
		::com::sun::star::linguistic::XSpellChecker1 > 	xSpellChecker;
	::com::sun::star::uno::Reference<
		::com::sun::star::linguistic::XHyphenator > 	xHyphenator;
	::com::sun::star::uno::Reference<
		::com::sun::star::linguistic::XDictionaryList > xDicList;
	Config*				pSearchEngCfg;
	Config*				pFontSubstCfg;
	BasicIDE*			pBasicIDE;
	XColorTable*		pStdColorTable;
	XOutdevItemPool*	pXOutdevItemPool;
	OfaTabAppearanceCfg* pTabAppearanceConfig;
	SpellNotifier*		pSpellNote;
	void				(*pWordDeInitFct)();
	OfaFilterOptions*	pFilterOptions;
	sal_uInt32			nChangeUserDataEvent;
	String				aMailTempPath;
	sal_Bool			bDoSearchCfg;

	virtual void		Notify( SfxBroadcaster& rBC, const SfxHint& rHint );

public:
	OfficeData_Impl( SfxBroadcaster& rBroadcast );
};

#endif // #ifndef _OFF_APPIMP_HXX


