/*************************************************************************
 *
 *  $RCSfile: ofaaccfg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFAACCFG_HXX
#define _OFAACCFG_HXX

// include ---------------------------------------------------------------

#ifndef	_SFXCFGITEM_HXX
#include <sfx2/cfgitem.hxx>
#endif

class SvxAutoCorrect;

/*--------------------------------------------------------------------
	Beschreibung:   Konfiguration fuer Auto Correction
 --------------------------------------------------------------------*/

class OfaAutoCorrCfg : public SfxConfigItem
{
private:
	SvxAutoCorrect*	pAutoCorrect;

	// Flags f"ur Autotext:
	BOOL	bFileRel : 1;
	BOOL	bNetRel : 1;
	// Tiphilfe f"ur Autotext w"ahrend der Eingabe
	BOOL	bAutoTextTip : 1;
	BOOL	bAutoFmtByInput : 1;

public:
		  SvxAutoCorrect* GetAutoCorrect()			{ return pAutoCorrect; }
	const SvxAutoCorrect* GetAutoCorrect() const	{ return pAutoCorrect; }
	// der Pointer geht in den Besitz des ConfigItems!
	void SetAutoCorrect( SvxAutoCorrect* );

	BOOL IsAutoFmtByInput() const 		{ return bAutoFmtByInput; }
	void SetAutoFmtByInput( BOOL bSet ) { bAutoFmtByInput = bSet;SetDefault(FALSE);}

	BOOL IsSaveRelFile() const 			{ return bFileRel; }
	void SetSaveRelFile( BOOL bSet ) 	{ bFileRel = bSet; SetDefault(FALSE); }

	BOOL IsSaveRelNet() const 			{ return bNetRel; }
	void SetSaveRelNet( BOOL bSet ) 	{ bNetRel = bSet; SetDefault(FALSE);}

	BOOL IsAutoTextTip() const 			{ return bAutoTextTip; }
	void SetAutoTextTip(BOOL bSet )  	{ bAutoTextTip = bSet;SetDefault(FALSE);}

	// geerbte Funktionalit"at
	virtual String	GetName() const;
	virtual int     Load( SvStream& );
	virtual BOOL    Store( SvStream& );
	virtual void    UseDefault();

	OfaAutoCorrCfg();
	virtual ~OfaAutoCorrCfg();
};


#endif

