/*************************************************************************
 *
 *  $RCSfile: apearcfg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFA_APEARCFG_HXX
#define _OFA_APEARCFG_HXX

#ifndef _SFXCFGITEM_HXX //autogen
#include <sfx2/cfgitem.hxx>
#endif

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

class OfaTabAppearanceCfg : public SfxConfigItem
{
	USHORT			nLookNFeel   ;
	USHORT			nDragMode    ;
	USHORT          nScaleFactor ;
	USHORT          nSnapMode    ;

	BOOL			bMenuMouseFollow		:1;
	BOOL			bMenuMouseFollowValid	:1;
	BOOL            bSingleLineTabCtrl		:1;
	BOOL            bSingleLineTabCtrlValid	:1;
	BOOL            bColoredTabCtrl			:1;
	BOOL            bColoredTabCtrlValid	:1;


	static Boolean  bInitialized ;

public:
	OfaTabAppearanceCfg( );

	virtual String	GetName() const;
	virtual int     Load   (SvStream&);
	virtual BOOL    Store  (SvStream&);
	virtual void    UseDefault();

	USHORT		GetLookNFeel () const { return nLookNFeel; }
	void		SetLookNFeel ( USHORT nSet );

	USHORT		GetDragMode  () const { return nDragMode; }
	void		SetDragMode  ( USHORT nSet );

	USHORT		GetScaleFactor () const { return nScaleFactor; }
	void		SetScaleFactor ( USHORT nSet );

	USHORT		GetSnapMode () const { return nSnapMode; }
	void		SetSnapMode ( USHORT nSet );

	void        SetApplicationDefaults ( Application* pApp );

	void		SetMenuMouseFollow(BOOL bSet) {bMenuMouseFollow = bSet; bMenuMouseFollowValid = TRUE; SetDefault(FALSE);}
	BOOL		IsMenuMouseFollow() const{return bMenuMouseFollow;}
	BOOL		IsMenuMouseFollowValid() const {return bMenuMouseFollowValid;}

	void        SetSingleLineTabCtrl(BOOL bSet) {bSingleLineTabCtrl = bSet; bSingleLineTabCtrlValid = TRUE; SetDefault(FALSE);}
	BOOL        IsSingleLineTabCtrl()const {return   bSingleLineTabCtrl;}
	BOOL        IsSingleLineTabCtrlValid()const {return   bSingleLineTabCtrlValid;}

	void        SetColoredTabCtrl(BOOL bSet)   {bColoredTabCtrl = bSet; bColoredTabCtrlValid = TRUE; SetDefault(FALSE);};
	BOOL        IsColoredTabCtrl()const {return     bColoredTabCtrl;}
	BOOL        IsColoredTabCtrlValid() const {return    bColoredTabCtrlValid;}

	static Boolean IsInitialized()  { return bInitialized; }
	static void	   SetInitialized() { bInitialized = True; }

};

#endif //  _OFA_APEARCFG_HXX
