/*************************************************************************
 *
 *  $RCSfile: appbas.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#ifndef _SV_FILDLG_HXX //autogen
#include <svtools/filedlg.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#pragma hdrstop

#include "app.hxx"

#ifndef _SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SFX_INIMGR_HXX
#include <sfx2/inimgr.hxx>
#endif
#ifndef _SVX_IMPGRF_HXX
#include <svx/impgrf.hxx>
#endif
#include <tools/fsys.hxx>

//=========================================================================

void OfficeApplication::ExecAPI_Impl( SfxRequest &rReq )
{
	USHORT nSlot = rReq.GetSlot();
	switch ( nSlot )
	{
		// standalone File/Grafic-Dialog von der API gerufen
		case SID_FILE_DIALOG:
		{
			// Flags: O)pen, S)aveas, G)raphic or P)ath
			SFX_REQUEST_ARG(rReq, pFlagsItem, SfxStringItem, SID_FLAGS, FALSE);
			String aFlags;

			if( pFlagsItem)
				aFlags = pFlagsItem->GetValue();
			else
				aFlags = String('O');

			aFlags.ToUpperAscii();
			WinBits nWinBits = 0;
			if ( STRING_NOTFOUND != aFlags.Search( 'O' ) )
				nWinBits |= WB_OPEN;
			if ( STRING_NOTFOUND != aFlags.Search( 'S' ) )
				nWinBits |= WB_SAVEAS;
			if ( STRING_NOTFOUND != aFlags.Search( 'P' ) )
				nWinBits |= SFXWB_PATHDIALOG;

			// Dialog erzeugen
			SfxFileDialog* pDlg;

			if ( STRING_NOTFOUND != aFlags.Search( 'G' ) )
				pDlg = new SvxImportGraphicDialog( 0, String(), 0, nWinBits );
			else
				pDlg = new SfxFileDialog( 0, nWinBits );

			// Titel: optional
			SFX_REQUEST_ARG(rReq, pTitleItem, SfxStringItem, SID_TITLE, FALSE);
			if ( pTitleItem )
				pDlg->SetText( pTitleItem->GetValue() );

			// Default-Pfad: optional
			SFX_REQUEST_ARG(rReq, pPathItem, SfxStringItem, SID_PATH, FALSE);
			if ( pPathItem )
			{
				DirEntry aPath( pPathItem->GetValue() );
				String aURL;
				if ( !aPath.IsAbs() )
				{
					DirEntry aWorkPath( SFX_INIMANAGER()->Get( SFX_KEY_WORK_PATH ) );
					aWorkPath += aPath;
					aURL = aWorkPath.GetFull( FSYS_STYLE_URL );
				}
				else
					aURL = aPath.GetFull( FSYS_STYLE_URL );
				pDlg->SetPath( aURL );
			}

			// Dialog ausf"uhren
			String aPath;
			if ( RET_OK == pDlg->Execute() )
				aPath = DirEntry( pDlg->GetPath() ).GetFull();
			delete pDlg;

			// R"uckgabewert setzen
			rReq.SetReturnValue( SfxStringItem( 0, aPath ) ); rReq.Done();
		}
	}
}

// ------------------------------------------------------------------------

void OfficeApplication::StateAPI_Impl( SfxItemSet& rState )
{
}


