/*************************************************************************
 *
 *  $RCSfile: htmlcfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#if SUPD<381
#ifndef _PARHTML_HXX //autogen
#include <goodies/parhtml.hxx>
#endif
#else
#ifndef _PARHTML_HXX //autogen
#include <svtools/parhtml.hxx>
#endif
#endif
#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#include <sfx2/viewfrm.hxx>

#pragma hdrstop

#include "htmlcfg.hxx"
#include "resid.hxx"
#include "app.hrc"

// -----------------------------------------------------------------------
#define HTMLCFG_UNKNOWN_TAGS 			0x01
//#define HTMLCFG_STYLE_SHEETS 			0x02
//#define HTMLCFG_NETSCAPE3    			0x04
#define HTMLCFG_STAR_BASIC   			0x08
#define HTMLCFG_LOCAL_GRF   			0x10
#define HTMLCFG_PRINT_LAYOUT_EXTENSION 	0x20
#define HTMLCFG_IGNORE_FONT_FAMILY	 	0x40
#define HTMLCFG_IS_BASIC_WARNING		0x80

#define HTMLCONFG_VERSION01 0x01
#define HTMLCONFG_VERSION02 0x02 // zusaetzlicher ExportMode
#define HTMLCONFG_VERSION03 0x03 // SaveGraphicsLocal
#define HTMLCONFG_VERSION04 0x04 // Netscape auch 4.0
#define HTMLCONFG_VERSION05 0x05 // Internet Explorer 4.0
#define HTMLCONFG_VERSION06 0x06 //  IE3 wird durch IE4 ersetzt
#define HTMLCONFG_VERSION07 0x07 // Warnung fuer Basic abschaltbar

#define HTMLCFG_VERSION HTMLCONFG_VERSION07

// -----------------------------------------------------------------------

int OfaHtmlOptions::Load(SvStream& rStream)
{
	USHORT nVersion;
	rStream >> nVersion;
	if(HTMLCONFG_VERSION03 <= nVersion)
	{
		rStream >> pImp->nFlags;
		if(HTMLCONFG_VERSION03 > nVersion)
		{
			pImp->nFlags |= HTMLCFG_LOCAL_GRF;
		}
		if(HTMLCONFG_VERSION07 > nVersion)
			pImp->nFlags |= HTMLCFG_IS_BASIC_WARNING;

		rStream>> pImp->nExportMode;
		if(HTMLCONFG_VERSION05 == nVersion && HTML_CFG_MSIE_40_OLD == pImp->nExportMode)
			pImp->nExportMode = HTML_CFG_MSIE_40;

		for(USHORT i = 0; i < HTML_FONT_COUNT; i++)
			rStream >> pImp->aFontSizeArr[i];

		return SfxConfigItem::ERR_OK;
	}
	else
		return SfxConfigItem::WARNING_VERSION;
}

// -----------------------------------------------------------------------


BOOL OfaHtmlOptions::Store(SvStream& rStream)
{
	rStream	<< (USHORT)HTMLCFG_VERSION;
	rStream << pImp->nFlags;
	rStream << pImp->nExportMode;
	for(USHORT i = 0; i < HTML_FONT_COUNT; i++)
		rStream << pImp->aFontSizeArr[i];

	return SVSTREAM_OK == rStream.GetError();
}

// -----------------------------------------------------------------------


void OfaHtmlOptions::UseDefault()
{
	pImp->nFlags = HTMLCFG_LOCAL_GRF|HTMLCFG_IS_BASIC_WARNING;
	pImp->nExportMode = HTML_CFG_NS40;
	pImp->aFontSizeArr[0] = HTMLFONTSZ1_DFLT;
	pImp->aFontSizeArr[1] = HTMLFONTSZ2_DFLT;
	pImp->aFontSizeArr[2] = HTMLFONTSZ3_DFLT;
	pImp->aFontSizeArr[3] = HTMLFONTSZ4_DFLT;
	pImp->aFontSizeArr[4] = HTMLFONTSZ5_DFLT;
	pImp->aFontSizeArr[5] = HTMLFONTSZ6_DFLT;
	pImp->aFontSizeArr[6] = HTMLFONTSZ7_DFLT;

	SfxConfigItem::UseDefault();
}

// -----------------------------------------------------------------------


OfaHtmlOptions::OfaHtmlOptions() :
	SfxConfigItem(SFX_ITEMTYPE_HTMLCONFIG)
{
	pImp = new HtmlOptions_Impl;
	UseDefault();
}

// -----------------------------------------------------------------------


OfaHtmlOptions::~OfaHtmlOptions()
{
	delete pImp;
}

// -----------------------------------------------------------------------


USHORT 	OfaHtmlOptions::GetFontSize(USHORT nPos) const
{
	if(nPos < HTML_FONT_COUNT)
		return pImp->aFontSizeArr[nPos];
	else
		return 0;
}

// -----------------------------------------------------------------------


void OfaHtmlOptions::SetFontSize(USHORT nPos, USHORT nSize)
{
	if(nPos < HTML_FONT_COUNT)
	{
		pImp->aFontSizeArr[nPos] = nSize;
		SetDefault(FALSE);
	}
}

// -----------------------------------------------------------------------

// -----------------------------------------------------------------------


BOOL OfaHtmlOptions::IsImportUnknown() const
{
	return 0 != (pImp->nFlags & HTMLCFG_UNKNOWN_TAGS) ;
}

// -----------------------------------------------------------------------


void OfaHtmlOptions::SetImportUnknown(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |= HTMLCFG_UNKNOWN_TAGS;
	else
		pImp->nFlags &= ~HTMLCFG_UNKNOWN_TAGS;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------


USHORT 	OfaHtmlOptions::GetExportMode() const
{
	return pImp->nExportMode;
}

// -----------------------------------------------------------------------


void OfaHtmlOptions::SetExportMode(USHORT nSet)
{
	if(nSet <= HTML_CFG_MAX )
	{
		pImp->nExportMode = nSet;
		SetDefault(FALSE);
		// Invalidierung, falls blinkender Text erlaubt/verboten wurde
        SfxViewFrame::Current()->GetBindings().Invalidate(SID_DRAW_TEXT_MARQUEE);
	}
}

// -----------------------------------------------------------------------


BOOL OfaHtmlOptions::IsStarBasic() const
{
	return 0 != (pImp->nFlags & HTMLCFG_STAR_BASIC) ;
}

// -----------------------------------------------------------------------


void OfaHtmlOptions::SetStarBasic(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |=  HTMLCFG_STAR_BASIC;
	else
		pImp->nFlags &= ~HTMLCFG_STAR_BASIC;
	SetDefault(FALSE);
}

/*-----------------04.09.96 10.32-------------------

--------------------------------------------------*/


String OfaHtmlOptions::GetName() const
{
	return String(OffResId(RID_STR_NAME_HTMLCFG));
}

/*-----------------14.02.97 08.34-------------------

--------------------------------------------------*/

BOOL OfaHtmlOptions::IsSaveGraphicsLocal() const
{
	return 0 != (pImp->nFlags & HTMLCFG_LOCAL_GRF) ;
}
/*-----------------14.02.97 08.34-------------------

--------------------------------------------------*/
void OfaHtmlOptions::SetSaveGraphicsLocal(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |=  HTMLCFG_LOCAL_GRF;
	else
		pImp->nFlags &= ~HTMLCFG_LOCAL_GRF;
	SetDefault(FALSE);
}

/*-----------------10/21/97 08:34am-----------------

--------------------------------------------------*/

BOOL 	OfaHtmlOptions::IsPrintLayoutExtension() const
{
	BOOL bRet = 0 != (pImp->nFlags & HTMLCFG_PRINT_LAYOUT_EXTENSION);
	switch( pImp->nExportMode )
	{
		case HTML_CFG_MSIE_40:
		case HTML_CFG_NS40  :
		case HTML_CFG_WRITER :
		break;
		default:
			bRet = FALSE;
	}
	return bRet;
}
/*-----------------10/21/97 08:34am-----------------

--------------------------------------------------*/
void	OfaHtmlOptions::SetPrintLayoutExtension(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |=  HTMLCFG_PRINT_LAYOUT_EXTENSION;
	else
		pImp->nFlags &= ~HTMLCFG_PRINT_LAYOUT_EXTENSION;
	SetDefault(FALSE);
}

/*-----------------10.07.98 10.02-------------------

--------------------------------------------------*/

BOOL OfaHtmlOptions::IsIgnoreFontFamily() const
{
	return 0 != (pImp->nFlags & HTMLCFG_IGNORE_FONT_FAMILY) ;
}
/*-----------------10.07.98 10.02-------------------

--------------------------------------------------*/
void OfaHtmlOptions::SetIgnoreFontFamily(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |=  HTMLCFG_IGNORE_FONT_FAMILY;
	else
		pImp->nFlags &= ~HTMLCFG_IGNORE_FONT_FAMILY;
	SetDefault(FALSE);
}
/* -----------------05.02.99 09:03-------------------
 *
 * --------------------------------------------------*/
BOOL OfaHtmlOptions::IsStarBasicWarning() const
{
	return 0 != (pImp->nFlags & HTMLCFG_IS_BASIC_WARNING) ;
}
/* -----------------05.02.99 09:03-------------------
 *
 * --------------------------------------------------*/
void OfaHtmlOptions::SetStarBasicWarning(BOOL bSet)
{
	if(bSet)
		pImp->nFlags |=  HTMLCFG_IS_BASIC_WARNING;
	else
		pImp->nFlags &= ~HTMLCFG_IS_BASIC_WARNING;
	SetDefault(FALSE);
}


