/*************************************************************************
 *
 *  $RCSfile: misccfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif

#pragma hdrstop

#include "app.hrc"
#include "misccfg.hxx"
#include "resid.hxx"

#define DEFAULT_TAB 2000

#define VERSION01 		1
#define VERSION02		2  	// TabDist kommt raus
#define VERSION03 		3	// nYear2000 dazu
#define MISC_VERSION 	VERSION03

#ifndef SFX_ITEMTYPE_MISCCONFIG
#define SFX_ITEMTYPE_MISCCONFIG			16
#endif

#define DEF_INCH	2540L
#define DEF_RELTWIP	1440L

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

OfaMiscCfg::OfaMiscCfg() :
	SfxConfigItem(SFX_ITEMTYPE_MISCCONFIG),
	nYear2000( SvNumberFormatter::GetYear2000Default() ),
	bNotFound (FALSE),
#ifdef PM2
	bPaperSize(TRUE),
	bPaperBin (TRUE)
#else
	bPaperSize(FALSE),
	bPaperBin (FALSE)
#endif
{
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

String	OfaMiscCfg::GetName() const
{
	return String(OffResId(RID_STR_NAME_MISCCFG));
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

int  OfaMiscCfg::Load(SvStream& rStream)
{
	SetDefault(FALSE);
	UINT16 nVersion;
	rStream >> nVersion;
	if(nVersion == VERSION01)
	{
		UINT16 nSet;
		rStream >> nSet; // das war mal die TabDist
	}
	if( VERSION02 <= nVersion && nVersion <= MISC_VERSION )
	{
		BYTE bSet;
		rStream >> bSet;
		bPaperSize = bSet;
		rStream >> bSet;
		bPaperBin = bSet;
		rStream >> bSet;
		bNotFound  = bSet;
	}
	else
	{
#ifdef PM2
		bPaperSize =
		bPaperBin  = TRUE;
#else
		bPaperSize =
		bPaperBin  =
#endif
		bNotFound  = FALSE;
	}
	if( VERSION03 <= nVersion && nVersion <= MISC_VERSION )
	{
		UINT16 nY2k;
		rStream >> nY2k;
		nYear2000 = nY2k;
	}
	else
		nYear2000 = SvNumberFormatter::GetYear2000Default();
	return SfxConfigItem::ERR_OK;
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

BOOL    OfaMiscCfg::Store(SvStream& rStream)
{
	UINT16 nVersion = MISC_VERSION;
	rStream << nVersion;
	rStream << (BYTE)bPaperSize;
	rStream << (BYTE)bPaperBin ;
	rStream << (BYTE)bNotFound;
	rStream << (UINT16) nYear2000;
	return TRUE;
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

void  OfaMiscCfg::UseDefault()
{
#ifdef PM2
	bPaperSize =
	bPaperBin  = TRUE;
#else
	bPaperSize =
	bPaperBin  =
#endif
	bNotFound  = FALSE;
	nYear2000 = SvNumberFormatter::GetYear2000Default();
	SfxConfigItem::UseDefault();
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

void OfaMiscCfg::SetNotFoundWarning( BOOL bSet)
{
	bNotFound = bSet;
	SetDefault(FALSE);
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

void OfaMiscCfg::SetPaperSizeWarning( BOOL bSet)
{
	bPaperSize = bSet;
	SetDefault(FALSE);
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

void OfaMiscCfg::SetPaperBinWarning( BOOL bSet)
{
	bPaperBin = bSet;
	SetDefault(FALSE);
}

/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/

void OfaMiscCfg::SetYear2000( USHORT nSet )
{
	nYear2000 = nSet;
	SetDefault(FALSE);
}


