/*************************************************************************
 *
 *  $RCSfile: ofaaccfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ENABLE_BYTESTRING_STREAM_OPERATORS

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SVXACORR_HXX
#include <svx/svxacorr.hxx>
#endif

#include <tools/urlobj.hxx>

#pragma hdrstop

#include "ofaaccfg.hxx"
#include "resid.hxx"
#include "app.hrc"

#define VERSION_341		((USHORT)341)
#define VERSION_343		((USHORT)343)
#define VERSION_355		((USHORT)355)
#define VERSION_365		((USHORT)365)
#define VERSION_366		((USHORT)366) // einfache Anfuehrungszeichen
#define VERSION_367		((USHORT)367) // Writer AutoFormat-Optionen mit speichern
#define VERSION_510		((USHORT)510) // zweites Bulletzeichen mit Font
#define VERSION_515		((USHORT)515) // AutoCompletion von Worten
#define VERSION_563		((USHORT)563) // more Settings for SW-AutoCompletion
#define VERSION_593		((USHORT)593) // more Settings for SW-AutoCompletion

#define AKT_VERSION  	VERSION_593

/*------------------------------------------------------------------------
 Beschreibung:	Einlesen aus Konfiguration
------------------------------------------------------------------------*/

int	OfaAutoCorrCfg::Load( SvStream& rStream )
{
	SetDefault( FALSE );
	int	rc = SfxConfigItem::ERR_OK;

	USHORT nVersion;
	rStream >> nVersion;

	long nFlags = 0;		// default alles aus

	unsigned char nVal = 0;
	rStream >> nVal;	if( nVal ) nFlags |= ChgQuotes;
	rStream >> nVal;	if( nVal ) nFlags |= Autocorrect;
	rStream >> nVal;	if( nVal ) nFlags |= CptlSttWrd;
	rStream >> nVal;	if( nVal ) nFlags |= CptlSttSntnc;
	rStream >> nVal;	if( nVal ) nFlags |= ChgFractionSymbol;
	rStream >> nVal;	if( nVal ) nFlags |= ChgOrdinalNumber;
	rStream >> nVal;	if( nVal ) nFlags |= ChgToEnEmDash;
	rStream >> nVal;	if( nVal ) nFlags |= ChgWeightUnderl;
	rStream >> nVal;	if( nVal ) nFlags |= SetINetAttr;

	rStream >> nVal;	bAutoFmtByInput = nVal ? TRUE : FALSE;
	rStream >> nVal;	bFileRel = nVal ? TRUE : FALSE;
	rStream >> nVal;    bNetRel = nVal ? TRUE : FALSE;
	rStream >> nVal;	bAutoTextTip = nVal ? TRUE : FALSE;

	rStream >> nVal;	pAutoCorrect->SetStartDoubleQuote( nVal );
	rStream >> nVal;	pAutoCorrect->SetEndDoubleQuote( nVal );

	if( VERSION_343 <= nVersion )
	{
		rStream >> nVal;	if( nVal ) nFlags |= SaveWordCplSttLst;
		rStream >> nVal;	if( nVal ) nFlags |= SaveWordWrdSttLst;
	}
	if( VERSION_355 <= nVersion )
		rStream >> nVal;	if( nVal ) nFlags |= IngnoreDoubleSpace;

	if( VERSION_365 <= nVersion )
	{
		rStream >> nVal;	pAutoCorrect->SetStartSingleQuote( nVal );
		rStream >> nVal;	pAutoCorrect->SetEndSingleQuote( nVal );
	}
	if( VERSION_366 <= nVersion)
	{
		rStream >> nVal;	if( nVal ) nFlags |= ChgSglQuotes;
	}
	if( VERSION_367 <= nVersion)
	{
		SvxSwAutoFmtFlags& rSwFlags = pAutoCorrect->GetSwFlags();
		ByteString aStr;
		USHORT nIn;

		rStream >> nVal;	rSwFlags.bAutoCorrect = nVal;
		rStream >> nVal;	rSwFlags.bCptlSttWrd = nVal;
		rStream >> nVal;	rSwFlags.bCptlSttSntnc = nVal;
		rStream >> nVal;	rSwFlags.bReplaceQuote = nVal;
		rStream >> nVal;	rSwFlags.bChgUserColl = nVal;
		rStream >> nVal;	rSwFlags.bChgEnumNum = nVal;
		rStream >> rSwFlags.cBullet;
		rStream >> aStr;	rSwFlags.aBulletFont.SetName(String(aStr,gsl_getSystemTextEncoding()));
		rStream >> nIn;		rSwFlags.aBulletFont.SetFamily(FontFamily(nIn));
		rStream >> nIn;		rSwFlags.aBulletFont.SetCharSet(CharSet(nIn));
		rStream >> nIn;		rSwFlags.aBulletFont.SetPitch(FontPitch(nIn));
		rStream >> nIn;		rSwFlags.nRightMargin = (BYTE)nIn;

		rStream >> nVal; 	rSwFlags.bDelEmptyNode 		= nVal;
		rStream >> nVal;    rSwFlags.bSetNumRule 		= nVal;
		rStream >> nVal;    rSwFlags.bChgFracionSymbol  = nVal;
		rStream >> nVal;    rSwFlags.bChgOrdinalNumber  = nVal;
		rStream >> nVal;    rSwFlags.bChgToEnEmDash 	= nVal;
		rStream >> nVal;    rSwFlags.bChgWeightUnderl 	= nVal;
		rStream >> nVal;    rSwFlags.bSetINetAttr 		= nVal;
		rStream >> nVal;    rSwFlags.bSetBorder 		= nVal;
		rStream >> nVal;    rSwFlags.bCreateTable 		= nVal;
		rStream >> nVal;    rSwFlags.bReplaceStyles 	= nVal;
		rStream >> nVal;    rSwFlags.bDummy			 	= nVal;

		if(VERSION_510 <= nVersion)
		{
			rStream >> rSwFlags.cByInputBullet;
			rStream >> aStr;	rSwFlags.aByInputBulletFont.SetName(String(aStr,gsl_getSystemTextEncoding()));
			rStream >> nIn;		rSwFlags.aByInputBulletFont.SetFamily(FontFamily(nIn));
			rStream >> nIn;		rSwFlags.aByInputBulletFont.SetCharSet(CharSet(nIn));
			rStream >> nIn;		rSwFlags.aByInputBulletFont.SetPitch(FontPitch(nIn));
		}

		if(VERSION_515 <= nVersion)
		{
			rStream >> nVal; rSwFlags.bAutoCompleteWords = nVal;
			rStream >> nIn; rSwFlags.nAutoCmpltWordLen = nIn;
			rStream >> nIn; rSwFlags.nAutoCmpltListLen = nIn;
		}

		if(VERSION_563 <= nVersion)
		{
			rStream >> nVal; rSwFlags.bAutoCmpltCollectWords = nVal;
			rStream >> nVal; rSwFlags.bAutoCmpltEndless = nVal;
			rStream >> nVal; rSwFlags.bAutoCmpltAppendBlanc = nVal;
			rStream >> nVal; rSwFlags.bAutoCmpltShowAsTip = nVal;
			rStream >> nIn; rSwFlags.nAutoCmpltExpandKey = nIn;
		}

		if(VERSION_593 <= nVersion)
		{
			rStream >> nVal; rSwFlags.bAFmtDelSpacesAtSttEnd = nVal;
			rStream >> nVal; rSwFlags.bAFmtDelSpacesBetweenLines = nVal;
			rStream >> nVal; rSwFlags.bAFmtByInpDelSpacesAtSttEnd = nVal;
			rStream >> nVal; rSwFlags.bAFmtByInpDelSpacesBetweenLines = nVal;
		}
	}

	if( nFlags )
		pAutoCorrect->SetAutoCorrFlag( nFlags, TRUE );
	pAutoCorrect->SetAutoCorrFlag( ( 0xffff & ~nFlags ), FALSE );

	return rc;
}
/*------------------------------------------------------------------------
 Beschreibung:	Schreiben in die Konfiguration
------------------------------------------------------------------------*/

BOOL OfaAutoCorrCfg::Store(SvStream& rStream)
{
	// typecast, weil SUN C++ manchmal zu doof....
	const unsigned char cOff = 0, cOn = 1;
	SvxSwAutoFmtFlags& rSwFlags = pAutoCorrect->GetSwFlags();

	rStream << AKT_VERSION
			<< pAutoCorrect->IsAutoCorrFlag( ChgQuotes )
			<< pAutoCorrect->IsAutoCorrFlag( Autocorrect )
			<< pAutoCorrect->IsAutoCorrFlag( CptlSttWrd )
			<< pAutoCorrect->IsAutoCorrFlag( CptlSttSntnc )
			<< pAutoCorrect->IsAutoCorrFlag( ChgFractionSymbol )
			<< pAutoCorrect->IsAutoCorrFlag( ChgOrdinalNumber )
			<< pAutoCorrect->IsAutoCorrFlag( ChgToEnEmDash )
			<< pAutoCorrect->IsAutoCorrFlag( ChgWeightUnderl )
			<< pAutoCorrect->IsAutoCorrFlag( SetINetAttr )
			<< (BYTE)(bAutoFmtByInput ? 1 : 0 )
			<< (BYTE)(bFileRel ? 1 : 0 )
			<< (BYTE)(bNetRel ? 1 : 0 )
			<< (BYTE)(bAutoTextTip ? 1 : 0 )
			<< pAutoCorrect->GetStartDoubleQuote()
			<< pAutoCorrect->GetEndDoubleQuote()
			<< pAutoCorrect->IsAutoCorrFlag( SaveWordCplSttLst )
			<< pAutoCorrect->IsAutoCorrFlag( SaveWordWrdSttLst )
			<< pAutoCorrect->IsAutoCorrFlag( IngnoreDoubleSpace )
			<< pAutoCorrect->GetStartSingleQuote()
			<< pAutoCorrect->GetEndSingleQuote()
			<< pAutoCorrect->IsAutoCorrFlag( ChgSglQuotes )

			<< (BYTE)(rSwFlags.bAutoCorrect? cOn: cOff)
			<< (BYTE)(rSwFlags.bCptlSttWrd? cOn: cOff)
			<< (BYTE)(rSwFlags.bCptlSttSntnc? cOn: cOff)
			<< (BYTE)(rSwFlags.bReplaceQuote? cOn: cOff)
			<< (BYTE)(rSwFlags.bChgUserColl? cOn: cOff)
			<< (BYTE)(rSwFlags.bChgEnumNum? cOn: cOff)
			<< rSwFlags.cBullet
			<< ByteString(rSwFlags.aBulletFont.GetName(),gsl_getSystemTextEncoding())
			<< (USHORT)rSwFlags.aBulletFont.GetFamily()
			<< (USHORT)rSwFlags.aBulletFont.GetCharSet()
			<< (USHORT)rSwFlags.aBulletFont.GetPitch()
			<< (USHORT)rSwFlags.nRightMargin

			<< (BYTE)( rSwFlags.bDelEmptyNode 		? cOn : cOff)
			<< (BYTE)( rSwFlags.bSetNumRule 		? cOn : cOff)
			<< (BYTE)( rSwFlags.bChgFracionSymbol 	? cOn : cOff)
			<< (BYTE)( rSwFlags.bChgOrdinalNumber 	? cOn : cOff)
			<< (BYTE)( rSwFlags.bChgToEnEmDash 		? cOn : cOff)
			<< (BYTE)( rSwFlags.bChgWeightUnderl 	? cOn : cOff)
			<< (BYTE)( rSwFlags.bSetINetAttr 		? cOn : cOff)
			<< (BYTE)( rSwFlags.bSetBorder 			? cOn : cOff)
			<< (BYTE)( rSwFlags.bCreateTable 		? cOn : cOff)

			<< (BYTE)( rSwFlags.bReplaceStyles 		? cOn : cOff)
			<< (BYTE)( rSwFlags.bDummy			 	? cOn : cOff)

			<< rSwFlags.cByInputBullet
			<< ByteString(rSwFlags.aByInputBulletFont.GetName(),gsl_getSystemTextEncoding())
			<< (USHORT)rSwFlags.aByInputBulletFont.GetFamily()
			<< (USHORT)rSwFlags.aByInputBulletFont.GetCharSet()
			<< (USHORT)rSwFlags.aByInputBulletFont.GetPitch()

			<< (BYTE)(rSwFlags.bAutoCompleteWords 	? cOn : cOff)
			<< (USHORT)rSwFlags.nAutoCmpltWordLen
			<< (USHORT)rSwFlags.nAutoCmpltListLen

			<< (BYTE)(rSwFlags.bAutoCmpltCollectWords 	? cOn : cOff)
			<< (BYTE)(rSwFlags.bAutoCmpltEndless 	? cOn : cOff)
			<< (BYTE)(rSwFlags.bAutoCmpltAppendBlanc 	? cOn : cOff)
			<< (BYTE)(rSwFlags.bAutoCmpltShowAsTip 	? cOn : cOff)
			<< (USHORT)rSwFlags.nAutoCmpltExpandKey

			<< (BYTE)(rSwFlags.bAFmtDelSpacesAtSttEnd ? cOn : cOff)
			<< (BYTE)(rSwFlags.bAFmtDelSpacesBetweenLines ? cOn : cOff)
			<< (BYTE)(rSwFlags.bAFmtByInpDelSpacesAtSttEnd ? cOn : cOff)
			<< (BYTE)(rSwFlags.bAFmtByInpDelSpacesBetweenLines ? cOn : cOff)
			;

	return SVSTREAM_OK == rStream.GetError();
}

/*--------------------------------------------------------------------
	Beschreibung:	Default-Image
 --------------------------------------------------------------------*/

void OfaAutoCorrCfg::UseDefault()
{
	long  nDefFlags = 	SvxAutoCorrect::GetDefaultFlags();
	pAutoCorrect->SetAutoCorrFlag( nDefFlags, TRUE );
	pAutoCorrect->SetAutoCorrFlag( ~nDefFlags, FALSE );

	bAutoFmtByInput = TRUE;
	bFileRel = bNetRel = bAutoTextTip = FALSE;

	SvxSwAutoFmtFlags aTmp;
	pAutoCorrect->GetSwFlags() = aTmp;

	SfxConfigItem::UseDefault();
}

/*--------------------------------------------------------------------
	Beschreibung:	Ctor Dtor
 --------------------------------------------------------------------*/

OfaAutoCorrCfg::OfaAutoCorrCfg()
	: SfxConfigItem( SFX_ITEMTYPE_AUTOCORRCONFIG )
{
	bAutoFmtByInput = TRUE;
	bFileRel = bNetRel = bAutoTextTip;

	SfxIniManager* pIniManager = SFX_APP()->GetIniManager();
	DBG_ASSERT( pIniManager, "Kein Inimanager angelegt !!" );

	String sPath( pIniManager->Get( SFX_KEY_AUTOCORRECT_DIR ) );
    sPath = sPath.GetToken(0, ';' );

	// Glossary-Path enthaelt gfs. mehrere Teile
    INetURLObject aPath( sPath );
    aPath.insertName( String::CreateFromAscii("acor") );

    pAutoCorrect = new SvxAutoCorrect( aPath.GetMainURL() );
}

OfaAutoCorrCfg::~OfaAutoCorrCfg()
{
	delete pAutoCorrect;
}

String OfaAutoCorrCfg::GetName() const
{
	return String( OffResId( RID_STR_NAME_ACORRCFG ));
}

void OfaAutoCorrCfg::SetAutoCorrect( SvxAutoCorrect* pNew )
{
	if( pNew && pNew != pAutoCorrect )
	{
		if( pAutoCorrect->GetFlags() != pNew->GetFlags() )
			SetDefault( FALSE );
		delete pAutoCorrect;
		pAutoCorrect = pNew;
	}
}


