/*************************************************************************
 *
 *  $RCSfile: osplcfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SFX_HRC
#include <sfx2/sfx.hrc>
#endif
#ifndef _SFXEVENT_HXX //autogen
#include <sfx2/event.hxx>
#endif
#ifndef _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif
#ifndef _COM_SUN_STAR_LINGUSTIC_XDICTIONARYLIST_HPP_
#include <com/sun/star/linguistic/XDictionaryList.hpp>
#endif

#ifndef _OFF_SPLNOTE_HXX
#include "splnote.hxx"
#endif

using namespace rtl;
using namespace utl;
using namespace com::sun::star;
using namespace com::sun::star::uno;
using namespace com::sun::star::frame;
using namespace com::sun::star::lang;
using namespace com::sun::star::linguistic;

///////////////////////////////////////////////////////////////////////////

SpellNotifier::SpellNotifier( SfxBroadcaster& rBC )
{
	StartListening( rBC );
}

SpellNotifier::~SpellNotifier()
{
	EndListeningAll();
}

void SpellNotifier::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
	SfxEventHint* pEventHint = PTR_CAST(SfxEventHint,&rHint);
	if( pEventHint &&
		( SFX_EVENT_SAVEDOC == pEventHint->GetEventId() ||
		  SFX_EVENT_SAVEASDOC == pEventHint->GetEventId() ) )
	{
 		Reference< XMultiServiceFactory >  xMgr( getProcessServiceFactory() );
		Reference< XDictionaryList >  xDicList( xMgr->createInstance(
				OUString::createFromAscii("com.sun.star.linguistic.DictionaryList") ), ::com::sun::star::uno::UNO_QUERY );

		if (xDicList.is())
		{
			uno::Sequence< Reference< XDictionary >  >	aDicts = 
					xDicList->getDictionaries();
			const Reference< XDictionary >  *pDic = aDicts.getConstArray();
			sal_Int32	nCount  = aDicts.getLength();

			for (sal_Int32 i = 0;  i < nCount;  i++)
			{
				Reference< XStorable >  xStor( pDic[i], UNO_QUERY );
				if (xStor.is())
				{
					if (xStor->hasLocation())
						xStor->store();
					else
					{
						DBG_ERROR("dictionary has no location to save it");
					}
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////


