/*************************************************************************
 *
 *  $RCSfile: hyprlink.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_CHAOS_RULESET_HPP_
#include <com/sun/star/chaos/RuleSet.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_RULE_HPP_
#include <com/sun/star/chaos/Rule.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_RULETERM_HPP_
#include <com/sun/star/chaos/RuleTerm.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XSYSTEM_HPP_
#include <com/sun/star/chaos/XSystem.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XANCHORFACTORY_HPP_
#include <com/sun/star/chaos/XAnchorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XANCHOR_HPP_
#include <com/sun/star/chaos/XAnchor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_RULEOPERATOR_HPP_
#include <com/sun/star/chaos/RuleOperator.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XCOMMANDEXECUTOR_HPP_
#include <com/sun/star/chaos/XCommandExecutor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XSTATUSCALLBACK_HPP_
#include <com/sun/star/chaos/XStatusCallback.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#include <unotools/processfactory.hxx>

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#include "sbaenum.hxx"
#include "sbaobj.hxx"

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_DRAG_HXX
#include <vcl/drag.hxx>
#endif
#ifndef _SV_CONFIG_HXX
#include <vcl/config.hxx>
#endif
#ifndef _URLBMK_HXX
#include <svtools/urlbmk.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _EXPLORER_HXX
#include <sfx2/explorer.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFXIMGMGR_HXX //autogen
#include <sfx2/imgmgr.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFXDOCINF_HXX //autogen
#include <sfx2/docinf.hxx>
#endif
#ifndef _SVX_DIALOGS_HRC
#include <svx/dialogs.hrc>
#endif
#ifndef _INETIMG_HXX //autogen
#include <svtools/inetimg.hxx>
#endif
#include <svtools/urihelper.hxx>

#include "app.hxx"
#include "app.hrc"
#include "hyprlink.hrc"
#include <svx/hlnkitem.hxx>
#include "resid.hxx"

#include "hyprlink.hxx"
#include "hyprdlg.hxx"

//#ifndef _CSTRITEM_HXX //autogen
//#include <chaos/cstritem.hxx>
//#endif

using namespace ::rtl;
using namespace ::com::sun::star;

// STATIC DATA -----------------------------------------------------------

#define SEARCH_ADDRBOOK 100
#define SEARCH_EXPLORER 101

/*************************************************************************
|*
|* Dialog zum Einf"ugen/"Andern eines Hyperlink
|*
\************************************************************************/

SvxHyperlinkDlg::SvxHyperlinkDlg( SfxBindings *pBindings, Window* pParent) :

	SfxControllerItem	( SID_HYPERLINK_SETLINK, *pBindings ),
	ToolBox				( pParent, OffResId( RID_SVXDLG_HYPERLINK ) ),

	aForwarder			( SID_HYPERLINK_GETLINK, *this ),
	aHyperlinkDlgForward( SID_HYPERLINK_DIALOG , *this),

	aNameCB				( this, ResId( CB_NAME ) ),
	aUrlFT				( this, ResId( FT_URL ) ),
	aUrlCB				( this, ResId( CB_URL ) ),
	sAddress			( ResId( STR_ADDRESS ) ),
	sExplorer			( ResId( STR_EXPLORER ) ),
	sSearchTitle		( ResId( STR_BOOKMARK_SEARCH ) ),
	aLinkPopup			( OffResId( RID_SVXMN_HYPERLINK) ),
	pTargetMenu			( NULL ),

	nQuery				( RET_YES ),
	bHasOldName			( FALSE ),
	bNoDoc				( TRUE ),
	bHtmlMode			( FALSE )

{
	FreeResource();

	SfxImageManager* pManager = SFX_IMAGEMANAGER();
	pManager->RegisterToolBox( this );
	SetItemImage( BTN_LINK, pManager->GetImage( BTN_LINK ) );
	SetItemImage( BTN_INSERT_BOOKMARK, pManager->GetImage( BTN_INSERT_BOOKMARK ) );
	SetItemImage( BTN_INET_SEARCH, pManager->GetImage( BTN_INET_SEARCH ) );
	SetItemImage( BTN_TARGET, pManager->GetImage( BTN_TARGET ) );

	SetItemImage( BTN_OPENDIALOG, pManager->GetImage( BTN_OPENDIALOG ) );

	nMaxWidth = GetSizePixel().Width();		// Initiale Groesse merken
	nMaxHeight = GetSizePixel().Height();	// Initiale Groesse merken

	SetSizePixel(CalcWindowSizePixel());	// Groesse initialisieren

	nMaxHeight = GetSizePixel().Height();	// Hoehe nochmal merken, da sie veraendert wurde
											// SetSizePixel ruft Resize-Handler!

	InsertSeparator (0);
	InsertWindow( CB_URL, &aUrlCB, 0, 0);
	InsertWindow( FT_URL, &aUrlFT, 0, 0);
	InsertSeparator (0);
	InsertWindow( CB_NAME, &aNameCB, 0, 0);

	Resize();

	long nUrlWidth = aUrlCB.GetResizeWidth();
	long nNameWidth = aNameCB.GetResizeWidth();
	long nSum = nUrlWidth + nNameWidth;

	aUrlCB.SetRatio((nUrlWidth * 100L) / nSum);
	aNameCB.SetRatio((nNameWidth * 100L) / nSum);

	aTimer.SetTimeout( 250 );
	aTimer.SetTimeoutHdl( LINK( this, SvxHyperlinkDlg, TimeHdl ) );

	SetClickHdl( LINK( this, SvxHyperlinkDlg, TBClickHdl ) );
	SetSelectHdl( LINK( this, SvxHyperlinkDlg, TBSelectHdl ) );
	SetDeactivateHdl( LINK( this, SvxHyperlinkDlg, TBDeactivateHdl ) );

	aLinkPopup.SetSelectHdl(LINK(this, SvxHyperlinkDlg, LinkPopupSelectHdl));

	Link aLk = LINK(this, SvxHyperlinkDlg, ComboSelectHdl);
	aNameCB.SetSelectHdl(aLk);
	aUrlCB.SetSelectHdl(aLk);

	aLk = LINK(this, SvxHyperlinkDlg, ComboModifyHdl);
	aNameCB.SetModifyHdl(aLk);
	aUrlCB.SetModifyHdl(aLk);

	EnableDrop(TRUE);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SvxHyperlinkDlg::~SvxHyperlinkDlg()
{
	SfxImageManager* pManager = SFX_IMAGEMANAGER();
	pManager->ReleaseToolBox(this);

	if (pTargetMenu != NULL)
		delete pTargetMenu;
}

/*--------------------------------------------------------------------
	Beschreibung: Leiste so resizen, dass die Comboboxen automatisch mit
	verkleinert werden
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::Resize()
{
	long nWidth = GetSizePixel().Width();

	ToolBox::Resize();

	if (nWidth)	// nWidth ist manchmal 0
	{
		long nDeltaW = nMaxWidth - nWidth + aUrlCB.LogicToPixel(Size(3, 1)).Width() + 1;

		long nNewUrlWidth = aUrlCB.CalcResizeWidth(nDeltaW);
		long nNewNameWidth = aNameCB.CalcResizeWidth(nDeltaW);

		if (nNewUrlWidth && nNewNameWidth)	// Flackern reduzieren
		{
			SetUpdateMode(FALSE);

			// Comboboxen resizen
			aUrlCB.DoResize(nNewUrlWidth);
			aNameCB.DoResize(nNewNameWidth);
			RecalcItems();	// Alle Elemente neu anordnen

			SetUpdateMode(TRUE);
		}
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::Resizing(Size& rSize)
{
	if (rSize.Height() > nMaxHeight)
		rSize.Height() = nMaxHeight;

	if (rSize.Width() > nMaxWidth)
		rSize.Width() = nMaxWidth;

	ToolBox::Resizing(rSize);
}

/*--------------------------------------------------------------------
	Beschreibung: Im Dokument selektierten Hyperlink in Leiste anzeigen
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::StateChanged( USHORT nSID, SfxItemState eState,
													const SfxPoolItem* pState )
{
	if ( nSID == SID_HYPERLINK_DIALOG )
	{
		if( eState != SFX_ITEM_DISABLED)
		{
			EnableItem( BTN_OPENDIALOG, TRUE );

			BOOL bItem = FALSE;
			if ( pState && eState == SFX_ITEM_AVAILABLE )
					bItem = ((SfxBoolItem*)pState)->GetValue();
			SetItemState ( BTN_OPENDIALOG, bItem ? STATE_CHECK : STATE_NOCHECK );
		}
		else
		{
			SetItemState ( BTN_OPENDIALOG, STATE_NOCHECK );
			EnableItem( BTN_OPENDIALOG, FALSE );
		}
	}

	if (nSID == SID_HYPERLINK_SETLINK)
	{
		if (eState == SFX_ITEM_DISABLED)
			bNoDoc = TRUE;
		else
			bNoDoc = FALSE;
		EnableItem(BTN_TARGET, !bNoDoc);
		EnableLink();
	}

	if (nSID == SID_HYPERLINK_GETLINK)
	{
		if (eState == SFX_ITEM_AVAILABLE)
		{
			const SvxHyperlinkItem& rHLnkItem = *((const SvxHyperlinkItem*)pState);

			USHORT nNamePos = aNameCB.GetEntryPos(aNameCB.GetText());
			USHORT nUrlPos = aUrlCB.GetEntryPos(aUrlCB.GetText());
			USHORT nNotFound = COMBOBOX_ENTRY_NOTFOUND;

			if (!bHasOldName &&
				(nNamePos == nNotFound || nUrlPos == nNotFound))
			{
				sOldName = aNameCB.GetText();
				bHasOldName = TRUE;
			}
			if (rHLnkItem.GetName().Len())
			{
				aNameCB.SetText(rHLnkItem.GetName());
				ComboModifyHdl(&aNameCB);
			}
			if (rHLnkItem.GetURL().Len() || rHLnkItem.GetName().Len())
			{
				String sUrl = INetURLObject(rHLnkItem.GetURL()).GetURLNoPass();
				aUrlCB.SetText(sUrl);
			}
			else if (aUrlCB.GetEntryCount())
			{	// Letzten Eintrag wieder selektieren
				aNameCB.SetText(aNameCB.GetEntry(0));
				aUrlCB.SetText(aUrlCB.GetEntry(0));
			}

			TargetMenu(rHLnkItem.GetTargetFrame(), FALSE);
			bHtmlMode = (rHLnkItem.GetInsertMode() & HLINK_HTMLMODE) != 0;
		}
		else
			return;

		ComboModifyHdl(&aUrlCB);
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, TBClickHdl, ToolBox *, pBox )
{
	switch (pBox->GetCurItemId())
	{
		case BTN_OPENDIALOG:
		{
			GetBindings().GetDispatcher()->Execute( SID_HYPERLINK_DIALOG );
		}
		break;

		case BTN_LINK:
		{
			// Link-Popup anstossen
			bSend = FALSE;
			aTimer.Start();
		}
		break;

		case BTN_INET_SEARCH:
		{
			// Search-Engines per Popup auswaehlen
			PopupMenu *pMenu = new PopupMenu;
			pMenu->SetSelectHdl(LINK(this, SvxHyperlinkDlg, SearchPopupSelectHdl));

			USHORT nCount = SvxInternetFkts::GetSearchEngineCount();
			String sFound;

			for (USHORT i = 0; i < nCount; i++)
				pMenu->InsertItem( i + 1,
					SvxInternetFkts::GetSearchEngineName(i));
			if (i)
				pMenu->InsertSeparator();


			pMenu->InsertItem( SEARCH_ADDRBOOK, sAddress);	// Text im Adressbuch suchen
			pMenu->InsertItem( SEARCH_EXPLORER, sExplorer);	// Text in den Explorer-Bookmarks suchen
			pMenu->Execute( this, GetItemRect( BTN_INET_SEARCH ), FLOATWIN_POPUPMODE_DOWN );
			EndSelection();

			delete pMenu;
		}
		break;

		case BTN_TARGET:
		{
			// Target Frame einstellen
			TargetMenu(GetSelTarget(), TRUE);
			EndSelection();
		}
		break;
	}

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, TBSelectHdl, ToolBox *, pBox )
{
	switch (pBox->GetCurItemId())
	{
		// Link als Bookmark im Explorer eintragen
		// Soll erst im Loslassen der Maus gerufen werden, daher im Select-Hdl
		case BTN_INSERT_BOOKMARK:
		{
			String sName = aNameCB.GetText();
			if ( !sName.Len() )
				sName = aUrlCB.GetText();

			SfxStringItem aName( SID_BOOKMARK_TITLE, sName );
			SfxStringItem aURL( SID_BOOKMARK_URL,
								URIHelper::SmartRelToAbs( aUrlCB.GetText(), FALSE,
														  INetURLObject::WAS_ENCODED,
														  INetURLObject::DECODE_UNAMBIGUOUS ) );
			GetBindings().GetDispatcher()->Execute(
				SID_CREATELINK, SFX_CALLMODE_ASYNCHRON, &aName, &aURL, 0L );
		}
		break;
	}

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::TargetMenu(const String& rSelEntry, BOOL bExecute)
{
	if (pTargetMenu && !bExecute)
	{
		for (USHORT i = 1; i <= pTargetMenu->GetItemCount(); i++)
		{
			if (pTargetMenu->GetItemText(i) == rSelEntry)
			{
				pTargetMenu->CheckItem(i);
				return;
			}
		}
	}

	SfxViewFrame* pVwFrm = SfxViewFrame::Current();

	if (pVwFrm)	// Alle moeglichen Target Frames zusammensammeln und anzeigen
	{
		TargetList aList;
		pVwFrm->GetTopFrame()->GetTargetList(aList);

		USHORT nCount = (USHORT)aList.Count();
		if( nCount )
		{
			BOOL bChecked = FALSE;

			if (pTargetMenu != NULL)
				delete pTargetMenu;

			pTargetMenu = new PopupMenu;
			pTargetMenu->SetMenuFlags( pTargetMenu->GetMenuFlags() |
									   MENU_FLAG_NOAUTOMNEMONICS );

			for ( USHORT i = 0; i < nCount; i++ )
			{
				String sEntry(*aList.GetObject(i));
				pTargetMenu->InsertItem(i + 1, sEntry, MIB_RADIOCHECK|MIB_AUTOCHECK);

				if (sEntry == rSelEntry)
				{
					pTargetMenu->CheckItem(i + 1);
					bChecked = TRUE;
				}
			}
			for ( i = nCount; i; i-- )
				delete aList.GetObject( i - 1 );

			if (!bChecked)
				pTargetMenu->CheckItem(1);

			if (bExecute)
			{
				USHORT nEntry = pTargetMenu->Execute(
					this, GetItemRect( BTN_TARGET ), FLOATWIN_POPUPMODE_DOWN );
				if ( nEntry )
					pTargetMenu->CheckItem( nEntry );
			}
		}
	}
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, TBDeactivateHdl, ToolBox *, pBox )
{
	switch (pBox->GetCurItemId())
	{
		case BTN_LINK:
		{
			if (aTimer.IsActive())
			{
				aTimer.Stop();
				if (!bSend)	// Link ins Dokument einfuegen
					SendToApp(HLINK_DEFAULT);
			}
		}
		break;
	}

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, TimeHdl, Timer *, pTimer )
{
	EndSelection();	// Vor dem Execute, damit Popup den Focus bekommt
	aLinkPopup.EnableItem(MN_BUTTON, !bHtmlMode);
	aLinkPopup.Execute( this, GetItemRect( BTN_LINK ), FLOATWIN_POPUPMODE_DOWN );
	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, LinkPopupSelectHdl, Menu *, pMenu )
{
	switch (pMenu->GetCurItemId())
	{
		case MN_FIELD:	// URL als Hyperlink ins Dok einfuegen
			SendToApp(HLINK_FIELD);
			break;
		case MN_BUTTON:	// URL als Button ins Dok einfuegen
			SendToApp(HLINK_BUTTON);
			break;
	}

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, SearchPopupSelectHdl, Menu *, pMenu )
{
	switch (pMenu->GetCurItemId())
	{
		case SEARCH_ADDRBOOK:
		{
			// Text im Adressbuch suchen
			String sName, sMailAddr;
			OfficeApplication *pApp = (OfficeApplication *)SFX_APP();

			sName = aNameCB.GetText();

			SbaObject* pSbaObject = pApp->GetSbaObject();
			DBG_ASSERT( pSbaObject, "Kein SBAOBJ!" );

			if ( pSbaObject && sName.Len() )
			{
				SbaSearchField eInField;
				USHORT nCnt = pSbaObject->SearchEMail(sName, sMailAddr, SBA_URL, eInField);

				if (nCnt && sMailAddr.Len())
				{
					// URL in Leiste anzeigen
					aUrlCB.SetText(sMailAddr);
					ComboModifyHdl(&aUrlCB);
				}
				else
				{
					if (nCnt > 1)
					{
						// Adressbuch zu Hilfe nehmen
						QueryBox aBox( this, OffResId(RID_QRY_SELECTADDR) );

						if ( aBox.Execute() == RET_YES )
						{
							pApp->ShowAddrPI( TRUE );
							sName += '*';
							pSbaObject->AddrBookSelect( sName, eInField );
						}
					}
				}
			}
		}
		break;

		case SEARCH_EXPLORER:
		{
			// Local service manager.
			uno::Reference< lang::XMultiServiceFactory > xManagerLcl ( ::utl::getProcessServiceFactory() );
			if (xManagerLcl.is())
			{
				// Local CHAOS system instance.
				uno::Reference< uno::XInterface > xProvInst (xManagerLcl->createInstance( OUString::createFromAscii("com.sun.star.chaos.System")));
				if (!xProvInst.is())
					return 0;
				uno::Reference< chaos::XSystem > xSystem( xProvInst, uno::UNO_QUERY );

				if ( !xSystem.is() )
					return 0;

				uno::Reference< chaos::XAnchorFactory > xFactory( xSystem, uno::UNO_QUERY );
				if (!xFactory.is())
					return 0;

				String aURL;aURL.AssignAscii( "private:searchfolder://" );

				DateTime aDateTime;
				aURL += String::CreateFromInt32(aDateTime.GetYear());
				aURL += String::CreateFromInt32(aDateTime.GetMonth());
				aURL += String::CreateFromInt32(aDateTime.GetDay());
				aURL += String::CreateFromInt32(aDateTime.GetHour());
				aURL += String::CreateFromInt32(aDateTime.GetMin());
				aURL += String::CreateFromInt32(aDateTime.GetSec());
				uno::Reference< chaos::XAnchor > xAnchor(xFactory->createAnchor( aURL ));
				if (!xAnchor.is())
					return 0;

				uno::Reference< beans::XPropertySet > xPropSet( xAnchor, uno::UNO_QUERY );
				if ( !xPropSet.is() )
					return 0;

				chaos::RuleSet		aRuleSet;
				chaos::Rule			aRule;
				chaos::RuleTerm		aTerm;
				uno::Any			aOperand, aPropVal;

				aOperand <<= ::rtl::OUString( aNameCB.GetText() );
				aTerm.Property = String::CreateFromAscii( "Title" );
				aTerm.Operand = aOperand;
				aTerm.Operator = chaos::RuleOperator::CONTAINS;
				aTerm.CaseSensitive = FALSE;
				aTerm.RegularExpression = FALSE;

				uno::Sequence<chaos::RuleTerm> aTermSeq( &aTerm, 1 );
				aRule.Terms = aTermSeq;

				uno::Sequence<chaos::Rule> aRulesSeq( &aRule, 1 );
				aRuleSet.Rules = aRulesSeq;
				aPropVal <<= aRuleSet;
				xPropSet->setPropertyValue( String::CreateFromAscii( "SearchCriteria" ), aPropVal );

				String	sBookmarkDir = SFX_INIMANAGER()->Get( SFX_KEY_BOOKMARK_DIR );
				sBookmarkDir = URIHelper::SmartRelToAbs( sBookmarkDir, FALSE,
														 INetURLObject::WAS_ENCODED,
														 INetURLObject::DECODE_UNAMBIGUOUS );

				aPropVal <<= OUString( sBookmarkDir );
				xPropSet->setPropertyValue( String::CreateFromAscii( "SearchLocations" ), aPropVal );

				String sTitle = sSearchTitle;
				sTitle.AppendAscii(": ");
				sTitle += aNameCB.GetText();
				aPropVal <<= OUString( sTitle  );
				xPropSet->setPropertyValue( String::CreateFromAscii( "Title" ), aPropVal );

				sal_Bool bValue = sal_True;
				aPropVal.setValue( &bValue, ::getCppuBooleanType() );
				xPropSet->setPropertyValue( String::CreateFromAscii( "SearchRecursive" ), aPropVal );
				xPropSet->setPropertyValue( String::CreateFromAscii( "SearchIndirections" ), aPropVal );

				uno::Reference< chaos::XCommandExecutor > xExecutor( xAnchor, uno::UNO_QUERY );
				if ( !xExecutor.is() )
					return 0;

				SfxStringItem aFileName( SID_FILE_NAME, aURL );
				SfxStringItem aReferer( SID_REFERER, String::CreateFromAscii("private::explorer") );
				GetBindings().GetDispatcher()->Execute( SID_OPENDOC, SFX_CALLMODE_SYNCHRON, &aFileName, &aReferer, 0L );
				xExecutor->execute( ::rtl::OUString::createFromAscii("update"), uno::Any(), uno::Reference< chaos::XStatusCallback >() );
			}
		}
		break;

		default:
			// Text in einer Internet-Searchengine suchen
			SvxInternetFkts::ExecuteInetSearch( pMenu->GetCurItemId() - 1, aNameCB.GetText() );
			break;
	}

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, BookmarkFoundHdl, String *, pUrl )
{
	if (pUrl && pUrl->Len())
	{
		aUrlCB.SetText(*pUrl);
		ComboModifyHdl(&aUrlCB);
	}

	return TRUE;
}
/*--------------------------------------------------------------------
	Beschreibung: Link-Button enablen/disablen
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::EnableLink()
{
	BOOL bEnable = aUrlCB.GetText().Len() != 0;

	EnableItem(BTN_LINK, (!bNoDoc) & bEnable);
}

/*--------------------------------------------------------------------
	Beschreibung: URL im Dokument einfuegen
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::SendToApp(USHORT nType)
{
	BOOL bIsFile = FALSE;
	bSend = TRUE;
	String sURL( aUrlCB.GetText() );

	if ( !sURL.Len() )
		return;

	INetURLObject aObj( URIHelper::SmartRelToAbs( sURL, FALSE,
												  INetURLObject::WAS_ENCODED,
												  INetURLObject::DECODE_UNAMBIGUOUS ) );
	sURL = aObj.GetMainURL();
	if ( aObj.GetProtocol() == INET_PROT_FILE )
		bIsFile = TRUE;

	if ( bIsFile )
	{
		EnterWait();
		SfxMedium aMedium( sURL, STREAM_STD_READ, TRUE );
		if ( aMedium.Exists( FALSE ) == FALSE )
		{
			LeaveWait();
			QueryBox aBox( this, OffResId( RID_SVXQB_DONTEXIST) );
			if ( aBox.Execute() == RET_NO )
				return;
		}
		else
			LeaveWait();
	}

	SvxHyperlinkItem aItem( SID_HYPERLINK_SETLINK );

	if (aNameCB.GetText().Len())
		aItem.SetName( aNameCB.GetText() );
	else
		aItem.SetName( sURL );

	sOldName = aNameCB.GetText();

	aItem.SetURL(sURL);
	aItem.SetInsertMode( (SvxLinkInsertMode)nType );
	aItem.SetTargetFrame( GetSelTarget() );

	GetBindings().GetDispatcher()->Execute(
		SID_HYPERLINK_SETLINK, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );

	AddToHistory( aNameCB.GetText(), sURL );

	if ( sURL != aUrlCB.GetText() )
		aUrlCB.SetText( sURL );
}

/*--------------------------------------------------------------------
	Beschreibung: Selektierten Target Frame Eintrag im Popup ermitteln
 --------------------------------------------------------------------*/

String SvxHyperlinkDlg::GetSelTarget()
{
	String sTarget;

	if (pTargetMenu != NULL)
	{
		for (USHORT i = 1; i <= pTargetMenu->GetItemCount(); i++)
		{
			if (pTargetMenu->IsItemChecked(i))
			{
				sTarget = pTargetMenu->GetItemText(i);
				break;
			}
		}
	}

	return sTarget;
}

/*--------------------------------------------------------------------
	Beschreibung: URL in History der Leiste aufnehmen
 --------------------------------------------------------------------*/

void SvxHyperlinkDlg::AddToHistory(const String& rName, const String& rURL)
{
	String sName(rName);

	if (bHasOldName && sOldName.Len())
	{
		sName = sOldName;
		bHasOldName = FALSE;
	}

	if (!sName.Len())
		sName = rURL;

	if (rURL.Len())
	{
		USHORT nNamePos = aNameCB.GetEntryPos(sName);
		USHORT nUrlPos = aUrlCB.GetEntryPos(rURL);
		USHORT nPos = COMBOBOX_ENTRY_NOTFOUND;

		if (nNamePos != COMBOBOX_ENTRY_NOTFOUND)
			nPos = nNamePos;
		else
			nPos = nUrlPos;

		// Alten Eintrag durch neuen Eintrag ersetzen
		if (nPos != COMBOBOX_ENTRY_NOTFOUND)
		{
			aNameCB.RemoveEntry(nPos);
			aUrlCB.RemoveEntry(nPos);
			aNameCB.SetText(rName);
			aUrlCB.SetText(rURL);
		}

		aNameCB.InsertEntry(sName, 0);
		aUrlCB.InsertEntry(rURL, 0);
	}
}

/*--------------------------------------------------------------------
	Beschreibung: Bookmark und Search-Button enablen/disablen
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, ComboSelectHdl, ComboBox *, pCombo )
{
	USHORT nPos = pCombo->GetEntryPos(pCombo->GetText());

	if (nPos != COMBOBOX_ENTRY_NOTFOUND)
	{
		aNameCB.SetText(aNameCB.GetEntry(nPos));
		aUrlCB.SetText(aUrlCB.GetEntry(nPos));

		EnableLink();
		EnableItem(BTN_INSERT_BOOKMARK, TRUE);
		EnableItem(BTN_INET_SEARCH, TRUE);
	}
	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

IMPL_LINK( SvxHyperlinkDlg, ComboModifyHdl, ComboBox *, pCombo )
{
	BOOL bEnable = TRUE;

	if (!pCombo->GetText().Len())
		bEnable = FALSE;

	if (pCombo == &aNameCB)
	{
		if (IsItemEnabled(BTN_INET_SEARCH) != bEnable)
			EnableItem(BTN_INET_SEARCH, bEnable);
	}

	EnableLink();

	if (aUrlCB.GetText().Len())
		bEnable = TRUE;
	else
		bEnable = FALSE;

	if (IsItemEnabled(BTN_INSERT_BOOKMARK) != bEnable)
		EnableItem(BTN_INSERT_BOOKMARK, bEnable);

	return TRUE;
}

/*--------------------------------------------------------------------
	Beschreibung: Drop moeglich, bzw Format bekannt?
 --------------------------------------------------------------------*/

BOOL SvxHyperlinkDlg::QueryDrop( DropEvent& rDEvt )
{
	rDEvt.SetAction(DROP_COPY);

	SotDataObject* pData = rDEvt.GetData();
	if (pData && INetImage::HasFormat(*pData))
		return TRUE;

	for (USHORT nItem = 0; nItem < DragServer::GetItemCount(); nItem++)
		if (INetBookmark::DragServerHasFormat(nItem))
			return TRUE;

	if ( DragServer::HasFormat( 0, FORMAT_FILE ) )
		return TRUE;

	return FALSE;
}

/*--------------------------------------------------------------------
	Beschreibung: Drop entgegennehmen
 --------------------------------------------------------------------*/

BOOL SvxHyperlinkDlg::Drop( const DropEvent& rDEvt )
{
	String sURL;
	String sName;
	BOOL bRet = FALSE;

	AddToHistory(aNameCB.GetText(), aUrlCB.GetText());	// Alten Eintrag sichern

	SotDataObject* pData = rDEvt.GetData();
	ULONG nFormat;

	if (!bRet && pData && (nFormat = INetImage::HasFormat(*pData)))
	{
		INetImage aImg;
		if (aImg.Paste(*pData, nFormat))
		{
			sURL = INetURLObject(aImg.GetTargetURL()).GetURLNoPass();
			sName = aImg.GetAlternateText();

			bHasOldName = FALSE;
			AddToHistory(sName, sURL);
			aNameCB.SetText(sName);
			aUrlCB.SetText(sURL);

			bRet = TRUE;
		}
	}

	if (!bRet)
	{
		const USHORT nCount = DragServer::GetItemCount();

		// Bookmarks entgegennehmen
		for (USHORT nItem = 0; nItem < nCount; nItem++)
		{
			INetBookmark aMark;
			if (aMark.PasteDragServer(nItem))
			{
				sURL = INetURLObject(aMark.GetURL()).GetURLNoPass();
				sName = aMark.GetDescription();

				bHasOldName = FALSE;
				AddToHistory(sName, sURL);
				aNameCB.SetText(sName);
				aUrlCB.SetText(sURL);

				bRet = TRUE;
			}
		}

		if (!bRet)
		{
			// File-URLs (z.B. aus Win-Explorer) entgegennehmen
			for (USHORT nItem = 0; nItem < nCount; nItem++)
			{
				sURL = DragServer::PasteFile(nItem);

				if (sURL.Len())
				{
					sName = sURL;

					SvStorageRef aStorage = new SvStorage(sName, STREAM_STD_READWRITE);
					SfxDocumentInfo aInfo;

					BOOL bStarDrop = aInfo.Load(aStorage);
					String sDocTitle;

					if (bStarDrop)
					{
						// Bei StarOffice-Dokumenten Titel auslesen
						sDocTitle = aInfo.GetTitle();
						sDocTitle.EraseTrailingChars();
					}

					if (!bStarDrop || !sDocTitle.Len())
					{
						INetURLObject aURL;

						aURL.SetSmartURL( sName );
						sName = aURL.getName();
					}
					else
						sName = sDocTitle;

					INetURLObject aObj;
					aObj.SetSmartProtocol(INET_PROT_FILE);
					aObj.SetURL(ByteString(sURL,gsl_getSystemTextEncoding()));
					sURL = aObj.GetURLNoPass();

					bHasOldName = FALSE;
					AddToHistory(sName, sURL);
					aNameCB.SetText(sName);
					aUrlCB.SetText(sURL);

					bRet = TRUE;
				}
			}
		}
	}

	if (bRet)
	{
		EnableLink();
		EnableItem(BTN_INSERT_BOOKMARK, TRUE);
		EnableItem(BTN_INET_SEARCH, TRUE);
	}
	return bRet;
}

/*--------------------------------------------------------------------
	Beschreibung: Comboboxen
 --------------------------------------------------------------------*/

HyperCombo::HyperCombo( SvxHyperlinkDlg* pDialog, const ResId& rResId ) :
		ComboBox( (Window *)pDialog, rResId )
{
	pDlg = pDialog;

	nMaxWidth = GetSizePixel().Width();
	if (this == &pDlg->aUrlCB)
		nMinWidth = GetTextWidth(String::CreateFromAscii("http://www.stardiv.dewww"));
	else
		nMinWidth = GetTextWidth(String::CreateFromAscii("StarDivision GmbHwww"));

	EnableDrop();
}

/*--------------------------------------------------------------------
	Beschreibung: Comboboxen KeyInput
 --------------------------------------------------------------------*/

long HyperCombo::Notify( NotifyEvent& rNEvt )
{
	long nHandled = 0;
	static BOOL bLocked = FALSE;

	if (bLocked)	// Keine weiteren RETURNs annehmen (nicht Reentrant!)
		return nHandled;

	bLocked = TRUE;

	if ( rNEvt.GetType() == EVENT_KEYINPUT )
	{
		const KeyEvent* pKEvt = rNEvt.GetKeyEvent();
		const KeyCode aKeyCode = pKEvt->GetKeyCode();

		if (aKeyCode.GetCode() == KEY_RETURN)
		{
			pDlg->SendToApp(HLINK_DEFAULT);
			nHandled = 1;
		}
	}
	if (this == &pDlg->aNameCB)
		pDlg->sOldName = GetText();

	if (!nHandled)
		nHandled = ComboBox::Notify( rNEvt );

	bLocked = FALSE;

	return nHandled;
}

/*--------------------------------------------------------------------
	Beschreibung: Drag&Drop vor dem Combo-Edit abfangen und weiterleiten
 --------------------------------------------------------------------*/

long HyperCombo::PreNotify( NotifyEvent& rNEvt )
{
	long nHandled = 0;

	nHandled = ComboBox::PreNotify( rNEvt );

	if ( rNEvt.GetType() == EVENT_QUERYDROP )
	{
		DropEvent *pDEvt = rNEvt.GetDropEvent();
		if (QueryDrop(*pDEvt))
		{
			rNEvt.SetReturnValue(1);
			nHandled = 1;
		}
	}
	else if ( rNEvt.GetType() == EVENT_DROP )
	{
		DropEvent *pDEvt = rNEvt.GetDropEvent();
		if (Drop(*pDEvt))
		{
			rNEvt.SetReturnValue(1);
			nHandled = 1;
		}
	}

	return nHandled;
}

/*--------------------------------------------------------------------
	Beschreibung: Drop moeglich, bzw Format bekannt?
 --------------------------------------------------------------------*/

BOOL HyperCombo::QueryDrop( DropEvent& rDEvt )
{
	return pDlg->QueryDrop(rDEvt);
}

/*--------------------------------------------------------------------
	Beschreibung: Drop entgegennehmen
 --------------------------------------------------------------------*/

BOOL HyperCombo::Drop( const DropEvent& rDEvt )
{
	return pDlg->Drop(rDEvt);
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

long HyperCombo::CalcResizeWidth( long nW )
{
	long nNewWidth = Max(nMaxWidth - nW * GetRatio() / 100L, nMinWidth);

	if (nNewWidth > nMaxWidth)
		nNewWidth = nMaxWidth;

	if (nNewWidth != GetSizePixel().Width())
		return nNewWidth;
	else
		return 0;	// Kein Resize notwendig
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void HyperCombo::DoResize( long nNewWidth )
{
	SetSizePixel(Size(nNewWidth, GetSizePixel().Height()));
}

/*--------------------------------------------------------------------
	Beschreibung: FixedText
 --------------------------------------------------------------------*/

HyperFixedText::HyperFixedText( SvxHyperlinkDlg* pDialog, const ResId& rResId ) :
		FixedInfo( (Window *)pDialog, rResId )
{
	pDlg = pDialog;
	EnableDrop();
}

/*--------------------------------------------------------------------
	Beschreibung: Drop moeglich, bzw Format bekannt?
 --------------------------------------------------------------------*/

BOOL HyperFixedText::QueryDrop( DropEvent& rDEvt )
{
	return pDlg->QueryDrop(rDEvt);
}

/*--------------------------------------------------------------------
	Beschreibung: Drop entgegennehmen
 --------------------------------------------------------------------*/

BOOL HyperFixedText::Drop( const DropEvent& rDEvt )
{
	return pDlg->Drop(rDEvt);
}

/*--------------------------------------------------------------------
	Beschreibung: Internet Search
 --------------------------------------------------------------------*/

Config* SvxInternetFkts::GetSearchEngineConfig()
{
	return OFF_APP()->GetSearchEngConfig();
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

USHORT SvxInternetFkts::GetSearchEngineCount()
{
	return ( GetSearchEngineConfig() ? GetSearchEngineConfig()->GetKeyCount() : 0 );
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

String SvxInternetFkts::GetSearchEngineName( USHORT nPos )
{
	String aEmptyStr;
	Config* pCfg = GetSearchEngineConfig();
	if ( pCfg && nPos < pCfg->GetKeyCount() )
		return String(pCfg->GetKeyName( nPos ),gsl_getSystemTextEncoding());
	return String();
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void SvxInternetFkts::ExecuteInetSearch( USHORT nEngine, const String& rSearchText )
{
	ByteString aGroup( SFX_INIMANAGER()->SubstPathVars( String::CreateFromAscii("SearchEngines-$(vlang)") ),gsl_getSystemTextEncoding());
	Config* pCfg = GetSearchEngineConfig();

	if ( pCfg && nEngine == 0xFFFF )
	{
		pCfg->SetGroup( "Defaults" );
		nEngine = (USHORT)pCfg->ReadKey( "Last" ).ToInt32();
		pCfg->SetGroup( aGroup);
	}

	if ( pCfg && nEngine < pCfg->GetKeyCount() && rSearchText.Len() )
	{
		String sKey( pCfg->ReadKey( nEngine ),gsl_getSystemTextEncoding() );
		String sText( rSearchText );

		sText.EraseLeadingChars().EraseTrailingChars();

		if (sText.Search(' ') != STRING_NOTFOUND)
			FillSearchUrl(sKey, sText, 8, ' ');			// EXAKT
		else if (sText.Search('+') != STRING_NOTFOUND)
			FillSearchUrl(sKey, sText, 0, '+');			// UND
		else if (sText.Search(',') != STRING_NOTFOUND)
			FillSearchUrl(sKey, sText, 4, ',');			// ODER
		else
			FillSearchUrl(sKey, sText, 4, 0);

		SfxViewFrame* pViewFrame = SfxViewFrame::Current();
		if ( pViewFrame )
			pViewFrame = pViewFrame->GetTopViewFrame();
		SvxInternetFkts::OpenDoc( sKey, FALSE, pViewFrame );

		pCfg->SetGroup( "Defaults" );
		pCfg->WriteKey( "Last", ByteString::CreateFromInt32( nEngine ) );
		pCfg->Flush();
		pCfg->SetGroup( aGroup );
	}
}

/*--------------------------------------------------------------------
	Beschreibung: Such-URL fuer Search-Engine zusammenbasteln
 --------------------------------------------------------------------*/

void SvxInternetFkts::FillSearchUrl( String& rKey, String& rText, xub_StrLen nPos, char cTok )
{
	String sURL = rKey.GetToken(nPos, '\"');	// Prefix
	String sSeparator = rKey.GetToken(nPos + 1, '\"');
	String sCase = rKey.GetToken(nPos + 3, '\"');
	xub_StrLen nTok;

	if (sCase == String::CreateFromAscii("Upper"))
		rText.ToUpperAscii();
	else if (sCase == String::CreateFromAscii("Lower"))
		rText.ToLowerAscii();

	if ((nTok = rText.GetTokenCount(cTok)) > 1)
	{
		for (USHORT i = 0; i < nTok; i++)
		{
			sURL += rText.GetToken(i, cTok);
			sURL += sSeparator;
		}
		sURL.Erase(sURL.Len() - sSeparator.Len(), sSeparator.Len());
		sURL += rKey.GetToken(nPos + 2, '\"');	// Postfix
	}
	else
	{
		sURL += rText;
		sURL += rKey.GetToken(nPos + 2, '\"');	// Postfix
	}
	sURL.EraseAllChars();	// Alle Leerzeichen entfernen

	rKey = sURL;
}

/*--------------------------------------------------------------------
	Beschreibung: Webseite der Search-Engine mit Suchergebnissen anzeigen
 --------------------------------------------------------------------*/

void SvxInternetFkts::OpenDoc( const String& rURL, BOOL bNewView, SfxViewFrame* pViewFrame )
{
	SfxStringItem aName( SID_FILE_NAME, rURL );
	SfxStringItem aReferer( SID_REFERER, String::CreateFromAscii(OFA_REFERER) );
	SfxBoolItem aNewView( SID_OPEN_NEW_VIEW, bNewView );
	SfxBoolItem aSilent( SID_SILENT, TRUE );
	SfxBoolItem aReadOnly( SID_DOC_READONLY, TRUE );
	SfxDispatcher* pDisp = SfxViewFrame::Current() ? SfxViewFrame::Current()->GetDispatcher() : NULL;

	if ( pViewFrame )
	{
		SfxFrameItem aView( SID_DOCFRAME, pViewFrame ? pViewFrame->GetFrame() : NULL );
		if ( pDisp )
			pDisp->Execute( SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
							&aName, &aView, &aNewView, &aSilent, &aReadOnly, &aReferer, 0L );
	}
	else if ( pDisp )
		pDisp->Execute( SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
						&aName, &aNewView, &aSilent, &aReadOnly, &aReferer, 0L );
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

void SvxInternetFkts::OpenURL( const String& rURL )
{
	SfxDispatcher* pDisp = SfxViewFrame::Current() ? SfxViewFrame::Current()->GetDispatcher() : NULL;
	if ( pDisp )
	{
		SfxStringItem aURL( SID_FILE_NAME, rURL );
		pDisp->Execute( SID_OPENURL, SFX_CALLMODE_ASYNCHRON, &aURL, 0L );
	}
}

// class SvxHyperlinkDialogWrapper ------------------------------------------

SFX_IMPL_CHILDWINDOW(SvxHyperlinkDlgWrapper, SID_HYPERLINK_INSERT)

/*--------------------------------------------------------------------
	Beschreibung: Wrapper fuer Hyperlinkleiste
 --------------------------------------------------------------------*/

SvxHyperlinkDlgWrapper::SvxHyperlinkDlgWrapper( Window* pParent, USHORT nId,
												SfxBindings* pBindings, SfxChildWinInfo* pInfo ) :

	SfxChildWindow( pParent, nId )

{
	pWindow = new SvxHyperlinkDlg( pBindings, pParent );
	eChildAlignment = SFX_ALIGN_TOP;
}

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

SfxChildWinInfo SvxHyperlinkDlgWrapper::GetInfo() const
{
	SfxChildWinInfo aInfo = SfxChildWindow::GetInfo();
	return aInfo;
}


