/*************************************************************************
 *
 *  $RCSfile: optgdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: pb $ $Date: 2000/09/22 12:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _SV_CONFIG_HXX //autogen wg. Config
#include <vcl/config.hxx>
#endif
#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif
#ifndef _SFXFLAGITEM_HXX //autogen
#include <svtools/flagitem.hxx>
#endif
#ifndef _SFX_INIMGR_HXX //autogen
#include <sfx2/inimgr.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SVX_OPTGENRL_HXX
#include <svx/optgenrl.hxx>
#endif
#ifndef _SVX_OPTPATH_HXX
#include <svx/optpath.hxx>
#endif
#ifndef _SVX_OPTSAVE_HXX
#include <svx/optsave.hxx>
#endif
#ifndef _SVX_OPTLINGU_HXX
#include <svx/optlingu.hxx>
#endif
#ifndef _XPOOL_HXX
#include <svx/xpool.hxx>
#endif
#ifndef _SVX_DLGUTIL_HXX
#include <svx/dlgutil.hxx>
#endif
#ifndef _SFXSZITEM_HXX
#include <svtools/szitem.hxx>
#endif
#ifndef _SFXVIEWSH_HXX
#include <sfx2/viewsh.hxx>
#endif
#ifndef _SVX_TAB_AREA_HXX
#include <svx/tabarea.hxx>
#endif
#ifndef _SVX_LANGTAB_HXX //autogen
#include <svx/langtab.hxx>
#endif
#ifndef _SVX_DIALOGS_HRC
#include <svx/dialogs.hrc>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif

#include "ofaids.hrc"
#include "app.hrc"
#include "app.hxx"
#include "resid.hxx"
#include "optgdlg.hrc"
#include "optgdlg.hxx"
#include "ofaitem.hxx"

#define CONFIG_LANGUAGES "OfficeLanguages"

// class OfaMiscTabPage --------------------------------------------------

IMPL_LINK_INLINE_START( OfaMiscTabPage, OpenGLHdl, CheckBox*, EMPTYARG )
{
	a3DOpenGLFasterCB.Enable( a3DOpenGLCB.IsChecked() );
	return 0;
}
IMPL_LINK_INLINE_END( OfaMiscTabPage, OpenGLHdl, CheckBox*, EMPTYARG )

// -----------------------------------------------------------------------

int OfaMiscTabPage::DeactivatePage( SfxItemSet* pSet )
{
	if ( pSet )
	{
		LanguageType eOldLang = (LanguageType)(USHORT)SFX_INIMANAGER()->Get( SFX_KEY_LANGUAGE ).ToInt32();
		LanguageType eCurLang = GetpApp()->GetAppInternational().GetLanguage();
		USHORT nSelPos = aLangLB.GetSelectEntryPos();

		if ( nSelPos != USHRT_MAX )
		{
			LanguageType eSetLang = (LanguageType)(int)aLangLB.GetEntryData( nSelPos );
			if ( eSetLang != eCurLang && eSetLang != eOldLang )
				InfoBox( this, aStrLanguageInfo ).Execute();
		}
		FillItemSet( *pSet );
	}
	return LEAVE_PAGE;
}

// -----------------------------------------------------------------------

OfaMiscTabPage::OfaMiscTabPage(Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, OffResId( OFA_TP_MISC ), rSet ),

	aLangGB					( this, ResId( GB_LANG ) ),
	aLangLB					( this, ResId( LB_LANG ) ),
	aHelpAgentGB			( this, ResId( GB_HELPAGENT ) ),
	aHelpAgentAutoCB		( this, ResId( CB_HELPAGENT_AUTO ) ),
	aHelpAgentResetCB		( this, ResId( CB_HELPAGENT_RESET ) ),
	aWelcomeScreenGB 		( this, ResId( GB_WELCOMESCREEN ) ),
	aWelcomeScreenCB		( this, ResId( CB_WELCOMESCREEN ) ),
	aWelcomeScreenResetCB	( this, ResId( CB_WELCOMESCREEN_RESET ) ),
	a3DGB					( this, ResId( GB_3D ) ),
	a3DOpenGLCB				( this, ResId( CB_3D_OPENGL ) ),
	a3DOpenGLFasterCB		( this, ResId( CB_3D_OPENGL_FASTER ) ),
	a3DDitheringCB			( this, ResId( CB_3D_DITHERING ) ),
	a3DShowFullCB			( this, ResId( CB_3D_SHOWFULL ) ),
	aGbTwoFigure			( this, ResId( GB_TWOFIGURE ) ),
	aNfYearValue			( this, ResId( NF_YEARVALUE ) ),
	aFtTo					( this, ResId( FT_TO) ),
	aStrLanguageInfo		(		ResId( STR_LANGUAGE_INFO ) )

{
	FreeResource();

	aStrDateInfo = aFtTo.GetText();
	a3DOpenGLCB.SetClickHdl( LINK( this, OfaMiscTabPage, OpenGLHdl ) );
	aNfYearValue.SetModifyHdl( LINK( this, OfaMiscTabPage, TwoFigureHdl ) );
	Link aLink = LINK( this, OfaMiscTabPage, TwoFigureConfigHdl );
	aNfYearValue.SetDownHdl( aLink );
	aNfYearValue.SetUpHdl( aLink );
	aNfYearValue.SetLoseFocusHdl( aLink );
	aNfYearValue.SetFirstHdl( aLink );
	TwoFigureConfigHdl( &aNfYearValue );

	//!!! (pb) no help at the moment
	aHelpAgentGB.Hide();
	aHelpAgentAutoCB.Hide();
	aHelpAgentResetCB.Hide();
	aWelcomeScreenCB.Hide();
	aWelcomeScreenResetCB.Hide();
	aWelcomeScreenGB.Hide();

	SetExchangeSupport();
}

// -----------------------------------------------------------------------

OfaMiscTabPage::~OfaMiscTabPage()
{
}

// -----------------------------------------------------------------------

SfxTabPage*	OfaMiscTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return new OfaMiscTabPage( pParent, rAttrSet );
}

// -----------------------------------------------------------------------

BOOL OfaMiscTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;
	BOOL bPut = FALSE;
	SfxIniManager* pIniMgr = SFX_INIMANAGER()->Find( SFX_KEY_LANGUAGE );

	if ( !pIniMgr )
		pIniMgr = SFX_INIMANAGER();

	LanguageType eCurLang = GetpApp()->GetAppInternational().GetLanguage();
	USHORT nSelPos = aLangLB.GetSelectEntryPos();

	if ( nSelPos != USHRT_MAX )
	{
		LanguageType eSetLang = (LanguageType)(int)aLangLB.GetEntryData( nSelPos );
		if ( eSetLang != eCurLang )
		{
			String aLocale = ConvertLanguageToIsoString( eSetLang, '_' );
			pIniMgr->Set( aLocale, SFX_KEY_LANGUAGE );
		}
	}

	SfxBoolItem* pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_ATTR_AUTOHELPAGENT ) );

	if ( pItem->GetValue() != aHelpAgentAutoCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_ATTR_AUTOHELPAGENT, aHelpAgentAutoCB.IsChecked() ) );
	}

	if ( aHelpAgentResetCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_AUTOHELPAGENT_RESET, TRUE ) );
	}

	pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_ATTR_WELCOMESCREEN ) );

	if ( pItem->GetValue() != aWelcomeScreenCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_ATTR_WELCOMESCREEN, aWelcomeScreenCB.IsChecked() ) );
	}

	if ( aWelcomeScreenResetCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_WELCOMESCREEN_RESET, TRUE ) );
	}

	BOOL bTemp = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_OPENGL ).ToInt32();

	if ( bTemp != a3DOpenGLCB.IsChecked() )
	{
		pIniMgr->Set( String::CreateFromInt32( (USHORT)a3DOpenGLCB.IsChecked() ), SFX_KEY_3D_OPENGL );
		bModified = TRUE;
	}

	String aKey = pIniMgr->Get( SFX_KEY_3D_OPENGL_FASTER );
	bTemp = !aKey.Len() ? TRUE : (BOOL)(USHORT)aKey.ToInt32();
	BOOL bCheck = ( a3DOpenGLCB.IsChecked() && a3DOpenGLFasterCB.IsChecked() );
	if ( bTemp != bCheck )
	{
		pIniMgr->Set( String::CreateFromInt32( (USHORT)bCheck ), SFX_KEY_3D_OPENGL_FASTER );
		bModified = TRUE;
	}

	bTemp = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_DITHERING ).ToInt32();

	if ( bTemp != a3DDitheringCB.IsChecked() )
	{
		pIniMgr->Set( String::CreateFromInt32( (USHORT)a3DDitheringCB.IsChecked() ), SFX_KEY_3D_DITHERING );
		bModified = TRUE;
	}

	bTemp = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_SHOWFULL ).ToInt32();

	if ( bTemp != a3DShowFullCB.IsChecked() )
	{
		pIniMgr->Set( String::CreateFromInt32( (USHORT)a3DShowFullCB.IsChecked() ), SFX_KEY_3D_SHOWFULL );
		bModified = TRUE;
	}

	const SfxUInt16Item* pUInt16Item = PTR_CAST( SfxUInt16Item, GetOldItem( rSet, SID_ATTR_YEAR2000 ) );
	USHORT nNum = aNfYearValue.GetText().ToInt32();
	if ( pUInt16Item->GetValue() != nNum )
	{
		bModified = TRUE;
		rSet.Put( SfxUInt16Item( SID_ATTR_YEAR2000, nNum ) );
	}

	return bModified;
}

// -----------------------------------------------------------------------

void OfaMiscTabPage::Reset( const SfxItemSet& rSet )
{
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	// eingestellte Sprache ermitteln
	LanguageType eCurLanguage = GetpApp()->GetAppInternational().GetLanguage();
	// ggf. aus der Ini-Datei
	String aLocale = pIniMgr->Get( SFX_KEY_LANGUAGE );
	eCurLanguage = ConvertIsoStringToLanguage( aLocale, '_' );
	USHORT i, nPos = 0;
	USHORT nKeyCount = pIniMgr->GetKeyCount( String::CreateFromAscii(CONFIG_LANGUAGES) );
	SvxLanguageTable aTable;
	// Listbox aus Ini-Datei f"ullen
	aLangLB.Clear();
	for ( i = 0; i < nKeyCount; ++i )
	{
		String aKey = pIniMgr->GetKeyName( String::CreateFromAscii(CONFIG_LANGUAGES), i );
		String aVal = pIniMgr->ReadKey( String::CreateFromAscii(CONFIG_LANGUAGES), aKey );

		if ( ByteString(aKey,gsl_getSystemTextEncoding()).IsNumericAscii() && aVal.EqualsIgnoreCaseAscii("Installed") )
		{
			LanguageType eLangType = (LanguageType)(USHORT)aKey.ToInt32();
			nPos = aLangLB.InsertEntry( aTable.GetString( eLangType ) );
			aLangLB.SetEntryData( nPos, (void*)eLangType );
		}
	}

	// wenn keine Eintr"age vorhanden waren,
	// dann zu mindestens die eingestellte Sprache eintragen
	if ( !aLangLB.GetEntryCount() )
	{
		nPos = aLangLB.InsertEntry( aTable.GetString( eCurLanguage ) );
		aLangLB.SetEntryData( nPos, (void*)eCurLanguage );
	}
	// eingestellte Sprache selektieren
	FASTBOOL bFound = FALSE;
	for ( i = 0; i < aLangLB.GetEntryCount(); ++i )
	{
		LanguageType eLang = (LanguageType)(int)aLangLB.GetEntryData(i);

		if ( eLang == eCurLanguage )
		{
			aLangLB.SelectEntryPos(i);
			bFound = TRUE;
			break;
		}
	}

	if ( !bFound )
	{
		// eingestellte Sprache war nicht vorhanden,
		// also eintragen und gleich selektieren
		nPos = aLangLB.InsertEntry( aTable.GetString( eCurLanguage ) );
		aLangLB.SetEntryData( nPos, (void*)eCurLanguage );
		aLangLB.SelectEntryPos( nPos );
	}

	// Listbox disablen, wenn nicht mindestens zwei Eintr"age vorhanden sind
	aLangLB.SetDropDownLineCount( aLangLB.GetEntryCount() );
	BOOL bEnable = ( aLangLB.GetEntryCount() >= 2 );
	aLangLB.Enable( bEnable );
	aLangGB.Enable( bEnable );
	const SfxPoolItem* pItem;

	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_ATTR_AUTOHELPAGENT, FALSE, &pItem ) )
		aHelpAgentAutoCB.Check( ( (SfxBoolItem*)pItem )->GetValue() );

	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_ATTR_WELCOMESCREEN, FALSE, &pItem ) )
		aWelcomeScreenCB.Check( ( (SfxBoolItem*)pItem )->GetValue() );

	BOOL bSet = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_OPENGL ).ToInt32();
	a3DOpenGLCB.Check( bSet );
	String aKey = pIniMgr->Get( SFX_KEY_3D_OPENGL_FASTER );
	bSet = !aKey.Len() ? TRUE : (BOOL)(USHORT)aKey.ToInt32();
	a3DOpenGLFasterCB.Check( a3DOpenGLCB.IsChecked() && bSet );
	OpenGLHdl( NULL );
	bSet = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_DITHERING ).ToInt32();
	a3DDitheringCB.Check( bSet );
	bSet = (BOOL)(USHORT)pIniMgr->Get( SFX_KEY_3D_SHOWFULL ).ToInt32();
	a3DShowFullCB.Check( bSet );

	if ( SFX_ITEM_SET == rSet.GetItemState( SID_ATTR_YEAR2000, FALSE, &pItem ) )
		aNfYearValue.SetValue( ((SfxUInt16Item*)pItem)->GetValue() );
	else
		aNfYearValue.SetValue( SvNumberFormatter::GetYear2000Default() );
	TwoFigureConfigHdl( &aNfYearValue );
}

// -----------------------------------------------------------------------


IMPL_LINK( OfaMiscTabPage, TwoFigureHdl, NumericField*, pEd )
{
	String aOutput( aStrDateInfo );
	String aStr( aNfYearValue.GetText() );
	aStr.EraseAllChars( aNfYearValue.GetInternational().GetNumThousandSep() );
	long nNum = aStr.ToInt32();
	if ( aStr.Len() != 4 || nNum < aNfYearValue.GetMin() || nNum > aNfYearValue.GetMax() )
		aOutput.AppendAscii("????");
	else
	{
		nNum += 99;
		aOutput += String::CreateFromInt32( nNum );
	}
	aFtTo.SetText( aOutput );
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( OfaMiscTabPage, TwoFigureConfigHdl, NumericField*, pEd )
{
	long nNum = aNfYearValue.GetValue();
	String aOutput( String::CreateFromInt32( nNum ) );
	aNfYearValue.SetText( aOutput );
	aNfYearValue.SetSelection( Selection( 0, aOutput.Len() ) );
	TwoFigureHdl( pEd );
	return 0;
}

// class OfaViewTabPage --------------------------------------------------

OfaViewTabPage::OfaViewTabPage(Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, OffResId( OFA_TP_VIEW ), rSet ),

	aAppearanceGB		( this, ResId( GB_APPEARANCE ) ),
	aLogoFT				( this, ResId( FT_LOGO ) ),
	aLogoLB				( this, ResId( LB_LOGO ) ),
	aAppearanceFT		( this, ResId( FT_APPEARANCE ) ),
	aAppearanceLB		( this, ResId( LB_APPEARANCE ) ),
	aWindowDragFT		( this, ResId( FT_WINDOW_DRAG ) ),
	aWindowDragLB		( this, ResId( LB_WINDOW_DRAG ) ),
	aScalingFT			( this, ResId( FT_SCALING ) ),
	aScalingMF			( this, ResId( MF_SCALING ) ),
	aButtonsGB			( this, ResId( GB_BUTTONS ) ),
	aBigCB				( this, ResId( CB_BIG ) ),
	aStyleCB			( this, ResId( CB_STYLE ) ),
	aMousePosGB			( this, ResId( GB_MOUSEPOS ) ),
	aMousePosLB			( this, ResId( LB_MOUSEPOS ) ),
	aMiscGB				( this, ResId( GB_VIEW_MISC ) ),
	aMouseFollowCB  	( this, ResId( CB_MOUSE_FOLLOW ) ),
	aFlatTabCtrlCB		( this, ResId( CB_FLAT_TAB_CTRL ) ),
	aColorTabCtrlCB		( this, ResId( CB_COLOR_TAB_CTRL ) ),
	aFontShowCB			( this, ResId( CB_FONT_SHOW ) ),
	aShowInactiveItemsCB( this, ResId( CB_SHOW_INACTIVE ) ),
	aFontHistoryCB		( this, ResId( CB_FONT_HISTORY ) )

{
	FreeResource();
}

/*-----------------06.12.96 11.50-------------------

--------------------------------------------------*/

OfaViewTabPage::~OfaViewTabPage()
{
}

/*-----------------06.12.96 11.50-------------------

--------------------------------------------------*/

SfxTabPage*	OfaViewTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return new OfaViewTabPage(pParent, rAttrSet);
}

/*-----------------06.12.96 11.50-------------------

--------------------------------------------------*/

BOOL OfaViewTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;
	USHORT nIntro = aLogoLB.GetSelectEntryPos();
	if (nIntro <= 1)
		nIntro ^= 1;

	SfxIniManager* pIniMgr = SFX_INIMANAGER()->Find( SFX_KEY_LANGUAGE );
	if ( !pIniMgr )
		pIniMgr = SFX_INIMANAGER();

	if (aLogoLB.GetSelectEntryPos() != aLogoLB.GetSavedValue())
		pIniMgr->Set( String::CreateFromInt32( nIntro ), SFX_KEY_SHOW_INTRO );

	SfxBoolItem *pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_ATTR_BUTTON_OUTSTYLE3D ) );
	if ( pItem->GetValue() == aStyleCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_ATTR_BUTTON_OUTSTYLE3D, !aStyleCB.IsChecked() ) );
	}

	pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_ATTR_BUTTON_BIGSIZE ) );
	if ( pItem->GetValue() != aBigCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_ATTR_BUTTON_BIGSIZE, aBigCB.IsChecked() ) );
	}

	// Look & Feel Group
	SfxUInt16Item *pU16Item = PTR_CAST( SfxUInt16Item, GetOldItem(rSet, SID_OPT_SYSTEMLOOK));
	SystemLook eOldLook = (SystemLook)pU16Item->GetValue();
	SystemLook eNewLook;

	switch (aAppearanceLB.GetSelectEntryPos())
	{
		case 1:	eNewLook = LookMacintosh;		break;
		case 2:	eNewLook = LookMotif;			break;
		case 3:	eNewLook = LookOSTwo;			break;
		case 0:
		default:eNewLook = LookStardivision;	break;
	}

	if ( eNewLook != eOldLook )
	{
		bModified = TRUE;
		rSet.Put( SfxUInt16Item( SID_OPT_SYSTEMLOOK, (UINT16)eNewLook ) );
	}

	// Screen Scaling
	pU16Item = PTR_CAST( SfxUInt16Item, GetOldItem(rSet, SID_OPT_SCREENSCALING));
	UINT16 nOldScale = (UINT16)pU16Item->GetValue();
	UINT16 nNewScale = (UINT16)aScalingMF.GetValue();

	if ( nNewScale != nOldScale )
	{
		bModified = TRUE;
		rSet.Put( SfxUInt16Item( SID_OPT_SCREENSCALING, nNewScale ) );
	}

	// Mouse Snap Mode
	pU16Item = PTR_CAST( SfxUInt16Item, GetOldItem(rSet, SID_OPT_SNAPTYPE) );
	SnapType eOldSnap = (SnapType)pU16Item->GetValue();
	SnapType eNewSnap;

	switch (aMousePosLB.GetSelectEntryPos())
	{
		case 0:	eNewSnap = SnapToButton;	break;
		case 1:	eNewSnap = SnapToMiddle;	break;
		case 2:
		default:eNewSnap = NoSnap;			break;
	}

	if ( eNewSnap != eOldSnap )
	{
		bModified = TRUE;
		rSet.Put( SfxUInt16Item( SID_OPT_SNAPTYPE, (UINT16)eNewSnap ) );
	}

	// Window Drag Mode
	pU16Item = PTR_CAST( SfxUInt16Item, GetOldItem(rSet, SID_OPT_DRAGMODE) );
	DragMode eOldDragMode = (DragMode)pU16Item->GetValue();
	UINT16   nNewDragMode = (UINT16)aWindowDragLB.GetSelectEntryPos();

	if ( nNewDragMode != USHRT_MAX )
	{
		if ( ( DragMode)nNewDragMode != eOldDragMode )
		{
			bModified = TRUE;
			rSet.Put( SfxUInt16Item( SID_OPT_DRAGMODE, nNewDragMode ) );
		}
	}

	if ( aMouseFollowCB.IsChecked() != aMouseFollowCB.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( SID_APPEAR_MENUE_MOUSE_FOLLOW, aMouseFollowCB.IsChecked() ) );
		bModified = TRUE;
	}
	if ( aFlatTabCtrlCB.IsChecked() != aFlatTabCtrlCB.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( SID_APPEAR_SINGLE_LINE_TABCTRL, aFlatTabCtrlCB.IsChecked() ) );
		bModified = TRUE;
	}

	if ( aColorTabCtrlCB.IsChecked() != aColorTabCtrlCB.GetSavedValue() )
	{
		rSet.Put( SfxBoolItem( SID_APPEAR_COLORED_TABCTRL, aColorTabCtrlCB.IsChecked() ) );
		bModified = TRUE;
	}

	if ( aFontShowCB.IsChecked() != aFontShowCB.GetSavedValue() )
	{
		String aVal;aVal.AssignAscii(aFontShowCB.IsChecked() ? "1" : "0");
		pIniMgr->Set( aVal, SFX_KEY_SHOW_FONTBOX_WYSIWYG );
		bModified = TRUE;
	}

	if ( aShowInactiveItemsCB.IsChecked() != aShowInactiveItemsCB.GetSavedValue() )
	{
		String aVal;aVal.AssignAscii(aShowInactiveItemsCB.IsChecked() ? "1" : "0");
		pIniMgr->Set( aVal, SFX_KEY_DONTHIDE_DISABLEDENTRIES );
		bModified = TRUE;
	}

	if ( aFontHistoryCB.IsChecked() != aFontHistoryCB.GetSavedValue() )
	{
		String aVal;aVal.AssignAscii(aFontHistoryCB.IsChecked() ? "1" : "0");
		pIniMgr->Set( aVal, SFX_KEY_FONT_HISTORY );
		bModified = TRUE;
	}
	return bModified;
}

/*-----------------06.12.96 11.50-------------------

--------------------------------------------------*/

void OfaViewTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;

	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	String aIntroVal( pIniMgr->Get( SFX_KEY_SHOW_INTRO ));
	USHORT nIntro = 2;	// Systemabh"angig

	if ( aIntroVal.Len() )
		nIntro = (USHORT)aIntroVal.ToInt32();

	aLogoLB.SelectEntryPos(nIntro > 1 ? nIntro : nIntro ^ 1);
	aLogoLB.SaveValue();

	if( SFX_ITEM_SET == rSet.GetItemState(SID_ATTR_BUTTON_OUTSTYLE3D, FALSE, &pItem) )
		aStyleCB.Check( !((SfxBoolItem*)pItem)->GetValue() );
	if( SFX_ITEM_SET == rSet.GetItemState(SID_ATTR_BUTTON_BIGSIZE, FALSE, &pItem) )
		aBigCB.Check( ((SfxBoolItem*)pItem)->GetValue() );

	// Look & Feel
	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_OPT_SYSTEMLOOK, FALSE, &pItem ) )
	{
		SystemLook eLook = (SystemLook)((const SfxUInt16Item*)pItem)->GetValue();
		USHORT nPos;

		switch (eLook)
		{
			case LookMacintosh:		nPos = 1;	break;
			case LookMotif:			nPos = 2;	break;
			case LookOSTwo:			nPos = 3;	break;
			case LookStardivision:
			default:				nPos = 0;	break;
		}
		aAppearanceLB.SelectEntryPos(nPos);
	}
	aAppearanceLB.SaveValue();

	// Screen Scaling
	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_OPT_SCREENSCALING, FALSE, &pItem ) )
	{
		UINT16 nScaleFactor = (UINT16)((const SfxUInt16Item*)pItem )->GetValue();
		aScalingMF.SetValue ( nScaleFactor );
	}
	aScalingMF.SaveValue();

	// Mouse Snap
	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_OPT_SNAPTYPE, FALSE, &pItem ) )
	{
		SnapType eSnap = (SnapType)((const SfxUInt16Item*)pItem )->GetValue();
		USHORT nPos;

		switch (eSnap)
		{
			case SnapToButton:		nPos = 0;	break;
			case SnapToMiddle:		nPos = 1;	break;
			case NoSnap:
			default:				nPos = 2;	break;
		}
		aMousePosLB.SelectEntryPos(nPos);
	}
	aMousePosLB.SaveValue();

	// Window Drag Mode
	if ( SFX_ITEM_SET ==
		 rSet.GetItemState( SID_OPT_DRAGMODE, FALSE, &pItem ) )
	{
		USHORT nPos = (USHORT)((const SfxUInt16Item*)pItem )->GetValue();
		aWindowDragLB.SelectEntryPos ( nPos );
	}
	aWindowDragLB.SaveValue();

	if(SFX_ITEM_SET == rSet.GetItemState(SID_APPEAR_MENUE_MOUSE_FOLLOW, FALSE, &pItem))
		aMouseFollowCB.Check( ((const SfxBoolItem*)pItem)->GetValue() );

	if(SFX_ITEM_SET == rSet.GetItemState(SID_APPEAR_SINGLE_LINE_TABCTRL, FALSE, &pItem))
		aFlatTabCtrlCB.Check( ((const SfxBoolItem*)pItem)->GetValue() );

	if(SFX_ITEM_SET == rSet.GetItemState(SID_APPEAR_COLORED_TABCTRL, FALSE, &pItem))
		aColorTabCtrlCB.Check(((const SfxBoolItem*)pItem)->GetValue() );

	USHORT nVal = pIniMgr->Get( SFX_KEY_SHOW_FONTBOX_WYSIWYG ).ToInt32();
	aFontShowCB.Check( (BOOL)nVal );

	String aTemp = pIniMgr->Get( SFX_KEY_DONTHIDE_DISABLEDENTRIES );
	BOOL bBool = aTemp.Len() ? (BOOL)(USHORT)aTemp.ToInt32() : FALSE;
	aShowInactiveItemsCB.Check( bBool );

   	aTemp = pIniMgr->Get( SFX_KEY_FONT_HISTORY );
	bBool = aTemp.Len() ? (BOOL)(USHORT)aTemp.ToInt32() : TRUE;
	aFontHistoryCB.Check( bBool );

	aMouseFollowCB.SaveValue();
	aFlatTabCtrlCB.SaveValue();
	aColorTabCtrlCB.SaveValue();
	aFontShowCB.SaveValue();
	aShowInactiveItemsCB.SaveValue();
	aFontHistoryCB.SaveValue();
}

// class OfaPrintTabPage -------------------------------------------------

OfaPrintTabPage::OfaPrintTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, OffResId( OFA_TP_PRINT ), rSet ),

	aWarnGB			( this, ResId( GB_WARN ) ),
	aPaperSizeCB	( this, ResId( CB_PAPER_SIZE ) ),
	aOrientationCB	( this, ResId( CB_ORIENTATION ) ),
	aOutputGB		( this, ResId( GB_PRINT_OUTPUT ) ),
	aEnableMetaCB	( this, ResId( CB_PRINT_ENABLEMETA ) )

{
	FreeResource();
#ifndef OS2
	aOutputGB.Hide();
	aEnableMetaCB.Hide();
#endif
}

/*-----------------06.12.96 11.46-------------------

--------------------------------------------------*/

OfaPrintTabPage::~OfaPrintTabPage()
{
}

/*-----------------06.12.96 11.47-------------------

--------------------------------------------------*/

SfxTabPage*	OfaPrintTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return new OfaPrintTabPage( pParent, rAttrSet );
}

/*-----------------06.12.96 11.48-------------------

--------------------------------------------------*/

BOOL OfaPrintTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;

	if ( aPaperSizeCB.IsChecked() != aPaperSizeCB.GetSavedValue() ||
		 aOrientationCB.IsChecked() != aOrientationCB.GetSavedValue() )
	{
		USHORT nFlag = aPaperSizeCB.IsChecked() ? SFX_PRINTER_CHG_SIZE : 0;
		nFlag |= aOrientationCB.IsChecked() ? SFX_PRINTER_CHG_ORIENTATION : 0;
		bModified |= ( 0 != rSet.Put( SfxFlagItem( SID_PRINTER_CHANGESTODOC, nFlag ) ) );
	}

	if ( aEnableMetaCB.IsChecked() != aEnableMetaCB.GetSavedValue() )
		bModified |= ( 0 != rSet.Put(
			SfxBoolItem( SID_ENABLE_METAFILEPRINT, aEnableMetaCB.IsChecked() ) ) );

	return bModified;
}

/*-----------------06.12.96 11.48-------------------

--------------------------------------------------*/

void OfaPrintTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;

	if ( SFX_ITEM_SET == rSet.GetItemState( SID_PRINTER_CHANGESTODOC, FALSE, &pItem ) )
	{
		USHORT nFlag = ( (const SfxFlagItem*)pItem )->GetValue();
		aPaperSizeCB.Check( 0 != ( nFlag & SFX_PRINTER_CHG_SIZE ) );
		aOrientationCB.Check( 0 != ( nFlag & SFX_PRINTER_CHG_ORIENTATION ) );
	}

	if ( SFX_ITEM_SET == rSet.GetItemState( SID_ENABLE_METAFILEPRINT, FALSE, &pItem ) )
		aEnableMetaCB.Check( ( (const SfxBoolItem*)pItem )->GetValue() );

	aPaperSizeCB.SaveValue();
	aOrientationCB.SaveValue();
	aEnableMetaCB.SaveValue();
}

// class OfaDesktopTabPage -----------------------------------------------

OfaDesktopTabPage::OfaDesktopTabPage( Window* pParent, const SfxItemSet& rSet ) :

	SfxTabPage( pParent, OffResId( OFA_TP_DESKTOP ), rSet ),

	aPosModeGB				( this, ResId( GB_POSITION_MODE ) ),
	aPosFreeRB				( this, ResId( RB_POS_FREE ) ),
	aPosAutoAdjustRB		( this, ResId( RB_POS_AUTOADJUST ) ),
	aPosAutoArrangeRB		( this, ResId( RB_POS_AUTOARRANGE ) ),
	aIconSpacingGB			( this, ResId( GB_ICON_SPACING ) ),
	aHoriFT					( this, ResId( FT_HORI ) ),
	aHoriMF					( this, ResId( MF_HORI ) ),
	aVertFT					( this, ResId( FT_VERT ) ),
	aVertMF					( this, ResId( MF_VERT ) ),
	aGBOptions				( this, ResId( GB_OPTIONS ) ),
	aSmartCB				( this, ResId( CB_SMART_BEAMER ) ),
	aRestoreExpandStateCB	( this, ResId( CB_RESTORE_EXPAND_STATE ) ),
	aWebViewCB				( this, ResId( CB_WEBVIEW ) ),
	aWebViewFileFT			( this, ResId( FT_WEBVIEWFILE ) ),
	aWebViewFileED			( this, ResId( ED_WEBVIEWFILE ) ),
	aWebViewDefaultFilePB	( this, ResId( PB_WEBVIEWDEFAULTFILE ) )

{
	FreeResource();
	// Anschalten des Exchange-Supports ist fuer die 5.1-Auslieferung zu riskant.
	// Wir setzen stattdessen im FillItemSet den WebViewFile-Namen auf
	// FOLDERWEBVIEW_DEFAULTFILE, wenn er leer ist, statt in DeactivatePage
	// eine Fehlermeldung auszugeben und das Schliessen des Dialogs zu verhindern.
	//SetExchangeSupport(TRUE);
	Link aClickHdl( LINK(this,OfaDesktopTabPage,ClickHdl_Impl ));
	aWebViewDefaultFilePB.SetClickHdl( aClickHdl );
	aWebViewCB.SetClickHdl( aClickHdl );
}

// -----------------------------------------------------------------------

OfaDesktopTabPage::~OfaDesktopTabPage()
{
}

// -----------------------------------------------------------------------

IMPL_LINK( OfaDesktopTabPage, ClickHdl_Impl, Button*, pButton )
{
	if( pButton == &aWebViewDefaultFilePB )
		aWebViewFileED.SetText( String::CreateFromAscii(FOLDERWEBVIEW_DEFAULTFILE) );
	else if( pButton == &aWebViewCB )
		EnableControls();

	return 0;
}

// -----------------------------------------------------------------------

SfxTabPage*	OfaDesktopTabPage::Create( Window* pParent,const SfxItemSet& rAttrSet)
{
	return new OfaDesktopTabPage(pParent, rAttrSet);
}

// -----------------------------------------------------------------------

BOOL OfaDesktopTabPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bModified = FALSE;

	SfxBoolItem* pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_ATTR_SMARTBEAMER ) );
	if ( pItem->GetValue() != aSmartCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_ATTR_SMARTBEAMER, aSmartCB.IsChecked() ) );
	}
	pItem = PTR_CAST( SfxBoolItem, GetOldItem( rSet, SID_RESTORE_EXPAND_STATE ) );
	if ( pItem->GetValue() != aRestoreExpandStateCB.IsChecked() )
	{
		bModified = TRUE;
		rSet.Put( SfxBoolItem( SID_RESTORE_EXPAND_STATE, aRestoreExpandStateCB.IsChecked() ) );
	}

	SfxSizeItem *pSzItem = PTR_CAST( SfxSizeItem, GetOldItem( rSet, SID_ICONGRID ) );
	Size aNewSize(aHoriMF.GetValue(), aVertMF.GetValue());
	if ( pSzItem->GetValue() != aNewSize )
	{
		bModified = TRUE;
		rSet.Put( SfxSizeItem( SID_ICONGRID, aNewSize ) );
	}

	UINT16 nMode = 0;
	if( aPosAutoArrangeRB.IsChecked() )
		nMode = 1;
	else if( aPosAutoAdjustRB.IsChecked() )
		nMode = 2;
	SfxUInt16Item* pPosItem = PTR_CAST( SfxUInt16Item, GetOldItem( rSet, SID_AUTO_ADJUSTICONS ) );
	if( pPosItem->GetValue() != nMode )
	{
		bModified = TRUE;
		rSet.Put( SfxUInt16Item( SID_AUTO_ADJUSTICONS, nMode ));
	}

	String aEDText( aWebViewFileED.GetText() );
	if( !aEDText.Len() ||
		aWebViewCB.GetSavedValue() != aWebViewCB.IsChecked() ||
		aWebViewFileED.GetSavedValue() != aEDText )
	{
		String aWebViewSettings;
		BOOL bWebViewOn = aWebViewCB.IsChecked();
		aWebViewSettings += (bWebViewOn ? '1' : '0');
		aWebViewSettings += ';';
		String aEDText( aWebViewFileED.GetText() );
		// statt einer Fehlermeldung in DeactivatePage setzen wir zur
		// 5.1-Auslieferung den Standardnamen
		if( !aEDText.Len() )
			aEDText = String::CreateFromAscii(FOLDERWEBVIEW_DEFAULTFILE);
		aWebViewSettings += aEDText;
		bModified = TRUE;
		rSet.Put( SfxStringItem( SID_ATTR_ALLOWFOLDERWEBVIEW, aWebViewSettings ));
	}
	return bModified;
}

// -----------------------------------------------------------------------

void OfaDesktopTabPage::Reset( const SfxItemSet& rSet )
{
	const SfxPoolItem* pItem;

	if( SFX_ITEM_SET == rSet.GetItemState(SID_ATTR_SMARTBEAMER, FALSE, &pItem) )
		aSmartCB.Check( ((SfxBoolItem*)pItem)->GetValue() );

	if( SFX_ITEM_SET == rSet.GetItemState(SID_RESTORE_EXPAND_STATE, FALSE, &pItem) )
		aRestoreExpandStateCB.Check( ((SfxBoolItem*)pItem)->GetValue() );

	if( SFX_ITEM_SET == rSet.GetItemState(SID_ICONGRID, FALSE, &pItem) )
	{
		const Size &rSz = ((SfxSizeItem*)pItem)->GetValue();
		aHoriMF.SetValue(rSz.Width());
		aVertMF.SetValue(rSz.Height());
	}

	if( SFX_ITEM_SET == rSet.GetItemState(SID_AUTO_ADJUSTICONS, FALSE, &pItem) )
	{
		UINT16 nMode = ((const SfxUInt16Item*)pItem)->GetValue();
		if( nMode == 1 )
			aPosAutoArrangeRB.Check();
		else if( nMode == 2 )
			aPosAutoAdjustRB.Check();
		else
			aPosFreeRB.Check();
	}

	if( SFX_ITEM_SET == rSet.GetItemState(SID_ATTR_ALLOWFOLDERWEBVIEW, FALSE, &pItem) )
	{
		String aValue( ((SfxStringItem*)pItem)->GetValue() );
		BOOL bWebViewOn = aValue.Len() ? (aValue.GetChar(0) == '0' ? FALSE : TRUE ) : FALSE;
		aWebViewCB.Check( bWebViewOn );
		aValue.Erase( 0, 2 );
		if( aValue.Len() )
			aWebViewFileED.SetText( aValue );
		else
			aWebViewFileED.SetText( String::CreateFromAscii(FOLDERWEBVIEW_DEFAULTFILE) );
	}
	else
	{
		aWebViewCB.Check( FALSE );
		aWebViewFileED.SetText( String::CreateFromAscii(FOLDERWEBVIEW_DEFAULTFILE) );
	}
	aWebViewCB.SaveValue();
	aWebViewFileED.SaveValue();

	EnableControls();
}

// -----------------------------------------------------------------------

void OfaDesktopTabPage::EnableControls()
{
	BOOL bWebViewOn = aWebViewCB.IsChecked();
	aWebViewFileFT.Enable( bWebViewOn );
	aWebViewFileED.Enable( bWebViewOn );
	aWebViewDefaultFilePB.Enable( bWebViewOn );
}


