/*************************************************************************
 *
 *  $RCSfile: msgdoc.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFA_MSGDOC_HXX
#define _OFA_MSGDOC_HXX

#ifndef OLD_CHAOS
#ifndef _CNTAPI_HXX //autogen
#include <chaos/cntapi.hxx>
#endif
#else
#ifndef _CNTAPI_HXX //autogen
#include <sfx2/cntapi.hxx>
#endif
#endif

#ifndef _SMART_COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HXX_
#include <smart/com/sun/star/frame/XDispatchProvider.hxx>
#endif

#include <chaos/rcpnitem.hxx>

#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#ifndef _FSETOBJSH_HXX //autogen
#include <sfx2/fsetobsh.hxx>
#endif
#ifndef _SFXSMPLHINT_HXX
#include <svtools/smplhint.hxx>
#endif

#include "msgmodel.hxx"

class IncomingMail;
class INetCoreNewsMessage;
class INetCoreMIMEMessage;
class OffMessageView_Impl;
class OffMsgInterceptor_Impl;
class SfxFrame;
class SfxFrameWindow;
class DateTime;
class SfxSimpleLockBytesFactory;
class StringMap;

#define SFX_INTERFACE_OFFMSGDOC (SFX_INTERFACE_OFA_START+2)

//=========================================================================

// Die Daten des Headers
struct OffMsgRecipient
{
	CntOutMsgProtocolType	_eProt;				// das Versende-Protokoll
	CntOutMsgRoleType		_eRole;				// Role der Adresse (To, CC, BCC,..)
	XubString				_aAdress;			// Adresse
	XubString				_aServer;			// der Versende-Server, falls bekannt

	// Konstruktoren
	OffMsgRecipient() :	_eProt (CNT_OUTMSG_PROTOCOL_SMTP), _eRole (CNT_OUTMSG_ROLE_TO) {};

	OffMsgRecipient( CntOutMsgProtocolType eP, CntOutMsgRoleType eR,
					 const XubString& aA, const XubString& aS ) :
		_eProt (eP), _eRole (eR), _aAdress ( aA ), _aServer ( aS ) {};

	OffMsgRecipient( const OffMsgRecipient& rhs );

	// Destruktor
	~OffMsgRecipient()  {};

};

// im Dokument gespeicherte Form der ServerMap der OffComboBox
struct OffServerMapEntry
{
	XubString	_aKey;
	XubString	_aValue;

	OffServerMapEntry() {};
	OffServerMapEntry( const XubString& rKey, const XubString& rVal ) :
		_aKey ( rKey ), _aValue ( rVal ) {};
	~OffServerMapEntry() {};
};

SV_DECL_PTRARR_DEL ( StoredServerMap, OffServerMapEntry*, 4, 4 )

SV_DECL_PTRARR_DEL ( RecipientList, OffMsgRecipient*, 4, 4 )

enum OffDataUpdate
{
	DATA_UPDATE_ALL,
	DATA_UPDATE_HEADER,
	DATA_UPDATE_BODY
};

class OffMsgDocHeader
{
private:
	RecipientList*			_pRecipients;			// Rezipienten
	OffMsgRecipient*		_pEditedRecipient;		// Rezipient-Daten, die gerade Ediert werden
	USHORT					_nPriority;
	XubString				_aFrom;
	BOOL					_bReturnReceipt;
	XubString				_aSubject;
	StoredServerMap*		_pServerMap;			// Zuordnung Versende-Server zu NewsGruppe

public:
	OffMsgDocHeader();
	~OffMsgDocHeader();

	void Clear();
	// der eingefuegte Rezipient wird Eigentum von OffMsgDocHeader
	void Append ( OffMsgRecipient* pRecipient );
	// der eingefuegte Rezipient wird Eigentum von OffMsgDocHeader
	void SetEditedRecipient ( OffMsgRecipient* pRecipient );
	// Prioritaet
	void SetPriority ( USHORT nPrio )			{ _nPriority = nPrio;}
	// From
	void SetFrom	 ( const XubString& rFrom )	{ _aFrom = rFrom;}
	// ReturnReceipt
	void SetReturnReceipt ( BOOL bValue )		{ _bReturnReceipt = bValue;}
	// Subject
	void SetSubject ( const XubString& rSub )	{ _aSubject = rSub;}
	// ServerMap-Eintrag
	void AddServerMapEntry ( const XubString& rKey, const XubString& rValue );

	USHORT	RecipientCount() const;
	const 	OffMsgRecipient*	GetRecipient ( USHORT i ) const
												{ return _pRecipients->GetObject(i);}
	const 	OffMsgRecipient*	GetEditedRecipient () const
												{ return _pEditedRecipient;}
	USHORT	GetPriority() const					{ return _nPriority;}
	const 	XubString& GetFrom() const			{ return _aFrom;}
	BOOL	GetReturnReceipt() const			{ return _bReturnReceipt;}
	const	XubString& GetSubject() const		{ return _aSubject;}
	USHORT	ServerMapCount() const ;
	const 	OffServerMapEntry*	GetServerMapEntry ( USHORT i ) const
												{ return _pServerMap->GetObject(i);}

};

inline USHORT OffMsgDocHeader::RecipientCount() const
{
	if ( !_pRecipients )
		return 0;
	return _pRecipients->Count();
}

inline USHORT OffMsgDocHeader::ServerMapCount() const
{
	if ( !_pServerMap )
		return 0;
	return _pServerMap->Count();
}

class OffMsgDocBody
{
private:
	USHORT					_nFormat;		// alternative Body-Formate
	// Der Body selbst
	XubString				_aBodyFile;		// Pfad zum Tmp-File mit dem Body
	// "Anhaenge"
	SvStringsDtor*			_pAttachList;	// Liste mit Pfaden der Anhaenge
public:
	OffMsgDocBody()
	: _nFormat ( 0 ), _pAttachList ( 0 )	{};
	~OffMsgDocBody();

	void SetFormat ( USHORT nFormat )					{ _nFormat = nFormat;}
	void SetBody	  ( const XubString& rTmpFile )		{ _aBodyFile = rTmpFile;}
	void AppendAttachment ( const XubString& rAttach );
	void Clear ();

	USHORT	GetFormat()	const							{ return _nFormat;}
	const 	XubString&	GetBody() const					{ return _aBodyFile;}
	USHORT	AttachCount() const;
	const 	XubString*	GetAttachment( USHORT i ) const	{ return _pAttachList->GetObject(i);}
};

inline USHORT OffMsgDocBody::AttachCount() const
{
	if ( !_pAttachList )
		return 0;
	return _pAttachList->Count();
}

struct OffMsgDocData {
	BOOL					_bEmpty;			// Leer ?
	BOOL					_bModified;			// geaendert ?
	OffMsgDocHeader			_Header;
	OffMsgDocBody			_Body;

	OffMsgDocData ()
	: _bEmpty ( TRUE ), _bModified ( FALSE ) {};
	~OffMsgDocData () {};

	void Clear();
	void SetModified ( BOOL bValue );
	BOOL IsModified ()						{return _bModified;}

};

inline void OffMsgDocData::SetModified ( BOOL bValue )
{
	_bModified = bValue;
	if ( _bModified )
		_bEmpty = FALSE;
}

//=========================================================================

class OffMessageDoc_Impl : public SfxFrameSetObjectShell

/*	[Beschreibung]

	Diese spezielle Document repr"asentiert ein- und ausgehende Messages
	(Mails und News-Postings) dar und kann sie als Dateien laden und
	speichern.

	Siehe dazu Feature-Chart <k:\sfx2\soffice3.2\features\messages.sdw>.
*/

{
friend class OffMessageView_Impl;
friend class OffMessageModel;

private:
	USHORT					_nSlot;
	USHORT                  _nSaveSlot;
	BOOL					_bPrepareClose	: 1, // Merker, ob schon gerufen
							_bNew			: 1, // Msg schreiben, nicht lesen
							_bWithAnchor	: 1, // mit Anchor ge"offnet?
							_bAsTemplate	: 1, // als template speichern?
							_bMustSetDate	: 1, // nach Speichern SetDate?
							_bRestoreTitle	: 1, // ggf. den Titel restaurieren
							_bAbortSave		: 1, // Speichern abgebrochen?
							_bInPrepareClose: 1, // in PrepareClose()?
							_bSalvage		: 1; // salvage after GPF?

	OffMessageView_Impl*	_pView;				 // die View
	SfxSimpleLockBytesFactory*	_pPreviewFac;	 // f"ur die Preview
	CntAnchorRef			_xAnchor;			 // ein Anchor
	CntAnchorRef			_xParentAnchor;		 // ein ParentAnchor
	CntAnchorRef			_xModelAnchor;		 // Anchor of the model
	String					_aFileName;			 // Dateiname aus ConvertFrom()
	String					_aBoxName;			 // Name des MessageContainers
	Timer                   _aSaveTimer;
	XubString				_aNewMsgParentURL;	 // URL des Parent-Ankers einer neuen Nachricht
												 // (ist nicht immer bekannt)
	OffMsgDocData			_aDocData;		 	 // Daten: Header, Body
	XDispatchProviderRef	xProvider;
	XDispatchProviderInterceptorRef	xInt1;
	XDispatchProviderInterceptorRef	xInt2;
	XDispatchProviderInterceptorRef	xInt3;

	String				GetMailBodyURL( INetCoreNewsMessage* pMsg );
	SvStream*			GetAttachmentMailBody( INetCoreNewsMessage& rMsg,
											   String& rType ) const;
	SvStream*			GetAlternativeMailBody( INetCoreNewsMessage& rMsg,
												String& rType ) const;
	void				ActivateFromView( OffMessageView_Impl* pView );
	FASTBOOL			HasView() { return ( _pView != NULL ); }
	FASTBOOL			Load( SvStream& rStrm, SfxMedium* pMedium );
	FASTBOOL			Store( SvStream& rStrm, SfxMedium* pMedium );
	void                SaveNow( SfxRequest *pReq = NULL );
	CntAnchor*			getModelAnchor();

	// UI-Anfrage: Soll die Nachricht geschlossen werden ...
	USHORT				UIQueryCloseMessage (Window* pParent, BOOL bSend );

	DECL_LINK( SaveHdl, Timer* );

protected:
	virtual void		FillClass( SvGlobalName* pClassName,
								   ULONG* pClipFormat, String* pAppName,
								   String* pLongUserName,
								   String* pUserName,
								   long nFileFormat = SOFFICE_FILEFORMAT_NOW ) const;

public:
                        SFX_DECL_SIMPLE_OBJECTFACTORY(OffMessageDoc_Impl);
						SFX_DECL_INTERFACE(SFX_INTERFACE_OFFMSGDOC);
						TYPEINFO();

						OffMessageDoc_Impl( SfxObjectCreateMode eMode );
						~OffMessageDoc_Impl();

	virtual BOOL		InitNew( SvStorage* pStg );
	virtual BOOL		ConvertFrom( SfxMedium& rMedium );
	virtual BOOL		ConvertTo( SfxMedium& rMedium );
	virtual BOOL		Load( SvStorage* pStg );
	virtual BOOL		Save();
	virtual BOOL		SaveAs( SvStorage* pStg );
	virtual BOOL		SaveCompleted( SvStorage* pStg );
	virtual SbxObject*	GetSbxObject();
	virtual USHORT		PrepareClose( BOOL bUI = TRUE, BOOL bForBrowsing = FALSE );
	virtual void		ParentActivate();
	virtual void		ParentDeactivate();
	virtual String		QueryTitle( SfxTitleQuery eType ) const;
	virtual BOOL		Close();

	void				SetSlot( USHORT nSlot ) { _nSlot = nSlot; }
	USHORT				GetSlot() const { return _nSlot; }
	void				SetView( OffMessageView_Impl* pView )
							{ _pView = pView; }
	const String&		GetFileName() const { return _aFileName; }
	void				EraseFileName() { _aFileName.Erase(); }
	const String&		GetBoxName() const { return _aBoxName; }
	void				SetBoxName( const String& rNew ) { _aBoxName = rNew; }

	CntAnchor*			GetAnchor() const { return _xAnchor; }
	void				SetAnchor( CntAnchor* pAnchor ) { _xAnchor = pAnchor; }
	void				CreateAnchor();
	CntAnchor*			GetParentAnchor() const { return _xParentAnchor; }
	BOOL				IsNew() const { return _bNew; }
	void				SetNew( BOOL bNew ) { _bNew = bNew; }
	BOOL				IsOpenWithAnchor() const { return _bWithAnchor; }
	void				SetOpenWithAnchor( BOOL bNew ) { _bWithAnchor = bNew; }
	void				SetAsTemplate() { _bAsTemplate = TRUE; }
	void				SetFileDateTime( const DateTime& rDateTime );
	void                SaveMail( USHORT nSlot, SfxRequest &rReq );
	BOOL				MustRestoreTitle() const { return _bRestoreTitle; }
	void				SetRestoreTitle() { _bRestoreTitle = TRUE; }
	void				SetNewTitle( const String& rTitle );
	void				UpdateAnchor();
	void				UpdateDocInfo( const INetCoreNewsMessage& rMsg );
	void				UpdateDone() { Broadcast( SfxSimpleHint( SFX_HINT_UPDATEDONE ) ); }
    void                SetModified( BOOL bModify );
	void				Connect( BOOL bConnect );
	XDispatchProviderRef GetProvider() const { return xProvider; }

    CntAnchorRef        GetUpdatedAnchor( BOOL bUpdate );
	BOOL				IsInPrepareClose() const { return _bInPrepareClose; }
	BOOL				IsSalvage() const { return _bSalvage; }

#if __PRIVATE
	void				MiscExec_Impl( SfxRequest& );
	void				MiscState_Impl( SfxItemSet& );
	void				PropExec_Impl( SfxRequest& );
	void				PropState_Impl( SfxItemSet& );
#endif
	XubString&			GetNewMsgParentURL()	{ return _aNewMsgParentURL; }

	static SfxFrameWindow* CreateWin( SfxFrame* pFrame, const String& rName );

	// Dokument-Daten aktualisieren
	void				UpdateData ( OffDataUpdate eUpdateHint );
	// Hat das Dokument Daten
	BOOL 				HasData()	{ return !_aDocData._bEmpty;}
	// Modified-Flag an den Daten setzen
	void				SetDataModified( BOOL bVal )	{ _aDocData.SetModified(bVal);}
	// Header und Body holen
	const OffMsgDocHeader&	GetHeaderData()	{ return _aDocData._Header;}
	const OffMsgDocBody&	GetBodyData()	{ return _aDocData._Body;}
};

#endif // #ifndef _OFA_MSGDOC_HXX


