/*************************************************************************
 *
 *  $RCSfile: msgview.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFA_MSGVIEW_HXX
#define _OFA_MSGVIEW_HXX

#ifndef _SFXSIDS_HRC
#include <sfx2/sfxsids.hrc>
#endif
#ifndef _SFXFSETVIW_HXX //autogen
#include <sfx2/fsetvwsh.hxx>
#endif
#ifndef _SFX_PGPWRP_HXX //autogen wg. SfxPGPWrapper
#include <sfx2/pgpwrp.hxx>
#endif
#ifndef _DATETIME_HXX //autogen
#include <tools/datetime.hxx>
#endif

#include "msgdoc.hxx"

// Forward ---------------------------------------------------------------

class SfxPrinter;
class SfxViewFrame;
class MailHeaderWin_Impl;
class MailAttachWin_Impl;
class OffPropertyValueList;

// define ----------------------------------------------------------------

#define SFX_INTERFACE_OFFMSGVIEW (SFX_INTERFACE_OFA_START+1)

#define TEMPLATE_SUB_DIR		"internal"
#define REPLY_TMPLFILE_ASCII	"rplytext.vor"
#define REPLY_TMPLFILE_OFFICE	"rplymail.vor"
#define PRINT_TMPLFILE			"prnmail.vor"

// Struktur Mail Encryption Info -----------------------------------------

enum MailEncodingType
{
	 NONE,
	 PGP
};

struct MailEncoding
{
	MailEncodingType	eType;
	BOOL				bPGPSign;
	BOOL				bPGPEncrypt;

	MailEncoding ( MailEncodingType eT ) { eType = eT; }
};

// class OffMessageView_Impl ---------------------------------------------

class OffMessageView_Impl : public SfxFrameSetViewShell

/*	[Beschreibung]

	Diese spezielle View stellt ein- und ausgehende Messages (Mails und News-
	Postings) in einem Dokumentfenster dar. Siehe dazu Feature-Chart
	<k:\sfx2\soffice3.2\features\messages.sdw>.
*/

{
friend class OffMessageDoc_Impl;

private:
	USHORT					_nSlot;
	USHORT					_nReleaseAnchor;
	BYTE					_nTxtFormat;
	BOOL					_bLocal				:1,
							_bMailReply			:1,
							_bPostReply			:1,
							_bForward			:1,
							_bAdrBook			:1,
							_bNewsGrps			:1,
							_bSetPrinter		:1,
							_bIsInPrinting		:1,
							_bFillOnCloseDone	:1,
							_bUpdateDone		:1,
							_bIsInSaving		:1,
							_bMustClose			:1;

	MailHeaderWin_Impl* 	_pHeaderWin;
	MailAttachWin_Impl*		_pAttachWin;
	OffMessageDoc_Impl*		_pSh;			// die dazugeh"orige ObjectShell
	SfxItemSet*				_pAnchorSet;	// Set des gelesenen Anchors
	SfxPrinter*				_pPrinter;		// neu konfigurierter Drucker
	CntAnchorRef			_xAnchor;		// aktueller Anchor
	CntAnchorRef			_xOldAnchor;	// aktueller Anchor
	CntAnchorRef			_xOutboxAnchor;	// Anchor auf die OutBox

	String					_aAnchorURL;	// Own-URL, zum Wiederherstellen
	String					_aAnchorMsgId;	// MessageId f"ur Reply/Followup
	String					_aAnchorReferences;
	String					_aDefaultFrom;
	String					_aDefaultReplyTo;
	String					_aDefaultMailServer;
	String					_aDefaultMailUser;
	String					_aDefaultMailPassword;
	String					_aDefaultNewsServer;
	String					_aDefaultNewsUser;
	String					_aDefaultNewsPassword;
	String					_aNewsGroup;
	String					_aBasicRecipient;
	String					_aBasicSubject;
	String					_aLocalFrom;

	DateTime				_aMsgDateTime;
	Timer					_aUpdateTimer;
	static UINT16			_nSendAction;

	void					Construct( SfxViewFrame* pFrame );
	FASTBOOL				IsFromEqual( const String& rFrom );
	FASTBOOL				SendNow( SfxRequest* pRequest = NULL, FASTBOOL bClose = TRUE );
	void					SaveFrameDescriptor();
	BOOL					SaveAnchor( SvStream& rOutStrm, BOOL bAsTemplate );
	BOOL					CreateAnchor();
	CntAnchor*				GetRootAnchor( BOOL bReply );
	void					FillModelAnchor();

	// Ist PGP vorhanden ?
	BOOL					IsPGPAvailable()
								{ return SfxPGPWrapper::IsPGPAvailable(); }

							DECL_LINK( TimeoutHdl, Timer * );
	// Update der Dokument-Daten
	void 					UpdateDocumentData ( OffDataUpdate eUpdateHint = DATA_UPDATE_ALL );

protected:
	virtual void			InnerResizePixel( const Point& rOfs, const Size& rSize );
	virtual void			OuterResizePixel( const Point& rOfs, const Size& rSize );

public:
							TYPEINFO();
							SFX_DECL_VIEWFACTORY(OffMessageView_Impl);
							SFX_DECL_INTERFACE(SFX_INTERFACE_OFFMSGVIEW);

							OffMessageView_Impl( SfxViewFrame* pFrame );
							OffMessageView_Impl( SfxViewFrame* pFrame,
												 SfxViewShell* );
							OffMessageView_Impl( SfxViewFrame* pFrame,
										 const OffMessageView_Impl& rThis );
	virtual					~OffMessageView_Impl();

	virtual FASTBOOL		KeyInput( const KeyEvent& rKEvt );
	virtual void			ParentActivate();
	virtual void			Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
	virtual USHORT			PrepareClose( BOOL bUI = TRUE, BOOL bForBrowsing = FALSE );

#if __PRIVATE
	void					MiscExec_Impl( SfxRequest& );
	void					MiscState_Impl( SfxItemSet& );

	void					SetHeaderWin( MailHeaderWin_Impl* pWin )
								{ _pHeaderWin = pWin; }
	void					SetAttachWin( MailAttachWin_Impl* pWin )
								{ _pAttachWin = pWin; }
	USHORT					GetSlot() const { return _nSlot; }
	void					SetSlot( USHORT nNew ) { _nSlot = nNew; }
	BYTE					GetTextFormat() const { return _nTxtFormat; }
	void					SetTextFormat( BYTE nNew ) { _nTxtFormat = nNew; }

	BOOL					FillMessage(const MailEncoding* pEncode = 0);
	MailHeaderWin_Impl* 	GetHeaderWin() const { return _pHeaderWin; };
	BOOL					IsComplete() const { return ( _pHeaderWin && _pAttachWin ); }
	inline FASTBOOL			IsReadOnly() const;
	BOOL					IsModified() const { return _pSh->IsModified(); }
	void					SetModified( BOOL bModify );
	SfxObjectShell*			GetBody() const;
	void					UpdateDone() { _pSh->UpdateDone(); _bUpdateDone = TRUE; }
	BOOL					IsUpdateDone() const { return _bUpdateDone; }
	void					AddNewAddress( const String& rAddr );

	CntAnchor*				GetAnchor() const { return _xAnchor; }
	void					SetAnchor( CntAnchor* pNew, USHORT nSlot );
	CntAnchor*				GetUpdatedAnchor();
	void					ReleaseAnchor();
	void					SetOutboxAnchor( CntAnchor* pNew ) { _xOutboxAnchor = pNew; }
	CntAnchor*				GetOutboxAnchor() const { return _xOutboxAnchor; }
	CntAnchor*				GetOutbox( BOOL bError = TRUE ) const;
	void					SaveAnchorSet( CntAnchor* pAnchor );
	const SfxItemSet*		GetAnchorSet() const { return _pAnchorSet; }
	void					PrintMessage( USHORT nSlot );

	const String&			GetDefaultFrom();
	void					SetDefaultFrom( const String& rNew )
								{ _aDefaultFrom = rNew; }
	const String&			GetDefaultReplyTo() const
								{ return _aDefaultReplyTo; }
	void					SetDefaultReplyTo( const String& rNew )
								{ _aDefaultReplyTo = rNew; }
	const String&			GetDefaultMailServer() const
								{ return _aDefaultMailServer; }
	void					SetDefaultMailServer( const String& rNew )
								{ _aDefaultMailServer = rNew; }
	const String&			GetDefaultMailUser() const
								{ return _aDefaultMailUser; }
	void					SetDefaultMailUser( const String& rNew )
								{ _aDefaultMailUser = rNew; }
	const String&			GetDefaultMailPassword() const
								{ return _aDefaultMailPassword; }
	void					SetDefaultMailPassword( const String& rNew )
								{ _aDefaultMailPassword = rNew; }
	const String&			GetDefaultNewsServer() const
								{ return _aDefaultNewsServer; }
	void					SetDefaultNewsServer( const String& rNew )
								{ _aDefaultNewsServer = rNew; }
	const String&			GetDefaultNewsUser() const
								{ return _aDefaultNewsUser; }
	void					SetDefaultNewsUser( const String& rNew )
								{ _aDefaultNewsUser = rNew; }
	const String&			GetDefaultNewsPassword() const
								{ return _aDefaultNewsPassword; }
	void					SetDefaultNewsPassword( const String& rNew )
								{ _aDefaultNewsPassword = rNew; }
	const String&			GetNewsGroup() const { return _aNewsGroup; }
	void					SetNewsGroup( const String& rGrp )
								{ _aNewsGroup = rGrp; }
	const String&			GetBasicRecipient() const
								{ return _aBasicRecipient; }
	void					SetBasicRecipient( const String& rRcpt );
	const String&			GetBasicSubject() const { return _aBasicSubject; }
	void					SetBasicSubject( const String& rSubject )
								{ _aBasicSubject = rSubject; }
	BOOL					IsLocal() const { return _bLocal; }
	const String&			GetLocalFrom() const { return _aLocalFrom; }
	BOOL					IsInSaving() const { return _bIsInSaving; }
	void					SetupPrinter();
	const String&			GetAnchorURL() const { return _aAnchorURL; }
	void					UpdateToolBox();

	XubString&				GetNewMsgParentURL()	{ return _pSh->GetNewMsgParentURL(); }

	// Zugriff auf Header-Daten
	void					UpdateHeaderData( OffMsgDocHeader& rHeader );
	// Zugriff auf Body-Daten
	void					UpdateBodyData( OffMsgDocBody& rBody );

	void					SetProperties( const OffPropertyValueList* pPropList );
	CntAnchor*				getModelAnchor();

	BOOL					ContinueAfterAsciiWarning() const;
#endif
};

inline FASTBOOL OffMessageView_Impl::IsReadOnly() const
{
	return ( SID_MAIL_NEW != _nSlot &&
			 SID_MAIL_REPLY != _nSlot &&
			 SID_MAIL_GROUPREPLY != _nSlot &&
			 SID_MAIL_FOLLOWUP != _nSlot &&
			 SID_MAIL_REPLY_FOLLOWUP != _nSlot &&
			 SID_MAIL_FORWARD != _nSlot );
}

#endif // #ifndef _OFA_MSGVIEW_HXX


