/*************************************************************************
 *
 *  $RCSfile: optgdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OFA_OPTGDLG_HXX
#define _OFA_OPTGDLG_HXX

#ifndef _SV_LSTBOX_HXX //autogen wg. ListBox
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen wg. GroupBox
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen wg. NumericField
#include <vcl/field.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen wg. FixedText
#include <vcl/fixed.hxx>
#endif
#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif

#define FOLDERWEBVIEW_DEFAULTFILE	"folder.so"

// class OfaMiscTabPage --------------------------------------------------

class OfaMiscTabPage : public SfxTabPage
{
private:
	GroupBox			aLangGB;
	ListBox				aLangLB;

	GroupBox			aHelpAgentGB;
	CheckBox			aHelpAgentAutoCB;
	CheckBox			aHelpAgentResetCB;

	GroupBox			a3DGB;
	CheckBox			a3DOpenGLCB;
	CheckBox			a3DOpenGLFasterCB;
	CheckBox			a3DDitheringCB;
	CheckBox			a3DShowFullCB;

	GroupBox			aWelcomeScreenGB;
	CheckBox			aWelcomeScreenCB;
	CheckBox			aWelcomeScreenResetCB;

	GroupBox			aGbTwoFigure;
	NumericField		aNfYearValue;
	FixedText			aFtTo;

	String				aStrDateInfo;
	String				aStrLanguageInfo;

	DECL_LINK( OpenGLHdl, CheckBox* );
	DECL_LINK( TwoFigureHdl, NumericField* );
	DECL_LINK( TwoFigureConfigHdl, NumericField* );

protected:
	virtual int         DeactivatePage( SfxItemSet* pSet = NULL );

public:
	OfaMiscTabPage( Window* pParent, const SfxItemSet& rSet );
	~OfaMiscTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class OfaViewTabPage --------------------------------------------------

typedef enum {
	LookStardivision = 0,
	LookMotif,
	LookWindows,
	LookOSTwo,
	LookMacintosh
} SystemLook;

typedef enum {
	NoSnap = 0,
	SnapToButton,
	SnapToMiddle
} SnapType;

typedef enum { // MUST match the order chosen in ListBox LB_DRAG_MODE in optgdlg.src
	DragFullWindow,
	DragFrame,
	DragSystemDep
} DragMode;

class OfaViewTabPage : public SfxTabPage
{
private:
	GroupBox	aAppearanceGB;
	FixedText	aLogoFT;
	ListBox		aLogoLB;
	FixedText	aAppearanceFT;
	ListBox		aAppearanceLB;
	FixedText	aWindowDragFT;
	ListBox		aWindowDragLB;
	FixedText	aScalingFT;
	MetricField	aScalingMF;

	GroupBox	aMousePosGB;
	ListBox		aMousePosLB;

	GroupBox	aButtonsGB;
	CheckBox	aBigCB;
	CheckBox	aStyleCB;

	GroupBox	aMiscGB;
	CheckBox	aMouseFollowCB;
	CheckBox	aFlatTabCtrlCB;
	CheckBox	aColorTabCtrlCB;
	CheckBox	aFontShowCB;
	CheckBox	aShowInactiveItemsCB;
	CheckBox	aFontHistoryCB;

public:
	OfaViewTabPage( Window* pParent, const SfxItemSet& rSet );
	~OfaViewTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class OfaPrintTabPage -------------------------------------------------

class OfaPrintTabPage : public SfxTabPage
{
private:
	GroupBox			aWarnGB;
	CheckBox			aPaperSizeCB;
	CheckBox			aOrientationCB;

	GroupBox			aOutputGB;
	CheckBox			aEnableMetaCB;

public:
	OfaPrintTabPage( Window* pParent, const SfxItemSet& rSet );
	~OfaPrintTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

// class OfaDesktopTabPage -------------------------------------------------

class OfaDesktopTabPage : public SfxTabPage
{
private:
	GroupBox 			aPosModeGB;
	RadioButton 		aPosFreeRB;
	RadioButton 		aPosAutoAdjustRB;
	RadioButton 		aPosAutoArrangeRB;

	GroupBox			aIconSpacingGB;
	FixedText			aHoriFT;
	MetricField			aHoriMF;
	FixedText			aVertFT;
	MetricField			aVertMF;

	GroupBox			aGBOptions;
	CheckBox			aSmartCB;
	CheckBox			aRestoreExpandStateCB;
	CheckBox			aWebViewCB;
	FixedText			aWebViewFileFT;
	Edit				aWebViewFileED;
	PushButton			aWebViewDefaultFilePB;

	void				EnableControls();

	DECL_LINK( ClickHdl_Impl, Button * );

public:
	OfaDesktopTabPage( Window* pParent, const SfxItemSet& rSet );
	~OfaDesktopTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
};

#endif // #ifndef _OFA_OPTGDLG_HXX


