/*************************************************************************
 *
 *  $RCSfile: dbbase.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DB_HXX
#include "db.hxx"
#endif
#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_MENUITEMDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuItemDescriptor.hpp>
#endif
#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif
#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
//#ifndef _SBA_SBAEXPOB_HXX
//#include "sbaexpob.hxx"
//#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SBA_SQLDLG_HXX
#include "sqldlg.hxx"
#endif
#ifndef _DTRANS_HXX //autogen
#include <so3/dtrans.hxx>
#endif
#ifndef _SOT_EXCHANGE_HXX //autogen
#include <sot/exchange.hxx>
#endif
#ifndef _SDB_SDBSTAT_HXX //autogen
#include <sdb/sdbstat.hxx>
#endif
#ifndef _FSYS_HXX //autogen wg. DirEntry
#include <tools/fsys.hxx>
#endif
#ifndef _BMKOBJ_HXX //autogen
#include <sfx2/bmkobj.hxx>
#endif
#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif
#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx>
#endif


// ---------------
// - SbaXDBContent -
// ---------------

#define DB_PROP_COUNT			13

const SbaXDBPropMap aSbaXDBMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_OWNURL,
	SBA_PROP_RENAME,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_SORTCRITERIA,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------

IMPL_DB_PROPMAP( SbaXDB, DB_PROP_COUNT );
IMPL_DB_PROPSET( SbaXDB );
//SMART_UNO_IMPLEMENTATION( DBPropertySetInfo, UsrObject );
//SMART_REFLECTION_IMPLEMENTATION( SbaXDBContent, SbaXChaosContent, ::rtl::OUString::createFromAscii("SbaXDBContent") )

// ------------------------------------------------------------------------
SbaXDBContent::SbaXDBContent()
			  :SbaXChaosContent(aSbaXDBMap_Impl, sal_True)
			  ,m_bFirstOpen(sal_True)
{
	aContentType = ::rtl::OUString("application/sbase;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_DATABASE)));
	m_nLargeBitmapId = RID_BMP_DB_DATABASE_L;
	m_nSmallBitmapId = RID_BMP_DB_DATABASE_S;
}

// ------------------------------------------------------------------------
SbaXDBContent::~SbaXDBContent()
{
	// As we have no explicit uninitialize we have to do this here.
	// And as we have no chance to know if we have been moved (there is only a "prepareMove" command
	// which of course isn't sufficient) we have to check if the SDB-file we represent is still
	// existent.
	// FS - 25.06.99 - 67017
	XubString sURL(S(aUrl));
	DirEntry aExistenceCheck(sURL);
	if (!aExistenceCheck.Exists())
		SBAEXPL()->DropDatabaseAlias(sURL);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any	SAL_CALL SbaXDBContent::queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface(_rType,
		static_cast< ::com::sun::star::chaos::XExplorerExchange*>(this));
	if(aRet.hasValue())
		return aRet;

	return SbaXChaosContent::queryInterface( _rType );
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL SbaXDBContent::getTypes() throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > aTypes(SbaXChaosContent::getTypes());
	aTypes.realloc(1);
	aTypes.getArray()[aTypes.getLength()-1] = ::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XExplorerExchange>*)0);
	return aTypes;
}

// ::com::sun::star::chaos::XExplorerExchange
//------------------------------------------------------------------
::com::sun::star::uno::Any SAL_CALL SbaXDBContent::createDataObject(sal_uInt16& nSourceOptions)
{
	nSourceOptions = DRAG_COPYABLE | DRAG_LINKABLE;
	if (!FileStat::GetReadOnlyFlag(aDatabasePath))
		nSourceOptions |= DRAG_MOVEABLE;

	SvDataMemberObject* pDataObject = new SvDataMemberObject;
	SvData* pData = new SvData( FORMAT_FILE, MEDIUM_MEMORY );

	// Windows mag keine Backslashes hinter Verzeichnisnamen (#56403)
	XubString aPath(aDatabasePath.GetFull());
	sal_uInt16 nLength = aPath.Len();
	char cDelim = DirEntry::GetAccessDelimiter().GetChar(0);
	if (nLength && aPath[(sal_uInt16)(nLength-1)] == cDelim)
		aPath.Erase( nLength-1 );
	pData->SetData( aPath );
	pDataObject->Append( pData );

	// Linkable
/*	INetURLObject aObj;
	aObj.SetSmartProtocol(INET_PROT_FILE);
	aObj.SetURL(aPath, sal_False);

*/
	::com::sun::star::uno::Any aAny(_getPropertyValue(PROP_ID_TITLE));
	SfxBookmarkObject::AddBookmarkObject( pDataObject, S(getURL()), S(::utl::getString(aAny)) );

	return ::com::sun::star::uno::makeAny(sal_Int64(pDataObject));
}

//------------------------------------------------------------------
sal_uInt16 SAL_CALL SbaXDBContent::insertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions)
{
	return 0;
}

//------------------------------------------------------------------
sal_Bool SAL_CALL SbaXDBContent::queryInsertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions, sal_uInt16& nResultingAction, sal_uInt16& nDefaultAction)
{
	return sal_False;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::create(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						   const ::com::sun::star::uno::Any& rParam)
{
	if (editProperties(rCmd, rJob, rParam, sal_True))
	{
		INetURLObject aObj;
		aObj.SetSmartProtocol(INET_PROT_FILE);
		aObj.SetURL(aDatabasePath.GetFull(), sal_False);
		aUrl = U(aObj.GetMainURL());
		rJob->result(rCmd, SBA_RESULT_CREATED, aUrl);
		return sal_True;
	}
	return sal_False;
}

//-------------------------------------------------------------------------
sal_Bool SbaXDBContent::editProperties(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								   const ::com::sun::star::uno::Any& rParam,
								   sal_Bool bNew)
{
	// Informationen ueber die Verbindung holen
	// wenn die Datenbank nicht neu angelegt wurde (IsSaved())
	sal_Bool	bReadOnly = sal_False;
	XubString	aConnectStr, aNewConnectStr;
	XubString  aDatabaseFileName;
	// Informationen ueber die Verbindung holen
	if (!bNew)
	{
		aDatabaseFileName = aDatabasePath.GetFull();
		if (xDatabase.Is())
		{
			OfaDatabaseGuard aDatabaseSafety(&xDatabase);
			aConnectStr = xDatabase->ConnectStr();
			bReadOnly	= xDatabase->IsReadOnly();

			// alle Kinder lschen, damit die Datenbank nicht gelockt wird
			aDatabaseSafety.clear();
			rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_TABLESMARK_HEADER));
			rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_FORMSMARK_HEADER));
			rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_REPORTSMARK_HEADER));
			rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_QUERIESMARK_HEADER));
		}
		else
		{
			aConnectStr = SBAOBJ()->GetDatabaseConnectStr(aDatabasePath.GetFull(), sal_False);
			bReadOnly	= FileStat::GetReadOnlyFlag(aDatabasePath);
		}
		aNewConnectStr = aConnectStr;
	}

	// Title und Filenamen ermitteln
	XubString aNewTitle	= S(aTitle);
	XubString aOldTitle	= aNewTitle;

	sal_Bool bReOpen = xDatabase.Is();

	// jetzt die Properties festlegen
	LoopDependentContents(COMMAND_FORCE_UNINITIALIZE);
	sal_Bool bResult = SBAEXPL()->SetDatabaseEntry(aDatabasePath.GetFull(), bReadOnly, aNewTitle, aConnectStr,xDatabase);

	if (!bResult)
	{
		if (bReOpen)
			rJob->result(rCmd, SBA_RESULT_REOPEN, aUrl);

		LoopDependentContents(COMMAND_REINITIALIZE);
		return sal_False;
	}

	// Blanks entfernen
	aNewTitle.EraseLeadingChars();
	aNewTitle.EraseTrailingChars();

	if (bNew)
	{
		//Pfad abholen
		DirEntry aPath = aDatabasePath.GetPath();

		// Dateinamen anhand des Titels vergeben
		DirEntry aFile;
		aFile.SetBase(aNewTitle);
		aFile.SetExtension(SDB_DATABASE_EXT);
		aPath.MakeShortName(aFile.GetName(),FSYS_KIND_FILE);
		aPath.Kill();

		if (SBAOBJ()->CreateDatabase(aPath.GetFull(), aNewTitle, aConnectStr, sal_True))
		{
			aDatabasePath = aPath;
			_setPropertyValue(PROP_ID_TITLE, ::rtl::OUString::createFromAscii("Title"), ::com::sun::star::uno::makeAny(U(aNewTitle)));

			// ensure that the db has an alias
			XubString sURL = aDatabasePath.GetFull();
			DBG_ASSERT(!SBAEXPL()->GetDatabaseAlias(sURL).Len(), "SbaXDBContent::editProperties : this _new_ db is already registered ?");
			SBAEXPL()->CreateDatabaseAlias(sURL, aNewTitle, sal_True, sal_False);
		}
		else
			bResult = sal_False;
	}
	else
	{
		if (aTitle != U(aNewTitle) && !_setPropertyValue(PROP_ID_TITLE, ::rtl::OUString::createFromAscii("Title"), ::com::sun::star::uno::makeAny(U(aNewTitle))))
			bResult = sal_False;
		else
		{
			if (aNewConnectStr.Compare(aConnectStr) != COMPARE_EQUAL)
			{
				if (bReOpen && !realeaseDB())
					bResult = sal_False;
				else
				{
					xDatabase = NULL;
					bResult = SBAOBJ()->AlterDatabase(aDatabasePath.GetFull(), aConnectStr, sal_True);
				}
			}
			// neu
			if (bReOpen)
				rJob->result(rCmd, SBA_RESULT_REOPEN, aUrl);
		}

	}

	LoopDependentContents(COMMAND_REINITIALIZE);
	return bResult;
}

//-------------------------------------------------------------------------
sal_Bool SbaXDBContent::readTitle(const INetURLObject& rUrl)
{
	SvStorageRef xStorage =
		new SvStorage( rUrl.PathToFileName(),
			STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYNONE, 0);

	// Wenn die Datenbank schon geoeffnet ist (kein Zugriff auf Datei mehr moeglich),
	// Titel beim Datenbankobjekt abholen
	if (!xStorage.Is() || xStorage->GetError() != ERRCODE_NONE)
	{
		xStorage = NULL;
		DirEntry aEntry(rUrl.PathToFileName());
		if (aEntry.Exists())
			aTitle = U(aEntry.GetBase());
		return sal_True;
	}

	// Wenn DatenbankDLLs noch nicht angezogen, Titel aus Datei holen
	SvStorageStreamRef xStream = xStorage->OpenStream("StarBaseDocument",STREAM_STD_READ);
	if (!xStream.Is() || xStream->GetError() != ERRCODE_NONE)	// konnte nicht ausgelesen werden
	{															// dann den vorgeschlagen titel
		aTitle = U(DirEntry(rUrl.PathToFileName()).GetBase());
	}
	else
	{
		XubString aValue;
		xStream->ReadLine(aValue);
		aValue.Convert(CHARSET_ANSI, CHARSET_SYSTEM);
		if (aValue.GetTokenCount(';') == 2)				// Lesen des Titels
			aTitle = U(aValue.GetToken(1,';'));
		else
			aTitle = U(DirEntry(rUrl.PathToFileName()).GetBase());
	}
	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & rParent, const ::rtl::OUString& rUrl, const INetURLObject& rUrlObj)
{
	if (SbaXChaosContent::_initialize( rParent, rUrl, rUrlObj ))
	{
		// lesen des Titels
		if (readTitle(rUrlObj))
		{
			// update the favorites the the database we represent (if necessary)
			::vos::OGuard aGuard(Application::GetSolarMutex());
				// We lock the solar mutex : the access to SBAEXPL may load the sba-dll, and the initialisation of this
				// dll (SbaObject/SbaObjectExt) isn't thread-safe at all. Besides changing this (which would be expensive)
				// we have no chance to ensure that accessing SBAEXPL is secured. (posting an event which does the SBAEXPL
				// access in the solar main thread isn't an alternative : any other SbaXChaosContents may use SBAEXPl,
				// too, and this may occure before our event arrives, so we would have the same problem on may other
				// places in SbaChaos. With doing the first SBAEXPL use here - under determined conditions - we're much
				// safer ....)

			// do we reside in the trash ?
			SfxIniManager* pIni = SFX_APP()->GetIniManager();
			if (pIni)
			{
				DirEntry aTrashPath(pIni->Get(SFX_KEY_TRASH_DIR));
				if (aTrashPath == aDatabasePath.GetPath())
					// yes -> drop the database link (we are not accessable in the trash)
					// (only to be sure, normally there shouldn't exist any link to such a database)
					SBAEXPL()->DropDatabaseAlias(S(aUrl));
			}
			return sal_True;
		}
		else
			return sal_False;
	}
	else
		return sal_False;
}

//-------------------------------------------------------------------------
void SbaXDBContent::actualize(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							  const ::com::sun::star::uno::Any& rParam)
{
	if (xDatabase.Is())
	{
		// alle Kinder lschen, damit die Datenbank nicht gelockt wird
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_TABLESMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_FORMSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_REPORTSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_QUERIESMARK_HEADER));

		xDatabase = NULL;
	}
	rJob->result(rCmd, SBA_RESULT_REOPEN, aUrl);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXDBContent::queryCommands() 
{
	const sal_uInt16 nCount = 11;
	static ::rtl::OUString aDBCommandList[ nCount ] =
	{
		::rtl::OUString::createFromAscii("close"),
		::rtl::OUString::createFromAscii("copy"),
		::rtl::OUString::createFromAscii("create"),
		::rtl::OUString::createFromAscii("cut"),
		::rtl::OUString::createFromAscii("delete"),
		::rtl::OUString::createFromAscii("initialize"),
		::rtl::OUString::createFromAscii("open"),
		::rtl::OUString::createFromAscii("prepareMenu"),
		::rtl::OUString::createFromAscii("prepareMove"),
		::rtl::OUString::createFromAscii("showPropertyDialog"),
		::rtl::OUString::createFromAscii("undelete")
	};
	return ::com::sun::star::uno::Sequence< ::rtl::OUString >( aDBCommandList, nCount );
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXDBContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_SORTCRITERIA:
		{
			::com::sun::star::chaos::SortingInfo aSingleSort;
			aSingleSort.PropertyName = ::rtl::OUString::createFromAscii("UserSortCriterium");
			aSingleSort.Ascending = sal_True;

			::com::sun::star::uno::Sequence<::com::sun::star::chaos::SortingInfo> aReturn(1);
			aReturn.getArray()[0] = aSingleSort;

			aAny <<= aReturn;
			break;
		}
		default:
			return SbaXChaosContent::_getPropertyValue( _nID );
		case PROP_ID_IS_FOLDER:
			{
				sal_Bool bB(sal_True);
				aAny.setValue(&bB,::getBooleanCppuType());
			}
			break;
		case PROP_ID_RENAME:
			aAny <<= ::rtl::OUString::createFromAscii("Title");
			break;
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SbaXDBContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	sal_Bool bResult = sal_True;

	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);

	if( aCmd.compareToAscii("reorganizeDB"))
		bResult = reorganize( aEvt, rCallback, aParam );
	else if( aCmd.compareToAscii("executeSQL"))
		bResult = executeSQL( aEvt, rCallback, aParam );
	else if( aCmd.compareToAscii("showPropertyDialog"))
		bResult = editProperties(aEvt, rCallback, aParam, sal_False);
	else if( aCmd.compareToAscii("create"))
		bResult = create(aEvt, rCallback, aParam);
	else if (aCmd.compareToAscii("switchFavorite"))
		switchFavorite(aEvt, rCallback, aParam);
	else if ((aCmd == COMMAND_REGISTER_DB_USER) || (aCmd == COMMAND_UNREGISTER_DB_USER))
	{	// eines meiner Kinder hat sich die DB geholt (oder sie losgelassen)
		DBG_ASSERT(aParam.getValueType() == ::getCppuType((const 
			::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor>*)0), "SbaXDBContent::executeImpl : wrong parameter type !");

		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xContent = *(::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor > *)aParam.getValue();

		if (aCmd == COMMAND_REGISTER_DB_USER)
			m_aDependentContents.insert(m_aDependentContents.end(), xContent);
		else
		{
			ContentVectorIterator aPos = find(m_aDependentContents.begin(), m_aDependentContents.end(), xContent);
			m_aDependentContents.erase(aPos);
		}
	} else
	{
		SbaXChaosContent::executeImpl(aCmd, aParam, rCallback);
		return;
	}

	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::open(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						 const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						 const ::com::sun::star::uno::Any& rParam)
{
	XubString aConStr = SBAOBJ()->GetDatabaseConnectStr(aDatabasePath.GetFull());
	sal_Bool bFound = sal_False;
	for(sal_Int32 i=0;!bFound && i<aConStr.GetTokenCount();++i)
		bFound = (aConStr.GetToken(i).GetToken(0,'=').ICompare("TYP")==COMPARE_EQUAL) && aConStr.GetToken(i).GetToken(1,'=') == "StarBase";

	if(bFound)
	{
		SBAEXPL()->ExecuteConvert(aDatabasePath.GetFull());
	}


	if (!SbaXChaosContent::open(rCmd, rJob, rParam))
		return sal_False;

	if (!getDatabase(sal_True))
		return sal_False;
	else
	{
		if (m_bFirstOpen)
		{	// create a new database alias (if necessary)

			XubString sURL = S(aUrl);
			XubString sKnownTitle = SBAEXPL()->GetDatabaseAlias(sURL);
			if (!sKnownTitle.Len())
				SBAEXPL()->CreateDatabaseAlias(sURL, S(aTitle), sal_True);
			m_bFirstOpen = sal_False;

			// (do this _before_ inserting the children, this may cause other threads - which work with our db, too -
			// to be created, and as we may have to lock the solar mutex here this is potentially dangerous ...)
		}

		rJob->result( rCmd, SBA_RESULT_INSERTED, U(SDB_TABLESMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_INSERTED, U(SDB_FORMSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_INSERTED, U(SDB_REPORTSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_INSERTED, U(SDB_QUERIESMARK_HEADER));
		return sal_True;
	}
}

// ------------------------------------------------------------------------
void SbaXDBContent::CloseImpl()
{
	xDatabase = NULL;
	SbaXChaosContent::CloseImpl();
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::realeaseDB()
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	SbaDatabaseRef xToRelease = xDatabase;
	if (!xToRelease.Is())
	{
		if (OFF_APP()->HasSbaObject())
			// wenn kein SBA angezogen ist, ist die DB auch nicht offen
			xToRelease = OFF_APP()->GetSbaObject()->GetSbaObjectExt()->GetDatabaseNoOpen(aDatabasePath.GetFull());
	}

	if (!xToRelease.Is())
		return sal_True;

	if (!xToRelease->CanRelease())
		return sal_False;

	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::destroy(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							const ::com::sun::star::uno::Any& rParam)
{
	sal_Bool bRes = sal_True;
	if (!realeaseDB())
		bRes = sal_False;

	// alle kinder loeschen
	if (bRes)
	{
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_TABLESMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_FORMSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_REPORTSMARK_HEADER));
		rJob->result( rCmd, SBA_RESULT_DELETED, U(SDB_QUERIESMARK_HEADER));
	}

	if (bRes && ::utl::getBOOL(rParam))	// wirklich loeschen
	{
		LoopDependentContents(COMMAND_FORCE_UNINITIALIZE);

		if (xDatabase.Is())
		{
			OfaDatabaseGuard aDatabaseSafety(&xDatabase);
			if (bRes = xDatabase->Drop())
				xDatabase = NULL;
			else
			{
				SBAOBJ()->ShowDbStatus(xDatabase->Status());
			}
		}
		else
			bRes = SBAOBJ()->DropDatabase(aDatabasePath.GetFull(), sal_True);

		if (!bRes)
			// das harte Loeschen ist schief gegangen -> die abhaengigen Contents duerfen sich wieder die DB holen
			LoopDependentContents(COMMAND_REINITIALIZE);
	}

	if (bRes)
		// drop the database link (no matter if we were 'hard' or 'soft' deleted - the database isn't accessable
		// anymore)
		SBAEXPL()->DropDatabaseAlias(S(aUrl));

	return bRes;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::rename( const ::rtl::OUString& rTitle )
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);

	// titel ohne blanks
	XubString aNewTitle(S(rTitle));
	aNewTitle.EraseLeadingChars();
	aNewTitle.EraseTrailingChars();

	// Zuerst den neuen Dateinamen erstellen
	//	Anlegen eines neuen Files, das im Namen dem Titel aehnelt
	DirEntry aTmpEntry(aDatabasePath.GetPath());
	DirEntry aFile;
	aFile.SetBase(S(rTitle));
	aFile.SetExtension(SDB_DATABASE_EXT);
	aTmpEntry.MakeShortName(aFile.GetName(),FSYS_KIND_FILE);
	XubString aNewFile	= aTmpEntry.GetFull();
	// loeschen des Files
	if (aTmpEntry.GetError() != ERRCODE_NONE)
		return sal_False;
	aTmpEntry.Kill();

	// Namen und Titel der Datenbank aendern
	if (xDatabase.Is())
	{
		if (!xDatabase->Rename(aNewFile))
		{
			SBAOBJ()->ShowDbStatus(xDatabase->Status());
			return sal_False;
		}

		// rebind all aliases for the old file
		SBA_MOD_EXT()->RebindDatabaseAlias(aDatabasePath.GetFull(), aNewFile);

		// Umsetzen der ::com::sun::star::util::URL
		INetURLObject aObj;
		aObj.SetSmartProtocol(INET_PROT_FILE);
		aObj.SetURL(aNewFile, sal_False);
		aDatabasePath = aNewFile;
		_setPropertyValue(PROP_ID_OWNURL,::rtl::OUString::createFromAscii("OwnURL"),::com::sun::star::uno::makeAny(U(aObj.GetMainURL())));

		// Umsetzen des Titels
		if (!xDatabase->AlterTitle(aNewTitle))
		{
			SBAOBJ()->ShowDbStatus(xDatabase->Status());
		}
	}
	else
	{
		if (!SBAOBJ()->AlterDatabaseName(aDatabasePath.GetFull(),aNewFile))
			return sal_False;

		XubString sOldUrl = aDatabasePath.GetFull();

		// Umsetzen der ::com::sun::star::util::URL
		INetURLObject aObj;
		aObj.SetSmartProtocol(INET_PROT_FILE);
		aObj.SetURL(aNewFile, sal_False);
		aDatabasePath = aNewFile;
		_setPropertyValue(PROP_ID_OWNURL,::rtl::OUString::createFromAscii("OwnURL"),::com::sun::star::uno::makeAny(U(aObj.GetMainURL())));

		// rebind all aliases for the old file
		SBA_MOD_EXT()->RebindDatabaseAlias(sOldUrl, aDatabasePath.GetFull());
			// _after_ setting the properties, this may affect aDatabasePath ...

		if (!SBAOBJ()->AlterDatabaseTitle(aDatabasePath.GetFull(),aNewTitle))
			return sal_False;
	}

	return sal_True;
}

// ------------------------------------------------------------------------
void SbaXDBContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	const int nItems(7);
	::com::sun::star::chaos::MenuDescriptor			aPopup;
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];


	sal_Int32 nPos = 0;
	aMenu[nPos].ParentPos = 0;
	aMenu[nPos].InsertionPos = 0;
	aMenu[nPos++].ItemFlags = CNT_COMPMENU_SEPARATOR;

	aMenu[nPos].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[nPos].Command			= ::rtl::OUString::createFromAscii("actualize");
	aMenu[nPos].HelpUrl			= ::rtl::OUString(HID_OFA_CHAOS_DB_ACTUALIZE);
	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos++].ItemFlags		= 0;

	aMenu[nPos].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_DB_REORGANIZE)));
	aMenu[nPos].Command			= ::rtl::OUString::createFromAscii("reorganizeDB");
	aMenu[nPos].HelpUrl			= ::rtl::OUString(HID_OFA_CHAOS_DB_REORGANIZE);
	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos++].ItemFlags		= 0;

	aMenu[nPos].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_MANUAL_SQL)));
	aMenu[nPos].Command			= ::rtl::OUString::createFromAscii("executeSQL");
	aMenu[nPos].HelpUrl			= ::rtl::OUString(HID_OFA_CHAOS_DB_EXECUTESQL);
	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos++].ItemFlags		= 0;

	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos++].ItemFlags		= CNT_COMPMENU_SEPARATOR;

	aMenu[nPos].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_DB_SWITCH_FAVORITE)));
	aMenu[nPos].Command			= ::rtl::OUString::createFromAscii("switchFavorite");
	aMenu[nPos].HelpUrl			= ::rtl::OUString(HID_OFA_CHAOS_DB_SWITCH_FAVORITE);
	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos].ItemFlags		= 0;
	// is the given database a favorite ?
	XubString sDBAlias = SBA_MOD_EXT()->GetDatabaseAlias(aDatabasePath.GetFull());
	if (sDBAlias.Len())
	{	// check the database entry
		aMenu[nPos].ItemFlags		= CNT_COMPMENU_CHECKED;
		// add add the alias to the item name
		UniString sTitleDesc(OfsStringRes(RID_STR_DB_FAVORITE_TTILE));
		sTitleDesc.SearchAndReplace("$name$", sDBAlias);

		UniString sCompleteName = OfsStringRes(RID_STR_DB_SWITCH_FAVORITE);
		sCompleteName += ' ';
		sCompleteName += sTitleDesc;
		aMenu[nPos].ItemText = sCompleteName;
	}
	++nPos;
	

	aMenu[nPos].ParentPos		= 0;
	aMenu[nPos].InsertionPos	= 0;
	aMenu[nPos++].ItemFlags		= CNT_COMPMENU_SEPARATOR;

	DBG_ASSERT(nItems == nPos, "SbaXDBContent::createPopup : forgot to adjust nItems ?");

	aPopup.Items = ::com::sun::star::uno::Sequence<::com::sun::star::chaos::MenuItemDescriptor>( aMenu, nPos );

	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::executeSQL( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								const ::com::sun::star::uno::Any& rParam )
{
	if (getDatabase(sal_True))
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		//////////////////////////////////////////////////////////////////////
		// Dialog zu manuellen Eingabe von SQL-Statements
		SbaSqlDlg* pDlg = SBAEXPL()->CreateSQLDlg( GetpApp()->GetAppWindow(), xDatabase);
		pDlg->Execute();
		delete pDlg;
		return sal_True;
	}
	else
		return sal_False;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::switchFavorite(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	XubString sPath = aDatabasePath.GetFull();
	XubString sCurrentAlias = SBA_MOD_EXT()->GetDatabaseAlias(sPath);
	if (!sCurrentAlias.Len())
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		SBA_MOD_EXT()->CreateDatabaseAlias(sPath, S(aTitle), sal_True, sal_False);
	}
	else
	{
		SBA_MOD_EXT()->DropDatabaseAlias(sPath, sal_True);
			// delete with confimation
	}
	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::reorganize(	const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
								const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								const ::com::sun::star::uno::Any& rParam )
{
	INetURLObject aParser(S(aUrl));
	DBG_ASSERT(aParser.GetProtocol() == INET_PROT_FILE, "SbaXDBContent::reorganize : wrong ::com::sun::star::util::URL type !");
	XubString aDatabaseFileName = aParser.PathToFileName();


	sal_Bool bDatabaseWas = xDatabase.Is();
	if (bDatabaseWas)
	{
		// alle Kinder lschen, damit die Datenbank nicht gelockt wird
		rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_TABLESMARK_HEADER));
		rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_FORMSMARK_HEADER));
		rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_REPORTSMARK_HEADER));
		rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_QUERIESMARK_HEADER));
		xDatabase = NULL;
	}

	// always loop the dependent contents : maybe we're not open (so we have no database), but there are
	// dependent contents which where created by (and reside directly under) a link to an SDB file
	// FS - 16.02.00 - 72944
	LoopDependentContents(COMMAND_FORCE_UNINITIALIZE);
	SBAOBJ()->GetSbaObjectExt()->DoReorganize(aDatabaseFileName);
	LoopDependentContents(COMMAND_REINITIALIZE);

	if (bDatabaseWas)
	{
		getDatabase(sal_True, sal_False);
		rJob->result(rEvt, SBA_RESULT_REOPEN, aUrl);
	}

	return sal_True;
}

// ------------------------------------------------------------------------
void SbaXDBContent::LoopDependentContents(const ::rtl::OUString& rCommand)
{
	ContentVectorIterator aLoop = m_aDependentContents.begin();
	ContentVectorIterator aEnd = m_aDependentContents.end();
	while (aLoop != aEnd)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xCurrent = *aLoop;
		DBG_ASSERT(xCurrent.is(), "SbaXDBContent::LoopDependentContents : invalid dependent content !");

		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xMe((::com::sun::star::chaos::XCommandExecutor*)this);
		xCurrent->execute(rCommand, ::com::sun::star::uno::makeAny(xMe), ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > (new SbaXDummyStatusCallback()));

		++aLoop;
	}
}

// ------------------------------------------------------------------------
sal_Bool SbaXDBContent::prepareMove(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	sal_Bool bRes = sal_True;
	if (!realeaseDB())
		return sal_False;

	if (!SbaXChaosContent::prepareMove(rEvt, rJob, rParam))
		return sal_False;

	// 'zuklappen'
	rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_TABLESMARK_HEADER));
	rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_FORMSMARK_HEADER));
	rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_REPORTSMARK_HEADER));
	rJob->result( rEvt, SBA_RESULT_DELETED, U(SDB_QUERIESMARK_HEADER));

	// allen unter mir liegenden Contents die DB entziehen
	LoopDependentContents(COMMAND_FORCE_UNINITIALIZE);

	return sal_True;
}

