/*************************************************************************
 *
 *  $RCSfile: dbcommon.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBCOMMON_HXX
#include "dbcommon.hxx"
#endif

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif

#ifndef _TOOLKIT_AWT_VCLXBITMAP_HXX_
#include <toolkit/helper/vclunohelper.hxx>
#endif

#include <com/sun/star/awt/XBitmap.hpp>

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif

#ifndef _SOT_DTRANS_HXX //autogen
#include <sot/dtrans.hxx>
#endif

#ifndef _EXCHOBJ_HXX //autogen
#include <sfx2/exchobj.hxx>
#endif

#ifndef _SFX_EXPLORER_HXX
#include <sfx2/explorer.hxx>
#endif

#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif

#ifndef _SBA_DBEXCH_HXX
#include "dbexch.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_CHAOS_CONTENTTYPE_HPP_
#include <com/sun/star/chaos/ContentType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_CHAOS_STATUSCALLBACKEVENT_HPP_
#include <com/sun/star/chaos/StatusCallbackEvent.hpp>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SDB_SDBOBJ_HXX
#include <sdb/sdbobj.hxx>
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include <sbaexpob.hxx>
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif // _SBA_DBTABOBJ_HXX

#ifndef _SOT_FORMATS_HXX
#include <sot/formats.hxx>
#endif

#ifndef _BMKOBJ_HXX //autogen
#include <sfx2/bmkobj.hxx>
#endif

#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif

#ifndef _SFX_MACROCONF_HXX //autogen
#include <sfx2/macrconf.hxx>
#endif

#ifndef _EHDL_HXX //autogen
#include <svtools/ehdl.hxx>
#endif

#ifndef _UTL_GUARDING_HXX_
#include <unotools/guarding.hxx>
#endif

static XubString aDataExchangeFormat;
static XubString aFormExchangeFormat;
static XubString aReportExchangeFormat;
static XubString aRTFExchangeFormat;
static XubString aHTMLExchangeFormat;

DBG_NAME(SbaXDummyStatusCallback);
DBG_NAME(SbaXChaosContent);
DBG_NAME(SbaThreadSafeLink);

SbaXChaosContent::BitmapCache SbaXChaosContent::m_sAllBitmaps;

// -------------------
// - SbaThreadSafeLink
// -------------------
// ------------------------------------------------------------------------
SbaThreadSafeLink::SbaThreadSafeLink(const Link& _rToCall, ::vos::OThread::TThreadIdentifier _nThreadToExecuteIn)
	:m_aHandler(_rToCall)
	,m_nThreadId(_nThreadToExecuteIn)
	,m_nExecutionEvent(0)
{
	DBG_CTOR(SbaThreadSafeLink,NULL);
	DBG_ASSERT(m_aHandler.IsSet(), "SbaThreadSafeLink::SbaThreadSafeLink : invalid link !");
}

// ------------------------------------------------------------------------
SbaThreadSafeLink::~SbaThreadSafeLink()
{
	KillPendingCall();
	DBG_DTOR(SbaThreadSafeLink,NULL);
}

// ------------------------------------------------------------------------
void SbaThreadSafeLink::KillPendingCall()
{
	::utl::OReusableGuard< ::osl::Mutex>  aGuard(m_aGeneralAccessSafety);
	if (!IsPendingCall())
		return;

	if (m_nExecutionEvent)
	{
		Application::RemoveUserEvent(m_nExecutionEvent);
		m_nExecutionEvent = 0;
	}

	// to prevent that somebody deletes us while OnExecute before the OnExecute (which maybe waiting for m_aGeneralAccessSafety)
	// accesses m_nExecutionEvent
	aGuard.clear();
	aGuard.attach(m_aEventIdSafety);
		// this will allow us to return only after OnExecute checked the m_nExecutionEvent (it will return without calling
		// the link then)
		// if no OnExecute was waiting while we did the KillPendingCall, no blocking will occur with the above "attach"
}

// ------------------------------------------------------------------------
long SbaThreadSafeLink::CallAndWait(void* _pArgs)
{
	::osl::ClearableMutexGuard aGuard(m_aGeneralAccessSafety);

	long nResult = Call(_pArgs);

	AddRef();

	sal_Bool bDone = sal_False;
	aGuard.clear();
	while (!bDone)
		bDone = !IsPendingCall();

	// cancel all member access before releasing the (maybe last) ref !
	ReleaseRef();

	return nResult;
}

// ------------------------------------------------------------------------
long SbaThreadSafeLink::Call(void* _pArgs)
{
	::osl::ClearableMutexGuard aGuard(m_aGeneralAccessSafety);
	DBG_ASSERT(!IsPendingCall(), "SbaThreadSafeLink::Call : already a pending call !");

	Link aMyHandler(LINK(this, SbaThreadSafeLink, OnExecute));

	sal_Bool bCallDirectly = ::vos::OThread::getCurrentIdentifier() == m_nThreadId;
	if (bCallDirectly)
	{
		AddRef();
		m_nExecutionEvent = 1;
			// just to prevent that OnExecute returns without doing anything
		aMyHandler.Call(_pArgs);
		// clear the guard (which is a member access) before releasing my (maybe last) ref
		aGuard.clear();
		ReleaseRef();
	}
	else
		m_nExecutionEvent = Application::PostUserEvent(aMyHandler, _pArgs);

	return 0;
}

// ------------------------------------------------------------------------
IMPL_LINK(SbaThreadSafeLink, OnExecute, void*, _pArgs)
{
	::osl::ClearableMutexGuard aEventIdGuard(m_aEventIdSafety);
	::osl::ClearableMutexGuard aGuard(m_aGeneralAccessSafety);
	if (!m_nExecutionEvent)
		// maybe we waited for the mutex while another thread did a KillPendingCall
		return 0;

	if (::vos::OThread::getCurrentIdentifier() != m_nThreadId)
	{
		m_nExecutionEvent = Application::PostUserEvent(LINK(this, SbaThreadSafeLink, OnExecute), _pArgs);
		return 0;
	}
	m_nExecutionEvent = 0;
	aEventIdGuard.clear();
		// not neccessary, but also not wrong : all my other members are now protected by m_aGeneralAccessSafety which
		// is sufficient from now

	AddRef();
	m_aHandler.Call(_pArgs);
	// clear the guard (which is a member access) before releasing my (maybe last) ref
	aGuard.clear();
	ReleaseRef();

	return 0;
}

// -------------------
// - SbaXChaosContent -
// -------------------
//::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass >  getChaosContentIdlClass()
//{
//	static ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass >  xClass =
//		createStandardClass
//		   ( ::rtl::OUString::createFromAscii("SbaXChaosContent"),
//			 UsrObject::getUsrObjectIdlClass(),
//			 4,
//			 ::getCppuType((const ::com::sun::star::chaos::XURLContent*)0),
//			 ::getCppuType((const ::com::sun::star::lang::XComponent*)0),
//			 ::getCppuType((const ::com::sun::star::chaos::XCommandExecutor*)0),
//			 ::getCppuType((const ::com::sun::star::beans::XPropertySet*)0));
//	return xClass;
//}

// ------------------------------------------------------------------------
SbaXChaosContent::SbaXChaosContent(const DBBasePropertyMap* _pMap, sal_Bool _bHasFolder)
		: ::cppu::WeakComponentImplHelper3< ::com::sun::star::chaos::XURLContent,
											::com::sun::star::chaos::XCommandExecutor,
											::com::sun::star::beans::XPropertySet>(m_aMutex)
		,pMap(_pMap)
		,bHasFolder(_bHasFolder)
		,bDisposed(sal_False)
		,nOpenCounter(0)
		,m_pCurrentExecParams(NULL)
		,m_pPropertyParams(NULL)
		,m_nSmallBitmapId(0)
		,m_nLargeBitmapId(0)
		,aPropertyListeners(m_aMutex)
{
	DBG_CTOR(SbaXChaosContent,NULL);

	m_pSolarThreadExecutor = new SbaThreadSafeLink(LINK(this, SbaXChaosContent, OnExecuteInDeterminedThread), Application::GetMainThreadIdentifier());
	m_pSolarThreadExecutor->AddRef();

	// load all the bitmaps we need
	if (!m_sAllBitmaps.size())
	{
		// a list of all bitmap ids ever used by any SbaXChaosContent
		// (very ugly ...)
		sal_uInt16 nUsedIds[] = {
			RID_BMP_DB_FORMFOLDER_L, RID_BMP_DB_FORMFOLDER_S, RID_BMP_DB_FORM_L, RID_BMP_DB_FORM_S,
			RID_BMP_DB_TABLEFOLDER_L, RID_BMP_DB_TABLEFOLDER_S, RID_BMP_DB_TABLE_L, RID_BMP_DB_TABLE_S,
			RID_BMP_DB_VIEW_L, RID_BMP_DB_VIEW_S, RID_BMP_DB_RELATIONS_L, RID_BMP_DB_RELATIONS_S,
			RID_BMP_DB_QUERYFOLDER_L, RID_BMP_DB_QUERYFOLDER_S, RID_BMP_DB_QUERY_L, RID_BMP_DB_QUERY_S,
			RID_BMP_DB_REPORTFOLDER_L, RID_BMP_DB_REPORTFOLDER_S, RID_BMP_DB_REPORT_L, RID_BMP_DB_REPORT_S,
			RID_BMP_DB_DATABASE_L, RID_BMP_DB_DATABASE_S
		};
		// as we're the first instance we may lock the solar mutex here
		::vos::OGuard aSolarGuard(Application::GetSolarMutex());
		for (sal_uInt16 i=0; i<sizeof(nUsedIds)/sizeof(nUsedIds[0]); ++i)
			m_sAllBitmaps[nUsedIds[i]] = Bitmap(OffResId(nUsedIds[i]));
	}
}

// ------------------------------------------------------------------------
SbaXChaosContent::~SbaXChaosContent()
{
	DBG_DTOR(SbaXChaosContent,NULL);

	if (!bDisposed)
	{
		acquire();
		dispose();
	}

	m_pSolarThreadExecutor->KillPendingCall();
	m_pSolarThreadExecutor->ReleaseRef();
	m_pSolarThreadExecutor = NULL;
}

// ::com::sun::star::container::XChild
// ------------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  SAL_CALL SbaXChaosContent::getParent() 
{
	return xParent;
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::setParent( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & Parent )
{
	xParent = Parent;
}

// ::com::sun::star::lang::XComponent
//------------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::dispose(void)
{
	::osl::MutexGuard aGuard(s_aWizardProtection);
	bDisposed = sal_True;

	::com::sun::star::lang::EventObject aEvt(*this);
	aPropertyListeners.disposeAndClear( aEvt );
	
	xDatabase	= NULL;

	// bei meinem Parent als Nutzer der DB abmelden
	::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xUnregisterMe(getParent(), ::com::sun::star::uno::UNO_QUERY);
	if (xUnregisterMe.is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xMe((::com::sun::star::chaos::XCommandExecutor*)this);
		
		xUnregisterMe->execute(COMMAND_UNREGISTER_DB_USER, ::com::sun::star::uno::makeAny(xMe), ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > (new SbaXDummyStatusCallback()));
	}

	xParent		= NULL;

	// a wizard call pending for myself ?
	if (s_aWizardCall.nEventId && (this == s_aWizardCall.pOwner))
	{
		Application::RemoveUserEvent(s_aWizardCall.nEventId);
		s_aWizardCall.nEventId = 0;
		s_aWizardCall.pOwner = NULL;
	}
}

// wizard handling
//-------------------------------------------------------------------------
SbaXChaosContent::WizardCallData	SbaXChaosContent::s_aWizardCall;
::osl::Mutex				SbaXChaosContent::s_aWizardProtection;

//-------------------------------------------------------------------------
IMPL_STATIC_LINK(SbaXChaosContent, ImplCallWizard, void*, EMPTYARG)
{
	::osl::MutexGuard aGuard(s_aWizardProtection);
	::vos::OGuard aSolarGuard(Application::GetSolarMutex());

	SfxApplication* pApp = SFX_APP();
	SbxArray* pParameter = new SbxArray();
	SbxVariable* pV		 = new SbxVariable();
	SbxValue* pReturn	 = new SbxValue();
	pReturn->AddRef();

	// Sicherstellen, da ein Datenbanklink besteht
	XubString sPath = s_aWizardCall.pOwner->xDatabase->Name();
	XubString sTitle = s_aWizardCall.pOwner->xDatabase->Title();
	XubString sCurrentAlias = SBA_MOD_EXT()->GetDatabaseAlias(sPath);
	if (!sCurrentAlias.Len())
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		sCurrentAlias = SBA_MOD_EXT()->CreateDatabaseAlias(sPath, sTitle, sal_True, sal_True);
		if (!sCurrentAlias.Len())
			// the user didn't allow us to create an alias
			return 0L;
	}

	pV->PutString(sCurrentAlias);
	pParameter->Put(pV,1);
	pApp->EnterBasicCall();
	ErrCode aResult = pApp->GetMacroConfig()->Call(NULL, s_aWizardCall.pOwner->m_sWizardName, pApp->GetBasicManager(), pParameter, pReturn);
	pApp->LeaveBasicCall();

	if (ERRCODE_NONE != aResult)
	{
		SfxErrorContext aContext(s_aWizardCall.pOwner->m_nWizardContext, NULL, RID_RES_SBACHAOS_ERR_CONTEXTS, OFF_APP()->GetOffResManager());
		ErrorHandler::HandleError(aResult);
	}

	s_aWizardCall.nEventId = 0;
	s_aWizardCall.pOwner = NULL;

	return 0L;
}

//-------------------------------------------------------------------------
sal_Bool SbaXChaosContent::callNewObjectWizard()
{
	::osl::MutexGuard aGuard(s_aWizardProtection);
	if (s_aWizardCall.nEventId)
		return sal_False;

	s_aWizardCall.pOwner = this;
	s_aWizardCall.nEventId = Application::PostUserEvent(STATIC_LINK(this, SbaXChaosContent, ImplCallWizard));

	return sal_True;
}

// ------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXChaosContent::getURL()
{
	return aUrl;
}

// ------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXChaosContent::initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & rParent, const ::rtl::OUString& rUrl)
{
	// schon mal das Paren setzen, damit koennen die _initialize-Methoden vielleicht schon was anfangen
	setParent((::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > )rParent);

	sal_Bool bSuccess = sal_False;

	INetURLObject aObj(S(rUrl));
	if (aObj.GetProtocol() == INET_PROT_FILE)
	{
		aUrl = rUrl;
		aDatabasePath = aObj.PathToFileName();
		if (aDatabasePath.GetNameDirect().Len())	// wenn das nicht anspringt, war die File-::com::sun::star::util::URL ungueltig
			bSuccess = _initialize(rParent, rUrl, aObj);
	}

	if (!bSuccess)
		setParent(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > ());
	return bSuccess;
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & rParent, const ::rtl::OUString& rUrl,  const INetURLObject& rUrlObj)
{
	return sal_True;
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::cancel( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & CommandId )
{
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::execute( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	// allow a call in any thread if the connection is multi-thread-capable
	sal_Bool bAllowForeignThreadCall = xDatabase.Is() && xDatabase->IsCapable(SDB_CAP_MULTITHREADACCESS);

	if (!xDatabase.Is())
	{
		if (SBAEXPL()->IsThreadSafe(aDatabasePath.GetFull()))
			bAllowForeignThreadCall = sal_True;
	}

	// some commands have always to be called synchronously
	sal_Bool bSynchronCommand =
		!aCmd.compareToAscii("initialize") ||
		!aCmd.compareToAscii("prepareMove") ||
		!aCmd.compareToAscii("collapse") ||
		!aCmd.compareToAscii("prepareMenu") ||
		!aCmd.compareToAscii("prepareEditing") ||
		!aCmd.compareToAscii("releaseMenu");

	// internal commands may be called synchronously, too
	sal_Bool bInternalCommand =
			aCmd.equals(COMMAND_REGISTER_DB_USER)
		||	aCmd.equals(COMMAND_UNREGISTER_DB_USER)
		||	aCmd.equals(COMMAND_FORCE_UNINITIALIZE)
		||	aCmd.equals(COMMAND_REINITIALIZE);

	// perhaps we're already within the main thread
	sal_Bool bIsMainThread = ::vos::OThread::getCurrentIdentifier() == Application::GetMainThreadIdentifier();

	sal_Bool bCallDirectly = bAllowForeignThreadCall || bSynchronCommand || bInternalCommand || bIsMainThread;

	if (bCallDirectly)
	{
		executeImpl(aCmd, aParam, rCallback);
		return;
	}

	::osl::ClearableMutexGuard aExecutionGuard(m_aExecuteSafety);
		// this will block the third concurrent call 'til the first is done
		// (or maybe this is no concurrent call, but another thread is executing an set-/getPropertyValue, which
		// use m_pSolarThreadExecutor, too.

	::utl::OReusableGuard< ::osl::Mutex> aParamGuard(m_aParamsAccessSafety);

	if (m_pCurrentExecParams && !bCallDirectly)
	{	// there is a problem in CHAOS with the consequtive execution of jobs (sometimes they are concurrent ... this will be fixed, me hopes (DV knows and thinks about it))

		// the already-running job will be executed in the main thread (this is ensured by m_pSolarThreadExecutor), so if we're
		// running in the main thread, too, we have to do a sync call
		if (::vos::OThread::getCurrentIdentifier() == Application::GetMainThreadIdentifier())
		{
			bCallDirectly = sal_True;
		}
		else
		{	// first ASSERT, so this Bug (it's a bug DV is resp. for ... he "is thinking about") won't be forgotten
#ifdef DBG_UTIL
			UniString sMessage = "SbaXChaosContent::execute : got two or more concurrent jobs (";
			sMessage += m_pCurrentExecParams->sCommand.getStr();
			sMessage += ", ";
			sMessage += aCmd.getStr();
			sMessage += ") !";
			//	DBG_ERROR(sMessage);
#endif

			// filter for some commands we may ignore (as we know that nobody handles them)
			// (!!!this is a BAD HACK !!! hope DV will fix it's bug, soon)
			if (!aCmd.compareToAscii("releaseMenu"))
			{
				::com::sun::star::chaos::StatusCallbackEvent aEvt(*this,*this,aCmd, aParam);

				rCallback->done(aEvt);
				return;
			}

			// now just wait 'til the posted event is done (this means m_pCurrentExecParams will become NULL)
			sal_Bool bIsPending = (m_pCurrentExecParams != NULL);

			aParamGuard.clear();
			while (bIsPending)
			{
				::osl::ClearableMutexGuard aParamGuard(m_aParamsAccessSafety);
				bIsPending = (m_pCurrentExecParams != NULL);
			}
			// reattach to m_aParamsAccessSafety as we want to work with m_pCurrentExecParams below
			aParamGuard.attach(m_aParamsAccessSafety);

			// if we're here we shouldn't have any pending jobs (except the one we're trying to execute in this call)
		}
	}

	DBG_ASSERT(m_pCurrentExecParams == NULL, "SbaXChaosContent::execute : already have params !");
	m_pCurrentExecParams = new ExecuteParameters;

	// build the parameter structure
	m_pCurrentExecParams->sCommand = aCmd;
	m_pCurrentExecParams->aParam = aParam;
	m_pCurrentExecParams->xCallback = rCallback;

	m_pSolarThreadExecutor->Call();
}

// ------------------------------------------------------------------------
IMPL_LINK(SbaXChaosContent, OnExecuteInDeterminedThread, void*, EMPTYARG)
{
	::osl::ClearableMutexGuard aGuard(m_aParamsAccessSafety);

	DBG_ASSERT(m_pCurrentExecParams || m_pPropertyParams, "SbaXChaosContent::OnExecuteInDeterminedThread : have no params anymore !");

	if (m_pCurrentExecParams)
	{
		// as we may be deleted within executeImpl we increment our ref count to prevent this
		acquire();

		executeImpl(m_pCurrentExecParams->sCommand, m_pCurrentExecParams->aParam, m_pCurrentExecParams->xCallback);

		// do all cleaning which may affect members _before_ decreasing the refCount (as with this decrease we
		// might be desroyed)
		delete m_pCurrentExecParams;
		m_pCurrentExecParams = NULL;
		aGuard.clear();

		release();
	}
	else
	{
		if (m_pPropertyParams->bSet)
			_setPropertyValue(m_pPropertyParams->nPropId, m_pPropertyParams->sPropName, m_pPropertyParams->aValueOrReturn);
		else
			m_pPropertyParams->aValueOrReturn = _getPropertyValue(m_pPropertyParams->nPropId);

		// don't delete m_pPropertyParams ! it's reused, as the property calls aren't really asnyc ...
	}

	return 0L;
}

// ------------------------------------------------------------------------
void SbaXChaosContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	sal_Bool bResult = sal_True;

	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this,*this,aCmd, aParam);

	if ( !aCmd.compareToAscii("open"))
		bResult = open( aEvt, rCallback, aParam );
	else if ( !aCmd.compareToAscii("prepareMenu"))
		prepareMenu( aEvt, rCallback, aParam );
	else if ( !aCmd.compareToAscii("prepareMove"))
		bResult = prepareMove( aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("delete"))
		bResult = destroy(aEvt, rCallback, aParam);
	else if( !aCmd.compareToAscii("actualize"))
		actualize( aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("close"))
		close( aEvt, rCallback, aParam );
	else if ((aCmd == COMMAND_REGISTER_DB_USER) || (aCmd == COMMAND_UNREGISTER_DB_USER))
	{	// defaultmaessig einfach an mein Parent
		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xParentExecutor(getParent(), ::com::sun::star::uno::UNO_QUERY);
		if (bResult = xParentExecutor.is())
			xParentExecutor->execute(aCmd, aParam, rCallback);
	}
	else if (aCmd == COMMAND_FORCE_UNINITIALIZE)
		xDatabase = NULL;
	else if (aCmd == COMMAND_REINITIALIZE)
		getDatabase(sal_False, sal_False);

	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}


// ------------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > SAL_CALL  SbaXChaosContent::getPropertySetInfo(void) 
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  aRef;
	return aRef;
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::setPropertyValue(const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue)
{
	for (const DBBasePropertyMap* pTempMap = pMap; pTempMap->sName.getLength(); ++pTempMap)
	{
		if (aPropertyName.equals(pTempMap->sName))
		{
			// check if we have to do the call in the main thread
			// (because of 72350 - FS - 31.01.00)

			// allow a call in any thread if the connection is multi-thread-capable
			sal_Bool bAllowForeignThreadCall = xDatabase.Is() && xDatabase->IsCapable(SDB_CAP_MULTITHREADACCESS);
			if (!xDatabase.Is())
				if (SBAEXPL()->IsThreadSafe(aDatabasePath.GetFull()))
					bAllowForeignThreadCall = sal_True;

			// properties which may be thread-critical
			sal_Bool bCriticalProperty =
					pTempMap->nId == PROP_ID_TITLE
				||	pTempMap->nId == PROP_ID_EDITSTRING;

			// perhaps we're already within the main thread
			sal_Bool bIsMainThread = ::vos::OThread::getCurrentIdentifier() == Application::GetMainThreadIdentifier();

			if (bAllowForeignThreadCall || !bCriticalProperty || bIsMainThread)
				_setPropertyValue(pTempMap->nId, aPropertyName, aValue);
			else
			{
				::osl::ClearableMutexGuard aExecutionGuard(m_aExecuteSafety);
					// this will 'til we're not executing

				// maybe there is an async execute call pending
				while (m_pSolarThreadExecutor->IsPendingCall())
					;

				::utl::OReusableGuard< ::osl::Mutex> aParamGuard(m_aParamsAccessSafety);
				DBG_ASSERT(!m_pCurrentExecParams, "SbaXChaosContent::setPropertyValue : still a pending execute ?");
					// should be impossible ... we waited 'til any async call was done
				DBG_ASSERT(!m_pPropertyParams, "SbaXChaosContent::setPropertyValue : another concurrent set-/getPropertyValue ?");
					// should be prevented by the m_aExecuteSafety-Guard

				m_pPropertyParams = new SetPropertyParams;
				m_pPropertyParams->bSet = sal_True;
				m_pPropertyParams->nPropId = pTempMap->nId;
				m_pPropertyParams->sPropName = aPropertyName;
				m_pPropertyParams->aValueOrReturn = aValue;

				aParamGuard.clear();		// param mutex is needed in the other thread
				m_pSolarThreadExecutor->CallAndWait();

				aParamGuard.attach(m_aParamsAccessSafety);
				delete m_pPropertyParams;
				m_pPropertyParams = NULL;
			}
			break;
		}
	}
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SAL_CALL SbaXChaosContent::getPropertyValue( const ::rtl::OUString& aPropertyName ) 
{
	for (const DBBasePropertyMap* pTempMap = pMap; pTempMap->sName.getLength(); ++pTempMap)
	{
		if (aPropertyName.equals(pTempMap->sName))
		{
			// check if we have to do the call in the main thread
			// (because of 72350 - FS - 31.01.00)

			// allow a call in any thread if the connection is multi-thread-capable
			sal_Bool bAllowForeignThreadCall = xDatabase.Is() && xDatabase->IsCapable(SDB_CAP_MULTITHREADACCESS);
			if (!xDatabase.Is())
				if (SBAEXPL()->IsThreadSafe(aDatabasePath.GetFull()))
					bAllowForeignThreadCall = sal_True;

			// properties which may be thread-critical
			sal_Bool bCriticalProperty =
					pTempMap->nId == PROP_ID_RENAME;

			// perhaps we're already within the main thread
			sal_Bool bIsMainThread = ::vos::OThread::getCurrentIdentifier() == Application::GetMainThreadIdentifier();

			::com::sun::star::uno::Any aReturn;
			if (bAllowForeignThreadCall || !bCriticalProperty || bIsMainThread)
				aReturn = _getPropertyValue(pTempMap->nId);
			else
			{
				::osl::ClearableMutexGuard aExecutionGuard(const_cast<SbaXChaosContent*>(this)->m_aExecuteSafety);
					// this will block 'til we're not executing

				// maybe there is an async execute call pending
				while (m_pSolarThreadExecutor->IsPendingCall())
					;

				::utl::OReusableGuard< ::osl::Mutex> aParamGuard(const_cast<SbaXChaosContent*>(this)->m_aParamsAccessSafety);
				DBG_ASSERT(!m_pCurrentExecParams, "SbaXChaosContent::setPropertyValue : still a pending execute ?");
					// should be impossible ... we waited 'til any async call was done
				DBG_ASSERT(!m_pPropertyParams, "SbaXChaosContent::setPropertyValue : another concurrent set-/getPropertyValue ?");
					// should be prevented by the m_aExecuteSafety-Guard

				const_cast<SbaXChaosContent*>(this)->m_pPropertyParams = new SetPropertyParams;
				m_pPropertyParams->bSet = sal_False;
				m_pPropertyParams->nPropId = pTempMap->nId;

				aParamGuard.clear();		// param mutex is needed in the other thread
				m_pSolarThreadExecutor->CallAndWait();

				aParamGuard.attach(const_cast<SbaXChaosContent*>(this)->m_aParamsAccessSafety);
				aReturn = m_pPropertyParams->aValueOrReturn;
				delete m_pPropertyParams;
				const_cast<SbaXChaosContent*>(this)->m_pPropertyParams = NULL;
			}
			return aReturn;
		}
	}
	return ::com::sun::star::uno::Any();
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::_setPropertyValue(sal_uInt16 _nID, const ::rtl::OUString& aPropertyName,  const ::com::sun::star::uno::Any& aValue)
{
	sal_Bool bModified = sal_False;
	sal_Bool bSuccess = sal_True;
	::com::sun::star::beans::PropertyChangeEvent	aEvt;
	switch (_nID)
	{
		case PROP_ID_TITLE:
			if (aTitle != ::utl::getString(aValue))
			{
				bModified = sal_True;
				sal_Bool bNew = !aTitle.len();
				// damit leer strings abgefangen werden
				if (::utl::getString(aValue).len() && (bNew || rename(::utl::getString(aValue))))
				{
					aEvt.OldValue <<= aTitle;
					aTitle = ::utl::getString(aValue);
					aEvt.NewValue = aValue;
				}
				else
				{
					// umbennen war nicht moeglich
					bSuccess = sal_False;
					aEvt.OldValue = aValue;
					aEvt.NewValue <<= aTitle;
				}
			}
			break;
		case PROP_ID_OWNURL:
			if (aUrl != ::utl::getString(aValue))
			{
				bModified = sal_True;
				aEvt.OldValue <<= aUrl;
				aUrl = ::utl::getString(aValue);
				aEvt.NewValue <<= aUrl;
				INetURLObject aObj(S(aUrl));
				aDatabasePath = aObj.PathToFileName();
			}
			break;
		case PROP_ID_HAS_FOLDER:
			if (bHasFolder != ::utl::getBOOL(aValue))
			{
				bModified = sal_True;
				aEvt.OldValue.setValue(&bHasFolder,::getBooleanCppuType());
				bHasFolder = ::utl::getBOOL(aValue);
				aEvt.NewValue.setValue(&bHasFolder,::getBooleanCppuType());
			}
			break;
		case PROP_ID_MENU:
			bModified = sal_True;
			aEvt.OldValue = aMenu;
			aMenu = aValue;
			aEvt.NewValue = aMenu;
			break;
		case PROP_ID_NEWCHILD:
		case PROP_ID_DELETEME:
			bModified = sal_True;
			aEvt.NewValue = aValue;
			break;
	}

	if (bModified)
	{
		aEvt.PropertyName   = aPropertyName;
		aEvt.PropertyHandle = 0;

		::cppu::OInterfaceContainerHelper* pContainer = aPropertyListeners.getContainer(aPropertyName);
		if (pContainer)
		{
			::cppu::OInterfaceIteratorHelper aIt(*pContainer);
			while (aIt.hasMoreElements())
				((::com::sun::star::beans::XPropertyChangeListener*)aIt.next())->propertyChange( aEvt );
		}

		// allListener
		pContainer = aPropertyListeners.getContainer(::rtl::OUString());
		if (pContainer)
		{
			::cppu::OInterfaceIteratorHelper aIt(*pContainer);
			while (aIt.hasMoreElements())
				((::com::sun::star::beans::XPropertyChangeListener *)aIt.next())->propertyChange( aEvt );
		}
	}
	return bSuccess;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXChaosContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_FLAGS:
			aAny <<= (sal_Int32)(0x02000000);
			// this bit should prevent the "open with" common for the entry
			break;

		case PROP_ID_EDITSTRING:
		case PROP_ID_TITLE:
			aAny <<= aTitle;
			break;
		case PROP_ID_SORTING:
		{
			::com::sun::star::chaos::SortingInfo aInfo(::rtl::OUString::createFromAscii("Title"), sal_True);
			::com::sun::star::uno::Sequence< ::com::sun::star::chaos::SortingInfo> aInfos(&aInfo,1);
			aAny <<= aInfos;

		}	break;
		case PROP_ID_OWNURL:
			aAny <<= aUrl;
			break;
		case PROP_ID_MENU:
			return aMenu;
		case PROP_ID_HAS_FOLDER:
			{
				sal_Bool bB(bHasFolder);
				aAny.setValue(&bB,::getBooleanCppuType());
			}
			break;
		case PROP_ID_CONTENT_TYPE:
		{
			UniString aTempStr( aContentType );
			::com::sun::star::chaos::ContentType aTemp;
			if (aTempStr.GetTokenCount(';') == 2)
			{
				aTemp.Type = aTempStr.GetToken(0,';');
				aTemp.Presentation = aTempStr.GetToken(1,';');
			}
			else
				aTemp.Type = aContentType;

			aAny <<= aTemp;
		}	break;
		case PROP_ID_MASK_COLOR:
			aAny <<= (sal_Int32) 0x00ff00ff;
			break;
		case PROP_ID_SMALL_IMAGE:
		case PROP_ID_BIG_IMAGE:
		{
			::com::sun::star::uno::Reference< ::com::sun::star::awt::XBitmap > 	xBmp;
			xBmp = VCLUnoHelper::CreateBitmap( (PROP_ID_BIG_IMAGE == _nID) ? getLargeBitmap() : getSmallBitmap() );

			aAny <<=  xBmp;
		}
		break;
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
												 const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener )
{
	aPropertyListeners.addInterface(aPropertyName,  aListener);
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
													const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener )
{
	aPropertyListeners.removeInterface(aPropertyName,  aListener);
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::addVetoableChangeListener( const ::rtl::OUString& aPropertyName,
												 const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener )
{
}

// ------------------------------------------------------------------------
void SAL_CALL SbaXChaosContent::removeVetoableChangeListener( const ::rtl::OUString& aPropertyName,
													const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener )
{
}

// ------------------------------------------------------------------------
void SbaXChaosContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
}

// ------------------------------------------------------------------------
Bitmap SbaXChaosContent::getLargeBitmap() const
{
	DBG_ASSERT(m_nLargeBitmapId != 0, "SbaXChaosContent::getLargeBitmap : please set m_nLargeBitmapId in your constructor !");
	ConstBitmapCacheIterator aIter = m_sAllBitmaps.find(m_nLargeBitmapId);
	if (aIter == m_sAllBitmaps.end())
	{
		DBG_ERROR("SbaXChaosContent::getLargeBitmap : invalid bitmap id !");
		return Bitmap();
	}
	return (*aIter).second;
}

// ------------------------------------------------------------------------
Bitmap SbaXChaosContent::getSmallBitmap() const
{
	DBG_ASSERT(m_nSmallBitmapId != 0, "SbaXChaosContent::getSmallBitmap : please set m_nSmallBitmapId in your constructor !");
	ConstBitmapCacheIterator aIter = m_sAllBitmaps.find(m_nSmallBitmapId);
	if (aIter == m_sAllBitmaps.end())
	{
		DBG_ERROR("SbaXChaosContent::getSmallBitmap : invalid bitmap id !");
		return Bitmap();
	}
	return (*aIter).second;
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::prepareMove(	const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
									const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									const ::com::sun::star::uno::Any& rParam)
{
	xDatabase	= NULL;
	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::rename( const ::rtl::OUString& rTitle )
{
	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::open( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						const ::com::sun::star::uno::Any& rParam )
{
	++nOpenCounter;
	return sal_True;
}

// ------------------------------------------------------------------------
void SbaXChaosContent::close( const ::com::sun::star::chaos::StatusCallbackEvent& aEvt,
							  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							  const ::com::sun::star::uno::Any& rParam )
{
	nOpenCounter -= ::utl::getINT32(rParam);
	if (!nOpenCounter)
		CloseImpl();
}

// ------------------------------------------------------------------------
void SbaXChaosContent::CloseImpl()
{
}

// ------------------------------------------------------------------------
void SbaXChaosContent::prepareMenu( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
									const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									const ::com::sun::star::uno::Any& rParam )
{
	::com::sun::star::uno::Any aNewMenu;
	createPopup(aNewMenu);
	_setPropertyValue(PROP_ID_MENU, ::rtl::OUString::createFromAscii("PopupMenu"), aNewMenu);
}

// ------------------------------------------------------------------------
sal_Bool SbaXChaosContent::destroy(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							   const ::com::sun::star::uno::Any& rParam)
{
	return sal_False;
}

//-------------------------------------------------------------------------
SbaDatabase* SbaXChaosContent::getDatabase( sal_Bool bShowError, sal_Bool bRegisterOnParent )
{
	if (!xDatabase.Is())
	{
		xDatabase = SBAOBJ()->GetDatabase( aDatabasePath.GetFull(), bShowError );

		if (bRegisterOnParent && xDatabase.Is())
		{
			// bei meinem Parent als Nutzer der DB registrieren
			::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xRegisterMe(getParent(), ::com::sun::star::uno::UNO_QUERY);
			if (xRegisterMe.is())
			{
				::com::sun::star::uno::Reference< ::com::sun::star::chaos::XCommandExecutor >  xMe((::com::sun::star::chaos::XCommandExecutor*)this);
				xRegisterMe->execute(COMMAND_REGISTER_DB_USER, ::com::sun::star::uno::makeAny(xMe), ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > (new SbaXDummyStatusCallback()));
			}
		}
	}

	return xDatabase;
}

// ------------------------------------------------------------------------
SbaXContainer::SbaXContainer(const DBBasePropertyMap* _pMap, DBObject _eObj)
			  :SbaXChaosContent(_pMap, sal_True)
			  ,eObj(_eObj)
			  ,nCopyMoveEvent(0)
			  ,aRequestedAction(RA_COPY)
{
	if(!aDataExchangeFormat.Len())
		aDataExchangeFormat = Exchange::GetFormatName(SOT_FORMATSTR_ID_SBA_DATAEXCHANGE);
	if(!aFormExchangeFormat.Len())
		aFormExchangeFormat = Exchange::GetFormatName(SOT_FORMATSTR_ID_SBA_FORMEXCHANGE);
	if(!aReportExchangeFormat.Len())
		aReportExchangeFormat = Exchange::GetFormatName(SOT_FORMATSTR_ID_SBA_REPORTEXCHANGE);
	if(!aRTFExchangeFormat.Len())
		aRTFExchangeFormat = Exchange::GetFormatName(SOT_FORMAT_RTF);
	if(!aHTMLExchangeFormat.Len())
		aHTMLExchangeFormat = Exchange::GetFormatName(SOT_FORMATSTR_ID_HTML);

}

// ------------------------------------------------------------------------
SbaXContainer::~SbaXContainer()
{
	if (!bDisposed)
	{
		acquire();
		dispose();
	}
}

// ::com::sun::star::lang::XComponent
//------------------------------------------------------------------------------
void SbaXContainer::dispose(void)
{
	if (IsListening(*SBAOBJ()))
		EndListening(*SBAOBJ());

	if (nCopyMoveEvent)
	{
		Application::RemoveUserEvent( nCopyMoveEvent );
		while (lstpDataExchObjects.Count() > 0)
			lstpDataExchObjects.Remove(sal_uInt32(0))->ReleaseRef();

		nCopyMoveEvent = 0;
	}

	SbaXChaosContent::dispose();
}


// ------------------------------------------------------------------------
::com::sun::star::uno::Any	SAL_CALL SbaXContainer::queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface(_rType,static_cast< ::com::sun::star::chaos::XExplorerExchange*>(this));
	if(aRet.hasValue())
		return aRet;
	return SbaXChaosContent::queryInterface( _rType);
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL SbaXContainer::getTypes() throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > aTypes(SbaXChaosContent::getTypes());
	aTypes.realloc(1);
	aTypes.getArray()[aTypes.getLength()-1] = ::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XExplorerExchange>*)0);
	return aTypes;
}

//-------------------------------------------------------------------------
void SbaXContainer::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType,
							   const SfxHint& rHint, const TypeId& rHintType )
{
	if (!xDatabase.Is())
		return;

	if (rHint.ISA(SfxSimpleHint) && (((SfxSimpleHint&)rHint).GetId() == SFX_HINT_DYING))
		// das koennte gerade das Dying des SBA_MOD sein, also ignoriere ich es, da sonst die Aufrufe der
		// virtuellen Methoden an SBA_MOD ziemlich kritisch sind
		// (ich handle hier drin sowieso keinerlei Dying-Hints, also kann ich sie auch alle ignorieren)
		return;

	SbaDBDefHint* pHint = SBA_MOD()->DBDEF_CAST(rHint);
	if (!pHint || !pHint->GetDBDef() ||
		pHint->GetDatabase() != xDatabase)
		return;

	sal_Bool bResult;
	switch (eObj)
	{
		case dbTable:
		case dbView:
			bResult = pHint->GetDBDef()->GetKind() == eObj || pHint->GetDBDef()->GetKind() == dbView;
			break;
		case dbQuery:
		case dbForm:
		case dbReport:
			bResult = eObj == pHint->GetDBDef()->GetKind();
			break;
		default:
			bResult = sal_False;
	}

	if (bResult)
	{
		switch (pHint->GetAction())
		{
			case SbaDBDefHint::dbCreate:
			{
				// ich habe ein neues Child
				UniString aNewChild;
				if(pHint->GetDBDef()->GetKind() == dbView)
					aNewChild = ";";
				 aNewChild += UniString(pHint->GetDBDef()->Name());
				 _setPropertyValue(PROP_ID_NEWCHILD, ::rtl::OUString::createFromAscii("NewChild"), ::com::sun::star::uno::makeAny(::rtl::OUString(aNewChild)));

				// und jetzt auch SubFolder (falls ich das vorher nicht schon hatte)
				if (!bHasFolder)
				{
					_setPropertyValue(PROP_ID_HAS_FOLDER, ::rtl::OUString::createFromAscii("HasFolder"), ::com::sun::star::uno::makeAny(sal_Bool(sal_True)));
				}
			} break;
			case SbaDBDefHint::dbDelete:
			{
				::rtl::OUString aOldChild;
				if(pHint->GetDBDef()->GetKind() == dbView)
					aOldChild = U(';');
				 aOldChild = aOldChild + U(pHint->GetDBDef()->Name());

				_setPropertyValue(PROP_ID_DELETEME, ::rtl::OUString::createFromAscii("DeleteMe"), ::com::sun::star::uno::makeAny(aOldChild));

				if (bHasFolder && !xDatabase->GetObjectCount(eObj))
					_setPropertyValue(PROP_ID_HAS_FOLDER, ::rtl::OUString::createFromAscii("HasFolder"), ::com::sun::star::uno::makeAny(sal_Bool(sal_False)));
			}
		}
	}
}

// ------------------------------------------------------------------------
sal_Bool SbaXContainer::open( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						  const ::com::sun::star::uno::Any& rParam )
{
	if (!SbaXChaosContent::open(rCmd, rJob, rParam))
		return sal_False;

	if (!getDatabase(sal_True))
		return sal_False;
	else
	{
		OfaDatabaseGuard aDatabaseSafety(&xDatabase);
		sal_uInt16 nCount = xDatabase->GetObjectCount(eObj),
			   i	  = 0;
	
		// collect the object names
		::std::vector< XubString> aNames;

		while (i < nCount)
			aNames.insert(aNames.end(), xDatabase->GetObjectName(eObj, i++));

		// do the CHAOS jobs after clearing our database guard
		aDatabaseSafety.clear();

		for	(	::std::vector< XubString>::iterator aChildLoop = aNames.begin();
				aChildLoop != aNames.end();
				++aChildLoop
			)
			rJob->result( rCmd, SBA_RESULT_INSERTED, U(*aChildLoop));

		return sal_True;
	}
}

// ------------------------------------------------------------------------
void SbaXContainer::CloseImpl()
{
	SbaXChaosContent::CloseImpl();
}

//-------------------------------------------------------------------------
sal_Bool SbaXContainer::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
								 const INetURLObject& rUrlObj )
{
	if (SbaXChaosContent::_initialize(aParent, aURL, rUrlObj) && getDatabase(sal_True) != NULL)
	{
		sal_uInt16 nCount = xDatabase->GetObjectCount(eObj);
		if (!nCount)
			_setPropertyValue(PROP_ID_HAS_FOLDER, ::rtl::OUString::createFromAscii("HasFolder"), ::com::sun::star::uno::makeAny(sal_Bool(sal_False)));

		StartListening(*SBAOBJ());
		return sal_True;
	}
	else
		return sal_False;
}

// ::com::sun::star::chaos::XExplorerExchange
//------------------------------------------------------------------
::com::sun::star::uno::Any SAL_CALL SbaXContainer::createDataObject(sal_uInt16& nSourceOptions)
{
	if (!xDatabase.Is())
		return ::com::sun::star::uno::Any();

	SvDataMemberObject *pDataObj = new SvDataMemberObject();
	UniString aLink(xDatabase->Title());
	aLink += ':';
	switch(eObj)
	{
		case dbForm:
			aLink += UniString(OfsStringRes(RID_STR_NAME_FORMS));
			break;
		case dbTable:
			aLink += UniString(OfsStringRes(RID_STR_NAME_TABLES));
			break;
		case dbQuery:
			aLink += UniString(OfsStringRes(RID_STR_NAME_QUERIES));
			break;
		case dbReport:
			aLink += UniString(OfsStringRes(RID_STR_NAME_REPORTS));
			break;
	}

	SfxBookmarkObject::AddBookmarkObject( pDataObj, S(aUrl), S(aLink) );
	nSourceOptions |= DRAG_LINKABLE;
	return ::com::sun::star::uno::makeAny(sal_uInt32(pDataObj));
}

//------------------------------------------------------------------
sal_uInt16 SAL_CALL SbaXContainer::insertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions)
{
	DBG_ASSERT(!xDatabase->IsReadOnly(), "SbaXContainer::insertDataObject darf nicht fuer ReadOnly-DBs aufgerufen werden !");

	sal_Bool bSomethingToDo = sal_False;
	sal_uInt16 nType =0;
	//////////////////////////////////////////////////////////////////////
	// Alle Formate des SfxExchObj durchlaufen
	sal_Int64 pConv;
	pSotDataObjectPtr >>= pConv;
	SfxExchangeObject* pExchObj = (SfxExchangeObject*)pConv;

	sal_uInt32 nFormatIndex = pExchObj->Count();
	while (nFormatIndex--)
	{
		SvDataObject* pDataObj = pExchObj->GetObject(nFormatIndex);
		const SvDataTypeList& rTypeList = pDataObj->GetTypeList();
		//////////////////////////////////////////////////////////////////////
		// Daten in SBA_DATA_EXCHANGE_FORMAT?
		if (rTypeList.Get(Exchange::RegisterFormatName(aDataExchangeFormat))
			|| rTypeList.Get(Exchange::RegisterFormatName(aFormExchangeFormat))
			|| rTypeList.Get(Exchange::RegisterFormatName(aReportExchangeFormat)))
		{
			// wenn noch ein Kopiervorgang anhaengt -> weg damit
			if (nCopyMoveEvent)
			{
				Application::RemoveUserEvent( nCopyMoveEvent );
				while (lstpDataExchObjects.Count() > 0)
					lstpDataExchObjects.Remove(sal_uInt32(0))->ReleaseRef();

				nCopyMoveEvent = 0;
			}

			// das aktuelle Objekt mit zu Liste
			SbaExplorerExchObj* pCurrent = (SbaExplorerExchObj*)pDataObj;
			pCurrent->AddRef();
			lstpDataExchObjects.Insert(pCurrent, lstpDataExchObjects.Count());

			bSomethingToDo = sal_True;
			nType = 1;
		}
		else if(rTypeList.Get(Exchange::RegisterFormatName(aHTMLExchangeFormat)))
		{
			if (nCopyMoveEvent)
			{
				Application::RemoveUserEvent( nCopyMoveEvent );
				nCopyMoveEvent = 0;
			}
			// das aktuelle Objekt mit zu Liste
			SvData *pData = new SvData(SOT_FORMATSTR_ID_HTML);
			if(pDataObj->GetData(pData) && pData->GetData((SvStorageStreamRef&)m_Stream) && m_Stream.Is())
			{
				bSomethingToDo = sal_True;
				nType = 2;
			}
		}
		else if(rTypeList.Get(Exchange::RegisterFormatName(aRTFExchangeFormat)) )
		{
			if (nCopyMoveEvent)
			{
				Application::RemoveUserEvent( nCopyMoveEvent );
				nCopyMoveEvent = 0;
			}
			// das aktuelle Objekt mit zu Liste
			SvData *pData = new SvData(SOT_FORMAT_RTF);
			if(pDataObj->GetData(pData) && pData->GetData((SvStorageStreamRef&)m_Stream) && m_Stream.Is())
			{
				bSomethingToDo = sal_True;
				nType = 3;
			}
		}
	}

	if (bSomethingToDo)
	{
		//////////////////////////////////////////////////////////////////////
		// In Copy wird ModalDlg aufgerufen, dies darf nicht innerhalb eines Hdls geschehen
		// deshalb wird die Funktion Copy asynchron gerufen
		// nur ein Object kopieren
		if (nUserAction == DRAG_MOVEABLE)
			aRequestedAction = RA_MOVE;
		else
			aRequestedAction = RA_COPY;

		switch(nType)
		{
			case 1:
				nCopyMoveEvent = Application::PostUserEvent(LINK(this, SbaXContainer, OnCopyMove));
				break;
			case 2:
				nCopyMoveEvent = Application::PostUserEvent(LINK(this, SbaXContainer, OnHTMLCopyMove));
				break;
			case 3:
				nCopyMoveEvent = Application::PostUserEvent(LINK(this, SbaXContainer, OnRTFCopyMove));
				break;
		}

		return DRAG_MOVEABLE;
	}

	return 0;
}

// ------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXContainer::queryInsertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions, sal_uInt16& nResultingAction, sal_uInt16& nDefaultAction)
{
	sal_Bool	bNew =	xDatabase.Is() && !xDatabase->IsReadOnly() &&
					!::utl::getBOOL(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::READ_ONLY)) &&
					(::utl::getINT16(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::CREATE);

	if (xDatabase->IsReadOnly() || nCopyMoveEvent || (eObj == dbTable && !bNew))
		return sal_False;

	sal_Bool	bAtLeastOne = sal_False;
	sal_Bool	bAllowed = sal_True;

	UniString strMyDatabase = xDatabase->Name();

	//////////////////////////////////////////////////////////////////////
	// Alle Formate des SfxExchObj durchlaufen
	sal_Int64 pConv;
	pSotDataObjectPtr >>= pConv;
	SfxExchangeObject* pExchObj = (SfxExchangeObject*)pConv;

	sal_uInt32 nFormatIndex = pExchObj->Count();
	while (nFormatIndex--)
	{
		SvDataObject* pDataObj = pExchObj->GetObject(nFormatIndex);
		const SvDataTypeList& rTypeList = pDataObj->GetTypeList();
		//////////////////////////////////////////////////////////////////////
		// Wenn Daten in SBA_DATA_EXCHANGE_FORMAT, koennten wir diese verarbeiten
		if (rTypeList.Get(Exchange::RegisterFormatName(aDataExchangeFormat))
			|| rTypeList.Get(Exchange::RegisterFormatName(aFormExchangeFormat))
			|| rTypeList.Get(Exchange::RegisterFormatName(aReportExchangeFormat)))
		{
			// testen, ob es sich um ein Verschieben innerhalb der selben DB handelt
			sal_Bool bMovingInSameDB = sal_False;
			sal_Bool bDropAllowed = sal_True;
			if (nUserAction == DRAG_MOVEABLE)
			{
				SbaDBDefRef xRequestedObject = ((SbaExplorerExchObj*)pDataObj)->GetSourceDef();
				DBG_ASSERT(xRequestedObject.Is(), "SbaXContainer::queryInsertDataObject : invalid object");
				SbaDatabase* pThisObjectDB = xRequestedObject->GetDatabase();
				DBG_ASSERT(pThisObjectDB != NULL, "SbaXContainer::queryInsertDataObject : object to insert has no database !");
					// In dem Kommentar zu GetDatabase steht, dass das nur gueltig waere, wenn das Objekt geoeffnet ist, was ich
					// aber nach Ansehen der Implementation nicht glauben kann. Es waere auch usinnig.
					// Aber sicherheisthalber trotzdem noch ein Check.
				UniString strThisObjectDB = pThisObjectDB ? pThisObjectDB->Name() : UniString();
				// selbes Objekt
				if ((xRequestedObject->GetKind() == eObj) && strMyDatabase == strThisObjectDB)
					bMovingInSameDB = sal_True;

				if (xRequestedObject->GetKind() == dbTable)
				{
					SbaTableDef* pAsTable = (SbaTableDef*)&xRequestedObject;
					if ((pAsTable->GetTablePrivileges() & SDB_PR_DROP) == 0)
						bDropAllowed = sal_False;
				}
			}

			if (!bDropAllowed || bMovingInSameDB || !((SbaExplorerExchObj*)pDataObj)->QueryInsertObject(eObj))
				bAllowed = sal_False;
			else
			{
				bAtLeastOne = sal_True;

				nResultingAction = (nUserAction == DRAG_MOVEABLE) ? DRAG_MOVEABLE : DRAG_COPYABLE;
				nDefaultAction		= DRAG_COPYABLE;
				bAllowed &= sal_True;
			}
		}
		else if((rTypeList.Get(Exchange::RegisterFormatName(aRTFExchangeFormat)) ||
				rTypeList.Get(Exchange::RegisterFormatName(aHTMLExchangeFormat))) && nUserAction != DRAG_MOVEABLE && eObj == dbTable)
		{
			bAllowed			= sal_True;
			bAtLeastOne			= sal_True;
			nResultingAction	= DRAG_COPYABLE;
			nDefaultAction		= DRAG_COPYABLE;
		}
	}

	return bAtLeastOne ? bAllowed : sal_False;
}
//-------------------------------------------------------------------------
IMPL_LINK( SbaXContainer, OnRTFCopyMove, void*, EMPTYARG )
{
	SbaRTFExchObj *pCurrent = (SbaRTFExchObj*)SBAEXPL()->CreateDataExchObj(RTF_EXCHANGE, &xDatabase, dbTable, UniString());
	pCurrent->AddRef();
	sal_Bool bTest = pCurrent->InsertRTFTable(m_Stream);
	pCurrent->ReleaseRef();
	nCopyMoveEvent = 0;
	return 0L;
}
//-------------------------------------------------------------------------
IMPL_LINK( SbaXContainer, OnHTMLCopyMove, void*, EMPTYARG )
{
	SbaHTMLExchObj *pCurrent = (SbaHTMLExchObj*)SBAEXPL()->CreateDataExchObj(HTML_EXCHANGE, &xDatabase, dbTable, UniString());
	pCurrent->AddRef();
	sal_Bool bTest = pCurrent->InsertHTMLTable(m_Stream);
	pCurrent->ReleaseRef();
	nCopyMoveEvent = 0;
	return 0L;
}
//-------------------------------------------------------------------------
IMPL_LINK( SbaXContainer, OnCopyMove, void*, EMPTYARG )
{
	//////////////////////////////////////////////////////////////////////
	// Delayed Copy
	sal_uInt16 nLastAction=0;
	while (lstpDataExchObjects.Count() > 0)
	{
		// zuerst kopieren wir das Objekt
		SbaExplorerExchObj* pCurrent = (SbaExplorerExchObj*)lstpDataExchObjects.Remove(sal_uInt32(0));
		SbaExplorerExchObj::ACTION_TYPE atWhat = (aRequestedAction == RA_MOVE) ? SbaExplorerExchObj::AT_MOVE : SbaExplorerExchObj::AT_COPY;
			// hmmm, wenn die die selben Typen verwenden wuerden, koennte ich mir diesen haesslichen Konstrukt sparen ...
		sal_Bool bThisRoundSuccess = pCurrent->CreateDestDef(xDatabase, atWhat, eObj,nLastAction);
		// ab der 507 weiss das ExplorerExchangeObject, dass es verschiebt und loescht deshalb gleich mit
		pCurrent->ReleaseRef();

		// ging irgendwas schief und habe ich noch weitere Objekte zu kopieren/verschieben ?
		if (!bThisRoundSuccess && lstpDataExchObjects.Count())
		{
			// fragen, ob weitergemacht werden soll
			UniString aInfoString = UniString(OfsStringRes(aRequestedAction == RA_COPY ? RID_STR_ASK_COPY_REMAINING : RID_STR_ASK_MOVE_REMAINING));
			short nObjectNameResId = 0;
			switch (eObj)
			{
				case dbView		:
				case dbTable	: nObjectNameResId = RID_STR_NAME_TABLES; break;
				case dbReport	: nObjectNameResId = RID_STR_NAME_REPORTS; break;
				case dbQuery	: nObjectNameResId = RID_STR_NAME_QUERIES; break;
				case dbForm		: nObjectNameResId = RID_STR_NAME_FORMS; break;
			}
			aInfoString.SearchAndReplace("$objects$", UniString(OfsStringRes(nObjectNameResId)));

			short nResult;
			{
				::vos::OGuard aGuard(Application::GetSolarMutex());
				nResult = QueryBox((Window*)Application::GetAppWindow(), WB_YES_NO | WB_DEF_YES, S(aInfoString)).Execute();
			}
			if (nResult != RET_YES)
			{
				// nicht weitermachen -> alle anstehenden Defs loeschen
				while (lstpDataExchObjects.Count() > 0)
					lstpDataExchObjects.Remove(sal_uInt32(0))->ReleaseRef();
				// und wech
				return 0L;
			}

		}
	}
	nCopyMoveEvent = 0;
	return 0L;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXContainer::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_IS_FOLDER:
			{
				sal_Bool bB(sal_True);
				aAny.setValue(&bB,::getBooleanCppuType());
			}
			break;
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii("_beamer;_top;_blank");
			break;
		default:
			return SbaXChaosContent::_getPropertyValue( _nID );
	}
	return aAny;
}

//-------------------------------------------------------------------------
void SbaXContainer::actualize(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							  const ::com::sun::star::uno::Any& rParam)
{
	// aktualisieren der Containerinhalte
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	if (xDatabase.Is())
		xDatabase->Refresh(eObj);

	aDatabaseSafety.clear();
	rJob->result(rCmd, SBA_RESULT_REOPEN, aUrl);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXContainer::queryCommands() 
{
	static ::rtl::OUString aCommandList[ 5 ] =
	{
			::rtl::OUString::createFromAscii("close"),
			::rtl::OUString::createFromAscii("initialize"),
			::rtl::OUString::createFromAscii("open"),
			::rtl::OUString::createFromAscii("paste"),
			::rtl::OUString::createFromAscii("prepareMenu")
	};
	return ::com::sun::star::uno::Sequence< ::rtl::OUString >( aCommandList, 5 );
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any	SAL_CALL SbaXContent::queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any aRet = ::cppu::queryInterface(_rType,static_cast< ::com::sun::star::chaos::XExplorerExchange*>(this));
	if(aRet.hasValue())
		return aRet;
	return SbaXChaosContent::queryInterface( _rType);
}
// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL SbaXContent::getTypes() throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > aTypes(SbaXChaosContent::getTypes());
	aTypes.realloc(1);
	aTypes.getArray()[aTypes.getLength()-1] = ::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XExplorerExchange>*)0);
	return aTypes;
}

// ------------------------------------------------------------------------
SbaXContent::~SbaXContent()
{
	if (!bDisposed)
	{
		SbaXChaosContent::acquire();
		SbaXChaosContent::dispose();
	}
}

// ::com::sun::star::chaos::XExplorerExchange
//------------------------------------------------------------------
::com::sun::star::uno::Any SAL_CALL SbaXContent::createDataObject(sal_uInt16& nSourceOptions)
{
	// FS - 65273 - 26.04.99
	// nicht das Objekt selber oeffnen, sondern das dem DataExchangeObject ueberlassen,
	// das kann entscheiden, ob das irgendwann wirklich notwendig ist

	if (!xDatabase.Is())
		return ::com::sun::star::uno::Any();
	else
	{
		nSourceOptions |= DRAG_COPYABLE | DRAG_MOVEABLE | DRAG_LINKABLE;
		return ::com::sun::star::uno::makeAny(sal_uInt32(SBAEXPL()->CreateDataExchObj(EXPLORER_EXCHANGE, &xDatabase, eObj, S(aTitle))));
	}
}

//------------------------------------------------------------------
sal_uInt16 SAL_CALL SbaXContent::insertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions)
{
	return 0;
}

//------------------------------------------------------------------
sal_Bool SAL_CALL SbaXContent::queryInsertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions, sal_uInt16& nResultingAction, sal_uInt16& nDefaultAction)
{
	return sal_False;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXContent::queryCommands()
{
	sal_uInt32 nCount = 6;
	static ::rtl::OUString aCommandList[ 6 ] =
	{
			::rtl::OUString::createFromAscii("close"),
			::rtl::OUString::createFromAscii("delete"),
			::rtl::OUString::createFromAscii("initialize"),
			::rtl::OUString::createFromAscii("open"),
			::rtl::OUString::createFromAscii("prepareMenu"),
			::rtl::OUString::createFromAscii("rename")
	};
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData = xDatabase->GetMetaData();
	if (xDatabase->IsReadOnly())
		nCount--;
	return ::com::sun::star::uno::Sequence< ::rtl::OUString >( aCommandList, nCount );
}

// ------------------------------------------------------------------------
void SbaXContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	if (!aCmd.compareToAscii("undelete"))
	{
		// undelete i.A. komplett abgeklemmt
//		::com::sun::star::chaos::StatusCallbackEvent aEvt((UsrObject*)this, (UsrObject*)this, aCmd, aParam);
//		if (restore(aEvt, rCallback, aParam))
//			rCallback->done(aEvt);
//		else
//			rCallback->cancelled(aEvt);
	}
	else
		SbaXChaosContent::executeImpl(aCmd, aParam, rCallback);
}

//-------------------------------------------------------------------------
void SbaXContent::actualize(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							const ::com::sun::star::uno::Any& rParam)
{
	// aktualisieren der Containerinhalte
	if (xDBObj)
		if (xDBObj->IsLocked())
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			ErrorBox(NULL, OffResId(RID_ERR_OBJECT_LOCKED)).Execute();
		}
		else
			xDBObj->Refresh();
}

// ------------------------------------------------------------------------
sal_Bool SbaXContent::restore(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	DBG_ERROR("SbaXContent::restore : shouldn't be used at this time !");
	return sal_False;

	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	if (!xDatabase.Is())
		// im _initialize bin ich auf jeden Fall schon vorbeigekommen, und das sollte mir die DB besorgt haben
		return sal_False;

	// die DB das Ding wiederherstellen lassen
	XubString strTitle = S(aTitle);
	if (!xDatabase->UndeleteObject(eObj,strTitle))
		return sal_False;
	m_bMayBeDeleted = sal_False;
	DBG_ASSERT(xDatabase->HasObject(eObj, strTitle) && getObj(), "SbaXContent::restore : The DB restored the object but doesn't know it afterwards ?");

	// und damit wurde praktisch ein neues Objekt angelegt
	SBA_MOD()->NOTIFY_DBDEF(xDBObj, (sal_uInt16)SbaDBDefHint::dbCreate);

	return sal_True;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii(";_top;_blank");
			break;
		case PROP_ID_SHOW_IN_EXPLORER:
			{
				sal_Bool bB(sal_True);
				aAny.setValue(&bB,::getBooleanCppuType());
			}
			break;
		case PROP_ID_IS_DOCUMENT:
			{
				sal_Bool bB(sal_True);
				aAny.setValue(&bB,::getBooleanCppuType());
			}
			break;
		case PROP_ID_RENAME:
			if (!xDatabase->IsReadOnly())
				aAny <<= ::rtl::OUString::createFromAscii("Title");
			break;
		default:
			return SbaXChaosContent::_getPropertyValue( _nID );
	}
	return aAny;
}

//-------------------------------------------------------------------------
sal_Bool SbaXContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
							   const INetURLObject& rUrlObj)
{
	if (!SbaXChaosContent::_initialize(aParent, aURL, rUrlObj) || !getDatabase(sal_True))
		return sal_False;

	XubString strTitle = S(aTitle);
	m_bMayBeDeleted = xDatabase->HasObjectDeleted(eObj, strTitle);
	m_bMayBeDeleted = sal_False;
		// Soft-Loeschen i.A. abgeklemmt

	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXContent::rename( const ::rtl::OUString& rTitle )
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	XubString aTmp(S(rTitle));
	if (getObj() && (aTmp.Search('#') == STRING_NOTFOUND))
	{
		if(xDBObj->GetKind() == dbTable || xDBObj->GetKind() == dbView)
		{
			SbaDatabase* pDatabase = xDBObj->GetDatabase();
			if(pDatabase->IsSQLNameValid(aTmp))
			{
				Link aOldHandler = ((SbaTableDef*)&xDBObj)->GetTable()->SetUiActionLink(LINK(this, SbaXContent, OnCoreMessage));
				xDBObj->Rename(aTmp);
				((SbaTableDef*)&xDBObj)->GetTable()->SetUiActionLink(aOldHandler);

				if (!xDBObj->Status().IsSuccessful())
				{
					SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbWriteError);
					return sal_False;
				}
				_setPropertyValue(PROP_ID_OWNURL,::rtl::OUString::createFromAscii("OwnURL"),::com::sun::star::uno::makeAny(U(xDBObj->ToURL())));
				return SbaXChaosContent::rename( rTitle );
			}
			else
			{
				::vos::OGuard aGuard(Application::GetSolarMutex());
				ErrorBox(NULL, OffResId(RID_ERR_NAME_INVALID)).Execute();
				return sal_False;
			}
		}
		else
		{
			if ((xDBObj->GetKind() == dbReport) || (xDBObj->GetKind() == dbForm))
			{
				if (rTitle.len() > 32)
				{
					// report and form names are not allowed to have more than 32 characters (because
					// of the method they are made persistent in an SvStorage)
					ErrorBox(NULL, WB_OK, OfsStringRes(RID_STR_FRMORREP_NAMETOLONG)).Execute();
					return sal_False;
				}
			}
			xDBObj->Rename(aTmp);
			if (xDBObj->Status().IsError())
			{
				SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbWriteError);
				return sal_False;
			}
			_setPropertyValue(PROP_ID_OWNURL,::rtl::OUString::createFromAscii("OwnURL"),::com::sun::star::uno::makeAny(::rtl::OUString::createFromAscii(xDBObj->ToURL())));
			return SbaXChaosContent::rename( rTitle );
		}
	}
	return sal_False;
}

// ::com::sun::star::lang::XComponent
//-------------------------------------------------------------------------
void SbaXContent::dispose(void)
{
	SbaXChaosContent::dispose();
	xDBObj = NULL;
}

// ------------------------------------------------------------------------
void SbaXContent::CloseImpl()
{
	xDBObj = NULL;
}

// ------------------------------------------------------------------------
sal_Bool SbaXContent::destroy(const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						  const ::com::sun::star::uno::Any& rParam)
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	// knallhart loeschen oder mit der Moeglichkeit des Undelete ?
	sal_Bool bSoftDelete = sal_False;
	if (rParam.getValueTypeClass() == ::com::sun::star::uno::TypeClass_BOOLEAN)
		bSoftDelete = !::utl::getBOOL(rParam);

	if (m_bMayBeDeleted && bSoftDelete)
	{
		DBG_ASSERT(xDatabase->HasObjectDeleted(eObj, S(aTitle)), "SbaXContent::destroy : m_bMayBeDeleted is invalid !");
		if (!xDatabase->DestroyDeletedObject(eObj, S(aTitle)))
			return sal_False;
		m_bMayBeDeleted = sal_False;
		return sal_True;
	}

	if (!getObj())
		return sal_False;

	aDatabaseSafety.clear();
	// the Drop on the DBObject plays a lot with notifies which may cause deadlocks. As we have no chance to
	// give the Drop a guard to clear before braodcasting we have to explicitly clear it here.
	// FS - 70276 - 01.12.99

	sal_Bool bDropSuccess = bSoftDelete ? xDBObj->DropReversible() : xDBObj->Drop();
	if (bDropSuccess)
	{
		xDBObj = NULL;
		return sal_True;
	}

	if (xDBObj->Status().IsError())
		SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbWriteError);
	return sal_False;
}

// tools
//-------------------------------------------------------------------------
SbaDBDef* SbaXContent::getObj()
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	if (!xDatabase.Is())
		return NULL;

	if (m_bMayBeDeleted && !xDatabase->HasObject(eObj, S(aTitle)))
		// es gibt kein normales, aber ein geloeschtes Objekt -> kann ich nicht oeffnen
		return NULL;

	if (!xDBObj.Is())
	{
		xDBObj = xDatabase->OpenDBDef(eObj, S(aTitle));
		if (xDBObj)
			m_bMayBeDeleted = sal_False;
	}
	return xDBObj;
}

//-------------------------------------------------------------------------
IMPL_LINK( SbaXContent, OnCoreMessage, SdbUiActionDescription*, pDesc )
{
	// nyi: das Verhalten waere ueberall, wo man den UiActionHandler benutzt, das selbe (ausser dem Parent der MessageBox),
	// das sollte man irgendwo zentral zugaenglich machen
	sal_Int32 nFlags = 0;
	struct Translation
	{
		sal_uInt32	nDesc;
		sal_uInt32	nDialog;
	};
	static const Translation aBits[] = { { SdbUiActionDescription::YES_NO, WB_YES_NO }, { SdbUiActionDescription::YES_NO_CANCEL, WB_YES_NO_CANCEL },
		{ SdbUiActionDescription::OK, WB_OK }, { SdbUiActionDescription::OK_CANCEL, WB_OK_CANCEL } };
	for (sal_uInt16 i=0; i<sizeof(aBits)/sizeof(*aBits); ++i)
		if (pDesc->eType & aBits[i].nDesc)
		{
			nFlags = aBits[i].nDialog;
			break;
		}

	sal_uInt16 nResult;
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		nResult = WarningBox(NULL, nFlags, pDesc->sMessage).Execute();
	}

	switch (nResult)
	{
		case RET_YES	: return SdbUiActionDescription::RETURN_YES;
		case RET_NO		: return SdbUiActionDescription::RETURN_NO;
		case RET_CANCEL	: return SdbUiActionDescription::RETURN_CANCEL;
		default : return SdbUiActionDescription::RETURN_OK;
	}
}


