/*************************************************************************
 *
 *  $RCSfile: dbcommon.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBCOMMON_HXX
#define _DBCOMMON_HXX

#if defined( WNT )
#pragma warning (disable : 4005 4237)
#endif

#ifndef _SBA_SBAOBJ_HXX
#include <sbaobj.hxx>
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include <sbaexpob.hxx>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_CHAOS_XCOMMANDEXECUTOR_HPP_
#include <com/sun/star/chaos/XCommandExecutor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XSTATUSCALLBACK_HPP_
#include <com/sun/star/chaos/XStatusCallback.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XURLCONTENT_HPP_
#include <com/sun/star/chaos/XURLContent.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XEXPLOREREXCHANGE_HPP_
#include <com/sun/star/chaos/XExplorerExchange.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XCOMPONENTENUMERATION_HPP_
#include <com/sun/star/container/XComponentEnumeration.hpp>
#endif



#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SV_BITMAP_HXX //autogen
#include <vcl/bitmap.hxx>
#endif

#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif

#ifndef _OFF_APP_HXX
#include "app.hxx"
#endif

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE4_HXX_
#include <cppuhelper/compbase3.hxx>
#endif
#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifndef _UTL_STLTYPES_HXX_
#include <unotools/stl_types.hxx>
#endif


#ifdef U
#undef U
#endif
#ifdef S
#undef S
#endif
// StringConversion
#define U(x)					\
	::rtl::OStringToOUString( (const sal_Char*)x, RTL_TEXTENCODING_ASCII_US )
#define S(aUniCode)				\
	XubString((const sal_Char*)::rtl::OUStringToOString(aUniCode, RTL_TEXTENCODING_ASCII_US))

#define	SBAOBJ()					\
	OFF_APP()->GetSbaObject()

#define	SBAEXPL()					\
	SBAOBJ()->GetSbaObjectExt()


class Window;
class SbaExplorerExchObj;
DECLARE_LIST(SbaExplorerExchObjList, SbaExplorerExchObj*);



// -----------
// - Defines -
// -----------
#define SBA_RESULT_INSERTED 		1
#define SBA_RESULT_DELETED			2
#define SBA_RESULT_REMOVED			3
#define SBA_RESULT_CREATED			4
#define SBA_RESULT_REOPEN			5

// defines fuer default command IDs
// wichtig: Properties immer aufsteigend sortieren
#define PROP_ID_HAS_FOLDER			1	// HasFolder -> kann Kinder haben
#define PROP_ID_IS_FOLDER			2	// IsFolder fuer alle im Explorer sichtbaren Contents
#define PROP_ID_MENU				3
#define PROP_ID_RENAME				4
#define PROP_ID_SORTING				5
#define PROP_ID_TARGETS				6
#define PROP_ID_TITLE				7
#define PROP_ID_CONTENT_TYPE		8
#define PROP_ID_BIG_IMAGE			9
#define PROP_ID_SMALL_IMAGE			10
#define PROP_ID_MASK_COLOR			11
#define PROP_ID_NEWCHILD			12
#define PROP_ID_DELETEME			13
#define PROP_ID_OWNURL				14
#define PROP_ID_IS_DOCUMENT			15
#define PROP_ID_EDITSTRING			16
#define PROP_ID_SHOW_IN_EXPLORER	17
#define PROP_ID_FLAGS				18
#define PROP_ID_SORTCRITERIA		19
#define PROP_ID_USERSORTCRITERIUM	20


// defines von default commands

#define SBA_PROP_HAS_FOLDER			DBBasePropertyMap(::rtl::OUString::createFromAscii("HasFolder"),	\
									PROP_ID_HAS_FOLDER,	::getBooleanCppuType(),							\
									::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_IS_FOLDER			DBBasePropertyMap(::rtl::OUString::createFromAscii("IsFolder"),		\
									PROP_ID_IS_FOLDER,	::getBooleanCppuType(),							\
									::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_MENU				DBBasePropertyMap(::rtl::OUString::createFromAscii("PopupMenu"),	PROP_ID_MENU,		::getCppuType((const ::com::sun::star::chaos::MenuDescriptor*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_RENAME				DBBasePropertyMap(::rtl::OUString::createFromAscii("Rename"),		PROP_ID_RENAME,		::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_SORTING			DBBasePropertyMap(::rtl::OUString::createFromAscii("Sorting"),		PROP_ID_SORTING,	::getCppuType((const ::com::sun::star::chaos::SortingInfo*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_TARGETS			DBBasePropertyMap(::rtl::OUString::createFromAscii("TargetFrames"),	PROP_ID_TARGETS,	::getCppuType((const ::rtl::OUString*)0),	::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_TITLE				DBBasePropertyMap(::rtl::OUString::createFromAscii("Title"),		PROP_ID_TITLE,		::getCppuType((const ::rtl::OUString*)0),	::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_CONTENT_TYPE		DBBasePropertyMap(::rtl::OUString::createFromAscii("ContentType"),	PROP_ID_CONTENT_TYPE,::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_BIG_IMAGE			DBBasePropertyMap(::rtl::OUString::createFromAscii("BigImage"),		PROP_ID_BIG_IMAGE,	::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XBitmap>*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_SMALL_IMAGE		DBBasePropertyMap(::rtl::OUString::createFromAscii("SmallImage"),	PROP_ID_SMALL_IMAGE,::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XBitmap>*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_MASK_COLOR			DBBasePropertyMap(::rtl::OUString::createFromAscii("MaskColor"),	PROP_ID_MASK_COLOR,	::getCppuType((const sal_Int32*)0),   ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_NEWCHILD			DBBasePropertyMap(::rtl::OUString::createFromAscii("NewChild"),		PROP_ID_NEWCHILD,	::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_DELETEME			DBBasePropertyMap(::rtl::OUString::createFromAscii("DeleteMe"),		PROP_ID_DELETEME,   ::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_OWNURL				DBBasePropertyMap(::rtl::OUString::createFromAscii("OwnURL"),		PROP_ID_OWNURL,		::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_IS_DOCUMENT		DBBasePropertyMap(::rtl::OUString::createFromAscii("IsDocument"),	PROP_ID_IS_DOCUMENT,::getBooleanCppuType(),	::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_EDITSTRING			DBBasePropertyMap(::rtl::OUString::createFromAscii("EditString"),	PROP_ID_EDITSTRING,	::getCppuType((const ::rtl::OUString*)0), ::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_SHOW_IN_EXPLORER	DBBasePropertyMap(::rtl::OUString::createFromAscii("ShowInExplorer"),PROP_ID_SHOW_IN_EXPLORER,	::getBooleanCppuType(),	::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_FLAGS				DBBasePropertyMap(::rtl::OUString::createFromAscii("Flags"),		PROP_ID_FLAGS,		::getCppuType((const sal_Int32*)0),	::com::sun::star::beans::PropertyAttribute::BOUND, 0 )
#define SBA_PROP_SORTCRITERIA		DBBasePropertyMap(::rtl::OUString::createFromAscii("SortCriteria"),	PROP_ID_SORTCRITERIA,::getCppuType((const ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::SortingInfo>*)0),	::com::sun::star::beans::PropertyAttribute::READONLY, 0 )
#define SBA_PROP_USERSORTCRITERIUM	DBBasePropertyMap(::rtl::OUString::createFromAscii("UserSortCriterium"),	PROP_ID_USERSORTCRITERIUM,	::getCppuType((const ::rtl::OUString*)0),	::com::sun::star::beans::PropertyAttribute::READONLY, 0 )


// --------------------------------------------------------------------------------------

// interne Kommunikation ueber das Command-Executor-IFace der Contents
#define COMMAND_REGISTER_DB_USER	::rtl::OUString::createFromAscii("internal_RegisterDbUser")
	// alle Contents unterhalb der DB setzen das an ihr Parent ab, wenn sie initialisiert werden
#define COMMAND_UNREGISTER_DB_USER	::rtl::OUString::createFromAscii("internal_UnregisterDbUser")
	// das Gegenstueck, wenn ein ::com::sun::star::ucb::Content aufgeraeumt wird
#define COMMAND_FORCE_UNINITIALIZE	::rtl::OUString::createFromAscii("internal_ForceUninitialize")
	// der DB-::com::sun::star::ucb::Content schickt das an alle registrirten DB-::com::sun::star::sdbcx::User, wenn diese die DB loslassen sollen
	// (weil der DB-::com::sun::star::ucb::Content sie mal krz fuer sich allein haben will)
#define	COMMAND_REINITIALIZE		::rtl::OUString::createFromAscii("internal_Reinitialize")
	// das Gegenstueck, wird geschickt, wenn die Contents sich wieder die DB holen sollen

// ====================================================================================
// = SbaXDummyStatusCallback - brauche ich fuer meine internen Commands
// ====================================================================================

#if DBG_UTIL || _DEBUG
DBG_NAMEEX(SbaXDummyStatusCallback);
#endif

class SbaXDummyStatusCallback : public ::cppu::WeakImplHelper1< ::com::sun::star::chaos::XStatusCallback>
{
public:
#if DBG_UTIL || _DEBUG
	SbaXDummyStatusCallback() { DBG_CTOR(SbaXDummyStatusCallback, NULL); }
	virtual ~SbaXDummyStatusCallback() { DBG_DTOR(SbaXDummyStatusCallback, NULL);  }
#endif

	//	DECLARE_UNO3_AGG_DEFAULTS(SbaXDummyStatusCallback, XStatusCallback);

	virtual void SAL_CALL started(const ::com::sun::star::chaos::StatusCallbackEvent& evt) throw( ::com::sun::star::uno::RuntimeException ){ };
	virtual void SAL_CALL done(const ::com::sun::star::chaos::StatusCallbackEvent& evt) throw( ::com::sun::star::uno::RuntimeException ){ };
	virtual void SAL_CALL cancelled(const ::com::sun::star::chaos::StatusCallbackEvent& evt) throw( ::com::sun::star::uno::RuntimeException ){ };
	virtual void SAL_CALL error(const ::com::sun::star::chaos::StatusCallbackEvent& evt, sal_Int32 nError) throw( ::com::sun::star::uno::RuntimeException ){ };
	virtual void SAL_CALL result(const ::com::sun::star::chaos::StatusCallbackEvent& aEvent, sal_Int32 nAction, const ::rtl::OUString& aResult) throw( ::com::sun::star::uno::RuntimeException ){ };
};


// ---------------------
// - DBBasePropertyMap -
// ---------------------
struct DBBasePropertyMap
{
	::com::sun::star::uno::Type	m_aType;
	::rtl::OUString				sName;
	long						nFlags;
	sal_uInt16					nId;
	sal_Int8					nMemberId;

	DBBasePropertyMap(const ::rtl::OUString& _sName, sal_uInt16 _nId, const ::com::sun::star::uno::Type	&_Type, long _nFlags, sal_Int8 _nMemberId)
		:sName(_sName) ,nId(_nId) ,m_aType(_Type) ,nFlags(_nFlags) ,nMemberId(_nMemberId)
	{ }
	DBBasePropertyMap() : nId(0), nFlags(0), nMemberId(0) { }
};


#define DECL_DB_PROPMAP( _PropName )															\
typedef DBBasePropertyMap _PropName##PropMap;													\
	class _PropName##PropertySetInfo : public ::cppu::WeakImplHelper1< ::com::sun::star::beans::XPropertySetInfo> \
{																								\
	const _PropName##PropMap*	mpMap;															\
																								\
	public:																						\
																								\
																								\
								_PropName##PropertySetInfo( const _PropName##PropMap* pMap );	\
																								\
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> SAL_CALL getProperties();			\
	::com::sun::star::beans::Property 	SAL_CALL getPropertyByName(const ::rtl::OUString& aPropertyName);			\
	sal_Bool			SAL_CALL hasPropertyByName(const ::rtl::OUString& Name);				\
};

// ------------------------------------------------------------------------
#define IMPL_DB_PROPMAP( _PropName, _PROP_COUNT )											\
_PropName##PropertySetInfo::##_PropName##PropertySetInfo( const _PropName##PropMap* pMap ) :\
	mpMap( pMap )																			\
{																							\
}																							\
																							\
::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> SAL_CALL _PropName##PropertySetInfo::getProperties() 						\
{																							\
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property>	aPropSeq( _PROP_COUNT );											\
	sal_uInt16				n = 0;																\
																							\
	for( const _PropName##PropMap* pMap = mpMap; pMap->sName.getLength(); ++pMap, n++ )					\
	{																						\
		aPropSeq.getArray()[n].Name = pMap->sName;											\
		aPropSeq.getArray()[n].Handle = pMap->nId;											\
		aPropSeq.getArray()[n].Type = pMap->m_aType;										\
		aPropSeq.getArray()[n].Attributes = pMap->nFlags;									\
	}																						\
																							\
	return aPropSeq;																		\
}																							\
																							\
::com::sun::star::beans::Property SAL_CALL _PropName##PropertySetInfo::getPropertyByName( const ::rtl::OUString &rName ) 		\
{																							\
	::com::sun::star::beans::Property	aProp;																		\
																							\
	for( const _PropName##PropMap* pMap = mpMap; pMap->sName.getLength(); ++pMap )						\
	{																						\
		if( rName.equals(pMap->sName) )															\
		{																					\
			aProp.Name = rName;																\
			aProp.Handle = pMap->nId;														\
			aProp.Type = pMap->m_aType;														\
			aProp.Attributes = pMap->nFlags;												\
			break;																			\
		}																					\
	}																						\
																							\
	return aProp;																			\
}																							\
																							\
sal_Bool SAL_CALL _PropName##PropertySetInfo::hasPropertyByName( const ::rtl::OUString &rName ) 		\
{																							\
	for( const _PropName##PropMap* pMap = mpMap; pMap->sName.getLength(); ++pMap )			\
	{																						\
		if( rName.equals(pMap->sName) )														\
			return sal_True;																\
	}																						\
	return sal_False;																		\
}
																							
// ------------------------------------------------------------------------

#define DECL_DB_PROPSET() virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  SAL_CALL getPropertySetInfo(void)

#define IMPL_DB_PROPSET( _PropName )														\
::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > SAL_CALL _PropName##Content::getPropertySetInfo(void) \
{																							\
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  aRef( new _PropName##PropertySetInfo( a##_PropName##Map_Impl ) );	\
	return aRef;																			\
}

// -------------------
// - OfaDatabaseGuard
// a class for guarding a database access sequence
// (we can't use SdbDatabaseGuard as we aren't linked against SDB)
// -------------------
class OfaDatabaseGuard
{
private:
	SdbDatabaseGuard*	m_pSdbGuard;
public:
	OfaDatabaseGuard(SdbDatabase* _pDB) { m_pSdbGuard = _pDB ? SBAEXPL()->CreateDatabaseGuard(_pDB) : NULL; }
	~OfaDatabaseGuard() { clear(); }

	void clear() { if (m_pSdbGuard) delete m_pSdbGuard; m_pSdbGuard = NULL; }
};

// -------------------
// - SbaThreadSafeLink
// -------------------
class SbaThreadSafeLink : public SvRefBase
{
	Link										m_aHandler;
	::vos::OThread::TThreadIdentifier	m_nThreadId;

	sal_uInt32					m_nExecutionEvent;
	::osl::Mutex	m_aEventIdSafety;
	::osl::Mutex	m_aGeneralAccessSafety;

public:
	SbaThreadSafeLink(const Link& _rToCall, ::vos::OThread::TThreadIdentifier _nThreadToExecuteIn);
		// _nThreadToExecuteIn should be the handle of a thread which does message looping as we have to rely on a posted message ...

	long Call(void* _pArgs = NULL);
		// Will call the link within the thread given by m_nThreadId, no matter which thread calls this method.
		// This method is async.
		// If the thread given by m_nThreadId does no message looping the call will never be done !!

	long CallAndWait(void* _pArgs = NULL);
		// Same restrictions as for Call. Additinally this methods waits 'til the call is done.

	sal_Bool	IsPendingCall() { ::osl::ClearableMutexGuard aGuard(m_aGeneralAccessSafety); return (m_nExecutionEvent != 0); }
	void	KillPendingCall();

protected:
	virtual ~SbaThreadSafeLink();
	DECL_LINK(OnExecute, void*);
};

// -------------------
// - SbaXChaosContent -
// -------------------
class SbaXChaosContent;
class SbaXChaosContent	:   public ::cppu::WeakComponentImplHelper3< ::com::sun::star::chaos::XURLContent,
															::com::sun::star::chaos::XCommandExecutor,
															::com::sun::star::beans::XPropertySet>
							
{

	const DBBasePropertyMap*	pMap;

protected:
	::osl::Mutex						m_aMutex;
	
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 				xParent;
	::rtl::OUString						aUrl;
	::rtl::OUString						aTitle;
	::rtl::OUString						aContentType;
	
	::cppu::OMultiTypeInterfaceContainerHelperVar< ::rtl::OUString,::utl::UStringHash, ::utl::UStringEqual>					
										aPropertyListeners;
	
	DirEntry							aDatabasePath;
	SbaDatabaseRef						xDatabase;
	::com::sun::star::uno::Any			aMenu;
										
	sal_Bool							bHasFolder,
										bDisposed;
										
	sal_Int32							nOpenCounter;
										
	XubString							m_sWizardName;
	sal_uInt16							m_nWizardContext;
										
	sal_uInt16							m_nSmallBitmapId;
	sal_uInt16							m_nLargeBitmapId;

	// As we have no thread-safe way to load bitmaps and chaos is multi threaded, we load _all_
	// bitmaps ever used by any SbaXChaosContent instances whenevenr the first instance is created.
	// At this moment we can lock the solar mutex and thus load the bitmaps without danger ...
	// It's ugly, isn't it ?
	typedef ::std::map<sal_uInt16, Bitmap, ::std::less<sal_uInt16> >	BitmapCache;
	typedef BitmapCache::iterator												BitmapCacheIterator;
	typedef BitmapCache::const_iterator											ConstBitmapCacheIterator;
	static	BitmapCache m_sAllBitmaps;

public:
	SbaXChaosContent(const DBBasePropertyMap* _pMap, sal_Bool _bHasFolder);
	virtual ~SbaXChaosContent();

	// interface  ::com::sun::star::container::XChild
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL getParent() ;
	virtual void				SAL_CALL setParent( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & Parent );

	//	Component - Interface
	virtual void				SAL_CALL dispose(void);

	// interface  ::com::sun::star::beans::XPropertySet
	virtual	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  SAL_CALL getPropertySetInfo() ;
	virtual void				SAL_CALL addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
														   const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener );
	virtual void				SAL_CALL removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
															  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & aListener );
	virtual void				SAL_CALL addVetoableChangeListener( const ::rtl::OUString& aPropertyName,
														   const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener );
	virtual void				SAL_CALL removeVetoableChangeListener( const ::rtl::OUString& aPropertyName,
															  const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & aListener );

	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
	virtual sal_Bool			_setPropertyValue( sal_uInt16 _nID, const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue );

	// interface  ::com::sun::star::chaos::XURLContent
	virtual ::rtl::OUString		SAL_CALL getURL();
	virtual sal_Bool			_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
											 const INetURLObject& rUrlObj);

	// interface  ::com::sun::star::chaos::XCommandExecutor
	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL queryCommands() = 0;

	virtual void				SAL_CALL cancel( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & CommandId );
	virtual void				executeImpl( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

	sal_Bool					callNewObjectWizard();
		// sal_False if a wizard call is already pending
private:
	// don't overwrite execute, use executeImpl instead
	// do prevent calling the base method in a derived class we made this private ...
	virtual void				SAL_CALL execute( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

protected:
	// standard commands
	virtual sal_Bool			destroy(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam);
	virtual sal_Bool			open( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
									  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									  const ::com::sun::star::uno::Any& rParam );
	virtual void				close( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
									  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									  const ::com::sun::star::uno::Any& rParam );
	virtual sal_Bool			rename( const ::rtl::OUString& rName);
	virtual void				actualize(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam) = 0;

	virtual void				prepareMenu(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
											const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
											const ::com::sun::star::uno::Any& rParam);

	virtual sal_Bool			prepareMove(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
											const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
											const ::com::sun::star::uno::Any& rParam);

	virtual void				createPopup( ::com::sun::star::uno::Any& rAny ) const;
	SbaDatabase*				getDatabase(sal_Bool bShowError, sal_Bool bRegisterOnParent = sal_True);

	virtual void				CloseImpl();

private:
	Bitmap	getLargeBitmap() const;	// m_nLargeBitmapId
	Bitmap	getSmallBitmap() const;	// m_nSmallBitmapId

	// ------------------
	struct WizardCallData
	{
		sal_uInt32			nEventId;	// the id for the async event
		SbaXChaosContent*	pOwner;		// the SbaXChaosContent which did the call

		WizardCallData() : nEventId(0), pOwner(NULL) { }
	};
	static WizardCallData			s_aWizardCall;
	static ::osl::Mutex	s_aWizardProtection;
	DECL_STATIC_LINK(SbaXChaosContent, ImplCallWizard, void*);

	// ---------------------
	struct ExecuteParameters
	{
		::rtl::OUString				sCommand;
		::com::sun::star::uno::Any				aParam;
		::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > 	xCallback;
	};
	struct SetPropertyParams
	{
		sal_Bool		bSet;			// sal_True -> set, sal_False -> get
		sal_uInt16		nPropId;		// property id
		::rtl::OUString		sPropName;		// property name
		::com::sun::star::uno::Any		aValueOrReturn;	// property value or return value
	};
	ExecuteParameters*		m_pCurrentExecParams;
	SetPropertyParams*		m_pPropertyParams;
	::osl::Mutex	m_aExecuteSafety;		// secures the execute method
	::osl::Mutex	m_aParamsAccessSafety;	// secures the access to m_pCurrentExecParams/m_pPropertyParams
	SbaThreadSafeLink*		m_pSolarThreadExecutor;

	DECL_LINK(OnExecuteInDeterminedThread, void*);

public:
	//	Methoden die durch interne ueberlagert werden
	virtual sal_Bool			SAL_CALL initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL );
	virtual ::com::sun::star::uno::Any	SAL_CALL getPropertyValue( const ::rtl::OUString& aPropertyName );
	virtual void				SAL_CALL setPropertyValue( const ::rtl::OUString& aPropertyName, const ::com::sun::star::uno::Any& aValue );
};

// -------------------
// - SbaXContainer -
// -------------------
class SbaXContainer : public ::com::sun::star::chaos::XExplorerExchange,
					  public SfxListener,
					  public SbaXChaosContent
{
protected:
	DBObject				eObj;
	SbaExplorerExchObjList	lstpDataExchObjects;
	SvStorageStreamRef		m_Stream;
	sal_uInt32					nCopyMoveEvent;

	enum REQUESTED_ACTION { RA_COPY, RA_MOVE };
	REQUESTED_ACTION	aRequestedAction;

public:
	SbaXContainer(const DBBasePropertyMap* _pMap, DBObject _eObj);
	virtual ~SbaXContainer();

	DECLARE_UNO3_DEFAULTS(SbaXContainer, SbaXChaosContent);

	virtual ::com::sun::star::uno::Any	SAL_CALL queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes() throw (::com::sun::star::uno::RuntimeException);

	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL queryCommands();

	// ::com::sun::star::chaos::XExplorerExchange
	virtual ::com::sun::star::uno::Any	SAL_CALL createDataObject(sal_uInt16& nSourceOptions);
	virtual sal_uInt16			SAL_CALL insertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions);
	virtual sal_Bool			SAL_CALL queryInsertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions, sal_uInt16& nResultingAction, sal_uInt16& nDefaultAction);

	virtual void				SAL_CALL dispose(void);

protected:
	virtual void				SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType,
										   const SfxHint& rHint, const TypeId& rHintType );

	virtual sal_Bool			open( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
									  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									  const ::com::sun::star::uno::Any& rParam );
	virtual void				actualize(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam);
	// tools
	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
	virtual sal_Bool				_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
											 const INetURLObject& rUrlObj);

	virtual void				CloseImpl();

private:
	DECL_LINK( OnCopyMove, void* );
	DECL_LINK( OnRTFCopyMove, void* );
	DECL_LINK( OnHTMLCopyMove, void* );
};

// -------------------
// - SbaXContent -
// -------------------
struct SdbUiActionDescription;
class SbaXContent : public ::com::sun::star::chaos::XExplorerExchange,
					public SbaXChaosContent
{
protected:
	DBObject		eObj;
	SbaDBDefRef		xDBObj;

	sal_Bool			m_bMayBeDeleted : 1;
		// bezeichne ich eventuell ein Objekt, das sich im Papierkorb befindet ?
		// (kann u.U. erst nach der ersten ausgefuehrten Operation entschieden werden)

public:
	SbaXContent(const DBBasePropertyMap* _pMap, DBObject _eObj)
		:SbaXChaosContent(_pMap, sal_False)
		,eObj(_eObj), m_bMayBeDeleted(sal_False) {};

	virtual ~SbaXContent();

	virtual ::com::sun::star::uno::Any	SAL_CALL queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes() throw (::com::sun::star::uno::RuntimeException);

	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL queryCommands();


	virtual void				executeImpl( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

	// ::com::sun::star::chaos::XExplorerExchange
	virtual ::com::sun::star::uno::Any				SAL_CALL createDataObject(sal_uInt16& nSourceOptions);
	virtual sal_uInt16			SAL_CALL insertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions);
	virtual sal_Bool			SAL_CALL queryInsertDataObject(const ::com::sun::star::uno::Any& pSotDataObjectPtr, sal_uInt16 nUserAction, sal_uInt16 nSourceOptions, sal_uInt16& nResultingAction, sal_uInt16& nDefaultAction);

protected:
	// ::com::sun::star::lang::XComponent
	virtual void SAL_CALL dispose(void);

	// commands
	virtual sal_Bool			destroy(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam);
	virtual sal_Bool			rename(const ::rtl::OUString& rName);
	virtual void				actualize(	const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
											const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
											const ::com::sun::star::uno::Any& rParam);
	virtual sal_Bool			restore(const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam);
	// tools
	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
	virtual sal_Bool			_initialize(const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
											const INetURLObject& rUrlObj);

	virtual void				CloseImpl();

	SbaDBDef* getObj();

	DECL_LINK( OnCoreMessage, SdbUiActionDescription* );
};

#endif
