/*************************************************************************
 *
 *  $RCSfile: dbdlgs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif
#ifndef _DBDLGS_HRC
#include "dbdlgs.hrc"
#endif
#ifndef _DBDLGS_HXX
#include "dbdlgs.hxx"
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif
#ifndef _SBA_DBDATDEF_HXX
#include "dbdatdef.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif
#ifndef _DBCOMMON_HXX
#include "dbcommon.hxx"
#endif
#ifndef _SFXSTRITEM_HXX //autogen wg. SfxStringItem
#include <svtools/stritem.hxx>
#endif

#define RET_OK	sal_True

//==================================================================
SbaXNewObjectDlg::SbaXNewObjectDlg( Window * pParent,
									SbaDatabase* pDB,
									const XubString& rTitle,
									DBObject eObj)
			:ModalDialog( pParent, OffResId(RID_OFA_TABNEW_DLG))
			,aGroup(this, ResId( GR_CHOICE) )
			,aDesign(this, ResId (RB_DESIGN))
			,aWizard(this, ResId (RB_WIZARD))
			,aPB_OK(this, ResId( PB_OK ) )
			,aPB_CANCEL(this, ResId( PB_CANCEL ))
			,aPB_HELP(this, ResId( PB_HELP))
			,eDBObj(eObj)
			,pDatabase(pDB)
{
	UniString aT = GetText();
	aT.SearchAndReplace("#", rTitle);
	SetText(aT);

	aDesign.SetClickHdl(LINK(this,SbaXNewObjectDlg,OnClick));
	aWizard.SetClickHdl(LINK(this,SbaXNewObjectDlg,OnClick));
	aPB_OK.SetClickHdl(LINK(this,SbaXNewObjectDlg,OnClick));

	if (eObj == dbView) // fuer Views gibts noch keinen Wizard
	{
		aDesign.Disable();
		aWizard.Disable();
	}

	FreeResource();
}

IMPL_LINK(SbaXNewObjectDlg, OnClick, Button *, pButton )
{
	if( pButton == &aDesign ||
		pButton == &aWizard)
	{
	}
	else if (pButton == &aPB_OK)
	{
		EndDialog(RET_OK);
	}
	return 0;
}


//==================================================================
SbaXNewFormDlg::SbaXNewFormDlg( Window * pParent )
			:ModalDialog( pParent, OffResId(RID_OFA_FORMNEW_DLG))
			,aGroup(this, ResId( GR_CHOICE) )
			,aDocList(this, ResId( GR_CHOICE) )
			,aPB_OK(this, ResId( PB_OK ) )
			,aPB_CANCEL(this, ResId( PB_CANCEL ))
			,aPB_HELP(this, ResId( PB_HELP))
{
	aPB_OK.SetClickHdl(LINK(this,SbaXNewFormDlg,OnClick));
	aDocList.SetDoubleClickHdl(LINK(this,SbaXNewFormDlg,OnDoubleClick));
	FreeResource();
}

IMPL_LINK(SbaXNewFormDlg, OnDoubleClick, ListBox *, pLb )
{
	EndDialog(RET_OK);
	return 0;
}

IMPL_LINK(SbaXNewFormDlg, OnClick, Button *, pButton )
{
	EndDialog(RET_OK);
	return 0;
}
/* -----------------09.07.98 16:31-------------------
 *
 * --------------------------------------------------*/

SbaXTablePropertieDlg::SbaXTablePropertieDlg( Window* pParent, SbaDatabaseRef xDB, XubString& rTabName) :
	SfxTabDialog    (pParent, OffResId( RID_OFA_TABPROPERTIES ), 0),
	xDatabase		(xDB),
	rTableName		(rTabName)
{
	FreeResource();
	AddTabPage( OFA_TP_TABPROPERTIES_GENERAL, SbaTablePropGeneralPage::Create, 0 );
	AddTabPage( OFA_TP_TABPROPERTIES_TEXT, SbaTablePropTextPage::Create, 0 );

	XubString aText( GetText() );
	aText += rTableName;
	SetText( aText );
}

// ------------------------------------------------------------------------

void SbaXTablePropertieDlg::PageCreated( sal_uInt16 nId, SfxTabPage &rPage )
{
	if( OFA_TP_TABPROPERTIES_GENERAL == nId )
		( (SbaTablePropGeneralPage&) rPage ).SetData( xDatabase, rTableName );
	else if(OFA_TP_TABPROPERTIES_TEXT == nId )
		( (SbaTablePropTextPage&) rPage ).SetData( xDatabase, rTableName );
}

/* -----------------09.07.98 16:48-------------------
 *
 * --------------------------------------------------*/

SbaTablePropGeneralPage::SbaTablePropGeneralPage( Window* pParent, const SfxItemSet& rSet ) :
			SfxTabPage              ( pParent, OffResId( OFA_TP_TABPROPERTIES_GENERAL ), rSet ),
			aFiMSImage              ( this, ResId( FI_MS_IMAGE ) ),
			aEdtMSName              ( this, ResId( EDT_MS_NAME ) ),
			aFlMSGeneralFirst       ( this, ResId( FL_MS_GENERAL_FIRST ) ),
			aFtMSType               ( this, ResId( FT_MS_TYPE ) ),
			aFtMSShowType           ( this, ResId( FT_MS_SHOW_TYPE ) ),
			aFtMSPath               ( this, ResId( FT_MS_PATH ) ),
			aFtMSShowPath           ( this, ResId( FT_MS_SHOW_PATH ) ),
			aFlMSGeneralSecond      ( this, ResId( FL_MS_GENERAL_SECOND ) ),
			aCbRead      			( this, ResId( CB_PROP_READ ) ),
			aCbInsert      			( this, ResId( CB_PROP_INSERT ) ),
			aCbUpdate      			( this, ResId( CB_PROP_UPDATE ) ),
			aCbDelete      			( this, ResId( CB_PROP_DELETE ) ),
			aCbAlter      			( this, ResId( CB_PROP_ALTER ) ),
			aCbDrop      			( this, ResId( CB_PROP_DROP ) ),
			aCbReferences      		( this, ResId( CB_PROP_REFERENCES ) ),
			aViewType				( ResId( STR_VIEW_TYPE ) )
{
	FreeResource();
}

// ------------------------------------------------------------------------

void SbaTablePropGeneralPage::SetData(SbaDatabaseRef xDB, XubString& rTabName)
{
	xDatabase = xDB;
	sTableName = rTabName;
}

// ------------------------------------------------------------------------

void SbaTablePropGeneralPage::Reset( const SfxItemSet& )
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	aEdtMSName.SetText(sTableName);

	XubString sDBPath(xDatabase->Name());
	sDBPath += " (";
	sDBPath += xDatabase->Title();
	sDBPath += ')';
	aFtMSShowPath.SetText(sDBPath);

	SdbTableRef xTbl = (SdbTable*)xDatabase->OpenObject(dbTable, sTableName);

	if (xTbl.Is())
	{
		sal_uInt16 nPrivs = xTbl->GetTablePrivileges();

		aCbRead.Check((nPrivs & SDB_PR_READ) != 0);
		aCbInsert.Check((nPrivs & SDB_PR_INSERT) != 0);
		aCbUpdate.Check((nPrivs & SDB_PR_UPDATE) != 0);
		aCbDelete.Check((nPrivs & SDB_PR_DELETE) != 0);
		aCbAlter.Check((nPrivs & SDB_PR_ALTER) != 0);
		aCbDrop.Check((nPrivs & SDB_PR_DROP) != 0);
		aCbReferences.Check((nPrivs & SDB_PR_REFERENCES) != 0);
		// Image setzen
		sal_uInt16 nType=RID_BMP_DB_TABLE_L;
		if(xTbl->IsView())
		{
			aFtMSShowType.SetText(aViewType);
			nType=RID_BMP_DB_VIEW_L;
		}
		aFiMSImage.SetImage( Image( Bitmap( OffResId( nType ) ), COL_LIGHTMAGENTA ) );
	}

	aOldHdl = aCbRead.GetToggleHdl();
	Link aLk = LINK(this, SbaTablePropGeneralPage, ToggleHdl);
	aCbRead.SetToggleHdl(aLk);
	aCbInsert.SetToggleHdl(aLk);
	aCbUpdate.SetToggleHdl(aLk);
	aCbDelete.SetToggleHdl(aLk);
	aCbAlter.SetToggleHdl(aLk);
	aCbDrop.SetToggleHdl(aLk);
	aCbReferences.SetToggleHdl(aLk);
}

// ------------------------------------------------------------------------

IMPL_LINK( SbaTablePropGeneralPage, ToggleHdl, CheckBox *, pCB )
{
	pCB->SetToggleHdl(aOldHdl);	// Rekursion vermeiden
	pCB->SetState((TriState)((sal_uInt16)pCB->GetState() ^ 1));
	pCB->SetToggleHdl(LINK(this, SbaTablePropGeneralPage, ToggleHdl));

	return 0;
}

// ------------------------------------------------------------------------

sal_Bool SbaTablePropGeneralPage::FillItemSet( SfxItemSet& rSet )
{
	return sal_False;
}

// ------------------------------------------------------------------------

SfxTabPage* SbaTablePropGeneralPage::Create( Window* pParent, const SfxItemSet& rSet )
{
	return new SbaTablePropGeneralPage( pParent, rSet );
}
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
SbaTablePropTextPage::SbaTablePropTextPage( Window* pParent, const SfxItemSet& rSet ) :
			SfxTabPage  ( pParent, OffResId( OFA_TP_TABPROPERTIES_TEXT ), rSet ),
			m_MLDesc    ( this, ResId( EDT_DESC ) ),
			m_FTDesc    ( this, ResId( FT_DESC ) )
{
	FreeResource();
}

// ------------------------------------------------------------------------

void SbaTablePropTextPage::SetData(SbaDatabaseRef xDB, XubString& rTabName)
{
	xDatabase = xDB;
	sTableName = rTabName;
}

// ------------------------------------------------------------------------

void SbaTablePropTextPage::Reset( const SfxItemSet& )
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	SbaTableDefRef xTbl = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, sTableName);

	if (xTbl.Is())
	{
		SfxStringItem aPropItem	(*PTR_CAST(SfxStringItem,&xTbl->GetObjAttrs()->Get( SBA_DEF_TABLEPROP )));
		m_MLDesc.SetText(aPropItem.GetValue());
	}
}

// ------------------------------------------------------------------------

sal_Bool SbaTablePropTextPage::FillItemSet( SfxItemSet& rSet )
{
	return sal_False;
}

// ------------------------------------------------------------------------

SfxTabPage* SbaTablePropTextPage::Create( Window* pParent, const SfxItemSet& rSet )
{
	return new SbaTablePropTextPage( pParent, rSet );
}

