/*************************************************************************
 *
 *  $RCSfile: dbdlgs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBDLGS_HXX
#define _DBDLGS_HXX

#ifndef _SBA_DBDEFOBJ_HXX
#include "dbdefobj.hxx"
#endif

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen wg. MultiLineEdi
#include <svtools/svmedit.hxx>
#endif

class SbaXNewObjectDlg : public ModalDialog
{
	SbaDatabase* pDatabase;
	DBObject eDBObj;

public:
	GroupBox	aGroup;
	RadioButton	aDesign;
	RadioButton	aWizard;

	OKButton		aPB_OK;
	CancelButton	aPB_CANCEL;
	HelpButton		aPB_HELP;

public:
	SbaXNewObjectDlg(Window * pParent,
				SbaDatabase* pDB,
				const XubString& rTitle,
				DBObject eObj);

private:
	DECL_LINK(OnClick, Button *);
};

class SbaXNewFormDlg : public ModalDialog
{
	SbaDatabase* pDatabase;

public:
	GroupBox		aGroup;
	ListBox			aDocList;

	OKButton		aPB_OK;
	CancelButton	aPB_CANCEL;
	HelpButton		aPB_HELP;

public:
	SbaXNewFormDlg(Window * pParent);

private:
	DECL_LINK(OnDoubleClick, ListBox *);
	DECL_LINK(OnClick, Button *);
};

// ------------------------------------------------------------------------

class SbaXTablePropertieDlg : public SfxTabDialog
{
	SbaDatabaseRef xDatabase;
	XubString& rTableName;

	virtual void	PageCreated( sal_uInt16 nId, SfxTabPage &rPage );

public:
	SbaXTablePropertieDlg( Window* pParent, SbaDatabaseRef xDB, XubString& rTabName);
	~SbaXTablePropertieDlg() {}
};

// ------------------------------------------------------------------------

class SbaTablePropGeneralPage : public SfxTabPage
{
	FixedImage			aFiMSImage;
	Edit				aEdtMSName;
	FixedLine			aFlMSGeneralFirst;
	FixedText			aFtMSType;
	FixedText			aFtMSShowType;
	FixedText			aFtMSPath;
	FixedText			aFtMSShowPath;
	FixedLine			aFlMSGeneralSecond;
	CheckBox			aCbRead;
	CheckBox			aCbInsert;
	CheckBox			aCbUpdate;
	CheckBox			aCbDelete;
	CheckBox			aCbAlter;
	CheckBox			aCbDrop;
	CheckBox			aCbReferences;
	XubString			aViewType;

	Link				aOldHdl;
	SbaDatabaseRef		xDatabase;
	XubString			sTableName;

	DECL_LINK(ToggleHdl, CheckBox*);

	virtual void		Reset( const SfxItemSet& );
	virtual sal_Bool        FillItemSet( SfxItemSet& rSet );

public:
						SbaTablePropGeneralPage( Window* pParent, const SfxItemSet& rSet  );
						~SbaTablePropGeneralPage() {}

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );

	void				SetData(SbaDatabaseRef xDB, XubString& rTabName);
};

// ------------------------------------------------------------------------

class SbaTablePropTextPage : public SfxTabPage
{
	MultiLineEdit		m_MLDesc;
	FixedText			m_FTDesc;
	SbaDatabaseRef		xDatabase;
	XubString				sTableName;

	virtual void		Reset( const SfxItemSet& );
	virtual sal_Bool        FillItemSet( SfxItemSet& rSet );

public:
						SbaTablePropTextPage( Window* pParent, const SfxItemSet& rSet  );
						~SbaTablePropTextPage() {}

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );

	void				SetData(SbaDatabaseRef xDB, XubString& rTabName);
};

#endif

