/*************************************************************************
 *
 *  $RCSfile: dbform.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBFORM_HXX
#include "dbform.hxx"
#endif

#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif


#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _DBDLGS_HXX
#include <dbdlgs.hxx>
#endif

#ifndef _SBASLTID_HRC
#include <sbasltid.hrc>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFXNEW_HXX //autogen
#include <sfx2/new.hxx>
#endif

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

#ifndef _DBCOMMON_HRC_
#include "dbcommon.hrc"
#endif

// locale functions
// ------------------------------------------------------------------------
static XubString getUniqueName(const SbaDatabaseRef& _xDatabase)
{
	XubString aNewName	= XubString(OfsStringRes(RID_STR_NAME_FORM));
	sal_uInt16 nIndex = aNewName.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		aNewName.Erase(nIndex, 1);
	return _xDatabase ? _xDatabase->GetUniqueName(dbTable, aNewName) : XubString();
}


const sal_uInt32 WIZARD		= 0;
const sal_uInt32 WRITER		= 1;
const sal_uInt32 CALC		= 2;
const sal_uInt32 IMPRESS	= 3;
const sal_uInt32 TEMPLATE	= 4;

// ------------------------------------------------------------------------
sal_Bool newForm(SbaXChaosContent* pJobStarter, const SbaDatabaseRef _xDatabase, sal_Int32 nType = -1)
{
	if (nType == -1)
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		SbaXNewFormDlg aDlg(Application::GetAppWindow());

		ListBox& rList = aDlg.aDocList;
		rList.SetEntryData(0, (void*)&WIZARD);
		rList.SetEntryData(1, (void*)&WRITER);
		rList.SetEntryData(2, (void*)&CALC);
		rList.SetEntryData(3, (void*)&IMPRESS);

		if (!SFX_APP()->HasFeature( SFX_FEATURE_SIMPRESS ) )
			rList.RemoveEntry(3);

		if (!SFX_APP()->HasFeature( SFX_FEATURE_SCALC  ) )
			rList.RemoveEntry(2);

		if (!aDlg.Execute())
			return sal_False;

		sal_uInt16 nPos = rList.GetSelectEntryPos();
		nType = *(sal_uInt32*)rList.GetEntryData(nPos);
	}

	XubString aFormFactory;

	switch (nType)
	{
		case WIZARD:
			pJobStarter->callNewObjectWizard();
			return sal_True;
		case WRITER:
			aFormFactory = "private:factory/swriter";
			break;
		case CALC:
			aFormFactory = "private:factory/scalc";
			break;
		case IMPRESS:
			aFormFactory = "private:factory/simpress";
			break;
		case TEMPLATE:
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			SfxNewFileDialog dlg(Application::GetAppWindow());
			if (dlg.Execute() != RET_OK)
				return sal_False;
			aFormFactory = dlg.GetTemplateFileName();
		}
	}

	SbaDBDefRef	xDBObj = _xDatabase->CreateDBDef(dbForm, getUniqueName(_xDatabase));
	if (xDBObj.Is())
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		SfxApplication *pSApp = SFX_APP();
		SfxAllItemSet aSet(pSApp->GetPool());
		INetURLObject aObj;
		aObj.SetSmartProtocol(INET_PROT_PRIVATE);
		aObj.SetURL("private:factory/form", sal_False);

		XubString aParam = xDBObj->ToURL();
		aParam += ';';
		aParam += aFormFactory;
		// HashMarks within ::com::sun::star::util::URL params have to be quoted (the ::com::sun::star::util::URL of the xDBObj contains a hash mark)
		// FS - 69717 - 19.11.99
		aObj.SetParam(INetURLObject::encode(aParam, INetURLObject::PART_URIC, '%', INetURLObject::ENCODE_ALL));
		aSet.Put(SfxStringItem( SID_FILE_NAME, aObj.GetMainURL()),SID_FILE_NAME);
		aSet.Put(SfxStringItem( SID_REFERER, "private:"), SID_REFERER);
		//	pSApp->GetAppDispatcher().Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON, aSet);
	}
	return sal_True;
}


sal_uInt32 includeNewFormMenu(const SbaDatabaseRef xDatabase, ::com::sun::star::chaos::MenuItemDescriptor* pBase, sal_uInt32 nFirstItem)
{
	if (!xDatabase.Is() || xDatabase->IsReadOnly())
		return nFirstItem;

	sal_Bool bHasWriter = SFX_APP()->HasFeature(SFX_FEATURE_SWRITER);
	sal_Bool bHasCalc = SFX_APP()->HasFeature(SFX_FEATURE_SCALC);
	sal_Bool bHasImpress = SFX_APP()->HasFeature(SFX_FEATURE_SIMPRESS);

	if (!bHasWriter && !bHasCalc && !bHasImpress)
		return nFirstItem;

	sal_uInt32 nItem = nFirstItem;

	pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NEW)));
	pBase[nItem].Command		;
	pBase[nItem].HelpUrl		;
	pBase[nItem].ParentPos		= 0;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= 0;

	pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_FORM)));
	pBase[nItem].Command		;
	pBase[nItem].HelpUrl		;
	pBase[nItem].ParentPos		= nFirstItem + 1;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= 0;

	if (bHasWriter)
	{
		pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_NEW_TEXTDOC)));
		pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newFormTextDocument");
		pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_NEWTEXTFORM);
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= 0;
	}

	if (bHasCalc)
	{
		pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_NEW_CALCDOC)));
		pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newFormCalcDocument");
		pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_NEWCALCFORM);
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= 0;
	}

	if (bHasImpress)
	{
		pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_NEW_IMPRESSDOC)));
		pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newFormImpressDocument");
		pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_NEWIMPRESSFORM);
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= 0;
	}

	if (nItem > 3)
	{
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= CNT_COMPMENU_SEPARATOR;
	}

	pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_NEW_TEMPLATE)));
	pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newFormTemplateDocument");
	pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_NEWTEMPLATEFORM);
	pBase[nItem].ParentPos		= nFirstItem + 2;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= 0;

	if (bHasWriter)
	{
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

		pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_NEW_AUTODOC)));
		pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newFormAutoPilot");
		pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_NEWAUTOFORM);
		pBase[nItem].ParentPos		= nFirstItem + 2;
		pBase[nItem].InsertionPos	= 0;
		pBase[nItem++].ItemFlags	= 0;
	}

	pBase[nItem].ParentPos		= 0;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	return nItem;
}

// --------------------
// - SbaXFormsContent -
// --------------------

#define DBFORMS_PROP_COUNT		14

const SbaXFormsPropMap aSbaXFormsMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_DELETEME,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_NEWCHILD,
	SBA_PROP_OWNURL,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_USERSORTCRITERIUM,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------

IMPL_DB_PROPMAP( SbaXForms, DBFORMS_PROP_COUNT );
IMPL_DB_PROPSET( SbaXForms );

// ------------------------------------------------------------------------
SbaXFormsContent::SbaXFormsContent()
				 :SbaXContainer(aSbaXFormsMap_Impl, dbForm)
{
	aTitle = ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_FORMS)));
	aContentType = ::rtl::OUString("application/sbase-forms;") + aTitle;

	m_sWizardName = "FormWizard.FormWizard.MainWithDefault";
	m_nWizardContext = ERROR_START_FORMWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_FORMFOLDER_L;
	m_nSmallBitmapId = RID_BMP_DB_FORMFOLDER_S;
}

// ------------------------------------------------------------------------
void SbaXFormsContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);

	if (aCmd == ::rtl::OUString::createFromAscii("newFormTextDocument"))
		newForm(this, xDatabase, WRITER );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormCalcDocument"))
		newForm(this, xDatabase, CALC );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormImpressDocument"))
		newForm(this, xDatabase, IMPRESS );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormTemplateDocument"))
		newForm(this, xDatabase, TEMPLATE );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormAutoPilot"))
		newForm(this, xDatabase, WIZARD );
	else
	{
		SbaXContainer::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	rCallback->done( aEvt );
}

// ------------------------------------------------------------------------
void SbaXFormsContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	const int nItems(15);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	i = includeNewFormMenu(xDatabase, aMenu, i);

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("actualize");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_ACTUALIZE);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXFormsContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_USERSORTCRITERIUM:
		{
			aAny <<= ::rtl::OUString::createFromAscii("0");
			break;
		}
		default:
			return SbaXContainer::_getPropertyValue( _nID );
	}
	return aAny;
}

// ---------------------
// - SbaXFormContent -
// ---------------------
#define DBFORM_PROP_COUNT		14

const SbaXFormPropMap aSbaXFormMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	//SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_SHOW_IN_EXPLORER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_OWNURL,
	SBA_PROP_RENAME,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_FLAGS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXForm, DBFORM_PROP_COUNT );
IMPL_DB_PROPSET( SbaXForm );

// ------------------------------------------------------------------------
SbaXFormContent::SbaXFormContent()
				:SbaXContent(aSbaXFormMap_Impl, dbForm)
{
	// aus dem Namen fuer Formulare das ~ entfernen (in der Resource ist es als Menu-Text gespeichert)
	UniString strContentSubType(OfsStringRes(RID_STR_NAME_FORM));
	sal_uInt16 nIndex = strContentSubType.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		strContentSubType.Erase(nIndex, 1);

	aContentType = ::rtl::OUString("application/sbase-form;") + ::rtl::OUString(strContentSubType);
	m_sWizardName = "FormWizard.FormWizard.MainWithDefault";
	m_nWizardContext = ERROR_START_FORMWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_FORM_L;
	m_nSmallBitmapId = RID_BMP_DB_FORM_S;
}

// ------------------------------------------------------------------------
sal_Bool SbaXFormContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
								   const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_FORMMARK_HEADER));
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXFormContent::queryCommands()
{
	::com::sun::star::uno::Sequence<::rtl::OUString> seqCommands(7);

	sal_Bool bWriterInstalled = SFX_APP()->HasFeature(SFX_FEATURE_SWRITER);
	sal_Bool bCanModify = !xDatabase->IsReadOnly();

	::rtl::OUString* pustrCommans = seqCommands.getArray();
	sal_uInt32 i = 0;
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("close");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("copy");
	if (bCanModify)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("delete");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("initialize");
	if (bWriterInstalled)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("open");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("prepareMenu");
	if (bCanModify)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("rename");
//	if (bCanModify)
//		pustrCommans[i++] = ::rtl::OUString::createFromAscii("undelete");

	return seqCommands;
}

// ------------------------------------------------------------------------
void SbaXFormContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool	bResult = sal_True;

	if (aCmd == ::rtl::OUString::createFromAscii("newFormTextDocument"))
		newForm(this, xDatabase, WRITER );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormCalcDocument"))
		newForm(this, xDatabase, CALC );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormImpressDocument"))
		newForm(this, xDatabase, IMPRESS );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormTemplateDocument"))
		newForm(this, xDatabase, TEMPLATE );
	else if (aCmd == ::rtl::OUString::createFromAscii("newFormAutoPilot"))
		newForm(this, xDatabase, WIZARD );
	else if( aCmd == ::rtl::OUString::createFromAscii("showLayout") )
		bResult = showLayout(aEvt, rCallback, aParam );
	else
	{
		SbaXContent::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
void SbaXFormContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	const int nItems(15);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	// sicherstellen da die Tabelle existiert
	((SbaXFormContent*)this)->getObj();

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	i = includeNewFormMenu(xDatabase, aMenu, i);

	if (xDBObj.Is() && SFX_APP()->HasFeature(SFX_FEATURE_SWRITER) && !xDatabase->IsReadOnly())
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_FRM_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("showLayout");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_FORM_LAYOUT);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= !xDBObj->IsLocked() ?	0 : CNT_COMPMENU_DISABLED;
	}

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

//-------------------------------------------------------------------------
sal_Bool SbaXFormContent::showLayout( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								   const ::com::sun::star::uno::Any& rParam )

{
	if (getObj() != NULL)
	{
		xDBObj->OpenDoc(sal_False, 0L);
		if(xDBObj->Status().IsError())
			SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
		return sal_True;
	}
	else
		return sal_False;
}

