/*************************************************************************
 *
 *  $RCSfile: dbinit.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//#ifndef _DB_HXX
//#include "db.hxx"
//#endif
//#ifndef _DBTABLE_HXX
//#include "dbtable.hxx"
//#endif
//#ifndef _DBQUERY_HXX
//#include "dbquery.hxx"
//#endif
//#ifndef _DBFORM_HXX
//#include "dbform.hxx"
//#endif
//#ifndef _DBREPORT_HXX
//#include "dbreport.hxx"
//#endif

#ifndef _SFXFRAME_HXX
#include <sfx2/frame.hxx>
#endif

//#ifndef _SV_UNOIFACE_HXX //autogen
//#include <toolkit/awt/vclxwindow.hxx>
//#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMELOADER_HPP_
#include <com/sun/star/frame/XFrameLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XLOADEVENTLISTENER_HPP_
#include <com/sun/star/frame/XLoadEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif
//#ifndef _SV_WINDOW_HXX
//#include <vcl/window.hxx>
//#endif

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif
#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif

#ifndef _SBA_SBAOBJ_HXX
#include <sbaobj.hxx>
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include <sbaexpob.hxx>
#endif
#ifndef _OFF_APP_HXX
#include "app.hxx"
#endif
#define	SBAOBJ()					\
	OFF_APP()->GetSbaObject()
#define	SBAEXPL()					\
	SBAOBJ()->GetSbaObjectExt()

// -------------------
// - DBContentLoader -
// -------------------
class DBContentLoader : public ::cppu::WeakImplHelper2< ::com::sun::star::frame::XFrameLoader, ::com::sun::star::lang::XServiceInfo>
{
private:
	::rtl::OUString																		aURL;
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>			aArgs;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > 	xListener;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > 				xFrame;

	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >	m_xServiceFactory;
public:
							DBContentLoader(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >&);
							~DBContentLoader();
	::rtl::OUString SAL_CALL	getImplementationName() throw(  );

	sal_Bool 		SAL_CALL	supportsService(const ::rtl::OUString& ServiceName) throw(  );
	::com::sun::star::uno::Sequence< ::rtl::OUString > 	SAL_CALL getSupportedServiceNames(void) throw(  );
	static ::rtl::OUString 			getImplementationName_Static() throw(  )
	{
		return ::rtl::OUString::createFromAscii("stardiv.offapp.DBContentLoader");
	}

	static ::com::sun::star::uno::Sequence< ::rtl::OUString>	getSupportedServiceNames_Static(void) throw(  );

	friend	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL DBContentLoader_CreateInstance( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > & rSMgr ) throw( ::com::sun::star::uno::Exception );

	// XLoader
	virtual void 	SAL_CALL 	load(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & aFrame, const ::rtl::OUString& aURL,
							const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs,
							const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > & aListener);
	virtual void 	SAL_CALL 	cancel(void);
};

DBContentLoader::DBContentLoader(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rxFactory)
	:m_xServiceFactory(_rxFactory)
{
}

DBContentLoader::~DBContentLoader()
{
}


::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL DBContentLoader_CreateInstance( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  & rSMgr ) throw( ::com::sun::star::uno::Exception )
{
	return *(new DBContentLoader(rSMgr));
}


// ::com::sun::star::lang::XServiceInfo
::rtl::OUString SAL_CALL DBContentLoader::getImplementationName() throw(  )
{
	return getImplementationName_Static();
}

// ::com::sun::star::lang::XServiceInfo
sal_Bool SAL_CALL DBContentLoader::supportsService(const ::rtl::OUString& ServiceName) throw(  )
{
	::com::sun::star::uno::Sequence< ::rtl::OUString > aSNL = getSupportedServiceNames();
	const ::rtl::OUString * pArray = aSNL.getConstArray();
	for( sal_Int32 i = 0; i < aSNL.getLength(); i++ )
		if( pArray[i] == ServiceName )
			return sal_True;
	return sal_False;
}

// ::com::sun::star::lang::XServiceInfo
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL DBContentLoader::getSupportedServiceNames(void) throw(  )
{
	return getSupportedServiceNames_Static();
}

// ORegistryServiceManager_Static
::com::sun::star::uno::Sequence< ::rtl::OUString > DBContentLoader::getSupportedServiceNames_Static(void) throw(  )
{
	::com::sun::star::uno::Sequence< ::rtl::OUString > aSNS( 2 );
	aSNS.getArray()[0] = ::rtl::OUString::createFromAscii("stardiv.one.frame.FrameLoader");
	aSNS.getArray()[1] = ::rtl::OUString::createFromAscii("stardiv.one.frame.DBContentLoader");
	return aSNS;
}

#define DECL_SERVICE(ImplName)																			\
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  ImplName##_CreateInstance_Impl();															\
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  ImplName##_CreateInstance (const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &) throw( ::com::sun::star::uno::Exception )\
{																										\
	return ImplName##_CreateInstance_Impl();															\
}

//DECL_SERVICE(SbaXDBContent);
//DECL_SERVICE(SbaXQueriesContent);
//DECL_SERVICE(SbaXQueryContent);
//DECL_SERVICE(SbaXReportsContent);
//DECL_SERVICE(SbaXReportContent);
//DECL_SERVICE(SbaXFormsContent);
//DECL_SERVICE(SbaXFormContent);
//DECL_SERVICE(SbaXTablesContent);
//DECL_SERVICE(SbaXTableContent);
//DECL_SERVICE(SbaXViewContent);
//DECL_SERVICE(SbaXStatementContent);
//DECL_SERVICE(SbaXRelationsContent);

//---------------------------------------------------------------------------------------
#define REGISTER_PROVIDER(classname, implName)															\
	{																									\
		::rtl::OUString aMainKeyName = ::rtl::OUString::createFromAscii("/");																	\
		aMainKeyName += implName;																\
		aMainKeyName += ::rtl::OUString::createFromAscii("/UNO/SERVICES");																\
		::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  xNewKey = xKey->createKey(aMainKeyName);										\
		DBG_ASSERT(xNewKey.is(), "SBA::exService_writeRegEntry : could not create a registry key !");	\
	}																									\


//---------------------------------------------------------------------------------------
#define CREATE_PROVIDER(classname, implName, creator, supportedservices)						\
	if (pServiceManager && !rtl_str_compare(implName,implementationName))						\
	{																							\
		try																						\
		{																						\
			::com::sun::star::uno::Reference< ::com::sun::star::lang::XSingleServiceFactory> xRet(	\
			creator(														\
				reinterpret_cast< ::com::sun::star::lang::XMultiServiceFactory*>(pServiceManager),	\
				::rtl::OUString::createFromAscii(implName),	classname##_CreateInstance				\
				, supportedservices));																\
																									\
			if(xRet.is())																			\
			{																						\
				xRet->acquire();																	\
				pRet = xRet.get();																	\
			}																						\
		}																						\
		catch(...)																				\
		{																						\
		}																						\
	}

extern "C" {

sal_Bool SAL_CALL component_writeInfo(void* pServiceManager,void* pRegistryKey)
{
	if(!pRegistryKey)
		return sal_False;

	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey> xKey(
		reinterpret_cast< ::com::sun::star::registry::XRegistryKey*>(pRegistryKey)); 
	//	uno2smart(xKey, *xUnoKey);

	// Eigentliche Implementierung und ihre Services registrieren
	::rtl::OUString aImpl = ::rtl::OUString::createFromAscii("/");
	aImpl += DBContentLoader::getImplementationName_Static();

	::rtl::OUString aImpltwo = aImpl;
	aImpltwo += ::rtl::OUString::createFromAscii("/UNO/SERVICES");

	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  xNewKey = xKey->createKey(aImpltwo);

	::com::sun::star::uno::Sequence < ::rtl::OUString> aSequ = DBContentLoader::getSupportedServiceNames_Static();
	const ::rtl::OUString * pArray = aSequ.getConstArray();
	for( sal_Int32 i = 0; i < aSequ.getLength(); i++ )
		xNewKey->createKey( pArray[i] );

	// Einen FrameLoader "uber ::com::sun::star::util::URL-Pattern registrieren
	aImpltwo = aImpl;
	aImpltwo += ::rtl::OUString::createFromAscii("/UNO/Loader");
	xNewKey = xKey->createKey( aImpltwo );
	aImpltwo = aImpl;
	aImpltwo += ::rtl::OUString::createFromAscii("/Loader");
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  xLoaderKey = xKey->createKey( aImpltwo );
	xNewKey = xLoaderKey->createKey( ::rtl::OUString::createFromAscii("Pattern") );
	xNewKey->setAsciiValue( ::rtl::OUString::createFromAscii(".component:DB*") );
	xNewKey = xLoaderKey->createKey( ::rtl::OUString::createFromAscii("Extension") );
	xNewKey->setAsciiValue( ::rtl::OUString::createFromAscii("sdb") );	

//	REGISTER_PROVIDER(SbaXDBContent, ::rtl::OUString::createFromAscii("com.sun.star.data.DatabaseComponent"));
//	REGISTER_PROVIDER(SbaXQueriesContent, ::rtl::OUString::createFromAscii("com.sun.star.data.QueriesComponent"));
//	REGISTER_PROVIDER(SbaXQueryContent, ::rtl::OUString::createFromAscii("com.sun.star.data.QueryComponent"));
//	REGISTER_PROVIDER(SbaXReportsContent, ::rtl::OUString::createFromAscii("com.sun.star.data.ReportsComponent"));
//	REGISTER_PROVIDER(SbaXReportContent, ::rtl::OUString::createFromAscii("com.sun.star.data.ReportComponent"));
//	REGISTER_PROVIDER(SbaXFormsContent, ::rtl::OUString::createFromAscii("com.sun.star.data.FormsComponent"));
//	REGISTER_PROVIDER(SbaXFormContent,::rtl::OUString::createFromAscii("com.sun.star.data.FormComponent"));
//	REGISTER_PROVIDER(SbaXTablesContent,::rtl::OUString::createFromAscii("com.sun.star.data.TablesComponent"));
//	REGISTER_PROVIDER(SbaXTableContent,::rtl::OUString::createFromAscii("com.sun.star.data.TableComponent"));
//	REGISTER_PROVIDER(SbaXViewContent,::rtl::OUString::createFromAscii("com.sun.star.data.ViewComponent"));
//	REGISTER_PROVIDER(SbaXStatementContent,::rtl::OUString::createFromAscii("com.sun.star.data.StatementComponent"));
//	REGISTER_PROVIDER(SbaXRelationsContent,::rtl::OUString::createFromAscii("com.sun.star.data.RelationsComponent"));

	return sal_True;
}

void* SAL_CALL component_getFactory(const sal_Char* implementationName,	void* pServiceManager,void* pRegistryKey)
{
	::com::sun::star::uno::Sequence< ::rtl::OUString>		aServices;
	void* pRet=NULL;
	

	//	uno2smart(xSMgr, *xUnoFact);

	CREATE_PROVIDER(DBContentLoader, "stardiv.offapp.DBContentLoader", ::cppu::createOneInstanceFactory, DBContentLoader::getSupportedServiceNames_Static());
//	CREATE_PROVIDER(SbaXDBContent, "com.sun.star.data.DatabaseComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXQueriesContent, "com.sun.star.data.QueriesComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXQueryContent, "com.sun.star.data.QueryComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXReportsContent, "com.sun.star.data.ReportsComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXReportContent, "com.sun.star.data.ReportComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXFormsContent, "com.sun.star.data.FormsComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXFormContent,"com.sun.star.data.FormComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXTablesContent,"com.sun.star.data.TablesComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXTableContent,"com.sun.star.data.TableComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXViewContent,"com.sun.star.data.ViewComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXStatementContent,"com.sun.star.data.StatementComponent", ::cppu::createOneInstanceFactory, aServices);
//	CREATE_PROVIDER(SbaXRelationsContent,"com.sun.star.data.RelationsComponent", ::cppu::createOneInstanceFactory, aServices);	

	return pRet;
}
void SAL_CALL component_getImplementationEnvironment(const sal_Char** ppEnvTypeName,uno_Environment **pEnv)
{
	*ppEnvTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
}
};

// -----------------------------------------------------------------------
void SAL_CALL DBContentLoader::load(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & rFrame, const ::rtl::OUString& rURL,
		const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& rArgs,
		const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > & rListener)
{
	xFrame = rFrame;
	xListener = rListener;
	aURL = rURL;
	aArgs = rArgs;

	INetURLObject aParser(rURL);
	// ich benutze nicht maURL, sondern rURL, denn zwischen dem Constructor und diesem Load hier kann sich die ::com::sun::star::util::URL des Objektes
	// schon geaendert haben (zum Beispiel durch Umbenennen)

	if (!aParser.GetMainURL().EqualsAscii(".component:DB/FormGridView"))
	{
		// we are registered for this special ::com::sun::star::util::URL stated above and for all database objects
		if (!aParser.HasMark())
		{
			// es war die SDB-Datei selber
			if (rListener.is())
				rListener->loadCancelled(this);
			return;
		}

		XubString sMark = aParser.GetMark();
		if (sMark.GetTokenCount(';') < 2)
		{
			if (!sMark.EqualsAscii(SDB_RELATIONMARK_HEADER))
			{	// es war ein (z.B. Tabellen-) ::com::sun::star::sdbcx::Container, auch fuer den haben wir keinen Loader
				if (rListener.is())
					rListener->loadCancelled(this);
				return;
			}
		}
	}

	SfxObjectFactory* pFactory = SBAEXPL()->GetObjectDocumentFactory(rURL, rFrame->getName(), rArgs);
	if (pFactory)
	{	// it's a database object which has no component (but a SfxObjectShell)
		sal_Bool bSuccess = SfxFrame::LoadSfxComponent(rFrame, rURL, rArgs, pFactory);
		if (rListener.is())
			if (bSuccess)
				rListener->loadFinished(this);
			else
				rListener->loadCancelled(this);
		return;
	}

	// ContainerWindow of frame
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >			xWindow;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >	xController;
	sal_Bool bSuccess = SBAEXPL()->CreateUIComponent(
		aParser.GetMainURL(),				// URL
		rFrame->getContainerWindow(),		// parent window
		m_xServiceFactory,					// service manager
		xWindow,							// out : the newly created window
		xController							// out : the newly created controller
	);

	if (bSuccess)
	{
		DBG_ASSERT(xWindow.is() && xController.is(),
			"DBContentLoader::load : invalid window or controller !");
		xFrame->setComponent(xWindow, xController);
		xController->attachFrame(xFrame);

		if (rListener.is())
			rListener->loadFinished(this);
	}
	else
	{
		if (rListener.is())
			rListener->loadCancelled(this);
	}
}

// -----------------------------------------------------------------------
void DBContentLoader::cancel(void)
{
}

// ------------------
// - Initialization	-
// ------------------
extern "C" void __LOADONCALLAPI InitDatabaseContents()
{
}

