/*************************************************************************
 *
 *  $RCSfile: dbquery.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBQUERY_HXX
#include "dbquery.hxx"
#endif
#ifndef _SBA_DBQRYOBJ_HXX
#include <dbqryobj.hxx>
#endif

#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif

#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif

#ifndef _DBDLGS_HXX
#include <dbdlgs.hxx>
#endif

#ifndef _SBASLTID_HRC
#include <sbasltid.hrc>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

#ifndef _DBCOMMON_HRC_
#include "dbcommon.hrc"
#endif

// locale functions
// ------------------------------------------------------------------------
static XubString getUniqueName(const SbaDatabaseRef& _xDatabase)
{
	XubString aNewName	= XubString(OfsStringRes(RID_STR_NAME_QUERIE));
	sal_uInt16 nIndex = aNewName.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		aNewName.Erase(nIndex, 1);
	return _xDatabase ? _xDatabase->GetUniqueName(dbTable, aNewName) : XubString();
}

// ------------------------------------------------------------------------
static sal_Bool newObject(const SbaDatabaseRef& _xDatabase, DBObject _eObj, sal_Bool bDesignView)
{
	SbaDBDefRef	xDBObj = _xDatabase->CreateDBDef(_eObj, getUniqueName(_xDatabase));
	if (xDBObj.Is())
	{
		::vos::OGuard aGuard(Application::GetSolarMutex());
		SfxApplication *pSApp = SFX_APP();
		SfxAllItemSet aSet(pSApp->GetPool());
		INetURLObject aObj;
		aObj.SetSmartProtocol(INET_PROT_PRIVATE);
		aObj.SetURL("private:factory/query", sal_False);
		if (bDesignView)
			aSet.Put(SfxUInt16Item(SID_VIEW_ID, SID_SBA_QRY_DESIGN), SID_VIEW_ID);
		else
			aSet.Put(SfxUInt16Item(SID_VIEW_ID, SID_SBA_QRY_SQL), SID_VIEW_ID);

		// HashMarks within ::com::sun::star::util::URL params have to be encoded (the ::com::sun::star::util::URL of the xDBObj contains a hash mark)
		// FS - 69717 - 19.11.99
		//	  - 70160 - 01.12.99
		aObj.SetParam(INetURLObject::encode(xDBObj->ToURL(), INetURLObject::PART_URIC, '%', INetURLObject::ENCODE_ALL));

		aSet.Put(SfxStringItem( SID_FILE_NAME, aObj.GetMainURL()),SID_FILE_NAME);
		aSet.Put(SfxStringItem( SID_REFERER, "private:"), SID_REFERER);
		//	pSApp->GetAppDispatcher().Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON, aSet);
	}
	return xDBObj.Is();
}

// ----------------------
// - SbaXQueriesContent -
// ----------------------

#define DBQUERIES_PROP_COUNT	14

const SbaXQueriesPropMap aSbaXQueriesMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_DELETEME,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_NEWCHILD,
	SBA_PROP_OWNURL,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_USERSORTCRITERIUM,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXQueries, DBQUERIES_PROP_COUNT );
IMPL_DB_PROPSET( SbaXQueries );

// ------------------------------------------------------------------------
SbaXQueriesContent::SbaXQueriesContent()
				   :SbaXContainer(aSbaXQueriesMap_Impl, dbQuery)
{
	aTitle = ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_QUERIES)));
	aContentType = ::rtl::OUString("application/sbase-queries;") + aTitle;

	m_sWizardName = "QueryWizard.QueryWizard.QueryMainWithDefault";
	m_nWizardContext = ERROR_START_QUERYWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_QUERYFOLDER_L;
	m_nSmallBitmapId = RID_BMP_DB_QUERYFOLDER_S;
}

// ------------------------------------------------------------------------
void SbaXQueriesContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool bResult = sal_True;

	if (!aCmd.compareToAscii("newQuery"))
		bResult = newObject(xDatabase, eObj, sal_True);
	else if (!aCmd.compareToAscii("newQuerySQL"))
		bResult = newObject(xDatabase, eObj, sal_False);
	else if (!aCmd.compareToAscii("newQueryByWizard"))
		callNewObjectWizard();
	else
	{
		SbaXContainer::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
void SbaXQueriesContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	//	Ist neu verfuegbar fuer Tabellen?
	sal_Bool bNewAvailable = xDatabase.Is() && !xDatabase->IsReadOnly();
	const int nItems(13);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	if (bNewAvailable)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NEW)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_QUERIE)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 2;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQuery");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWDESIGNQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_SQLVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQuerySQL");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWSQLQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_WIZARD)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQueryByWizard");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWAUTOQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;
	}

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("actualize");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_ACTUALIZE);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXQueriesContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_USERSORTCRITERIUM:
		{
			aAny <<= ::rtl::OUString::createFromAscii("2");
			break;
		}
		default:
			return SbaXContainer::_getPropertyValue( _nID );
	}
	return aAny;
}

// --------------------
// - SbaXQueryContent -
// --------------------

#define DBQUERY_PROP_COUNT		14

const SbaXQueryPropMap aSbaXQueryMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	//SBA_PROP_HAS_FOLDER,
	SBA_PROP_SHOW_IN_EXPLORER,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_OWNURL,
	SBA_PROP_RENAME,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_FLAGS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXQuery, DBQUERY_PROP_COUNT );
IMPL_DB_PROPSET( SbaXQuery );

// ------------------------------------------------------------------------
SbaXQueryContent::SbaXQueryContent()
				 :SbaXContent(aSbaXQueryMap_Impl, dbQuery)
{
	// aus dem Namen fuer Abfragen das ~ entfernen (in der Resource ist es als Menu-Text gespeichert)
	UniString strContentSubType(OfsStringRes(RID_STR_NAME_QUERIE));
	sal_uInt16 nIndex = strContentSubType.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		strContentSubType.Erase(nIndex, 1);

	aContentType = ::rtl::OUString("application/sbase-query;") + ::rtl::OUString(strContentSubType);

	m_sWizardName = "QueryWizard.QueryWizard.QueryMainWithDefault";
	m_nWizardContext = ERROR_START_QUERYWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_QUERY_L;
	m_nSmallBitmapId = RID_BMP_DB_QUERY_S;
}

// ------------------------------------------------------------------------
sal_Bool SbaXQueryContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
									const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_QUERYMARK_HEADER));
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXQueryContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii("_beamer;_top;_blank");
			break;
		default:
			return SbaXContent::_getPropertyValue( _nID );
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SbaXQueryContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool bResult = sal_True;

	if (!aCmd.compareToAscii("newQuery"))
		bResult = newObject(xDatabase, eObj, sal_True);
	else if (!aCmd.compareToAscii("newQuerySQL"))
		bResult = newObject(xDatabase, eObj, sal_False);
	else if (!aCmd.compareToAscii("newQueryByWizard"))
		callNewObjectWizard();
	else if( !aCmd.compareToAscii("showLayout") )
		bResult = showLayout(aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("showNative") )
		bResult = showNative(aEvt, rCallback, aParam );
	else
	{
		SbaXContent::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXQueryContent::queryCommands()
{
	::com::sun::star::uno::Sequence< ::rtl::OUString> seqCommands(7);

	sal_Bool bCanModify = !xDatabase->IsReadOnly();

	::rtl::OUString* pustrCommans = seqCommands.getArray();
	sal_uInt32 i = 0;
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("close");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("copy");
	if (bCanModify)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("delete");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("initialize");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("open");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("prepareMenu");
	if (bCanModify)
	{
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("rename");
//		pustrCommans[i++] = ::rtl::OUString::createFromAscii("undelete");
	}

	return seqCommands;
}

// ------------------------------------------------------------------------
void SbaXQueryContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	//	Ist neu verfuegbar fuer Tabellen?
	sal_Bool bNewAvailable = xDatabase.Is() && !xDatabase->IsReadOnly();
	const int nItems(13);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	// sicherstellen da die Tabelle existiert
	((SbaXQueryContent*)this)->getObj();

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	if (bNewAvailable)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NEW)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_QUERIE)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 2;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQuery");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWDESIGNQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_SQLVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQuerySQL");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWSQLQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_WIZARD)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newQueryByWizard");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_NEWAUTOQUERY);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;
	}

	if (xDBObj.Is())
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("showLayout");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_SHOWLAYOUT);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= !xDBObj->IsLocked() && !((SbaQueryDef*)&xDBObj)->IsNative() ?
			0 : CNT_COMPMENU_DISABLED;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_QRY_SQLVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("showNative");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_QUERY_SHOWSQL);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= !xDBObj->IsLocked() ?	0 : CNT_COMPMENU_DISABLED;
	}

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

//-------------------------------------------------------------------------
sal_Bool SbaXQueryContent::showLayout( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
								   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								   const ::com::sun::star::uno::Any& rParam )

{
	if (xDBObj.Is())
	{
		SfxUInt16Item aViewId( SID_VIEW_ID, SID_SBA_QRY_DESIGN);
		xDBObj->OpenDoc(sal_False, &aViewId, 0L);
		if(xDBObj->Status().IsError())
			SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
		return sal_True;
	}
	else
		return sal_False;
}

//-------------------------------------------------------------------------
sal_Bool SbaXQueryContent::showNative( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
								   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								   const ::com::sun::star::uno::Any& rParam )

{
	if (xDBObj.Is())
	{
		SfxUInt16Item aViewId( SID_VIEW_ID, SID_SBA_QRY_SQL);
		xDBObj->OpenDoc(sal_False, &aViewId, 0L);
		if(xDBObj->Status().IsError())
			SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
		return sal_True;
	}
	else
		return sal_False;
}


// --------------------
// - SbaXStatementContent -
// --------------------

#define DBSTMT_PROP_COUNT		8

const SbaXStatementPropMap aSbaXStatementMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_TARGETS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXStatement, DBSTMT_PROP_COUNT );
IMPL_DB_PROPSET( SbaXStatement );

// ------------------------------------------------------------------------
SbaXStatementContent::SbaXStatementContent()
					 :SbaXContent(aSbaXStatementMap_Impl, dbQuery)
{
	aContentType = ::rtl::OUString("application/sbase-statement;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_QUERIE)));
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXStatementContent::queryCommands()
{
	static ::rtl::OUString aCommandList[ 1 ] =
	{
			::rtl::OUString::createFromAscii("initialize"),
	};
	return ::com::sun::star::uno::Sequence< ::rtl::OUString >( aCommandList, 1 );
}

// ------------------------------------------------------------------------
sal_Bool SbaXStatementContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
										const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_STATEMENTMARK_HEADER));
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXStatementContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii("_beamer;_beamer;_beamer");
			break;
		case PROP_ID_TITLE:
			aAny <<= aTitle;
			break;
		case PROP_ID_IS_FOLDER:
			{
				sal_Bool bB(sal_False);
				aAny.setValue( &bB,::getBooleanCppuType());
			}
			break;

		case( PROP_ID_CONTENT_TYPE ):
		case( PROP_ID_SMALL_IMAGE ):
		case( PROP_ID_BIG_IMAGE ):
		case( PROP_ID_MASK_COLOR ):
			return SbaXContent::_getPropertyValue( _nID );
			break;
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SbaXStatementContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	rCallback->done( aEvt );
}


