/*************************************************************************
 *
 *  $RCSfile: dbquery.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBQUERY_HXX
#define _DBQUERY_HXX

#ifndef _DBCOMMON_HXX
#include "dbcommon.hxx"
#endif

class INetURLObject;

// ----------------------
// - SbaXQueriesContent -
// ----------------------

DECL_DB_PROPMAP( SbaXQueries );

class SbaXQueriesContent : public SbaXContainer
{
public:

								DECL_DB_PROPSET();

								SbaXQueriesContent();

	virtual void				executeImpl( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

protected:
	virtual void				createPopup( ::com::sun::star::uno::Any& rAny ) const;
	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
};

// --------------------
// - SbaXQueryContent -
// --------------------

DECL_DB_PROPMAP( SbaXQuery );

class SbaXQueryContent : public SbaXContent
{
public:
								DECL_DB_PROPSET();

								SbaXQueryContent();

	virtual void				executeImpl( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL queryCommands();

protected:
	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
	virtual sal_Bool				_initialize(const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
											const INetURLObject& rUrlObj);

	virtual void				createPopup( ::com::sun::star::uno::Any& rAny ) const;

	sal_Bool						showLayout( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam );

	sal_Bool						showNative( const ::com::sun::star::chaos::StatusCallbackEvent& rEvt,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam );
};

// --------------------
// - SbaXStatementContent -
// --------------------

DECL_DB_PROPMAP( SbaXStatement );

class SbaXStatementContent : public SbaXContent
{
public:
								DECL_DB_PROPSET();

								SbaXStatementContent();

	virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL queryCommands();

	virtual void				executeImpl( const ::rtl::OUString& Command, const ::com::sun::star::uno::Any& Args, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & Callback );

protected:
	virtual ::com::sun::star::uno::Any				_getPropertyValue( sal_uInt16 _nID ) const;
	virtual sal_Bool				_initialize(const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
											const INetURLObject& rUrlObj);
};



#endif

