/*************************************************************************
 *
 *  $RCSfile: dbreport.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DBREPORT_HXX
#include "dbreport.hxx"
#endif

#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif
#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

#ifndef _DBCOMMON_HRC_
#include "dbcommon.hrc"
#endif

// locale functions
// ------------------------------------------------------------------------
static XubString getUniqueName(const SbaDatabaseRef& _xDatabase)
{
	XubString aNewName	= XubString(OfsStringRes(RID_STR_NAME_REPORT));
	sal_uInt16 nIndex = aNewName.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		aNewName.Erase(nIndex, 1);
	return _xDatabase ? _xDatabase->GetUniqueName(dbTable, aNewName) : XubString();
}

sal_uInt32 includeNewReportMenu(const SbaDatabaseRef xDatabase, ::com::sun::star::chaos::MenuItemDescriptor* pBase, sal_uInt32 nFirstItem)
{
	if (!xDatabase.Is() || xDatabase->IsReadOnly())
		return nFirstItem;

	if (!SFX_APP()->HasFeature(SFX_FEATURE_SWRITER))
		return nFirstItem;

	sal_uInt32 nItem = nFirstItem;

	pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NEW)));
	pBase[nItem].Command		;
	pBase[nItem].HelpUrl		;
	pBase[nItem].ParentPos		= 0;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= 0;

	pBase[nItem].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_REPORT)));
	pBase[nItem].Command		= ::rtl::OUString::createFromAscii("newReport");
	pBase[nItem].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_REPORT_NEWAUTOREPORT);
	pBase[nItem].ParentPos		= nFirstItem + 1;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= 0;

	pBase[nItem].ParentPos		= 0;
	pBase[nItem].InsertionPos	= 0;
	pBase[nItem++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	return nItem;
}

// ----------------------
// - SbaXReportsContent -
// ----------------------

#define DBREPORTS_PROP_COUNT	14

const SbaXReportsPropMap aSbaXReportsMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_DELETEME,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_NEWCHILD,
	SBA_PROP_OWNURL,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_USERSORTCRITERIUM,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXReports, DBREPORTS_PROP_COUNT );
IMPL_DB_PROPSET( SbaXReports );
//	SMART_UNO_IMPLEMENTATION( DBReportsPropertySetInfo, UsrObject );
//	SMART_REFLECTION_IMPLEMENTATION( SbaXReportsContent, SbaXContainer, ::rtl::OUString::createFromAscii("SbaXReportsContent") )

// ------------------------------------------------------------------------
SbaXReportsContent::SbaXReportsContent()
				   :SbaXContainer(aSbaXReportsMap_Impl, dbReport)
{
	aTitle = ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_REPORTS)));
	aContentType = ::rtl::OUString::createFromAscii("application/sbase-reports;") + aTitle;

	m_sWizardName = "ReportWizard.ReportWizard.MainWithDefault";
	m_nWizardContext = ERROR_START_REPORTWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_REPORTFOLDER_L;
	m_nSmallBitmapId = RID_BMP_DB_REPORTFOLDER_S;
}

// ------------------------------------------------------------------------
void SbaXReportsContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);

	if (!aCmd.compareToAscii("newReport"))
		callNewObjectWizard();
	else
	{
		SbaXContainer::executeImpl(aCmd, aParam, rCallback);
		return;
	}

	rCallback->done( aEvt );
}

// ------------------------------------------------------------------------
void SbaXReportsContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	const int nItems(10);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	i = includeNewReportMenu(xDatabase, aMenu, i);

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("actualize");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_REPORT_ACTUALIZE);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );
	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXReportsContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_USERSORTCRITERIUM:
		{
			aAny <<= ::rtl::OUString::createFromAscii("1");
			break;
		}
		default:
			return SbaXContainer::_getPropertyValue( _nID );
	}
	return aAny;
}
// ---------------------
// - SbaXReportContent -
// ---------------------

#define DBREPORT_PROP_COUNT		14

const SbaXReportPropMap aSbaXReportMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	//SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_SHOW_IN_EXPLORER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_OWNURL,
	SBA_PROP_RENAME,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_FLAGS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXReport, DBREPORT_PROP_COUNT );
IMPL_DB_PROPSET( SbaXReport );
//	SMART_UNO_IMPLEMENTATION( DBReportPropertySetInfo, UsrObject );
//	SMART_REFLECTION_IMPLEMENTATION( SbaXReportContent, SbaXContent, ::rtl::OUString::createFromAscii("SbaXReportContent") )

// ------------------------------------------------------------------------
SbaXReportContent::SbaXReportContent()
				  :SbaXContent(aSbaXReportMap_Impl, dbReport)
{
	// aus dem Namen fuer Berichte das ~ entfernen (in der Resource ist es als Menu-Text gespeichert)
	UniString strContentSubType(OfsStringRes(RID_STR_NAME_REPORT));
	sal_uInt16 nIndex = strContentSubType.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		strContentSubType.Erase(nIndex, 1);

	aContentType = ::rtl::OUString::createFromAscii("application/sbase-report;") + ::rtl::OUString(strContentSubType);

	m_sWizardName = "ReportWizard.ReportWizard.MainWithDefault";
	m_nWizardContext = ERROR_START_REPORTWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_REPORT_L;
	m_nSmallBitmapId = RID_BMP_DB_REPORT_S;
}

// ------------------------------------------------------------------------
sal_Bool SbaXReportContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
									 const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_REPORTMARK_HEADER));
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXReportContent::queryCommands()
{
	::com::sun::star::uno::Sequence< ::rtl::OUString> seqCommands(7);

	sal_Bool bWriterInstalled = SFX_APP()->HasFeature(SFX_FEATURE_SWRITER);
	sal_Bool bCanModify = !xDatabase->IsReadOnly();

	::rtl::OUString* pustrCommans = seqCommands.getArray();
	sal_uInt32 i = 0;
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("close");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("copy");
	if (bCanModify)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("delete");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("initialize");
	if (bWriterInstalled)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("open");
	pustrCommans[i++] = ::rtl::OUString::createFromAscii("prepareMenu");
	if (bCanModify)
		pustrCommans[i++] = ::rtl::OUString::createFromAscii("rename");
//	if (bCanModify)
//		pustrCommans[i++] = ::rtl::OUString::createFromAscii("undelete");

	return seqCommands;
}

// ------------------------------------------------------------------------
void SbaXReportContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool bResult = sal_True;

	if (!aCmd.compareToAscii("newReport"))
		callNewObjectWizard();
	else if( !aCmd.compareToAscii("showLayout") )
		bResult = showLayout(aEvt, rCallback, aParam );
	else
	{
		SbaXContent::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
void SbaXReportContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	::com::sun::star::chaos::MenuDescriptor		 aPopup;
	const int nItems(10);
	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];
	sal_uInt32 i = 0;

	// sicherstellen da die Tabelle existiert
	((SbaXReportContent*)this)->getObj();

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	i = includeNewReportMenu(xDatabase, aMenu, i);

	if (xDBObj.Is() && SFX_APP()->HasFeature(SFX_FEATURE_SWRITER) && !xDatabase->IsReadOnly())
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_RPT_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("showLayout");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_REPORT_SHOWLAYOUT);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= !xDBObj->IsLocked() ?	0 : CNT_COMPMENU_DISABLED;
	}

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

//-------------------------------------------------------------------------
sal_Bool SbaXReportContent::showLayout( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								  const ::com::sun::star::uno::Any& rParam )
{
	if (xDBObj.Is())
	{
		xDBObj->OpenDoc(sal_False, 0L);
		if(xDBObj->Status().IsError())
			SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
		return sal_True;
	}
	else
		return sal_False;
}


