/*************************************************************************
 *
 *  $RCSfile: dbtable.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _DBTABLE_HXX
#include "dbtable.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _COM_SUN_STAR_CHAOS_MENUDESCRIPTOR_HPP_
#include <com/sun/star/chaos/MenuDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTENTENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XContentEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif


#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SBASLTID_HRC
#include <sbasltid.hrc>
#endif

#ifndef _DBDLGS_HXX
#include <dbdlgs.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SBAITEMS_HXX //autogen
#include <sbaitems.hxx>
#endif

#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _OFF_APP_HRC
#include "app.hrc"
#endif
#ifndef _OFF_RESID_HXX
#include "resid.hxx"
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_SORTINGINFO_HPP_
#include <com/sun/star/chaos/SortingInfo.hpp>
#endif

#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif

#ifndef _DBCOMMON_HRC_
#include "dbcommon.hrc"
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
// locale functions
// ------------------------------------------------------------------------
static XubString getUniqueName(const SbaDatabaseRef& _xDatabase)
{
	XubString aNewName	= XubString(OfsStringRes(RID_STR_NAME_TABLE));
	sal_uInt16 nIndex = aNewName.Search('~'); // Tilde da Menueeintrag
	if (nIndex != STRING_NOTFOUND)
		aNewName.Erase(nIndex, 1);
	return _xDatabase ? _xDatabase->GetUniqueName(dbTable, aNewName) : XubString();
}

// ------------------------------------------------------------------------
static sal_Bool newObject(const SbaDatabaseRef& _xDatabase, DBObject _eObj, const ::com::sun::star::chaos::StatusCallbackEvent& aEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	SbaDBDefRef	xDBObj = _xDatabase->CreateDBDef(_eObj, getUniqueName(_xDatabase));
	if (_eObj == dbView)
	{
		if (xDBObj.Is())
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			SfxApplication *pSApp = SFX_APP();
			SfxAllItemSet aSet(pSApp->GetPool());
			INetURLObject aObj;
			aObj.SetSmartProtocol(INET_PROT_PRIVATE);
			aObj.SetURL("private:factory/query", sal_False);
			aSet.Put(SfxUInt16Item(SID_VIEW_ID, SID_SBA_QRY_DESIGN), SID_VIEW_ID);

			// HashMarks within ::com::sun::star::util::URL params have to be encoded (the ::com::sun::star::util::URL of the xDBObj contains a hash mark)
			// FS - 69717 - 19.11.99
			//	  - 70160 - 01.12.99
			aObj.SetParam(INetURLObject::encode(xDBObj->ToURL(), INetURLObject::PART_URIC, '%', INetURLObject::ENCODE_ALL));

			aSet.Put(SfxStringItem( SID_FILE_NAME, aObj.GetMainURL()),SID_FILE_NAME);
			aSet.Put(SfxStringItem( SID_REFERER, "private:"), SID_REFERER);
			//	pSApp->GetAppDispatcher().Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON, aSet);
		}
	}
	else
	{
		if (xDBObj.Is())
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			SfxApplication *pSApp = SFX_APP();
			SfxAllItemSet aSet(pSApp->GetPool());
			INetURLObject aObj;
			aObj.SetSmartProtocol(INET_PROT_PRIVATE);

			// ::com::sun::star::util::URL aufbauen
			if (_eObj == dbTable)
			{
				aObj.SetURL("private:factory/table", sal_False);
				aSet.Put(SfxUInt16Item(SID_VIEW_ID, SID_SBA_TBL_DESIGN), SID_VIEW_ID);
			}
			else
			{
				aObj.SetURL("private:factory/query", sal_False);
				aSet.Put(SfxUInt16Item(SID_VIEW_ID, SID_SBA_QRY_DESIGN), SID_VIEW_ID);
			}

			// HashMarks within ::com::sun::star::util::URL params have to be encoded (the ::com::sun::star::util::URL of the xDBObj contains a hash mark)
			// FS - 69717 - 19.11.99
			//	  - 70160 - 01.12.99
			aObj.SetParam(INetURLObject::encode(xDBObj->ToURL(), INetURLObject::PART_URIC, '%', INetURLObject::ENCODE_ALL));

			aSet.Put(SfxStringItem( SID_FILE_NAME, aObj.GetMainURL()),SID_FILE_NAME);
			aSet.Put(SfxStringItem( SID_REFERER, "private:"), SID_REFERER);

			//	pSApp->GetAppDispatcher().Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON, aSet);
		}
	}
	return xDBObj.Is();
}

// ---------------------
// - SbaXTablesContent -
// ---------------------

#define DBTABLES_PROP_COUNT		14 // Anzahl von aSbaXTablesMap_Impl
// defines m"ussen nach Buchstaben sortiert sein
const SbaXTablesPropMap aSbaXTablesMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_DELETEME,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_NEWCHILD,
	SBA_PROP_OWNURL,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_USERSORTCRITERIUM,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXTables, DBTABLES_PROP_COUNT );
IMPL_DB_PROPSET( SbaXTables );
//	SMART_UNO_IMPLEMENTATION( DBTablesPropertySetInfo, UsrObject );
//	SMART_REFLECTION_IMPLEMENTATION( SbaXTablesContent, SbaXContainer, ::rtl::OUString::createFromAscii("SbaXTablesContent") )

// ------------------------------------------------------------------------
SbaXTablesContent::SbaXTablesContent()
				  :SbaXContainer(aSbaXTablesMap_Impl, dbTable)
{
	aTitle = ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_TABLES)));
	
	aContentType = ::rtl::OUString("application/sbase-tables;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_TABLES)));

	m_sWizardName = "TableWizard.TableWizard.SubCreateTabelWithDefault";
	m_nWizardContext = ERROR_START_TABLEWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_TABLEFOLDER_L;
	m_nSmallBitmapId = RID_BMP_DB_TABLEFOLDER_S;
}

// ------------------------------------------------------------------------
void SbaXTablesContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool bResult = sal_True;

	if( !aCmd.compareToAscii("newTable") )
		bResult = newObject(xDatabase, dbTable, aEvt, rCallback, aParam );
	else if (!aCmd.compareToAscii("newTableByWizard"))
		callNewObjectWizard();
	else if( !aCmd.compareToAscii("newView") )
		bResult = newObject(xDatabase, dbView, aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("showRelations") )
		bResult = showRelations( aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("compress") )
		bResult = compress( aEvt, rCallback, aParam );
	else if( aCmd == ::rtl::OUString(::rtl::OUString::createFromAscii("userSettings")))
		bResult = userSettings( aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("backup") )
		bResult = backup( aEvt, rCallback, aParam );
	else
	{
		SbaXContainer::executeImpl(aCmd, aParam, rCallback);
		return;
	}
	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
void SbaXTablesContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);

	::com::sun::star::chaos::MenuDescriptor			aPopup;
	//	Ist neu verfuegbar fuer Tabellen?

	sal_Bool bNewAvailable = xDatabase.Is() && !xDatabase->IsReadOnly() &&
			!::utl::getBOOL(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::READ_ONLY)) &&
			(::utl::getINT16(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::CREATE);

	sal_Bool bRelations	   = xDatabase.Is() && xDatabase->GetMetaData()->isCapable(::com::sun::star::data::DatabaseCapability::INTEGRITY);

	//  Wie erkenne ich ob vies erzeugt werden knnen?
	sal_Bool bCreateView   = bNewAvailable && xDatabase.Is() && (::utl::getINT16(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::VIEW_DEFINITION)) & ::com::sun::star::data::DatabaseViewDefinition::CREATE);
	sal_Bool bCompress	   = bNewAvailable && (xDatabase->IsCapable(SDB_CAP_COMPRESS) || xDatabase->IsCapable(SDB_CAP_COMPACT));
	sal_Bool bBackUp	   = bNewAvailable && xDatabase->IsCapable(SDB_CAP_BACKUP);

	sal_Bool bUserSettings = bNewAvailable && xDatabase->IsCapable(SDB_CAP_USERSETTINGS);

	const int nItems(15);


	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	if (bNewAvailable)
	{
		aMenu[i].ItemText		= UniString(OfsStringRes(RID_STR_NEW));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= UniString(OfsStringRes(RID_STR_NAME_TABLE));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 2;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_TBL_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newTable");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWDESIGNTABLE);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_WIZARD)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newTableByWizard");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWAUTOTABLE);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		if (bCreateView)
		{
			aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_VIEW)));
			aMenu[i].Command		= ::rtl::OUString::createFromAscii("newView");
			aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWVIEW);
			aMenu[i].ParentPos		= 2;
			aMenu[i].InsertionPos	= 0;
			aMenu[i++].ItemFlags	= 0;
		}

		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;
	}

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("actualize");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLES_ACTUALIZE);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	if (bCompress)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_TBL_COMPRESS)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("compress");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_COMPRESS);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;
	}

	if (bRelations)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_RELATIONS)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("showRelations");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_RELATIONS);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;
	}
	if (bUserSettings)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_USER_SETTINGS)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("userSettings");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_DB_USERSETTINGS);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;
	}

	if(bBackUp)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_TBL_CREATE_BACKUP)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("backup");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_DB_CREATE_BACKUP);
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;
	}

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;


	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );
	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTablesContent::open( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
						  const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
						  const ::com::sun::star::uno::Any& rParam )
{
	if (!SbaXChaosContent::open(rCmd, rJob, rParam))
		return sal_False;

	if (!getDatabase(sal_True))
		return sal_False;
	else
	{
		OfaDatabaseGuard aDatabaseSafety(&xDatabase);
		sal_uInt16 nCount = xDatabase->GetObjectCount(eObj),
			   i	  = 0;

		// collect the table (view) names
		::std::vector<XubString> aNames;

		while (i < nCount)
		{
			XubString aName = xDatabase->GetObjectName(eObj, i++);

			// Views werden ::com::sun::star::util::URL mig durch ; unterschieden
			if (xDatabase->IsView(aName))
				aName = XubString(";") + aName;
			aNames.insert(aNames.end(), aName);
		}

		// do the CHAOS jobs after clearing our database guard
		aDatabaseSafety.clear();
		for	(	::std::vector<XubString>::iterator aChildLoop = aNames.begin();
				aChildLoop != aNames.end();
				++aChildLoop
			)
			rJob->result( rCmd, SBA_RESULT_INSERTED, U(*aChildLoop));

		return sal_True;
	}
}


// ------------------------------------------------------------------------
sal_Bool SbaXTablesContent::showRelations(const ::com::sun::star::chaos::StatusCallbackEvent& aEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	//////////////////////////////////////////////////////////////////////
	// Oeffnen der RelationDocSh
	SfxApplication* pApp = SFX_APP();
	SfxAllItemSet aOpenSet( pApp->GetPool() );
	INetURLObject aObj;
	aObj.SetSmartProtocol(INET_PROT_FILE);

	XubString sUrl(aDatabasePath.GetFull());
	aObj.SetURL(sUrl, sal_False);
	aObj.SetMark(SDB_RELATIONMARK_HEADER);

	aOpenSet.Put( SfxBoolItem(SID_DOC_READONLY, sal_False), SID_DOC_READONLY );
	aOpenSet.Put( SfxStringItem(SID_FILE_NAME, aObj.GetMainURL()), SID_FILE_NAME );
	aOpenSet.Put( SfxStringItem(SID_REFERER, "file:"), SID_REFERER );

	SbaDBDatabaseItem* pDatabaseItem = SBAEXPL()->CreateDatabaseItem( SID_SBA_DATABASE, xDatabase );
	aOpenSet.Put( *pDatabaseItem, SID_SBA_DATABASE );
	delete pDatabaseItem; // Das Set hat das Item cloned

	//	pApp->GetAppDispatcher().Execute( SID_OPENDOC, SFX_CALLMODE_ASYNCHRON, aOpenSet);
	return 0L;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTablesContent::compress(const ::com::sun::star::chaos::StatusCallbackEvent& aEvt, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob, const ::com::sun::star::uno::Any& rParam)
{
	sal_Bool bResult(sal_False);
	if(bResult = SBAEXPL()->DoCompact(xDatabase))
		actualize(aEvt, rJob, rParam);
	return bResult;
}
// ------------------------------------------------------------------------
sal_Bool SbaXTablesContent::userSettings( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								const ::com::sun::star::uno::Any& rParam )
{
	return SBAEXPL()->ExecuteUserSettings(xDatabase);
}
// ------------------------------------------------------------------------
sal_Bool SbaXTablesContent::backup( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								const ::com::sun::star::uno::Any& rParam )
{
	return SBAEXPL()->ExecuteBackup(xDatabase);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXTablesContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_USERSORTCRITERIUM:
		{
			aAny <<= ::rtl::OUString::createFromAscii("3");
			break;
		}
		default:
			return SbaXContainer::_getPropertyValue( _nID );
	}
	return aAny;
}

// --------------------
// - SbaXTableContent -
// --------------------

#define DBTABLE_PROP_COUNT		14

const SbaXTablePropMap aSbaXTableMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_EDITSTRING,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_SHOW_IN_EXPLORER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_MENU,
	SBA_PROP_OWNURL,
	SBA_PROP_RENAME,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_SORTING,
	SBA_PROP_TARGETS,
	SBA_PROP_TITLE,
	SBA_PROP_FLAGS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXTable, DBTABLE_PROP_COUNT );
IMPL_DB_PROPSET( SbaXTable );
//	SMART_UNO_IMPLEMENTATION( DBTablePropertySetInfo, UsrObject );
//	SMART_REFLECTION_IMPLEMENTATION( SbaXTableContent, SbaXContent, ::rtl::OUString::createFromAscii("SbaXTableContent") )

// ------------------------------------------------------------------------
SbaXTableContent::SbaXTableContent()
				 :SbaXContent(aSbaXTableMap_Impl, dbTable)
{
	aContentType = ::rtl::OUString("application/sbase-table;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_TABLE)));

	m_sWizardName = "TableWizard.TableWizard.SubCreateTabelWithDefault";
	m_nWizardContext = ERROR_START_TABLEWIZARD;

	m_nLargeBitmapId = RID_BMP_DB_TABLE_L;
	m_nSmallBitmapId = RID_BMP_DB_TABLE_S;
}
// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
									const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_TABLEMARK_HEADER));
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXTableContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii("_beamer;_top;_blank");
			break;
		case PROP_ID_RENAME:
		{
			OfaDatabaseGuard aDatabaseSafety(&xDatabase);
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(xDatabase->GetMetaData());

			XubString aTableName(S(aTitle));
			sal_Bool bRename = !xDatabase->IsReadOnly() && !::utl::getBOOL(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::READ_ONLY));
			bRename &= !xDatabase->StructureIsReadOnly() && (!xDatabase->HasObject(dbTable,aTableName) || !xDatabase->IsView(aTableName));

			// testen, ob der Owner der Tabelle auch gleichzeitig der aktuelle ::com::sun::star::sdbcx::User ist, nur dann rename erlauben
			XubString sCatalog, sSchema, sName;
			if (SBA_MOD()->SplitTableName(aTableName, sCatalog, sSchema, sName, &xDatabase) && sSchema.Len())
			{	// das Ding konnte gesplittet werden und enthielt ueberhaupt einen Owner-(Schema-)Teil

				sal_Bool bCaseSensitive = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::IDENT_CASE_QUOTED)) & ::com::sun::star::data::DatabaseIdentifierCase::SENSITIVE) == ::com::sun::star::data::DatabaseIdentifierCase::SENSITIVE;

				XubString strCurrentUser(xDatabase->GetUser());

				StringCompare eResult;
				if (bCaseSensitive)
					eResult = strCurrentUser.Compare(sSchema);
				else
					eResult = strCurrentUser.ICompare(sSchema);
				bRename &= (eResult == COMPARE_EQUAL);
			}


			if (bRename)
				aAny <<= ::rtl::OUString::createFromAscii("Title");
			else
				aAny.clear();
			break;
		}
		default:
			return SbaXContent::_getPropertyValue( _nID );
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SbaXTableContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	sal_Bool bResult = sal_True;

	if( !aCmd.compareToAscii("newTable") )
		bResult = newObject(xDatabase, dbTable, aEvt, rCallback, aParam );
	else if ( !aCmd.compareToAscii("newTableByWizard") )
		callNewObjectWizard();
	else if( !aCmd.compareToAscii("newView") )
		bResult = newObject(xDatabase, dbView, aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("showLayout") )
		bResult = showLayout(aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("showPropertyDialog"))
		bResult = editProperties(aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("prepareEditing") )
		bResult = prepareEditing(aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("setAddressbook") )
		bResult = setAddressbook(aEvt, rCallback, aParam );
	else if( !aCmd.compareToAscii("ImportVCard") || !aCmd.compareToAscii("ExportVCard") )
	{

		::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  xDispatch(::utl::getProcessServiceFactory()
				->createInstance(::rtl::OUString::createFromAscii("com.sun.star.schedule.ScheduleManager")), ::com::sun::star::uno::UNO_QUERY);
		if (xDispatch.is())
		{
			::com::sun::star::util::URL aURL;
			sal_Bool bTest = (!aCmd.compareToAscii("ImportVCard"));
			if(bTest)
				aURL.Complete	= ::rtl::OUString::createFromAscii(".uno:ss/ImportVCard");
			else
				aURL.Complete	= ::rtl::OUString::createFromAscii(".uno:ss/ExportVCard");

			xDispatch->dispatch( aURL, ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>() );

			// !alle Datensichten bei Import erneuern
			if (!aCmd.compareToAscii("ImportVCard"))
			{
				//! Ueber ::com::sun::star::frame::Desktop oeffnen
				::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >  xController(::utl::getProcessServiceFactory()
								->createInstance(::rtl::OUString::createFromAscii("com.sun.star.frame.Desktop")), ::com::sun::star::uno::UNO_QUERY);

				if (xController.is())
				{
					::com::sun::star::util::URL aURL;
					aURL.Complete	= ::rtl::OUString::createFromAscii(".uno:Reload");
					// ::com::sun::star::util::URL-Parsing wird noch nicht als Service angeboten...
					aURL.Protocol	= ::rtl::OUString::createFromAscii(".uno:");
					aURL.Path		= ::rtl::OUString::createFromAscii("Reload");

					::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  xProvider(xController, ::com::sun::star::uno::UNO_QUERY);
					if (xProvider.is())
					{
						::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  xDispatch =
							xProvider->queryDispatch(
									aURL,
									::rtl::OUString::createFromAscii("_beamer"),
									::com::sun::star::frame::FrameSearchFlag::PARENT |	// alle, ausser CREATE
									::com::sun::star::frame::FrameSearchFlag::SELF |
									::com::sun::star::frame::FrameSearchFlag::CHILDREN |
									::com::sun::star::frame::FrameSearchFlag::SIBLINGS |
									::com::sun::star::frame::FrameSearchFlag::TASKS );

						if (xDispatch.is())
							xDispatch->dispatch( aURL, ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>() );
					}
				}
			}
		}
	}
	else
	{
		SbaXContent::executeImpl(aCmd, aParam, rCallback);
		return;
	}

	if (bResult)
		rCallback->done( aEvt );
	else
		rCallback->cancelled( aEvt );
}

// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::editProperties(  const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
										const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
										const ::com::sun::star::uno::Any& rParam )
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	XubString sTableName(S(aTitle));
	SbaXTablePropertieDlg aDlg(Application::GetAppWindow(), xDatabase, sTableName);
	aDlg.Execute();

	return sal_True;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::open( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
							 const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
							 const ::com::sun::star::uno::Any& rParam )
{
	if (!SbaXContent::open(rCmd, rJob, rParam))
		return sal_False;

	if (!getObj())
		return sal_False;
	else
	{
		XubString aFrameStr;
		if (xDBObj.Is() && !xDBObj->IsLocked())
		{
			if(xDBObj->GetKind() == dbTable)
			{
				SbaTableDef* pTableDef = (SbaTableDef*)&xDBObj;
				if(pTableDef->GetTablePrivileges() & SDB_PR_READ)
				{
					SfxUInt16Item aViewId( SID_VIEW_ID, SID_SBA_TBL_BROWSE);
					xDBObj->OpenDoc(sal_True, &aViewId, 0L);
					if(xDBObj->Status().IsError())
						SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
				}
				else
				{
					::vos::OGuard aGuard(Application::GetSolarMutex());
					InfoBox(NULL,OffResId(RID_INFO_TABLE_NO_SELECT)).Execute();			
					return sal_False;
				}
			}
			else
			{
				SfxUInt16Item aViewId( SID_VIEW_ID, SID_SBA_TBL_BROWSE);
				xDBObj->OpenDoc(sal_True, &aViewId, 0L);
				if(xDBObj->Status().IsError())
					SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
			}
		}
		return sal_True;
	}
}


// ------------------------------------------------------------------------
void SbaXTableContent::createPopup( ::com::sun::star::uno::Any& rAny ) const
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);

	::com::sun::star::chaos::MenuDescriptor	aPopup;
	//	Ist neu verfuegbar fuer Tabellen?

	sal_Bool bNewAvailable = xDatabase.Is() && !xDatabase->IsReadOnly() &&
			!::utl::getBOOL(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::READ_ONLY)) &&
			(::utl::getINT16(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::CREATE);


	//  Wie erkenne ich ob vies erzeugt werden knnen?
	sal_Bool bCreateView   = bNewAvailable && xDatabase.Is() && (::utl::getINT16(xDatabase->GetMetaData()->getInfo(::com::sun::star::data::DatabaseInfo::VIEW_DEFINITION)) & ::com::sun::star::data::DatabaseViewDefinition::CREATE);

	const int nItems(16);

	::com::sun::star::chaos::MenuItemDescriptor		aMenu[ nItems ];

	sal_uInt32 i = 0;

	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

	if (bNewAvailable)
	{
		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NEW)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_TABLE)));
		aMenu[i].Command		;
		aMenu[i].HelpUrl		;
		aMenu[i].ParentPos		= 2;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_TBL_DESIGNVIEW)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newTable");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWDESIGNTABLE);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

		aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_WIZARD)));
		aMenu[i].Command		= ::rtl::OUString::createFromAscii("newTableByWizard");
		aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWAUTOTABLE);
		aMenu[i].ParentPos		= 3;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= 0;

		if (bCreateView)
		{
			aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_VIEW)));
			aMenu[i].Command		= ::rtl::OUString::createFromAscii("newView");
			aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_NEWVIEW);
			aMenu[i].ParentPos		= 2;
			aMenu[i].InsertionPos	= 0;
			aMenu[i++].ItemFlags	= 0;
		}

		aMenu[i].ParentPos		= 0;
		aMenu[i].InsertionPos	= 0;
		aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;
	}

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_TBL_DESIGNVIEW)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("showLayout");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_SHOWLAYOUT);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_ACTUALIZE)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("actualize");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_ACTUALIZE);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= 0;

	aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_ADDRESSBOOK)));
	aMenu[i].Command		= ::rtl::OUString::createFromAscii("setAddressbook");
	aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_SETADDRBOOK);
	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;

	sal_Bool bAdressBook = DirEntry(SBAOBJ()->GetAddrDBName()) == aDatabasePath && S(aTitle).ICompare(SBAOBJ()->GetAddrTableName()) == COMPARE_EQUAL;
	if (bAdressBook)
		aMenu[i++].ItemFlags= CNT_COMPMENU_CHECKED;
	else
		aMenu[i++].ItemFlags= 0;

	if (bAdressBook)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::container::XContentEnumerationAccess >  xAccess(::utl::getProcessServiceFactory(), ::com::sun::star::uno::UNO_QUERY);
		::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration >  xEnum = xAccess.is() ? xAccess->createContentEnumeration(::rtl::OUString::createFromAscii("com.sun.star.schedule.ScheduleManager"))
											 : ::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration > ();
		if (xEnum.is() && xEnum->hasMoreElements())
		{
			aMenu[i].ParentPos		= 0;
			aMenu[i].InsertionPos	= 0;
			aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;

			aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_IMPORTVCARD)));
			aMenu[i].Command		= ::rtl::OUString::createFromAscii("ImportVCard");
			aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_IMPORTVCARD);
			aMenu[i].ParentPos		= 0;
			aMenu[i].InsertionPos	= 0;
			aMenu[i++].ItemFlags	= 0;

			aMenu[i].ItemText		= ::rtl::OUString(UniString(OfsStringRes(RID_STR_EXPORTVCARD)));
			aMenu[i].Command		= ::rtl::OUString::createFromAscii("ExportVCard");
			aMenu[i].HelpUrl		= ::rtl::OUString(HID_OFA_CHAOS_TABLE_EXPORTVCARD);
			aMenu[i].ParentPos		= 0;
			aMenu[i].InsertionPos	= 0;
			aMenu[i++].ItemFlags	= 0;
		}
	}


	aMenu[i].ParentPos		= 0;
	aMenu[i].InsertionPos	= 0;
	aMenu[i++].ItemFlags	= CNT_COMPMENU_SEPARATOR;


	aPopup.Items = ::com::sun::star::uno::Sequence< ::com::sun::star::chaos::MenuItemDescriptor >( aMenu, i );

	rAny <<= aPopup;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::setAddressbook( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
									   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									   const ::com::sun::star::uno::Any& rParam )
{
	::vos::OGuard aGuard(Application::GetSolarMutex());
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	// Ist diese Tabelle das Addressbuch?
	if (SBAOBJ()->GetAddrDBName() == xDatabase->Name() && S(aTitle).ICompare(SBAOBJ()->GetAddrTableName()) == COMPARE_EQUAL)
		return sal_True;
	else if (QueryBox(Application::GetAppWindow(),OffResId(RID_QRY_ADDRESSBOOK)).Execute() == RET_YES)
	{
		SBAEXPL()->SetAddressBookEntry(xDatabase->Name(), S(aTitle));
		return sal_True;
	}
	return sal_False;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::showLayout( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
								   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
								   const ::com::sun::star::uno::Any& rParam )

{
	if (getObj() != NULL)
	{
		if (xDBObj->IsLocked())
		{
			::vos::OGuard aGuard(Application::GetSolarMutex());
			ErrorBox(NULL, OffResId(RID_ERR_TABLE_LOCKED)).Execute();
			return sal_False;
		}
		SfxUInt16Item aViewId( SID_VIEW_ID, SID_SBA_TBL_DESIGN);
		xDBObj->OpenDoc(
			(((SbaTableDef*)&xDBObj)->GetTablePrivileges() & SDB_PR_ALTER) != SDB_PR_ALTER
			, &aViewId, 0L);
		if(xDBObj->Status().IsError())
			SBAEXPL()->ShowDbStatus(xDBObj->Status(), dbReadError);
	}
	return 0L;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXTableContent::queryCommands()
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(xDatabase->GetMetaData());
	sal_Bool bDelete = !xDatabase->IsReadOnly();

	bDelete &= !xDatabase->StructureIsReadOnly();

	::com::sun::star::uno::Sequence< ::rtl::OUString > aList( 7 );
	sal_uInt32 i = 0;

	::rtl::OUString* pAry = (::rtl::OUString*)aList.getConstArray();

	pAry[i++] = ::rtl::OUString::createFromAscii("close");
	pAry[i++] = ::rtl::OUString::createFromAscii("copy");
	if (bDelete)
		pAry[i++] = ::rtl::OUString::createFromAscii("delete");
	pAry[i++] = ::rtl::OUString::createFromAscii("initialize");
	pAry[i++] = ::rtl::OUString::createFromAscii("open");
	pAry[i++] = ::rtl::OUString::createFromAscii("prepareMenu");
	pAry[i++] = ::rtl::OUString::createFromAscii("showPropertyDialog");

	return aList;
}

// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::prepareEditing( const ::com::sun::star::chaos::StatusCallbackEvent& rCmd,
									   const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rJob,
									   const ::com::sun::star::uno::Any& rParam )
{
	OfaDatabaseGuard aDatabaseSafety(&xDatabase);
	XubString aName(S(aTitle));

	if(xDatabase->IsView(aName))
		return sal_False;

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(xDatabase->GetMetaData());

	sal_Bool   bQualifier = ::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;
	sal_Bool   bOwner	  = ::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SCHEMA_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;

	aFullTableName = aTitle;

	if (bQualifier)
	{
		sal_Bool bQualifierAtStart = ::utl::getBOOL(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_AT_START));
		XubString aSep =	S(::utl::getString(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_SEPARATOR)));

		char cChar = aSep[sal_uInt16(0)];

		sal_uInt16 nIndex = 0;
		XubString aQualifier = aName.GetToken(0, cChar, nIndex);
		if (bQualifierAtStart)
			aName = aName.Copy(nIndex);
		else
			aName.Cut(nIndex--);
	}

	if (bOwner)
		aName = aName.GetToken(1,'.');

	// aus _setPropertyValue von SbaXChaosContent kopiert
	::com::sun::star::beans::PropertyChangeEvent	aEvt;
	aEvt.OldValue <<= U(aName);
	aEvt.NewValue <<= U(aName);
	aEvt.PropertyName   = ::rtl::OUString::createFromAscii("EditString");
	aEvt.PropertyHandle = 0;

	::cppu::OInterfaceContainerHelper* pContainer = aPropertyListeners.getContainer(::rtl::OUString::createFromAscii("EditString"));
	if (pContainer)
	{
		::cppu::OInterfaceIteratorHelper aIt(*pContainer);
		while (aIt.hasMoreElements())
			((::com::sun::star::beans::XPropertyChangeListener *)aIt.next())->propertyChange( aEvt );
	}

	// allListener
	pContainer = aPropertyListeners.getContainer(::rtl::OUString());
	if (pContainer)
	{
		::cppu::OInterfaceIteratorHelper aIt(*pContainer);
		while (aIt.hasMoreElements())
			((::com::sun::star::beans::XPropertyChangeListener *)aIt.next())->propertyChange( aEvt );
	}
	return sal_True;
}
// ------------------------------------------------------------------------
sal_Bool SbaXTableContent::_setPropertyValue(sal_uInt16 _nID, const ::rtl::OUString& aPropertyName,  const ::com::sun::star::uno::Any& aValue)
{
	if(_nID == PROP_ID_TITLE || _nID == PROP_ID_EDITSTRING)
	{
		OfaDatabaseGuard aDatabaseSafety(&xDatabase);

		sal_Bool bModified = sal_False;
		sal_Bool bSuccess = sal_True;
		::com::sun::star::beans::PropertyChangeEvent	aEvt;
		::rtl::OUString aNewTitle(::utl::getString(aValue));
		if(_nID == PROP_ID_EDITSTRING)
		{
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(xDatabase->GetMetaData());

			sal_Bool bQualifier = ::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;
			sal_Bool bOwner	  = ::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SCHEMA_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;
			sal_Bool bQualifierAtStart = ::utl::getBOOL(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_AT_START));

			XubString aName(S(aNewTitle));

			if (bQualifier)
			{
				XubString aSep = S(::utl::getString(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_SEPARATOR)));
				char cChar		= aSep[sal_uInt16(0)];
				if (bQualifierAtStart)
				{
					aName = xDatabase->GetQualifier();
					if(aName.Len())
						aName += cChar;
				}
				else
				{
					aName = cChar;
					aName += xDatabase->GetQualifier();
				}
				if (bOwner)
				{
					if (bQualifierAtStart)
					{
						aName += xDatabase->GetUser();
						if(xDatabase->GetUser().Len())
							aName += '.';
						aName += S(aNewTitle);
					}
					else
					{
						XubString aTmp(xDatabase->GetUser());
						aTmp += '.';
						aTmp += S(aNewTitle);
						aName = aTmp;
					}
				}
				else // Catalog ohne Schemata
				{
					if (bQualifierAtStart)
						aName += S(aNewTitle);
					else
					{
						XubString aTmp(S(aNewTitle));
						aTmp += aName;
						aName = aTmp;
					}
				}
			}
			else if (bOwner)
			{
				if (bQualifierAtStart)
				{
					aName += xDatabase->GetUser();
					if(xDatabase->GetUser().Len())
						aName += '.';
					aName += S(aNewTitle);
				}
				else
				{
					XubString aTmp(xDatabase->GetUser());
					aTmp += '.';
					aTmp += S(aNewTitle);
					aName = aTmp;
				}
			}
			aNewTitle = U(aName);
		}
		// Tabellen koennen Casesentive behandelt werden
		sal_Bool bChanged = sal_False;
		if ((xDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT)
			bChanged = !aTitle.equals(aNewTitle);
		else
			bChanged = !aTitle.equalsIgnoreCase(aNewTitle);

		if (bChanged)
		{
			bModified = sal_True;
			sal_Bool bNew = !aTitle.len();
			// damit leer strings abgefangen werden
			if (::utl::getString(aValue).getLength() && (bNew || rename(::utl::getString(aValue))))
			{
				aEvt.OldValue <<= aTitle;
				aEvt.NewValue <<= aTitle = aNewTitle;
			}
			else
			{
				// umbennen war nicht moeglich
				bSuccess = sal_False;
				aEvt.OldValue <<= aNewTitle;
				aEvt.NewValue <<= aFullTableName;
			}
		}

		if (bModified)
		{
			aEvt.PropertyName   = ::rtl::OUString::createFromAscii("Title");
			aEvt.PropertyHandle = 0;

			::cppu::OInterfaceContainerHelper* pContainer = aPropertyListeners.getContainer(aPropertyName);
			if (pContainer)
			{
				::cppu::OInterfaceIteratorHelper aIt(*pContainer);
				while (aIt.hasMoreElements())
					((::com::sun::star::beans::XPropertyChangeListener *)aIt.next())->propertyChange( aEvt );
			}

			// allListener
			pContainer = aPropertyListeners.getContainer(::rtl::OUString());
			if (pContainer)
			{
				::cppu::OInterfaceIteratorHelper aIt(*pContainer);
				while (aIt.hasMoreElements())
					((::com::sun::star::beans::XPropertyChangeListener *)aIt.next())->propertyChange( aEvt );
			}
		}
		return bSuccess;
	}else
		return SbaXChaosContent::_setPropertyValue(_nID,aPropertyName,aValue);
}

// ------------------------------------------------------------------------
SbaXViewContent::SbaXViewContent()
{
	aContentType = ::rtl::OUString("application/sbase-view;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_VIEW)));

	m_nLargeBitmapId = RID_BMP_DB_VIEW_L;
	m_nSmallBitmapId = RID_BMP_DB_VIEW_S;
};

//	SMART_REFLECTION_IMPLEMENTATION( SbaXViewContent, SbaXTableContent, ::rtl::OUString::createFromAscii("SbaXViewContent") )

// ------------------------------------------------------------------------
sal_Bool SbaXViewContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
								   const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	// ::com::sun::star::util::URL unterscheidet sich durch doppeltes ;
	aMark.Erase(0, strlen(SDB_TABLEMARK_HEADER) + 1);
	aTitle = U(aMark);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// --------------------
// - SbaXRelationsContent -
// --------------------

#define DBRELS_PROP_COUNT		8

const SbaXRelationsPropMap aSbaXRelationsMap_Impl[] =
{
	SBA_PROP_BIG_IMAGE,
	SBA_PROP_CONTENT_TYPE,
	SBA_PROP_HAS_FOLDER,
	SBA_PROP_IS_DOCUMENT,
	SBA_PROP_IS_FOLDER,
	SBA_PROP_MASK_COLOR,
	SBA_PROP_SMALL_IMAGE,
	SBA_PROP_TARGETS,
	DBBasePropertyMap()
};

// ------------------------------------------------------------------------
IMPL_DB_PROPMAP( SbaXRelations, DBRELS_PROP_COUNT );
IMPL_DB_PROPSET( SbaXRelations );
//	SMART_REFLECTION_IMPLEMENTATION( SbaXRelationsContent, SbaXContent, ::rtl::OUString::createFromAscii("SbaXRelationsContent") )

// ------------------------------------------------------------------------
SbaXRelationsContent::SbaXRelationsContent()
					 :SbaXContent(aSbaXRelationsMap_Impl, dbQuery)
{
	aContentType = ::rtl::OUString("application/sbase-relations;") + ::rtl::OUString(UniString(OfsStringRes(RID_STR_NAME_RELATIONS)));

	m_nLargeBitmapId = RID_BMP_DB_RELATIONS_L;
	m_nSmallBitmapId = RID_BMP_DB_RELATIONS_S;
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL SbaXRelationsContent::queryCommands() 
{
	static ::rtl::OUString aCommandList[ 1 ] =
	{
			::rtl::OUString::createFromAscii("initialize"),
	};
	return ::com::sun::star::uno::Sequence< ::rtl::OUString >( aCommandList, 1 );
}

// ------------------------------------------------------------------------
sal_Bool SbaXRelationsContent::_initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XURLContent > & aParent, const ::rtl::OUString& aURL,
										const INetURLObject& rUrlObj)
{
	XubString aMark(rUrlObj.GetMark());
	aMark.Erase(0, strlen(SDB_RELATIONMARK_HEADER));

	XubString sTitle = OfsStringRes(RID_STR_NAME_RELATIONS);
	sal_uInt16 nIndex = sTitle.Search('~'); // menu entry
	if (nIndex != STRING_NOTFOUND)
		sTitle.Erase(nIndex, 1);
	aTitle = U(sTitle);
	return SbaXContent::_initialize( aParent, aUrl, rUrlObj);
}

// ------------------------------------------------------------------------
::com::sun::star::uno::Any SbaXRelationsContent::_getPropertyValue( sal_uInt16 _nID ) const
{
	::com::sun::star::uno::Any aAny;
	switch (_nID)
	{
		case PROP_ID_TARGETS:
			aAny <<= ::rtl::OUString::createFromAscii("_top;_blank");
			break;
		case PROP_ID_TITLE:
			aAny<<=aTitle;
			break;
		case PROP_ID_IS_FOLDER:
			{
				sal_Bool bB(sal_False);
				aAny.setValue( &bB,::getBooleanCppuType());
			}
			break;

		case PROP_ID_CONTENT_TYPE:
		case PROP_ID_SMALL_IMAGE:
		case PROP_ID_BIG_IMAGE:
		case PROP_ID_MASK_COLOR:
			return SbaXContent::_getPropertyValue( _nID );
			break;
	}
	return aAny;
}

// ------------------------------------------------------------------------
void SbaXRelationsContent::executeImpl( const ::rtl::OUString& aCmd, const ::com::sun::star::uno::Any& aParam, const ::com::sun::star::uno::Reference< ::com::sun::star::chaos::XStatusCallback > & rCallback )
{
	::com::sun::star::chaos::StatusCallbackEvent aEvt(*this, *this, aCmd, aParam);
	rCallback->done( aEvt );
}


