/*************************************************************************
 *
 *  $RCSfile: api.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <api.hrc>
#include <api.hxx>

#ifndef _COM_SUN_STAR_FRAME_XCONFIGMANAGER_HPP_
#include <com/sun/star/frame/XConfigManager.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XDATABASEMETADATA_HPP_
#include <com/sun/star/sdbc/XDatabaseMetaData.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _RTL_UUID_H_
#include <rtl/uuid.h>
#endif
#ifndef _FSYS_HXX
#include <tools/fsys.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _SDB_SDBSTAT_HXX
#include <sdb/sdbstat.hxx>
#endif
#ifndef _SDB_VARIANT_HXX
#include <sdb/variant.hxx>
#endif

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::sdbc;
using namespace ::cppu;
using namespace ::osl;


//************************************************************
// PropertyNames
//************************************************************
namespace offmgr_disambiguate
{
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TITLE, "Title");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_URL, "URL");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CONNECTURL, "ConnectURL");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CONNECTINFO, "ConnectInfo");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PASSWORDREQUIRED, "IsPasswordRequired");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TABLEFILTER, "TableFilter");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_NAME, "Name");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_SCHEMANAME, "SchemaName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CATALOGNAME, "CatalogName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PRIVILEGES, "Privileges");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_USE_ESCAPE_PROCESSING, "EscapeProcessing");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_COMMAND, "Command");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TYPE, "Type");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TYPENAME, "TypeName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PRECISION, "Precision");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_SCALE, "Scale");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISNULLABLE, "IsNullable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISAUTOINCREMENT, "IsAutoIncrement");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISROWVERSION, "IsRowVersion");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DESCRIPTION, "Description");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DEFAULTVALUE, "DefaultValue");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_NUMBERFORMAT, "FormatKey");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_QUERYTIMEOUT, "QueryTimeOut");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_MAXFIELDSIZE, "MaxFieldSize");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_MAXROWS, "MaxRows");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CURSORNAME, "CursorName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_RESULTSETCONCURRENCY, "ResultSetConcurrency");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_RESULTSETTYPE, "ResultSetType");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FETCHDIRECTION, "FetchDirection");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FETCHSIZE, "FetchSize");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_USEBOOKMARKS, "UseBookmarks");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISSEARCHABLE, "IsSearchable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISCURRENCY, "IsCurrency");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISSIGNED, "IsSigned");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DISPLAYSIZE, "DisplaySize");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_LABEL, "Label");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISREADONLY, "IsReadOnly");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISWRITABLE, "IsWritable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISDEFINITELYWRITABLE, "IsDefinitelyWritable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_VALUE, "Value");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TABLENAME, "TableName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISCASESENSITIVE, "IsCaseSensitive");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_SERVICENAME, "ServiceName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISBOOKMARKABLE, "IsBookmarkable");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CANUPDATEINSERTEDROWS, "CanUpdateInsertedRows");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISSET, "IsSet");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISOUTPARAMETER, "IsOutParameter");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_NUMBERFORMATSSUPPLIER, "NumberFormatsSupplier");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISCALCULATED, "IsCalculated");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_DATASOURCENAME, "DataSourceName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TRANSACTIONISOLATION, "TransactionIsolation");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TYPEMAP, "TypeMap");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_USER, "User");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_PASSWORD, "Password");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_COMMANDTYPE, "CommandType");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ACTIVECOMMAND, "ActiveCommand");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ACTIVECONNECTION, "ActiveConnection");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISINSERTONLY, "IgnoreResult");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FILTER, "Filter");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_APPLYFILTER, "ApplyFilter");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ORDER, "Order");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISMODIFIED, "IsModified");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISNEW, "IsNew");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ROWCOUNT, "RowCount");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ISROWCOUNTFINAL, "IsRowCountFinal");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_THREADSAFE, "ThreadSafe");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_HELPFILENAME, "HelpFileName");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_WIDTH, "Width");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ROW_HEIGHT, "RowHeight");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FORMATKEY, "FormatKey");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_ALIGN, "Align");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_FONT, "FontDescriptor");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_TEXTCOLOR, "TextColor");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_BOUNDFIELD, "BoundField");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_CONTROLSOURCE, "DataField");
IMPLEMENT_CONSTASCII_USTRING(PROPERTY_REALNAME, "RealName");
} // namespace offmgr_disambiguate

//************************************************************
// ServiceNames
//************************************************************
namespace offmgr_disambiguate
{
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_RESULTSET, "com.sun.star.sdbc.ResultSet");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_ROWSET, "com.sun.star.sdbc.RowSet");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_STATEMENT, "com.sun.star.sdbc.Statement");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_PREPAREDSTATEMENT, "com.sun.star.sdbc.PreparedStatement");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_CALLABLESTATEMENT, "com.sun.star.sdbc.CallableStatement");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBC_CONNECTION, "com.sun.star.sdbc.Connection");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBCX_CONTAINER, "com.sun.star.sdbcx.Container");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBCX_TABLE, "com.sun.star.sdbcx.Table");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDBCX_RESULTSET, "com.sun.star.sdbcx.ResultSet");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_CONNECTION, "com.sun.star.sdb.Connection");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_COLUMN, "com.sun.star.sdb.Column");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_DATACOLUMN, "com.sun.star.sdb.DataColumn");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_PARAMETER, "com.sun.star.sdb.Parameter");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_DATAACCESS, "com.sun.star.sdb.DatabaseAccess");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_DATAACCESSCONNECTION, "com.sun.star.sdb.DataAccessConnection");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_DATABASEENVIRONMENT, "com.sun.star.sdb.DatabaseEnvironment");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_DATABASEACCESSCONTEXT, "com.sun.star.sdb.DatabaseAccessContext");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_RESULTSET, "com.sun.star.sdb.ResultSet");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_ROWSET, "com.sun.star.sdb.RowSet");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_STATEMENT, "com.sun.star.sdb.Statement");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_PREPAREDSTATMENT, "com.sun.star.sdb.PreparedStatement");
IMPLEMENT_CONSTASCII_USTRING(SERVICE_SDB_SQLQUERYCOMPOSER, "com.sun.star.sdb.SQLQueryComposer");
} // namespace offmgr_disambiguate

//************************************************************
//  SQLException_Impl
//************************************************************
//------------------------------------------------------------------------------
SQLException_Impl::SQLException_Impl(const SdbStatus& rStat, const Reference< XInterface > & xCont)
{
	Message = UniString(rStat.ErrorMessage());
	Context = xCont;
	SQLState = UniString(rStat.SQLState());
	ErrorCode = rStat.NativeErrorCode();
	if (rStat.ErrorInfo().Len())
	{
		SQLException_Impl aInfo(UniString(rStat.ErrorInfo()));
		NextException.setValue(&aInfo, ::getCppuType((const SQLException*)0));
	}
}

//------------------------------------------------------------------------------
SQLException_Impl::SQLException_Impl(const UniString& rDescription)
{
	Message = rDescription;
}

//------------------------------------------------------------------------------
void checkResult(const SdbStatus& rStat, const Reference< XInterface >& xCont, sal_Bool bWrapp) throw( SQLException, WrappedTargetException )
{
	if (rStat.Result() == SDB_STAT_ERROR)
	{
		if (bWrapp)
		{
			SQLException_Impl aExcept(rStat, xCont);
			throw WrappedTargetException(rtl::OUString(), xCont, Any(&aExcept, ::getCppuType((const SQLException*)0)));
		}
		else
			throw SQLException_Impl(rStat, xCont);
	}
}

// Helper
//------------------------------------------------------------------------------
void throwSequenceError(const Reference< XInterface > & xCont) throw( SQLException )
{
	SdbStatus aSdbStat;
	aSdbStat.SetSequenceError();
	checkResult(aSdbStat, xCont, sal_False);
}


//************************************************************
//  OSubComponent
//************************************************************
//--------------------------------------------------------------------------
OSubComponent::OSubComponent(::osl::Mutex& _rMutex, const Reference< XInterface > & xParent)
			  :OComponentHelper(_rMutex)
			  ,m_xParent(xParent)
{
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > OSubComponent::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XComponent > *)0 ),
						   ::getCppuType( (const Reference< XWeak > *)0 ));

	return aTypes.getTypes();
}

// XInterface
//--------------------------------------------------------------------------
void OSubComponent::acquire() throw (RuntimeException)
{
	OComponentHelper::acquire();
}

//--------------------------------------------------------------------------
void OSubComponent::release() throw (RuntimeException)
{
	Reference< XInterface > x( xDelegator );
	if (! x.is())
	{
		if (osl_decrementInterlockedCount( &m_refCount ) == 0)
		{
			if (! rBHelper.bDisposed)
			{
				Reference< XInterface > xHoldAlive( *this );

				// remember the parent
				Reference< XInterface > xParent;
				{
					::osl::MutexGuard aGuard( rBHelper.rMutex );
					xParent = m_xParent;
					m_xParent = NULL;
				}

				// First dispose
				dispose();

				// only the alive ref holds the object
				OSL_ASSERT( m_refCount == 1 );

				// release the parent in the ~
				if (xParent.is())
				{
					MutexGuard aGuard( rBHelper.rMutex );
					m_xParent = xParent;
				}

				// destroy the object if xHoldAlive decrement the refcount to 0
				return;
			}
		}
		// restore the reference count
		osl_incrementInterlockedCount( &m_refCount );
	}

	// as we cover the job of the componenthelper we use the ...
	OWeakAggObject::release();
}

//--------------------------------------------------------------------------
Any OSubComponent::queryInterface( const Type & rType ) throw(RuntimeException)
{
	Any aReturn;
	if (!rType.equals(::getCppuType(static_cast< Reference< XAggregation >* >(NULL))))
		aReturn = OComponentHelper::queryInterface(rType);

	return aReturn;
}

//--------------------------------------------------------------------------
void OSubComponent::disposing()
{
	MutexGuard aGuard( rBHelper.rMutex );
	m_xParent = NULL;
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > OServerComponent::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XUnoTunnel > *)0 ),
						   OSubComponent::getTypes());

	return aTypes.getTypes();
}

//------------------------------------------------------------------------------
void OServerComponent::acquire() throw (RuntimeException)
{
	OSubComponent::acquire();
}

//------------------------------------------------------------------------------
void OServerComponent::release() throw (RuntimeException)
{
	OSubComponent::release();
}

//------------------------------------------------------------------------------
Any OServerComponent::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OSubComponent::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(rType,	static_cast< XUnoTunnel * >( this ) );
	return aIface;
}

//------------------------------------------------------------------------------
void OServerComponent::appendStub(const Reference< XInterface > & xStub)
{
	m_aStubs.push_back(WeakReferenceHelper(xStub));
}

//------------------------------------------------------------------------------
void OServerComponent::disposing()
{
	MutexGuard aGuard(*m_pMutex);
	for (OWeakRefArray::iterator i = m_aStubs.begin(); m_aStubs.end() != i; i++)
	{
		Reference< XComponent > xComp((*i).get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aStubs.clear();
	OSubComponent::disposing();
}

// com::sun::star::lang::XUnoTunnel
//------------------------------------------------------------------
sal_Int64 OServerComponent::getSomething( const Sequence< sal_Int8 > & rId ) throw (RuntimeException)
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

//************************************************************
//  OStubComponent
//************************************************************
//------------------------------------------------------------------------------
OStubComponent::OStubComponent(OServerComponent& rServer)
	           :OShared(rServer.m_pMutex)
			   ,OSubComponent(*m_pMutex, rServer)
{
	osl_incrementInterlockedCount( &m_refCount );
	{
		Reference <XInterface> xStub(*this);
		rServer.appendStub(xStub);
	}

	sal_Int32 n = osl_decrementInterlockedCount( &m_refCount );
	DBG_ASSERT(n == 0, "OStubObject::Invalid RefCount");
}

//------------------------------------------------------------------------------
sal_Int64 OStubComponent::getServer(const Sequence< sal_Int8 >& _rId) const throw( DisposedException )
{
	if (!m_xParent.is())
		throw DisposedException();

	return Reference<XUnoTunnel>(m_xParent,UNO_QUERY)->getSomething(_rId);
}


// hash classes
//************************************************************
size_t OBookmarkHash::operator() (const Any& rBookmark) const
{
	switch (rBookmark.getValueTypeClass())
	{
		case TypeClass_VOID:
			return 0;
		case TypeClass_BOOLEAN:
		case TypeClass_CHAR:
		case TypeClass_BYTE:
		case TypeClass_FLOAT:
		case TypeClass_DOUBLE:
		case TypeClass_SHORT:
		case TypeClass_LONG:
		case TypeClass_HYPER:
			return *(size_t *)rBookmark.getValue();
		case TypeClass_STRING:
		{
			rtl::OUString aString;
			rBookmark >>= aString;
			return aString.hashCode();
		}
		default:
			if (rBookmark.getValueType() == ::getCppuType((const Sequence< sal_Int8 > *)0))
			{
				const Sequence<sal_Int8>& rLeftSeq = *(Sequence<sal_Int8> *)rBookmark.getValue();
				register const sal_Int8* p = rLeftSeq.getConstArray();
				register sal_Int32 nLen = rLeftSeq.getLength(), i = 0;
				register size_t nHash = 0;
				for (; i < nLen; i++)
					nHash = (nHash << 1) + *(p++);
				return nHash;
			}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Bool OBookmarkEqual::operator() (const Any& lhs, const Any& rhs) const
{
	return ::areEqual(lhs, rhs);
}

// helper methods
//************************************************************
sal_Bool hasString(const Sequence< rtl::OUString >& rStrings, const rtl::OUString& rString)
{
	const rtl::OUString * pArray = rStrings.getConstArray();
	for( sal_Int32 i = 0; i < rStrings.getLength(); i++ )
		if ( pArray[i] == rString )
			return sal_True;
	return sal_False;
}

//--------------------------------------------------------------------------
sal_Int32 compareURLs(const rtl::OUString& _rUrlLeft, const rtl::OUString& _rUrlRight)
{
	INetURLObject aLeft(_rUrlLeft);
	INetURLObject aRight(_rUrlRight);
	if (aLeft == aRight)
		return 0;
	if (aLeft < aRight)
		return -1;
	return 1;
}

//--------------------------------------------------------------------------
void substFileURLVars(rtl::OUString& _rUrl)
{
	Reference< ::com::sun::star::frame::XConfigManager > xSofficeIni(
		::utl::getProcessServiceFactory()->createInstance(rtl::OUString::createFromAscii("com.sun.star.config.SpecialConfigManager")), UNO_QUERY);
	if (xSofficeIni.is())
		_rUrl = xSofficeIni->substituteVariables(_rUrl);
}

//------------------------------------------------------------------------------
String getProgrammaticUrl(const String& _rSdbFile)
{
	DirEntry aSdbFileEntry(_rSdbFile);
	if (!aSdbFileEntry.GetExtension().Len())
		aSdbFileEntry.SetExtension(String::CreateFromAscii("sdb"));

	INetURLObject aObj, aFileRef;
	aFileRef.SetSmartProtocol(INET_PROT_FILE);
	aFileRef.SetSmartURL(aSdbFileEntry.GetFull());
	return aFileRef.GetMainURL();
}



