/*************************************************************************
 *
 *  $RCSfile: dataaccess.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <dataaccess.hxx>
#include <dataaccessconnection.hxx>
#include <api.hrc>

#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEACCESSLISTENER_HPP_
#include <com/sun/star/sdb/XDatabaseAccessListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATE_HPP_
#include <com/sun/star/beans/PropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HDL_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _UNOTOOLS_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen wg. INetURLObject
#include <tools/urlobj.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif
#ifndef _SBA_ENVIRONMENT_HXX
#include <environment.hxx>
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::cppu;
using namespace ::osl;

DBG_NAME(ODatabaseAccess);

//--------------------------------------------------------------------------
ODatabaseAccess::ODatabaseAccess(OEnvironment& rEnv, const SbaDatabaseRef& xDB)
				:OSubComponent(m_aMutex, static_cast<XWeak*>(&rEnv))
				,OPropertySetHelper(OComponentHelper::rBHelper)
				,m_aListeners(m_aMutex)
				,m_nLoginTimeout(0)
				,m_xDatabase(xDB)
{
	DBG_CTOR(ODatabaseAccess,NULL);
	m_nLoginTimeout = rEnv.getLoginTimeout();
}

//--------------------------------------------------------------------------
ODatabaseAccess::~ODatabaseAccess()
{
	DBG_DTOR(ODatabaseAccess,NULL);
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > ODatabaseAccess::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XPropertySet > *)0 ),
						   ::getCppuType( (const Reference< XFastPropertySet > *)0 ),
						   ::getCppuType( (const Reference< XDatabaseAccess > *)0 ),
						   ::getCppuType( (const Reference< XUnoTunnel > *)0 ),
						   ::getCppuType( (const Reference< XServiceInfo > *)0 ),
							OSubComponent::getTypes() );

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccess::getUnoTunnelImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccess::getImplementationId() throw (RuntimeException)
{
	return getUnoTunnelImplementationId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any ODatabaseAccess::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OSubComponent::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XPropertySet * >( this ),
					static_cast< XFastPropertySet * >( this ),
					static_cast< XDatabaseAccess * >( this ),
					static_cast< XDataSource * >( this ),
					static_cast< XUnoTunnel * >( this ),
					static_cast< XServiceInfo * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void ODatabaseAccess::acquire() throw (RuntimeException)
{
	OSubComponent::acquire();
}

//--------------------------------------------------------------------------
void ODatabaseAccess::release() throw (RuntimeException)
{
	OSubComponent::release();
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccess::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.ODatabaseAccess");
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccess::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > ODatabaseAccess::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< ::rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDB_DATAACCESS;
	return aSNS;
}

// com::sun::star::lang::XUnoTunnel
//------------------------------------------------------------------
sal_Int64 ODatabaseAccess::getSomething( const Sequence< sal_Int8 > & rId ) throw (RuntimeException)
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

// OComponentHelper
//------------------------------------------------------------------------------
void ODatabaseAccess::disposing()
{
	OPropertySetHelper::disposing();

	EventObject aEvt(*this);
	m_aListeners.disposeAndClear(aEvt);

	MutexGuard aGuard(m_aMutex);
	Reference< XConnection > xCon(m_aSharedConnection);
	if (xCon.is())
		xCon->close();

	for (OWeakConnectionArray::iterator i = m_aIsolatedConnections.begin(); m_aIsolatedConnections.end() != i; i++)
	{
		xCon = *i;
		if (xCon.is())
			xCon->close();
	}
	m_aIsolatedConnections.clear();
	m_xDatabase = NULL;
	m_xNumberFormatsSupplier = NULL;
}

// helper
//------------------------------------------------------------------------------
Sequence< PropertyValue > ODatabaseAccess::toConnectionProperties(const String& rConnectStr)
{
	CommandParser aOptionsParser(rConnectStr,';','=',sal_True);
	sal_Int32 nCount = aOptionsParser.OptionCount();

	Sequence< PropertyValue > aPropertySequence(nCount);
	PropertyValue* pArray = aPropertySequence.getArray();

	// Password nicht mit rausgeben
	sal_Int32 nPwdPos(-1);
	for (sal_Int32 i = 0, j = 0; i < nCount; i++)
	{
		String aKey(aOptionsParser.OptionName(i));
		String aValue(aOptionsParser.OptionString(i));

		if ((aKey.EqualsAscii("TYP")) ||
			(aKey.EqualsAscii("PWD")) ||
			(aKey.EqualsAscii("DSN")) ||
			(aKey.EqualsAscii("URL")))
			continue;
		pArray[j] = PropertyValue(UniString(aKey),-1,
								  Any(&aValue, ::getCppuType((const rtl::OUString*)0)),
								  PropertyState_DIRECT_VALUE);
		++j;
	}

	// shrink the sequence if necessary
	if (j < i)
		aPropertySequence.realloc(j);

	return aPropertySequence;
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccess::toConnectionURL(const String& rConnectStr)
{
	CommandParser aOptionsParser(rConnectStr,';','=',sal_True);

	// retrieve the type
	String aType = aOptionsParser.OptionString(String::CreateFromAscii("TYP"));
	if (aType.EqualsIgnoreCaseAscii("TYP"))
		return UniString(aOptionsParser.OptionString(String::CreateFromAscii("URL")));
	else if (aType.Len())
	{
		String aUrl;
		aUrl.AssignAscii("sdbc:");
		if (aType.CompareIgnoreCaseToAscii("Adabas"))
			aUrl.AppendAscii("AdabasD");
		else if (aType.CompareIgnoreCaseToAscii("DBF"))
			aUrl.AppendAscii("dBase");
		else if (aType.CompareIgnoreCaseToAscii("TXT"))
			aUrl.AppendAscii("Text");
		else
			aUrl.AppendAscii("Type");
		aUrl += ':';
		aUrl += aOptionsParser.OptionString(String::CreateFromAscii("DSN"));

		return UniString(aUrl);
	}
	else
		return rtl::OUString();
}

//------------------------------------------------------------------------------
String ODatabaseAccess::toConnectionStr(const rtl::OUString& rUrl, const String& rConnectStr)
{
	String sURL(rUrl);
	xub_StrLen nPos = 0;
	String aType = sURL.GetToken(0, ':', nPos);
	String aConnectStr;
	String aInfo;

	if (rConnectStr.Len())
	{
		static const char* pOptions = "TYP;URL;DSN";
		static String sOptions = String::CreateFromAscii(pOptions);
		CommandParser aOptionsParser(rConnectStr,';','=',sal_True);
		aOptionsParser.Compose(aInfo, sOptions);
	}

	/* currently available drivers
	// Jdbc
	jdbc:oracle:Test

	// Sdbc
	sdbc:Text
	sdbc:ODBC:
	sdbc:AdabasD:
	sdbc:dBase:
	sdbc:DAO:
	sdbc:ADO:
	sdbc:DB2:
	sdbc:StarBase: */

	if (aType.CompareIgnoreCaseToAscii("jdbc") == COMPARE_EQUAL)
	{
		// take the url as it is
		aConnectStr.AppendAscii("TYP=JDBC;");
		aConnectStr.AppendAscii("URL=");
		aConnectStr += sURL;
		aConnectStr += ';';
		aConnectStr += aInfo;
	}
	else if (aType.CompareIgnoreCaseToAscii("sdbc") == COMPARE_EQUAL)
	{
		aType = sURL.GetToken(0, ':', nPos);

		if (aType.CompareIgnoreCaseToAscii("AdabasD")  == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=Adabas;");
		else if (aType.CompareIgnoreCaseToAscii("ODBC") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=ODBC;");
		else if (aType.CompareIgnoreCaseToAscii("dBase") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=DBF;");
		else if (aType.CompareIgnoreCaseToAscii("Orcl7") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=Orcl7;");
		else if (aType.CompareIgnoreCaseToAscii("DB2") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=DB2;");
		else if (aType.CompareIgnoreCaseToAscii("DAO") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=DAO;");
		else if (aType.CompareIgnoreCaseToAscii("ADO") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=ADO;");
		else if (aType.CompareIgnoreCaseToAscii("StarBase") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=StarBase;");
		else if (aType.CompareIgnoreCaseToAscii("Text") == COMPARE_EQUAL)
			aConnectStr.AppendAscii("TYP=TXT;");
		else
			throw SQLException();

		aConnectStr.AppendAscii("DSN=");
		aConnectStr += sURL.Copy(nPos);
		aConnectStr += ';';
		aConnectStr += aInfo;
	}
	else
		throw SQLException();

	aConnectStr.EraseLeadingChars(';');
	aConnectStr.EraseTrailingChars(';');
	return aConnectStr;
}

//------------------------------------------------------------------------------
String ODatabaseAccess::toConnectionStr(const Sequence< PropertyValue >& aProperties)
{
	const PropertyValue* pArray = aProperties.getConstArray();
	sal_Int32 nCount = aProperties.getLength();
	String aConnectStr;
	for (sal_Int32 i = 0; i < nCount; i++)
	{
		String aKey(pArray[i].Name);
		rtl::OUString aValue;
		pArray[i].Value >>= aValue;
		String aStrValue(aValue);

		// sdb specific token
		if (aKey.CompareIgnoreCaseToAscii( "User") == COMPARE_EQUAL)
			aKey.AssignAscii("UID");
		if (aKey.CompareIgnoreCaseToAscii("Password") == COMPARE_EQUAL)
			aKey.AssignAscii("PWD");

		(((aConnectStr += aKey) += '=') += aStrValue) += ';';
	}
	aConnectStr.EraseTrailingChars(';');
	return aConnectStr;
}

//------------------------------------------------------------------------------
const Reference< ::com::sun::star::util::XNumberFormatsSupplier > & ODatabaseAccess::getNumberFormatsSupplier()
{
	if (!m_xNumberFormatsSupplier.is())
		m_xNumberFormatsSupplier = new SvNumberFormatsSupplierObj(m_xDatabase->GetFormatter());
	return m_xNumberFormatsSupplier;
}


// OPropertySetHelper
//------------------------------------------------------------------------------
Reference< XPropertySetInfo >  ODatabaseAccess::getPropertySetInfo() throw (RuntimeException)
{
	return createPropertySetInfo( getInfoHelper() ) ;
}

// utl::OPropertyArrayUsageHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper* ODatabaseAccess::createArrayHelper( ) const
{
	BEGIN_PROPERTY_HELPER(7)
		DECL_PROP0(CONNECTINFO,				Sequence< PropertyValue >);
		DECL_PROP0(CONNECTURL,				::rtl::OUString);
		DECL_PROP1_BOOL(ISREADONLY,			READONLY);
		DECL_PROP1(NUMBERFORMATSSUPPLIER,	Reference< ::com::sun::star::util::XNumberFormatsSupplier >,	BOUND);
		DECL_PROP1_BOOL(THREADSAFE,			READONLY);
		DECL_PROP1(TITLE,					::rtl::OUString,		BOUND);
		DECL_PROP1(URL,						::rtl::OUString,		READONLY);
	END_PROPERTY_HELPER();
}

// cppu::OPropertySetHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper& ODatabaseAccess::getInfoHelper()
{
	return *getArrayHelper();
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccess::convertFastPropertyValue(Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( IllegalArgumentException  )
{
	if (m_xDatabase->IsReadOnly())
		throw IllegalArgumentException();

	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROPERTY_ID_TITLE:
		{
			rtl::OUString aTitle(UniString(m_xDatabase->Title()));
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, aTitle);
			if (bModified)
			{
				rConvertedValue >>= aTitle;
				m_xDatabase->AlterTitle(aTitle);
			}
			if (m_xDatabase->Status().IsError())
				throw IllegalArgumentException();

		}	break;
		case PROPERTY_ID_CONNECTURL:
		{
			getFastPropertyValue(rOldValue, nHandle);
			rtl::OUString aUrl;
			rOldValue >>= aUrl;
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, aUrl);
			if (bModified)
			{
				rConvertedValue >>= aUrl;
				m_xDatabase->AlterConnection(toConnectionStr(aUrl, m_xDatabase->ConnectStr()));
			}

			if (m_xDatabase->Status().IsError())
				throw IllegalArgumentException();

		}	break;
		case PROPERTY_ID_NUMBERFORMATSSUPPLIER:
		{
			if (rValue.getValueType() != ::getCppuType( (const Reference< ::com::sun::star::util::XNumberFormatsSupplier > *)0 ))
				throw IllegalArgumentException();

			Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier;
			rValue >>= xSupplier;
			if (!SvNumberFormatsSupplierObj::getImplementation(xSupplier))
				throw IllegalArgumentException();

			bModified = sal_True;
			rConvertedValue = rValue;
			rOldValue <<= getNumberFormatsSupplier();
			DBG_ERROR("AlterFormatter is missing");
		}	break;
		case PROPERTY_ID_CONNECTINFO:
		{
			getFastPropertyValue(rOldValue, nHandle);
			if (rValue.getValueType() != ::getCppuType((const Sequence<PropertyValue>*)0))
				throw IllegalArgumentException();

			Sequence<PropertyValue> aValues;
			rValue >>= aValues;
			m_xDatabase->AlterConnection(toConnectionStr(toConnectionURL(m_xDatabase->ConnectStr()), toConnectionStr(aValues)));
			if (m_xDatabase->Status().IsError())
				throw IllegalArgumentException();

			rConvertedValue = rValue;
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void ODatabaseAccess::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw (Exception)
{
}

//------------------------------------------------------------------------------
void ODatabaseAccess::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_THREADSAFE:
			rValue = bool2any(m_xDatabase.Is() && m_xDatabase->IsCapable(SDB_CAP_MULTITHREADACCESS));
			break;
		case PROPERTY_ID_ISREADONLY:
			rValue = bool2any(m_xDatabase->IsReadOnly());
			break;
		case PROPERTY_ID_CONNECTINFO:
		{
			Sequence<PropertyValue> aValues(toConnectionProperties(m_xDatabase->ConnectStr()));
			rValue <<= aValues;
		}	break;
		case PROPERTY_ID_CONNECTURL:
			rValue <<= toConnectionURL(m_xDatabase->ConnectStr());
			break;
		case PROPERTY_ID_NUMBERFORMATSSUPPLIER:
			rValue <<= const_cast<ODatabaseAccess*>(this)->getNumberFormatsSupplier();
			break;
		case PROPERTY_ID_TITLE:
			rValue <<= rtl::OUString(UniString(m_xDatabase->Title()));
			break;
		case PROPERTY_ID_URL:
		{
			INetURLObject aObj;
			aObj.SetSmartProtocol(INET_PROT_FILE);
			aObj.SetSmartURL(m_xDatabase->Name());
			rValue <<= rtl::OUString(aObj.GetMainURL());
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
}

// XDataSource
//------------------------------------------------------------------------------
void ODatabaseAccess::setLoginTimeout(sal_Int32 seconds) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	m_nLoginTimeout = seconds;
}

//------------------------------------------------------------------------------
sal_Int32 ODatabaseAccess::getLoginTimeout(void) throw( SQLException, RuntimeException )
{
	return m_nLoginTimeout;
}

//------------------------------------------------------------------------------
Reference< XConnection > ODatabaseAccess::getConnection(const rtl::OUString& user, const rtl::OUString& password) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	// do we have a valid shared
	Reference< XConnection > xCon(m_aSharedConnection);
	if (xCon.is())
	{
		// do we have the same user?
		if (!user.len() || user == m_aSharedUser)
		{
			ODatabaseAccessConnection* pImpl =
				reinterpret_cast<ODatabaseAccessConnection*>(Reference<XUnoTunnel>(xCon,UNO_QUERY)->getSomething(ODatabaseAccessConnection::getUnoTunnelId()));
			return new ODatabaseAccessConnectionStub(*pImpl);
		}
		else
			return getIsolatedConnection(user, password);
	}
	else
		m_aSharedConnection = Reference< XConnection >();

	// now we get a new shared name
	if (m_xDatabase->IsOpen())
	{
		m_aSharedUser = UniString(m_xDatabase->GetUser());
		if (!user.len() || user == m_aSharedUser)
		{
			ODatabaseAccessConnection* pImpl = new ODatabaseAccessConnection(*this, m_xDatabase);
			xCon = pImpl;
			m_aSharedConnection = xCon;
			return new ODatabaseAccessConnectionStub(*pImpl);
		}
		else
			return getIsolatedConnection(user, password);
	}
	else
	{
		SdbEnvironmentRef m_xSdbEnv;
		SbaDatabaseRef xDB = (SbaDatabase*)m_xSdbEnv->OpenDatabase(m_xDatabase->Name());
		checkResult(m_xSdbEnv->Status(), *this, sal_False);

		// this must be the same instance
		DBG_ASSERT(xDB == m_xDatabase, "ODatabaseAccess::connect() wrong instance");

		// remember the user
		m_aSharedUser = user;
		ODatabaseAccessConnection* pImpl = new ODatabaseAccessConnection(*this, m_xDatabase);
		xCon = pImpl;
		m_aSharedConnection = xCon;

		EventObject aEvt(*this);
		OInterfaceIteratorHelper aIter(m_aListeners);
		while (aIter.hasMoreElements())
			((XDatabaseAccessListener*)aIter.next())->connectionChanged(aEvt);

		return new ODatabaseAccessConnectionStub(*pImpl);
	}
	return NULL;
}

// XDatabaseAccess
//------------------------------------------------------------------------------
sal_Bool ODatabaseAccess::hasConnections(void) throw( RuntimeException )
{
	{
		MutexGuard aGuard(m_aMutex);
		if (m_xDatabase.Is() && m_xDatabase->IsOpen())
			return sal_True;
	}
	return sal_False;
}

//------------------------------------------------------------------------------
Reference< XConnection >  ODatabaseAccess::getIsolatedConnection(const rtl::OUString& user, const rtl::OUString& password) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	// create a new workspace
	SdbEnvironmentRef m_xSdbEnv;

	// use a tmp name
	SdbWorkspaceRef xWsp = m_xSdbEnv->CreateWorkspace(String());
	SbaDatabaseRef xDB = (SbaDatabase*)xWsp->OpenDatabase(m_xDatabase->Name());
	checkResult(m_xSdbEnv->Status(), *this, sal_False);

	// this must be the same instance
	DBG_ASSERT(xDB != m_xDatabase, "ODatabaseAccess::connect() wrong instance");

	Reference< XConnection > xCon = new ODatabaseAccessConnection(*this, xDB, xWsp);
	m_aIsolatedConnections.push_back(OWeakConnection(xCon));
	return xCon;
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccess::suspendConnections(void) throw( SQLException, RuntimeException )
{
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	if (hasConnections())
	{
		// ask if the suspending is allowed?
		EventObject aEvt(*this);
		OInterfaceIteratorHelper aApproveIter(m_aListeners);
		while (aApproveIter.hasMoreElements())
		{
			if (!((XDatabaseAccessListener*)aApproveIter.next())->approveConnectionClosing(aEvt))
				return sal_False;
		}

		// notify that the connections are about to be disposed
		OInterfaceIteratorHelper aIter(m_aListeners);
		while (aIter.hasMoreElements())
			((XDatabaseAccessListener*)aIter.next())->connectionClosing(aEvt);

		// dispose them
		MutexGuard aGuard(m_aMutex);
		Reference< XConnection > xCon(m_aSharedConnection);
		if (xCon.is())
			xCon->close();
		m_aSharedConnection = Reference< XConnection >();

		for (OWeakConnectionArray::iterator i = m_aIsolatedConnections.begin(); m_aIsolatedConnections.end() != i; i++)
		{
			xCon = *i;
			if (xCon.is())
				xCon->close();
		}
		m_aIsolatedConnections.clear();
	}
	return sal_True;
}

//------------------------------------------------------------------------------
void ODatabaseAccess::addDatabaseAccessListener(const Reference< XDatabaseAccessListener > & listener) throw( RuntimeException )
{
	m_aListeners.addInterface(listener);
}

//------------------------------------------------------------------------------
void ODatabaseAccess::removeDatabaseAccessListener(const Reference< XDatabaseAccessListener > & listener) throw( RuntimeException )
{
	m_aListeners.removeInterface(listener);
}



