/*************************************************************************
 *
 *  $RCSfile: dataaccessconnection.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <dataaccessconnection.hxx>
#include <dataaccess.hxx>
#include <statement.hxx>
#include <preparedstatement.hxx>
#include <callablestatement.hxx>
#include <querycomposer.hxx>
#include <api.hrc>

#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_TRANSACTIONISOLATION_HPP_
#include <com/sun/star/sdbc/TransactionIsolation.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEISOLATIONLEVEL_HPP_
#include <com/sun/star/data/DatabaseIsolationLevel.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::osl;
using namespace ::cppu;

DBG_NAME(ODatabaseAccessConnection);

//--------------------------------------------------------------------------
ODatabaseAccessConnection::ODatabaseAccessConnection(ODatabaseAccess& rAccess,
													 const SbaDatabaseRef& xDB,
													 const SdbWorkspaceRef& xWsp)
						  :OConnectionBase((XUnoTunnel*)&rAccess)
						  ,m_xDatabase(xDB)
						  ,m_xWsp(xWsp)
						  ,m_aTables(*this)
						  ,m_aQueries(*this)
						  ,m_aMetaData(*this)
{
	DBG_CTOR(ODatabaseAccessConnection,NULL);
	m_bReadOnly = !m_xDatabase->GetConnection()->IsCapable(SDB_CAP_UPDATABLE);
}

//--------------------------------------------------------------------------
ODatabaseAccessConnection::~ODatabaseAccessConnection()
{
	DBG_DTOR(ODatabaseAccessConnection,NULL);
}


// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > ODatabaseAccessConnection::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XConnection > *)0 ),
						   ::getCppuType( (const Reference< XServiceInfo > *)0 ),
						   ::getCppuType( (const Reference< ::com::sun::star::container::XChild > *)0 ),
						   ::getCppuType( (const Reference< XWarningsSupplier > *)0 ),
						   ::getCppuType( (const Reference< XTablesSupplier > *)0 ),
						   ::getCppuType( (const Reference< XQueriesSupplier > *)0 ),
						   ::getCppuType( (const Reference< XSQLQueryComposerFactory > *)0 ),
						   OConnectionBase::getTypes());

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccessConnection::getUnoTunnelId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccessConnection::getImplementationId() throw (RuntimeException)
{
	return getUnoTunnelId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any ODatabaseAccessConnection::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OConnectionBase::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XConnection * >( this ),
					static_cast< XCloseable * >( this ),
					static_cast< XServiceInfo * >( this ),
					static_cast< ::com::sun::star::container::XChild * >( this ),
					static_cast< XWarningsSupplier * >( this ),
					static_cast< XTablesSupplier * >( this ),
					static_cast< XQueriesSupplier * >( this ),
					static_cast< XSQLQueryComposerFactory * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void ODatabaseAccessConnection::acquire() throw (RuntimeException)
{
	OConnectionBase::acquire();
}

//--------------------------------------------------------------------------
void ODatabaseAccessConnection::release() throw (RuntimeException)
{
	OConnectionBase::release();
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnection::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.ODatabaseAccessConnection");
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnection::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > ODatabaseAccessConnection::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< ::rtl::OUString > aSNS( 2 );
	aSNS[0] = SERVICE_SDBC_CONNECTION;
	aSNS[1] = SERVICE_SDB_CONNECTION;
	return aSNS;
}

// OConnectionBase
//------------------------------------------------------------------------------
void ODatabaseAccessConnection::disposing()
{
	MutexGuard aGuard(*m_pMutex);

	OConnectionBase::disposing();
	m_aTables.disposing();
	m_aQueries.disposing();

	for (OWeakRefArray::iterator i = m_aStatements.begin(); m_aStatements.end() != i; i++)
	{
		Reference< XComponent > xComp(i->get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aStatements.clear();

	for (OWeakRefArray::iterator j = m_aComposers.begin(); m_aComposers.end() != j; j++)
	{
		Reference< XComponent > xComp(j->get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aComposers.clear();
	m_xDatabase = NULL;
}

// XCloseable
//------------------------------------------------------------------------------
void ODatabaseAccessConnection::close(void) throw( SQLException, RuntimeException )
{
	{
		MutexGuard aGuard( *m_pMutex );
		if (OSubComponent::rBHelper.bDisposed)
			throw DisposedException();
	}
	dispose();
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnection::isClosed(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	return OSubComponent::rBHelper.bDisposed;
}

// ::com::sun::star::container::XChild
//------------------------------------------------------------------------------
Reference< XInterface >  ODatabaseAccessConnection::getParent(void) throw( RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	return m_xParent;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setParent(const Reference< XInterface > & Parent) throw( NoSupportException, RuntimeException )
{
	throw NoSupportException();
}

// XWarningsSupplier
//------------------------------------------------------------------------------
Any ODatabaseAccessConnection::getWarnings(void) throw( SQLException, RuntimeException )
{
	return Any();
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::clearWarnings(void) throw( SQLException, RuntimeException )
{
}

// XSQLQueryComposerFactory
//------------------------------------------------------------------------------
Reference< XSQLQueryComposer >  ODatabaseAccessConnection::createQueryComposer(void) throw( RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	// get the supplier of the database
	Reference< XUnoTunnel > xTunnel(m_xParent, UNO_QUERY);
	if (!xTunnel.is())
		throw RuntimeException();

	ODatabaseAccess* pAccess = reinterpret_cast<ODatabaseAccess*>(xTunnel->getSomething(ODatabaseAccess::getUnoTunnelImplementationId()));
	Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier = pAccess->getNumberFormatsSupplier();
	Reference< XSQLQueryComposer >  xComposer(new OQueryComposer(*this, m_xDatabase->GetConnection(), xSupplier));
	m_aComposers.push_back(WeakReferenceHelper(xComposer));
	return xComposer;
}

// XTablesSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnection::getTables() throw( RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	return &const_cast<ODatabaseAccessConnection*>(this)->m_aTables;
}

// XQueriesSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnection::getQueries(void) throw( RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	return &const_cast<ODatabaseAccessConnection*>(this)->m_aQueries;
}

// XConnection
//------------------------------------------------------------------------------
Reference< XStatement >  ODatabaseAccessConnection::createStatement(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	SdbCursorRef xCursor = m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
	checkResult(m_xDatabase->Status(), *this, sal_False);

	Reference< XStatement >  xStmt(new OStatement(*this, xCursor, this));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));
	return xStmt;
}

//------------------------------------------------------------------------------
Reference< XPreparedStatement >  ODatabaseAccessConnection::prepareStatement(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	SdbCursorRef xCursor = m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY | SDB_INDIRECT);
	checkResult(m_xDatabase->Status(), *this, sal_False);

	// try it first with parsing
	if (!xCursor->Prepare(sql))
	{
		xCursor = NULL;
		// now without parsing
		xCursor = m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
		checkResult(m_xDatabase->Status(), *this, sal_False);
		xCursor->Prepare(sql);
		checkResult(xCursor->Status(), *this, sal_False);
	}

	Reference< XPreparedStatement >  xStmt(new OPreparedStatement(*this, xCursor, this));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));
	return xStmt;
}

//------------------------------------------------------------------------------
Reference< XPreparedStatement >  ODatabaseAccessConnection::prepareCall(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	SdbCursorRef xCursor = m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
	checkResult(m_xDatabase->Status(), *this, sal_False);

	xCursor->Prepare(sql);
	checkResult(xCursor->Status(), *this, sal_False);

	Reference< XPreparedStatement >  xStmt(new OCallableStatement(*this, xCursor, this));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));
	return xStmt;
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnection::nativeSQL(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	return sql;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setAutoCommit(sal_Bool autoCommit) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	m_xDatabase->GetConnection()->SetAutoCommit(autoCommit);
	checkResult(m_xDatabase->GetConnection()->Status(), *this, sal_False);
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnection::getAutoCommit(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	return m_xDatabase->GetConnection()->IsAutoCommit();
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::commit(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	if (!m_xDatabase->GetConnection()->CommitTrans())
		checkResult(m_xDatabase->GetConnection()->Status(), *this);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::rollback(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	if (!m_xDatabase->GetConnection()->RollbackTrans())
		checkResult(m_xDatabase->GetConnection()->Status(), *this);
}

//------------------------------------------------------------------------------
Reference< XDatabaseMetaData >  ODatabaseAccessConnection::getMetaData(void) throw( SQLException, RuntimeException )
{
	if (!m_aMetaData.getDescriptor().is())
	{
		MutexGuard aGuard(*m_pMutex);
		m_aMetaData.setDescriptor(getDescriptor());
	}
	return &((ODatabaseAccessConnection*)this)->m_aMetaData;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setReadOnly(sal_Bool readOnly) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	m_bReadOnly = readOnly;
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnection::isReadOnly(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	return m_bReadOnly;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setCatalog(const rtl::OUString& catalog) throw( SQLException, RuntimeException )
{
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnection::getCatalog(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	return UniString(m_xDatabase->GetQualifier());
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setTransactionIsolation(sal_Int32 level) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	SdbIsolationLevel aSDBIso;
	switch (level)
	{
		case TransactionIsolation::NONE:
			aSDBIso = SdbIsolationLevel(DatabaseIsolationLevel::NONE);
			break;
		case TransactionIsolation::READ_UNCOMMITTED:
			aSDBIso = SdbIsolationLevel(DatabaseIsolationLevel::READ_UNCOMMIT);
			break;
		case TransactionIsolation::READ_COMMITTED:
			aSDBIso = SdbIsolationLevel(DatabaseIsolationLevel::READ_COMMIT);
			break;
		case TransactionIsolation::REPEATABLE_READ:
			aSDBIso = SdbIsolationLevel(DatabaseIsolationLevel::REPEAT_READ);
			break;
		case TransactionIsolation::SERIALIZABLE:
			aSDBIso = SdbIsolationLevel(DatabaseIsolationLevel::SERIALIZABLE);
			break;
		default:
			throw SQLException();
	}
	m_xDatabase->GetConnection()->SetIsolationLevel(aSDBIso);
	checkResult(m_xDatabase->Status(), *this, sal_False);
}

//------------------------------------------------------------------------------
sal_Int32 ODatabaseAccessConnection::getTransactionIsolation(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	sal_Int32 nLevel = TransactionIsolation::NONE;
	switch (m_xDatabase->GetConnection()->IsolationLevel())
	{
		case DatabaseIsolationLevel::NONE:
			nLevel = TransactionIsolation::NONE;
			break;
		case DatabaseIsolationLevel::READ_UNCOMMIT:
			nLevel = TransactionIsolation::READ_UNCOMMITTED;
			break;
		case DatabaseIsolationLevel::READ_COMMIT:
			nLevel = TransactionIsolation::READ_COMMITTED;
			break;
		case DatabaseIsolationLevel::REPEAT_READ:
			nLevel = TransactionIsolation::REPEATABLE_READ;
			break;
		case DatabaseIsolationLevel::SERIALIZABLE:
			nLevel = TransactionIsolation::SERIALIZABLE;
			break;
		default:
			DBG_ERROR("Unknown transaction level");
	}
	return nLevel;
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnection::getTypeMap(void) throw( SQLException, RuntimeException )
{
	return NULL;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnection::setTypeMap(const Reference< ::com::sun::star::container::XNameAccess > & typeMap) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	throw SQLException();
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::data::XDatabaseDescriptor >  ODatabaseAccessConnection::getDescriptor() const throw( SQLException, RuntimeException )
{
	Reference< ::com::sun::star::data::XDatabaseDescriptor >  xDesc;
	{
		MutexGuard aGuard(*m_pMutex);
		if (m_xDatabase.Is())
			xDesc = m_xDatabase->GetMetaData();
		else
			throw DisposedException();
	}
	return xDesc;
}

//--------------------------------------------------------------------------
SdbObj* ODatabaseAccessConnection::getByName(DBObject _eObj, const rtl::OUString& _rName) throw(::com::sun::star::container::NoSuchElementException,
																								WrappedTargetException,
																								RuntimeException )
{
	SdbObj* pObj = NULL;
	{
		MutexGuard aGuard( *m_pMutex );
		if (m_xDatabase.Is())
			pObj = (SdbObj*)m_xDatabase->OpenDBDef(_eObj, _rName, sal_False);
		else
			throw DisposedException();

		if (!pObj)
			throw ::com::sun::star::container::NoSuchElementException();
	}
	return pObj;
}

//--------------------------------------------------------------------------
SdbObj* ODatabaseAccessConnection::getByIndex(DBObject _eObj, sal_Int32 _nPos) throw( IndexOutOfBoundsException, WrappedTargetException, RuntimeException )
{
	SdbObj* pObj = NULL;
	{
		MutexGuard aGuard( *m_pMutex );
		if (m_xDatabase.Is())
			pObj = (SdbObj*)m_xDatabase->OpenDBDef(_eObj, m_xDatabase->GetObjectName(_eObj, (sal_uInt16)_nPos), sal_False);
		else
			throw DisposedException();

		if (!pObj)
			throw IndexOutOfBoundsException();
	}
	return pObj;
}

//--------------------------------------------------------------------------
void ODatabaseAccessConnection::refresh(DBObject _eObj) throw( RuntimeException )
{
	MutexGuard aGuard( *m_pMutex );
	if (m_xDatabase.Is())
		m_xDatabase->Refresh(_eObj);
	else
		throw DisposedException();
}

//--------------------------------------------------------------------------
Sequence<rtl::OUString> ODatabaseAccessConnection::getElementNames(DBObject _eObj) throw( RuntimeException  )
{
	MutexGuard aGuard(*m_pMutex );
	sal_Int32 nCount = getCount(_eObj);

	Sequence<rtl::OUString> aNameList(nCount);
	rtl::OUString* pStringArray = aNameList.getArray();
	for (sal_uInt32 i = 0; i < nCount; i++)
		pStringArray[i] = UniString(m_xDatabase->GetObjectName(_eObj, i));

	return aNameList;
}

//--------------------------------------------------------------------------
sal_Int32 ODatabaseAccessConnection::getCount(DBObject _eObj) throw( RuntimeException )
{
	sal_Int32 nRet = 0;
	{
		MutexGuard aGuard(*m_pMutex );
		if (m_xDatabase.Is())
			nRet = m_xDatabase->GetObjectCount(_eObj);
		else
			throw DisposedException();
	}
	return nRet;
}

//************************************************************
//  ODatabaseAccessConnectionStub
//************************************************************
DBG_NAME(ODatabaseAccessConnectionStub);

//--------------------------------------------------------------------------
ODatabaseAccessConnectionStub::ODatabaseAccessConnectionStub(ODatabaseAccessConnection& rServer)
							  :OStubComponent(rServer)
							  ,m_aMetaData(*this)
{
	DBG_CTOR(ODatabaseAccessConnectionStub,NULL);
}

//--------------------------------------------------------------------------
ODatabaseAccessConnectionStub::~ODatabaseAccessConnectionStub()
{
	DBG_DTOR(ODatabaseAccessConnectionStub,NULL);
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > ODatabaseAccessConnectionStub::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XConnection > *)0 ),
						   ::getCppuType( (const Reference< XServiceInfo > *)0 ),
						   ::getCppuType( (const Reference< ::com::sun::star::container::XChild > *)0 ),
						   ::getCppuType( (const Reference< XWarningsSupplier > *)0 ),
						   ::getCppuType( (const Reference< XTablesSupplier > *)0 ),
						   ::getCppuType( (const Reference< XQueriesSupplier > *)0 ),
						   ::getCppuType( (const Reference< XSQLQueryComposerFactory > *)0 ),
						   OStubComponent::getTypes());

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccessConnectionStub::getImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any ODatabaseAccessConnectionStub::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OStubComponent::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XConnection * >( this ),
					static_cast< XCloseable * >( this ),
					static_cast< XServiceInfo * >( this ),
					static_cast< ::com::sun::star::container::XChild * >( this ),
					static_cast< XWarningsSupplier * >( this ),
					static_cast< XTablesSupplier * >( this ),
					static_cast< XQueriesSupplier * >( this ),
					static_cast< XSQLQueryComposerFactory * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::acquire() throw (RuntimeException)
{
	OStubComponent::acquire();
}

//--------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::release() throw (RuntimeException)
{
	OStubComponent::release();
}

// OConnectionBase
//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::disposing(void)
{
	MutexGuard aGuard(*m_pMutex);
	for (OWeakRefArray::iterator i = m_aStatements.begin(); m_aStatements.end() != i; i++)
	{
		Reference< XComponent > xComp(i->get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aStatements.clear();
	OStubComponent::disposing();
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnectionStub::isClosed(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	return OSubComponent::rBHelper.bDisposed;
}

// XCloseable
//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::close(void) throw( SQLException, RuntimeException )
{
	{
		MutexGuard aGuard( *m_pMutex );
		if (OSubComponent::rBHelper.bDisposed)
			throw DisposedException();
	}
	dispose();
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnectionStub::getImplementationName(  ) throw (RuntimeException)
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getImplementationName(), rtl::OUString);
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnectionStub::supportsService(const rtl::OUString& ServiceName) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, supportsService(ServiceName), sal_Bool);
}

//------------------------------------------------------------------------------
Sequence< rtl::OUString > ODatabaseAccessConnectionStub::getSupportedServiceNames(void) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getSupportedServiceNames(), Sequence< rtl::OUString >);
}

// ::com::sun::star::container::XChild
//------------------------------------------------------------------------------
Reference< XInterface >  ODatabaseAccessConnectionStub::getParent(void) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getParent(), Reference< XInterface > );
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setParent(const Reference< XInterface > & Parent) throw( NoSupportException, RuntimeException )
{
	throw NoSupportException();
}

// XWarningsSupplier
//------------------------------------------------------------------------------
Any ODatabaseAccessConnectionStub::getWarnings(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getWarnings(), Any);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::clearWarnings(void) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,clearWarnings());
}

// XConnection
//------------------------------------------------------------------------------
Reference< XStatement >  ODatabaseAccessConnectionStub::createStatement(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	ODatabaseAccessConnection* pConnection = GET_SERVER(ODatabaseAccessConnection);

	SdbCursorRef xCursor = pConnection->m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
	checkResult(pConnection->m_xDatabase->Status(), *this, sal_False);

	Reference< XStatement >  xStmt(new OStatement(*this, xCursor, pConnection));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));
	return xStmt;
}

//------------------------------------------------------------------------------
Reference< XPreparedStatement >  ODatabaseAccessConnectionStub::prepareStatement(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	ODatabaseAccessConnection* pConnection = GET_SERVER(ODatabaseAccessConnection);

	SdbCursorRef xCursor = pConnection->m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY | SDB_INDIRECT);
	checkResult(pConnection->m_xDatabase->Status(), *this, sal_False);

	// try it first with parsing
	if (!xCursor->Prepare(sql))
	{
		xCursor = NULL;
		// now without parsing
		xCursor = pConnection->m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
		checkResult(pConnection->m_xDatabase->Status(), *this, sal_False);
		xCursor->Prepare(sql);
		checkResult(xCursor->Status(), *this, sal_False);
	}

	Reference< XPreparedStatement >  xStmt(new OPreparedStatement(*this, xCursor, pConnection));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));
	return xStmt;
}

//------------------------------------------------------------------------------
Reference< XPreparedStatement >  ODatabaseAccessConnectionStub::prepareCall(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(*m_pMutex);
	ODatabaseAccessConnection* pConnection = GET_SERVER(ODatabaseAccessConnection);

	SdbCursorRef xCursor = pConnection->m_xDatabase->CreateCursor(SDB_SNAPSHOT, SDB_FORWARDONLY | SDB_READONLY);
	checkResult(pConnection->m_xDatabase->Status(), *this, sal_False);

	xCursor->Prepare(sql);
	checkResult(xCursor->Status(), *this, sal_False);

	Reference< XPreparedStatement >  xStmt(new OCallableStatement(*this, xCursor, pConnection));
	m_aStatements.push_back(WeakReferenceHelper(xStmt));

	return xStmt;
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnectionStub::nativeSQL(const rtl::OUString& sql) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, nativeSQL(sql), rtl::OUString);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setAutoCommit(sal_Bool autoCommit) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,setAutoCommit(autoCommit));
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnectionStub::getAutoCommit(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getAutoCommit(), sal_Bool);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::commit(void) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,commit());
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::rollback(void) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,rollback());
}

//------------------------------------------------------------------------------
Reference< XDatabaseMetaData >  ODatabaseAccessConnectionStub::getMetaData(void) throw( SQLException, RuntimeException )
{
	if (!m_aMetaData.getDescriptor().is())
	{
		MutexGuard aGuard(*m_pMutex);
		m_aMetaData.setDescriptor(GET_SERVER(ODatabaseAccessConnection)->getDescriptor());
	}
	return &((ODatabaseAccessConnectionStub*)this)->m_aMetaData;
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setReadOnly(sal_Bool readOnly) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,setReadOnly(readOnly));
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessConnectionStub::isReadOnly(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, isReadOnly(), sal_Bool);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setCatalog(const rtl::OUString& catalog) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,setCatalog(catalog));
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessConnectionStub::getCatalog(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getCatalog(), rtl::OUString);
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setTransactionIsolation(sal_Int32 level) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,setTransactionIsolation(level));
}

//------------------------------------------------------------------------------
sal_Int32 ODatabaseAccessConnectionStub::getTransactionIsolation(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getTransactionIsolation(), sal_Int32);
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnectionStub::getTypeMap(void) throw( SQLException, RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getTypeMap(), Reference< ::com::sun::star::container::XNameAccess > );
}

//------------------------------------------------------------------------------
void ODatabaseAccessConnectionStub::setTypeMap(const Reference< ::com::sun::star::container::XNameAccess > & typeMap) throw( SQLException, RuntimeException )
{
	SERVER_EXECUTE(ODatabaseAccessConnection,setTypeMap(typeMap));
}

// XSQLQueryComposerFactory
//------------------------------------------------------------------------------
Reference< XSQLQueryComposer >  ODatabaseAccessConnectionStub::createQueryComposer(void) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, createQueryComposer(), Reference< XSQLQueryComposer > );
}

// XTablesSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnectionStub::getTables(void) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getTables(), Reference< ::com::sun::star::container::XNameAccess > );
}

// XQueriesSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  ODatabaseAccessConnectionStub::getQueries(void) throw( RuntimeException )
{
	RETURN_SERVER_RESULT(ODatabaseAccessConnection, getQueries(), Reference< ::com::sun::star::container::XNameAccess > );
}



