/*************************************************************************
 *
 *  $RCSfile: databasecontext.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DATABASECONTEXT_HXX
#include "databasecontext.hxx"
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONFIGMANAGER_HPP_
#include <com/sun/star/frame/XConfigManager.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XDATASOURCE_HPP_
#include <com/sun/star/sdbc/XDataSource.hpp>
#endif
#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _UNOTOOLS_ENUMHELPER_HXX_
#include <unotools/enumhelper.hxx>
#endif
#ifndef _SBA_API_HRC
#include <api.hrc>
#endif
#ifndef _SBA_RESOURCE_CACHE_HXX_
#include "SbaResourceCache.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen wg. INetURLObject
#include <tools/urlobj.hxx>
#endif
#ifndef _EXPLORER_HXX //autogen
#include <sfx2/explorer.hxx>
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _TOOLS_INTN_HXX
#include <tools/intn.hxx>
#endif
#ifndef _SVX_LANGTAB_HXX
#include <svx/langtab.hxx>
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include <sbaexpob.hxx>
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::util;
using namespace ::com::sun::star::registry;
using namespace ::cppu;
using namespace ::osl;

DBG_NAME(ODatabaseAccessContext);

#define CHECK_LOCAL(loc)						\
	if (!loc.Language.getLength())				\
		throw IllegalArgumentException()

//==========================================================================
//==========================================================================
typedef ::cppu::WeakImplHelper1< XSimpleRegistry > KeyRegistry_Base;

class OKeyRegistry	:public KeyRegistry_Base
{
	Reference< XSimpleRegistry > m_xMainRegistry;
	Reference< XRegistryKey > 	 m_xRoot;

public:
	OKeyRegistry(const Reference< XSimpleRegistry > & _rxMainRegistry, const rtl::OUString& _rSubKeyPath);
	virtual ~OKeyRegistry();

// XSimpleRegistry
    virtual ::rtl::OUString SAL_CALL getURL() throw(RuntimeException);
    virtual void SAL_CALL open( const ::rtl::OUString& rURL, sal_Bool bReadOnly, sal_Bool bCreate ) throw(InvalidRegistryException, RuntimeException);
    virtual sal_Bool SAL_CALL isValid(  ) throw(RuntimeException);
    virtual void SAL_CALL close(  ) throw(InvalidRegistryException, RuntimeException);
    virtual void SAL_CALL destroy(  ) throw(InvalidRegistryException, RuntimeException);
    virtual Reference< XRegistryKey > SAL_CALL getRootKey(  ) throw(InvalidRegistryException, RuntimeException);
    virtual sal_Bool SAL_CALL isReadOnly(  ) throw(InvalidRegistryException, RuntimeException);
    virtual void SAL_CALL mergeKey( const ::rtl::OUString& aKeyName, const ::rtl::OUString& aUrl ) throw(InvalidRegistryException, MergeConflictException, RuntimeException);
};

//--------------------------------------------------------------------------
DBG_NAME(OKeyRegistry);

//--------------------------------------------------------------------------
OKeyRegistry::OKeyRegistry(const Reference< XSimpleRegistry > & _rxMainRegistry, const rtl::OUString& _rSubKeyPath)
			 :m_xMainRegistry(_rxMainRegistry)
{
	DBG_CTOR(OKeyRegistry, NULL);
	if (m_xMainRegistry.is())
	{
		try
		{
			Reference< XRegistryKey >  xRoot = m_xMainRegistry->getRootKey();
			if (xRoot.is())
			{
				m_xRoot = xRoot->openKey(_rSubKeyPath);
				if (!m_xRoot.is())
					m_xRoot = xRoot->createKey(_rSubKeyPath);
			}
		}
		catch (...)
		{
		}
	}
}

//--------------------------------------------------------------------------
OKeyRegistry::~OKeyRegistry()
{
	DBG_DTOR(OKeyRegistry, NULL);
}

//--------------------------------------------------------------------------
rtl::OUString OKeyRegistry::getURL(void) throw( RuntimeException )
{
	rtl::OUString sReturn;
	if (m_xMainRegistry.is() && m_xRoot.is())
	{
		sReturn = m_xMainRegistry->getURL();
		sReturn += rtl::OUString::createFromAscii("#");

		rtl::OUString sRelative = m_xRoot->getKeyName();
		String sRelativeEncoded = INetURLObject::encode(sRelative, INetURLObject::PART_URIC, '%', INetURLObject::ENCODE_ALL);
		sReturn += sRelativeEncoded;
	}
	return sReturn;
}

//--------------------------------------------------------------------------
void OKeyRegistry::open(const rtl::OUString& rURL, sal_Bool bReadOnly, sal_Bool bCreate) throw( InvalidRegistryException, RuntimeException )
{
	DBG_ERROR("OKeyRegistry::open : not supported yet !");
		// nyi : parse the URL, find the main URL, open m_xMainRegistry with it,
		// find the mark, open the key corresponding to the it
	close();
	throw InvalidRegistryException();
}

//--------------------------------------------------------------------------
sal_Bool OKeyRegistry::isValid(void) throw( RuntimeException )
{
	return m_xMainRegistry.is() && m_xRoot.is();
}

//--------------------------------------------------------------------------
void OKeyRegistry::close(void) throw( InvalidRegistryException, RuntimeException )
{
	if (m_xRoot.is())
		m_xRoot->closeKey();
	m_xRoot = NULL;
	// don't close the main registry, we just "borrowed" it
}

//--------------------------------------------------------------------------
void OKeyRegistry::destroy(void) throw( InvalidRegistryException, RuntimeException )
{
	DBG_ERROR("OKeyRegistry::destroy : not supported yet !");
	throw InvalidRegistryException();
}

//--------------------------------------------------------------------------
Reference< XRegistryKey >  OKeyRegistry::getRootKey(void) throw( InvalidRegistryException, RuntimeException )
{
	if (!isValid())
		throw InvalidRegistryException();
	return m_xRoot;
}

//--------------------------------------------------------------------------
sal_Bool OKeyRegistry::isReadOnly(void) throw( InvalidRegistryException, RuntimeException )
{
	if (!isValid())
		throw InvalidRegistryException();
	return m_xMainRegistry->isReadOnly();
}

//--------------------------------------------------------------------------
void OKeyRegistry::mergeKey( const ::rtl::OUString& aKeyName, const ::rtl::OUString& aUrl ) throw(InvalidRegistryException, MergeConflictException, RuntimeException)
{
	DBG_ERROR("OKeyRegistry::mergeKey : not supported yet !");
	throw InvalidRegistryException();
}

//==========================================================================
//==========================================================================
class ORegistryLevelEnumeration
{
	Sequence< Reference< XRegistryKey > >	m_aElements;
	sal_Int32						m_nCurPos;

public:
	ORegistryLevelEnumeration(const Reference< XRegistryKey > & _rxLevel);

	sal_Bool	hasMoreElements() const;
	Reference< XRegistryKey > 	nextElement();

private:
	void implSeekNext();
};

//--------------------------------------------------------------------------
ORegistryLevelEnumeration::ORegistryLevelEnumeration(const Reference< XRegistryKey > & _rxLevel)
	:m_nCurPos(0)
{
	if (_rxLevel.is())
	{
		try
		{
			m_aElements = _rxLevel->openKeys();
			m_nCurPos = -1;
			implSeekNext();
		}
		catch (...)
		{
			m_nCurPos = 0;
			m_aElements.realloc(0);
		}
	}
}

//--------------------------------------------------------------------------
sal_Bool ORegistryLevelEnumeration::hasMoreElements() const
{
	return m_nCurPos < m_aElements.getLength();
}

//--------------------------------------------------------------------------
Reference< XRegistryKey > 	ORegistryLevelEnumeration::nextElement()
{
	Reference< XRegistryKey >  xReturn;
	if (hasMoreElements())
	{
		xReturn = m_aElements[m_nCurPos];
		implSeekNext();
	}
	else
		DBG_ERROR("ORegistryLevelEnumeration::nextElement : no more elements !");
	return xReturn;
}

//--------------------------------------------------------------------------
void ORegistryLevelEnumeration::implSeekNext()
{
	while (++m_nCurPos < m_aElements.getLength())
	{
		Reference< XRegistryKey >  xCheck = m_aElements[m_nCurPos];
		if (xCheck.is())
			break;
	}
}

//==========================================================================
Reference< XInterface >
	SAL_CALL ODatabaseAccessContext_CreateInstance(const Reference< XMultiServiceFactory >  & xServiceManager)
		throw( Exception )
{
	Reference< XInterface >  xService(*new ODatabaseAccessContext(xServiceManager));
	return xService;
}

//--------------------------------------------------------------------------
ODatabaseAccessContext::ODatabaseAccessContext(const Reference< XMultiServiceFactory >  & xServiceManager)
					   :DatabaseAccessContext_Base(m_aMutex)
					   ,m_xServiceManager(xServiceManager)
					   ,m_pLanguages(NULL)
{
	DBG_CTOR(ODatabaseAccessContext,NULL);
	// get the db env
	m_xEnvironment = Reference< XDatabaseEnvironment > (m_xServiceManager
								->createInstance(SERVICE_SDB_DATABASEENVIRONMENT), UNO_QUERY);
	DBG_ASSERT(m_xEnvironment.is(), "ODatabaseAccessContext::ODatabaseAccessContext : could not get the DatabaseEnvironment !");
	// get the registry
	implGetRegistry();
	DBG_ASSERT(m_xRegistry.is(), "ODatabaseAccessContext::ODatabaseAccessContext : could not get the registry !");

	// stuff which has to be guarded by the solar mutex
	::vos::OGuard aGuard(Application::GetSolarMutex());

	// the language table
	m_pLanguages = new SvxLanguageTable;

	// all string resources used in this class
	OSbaResourceCache::RegisterStringResource(RID_STR_DBACC_PROGRAMMATIC_USED);
	OSbaResourceCache::RegisterStringResource(RID_STR_DBACC_NAMEURL_EXISTS);
	OSbaResourceCache::RegisterStringResource(RID_STR_DBACC_TITLE_CONFLICT);
	OSbaResourceCache::RegisterStringResource(RID_STR_DBACC_FALLBACKTITLE_CONFLICT);
	OSbaResourceCache::RegisterStringResource(RID_STR_DBACC_TITLE_USED);
	OSbaResourceCache::RegisterStringResource(RID_STR_STANDARD);

	// ensure that the address db is registered
	// (in the past we did this in SbaDLL::Load, but this isn't possible : if somebody creates a DatabaseAccessContext
	// (e.g. from BASIC), this would cause the SbaDLL to be loaded, which would try to register the address book,
	// which would instantiate the ODatabaseAccessContext. Goodbye Single-Instance .... So we do this here, cause
	// it's the only place where we know that it is right in time before anybody requests an alias.)
	osl_incrementInterlockedCount( &m_refCount );
	implRegisterAddressDB();
	osl_decrementInterlockedCount( &m_refCount );
}

//--------------------------------------------------------------------------
ODatabaseAccessContext::~ODatabaseAccessContext()
{
	DBG_DTOR(ODatabaseAccessContext,NULL);
	delete m_pLanguages;
}

// Helper
//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getImplementationName_Static() throw( RuntimeException )

{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.ODatabaseAccessContext");
}

//------------------------------------------------------------------------------
Sequence< rtl::OUString > ODatabaseAccessContext::getSupportedServiceNames_Static(void) throw( RuntimeException )
{
	Sequence< ::rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDB_DATABASEACCESSCONTEXT;
	return aSNS;
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getImplementationName(  ) throw(RuntimeException)
{
	return getImplementationName_Static();
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessContext::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > ODatabaseAccessContext::getSupportedServiceNames(  ) throw (RuntimeException)
{
	return getSupportedServiceNames_Static();
}

// ::com::sun::star::lang::XUnoTunnel
//--------------------------------------------------------------------------
sal_Int64 SAL_CALL ODatabaseAccessContext::getSomething(const Sequence<sal_Int8>& rId) throw( RuntimeException )
{
	//	return ODatabaseAccessContext_TunnelBase::getSomething(_rIdentifier);
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODatabaseAccessContext::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}
// DatabaseAccessContext_Base
//------------------------------------------------------------------------------
void ODatabaseAccessContext::disposing()
{
	MutexGuard aGuard(m_aMutex);
	m_xEnvironment = NULL;
}

// XNamingService
//------------------------------------------------------------------------------
Reference< XInterface >  ODatabaseAccessContext::getRegisteredObject(const rtl::OUString& Name) throw( Exception, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (DatabaseAccessContext_Base::rBHelper.bDisposed)
		throw DisposedException();

	rtl::OUString sLocation = implGetLocation(Name, getCurrentLocale());
	if (!sLocation.getLength())
		// check for a fallback
		sLocation = implGetLocation(Name, Locale());

	if (m_xEnvironment.is() && sLocation.getLength())
	{
		substFileURLVars(sLocation);
		try
		{
			return m_xEnvironment->getDatabaseAccess(sLocation);
		}
		catch (SQLException)
		{
			return Reference< XInterface > ();
		}
	}
	else
		throw NoSuchElementException();
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::registerObject(const rtl::OUString& Name, const Reference< XInterface > & Object) throw( Exception, RuntimeException )
{
	Reference< XDatabaseAccess >  xDBA(Object, UNO_QUERY);
	if (!xDBA.is())
		throw IllegalArgumentException();

	bindAlias(Name, getCurrentLocale(), getObjectURL(xDBA));
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::revokeObject(const rtl::OUString& Name) throw( Exception, RuntimeException )
{
	unbindAlias(getCurrentLocale(), Name);
}

//------------------------------------------------------------------------------
Sequence <AliasProgrammaticPair> ODatabaseAccessContext::implCollectPairs(const Locale& _rLoc) throw( RuntimeException )
{
	Sequence <AliasProgrammaticPair> aReturn;
	try
	{
		Reference< XRegistryKey >  xLangKey = getLanguageKey(_rLoc, sal_False);
		if (xLangKey.is())
		{
			Sequence<Reference< XRegistryKey > > aRegistered = xLangKey->openKeys();
			const Reference< XRegistryKey > * pRegistered = aRegistered.getConstArray();

			aReturn.realloc(aRegistered.getLength());
			AliasProgrammaticPair* pURLs = aReturn.getArray();

			for (sal_Int32 i=0; i<aReturn.getLength(); ++i, ++pRegistered, ++pURLs)
			{
				if (pRegistered->is())
				{
					try
					{
						pURLs->Alias = implGetShortKeyName(*pRegistered);
						pURLs->ProgrammaticName = (*pRegistered)->getStringValue();
						(*pRegistered)->closeKey();
					}
					catch (...) { };
				}
			}
			xLangKey->closeKey();
		}
	}
	catch (...)
	{
		aReturn.realloc(0);
	}
	return aReturn;
}

//------------------------------------------------------------------------------
// compare two AliasProgrammaticPair's by flat url (simple string compare)

int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	AliasProgrammaticPairCompareByURL( const void* pFirst, const void* pSecond)
{
	DBG_ASSERT(pFirst && pSecond, "AliasProgrammaticPairCompareByURL : invalid arguments ! (are your bsearch-ing a zero-length-array ? are you on solarsi sparc ? yes ? that's it ! :)");
	if (!pFirst && !pSecond) return 0;
	if (!pFirst) return -1;
	if (!pSecond) return 1;
	return ((AliasProgrammaticPair*)pFirst)->ProgrammaticName.compareTo(((AliasProgrammaticPair*)pSecond)->ProgrammaticName);
}

//------------------------------------------------------------------------------
// compare two AliasProgrammaticPair's by url
int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	AliasProgrammaticPairCompareByURLComplete( const void* pFirst, const void* pSecond)
{
	DBG_ASSERT(pFirst && pSecond, "AliasProgrammaticPairCompareByURLComplete : invalid arguments ! (are your bsearch-ing a zero-length-array ? are you on solarsi sparc ? yes ? that's it ! :)");
	if (!pFirst && !pSecond) return 0;
	if (!pFirst) return -1;
	if (!pSecond) return 1;
	return compareURLs(((AliasProgrammaticPair*)pFirst)->ProgrammaticName, ((AliasProgrammaticPair*)pSecond)->ProgrammaticName);
}

//------------------------------------------------------------------------------
// compare two AliasProgrammaticPair's by name
int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	AliasProgrammaticPairCompareByName( const void* pFirst, const void* pSecond)
{
	if (!pFirst && !pSecond) return 0;
	if (!pFirst) return -1;
	if (!pSecond) return 1;
	return ( (AliasProgrammaticPair*)pFirst)->Alias.compareTo(((AliasProgrammaticPair*)pSecond)->Alias);
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::implLookupURL(const rtl::OUString _rURL, const Locale& _rLoc)
{
	// a pair to search for
	AliasProgrammaticPair aSearch;
	aSearch.ProgrammaticName = _rURL;

	rtl::OUString sReturn;
	Sequence <AliasProgrammaticPair> aPairs = implCollectPairs(_rLoc);
	AliasProgrammaticPair* pPairs = aPairs.getArray();
	if (aPairs.getLength())
	{
		// normalize the URLs of this language
		for (sal_Int32 i=0; i<aPairs.getLength(); ++i, ++pPairs)
			substFileURLVars(pPairs->ProgrammaticName);

		// sort 'n' search
		qsort(aPairs.getArray(), aPairs.getLength(), sizeof (AliasProgrammaticPair), AliasProgrammaticPairCompareByURLComplete);
		const AliasProgrammaticPair* pExistent = NULL;
		if (aPairs.getLength())	// don't bsearch in an empty array (solaris sparc has some problems with this ...)
			pExistent =  (AliasProgrammaticPair*)bsearch(&aSearch, aPairs.getConstArray(), aPairs.getLength(), sizeof (AliasProgrammaticPair), AliasProgrammaticPairCompareByURLComplete);
		if (pExistent)
			sReturn = pExistent->Alias;
	}
	return sReturn;
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::lookupProgrammatic(const Locale& locale, const rtl::OUString& programmatic) throw( NoSuchElementException, RuntimeException )
{
	// normalize the given URL
	rtl::OUString sNormalized(programmatic);
	substFileURLVars(sNormalized);

	// check if it is known within the given language
	rtl::OUString sReturn = implLookupURL(sNormalized, locale);

	if (!sReturn.getLength())
	{	// search the fallback entries
		Locale aFallback;
		sReturn = implLookupURL(sNormalized, aFallback);
	}

	if (!sReturn.getLength())
		throw NoSuchElementException();

	return sReturn;
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::bindAlias(const rtl::OUString& programmaticName, const Locale& locale, const rtl::OUString& alias) throw( ::com::sun::star::container::ElementExistException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (DatabaseAccessContext_Base::rBHelper.bDisposed)
		throw DisposedException();

	CHECK_LOCAL(locale);

	implRegister(alias, programmaticName, locale);
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::unbindAlias(const Locale& locale, const rtl::OUString& alias) throw( NoSuchElementException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (DatabaseAccessContext_Base::rBHelper.bDisposed)
		throw DisposedException();

	CHECK_LOCAL(locale);

	implRevoke(alias, locale);
}

//------------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::lookupAlias(const Locale& locale, const rtl::OUString& _rAlias) throw( NoSuchElementException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (DatabaseAccessContext_Base::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xEnvironment.is())	// can't get the without my environment ...
		throw NoSuchElementException();

	CHECK_LOCAL(locale);

	rtl::OUString sReturn;

	Reference< XRegistryKey >  xLangKey = getLanguageKey(locale, sal_False);
	if (xLangKey.is())
	{
		// get the URL
		try
		{
			Reference< XRegistryKey >  xObjectKey = xLangKey->openKey(_rAlias);
			if (xObjectKey.is())
			{
				sReturn = xObjectKey->getStringValue();
				substFileURLVars(sReturn);
				xObjectKey->closeKey();
			}
			xLangKey->closeKey();
		}
		catch (...)
		{
		}
	}

	if (!sReturn.getLength())
		throw NoSuchElementException();

	return sReturn;
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::unbindAliases(const rtl::OUString& programmaticName) throw( NoSuchElementException, RuntimeException )
{
	sal_Bool bDeletedAnything = sal_False;
	Reference< XRegistryKey >  xAllLangs = getAllLanguageKey();
	if (xAllLangs.is())
	{
		rtl::OUString sNormalizedURL(programmaticName);
		substFileURLVars(sNormalizedURL);
		// loop through all languages
		ORegistryLevelEnumeration aLanguages(xAllLangs);
		while (aLanguages.hasMoreElements())
		{
			Reference< XRegistryKey >  xCurrentLang = aLanguages.nextElement();
			ORegistryLevelEnumeration aRegisteredNames(xCurrentLang);

			while (aRegisteredNames.hasMoreElements())
			{
				Reference< XRegistryKey >  xCurrentName = aRegisteredNames.nextElement();
				try
				{
					rtl::OUString sThisRoundURL = xCurrentName->getStringValue();
					substFileURLVars(sThisRoundURL);

					if (compareURLs(sNormalizedURL, sThisRoundURL) == 0)
					{	// found an alias for this URL
						xCurrentLang->deleteKey(implGetShortKeyName(xCurrentName));
						bDeletedAnything = sal_True;
						break;	// next language
					}
				}
				catch (InvalidValueException)
				{
					DBG_ERROR("ODatabaseAccessContext::rebindAliases : no string value for this name ?");
				}
				catch (InvalidRegistryException)
				{
					DBG_ERROR("ODatabaseAccessContext::rebindAliases : invalid registry ?");
				}

			}
		}
	}
	if (!bDeletedAnything)
		throw NoSuchElementException();
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::rebindAliases(const rtl::OUString& currentProgrammatic, const rtl::OUString& newProgrammatic) throw( NoSuchElementException, ::com::sun::star::container::ElementExistException, RuntimeException )
{
	sal_Bool bSubstitutedSomething = sal_False;

	Reference< XRegistryKey >  xAllLangs = getAllLanguageKey();
	if (xAllLangs.is())
	{
		rtl::OUString sNormalizedCurrent(currentProgrammatic);
		substFileURLVars(sNormalizedCurrent);
		rtl::OUString sNormalizedNew(newProgrammatic);
		substFileURLVars(sNormalizedNew);

		// loop through all languages
		ORegistryLevelEnumeration aLanguages(xAllLangs);
		while (aLanguages.hasMoreElements())
		{
			Reference< XRegistryKey >  xCurrentLang = aLanguages.nextElement();
			ORegistryLevelEnumeration aRegisteredNames(xCurrentLang);

			sal_Bool bSubstitutedThisRound = sal_False;
			while (aRegisteredNames.hasMoreElements())
			{
				Reference< XRegistryKey >  xCurrentName = aRegisteredNames.nextElement();
				try
				{
					rtl::OUString sThisRoundURL = xCurrentName->getStringValue();
					substFileURLVars(sThisRoundURL);

					if (compareURLs(sNormalizedNew, sThisRoundURL) == 0)
					{
						rtl::OUString sDesc = OSbaResourceCache::GetRegisteredString(RID_STR_DBACC_PROGRAMMATIC_USED);
						throw ElementExistException(sDesc, *this);
						// though it might not be a conflict in the current language (perhaps currentProgrammatic
						// is unknown here), in any case it's a conflict in our "fallback language", cause
						// currentProgrammatic is known there
					}

					if (!bSubstitutedThisRound)
					{
						if (compareURLs(sNormalizedCurrent, sThisRoundURL) == 0)
						{
							// found a name for this URL
							xCurrentName->setStringValue(newProgrammatic);
							bSubstitutedThisRound = sal_True;
							// we can't just break here, we still have to check the new URL for conflicts ...
						}
					}
				}
				catch (InvalidValueException)
				{
					DBG_ERROR("ODatabaseAccessContext::rebindAliases : no string value for this name ?");
				}
				catch (InvalidRegistryException)
				{
					DBG_ERROR("ODatabaseAccessContext::rebindAliases : invalid registry ?");
				}
			}
			bSubstitutedSomething |= bSubstitutedThisRound;
		}
	}
	if (!bSubstitutedSomething)
		throw NoSuchElementException();
}

//------------------------------------------------------------------------------
void ODatabaseAccessContext::renameAlias(const Locale& locale, const rtl::OUString& aOldName, const rtl::OUString& aNewName) throw( NoSuchElementException, ::com::sun::star::container::ElementExistException, RuntimeException )
{
	if (aOldName.equals(aNewName))
		// nothing to be done
		return;

	Reference< XRegistryKey >  xLangKey = getLanguageKey(locale, sal_True);
	if (xLangKey.is())
	{
		try
		{
			rtl::OUString sURL;
			Reference< XRegistryKey >  xExistent = xLangKey->openKey(aOldName);
			if (xExistent.is())
				sURL = xExistent->getStringValue();
			if (!sURL.getLength())
			{
				// we don't have a title for the given language, but maybe a fallback ?
				Locale aFallback;
				xLangKey = getLanguageKey(aFallback, sal_False);
				xExistent = xLangKey.is() ? xLangKey->openKey(aOldName) : Reference< XRegistryKey > ();
				if (xExistent.is())
					sURL = xExistent->getStringValue();
				if (!sURL.getLength())
					// no more chances
					throw NoSuchElementException();
			}

			implRegister(aNewName, sURL, locale);
			// will check for conflicts ...
		}
		catch (InvalidRegistryException)
		{
			DBG_ERROR("ODatabaseAccessContext::renameAlias : could not rename (invalid registry) !");
		}
	}
	else
		throw NoSuchElementException();
}

//------------------------------------------------------------------------------
Sequence <AliasProgrammaticPair> ODatabaseAccessContext::listAliases(const Locale& locale) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (DatabaseAccessContext_Base::rBHelper.bDisposed)
		throw DisposedException();

	CHECK_LOCAL(locale);

	// collect all pairs for the requested language
	Sequence< AliasProgrammaticPair > aLangPairs = implCollectPairs(locale);
	// and (additionally) : collect all fallback pairs which's URLs aren't covered in the given locale
	Locale aFallback;
	Sequence< AliasProgrammaticPair > aFallbacks = implCollectPairs(aFallback);

	// sort the language pairs by URL
	if (aLangPairs.getLength())
	{
		// (after normaliing them)
		for (sal_Int32 i=0; i<aLangPairs.getLength(); ++i)
			substFileURLVars(aLangPairs.getArray()[i].ProgrammaticName);
		qsort(aLangPairs.getArray(), aLangPairs.getLength(), sizeof (AliasProgrammaticPair), AliasProgrammaticPairCompareByURLComplete);
	}

	Sequence< AliasProgrammaticPair > aReturn = aLangPairs;
	aReturn.realloc(aLangPairs.getLength() + aFallbacks.getLength());
	AliasProgrammaticPair* pReturn = aReturn.getArray();
	pReturn += aLangPairs.getLength();

	AliasProgrammaticPair* pFallbacks = aFallbacks.getArray();
	for (sal_Int32 i=0; i<aFallbacks.getLength(); ++i, ++pFallbacks)
	{
		substFileURLVars(pFallbacks->ProgrammaticName);
		const AliasProgrammaticPair* pExistent = NULL;
		if (aLangPairs.getLength())	// don't bsearch in an empty array (solaris sparc has some problems with this)
			pExistent =  (AliasProgrammaticPair*)bsearch(pFallbacks, aLangPairs.getConstArray(), aLangPairs.getLength(), sizeof (AliasProgrammaticPair), AliasProgrammaticPairCompareByURLComplete);
		if (!pExistent)
		{	// we have a fallback entry with an URL which has no title in the language given by locale
			// -> add it to the to-be-returned array
			*pReturn = *pFallbacks;
			++pReturn;
		}
	}
	aReturn.realloc(pReturn - aReturn.getArray());

	return aReturn;
}

// XLocalizable
//------------------------------------------------------------------------------
void ODatabaseAccessContext::setLocale(const Locale& eLocale) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	m_aCurrentLocale = eLocale;
}

//------------------------------------------------------------------------------
Locale ODatabaseAccessContext::getLocale(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	return m_aCurrentLocale;
}

// ::com::sun::star::container::XElementAccess
//------------------------------------------------------------------------------
Type ODatabaseAccessContext::getElementType(  ) throw(RuntimeException)
{
	return::getCppuType(static_cast<Reference<XDataSource>*>(NULL));
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessContext::hasElements(void) throw( RuntimeException )
{
	MutexGuard aGuard(const_cast<ODatabaseAccessContext*>(this)->m_aMutex);
//	return getFavorites().getLength();

	sal_Bool bHaveSomething = sal_False;
	Reference< XRegistryKey >  xLangKey = getLanguageKey(getCurrentLocale(), sal_True);
	if (xLangKey.is())
	{
		try
		{
			bHaveSomething = (xLangKey->getKeyNames().getLength() > 0);
			xLangKey->closeKey();
			if (!bHaveSomething)
			{	// maybe we have some fallback entries
				xLangKey = getLanguageKey(Locale(), sal_True);
				if (xLangKey.is())
				{
					bHaveSomething = (xLangKey->getKeyNames().getLength() > 0);
					xLangKey->closeKey();
				}
			}
		}
		catch (InvalidRegistryException)
		{
		}

	}
	return bHaveSomething;
}

// ::com::sun::star::container::XEnumerationAccess
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XEnumeration >  ODatabaseAccessContext::createEnumeration(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	return new utl::OEnumerationByName( static_cast< ::com::sun::star::container::XNameAccess*>(this));
}

// ::com::sun::star::container::XNameAccess
//------------------------------------------------------------------------------
Any ODatabaseAccessContext::getByName(const rtl::OUString& aName) throw( ::com::sun::star::container::NoSuchElementException,
														  WrappedTargetException, RuntimeException )
{
	Any aRes;
	MutexGuard aGuard(m_aMutex);
	Reference< XDataSource >  xSource;
	try
	{
		Reference< XDataSource > xSource(getRegisteredObject(aName), UNO_QUERY);
		aRes <<= xSource;
	}
	catch (SQLException e)
	{
		Any aExcept;
		aExcept <<= e;
		throw WrappedTargetException(rtl::OUString(), *this, aExcept);
	}
	catch ( Exception )
	{
		throw NoSuchElementException();
	}
	return aRes;
}

//------------------------------------------------------------------------------
Sequence< rtl::OUString > ODatabaseAccessContext::getElementNames(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	try
	{
		Sequence< AliasProgrammaticPair > aAliases = listAliases(getCurrentLocale());
		const AliasProgrammaticPair* pAliases = aAliases.getConstArray();
		Sequence<rtl::OUString> aNames(aAliases.getLength());
		rtl::OUString* pNames = aNames.getArray();
		for (sal_Int32 i=0; i<aAliases.getLength(); ++i, ++pAliases, ++pNames)
			*pNames = pAliases->Alias;

		return aNames;
	}
	catch(InvalidRegistryException)
	{
	}
	return Sequence<rtl::OUString>();
}

//------------------------------------------------------------------------------
sal_Bool ODatabaseAccessContext::hasByName(const rtl::OUString& _rName) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	sal_Bool bKnown = sal_False;
	rtl::OUString sLocation = implGetLocation(_rName, getCurrentLocale());
	if (!sLocation.getLength())
		sLocation = implGetLocation(_rName, Locale());
	return sLocation.getLength() != 0;
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::checkTitleExistence(const rtl::OUString& _rTitle, const rtl::OUString& _rLangTitle) throw( ::com::sun::star::container::ElementExistException, InvalidRegistryException )
{
	// the "all languages" key
	Reference< XRegistryKey >  xAllLangs = getAllLanguageKey();
	if (!xAllLangs.is())
		// creation of this essential key failed ....
		throw InvalidRegistryException();

	// the key for the given language
	Reference< XRegistryKey >  xLang = xAllLangs->openKey(_rLangTitle);
	if (!xLang.is())
		xLang = xAllLangs->createKey(_rLangTitle);
	if (!xLang.is())
	{	// creation of this key failed ....
		xAllLangs->closeKey();
		throw InvalidRegistryException();
	}

	Reference< XRegistryKey >  xTitle = xLang->openKey(_rTitle);
	sal_Bool bExistent = xTitle.is();

	// close the keys before throwing an excpetion
	if (xTitle.is())
		xTitle->closeKey();
	xLang->closeKey();
	xAllLangs->closeKey();

	if (bExistent)
	{
		String sDesc(OSbaResourceCache::GetRegisteredString(RID_STR_DBACC_NAMEURL_EXISTS));
		while (sDesc.SearchAndReplaceAscii("$lang$", getDisplayName(getLocaleFromLangKey(_rLangTitle))) != STRING_NOTFOUND)
			;
		while (sDesc.SearchAndReplaceAscii("$title$", _rTitle) != STRING_NOTFOUND)
			;
		throw ElementExistException(sDesc, *this);
	}
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::checkTitleConflicts(const rtl::OUString& _rTitle, const Locale& _rLoc) throw( ::com::sun::star::container::ElementExistException, IllegalArgumentException )
{
	try
	{
		// check if there is
		// a) another object with the same title as fallback _and_
		// b) for this object doesn't exist a title in _rLang
		// (this would be a title ambiguity for _rLang)

		Locale aFallback;
		Reference< XRegistryKey >  xFallbackGroup = getLanguageKey(aFallback, sal_True);
		if (!xFallbackGroup.is())
			throw InvalidRegistryException();

		Reference< XRegistryKey >  xExistentFallback = xFallbackGroup->openKey(_rTitle);
		if (xExistentFallback.is())
		{
			rtl::OUString sURL = xExistentFallback->getStringValue();
			rtl::OUString sUrlLangTitle = getTitleForLanguage(sURL, _rLoc);
			if (!sUrlLangTitle.getLength())
			{	// there is an URL wich has no title for _rLoc, but as fallback it uses _rTitle
				// -> conflict if another URL is about to get this title ...
				xExistentFallback->closeKey();
				xFallbackGroup->closeKey();

				String sDesc(OSbaResourceCache::GetRegisteredString(RID_STR_DBACC_TITLE_CONFLICT));
				while (sDesc.SearchAndReplaceAscii("$title$", _rTitle) != STRING_NOTFOUND)
					;
				while (sDesc.SearchAndReplaceAscii("$lang$", getDisplayName(_rLoc)) != STRING_NOTFOUND)
					;
				while (sDesc.SearchAndReplaceAscii("$url$", sURL) != STRING_NOTFOUND)
					;
				throw ElementExistException(sDesc, *this);
			}
			xExistentFallback->closeKey();
		}
		xFallbackGroup->closeKey();
	}
	catch (InvalidRegistryException)
	{
		throw IllegalArgumentException();
	}
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::checkFallbackTitleConflicts(const rtl::OUString& _rTitle, const rtl::OUString& _rURL) throw( ::com::sun::star::container::ElementExistException, IllegalArgumentException )
{
	try
	{
		Reference< XRegistryKey >  xAllLangs = getAllLanguageKey();
		if (!xAllLangs.is())
			throw InvalidRegistryException();
			// catched and thrown again below

		// check if there is
		// a) another object which has the same title in another language _and_
		// b) for _rURL doesn't exist a title in this language
		// (this would be a title ambiguity for this special language)

		sal_Bool bForeignLanguageConflict = sal_False;
		rtl::OUString sConflictURL;

		rtl::OUString sNormalizedURL = _rURL;
		substFileURLVars(sNormalizedURL);
		// loop through all languages
		ORegistryLevelEnumeration aLanguages(xAllLangs);
		while (aLanguages.hasMoreElements() && !bForeignLanguageConflict)
		{
			Reference< XRegistryKey >  xCurLang = aLanguages.nextElement();
			rtl::OUString sCurrentLanguage = implGetShortKeyName(xCurLang);

			// go through all entries for this language
			ORegistryLevelEnumeration aObjects(xCurLang);
			while (aObjects.hasMoreElements() && !bForeignLanguageConflict)
			{
				Reference< XRegistryKey >  xCurObj = aObjects.nextElement();
				rtl::OUString sCurrentName = implGetShortKeyName(xCurObj);

				bForeignLanguageConflict = (sCurrentName.equals(_rTitle));
					// maybe corrected immediately, this is only a potential conflict 'til now :
					// the object in the foreign language has the same title as new object is about to get in the
					// requested language (i.e. locale)
				if (bForeignLanguageConflict)
				{
					try { sConflictURL = xCurObj->getStringValue(); } catch (...) { };
					ORegistryLevelEnumeration aCurrentLanguage(xCurLang);
					while (aCurrentLanguage.hasMoreElements())
					{
						Reference< XRegistryKey >  xCheckUrl = aCurrentLanguage.nextElement();
						rtl::OUString sThisRoundUrl = xCheckUrl->getStringValue();
						substFileURLVars(sThisRoundUrl);
						if (compareURLs(sThisRoundUrl, sNormalizedURL) == 0)
							// in the language with the potential conflict the given URL has another title ...
							bForeignLanguageConflict = sal_False;
						xCheckUrl->closeKey();
					}
				}

				xCurObj->closeKey();
			}

			xCurLang->closeKey();
		}
		if (bForeignLanguageConflict)
		{
			String sDesc(OSbaResourceCache::GetRegisteredString(RID_STR_DBACC_FALLBACKTITLE_CONFLICT));
			while (sDesc.SearchAndReplaceAscii("$title$", _rTitle) != STRING_NOTFOUND)
				;
			while (sDesc.SearchAndReplaceAscii("$url1$", _rURL) != STRING_NOTFOUND)
				;
			while (sDesc.SearchAndReplaceAscii("$url1$", sConflictURL) != STRING_NOTFOUND)
				;
			throw ::com::sun::star::container::ElementExistException();
		}
		xAllLangs->closeKey();
	}
	catch (InvalidRegistryException)
	{
		throw IllegalArgumentException();
	}
}

//--------------------------------------------------------------------------
Reference< XRegistryKey >  ODatabaseAccessContext::getUrlKey(const rtl::OUString& _rURL, const Locale& _rLoc)
{
	Reference< XRegistryKey >  xReturn;
	try
	{
		rtl::OUString sNormalizedURL(_rURL);
		substFileURLVars(sNormalizedURL);

		Reference< XRegistryKey >  xLanguageKey = getLanguageKey(_rLoc, sal_False);
		ORegistryLevelEnumeration aSearch(xLanguageKey);
		while (aSearch.hasMoreElements())
		{
			Reference< XRegistryKey >  xCheck = aSearch.nextElement();
			rtl::OUString sThisRound(xCheck->getStringValue());
			substFileURLVars(sThisRound);
			if (compareURLs(sThisRound, sNormalizedURL) == 0)
			{
				xReturn = xCheck;
				break;
			}
			xCheck->closeKey();
		}
	}
	catch (InvalidRegistryException)
	{

	}
	return xReturn;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getTitleForLanguage(const rtl::OUString& _rURL, const Locale& _rLoc)
{
	rtl::OUString sReturn;
	Reference< XRegistryKey >  xUrlKey = getUrlKey(_rURL, _rLoc);
	if (xUrlKey.is())
	{
		try
		{
			sReturn = implGetShortKeyName(xUrlKey);
		}
		catch (InvalidRegistryException)
		{
		}
	}
	return sReturn;
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::implRegister(const rtl::OUString& _rTitle, const rtl::OUString& _rURL, const Locale& _rLoc)
{
	Reference< XRegistryKey >  xLanguageKey = getLanguageKey(_rLoc, sal_True);
	if (xLanguageKey.is())
	{
		try
		{
			rtl::OUString sNormalizedURL(_rURL);
			substFileURLVars(sNormalizedURL);

			Reference< XRegistryKey >  xExistentKey = xLanguageKey->openKey(_rTitle);
			if (xExistentKey.is())
			{
				rtl::OUString sExistentURL = xExistentKey->getStringValue();
				substFileURLVars(sExistentURL);
				if (compareURLs(sExistentURL, sNormalizedURL) == 0)
				{	// nothing to do, all is fine
					xExistentKey->closeKey();
					xLanguageKey->closeKey();
					return;
				}
				// there is another url registered for this title
				String sDesc(OSbaResourceCache::GetRegisteredString(RID_STR_DBACC_TITLE_USED));
				while (sDesc.SearchAndReplaceAscii("$title$", _rTitle) != STRING_NOTFOUND);
					;
				while (sDesc.SearchAndReplaceAscii("$lang$", getDisplayName(_rLoc)) != STRING_NOTFOUND);
					;
				while (sDesc.SearchAndReplaceAscii("$url$", sExistentURL) != STRING_NOTFOUND)
					;
				throw ElementExistException(sDesc, *this);
				// note : this exception passes the catch-statement below !
			}

			Locale aFallbackLoc;
			rtl::OUString sExistentFallbackTitle = getTitleForLanguage(_rURL, aFallbackLoc);
			sal_Bool bCreateAsFallback = !sExistentFallbackTitle.getLength();
			if (bCreateAsFallback)
			{	// we have no fallback title for the given URL, so we need to create one, so check this first
				// check if we already have a fallback entry with the given title
				Locale aFallback;
				checkTitleExistence(_rTitle, getLanguageString(aFallback));
				// then check if there any potential conflicts if we would create the fallback title
				checkFallbackTitleConflicts(_rTitle, _rURL);
			}

			// at this point we know that the title given may be used as fallback if necessary

			// we already tested the title for uniqueness within _rLoc (with the above openKey), but neverless
			// there may be a potential conflict with the default names of other files
			if (!sExistentFallbackTitle.equals(_rTitle))
				// if he existent fallback title for _rURL already is _rTitle, there is no other URL with
				// the same fallback title, so checkTitleConflicts isn't necessary (and indeed it would
				// throw an ::com::sun::star::container::ElementExistException in that case as it thinks _rTitle is invalid)
				checkTitleConflicts(_rTitle, _rLoc);

			// does there already exist a title for the given URL/Locale ?
			rtl::OUString sOldTitle = getTitleForLanguage(_rURL, _rLoc);
			if (sOldTitle.getLength())
				// yes -> delete it
				xLanguageKey->deleteKey(sOldTitle);

			xExistentKey = xLanguageKey->createKey(_rTitle);
			if (!xExistentKey.is())
				throw IllegalArgumentException();

			xExistentKey->setStringValue(_rURL);
			xExistentKey->closeKey();

			xLanguageKey->closeKey();

			if (bCreateAsFallback)
			{
				Reference< XRegistryKey >  xFallbackGroup = getLanguageKey(aFallbackLoc, sal_True);
				if (!xFallbackGroup.is())
					throw InvalidRegistryException();

				Reference< XRegistryKey >  xFallback = xFallbackGroup->createKey(_rTitle);
				if (xFallback.is())
				{
					xFallback->setStringValue(_rURL);
					xFallback->closeKey();
				}
				xFallbackGroup->closeKey();
			}
		}
		catch (InvalidRegistryException)
		{
			DBG_ERROR("ODatabaseAccessContext::registerObject : could not write to the registry !");
			throw IllegalArgumentException();
		}
	}
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::implRevoke(const rtl::OUString& _rTitle, const Locale& _rLoc)
{
	Reference< XRegistryKey >  xLanguageKey = getLanguageKey(_rLoc, sal_False);
	if (xLanguageKey.is())
	{
		try
		{
			Reference< XRegistryKey >  xExistentKey = xLanguageKey->openKey(_rTitle);
			if (xExistentKey.is())
			{
				xExistentKey->closeKey();
				xLanguageKey->deleteKey(_rTitle);
			}
			xLanguageKey->closeKey();
		}
		catch (InvalidRegistryException)
		{
			DBG_ERROR("ODatabaseAccessContext::revokeObject : could not revoke the registry entries !");
		}
	}
}

//--------------------------------------------------------------------------
Locale ODatabaseAccessContext::getCurrentLocale() const
{
	if (!m_aCurrentLocale.Language.getLength())
	{
		String sLanguage, sCountry;
		ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
		((ODatabaseAccessContext*)this)->m_aCurrentLocale.Language = sLanguage;
		((ODatabaseAccessContext*)this)->m_aCurrentLocale.Country = sCountry;
	}
	return m_aCurrentLocale;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getLanguageString(const Locale& _rLoc) const
{
	rtl::OUString sLangString = _rLoc.Language;
	sLangString += ::rtl::OUString::createFromAscii("#");
	sLangString += _rLoc.Country;
	return sLangString;
}

//--------------------------------------------------------------------------
Locale ODatabaseAccessContext::getLocaleFromLangKey(const rtl::OUString& _rLangKey) const
{
	sal_Int32 nDelimiter = _rLangKey.indexOf(::rtl::OUString::createFromAscii("#"));
	DBG_ASSERT((nDelimiter != -1) && (nDelimiter == _rLangKey.lastIndexOf(::rtl::OUString::createFromAscii("#"))),
		"ODatabaseAccessContext::getLocaleFromLangKey : invalid arg (not got from getLanguageString ?) !");

	Locale aReturn;
	aReturn.Language = _rLangKey.copy(0, nDelimiter - 1);
	aReturn.Country = _rLangKey.copy(nDelimiter + 1);
	return aReturn;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getDisplayName(const Locale& _rLoc)
{
	if (!_rLoc.Language.getLength() && !_rLoc.Country.getLength())
		return OSbaResourceCache::GetRegisteredString(RID_STR_STANDARD);

	LanguageType eLang = ConvertIsoNamesToLanguage(_rLoc.Language, _rLoc.Country);
	return m_pLanguages->GetString(eLang);
}

//--------------------------------------------------------------------------
Reference< XRegistryKey >  ODatabaseAccessContext::getAllLanguageKey() const
{
	Reference< XRegistryKey >  xReturn;
	if (m_xRegistry.is())
	{
		try
		{
			Reference< XRegistryKey >  xRootKey = m_xRegistry->getRootKey();
			if (xRootKey.is())
			{
				xReturn = xRootKey->openKey(::rtl::OUString::createFromAscii("StarOffice Database Names 1.0"));
				if (!xReturn.is())
					xReturn = xRootKey->createKey(::rtl::OUString::createFromAscii("StarOffice Database Names 1.0"));
			}
		}
		catch (InvalidRegistryException)
		{
		}
	}
	return xReturn;
}

//--------------------------------------------------------------------------
Reference< XRegistryKey >  ODatabaseAccessContext::getLanguageKey(const Locale& _rLoc, sal_Bool _bCreate) const
{
	Reference< XRegistryKey >  xReturn;
	try
	{
		Reference< XRegistryKey >  xAllLangs = getAllLanguageKey();
		if (xAllLangs.is())
		{
			rtl::OUString sLanguageKey(getLanguageString(_rLoc));
			xReturn = xAllLangs->openKey(sLanguageKey);
			if (!xReturn.is() && _bCreate)
				xReturn = xAllLangs->createKey(sLanguageKey);
		}
	}
	catch (InvalidRegistryException)
	{
	}
	return xReturn;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::implGetLocation(const rtl::OUString& _rTitle, const Locale& _rLoc) const
{
	rtl::OUString sLocation;
	if (m_xRegistry.is())
	{
		try
		{
			Reference< XRegistryKey >  xLangKey = getLanguageKey(_rLoc, sal_False);
			Reference< XRegistryKey >  xTitleKey = xLangKey.is() ? xLangKey->openKey(_rTitle) : Reference< XRegistryKey > ();
			if (xTitleKey.is())
				sLocation = xTitleKey->getStringValue();
		}
		catch (InvalidRegistryException)
		{
		}
		catch (InvalidValueException)
		{

			DBG_ERROR("ODatabaseAccessContext::implGetLocation : InvalidValueException .. .how this ?");
				// this would mean the key hasn't a string value
		}
	}
	return sLocation;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::getObjectURL(const Reference< XInterface > & _rxObject) throw( IllegalArgumentException )
{
	Reference< XPropertySet >  xSet(_rxObject, UNO_QUERY);
	if (!xSet.is())
		throw IllegalArgumentException();

	rtl::OUString sURL;
	try
	{
		xSet->getPropertyValue(PROPERTY_URL) >>= sURL;
	}
	catch (...)
	{
		throw IllegalArgumentException();
	}
	return sURL;
}

//--------------------------------------------------------------------------
rtl::OUString ODatabaseAccessContext::implGetShortKeyName(const Reference< XRegistryKey > & _rxKey) const
{
	rtl::OUString sReturn;
	if (_rxKey.is())
	{
		sReturn = _rxKey->getKeyName();
		sal_Int32 nSeparatorPos = sReturn.lastIndexOf(L'/');
		if (nSeparatorPos != -1)
			sReturn = sReturn.copy(nSeparatorPos + 1);
	}
	return sReturn;
}

//--------------------------------------------------------------------------
Sequence<rtl::OUString> ODatabaseAccessContext::implGetShortChildKeyNames(const Reference< XRegistryKey > & _rxKey) const
{
	Sequence<rtl::OUString> aReturn;
	if (_rxKey.is())
	{
		aReturn = _rxKey->getKeyNames();
		rtl::OUString* pReturn = aReturn.getArray();
		for (sal_Int32 i=0; i<aReturn.getLength(); ++i, ++pReturn)
		{
			sal_Int32 nSeparatorPos = pReturn->lastIndexOf(L'/');
			if (nSeparatorPos != -1)
				*pReturn = pReturn->copy(nSeparatorPos + 1);
		}
	}
	return aReturn;
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::implRegisterAddressDB()
{
	if (!m_xEnvironment.is())
		// can't do anything
		return;

	rtl::OUString sAddrDbName;
	// get the SpecialConfigManager which can tell us about the location of the address book
	Reference< ::com::sun::star::frame::XConfigManager > xSofficeIni(
		m_xServiceManager->createInstance(rtl::OUString::createFromAscii("com.sun.star.config.SpecialConfigManager")), UNO_QUERY);
	try
	{
		Reference< XSimpleRegistry >  xIniRegistry(xSofficeIni, UNO_QUERY);
		if (xIniRegistry.is())
		{
			Reference< XRegistryKey >  xIniRoot = xIniRegistry->getRootKey();
			Reference< XRegistryKey >  xAddrBookLocation = xIniRoot.is() ? xIniRoot->openKey(::rtl::OUString::createFromAscii("Database/AddressBook")) : Reference< XRegistryKey > ();
			if (xAddrBookLocation.is())
			{
				sAddrDbName = xAddrBookLocation->getStringValue();
				sal_Int32 nSepPos = sAddrDbName.indexOf(L';');
				if (nSepPos != -1)
					sAddrDbName = sAddrDbName.copy(0, nSepPos);
			}
		}
	}
	catch (InvalidRegistryException)
	{
	}
	catch (InvalidValueException)
	{
	}

	if (sAddrDbName.getLength() == 0)
		// nothing known about the address book
		return;

	// normalize the file url
	substFileURLVars(sAddrDbName);
	INetURLObject aFile;
	aFile.SetSmartProtocol(INET_PROT_FILE);
	aFile.SetSmartURL(sAddrDbName);
	sAddrDbName = aFile.GetMainURL();

	// do we already have an alias for the the URL ?
	rtl::OUString sAlias;
	try
	{
		sAlias = lookupProgrammatic(Locale(), sAddrDbName);
	}
	catch (NoSuchElementException)
	{
	}

	if (sAlias.getLength())
		// already registered
		return;

	// try to open the database access for the address book
	Reference< XDatabaseAccess >  xAddressBook;
	try
	{
		xAddressBook = m_xEnvironment->getDatabaseAccess(sAddrDbName);
	}
	catch (SQLException)
	{
	}

	if (!xAddressBook.is())
		// can't do anything
		return;

	// get the title of the the database access
	try
	{
		Reference< XPropertySet >  xProps(xAddressBook, UNO_QUERY);
		if (xProps.is())
			xProps->getPropertyValue(PROPERTY_TITLE) >>= sAlias;
	}
	catch (...)
	{
	}

	if (!sAlias.getLength())
		// doesn't have a title, can't register
		return;

	// now register it
	try
	{
		implRegister(sAlias, sAddrDbName, Locale());
	}
	catch (...)
	{
	}
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::implGetRegistry()
{
	if (m_xRegistry.is())
		return;

	sal_Bool bSuccess = sal_False;
	try
	{
		m_xRegistry = Reference< XSimpleRegistry > (
				m_xServiceManager->createInstance(rtl::OUString::createFromAscii("com.sun.star.registry.SimpleRegistry")), UNO_QUERY);

		if (m_xRegistry.is())
		{
			// calc the registry file name
			String sRegistryFile;
			String sUserDirFallback;
			Reference< ::com::sun::star::frame::XConfigManager > xSofficeIni(
				m_xServiceManager->createInstance(rtl::OUString::createFromAscii("com.sun.star.config.SpecialConfigManager")), UNO_QUERY);
			Reference< XSimpleRegistry >  xIniRegistry(xSofficeIni, UNO_QUERY);

			try
			{
				if (xIniRegistry.is())
				{
					Reference< XRegistryKey >  xIniRoot = xIniRegistry->getRootKey();
					Reference< XRegistryKey >  xDirectories = xIniRoot.is() ? xIniRoot->openKey(::rtl::OUString::createFromAscii("Directories/")) : Reference< XRegistryKey > ();
					if (xDirectories.is())
					{
						Reference< XRegistryKey >  xUserConfigKey = xDirectories->openKey(::rtl::OUString::createFromAscii("UserConfig-Path"));
						if (xUserConfigKey.is())
						{
							rtl::OUString sValue = xUserConfigKey->getStringValue();
							sRegistryFile = (const sal_Unicode*)xSofficeIni->substituteVariables(sValue);
							sRegistryFile += DirEntry::GetAccessDelimiter();
							sRegistryFile.AppendAscii("dbtitle.rdb");
							sUserDirFallback = sRegistryFile;
						}
						if (sRegistryFile.Len() && !DirEntry(sRegistryFile).Exists())
						{
							sRegistryFile.Erase();	// in case of exceptions ...
							// check the global config dir
							Reference< XRegistryKey >  xGlobalConfigKey = xDirectories->openKey(::rtl::OUString::createFromAscii("Config-Dir"));
							if (xGlobalConfigKey.is())
							{
								rtl::OUString sValue = xGlobalConfigKey->getStringValue();
								sRegistryFile = (const sal_Unicode*)xSofficeIni->substituteVariables(sValue);
								sRegistryFile += DirEntry::GetAccessDelimiter();
								sRegistryFile.AppendAscii("dbtitle.rdb");
							}
						}
						if (sRegistryFile.Len() && !DirEntry(sRegistryFile).Exists())
							sRegistryFile.Erase();
					}
				}
			}
			catch (InvalidRegistryException)
			{
				sRegistryFile.Erase();
			}


			// have we to create a new registry within the user dir ?
			sal_Bool bCreateIt = sal_False;
			if (!sRegistryFile.Len())
			{
				sRegistryFile = sUserDirFallback;
				bCreateIt = sal_True;
			}

			if (sRegistryFile.Len())
			{
				try
				{
					m_xRegistry->open(sRegistryFile, sal_False, bCreateIt);
					if (m_xRegistry->getRootKey().is())
						bSuccess = sal_True;
				}
				catch (InvalidRegistryException)
				{
				}
			}
		}
	}
	catch (...)
	{
		// something went heavyly wrong (e.g. the instantiation of the SpecialConfigManager)
		bSuccess = sal_False;
	}

	if (!bSuccess)
	{
		if (m_xRegistry.is())
		{
			try { m_xRegistry->close(); } catch (InvalidRegistryException) {  };
		}
		m_xRegistry = NULL;
	}
}

//--------------------------------------------------------------------------
Reference< XSimpleRegistry >  ODatabaseAccessContext::getSubRegistry(const rtl::OUString& _rURL)
{
	rtl::OUString sDatabaseInformations = rtl::OUString::createFromAscii("/StarOffice Database Informations 1.0/");
	return new OKeyRegistry(m_xRegistry, sDatabaseInformations + _rURL);
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::implCopyKeys(const Reference< XRegistryKey > & _rxSource, const Reference< XRegistryKey > & _rxDest)
{
	try
	{
		Sequence<Reference< XRegistryKey > > aSourceKeys = _rxSource->openKeys();
		const Reference< XRegistryKey > * pSourceKeys = aSourceKeys.getConstArray();
		for (sal_Int32 i=0; i<aSourceKeys.getLength(); ++i, ++pSourceKeys)
		{
			// create an equivalent key within the destination key
			rtl::OUString sKeyName = implGetShortKeyName(*pSourceKeys);
			Reference< XRegistryKey >  xCurrentDest = _rxDest->openKey(sKeyName);
			if (!xCurrentDest.is())
				// not existent yet
				xCurrentDest = _rxDest->createKey(sKeyName);

			// copy all child keys
			implCopyKeys(*pSourceKeys, xCurrentDest);
			// copy the key value
			switch ((*pSourceKeys)->getValueType())
			{
				case RegistryValueType_LONG:
					xCurrentDest->setLongValue((*pSourceKeys)->getLongValue());
					break;
				case RegistryValueType_ASCII:
					xCurrentDest->setAsciiValue((*pSourceKeys)->getAsciiValue());
					break;
				case RegistryValueType_STRING:
					xCurrentDest->setStringValue((*pSourceKeys)->getStringValue());
					break;
				case RegistryValueType_BINARY:
					xCurrentDest->setBinaryValue((*pSourceKeys)->getBinaryValue());
					break;
				case RegistryValueType_LONGLIST:
					xCurrentDest->setLongListValue((*pSourceKeys)->getLongListValue());
					break;
				case RegistryValueType_ASCIILIST:
					xCurrentDest->setAsciiListValue((*pSourceKeys)->getAsciiListValue());
					break;
				case RegistryValueType_STRINGLIST:
					xCurrentDest->setStringListValue((*pSourceKeys)->getStringListValue());
					break;
			}
		}
	}
	catch (...)
	{
	}
}

//--------------------------------------------------------------------------
void ODatabaseAccessContext::renameSubRegistry(const rtl::OUString& _rOldURL, const rtl::OUString& _rNewURL)
{
	if (!m_xRegistry.is())
		return;
	Reference< XRegistryKey >  xRoot = m_xRegistry->getRootKey();
	if (!xRoot.is())
		return;

	static rtl::OUString sDatabaseInformations = ::rtl::OUString::createFromAscii("/StarOffice Database Informations 1.0/");
	// open the key for the old URL
	Reference< XRegistryKey >  xOldKey;
	rtl::OUString sOldKeyName = sDatabaseInformations + _rOldURL;
	try
	{
		xOldKey = xRoot->openKey(sOldKeyName);
	}
	catch (...)
	{
	}
	if (!xOldKey.is())
		// nothing to do
		return;

	// the key for the new URL
	Reference< XRegistryKey >  xNewKey;
	rtl::OUString sNewKeyName = sDatabaseInformations + _rNewURL;
	try
	{
		xNewKey = xRoot->openKey(sNewKeyName);
		if (!xNewKey.is())
			xNewKey = xRoot->createKey(sNewKeyName);
	}
	catch (...)
	{
	}

	if (!xNewKey.is())
	{
		DBG_ERROR("ODatabaseAccessContext::renameSubRegistry : could not create the new key !");
		return;
	}

	// transfer all sub keys
	implCopyKeys(xOldKey, xNewKey);

	// delete the old key
	try
	{
		xRoot->deleteKey(sOldKeyName);
	}
	catch (...)
	{
	}
}



