/*************************************************************************
 *
 *  $RCSfile: datacolumn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <datacolumn.hxx>
#include <api.hrc>
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_COLUMNVALUE_HPP_
#include <com/sun/star/sdbc/ColumnValue.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEFIELDTYPE_HPP_
#include <com/sun/star/data/DatabaseFieldType.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOBJECTOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XObjectOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HDL_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _UNOTOOLS_DATETIME_HXX_
#include <unotools/datetime.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _SDB_TYPECONV_HXX
#include <sdb/typeconv.hxx>
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::osl;
using namespace ::cppu;


//************************************************************
//  ODataColumn
//************************************************************
//------------------------------------------------------------------------------
ODataColumn::ODataColumn(const Reference< XPropertySet > & rCol)
			:OResultColumn(rCol)
			,m_bFireValueChanges(sal_True)
			,m_pResultSet(NULL)
{
	construct(rCol);
}

//------------------------------------------------------------------------------
void ODataColumn::construct(const Reference< XPropertySet > & xSet)
{
	if (xSet.is())
	{
		m_xValue = new ODbVariant();
		m_xValue->setAny(xSet->getPropertyValue(PROPERTY_VALUE));
	}
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > ODataColumn::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XColumn > *)0 ),
						   ::getCppuType( (const Reference< XColumnUpdate > *)0 ),
							OColumn::getTypes() );

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODataColumn::getImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}


// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any ODataColumn::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OColumn::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XColumn * >( this ),
					static_cast< XColumnUpdate * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void ODataColumn::acquire() throw(RuntimeException)
{
	OColumn::acquire();
}

//--------------------------------------------------------------------------
void ODataColumn::release() throw(RuntimeException)
{
	OColumn::release();
}

// OComponentHelper
//------------------------------------------------------------------------------
void ODataColumn::disposing()
{
	OResultColumn::disposing();
	MutexGuard aGuard(m_aMutex);
	m_xValue = NULL;
	m_pResultSet = NULL;
}

// utl::OPropertyArrayUsageHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper* ODataColumn::createArrayHelper( ) const
{
	BEGIN_PROPERTY_HELPER(25)
		DECL_PROP1(CATALOGNAME,				::rtl::OUString,	READONLY);
		DECL_PROP1(DEFAULTVALUE,			::rtl::OUString,	READONLY);
		DECL_PROP1(DESCRIPTION,				::rtl::OUString,	READONLY);
		DECL_PROP1(DISPLAYSIZE,				sal_Int32,		READONLY);
		DECL_PROP1(NUMBERFORMAT,			sal_Int32,		READONLY);
		DECL_PROP1_BOOL(ISAUTOINCREMENT,			READONLY);
		DECL_PROP1_BOOL(ISCASESENSITIVE,			READONLY);
		DECL_PROP1_BOOL(ISCURRENCY,				READONLY);
		DECL_PROP1_BOOL(ISDEFINITELYWRITABLE,	READONLY);
		DECL_PROP1(ISNULLABLE,				sal_Int32,		READONLY);
		DECL_PROP1_BOOL(ISREADONLY,				READONLY);
		DECL_PROP1_BOOL(ISROWVERSION,			READONLY);
		DECL_PROP1_BOOL(ISSEARCHABLE,			READONLY);
		DECL_PROP1_BOOL(ISSIGNED,				READONLY);
		DECL_PROP1_BOOL(ISWRITABLE,				READONLY);
		DECL_PROP1(LABEL,					::rtl::OUString,	READONLY);
		DECL_PROP1(NAME,					::rtl::OUString,	READONLY);
		DECL_PROP1(PRECISION,				sal_Int32,		READONLY);
		DECL_PROP1(SCALE,					sal_Int32,		READONLY);
		DECL_PROP1(SCHEMANAME,				::rtl::OUString,	READONLY);
		DECL_PROP1(SERVICENAME,				::rtl::OUString,	READONLY);
		DECL_PROP1(TABLENAME,				::rtl::OUString,	READONLY);
		DECL_PROP1(TYPE,					sal_Int32,		READONLY);
		DECL_PROP1(TYPENAME,				::rtl::OUString,	READONLY);
		DECL_PROP1(VALUE,					Any,		BOUND);
	END_PROPERTY_HELPER();
}

// cppu::OPropertySetHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper& ODataColumn::getInfoHelper()
{
	return *static_cast< ::utl::OPropertyArrayUsageHelper<ODataColumn>*>(this)->getArrayHelper();
}

//------------------------------------------------------------------------------
sal_Bool ODataColumn::convertFastPropertyValue(
							Any & rConvertedValue,
							Any & rOldValue,
							sal_Int32 nHandle,
							const Any& rValue )
								throw (IllegalArgumentException)
{
	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROPERTY_ID_VALUE:
		{
			if (m_bReadOnly || !m_xValue.is())
				throw IllegalArgumentException();

			ODbVariantRef xTemp = m_xValue;
			m_xValue = new ODbVariant();
			try
			{
				// dont fire any propertychange events during conversion
				m_bFireValueChanges = sal_False;

				// writes the value directly, not in setFast....
				updateObject(rValue);
				rConvertedValue = rValue;

				// we can fire again
				m_bFireValueChanges = sal_True;
			}
			catch (...)
			{
				m_xValue = xTemp;
				m_bFireValueChanges = sal_True;
				throw IllegalArgumentException();
			}
			rConvertedValue = m_xValue->getAny();
			bModified = !::areEqual(rConvertedValue, rOldValue);
			m_xValue  = xTemp;
			break;
		}
		default:
			bModified = OResultColumn::convertFastPropertyValue(rConvertedValue, rOldValue, nHandle, rValue);
	}
	return bModified;
}

//------------------------------------------------------------------------------
void ODataColumn::setFastPropertyValue_NoBroadcast(
								sal_Int32 nHandle,
								const Any& rValue
												 )
												 throw (Exception)
{
	switch (nHandle)
	{
		case PROPERTY_ID_VALUE:
		{
			try
			{
				updateObject(rValue);
			}
			catch ( ... )
			{
			}
		}	break;
		default:
			OResultColumn::setFastPropertyValue_NoBroadcast(nHandle, rValue);
	}
}

//------------------------------------------------------------------------------
void ODataColumn::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_VALUE:
			if (m_xValue.is())
				rValue = m_xValue->getAny();
			break;
		default:
			OResultColumn::getFastPropertyValue(rValue, nHandle);
	}
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString ODataColumn::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.ODataColumn");
}

//------------------------------------------------------------------------------
sal_Bool ODataColumn::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > ODataColumn::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< ::rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDB_COLUMN;
	return aSNS;
}

//------------------------------------------------------------------------------
void ODataColumn::setDefault()
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly && m_aDefaultValue.len())
	{
		m_xValue->setString(m_aDefaultValue);
		aGuard.clear();
		fireValueChanged();
	}
}

//--------------------------------------------------------------------------
void ODataColumn::setValue(const ODbVariantRef& xValue, sal_Bool bBroadcast)
{
	{
		MutexGuard aGuard( m_aMutex );
		m_xValue = xValue;
	}
	if (bBroadcast)
		fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::fireValueChanged()
{
	sal_Int32 nHandle = -1;
	Any aVal, aOldVal;
	{
		MutexGuard aGuard(m_aMutex);

		// prevent disposing while we're herein (73365 - 23.02.00 - FS)
		if (m_bFireValueChanges && hasValueListeners()
			&& m_xValue.is() && *m_xOldValue != *m_xValue)
		{
			// file a change event, if the value changed
			nHandle	= PROPERTY_ID_VALUE;
			aVal	= m_xValue->getAny();
			aOldVal	= m_xOldValue->getAny();

			// Referenzwert speichern
			(*m_xOldValue) = *m_xValue;
		}
	}

	if (nHandle != -1)
		fire(&nHandle, &aVal, &aOldVal, 1, sal_False );
}

// XColumn
//------------------------------------------------------------------------------
sal_Bool ODataColumn::wasNull(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	return m_xValue->isNull();
}

//------------------------------------------------------------------------------
rtl::OUString ODataColumn::getString(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toString(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return rtl::OUString();
}

//------------------------------------------------------------------------------
sal_Bool ODataColumn::getBoolean(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBOOL(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return sal_False;
}

//------------------------------------------------------------------------------
sal_Int8 ODataColumn::getByte(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBYTE(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int16 ODataColumn::getShort(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT16(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int32 ODataColumn::getInt(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT32(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int64 ODataColumn::getLong(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT64(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
float ODataColumn::getFloat(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toFloat(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0.0;
}
//------------------------------------------------------------------------------
double ODataColumn::getDouble(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toDouble(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0.0;
}

//------------------------------------------------------------------------------
Sequence< sal_Int8 > ODataColumn::getBytes(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBytes(*m_xValue);
		}
		catch ( ... )
		{
		}
	}
	return Sequence< sal_Int8 >();
}
//------------------------------------------------------------------------------
com::sun::star::util::Date ODataColumn::getDate(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	com::sun::star::util::Date aDate;
	if (!m_xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toDate(*m_xValue), aDate);
		}
		catch ( ... )
		{
		}
	}
	return aDate;
}

//------------------------------------------------------------------------------
com::sun::star::util::Time ODataColumn::getTime(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	com::sun::star::util::Time aTime;
	if (!m_xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toTime(*m_xValue), aTime);
		}
		catch ( ... )
		{
		}
	}
	return aTime;
}
//------------------------------------------------------------------------------
com::sun::star::util::DateTime ODataColumn::getTimestamp(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	com::sun::star::util::DateTime aDateTime;
	if (!m_xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toDateTime(*m_xValue), aDateTime);
		}
		catch ( ... )
		{
		}
	}
	return aDateTime;
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  ODataColumn::getBinaryStream(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		switch (m_nType)
		{
			case DataType::OTHER:
			case DataType::BINARY:
			case DataType::VARBINARY:
			case DataType::LONGVARBINARY:
			{
				if (m_xValue->getValueType() == ::getCppuType((const Sequence< sal_Int8 > *)0))
				{
					Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
					if (xSink.is())
					{
						// TODO
						// SbaUnoInputStream* pUnoStream = new SbaUnoInputStream(m_xValue->getBytes());
						// xSink->setInputStream(Reference< ::com::sun::star::io::XInputStream > (pUnoStream));
						return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
					}
				}
				else
				{
					Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
					if (xSink.is())
					{
						// TODO
						// SbaUnoInputStream* pUnoStream = new SbaUnoInputStream(Sequence<sal_Int8>());
						// xSink->setInputStream(Reference< ::com::sun::star::io::XInputStream > (pUnoStream));
						return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
					}
				}
				break;
			}
		}
	}
	return Reference< ::com::sun::star::io::XInputStream > ();
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  ODataColumn::getCharacterStream(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_xValue->isNull())
	{
		switch (m_nType)
		{
			case DataType::CHAR:
			case DataType::VARCHAR:
			case DataType::LONGVARCHAR:
			{
				rtl::OUString aStr = getString();

				// writes the string as character sequence
				// creating a pipe
				Reference< ::com::sun::star::io::XOutputStream >  xOutPipe(utl::getProcessServiceFactory()
									->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.Pipe")), UNO_QUERY);
				Reference< ::com::sun::star::io::XInputStream >  xInPipe(xOutPipe, UNO_QUERY);

				// connect pipe and sink
				Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
				xSink->setInputStream(xInPipe);

				// connect pipe and source
				Reference< ::com::sun::star::io::XActiveDataSource >  xSource(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectOutputStream")), UNO_QUERY);
				xSource->setOutputStream(xOutPipe);

				// write the string to source
				Reference< ::com::sun::star::io::XObjectOutputStream >  xOutStrm(xSource, UNO_QUERY);

				// get the stream length
				sal_Int32 nLen = aStr.len();
				Sequence<sal_Int8> aData((sal_Int8*)aStr.getStr(), (nLen + 1) * sizeof(sal_Unicode));
				xOutStrm->writeBytes(aData);
				xOutStrm->closeOutput();

				// return the input
				return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
			}
		}
	}
	return Reference< ::com::sun::star::io::XInputStream > ();
}

//------------------------------------------------------------------------------
Any ODataColumn::getObject(const Reference< ::com::sun::star::container::XNameAccess > & typeMap) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OColumnBase::rBHelper.bDisposed)
		throw DisposedException();

	return m_xValue->getAny();
}

//------------------------------------------------------------------------------
Reference< XRef >  ODataColumn::getRef(void) throw( SQLException, RuntimeException )
{
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XBlob >  ODataColumn::getBlob(void) throw( SQLException, RuntimeException )
{
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XClob >  ODataColumn::getClob(void) throw( SQLException, RuntimeException )
{
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XArray >  ODataColumn::getArray(void) throw( SQLException, RuntimeException )
{
	return NULL;
}

// XColumnUpdate
//------------------------------------------------------------------------------
void ODataColumn::updateNull(void) throw( SQLException, RuntimeException )
{
	// notified before modification
	if (m_pResultSet && m_bFireValueChanges)
		m_pResultSet->valueWillChange(*this);
	{
		MutexGuard aGuard( m_aMutex );
		if (OColumnBase::rBHelper.bDisposed)
			throw DisposedException();
		else if (m_bReadOnly)
			throw SQLException();
		m_xValue->setNull();
	}
	if (m_pResultSet && m_bFireValueChanges)
		m_pResultSet->valueHasChanged(*this);

	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateBoolean(sal_Bool x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setBOOL(x);
			}
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateByte(sal_Int8 x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setBYTE(x);
			}
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateShort(sal_Int16 x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);

			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setINT16(x);
			}

			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateInt(sal_Int32 x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);

			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setINT32(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateLong(sal_Int64 x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setINT64(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateFloat(float x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setFloat(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateDouble(double x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setDouble(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateString(const rtl::OUString& x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::OTHER:
		case DataType::OBJECT:
		case DataType::DISTINCT:
		case DataType::STRUCT:
		case DataType::ARRAY:
		case DataType::BLOB:
		case DataType::CLOB:
		case DataType::REF:
		{
			throw SQLException();
		}   break;
		default:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setString(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateBytes(const Sequence< sal_Int8 >& x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::OTHER:
		case DataType::OBJECT:
		{
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();
				m_xValue->setBytes(x);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
		}   break;
		default:
			throw SQLException();
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateDate(const com::sun::star::util::Date& x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::DATE:
		case DataType::TIMESTAMP:
		case DataType::CHAR:
		case DataType::VARCHAR:
		case DataType::DOUBLE:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();

				Date aConverted;
				utl::typeConvert(x, aConverted);
				m_xValue->setDate(aConverted);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
			break;
		default:
			throw SQLException();
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateTime(const ::com::sun::star::util::Time& x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::TIMESTAMP:
		case DataType::TIME:
		case DataType::CHAR:
		case DataType::VARCHAR:
		case DataType::DOUBLE:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();

				Time aConverted;
				utl::typeConvert(x, aConverted);
				m_xValue->setTime(aConverted);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
			break;
		default:
			throw SQLException();
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateTimestamp(const ::com::sun::star::util::DateTime& x) throw( SQLException, RuntimeException )
{
	switch (m_nType)
	{
		case DataType::TIMESTAMP:
		case DataType::DATE:
		case DataType::TIME:
		case DataType::CHAR:
		case DataType::VARCHAR:
		case DataType::DOUBLE:
			// notified before modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueWillChange(*this);
			{
				MutexGuard aGuard( m_aMutex );
				if (OColumnBase::rBHelper.bDisposed)
					throw DisposedException();
				else if (m_bReadOnly)
					throw SQLException();

				DateTime aConverted;
				utl::typeConvert(x, aConverted);
				m_xValue->setDateTime(aConverted);
			}
			// notified after modification
			if (m_pResultSet && m_bFireValueChanges)
				m_pResultSet->valueHasChanged(*this);
			break;
		default:
			throw SQLException();
	}
	fireValueChanged();
}
//------------------------------------------------------------------------------
void ODataColumn::updateCharacterStream(const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	if (!x.is())
		throw SQLException();

	switch (m_nType)
	{
		case DataType::LONGVARCHAR:
		{
			try
			{
				Sequence <sal_Int8> aData;
				rtl::OUString aDataStr;
				// the data is given as character data and the length defines the character length
				sal_Int32 nSize = x->readBytes(aData, length * sizeof(sal_Unicode));
				if (nSize / sizeof(sal_Unicode))
					aDataStr = rtl::OUString((sal_Unicode*)aData.getConstArray(), nSize / sizeof(sal_Unicode));
				// notified before modification
				if (m_pResultSet && m_bFireValueChanges)
					m_pResultSet->valueWillChange(*this);
				{
					MutexGuard aGuard( m_aMutex );
					if (OColumnBase::rBHelper.bDisposed)
						throw DisposedException();
					else if (m_bReadOnly)
						throw SQLException();
					m_xValue->setString(aDataStr);
				}
				// notified after modification
				if (m_pResultSet && m_bFireValueChanges)
					m_pResultSet->valueHasChanged(*this);
				x->closeInput();
			}
			catch ( ... )
			{
			}
		}   break;
		default:
			throw SQLException();
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateBinaryStream(const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	if (!x.is())
		throw SQLException();

	switch (m_nType)
	{
		case DataType::BINARY:
		case DataType::VARBINARY:
		case DataType::LONGVARBINARY:
		case DataType::OTHER:
		{
			try
			{
				Sequence <sal_Int8> aData;
				x->readBytes(aData, length);
				// notified before modification
				if (m_pResultSet && m_bFireValueChanges)
					m_pResultSet->valueWillChange(*this);
				{
					MutexGuard aGuard( m_aMutex );
					if (OColumnBase::rBHelper.bDisposed)
						throw DisposedException();
					else if (m_bReadOnly)
						throw SQLException();
					m_xValue->setBytes(aData);
				}
				// notified after modification
				if (m_pResultSet && m_bFireValueChanges)
					m_pResultSet->valueHasChanged(*this);
				x->closeInput();
			}
			catch ( ... )
			{
			}
		}   break;
		default:
		{
			throw SQLException();
		}
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void ODataColumn::updateNumericObject(const Any& x, sal_Int32 scale) throw( SQLException, RuntimeException )
{
	updateObject(x);
}

//------------------------------------------------------------------------------
void ODataColumn::updateObject(const Any& x) throw( SQLException, RuntimeException )
{
	if (x.getValueTypeClass() == TypeClass_ANY)
		updateObject(Any(*(Any*)x.getValue()));
	else
	{
		try
		{
			switch (x.getValueTypeClass())
			{
				case TypeClass_VOID:
					updateNull();
					break;
				case TypeClass_STRING:
					updateString(*(rtl::OUString*)x.getValue());
					break;
				case TypeClass_BOOLEAN:
					updateBoolean(*(sal_Bool *)x.getValue());
					break;
				case TypeClass_BYTE:
					updateByte(*(sal_Int8 *)x.getValue());
					break;
				case TypeClass_UNSIGNED_SHORT:
				case TypeClass_SHORT:
					updateShort(*(sal_Int16*)x.getValue());
					break;
				case TypeClass_CHAR:
					updateShort(*(sal_Int16*)(sal_Unicode *)x.getValue());//XXX
					break;
				case TypeClass_LONG:
				case TypeClass_UNSIGNED_LONG:
					updateLong(*(sal_Int32*)x.getValue());
					break;
				case TypeClass_FLOAT:
					updateFloat(*(float*)x.getValue());
					break;
				case TypeClass_DOUBLE:
					updateDouble(*(double*)x.getValue());
					break;
				case TypeClass_SEQUENCE:
					if (x.getValueType() == ::getCppuType((const Sequence< sal_Int8 > *)0))
						updateBytes(*(Sequence<sal_Int8>*)x.getValue());
					else
						throw IllegalArgumentException();
					break;
				case TypeClass_STRUCT:
				case TypeClass_INTERFACE:
					if (x.getValueType() == ::getCppuType(static_cast<Reference< ::com::sun::star::io::XInputStream>*>(NULL)))
					{
						Reference< ::com::sun::star::io::XInputStream >  xStream;
						x >>= xStream;
						if (m_nType == DataType::LONGVARCHAR)
							updateCharacterStream(xStream, xStream->available() / sizeof(sal_Unicode));
						else
							updateBinaryStream(xStream, xStream->available());
					}
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::DateTime*)0))
						updateTimestamp(*(::com::sun::star::util::DateTime*)x.getValue());
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::Date*)0))
						updateDate(*(::com::sun::star::util::Date*)x.getValue());
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::Time*)0))
						updateTime(*(::com::sun::star::util::Time*)x.getValue());
					else
						throw SQLException();
					break;
				default:
					throw SQLException();
			}
		}
		catch ( ... )
		{
			throw SQLException();
		}
	}
}

//------------------------------------------------------------------------------
void ODataColumn::addPropertyChangeListener( const ::rtl::OUString& aPropertyName, const Reference< XPropertyChangeListener >& Listener ) throw(UnknownPropertyException, WrappedTargetException, RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OResultColumn::addPropertyChangeListener(aPropertyName, Listener);
	if (!OColumnBase::rBHelper.bInDispose && !OColumnBase::rBHelper.bDisposed && !hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void ODataColumn::removePropertyChangeListener( const ::rtl::OUString& aPropertyName, const Reference< XPropertyChangeListener >& aListener ) throw(UnknownPropertyException, WrappedTargetException, RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OResultColumn::removePropertyChangeListener(aPropertyName, aListener);
	if (!OColumnBase::rBHelper.bInDispose && !OColumnBase::rBHelper.bDisposed && hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void ODataColumn::addPropertiesChangeListener( const Sequence< ::rtl::OUString >& aPropertyNames, const Reference< XPropertiesChangeListener >& xListener ) throw(RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OResultColumn::addPropertiesChangeListener(aPropertyNames, xListener);
	if (!OColumnBase::rBHelper.bInDispose && !OColumnBase::rBHelper.bDisposed && !hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void ODataColumn::removePropertiesChangeListener( const Reference< XPropertiesChangeListener >& Listener ) throw(RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OResultColumn::removePropertiesChangeListener(Listener);
	if (!OColumnBase::rBHelper.bInDispose && !OColumnBase::rBHelper.bDisposed && hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void ODataColumn::checkForNotify()
{
	sal_Bool bOld = hasValueListeners();
	sal_Bool bNew;
	// do we need to broadcast value changes
	OInterfaceContainerHelper* pLC = aBoundLC.getContainer(PROPERTY_ID_VALUE);
	bNew = pLC && pLC->getLength();

	// broadcast to all listeners with "" property name?
	if (!bNew)
	{
		// haesslicher cast, danke bei egcs
		pLC = ((OBroadcastHelper&)OPropertySetHelper::rBHelper).aLC.getContainer( ::getCppuType((const Reference< XPropertyChangeListener >*)0) );
		bNew = pLC && pLC->getLength();
	}

	if (!bNew)
	{
		pLC = ((OBroadcastHelper&)OPropertySetHelper::rBHelper).aLC.getContainer( ::getCppuType((const Reference< XPropertiesChangeListener >*)0) );
		bNew = pLC && pLC->getLength();
	}

	if (bOld != bNew)   // Anlegen einer Copie zum Vergleichen
	{
		if (!bNew)
			m_xOldValue.unbind();
		else if (bNew && m_xValue.is())
			m_xOldValue = new ODbVariant(*m_xValue);
	}
}

//************************************************************
//  ODataColumns
//************************************************************
// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > ODataColumns::getTypes() throw (RuntimeException)
{
	// other interfaces are only for internal use (XRow, XRowUpdate)
	OTypeCollection aTypes(::getCppuType( (const Reference< XResultSetMetaData > *)0 ),
							OColumns::getTypes() );

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > ODataColumns::getImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}


// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any ODataColumns::queryInterface( const Type & rType ) throw (RuntimeException)
{
	// other interfaces are only for internal use (XRow, XRowUpdate)
	Any aIface = OColumns::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XResultSetMetaData * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void ODataColumns::acquire() throw(RuntimeException)
{
	OColumns::acquire();
}

//--------------------------------------------------------------------------
void ODataColumns::release() throw(RuntimeException)
{
	OColumns::release();
}

// XResultSetMetaData
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::getColumnCount(void) throw( SQLException, RuntimeException )
{
	return m_aColArray.size();
}

//--------------------------------------------------------------------------
sal_Bool ODataColumns::isAutoIncrement(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isAutoIncrement();
}

//--------------------------------------------------------------------------
sal_Bool ODataColumns::isCaseSensitive(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isCaseSensitive();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isSearchable(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isSearchable();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isCurrency(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isCurrency();
}
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::isNullable(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isNullable();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isSigned(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isSigned();
}
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::getColumnDisplaySize(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnDisplaySize();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getColumnLabel(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnLabel();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getColumnName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnName();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getSchemaName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getSchemaName();
}
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::getPrecision(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getPrecision();
}
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::getScale(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getScale();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getTableName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getTableName();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getCatalogName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getCatalogName();
}
//--------------------------------------------------------------------------
sal_Int32 ODataColumns::getColumnType(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnType();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getColumnTypeName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnTypeName();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isReadOnly(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isWritable();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isWritable(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isWritable();
}
//--------------------------------------------------------------------------
sal_Bool ODataColumns::isDefinitelyWritable(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->isDefinitelyWritable();
}
//--------------------------------------------------------------------------
rtl::OUString ODataColumns::getColumnServiceName(sal_Int32 column) throw( SQLException, RuntimeException )
{
	if (column < 1 || column > m_aColArray.size())
		throw SQLException();

	return static_cast<ODataColumn*>(m_aColArray[column - 1])->getColumnServiceName();
}

// XRow
//------------------------------------------------------------------------------
sal_Bool ODataColumns::wasNull(void) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (m_nLastColumn > 0 || m_nLastColumn <= m_aColArray.size())
		return static_cast<ODataColumn*>(m_aColArray[m_nLastColumn-1])->wasNull();
	else
		return sal_False;
}

//------------------------------------------------------------------------------
rtl::OUString ODataColumns::getString(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getString();
}

//------------------------------------------------------------------------------
sal_Bool ODataColumns::getBoolean(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getBoolean();
}

//------------------------------------------------------------------------------
sal_Int8 ODataColumns::getByte(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getByte();
}

//------------------------------------------------------------------------------
sal_Int16 ODataColumns::getShort(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getShort();
}
//------------------------------------------------------------------------------
sal_Int32 ODataColumns::getInt(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getInt();
}
//------------------------------------------------------------------------------
sal_Int64 ODataColumns::getLong(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getLong();
}
//------------------------------------------------------------------------------
float ODataColumns::getFloat(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getFloat();
}
//------------------------------------------------------------------------------
double ODataColumns::getDouble(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getDouble();
}
//------------------------------------------------------------------------------
Sequence< sal_Int8 > ODataColumns::getBytes(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getBytes();
}
//------------------------------------------------------------------------------
com::sun::star::util::Date ODataColumns::getDate(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getDate();
}
//------------------------------------------------------------------------------
com::sun::star::util::Time ODataColumns::getTime(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getTime();
}
//------------------------------------------------------------------------------
com::sun::star::util::DateTime ODataColumns::getTimestamp(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getTimestamp();
}
//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  ODataColumns::getBinaryStream(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getBinaryStream();
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  ODataColumns::getCharacterStream(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getCharacterStream();
}

//------------------------------------------------------------------------------
Any ODataColumns::getObject(sal_Int32 columnIndex, const Reference< ::com::sun::star::container::XNameAccess > & typeMap) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getObject(typeMap);
}

//------------------------------------------------------------------------------
Reference< XRef >  ODataColumns::getRef(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getRef();
}

//------------------------------------------------------------------------------
Reference< XBlob >  ODataColumns::getBlob(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getBlob();
}

//------------------------------------------------------------------------------
Reference< XClob >  ODataColumns::getClob(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getClob();
}

//------------------------------------------------------------------------------
Reference< XArray >  ODataColumns::getArray(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	m_nLastColumn = columnIndex;
	return static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->getArray();
}

// XRowUpdate
//------------------------------------------------------------------------------
void ODataColumns::updateNull(sal_Int32 columnIndex) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateNull();
}

//------------------------------------------------------------------------------
void ODataColumns::updateBoolean(sal_Int32 columnIndex, sal_Bool x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateBoolean(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateByte(sal_Int32 columnIndex, sal_Int8 x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateByte(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateShort(sal_Int32 columnIndex, sal_Int16 x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateShort(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateInt(sal_Int32 columnIndex, sal_Int32 x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateInt(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateLong(sal_Int32 columnIndex, sal_Int64 x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateLong(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateFloat(sal_Int32 columnIndex, float x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateFloat(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateDouble(sal_Int32 columnIndex, double x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateDouble(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateString(sal_Int32 columnIndex, const rtl::OUString& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateString(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateBytes(sal_Int32 columnIndex, const Sequence< sal_Int8 >& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateBytes(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateDate(sal_Int32 columnIndex, const ::com::sun::star::util::Date& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateDate(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateTime(sal_Int32 columnIndex, const ::com::sun::star::util::Time& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateTime(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateTimestamp(sal_Int32 columnIndex, const ::com::sun::star::util::DateTime& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateTimestamp(x);
}
//------------------------------------------------------------------------------
void ODataColumns::updateBinaryStream(sal_Int32 columnIndex, const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateBinaryStream(x, length);
}

//------------------------------------------------------------------------------
void ODataColumns::updateCharacterStream(sal_Int32 columnIndex, const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateCharacterStream(x, length);
}

//------------------------------------------------------------------------------
void ODataColumns::updateNumericObject(sal_Int32 columnIndex, const Any& x, sal_Int32 scale) throw( SQLException, RuntimeException )
{
	updateObject(columnIndex, x);
}

//------------------------------------------------------------------------------
void ODataColumns::updateObject(sal_Int32 columnIndex, const Any& x) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (columnIndex < 1 || columnIndex > m_aColArray.size())
		throw SQLException();

	static_cast<ODataColumn*>(m_aColArray[columnIndex - 1])->updateObject(x);
}

//------------------------------------------------------------------------------
void ODataColumns::setRow(const ODbRowRef& xRow, sal_Bool bBroadcast)
{
	if (!xRow.is())
		return;

	MutexGuard aGuard(m_rMutex);
	DBG_ASSERT(xRow->size() == m_aColArray.size() + 1, "ODataColumns::setRow: inconsistent arrays !");
	for (sal_uInt16 i = 0; i < m_aColArray.size(); i++)
		static_cast<ODataColumn*>(m_aColArray[i])->setValue((*xRow)[i+1], bBroadcast);
}

//------------------------------------------------------------------------------
void ODataColumns::setDefaults()
{
	MutexGuard aGuard(m_rMutex);
	for (sal_uInt16 i = 0; i < m_aColArray.size(); i++)
		static_cast<ODataColumn*>(m_aColArray[i])->setDefault();
}

//------------------------------------------------------------------------------
void ODataColumns::insertColumns(const SdbColumnsRef& xCols, sal_Bool bReadOnly, IValueListener* pListener)
{
	disposing();

	MutexGuard aGuard(m_rMutex);
	sal_uInt32 nCount = xCols->Count();
	for (sal_uInt32 i = 1; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i);
		append(new ODataColumn(*pCol, bReadOnly, pListener));
	}
}



