/*************************************************************************
 *
 *  $RCSfile: environment.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <environment.hxx>
#include <connection.hxx>
#include <api.hrc>

#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HDL_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen wg. INetURLObject
#include <tools/urlobj.hxx>
#endif
#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif
#ifndef _SBA_DATAACCESS_HXX
#include <dataaccess.hxx>
#endif
#ifndef _SBA_SBAOBJ_HXX
#include <sbaobj.hxx>
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::cppu;
using namespace ::osl;

DBG_NAME(OEnvironment);

Reference< XInterface >
	SAL_CALL OEnvironment_CreateInstance(const Reference< XMultiServiceFactory >  & xServiceManager)
		throw( Exception )
{
	Reference< XInterface >  xService(*new OEnvironment());
	return xService;
}

//--------------------------------------------------------------------------
OEnvironment::OEnvironment()
			 :OEnvironmentBase(m_aMutex)
			 ,OPropertySetHelper(OEnvironmentBase::rBHelper)
{
	DBG_CTOR(OEnvironment,NULL);
}

//--------------------------------------------------------------------------
OEnvironment::~OEnvironment()
{
	DBG_DTOR(OEnvironment,NULL);
}

// ::com::sun::star::lang::XUnoTunnel
//--------------------------------------------------------------------------
sal_Int64 SAL_CALL OEnvironment::getSomething(const Sequence<sal_Int8>& rId) throw( RuntimeException )
{
	//	return OEnvironment_TunnelBase::getSomething(_rIdentifier);
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > OEnvironment::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}
// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > OEnvironment::getTypes() throw (RuntimeException)
{
	// ComponentInterface is not available for the world, only internal use
	OTypeCollection aTypes(::getCppuType( (const Reference< XWeak > *)0 ),
						   ::getCppuType( (const Reference< XTypeProvider > *)0 ),
						   ::getCppuType( (const Reference< XDatabaseEnvironment > *)0 ),
						   ::getCppuType( (const Reference< XPropertySet > *)0 ),
						   ::getCppuType( (const Reference< XServiceInfo > *)0 ));

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > OEnvironment::getImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any OEnvironment::queryInterface( const Type & rType ) throw (RuntimeException)
{
	// ComponentInterface is not available for the world, only internal use
	Any aIface = OWeakObject::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XPropertySet * >( this ),
					static_cast< XTypeProvider * >( this ),
					static_cast< XDatabaseEnvironment * >( this ),
					static_cast< XDriverManager * >( this ),
					static_cast< XServiceInfo * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void OEnvironment::acquire() throw (RuntimeException)
{
	OEnvironmentBase::acquire();
}

//--------------------------------------------------------------------------
void OEnvironment::release() throw (RuntimeException)
{
	OEnvironmentBase::release();
}

// static ServiceInfo
//------------------------------------------------------------------------------
rtl::OUString OEnvironment::getImplementationName_Static(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.OEnvironment");
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > OEnvironment::getSupportedServiceNames_Static(  ) throw (RuntimeException)
{
	Sequence< ::rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDB_DATABASEENVIRONMENT;
	return aSNS;
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString OEnvironment::getImplementationName(  ) throw(RuntimeException)
{
	return getImplementationName_Static();
}

//------------------------------------------------------------------------------
sal_Bool OEnvironment::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > OEnvironment::getSupportedServiceNames(  ) throw (RuntimeException)
{
	return getSupportedServiceNames_Static();
}

// OEnvironmentBase
//------------------------------------------------------------------------------
void OEnvironment::disposing()
{
	OPropertySetHelper::disposing();

	MutexGuard aGuard(m_aMutex);
	for (OWeakRefArray::iterator i = m_aDatabases.begin(); m_aDatabases.end() != i; i++)
	{
		Reference< XComponent > xComp(i->get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aDatabases.clear();

	for (OWeakRefArray::iterator j = m_aConnections.begin(); m_aConnections.end() != j; j++)
	{
		Reference< XComponent > xComp(j->get(), UNO_QUERY);
		if (xComp.is())
			xComp->dispose();
	}
	m_aConnections.clear();

	m_xNumberFormatsSupplier = NULL;
	// free sdb
	m_xSdbEnvironment = NULL;
}

// OPropertySetHelper
//------------------------------------------------------------------------------
Reference< XPropertySetInfo >  OEnvironment::getPropertySetInfo() throw (RuntimeException)
{
	return createPropertySetInfo( getInfoHelper() ) ;
}

// utl::OPropertyArrayUsageHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper* OEnvironment::createArrayHelper( ) const
{
	BEGIN_PROPERTY_HELPER(1)
		DECL_PROP1(NUMBERFORMATSSUPPLIER, Reference < ::com::sun::star::util::XNumberFormatsSupplier>,	READONLY);
	END_PROPERTY_HELPER();
}

// cppu::OPropertySetHelper
//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper& OEnvironment::getInfoHelper()
{
	return *getArrayHelper();
}

//------------------------------------------------------------------------------
sal_Bool OEnvironment::convertFastPropertyValue(Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( IllegalArgumentException  )
{
	return sal_False;
}

//------------------------------------------------------------------------------
void OEnvironment::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw (Exception)
{
}

//------------------------------------------------------------------------------
void OEnvironment::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROPERTY_ID_NUMBERFORMATSSUPPLIER:
		{
			if (!m_xNumberFormatsSupplier.is())
				const_cast<OEnvironment*>(this)->m_xNumberFormatsSupplier = new SvNumberFormatsSupplierObj(m_xSdbEnvironment->GetStandardFormatter());
			rValue <<= m_xNumberFormatsSupplier;
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
}

// XDatabaseEnvironment
//------------------------------------------------------------------------------
Reference< XDatabaseAccess >  OEnvironment::getDatabaseAccess( const ::rtl::OUString& URL ) throw(SQLException, RuntimeException)
{
	MutexGuard aGuard(m_aMutex);
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();

	SbaDatabaseRef xSbaDB = (SbaDatabase*)m_xSdbEnvironment->GetDatabaseNoOpen(URL);
	if (xSbaDB.Is())
	{
		for (OWeakRefArray::reverse_iterator i = m_aDatabases.rbegin();
				i.base() != m_aDatabases.rend().base();)
		{
			Reference< XDatabaseAccess > xDB(i->get(), UNO_QUERY);
			if (xDB.is())
			{
				ODatabaseAccess* pImpl =
					reinterpret_cast<ODatabaseAccess*>(Reference<XUnoTunnel>(xDB,UNO_QUERY)->getSomething(ODatabaseAccess::getUnoTunnelImplementationId()));
				if (pImpl->m_xDatabase == xSbaDB)
					return xDB;
				else
					++i;
			}
			else
			{
				// clear empty weaks
				OWeakRefArray::reverse_iterator last = i;
				++i;
				m_aDatabases.erase(last.base());
			}
		}
	}
	else
	{
		// load the database
		xSbaDB = SBA_MOD()->LoadDatabase(URL);
		if (!xSbaDB.Is())
		{
			checkResult(m_xSdbEnvironment->Status(), static_cast<XWeak*>(this), sal_False);
			return Reference< XDatabaseAccess > ();
		}
	}

	Reference< XDatabaseAccess >  xDatabase = new ODatabaseAccess(*this, xSbaDB);
	m_aDatabases.push_back(WeakReferenceHelper(xDatabase));
	return xDatabase;
}

//------------------------------------------------------------------------------
Reference< XDatabaseAccess >  OEnvironment::createDatabaseAccess( const ::rtl::OUString& URL, const ::rtl::OUString& title ) throw(SQLException, RuntimeException)
{
	MutexGuard aGuard(m_aMutex);
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();

	if (!m_xSdbEnvironment->CreateDatabase(URL, title, String()))
		checkResult(m_xSdbEnvironment->Status(), static_cast<XWeak*>(this), sal_False);

	SbaDatabaseRef xSbaDB = SBA_MOD()->LoadDatabase(URL);
	if (!xSbaDB.Is())
		checkResult(m_xSdbEnvironment->Status(), static_cast<XWeak*>(this), sal_False);

	Reference< XDatabaseAccess >  xDatabase = new ODatabaseAccess(*this, xSbaDB);
	m_aDatabases.push_back(WeakReferenceHelper(xDatabase));
	return xDatabase;
}

// XDriverManager
//------------------------------------------------------------------------------
Reference< XConnection > OEnvironment::getConnection(const rtl::OUString& url) throw( SQLException, RuntimeException )
{
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();

	String aConnectStr = ODatabaseAccess::toConnectionStr(url, String());
	SdbConnection* pConn = m_xSdbEnvironment->OpenConnection(aConnectStr);
	if (!pConn)
		checkResult(m_xSdbEnvironment->Status(), static_cast<XWeak*>(this), sal_False);

	Reference< XConnection >  xCon = new OConnection(static_cast<XWeak*>(this), pConn);
	m_aConnections.push_back(WeakReferenceHelper(xCon));
	return xCon;
}

//------------------------------------------------------------------------------
Reference< XConnection >  OEnvironment::getConnectionWithInfo(const rtl::OUString& url, const Sequence< PropertyValue >& info) throw( SQLException, RuntimeException )
{
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();

	String aConnectStr = ODatabaseAccess::toConnectionStr(url, ODatabaseAccess::toConnectionStr(info));
	SdbConnection* pConn = m_xSdbEnvironment->OpenConnection(aConnectStr);
	if (!pConn)
		checkResult(m_xSdbEnvironment->Status(), static_cast<XWeak*>(this), sal_False);

	Reference< XConnection >  xCon = new OConnection(static_cast<XWeak*>(this), pConn);
	m_aConnections.push_back(WeakReferenceHelper(xCon));
	return xCon;
}

//------------------------------------------------------------------------------
void OEnvironment::setLoginTimeout(sal_Int32 seconds) throw( RuntimeException )
{
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();

	m_xSdbEnvironment->SetLoginTimeOut(seconds);
}

//------------------------------------------------------------------------------
sal_Int32 OEnvironment::getLoginTimeout(void) throw( RuntimeException )
{
	if (OEnvironmentBase::rBHelper.bDisposed || !m_xSdbEnvironment.Is())
		throw DisposedException();
	return m_xSdbEnvironment->GetLoginTimeOut();
}



