/*************************************************************************
 *
 *  $RCSfile: parameter.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <parameter.hxx>
#include <api.hrc>

#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_COLUMNVALUE_HPP_
#include <com/sun/star/sdbc/ColumnValue.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOBJECTOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XObjectOutputStream.hpp>
#endif
#ifndef _UNOTOOLS_DATETIME_HXX_
#include <unotools/datetime.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _SDB_TYPECONV_HXX
#include <sdb/typeconv.hxx>
#endif

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;

//************************************************************
//  ParameterInfo
//************************************************************

// XParameters
//------------------------------------------------------------------------------
void OParameters::setNull(sal_Int32 parameterIndex, sal_Int32 sqlType) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setNull(sqlType);
}

//------------------------------------------------------------------------------
void OParameters::setObjectNull(sal_Int32 parameterIndex, sal_Int32 sqlType, const rtl::OUString& typeName) throw( SQLException, RuntimeException )
{
	setNull(parameterIndex, sqlType);
}

//------------------------------------------------------------------------------
void OParameters::setBoolean(sal_Int32 parameterIndex, sal_Bool x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setBoolean(x);
}

//------------------------------------------------------------------------------
void OParameters::setByte(sal_Int32 parameterIndex, sal_Int8 x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setByte(x);
}

//------------------------------------------------------------------------------
void OParameters::setShort(sal_Int32 parameterIndex, sal_Int16 x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setShort(x);
}

//------------------------------------------------------------------------------
void OParameters::setInt(sal_Int32 parameterIndex, sal_Int32 x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setInt(x);
}

//------------------------------------------------------------------------------
void OParameters::setLong(sal_Int32 parameterIndex, sal_Int64 x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setLong(x);
}

//------------------------------------------------------------------------------
void OParameters::setFloat(sal_Int32 parameterIndex, float x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setFloat(x);
}

//------------------------------------------------------------------------------
void OParameters::setDouble(sal_Int32 parameterIndex, double x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setDouble(x);
}

//------------------------------------------------------------------------------
void OParameters::setString(sal_Int32 parameterIndex, const rtl::OUString& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setString(x);
}

//------------------------------------------------------------------------------
void OParameters::setBytes(sal_Int32 parameterIndex, const Sequence< sal_Int8 >& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].setBytes(x);
}

//------------------------------------------------------------------------------
void OParameters::setDate(sal_Int32 parameterIndex, const ::com::sun::star::util::Date& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	Date aConverted;
	utl::typeConvert(x, aConverted);
	m_aParameters[parameterIndex-1].setDate(aConverted);
}

//------------------------------------------------------------------------------
void OParameters::setTime(sal_Int32 parameterIndex, const ::com::sun::star::util::Time& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	Time aConverted;
	utl::typeConvert(x, aConverted);
	m_aParameters[parameterIndex-1].setTime(aConverted);
}

//------------------------------------------------------------------------------
void OParameters::setTimestamp(sal_Int32 parameterIndex, const ::com::sun::star::util::DateTime& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	DateTime aConverted;
	utl::typeConvert(x, aConverted);
	m_aParameters[parameterIndex-1].setTimestamp(aConverted);
}

//------------------------------------------------------------------------------
void OParameters::setBinaryStream(sal_Int32 parameterIndex, const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1 || !x.is())
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	try
	{
		Sequence <sal_Int8> aData;
		x->readBytes(aData, length);
		m_aParameters[parameterIndex-1].setBytes(aData);
		x->closeInput();
	}
	catch( ... )
	{
		throw SQLException();
	}
}

//------------------------------------------------------------------------------
void OParameters::setCharacterStream(sal_Int32 parameterIndex, const Reference< ::com::sun::star::io::XInputStream > & x, sal_Int32 length) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1 || !x.is())
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	try
	{
		Sequence <sal_Int8> aData;
		rtl::OUString aDataStr;
		// the data is given as character data and the length defines the character length
		sal_Int32 nSize = x->readBytes(aData, length * sizeof(sal_Unicode));
		if (nSize / sizeof(sal_Unicode))
			aDataStr = rtl::OUString((sal_Unicode*)aData.getConstArray(), nSize / sizeof(sal_Unicode));
		m_aParameters[parameterIndex-1].setString(aDataStr);
		m_aParameters[parameterIndex-1].nType = DataType::LONGVARCHAR;
		x->closeInput();
	}
	catch( ... )
	{
		throw SQLException();
	}
}

//------------------------------------------------------------------------------
void OParameters::setObjectWithInfo(sal_Int32 parameterIndex, const Any& x, sal_Int32 targetSqlType, sal_Int32 scale) throw( SQLException, RuntimeException )
{
	setObject(parameterIndex, x);
	m_aParameters[parameterIndex-1].nType = targetSqlType;
}

//------------------------------------------------------------------------------
void OParameters::setObject(sal_Int32 parameterIndex, const Any& x) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard( m_rBHelper.rMutex );
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	if (x.getValueTypeClass() == TypeClass_ANY)
		setObject(parameterIndex, Any(*(Any*)x.getValue()));
	else
	{
		try
		{
			switch (x.getValueTypeClass())
			{
				case TypeClass_VOID:
					setNull(parameterIndex, DataType::SQLNULL);
					break;
				case TypeClass_STRING:
					setString(parameterIndex, *(rtl::OUString*)x.getValue());
					break;
				case TypeClass_BOOLEAN:
					setBoolean(parameterIndex, *(sal_Bool *)x.getValue());
					break;
				case TypeClass_BYTE:
					setByte(parameterIndex, *(sal_Int8 *)x.getValue());
					break;
				case TypeClass_UNSIGNED_SHORT:
				case TypeClass_SHORT:
					setShort(parameterIndex, *(sal_Int16*)x.getValue());
					break;
				case TypeClass_CHAR:
					setShort(parameterIndex, *(sal_Int16*)(sal_Unicode *)x.getValue());//XXX
					break;
				case TypeClass_LONG:
				case TypeClass_UNSIGNED_LONG:
					setInt(parameterIndex, *(sal_Int32*)x.getValue());
					break;
				case TypeClass_FLOAT:
					setFloat(parameterIndex, *(float*)x.getValue());
					break;
				case TypeClass_DOUBLE:
					setDouble(parameterIndex, *(double*)x.getValue());
					break;
				case TypeClass_SEQUENCE:
					if (x.getValueType() == ::getCppuType((const Sequence< sal_Int8 > *)0))
						setBytes(parameterIndex, *(Sequence<sal_Int8>*)x.getValue());
					else
						throw IllegalArgumentException();
					break;
				case TypeClass_STRUCT:
				case TypeClass_INTERFACE:
					if (x.getValueType() == ::getCppuType(static_cast<Reference< ::com::sun::star::io::XInputStream>*>(NULL)))
					{
						Reference< ::com::sun::star::io::XInputStream >  xStream;
						x >>= xStream;
						setBinaryStream(parameterIndex, xStream, xStream->available());
					}
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::DateTime*)0))
						setTimestamp(parameterIndex, *(::com::sun::star::util::DateTime*)x.getValue());
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::Date*)0))
						setDate(parameterIndex, *(::com::sun::star::util::Date*)x.getValue());
					else if (x.getValueType() == ::getCppuType((const ::com::sun::star::util::Time*)0))
						setTime(parameterIndex, *(::com::sun::star::util::Time*)x.getValue());
					else
						throw SQLException();
					break;
				default:
					throw SQLException();
			}
		}
		catch( ... )
		{
			throw SQLException();
		}
	}
}

//------------------------------------------------------------------------------
void OParameters::setRef(sal_Int32 parameterIndex, const Reference< XRef > & x) throw( SQLException, RuntimeException )
{
	throw SQLException();
}

//------------------------------------------------------------------------------
void OParameters::setBlob(sal_Int32 parameterIndex, const Reference< XBlob > & x) throw( SQLException, RuntimeException )
{
	throw SQLException();
}

//------------------------------------------------------------------------------
void OParameters::setClob(sal_Int32 parameterIndex, const Reference< XClob > & x) throw( SQLException, RuntimeException )
{
	throw SQLException();
}

//------------------------------------------------------------------------------
void OParameters::setArray(sal_Int32 parameterIndex, const Reference< XArray > & x) throw( SQLException, RuntimeException )
{
	throw SQLException();
}

//------------------------------------------------------------------------------
void OParameters::clearParameters(void) throw( SQLException, RuntimeException )
{
	m_aParameters.clear();
}

// XOutParameters
//------------------------------------------------------------------------------
void OParameters::registerOutParameter(sal_Int32 parameterIndex, sal_Int32 sqlType, const rtl::OUString& typeName) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].registerOutParameter(sqlType);
}

//------------------------------------------------------------------------------
void OParameters::registerNumericOutParameter(sal_Int32 parameterIndex, sal_Int32 sqlType, sal_Int32 scale) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (m_rBHelper.bDisposed)
		throw DisposedException();
	else if (parameterIndex < 1)
		throw SQLException();
	else if (m_aParameters.size() < parameterIndex)
		m_aParameters.resize(parameterIndex);

	m_aParameters[parameterIndex-1].registerNumericOutParameter(sqlType, scale);
}

// XRow
//------------------------------------------------------------------------------
sal_Bool OParameters::wasNull(void) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (m_nLastColumn > 0 || m_nLastColumn <= m_aParameters.size())
		return m_aParameters[m_nLastColumn-1].xValue->isNull();
	else
		return sal_False;
}

//------------------------------------------------------------------------------
rtl::OUString OParameters::getString(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toString(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return rtl::OUString();
}

//------------------------------------------------------------------------------
sal_Bool OParameters::getBoolean(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBOOL(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return sal_False;
}

//------------------------------------------------------------------------------
sal_Int8 OParameters::getByte(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBYTE(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int16 OParameters::getShort(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT16(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int32 OParameters::getInt(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT32(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int64 OParameters::getLong(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT64(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0;
}
//------------------------------------------------------------------------------
float OParameters::getFloat(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toFloat(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0.0;
}
//------------------------------------------------------------------------------
double OParameters::getDouble(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toDouble(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return 0.0;
}
//------------------------------------------------------------------------------
Sequence< sal_Int8 > OParameters::getBytes(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;
	if (!xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBytes(*xValue);
		}
		catch ( ... )
		{
		}
	}
	return Sequence< sal_Int8 >();
}
//------------------------------------------------------------------------------
::com::sun::star::util::Date OParameters::getDate(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;

	com::sun::star::util::Date aDate;
	if (!xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toDate(*xValue), aDate);
		}
		catch ( ... )
		{
		}
	}
	return aDate;
}
//------------------------------------------------------------------------------
::com::sun::star::util::Time OParameters::getTime(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;

	com::sun::star::util::Time aTime;
	if (!xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toTime(*xValue), aTime);
		}
		catch ( ... )
		{
		}
	}
	return aTime;
}
//------------------------------------------------------------------------------
::com::sun::star::util::DateTime OParameters::getTimestamp(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	const ODbVariantRef& xValue = m_aParameters[m_nLastColumn-1].xValue;

	com::sun::star::util::DateTime aDateTime;
	if (!xValue->isNull())
	{
		try
		{
			utl::typeConvert(ODbTypeConversion::toDateTime(*xValue), aDateTime);
		}
		catch ( ... )
		{
		}
	}
	return aDateTime;
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  OParameters::getBinaryStream(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;

	ParameterInfo& rInfo = m_aParameters[m_nLastColumn-1];

	if (!rInfo.xValue->isNull())
	{
		switch (rInfo.nType)
		{
			case DataType::OTHER:
			case DataType::BINARY:
			case DataType::VARBINARY:
			case DataType::LONGVARBINARY:
			{
				if (rInfo.xValue->getValueType() == ::getCppuType((const Sequence< sal_Int8 > *)0))
				{
					Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
					if (xSink.is())
					{
						// TODO
						// SbaUnoInputStream* pUnoStream = new SbaUnoInputStream(rInfo.xValue->getBytes());
						// xSink->setInputStream(Reference< ::com::sun::star::io::XInputStream > (pUnoStream));
						return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
					}
				}
				else
				{
					Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
					if (xSink.is())
					{
						// TODO
						// SbaUnoInputStream* pUnoStream = new SbaUnoInputStream(Sequence<sal_Int8>());
						// xSink->setInputStream(Reference< ::com::sun::star::io::XInputStream > (pUnoStream));
						return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
					}
				}
				break;
			}
		}
	}
	return Reference< ::com::sun::star::io::XInputStream > ();
}

//------------------------------------------------------------------------------
Reference< ::com::sun::star::io::XInputStream >  OParameters::getCharacterStream(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;

	ParameterInfo& rInfo = m_aParameters[m_nLastColumn-1];
	if (!rInfo.xValue->isNull())
	{
		switch (rInfo.nType)
		{
			case DataType::CHAR:
			case DataType::VARCHAR:
			case DataType::LONGVARCHAR:
			{
				rtl::OUString aStr = getString(parameterIndex);
				// writes the string as character sequence
				// creating a pipe
				Reference< ::com::sun::star::io::XOutputStream >  xOutPipe(utl::getProcessServiceFactory()
									->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.Pipe")), UNO_QUERY);
				Reference< ::com::sun::star::io::XInputStream >  xInPipe(xOutPipe, UNO_QUERY);

				// connect pipe and sink
				Reference< ::com::sun::star::io::XActiveDataSink >  xSink(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
				xSink->setInputStream(xInPipe);

				// connect pipe and source
				Reference< ::com::sun::star::io::XActiveDataSource >  xSource(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.io.ObjectOutputStream")), UNO_QUERY);
				xSource->setOutputStream(xOutPipe);

				// write the string to source
				Reference< ::com::sun::star::io::XObjectOutputStream >  xOutStrm(xSource, UNO_QUERY);

				// get the stream length
				sal_Int32 nLen = aStr.len();
				Sequence<sal_Int8> aData((sal_Int8*)aStr.getStr(), (nLen + 1) * sizeof(sal_Unicode));
				xOutStrm->writeBytes(aData);
				xOutStrm->closeOutput();

				// return the input
				return Reference< ::com::sun::star::io::XInputStream > (xSink, UNO_QUERY);
			}
		}
	}
	return Reference< ::com::sun::star::io::XInputStream > ();
}

//------------------------------------------------------------------------------
Any OParameters::getObject(sal_Int32 parameterIndex, const Reference< ::com::sun::star::container::XNameAccess > & typeMap) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	return m_aParameters[m_nLastColumn-1].xValue->getAny();
}

//------------------------------------------------------------------------------
Reference< XRef >  OParameters::getRef(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XBlob >  OParameters::getBlob(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XClob >  OParameters::getClob(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	return NULL;
}

//------------------------------------------------------------------------------
Reference< XArray >  OParameters::getArray(sal_Int32 parameterIndex) throw( SQLException, RuntimeException )
{
	::osl::MutexGuard aGuard(m_rBHelper.rMutex);
	if (parameterIndex < 1 || parameterIndex > m_aParameters.size())
		throw SQLException();

	m_nLastColumn = parameterIndex;
	return NULL;
}



