/*************************************************************************
 *
 *  $RCSfile: preparedstatement.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <preparedstatement.hxx>
#ifndef _COM_SUN_STAR_SDBC_FETCHDIRECTION_HPP_
#include <com/sun/star/sdbc/FetchDirection.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_RESULTSETCONCURRENCY_HPP_
#include <com/sun/star/sdbc/ResultSetConcurrency.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_RESULTSETTYPE_HPP_
#include <com/sun/star/sdbc/ResultSetType.hpp>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#include <resultset.hxx>
#include <api.hrc>

using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::cppu;
using namespace ::osl;

DBG_NAME(OPreparedStatement);

//--------------------------------------------------------------------------
OPreparedStatement::OPreparedStatement(const Reference< XInterface > & xPar, const SdbCursorRef& xCur, ODatabaseAccessConnection* pCon)
				   :OStatementBase(xPar, xCur, pCon)
				   ,OParameters(OComponentHelper::rBHelper)
				   ,m_aColumns(*this, m_aMutex, xCur->GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
{
	DBG_CTOR(OPreparedStatement, NULL);
	m_aColumns.insertColumns(xCur->GetColumns(),sal_False);
}

//--------------------------------------------------------------------------
OPreparedStatement::~OPreparedStatement()
{
	DBG_DTOR(OPreparedStatement, NULL);
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > OPreparedStatement::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XServiceInfo > *)0 ),
						   ::getCppuType( (const Reference< XPreparedStatement > *)0 ),
						   ::getCppuType( (const Reference< XParameters > *)0 ),
						   ::getCppuType( (const Reference< XColumnsSupplier > *)0 ),
						   ::getCppuType( (const Reference< XUnoTunnel > *)0 ),
						   ::getCppuType( (const Reference< XResultSetMetaDataSupplier > *)0 ),
							OStatementBase::getTypes() );

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > OPreparedStatement::getUnoTunnelId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > OPreparedStatement::getImplementationId() throw (RuntimeException)
{
	return getUnoTunnelId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any OPreparedStatement::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OStatementBase::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XServiceInfo * >( this ),
					static_cast< XParameters * >( this ),
					static_cast< XColumnsSupplier * >( this ),
					static_cast< XResultSetMetaDataSupplier * >( this ),
					static_cast< XUnoTunnel * >( this ),
					static_cast< XPreparedStatement * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void OPreparedStatement::acquire() throw (RuntimeException)
{
	OStatementBase::acquire();
}

//--------------------------------------------------------------------------
void OPreparedStatement::release() throw (RuntimeException)
{
	OStatementBase::release();
}


// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString OPreparedStatement::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.OPreparedStatement");
}

//------------------------------------------------------------------------------
sal_Bool OPreparedStatement::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > OPreparedStatement::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< ::rtl::OUString > aSNS( 2 );
	aSNS.getArray()[0] = SERVICE_SDBC_PREPAREDSTATEMENT;
	aSNS.getArray()[1] = SERVICE_SDB_PREPAREDSTATMENT;
	return aSNS;
}

// com::sun::star::lang::XUnoTunnel
//------------------------------------------------------------------
sal_Int64 OPreparedStatement::getSomething( const Sequence< sal_Int8 > & rId ) throw (RuntimeException)
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

// OComponentHelper
//------------------------------------------------------------------------------
void OPreparedStatement::disposing()
{
	OStatementBase::disposing();

	MutexGuard aGuard(m_aMutex);
	OParameters::disposing();
	m_aColumns.disposing();
}

// XColumnsSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess > OPreparedStatement::getColumns(void) throw( RuntimeException )
{
	return &m_aColumns;
}

// XResultSetMetaDataSupplier
//------------------------------------------------------------------------------
Reference< XResultSetMetaData > OPreparedStatement::getMetaData(void) throw( SQLException, RuntimeException )
{
	return &m_aColumns;
}

// XPreparedStatement
//------------------------------------------------------------------------------
Reference< XResultSet >  OPreparedStatement::executeQuery() throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	disposeResultSet();

	sal_uInt16 nSdbOptions = SDB_API_COMPATIBLE;
	SdbCursorType eSdbType = SDB_SNAPSHOT;

	if (m_nResultSetConcurrency == ResultSetConcurrency::READ_ONLY)
		nSdbOptions |= SDB_READONLY;

	if (m_bUseEscapeProcessing)
		nSdbOptions |= SDB_INDIRECT;

	if (m_nResultSetType == ResultSetType::FORWARD_ONLY)
	{
		nSdbOptions |= SDB_FORWARDONLY;
		eSdbType = SDB_SNAPSHOT;
	}
	else if (m_nResultSetType == ResultSetType::SCROLL_INSENSITIVE)
	{
		eSdbType = SDB_SNAPSHOT;
		nSdbOptions |= SDB_SEEDELETED;
	}
	else
	{
		eSdbType = SDB_KEYSET;
		nSdbOptions |= SDB_SEEDELETED;
	}

	m_xCursor->SetMaxFieldLen(m_nMaxFieldSize);
	m_xCursor->SetMaxRows(m_nMaxRows);

	// copying the parameter values
	ODbRowRef xRow = m_xCursor->GetParameterRow();
	for (sal_Int32 i = 0; i < m_aParameters.size() && ((i + 1) < xRow->size()); i++)
	{
		(*xRow)[i+1]->setAny(m_aParameters[i].xValue->getAny());
	}

	m_xCursor->Open(eSdbType, nSdbOptions);
	checkResult(m_xCursor->Status(), *this, sal_False);

	if (!m_xCursor->GetColumns().is() || m_xCursor->GetColumns()->Count() < 2)
	{
		SdbStatus aStatus;
		aStatus.SetInvalidStatement();
		checkResult(aStatus, *this, sal_False);
	}

	Reference< XResultSet >  xResult;
	OResultSet* pSet;

	xResult = pSet = new OUpdateResultSet(*this, m_xCursor);

	adjustResultColumns(pSet->getImplColumns());
	m_aResultSet = xResult;
	return xResult;
}

//------------------------------------------------------------------------------
sal_Int32 OPreparedStatement::executeUpdate() throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	disposeResultSet();

	ODbRowRef xRow = m_xCursor->GetParameterRow();
	for (sal_Int32 i = 0; i < m_aParameters.size() && ((i + 1) < xRow->size()); i++)
	{
		(*xRow)[i+1]->setAny(m_aParameters[i].xValue->getAny());
	}
	m_xCursor->Open();
	checkResult(m_xCursor->Status(), *this, sal_False);
	return (sal_Int32) m_xCursor->Status().GetRecordsAffected();
}

//------------------------------------------------------------------------------
sal_Bool OPreparedStatement::execute() throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OComponentHelper::rBHelper.bDisposed)
		throw DisposedException();

	disposeResultSet();

	m_xCursor->Open();
	checkResult(m_xCursor->Status(), *this, sal_False);
	return sal_True;
}

//------------------------------------------------------------------------------
Reference< XConnection >  OPreparedStatement::getConnection(void) throw( SQLException, RuntimeException )
{
	return Reference< XConnection > (m_xParent, UNO_QUERY);
}



