/*************************************************************************
 *
 *  $RCSfile: querycomposer.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DATABASEMETADATA_HXX
#include "databasemetadata.hxx"
#endif
#ifndef _SBA_QUERYCOMPOSER_HXX
#include "querycomposer.hxx"
#endif
#ifndef _SBA_DATACOLUMN_HXX
#include "datacolumn.hxx"
#endif
#ifndef _SBA_API_HRC
#include "api.hrc"
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_
#include <com/sun/star/sdb/SQLContext.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_DATATYPE_HPP_
#include <com/sun/star/sdbc/DataType.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HDL_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _UNOTOOLS_ENUMHELPER_HXX_
#include <unotools/enumhelper.hxx>
#endif
#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif
#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SBA_QRYFILT_HXX
#include <qryfilt.hxx>
#endif
#ifndef _SBA_QRYORDER_HXX
#include <qryorder.hxx>
#endif
#ifndef _SDB_SDBENV_HXX //autogen
#include <sdb/sdbenv.hxx>
#endif
#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif
#ifndef _SDB_SDBTAB_HXX
#include <sdb/sdbtab.hxx>
#endif
#ifndef _SBA_SBADBIT_HXX
#include <sbadbit.hxx>
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif

static char __READONLY_DATA L_BRACKET = '(';
static char __READONLY_DATA R_BRACKET = ')';
static char __READONLY_DATA COMMA = ',';

using namespace ::com::sun::star::sdb;
using namespace ::com::sun::star::sdbc;
using namespace ::com::sun::star::sdbcx;
using namespace ::com::sun::star::data;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::osl;
using namespace ::cppu;

//--------------------------------------------------------------------------
OQueryTables::OQueryTables(OQueryComposer& rComposer, ::osl::Mutex& rMutex)
			 :m_rParent(rComposer)
			 ,m_rMutex(rMutex)
{
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
void OQueryTables::acquire() throw(RuntimeException)
{
	m_rParent.acquire();
}

//--------------------------------------------------------------------------
void OQueryTables::release() throw(RuntimeException)
{
	m_rParent.release();
}

//------------------------------------------------------------------------------
void OQueryTables::clear()
{
	m_aMap.clear();
}

//------------------------------------------------------------------------------
void OQueryTables::construct(SbaParseIterator* pIterator)
{
	// filling the table map
	Reference< XTablesSupplier >  xTablesSupplier(m_rParent.m_xParent, UNO_QUERY);
	if (xTablesSupplier.is())
	{
		Reference< ::com::sun::star::container::XNameAccess >  xNameAccess(xTablesSupplier->getTables(), UNO_QUERY);
		const SdbTableRangeMap& rMap = pIterator->GetSdbTableRangeMap();
		for (sal_uInt32 i =0, nCount = rMap.Count(); i < nCount; i++)
		{
			try
			{
				Reference< XPropertySet >  xTable;
				xNameAccess->getByName(UniString((*rMap.GetObject(i))->GetFullName())) >>= xTable;
				m_aMap[UniString(rMap.GetKey(rMap.GetObject(i)))] = xTable;
			}
			catch (...)
			{
				break;
			}
		}
	}
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString OQueryTables::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.OQueryTables");
}

//------------------------------------------------------------------------------
sal_Bool OQueryTables::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > OQueryTables::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDBCX_CONTAINER;
	return aSNS;
}


// ::com::sun::star::container::XElementAccess
//------------------------------------------------------------------------------
Type OQueryTables::getElementType(  ) throw(RuntimeException)
{
	return::getCppuType(static_cast<Reference<XPropertySet>*>(NULL));
}


//------------------------------------------------------------------------------
sal_Bool OQueryTables::hasElements(void) throw( RuntimeException )
{
	return getCount() != 0;
}

// ::com::sun::star::container::XEnumerationAccess
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XEnumeration >  OQueryTables::createEnumeration(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	return new utl::OEnumerationByName( static_cast< ::com::sun::star::container::XNameAccess*>(this));
}

// ::com::sun::star::container::XIndexAccess
//------------------------------------------------------------------------------
sal_Int32 OQueryTables::getCount(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	return m_aMap.size();
}

//------------------------------------------------------------------------------
Any OQueryTables::getByIndex(sal_Int32 Index) throw( IndexOutOfBoundsException, WrappedTargetException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	if (Index < 0 || Index >= m_aMap.size())
		throw IndexOutOfBoundsException();

	Reference< XPropertySet >  xSet;
	for (QueryTableMap::const_iterator i = m_aMap.begin(); m_aMap.end() != i; i++)
	{
		if (!Index)
		{
			xSet = (*i).second;
			break;
		}
		--Index;

	}
	return makeAny(xSet);
}

// ::com::sun::star::container::XNameAccess
//------------------------------------------------------------------------------
Any OQueryTables::getByName(const rtl::OUString& aName) throw( ::com::sun::star::container::NoSuchElementException,
														   WrappedTargetException, RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	QueryTableMap::const_iterator i = m_aMap.find(aName);
	if (i == m_aMap.end())
		throw ::com::sun::star::container::NoSuchElementException();

	return makeAny((*i).second);
}

//------------------------------------------------------------------------------
Sequence< rtl::OUString > OQueryTables::getElementNames(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	Sequence<rtl::OUString> aNameList(m_aMap.size());
	rtl::OUString* pStringArray = aNameList.getArray();
	for (QueryTableMap::const_iterator i = m_aMap.begin(); m_aMap.end() != i; i++)
	{
		(*pStringArray) = (*i).first;
		++pStringArray;
	}
	return aNameList;
}

//------------------------------------------------------------------------------
sal_Bool OQueryTables::hasByName(const rtl::OUString& aName) throw( RuntimeException )
{
	MutexGuard aGuard(m_rMutex);
	QueryTableMap::const_iterator i = m_aMap.find(aName);
	return i != m_aMap.end();
}

//************************************************************
//  OQueryColumn
//************************************************************
class OQueryColumn : public OResultColumn,
					 public ::utl::OPropertyArrayUsageHelper < OQueryColumn >
{
	friend class OQueryComposer;

protected:
	rtl::OUString	m_aRealName;
	sal_Bool		m_bCalculated : 1;

public:
	OQueryColumn(const SdbColumn& rCol, const SdbTableRef& xTable)
		:OResultColumn(rCol)
		,m_bCalculated(rCol.IsFunction())
	{
		// crack the table name into parts
		if (xTable.Is())
		{
			m_aTableName	= UniString(xTable->Name());
			m_aSchemaName	= UniString(xTable->OwnerName());
			m_aCatalogName	= UniString(xTable->QualifierName());
		}
		m_aRealName = rCol.GetRealName();
	}

// XServiceInfo
	virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw(RuntimeException)
	{
		return rtl::OUString::createFromAscii("com.sun.star.sdb.OQueryColumn");
	}

// OPropertySetHelper
// utl::OPropertyArrayUsageHelper
	virtual ::cppu::IPropertyArrayHelper* createArrayHelper( ) const
	{
		BEGIN_PROPERTY_HELPER(25)
			DECL_PROP1(CATALOGNAME,				::rtl::OUString,	READONLY);
			DECL_PROP1(DEFAULTVALUE,			::rtl::OUString,	READONLY);
			DECL_PROP1(DESCRIPTION,				::rtl::OUString,	READONLY);
			DECL_PROP1(DISPLAYSIZE,				sal_Int32,		READONLY);
			DECL_PROP1(NUMBERFORMAT,			sal_Int32,		READONLY);
			DECL_PROP1_BOOL(ISAUTOINCREMENT,			READONLY);
			DECL_PROP1_BOOL(ISCALCULATED,			READONLY);
			DECL_PROP1_BOOL(ISCASESENSITIVE,			READONLY);
			DECL_PROP1_BOOL(ISCURRENCY,				READONLY);
			DECL_PROP1_BOOL(ISDEFINITELYWRITABLE,	READONLY);
			DECL_PROP1(ISNULLABLE,				sal_Int32,		READONLY);
			DECL_PROP1_BOOL(ISREADONLY,				READONLY);
			DECL_PROP1_BOOL(ISROWVERSION,			READONLY);
			DECL_PROP1_BOOL(ISSEARCHABLE,			READONLY);
			DECL_PROP1_BOOL(ISSIGNED,				READONLY);
			DECL_PROP1_BOOL(ISWRITABLE,				READONLY);
			DECL_PROP1(LABEL,					::rtl::OUString,	READONLY);
			DECL_PROP1(NAME,					::rtl::OUString,	READONLY);			
			DECL_PROP1(PRECISION,				sal_Int32,		READONLY);
			DECL_PROP1(REALNAME,				::rtl::OUString,	READONLY);
			DECL_PROP1(SCALE,					sal_Int32,		READONLY);
			DECL_PROP1(SCHEMANAME,				::rtl::OUString,	READONLY);
			DECL_PROP1(SERVICENAME,				::rtl::OUString,	READONLY);
			DECL_PROP1(TABLENAME,				::rtl::OUString,	READONLY);
			DECL_PROP1(TYPE,					sal_Int32,		READONLY);
			DECL_PROP1(TYPENAME,				::rtl::OUString,	READONLY);
		END_PROPERTY_HELPER();
	}


// cppu::OPropertySetHelper
	virtual ::cppu::IPropertyArrayHelper& SAL_CALL getInfoHelper()
	{
		return *static_cast< ::utl::OPropertyArrayUsageHelper<OQueryColumn>*>(this)->getArrayHelper();
	}

	virtual void SAL_CALL getFastPropertyValue(
								Any& rValue,
								sal_Int32 nHandle
									 ) const
	{
		switch (nHandle)
		{
			case PROPERTY_ID_ISCALCULATED:
			{
				sal_Bool bVal = m_bCalculated;
				rValue.setValue(&bVal, getBooleanCppuType());
			}	break;				
			case PROPERTY_ID_REALNAME:
				rValue <<= m_aRealName;
				break;
			default:
				OResultColumn::getFastPropertyValue(rValue, nHandle);
		}
	}
};

//************************************************************
//  OQueryComposer
//************************************************************
DBG_NAME(OQueryComposer);

//--------------------------------------------------------------------------
OQueryComposer::OQueryComposer(const Reference< XInterface > & xParent,
							   const SdbConnectionRef& xConn,
							   const Reference< ::com::sun::star::util::XNumberFormatsSupplier > & xSupplier)
			   :OSubComponent(m_aMutex, xParent)
			   ,m_aTables(*this, m_aMutex)
			   ,m_aColumns(*this, m_aMutex, xConn->GetIdentifierCase() == SDB_IC_ALL)
			   ,m_aParameters(*this, m_aMutex, xConn->GetIdentifierCase() == SDB_IC_ALL)
			   ,m_xNumberFormatsSupplier(xSupplier)
			   ,m_xConnection(xConn)
			   ,m_pSqlParser(NULL)
			   ,m_pSqlRootNode(NULL)
{
	DBG_CTOR(OQueryComposer, NULL);

	SdbEnvironmentRef xEnv;
	m_pSqlParser = xEnv->GetSqlParser();
	m_pIterator  = new SbaParseIterator(m_pSqlRootNode, m_xConnection);

	// setting the supplier
	if (!m_xNumberFormatsSupplier.is())
	{
		// get the global
		m_xNumberFormatsSupplier = new SvNumberFormatsSupplierObj(xEnv->GetStandardFormatter());
	}
}

//--------------------------------------------------------------------------
OQueryComposer::~OQueryComposer()
{
	DBG_DTOR(OQueryComposer, NULL);
}

// com::sun::star::lang::XTypeProvider
//--------------------------------------------------------------------------
Sequence< Type > OQueryComposer::getTypes() throw (RuntimeException)
{
	OTypeCollection aTypes(::getCppuType( (const Reference< XDatabaseDialogs > *)0 ),
						   ::getCppuType( (const Reference< XSQLQueryComposer > *)0 ),
						   ::getCppuType( (const Reference< XColumnsSupplier > *)0 ),
						   ::getCppuType( (const Reference< XParametersSupplier > *)0 ),
						   ::getCppuType( (const Reference< XTablesSupplier > *)0 ),
						   ::getCppuType( (const Reference< XServiceInfo > *)0 ),
							OSubComponent::getTypes() );

	return aTypes.getTypes();
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > OQueryComposer::getImplementationId() throw (RuntimeException)
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// com::sun::star::uno::XInterface
//--------------------------------------------------------------------------
Any OQueryComposer::queryInterface( const Type & rType ) throw (RuntimeException)
{
	Any aIface = OSubComponent::queryInterface( rType );
	if (!aIface.hasValue())
		aIface = ::cppu::queryInterface(
					rType,
					static_cast< XDatabaseDialogs * >( this ),
					static_cast< XSQLQueryComposer * >( this ),
					static_cast< XColumnsSupplier * >( this ),
					static_cast< XParametersSupplier * >( this ),
					static_cast< XTablesSupplier * >( this ),
					static_cast< XServiceInfo * >( this ));
	return aIface;
}

//--------------------------------------------------------------------------
void OQueryComposer::acquire() throw (RuntimeException)
{
	OSubComponent::acquire();
}

//--------------------------------------------------------------------------
void OQueryComposer::release() throw (RuntimeException)
{
	OSubComponent::release();
}

// OComponentHelper
//------------------------------------------------------------------------------
void OQueryComposer::disposing()
{
	MutexGuard aGuard(m_aMutex);
	m_aTables.clear();
	m_aColumns.disposing();
	m_aParameters.disposing();

	DELETEZ(m_pIterator);
	DELETEZ(m_pSqlRootNode);

	m_xNumberFormatsSupplier = NULL;
	m_pSqlParser = NULL;
	m_xConnection = NULL;
}

// XServiceInfo
//------------------------------------------------------------------------------
rtl::OUString OQueryComposer::getImplementationName(  ) throw(RuntimeException)
{
	return rtl::OUString::createFromAscii("com.sun.star.sdb.OQueryComposer");
}

//------------------------------------------------------------------------------
sal_Bool OQueryComposer::supportsService( const ::rtl::OUString& ServiceName ) throw (RuntimeException)
{
	return ::hasString(getSupportedServiceNames(), ServiceName);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > OQueryComposer::getSupportedServiceNames(  ) throw (RuntimeException)
{
	Sequence< rtl::OUString > aSNS( 1 );
	aSNS[0] = SERVICE_SDB_SQLQUERYCOMPOSER;
	return aSNS;
}

// XTablesSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess > OQueryComposer::getTables() throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	return &m_aTables;
}

// XColumnsSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XNameAccess >  OQueryComposer::getColumns(void) throw( RuntimeException )
{
	return &m_aColumns;
}

// XParametersSupplier
//------------------------------------------------------------------------------
Reference< ::com::sun::star::container::XIndexAccess >  OQueryComposer::getParameters(void) throw( RuntimeException )
{
	return &m_aParameters;
}

// ::com::sun::star::data::XDatabaseDialogs
//------------------------------------------------------------------------------
void OQueryComposer::executeFilter(const Reference< ::com::sun::star::container::XNamed > & rField) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pIterator->GetSdbTableRangeMap().Count())
		return;

	SdbTableRef xTable = *m_pIterator->GetSdbTableRangeMap().GetObject(0);

	// OriginalFilter nicht mit darstellen
	String aOldFilter = m_aOrigFilter;
	if (aOldFilter.Len() != 0)
	{
		m_aOrigFilter.Erase();
		setFilter(UniString(m_aCurrentFilter));
	}

	String aFieldName;
	ODbVariantRef xVar;
	if (rField.is())
	{
		aFieldName = (const sal_Unicode*)rField->getName();
		Reference< XPropertySet >  xField(rField, UNO_QUERY);
		if (xField.is())
		{
			ODataColumn* pColumn = new ODataColumn(xField);
			pColumn->acquire();
			xVar = pColumn->m_xValue;
			pColumn->release();
		}
	}

	DlgFilterCrit aFilterDlg(Application::GetDefDialogParent(), m_pIterator, xTable->Columns(), xVar, aFieldName);
	if (aFilterDlg.Execute())
	{
		m_aOrigFilter = aOldFilter;
		setFilter(UniString(aFilterDlg.BuildWherePart()));
	}
	else
	{
		m_aOrigFilter = aOldFilter;
		setFilter(UniString(m_aCurrentFilter));
	}
}
//------------------------------------------------------------------------------
void OQueryComposer::executeSort(const Reference< ::com::sun::star::container::XNamed > & rField) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pIterator->GetSdbTableRangeMap().Count())
		return;

	SdbTableRef xTable = *m_pIterator->GetSdbTableRangeMap().GetObject(0);

	// OriginalSort nicht mit darstellen
	String aOldOrder = m_aOrigOrder;
	if (aOldOrder.Len() != 0)
	{
		m_aOrigOrder.Erase();
		setOrder(UniString(m_aCurrentOrder));
	}

	DlgOrderCrit aOrderDlg(Application::GetDefDialogParent(), *m_pIterator, xTable->Columns());
	if (aOrderDlg.Execute())
	{
		m_aOrigOrder = aOldOrder;
		setOrder(UniString(aOrderDlg.BuildOrderPart()));
	}
	else
	{
		m_aOrigOrder = aOldOrder;
		setOrder(UniString(m_aCurrentOrder));
	}
}

// XSQLQueryComposer
//------------------------------------------------------------------------------
rtl::OUString OQueryComposer::getQuery(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	return UniString(m_aOrigSql);
}

//------------------------------------------------------------------------------
void OQueryComposer::setQuery(const rtl::OUString& command) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	m_aOrigSql = (const sal_Unicode*)command;
	delete m_pSqlRootNode;

	// ParseTree aufbauen
	String aErrorMsg;
	m_pSqlRootNode = m_pSqlParser->ParseTree(aErrorMsg, m_aOrigSql);
	m_pIterator->SetParseTree(m_pSqlRootNode);

	if (!m_pSqlRootNode)
	{
		reset();
		throw SQLException();
	}
	else if (m_pIterator->StatementType() != SDB_STATEMENT_SELECT || SDB_ISRULE(m_pSqlRootNode,union_statement))
	{
		reset();
		throw SQLException();
	}

	m_aWorkSql = STR_SELECT;
	m_aWorkSql += m_pIterator->BuildColumnPart();
	m_aWorkSql += STR_FROM;
	m_aWorkSql += m_pIterator->BuildTablePart();

	m_aOrigFilter = m_pIterator->BuildPart(SbaParseIterator::WHERE, sal_False);
	m_aOrigOrder  = m_pIterator->BuildPart(SbaParseIterator::ORDER_BY, sal_False);			;

	m_aCurrentFilter = m_aCurrentOrder = String();

	m_aColumns.disposing();
	m_aParameters.disposing();
	m_aTables.clear();
	m_aTables.construct(m_pIterator);

	// insert the new selected columns
	const SdbColumnsRef xCols = m_pIterator->GetSelectColumns();
	sal_uInt32 nCount = xCols->Count();
	for (sal_uInt32 i = 1; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i);
		// now look for the according table of the column
		SdbTableRef xTable = m_xConnection->OpenTable(pCol->GetTableName());
		SdbTableRef xColTable;
		if (xTable.Is())
		{
			for (sal_uInt32 j = 0; xColTable == NULL && j < m_pIterator->GetSdbTableRangeMap().Count(); j++)
				if (&(*m_pIterator->GetSdbTableRangeMap().GetObject(j)) == &xTable)
					xColTable = &xTable;
		}
		m_aColumns.append(new OQueryColumn(*pCol, xColTable));
	}

	// look for any parameters
	setParameters(m_pSqlRootNode);
}

//------------------------------------------------------------------------------
rtl::OUString OQueryComposer::getComposedQuery(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (m_pSqlRootNode)
	{
		String aResult;
		m_pSqlRootNode->ParseNodeToStr(aResult,m_xConnection->GetMetaData());
		return UniString(aResult);
	}
	else
		return getQuery();
}

//------------------------------------------------------------------------------
rtl::OUString OQueryComposer::getFilter(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	return UniString(m_aCurrentFilter);
}

//------------------------------------------------------------------------------
Sequence< Sequence< PropertyValue > > OQueryComposer::getStructuredFilter(void) throw( RuntimeException )
{
	OQueryComposer* THIS = const_cast<OQueryComposer*>(this);
	MutexGuard aGuard(THIS->m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	Sequence< Sequence< PropertyValue > > aFilterSeq;
	if (m_aCurrentFilter.Len() != 0)
	{
		String aSql(m_aWorkSql);
		// build a temporary parse node
		SdbSqlParseNode* pTempNode = m_pSqlRootNode;
		THIS->m_pSqlRootNode = NULL;

		aSql += STR_WHERE;
		aSql += m_aCurrentFilter;
		THIS->resetIterator(aSql);

		if (m_pSqlRootNode)
		{
			// normalize the filter
			SdbSqlParseNode* pWhereNode = m_pSqlRootNode->GetChild(3)->GetChild(1);
			SdbSqlParseNode* pCondition = pWhereNode->GetChild(1);
			SdbSqlParseNode::NegateSearchCondition(pCondition);
			pCondition = pWhereNode->GetChild(1);
			SdbSqlParseNode::DisjunctiveNormalForm(pCondition);
			pCondition = pWhereNode->GetChild(1);
			SdbSqlParseNode::Absorptions(pCondition);
			pCondition = pWhereNode->GetChild(1);
			if (pCondition)
			{
				vector< vector < PropertyValue > > aFilters;
				Reference< ::com::sun::star::util::XNumberFormatter >  xFormatter(utl::getProcessServiceFactory()
								->createInstance(rtl::OUString::createFromAscii("com.sun.star.util.NumberFormatter")), UNO_QUERY);
				xFormatter->attachNumberFormatsSupplier(m_xNumberFormatsSupplier);

				if (setORCriteria(pCondition, aFilters, xFormatter))
				{
					aFilterSeq.realloc(aFilters.size());
					Sequence<PropertyValue>* pFilters = aFilterSeq.getArray();
					for (vector< vector < PropertyValue > >::const_iterator i = aFilters.begin();
						 i != aFilters.end();
						 i++)
					{
						const vector < PropertyValue >& rProperties = *i;
						pFilters->realloc(rProperties.size());
						PropertyValue* pFilter = pFilters->getArray();
						for (vector < PropertyValue >::const_iterator j = rProperties.begin();
							 j != rProperties.end();
							 j++)
						{
							*pFilter = *j;
							pFilter++;
						}
						pFilters++;
					}
				}
			}
			delete THIS->m_pSqlRootNode;
		}

		// restore
		THIS->m_pSqlRootNode = pTempNode;
		THIS->m_pIterator->SetParseTree(m_pSqlRootNode);
	}
	return aFilterSeq;
}

//------------------------------------------------------------------------------
rtl::OUString OQueryComposer::getOrder(void) throw( RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();
	return UniString(m_aCurrentOrder);
}

//------------------------------------------------------------------------------
void OQueryComposer::appendFilterByColumn(const Reference< XPropertySet > & column) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT || !column.is())
	{
		throw SQLException();
	}

	ODataColumn* pColumn = new ODataColumn(column);
	pColumn->acquire();

	if (!pColumn->isSearchable())
	{
		pColumn->release();
		return;
	}

	ODbVariantRef xVar = pColumn->m_xValue;
	String sName = pColumn->getColumnName();
	const SdbColumn* pCol = m_pIterator->GetCol(sName);
	if (!pCol)
	{
		pColumn->release();

		SQLException aError;
		aError.Context = static_cast<XWeak*>(this);
		aError.SQLState = ::rtl::OUString::createFromAscii("S1000");
		aError.ErrorCode = 0;

		String sMessage(SbaResId(SBA_PARSER_INVALID_FIELD));
		while (sMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aError.Message = UniString(sMessage);

		SQLContext aInfo;
		String aInfoMessage(SbaResId(SBA_PARSER_INVALID_FIELD_DETAILED));
		while (aInfoMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aInfo.Message = UniString(aInfoMessage);
		aInfo.Details = UniString(String(SbaResId(SBA_PARSER_INVALID_FIELD_CURRENTSTMT)));
		aInfo.Details += getComposedQuery();

		aError.NextException <<= aInfo;
		throw SQLException(aError);
	}

	SbaPredicateItemList aList;
	SbaPredicateItem* pItem = new SbaPredicateItem;
	// Init LogTyp und Feldname
//	pItem->aFieldName	= S(pColumn->getColumnName());
	pItem->aFieldName	= pCol->GetRealName();
		// use the real name : some databases (at least oterro, adabas) won't accept a statement
		// like "select <field> as alias where alias = <value>"
		// FS - 05.01.00 - 71368
	pItem->eLogType		= SBA_LOG_INVALID;

	// Init Typ
	if (xVar->isNull())
		pItem->eType = SDB_PRED_ISNULL;
	else
	{
		switch (pColumn->getColumnType())
		{
			case DataType::VARCHAR:
			case DataType::CHAR:
			case DataType::LONGVARCHAR:
				pItem->eType = SDB_PRED_LIKE;
				break;
			default:
				pItem->eType = SDB_PRED_EQUAL;
		}
	}

	sal_Int32 nFieldType = pColumn->getColumnType();
	pItem->eVarType = (SdbDatabaseType)nFieldType;
	switch (nFieldType)
	{
		case DataType::TIMESTAMP:
		case DataType::DATE:
		case DataType::TIME:
			// quote the field
			pItem->aValue	= SdbTools::SQLString( pItem->eVarType, *xVar, sal_True);
			break;
		default:
			pItem->aValue	= SdbTools::SQLString( pItem->eVarType, *xVar, sal_False );
	}

	// like nur bis max. 255 Zeichen
	if (pItem->eType == SDB_PRED_LIKE && pItem->aValue.Len() > 255)
	{
		pItem->aValue.Erase(254);
		pItem->aValue += '%';
	}

	aList.Insert(pItem, LIST_APPEND);

	// filter anhaengen
	// select ohne where und order by aufbauen
	String aSql(m_aWorkSql);
	String aAppendFilter(m_pIterator->BuildWherePart(aList));

	if ((m_aCurrentFilter.Len() != 0) && (aAppendFilter.Len() != 0))
	{
		String sTemp(L_BRACKET);
		sTemp += m_aCurrentFilter;
		sTemp += R_BRACKET;
		sTemp += STR_AND;
		m_aCurrentFilter = sTemp;
	}
	m_aCurrentFilter += aAppendFilter;

	// add the filter and the sort order
	aSql += getComposedFilter();
	aSql += getComposedSort();

	resetIterator(aSql);

	delete pItem;
	pColumn->release();
}

//------------------------------------------------------------------------------
void OQueryComposer::appendOrderByColumn(const Reference< XPropertySet > & column, sal_Bool ascending) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT || !column.is())
	{
		throw SQLException();
	}

	// ORDER BY festlegen
	SbaOrderItemList	aList;
	SbaOrderItem		*pItem = new SbaOrderItem;

	rtl::OUString aName;
	column->getPropertyValue(PROPERTY_NAME) >>= aName;
	String sName = aName;
	const SdbColumn* pCol = m_pIterator->GetCol(sName);
	if (!pCol)
	{
		delete pItem;

		SQLException aError;
		aError.Context = static_cast<XWeak*>(this);
		aError.SQLState = ::rtl::OUString::createFromAscii("S1000");
		aError.ErrorCode = 0;

		String sMessage(SbaResId(SBA_PARSER_INVALID_FIELD));
		while (sMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aError.Message = UniString(sMessage);

		SQLContext aInfo;
		String aInfoMessage(SbaResId(SBA_PARSER_INVALID_FIELD_DETAILED));
		while (aInfoMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aInfo.Message = UniString(aInfoMessage);
		aInfo.Details = UniString(String(SbaResId(SBA_PARSER_INVALID_FIELD_CURRENTSTMT)));
		aInfo.Details += getComposedQuery();

		aError.NextException <<= aInfo;
		throw SQLException(aError);
	}

	try
	{
		// some databases (at least oterro) won't accept a statement like "select <field> as alias order by alias",
		// so we may have to use the real name of the column
		// FS - 05.01.00 - 71368
		sal_Bool bUseRealName = sal_False;
		ODatabaseMetaData aMetaData(*this);
		if (m_xConnection.Is())
		{
			aMetaData.setDescriptor(m_xConnection->GetMetaData());
			bUseRealName = aMetaData.supportsExpressionsInOrderBy();
			// sal_True -> no matter if the real name is an expression or not, the connection can handle it
		}

		if (!bUseRealName)
		{	// the connection can't handle expressions within order clauses -> check if the column is an expression
			if (!pCol->GetColumnInfo().bFunction)
				// no : we may use the real name
				bUseRealName = sal_True;
		}

		if (bUseRealName)
			pItem->aFieldName = pCol->GetRealName();
		else
			pItem->aFieldName = sName;
			// if expressions within order by clauses aren't allowed we use the alias and the realname is an expression

		pItem->bDirection = !ascending;
		aList.Insert( pItem, LIST_APPEND );

		// filter anhaengen
		// select ohne where und order by aufbauen
		String aSql(m_aWorkSql);
		String aAppendOrder(m_pIterator->BuildOrderPart(aList));

		if ((m_aCurrentOrder.Len() != 0) && (aAppendOrder.Len() != 0))
			m_aCurrentOrder += COMMA;
		m_aCurrentOrder += aAppendOrder;

		// add the filter and the sort order
		aSql += getComposedFilter();
		aSql += getComposedSort();

		resetIterator(aSql);

		delete pItem;
	}
	catch (... )
	{
		throw SQLException();
	}
}

//------------------------------------------------------------------------------
void OQueryComposer::setFilter(const rtl::OUString& filter) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT)
	{
		throw SQLException();
	}

	String aSql(m_aWorkSql);

	m_aCurrentFilter = (const sal_Unicode*)filter;

	// add the filter and the sort order
	aSql += getComposedFilter();
	aSql += getComposedSort();

	resetIterator(aSql);
}
//------------------------------------------------------------------------------
void OQueryComposer::setOrder(const rtl::OUString& order) throw( SQLException, RuntimeException )
{
	MutexGuard aGuard(m_aMutex);
	if (OSubComponent::rBHelper.bDisposed)
		throw DisposedException();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT)
	{
		throw SQLException();
	}

	String aSql(m_aWorkSql);

	// set the new order
	m_aCurrentOrder = (const sal_Unicode*)order;

	// add the filter and the sort order
	aSql += getComposedFilter();
	aSql += m_pIterator->BuildPart(SbaParseIterator::HAVING, sal_True);
	aSql += m_pIterator->BuildPart(SbaParseIterator::GROUP_BY, sal_True);
	aSql += getComposedSort();

	resetIterator(aSql);
}

// Helper
//------------------------------------------------------------------------------
void OQueryComposer::reset()
{
	m_aOrigSql = m_aOrigFilter = m_aOrigOrder = m_aWorkSql = m_aCurrentFilter = m_aCurrentOrder = String();
	DELETEZ(m_pSqlRootNode);

	m_pIterator->SetParseTree(m_pSqlRootNode);
}

//------------------------------------------------------------------------------
void OQueryComposer::resetIterator(const String& aSql)
{
	String aErrorMsg;
	delete m_pSqlRootNode;
	m_pSqlRootNode = m_pSqlParser->ParseTree(aErrorMsg, aSql);
	m_pIterator->SetParseTree(m_pSqlRootNode);
}

// functions for analysing SQL
//--------------------------------------------------------------------------------------------------
String OQueryComposer::getColumnName(SdbSqlParseNode* pColumnRef) const
{
	String aTableRange, aColumnName;
	m_pIterator->GetColumnRange(pColumnRef, aColumnName, aTableRange );
	return aColumnName;
}

//------------------------------------------------------------------------------
sal_Bool OQueryComposer::setORCriteria(SdbSqlParseNode* pCondition,
									vector< vector < PropertyValue > >& rFilters, const Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter) const
{
	// Runde Klammern um den Ausdruck
	if (pCondition->Count() == 3 &&
		SDB_ISPUNCTUATION(pCondition->GetChild(0),"(") &&
		SDB_ISPUNCTUATION(pCondition->GetChild(2),")"))
	{
		return setORCriteria(pCondition->GetChild(1), rFilters, xFormatter);
	}
	// oder Verknuepfung
	// a searchcondition can only look like this: search_condition SDB_TOKEN_OR boolean_term
	else if (SDB_ISRULE(pCondition,search_condition))
	{
		sal_Bool bResult = sal_True;
		for (int i = 0; bResult && i < 3; i+=2)
		{
			// Ist das erste Element wieder eine OR-Verknuepfung?
			// Dann rekursiv absteigen ...
			//if (!i && SDB_ISRULE(pCondition->GetChild(i),search_condition))
			if (SDB_ISRULE(pCondition->GetChild(i),search_condition))
				bResult = setORCriteria(pCondition->GetChild(i), rFilters, xFormatter);
			else
			{
				rFilters.push_back(vector < PropertyValue >());
				bResult = setANDCriteria(pCondition->GetChild(i), rFilters[rFilters.size() - 1], xFormatter);
			}
		}
		return bResult;
	}
	else
	{
		rFilters.push_back(vector < PropertyValue >());
		return setANDCriteria(pCondition, rFilters[rFilters.size() - 1], xFormatter);
	}
}

//--------------------------------------------------------------------------------------------------
sal_Bool OQueryComposer::setANDCriteria(SdbSqlParseNode * pCondition,
								  vector < PropertyValue >& rFilter, const Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter) const
{
	// Runde Klammern
	if (SDB_ISRULE(pCondition,boolean_primary))
	{
		// this should not occur
		DBG_ERROR("Primary condition in And-Criteria");
		return sal_False;
	}
	// Das erste Element ist (wieder) eine AND-Verknuepfung
	else if ( SDB_ISRULE(pCondition,boolean_term) && pCondition->Count() == 3 )
	{
		return setANDCriteria(pCondition->GetChild(0), rFilter, xFormatter) &&
			   setANDCriteria(pCondition->GetChild(2), rFilter, xFormatter);
	}
	else if (SDB_ISRULE(pCondition, comparison_predicate))
	{
		return setComparsionPredicate(pCondition,rFilter,xFormatter);
	}
	else if (SDB_ISRULE(pCondition,like_predicate) ||
			 SDB_ISRULE(pCondition,test_for_null) ||
			 SDB_ISRULE(pCondition,in_predicate) ||
			 SDB_ISRULE(pCondition,all_or_any_predicate) ||
			 SDB_ISRULE(pCondition,between_predicate))
	{
		if (SDB_ISRULE(pCondition->GetChild(0), column_ref))
		{
			PropertyValue aItem;
			String aValue;
			String aColumnName;
			pCondition->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
			pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

			// don't display the column name
			aValue.Erase(0, aColumnName.Len());
			aValue.EraseLeadingChars();

			aItem.Name = UniString(getColumnName(pCondition->GetChild(0)));
			rtl::OUString aStrValue = UniString(aValue);
			aItem.Value <<= aStrValue;
			rFilter.push_back(aItem);
		}
		else
			return sal_False;
	}
	else if (SDB_ISRULE(pCondition,existence_test) ||
			 SDB_ISRULE(pCondition,unique_test))
	{
		// this couldn't be handled here, too complex
		// as we need a field name
		return sal_False;
	}
	else
		return sal_False;

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool OQueryComposer::setComparsionPredicate(SdbSqlParseNode * pCondition,
										    vector < PropertyValue >& rFilter, const Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter) const
{
	DBG_ASSERT(SDB_ISRULE(pCondition, comparison_predicate),"setComparsionPredicate: pCondition ist kein ComparsionPredicate");
	if (SDB_ISRULE(pCondition->GetChild(0), column_ref) ||
		SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref))
	{
		PropertyValue aItem;
		String aValue;
		sal_uInt16 nPos;
		if (SDB_ISRULE(pCondition->GetChild(0), column_ref))
		{
			nPos = 0;
			sal_Int16 i=1;

			// don't display the equal
			if (pCondition->GetChild(i)->GetNodeType() == SDB_SQL_EQUAL)
				i++;

			// go forward
			for (;i < pCondition->Count();i++)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		}
		else if (SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref))
		{
			nPos = pCondition->Count()-1;

			sal_Int16 i = pCondition->Count() - 2;

			switch (pCondition->GetChild(i)->GetNodeType())
			{
				case SDB_SQL_EQUAL:
					// don't display the equal
					i--;
					break;
				case SDB_SQL_LESS:
					// take the opposite as we change the order
					i--;
					aValue = '>';
					break;
				case SDB_SQL_LESSEQ:
					// take the opposite as we change the order
					i--;
					aValue.AssignAscii(">=");
					break;
				case SDB_SQL_GREAT:
					// take the opposite as we change the order
					i--;
					aValue = '<';
					break;
				case SDB_SQL_GREATEQ:
					// take the opposite as we change the order
					i--;
					aValue.AssignAscii("<=");
					break;
			}

			// go backward
			for (; i >= 0; i--)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		}
		else
			return sal_False;

		aItem.Name = UniString(getColumnName(pCondition->GetChild(nPos)));
		rtl::OUString aStrValue = UniString(aValue);
		aItem.Value <<= aStrValue;
		rFilter.push_back(aItem);
	}
	else if (SDB_ISRULE(pCondition->GetChild(0), set_fct_spec ) ||
			 SDB_ISRULE(pCondition->GetChild(0), general_set_fct))
	{
		PropertyValue aItem;
		String aValue;
		String aColumnName;
		pCondition->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		// don't display the column name
		aValue.Erase(0, aColumnName.Len());
		aValue.EraseLeadingChars();

		aItem.Name = UniString(getColumnName(pCondition->GetChild(0)));
		rtl::OUString aStrValue = UniString(aValue);
		aItem.Value <<= aStrValue;
		rFilter.push_back(aItem);
	}
	else // kann sich nur um einen Expr. Ausdruck handeln
	{
		PropertyValue aItem;
		String aName, aValue;

		SdbSqlParseNode *pLhs = pCondition->GetChild(0);
		SdbSqlParseNode *pRhs = pCondition->GetChild(2);

		// Feldnamen
		sal_uInt16 i;
		for (i=0;i< pLhs->Count();i++)
			 pCondition->GetChild(i)->ParseNodeToPredicateStr(aName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		// Kriterium
		aValue = pCondition->GetChild(1)->TokenValue();
		for(i=0;i< pRhs->Count();i++)
			pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		aItem.Name = UniString(aName);
		rtl::OUString aStrValue = UniString(aValue);
		aItem.Value <<= aStrValue;
		rFilter.push_back(aItem);
	}
	return sal_True;
}

//-----------------------------------------------------------------------------
SdbColumnRef OQueryComposer::findColumn(SdbSqlParseNode* pNode) const
{
	String aTableRange, aColumnName;
	m_pIterator->GetColumnRange(pNode, aColumnName, aTableRange );

	// do we have a table range, then look for the table otherwise look through all involved tables
	SdbColumnRef xCol;
	SdbTableRef xTable;
	if (aTableRange.Len() != 0)
		xTable = m_xConnection->OpenTable(aTableRange);
	if (xTable.Is())
		xCol = (SdbColumn*)xTable->OriginalColumns()->Column(aColumnName);
	else
	{
		for (sal_uInt32 i = 0; xCol == NULL && i < m_pIterator->GetSdbTableRangeMap().Count(); i++)
			xCol = (SdbColumn*)(*m_pIterator->GetSdbTableRangeMap().GetObject(i))->OriginalColumns()->Column(aColumnName);
	}

	return xCol;
}

//-----------------------------------------------------------------------------
void OQueryComposer::setParameters(SdbSqlParseNode* pNode)
{
	// searching for parameters
	if (SDB_ISRULE(pNode, parameter))
	{
		// get the name of the parameter
		String aParameterName(pNode->GetChild(0)->TokenValue());
		DBG_ASSERT(aParameterName == ':' || aParameterName == '?',"error in ParseTree");

		// do we have a named parameter?
		if (aParameterName == ':')
			aParameterName = pNode->GetChild(1)->TokenValue();

		// find the according column
		SdbSqlParseNode* pParent = pNode->Parent();
		SdbColumnRef xCol;
		while (pParent)
		{
			if (SDB_ISRULE(pParent,comparison_predicate))
			{
				// search for column_ref
				if (pParent->GetChild(0) == pNode)
					xCol = findColumn(pParent->GetChild(2));
				else
					xCol = findColumn(pParent->GetChild(0));
				break;
			}
			else if ((SDB_ISRULE(pParent,like_predicate) ||
					  SDB_ISRULE(pParent,in_predicate) ||
					  SDB_ISRULE(pParent,between_predicate)) &&
					  SDB_ISRULE(pParent->GetChild(0),column_ref))
			{
				// find the table of column
				xCol = findColumn(pParent->GetChild(0));
				break;
			}
			else
			{
				pNode = pParent;
				pParent = pNode->Parent();
			}
		}

		if ((aParameterName == '?') && xCol.is())
			aParameterName = xCol->GetName();

		// did we create a column?
		if (!xCol.is())
		{
			// so create a default column
			xCol = m_xConnection->CreateColumn(aParameterName, SDB_DBTYPE_VARCHAR, 255,0, SDB_FLAGS_PARAM_IN);
		}

		OColumn* pColumn = new OColumn(*xCol);
		pColumn->setNameImpl(UniString(aParameterName));
		m_aParameters.append(pColumn);
	}
	else
	   // otherwise look further in the tree
		for (sal_uInt32 i = 0; i < pNode->Count(); i++)
			setParameters(pNode->GetChild(i));
}

//-----------------------------------------------------------------------------
String OQueryComposer::getComposedFilter() const
{
	String aResult;
	// compose the query use brackets if necessary
	if ((m_aOrigFilter.Len() != 0) && (m_aCurrentFilter.Len() != 0))
		(((((((aResult = STR_WHERE) += L_BRACKET) += m_aOrigFilter) += R_BRACKET) += STR_AND) += L_BRACKET) += m_aCurrentFilter) += R_BRACKET;
	else if (m_aOrigFilter.Len() != 0)
		(aResult = STR_WHERE) += m_aOrigFilter;
	else if (m_aCurrentFilter.Len() != 0)
		(aResult = STR_WHERE) += m_aCurrentFilter;
	return aResult;
}

//-----------------------------------------------------------------------------
String OQueryComposer::getComposedSort() const
{
	String aResult;
	// set the order part
	if ((m_aOrigOrder.Len() != 0) && (m_aCurrentOrder.Len() != 0))
		(((aResult = STR_ORDER_BY) += m_aOrigOrder) += COMMA) += m_aCurrentOrder;
	else if (m_aOrigOrder.Len() != 0)
		(aResult = STR_ORDER_BY) += m_aOrigOrder;
	else if (m_aCurrentOrder.Len() != 0)
		(aResult = STR_ORDER_BY) += m_aCurrentOrder;
	return aResult;
}



