/*************************************************************************
 *
 *  $RCSfile: dbdatdef.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "sbaexpob.hxx"
#include "sbadb.hxx"
#include <sdb/sdbtools.hxx>

#include "sbaresid.hrc"
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _VOS_MUTEX_HXX_ //autogen wg. OMutex
#include <vos/mutex.hxx>
#endif

#ifndef _SBA_SBADBIT_HXX
#include "sbadbit.hxx"
#endif

#include "dbstat.hxx"
#include "dbdatdef.hxx"
#include "sbaitems.hrc"
#include "sbaitems.hxx"
#include "dlgfldmt.hxx"
#include "dlgerr.hxx"
#include "sbaresid.hrc"

#define CACHE_SIZE 100				// Cache Groesse des Datenbank-Cursors

#ifndef _SVX_QRYPARAM_HXX
#include <svx/qryparam.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif

#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXRNGITEM_HXX
#include <svtools/rngitem.hxx>
#endif

#ifndef _SFX_PROGRESS_HXX //autogen
#include <sfx2/progress.hxx>
#endif

#ifndef _SFXCANCEL_HXX //autogen
#include <svtools/cancel.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SDB_SDBCURS_HXX //autogen
#include <sdb/sdbcurs.hxx>
#endif

#ifndef _SVX_FONTITEM_HXX //autogen
#include <svx/fontitem.hxx>
#endif

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif

#ifndef _SVX_WGHTITEM_HXX //autogen
#include <svx/wghtitem.hxx>
#endif

#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif

#ifndef _SVX_POSTITEM_HXX //autogen
#include <svx/postitem.hxx>
#endif

#ifndef _SVX_SHDDITEM_HXX //autogen
#include <svx/shdditem.hxx>
#endif

#ifndef _SVX_ITEM_HXX //autogen
#include <svx/cntritem.hxx>
#endif

#ifndef _SVX_CRSDITEM_HXX //autogen
#include <svx/crsditem.hxx>
#endif

#ifndef _SVX_LANGITEM_HXX //autogen
#include <svx/langitem.hxx>
#endif

#ifndef _SVX_UDLNITEM_HXX //autogen
#include <svx/udlnitem.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#include "datconv.hxx"

SfxPoolItem* SbaDBDataDef::ppPoolDefaults[] =
{
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

USHORT SbaDBDataDef::nPoolDefaultsLen = 0;
//==============================================================================

static USHORT ColAttrMap[] =		// Attribute der Spalten
{
	SBA_DEF_RANGEFORMAT,SBA_DEF_FLTPRIMARY,
	SBA_DEF_FLTCOLWIDTH_DEFAULT, SBA_DEF_FLTCOLWIDTH_DEFAULT,
	SID_ATTR_NUMBERFORMAT_ONE_AREA, SID_ATTR_NUMBERFORMAT_ONE_AREA,
	SBA_DEF_FLTNAME, SBA_DEF_FLTSEARCH,
	0
};

static USHORT ObjAttrMap[] =	// Attribute dieses Objektes
{
	SBA_DEF_ROWHEIGHT, SBA_DEF_LANGUAGE,
	SBA_DEF_TABLEPROP,SBA_DEF_ROWHEIGHT_DEFAULT,
	0
};

static SfxItemInfo __READONLY_DATA aItemInfos[] =
{
	{0,0},											// SBA_BRW_ROWHEIGHT
	{0,0},											// SBA_BRW_RANGEFONT
	{SID_ATTR_CHAR_FONT,SFX_ITEM_POOLABLE},			// SBA_BRW_FONT
	{SID_ATTR_CHAR_FONTHEIGHT,SFX_ITEM_POOLABLE},	// SBA_BRW_FONTHEIGHT
	{SID_ATTR_CHAR_COLOR,SFX_ITEM_POOLABLE},		// SBA_BRW_FONTCOLOR
	{SID_ATTR_CHAR_WEIGHT,SFX_ITEM_POOLABLE},		// SBA_BRW_FONTWEIGHT
	{SID_ATTR_CHAR_POSTURE,SFX_ITEM_POOLABLE},		// SBA_BRW_POSTURE
	{SID_ATTR_CHAR_SHADOWED,SFX_ITEM_POOLABLE},		// SBA_BRW_SHADOWED
	{SID_ATTR_CHAR_CONTOUR,SFX_ITEM_POOLABLE},		// SBA_BRW_CONTOUR
	{SID_ATTR_CHAR_STRIKEOUT,SFX_ITEM_POOLABLE},	// SBA_BRW_CROSSEDOUT
	{SID_ATTR_CHAR_UNDERLINE,SFX_ITEM_POOLABLE},	// SBA_BRW_UNDERLINE
	{SID_ATTR_CHAR_LANGUAGE,SFX_ITEM_POOLABLE},		// SBA_BRW_LANGUAGE
	{0,0},											// SBA_BRW_RANGEFORMAT
	{SID_ATTR_NUMBERFORMAT_VALUE,SFX_ITEM_POOLABLE},// SBA_BRW_FMTVALUE
	{SID_ATTR_ALIGN_HOR_JUSTIFY,SFX_ITEM_POOLABLE},	// SBA_ATTR_ALIGN_HOR_JUSTIFY
	{0,0},											// SBA_BRW_FLTCOLWIDTH
	{0,0},											// SBA_BRW_FLTTYPE
	{0,0},											// SBA_BRW_FLTLENGTH
	{0,0},											// SBA_BRW_FLTREQUIRED
	{0,0},											// SBA_BRW_FLTPOS
	{0,0},											// SBA_BRW_FLTTABLE
	{0,0},											// SBA_BRW_FLTHIDE
	{0,0},											// SBA_DEF_FLTCOMMENT
	{0,0},											// SBA_DEF_FLTDEFAULT
	{0,0},											// SBA_DEF_FLTPRIMARY
	{0,0},											// SBA_DEF_TABLEPROP
	{0,0},											// SBA_DEF_SORT
	{0,0},											// SBA_DEF_FILTER
	{0,0},											// SBA_DEF_FILTERAPPLIED
	{0,0},											// SBA_DEF_ROWHEIGHT_DEFAULT
	{0,0},											// SBA_DEF_FLTCOLWIDTH_DEFAULT
	{0,0},											// SID_ATTR_NUMBERFORMAT_ONE_AREA
};



const String gc_strEmptyString;

//------------------------------------------------------------------------------

DBG_NAME( SbaDBDataDef );

IMPL_SDBKEYREFCONT_VIRT(SbaColumnMap,SbaColumn*);

#define IS_CASE_SENSITIVE(pDB) pDB->GetIdentifierCase() == SDB_IC_ALL
DBG_NAME(SbaColumn);
//------------------------------------------------------------------------------
SfxItemSet* SbaColumn::Clone(BOOL bItems, SfxItemPool *pToPool) const
{
	DBG_CHKTHIS(SbaColumn,NULL);
	SbaColumn* pColumn = NULL;
	if (pToPool && pToPool != GetPool())
	{
		pColumn = new SbaColumn( *pToPool, GetRanges() );
		if (bItems)
		{
			SfxWhichIter aIter(*pColumn);
			USHORT nWhich = aIter.FirstWhich();
			while ( nWhich )
			{
				const SfxPoolItem* pItem;
				if (SFX_ITEM_SET == GetItemState( nWhich, FALSE, &pItem ) )
					pColumn->Put( *pItem, pItem->Which() );
				nWhich = aIter.NextWhich();
			}
		}
	}
	else
	{
		pColumn = new SbaColumn(*GetPool(), GetRanges());
		if (bItems)
		{
			SfxWhichIter aIter(*pColumn);
			USHORT nWhich = aIter.FirstWhich();
			while (nWhich )
			{
				const SfxPoolItem* pItem;
				if (SFX_ITEM_SET == GetItemState( nWhich, FALSE, &pItem ) )
					pColumn->Put( *pItem, pItem->Which() );
				nWhich = aIter.NextWhich();
			}
		}
	}
	return pColumn;
}

//------------------------------------------------------------------------------
BOOL SbaColumn::CompareCoreAttrs(const SbaColumn& _rCol, const SbaDBDataDef& _rDef) const
{
	DBG_CHKTHIS(SbaColumn,NULL);
	if (!_rDef.aCoreWhichList.Count())
		return TRUE;

	SfxWhichIter aIter(*this);
	BOOL bRes = TRUE;
	for (USHORT nWh = aIter.FirstWhich();nWh && bRes;nWh = aIter.NextWhich())
	{
		USHORT nCount = _rDef.aCoreWhichList.Count();
		for (USHORT i = 0; i < nCount; i++)
		{
			if (_rDef.aCoreWhichList[i] == nWh)
			{
				SFX_ITEMSET_GET(*this, pItem, SfxPoolItem, nWh, TRUE);
				SFX_ITEMSET_GET(_rCol, pRefItem, SfxPoolItem, nWh, TRUE);
				bRes = *pItem == *pRefItem;
				break;
			}
		}
	}
	return bRes;
}
DBG_NAME(SbaColumnList);
//------------------------------------------------------------------------------
SbaColumnList& SbaColumnList::operator= (const SbaColumnList& _rCols)
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	DBG_ASSERT(this != &_rCols,"SbaColumnList: source and dest are the same");
	// optimierung
	// sind die Columns gleich, wird nur eine zuweisung gemacht

	// this optimizing is buggy and will be no more longer used
	/*
	if (Count() == _rCols.Count())
	{

		for (ULONG i = 0; i < _rCols.Count(); i++)
		{
			GetObject(i)->Set(*_rCols.GetObject(i));
			SbaColumn* pCol = _rCols.GetObject(i);
			SFX_ITEMSET_GET(*pCol, pStringItem, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
			ReplaceAt(i,pStringItem->GetValue(),GetObject(i));
		}
	}
	else
	{
	*/
		Clear();
		for (ULONG i = 0; i < _rCols.Count(); i++)
		{
			SbaColumn* pCol = _rCols.GetObject(i);
			SFX_ITEMSET_GET(*pCol, pStringItem, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
			InsertAt(pStringItem->GetValue(), (SbaColumn*)pCol->Clone(TRUE));
		}
	//}
	return *this;
}

//------------------------------------------------------------------------------
BOOL SbaColumnList::operator==(const SbaColumnList& _rCols) const
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	if(this == &_rCols)
		return TRUE;
	BOOL bRes = Count() == _rCols.Count();
	for (ULONG i = 0; i < _rCols.Count() && bRes; i++)
	{
		SbaColumn* pRefCol = _rCols.GetObject(i);
		SbaColumn* pCol	   = GetObject(i);

		bRes = *pCol == *pRefCol;
	}
	return bRes;
}

//------------------------------------------------------------------------------
BOOL SbaColumnList::CompareCoreAttrs(const SbaColumnList& _rCols, const SbaDBDataDef& _rDef) const
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	// Vergleicht alle Attribute die in der Datenbank (nicht Sdb-Datenbank)
	// gespeichert werden koennen
	BOOL bRes = Count() == _rCols.Count();
	for (ULONG i = 0; i < _rCols.Count() && bRes; i++)
	{
		SbaColumn* pRefCol = _rCols.GetObject(i);
		SbaColumn* pCol	   = GetObject(i);

		bRes = pCol->CompareCoreAttrs(*pRefCol, _rDef);
	}
	return bRes;
}

//------------------------------------------------------------------------------
SbaColumn* SbaColumnList::Lookup(const String& _rFieldName, const String& _rTableName) const
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	if( _rTableName.Len() )
	{
		// LINUX braucht dieses temporaere Objekt
		String aRet = _rTableName;
		aRet += String('.');
		aRet += _rFieldName;
		return SbaColumnMap::Lookup( aRet );
	}
	else
		return SbaColumnMap::Lookup(_rFieldName);
}

//------------------------------------------------------------------------------
void SbaColumnList::SetIdentifierCase(SdbIdentifierCase _eCase)
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	SetCaseSensitive(_eCase == SDB_IC_ALL);
	eIdentifierCase = _eCase;
}

//------------------------------------------------------------------------------
SvRefBase* SbaColumnList::Find(const String& _rKey) const
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	SbaColumn* pColumn = (SbaColumn*)SbaColumnMap::Find(_rKey);
	if (!pColumn)
	{
		// Ist der Name vieleicht mit TabellenName.Feldname angegeben
		xub_StrLen nIndex = _rKey.SearchBackward('.');
		if (nIndex != STRING_NOTFOUND)		// es handelt sich vieleicht um Tabbelle.Feldname
		{
			pColumn = (SbaColumn*)SbaColumnMap::Find(_rKey.Copy(nIndex + 1));
			if (pColumn)
			{
				// stimmen die Tabellennamen ueberein
				SFX_ITEMSET_GET(*pColumn, pTableName, SfxStringItem, SBA_DEF_FLTTABLE, TRUE);
				// wie muessen die Tabellennamen verglichen werden
				BOOL bMatch = FALSE;
				if (IsCaseSensitive() || (eIdentifierCase & SDB_IC_OBJECT) == SDB_IC_OBJECT)
					bMatch = !pTableName->GetValue().Equals(_rKey.Copy(0, nIndex));
				else
					bMatch = !SbaDBObj::EqualNamesInsensitive(pTableName->GetValue(), _rKey.Copy(0, nIndex));
				if (!bMatch)
					pColumn = NULL;
			}
		}
	}
	return pColumn;
}
//------------------------------------------------------------------------------
String SbaColumnList::ShortenFieldName( const String& rName, xub_StrLen nNewLength)
{
	DBG_CHKTHIS(SbaColumnList,NULL);
	//////////////////////////////////////////////////////////////////////
	// Wenn es schon einen gekuerzten Namen gibt, Namen durchnumerieren (bis 99)
	String aNewName( rName.Copy( 0, nNewLength ));
	String aBaseName( rName.Copy( 0, nNewLength-2 ));
	xub_StrLen i=1;
	while( Lookup(aNewName, String()) && (i<100) )
	{
		aNewName = aBaseName;
		aNewName += String::CreateFromInt32(i);
		i++;
	}

	return aNewName;
}
//------------------------------------------------------------------------------


TYPEINIT1(SbaDBDataDef, SbaDBDef);
//------------------------------------------------------------------------------
SbaDBDataDef::SbaDBDataDef(SbaDatabase* _pDB,
						   const String& _rName,
						   DBObject _eObj,
						   BOOL _bNew,
						   BOOL _bShow)
		  :SbaDBDef(_pDB, _rName, _eObj, _bNew, _bShow)
		  ,pObjAttrSet(NULL)
		  ,pPool(NULL)
		  ,bAttrsModified(FALSE)
		  ,nUsageCount(0)
{
	DBG_CTOR(SbaDBDataDef, NULL);
	xOriginalColumns = new SbaColumnList(_pDB->GetIdentifierCase());
	xColumns = new SbaColumnList(_pDB->GetIdentifierCase());
	CreatePool();
}

//------------------------------------------------------------------------------
SbaDBDataDef::~SbaDBDataDef()
{
	// wichtig!
	// Columns vor dem Pool freigeben
	xOriginalColumns = NULL;
	xColumns		 = NULL;

	DELETEZ(pObjAttrSet);
	delete pPool;
	DBG_DTOR(SbaDBDataDef, NULL);
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::FillVariant(const ODbVariantRef& xVar, const String& rString, SbaColumn* pColumn )
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	if (!xVar.is() || !rString.Len() ) // darf nicht pVar->PutNull() da DB2 decimal sonst Probleme #65060#
		return TRUE; // XXXX hack
	////////////////////////////////////////////////////////////////////////////////
	// Wandelt String in SdbVariable um unter Ausnutzung der Infos aus der SbaColumn

	SFX_ITEMSET_GET( *pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE );
	SFX_ITEMSET_GET( *pColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, TRUE );

	SvNumberFormatter* pFormatter = GetFormatter();
	ULONG nFormat = pFormat->GetValue();
	SbaFieldType eType = pType->GetType();

	//////////////////////////////////////////////////////////////////////
	// In welchen Typ soll konvertiert werden?
	switch( eType )
	{
	//////////////////////////////////////////////////////////////////////
	// Bool
	case dbBool:
		// FS - 66161 - 14.05.1999
		// defaults werden als sprachunabhaengiges 0/1 gespeichert, aeltere Versionen haben noch ein
		// sprachabhaengiges ja/nein
		if (EqualNamesInsensitive(rString, SbaResId(STR_VALUE_YES)))
			xVar->setBOOL(TRUE);
		else if (EqualNamesInsensitive(rString, SbaResId(STR_VALUE_NO)))
			xVar->setBOOL(FALSE);
		else if (rString.EqualsAscii("1"))
			xVar->setBOOL(TRUE);
		else if (rString.EqualsAscii("0"))
			xVar->setBOOL(FALSE);
		else
			xVar->setNull();
		break;

	//////////////////////////////////////////////////////////////////////
	// Memo
	case dbMemo:
		xVar->setString( UniString(rString) );
		break;

	//////////////////////////////////////////////////////////////////////
	// Text types
	case dbText:
	case dbChar:
		double nResult;
		if (pFormatter->IsTextFormat(nFormat))
			xVar->setString( UniString(rString) );
		else if (pFormatter->IsNumberFormat(rString, nFormat, nResult))
		{
			switch (pFormatter->GetType(nFormat))
			{
				case NUMBERFORMAT_DATETIME:
				case NUMBERFORMAT_TIME:
				case NUMBERFORMAT_DATE:
					xVar->setDouble( SdbTools::ToStandardDate(*pFormatter, nResult) );
					break;
				default:
					xVar->setDouble( nResult );
			}
		}
		else
			return FALSE;
		break;

	//////////////////////////////////////////////////////////////////////
	// Numeric types
	case dbCurrency:
	case dbCounter:
	case dbDecimal:
	case dbNumeric:
	case dbDateTime:
	case dbDate:
	case dbTime:
		if (pFormatter->IsTextFormat(nFormat))
			xVar->setString( UniString(rString) );
		else if( pFormatter->IsNumberFormat(rString, nFormat, nResult) )
		{
			if( eType == dbNumeric )
			{
				SbaNumericSize eSize = (SbaNumericSize)PTR_CAST(SfxUInt32Item,&pColumn->Get(SBA_DEF_FLTLENGTH))->GetValue();
				switch( eSize )
				{
					case dbLong:
						xVar->setINT32( (INT32)nResult );
						break;

					case dbInteger:
						xVar->setINT16( (INT16) nResult );
						break;

					case dbByte:
						xVar->setBYTE( (BYTE) nResult );
						break;
					case dbSingle:
						xVar->setFloat((float)nResult);
						break;
					default:
						switch (pFormatter->GetType(nFormat))
						{
							case NUMBERFORMAT_DATETIME:
							case NUMBERFORMAT_TIME:
							case NUMBERFORMAT_DATE:
								xVar->setDouble( SdbTools::ToStandardDate(*pFormatter, nResult) );
								break;
							default:
								xVar->setDouble( nResult );
						}
				}
			}
			else
			{
				switch (eType)
				{
					case dbDateTime:
					case dbDate:
					case dbTime:
						xVar->setDouble( SdbTools::ToStandardDate(*pFormatter, nResult) );
						break;
					default:
						xVar->setDouble( nResult );
				}
			}
		}
	}

	return TRUE;
}
//------------------------------------------------------------------------------
void SbaDBDataDef::SetDefault( const SdbColumnsRef& xColumnsRef )
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	//////////////////////////////////////////////////////////////////////
	// Aktuellen Datensatz mit Defaultdaten aus Definition fuellen
	ULONG nColCount(xColumns->Count());
	for( ULONG i=0; i<nColCount; i++ )
	{
		SbaColumn* pColumn = xColumns->GetObject(i);
		SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE );
		SFX_ITEMSET_GET( *pColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, TRUE );

		SdbColumn *pCol = (SdbColumn*)xColumnsRef->Column( pName->GetValue() );
		if(pCol)
			pCol->SetDefaultValue(pDefault->GetValue());
	}
}
//------------------------------------------------------------------------------
void SbaDBDataDef::SetDefault(const ODbRowRef& xRow)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	//////////////////////////////////////////////////////////////////////
	// Aktuellen Datensatz mit Defaultdaten aus Definition fuellen
	ULONG nColCount(xColumns->Count());
	//String aFieldName;
	//String aDefault;

	const SdbColumnsRef xResultColumns(xRow->getColumns());
	for( ULONG i=0; i<nColCount; i++ )
	{
		SbaColumn* pColumn = xColumns->GetObject(i);
		const SdbColumn* pSdbColumn = xResultColumns->Column(i+1);
		SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE );
		SFX_ITEMSET_GET( *pColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, TRUE );
		SFX_ITEMSET_GET( *pColumn, pAutoInc, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, TRUE );

		SFX_ITEMSET_GET(*pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
		SFX_ITEMSET_GET(*pColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, TRUE);

		if (pSdbColumn && pSdbColumn->IsUpdateAllowed())
		{
			ODbVariantRef xVar = (*xRow)[pSdbColumn->GetId()];
			if (!pAutoInc || !pAutoInc->GetValue())
				FillVariant( xVar, pDefault->GetValue(), pColumn );
				// Auto-Werte werden nicht gefuellt, die haben sowieso kein default (59811)
			if (pType->GetType() == dbBool && pRequired->GetValue() && xVar->isNull())
			{	// das erste FillVariable hat als Default nicht auf 'ja' oder 'nein' erkannt
				// -> nein erzwingen, da das Feld ja required ist
				FillVariant( xVar, String::CreateFromAscii("0"), pColumn );
			}
		}
	}
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::IsModified() const
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	return bAttrsModified || *xOriginalColumns != *xColumns;
}



//------------------------------------------------------------------------------
String SbaDBDataDef::TypeString(SbaFieldType eFieldType)
{
	return String(SbaResId(STR_DBFIELDTYPES)).GetToken((int)eFieldType );
}

//------------------------------------------------------------------------------
String SbaDBDataDef::SizeString(SbaNumericSize eLengthType)
{
	String sReturn;
	switch (eLengthType)
	{
		case dbByte:
			sReturn.AssignAscii("Byte");
			break;
		case dbInteger:
			sReturn.AssignAscii("SmallInt");
			break;
		case dbLong:
			sReturn.AssignAscii("Integer");
			break;
		case dbSingle:
			sReturn.AssignAscii("Single");
			break;
		case dbDouble:
			sReturn.AssignAscii("Double");
			break;
		default:
			DBG_ERROR("Undefined");
	}
	return sReturn;
}



//------------------------------------------------------------------------------
UINT32 SbaDBDataDef::GetFieldLength(const SdbColumn& rCol)
{
	switch (rCol.GetType())
	{
		case SDB_DBTYPE_TINYINT:
			return (UINT32) dbByte;
		case SDB_DBTYPE_SMALLINT:
			return (UINT32) dbInteger;
		case SDB_DBTYPE_INTEGER:
			return (UINT32) dbLong;
		case SDB_DBTYPE_REAL:
			return (UINT32) dbSingle;
		case SDB_DBTYPE_DOUBLE:
			return (UINT32) dbDouble;
		default:
			return rCol.GetLength();
	}
}
//------------------------------------------------------------------------------
BOOL SbaDBDataDef::SetLock(BOOL _bLock)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	if (!IsLocked() && _bLock && IsUsed())
		return FALSE;
	else
		return SbaDBDef::SetLock(_bLock);
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::IsDataUpdateAllowed() const
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	// besteht eine Moeglichkeit, ein Object zu updaten
	SbaDatabase* pDatabase = GetDatabase();
	return pDatabase && !IsLocked() && pDatabase->IsCapable(SDB_CAP_UPDATABLE);
}

//------------------------------------------------------------------------------
void SbaDBDataDef::FillColumns(const SdbColumns& rCols)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	xOriginalColumns->Clear();
	xColumns->Clear();

	for (USHORT i = 1; i < rCols.Count(); i++)	// Spalten durchhuenern
	{
		const SdbColumn* pCol = rCols.Column(i);
		xOriginalColumns->InsertAt(pCol->GetName(), CreateColumn(*pCol));
		xColumns->InsertAt(pCol->GetName(), CreateColumn(*pCol));
	}
}

//------------------------------------------------------------------------------
void SbaDBDataDef::CreatePool()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);

	static BOOL bFirst = TRUE;

	if (bFirst)
	{
		USHORT i=0;
		bFirst = FALSE;

		// Font Defaults bestimmen
		Font	aFont = System::GetStandardFont(STDFONT_APP);
		aFont.SetSize(Size(aFont.GetSize().Width(), 10));
		UINT32	nFontHeight =
				(UINT32)Application::GetDefaultDevice()->PixelToLogic(aFont.GetSize(), MAP_TWIP).Height();

		// Bei Erweiterungen die null oben nicht vergessen
		ppPoolDefaults[i++] = new SbaColRowSizeItem(SBA_DEF_ROWHEIGHT, 0); // Wert wird geschaetzt
		ppPoolDefaults[i++] = new SfxRangeItem( SBA_DEF_RANGEFONT, SBA_DEF_FONTHEIGHT, SBA_DEF_LANGUAGE );
		ppPoolDefaults[i++] = new SvxFontItem(aFont.GetFamily(), aFont.GetName(), String(), PITCH_DONTKNOW, RTL_TEXTENCODING_DONTKNOW, SBA_DEF_FONT);
		ppPoolDefaults[i++] = new SvxFontHeightItem(nFontHeight, 100, SBA_DEF_FONTHEIGHT );
		ppPoolDefaults[i++] = new SvxColorItem(aFont.GetColor(), SBA_DEF_FONTCOLOR );
		ppPoolDefaults[i++] = new SvxWeightItem(WEIGHT_LIGHT, SBA_DEF_FONTWEIGHT);
		ppPoolDefaults[i++] = new SvxPostureItem( ITALIC_NONE, SBA_DEF_POSTURE );
		ppPoolDefaults[i++] = new SvxShadowedItem( FALSE, SBA_DEF_SHADOWED );
		ppPoolDefaults[i++] = new SvxContourItem( FALSE, SBA_DEF_CONTOUR );
		ppPoolDefaults[i++] = new SvxCrossedOutItem( STRIKEOUT_NONE, SBA_DEF_CROSSEDOUT );
		ppPoolDefaults[i++] = new SvxUnderlineItem( UNDERLINE_NONE, SBA_DEF_UNDERLINE );
		ppPoolDefaults[i++] = new SvxLanguageItem( LANGUAGE_GERMAN, SBA_DEF_LANGUAGE );
		ppPoolDefaults[i++] = new SfxRangeItem(	 SBA_DEF_RANGEFORMAT, SBA_DEF_FMTVALUE, SBA_DEF_FMTVALUE);
		ppPoolDefaults[i++] = new SfxUInt32Item( SBA_DEF_FMTVALUE );
		ppPoolDefaults[i++] = new SvxHorJustifyItem( SVX_HOR_JUSTIFY_STANDARD, SBA_ATTR_ALIGN_HOR_JUSTIFY );
		ppPoolDefaults[i++] = new SbaColRowSizeItem(SBA_DEF_FLTCOLWIDTH, 0);
		ppPoolDefaults[i++] = new SbaDataFieldTypeItem(SBA_DEF_FLTTYPE, dbNone);
		ppPoolDefaults[i++] = new SfxUInt32Item(SBA_DEF_FLTLENGTH, (UINT32)dbSizeNone);
		ppPoolDefaults[i++] = new SfxBoolItem(SBA_DEF_FLTREQUIRED, FALSE);
		ppPoolDefaults[i++] = new SfxUInt16Item(SBA_DEF_FLTPOS, 0);
		ppPoolDefaults[i++] = new SfxStringItem(SBA_DEF_FLTTABLE, String() );
		ppPoolDefaults[i++] = new SfxBoolItem(SBA_DEF_FLTHIDE, FALSE);
		ppPoolDefaults[i++] = new SfxStringItem(SBA_DEF_FLTCOMMENT, String() );
		ppPoolDefaults[i++] = new SfxStringItem(SBA_DEF_FLTDEFAULT, String() );
		ppPoolDefaults[i++] = new SfxBoolItem(SBA_DEF_FLTPRIMARY, FALSE);
		ppPoolDefaults[i++] = new SfxStringItem( SBA_DEF_TABLEPROP, String() );
		ppPoolDefaults[i++] = new SfxStringItem( SBA_DEF_SORT, String() );
		ppPoolDefaults[i++] = new SfxStringItem( SBA_DEF_FILTER, String() );
		ppPoolDefaults[i++] = new SfxBoolItem( SBA_DEF_FILTERAPPLIED, TRUE );
		ppPoolDefaults[i++] = new SfxBoolItem( SBA_DEF_ROWHEIGHT_DEFAULT, TRUE );
		ppPoolDefaults[i++] = new SfxBoolItem(SBA_DEF_FLTCOLWIDTH_DEFAULT, TRUE);
		ppPoolDefaults[i++] = new SfxBoolItem(SID_ATTR_NUMBERFORMAT_ONE_AREA, TRUE);

		nPoolDefaultsLen = i;
	}

	pPool = new SfxItemPool(String::CreateFromAscii("Table"),
					SBA_DEF_ROWHEIGHT,
					SBA_DEF_FLTCOLWIDTH_DEFAULT,
					aItemInfos,
					ppPoolDefaults,
					FALSE);		// transient ref counts

	DBG_ASSERT( pPool, "SbaDBDataDef::CreatePool" );
	pPool->SetDefaultMetric( SFX_MAPUNIT_TWIP );
	pPool->FreezeIdRanges();

	pObjAttrSet = new SfxItemSet( *pPool, ObjAttrMap );
}

//------------------------------------------------------------------------------
SbaColumn* SbaDBDataDef::CreateColumn(const String& rName,
									  SbaFieldType eType,
									  UINT32 nLength,
									  UINT16 nScale,
									  BOOL bRequired,
									  UINT32 nKey,
									  UINT16 nPos,
									  const String& rDefault) const
{
	DBG_CHKTHIS( SbaDBDataDef, NULL);
	SbaDatabase* pDatabase = GetDatabase();
	if (!pDatabase)
		return NULL;

	SbaColumn* pColumn = new SbaColumn(*pPool, ColAttrMap);
	SvxHorJustifyItem aHorzItem(SVX_HOR_JUSTIFY_RIGHT, SBA_ATTR_ALIGN_HOR_JUSTIFY);
	pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, rName,IS_CASE_SENSITIVE(pDatabase)));
	SbaFieldType eNewType = eType;
	UINT32 nLen = nLength;
	if(eType == dbCounter)
	{
		eNewType = dbNumeric;
		nLen = dbLong;
	}
	pColumn->Put(SbaDataFieldTypeItem(SBA_DEF_FLTTYPE, eNewType));
	pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLen));
	pColumn->Put(SfxBoolItem(SBA_DEF_FLTREQUIRED, bRequired));
	pColumn->Put(SfxUInt16Item(SBA_DEF_FLTPOS, nPos));
	pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, FALSE));
	pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE, nScale));
	pColumn->Put(SfxBoolItem(SBA_DEF_FLTUPDATABLE, TRUE));
	pColumn->Put(SfxStringItem(SBA_DEF_FLTDEFAULT, rDefault));
	pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, eNewType != eType));


	SvNumberFormatter* pSvNumberFormatter = GetFormatter();
	switch (eType)
	{
		case dbText:
		case dbChar:
		case dbMemo:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_TEXT, Application::GetAppInternational().GetLanguage());
			break;
		case dbBool:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_LOGICAL, Application::GetAppInternational().GetLanguage());
			break;
		case dbCurrency:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_CURRENCY, Application::GetAppInternational().GetLanguage());
			pColumn->Put(aHorzItem);
			break;
		case dbDateTime:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_DATETIME, Application::GetAppInternational().GetLanguage());
			pColumn->Put(aHorzItem);
			break;
		case dbDate:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_DATE, Application::GetAppInternational().GetLanguage());
			pColumn->Put(aHorzItem);
			break;
		case dbTime:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_TIME, Application::GetAppInternational().GetLanguage());
			pColumn->Put(aHorzItem);
			break;
		case dbNumeric:
			if (nKey == 0)
			{
				String		aFormatString;
				xub_StrLen	nCheckPos;
				short		nType;
				SbaNumericSize eSize = (SbaNumericSize) nLength;
				pSvNumberFormatter->GenerateFormat(aFormatString, 0L, LANGUAGE_DONTKNOW, FALSE,	FALSE,
												  (eSize == dbDouble || eSize == dbSingle) ? 2 : 0);


				pSvNumberFormatter->PutEntry( aFormatString,
					nCheckPos,
					nType,
					nKey
					);

				DBG_ASSERT(nCheckPos==0, "");
			}
			pColumn->Put(aHorzItem);
			break;
		case dbDecimal:
			if (nKey == 0)
			{
				String		aFormatString;
				xub_StrLen	nCheckPos;
				short		nType;
				pSvNumberFormatter->GenerateFormat(aFormatString, 0L, LANGUAGE_DONTKNOW, FALSE,	FALSE,
												   nScale);


				pSvNumberFormatter->PutEntry( aFormatString,
					nCheckPos,
					nType,
					nKey
					);

				DBG_ASSERT(nCheckPos==0, "");
			}
			pColumn->Put(aHorzItem);
			break;
		case dbCounter:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_NUMBER, Application::GetAppInternational().GetLanguage());
			break;
		case dbVarBinary:
		case dbBinary:
		case dbImage:
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_UNDEFINED, Application::GetAppInternational().GetLanguage());
			break;
		default: //XXX Fehlerbehandlung ein wenig brutal
		{
			/*String	aMsg( "DbObj: nicht unterstuetzer Datentyp: " );
			Window* pWindow = GetpApp()->GetDefDialogParent();
			InfoBox( pWindow, aMsg ).Execute();*/
			DBG_ERROR("DbObj: nicht unterstuetzer Datentyp:");
			if (nKey == 0)
				nKey = pSvNumberFormatter->GetStandardFormat(NUMBERFORMAT_UNDEFINED, Application::GetAppInternational().GetLanguage());
		}
		//DBG_ERROR( "DbObj: invalid fieldtype" );
		break;
	}
	pColumn->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, nKey));
	return pColumn;
}

//------------------------------------------------------------------------------
SbaColumn* SbaDBDataDef::CreateColumn(const SdbColumn& rCol) const
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	SbaColumn* pColumn = CreateColumn(rCol.GetName(), GetDatabase()->GetFieldType(rCol), GetFieldLength(rCol), rCol.GetScale(), !rCol.IsNullAllowed(), rCol.GetFormatKey(), rCol.GetId());
	if (pColumn)
	{
		if (rCol.IsPrimaryKey())
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, TRUE));
		if (rCol.GetComment().Len())
			pColumn->Put(SfxStringItem(SBA_DEF_FLTCOMMENT, rCol.GetComment()));
		// ist die SdbColumn eien AutoIncrement wert
		pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, rCol.IsAutoIncrement()));
		pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSEARCH, rCol.GetAllFlags()));
		if(rCol.GetAllFlags() & SDB_FLAGS_VERSIONING)
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTHIDE, TRUE));
	}
	return pColumn;
}
//------------------------------------------------------------------------------
SbaColumn* SbaDBDataDef::CreateColumn(const SbaColumn& rColumn,BOOL bDummy) const
{
	DBG_CHKTHIS( SbaDBDataDef, NULL);
	// Erzeugen einer Datenbankspalte
	SbaDatabase* pDatabase = GetDatabase();
	if (!pDatabase)
		return NULL;

	DBG_ASSERT(IsOpen(), "Datenbank nicht geoeffnet");
	SFX_ITEMSET_GET(rColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
	SFX_ITEMSET_GET(rColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
	SFX_ITEMSET_GET(rColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, TRUE);
	SFX_ITEMSET_GET(rColumn, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, TRUE);
	SFX_ITEMSET_GET(rColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, TRUE);
	SFX_ITEMSET_GET(rColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
	SFX_ITEMSET_GET(rColumn, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, TRUE);
	SFX_ITEMSET_GET(rColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, TRUE);
	SFX_ITEMSET_GET(rColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, TRUE);
	SFX_ITEMSET_GET(rColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
	SFX_ITEMSET_GET(rColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, TRUE );
	SFX_ITEMSET_GET(rColumn, pPos,SfxUInt16Item,SBA_DEF_FLTPOS, TRUE);

	SbaColumn* pColumn = CreateColumn(pName->GetValue(), pType->GetType(), pLength->GetValue(),
			pScale->GetValue(), pRequired->GetValue(),pFormat->GetValue(),pPos->GetValue());
	if (pColumn)
	{
		if (pPrimary && pPrimary->GetValue())
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, TRUE));
		if (pComment && pComment->GetValue().Len())
			pColumn->Put(SfxStringItem(SBA_DEF_FLTCOMMENT, pComment->GetValue()));
		// ist die SdbColumn eien AutoIncrement wert
		pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, pAutoIncrement && pAutoIncrement->GetValue()));
		if(pFlags)
			pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSEARCH, pFlags->GetValue()));
	}
	return pColumn;
}
//------------------------------------------------------------------------------
SdbColumn* SbaDBDataDef::CreateColumn(const SbaColumn& rColumn) const
{
	DBG_CHKTHIS( SbaDBDataDef, NULL);
	// Erzeugen einer Datenbankspalte
	SbaDatabase* pDatabase = GetDatabase();
	if (!pDatabase)
		return NULL;

	DBG_ASSERT(IsOpen(), "Datenbank nicht geoeffnet");
	SFX_ITEMSET_GET(rColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
	SFX_ITEMSET_GET(rColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
	SFX_ITEMSET_GET(rColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, TRUE);
	SFX_ITEMSET_GET(rColumn, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, TRUE);
	SFX_ITEMSET_GET(rColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, TRUE);
	SFX_ITEMSET_GET(rColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
	SFX_ITEMSET_GET(rColumn, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, TRUE);
	SFX_ITEMSET_GET(rColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, TRUE);
	SFX_ITEMSET_GET(rColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, TRUE);
	SFX_ITEMSET_GET(rColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
	SFX_ITEMSET_GET(rColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, TRUE );

	SbaFieldType eType	= pType->GetType();
	UINT32		 nLength= pLength->GetValue();
	SdbTypeInfo* pInfo = pDatabase->IsTypeAvailable(eType,(SbaNumericSize)nLength);
	SdbColumn* pColumn = NULL;

	if (!pInfo)
		return NULL;

	SdbConnectionRef rCon(pDatabase->GetConnection());
	const SdbTypeInfo* pTypInfo = rCon->GetColumnTypeInfo(pInfo->eType);

	switch (eType)
	{
		case dbText:
		case dbChar:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, pTypInfo->nPrecision ? min(pLength->GetValue(),pTypInfo->nPrecision):pLength->GetValue());
			break;
		case dbBool:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pLength->GetValue(),pTypInfo->nPrecision));
			break;
		case dbDecimal:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, pTypInfo->nPrecision ? min(pLength->GetValue(),pTypInfo->nPrecision) : pLength->GetValue(),min((INT16)pScale->GetValue(),(INT16)pTypInfo->nScale));
			break;
		case dbNumeric:
		{
			switch (nLength)
			{
				case dbByte:
					pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(3L,(INT32)pTypInfo->nPrecision),0);
					break;
				case dbInteger:
					pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(5L,(INT32)pTypInfo->nPrecision),0);
					break;
				case dbLong:
					pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(10L,(INT32)pTypInfo->nPrecision), 0);
					break;
				case dbSingle:
					pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(15L,(INT32)pTypInfo->nPrecision), min(5L,(INT32)pTypInfo->nScale));
					break;
				case dbDouble:
					pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(15L,(INT32)pTypInfo->nPrecision),min(5L,(INT32)pTypInfo->nScale));
					break;
				default:
					DBG_ERROR("Unbekanntes Size!");
			}
		}	break;
		case dbCurrency:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(19L,(INT32)pTypInfo->nPrecision),min(4L,(INT32)pTypInfo->nScale));
			break;
		case dbDateTime:
			if (pInfo->eType == SDB_DBTYPE_TIMESTAMP)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision), min(pInfo->nScale,pTypInfo->nScale));
			else if (pInfo->eType == SDB_DBTYPE_DECIMAL)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(17L,(INT32)pTypInfo->nPrecision), min(10L,(INT32)pTypInfo->nScale));
			else
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision),min((INT32)pInfo->nScale,(INT32)pTypInfo->nScale));
			break;
		case dbDate:
			if (pInfo->eType == SDB_DBTYPE_DATE)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision), min(pInfo->nScale,pTypInfo->nScale));
			else if (pInfo->eType == SDB_DBTYPE_DECIMAL)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(6L,(INT32)pTypInfo->nPrecision));
			else
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision), min(pInfo->nScale,pTypInfo->nScale));
			break;
		case dbTime:
			// kann auch als Text abgelegt werden
			if (pInfo->eType == SDB_DBTYPE_TIME)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision), min(pInfo->nScale,pTypInfo->nScale));
			else if (pInfo->eType == SDB_DBTYPE_DECIMAL)
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(12L,(INT32)pTypInfo->nPrecision),min(10L,(INT32)pTypInfo->nScale));
			else
				pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, min(pInfo->nPrecision,pTypInfo->nPrecision), min(pInfo->nScale,pTypInfo->nScale));
			break;
		case dbMemo:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType);
			break;
		case dbImage:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType);
			break;
		case dbVarBinary:
		case dbBinary:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), pInfo->eType, pTypInfo->nPrecision ? min(pLength->GetValue(),pTypInfo->nPrecision) : pLength->GetValue());
			break;
		case dbCounter:
			pColumn = pDatabase->CreateColumn(pName->GetValue(), SDB_DBTYPE_INTEGER); //pInfo->eType); // wird auf integer gemaped.
			break;
		default:
			DBG_ERROR("Unbekannter Typ!");
	}
	if (pColumn)
	{
		if (!pRequired->GetValue())
			pColumn->SetFlag(SDB_FLAGS_NULLALLOWED);
		if (pPrimary->GetValue())
			pColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
		pColumn->SetComment(pComment->GetValue());
		pColumn->SetDefaultValue(pDefault->GetValue());
		if(pInfo->bAutoIncrement && pAutoIncrement->GetValue())
			pColumn->SetFlag(SDB_FLAGS_AUTOINCREMENT);  // AutoIncrement setzen
		// set the versioning flag
		if(pFlags && pFlags->GetValue() & SDB_FLAGS_VERSIONING)
			pColumn->SetFlag(SDB_FLAGS_VERSIONING);
		if(pFormat)
			pColumn->SetFormatKey(pFormat->GetValue());
	}
	return pColumn;
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::Update()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	SBA_CHK_OPEN_BOOL();

	if (IsTemp())
	{
		*xOriginalColumns = *xColumns;
		return TRUE;
	}

	BeginDBAction();
	if (!Store())
		CancelDBAction();
	else
	{
		*xOriginalColumns = *xColumns;
		EndDBAction();
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
void SbaDBDataDef::Merge(const SdbColumns& rCols,BOOL bMergePkKeys)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	SbaDatabase* pDatabase = GetDatabase();
	if (!pDatabase)
		return;

	SbaColumnListRef xMergeList = new SbaColumnList(pDatabase->GetIdentifierCase());
	// beim Mergen werden zunaechst alle Spalten
	// aus der bisherigen Beschreibung uebernommen, bei denen
	// der Namen uebereinstimmt

	for (UINT16 i = 1; i < rCols.Count(); i++)
	{
		const SdbColumn* pCol = rCols.Column(i);
		SbaColumn* pSbaCol	  = GetColumn(pCol->GetName());
		// definition exitiert, dann uebernehmen, sonst neue erzeugen
		if (pSbaCol)
		{
			pSbaCol->Put(SfxUInt16Item(SBA_DEF_FLTPOS, pCol->GetId()));
			pSbaCol->Put(SfxUInt16Item(SBA_DEF_FLTSCALE, pCol->GetScale()));
			if(bMergePkKeys)
			{
				pSbaCol->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY , pCol->IsPrimaryKey()));
				pSbaCol->Put(SfxBoolItem(SBA_DEF_FLTREQUIRED, !pCol->IsNullAllowed()));
				pSbaCol->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, pCol->IsAutoIncrement()));
			}
			pSbaCol->Put(SfxBoolItem(SBA_DEF_FLTUPDATABLE, pCol->IsUpdateAllowed()));
			pSbaCol->Put(SfxUInt16Item(SBA_DEF_FLTSEARCH, pCol->GetAllFlags()));
		}
		else
			pSbaCol = CreateColumn(*pCol);
		xMergeList->InsertAt(pCol->GetName(), pSbaCol);
	}
	xOriginalColumns = xMergeList;
	*xColumns = *xOriginalColumns;
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::Load(const SdbColumns* pCols,BOOL bMergePkKeys)
{
	// Lesen der Spalten
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	// Itemsets fuer die Spalten Fontinformationen holen
	// Struktur abholen
	// es gibt ueberhaupt was
	SbaColumn* pColumn = NULL;
	ULONG i;
	SvStorageStreamRef aStream;
	SdbStorageRef aOrderFilterStorage;
	StringList aInfoList;
	SbaDatabase* pDatabase = GetDatabase();

	// alte Strukturen freigen
	xOriginalColumns->Clear();
	xColumns->Clear();

	bAttrsModified = FALSE;

	// Ist die definition erst neu angelegt oder
	// sie ist nur temp angelegt
	// dann nur die Defaulteinstellungen setzen
	if ((IsNew() || IsTemp()) && pCols)
	{
		BeginDBAction();
		Merge(*pCols,bMergePkKeys);
		EndDBAction();
		return TRUE;
	}
	else if (!BeginTrans(FALSE))
		return FALSE;

	BeginDBAction();
	SdbStorageRef aObjStor( pDatabase->OpenStorage(*aDBStor, Name(), STREAM_STD_READ) );
	if (!aObjStor.Is())	// neue Objekte koennen auch nur die default werte setzen
		goto End;

	aStream = pDatabase->OpenContent(*aObjStor,STREAM_STD_READ);
	if (aStream.Is())	// es ist schon Stream angelegt
	{
		// Einlesen der PoolInfo und der Tabellenattribute
		SbaColumnListRef xMergeList = new SbaColumnList(pDatabase->GetIdentifierCase());
		pPool->Load(*aStream);
		pObjAttrSet->ClearItem(0);
		pObjAttrSet->Load(*aStream, TRUE, pPool);

		// Einlesen der Spalten
		aObjStor->GetStorageNameList(aInfoList);
		for (i = 0; i < aInfoList.Count(); i++)		// Auslesen der Spalten
		{
			String* pInfo = aInfoList.GetObject(i);

			// SbaColumn erzeugen, und gleich in die Liste packen
			pColumn = new SbaColumn(*pPool, ColAttrMap);

			// Informationen aus der Table holen
			SdbStorageRef aColStor( pDatabase->OpenStorage(*aObjStor, *pInfo, STREAM_STD_READ) );
			if (!aColStor.Is())
				goto End;

			SvStorageStreamRef aColStream( pDatabase->OpenContent(*aColStor,STREAM_STD_READ) );
			if (!aColStream.Is())
				goto End;

			// Column einlesen
			pColumn->Load(*aColStream, FALSE, pPool);

			// Temp info setzen
			// Spaltenname kann aus Tabellenname.Spaltenname zusammengesetzt sein
			if (pInfo->GetTokenCount('.') == 2)
				pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, pInfo->GetToken(1,'.'), IS_CASE_SENSITIVE(pDatabase)));
			else
				pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, *pInfo, IS_CASE_SENSITIVE(pDatabase)));

			//pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, FALSE));
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTUPDATABLE, TRUE));
			pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE, 0));
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, FALSE));
			pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSEARCH, 0));

			// an sich muessten die Felder hier schon anhand der Positionen
			// eingefuegt werden, das kann InsertAt allerdings noch nicht
			// daher erst unten
			xMergeList->InsertAt(*pInfo, pColumn);
		}
		// hier ist zu beachten, da in der SDB-Datenbank die Spalten
		// nicht in der Reihenfolge gespeichert sind, wie sie in den SdbColumns
		// abgelegt ist.
		// Die alten Positionen muessen eingehalten werden
		UINT16 nPos = 1;
		while (xMergeList->Count())
		{
			ULONG nCount = xMergeList->Count();
			for (ULONG j = 0; j < nCount; j++)
			{
				pColumn = xMergeList->GetObject(j);
				if (nPos == PTR_CAST(SfxUInt16Item,&pColumn->Get(SBA_DEF_FLTPOS))->GetValue())
				{
					// Positionen stimmen ueberein
					SFX_ITEMSET_GET(*pColumn, pNameItem, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
					xOriginalColumns->InsertAt(pNameItem->GetValue(), pColumn);
					xMergeList->RemoveAt(j);
					break;
				}
			}
			if (nCount == xMergeList->Count())
				break;	// Um endlos zu verhindern
			else
				nPos++;
		}
	}

	// Some older versions saved the filter and sort criterias separately (not in the object attributes)
	// so we have to convert this.
	// the storage for the order/filter crits
	aOrderFilterStorage = pDatabase->OpenStorage(*aObjStor, String::CreateFromAscii("DbObjectOrderFilter_10"), STREAM_STD_READ);
	if (aOrderFilterStorage.Is())
	{
		// within these storage a content stream
		SvStorageStreamRef aOrderFilter = pDatabase->OpenContent(*aOrderFilterStorage, STREAM_STD_READ);
		if (aOrderFilter.Is())
		{
			// (the old format is rather stupid .... ;)
			USHORT i, nCount;
			SbaPredicateItemList	aFilter;
			SbaOrderItemList		aSort;

			// the filter list
			nCount = 0;
			*aOrderFilter >> nCount;
			for (i=0; i<nCount; ++i)
			{
				SbaPredicateItem* pItem = new SbaPredicateItem();
				unsigned char aDummy;
				aOrderFilter->ReadByteString(pItem->aTableRange, RTL_TEXTENCODING_ASCII_US);
				aOrderFilter->ReadByteString(pItem->aFieldName, RTL_TEXTENCODING_ASCII_US);
				*aOrderFilter >> aDummy; pItem->eType = (SdbPredicateType)aDummy;
				aOrderFilter->ReadByteString(pItem->aValue, RTL_TEXTENCODING_ASCII_US);
				aOrderFilter->ReadByteString(pItem->aName, RTL_TEXTENCODING_ASCII_US);
				*aOrderFilter >> aDummy; pItem->eVarType = (SdbDatabaseType)aDummy;
				*aOrderFilter >> aDummy; pItem->eLogType = (SbaLogType)aDummy;

				aFilter.Insert(pItem, LIST_APPEND);
			}
			// the sort list
			nCount = 0;
			*aOrderFilter >> nCount;
			for (i=0; i<nCount; ++i)
			{
				SbaOrderItem* pItem = new SbaOrderItem();
				unsigned char aDummy;
				::rtl::OUString sDummy;
				aOrderFilter->ReadByteString(pItem->aTableRange, RTL_TEXTENCODING_ASCII_US);
				aOrderFilter->ReadByteString(pItem->aFieldName, RTL_TEXTENCODING_ASCII_US);
				*aOrderFilter >> aDummy; pItem->bDirection = (BOOL)aDummy;

				aSort.Insert(pItem, LIST_APPEND);
			}

			// convert into strings
			SbaParseIterator aParser(NULL, GetDatabase());
			String sFilter = aParser.BuildWherePart(aFilter);
			String sSort = aParser.BuildOrderPart(aSort);

			const SfxStringItem* pOldFilter = (const SfxStringItem*)pObjAttrSet->GetItem(SBA_DEF_FILTER);
			if (!pOldFilter || !pOldFilter->GetValue().Len())
				pObjAttrSet->Put(SfxStringItem(SBA_DEF_FILTER, sFilter));

			const  SfxStringItem* pOldSort = (const SfxStringItem*)pObjAttrSet->GetItem(SBA_DEF_SORT);
			if (!pOldSort || !pOldSort->GetValue().Len())
				pObjAttrSet->Put(SfxStringItem(SBA_DEF_SORT, sSort));
		}
	}

	// ist eine Spaltendefinition angegeben
	// dann mu noch ein Abgleich erfolgen,
	// sprich da was in der SDB Datenbank steht, kann veraltet sein!
	if (pCols)
		Merge(*pCols,bMergePkKeys);

	// schon gesetzt ?
	if (!xColumns->Count())
		*xColumns = *xOriginalColumns;

	EndTrans();
	EndDBAction();
	for (i = 0; i < aInfoList.Count(); i++)
		delete aInfoList.GetObject(i);
	return TRUE;
End:
	for (i = 0; i < aInfoList.Count(); i++)
		delete aInfoList.GetObject(i);

	xOriginalColumns->Clear();
	xColumns->Clear();

	aStatus = pDatabase->Status();
	CancelDBAction();
	EndTrans();
	return FALSE;
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::Store()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	if (!BeginTrans(TRUE))
		return FALSE;

	BeginDBAction();
	SbaDatabase* pDatabase = GetDatabase();

	ULONG i;
	SvStorageStreamRef aStream;
	StringList aInfoList;

	SdbStorageRef aObjStor = pDatabase->OpenStorage(*aDBStor, Name(), STREAM_STD_READWRITE);
	if (!aObjStor.Is())
		goto Rollback;

	// alle bisherigen spalten loeschen
	// Einlesen der Spalten
	aObjStor->GetStorageNameList(aInfoList);
	// Loeschen der Spalten die nicht mehr benoetigt werden
	for (i = 0; i < aInfoList.Count(); i++)
	{
		String* pInfo = aInfoList.GetObject(i);
		// existiert in der aktuellen Version nicht?
		if (!xColumns->Lookup(*pInfo, gc_strEmptyString))
			aObjStor->Remove(*pInfo,GetKind()==dbTable);

		delete pInfo;
	}

	aStream = pDatabase->OpenContent(*aObjStor,STREAM_STD_READWRITE | STREAM_TRUNC);
	if (!aStream.Is())
		goto Rollback;

	pPool->Store(*aStream);
	pObjAttrSet->Store(*aStream,TRUE);
	aStream->Flush();							// sonst werden die Daten nicht geschrieben

	for (i = 0; i < xColumns->Count(); i++)
	{
		SbaColumn* pColumn = xColumns->GetObject(i);
		SFX_ITEMSET_GET(*pColumn, pNameItem, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
		SdbStorageRef aColStor( pDatabase->OpenStorage(*aObjStor, pNameItem->GetValue(), STREAM_STD_READWRITE | STREAM_TRUNC));
		if (!aColStor.Is())
			goto Rollback;

		SvStorageStreamRef aColStream( pDatabase->OpenContent(*aColStor, STREAM_STD_READWRITE | STREAM_TRUNC) );
		if (!aColStream.Is())
			goto Rollback;

		pColumn->Store(*aColStream);
		aColStream->Flush();
	}

	// Some older versions saved the filter and sort criterias separately (not in the object attributes).
	// We converted this in Load, so we may delete the old stuff now.
	aObjStor->Remove(String::CreateFromAscii("DbObjectOrderFilter_10"),GetKind()==dbTable);

	// wird immer aufgerufen
	pDatabase->AlterFormatter();
	goto Commit;

Rollback:
	aStatus = pDatabase->Status();
	Rollback();
	CancelDBAction();
	return FALSE;

Commit:
	// Freigeben des Objects, sonst wird dieses nicht richtig gespeichert
	aObjStor.Clear();
	Commit();
	bAttrsModified = FALSE;
	EndDBAction();
	return TRUE;
}

//------------------------------------------------------------------------------
void SbaDBDataDef::PutObjAttrs(const SfxItemSet& rSet)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	pObjAttrSet->Put(rSet);
	bAttrsModified = TRUE;
}

//------------------------------------------------------------------------------
String SbaDBDataDef::GetString(const ODbVariantRef& xVar, USHORT nColID, Color **ppColor, BOOL bOutput) const
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	String aText;
	if (!xVar.is())
		return aText;

	SbaColumn* pColumn = GetColumn(nColID);
	DBG_ASSERT( pColumn, "GetColumn(nColID) == NULL");

	const SbaDataFieldTypeItem* pTypeItem	= PTR_CAST(SbaDataFieldTypeItem,&pColumn->Get(SBA_DEF_FLTTYPE));
	const SfxUInt32Item* pFormatItem		= PTR_CAST(SfxUInt32Item, &pColumn->Get(SBA_DEF_FMTVALUE));
	const SfxBoolItem* pAutoIncItem			= PTR_CAST(SfxBoolItem, &pColumn->Get(SBA_DEF_FLTAUTOINCREMENT));
	DBG_ASSERT(pTypeItem && pFormatItem, "TYPFEHLER" );

	return SbaDbDataConverter::Var2String(*xVar,(SbaFieldType)pTypeItem->GetValue(),pFormatItem->GetValue(),ppColor,GetFormatter(),bOutput,pAutoIncItem && pAutoIncItem->GetValue());
}

//------------------------------------------------------------------------------
void SbaDBDataDef::AddUsage()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	nUsageCount++;
	SFX_BINDINGS().Invalidate(SID_EDITDOC);
}

//------------------------------------------------------------------------------
void SbaDBDataDef::ReleaseUsage()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	nUsageCount--;
	SFX_BINDINGS().Invalidate(SID_EDITDOC);
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::BeginTrans(BOOL bForStore)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	if (aDBStor.Is())		// Storage schon geoeffnet
	{
		aDBStor->AddRef();
		return TRUE;
	}
	else
	{
		SbaDatabase* pDatabase = GetDatabase();
		aDBStor = pDatabase->OpenStorage(edbObj, !bForStore);
		if (!aDBStor.Is())
			aStatus = pDatabase->Status();
		return aDBStor.Is();
	}
}

//------------------------------------------------------------------------------
BOOL SbaDBDataDef::EndTrans(BOOL bCommit)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	DBG_ASSERT(aDBStor.Is(), "SbaDBDataDef: Fehler in der Transaction");
	BOOL bResult;
	if (!aDBStor.Is())
		bResult = FALSE;
	else if (aDBStor->GetRefCount() > 2)		// eine Ref haelt immer die Datenbank
	{
		aDBStor->ReleaseReference();
		bResult = TRUE;
	}
	else
	{
		aDBStor.Clear();
		SbaDatabase* pDatabase = GetDatabase();
		if(pDatabase)
		{
			bResult = pDatabase->ReleaseStorage(edbObj,bCommit);
			if (!bResult && bCommit)
				aStatus = pDatabase->Status();
		}
		else
			bResult = FALSE;
	}
	return bResult;
}

//------------------------------------------------------------------------------
SbaDataObj* SbaDBDataDef::CreateDataObj()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	SbaDataObj* pDataObj = CreateDataObjImpl();
	aDataObjList.Insert(pDataObj, LIST_APPEND);
	return pDataObj;
}

//------------------------------------------------------------------------------
void SbaDBDataDef::RemoveChild(SdbObj* pObj)
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	SbaDataObj* pDBObj = PTR_CAST(SbaDataObj, pObj);
	if (pDBObj)
		aDataObjList.Remove(pDBObj);
	SbaDBDef::RemoveChild(pObj);
}

//------------------------------------------------------------------------------
void SbaDBDataDef::RemoveChildren()
{
	DBG_CHKTHIS(SbaDBDataDef, NULL);
	while (aDataObjList.Count())
		RemoveChild(aDataObjList.GetObject(0));
}

//------------------------------------------------------------------------------
SvNumberFormatter* SbaDBDataDef::GetFormatter() const { DBG_CHKTHIS(SbaDBDataDef, NULL);return GetDatabase()->GetFormatter();}
const SvxFontListItem& SbaDBDataDef::GetFontListItem() const {DBG_CHKTHIS(SbaDBDataDef, NULL);return *SBA_MOD_EXT()->pFontListItem;}

TYPEINIT1(SbaDataObj, SbaDBObj);

DBG_NAME(SbaDataObj);
//------------------------------------------------------------------------------
SbaDataObj::SbaDataObj(SbaDBDataDef* pDBDef,
					   const String& rSQLStatement,
					   BOOL _bNative,
					   const String& rName,
					   BOOL bShow)
			 :SbaDBObj(pDBDef, rName, FALSE, bShow)
			 ,pCursor(NULL)
			 ,aSQLStatement(rSQLStatement)
			 ,nCacheSize(CACHE_SIZE)
			 ,bForUpdate(FALSE)
			 ,bNative(_bNative)
{
	DBG_CTOR(SbaDataObj,NULL);
	// mit sql parsing ?
	UINT16 nOptions = (bNative) ? SDB_SEEDELETED : SDB_SEEDELETED | SDB_INDIRECT | SDB_CONCURRENCY;
	pCursor =  GetDatabase()->CreateCursor(SDB_KEYSET, nOptions);
	pCursor->AddRef();

	// Datenobjekte koennen nicht neu angelegt werden
	bNew = FALSE;
}

//------------------------------------------------------------------------------
SbaDataObj::~SbaDataObj()
{
	if (pCursor)
	{
		pCursor->ReleaseRef();
		pCursor = NULL;
	}
	DBG_DTOR(SbaDataObj,NULL);
}

//------------------------------------------------------------------------------
void SbaDataObj::ReInit(const String& rSQLStatement)
{
	Close();
	aSQLStatement = rSQLStatement;
	Open();
}

//------------------------------------------------------------------------------
BOOL SbaDataObj::Prepare()
{
	aStatus.Clear();
	if (IsPrepared())
		return TRUE;
	else if (!pCursor)
		return FALSE;

	BeginDBAction();
	// nur bei einen DatenObjekt, welches auf einer Tabelle basiert,
	// ist aSQLStatement == aName, d.h. das Statement wird im Cursor erst
	// aufgebaut
	BOOL bTable = aSQLStatement == aName;
	if (!pCursor->Prepare(aSQLStatement, bTable))
	{
		aStatus = pCursor->Status();
		CancelDBAction();
		ShowError(dbReadError);
	}
	else if (bTable)
	{
		aSQLStatement = pCursor->SQLStatement();
	}

	EndDBAction();
	return pCursor->IsPrepared();
}

//------------------------------------------------------------------------------
BOOL SbaDataObj::Open()
{
	if (IsOpen())
		return TRUE;

	BeginDBAction();
	aStatus.Clear();

	if (!IsPrepared() && !Prepare())
	{
		EndDBAction();
		return FALSE;
	}

	ODbRowRef aParameterRow = pCursor->GetParameterRow();
	if (aParameterRow.is())	// Benutzer nach Parametern befragen
	{
		EndDBAction();
		UINT16 nCount = aParameterRow->size();
		if (nCount>1)
		{
			NAMESPACE_VOS(OGuard) aGuard(Application::GetSolarMutex());
				// this may be called from outside the main thread ...
				// 67973 - 30.07.99 - FS

			DBG_ERROR("SbaDataObj::Open : no parameter handling anymore! ask FS.");
				// nobody should use this object anymore (at least not with parametrized statements)
				// if anybody does, we would have to translate the params into UNO-objects, as
				// the FmEnterParamDlg works only with UNO ...
				// FS - 16.11.99 - (69207)
/*			FmEnterParamDlg aDlg(NULL, aParameterRow->getColumns()->Column(1)->GetName());
			for (UINT16 i=2; i<nCount; ++i)
				aDlg.AddParam(aParameterRow->getColumns()->Column(i)->GetName());

			if (aDlg.Execute() != RET_OK)
				return FALSE;

			for (i=1; i<nCount; ++i)
			{
				ODbVariantRef xVar = (*aParameterRow)[i];
				UsrAny aParam = aDlg.GetParamValue(i-1);
				if (!aParam.get())
					xVar->setNull();
				else
					xVar->setString(aParam.getString());
			}
*/
		}

		BeginDBAction();
	}

	pCursor->SetCacheSize(nCacheSize);
	if (!IsPrepared())
		pCursor->Open(aSQLStatement, aSQLStatement == aName);
	else
		pCursor->Open();	// Statement bereits uebergeben

	BOOL bCorrectColumns = TRUE;
	if (!pCursor->IsOpen())
	{
		aStatus = pCursor->Status();
		CancelDBAction();
		ShowError(dbReadError);
	}
	else
	{
		pCursor->SetUpdatable(bForUpdate);

		bOpen = TRUE;
		EndDBAction();

		// Der SdbCursor haelt sich intern Informationen, die er beim Oeffnen nur auf default-Werte setzten konnte, die ich ihm aber
		// jetzt - da ich aus der Def die richtigen Werte habe - korrekt geben kann.
		// Nun, vielleicht war der Plural InformationEN nicht richtig, es geht i.A. nur um FormatKeys ...
		SdbObj* pParent = GetParent();
		DBG_ASSERT(pParent->ISA(SbaDBDataDef), "SbaDataObj::Open : Parent hat falschen Typ !");
			// das KANN eigentlich nie anspringen, da das Parent genau die im Constructor uebergebene Def ist
		SbaDBDataDef* pParentDef = (SbaDBDataDef*)pParent;

		SdbColumnsRef xCursorColumns = pCursor->GetColumns();

		bCorrectColumns = (xCursorColumns->Count() == (pParentDef->GetColumns().Count()+1));
		if(!bCorrectColumns)
		{
			String aColumnNames;
			if(xCursorColumns->Count() < (pParentDef->GetColumns().Count()+1))
			{
				for(USHORT i = xCursorColumns->Count()-2; i < pParentDef->GetColumns().Count();i++)
				{
					SbaColumn* pCurrentColumn = pParentDef->GetColumn(i);
					SFX_ITEMSET_GET(*pCurrentColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
					aColumnNames += pName->GetValue();
					aColumnNames += ';';
				}
			}
			else
			{
				for(USHORT i = pParentDef->GetColumns().Count()-1; i < xCursorColumns->Count();i++)
				{
					const SdbColumn* pCurrentColumn = xCursorColumns->Column(i);
					aColumnNames += pCurrentColumn->GetName();
					aColumnNames += ';';
				}
			}

			if(aColumnNames.Len())
				aColumnNames.SetChar(aColumnNames.Len()-1, '.'); // Satz sollte mit Punkt enden

			String aText( SbaResId( SBA_STR_INCONSISTENTS_COLUMNS ) );
			aText.SearchAndReplace(String::CreateFromAscii("\'$name$\'"),aColumnNames);

			aStatus.Set(SDB_STAT_ERROR,String(),aText,0,String());
		}
		else
		{
			DBG_ASSERT(xCursorColumns->Count() == pParentDef->GetColumns().Count()+1, "SbaDataObj::Open : Spalten ungleich -> Inkonsistenzen !");
			// normalerweise hat der Cursor genau eine Spalte mehr, naemlich die, die die Bookmark haelt

			for (USHORT i=1; i < xCursorColumns->Count(); i++)
			{
				SdbColumn* pColumn = (SdbColumn*)xCursorColumns->Column(i);

				// den Format-Key aus der Def ...
				USHORT nColId = i-1;	// Fuer UNIX, damit GetColumn() richtig aufgeloest wird
				SbaColumn* pCurrentColumn = pParentDef->GetColumn( nColId );
				const SfxUInt32Item* pFormatItem = PTR_CAST(SfxUInt32Item, &pCurrentColumn->Get(SBA_DEF_FMTVALUE));
				// ... in den Cursor packen
				pColumn->SetFormatKey(pFormatItem->GetValue());
					// ja, ich caste hier ein const weg ... aber die SdbColumns-Auszaehlung liesse mir sonst nur die Chance, eine
					// Column zu ersetzen, was ein wenig Overkill waere
			}
		}
	}
	return IsOpen() && bCorrectColumns;
}

//------------------------------------------------------------------------------
BOOL SbaDataObj::IsUpdatable() const
{
	return bForUpdate && pCursor && pCursor->IsOpen() && pCursor->IsUpdatable();
}

//------------------------------------------------------------------------------
void SbaDataObj::Close()
{
	if (pCursor)
		pCursor->Close();
	bOpen = FALSE;
}

//------------------------------------------------------------------------------
BOOL SbaDataObj::IsPrepared() const
{
	//return pCursor && (pCursor->IsPrepared() || bNative);
	return pCursor && pCursor->IsPrepared();
}

//------------------------------------------------------------------------------
INT32 SbaDataObj::CountAll()
{
	if (!IsOpen())
		return 0;
	else if (!pCursor->IsRowCountFinal())
	{
		BeginDBAction();
		UINT16 nSize = pCursor->GetCacheSize();
		if (nSize)
			pCursor->SetCacheSize(0);

		pCursor->DetermineRowCount();

		if (nSize)
			pCursor->SetCacheSize(nSize);

		EndDBAction();
	}
	return pCursor->RowCount();
}

//------------------------------------------------------------------------------
void SbaDataObj::SetCacheSize(UINT16 nSize)
{
	nCacheSize = nSize;
	if (pCursor)
		pCursor->SetCacheSize(nCacheSize);
}

//------------------------------------------------------------------------------
BOOL SbaDataObj::SetUpdatable(BOOL bUpdate)
{
	BOOL bResult = pCursor && pCursor->IsOpen();
	if (bResult)
	{
		aStatus.Clear();	// damit die nachfolgende Ermittlung
							// aussagekraeftig ist.
		BeginDBAction();
		if (!pCursor->SetUpdatable(bUpdate))
		{
			aStatus = pCursor->Status();
			CancelDBAction();
			ShowError(dbReadError);
			bResult = FALSE;
		}
		// beim Umschalten auf Update kann es vorkommen, da
		// der Treiber noch eine Warnung ausgibt:
		else if (bUpdate && pCursor->Status().Result() == SDB_STAT_SUCCESS_WITH_INFO)
		{
			if (bShowError)
			{
				CancelDBAction();

				String aMsg(pCursor->Status().ErrorInfo());
				aMsg += '\n';
				aMsg += String(SbaResId(SBA_STR_QRY_CONTINUE));
				SbaMsgBox aBox(GetpApp()->GetDefDialogParent(), String(SbaResId(SBA_STAT_WARNING)),
					aMsg, WB_YES_NO | WB_DEF_NO, SbaMsgBox::Warning);

				if (aBox.Execute() == RET_YES)
					bForUpdate = bUpdate;
				else
				{
					pCursor->SetUpdatable(FALSE);
					bResult = FALSE;
				}
			}
			else
			{
				EndDBAction();
				bForUpdate = bUpdate;
			}
		}
		else
		{
			EndDBAction();
			bForUpdate = bUpdate;
		}
	}
	if (bResult)
		SFX_BINDINGS().Invalidate(SID_EDITDOC);

	return bResult;
}

//------------------------------------------------------------------------------
SbaDBDataDef* SbaDataObj::GetDataDef() const
{
	return PTR_CAST(SbaDBDataDef,GetParent());
}

















