/*************************************************************************
 *
 *  $RCSfile: dbitems.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#include "dbobj.hxx"


#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif


TYPEINIT1(SbaNameItem, SfxStringItem)
DBG_NAME(SbaNameItem);
//------------------------------------------------------------------------------
SfxPoolItem* SbaNameItem::Clone( SfxItemPool *pPool) const
{
	return new SbaNameItem(Which(), GetValue(), bCase );
}

//------------------------------------------------------------------------------
int SbaNameItem::operator==( const SfxPoolItem& _rItem) const
{
	if (_rItem.Type() == Type())
	{
		SbaNameItem* pRef = (SbaNameItem*)&_rItem;
		return bCase ? (int) (GetValue().Equals(pRef->GetValue()))
					 : (int) (SbaDBObj::EqualNamesInsensitive(GetValue(), pRef->GetValue()));
	}
	else
	{
		DBG_ERROR( "SbaNameItem: operator==" );
	}
	return 0;
}

TYPEINIT1(SbaDataFieldTypeItem, SfxEnumItem)
DBG_NAME(SbaDataFieldTypeItem);
//------------------------------------------------------------------------------
SfxPoolItem* SbaDataFieldTypeItem::Clone( SfxItemPool *pPool) const
{
	return new SbaDataFieldTypeItem( Which(), (SbaFieldType)GetValue() );
}

//------------------------------------------------------------------------------
USHORT SbaDataFieldTypeItem::GetValueCount() const
{
	return dbImage + 1;
}

//------------------------------------------------------------------------------
String SbaDataFieldTypeItem::GetValueText() const
{
	String aRet(SbaResId(STR_DBFIELDTYPES));
	return aRet.GetToken(GetValue());
}

//------------------------------------------------------------------------------
String SbaDataFieldTypeItem::GetValueTextByPos( USHORT nPos ) const
{
	String	aRet(SbaResId(STR_DBFIELDTYPES));
	return aRet.GetToken( nPos );
}

//------------------------------------------------------------------------------
USHORT SbaDataFieldTypeItem::GetValueByPos( USHORT nPos ) const
{
	if( nPos > dbImage)
	{
		DBG_ERROR( "SbaDataFieldTypeItem: <nPos> out of range" );
	}
	return nPos;
}

//------------------------------------------------------------------------------
int SbaDataFieldTypeItem::operator==( const SfxPoolItem& rItem ) const
{
	if( rItem.Type() == Type() )
	{
		SbaDataFieldTypeItem* pT = (SbaDataFieldTypeItem*)&rItem;
		return GetValue() == pT->GetValue();
	}
	else
	{
		DBG_ERROR( "SbaDataFieldTypeItem: operator==" );
	}
	return 0;
}

//------------------------------------------------------------------------------
USHORT SbaDataFieldTypeItem::GetVersion(USHORT) const
{
	return 0x0100;
}

//------------------------------------------------------------------------------
SfxPoolItem* SbaDataFieldTypeItem::Create( SvStream &rStream, USHORT nVer ) const
{
	USHORT		nMode;

	rStream >> nMode;
	return new SbaDataFieldTypeItem( Which(), (SbaFieldType) nMode );
}


TYPEINIT1(SbaColRowSizeItem, SfxPoolItem)
DBG_NAME(SbaColRowSizeItem);
/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SbaColRowSizeItem::SbaColRowSizeItem(USHORT nWhich, UINT16 nCompValue, UINT16 nValue)
				  :SfxPoolItem(nWhich)
				  ,nCompVal(nCompValue)
				  ,nVal(nValue)
				  ,nVersion(1)
{
	DBG_CTOR(SbaColRowSizeItem,NULL);
}


/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SbaColRowSizeItem::SbaColRowSizeItem(USHORT nWhich, UINT16 nValue)
				  :SfxPoolItem(nWhich)
				  ,nVal(nValue)
				  ,nVersion(1)
{
	DBG_CTOR(SbaColRowSizeItem,NULL);
	nCompVal = (USHORT)Application::GetDefaultDevice()->LogicToPixel(Point(nValue,0),MAP_10TH_MM).X();
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SbaColRowSizeItem::SbaColRowSizeItem(const SbaColRowSizeItem& rItem)
				  :SfxPoolItem(rItem.Which())
				  ,nVal(rItem.GetLogicValue())
				  ,nCompVal(rItem.GetPixelValue())
				  ,nVersion(rItem.nVersion)
{
	DBG_CTOR(SbaColRowSizeItem,NULL);
}

SbaColRowSizeItem::~SbaColRowSizeItem()
{
	DBG_DTOR(SbaColRowSizeItem,NULL);
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
int SbaColRowSizeItem::operator==( const SfxPoolItem& rItem) const
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	if (rItem.Type() == Type())
	{
		SbaColRowSizeItem* pT = (SbaColRowSizeItem*)&rItem;
		return (GetVersion(SOFFICE_FILEFORMAT_40) > 0) ?
			GetLogicValue() == pT->GetLogicValue() :
			GetPixelValue() == pT->GetPixelValue();
	}
	else
	{
		DBG_ERROR( "SbaColRowSizeItem: operator==" );
		return 0;
	}
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SfxPoolItem* SbaColRowSizeItem::Clone(SfxItemPool *pPool) const
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	return new SbaColRowSizeItem(*this);
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SfxPoolItem* SbaColRowSizeItem::Create(SvStream& rStream, USHORT nVers) const
{
	USHORT nCompValue = 0,
		   nValue = 0;

	if (nVers > 0)
	{
		rStream >> nCompValue;
		rStream >> nValue;
	}
	else
	{
		rStream >> nCompValue;
		nValue = (USHORT)Application::GetDefaultDevice()->PixelToLogic(Point(nCompValue, 0 ), MAP_10TH_MM).X();
	}

	SbaColRowSizeItem* pItem = new SbaColRowSizeItem(Which(), nCompValue, nValue);
	pItem->nVersion = nVers;
	return pItem;
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
SvStream& SbaColRowSizeItem::Store(SvStream& rStream, USHORT nItemVersion) const
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	if (GetVersion(SOFFICE_FILEFORMAT_40) > 0)
	{
		rStream << nCompVal;
		rStream << nVal;
	}
	else
		rStream << nCompVal;

	return rStream;
}

/*--------------------------------------------------------------------------*
/
/*--------------------------------------------------------------------------*/
USHORT SbaColRowSizeItem::GetVersion(USHORT) const
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	return nVersion;
}

/*--------------------------------------------------------------------------*
/  Setzen eines neuen Wertes in 10th mm
/*--------------------------------------------------------------------------*/
void SbaColRowSizeItem::PutPixelValue(UINT16 nNewVal)
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	nVal		= (USHORT)Application::GetDefaultDevice()->PixelToLogic(Point(nNewVal,0),MAP_10TH_MM).X();;
	nCompVal	= nNewVal;
}

/*--------------------------------------------------------------------------*
/  Setzen eines neuen Wertes in 10th mm
/*--------------------------------------------------------------------------*/
void SbaColRowSizeItem::PutLogicValue(UINT16 nNewVal)
{
	DBG_CHKTHIS(SbaColRowSizeItem,NULL);
	nVal		= nNewVal;
	nCompVal	= (USHORT)Application::GetDefaultDevice()->LogicToPixel(Point(nVal,0),MAP_10TH_MM).X();
}


