/*************************************************************************
 *
 *  $RCSfile: dbobj.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "dbobj.hxx"
#include "dbstat.hxx"
#include "sbaobj.hxx"

TYPEINIT1(SbaDBObj, SdbObj);

//------------------------------------------------------------------------------
SbaDBObj::SbaDBObj(SdbObj* pObj, const String& rName, BOOL bPersist, BOOL bShowErr)
		 :SdbObj(pObj, bPersist)
		 ,aName(rName)
		 ,bShowError(bShowErr)
{
}

//------------------------------------------------------------------------------
void SbaDBObj::BeginDBAction()
{
	SBA_MOD()->BeginDBAction();
}

//------------------------------------------------------------------------------
void SbaDBObj::EndDBAction()
{
	SBA_MOD()->EndDBAction();
}

//------------------------------------------------------------------------------
void SbaDBObj::CancelDBAction()
{
	SBA_MOD()->CancelDBAction();
}

//------------------------------------------------------------------------------
void SbaDBObj::ShowError(DBErrorContext eContext)
{
	/*
	if (bShowError)
	{
		SBA_MOD()->ShowDbStatus(aStatus, eContext);
	}
	*/
}

//------------------------------------------------------------------------------
String SbaDBObj::ToURL() const
{
	static String s_sEmpty;
	return s_sEmpty;
}

#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

//------------------------------------------------------------------------------
sal_Bool SbaDBObj::EqualNamesInsensitive(const String& rLHS, const String& rRHS, LanguageType eLanguage)
{
//	String sLanguage, sCountry;
//	if (eLanguage == LANGUAGE_SYSTEM)
//		eLanguage = Application::GetAppInternational().GetLanguage();
//	ConvertLanguageToIsoNames(eLanguage, sLanguage, sCountry);
	::rtl::OUString sLeft(rLHS), sRight(rRHS);
	return sLeft.equalsIgnoreCase(sRight);
}

















