/*************************************************************************
 *
 *  $RCSfile: dbtabobj.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "sbaresid.hrc"

#include "sbadb.hxx"

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#include "dbstat.hxx"

#include "sbaexpob.hxx"

#include "sbaitems.hrc"

#include "sbaitems.hxx"

#include "dbqryobj.hxx"

#include "dbtabobj.hxx"

#include "copytbl.hxx"

#include "dlgfldmt.hxx"

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SFXCANCEL_HXX //autogen
#include <svtools/cancel.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXCANCEL_HXX //autogen
#include <svtools/cancel.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

#ifndef _SFX_PROGRESS_HXX //autogen
#include <sfx2/progress.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _SDB_SDBVIEW_HXX //autogen
#include <sdb/sdbview.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#include "sbahints.hxx"

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif

namespace staruno = com::sun::star::uno;
namespace stardata = com::sun::star::data;

IMPL_SDBKEYREFCONT_VIRT(SbaIndexMap,SbaIndexDef*);

DBG_NAME(SbaIndexDef);
//------------------------------------------------------------------------------
SbaIndexDef::SbaIndexDef(const SbaTableDef& _rTable)
			:bUnique(FALSE)
			,bSystemReadOnly(FALSE)
{
	DBG_CTOR(SbaIndexDef,NULL);
	SdbDatabase* pDatabase = _rTable.GetDatabase();
	bCase = (pDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
	aColumns = pDatabase->CreateColumns();
}

//------------------------------------------------------------------------------
SbaIndexDef::SbaIndexDef(const SbaTableDef& _rTable, const SbaIndexDef& _rIndex)
			:bUnique(_rIndex.IsUnique())
			,aName(_rIndex.GetName())
			,aQualifierName(_rIndex.GetQualifier())
			,bSystemReadOnly(_rIndex.IsSystemReadOnly())
{
	DBG_CTOR(SbaIndexDef,NULL);
	SdbDatabase* pDatabase = _rTable.GetDatabase();
	bCase = (pDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	aColumns = pDatabase->CreateColumns(*_rIndex.GetColumns());
}

//------------------------------------------------------------------------------
SbaIndexDef::SbaIndexDef(const SbaTableDef& _rTable, const SdbIndex& _rIndex)
			:bUnique(_rIndex.IsUnique())
			,aName(_rIndex.Name())
			,aQualifierName(_rIndex.Qualifier())
			,bSystemReadOnly(_rIndex.IsSystemReadOnly())
{
	DBG_CTOR(SbaIndexDef,NULL);
	SdbDatabase* pDatabase = _rTable.GetDatabase();
	bCase = (pDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	aColumns = pDatabase->CreateColumns(*_rIndex.Columns());
}

//------------------------------------------------------------------------------
SbaIndexDef::SbaIndexDef(const SbaTableDef& _rTable, const String& rQualifier, const String& rName, BOOL bUniq,BOOL bReadOnly)
			:bUnique(bUniq)
			,aName(rName)
			,aQualifierName(rQualifier)
			,bSystemReadOnly(bReadOnly)
{
	DBG_CTOR(SbaIndexDef,NULL);
	SdbDatabase* pDatabase = _rTable.GetDatabase();
	bCase = (pDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	aColumns = pDatabase->CreateColumns();
}
//------------------------------------------------------------------------------
SbaIndexDef::~SbaIndexDef()
{
	DBG_DTOR(SbaIndexDef,NULL);
}
//------------------------------------------------------------------------------
SbaIndexDef* SbaIndexDef::Clone(const SbaTableDef& _rTable) const
{
	DBG_CHKTHIS(SbaIndexDef,NULL);
	return new SbaIndexDef(_rTable, *this);
}

//------------------------------------------------------------------------------
BOOL SbaIndexDef::operator== (const SbaIndexDef& _rDef) const
{
	DBG_CHKTHIS(SbaIndexDef,NULL);
	DBG_ASSERT((this) != &_rDef,"SbaIndexDef::operator==: Es werden die selben Objekte miteinander verglichen");
	if(this == &_rDef)
		return TRUE;
	return bUnique == _rDef.bUnique && bSystemReadOnly == _rDef.bSystemReadOnly &&
		(bCase	?
				aName.Equals(_rDef.aName)&& aQualifierName.Equals(_rDef.aQualifierName)
				:
				SbaDBObj::EqualNamesInsensitive(aName, _rDef.aName) &&
				SbaDBObj::EqualNamesInsensitive(aQualifierName, _rDef.aQualifierName)
		)
		&& aColumns->Compare(*_rDef.aColumns, SDB_FLAGS_DESCENDING);
}

//------------------------------------------------------------------------------
SbaIndexList& SbaIndexList::Copy(const SbaTableDef& _rTable, const SbaIndexList& _rList)
{
	Clear();
	return Append(_rTable, _rList);
}

//------------------------------------------------------------------------------
SbaIndexList& SbaIndexList::Append(const SbaTableDef& _rTable, const SbaIndexList& _rList)
{
	for (ULONG i = 0; i < _rList.Count(); i++)
	{
		SbaIndexDef* pIdx = _rList.GetObject(i);
		InsertAt(pIdx->GetFullName(), pIdx->Clone(_rTable));
	}
	return *this;
}

//------------------------------------------------------------------------------
BOOL SbaIndexList::operator==(const SbaIndexList& _rList) const
{
	BOOL bRes = Count() == _rList.Count();
	for (ULONG i = 0; i < _rList.Count() && bRes; i++)
	{
		SbaIndexDef* pRefIdx = _rList.GetObject(i);
		SbaIndexDef* pIdx	 = GetObject(i);

		bRes = *pIdx == *pRefIdx;
	}
	return bRes;
}

//------------------------------------------------------------------------------
SbaIndexDef* SbaIndexList::Lookup(const String& _rIndexName, const String& _rQualifierName) const
{
	String aTmp; // Tempvar ist noetig da sonst Linux hier einen GPF erzeugt
	if(_rQualifierName.Len())
	{
		aTmp = _rQualifierName;
		aTmp += '.';
		aTmp += _rIndexName;
	}
	else
		aTmp = _rIndexName;

	return SbaIndexMap::Lookup(aTmp);
}


TYPEINIT1(SbaTableDef, SbaDBDataDef);
DBG_NAME(SbaTableDef);
//------------------------------------------------------------------------------
SbaTableDef::SbaTableDef(SbaDatabase* _pDB,
						 const String& _rName,
						 BOOL _bView,
						 BOOL _bNew,
						 BOOL _bShow)
						 :SbaDBDataDef(_pDB, _rName, (_bNew && _bView) ? dbView : dbTable, _bNew, _bShow)
			,pTable(NULL)
			,bNotNullAllowed(FALSE)
{
	DBG_CTOR(SbaTableDef,NULL);
	if (bNew)
	{
		if (_bView)
			pTable = (SdbTable*)_pDB->CreateObject(dbView,_rName);
		else
			pTable = (SdbTable*)_pDB->CreateObject(dbTable,_rName);
	}
	else
		pTable = (SdbTable*)_pDB->OpenObject(dbTable,_rName);

	if (pTable)
	{
		pTable->AddRef();
		if (bNew)
		// den voll qualifizierten Namen bestimmen
		{
			aName = pTable->GetFullName();
			bOpen = TRUE;
		}
		// siehe SbaDBDataDef
		USHORT nPos = 0;
		aCoreWhichList.Insert(SBA_DEF_FLTNAME,nPos++);
		aCoreWhichList.Insert(SBA_DEF_FLTTYPE,nPos++);
		aCoreWhichList.Insert(SBA_DEF_FLTLENGTH,nPos++);
		aCoreWhichList.Insert(SBA_DEF_FLTSCALE,nPos++);
		aCoreWhichList.Insert(SBA_DEF_FLTREQUIRED,nPos++);
		aCoreWhichList.Insert(SBA_DEF_FLTAUTOINCREMENT,nPos++);

		::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( _pDB->GetMetaData() );
		sal_Int16 nInfo;
		rMetaData->getInfo(::stardata::DatabaseInfo::SQL_CONFORMANCE) >>= nInfo;
		if ((nInfo & ::stardata::DatabaseSQLConformance::CORE) == ::stardata::DatabaseSQLConformance::CORE)
			aCoreWhichList.Insert(SBA_DEF_FLTPRIMARY,nPos++);

		if (_pDB->IsCapable(SDB_CAP_COL_COMMENT))
			aCoreWhichList.Insert(SBA_DEF_FLTCOMMENT,nPos++);

		bNotNullAllowed = rMetaData->isCapable(::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS);

		aOriginalIndexDefs.SetCaseSensitive(_pDB->GetIdentifierCase() == SDB_IC_OBJECT);
		aIndexDefs.SetCaseSensitive(_pDB->GetIdentifierCase() == SDB_IC_OBJECT);
	}
	else
	{
		aStatus = _pDB->Status();
		bNew = FALSE;
	}
}

//------------------------------------------------------------------------------
SbaTableDef::~SbaTableDef()
{
	DBG_DTOR(SbaTableDef,NULL);
	if (pTable)
		pTable->ReleaseRef();
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::Open()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if (IsOpen())
		return TRUE;

	BeginDBAction();
	aOriginalIndexDefs.Clear();
	aIndexDefs.Clear();
	// Oeffnen einer bestehenden Tabelle und
	// lesen der Index Informationen
	SdbColumnsRef rCols = pTable->OriginalColumns();
	if (Load(rCols.getBodyPtr(),!pTable->IsView()))
	{
		if(pTable->IsView())
		{
			SdbColumnsRef rCols = pTable->OriginalColumns();
			for (UINT16 i = 1; i < rCols->Count(); i++)
			{
				SdbColumn* pCol = (SdbColumn*)rCols->Column(i);
				SbaColumn* pSbaCol	  = GetColumn(pCol->GetName());
				// definition exitiert, dann uebernehmen, sonst neue erzeugen
				if (pSbaCol)
				{
					SFX_ITEMSET_GET(*pSbaCol, pPkKeyItem, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
					if(pPkKeyItem->GetValue())
						((SdbColumn*)pCol)->SetFlag(SDB_FLAGS_PRIMARYKEY);		 // Mu hier gemacht werden, damit eine View
					else
						((SdbColumn*)pCol)->ResetFlag(SDB_FLAGS_PRIMARYKEY);
					// geupdated werden kann. (Ist aber nicht schn! :-))
					SFX_ITEMSET_GET(*pSbaCol, pRequiredItem, SfxBoolItem, SBA_DEF_FLTREQUIRED, TRUE);
					if(pRequiredItem->GetValue())
						((SdbColumn*)pCol)->ResetFlag(SDB_FLAGS_NULLALLOWED);		 // Mu hier gemacht werden, damit eine View
					else
						((SdbColumn*)pCol)->SetFlag(SDB_FLAGS_NULLALLOWED);
					// Gilt auch f"ur Autoinkrement
					SFX_ITEMSET_GET(*pSbaCol, pAutoItem, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, TRUE);
					if(pAutoItem->GetValue())
						((SdbColumn*)pCol)->SetFlag(SDB_FLAGS_AUTOINCREMENT);		 // Mu hier gemacht werden, damit eine View
					else
						((SdbColumn*)pCol)->ResetFlag(SDB_FLAGS_AUTOINCREMENT);
				}
			}
		}
		FillIndexes();
	}

	if (aStatus.IsError())
		CancelDBAction();
	else
	{
		EndDBAction();
		bOpen = TRUE;
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::DoRefresh()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if (IsNew())
		return TRUE;

	BOOL bResult = pTable->Refresh();
	if (!bResult)
	{
		bOpen = FALSE;
		SbaDBDefHint aHint(this, SbaDBDefHint::dbDelete);
		SBA_MOD()->Broadcast(aHint);
	}
	else
	{
		bOpen = FALSE;
		bResult = Open();
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::IsDataUpdateAllowed() const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	// besteht eine Moeglichkeit, ein Object zu updaten
	UINT16 nPrivileges = pTable ? pTable->GetTablePrivileges() : 0;
	BOOL   bAllow = FALSE;
	if (nPrivileges > SDB_PR_READ)
	{
		bAllow = (nPrivileges & SDB_PR_INSERT) == SDB_PR_INSERT ||
				 (nPrivileges & SDB_PR_UPDATE) == SDB_PR_UPDATE ||
				 (nPrivileges & SDB_PR_DELETE) == SDB_PR_DELETE;
	}
	return bAllow && SbaDBDataDef::IsDataUpdateAllowed();
}

//------------------------------------------------------------------------------
void SbaTableDef::FillIndexes()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	DBG_ASSERT(pTable, "Table not opened!");
	SbaDatabase* pDatabase = GetDatabase();

	// erstmal aufraemen
	aIndexDefs.Clear();
	aOriginalIndexDefs.Clear();

	String aIndexName;
	USHORT nCount = pTable->GetIndexCount();
	for (USHORT i = 0; i < nCount; i++)
	{
		SdbIndex* pIndex = pTable->OpenIndex(pTable->GetIndexName(i));
		if (!pIndex)
			continue;

		SbaIndexDef* pIndexDef = new SbaIndexDef(*this, *pIndex);
		aOriginalIndexDefs.InsertAt(pIndex->GetFullName(),pIndexDef);
	}
	aIndexDefs.Copy(*this,aOriginalIndexDefs);
}

//------------------------------------------------------------------------------
SbaIndexDef* SbaTableDef::CreateIndexDef() const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	return GetDatabase() ? new SbaIndexDef(*this) : NULL;
}

//------------------------------------------------------------------------------
SbaIndexDef* SbaTableDef::CreateIndexDef(const SbaIndexDef& _rDef) const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	return GetDatabase() ? new SbaIndexDef(*this, _rDef) : NULL;
}
//------------------------------------------------------------------------------
SbaIndexDef* SbaTableDef::CreateIndexDef(const String& rName,const String& rQualifier,BOOL bUnique) const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	return GetDatabase() ? new SbaIndexDef(*this,rQualifier,rName,bUnique) : NULL;
}
//------------------------------------------------------------------------------
BOOL SbaTableDef::UpdateIndex(BOOL bIgnorError)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	// Das Abspeichern der Indexinformationen erfolgt folgendermaen:
	// 1.) Zuerst werden die Indizes gelscht, die nicht mehr vorkommen, bzw die geaendert wurden
	BeginDBAction();
	aStatus.Clear();

	// Wenn Indices geaendert werden, setzen manche Treiber voraus, da kein Cursor mehr auf die zugrundeliegende
	// Tabelle geoeffnet ist:
	String aIndexName;
	ULONG nCount(aOriginalIndexDefs.Count());
	ULONG i;
	for (i = nCount; i > 0; i--)
	{
		SbaIndexDef* pOrigIndexDef = aOriginalIndexDefs.GetObject(i-1);
		SbaIndexDef* pIndexDef = aIndexDefs.Lookup(pOrigIndexDef->GetFullName());
		if (!pIndexDef || (*pIndexDef != *pOrigIndexDef))
		{
			SdbIndex* pIndex = pTable->OpenIndex(pOrigIndexDef->GetFullName());
			if (pIndex && !pIndex->Drop() )
			{
				if(!bIgnorError){
					aStatus = pIndex->Status();
					break;
				}
			}
			else
				aOriginalIndexDefs.Remove(pOrigIndexDef);
		}
	}

	// 2.) Erzeugen  der neuen Indizes
	for (i = 0; ( i<aIndexDefs.Count() )&& aStatus.IsSuccessful(); i++)
	{
		SbaIndexDef* pIndexDef = aIndexDefs.GetObject(i);
		SbaIndexDef* pOrigIndexDef = aOriginalIndexDefs.Lookup(pIndexDef->GetFullName());
		if (pOrigIndexDef)
		{
			if (*pOrigIndexDef != *pIndexDef)
			{
				SdbIndex* pIndex = pTable->OpenIndex(pOrigIndexDef->GetFullName());
				if (pIndex && !pIndex->Drop())
				{
					if(!bIgnorError){
						aStatus = pIndex->Status();
						break;
					}
				}
				else
				{
					aOriginalIndexDefs.Remove(pOrigIndexDef);
					pOrigIndexDef = NULL;
				}
			}
			else
				continue;
		}

		SdbIndexRef xIndex = pTable->CreateIndex(pIndexDef->GetFullName());
		if (xIndex.Is())
		{
			if (pIndexDef->IsUnique())
				xIndex->SetStyle(SDB_IDX_UNIQUE);
			for (UINT16 j = 1; j < pIndexDef->GetColumns()->Count(); j++)
				xIndex->Columns()->AddColumn(pTable->CreateColumn(*pIndexDef->GetColumns()->Column(j)));

			if(!xIndex->Update()){
				if(!bIgnorError){
					aStatus = xIndex->Status();
					break;
				}
			}
		}

		else
		{
			if(!bIgnorError){
				aStatus = xIndex->Status();
				break;
			}
		}

	}

	if(!bIgnorError){
		BOOL bResult(aStatus.IsSuccessful());
		SdbStatus aTmpStat(aStatus);
		if (!aStatus.IsSuccessful())
		{
			CancelDBAction();
		}
		Refresh();
		aStatus = aTmpStat;
		EndDBAction();
		return bResult;
	}
	// jetzt nochmal neu einlesen
	Refresh();
	EndDBAction();
	return TRUE;

}
//------------------------------------------------------------------------------
BOOL SbaTableDef::UpdateIndex()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	SBA_CHK_OPEN_BOOL();
	return UpdateIndex(FALSE);
}

//------------------------------------------------------------------------------
void SbaTableDef::RestoreIndex()
{
	aIndexDefs.Clear();
	aIndexDefs.Copy(*this, aOriginalIndexDefs);
}
//------------------------------------------------------------------------------
BOOL SbaTableDef::RenameImpl(const String& rNewName)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	String aOldName = aName;
	BeginDBAction();
	if (!pTable->Rename(rNewName))
	{
		aStatus = pTable->Status();
		EndDBAction();
	}
	else
	{
		aName = pTable->GetFullName();
		// adrebuch anpassen
		if (DirEntry(GetDatabase()->Name()) == DirEntry(SBA_MOD()->GetAddrDBName()) &&
			aOldName == SBA_MOD()->GetAddrTableName())
			SBA_MOD()->SetAddressBookEntry(GetDatabase()->Name(), aName);
		EndDBAction();
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::Update()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	SBA_CHK_OPEN_BOOL();
	SbaDatabase* pDatabase = GetDatabase();
	BOOL bResult = TRUE;
	BOOL bUpdate = TRUE;
	if (IsNew())
	{
		for (ULONG i = 0; i < xColumns->Count(); i++)
		{
			SdbColumn* pCol = CreateColumn(*xColumns->GetObject(i));
			if (pCol)
				pTable->Columns()->AddColumn(pCol);
		}
	}
	else if (!xOriginalColumns->CompareCoreAttrs(*xColumns,*this) )
	{
		if(!pTable->IsView()) // Update nur weiter geben, wenn es keine View ist
		{
			pTable->Columns()->Reset();
			for (ULONG i = 0; i < xColumns->Count(); i++)
			{
				SdbColumn* pCol = CreateColumn(*xColumns->GetObject(i));
				if (pCol)
					pTable->Columns()->AddColumn(pCol);
			}
		}
	}
	else
		bUpdate = FALSE;

	BeginDBAction();
	// nur wenn in die Datenbank geschrieben werden kann
	// und die Tabelle erzeugt wird, ist das Erzeugen erfolgreich
	if (!BeginTrans(TRUE))
	{
		aStatus = pDatabase->Status();
		CancelDBAction();
		bResult = FALSE;
	}					// Update nur weiter geben, wenn es keine View ist
	else if (bUpdate && !pTable->IsView() && !pTable->Update())
	{
		aStatus = pTable->Status();
		bResult = FALSE;
		// wenn Fehler aufgetreten ist, muessen die Columns freigegeben werden
		SdbColumnsRef xColumns = pTable->Columns();
		if(xColumns.Is())
			xColumns->Reset();
	}

	if (!bResult || !Store() || !Commit())
	{
		// Fehlerstatus noch nachtragen
		if (bResult)
			aStatus = pDatabase->Status();

		// Erzeugte Tabelle wieder loeschen
		// da der Eintrag in die Datenbank nicht uebernommen wurde
		if (IsNew())
		{
			// Tabelle nur droppen, wenn sie auch offen und nicht mehr neu ist
			if(pTable->IsOpen() && !pTable->IsNew())
				pTable->Drop();

			// Tabelle weg schmeien, da sie geschlossen sein kann und dann haben wir keine Chance mehr.
			pTable->ReleaseRef();

			// Vorbereiten fuer einen neuen Versuch
			pTable = (SdbTable*)pDatabase->CreateObject(dbTable, aName);
			if (pTable)
				pTable->AddRef();

			bOpen = bNew = pTable != NULL;
			EndTrans(FALSE);
		}
		else
		{
			SdbStatus aTempStat(aStatus);
			EndTrans(FALSE);
			// dann zumindest die aktuellen Daten nochmals lesen
			Refresh();
			aStatus = aTempStat;
		}

		CancelDBAction();
		bResult = FALSE;
	}
	else if (bResult)
	{
		// Erneut einlesen, da Positionen der Spalten anders als vorgesehen sein
		// koennen, abhaengig vom Datenbanktreiber
		if (IsNew())
		{
			OnCreate();
			bNew = FALSE;

			// new definitions are initially locked, so decrement the lock counter as we aren't new anymore
			UnLock();
		}

		// nochmals einlesen
		bOpen   = FALSE;
		Open();
		EndDBAction();
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::Update(const String& _rSQL,BOOL bNative)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	SBA_CHK_OPEN_BOOL();
	SbaDatabase* pDatabase = GetDatabase();
	BOOL bResult = TRUE;
	BOOL bUpdate = TRUE;
	if (!IsNew() || GetKind() != dbView)
	{
		aStatus.SetSequenceError();
		return FALSE;
	}
	else
	{
		BeginDBAction();
		// nur wenn in die Datenbank geschrieben werden kann
		// und die Tabelle erzeugt wird, ist das Erzeugen erfolgreich
		if (!BeginTrans(TRUE))
		{
			aStatus = pDatabase->Status();
			CancelDBAction();
			bResult = FALSE;
		}

		if (bResult && !PTR_CAST(SdbView,pTable)->Update(_rSQL, FALSE))
		{
			aStatus = pTable->Status();
			bResult = FALSE;
		}
		if(bResult && !bNative)
		{
			SdbSqlParser* pParser = pDatabase->GetSqlParser();
			String aErrorMsg;
			SdbSqlParseNode* pParseNode = pParser->ParseTree(aErrorMsg,_rSQL,TRUE);
			if(pParseNode)
			{
				SbaParseIterator aIter(pParseNode,pDatabase);

				const SdbColumnsRef aSelectColumns(aIter.GetSelectColumns());
				for (UINT16 i = 1; i < aSelectColumns->Count(); i++)
				{
					const SdbColumn* pCol = aSelectColumns->Column(i);
					SdbColumn* pViewCol	  = (SdbColumn*)pTable->Columns()->Column(pCol->GetName());
					if (pViewCol)
					{
						INT16 nOldFlags = pViewCol->GetAllFlags();
						pViewCol->SetAllFlags(pCol->GetAllFlags());
						SbaColumn *pSbaCol = CreateColumn(*pViewCol);
						xColumns->InsertAt(pViewCol->GetName(), pSbaCol);
						pViewCol->SetAllFlags(nOldFlags);
					}
				}
				delete pParseNode;
			}
		}

		if (!bResult || !Store() || !Commit())
		{
			EndTrans(FALSE);
			CancelDBAction();
			bResult = FALSE;
		}

		if (bResult)
		{
			OnCreate();

			if (bNew)
				// new definitions are initially locked, so decrement the lock counter as we aren't new anymore
				UnLock();

			bNew = FALSE;

			//ab jetzt eine volle Tabelle, wegen url etc...
			edbObj  = dbTable;
			// nochmals einlesen
			bOpen   = FALSE;
			Open();
		}
		EndDBAction();
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::DropImpl()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if (!pTable->Drop())
		aStatus = pTable->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
SbaDataObj* SbaTableDef::CreateDataObjImpl()
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	return new SbaQueryObj(this, Name(), FALSE);
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::GetDefaultNull(SbaFieldType eType, SbaNumericSize eSizeType) const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	return !bNotNullAllowed ? TRUE : GetDatabase()->IsTypeNullable(eType, eSizeType);
}

//------------------------------------------------------------------------------
UINT32 SbaTableDef::GetDefaultLength(SbaFieldType eType) const
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	UINT32 nLength = 0;
	if (eType == dbText)
	{
		SdbTypeInfo* pInfo = GetDatabase()->IsTypeAvailable(dbText, SbaNumericSize(0));
		nLength = 50;
		if (pInfo)
			nLength = pInfo->nPrecision ? min(pInfo->nPrecision, nLength) : 50;
	}
	else if (eType == dbNumeric)
	{
		if (GetDatabase()->IsTypeAvailable(eType, dbLong))	 // long ist default
			nLength = (UINT32) dbLong;
		else
		{
			for (nLength = (UINT32)dbDouble;
				 nLength > (UINT32)dbSizeNone && !GetDatabase()->IsTypeAvailable(eType, (SbaNumericSize)nLength); nLength--);
		}
	}

	return nLength;
}

//------------------------------------------------------------------------
BOOL SbaTableDef::ConvertTypeTo( SbaFieldType eType, SbaColumn* pDestColumn)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if( !GetDatabase()->IsTypeAvailable(eType) )
		return FALSE;
	pDestColumn->Put( SbaDataFieldTypeItem(SBA_DEF_FLTTYPE, eType) );
	return TRUE;
}

//------------------------------------------------------------------------
BOOL SbaTableDef::ConvertNumericTypeTo( SbaNumericSize eSize, SbaColumn* pDestColumn)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if( !GetDatabase()->IsNumericSizeAvailable(eSize) )
		return FALSE;

	pDestColumn->Put( SbaDataFieldTypeItem(SBA_DEF_FLTTYPE, dbNumeric) );
	pDestColumn->Put( SfxUInt32Item(SBA_DEF_FLTLENGTH, eSize) );
	return TRUE;
}

//------------------------------------------------------------------------
BOOL SbaTableDef::AdjustType( SbaColumn* pSourceColumn, SbaColumn* pDestColumn)
{
	//DBG_CHKTHIS(SbaDataExchObj,NULL);

	SFX_ITEMSET_GET(*pSourceColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
	SFX_ITEMSET_GET(*pSourceColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, TRUE);
	SFX_ITEMSET_GET(*pSourceColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, TRUE);

	SbaFieldType eSrcType(pType->GetType());
	UINT32 nSrcFieldLen(pLength->GetValue());

	//////////////////////////////////////////////////////////////////////
	// Wenn die Zieldatenbank den Typen "kennt", nichts machen
	BOOL bSuccess = FALSE;
	if ( GetDatabase()->IsTypeAvailable(eSrcType) )
	{
		if(pAutoIncrement && pAutoIncrement->GetValue())
			pDestColumn->Put( SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, FALSE) );

		bSuccess = TRUE;
	}
	else
	{
		#define BREAK_SUCCESSFULL() { bSuccess = TRUE; break; }
		//////////////////////////////////////////////////////////////////////
		// ansonsten konvertieren
		switch( eSrcType )
		{
		case dbText:
			{
				::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( GetDatabase()->GetMetaData() );

				if( nSrcFieldLen <= rMetaData->getLimit(::stardata::DatabaseLimit::CHAR_LITERAL_LEN) )
				{
					if( ConvertTypeTo(dbChar, pDestColumn) )
						BREAK_SUCCESSFULL();
				}
				if( ConvertTypeTo(dbMemo, pDestColumn) )
					BREAK_SUCCESSFULL();
			}
			break;

		case dbChar:
			{
				::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( GetDatabase()->GetMetaData() );

				if( nSrcFieldLen <= rMetaData->getLimit(::stardata::DatabaseLimit::CHAR_LITERAL_LEN) )
				{
					if( ConvertTypeTo(dbText, pDestColumn) )
						BREAK_SUCCESSFULL();
				}
				if( ConvertTypeTo(dbMemo, pDestColumn) )
					BREAK_SUCCESSFULL();
			}
			break;

		case dbDateTime:
			if( ConvertTypeTo(dbDate, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbTime, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbDate:
			if( ConvertTypeTo(dbTime, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbTime:
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbNumeric:
			switch((SbaNumericSize)nSrcFieldLen)
			{
				case dbDouble:
					if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbSingle, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbCurrency, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
					break;

				case dbSingle:
					if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbSingle, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbCurrency, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
					break;

				case dbLong:
					if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbCurrency, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
					break;

				case dbInteger:
					if( ConvertTypeTo(dbCurrency, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
					break;

				case dbByte:
					if( ConvertTypeTo(dbCurrency, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
					if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
					break;
			}
			break;

		case dbCounter:
			if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbBool:
			if( ConvertNumericTypeTo(dbByte, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbDecimal:
			if( ConvertNumericTypeTo(dbDouble, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbSingle, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbCurrency:
			if( ConvertNumericTypeTo(dbDouble, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbSingle, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbDecimal, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbLong, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertNumericTypeTo(dbInteger, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbMemo, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbMemo:
			if( ConvertTypeTo(dbText, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbChar, pDestColumn) ) BREAK_SUCCESSFULL();
			break;

		case dbImage:
			if( ConvertTypeTo(dbBinary, pDestColumn) ) BREAK_SUCCESSFULL();
			if( ConvertTypeTo(dbVarBinary, pDestColumn) ) BREAK_SUCCESSFULL();
			break;
		}
	}

	// das Required-Flag eventuell anpassen
	// FS - 18.05.99 - 65576
	if (bSuccess)
	{
		SFX_ITEMSET_GET(*pSourceColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, TRUE);
		SFX_ITEMSET_GET(*pDestColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
		SFX_ITEMSET_GET(*pDestColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, TRUE);
		SdbTypeInfo* pInfo = GetDatabase()->IsTypeAvailable(pType->GetType(), pLength->GetValue());
		DBG_ASSERT(pInfo != NULL, "SbaExplorerExchObj::AdjustType : the type we converted to is not available !");
			// dann sollte nicht bSuccess gesetzt worden sein ...
		if (!pRequired->GetValue() && pInfo && !pInfo->bNullable)
		{	// die Feldbeschreibung sagt 'nicht erforderlich', fuer den Zieltypen geht das aber nicht
			// -> anpassen
			SfxBoolItem aNewRequired(TRUE);
			pDestColumn->Put(aNewRequired, SBA_DEF_FLTREQUIRED);
		}
	}
	return bSuccess;
}

//------------------------------------------------------------------------------
BOOL SbaTableDef::CopyIndexes(SbaTableDef* pSourceTableDef )
{
	DBG_CHKTHIS(SbaTableDef,NULL);
//	SBA_CHK_OPEN_BOOL();

	//////////////////////////////////////////////////////////////////////////
	// Kann neuer Index erzeugt werden?
	SbaDatabase* pDatabase = GetDatabase();

	::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( pDatabase->GetMetaData() );

	if(!rMetaData->getLimit(::stardata::DatabaseLimit::INDEX_SIZE))
		return FALSE;

	//////////////////////////////////////////////////////////////////////////
	// Kopieren der Indizes
	const SbaIndexList& rSourceIndexDefs = pSourceTableDef->GetOriginalIndexDefs();
	SbaIndexList& rDestIndexDefs = GetIndexDefs();
	// Indices anhaengen, da schon Indices (ber PrimaryKeys) bestehen koennen

	SbaIndexList aTempIndexDefs;

	INT32 nColLen(rMetaData->getLimit(::stardata::DatabaseLimit::COLUMN_NAME_LEN));

	String aTmpName,aQualName;
	for (ULONG i = 0; i < rSourceIndexDefs.Count(); i++)
	{
		SbaIndexDef* pIdx = rSourceIndexDefs.GetObject(i);
		if(!pIdx->IsSystemReadOnly())
		{

			if(pDatabase == pSourceTableDef->GetDatabase())
			{
				aTmpName = pIdx->GetName();
				aQualName = pIdx->GetQualifier();
			}
			else
			{
				aTmpName = pDatabase->ShortenTableName(pDatabase->ConvertName(pIdx->GetName()),nColLen);
				aQualName = pDatabase->ShortenTableName(pDatabase->ConvertName(pIdx->GetQualifier()),nColLen);
			}

			sal_Int16 nUsage;
			rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nUsage;

			SbaIndexDef* pTmpIdx = CreateIndexDef(aTmpName,nUsage ? aQualName : String(), pIdx->IsUnique());
			SdbColumnsRef rCols = pIdx->GetColumns();

			for(ULONG j=1;j<rCols->Count();j++)
			{

				if(pDatabase == pSourceTableDef->GetDatabase())
					aTmpName = (*rCols)[j]->GetName();
				else
					aTmpName = pDatabase->ShortenTableName(pDatabase->ConvertName((*rCols)[j]->GetName()),nColLen);

				SdbColumn *pCol = pDatabase->CreateColumn(aTmpName,(*rCols)[j]->GetType(),
					(*rCols)[j]->GetLength(),(*rCols)[j]->GetScale(),(*rCols)[j]->GetAllFlags());

				pCol->SetFormatKey((*rCols)[j]->GetFormatKey());
				pTmpIdx->GetColumns()->InsertColumn(pCol,j);
			}
			aTempIndexDefs.InsertAt(pTmpIdx->GetFullName(),pTmpIdx );
		}
	}

	rDestIndexDefs.Append(*this, aTempIndexDefs);

	return IsIndexModified() ? UpdateIndex(TRUE) : TRUE;
}
//------------------------------------------------------------------------------
BOOL SbaTableDef::CopyStructure( SbaTableDef* pSourceDef )
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	if (!pSourceDef || !pSourceDef->IsOpen() )
		return FALSE;
	PutObjAttrs(*pSourceDef->GetObjAttrs());
	return CopyStructure(pSourceDef->GetOriginalColumns(),pSourceDef->GetDatabase());
}
//------------------------------------------------------------------------------
BOOL SbaTableDef::CopyStructure(const SbaColumnList& rSourceList,const SbaDatabase* pSourceDatabase,void* _pColumnsPos)
{
	DBG_CHKTHIS(SbaTableDef,NULL);
	BOOL bAutoAdjust = FALSE;

	//////////////////////////////////////////////////////////////////////
	// Fehlercodes definieren
	USHORT nError(0);
	const USHORT ERROR_PRIMKEYS_NOTAVAILABLE	= 1;
	const USHORT ERROR_MISSING_VALID_FIELDS		= 2;

	//////////////////////////////////////////////////////////////////////
	// Spaltenstruktur kopieren

	::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( GetDatabase()->GetMetaData() );

	INT32 nMaxNameLen(rMetaData->getLimit(::stardata::DatabaseLimit::COLUMN_NAME_LEN));

	String aFieldName;
	SbaColumnList& rDestList = GetColumns();

	SbaColumn* pSourceColumn;
	SbaColumn* pDestColumn;

	DlgFieldMatch	dlgMissingFields(GetpApp()->GetDefDialogParent());
	ListBox*		pInfoBox = dlgMissingFields.GetInfoBox();
	BOOL			bMissingAnyFields = FALSE;

	INT32 nMaxCharRecLen(rMetaData->getLimit(::stardata::DatabaseLimit::CHAR_LITERAL_LEN));
	INT32 nMaxBinRecLen(rMetaData->getLimit(::stardata::DatabaseLimit::BINARAY_LITERAL_LEN));

	ULONG nCountDel = rSourceList.Count();

	for (ULONG i = 0; i < rSourceList.Count(); i++)
	{
		pSourceColumn = rSourceList.GetObject(i);
		pDestColumn = (SbaColumn*)pSourceColumn->Clone(TRUE, GetPool());
		SFX_ITEMSET_GET(*pSourceColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
		SFX_ITEMSET_GET(*pSourceColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, TRUE);
		SFX_ITEMSET_GET(*pSourceColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, TRUE);
		SFX_ITEMSET_GET(*pSourceColumn, pPrimKey, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);

		//////////////////////////////////////////////////////////////////////
		// Anpassung von ueberlangen Feldern
		UINT32 nFieldLength(pLength->GetValue());
		switch( pType->GetValue() )
		{
		case dbText:
		case dbChar:
			if( nMaxCharRecLen && (nFieldLength>nMaxCharRecLen) )
				pDestColumn->Put( SfxUInt32Item(SBA_DEF_FLTLENGTH, nMaxCharRecLen) );
			break;
		case dbBinary:
		case dbVarBinary:
			if( nMaxBinRecLen && (nFieldLength>nMaxBinRecLen) )
				pDestColumn->Put( SfxUInt32Item(SBA_DEF_FLTLENGTH, nMaxBinRecLen) );
			break;
		};

		//////////////////////////////////////////////////////////////////////
		// Anpassung von ueberlangen Feldnamen
		aFieldName = pName->GetValue();
		// nur anpassen, wenn die Datenbanken unterschiedlich sind
		if(GetDatabase() != pSourceDatabase)
			aFieldName = GetDatabase()->ConvertName(aFieldName);

		if( nMaxNameLen && (aFieldName.Len() > nMaxNameLen) )
		{
			String aLongName( aFieldName);
			aFieldName = rDestList.ShortenFieldName( aFieldName, nMaxNameLen);
			if( !bAutoAdjust )
			{
				DlgLongName aDlg( GetpApp()->GetDefDialogParent(), aFieldName, aLongName, bAutoAdjust, this );
				if( !aDlg.Execute() )
					return FALSE;
			}
		}

		//////////////////////////////////////////////////////////////////////
		// Neue Feldnamen in Spaltenbeschreibung uebernehmen
		//aFieldNameList.Insert( new SbaCopyTableInfo(aFieldName,rDestList.Count()+1, i+1), LIST_APPEND );
		pDestColumn->Put( SbaNameItem(SBA_DEF_FLTNAME, aFieldName, FALSE) );

		//////////////////////////////////////////////////////////////////////
		// Anpassen des Primary-Key Flags
		::staruno::Reference< ::stardata::XDatabaseDescriptor >  rMetaData( GetDatabase()->GetMetaData() );
		sal_Int16 nInfo;
		rMetaData->getInfo(::stardata::DatabaseInfo::SQL_CONFORMANCE) >>= nInfo;
		if (!(nInfo & stardata::DatabaseSQLConformance::CORE))
		{
			BOOL bPrimKey(pPrimKey->GetValue());
			if( bPrimKey )
			{
				pDestColumn->Put( SfxBoolItem(SBA_DEF_FLTPRIMARY, FALSE) );
				nError = ERROR_PRIMKEYS_NOTAVAILABLE;
			}
		}

		//////////////////////////////////////////////////////////////////////
		// Anpassung der Feldtypen, falls Zieldatenbank Typ nicht verarbeiten kann
		if (AdjustType(pSourceColumn, pDestColumn))
			rDestList.InsertAt( aFieldName, pDestColumn );
		else
		{
			pDestColumn->AddRef();
			while (pDestColumn->ReleaseRef() > 0)
				;
			pInfoBox->InsertEntry( aFieldName );
			//delete aFieldNameList.Remove(aFieldNameList.Count() - 1);
			if(_pColumnsPos)
				(*(vector<ULONG>*)_pColumnsPos)[i] = CONTAINER_ENTRY_NOTFOUND;
			--nCountDel;
			bMissingAnyFields = TRUE;
		}
	}

	// ueberhaupt Felder ?
	if (nCountDel == 0)
		nError = ERROR_MISSING_VALID_FIELDS;
	// alles Felder ohne einige nicht kopierbar ?
	else if (bMissingAnyFields)
		dlgMissingFields.Execute();

	//////////////////////////////////////////////////////////////////////
	// Fehlermeldungen

	Window* pAppWindow = GetpApp()->GetDefDialogParent();
	switch( nError )
	{
		case ERROR_PRIMKEYS_NOTAVAILABLE:
			SbaMsgBox( pAppWindow, String(SbaResId(SBA_ERRORBOX_COPYSTRUCTURE_TITLE)),
				   String(SbaResId(SBA_ERR_PRIMKEYS_NOTAVAILABLE)), WB_OK ).Execute();
			break;
		case ERROR_MISSING_VALID_FIELDS:
			SbaMsgBox( pAppWindow, String(SbaResId(SBA_ERRORBOX_COPYSTRUCTURE_TITLE)),
				   String(SbaResId(SBA_ERR_FIELDS_TYPES_INVALID)), WB_OK ).Execute();
			return FALSE;
	}

	BOOL bRes = Update();

	if(!bRes) // I have to reset the columns
	{
		rDestList.Clear();
	}
	return bRes;
}
















