/*************************************************************************
 *
 *  $RCSfile: impexp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#define ENABLE_BYTESTRING_STREAM_OPERATORS

#include "impexp.hxx"

#include "sbaitems.hrc"
#include "sbaitems.hxx"

#ifndef _SDB_SDBCURS_HXX //autogen
#include <sdb/sdbcurs.hxx>
#endif

#ifndef _RTFKEYWD_HXX
#include <svtools/rtfkeywd.hxx>
#endif

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _HTMLOUT_HXX //autogen
#include <svtools/htmlout.hxx>
#endif

#ifndef _FRMHTMLW_HXX //autogen
#include <sfx2/frmhtmlw.hxx>
#endif

#ifndef _HTMLKYWD_HXX
#include <svtools/htmlkywd.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_FONT_HXX //autogen
#include <vcl/font.hxx>
#endif

#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif

#ifndef _SFXDOCINF_HXX //autogen
#include <sfx2/docinf.hxx>
#endif

#include "sbartf.hxx"
#include "sbahtml.hxx"

#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE		// ohne das bekomme ich einen Compiler-Fehler in <svtools/zforlist.hxx>
#include <svtools/zforlist.hxx>
#endif

#ifndef _ZFORMAT_HXX //autogen
#include <svtools/zformat.hxx>
#endif

#ifndef _DBWHICH_HRC
#include "dbwhich.hrc"
#endif

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif

#ifndef _SVX_UDLNITEM_HXX //autogen
#include <svx/udlnitem.hxx>
#endif

#ifndef _SVX_SHDDITEM_HXX //autogen
#include <svx/shdditem.hxx>
#endif

#ifndef _SVX_CRSDITEM_HXX //autogen
#include <svx/crsditem.hxx>
#endif

#ifndef _SVX_ITEM_HXX //autogen
#include <svx/cntritem.hxx>
#endif

#ifndef _SVX_WGHTITEM_HXX //autogen
#include <svx/wghtitem.hxx>
#endif

#ifndef _SVX_POSTITEM_HXX //autogen
#include <svx/postitem.hxx>
#endif

#ifndef _SVX_FONTITEM_HXX //autogen
#include <svx/fontitem.hxx>
#endif

#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif

#if defined(MAC)
const char __FAR_DATA SbaImportExport::sNewLine = '\015';
#elif defined(UNX)
const char __FAR_DATA SbaImportExport::sNewLine = '\012';
#else
const char __FAR_DATA SbaImportExport::sNewLine[] = "\015\012";
#endif

const static char __FAR_DATA sMyBegComment[]	= "<!-- ";
const static char __FAR_DATA sMyEndComment[]	= " -->";
const static char __FAR_DATA sFontFamily[]		= "font-family: ";
const static char __FAR_DATA sFontSize[]		= "font-size: ";

#define SBA_FORMAT_SELECTION_COUNT	4

DBG_NAME(SbaImportExport);
//======================================================================
SbaImportExport::SbaImportExport(SvStream &rStream,SbaDBDef& rDBDef,const String& rExchange)
	: m_aStream(rStream)
	,m_rDBDef(&rDBDef)
	,m_pReader(NULL)
	,m_pRowMarker(NULL)
{

	DBG_CTOR(SbaImportExport,NULL);

	SfxItemSet* pSet = ((SbaDBDataDef*)&m_rDBDef)->GetObjAttrs();
	const SfxPoolItem* pAnyItem;

	// Farbe
	pAnyItem = &pSet->Get(SBA_BRW_FONTCOLOR);
	const SvxColorItem* pColorItem = (SvxColorItem*)pAnyItem;

	// Font
	pAnyItem = &pSet->Get( SBA_BRW_FONT );
	const SvxFontItem* pFontItem = (SvxFontItem*)pAnyItem;

	// Zeichenstaerke
	pAnyItem = &pSet->Get( SBA_BRW_FONTWEIGHT );
	const SvxWeightItem* pWeightItem = (SvxWeightItem*)pAnyItem;

	// Fontgroesse
	pAnyItem = &pSet->Get( SBA_BRW_FONTHEIGHT );
	const SvxFontHeightItem* pFontHeightItem = (SvxFontHeightItem*)pAnyItem;

	// Kursiv
	pAnyItem = &pSet->Get( SBA_BRW_POSTURE );
	const SvxPostureItem* pFontItalicItem = (SvxPostureItem*)pAnyItem;

	// Schatten
	pAnyItem = &pSet->Get( SBA_BRW_SHADOWED );
	const SvxShadowedItem* pFontShadowItem = (SvxShadowedItem*)pAnyItem;

	// Contour
	pAnyItem = &pSet->Get( SBA_BRW_CONTOUR );
	const SvxContourItem* pFontContourItem = (SvxContourItem*)pAnyItem;

	// Underline
	pAnyItem = &pSet->Get( SBA_BRW_UNDERLINE );
	const SvxUnderlineItem* pFontUnderlineItem = (SvxUnderlineItem*)pAnyItem;

	// Strikeout
	pAnyItem = &pSet->Get( SBA_BRW_CROSSEDOUT );
	const SvxCrossedOutItem* pFontCrossedOutItem = (SvxCrossedOutItem*)pAnyItem;

	m_aFont.SetFamily( pFontItem->GetFamily() );
	m_aFont.SetName( pFontItem->GetFamilyName() );
	m_aFont.SetStyleName( pFontItem->GetStyleName() );
	m_aFont.SetCharSet( pFontItem->GetCharSet() );

	m_aFont.SetColor( pColorItem->GetValue() );
	m_aFont.SetWeight( pWeightItem->GetWeight() );
	m_aFont.SetItalic( pFontItalicItem->GetPosture() );
	m_aFont.SetUnderline( pFontUnderlineItem->GetUnderline() );

	m_aFont.SetShadow( pFontShadowItem->GetValue() );
	m_aFont.SetOutline( pFontContourItem->GetValue() );
	m_aFont.SetStrikeout( pFontCrossedOutItem->GetStrikeout() );

	UINT32 nHeight = pFontHeightItem->GetHeight();
	Size aSize(Size(0, nHeight));
	m_aFont.SetSize(aSize);

	xub_StrLen nCount = rExchange.GetTokenCount(char(11));
	if( nCount > SBA_FORMAT_SELECTION_COUNT && rExchange.GetToken(4).Len())
	{
		m_pRowMarker = new ULONG[nCount-SBA_FORMAT_SELECTION_COUNT];
		for(xub_StrLen i=SBA_FORMAT_SELECTION_COUNT;i<nCount;++i)
			m_pRowMarker[i-SBA_FORMAT_SELECTION_COUNT] = rExchange.GetToken(i,char(11)).ToInt32();
	}

}
//-------------------------------------------------------------------
SbaImportExport::~SbaImportExport()
{
	if(m_pReader)
		((SvRefBase*)m_pReader)->ReleaseRef();
	delete m_pRowMarker;
	DBG_DTOR(SbaImportExport,NULL);
}
//======================================================================
BOOL SbaRTFImportExport::Write()
{
	SbaDataObjRef pDataObj = ((SbaDBDataDef*)&m_rDBDef)->CreateDataObj();
	if(!pDataObj->Open())
		return FALSE;
	SdbCursorRef xDestCursor = pDataObj->GetCursor();
/*
		m_rDBDef->GetDatabase()->CreateCursor( SDB_SNAPSHOT, SDB_FORWARDONLY );
	String aDestTableName( m_rDBDef->Name());
	if(m_rDBDef->GetKind() == dbQuery)
		xDestCursor->Open(((SbaQueryDef*)&m_rDBDef)->Statement(), FALSE);
	else
		xDestCursor->Open(aDestTableName, TRUE);
*/
	if(!xDestCursor->IsOpen())
		return FALSE;

	m_aStream << '{'		<< sRTF_RTF;
#ifdef MAC
	m_aStream << sRTF_MAC	<< sNewLine;
#else
	m_aStream << sRTF_ANSI	<< sNewLine;
#endif

	/*
	// Access RTF Export Beispiel
	{\rtf1\ansi
		{\colortbl\red0\green0\blue0;\red255\green255\blue255;\red192\green192\blue192;}
		{\fonttbl\f0\fcharset0\fnil MS Sans Serif;\f1\fcharset0\fnil Arial;\f2\fcharset0\fnil Arial;}
		\trowd\trgaph40\clbrdrl\brdrs\brdrcf0\clbrdrt\brdrs\brdrcf0\clbrdrb\brdrs\brdrcf0\clbrdrr\brdrs\brdrcf0\clshdng10000\clcfpat2\cellx1437\clbrdrl\brdrs\brdrcf0\clbrdrt\brdrs\brdrcf0\clbrdrb\brdrs\brdrcf0\clbrdrr\brdrs\brdrcf0\clshdng10000\clcfpat2\cellx2874
		{
			\trrh-270\pard\intbl
				{\qc\fs20\b\f1\cf0\cb2 text\cell}
				\pard\intbl
				{\qc\fs20\b\f1\cf0\cb2 datum\cell}
				\pard\intbl\row
		}
		\trowd\trgaph40\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx1437\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx2874
		{\trrh-270\pard\intbl
			{\ql\fs20\f2\cf0\cb1 heute\cell}
			\pard\intbl
			{\qr\fs20\f2\cf0\cb1 10.11.98\cell}
			\pard\intbl\row
		}
		\trowd\trgaph40\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx1437\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx2874
		{\trrh-270\pard\intbl
			{\ql\fs20\f2\cf0\cb1 morgen\cell}
			\pard\intbl
			{\qr\fs20\f2\cf0\cb1 11.11.98\cell}
			\pard\intbl\row
		}
		\trowd\trgaph40\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx1437\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx2874
		{\trrh-270\pard\intbl
			{\ql\fs20\f2\cf0\cb1 bruder\cell}
			\pard\intbl
			{\qr\fs20\f2\cf0\cb1 21.04.98\cell}
			\pard\intbl\row
		}
		\trowd\trgaph40
		\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx
		\clbrdrl\brdrs\brdrcf2\clbrdrt\brdrs\brdrcf2\clbrdrb\brdrs\brdrcf2\clbrdrr\brdrs\brdrcf2\clshdng10000\clcfpat1\cellx2874
		{\trrh-270\pard\intbl
			{\ql\fs20\f2\cf0\cb1 vater\cell}
			\pard\intbl
			{\qr\fs20\f2\cf0\cb1 28.06.98\cell}
			\pard\intbl\row
		}
	}
	*/

	BOOL bBold			= ( WEIGHT_NORMAL	!= m_aFont.GetWeight() );
	BOOL bItalic		= ( ITALIC_NONE		!= m_aFont.GetItalic() );
	BOOL bUnderline		= ( UNDERLINE_NONE	!= m_aFont.GetUnderline() );
	BOOL bStrikeout		= ( STRIKEOUT_NONE	!= m_aFont.GetStrikeout() );

	const Color &aColor = m_aFont.GetColor();

	ByteString aFonts(m_aFont.GetName().GetBuffer(), gsl_getSystemTextEncoding());
		// TODO : think about the encoding of the font name
	ByteString aFormat("\\fcharset0\\fnil ");
	ByteString aFontNr;

	m_aStream	<< "{\\fonttbl";
	for(xub_StrLen j=0;j<aFonts.GetTokenCount();++j)
	{
		aFontNr = "\\f";
		aFontNr += ByteString::CreateFromInt32(j);
		m_aStream << aFontNr;
		m_aStream << aFormat;
		m_aStream << aFonts.GetToken(j);
		m_aStream << ';';
	}
	m_aStream << "}" ;
	m_aStream << sNewLine;
	m_aStream << "{\\colortbl\\red"	<< ByteString::CreateFromInt32((UINT32)aColor.GetRed())
						<< "\\green"	<< ByteString::CreateFromInt32((UINT32)aColor.GetGreen())
						<< "\\blue"		<< ByteString::CreateFromInt32((UINT32)aColor.GetBlue())
						<< ";\\red255\\green255\\blue255;\\red192\\green192\\blue192;}"		<< sNewLine;

	UINT32 nCellx = 1437;
	ByteString aRowDef("\\trowd\\trgaph40");
	ByteString aTRRH("\\trrh-270\\pard\\intbl");
	ByteString aFS("\\fs20\\f0\\cf0\\cb2");
	ByteString aFS2("\\fs20\\f1\\cf0\\cb1");
	ByteString aCell1("\\clbrdrl\\brdrs\\brdrcf0\\clbrdrt\\brdrs\\brdrcf0\\clbrdrb\\brdrs\\brdrcf0\\clbrdrr\\brdrs\\brdrcf0\\clshdng10000\\clcfpat2\\cellx");
	ByteString aCell2("\\clbrdrl\\brdrs\\brdrcf2\\clbrdrt\\brdrs\\brdrcf2\\clbrdrb\\brdrs\\brdrcf2\\clbrdrr\\brdrs\\brdrcf2\\clshdng10000\\clcfpat1\\cellx");

	m_aStream << aRowDef	<< sNewLine;

	UINT32 nCount = xDestCursor->GetColumns()->Count();

	ULONG i;
	for(i=1;i<nCount;++i)
	{
		m_aStream << aCell1;
		m_aStream << ByteString::CreateFromInt32(i*nCellx);
		m_aStream << sNewLine;
	}

	// Spaltenbeschreibung
	m_aStream << '{' << sNewLine;
	m_aStream << aTRRH;

	SbaColumnList &aList = ((SbaDBDataDef*)&m_rDBDef)->GetColumns();
	ByteString* pHorzChar = new ByteString[nCount];

	for(i=1;i<nCount;++i)
	{
		SbaColumn *pColumn = aList.GetObject(i-1);
		SFX_ITEMSET_GET(*pColumn, pHorJustify, SvxHorJustifyItem, SBA_ATTR_ALIGN_HOR_JUSTIFY, TRUE);
		const char* pChar;

		switch( pHorJustify->GetValue() )
		{
			case SVX_HOR_JUSTIFY_CENTER:	pChar = sRTF_QC;	break;
			case SVX_HOR_JUSTIFY_BLOCK:		pChar = sRTF_QJ;	break;
			case SVX_HOR_JUSTIFY_RIGHT:		pChar = sRTF_QR;	break;
			case SVX_HOR_JUSTIFY_STANDARD:
			case SVX_HOR_JUSTIFY_LEFT:
			case SVX_HOR_JUSTIFY_REPEAT:
			default:						pChar = sRTF_QL;	break;
		}

		pHorzChar[i-1] = pChar; // um sp"ater nicht immer im ITEMSET zuw"uhlen

		m_aStream << sNewLine;
		m_aStream << '{';
		m_aStream << pChar;

		if ( bBold )		m_aStream << sRTF_B;
		if ( bItalic )		m_aStream << sRTF_I;
		if ( bUnderline )	m_aStream << sRTF_UL;
		if ( bStrikeout )	m_aStream << sRTF_STRIKE;

		m_aStream << aFS;
		m_aStream << ' ';
		m_aStream << ByteString((*xDestCursor->GetColumns())[i]->GetName().GetBuffer(), gsl_getSystemTextEncoding());
			// TODO : think about the encoding of the column name
		m_aStream << sRTF_CELL;
		m_aStream << '}';
		m_aStream << sNewLine;
		m_aStream << sRTF_PARD	<< sRTF_INTBL;
	}

	m_aStream << sRTF_ROW;
	m_aStream << sNewLine << '}';
	m_aStream << sNewLine;

	ULONG k=1;
	ULONG kk=0;
	while(xDestCursor->IsInRange())
	{
		if(!m_pRowMarker || m_pRowMarker[kk] == k)
		{
			ODbRow& rRow = *xDestCursor->GetRow();
			++kk;
			m_aStream << aRowDef	<< sNewLine;

			for(i=1;i<nCount;++i)
			{
				m_aStream << aCell2;
				m_aStream << ByteString::CreateFromInt32(i*nCellx);
				m_aStream << sNewLine;
			}

			m_aStream << '{';
			m_aStream << aTRRH;
			for(ULONG i=1;i<nCount;++i)
			{
				m_aStream << sNewLine;
				m_aStream << '{';
				m_aStream << pHorzChar[i-1];

				if ( bBold )		m_aStream << sRTF_B;
				if ( bItalic )		m_aStream << sRTF_I;
				if ( bUnderline )	m_aStream << sRTF_UL;
				if ( bStrikeout )	m_aStream << sRTF_STRIKE;

				m_aStream << aFS2;
				m_aStream << ' ';

				try
				{
					ODbVariantRef xVar = rRow[i];
					if (xVar.is() && !xVar->isNull())
					{
						String aStr = xVar->toString().getStr();
						m_aStream << ByteString(aStr, gsl_getSystemTextEncoding());
							// TODO : think about the encoding of the value string
					}
				}
				catch (...)
				{
				}				

				m_aStream << sRTF_CELL;
				m_aStream << '}';
				m_aStream << sNewLine;
				m_aStream << sRTF_PARD	<< sRTF_INTBL;
			}
			m_aStream << sRTF_ROW << sNewLine;
			m_aStream << '}';
		}
		++k;
		xDestCursor->Next();
	}

	delete [] pHorzChar;

	m_aStream << '}' << sNewLine;
	m_aStream << (BYTE) 0;
	return (m_aStream.GetError() == SVSTREAM_OK);
}
//-------------------------------------------------------------------
BOOL SbaRTFImportExport::Read()
{
	m_pReader = new SbaRTFReader(m_aStream,m_rDatabase);
	((SbaRTFReader*)m_pReader)->AddRef();
	SvParserState eState = ((SbaRTFReader*)m_pReader)->CallParser();
	((SbaRTFReader*)m_pReader)->ReleaseRef();

	return eState != SVPAR_ERROR;
}
//-------------------------------------------------------------------
//===================================================================
const USHORT __FAR_DATA SbaHTMLImportExport::nDefaultFontSize[SBA_HTML_FONTSIZES] =
{
	HTMLFONTSZ1_DFLT, HTMLFONTSZ2_DFLT, HTMLFONTSZ3_DFLT, HTMLFONTSZ4_DFLT,
	HTMLFONTSZ5_DFLT, HTMLFONTSZ6_DFLT, HTMLFONTSZ7_DFLT
};

USHORT SbaHTMLImportExport::nFontSize[SBA_HTML_FONTSIZES] = { 0 };

const USHORT SbaHTMLImportExport::nCellSpacing = 0;
const char __FAR_DATA SbaHTMLImportExport::sIndentSource[nIndentMax+1] = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";

//========================================================================
// Makros fuer HTML-Export
//========================================================================
#define OUT_PROLOGUE()		(m_aStream << sHTML30_Prologue << sNewLine << sNewLine)
#define TAG_ON( tag )		HTMLOutFuncs::Out_AsciiTag( m_aStream, tag )
#define TAG_OFF( tag )		HTMLOutFuncs::Out_AsciiTag( m_aStream, tag, FALSE )
#define OUT_STR( str )		HTMLOutFuncs::Out_String( m_aStream, str )
#define OUT_LF()			m_aStream << sNewLine << GetIndentStr()
#define lcl_OUT_LF() 		m_aStream << sNewLine
#define TAG_ON_LF( tag )	(TAG_ON( tag ) << sNewLine << GetIndentStr())
#define TAG_OFF_LF( tag )	(TAG_OFF( tag ) << sNewLine << GetIndentStr())
#define OUT_HR()			TAG_ON_LF( sHTML_horzrule )
#define OUT_COMMENT( comment )	(m_aStream << sMyBegComment, OUT_STR( comment ) << sMyEndComment << sNewLine << GetIndentStr())
#define lcl_OUT_COMMENT( comment )	(m_aStream << sMyBegComment, OUT_STR( comment ) << sMyEndComment << sNewLine)

//-------------------------------------------------------------------
SbaHTMLImportExport::SbaHTMLImportExport(SvStream &rStream,SbaDBDef& rDBDef,const String& rExchange) : SbaImportExport(rStream,rDBDef,rExchange)
	,nIndent(0)
#if DBG_UTIL
	,m_bCheckFont(FALSE)
#endif
{
	strcpy( sIndent, sIndentSource );
	sIndent[0] = 0;
}
//-------------------------------------------------------------------
BOOL SbaHTMLImportExport::Write()
{
	m_aStream << '<' << sHTML_doctype << ' ' << sHTML_doctype32 << '>' << sNewLine << sNewLine;
	TAG_ON_LF( sHTML_html );
	WriteHeader();
	OUT_LF();
	WriteBody();
	OUT_LF();
	TAG_OFF_LF( sHTML_html );

	return (m_aStream.GetError() == SVSTREAM_OK);
}
//-------------------------------------------------------------------
BOOL SbaHTMLImportExport::Read()
{
	m_pReader = new SbaHTMLReader(m_aStream,m_rDatabase);
	((SbaHTMLReader*)m_pReader)->AddRef();
	SvParserState eState = ((SbaHTMLReader*)m_pReader)->CallParser();
	((SbaHTMLReader*)m_pReader)->ReleaseRef();

	return eState != SVPAR_ERROR;
}
//-------------------------------------------------------------------
void SbaHTMLImportExport::WriteHeader()
{
	const International&	 rInter		= Application::GetAppInternational();
	SfxDocumentInfo rInfo;
	rInfo.SetTitle(m_rDBDef->Name());
	String	aStrOut;

	IncIndent(1); TAG_ON_LF( sHTML_head );

	SfxFrameHTMLWriter::Out_DocInfo( m_aStream, &rInfo, sIndent );
	OUT_LF();
	/*
	TAG_ON( sHTML_title );
	m_aStream << m_rDBDef->Name();
	TAG_OFF_LF( sHTML_title );
	*/
	IncIndent(-1); OUT_LF(); TAG_OFF_LF( sHTML_head );
}
//-----------------------------------------------------------------------
void SbaHTMLImportExport::WriteBody()
{

	IncIndent(1); TAG_ON_LF( sHTML_style );

	m_aStream << sMyBegComment; OUT_LF();
	m_aStream << sHTML_body << " { " << sFontFamily << '\"' << ByteString(m_aFont.GetName(), gsl_getSystemTextEncoding()) << '\"';
		// TODO : think about the encoding of the font name
	m_aStream << "; " << sFontSize << ByteString::CreateFromInt32(m_aFont.GetSize().B()) << '}';
	OUT_LF();
	m_aStream << sMyEndComment;
	IncIndent(-1); OUT_LF(); TAG_OFF_LF( sHTML_style );
	OUT_LF();

	// default Textfarbe schwarz
	m_aStream << '<' << sHTML_body << ' ' << sHTML_O_text << '=';
	HTMLOutFuncs::Out_Color( m_aStream, m_aFont.GetColor() );

	ByteString sOut( ' ' );
	(sOut += sHTML_O_bgcolor) += '=';
	m_aStream	<< sOut;
	HTMLOutFuncs::Out_Color( m_aStream, m_aFont.GetFillColor() );

	m_aStream << '>'; OUT_LF();

	WriteTables();

	TAG_OFF_LF( sHTML_body );
}
//-----------------------------------------------------------------------
void SbaHTMLImportExport::WriteTables()
{
	ByteString aStrOut  = sHTML_table;
	aStrOut += ' ';
	aStrOut += sHTML_frame;
	aStrOut += '=';
	aStrOut += sHTML_TF_void;

	(((aStrOut	+= ' ')		+= sHTML_O_align)			+= '=')	+= sHTML_AL_left;
	(((aStrOut	+= ' ' )	+= sHTML_O_cellspacing )	+= '=')	+= ByteString::CreateFromInt32(nCellSpacing);
	(((aStrOut	+= ' ' )	+= sHTML_O_cols )			+= '=')	+= ByteString::CreateFromInt32(((SbaDBDataDef*)&m_rDBDef)->GetColumns().Count());
	((aStrOut	+= ' ')		+= sHTML_O_border)			+= "=1";
	IncIndent(1);
	TAG_ON( aStrOut.GetBuffer() );

	FontOn();

	TAG_ON( sHTML_caption );
	TAG_ON( sHTML_bold );
	m_aStream	<< ByteString(m_rDBDef->Name(), gsl_getSystemTextEncoding());
		// TODO : think about the encoding of the name
	TAG_OFF( sHTML_bold );
	TAG_OFF( sHTML_caption );

	FontOff();
	OUT_LF();
	// </FONT>

	IncIndent(1);
	TAG_ON_LF( sHTML_thead );

	IncIndent(1);
	TAG_ON_LF( sHTML_tablerow );

	SbaColumnList &aList = ((SbaDBDataDef*)&m_rDBDef)->GetColumns();
	ULONG* pFormat = new ULONG[aList.Count()];

	char **pHorJustify = new char*[aList.Count()];
	USHORT *pColWidth = new USHORT[aList.Count()];

	const SbaColRowSizeItem* pRowHeightItem = (const SbaColRowSizeItem*)&((SbaDBDataDef*)&m_rDBDef)->GetObjAttrs()->Get( SBA_DEF_ROWHEIGHT );
	USHORT nHeight = pRowHeightItem->GetPixelValue();

	// 1. die Spaltenbeschreibung rauspusten
	for(ULONG i=0;i<aList.Count();++i)
	{

		SbaColumn *pColumn = aList.GetObject(i);
		SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE );

		SFX_ITEMSET_GET(*pColumn, pColumnWidth, SbaColRowSizeItem, SBA_DEF_FLTCOLWIDTH, TRUE);
		pColWidth[i] = pColumnWidth->GetPixelValue();

		SFX_ITEMSET_GET(*pColumn, pHorJustifyItem, SvxHorJustifyItem, SBA_ATTR_ALIGN_HOR_JUSTIFY, TRUE);
		switch( pHorJustifyItem->GetValue() )
		{
			case SVX_HOR_JUSTIFY_CENTER:	pHorJustify[i] = sHTML_AL_center;	break;
			case SVX_HOR_JUSTIFY_BLOCK:		pHorJustify[i] = sHTML_AL_justify;	break;
			case SVX_HOR_JUSTIFY_RIGHT:		pHorJustify[i] = sHTML_AL_right;	break;
			case SVX_HOR_JUSTIFY_LEFT:
			case SVX_HOR_JUSTIFY_REPEAT:
			case SVX_HOR_JUSTIFY_STANDARD:
			default:						pHorJustify[i] = sHTML_AL_left;		break;
		}

		SFX_ITEMSET_GET( *pColumn, pFormatS, SfxUInt32Item, SBA_DEF_FMTVALUE, TRUE );
		pFormat[i] = pFormatS->GetValue();

		if(i == aList.Count()-1)
			IncIndent(-1);

		WriteCell(pFormat[i],pColWidth[i],nHeight,pHorJustify[i],pName->GetValue(),sHTML_tableheader);
	}


	IncIndent(-1);
	TAG_OFF_LF( sHTML_tablerow );
	TAG_OFF_LF( sHTML_thead );

	IncIndent(1);
	TAG_ON_LF( sHTML_tbody );

	// 2. und jetzt die Daten
	SbaDataObjRef pDataObj = ((SbaDBDataDef*)&m_rDBDef)->CreateDataObj();
	if(!pDataObj->Open())
		return ;
	SdbCursorRef xDestCursor = pDataObj->GetCursor();
	/*
	SdbCursorRef xDestCursor = m_rDBDef->GetDatabase()->CreateCursor( SDB_SNAPSHOT, SDB_FORWARDONLY );
	String aDestTableName( m_rDBDef->Name());
	if(m_rDBDef->GetKind() == dbQuery)
		!xDestCursor->Open(((SbaQueryDef*)&m_rDBDef)->Statement(), FALSE);
	else
		!xDestCursor->Open(aDestTableName, TRUE);
	*/
	if(xDestCursor->IsOpen())
	{
		ULONG j=1;
		ULONG kk=0;
		while(xDestCursor->IsInRange())
		{
			IncIndent(1);
			TAG_ON_LF( sHTML_tablerow );

			if(!m_pRowMarker || m_pRowMarker[kk] == j)
			{
				ODbRow& rRow = *xDestCursor->GetRow();
				++kk;
				for(ULONG i=1;i<xDestCursor->GetColumns()->Count();++i)
				{
					if(i == xDestCursor->GetColumns()->Count()-1)
						IncIndent(-1);

					String aValue;
					try
					{
						ODbVariantRef xVar = rRow[i];
						if (xVar.is() && !xVar->isNull())
						{
							aValue = xVar->toString().getStr();
						}
					}
					catch ( ... )
					{
					}					
					WriteCell(pFormat[i-1],pColWidth[i-1],nHeight,pHorJustify[i-1],aValue,sHTML_tabledata);
				}
			}
			++j;
			xDestCursor->Next();
			TAG_OFF_LF( sHTML_tablerow );
		}
	}

	delete [] pFormat;
	delete [] pHorJustify;
	delete [] pColWidth;

	IncIndent(-1); OUT_LF(); TAG_OFF_LF( sHTML_tbody );
	IncIndent(-1); TAG_OFF_LF( sHTML_table );
}
//-----------------------------------------------------------------------
void SbaHTMLImportExport::WriteCell( ULONG nFormat,USHORT nWidthPixel,USHORT nHeightPixel,const char* pChar,const String& rValue,const char* pHtmlTag)
{
	BOOL bValueData;
	bValueData = FALSE;

	ByteString aStrTD = pHtmlTag;

	nWidthPixel  = nWidthPixel	? nWidthPixel	: 86;
	nHeightPixel = nHeightPixel ? nHeightPixel	: 17;

	// trotz der <TABLE COLS=n> und <COL WIDTH=x> Angaben noetig,
	// da die nicht von Netscape beachtet werden..
	// Spaltenbreite
	(((aStrTD += ' ') += sHTML_O_width)		+= '=') += ByteString::CreateFromInt32(nWidthPixel);
	// Zeilenhoehe
	(((aStrTD += ' ') += sHTML_O_height)	+= '=') += ByteString::CreateFromInt32(nHeightPixel);

	(((aStrTD += ' ') += sHTML_O_align)		+= '=') += pChar;

	double fVal = 0.0;
	((SbaDBDataDef*)&m_rDBDef)->GetFormatter()->IsNumberFormat(rValue,nFormat,fVal);

	HTMLOutFuncs::CreateTableDataOptionsValNum( aStrTD, bValueData, fVal,nFormat, *((SbaDBDataDef*)&m_rDBDef)->GetFormatter() );

	TAG_ON( aStrTD.GetBuffer() );

	FontOn();

	BOOL bBold			= ( WEIGHT_NORMAL	!= m_aFont.GetWeight() );
	BOOL bItalic		= ( ITALIC_NONE		!= m_aFont.GetItalic() );
	BOOL bUnderline		= ( UNDERLINE_NONE	!= m_aFont.GetUnderline() );
	BOOL bStrikeout		= ( STRIKEOUT_NONE	!= m_aFont.GetStrikeout() );

	if ( bBold )		TAG_ON( sHTML_bold );
	if ( bItalic )		TAG_ON( sHTML_italic );
	if ( bUnderline )	TAG_ON( sHTML_underline );
	if ( bStrikeout )	TAG_ON( sHTML_strike );

	if ( !rValue.Len() )
		TAG_ON( sHTML_linebreak );		// #42573# keine komplett leere Zelle
	else
		OUT_STR( rValue );

	if ( bStrikeout )	TAG_OFF( sHTML_strike );
	if ( bUnderline )	TAG_OFF( sHTML_underline );
	if ( bItalic )		TAG_OFF( sHTML_italic );
	if ( bBold )		TAG_OFF( sHTML_bold );

	FontOff();

	TAG_OFF_LF( pHtmlTag );
}
//-----------------------------------------------------------------------
void SbaHTMLImportExport::FontOn()
{
#if DBG_UTIL
		m_bCheckFont = TRUE;
#endif

	// <FONT FACE="xxx">
	ByteString aStrOut  = '<';
	aStrOut  += sHTML_font;
	aStrOut  += ' ';
	aStrOut  += sHTML_O_face;
	aStrOut  += '=';
	aStrOut  += '\"';
	aStrOut  += ByteString(m_aFont.GetName(), gsl_getSystemTextEncoding());
		// TODO : think about the encoding of the font name
	aStrOut  += '\"';
	aStrOut  += ' ';
	aStrOut  += sHTML_O_color;
	aStrOut  += '=';
	m_aStream << aStrOut;
	HTMLOutFuncs::Out_Color( m_aStream, m_aFont.GetColor() );
	m_aStream << '>';
}
//-----------------------------------------------------------------------
inline void SbaHTMLImportExport::FontOff()
{
	DBG_ASSERT(m_bCheckFont,"Kein FontOn() gerufen");
	TAG_OFF( sHTML_font );
#if DBG_UTIL
	m_bCheckFont = FALSE;
#endif
}
//-----------------------------------------------------------------------
void SbaHTMLImportExport::IncIndent( short nVal )
{
	sIndent[nIndent] = '\t';
	nIndent += nVal;
	if ( nIndent < 0 )
		nIndent = 0;
	else if ( nIndent > nIndentMax )
		nIndent = nIndentMax;
	sIndent[nIndent] = 0;
}




