/*************************************************************************
 *
 *  $RCSfile: sbadb.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#include <iniwrap.hxx>

#ifndef _SBA_DBSTAT_HXX
#include <dbstat.hxx>
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif

#ifndef _SBA_DBFILEOB_HXX
#include "dbfileob.hxx"
#endif

#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _EXPLORER_HXX //autogen
#include <sfx2/explorer.hxx>
#endif

#ifndef _CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif

namespace staruno = com::sun::star::uno;
namespace stardata = com::sun::star::data;

TYPEINIT1(SbaDatabase, SdbDatabase);

//------------------------------------------------------------------------------
void SbaDatabase::RemoveChild(SdbObj* pObj)
{
	SbaDBDef* pDBDef = PTR_CAST(SbaDBDef, pObj);
	if (pDBDef)
	{
		switch (pDBDef->GetKind())
		{
			case dbTable:
			case dbView:
				aTableList.Remove(pDBDef); break;
			case dbQuery:
				aQueryList.Remove(pDBDef); break;
			case dbForm:
				aFormList.Remove(pDBDef); break;
			case dbReport:
				aReportList.Remove(pDBDef); break;
			default:
				DBG_ERROR("Unknown Type");
		}
		SdbObj::RemoveChild(pObj);
	}
	else // datenbank fuehrt noch eigene Listen
		SdbDatabase::RemoveChild(pObj);
}



//------------------------------------------------------------------------------
void SbaDatabase::RemoveChildren()
{
	while (aTableList.Count())
		RemoveChild(aTableList.GetObject(0));
	while (aQueryList.Count())
		RemoveChild(aQueryList.GetObject(0));
	while (aFormList.Count())
		RemoveChild(aFormList.GetObject(0));
	while (aReportList.Count())
		RemoveChild(aReportList.GetObject(0));

	SdbDatabase::RemoveChildren();
}

//------------------------------------------------------------------------------
void SbaDatabase::InsertIntoList(SbaDBDef* pDBDef)
{
	if (pDBDef)
	{
		switch (pDBDef->GetKind())
		{
			case dbTable:
			case dbView:
				aTableList.InsertAt(pDBDef->Name(), pDBDef); break;
			case dbQuery:
			{
				// temp Objekte werden nicht in der Liste gehalten
				// siehe SbaQueryDef
				SbaQueryDef* pQueryDef = (SbaQueryDef*)pDBDef;
				if (!pQueryDef->IsTemp())
					aQueryList.InsertAt(pDBDef->Name(), pDBDef);
			}	break;
			case dbForm:
				aFormList.InsertAt(pDBDef->Name(), pDBDef); break;
			case dbReport:
				aReportList.InsertAt(pDBDef->Name(), pDBDef); break;
			default:
				DBG_ERROR("Unknown Type");
		}
	}
}

//------------------------------------------------------------------------------
void SbaDatabase::ReplaceInList(SbaDBDef* pDBDef)
{
	if (pDBDef)
	{
		switch (pDBDef->GetKind())
		{
			case dbTable:
			case dbView:
				aTableList.Replace(pDBDef, pDBDef->Name(), pDBDef); break;
			case dbQuery:
				aQueryList.Replace(pDBDef, pDBDef->Name(), pDBDef); break;
			case dbForm:
				aFormList.Replace(pDBDef, pDBDef->Name(), pDBDef); break;
			case dbReport:
				aReportList.Replace(pDBDef, pDBDef->Name(), pDBDef); break;
			default:
				DBG_ERROR("Unknown Type");
		}
	}
}

//------------------------------------------------------------------------------
void SbaDatabase::RemoveFromList(SbaDBDef* pDBDef)
{
	if (pDBDef)
	{
		switch (pDBDef->GetKind())
		{
			case dbTable:
			case dbView:
				aTableList.Remove(pDBDef); break;
			case dbQuery:
				aQueryList.Remove(pDBDef); break;
			case dbForm:
				aFormList.Remove(pDBDef); break;
			case dbReport:
				aReportList.Remove(pDBDef); break;
			default:
				DBG_ERROR("Unknown Type");
		}
	}
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::Refresh(DBObject eObj)
{
	BOOL bResult = SdbDatabase::Refresh(eObj);
	if (bResult)
	{
		switch (eObj)
		{
			case dbTable:
			case dbView:
				UpdateList(eObj, aTableList);
				break;
			case dbQuery:
				UpdateList(eObj, aQueryList);
				break;
			case dbForm:
				UpdateList(eObj, aFormList);
				break;
			case dbReport:
				UpdateList(eObj, aReportList);
				break;
		}
	}
	return bResult;
}

//------------------------------------------------------------------------------
void SbaDatabase::UpdateList(DBObject eObj, SbaDBDefList& rList)
{
	ULONG nCount = rList.Count();
	for (ULONG i = nCount; i > 0; i--)
	{
		SbaDBDef* pDBDef = rList.GetObject(i-1);
		if (!pDBDef->IsNew())
		{
			if (!SdbDatabase::HasObject(eObj,pDBDef->Name()))
				RemoveChild(pDBDef);
			else
				pDBDef->Refresh();
		}
	}
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::CreateDBDef(DBObject eObj, const String& rName, BOOL bShowError)
{
	SbaDBDef* pDBDef = NULL;
	switch (eObj)
	{
		case dbTable:
			pDBDef = CreateTableDef(rName, FALSE, bShowError); break;
		case dbView:
			pDBDef = CreateTableDef(rName, TRUE, bShowError); break;
		case dbQuery:
			pDBDef = CreateQueryDef(rName, bShowError); break;
		case dbForm:
			pDBDef = CreateFormDef(rName, bShowError); break;
		case dbReport:
			pDBDef = CreateReportDef(rName, bShowError); break;
		default:
			DBG_ERROR("Unknown Type");
	}
	if (pDBDef)
		InsertIntoList(pDBDef);
	return pDBDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::CreateTableDef(const String& rName, BOOL bView, BOOL bShowError)
{
	SBA_CHK_OPEN_NULL();

	SbaDBDef* pDef = NULL;
	String aSearchName(SdbTable::GetFullName(*GetConnection(), rName));
	if (!IsUniqueName(dbTable,rName) || aTableList.Lookup(aSearchName))
	{
		aStatus.SetError(ERRCODE_IO_ALREADYEXISTS,dbTable,rName);
		if (bShowError)
		{
			SBA_MOD()->ShowDbStatus(aStatus,dbWriteError);
		}
	}
	else
	{
		pDef = new SbaTableDef(this, rName, bView, TRUE, bShowError);
		if (pDef->Status().IsError())
		{
			pDef->RemoveFromParent();
			pDef = NULL;
		}
	}
	return pDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::CreateFormDef(const String& rName, BOOL bShowError)
{
	SBA_CHK_OPEN_NULL();

	SbaDBDef* pDef = NULL;
	if (!IsUniqueName(dbForm,rName) || aFormList.Lookup(rName))
	{
		aStatus.SetError(ERRCODE_IO_ALREADYEXISTS,dbForm,rName);
		if (bShowError)
		{
			SBA_MOD()->ShowDbStatus(aStatus,dbWriteError);
		}
	}
	else
	{
		pDef = new SbaFormDef(this, rName, TRUE, bShowError);
		if (pDef->Status().IsError())
		{
			pDef->RemoveFromParent();
			pDef = NULL;
		}
	}
	return pDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::CreateReportDef(const String& rName, BOOL bShowError)
{
	SBA_CHK_OPEN_NULL();
	SbaDBDef* pDef = NULL;
	if (!IsUniqueName(dbReport,rName) || aReportList.Lookup(rName))
	{
		aStatus.SetError(ERRCODE_IO_ALREADYEXISTS,dbReport,rName);

		if (bShowError)
		{
			SBA_MOD()->ShowDbStatus(aStatus,dbWriteError);
		}
	}
	else
	{
		pDef = new SbaReportDef(this, rName, TRUE, bShowError);
		if (pDef->Status().IsError())
		{
			pDef->RemoveFromParent();
			pDef = NULL;
		}
	}
	return pDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::CreateQueryDef(const String& rName, BOOL bShowError)
{
	SBA_CHK_OPEN_NULL();
	SbaDBDef* pDef = NULL;
	if (!IsUniqueName(dbQuery,rName) || aQueryList.Lookup(rName))
	{
		aStatus.SetError(ERRCODE_IO_ALREADYEXISTS,dbQuery,rName);
		if (bShowError)
		{
			SBA_MOD()->ShowDbStatus(aStatus,dbWriteError);
		}
	}
	else
	{
		pDef = new SbaQueryDef(this, rName, TRUE, bShowError);
		if (pDef->Status().IsError())
		{
			pDef->RemoveFromParent();
			pDef = NULL;
		}
	}
	return pDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::OpenDBDef(DBObject eObj, const String& rName, BOOL bShowError)
{
	SBA_CHK_OPEN_NULL();

	SbaDBDef* pDBDef = NULL;
	String aSearchName = rName;
	switch (eObj)
	{
		case dbTable:
		case dbView:
			aSearchName = SdbTable::GetFullName(*GetConnection(),rName);
			pDBDef = aTableList.Lookup(aSearchName);
			break;
		case dbQuery:
			pDBDef = aQueryList.Lookup(aSearchName); break;
		case dbForm:
			pDBDef = aFormList.Lookup(aSearchName); break;
		case dbReport:
			pDBDef = aReportList.Lookup(aSearchName); break;
	}

	// Temporaere Objekte sind Abfragen die nur zur Ausfuehrung eines SQL-Statements
	// verwendet werden
	if (!pDBDef)
	{
		switch (eObj)
		{
			case dbTable:
			case dbView:
				pDBDef = new SbaTableDef(this, aSearchName, FALSE, FALSE, FALSE);
				break;
			case dbQuery:
				pDBDef = new SbaQueryDef(this, aSearchName, FALSE, FALSE);
				break;
			case dbForm:
				pDBDef = new SbaFormDef(this, aSearchName, FALSE, FALSE);
				break;
			case dbReport:
				pDBDef = new SbaReportDef(this, aSearchName, FALSE, FALSE);
				break;
		}
		if (pDBDef->Status().IsError())
		{
			aStatus = pDBDef->Status();

			if(bShowError)
				SBA_MOD()->ShowDbStatus(pDBDef->Status(), dbReadError);
			pDBDef->RemoveFromParent();
			pDBDef = NULL;
		}
	}
	if (pDBDef && !pDBDef->IsOpen())
	{
		if (!pDBDef->Open())
		{
			aStatus = pDBDef->Status();

			if(bShowError)
				SBA_MOD()->ShowDbStatus(pDBDef->Status(), dbReadError);
			pDBDef->RemoveFromParent();
			pDBDef = NULL;
		}
		else
		{
			InsertIntoList(pDBDef);
		}
	}
	return pDBDef;
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::OpenDBDef(const String& rURL, BOOL bShowError)
{
	//////////////////////////////////////////////////////////////////////
	// Erzeugt DBObj aus URL

	// URL-Object
	INetURLObject aURLObj( rURL );
	aURLObj.SetSmartProtocol( INET_PROT_FILE );

	// Typ DBObjects
	DBObject eDBObjType;
	xub_StrLen nIndex(0);
	String aMark( aURLObj.GetMark() );
	String aMarkHeader = aMark.GetToken( 0, ';', nIndex);

	aMarkHeader += ';';

	if (aMarkHeader.EqualsAscii(SDB_TABLEMARK_HEADER))
	{
		if (nIndex != STRING_NOTFOUND && aMark.GetChar(nIndex) == ';')
		{
			eDBObjType = dbView;
		}
		else
			eDBObjType = dbTable;
	}
	else if (aMarkHeader.EqualsAscii(SDB_QUERYMARK_HEADER))
		eDBObjType = dbQuery;
	else if (aMarkHeader.EqualsAscii(SDB_FORMMARK_HEADER))
		eDBObjType = dbForm;
	else if (aMarkHeader.EqualsAscii(SDB_REPORTMARK_HEADER))
		eDBObjType = dbReport;

	else
		return NULL;	// Kein bekannter Typ

	return OpenDBDef(rURL, eDBObjType);
}

//------------------------------------------------------------------------------
SbaDBDef* SbaDatabase::OpenDBDef(const String& rURL, DBObject eDBObjType, BOOL bShowError)
{
	INetURLObject aURLObj( rURL );
	aURLObj.SetSmartProtocol( INET_PROT_FILE );

	// Name des DBObjects
	String aDBObjName( aURLObj.GetMark() );
	String aMarkHeader;
	switch( eDBObjType )
	{
		case dbTable:
		case dbView:
			aMarkHeader.AssignAscii(SDB_TABLEMARK_HEADER);
			break;
		case dbQuery:
			aMarkHeader.AssignAscii(SDB_QUERYMARK_HEADER);
			break;
		case dbForm:
			aMarkHeader.AssignAscii(SDB_FORMMARK_HEADER);
			break;
		case dbReport:
			aMarkHeader.AssignAscii(SDB_REPORTMARK_HEADER);
			break;
		default:
			return NULL;
	};

	// Objectname
	if (eDBObjType == dbView) // doppeltes ;
		aDBObjName.Erase( 0, aMarkHeader.Len() + 1 );
	else
		aDBObjName.Erase( 0, aMarkHeader.Len() );

	return OpenDBDef(eDBObjType, aDBObjName, bShowError);
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::HasObjectByURL(const String& rURL)
{
	// Erzeugt DBObj aus URL

	// URL-Object
	INetURLObject aURLObj( rURL );
	aURLObj.SetSmartProtocol( INET_PROT_FILE );

	// Typ DBObjects
	DBObject eDBObjType;
	xub_StrLen nIndex(0);
	String aMark( aURLObj.GetMark() );
	String aMarkHeader = aMark.GetToken( 0, ';', nIndex );
	aMarkHeader += ';';

	if (aMarkHeader.EqualsAscii(SDB_TABLEMARK_HEADER))
	{
		if (nIndex != STRING_NOTFOUND && aMark.GetChar(nIndex) == ';')
		{
			aMarkHeader += ';';
			eDBObjType = dbView;
		}
		else
			eDBObjType = dbTable;
	}
	else if (aMarkHeader.EqualsAscii(SDB_QUERYMARK_HEADER))
		eDBObjType = dbQuery;
	else if (aMarkHeader.EqualsAscii(SDB_FORMMARK_HEADER))
		eDBObjType = dbForm;
	else if (aMarkHeader.EqualsAscii(SDB_REPORTMARK_HEADER))
		eDBObjType = dbReport;
	else
		return FALSE;	// Kein bekannter Typ

	return SdbDatabase::HasObject(eDBObjType, aMark.Erase(0, aMarkHeader.Len()));
}


//------------------------------------------------------------------------------
BOOL SbaDatabase::Create(const String& rName, const String& rTitle, const String& rConnectStr)
{
	return SdbDatabase::Create(rName, rTitle, rConnectStr);
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::Open()
{
	BOOL bResult = SdbDatabase::Open();
	if (bResult)
	{
#if SUPD < 566
		CreateDatabaseLink(Name(),Title());
#endif
		aTableList.SetCaseSensitive((GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT);
		aQueryList.SetCaseSensitive(TRUE);
		aFormList.SetCaseSensitive(TRUE);
		aReportList.SetCaseSensitive(TRUE);
	}
	return bResult;

}

//------------------------------------------------------------------------------
BOOL SbaDatabase::Drop()
{
	BOOL bResult = CanRelease() && SdbDatabase::Drop();
	if (bResult)
	{
		// Ist die Addressdatenbank geloescht worden, dann Configeintrag zuruecksetzen
		if (DirEntry(Name()) == DirEntry(SBA_MOD()->GetAddrDBName()))
			SBA_MOD()->SetAddressBookEntry(String(), String());
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::CanRelease()
{
	SbaDBHint aHint(this, SbaDBHint::dbRelease);
	SBA_MOD()->Broadcast(aHint);

	return aHint.CanRelease();
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::Rename(const String& rName)
{
	String aOldName = Name();
	BOOL bResult = SdbDatabase::Rename(rName);

	// Ist die Addressdatenbank umbenannt worden, dann Configeintrag anpassen
	if (bResult)
	{
		if (DirEntry(aOldName) == DirEntry(SBA_MOD()->GetAddrDBName()))
			SBA_MOD()->SetAddressBookEntry(rName, SBA_MOD()->GetAddrTableName());
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::AlterTitle(const String& rTitle)
{
	BOOL bResult = SdbDatabase::AlterTitle(rTitle);
	if (bResult)
	{
		SbaDBHint aHint(this, SbaDBHint::dbRename);
		SBA_MOD()->Broadcast(aHint);
	}
	return bResult;
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::AlterConnection(const String& rConnect)
{
	return CanRelease() && SdbDatabase::AlterConnection(rConnect);
}

//------------------------------------------------------------------------------
void SbaDatabase::CreateDatabaseLink(const String& rDBName, const String& rTitle)
{
	DBG_ERROR("SbaDatabase::CreateDatabaseLink : not supported anymore (please use the sdb::DatabaseAccessContext service) !");
	// no implicit link creation anymore
	// FS - 21.01.00 - 71571
}

//------------------------------------------------------------------------------
void SbaDatabase::DropDatabaseLink(const String& rDBName)
{
	DBG_ERROR("SbaDatabase::DropDatabaseLink : not supported anymore (please use the sdb::DatabaseAccessContext service) !");
	// no implicit link creation anymore
	// FS - 21.01.00 - 71571
}

//------------------------------------------------------------------------------
String SbaDatabase::GetDatabaseNames()
{
	DBG_ERROR("SbaDatabase::GetDatabaseNames : who the hell is calling this obsolete method ?");
	return SBA_MOD()->GetDatabaseNames();
}

//------------------------------------------------------------------------------
String SbaDatabase::GetDatabaseFilename(const String& rDBTitle)
{
	DBG_ERROR("SbaDatabase::GetDatabaseFilename : who the hell is calling this obsolete method ?");
	return SBA_MOD()->GetDatabaseName(rDBTitle);
}


//------------------------------------------------------------------------------
void SbaDatabase::ShowDBDef(const String& rURL)
{
	SBA_MOD()->ShowDBObj(rURL);
}

//------------------------------------------------------------------------------
void SbaDatabase::ShowDBDef(DBObject eObj, const String& rName)
{
	SbaDBDefRef aRef;
	if (eObj == dbTable || eObj == dbView)
		aRef = OpenDBDef(eObj,rName);
	else if (eObj == dbQuery)
		aRef = OpenDBDef(dbQuery,rName);

	if (aRef.Is())
		ShowDBDef(aRef->ToURL());
}

//------------------------------------------------------------------------------
void SbaDatabase::ShowStatement(const String& rStatement, BOOL bNative)
{
	INetURLObject aObj;
	aObj.SetSmartProtocol(INET_PROT_FILE);

	String aUrl(Name());
	aObj.SetSmartURL(aUrl);

	String aMark;
	aMark.AssignAscii(SDB_STATEMENTMARK_HEADER);
	aMark += SDB_STATEMENT_DELIMETER;
	if (bNative)
		aMark += '1';
	else
		aMark += '0';

	aMark += SDB_STATEMENT_DELIMETER;
	if(!bNative)
		aMark.AppendAscii("%20");
	aMark += rStatement;
	aObj.SetMark(aMark);
	String aUrla(aObj.GetMainURL());
	if(!bNative && rStatement.Len())
	{
		xub_StrLen nPos = aUrla.Search(rStatement);
		aUrla.Erase(nPos-3,3);
	}
	ShowDBDef(aUrla);
}

//------------------------------------------------------------------------------
String SbaDatabase::ShortenTableName( const String& rName, xub_StrLen nNewLength) const
{
	//////////////////////////////////////////////////////////////////////
	// Wenn es schon einen gekuerzten Namen gibt, Namen durchnumerieren (bis 99)
	String aNewName(rName.Copy( 0, nNewLength ));
	String aBaseName(rName.Copy( 0, nNewLength-2 ));
	USHORT i=1;
	while( ((SbaDatabase*)this)->HasObject(dbTable, rName) && (i<100) )
	{
		aNewName = aBaseName;
		aNewName += String::CreateFromInt32(i);
		i++;
	}

	return aNewName;
}
//------------------------------------------------------------------------------
String SbaDatabase::CheckTableName(const String &rTableName,const SdbDatabase* pSourceDatabase) const
{
	String aTableName(rTableName);
	//// Tabellennamen ueberpruefen
	if(pSourceDatabase != this)
		aTableName = ConvertName(rTableName);
	//////////////////////////////////////////////////////////////////////////
	// Ist der Name zu lang?
	::staruno::Reference< ::stardata::XDatabaseDescriptor >  xDestMetaData(GetMetaData());
	xub_StrLen nMaxTableNameLen(xDestMetaData->getLimit(stardata::DatabaseLimit::TABLE_NAME_LEN));	
	if( nMaxTableNameLen && (aTableName.Len()>nMaxTableNameLen) )
	{
		String aInfoString( SbaResId(SBA_ERR_TABLENAME_LEN) );
		aInfoString.SearchAndReplaceAscii( "$max$", String::CreateFromInt32(nMaxTableNameLen) );
		InfoBox aNameLenInfoBox( Application::GetDefDialogParent(), aInfoString );
		aNameLenInfoBox.Execute();
		aTableName = ShortenTableName( aTableName, nMaxTableNameLen );
	}
	return aTableName;
}
//------------------------------------------------------------------------------
SdbTypeInfo* SbaDatabase::GetRowVersionTypeInfo() const
{
	const SdbTypeInfoList* pTypeList = SdbDatabase::GetTypeInfo();
	ULONG i(0);
	SdbTypeInfo* pInfo = pTypeList->GetObject(i++);
	while (pInfo)
	{
		if(pInfo->bRowVersion)
			break;
		pInfo = pTypeList->GetObject(i++);
	}
	return pInfo;
}
//------------------------------------------------------------------------------
SdbTypeInfo* SbaDatabase::GetTypeInfo(SdbDatabaseType eType, BOOL bCounter) const
{
	const SdbTypeInfoList* pTypeList = SdbDatabase::GetTypeInfo();
	ULONG i(0);
	SdbTypeInfo* pInfo = pTypeList->GetObject(i++);
	while (pInfo)
	{
		if (bCounter != pInfo->bAutoIncrement)
		{
			pInfo = pTypeList->GetObject(i++);
			continue;
		}
		if (pInfo->eType == eType)
			break;
		else if (pInfo->bCurrency && eType == SDB_DBTYPE_CURRENCY)
			break;
		pInfo = pTypeList->GetObject(i++);
	}
	return pInfo;
}
//------------------------------------------------------------------------------
SbaFieldType SbaDatabase::GetFieldType(const SdbColumn& rCol) const
{
	return GetFieldType(rCol.GetType(),rCol.GetLength());
}
//------------------------------------------------------------------------------
SbaFieldType SbaDatabase::GetFieldType(SdbDatabaseType eSdbType,sal_Int32 nLength) const
{
	SbaFieldType eType;
	switch (eSdbType)
	{
		case SDB_DBTYPE_CHAR:
		{
			::staruno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(GetMetaData());

			sal_Int32 nLimit(rMetaData->getLimit(::stardata::DatabaseLimit::CHAR_LITERAL_LEN));

			if (!nLimit || nLength <= nLimit)
				eType = dbChar;
			else
				eType = dbMemo;

		}	break;
		case SDB_DBTYPE_VARCHAR:
		{
			::staruno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(GetMetaData());
			sal_Int32 nLimit(rMetaData->getLimit(::stardata::DatabaseLimit::CHAR_LITERAL_LEN));
			if (!nLimit || nLength <= nLimit)
				eType = dbText;
			else
				eType = dbMemo;
		}	break;
		case SDB_DBTYPE_LONGVARCHAR:
			eType = dbMemo;
			break;
		case SDB_DBTYPE_LONGVARBINARY:
			eType = dbImage;
			break;
		case SDB_DBTYPE_BINARY:
			eType = dbBinary;
			break;
		case SDB_DBTYPE_VARBINARY:
			eType = dbVarBinary;
			break;
		case SDB_DBTYPE_BOOLEAN:
			eType = dbBool;
			break;
		case SDB_DBTYPE_CURRENCY:
			eType = dbCurrency;
			break;
		case SDB_DBTYPE_TIMESTAMP:
			eType = dbDateTime;
			break;
		case SDB_DBTYPE_DATE:
			eType = dbDate;
			break;
		case SDB_DBTYPE_TIME:
			eType = dbTime;
			break;
		case SDB_DBTYPE_TINYINT:
		case SDB_DBTYPE_SMALLINT:
		case SDB_DBTYPE_INTEGER:
		case SDB_DBTYPE_REAL:
		case SDB_DBTYPE_DOUBLE:
			eType = dbNumeric;
			break;
		case SDB_DBTYPE_DECIMAL:
		case SDB_DBTYPE_NUMERIC:
			eType = dbDecimal;
			break;
		default:
			eType = dbNone;
	}
	return eType;
}

//------------------------------------------------------------------------------
SdbTypeInfo* SbaDatabase::IsTypeAvailable(SbaFieldType eFieldType, SbaNumericSize eSizeType) const
{
	SdbTypeInfo* pInfo = NULL;

	switch (eFieldType)
	{
		case dbText:
			pInfo = GetTypeInfo(SDB_DBTYPE_VARCHAR);
			if (!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_CHAR);
			break;
		case dbChar:
			pInfo = GetTypeInfo(SDB_DBTYPE_CHAR,TRUE);
			if(!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_CHAR);
			break;
		case dbBool:
			pInfo = GetTypeInfo(SDB_DBTYPE_BOOLEAN);
			if (!pInfo){ // einer sollte vorhanden sein
				pInfo = GetTypeInfo(SDB_DBTYPE_TINYINT);
				if (!pInfo){
					pInfo = GetTypeInfo(SDB_DBTYPE_SMALLINT);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_INTEGER);
				}
			}
			break;
		case dbDecimal:
			pInfo = GetTypeInfo(SDB_DBTYPE_DECIMAL,TRUE);
			if (!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_DECIMAL);
			if (!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_NUMERIC);
			break;
		case dbNumeric:
			switch (eSizeType)
			{
				case dbByte:
					pInfo = GetTypeInfo(SDB_DBTYPE_TINYINT,TRUE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_TINYINT);
					if (pInfo)
						break;
				case dbInteger:
					pInfo = GetTypeInfo(SDB_DBTYPE_SMALLINT,TRUE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_SMALLINT);
					if (pInfo)
						break;
				case dbLong:
					pInfo = GetTypeInfo(SDB_DBTYPE_INTEGER,TRUE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_INTEGER);
					if (pInfo)
						break;
				case dbSingle:
					pInfo = GetTypeInfo(SDB_DBTYPE_REAL,TRUE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_REAL);
					if (pInfo)
						break;
				case dbDouble:
					pInfo = GetTypeInfo(SDB_DBTYPE_DOUBLE,TRUE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_DOUBLE);
					if (!pInfo)
						pInfo = GetTypeInfo(SDB_DBTYPE_DECIMAL);
					break;
				default:
					DBG_ERROR("Unbekannte Size!");
			}
			break;
		case dbCurrency:
			pInfo = GetTypeInfo(SDB_DBTYPE_CURRENCY);
			if (!pInfo)	// decimal ?
			{
				pInfo = GetTypeInfo(SDB_DBTYPE_DECIMAL);
				if (!pInfo || pInfo->nPrecision < 19 || pInfo->nScale < 4)	// ersatz
					pInfo = 0;
			}
			if (!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_DOUBLE);
			break;
		case dbDateTime:
			pInfo = GetTypeInfo(SDB_DBTYPE_TIMESTAMP);
			if (!pInfo)
			{
				pInfo = GetTypeInfo(SDB_DBTYPE_DECIMAL);
				if (!pInfo || pInfo->nPrecision < 17 || pInfo->nScale < 10)	// ersatz
					pInfo = 0;
				if (!pInfo)
					pInfo = GetTypeInfo(SDB_DBTYPE_CHAR);
			}
			break;
		case dbDate:
			pInfo = GetTypeInfo(SDB_DBTYPE_DATE);
			if (!pInfo)
				pInfo = IsTypeAvailable(dbDateTime, dbSizeNone);
			break;
		case dbTime:
			pInfo = GetTypeInfo(SDB_DBTYPE_TIME);
			if (!pInfo)
				pInfo = IsTypeAvailable(dbDateTime, dbSizeNone);
			break;
		case dbMemo:
			pInfo = GetTypeInfo(SDB_DBTYPE_LONGVARCHAR);
			break;
		case dbImage:
			pInfo = GetTypeInfo(SDB_DBTYPE_LONGVARBINARY);
			break;
		case dbBinary:
			pInfo = GetTypeInfo(SDB_DBTYPE_BINARY);
			break;
		case dbVarBinary:
			pInfo = GetTypeInfo(SDB_DBTYPE_VARBINARY);
			break;
		case dbBigInt:
			pInfo = GetTypeInfo(SDB_DBTYPE_BIGINT,TRUE);
			if(!pInfo)
				pInfo = GetTypeInfo(SDB_DBTYPE_BIGINT);
			break;
		case dbCounter:
		case dbNULL:
			pInfo = NULL;
			break;
		default:
			DBG_ERROR("Unbekannter Typ!");
	}
	return pInfo;
}

//------------------------------------------------------------------------------
BOOL SbaDatabase::IsTypeNullable(SbaFieldType eFieldType, SbaNumericSize eSizeType) const
{
	SdbTypeInfo* pInfo = IsTypeAvailable(eFieldType, eSizeType);
	return pInfo && pInfo->bNullable;
}
//------------------------------------------------------------------------------
USHORT SbaDatabase::CountNumericTypes() const
{
	USHORT nCount = 0;
	for (USHORT i = (USHORT) dbByte; i <= (USHORT)dbDouble; i++)
		if (IsNumericSizeAvailable((SbaNumericSize)i))
			nCount++;
	return nCount;
}
















