/*************************************************************************
 *
 *  $RCSfile: sbahtml.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif

#include "sbahtml.hxx"

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#ifndef _HTMLKYWD_HXX
#include <svtools/htmlkywd.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif


#include "sbares.hxx"
#include "sbaresid.hrc"

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE		// ohne das bekomme ich einen Compiler-Fehler in <svtools/zforlist.hxx>
#include <svtools/zforlist.hxx>
#endif

#ifndef _ZFORMAT_HXX //autogen
#include <svtools/zformat.hxx>
#endif

#include "sbaitems.hxx"
#include "sbaitems.hrc"

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _HTMLTOKN_H
#include <svtools/htmltokn.h>
#endif

#include "dlgerr.hxx"

#ifndef _DBWHICH_HRC
#include "dbwhich.hrc"
#endif

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SVX_UDLNITEM_HXX //autogen
#include <svx/udlnitem.hxx>
#endif

#ifndef _SVX_SHDDITEM_HXX //autogen
#include <svx/shdditem.hxx>
#endif

#ifndef _SVX_CRSDITEM_HXX //autogen
#include <svx/crsditem.hxx>
#endif

#ifndef _SVX_ITEM_HXX //autogen
#include <svx/cntritem.hxx>
#endif

#ifndef _SVX_WGHTITEM_HXX //autogen
#include <svx/wghtitem.hxx>
#endif

#ifndef _SVX_POSTITEM_HXX //autogen
#include <svx/postitem.hxx>
#endif

#ifndef _SVX_FONTITEM_HXX //autogen
#include <svx/fontitem.hxx>
#endif

#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif

#include "copytbl.hxx"
#include "rtfcpydg.hxx"

#define SBA_HTML_FONTSIZES 7		// wie Export, HTML-Options

namespace staruno = com::sun::star::uno;
namespace stardata = com::sun::star::data;

// ==========================================================================
DBG_NAME(SbaParser);
// ==========================================================================
// SbaParser
// ==========================================================================
SbaParser::SbaParser(UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf)
	:xTableDef(NULL)
	,xDatabase(NULL)
	,xDestCursor(NULL)
	,m_vColumns((long int)nColumns,0)
	,nColumnPos(0)
	,m_nRows(1)
	,m_nRowCount(0)
	,nDefToken(LANGUAGE_DONTKNOW)
	,bError(FALSE)
	,bInTbl(FALSE)
	,m_pNF(pNf)
	,m_bHead(TRUE)
	,m_bDontAskAgain(FALSE)
	,m_bIsAutoIncrement(FALSE)
{
	DBG_CTOR(SbaParser,NULL);
	m_nRows += nRows;
	m_pColumnSize = new ULONG[nColumns];
	m_pFormatKeys = new ULONG[nColumns];
	for(ULONG i=0;i<nColumns;++i)
	{
		m_pColumnSize[i] = 0;
		m_pFormatKeys[i] = 0;
	}

}
//---------------------------------------------------------------------------
SbaParser::SbaParser(SbaDatabase *pDatabase)
	:xTableDef(NULL)
	,xDatabase(pDatabase)
	,xDestCursor(NULL)
	,nColumnPos(0)
	,m_nRows(1)
	,m_nRowCount(0)
	,nDefToken(LANGUAGE_DONTKNOW)
	,bError(FALSE)
	,bInTbl(FALSE)
	,m_pNF(pDatabase->GetFormatter())
	,m_pColumnSize(0)
	,m_pFormatKeys(0)
	,m_bHead(TRUE)
	,m_bDontAskAgain(FALSE)
	,m_bIsAutoIncrement(FALSE)
{
	DBG_CTOR(SbaParser,NULL);
}
//---------------------------------------------------------------------------
SbaParser::~SbaParser()
{
	delete m_pColumnSize;
	delete m_pFormatKeys;
	DBG_DTOR(SbaParser,NULL);
}
//------------------------------------------------------------------------------
String SbaParser::ShortenFieldName( const String& rName, xub_StrLen nNewLength, const SbaColumnList& rDestList )
{
	DBG_CHKTHIS(SbaParser,NULL);
	xub_StrLen nLength = nNewLength ? nNewLength : rName.Len();
	//////////////////////////////////////////////////////////////////////
	// Wenn es schon einen gekuerzten Namen gibt, Namen durchnumerieren (bis 99)
	String aNewName( rName.Copy( 0, nLength ));
	String aBaseName( rName.Copy( 0, nLength - 2 ));
	xub_StrLen i=1;
	while( rDestList.Lookup(aNewName, String()) && (i<100) )
	{
		aNewName = aBaseName;
		aNewName += String::CreateFromInt32(i);
		i++;
	}

	return aNewName;
}

// ==========================================================================
DBG_NAME(SbaHTMLReader);
// ==========================================================================
// SbaHTMLReader
// ==========================================================================
SbaHTMLReader::SbaHTMLReader(SvStream& rIn,SbaDatabase *pDatabase): HTMLParser(rIn)
	,SbaParser(pDatabase)
	,m_nTableCount(0)
	,m_nColumnWidth(87)
{
	DBG_CTOR(SbaHTMLReader,NULL);
}
// ---------------------------------------------------------------------------
SbaHTMLReader::SbaHTMLReader(SvStream& rIn,UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf): HTMLParser(rIn)
	,SbaParser(nRows,nColumns,pNf)
	,m_nTableCount(0)
	,m_nColumnWidth(87)
{
	DBG_CTOR(SbaHTMLReader,NULL);
}
// ---------------------------------------------------------------------------
SbaHTMLReader::~SbaHTMLReader()
{
	DBG_DTOR(SbaHTMLReader,NULL);
}
// ---------------------------------------------------------------------------
SvParserState SbaHTMLReader::CallParser()
{
	rInput.Seek(STREAM_SEEK_TO_BEGIN);
	rInput.ResetError();
	return HTMLParser::CallParser();
}
// ---------------------------------------------------------------------------
void SbaHTMLReader::NextToken( int nToken )
{
	if(bError || !m_nRows) // falls Fehler oder keine Rows mehr zur "Uberpr"ufung dann gleich zur"uck
		return;

	if(xDatabase)	  // gibt an welcher CTOR gerufen wurde und damit, ob eine Tabelle erstellt werden soll
	{
		switch(nToken)
		{
			case HTML_TABLE_ON:
				++m_nTableCount;
				{	// es kann auch TD oder TH sein, wenn es vorher kein TABLE gab
					const HTMLOptions* pOptions = GetOptions();
					USHORT nArrLen = pOptions->Count();
					for ( USHORT i = 0; i < nArrLen; i++ )
					{
						const HTMLOption* pOption = (*pOptions)[i];
						switch( pOption->GetToken() )
						{
							case HTML_O_WIDTH:
							{	// Prozent: von Dokumentbreite bzw. aeusserer Zelle
								m_nColumnWidth = GetWidthPixel( pOption );
							}
							break;
						}
					}
				}
			case HTML_THEAD_ON:
			case HTML_TBODY_ON:
				if(!xTableDef.Is()) // erste Zeile als Header verwenden
					bError = !CreateTableDef(nToken);
				break;
			case HTML_TABLE_OFF:
				if(!--m_nTableCount)
				{
					xTableDef = NULL;
					xDestCursor = NULL;
				}
				break;
			case HTML_TABLEROW_ON:
				xDestCursor->AppendRow(); // sonst neue Zeile anh"angen
				break;
			case HTML_TEXTTOKEN:
			case HTML_SINGLECHAR:
				if(bInTbl) // wichtig, da wir sonst auch die Namen der Fonts bekommen
					aTextToken += aToken;
				break;
			case HTML_TABLEDATA_ON:
				bInTbl = TRUE;
				break;
			case HTML_TABLEDATA_OFF:
				{
					SbaColumn* pColumn = xTableDef->GetColumns().GetObject(nColumnPos);
					if(pColumn)
					{
						SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
						if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
						{
							ULONG nPos = m_vColumns[m_bIsAutoIncrement ? nColumnPos+1 : nColumnPos];
							if(nPos != CONTAINER_ENTRY_NOTFOUND)
							{
								if(!aTextToken.Len() && (*xDestCursor->GetColumns())[nPos]->IsNullAllowed())
									(*xDestCursor->GetRow())[nPos]->setNull();
								else
								{
									ULONG F_Index = 0;
									double fOutNumber = 0.0;
									if (m_vColumnTypes[nColumnPos] != dbText && m_pNF->IsNumberFormat(aTextToken,F_Index,fOutNumber))
									{
										switch (m_pNF->GetType(F_Index))
										{
											case NUMBERFORMAT_DATETIME:
											case NUMBERFORMAT_TIME:
											case NUMBERFORMAT_DATE:
												(*xDestCursor->GetRow())[nPos]->setDouble( SdbTools::ToStandardDate(*m_pNF, fOutNumber) );
												break;
											default:
												(*xDestCursor->GetRow())[nPos]->setDouble( fOutNumber );
										}
									}
									else
										(*xDestCursor->GetRow())[nPos]->setString(aTextToken);
								}
							}
						}
					}
					nColumnPos++;
					aTextToken.Erase();
					bInTbl = FALSE;
				}
				break;
			case HTML_TABLEROW_OFF:
				m_nRowCount++;
				if (m_bIsAutoIncrement) // if bSetAutoIncrement then I have to set the autoincrement
					(*xDestCursor->GetRow())[1]->setINT32(m_nRowCount);
				xDestCursor->UpdateRow();
				//////////////////////////////////////////////////////////////////////
				// UpdateFehlerbehandlung
				if( xDestCursor->Status().IsError() )
				{
					if(!m_bDontAskAgain)
					{
						String aMsg(xDestCursor->Status().ErrorMessage());
						aMsg += '\n';
						aMsg += String(SbaResId(SBA_STR_QRY_CONTINUE));
						SbaMsgBox aBox(GetpApp()->GetDefDialogParent(), String(SbaResId(SBA_STAT_WARNING)),
							aMsg, WB_YES_NO | WB_DEF_NO, SbaMsgBox::Warning);

						if (aBox.Execute() == RET_YES)
							m_bDontAskAgain = TRUE;
						else
							bError = TRUE;
					}
				}
				nColumnPos = 0;
				break;
		}
	}
	else // Zweig nur f"ur Typpr"ufung g"ultig
	{
		switch(nToken)
		{
			case HTML_THEAD_ON:
			case HTML_TBODY_ON:
				// Der Spalten Kopf z"ahlt nicht mit
				if(m_bHead)
				{
					do
					{}
					while(GetNextToken() != HTML_TABLEROW_OFF);
					m_bHead = FALSE;
				}
				break;
			case HTML_TABLEDATA_ON:
			case HTML_TABLEHEADER_ON:
				bInTbl = TRUE;
				break;
			case HTML_TEXTTOKEN:
			case HTML_SINGLECHAR:
				if(bInTbl)
					aTextToken += aToken;
				break;
			case HTML_TABLEDATA_OFF:
				if(aTextToken.Len())
				{
					m_vColumns[nColumnPos] = CheckString(aTextToken,m_vColumns[nColumnPos]);
					m_pColumnSize[nColumnPos] = Max((xub_StrLen)m_pColumnSize[nColumnPos],(xub_StrLen)aTextToken.Len());
					aTextToken.Erase();
				}
				nColumnPos++;
				bInTbl = FALSE;
				break;
			case HTML_TABLEROW_OFF:
				if(aTextToken.Len())
				{
					m_vColumns[nColumnPos] = CheckString(aTextToken,m_vColumns[nColumnPos]);
					m_pColumnSize[nColumnPos] = Max((xub_StrLen)m_pColumnSize[nColumnPos],(xub_StrLen)aTextToken.Len());
					aTextToken.Erase();
				}
				nColumnPos = 0;
				m_nRows--;
				break;
		}
	}
}
// --------------------------------------------------------------------------------
ULONG SbaHTMLReader::CheckString(const String& aCheckToken, ULONG nOldFormat)
{
	ULONG F_Index = 0;
	double fOutNumber = 0.0;
	ULONG nFormat = 0;
	if(m_pNF->IsNumberFormat(aCheckToken,F_Index,fOutNumber))
	{
		m_pFormatKeys[nColumnPos] = F_Index; // wird sp"ater f"ur die SbaColumn gebraucht
		short nType = m_pNF->GetType(F_Index) &~NUMBERFORMAT_DEFINED;
		nFormat = nType;
		switch(nType)
		{
			case NUMBERFORMAT_ALL:
				nFormat = NUMBERFORMAT_ALL;
				m_pFormatKeys[nColumnPos] =	100;
				break;
			case NUMBERFORMAT_DEFINED:
				nFormat = NUMBERFORMAT_TEXT;
				m_pFormatKeys[nColumnPos] =	100;
				break;
			case NUMBERFORMAT_DATE:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_DATE:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_DATE;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						m_pFormatKeys[nColumnPos] =	100;

				}
				break;
			case NUMBERFORMAT_TIME:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_TIME:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_TIME;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						m_pFormatKeys[nColumnPos] =	100;
						break;
				}
				break;
			case NUMBERFORMAT_CURRENCY:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_NUMBER:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					case NUMBERFORMAT_CURRENCY:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						m_pFormatKeys[nColumnPos] =	100;
						break;
				}
				break;
			case NUMBERFORMAT_NUMBER:
			case NUMBERFORMAT_SCIENTIFIC:
			case NUMBERFORMAT_FRACTION:
			case NUMBERFORMAT_PERCENT:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_NUMBER:
						break;
					case NUMBERFORMAT_CURRENCY:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					case NUMBERFORMAT_ALL:
						nFormat = nType;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						m_pFormatKeys[nColumnPos] =	100;
						break;
				}
				break;
			case NUMBERFORMAT_TEXT:
			case NUMBERFORMAT_UNDEFINED:
			case NUMBERFORMAT_LOGICAL:
				nFormat = NUMBERFORMAT_TEXT; // Text "uberschreibt alles
				m_pFormatKeys[nColumnPos] =	100;
				break;
			case NUMBERFORMAT_DATETIME:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_TIME:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_DATETIME;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						m_pFormatKeys[nColumnPos] =	100;
						break;
				}
				break;
			default:
				DBG_ERROR("RTFReader: Unbekanntes Format");
		}
	}
	else
	{
		m_pFormatKeys[nColumnPos] =	100;
		nFormat = NUMBERFORMAT_TEXT; // Text "uberschreibt alles
	}

	return nFormat;
}

// ---------------------------------------------------------------------------
SbaColumnList& SbaHTMLReader::FillColumnTypes(SbaColumnList& rList)
{
	if(xDatabase)
		return rList;
	for(ULONG i=0;i < rList.Count();i++)
	{
		SbaColumn *pColumn = rList.GetObject(i);
		SbaFieldType eFieldType;
		UINT32 nLength(0),nScale(0);
		switch(m_vColumns[i])
		{
			case NUMBERFORMAT_ALL:
				eFieldType  = dbNumeric;
				nLength		= dbDouble;
				break;
			case NUMBERFORMAT_DEFINED:
				eFieldType	= dbText;
				nLength		= ((m_pColumnSize[i] % 10 ) ? m_pColumnSize[i]/ 10 + 1: m_pColumnSize[i]/ 10) * 10;
				break;
			case NUMBERFORMAT_DATE:
				eFieldType	= dbDate;
				break;
			case NUMBERFORMAT_TIME:
				eFieldType	= dbTime;
				break;
			case NUMBERFORMAT_DATETIME:
				eFieldType	= dbDateTime;
				break;
			case NUMBERFORMAT_CURRENCY:
				eFieldType	= dbCurrency;
				nScale		= 4;
				nLength		= 19;
				break;
			case NUMBERFORMAT_NUMBER:
			case NUMBERFORMAT_SCIENTIFIC:
			case NUMBERFORMAT_FRACTION:
			case NUMBERFORMAT_PERCENT:
				eFieldType  = dbNumeric;
				nLength		= dbDouble;
				break;
			case NUMBERFORMAT_TEXT:
			case NUMBERFORMAT_UNDEFINED:
			case NUMBERFORMAT_LOGICAL:
				eFieldType	= dbText;
				nLength		= ((m_pColumnSize[i] % 10 ) ? m_pColumnSize[i]/ 10 + 1: m_pColumnSize[i]/ 10) * 10;
				break;

			default:
				DBG_ERROR("RTFReader: Unbekanntes Format");
		}

		pColumn->Put(SbaDataFieldTypeItem(SBA_DEF_FLTTYPE,(SbaFieldType) eFieldType ));
		pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH,nLength));
		pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE,nScale));
		pColumn->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, m_pFormatKeys[i]));
	}

	return rList;
}
//---------------------------------------------------------------------------------
void SbaHTMLReader::TableDataOn(SvxCellHorJustify& eVal,String *pValue,int nToken)
{
	BOOL bHorJustifyCenterTH = (nToken == HTML_TABLEHEADER_ON);
	const HTMLOptions* pOptions = GetOptions();
	USHORT nArrLen = pOptions->Count();
	for ( USHORT i = 0; i < nArrLen; i++ )
	{
		const HTMLOption* pOption = (*pOptions)[i];
		switch( pOption->GetToken() )
		{
			case HTML_O_ALIGN:
			{
				bHorJustifyCenterTH = FALSE;
				const String& rOptVal = pOption->GetString();
				if (rOptVal.EqualsIgnoreCaseAscii( sHTML_AL_right ))
					eVal = SVX_HOR_JUSTIFY_RIGHT;
				else if (rOptVal.EqualsIgnoreCaseAscii( sHTML_AL_center ))
					eVal = SVX_HOR_JUSTIFY_CENTER;
				else if (rOptVal.EqualsIgnoreCaseAscii( sHTML_AL_left ))
					eVal = SVX_HOR_JUSTIFY_LEFT;
				else
					eVal = SVX_HOR_JUSTIFY_STANDARD;
			}
			break;
			case HTML_O_SDVAL:
			{
				pValue = new String( pOption->GetString() );
			}
			break;
			case HTML_O_SDNUM:
			{
				pValue = new String( pOption->GetString() );
			}
			break;
			case HTML_O_BGCOLOR:
				//m_aFont.SetFillColor(Color((UINT32)pOption->GetString()));
			break;
			case HTML_O_WIDTH:
			{
				m_nWidth = GetWidthPixel( pOption );
			}
			break;
		}
	}
}

//---------------------------------------------------------------------------------
void SbaHTMLReader::TableFontOn(USHORT &nWidth,USHORT &nHeight)
{
	const HTMLOptions* pOptions = GetOptions();
	USHORT nArrLen = pOptions->Count();
	for ( USHORT i = 0; i < nArrLen; i++ )
	{
		const HTMLOption* pOption = (*pOptions)[i];
		switch( pOption->GetToken() )
		{
		case HTML_O_COLOR:
			{
				Color aColor;
				pOption->GetColor( aColor );
				SvxColorItem aItem(*PTR_CAST(SvxColorItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTCOLOR )));
				aItem.SetValue(aColor);
				xTableDef->GetObjAttrs()->Put(aItem);
				xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
			}
			break;
		case HTML_O_FACE :
			{
				const String& rFace = pOption->GetString();
				String aFontName;
				xub_StrLen nPos = 0;
				while( nPos != STRING_NOTFOUND )
				{	// Fontliste, VCL: Semikolon als Separator, HTML: Komma
					String aFName = rFace.GetToken( 0, ',', nPos );
					aFName.EraseTrailingChars().EraseLeadingChars();
					if( aFontName.Len() )
						aFontName += ';';
					aFontName += aFName;
				}
				if ( aFontName.Len() )
				{
					SvxFontItem aItem(*PTR_CAST(SvxFontItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONT )));
					aItem.GetStyleName() = aFontName;
					xTableDef->GetObjAttrs()->Put(aItem);
					xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
				}

			}
			break;
		case HTML_O_SIZE :
			{
				USHORT nSize = (USHORT) pOption->GetNumber();
				if ( nSize == 0 )
					nSize = 1;
				else if ( nSize > SBA_HTML_FONTSIZES )
					nSize = SBA_HTML_FONTSIZES;

				SvxFontHeightItem aItem(*PTR_CAST(SvxFontHeightItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTHEIGHT )));
				aItem.SetHeight(nSize);
				xTableDef->GetObjAttrs()->Put(aItem);
				xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
			}
			break;
		}
	}
}
// ---------------------------------------------------------------------------
USHORT SbaHTMLReader::GetWidthPixel( const HTMLOption* pOption )
{
	const String& rOptVal = pOption->GetString();
	if ( rOptVal.Search('%') != STRING_NOTFOUND )
	{	// Prozent
		DBG_ASSERT( m_nColumnWidth, "WIDTH Option: m_nColumnWidth==0 und Width%" );
		return (USHORT)((pOption->GetNumber() * m_nColumnWidth) / 100);
	}
	else
	{
		if ( rOptVal.Search('*') != STRING_NOTFOUND )
		{	// relativ zu was?!?
//2do: ColArray aller relativen Werte sammeln und dann MakeCol
			return 0;
		}
		else
			return (USHORT)pOption->GetNumber();	// Pixel
	}
}
// ---------------------------------------------------------------------------
SbaColumn* SbaHTMLReader::CreateColumn(String& aColumnName,const String& aTableName,SbaColumnListRef &pDestList)
{
	aColumnName.EraseLeadingChars();
	aColumnName.EraseTrailingChars();
	::staruno::Reference< ::stardata::XDatabaseDescriptor >  xDestMetaData(xDatabase->GetMetaData());	
	INT32 nMaxNameLen(xDestMetaData->getLimit(::stardata::DatabaseLimit::COLUMN_NAME_LEN));

	String aAlias(ShortenFieldName(xDatabase->ConvertName(aColumnName),nMaxNameLen,*pDestList));
	aColumnName = aAlias;

	return xTableDef->CreateColumn(aAlias,dbText,255,0,FALSE,0,pDestList->Count()+1);
}
// ---------------------------------------------------------------------------
BOOL SbaHTMLReader::CreateTableDef(int nToken)
{
	String aTableName(SbaResId(RID_STR_TBL_TITLE));
	aTableName = aTableName.GetToken(0,' ');

	SbaColumnListRef pDestList = NULL;
	int nTmpToken2 = nToken;
	BOOL bCaption = FALSE;
	BOOL bTableHeader = FALSE;
	String aColumnName;
	SvxCellHorJustify eVal;
	String *pValue=NULL;
	USHORT nWidth = 0;
	USHORT nHeight = 0;

	if(!xTableDef.Is())
	{
		//////////////////////////////////////////////////////////////////////////
		// Wenn keine Tabelle zum Anhaengen da ist, neue erzeugen
		aTableName.EraseLeadingChars();
		aTableName.EraseTrailingChars();
		aTableName = xDatabase->GetUniqueName(dbTable,aTableName);
		xTableDef = (SbaTableDef*)xDatabase->CreateDBDef( dbTable, aTableName, TRUE );
		pDestList = &xTableDef->GetColumns();
	}
	do
	{
		switch(nTmpToken2)
		{
			case HTML_TEXTTOKEN:
			case HTML_SINGLECHAR:
				if(bTableHeader)
					aColumnName += aToken;
				if(bCaption)
					aTableName += aToken;
				break;
			case HTML_TABLEDATA_ON:
			case HTML_TABLEHEADER_ON:
				if(pValue)
				{		// HTML_TABLEHEADER_OFF oder HTML_TABLEDATA_OFF fehlte
					aColumnName.EraseLeadingChars();
					aColumnName.EraseTrailingChars();
					if (!aColumnName.Len())
						aColumnName = String(SbaResId(SBA_STR_COLUMN_NAME));

					SbaColumn* pColumn = CreateColumn(aColumnName,aTableName,pDestList);
					pColumn->Put(SvxHorJustifyItem( eVal, SBA_ATTR_ALIGN_HOR_JUSTIFY) );

					pDestList->InsertAt(aColumnName,pColumn);
					aColumnName.Erase();

					DELETEZ(pValue);
					eVal = SVX_HOR_JUSTIFY_STANDARD;
				}
				TableDataOn(eVal,pValue,nTmpToken2);
				bTableHeader = TRUE;
				break;
			case HTML_TABLEDATA_OFF:
			case HTML_TABLEHEADER_OFF:
				{
					aColumnName.EraseLeadingChars();
					aColumnName.EraseTrailingChars();
					if (!aColumnName.Len())
						aColumnName = String(SbaResId(SBA_STR_COLUMN_NAME));

					SbaColumn* pColumn = CreateColumn(aColumnName,aTableName,pDestList);
					pColumn->Put(SvxHorJustifyItem( eVal, SBA_ATTR_ALIGN_HOR_JUSTIFY) );

					pDestList->InsertAt(aColumnName,pColumn);
					aColumnName.Erase();

					SbaColRowSizeItem aRowHeightItem(*PTR_CAST(SbaColRowSizeItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_DEF_ROWHEIGHT )));
					aRowHeightItem.PutPixelValue(nHeight);
					pColumn->Put(SbaColRowSizeItem(SBA_DEF_FLTCOLWIDTH,nWidth));

					DELETEZ(pValue);
					eVal = SVX_HOR_JUSTIFY_STANDARD;
					bTableHeader = FALSE;
				}
				break;

			case HTML_TITLE_ON:
			case HTML_CAPTION_ON:
				bCaption = TRUE;
				break;
			case HTML_TITLE_OFF:
			case HTML_CAPTION_OFF:
				aTableName.EraseLeadingChars();
				aTableName.EraseTrailingChars();
				if(aTableName.Len())
				{
					aTableName = xDatabase->GetUniqueName(dbTable,aTableName);
					xTableDef->Rename(aTableName);
				}
				aTableName.Erase();
				bCaption = FALSE;
				break;
			case HTML_FONT_ON:
				TableFontOn(nWidth,nHeight);
				break;
			case HTML_BOLD_ON:
				{
					SvxWeightItem aItem(*PTR_CAST(SvxWeightItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTWEIGHT )));
					aItem.SetWeight(WEIGHT_BOLD);
					xTableDef->GetObjAttrs()->Put(aItem);
					xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
				}
				break;
			case HTML_ITALIC_ON:
				{
					SvxPostureItem aItem(*PTR_CAST(SvxPostureItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_POSTURE )));
					aItem.SetPosture(ITALIC_NORMAL);
					xTableDef->GetObjAttrs()->Put(aItem);
					xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
				}
				break;
			case HTML_UNDERLINE_ON:
				{
					SvxUnderlineItem aItem(*PTR_CAST(SvxUnderlineItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_UNDERLINE )));
					aItem.SetUnderline(UNDERLINE_SINGLE);
					xTableDef->GetObjAttrs()->Put(aItem);
					xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
				}
				break;
			case HTML_STRIKE_ON:
				{
					SvxCrossedOutItem aItem(*PTR_CAST(SvxCrossedOutItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_CROSSEDOUT )));
					aItem.SetStrikeout(STRIKEOUT_SINGLE);
					xTableDef->GetObjAttrs()->Put(aItem);
					xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());
				}
				break;
		}
	}
	while((nTmpToken2 = GetNextToken()) != HTML_TABLEROW_OFF);

	if(aColumnName.Len())
		pDestList->InsertAt(aColumnName,xTableDef->CreateColumn(aColumnName,dbText,255,0,FALSE,0,pDestList->Count()+1));

	bInTbl = FALSE;

	BOOL bError = FALSE;

	SbaDBDataDefRef xSourceDef = (SbaDBDataDef*)xTableDef;
	CopyTableWizard aWizard(Application::GetDefDialogParent(),xSourceDef,xDatabase);

	DlgCopyTable*		pPage1 = new DlgCopyTable(&aWizard,SbaExplorerExchObj::AT_COPY, FALSE,0);
	SbaWizNameMatching* pPage2 = new SbaWizNameMatching(&aWizard);
	SbaWizColumnSelect* pPage3 = new SbaWizColumnSelect(&aWizard);
	SbaWizHTMLExtend*	pPage4 = new SbaWizHTMLExtend(&aWizard,rInput);

	aWizard.AddWizardPage(pPage1);
	aWizard.AddWizardPage(pPage2);
	aWizard.AddWizardPage(pPage3);
	aWizard.AddWizardPage(pPage4);

	aWizard.ActivatePage();

	if (aWizard.Execute())
	{
		switch(aWizard.GetCreateStyle())
		{
			case CopyTableWizard::WIZARD_DEF_DATA:
			case CopyTableWizard::WIZARD_APPEND_DATA:
				{
					m_bIsAutoIncrement = aWizard.SetAutoincrement();
					m_vColumns = aWizard.GetColumnPositions();
					m_vColumnTypes = aWizard.GetColumnTypes();
					xTableDef = aWizard.GetTableDef();
					void *pTemp = (void *)&m_vColumns;
					map<String,String,SbaStringCompare> aTmp = aWizard.GetNameMapping();
					void* pTemp2 = (void *)&aTmp;
					bError = !SbaExplorerExchObj::CheckColumnMerge(xSourceDef->GetColumns(),xTableDef->GetOriginalColumns(),pTemp,pTemp2);
				}
				break;
			default:
				bError = TRUE; // there is no error but I have nothing more to do
		}
	}
	else
		bError = TRUE;

	if(!bError && xTableDef.Is())
	{
		xDestCursor = xDatabase->CreateCursor( SDB_SNAPSHOT, SDB_APPENDONLY );
		String aDestTableName( xTableDef->Name());
		if (!xDestCursor->Open(aDestTableName, TRUE))
			return FALSE;
	}
	// this two statements are nessesary, else this would let to gpf
	pDestList = NULL; // it must be sure that the list is destroied before def object
	xSourceDef = NULL;


	return !bError && xTableDef.Is();
}

