/*************************************************************************
 *
 *  $RCSfile: sbartf.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#include "rtfcpydg.hxx"
#include "sbartf.hxx"

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _RTFTOKEN_H
#include <svtools/rtftoken.h>
#endif

#include "sbares.hxx"
#include "sbaresid.hrc"

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE		// ohne das bekomme ich einen Compiler-Fehler in <svtools/zforlist.hxx>
#include <svtools/zforlist.hxx>
#endif

#ifndef _ZFORMAT_HXX //autogen
#include <svtools/zformat.hxx>
#endif

#include "sbaitems.hxx"
#include "sbaitems.hrc"

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _HTMLTOKN_H
#include <svtools/htmltokn.h>
#endif

#include "dlgerr.hxx"

#ifndef _DBWHICH_HRC
#include "dbwhich.hrc"
#endif

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif

#ifndef _SVX_UDLNITEM_HXX //autogen
#include <svx/udlnitem.hxx>
#endif

#ifndef _SVX_SHDDITEM_HXX //autogen
#include <svx/shdditem.hxx>
#endif

#ifndef _SVX_CRSDITEM_HXX //autogen
#include <svx/crsditem.hxx>
#endif

#ifndef _SVX_ITEM_HXX //autogen
#include <svx/cntritem.hxx>
#endif

#ifndef _SVX_WGHTITEM_HXX //autogen
#include <svx/wghtitem.hxx>
#endif

#ifndef _SVX_POSTITEM_HXX //autogen
#include <svx/postitem.hxx>
#endif

#ifndef _SVX_FONTITEM_HXX //autogen
#include <svx/fontitem.hxx>
#endif

#ifndef _SVX_FHGTITEM_HXX //autogen
#include <svx/fhgtitem.hxx>
#endif

#include "copytbl.hxx"

namespace staruno = com::sun::star::uno;
namespace stardata = com::sun::star::data;

DBG_NAME(SbaRTFReader);
// ==========================================================================
// SbaRTFReader
// ==========================================================================
SbaRTFReader::SbaRTFReader(SvStream& rIn,SbaDatabase *pDatabase): SvRTFParser(rIn) ,SbaParser(pDatabase)
{
	DBG_CTOR(SbaRTFReader,NULL);
}
// ---------------------------------------------------------------------------
SbaRTFReader::SbaRTFReader(SvStream& rIn,UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf): SvRTFParser(rIn) ,SbaParser(nRows,nColumns,pNf)
{
	DBG_CTOR(SbaRTFReader,NULL);
}
// ---------------------------------------------------------------------------
SbaRTFReader::~SbaRTFReader()
{
	DBG_DTOR(SbaRTFReader,NULL);
}
// ---------------------------------------------------------------------------
SvParserState SbaRTFReader::CallParser()
{
	rInput.Seek(STREAM_SEEK_TO_BEGIN);
	rInput.ResetError();
	return SvRTFParser::CallParser();
}


// ---------------------------------------------------------------------------
void SbaRTFReader::NextToken( int nToken )
{
	if(bError || !m_nRows) // falls Fehler oder keine Rows mehr zur "Uberpr"ufung dann gleich zur"uck
		return;

	if(xDatabase)	  // gibt an welcher CTOR gerufen wurde und damit, ob eine Tabelle erstellt werden soll
	{
		switch(nToken)
		{
			case RTF_COLORTBL:
				{

					int nTmpToken2 = GetNextToken();
					BOOL bNext = TRUE;
					do
					{
						Color aColor;
						do
						{
							switch(nTmpToken2)
							{
								case RTF_RED:	aColor.SetRed(nTokenValue); break;
								case RTF_BLUE:	aColor.SetBlue(nTokenValue); break;
								case RTF_GREEN:	aColor.SetGreen(nTokenValue); break;
								default:
									bNext = FALSE;
							}
							nTmpToken2 = GetNextToken();
						}
						while(aToken.GetChar(0) != ';');
						m_vecColor.push_back(aColor);
						nTmpToken2 = GetNextToken();
					}
					while(nTmpToken2 == RTF_RED);
					SkipToken();
				}
				break;

			case RTF_DEFLANG:
			case RTF_LANG: // Sprache abfragen
				nDefToken = nTokenValue;
				break;
			case RTF_TROWD:
				if(!xTableDef.Is()) // erste Zeile als Header verwenden
					bError = !CreateTableDef(nToken);
				else
					xDestCursor->AppendRow(); // sonst neue Zeile anh"angen
				break;
			case RTF_INTBL:
				if(bInTbl)
					aTextToken.Erase();
				bInTbl = TRUE; // jetzt befinden wir uns in einer Tabellenbeschreibung
				break;
			case RTF_TEXTTOKEN:
			case RTF_SINGLECHAR:
				if(bInTbl) // wichtig, da wir sonst auch die Namen der Fonts bekommen
					aTextToken += aToken;
				break;
			case RTF_CELL:
				{
					SbaColumn* pColumn = xTableDef->GetColumns().GetObject(nColumnPos);
					if(pColumn)
					{
						SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
						if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
						{
							ULONG nPos = m_vColumns[m_bIsAutoIncrement ? nColumnPos+1 : nColumnPos];
							if(nPos != CONTAINER_ENTRY_NOTFOUND)
							{
								if(nDefToken != LANGUAGE_DONTKNOW) // falls Sprache anders als Systemsprache
									m_pNF->ChangeIntl((LanguageType)nDefToken);
								if(!aTextToken.Len() && (*xDestCursor->GetColumns())[nPos]->IsNullAllowed())
									(*xDestCursor->GetRow())[nPos]->setNull();
								else
								{
									ULONG F_Index = 0;
									double fOutNumber = 0.0;
									if (m_vColumnTypes[nColumnPos] != dbText && m_pNF->IsNumberFormat(aTextToken,F_Index,fOutNumber))
									{
										switch (m_pNF->GetType(F_Index))
										{
											case NUMBERFORMAT_DATETIME:
											case NUMBERFORMAT_TIME:
											case NUMBERFORMAT_DATE:
												(*xDestCursor->GetRow())[nPos]->setDouble( SdbTools::ToStandardDate(*m_pNF, fOutNumber) );
												break;
											default:
												(*xDestCursor->GetRow())[nPos]->setDouble( fOutNumber );
										}
									}
									else
										(*xDestCursor->GetRow())[nPos]->setString(UniString(aTextToken));
								}
							}
						}
					}
					nColumnPos++;
					aTextToken.Erase();
				}
				break;
			case RTF_ROW:
				// es kann vorkommen, da die letzte Celle nicht mit \cell abgeschlossen ist
				if(nColumnPos < xTableDef->GetColumns().Count())
				{
					SbaColumn* pColumn = xTableDef->GetColumns().GetObject(nColumnPos);
					if(pColumn)
					{
						SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
						if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
						{
							ULONG nPos = m_vColumns[nColumnPos];
							if(nPos != CONTAINER_ENTRY_NOTFOUND)
							{
								if(nDefToken != LANGUAGE_DONTKNOW)
									m_pNF->ChangeIntl((LanguageType)nDefToken);
								if(!aTextToken.Len() && (*xDestCursor->GetColumns())[nPos]->IsNullAllowed())
									(*xDestCursor->GetRow())[nPos]->setNull();
								else
								{
									ULONG F_Index = 0;
									double fOutNumber = 0.0;
									if(m_vColumnTypes[nColumnPos] != dbText && m_pNF->IsNumberFormat(aTextToken,F_Index,fOutNumber))
									{
										switch (m_pNF->GetType(F_Index))
										{
											case NUMBERFORMAT_DATETIME:
											case NUMBERFORMAT_TIME:
											case NUMBERFORMAT_DATE:
												(*xDestCursor->GetRow())[nPos]->setDouble( SdbTools::ToStandardDate(*m_pNF, fOutNumber) );
												break;
											default:
												(*xDestCursor->GetRow())[nPos]->setDouble( fOutNumber );
										}
									}
									else
										(*xDestCursor->GetRow())[nPos]->setString(UniString(aTextToken));
								}
							}
							aTextToken.Erase();
						}
					}
				}
				m_nRowCount++;
				if(m_bIsAutoIncrement) // if bSetAutoIncrement then I have to set the autoincrement
					(*xDestCursor->GetRow())[1]->setINT32(m_nRowCount);
				xDestCursor->UpdateRow();
				//////////////////////////////////////////////////////////////////////
				// UpdateFehlerbehandlung
				if( xDestCursor->Status().IsError() )
				{
					if(!m_bDontAskAgain)
					{
						String aMsg(xDestCursor->Status().ErrorMessage());
						aMsg += '\n';
						aMsg += String(SbaResId(SBA_STR_QRY_CONTINUE));
						SbaMsgBox aBox(GetpApp()->GetDefDialogParent(), String(SbaResId(SBA_STAT_WARNING)),
							aMsg, WB_YES_NO | WB_DEF_NO, SbaMsgBox::Warning);

						if (aBox.Execute() == RET_YES)
							m_bDontAskAgain = TRUE;
						else
							bError = TRUE;
					}
				}
				nColumnPos = 0;
				break;
		}
	}
	else // Zweig nur f"ur Typpr"ufung g"ultig
	{
		switch(nToken)
		{
			case RTF_TROWD:
				// Der Spalten Kopf z"ahlt nicht mit
				if(m_bHead)
				{
					do
					{}
					while(GetNextToken() != RTF_ROW);
					m_bHead = FALSE;
				}
				break;
			case RTF_INTBL:
				bInTbl = TRUE;
				break;
			case RTF_TEXTTOKEN:
			case RTF_SINGLECHAR:
				if(bInTbl)
					aTextToken += aToken;
				break;
			case RTF_CELL:
				if(aTextToken.Len())
				{
					m_vColumns[nColumnPos] = CheckString(aTextToken,m_vColumns[nColumnPos]);
					m_pColumnSize[nColumnPos] = max(m_pColumnSize[nColumnPos],(UINT32)aTextToken.Len());

					aTextToken.Erase();
				}
				nColumnPos++;
				break;
			case RTF_ROW:
				if(aTextToken.Len())
				{
					m_vColumns[nColumnPos] = CheckString(aTextToken,m_vColumns[nColumnPos]);
					m_pColumnSize[nColumnPos] = max(m_pColumnSize[nColumnPos],(UINT32)aTextToken.Len());
					aTextToken.Erase();
				}
				nColumnPos = 0;
				m_nRows--;
				break;
		}
	}
}
// --------------------------------------------------------------------------------
ULONG SbaRTFReader::CheckString(const String& aCheckToken, ULONG nOldFormat)
{
	ULONG F_Index = 0;
	double fOutNumber = 0.0;
	ULONG nFormat = 0;

	if(m_pNF->IsNumberFormat(aCheckToken,F_Index,fOutNumber))
	{
		m_pFormatKeys[nColumnPos] = F_Index; // wird sp"ater f"ur die SbaColumn gebraucht
		short nType = m_pNF->GetType(F_Index) &~NUMBERFORMAT_DEFINED;
		nFormat = nType;
		switch(nType)
		{
			case NUMBERFORMAT_ALL:
				nFormat = NUMBERFORMAT_ALL;
				break;
			case NUMBERFORMAT_DEFINED:
				nFormat = NUMBERFORMAT_TEXT;
				break;
			case NUMBERFORMAT_DATE:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_TEXT:
					case NUMBERFORMAT_DATE:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_DATE;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;

				}
				break;
			case NUMBERFORMAT_TIME:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_TEXT:
					case NUMBERFORMAT_TIME:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_TIME;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						break;
				}
				break;
			case NUMBERFORMAT_CURRENCY:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_NUMBER:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					case NUMBERFORMAT_CURRENCY:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						break;
				}
				break;
			case NUMBERFORMAT_NUMBER:
			case NUMBERFORMAT_SCIENTIFIC:
			case NUMBERFORMAT_FRACTION:
			case NUMBERFORMAT_PERCENT:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_NUMBER:
						break;
					case NUMBERFORMAT_CURRENCY:
						nFormat = NUMBERFORMAT_CURRENCY;
						break;
					case NUMBERFORMAT_ALL:
						nFormat = nType;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						break;
				}
				break;
			case NUMBERFORMAT_TEXT:
			case NUMBERFORMAT_UNDEFINED:
			case NUMBERFORMAT_LOGICAL:
				nFormat = NUMBERFORMAT_TEXT; // Text "uberschreibt alles
				break;
			case NUMBERFORMAT_DATETIME:
				switch(nOldFormat)
				{
					case NUMBERFORMAT_DATETIME:
					case NUMBERFORMAT_TEXT:
					case NUMBERFORMAT_TIME:
						break;
					case NUMBERFORMAT_ALL:
						nFormat = NUMBERFORMAT_DATETIME;
						break;
					default:
						nFormat = NUMBERFORMAT_TEXT;
						break;
				}
				break;
			default:
				DBG_ERROR("RTFReader: Unbekanntes Format");
		}
	}
	else
	{
		m_pFormatKeys[nColumnPos] =	100;
		nFormat = NUMBERFORMAT_TEXT; // Text "uberschreibt alles
	}

	return nFormat;
}
// ---------------------------------------------------------------------------
SbaColumnList& SbaRTFReader::FillColumnTypes(SbaColumnList& rList)
{
	if(xDatabase)
		return rList;
	for(ULONG i=0;i < rList.Count();i++)
	{
		SbaColumn *pColumn = rList.GetObject(i);
		SbaFieldType eFieldType;
		UINT32 nLength(0),nScale(0);
		switch(m_vColumns[i])
		{
			case NUMBERFORMAT_ALL:
				eFieldType  = dbNumeric;
				nLength		= dbDouble;
				break;
			case NUMBERFORMAT_DEFINED:
				eFieldType	= dbText;
				nLength		= ((m_pColumnSize[i] % 10 ) ? m_pColumnSize[i]/ 10 + 1: m_pColumnSize[i]/ 10) * 10;
				break;
			case NUMBERFORMAT_DATE:
				eFieldType	= dbDate;
				break;
			case NUMBERFORMAT_TIME:
				eFieldType	= dbTime;
				break;
			case NUMBERFORMAT_DATETIME:
				eFieldType	= dbDateTime;
				break;
			case NUMBERFORMAT_CURRENCY:
				eFieldType	= dbCurrency;
				nScale		= 4;
				nLength		= 19;
				break;
			case NUMBERFORMAT_NUMBER:
			case NUMBERFORMAT_SCIENTIFIC:
			case NUMBERFORMAT_FRACTION:
			case NUMBERFORMAT_PERCENT:
				eFieldType  = dbNumeric;
				nLength		= dbDouble;
				break;
			case NUMBERFORMAT_TEXT:
			case NUMBERFORMAT_UNDEFINED:
			case NUMBERFORMAT_LOGICAL:
				eFieldType	= dbText;
				nLength		= ((m_pColumnSize[i] % 10 ) ? m_pColumnSize[i]/ 10 + 1: m_pColumnSize[i]/ 10) * 10;
				break;

			default:
				DBG_ERROR("RTFReader: Unbekanntes Format");
		}

		pColumn->Put(SbaDataFieldTypeItem(SBA_DEF_FLTTYPE,(SbaFieldType) eFieldType ));
		pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH,nLength));
		pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE,nScale));
		pColumn->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, m_pFormatKeys[i]));
	}

	return rList;
}
// ---------------------------------------------------------------------------
BOOL SbaRTFReader::CreateTableDef(int nToken)
{
	String aTableName(SbaResId(RID_STR_TBL_TITLE));
	aTableName = aTableName.GetToken(0,' ');
	//////////////////////////////////////////////////////////////////////////
	// Wenn keine Tabelle zum Anhaengen da ist, neue erzeugen
	aTableName = xDatabase->GetUniqueName(dbTable,aTableName);
	xTableDef = (SbaTableDef*)xDatabase->CreateDBDef( dbTable, aTableName, TRUE );
	SbaColumnList& rDestList = xTableDef->GetColumns();
	int nTmpToken2 = nToken;
	String aColumnName;
	BOOL bColorSet=FALSE;
	BOOL bBoldSet=FALSE;
	BOOL bUnderlineSet=FALSE;
	BOOL bStrikeoutSet=FALSE;
	BOOL bItalicSet=FALSE;

	SvxFontItem			aFontItem		(*PTR_CAST(SvxFontItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONT )));
	SvxFontHeightItem	aFontHeightItem	(*PTR_CAST(SvxFontHeightItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTHEIGHT )));
	SvxColorItem		aColorItem		(*PTR_CAST(SvxColorItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTCOLOR )));
	SbaColRowSizeItem	aRowHeightItem	(*PTR_CAST(SbaColRowSizeItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_DEF_ROWHEIGHT )));
	SvxWeightItem		aWeightItem		(*PTR_CAST(SvxWeightItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_FONTWEIGHT )));
	SvxUnderlineItem	aUnderlineItem	(*PTR_CAST(SvxUnderlineItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_UNDERLINE )));
	SvxCrossedOutItem	aStrikeoutItem	(*PTR_CAST(SvxCrossedOutItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_CROSSEDOUT )));
	SvxPostureItem		aItalicItem		(*PTR_CAST(SvxPostureItem,&((SbaDBDataDef*)&xTableDef)->GetObjAttrs()->Get( SBA_BRW_POSTURE )));

	/*aFontItem.GetStyleName() = aFontName;
	xTableDef->GetObjAttrs()->Put(aFontItem);
	xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());*/
	do
	{
		switch(nTmpToken2)
		{
			case RTF_UNKNOWNCONTROL:
			case RTF_UNKNOWNDATA:
				bInTbl = FALSE;
				aColumnName.Erase();
				break;
			case RTF_INTBL:
				if(bInTbl)
					aColumnName.Erase();

				bInTbl = TRUE;
				break;
			case RTF_TEXTTOKEN:
			case RTF_SINGLECHAR:
				if(bInTbl)
					aColumnName += aToken;
				break;
			case RTF_CELL:
				{
					aColumnName.EraseLeadingChars();
					aColumnName.EraseTrailingChars();
					if (!aColumnName.Len())
						aColumnName = String(SbaResId(SBA_STR_COLUMN_NAME));

					::staruno::Reference< ::stardata::XDatabaseDescriptor >  xDestMetaData(xDatabase->GetMetaData());	
					INT32 nMaxNameLen(xDestMetaData->getLimit(::stardata::DatabaseLimit::COLUMN_NAME_LEN));					
					String aAlias(ShortenFieldName(xDatabase->ConvertName(aColumnName),nMaxNameLen,rDestList));
					rDestList.InsertAt(aAlias,xTableDef->CreateColumn(aAlias,dbText,255,0,FALSE,0,rDestList.Count()+1));
					aColumnName.Erase();
				}
				break;
			case RTF_CF:
				if(nTokenValue < m_vecColor.size())
					aColorItem.SetValue(m_vecColor[nTokenValue]);
				break;
			case RTF_B:
				aWeightItem.SetWeight(WEIGHT_BOLD);
				break;
			case RTF_I:
				aItalicItem.SetPosture(ITALIC_NORMAL);
				break;
			case RTF_UL:
				aUnderlineItem.SetUnderline(UNDERLINE_SINGLE);
				break;
			case RTF_STRIKE:
				aStrikeoutItem.SetStrikeout(STRIKEOUT_SINGLE);
				break;
		}
	}
	while((nTmpToken2 = GetNextToken()) != RTF_ROW);

	xTableDef->GetObjAttrs()->Put(aColorItem);
	xTableDef->GetObjAttrs()->Put(aWeightItem);
	xTableDef->GetObjAttrs()->Put(aItalicItem);
	xTableDef->GetObjAttrs()->Put(aUnderlineItem);
	xTableDef->GetObjAttrs()->Put(aStrikeoutItem);
	xTableDef->PutObjAttrs(*xTableDef->GetObjAttrs());

	if(aColumnName.Len())
		rDestList.InsertAt(aColumnName,xTableDef->CreateColumn(aColumnName,dbText,255,0,FALSE,0,rDestList.Count()+1));

	bInTbl = FALSE;

	BOOL bError = FALSE;

	SbaDBDataDefRef xSourceDef = (SbaDBDataDef*)xTableDef;
	CopyTableWizard aWizard(Application::GetDefDialogParent(),xSourceDef,xDatabase);

	DlgCopyTable*		pPage1 = new DlgCopyTable(&aWizard,SbaExplorerExchObj::AT_COPY, FALSE,0);
	SbaWizNameMatching* pPage2 = new SbaWizNameMatching(&aWizard);
	SbaWizColumnSelect* pPage3 = new SbaWizColumnSelect(&aWizard);
	SbaWizRTFExtend*	pPage4 = new SbaWizRTFExtend(&aWizard,rInput);

	aWizard.AddWizardPage(pPage1);
	aWizard.AddWizardPage(pPage2);
	aWizard.AddWizardPage(pPage3);
	aWizard.AddWizardPage(pPage4);

	aWizard.ActivatePage();

	if (aWizard.Execute())
	{
		switch(aWizard.GetCreateStyle())
		{
			case CopyTableWizard::WIZARD_DEF_DATA:
			case CopyTableWizard::WIZARD_APPEND_DATA:
				{
					m_bIsAutoIncrement = aWizard.SetAutoincrement();
					m_vColumns = aWizard.GetColumnPositions();
					m_vColumnTypes = aWizard.GetColumnTypes();
					xTableDef = aWizard.GetTableDef();
					void *pTemp = (void *)&m_vColumns;
					map<String,String,SbaStringCompare> aTmp = aWizard.GetNameMapping();
					void* pTemp2 = (void *)&aTmp;
					bError = !SbaExplorerExchObj::CheckColumnMerge(xSourceDef->GetColumns(),xTableDef->GetOriginalColumns(),pTemp,pTemp2);
				}
				break;
			default:
				bError = TRUE; // there is no error but I have nothing more to do
		}
	}
	else
		bError = TRUE;

	if(!bError && xTableDef.Is())
	{
		xDestCursor = xDatabase->CreateCursor( SDB_SNAPSHOT, SDB_APPENDONLY );
		String aDestTableName( xTableDef->Name());
		if (!xDestCursor->Open(aDestTableName, TRUE))
			return FALSE;
	}
	// this two statements are nessesary, else this would let to gpf
	//pDestList = NULL; // it must be sure that the list is destroied before def object
	xSourceDef = NULL;

	return !bError && xTableDef.Is();
}


