/*************************************************************************
 *
 *  $RCSfile: ldapsrch.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif
#pragma hdrstop

#include "ldapsrch.hrc"
#include "ldapsrch.hxx"
#include "sbares.hxx"
#include "addrpi.hxx"

#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SFX_INIMGR_HXX //autogen
#include <sfx2/inimgr.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _INET_WRAPPER_HXX //autogen
#include <inet/wrapper.hxx>
#endif
#ifndef _INETLDAP_HXX //autogen
#include <inet/inetldap.hxx>
#endif
#ifndef _INET_LDAPWRAP_HXX //autogen
#include <inet/ldapwrap.hxx>
#endif
#ifndef _FACTORY_HXX //autogen
#include <so3/factory.hxx>
#endif
#ifndef __RSC //autogen
#include <tools/errinf.hxx>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _SFX_SFXUNO_HXX
#include <sfx2/sfxuno.hxx>
#endif
#ifndef _EHDL_HXX
#include <svtools/ehdl.hxx>
#endif
#ifndef _SFXECODE_HXX
#include <svtools/sfxecode.hxx>
#endif

/*#ifndef _SMART_COM_SUN_STAR_SCHEDULE_XSCHEDULECURSOR_HXX_
#include <smart/com/sun/star/schedule/XScheduleCursor.hxx>
#endif*/

// Common Errors ---------------------------------------------------------

static const char __FAR_DATA * pCommonErrors[] =
{
	/*   0: */  "'Success' (0x00)",
	/*   1: */  "'Operations error' (0x01)",
	/*   2: */  "'Protocol error' (0x02)",
	/*   3: */  "'Timelimit exceeded' (0x03)",
	/*   4: */  "'Sizelimit exceeded' (0x04)",
	/*   5: */  "'CompareTo false' (0x05)",
	/*   6: */  "'CompareTo true' (0x06)",
	/*   7: */  "'Authentication method not supported' (0x07)",
	/*   8: */  "'Strong authentication required' (0x08)",
	/*   9: */  "(0x09)",
	/*  10: */  "(0x09)",
	/*  11: */  "(0x0A)",
	/*  12: */  "(0x0B)",
	/*  13: */  "(0x0C)",
	/*  14: */  "(0x0D)",
	/*  15: */  "(0x0E)",
	/*  16: */  "'No such attribute' (0x10)",
	/*  17: */  "'Undefined attribute type' (0x11)",
	/*  18: */  "'Inappropriate matching' (0x12)",
	/*  19: */  "'Constraint violating' (0x13)",
	/*  20: */  "'Attribute or value exists' (0x14)",
	/*  21: */  "'Invalid attribute syntax' (0x15)",
	/*  22: */  "(0x16)",
	/*  23: */  "(0x17)",
	/*  24: */  "(0x18)",
	/*  25: */  "(0x19)",
	/*  26: */  "(0x1A)",
	/*  27: */  "(0x1B)",
	/*  28: */  "(0x1C)",
	/*  29: */  "(0x1D)",
	/*  30: */  "(0x1E)",
	/*  31: */  "(0x1F)",
	/*  32: */  "'No such object' (0x20)",
	/*  33: */  "'Alias problem' (0x21)",
	/*  34: */  "'Invalid DN syntax' (0x22)",
	/*  35: */  "'Is leaf' (0x23)",
	/*  36: */  "'Alias derefering problem' (0x24)",
	/*  37: */  "(0x25)",
	/*  38: */  "(0x26)",
	/*  39: */  "(0x27)",
	/*  40: */  "(0x28)",
	/*  41: */  "(0x29)",
	/*  42: */  "(0x2A)",
	/*  43: */  "(0x2B)",
	/*  44: */  "(0x2C)",
	/*  45: */  "(0x2D)",
	/*  46: */  "(0x2E)",
	/*  47: */  "(0x2F)",
	/*  48: */  "'Inappropriate authentication' (0x30)",
	/*  49: */  "'Invalid credentials' (0x31)",
	/*  50: */  "'Insufficient access rights' (0x32)",
	/*  51: */  "'Busy' (0x33)",
	/*  52: */  "'Unavailable' (0x34)",
	/*  53: */  "'Unwilling to perform' (0x35)",
	/*  54: */  "'Loop detect' (0x36)",
	/*  55: */  "(0x37)",
	/*  56: */  "(0x38)",
	/*  57: */  "(0x39)",
	/*  58: */  "(0x3A)",
	/*  59: */  "(0x3B)",
	/*  60: */  "(0x3C)",
	/*  61: */  "(0x3D)",
	/*  62: */  "(0x3E)",
	/*  63: */  "(0x3F)",
	/*  64: */  "'Naming violation' (0x40)",
	/*  65: */  "'Object class violation' (0x41)",
	/*  66: */  "'Not allowed on nonleaf' (0x42)",
	/*  67: */  "'Not allowed on RDN' (0x43)",
	/*  68: */  "'Entry already exists' (0x44)",
	/*	69: */	"'Object class mods prohibited' (0x45)",
	/*  70: */  "(0x46)",
	/*  71: */  "(0x47)",
	/*  72: */  "(0x48)",
	/*  73: */  "(0x49)",
	/*  74: */  "(0x4A)",
	/*  75: */  "(0x4B)",
	/*  76: */  "(0x4C)",
	/*  77: */  "(0x4D)",
	/*  78: */  "(0x4E)",
	/*  79: */  "(0x4F)",
	/*  80: */  "'Unknown error' (0x50)",
	/*  81: */	0
};

#define MAX_COMMON_ERROR	80

// struct SbaLDAPSearchResult_Impl ---------------------------------------

struct SbaLDAPSearchResult_Impl
{
	String		aCommonName;
	String		aGivenName;
	String		aSurName;
	String		aCountry;
	String		aLocation;
	String		aOrganization;
	String		aEmail;
	String		aTelephoneNumber;
	String		aState;
	String		aCalendarURL;
	String		aKuerzel;
};

// class SbaLDAPSearchResultList_Impl ------------------------------------

SV_DECL_PTRARR_DEL(SbaLDAPSearchResultList_Impl,SbaLDAPSearchResult_Impl*,1,1)
SV_IMPL_PTRARR(SbaLDAPSearchResultList_Impl,SbaLDAPSearchResult_Impl*)

// class LDAPFilterList_Impl ---------------------------------------------

SV_DECL_PTRARR_DEL(LDAPFilterList_Impl,INetCoreLDAPFilter*,1,1)
SV_IMPL_PTRARR(LDAPFilterList_Impl,INetCoreLDAPFilter*)

// class SbaLDAPSearcher -------------------------------------------------

#define WRAPPER()		pSearcher->pWrapper
#define CONN()			pSearcher->xConnection
#define SERVERLST()		pSearcher->pServerList
#define RESULTLST()		pSearcher->pResultList
#define REPLYCODE()		pSearcher->nReplyCode
#define STATE()			pSearcher->eState
#define FINISHED()		pSearcher->bFinished
#define FINLINK()		pSearcher->aFinishedLink
#define SEARCHSTR()		pSearcher->aSearchStr
#define SERVERSTR()		pSearcher->aServerStr
#define REPLYSTR()		pSearcher->aReplyStr
#define ADDRPI()		pSearcher->pAddrPI

int SbaLDAPSearcher::RequestCallback
(
	INetCoreLDAPConnection* pConnection,
	int nReplyCode,
	const void* pReplyData,
	USHORT nMsgID,
	SbaLDAPSearcher* pSearcher
)

/*	[Beschreibung]

	Callback f"ur die asynchrone Suche.
*/

{
	if ( FINISHED() )
		return 1;

	String aServer = SERVERSTR().GetToken( LDAP_DESCRIPTION, LDAP_TOKEN_DELIMITER );

	switch ( nReplyCode )
	{
		// wenn die Connection Erfolgreich ist -> State auf open
		case INETCORELDAP_REPLY_CONNECT_DONE:
			STATE() = STATE_OPEN;
			break;

		case INETCORELDAP_REPLY_NETWORK_ERROR:
		case INETCORELDAP_REPLY_RESOLVER_ERROR:
		case INETCORELDAP_REPLY_CONNECT_ERROR:
		case INETCORELDAP_REPLY_REQUEST_ERROR:
		case INETCORELDAP_REPLY_RESPONSE_ERROR:
		case INETCORELDAP_REPLY_CONNECTION_TERMINATED:
		{
			FASTBOOL bEnd = ( INETCORELDAP_REPLY_NETWORK_ERROR == nReplyCode ||
							  INETCORELDAP_REPLY_CONNECTION_TERMINATED == nReplyCode );

			if ( !FINISHED() && INETCORELDAP_REPLY_CONNECTION_TERMINATED != nReplyCode )
			{
				// Fehlermeldung
				ULONG nErr = 0;

				switch ( nReplyCode )
				{
					case INETCORELDAP_REPLY_NETWORK_ERROR:
						nErr = ERRCODE_INET_GENERAL; break;
					case INETCORELDAP_REPLY_RESOLVER_ERROR:
						nErr = ERRCODE_INET_NAME_RESOLVE; break;
					case INETCORELDAP_REPLY_CONNECT_ERROR:
						nErr = ERRCODE_INET_CONNECT; break;
					case INETCORELDAP_REPLY_REQUEST_ERROR:
						nErr = ERRCODE_INET_READ; break;
					case INETCORELDAP_REPLY_RESPONSE_ERROR:
						nErr = ERRCODE_INET_WRITE; break;
				}
				SfxErrorContext aCtx( ERRCTX_SFX_SEARCHADDRESS, ADDRPI() );
				ErrorHandler::HandleError( *( new StringErrorInfo( nErr, aServer ) ) );
			}

			if ( bEnd )
			{
				CONN() = NULL;

				if ( !FINISHED() )
				{
					NAMESPACE_VOS( OGuard ) aGuard( Application::GetSolarMutex() );
					FINISHED() = TRUE;
					pSearcher->pAddrPI->HideStatusText();
					FINLINK().Call( pSearcher );
				}
			}
			break;
		}

		case INETCORELDAP_REPLY_RESPONSE_DONE:
		{
			if ( pReplyData )
			{
				const INetCoreLDAPResult* pResult = (const INetCoreLDAPResult*)pReplyData;
				REPLYCODE() = pResult->GetResultCode();
				pResult->GetErrorMessage( ::rtl::OUString(REPLYSTR()) );
			}
			break;
		}

		case INETCORELDAP_REPLY_SEARCHENTRY:
		{
			if ( pReplyData )
			{
				NAMESPACE_VOS( OGuard ) aGuard( Application::GetSolarMutex() );
				USHORT nCount = RESULTLST()->Count() + 1;
				String aStatus( SbaResId( RID_LDAP_STATUS_FOUND ) );
				aStatus.SearchAndReplaceAscii( "%1", aServer );
				aStatus.SearchAndReplaceAscii( "%2", String::CreateFromInt32( nCount ) );
				pSearcher->pAddrPI->ShowStatusText( aStatus );

				const INetCoreLDAPEntry* pEntry = (const INetCoreLDAPEntry*)pReplyData;
				SbaLDAPSearchResult_Impl* pResult = new SbaLDAPSearchResult_Impl;
				USHORT nCnt = pEntry->GetAttributeCount();
				INetCoreLDAPAttribute* pAttrs = NULL;

				for ( USHORT i = 0; i < nCnt; ++i )
				{
					::rtl::OUString aOUType, aOUTmp;
					String aType, aValue;
					pAttrs = pEntry->GetAttribute(i);
					pAttrs->GetType( aOUType );
					aType = String( aOUType );
					USHORT nValCnt = pAttrs->GetValueCount();

					for ( USHORT j = 0; j < nValCnt; ++j )
					{
						pAttrs->GetValue( aOUTmp, 0 );

						if ( aValue.Len() )
						{
							aValue += ',';
							aValue += ' ';
						}
						aValue += String( aOUTmp );
					}
					delete pAttrs;

					if ( aType.CompareIgnoreCaseToAscii( "cn" ) == COMPARE_EQUAL )
						pResult->aCommonName = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "givenName" ) == COMPARE_EQUAL )
						pResult->aGivenName = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "sn" ) == COMPARE_EQUAL )
						pResult->aSurName = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "c" ) == COMPARE_EQUAL )
						pResult->aCountry = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "l" ) == COMPARE_EQUAL )
						pResult->aLocation = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "o" ) == COMPARE_EQUAL )
						pResult->aOrganization = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "mail" ) == COMPARE_EQUAL )
						pResult->aEmail = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "telephoneNumber" ) == COMPARE_EQUAL )
						pResult->aTelephoneNumber = aValue;
					else if ( aType.CompareIgnoreCaseToAscii( "sp" ) == COMPARE_EQUAL )
						pResult->aState = aValue;
				}
				RESULTLST()->C40_INSERT( SbaLDAPSearchResult_Impl, pResult, RESULTLST()->Count() );
			}
			break;
		}

		default:
			break;
	}

	switch ( STATE() )
	{
		case STATE_OPEN:
		{
			// nach dem "Offnen jetzt verbinden
			if ( INETCORELDAP_REPLY_CONNECT_DONE == nReplyCode && CONN().isValid() )
			{
				String aEmptyStr;
				STATE() = STATE_BIND;

				if ( !CONN()->Bind( aEmptyStr, aEmptyStr ) )
				{
					// Fehler?
				}
			}
			break;
		}

		case STATE_BIND:
		{
			// nach dem Verbinden kann jetzt gesucht werden
			if ( INETCORELDAP_REPLY_RESPONSE_DONE == nReplyCode && CONN().isValid() )
			{
				NAMESPACE_VOS( OGuard ) aGuard( Application::GetSolarMutex() );
				String aStatus( SbaResId( RID_LDAP_STATUS_SEARCH ) );
				aStatus.SearchAndReplaceAscii( "%1", aServer );
				pSearcher->pAddrPI->ShowStatusText( aStatus );

				STATE() = STATE_SEARCH;
				INetCoreLDAPFilter* pFilter = NULL;
				String aSearchStr = SEARCHSTR();
				USHORT nCount = aSearchStr.GetTokenCount( LDAP_TOKEN_DELIMITER );
				LDAPFilterList_Impl aFilterList;

				if ( 1 == nCount )
				{
					String aType = aSearchStr.GetToken( 0, '=' );
					String aValue = aSearchStr.GetToken( 1, '=' );
					INetCoreLDAPSubstringFilter* pTemp = NULL;

					if ( WRAPPER()->newLDAPSubstringFilter( pTemp ) )
					{
						pFilter = pTemp;
						aFilterList.C40_INSERT( INetCoreLDAPFilter, pFilter, aFilterList.Count() );
						INetCoreLDAPSubstringPosition ePos = INETCORELDAP_SUBSTRING_ANY;
						if ( aValue.GetChar(0) == '*' )
							ePos = INETCORELDAP_SUBSTRING_FINAL;
						else if ( aValue.GetChar( aValue.Len() - 1 ) == '*' )
							ePos = INETCORELDAP_SUBSTRING_INITIAL;
						( (INetCoreLDAPSubstringFilter*)pFilter )->SetAttributeType( aType );
						( (INetCoreLDAPSubstringFilter*)pFilter )->SetSubstring( aValue, ePos );
					}
				}
				else
				{
					INetCoreLDAPAndFilter* pTemp = NULL;

					if ( WRAPPER()->newLDAPAndFilter( pTemp ) )
					{
						pFilter = pTemp;
						aFilterList.C40_INSERT( INetCoreLDAPFilter, pFilter, aFilterList.Count() );

						for ( USHORT i = 0; i < nCount; ++i )
						{
							String aToken = aSearchStr.GetToken( i, LDAP_TOKEN_DELIMITER );
							String aType = aToken.GetToken( 0, '=' );
							String aValue = aToken.GetToken( 1, '=' );

							if ( !aType.Len() || !aValue.Len() )
								continue;
							INetCoreLDAPSubstringFilter* pSubFilter = NULL;
							if ( WRAPPER()->newLDAPSubstringFilter( pSubFilter ) )
							{
								INetCoreLDAPFilter* pTmp = pSubFilter;
								aFilterList.C40_INSERT( INetCoreLDAPFilter, pTmp, aFilterList.Count() );
								INetCoreLDAPSubstringPosition ePos = INETCORELDAP_SUBSTRING_ANY;
								if ( aValue.GetChar(0) == '*' )
									ePos = INETCORELDAP_SUBSTRING_FINAL;
								else if ( aValue.GetChar( aValue.Len() - 1 ) == '*' )
									ePos = INETCORELDAP_SUBSTRING_INITIAL;
								pSubFilter->SetAttributeType( aType );
								pSubFilter->SetSubstring( aValue, ePos );
								( (INetCoreLDAPAndFilter*)pFilter )->SetFilter( *pSubFilter );
							}
						}
					}
				}
				INetCoreLDAPSearchRequestMessage* pSearch  = NULL;
				if ( WRAPPER()->newLDAPSearchRequestMessage( pSearch ) )
				{
					String aRoot = SERVERSTR().GetToken( LDAP_SEARCHROOT, LDAP_TOKEN_DELIMITER );
					String aHits = SERVERSTR().GetToken( LDAP_MAXHITS, LDAP_TOKEN_DELIMITER );
					pSearch->SetMessageID( 0 );
					pSearch->SetBaseObject( aRoot );
					pSearch->SetScope( INETCORELDAP_SEARCH_SCOPE_WHOLESUBTREE );
					pSearch->SetDerefAlias( INETCORELDAP_SEARCH_DEREF_FINDING_BASEOBJECT );
					pSearch->SetSizeLimit( aHits.ToInt32() );
					pSearch->SetTimeLimit( 0 );
					pSearch->SetAttributesOnly( FALSE );
					pSearch->SetFilter( *pFilter );
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("cn"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("sn"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("givenName"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("c"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("l"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("o"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("mail"));
					pSearch->SetAttributeType(::rtl::OUString::createFromAscii("telephoneNumber"));

					if ( !pConnection->Search( *pSearch ) )
					{
						// Fehler?
					}
					delete pSearch;
				}
			}
			break;
		}

		case STATE_SEARCH:
		{
			// nach dem Suchen wieder schliessen
			if ( INETCORELDAP_REPLY_RESPONSE_DONE == nReplyCode && CONN().isValid() )
			{
				String aEmptyStr;
				STATE() = STATE_FINISHED;
				FASTBOOL bFinished = !FINISHED();
				FINISHED() = TRUE;
				CONN()->Unbind();
				CONN() = NULL;

				if ( bFinished )
				{
					NAMESPACE_VOS( OGuard ) aGuard( Application::GetSolarMutex() );
					FINISHED() = TRUE;
					pSearcher->pAddrPI->HideStatusText();
					FINLINK().Call( pSearcher );
				}
			}
			break;
		}

		case STATE_FINISHED:
		case STATE_CANCEL:
			break;
	}
	return 1;
}

// -----------------------------------------------------------------------

SbaLDAPSearcher::SbaLDAPSearcher( SbaAddrPI* pParent ) :

/*	[Beschreibung]

	Konstruktor: aus der Ini werden alle LDAP-Server-Ini-Strings
	in eine Liste eingef"ugt.
*/

	pWrapper	( NULL ),
	pServerList	( NULL ),
	pResultList	( NULL ),
	pAddrPI		( pParent ),
	nReplyCode	( INETCORELDAP_RESULT_SUCCESS ),
	eState		( STATE_INIT ),
	bFinished	( FALSE )

{
	USHORT i = 0;
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	String aServer = pIniMgr->Get( SFX_KEY_LDAP_SERVER, i++ );

	if ( aServer.Len() )
		pServerList = new SvStringsDtor;

	while ( aServer.Len() )
	{
		String* pStr = new String( aServer );
		pServerList->Insert( pStr, pServerList->Count() );
		aServer = pIniMgr->Get( SFX_KEY_LDAP_SERVER, i++ );
	}
}

// -----------------------------------------------------------------------

SbaLDAPSearcher::~SbaLDAPSearcher()

/*	[Beschreibung]

	Destruktor
*/

{
	delete pWrapper;
	delete pServerList;
	delete pResultList;
}

// -----------------------------------------------------------------------

BOOL SbaLDAPSearcher::Search( const String& rServer, const String& rSrchStr )

/*	[Beschreibung]

	Diese Methode sucht den Ini-String, passend zum 'rServer' und
	"offnet damit eine LDAP-Verbindung.

	[R"uckgabewert]

	TRUE: 	Verbindung konnte ge"offnet werden -> Suche l"auft.
	FALSE:	Ini-String nicht gefunden oder
			Verbindung konnte nicht hergestellt werden
*/

{
	SfxApplication* pSfxApp = SFX_APP();
	/*
	CntSystem* 	pCntSys = CntSystem::GetMgr();
	CntConnMode eMode = (CntConnMode)
		( (CntConnModeItem&)pCntSys->Get( WID_CONNECTION_MODE ) ).GetValue();

	// wenn im Offline-Modus dann ggf. auf Online schalten
	if ( CNT_CONN_MODE_OFFLINE == eMode )
	{
		QueryBox aBox( Application::GetDefDialogParent(),
					   SbaResId( RID_LDAP_QUERY_OFFLINE ) );

		if ( aBox.Execute() == RET_YES )

			pCntSys->Put( CntConnModeItem(
				WID_CONNECTION_MODE, CNT_CONN_MODE_ONLINE ) );
		else
			return FALSE;
	}
	*/
	delete pResultList;
	pResultList = new SbaLDAPSearchResultList_Impl;
	nReplyCode = INETCORELDAP_RESULT_SUCCESS;
	nCurrentRow = 0;
	eState = STATE_INIT;
	bFinished = FALSE;
	aSearchStr.Erase();
	aServerStr.Erase();
	aReplyStr.Erase();

	if ( !pServerList || !pServerList->Count() )
		return FALSE;

	for ( USHORT i = 0; i < pServerList->Count(); ++i )
	{
		String aName = pServerList->GetObject(i)->
			GetToken( LDAP_DESCRIPTION, LDAP_TOKEN_DELIMITER );

		if ( rServer == aName )
		{
			aServerStr = *(*pServerList)[i];
			break;
		}
	}

	if ( !aServerStr.Len() )
		return FALSE;

	if ( !pWrapper )
	{
		NAMESPACE_INET(INetWrapper)* pINetWrapper = SvFactory::GetINetWrapper();
		pINetWrapper->newINetLDAPWrapper( pWrapper );
	}

	if ( !pWrapper )
		return FALSE;

	if ( !xConnection.isValid() && !pWrapper->newLDAPConnection( xConnection ) )
		return FALSE;

	aSearchStr = rSrchStr;
	// SBI: der State ist erst OPEN, wenn der xConnection->Open - Aufruf unten geglueckt
	// ist. Das bekommen wir ueber den RequestCallback mit
	// eState = STATE_OPEN;
	String aHost = aServerStr.GetToken( LDAP_SERVER, LDAP_TOKEN_DELIMITER );
	String aPort = aServerStr.GetToken( LDAP_PORT, LDAP_TOKEN_DELIMITER );
	USHORT nPort = 389;

	if ( aPort.Len() && ByteString(::rtl::OUStringToOString(aPort,RTL_TEXTENCODING_UTF8)).IsNumericAscii() )
		nPort = aPort.ToInt32();

	String aStatus( SbaResId( RID_LDAP_STATUS_CONNECT ) );
	aStatus.SearchAndReplaceAscii( "%1", aServerStr.GetToken( LDAP_DESCRIPTION, LDAP_TOKEN_DELIMITER ) );
	pAddrPI->ShowStatusText( aStatus );

	if ( !xConnection->Open( aHost, nPort, (INetCoreLDAPCallback*)RequestCallback, this ) )
	{
		pAddrPI->HideStatusText();
		xConnection = NULL;
		return FALSE;
	}
	return TRUE;
}

/*
void SbaLDAPSearcher::Init( const XScheduleCursorRef& xCursor )
{
	Init();
	delete pResultList;
	pResultList = new SbaLDAPSearchResultList_Impl;
	xCursor->moveToFirst();
	XPropertySetRef xRecord = xCursor->getRecord();
	while( xCursor->isValid() )
	{
		SbaLDAPSearchResult_Impl* pResult = new SbaLDAPSearchResult_Impl;
		::rtl::OUString aName( xRecord->getPropertyValue( "Name" ).getString() );
		const sal_Unicode* pStart = aName;
		const sal_Unicode* pChar = pStart + aName.len() - 1;
		while( pStart != pChar && *pChar != L' ' ) pChar--;
		::rtl::OUString aFirstName;
		::rtl::OUString aLastName;
		if( *pChar == L' ' )
		{
			aFirstName = aName.copy( 0, pChar - pStart );
			aLastName = aName.copy( pChar - pStart + 1 );
		}

		pResult->aSurName = U2S( aLastName );
		pResult->aGivenName = U2S( aFirstName );
		pResult->aEmail = U2S( xRecord->getPropertyValue( "EMail" ).getString() );
		pResult->aKuerzel = U2S( xRecord->getPropertyValue( "Login" ).getString() );
		pResult->aCalendarURL = U2S( xRecord->getPropertyValue( "CalendarURL" ).getString() );

		pResultList->C40_INSERT( SbaLDAPSearchResult_Impl, pResult, pResultList->Count() );
		xCursor->moveRelative( 1 );
	}
	aFinishedLink.Call( this );
	bFinished = TRUE;
}
*/

// -----------------------------------------------------------------------

void SbaLDAPSearcher::Init()

/*	[Beschreibung]

	Mit dieser Methode wird eine Instanz von aussen initialisiert.
*/

{
	nReplyCode = INETCORELDAP_RESULT_SUCCESS;
	nCurrentRow = 0;
	eState = STATE_INIT;
	bFinished = FALSE;
	aSearchStr.Erase();
	aServerStr.Erase();
	aReplyStr.Erase();
}

// -----------------------------------------------------------------------

void SbaLDAPSearcher::Stop()

/*	[Beschreibung]

	Mit dieser Methode wird der Suchvorgang von aussen gestoppt.
*/

{
	if ( eState < STATE_FINISHED )
	{
		if ( xConnection.isValid() && eState > STATE_INIT )
			xConnection->Abort();
		xConnection = NULL;
		eState = STATE_CANCEL;
		nReplyCode = INETCORELDAP_RESULT_OTHER;
		pAddrPI->HideStatusText();
		aFinishedLink.Call( this );
	}
}

// -----------------------------------------------------------------------

USHORT SbaLDAPSearcher::GetResultCount() const

/*	[Beschreibung]

	Diese Methode gibt die Anzahl der gefundenen Eintr"gen zur"uck.
*/

{
	if ( pResultList )
		return pResultList->Count();
	else
		return 0;
}

// -----------------------------------------------------------------------

String SbaLDAPSearcher::GetResultValue( SbaIniWrap::FieldKey eField, USHORT nIdx ) const

/*	[Beschreibung]

	Diese Methode gibt einen gefunden Wert zur"uck. Die Position wird
	durch die Spalte 'eField' und dem Eintrag 'nIdx' bestimmt.

*/

{
	String aResult;

	if ( pResultList->Count() > nIdx )
	{
		SbaLDAPSearchResult_Impl* pResult = pResultList->GetObject( nIdx );

		if ( SbaIniWrap::COMPANY == eField )
			aResult = pResult->aOrganization;
		else if ( SbaIniWrap::FIRSTNAME == eField )
			aResult = pResult->aGivenName;
		else if ( SbaIniWrap::LASTNAME == eField )
			aResult = pResult->aSurName;
		else if ( SbaIniWrap::COUNTRY == eField )
			aResult = pResult->aCountry;
		else if ( SbaIniWrap::CITY == eField )
			aResult = pResult->aLocation;
		else if ( SbaIniWrap::HOMEPHONE == eField )
			aResult = pResult->aTelephoneNumber;
		else if ( SbaIniWrap::EMAIL == eField )
			aResult = pResult->aEmail;
		else if ( SbaIniWrap::STATE == eField )
			aResult = pResult->aState;
		else if ( SbaIniWrap::CALENDARURL == eField )
			aResult = pResult->aCalendarURL;
		else if ( SbaIniWrap::INITIALS == eField )
			aResult = pResult->aKuerzel;
	}
	else
		DBG_ERRORFILE( "resultlist overflow" );
	return aResult;
};

// -----------------------------------------------------------------------

BOOL SbaLDAPSearcher::GetServerName( USHORT nIdx, String& rName ) const

/*	[Beschreibung]

	Diese Methode setzt 'rName' mit einem Namen eines LDAP-Servers.

	[R"uckgabewert]

	TRUE:	Index gefunden
	FALSE	Index nicht verf"ugbar
*/

{
	if ( !pServerList || nIdx >= pServerList->Count() )
		return FALSE;

	rName = pServerList->GetObject( nIdx )->
		GetToken( LDAP_DESCRIPTION, LDAP_TOKEN_DELIMITER );
	return TRUE;
}

// -----------------------------------------------------------------------

USHORT SbaLDAPSearcher::GetErrorResId() const

/*	[Beschreibung]

	Diese Methode gibt die Id f"ur die Resource eines Strings,
	passend zum gesetzten Fehlers.
*/

{
	USHORT nId = 0;

	if ( INETCORELDAP_RESULT_SIZELIMIT_EXCEEDED == nReplyCode )
		nId = RID_LDAP_ERROR_SIZELIMIT;
	else if ( INETCORELDAP_RESULT_UNAVAILABLE == nReplyCode )
		nId = RID_LDAP_ERROR_UNAVAILABLE;
	else if ( nReplyCode > 0 )
		nId = RID_LDAP_ERROR_COMMON;

	if ( STATE_CANCEL == eState )
		nId = LDAP_USER_CANCEL;
	return nId;
}

// -----------------------------------------------------------------------

void SbaLDAPSearcher::GetCommonError( String& rErrorStr )

/*	[Beschreibung]

	Diese Methode ersetzt im "ubergebenen String die Variable $server$ mit
	den Namen des aktuellen LDAP-Servers und die Variable $error$ mit
	der englischen Kurzbezeichnung und der Nummer des aktuellen Fehlers.
*/

{
	if ( nReplyCode > 0 )
	{
		String aError;

		if ( nReplyCode > MAX_COMMON_ERROR )
		{
			String aNewNumStr( String::CreateFromInt32( nReplyCode / 16 ) );
			DBG_ASSERT( aNewNumStr.Len() == 1, "ReplyCode zu gross" );
			aNewNumStr += String::CreateFromInt32( nReplyCode % 16 );
			aNewNumStr += ')';
			nReplyCode = MAX_COMMON_ERROR;
			aError = String::CreateFromAscii( pCommonErrors[ nReplyCode ] );
			aError.Erase( aError.Len() - 3 );
			aError += aNewNumStr;
		}
		else
			aError = String::CreateFromAscii( pCommonErrors[ nReplyCode ] );
		rErrorStr.SearchAndReplaceAscii( "$server$", GetCurrentServer() );
		rErrorStr.SearchAndReplaceAscii( "$error$", aError );
	}
}

// -----------------------------------------------------------------------

ULONG SbaLDAPSearcher::GetRowCount() const

/*	[Beschreibung]

	Diese Methode gibt die Anzahl der gefundenen Eintr"age zur"uck.
*/

{
	return pResultList ? pResultList->Count() : 0;
}

// -----------------------------------------------------------------------

BOOL SbaLDAPSearcher::FetchRow( SdbCursorPosition eType, long nPos )

/*	[Beschreibung]

	Diese Methode setzt die angegebene Position in der Liste
	der gefundenen Eintr"age (wie ein Datenbank-Cursor).
	Die Position wird sich in der Variablen 'nCurrentRow' gemerkt.

	[R"uckgabewert]

	TRUE:	Position gefunden und gesetzt
	FALSE	Position nicht gefunden (z.B.: nPos - 1 >= Count())
*/

{
	if ( !pResultList )
		return FALSE;
	BOOL bRet = TRUE;

	switch ( eType )
	{
		case SDB_POS_FIRST:
			nCurrentRow = 0;
			break;

		case SDB_POS_LAST:
			nCurrentRow = pResultList->Count();

			if ( nCurrentRow )
				nCurrentRow--;
			else
				bRet = FALSE;
			break;

		case SDB_POS_NEXT:
			if ( ( nCurrentRow + 1 ) < pResultList->Count() )
				nCurrentRow++;
			else
				bRet = FALSE;
			break;

		case SDB_POS_PRIOR:
			if ( nCurrentRow )
				nCurrentRow--;
			else
				bRet = FALSE;
			break;

		case SDB_POS_ABSOLUTE:
			if ( nPos && nPos <= pResultList->Count() )
				nCurrentRow = nPos - 1;
			else
				bRet = FALSE;
			break;

		case SDB_POS_RELATIVE:
			DBG_ERRORFILE( "SDB_POS_RELATIVE fuer LDAP nicht implementiert" );
			bRet = FALSE;
			break;
	}
	return bRet;
}

// -----------------------------------------------------------------------

void SbaLDAPSearcher::ReadRow( SbaAddrContainer& rContainer ) const

/*	[Beschreibung]

	Diese Methode f"ullt 'rContainer' mit den Strings des Eintrages
	an der aktuellen Position (nCurrentRow ).
*/

{
	if ( !pResultList )
		return;

	USHORT i, nCnt;
	nCnt = (USHORT)rContainer.Count();
	DBG_ASSERT( nCurrentRow < pResultList->Count(), "invalid CurrentRow" );
	SbaLDAPSearchResult_Impl* pResult = pResultList->GetObject( (USHORT)nCurrentRow );

//	for ( i = 0; i < nCnt; ++i )
	for ( i = 0; i < ADDR_BOOK_FIELDS_CNT; ++i )
	{
		String aDataStr;

		if ( SbaIniWrap::COMPANY == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aOrganization;
		else if ( SbaIniWrap::FIRSTNAME == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aGivenName;
		else if ( SbaIniWrap::LASTNAME == (SbaIniWrap::FieldKey)i )
		{
			aDataStr = pResult->aSurName;

			if ( !aDataStr.Len() )
				aDataStr = pResult->aCommonName;
		}
		else if ( SbaIniWrap::COUNTRY == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aCountry;
		else if ( SbaIniWrap::CITY == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aLocation;
		else if ( SbaIniWrap::HOMEPHONE == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aTelephoneNumber;
		else if ( SbaIniWrap::EMAIL == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aEmail;
		else if ( SbaIniWrap::STATE == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aState;
		else if ( SbaIniWrap::CALENDARURL == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aCalendarURL;
		else if ( SbaIniWrap::INVITE == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aCalendarURL.Len() ? '1' : '0';
		else if ( SbaIniWrap::INITIALS == (SbaIniWrap::FieldKey)i )
			aDataStr = pResult->aKuerzel;
		rContainer.SetField( i, aDataStr );
	}
}


