/*************************************************************************
 *
 *  $RCSfile: sbadbcom.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "sbadbcom.hxx"

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _UTL_ENUMHELPER_HXX_
#include <unotools/enumhelper.hxx>
#endif

#ifndef _UTL_CONTAINER_HXX_
#include <unotools/container.hxx>
#endif

using staruno::Any;
using staruno::Reference;
using staruno::Sequence;

#include <memory.h>

#undef STATIC_USTRING
#define STATIC_USTRING(name, value)	SBA_DEFINE_CONSTASCII( name,value)

STATIC_USTRING( PROP_NAME_DEFAULTVALUE		,"DefaultValue" );
STATIC_USTRING( PROP_NAME_DESCRIPTION		,"Description" );
STATIC_USTRING( PROP_NAME_FORMATKEY			,"FormatKey" );
STATIC_USTRING( PROP_NAME_ISAUTOINCREMENT	,"IsAutoIncrement" );
STATIC_USTRING( PROP_NAME_ISDESCENDING		,"IsDescending" );
STATIC_USTRING( PROP_NAME_ISMODIFIED		,"IsModified" );
STATIC_USTRING( PROP_NAME_ISPRIMARYKEY		,"IsPartOfPrimaryKey" );
STATIC_USTRING( PROP_NAME_ISREADONLY		,"IsReadOnly" );
STATIC_USTRING( PROP_NAME_ISREQUIRED		,"IsRequired" );
STATIC_USTRING( PROP_NAME_ISUNIQUE			,"IsUnique" );
STATIC_USTRING( PROP_NAME_ISUNSIGNED		,"IsUnsigned" );
STATIC_USTRING( PROP_NAME_NAME				,"Name" );
STATIC_USTRING( PROP_NAME_PARAMETERTYPE		,"ParameterType" );
STATIC_USTRING( PROP_NAME_REFNAME			,"RefName" );
STATIC_USTRING( PROP_NAME_SCALE				,"Scale" );
STATIC_USTRING( PROP_NAME_SEARCHINFO		,"SearchInfo" );
STATIC_USTRING( PROP_NAME_SIZE				,"Size" );
STATIC_USTRING( PROP_NAME_TYPE				,"Type" );
STATIC_USTRING( PROP_NAME_VALUE				,"Value" );
STATIC_USTRING( PROP_NAME_ISCLUSTERED		,"IsClustered" );
STATIC_USTRING( PROP_NAME_REFTABLENAME		,"RefTableName" );
STATIC_USTRING( PROP_NAME_TABLENAME			,"TableName" );
STATIC_USTRING( PROP_NAME_UPDATERULE		,"UpdateRule" );
STATIC_USTRING( PROP_NAME_DELETERULE		,"DeleteRule" );
STATIC_USTRING( PROP_NAME_QUERY				,"Query" );
STATIC_USTRING( PROP_NAME_FILTER			,"Filter" );
STATIC_USTRING( PROP_NAME_SORT				,"Sort" );
STATIC_USTRING( PROP_NAME_ISPASSTHROUGH		,"IsPassThrough" );
STATIC_USTRING( PROP_NAME_PRIVILIGES		,"Priviliges" );
STATIC_USTRING( PROP_NAME_CACHESIZE			,"CacheSize" );
STATIC_USTRING( PROP_NAME_CANDELETE			,"CanDelete" );
STATIC_USTRING( PROP_NAME_CANINSERT			,"CanInsert" );
STATIC_USTRING( PROP_NAME_CANUPDATE			,"CanUpdate" );
STATIC_USTRING( PROP_NAME_RECORDMODE		,"RecordMode" );
STATIC_USTRING( PROP_NAME_LASTUPDATED		,"LastUpdated" );
STATIC_USTRING( PROP_NAME_RECORDCOUNT		,"RecordCount" );
STATIC_USTRING( PROP_NAME_ISRECORDCOUNTFINAL,"IsRecordCountFinal" );
STATIC_USTRING( PROP_NAME_RECORDSTATUS		,"RecordStatus" );
STATIC_USTRING( PROP_NAME_TITLE				,"Title" );
STATIC_USTRING( PROP_NAME_URL				,"URL");
STATIC_USTRING( PROP_NAME_CONNECTIONSETTINGS,"ConnectionSettings");
STATIC_USTRING( PROP_NAME_STATEMENT			,"Statement");
STATIC_USTRING( PROP_NAME_EXECUTIONTIMEOUT	,"ExecutionTimeOut");
STATIC_USTRING( PROP_NAME_MAXFIELDSIZE		,"MaxFieldSize");
STATIC_USTRING( PROP_NAME_MAXRECORDCOUNT	,"MaxRecords");
STATIC_USTRING( PROP_NAME_FIELDSOURCE		,"FieldSource");
STATIC_USTRING( PROP_NAME_CONTROLSOURCE		,"DataField");
STATIC_USTRING( PROP_NAME_CURSORSOURCE		,"DataSelection");
STATIC_USTRING( PROP_NAME_CURSORSOURCETYPE	,"DataSelectionType");
STATIC_USTRING( PROP_NAME_DATASOURCE		,"DataSource");
STATIC_USTRING( PROP_NAME_DEFAULTCONTROL	,"DefaultControl");
STATIC_USTRING( PROP_NAME_LABEL				,"Label");
STATIC_USTRING( PROP_NAME_WIDTH				,"Width");
STATIC_USTRING( PROP_NAME_BORDER			,"Border");
STATIC_USTRING( PROP_NAME_BOUNDFIELD		,"BoundField");
STATIC_USTRING( PROP_NAME_SORT_CRITERIA		,"SortOrder");
STATIC_USTRING( PROP_NAME_FILTER_CRITERIA	,"Filter");
STATIC_USTRING( PROP_NAME_HIDDEN			,"Hidden");
STATIC_USTRING( PROP_NAME_HELPTEXT			,"HelpText");
STATIC_USTRING( PROP_NAME_ALIGN				,"Align");
STATIC_USTRING( PROP_NAME_ROW_HEIGHT		,"RowHeight");
STATIC_USTRING( PROP_NAME_FONT				,"FontDescriptor");
STATIC_USTRING( PROP_NAME_TEXTCOLOR			,"TextColor");
STATIC_USTRING( PROP_NAME_SELECTED_FIELDS	,"SelectedFields");
STATIC_USTRING( PROP_NAME_SELECTED_TABLES	,"SelectedTables");
STATIC_USTRING( PROP_NAME_ISFUNCTION		,"IsFunction");
STATIC_USTRING( PROP_NAME_PRIMARYKEY		,"IsPrimaryKey" );
STATIC_USTRING( PROP_NAME_THREADSAFE		,"ThreadSafe");
STATIC_USTRING( PROP_NAME_SOURCE			,"Source");
STATIC_USTRING( PROP_NAME_ISVERSIONING		,"IsVersioning");

//------------------------------------------------------------------------------
SbaDatabaseException::SbaDatabaseException(const SdbStatus& rStat, const Reference< staruno::XInterface > & xCont)
{
	Message = rStat.ErrorMessage();
	Context = xCont;
	SQLState = rStat.SQLState();
	ErrorCode = rStat.NativeErrorCode();
	Description = rStat.ErrorInfo();
}

//------------------------------------------------------------------------------
void checkDBResult(const SdbStatus& rStat, const Reference< staruno::XInterface > & xCont, sal_Bool bWrapp) 
					throw( stardata::DatabaseException, starlang::WrappedTargetException )
{
	if (rStat.Result() == SDB_STAT_ERROR)
	{
		if (bWrapp)
		{
			SbaDatabaseException aExcept(rStat, xCont);
			throw starlang::WrappedTargetException(::rtl::OUString(), xCont, staruno::makeAny(aExcept));
		}
		else
			throw(SbaDatabaseException(rStat, xCont));
	}
}

//------------------------------------------------------------------
void checkIndex(const starcontainer::XIndexAccess* pContr, sal_Int32 Index) throw( starlang::IndexOutOfBoundsException )
{
	DBG_ASSERT(pContr, "ungueltiges Object");
	if (!pContr || Index < 0 || Index >= const_cast<starcontainer::XIndexAccess*>(pContr)->getCount())
		throw starlang::IndexOutOfBoundsException();
}

//------------------------------------------------------------------
void checkArg(const Reference< staruno::XInterface > & xIface) throw( starlang::IllegalArgumentException )
{
	if (!xIface.is())
		throw starlang::IllegalArgumentException();
}

//------------------------------------------------------------------
void checkComponent(const SbaXdbComponent* pObj, const SbaXdbComponent& rParent) throw( starlang::IllegalArgumentException )
{
	if (!pObj || pObj->getXdbParent() != &rParent)
	{
		throw starlang::IllegalArgumentException();
	}
}

/*************************************************************************/

//------------------------------------------------------------------------------
void SbaXdbComponentContext::setServiceManager(staruno::Reference<starlang::XMultiServiceFactory> const& xServiceManager) 
		throw(staruno::RuntimeException)
{
	if (!::utl::getProcessServiceFactory().is())
		::utl::setProcessServiceFactory(xServiceManager);
	DBG_ASSERT(::utl::getProcessServiceFactory() == xServiceManager, "Wrong global service manager");
}

//------------------------------------------------------------------------------
staruno::Reference<starlang::XMultiServiceFactory> SbaXdbComponentContext::getServiceManager() const 
		throw(staruno::RuntimeException)
{
	return ::utl::getProcessServiceFactory();
}

//------------------------------------------------------------------------------
SbaXdbComponentContext& SbaXdbContent::getXdbContext() const throw(staruno::RuntimeException)
{
	// No Protection needed: Object is POD and will be statically initialized
	static SbaXdbComponentContext aGlobalContext;
	return aGlobalContext;
}

/*************************************************************************/
//------------------------------------------------------------------------------
SbaXdbContent::SbaXdbContent(SbaXdbComponent* _pParent)
			  : m_pParent(_pParent)
{
}

//------------------------------------------------------------------------------
void SbaXdbContent::disposing()
{
	m_pParent = NULL;
}

// starcontainer::XChild
//------------------------------------------------------------------------------
Reference< staruno::XInterface > SAL_CALL SbaXdbContent::getParent(void) 
			throw( staruno::RuntimeException )
{
	if (m_pParent)
		return *m_pParent;
	else
		return Reference< staruno::XInterface > ();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbContent::setParent(const Reference< staruno::XInterface > &) 
	throw( starlang::NoSupportException, staruno::RuntimeException  )
{
	throw starlang::NoSupportException();
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbContent::isOpen() const
{
	return m_pParent != NULL;
}

//------------------------------------------------------------------------------
void SbaXdbContent::checkOpen() const throw( starlang::DisposedException )
{
	if (!m_pParent)
	{
		throw starlang::DisposedException();
	}
}

//------------------------------------------------------------------------------
SbaXdbCollection::SbaXdbCollection(SbaXdbComponent& _rParent)
				 :SbaXdbContent(&_rParent)
				 ,m_rParent(_rParent)
				 ,m_aContainerListeners(_rParent.getMutex())
{
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCollection::acquire() throw( staruno::RuntimeException ) {m_rParent.acquire();}
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCollection::release() throw( staruno::RuntimeException ) {m_rParent.release();}

//------------------------------------------------------------------------------

Any SAL_CALL SbaXdbCollection::queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException )
{
	typedef ::cppu::WeakImplHelper3<
				starlang::XEventListener,
				starcontainer::XContainer,
				starcontainer::XChild
				> ImplHelper;

	if (rType == ::getCppuType(static_cast<Reference<starcontainer::XChild> const*>(0)))
	{
		starcontainer::XChild* pThis = static_cast<SbaXdbContent*>(this);
		return Any(&pThis,rType);
	}
	return ImplHelper::queryInterface(rType);
}

// starlang::XEventListener
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCollection::disposing(const starlang::EventObject& evt)
		throw( staruno::RuntimeException )
{
	DBG_ASSERT(evt.Source.is(), "kein Element");
	::osl::MutexGuard aGuard( m_rParent.getMutex() );

	SbaXdbObject* pObj = 0;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel(evt.Source,::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		pObj = (SbaXdbObject*)xTunnel->getSomething(SbaXdbObject::getUnoTunnelImplementationId());
	}
	//	utl::getImplementation(pObj,evt.Source);
	removeObject(pObj);
}

//------------------------------------------------------------------------------
void SbaXdbCollection::disposing()
{
	{
		::osl::MutexGuard aGuard( m_rParent.getMutex() );
		sal_uInt32 nCount = size();
		while (nCount)
		{
			SbaXdbObject* pObject = removeObject(--nCount);
			if (pObject)
				pObject->dispose();
		}
	}

	starlang::EventObject aEvt(getParent());
	m_aContainerListeners.disposeAndClear(aEvt);
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbCollection::hasObject(SbaXdbObject* pObject) const
{
	return pObject && std::find(m_aObjects.begin(), m_aObjects.end(), pObject) != m_aObjects.end();
}

//------------------------------------------------------------------------------
void SbaXdbCollection::appendObject(SbaXdbObject* pObject)
{
	DBG_ASSERT(pObject != NULL && !hasObject(pObject), "Bereits enthalten");
	::osl::MutexGuard aGuard( m_rParent.getMutex() );

	if (pObject)
	{
		m_aObjects.push_back(pObject);
		pObject->addEventListener(this);
	}
}

//------------------------------------------------------------------------------
void SbaXdbCollection::removeObject(SbaXdbObject* pObject)
{
	DBG_ASSERT(pObject != NULL && hasObject(pObject), "Nicht enthalten");
	::osl::MutexGuard aGuard( m_rParent.getMutex() );

	if (pObject)
	{
		ODbObjectList::iterator i = std::find(m_aObjects.begin(), m_aObjects.end(), pObject);
		m_aObjects.erase(i);		
		pObject->removeEventListener(this);
	}
}

//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbCollection::removeObject(sal_uInt32 nPos)
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );

	ODbObjectList::iterator i = m_aObjects.begin() + nPos;
	SbaXdbObject* pObject = *i;
	m_aObjects.erase(i);		

	DBG_ASSERT(pObject != NULL && !hasObject(pObject), "Bereits enthalten");

	if (pObject)
		pObject->removeEventListener(this);
	return pObject;
}

// starcontainer::XContainer
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCollection::addContainerListener(const Reference< starcontainer::XContainerListener > & l) 
	throw( staruno::RuntimeException  )
{
	m_aContainerListeners.addInterface(l);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCollection::removeContainerListener(const Reference< starcontainer::XContainerListener > & l) 
	throw( staruno::RuntimeException  )
{
	m_aContainerListeners.removeInterface(l);
}

//------------------------------------------------------------------------------
SbaXdbNamedCollection::SbaXdbNamedCollection(SbaXdbObjectCreator& rParent,
											 DBObject _eObj,
											 const staruno::Type& rType)
				:SbaXdbCollection(rParent)
				,m_aRefreshListeners(rParent.getMutex())
				,m_eObj(_eObj)
				,m_aElementType(rType)
{
}

//------------------------------------------------------------------------------
void SbaXdbNamedCollection::disposing()
{
	starlang::EventObject aEvt(getParent());
	m_aRefreshListeners.disposeAndClear(aEvt);

	SbaXdbCollection::disposing();
}


// starcontainer::XElementAccess
//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbNamedCollection::hasElements(void)
	throw( staruno::RuntimeException  )
{
	checkOpen();
	return getXdbCreator()->getObjectCount(m_eObj) != 0;
}

//------------------------------------------------------------------------------
staruno::Type SAL_CALL SbaXdbNamedCollection::getElementType(void) 
	throw( staruno::RuntimeException )
{
	return m_aElementType;
}

// starcontainer::XEnumerationAccess
//------------------------------------------------------------------------------
Reference< starcontainer::XEnumeration > SAL_CALL SbaXdbNamedCollection::createEnumeration(void) 
	throw( staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	return new utl::OEnumerationByName( static_cast<starcontainer::XNameAccess*>(this));
}

// helper method
//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbNamedCollection::get(const ::rtl::OUString& Name) const
{
	SdbObj* pObj = getXdbCreator()->openObject(m_eObj, Name);
	if (!pObj)
	{
		throw starcontainer::NoSuchElementException();
	}

	return doGet(pObj);
}

// starcontainer::XNameAccess
//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbNamedCollection::getByName(const ::rtl::OUString& Name) 
	throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException  )
{
	checkOpen();

	SbaXdbObject* pObj = get(Name);

	return pObj->queryInterface(m_aElementType);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > SAL_CALL SbaXdbNamedCollection::getElementNames(void) 
	throw( staruno::RuntimeException  )
{
	checkOpen();

	sal_uInt32 nCount(getXdbCreator()->getObjectCount(m_eObj));
	Sequence< ::rtl::OUString > aNameList(nCount);

	for (sal_uInt32 i = 0; i < nCount; i++)
		aNameList[i] = getXdbCreator()->getObjectName(m_eObj, i);

	return aNameList;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbNamedCollection::hasByName(const ::rtl::OUString& Name) 
	throw( staruno::RuntimeException  )
{
	checkOpen();

	SdbObj* pObj = getXdbCreator()->openObject(m_eObj, Name);
	return pObj != NULL;
}

// starcontainer::XNameContainer
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::insertByName(const ::rtl::OUString& Name, const Any& Element) 
	throw(	starlang::IllegalArgumentException, starcontainer::ElementExistException, 
			starlang::WrappedTargetException, staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	// Existiert schon ein element mit diesem Namen
	if (hasByName(Name))
	{
		throw starcontainer::ElementExistException();
	}

	SbaXdbObject* pObj = doInsert(Name, Element);

	// Object gehoert bereits einem Container an
	if (pObj && pObj->isOpen())
	{
		throw starlang::IllegalArgumentException();
	}

	if (pObj)
	{
		appendObject(pObj);
		pObj->setXdbParent(getXdbParent());

		starcontainer::ContainerEvent aEvt(	*this, 
											staruno::makeAny(Name), 
											pObj->queryInterface(m_aElementType), staruno::Any());

		NOTIFY_LISTENERS(m_aContainerListeners, starcontainer::XContainerListener, elementInserted, aEvt);
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::replaceByName(const ::rtl::OUString& Name, const Any& Element) 
	throw( starlang::IllegalArgumentException, starcontainer::NoSuchElementException, 
	starlang::WrappedTargetException, staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	SbaXdbObject* pObj = get(Name);
	if (doRemove(pObj))
	{
		Any  aReplaced(pObj->queryInterface(m_aElementType));

		SbaXdbObject* pOldObj = pObj;
		removeObject(pObj);

		pObj = doInsert(Name, Element);

		// Object gehoert bereits einem Container an
		if (pObj && pObj->isOpen())
		{
			throw starlang::IllegalArgumentException();
		}

		appendObject(pObj);
		pObj->setXdbParent(getXdbParent());

		starcontainer::ContainerEvent aEvt(	*this, 
											staruno::makeAny(Name), 
											pObj->queryInterface(m_aElementType), aReplaced );

		NOTIFY_LISTENERS(m_aContainerListeners, starcontainer::XContainerListener, elementReplaced, aEvt);


		pOldObj->dispose();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::removeByName(const ::rtl::OUString& Name) 
	throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	SbaXdbObject* pObj = get(Name);

	if (doRemove(pObj))
	{
		removeObject(pObj);

		starcontainer::ContainerEvent aEvt(	*this, 
											staruno::makeAny(Name), 
											staruno::Any(),
											pObj->queryInterface(m_aElementType));

		NOTIFY_LISTENERS(m_aContainerListeners, starcontainer::XContainerListener, elementRemoved, aEvt);

		// freigeben des Objects
		pObj->dispose();
	}
}

// starutil::XRefreshable
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::addRefreshListener(const Reference< starutil::XRefreshListener > & l) 
	throw( staruno::RuntimeException  )
{   m_aRefreshListeners.addInterface(l); }
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::removeRefreshListener(const Reference< starutil::XRefreshListener > & l) 
	throw( staruno::RuntimeException  )
{   m_aRefreshListeners.removeInterface(l); }

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbNamedCollection::refresh(void) throw( staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	getXdbCreator()->refresh(m_eObj);

	starlang::EventObject aEvt(*this);

	NOTIFY_LISTENERS(m_aRefreshListeners, starutil::XRefreshListener, refreshed, aEvt);
}

//------------------------------------------------------------------------------

staruno::Any SAL_CALL SbaXdbComponent::queryInterface(staruno::Type const& rType)
	throw( staruno::RuntimeException )
{
	if (rType == ::getCppuType(static_cast<const Reference< starcontainer::XChild >*>(0)))
	{
		starcontainer::XChild* pThis = static_cast<SbaXdbContent*>(this);
		return Any(&pThis,rType);
	}

	return ComponentHelper::queryInterface( rType );
}

//------------------------------------------------------------------------------
void SbaXdbComponent::disposing(void)
{
	SbaXdbContent::disposing();
}

using namespace cppu;
using namespace osl;
// XUnoTunnel
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbObject::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}
//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbObject::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
SbaXdbObject::SbaXdbObject(SbaXdbCollection& rCollection)
			 :SbaXdbComponent(rCollection.getXdbParent())
{
	// Vater gleich als disposeListener eintragen
	// damit ist sichergestellt, da der Vater immer solange lebt wie sein
	// Kind
	rCollection.appendObject(this);
}

//------------------------------------------------------------------------------
SbaXdbObject::~SbaXdbObject()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}
//------------------------------------------------------------------------------
//sal_Int64 SAL_CALL SbaXdbObject::getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
//			throw( staruno::RuntimeException )
//{
//	typedef utl::UnoTunnelHelper<SbaXdbObject> ObjectUnoTunnel;
//	return ObjectUnoTunnel::getSomething(aIdentifier);
//}

















