/*************************************************************************
 *
 *  $RCSfile: sbadbcur.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBCUR_HXX
#include "sbadbcur.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASECURSOROPTION_HPP_
#include <com/sun/star/data/DatabaseCursorOption.hpp>
#endif

#ifndef _SV_SVAPP_HXX //autogen wg. Application
#include <vcl/svapp.hxx>
#endif

#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif

#ifndef _UNOTOOLS_GUARDING_HXX_
#include <unotools/guarding.hxx>
#endif

#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SBAITEMS_HRC //autogen
#include <sbaitems.hrc>
#endif

#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#ifndef _SBA_SBADBDAT_HXX
#include <sbadbdat.hxx>
#endif

#ifndef _SBA_SBADBTBL_HXX
#include <sbadbtbl.hxx>
#endif

#ifndef _SBA_SBADBQRY_HXX
#include <sbadbqry.hxx>
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

using staruno::Any;
using staruno::Reference;
using staruno::Sequence;
typedef ::utl::OReusableGuard< ::osl::Mutex > ReusableMutexGuard;

const sal_Int32 DBPOSITION_UNKNOWN = -2;


using namespace ::cppu;
using namespace ::osl;

//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbCursor::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbObject::getSomething(rId);
}
//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbCursor::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
SbaXdbCursorMultiplexer::SbaXdbCursorMultiplexer(SdbCursor* pCursor, ::osl::Mutex& rMutex)
: m_aListeners(rMutex)
{
	pCursor->SetRowCountHdl(LINK(this,SbaXdbCursorMultiplexer,RowCountHdl));
}

//------------------------------------------------------------------------------
inline SbaXdbCursor* SbaXdbCursorMultiplexer::getXdbCursor(staruno::XInterface* pI)
{
	return static_cast<SbaXdbCursor*>(static_cast<starlang::XEventListener*>(pI));
}
//------------------------------------------------------------------------------
void SbaXdbCursorMultiplexer::addEventListener(SbaXdbCursor* pCursor)
{
	m_aListeners.addInterface(Reference< starlang::XEventListener >(pCursor));
}

//------------------------------------------------------------------------------
void SbaXdbCursorMultiplexer::removeEventListener(SbaXdbCursor* pCursor)
{
	m_aListeners.removeInterface(Reference< starlang::XEventListener >(pCursor));
}

//------------------------------------------------------------------------------
void SbaXdbCursorMultiplexer::updateRowCount()
{
	::cppu::OInterfaceIteratorHelper aIt(m_aListeners);
	while (aIt.hasMoreElements())
		getXdbCursor(aIt.next())->updateRowCount();

}

//------------------------------------------------------------------------------
void SbaXdbCursorMultiplexer::recordDeleted(const Any& aCurrentBookmark, const Any& aNextBookmark)
{
	::cppu::OInterfaceIteratorHelper aIt(m_aListeners);
	while (aIt.hasMoreElements())
		getXdbCursor(aIt.next())->recordDeleted(aCurrentBookmark, aNextBookmark);

}

//------------------------------------------------------------------------------
IMPL_LINK(SbaXdbCursorMultiplexer, RowCountHdl, SdbCursor*, pCursor)
{
	updateRowCount();
	return 1;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::construct(sal_Bool bForwardOnly)
{
	m_pCursorHdl = NULL;
	m_nPosition = DBPOSITION_UNKNOWN;
	m_eRecordMode = stardata::DatabaseRecordMode_STANDARD;
	m_eOrigStatus = m_eRecordStatus = stardata::DatabaseRecordStatus_INVALID;
	m_bEOF = m_bBOF = sal_True;
	m_bFirst = m_bLast = sal_False;
	m_bOwnsResultRow = sal_False;
	m_bForwardOnly = bForwardOnly;
	m_bRecordCountFinal = sal_False;
	m_nRecordCount = 0;
	m_bClone = sal_False;
	m_bObsolete = sal_False;
	m_nAsyncUpdateRowCount = 0;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::construct(const SbaXdbCursor& rCur)
{
	m_pCursorHdl = rCur.m_pCursorHdl;
	m_nPosition = rCur.m_nPosition;
	m_eRecordMode = rCur.m_eRecordMode;
	m_eOrigStatus = stardata::DatabaseRecordStatus_INVALID;
	m_eRecordStatus = rCur.m_eRecordStatus;
	m_bEOF = rCur.m_bEOF;
	m_bBOF = rCur.m_bBOF;
	m_bFirst = rCur.m_bFirst;
	m_bLast = rCur.m_bLast;
	m_bOwnsResultRow = sal_True;
	m_bForwardOnly = rCur.m_bForwardOnly;
	m_bRecordCountFinal = rCur.m_bRecordCountFinal;
	m_nRecordCount = rCur.m_nRecordCount;
	m_bClone = sal_True;
	m_bObsolete = sal_False;
	m_nAsyncUpdateRowCount = 0;
}

//------------------------------------------------------------------------------
SbaXdbCursor::SbaXdbCursor()
			 :PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aFields(*this, sal_True)
{
	construct(sal_False);
}

//------------------------------------------------------------------------------
SbaXdbCursor::SbaXdbCursor(SdbCursor* pCursor, sal_Bool bForwardOnly)
			 :PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aFields(*this, pCursor->GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
			 ,m_xCursor(pCursor)
{
	construct(bForwardOnly);

	::utl::increment(m_refCount);

	SdbColumnsRef xCols;
	if (m_xCursor.Is())
	{
		xCols = m_xCursor->GetColumns();
		m_xResultRow = m_xCursor->GetRow();
	}

	m_aFields.constructRecordFields(xCols);
	adjustState();

	{
		m_pCursorHdl = new SbaXdbCursorMultiplexer(pCursor, m_aMutex);
		m_pCursorHdl->acquire();
		m_pCursorHdl->addEventListener(this);
	}

	// Refcount wieder bei 1
	sal_Int32 n = ::utl::decrement(m_refCount);
	DBG_ASSERT(n == 1, "Fehlerhafter Refcount");
}

//------------------------------------------------------------------------------
SbaXdbCursor::SbaXdbCursor(SbaXdbCollection& rCollection, SdbCursor& rCursor, const SbaXdbFields* pRefFields, sal_Bool bForwardOnly)
			 :SbaXdbObject(rCollection)
			 ,PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aFields(*this, rCursor.GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
			 ,m_xCursor(&rCursor)
{
	construct(bForwardOnly);

	::utl::increment(m_refCount);

	SdbColumnsRef xCols;
	if (m_xCursor.Is())
	{
		xCols = m_xCursor->GetColumns();
		m_xResultRow = m_xCursor->GetRow();
	}
	m_aFields.constructRecordFields(xCols);

	if (pRefFields)
	{
		// Anpassen von Type und Formatkey und DefaultValue
		m_aFields.adjustTypes(*pRefFields);
	}

	adjustState();

	{
		m_pCursorHdl = new SbaXdbCursorMultiplexer(m_xCursor,m_aMutex);
		m_pCursorHdl->acquire();
		m_pCursorHdl->addEventListener(this);
	}

	// Refcount wieder bei 1
	sal_Int32 n = ::utl::decrement(m_refCount);
	DBG_ASSERT(n == 1, "Fehlerhafter Refcount");
}

//------------------------------------------------------------------------------
SbaXdbCursor::SbaXdbCursor(const SbaXdbCursor& rCur)
			 :m_aFields(*this, rCur.m_aFields.isCaseSensitive())
			 ,PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_xCursor(rCur.m_xCursor)
{
	construct(rCur);

	::utl::increment(m_refCount);

	SdbColumnsRef xCols;
	if (m_xCursor.Is())
	{
		xCols = m_xCursor->GetColumns();
		m_xResultRow = new ODbRow(*xCols);
	}
	m_aFields.constructRecordFields(xCols);

	adjustState();

	// Jetzt setzen ,da adjust State diese ueberschreibt
	m_aNextBookmark = rCur.m_aNextBookmark;

	if (m_pCursorHdl)
	{
		m_pCursorHdl->acquire();
		m_pCursorHdl->addEventListener(this);
	}

	// Refcount wieder bei 1
	sal_Int32 n = ::utl::decrement(m_refCount);
	DBG_ASSERT(n == 1, "Fehlerhafter Refcount");
}

//------------------------------------------------------------------------------
SbaXdbCursor::SbaXdbCursor(const SbaXdbCursor& rCur, SbaXdbCollection& rCollection)
			 :SbaXdbObject(rCollection)
			 ,PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aFields(*this, rCur.m_aFields.isCaseSensitive())
			 ,m_xCursor(rCur.m_xCursor)
{
	construct(rCur);

	::utl::increment(m_refCount);

	SdbColumnsRef xCols;
	if (m_xCursor.Is())
	{
		xCols = m_xCursor->GetColumns();
		// der Clone braucht eine eigene Row
		m_xResultRow = new ODbRow(*xCols);
	}
	m_aFields.constructRecordFields(xCols);

	adjustState();

	// Jetzt setzen ,da adjust State diese ueberschreibt
	m_aNextBookmark = rCur.m_aNextBookmark;

	if (m_pCursorHdl)
	{
		m_pCursorHdl->acquire();
		m_pCursorHdl->addEventListener(this);
	}

	// Refcount wieder bei 1
	sal_Int32 n = ::utl::decrement(m_refCount);
	DBG_ASSERT(n == 1, "Fehlerhafter Refcount");
}

//------------------------------------------------------------------------------
SbaXdbCursor::~SbaXdbCursor()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}


// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbCursor::disposing(void)
{
	SbaXdbObject::disposing();
	OPropertySetHelper::disposing();

	m_aFields.disposing();

	m_pCursorHdl->removeEventListener(this);
	m_pCursorHdl->release();
	m_pCursorHdl = NULL;

	m_xCursor = NULL;
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCursor::dispose() throw(staruno::RuntimeException)
{
	if (m_nAsyncUpdateRowCount)
		Application::RemoveUserEvent(m_nAsyncUpdateRowCount);
	m_nAsyncUpdateRowCount = 0;

	ComponentHelper::dispose();
}

// SbaXdbContent
//------------------------------------------------------------------------------
void SbaXdbCursor::checkOpen() const throw( starlang::DisposedException )
{
	if (!m_xCursor)
	{
		SdbStatus aSdbStatus;
		aSdbStatus.SetConnectionLost();

		throw starlang::DisposedException();
	}
}

// starutil::XCloneable
//------------------------------------------------------------------------------
Reference< starutil::XCloneable > SAL_CALL SbaXdbCursor::clone(void) throw( staruno::RuntimeException )
{
	checkOpen();

	if (m_bForwardOnly)
		return Reference< starutil::XCloneable > ();

	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
	::osl::MutexGuard aGuard(m_aMutex);

	// Jetzt eine Copy der Row erstellen
	if (!m_bOwnsResultRow && m_xCursor)
	{
		SdbColumnsRef xCols = m_xCursor->GetColumns();
		m_xResultRow = new ODbRow(*xCols);
		if (m_xCursor->GetRow().is())
			(*m_xResultRow) = *m_xCursor->GetRow();
		m_aFields.replaceValues(m_xResultRow);
		m_bOwnsResultRow = sal_True;

		// If we are updateng or inserting we did a saveState which didn't do anything as we weren't the owner
		// of the result row at this time. _Now_ we are the owner, so we have to initialize m_xOrigRow here ...
		// (we need m_xOrigRow later in restoreState, after the update has been done)
		// FS - 16.12.99 - 70927
		if ((stardata::DatabaseRecordMode_STANDARD != m_eRecordMode) && (!m_xOrigRow.is()))
		{
			m_xOrigRow = new ODbRow(*m_xResultRow);
		}
	}

	Reference< starutil::XCloneable >  xClone;
	if (getXdbParent())
		xClone = new SbaXdbCursor(*this, ((SbaXdbStatement*)getXdbParent())->m_aCursors);
	else
		xClone = new SbaXdbCursor(*this);

	return xClone;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::firePropertyChange(sal_Int32 nHandle, const Any& aNewValue, const Any& aOldValue)
{
	PropertySetHelper::fire(&nHandle, &aNewValue, &aOldValue, 1, sal_False);
}

//------------------------------------------------------------------------------
void SbaXdbCursor::saveState()
{
	if (m_bOwnsResultRow)
	{
		if (m_xResultRow.is())
		{
			m_xResultRow->setModified(sal_False);
			m_xOrigRow	= new ODbRow(*m_xResultRow);  // alten Stand merken
		}
		else
			m_xOrigRow.unbind();
	}
	m_eOrigStatus = m_eRecordStatus;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::restoreState()
{
	::osl::ClearableMutexGuard aGuard( m_aMutex );
	// alten Zustand wiederherstellen
	if (m_bOwnsResultRow)
	{
		if (m_xOrigRow.is())
		{
			DBG_ASSERT(m_bOwnsResultRow , "SbaXdbCursor::restoreState(), invalid State");
			(*m_xResultRow) = *m_xOrigRow;
			m_aBookmark = (*m_xResultRow)[0]->getAny();
		}
		else
		{
			m_xResultRow = m_xOrigRow;
			m_aBookmark = Any();
		}
	}
	else
	{
		m_xCursor->CancelRow();
		m_xResultRow = m_xCursor->GetRow();
		if (m_xResultRow.is() && !m_bForwardOnly)
			m_aBookmark = (*m_xResultRow)[0]->getAny();
	}
	m_eRecordStatus  = m_eOrigStatus;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::throwSequenceError()	throw( stardata::DatabaseException )
{
	SdbStatus aSdbStat;
	aSdbStat.SetSequenceError();
	checkDBResult(aSdbStat, *this, sal_False);
}

//------------------------------------------------------------------------------
void SbaXdbCursor::adjustState(SdbCursor::SdbCursorGuard* pClearForNotify)
{
	::osl::ClearableMutexGuard aGuard( m_aMutex );
	if (m_xCursor)
	{
		stardata::DatabaseRecordMode eOldRecordMode = m_eRecordMode;
		stardata::DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;

		m_bObsolete = sal_False;
		if (m_aNextBookmark.hasValue())
			m_aNextBookmark.clear();

		m_bBOF			= m_xCursor->IsBOF();
		m_bEOF			= m_xCursor->IsEOF();
		m_nPosition 	= Max( sal_Int32(m_xCursor->GetCurrentPos() - 1), sal_Int32(DBPOSITION_UNKNOWN));
		m_bFirst		= m_xCursor->IsOnFirst();
		m_bLast 		= m_xCursor->IsOnLast();
		m_eRecordMode	= stardata::DatabaseRecordMode_STANDARD;

		// aktuellen Status
		if (m_xCursor->GetRow().is())
		{
			if (!m_xCursor->IsValid())
			{
				if (m_xCursor->GetRow()->isDeleted())
					m_eRecordStatus = stardata::DatabaseRecordStatus_DELETED;
				else
					m_eRecordStatus = stardata::DatabaseRecordStatus_INVALID;
			}
			else
			{
				DBG_ASSERT(!m_xCursor->GetRow()->isModified(), "SbaXdbCursor::adjustState: Cursor darf nicht modfiziert sein");
				if (m_xCursor->IsModeNew() || m_xCursor->IsModeEdit())
					m_eRecordStatus = stardata::DatabaseRecordStatus_INVALID;
					// Normally this is called after a move operation so the cursor isn't in "new" or "edit" mode.
					// But if we clone an SbaXdbCursor which isn't clean or invalid or deleted we force a (more) consistent
					// state with this ...
				else
					m_eRecordStatus = stardata::DatabaseRecordStatus_CLEAN;
			}
		}
		else
			m_eRecordStatus = stardata::DatabaseRecordStatus_INVALID;

		switch (m_eRecordStatus)
		{
			case stardata::DatabaseRecordStatus_CLEAN:
			case stardata::DatabaseRecordStatus_MODIFIED:
				if (m_bOwnsResultRow)
					(*m_xResultRow) = *m_xCursor->GetRow();
				else
					m_xResultRow = m_xCursor->GetRow();
				if (!m_bForwardOnly)
					m_aBookmark = (*m_xResultRow)[0]->getAny();
				break;
			case stardata::DatabaseRecordStatus_DELETED:
				if (m_bOwnsResultRow)
					m_xResultRow->reset();
				else
					m_xResultRow = m_xCursor->GetRow();

				if (!m_bForwardOnly)
					m_aBookmark = (*m_xResultRow)[0]->getAny();
				break;
			default:
				if (m_bOwnsResultRow)
					m_xResultRow->reset();
				else
					m_xResultRow = m_xCursor->GetRow();

				if (!m_bForwardOnly)
					m_aBookmark.clear();
		}

		sal_Bool bFireFinalCountFlagChange = sal_False;
		Any aOldValue;
		Any aNewValue;
		if (m_bRecordCountFinal != m_xCursor->IsRowCountFinal())
		{
			::utl::setBOOL(aOldValue, m_bRecordCountFinal);
			::utl::setBOOL(aNewValue, m_xCursor->IsRowCountFinal());
			m_bRecordCountFinal = m_xCursor->IsRowCountFinal();

			bFireFinalCountFlagChange = sal_True;
		}
		// ERST den SdbCursorGuard und meinen eigenen freigeben
		if (pClearForNotify)
		{
			pClearForNotify->clear();
			pClearForNotify = NULL;
		}
		aGuard.clear();

		// for the notifications we lock the solar mutex
		// With this we ensure that any mutexes locked in the listeners are locked _after_ the solar mutex. This is the usual order
		// for any ui triggered actions (the application core locks the SM before calling any ui handlers), and as we emulate
		// this here we dramatically reduce the probabillity of deadlocks ... (me hopes)
		::vos::OGuard aGuard(Application::GetSolarMutex());

		// und DANN alles, was auf ein Notify anderer Teilnehmer (woran auch immer ;) hinauslaeuft, erledigen
		// (das vermeidet so ungefaehr hundert potentielle DeadLocks  - grob geschaetzt ;)
		m_aFields.replaceValues(m_xResultRow);
			// die Benutzung von m_xResultRow braucht nicht mehr durch den SdbCursorGuard geschuetzt werden : Entweder bin
			// ich der einzige SbaXdbCursor, der den SdbCursor benutzt, dann ist es egal, oder es gibt noch andere (eventuell in
			// anderen Threads), dann ist m_xResultRow sowieso nicht die originale Row des Cursors, sondern einen geklonte, die ich
			// selber besitze. Damit ist der Zugriff darauf, den replaceValues ausfuehrt, auf jeden Fall thread-sicher
			// Ebenso braucht replaceValues nicht durch meinen eigenen Guard geschuetzt werden : es reicht lediglich die Values
			// an die einzelnen Fields weiter, und die haben einen eigenen Mutex.

		if (bFireFinalCountFlagChange)
			// im Prinzip haette das auch vor dem clearen des SdbCursorGuard passieren koennen, jedenfalls hatten wir hiermit noch
			// keinen Deadlock, als es noch so war, aber sicher ist sicher ;)
			firePropertyChange(PROP_ISRECORDCOUNTFINAL, aNewValue, aOldValue);

		if (eOldRecordMode != m_eRecordMode)
			firePropertyChange(	PROP_RECORDMODE,
								staruno::makeAny(m_eRecordMode),
								staruno::makeAny(eOldRecordMode) );

		if (eOldRecordStatus != m_eRecordStatus)
			firePropertyChange(	PROP_RECORDSTATUS,
								staruno::makeAny(m_eRecordStatus),
								staruno::makeAny(eOldRecordStatus) );

		if (m_pCursorHdl)
			m_pCursorHdl->updateRowCount();
		else
			updateRowCount();

#ifdef DBG_UTIL
		if (!m_bForwardOnly && m_eRecordStatus == stardata::DatabaseRecordStatus_CLEAN)
		{
			DBG_ASSERT(m_aBookmark.getValueTypeClass() != staruno::TypeClass_VOID, "Ungueltige Bookmark");


		}
#endif

	}
	else
	{
		m_bBOF = m_bEOF = m_bFirst = m_bLast = sal_False;
		m_aBookmark = Any();
		m_nPosition = DBPOSITION_UNKNOWN;
		m_eRecordStatus = stardata::DatabaseRecordStatus_INVALID;
		if (m_bOwnsResultRow && m_xResultRow.is())
			m_xResultRow->reset();
		m_aFields.replaceValues(m_xResultRow);
	}

	if (pClearForNotify)
		pClearForNotify->clear();
}

//------------------------------------------------------------------------------
void SbaXdbCursor::updateRowCount()
{
	Any aOldValue, aNewValue;
	sal_Bool bFire = sal_False;

	// We can't simply lock our mutex : this updateRowCount may be called directly after a cursor operation, indirect
	// from a clone or indirect from the sdb-cursor which calls the RowCountChangedLink if another sba-cursor operates on it.
	// There are a lot of mutexes involved (at least on mutex for every clone and and one mutex for the sdb-cursor) and we don't
	// know which ones are locked (imagine two threads doin' a move and a third thread asking for a property value of an
	// sba cursor (which locks it's mutex, too)).
	// With all this unsureness  it would be very simple to deadlock if we would just acquire our mutex ...
	if (m_aMutex.tryToAcquire())
	{
		try
		{
			sal_Int32 nNewRecordCount = m_xCursor->RowCount();
			if (m_xCursor && (nNewRecordCount != m_nRecordCount))
			{
				aOldValue <<= sal_Int32(m_nRecordCount);
				m_nRecordCount = nNewRecordCount;
				aNewValue <<= sal_Int32(m_nRecordCount);
				bFire = sal_True;
			}
			m_aMutex.release();
		}
		catch(...)
		{
			m_aMutex.release();
		}
		if (bFire)
			firePropertyChange(PROP_RECORDCOUNT, aNewValue, aOldValue);
	}
	else
	{
		// ... so if we can't get it we try again ... later.
		if (!m_nAsyncUpdateRowCount)
			m_nAsyncUpdateRowCount = Application::PostUserEvent(LINK(this, SbaXdbCursor, DoUpdateRowCount));
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaXdbCursor, DoUpdateRowCount, void*, EMPTYARG)
{
	m_nAsyncUpdateRowCount = 0;
	updateRowCount();
	return 0L;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::recordDeleted(const Any& aCurrentBookmark, const Any& aNextBookmark)
{
	if (::areEqual(m_aBookmark, aCurrentBookmark))
	{
		stardata::DatabaseRecordMode eOldRecordMode = m_eRecordMode;
		stardata::DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;
		{
			::osl::MutexGuard aGuard( m_aMutex );

			m_eRecordMode = stardata::DatabaseRecordMode_STANDARD;
			m_eRecordStatus = stardata::DatabaseRecordStatus_DELETED;

	// Zustandsvariablen nur Aendern, wenn m_bLast gesetzt ist
			if (m_bLast)
			{
				m_bBOF			= m_xCursor->IsBOF();
				m_bEOF			= m_xCursor->IsEOF();
				m_bFirst		= m_xCursor->IsOnFirst();
				m_bLast 		= m_xCursor->IsOnLast();
			}

			m_bObsolete = sal_True;
			m_aNextBookmark = aNextBookmark;
			m_aBookmark = Any();
		}

		if (eOldRecordMode != m_eRecordMode)
			firePropertyChange(PROP_RECORDMODE,
								staruno::makeAny(m_eRecordMode),
								staruno::makeAny(eOldRecordMode));

		if (eOldRecordStatus != m_eRecordStatus)
			firePropertyChange(PROP_RECORDSTATUS,
								staruno::makeAny(m_eRecordStatus),
								staruno::makeAny(eOldRecordStatus));
	}
	updateRowCount();
}

// PropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbCursor::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	using namespace stardata;
	using staruno::XInterface;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,10)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CACHESIZE),			PROP_TYPE(sal_Int16),			starbeans::PropertyAttribute::TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CANDELETE),			BOOL_PROP(),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CANINSERT),			BOOL_PROP(),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CANUPDATE),			BOOL_PROP(),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISRECORDCOUNTFINAL),BOOL_PROP(),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::BOUND | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(LASTUPDATED),		PROP_TYPE(Any),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(RECORDCOUNT),		PROP_TYPE(sal_Int32),			starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY | starbeans::PropertyAttribute::BOUND);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(RECORDMODE),		PROP_TYPE(DatabaseRecordMode),	starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::BOUND | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(RECORDSTATUS),		PROP_TYPE(DatabaseRecordStatus),starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::BOUND);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(THREADSAFE),		BOOL_PROP(),					starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
	SBA_END_PROPERTY_HELPER();
}

// OPropertySetHelper
//------------------------------------------------------------------------------
sal_Bool SbaXdbCursor::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException )
{
	checkOpen();

	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_xCursor->GetCacheSize());
			break;
		case PROP_RECORDSTATUS:
		{
			stardata::DatabaseRecordStatus eTempStatus = m_eRecordStatus;
			if (m_eRecordMode != stardata::DatabaseRecordMode_STANDARD && m_xResultRow->isModified())
				eTempStatus = stardata::DatabaseRecordStatus_MODIFIED;

			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue, eTempStatus);
			if (bModified && eTempStatus != stardata::DatabaseRecordStatus_MODIFIED &&
				::utl::getEnumAsINT32(rValue) != stardata::DatabaseRecordStatus_CLEAN)
			{
				throw starlang::IllegalArgumentException();
			}
		}	break;
		default:
			DBG_ERROR("unknown Porperty");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbCursor::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw(staruno::Exception)
{
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			m_xCursor->SetCacheSize(::utl::getINT16(rValue));

			// if the cursor positioned on a new record internally don't replace my field values
			if (m_xCursor->GetRow().is() && ::areEqual(m_aBookmark, (*m_xCursor->GetRow())[0]->getAny()))
			{	// (the bookmark of the result row shouldn't be empty, but my own bookmark may be invalid)
				if (m_bOwnsResultRow)
				{
					if (m_xCursor->GetRow().is())
						(*m_xResultRow) = *m_xCursor->GetRow();
				}
				else
					m_xResultRow = m_xCursor->GetRow();

				m_aFields.replaceValues(m_xResultRow);
			}

			// Durch Aenderung der CacheSize kann der aktuelle zustand geaendert werden
			m_bBOF			= m_xCursor->IsBOF();
			m_bEOF			= m_xCursor->IsEOF();
			m_bFirst		= m_xCursor->IsOnFirst();
			m_bLast 		= m_xCursor->IsOnLast();

			break;
		case PROP_RECORDSTATUS:
			rValue >>= m_eRecordStatus;
			if (m_xResultRow.is())
				m_xResultRow->setModified(sal_False);
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbCursor::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	using namespace stardata;
	checkOpen();
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			rValue <<= m_xCursor->GetCacheSize();
			break;
		case PROP_CANINSERT:
			::utl::setBOOL(rValue,m_xCursor->CanAppend());
			break;
		case PROP_CANUPDATE:
			::utl::setBOOL(rValue,m_xCursor->CanUpdate());
			break;
		case PROP_CANDELETE:
			::utl::setBOOL(rValue,m_xCursor->CanDelete());
			break;
		case PROP_RECORDMODE:
			rValue <<= m_eRecordMode;
			break;
		case PROP_LASTUPDATED:
			rValue = m_xCursor->GetLastModified();
			break;
		case PROP_RECORDCOUNT:
			if (m_xCursor->RowCount() != m_nRecordCount)
				const_cast<SbaXdbCursor*>(this)->m_nRecordCount = m_xCursor->RowCount();
			rValue <<= m_nRecordCount;
			break;
		case PROP_ISRECORDCOUNTFINAL:
			if (m_bRecordCountFinal != m_xCursor->IsRowCountFinal())
				const_cast<SbaXdbCursor*>(this)->m_bRecordCountFinal = m_xCursor->IsRowCountFinal();
			::utl::setBOOL(rValue,m_bRecordCountFinal);
			break;
		case PROP_RECORDSTATUS:
			if (m_eRecordStatus == DatabaseRecordStatus_CLEAN && // datensatz geaendert ?
				m_eRecordMode != DatabaseRecordMode_STANDARD && m_xResultRow->isModified())
				const_cast<SbaXdbCursor*>(this)->m_eRecordStatus = DatabaseRecordStatus_MODIFIED;

			rValue <<= m_eRecordStatus;
			break;
		case PROP_THREADSAFE:
			::utl::setBOOL(rValue, m_xCursor.Is() && m_xCursor->IsThreadsafe());
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

// stardata::XDatabaseRecordSupplier
//------------------------------------------------------------------------------
Reference< starbeans::XPropertySet > SAL_CALL SbaXdbCursor::getRecord(void) throw( staruno::RuntimeException )
{
	return &m_aFields;
}

// stardata::XDatabaseCursor
//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::isValid(void) throw( staruno::RuntimeException )
{
	return m_xCursor && m_eRecordStatus != stardata::DatabaseRecordStatus_INVALID;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::isBeforeFirst(void) throw( staruno::RuntimeException )
{
	return m_bBOF;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::isBehindLast(void) throw( staruno::RuntimeException )
{
	return m_bEOF;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::isAtFirst(void) throw( staruno::RuntimeException )
{
	return m_bFirst;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::isAtLast(void) throw( staruno::RuntimeException )
{
	return m_bLast;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::moveToFirst(void) throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);

	// 66494 - FS - 01.06.1999
	// forward only cursor sollten kein moveToFirst zulassen
	if (m_bForwardOnly)
		throwSequenceError();

	sal_Bool bResult = m_xCursor->First();
	adjustState(&aCursorGuard);

	checkDBResult(m_xCursor->Status(), *this, sal_False);

	return bResult;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::moveRelative(sal_Int32 nCount) throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	sal_Bool bResult = sal_False;

	// 01.06.1999 - FS - 66494
	// forward only cursor sollten kein moveRelative rueckwaerts zulassen
	if (m_bForwardOnly && (nCount < 0))
		throwSequenceError();

	// aktuelle Position auswerten
	if (isValid())
	{
		if (m_eRecordMode != stardata::DatabaseRecordMode_STANDARD)
		{
			::osl::MutexGuard aGuard( m_aMutex );
			restoreState();
		}

		if (m_bForwardOnly)
		{
			if (nCount >= 1)
			{
				SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
				bResult = m_xCursor->MoveRel(nCount);
				adjustState(&aCursorGuard);
			}
			else
				throwSequenceError();
		}
		else if (m_eRecordStatus == stardata::DatabaseRecordStatus_DELETED && nCount == 0)
		{
			throwSequenceError();
		}
		else
		{
			SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
			if (m_bOwnsResultRow)
			{
				// Zeile ist vom Cursor geloescht worden
				if (m_bObsolete)
				{
					// startext::Bookmark von der Naechsten Zeile bekannt
					if (m_aNextBookmark.hasValue())
					{
						// in forward direction um einen weniger bewegen
						if (nCount > 0)
							nCount--;

						bResult = m_xCursor->MoveBookmark(m_aNextBookmark);
						if (bResult && nCount)
							bResult = m_xCursor->MoveRel(nCount);
					}
					else
					{
						// jetzt mu er schon hinter dem letzten stehen!
						if (nCount > 0)
							// fertig
							bResult = sal_False;
						else
						{
							bResult = m_xCursor->Last();
							if (bResult && nCount < -1)
								bResult = m_xCursor->MoveRel(nCount + 1);
						}
					}
				}
				else
				{
					if (!m_aBookmark.hasValue())
						throwSequenceError();
					bResult = m_xCursor->MoveBookmark(m_aBookmark) && m_xCursor->MoveRel(nCount);
				}
			}
			else
				bResult = m_xCursor->MoveRel(nCount);

			adjustState(&aCursorGuard);
		}
	}
	else
	{
		throwSequenceError();
	}

	checkDBResult(m_xCursor->Status(), *this, sal_False);

	return bResult;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::moveToLast(void) throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();

	SdbCursor::SdbCursorGuard aMainCursorGuard(m_xCursor);
	::osl::ClearableMutexGuard aMainGuard(m_aMutex);

	// 01.06.1999 - FS - 66494
	// forward only cursor sollten kein moveToLast zulassen
	if (m_bForwardOnly)
		throwSequenceError();

	sal_Bool bResult(sal_False);
	if (!m_bOwnsResultRow || m_bRecordCountFinal)
	{	// we're the only one working on the sdb cursor (so we can block it while moving)
		// or the last record is known (so the Last call should be fast enough)


		// remember our original position in case we will be canceled
		sal_Int32	nOriginalPosition = m_nPosition;

		aMainGuard.clear();
		bResult = m_xCursor->Last();

		// protect the results evaluation
		::osl::ClearableMutexGuard aEvaluationGuard(m_aMutex);

		if (m_xCursor->Status().IsCanceled())
		{	// somebody canceled it
			// restore the position
			m_xCursor->MoveAbs(nOriginalPosition + 1);
			bResult = sal_False;	// the operation was canceled ...

			// as usual : clear the guards before braodcasting any events
			aEvaluationGuard.clear();
			aMainCursorGuard.clear();

			// two aspects may have changed while this (only half done) "Last" call :
			// the "row count final" flag
			if (m_bRecordCountFinal != m_xCursor->IsRowCountFinal())
			{
				Any aOldValue = ::utl::makeBoolAny(m_bRecordCountFinal);
				Any aNewValue = ::utl::makeBoolAny(m_xCursor->IsRowCountFinal());
				m_bRecordCountFinal = m_xCursor->IsRowCountFinal();
				firePropertyChange(PROP_ISRECORDCOUNTFINAL, aNewValue, aOldValue);
			}

			// and the row count itself
			if (m_pCursorHdl)
				m_pCursorHdl->updateRowCount();
			else
				updateRowCount();
		}
		else
		{
			aEvaluationGuard.clear();
			adjustState(&aMainCursorGuard);
		}

		checkDBResult(m_xCursor->Status(), *this, sal_False);
	}
	else
	{
		// remember our original position in case we are canceled
		sal_Int32	nOriginalPosition = m_nPosition;

		// first reset the cache size to 0 so our repeated moveRelative isn't to inperformant
		sal_Int32 nOldCacheSize = m_xCursor->GetCacheSize();
		if (nOldCacheSize)
			m_xCursor->SetCacheSize(0);

		// we start a cancelable operation
		m_bCanceled = sal_False;

		// we should move (with an absolut jump) to the last known record
		m_xCursor->MoveAbs(m_xCursor->RowCount());
		checkDBResult(m_xCursor->Status(), *this, sal_False);

		sal_Bool bFinished = sal_False;
		bResult = sal_True;

		sal_Int32 nLastRoundPosition = m_xCursor->GetCurrentPos() - 1;

		aMainCursorGuard.clear();
		aMainGuard.clear();

		while (!bFinished)
		{
			// only protect the loop body with a guard so any other clones are able to move, too
			SdbCursor::SdbCursorGuard aInnerCursorGuard(m_xCursor);
			ReusableMutexGuard aInnerGuard(m_aMutex);

			// an other clone may have moved while we made a step
			bResult = m_xCursor->MoveAbs(nLastRoundPosition + 1);

			if (bResult)
			{
				// move forward some steps
				sal_Int32 nSteps = max(10L, min(100L, (sal_Int32)m_nRecordCount/50L));
					// while we move nSteps forward all other clones are blocked, so we use an uppper limit of 100

				aInnerGuard.clear();
				bResult = m_xCursor->MoveRel(nSteps);
				aInnerGuard.attach(m_aMutex);
				// We clear our mutex while moving the cursor. The reason is that the MoveRel may result in a change of the rowcount
				// which may trigger a _lot_ of other code here (the RowCountChangeHdl may be called, which will update our
				// and all our clone's RowCount, which forces us to fire our own propertyChanged event ...)
				// This is correct if we interpret m_aMutex as a mutex protecting our own internal state and the SdbCursor's mutex
				// as protector for all SdbCursor-accesses. The flaw in this understanding is that it isn't used consequently in
				// this class ...
				// Anyway. It's not wrong to do so here (me hopes), and it spares us some deadlocks (again :() ....

				// update my position (neded for the next round)
				nLastRoundPosition = Max((sal_Int32)(m_xCursor->GetCurrentPos() - 1), (sal_Int32)DBPOSITION_UNKNOWN);
				m_bRecordCountFinal = m_xCursor->IsRowCountFinal();

				// check if we're finished
				bFinished = m_bRecordCountFinal || !bResult || !m_xCursor->Status().IsSuccessful() || m_bCanceled;

				// update the row count (which results in m_nRecordCount to be set and a property change to be braodcasted)
				// (and clear my guards for this)
				aInnerGuard.clear();
				aInnerCursorGuard.clear();

				if (m_pCursorHdl)
					m_pCursorHdl->updateRowCount();
				else
					updateRowCount();
			}
			else
				bFinished = sal_True;
		}

		// the final cleaup requires protection, again
		SdbCursor::SdbCursorGuard aOuterCursorGuard(m_xCursor);
		::osl::ClearableMutexGuard aOuterGuard(m_aMutex);

		// reset the cache size
		if (nOldCacheSize)
			m_xCursor->SetCacheSize(nOldCacheSize);

		if (m_bCanceled)
		{
			m_xCursor->MoveAbs(nOriginalPosition + 1);

			m_nPosition = m_xCursor->GetCurrentPos() - 1;
			if (m_nPosition == nOriginalPosition)
			{	// the MoveAbs succeeded so we need to update only the few members modified in the upper loop
				m_bRecordCountFinal = m_xCursor->IsRowCountFinal();

				// (don't use adjustState, it plays a lot with mutexes which led to deadlocks as we tried it ...)
				aOuterGuard.clear();
				aOuterCursorGuard.clear();
				if (m_bRecordCountFinal)
				{
					Any aOldValue = ::utl::makeBoolAny(sal_False);
					Any aNewValue = ::utl::makeBoolAny(sal_True);
					firePropertyChange(PROP_ISRECORDCOUNTFINAL, aNewValue, aOldValue);
				}

				if (m_pCursorHdl)
					m_pCursorHdl->updateRowCount();
				else
					updateRowCount();
			}
			else
			{	// the upper MoveAbs failed so we need to fully adjust our state
				aOuterGuard.clear();
				adjustState(&aOuterCursorGuard);
			}

			bResult = sal_False;	// the operation was canceled ...
		}
		else if (m_xCursor->Status().Result() == SDB_STAT_NO_DATA_FOUND)
		{	// our only "mistake" was to move behind the last record, so simply correct this
			bResult = m_xCursor->Last();

			aOuterGuard.clear();	// same as above
			adjustState(&aOuterCursorGuard);
		}

		// and throw an exception ;) ...
		checkDBResult(m_xCursor->Status(), *this, sal_False);
	}

	return bResult;
}

// XBookmarkCursor
//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbCursor::getBookmark(void) throw( staruno::RuntimeException )
{
	return m_aBookmark;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::moveToBookmark(const Any& aBookmark)
	throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )
{
	checkOpen();

	// 66494 - FS - 01.06.1999
	// forward only cursor sollten kein moveToBookmark zulassen
	if (m_bForwardOnly)
		throwSequenceError();

	sal_Bool bResult = sal_False;
	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
	try
	{
		bResult = m_xCursor->MoveBookmark(aBookmark);
		adjustState(&aCursorGuard);
	}
	catch(...)
	{
		adjustState(&aCursorGuard);
		throw;
	}

	checkDBResult(m_xCursor->Status(), *this, sal_False);
	return bResult;
}

// stardata::XDatabaseDirectCursor
//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbCursor::getPosition(void)
 throw( staruno::RuntimeException )
{
	return m_nPosition;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbCursor::moveToPosition(sal_Int32 nPos)
	throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )
{
	checkOpen();
	if (nPos <= -2)
		throw starlang::IllegalArgumentException();

	// 66494 - FS - 01.06.1999
	// forward only cursor sollten kein moveToPosition zulassen
	if (m_bForwardOnly)
		throwSequenceError();

	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
	sal_Bool bResult = m_xCursor->MoveAbs(nPos + 1);
	adjustState(&aCursorGuard);
	checkDBResult(m_xCursor->Status(), *this, sal_False);

	return bResult;
}

// stardata::XDatabaseUpdateCursor
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCursor::addRecord(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	using namespace stardata;	// for enum/const values

	checkOpen();
	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);

	if (!m_xCursor->CanAppend())
		throwSequenceError();
	else
	{
		if (m_eRecordMode != DatabaseRecordMode_NEW)
		{
			::osl::ClearableMutexGuard aGuard( m_aMutex );

			if (m_eRecordMode != DatabaseRecordMode_STANDARD)
				restoreState();

			saveState();

			if (m_bOwnsResultRow)
				m_xResultRow = new ODbRow(*m_xCursor->GetColumns());
			else
			{
				if (!m_xCursor->AppendRow())
					checkDBResult(m_xCursor->Status(), *this, sal_False);

				m_xResultRow = m_xCursor->GetRow();
			}

			// Default eintragen, das sind in erster Linie autoinkrement werte
			m_xCursor->PrepareAppendRow(m_xResultRow);

			DatabaseRecordMode eOldRecordMode = m_eRecordMode;
			DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;

			m_eRecordMode = DatabaseRecordMode_NEW;
			m_eRecordStatus = DatabaseRecordStatus_CLEAN;

			m_aFields.replaceValues(m_xResultRow);
			m_aFields.setDefaults();
			m_xResultRow->setModified(sal_False);
			if (!m_bForwardOnly)
				m_aBookmark = Any();

			aGuard.clear();
			if (eOldRecordMode != m_eRecordMode)
				firePropertyChange(PROP_RECORDMODE,
									staruno::makeAny(m_eRecordMode),
									staruno::makeAny(eOldRecordMode) );

			if (eOldRecordStatus != m_eRecordStatus)
				firePropertyChange(PROP_RECORDSTATUS,
									staruno::makeAny(m_eRecordStatus),
									staruno::makeAny(eOldRecordStatus) );
		}
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCursor::editRecord(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	using namespace stardata;	// for enum/const values

	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);

	if (!isValid() || !m_xCursor->CanUpdate() ||
		m_eRecordStatus == DatabaseRecordStatus_DELETED ||
		(!m_bForwardOnly && !m_aBookmark.hasValue()))
	{
		throwSequenceError();
	}
	else
	{
		if (m_eRecordMode != DatabaseRecordMode_UPDATING)
		{
			::osl::ClearableMutexGuard aGuard( m_aMutex );

			if (m_eRecordMode != DatabaseRecordMode_STANDARD)
				restoreState();

			saveState();

			if (!m_bOwnsResultRow)
			{
				if (!m_xCursor->EditRow())
					checkDBResult(m_xCursor->Status(), *this, sal_False);

				m_xResultRow = m_xCursor->GetRow();
			}

			DatabaseRecordMode eOldRecordMode = m_eRecordMode;
			m_eRecordMode = DatabaseRecordMode_UPDATING;
			m_aFields.replaceValues(m_xResultRow);

			aGuard.clear();
			firePropertyChange(PROP_RECORDMODE,
								staruno::makeAny(m_eRecordMode),
								staruno::makeAny(eOldRecordMode) );
		}
	}
}

//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbCursor::updateRecord(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	using namespace stardata;	// for enum/const values

	sal_Int32 nRecordsAffected(0);
	checkOpen();
	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);

	if (!isValid() || m_eRecordMode == DatabaseRecordMode_STANDARD)
	{
		throwSequenceError();
	}
	else
	{
		::osl::ClearableMutexGuard aGuard( m_aMutex );
		DatabaseRecordMode eOldRecordMode = m_eRecordMode;
		DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;
		if (m_eRecordMode == DatabaseRecordMode_NEW)	// hinzufuegen
		{
			if (m_bOwnsResultRow)
			{
				if (!m_xCursor->AppendRow())
					checkDBResult(m_xCursor->Status(), *this);

				(*m_xCursor->GetRow()) = *m_xResultRow;
			}

			if (!m_xCursor->UpdateRow())
			{
				SdbStatus aStatus = m_xCursor->Status();

				if (m_bOwnsResultRow)
					m_xCursor->CancelRow(); 		// verarbeitung abbrechen

				checkDBResult(aStatus, *this);
			}
			else
			{
				nRecordsAffected = m_xCursor->Status().GetRecordsAffected();
				restoreState();

				if (!m_bForwardOnly)
					m_aFields.replaceValues(m_xResultRow);

				m_eRecordMode = DatabaseRecordMode_STANDARD;
			}
		}
		else if (m_eRecordMode == DatabaseRecordMode_UPDATING)
		{
			if (m_bOwnsResultRow)
			{
				if (!m_xCursor->MoveBookmark(m_aBookmark))
					checkDBResult(m_xCursor->Status(), *this);

				if (!m_xCursor->EditRow())
					checkDBResult(m_xCursor->Status(), *this);

				(*m_xCursor->GetRow()) = *m_xResultRow;
			}

			if (!m_xCursor->UpdateRow())
			{
				SdbStatus aStatus = m_xCursor->Status();
				if (m_bOwnsResultRow)
					m_xCursor->CancelRow(); 		// verarbeitung abbrechen
				checkDBResult(aStatus, *this);
			}
			else
			{
				nRecordsAffected = m_xCursor->Status().GetRecordsAffected();

				//Aenderungen uebernehmen
				if (!m_bForwardOnly)
				{
					if (m_bOwnsResultRow)
						(*m_xResultRow) = *m_xCursor->GetRow();

					m_aFields.replaceValues(m_xResultRow);
				}
				m_eRecordMode = DatabaseRecordMode_STANDARD;
				m_xResultRow->setModified(sal_False);
			}
		}
		aGuard.clear();
		firePropertyChange(PROP_RECORDMODE,
							staruno::makeAny(m_eRecordMode),
							staruno::makeAny(eOldRecordMode) );

		firePropertyChange(PROP_RECORDSTATUS,
							staruno::makeAny(m_eRecordStatus),
							staruno::makeAny(eOldRecordStatus) );

	}
	return nRecordsAffected;
}

//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbCursor::deleteRecord(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	using namespace stardata;	// for enum/const values

	sal_Int32 nRecordsAffected(0);
	checkOpen();
	SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);

	if (!isValid() || !m_xCursor->CanDelete() || (!m_bForwardOnly && !m_aBookmark.hasValue()))
	{
		throwSequenceError();
	}
	else
	{
		::osl::ClearableMutexGuard aGuard( m_aMutex );

		// zunaechst auf den Datensatz positionieren
		if (m_bOwnsResultRow && !m_xCursor->MoveBookmark(m_aBookmark))
			checkDBResult(m_xCursor->Status(), *this);

		if (m_xCursor->DeleteRow())
		{
			nRecordsAffected = m_xCursor->Status().GetRecordsAffected();

			// Um zu verhindern, da ein geclonter Cursor die aktuelle startext::Bookmark durch
			// Move-Operation ungueltig macht, wird sich die startext::Bookmark vom naechsten Datensatz gemerkt
			if (m_bOwnsResultRow)
			{
				Any aNextBookmark;
				if (m_xCursor->Next())
					aNextBookmark = (*m_xCursor->GetRow())[0]->getAny();
				else
					aNextBookmark = Any();

				aGuard.clear();
				if (m_pCursorHdl)
					m_pCursorHdl->recordDeleted(m_aBookmark, aNextBookmark);
				else
					recordDeleted(m_aBookmark, aNextBookmark);
			}
			else
			{
				if (!m_bForwardOnly)
					m_aBookmark = Any();
				DatabaseRecordMode eOldRecordMode = m_eRecordMode;
				DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;

				m_eRecordMode = DatabaseRecordMode_STANDARD;
				m_eRecordStatus = DatabaseRecordStatus_DELETED;
				m_bObsolete = sal_True;

				aGuard.clear();
				firePropertyChange(PROP_RECORDMODE,
									staruno::makeAny(m_eRecordMode),
									staruno::makeAny(eOldRecordMode));

				firePropertyChange(PROP_RECORDSTATUS,
									staruno::makeAny(m_eRecordStatus),
									staruno::makeAny(eOldRecordStatus));

			}
		}
		else
			checkDBResult(m_xCursor->Status(), *this);
	}
	return nRecordsAffected;
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCursor::restoreRecord(void)
	throw( staruno::RuntimeException )
{
	checkOpen();
	stardata::DatabaseRecordMode eOldRecordMode = m_eRecordMode;
	stardata::DatabaseRecordStatus eOldRecordStatus = m_eRecordStatus;
	{
		SdbCursor::SdbCursorGuard aCursorGuard(m_xCursor);
		::osl::MutexGuard aGuard( m_aMutex );
		restoreState();

		m_aFields.replaceValues(m_xResultRow);
		m_eRecordMode = stardata::DatabaseRecordMode_STANDARD;
	}
	if (eOldRecordMode != m_eRecordMode)
		firePropertyChange(PROP_RECORDMODE,
							staruno::makeAny(m_eRecordMode),
							staruno::makeAny(eOldRecordMode));

	if (eOldRecordStatus != m_eRecordStatus)
		firePropertyChange(PROP_RECORDSTATUS,
							staruno::makeAny(m_eRecordStatus),
							staruno::makeAny(eOldRecordStatus));
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbCursor::cancel(void)
	throw( staruno::RuntimeException )
{
	checkOpen();

	DBG_ASSERT(m_xCursor->IsCancelable(), "SbaXdbCursor::cancel : called on a non-cancelable cursor !");
	m_xCursor->Cancel();

	::osl::MutexGuard aGuard(m_aMutex);
	m_bCanceled = sal_True;
}

//------------------------------------------------------------------------------
SbaXdbStatement::SbaXdbStatement(SbaXdbCollection& rCollection, SdbCursor& rCursor, const ::rtl::OUString& aStmt, sal_Bool bPassThrough)
				:SbaXdbObject(rCollection)
				,PropertySetHelper(ComponentHelper::rBHelper)
				,m_aCursors(*this)
				,m_aParameters(*this, rCursor.GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
				,m_aFields(*this, rCursor.GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
				,m_xCursor(&rCursor)
				,m_aStatement(aStmt)
				,m_nTimeOut(0)
				,m_nMaxFieldSize(0)
				,m_nMaxRecordCount(0)
				,m_bCreateRefFields(sal_False)
				,m_bPassThrough(bPassThrough)
				,m_nCacheSize(0)
{
	SbaXdbDatabase* pDatabase;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getXdbParent(),::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		pDatabase = (SbaXdbDatabase*)xTunnel->getSomething(SbaXdbDatabase:: getUnoTunnelImplementationId());
	}
	m_bCreateRefFields = !m_bPassThrough && pDatabase;

	m_aParameters.constructParameterFields(m_xCursor->GetParameterColumns(), m_xCursor->GetParameterRow());
}

//------------------------------------------------------------------------------
SbaXdbStatement::SbaXdbStatement(SbaXdbCollection& rCollection,
								 SdbCursor& rCursor,
								 const ::rtl::OUString& aStmt,
								 sal_Bool bPassThrough,
								 const SbaXdbFields& rFields)
				:SbaXdbObject(rCollection)
				,PropertySetHelper(ComponentHelper::rBHelper)
				,m_aCursors(*this)
				,m_aParameters(*this, rCursor.GetConnection()->GetIdentifierCase() == SDB_IC_ALL)
				,m_aFields(*this, rFields)
				,m_xCursor(&rCursor)
				,m_aStatement(aStmt)
				,m_nTimeOut(0)
				,m_nMaxFieldSize(0)
				,m_nMaxRecordCount(0)
				,m_bPassThrough(bPassThrough)
				,m_bCreateRefFields(sal_False)
				,m_nCacheSize(0)
{
	m_aParameters.constructParameterFields(m_xCursor->GetParameterColumns(), m_xCursor->GetParameterRow());
}

//------------------------------------------------------------------------------
SbaXdbStatement::~SbaXdbStatement()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbStatement::disposing(void)
{
	SbaXdbObject::disposing();

	m_aFields.disposing();
	m_aParameters.disposing();
	m_aCursors.disposing();
	m_xCursor = NULL;
}

// stardata::XPreparedDatabaseStatement
//------------------------------------------------------------------------------
Reference< starbeans::XPropertySet > SAL_CALL SbaXdbStatement::getParameters(void)
	throw( staruno::RuntimeException )
{
	return &m_aParameters;
}

// stardata::XDatabaseStatement
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbStatement::getStatement(void)
	throw( staruno::RuntimeException )
{
	return m_aStatement;
}

//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbStatement::execute(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();

	{
		::osl::MutexGuard aGuard( m_aMutex );
		m_aCursors.disposing();

		if (m_xCursor->IsPrepared())
			m_xCursor->Open();
		else
		{
			if (m_xCursor->IsOpen())
				m_xCursor->Close();

			if (m_aTableName.len())
				m_xCursor->Open(m_aTableName,sal_True);
			else
				m_xCursor->Open(m_aStatement,sal_False);

		}
	}

	checkDBResult(m_xCursor->Status(), *this, sal_False);
	return (sal_Int32) m_xCursor->Status().GetRecordsAffected();
}

//------------------------------------------------------------------------------
Reference< stardata::XDatabaseCursor >
	SAL_CALL SbaXdbStatement::executeQuery( stardata::DatabaseCursorType eType, sal_Int16 nOptions)
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )
{
	using namespace stardata;

	checkOpen();

	::osl::MutexGuard aGuard( m_aMutex );
	m_aCursors.disposing();

	SdbCursorType eSdbType = SDB_SNAPSHOT;
	sal_uInt16 nSdbOptions = 0;
	if (!m_bPassThrough)
		nSdbOptions = SDB_INDIRECT;

	switch (eType)
	{
		case DatabaseCursorType_FORWARD:
			nSdbOptions |= SDB_FORWARDONLY;
			break;
		case DatabaseCursorType_SNAPSHOT:
			nSdbOptions |= SDB_SEEDELETED;
			break;
		default:
			// DatabaseCursorType_DYNAMIC wird noch nicht unterstuetzt
			nSdbOptions |= SDB_SEEDELETED;
			eSdbType = SDB_KEYSET;
	}

	if (nOptions & DatabaseCursorOption::READONLY)
		nSdbOptions |= SDB_READONLY;

	if (nOptions & DatabaseCursorOption::INSERTONLY)
		nSdbOptions |= SDB_APPENDONLY;

	if (m_nCacheSize && eSdbType == SDB_KEYSET)
		m_xCursor->SetCacheSize(m_nCacheSize);

	if (m_xCursor->IsPrepared())
		m_xCursor->Open(eSdbType, nSdbOptions);
	else
	{
		if (m_xCursor->IsOpen())
			m_xCursor->Close();

		if (m_aTableName.len())
			m_xCursor->Open(m_aTableName,sal_True, eSdbType, nSdbOptions);
		else
			m_xCursor->Open(m_aStatement,sal_False, eSdbType, nSdbOptions);
	}

	checkDBResult(m_xCursor->Status(), *this, sal_False);

	if (!m_xCursor->GetColumns().is() || m_xCursor->GetColumns()->Count() < 2)
	{
		SdbStatus aStatus;
		aStatus.SetInvalidStatement();
		checkDBResult(aStatus, *this, sal_False);
	}

	if (m_bCreateRefFields)
	{
		DBG_ASSERT(!m_aFields.getCount(), "SbaXdbStatement::executeQuery, ungltiger Count()");
		m_bCreateRefFields = sal_False;

		const SdbSqlParseTreeIterator& rIter =	*m_xCursor->SQLParseIterator();
		if (m_xCursor->SQLParseIterator()
			&& rIter.StatementType() == SDB_STATEMENT_SELECT
			&& rIter.GetSelectColumns().is()
			&& rIter.GetSelectColumns()->Count() > 1)
		{
			const SdbColumnsRef xCols(rIter.GetSelectColumns());
			// Vater auf alle Faelle festhalten
			Reference< staruno::XInterface >  xParent(*getXdbParent());

			SbaXdbDatabase* pDatabase = 0;
			::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel(xParent,::com::sun::star::uno::UNO_QUERY);
			if(xTunnel.is())
			{
				pDatabase = (SbaXdbDatabase*)xTunnel->getSomething(SbaXdbDatabase:: getUnoTunnelImplementationId());
			}
			//	utl::getImplementation(pDatabase, xParent);

			DBG_ASSERT(pDatabase, "SbaXdbStatement::executeQuery, ungltiger Parent");
			SbaXdbTableDefs& rTables = pDatabase->getXdbTables();

			Reference< staruno::XInterface > 	 xTable;
			SbaXdbTableDef*  pTable  = NULL;
			String			 aCurrentTableName;
			m_aFields.setDefinitions(xCols);

			for (sal_uInt32 i = 1; i < xCols->Count(); i++)
			{
				const SdbColumn* pCol	= xCols->Column(i);
				if (!pCol->GetTableName().Len())
					continue;

				if (!aCurrentTableName.Equals(pCol->GetTableName()))
				{
					aCurrentTableName = pCol->GetTableName();

					if (aCurrentTableName.Len())
					{
						try
						{
							pTable	= (SbaXdbTableDef*)rTables.get(aCurrentTableName);
						}
						catch(...)
						{
							pTable = NULL;
						}
					}
					else
						pTable = NULL;

					if (pTable)
						xTable = static_cast< Reference<staruno::XInterface> >(*pTable);
					else
						xTable = NULL;
				}

				if (pTable)
				{
					const SbaXdbFields& m_rFields = pTable->getImplFields();
					const SbaXdbField* pRefField  = m_rFields.at(pCol->GetRealName());
					if (pRefField)
					{
						SbaXdbField* pField = m_aFields[i-1];
						pField->adjustType(*pRefField);
					}
				}
			}
		}
	}

	const SbaXdbFields* pRefFields = m_aFields.getCount() ? &m_aFields : NULL;
	return new SbaXdbCursor(m_aCursors, *m_xCursor, pRefFields, eType == DatabaseCursorType_FORWARD);
}

// PropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbStatement::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	SBA_BEGIN_PROPERTY_HELPER(aProperties,6)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CACHESIZE),			PROP_TYPE(sal_Int16),	starbeans::PropertyAttribute::TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(EXECUTIONTIMEOUT),	PROP_TYPE(sal_Int32),	starbeans::PropertyAttribute::TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISPASSTHROUGH),		BOOL_PROP(),			starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(MAXFIELDSIZE),		PROP_TYPE(sal_Int32),	starbeans::PropertyAttribute::TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(MAXRECORDCOUNT),	PROP_TYPE(sal_Int32),	starbeans::PropertyAttribute::TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(STATEMENT),			PROP_TYPE(OUString),	starbeans::PropertyAttribute::TRANSIENT | starbeans::PropertyAttribute::READONLY);
	SBA_END_PROPERTY_HELPER();
}

// OPropertySetHelper
//------------------------------------------------------------------------------
sal_Bool SbaXdbStatement::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException )
{
	checkOpen();

	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nCacheSize);
			break;
		case PROP_EXECUTIONTIMEOUT:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nTimeOut);
			break;
		case PROP_MAXFIELDSIZE:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nMaxFieldSize);
			break;
		case PROP_MAXRECORDCOUNT:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nMaxRecordCount);
			break;
		default:
			DBG_ERROR("unknown Porperty");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbStatement::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw (staruno::Exception)
{
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nCacheSize;
			break;
		case PROP_EXECUTIONTIMEOUT:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_LONG, "invalid type" );

			rValue>>= m_nTimeOut;
			break;
		case PROP_MAXFIELDSIZE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_LONG, "invalid type" );

			rValue>>= m_nMaxFieldSize;
			break;
		case PROP_MAXRECORDCOUNT:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_LONG, "invalid type" );

			rValue>>= m_nMaxRecordCount;
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbStatement::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	checkOpen();
	switch (nHandle)
	{
		case PROP_CACHESIZE:
			rValue <<= m_nCacheSize;
			break;
		case PROP_EXECUTIONTIMEOUT:
			rValue <<= m_nTimeOut;
			break;
		case PROP_MAXFIELDSIZE:
			rValue <<= m_nMaxFieldSize;
			break;
		case PROP_MAXRECORDCOUNT:
			rValue <<= m_nMaxRecordCount;
			break;
		case PROP_STATEMENT:
			rValue <<= m_aStatement;
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
SbaXdbTableStatement::SbaXdbTableStatement(SbaXdbCollection& rCollection, SdbCursor& rCursor,
										   const SbaXdbTable_Impl& rTable)
					 :SbaXdbStatement(rCollection, rCursor, ::rtl::OUString(), sal_False, rTable.m_aFields)
{
	m_aTableName = const_cast<SbaXdbTable_Impl&>(rTable).getName();
	String aSQLStatement;
	aSQLStatement.AssignAscii("Select * FROM ");
	aSQLStatement += rCursor.GetConnection()->QuoteTableName(m_aTableName);
	m_aStatement = aSQLStatement;
}

//------------------------------------------------------------------------------
SbaXdbQueryStatement::SbaXdbQueryStatement(SbaXdbCollection& rCollection, SdbCursor& rCursor,
										   const SbaXdbQuery& rQuery)
					 :SbaXdbStatement(rCollection, rCursor, rQuery.m_aQuery, rQuery.m_bPassThrough, rQuery.m_aFields)
{
}

















