/*************************************************************************
 *
 *  $RCSfile: sbadbdat.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBDAT_HXX
#include "sbadbdat.hxx"
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif
#ifndef _UTL_SEQUENCE_HXX_
#include <unotools/sequence.hxx>
#endif
#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif

#include "sbautl/unopropertymacros.hxx"

using staruno::Any;
using staruno::Sequence;
using staruno::Reference;
using staruno::UNO_QUERY;
using starbeans::PropertyValue;


DBG_NAME(SbaXdbDatabase);
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbDatabase::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbObjectCreator::getSomething(rId);
}
using namespace ::cppu;
using namespace ::osl;

//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbDatabase::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
SbaXdbDatabase::SbaXdbDatabase()
			   :SbaXdbObjectCreator(sal_True)
			   ,PropertySetHelper(ComponentHelper::rBHelper)
			   ,m_aStatements(*this)
			   ,m_aTables(*this)
			   ,m_aRelations(*this)
			   ,m_aQueries(*this)
			   ,m_aForms(*this,dbForm)
			   ,m_aReports(*this, dbReport)
			   ,m_aParsers(*this)
{
	DBG_CTOR(SbaXdbDatabase,NULL);
	::utl::increment(m_refCount);
	getAggregation();
	::utl::decrement(m_refCount);
}

//------------------------------------------------------------------------------
SbaXdbDatabase::SbaXdbDatabase(SbaXdbCollection& rCollection, SbaDatabase* pDat)
			   :SbaXdbObjectCreator(rCollection, pDat->GetIdentifierCase() == SDB_IC_ALL)
			   ,PropertySetHelper(ComponentHelper::rBHelper)
			   ,m_xDatabase(pDat)
			   ,m_aStatements(*this)
			   ,m_aTables(*this)
			   ,m_aRelations(*this)
			   ,m_aQueries(*this)
			   ,m_aForms(*this, dbForm)
			   ,m_aReports(*this, dbReport)
			   ,m_aParsers(*this)
{
	DBG_CTOR(SbaXdbDatabase,NULL);
	::utl::increment(m_refCount);
	getAggregation();
	::utl::decrement(m_refCount);
}

//------------------------------------------------------------------------------
SbaXdbDatabase::~SbaXdbDatabase()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}

	if (m_xAgg.is())
	{
		Reference< staruno::XInterface >  xInt;
		m_xAgg->setDelegator(xInt);
	}
	DBG_DTOR(SbaXdbDatabase,NULL);
}

//------------------------------------------------------------------------------
Sequence<staruno::Type> SbaXdbDatabase::collectTypes(SbaXdbDatabase* p) throw(staruno::RuntimeException)
{
	// hard-coded: Aggregate provides XNumberFormatsSupplier
	using starutil::XNumberFormatsSupplier;
	staruno::Type const& rExtraType = ::getCppuType(static_cast<Reference<XNumberFormatsSupplier>*>(0));

	DBG_ASSERT(getAggregation()->queryAggregation(rExtraType).hasValue(),"Missing type from aggregated object");
	return ::cppu::OTypeCollection(rExtraType, PropertySetHelper::collectTypes(p) ).getTypes();
}

//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbDatabase::queryInterface(staruno::Type const& rType) throw(staruno::RuntimeException)
{
	Any aRet(PropertySetHelper::queryInterface(rType));
	return aRet.hasValue() ? aRet : getAggregation()->queryAggregation(rType);
}

//------------------------------------------------------------------------------
const Reference< staruno::XAggregation > & SbaXdbDatabase::getAggregation()
{
	::osl::MutexGuard aGuard( m_aMutex );
	if (!m_xAgg.is())
	{
		SvNumberFormatsSupplierObj* pNum = new SvNumberFormatsSupplierObj(m_xDatabase->GetFormatter());
		m_xAgg = pNum;
		m_xAgg->setDelegator(*this);
	}
	return m_xAgg;
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbDatabase::disposing()
{
	SbaXdbObject::disposing();
	m_aStatements.disposing();
	m_aTables.disposing();
	m_aRelations.disposing();
	m_aQueries.disposing();
	m_aForms.disposing();
	m_aReports.disposing();
	m_aParsers.disposing();
	m_xDatabase = NULL;
}

// starcontainer::XNamed
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbDatabase::getName(void)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard(m_aMutex );
	return isOpen() ?::rtl::OUString( m_xDatabase->Name()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDatabase::setName(const ::rtl::OUString& _rName)
	throw( staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDatabase->Rename(_rName);
	try
	{
		checkDBResult(m_xDatabase->Status(), *this, sal_True);
	}
	catch(staruno::RuntimeException&)
	{
		throw;
	}
	catch(staruno::Exception& e)
	{
		throw staruno::RuntimeException(e.Message,*this);
	}
}

// Helper
//------------------------------------------------------------------------------
Sequence< PropertyValue > SbaXdbDatabase::toConnectionProperties(const String& rConnectStr)
{
	CommandParser aOptionsParser(rConnectStr,';','=',sal_True);
	sal_Int32 nCount = aOptionsParser.OptionCount();

	Sequence< PropertyValue > aPropertySequence(nCount);
	PropertyValue* pArray = aPropertySequence.getArray();

	// Password nicht mit rausgeben
	sal_Int32 nPwdPos(-1);
	for (sal_Int32 i = 0; i < nCount; i++)
	{
		String aKey(aOptionsParser.OptionName(i));
		String aValue(aOptionsParser.OptionString(i));

		if (aKey.EqualsIgnoreCaseAscii("TYP") == COMPARE_EQUAL)
			aKey.AssignAscii("TYPE");
		else if (aKey.EqualsIgnoreCaseAscii("PWD") == COMPARE_EQUAL)
		{
			nPwdPos = i;
			continue;
		}

		pArray[i] = PropertyValue(aKey,-1,
									staruno::makeAny(::rtl::OUString(aValue)),
									starbeans::PropertyState_DIRECT_VALUE);
	}

	if (nPwdPos >= 0)
		::utl::removeElementAt(aPropertySequence,nPwdPos);

	return aPropertySequence;
}

//------------------------------------------------------------------------------
String SbaXdbDatabase::toConnectionStr(const Sequence< PropertyValue >& aProperties)
{
	sal_Int32 nCount = aProperties.getLength();
	String aConnectStr;
	for (sal_Int32 i = 0; i < nCount; i++)
		try
		{
			String aKey(aProperties[i].Name);

			::rtl::OUString aValue;
			::cppu::convertPropertyValue(aValue, aProperties[i].Value);

			// sdb kennt nur TYP
			if (aKey.EqualsIgnoreCaseAscii("TYPE") == COMPARE_EQUAL)
				aKey.AssignAscii("TYP");

			(((aConnectStr += aKey) += '=') += (const sal_Unicode*)aValue) += ';';
		}
		catch(...) // Ignore Illegal Arguments
		{
			DBG_WARNING("Illegal Property value for connection string");
		}
	aConnectStr.EraseLeadingChars(';');
	return aConnectStr;
}

// stardata::XDatabase
//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL  SbaXdbDatabase::getQueries(void)
	throw( staruno::RuntimeException )
{
	return &m_aQueries;
}

//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL SbaXdbDatabase::getForms(void)
	throw( staruno::RuntimeException )
{
	return &m_aForms;
}

//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL SbaXdbDatabase::getReports(void)
	throw( staruno::RuntimeException )
{
	return &m_aReports;
}

// stardata::XDatabaseConnection
//------------------------------------------------------------------------------
Reference< stardata::XDatabaseDescriptor > SAL_CALL SbaXdbDatabase::getMetaData(void)
	throw( staruno::RuntimeException )
{
	Reference< stardata::XDatabaseDescriptor >  xMData;
	if (m_xDatabase)
		xMData = m_xDatabase->GetMetaData();
	return xMData;
}

//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL SbaXdbDatabase::getTables(void)
	throw( staruno::RuntimeException )
{
	return &m_aTables;
}

//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL SbaXdbDatabase::getRelations(void)
	throw( staruno::RuntimeException )
{
	return &m_aRelations;
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbDatabase::getCatalog(void)
	throw( staruno::RuntimeException )
{
	return isOpen() ? ::rtl::OUString(m_xDatabase->GetQualifier()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDatabase::setCatalog(const ::rtl::OUString& aCatalog)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
}

//------------------------------------------------------------------------------
Reference< stardata::XDatabaseStatement >
	SAL_CALL SbaXdbDatabase::createStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough)
		throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();

	SdbCursorType eSdbType = SDB_SNAPSHOT;
	sal_uInt16 nSdbOptions = SDB_FORWARDONLY | SDB_READONLY;

	if (!bPassThrough)
		nSdbOptions |= SDB_INDIRECT;

	SdbCursorRef xSdbCursor = m_xDatabase->CreateCursor(eSdbType, nSdbOptions);
	checkDBResult(m_xDatabase->Status(), *this, sal_False);

	DBG_ASSERT(xSdbCursor.Is(), "SbaXdbDatabase::createStatement: kein Cursor erzeugt");

	if (xSdbCursor.Is())
		return new SbaXdbStatement(m_aStatements, *xSdbCursor, aStatement, bPassThrough);
	else
		return Reference< stardata::XDatabaseStatement > ();
}

//------------------------------------------------------------------------------
Reference< stardata::XPreparedDatabaseStatement >
	SAL_CALL SbaXdbDatabase::createPreparedStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough)
		throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();

	SdbCursorType eSdbType = SDB_SNAPSHOT;
	sal_uInt16 nSdbOptions = SDB_FORWARDONLY | SDB_READONLY;

	if (!bPassThrough)
		nSdbOptions |= SDB_INDIRECT;

	SdbCursorRef xSdbCursor = m_xDatabase->CreateCursor(eSdbType, nSdbOptions);
	checkDBResult(m_xDatabase->Status(), *this, sal_False);

	DBG_ASSERT(xSdbCursor.Is(), "SbaXdbDatabase::createStatement: kein Cursor erzeugt");

	if (xSdbCursor.Is())
	{
		xSdbCursor->Prepare(aStatement);
		checkDBResult(xSdbCursor->Status(), *this, sal_False);
		return new SbaXdbStatement(m_aStatements, *xSdbCursor, aStatement, bPassThrough);
	}
	else
		return Reference< stardata::XPreparedDatabaseStatement > ();
}

//------------------------------------------------------------------------------
Reference< stardata::XPreparedDatabaseStatement >
	SAL_CALL SbaXdbDatabase::createProcedureStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough)
		throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();

	SdbCursorType eSdbType = SDB_SNAPSHOT;
	sal_uInt16 nSdbOptions = SDB_FORWARDONLY | SDB_READONLY;

	if (!bPassThrough)
		nSdbOptions |= SDB_INDIRECT;

	SdbCursorRef xSdbCursor = m_xDatabase->CreateCursor(eSdbType, nSdbOptions);
	checkDBResult(m_xDatabase->Status(), *this, sal_False);

	DBG_ASSERT(xSdbCursor.Is(), "SbaXdbDatabase::createStatement: kein Cursor erzeugt");

	if (xSdbCursor.Is())
	{
		xSdbCursor->Prepare(aStatement);
		checkDBResult(xSdbCursor->Status(), *this, sal_False);
		return new SbaXdbStatement(m_aStatements, *xSdbCursor, aStatement, bPassThrough);
	}
	else
		return Reference< stardata::XPreparedDatabaseStatement > ();
}

// stardata::XDatabaseTransactionSupplier
//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbDatabase::isAutoCommit(void) throw( staruno::RuntimeException )
{
	if (m_xDatabase.Is())
		return m_xDatabase->GetConnection()->IsAutoCommit();
	else
		return sal_True;
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDatabase::setAutoCommit(sal_Bool bEnable)
	throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDatabase->GetConnection()->SetAutoCommit(bEnable);
	checkDBResult(m_xDatabase->GetConnection()->Status(), *this);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDatabase::commit(void)
	throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	if (!m_xDatabase->GetConnection()->CommitTrans())
		checkDBResult(m_xDatabase->GetConnection()->Status(), *this);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDatabase::rollback(void)
	throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	if (!m_xDatabase->GetConnection()->RollbackTrans())
		checkDBResult(m_xDatabase->GetConnection()->Status(), *this);
}

//------------------------------------------------------------------------------
sal_Int16 SAL_CALL SbaXdbDatabase::getIsolationLevel(void)
	throw( staruno::RuntimeException )
{
	return m_xDatabase ? m_xDatabase->GetConnection()->IsolationLevel() : stardata::DatabaseIsolationLevel::NONE;
}

//------------------------------------------------------------------------------
void SbaXdbDatabase::setIsolationLevel(sal_Int16 Level)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDatabase->GetConnection()->SetIsolationLevel(SdbIsolationLevel(Level));
	checkDBResult(m_xDatabase->GetConnection()->Status(), *this);
}

// PropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbDatabase::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	using starbeans::PropertyAttribute::TRANSIENT;
	using starbeans::PropertyAttribute::READONLY;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,6)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(CONNECTIONSETTINGS),PROP_TYPE(Sequence<PropertyValue>),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREADONLY),		BOOL_PROP(),				TRANSIENT | READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),				PROP_TYPE(OUString),		READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(THREADSAFE),		BOOL_PROP(),				TRANSIENT | READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TITLE),				PROP_TYPE(OUString),		0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(URL),				PROP_TYPE(OUString),		READONLY | TRANSIENT);
	SBA_END_PROPERTY_HELPER();
}

// OPropertySetHelper
//------------------------------------------------------------------------------
sal_Bool SbaXdbDatabase::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException  )
{
	checkOpen();

	if (m_xDatabase->IsReadOnly())
	{
		throw starlang::IllegalArgumentException();
	}

	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_TITLE:
		{
			::rtl::OUString aTitle(m_xDatabase->Title());

			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															aTitle);
		}	break;
		case PROP_CONNECTIONSETTINGS:
			if (!rValue.getValueType().equals(PROP_TYPE(Sequence<PropertyValue>)))

			{
				throw starlang::IllegalArgumentException();
			}
			bModified = sal_True;
			getFastPropertyValue(rOldValue, nHandle);
			rConvertedValue = rValue;
			break;
		default:
			DBG_ERROR("unknown Property");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbDatabase::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw( staruno::Exception )
{
	switch (nHandle)
	{
		case PROP_TITLE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			m_xDatabase->AlterTitle(::utl::getString(rValue));
			break;
		case PROP_CONNECTIONSETTINGS:
		{
			DBG_ASSERT(rValue.getValueType().equals(PROP_TYPE(Sequence<PropertyValue>)), "invalid type" );

			Sequence<PropertyValue> const*pValues = static_cast<Sequence<PropertyValue> const*>(rValue.getValue());
			String aConnectStr(toConnectionStr(*pValues));
			m_xDatabase->AlterConnection(aConnectStr);
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbDatabase::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_TITLE:
			if (isOpen())
				rValue <<= ::rtl::OUString(m_xDatabase->Title());
			else
				rValue <<= ::rtl::OUString();
			break;
		case PROP_ISREADONLY:
			if (!isOpen())
				::utl::setBOOL(rValue,sal_True);
			else
				::utl::setBOOL(rValue,m_xDatabase->IsReadOnly());
			break;
		case PROP_NAME:
			rValue <<= const_cast<SbaXdbDatabase*>(this)->getName();
			break;
		case PROP_CONNECTIONSETTINGS:
		{
			Sequence<PropertyValue> aValues;
			if (isOpen())
				aValues = toConnectionProperties(m_xDatabase->ConnectStr());
			rValue <<= aValues;

		}	break;
		case PROP_URL:
		{
			INetURLObject aObj;
			aObj.SetSmartProtocol(INET_PROT_FILE);
			aObj.SetSmartURL(const_cast<SbaXdbDatabase*>(this)->getName());
			rValue <<= ::rtl::OUString(aObj.GetMainURL());
		}	break;
		case PROP_THREADSAFE:
		{
			if (m_xDatabase && m_xDatabase->GetConnection())
				::utl::setBOOL(rValue,m_xDatabase->GetConnection()->IsCapable(SDB_CAP_MULTITHREADACCESS));
			else
				::utl::setBOOL(rValue,sal_False);
		}
		break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbDatabase::createObject(DBObject _eObj, const ::rtl::OUString& _rName) throw( stardata::DatabaseException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xDatabase.Is())
	{
		switch (_eObj)
		{
			case dbRelation:
				pObj = m_xDatabase->CreateObject(_eObj, _rName);
				break;
			default:
				pObj = (SdbObj*)m_xDatabase->CreateDBDef(_eObj, _rName, sal_False);
				break;
		}
		if (!pObj)
			checkDBResult(m_xDatabase->Status(), *this);
	}
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbDatabase::openObject(DBObject _eObj, const ::rtl::OUString& _rName)
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xDatabase.Is())
	{
		switch (_eObj)
		{
			case dbRelation:
				pObj = m_xDatabase->OpenObject(_eObj, _rName);
				break;
			default:
				pObj = (SdbObj*)m_xDatabase->OpenDBDef(_eObj, _rName, sal_False);
				break;
		}
	}
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbDatabase::openObject(DBObject _eObj, sal_Int32 _nPos)
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xDatabase.Is())
	{
		switch (_eObj)
		{
			case dbRelation:
				pObj = m_xDatabase->OpenObject(_eObj, (sal_uInt16)_nPos);
				break;
			default:
				pObj = (SdbObj*)m_xDatabase->OpenDBDef(_eObj, m_xDatabase->GetObjectName(_eObj, (sal_uInt16)_nPos), sal_False);
				break;
		}
	}
	return pObj;
}

//------------------------------------------------------------------------------
::rtl::OUString SbaXdbDatabase::getObjectName(DBObject _eObj, sal_Int32 _nPos) const
{
	::rtl::OUString aName;
	if (m_xDatabase.Is())
		aName = m_xDatabase->GetObjectName(_eObj, (sal_uInt16)_nPos);

	return aName;
}

//------------------------------------------------------------------------------
sal_Int32 SbaXdbDatabase::getObjectCount(DBObject _eObj) const
{
	sal_Int32 nRet = 0;
	if (m_xDatabase.Is())
		nRet = m_xDatabase->GetObjectCount(_eObj);
	return nRet;
}

//------------------------------------------------------------------------------
void SbaXdbDatabase::refresh(DBObject _eObj) throw( stardata::DatabaseException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDatabase->Refresh(_eObj);
}

// stardata::XDatabaseQueryComposerFactory
//------------------------------------------------------------------------------
Reference< stardata::XDatabaseQueryComposer > SAL_CALL SbaXdbDatabase::createDatabaseQueryComposer(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	::osl::MutexGuard aGuard( m_aMutex );

	return new SbaXdbParser(m_aParsers, m_xDatabase, m_xDatabase->GetConnection());
}

















