/*************************************************************************
 *
 *  $RCSfile: sbadbdoc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBDOC_HXX
#include "sbadbdoc.hxx"
#endif

#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif

#ifndef _SDB_SDBDOC_HXX
#include <sdb/sdbdoc.hxx>
#endif

#ifndef _SBXMSTRM_HXX
#include <svtools/sbxmstrm.hxx>
#endif

#ifndef _UTL_CONTAINER_HXX_
#include <unotools/container.hxx>
#endif

#ifndef _UTL_SEQSTREAM_HXX
#include <unotools/seqstream.hxx>
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

using staruno::Any;
using staruno::Sequence;
using staruno::Reference;
using staruno::UNO_QUERY;


using namespace ::cppu;
using namespace ::osl;
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbDocument::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbObject::getSomething(rId);
}
//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbDocument::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
SbaXdbDocument::SbaXdbDocument()
				:PropertySetHelper(ComponentHelper::rBHelper)
				,m_aRefreshListeners(m_aMutex)
{
}

//------------------------------------------------------------------------------
SbaXdbDocument::SbaXdbDocument(SbaXdbCollection& rCollection, SbaFileDef* pDocDef)
			   :SbaXdbObject(rCollection)
			   ,PropertySetHelper(ComponentHelper::rBHelper)
			   ,m_aRefreshListeners(m_aMutex)
			   ,m_xDocDef(pDocDef)
{
}

//------------------------------------------------------------------------------
SbaXdbDocument::~SbaXdbDocument()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbDocument::disposing()
{
	SbaXdbObject::disposing();
	starlang::EventObject aEvt(*this);
	m_aRefreshListeners.disposeAndClear(aEvt);
	m_xDocDef = NULL;
}

// starcontainer::XNamed
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbDocument::getName(void) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( ((SbaXdbDocument*)this)->m_aMutex );

	return isOpen() ? ::rtl::OUString(m_xDocDef->Name()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDocument::setName(const ::rtl::OUString& _rName) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDocDef->Rename(_rName);

	checkDBResult(m_xDocDef->Status(), *this, sal_True);
}

//------------------------------------------------------------------------------
void SbaXdbDocument::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	using starbeans::PropertyAttribute::READONLY;
	using starbeans::PropertyAttribute::TRANSIENT;
	SBA_BEGIN_PROPERTY_HELPER( aProperties, 2)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),	PROP_TYPE(OUString), READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(URL),	PROP_TYPE(OUString), READONLY | TRANSIENT);
	SBA_END_PROPERTY_HELPER();
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbDocument::convertFastPropertyValue( 
									Any & rConvertedValue, Any & rOldValue,
									sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException )
{
	DBG_ERROR("unknown Property");
	return sal_False;
}

//------------------------------------------------------------------------------
void SbaXdbDocument::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw(staruno::Exception)
{
	DBG_ERROR("unknown Property");
}

//------------------------------------------------------------------------------
void SbaXdbDocument::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_URL:
			rValue <<= ( isOpen() ? ::rtl::OUString(m_xDocDef->ToURL()) : ::rtl::OUString() );
			break;
		case PROP_NAME:
			rValue <<= ::rtl::OUString(const_cast<SbaXdbDocument*>(this)->getName());
			break;
		default:
			DBG_ERROR("unknown Porperty");
	}
}


// starchaos::XDataStreamSupplier
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbDocument::getDataType(void) throw( staruno::RuntimeException )
{
	return m_aDataType;
}

//------------------------------------------------------------------------------
Reference< stario::XInputStream > SAL_CALL SbaXdbDocument::getData(void) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );

	if (!m_xDocDef.Is())
		return m_xStream;

	checkOpen();

	Reference< stario::XActiveDataSink >  
		xSink(getXdbContext().getServiceManager()->
				createInstance(::rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")), UNO_QUERY);
	if (xSink.is())
	{
		Sequence<sal_Int8> aData;
		m_xDocDef->GetDocument()->Get(aData);
		checkDBResult(m_xDocDef->Status(), *this, sal_True);
		::utl::SequenceInputStream* pUnoStream = new ::utl::SequenceInputStream(aData);
		xSink->setInputStream(Reference< stario::XInputStream > (pUnoStream));
	}
	return Reference< stario::XInputStream > (xSink, UNO_QUERY);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDocument::setData(const ::rtl::OUString& aDataType, const Reference< stario::XInputStream > & xStream) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );

	checkArg((const Reference< staruno::XInterface > &)xStream);

	m_xStream = xStream;
	m_aDataType = aDataType;

	if (!m_xDocDef.Is())
		return;

	// beim Einfgen keine berprfung
	if (!m_xDocDef->IsNew())
		checkOpen();

	// In Chunks von 8192 BYTES lesen
	SbxMemoryStreamRef xMemoryStream = new SbxMemoryStream(8192, 8192);
	Sequence <sal_Int8> aBuffer(8192);

	sal_Int32 nBytes;
	sal_Bool bReadAllowed = sal_True;
	do
	{
		nBytes = xStream->readBytes(aBuffer, 8192);
		if (nBytes > 0)
			xMemoryStream->Write(aBuffer.getConstArray(), nBytes);
		if( (nBytes<8192) || (nBytes==-1) )
			bReadAllowed = sal_False;
	}
	while( bReadAllowed );

	m_xDocDef->Update((SvMemoryStream&)(*xMemoryStream));
	checkDBResult(m_xDocDef->Status(), *this, sal_True);

	m_xStream = NULL;
}

//------------------------------------------------------------------------------
void SbaXdbDocument::setObject(const SbaFileDefRef& xDef) throw( stardata::DatabaseException, staruno::RuntimeException )
{
	m_xDocDef = xDef;
	try
	{
		setData(m_aDataType, m_xStream);
	}
	catch(...)
	{
		m_xDocDef = NULL;
		throw;
	}
}

// starutil::XRefreshable
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDocument::addRefreshListener(const Reference< starutil::XRefreshListener > & l) throw( staruno::RuntimeException )
{   m_aRefreshListeners.addInterface(l); }
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDocument::removeRefreshListener(const Reference< starutil::XRefreshListener > & l) throw( staruno::RuntimeException )
{   m_aRefreshListeners.removeInterface(l); }

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbDocument::refresh(void) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xDocDef->Refresh();

	starlang::EventObject aEvt(*this);
	NOTIFY_LISTENERS(m_aRefreshListeners, starutil::XRefreshListener, refreshed, aEvt);
}

//------------------------------------------------------------------------------
SbaXdbDocuments::SbaXdbDocuments(SbaXdbObjectCreator& rParent, DBObject _eObj)
:SbaXdbNamedCollection(rParent,_eObj, 
					   ::getCppuType(static_cast<const Reference< starchaos::XDataStreamSupplier >*>(0) ))
{
}

// stardata::XDatabaseDocumentFactory
//------------------------------------------------------------------------------
Reference< starchaos::XDataStreamSupplier > SAL_CALL SbaXdbDocuments::create(void)
			throw( starlang::NoSupportException, staruno::RuntimeException )
{
	return new SbaXdbDocument();
}

// helper methods
//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbDocuments::doGet(SdbObj* pObj) const
{
	SbaXdbDocument* pXObj = NULL;

	// Dokument schon geoeffnet
	sal_uInt32 nCount = size();
	sal_uInt32 i;
	for (i = 0; i < nCount; i++)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getObject(i),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbDocument*)xTunnel->getSomething(SbaXdbDocument:: getUnoTunnelImplementationId());
		}
		//	utl::getImplementation(pXObj, getObject(i));

		if (pXObj && pObj == &pXObj->m_xDocDef)
			break;
	}

	if (i == nCount)
		pXObj = new SbaXdbDocument(*(SbaXdbDocuments*)this, (SbaFileDef*)pObj);

	return pXObj;
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbDocuments::doRemove(SbaXdbObject* pObj)
{
	SbaXdbDocument* pXObj = (SbaXdbDocument*)pObj;

	if (!pXObj->m_xDocDef->Drop())
		checkDBResult(pXObj->m_xDocDef->Status(), *this, sal_True);
	return sal_True;
}

//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbDocuments::doInsert(const ::rtl::OUString& Name, const Any& Element)
{
	// Ist es ein bekanntes document
	SbaXdbDocument* pXObj = 0;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel;
	Element >>= xTunnel;
	//	((::cppu::OWeakObject*)getObject(i),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbDocument*)xTunnel->getSomething(SbaXdbDocument:: getUnoTunnelImplementationId());
		}
	//	utl::getImplementation(pXObj,Element);

	DBG_ASSERT(pXObj, "SbaXdbDocuments::doInsert for invalid element");

	// bereits in einem Container enthalten?
	if (!pXObj || pXObj->getXdbParent())
	{
		throw starlang::IllegalArgumentException() ;
	}

	SdbObj* pObj = NULL;

	try
	{
		pObj = getXdbCreator()->createObject(m_eObj, Name);
	}
	catch (stardata::DatabaseException& e)
	{
		throw starlang::WrappedTargetException(::rtl::OUString(), *this, staruno::makeAny(e) );
	}

	SbaFileDefRef xDoc = (SbaFileDef*)pObj;
	pXObj->setObject(xDoc);

	return pXObj;
}

















