/*************************************************************************
 *
 *  $RCSfile: sbadbeng.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "sbadbeng.hxx"

#ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
#include <com/sun/star/util/XLocalizedAliases.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif


#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _EXPLORER_HXX //autogen
#include <sfx2/explorer.hxx>
#endif

#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif

#ifndef _SBA_SBADBPAR_HXX
#include "sbadbpar.hxx"
#endif

using staruno::Reference;
using staruno::Sequence;
using staruno::Any;
using staruno::UNO_QUERY;

//------------------------------------------------------------------
Reference< staruno::XInterface > SAL_CALL 
	SbaXdbEngine_CreateInstance(const Reference< starlang::XMultiServiceFactory >  & xServiceManager) 
		throw( staruno::Exception )
{
	SbaXdbEngine* pEngine = new SbaXdbEngine();
	Reference< staruno::XInterface >  xService(*pEngine);

	pEngine->getXdbContext().setServiceManager(xServiceManager);

	return xService;
}

//------------------------------------------------------------------------------
SbaXdbEngine::SbaXdbEngine()
			 :SbaXdbObjectCreator(sal_True)
			 ,m_aWorkspaces(*this)
			 ,m_aConnections(*this)
{
	// einfuegen des default workspace
	m_pDefaultWsp = new SbaXdbWorkspace(m_aWorkspaces, m_xEnvironment->OpenWorkspace(0), sal_True);
	m_pDefaultWsp->acquire();
}

//------------------------------------------------------------------------------
SbaXdbEngine::~SbaXdbEngine()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}

	if (m_pDefaultWsp)
		m_pDefaultWsp->release();
}


// staruno::XInterface
//------------------------------------------------------------------------------
using namespace ::cppu;
using namespace ::osl;

Any SAL_CALL SbaXdbEngine::queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException )
{
	Any aRet( TypeProviderHelper::queryInterface(rType) );
	if (!aRet.hasValue())
		aRet = ::utl::queryDeepInterface( rType,
											static_cast<stardata::XDatabaseEngine*>(this),
											static_cast<stardata::XDatabaseFavorites*>(this),
											static_cast<starlang::XServiceInfo*>(this),
											static_cast<starlang::XUnoTunnel*>(this)
										);

	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType));

}


// TypeProviderHelper
//------------------------------------------------------------------------------
Sequence< staruno::Type > SbaXdbEngine::collectTypes(SbaXdbEngine*) throw(staruno::RuntimeException)
{ 
	return ::cppu::OTypeCollection( 
				::getCppuType(static_cast<Reference<stardata::XDatabaseEngine > const*>(0)),
				::getCppuType(static_cast<Reference<stardata::XDatabaseFavorites > const*>(0)),
				::getCppuType(static_cast<Reference<starlang::XServiceInfo > const*>(0)),
				::getCppuType(static_cast<Reference<starlang::XTypeProvider > const*>(0)),
				::getCppuType(static_cast<Reference<starlang::XUnoTunnel > const*>(0)),
				::getCppuType(static_cast<Reference<staruno::XWeak > const*>(0))
			).getTypes(); 
}

// XUnoTunnel
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbEngine::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbObjectCreator::getSomething(rId);
}
//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbEngine::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbEngine::disposing()
{
	SbaXdbObjectCreator::disposing();

	// jetzt gibt es kein default workspace mehr
	m_pDefaultWsp->resetDefault();
	m_aWorkspaces.disposing();
	m_aConnections.disposing();

	// alle Verbindungen werden jetzt gecapt
	m_pDefaultWsp->release();
	m_pDefaultWsp = NULL;
	m_xEnvironment = NULL;
}

// starlang::XServiceInfo
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbEngine::getImplementationName() 
	throw( staruno::RuntimeException )
{
	return getImplementationName_Static();

}

//------------------------------------------------------------------------------
::rtl::OUString SbaXdbEngine::getImplementationName_Static() 
	throw( staruno::RuntimeException )
{
	SBA_DEFINE_CONSTASCII(cName,"com.sun.star.data.SbaXdbEngine");
	return cName;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbEngine::supportsService(const ::rtl::OUString& ServiceName) 
	throw( staruno::RuntimeException )
{
	Sequence< ::rtl::OUString > aSNL = getSupportedServiceNames();

	for( sal_Int32 i = 0; i < aSNL.getLength(); i++ )
		if( aSNL[i] == ServiceName )
			return sal_True;
	return sal_False;
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > SAL_CALL SbaXdbEngine::getSupportedServiceNames(void) 
	throw( staruno::RuntimeException )
{
	return getSupportedServiceNames_Static();
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > SbaXdbEngine::getSupportedServiceNames_Static(void) 
	throw( staruno::RuntimeException )
{
	Sequence< ::rtl::OUString > aSNS( 1 );
	aSNS[0] = ::rtl::OUString::createFromAscii("com.sun.star.data.DatabaseEngine");
	return aSNS;
}

// stardata::XDatabaseEngine
//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer >  SAL_CALL SbaXdbEngine::getWorkspaces(void) 
	throw( staruno::RuntimeException )
{
	return &((SbaXdbEngine*)this)->m_aWorkspaces;
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString > SAL_CALL SbaXdbEngine::queryServerTypes(void) 
	throw( staruno::RuntimeException )
{
	if (ComponentHelper::rBHelper.bDisposed)
		throw starlang::DisposedException();

	String sServerTypes = m_xEnvironment->ServerTypes();
	Sequence< ::rtl::OUString > aServerTypeSequence(sServerTypes.GetTokenCount(';'));

	xub_StrLen nIndex = 0;
	sal_uInt32 i = 0;
	::rtl::OUString * pStringArray = aServerTypeSequence.getArray();
	for (String aToken = sServerTypes.GetToken(0,';',nIndex);
		 aToken.Len();
		 aToken = sServerTypes.GetToken(0,';',nIndex))
	{
		pStringArray[i++] = aToken;
	}

	return aServerTypeSequence;
}

//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbEngine::getLoginTimeOut(void)
	throw( staruno::RuntimeException )
{
	if (m_xEnvironment.Is())
		return m_xEnvironment->GetLoginTimeOut();
	else
		return 20;
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbEngine::setLoginTimeOut(sal_Int32 TimeOut)
	throw( staruno::RuntimeException )
{
	if (m_xEnvironment.Is())
		m_xEnvironment->SetLoginTimeOut(TimeOut);
}

//------------------------------------------------------------------------------
Reference< stardata::XDatabaseConnection > 
	SAL_CALL SbaXdbEngine::createConnection(const Sequence< starbeans::PropertyValue >& ConnectionInfo) 
		throw( stardata::DatabaseException, staruno::RuntimeException )
{
	if (ComponentHelper::rBHelper.bDisposed)
		throw starlang::DisposedException();

	Reference< stardata::XDatabaseConnection >  xConnection;
	String aConnectStr(SbaXdbDatabase::toConnectionStr(ConnectionInfo));

	SdbConnection* pConn = m_xEnvironment->OpenConnection(aConnectStr);
	if (!pConn)
		checkDBResult(m_xEnvironment->Status(), *this, sal_False);

	return Reference< stardata::XDatabaseConnection > (new SbaXdbConnection(m_aConnections, pConn));
}

// stardata::XDatabaseFavorites
//------------------------------------------------------------------------------
Sequence< starbeans::PropertyValue > SAL_CALL SbaXdbEngine::getFavorites(void) 
	throw( staruno::RuntimeException )
{
	Sequence<starbeans::PropertyValue> aReturn;

	Reference< starutil::XLocalizedAliases >  
		xContext(getXdbContext().getServiceManager()->
					createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseAccessContext")), UNO_QUERY);

	if (xContext.is())
	{
		starlang::Locale aAppLocale;
		String sLanguage, sCountry;
		ConvertLanguageToIsoNames(Application::GetAppInternational().GetLanguage(), sLanguage, sCountry);
		aAppLocale.Language = sLanguage;
		aAppLocale.Country = sCountry;

		Sequence< starutil::AliasProgrammaticPair> aRegistered = xContext->listAliases(aAppLocale);
		aReturn.realloc(aRegistered.getLength());

		const starutil::AliasProgrammaticPair* pRegistered = aRegistered.getConstArray();
		starbeans::PropertyValue* pValues = aReturn.getArray();
		starbeans::PropertyValue* const pValuesEnd = pValues + aReturn.getLength();

		for ( ; pValues < pValuesEnd; ++pValues, ++pRegistered)
		{
			pValues->Name = pRegistered->Alias;
			pValues->Value <<= pRegistered->ProgrammaticName;
		}
	}
	return aReturn;
}


void SbaXdbEngine::dropDatabaseAlias(::rtl::OUString const& sProgrammaticURL) const
{
	Reference< starutil::XLocalizedAliases >  
		xContext(getXdbContext().getServiceManager()->
					createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseAccessContext")), UNO_QUERY);

	if (xContext.is())
	{
		try
		{
			xContext->unbindAliases(sProgrammaticURL);
		}
		catch(starcontainer::NoSuchElementException&)
		{
		}
		catch(...)
		{
			DBG_ERROR("SbaXdbEngine::DropDatabaseAlias : could not revoke an alias !");
		}
	}
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbEngine::getLocation(const ::rtl::OUString& aTitle) 
	throw( staruno::RuntimeException )
{
	Sequence< starbeans::PropertyValue > aProperties(getFavorites());
	const starbeans::PropertyValue* pArray = aProperties.getConstArray();

	::rtl::OUString sLocation;
	sal_Int32 nCount = aProperties.getLength();

	for (sal_Int32 j = 0; j < nCount; j++)
	{
		if (pArray[j].Name == aTitle)
		{
			pArray[j].Value >>= sLocation;

			// FS - 06.01.00 - 68367
			// check for the existence of the file refered to by sLocation
			INetURLObject aExistenceCheck;
			aExistenceCheck.SetSmartURL(sLocation);
			String aDatabaseURL(aExistenceCheck.PathToFileName());
			if (!DirEntry(aDatabaseURL).Exists())
				// drop the link which is responsible for this favorite entry
				dropDatabaseAlias(sLocation);

			// (Return the location anyway to be consistent with the result the user got from getFavorites)
			break;
		}
	}
	return sLocation;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbEngine::createObject(DBObject, const ::rtl::OUString& _rName) throw( stardata::DatabaseException  )
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xEnvironment.Is())
	{
		pObj = m_xEnvironment->CreateWorkspace(_rName);
		if (!pObj)
			checkDBResult(m_xEnvironment->Status(), *this);
	}
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbEngine::openObject(DBObject _eObj, const ::rtl::OUString& _rName)
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xEnvironment.Is())
		pObj = m_xEnvironment->OpenWorkspace(_rName);
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbEngine::openObject(DBObject, sal_Int32 _nPos)
{
	::osl::MutexGuard aGuard( m_aMutex );
	SdbObj* pObj = NULL;
	if (m_xEnvironment.Is())
		pObj = m_xEnvironment->OpenWorkspace((sal_uInt16)_nPos);
	return pObj;
}

//------------------------------------------------------------------------------
::rtl::OUString SbaXdbEngine::getObjectName(DBObject , sal_Int32 _nPos) const
{
	String sName;
	if (m_xEnvironment.Is())
		sName = m_xEnvironment->GetWorkspaceName((sal_uInt16)_nPos);
	return sName;
}

//------------------------------------------------------------------------------
sal_Int32 SbaXdbEngine::getObjectCount(DBObject) const
{
	sal_Int32 nCount = 0;
	if (m_xEnvironment.Is())
		nCount = m_xEnvironment->GetWorkspaceCount();
	return nCount;
}

//------------------------------------------------------------------------------
void SbaXdbEngine::refresh(DBObject _eObj) throw( stardata::DatabaseException  )
{
}

















