/*************************************************************************
 *
 *  $RCSfile: sbadbfld.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

#ifndef _COM_SUN_STAR_UNO_TYPECLASS_HPP_
#include <com/sun/star/uno/TypeClass.hpp>
#endif

#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOBJECTOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XObjectOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEPARAMETERTYPE_HPP_
#include <com/sun/star/data/DatabaseParameterType.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESEARCH_HPP_
#include <com/sun/star/data/DatabaseSearch.hpp>
#endif

#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif

#ifndef _UTL_ENUMHELPER_HXX_
#include <unotools/enumhelper.hxx>
#endif

#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif

#ifndef _UTL_SEQSTREAM_HXX
#include <unotools/seqstream.hxx>
#endif
#ifndef _UTL_DATETIME_HXX_
#include <unotools/datetime.hxx>
#endif

#ifndef _CPPUHELPER_PROPTYPEHLP_HXX
#include <cppuhelper/proptypehlp.hxx>
#endif

#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/ImplBase2.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifdef _SVSTDARR_STRINGSISORTDTOR
#define _SVSTDARR_STRINGSISORTDTOR
#include <svtools/svstdarr.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SDB_SDBCOL_HXX //autogen
#include <sdb/sdbcol.hxx>
#endif

#ifndef _SDB_SDBCONN_HXX
#include <sdb/sdbconn.hxx>
#endif

#ifndef _SDB_SDBREL_HXX //autogen
#include <sdb/sdbrel.hxx>
#endif

#ifndef _SBA_DBDATDEF_HXX
#include <dbdatdef.hxx>
#endif

#ifndef _SBA_DBOBJENU_HXX //autogen
#include <dbobjenu.hxx>
#endif

#ifndef _SDB_TYPECONV_HXX
#include <sdb/typeconv.hxx>
#endif

#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

// enum namespaces
namespace PropertyAttribute = starbeans::PropertyAttribute;
namespace DatabaseFieldType = stardata::DatabaseFieldType;
namespace DatabaseSearch	= stardata::DatabaseSearch;
namespace staruno = staruno; // for TypeClass

using staruno::Reference;
using staruno::UNO_QUERY;
using staruno::Any;
using staruno::Sequence;

using ::osl::MutexGuard;
using ::osl::ClearableMutexGuard;

#ifdef DBG_UTIL
#define DEBUG_CHECK( x, msg ) if (!(x)) DBG_ASSERT(false,(msg)) else
#else
#define DEBUG_CHECK( x, msg ) (x)
#endif

staruno::Any const*const forUnoAny=0;	// to get the cpputype

//------------------------------------------------------------------------------
sal_uInt16 SbaType2XdbType(SbaFieldType eType, SbaNumericSize eNum)
{
	sal_uInt16 nType = DatabaseFieldType::OTHER;
	switch (eType)
	{
		case dbText:
			nType = DatabaseFieldType::VARCHAR;
			break;
		case dbChar:
			nType = DatabaseFieldType::CHAR;
			break;
		case dbMemo:
			nType = DatabaseFieldType::LONGVARCHAR;
			break;
		case dbBool:
			nType = DatabaseFieldType::BOOL;
			break;
		case dbCurrency:
			nType = DatabaseFieldType::CURRENCY;
			break;
		case dbDateTime:
			nType = DatabaseFieldType::DATETIME;
			break;
		case dbDate:
			nType = DatabaseFieldType::DATE;
			break;
		case dbTime:
			nType = DatabaseFieldType::TIME;
			break;
		case dbDecimal:
			nType = DatabaseFieldType::NUMERIC;
			break;
		case dbVarBinary:
			nType = DatabaseFieldType::VARBINARY;
			break;
		case dbBinary:
			nType = DatabaseFieldType::BINARY;
			break;
		case dbImage:
			nType = DatabaseFieldType::LONGVARBINARY;
			break;
		case dbCounter:
			nType = DatabaseFieldType::INTEGER;
			break;
		case dbNumeric:
			switch (eNum)
			{
				case dbByte:
					nType = DatabaseFieldType::TINYINT;
					break;
				case dbInteger:
					nType = DatabaseFieldType::SMALLINT;
					break;
				case dbLong:
					nType = DatabaseFieldType::INTEGER;
					break;
				case dbSingle:
					nType = DatabaseFieldType::REAL;
					break;
				case dbDouble:
					nType = DatabaseFieldType::DOUBLE;
					break;
				default:
					DBG_ERROR("Unbekanntes ::com::sun::star::awt::Size!");
			}
	}
	return nType;
}

//------------------------------------------------------------------------------
SbaFieldType XdbType2SbaType(sal_Int16 Type, SbaNumericSize& eSize)
{
	SbaFieldType eType = dbNone;
	eSize = dbSizeNone;
	switch (Type)
	{
		case DatabaseFieldType::CHAR:
			eType = dbChar;
			break;
		case DatabaseFieldType::VARCHAR:
			eType = dbText;
			break;
		case DatabaseFieldType::LONGVARCHAR:
			eType = dbMemo;
			break;
		case DatabaseFieldType::NUMERIC:
		case DatabaseFieldType::DECIMAL:
			eType = dbDecimal;
			break;
		case DatabaseFieldType::TINYINT:
			eType = dbNumeric;
			eSize = dbByte;
			break;
		case DatabaseFieldType::SMALLINT:
			eType = dbNumeric;
			eSize = dbInteger;
			break;
		case DatabaseFieldType::BIGINT:
			eType = dbNumeric;
			eSize = dbDouble;         //XXX richtiger Type fehlt
			break;
		case DatabaseFieldType::INTEGER:
			eType = dbNumeric;
			eSize = dbLong;
			break;
		case DatabaseFieldType::REAL:
			eType = dbNumeric;
			eSize = dbSingle;
			break;
		case DatabaseFieldType::DOUBLE:
			eType = dbNumeric;
			eSize = dbDouble;
			break;
		case DatabaseFieldType::BINARY:
			eType = dbBinary;
			break;
		case DatabaseFieldType::VARBINARY:
			eType = dbVarBinary;
			break;
		case DatabaseFieldType::LONGVARBINARY:
			eType = dbImage;
			break;
		case DatabaseFieldType::DATE:
			eType = dbDate;
			break;
		case DatabaseFieldType::TIME:
			eType = dbTime;
			break;
		case DatabaseFieldType::DATETIME:
			eType = dbDateTime;
			break;
		case DatabaseFieldType::CURRENCY:
			eType = dbCurrency;
			break;
		case DatabaseFieldType::BOOL:
			eType = dbBool;
			break;
		default:
			eType = dbNone;
			break;
	}
	return eType;
}


//------------------------------------------------------------------------------
void SbaXdbField::construct()
{
	m_nSize = 0;
	m_nFormatKey = 0;
	m_nScale = 0;
	m_nParameterType = stardata::DatabaseParameterType::IN;
	m_nSearchInfo = DatabaseSearch::NONE;
	m_nType = DatabaseFieldType::OTHER;
	m_bPrimaryKey = m_bAutoIncrement =
	m_bDescending = m_bReadOnly = m_bRequired = m_bUnsigned = sal_False;
	m_bFireValueChanges = sal_True;
	m_bFunction = sal_False;
	m_bVersioning = sal_False;
}

//------------------------------------------------------------------------------
void SbaXdbField::construct(const Reference< starbeans::XPropertySet > & xSet)
{
	construct();
	if (xSet.is())
	{
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_NAME)			>>= m_aName,		"'Name' Property for SbaXdbField missing or invalid");
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_SEARCHINFO)	>>= m_nSearchInfo,	"'SearchInfo' Property for SbaXdbField missing or invalid");
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_TYPE)			>>= m_nType,		"'Type' Property for SbaXdbField missing or invalid");
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_SCALE)		>>= m_nScale,		"'Scale' Property for SbaXdbField missing or invalid");
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_SIZE)			>>= m_nSize,		"'Size' Property for SbaXdbField missing or invalid");
		DEBUG_CHECK( xSet->getPropertyValue(PROP_NAME_FORMATKEY)	>>= m_nFormatKey,	"'FormatKey' Property for SbaXdbField missing or invalid");

		m_xValue = new ODbVariant();

		m_xValue->setAny(xSet->getPropertyValue(PROP_NAME_VALUE));
	}
}

//------------------------------------------------------------------------------
void SbaXdbField::construct(const SdbColumn& rCol)
{
	m_aName = rCol.GetName();
	m_aDescription = rCol.GetComment();
	m_aFieldSource = rCol.GetRealName();
	m_aTableSource = rCol.GetTableName();

	if (rCol.GetDefaultValue().Len())
	{
		m_xDefValue = new ODbVariant();
		m_xDefValue->setString(rCol.GetDefaultValue());
	}

	m_nSize = rCol.GetLength();
	m_nFormatKey = rCol.GetFormatKey();
	m_nScale = rCol.GetScale();
	m_nType = rCol.GetType();
	m_bPrimaryKey = rCol.IsPrimaryKey();
	m_bAutoIncrement = rCol.IsAutoIncrement();
	m_bDescending = rCol.IsDescending();
	m_bRequired = !rCol.IsNullAllowed();
	m_bReadOnly = !rCol.IsUpdateAllowed();
	m_bFunction = rCol.IsFunction();
	m_bVersioning = (rCol.GetAllFlags() & SDB_FLAGS_VERSIONING) == SDB_FLAGS_VERSIONING;

	if ((rCol.GetAllFlags() & SDB_FLAGS_SEARCH_ALL) == SDB_FLAGS_SEARCH_ALL)
		m_nSearchInfo = DatabaseSearch::ALL;
	else if ((rCol.GetAllFlags() & SDB_FLAGS_SEARCH_LIKE) == SDB_FLAGS_SEARCH_LIKE)
		m_nSearchInfo = DatabaseSearch::CHAR;
	else if ((rCol.GetAllFlags() & SDB_FLAGS_SEARCH_EXCEPT_LIKE) == SDB_FLAGS_SEARCH_EXCEPT_LIKE)
		m_nSearchInfo = DatabaseSearch::BASIC;
	else
		m_nSearchInfo = DatabaseSearch::NONE;

	m_bUnsigned = sal_False;
	m_bFireValueChanges = sal_True;
}

//------------------------------------------------------------------------------
void SbaXdbField::construct(const SbaXdbField& rField)
{
	construct();

	m_aFieldSource		= rField.m_aFieldSource;
	m_aTableSource		= rField.m_aTableSource;
	m_bFunction			= rField.m_bFunction;
	m_bVersioning		= rField.m_bVersioning;
	m_nSize				= rField.m_nSize;
	m_nFormatKey		= rField.m_nFormatKey;
	m_nScale			= rField.m_nScale;
	m_nParameterType	= rField.m_nParameterType;
	m_nType				= rField.m_nType;
	m_bPrimaryKey		= rField.m_bPrimaryKey;
	m_bAutoIncrement	= rField.m_bAutoIncrement;
	m_bDescending		= rField.m_bDescending;
	m_bRequired			= rField.m_bRequired;
	m_aDescription		= rField.m_aDescription;
	m_aRefName			= rField.m_aRefName;
}

//------------------------------------------------------------------------------
void SbaXdbField::construct(const SbaColumn& rCol)
{
	construct();

	SFX_ITEMSET_GET(rCol,pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True);
	m_aName = pName->GetValue();

	SFX_ITEMSET_GET(rCol, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
	SFX_ITEMSET_GET(rCol, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, sal_True);
	m_nType = SbaType2XdbType((SbaFieldType)pType->GetValue(), (SbaNumericSize)pLength->GetValue());
	m_nSize = (sal_Int32)pLength->GetValue();

	SFX_ITEMSET_GET(rCol, pFormatKey, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True);
	m_nFormatKey = pFormatKey->GetValue();

	SFX_ITEMSET_GET(rCol, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, sal_True);
	m_nScale = pScale->GetValue();

	SFX_ITEMSET_GET(rCol, pUpd, SfxBoolItem, SBA_DEF_FLTUPDATABLE, sal_True);
	m_bReadOnly = !pUpd->GetValue();

	SFX_ITEMSET_GET(rCol, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, sal_True);
	m_bRequired = pRequired->GetValue();

	SFX_ITEMSET_GET(rCol, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
	m_bPrimaryKey = pPrimary->GetValue();

	SFX_ITEMSET_GET(rCol, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, sal_True);
	m_aDescription = pComment->GetValue();

	SFX_ITEMSET_GET(rCol, pAuto, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, sal_True);
	m_bAutoIncrement = pAuto->GetValue();

	SFX_ITEMSET_GET(rCol, pSearch, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
	m_bVersioning = pSearch && (pSearch->GetValue() & SDB_FLAGS_VERSIONING);

	switch (pSearch->GetValue() & SDB_FLAGS_SEARCH_ALL)
	{
		case SDB_FLAGS_SEARCH_ALL:
			m_nSearchInfo = DatabaseSearch::ALL;
			break;
		case SDB_FLAGS_SEARCH_LIKE:
			m_nSearchInfo = DatabaseSearch::CHAR;
			break;
		case SDB_FLAGS_SEARCH_EXCEPT_LIKE:
			m_nSearchInfo = DatabaseSearch::BASIC;
			break;
		default:
			m_nSearchInfo = DatabaseSearch::NONE;
	}

	SFX_ITEMSET_GET(rCol, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, sal_True);
	if (pDefault->GetValue().Len())
	{
		m_xDefValue = new ODbVariant();
		m_xDefValue->setString(pDefault->GetValue());
	}
}

//------------------------------------------------------------------------------
void SbaXdbField::construct(const SdbColumnRelation& rCol)
{
	construct((const SdbColumn&)rCol);
	m_aRefName = rCol.GetForeignName();
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(SbaXdbComponent* pParent)
			:SbaXdbComponent(pParent)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct();
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(SbaXdbComponent* pParent, const SbaXdbField& rField)
			:SbaXdbComponent(pParent)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct(rField);
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(SbaXdbComponent* pParent, const SdbColumn& rCol)
			:SbaXdbComponent(pParent)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct(rCol);
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(SbaXdbComponent* pParent, const SdbColumnRelation& rCol)
			:SbaXdbComponent(pParent)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct(rCol);
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(SbaXdbComponent* pParent, const SbaColumn& rCol)
			:SbaXdbComponent(pParent)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct(rCol);
}

//------------------------------------------------------------------------------
SbaXdbField::SbaXdbField(const Reference< ::com::sun::star::beans::XPropertySet > & xSet)
			:SbaXdbComponent(NULL)
			,PropertySetHelper(ComponentHelper::rBHelper)
{
	construct(xSet);
}

//------------------------------------------------------------------------------
SbaXdbField::~SbaXdbField()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

//------------------------------------------------------------------------------
void SbaXdbField::adjustType(const SbaXdbField& rField)
{
	m_nFormatKey = rField.m_nFormatKey;
	m_nType = rField.m_nType;

	if (rField.m_xDefValue.is())
		m_xDefValue = new ODbVariant(*rField.m_xDefValue);
}

//------------------------------------------------------------------------------
void SbaXdbField::disposing()
{
	::osl::MutexGuard aGuard(m_aMutex);
	OPropertySetHelper::disposing();
}

// staruno::XInterface
//------------------------------------------------------------------------------
staruno::Any SbaXdbField::queryFieldBase(staruno::Type const& rType) throw( staruno::RuntimeException )
{
	typedef sbautl::PropertySetHelperBase<SbaXdbField> PropSetBase;
	Any aRet( PropSetBase::queryInterface(rType) );

	if (!aRet.hasValue() && rType == ::getCppuType(static_cast<Reference<starlang::XUnoTunnel> const*>(0)))
		aRet.setValue(static_cast<starlang::XUnoTunnel*>(this),rType);

	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType));
}
//------------------------------------------------------------------------------
staruno::Any SAL_CALL SbaXdbField::queryInterface(staruno::Type const& rType)
	throw( staruno::RuntimeException )
{
	Any aRet( queryFieldBase(rType) );

	return aRet.hasValue() ?
				aRet :
				utl::queryDeepInterface( rType,
											static_cast<starcontainer::XNamed*>(this),
											static_cast<stardata::XDatabaseFieldDescriptorFactory*>(this),
											static_cast<stardata::XDatabaseVariant*>(this)
										);
}

// TypeProviderHelper
//------------------------------------------------------------------------------
staruno::Sequence< staruno::Type > SbaXdbField::getFieldBaseTypes() throw( staruno::RuntimeException )
{
	::cppu::OTypeCollection myTypes(
								::getCppuType(static_cast<Reference<starlang::XTypeProvider > const*>(0)),
								::getCppuType(static_cast<Reference<staruno::XWeak > const*>(0))
							);

	return addPropertyTypes(myTypes.getTypes());
}

Sequence< staruno::Type > SbaXdbField::collectTypes(SbaXdbField*) throw(staruno::RuntimeException)
{
	return ::cppu::OTypeCollection(
								::getCppuType(static_cast<Reference<starcontainer::XNamed > const*>(0)),
								::getCppuType(static_cast<Reference<stardata::XDatabaseFieldDescriptorFactory > const*>(0)),
								::getCppuType(static_cast<Reference<stardata::XDatabaseVariant > const*>(0)),
								getFieldBaseTypes()
							).getTypes();
}

//------------------------------------------------------------------------------
void SbaXdbField::fireValueChanged()
{
	if (m_bFireValueChanges && hasValueListeners()
		&& m_xValue.is() && *m_xOldValue != *m_xValue)
	{
		// file a change event, if the value changed
		sal_Int32 nHandle(PROP_VALUE);
		Any aVal	(m_xValue->getAny());
		Any aOldVal	(m_xOldValue->getAny());

		fire(&nHandle, &aVal, &aOldVal, 1, sal_False );

		// Referenzwert speichern
		(*m_xOldValue) = *m_xValue;
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::addPropertyChangeListener(
						const ::rtl::OUString& rPropertyName,
						const Reference< starbeans::XPropertyChangeListener > & rxListener)
			throw(	starbeans::UnknownPropertyException,
					starlang::WrappedTargetException,
					staruno::RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OPropertySetHelper::addPropertyChangeListener(rPropertyName, rxListener);
	if (!ComponentHelper::rBHelper.bInDispose && !ComponentHelper::rBHelper.bDisposed && !hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::removePropertyChangeListener(
						const ::rtl::OUString& rPropertyName,
						const Reference< starbeans::XPropertyChangeListener > & rxListener)
			throw(	starbeans::UnknownPropertyException,
					starlang::WrappedTargetException,
					staruno::RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OPropertySetHelper::removePropertyChangeListener(rPropertyName, rxListener);
	if (!ComponentHelper::rBHelper.bInDispose && !ComponentHelper::rBHelper.bDisposed && hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::addPropertiesChangeListener(
						const staruno::Sequence< ::rtl::OUString>& rProps,
						const Reference< starbeans::XPropertiesChangeListener > & rListener )
			throw(staruno::RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OPropertySetHelper::addPropertiesChangeListener(rProps, rListener);
	if (!ComponentHelper::rBHelper.bInDispose && !ComponentHelper::rBHelper.bDisposed && !hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::removePropertiesChangeListener(
						const Reference< starbeans::XPropertiesChangeListener > & rListener )
			throw(staruno::RuntimeException)
{
	MutexGuard aGuard( m_aMutex );
	OPropertySetHelper::removePropertiesChangeListener(rListener);
	if (!ComponentHelper::rBHelper.bInDispose && !ComponentHelper::rBHelper.bDisposed && hasValueListeners())
		checkForNotify();
}

//------------------------------------------------------------------------------
void SbaXdbField::checkForNotify()
{
	using ::cppu::OPropertySetHelper;

	sal_Bool bOld = hasValueListeners();
	sal_Bool bNew;
	// do we need to broadcast value changes
	::cppu::OInterfaceContainerHelper* pLC = aBoundLC.getContainer(PROP_VALUE);
	bNew = pLC && pLC->getLength();

	// broadcast to all listeners with "" property name?
	if (!bNew)
	{
		// haesslicher cast, danke bei egcs
		// static_cast<BroadcastHelper&>
		pLC = (this->OPropertySetHelper::rBHelper).aLC.getContainer(::getCppuType(
					static_cast<Reference<starbeans::XPropertyChangeListener> const *>(0) ) );
		bNew = pLC && pLC->getLength();
	}

	if (!bNew)
	{
		pLC = (this->OPropertySetHelper::rBHelper).aLC.getContainer( ::getCppuType(
					static_cast<Reference<starbeans::XPropertiesChangeListener> const *>(0) ) );
		bNew = pLC && pLC->getLength();
	}

	if (bOld != bNew)   // Anlegen einer Copie zum Vergleichen
	{
		if (!bNew)
			m_xOldValue.unbind();
		else if (bNew && m_xValue.is())
			m_xOldValue = new ODbVariant(*m_xValue);
	}
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbField::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue,
											   sal_Int32 nHandle, const Any& rValue )
											throw( starlang::IllegalArgumentException )
{
	using utl::tryPropertyValue;

	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_DESCRIPTION:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_aDescription);
			break;
		case PROP_FORMATKEY:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue,m_nFormatKey);
			break;
		case PROP_ISAUTOINCREMENT:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue,m_bAutoIncrement);
			break;
		case PROP_ISDESCENDING:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue,m_bDescending);
			break;
		case PROP_ISMODIFIED:
		{
			sal_Bool b;
			::cppu::convertPropertyValue(b, rValue );
			if (m_xValue.is() && b != m_xValue->isModified() )
			{
				rConvertedValue	.setValue( &b,::getBooleanCppuType());
				b = !b;
				rOldValue		.setValue( &b,::getBooleanCppuType());
				bModified = sal_True;
			}
		}   break;
		case PROP_ISPRIMARYKEY:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue,m_bPrimaryKey);
			break;
		case PROP_ISVERSIONING:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue,m_bVersioning);
			break;
		case PROP_ISREQUIRED:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_bRequired);
			break;
		case PROP_PARAMETERTYPE:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_nParameterType);
			break;
		case PROP_REFNAME:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_aRefName);
			break;
		case PROP_SCALE:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_nScale);
			break;
		case PROP_SIZE:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_nSize);
			break;
		case PROP_TYPE:
			bModified = tryPropertyValue(rConvertedValue, rOldValue, rValue, m_nType);
			break;
		case PROP_DEFAULTVALUE:
			if (!m_xDefValue.is())
				m_xDefValue = new ODbVariant();

			rOldValue = m_xDefValue->getAny();
			bModified = convertValue(rConvertedValue, m_xDefValue->getAny(), rValue);
			break;
		case PROP_VALUE:
			rOldValue = m_xDefValue->getAny();
			bModified = convertValue(rConvertedValue, rOldValue, rValue);
			break;
		default:
			DBG_ERROR("unknown Porperty");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbField::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw(staruno::Exception)
{
	switch (nHandle)
	{
		case PROP_DESCRIPTION:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aDescription;
			break;
		case PROP_FORMATKEY:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_LONG, "invalid type" );

			rValue >>= m_nSize;
			break;
		case PROP_ISAUTOINCREMENT:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			m_bAutoIncrement = utl::getBOOL(rValue);
			break;
		case PROP_ISDESCENDING:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			m_bDescending = utl::getBOOL(rValue);
			break;
		case PROP_ISMODIFIED:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			if (m_xValue.is())
				m_xValue->setModified(sal_False);
			break;
		case PROP_ISPRIMARYKEY:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			m_bPrimaryKey = utl::getBOOL(rValue);
			break;
		case PROP_ISREQUIRED:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			m_bRequired = utl::getBOOL(rValue);
			break;
		case PROP_ISVERSIONING:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_BOOLEAN, "invalid type" );

			m_bVersioning = utl::getBOOL(rValue);
			break;
		case PROP_PARAMETERTYPE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nParameterType;
			break;
		case PROP_REFNAME:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aRefName;
			break;
		case PROP_SCALE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nSize;
			break;
		case PROP_SIZE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_LONG, "invalid type" );

			rValue >>= m_nSize;
			break;
		case PROP_TYPE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nType;
			break;
		case PROP_DEFAULTVALUE:
		{
			m_xDefValue->setAny(rValue);
		}	break;
		case PROP_VALUE:
		{
			m_xValue->setAny(rValue);
			if (m_xOldValue.is())
				m_xOldValue->setAny(rValue);
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbField::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_DEFAULTVALUE:
			if (m_xDefValue.is())
				rValue = m_xDefValue->getAny();
			break;
		case PROP_DESCRIPTION:
			rValue <<= m_aDescription;
			break;
		case PROP_FIELDSOURCE:
			rValue <<= m_aFieldSource;
			break;
		case PROP_TABLENAME:
			rValue <<= m_aTableSource;
			break;
		case PROP_FORMATKEY:
			rValue <<= m_nFormatKey;
			break;
		case PROP_ISAUTOINCREMENT:
			rValue <<= (sal_Bool) m_bAutoIncrement;
			break;
		case PROP_ISFUNCTION:
			rValue <<= (sal_Bool) m_bFunction;
			break;
		case PROP_ISDESCENDING:
			rValue <<= (sal_Bool) m_bDescending;
			break;
		case PROP_ISMODIFIED:
			if (m_xValue.is())
				rValue <<= m_xValue->isModified();
			else
				rValue <<= sal_False;
			break;
		case PROP_ISPRIMARYKEY:
			rValue <<= (sal_Bool) m_bPrimaryKey;
			break;
		case PROP_ISVERSIONING:
			rValue <<= (sal_Bool) m_bVersioning;
			break;
		case PROP_ISREQUIRED:
			rValue <<= (sal_Bool) m_bRequired;
			break;
		case PROP_ISUNSIGNED:
			rValue <<= (sal_Bool) m_bUnsigned;
			break;
		case PROP_ISREADONLY:
			rValue <<= (sal_Bool) m_bReadOnly;
			break;
		case PROP_SEARCHINFO:
			rValue <<= m_nSearchInfo;
			break;
		case PROP_PARAMETERTYPE:
			rValue <<= m_nParameterType;
			break;
		case PROP_REFNAME:
			rValue <<= m_aRefName;
			break;
		case PROP_NAME:
			rValue <<= m_aName;
			break;
		case PROP_SCALE:
			rValue <<= m_nScale;
			break;
		case PROP_SIZE:
			rValue <<= m_nSize;
			break;
		case PROP_TYPE:
			rValue <<= m_nType;
			break;
		case PROP_VALUE:
			if (m_xValue.is())
				rValue = m_xValue->getAny();
			break;

		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbField::convertValue(Any& rConvertedValue, const Any& rOldValue, const Any& rValue)
						throw( starlang::IllegalArgumentException )
{
	if (rValue.getValueTypeClass() == staruno::TypeClass_ANY)
	{
		Any const*const pValue = static_cast<Any const*>(rValue.getValue());
		return convertValue(rConvertedValue, rOldValue, Any(*pValue));
	}

	else if (rOldValue == rValue)
		return sal_False;
	else
	{
		sal_Bool bModified(sal_False);
		ODbVariantRef xTemp = m_xValue;
		m_xValue = new ODbVariant();
		try
		{
			// dont fire any propertychange events
			m_bFireValueChanges = sal_False;

			staruno::Type aValueType = rValue.getValueType();

			switch (aValueType.getTypeClass())
			{
				case staruno::TypeClass_VOID:
					setNull();
					break;
				case staruno::TypeClass_STRING:
					setString( ::utl::getString(rValue) );
					break;
				case staruno::TypeClass_BOOLEAN:
					setBoolean( ::utl::getBOOL(rValue) );
					break;
				case staruno::TypeClass_BYTE:
					setByte(*static_cast<const sal_Int8 *>(rValue.getValue()));
					break;
				case staruno::TypeClass_UNSIGNED_SHORT:
				case staruno::TypeClass_SHORT:
					setShort( ::utl::getINT16(rValue) );
					break;
				case staruno::TypeClass_CHAR:
//					setShort(reinterpret_cast<const sal_Int16*>(*static_cast<const sal_Unicode *>(rValue.getValue()) ));//XXX
					setShort(*static_cast<const sal_Unicode *>(rValue.getValue() ));//XXX
					break;
				case staruno::TypeClass_LONG:
				case staruno::TypeClass_UNSIGNED_LONG:
					setLong( ::utl::getINT32(rValue) );
					break;
				case staruno::TypeClass_FLOAT:
					setFloat(*static_cast<const float*>(rValue.getValue()));
					break;
				case staruno::TypeClass_DOUBLE:
					setDouble(*static_cast<const double*>(rValue.getValue()));
					break;
				case staruno::TypeClass_SEQUENCE:
					if (aValueType.equals( ::getCppuType(static_cast<const staruno::Sequence<sal_Int8>*>(0)) ) )
						setBytes(*static_cast<const staruno::Sequence<sal_Int8>*>(rValue.getValue()));
					else
						throw starlang::IllegalArgumentException();
					break;
				case staruno::TypeClass_STRUCT:
				case staruno::TypeClass_INTERFACE:
					if (aValueType.equals( ::getCppuType(static_cast<const Reference<stario::XInputStream>*>(0)) ))
						setBinaryStream(*static_cast<const Reference<stario::XInputStream>*>(rValue.getValue()));

					else if (aValueType.equals( ::getCppuType(static_cast<const starutil::DateTime*>(0)) ))
						setDateTime(*static_cast<const starutil::DateTime*>(rValue.getValue()));

					else if (aValueType.equals( ::getCppuType(static_cast<const starutil::Date*>(0)) ))
						setDate(*static_cast<const starutil::Date*>(rValue.getValue()));

					else if (aValueType.equals( ::getCppuType(static_cast<const starutil::Time*>(0)) ))
						setTime(*static_cast<const starutil::Time*>(rValue.getValue()));

					else
						throw starlang::IllegalArgumentException();
					break;
				default:
					throw starlang::IllegalArgumentException();
			}
			m_bFireValueChanges = sal_True;
		}
		catch(starlang::IllegalArgumentException&)
		{
			m_xValue = xTemp;
			m_bFireValueChanges = sal_True;
			throw;
		}
		catch(...)
		{
			m_xValue = xTemp;
			m_bFireValueChanges = sal_True;
			throw starlang::IllegalArgumentException();
		}

		rConvertedValue = m_xValue->getAny();
		bModified = (rConvertedValue == rValue);
		m_xValue  = xTemp;
		return bModified;
	}
}

//------------------------------------------------------------------------------
void SbaXdbField::replaceValue(const ODbVariantRef& xValue)
{
	{
		MutexGuard aGuard( m_aMutex );
		m_xValue = xValue;
	}
	fireValueChanged();
}

//------------------------------------------------------------------------------
void SbaXdbField::setDefault()
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xDefValue.is() && m_xValue.is())
	{
		*m_xValue = *m_xDefValue;
		aGuard.clear();
		fireValueChanged();
	}
}

//XDatabaseVariant
//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbField::isNull(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is())
		return m_xValue->isNull();
	else
		return sal_False;
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbField::getString(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toString(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return ::rtl::OUString();
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbField::getBoolean(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull() )
	{
		try
		{
			return ODbTypeConversion::toBOOL(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return sal_False;
}

//------------------------------------------------------------------------------
sal_Int8 SAL_CALL SbaXdbField::getByte(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toBYTE(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int16 SAL_CALL SbaXdbField::getShort(void) /*const*/
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT16(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbField::getLong(void) /*const*/
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toINT32(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return 0;
}

//------------------------------------------------------------------------------
float SAL_CALL SbaXdbField::getFloat(void) /*const*/
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toFloat(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return 0.0;
}

//------------------------------------------------------------------------------
double SAL_CALL SbaXdbField::getDouble(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			return ODbTypeConversion::toDouble(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return 0.0;
}

//------------------------------------------------------------------------------
staruno::Sequence< sal_Int8 > SAL_CALL SbaXdbField::getBytes(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is())
	{
		try
		{
			return ODbTypeConversion::toBytes(*m_xValue);
		}
		catch(...)
		{
		}
	}
	return staruno::Sequence< sal_Int8 >();
}

//------------------------------------------------------------------------------
starutil::Date SAL_CALL SbaXdbField::getDate(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			starutil::Date aDate;
			::utl::typeConvert(ODbTypeConversion::toDate(*m_xValue), aDate);
			return aDate;
		}
		catch(...)
		{
		}
	}
	return starutil::Date();
}

//------------------------------------------------------------------------------
starutil::Time SAL_CALL SbaXdbField::getTime(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			starutil::Time aTime;
			::utl::typeConvert(ODbTypeConversion::toTime(*m_xValue), aTime);
			return aTime;
		}
		catch(...)
		{
		}
	}
	return starutil::Time();
}

//------------------------------------------------------------------------------
starutil::DateTime SAL_CALL SbaXdbField::getDateTime(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		try
		{
			starutil::DateTime aDateTime;
			::utl::typeConvert(ODbTypeConversion::toDateTime(*m_xValue), aDateTime);
			return aDateTime;
		}
		catch(...)
		{
		}
	}
	return starutil::DateTime();
}

//------------------------------------------------------------------------------
Reference< stario::XInputStream > SAL_CALL SbaXdbField::getBinaryStream(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	if (m_xValue.is() && !m_xValue->isNull())
	{
		switch (m_nType)
		{
			case DatabaseFieldType::CHAR:
			case DatabaseFieldType::VARCHAR:
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::OTHER:
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			{
				if (m_xValue->getValueType().equals(::getCppuType(static_cast<const staruno::Sequence<sal_Int8>*>(0))))
				{
					Reference< stario::XActiveDataSink >
						xSink(	getXdbContext().getServiceManager()->
									createInstance(::rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")),
								UNO_QUERY);

					if (xSink.is())
					{
						::utl::SequenceInputStream* pUnoStream = new ::utl::SequenceInputStream(m_xValue->getBytes());
						xSink->setInputStream(Reference< stario::XInputStream > (pUnoStream));
						return Reference< stario::XInputStream > (xSink, UNO_QUERY);
					}
				}
				else
				{
					::rtl::OUString aStr = getString();

					// creating a pipe
					Reference< stario::XOutputStream >
						xOutPipe(	getXdbContext().getServiceManager()->
										createInstance(::rtl::OUString::createFromAscii("com.sun.star.io.Pipe")),
									UNO_QUERY);

					Reference< stario::XInputStream >  xInPipe(xOutPipe, UNO_QUERY);

					// connect pipe and sink
					Reference< stario::XActiveDataSink >
						xSink(	getXdbContext().getServiceManager()->
									createInstance(::rtl::OUString::createFromAscii("com.sun.star.io.ObjectInputStream")),
								UNO_QUERY);

					xSink->setInputStream(xInPipe);

					// connect pipe and source
					Reference< stario::XActiveDataSource >
						xSource(getXdbContext().getServiceManager()->
									createInstance(::rtl::OUString::createFromAscii("com.sun.star.io.ObjectOutputStream")),
								UNO_QUERY);

					xSource->setOutputStream(xOutPipe);

					// write the string to source
					Reference< stario::XObjectOutputStream >  xOutStrm(xSource, UNO_QUERY);
					xOutStrm->writeUTF(aStr);
					xOutStrm->closeOutput();

					// return the input
					return Reference< stario::XInputStream > (xSink, UNO_QUERY);
				}
				break;
			}
		}
	}
	return Reference< stario::XInputStream > ();
}
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setNull(void)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		m_xValue->setNull();
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setString(const ::rtl::OUString& x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setString(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setBoolean(sal_Bool x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setBOOL(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setByte(sal_Int8 x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setBYTE(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setShort(sal_Int16 x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setINT16(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setLong(sal_Int32 x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setINT32(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setFloat(float x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setFloat(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setDouble(double x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::OTHER:
			{
				throw starlang::IllegalArgumentException();
			}   break;
			default:
				m_xValue->setDouble(x);
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setBytes(const staruno::Sequence< sal_Int8 >& x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::OTHER:
			{
				m_xValue->setBytes(x);
			}   break;
			default:
			{
				throw starlang::IllegalArgumentException();
			}   break;
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setDate(const starutil::Date& x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::VARCHAR:
			case DatabaseFieldType::CHAR:
			case DatabaseFieldType::DOUBLE:
			{
				::Date aDate;
				::utl::typeConvert(x,aDate);
				m_xValue->setDate(aDate);
			}	break;
			default:
				throw starlang::IllegalArgumentException();
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setTime(const starutil::Time& x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::VARCHAR:
			case DatabaseFieldType::CHAR:
			case DatabaseFieldType::DOUBLE:
			{
				::Time aTime;
				::utl::typeConvert(x,aTime);
				m_xValue->setTime(aTime);
			}	break;
			default:
				throw starlang::IllegalArgumentException();
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setDateTime(const starutil::DateTime& x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::DATETIME:
			case DatabaseFieldType::DATE:
			case DatabaseFieldType::TIME:
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::VARCHAR:
			case DatabaseFieldType::CHAR:
			case DatabaseFieldType::DOUBLE:
			{
				::DateTime aDateTime;
				::utl::typeConvert(x,aDateTime);
				m_xValue->setDateTime(aDateTime);
			}	break;
			default:
				throw starlang::IllegalArgumentException();
		}
		aGuard.clear();
		fireValueChanged();
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setBinaryStream(const Reference< stario::XInputStream > & x)
	throw(stardata::DatabaseException, staruno::RuntimeException)
{
	ClearableMutexGuard aGuard( m_aMutex );
	if (m_xValue.is() && !m_bReadOnly)
	{
		switch (m_nType)
		{
			case DatabaseFieldType::LONGVARCHAR:
			case DatabaseFieldType::BINARY:
			case DatabaseFieldType::VARBINARY:
			case DatabaseFieldType::LONGVARBINARY:
			case DatabaseFieldType::OTHER:
			{
				try
				{
					staruno::Sequence <sal_Int8> aBuffer;
					staruno::Sequence <sal_Int8> aData;

					sal_Int32 nBytes = x->available();
					while (nBytes)
					{
						aBuffer.realloc(nBytes);
						nBytes = x->readBytes(aBuffer, nBytes);
						if (nBytes > 0)
						{
							aData.realloc(aData.getLength() + nBytes);
							memcpy(aData.getArray() + aData.getLength() - nBytes, aBuffer.getConstArray(), nBytes);
						}
						nBytes = x->available();
					}
					m_xValue->setBytes(aData);
					x->closeInput();
				}
				catch(...)
				{
				}
			}   break;
			default:
			{
				throw starlang::IllegalArgumentException();
			}
		}
		aGuard.clear();
		fireValueChanged();
	}
}

// ::com::sun::star::data::XDatabaseFieldDescriptorFactory
//------------------------------------------------------------------------------
Reference< starbeans::XPropertySet >
	SAL_CALL SbaXdbField::create(void)
		throw( staruno::RuntimeException )
{
	return new SbaXdbFieldDescriptor(NULL, *this);
}

//------------------------------------------------------------------------------
// ::com::sun::star::container::XNamed
::rtl::OUString
	SAL_CALL SbaXdbField::getName(void)
		throw( staruno::RuntimeException )
{
	return m_aName;
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbField::setName(const ::rtl::OUString& /*Name_*/)
		throw( staruno::RuntimeException )
{
	//Not allowed: throw(starlang::NoSupportException());
	throw staruno::RuntimeException(); // ???
}

//------------------------------------------------------------------------------
SdbColumn* SbaXdbField::createColumn(SdbConnection* pCon) const
{
	sal_uInt16 nFlags(0);
	if (!m_bRequired)
		nFlags |= SDB_FLAGS_NULLALLOWED;
	if (m_bDescending)
		nFlags |= SDB_FLAGS_DESCENDING;
	if (m_bPrimaryKey)
		nFlags |= SDB_FLAGS_PRIMARYKEY;
	if (m_bAutoIncrement)
		nFlags |= SDB_FLAGS_AUTOINCREMENT;

	SdbColumn* pCol = pCon->CreateColumn(m_aName, SdbDatabaseType(m_nType),
								m_nSize, m_nScale, nFlags);

	pCol->SetFormatKey(m_nFormatKey);
	return pCol;
}

//------------------------------------------------------------------------------
SbaColumn* SbaXdbField::createColumn(SbaDBDataDef& rDef) const
{
	SbaNumericSize eSize;
	SbaFieldType eType = XdbType2SbaType(m_nType, eSize);

	String aDefault;
	try
	{
		if (m_xDefValue.is())
			aDefault = (const sal_Unicode*)ODbTypeConversion::toString(*m_xDefValue);
	}
	catch(...)
	{
	}

	SbaColumn* pColumn = rDef.CreateColumn(m_aName, eType,
									eType == dbNumeric ? eSize : m_nSize,
									m_nScale,
									m_bRequired,
									m_nFormatKey,
									rDef.GetColumns().Count(),
									aDefault);

	pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, m_bPrimaryKey));
	pColumn->Put(SfxStringItem(SBA_DEF_FLTCOMMENT, m_aDescription));
	pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, m_bAutoIncrement));

	return pColumn;
}

//SbaXdbFieldDescriptor
// SbaXdbRecordField

// staruno::XInterface
//------------------------------------------------------------------------------
staruno::Any SAL_CALL SbaXdbFieldDescriptor::queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException )
{
	return queryFieldBase(rType);
}

// TypeProviderHelper
//------------------------------------------------------------------------------
Sequence< staruno::Type > SbaXdbFieldDescriptor::collectTypes(SbaXdbFieldDescriptor*) throw(staruno::RuntimeException)
{
	return getFieldBaseTypes();
}
using namespace ::cppu;
using namespace ::osl;
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbFieldDescriptor::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}
// XUnoTunnel
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbFieldDescriptor::getSomething(staruno::Sequence<sal_Int8> const& rId) throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return sal_Int64();
}


//------------------------------------------------------------------------------
void SbaXdbFieldDescriptor::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw(staruno::RuntimeException)
{
	using namespace starbeans::PropertyAttribute;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,13)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( DEFAULTVALUE),		PROP_TYPE(Any),			MAYBEVOID);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( DESCRIPTION),		PROP_TYPE(OUString),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( FORMATKEY),		PROP_TYPE(sal_Int32),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( ISAUTOINCREMENT),	BOOL_PROP(),			0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( ISDESCENDING),		BOOL_PROP(),			0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( ISPRIMARYKEY),		BOOL_PROP(),			0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( ISREQUIRED),		BOOL_PROP(),			0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( ISVERSIONING),		BOOL_PROP(),			0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( PARAMETERTYPE),	PROP_TYPE(sal_Int16),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( REFNAME),			PROP_TYPE(OUString),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( SCALE),			PROP_TYPE(sal_Int16),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( SIZE),				PROP_TYPE(sal_Int32),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY( TYPE),				PROP_TYPE(sal_Int16),	0);
	SBA_END_PROPERTY_HELPER();
}

//SbaXdbFieldDefinition
//------------------------------------------------------------------------------

// staruno::XInterface
//------------------------------------------------------------------------------
staruno::Any SAL_CALL SbaXdbFieldDefinition::queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException )
{
	Any aRet( queryFieldBase(rType) );

	return aRet.hasValue() ?
				aRet :
				utl::queryDeepInterface( rType,
											static_cast<starcontainer::XNamed*>(this),
											static_cast<stardata::XDatabaseFieldDescriptorFactory*>(this)
										);
}

// TypeProviderHelper
//------------------------------------------------------------------------------
Sequence< staruno::Type > SbaXdbFieldDefinition::collectTypes(SbaXdbFieldDefinition*) throw(staruno::RuntimeException)
{
	return ::cppu::OTypeCollection(
					::getCppuType(static_cast<Reference<starcontainer::XNamed > const*>(0)),
					::getCppuType(static_cast<Reference<stardata::XDatabaseFieldDescriptorFactory > const*>(0)),
					getFieldBaseTypes()
				).getTypes();
}

// XUnoTunnel
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbFieldDefinition::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbFieldDefinition::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbFieldDescriptor::getSomething(rId);

}


//------------------------------------------------------------------------------
void SbaXdbFieldDefinition::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw(staruno::RuntimeException)
{
	using namespace starbeans::PropertyAttribute;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,14)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(DEFAULTVALUE),		PROP_TYPE(Any),			MAYBEVOID | READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(DESCRIPTION),		PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FORMATKEY),			PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISAUTOINCREMENT),	BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISDESCENDING),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISPRIMARYKEY),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREQUIRED),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISVERSIONING),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),				PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(PARAMETERTYPE),		PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(REFNAME),			PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SCALE),				PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SIZE),				PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TYPE),				PROP_TYPE(sal_Int16),	READONLY);
	SBA_END_PROPERTY_HELPER();
}

// SbaXdbParameter
//------------------------------------------------------------------------------

void SbaXdbParameter::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw(staruno::RuntimeException)
{
	using namespace starbeans::PropertyAttribute;
	SBA_BEGIN_PROPERTY_HELPER(aProperties, 8)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FORMATKEY),		PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREQUIRED),	BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISUNSIGNED),	BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),			PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SCALE),			PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SIZE),			PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TYPE),			PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(VALUE),			PROP_TYPE(Any),			BOUND |MAYBEVOID);
	SBA_END_PROPERTY_HELPER();
}

// XUnoTunnel
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbParameter::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbParameter::getSomething(staruno::Sequence<sal_Int8> const& rId) throw( staruno::RuntimeException )
{
		if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbFieldDescriptor::getSomething(rId);
}


// SbaXdbRecordField
//------------------------------------------------------------------------------
void SbaXdbRecordField::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw(staruno::RuntimeException)
{
	using namespace starbeans::PropertyAttribute;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,13)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(DEFAULTVALUE),		PROP_TYPE(Any),			MAYBEVOID | READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FORMATKEY),			PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISAUTOINCREMENT),	BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISMODIFIED),		BOOL_PROP(),			TRANSIENT);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREADONLY),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREQUIRED),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISUNSIGNED),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),				PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SCALE),				PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SEARCHINFO),		PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SIZE),				PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TYPE),				PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(VALUE),				PROP_TYPE(Any),			BOUND | MAYBEVOID);
	SBA_END_PROPERTY_HELPER();
}

// XUnoTunnel
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbRecordField::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbRecordField::getSomething(staruno::Sequence<sal_Int8> const& rId) throw( staruno::RuntimeException )
{
		if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return sal_Int64();
}


// SbaXdbQueryFieldDescriptor
//------------------------------------------------------------------------------
void SbaXdbQueryFieldDescriptor::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw(staruno::RuntimeException)
{
	using namespace starbeans::PropertyAttribute;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,13)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FIELDSOURCE),		PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FORMATKEY),			PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISAUTOINCREMENT),	BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISFUNCTION),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREADONLY),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISREQUIRED),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(ISUNSIGNED),		BOOL_PROP(),			READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),				PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SCALE),				PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SEARCHINFO),		PROP_TYPE(sal_Int16),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SIZE),				PROP_TYPE(sal_Int32),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TABLENAME),			PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TYPE),				PROP_TYPE(sal_Int16),	READONLY);
	SBA_END_PROPERTY_HELPER();
}

// XUnoTunnel
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbQueryFieldDescriptor::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbQueryFieldDescriptor::getSomething(staruno::Sequence<sal_Int8> const& rId) throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbFieldDescriptor::getSomething(rId);
}

//------------------------------------------------------------------------------
SbaXdbFields::SbaXdbFields(SbaXdbComponent& _rParent, sal_Bool bCase)
			 :SbaXdbBroadcaster(_rParent.getMutex())
			 ,m_rParent(_rParent)
			 ,m_aFieldMap(17, ::utl::UStringMixHash(bCase), ::utl::UStringMixEqual(bCase))
{
}

//------------------------------------------------------------------------------
SbaXdbFields::SbaXdbFields(SbaXdbComponent& _rParent, const SbaXdbFields& rFields)
			 :SbaXdbBroadcaster(_rParent.getMutex())
			 ,m_rParent(_rParent)
			 ,m_aFieldMap(rFields.m_aFieldMap.size(), rFields.m_aFieldMap.hash_funct(), rFields.m_aFieldMap.key_eq())
{
	sal_Int32 nCount(rFields.m_aFields.size());
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		SbaXdbField* pCopyField = rFields.m_aFields[i];
		SbaXdbFieldDefinition* pField = new SbaXdbFieldDefinition(&m_rParent, *pCopyField);
		pField->m_aName = pCopyField->m_aName;
		append(pField);
	}
}

//------------------------------------------------------------------------------
SbaXdbFields::~SbaXdbFields()
{
}

//------------------------------------------------------------------------------
void SbaXdbFields::acquire()
	throw(staruno::RuntimeException)
{
	m_rParent.acquire();
}

//------------------------------------------------------------------------------
void SbaXdbFields::release()
			throw(staruno::RuntimeException)
{
	m_rParent.release();
}

//------------------------------------------------------------------
const SbaXdbField* SbaXdbFields::at(const ::rtl::OUString& rName) const
{
	OFieldMap::const_iterator i = m_aFieldMap.find(rName);
	return i == m_aFieldMap.end() ? NULL : (*i).second;
}

//------------------------------------------------------------------
void SbaXdbFields::append(SbaXdbField* pField)
{
	pField->acquire();
	m_aFieldMap[pField->m_aName] = pField;
	m_aFields.push_back(pField);
}


//------------------------------------------------------------------------------
void SbaXdbFields::disposing()
{
	for (OFieldArray::iterator i = m_aFields.begin(); m_aFields.end() != i; i++)
	{
		(*i)->dispose();
		(*i)->release();
	}
	m_aFields.clear();
	m_aFieldMap.clear();
}

// ::com::sun::star::data::XDatabaseFieldDescriptorFactory
//------------------------------------------------------------------------------
Reference< starbeans::XPropertySet > SAL_CALL SbaXdbFields::create(void) throw( staruno::RuntimeException )
{
	return new SbaXdbFieldDescriptor();
}

// ::com::sun::star::container::XChild
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbFields::setParent(const Reference< staruno::XInterface > &) throw( starlang::NoSupportException, staruno::RuntimeException  )
{
	throw starlang::NoSupportException();
}

// starcontainer::XElementAccess
//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbFields::hasElements(void) throw( staruno::RuntimeException )
{
	return !m_aFields.empty();
}

//------------------------------------------------------------------------------
staruno::Type SAL_CALL SbaXdbFields::getElementType(void) throw( staruno::RuntimeException )
{
	Reference<starbeans::XPropertySet> const*const pxPropertySet = 0;
	return ::getCppuType(pxPropertySet);
}

// ::com::sun::star::container::XEnumerationAccess
//------------------------------------------------------------------------------
Reference< starcontainer::XEnumeration > SAL_CALL SbaXdbFields::createEnumeration(void)
	throw( staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );
	return new ::utl::OEnumerationByName(static_cast<starcontainer::XNameAccess*>(this));
}

// starcontainer::XIndexAccess
//------------------------------------------------------------------------------
sal_Int32 SAL_CALL SbaXdbFields::getCount(void) throw( staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );
	return m_aFields.size();
}

//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbFields::getByIndex(sal_Int32 Index)
	throw( starlang::IndexOutOfBoundsException, starlang::WrappedTargetException, staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );
	checkIndex(this, Index);

	Reference< starbeans::XPropertySet >  xVal(m_aFields[Index]);
	return staruno::makeAny(xVal);
}

// ::com::sun::star::container::XNameAccess
//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbFields::getByName(const ::rtl::OUString& Name) /*const*/
	throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );
	OFieldMap::const_iterator i = m_aFieldMap.find(Name);
	if (i == m_aFieldMap.end())
		throw starcontainer::NoSuchElementException();

	Reference< starbeans::XPropertySet >  xObj((*i).second);
	return staruno::makeAny(xObj);
}

//------------------------------------------------------------------------------
staruno::Sequence< ::rtl::OUString> SAL_CALL SbaXdbFields::getElementNames(void) throw( staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );

	staruno::Sequence< ::rtl::OUString> aNameList(m_aFields.size());
	::rtl::OUString* pStringArray = aNameList.getArray();

	for (OFieldArray::const_iterator i = m_aFields.begin(); m_aFields.end() != i; i++)
	{
		(*pStringArray) = (*i)->getName();
		++pStringArray;
	}
	return aNameList;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbFields::hasByName(const ::rtl::OUString& Name) /*const*/ throw( staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );
	OFieldMap::const_iterator i = m_aFieldMap.find(Name);
	return i != m_aFieldMap.end();
}

// ::com::sun::star::data::XDatabaseNameContainer
void SAL_CALL SbaXdbFields::insertNewByName(const ::rtl::OUString& Name, const Any& Element)
	throw( starlang::IllegalArgumentException, starcontainer::ElementExistException,
			stardata::DatabaseException, staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );

	// Existiert schon ein element mit diesem Namen
	if (hasByName(Name))
	{
		throw starcontainer::ElementExistException();
	}

	if (!Element.getValueType().equals(::getCppuType(static_cast<const Reference<starbeans::XPropertySet>*>(0))))
	{
		throw starlang::IllegalArgumentException();
	}

	SbaXdbFieldDescriptor* pDesc = 0;

	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel;
	Element >>= xTunnel;
	if(xTunnel.is())
	{
		pDesc = (SbaXdbFieldDescriptor*)xTunnel->getSomething(SbaXdbFieldDescriptor:: getUnoTunnelImplementationId());
	}
	if(!pDesc)
		throw starlang::IllegalArgumentException();

	SbaXdbFieldDefinition* pField = new SbaXdbFieldDefinition(&m_rParent, *pDesc);
	pField->m_aName = Name;
	append(pField);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbFields::removeByName(const ::rtl::OUString& Name)
	throw( starcontainer::NoSuchElementException, stardata::DatabaseException, staruno::RuntimeException )
{
	MutexGuard aGuard( m_rParent.getMutex() );

	OFieldMap::iterator i = m_aFieldMap.find(Name);
	if (i == m_aFieldMap.end())
		throw starlang::NoSupportException();

	OFieldArray::iterator j = find(m_aFields.begin(), m_aFields.end(), (*i).second);
	SbaXdbField* pField = *j;

	m_aFields.erase(j);
	m_aFieldMap.erase(i);

	pField->disposing();
	pField->release();
}

//------------------------------------------------------------------------------
void SbaXdbFields::setDefinitions(const SdbColumnsRef& xCols)
{
	disposing();
	sal_uInt32 nCount = xCols->Count();
	for (sal_uInt32 i = 1; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i);
		SbaXdbField* pField = new SbaXdbFieldDefinition(&m_rParent,*pCol);
		append(pField);
	}
}

//------------------------------------------------------------------------------
void SbaXdbFields::setDefinitions(const SbaColumnList& rCols)
{
	disposing();
	sal_uInt32 nCount = rCols.Count();
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SbaColumn* pCol = rCols.GetObject(i);
		SbaXdbField* pField = new SbaXdbFieldDefinition(&m_rParent,*pCol);
		append(pField);
	}
}

//------------------------------------------------------------------------------
void SbaXdbFields::setRelDefinitions(const SdbColumnsRef& xCols)
{
	disposing();
	sal_uInt32 nCount = xCols->Count();
	for (sal_uInt32 i = 1; i < nCount; i++)
	{
		const SdbColumnRelation* pCol = (const SdbColumnRelation*)xCols->Column(i);
		SbaXdbField* pField = new SbaXdbFieldDefinition(&m_rParent,*pCol);
		append(pField);
	}
}

//------------------------------------------------------------------------------
void SbaXdbFields::adjustTypes(const SbaXdbFields& rdbFields)
{
	const OFieldArray& rFields = rdbFields.m_aFields;
	sal_Int32 nFieldCount = rFields.size();
	for (sal_Int32 i = 0; i < nFieldCount; i++)
	{
		// Abgleich ueber den Namen der Felder
		const SbaXdbField* pRefField = rFields[i];
		OFieldMap::iterator i = m_aFieldMap.find(pRefField->m_aName);
		if (i != m_aFieldMap.end())
			(*i).second->adjustType(*pRefField);
	}
}

//----------------------------------------------------------------------
class SbaXdbFieldValuesInfo : public ::cppu::WeakImplHelper2<starlang::XEventListener, starbeans::XPropertySetInfo>
{
	// JB: Was not weak before UNO 3
public:
	typedef starbeans::Property Property;
	::cppu::IPropertyArrayHelper* m_pHelper;

	SbaXdbFieldValuesInfo(const Reference<starlang::XComponent> & xComp, ::cppu::IPropertyArrayHelper* pHelper_);

	// ::com::sun::star::beans::XPropertySetInfo-Methoden
	virtual staruno::Sequence< Property > SAL_CALL getProperties(void) /*const*/
		throw(staruno::RuntimeException);

	virtual Property	SAL_CALL getPropertyByName(const ::rtl::OUString& PropertyName) /*const*/
		throw(starbeans::UnknownPropertyException, staruno::RuntimeException);

	virtual sal_Bool SAL_CALL hasPropertyByName(const ::rtl::OUString& PropertyName) /*const*/
		throw(staruno::RuntimeException);

	// starlang::XEventListener
	virtual void SAL_CALL disposing(const starlang::EventObject& Source)
		throw(staruno::RuntimeException);

};


//------------------------------------------------------------------------------
SbaXdbFieldValuesInfo::SbaXdbFieldValuesInfo(const Reference< starlang::XComponent > & xComp, ::cppu::IPropertyArrayHelper* pHelper_ )
					  :m_pHelper( pHelper_ )
{
	if (xComp.is())
		xComp->addEventListener(this);
}


// ::com::sun::star::lang::XEventListener
//------------------------------------------------------------------------------
void SbaXdbFieldValuesInfo::disposing(const starlang::EventObject& evt) throw(staruno::RuntimeException)
{
	m_pHelper = NULL;
}

//------------------------------------------------------------------------------
staruno::Sequence< starbeans::Property > SbaXdbFieldValuesInfo::getProperties(void) throw(staruno::RuntimeException)
{
	if (m_pHelper)
		return m_pHelper->getProperties();
	else
		return staruno::Sequence< starbeans::Property >();
}

//------------------------------------------------------------------------------
starbeans::Property SbaXdbFieldValuesInfo::getPropertyByName( const ::rtl::OUString & PropertyName )
	throw(starbeans::UnknownPropertyException, staruno::RuntimeException)
{
	if (m_pHelper)
		return m_pHelper->getPropertyByName( PropertyName );
	else
	{
		throw staruno::RuntimeException();
	}
	return starbeans::Property();
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbFieldValuesInfo::hasPropertyByName( const ::rtl::OUString & PropertyName ) throw(staruno::RuntimeException)
{
	return m_pHelper && m_pHelper->hasPropertyByName( PropertyName );
}


// SbaXdbFieldValues
//------------------------------------------------------------------------------
void SbaXdbFieldValues::constructRecordFields(const SdbColumnsRef& xCols)
{
	DBG_ASSERT(!m_pPropertyHelper, "SbaXdbFieldValues::construct called more than once");

	sal_uInt32 nCount = xCols.is() ? (xCols->Count() - 1) : 0;
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i+1);
		SbaXdbField* pField = new SbaXdbRecordField(&m_rParent,*pCol);
		append(pField);
	}

	using starbeans::Property;

	staruno::Sequence<Property> aProperties;
	if ( nCount )
	{
		aProperties.realloc(nCount);
		Property *pProperties = aProperties.getArray();

		for (sal_uInt32 i = 0; i < nCount; i++)
		{
			SbaXdbField* pField = m_aFields[i];
			pProperties[i].Name = pField->m_aName;
			pProperties[i].Handle = i;
			pProperties[i].Type   = ::getCppuType( forUnoAny );

			pProperties[i].Attributes = pField->m_bReadOnly ?
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND | PropertyAttribute::READONLY :
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND;
		}
	}
	m_pPropertyHelper = new ::cppu::OPropertyArrayHelper(aProperties);
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::constructParameterFields(const SdbColumnsRef& xCols, const ODbRowRef& xParams)
{
	DBG_ASSERT(!m_pPropertyHelper, "SbaXdbFieldValues::construct called more than once");

	sal_uInt32 nCount = xCols.is() ? (xCols->Count() - 1) : 0;
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i+1);
		SbaXdbField* pField = new SbaXdbParameter(&m_rParent,*pCol);
		append(pField);

		// Parameter sind grundsaetzlich updatebar
		pField->m_bReadOnly = sal_False;
		pField->replaceValue((*xParams)[i+1]);

	}

	using starbeans::Property;
	staruno::Sequence<Property> aProperties;
	if ( nCount )
	{
		aProperties.realloc(nCount);
		Property *pProperties = aProperties.getArray();

		for (sal_uInt32 i = 0; i < nCount; i++)
		{
			SbaXdbField* pField = m_aFields[i];
			pProperties[i].Name = pField->m_aName;
			pProperties[i].Handle = i;
			pProperties[i].Type   = ::getCppuType( forUnoAny );

			pProperties[i].Attributes = pField->m_bReadOnly ?
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND | PropertyAttribute::READONLY :
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND;
		}
	}
	m_pPropertyHelper = new ::cppu::OPropertyArrayHelper(aProperties);
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::constructQueryDescriptionFields(const SdbColumnsRef& xCols)
{
	DBG_ASSERT(!m_pPropertyHelper, "SbaXdbFieldValues::construct called more than once");

	sal_uInt32 nCount = xCols.is() ? (xCols->Count() - 1) : 0;
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SdbColumn* pCol = xCols->Column(i+1);
		SbaXdbField* pField = new SbaXdbQueryFieldDescriptor(&m_rParent,*pCol);
		append(pField);
	}

	using starbeans::Property;
	staruno::Sequence<Property> aProperties;
	if ( nCount )
	{
		aProperties.realloc(nCount);
		Property *pProperties = aProperties.getArray();

		for (sal_uInt32 i = 0; i < nCount; i++)
		{
			SbaXdbField* pField = m_aFields[i];
			pProperties[i].Name = pField->m_aName;
			pProperties[i].Handle = i;
			pProperties[i].Type   = ::getCppuType( forUnoAny );

			pProperties[i].Attributes = pField->m_bReadOnly ?
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND | PropertyAttribute::READONLY :
				PropertyAttribute::MAYBEVOID | PropertyAttribute::BOUND;
		}
	}
	m_pPropertyHelper = new ::cppu::OPropertyArrayHelper(aProperties);
}

//------------------------------------------------------------------------------
SbaXdbFieldValues::~SbaXdbFieldValues()
{
	delete m_pPropertyHelper;
}

//------------------------------------------------------------------------------
// automatisch auskommentiert - [getIdlClass(es) or queryInterface] - Bitte XTypeProvider benutzen!

Any SAL_CALL SbaXdbFieldValues::queryInterface(staruno::Type const& rType) throw(staruno::RuntimeException)
{
	staruno::Any aRet( OPropertySetHelper::queryInterface(rType) );
	if (!aRet.hasValue())
		aRet = utl::queryDeepInterface( rType,
						static_cast<starcontainer::XIndexAccess *>(this),
						static_cast<starcontainer::XEnumerationAccess *>(this),
						static_cast<starcontainer::XNameAccess *>(this),
						static_cast<stardata::XDatabaseFieldDescriptorFactory *>(this)
					);
	return aRet.hasValue() ? aRet : OWeakObject::queryInterface(rType);
}

Sequence< staruno::Type > SbaXdbFieldValues::collectTypes(SbaXdbFieldValues*) throw(staruno::RuntimeException)
{
	return ::cppu::OTypeCollection(
			::getCppuType(static_cast< staruno::Reference< starlang::XTypeProvider > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< staruno::XWeak > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< starbeans::XPropertySet > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< starbeans::XMultiPropertySet > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< starbeans::XFastPropertySet > const*>(0)),

			::getCppuType(static_cast< staruno::Reference< starcontainer::XIndexAccess > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< starcontainer::XEnumerationAccess > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< starcontainer::XNameAccess > const*>(0)),
			::getCppuType(static_cast< staruno::Reference< stardata::XDatabaseFieldDescriptorFactory > const*>(0))
		).getTypes();
}

//------------------------------------------------------------------------------
::cppu::IPropertyArrayHelper& SbaXdbFieldValues::getInfoHelper() /*const*/
{
	DBG_ASSERT(m_pPropertyHelper, "SbaXdbFieldValues::construct not called");
	return *m_pPropertyHelper;
}

//------------------------------------------------------------------------------
Reference< starbeans::XPropertySetInfo >  SbaXdbFieldValues::getPropertySetInfo() /*const*/
		throw(staruno::RuntimeException)
{
	Reference< starlang::XComponent >  xComp;
	{
		MutexGuard aGuard( m_rParent.getMutex() );
		if (!m_rParent.isDisposed())
		{
			xComp = &m_rParent;
			return new SbaXdbFieldValuesInfo(xComp, &getInfoHelper() );
		}
		else
			return new SbaXdbFieldValuesInfo(xComp, NULL);
	}
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbFieldValues::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue,
											sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException )
{
	SbaXdbField* pField = m_aFields[nHandle];
	return pField->convertFastPropertyValue(rConvertedValue, rOldValue, PROP_VALUE, rValue);
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue )throw (staruno::Exception)
{
	SbaXdbField* pField = m_aFields[nHandle];
	pField->setFastPropertyValue_NoBroadcast(PROP_VALUE, rValue);
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	MutexGuard aGuard( /*(Mutex &)*/rBHelper.rMutex );
	checkIndex(this, nHandle);
	const SbaXdbField* pField = m_aFields[nHandle];
	pField->getFastPropertyValue(rValue, PROP_VALUE);
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::disposing()
{
	OPropertySetHelper::disposing();
	SbaXdbFields::disposing();
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::reset()
{
	disposing();
	MutexGuard aGuard( /*(Mutex &)*/rBHelper.rMutex );
	DELETEZ(m_pPropertyHelper);
	rBHelper.bDisposed = sal_False;
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::replaceValues(const ODbRowRef& rRow)
{
	if (!rRow.is())
		return;

	DBG_ASSERT(rRow->size() == m_aFields.size() + 1, "SbaXdbFieldValues::replaceValues : inconsistent arrays !");
	for (sal_uInt16 i = m_aFields.size(); i ; )
	{
		const ODbVariantRef& rValue = (*rRow)[i];
		m_aFields[--i]->replaceValue(rValue);
	}
}

//------------------------------------------------------------------------------
void SbaXdbFieldValues::setDefaults()
{
	for (sal_uInt16 i = m_aFields.size(); i ; )
		m_aFields[--i]->setDefault();
}

















