/*************************************************************************
 *
 *  $RCSfile: sbadbpar.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBPAR_HXX
#include "sbadbpar.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif

#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif

#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SDB_SDBENV_HXX //autogen
#include <sdb/sdbenv.hxx>
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#ifndef _SBA_SBADBIT_HXX
#include "sbadbit.hxx"
#endif

#ifndef  _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

#ifndef _SBA_SBADBDAT_HXX
#include "sbadbdat.hxx"
#endif

#ifndef _SBA_SBADBCON_HXX
#include "sbadbcon.hxx"
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_QRYFILT_HXX
#include <qryfilt.hxx>
#endif

#ifndef _SBA_QRYORDER_HXX
#include <qryorder.hxx>
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _UTL_ENUMHELPER_HXX_
#include <unotools/enumhelper.hxx>
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

using staruno::Any;
using staruno::Reference;
using staruno::Sequence;
using staruno::UNO_QUERY;
namespace DatabaseSearch	= stardata::DatabaseSearch;
namespace DatabaseFieldType	= stardata::DatabaseFieldType;

//------------------------------------------------------------------------------
SbaXdbSelectTables::SbaXdbSelectTables(SbaXdbParser& _rParent)
				   :m_rParent(_rParent)
{
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbSelectTables::acquire() throw( staruno::RuntimeException )
{
	m_rParent.acquire();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbSelectTables::release() throw( staruno::RuntimeException )
{
	m_rParent.release();
}

//------------------------------------------------------------------------------
void SbaXdbSelectTables::construct(SbaParseIterator* pIterator)
{
	// filling the table map
	Reference< starcontainer::XChild >  xChild(static_cast<SbaXdbContent*>(&m_rParent));
	if (xChild.is())
	{
		Reference< stardata::XDatabaseConnection >  xConn(xChild->getParent(), UNO_QUERY);
		if (xConn.is())
		{
			Reference< starcontainer::XNameContainer >  xNameAccess(xConn->getTables());
			const SdbTableRangeMap& rMap = pIterator->GetSdbTableRangeMap();
			for (sal_uInt32 i =0, nCount = rMap.Count(); i < nCount; i++)
			{
				Reference< stardata::XDatabaseTable >  xTable;
				xNameAccess->getByName((*rMap.GetObject(i))->GetFullName()) >>= xTable;
				m_aTables[rMap.GetKey(rMap.GetObject(i))] = xTable;
			}
		}
	}
}

//------------------------------------------------------------------------------
void SbaXdbSelectTables::clear()
{
	m_aTables.clear();
}

// starcontainer::XElementAccess
//------------------------------------------------------------------------------
staruno::Type SAL_CALL SbaXdbSelectTables::getElementType(void) throw( staruno::RuntimeException )
{
	return ::getCppuType(static_cast<const Reference<stardata::XDatabaseTable>*>(0));
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbSelectTables::hasElements(void) throw( staruno::RuntimeException )
{
	return m_aTables.size() != 0;
}

// starcontainer::XEnumerationAccess
//------------------------------------------------------------------------------
Reference< starcontainer::XEnumeration >
	SAL_CALL SbaXdbSelectTables::createEnumeration(void) throw( staruno::RuntimeException )
{
	return new utl::OEnumerationByName( static_cast<starcontainer::XNameAccess*>(this));
}

// starcontainer::XNameAccess
//------------------------------------------------------------------------------
Any SAL_CALL SbaXdbSelectTables::getByName(const ::rtl::OUString& Name)
		throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException  )
{
	TableMap::const_iterator i = m_aTables.find(Name);
	if (i == m_aTables.end())
		throw starcontainer::NoSuchElementException();

	Reference< stardata::XDatabaseTable >  xRet((*i).second);
	return ::staruno::makeAny(xRet);
}

//------------------------------------------------------------------------------
Sequence< ::rtl::OUString> SAL_CALL SbaXdbSelectTables::getElementNames(void) throw( staruno::RuntimeException  )
{
	Sequence< ::rtl::OUString > aNameList(m_aTables.size());
	::rtl::OUString* pStringArray = aNameList.getArray();
	for (TableMap::const_iterator i = m_aTables.begin();
		 i != m_aTables.end(); i++)
	{
		*pStringArray = (*i).first; pStringArray++;
	}
	return aNameList;
}

//------------------------------------------------------------------------------
sal_Bool SAL_CALL SbaXdbSelectTables::hasByName(const ::rtl::OUString& Name) throw( staruno::RuntimeException  )
{
	return m_aTables.find(Name) != m_aTables.end();
}

//------------------------------------------------------------------------------
SbaXdbParser::SbaXdbParser(SbaXdbCollection& rCollection, SdbConnection* pConn)
			 :SbaXdbObject(rCollection)
			 ,PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aSelectedTables(*this)
			 ,m_xConnection(pConn)
			 ,m_pSqlRootNode(NULL)
			 ,m_pIterator(NULL)
			 ,m_aSelectedFields(*this, pConn->GetIdentifierCase() == SDB_IC_ALL)
{
	SdbEnvironmentRef xEnv;
	m_pSqlParser = xEnv->GetSqlParser();
	m_pIterator  = new SbaParseIterator(m_pSqlRootNode, m_xConnection);
}

//------------------------------------------------------------------------------
SbaXdbParser::SbaXdbParser(SbaXdbCollection& rCollection, SdbDatabase* pDb, SdbConnection* pConn)
			 :SbaXdbObject(rCollection)
			 ,PropertySetHelper(ComponentHelper::rBHelper)
			 ,m_aSelectedFields(*this, pConn->GetIdentifierCase() == SDB_IC_ALL)
			 ,m_aSelectedTables(*this)
			 ,m_xDatabase(pDb)
			 ,m_xConnection(pConn)
			 ,m_pSqlRootNode(NULL)
			 ,m_pIterator(NULL)
{
	SdbEnvironmentRef xEnv;
	m_pSqlParser = xEnv->GetSqlParser();
	m_pIterator  = new SbaParseIterator(m_pSqlRootNode, m_xDatabase);
}

//------------------------------------------------------------------------------
SbaXdbParser::~SbaXdbParser()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}

	DELETEZ(m_pIterator);
	DELETEZ(m_pSqlRootNode);
}

// OComponentHelper
//------------------------------------------------------------------------------
void SbaXdbParser::disposing()
{
	SbaXdbComponent::disposing();
	PropertySetHelper::disposing();

	::osl::MutexGuard aGuard( /*(Mutex &)*/ComponentHelper::rBHelper.rMutex );
	m_aSelectedFields.disposing();
	m_aSelectedTables.clear();

	DELETEZ(m_pIterator);
	DELETEZ(m_pSqlRootNode);
	m_xConnection = NULL;
	m_xDatabase = NULL;
}

// functions for analysing SQL
//--------------------------------------------------------------------------------------------------
String SbaXdbParser::getColumnName(SdbSqlParseNode* pColumnRef) const
{
	String aTableRange,aColumnName;
	m_pIterator->GetColumnRange(pColumnRef, aColumnName, aTableRange );
	return aColumnName;
}

// functions for analysing SQL
//--------------------------------------------------------------------------------------------------
/*Reference< starbeans::XPropertySet >  SbaXdbParser::getField(SdbSqlParseNode* pColumnRef, const String& aColumnName) const
{
	String aTableRange;
	Reference< starbeans::XPropertySet >  xField;
	m_pIterator->GetColumnTableRange(pColumnRef, aTableRange);
	if (!aTableRange || !aColumnName)
		return xField;

	if (m_aSelectedTables.hasByName(aTableRange))
	{
		Reference< starcontainer::XNameAccess >  xFields(
			(*(Reference< stardata::XDatabaseTable > *)m_aSelectedTables.getByName(aTableRange).get())->getFields());
		if (xFields->hasByName(aColumnName))
			xField = *(Reference< starbeans::XPropertySet > *)xFields->getByName(aColumnName).get();
	}
	return xField;
}*/

//------------------------------------------------------------------------------
sal_Bool
	SbaXdbParser::setORCriteria(
		SdbSqlParseNode* pCondition,
		vector< vector < starbeans::PropertyValue > >& rFilters,
		const Reference< starutil::XNumberFormatter > & xFormatter
	) const
{
	// Runde Klammern um den Ausdruck
	if (pCondition->Count() == 3 &&
		SDB_ISPUNCTUATION(pCondition->GetChild(0),"(") &&
		SDB_ISPUNCTUATION(pCondition->GetChild(2),")"))
	{
		return setORCriteria(pCondition->GetChild(1), rFilters, xFormatter);
	}
	// oder Verknuepfung
	// a searchcondition can only look like this: search_condition SDB_TOKEN_OR boolean_term
	else if (SDB_ISRULE(pCondition,search_condition))
	{
		sal_Bool bResult = sal_True;
		for (int i = 0; bResult && i < 3; i+=2)
		{
			// Ist das erste Element wieder eine OR-Verknuepfung?
			// Dann rekursiv absteigen ...
			//if (!i && SDB_ISRULE(pCondition->GetChild(i),search_condition))
			if (SDB_ISRULE(pCondition->GetChild(i),search_condition))
				bResult = setORCriteria(pCondition->GetChild(i), rFilters, xFormatter);
			else
			{
				rFilters.push_back(vector < starbeans::PropertyValue >());
				bResult = setANDCriteria(pCondition->GetChild(i), rFilters[rFilters.size() - 1], xFormatter);
			}
		}
		return bResult;
	}
	else
	{
		rFilters.push_back(vector < starbeans::PropertyValue >());
		return setANDCriteria(pCondition, rFilters[rFilters.size() - 1], xFormatter);
	}
}

//--------------------------------------------------------------------------------------------------
sal_Bool
	SbaXdbParser::setANDCriteria(
		SdbSqlParseNode * pCondition,
		vector < starbeans::PropertyValue >& rFilter,
		const Reference< starutil::XNumberFormatter > & xFormatter
	) const
{
	// Runde Klammern
	if (SDB_ISRULE(pCondition,boolean_primary))
	{
		// this should not occur
		DBG_ERROR("Primary condition in And-Criteria");
		return sal_False;
	}
	// Das erste Element ist (wieder) eine AND-Verknuepfung
	else if ( SDB_ISRULE(pCondition,boolean_term) && pCondition->Count() == 3 )
	{
		return setANDCriteria(pCondition->GetChild(0), rFilter, xFormatter) &&
			   setANDCriteria(pCondition->GetChild(2), rFilter, xFormatter);
	}
	else if (SDB_ISRULE(pCondition, comparison_predicate))
	{
		return setComparsionPredicate(pCondition,rFilter,xFormatter);
	}
	else if (SDB_ISRULE(pCondition,like_predicate) ||
			 SDB_ISRULE(pCondition,test_for_null) ||
			 SDB_ISRULE(pCondition,in_predicate) ||
			 SDB_ISRULE(pCondition,all_or_any_predicate) ||
			 SDB_ISRULE(pCondition,between_predicate))
	{
		if (SDB_ISRULE(pCondition->GetChild(0), column_ref))
		{
			starbeans::PropertyValue aItem;
			String aValue;
			String aColumnName;
			pCondition->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
			pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

			// don't display the column name
			aValue.Erase(0, aColumnName.Len());
			aValue.EraseLeadingChars();

			aItem.Name = getColumnName(pCondition->GetChild(0));
			aItem.Value <<= ::rtl::OUString(aValue);
			rFilter.push_back(aItem);
		}
		else
			return sal_False;
	}
	else if (SDB_ISRULE(pCondition,existence_test) ||
			 SDB_ISRULE(pCondition,unique_test))
	{
		// this couldn't be handled here, too complex
		// as we need a field name
		return sal_False;
	}
	else
		return sal_False;

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool
	SbaXdbParser::setComparsionPredicate(
		SdbSqlParseNode * pCondition,
		vector < starbeans::PropertyValue >& rFilter,
		const Reference< starutil::XNumberFormatter > & xFormatter
	) const
{
	DBG_ASSERT(SDB_ISRULE(pCondition, comparison_predicate),"setComparsionPredicate: pCondition ist kein ComparsionPredicate");
	if (SDB_ISRULE(pCondition->GetChild(0), column_ref) ||
		SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref))
	{
		starbeans::PropertyValue aItem;
		String aValue;
		sal_uInt16 nPos;
		if (SDB_ISRULE(pCondition->GetChild(0), column_ref))
		{
			nPos = 0;
			sal_uInt16 i=1;

			// don't display the equal
			if (pCondition->GetChild(i)->GetNodeType() == SDB_SQL_EQUAL)
				i++;

			// go forward
			for (;i < pCondition->Count();i++)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		}
		else if (SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref))
		{
			nPos = pCondition->Count()-1;

			sal_uInt16 i = pCondition->Count() - 2;
			// don't display the equal
			if (pCondition->GetChild(i)->GetNodeType() == SDB_SQL_EQUAL)
				i--;

			// go backward
			for (; i >= 0; i--)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		}
		else
			return sal_False;

		aItem.Name = getColumnName(pCondition->GetChild(nPos));
		aItem.Value <<= ::rtl::OUString(aValue);
		rFilter.push_back(aItem);
	}
	else if (SDB_ISRULE(pCondition->GetChild(0), set_fct_spec ) ||
			 SDB_ISRULE(pCondition->GetChild(0), general_set_fct))
	{
		starbeans::PropertyValue aItem;
		String aValue;
		String aColumnName;
		pCondition->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());
		pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		// don't display the column name
		aValue.Erase(0, aColumnName.Len());
		aValue.EraseLeadingChars();

		aItem.Name = getColumnName(pCondition->GetChild(0));
		aItem.Value <<= ::rtl::OUString(aValue);
		rFilter.push_back(aItem);
	}
	else // kann sich nur um einen Expr. Ausdruck handeln
	{
		starbeans::PropertyValue aItem;
		String aName, aValue;

		SdbSqlParseNode *pLhs = pCondition->GetChild(0);
		SdbSqlParseNode *pRhs = pCondition->GetChild(2);

		// Feldnamen
		sal_uInt16 i;
		for (i=0;i< pLhs->Count();i++)
			 pCondition->GetChild(i)->ParseNodeToPredicateStr(aName,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		// Kriterium
		aValue = pCondition->GetChild(1)->TokenValue();
		for(i=0;i< pRhs->Count();i++)
			pCondition->GetChild(i)->ParseNodeToPredicateStr(aValue,m_xConnection->GetMetaData(), xFormatter, Application::GetAppInternational());

		aItem.Name = aName;
		aItem.Value <<= ::rtl::OUString(aValue);
		rFilter.push_back(aItem);
	}
	return sal_True;
}

// PropertySetHelper
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
void SbaXdbParser::fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	typedef Sequence< Sequence<starbeans::PropertyValue> >	UFilterSequence;
	using starcontainer::XNameAccess;
	using starbeans::Property;
	using starbeans::PropertyAttribute::TRANSIENT;
	using starbeans::PropertyAttribute::READONLY;

	aProperties.realloc(3);
	sal_Int32 nPos = 0;
	aProperties[nPos++] = Property(SBA_OLD_PROPERTY(FILTER),			PROP_TYPE(UFilterSequence),	TRANSIENT | READONLY);
	aProperties[nPos++] = Property(SBA_OLD_PROPERTY(SELECTED_FIELDS),	IFACE_PROP(XNameAccess),	TRANSIENT | READONLY);
	aProperties[nPos++] = Property(SBA_OLD_PROPERTY(SELECTED_TABLES),	IFACE_PROP(XNameAccess),	TRANSIENT | READONLY);
	DBG_ASSERT(nPos == aProperties.getLength(),"SbaXdbParser::fillPropertyInfo : forgot to adjust the count ?");
}


//------------------------------------------------------------------------------
sal_Bool SbaXdbParser::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException )
{
	DBG_ERROR("unknown Property");
	return sal_False;
}

//------------------------------------------------------------------------------
void SbaXdbParser::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw (staruno::Exception)
{
	DBG_ERROR("unknown Property");
}

//------------------------------------------------------------------------------
void SbaXdbParser::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{

	SbaXdbParser* pTHIS = const_cast<SbaXdbParser*>(this);
	checkOpen();
	switch (nHandle)
	{
		case PROP_SELECTED_TABLES:
		{
			Reference< starcontainer::XNameAccess >
				xNameAccess( static_cast<starcontainer::XNameAccess*>(&pTHIS->m_aSelectedTables) );

			rValue <<= xNameAccess;
		}	break;
		case PROP_SELECTED_FIELDS:
		{
			Reference< starcontainer::XNameAccess >
				xNameAccess( static_cast<starcontainer::XNameAccess*>(&pTHIS->m_aSelectedFields) );

			rValue <<= xNameAccess;
		}	break;
		case PROP_FILTER:
		{
			Sequence< Sequence<starbeans::PropertyValue> > aFilterSeq;
			if (m_aCurrentFilter.Len())
			{
				String aSql(m_aWorkSql);
				// build a temporary parse node
				SdbSqlParseNode* pTempNode = m_pSqlRootNode;
				pTHIS->m_pSqlRootNode = NULL;

				aSql += STR_WHERE;
				aSql += m_aCurrentFilter;
				pTHIS->resetIterator(aSql);

				if (m_pSqlRootNode)
				{
					// normalize the filter
					SdbSqlParseNode* pNode = m_pSqlRootNode->GetChild(3)->GetChild(1)->GetChild(1);
					SdbSqlParseNode::NegateSearchCondition(pNode);

					pNode = m_pSqlRootNode->GetChild(3)->GetChild(1)->GetChild(1);
					SdbSqlParseNode::DisjunctiveNormalForm(pNode);

					pNode = m_pSqlRootNode->GetChild(3)->GetChild(1)->GetChild(1);
					SdbSqlParseNode::Absorptions(pNode);

					pNode = m_pSqlRootNode->GetChild(3)->GetChild(1)->GetChild(1);
					SdbSqlParseNode::Compress(pNode);

					pNode = m_pSqlRootNode->GetChild(3)->GetChild(1);
					// do we have a where clause then look for the conditions
					pNode = pNode ? pNode->GetChild(1) : NULL;
					if (pNode)
					{
						vector< vector < starbeans::PropertyValue > > aFilters;
						Reference< starutil::XNumberFormatsSupplier >
							xFormatSupplier(pTHIS->getParent(), UNO_QUERY);

						Reference< starutil::XNumberFormatter >
							xFormatter(getXdbContext().getServiceManager()
										->createInstance(::rtl::OUString::createFromAscii("com.sun.star.util.NumberFormatter")), UNO_QUERY);

						xFormatter->attachNumberFormatsSupplier(xFormatSupplier);

						if (setORCriteria(pNode, aFilters, xFormatter))
						{
							aFilterSeq.realloc(aFilters.size());
							Sequence<starbeans::PropertyValue>* pFilters = aFilterSeq.getArray();
							for (vector< vector < starbeans::PropertyValue > >::const_iterator i = aFilters.begin();
								 i != aFilters.end();
								 i++)
							{
								const vector < starbeans::PropertyValue >& rProperties = *i;
								pFilters->realloc(rProperties.size());
								starbeans::PropertyValue* pFilter = pFilters->getArray();
								for (vector < starbeans::PropertyValue >::const_iterator j = rProperties.begin();
									 j != rProperties.end();
									 j++)
								{
									*pFilter = *j;
									pFilter++;
								}
								pFilters++;
							}
						}
					}
					delete pTHIS->m_pSqlRootNode;
				}
				// restore
				pTHIS->m_pSqlRootNode = pTempNode;
				pTHIS->m_pIterator->SetParseTree(m_pSqlRootNode);
			}
			rValue <<= aFilterSeq;
		}	break;
		default:
			DBG_ERROR("unknown Property");
	}
}

// stardata::XDatabaseDialogs
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::executeFilter(const Reference< starcontainer::XNamed > & rField)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( /*(Mutex &)*/ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pIterator->GetSdbTableRangeMap().Count())
		return;

	SdbTableRef xTable = *m_pIterator->GetSdbTableRangeMap().GetObject(0);

	// OriginalFilter nicht mit darstellen
	String aOldFilter = m_aOrigFilter;
	if (aOldFilter.Len())
	{
		m_aOrigFilter.Erase();
		setFilter(m_aCurrentFilter);
	}

	String aFieldName;
	ODbVariantRef xVar;
	if (rField.is())
	{
		const SdbColumn* pCol = m_pIterator->GetCol(rField->getName());
		if (!pCol)
			return;

		aFieldName = (const sal_Unicode*)rField->getName();
		Reference< starbeans::XPropertySet >  xField(rField, UNO_QUERY);
		if (xField.is())
		{
			SbaXdbField* pField = new SbaXdbRecordField(xField);
			pField->acquire();
			xVar = pField->m_xValue;
			pField->release();
		}
	}

	DlgFilterCrit aFilterDlg((Window*)Application::GetDefDialogParent(), m_pIterator, xTable->Columns(), xVar, aFieldName);
	if (aFilterDlg.Execute())
	{
		m_aOrigFilter = aOldFilter;
		setFilter(aFilterDlg.BuildWherePart());
	}
	else
	{
		m_aOrigFilter = aOldFilter;
		setFilter(m_aCurrentFilter);
	}
}
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::executeSort(const Reference< starcontainer::XNamed > & rField)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( /*(Mutex &)*/ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pIterator->GetSdbTableRangeMap().Count())
		return;

	SdbTableRef xTable = *m_pIterator->GetSdbTableRangeMap().GetObject(0);

	// OriginalSort nicht mit darstellen
	String aOldOrder = m_aOrigOrder;
	if (aOldOrder.Len())
	{
		m_aOrigOrder.Erase();
		setSort(m_aCurrentOrder);
	}

	DlgOrderCrit aOrderDlg((Window*)Application::GetDefDialogParent(), *m_pIterator, xTable->Columns());
	if (aOrderDlg.Execute())
	{
		m_aOrigOrder = aOldOrder;
		setSort(aOrderDlg.BuildOrderPart());
	}
	else
	{
		m_aOrigOrder = aOldOrder;
		setSort(m_aCurrentOrder);
	}
}

// Helper
//------------------------------------------------------------------------------
void SbaXdbParser::reset()
{
	m_aOrigSql = m_aOrigFilter = m_aOrigOrder = m_aWorkSql = m_aCurrentFilter = m_aCurrentOrder = String();
	DELETEZ(m_pSqlRootNode);

	m_pIterator->SetParseTree(m_pSqlRootNode);
}

//------------------------------------------------------------------------------
void SbaXdbParser::resetIterator(const String& aSql)
{
	String aQuery(aSql);
	String aErrorMsg;
	aQuery += m_pIterator->BuildPart(SbaParseIterator::HAVING, sal_True);
	aQuery += m_pIterator->BuildPart(SbaParseIterator::GROUP_BY, sal_True);

	delete m_pSqlRootNode;
	m_pSqlRootNode = m_pSqlParser->ParseTree(aErrorMsg, aQuery);
	m_pIterator->SetParseTree(m_pSqlRootNode);
}

// stardata::XDatabaseQueryComposer
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbParser::getQuery(void)
	throw( staruno::RuntimeException )
{
	return m_aOrigSql;
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbParser::getFilter(void)
	throw( staruno::RuntimeException )
{
	return m_aCurrentFilter;
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbParser::getSort(void)
	throw( staruno::RuntimeException )
{
	return m_aCurrentOrder;
}

//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbParser::getComposedQuery(void)
	throw( staruno::RuntimeException )
{
	if (m_pSqlRootNode)
	{
		String aResult;
		m_pSqlRootNode->ParseNodeToStr(aResult,m_xConnection->GetMetaData());
		return aResult;
	}
	else
		return getQuery();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::setQuery(const ::rtl::OUString& aStatement)
	throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( /*(Mutex &)*/ComponentHelper::rBHelper.rMutex );
	checkOpen();

	m_aOrigSql = (const sal_Unicode*)aStatement;
	delete m_pSqlRootNode;

	// ParseTree aufbauen
	String aErrorMsg;
	m_pSqlRootNode = m_pSqlParser->ParseTree(aErrorMsg, m_aOrigSql);
	m_pIterator->SetParseTree(m_pSqlRootNode);

	if (!m_pSqlRootNode)
	{
		reset();
		throw starlang::IllegalArgumentException( aErrorMsg, *this, 0);
	}
	else if (m_pIterator->StatementType() != SDB_STATEMENT_SELECT || SDB_ISRULE(m_pSqlRootNode,union_statement))
	{
		reset();
		throw starlang::IllegalArgumentException(aStatement, *this, 0);
	}

	m_aWorkSql = STR_SELECT;
	m_aWorkSql += m_pIterator->BuildColumnPart();
	m_aWorkSql += STR_FROM;
	m_aWorkSql += m_pIterator->BuildTablePart();

	m_aOrigFilter = m_pIterator->BuildPart(SbaParseIterator::WHERE, sal_False);
	m_aOrigOrder  = m_pIterator->BuildPart(SbaParseIterator::ORDER_BY, sal_False);			;

	m_aCurrentFilter = m_aCurrentOrder = String();

	m_aSelectedTables.clear();
	m_aSelectedFields.reset();
	m_aSelectedFields.constructQueryDescriptionFields(m_pIterator->GetSelectColumns());
	m_aSelectedTables.construct(m_pIterator);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::setFilter(const ::rtl::OUString& aFilter)
	throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT)
	{
		throw(starlang::IllegalArgumentException(aFilter, *this, 0));
	}

	String aSql(m_aWorkSql);
	if (m_aOrigFilter.Len())
	{
		aSql += STR_WHERE;
		aSql += m_aOrigFilter;
	}

	m_aCurrentFilter = (const sal_Unicode*)aFilter;
	if (m_aCurrentFilter.Len())
	{
		if (m_aOrigFilter.Len())
			aSql += STR_AND;
		else
			aSql += STR_WHERE;
		aSql += m_aCurrentFilter;
	}

	if (m_aOrigOrder.Len())
	{
		aSql += STR_ORDER_BY;
		aSql += m_aOrigOrder;
	}

	if (m_aCurrentOrder.Len())
	{
		if (m_aOrigOrder.Len())
			aSql += ',';
		else
			aSql += STR_ORDER_BY;
		aSql += m_aCurrentOrder;
	}
	resetIterator(aSql);
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::setSort(const ::rtl::OUString& aSort)
	throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT)
	{
		throw(starlang::IllegalArgumentException(aSort, *this, 0));
	}

	String aSql(m_aWorkSql);
	if (m_aOrigFilter.Len())
	{
		aSql += STR_WHERE;
		aSql += m_aOrigFilter;
	}

	if (m_aCurrentFilter.Len())
	{
		if (m_aOrigFilter.Len())
			aSql += STR_AND;
		else
			aSql += STR_WHERE;
		aSql += m_aCurrentFilter;
	}

	if (m_aOrigOrder.Len())
	{
		aSql += STR_ORDER_BY;
		aSql += m_aOrigOrder;
	}

	m_aCurrentOrder = (const sal_Unicode*)aSort;
	if (m_aCurrentOrder.Len())
	{
		if (m_aOrigOrder.Len())
			aSql += ',';
		else
			aSql += STR_ORDER_BY;
		aSql += m_aCurrentOrder;
	}

	resetIterator(aSql);
}

void SAL_CALL SbaXdbParser::appendFilterByField(const Reference< starcontainer::XNamed > & rField)
	throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT || !rField.is())
	{
		throw starlang::IllegalArgumentException(::rtl::OUString(), *this, 0);
	}

	SbaXdbField* pField = NULL;
	if (rField.is())
	{
		Reference< starbeans::XPropertySet >  xField(rField, UNO_QUERY);
		if (xField.is())
		{
			pField = new SbaXdbRecordField(xField);
			pField->acquire();
		}
	}

	if (!pField)
	{
		if (pField)
			pField->release();
		throw starlang::IllegalArgumentException(::rtl::OUString(), *this, 0);
	}

	Reference< staruno::XInterface >  xParent(*getXdbParent());

	sal_Int16 nSearchFlags;
	pField->SbaXdbField::PropertySetHelper::getFastPropertyValue(PROP_SEARCHINFO) >>= nSearchFlags;
	if (nSearchFlags == DatabaseSearch::NONE)
	{
		if (pField)
			pField->release();
//		throw(starlang::IllegalArgumentException(::rtl::OUString(), *this, 0));
		return;
	}

	ODbVariantRef xVar= pField->m_xValue;

	String sName = rField->getName();
	const SdbColumn* pCol = m_pIterator->GetCol(sName);
	if (!pCol)
	{
		if (pField)
			pField->release();
		SdbStatus aStatus;
		String sMessage(SbaResId(SBA_PARSER_INVALID_FIELD));
		while (sMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		String sDetailedMessage(SbaResId(SBA_PARSER_INVALID_FIELD_DETAILED));
		while (sDetailedMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("S1000"), sMessage, 0, sDetailedMessage);
		checkDBResult(aStatus, *(this), sal_False);
		return;
	}

	SbaPredicateItemList aList;
	SbaPredicateItem* pItem = new SbaPredicateItem;
	// Init LogTyp und Feldname
	pItem->aFieldName	= pCol->GetRealName();
		// use the real name (not rField->getName) : some databases (at least oterro, adabas) won't accept a statement
		// like "select <field> as alias where alias = <value>"
		// FS - 05.01.00 - 71368
	pItem->eLogType		= SBA_LOG_INVALID;

	// Init Typ
	if (xVar->isNull())
		pItem->eType = SDB_PRED_ISNULL;
	else if (nSearchFlags == DatabaseSearch::NONE)
		pItem->eType = SDB_PRED_ISNOTNULL;
	else if (nSearchFlags == DatabaseSearch::CHAR)
		pItem->eType = SDB_PRED_LIKE;
	else
		pItem->eType = SDB_PRED_EQUAL;

	sal_Int16 nFieldType;
	pField->SbaXdbField::PropertySetHelper::getFastPropertyValue(PROP_TYPE) >>= nFieldType;

	SbaXdbConnection* pConnection = NULL;

	SbaXdbDatabase* pDatabase = 0;

	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel(xParent,::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		pDatabase = (SbaXdbDatabase*)xTunnel->getSomething(SbaXdbDatabase:: getUnoTunnelImplementationId());
		if(!pDatabase)
		{
			::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel2(xParent,::com::sun::star::uno::UNO_QUERY);
			if(xTunnel2.is())
			{
				pConnection = (SbaXdbConnection*)xTunnel2->getSomething(SbaXdbConnection:: getUnoTunnelImplementationId());
			}
		}
	}


	DBG_ASSERT(pDatabase || pConnection, "SbaXdbParser::appendFilterByField(:::) unknown Parent");

	pItem->eVarType = (SdbDatabaseType)nFieldType;
	switch (nFieldType)
	{
		case DatabaseFieldType::DATETIME:
		case DatabaseFieldType::DATE:
		case DatabaseFieldType::TIME:
			// quote the field
			pItem->aValue	= SdbTools::SQLString( pItem->eVarType, *xVar, sal_True);
			break;
		default:
			pItem->aValue	= SdbTools::SQLString( pItem->eVarType, *xVar, sal_False );
	}

	// like nur bis max. 255 Zeichen
	if (pItem->eType == SDB_PRED_LIKE && pItem->aValue.Len() > 255)
	{
		pItem->aValue.Erase(254);
		pItem->aValue += '%';
	}

	aList.Insert(pItem, LIST_APPEND);

	// filter anhaengen
	// select ohne where und order by aufbauen
	String aSql(m_aWorkSql);

	String aOldFilter(m_pIterator->BuildPart(SbaParseIterator::WHERE, sal_False));
	String aAppendFilter(m_pIterator->BuildWherePart(aList));

	if (aOldFilter.Len()) // bisherigen filter setzen
	{
		aSql += STR_WHERE;
		aSql += aOldFilter;
	}

	if (aAppendFilter.Len()) // neuen filter setzen
	{
		if (aOldFilter.Len())
			aSql += STR_AND;
		else
			aSql += STR_WHERE;
		aSql += aAppendFilter;
	}

	aSql += m_pIterator->BuildPart(SbaParseIterator::ORDER_BY, sal_True);
	delete pItem;

	if (m_aCurrentFilter.Len() && aAppendFilter.Len())
		m_aCurrentFilter += STR_AND;
	m_aCurrentFilter += aAppendFilter;

	resetIterator(aSql);

	if (pField)
		pField->release();
}
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbParser::appendSortByField(const Reference< starcontainer::XNamed > & aField, sal_Bool Ascending)
	throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( /*(Mutex &)*/ComponentHelper::rBHelper.rMutex );
	checkOpen();

	if (!m_pSqlRootNode || m_pIterator->StatementType() != SDB_STATEMENT_SELECT || !aField.is())
	{
		throw starlang::IllegalArgumentException(::rtl::OUString(), *this, 0);
	}

	// ORDER BY festlegen
	SbaOrderItemList	aList;
	SbaOrderItem		*pItem = new SbaOrderItem;

	String sName = aField->getName();
	const SdbColumn* pCol = m_pIterator->GetCol(sName);
	if (!pCol)
	{
		delete pItem;

		SdbStatus aStatus;
		String sMessage(SbaResId(SBA_PARSER_INVALID_FIELD));
		while (sMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		String sDetailedMessage(SbaResId(SBA_PARSER_INVALID_FIELD_DETAILED));
		while (sDetailedMessage.SearchAndReplaceAscii("$name$", sName) != STRING_NOTFOUND)
			;
		aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("S1000"), sMessage, 0, sDetailedMessage);
		checkDBResult(aStatus, *this, sal_False);
		return;
	}

	// some databases (at least oterro) won't accept a statement like "select <field> as alias order by alias",
	// so we may have to use the real name of the column
	// FS - 05.01.00 - 71368
	sal_Bool bUseRealName = sal_False;
	Reference< stardata::XDatabaseDescriptor >  xMD = m_xConnection.Is() ? m_xConnection->GetMetaData() : Reference< stardata::XDatabaseDescriptor > ();
	if (xMD.is())
		bUseRealName = xMD->isCapable(stardata::DatabaseCapability::EXPRESSION_ORDERBY);
		// sal_True -> no matter if the real name is an expression or not, the connection can handle it

	if (!bUseRealName)
	{	// the connection can't handle expressions within order clauses -> check if the column is an expression
		if (!pCol->GetColumnInfo().bFunction)
			// no : we may use the real name
			bUseRealName = sal_True;
	}

	if (bUseRealName)
		pItem->aFieldName = pCol->GetRealName();
	else
		pItem->aFieldName = (const sal_Unicode*)aField->getName();
		// if expressions within order by clauses aren't allowed we use the alias and the realname is an expression

	pItem->bDirection = !Ascending;
	aList.Insert( pItem, LIST_APPEND );

	// filter anhaengen
	// select ohne where und order by aufbauen
	String aSql(m_aWorkSql);
	aSql += m_pIterator->BuildPart(SbaParseIterator::WHERE, sal_True);

	String aOldOrder(m_pIterator->BuildPart(SbaParseIterator::ORDER_BY, sal_False));
	String aAppendOrder(m_pIterator->BuildOrderPart(aList));

	if (aOldOrder.Len())
	{
		aSql += STR_ORDER_BY;
		aSql += aOldOrder;
	}

	if (aAppendOrder.Len()) // neuen filter setzen
	{
		if (aOldOrder.Len())
			aSql += ',';
		else
			aSql += STR_ORDER_BY;
		aSql += aAppendOrder;
	}

	delete pItem;

	if (m_aCurrentOrder.Len() && aAppendOrder.Len())
		m_aCurrentOrder += ',';
	m_aCurrentOrder += aAppendOrder;
	resetIterator(aSql);
}


