/*************************************************************************
 *
 *  $RCSfile: sbadbrel.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBREL_HXX
#include "sbadbrel.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif

#ifndef _SDB_SDBCONN_HXX
#include <sdb/sdbconn.hxx>
#endif

#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif

#ifndef _UTL_CONTAINER_HXX_
#include <unotools/container.hxx>
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

using staruno::Any;
using staruno::Sequence;
using staruno::Reference;

namespace DatabaseKeyRule = stardata::DatabaseKeyRule;

//------------------------------------------------------------------------------
SbaXdbRelation::SbaXdbRelation(sal_Bool bCase)
			:SbaXdbObject()
			,PropertySetHelper(ComponentHelper::rBHelper)
			,m_aFields(*this, bCase)
			,m_nUpdateRule(DatabaseKeyRule::NO_ACTION)
			,m_nDeleteRule(DatabaseKeyRule::NO_ACTION)
{}

//------------------------------------------------------------------------------
SbaXdbRelation::SbaXdbRelation(SbaXdbCollection& rCollection, SdbRelation* pRelationDef, sal_Bool bCase)
			:SbaXdbObject(rCollection)
			,PropertySetHelper(ComponentHelper::rBHelper)
			,m_aFields(*this, bCase)
			,m_xRelation(pRelationDef)
			,m_nUpdateRule(DatabaseKeyRule::NO_ACTION)
			,m_nDeleteRule(DatabaseKeyRule::NO_ACTION)
{
	if (m_xRelation)
	{
		SdbColumnsRef xCols = m_xRelation->GetColumns();
		m_aFields.setRelDefinitions(xCols);

		m_nUpdateRule = m_xRelation->GetUpdateRules();
		m_nDeleteRule = m_xRelation->GetDeleteRules();
		m_aTableName = m_xRelation->GetTableName();
		m_aRefTableName = m_xRelation->GetForeignTableName();
	}
}

//------------------------------------------------------------------------------
SbaXdbRelation::~SbaXdbRelation()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}
using namespace ::cppu;
using namespace ::osl;
// -------------------------------------------------------------------------
::com::sun::star::uno::Sequence< sal_Int8 > SbaXdbRelation::getUnoTunnelImplementationId()
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbRelation::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return SbaXdbObject::getSomething(rId);
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbRelation::disposing()
{
	::osl::MutexGuard aGuard( m_aMutex );
	SbaXdbObject::disposing();
	PropertySetHelper::disposing();

	m_aFields.disposing();
	m_xRelation = NULL;
}

// starcontainer::XNamed
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbRelation::getName(void)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	return isOpen() ?::rtl::OUString(m_xRelation->GetName()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbRelation::setName(const ::rtl::OUString& _rName)
	throw( staruno::RuntimeException  )
{
	//Not allowed: throw(starlang::NoSupportException());
	throw staruno::RuntimeException();
}

// stardata::XDatabaseFieldsSupplier
//------------------------------------------------------------------------------
Reference< starcontainer::XNameAccess > SAL_CALL SbaXdbRelation::getFields(void)
	throw( staruno::RuntimeException  )
{
	return &m_aFields;
}

//------------------------------------------------------------------------------
void SbaXdbRelation::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	using starbeans::PropertyAttribute::READONLY;
	SBA_BEGIN_PROPERTY_HELPER( aProperties, 5)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(DELETERULE),	PROP_TYPE(sal_Int16),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),			PROP_TYPE(OUString),	READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(REFTABLENAME),	PROP_TYPE(OUString),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(TABLENAME),		PROP_TYPE(OUString),	0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(UPDATERULE),	PROP_TYPE(sal_Int16),	0);
	SBA_END_PROPERTY_HELPER();
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbRelation::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue,
											sal_Int32 nHandle, const Any& rValue )
	throw( starlang::IllegalArgumentException  )
{
	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_DELETERULE:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nDeleteRule);
			break;
		case PROP_UPDATERULE:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nUpdateRule);
			break;
		case PROP_REFTABLENAME:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_aRefTableName);
			break;
		case PROP_TABLENAME:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_aTableName);
			break;
		default:
			DBG_ERROR("unknown Porperty");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbRelation::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue )
	throw (staruno::Exception)
{
	switch (nHandle)
	{
		case PROP_DELETERULE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nDeleteRule;
			break;
		case PROP_UPDATERULE:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nUpdateRule;
			break;
		case PROP_REFTABLENAME:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aRefTableName;
			break;
		case PROP_TABLENAME:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aTableName;
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbRelation::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_DELETERULE:
			rValue <<= m_nDeleteRule;
			break;
		case PROP_UPDATERULE:
			rValue <<= m_nUpdateRule;
			break;
		case PROP_REFTABLENAME:
			rValue <<= m_aRefTableName;
			break;
		case PROP_TABLENAME:
			rValue <<= m_aTableName;
			break;
		case PROP_NAME:
			rValue <<= const_cast<SbaXdbRelation*>(this)->getName();
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbRelation::setObject(const SdbRelationRef& xDef)
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );

	xDef->SetDeleteRules(m_nDeleteRule);
	xDef->SetUpdateRules(m_nUpdateRule);
	xDef->SetTableName(m_aTableName);
	xDef->SetForeignTableName(m_aRefTableName);

	// setzen der Columns
	sal_uInt32 nCount = m_aFields.getCount();
	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SbaXdbField* pField = m_aFields[i];
		SdbColumnRef xCol = pField->createColumn(xDef->GetConnection());

		SdbColumn* pCol = xDef->CreateColumn(*xCol, pField->m_aRefName);
		xDef->GetColumns()->AddColumn(pCol);
	}

	if (xDef->Update())
		m_xRelation = xDef;
	else
		checkDBResult(xDef->Status(), *this);
}

//------------------------------------------------------------------------------
SbaXdbRelations::SbaXdbRelations(SbaXdbObjectCreator& _rParent)
: SbaXdbNamedCollection(_rParent, dbRelation,
						::getCppuType(static_cast<const Reference< starbeans::XPropertySet >*>(0)) )
{
}

// stardata::XDatabaseRelationFactory
//------------------------------------------------------------------------------
Reference< starbeans::XPropertySet >  SbaXdbRelations::create(void)
			throw( staruno::RuntimeException )
{
	checkOpen();
	return new SbaXdbRelation(getXdbCreator()->isCaseSensitive());
}

// helper methods
//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbRelations::doGet(SdbObj* pObj) const
			throw( stardata::DatabaseException, staruno::RuntimeException )
{
	SbaXdbRelation* pXObj = NULL;

	// Dokument schon geoeffnet
	sal_uInt32 nCount = size();
	sal_uInt32 i;
	for (i = 0; i < nCount; i++)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getObject(i),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbRelation*)xTunnel->getSomething(SbaXdbRelation::getUnoTunnelImplementationId());
		}
		//	utl::getImplementation(pXObj, getObject(i));

		if (pXObj && pObj == &pXObj->m_xRelation)
			break;
	}

	if (i == nCount)
		pXObj = new SbaXdbRelation(*(SbaXdbRelations*)this, (SdbRelation*)pObj, getXdbCreator()->isCaseSensitive());

	return pXObj;
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbRelations::doRemove(SbaXdbObject* pObj)
			throw( stardata::DatabaseException, staruno::RuntimeException )
{
	SbaXdbRelation* pXObj = (SbaXdbRelation*)pObj;

	if (!pXObj->m_xRelation->Drop())
		checkDBResult(pXObj->m_xRelation->Status(), *this, sal_True);
	return sal_True;
}

//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbRelations::doInsert(const ::rtl::OUString& Name, const Any& Element)
			throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )
{
	// Ist es ein bekanntes objekt
	SbaXdbRelation* pXObj = 0;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel;
	Element >>= xTunnel;
	if(xTunnel.is())
	{
		pXObj = (SbaXdbRelation*)xTunnel->getSomething(SbaXdbRelation::getUnoTunnelImplementationId());
	}
	//	utl::getImplementation(pXObj,Element);

	DBG_ASSERT(pXObj, "SbaXdbRelations::doInsert for invalid element");

	// bereits in einem Container enthalten?
	if (!pXObj || pXObj->getXdbParent())
	{
		throw starlang::IllegalArgumentException();
	}

	SdbObj* pObj = NULL;

	try
	{
		pObj = getXdbCreator()->createObject(m_eObj, Name);
	}
	catch (stardata::DatabaseException& e)
	{
		throw starlang::WrappedTargetException(::rtl::OUString(), *this, staruno::makeAny(e) );
	}

	SdbRelationRef xIdx = (SdbRelation*)pObj;
	pXObj->setObject(xIdx);
	return pXObj;
}

// starcontainer::XNameContainer
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbRelations::insertByName(const ::rtl::OUString& Name, const Any& Element)
		throw(	starlang::IllegalArgumentException, starcontainer::ElementExistException,
				starlang::WrappedTargetException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	// Existiert schon ein element mit diesem Namen
	if (hasByName(Name))
	{
		throw starcontainer::ElementExistException();
	}

	SbaXdbRelation* pObj = (SbaXdbRelation*)doInsert(Name, Element);

	// Object gehoert bereits einem Container an
	if (pObj && pObj->isOpen())
	{
		throw starlang::IllegalArgumentException();
	}

	if (pObj)
	{
		appendObject(pObj);
		pObj->setXdbParent(getXdbParent());

		starcontainer::ContainerEvent aEvt( *this,
											staruno::makeAny(pObj->getName()),
											pObj->queryInterface(m_aElementType),
											staruno::Any() );

		NOTIFY_LISTENERS(m_aContainerListeners, starcontainer::XContainerListener, elementInserted, aEvt);
	}
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbRelations::replaceByName(const ::rtl::OUString& Name, const Any& Element)
		throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_rParent.getMutex() );
	checkOpen();

	SbaXdbRelation* pObj = (SbaXdbRelation*)get(Name);
	if (doRemove(pObj))
	{
		staruno::Any aReplaced = pObj->queryInterface(m_aElementType);

		SbaXdbRelation* pOldObj = pObj;
		removeObject(pObj);

		pObj = (SbaXdbRelation*)doInsert(Name, Element);

		// Object gehoert bereits einem Container an
		if (pObj && pObj->isOpen())
		{
			throw starlang::IllegalArgumentException();
		}

		appendObject(pObj);
		pObj->setXdbParent(getXdbParent());

		starcontainer::ContainerEvent aEvt( *this,
											staruno::makeAny(pObj->getName()),
											pObj->queryInterface(m_aElementType),
											aReplaced );

		NOTIFY_LISTENERS(m_aContainerListeners, starcontainer::XContainerListener, elementReplaced, aEvt);


		pOldObj->dispose();
	}
}


















