/*************************************************************************
 *
 *  $RCSfile: sbadbtbl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBTBL_HXX
#include "sbadbtbl.hxx"
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _SBA_SBADBDAT_HXX
#include <sbadbdat.hxx>
#endif

#ifndef _SBA_SBADBCON_HXX
#include <sbadbcon.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen wg. SfxStringItem
#include <svtools/stritem.hxx>
#endif

#ifndef _UTL_PROPERTY_HXX_
#include <unotools/property.hxx>
#endif

#ifndef _UTL_CONTAINER_HXX_
#include <unotools/container.hxx>
#endif

#ifndef _SBA_UNOPROPMACROS_HXX
#include "sbautl/unopropertymacros.hxx"
#endif

using staruno::Any;
using staruno::Sequence;
using staruno::Reference;

//------------------------------------------------------------------------------
SbaXdbTable_Impl::SbaXdbTable_Impl(sal_Bool bCase)
			:SbaXdbObjectCreator(bCase)
			,PropertySetHelper(ComponentHelper::rBHelper)
			,m_aFields(*this, bCase)
			,m_aIndexes(*this)
			,m_aRefreshListeners(m_aMutex)
			,m_nPrivileges(0)
{}

//------------------------------------------------------------------------------
SbaXdbTable_Impl::SbaXdbTable_Impl(SbaXdbCollection& rCollection, sal_Bool bCase)
			:SbaXdbObjectCreator(rCollection, bCase)
			,PropertySetHelper(ComponentHelper::rBHelper)
			,m_aFields(*this, bCase)
			,m_aIndexes(*this)
			,m_aRefreshListeners(m_aMutex)
			,m_nPrivileges(0)
{}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbTable_Impl::disposing()
{
	SbaXdbObjectCreator::disposing();
	OPropertySetHelper::disposing();

 starlang::EventObject aEvt(*this);
	m_aRefreshListeners.disposeAndClear(aEvt);

	m_aFields.disposing();
	m_aIndexes.disposing();
}

// stardata::XDatabaseFieldsSupplier
//------------------------------------------------------------------------------
Reference< starcontainer::XNameAccess > SAL_CALL SbaXdbTable_Impl::getFields(void) throw( staruno::RuntimeException )
{
	return &m_aFields;
}

// stardata::XDatabaseTable
//------------------------------------------------------------------------------
Reference< starcontainer::XNameContainer > SAL_CALL SbaXdbTable_Impl::getIndexes(void) throw( staruno::RuntimeException )
{
	return &m_aIndexes;
}

// starutil::XRefreshable
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTable_Impl::addRefreshListener(const Reference< starutil::XRefreshListener > & l)
	throw( staruno::RuntimeException )
{
	m_aRefreshListeners.addInterface(l);
}
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTable_Impl::removeRefreshListener(const Reference< starutil::XRefreshListener > & l)
	throw( staruno::RuntimeException )
{
	m_aRefreshListeners.removeInterface(l);
}


// PropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbTable_Impl::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	SBA_BEGIN_PROPERTY_HELPER(aProperties,4)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FILTER),	PROP_TYPE(OUString), 0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),		PROP_TYPE(OUString), com::sun::star::beans::PropertyAttribute::READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(PRIVILIGES),PROP_TYPE(sal_Int16), 0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SORT),		PROP_TYPE(OUString), 0);
	SBA_END_PROPERTY_HELPER();
}

// OPropertySetHelper
//------------------------------------------------------------------------------
sal_Bool SbaXdbTable_Impl::convertFastPropertyValue( Any & rConvertedValue, Any & rOldValue, sal_Int32 nHandle, const Any& rValue ) throw( starlang::IllegalArgumentException  )
{
	sal_Bool bModified(sal_False);
	switch (nHandle)
	{
		case PROP_PRIVILIGES:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_nPrivileges);
			break;
		case PROP_SORT:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_aSort);
			break;
		case PROP_FILTER:
			bModified = ::utl::tryPropertyValue(rConvertedValue, rOldValue, rValue,
															m_aFilter);
			break;
		default:
			DBG_ERROR("unknown Porperty");
	}
	return bModified;
}

//------------------------------------------------------------------------------
void SbaXdbTable_Impl::setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const Any& rValue ) throw(staruno::Exception)
{
	switch (nHandle)
	{
		case PROP_PRIVILIGES:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_SHORT, "invalid type" );

			rValue >>= m_nPrivileges;
			break;
		case PROP_FILTER:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aFilter;
			break;
		case PROP_SORT:
			DBG_ASSERT(rValue.getValueTypeClass() == staruno::TypeClass_STRING, "invalid type" );

			rValue >>= m_aSort;
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

//------------------------------------------------------------------------------
void SbaXdbTable_Impl::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_PRIVILIGES:
			rValue <<= m_nPrivileges;
			break;
		case PROP_FILTER:
			rValue <<= m_aFilter;
			break;
		case PROP_SORT:
			rValue <<= m_aSort;
			break;
		case PROP_NAME:
			rValue <<= ::rtl::OUString(const_cast<SbaXdbTable_Impl*>(this)->getName());
			break;
		default:
			DBG_ERROR("unknown Property");
	}
}

// Implementation fuer Tabellen aus Datenbanken
//------------------------------------------------------------------------------
SbaXdbTableDef::SbaXdbTableDef(SbaXdbCollection& rCollection, SbaTableDef* pTableDef, sal_Bool bCase)
			   :SbaXdbTable_Impl(rCollection, bCase)
			   ,m_xTable(pTableDef)
{
	if (m_xTable.Is())
	{
		const SbaColumnList& rCols = m_xTable->GetOriginalColumns();
		m_aFields.setDefinitions(rCols);
		m_nPrivileges = m_xTable->GetTable()->GetTablePrivileges();

		const SfxStringItem* pOrderFilter = (const SfxStringItem*)m_xTable->GetObjAttrs()->GetItem(SBA_DEF_FILTER);
		m_aFilter = pOrderFilter ? pOrderFilter->GetValue() : String();

		pOrderFilter = (const SfxStringItem*)m_xTable->GetObjAttrs()->GetItem(SBA_DEF_SORT);
		m_aSort = pOrderFilter ? pOrderFilter->GetValue() : String();
	}
}

//------------------------------------------------------------------------------
SbaXdbTableDef::SbaXdbTableDef(sal_Bool bCase)
			   :SbaXdbTable_Impl(bCase){}

//------------------------------------------------------------------------------
SbaXdbTableDef::~SbaXdbTableDef()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

// XUnoTunnel
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbTableDef::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
//	typedef utl::UnoTunnelHelper<SbaXdbTableDef> UnoTunnel;
//	sal_Int64 nSomething = UnoTunnel::getSomething(aIdentifier);
//
//	if (nSomething == sal_Int64())
//		nSomething = SbaXdbTable_Impl::getSomething(aIdentifier);
//
//	return nSomething;
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbTableDef::disposing()
{
	SbaXdbTable_Impl::disposing();
	m_xTable = NULL;
}

// starcontainer::XNamed
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbTableDef::getName(void)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	return isOpen() ? ::rtl::OUString(m_xTable->Name()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTableDef::setName(const ::rtl::OUString& _rName)
	throw( staruno::RuntimeException )
{
	try
	{
		::osl::MutexGuard aGuard( m_aMutex );
		checkOpen();

		m_xTable->Rename(_rName);

		checkDBResult(m_xTable->Status(), *this, sal_True);
	}
	catch (staruno::RuntimeException&)
	{
		throw;
	}
	catch (...)
	{
		throw staruno::RuntimeException();
	}
}

// starutil::XRefreshable
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTableDef::refresh(void) throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xTable->Refresh();

	const SdbColumnsRef xCols = m_xTable->GetTable()->OriginalColumns();
	m_aFields.setDefinitions(xCols);
	m_nPrivileges = m_xTable->GetTable()->GetTablePrivileges();

	starlang::EventObject aEvt(*this);
	NOTIFY_LISTENERS(m_aRefreshListeners, starutil::XRefreshListener, refreshed, aEvt);
}

// PropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbTableDef::fillProperties( Sequence<starbeans::Property>& aProperties) const
	throw( staruno::RuntimeException )
{
	using starbeans::PropertyAttribute::TRANSIENT;
	using starbeans::PropertyAttribute::READONLY;
	SBA_BEGIN_PROPERTY_HELPER(aProperties,5)
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(FILTER),	PROP_TYPE(OUString), 0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(NAME),		PROP_TYPE(OUString), READONLY);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(PRIVILIGES),PROP_TYPE(sal_Int16), 0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(SORT),		PROP_TYPE(OUString), 0);
		NEXT_PROPERTY() = Property(SBA_OLD_PROPERTY(URL),		PROP_TYPE(OUString), TRANSIENT | READONLY);
	SBA_END_PROPERTY_HELPER();
}

// OPropertySetHelper
//------------------------------------------------------------------------------
void SbaXdbTableDef::getFastPropertyValue( Any& rValue, sal_Int32 nHandle ) const
{
	switch (nHandle)
	{
		case PROP_URL:
			rValue <<= (isOpen() ? ::rtl::OUString(m_xTable->ToURL()) : ::rtl::OUString());
			break;
		default:
			SbaXdbTable_Impl::getFastPropertyValue(rValue, nHandle);
	}
}

// stardata::XDatabaseUpdate
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTableDef::update(void)
	throw( starlang::NoSupportException, stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	::osl::MutexGuard aGuard( m_aMutex );

	// Anlegen der Columns aus der derzeitigen Struktur
	SbaColumnList& rCols = m_xTable->GetColumns();
	rCols.Clear();

	// setzen der Columns
	sal_uInt32 nCount = m_aFields.getCount();
	// keine Spalten -> Fehler
	if (!nCount)
	{
		SdbStatus aStat;
		aStat.Set(SDB_STAT_ERROR);
		checkDBResult(aStat, *this);
	}

	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		SbaXdbField* pField = m_aFields[i];
		SbaColumn* pCol = pField->createColumn(*m_xTable);
		rCols.InsertAt(pField->getName(), pCol);
	}

	if (!m_xTable->Update())
		checkDBResult(m_xTable->Status(), *this);
	else
	{
		const SdbColumnsRef xCols = m_xTable->GetTable()->OriginalColumns();
		m_aFields.setDefinitions(xCols);
		m_nPrivileges = m_xTable->GetTable()->GetTablePrivileges();
	}
}
using namespace cppu;
using namespace osl;
//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbTableDef::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// stardata::XDatabaseTable
Reference< stardata::XDatabaseStatement > SAL_CALL SbaXdbTableDef::createStatement(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	::osl::MutexGuard aGuard( m_aMutex );

	SdbCursorType eSdbType = SDB_KEYSET;
	sal_uInt16 nSdbOptions = SDB_SEEDELETED | SDB_INDIRECT;

	SbaXdbDatabase* pDatabase = 0;
	//	utl::getImplementation(pDatabase,getXdbParent());
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getXdbParent(),::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		pDatabase = (SbaXdbDatabase*)xTunnel->getSomething(SbaXdbDatabase:: getUnoTunnelImplementationId());
	}

	DBG_ASSERT(pDatabase, " SbaXdbTableDef::createStatement : keine Datenbank");
	SbaDatabaseRef xDatabaseImpl = pDatabase->getDatabase();

	SdbCursorRef xSdbCursor = xDatabaseImpl->CreateCursor(eSdbType, nSdbOptions);
	checkDBResult(xDatabaseImpl->Status(), *this, sal_False);

	DBG_ASSERT(xSdbCursor.Is(), "SbaXdbTableDef::createStatement: kein Cursor erzeugt");

	if (xSdbCursor.Is())
	{
		// xSdbCursor->Prepare(getName(), sal_True);
		// checkDBResult(xSdbCursor->Status(), *this, sal_False);
		return new SbaXdbTableStatement(pDatabase->getXdbStatements(), *xSdbCursor, *this);
	}
	else
		return Reference< stardata::XDatabaseStatement > ();
}

//------------------------------------------------------------------------------
void SbaXdbTableDef::setObject(const SbaTableDefRef& xDef)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );

	// Anlegen der Columns aus der derzeitigen Struktur
	SbaColumnList& rCols = xDef->GetColumns();
	rCols.Clear();

	// setzen der Columns
	sal_uInt32 nCount = m_aFields.getCount();
	// keine Spalten -> Fehler
	if (!nCount)
	{
		SdbStatus aStat;
		aStat.Set(SDB_STAT_ERROR);
		checkDBResult(aStat, *this);
	}

	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		SbaXdbField* pField = m_aFields[i];
		SbaColumn* pCol = pField->createColumn(*xDef);
		rCols.InsertAt(pField->getName(), pCol);
	}

	if (xDef->Update())
	{
		m_xTable = xDef;
		const SdbColumnsRef xCols = m_xTable->GetTable()->OriginalColumns();
		m_aFields.setDefinitions(xCols);
		m_nPrivileges = m_xTable->GetTable()->GetTablePrivileges();
	}
	else
		checkDBResult(xDef->Status(), *this);
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTableDef::createObject(DBObject _eObj, const ::rtl::OUString& _rName)
	throw( stardata::DatabaseException  )
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");

	::osl::MutexGuard aGuard( m_aMutex );

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
	{
		pObj = m_xTable->GetTable()->CreateIndex(_rName);
		if (!pObj)
			checkDBResult(m_xTable->GetTable()->Status(), *this);
	}
	else
	{
		throw starlang::DisposedException();
	}
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTableDef::openObject(DBObject _eObj, const ::rtl::OUString& _rName)
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");

	::osl::MutexGuard aGuard( m_aMutex );

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
		pObj = m_xTable->GetTable()->OpenIndex(_rName);
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTableDef::openObject(DBObject _eObj, sal_Int32 _nPos)
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	::osl::MutexGuard aGuard( m_aMutex );

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
		pObj = m_xTable->GetTable()->OpenIndex((sal_uInt16)_nPos);
	return pObj;
}

//------------------------------------------------------------------------------
::rtl::OUString SbaXdbTableDef::getObjectName(DBObject _eObj, sal_Int32 _nPos) const
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	::rtl::OUString aRet;
	if (m_xTable && m_xTable->IsOpen())
		aRet = m_xTable->GetTable()->GetIndexName((sal_uInt16)_nPos);
	return aRet;
}

//------------------------------------------------------------------------------
sal_Int32 SbaXdbTableDef::getObjectCount(DBObject _eObj) const
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	sal_Int32 nRet = 0;
	if (m_xTable && m_xTable->IsOpen())
		nRet = m_xTable->GetTable()->GetIndexCount();
	return nRet;
}

//------------------------------------------------------------------------------
void SbaXdbTableDef::refresh(DBObject _eObj) throw( stardata::DatabaseException  )
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	refresh();
}

// Implementation fuer Tabellen aus Connections
//------------------------------------------------------------------------------
SbaXdbTable::SbaXdbTable(SbaXdbCollection& rCollection, SdbTable* pTableDef, sal_Bool bCase)
			:SbaXdbTable_Impl(rCollection, bCase)
			,m_xTable(pTableDef)
{
	if (m_xTable)
	{
		const SdbColumnsRef xCols = m_xTable->OriginalColumns();
		m_aFields.setDefinitions(xCols);
		m_nPrivileges = m_xTable->GetTablePrivileges();
	}
}

//------------------------------------------------------------------------------
SbaXdbTable::SbaXdbTable(sal_Bool bCase)
			:SbaXdbTable_Impl(bCase){}


//------------------------------------------------------------------------------
SbaXdbTable::~SbaXdbTable()
{
	if (!ComponentHelper::rBHelper.bDisposed)
	{
		acquire();
		dispose();
	}
}

//--------------------------------------------------------------------------
Sequence< sal_Int8 > SbaXdbTable::getUnoTunnelImplementationId() 
{
	static OImplementationId * pId = 0;
	if (! pId)
	{
		MutexGuard aGuard( Mutex::getGlobalMutex() );
		if (! pId)
		{
			static OImplementationId aId;
			pId = &aId;
		}
	}
	return pId->getImplementationId();
}

// XUnoTunnel
//------------------------------------------------------------------------------
sal_Int64 SAL_CALL SbaXdbTable::getSomething(staruno::Sequence<sal_Int8> const& rId)throw( staruno::RuntimeException )
{
	if (rId.getLength() == 16 && 0 == rtl_compareMemory(getUnoTunnelImplementationId().getConstArray(),  rId.getConstArray(), 16 ) )
		return (sal_Int64)this;

	return 0;

//	typedef utl::UnoTunnelHelper<SbaXdbTable> UnoTunnel;
//	sal_Int64 nSomething = UnoTunnel::getSomething(aIdentifier);
//
//	if (nSomething == sal_Int64())
//		nSomething = SbaXdbTable_Impl::getSomething(aIdentifier);
//
//	return nSomething;
}

// ComponentHelper
//------------------------------------------------------------------------------
void SbaXdbTable::disposing()
{
	SbaXdbTable_Impl::disposing();
	m_xTable = NULL;
}

// starcontainer::XNamed
//------------------------------------------------------------------------------
::rtl::OUString SAL_CALL SbaXdbTable::getName(void)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	return isOpen() ? ::rtl::OUString(m_xTable->GetFullName()) : ::rtl::OUString();
}

//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTable::setName(const ::rtl::OUString& _rName)
	throw( staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_aMutex );
	try
	{
		checkOpen();

		m_xTable->Rename(_rName);

		checkDBResult(m_xTable->Status(), *this, sal_True);
	}
	catch (staruno::RuntimeException&)
	{
		throw;
	}
	catch (...)
	{
		throw staruno::RuntimeException();
	}
}

// starutil::XRefreshable
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTable::refresh(void)
	throw( staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	m_xTable->Refresh();

	const SdbColumnsRef xCols = m_xTable->OriginalColumns();
	m_aFields.setDefinitions(xCols);
	m_nPrivileges = m_xTable->GetTablePrivileges();

	starlang::EventObject aEvt(*this);
	NOTIFY_LISTENERS(m_aRefreshListeners, starutil::XRefreshListener, refreshed, aEvt);
}

// stardata::XDatabaseUpdate
//------------------------------------------------------------------------------
void SAL_CALL SbaXdbTable::update(void)
	throw( starlang::NoSupportException, stardata::DatabaseException, staruno::RuntimeException  )
{
	::osl::MutexGuard aGuard( m_aMutex );
	checkOpen();

	// Anlegen der Columns aus der derzeitigen Struktur
	SdbColumnsRef xCols = m_xTable->Columns();
	xCols->Reset();

	// setzen der Columns
	sal_uInt32 nCount = m_aFields.getCount();

	// keine Spalten -> Fehler
	if (!nCount)
	{
		SdbStatus aStat;
		aStat.Set(SDB_STAT_ERROR);
		checkDBResult(aStat, *this);
	}

	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SbaXdbField* pField = m_aFields[i];
		SdbColumn* pCol = pField->createColumn(m_xTable->GetConnection());
		xCols->AddColumn(pCol);
	}

	if (!m_xTable->Update())
		checkDBResult(m_xTable->Status(), *this);
	else
	{
		const SdbColumnsRef xCols = m_xTable->OriginalColumns();
		m_aFields.setDefinitions(xCols);
		m_nPrivileges = m_xTable->GetTablePrivileges();
	}
}

// stardata::XDatabaseTable
//------------------------------------------------------------------------------
Reference< stardata::XDatabaseStatement >  SAL_CALL SbaXdbTable::createStatement(void)
	throw( stardata::DatabaseException, staruno::RuntimeException )
{
	checkOpen();
	::osl::MutexGuard aGuard( m_aMutex );

	SdbCursorType eSdbType = SDB_KEYSET;
	sal_uInt16 nSdbOptions = SDB_SEEDELETED | SDB_INDIRECT;

	SbaXdbConnection* pConnection = 0;
	//	utl::getImplementation(pConnection,getXdbParent());
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getXdbParent(),::com::sun::star::uno::UNO_QUERY);
	if(xTunnel.is())
	{
		pConnection = (SbaXdbConnection*)xTunnel->getSomething(SbaXdbConnection:: getUnoTunnelImplementationId());
	}

	DBG_ASSERT(pConnection, " SbaXdbTable::createStatement : keine Datenbank");
	SdbConnectionRef xConnectionImpl = pConnection->getConnection();

	SdbCursorRef xSdbCursor = xConnectionImpl->CreateCursor(eSdbType, nSdbOptions);
	checkDBResult(xConnectionImpl->Status(), *this, sal_False);

	DBG_ASSERT(xSdbCursor.Is(), "SbaXdbTable::createStatement: kein Cursor erzeugt");

	if (xSdbCursor.Is())
	{
		xSdbCursor->Prepare(getName(), sal_True);
		checkDBResult(xSdbCursor->Status(), *this, sal_False);
		return new SbaXdbTableStatement(pConnection->getStatements(), *xSdbCursor, *this);
	}
	else
		return Reference< stardata::XDatabaseStatement > ();
}

//------------------------------------------------------------------------------
void SbaXdbTable::setObject(const SdbTableRef& xDef) throw( stardata::DatabaseException, staruno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex );

	// Anlegen der Columns aus der derzeitigen Struktur
	SdbColumnsRef xCols = xDef->Columns();
	xCols->Reset();

	// setzen der Columns
	sal_uInt32 nCount = m_aFields.getCount();

	// keine Spalten -> Fehler
	if (!nCount)
	{
		SdbStatus aStat;
		aStat.Set(SDB_STAT_ERROR);
		checkDBResult(aStat, *this);
	}

	for (sal_uInt32 i = 0; i < nCount; i++)
	{
		const SbaXdbField* pField = m_aFields[i];
		SdbColumn* pCol = pField->createColumn(xDef->GetConnection());
		xCols->AddColumn(pCol);
	}

	if (xDef->Update())
	{
		m_xTable = xDef;
		const SdbColumnsRef xCols = m_xTable->OriginalColumns();
		m_aFields.setDefinitions(xCols);
		m_nPrivileges = m_xTable->GetTablePrivileges();
	}
	else
		checkDBResult(xDef->Status(), *this);
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTable::createObject(DBObject _eObj, const ::rtl::OUString& _rName) throw( stardata::DatabaseException  )
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
	{
		pObj = m_xTable->CreateIndex(_rName);
		if (!pObj)
			checkDBResult(m_xTable->Status(), *this);
	}
	else
	{
		throw starlang::DisposedException();
	}
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTable::openObject(DBObject _eObj, const ::rtl::OUString& _rName)
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	::osl::MutexGuard aGuard( m_aMutex );

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
		pObj = m_xTable->OpenIndex(_rName);
	return pObj;
}

//------------------------------------------------------------------------------
SdbObj* SbaXdbTable::openObject(DBObject _eObj, sal_Int32 _nPos)
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	::osl::MutexGuard aGuard( m_aMutex );

	SdbObj* pObj = NULL;
	if (m_xTable && m_xTable->IsOpen())
		pObj = m_xTable->OpenIndex((sal_uInt16)_nPos);
	return pObj;
}

//------------------------------------------------------------------------------
::rtl::OUString SbaXdbTable::getObjectName(DBObject _eObj, sal_Int32 _nPos) const
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	::rtl::OUString aRet;
	if (m_xTable && m_xTable->IsOpen())
		aRet = m_xTable->GetIndexName((sal_uInt16)_nPos);
	return aRet;
}

//------------------------------------------------------------------------------
sal_Int32 SbaXdbTable::getObjectCount(DBObject _eObj) const
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	sal_Int32 nRet = 0;
	if (m_xTable && m_xTable->IsOpen())
		nRet = m_xTable->GetIndexCount();
	return nRet;
}

//------------------------------------------------------------------------------
void SbaXdbTable::refresh(DBObject _eObj) throw( stardata::DatabaseException  )
{
	DBG_ASSERT(_eObj == dbIndex, "wrong object");
	refresh();
}

//------------------------------------------------------------------------------
SbaXdbTableDefs::SbaXdbTableDefs(SbaXdbObjectCreator& _rParent)
:	SbaXdbNamedCollection(_rParent, dbTable, ::getCppuType(static_cast<const Reference< stardata::XDatabaseTable >*>(0)) )
{
}

// stardata::XDatabaseTableFactory
//------------------------------------------------------------------------------
Reference< stardata::XDatabaseTable >
	SAL_CALL SbaXdbTableDefs::create(void)
		throw( starlang::NoSupportException, staruno::RuntimeException )
{
	checkOpen();
	return new SbaXdbTableDef(getXdbCreator()->isCaseSensitive());
}

// helper methods
//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbTableDefs::doGet(SdbObj* pObj) const
{
	SbaXdbTableDef* pXObj = NULL;

	// Dokument schon geoeffnet
	sal_uInt32 nCount = size();
	sal_uInt32 i;
	for (i = 0; i < nCount; i++)
	{
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getObject(i),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbTableDef*)xTunnel->getSomething(SbaXdbTableDef:: getUnoTunnelImplementationId());
		}
		//	utl::getImplementation(pXObj,getObject(i));

		if (pXObj && pObj == &pXObj->m_xTable)
			break;
	}

	if (i == nCount)
		pXObj = new SbaXdbTableDef(*(SbaXdbTableDefs*)this, (SbaTableDef*)pObj, getXdbCreator()->isCaseSensitive());

	return pXObj;
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbTableDefs::doRemove(SbaXdbObject* pObj)
{
	SbaXdbTableDef* pXObj = (SbaXdbTableDef*)pObj;

	if (!pXObj->m_xTable->Drop())
		checkDBResult(pXObj->m_xTable->Status(), *this, sal_True);
	return sal_True;
}

//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbTableDefs::doInsert(const ::rtl::OUString& Name, const Any& Element)
{
	// Ist es ein bekanntes document
	SbaXdbTableDef* pXObj = 0;
	//	utl::getImplementation(pXObj,Element);
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel;
	Element >>= xTunnel;
	//	(Element.getValue(),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbTableDef*)xTunnel->getSomething(SbaXdbTableDef:: getUnoTunnelImplementationId());
		}

	DBG_ASSERT(pXObj, "SbaXdbTableDefs::doInsert for invalid element");

	// bereits in einem Container enthalten?
	if (!pXObj || pXObj->getXdbParent())
	{
		throw starlang::IllegalArgumentException();
	}

	SdbObj* pObj = NULL;

	try
	{
		pObj = getXdbCreator()->createObject(m_eObj, Name);
	}
	catch (stardata::DatabaseException& e)
	{
		throw starlang::WrappedTargetException(::rtl::OUString(), *this, staruno::makeAny(e) );
	}

	SbaTableDefRef xTable = (SbaTableDef*)pObj;
	pXObj->setObject(xTable);
	return pXObj;
}

//------------------------------------------------------------------------------
SbaXdbTables::SbaXdbTables(SbaXdbObjectCreator& _rParent)
:	SbaXdbNamedCollection(_rParent, dbTable, ::getCppuType(static_cast<const Reference< stardata::XDatabaseTable >*>(0)) )
{
}

// stardata::XDatabaseTableFactory
//------------------------------------------------------------------------------
Reference< stardata::XDatabaseTable >
	SAL_CALL SbaXdbTables::create(void)
		throw( starlang::NoSupportException, staruno::RuntimeException )
{
	checkOpen();
	return new SbaXdbTable(getXdbCreator()->isCaseSensitive());
}

// helper methods
//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbTables::doGet(SdbObj* pObj) const
{
	SbaXdbTable* pXObj = NULL;

	// Dokument schon geoeffnet
	sal_uInt32 nCount = size();
	sal_uInt32 i;
	for (i = 0; i < nCount; i++)
	{
		//	utl::getImplementation(pXObj,getObject(i));
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel((::cppu::OWeakObject*)getObject(i),::com::sun::star::uno::UNO_QUERY);
		if(xTunnel.is())
		{
			pXObj = (SbaXdbTable*)xTunnel->getSomething(SbaXdbTable:: getUnoTunnelImplementationId());
		}

		if (pXObj && pObj == &pXObj->m_xTable)
			break;
	}

	if (i == nCount)
		pXObj = new SbaXdbTable(*(SbaXdbTables*)this, (SdbTable*)pObj, getXdbCreator()->isCaseSensitive());

	return pXObj;
}

//------------------------------------------------------------------------------
sal_Bool SbaXdbTables::doRemove(SbaXdbObject* pObj)
{
	SbaXdbTable* pXObj = (SbaXdbTable*)pObj;

	if (!pXObj->m_xTable->Drop())
		checkDBResult(pXObj->m_xTable->Status(), *this, sal_True);
	return sal_True;
}

//------------------------------------------------------------------------------
SbaXdbObject* SbaXdbTables::doInsert(const ::rtl::OUString& Name, const Any& Element)
{
	// Ist es ein bekanntes document
	SbaXdbTable* pXObj = 0;
	//	utl::getImplementation(pXObj,Element);
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XUnoTunnel> xTunnel;
	Element >>= xTunnel;
	if(xTunnel.is())
	{
		pXObj = (SbaXdbTable*)xTunnel->getSomething(SbaXdbTable:: getUnoTunnelImplementationId());
	}

	DBG_ASSERT(pXObj, "SbaXdbTables::doInsert for invalid element");

	// bereits in einem Container enthalten?
	if (!pXObj || pXObj->getXdbParent())
	{
		throw starlang::IllegalArgumentException();
	}

	SdbObj* pObj = NULL;

	try
	{
		pObj = getXdbCreator()->createObject(m_eObj, Name);
	}
	catch (stardata::DatabaseException& e)
	{
		throw starlang::WrappedTargetException(::rtl::OUString(), *this, staruno::makeAny(e));
	}

	SdbTableRef xTbl = (SdbTable*)pObj;
	pXObj->setObject(xTbl);
	return pXObj;
}

















