/*************************************************************************
 *
 *  $RCSfile: iniwrap.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:25:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "iniwrap.hxx"
#include "sbastr.hxx"

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

DBG_NAME( SbaIniWrap );

//==================================================================
SbaIniWrap::SbaIniWrap():
	pIni(0)
{
	DBG_CTOR( SbaIniWrap, NULL );

	SfxApplication* pApp = SFX_APP();			// immer die INI - des Desktops
	pIni = pApp->GetIniManager();
	DBG_ASSERT( pIni, "SbaIniWrap::SbaIniWrap");

	// Fuellen des Mappings IniKey(String)->SbaFieldKey(Index)
	// von AddressBookFields
/* Dieses sind die entgltigen Felder, wenn ini-Datei gendert
	aFieldMap[COMPANY] = "Company";
	aFieldMap[DEPARTMENT] = "Department";
	aFieldMap[FIRSTNAME] = "FirstName";
	aFieldMap[LASTNAME] = "LastName";
	aFieldMap[ADDRESS] = "Address";
	aFieldMap[POSTALCODE] = "PostalCode";
	aFieldMap[COUNTRY] = "Country";
	aFieldMap[CITY] = "City";
	aFieldMap[TITLE]="Title";
	aFieldMap[POSITION]="Position";
	aFieldMap[PREFIX]="Prefix";
	aFieldMap[INITIALS]="Initials";
	aFieldMap[SALUTATION]="Salutation";
	aFieldMap[HOMEPHONE]="HomePhone";
	aFieldMap[WORKPHONE]="WorkPhone";
	aFieldMap[FAX]="Fax";
	aFieldMap[EMAIL]="EMail";
	aFieldMap[URL]="URL";
*/
	aFieldMap[COMPANY].AssignAscii("Company");
	aFieldMap[DEPARTMENT].AssignAscii("Department");
	aFieldMap[FIRSTNAME].AssignAscii("FirstName");
	aFieldMap[LASTNAME].AssignAscii("LastName");
	aFieldMap[ADDRESS].AssignAscii("Street");
	aFieldMap[POSTALCODE].AssignAscii("Zip");
	aFieldMap[COUNTRY].AssignAscii("Country");
	aFieldMap[CITY].AssignAscii("City");
	aFieldMap[TITLE].AssignAscii("Title");
	aFieldMap[POSITION].AssignAscii("Position");
	aFieldMap[PREFIX].AssignAscii("AddrForm");
	aFieldMap[INITIALS].AssignAscii("Code");
	aFieldMap[SALUTATION].AssignAscii("AddrFormMail");
	aFieldMap[HOMEPHONE].AssignAscii("PhonePriv");
	aFieldMap[WORKPHONE].AssignAscii("PhoneComp");
	aFieldMap[FAX].AssignAscii("Fax");
	aFieldMap[EMAIL].AssignAscii("EMail");
	aFieldMap[URL].AssignAscii("URL");

	aFieldMap[NOTE].AssignAscii("Note");
	aFieldMap[OLDFIELD1].AssignAscii("Altfield1");
	aFieldMap[OLDFIELD2].AssignAscii("Altfield2");
	aFieldMap[OLDFIELD3].AssignAscii("Altfield3");
	aFieldMap[OLDFIELD4].AssignAscii("Altfield4");
	aFieldMap[ID].AssignAscii("Id");
	aFieldMap[STATE].AssignAscii("State");
	aFieldMap[OFFICEPHONE].AssignAscii("PhoneOffice");
	aFieldMap[PAGER].AssignAscii("Pager");
	aFieldMap[HANDYPHONE].AssignAscii("PhoneCell");
	aFieldMap[OTHERPHONE].AssignAscii("PhoneOther");

	aFieldMap[CALENDARURL].AssignAscii("CalendarURL");
	aFieldMap[INVITE].AssignAscii("InviteParticipant");
}

//------------------------------------------------------------------------------
SbaIniWrap::~SbaIniWrap()
{
	DBG_DTOR( SbaIniWrap, NULL );
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetDefaultDatabase()
{
	DBG_CHKTHIS( SbaIniWrap, NULL );
	String  aName = pIni->Get(SFX_KEY_LAST_DATABASE);

	if( aName == String('*') )      // kein Eintrag
		aName.Erase();

	return aName;
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetDefaultDatabasePath()
{
	DBG_CHKTHIS( SbaIniWrap, NULL );
	return pIni->Get(SFX_KEY_DATABASE_PATH);
}

//------------------------------------------------------------------------------
void SbaIniWrap::SetDefaultDatabasePath( const String& rPath )
{
	DBG_CHKTHIS( SbaIniWrap, NULL );

	DirEntry aDir(rPath);
	String aPath = aDir.GetPath().GetFull();
	pIni->Set( aPath, SFX_KEY_DATABASE_PATH);
}

//------------------------------------------------------------------------------
void SbaIniWrap::SetDefaultDatabase( const String& rAliasName )
{
	DBG_CHKTHIS( SbaIniWrap, NULL );

	String  aAlias = rAliasName;

	if (!aAlias.Len() )
		aAlias = '*';

	pIni->Set( aAlias, SFX_KEY_LAST_DATABASE);
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetAdressDB() const
{
	String aString = pIni->Get(SFX_KEY_ADDRESSBOOK);
	if (aString.GetTokenCount(';') > 1)
		return aString.GetToken(0,';');
	else
		return String();
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetAdressTable() const
{
	String aString = pIni->Get(SFX_KEY_ADDRESSBOOK);
	if (aString.GetTokenCount(';') > 1)
		return aString.GetToken(1,';');
	else
		return String();
}

//------------------------------------------------------------------------------
void SbaIniWrap::SetAdressDB(const String& rDB, const String& rTable)
{
	DBG_CHKTHIS( SbaIniWrap, NULL );
	String aEntry;
	if (rDB.Len() && rTable.Len())  // nur in diesem Fall macht ein Eintrag Sinn
	{
		aEntry = rDB;
		aEntry += ';';
		aEntry += rTable;
	}
	pIni->Set(aEntry, SFX_KEY_ADDRESSBOOK);
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetAddressFields() const
{
	return 	pIni->Get( SFX_KEY_ADDRESSBOOK_FIELDS );

}

//------------------------------------------------------------------------------
void SbaIniWrap::SetAddressFields( const String& rFields )
{
	DBG_CHKTHIS( SbaIniWrap, NULL );

	pIni->Set( rFields, SFX_KEY_ADDRESSBOOK_FIELDS );
}

//------------------------------------------------------------------------------
String SbaIniWrap::GetAssocFieldName( FieldKey eKey )
{
	String aIniString = GetAddressFields();
	String aEntry;
	String aKey;
	String aFieldName;

	for (xub_StrLen i=0; i<ADDR_BOOK_FIELDS_CNT; ++i)
	{
		aEntry = aIniString.GetToken(i);
		aKey = aEntry.GetToken(0,':');
		aFieldName = aEntry.GetToken(1,':');
		if( aKey == aFieldMap[eKey] )
			return aFieldName;
	}

	return String();
}

//------------------------------------------------------------------------------
INT16 SbaIniWrap::GetAssocCtrlPos( const String& rField )
{
	String aIniString = GetAddressFields();
	String aEntry;
	String aKey;
	String aFieldName;

	for ( xub_StrLen i=0; i<ADDR_BOOK_FIELDS_CNT; ++i )
	{
		aEntry = aIniString.GetToken(i);
		aKey = aEntry.GetToken(0,':');
		aFieldName = aEntry.GetToken(1,':');
		if( aFieldName == rField )
		{
			// Position des Keys in der FieldMap
			for( USHORT pos=0; pos<ADDR_BOOK_FIELDS_CNT; pos++ )
			{
				if( aKey == aFieldMap[pos] )
					return pos;
			}

		}
	}
	return -1;
}

//------------------------------------------------------------------------------


