/*************************************************************************
 *
 *  $RCSfile: DatabaseNamesPage.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_DATABASE_NAMES_PAGE_HXX_
#define _SBA_DATABASE_NAMES_PAGE_HXX_

#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _LINK_HXX
#include <tools/link.hxx>
#endif
#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
#include <com/sun/star/util/XLocalizedAliases.hpp>
#endif
#ifndef _SV_MENUBTN_HXX
#include <vcl/menubtn.hxx>
#endif

//==============================================================================
//==============================================================================
class SbaEditDbNameControl;
class SbaDatabaseNamesTabPage : public SfxTabPage
{
	GroupBox				m_aFrame;
	FixedText				m_aLanguageLabel;
	ListBox					m_aLanguages;
	FixedText				m_aAppLang;
	SbaEditDbNameControl*	m_pEditor;
	MenuButton				m_aCommands;

	PopupMenu*				m_pCommandsMenu;	// reused, thus as member

public:
	SbaDatabaseNamesTabPage(Window* pParent, const SfxItemSet& rSet);
	~SbaDatabaseNamesTabPage();

	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );

	virtual	sal_Bool 		FillItemSet( SfxItemSet& rSet );
	virtual	void 		Reset( const SfxItemSet& rSet );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );

protected:
	DECL_LINK(OnLanguageSelected, void*);
	DECL_LINK(OnCommandsActivate, void*);
	DECL_LINK(OnCommandsSelected, void*);
};

//==============================================================================
//==============================================================================
class NameConflictDialog : public ModalDialog
{
	FixedText		m_aDescription;
	GroupBox		m_aFrame;
	FixedText		m_aInputRequest;
	FixedText		m_aURLLabel;
	FixedText		m_aURL;
	FixedText		m_aTitleLabel;
	Edit			m_aTitle;
	PushButton		m_aAdministration;
	OKButton		m_aOK;
	CancelButton	m_aCancel;

	::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases > 	m_xContext;
	::com::sun::star::lang::Locale					m_aLocale;
	String					m_sURL;
	String					m_sTitle;

public:
	NameConflictDialog(Window* _pParent, const String& _rInitialTitle, const String& _rUrl, sal_Bool _bUrgent);

	void	setContext(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases > & _rxContext) { m_xContext = _rxContext; }
	void	setLocale(const ::com::sun::star::lang::Locale& _rLoc) { m_aLocale = _rLoc; }
	String	getTitle() const { return m_sTitle; }

private:
	DECL_LINK(OnAdministrationClicked, void*);
	DECL_LINK(OnOkClicked, void*);
};

#endif // _SBA_DATABASE_NAMES_PAGE_HXX_

