/*************************************************************************
 *
 *  $RCSfile: SbaResourceCache.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_RESOURCE_CACHE_HXX_
#define _SBA_RESOURCE_CACHE_HXX_

#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
	// for stl :)
#endif

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif

class OSbaResourceCache
{
	typedef NAMESPACE_STD(map)<USHORT, String, NAMESPACE_STD(less)<USHORT> >	StringCache;
	typedef StringCache::iterator												StringCacheIterator;
	typedef StringCache::const_iterator											ConstStringCacheIterator;

	static StringCache				s_aStrings;
	static NAMESPACE_VOS(OMutex)	s_aAccessSafety;

private:
	OSbaResourceCache() { }	// no instantiation allowed, this class has only static members
	~OSbaResourceCache() { }

public:
	static void RegisterStringResource(USHORT _nResId);
		// register (i.e. load and cache) the string determined by _nResId
		// this should be called with a locked solar mutex
	static String GetRegisteredString(USHORT _nResId, BOOL _bLoadIfNecessary = FALSE);
		// get the string registered under the given id. If the string isn't found and _bLoadIfNecessary == TRUE,
		// it will be loaded and added to the cache. In this case a locked solar mutex is required here. In all
		// other cases this method is thread-safe.
};


#endif // _SBA_RESOURCE_CACHE_HXX_


