/*************************************************************************
 *
 *  $RCSfile: adanewdb.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef SBA_ADANEWDB_HXX
#define SBA_ADANEWDB_HXX

#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#include "editbrw.hxx"
class SfxFileDialog;
//========================================================================
// ADABAS for new db; is called from typepage
//========================================================================
class SbaAdabasNewDbPage : public ModalDialog
{
private:
	GroupBox			m_GB_USER;
	FixedText			m_FT_SYSUSR;
	FixedText			m_FT_CONUSR;
	FixedText			m_FT_DOMAIN_USR;

	EditCtrl			m_ET_SYSUSR;
	PushButton			m_PB_SYSPWD;
	EditCtrl			m_ET_CONUSR;
	PushButton			m_PB_CONPWD;
	Edit				m_ET_DOMAIN_USR;
	PushButton			m_PB_DOMAINPWD;

	FixedImage			m_BMP_CON;
	FixedImage			m_BMP_SYS;
	FixedImage			m_BMP_DOMAIN;

	FixedText			m_FT_RESTORE;
	Edit				m_ET_RESTORE;
	PushButton			m_PB_RESTORE;

	GroupBox			m_GB_DBSETTINGS;
	FixedText			m_FT_SYSDEVSPACE;
	FixedText			m_FT_TRANSACTIONLOG;
	FixedText			m_FT_DATADEVSPACE;
	Edit				m_ET_SYSDEVSPACE;
	PushButton			m_PB_SYSDEVSPACE;
	Edit				m_ET_TRANSACTIONLOG;
	PushButton			m_PB_TRANSACTIONLOG;
	Edit				m_ET_DATADEVSPACE;
	PushButton			m_PB_DATADEVSPACE;

	FixedText			m_FT_TRANSACTIONLOG_SIZE;
	NumericField		m_NF_TRANSACTIONLOG_SIZE;
	FixedText			m_FT_DATADEVSPACE_SIZE;
	NumericField		m_NF_DATADEVSPACE_SIZE;
	FixedText			m_FT_CACHE_SIZE;
	NumericField		m_NF_CACHE_SIZE;
	
	OKButton			m_PB_OK;
	CancelButton		m_PB_CANCEL;

	String				m_DbName;
	String				m_SYSDEV_File;
	String				m_TRANSDEV_File;
	String				m_DATADEV_File;
	String				m_Backup_File;
	String				m_ConPwd;
	String				m_SysPwd;
	String				m_DomainPwd;
	SfxFileDialog*		m_pFileDlg;
	BOOL				m_bRestore;
	INT8				m_nSetBitmap;

	DECL_LINK( LoadButtonClickHdl,	Button		* );
	DECL_LINK( ButtonClickHdl,		Button		* );
	DECL_LINK( PwdClickHdl,			Button		* );
	DECL_LINK( ImplOKHdl,			OKButton	* );
	DECL_LINK( LoseFocusHdl,		Edit		* );

	void CheckBitmaps();
	void ShowErrorText(INT32 _nError);
	String GenerateInitFile();
public:
	SbaAdabasNewDbPage( Window* pParent,const String &_DbName,BOOL _bRestore=FALSE);
	~SbaAdabasNewDbPage();

	String GetCtrlUser() const { return m_ET_CONUSR.GetText(); }
	String GetCtrlPwd() const { return m_ConPwd; }
	String GetSysUser() const { return m_ET_SYSUSR.GetText(); }
	String GetSysPwd() const { return m_SysPwd; }
};

#endif // SBA_ADANEWDB_HXX
