/*************************************************************************
 *
 *  $RCSfile: addrcnt.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_ADDRCNT_HXX
#define _SBA_ADDRCNT_HXX

// include ---------------------------------------------------------------

#include "iniwrap.hxx"

// class SbaAdrContainer -------------------------------------------------

class SbaAddrContainer
{
private:
	String				aStrArr[ADDR_BOOK_FIELDS_CNT];

public:
	String				GetField( USHORT nIdx )	const;
	void				SetField( USHORT nIdx, const String& rStr );
	inline USHORT		Count() const { return ADDR_BOOK_FIELDS_CNT; }
	BOOL				operator==( const SbaAddrContainer& rCont ) const;

	inline String		GetFirma()			const { return aStrArr[SbaIniWrap::COMPANY]; }
	inline String		GetAbteilung()		const { return aStrArr[SbaIniWrap::DEPARTMENT]; }
	inline String		GetVorname()		const { return aStrArr[SbaIniWrap::FIRSTNAME]; }
	inline String		GetName()			const { return aStrArr[SbaIniWrap::LASTNAME]; }
	inline String		GetStrasse()		const { return aStrArr[SbaIniWrap::ADDRESS]; }
	inline String		GetLand()			const { return aStrArr[SbaIniWrap::COUNTRY]; }
	inline String		GetPlz()			const { return aStrArr[SbaIniWrap::POSTALCODE]; }
	inline String		GetOrt()			const { return aStrArr[SbaIniWrap::CITY]; }
	inline String		GetTitel()			const { return aStrArr[SbaIniWrap::TITLE]; }
	inline String		GetPosition()		const { return aStrArr[SbaIniWrap::POSITION]; }
	inline String		GetAnrede()			const { return aStrArr[SbaIniWrap::PREFIX]; }
	inline String		GetKuerzel()		const { return aStrArr[SbaIniWrap::INITIALS]; }
	inline String		GetBriefAnrede()	const { return aStrArr[SbaIniWrap::SALUTATION]; }
	inline String		GetTelPriv()		const { return aStrArr[SbaIniWrap::HOMEPHONE]; }
	inline String		GetTelGesch()		const { return aStrArr[SbaIniWrap::WORKPHONE]; }
	inline String		GetFax()			const { return aStrArr[SbaIniWrap::FAX]; }
	inline String		GetEmail()			const { return aStrArr[SbaIniWrap::EMAIL]; }
	inline String		GetURL()			const { return aStrArr[SbaIniWrap::URL]; }
	inline String		GetNote()			const {	return aStrArr[SbaIniWrap::NOTE]; }
	inline String		GetUserField1()		const {	return aStrArr[SbaIniWrap::OLDFIELD1]; }
	inline String		GetUserField2()		const {	return aStrArr[SbaIniWrap::OLDFIELD2]; }
	inline String		GetUserField3()		const {	return aStrArr[SbaIniWrap::OLDFIELD3]; }
	inline String		GetUserField4()		const {	return aStrArr[SbaIniWrap::OLDFIELD4]; }
	inline String		GetState()			const {	return aStrArr[SbaIniWrap::STATE]; }
	inline String		GetOfficePhone()	const {	return aStrArr[SbaIniWrap::OFFICEPHONE]; }
	inline String		GetPager()			const {	return aStrArr[SbaIniWrap::PAGER]; }
	inline String		GetHandyPhone()		const {	return aStrArr[SbaIniWrap::HANDYPHONE]; }
	inline String		GetOtherPhone()		const {	return aStrArr[SbaIniWrap::OTHERPHONE]; }
	inline String		GetCalendarURL()	const {	return aStrArr[SbaIniWrap::CALENDARURL]; }
	inline String		GetInvite()			const {	return aStrArr[SbaIniWrap::INVITE]; }

	inline void		SetFirma( const String& rStr )		{ aStrArr[SbaIniWrap::COMPANY]=rStr; }
	inline void		SetAbteilung( const String& rStr )	{ aStrArr[SbaIniWrap::DEPARTMENT]=rStr; }
	inline void		SetVorname( const String& rStr )	{ aStrArr[SbaIniWrap::FIRSTNAME]=rStr; }
	inline void		SetName( const String& rStr )		{ aStrArr[SbaIniWrap::LASTNAME]=rStr; }
	inline void		SetStrasse( const String& rStr )	{ aStrArr[SbaIniWrap::ADDRESS]=rStr; }
	inline void		SetLand( const String& rStr )		{ aStrArr[SbaIniWrap::COUNTRY]=rStr; }
	inline void		SetPlz( const String& rStr )		{ aStrArr[SbaIniWrap::POSTALCODE]=rStr; }
	inline void		SetOrt( const String& rStr )		{ aStrArr[SbaIniWrap::CITY]=rStr; }
	inline void		SetTitel( const String& rStr )		{ aStrArr[SbaIniWrap::TITLE]=rStr; }
	inline void		SetPosition( const String& rStr )	{ aStrArr[SbaIniWrap::POSITION]=rStr; }
	inline void		SetAnrede( const String& rStr )		{ aStrArr[SbaIniWrap::PREFIX]=rStr; }
	inline void		SetKuerzel( const String& rStr )	{ aStrArr[SbaIniWrap::INITIALS]=rStr; }
	inline void		SetBriefAnrede( const String& rStr ){ aStrArr[SbaIniWrap::SALUTATION]=rStr; }
	inline void		SetTelPriv( const String& rStr )	{ aStrArr[SbaIniWrap::HOMEPHONE]=rStr; }
	inline void		SetTelGesch( const String& rStr )	{ aStrArr[SbaIniWrap::WORKPHONE]=rStr; }
	inline void		SetFax( const String& rStr )		{ aStrArr[SbaIniWrap::FAX]=rStr; }
	inline void		SetEmail( const String& rStr )		{ aStrArr[SbaIniWrap::EMAIL]=rStr; }
	inline void		SetURL( const String& rStr )		{ aStrArr[SbaIniWrap::URL]=rStr; }
	inline void		SetNote( const String& rStr )		{ aStrArr[SbaIniWrap::NOTE]=rStr; }
	inline void		SetUserField1( const String& rStr )	{ aStrArr[SbaIniWrap::OLDFIELD1]=rStr; }
	inline void		SetUserField2( const String& rStr )	{ aStrArr[SbaIniWrap::OLDFIELD2]=rStr; }
	inline void		SetUserField3( const String& rStr )	{ aStrArr[SbaIniWrap::OLDFIELD3]=rStr; }
	inline void		SetUserField4( const String& rStr )	{ aStrArr[SbaIniWrap::OLDFIELD4]=rStr; }
	inline void		SetState( const String& rStr )		{ aStrArr[SbaIniWrap::STATE]=rStr; }
	inline void		SetOfficePhone( const String& rStr ) {aStrArr[SbaIniWrap::OFFICEPHONE]=rStr; }
	inline void		SetPager( const String& rStr )		{ aStrArr[SbaIniWrap::PAGER]=rStr; }
	inline void		SetHandyPhone( const String& rStr )	{ aStrArr[SbaIniWrap::HANDYPHONE]=rStr; }
	inline void		SetOtherPhone( const String& rStr )	{ aStrArr[SbaIniWrap::OTHERPHONE]=rStr; }
	inline void		SetCalendarURL( const String& rStr ) {aStrArr[SbaIniWrap::CALENDARURL]=rStr; }
	inline void		SetInvite( const String& rStr )		{ aStrArr[SbaIniWrap::INVITE]=rStr; }
};


#endif

