/*************************************************************************
 *
 *  $RCSfile: address.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <vos/mutex.hxx>
#ifndef __STARDIV_UNO_UTIL_COMP_HXX__ //autogen wg. XComponent
#include <stardiv/uno/util/comp.hxx>
#endif
#ifndef _USR_LSTCOMP_HXX //autogen wg. ListenerContainer
#include <usr/lstcont.hxx>
#endif
#ifndef __STARDIV_UNO_UTIL_EVTLSTER_HXX__ //autogen wg. XEventListener
#include <stardiv/uno/util/evtlster.hxx>
#endif
#include <usr/factoryhlp.hxx>
#include <usr/reflserv.hxx>
#include <stardiv/uno/lang/serviceinfo.hxx>
#include <stardiv/one/frame/xstatind.hxx>
#include <stardiv/one/address/address.hxx>

#ifndef _USR_PROPSHLP_HXX
#include <usr/propshlp.hxx>
#endif

#include <usr/comphlp.hxx>

#ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_CTOR
#include <tools/debug.hxx>
#endif

#include "sbadbcom.hxx"

#ifndef _USR_MACROS_HXX //autogen wg. NAMESPACE_USR
#include <usr/macros.hxx>
#endif

#ifndef _USR_SERVICES_HXX
#include <usr/services.hxx>
#endif
#include <tools/presys.h>
#include <vector.h>
#include <algo.h>
#include <tools/postsys.h>


#ifdef _USE_NAMESPACE
using namespace usr;
using namespace vos;
#endif

class SbaXAddressbookSource :	public OComponentHelper,
								public XAddressBookCursorDescriptorFactory,
								public XAddressBookSchemataSupplier,
								public XAddressBookCursorFactory,
								public OPropertySetHelper,
								public XServiceInfo
{
protected:
	OMutex					m_aMutex;

private:
	Sequence<AddressBookSourceMappedSchema>		m_Schemata;
	UString										m_ServiceName;
	UString										m_Name;
	UString										m_File;

	vector<UString>			getColumnNames(const UString& rAddrFieldName);
	UString					getColumnNames(const Sequence<UString>& rColumns,const Sequence<UString>& rSchemata);
	void					buildQuery(UString& rQuery,const AddressBookQueryTerm& aTerm);
	void					buildQuery(UString& rQuery,const Sequence<UsrAny>& rList);
	UString					retValue(const UsrAny& rValue);

public:
	SMART_UNO_DECLARATION( SbaXAddressbookSource, OComponentHelper );
							SbaXAddressbookSource();
							~SbaXAddressbookSource();
	// XInterface
	virtual BOOL 			queryInterface( UsrUik aUIK, XInterfaceRef& );

	// XIdlClassProvider
	Sequence< XIdlClassRef > getIdlClasses(void);

	// XServiceInfo
	UString 				getImplementationName() THROWS( (UsrSystemException) );
	BOOL 					supportsService(const UString& ServiceName) THROWS( (UsrSystemException) );
	Sequence< UString > 	getSupportedServiceNames(void) THROWS( (UsrSystemException) );

	static UString 			getImplementationName_Static() THROWS( () );

	static XIdlClassRef		getStaticIdlClass();
	static Sequence<UString>	getSupportedServiceNames_Static(void) THROWS( (UsrSystemException) );

	friend	XInterfaceRef 	SbaXAddressbookSource_CreateInstance( const XMultiServiceFactoryRef& rSMgr ) THROWS((Exception));

	// XAddressBookCursorDescriptorFactory
	virtual XInterfaceRef	createCursorDescriptor(void) THROWS( (UsrSystemException) );

	// XAddressBookSchemataSupplier
	virtual XNameAccessRef	getSchemata(void) THROWS( (UsrSystemException) );

	// XAddressBookCursorFactory
	virtual XDatabaseCursorRef createCursorByDescriptor(const XPropertySetRef& cursorDescriptor) THROWS( (UsrSystemException) );

	// OPropertySetHelper
	virtual IPropertyArrayHelper & getInfoHelper() const;
	virtual void			setFastPropertyValue_NoBroadcast( INT32 nHandle, const UsrAny& rValue ) THROWS( (Exception) );
	virtual void			getFastPropertyValue( UsrAny& rValue, INT32 nHandle ) const;
	virtual BOOL			convertFastPropertyValue( UsrAny & rConvertedValue, UsrAny & rOldValue, INT32 nHandle, const UsrAny& rValue )
								THROWS( (IllegalArgumentException) );
	virtual XPropertySetInfoRef getPropertySetInfo() const;
};
