/*************************************************************************
 *
 *  $RCSfile: addrpi.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_ADDRPI_HXX
#define _SBA_ADDRPI_HXX

// include ---------------------------------------------------------------

#ifndef _FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _IMAGEBTN_HXX
#include <vcl/imagebtn.hxx>
#endif
#ifndef _MENUBTN_HXX
#include <vcl/menubtn.hxx>
#endif
#ifndef _COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif
#ifndef _FLOATWIN_HXX
#include <vcl/floatwin.hxx>
#endif
#ifndef _TOOLBOX_HXX
#include <vcl/toolbox.hxx>
#endif
#ifndef _TABBAR_HXX //autogen
#include <svtools/tabbar.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif
#ifndef _SV_DECOVIEW_HXX //autogen
#include <vcl/decoview.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _SBA_SBAENUM_HXX
#include "sbaenum.hxx"
#endif
#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

// enum ------------------------------------------------------------------

enum eSearchModeType
{
	NoSearch,
	SetSearchData,
	SearchActive
};

// class GotoEdit --------------------------------------------------------

class GotoEdit_Impl : public Edit
{
private:
	Link    aKeyLink;

public:
	GotoEdit_Impl( Window* pParent, const ResId& rId ) : Edit( pParent, rId ) {}

	void    KeyInput( const KeyEvent& rKeyEvent );
	void    SetKeyReturnLink( const Link& rNewLink ) { aKeyLink = rNewLink; }
};

// class DragButton_Impl -------------------------------------------------

class SbaAddrPI;

class DragButton_Impl : public FixedImage
{
private:
	SbaAddrPI*		pAddrPI;

public:
	DragButton_Impl( SbaAddrPI* pParent );

	virtual void 	Command ( const CommandEvent& rCEvt );
	virtual void	MouseMove( const MouseEvent& rMEvt );
	virtual void	MouseButtonDown( const MouseEvent& rMEvt );
};

// class SbaAddrPI -------------------------------------------------------

class SbaAddrMan;
class SbaAddrContainer;
class SbaObject;
class SbaLDAPSearcher;
class LDAPCancellable_Impl;
class SbaExplorerExchObj;

class SbaAddrPI : public ModelessDialog, public SfxControllerItem, public SfxListener
{
private:
					// Controls
	TabBar			aTabBar;

	FixedText		aFTAnrede;
	ComboBox		aCBAnrede;
	Edit			aEdTitel;
	FixedText		aFTVorname;
	Edit			aEdVorname;
	FixedText		aFTName;
	Edit			aEdName;
	FixedText		aFTBriefanrede;
	Edit			aEdBriefanrede;
	FixedText		aFTStrasse;
	Edit			aEdStrasse;
	FixedText		aFTState;
	Edit			aEdLand;
	Edit			aEdState;
	FixedText		aFTOrt;
	Edit			aEdPLZ;
	Edit			aEdOrt;

	FixedText		aFTKuerzel;
	Edit			aEdKuerzel;
	FixedText		aFTTelPriv;
	Edit			aEdTelPriv;
	FixedText		aFTTelHandy;
	Edit			aEdTelHandy;
	FixedText		aFTFax;
	Edit			aEdFax;
	FixedText		aFTEmail;
	Edit			aEdEmail;
	FixedText		aFTURL;
	Edit			aEdURL;

	FixedText		aFTFullName;
	FixedText		aFTFullNameValue;
	FixedText		aFTFirma;
	Edit			aEdFirma;
	FixedText		aFTAbteilung;
	Edit			aEdAbteilung;
	FixedText		aFTPosition;
	Edit			aEdPosition;

	FixedText		aFTTelGesch;
	Edit			aEdTelGesch;
	FixedText		aFTTelOffice;
	Edit			aEdTelOffice;
	FixedText		aFTTelOther;
	Edit			aEdTelOther;
	FixedText		aFTPager;
	Edit			aEdPager;

	FixedText		aFTUser1;
	Edit			aEdUser1;
	FixedText		aFTUser2;
	Edit			aEdUser2;
	FixedText  		aFTUser3;
	Edit			aEdUser3;
	FixedText		aFTUser4;
	Edit			aEdUser4;
	FixedText		aFTNote;
	MultiLineEdit	aEdNote;
	FixedLine		aOtherLine;
	FixedText		aFTCalendarURL;
	Edit			aEdCalendarURL;
	CheckBox		aCBInvite;

	ToolBox         aSelectBox;

	MenuButton		aSearchMenuBtn;
	PushButton		aBTSuchen;
	PushButton		aEndBtn;

	ImageButton		aBTFirst;
	ImageButton		aBTPrev;

	GotoEdit_Impl	aEdActualNumber;

	ImageButton		aBTNext;
	ImageButton		aBTLast;

	ToolBox			aActionBox;

	DragButton_Impl	aDragBtn;
	FixedText		aFTStatus;
	GroupBox		aHiddenGB;
	DecorationView	aDecoView;

							// Extras
	String					aEmptyStr;
	String                  aStrSearch;
	String                  aStrSearchStart;
	String                  aStrSearchStop;
	String                  aStrAnreden;
	String					aLDAPServer;
	String                  aActualSelection;
	String                  aTitleTextBase;		// "Adressbuch"
	String					aSearchStr;			// "Suche"
	String					aNameStr;			// "Name"
	String					aPhoneStr;			// "Telefon"
	String					aNewBtnStr;			// zum Umtauschen
	String					aReadOnlyStr;		// (Schreibgesch"utzt)

	USHORT					nDefItemId;
#if (SUPD < 580)
	USHORT					nFirstScheduleMenuId;
#endif
	ULONG					nNewBtnHelpId;		// zum Vertauschen
	SbaLDAPSearcher*		pLDAPSearcher;
	LDAPCancellable_Impl*	pLDAPCancel;
	SbaAddrMan*             pSbaAddrMan;
	SbaObject*              pSbaObject;
	SbaDatabaseRef          aDB;

	// wird bei Anlegen eines neuen Datensatzes auf TRUE gesetzt
	BOOL                    bAppendActualRecord;
	BOOL                    bDontUseDBase;
	BOOL                    bModified;
	BOOL                    bReadOnlyDoc;
	BOOL					bInLDAPMode;
#if (SUPD < 580)
	BOOL					bInScheduleLDAPMode;
#endif
	BOOL					bHasLDAPServer;
	BOOL					bAddRecordMode;
	BOOL                    bEinfuegen;
	BOOL					bMischen;
	BOOL                    bMustUpdate;
	BOOL                    bNotifyDisabled;
	BOOL					bStatus;
	BOOL					bTextChanged;
	long					nStatusOffset;
	ULONG                   nFirstRecordCount;
	eSearchModeType			eSearchMode;

	// methods
	BOOL		CheckDBFormat();
	void		GetDBaseData();
	void		ClearFields();
	void		GetFields( SbaAddrContainer& rSbaCont, BOOL bWrite );
	void		SetFields( const SbaAddrContainer& rSbaCont );
	void		SetFieldsLen();
	void		WriteRecord();
	void		InsertRecord();
	void		DrawTitleBar( ULONG nCnt );

	void		NoSearchImpl( BOOL bClear = TRUE );
	void		SetSearchDataImpl();
	void		SearchActiveImpl();
	void		SetReadOnly( BOOL bReadOnly );
	void		DisableAll();
	void		EnableAll();
	void		Enable4LDAP( BOOL bEnable, BOOL bSchedule );
	void		EnableNavButtons();
	void		UpdateAnredeList();
	BOOL		Init();
	void		NewRecord();
	void		AddRecord();
	void		DeleteRecord();
	void		ResetRecord();
	void		BroadcastUpdate();
	void        SetFocusInFirstControl();

	DECL_LINK( GotoRecord, void * );
	DECL_LINK( NextButtonClickHdl, Button * );
	DECL_LINK( PrevButtonClickHdl, Button * );
	DECL_LINK( LastButtonClickHdl, Button * );
	DECL_LINK( FirstButtonClickHdl, Button * );
	DECL_LINK( LoeschenButtonClickHdl, Button * );
	DECL_LINK( AddBtnClickHdl, Button * );
	DECL_LINK( RueckgaengigButtonClickHdl, Button * );
	DECL_LINK( SearchHdl, Control * );
	DECL_LINK( SearchEndHdl, Button * );
	DECL_LINK( FinishedHdl, SbaLDAPSearcher * );

	DECL_LINK( ToolBoxClickHdl, ToolBox * );
	DECL_LINK( ActionHdl, ToolBox * );
	DECL_LINK( TabSelectHdl, TabBar * );
	DECL_LINK( ModifyHdl, Control * );

public:
	SbaAddrPI( Window* pParent, BOOL& rSuccess, SbaObject* pObj,
			   BOOL bInsert = TRUE, BOOL bMerge = TRUE );
	~SbaAddrPI();

	BOOL 			Close();
	void 			Shutdown();
	void 			AutoSelect( const String& rName, SbaSearchField eInField );
	void 			AutoInsert( const String& rName, SbaSearchField eInField );
	BOOL 			OnChangeAddrbook();
	void			StopLDAPSearch() { SearchActiveImpl(); }
	void			ShowStatusText( const String& rStatus );
	void			HideStatusText();

	SbaExplorerExchObj*	GetExchangeObject();

	virtual void    StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual void 	ModifyNotify( Control* pDlgItem );
	virtual void    Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
	virtual long    Notify( NotifyEvent& rNEvt );
	virtual void	Paint( const Rectangle& rRect );
};


#endif

