/*************************************************************************
 *
 *  $RCSfile: api.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_API_HXX
#define _SBA_API_HXX 1

#ifndef _COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP_
#include <com/sun/star/lang/WrappedTargetException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_INDEXOUTOFBOUNDSEXCEPTION_HPP_
#include <com/sun/star/lang/IndexOutOfBoundsException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_NOSUCHELEMENTEXCEPTION_HPP_
#include <com/sun/star/container/NoSuchElementException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCHILD_HPP_
#include <com/sun/star/container/XChild.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_SQLEXCEPTION_HPP_
#include <com/sun/star/sdbc/SQLException.hpp>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _CPPUHELPER_COMPONENT_HXX_
#include <cppuhelper/component.hxx>
#endif
#ifndef _CPPUHELPER_WEAKREF_HXX_
#include <cppuhelper/weakref.hxx>
#endif
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _SDB_SDBSTAT_HXX //autogen
#include <sdb/sdbstat.hxx>
#endif

class SdbObj;

typedef std::vector< ::com::sun::star::uno::WeakReferenceHelper > OWeakRefArray;

//************************************************************
// SQLException_Impl
//************************************************************
class SQLException_Impl : public ::com::sun::star::sdbc::SQLException
{
public:
	SQLException_Impl(const SdbStatus& rStat, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & xCont);
	SQLException_Impl(const UniString& rDescription);
};

// checks the result of a database acton
void checkResult(const SdbStatus&, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >&, sal_Bool bWrap = sal_False)
			 throw( ::com::sun::star::sdbc::SQLException, ::com::sun::star::lang::WrappedTargetException );

void throwSequenceError(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & xCont)
			 throw( ::com::sun::star::sdbc::SQLException );

//************************************************************
// OSharedMutex
//************************************************************
class OSharedMutex : public ::osl::Mutex
{
	oslInterlockedCount	m_refCount;

public:
	OSharedMutex(){};
	void addRef() {osl_incrementInterlockedCount( &m_refCount ) ;}
	void releaseRef(){ if (osl_decrementInterlockedCount(&m_refCount) == 0) delete this;}
};

//************************************************************
// OShared
//************************************************************
class OShared
{
public:
	OSharedMutex* m_pMutex;

public:
	OShared(OSharedMutex* pMutex):m_pMutex(pMutex){m_pMutex->addRef();}
	virtual ~OShared(){m_pMutex->releaseRef();}
};

//************************************************************
// OSubComponent
//************************************************************
class OSubComponent : public ::cppu::OComponentHelper
{
protected:
	// the parent must support the tunnel implementation
	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > m_xParent;

public:
	OSubComponent(::osl::Mutex& _rMutex,
				  const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _xParent);

// ::com::sun::star::lang::XTypeProvider
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes() throw (::com::sun::star::uno::RuntimeException);

// ::com::sun::star::uno::XInterface
	virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType )
			throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL release() throw(::com::sun::star::uno::RuntimeException);

	inline operator ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > () const
		{ return (::com::sun::star::uno::XWeak *)this; }

protected:
	virtual void SAL_CALL disposing();
};

class OStubComponent;
//************************************************************
// OServerComponent
//************************************************************
class OServerComponent : public OShared
						,public OSubComponent
						,public ::com::sun::star::lang::XUnoTunnel
{
protected:
	OWeakRefArray m_aStubs;

public:
	OServerComponent(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _xParent):OShared(new OSharedMutex()), OSubComponent(*m_pMutex, _xParent){};

// ::com::sun::star::lang::XTypeProvider
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes() throw (::com::sun::star::uno::RuntimeException);

// ::com::sun::star::uno::XInterface
	virtual void SAL_CALL acquire() throw(::com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL release() throw(::com::sun::star::uno::RuntimeException);
	virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( const ::com::sun::star::uno::Type & rType )
			throw(::com::sun::star::uno::RuntimeException);

// com::sun::star::lang::XUnoTunnel
	virtual sal_Int64 SAL_CALL getSomething( const ::com::sun::star::uno::Sequence< sal_Int8 >& aIdentifier ) throw(::com::sun::star::uno::RuntimeException);

	void appendStub(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > &);

protected:
	virtual void SAL_CALL disposing();
};


//************************************************************
// OStubComponent
//************************************************************
class OStubComponent : public OShared, public OSubComponent
{
	OServerComponent* m_pServer;

public:
	OStubComponent(OServerComponent& rServer);

protected:
	// getServer is not protected by a guard
	virtual sal_Int64 getServer(const ::com::sun::star::uno::Sequence< sal_Int8 >& _rId) const
		throw( ::com::sun::star::lang::DisposedException );
};


//************************************************************
// ODbImplObjects
//************************************************************
class ODbImplObjects
{
public:
	ODbImplObjects(){}

	virtual SdbObj* getByName(DBObject _eObj, const rtl::OUString& _rName) throw( ::com::sun::star::container::NoSuchElementException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException ) = 0;
	virtual SdbObj* getByIndex(DBObject _eObj, sal_Int32 _nPos) throw( ::com::sun::star::lang::IndexOutOfBoundsException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException ) = 0;
	virtual void refresh(DBObject _eObj) throw( ::com::sun::star::uno::RuntimeException  ) = 0;
	virtual ::com::sun::star::uno::Sequence<rtl::OUString> getElementNames(DBObject _eObj) throw( ::com::sun::star::uno::RuntimeException  ) = 0;
	virtual sal_Int32 getCount(DBObject _eObj) throw( ::com::sun::star::uno::RuntimeException ) = 0;
};

//************************************************************
// OConnectionBase
//************************************************************
class OConnectionBase : public OServerComponent,
						public ODbImplObjects
{
public:
	OConnectionBase(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& _xParent):OServerComponent(_xParent){}
};

// Macro for accessing the server
#define GET_SERVER(server_name)	\
reinterpret_cast<server_name*>(getServer(server_name##::getUnoTunnelId()))

#define USE_SERVER(server_name)	\
server_name* pServer = reinterpret_cast<server_name*>(getServer(server_name##::getUnoTunnelId()))

#define SERVER_EXECUTE(server_name, method)		\
	try											\
	{											\
		osl::MutexGuard aGuard(*m_pMutex);		\
		GET_SERVER(server_name)->method;		\
	}											\
	catch (::com::sun::star::uno::Exception e)	\
	{											\
		e.Context = static_cast<XWeak*>(this);	\
		throw;									\
	}

#define RETURN_SERVER_RESULT(server_name, method, returntype)		\
	returntype result;										\
	try														\
	{														\
		osl::MutexGuard aGuard(*m_pMutex);					\
		result = GET_SERVER(server_name)->method;			\
	}														\
	catch (::com::sun::star::uno::Exception e)				\
	{														\
		e.Context = static_cast<XWeak*>(this);				\
		throw;												\
	}														\
	return result


// hash classes
//************************************************************
struct OBookmarkHash
{
	size_t operator() (const ::com::sun::star::uno::Any& rBookmark) const;
};

struct OBookmarkEqual
{
	sal_Bool operator() (const ::com::sun::star::uno::Any& lhs, const ::com::sun::star::uno::Any& rhs) const;
};

// helper methods
//************************************************************
sal_Bool hasString(const ::com::sun::star::uno::Sequence< rtl::OUString >& rStrings, const rtl::OUString& rString);


//************************************************************
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL ORowSet_CreateInstance(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &) throw( ::com::sun::star::uno::Exception );
::com::sun::star::uno::Sequence< ::rtl::OUString> ORowSet_getSupportedServiceNames(void) throw( ::com::sun::star::uno::RuntimeException );
::rtl::OUString ORowSet_getImplementationName(void) throw( ::com::sun::star::uno::RuntimeException );
//************************************************************


/// compares two strings representing an ::com::sun::star::util::URL each (which is more than a string compare)
sal_Int32 compareURLs(const rtl::OUString& _rUrlLeft, const rtl::OUString& _rUrlRight);

/// subst any $(...) vars in the given ::com::sun::star::util::URL if it is an file ::com::sun::star::util::URL
void substFileURLVars(rtl::OUString& rUrl);

int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	AliasProgrammaticPairCompareByURL( const void* pFirst, const void* pSecond);

int
#if defined( WNT )
 __cdecl
#endif
#if defined( ICC ) && defined( OS2 )
_Optlink
#endif
	AliasProgrammaticPairCompareByName( const void* pFirst, const void* pSecond);

/// normalize the given file url so it may be used with all the XLocalizableAliases methods of our DatabaseAccessContext
String getProgrammaticUrl(const String& _rSdbFile);

//------------------------------------------------------------------------------
#define BEGIN_PROPERTY_HELPER(count)							\
	::com::sun::star::uno::Sequence< ::com::sun::star::beans::Property> aDescriptor(count);	\
	::com::sun::star::beans::Property* pDesc = aDescriptor.getArray();					\
	INT32 nPos = 0;												\

//------------------------------------------------------------------------------
#define DECL_PROP_IMPL(varname, cpputype) \
	pDesc[nPos++] = ::com::sun::star::beans::Property(PROPERTY_##varname, PROPERTY_ID_##varname, cpputype,

//------------------------------------------------------------------------------
#define DECL_PROP0(varname, type)	\
	DECL_PROP_IMPL(varname, ::getCppuType((const type *)0)) 0)
//------------------------------------------------------------------------------
#define DECL_PROP0_BOOL(varname)	\
	DECL_PROP_IMPL(varname, ::getBooleanCppuType()) 0)

//------------------------------------------------------------------------------
#define DECL_PROP1(varname, type, attrib1)	\
	DECL_PROP_IMPL(varname, ::getCppuType((const type *)0)) ::com::sun::star::beans::PropertyAttribute::##attrib1)
//------------------------------------------------------------------------------
#define DECL_PROP1_BOOL(varname, attrib1)	\
	DECL_PROP_IMPL(varname, ::getBooleanCppuType()) ::com::sun::star::beans::PropertyAttribute::##attrib1)

//------------------------------------------------------------------------------
#define DECL_PROP2(varname, type, attrib1, attrib2)	\
	DECL_PROP_IMPL(varname, ::getCppuType((const type *)0)) ::com::sun::star::beans::PropertyAttribute::##attrib1 | ::com::sun::star::beans::PropertyAttribute::##attrib2)
//------------------------------------------------------------------------------
#define DECL_PROP2_BOOL(varname, attrib1, attrib2)	\
	DECL_PROP_IMPL(varname, ::getBooleanCppuType()) ::com::sun::star::beans::PropertyAttribute::##attrib1 | ::com::sun::star::beans::PropertyAttribute::##attrib2)

//------------------------------------------------------------------------------
#define DECL_PROP3(varname, type, attrib1, attrib2, attrib3)	\
	DECL_PROP_IMPL(varname, ::getCppuType((const type *)0)) ::com::sun::star::beans::PropertyAttribute::##attrib1 | ::com::sun::star::beans::PropertyAttribute::##attrib2 | ::com::sun::star::beans::PropertyAttribute::##attrib3)
//------------------------------------------------------------------------------
#define DECL_PROP3_BOOL(varname, attrib1, attrib2, attrib3)	\
	DECL_PROP_IMPL(varname, ::getBooleanCppuType()) ::com::sun::star::beans::PropertyAttribute::##attrib1 | ::com::sun::star::beans::PropertyAttribute::##attrib2 | ::com::sun::star::beans::PropertyAttribute::##attrib3)


//------------------------------------------------------------------------------
#define END_PROPERTY_HELPER()								\
	DBG_ASSERT(nPos == aDescriptor.getLength(), "<...>::getInfohelper : forgot to adjust the count ?");	\
	return new ::cppu::OPropertyArrayHelper(aDescriptor);




#endif

