/*************************************************************************
 *
 *  $RCSfile: copytbl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_COPYTBL_HXX
#define _SBA_COPYTBL_HXX

#include "rtfcpydg.hxx"

#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

#ifndef _SBA_DBDATDEF_HXX
#include "dbdatdef.hxx"
#endif

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SBA_DBEXCH_HXX
#include "dbexch.hxx"
#endif // _SBA_DBEXCH_HXX

//========================================================================
class SbaDBDataDefRef;
class DlgLongName : public ModalDialog
{
private:
	OKButton		aPB_OK;
	CancelButton	aPB_CANCEL;
	HelpButton		aPB_HELP;
	PushButton		aPB_Auto;

	FixedText		aFT_Info;
	FixedText		aFT_Name;
	Edit			aET_Name;

	String&			rFieldName;
	BOOL&			rbAutoAdjust;
	SbaDBDataDefRef xDestDef;

	DECL_LINK( OKClickHdl, Button* );
	DECL_LINK( AutoClickHdl, Button* );

public:
	DlgLongName( Window* pParent, String& rName, const String& rLongName, BOOL& rbAuto, SbaDBDataDef* pDestDef );
	virtual ~DlgLongName();
};

//========================================================================
class DlgCopyTable : public SbaWizardPage
{
protected:
	FixedBitmap			m_aFBmpCopyTable;
	GroupBox			m_aGB_Temp;
	FixedText			m_ftTableName;
	Edit				m_edTableName;
	GroupBox			m_aGB_Options;
	RadioButton			m_aRB_DefData;
	RadioButton			m_aRB_Def;
	RadioButton			m_aRB_View;
	RadioButton			m_aRB_AppendData;
	CheckBox			m_aCB_PrimaryColumn;
	FixedText			m_aFT_KeyName;
	Edit				m_edKeyName;
	CopyTableWizard::Wizard_Create_Style m_eOldStyle;

	SbaWizColumnSelect* m_pPage2;
	SbaWizNormalExtend*	m_pPage3;

	BOOL				m_bIsViewAllowed;
	BOOL				m_bPKeyAllowed;


	DECL_LINK( AppendDataClickHdl, Button* );
	DECL_LINK( RadioChangeHdl, Button* );
	DECL_LINK( KeyClickHdl, Button* );

public:
	virtual	void			Reset();
	virtual void			ActivatePage();
	virtual BOOL			LeavePage();
	virtual String			GetTitle() const ;

	DlgCopyTable( Window * pParent, SbaExplorerExchObj::ACTION_TYPE atWhat, BOOL bIsQuery, USHORT nLastAction );
	virtual ~DlgCopyTable();

	BOOL IsOptionDefData() const { return m_aRB_DefData.IsChecked(); }
	BOOL IsOptionDef() const { return m_aRB_Def.IsChecked(); }
	BOOL IsOptionAppendData() const { return m_aRB_AppendData.IsChecked(); }
	BOOL IsOptionView() const { return m_aRB_View.IsChecked(); }

};

#endif

