/*************************************************************************
 *
 *  $RCSfile: databasecontext.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DATABASECONTEXT_HXX
#define _SBA_DATABASECONTEXT_HXX 1

#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XNAMINGSERVICE_HPP_
#include <com/sun/star/uno/XNamingService.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEENVIRONMENT_HPP_
#include <com/sun/star/sdb/XDatabaseEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
#include <com/sun/star/lang/Locale.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XLOCALIZABLE_HPP_
#include <com/sun/star/lang/XLocalizable.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XSIMPLEREGISTRY_HPP_
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
#include <com/sun/star/util/XLocalizedAliases.hpp>
#endif
#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef _CPPUHELPER_COMPBASE7_HXX_
#include <cppuhelper/compbase7.hxx>
#endif
#ifndef _SBA_API_HXX
#include <api.hxx>
#endif

// needed for registration
namespace com { namespace sun { namespace star {
	namespace lang
	{
		class XMultiServiceFactory;
		class IllegalArgumentException;
	}
}}}

class SvxLanguageTable;
::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL ODatabaseAccessContext_CreateInstance(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > &) throw( ::com::sun::star::uno::Exception );

//************************************************************
//  ODatabaseAccessContext
//************************************************************
typedef ::cppu::WeakComponentImplHelper7< ::com::sun::star::lang::XServiceInfo,
										  ::com::sun::star::container::XEnumerationAccess,
										  ::com::sun::star::container::XNameAccess,
										  ::com::sun::star::uno::XNamingService,
										  ::com::sun::star::util::XLocalizedAliases,
										  ::com::sun::star::lang::XLocalizable,
										  ::com::sun::star::lang::XUnoTunnel > DatabaseAccessContext_Base;

class ODatabaseAccessContext;
//	typedef ::utl::UnoTunnelHelper< ODatabaseAccessContext >	ODatabaseAccessContext_TunnelBase;

class ODatabaseAccessContext
			:public DatabaseAccessContext_Base
{

protected:
	::osl::Mutex	m_aMutex;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > 	m_xServiceManager;
	::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment > 	m_xEnvironment;
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry > 	m_xRegistry;
	::com::sun::star::lang::Locale	m_aCurrentLocale;

	SvxLanguageTable*		m_pLanguages;
		// want to create the table in a controlled environment (with a locked SolarMutex)

public:
	ODatabaseAccessContext(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >&);
	virtual ~ODatabaseAccessContext();


// OComponentHelper
	virtual void SAL_CALL disposing(void);

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64 SAL_CALL getSomething(const ::com::sun::star::uno::Sequence<sal_Int8>& _rIdentifier) throw( ::com::sun::star::uno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// ::com::sun::star::lang::XServiceInfo
    virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(  ) throw(::com::sun::star::uno::RuntimeException);

// ::com::sun::star::lang::XServiceInfo - static methods
	static ::com::sun::star::uno::Sequence< ::rtl::OUString > getSupportedServiceNames_Static(void) throw( ::com::sun::star::uno::RuntimeException );
	static ::rtl::OUString getImplementationName_Static(void) throw( ::com::sun::star::uno::RuntimeException );

// ::com::sun::star::container::XElementAccess
    virtual ::com::sun::star::uno::Type SAL_CALL getElementType(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL hasElements(  ) throw(::com::sun::star::uno::RuntimeException);

// ::com::sun::star::container::XEnumerationAccess
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration > SAL_CALL createEnumeration(  ) throw(::com::sun::star::uno::RuntimeException);

// ::com::sun::star::container::XNameAccess
	virtual ::com::sun::star::uno::Any SAL_CALL getByName( const ::rtl::OUString& aName ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::lang::WrappedTargetException, ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getElementNames(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL hasByName( const ::rtl::OUString& aName ) throw(::com::sun::star::uno::RuntimeException);

// ::com::sun::star::uno::XNamingService
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL getRegisteredObject( const ::rtl::OUString& Name ) throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL registerObject( const ::rtl::OUString& Name, const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >& Object ) throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL revokeObject( const ::rtl::OUString& Name ) throw(::com::sun::star::uno::Exception, ::com::sun::star::uno::RuntimeException);

// ::com::sun::star::util::XLocalizedAliases
    virtual void SAL_CALL bindAlias( const ::rtl::OUString& programmaticName, const ::com::sun::star::lang::Locale& locale, const ::rtl::OUString& alias ) throw(::com::sun::star::container::ElementExistException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL unbindAlias( const ::com::sun::star::lang::Locale& locale, const ::rtl::OUString& alias ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL lookupAlias( const ::com::sun::star::lang::Locale& locale, const ::rtl::OUString& Alias ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL lookupProgrammatic( const ::com::sun::star::lang::Locale& locale, const ::rtl::OUString& programmatic ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL unbindAliases( const ::rtl::OUString& programmaticName ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL rebindAliases( const ::rtl::OUString& currentProgrammatic, const ::rtl::OUString& newProgrammatic ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::container::ElementExistException, ::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL renameAlias( const ::com::sun::star::lang::Locale& locale, const ::rtl::OUString& oldName, const ::rtl::OUString& aNewName ) throw(::com::sun::star::container::NoSuchElementException, ::com::sun::star::container::ElementExistException, ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair > SAL_CALL listAliases( const ::com::sun::star::lang::Locale& locale ) throw(::com::sun::star::uno::RuntimeException);

// ::com::sun::star::lang::XLocalizable
    virtual void SAL_CALL setLocale( const ::com::sun::star::lang::Locale& eLocale ) throw(::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::lang::Locale SAL_CALL getLocale(  ) throw(::com::sun::star::uno::RuntimeException);

// other
	/** want to make any informations about an database ("programmatic") persistent ? use this !
		(beware : the returned registry isn't fully implemented yet, for instance you can't reopen or close it !)
	*/
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XSimpleRegistry > getSubRegistry(const rtl::OUString& _rURL);
	/**	"rename" the sub registry for a special programmatic, so it is accessable under the new name
	*/
	void	renameSubRegistry(const rtl::OUString& _rOldURL, const rtl::OUString& _rNewURL);

private:
	/// open or create the registry. called only once
	void	implGetRegistry();

	/// register the address db. called only once
	void	implRegisterAddressDB();

	/// supplies a user-readable name for the given Locale
	rtl::OUString getDisplayName(const ::com::sun::star::lang::Locale& _rLoc);

	/// get the key where all languages reside
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  getAllLanguageKey() const;

	/// get the key for the given locale (empty ::com::sun::star::util::Language/Country members -> the fallback key)
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  getLanguageKey(const ::com::sun::star::lang::Locale& _rLoc, sal_Bool _bCreate) const;

	/// the the key name a locale would be stored under
	rtl::OUString getLanguageString(const ::com::sun::star::lang::Locale& _rLoc) const;

	/// inverse of getLanguageString
	::com::sun::star::lang::Locale getLocaleFromLangKey(const rtl::OUString& _rLangKey) const;

	/// get the location for a given title
	rtl::OUString	implGetLocation(const rtl::OUString& _rTitle, const ::com::sun::star::lang::Locale& _rLoc) const;

	/// get the local of the application
	::com::sun::star::lang::Locale	getCurrentLocale() const;

	/** is the given title unique within the given language ?
		creates a key for the given language if necessary
	*/
	void checkTitleExistence(const rtl::OUString& _rTitle, const rtl::OUString& _rLang) throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::registry::InvalidRegistryException );

	/** the given title is a valid fallback for the given url ?
		(this test is rather complex)
	*/
	void checkFallbackTitleConflicts(const rtl::OUString& _rTitle, const rtl::OUString& _rURL) throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::lang::IllegalArgumentException );

	/** if _rTitle would be added to _rLoc, are there any conflicts with the fallback titles of other URLs ?
		(note: you shouldn't use that for an ::com::sun::star::util::URL which already uses _rTitle as fallback. As the method doesn't
		know anything about the ::com::sun::star::util::URL _rTitle is going to be used for, the check would fail though it would
		not be wanted for this scenario)
	*/
	void checkTitleConflicts(const rtl::OUString& _rTitle, const ::com::sun::star::lang::Locale& _rLoc) throw( ::com::sun::star::container::ElementExistException, ::com::sun::star::lang::IllegalArgumentException );

	/** register a title/url pair for the given locale. if no fallback title for the given url exists, it is
		created, too
	*/
	void implRegister(const rtl::OUString& _rName, const rtl::OUString& _rURL, const ::com::sun::star::lang::Locale& _rLoc);

	/// get the (first) title for the given url in the given language
	rtl::OUString getTitleForLanguage(const rtl::OUString& _rURL, const ::com::sun::star::lang::Locale& _rLoc);

	/// get the key which represents the given ::com::sun::star::util::URL in the given ::com::sun::star::lang::Locale (if any)
	::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey >  getUrlKey(const rtl::OUString& _rURL, const ::com::sun::star::lang::Locale& _rLoc);

	/// revoke the registration (in all languages) for an object which is - for the given local - registered under the given name
	void implRevoke(const rtl::OUString& _rName, const ::com::sun::star::lang::Locale& _rLoc);

	/// search the given ::com::sun::star::util::URL within the given language. no fallback handling. the ::com::sun::star::util::URL has to be normalized.
	rtl::OUString implLookupURL(const rtl::OUString _rName, const ::com::sun::star::lang::Locale& _rLoc);

	::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair> implCollectPairs(const ::com::sun::star::lang::Locale& _rLoc) throw( ::com::sun::star::uno::RuntimeException );

	rtl::OUString implGetShortKeyName(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > & _rxKey) const;
	::com::sun::star::uno::Sequence<rtl::OUString> implGetShortChildKeyNames(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > & _rxKey) const;
	void implCopyKeys(const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > & _rxSource, const ::com::sun::star::uno::Reference< ::com::sun::star::registry::XRegistryKey > & _rxDest);

	/// gets the url of the given object (asks the property set)
	rtl::OUString getObjectURL(const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > & _rxObject) throw( ::com::sun::star::lang::IllegalArgumentException );
};

#endif

