/*************************************************************************
 *
 *  $RCSfile: datconv.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_DATCONV_HXX_
#define _SBA_DATCONV_HXX_

// ======================================================================================================================
// =
// =	ich gebe zu, die Klasse ist mit zwei Methoden etwas duenn, aber durch ihre Benutzung kann man sicherstellen,
// =	dass der - relativ komplexe - Vorgang des Auswertens eines Strings immer auf die gleiche Weise geschieht.
// =	Zur Zeit wird das zum Beispiel benutzt im DataBrowserCtrl zur Validierung der normalen Eingabe und im Tabellenentwurf
// =	zur Ueberpruefung des fuer einen Spalte eingetragenen Default-Wertes.
// =
// ======================================================================================================================



#ifndef _SBA_DBOBJENU_HXX //autogen
#include <dbobjenu.hxx>
#endif

#ifndef _SDB_VARIANT_HXX
#include <sdb/variant.hxx>
#endif

class SvNumberFormatter;
class Color;
class SbaDbDataConverter
{
	SvNumberFormatter*	m_pFormatter;

public:
	SbaDbDataConverter(SvNumberFormatter* pFormatter) : m_pFormatter(pFormatter) { }

	/**	konvertiert den String unter Beachtung des angegebenen Typs und - wenn es ein numerisches Feld ist - der NumericSize
		wenn der String der angegebenen Formatierung entspricht, ist der Rueckgabewert TRUE und der Wert wird in die
		Variable gesteckt, sonst return FALSE
		dbBool als aRequestedType wird nicht behandelt
	*/
	BOOL String2Var(const String& strText, SbaFieldType aRequestedType, ULONG nFormatKey, SbaNumericSize aSize, ODbVariant& rVar);

	/**	der umgekehrte Weg. Das Ergebnis kann hier durchaus so etwas wie <OBJEKT> sein, denn genau das braucht man fuer die
		Anzeige von zum Beispiel Binaerfeldern.
	*/
	String Var2String(const ODbVariant& rVar, SbaFieldType aOutputType, ULONG nFormatKey, Color** ppColor, BOOL bOutput = TRUE);

	/**	konvertiert einen String in ein double. Ist im Prinzip nur ein Herausreichen von m_pFormatter->IsNumberFormat, allerdings
		werden hier Prozent-Werte etwas anders behandelt : ein NumberFormatter macht aus '15' 0.15, aus '15%' wirklich 15,
		wenn das Format ein Prozent-Format ist, diese Funktion hier liefert in beiden Faellen 15 (wie man das eigentlich erwarten
		wuerde ;)
		Ist eigentlich nur eine Hilfsfunktion fuer String2Var, aber vielleicht braucht das ja jemand ;) ...
	*/
	BOOL String2Double(const String& rText, ULONG nFormatKey, double& rRet);

	static String Var2String(const ODbVariant& rVar, SbaFieldType aOutputType, ULONG nFormatKey, Color** ppColor, SvNumberFormatter* pFormatter,BOOL bOutput = TRUE,BOOL bAutoInc=FALSE);
};


#endif // _SBA_DATCONV_HXX_
