/*************************************************************************
 *
 *  $RCSfile: dbconfig.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DBCONFIG_HXX
#define _DBCONFIG_HXX

#define	WID_CONN_FIRST				1	// Anfangsmarker
#define	WID_CONN_TYP				1	// String
#define	WID_CONN_DSN				2	// String
#define	WID_CONN_USER_ID			3	// String
#define	WID_CONN_USER_PWD			4	// String
#define	WID_CONN_CHARSET			5	// String
#define	WID_CONN_FIX				6	// BOOL
#define	WID_CONN_HDR				7	// BOOL
#define	WID_CONN_DEL				8	// Byte
#define	WID_CONN_STR				9	// Byte
#define	WID_CONN_DATEDIR			10	// String
#define	WID_CONN_DATESEP			11	// Byte
#define	WID_CONN_DATEZERO			12	// BOOL
#define	WID_CONN_DATEFOUR			13	// BOOL
#define	WID_CONN_TIMEDEL			14	// Byte
#define	WID_CONN_DECDEL				15	// Byte
#define	WID_CONN_ISDIR				16	// BOOL
#define	WID_CONN_OPTIONS			17	// String
#define	WID_CONN_TABLE				18	// String
#define	WID_CONN_PWDSAVE			19	// BOOL
#define	WID_CONN_DBASE4				20	// BOOL
#define	WID_CONN_DELETED			21	// BOOL
#define	WID_CONN_ALIAS				22	// String
#define	WID_CONN_MODIFY				23	// BOOL
#define	WID_CONN_FETCHALL			24	// BOOL
#define	WID_CONN_MAXROWS			25	// String
#define	WID_CONN_THODEL				26	// Byte
#define	WID_CONN_EXT				27	// String
#define WID_CONN_FILENAME			28  // String
#define WID_CONN_LONGTABLENAME		29  // BOOL
#define WID_CONN_URL				30	// String
#define WID_CONN_JDBCDRV			31	// String
#define WID_CONN_DBNEW				32	// Bool
#define WID_CONN_MULTI_USER_ON		33	// Bool
#define WID_CONN_NEW_ADMIN_PWD		34	// String
#define WID_CONN_TRANSACT			35	// BOOL
#define WID_CONN_DBPASSWD			36	// String
#define WID_CONN_SYSTEMDB			37	// String
#define WID_CONN_HAS_OWNER			38	// BOOL
#define WID_CONN_ORIG_ADMIN_PWD		39	// String
#define WID_CONN_ADMIN_PWD			40	// String
#define WID_CONN_ADMIN_ID			41	// String
#define WID_CONN_NEW_ADMIN_ID		42	// String
#define WID_CONN_ASK_WHEN_EMPTY_PWD	43	// BOOL
#define WID_CONN_PROVIDER			44	// String
#define WID_CONN_DATAINC			45	// Int32
#define WID_CONN_SHUTSERVICE		46	// BOOL
#define WID_CONN_CTRLUSER			47	// String
#define WID_CONN_CTRLPWD			48	// String
#define WID_CONN_CACHESIZE			49	// Int32
#define	WID_CONN_LAST				50	// Endemarker

class SfxItemPool;
class SfxPoolItem;
class SfxItemSet;
class OptionKeyList;
class Window;
class SbaDatabase;

#include "iniwrap.hxx"

class SbaDBConfig
{
protected:
	SbaIniWrap		aIniWrap;
	String			aConnectionStr,	aKey, aFileName;
	SfxItemPool*	pPool;
	SfxPoolItem**	ppPoolDefaults;
	OptionKeyList*	pOptionKeyList;

	void			ParseArgString( SfxItemSet& rSet );
	String			GetUniqueName();
	SbaDatabase*	p_mDatabase;

	String			BuildUserConnectString(SfxItemSet& rSet, const String& strUid, const String& strPwd);
		// tauscht im Set den Nutzer und das Pwd aus, ruft BuildArgString, macht das Austauschen wieder rueckgaengig, liefert
		// das Ergebnis
	SdbStatus		ExecuteSQL(const String& strSQL, SfxItemSet& aSet, const String& strAltUid, const String& strAltPwd, SdbConnectionRef& rConn);
		// fuehrt den SQL-Befehl aus. Versuche werden gestartet ueber p_mDatabase, eine aus aConnectionStr gebildete Connection
		// und eine mit dem alternativen Beutzer aus dem angegebenen Set gebildete Connecion (in diser Reihenfolge)
		// rConn enthaelt im Erfolgsfall die Connection, ueber die das Statement ausgefuehrt wurde (oder NULL, wenn es schon mit
		// p_mDatabase erfolgreich war)

public:
	SbaDBConfig(const String& rFilename, BOOL bReadOnly, const String& rConn, const String& rKey, SbaDatabase* pDatabase);
	~SbaDBConfig();

	BOOL Config();
	String	GetConnectionKey();
	String	GetConnectionStr();
	SfxPoolItem** GetPoolDefaults() const {return ppPoolDefaults;}
	String  	  BuildArgString( const SfxItemSet& rSet );
	void SetStarBaseDep(SfxItemSet &aSet);
	void SetAdabasSettings(const String &_rDsn,INT32 _nValue,const String &_Usr,const String &_Pwd);
	INT32 ReadAdabasSettings(const String &_rDsn);
};



#endif
