/*************************************************************************
 *
 *  $RCSfile: dbprogresshandler.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_DBPROGRESSHANDLER_HXX
#define _SBA_DBPROGRESSHANDLER_HXX

#ifndef _COM_SUN_STAR_UCB_XPROGRESSHANDLER_HPP_
#include <com/sun/star/ucb/XProgressHandler.hpp>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SDB_SDBENV_HXX
#include <sdb/sdbenv.hxx>
#endif
#ifndef _TASKBAR_HXX
#include <svtools/taskbar.hxx>
#endif
#ifndef _SV_MENU_HXX
#include <vcl/menu.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

//=========================================================================
class SbaProgressStatusBarControl : public ITaskStatusNotify
{
private:
	TaskStatusBar*	m_pStatusBar;
	ImageList		m_aImageList;
	String			m_aHelpText;
	String			m_CtrlUid;
	String			m_CtrlPwd;
	PopupMenu		m_aContextMenu;
	sal_uInt32		m_nMaxProgress;
	sal_uInt16		m_nImageId;
	sal_uInt16		m_nPos;
	KernelState		m_eState;

	void			ModifyStatus();
	void			Restart();
	void			Actualize();
	sal_Bool			ShutDown();
public:
					SbaProgressStatusBarControl(TaskStatusBar& rBar ,sal_uInt16 _nPos,const String& _rDBName,
												const String& _rCtrlUid,const String& _rCtrlPwd);
	virtual 		~SbaProgressStatusBarControl();

	void			SetState( KernelState _eState);
	void			EndProgress();
	virtual sal_Bool	Command( sal_uInt16 nItemd, const CommandEvent& rCEvt );
};
//------------------------------------------------------------------------
typedef ::cppu::WeakImplHelper1< ::com::sun::star::ucb::XProgressHandler >	DBProgressHandler_Base;
class DBProgressHandler : public DBProgressHandler_Base
{
	map<String,SbaProgressStatusBarControl*,::utl::UStringMixLess>	m_KernelStates;
	::osl::Mutex						m_aMutex;
	::osl::Mutex						m_aMemberMutex;
	::std::vector< AdabasKernelState >	m_States;
	sal_uInt32							m_nAsyncState;

	DECL_LINK(OnAsyncState, void*);

protected:
	~DBProgressHandler();

public:
	DECLARE_UNO3_AGG_DEFAULTS( DBProgressHandler, DBProgressHandler_Base );

	DBProgressHandler();

	// ::com::sun::star::ucb::XProgressHandler
	virtual void SAL_CALL push(const ::com::sun::star::uno::Any& Status) throw(::com::sun::star::uno::RuntimeException) { }
	virtual void SAL_CALL pop() throw(::com::sun::star::uno::RuntimeException) { }

    virtual void SAL_CALL update(const ::com::sun::star::uno::Any& Status) throw(::com::sun::star::uno::RuntimeException);
    
};

#endif //_SBA_DBPROGRESSHANDLER_HXX


