/*************************************************************************
 *
 *  $RCSfile: dlgindex.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DLGINDEXES_HXX
#define _DLGINDEXES_HXX

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
//////////////////////////////////////////////////////////////////////////
// Klasse fuer die einzelnen Indizes
class TableIndex
{
private:
	String aIndexFileName;
public:
	TableIndex();
	TableIndex( const String& rFileName ) :
		aIndexFileName( rFileName ) {}
	void SetIndexFileName( const String& rFileName ) { aIndexFileName = rFileName; }
	String GetIndexFileName() { return aIndexFileName; }
};

//////////////////////////////////////////////////////////////////////////
// Liste der Indizes einer Tabelle
DECLARE_LIST( TableIndexList, TableIndex* );

//////////////////////////////////////////////////////////////////////////
// Liste der freien Indizes
DECLARE_LIST( FreeIndexList, TableIndex* );

//////////////////////////////////////////////////////////////////////////
// Klasse fuer die INF-Datei einer Tabelle
class DlgIndexes;

class TableInfo
{
	friend class DlgIndexes;
private:
	String aTableName;
	TableIndexList aIndexList;

public:
	TableInfo();
	TableInfo( const String& rName ) :
		aTableName(rName){}
	void WriteInfFile( const String& rDSN );
};

//////////////////////////////////////////////////////////////////////////
// Liste der Tabellen
DECLARE_LIST( TableInfoList, TableInfo* );

//////////////////////////////////////////////////////////////////////////
// IndexDialog
class DlgIndexes : public ModalDialog
{
protected:
	OKButton		aPB_OK;
	CancelButton	aPB_CANCEL;
	HelpButton		aPB_HELP;
					
	FixedText		m_FT_Tables;
	ComboBox		aCB_Tables;
					
	GroupBox		m_GB_Indexes;
					
	FixedText		m_FT_TableIndexes;
	ListBox			aLB_TableIndexes;
					
	FixedText		m_FT_AllIndexes;
	ListBox			aLB_FreeIndexes;
					
	PushButton		aPB_Add;
	PushButton		aPB_Remove;
	PushButton		aPB_AddAll;
	PushButton		aPB_RemoveAll;

	DECL_LINK( TableSelectHdl, ComboBox* );
	DECL_LINK( AddClickHdl, PushButton* );
	DECL_LINK( RemoveClickHdl, PushButton* );
	DECL_LINK( AddAllClickHdl, PushButton* );
	DECL_LINK( RemoveAllClickHdl, PushButton* );
	DECL_LINK( OKClickHdl, PushButton* );

	String aDSN;
	TableInfoList aTableInfoList;
	TableIndexList aFreeIndexList;
	BOOL m_bCaseSensitiv;

	void		Init();
	void		SetCtrls();
	TableInfo*	GetTable( const String& rName );

	TableIndex* RemoveFreeIndex( const String& rName );
	void		InsertFreeIndex( TableIndex* pIndex );
	TableIndex* RemoveTableIndex( const String& rTableName, const String& rIndexName );
	void		InsertTableIndex( const String& rTableName, TableIndex* pIndex );

public:
	DlgIndexes( Window * pParent, String aDataSrcName );
	virtual ~DlgIndexes();
};

#endif

