/*************************************************************************
 *
 *  $RCSfile: fldctrl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_FLDCTRL_HXX
#define _SBA_FLDCTRL_HXX

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SBA_DBOBJENU_HXX //autogen
#include <dbobjenu.hxx>
#endif

class FixedText;
class SbaPropListBoxCtrl;
class SbaPropEditCtrl;
class SbaPropNumericEditCtrl;
class PushButton;
class SvxNumberFormatShell;
class ScrollBar;
class ListBox;
class Button;
class SbaTableDesignHelpBar;
class SbaFieldDescr;
class SbaTableEditorCtrl;
class SbaColumn;
class SvNumberFormatter;
class SbaDBDataDef;
class Control;

//==================================================================
enum SbaControlType
{
	tpDefault = 0,
	tpRequired,
	tpTextLen,
	tpNumType,
	tpLength,
	tpScale,
	tpFormat,
	tpAutoIncrement,
	tpBoolDefault,
	tpColumnName,
	tpType
};

enum SbaScrollDir
{
	scrollUp,
	scrollDown,
	scrollHome,
	scrollEnd
};

//------------------------------------------------------------------
// die Spalten einer Feld-Beschreibung einer Tabelle
#define FIELD_NAME		1
#define FIELD_TYPE		2
#define FIELD_DESCR		3

#define FIELD_FIRST_VIRTUAL_COLUMN	4

#define FIELD_PROPERTY_REQUIRED		4
#define FIELD_PROPERTY_NUMTYPE		5
#define FIELD_PROPERTY_AUTOINC		6
#define FIELD_PROPERTY_DEFAULT		7
#define FIELD_PROPERTY_TEXTLEN		8
#define FIELD_PROPERTY_LENGTH		9
#define FIELD_PROPERTY_SCALE		10
#define FIELD_PROPERTY_BOOL_DEFAULT	11
#define FIELD_PROPERTY_FORMAT		12
#define FIELD_PRPOERTY_COLUMNNAME	13
#define FIELD_PRPOERTY_TYPE			14

//==================================================================
class SbaFieldDescControl : public TabPage
{
private:
	SbaTableDesignHelpBar*	pHelp;
	Window*					pLastFocusWindow;

	FixedText*				pDefaultText;
	FixedText*				pRequiredText;
	FixedText*				pAutoIncrementText;
	FixedText*				pTextLenText;
	FixedText*				pNumTypeText;
	FixedText*				pLengthText;
	FixedText*				pScaleText;
	FixedText*				pFormatText;
	FixedText*				pBoolDefaultText;
	FixedText*				m_pColumnNameText;
	FixedText*				m_pTypeText;

	SbaPropListBoxCtrl*		pRequired;
	SbaPropListBoxCtrl*		pNumType;
	SbaPropListBoxCtrl*		pAutoIncrement;
	SbaPropEditCtrl*		pDefault;
	SbaPropNumericEditCtrl*	pTextLen;
	SbaPropNumericEditCtrl*	pLength;
	SbaPropNumericEditCtrl*	pScale;
	SbaPropEditCtrl*		pFormatSample;
	SbaPropListBoxCtrl*		pBoolDefault;
	SbaPropEditCtrl*		m_pColumnName;
	SbaPropListBoxCtrl*		m_pType;

	PushButton*				pFormat;

	SvxNumberFormatShell*	m_pFormatterShell;

	ScrollBar*				m_pVertScroll;
	ScrollBar*				m_pHorzScroll;

	SbaFieldType			aPreviousType;
	USHORT					nCurChildId;
	short					nPos;
	short					nOldDefaultPos;
	XubString				aYes;
	XubString				aNo;

	long					m_nOldVThumb;
	long					m_nOldHThumb;

	ULONG					nDelayedGrabFocusEvent;

	DECL_LINK( OnScroll, ScrollBar*);

	DECL_LINK( FormatClickHdl, Button * );
	DECL_LINK( ChangeHdl, ListBox * );

	DECL_LINK( DelayedGrabFocus, Control** );
		// von ActivatePropertyField benutzt
	DECL_LINK( OnControlFocusLost, Control* );
	DECL_LINK( OnControlFocusGot, Control* );

	void				UpdateFormatSample(SbaFieldDescr* pFieldDescr);
	void				ArrangeAggregates();

	void				SetPosSize( Control** ppControl, long nRow, USHORT nCol );

	void				ScrollAggregate(Control* pText, Control* pInput, Control* pButton, long nDeltaX, long nDeltaY);
	void				ScrollAllAggregates();

protected:
	SbaFieldDescr*		pActFieldDescr; // falls geloescht werden soll
	USHORT				CountActiveAggregates() const;

	virtual void		ActivateAggregate( SbaControlType eType );
	virtual void		DeactivateAggregate( SbaControlType eType );
	virtual SvNumberFormatter*	GetFormatter();
	virtual BOOL		IsReadOnly() { return FALSE; };
	// Sind von den abgeleiteten Klassen zu impl.
	virtual void		CellModified(long nRow, USHORT nColId ) = 0;
	virtual SbaDBDataDef*		GetDataDef()					= 0;
	virtual void		SetModified(BOOL bModified)				= 0;

	String	BoolStringPersistent(const String& rUIString) const;
	String	BoolStringUI(const String& rPersistentString) const;

public:
	SbaFieldDescControl( Window* pParent, SbaTableDesignHelpBar* pHelpBar);
	SbaFieldDescControl( Window* pParent, const ResId& rResId, SbaTableDesignHelpBar* pHelpBar);
	virtual ~SbaFieldDescControl();

	void				DisplayData(SbaFieldDescr* pFieldDescr );
	void				DisplayData(const SbaColumn* pColumn);

	void				SaveData( SbaFieldDescr* pFieldDescr );
	void				SaveData( SbaColumn* pColumn);

	BOOL				ChildHasFocus();

	void				SetControlText( USHORT nControlId, const String& rText );
	String				GetControlText( USHORT nControlId );
	void				SetReadOnly( BOOL bReadOnly );

	short				GetFormatCategory(SbaFieldDescr* pFieldDescr);
		// liefert zum am Feld eingestellten Format einen der CAT_xxx-Werte (CAT_NUMBER, CAT_DATE ...)
	void				ActivatePropertyField(USHORT nVirtualField);
		// Parameter ist einer der FIELD_PROPERTY_xxx-Werte, das entsprechende Control wird aktiviert, wenn vorhanden

	void				InitFormatterShell(ULONG nFormatKey = 0);
	// Resize aufegrufen
	void				CheckScrollBars();

	virtual void		Init();
	virtual void		GetFocus();
	virtual void		LoseFocus();
	virtual void		Resize();

protected:
	void	implFocusLost(Window* _pWhich);
};


#endif // _SBA_FLDCTRL_HXX

