/*************************************************************************
 *
 *  $RCSfile: joinds.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_JOINDS_HXX
#define _SBA_JOINDS_HXX

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _SFX_SHELL_HXX
#include <sfx2/shell.hxx>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _SBAINTID_HRC
#include "sbaintid.hrc"
#endif

#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

#ifndef _SBA_TABWIN_HXX
#include "tabwin.hxx"
#endif

#ifndef _SBA_TABCONN_HXX
#include "tabconn.hxx"
#endif

//==================================================================
class SbaJoinDocShExt
{
protected:
	SbaJoinTabWinDataList* pTabWinDataList;
	SbaJoinTabConnDataList* pTabConnDataList;
	SbaDatabaseRef xJoinDocDatabase;

	SfxObjectShell*	m_posRealDocShell;

	static const BYTE	SBA_VERSION_SO50;
	static const UINT16	SBA_JOIN_UI_TABWIN_TAG;
	virtual UINT16 GetUIInformationTag() { return SBA_JOIN_UI_TABWIN_TAG; }
		// dieser Wert wird als Tag fuer einen Record benutzt, in dem UI-Daten gespeichert und geladen werden

	virtual BOOL CheckTabWinData(const SbaJoinTabWinData* pData);
		// wird in LoadUI benutzt fuer jedes geladene TabWinData benutzt. Wenn hier FALSE zurueckkommt, werden die Daten sofort
		// wieder verworfen und nicht in die interne Liste eingefuegt.
		// Die Standard-Implementierung versucht, die in pData angegebene Tabelle an der Datenbank (xJoinDocDatabase) zu oeffnen.

public:
	TYPEINFO();

	SbaJoinDocShExt( SfxObjectShell* posRealDocShell );
		// da ich selber nur eine Extension bin, brauche ich eine Verbindung zur 'wirklichen' ObjectShell
	virtual ~SbaJoinDocShExt();

	virtual BOOL InitNew(SvStorage *pStor);
	virtual BOOL ConvertFrom( SfxMedium& rMedium );

	virtual BOOL LoadData();	// in abgeleiteten Klassen zu ueberschreiben, wird in ConvertFrom aufgerufen
	virtual BOOL SaveData();	// der Vollstaendigkeit halber, mach gar nix

	virtual void LoadUI( SvStream& rStream );	// laedt die Layout-Informationen aus dem Stream
	virtual void SaveUI( SvStream& rStream );	// der umgekehrte Weg

	// die Daten, mit denen ich arbeite
	SbaDatabase* GetJoinDocDatabase(){ return &xJoinDocDatabase; }
	SbaJoinTabWinDataList* GetTabWinDataList(){ return pTabWinDataList; }
	SbaJoinTabConnDataList* GetTabConnDataList(){ return pTabConnDataList; }

	void DeleteConnection( SbaJoinTabConnData* pConn );

	// zu ueberschreiben, erzeugt eine Instanz einer von SbaJoinTabWinData abgeleiteten Klasse
	virtual SbaJoinTabWinData* CreateTabWinDataObj();


	USHORT CountWindows( const String& rWinName );

	SfxObjectShell* GetObjectShell() const { return m_posRealDocShell; }

};

#endif
