/*************************************************************************
 *
 *  $RCSfile: qrydgn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYDGN_HXX
#define _SBA_QRYDGN_HXX

#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif

#ifndef _SBA_QRYDGN1_HXX
#include "qrydgn1.hxx"
#endif

#ifndef _SPLIT_HXX //autogen
#include <vcl/split.hxx>
#endif

#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif // _SBA_TWCONT_HXX


#ifndef _SVX_DBBROWSE_HXX
#include <svx/dbbrowse.hxx>
#endif // _SVX_DBBROWSE_HXX

#ifndef _SBA_QRYCONN_HXX
#include "qryconn.hxx"
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

//FORWARD_DECLARE_INTERFACE( uno,Reference)
FORWARD_DECLARE_INTERFACE( util,XNumberFormatter)

//==================================================================
class QueryTabWinUndoAct;
class QueryTabWinShowUndoAct;
class QueryTabWinDelUndoAct;
class QueryTabWin;
class SbaQueryDesignViewSh;
class QueryDesignWin;
class SfxItemSet;
class EditCtrl;
class ComboBoxEngine;
class TabFieldDesc;
class TabFieldDescList;
class SbaQueryDocSh;
struct SbaJoinExchangeData;

//==================================================================
#define SIZ_NONE		0
#define SIZ_TOP			1
#define SIZ_BOTTOM		2
#define SIZ_LEFT		4
#define SIZ_RIGHT		8

#define BROW_FIELD_ROW			0
#define BROW_COLUMNALIAS_ROW	1
#define BROW_TABLE_ROW			2
#define BROW_ORDER_ROW			3
#define BROW_VIS_ROW			4
#define BROW_FUNCTION_ROW		5
#define BROW_CRIT1_ROW			6
#define BROW_CRIT2_ROW			7
#define BROW_CRIT3_ROW			8
#define BROW_CRIT4_ROW			9
#define BROW_CRIT5_ROW			10
#define BROW_CRIT6_ROW			11
#define BROW_ROW_CNT			12
//==================================================================
class SelectionBrowseBox : public DbBrowseBox
{
	friend class QueryDesignWin;

	::std::vector<FASTBOOL>		bVisibleRow;	// an Pos steht die RowId

	long						nSeekRow;
	BrowserMode					nMode;						// Merken des BrowseModes
	EditCtrl*					pTextCell;
	DbCheckBoxCtrl*				pVisibleCell;
	DbComboBoxCtrl				*pFieldCell;
	DbListBoxCtrl				*pFunctionCell, *pTableCell, *pOrderCell;
	TabFieldDescList*			pTabFieldDescList;
	sal_Int32					nMaxColumns;				// maximale Anzahl der Spalten in einem Select-Statement

	String						aFunctionStrings;
	sal_uInt16					nVisibleCount;				// Anzahl der max sichtbaren Zeilen
	sal_Bool					bDistinct;
	sal_Bool					m_bOrderByUnRelated;
	sal_Bool					m_bGroupByUnRelated;

public:							SelectionBrowseBox( Window* pParent );
								~SelectionBrowseBox();
	TabFieldDesc*				InsertField( const SbaJoinExchangeData& jxdSource, long nColId=-1, sal_Bool bVis=sal_True, sal_Bool bActivate=sal_True );
	TabFieldDesc*				InsertField( const TabFieldDesc& rInfo, long nCol=-1, sal_Bool bVis=sal_True, sal_Bool bActivate=sal_True );
	void						InsertColumn( TabFieldDesc* pEntry, long& nColId );
	void						RemoveColumn( sal_uInt16 nColId );
	TabFieldDescList*			GetFieldDescList() const {return pTabFieldDescList;}
	void						DeleteFields( const String& rAliasName );
	// AddGroupBy:: F"ugt ein Feld mit Funktion == Grupierung. Falls das Feld schon vorhanden ist und ein Aggregate Funktion
	// benutzt, wird das Flag nicht gesetzt
	void						AddGroupBy( const TabFieldDesc& rInfo );
	void						AddCondition( const TabFieldDesc& rInfo,
											  const String& rValue,
											  const sal_uInt16 nLevel, const char* pOp=0 );
	void						AddOrder(const TabFieldDesc& rInfo, const SbaOrderDir eDir, sal_uInt16& nPos);
	void						ClearAll();
	TabFieldDesc*				AppendNewCol( sal_uInt16 nCnt=1 );
	void						Save();
	SbaQueryDocSh*				Shell() const;
	void						SetColWidth();
	sal_uInt16						FieldsCount();

	void						SetColWidth(sal_uInt16 nColId, long lNewWidth);
								// beachtet im Gegensatz zum SetColumnWidth der Basisklasse auch eine eventuell aktive Zelle in dieser Spalte

	String						GetCellContents(sal_uInt16 nCellIndex, long nColId);
	void						SetCellContents(sal_uInt16 nCellIndex, long nColId, const String& strNewText);
									// Zelleninhalt (als String formatiert) setzen/liefern
	sal_Int32					GetNoneVisibleRows() const;
	void						SetNoneVisbleRow(long nRows);
	sal_Bool					IsRowVisible(sal_uInt16 _nWhich) const;
	void						SetRowVisible(sal_uInt16 _nWhich, sal_Bool _bVis);
	sal_Bool					IsDistinct() const { return bDistinct;};
	void						SetDistinct(sal_Bool bDis) { bDistinct = bDis; };

	void						SetReadOnly(sal_Bool bRO);

protected:
	virtual sal_Bool			SeekRow( long nRow );

	virtual void				PaintStatusCell(OutputDevice& rDev, const Rectangle& rRect) const;
	virtual void				PaintCell(OutputDevice& rDev, const Rectangle& rRect,
										  sal_uInt16 nColumnId ) const;

	virtual sal_Bool				QueryDrop(const BrowserDropEvent& rEvt);
	virtual sal_Bool				Drop(const BrowserDropEvent& rEvt);
	virtual void				MouseButtonDown( const BrowserMouseEvent& rEvt );
	virtual void				MouseButtonUp( const BrowserMouseEvent& rEvt );
	virtual void				KeyInput( const KeyEvent& rEvt );
	virtual void				Command(const CommandEvent& rEvt);
	virtual void				ArrangeControls(sal_uInt16& nX, sal_uInt16 nY);

	virtual DbCellController*	GetController(long nRow, sal_uInt16 nCol);
	virtual void				InitController(DbCellControllerRef& rController, long nRow, sal_uInt16 nCol);
	virtual void				CellModified();
	virtual sal_Bool				SaveModified();
	virtual void				Init();
	virtual String				GetCellText(long nRow, sal_uInt16 nColId) const;
	virtual sal_uInt32				GetTotalCellWidth(long nRow, sal_uInt16 nColId) const;
	virtual void				ColumnResized( sal_uInt16 nColId );

	virtual sal_uInt32				GetTotalCellWidth(long nRow, sal_uInt16 nColId);

	virtual sal_uInt16				GetDefaultColumnWidth(const String& rName) const;

	void						Fill();

private:
	TabFieldDesc*				FindFirstFreeCol(long & rCol);
		// rCol enthaelt die Nummer (in pTabFieldDescList) der ersten Spalte, die von sich sagt, dass sie leer ist
		// wenn es keine solche gibt, ist rCol undefiniert und der Rueckgabewert NULL
	void						CheckFreeColumns(long& rCol);
		// testet, ob es noch freie Spalten gibt, wenn nicht, wird ein neuer Packen angefuegt
		// rCol enthaelt die Nummer der ersten freien Spalte (in pTabFieldDescList)

	void						RemoveField( sal_uInt16 nId, sal_Bool bActivate = sal_True);
	Rectangle					GetInvalidRect( sal_uInt16 nColId );
	long						GetRealRow(long nRow) const;
	long						GetBrowseRow(long nRowId) const;
	sal_Bool						GetFunktionName(String& rFkt);
};

//==================================================================
class SbaQuerySplitter : public Splitter
{
private:
	sal_uInt16	bFirstMove;
	double	m_bLastRelation;
		// letztes Verhaeltnis der beiden Panes
public:
	double GetRelation() const { return m_bLastRelation; }
	void ClearRelation() { m_bLastRelation = -1; }

public:
	SbaQuerySplitter( Window* pParent );
	~SbaQuerySplitter();

	virtual void Move();
};

//==================================================================

struct TabWinsChangeNotification;
class QueryTabConnData;
class QueryDesignWin: public SbaJoinFrameWindow
{
	SbaQuerySplitter			aSplitter;
	Size						aDefScrollSize;
	Link						aModifyLink;

	SbaQueryDesignViewSh*		pView; // Parent
	SelectionBrowseBox*	   		pSelectionWindow;
	long						nSplitHeight;
	sal_Bool						bNotifyModification;

	void						ArrangeChilds( long nSplitPos );
	void						InitFromParseNode();
	void						GetTable( String& rDatabase, String& rTable, String& rAlias, SdbSqlParseNode* pNode );

	void						GenerateInnerJoinCriterias(String& _rJoinCrit,const SbaJoinTabConnList*	_pConnList) const;
	// erzeugt das Group Argument, falls vorhanden
	String						GenerateGroupBy(TabFieldDescList* pFieldList, sal_Bool bMulti ) const;
	// erzeugt Where und Having Argument, falls vorhanden
	sal_Bool						GenerateCriterias(String& aRetStr,String& rHavingStr/*,String& rOrderStr*/, TabFieldDescList* pFieldList, sal_Bool bMulti ) const;
	String						GenerateOrder( TabFieldDescList* pFieldList , sal_Bool bMulti) const;
	// Erzeugt die SelectList. bAlias mu"s gesetzt sein, wenn mehr als 1 Tabelle vorhanden ist
	String						GenerateSelectList(const TabFieldDescList*	pFieldList,sal_Bool bAlias) const;
	// Erzeugt die Tabellenliste mit Joins aus pConnList, wenn bJoin == True. pConnList kann == NULL wenn bJoin == sal_False
	String						GenerateFromClause(const SbaJoinTabWinMap*	pTabMap,const SbaJoinTabConnList*	pConnList) const;

	String						BuildACriteria( const String& rVal, SdbDatabaseType aType ) const;
	int							InstallFields( SdbSqlParseNode* pNode, SbaJoinTabWinMap* pTabList );

	// nLevel gibt die Zeile an in der die Bedingungen eingetragen werden sollen
	int							GetSelectionCriteria( SdbSqlParseNode* pNode ,int &nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bJoinWhere=sal_False);
	void						GetHavingCriteria( SdbSqlParseNode* pNode ,int &nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter);

	int							GetORCriteria(SdbSqlParseNode * pCondition, int& nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bHaving = sal_False );
	int							GetANDCriteria(SdbSqlParseNode * pCondition, const int nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bHaving);
	int							ComparsionPredicate( SdbSqlParseNode * pCondition, const int nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bHaving );

	void						GetOrderCriteria( SdbSqlParseNode* pNode );
	void						GetGroupCriteria( SdbSqlParseNode* pNode );

	sal_Bool						GetInnerJoinCriteria(SdbSqlParseNode *pCondition);
	void						FillOuterJoins(SdbSqlParseNode* pParseNode);
	sal_Bool						InsertJoin(SdbSqlParseNode *pNode);
	sal_Bool						InsertJoinConnection(SdbSqlParseNode *pNode, const SbaJoinType& _eJoinType);

	sal_Bool						FillDragInfo(SdbSqlParseNode* pTableRef,TabFieldDesc& aDragInfo);

	sal_Bool						HasFields();
	String						BuildTable(QueryTabWin* pEntryTab) const;

	String						BuildJoin(QueryTabWin* pLh, QueryTabWin* pRh, QueryTabConnData* pData) const;
	String						BuildJoin(const String &rLh, QueryTabWin* pRh, QueryTabConnData* pData) const;
	String						BuildJoin(QueryTabWin* pLh, const String &rRh, QueryTabConnData* pData) const;
	String						BuildJoin(const String& rLh, const String& rRh, QueryTabConnData* pData) const;

	String						BuildJoinCriteria(SbaJoinConnLineDataList* pLineDataList,QueryTabConnData* pData) const;

	void						GetNextJoin(QueryTabConn* pEntryConn,String &aJoin,QueryTabWin* pEntryTabTo) const;
	void						JoinCycle(QueryTabConn* pEntryConn,String &rJoin,QueryTabWin* pEntryTabTo) const;

	int							InsertColumnRef(const SdbSqlParseNode * pColumnRef,String& aColumnName,const String& aColumnAlias,
									String& aTableRange,TabFieldDesc& aInfo, SbaJoinTabWinMap* pTabList) const;

	sal_uInt32						GetColumnFormatKey(const SdbSqlParseNode* pColumnRef);

protected:
	DECL_LINK(SplitHHdl, Splitter*);
	virtual void				Resize();
	virtual void				GetFocus();
	virtual long				PreNotify(NotifyEvent& rNEvt);

public:
	QueryDesignWin( Window* pParent, SbaQueryDesignViewSh* pView);
	~QueryDesignWin();

	void 						UpdateSQL();
	// InsertFields sal_False zur"uck, wenn die Selectionbrowsebox einen NULL Pointer zur"uck gibt
	sal_Bool						InsertField( const TabFieldDesc& rInfo, sal_Bool bVis=sal_True, sal_Bool bActivate = sal_True);
	void						AddTable( const String& rSchName, const String& rTabName, const sal_Unicode* pAlias=0, sal_Bool bNewTable = sal_False );
	void						TableDeleted(const String& rAliasName);

	SbaQueryDocSh*				Shell() const;
	SbaQueryDesignViewSh*		View() const {return pView;}

	void						DeleteFields( const String& rAliasName );
	void						UpdateAll();
	void						ClearAll( sal_Bool nNewCols=sal_False );
	void						HideTabWins();
	void						UpdateSliders( const Point& rRange );

	sal_Bool						HasTable() const {return pTabWinCont->GetTabWinMap()->Count() != 0;}
	String 						GenerateSQL() const;

	const Link&					ModifyHdl() const {return aModifyLink;}
	void						ModifyHdl( const Link& rLink ) { aModifyLink = rLink; }
	void						SetModified();
	void						SaveUIConfig();
	void						SaveTabWinUIConfig(QueryTabWin* pWin);
	SelectionBrowseBox*			GetSelectionWin() { return pSelectionWindow; }

	long						GetSplitPos();

	void						FillValidFields(const String& strTableName, ComboBox* pFieldList);
		// fuellt die ComboBox mit einer Liste aller verfuegbaren Tabellenfelder der genannten Tabelle
		// wenn strTableName leer ist, werden die Felder aller aktuell in der Abfrage verfuegbaren Tabellen aufgelistetet

	virtual void SetReadOnly(sal_Bool bRO);

	DECL_LINK( OnTabWinsChanged, TabWinsChangeNotification* );
};


//==================================================================
// String ConvertAlias(const String& rName) entfernt alle Zeichen die nicht innerhlab von a-z,A-Z,0-9 liegen
// und ersetzt diese durch die Zahl der Position des erst gefundenen
String ConvertAlias(const String& rName);

#endif //SB_QRYGRAVS_HXX


