/*************************************************************************
 *
 *  $RCSfile: qrydgn1.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYDGN1_HXX
#define _SBA_QRYDGN1_HXX

#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#ifndef _SVLBOX_HXX //autogen
#include <svtools/svlbox.hxx>
#endif

#ifndef _GEN_HXX //autogen
#include <tools/gen.hxx>
#endif

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif

#ifndef _SDB_SDBCOL_HXX //autogen
#include <sdb/sdbcol.hxx>
#endif

//==================================================================
enum	SbaTabFieldType	{ TAB_NORMAL_FIELD, TAB_PRIMARY_FIELD };
class TabFieldInfo
{
private:
	SbaTabFieldType	eFieldType;
	SdbDatabaseType	eDataType;

public:
	TabFieldInfo();
	~TabFieldInfo();

	inline SbaTabFieldType	GetKeyType() const { return eFieldType; }
	inline void				SetKey(SbaTabFieldType bKey=TAB_NORMAL_FIELD) { eFieldType = bKey; }
	inline SdbDatabaseType	GetDataType() const { return eDataType; }
	inline void				SetDataType(SdbDatabaseType eTyp) { eDataType = eTyp; }
};


//==================================================================
class TabDragInfo;
class SbaQueryDocSh;
//==================================================================

enum	SbaOrderDir		{ ORDER_NONE, ORDER_ASC, ORDER_DESC };
enum	SbaFunctionType
{
	FKT_AGGREGATE,
	FKT_OTHER    ,
	FKT_NONE     ,
	FKT_CONDITION	 // wenn dieser Fkt.Typ gesetzt handelt es sich um EXISTS oder UNIQUE, der FieldName enthlt das gesamte Statement
};


class TabFieldDesc
{
private:
	vector<String>				m_vecCriteria;

	String						aTableName;
	String						aAliasName;		// table range
	String						aFieldName;		// column
	String						aFieldAlias;	// column alias
	String						aDatabaseName;	// qualifier or catalog
	String						aFunctionName;	// enth"alt den Funktionsnamen, nur wenn eFunctionType != FKT_NONE gesetzt
	
	Window*						pTabWindow;
	
	//	String						*parrCriteria;
	SdbDatabaseType				eDataType;
	SbaFunctionType				eFunctionType;
	SbaTabFieldType				eFieldType;
	SbaOrderDir					eOrderDir;
	USHORT						nIndex;
	USHORT						nColWidth;
	BOOL						bGroupBy;
	BOOL						bVisible;

	// !!!! bitte bei Erweiterung um neue Felder auch IsEmpty mitpflegen !!!!

public:
	TabFieldDesc();
	TabFieldDesc(const String& rT, const String& rF );
	TabFieldDesc(const TabFieldDesc& rRS);
	~TabFieldDesc();

	inline BOOL				IsEmpty() const;

	BOOL					operator==( const TabFieldDesc& rDesc );

	BOOL					IsVisible() const	 { return bVisible;}
	BOOL					IsNumericDataType() const;
	BOOL					IsGroupBy() const	 { return bGroupBy;}

	void					SetVisible( BOOL bVis=TRUE ){ bVisible = bVis;}
	void					SetGroupBy( BOOL bGb=FALSE ){ bGroupBy = bGb;}
	void					SetTabWindow( Window* pWin ){ pTabWindow = pWin;}
	void					SetField( const String& rF ){ aFieldName = rF;}
	void					SetFieldAlias( const String& rF ){ aFieldAlias = rF;}
	void					SetTable( const String& rT ){ aTableName = rT;}
	void					SetAlias( const String& rT ){ aAliasName = rT;}
	void					SetDatabase( const String& rT ) { aDatabaseName = rT;}
	void					SetFunction( const String& rT ) { aFunctionName = rT;}
	void					SetOrderDir( SbaOrderDir eDir )	{ eOrderDir = eDir; }
	void					SetDataType( SdbDatabaseType eTyp )	{ eDataType = eTyp; }
	void					SetFieldType( SbaTabFieldType eTyp )	{ eFieldType = eTyp; }
	void					SetCriteria( USHORT nIdx, const String& rCrit);
	void					SetColWidth( USHORT nWidth ) { nColWidth = nWidth; }
	void					SetFieldIndex( USHORT nFieldIndex ) { nIndex = nFieldIndex; }
	void					SetFunctionType( SbaFunctionType eTyp )	{ eFunctionType = eTyp; }

	const String&			GetField() const { return aFieldName;}
	const String&			GetFieldAlias() const { return aFieldAlias;}
	const String&			GetTable() const { return aTableName;}
	const String&			GetAlias() const { return aAliasName;}
	const String&			GetDatabase() const { return aDatabaseName;}
	const String&			GetFunction() const { return aFunctionName;}
	SdbDatabaseType			GetDataType() const	{ return eDataType; }
	SbaTabFieldType			GetFieldType() const	{ return eFieldType; }
	SbaOrderDir				GetOrderDir() const	{ return eOrderDir; }
	String					GetCriteria( USHORT nIdx ) const;
	USHORT					GetColWidth() const { return nColWidth; }
	USHORT					GetFieldIndex() const { return nIndex; }
	Window*					GetTabWindow() const { return pTabWindow;}
	SbaFunctionType			GetFunctionType() const	{ return eFunctionType; }

	void					NextOrderDir();
	const vector<String>&	GetCriteria() const { return m_vecCriteria;}
};

//------------------------------------------------------------------
inline BOOL TabFieldDesc::IsEmpty()	const
{
	sal_Bool bEmpty = (!aTableName.Len()		 &&
					 !aAliasName.Len()		 &&
					 !aFieldName.Len()		 &&
					 !aFieldAlias.Len()		 &&
					 !aDatabaseName.Len()	 &&
					 !aFunctionName.Len());

	for(vector<String>::const_iterator aIter = m_vecCriteria.begin();bEmpty && aIter != m_vecCriteria.end();++aIter)
		if(aIter->Len())
			 bEmpty = FALSE;
	return bEmpty;
}


//------------------------------------------------------------------

DECLARE_LIST( TabFieldDescList, TabFieldDesc* );

//==================================================================
#define REGISTERID() (Exchange::RegisterFormatName( String::CreateFromAscii(SBA_JOIN_EXCHANGE_FORMAT) ))
//==================================================================

#endif //SB_QRYGRAT1_HXX


