/*************************************************************************
 *
 *  $RCSfile: qrydlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef QRYDLG_HXX
#define QRYDLG_HXX

#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

#ifndef _SBA_QRYCONN_HXX
#include "qryconn.hxx"
#endif // _SBA_QRYCONN_HXX


//========================================================================

class DlgQryJoin : public ModalDialog
{
protected:
	GroupBox			aGB_Join;
	RadioButton			aRB_Inner;
	RadioButton			aRB_Left;
	RadioButton			aRB_Right;
	RadioButton			aRB_Full;
	MultiLineEdit		aML_HelpText;
	OKButton			aPB_OK;
	CancelButton		aPB_CANCEL;
	HelpButton			aPB_HELP;

	SbaJoinType			eJoinType;
	SbaDatabaseRef		rDatabase;
	QueryTabConnData*	pConnData; // enth"alt linke und rechte Tabelle

	DECL_LINK( OKClickHdl, Button* );
	DECL_LINK( RBTogleHdl, RadioButton* );
public:
	DlgQryJoin::DlgQryJoin( Window * pParent, QueryTabConnData* pData, SbaDatabaseRef xDatabase );
	virtual ~DlgQryJoin();
	SbaJoinType GetJoinType() const { return eJoinType; };
};

//========================================================================

class QueryMissingTableDialog : public ModalDialog
{
protected:
	FixedText		m_ftExplanantion;
	GroupBox		m_gbChoose;
	RadioButton		m_rbOpenGraphic;
	RadioButton		m_rbOpenSql;
	RadioButton		m_rbDontOpen;
	CheckBox		m_cbIgnoreOther;
	CancelButton	m_ctrlCancel;
	OKButton		m_ctrlOk;

	DECL_LINK(OnRadioClicked, RadioButton*);

public:
	QueryMissingTableDialog(Window* pParent, USHORT nExplanationId, const String& strAffectedString);

	USHORT GetResponse() const;
		// 1 - graphische Ansicht
		// 2 - SQL-Ansicht
		// 3 - nicht oeffnen
	BOOL	IgnoreOther() const { return m_cbIgnoreOther.IsChecked(); }

};


#endif // QRYDLG_HXX
