/*************************************************************************
 *
 *  $RCSfile: qryds.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYDS_HXX
#define _SBA_QRYDS_HXX

#ifndef _SBA_DOCSH_HXX
#include "sbads.hxx"
#endif

#ifndef _SFX_OBJFAC_HXX
#include <sfx2/docfac.hxx>
#endif

#ifndef _UNDO_HXX //autogen
#include <svtools/undo.hxx>
#endif

#ifndef _SBADBIT_HXX
#include "sbadbit.hxx"
#endif

#ifndef _QRYDGN_HXX
#include "qrydgn.hxx"
#endif

#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif

#include <svx/ifaceids.hxx>
#include "sbaintid.hrc"
#include "dbqryobj.hxx"

//========================================================================
#define NEWDESIGN
DBG_NAMEEX(SbaTabFieldFormat);

//========================================================================


/*==================================================================
	Diese Klasse haelt FormatInfos, um
	TabFields mit ihren alten Eigenschaften zu initialisieren.
*/
class SbaTabFieldFormat
{
private:
	ULONG nColWidth;

public:
	SbaTabFieldFormat( ULONG nWidth ) 
#if DBG_UTIL
	;
	~SbaTabFieldFormat( );
#else
	: nColWidth( nWidth ) {}
#endif
	ULONG GetColWidth() { return nColWidth; }
	void SetColWidth( ULONG nWidth ) { nColWidth = nWidth; }
};

DECLARE_LIST( TabFieldFormatList, SbaTabFieldFormat* );

class SbaTabFieldFormatList : public TabFieldFormatList
{
public:
	void DeleteAll();
	ULONG GetTabFieldWidth( USHORT nIndex );
};
//==================================================================

class SbaQueryViewSh;
class SdbConnection;

//==================================================================
class SbaTabFieldData
{
private:
	String aFieldName;
	String aTableName;
	String aAliasName;
	ULONG nColWidth;

public:
	SbaTabFieldData();
	SbaTabFieldData( const String& rFieldName, const String& rTableName, const String& rAliasName );
	~SbaTabFieldData();

	String GetFieldName(){ return aFieldName; }
	String GetTableName(){ return aTableName; }
	String GetAliasName(){ return aAliasName; }
	ULONG GetColWidth(){ return nColWidth; }

	void SetFieldName( const String& rName ){ aFieldName = rName; }
	void SetTableName( const String& rName ){ aTableName = rName; }
	void SetAliasName( const String& rName ){ aAliasName = rName; }
	void SetColWidth( ULONG nWidth ){ nColWidth = nWidth; }

	void Save( SvStream& rStream );
	void Load( SvStream& rStream );
};

DECLARE_LIST(SbaTabFieldDataBaseList, SbaTabFieldData*);

class SbaTabFieldDataList : public SbaTabFieldDataBaseList
{
private:
public:
	SbaTabFieldDataList(){}
	~SbaTabFieldDataList(){}

	void Load( SvStream& rStream );
	void Save( SvStream& rStream );
};

//==================================================================
class SbaTabWinList;
class SelectionBrowseBox;
class SbaTableDef;

//==================================================================
// SbaQueryDocSh
// dient zum Anlegen und Modifizieren von Datenbankabfragen, kann aber
// auch ebenso Tabellensichten erstellen
//==================================================================
class QueryTabWin;
struct SdbParseIteratorErrorInfo;
class SbaQueryDocSh : public SbaDBDataDefDocSh, public SbaJoinDocShExt
{
	friend class SbaQueryViewSh;
	friend class SbaQueryTxtViewSh;

	String aStatement;
	BOOL   bNative;
	ULONG  nEvent;
	long   nSplitPos;
	INT32  nVisibleRows;	 // bitmaske 1 wo sichtbar

	SfxUndoManager		aUndoMgr;
	SdbSqlParseNode*	pParseTree;		// sqlparser
	SbaParseIterator*	pParseIterator;

	SbaTabFieldFormatList	aTabFieldFormatList;	// Spaltenbreite in BrowseBox

	SbaTabFieldDataList* pTabFieldDataList;

	// waehrend des Oeffnens eines Dokumentes muss ich parsen und dabei atomare Fehler behandeln, die folgenden Felder dienen dazu,
	// dabei Informationen in beide Richtungen auszutauschen
	enum OPENERROR_RESPONSE { OR_NOERROR_ENCOUNTERED, OR_OPEN_ANYHOW, OR_OPEN_SQL, OR_DONT_OPEN };
	OPENERROR_RESPONSE	m_orErrorResponse;	// das Ergebnis der letzten Fehlerbehandlung

	UINT16	m_nViewIdOpening;	// die ID der aktuell zu oeffnenden View (Browse, Design, SQL)

	BOOL	m_bIgnoreMissingElements : 1;

	BOOL	m_bShowParseErrors : 1;

// Attribut-Zugriff
public:
	void	EnableShowParseErrors(BOOL bEnable) { m_bShowParseErrors = bEnable; }
	BOOL	IsShowParseErrorsEnabled() const { return m_bShowParseErrors; }

//========================================================================
public:
	BOOL GenerateDataLists( SdbSqlParseNode* pParseTree );

private:
	BOOL GetTableName( String& rDatabaseName, String& rTableName,
					   String& rAliasName, SdbSqlParseNode* pNode );
	BOOL GetColumnRef( SdbSqlParseNode* pColumnRefNode, String& rFieldName,
					   String& rTableName, String& rAliasName );
	BOOL GetORCriteria( SdbSqlParseNode* pConditionNode, USHORT& nLevel );
	BOOL GetANDCriteria( SdbSqlParseNode* pConditionNode, const USHORT nLevel );

//========================================================================

public:
	SFX_DECL_SIMPLE_OBJECTFACTORY_DLL(SbaQueryDocSh);
	SFX_DECL_INTERFACE(ID_SBA_QUERYDOCSH);
	TYPEINFO();

	SbaQueryDocSh(SfxObjectCreateMode eMode);
	virtual ~SbaQueryDocSh();
	virtual BOOL			InitNew(SvStorage*);
	virtual BOOL			_SaveImpl();
	virtual BOOL			ConvertFrom( SfxMedium& rMedium );

	// kommen aus SbaJoinDocShExt
	virtual void			LoadUI( SvStream& rStream );	// laedt die Layout-Informationen aus dem Stream
	virtual void			SaveUI( SvStream& rStream );	// der umgekehrte Weg

	void					SaveTabWinPosSize(QueryTabWin* pTabWin, long nOffsetX, long nOffsetY);
	void					SaveTabWinsPosSize( SbaJoinTabWinMap* pTabWinList, long nOffsetX, long nOffsetY );
	BOOL					GetTabWinPosSize( const String& rAliasName, Point& rPos, Size& rSize );
	void					SaveTabFieldsWidth( SelectionBrowseBox* pSelectionWindow );
	void					SaveNonVisibleRows(SelectionBrowseBox* pSelectionWindow );
	BOOL					GetColWidth( const String& rAliasName, const String& rFieldName, ULONG& nWidth );
	void					SaveSplitPos( long nPos ){ nSplitPos = nPos; }
	long					GetSplitPos(){ return nSplitPos; }

	void					SaveTabFieldWidth( ULONG nWidth )
								{ aTabFieldFormatList.Insert( new SbaTabFieldFormat(nWidth), LIST_APPEND ); }
	ULONG					GetTabFieldWidth( USHORT nID )
								{ return aTabFieldFormatList.GetTabFieldWidth(nID); }
	void					ClearTabFieldFormatList()
								{ aTabFieldFormatList.DeleteAll(); }

	const String&			Statement() const {return aStatement;}
	BOOL					IsNative() const {return bNative;}

	void					ExecuteStatement();// Ausfuehren, d.h Anzeige der Abfrageergebnisse
	void					SetStatement(SbaQueryDef* pQueryDef, BOOL bAddUndo = FALSE);	// setzen des Statements aus QueryObj vom SbaObj
	BOOL					SetStatement(const String& rStatement,
										BOOL bNat,
										BOOL bAddUndo = FALSE,
										BOOL bParseStatement = TRUE);

	void					GetTable(String& rDatabase, String& rTable, String& rAlias, SdbSqlParseNode* pNode);

	BOOL					OnViewSwitch();	// View wird gewechselt

	BOOL					SetNative(BOOL bNat);
	BOOL					ToggleNative();
	void					AddUndo();

	const SdbSqlParseNode*	ParseTree() const {return pParseTree;}
	SbaParseIterator&		Iterator() {return *pParseIterator;}

	Link					SetParseErrorHandler(const Link&);

	BOOL					BuildParseTree(const String& rStatement);

	virtual void			GetState(SfxItemSet &);
	virtual void			Execute( SfxRequest& rReq );

	SfxUndoManager*			GetUndoMgr(){return &aUndoMgr;}

	long					GetNoneVisibleRows() const { return nVisibleRows;};
	// uses the formatter from the database and formatkey of a field
	International			BuildInternational(UINT32 _nFormatKey);

protected:
	static const UINT16 QUERY_UI_TABWIN_TAG;
	virtual UINT16 GetUIInformationTag() { return QUERY_UI_TABWIN_TAG; }
		// das ist das Tag fuer das Speichern/Laden der UI-Informationen

	// die Basisklasse legt SbaJoinTabWinData's an, ich brauche aber QueryTabWinData's
	virtual SbaJoinTabWinData* CreateTabWinDataObj();


	virtual void SFX_NOTIFY(SfxBroadcaster& rBC,
							const TypeId& rBCType,
							const SfxHint& rHint,
							const TypeId& rHintType );

	SbaQueryDef* GetQueryDef() const;
	SbaTableDef* GetTableDef() const;

	BOOL IsQuery() const {return GetQueryDef() != NULL;}
	BOOL IsDBView() const {return GetTableDef() != NULL;}

private:
	DECL_LINK(CloseHdl, void* );
	DECL_LINK(NewHdl, void* );
	BOOL UpdateStatement(BOOL bUpdateView);

	DECL_LINK(OnParseStatementError, SdbParseIteratorErrorInfo*);
};

#endif
