/*************************************************************************
 *
 *  $RCSfile: qrytbwin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYTBWIN_HXX
#define _SBA_QRYTBWIN_HXX

#ifndef _SBA_TABWIN_HXX
#include "tabwin.hxx"
#endif

#ifndef _SBA_QRYDGN1_HXX
#include "qrydgn1.hxx"
#endif // _SBA_QRYDGN1_HXX


class QueryTabWinData : public SbaJoinTabWinData
{
protected:
	StringList	m_lststrFieldList;
public:
	TYPEINFO();
	QueryTabWinData();
	QueryTabWinData(const String& rDatabaseName, const String& rTableName, const String& rTableAlias);
	virtual ~QueryTabWinData();

	virtual void Load(SvStream& rStream);
	virtual void Save(SvStream& rStream);

	String GetAliasName() { return GetWinName(); }
	void SetAliasName(const String& rNewAlias) { SetWinName(rNewAlias); }
};

//==================================================================
class QueryTabWin : public SbaJoinTabWin
{
	USHORT			m_nAliasNum;
	String			m_strInitialAlias;
public:
	TYPEINFO();
	QueryTabWin( Window* pParent, QueryTabWinData* pTabWinData, char* pszInitialAlias = NULL );
	virtual ~QueryTabWin();

	String			GetAliasName() const { return ((QueryTabWinData*)GetData())->GetAliasName(); }
	void			SetAliasName(const String& strNewAlias) { ((QueryTabWinData*)GetData())->SetAliasName(strNewAlias); }

	// spaeter Constructor, die Basisklasse ERZEUGT beim ersten Aufruf die Listbox
	virtual BOOL	Init();

	USHORT			GetAliasNum() const	{ return m_nAliasNum; }

	BOOL			ExistsField(const String& strFieldName, TabFieldDesc& rInfo);
	BOOL			ExistsAVisitedConn() const;



protected:
	virtual void	KeyInput( const KeyEvent& rEvt );

	virtual			SbaJoinTabWinListBox*	CreateListBox();
		// wird im ERSTEN Init aufgerufen
	virtual BOOL	FillListBox();
		// wird in JEDEM Init aufgerufen
	virtual void	EmptyListBox();
		// ListBox definiert leeren

	virtual void	OnEntryDoubleClicked(SvLBoxEntry* pEntry);
		// wird aus dem DoubleClickHdl der ListBox heraus aufgerufen
};

//==================================================================
class QueryTabWinListBox : public SbaJoinTabWinListBox
{
public:
	QueryTabWinListBox(SbaJoinTabWin* pParent, const String& strDatabase, const String& strTable);

protected:
	virtual void InitEntry(SvLBoxEntry* pEntry, const String& rStr, const Image& rImg1, const Image& rImg2);

	virtual void NotifyEndScroll();
	virtual void ShowTargetEmphasis( SvLBoxEntry*, BOOL bShow );
	virtual void LoseFocus();
	virtual void Resize();
};

//==================================================================
class TabLBoxString: public SvLBoxString
{
public:
	TabLBoxString(SvLBoxEntry* pEntry,USHORT nFlags,const String& rStr)
				 :SvLBoxString(pEntry, nFlags, rStr ){}
	TabLBoxString(){}
protected:
	virtual void Paint( const Point&, SvLBox& rDev, USHORT nFlags,SvLBoxEntry* );
};

#endif // _SBA_QRYTBWIN_HXX

