/*************************************************************************
 *
 *  $RCSfile: qrytxtvs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYTXTVS_HXX
#define _SBA_QRYTXTVS_HXX

#ifndef _SBA_QRYVS_HXX
#include "qryvs.hxx"
#endif

#ifndef _SBAINTID_HRC
#include "sbaintid.hrc"
#endif

#ifndef _SV_MEDIT_HXX
// MS-VC 4.1 Compiler has a problem with the stl

#ifndef	WB_LEFT
#define WB_LEFT 				((WinBits)0x00004000)
#endif

#include <svtools/svmedit.hxx>
#endif

#ifndef _VIEWFAC_HXX //autogen
#include <sfx2/viewfac.hxx>
#endif

class SbaQueryTxtViewSh;
class TabBar;
class SfxBindings;

class SqlEdit : public MultiLineEdit
{
private:
	SbaQueryTxtViewSh* pView;
	SfxBindings& rBindings;
	String m_strOrigText;		// wird beim Undo wiederhergestellt
	BOOL bAccelAction;		// Wird bei Cut, Copy, Paste gesetzt

	SfxBindings& Bindings() { return rBindings; }

	Timer	m_timerUndoActionCreation;
	DECL_LINK(OnUndoActionTimer, void*);

	Link	m_lnkTextModifyHdl;

protected:
	virtual void MouseButtonUp( const MouseEvent& rMEvt );
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void GetFocus();

	DECL_LINK(ModifyHdl, void*);

public:
	SqlEdit( Window* pParent, SbaQueryTxtViewSh* pViewSh, WinBits nWinStyle = WB_LEFT | WB_VSCROLL );
	virtual ~SqlEdit();

	void OverloadedSetText(const String& rNewText);
		// mieser name, ich weiss .... leider muss ich das SetText, dass die UndoActions an mir ausfuehren koennen, abfangen
		// die Alternative waere gewesen, allen oder nur den UndoActions Zugriff auf m_strOrigText zu geben ...

	BOOL IsInAccelAct();

	void SetTextModifyHdl(const Link& lnk) { m_lnkTextModifyHdl = lnk; }
		// bitte nicht SetModifyHdl benutzen, den brauche ich selber, der hier wird von dem damit gesetzten Handler
		// gerufen
		// der Link bekommt einen Pointer-to-string, der nach dem Link nicht mehr gueltig ist

	SbaQueryTxtViewSh* View() { return pView; }
};

//==============================================================================
struct SdbParseIteratorErrorInfo;
class SbaQueryTxtViewSh: public SbaQueryViewSh
{
private:
	SqlEdit* pEdit;

	BOOL	m_bHadParseError;
	ULONG	m_nAsyncGetFocusEvent;

public:
	TYPEINFO();
	SFX_DECL_VIEWFACTORY(SbaQueryViewTxtSh);
	SFX_DECL_INTERFACE(ID_SBA_QUERYTXTVIEWSH);

	SbaQueryTxtViewSh(SfxViewFrame *pFrame, SfxViewShell* pView);
	SbaQueryTxtViewSh(SfxViewFrame *pFrame, Window *pParent);
	SbaQueryTxtViewSh(SfxViewFrame *pFrame, const SbaQueryTxtViewSh& );
	~SbaQueryTxtViewSh();

	virtual void Execute(SfxRequest& rReq);
	virtual void GetState(SfxItemSet &);

	void SwitchToDesign();

protected:
	virtual void InnerResizePixel(const Point &rOfs, const Size &rSize);
	virtual void OuterResizePixel(const Point &rOfs, const Size &rSize);
	virtual void Activate(BOOL IsMDIActivate);
	virtual void Deactivate(BOOL IsMDIActivate);

	virtual void SetStatement(const String& rStatement);
	virtual String GetStatement();

private:
	void Construct(SfxViewFrame *pFrame);

	DECL_LINK(OnTextModified, void*);
	DECL_LINK(OnParseStatementError, SdbParseIteratorErrorInfo*);
	DECL_LINK(OnAsyncGetFocus, void*);
};

//==================================================================
class SbaQuerySqlDesignFrame : public SbaQueryDesignFrame
{
	friend class SbaQueryTxtViewSh;
public:
	SbaQuerySqlDesignFrame(Window* pParent, SbaDBDataDef* pDef, SbaQueryTxtViewSh* pView);
};

//==================================================================

#endif


