/*************************************************************************
 *
 *  $RCSfile: relconn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_RELCONN_HXX
#define _SBA_RELCONN_HXX

#ifndef _SBA_TABCONN_HXX
#include "tabconn.hxx"
#endif

#ifndef _SBA_RELWINCT_HXX
#include "relwinct.hxx"
#endif

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#ifndef _SVLBOX_HXX //autogen
#include <svtools/svlbox.hxx>
#endif

//==================================================================
const UINT16 CARDINAL_UNDEFINED	= 0x0000;
const UINT16 CARDINAL_ONE_MANY	= 0x0001;
const UINT16 CARDINAL_MANY_ONE	= 0x0002;
const UINT16 CARDINAL_ONE_ONE	= 0x0004;

class SbaRelTabConnData : public SbaJoinTabConnData
{
	String aDatabaseName;

	SbaDatabaseRef xDatabase;
	SbaTableDefRef xSourceTableDef;
	SbaTableDefRef xDestTableDef;

	UINT16 nUpdateRules;
	UINT16 nDeleteRules;
	UINT16 nCardinality;

	BOOL IsSourcePrimKey();
	BOOL IsDestPrimKey();

protected:
	virtual SbaJoinConnLineData* CreateLineDataObj();
	virtual SbaJoinConnLineData* CreateLineDataObj( const SbaJoinConnLineData& rConnLineData );

public:
	TYPEINFO();
	SbaRelTabConnData();
	SbaRelTabConnData( const SbaDatabaseRef rDatabase );
	SbaRelTabConnData( const SbaRelTabConnData& rConnData );
	SbaRelTabConnData( const SbaDatabaseRef rDatabase, const String& rSourceWinName, const String& rDestWinName, const String& rConnName = String() );
	virtual ~SbaRelTabConnData();

	virtual void CopyFrom(const SbaJoinTabConnData& rSource);
	virtual SbaJoinTabConnData* NewInstance() const { return new SbaRelTabConnData(); }

	SbaRelTabConnData& operator=( const SbaRelTabConnData& rConnData );

	String GetDatabaseName() const { return aDatabaseName; }

	SbaDatabase* GetDatabase() const { return &xDatabase; }
	SbaTableDef* GetSourceTableDef() const { return &xSourceTableDef; }
	SbaTableDef* GetDestTableDef() const { return &xDestTableDef; }

	virtual void SetSourceWinName( const String& rSourceWinName );
	virtual void SetDestWinName( const String& rDestWinName );

	void		SetCardinality();
	void		SetUpdateRules( UINT16 nAttr ){ nUpdateRules = nAttr; }
	UINT16		GetUpdateRules() const { return nUpdateRules; }
	void		SetDeleteRules( UINT16 nAttr ){ nDeleteRules = nAttr; }
	UINT16		GetDeleteRules() const { return nDeleteRules; }
	UINT16		GetCardinality() const { return nCardinality; }

	BOOL		Update();
	BOOL		IsConnectionPossible();
	void		ChangeOrientation();
	BOOL		DropRelation();
};


//==================================================================
class SbaRelTabConn : public SbaJoinTabConn
{
protected:
	SbaJoinConnLine* CreateConnLine( const SbaJoinConnLine& rConnLine );

public:
	TYPEINFO();
	SbaRelTabConn( SbaRelTabWinCont* pContainer, SbaRelTabConnData* pTabConnData );
	SbaRelTabConn( const SbaRelTabConn& rConn );
		// wichtiger Kommentar zum CopyConstructor siehe SbaJoinTabConn(const SbaJoinTabConn&)
	virtual ~SbaRelTabConn();

	SbaRelTabConn& operator=( const SbaRelTabConn& rConn );

	virtual void	Draw( const Rectangle& rRect );
};

#endif


