/*************************************************************************
 *
 *  $RCSfile: rtfcpydg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_RTFCPYDG_HXX
#define  _SBA_RTFCPYDG_HXX

//	#include <sdb/tools.hxx>

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _SV_IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif

#ifndef _SBA_FLDCTRL_HXX
#include "fldctrl.hxx"
#endif

#ifndef _SVT_WIZDLG_HXX
#include <svtools/wizdlg.hxx>
#endif

#ifndef _SBA_SBATREE_HXX
#include "sbatree.hxx"
#endif

class SbaDatabase;
class SbaWizardPage;
class DlgCopyTable;
class SbaWizNameMatching;

class SbaStringCompare
{
public:
	sal_Bool operator() (const String& lhs,const String& rhs) const
	{
		return lhs.CompareTo(rhs) == COMPARE_LESS;
	}
};
// =============================================================================================
// SbaWizTypeSelectControl
// =============================================================================================
class SbaWizTypeSelectControl : public SbaFieldDescControl
{
protected:
	virtual void		ActivateAggregate( SbaControlType eType );
	virtual void		DeactivateAggregate( SbaControlType eType );

	virtual void		CellModified(long nRow, sal_uInt16 nColId );
	virtual SbaDBDataDef*		GetDataDef();
	virtual void		SetModified(sal_Bool bModified);


public:
	SbaWizTypeSelectControl(Window* pParent, SbaTableDesignHelpBar* pHelpBar=NULL)
		: SbaFieldDescControl(pParent,pHelpBar) { };
	SbaWizTypeSelectControl(Window* pParent, const ResId& rResId,SbaTableDesignHelpBar* pHelpBar=NULL)
		: SbaFieldDescControl(pParent,rResId,pHelpBar) { };
	~SbaWizTypeSelectControl();
};

// ========================================================
// Wizard Dialog
// ========================================================
class CopyTableWizard : public WizardDialog
{
	friend class		SbaWizColumnSelect;
	friend class		SbaWizTypeSelect;
	friend class		SbaWizTypeSelectControl;
	friend class		DlgCopyTable;
	friend class		SbaWizNameMatching;
private:

	OKButton			m_pbFinish;
	CancelButton		m_pbCancel;
	PushButton			m_pbNext;
	PushButton			m_pbPrev;

	sal_uInt32				m_nPageCount;

	DECL_LINK( ImplPrevHdl	, PushButton* );
	DECL_LINK( ImplNextHdl	, PushButton* );
	DECL_LINK( ImplOKHdl	, OKButton* );
	DECL_LINK( ImplActivateHdl, WizardDialog* );
	void OnError();
	void CheckColumns();

protected:
	SbaTableDefRef		m_xTableDef;
	SbaDBDataDefRef		m_xSourceDef;
	SbaDatabaseRef		m_xDatabase;
	SbaColumnList		m_lColumnList;
	SbaColumnList		m_lOrgColumnList;
	String				m_aTableName;
	String				m_aKeyName;
	::std::map<String,String,SbaStringCompare>  m_mNameMapping;
	::std::vector<sal_uInt32>		m_vColumnPos;
	::std::vector<SbaFieldType> m_vColumnTypes;

public:
	enum Wizard_Create_Style
	{
		WIZARD_APPEND_DATA = 0,
		WIZARD_DEF_DATA,
		WIZARD_DEF,
		WIZARD_DEF_VIEW
	};

	enum Wizard_Button_Style
	{
		WIZARD_NEXT,
		WIZARD_PREV,
		WIZARD_FINISH
	};

protected:
	Wizard_Create_Style m_eCreateStyle;
	Wizard_Button_Style	m_ePressed;
	sal_Bool				m_bPrimaryColumn;

public:
	CopyTableWizard( Window * pParent,const SbaDBDataDefRef& rSourceDef,SbaDatabase *pPasteDatabase);

	virtual ~CopyTableWizard();
	SbaColumnList&		GetColumns() { return m_lColumnList; }
	const SbaColumnList& GetOriginalColumns() const{ return m_xSourceDef.Is() ? m_xSourceDef->GetColumns() : m_xTableDef->GetColumns(); }

	virtual long		DeactivatePage();
	OKButton&			GetOKButton() { return m_pbFinish; }
	sal_Bool				WasButtonPressed() const { return m_ePressed; }
	void				EnableButton(Wizard_Button_Style eStyle,sal_Bool bEnable);
	SbaTableDef*		GetTableDef() { return m_xTableDef; }
	void				AddWizardPage(SbaWizardPage* pPage); // Page wird von CopyTableWizard gelscht
	void				RemoveWizardPage(SbaWizardPage* pPage); // Page goes again to user
	void				ShowCreationError(const SdbStatus& rSourceError, const SdbStatus& rDestError) const;
	void				CheckButtons(); // checks which button can be disabled, enabled
	Wizard_Create_Style GetCreateStyle() const { return m_eCreateStyle; }
	// returns a vector where the position of a column and if the column is in the selection
	// when not the value is CONTAINER_ENTRY_NOTFOUND == (sal_uInt32)-1
	vector<sal_uInt32>		GetColumnPositions() const { return m_vColumnPos; }
	vector<SbaFieldType> GetColumnTypes() const { return m_vColumnTypes; }
	map<String,String,SbaStringCompare> GetNameMapping() const { return m_mNameMapping; }
	// return sal_True if I need to set the autoincrement value by myself otherwise sal_False
	sal_Bool				SetAutoincrement() const;
};

// ========================================================
// Wizard Page
// ========================================================

class SbaWizardPage		: public TabPage
{
protected:
	SbaColumnList		m_aColumnList;  // I have to save the columns otherwise they are lost
	CopyTableWizard*	m_pParent;
	sal_Bool				m_bFirstTime;	// Page wird das erste mal gerufen ; should be set in the reset methode

	SbaWizardPage( Window* pParent, WinBits nStyle = WB_STDTABDIALOG ) : TabPage(pParent,nStyle),m_pParent((CopyTableWizard*)pParent),m_bFirstTime(sal_True) {};
	SbaWizardPage( Window* pParent, const ResId& rResId ) : TabPage(pParent,rResId),m_pParent((CopyTableWizard*)pParent),m_bFirstTime(sal_True) {};
public:
	virtual	void		Reset ( )			= 0;
	virtual sal_Bool		LeavePage()			= 0;
	virtual String		GetTitle() const	= 0;

	sal_Bool				IsFirstTime() const { return m_bFirstTime; }

};

// ========================================================
// Wizard Page: SbaWizColumnSelect
// ========================================================

class SbaWizColumnSelect : public SbaWizardPage
{

	GroupBox				m_gpColumns;
	MultiListBox			m_lbOrgColumnNames; // left side
	PushButton				m_pbColumn_RH;
	PushButton				m_pbColumns_RH;
	PushButton				m_pbColumn_LH;
	PushButton				m_pbColumns_LH;
	MultiListBox			m_lbNewColumnNames; // right side
	sal_Bool					m_bAttrsChanged;


	DECL_LINK( ButtonClickHdl, Button * );
	DECL_LINK( ListDoubleClickHdl, MultiListBox * );


public:
	virtual	void			Reset ( );
	virtual void			ActivatePage();
	virtual sal_Bool			LeavePage();
	virtual String			GetTitle() const ;

	SbaWizColumnSelect(Window* pParent);
	virtual ~SbaWizColumnSelect();
};
// ========================================================
// Wizard Page: SbaWizTypeSelectList
// definiert nur das ::com::sun::star::ucb::Command f"ur das Contextmenu
// ========================================================
class SbaWizTypeSelectList : public MultiListBox
{
	sal_Bool					m_bPKey;
	sal_Bool					IsPrimaryKeyAllowed() const;
protected:
	virtual long			PreNotify( NotifyEvent& rNEvt );
public:
	SbaWizTypeSelectList( Window* pParent, WinBits nStyle = WB_BORDER ) : MultiListBox(pParent,nStyle) {};
	SbaWizTypeSelectList( Window* pParent, const ResId& rResId ) : MultiListBox(pParent,rResId) {};
	void					SetPKey(sal_Bool bPKey) { m_bPKey = bPKey; }
};
// ========================================================
// Wizard Page: SbaWizTypeSelect
// Dient als Basis Klasse fuer unterschiedliche Kopiereigenschaften
// FillColumnList wird aufgerufen, wenn der Button AUTO ausgeloest wird.
// ========================================================
class SbaWizTypeSelect : public SbaWizardPage
{
	friend class SbaWizTypeSelectControl;
	friend class SbaWizTypeSelectList;

	DECL_LINK( ColumnSelectHdl, MultiListBox* );
	DECL_LINK( ButtonClickHdl, Button * );

protected:
	SbaWizTypeSelectList	m_lbColumnNames;
	GroupBox				m_gpColumns;
	SbaWizTypeSelectControl m_aTypeControl;
	GroupBox				m_gpAutoType;
	FixedText				m_ftAuto;
	NumericField			m_etAuto;
	PushButton				m_pbAuto;

	Image					m_imgPKey;

	virtual SbaColumnList&	FillColumnList(SbaColumnList& rList,sal_uInt32 nRows) = 0;
	void					EnableAuto(sal_Bool bEnable);
public:
	virtual	void			Reset ( );
	virtual void			ActivatePage( );
	virtual void			Resize();
	virtual sal_Bool			LeavePage();
	virtual String			GetTitle() const;

	SbaWizTypeSelect(Window* pParent);
	virtual ~SbaWizTypeSelect();

};
// ========================================================
// Wizard Page: SbaWizHTMLExtend
// ========================================================
class SbaWizHTMLExtend : public SbaWizTypeSelect
{
	SvStream*		m_pParserStream; // HTML Stream
protected:
	virtual SbaColumnList&	FillColumnList(SbaColumnList& rList,sal_uInt32 nRows);
public:
	SbaWizHTMLExtend(Window* pParent,SvStream&	rRtfStream) : SbaWizTypeSelect( pParent),m_pParserStream(&rRtfStream) {};

	virtual ~SbaWizHTMLExtend(){}
	//virtual String GetTitle() const { return String(SbaResId(SBA_STR_HTML_TITLE)); }
};
// ========================================================
// Wizard Page: SbaWizRTFExtend
// ========================================================
class SbaWizRTFExtend : public SbaWizTypeSelect
{
	SvStream*		m_pParserStream; // RTF Stream
protected:
	virtual SbaColumnList&	FillColumnList(SbaColumnList& rList,sal_uInt32 nRows);
public:
	SbaWizRTFExtend(Window* pParent,SvStream&	rRtfStream) : SbaWizTypeSelect( pParent),m_pParserStream(&rRtfStream) {};

	virtual ~SbaWizRTFExtend(){}
	//virtual String GetTitle() const { return String(SbaResId(SBA_STR_RTF_TITLE)); }
};

// ========================================================
// Wizard Page: SbaWizNormalExtend
// ========================================================
class SbaWizNormalExtend : public SbaWizTypeSelect
{
protected:
	virtual SbaColumnList&	FillColumnList(SbaColumnList& rList,sal_uInt32 nRows) { return rList;};
public:
	SbaWizNormalExtend(Window* pParent);
};
// ========================================================
// columns are at root only no children
// ========================================================
class SbaColumnTreeBox : public SbaTreeListBox
{
	sal_Bool m_bReadOnly;
protected:
	virtual void InitEntry(SvLBoxEntry* pEntry, const String& rStr, const Image& rImg1, const Image& rImg2);
	
public:
	SbaColumnTreeBox( Window* pParent, WinBits nWinStyle=0 );
	SbaColumnTreeBox( Window* pParent, const ResId& rResId );
	
	void FillListBox( const SbaColumnList& _rList);
	void SetReadOnly(sal_Bool _bRo=sal_True) { m_bReadOnly = _bRo; }
	virtual sal_Bool Select( SvLBoxEntry* pEntry, sal_Bool bSelect=sal_True );
};
// ========================================================
// Wizard Page: SbaWizNameMatching
// Name matching for data appending
// ========================================================
class SbaWizNameMatching : public SbaWizardPage
{
	FixedText			m_FT_TABLE_LEFT;
	FixedText			m_FT_TABLE_RIGHT;
	SbaColumnTreeBox	m_CTRL_LEFT; // left side
	SbaColumnTreeBox	m_CTRL_RIGHT; // right side
	PushButton			m_pbColumn_up;
	PushButton			m_pbColumn_down;
	PushButton			m_pbColumn_up_right;
	PushButton			m_pbColumn_down_right;
	PushButton			m_pbAll;
	PushButton			m_pbNone;

	sal_Bool				m_bAttrsChanged;

	DECL_LINK( ButtonClickHdl, Button * );
	DECL_LINK( RightButtonClickHdl, Button * );
	DECL_LINK( AllNoneClickHdl, Button * );
	DECL_LINK( TableListClickHdl, SvTreeListBox* );
	DECL_LINK( TableListRightSelectHdl, SvTreeListBox* );

public:
	virtual	void			Reset ( );
	virtual void			ActivatePage();
	virtual sal_Bool			LeavePage();
	virtual String			GetTitle() const ;

	SbaWizNameMatching(Window* pParent);
	virtual ~SbaWizNameMatching();

};

#endif

