/*************************************************************************
 *
 *  $RCSfile: sbaconn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SBA_SBACONN_HXX
#define SBA_SBACONN_HXX

#ifndef _SVX_CHECKLBX_HXX //autogen
#include <svx/checklbx.hxx>
#endif

#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif

#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _DBCONFIG_HXX
#include "dbconfig.hxx"
#endif

#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif

#include "sbatree.hxx"

class SbaDbtypeDlg;
class DbTypeDefList;
class SbaCharset;
class SfxStringItem;
class SfxFileDialog;
//========================================================================

class SbaDlgTypeselect : public ModalDialog
{
protected:
	ListBox			aLB_DATASOURCE;
	OKButton		aPB_OK;
	CancelButton	aPB_CANCEL;
	HelpButton		aPB_HELP;
	PushButton		aPB_MANAGE;
	GroupBox		aGB_BOX1;
	String			aServerType;

	DECL_LINK( ListDblClickHdl, ListBox * );
	DECL_LINK( ManageClickHdl, PushButton * );


public:
	SbaDlgTypeselect( Window* pParent, const String& rStrList,
					  const String& rServer, USHORT nServerType);
	~SbaDlgTypeselect();

	inline String	GetSelectEntry() const
					{ return aLB_DATASOURCE.GetSelectEntry();}
};

//========================================================================

class SbaDbtypeDlg : public SfxTabDialog
{
	friend class SbaTypePage;
	friend class SbaGeneralPage;

	String			aTitle;
	String			aGeneralTitle;
	String			aTypeTitle;
	String			aTextTitle;
	String			aOdbcTitle;
	String			aJdbcTitle;
	String			aDb2Title;
	String			aAdabasTitle;
	String			aAdabasAdminTitle;
	String			aAddrbookTitle;
	String			aORCL7Title;
	String			aDAOTitle;
	String			aADOTitle;
	String			aOTERTitle;
	String			aStarBaseTitle;
	String			aDbaseTitle;
	String			aFmkTitle;
	String			aTabSubscrTitle;
	USHORT			nTypePageId;
	USHORT			nServerType;
	DbTypeDefList*	pDbTypeDefList;
	SbaDBConfig*	pOwner;
	BOOL			bMultiUser; // gilt nur fuer StarBase
	BOOL			m_bServerAdmin;

public:
	SbaDbtypeDlg(Window* pParent, const SfxItemSet*, SbaDBConfig* pCaller);
	~SbaDbtypeDlg();

	virtual void PageCreated( USHORT nPageId, SfxTabPage& rTabPage );
	void AddDetailPage( USHORT nPageId );
	void CreateDetailPage( USHORT nNewServerType );
	USHORT GetSelectServerType(const String&);
	USHORT ServerType() const {return nServerType;}
	SbaDBConfig* GetOwner(){ return pOwner; }
};


//========================================================================

class SbaAliasEdit : public Edit
{
	virtual void KeyInput( const KeyEvent& rKEvt );

public:
	inline SbaAliasEdit( Window* pParent, const ResId& rResId ) :
					Edit( pParent, rResId ) {}
};

//========================================================================

class SbaGeneralPage : public SfxTabPage
{
	BOOL bMod;

public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset ( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );

private:
	FixedImage			aBMP_DB;
	SbaAliasEdit		aET_NAME;

	FixedLine			aFL_1;

	FixedText			aFT_TYPE;
	FixedText			aFT_TYPE_SHOW;

	FixedText			aFT_FILE;
	FixedText			aFT_FILE_SHOW;

	FixedLine			aFL_2;

	FixedText			aFT_CREATED;
	FixedText			aFT_CREATED_SHOW;

	FixedText			aFT_CHANGED;
	FixedText			aFT_CHANGED_SHOW;
	String 				aReadOnly;

	SbaGeneralPage(Window* pParent, const SfxItemSet& rCoreAttrs);
	~SbaGeneralPage();

private:
	BOOL bAttrsChanged;
	SbaDbtypeDlg*		pParentDlg;

	DECL_LINK( EditLoseFocusHdl, Control * );
	DECL_LINK( EditModifyHdl, Edit * );

public:
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }
};

//========================================================================

class SbaTypePage : public SfxTabPage
{
	String			aDSNName;
	String			aDSNDir;
	String			aDBFilename;

public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );

private:
	FixedText			aFT_DATATYPE;
	ListBox				aLB_DATATYPE;
	FixedText			aFT_DSNNAME;
	Edit				aET_DSNNAME;
	PushButton			aPB_RESTORE_BACKUP;
	PushButton			aPB_NEWDB;
	PushButton			aPB_DSNNAME;
	FixedText			aFT_ORCL_EXPL;
	FixedText			aFT_OTER_EXPL;

	String				aStrTextFilterList;
	String				aStrDbaseFilterList;
	String				aStrFmkFilterList;
	String				m_AdabasSysUser;
	String				m_AdabasSysPwd;
	String				m_AdabasCtrlUser;
	String				m_AdabasCtrlPwd;

	SbaDbtypeDlg*		pParentDlg;
	String				FindServerType( const String& aName );

	SbaTypePage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaTypePage();

private:
	BOOL	bAttrsChanged;
	BOOL	bDbNew;
	BOOL	bFound;		// gibt an ob eine Datei gefunden wurde, bei neuen wird es auf neu gesetzt

	DECL_LINK( ListBoxHdl, ListBox * );
	DECL_LINK( ButtonClickHdl, Button * );
	DECL_LINK( ButtonNEWDBClickHdl, Button * );
	DECL_LINK( EditLoseFocusHdl, Control * );
	DECL_LINK( EditModifyHdl, Edit * );

public:
	void SetParentDlg( SbaDbtypeDlg* pDlg );
};

// =======================================================================
// =
// = mit Passwoertern/CharSets muessen sich mehrere der TabPages rumschlagen, also
// = packe ich das doch mal in eine KLasse
// =
// = die Controls muessen wie ueblich in der Ressource definiert sein, lediglich
// = ihre Verwaltung wird von mir uebernommen

#define		CBTP_NONE			0x0000
#define		CBTP_USE_UIDPWD		0x0001
#define		CBTP_USE_CHARSET	0x0002
#define		CBTP_USE_OPTIONS	0x0004

class SbaCommonBehaviourTabPage : public SfxTabPage
{
protected:
	FixedText*			pFT_USERNAME;
	Edit*				pET_USERNAME;
	FixedText*			pFT_PASSWORD;
	Edit*				pET_PASSWORD;
	CheckBox*			pCB_ASK_WHEN_EMPTY_PWD;

	FixedText*			pFT_OPTIONS;
	Edit*				pET_OPTIONS;

	FixedText*			pFT_CHARSET;
	ListBox*			pLB_CHARSET;

	SbaCharset*			pSbaCharset;

	USHORT				m_nControlFlags;

public:
	virtual void		ActivatePage(const SfxItemSet& rCoreAttrs);
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
	virtual	BOOL		FillItemSet	(SfxItemSet& rCoreAttrs);

protected:
	SbaCommonBehaviourTabPage(Window* pParent, USHORT nResId, const SfxItemSet& rCoreAttrs, USHORT nControlFlags);
		// nControlFlags ist eine Kombination der CBTP_xxx-Konstanten
	virtual ~SbaCommonBehaviourTabPage();

private:
	DECL_LINK( OnPasswordModified, Control* );
};

//========================================================================

class SbaOdbcPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedLine			aFL_1;

	SbaDbtypeDlg*		pParentDlg;

	SbaOdbcPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaOdbcPage();
};

//========================================================================
class SbaJdbcPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedText			aFT_JDBCDRV;
	Edit				aET_JDBCDRV;
	FixedText			aFT_URL;
	Edit				aET_URL;
	FixedLine			aFL_1;

	SbaDbtypeDlg*		pParentDlg;

	SbaJdbcPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaJdbcPage();

private:

	BOOL				bAttrsChanged;
	DECL_LINK( EditLoseFocusHdl, Control * );
};

//========================================================================
class SbaDb2Page : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedLine			aFL_1;
	SbaDbtypeDlg*		pParentDlg;

	SbaDb2Page( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaDb2Page();
};

//========================================================================
class SbaAdabasPage : public SbaCommonBehaviourTabPage
{
public:
	virtual void		ActivatePage( const SfxItemSet& rCoreAttrs );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	SbaDbtypeDlg*		pParentDlg;
	BOOL				bAttrsChanged;

	SbaAdabasPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaAdabasPage();
	DECL_LINK( AttributesChangedHdl, void * );
};
//========================================================================
class SbaAdabasSettings : public SbaCommonBehaviourTabPage
{
public:
	virtual void		ActivatePage( const SfxItemSet& rCoreAttrs );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedText			m_FT_CACHE_SIZE;
	NumericField		m_NF_CACHE_SIZE;

	FixedText			m_FT_DATA_INCREMENT;
	NumericField		m_NF_DATA_INCREMENT;

	FixedLine			aFL_1;
	FixedText			m_FT_CTRLUSERNAME;
	Edit				m_ET_CTRLUSERNAME;
	FixedText			m_FT_CTRLPASSWORD;
	Edit				m_ET_CTRLPASSWORD;

	CheckBox			m_CB_SHUTDB;
	PushButton			m_PB_STAT;
	String				m_aConnection;
	SbaDbtypeDlg*		pParentDlg;
	BOOL				bAttrsChanged;

	SbaAdabasSettings( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaAdabasSettings();
	DECL_LINK( AttributesChangedHdl,	void * );
	DECL_LINK( UserSettingsHdl,			void * );
	DECL_LINK( LoseFocusHdl,			Edit * );
	DECL_LINK( PBClickHdl,				Button *);
};

//========================================================================
class SbaAddrbookPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	SbaDbtypeDlg*		pParentDlg;
	PushButton			m_pbMapping;

	SbaAddrbookPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaAddrbookPage();
	DECL_LINK( ButtonClickHdl, Button * );
};

//========================================================================
class SbaORCL7Page : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg ) { pParentDlg = pDlg; }

private:
	FixedLine			aFL_1;

	SbaDbtypeDlg*		pParentDlg;

	SbaORCL7Page( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaORCL7Page();
};


//========================================================================
class SbaDAOPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedLine			aFL_1;
	FixedText			aFT_DBPASSWD;
	Edit				aET_DBPASSWD;
	FixedText			aFT_SYSTEMDB;
	Edit				aET_SYSTEMDB;
	PushButton			aPB_SYSTEMDB;
	FixedText			aFT_SYSTEMDB_EXPL;
	SbaDbtypeDlg*		pParentDlg;
	BOOL	bFound;		// gibt an ob die mdw Datei gefunden wurde

	SbaDAOPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaDAOPage();

private:

	BOOL				bAttrsChanged;
	DECL_LINK( AttributesChangedHdl, void * );
	DECL_LINK( EditLoseFocusHdl, Control * );
	DECL_LINK( PBClickHdl, Button *);
};

//========================================================================
class SbaADOPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	FixedText			aFT_PROVIDER;
	Edit				aET_PROVIDER;
	
	SbaDbtypeDlg*		pParentDlg;
	BOOL	bFound;		// gibt an ob die mdw Datei gefunden wurde

	SbaADOPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaADOPage();

private:

	BOOL				bAttrsChanged;
    DECL_LINK( AttributesChangedHdl, void * );
    DECL_LINK( EditLoseFocusHdl, Control * );
};



//========================================================================

class SbaTextPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	CheckBox	aCB_HDR;
	FixedText	aFT_DEL;
	ComboBox	aCM_DEL;
	FixedText	aFT_STR;
	ComboBox	aCM_STR;
	FixedText	aFT_DECDEL;
	ComboBox	aCM_DECDEL;
	FixedText	aFT_THODEL;
	ComboBox	aCM_THODEL;
	FixedLine	aFL_1;
	FixedText	aFT_EXTENSION;
	ComboBox	aCM_EXTENSION;

	SbaDbtypeDlg*		pParentDlg;

	String				aStrDelList;
	String				aStrStrList;

	SbaTextPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaTextPage();

private:

	BOOL bAttrsChanged;
	DECL_LINK( AttributesChangedHdl, void * );
	DECL_LINK( EditLoseFocusHdl, Control * );
	DECL_LINK( ButtonClickHdl, Button * );
	DECL_LINK( DelimeterHdl, Control * );
	DECL_LINK( ExtensionHdl, Control * );
	USHORT				GetSeparator( const ComboBox& rBox, const String& rList );
	void				SetSeparator( ComboBox& rBox, const String& rList, USHORT nVal );
};

//========================================================================
class SbaDbasePage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg ) { pParentDlg = pDlg; }

private:
	CheckBox			aCB_SHOWDELETED;
	CheckBox			aCB_LONGTABLENAMES;

	SbaDbtypeDlg*		pParentDlg;

	SbaDbasePage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaDbasePage();

private:

	PushButton				aPB_INDEXES;
	const SfxStringItem*	pDSNItem;
	DECL_LINK( ButtonClickHdl, Button * );
};
//========================================================================
class SbaTableTreeListBox : public SbaTreeListBox
{
protected:
	Image			m_aTableImage;
	Image			m_aViewImage;

	virtual void Command( const CommandEvent& rEvt );
public:
	SbaTableTreeListBox( Window* pParent, WinBits nWinStyle=0 );
	SbaTableTreeListBox( Window* pParent, const ResId& rResId );
	// gefiltert
	virtual void	UpdateTableList(SdbDatabase* pDatabase,BOOL bViewsAllowed);
	// ungefiltert
	virtual void	UpdateTableList(SdbConnection* pConnection,BOOL bViewsAllowed);
};
//========================================================================
class SbaTabSubscrPage : public SfxTabPage
{
private:
	SbaTableTreeListBox		aTLB_Tables;
	FixedText			aFT_TabSubscr;
	PushButton			aPB_AddAll;
	BOOL				bCheckedAll;
	SbaDbtypeDlg*		pParentDlg;
	char				m_cSeparator;

public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
	virtual	BOOL		FillItemSet( SfxItemSet& rCoreAttrs );
	virtual	void		Reset( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:


	SbaTabSubscrPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaTabSubscrPage();

	void CheckAll( BOOL bCheck=TRUE );
	// Durchsucht die ListBox nach diesem Eintrag
	DECL_LINK( AddAllClickHdl, PushButton* );
	// F"uhrt eine Plausibilit"atspr"ufung durch

};

//========================================================================

class SbaFmkPage : public SfxTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	CheckBox			aCB_FETCHALL;
	FixedText			aFT_MAXROWS;
	Edit				aET_MAXROWS;

	SbaDbtypeDlg*		pParentDlg;

	SbaFmkPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaFmkPage();

private:

	BOOL				bAttrsChanged;
	DECL_LINK( EditLoseFocusHdl, Control * );
	DECL_LINK( ButtonClickHdl, Button * );
};

//========================================================================
class SbaOTERPage : public SbaCommonBehaviourTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg ) { pParentDlg = pDlg; }

private:
	SbaDbtypeDlg*		pParentDlg;

	SbaOTERPage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaOTERPage();
};
//========================================================================
// Diese Page dient zur Admin. der Datenbank
class SbaStarBasePage : public SfxTabPage
{
public:
	static	SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
	virtual	BOOL		FillItemSet	( SfxItemSet& rCoreAttrs );
	virtual	void		Reset		( const SfxItemSet& rCoreAttrs );
	virtual void		ActivatePage( const SfxItemSet& );
	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
	inline void			SetParentDlg( SbaDbtypeDlg* pDlg )
						{ pParentDlg = pDlg; }

private:
	PushButton			aPB_PWD;
	FixedText			aFT_USERNAME;
	Edit				aET_USERNAME;
	FixedText			aFT_PASSWORD;
	Edit				aET_PASSWORD;
	FixedText			aFT_CONFIRM;
	Edit				aET_CONFIRM;
	CheckBox			aCB_MULTI_USER;
	CheckBox			aCB_TRANSACT;
	GroupBox			aGB_PWD;
	GroupBox			aGB_ATT;
	PushButton			m_PB_CONVERT;
	String				aOldPwd;
	String				aTxt1;
	String				aTxt2;
//	String				aConn;
	String				aPwd;
	String				m_aFileName;

	SbaDbtypeDlg*		pParentDlg;

	SbaStarBasePage( Window* pParent, const SfxItemSet& rCoreAttrs );
	~SbaStarBasePage();

	BOOL				m_bInLoseFocusHdl;
		// wenn man von der Passwort-Editzeile zur Bestaetigungs-Editzeile wechselt, bekommt man ein LoseFocus fuer erstere.
		// Zeigt man dort eine MessageBox an (wg. Fehler), bekommt man ein LoseFocus fuer letztere. Zeigt man dort auch die
		// Fehlermeldung an, hat man wegen einem Control-Wechsel zweimal dieselbe Fehlermeldung ...

private:

	BOOL				bAttrsChanged;
	DECL_LINK( AttributesChangedHdl, void * );
	DECL_LINK( CbClickPWD_ON_Hdl, Button*);
	DECL_LINK( LoseFocusHdl,Control *);
	DECL_LINK( ConvertHdl, Button*);
};




#endif // SBA_SBACONN_HXX
