/*************************************************************************
 *
 *  $RCSfile: sbactrl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBACTRL_HXX
#define _SBACTRL_HXX

#ifndef _SFX_HXX
#include <sfx.hxx>
#endif

#ifndef _SFXDOC_HXX
#include <sfxdoc.hxx>
#endif

#include "sbastr.hxx"
class SbaQueryDocSh;

//==========================================================================
class SbaTableNameBox : public ComboBox
{
private:
	SbaStringList	aSbaStringList;
	String			aCurText;
	Accelerator*	pAccel;
	SbaQueryDocSh*	pQrySh;

	void			ReleaseFocus();
	DECL_LINK( AccelSelectHdl, Accelerator * );

protected:
	virtual void 	Select();
	virtual void	GetFocus();
	virtual void	LoseFocus();

public:
					SbaTableNameBox( Window* pParent, WinBits nStyle = 0 );

	void 			Update( const SfxStringItem* pItem );
	void 			Update();
};

//==========================================================================

class SbaTargetBox : public ListBox, public SfxListener
{
private:
	USHORT			nSlotId;
	USHORT			nCurSel;
//	String			aCurText;
	Accelerator*	pAccel;
	SbaQueryDocSh*	pQrySh;

	void	ReleaseFocus();
	DECL_LINK( AccelSelectHdl, Accelerator * );

protected:
	virtual void	Select();
	virtual void	GetFocus();
	virtual void	LoseFocus();
	virtual void 	Notify( SfxBroadcaster& rBC, const SfxHint& rHint);

public:
					SbaTargetBox( Window*		pParent,
								 USHORT			nSlot,
								 WinBits		nStyle = WB_SORT );
					~SbaTargetBox();

	void 			Update( const SfxStringItem* pItem );
	void 			Update();
};

//==========================================================================

class SbaDBSelectBox : public ListBox, public SfxListener
{
private:
	USHORT			nSlotId;
	String			aCurSel;
	Accelerator*	pAccel;
	SbaQueryDocSh*	pQrySh;

	void	ReleaseFocus();
	DECL_LINK( AccelSelectHdl, Accelerator * );

protected:
	virtual void	Select();
	virtual void	GetFocus();
	virtual void	LoseFocus();
	virtual void 	Notify( SfxBroadcaster& rBC, const SfxHint& rHint);

public:
					SbaDBSelectBox( Window*		pParent,
								 USHORT			nSlot,
								 WinBits		nStyle = WB_SORT );
					~SbaDBSelectBox();

	void 			Update( const SfxStringItem* pItem );
	void 			Update();
};

//==========================================================================

class SbaTableNameBoxToolBoxControl : public SfxToolBoxControl
{
private:
	SfxStatusForwarder	aDBChangeForwarder;

public:
	SFX_DECL_TOOLBOX_CONTROL();
	SbaTableNameBoxToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );

	virtual void	StateChanged		( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual Window*	CreateItemWindow	( Window *pParent );
};

//==========================================================================

class SbaTargetBoxToolBoxControl : public SfxToolBoxControl
{
private:
public:
	SFX_DECL_TOOLBOX_CONTROL();
	SbaTargetBoxToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );

	virtual void	StateChanged		( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual Window*	CreateItemWindow	( Window *pParent );
};

//==========================================================================

class SbaDBSelectBoxToolBoxControl : public SfxToolBoxControl
{
private:
public:
	SFX_DECL_TOOLBOX_CONTROL();
	SbaDBSelectBoxToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings );

	virtual void	StateChanged		( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState );
	virtual Window*	CreateItemWindow	( Window *pParent );
};

//==========================================================================

#endif//_SBACTRL_HXX

