/*************************************************************************
 *
 *  $RCSfile: sbadbcom.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBCOM_HXX
#define _SBA_SBADBCOM_HXX

#ifndef _COM_SUN_STAR_DATA_DATABASEDETAILEDEXCEPTION_HPP_
#include <com/sun/star/data/DatabaseDetailedException.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEEXCEPTION_HPP_
#include <com/sun/star/data/DatabaseException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_WRAPPEDTARGETEXCEPTION_HPP_
#include <com/sun/star/lang/WrappedTargetException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_INDEXOUTOFBOUNDSEXCEPTION_HPP_
#include <com/sun/star/lang/IndexOutOfBoundsException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HPP_
#include <com/sun/star/lang/IllegalArgumentException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XCHILD_HPP_
#include <com/sun/star/container/XChild.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XEVENTLISTENER_HPP_
#include <com/sun/star/lang/XEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINER_HPP_
#include <com/sun/star/container/XContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XREFRESHABLE_HPP_
#include <com/sun/star/util/XRefreshable.hpp>
#endif

namespace com { namespace sun { namespace star { namespace container {
	class XIndexAccess;
}	}	}	}

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE3_HXX_
#include <cppuhelper/implbase3.hxx>
#endif

//forgotten to include in <cppuhelper/compbase.hxx>
#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#ifndef _CPPUHELPER_COMPBASE2_HXX_
#include <cppuhelper/compbase2.hxx>
#endif

#ifndef _SBA_UTL_DERIVEDIMPL3_HXX
#include <sbautl/derivedimpl3.hxx>
#endif

#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

#ifndef _SBA_CONSTASCII_HXX_
#include <sbautl/constascii.hxx>
#endif

#ifndef _SDB_SDBSTAT_HXX //autogen
#include <sdb/sdbstat.hxx>
#endif

namespace staruno		= ::com::sun::star::uno;
namespace starlang		= ::com::sun::star::lang;
//namespace starbeans		= ::com::sun::star::beans;
namespace starcontainer	= ::com::sun::star::container;
namespace stardata		= ::com::sun::star::data;
namespace starutil		= ::com::sun::star::util;

class SdbObj;
class SdbColumn;
class SbaColumn;
class SbaXdbContent;
class SbaXdbComponent;

/**/
// StringConversion
#define U(aStr)			\
	(::rtl::OUString(UniString((aStr).GetStr(), CHARSET_SYSTEM)))
#define S(aUniCode)		\
	String(UniString(aUniCode), CHARSET_SYSTEM)
/**/
//==================================================================
// SbaDatabaseException
//==================================================================
class SbaDatabaseException 
	: public ::com::sun::star::data::DatabaseDetailedException
{
public:
	SbaDatabaseException(const SdbStatus& rStat, const staruno::Reference< staruno::XInterface > & xCont);
};

// ueberprueft das ergebnis einer Datenbankaction
// und wirft im bedarfsfall eine Exception
void checkDBResult(	
		const SdbStatus&, 
		const staruno::Reference< staruno::XInterface > &, 
		sal_Bool bWrap = sal_False
	)
	throw( stardata::DatabaseException, starlang::WrappedTargetException );

// uberpruefen ob ein index im gueltigen Bereich liegt
void checkIndex(
		const starcontainer::XIndexAccess* pContr, 
		sal_Int32 nIndex
	) 
	throw( starlang::IndexOutOfBoundsException );

// ueberpruefen ob ein Argument gesetzt ist
void checkArg(const staruno::Reference< staruno::XInterface > & xIface) 
		throw( starlang::IllegalArgumentException );

// ueberpruefen ob eine gueltige Componente gesetzt ist
void checkComponent(
		const SbaXdbComponent* pObj, 
		const SbaXdbComponent& rParent
	)
	throw( starlang::IllegalArgumentException );

//==================================================================
// SbaXdbBroadcaster,
// Hilfsklasse zum initialisieren eines OBroadcasterHelpers
//==================================================================
class SbaXdbBroadcaster
{
protected:
	::cppu::OBroadcastHelper m_aBHelper;

	SbaXdbBroadcaster(::osl::Mutex & rMutex_):m_aBHelper(rMutex_){}
};

//==================================================================
// SbaXdbComponentContext
// diese Klasse erlaubt Zugriff auf den globalen Kontext der Komponente
//==================================================================

class SbaXdbComponentContext // object is POD for now
{
public:
	staruno::Reference<starlang::XMultiServiceFactory> getServiceManager() const 
		throw(staruno::RuntimeException);

	void setServiceManager(staruno::Reference<starlang::XMultiServiceFactory> const& xServiceManager) 
		throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbContent
// diese Klasse kann von SbaXdbComponent erzeugt werden
//==================================================================
class SbaXdbContent 
	: public ::com::sun::star::container::XChild
{
	friend class SbaXdbComponent;

protected:
	SbaXdbComponent*		  m_pParent; // Vater

protected:
	SbaXdbContent(SbaXdbComponent* _pParent = NULL);

public:
	// starcontainer::XChild
	virtual staruno::Reference< staruno::XInterface >  
		SAL_CALL getParent(void) /*const*/ 
			throw( staruno::RuntimeException );

	virtual void 
		SAL_CALL setParent(const staruno::Reference< staruno::XInterface > & Parent) 
			throw( starlang::NoSupportException, staruno::RuntimeException );

	SbaXdbComponentContext& getXdbContext() const throw(staruno::RuntimeException);

	SbaXdbComponent* getXdbParent() const throw() {return m_pParent;}
	sal_Bool isOpen() const;

protected:
	// uberprueft ob das object geoeffnet ist
	virtual void checkOpen() const throw( starlang::DisposedException );
	void setXdbParent(SbaXdbComponent* pParent) throw() {m_pParent = pParent;}
	virtual void SAL_CALL disposing();
};

class SbaXdbObjectCreator;
class SbaXdbObject;

typedef std::vector<SbaXdbObject*> ODbObjectList;

//==================================================================
// SbaXdbCollection
// alle Collections sind subobjecte
//==================================================================
class SbaXdbCollection 
	: public SbaXdbContent
	, public ::cppu::WeakImplHelper3<
				::com::sun::star::lang::XEventListener,
				::com::sun::star::container::XContainer,
				::com::sun::star::container::XChild
				>
{
	friend class SbaXdbObject;

	ODbObjectList	m_aObjects;

	SbaXdbCollection( const SbaXdbComponent& );
	SbaXdbCollection& operator = ( const SbaXdbCollection & );

protected:
	SbaXdbComponent&					m_rParent;
	::cppu::OInterfaceContainerHelper	m_aContainerListeners;
public:
	SbaXdbCollection(SbaXdbComponent& _rParent);

// ::com::sun::star::uno::XInterface
	virtual void SAL_CALL acquire() throw( staruno::RuntimeException );
	virtual void SAL_CALL release() throw( staruno::RuntimeException );
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// ::com::sun::star::lang::XEventListener
	virtual void SAL_CALL disposing(const starlang::EventObject& Source) 
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XContainer
	virtual void SAL_CALL addContainerListener(
					const staruno::Reference< starcontainer::XContainerListener > & l) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL removeContainerListener(
					const staruno::Reference< starcontainer::XContainerListener > & l) 
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XChild
	virtual staruno::Reference< staruno::XInterface >  
		SAL_CALL getParent(void) /*const*/ 
			throw( staruno::RuntimeException )
	{ return SbaXdbContent::getParent(); }

	virtual void 
		SAL_CALL setParent(const staruno::Reference< staruno::XInterface > & Parent) 
			throw( starlang::NoSupportException, staruno::RuntimeException )
	{ SbaXdbContent::setParent(Parent); }

	sal_Bool hasObject(SbaXdbObject* pObj) const;
	void removeObject(SbaXdbObject* pObj);
	SbaXdbObject* removeObject(sal_uInt32 nPos);
	SbaXdbObject* getObject(sal_uInt32 nPos) const {return m_aObjects[nPos];}
	sal_Int32 size() const {return m_aObjects.size();}
	sal_Bool empty() const {return m_aObjects.empty();}

	virtual void SAL_CALL disposing();

protected:
	// direkter cast, kann zu Problemen fhren
	inline SbaXdbObjectCreator* getXdbCreator() const;
	void appendObject(SbaXdbObject* pObj);
};

//==================================================================
// SbaXdbNamedCollection
//==================================================================
class SbaXdbNamedCollection	: public ::sbautl::DerivedImplHelper3< SbaXdbNamedCollection, SbaXdbCollection,
									   ::com::sun::star::container::XNameContainer,
									   ::com::sun::star::container::XEnumerationAccess,
									   ::com::sun::star::util::XRefreshable
									  >
							, public SbaXdbCollection
{
protected:
	::cppu::OInterfaceContainerHelper	m_aRefreshListeners;
	staruno::Type						m_aElementType;
	const DBObject						m_eObj;

	SbaXdbNamedCollection(SbaXdbObjectCreator& rParent, DBObject _eObj, 
							staruno::Type const& rType);

public:
	DECLARE_DERIVED_IMPL(SbaXdbNamedCollection, DerivationHelper3);

// ::com::sun::star::container::XElementAccess (Base of XNameAccess and XEnumerationAccess)
	virtual staruno::Type SAL_CALL getElementType(void) throw( staruno::RuntimeException );
	virtual sal_Bool      SAL_CALL hasElements(void)    throw( staruno::RuntimeException );

// ::com::sun::star::container::XEnumerationAccess
	virtual staruno::Reference< starcontainer::XEnumeration >  
		SAL_CALL createEnumeration(void) 
			throw( staruno::RuntimeException );

// ::com::sun::star::container::XNameAccess (base of starcontainer::XNameReplace)
	virtual staruno::Any SAL_CALL getByName(const ::rtl::OUString& Name)        
		throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException );

	virtual sal_Bool     SAL_CALL hasByName(const ::rtl::OUString& Name)        
		throw( staruno::RuntimeException );

	virtual staruno::Sequence< ::rtl::OUString > SAL_CALL getElementNames(void) 
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XNameReplace (base of starcontainer::XNameContainer)
	virtual void SAL_CALL replaceByName(const ::rtl::OUString& Name, const staruno::Any& Element) 
		throw(	starlang::IllegalArgumentException, starcontainer::NoSuchElementException, 
				starlang::WrappedTargetException, staruno::RuntimeException );

// ::com::sun::star::container::XNameContainer
	virtual void SAL_CALL insertByName(const ::rtl::OUString& Name, const staruno::Any& Element) 
		throw(	starlang::IllegalArgumentException, starcontainer::ElementExistException, 
				starlang::WrappedTargetException, staruno::RuntimeException );

	virtual void SAL_CALL removeByName(const ::rtl::OUString& Name) 
		throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException );

// ::com::sun::star::util::XRefreshable
	virtual void SAL_CALL refresh(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL addRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL removeRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL disposing();

	// Object mu nicht ueber Refcount festgehalten sein!
	SbaXdbObject* get(const ::rtl::OUString& Name) const;

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const
		throw( stardata::DatabaseException, staruno::RuntimeException )= 0;
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element)
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException )= 0;
	virtual sal_Bool doRemove(SbaXdbObject* pObj)
		throw( stardata::DatabaseException, staruno::RuntimeException )= 0;
};


//==================================================================
// SbaXdbComponent
// diese Klasse kann DBObject erzeugen
//==================================================================
typedef ::cppu::WeakComponentImplHelper2<
									::com::sun::star::container::XChild,
									::com::sun::star::lang::XUnoTunnel
								> SbaXdbComponent_BASE; 
class SbaXdbComponent : public SbaXdbContent, // muss zuerst angegeben werden!
						public SbaXdbComponent_BASE
{
protected:
	typedef ::cppu::WeakComponentImplHelper2<starcontainer::XChild,starlang::XUnoTunnel> ComponentHelper;
	::osl::Mutex	  m_aMutex;

public:
	SbaXdbComponent(SbaXdbComponent* pParent = NULL)
	: SbaXdbContent(pParent)
	, ComponentHelper(m_aMutex)
	{}

	DECLARE_UNO3_DEFAULTS(SbaXdbComponent,ComponentHelper);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// ::com::sun::star::container::XChild
	virtual staruno::Reference< staruno::XInterface >  
		SAL_CALL getParent(void)
			throw( staruno::RuntimeException )
	{ return SbaXdbContent::getParent(); }

	virtual void 
		SAL_CALL setParent(const staruno::Reference< staruno::XInterface > & Parent) 
			throw( starlang::NoSupportException, staruno::RuntimeException )
	{ SbaXdbContent::setParent(Parent); }

// ComponentHelper
	virtual void SAL_CALL disposing(void);

	sal_Bool isDisposed() const { return ComponentHelper::rBHelper.bDisposed
									  || ComponentHelper::rBHelper.bInDispose; }

	::osl::Mutex&	getMutex() {return m_aMutex;}
};

//==================================================================
// SbaXdbObject
//==================================================================
class SbaXdbObject	:	public SbaXdbComponent
{
	friend class SbaXdbNamedCollection;

public:
	SbaXdbObject(SbaXdbCollection& rCollection);
	SbaXdbObject(){}
	~SbaXdbObject();

	// UnoTunnel support
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

};

//==================================================================
// SbaXdbComponent
// diese Klasse kann DBObject erzeugen
//==================================================================
class SbaXdbObjectCreator : public SbaXdbObject
{
	sal_Bool	m_bCaseSensitive;
public:
	SbaXdbObjectCreator(SbaXdbCollection& rCollection, sal_Bool bCase)
	: SbaXdbObject(rCollection)
	, m_bCaseSensitive(bCase)
	{}

	SbaXdbObjectCreator(sal_Bool bCase) : m_bCaseSensitive(bCase) {}

	virtual SdbObj* createObject(DBObject _eObj, const ::rtl::OUString& _rName) throw( stardata::DatabaseException )= 0;
	virtual SdbObj* openObject(DBObject _eObj, const ::rtl::OUString& _rName) = 0;
	virtual SdbObj* openObject(DBObject _eObj, sal_Int32 _nPos) = 0;
	virtual ::rtl::OUString getObjectName(DBObject _eObj, sal_Int32 _nPos) const = 0;
	virtual sal_Int32 getObjectCount(DBObject _eObj) const = 0;
	virtual void refresh(DBObject _eObj) throw( stardata::DatabaseException )= 0;

	sal_Bool isCaseSensitive() const { return m_bCaseSensitive; }
};

inline SbaXdbObjectCreator* SbaXdbCollection::getXdbCreator() const
{ return static_cast<SbaXdbObjectCreator*>(getXdbParent()); }

//==================================================================
// SbaReusableGuard
// a guard which can be cleared and reconnected to a mutex
//==================================================================
//= replaced by utl::OReusableGuard< ::osl::Mutex> in <unotools/guarding.hxx>

//==================================================================
// PropertyIds
//==================================================================
sal_Int32 const PROP_DEFAULTVALUE			= 0;
sal_Int32 const PROP_DESCRIPTION			= 1;
sal_Int32 const PROP_FORMATKEY				= 2;
sal_Int32 const PROP_ISAUTOINCREMENT		= 3;
sal_Int32 const PROP_ISDESCENDING			= 4;
sal_Int32 const PROP_ISMODIFIED				= 5;
sal_Int32 const PROP_ISPRIMARYKEY			= 6;
sal_Int32 const PROP_ISREADONLY				= 7;
sal_Int32 const PROP_ISREQUIRED				= 8;
sal_Int32 const PROP_ISUNIQUE				= 9;
sal_Int32 const PROP_ISUNSIGNED				= 10;
sal_Int32 const PROP_NAME					= 11;
sal_Int32 const PROP_PARAMETERTYPE			= 12;
sal_Int32 const PROP_REFNAME				= 13;
sal_Int32 const PROP_SCALE					= 14;
sal_Int32 const PROP_SEARCHINFO				= 15;
sal_Int32 const PROP_SIZE					= 16;
sal_Int32 const PROP_TYPE					= 17;
sal_Int32 const PROP_VALUE					= 18;
sal_Int32 const PROP_ISCLUSTERED			= 19;
sal_Int32 const PROP_REFTABLENAME			= 20;
sal_Int32 const PROP_TABLENAME				= 21;
sal_Int32 const PROP_UPDATERULE				= 22;
sal_Int32 const PROP_DELETERULE				= 23;
sal_Int32 const PROP_QUERY					= 24;
sal_Int32 const PROP_FILTER					= 25;
sal_Int32 const PROP_SORT					= 26;
sal_Int32 const PROP_ISPASSTHROUGH			= 27;
sal_Int32 const PROP_PRIVILIGES				= 28;
sal_Int32 const PROP_CACHESIZE				= 29;
sal_Int32 const PROP_CANDELETE				= 30;
sal_Int32 const PROP_CANINSERT				= 31;
sal_Int32 const PROP_CANUPDATE				= 32;
sal_Int32 const PROP_RECORDMODE				= 33;
sal_Int32 const PROP_LASTUPDATED			= 34;
sal_Int32 const PROP_RECORDCOUNT			= 35;
sal_Int32 const PROP_ISRECORDCOUNTFINAL		= 36;
sal_Int32 const PROP_RECORDSTATUS			= 37;
sal_Int32 const PROP_TITLE					= 38;
sal_Int32 const PROP_URL					= 39;
sal_Int32 const PROP_CONNECTIONSETTINGS		= 40;
sal_Int32 const PROP_STATEMENT				= 41;
sal_Int32 const PROP_EXECUTIONTIMEOUT		= 42;
sal_Int32 const PROP_MAXFIELDSIZE			= 43;
sal_Int32 const PROP_MAXRECORDCOUNT			= 44;
sal_Int32 const PROP_FIELDSOURCE			= 45;
sal_Int32 const PROP_CONTROLSOURCE			= 46;
sal_Int32 const PROP_CURSORSOURCE			= 47;
sal_Int32 const PROP_CURSORSOURCETYPE		= 48;
sal_Int32 const PROP_DATASOURCE				= 49;
sal_Int32 const PROP_DEFAULTCONTROL			= 50;
sal_Int32 const PROP_LABEL					= 51;
sal_Int32 const PROP_WIDTH					= 52;
sal_Int32 const PROP_BORDER					= 53;
sal_Int32 const PROP_BOUNDFIELD				= 54;
sal_Int32 const PROP_SORT_CRITERIA			= 55;
sal_Int32 const PROP_FILTER_CRITERIA		= 56;
sal_Int32 const PROP_HIDDEN					= 57;
sal_Int32 const PROP_HELPTEXT				= 58;
sal_Int32 const PROP_ALIGN					= 59;
sal_Int32 const PROP_ROW_HEIGHT				= 60;
sal_Int32 const PROP_FONT					= 61;
sal_Int32 const PROP_TEXTCOLOR				= 62;
sal_Int32 const PROP_SELECTED_FIELDS		= 63;
sal_Int32 const PROP_SELECTED_TABLES		= 64;
sal_Int32 const PROP_ISFUNCTION				= 65;
sal_Int32 const PROP_PRIMARYKEY				= 66;
sal_Int32 const PROP_THREADSAFE				= 67;
sal_Int32 const PROP_SOURCE					= 68;
sal_Int32 const PROP_ISVERSIONING			= 69;

//==================================================================
// PropertyNamen
//==================================================================
typedef SbaConstAsciiString const StaticPropertyName;
extern StaticPropertyName PROP_NAME_DEFAULTVALUE;
extern StaticPropertyName PROP_NAME_DESCRIPTION;
extern StaticPropertyName PROP_NAME_FORMATKEY;
extern StaticPropertyName PROP_NAME_ISAUTOINCREMENT;
extern StaticPropertyName PROP_NAME_ISDESCENDING;
extern StaticPropertyName PROP_NAME_ISMODIFIED;
extern StaticPropertyName PROP_NAME_ISPRIMARYKEY;
extern StaticPropertyName PROP_NAME_ISREADONLY;
extern StaticPropertyName PROP_NAME_ISREQUIRED;
extern StaticPropertyName PROP_NAME_ISUNIQUE;
extern StaticPropertyName PROP_NAME_ISUNSIGNED;
extern StaticPropertyName PROP_NAME_NAME;
extern StaticPropertyName PROP_NAME_PARAMETERTYPE;
extern StaticPropertyName PROP_NAME_REFNAME;
extern StaticPropertyName PROP_NAME_SCALE;
extern StaticPropertyName PROP_NAME_SEARCHINFO;
extern StaticPropertyName PROP_NAME_SIZE;
extern StaticPropertyName PROP_NAME_TYPE;
extern StaticPropertyName PROP_NAME_VALUE;
extern StaticPropertyName PROP_NAME_ISCLUSTERED;
extern StaticPropertyName PROP_NAME_REFTABLENAME;
extern StaticPropertyName PROP_NAME_TABLENAME;
extern StaticPropertyName PROP_NAME_UPDATERULE;
extern StaticPropertyName PROP_NAME_DELETERULE;
extern StaticPropertyName PROP_NAME_QUERY;
extern StaticPropertyName PROP_NAME_FILTER;
extern StaticPropertyName PROP_NAME_SORT;
extern StaticPropertyName PROP_NAME_ISPASSTHROUGH;
extern StaticPropertyName PROP_NAME_PRIVILIGES;
extern StaticPropertyName PROP_NAME_CACHESIZE;
extern StaticPropertyName PROP_NAME_CANDELETE;
extern StaticPropertyName PROP_NAME_CANINSERT;
extern StaticPropertyName PROP_NAME_CANUPDATE;
extern StaticPropertyName PROP_NAME_RECORDMODE;
extern StaticPropertyName PROP_NAME_LASTUPDATED;
extern StaticPropertyName PROP_NAME_RECORDCOUNT;
extern StaticPropertyName PROP_NAME_ISRECORDCOUNTFINAL;
extern StaticPropertyName PROP_NAME_RECORDSTATUS;
extern StaticPropertyName PROP_NAME_TITLE;
extern StaticPropertyName PROP_NAME_URL;
extern StaticPropertyName PROP_NAME_CONNECTIONSETTINGS;
extern StaticPropertyName PROP_NAME_STATEMENT;
extern StaticPropertyName PROP_NAME_EXECUTIONTIMEOUT;
extern StaticPropertyName PROP_NAME_MAXFIELDSIZE;
extern StaticPropertyName PROP_NAME_MAXRECORDCOUNT;
extern StaticPropertyName PROP_NAME_FIELDSOURCE;
extern StaticPropertyName PROP_NAME_CONTROLSOURCE;
extern StaticPropertyName PROP_NAME_CURSORSOURCE;
extern StaticPropertyName PROP_NAME_CURSORSOURCETYPE;
extern StaticPropertyName PROP_NAME_DATASOURCE;
extern StaticPropertyName PROP_NAME_DEFAULTCONTROL;
extern StaticPropertyName PROP_NAME_LABEL;
extern StaticPropertyName PROP_NAME_WIDTH;
extern StaticPropertyName PROP_NAME_BORDER;
extern StaticPropertyName PROP_NAME_BOUNDFIELD;
extern StaticPropertyName PROP_NAME_SORT_CRITERIA;
extern StaticPropertyName PROP_NAME_FILTER_CRITERIA;
extern StaticPropertyName PROP_NAME_HIDDEN;
extern StaticPropertyName PROP_NAME_HELPTEXT;
extern StaticPropertyName PROP_NAME_ALIGN;
extern StaticPropertyName PROP_NAME_ROW_HEIGHT;
extern StaticPropertyName PROP_NAME_FONT;
extern StaticPropertyName PROP_NAME_TEXTCOLOR;
extern StaticPropertyName PROP_NAME_SELECTED_FIELDS;
extern StaticPropertyName PROP_NAME_SELECTED_TABLES;
extern StaticPropertyName PROP_NAME_ISFUNCTION;
extern StaticPropertyName PROP_NAME_PRIMARYKEY;
extern StaticPropertyName PROP_NAME_THREADSAFE;
extern StaticPropertyName PROP_NAME_SOURCE;
extern StaticPropertyName PROP_NAME_ISVERSIONING;


#endif //_SBA_SBADBCOM_HXX

