/*************************************************************************
 *
 *  $RCSfile: sbadbcur.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBCUR_HXX
#define _SBA_SBADBCUR_HXX

#ifndef _COM_SUN_STAR_UTIL_XCANCELLABLE_HPP_
#include <com/sun/star/util/XCancellable.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XCLONEABLE_HPP_
#include <com/sun/star/util/XCloneable.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XEVENTLISTENER_HPP_
#include <com/sun/star/lang/XEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEUPDATECURSOR_HPP_
#include <com/sun/star/data/XDatabaseUpdateCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEBOOKMARKCURSOR_HPP_
#include <com/sun/star/data/XDatabaseBookmarkCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDIRECTCURSOR_HPP_
#include <com/sun/star/data/XDatabaseDirectCursor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XPREPAREDDATABASESTATEMENT_HPP_
#include <com/sun/star/data/XPreparedDatabaseStatement.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASERECORDSTATUS_HPP_
#include <com/sun/star/data/DatabaseRecordStatus.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASERECORDMODE_HPP_
#include <com/sun/star/data/DatabaseRecordMode.hpp>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL7_HXX
#include <sbautl/derivedpropimpl7.hxx>
#endif
#ifndef _SBA_UTL_DERIVEDPROPIMPL1_HXX
#include <sbautl/derivedpropimpl1.hxx>
#endif

#ifndef _SDB_SDBCURS_HXX //autogen
#include <sdb/sdbcurs.hxx>
#endif

#ifndef _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

class SbaXdbTable_Impl;
class SbaXdbQuery;

namespace staruno	= :: com::sun::star::uno;
namespace starlang	= :: com::sun::star::lang;
namespace stardata	= :: com::sun::star::data;
namespace starutil	= :: com::sun::star::util;

//==================================================================
// SbaXdbCursorMultiplexer
//==================================================================
class SbaXdbCursor;
class SbaXdbCursorMultiplexer : public ::cppu::OWeakObject//UsrObject
{
	::cppu::OInterfaceContainerHelper /*ListenerContainer*/  m_aListeners;

	static SbaXdbCursor* getXdbCursor(staruno::XInterface*);
public:
	SbaXdbCursorMultiplexer(SdbCursor* pCursor, ::osl::Mutex& rMutex );

	void addEventListener(SbaXdbCursor* pCursor);
	void removeEventListener(SbaXdbCursor* pCursor);

	void recordDeleted(const staruno::Any& aCurrentBookmark, const staruno::Any& aNextBookmark);
	void updateRowCount();

	DECL_LINK(RowCountHdl, SdbCursor* );
};

//==================================================================
// SbaXdbCursor
//==================================================================
class SbaXdbCursor   : public SbaXdbObject,
					   public ::sbautl::DerivedPropertySetHelper7<SbaXdbCursor,SbaXdbObject,
										::com::sun::star::data::XDatabaseUpdateCursor,
										::com::sun::star::data::XDatabaseBookmarkCursor,
										::com::sun::star::data::XDatabaseDirectCursor,
										::com::sun::star::util::XCloneable,
										::com::sun::star::lang::XEventListener,
										::com::sun::star::util::XCancellable,
										::com::sun::star::lang::XUnoTunnel
									>
{
	friend class SbaXdbDatabase;
	friend class SbaXdbConnection;

protected:
	SbaXdbFieldValues           m_aFields;
	SdbCursorRef                m_xCursor;
	ODbRowRef	                m_xResultRow;

	sal_Bool					m_bCanceled;

private:
	ODbRowRef                   m_xOrigRow;

	SbaXdbCursorMultiplexer*	m_pCursorHdl;
	sal_uInt32					m_nAsyncUpdateRowCount;

	// Saemtliche zustandsvariablen
	staruno::Any                m_aBookmark, m_aNextBookmark;
	sal_uInt32                  m_nRecordCount;
	sal_Int32                   m_nPosition;
	stardata::DatabaseRecordMode	m_eRecordMode;
	stardata::DatabaseRecordStatus	m_eRecordStatus,
									m_eOrigStatus;
	sal_Bool                    m_bEOF          : 1,
								m_bBOF          : 1,
								m_bFirst        : 1,
								m_bLast         : 1,
								m_bOwnsResultRow: 1,    // Ist der Cursor lediglich eine Copy ?
								m_bRecordCountFinal : 1,
								m_bForwardOnly  : 1,
								m_bClone        : 1,    // ein Clone hat nur eingeschraenkt Funktionalitaet
								m_bObsolete     : 1;

protected:
	void construct(sal_Bool bForwardOnly);
	void construct(const SbaXdbCursor& rCur);

	SbaXdbCursor();
	SbaXdbCursor(const SbaXdbCursor& rCur);
	SbaXdbCursor(const SbaXdbCursor& rCur, SbaXdbCollection& rCollection);
	virtual ~SbaXdbCursor();

public:
	SbaXdbCursor(SbaXdbCollection& rCollection, SdbCursor&, const SbaXdbFields* pRefFields, sal_Bool bForward = sal_False);

	// Cursor ohne Parent! wird nur als wrapper verwendet in datbrw.cxx
	SbaXdbCursor(SdbCursor*, sal_Bool bForward = sal_False);

public:
	DECLARE_DERIVED_IMPL(SbaXdbCursor,PropertySetHelper);

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );

	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// starlang::XEventListener
	virtual void SAL_CALL disposing(const starlang::EventObject&) 
		throw(::com::sun::star::uno::RuntimeException) 
	{}

// OComponentHelper
	virtual void SAL_CALL disposing(void);
	virtual void SAL_CALL dispose() throw(::com::sun::star::uno::RuntimeException);

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		 throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue( 
					staruno::Any & rConvertedValue, staruno::Any & rOldValue,
					sal_Int32 nHandle, const staruno::Any& rValue )
			throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw(staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

// starutil::XCloneable
	virtual staruno::Reference< starutil::XCloneable > SAL_CALL  clone(void) 
		throw( staruno::RuntimeException );

	virtual staruno::Reference< starutil::XCloneable > SAL_CALL  createClone(void) 
		throw( staruno::RuntimeException )
		{ return clone(); }

// stardata::XDatabaseRecordSupplier (base of XDatabaseCursor)
	virtual staruno::Reference< starbeans::XPropertySet >  SAL_CALL getRecord(void) 
		throw( staruno::RuntimeException );

// stardata::XDatabaseCursor (base of XDatabaseUpdateCursor)
	virtual sal_Bool SAL_CALL isValid(void)					throw( staruno::RuntimeException );
	virtual sal_Bool SAL_CALL isBeforeFirst(void)			throw( staruno::RuntimeException );
	virtual sal_Bool SAL_CALL isBehindLast(void)			throw( staruno::RuntimeException );
	virtual sal_Bool SAL_CALL isAtFirst(void)				throw( staruno::RuntimeException );
	virtual sal_Bool SAL_CALL isAtLast(void)				throw( staruno::RuntimeException );
	virtual sal_Bool SAL_CALL moveToFirst(void)				throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual sal_Bool SAL_CALL moveRelative(sal_Int32 nCount)throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual sal_Bool SAL_CALL moveToLast(void)				throw( stardata::DatabaseException, staruno::RuntimeException );

// stardata::XDatabaseBookmarkCursor
	virtual staruno::Any SAL_CALL getBookmark(void) 
		throw( staruno::RuntimeException );

	virtual sal_Bool SAL_CALL moveToBookmark(const staruno::Any& aBookmark) 
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException );

// stardata::XDatabaseDirectCursor
	virtual sal_Int32	SAL_CALL getPosition(void) 
		throw( staruno::RuntimeException );

	virtual sal_Bool	SAL_CALL moveToPosition(sal_Int32 nPosition) 
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException );

// stardata::XDatabaseUpdateCursor
	virtual void		SAL_CALL addRecord(void)	throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual void		SAL_CALL editRecord(void)	throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual sal_Int32	SAL_CALL updateRecord(void)	throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual sal_Int32	SAL_CALL deleteRecord(void)	throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual void		SAL_CALL restoreRecord(void)throw( staruno::RuntimeException );

// XCancelable
	virtual void SAL_CALL cancel(void) throw( staruno::RuntimeException );

public:
	// SbaXdbContent
	virtual void checkOpen() const throw( starlang::DisposedException );

	void updateRowCount();
	void recordDeleted(const staruno::Any& aCurrentBookmark, const staruno::Any& aNextBookmark);

protected:
	void throwSequenceError() throw( stardata::DatabaseException );
	void adjustState(SdbCursor::SdbCursorGuard* pClearWhenDone = NULL);
	void saveState();
	void restoreState();
	void firePropertyChange(sal_Int32 nHandle, const staruno::Any& aNewValue, const staruno::Any& aOldValue);

private:
	DECL_LINK(DoUpdateRowCount, void*);
};

class SbaXdbStatement;

//==================================================================
// SbaXdbCursors
// Collection von Cursorn
//==================================================================
class SbaXdbCursors : public SbaXdbCollection
{
public:
	inline SbaXdbCursors(SbaXdbStatement&);
};

//==================================================================
// SbaXdbStatement
//==================================================================
class SbaXdbStatement : public SbaXdbObject,
						public ::sbautl::DerivedPropertySetHelper1<SbaXdbStatement,SbaXdbObject,
										::com::sun::star::data::XPreparedDatabaseStatement
									>
{
	friend class SbaXdbTable;
	friend class SbaXdbDatabase;
	friend class SbaXdbConnection;
	friend class SbaXdbCursor;

protected:
	SbaXdbCursors       m_aCursors;
	SbaXdbFieldValues   m_aParameters;
	SbaXdbFields        m_aFields;      // Feldbeschreibungen zum Abgleich der FeldTypen
	SdbCursorRef        m_xCursor;
	::rtl::OUString     m_aTableName;
// [properties]
	::rtl::OUString     m_aStatement;
	sal_Int32           m_nTimeOut,
						m_nMaxFieldSize,
						m_nMaxRecordCount;
	sal_Int16			m_nCacheSize;
	sal_Bool            m_bPassThrough : 1;
// [properties]
	sal_Bool            m_bCreateRefFields : 1;

protected:
	virtual ~SbaXdbStatement();

public:
	SbaXdbStatement(SbaXdbCollection& rCollection, SdbCursor& rCursor,
					const ::rtl::OUString& rStatement, sal_Bool bPassThrough);

	SbaXdbStatement(SbaXdbCollection& rCollection, SdbCursor& rCursor,
					const ::rtl::OUString& rStatement, sal_Bool bPassThrough, const SbaXdbFields& rFields);

public:
	DECLARE_DERIVED_IMPL(SbaXdbStatement, PropertySetHelper);

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		 throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue( 
							staruno::Any & rConvertedValue, staruno::Any & rOldValue,
							sal_Int32 nHandle, const staruno::Any& rValue )
			throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw (staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

// stardata::XDatabaseStatement
	virtual ::rtl::OUString SAL_CALL getStatement(void) 
		throw( staruno::RuntimeException );

	virtual sal_Int32 SAL_CALL execute(void) 
		throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual staruno::Reference< stardata::XDatabaseCursor >  SAL_CALL 
		executeQuery(stardata::DatabaseCursorType eType, sal_Int16 nOptions) 
			throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException );

// stardata::XPreparedDatabaseStatement
	virtual staruno::Reference< starbeans::XPropertySet > SAL_CALL getParameters(void) 
		throw( staruno::RuntimeException );
};

//==================================================================
// SbaXdbTableStatement
//==================================================================
class SbaXdbTableStatement : public SbaXdbStatement
{
public:
	SbaXdbTableStatement(SbaXdbCollection& rCollection, SdbCursor&,
						 const SbaXdbTable_Impl& rTable);
};

//==================================================================
// SbaXdbQueryStatement
//==================================================================
class SbaXdbQueryStatement : public SbaXdbStatement
{
public:
	SbaXdbQueryStatement(SbaXdbCollection& rCollection, SdbCursor&,
						 const SbaXdbQuery& rQuery);
};

//==================================================================
// SbaXdbStatements
// Collection von Statements
//==================================================================
class SbaXdbStatements : public SbaXdbCollection
{
public:
	SbaXdbStatements(SbaXdbObject& _rParent):SbaXdbCollection(_rParent){}
};

//------------------------------------------------------------------------------
inline SbaXdbCursors::SbaXdbCursors(SbaXdbStatement& _rParent):SbaXdbCollection(_rParent){}

#endif

