/*************************************************************************
 *
 *  $RCSfile: sbadbdat.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBDAT_HXX
#define _SBA_SBADBDAT_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASE_HPP_
#include <com/sun/star/data/XDatabase.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASECONNECTION_HPP_
#include <com/sun/star/data/XDatabaseConnection.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEQUERYCOMPOSERFACTORY_HPP_
#include <com/sun/star/data/XDatabaseQueryComposerFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASETRANSACTIONSUPPLIER_HPP_
#include <com/sun/star/data/XDatabaseTransactionSupplier.hpp>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL5_HXX
#include <sbautl/derivedpropimpl5.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBPAR_HXX
#include "sbadbpar.hxx"
#endif

#ifndef _SBA_SBADBTBL_HXX
#include "sbadbtbl.hxx"
#endif

#ifndef _SBA_SBADBREL_HXX
#include "sbadbrel.hxx"
#endif

#ifndef _SBA_SBADBCUR_HXX
#include "sbadbcur.hxx"
#endif

#ifndef _SBA_SBADBDOC_HXX
#include "sbadbdoc.hxx"
#endif

#ifndef _SBA_SBADBQRY_HXX
#include "sbadbqry.hxx"
#endif

#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

namespace staruno	= :: com::sun::star::uno;
namespace starlang	= :: com::sun::star::lang;
namespace stardata	= :: com::sun::star::data;
namespace starbeans	= :: com::sun::star::beans;

//==================================================================
// SbaXdbDatabase
//==================================================================
class SbaXdbDatabase   : public SbaXdbObjectCreator,
						 public sbautl::DerivedPropertySetHelper5<SbaXdbDatabase,SbaXdbObjectCreator,
						 	stardata::XDatabase,
							stardata::XDatabaseConnection,
							stardata::XDatabaseTransactionSupplier,
							stardata::XDatabaseQueryComposerFactory,
							::com::sun::star::lang::XUnoTunnel
						 >
{
	friend class SbaXdbEngine;
	friend class SbaXdbWorkspace;

	SbaXdbStatements m_aStatements;
	SbaXdbTableDefs	 m_aTables;
	SbaXdbRelations  m_aRelations;
	SbaXdbQueries	 m_aQueries;
	SbaXdbDocuments	 m_aForms;
	SbaXdbDocuments	 m_aReports;
	SbaXdbParsers	 m_aParsers;

	SbaDatabaseRef	 m_xDatabase;
	staruno::Reference< staruno::XAggregation > 	 m_xAgg;

protected:
	SbaXdbDatabase();
	SbaXdbDatabase(SbaXdbCollection& rCollection, SbaDatabase*);
	virtual ~SbaXdbDatabase();

public:
	DECLARE_DERIVED_IMPL_NOQUERY(SbaXdbDatabase, PropertySetHelper);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) 
		throw (staruno::RuntimeException);

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// starcontainer::XNamed (base of XDatabase)
	virtual ::rtl::OUString SAL_CALL getName(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// stardata::XDatabase
	virtual staruno::Reference< starcontainer::XNameContainer > 
		SAL_CALL getQueries(void)	
			throw( staruno::RuntimeException );

	virtual staruno::Reference< starcontainer::XNameContainer > 
		SAL_CALL getForms(void)		
			throw( staruno::RuntimeException );

	virtual staruno::Reference< starcontainer::XNameContainer > 
		SAL_CALL getReports(void)	
			throw( staruno::RuntimeException );

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const 
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue(
							staruno::Any & rConvertedValue, staruno::Any & rOldValue,
							sal_Int32 nHandle, const staruno::Any& rValue )
				throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw( staruno::Exception );

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

// stardata::XDatabaseConnection
	virtual staruno::Reference< starcontainer::XNameContainer > 
		SAL_CALL getTables(void) 
			throw( staruno::RuntimeException );

	virtual staruno::Reference< starcontainer::XNameContainer > 
		SAL_CALL getRelations(void) 
			throw( staruno::RuntimeException );

	virtual staruno::Reference< stardata::XDatabaseDescriptor > 
		SAL_CALL getMetaData(void) 
			throw( staruno::RuntimeException );

	virtual ::rtl::OUString 
		SAL_CALL getCatalog(void) 
			throw( staruno::RuntimeException );

	virtual void SAL_CALL setCatalog(const ::rtl::OUString& aCatalog) 
		throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual staruno::Reference< stardata::XDatabaseStatement > SAL_CALL  
		createStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual staruno::Reference< stardata::XPreparedDatabaseStatement > SAL_CALL  
		createPreparedStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual staruno::Reference< stardata::XPreparedDatabaseStatement > SAL_CALL  
		createProcedureStatement(const ::rtl::OUString& aStatement, sal_Bool bPassThrough) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

// stardata::XDatabaseTransactionSupplier
	virtual sal_Int16 SAL_CALL getIsolationLevel(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setIsolationLevel(sal_Int16 Level) 
		throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual sal_Bool SAL_CALL isAutoCommit(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setAutoCommit(sal_Bool Enable) 
		throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException );

	virtual void SAL_CALL commit(void) 
		throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException );

	virtual void SAL_CALL rollback(void) 
		throw( stardata::DatabaseException, starlang::IllegalAccessException, staruno::RuntimeException );

// stardata::XDatabaseQueryComposerFactory
	virtual staruno::Reference< stardata::XDatabaseQueryComposer > SAL_CALL 
		createDatabaseQueryComposer(void) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

// Helper
	static String toConnectionStr(const staruno::Sequence< starbeans::PropertyValue >& aProperties);
	static staruno::Sequence< starbeans::PropertyValue > toConnectionProperties(const String& rConnectStr);
	SbaDatabase* getDatabase() const {return m_xDatabase;}
	SbaXdbStatements& getXdbStatements() {return m_aStatements;}
	SbaXdbTableDefs& getXdbTables() {return m_aTables;}

protected:
	virtual SdbObj* createObject(DBObject _eObj, const ::rtl::OUString& _rName) throw( stardata::DatabaseException );
	virtual SdbObj* openObject(DBObject _eObj, const ::rtl::OUString& _rName);
	virtual SdbObj* openObject(DBObject _eObj, sal_Int32 _nPos);
	virtual ::rtl::OUString getObjectName(DBObject _eObj, sal_Int32 _nPos) const;
	virtual sal_Int32	getObjectCount(DBObject _eObj) const;
	virtual void refresh(DBObject _eObj) throw( stardata::DatabaseException );

	const staruno::Reference< staruno::XAggregation > & getAggregation();

	// ImplHelper override
	virtual staruno::Sequence<staruno::Type> collectTypes(SbaXdbDatabase*) throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbDatabases
// Klasse zum Verwalten von Connection
//==================================================================
class SbaXdbDatabases : public SbaXdbCollection
{
public:
	SbaXdbDatabases(SbaXdbComponent& _rParent):SbaXdbCollection(_rParent){}
};

#endif

