/*************************************************************************
 *
 *  $RCSfile: sbadbdoc.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBDOC_HXX
#define _SBA_SBADBDOC_HXX

#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XDATASTREAMSUPPLIER_HPP_
#include <com/sun/star/chaos/XDataStreamSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XREFRESHABLE_HPP_
#include <com/sun/star/util/XRefreshable.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDOCUMENTFACTORY_HPP_
#include <com/sun/star/data/XDatabaseDocumentFactory.hpp>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL4_HXX
#include <sbautl/derivedpropimpl4.hxx>
#endif
#ifndef _SBA_UTL_DERIVEDIMPL1_HXX
#include <sbautl/derivedimpl1.hxx>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SBA_DBFILEOB_HXX
#include <dbfileob.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

namespace staruno		= :: com::sun::star::uno;
namespace starbeans		= :: com::sun::star::beans;
namespace starlang		= :: com::sun::star::lang;
namespace starcontainer	= :: com::sun::star::container;
namespace starchaos		= :: com::sun::star::chaos;
namespace stario		= :: com::sun::star::io;
namespace starutil		= :: com::sun::star::util;
namespace stardata		= :: com::sun::star::data;

//==================================================================
// SbaXdbDocument
//==================================================================
class SbaXdbDocument : public SbaXdbObject,
					   public ::sbautl::DerivedPropertySetHelper4<SbaXdbDocument, SbaXdbObject,
									::com::sun::star::container::XNamed,
									::com::sun::star::chaos::XDataStreamSupplier,
									::com::sun::star::util::XRefreshable,
									::com::sun::star::lang::XUnoTunnel
								>
{
	friend class SbaXdbDatabase;
	friend class SbaXdbDocuments;

	::cppu::OInterfaceContainerHelper
						m_aRefreshListeners;
	SbaFileDefRef		m_xDocDef;
	::rtl::OUString				m_aDataType;
	staruno::Reference< stario::XInputStream > 		m_xStream;		// Zwischenspeichern des Streams

	SbaXdbDocument(SbaXdbCollection& rCollection, SbaFileDef*);

public:
	SbaXdbDocument();
	~SbaXdbDocument();

	DECLARE_DERIVED_IMPL(SbaXdbDocument,PropertySetHelper);

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const  
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue( 
							staruno::Any & rConvertedValue, staruno::Any & rOldValue,
							sal_Int32 nHandle, const staruno::Any& rValue )
		throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw (staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;


// starcontainer::XNamed
	virtual ::rtl::OUString SAL_CALL getName(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// starchaos::XDataStreamSupplier
	virtual ::rtl::OUString SAL_CALL getDataType(void) 
		throw( staruno::RuntimeException );

	virtual staruno::Reference< stario::XInputStream > SAL_CALL getData(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setData(
					const ::rtl::OUString& aDataType, 
					const staruno::Reference< stario::XInputStream > & xStream) 
		throw( staruno::RuntimeException );

// starutil::XRefreshable
	virtual void SAL_CALL refresh(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL addRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL removeRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
		throw( staruno::RuntimeException );

protected:
	void setObject(const SbaFileDefRef& xDef)
			throw( stardata::DatabaseException, staruno::RuntimeException );
};

//==================================================================
// SbaXdbDocuments
//==================================================================
class SbaXdbDocuments : public ::sbautl::DerivedImplHelper1<SbaXdbDocuments,SbaXdbNamedCollection,
									::com::sun::star::data::XDatabaseDocumentFactory
								>,
						public SbaXdbNamedCollection
{
	friend class SbaXdbDatabase;

	SbaXdbDocuments(SbaXdbObjectCreator& rParent, DBObject _eObj);

public:
	DECLARE_DERIVED_IMPL(SbaXdbDocuments, DerivationHelper1);

// stardata::XDatabaseDocumentFactory
	virtual staruno::Reference< starchaos::XDataStreamSupplier > 
		SAL_CALL create(void)
			throw( starlang::NoSupportException, staruno::RuntimeException );

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const;
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element);
	virtual sal_Bool doRemove(SbaXdbObject* pObj);
};

#endif //_SBA_SBADBDOC_HXX

