/*************************************************************************
 *
 *  $RCSfile: sbadbeng.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBENG_HXX
#define _SBA_SBADBENG_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEENGINE_HPP_
#include <com/sun/star/data/XDatabaseEngine.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEFAVORITES_HPP_
#include <com/sun/star/data/XDatabaseFavorites.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SDB_SDBENV_HXX //autogen
#include <sdb/sdbenv.hxx>
#endif
#ifndef _SBA_UTL_DERIVEDIMPL3_HXX
#include <sbautl/derivedimpl3.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBCON_HXX
#include "sbadbcon.hxx"
#endif
#ifndef _SBA_SBADBWSP_HXX
#include "sbadbwsp.hxx"
#endif

class SbaXdbWorkspace;

namespace com { namespace sun { namespace star {
	namespace lang { class XMultiServiceFactory; }
} } }

namespace staruno		= :: com::sun::star::uno;
namespace starlang		= :: com::sun::star::lang;
namespace stardata		= :: com::sun::star::data;
namespace starbeans		= :: com::sun::star::beans;

//==================================================================
// SbaXdbEngine
//==================================================================
staruno::Reference< staruno::XInterface > SAL_CALL SbaXdbEngine_CreateInstance(const staruno::Reference< starlang::XMultiServiceFactory > & xServiceManager) throw( staruno::Exception );


//------------------------------------------------------------------
// HACK: Derives skipping base classes
// No XChild,XUnoTunnel or XComponent available
//------------------------------------------------------------------
class SbaXdbEngine : public SbaXdbObjectCreator,
					 public	::com::sun::star::data::XDatabaseEngine,
					 public	::com::sun::star::data::XDatabaseFavorites,
					 public	::com::sun::star::lang::XServiceInfo,
					 public ::sbautl::TypeProviderImplHelper<SbaXdbEngine>
{
	friend class SbaXdbWorkspaces;
	friend staruno::Reference< staruno::XInterface > SAL_CALL
		SbaXdbEngine_CreateInstance(const staruno::Reference< starlang::XMultiServiceFactory > &) throw( staruno::Exception );

	SdbEnvironmentRef m_xEnvironment;

	SbaXdbWorkspaces  m_aWorkspaces;
	SbaXdbConnections m_aConnections;

	SbaXdbWorkspace*  m_pDefaultWsp;

protected:
	SbaXdbEngine();
	virtual ~SbaXdbEngine();

	typedef ::sbautl::TypeProviderImplHelper<SbaXdbEngine> TypeProviderHelper;
public:
	DECLARE_UNO3_DEFAULTS(SbaXdbEngine, OWeakObject);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// stardata::XTypeProvider
	virtual staruno::Sequence< staruno::Type > SAL_CALL getTypes() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getTypes(); }

	virtual staruno::Sequence< sal_Int8 > SAL_CALL getImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getImplementationId(); }

	static staruno::Sequence< sal_Int8 > getStaticImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getStaticImplementationId(); }

 // OComponentHelper
	virtual void SAL_CALL disposing(void);

// stardata::XDatabaseEngine
	virtual staruno::Reference< starcontainer::XNameContainer >
		SAL_CALL getWorkspaces(void)
			throw( staruno::RuntimeException );

	virtual staruno::Sequence< ::rtl::OUString >
		SAL_CALL queryServerTypes(void)
			throw( staruno::RuntimeException );

	virtual sal_Int32
		SAL_CALL getLoginTimeOut(void)
			throw( staruno::RuntimeException );

	virtual void
		SAL_CALL setLoginTimeOut(sal_Int32 TimeOut)
			throw( staruno::RuntimeException );

	virtual staruno::Reference< stardata::XDatabaseConnection >
		SAL_CALL  createConnection(const staruno::Sequence< starbeans::PropertyValue >& ConnectionInfo)
			throw( stardata::DatabaseException, staruno::RuntimeException );

// stardata::XDatabaseFavorites
	virtual staruno::Sequence< starbeans::PropertyValue >
		SAL_CALL getFavorites(void)
			throw( staruno::RuntimeException );

	virtual ::rtl::OUString
		SAL_CALL getLocation(const ::rtl::OUString& aTitle)
			throw( staruno::RuntimeException );

// starlang::XServiceInfo
	virtual ::rtl::OUString SAL_CALL getImplementationName()
		throw( staruno::RuntimeException );

	virtual sal_Bool SAL_CALL supportsService(const ::rtl::OUString& ServiceName)
		throw( staruno::RuntimeException );

	virtual staruno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(void)
		throw( staruno::RuntimeException );

// starlang::XServiceInfo - static methods
	static staruno::Sequence< ::rtl::OUString > getSupportedServiceNames_Static(void)
		throw( staruno::RuntimeException );

	static ::rtl::OUString getImplementationName_Static(void)
		throw( staruno::RuntimeException );


protected:
	virtual SdbObj* createObject(DBObject _eObj, const ::rtl::OUString& _rName)
		throw( stardata::DatabaseException );

	virtual SdbObj* openObject(DBObject _eObj, const ::rtl::OUString& _rName);
	virtual SdbObj* openObject(DBObject _eObj, sal_Int32 _nPos);
	virtual ::rtl::OUString getObjectName(DBObject _eObj, sal_Int32 _nPos) const;
	virtual sal_Int32	getObjectCount(DBObject _eObj) const;
	virtual void refresh(DBObject _eObj)
		throw( stardata::DatabaseException );

	void dropDatabaseAlias(::rtl::OUString const& sProgrammaticURL) const;

// TypeProviderHelper support
	virtual staruno::Sequence< staruno::Type > collectTypes(SbaXdbEngine*) throw(staruno::RuntimeException);
};

#endif


