/*************************************************************************
 *
 *  $RCSfile: sbadbfld.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBFLD_HXX
#define _SBA_SBADBFLD_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEVARIANT_HPP_
#include <com/sun/star/data/XDatabaseVariant.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEFIELDDESCRIPTORFACTORY_HPP_
#include <com/sun/star/data/XDatabaseFieldDescriptorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASENAMECONTAINER_HPP_
#include <com/sun/star/data/XDatabaseNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXACCESS_HPP_
#include <com/sun/star/container/XIndexAccess.hpp>
#endif


#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _CPPUHELPER_COMPONENT_HXX
#include <cppuhelper/component.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE5_HXX_
#include <cppuhelper/implbase5.hxx>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL_HXX
#include <sbautl/derivedpropimpl.hxx>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL3_HXX
#include <sbautl/derivedpropimpl3.hxx>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SDB_ROW_HXX
#include <sdb/row.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _UTL_STLTYPES_HXX_
#include <unotools/stl_types.hxx>
#endif

namespace staruno		= ::com::sun::star::uno;
namespace starbeans		= ::com::sun::star::beans;
namespace starlang		= ::com::sun::star::lang;
namespace stario		= ::com::sun::star::io;
namespace stardata		= ::com::sun::star::data;
namespace starutil		= ::com::sun::star::util;
namespace starcontainer = ::com::sun::star::container;

class SbaColumn;
class SbaColumnList;
class SdbColumn;
class SdbColumnRelation;
class SdbConnection;
class SbaDBDataDef;

//==================================================================
// SbaXdbField
// allgemeine Felddefinition
//==================================================================
// : Derives skipping base classes
// No XChild or XComponent available
//------------------------------------------------------------------
class SbaXdbField	: public SbaXdbComponent,
			  public ::sbautl::DerivedPropertySetHelper3< SbaXdbField, SbaXdbComponent,
								::com::sun::star::container::XNamed,
								::com::sun::star::data::XDatabaseFieldDescriptorFactory,
								::com::sun::star::data::XDatabaseVariant
								>
{
	friend class SbaXdbCursor;
	friend class SbaXdbFields;
	friend class SbaXdbFieldValues;
	friend class SbaXdbParser;

public:
	ODbVariantRef	m_xValue, m_xOldValue, m_xDefValue;	// Werte

	rtl::OUString		m_aDescription;
	rtl::OUString		m_aName;
	rtl::OUString		m_aRefName;
	rtl::OUString		m_aFieldSource;
	rtl::OUString		m_aTableSource;
	sal_Int32		m_nSize;
	sal_Int32		m_nFormatKey;
	sal_Int16		m_nScale;
	sal_Int16		m_nParameterType;
	sal_Int16		m_nSearchInfo;
	sal_Int16		m_nType;
	sal_Bool		m_bAutoIncrement	: 1;
	sal_Bool		m_bDescending		: 1;
	sal_Bool		m_bReadOnly			: 1;
	sal_Bool		m_bRequired			: 1;
	sal_Bool		m_bUnsigned			: 1;
	sal_Bool		m_bPrimaryKey		: 1;
	sal_Bool		m_bFireValueChanges	: 1; // sollen aenderungen am wert gebroadcastet werden
	sal_Bool		m_bFunction			: 1; // is the column a function ?
	sal_Bool		m_bVersioning		: 1; // is it a VERSIONING column

public:
	SbaXdbField(SbaXdbComponent* pParent, const SbaXdbField& rField);
	SbaXdbField(SbaXdbComponent* pParent);
	SbaXdbField(SbaXdbComponent* pParent, const SdbColumn& rCol);
	SbaXdbField(SbaXdbComponent* pParent, const SbaColumn& rCol);
	SbaXdbField(SbaXdbComponent* pParent, const SdbColumnRelation& rCol);
	SbaXdbField(const staruno::Reference< starbeans::XPropertySet > & xSet);
	~SbaXdbField();

	DECLARE_DERIVED_IMPL_NOQUERY(SbaXdbField,PropertySetHelper);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// OComponentHelper
	virtual void SAL_CALL disposing();

// ::com::sun::star::container::XNamed
	virtual ::rtl::OUString SAL_CALL getName(void)
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_)
		throw( staruno::RuntimeException );

// OPropertySetHelper
	virtual sal_Bool
		SAL_CALL convertFastPropertyValue(
					staruno::Any & rConvertedValue,
					staruno::Any & rOldValue,
					sal_Int32 nHandle,
					const staruno::Any& rValue )
			throw( starlang::IllegalArgumentException );

	virtual void
		SAL_CALL setFastPropertyValue_NoBroadcast(
					sal_Int32 nHandle,
					const staruno::Any& rValue )
			 throw (staruno::Exception);

	virtual void
		SAL_CALL getFastPropertyValue(
					staruno::Any& rValue,
					sal_Int32 nHandle ) const;

// ::com::sun::star::beans::XPropertySet
	virtual void SAL_CALL addPropertyChangeListener(
							const ::rtl::OUString& rPropertyName,
							const staruno::Reference< starbeans::XPropertyChangeListener > & rxListener)
			throw(	starbeans::UnknownPropertyException,
					starlang::WrappedTargetException,
					staruno::RuntimeException);

	virtual void SAL_CALL removePropertyChangeListener(
							const ::rtl::OUString& rPropertyName,
							const staruno::Reference< starbeans::XPropertyChangeListener > & rxListener)
			throw(	starbeans::UnknownPropertyException,
					starlang::WrappedTargetException,
					staruno::RuntimeException);

// ::com::sun::star::beans::XMultiPropertySet
	virtual void SAL_CALL addPropertiesChangeListener(
							const staruno::Sequence< ::rtl::OUString >& rProps,
							const staruno::Reference< starbeans::XPropertiesChangeListener > & rListener )
			throw(staruno::RuntimeException);

	virtual void SAL_CALL removePropertiesChangeListener(
							const staruno::Reference< starbeans::XPropertiesChangeListener > & rListener )
			throw(staruno::RuntimeException);


// ::com::sun::star::data::XDatabaseVariant
	virtual sal_Bool  SAL_CALL isNull(void)					throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual ::rtl::OUString	  SAL_CALL getString(void)		throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual sal_Bool  SAL_CALL getBoolean(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual sal_Int8  SAL_CALL getByte(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual sal_Int16 SAL_CALL getShort(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual sal_Int32 SAL_CALL getLong(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual float	  SAL_CALL getFloat(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual double	  SAL_CALL getDouble(void)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual starutil::Date	SAL_CALL getDate(void)			throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual starutil::Time	SAL_CALL getTime(void)			throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual starutil::DateTime SAL_CALL getDateTime(void)	throw(stardata::DatabaseException, staruno::RuntimeException);

	virtual staruno::Sequence< sal_Int8 > SAL_CALL getBytes(void)
		throw(stardata::DatabaseException, staruno::RuntimeException);

	virtual staruno::Reference< stario::XInputStream > SAL_CALL  getBinaryStream(void)
		throw(stardata::DatabaseException, staruno::RuntimeException);

	virtual void SAL_CALL setNull(void)							throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setString(const ::rtl::OUString& x)	throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setBoolean(sal_Bool x)				throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setByte(sal_Int8 x)					throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setShort(sal_Int16 x)					throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setLong(sal_Int32 x)					throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setFloat(float x)						throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setDouble(double x)					throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setDate(const starutil::Date& x)		throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setTime(const starutil::Time& x)		throw(stardata::DatabaseException, staruno::RuntimeException);
	virtual void SAL_CALL setDateTime(const starutil::DateTime& x)	throw(stardata::DatabaseException, staruno::RuntimeException);

	virtual void SAL_CALL setBytes(const staruno::Sequence< sal_Int8 >& x)
		throw(stardata::DatabaseException, staruno::RuntimeException);

	virtual void SAL_CALL setBinaryStream(const staruno::Reference< stario::XInputStream > & x)
		throw(stardata::DatabaseException, staruno::RuntimeException);

// ::com::sun::star::data::XDatabaseFieldDescriptorFactory
	virtual staruno::Reference< starbeans::XPropertySet > SAL_CALL  create(void)
		throw(staruno::RuntimeException);

	SdbColumn* createColumn(SdbConnection* pCon) const;
	SbaColumn* createColumn(SbaDBDataDef& rDef) const;
	void adjustType(const SbaXdbField& rField);

protected:
	sal_Bool convertValue(
				staruno::Any& rConvertedValue,
				const staruno::Any& rOldValue,
				const staruno::Any& rValue)
				throw( starlang::IllegalArgumentException );

	// gibt es listener am Value?
	sal_Bool hasValueListeners() const {return m_xOldValue.is();}

	// Benachrichtigen bei Aenderungen
	void checkForNotify();
	void fireValueChanged();

	// Aktuelle Werte austauschen
	void replaceValue(const ODbVariantRef& xValue);
	void setDefault();

// TypeProviderHelper support
	virtual staruno::Sequence< staruno::Type > collectTypes(SbaXdbField*) throw(staruno::RuntimeException);
// Derived class support
	staruno::Any queryFieldBase(staruno::Type const& rType) throw( staruno::RuntimeException );
	staruno::Sequence< staruno::Type > getFieldBaseTypes() throw( staruno::RuntimeException );
private:
	void construct();
	void construct(const SbaXdbField& rField);
	void construct(const SdbColumn&);
	void construct(const SbaColumn& rCol);
	void construct(const SdbColumnRelation& rCol);
	void construct(const staruno::Reference< starbeans::XPropertySet > & xSet);
};

//==================================================================
// SbaXdbFieldDescriptor
// Descriptor zur Feldbeschreibung
//==================================================================
class SbaXdbFieldDescriptor :	public SbaXdbField,
								public sbautl::TypeProviderImplHelper<SbaXdbFieldDescriptor>
{
	typedef ::sbautl::TypeProviderImplHelper<SbaXdbFieldDescriptor> TypeProviderHelper;
public:
	SbaXdbFieldDescriptor():SbaXdbField(NULL){}
	SbaXdbFieldDescriptor(SbaXdbComponent* pParent, const SbaXdbField& rField)
		:SbaXdbField(pParent, rField){}
	SbaXdbFieldDescriptor(SbaXdbComponent* pParent, const SdbColumn& rCol)
		:SbaXdbField(pParent, rCol){}
	SbaXdbFieldDescriptor(SbaXdbComponent* pParent, const SbaColumn& rCol)
		:SbaXdbField(pParent, rCol){}
	SbaXdbFieldDescriptor(SbaXdbComponent* pParent, const SdbColumnRelation& rCol)
		:SbaXdbField(pParent, rCol){}

	DECLARE_UNO3_DEFAULTS(SbaXdbFieldDescriptor,SbaXdbField);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// stardata::XTypeProvider
	virtual staruno::Sequence< staruno::Type > SAL_CALL getTypes() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getTypes(); }

	virtual staruno::Sequence< sal_Int8 > SAL_CALL getImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getImplementationId(); }

	static staruno::Sequence< sal_Int8 > getStaticImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getStaticImplementationId(); }

//	using TypeProviderHelper::getStaticImplementationId;

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

protected:
	// PropertyHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		throw(staruno::RuntimeException);

// TypeProviderHelper support
	virtual staruno::Sequence< staruno::Type > collectTypes(SbaXdbFieldDescriptor*) throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbFieldDefinition
// Feld einer Feldbeschreibung
//==================================================================
class SbaXdbFieldDefinition :	public SbaXdbFieldDescriptor,
								public sbautl::TypeProviderImplHelper<SbaXdbFieldDefinition>
{
	typedef ::sbautl::TypeProviderImplHelper<SbaXdbFieldDefinition> TypeProviderHelper;
public:
	SbaXdbFieldDefinition(SbaXdbComponent* pParent, const SbaXdbFieldDescriptor& rField)
		:SbaXdbFieldDescriptor(pParent, rField){}
	SbaXdbFieldDefinition(SbaXdbComponent* pParent, const SbaXdbField& rField)
		:SbaXdbFieldDescriptor(pParent, rField){}
	SbaXdbFieldDefinition(SbaXdbComponent* pParent, const SdbColumn& rCol)
		:SbaXdbFieldDescriptor(pParent, rCol){}
	SbaXdbFieldDefinition(SbaXdbComponent* pParent, const SbaColumn& rCol)
		:SbaXdbFieldDescriptor(pParent, rCol){}
	SbaXdbFieldDefinition(SbaXdbComponent* pParent, const SdbColumnRelation& rCol)
		:SbaXdbFieldDescriptor(pParent, rCol){}

	DECLARE_UNO3_DEFAULTS(SbaXdbFieldDefinition,SbaXdbFieldDescriptor);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw( staruno::RuntimeException );

// stardata::XTypeProvider
	virtual staruno::Sequence< staruno::Type > SAL_CALL getTypes() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getTypes(); }

	virtual staruno::Sequence< sal_Int8 > SAL_CALL getImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getImplementationId(); }

  	static staruno::Sequence< sal_Int8 > getStaticImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getStaticImplementationId(); }

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );

	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

protected:
	// PropertyHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		throw(staruno::RuntimeException);

// TypeProviderHelper support
	virtual staruno::Sequence< staruno::Type > collectTypes(SbaXdbFieldDefinition*) throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbParameter
// Felder einer Parameterbeschreibung
//==================================================================
class SbaXdbParameter : public SbaXdbFieldDescriptor
{
public:
	SbaXdbParameter(SbaXdbComponent* pParent, const SbaXdbField& rField)
		:SbaXdbFieldDescriptor(pParent, rField){}
	SbaXdbParameter(SbaXdbComponent* pParent, const SdbColumn& rCol)
		:SbaXdbFieldDescriptor(pParent, rCol){}

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

	// PropertyHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbRecordField
// Felder eines Recordsets
//==================================================================
class SbaXdbRecordField : public SbaXdbField
{
public:
	SbaXdbRecordField(SbaXdbComponent* pParent)
		:SbaXdbField(pParent){}
	SbaXdbRecordField(SbaXdbComponent* pParent, const SdbColumn& rCol)
		:SbaXdbField(pParent, rCol){}
	SbaXdbRecordField(const staruno::Reference< starbeans::XPropertySet > & xSet)
		:SbaXdbField(xSet){}

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// PropertyHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		throw(staruno::RuntimeException);
};

//==================================================================
// SbaXdbQueryFieldDescriptor
// Field of a query composer
//==================================================================
class SbaXdbQueryFieldDescriptor : public SbaXdbFieldDescriptor
{
public:
	SbaXdbQueryFieldDescriptor(SbaXdbComponent* pParent, const SdbColumn& rCol)
		:SbaXdbFieldDescriptor(pParent, rCol){}

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// PropertyHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const
		throw(staruno::RuntimeException);
};


typedef ::std::hash_map< ::rtl::OUString, SbaXdbField*, ::utl::UStringMixHash, ::utl::UStringMixEqual> OFieldMap;
typedef ::std::vector<SbaXdbField*> OFieldArray;

//==================================================================
// SbaXdbFields
//==================================================================
class SbaXdbFields	: public SbaXdbBroadcaster,
					  public ::cppu::WeakImplHelper5<
								  starcontainer::XIndexAccess,
								  stardata::XDatabaseNameContainer,
								  starcontainer::XEnumerationAccess,
								  stardata::XDatabaseFieldDescriptorFactory,
								  starcontainer::XChild
							>
{
	friend class SbaXdbStatement;

protected:
	SbaXdbComponent&			m_rParent;
	OFieldArray					m_aFields;
	OFieldMap					m_aFieldMap;

public:
	SbaXdbFields(SbaXdbComponent& _rParent, sal_Bool bCase);
	SbaXdbFields(SbaXdbComponent& _rParent, const SbaXdbFields& rFields);
	virtual ~SbaXdbFields();

	virtual void SAL_CALL acquire() throw(staruno::RuntimeException);
	virtual void SAL_CALL release() throw(staruno::RuntimeException);

// ::com::sun::star::container::XElementAccess
	virtual staruno::Type SAL_CALL getElementType(void)
		throw( staruno::RuntimeException );

	virtual sal_Bool SAL_CALL hasElements(void)
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XEnumerationAccess
	virtual staruno::Reference< starcontainer::XEnumeration >  SAL_CALL createEnumeration(void)
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XChild
	virtual staruno::Reference< staruno::XInterface >  SAL_CALL getParent(void) /*const*/
		throw( staruno::RuntimeException )
	{return staruno::Reference< starlang::XComponent > (&m_rParent);}

	virtual void SAL_CALL setParent(const staruno::Reference< staruno::XInterface > & Parent)
		throw( starlang::NoSupportException, staruno::RuntimeException );

// ::com::sun::star::container::XNameAccess
	virtual staruno::Any SAL_CALL getByName(const ::rtl::OUString& Name) /*const*/
		throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException );

	virtual staruno::Sequence< ::rtl::OUString > SAL_CALL getElementNames(void) /*const*/
		throw( staruno::RuntimeException );

	virtual sal_Bool SAL_CALL hasByName(const ::rtl::OUString& Name) /*const*/
		throw( staruno::RuntimeException );

// ::com::sun::star::container::XIndexAccess
	virtual sal_Int32 SAL_CALL getCount(void) /*const*/
		throw( staruno::RuntimeException );

	virtual staruno::Any SAL_CALL getByIndex(sal_Int32 Index) /*const*/
		throw( starlang::IndexOutOfBoundsException, starlang::WrappedTargetException, staruno::RuntimeException );

// ::com::sun::star::data::XDatabaseNameContainer
	virtual void SAL_CALL insertNewByName(const ::rtl::OUString& Name, const staruno::Any& Element)
		throw( starlang::IllegalArgumentException, starcontainer::ElementExistException,
				stardata::DatabaseException, staruno::RuntimeException );

	virtual void SAL_CALL removeByName(const ::rtl::OUString& Name)
		throw( starcontainer::NoSuchElementException, stardata::DatabaseException,
				staruno::RuntimeException );

// ::com::sun::star::data::XDatabaseFieldDescriptorFactory
	virtual staruno::Reference< starbeans::XPropertySet > SAL_CALL  create(void)
		throw( staruno::RuntimeException );

	void disposing();

	void setDefinitions(const SdbColumnsRef& xCols);
	void setDefinitions(const SbaColumnList&);
	void setRelDefinitions(const SdbColumnsRef& xCols);

	SbaXdbField* operator[] (sal_uInt32 nIndex) {return m_aFields[nIndex];}
	const SbaXdbField* operator[] (sal_uInt32 nIndex) const {return m_aFields[nIndex];}
	const SbaXdbField* at(const ::rtl::OUString& rName) const;
	void adjustTypes(const SbaXdbFields& rFields);

	sal_Bool isCaseSensitive() const {return m_aFieldMap.key_eq().isCaseSensitive();}

protected:
	void append(SbaXdbField*);
};

//==================================================================
// SbaXdbFieldValues
//==================================================================
class SbaXdbFieldValues	: public ::cppu::OPropertySetHelper
						, public sbautl::TypeProviderImplHelper<SbaXdbFieldValues>
						, public SbaXdbFields
{
	::cppu::IPropertyArrayHelper* m_pPropertyHelper;

	typedef sbautl::TypeProviderImplHelper<SbaXdbFieldValues> TypeProviderHelper;
public:
	SbaXdbFieldValues(SbaXdbComponent& _rParent, sal_Bool bCase)
		:SbaXdbFields(_rParent, bCase)
		,OPropertySetHelper(m_aBHelper)
		,m_pPropertyHelper(NULL){}

	~SbaXdbFieldValues();

	DECLARE_UNO3_DEFAULTS(SbaXdbFieldValues,SbaXdbFields);
	virtual staruno::Any SAL_CALL queryInterface(staruno::Type const& rType) throw(staruno::RuntimeException);

// stardata::XTypeProvider
	virtual staruno::Sequence< staruno::Type > SAL_CALL getTypes() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getTypes(); }

	virtual staruno::Sequence< sal_Int8 > SAL_CALL getImplementationId() throw (staruno::RuntimeException)
	{ return TypeProviderHelper::getImplementationId(); }

	using TypeProviderHelper::getStaticImplementationId;

// OComponentHelper
	virtual void disposing();

// OPropertySetHelper
	virtual ::cppu::IPropertyArrayHelper& SAL_CALL getInfoHelper() /*const*/;
	virtual staruno::Reference<starbeans::XPropertySetInfo> SAL_CALL getPropertySetInfo()
		throw(staruno::RuntimeException);

	virtual sal_Bool  SAL_CALL convertFastPropertyValue(
							staruno::Any & rConvertedValue,
							staruno::Any & rOldValue,
							sal_Int32 nHandle,
							const staruno::Any& rValue )
				throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
			 throw (staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

	void replaceValues(const ODbRowRef& rRow);
	void setDefaults();
	void constructRecordFields(const SdbColumnsRef& xCols);
	void constructParameterFields(const SdbColumnsRef& xCols, const ODbRowRef& xParams);
	void constructQueryDescriptionFields(const SdbColumnsRef& xCols);

	void reset();

// TypeProviderHelper support
	virtual staruno::Sequence< staruno::Type > collectTypes(SbaXdbFieldValues*) throw(staruno::RuntimeException);
};


#endif //_SBA_SBADBFLD_HXX

