/*************************************************************************
 *
 *  $RCSfile: sbadbidx.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBIDX_HXX
#define _SBA_SBADBIDX_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEFIELDSSUPPLIER_HPP_
#include <com/sun/star/data/XDatabaseFieldsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEINDEXFACTORY_HPP_
#include <com/sun/star/data/XDatabaseIndexFactory.hpp>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL2_HXX
#include <sbautl/derivedpropimpl2.hxx>
#endif
#ifndef _SBA_UTL_DERIVEDIMPL1_HXX
#include <sbautl/derivedimpl1.hxx>
#endif

#ifndef _SDB_SDBIDX_HXX //autogen
#include <sdb/sdbidx.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

namespace staruno	= :: com::sun::star::uno;
namespace starlang	= :: com::sun::star::lang;
namespace stardata	= :: com::sun::star::data;

//==================================================================
// SbaXdbIndex
// Die Indexdefinition basiert auf ist Teil einer TableDef
//==================================================================
class SbaXdbIndex	 : public SbaXdbObject,
					   public ::sbautl::DerivedPropertySetHelper2<SbaXdbIndex,SbaXdbObject,
									::com::sun::star::data::XDatabaseFieldsSupplier,
									::com::sun::star::container::XNamed
								>
{
	friend class SbaXdbIndexes;

	SdbIndexRef		m_xIndex;
	SbaXdbFields	m_aFields;

	sal_Bool			m_bUnique : 1;
	sal_Bool			m_bClustered : 1;
	sal_Bool			m_bPrimaryKey : 1;

protected:
	SbaXdbIndex(SbaXdbCollection& rCollection, SdbIndex*, sal_Bool bCase);
	~SbaXdbIndex();

public:
	SbaXdbIndex(sal_Bool bCase);

	DECLARE_DERIVED_IMPL(SbaXdbIndex, PropertySetHelper);

// ::com::sun::star::lang::XUnoTunnel
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// starcontainer::XNamed
	virtual ::rtl::OUString SAL_CALL getName() 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// stardata::XDatabaseFieldsSupplier
	virtual staruno::Reference< starcontainer::XNameAccess > SAL_CALL getFields() 
		throw( staruno::RuntimeException );

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const  
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue( 
						staruno::Any & rConvertedValue, staruno::Any & rOldValue,
						sal_Int32 nHandle, const staruno::Any& rValue 
				)
				throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw( staruno::Exception );

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

protected:
	void	setObject(const SdbIndexRef& xDef)
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException );
};

//==================================================================
// SbaXdbIndexes
// Indices der Table
//==================================================================
class SbaXdbIndexes : public ::sbautl::DerivedImplHelper1<SbaXdbIndexes, SbaXdbNamedCollection,
									::com::sun::star::data::XDatabaseIndexFactory
								>,
					  public SbaXdbNamedCollection
{
	friend class SbaXdbTable_Impl;

	SbaXdbIndexes(SbaXdbObjectCreator&);

public:
	DECLARE_DERIVED_IMPL(SbaXdbIndexes, DerivationHelper1);

// stardata::XDatabaseIndexFactory
	virtual staruno::Reference< starbeans::XPropertySet > 
		SAL_CALL create(void) 
			throw( starlang::NoSupportException, staruno::RuntimeException );

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const
		throw( stardata::DatabaseException, staruno::RuntimeException );
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element)
		throw( stardata::DatabaseException, starlang::IllegalArgumentException, staruno::RuntimeException );
	virtual sal_Bool doRemove(SbaXdbObject* pObj)
		throw( stardata::DatabaseException, staruno::RuntimeException );
};

#endif

