/*************************************************************************
 *
 *  $RCSfile: sbadbpar.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBPAR_HXX
#define _SBA_SBADBPAR_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEDIALOGS_HPP_
#include <com/sun/star/data/XDatabaseDialogs.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEQUERYCOMPOSER_HPP_
#include <com/sun/star/data/XDatabaseQueryComposer.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif

#ifndef _CPPUHELPER_PROPSHLP_HXX
#include <cppuhelper/propshlp.hxx>
#endif

#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL2_HXX
#include <sbautl/derivedpropimpl2.hxx>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SDB_SDBCONN_HXX //autogen
#include <sdb/sdbconn.hxx>
#endif

#ifndef _SDB_SDBDB_HXX //autogen wg. SdbDatabase
#include <sdb/sdbdb.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

#include <stl/functional>

#ifndef _UTL_STLTYPES_HXX_
#include <unotools/stl_types.hxx>
#endif


namespace com { namespace sun { namespace star {
	namespace data { class XDatabaseTable; }
	namespace util { class XNumberFormatter; }
} } }

namespace staruno	= ::com::sun::star::uno;
namespace stardata	= ::com::sun::star::data;
namespace starutil	= ::com::sun::star::util;

DECLARE_STL_USTRINGACCESS_MAP(staruno::Reference<stardata::XDatabaseTable>,TableMap);

class SdbSqlParser;
class SbaParseIterator;
class SdbSqlParseNode;

//==================================================================
// SbaXdbTableDefs
// Tabledefinitions used by database
//==================================================================
class SbaXdbSelectTables 
: public ::cppu::WeakImplHelper2<
					starcontainer::XEnumerationAccess,
					starcontainer::XNameAccess
			>
{
	friend class SbaXdbParser;

	SbaXdbParser& m_rParent;
	TableMap	  m_aTables;	// selected table description

public:
	SbaXdbSelectTables(SbaXdbParser&);

	virtual void SAL_CALL acquire() throw(staruno::RuntimeException);
	virtual void SAL_CALL release() throw(staruno::RuntimeException);

// starcontainer::XElementAccess
	virtual staruno::Type	SAL_CALL getElementType(void)	throw( staruno::RuntimeException );
	virtual sal_Bool		SAL_CALL hasElements(void)		throw( staruno::RuntimeException );

// starcontainer::XEnumerationAccess
	virtual staruno::Reference< starcontainer::XEnumeration >  
		SAL_CALL createEnumeration(void) 
			throw( staruno::RuntimeException );

// starcontainer::XNameAccess
	virtual staruno::Any 
		SAL_CALL getByName(const ::rtl::OUString& Name) 
			throw( starcontainer::NoSuchElementException, starlang::WrappedTargetException, staruno::RuntimeException );

	virtual staruno::Sequence< ::rtl::OUString > 
		SAL_CALL getElementNames(void) 
			throw( staruno::RuntimeException );

	virtual sal_Bool 
		SAL_CALL hasByName(const ::rtl::OUString& Name) 
			throw( staruno::RuntimeException );

	void clear();
	void construct(SbaParseIterator*);
};

//==================================================================
// SbaXdbParser
//==================================================================
class SbaXdbParser	 : 	public SbaXdbObject,
						public ::sbautl::DerivedPropertySetHelper2<SbaXdbParser,SbaXdbObject,
										stardata::XDatabaseDialogs,
										stardata::XDatabaseQueryComposer
								>
{
	SbaParseIterator*	m_pIterator;
	SdbSqlParser	*	m_pSqlParser;
	SdbSqlParseNode *	m_pSqlRootNode;

	SbaXdbFieldValues   m_aSelectedFields;	// selected field description
	SbaXdbSelectTables	m_aSelectedTables;

	SdbConnectionRef	m_xConnection;
	SdbDatabaseRef		m_xDatabase;
	String				m_aOrigSql,			// Ausgangsstatement
						m_aOrigFilter,		// AusgangsFilter
						m_aOrigOrder,		// Ausganssortierung
						m_aWorkSql,			// Ausgangsstatement ohne Filter und Order
						m_aCurrentFilter,
						m_aCurrentOrder;

public:
	SbaXdbParser(SbaXdbCollection& rCollection, SdbConnection* pConn);
	SbaXdbParser(SbaXdbCollection& rCollection, SdbDatabase* pDb, SdbConnection* pConn);
	~SbaXdbParser();

public:
	DECLARE_DERIVED_IMPL(SbaXdbParser, PropertySetHelper);

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// stardata::XDatabaseQueryComposer
	virtual ::rtl::OUString SAL_CALL getQuery(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setQuery(const ::rtl::OUString& aStatement) 
		throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException );

	virtual ::rtl::OUString SAL_CALL getComposedQuery(void) 
		throw( staruno::RuntimeException );

	virtual ::rtl::OUString SAL_CALL getFilter(void) 
		throw( staruno::RuntimeException );

	virtual ::rtl::OUString SAL_CALL getSort(void) 
		throw( staruno::RuntimeException );

	virtual void 
		SAL_CALL appendFilterByField(const staruno::Reference< starcontainer::XNamed > & aField) 
			throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException );

	virtual void 
		SAL_CALL appendSortByField(const staruno::Reference< starcontainer::XNamed > & Field, sal_Bool Ascending) 
			throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException );

	virtual void 
		SAL_CALL setFilter(const ::rtl::OUString& aFilter) 
			throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException );

	virtual void SAL_CALL setSort(const ::rtl::OUString& aFilter) 
		throw( starlang::IllegalArgumentException, stardata::DatabaseException, staruno::RuntimeException );

// stardata::XDatabaseDialogs
	virtual void SAL_CALL executeFilter(const staruno::Reference< starcontainer::XNamed > & aField) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL executeSort(const staruno::Reference< starcontainer::XNamed > & aField) 
		throw( staruno::RuntimeException );

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const 
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue( 
						staruno::Any & rConvertedValue, staruno::Any & rOldValue,
						sal_Int32 nHandle, const staruno::Any& rValue 
				)
				throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue ) 
				throw (staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

private:
	void reset();
	void resetIterator(const String& aSql);
	String getColumnName(SdbSqlParseNode* pColumnRef) const;
	// staruno::Reference< starbeans::XPropertySet >  getField(SdbSqlParseNode* pColumnRef, const String& aColumnName) const;
	sal_Bool setORCriteria(
					SdbSqlParseNode* pCondition, 
					std::vector< std::vector < starbeans::PropertyValue > >& rFilters, 
					const staruno::Reference< starutil::XNumberFormatter > & xFormatter
			) const;

	sal_Bool setANDCriteria(
					SdbSqlParseNode * pCondition, 
					std::vector < starbeans::PropertyValue >& rFilter,
					const staruno::Reference< starutil::XNumberFormatter > & xFormatter
			) const;

	sal_Bool setComparsionPredicate(
					SdbSqlParseNode * pCondition, 
					std::vector < starbeans::PropertyValue >& rFilter, 
					const staruno::Reference< starutil::XNumberFormatter > & xFormatter
			) const;
};

//==================================================================
// SbaXdbParsers
// Klasse zum Verwalten von Parsern
//==================================================================
class SbaXdbParsers : public SbaXdbCollection
{
public:
	SbaXdbParsers(SbaXdbComponent& _rParent):SbaXdbCollection(_rParent){}
};

#endif

