/*************************************************************************
 *
 *  $RCSfile: sbadbtbl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBTBL_HXX
#define _SBA_SBADBTBL_HXX

#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XREFRESHABLE_HPP_
#include <com/sun/star/util/XRefreshable.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASETABLE_HPP_
#include <com/sun/star/data/XDatabaseTable.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEUPDATE_HPP_
#include <com/sun/star/data/XDatabaseUpdate.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASETABLEFACTORY_HPP_
#include <com/sun/star/data/XDatabaseTableFactory.hpp>
#endif

#ifndef _SBA_UTL_DERIVEDPROPIMPL5_HXX
#include <sbautl/derivedpropimpl5.hxx>
#endif
#ifndef _SBA_UTL_DERIVEDIMPL1_HXX
#include <sbautl/derivedimpl1.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBFLD_HXX
#include "sbadbfld.hxx"
#endif

#ifndef _SBA_SBADBIDX_HXX
#include "sbadbidx.hxx"
#endif


#ifndef _SBA_DBTABOBJ_HXX
#include <dbtabobj.hxx>
#endif


namespace staruno		= :: com::sun::star::uno;
namespace starlang		= :: com::sun::star::lang;
namespace stardata		= :: com::sun::star::data;
namespace starutil		= :: com::sun::star::util;
namespace starcontainer	= :: com::sun::star::container;
namespace starbeans		= :: com::sun::star::beans;

//class SbaTableDef;
//typedef staruno::Reference<SbaTableDef> SbaTableDefRef;

//==================================================================
// SbaXdbTable
// Implementation of table
//==================================================================
class SbaXdbTable_Impl : 
	public SbaXdbObjectCreator,
	public ::sbautl::DerivedPropertySetHelper5<SbaXdbTable_Impl, SbaXdbObjectCreator,
				::com::sun::star::data::XDatabaseTable,
				::com::sun::star::util::XRefreshable,
				::com::sun::star::data::XDatabaseUpdate,
				::com::sun::star::container::XNamed,
				::com::sun::star::lang::XUnoTunnel
			>
{
	friend class SbaXdbTables;
	friend class SbaXdbTableStatement;

protected:
	SbaXdbIndexes	m_aIndexes;
	SbaXdbFields	m_aFields;
	::cppu::OInterfaceContainerHelper m_aRefreshListeners;

	::rtl::OUString			m_aFilter;
	::rtl::OUString			m_aSort;
	sal_Int16			m_nPrivileges;

	SbaXdbTable_Impl(SbaXdbCollection& rCollection, sal_Bool bCase);

public:
	SbaXdbTable_Impl(sal_Bool bCase);

	DECLARE_DERIVED_IMPL(SbaXdbTable_Impl, PropertySetHelper);

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// starutil::XRefreshable
	virtual void  
		SAL_CALL addRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
			throw( staruno::RuntimeException );

	virtual void  
		SAL_CALL removeRefreshListener(const staruno::Reference< starutil::XRefreshListener > & l) 
			throw( staruno::RuntimeException );

// stardata::XDatabaseFieldsSupplier (base of XDatabaseTable)
	virtual staruno::Reference< starcontainer::XNameAccess >   
		SAL_CALL getFields(void)  
			throw( staruno::RuntimeException );

// stardata::XDatabaseTable
	virtual staruno::Reference< starcontainer::XNameContainer >   
		SAL_CALL getIndexes(void) 
			throw( staruno::RuntimeException );

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const  
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual sal_Bool SAL_CALL convertFastPropertyValue(
							staruno::Any & rConvertedValue, staruno::Any & rOldValue,
							sal_Int32 nHandle, const staruno::Any& rValue )
			throw( starlang::IllegalArgumentException );

	virtual void SAL_CALL setFastPropertyValue_NoBroadcast( sal_Int32 nHandle, const staruno::Any& rValue )
		throw(staruno::Exception);

	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

// helper
	const SbaXdbFields& getImplFields() const {return m_aFields;}
};

//==================================================================
// SbaXdbTableDef
// Tabledefinition used by database
//==================================================================
class SbaXdbTableDef : public SbaXdbTable_Impl
{
	friend class SbaXdbTableDefs;

protected:
	SbaTableDefRef	m_xTable;

	SbaXdbTableDef(SbaXdbCollection& rCollection, SbaTableDef*, sal_Bool bCase);
	virtual ~SbaXdbTableDef();

public:
	SbaXdbTableDef(sal_Bool bCase);

	// UnoTunnel support
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );

	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// stardata::XDatabaseTable
	virtual staruno::Reference< stardata::XDatabaseStatement > SAL_CALL createStatement(void) 
		throw( stardata::DatabaseException, staruno::RuntimeException );

// starutil::XRefreshable
	virtual void SAL_CALL refresh(void) 
		throw( staruno::RuntimeException );

// starcontainer::XNamed
	virtual ::rtl::OUString SAL_CALL getName(void)  
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// stardata::XDatabaseUpdate
	virtual void SAL_CALL update(void)
		throw( starlang::NoSupportException, stardata::DatabaseException, staruno::RuntimeException );

// PropertySetHelper
	virtual void fillProperties(staruno::Sequence<starbeans::Property>& aProperties) const  
		throw(staruno::RuntimeException);

// OPropertySetHelper
	virtual void SAL_CALL getFastPropertyValue( staruno::Any& rValue, sal_Int32 nHandle ) const;

protected:
	virtual void setObject(const SbaTableDefRef& xDef)
		throw( stardata::DatabaseException, staruno::RuntimeException );

protected:
	virtual SdbObj* createObject(DBObject _eObj, const ::rtl::OUString& _rName) 
		throw( stardata::DatabaseException );

	virtual SdbObj* openObject(DBObject _eObj, const ::rtl::OUString& _rName) ;
	virtual SdbObj* openObject(DBObject _eObj, sal_Int32 _nPos) ;
	virtual ::rtl::OUString getObjectName(DBObject _eObj, sal_Int32 _nPos) const;
	virtual sal_Int32	getObjectCount(DBObject _eObj) const;
	virtual void refresh(DBObject _eObj) 
		throw( stardata::DatabaseException );
};

//==================================================================
// SbaXdbTable
// Tabledefinition used by a Connection
//==================================================================
class SbaXdbTable : public SbaXdbTable_Impl
{
	friend class SbaXdbTables;

protected:
	SdbTableRef	m_xTable;

	SbaXdbTable(SbaXdbCollection& rCollection, SdbTable*, sal_Bool bCase);
	virtual ~SbaXdbTable();

public:
	SbaXdbTable(sal_Bool bCase);

	// UnoTunnel support
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// stardata::XDatabaseTable
	virtual staruno::Reference< stardata::XDatabaseStatement > SAL_CALL 
		createStatement(void) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

// starutil::XRefreshable
	virtual void SAL_CALL refresh(void) 
		throw( staruno::RuntimeException );

// starcontainer::XNamed
	virtual ::rtl::OUString SAL_CALL getName(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// stardata::XDatabaseUpdate
	virtual void SAL_CALL update(void) 
		throw( starlang::NoSupportException, stardata::DatabaseException, staruno::RuntimeException );

protected:
	virtual void setObject(const SdbTableRef& xDef)
			throw( stardata::DatabaseException, staruno::RuntimeException );

protected:
	virtual SdbObj* createObject(DBObject _eObj, const ::rtl::OUString& _rName) 
		throw( stardata::DatabaseException );

	virtual SdbObj* openObject(DBObject _eObj, const ::rtl::OUString& _rName) ;
	virtual SdbObj* openObject(DBObject _eObj, sal_Int32 _nPos) ;
	virtual ::rtl::OUString getObjectName(DBObject _eObj, sal_Int32 _nPos) const;
	virtual sal_Int32	getObjectCount(DBObject _eObj) const;
	virtual void refresh(DBObject _eObj) 
		throw( stardata::DatabaseException );
};

//==================================================================
// SbaXdbTableDefs
// Tabledefinitions used by database
//==================================================================
class SbaXdbTableDefs : public ::sbautl::DerivedImplHelper1<SbaXdbTableDefs, SbaXdbNamedCollection,
									::com::sun::star::data::XDatabaseTableFactory
								>,
						public SbaXdbNamedCollection
{
	friend class SbaXdbDatabase;

	SbaXdbTableDefs(SbaXdbObjectCreator&);

public:
	DECLARE_DERIVED_IMPL(SbaXdbTableDefs, DerivationHelper1);

// stardata::XDatabaseTableFactory
	virtual staruno::Reference< stardata::XDatabaseTable > 
		SAL_CALL create(void)
			throw( starlang::NoSupportException, staruno::RuntimeException );

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const;
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element);
	virtual sal_Bool doRemove(SbaXdbObject* pObj);
};

//==================================================================
// SbaXdbTables
// Implementation of Tables used by a Connection
//==================================================================
class SbaXdbTables : public ::sbautl::DerivedImplHelper1<SbaXdbTables, SbaXdbNamedCollection,
									::com::sun::star::data::XDatabaseTableFactory
								>,
						public SbaXdbNamedCollection
{
	friend class SbaXdbConnection;

	SbaXdbTables(SbaXdbObjectCreator&);

public:
	DECLARE_DERIVED_IMPL(SbaXdbTableDefs, DerivationHelper1);

// stardata::XDatabaseTableFactory
	virtual staruno::Reference< stardata::XDatabaseTable > 
		SAL_CALL create(void)
			throw( starlang::NoSupportException, staruno::RuntimeException );

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const;
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element);
	virtual sal_Bool doRemove(SbaXdbObject* pObj);
};

#endif

