/*************************************************************************
 *
 *  $RCSfile: sbadbwsp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADBWSP_HXX
#define _SBA_SBADBWSP_HXX

#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXACCESS_HPP_
#include <com/sun/star/container/XIndexAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEWORKSPACE_HPP_
#include <com/sun/star/data/XDatabaseWorkspace.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEWORKSPACEFACTORY_HPP_
#include <com/sun/star/data/XDatabaseWorkspaceFactory.hpp>
#endif

#ifndef _SBA_UTL_DERIVEDIMPL2_HXX
#include <sbautl/derivedimpl2.hxx>
#endif

#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif

#ifndef _SDB_SDBWORK_HXX //autogen
#include <sdb/sdbwork.hxx>
#endif

#ifndef _SDB_SDBENV_HXX //autogen
#include <sdb/sdbenv.hxx>
#endif

#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif

#ifndef _SBA_SBADBDAT_HXX
#include "sbadbdat.hxx"
#endif

namespace staruno		= :: com::sun::star::uno;
namespace starlang		= :: com::sun::star::lang;
namespace stardata		= :: com::sun::star::data;
namespace starbeans		= :: com::sun::star::beans;
namespace starcontainer	= :: com::sun::star::container;

//==================================================================
// SbaXdbWorkspace
//==================================================================
class SbaXdbWorkspace: public SbaXdbObject,
					   public ::sbautl::DerivedImplHelper2<SbaXdbWorkspace, SbaXdbObject,
								   ::com::sun::star::container::XNamed,
								   ::com::sun::star::data::XDatabaseWorkspace
								>,
					   private ::com::sun::star::container::XIndexAccess

{
	friend class SbaXdbTableDef;
	friend class SbaXdbTable;
	friend class SbaXdbWorkspaces;
	friend class SbaXdbEngine;

	SbaXdbDatabases		m_aDatabases;
	SdbWorkspaceRef		m_xWorkspace;
	sal_Bool			m_bDefault;


protected:
	SbaXdbWorkspace(SbaXdbCollection& rCollection, SdbWorkspace*, sal_Bool bDefault = sal_False);
	~SbaXdbWorkspace();

public:
	SbaXdbWorkspace();

	DECLARE_DERIVED_IMPL(SbaXdbWorkspace, DerivationHelper2);
    
	// UnoTunnel support
	virtual sal_Int64  
		SAL_CALL getSomething(staruno::Sequence<sal_Int8> const& aIdentifier)
			throw( staruno::RuntimeException );
	static ::com::sun::star::uno::Sequence< sal_Int8 > getUnoTunnelImplementationId();

// starlang::XComponent
	virtual void SAL_CALL dispose(void) throw( staruno::RuntimeException );

// OComponentHelper
	virtual void SAL_CALL disposing(void);

// starcontainer::XNamed
	virtual ::rtl::OUString SAL_CALL getName(void) 
		throw( staruno::RuntimeException );

	virtual void SAL_CALL setName(const ::rtl::OUString& Name_) 
		throw( staruno::RuntimeException );

// starcontainer::XElementAccess (base of XEnumerationAccess,XIndexAccess)
	virtual staruno::Type SAL_CALL getElementType(void) 
		throw( staruno::RuntimeException );

	virtual sal_Bool SAL_CALL hasElements(void) 
		throw( staruno::RuntimeException );

// starcontainer::XEnumerationAccess (base of XDatabaseWorkspace)
	virtual staruno::Reference< starcontainer::XEnumeration > 
		SAL_CALL  createEnumeration(void) 
			throw( staruno::RuntimeException );


// stardata::XDatabaseWorkspace
	virtual staruno::Reference< stardata::XDatabase > 
		SAL_CALL create(const ::rtl::OUString& DatabaseName, 
						const ::rtl::OUString& Title, 
						const staruno::Sequence< starbeans::PropertyValue >& ConnectInfo) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual staruno::Reference< stardata::XDatabase > 
		SAL_CALL open(const ::rtl::OUString& DatabaseName) 
			throw( stardata::DatabaseException, staruno::RuntimeException );

	virtual void setObject(const SdbWorkspaceRef& xWs)
			throw( stardata::DatabaseException, staruno::RuntimeException );

protected:
// starcontainer::XIndexAccess (nur fuer enumeration, daher nicht im QueryInterface)
	virtual sal_Int32 SAL_CALL getCount(void) 
		throw( staruno::RuntimeException ) 
			{ return m_aDatabases.size();}

	virtual staruno::Any SAL_CALL getByIndex(sal_Int32 Index) 
		throw( starlang::IndexOutOfBoundsException, starlang::WrappedTargetException, staruno::RuntimeException ); 

	void resetDefault() {m_bDefault = sal_False;}
};

//==================================================================
// SbaXdbWorkspaces
//==================================================================
class SbaXdbWorkspaces : public SbaXdbNamedCollection,
						 public ::sbautl::DerivedImplHelper2<SbaXdbWorkspaces, SbaXdbNamedCollection,
										::com::sun::star::container::XIndexAccess,
										::com::sun::star::data::XDatabaseWorkspaceFactory
									>
{
	friend class SbaXdbEngine;
	SdbEnvironmentRef m_xEnvironment;

protected:
	// liste aller Workspaces
	SbaXdbWorkspaces(SbaXdbEngine&);

public:
	DECLARE_DERIVED_IMPL(SbaXdbWorkspaces, DerivationHelper2);

// stardata::XDatabaseWorkspaceFactory
	virtual staruno::Reference< stardata::XDatabaseWorkspace > 
		SAL_CALL create(void) 
			throw( staruno::RuntimeException );

// starcontainer::XElementAccess
	virtual staruno::Type SAL_CALL getElementType(void) 
		throw( staruno::RuntimeException )
			{return SbaXdbNamedCollection::getElementType();}

	virtual sal_Bool SAL_CALL hasElements(void) 
		throw( staruno::RuntimeException )
			{return SbaXdbNamedCollection::hasElements();}

// starcontainer::XIndexAccess
	virtual sal_Int32 SAL_CALL getCount(void)
		throw( staruno::RuntimeException ) 
			{return SbaXdbNamedCollection::size();}

	virtual staruno::Any SAL_CALL 
		getByIndex(sal_Int32 Index) 
			throw( starlang::IndexOutOfBoundsException, starlang::WrappedTargetException, staruno::RuntimeException ); 

	virtual void SAL_CALL disposing();

protected:
	virtual SbaXdbObject* doGet(SdbObj*) const;
	virtual SbaXdbObject* doInsert(const ::rtl::OUString& Name, const staruno::Any& Element);
	virtual sal_Bool doRemove(SbaXdbObject* pObj);
};

#endif

