/*************************************************************************
 *
 *  $RCSfile: sbads.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBADS_HXX
#define _SBA_SBADS_HXX

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _FSETOBJSH_HXX //autogen
#include <sfx2/fsetobsh.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _SBA_DBDATDEF_HXX
#include "dbdatdef.hxx"
#endif
#ifndef _SBA_DBFILEOB_HXX
#include "dbfileob.hxx"
#endif
#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

class SfxSlotInterceptor;
// FORWARD_DECLARE_INTERFACE(uno,Reference)
FORWARD_DECLARE_INTERFACE(container,XChild)
class SbaXFileDefHelper;

//==================================================================
// Tools

INetURLObject GetFileUrl(const INetURLObject& _rUrl);

//==================================================================
// DocShellWaitObject
//==================================================================
class DocShellWaitObject
{
	SfxObjectShell*			m_pDocShell;
	::std::vector<Window*>	m_aWindows;

public:
	DocShellWaitObject(SfxObjectShell* _pDocShell);
	~DocShellWaitObject();
};

//==================================================================
//	Erweiterung zur Shell fuer die Datendefinitionsobjecte
//==================================================================
class SbaDBDefDocShExt: public SfxListener
{
	sal_uInt32		nEventID;
	sal_uInt32		nShellCloseEventID;
	SfxObjectShell* pShell;

protected:
	SbaDatabaseRef	xDatabase;
	SbaDBDefRef		xDBDef;

	sal_Bool		bInPrepareClose;


public:
	SbaDBDefDocShExt(SfxObjectShell* pShell);
	~SbaDBDefDocShExt();

	SbaDatabase*		GetDatabase() const {return &xDatabase;}
	SbaDBDef*			GetDBDef() const {return &xDBDef;}

	virtual void		SetDocTitle();
	virtual sal_Bool	PrepareSaveAs();

	String				GetDocTitle(sal_Bool bWithPrefix = sal_False) const;

	virtual sal_uInt16	PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing );

protected:
	virtual void SFX_NOTIFY(SfxBroadcaster& rBC,
							const TypeId& rBCType,
							const SfxHint& rHint,
							const TypeId& rHintType );

	virtual sal_Bool	SaveAs(const SbaDBDefRef& _rOldDef);
	virtual sal_Bool	_SaveImpl() = 0;
	sal_Bool			InitNew();
	sal_Bool			ConvertFrom(SfxMedium& rMedium);

	// fuer das Handling der Year2000-::com::sun::star::frame::Settings eine zentrale Anlaufstelle
	void				GetYear2000(SfxItemSet& rSet);
	void				SetYear2000(const SfxItemSet& rSet);

private:
	DECL_LINK(FinishedLoadHdl, void* );
	DECL_LINK(DoCloseHdl, void* );
};

//==================================================================
//	Shell fuer die Datendefinitionsobjecte
//==================================================================
class SbaDBDataDefDocSh : public SfxObjectShell , public SbaDBDefDocShExt
{
	friend class SbaDBDataDefViewSh;

public:
	TYPEINFO();

	SbaDBDataDefDocSh(SfxObjectCreateMode eMode);
	virtual ~SbaDBDataDefDocSh();

	virtual sal_Bool	InitNew(SvStorage*);
	virtual sal_Bool	ConvertFrom(SfxMedium& rMedium);
	virtual sal_Bool	Save();

	SbaDBDataDefViewSh*	GetCurView() const;			// kann auch NULL sein
	sal_uInt16			GetCurViewId() const;		// liefert 0 wenn keine ::com::sun::star::sdbcx::View gesetzt
	sal_Bool			SetCurView(sal_uInt16 nViewId);
	SbaDBDataDef*		GetDataDef() const {return PTR_CAST(SbaDBDataDef,GetDBDef());}
	void				SetReadOnlyUI( sal_Bool bReadOnly );

	virtual sal_uInt16	PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing );

	virtual sal_Bool	Refresh();

protected:
	virtual String		GetAPIName() const;
};

//==================================================================
//	Shell fuer die Filedefinitionsobjekte
//==================================================================
class SbaFileDefDocSh : public SfxFrameSetObjectShell , public SbaDBDefDocShExt
{
	friend class SbaFileDefViewSh;

protected:
	DirEntry			aEntry;
	String				aFileFrameName;		// Name des Frames, der das File darstellt
	SfxSlotInterceptor*	pInterceptor;
	SbaFileDefViewSh*	m_pView;
	SbaXFileDefHelper*	m_pHelper;
	BOOL				m_bInSave;

public:
	TYPEINFO();

	SbaFileDefDocSh(SfxObjectCreateMode eMode, const String& aFileFrame);
	virtual ~SbaFileDefDocSh();

	virtual sal_Bool	InitNew(SvStorage*);
	virtual sal_Bool	ConvertFrom(SfxMedium& rMedium);
	virtual sal_Bool	_SaveImpl();
	virtual sal_Bool	Save();

	SbaFileDef*			GetFileDef() const { return PTR_CAST(SbaFileDef,GetDBDef()); }
	SbaFileDefViewSh*	GetCurView() const { return m_pView; }
	void				SetReadOnlyUI( sal_Bool bReadOnly );

	const String&		GetFileFrameName() const {return aFileFrameName;}

	virtual sal_Bool	PrepareSaveAs();
	virtual sal_uInt16	PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing );

	virtual void SFX_NOTIFY(SfxBroadcaster& rBC,
							const TypeId& rBCType,
							const SfxHint& rHint,
							const TypeId& rHintType );
protected:
	virtual void		GetState(SfxItemSet &);
	virtual void		Execute( SfxRequest& rReq );

	virtual void		ParentActivate();
	virtual void		ParentDeactivate();
	virtual void		ViewActivate(SbaFileDefViewSh* pVw);

	virtual String		GetAPIName() const;

	SbaXFileDefHelper*	GetHelper() const {return m_pHelper;}
	void				CreateHelper();
};

#endif
