/*************************************************************************
 *
 *  $RCSfile: sbahtml.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SBA_SBAHTML_HXX
#define _SBA_SBAHTML_HXX

#if STLPORT_VERSION < 321
#ifndef __SGI_STL_VECTOR_H //autogen
	// leider ist das presys/postsys-Paar nicht ganz perfekt, also kuemmere ich mich um einige Sachen noch selber ...

#include <tools/presys.h>
#include <stl/vector.h>
#include <stl/map.h>
#include <tools/postsys.h>

// zu 'nicht ganz perfekt' gehoert auch das nicht korrekte Behandeln des CreateWindow
// (das folgende Stueck ist geklaut aus der postsys.h, dort wurde es fuer etliche andere statt dem CreateWindow auch benutzt)
#if defined( WIN ) || defined( WNT )
#ifdef CreateWindow
#undef CreateWindow
#ifdef UNICODE
#define WIN_CreateWindow	CreateWindowW
#else
#define WIN_CreateWindow	CreateWindowA
#endif
#else
#define CreateWindow		CreateWindow
#endif
#endif

#undef __PRIVATE
#include <tools/solar.h>
// das setzt das __PRIVATE wieder, dito BOOL ...

// Der MS-VC 4.1 Compiler hat ein Problem mit der STL und dem  Operator != fuer Strings
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#if defined( WNT ) && defined( __SGI_STL_ITERATOR_H )
#if defined WANT_NO_4270WARNINGS
#pragma warning( disable: 4270 )
#endif
inline BOOL	operator != (String & rStr1,  const String& rStr2) { return !(operator == (rStr1, rStr2)); }
inline BOOL	operator != (const String rStr1, String & rStr2 ) { return !(operator == (rStr1, rStr2)); }
#endif
#endif
#else
#include <vector>
#endif

#include <limits.h>

#ifndef _SVX_SVXENUM_HXX //autogen
#include <svx/svxenum.hxx>
#endif


#ifndef _PARHTML_HXX //autogen
#include <svtools/parhtml.hxx>
#endif

#include <sdb/sdbcurs.hxx>
#ifndef _SBA_DBTABOBJ_HXX
#include <dbtabobj.hxx>
#endif

#ifndef _SV_FONT_HXX //autogen
#include <vcl/font.hxx>
#endif

class SvNumberFormatter;
class SbaWizardPage;
class SbaParser
{
protected:
	SbaTableDefRef		xTableDef;		// Ziel Tabelle
	SbaDatabaseRef		xDatabase;		// Ziel Datenbank
	SdbCursorRef		xDestCursor; 	// Cursor zum F"ullen der Tabelle
	String				aTextToken;		// Zellen Inhalt
	vector<ULONG>		m_vColumns;		// Welche Spalten "ubernommen werden sollen
	ULONG*				m_pColumnSize;  // max Gr"o"se f"ur Textfelder
	ULONG*				m_pFormatKeys;  // max Gr"o"se f"ur Textfelder
	vector<SbaFieldType> m_vColumnTypes; // FeldTypen f"ur schnelleren Zugriff
	SvNumberFormatter*	m_pNF;			// dient zur Typerkennung
	UINT32				nColumnPos;		// aktuelle Spaltenposition
	UINT32				m_nRows;		// Anzahl der Zeilen die durchsucht werden sollen
	UINT32				m_nRowCount;	// current count of rows
	USHORT				nDefToken;		// Sprache
	BOOL				bError;			// Fehler und Abbruchstatus
	BOOL				bInTbl;			// Ist gesetzt, wenn der Parser sich in der RTF Tabelle befindet
	BOOL				m_bHead;		// ist true, wenn die Kopfzeile noch nicht gelesen wurde
	BOOL				m_bDontAskAgain;// Falls beim Einf"ugen ein Fehler auftritt, soll die Fehlermeldung nicht
										// mehrmals erscheinen
	BOOL				m_bIsAutoIncrement; // if PKey is set by user

	virtual ULONG		CheckString(const String& aToken, ULONG nOldFormat) = 0;
	virtual BOOL		CreateTableDef(int nToken) = 0;

	virtual ~SbaParser();
public:
	SbaParser(SbaDatabase *pDatabase);
	// wird f"ur auto. Typ-Erkennung gebraucht
	SbaParser(UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf);

	virtual SbaColumnList&	FillColumnTypes(SbaColumnList& rList) = 0;
	String					ShortenFieldName( const String& rName, xub_StrLen nNewLength, const SbaColumnList& rDestList );
};

//===============================================================================================
// SbaHTMLReader
//===============================================================================================
class SbaHTMLReader : public HTMLParser, public SbaParser
{

	UINT32			m_nTableCount;
	USHORT			m_nWidth;
	USHORT			m_nColumnWidth;		// max. Spaltenbreite
protected:
	Font			m_aFont;
	virtual void	NextToken( int nToken ); // Basisklasse

	virtual ULONG	CheckString(const String& aToken, ULONG nOldFormat);
	virtual BOOL	CreateTableDef(int nToken);
	void			TableDataOn(SvxCellHorJustify& eVal,String *pValue,int nToken);
	void			TableFontOn(USHORT &nWidth,USHORT &nHeight);
	SbaColumn*		CreateColumn(String& aColumnName,const String& aTableName,SbaColumnListRef &pDestList);
	USHORT			GetWidthPixel( const HTMLOption* pOption );
	~SbaHTMLReader();
public:
	SbaHTMLReader(SvStream& rIn,SbaDatabase *pDatabase);
	// wird f"ur auto. Typ-Erkennung gebraucht
	SbaHTMLReader(SvStream& rIn,UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf);

	virtual			SvParserState CallParser();// Basisklasse
	// birgt nur korrekte Daten, wenn der 2. CTOR benutzt wurde
	// ansonsten wird die SbaColumnList ohne "Anderung zur"uckgegeben
	virtual SbaColumnList&	FillColumnTypes(SbaColumnList& rList);
};

SV_DECL_IMPL_REF( SbaHTMLReader );

#endif

