/*************************************************************************
 *
 *  $RCSfile: sbartf.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_SBARTF_HXX
#define _SBA_SBARTF_HXX

#include <limits.h>
#ifndef _PARRTF_HXX //autogen
#include <svtools/parrtf.hxx>
#endif

#include <sdb/sdbcurs.hxx>
#ifndef _SBA_DBTABOBJ_HXX
#include <dbtabobj.hxx>
#endif

#include "sbahtml.hxx"

#if STLPORT_VERSION < 321
#ifndef __SGI_STL_VECTOR_H //autogen
// leider ist das presys/postsys-Paar nicht ganz perfekt, also kuemmere ich mich um einige Sachen selber ...
#ifdef __PRIVATE
#define PRIVATE_WAS_SET
#undef __PRIVATE
#endif
#include <tools/presys.h>

#include <stl/vector.h>
#include <stl/map.h>

#include <tools/postsys.h>
#undef __PRIVATE
#include <tools/solar.h>

// zu 'nicht ganz perfekt' gehoert auch das nicht korrekte Behandeln des CreateWindow
// (das folgende Stueck ist geklaut aus der postsys.h, dort wurde es fuer etliche andere statt dem CreateWindow auch benutzt)
#if defined( WIN ) || defined( WNT )
#ifdef CreateWindow
#undef CreateWindow
#ifdef UNICODE
#define WIN_CreateWindow	CreateWindowW
#else
#define WIN_CreateWindow	CreateWindowA
#endif
#else
#define CreateWindow		CreateWindow
#endif
#endif
#endif
#else
#include <vector>
#include <map>
#endif


class SvNumberFormatter;

class SbaRTFReader : public SvRTFParser , public SbaParser
{
	vector<Color>	m_vecColor;
protected:

	virtual ULONG	CheckString(const String& aToken, ULONG nOldFormat);
	virtual BOOL	CreateTableDef(int nToken);

	virtual void	NextToken( int nToken ); // Basisklasse

	~SbaRTFReader();
public:
	SbaRTFReader(SvStream& rIn,SbaDatabase *pDatabase);
	// wird f"ur auto. Typ-Erkennung gebraucht
	SbaRTFReader(SvStream& rIn,UINT32 nRows,UINT32 nColumns,SvNumberFormatter *pNf);

	virtual			SvParserState CallParser();// Basisklasse
	// birgt nur korrekte Daten, wenn der 2. CTOR benutzt wurde
	// ansonsten wird die SbaColumnList ohne "Anderung zur"uckgegeben
	virtual SbaColumnList&	FillColumnTypes(SbaColumnList& rList);
};

SV_DECL_IMPL_REF( SbaRTFReader );
#endif
