/*************************************************************************
 *
 *  $RCSfile: sbatabdn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBATABDN_HXX
#define _SBA_SBATABDN_HXX

#ifndef _TABBAR_HXX //autogen
#include <svtools/tabbar.hxx>
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif
#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SVX_DBBROWSE_HXX
#include <svx/dbbrowse.hxx>
#endif // _SVX_DBBROWSE_HXX

#define TABPAGESIZE 70

//==================================================================
class SbaTableDesignCtrl : public DbBrowseBox
{
	friend class SbaTabDgnUndoAct;

protected:
	long nDataPos;				// derzeit benoetigte Zeile
	long nCurrentPos;			// Aktuelle Position der ausgewaehlten Column
	ULONG nClipboardFormat;
private:
	USHORT nCurUndoActId;
protected:
	BOOL bCurrentModified;
	BOOL bUpdatable;
	BOOL bClipboardFilled;

public:
	SbaTableDesignCtrl(Window* pParent, SbaResId aResID);
	virtual ~SbaTableDesignCtrl();

	virtual void	SetData( long nRow, USHORT nColId, const String& rNewData ) = 0;
	virtual String	GetData( long nRow, USHORT nColId ) = 0;
	virtual void	SetControlText( long nRow, USHORT nColId, const String& rText ) = 0;
	virtual String	GetControlText( long nRow, USHORT nColId ) = 0;

	virtual SbaTableViewSh* GetViewShell() = 0;
	SbaTableDocSh*	GetDocShell(){ return (SbaTableDocSh*)GetViewShell()->GetShell(); }

	USHORT	GetCurUndoActId(){ return nCurUndoActId; }

	virtual void Cut();
	virtual void Copy();
	virtual void Paste();

protected:
	void Paste( long nRow );

	virtual void CopyRows() = 0;
	virtual void DeleteRows() = 0;
	virtual void InsertRows( long nRow ) = 0;
	virtual void InsertNewRows( long nRow ) = 0;

	virtual BOOL IsUpdatable() const {return bUpdatable;}
	virtual void SetUpdatable( BOOL bUpdate=TRUE );

	virtual RowStatus GetRowStatus(long nRow) const;
	virtual void KeyInput(const KeyEvent& rEvt);
	virtual void Command( const CommandEvent& rEvt );

	virtual void Init();
};
#endif

