/*************************************************************************
 *
 *  $RCSfile: sbatabed.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBATABED_HXX
#define _SBA_SBATABED_HXX

#include "tbldgnvs.hxx"
#include "sbatabdn.hxx"
#include "dbview.hxx"
#include "dbtabobj.hxx"

#ifndef _SBA_EDITECTL_HXX
#include "editectl.hxx"
#endif

#include "tblds.hxx"

#ifndef _SV_WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

#ifndef _SPLIT_HXX //autogen
#include <vcl/split.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_TABCTRL_HXX //autogen
#include <vcl/tabctrl.hxx>
#endif

#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SVX_NUMFMTSH_HXX //autogen
#include <svx/numfmtsh.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SBA_FLDCTRL_HXX
#include "fldctrl.hxx"
#endif

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
//==================================================================

enum SbaEditMode
{
	SBA_EDITMODE_ADD,
	SBA_EDITMODE_DROP,
	SBA_EDITMODE_KEY,
	SBA_EDITMODE_ADD_DROP
};
//------------------------------------------------------------------

class SbaTableViewSh;
class SbaTableDesignViewSh;
class SbaTableFieldDescWin;
class SbaTableEditorCtrl;
class SbaTableFieldControl;
class SbaTableDescWin;
class MultiLineEdit;

//==================================================================
// Ableitung von TabPage ist ein Trick von TH,
// um Aenderungen der Systemfarben zu bemerken (Bug #53905)
class SbaTableDesignHelpBar : public TabPage
{
private:
	String aHelpText;
	MultiLineEdit* pTextWin;
	USHORT nDummy;

protected:
	virtual void Resize();

public:
	SbaTableDesignHelpBar( Window* pParent );
	virtual ~SbaTableDesignHelpBar();

	void SetHelpText( const String& rText );
	String GetHelpText(){ return aHelpText; }

	virtual long PreNotify( NotifyEvent& rNEvt );
};

//==================================================================
class SbaPropEditCtrl : public Edit
{
	short	m_nPos;
	String	m_strHelpText;

public:
	inline SbaPropEditCtrl(Window* pParent, INT32 nHelpId, short nPosition = -1, WinBits nWinStyle = 0);

	inline BOOL IsModified() { return GetText() != GetSavedValue(); }

	short GetPos() const { return m_nPos; }
	String GetHelp() const { return m_strHelpText; }
};

inline SbaPropEditCtrl::SbaPropEditCtrl(Window* pParent, INT32 nHelpId, short nPosition, WinBits nWinStyle)
	:Edit(pParent, nWinStyle)
	,m_nPos(nPosition)
{
	m_strHelpText = String(SbaResId(nHelpId));
}

//==================================================================
class SbaPropNumericEditCtrl : public NumericField
{
	short	m_nPos;
	String	m_strHelpText;

public:
	inline SbaPropNumericEditCtrl(Window* pParent, INT32 nHelpId, short nPosition = -1, WinBits nWinStyle = 0);

	inline BOOL IsModified() { return GetText() != GetSavedValue(); }

	short GetPos() const { return m_nPos; }
	String GetHelp() const { return m_strHelpText; }
};

inline SbaPropNumericEditCtrl::SbaPropNumericEditCtrl(Window* pParent, INT32 nHelpId, short nPosition, WinBits nWinStyle)
	:NumericField(pParent, nWinStyle)
	,m_nPos(nPosition)
{
	m_strHelpText = String(SbaResId(nHelpId));
}

//==================================================================
class SbaPropListBoxCtrl : public ListBox
{
	short	m_nPos;
	String	m_strHelpText;

public:
	inline SbaPropListBoxCtrl(Window* pParent, INT32 nHelpId, short nPosition = -1, WinBits nWinStyle = 0);

	inline BOOL IsModified() { return GetSelectEntryPos() != GetSavedValue(); }

	short GetPos() const { return m_nPos; }
	String GetHelp() const { return m_strHelpText; }
};

inline SbaPropListBoxCtrl::SbaPropListBoxCtrl(Window* pParent, INT32 nHelpId, short nPosition, WinBits nWinStyle)
	:ListBox(pParent, nWinStyle)
	,m_nPos(nPosition)
{
	m_strHelpText = String(SbaResId(nHelpId));
}

//==================================================================
class SbaTableDesignWin : public Window
{
private:

	SbaTableDesignViewSh*	pViewSh;
	SbaTableFieldDescWin*	pFieldDescWin;
	SbaTableDescWin*		m_pDescWin;	// properties of the table
	SbaTableEditorCtrl*		pEditorCtrl;
	SbaTableDef*			pTableDef;
	ULONG					nStartIndexingEvent;
	Splitter				m_aHorzSplitter;
	Splitter				m_aVertSplitter; // splitter between edit and descWin


	void ArrangeChilds( long nSplitPos );
	void ArrangeChildsVert( long nSplitPos );
	void ImplInitSettings( BOOL bFont, BOOL bForeground, BOOL bBackground );

protected:
	DECL_LINK( SplitHdl, Splitter* );

	virtual void Resize();
	virtual void DataChanged(const DataChangedEvent& rDCEvt);

public:
	SbaTableDesignWin( Window* pParent, SbaTableDef* pDef, SbaTableDesignViewSh* pView );
	virtual ~SbaTableDesignWin();

	SbaTableEditorCtrl*		GetEditorCtrl() const { return pEditorCtrl; }
	SbaTableFieldDescWin*	GetDescWin() const { return pFieldDescWin; }
	SbaTableDescWin*		GetTabDescWin() const { return m_pDescWin; }
	SbaTableDesignViewSh*	GetViewSh() const { return pViewSh; }
	SbaTableDocSh*			GetDocShell() const { return (SbaTableDocSh*)pViewSh->GetShell(); }

	DECL_LINK( SwitchHdl, Accelerator* );
};

//==================================================================
class SbaFieldDescGenPage : public TabPage
{

	SbaTableFieldControl	*m_pFieldControl;
protected:
	virtual void Resize();

public:
	SbaFieldDescGenPage( Window* pParent, SbaTableDesignHelpBar* pHelpBar );
	virtual ~SbaFieldDescGenPage();

	virtual void GetFocus();
	virtual void LoseFocus();
	virtual void Init();


	void DisplayData( SbaFieldDescr* pFieldDescr );
	void SaveData( SbaFieldDescr* pFieldDescr );
	BOOL ChildHasFocus();
	void SetControlText( USHORT nControlId, const String& rText );
	String GetControlText( USHORT nControlId );
	void SetReadOnly( BOOL bReadOnly );
	SbaTableEditorCtrl* GetEditorCtrl();

	short GetFormatCategory(SbaFieldDescr* pFieldDescr);
		// liefert zum am Feld eingestellten Format einen der CAT_xxx-Werte (CAT_NUMBER, CAT_DATE ...)
	void ActivatePropertyField(USHORT nVirtualField);
		// Parameter ist einer der FIELD_PROPERTY_xxx-Werte, das entsprechende Control wird aktiviert, wenn vorhanden

	inline String BoolStringPersistent(const String& rUIString) const;
	inline String BoolStringUI(const String& rPersistentString) const;
};

//==================================================================
class SbaFieldPropTabCtrl : public TabControl
{
public:
	SbaFieldPropTabCtrl( Window* pParent, WinBits nWinStyle = WB_STDTABCONTROL );
	virtual ~SbaFieldPropTabCtrl();

};
//==================================================================
class SbaTableDescWin : public TabPage
{
private:
	SbaTableDesignViewSh*	m_pViewSh;
	SbaTableEditorCtrl*		m_pEditorCtrl;

	FixedText*				m_pHeader;
	MultiLineEdit*			m_pTextWin;
	CheckBox*				m_pCBRowVersion;
	FixedText*				m_pFTTableDesc;
	BOOL					m_bModified;
	BOOL					m_bRowVersionAvailable;

	DECL_LINK(OnModified, void*);
	DECL_LINK(OnClick, CheckBox*);
protected:
	virtual void Resize();
	virtual void Paint( const Rectangle& rRect );

public:
	SbaTableDescWin( Window* pParent, SbaTableDesignViewSh* pView );
	virtual ~SbaTableDescWin();

	void	SetReadOnly( BOOL bReadOnly );
	void	SetEditorCtrl( SbaTableEditorCtrl* pCtrl ){  m_pEditorCtrl = pCtrl; }

	BOOL	IsRowVersion() const { return m_pCBRowVersion->IsChecked(); }
	BOOL	IsModified() const { return m_bModified; }
	String	GetTableDesc() const;

	virtual void Init();

	virtual void GetFocus();
};
//==================================================================
// Ableitung von TabPage ist ein Trick von TH,
// um Aenderungen der Systemfarben zu bemerken (Bug #53905)
class SbaTableFieldDescWin : public TabPage
{
private:
	SbaTableDesignViewSh* pViewSh;
	SbaTableDesignHelpBar* pHelpBar;
	SbaFieldDescGenPage* pGenPage;
	SbaFieldPropTabCtrl* pTabControl;
	SbaTableEditorCtrl* pEditorCtrl;
	FixedText* pHeader;

protected:
	virtual void Resize();
	virtual void Paint( const Rectangle& rRect );

public:
	SbaTableFieldDescWin( Window* pParent, SbaTableDesignViewSh* pView );
	virtual ~SbaTableFieldDescWin();

	virtual void Init();

	void DisplayData( SbaFieldDescr* pFieldDescr );
	void SaveData( SbaFieldDescr* pFieldDescr );
	void SetReadOnly( BOOL bReadOnly );
	void SetEditorCtrl( SbaTableEditorCtrl* pCtrl ){  pEditorCtrl = pCtrl; }

	BOOL ChildHasFocus(){ return pGenPage->HasChildPathFocus(); }
	virtual void GetFocus(){ pGenPage->GetFocus(); }
	virtual void LoseFocus(){ pGenPage->LoseFocus(); }
	void SetControlText( USHORT nControlId, const String& rText )
			{ pGenPage->SetControlText(nControlId,rText); }
	String GetControlText( USHORT nControlId )
			{ return pGenPage->GetControlText(nControlId); }

	short GetFormatCategory(SbaFieldDescr* pFieldDescr) { return pGenPage ? pGenPage->GetFormatCategory(pFieldDescr) : -1; }
		// liefert zum am Feld eingestellten Format einen der CAT_xxx-Werte (CAT_NUMBER, CAT_DATE ...)
	void ActivatePropertyField(USHORT nVirtualField) { if (pGenPage) pGenPage->ActivatePropertyField(nVirtualField); }
		// Parameter ist einer der FIELD_PROPERTY_xxx-Werte, das entsprechende Control wird aktiviert, wenn vorhanden

	String	BoolStringPersistent(const String& rUIString) const { return pGenPage->BoolStringPersistent(rUIString); }
	String	BoolStringUI(const String& rPersistentString) const { return pGenPage->BoolStringUI(rPersistentString); }
};
//==================================================================
class EditCtrl;
class SbaTableEditorCtrl: public SbaTableDesignCtrl, public DBView
{
	friend class SbaTableFieldControl;

	SbaTabEdRowList		aClipboardList;
	SbaTabEdRowList		aUndoList;

	SbaEditMode eEditMode;

	EditCtrl*				pNameCell;
	DbListBoxCtrl*			pTypeCell;
	Edit*					pDescrCell;
	SbaTableFieldDescWin*	pDescrWin;			// properties of one column
	SbaTableDescWin*		m_pTableDescWin;	// properties of the table
	SbaTabEdRowList*		pRowList;
	SbaTabEdRow*			pActRow;
	SbaTableDef*			pTableDef;
	SbaTableViewSh*			pViewSh;

	ULONG nIndexEvent;
	ULONG nCutEvent;
	ULONG nPasteEvent;
	ULONG nDeleteEvent;
	ULONG nInsNewRowsEvent;
	ULONG nInvalidateTypeEvent;
	ULONG nEntryNotFoundEvent;

	long nOldDataPos;

	BOOL bSaveOnMove;
	BOOL bSaveFormatter;
	BOOL bReadOnly;

	//------------------------------------------------------------------
	// Hilfsklasse
	class ClipboardInvalidator
	{
	private:
		AutoTimer	m_aInvalidateTimer;

	public:
		ClipboardInvalidator(ULONG nTimeout);
		~ClipboardInvalidator();

	protected:
		DECL_LINK(OnInvalidate, void*);
	};
	friend class SbaTableEditorCtrl::ClipboardInvalidator;

	ClipboardInvalidator	m_aInvalidate;

protected:
	virtual void Command( const CommandEvent& rEvt );
	virtual BOOL SeekRow(long nRow);
	virtual void PaintCell(OutputDevice& rDev, const Rectangle& rRect,
						   USHORT nColumnId ) const;

	virtual void CursorMoved();
	virtual RowStatus GetRowStatus(long nRow) const;

	virtual DbCellController* GetController(long nRow, USHORT nCol);
	virtual void InitController(DbCellControllerRef& rController, long nRow, USHORT nCol);

	virtual void CellModified();
	virtual BOOL SaveModified();	// wird aufgerufen vor einem Zellenwechsel
									// return FALSE, verhindert Zellenwechsel

	void		 ClearModified();

	void		 SetPrimaryKey( BOOL bSet );
	BOOL		 IsPrimaryKey();

	DECL_LINK(ControlPreNotifyHdl, NotifyEvent*);

public:
	TYPEINFO();
	SbaTableEditorCtrl(Window* pParentWin, SbaTableDef* pTableDef, SbaTableViewSh* pV);
	virtual			~SbaTableEditorCtrl();
	virtual BOOL	CursorMoving(long nNewRow, USHORT nNewCol);
	virtual void	UpdateAll();
	SfxUndoManager* GetUndoManager(){ return ((SbaTableDesignViewSh*)pViewSh)->GetUndoManager(); }
	virtual			SbaTableViewSh* GetViewShell(){ return pViewSh; }
	void			SetDescrWin( SbaTableFieldDescWin* pWin ){ pDescrWin = pWin; if (pDescrWin && pActRow) pDescrWin->DisplayData(pActRow->GetActFieldDescr()); }
	void			SetTableDescrWin( SbaTableDescWin* pWin ){ m_pTableDescWin = pWin;}
	BOOL			SaveCurRow();
	void			SwitchType( const String& rType );

	void			DisplayData( long nRow, BOOL bGrabFocus = TRUE );
		// erzwingt das Anzeigen der genannten Zeile (selbst wenn es eigentlich schon die aktuelle ist)

	virtual void	SetData( long nRow, USHORT nColId, const String& rNewData );
	virtual String	GetData( long nRow, USHORT nColId );
	virtual void	SetControlText( long nRow, USHORT nColId, const String& rText );
	virtual String	GetControlText( long nRow, USHORT nColId );

	SbaTabEdRowList* GetRowList(){ return pRowList; }
	SbaTabEdRowList* GetClipboardRowList(){ return &aClipboardList; }
	SbaTabEdRow*	GetActRow(){ return pActRow; }
	void			CellModified( long nRow, USHORT nColId );
	void			SetReadOnly( BOOL bRead=TRUE );
	BOOL			IsReadOnly();

	virtual void Init();

	BOOL IsCutAllowed( long nRow = -1 );
	BOOL IsCopyAllowed( long nRow = -1 );
	BOOL IsPasteAllowed( long nRow = -1 );

	virtual void Cut();
	virtual void Copy();
	virtual void Paste();

protected:
	virtual void Undo();
	virtual void Redo();
	virtual String GetCellText(long nRow, USHORT nColId) const;
	virtual ULONG GetTotalCellWidth(long nRow, USHORT nColId) const;

	virtual void CopyRows();
	virtual void InsertRows( long nRow );
	virtual void DeleteRows();
	virtual void InsertNewRows( long nRow );

	SbaTableDef& DBObj() const {return *pTableDef;} // const cast

private:
	DECL_LINK( StartIndexing, void* );
	DECL_LINK( DelayedCut, void* );
	DECL_LINK( DelayedPaste, void* );
	DECL_LINK( DelayedDelete, void* );
	DECL_LINK( DelayedInsNewRows, void* );
	DECL_LINK( InvalidateFieldType, void* );
	DECL_LINK( EntryNotFound, void* );

	void InitCellController();
	INT32 HasFieldName( const String& rFieldName );
	String GenerateName( const String& rName );
	BOOL SetDataPtr( long nRow );
	SbaFieldDescr* GetFieldDescr( long nRow );
	BOOL IsPrimaryKeyAllowed( long nRow );
	BOOL IsInsertNewAllowed( long nRow );
	BOOL IsDeleteAllowed( long nRow );
	void SetEditMode( SbaEditMode eMode ){ eEditMode = eMode; }
	SbaEditMode GetEditMode(){ return eEditMode; }
	BOOL SaveData(long nRow, USHORT nColumnId);
};
//==================================================================
// SbaTableFieldControl
//==================================================================
class SbaTableFieldControl : public SbaFieldDescControl
{
	SbaTableEditorCtrl*	GetCtrl();
protected:
	virtual void		ActivateAggregate( SbaControlType eType );
	virtual void		DeactivateAggregate( SbaControlType eType );
	// Sind von den abgeleiteten Klassen zu impl.
	virtual void		CellModified(long nRow, USHORT nColId );
	virtual SbaDBDataDef*	GetDataDef();
	virtual BOOL		IsReadOnly();
	virtual void		SetModified(BOOL bModified) { ((SbaTableEditorCtrl*)GetCtrl())->GetDocShell()->SetModified(bModified); };

public:
	SbaTableFieldControl( Window* pParent, SbaTableDesignHelpBar* pHelpBar) :SbaFieldDescControl(pParent,pHelpBar) {};


	String BoolStringPersistent(const String& rUIString) const { return SbaFieldDescControl::BoolStringPersistent(rUIString); }
	String BoolStringUI(const String& rPersistentString) const { return SbaFieldDescControl::BoolStringUI(rPersistentString); }
};

//------------------------------------------------------------------
inline String SbaFieldDescGenPage::BoolStringPersistent(const String& rUIString) const
{
	return m_pFieldControl->BoolStringPersistent(rUIString);
}

//------------------------------------------------------------------
inline String SbaFieldDescGenPage::BoolStringUI(const String& rPersistentString) const
{
	return m_pFieldControl->BoolStringUI(rPersistentString);
}

#endif

