/*************************************************************************
 *
 *  $RCSfile: sbatabid.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBATABID_HXX
#define _SBA_SBATABID_HXX

#ifndef _SBA_TBLIDXVS_HXX
#include "tblidxvs.hxx"
#endif

#ifndef _SBA_SBATABDN_HXX
#include "sbatabdn.hxx"
#endif

#ifndef _SBA_DBVIEW_HXX
#include "dbview.hxx"
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _SBA_EDITECTL_HXX
#include "editectl.hxx"
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif

class SbaTableViewSh;

//==================================================================
class EditCtrl;
class SbaTableIndexCtrl: public SbaTableDesignCtrl, public DBView
{
	friend class SbaIndexUndoAction;
	ULONG nNoIndexNameEvent;
	ULONG nNoFieldNameEvent;
	ULONG nDuplicateIndexEvent;

	SbaIndexInfo* pDataCol;
	SbaIndexInfo* pCurrentCol;
	SbaIndexInfos aInfoCols;	// Alle Indexinformationen

	EditCtrl* pIndexNameCell;			// Name des Index
	DbListBoxCtrl* pIndexFieldCell;		// Feld innerhalb eines Index
	DbCheckBoxCtrl* pUniqueCell;		// Kann das Feld NULL sein
	DbListBoxCtrl* pSortingCell;		// Kann das Feld NULL sein
	ULONG nTableEvent;

	SbaTableDef* pTableDef;
	SbaTableViewSh* pViewSh;

	BOOL	m_bStrongReadOnly : 1;		// siehe IsStrongReadOnly
	BOOL	m_bDefObjectLocked : 1;		// we locked the definition object

protected:
	virtual BOOL SeekRow(long nRow);
	virtual void PaintCell(OutputDevice& rDev, const Rectangle& rRect,
						   USHORT nColumnId ) const;

	virtual void CursorMoved();

	virtual DbCellController* GetController(long nRow, USHORT nCol);
	virtual void InitController(DbCellControllerRef& rController, long nRow, USHORT nCol);

	virtual String GetCellText(long nRow, USHORT nColId) const;
	virtual ULONG GetTotalCellWidth(long nRow, USHORT nColId) const;

	virtual void CellModified();
	virtual BOOL SaveModified();	// wird aufgerufen vor einem Zellenwechsel
									// return FALSE, verhindert Zellenwechsel

	RowStatus	GetRowStatus(long nRow) const;

	virtual void CopyRows();
	virtual void InsertRows( long nRow );
	virtual void DeleteRows();
	virtual void InsertNewRows( long nRow );

	virtual void ArrangeControls(USHORT& nX, USHORT nY);
	BOOL		 IsDuplicateIndex( SbaIndexInfo* pInfo );
	SfxUndoManager* GetUndoManager(){ return ((SbaTableIdxViewSh*)pViewSh)->GetUndoManager(); }
	// zeigt das Contextmenu einer Zeile an
	virtual void Command( const CommandEvent& rEvt );

public:
	TYPEINFO();
	SbaTableIndexCtrl(Window* pParentWin, SbaTableDef* pTableDef, SbaTableViewSh* pV);
	virtual ~SbaTableIndexCtrl();

	virtual SbaTableViewSh* GetViewShell(){ return pViewSh; }

	virtual void SetUpdatable(BOOL bUpdate);
	virtual BOOL IsUpdatable() const;

	BOOL IsStrongReadOnly() const { return m_bStrongReadOnly; }
		// wenn das FALSE liefert, dann auch IsUpdatable, aber nicht umgekehrt : hier gehen nur Bedingungen ein, die
		// sich nicht beeinflussen lassen, waehrend der Entwurf geoeffnet ist, also zum Beispiel mangelnde Faehigkeiten der
		// unterliegenden Datenbank oder fehlenden Rechte

	virtual void	SetData( long nRow, USHORT nColId, const String& rNewData );
	virtual String	GetData( long nRow, USHORT nColId );
	virtual void	SetControlText( long nRow, USHORT nColId, const String& rText );
	virtual String	GetControlText( long nRow, USHORT nColId );

	virtual USHORT SaveData(BOOL bUI, BOOL bForBrowsing = FALSE);
	virtual void Undo();
	virtual void Redo();
	virtual void UpdateAll();

	virtual void Init();

	INT32 getFirstWritableIndex() const;

protected:
	virtual BOOL IsCursorMoveAllowed(long nNewRow, USHORT nNewColId) const;

	SbaTableDef& DBObj() const {return *pTableDef;} // const cast

private:
	DECL_LINK( OnNoIndexName, void* );
	DECL_LINK( OnNoFieldName, void* );
	DECL_LINK( OnDuplicateIndex, void* );

	void Replace(DBUndoAction& rAction, long nRow, USHORT nColId);
	BOOL PutData(String& rErrorText);

	void InitCellController();
	BOOL IsSystemReadOnly(ULONG nRow);
};

#endif

