/*************************************************************************
 *
 *  $RCSfile: sbaunotl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_SBAUNOTL_HXX
#define _SBA_SBAUNOTL_HXX

#ifndef _SV_FONT_HXX //autogen
#include <vcl/font.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COM_SUN_STAR_AWT_FONTDESCRIPTOR_HPP_
#include <com/sun/star/awt/FontDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#ifndef _COM_SUN_STAR_SDB_XDATABASEACCESS_HPP_
#include <com/sun/star/sdb/XDatabaseAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEENVIRONMENT_HPP_
#include <com/sun/star/sdb/XDatabaseEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEACCESS_HPP_
#include <com/sun/star/sdb/XDatabaseAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_XNAMINGSERVICE_HPP_
#include <com/sun/star/uno/XNamingService.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XCONNECTION_HPP_
#include <com/sun/star/sdbc/XConnection.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XROWSET_HPP_
#include <com/sun/star/sdbc/XRowSet.hpp>
#endif

sal_uInt32 RegisterRowExchangeFormatName();
sal_uInt32 RegisterColumnExchangeFormatName();
sal_uInt32 RegisterFieldExchangeFormatName();

String Any2String(const ::com::sun::star::uno::Any& rValue);
double Any2Double(const ::com::sun::star::uno::Any& rValue);

///	collect the SBA_DEF_...-items and use them to create a new font based on the given one
::com::sun::star::awt::FontDescriptor	BuildFontFromItems(const SfxItemSet* pAttr, const Font& rBase);

///	translate the given font into SBA_DEF_...-items, put them into the set
void			BuildItemsFromFont(SfxItemSet* pAttr, const ::com::sun::star::awt::FontDescriptor& rFont);

/// ensure that a database favorite for the give data source is existent
//String EnsureDBLink(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xDataSource, sal_Bool _bUserInteraction, sal_Bool _bNeedTitle);
String EnsureDBLink(const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess > & xDataSource, sal_Bool _bUserInteraction, sal_Bool _bNeedTitle);

/// a class for sharing the complete database environment and context
class DbEnvironmentAccess
{
	static ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment > 	m_xTheEnvironment;
	static ::com::sun::star::uno::Reference< ::com::sun::star::uno::XNamingService > 		m_xTheContext;	
	static ::osl::Mutex	m_aMutex;	
	static sal_uInt16					m_nUsageCounter;

public:
	DbEnvironmentAccess();
	~DbEnvironmentAccess();

	const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment > & getEnv() const  { return m_xTheEnvironment; }
	const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XNamingService > & getContext() const  { return m_xTheContext; }
};

/**	use this if you have a ::com::sun::star::data::DatabaseEngine at hand (it's somewhat less expensive than the first method)
	(you may want to use a DbEngineAccess as a member of you class)
*/
//String EnsureDBLink(const DbEnvironmentAccess& rAccess, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xDataSource, sal_Bool _bUserInteraction, sal_Bool _bNeedTitle);
String EnsureDBLink(const DbEnvironmentAccess& rAccess, const ::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess > & xDataSource, sal_Bool _bUserInteraction, sal_Bool _bNeedTitle);
String EnsureDBLink(const String& _rSdbFile, sal_Bool _bUserInteraction, sal_Bool _bNeedTitle);

/// get the database a data source is bound to
::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  GetFormDatabase(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & _rxDataSource);
::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  GetFormDatabase(const DbEnvironmentAccess& _rAccess, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rInfoSet);

/// get the full title and path of a database a data source is bound to
sal_Bool GetDbDescription(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & rInfoSet, String& rTitle, String& rUrl);
sal_Bool GetDbDescription(const DbEnvironmentAccess& rAccess, const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xDataSource, String& rTitle, String& rUrl);

/**	some non-UNO stuff works with SbaDBDataDefs instead of XPropertySets
	Use
*/
class SbaDBDataDef;
SbaDBDataDef* GetOldStyleSbaDefinition(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xDataSource);


#endif // _SBA_SBAUNOTL_HXX

