/*************************************************************************
 *
 *  $RCSfile: unopropertymacros.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_UNOPROPMACROS_HXX
#define _SBA_UNOPROPMACROS_HXX

#ifndef _COM_SUN_STAR_BEANS_PROPERTY_HPP_
#include <com/sun/star/beans/Property.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif

//------------------------------------------------------------------------------
#define SBA_BEGIN_PROPERTY_HELPER(varname,count)	\
		{												\
		using ::rtl::OUString;							\
		using starbeans::Property;						\
		varname.realloc(count);							\
		staruno::Sequence<Property> & _aProperties_ = varname;	\
		sal_Int32 nPos_ = 0;								\

#define NEXT_PROPERTY()			_aProperties_[nPos_++]
#define SBA_PROPERTY(name)		PROPERTY_ ## name, PROPERTY_ID_## name
#define SBA_OLD_PROPERTY(name)	PROP_NAME_ ## name, PROP_## name

#define PROP_TYPE(type)			::getCppuType(static_cast< type const*>(0))
#define BOOL_PROP()				::getBooleanCppuType()
#define IFACE_PROP(type)		PROP_TYPE(::staruno::Reference< type>)

#define SBA_END_PROPERTY_HELPER()	\
		DBG_ASSERT(nPos_ == _aProperties_.getLength(), "<...>::getInfohelper : forgot to adjust the count ?");	\
		}	

#endif // _SBA_UNOPROPMACROS_HXX


