/*************************************************************************
 *
 *  $RCSfile: unotunnelhelper.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_UTL_UNOTUNNELHLP_HXX
#define _SBA_UTL_UNOTUNNELHLP_HXX

#ifndef _UNOTOOLS_UNOTUNNELHLP_HXX
#include <unotools/unotunnelhelper.hxx>
#endif

namespace utl // cannot use sbautl - getTunneledImplementation is not found by MSVC6
{
namespace staruno = ::com::sun::star::uno;
namespace starlang = ::com::sun::star::lang;

//-----------------------------------------------------------------------------------------------------------

template<class Classname>
class UnoTunnelDerivedImplHelper : public UnoTunnelImplBase<Classname>
{
	// not implemented - enforce implementation by class Classname (rather than a baseclass)
	void getStaticImplementationId();
protected:
	sal_Int64 getSomething(staruno::Sequence<sal_Int8> const& rTunnelId)
		throw(staruno::RuntimeException)
	{
		if (getImplementationTunnelId() == rTunnelId)
			return makeUnoSomething();
		else
			return sal_Int64();
	}
public:
	static staruno::Sequence<sal_Int8> getImplementationTunnelId()
		throw(staruno::RuntimeException)
	{
		return Classname::getStaticImplementationId();
	}
#ifdef LINUX
//	friend sal_Bool getTunneledImplementation(Classname*& pImpl, staruno::Reference<starlang::XUnoTunnel> const& xObj);
#else
	friend sal_Bool getTunneledImplementation(Classname*& pImpl, staruno::Reference<starlang::XUnoTunnel> const& xObj)
		throw(staruno::RuntimeException)
	{
		pImpl = UnoTunnelDerivedImplHelper<Classname>::extractUnoSomething( xObj, UnoTunnelDerivedImplHelper<Classname>::getImplementationTunnelId() );

		return pImpl != 0;
	}
#endif
};


//-----------------------------------------------------------------------------------------------------------
} // namespace utl

#endif // _SBA_UTL_UNOTUNNELHLP_HXX

