/*************************************************************************
 *
 *  $RCSfile: sbavs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBAVS_HXX
#define _SBA_SBAVS_HXX

#ifndef _SFXVIEWSH_HXX //autogen
#include <sfx2/viewsh.hxx>
#endif

#ifndef _SFXFSETVIW_HXX //autogen
#include <sfx2/fsetvwsh.hxx>
#endif

#ifndef _TABBAR_HXX //autogen wg. TabBar
#include <svtools/tabbar.hxx>
#endif

class SbaDBDataDefDocSh;
class SbaFileDefDocSh;

//==================================================================
//	ViewShell fuer die Filedefinitionsobjekte
//==================================================================
class SbaDBDataDefViewSh: public SfxViewShell
{
	SbaDBDataDefDocSh *_pSh;

public:
	TYPEINFO();

	SbaDBDataDefViewSh(SfxViewFrame *pFrame);
	SbaDBDataDefDocSh* GetShell() const {return _pSh;};
};

//==================================================================
//	ViewShell fuer die Filedefinitionsobjekte
//==================================================================
class SbaFileDefViewSh: public SfxFrameSetViewShell
{
	SbaFileDefDocSh *_pSh;

public:
	TYPEINFO();

	SbaFileDefViewSh(SfxViewFrame *pFrame);
	SbaFileDefDocSh* GetShell() const {return _pSh;};
	SfxObjectShell*	 GetFileShell() const;

protected:
	virtual void InnerResizePixel(const Point& rOfs, const Size& rSize);
	virtual void OuterResizePixel(const Point& rOfs, const Size& rSize);
	virtual void Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
	virtual void ParentActivate();
};

//==================================================================
//	FrameWindow for Views which allow a shell switch via a tabbar
//==================================================================
class SbaDBDataDef;
class SbaViewSwitchFrame : public Window
{
	Accelerator*		m_pViewSwitchAccel;

protected:
	SbaDBDataDef*		m_pDefinition;
	SbaDBDataDefViewSh*	m_pView;
	Window*				m_pMainWin;
	TabBar				m_aTabBar;

public:
	SbaDBDataDefDocSh*	GetDocShell() const	{ return (SbaDBDataDefDocSh*)m_pView->GetShell(); }
	Window*				GetMainWin() const	{ return m_pMainWin; }

public:
	SbaViewSwitchFrame(Window* pParent, SbaDBDataDef* pDef, SbaDBDataDefViewSh* pView);
	~SbaViewSwitchFrame();

	void EnableAccelSwitch(BOOL bEnable);

protected:
	// Window overridables
	virtual void	Resize();
	virtual void	Paint(const Rectangle& rRect);

	// our own overridables
	virtual void	TabSelected(USHORT) { }

private:
	DECL_LINK(OnTabBarSelect, TabBar*);
	DECL_LINK(OnAccelerator, Accelerator*);
};

#endif


