/*************************************************************************
 *
 *  $RCSfile: tabedund.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_TABEDUNDO_HXX
#define _SBA_TABEDUNDO_HXX

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _UNDO_HXX //autogen
#include <svtools/undo.hxx>
#endif

#ifndef _SV_MULTISEL_HXX //autogen
#include <tools/multisel.hxx>
#endif

//========================================================================
class SbaTableDesignCtrl;
class SbaTabDgnUndoAct : public SfxUndoAction
{
protected:
	SbaTableDesignCtrl* pTabDgnCtrl;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabDgnUndoAct( SbaTableDesignCtrl* pOwner );
	virtual ~SbaTabDgnUndoAct();
};

//========================================================================
class SbaTableEditorCtrl;
class SbaTabEdUndoAct : public SbaTabDgnUndoAct
{
protected:
	SbaTableEditorCtrl* pTabEdCtrl;

public:
	SbaTabEdUndoAct( SbaTableEditorCtrl* pOwner );
	virtual ~SbaTabEdUndoAct();
};


//========================================================================
class SbaTabDgnCellUndoAct : public SbaTabDgnUndoAct
{
protected:
	USHORT nCol;
	long nRow;
	String aOldText;
	String aNewText;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabDgnCellUndoAct( SbaTableDesignCtrl* pOwner, long nRowID, USHORT nColumn );
	virtual ~SbaTabDgnCellUndoAct();
};

//========================================================================
class SbaTabEdTypeSelUndoAct : public SbaTabEdUndoAct
{
protected:
	USHORT nCol;
	long nRow;
	String aOldType;
	String aNewType;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabEdTypeSelUndoAct( SbaTableEditorCtrl* pOwner, long nRowID, USHORT nColumn, const String& rOldType );
	virtual ~SbaTabEdTypeSelUndoAct();
};

//========================================================================
class SbaTabEdDelUndoAct : public SbaTabEdUndoAct
{
protected:
	SbaTabEdRowList	aDeletedRows;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabEdDelUndoAct( SbaTableEditorCtrl* pOwner );
	virtual ~SbaTabEdDelUndoAct();
};

//========================================================================
class SbaTabEdInsUndoAct : public SbaTabEdUndoAct
{
protected:
	SbaTabEdRowList	aInsertedRows;
	long nInsPos;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabEdInsUndoAct( SbaTableEditorCtrl* pOwner, long nInsertPosition );
	virtual ~SbaTabEdInsUndoAct();
};

//========================================================================
class SbaTabEdInsNewUndoAct : public SbaTabEdUndoAct
{
protected:
	long nInsPos;
	long nInsRows;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaTabEdInsNewUndoAct( SbaTableEditorCtrl* pOwner, long nInsertPosition, long nInsertedRows );
	virtual ~SbaTabEdInsNewUndoAct();
};

//========================================================================
class SbaPrimKeyUndoAct : public SbaTabEdUndoAct
{
protected:
	MultiSelection aDelKeys, aInsKeys;
	BOOL bActPrimKeySet;
	SbaTableEditorCtrl* pEditorCtrl;

	virtual void	Undo();
	virtual void	Redo();
	virtual String	GetComment() const;

public:
	SbaPrimKeyUndoAct( SbaTableEditorCtrl* pOwner, MultiSelection aDeletedKeys, MultiSelection aInsertedKeys );
	virtual ~SbaPrimKeyUndoAct();
};

#endif

