/*************************************************************************
 *
 *  $RCSfile: tabwin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_TABWIN_HXX
#define _SBA_TABWIN_HXX

#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif

#ifndef _SV_WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif

#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#ifndef _SVTOOLS_HASHCONT_HXX //autogen
#include <svtools/hashcont.hxx>
#endif

//////////////////////////////////////////////////////////////////////////
// Flags fuer die Groessenanpassung der SbaJoinTabWins
const UINT16 SIZING_NONE	= 0x0000;
const UINT16 SIZING_TOP		= 0x0001;
const UINT16 SIZING_BOTTOM	= 0x0002;
const UINT16 SIZING_LEFT	= 0x0004;
const UINT16 SIZING_RIGHT	= 0x0008;

//==================================================================
class SbaJoinTabWin;
class SbaJoinTabWinMap;
class SbaJoinTabWinListBox: public SvTreeListBox
{
	DECL_LINK( DoubleClickHdl, SvTreeListBox* );
	DECL_LINK( ScrollUpHdl, SvTreeListBox* );
	DECL_LINK( ScrollDownHdl, SvTreeListBox* );
	Point aMousePos;
	Timer aScrollTimer;

	SbaJoinTabWin* pTabWin;

	BOOL m_bReallyScrolled : 1;
	BOOL bDragSource : 1;

protected:
	virtual void Command(const CommandEvent& rEvt);
	virtual void LoseFocus();
	virtual void GetFocus();
	virtual	void NotifyScrolled();
	virtual void NotifyEndScroll();

	virtual long PreNotify(NotifyEvent& rNEvt);

public:
	SbaJoinTabWinListBox(SbaJoinTabWin* pParent, const String& rDatabaseName, const String& rTableName);
	virtual ~SbaJoinTabWinListBox();

	SbaJoinTabWin* GetTabWin(){ return pTabWin; }
	virtual BOOL QueryDrop( DropEvent& rDEvt );
	virtual BOOL Drop( const DropEvent& rDEvt );
	SvLBoxEntry* GetEntryFromText( const String& rEntryText );
};

//==================================================================
class SbaJoinTabWinTitle : public Control
{
	SbaJoinTabWin* pTabWin;

protected:
	virtual void Command(const CommandEvent& rEvt);
	virtual void Paint( const Rectangle& rRect );
	virtual void MouseButtonDown( const MouseEvent& rEvt );
	virtual void KeyInput( const KeyEvent& rEvt );
	virtual void DataChanged( const DataChangedEvent& rDCEvt );

public:
	SbaJoinTabWinTitle( SbaJoinTabWin* pParent );
	virtual ~SbaJoinTabWinTitle();
	virtual void LoseFocus();
	virtual void GetFocus();
	virtual void RequestHelp( const HelpEvent& rHEvt );
};

//==================================================================
class SbaJoinTabWinData
{
protected:
	String	aTableName;
	String	aWinName;

	Point	aPosition;
	Size	aSize;

	BOOL	bShowAll;

	String	m_strDatabaseName;

public:
	TYPEINFO();
	SbaJoinTabWinData();
	SbaJoinTabWinData( const String& strDatabaseName, const String& strTableName, const String& rWinName = String() );
	virtual ~SbaJoinTabWinData();

	virtual void Load( SvStream& rStream );
	virtual void Save( SvStream& rStream );

	String GetDatabaseName() const { return m_strDatabaseName; }

	String GetTableName() const { return aTableName; }
	String GetWinName() const { return aWinName; }
	Point GetPosition() const { return aPosition; }
	Size GetSize() const { return aSize; }
	BOOL IsShowAll() const { return bShowAll; }
	BOOL HasPosition() const;
	BOOL HasSize() const;

	void SetTableName( const String& rTableName ){ aTableName = rTableName; }
	void SetWinName( const String& rWinName ){ aWinName = rWinName; }
	void SetPosition( const Point& rPos ){ aPosition=rPos; }
	void SetSize( const Size& rSize ){ aSize = rSize; }
	void ShowAll( BOOL bAll ){ bShowAll = bAll; }
};

DECLARE_LIST( SbaJoinTabWinDataList, SbaJoinTabWinData* );

//==================================================================
class SbaJoinDocShExt;
class SbaJoinTabWin: public Window
{
	friend class SbaJoinTabWinTitle;
	friend class SbaJoinTabWinListBox;

	UINT16 nSizingFlags;

	SbaJoinTabWinData*		pData;

	String					m_strInitialWinName;

	BOOL bActive;

	// die Spalten der Tabelle, die ich repraesentiere
	SbaColumnListRef		xColumnList;


protected:
	// und die Tabelle selber (brauche ich, da ich sie locken will, solange das Fenster lebt)
	SbaTableDefRef			m_xTableDef;
	SbaJoinTabWinListBox*	pListBox;
	SbaJoinTabWinTitle		aTitle;

private:
	void Draw3DBorder( const Rectangle& rRect );

protected:
	virtual void	Resize();
	virtual void	Paint( const Rectangle& rRect );
	virtual void	MouseMove( const MouseEvent& rEvt );
	virtual void	MouseButtonDown( const MouseEvent& rEvt );
	virtual void	KeyInput( const KeyEvent& rEvt );

	virtual void	DataChanged( const DataChangedEvent& rDCEvt );

	virtual SbaJoinTabWinListBox*	CreateListBox();
		// wird im ERSTEN Init aufgerufen
	virtual BOOL FillListBox();
		// wird in JEDEM Init aufgerufen

	virtual void EmptyListBox();
		// Liste wird geleert, damit haben abgeleitete Klassen die Moeglichkeit, eventuell gesetzte UserData zu loeschen

	virtual void OnEntryDoubleClicked(SvLBoxEntry* pEntry) { }
		// wird aus dem DoubleClickHdl der ListBox heraus aufgerufen

	// die unterliegende Tabellendefinition (un)locken
	void LockTable() { if (m_xTableDef.Is()) m_xTableDef->AddUsage(); }
	void UnlockTable() { if (m_xTableDef.Is()) m_xTableDef->ReleaseUsage(); }

public:
	TYPEINFO();
	SbaJoinTabWin( Window* pParent, SbaJoinTabWinData* pTabWinData);
	virtual ~SbaJoinTabWin();

	// spaeter Constructor, siehe auch CreateListbox und FillListbox
	virtual BOOL Init();

	void						SetPosPixel( const Point& rNewPos );
	void						SetSizePixel( const Size& rNewSize );
	void						SetPosSizePixel( const Point& rNewPos, const Size& rNewSize );

	void						SetTitle( const String& rTit );
	void						SetBoldTitle( BOOL bBold );

	void						Remove();
	BOOL						IsActive(){ return bActive; }

	String						GetTableName() const { return pData->GetTableName(); }
	String						GetWinName() const { return pData->GetWinName(); }
	String						GetDatabaseName() const { return pData->GetDatabaseName(); }
	SbaJoinDocShExt*			GetDocShell();
	SbaJoinTabWinListBox*		GetListBox() const { return (SbaJoinTabWinListBox*)pListBox; }
	SbaJoinTabWinData*			GetData() const { return pData; }
	const SbaColumnList&		GetOriginalColumns() const { return *xColumnList; }

	UINT16						GetSizingFlags() const { return nSizingFlags; }

	virtual void				GetFocus();
	virtual void				LoseFocus();

	// Linien neu zeichnen
	void InvalidateLines();
	// habe ich Connections nach aussen ?
	BOOL ExistsAConn() const;

	virtual void EnumValidFields(SvStringsDtor& arrstrFields);

	SbaTableDefRef	GetTableDef() { return m_xTableDef; }
};

DECL_SV_STRING_MAP_CONTAINER( SbaJoinTabWinMap, SbaJoinTabWin* );

#endif


