/*************************************************************************
 *
 *  $RCSfile: tblds.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_TBLDS_HXX
#define _SBA_TBLDS_HXX

#include "sbads.hxx"

#ifndef _SFX_OBJFAC_HXX
#include <sfx2/docfac.hxx>
#endif

#ifndef _UNDO_HXX //autogen
#include <svtools/undo.hxx>
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SVX_SVXENUM_HXX //autogen
#include <svx/svxenum.hxx>
#endif

#include <svx/ifaceids.hxx>
#include "sbaintid.hrc"
#include "dbtabobj.hxx"

//========================================================================
// Anhand dieser Ids werden die sprachabhaengigen String aus der Resource geholt
const USHORT TYPE_UNKNOWN	= 0;
const USHORT TYPE_TEXT		= 1;
const USHORT TYPE_NUMERIC	= 2;
const USHORT TYPE_DATETIME	= 3;
const USHORT TYPE_DATE		= 4;
const USHORT TYPE_TIME		= 5;
const USHORT TYPE_BOOL		= 6;
const USHORT TYPE_CURRENCY	= 7;
const USHORT TYPE_MEMO		= 8;
const USHORT TYPE_COUNTER	= 9;
const USHORT TYPE_IMAGE		= 10;
const USHORT TYPE_CHAR		= 11;
const USHORT TYPE_DECIMAL	= 12;
const USHORT TYPE_BINARY	= 13;
const USHORT TYPE_VARBINARY	= 14;
const USHORT TYPE_BIGINT	= 15;

String GetTypeString( USHORT nType );

//========================================================================
class SbaFieldDescr
{
private:

protected:
	String				aName;
	String				aType;
	String				aDescription;
	UINT32				nFormatKey;
	SvxCellHorJustify	aHorJustify;
	BOOL				bPrimaryKey;
	BOOL				bAutoIncrement;
	

public:
	SbaFieldDescr();
	SbaFieldDescr( const SbaFieldDescr& rDescr );
	virtual ~SbaFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetName			(const String& rName)		{ aName = rName; }
	void SetType			(const String& rType)		{ aType = rType; }
	void SetDescription		(const String& rDescr)		{ aDescription = rDescr; }
	void SetPrimaryKey		(BOOL bSet)					{ bPrimaryKey = bSet; }
	void SetFormatKey		(UINT32 nFormat)			{ nFormatKey = nFormat; }
	void SetAutoIncrement	(BOOL bAutoInc)				{ bAutoIncrement = bAutoInc; }
	void SetHorJustify		(SvxCellHorJustify aJust)	{ aHorJustify = aJust; }

	String				GetName() const			{ return aName; }
	String				GetType() const			{ return aType; }
	SbaFieldType		GetFieldType() const;
	String				GetDescription() const	{ return aDescription; }
	BOOL				IsPrimaryKey() const	{ return bPrimaryKey; }
	UINT32				GetFormatKey() const	{ return nFormatKey; }
	BOOL				IsAutoIncrement() const	{ return bAutoIncrement; }
	SvxCellHorJustify	GetHorJustify() const	{ return aHorJustify; }
};

//========================================================================
class SbaExtFieldDescr : public SbaFieldDescr
{
private:

protected:
	String aDefaultValue;
	BOOL bRequired;

public:
	SbaExtFieldDescr(BOOL bRequire = FALSE);
	SbaExtFieldDescr( const SbaExtFieldDescr& rDescr );
	virtual ~SbaExtFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetDefault( const String& rDefault ){ aDefaultValue = rDefault; }
	void SetRequired( BOOL bReq ){ bRequired = bReq; }

	String			GetDefault() const { return aDefaultValue; }
	BOOL			IsRequired() const { return bRequired; }
};


//========================================================================
class SbaUnknownFieldDescr : public SbaFieldDescr
{
private:
protected:
public:
	SbaUnknownFieldDescr();
	SbaUnknownFieldDescr( const SbaUnknownFieldDescr& rDescr );
	virtual ~SbaUnknownFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};


//========================================================================
class SbaTextFieldDescr : public SbaExtFieldDescr
{
private:
	String aTextLen;

protected:
public:
	SbaTextFieldDescr();
	SbaTextFieldDescr( const SbaTextFieldDescr& rDescr );
	virtual ~SbaTextFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetTextLen( const String& rLen ){ aTextLen = rLen; }
	String GetTextLen(){ return aTextLen; }
};


//========================================================================
class SbaNumericFieldDescr : public SbaExtFieldDescr
{
private:
	String aNumType;

protected:
public:
	SbaNumericFieldDescr();
	SbaNumericFieldDescr( const SbaNumericFieldDescr& rDescr );
	virtual ~SbaNumericFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetNumType(const String& rType)	{ aNumType = rType; }
	String GetNumType()						{ return aNumType; }
	SbaNumericSize GetNumericSize();
};

//========================================================================
class SbaDateTimeFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaDateTimeFieldDescr();
	SbaDateTimeFieldDescr( const SbaDateTimeFieldDescr& rDescr );
	virtual ~SbaDateTimeFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaDateFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaDateFieldDescr();
	SbaDateFieldDescr( const SbaDateFieldDescr& rDescr );
	virtual ~SbaDateFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaTimeFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaTimeFieldDescr();
	SbaTimeFieldDescr( const SbaTimeFieldDescr& rDescr );
	virtual ~SbaTimeFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaCurrencyFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaCurrencyFieldDescr();
	SbaCurrencyFieldDescr( const SbaCurrencyFieldDescr& rDescr );
	virtual ~SbaCurrencyFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaMemoFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaMemoFieldDescr();
	SbaMemoFieldDescr( const SbaMemoFieldDescr& rDescr );
	virtual ~SbaMemoFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaBoolFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaBoolFieldDescr();
	SbaBoolFieldDescr( const SbaBoolFieldDescr& rDescr );
	virtual ~SbaBoolFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaCounterFieldDescr : public SbaFieldDescr
{
private:
protected:
public:
	SbaCounterFieldDescr();
	SbaCounterFieldDescr( const SbaCounterFieldDescr& rDescr );
	virtual ~SbaCounterFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaImageFieldDescr : public SbaExtFieldDescr
{
private:
protected:
public:
	SbaImageFieldDescr();
	SbaImageFieldDescr( const SbaImageFieldDescr& rDescr );
	virtual ~SbaImageFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

//========================================================================
class SbaCharFieldDescr : public SbaExtFieldDescr
{
private:
	String aTextLen;

protected:
public:
	SbaCharFieldDescr();
	SbaCharFieldDescr( const SbaCharFieldDescr& rDescr );
	virtual ~SbaCharFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetTextLen( const String& rLen ){ aTextLen = rLen; }
	String GetTextLen(){ return aTextLen; }
};

//========================================================================
class SbaDecimalFieldDescr : public SbaExtFieldDescr
{
private:
	String aLength;
	String aScale;

protected:
public:
	SbaDecimalFieldDescr();
	SbaDecimalFieldDescr( const SbaDecimalFieldDescr& rDescr );
	virtual ~SbaDecimalFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetLength( const String& rLength ){ aLength = rLength; }
	void SetScale( const String& rScale ){ aScale = rScale; }

	String GetLength(){ return aLength; }
	String GetScale(){ return aScale; }
};

//========================================================================
class SbaBinaryFieldDescr : public SbaFieldDescr
{
private:
	String aLength;

protected:
public:
	SbaBinaryFieldDescr();
	SbaBinaryFieldDescr( const SbaBinaryFieldDescr& rDescr );
	virtual ~SbaBinaryFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetLength( const String& rLength ){ aLength = rLength; }
	String GetLength(){ return aLength; }
};

//========================================================================
class SbaVarBinaryFieldDescr : public SbaFieldDescr
{
private:
	String aLength;

protected:
public:
	SbaVarBinaryFieldDescr();
	SbaVarBinaryFieldDescr( const SbaVarBinaryFieldDescr& rDescr );
	virtual ~SbaVarBinaryFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();

	void SetLength( const String& rLength ){ aLength = rLength; }
	String GetLength(){ return aLength; }
};

//========================================================================
class SbaBigIntFieldDescr : public SbaExtFieldDescr
{
private:

protected:
public:
	SbaBigIntFieldDescr();
	SbaBigIntFieldDescr( const SbaBigIntFieldDescr& rDescr );
	virtual ~SbaBigIntFieldDescr();
	TYPEINFO();

	virtual SbaFieldDescr* Clone();
};

DECL_SDB_STRING_MAP( SbaFieldDescrMap, SbaFieldDescr ) 					\

//========================================================================
class SbaTabEdRow
{
private:
	SbaFieldDescrMap aFieldDescrMap;
	SbaFieldDescr* pActFieldDescr;
	long nPos;
	String aFieldTypes;
	BOOL bReadOnly;
	BOOL bFirstNameModify;
	BOOL bFirstDescrModify;

protected:
public:
	SbaTabEdRow();
	SbaTabEdRow( const SbaTabEdRow& rRow, long nPosition = -1 );
	virtual ~SbaTabEdRow();

	SbaFieldDescr* GetActFieldDescr() const { return pActFieldDescr; }
	void SetActFieldDescr( const String& rType );

	void SetFieldType( const String& rType );

	void SetPrimaryKey( BOOL bSet );
	BOOL IsPrimaryKey() const;

	long GetPos(){ return nPos; }

	void SetReadOnly( BOOL bRead=TRUE ){ bReadOnly = bRead; }
	BOOL IsReadOnly() const { return bReadOnly; }

	void SetFirstNameModify( BOOL bMod ){ bFirstNameModify = bMod; }
	void SetFirstDescrModify( BOOL bMod ){ bFirstDescrModify = bMod; }

	BOOL IsFirstNameModify() const { return bFirstNameModify; }
	BOOL IsFirstDescrModify() const { return bFirstDescrModify; }
};

DECLARE_LIST( SbaTabEdRowList, SbaTabEdRow* );

//==================================================================
// SbaIndexInfo
DBG_NAMEEX(SbaIndexInfo);
//==================================================================
class SbaIndexInfo : public SvRefBase		// Entspricht einer Spalte im Index
{
public:
	String	aIndexName,		// Name des zugehoerigen Index, nur gesetzt, wenn es der erste Eintrag im Index ist
			aQualifierName,
			aColumnName;	// Feldname
	BOOL	bDescending;	// Feld absteigend sortiert
	BOOL	bUnique;		// Index eindeutig, nur gesetzt, wenn es der erste Eintrag im Index ist
	BOOL	bReadOnly;		// Index stammt aus der Datenbank un darf nicht veraendert werden

public:
	SbaIndexInfo():bUnique(FALSE)
				  ,bDescending(FALSE)
				  ,bReadOnly(FALSE){DBG_CTOR(SbaIndexInfo,NULL);AddRef();}

	SbaIndexInfo(const SdbColumn& rCol, const String& rIndexName = String(),
				 const String& rQualifierName = String(),
				 BOOL bIsUnique = FALSE,BOOL bIsReadOnly = FALSE)
				 :aIndexName(rIndexName)
				 ,aQualifierName(rQualifierName)
				 ,aColumnName(rCol.GetName())
				 ,bDescending(rCol.IsDescending())
				 ,bUnique(bIsUnique)
				 ,bReadOnly(bIsReadOnly){DBG_CTOR(SbaIndexInfo,NULL);AddRef();}

	SbaIndexInfo(const SbaIndexInfo& rInfo)
				:aIndexName(rInfo.aIndexName)
				,aQualifierName(rInfo.aQualifierName)
				,bDescending(rInfo.bDescending)
				,aColumnName(rInfo.aColumnName)
				,bUnique(rInfo.bUnique)
				,bReadOnly(rInfo.bReadOnly){DBG_CTOR(SbaIndexInfo,NULL);AddRef();}
	~SbaIndexInfo(){DBG_DTOR(SbaIndexInfo,NULL);}

	inline SbaIndexInfo& operator= (const SbaIndexInfo& rInfo);
};

DECLARE_LIST(SbaIndexInfos,SbaIndexInfo*);



//========================================================================
class SbaTableViewSh;
class SbaTableDocSh : public SbaDBDataDefDocSh
{
	friend class SbaTableViewSh;
	friend class SbaTableIndexCtrl;
	friend class SbaTableDesignWin;
	friend class SbaTableDesignFrame;

	SfxUndoManager	aUndoMgr;
	SbaTabEdRowList aTabEdRowList;		// list with all columns shown in TableEditorCtrl
	BOOL			m_bRowVersionColumn;// true if there is a version column
	ULONG			nInitialRows;

	void LoadData();
	String GetType( SbaFieldType eType );
	SbaFieldType GetType( const String& rType );
	String GetLength( UINT32 nLength ){ return String::CreateFromInt32(nLength); }
	UINT32 GetLength( const String& rLength ){ return rLength.ToInt32(); }
//	UINT32 GetNumType( const String& rType );

protected:
	BOOL CheckDefConsistency();
		// ueberprueft die Konsistenz der Tabellendefinition

public:
	SFX_DECL_SIMPLE_OBJECTFACTORY_DLL(SbaTableDocSh);
	SFX_DECL_INTERFACE(ID_SBA_TABLEDOCSH);
	TYPEINFO();

	SbaTableDocSh(SfxObjectCreateMode eMode);
	~SbaTableDocSh();

	virtual void GetState(SfxItemSet &);
	virtual BOOL InitNew(SvStorage*);
	virtual BOOL ConvertFrom(SfxMedium& rMedium);
	virtual void Execute( SfxRequest& rReq );
	virtual BOOL _SaveImpl();

	virtual USHORT PrepareClose( BOOL bUI, BOOL bForBrowsing );

	BOOL				HasPrimaryKey();
	BOOL				HasFieldName( const String& rFieldName );
	String				GenerateUniqueName( const String& rBaseName );
	SbaTabEdRowList*	GetTabEdRowList() { return &aTabEdRowList; }
	BOOL				IsRowVersionColumn() const { return m_bRowVersionColumn; }
	void				SetRowVersionColumn(BOOL bSet) { m_bRowVersionColumn = bSet; }

	virtual BOOL	Refresh();
};

//------------------------------------------------------------------------
inline SbaIndexInfo& SbaIndexInfo::operator= (const SbaIndexInfo& rInfo)
{
	if(this == &rInfo)
		return *this;
	aIndexName		= rInfo.aIndexName;
	aQualifierName	= rInfo.aQualifierName;
	bDescending		= rInfo.bDescending;
	aColumnName		= rInfo.aColumnName;
	bUnique			= rInfo.bUnique;
	bReadOnly		= rInfo.bReadOnly;

	return *this;
}

#endif
