/*************************************************************************
 *
 *  $RCSfile: twcont.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_TWCONT_HXX
#define _SBA_TWCONT_HXX

#ifndef _SBA_SBADB_HXX
#include "sbadb.hxx"
#endif

#ifndef _SBA_TABCONN_HXX
#include "tabconn.hxx"
#endif

#ifndef _SBA_TABWIN_HXX
#include "tabwin.hxx"
#endif

#ifndef _SV_WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif

#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif

#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif

////////////////////////////////////////////////////////////////
// Konstanten fuer das Fensterlayout
const long TABWIN_SPACING_X  = 17;
const long TABWIN_SPACING_Y  = 17;

const long TABWIN_WIDTH_STD  = 120;
const long TABWIN_HEIGHT_STD = 120;

const long TABWIN_WIDTH_MIN  = 90;
const long TABWIN_HEIGHT_MIN = 80;

//==================================================================
class SbaJoinTabWinCont;
class SbaJoinViewShExt;
class SbaJoinDocShExt;
class SbaJoinFrameWindow : public Window
{
	DECL_LINK( ScrollHdl, ScrollBar* );

	BOOL				m_bReadOnly;

protected:
	ScrollBar	aHScrollBar;
	ScrollBar	aVScrollBar;
		// die beiden Scrollbars waren vorher private, was sie aber nicht sein duerfen, da ich abgeleiteten Klassen ja die
		// Moeglichkeit zum eigenen Layout geben will, was die Positiobnierung der Scrollbars einschliesst

protected:
	SbaJoinTabWinCont*	pTabWinCont;

	virtual void Resize();
	virtual void GetFocus();

public:
	SbaJoinFrameWindow( Window* pParent, SbaJoinViewShExt* pView );
	virtual ~SbaJoinFrameWindow();

	ScrollBar* GetHScrollBar() { return &aHScrollBar; }
	ScrollBar* GetVScrollBar() { return &aVScrollBar; }

	SbaJoinTabWinCont* GetTabWinCont() { return pTabWinCont; }

	virtual BOOL	IsReadOnly() const { return m_bReadOnly; }
	virtual void	SetReadOnly(BOOL bRO);
};


//==================================================================
class SbaDatabase;
class SbaAddTableDlg;
class SbaJoinTabConn;
class SbaJoinTabWin;
struct SbaJoinExchangeData;
class SbaJoinTabWinCont : public Window
{
	SbaJoinTabConnList	aTabConnList;
	SbaJoinTabWinMap	aTabWinMap;

	Rectangle	aDragRect;
	Rectangle	aSizingRect;
	Point		aDragOffset;
	Point		aScrollOffset;
	Size		aOutputSize;

	SbaJoinViewShExt*	pViewSh;
	SbaAddTableDlg*		pAddTabDlg;
	SbaJoinTabWin*		pDragWin;
	SbaJoinTabWin*		pSizingWin;

	SbaJoinTabConn*		pSelectedConn;

	ScrollBar*			pHScrollBar;
	ScrollBar*			pVScrollBar;

	Point				m_ptPrevDraggingPos;
	Timer				m_aDragScrollTimer;
	DECL_LINK(OnDragScrollTimer, void*);
	BOOL				m_bTrackingInitiallyMoved;

protected:
	SbaJoinTabWin*		m_pLastFocusTabWin;

public:
	TYPEINFO();
	SbaJoinTabWinCont( Window* pParent, SbaJoinViewShExt* pView );
	virtual ~SbaJoinTabWinCont();

	void DrawConnections( const Rectangle& rRect );
	void InvalidateConnections();

	void CreateAddTabDlg();
	void DestroyAddTabDlg();
	BOOL HasAddTabDlg(){ return pAddTabDlg!=NULL; }

	void BeginChildMove( SbaJoinTabWin* pTabWin, const Point& rMousePos );
	void BeginChildSizing( SbaJoinTabWin* pTabWin, const Pointer& rPointer );

	void NotifyTitleClicked( SbaJoinTabWin* pTabWin, const Point rMousePos );

	virtual void AddTabWin(const String& strDatabase, const String& rWinName, BOOL bNewTable = FALSE);
	virtual void RemoveTabWin( SbaJoinTabWin* pTabWin );

	virtual void	AddConnection(const SbaJoinExchangeData& jxdSource, const SbaJoinExchangeData& jxdDest);
	virtual BOOL	RemoveConnection(SbaJoinTabConn* pConn);

	BOOL			Scroll( long nDelta, BOOL bHoriz, BOOL bPaintScrollBars );
	ULONG			GetTabWinCount();
	Point			GetScrollOffset() const { return aScrollOffset; }

	SbaDatabase*				GetDatabase();
	SbaJoinDocShExt*			GetDocShell();
	SbaJoinViewShExt*			GetViewShell();
	SbaJoinTabWin*				GetWindow( const String& rName );

	SbaJoinTabConn*				GetSelectedConn() { return pSelectedConn; }
	void						DeselectConn(SbaJoinTabConn* pConn);	// NULL ist ausdruecklich zugelassen, dann passiert nichts
	void						SelectConn(SbaJoinTabConn* pConn);

	SbaJoinTabWinMap*			GetTabWinMap() { return &aTabWinMap; }
	const SbaJoinTabWinMap*		GetTabWinMap() const { return &aTabWinMap; }
	SbaJoinTabConnList*			GetTabConnList() { return &aTabConnList; }
	const SbaJoinTabConnList*	GetTabConnList() const { return &aTabConnList; }

	
	BOOL						ExistsAConn(const SbaJoinTabWin* pFromWin) const;
	SbaJoinTabConn*				GetTabConn(SbaJoinTabWin* pLhs,SbaJoinTabWin* pRhs, SbaJoinTabConn* _rpFirstAfter = NULL);

	// set the focus to that tab win which most recently had it (or to the first available one)
	void GrabTabWinFocus();

	// ReSync ist dazu gedacht, aus dem Dokument alle WinData und ConnData zu holen und entsprechend Wins und Conns anzulegen
	virtual void ReSync() { }
	// ClearAll implementiert ein hartes Loeschen, es werden alle Conns und alle Wins aus ihren jeweiligen Listen geloescht
	// sowie die entsprechenden Datas aus dem Dokument ausgetragen
	virtual void ClearAll();

	// wird vom AddTabDlg benutzt, um festzustellen, ob noch Tabellen hinzugefuegt werden duerfen
	virtual BOOL IsAddAllowed();

	virtual BOOL	IsReadOnly() const { return ((SbaJoinFrameWindow*)GetParent())->IsReadOnly(); }
	virtual void	SetReadOnly(BOOL bRO) { ((SbaJoinFrameWindow*)GetParent())->SetReadOnly(bRO); }

	virtual long	PreNotify(NotifyEvent& rNEvt);

protected:
	virtual void MouseButtonUp( const MouseEvent& rEvt );
	virtual void MouseButtonDown( const MouseEvent& rEvt );
	virtual void Tracking( const TrackingEvent& rTEvt );
	virtual void Paint( const Rectangle& rRect );
	virtual void ConnDoubleClicked( SbaJoinTabConn* pConnection );
	virtual void KeyInput( const KeyEvent& rEvt );
	virtual void SetDefaultTabWinPosSize( SbaJoinTabWin* pTabWin );
	virtual void DataChanged( const DataChangedEvent& rDCEvt );

	virtual void Resize();
	virtual BOOL Drop( const DropEvent& rEvt );
	virtual BOOL QueryDrop( DropEvent& rEvt );

	// wird nach Verschieben/Groessenaenderung der TabWins aufgerufen (die Standardimplementation reicht die neuen Daten einfach
	// an die Daten des Wins weiter)
	virtual void TabWinMoved(SbaJoinTabWin* ptWhich, const Point& ptOldPosition);
		// die Position ist "virtuell" : der Container hat sozusagen eine virtuelle Flaeche, von der immer nur ein bestimmter Bereich
		// - der mittels der Scrollbar veraendert werden kann - zu sehen ist. Insbesondere hat ptOldPosition immer positive Koordinaten,
		// auch wenn er einen Punkt oberhalb des aktuell sichtbaren Bereichs bezeichnet, dessen physische Ordinate eigentlich
		// negativ ist.
	virtual void TabWinSized(SbaJoinTabWin* ptWhich, const Point& ptOldPosition, const Size& szOldSize);
		// hier ist die Position (die sich waehrend des Sizings aendern kann) physisch, da waehrend des Sizens nicht gescrollt wird
	virtual void Command(const CommandEvent& rEvt);

	virtual void EnsureVisible(const SbaJoinTabWin* _pWin);

private:
	void	InitColors();
	BOOL	ScrollWhileDragging();
};

#endif


