/*************************************************************************
 *
 *  $RCSfile: unotools.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_UNOTOOLS_HXX
#define _SBA_UNOTOOLS_HXX

#ifndef _SMART_COM_SUN_STAR_SDB_SQLCONTEXT_HXX_
#include <smart/com/sun/star/sdb/SQLContext.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LANG_INDEXOUTOFBOUNDSEXCEPTION_HXX_
#include <smart/com/sun/star/lang/IndexOutOfBoundsException.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LANG_ILLEGALARGUMENTEXCEPTION_HXX_
#include <smart/com/sun/star/lang/IllegalArgumentException.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XENUMERATIONACCESS_HXX_
#include <smart/com/sun/star/container/XEnumerationAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XNAMEACCESS_HXX_
#include <smart/com/sun/star/container/XNameAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XENUMERATION_HXX_
#include <smart/com/sun/star/container/XEnumeration.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_CONTAINER_XINDEXACCESS_HXX_
#include <smart/com/sun/star/container/XIndexAccess.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_IO_XINPUTSTREAM_HXX_
#include <smart/com/sun/star/io/XInputStream.hxx>
#endif

#ifndef _USR_ITERHLP_HXX
#include <usr/iterhlp.hxx>
#endif

// listener benachrichtigen
#define NOTIFY_LISTENERS(listeners, XIface, method, evt)				\
	if (listeners.getLen())												\
	{																	\
		NAMESPACE_USR(OInterfaceIteratorHelper) aIter(listeners);		\
		while (aIter.hasMoreElements())									\
			((XIface*)aIter.next())->method(evt);						\
	}

//==================================================================
// SbaPropertyTypeConversion
//==================================================================
class SbaPropertyTypeConversion
{
public:
	static BOOL tryAny(UsrAny& rConvertedValue,
						  UsrAny& rOldValue,
						  const UsrAny& rValue,
						  const UsrAny& rCurrentValue, const Reflection* pReflection) THROWS( (IllegalArgumentException) );
	static BOOL tryEnumAsINT32(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 INT32 nCurrentValue, const Reflection* pReflection) THROWS( (IllegalArgumentException) );
	static BOOL tryString(UsrAny& rConvertedValue,
						  UsrAny& rOldValue,
						  const UsrAny& rValue,
						  const UString& rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryBOOL(UsrAny& rConvertedValue,
						  UsrAny& rOldValue,
						  const UsrAny& rValue,
						  BOOL rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryINT16(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 INT16 rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryINT32(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 INT32 rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryStringSequence(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 const Sequence<UString>& rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryINT16Sequence(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 const Sequence<INT16>& rCurrentValue ) THROWS( (IllegalArgumentException) );
	static BOOL tryINT32Sequence(UsrAny& rConvertedValue,
						 UsrAny& rOldValue,
						 const UsrAny& rValue,
						 const Sequence<INT32>& rCurrentValue ) THROWS( (IllegalArgumentException) );
};

//==================================================================
// SbaUnoInputStream,
// stream zum schreiben und lesen von Daten, basieren  auf sbxmemorystream
//==================================================================
class SbaUnoInputStream: public XInputStream,
						 public NAMESPACE_USR(OWeakObject)
{
	NAMESPACE_VOS(OMutex) m_aMutex;
	Sequence<BYTE> m_aData;
	INT32		   m_nPos;

public:
	SbaUnoInputStream(const Sequence<BYTE>& rData);

	// UNO Anbindung
	SMART_UNO_DECLARATION(SbaUnoInputStream, OWeakObject);
	virtual BOOL queryInterface(Uik aUik, XInterfaceRef& rOut);
	virtual Sequence< XIdlClassRef>	getIdlClasses(void);

//	XInputStream
	virtual INT32 readBytes(Sequence< BYTE >& aData, INT32 nBytesToRead) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual INT32 readSomeBytes(Sequence< BYTE >& aData, INT32 nMaxBytesToRead) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual void skipBytes(INT32 nBytesToSkip) THROWS( (NotConnectedException, BufferSizeExceededException, UsrSystemException) );
	virtual INT32 available(void) THROWS( (NotConnectedException, UsrSystemException) );
	virtual void closeInput(void) THROWS( (NotConnectedException, UsrSystemException) );
};

//==================================================================
// SbadbEnumeration
// allgemeine enumeration implementierung
//==================================================================
class SbadbEnumerationByName : public XEnumeration,
							   public UsrObject
{
	INT32				m_nPos;
	XNameAccessRef		m_xAccess;
	Sequence<UString>	m_aNames;

public:
	SbadbEnumerationByName(XNameAccess* _pAccess)
		:m_xAccess(_pAccess)
		,m_nPos(0)
	{
		m_aNames = _pAccess->getElementNames();
	}

	SMART_UNO_DECLARATION(SbadbEnumeration, UsrObject);
	virtual BOOL queryInterface(Uik aUik, XInterfaceRef& rOut);
	virtual Sequence< XIdlClassRef>	getIdlClasses(void);

	virtual BOOL hasMoreElements(void) THROWS( (UsrSystemException) );
	virtual UsrAny nextElement(void) THROWS( (NoSuchElementException, WrappedTargetException, UsrSystemException) );
};

//==================================================================
// SbadbEnumerationByIndex
// allgemeine enumeration implementierung
//==================================================================
class SbadbEnumerationByIndex : public XEnumeration,
							 public UsrObject
{
	INT32			m_nPos;
	XIndexAccessRef m_xAccess;

public:
	SbadbEnumerationByIndex(XIndexAccess* _pAccess)
		:m_xAccess(_pAccess)
		,m_nPos(0){}

	SMART_UNO_DECLARATION(SbadbEnumerationByIndex, UsrObject);

	virtual BOOL queryInterface(Uik aUik, XInterfaceRef& rOut);
	virtual Sequence< XIdlClassRef>	getIdlClasses(void);

	virtual BOOL hasMoreElements(void) THROWS( (UsrSystemException) );
	virtual UsrAny nextElement(void) THROWS( (NoSuchElementException, WrappedTargetException, UsrSystemException) );
};

//==================================================================
//= common functions
//==================================================================
SQLContext prependContextInfo(SQLException& _rException, const XInterfaceRef& _rxContext, const String& _rContextDescription, const String& _rContextDetails = String());

#endif //_SBA_UNOTOOLS_HXX

