/*************************************************************************
 *
 *  $RCSfile: user.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef SBA_USER_HXX
#define SBA_USER_HXX

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_DIALOG_HXX
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SVX_DBBROWSE_HXX
#include <svx/dbbrowse.hxx>
#endif
#ifndef _SDB_SDBCURS_HXX
#include <sdb/sdbcurs.hxx>
#endif
#ifndef _SDB_SDBDB_HXX
#include <sdb/sdbdb.hxx>
#endif


#ifndef _COM_SUN_STAR_DATA_XDATABASE_HPP_
#include <com/sun/star/data/XDatabase.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif

class SbaUserAdmin;
class SfxFileDialog;

class SbaTableRightCtrl : public DbBrowseBox
{
	friend class SbaUserAdmin;

	SdbCursorRef		m_xTableCursor; // show all tables which this user can grant or revoke rights
	SdbCursorRef		m_xPrivCursor;  // hold all privelegs which the choosen user have already
	SdbDatabaseRef		m_xDb; 
	DbCheckBoxCtrl*		m_pCheckCell;
	Edit*				m_pEdit;
	long				m_nDataPos;
	sal_Bool				m_bEnable;

public:
	SbaTableRightCtrl( SbaUserAdmin* pParent,const ResId& _RsId,SdbDatabase* _pConn=NULL);
	virtual ~SbaTableRightCtrl();
	void SetDatabase(SdbDatabase* _pDb) { m_xDb = _pDb; Invalidate();}
	void UpdateTables();

protected:
	virtual void Resize();

	virtual long PreNotify(NotifyEvent& rNEvt );

	virtual sal_Bool IsTabAllowed(sal_Bool bForward) const;

	virtual void Init();
	virtual void InitController( DbCellControllerRef& rController, long nRow, sal_uInt16 nCol );
	virtual DbCellController* GetController( long nRow, sal_uInt16 nCol );
	virtual void PaintCell( OutputDevice& rDev, const Rectangle& rRect, sal_uInt16 nColId ) const;
	virtual sal_Bool SeekRow( long nRow );
	virtual sal_Bool SaveModified();
	virtual String GetCellText( long nRow, sal_uInt16 nColId );

	virtual void CellModified();

private:
	sal_uInt32		m_nDeActivateEvent;
	DECL_LINK( AsynchActivate, void* );
	DECL_LINK( AsynchDeactivate, void* );
};

class SbaUserAdmin : public ModalDialog
{
protected:
	GroupBox			m_GB_USER;
	FixedText			m_FT_USER;
	ListBox				m_LB_USER;
	FixedText			m_FT_MODUS;
	ListBox				m_LB_MODUS;
	PushButton			m_PB_NEWUSER;
	PushButton			m_PB_CHANGEPWD;
	PushButton			m_PB_DELETEUSER;
	GroupBox			m_GB_TABLE_GRANTS;
	SbaTableRightCtrl	m_TableCtrl; // show the grant rights of one user

	PushButton			m_PB_OK;
	HelpButton			m_PB_HELP;
						
	SdbDatabaseRef		m_xDb; 
	SdbCursorRef		m_xUserCursor;
	String				m_UserName;
	sal_Bool				m_bSysDba; // true if i am SYSDBA user else false
	sal_Bool				m_bDba;
		
	// methods
	DECL_LINK( ListDblClickHdl, ListBox * );
	DECL_LINK( CloseHdl,		PushButton * );
	DECL_LINK( UserHdl,			PushButton * );
	void FillUserNames();

public:
	SbaUserAdmin( Window* pParent,SdbDatabase* pDatabase);
	~SbaUserAdmin();
	void NotifyCellChange();
	String GetUser();
};
//========================================================================
// Convert oterro db in adabas db
//========================================================================
class SbaConvertOterroAdabas : public ModalDialog
{
protected:
	FixedText			m_FT_EXPLAINATION;
	GroupBox			m_GB_EXPORT;
	CheckBox			m_CB_QUERY;
	CheckBox			m_CB_REPORT;
	CheckBox			m_CB_FORM;
	CheckBox			m_CB_TABLE;
	CheckBox			m_CB_RELATION;
	FixedText			m_FT_FILE_TO_CONVERT;
	Edit				m_ET_FILE_TO_CONVERT;
	FixedText			m_FT_DB_TITLE;
	Edit				m_ET_DB_TITLE;
	FixedText			m_FT_DEST_FILE;
	Edit				m_ET_DEST_FILE;
	PushButton			m_PB_DEST_FILE;
	CheckBox			m_CB_DONT_SHOW_AGAIN;
	FixedLine			m_FL_1;
	OKButton			m_PB_OK;
	HelpButton			m_PB_HELP;
	CancelButton		m_PB_CANCEL;

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabase > 		m_xDb;
	SfxFileDialog*		m_pFileDlg;
	
	DECL_LINK( PushHdl,			PushButton	* );
	DECL_LINK( CloseHdl,		PushButton	* );
	DECL_LINK( ModifyHdl,		Edit		* );
	DECL_LINK( LoseFocusHdl,	Edit		* );
	DECL_LINK( ToggleHdl,		CheckBox	* );

	::rtl::OUString CopyDocuments(::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & _xSrcDocs,::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > & _xDestDocs);

	sal_Bool isOkAllowed() const;
	sal_Bool areRelationsAllowed() const;

public:
	SbaConvertOterroAdabas( Window* pParent,const ::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabase >& _rxDatabase);
	~SbaConvertOterroAdabas();
	sal_Bool ShowDialogAgain() const;
};

#endif // SBA_USER_HXX


