/*************************************************************************
 *
 *  $RCSfile: sbadll.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: fs $ $Date: 2000/09/20 08:26:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef WIN
#include <svwin.h>
#endif

#ifndef _SBADLL_HXX
#include "sbadll.hxx"
#endif

#include "sbaobj.hxx"
#include "qryds.hxx"
#include <sfx2/sfx.hrc>

#ifndef _LIBCALL_HXX //autogen
#include <svtools/libcall.hxx>
#endif

#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif

#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SFX_APPUNO_HXX
#include <sfx2/appuno.hxx>
#endif

String aModule = String::CreateFromAscii(SVLIBRARY("sba"));
TYPEINIT1(SbaModuleDummy, SfxModule);
SFX_IMPL_MODULE_LIB(Sba, aModule);
//------------------------------------------------------------------------------------
SFX_IMPL_SIMPLE_OBJECTFACTORY_LIB(SbaQueryDocSh, SFXOBJECTSHELL_STD_NORMAL, Query, Sba, String::CreateFromAscii(SVLIBRARY("sba")), SBA_MOD())
{
	String aName; aName.AssignAscii("DBQuery");

	SFX_SIMPLE_FILTER_REGISTRATION(
		aName,                              // Name
		String(),                           // Wildcard
		SFX_FILTER_IMPORT |
		SFX_FILTER_EXPORT | // SFX_FILTER_OPENREADONLY |
		SFX_FILTER_INTERNAL | SFX_FILTER_NOTINFILEDLG |
		SFX_FILTER_NOTINCHOOSER ,               // Purpose
		0L,                                     // Clipboard-Format
		'0',									// MAC-Typ
		String(),                               // OS/2-Typ
		0,                                      // OS/2-Icon
		String(),                               // MIME-Typ
		String() );                             // Userdata
	SfxFactoryFilterContainer* pFilterContainer = Factory().GetFilterContainer();
	SfxFilter* pFilter = (SfxFilter*)pFilterContainer->GetFilter4FilterName(aName);
	pFilter->SetURLPattern(String::CreateFromAscii(SDB_DATABASE_QUERY_URL));

	Factory().RegisterHelpFile( String::CreateFromAscii(SFX_DESKTOP_HELPFILE_NAME) );
	Factory().SetExplorerImageId(IMG_SFX_EXP_QUERY);
};

/*************************************************************************
|*
|* Ctor
|* the ctor is called at the beginning of SfxApplication-subclass::Main()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/
SbaDLL::SbaDLL()
{
}

/*************************************************************************
|*
|* Dtor
|* the dtor is called at the end of SfxApplication-subclass::Main()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/
SbaDLL::~SbaDLL()
{
}

/*************************************************************************
|*
|* LibInit
|* method is called before Application::Execute()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/
void SbaDLL::LibInit()
{
	SbaQueryDocSh::RegisterFactory(0);

	// create a dummy-module for Object-Factory-Pointer
    SBA_DLL() = new SbaModuleDummy(NULL, TRUE
            ,&SbaQueryDocSh::Factory(), NULL, NULL, NULL, NULL );
}

/*************************************************************************
|*
|* LibExit
|* this method is called after Application::Execute()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
************************************************************************/
void SbaDLL::LibExit()
{
	// destroy the dummy-module with Object-Factory-Pointer
	FreeLibSba();
	DELETEZ(SBA_DLL());
}


/*************************************************************************
|*
|* Modul laden
|*
\************************************************************************/
SfxModule* SbaModuleDummy::Load()
{
//    return (LoadLibSba() ? SBA_DLL() : NULL); Geht nicht durch UNIX, deshalb:

	BOOL bLoaded = LoadLibSba();	// wird zu Debugging-Zwecken benoetigt
	if( bLoaded ) return SBA_DLL();

	return NULL;
}

