/*************************************************************************
 *
 *  $RCSfile: sbaicc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <tools/debug.hxx>
#include <tools/string.hxx>
#include <tools/stream.hxx>
#include <sfx2/docfile.hxx>

/*
ICC braucht diese Dummy Destruktoren. Er darf aber nicht die Klassendefinition
kennen, sonst gibt es Unresolves mit virtual-funktion-tables. Daher hier keine
Header includen
*/

class SbaFileDefDocSh
{
	public:
#if defined ( GCC )
		virtual ~SbaFileDefDocSh();
#else
		~SbaFileDefDocSh();
#endif

#if defined ( LINUX ) || defined ( SOLARIS ) || defined ( OS2 )
	protected:
		virtual String GetAPIName() const;
#endif
};

SbaFileDefDocSh::~SbaFileDefDocSh()
{
	DBG_ERROR("ICC-Hack failed!");
}

#if defined ( LINUX ) || defined ( SOLARIS ) || defined ( OS2 )
String SbaFileDefDocSh::GetAPIName() const
{
	DBG_ERROR("ICC-Hack failed!");
	return String();
}
#endif

class SbaDBDataDefDocSh
{
	public:
#if defined ( GCC )
		virtual ~SbaDBDataDefDocSh();
#else
		~SbaDBDataDefDocSh();
#endif

#if defined ( LINUX ) || defined ( SOLARIS ) || defined ( OS2 )
	protected:
		virtual String GetAPIName() const;
#endif
};

SbaDBDataDefDocSh::~SbaDBDataDefDocSh()
{
	DBG_ERROR("ICC-Hack failed!");
}

#if defined ( LINUX ) || defined ( SOLARIS ) || defined ( OS2 )
String SbaDBDataDefDocSh::GetAPIName() const
{
	DBG_ERROR("ICC-Hack failed!");
	return String();
}
#endif


#if defined ( LINUX ) || defined ( SOLARIS ) || defined ( OS2 )
class SbaJoinTabWinData;
class SvStorage;

class SbaJoinDocShExt
{
	protected:
		virtual BOOL CheckTabWinData(const SbaJoinTabWinData* pData);

	public:
#ifndef SOLARIS
		virtual BOOL IsA( void*() ) const;
#else
		virtual BOOL IsA( TypeId ) const;
#endif
		virtual TypeId Type() const;

		virtual ~SbaJoinDocShExt();

		virtual BOOL InitNew(SvStorage *pStor);
		virtual BOOL ConvertFrom( SfxMedium& rMedium );

		virtual BOOL LoadData();
		virtual BOOL SaveData();

		virtual void LoadUI( SvStream& rStream );
		virtual void SaveUI( SvStream& rStream );
		virtual SbaJoinTabWinData* CreateTabWinDataObj();
};

#ifndef OS2

#ifndef SOLARIS
BOOL SbaJoinDocShExt::IsA(void*()) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#else
BOOL SbaJoinDocShExt::IsA(TypeId) const
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}
#endif

TypeId SbaJoinDocShExt::Type(void) const
{
	DBG_ERROR("ICC-Hack failed!");
	return TypeId();
}

#endif

SbaJoinDocShExt::~SbaJoinDocShExt()
{
	DBG_ERROR("ICC-Hack failed!");
}

#ifndef OS2

BOOL SbaJoinDocShExt::CheckTabWinData(const SbaJoinTabWinData* pData)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaJoinDocShExt::InitNew(SvStorage *pStor)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaJoinDocShExt::ConvertFrom( SfxMedium& rMedium )
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}


BOOL SbaJoinDocShExt::LoadData(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

BOOL SbaJoinDocShExt::SaveData(void)
{
	DBG_ERROR("ICC-Hack failed!");
	return FALSE;
}

void SbaJoinDocShExt::LoadUI(SvStream&)
{
	DBG_ERROR("ICC-Hack failed!");
}

void SbaJoinDocShExt::SaveUI(SvStream&)
{
	DBG_ERROR("ICC-Hack failed!");
}

SbaJoinTabWinData* SbaJoinDocShExt::CreateTabWinDataObj()
{
	DBG_ERROR("ICC-Hack failed!");
	return NULL;
}

#endif	// OS2

class SbaQueryDocSh
{
	public:
		void LoadUI( SvStream& rStream );
		void SaveUI( SvStream& rStream );
};

void SbaQueryDocSh::LoadUI( SvStream& rStream )
{
	DBG_ERROR("ICC-Hack failed!");
}

void SbaQueryDocSh::SaveUI( SvStream& rStream )
{
	DBG_ERROR("ICC-Hack failed!");
}
#endif

#if defined (GCC)
class SdbStringMap
{
	virtual dummy() {};
};
#endif

class SbaSqlDlg
{
	virtual ~SbaSqlDlg();
};

SbaSqlDlg::~SbaSqlDlg()
{
	DBG_ERROR("ICC-Hack failed!");
}

