/*************************************************************************
 *
 *  $RCSfile: dshelper.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:26:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DSHELPER_HXX
#include <dshelper.hxx>
#endif

#ifndef _COM_SUN_STAR_SDB_XDATABASEENVIRONMENT_HPP_
#include <com/sun/star/sdb/XDatabaseEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEACCESS_HPP_
#include <com/sun/star/sdb/XDatabaseAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XCONNECTION_HPP_
#include <com/sun/star/sdbc/XConnection.hpp>
#endif

#ifndef _SBA_SBADB_HXX
#include <sbadb.hxx>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

//------------------------------------------------------------------------------
SbaXFileDefHelper::SbaXFileDefHelper(const ::com::sun::star::uno::Reference< ::com::sun::star::container::XChild > & xModel, const SbaDatabaseRef& xDb)
{
	if (xModel.is() && xDb.Is())
	{
		try
		{
			::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment >  xEnv(::utl::getProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseEnvironment")), ::com::sun::star::uno::UNO_QUERY);
			if (xEnv.is())
			{
				::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  xDatabaseAccess = xEnv->getDatabaseAccess(UniString(xDb->Name()));
				::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XConnection >  xConn = xDatabaseAccess->getConnection(::rtl::OUString(),::rtl::OUString());
				if (xConn.is())
				{
					xModel->setParent(xConn);
					m_xModel = xModel;
				}
			}
		}
		catch(...)
		{
		}
	}
}

// ::com::sun::star::lang::XEventListener
//------------------------------------------------------------------------
void SAL_CALL SbaXFileDefHelper::disposing(const ::com::sun::star::lang::EventObject& e) throw( ::com::sun::star::uno::RuntimeException )
{
	dispose();
}

//------------------------------------------------------------------------
void SbaXFileDefHelper::dispose()
{
	if (m_xModel.is())
	{
		m_xModel->setParent(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > ());
		m_xModel = NULL;
	}
}



