/*************************************************************************
 *
 *  $RCSfile: sbavs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:26:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_SBAVS_HXX
#include "sbavs.hxx"
#endif
#ifndef _SBA_SBADS_HXX
#include "sbads.hxx"
#endif

#ifndef _SV_SVAPP_HXX //autogen wg. GetpApp
#include <vcl/svapp.hxx>
#endif

#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFXEVENT_HXX //autogen
#include <sfx2/event.hxx>
#endif

#ifndef _SFX_HRC
#include <sfx2/sfx.hrc>
#endif

//==================================================================
TYPEINIT1(SbaDBDataDefViewSh, SfxViewShell)
//------------------------------------------------------------------------------
SbaDBDataDefViewSh::SbaDBDataDefViewSh(SfxViewFrame *pFrame)
				   :SfxViewShell(pFrame, SFX_VIEW_MAXIMIZE_FIRST)
{
	// damit Drop nicht geht ????
	pFrame->GetWindow().EnableDrop();
	SetName( String::CreateFromAscii("View") );

	_pSh = (SbaDBDataDefDocSh*)pFrame->GetObjectShell();
}

//==================================================================
#define FRAME_FLAGS	SFX_VIEW_MAXIMIZE_FIRST | SFX_VIEW_IMPLEMENTED_AS_FRAMESET

TYPEINIT1(SbaFileDefViewSh, SfxFrameSetViewShell)
//==================================================================
//------------------------------------------------------------------------------
SbaFileDefViewSh::SbaFileDefViewSh(SfxViewFrame *pFrame)
				 :SfxFrameSetViewShell(pFrame, NULL, FRAME_FLAGS)
{
	// damit Drop nicht geht ????
	pFrame->GetWindow().EnableDrop();
	SetName( String::CreateFromAscii("View") );
	_pSh = (SbaFileDefDocSh*)pFrame->GetObjectShell();
}

//------------------------------------------------------------------------------
void SbaFileDefViewSh::InnerResizePixel(const Point& rOfs,
										const Size& rSize)
{
	SetBorderPixel( SvBorder() );
}

//------------------------------------------------------------------------------
void SbaFileDefViewSh::OuterResizePixel(const Point& rOfs,
										const Size& rSize)
{
	SetBorderPixel( SvBorder() );
}

//------------------------------------------------------------------------------
SfxObjectShell*	SbaFileDefViewSh::GetFileShell() const
{
	SfxFrame* pFileFrm = GetViewFrame()->SearchFrame(_pSh->GetFileFrameName());

	return (pFileFrm && pFileFrm->GetCurrentViewFrame())
		? pFileFrm->GetCurrentViewFrame()->GetObjectShell() : NULL;
}

//------------------------------------------------------------------------------
void SbaFileDefViewSh::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
	SfxEventHint* pEventHint = PTR_CAST(SfxEventHint, &rHint);
	if (pEventHint)

	switch (pEventHint->GetEventId())
	{
		case SFX_EVENT_LOADFINISHED:
		{
			// FS - 28.04.99 - 65471 : nach dem Laden das Modified-Flag von meiner inneren
			// Shell uebernehmen
			// eigentlich sollte sowas natuerlich in's Dokument, aber das bekommt leider das
			// Ende des Ladens nicht mit : FinishedLoading ist nicht virtuell, also muesste
			// das Dok sich als Listener an sich selber anmelden ....
			SfxObjectShell* pFileSh = GetFileShell();
			if (pFileSh)
				GetShell()->SetModified(pFileSh->IsModified());
		}
		break;
		case SFX_EVENT_MODIFYCHANGED:
		{
			SfxObjectShell* pFileSh = GetFileShell();
			if (pFileSh && (pEventHint->GetObjShell() == pFileSh))
				GetShell()->SetModified(pFileSh->IsModified());
		}	break;
		case SFX_EVENT_OPENDOC:
		{
			SfxObjectShell* pFileSh = GetFileShell();
			if (pFileSh == pEventHint->GetObjShell())
				pFileSh->SetTitle(GetShell()->GetDocTitle(sal_False));
		}	break;
		case SFX_EVENT_CREATEDOC:
		{
			// Event wird mehrfach ausgefuehrt
			SfxObjectShell* pFileSh = GetFileShell();
			if	(	pFileSh == pEventHint->GetObjShell()
				&&	!pFileSh->GetTitle().Equals(GetShell()->GetDocTitle(sal_False))
				)
				pFileSh->SetTitle(GetShell()->GetDocTitle(sal_False));
		}	break;
	}
	SfxFrameSetViewShell::Notify( rBC, rHint);
}

//------------------------------------------------------------------------------
void SbaFileDefViewSh::ParentActivate()
{
	_pSh->ViewActivate(this);
}

//==================================================================
//	FrameWindow for Views which allow a shell switch via a tabbar
//==================================================================

//------------------------------------------------------------------------------
SbaViewSwitchFrame::SbaViewSwitchFrame(Window* pParent, SbaDBDataDef* pDef, SbaDBDataDefViewSh* pView)
	:Window(pParent)
	,m_aTabBar(this, WB_STDTABBAR | WB_3DLOOK)
	,m_pView(pView)
	,m_pDefinition(pDef)
	,m_pMainWin(NULL)	// to be initialized in derived classes
	,m_pViewSwitchAccel(NULL)
{
	// set color 'n font
	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();

	if( IsControlBackground() )
		SetBackground( rStyleSettings.GetFaceColor() );
	else
		SetBackground( rStyleSettings.GetFaceColor() );

	Font aFont = rStyleSettings.GetAppFont();
	if (IsControlFont())
		aFont.Merge(GetControlFont());
	SetPointFont(aFont);

	// the only thing we can do for the bar bar here : set the handler
	m_aTabBar.SetSelectHdl(LINK(this, SbaViewSwitchFrame, OnTabBarSelect));
}

//------------------------------------------------------------------------------
SbaViewSwitchFrame::~SbaViewSwitchFrame()
{
	delete m_pMainWin;
	m_pMainWin = NULL;

	if (m_pViewSwitchAccel)
	{
		GetpApp()->RemoveAccel( m_pViewSwitchAccel );
		delete m_pViewSwitchAccel;
		m_pViewSwitchAccel = NULL;
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaViewSwitchFrame, OnTabBarSelect, TabBar*, pTabBar)
{
	DBG_ASSERT(pTabBar == &m_aTabBar, "SbaTableDesignFrame::OnTabBarSelect : where did this call come frome ?");

	TabSelected(pTabBar->GetCurPageId());
	return 0L;
}

//------------------------------------------------------------------------------
void SbaViewSwitchFrame::Paint(const Rectangle& rRect)
{
	// draw a border around our "main child"
	Point aChildPos = m_pMainWin->GetPosPixel();
	Size aChildSize = m_pMainWin->GetSizePixel();

	Point aUpperLeft(aChildPos);
	Point aUpperRight(aChildPos + Point(aChildSize.Width(), 0));
	Point aLowerLeft(aChildPos + Point(0, aChildSize.Height()));
	Point aLowerRight(aUpperRight.X(), aLowerLeft.Y());

	long nTabBarHeight = m_aTabBar.GetSizePixel().Height();
	aUpperLeft += Point(-1, -1);
	aUpperRight += Point(0, -1);
	aLowerLeft += Point(-1, 0);
	aLowerRight += Point(0, 0);

	// the tab bar is placed below the main win and draws a dark shadow color at it's top, so we have to handle
	// only three sides
	SetLineColor( GetSettings().GetStyleSettings().GetDarkShadowColor() );
	DrawLine( aLowerLeft, aUpperLeft);
	DrawLine( aUpperLeft, aUpperRight);
	DrawLine( aUpperRight, aLowerRight);
}

//------------------------------------------------------------------------------
void SbaViewSwitchFrame::Resize()
{
	Size aSize = GetOutputSizePixel();
	// work with a 5-point-margin
	aSize.Width() -= 10;
	aSize.Height() -= 10;

	// the tab bar's space
	long nTabBarHeight = m_aTabBar.GetSizePixel().Height();
	aSize.Height() -= nTabBarHeight;
	m_pMainWin->SetPosSizePixel(Point(5, 5), aSize);

	// position the tab bar
	m_aTabBar.SetPosSizePixel(Point(4, aSize.Height() + 5), Size(aSize.Width() + 2, nTabBarHeight));

	// as we don't erase our background in Paint we let the Invalidate do it here
	Invalidate(INVALIDATE_CHILDREN);
}

//------------------------------------------------------------------------------
void SbaViewSwitchFrame::EnableAccelSwitch(sal_Bool bEnable)
{
	if (bEnable && !m_pViewSwitchAccel)
	{
		m_pViewSwitchAccel = new Accelerator();
		m_pViewSwitchAccel->InsertItem( 1, KeyCode( KEY_PAGEUP, KEY_MOD1) );
		m_pViewSwitchAccel->InsertItem( 2, KeyCode( KEY_PAGEDOWN, KEY_MOD1) );
		m_pViewSwitchAccel->InsertItem( 3, KeyCode( KEY_1, KEY_MOD1) );
		m_pViewSwitchAccel->InsertItem( 4, KeyCode( KEY_2, KEY_MOD1) );
		m_pViewSwitchAccel->InsertItem( 5, KeyCode( KEY_3, KEY_MOD1) );

		GetpApp()->InsertAccel( m_pViewSwitchAccel );
		m_pViewSwitchAccel->SetSelectHdl( LINK(this, SbaViewSwitchFrame, OnAccelerator) );
	}
	else if (!bEnable && m_pViewSwitchAccel)
	{
		GetpApp()->RemoveAccel( m_pViewSwitchAccel );
		delete m_pViewSwitchAccel;
		m_pViewSwitchAccel = NULL;
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaViewSwitchFrame, OnAccelerator, Accelerator*, pAccel)
{
	sal_uInt16 nCurPos = m_aTabBar.GetPagePos(m_aTabBar.GetCurPageId());

	// select the page to the left (or right) to the current
	sal_uInt16 nNextPos = nCurPos;
	switch (pAccel->GetCurItemId())
	{
		case 1: nNextPos = nCurPos == 0 ? m_aTabBar.GetPageCount() - 1 : nCurPos - 1; break;
		case 2: nNextPos = nCurPos == m_aTabBar.GetPageCount() - 1 ? 0 : nCurPos + 1; break;
		default:
			// other valid id's : 3,4,5
			nNextPos = pAccel->GetCurItemId() - 3;
			if (nNextPos > m_aTabBar.GetPageCount() - 1)
				return 0L;
			break;
	}

	if (nCurPos == nNextPos)
		return 0L;

	m_aTabBar.SetCurPageId(m_aTabBar.GetPageId(nNextPos));
	m_aTabBar.Select();		// call explicitly as the upper SelectPage is no user interaction

	return 0L;
}

