/*************************************************************************
 *
 *  $RCSfile: DatabaseNamesPage.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_API_HRC
#include "api.hrc"
#endif
#ifndef _VCL_STDTEXT_HXX
#include <vcl/stdtext.hxx>
#endif
#ifndef _BASEDLGS_HXX
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SBA_API_HXX
#include "api.hxx"
#endif
#ifndef _SBA_DATABASE_NAMES_PAGE_HXX_
#include "DatabaseNamesPage.hxx"
#endif
#ifndef _SBA_DATABASE_NAMES_PAGE_HRC_
#include "DatabaseNamesPage.hrc"
#endif
#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SVX_DBBROWSE_HXX
#include <svx/dbbrowse.hxx>
#endif
#ifndef _SVX_LANGTAB_HXX
#include <svx/langtab.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SBA_OPTION_ITEMS_HXX_
#include "OptionItems.hxx"
#endif
#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _COM_SUN_STAR_SDB_XDATABASEENVIRONMENT_HPP_
#include <com/sun/star/sdb/XDatabaseEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _SVX_DBERRBOX_HXX
#include <svx/dbmsgbox.hxx>
#endif
#ifndef _COM_SUN_STAR_SDB_SQLCONTEXT_HPP_
#include <com/sun/star/sdb/SQLContext.hpp>
#endif
#ifndef _SFXFILEDLG_HXX
#include <sfx2/iodlg.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif


//==============================================================================
class SbaEditDbNameControl : public DbBrowseBox
{
	::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases > 				m_xContext;
	::com::sun::star::lang::Locale								m_aCurrentLocale;
	::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair>		m_aCurrentNames;

	long					m_nSeekRow;
	long					m_nEditRow;
	Edit*					m_pNameEdit;

	sal_Bool					m_bInserting;

private:
	void implInsert();
	void implModify(long _nRow);
	void implDelete(long _nRow);
	void implChooseUrl(long _nRow);

	void implCancelEditName();

public:
	SbaEditDbNameControl(SbaDatabaseNamesTabPage* _pParent, const ResId& _rRes);
	virtual ~SbaEditDbNameControl();

	virtual void Init(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases > & _rxContext);

	void Update(LanguageType _nLang);

	long GetRowCount() const { return DbBrowseBox::GetRowCount(); }

	void InsertNew() { implInsert(); }
	void ModifyCurrent() { implModify(GetCurRow()); }
	void DeleteCurrent() { implDelete(GetCurRow()); }
	void ChooseURLCurrent() { implChooseUrl(GetCurRow()); }

	// valid while editing a name
	sal_Bool Commit();

protected:
	virtual void KeyInput( const KeyEvent& rKEvt );
	virtual void Command(const CommandEvent& rCEvt);
	virtual long PreNotify(NotifyEvent& rNEvt);
	virtual void MouseButtonDown(const BrowserMouseEvent& rEvt);

	virtual sal_Bool CursorMoving(long nNewRow, sal_uInt16 nNewCol);
	virtual void InitController( DbCellControllerRef& rController, long nRow, sal_uInt16 nCol );
	virtual DbCellController* GetController( long nRow, sal_uInt16 nCol );

	virtual void PaintCell( OutputDevice& rDev, const Rectangle& rRect, sal_uInt16 nColId ) const;

	virtual sal_Bool SeekRow( long nRow );
	virtual sal_Bool SaveModified();

	virtual sal_Bool IsTabAllowed(sal_Bool bForward) const;
	virtual sal_uInt32 GetTotalCellWidth(long nRow, sal_uInt16 nColId);
	virtual String GetCellText( long nRow, sal_uInt16 nColId ) const;

	virtual void CellModified();

private:
	void implUpdate(const ::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair>& _rNames);

	DECL_LINK(OnAsyncCursorMove, void*);
};

//------------------------------------------------------------------------------
SbaEditDbNameControl::SbaEditDbNameControl(SbaDatabaseNamesTabPage* _pParent, const ResId& _rRes)
	:DbBrowseBox(_pParent, _rRes, DBBF_NOROWPICTURE,
//			BROWSER_AUTO_VSCROLL | BROWSER_AUTO_HSCROLL | BROWSER_COLUMNSELECTION | BROWSER_HLINESFULL | BROWSER_VLINESFULL | BROWSER_HIDESELECT | BROWSER_CURSOR_WO_FOCUS)
			BROWSER_AUTO_VSCROLL | BROWSER_AUTO_HSCROLL | BROWSER_HIDECURSOR | BROWSER_AUTOSIZE_LASTCOL)
	,m_nSeekRow(-1)
	,m_nEditRow(-1)
	,m_pNameEdit(NULL)
	,m_bInserting(sal_False)
{
	SetStyle((GetStyle() & ~WB_HSCROLL) | WB_AUTOHSCROLL);
}

//------------------------------------------------------------------------------
SbaEditDbNameControl::~SbaEditDbNameControl()
{
	delete m_pNameEdit;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::Init(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases > & _rxContext)
{
	DbBrowseBox::Init();

	m_xContext = _rxContext;
	DBG_ASSERT(m_xContext.is(), "SbaEditDbNameControl::Init : invalid context !");

	Size aColWidth = LogicToPixel(Size(60, 0), MAP_APPFONT);
	InsertDataColumn(1, String(ResId(STR_COLUMNTITLE)), aColWidth.Width());
	aColWidth = LogicToPixel(Size(160, 0), MAP_APPFONT);
	InsertDataColumn(2, String(ResId(STR_COLUMNURL)), aColWidth.Width());
		// use ResId instead of SbaResId : the resources are local to the main dialog resource

	m_pNameEdit = new Edit(&GetDataWindow(), 0);

	ActivateCell(1, 0);
}

//------------------------------------------------------------------------------
sal_Bool SbaEditDbNameControl::Commit()
{
	if (!IsEditing())
		return sal_True;
	if (!IsModified())
		return sal_True;

	return SaveModified();
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::Update(LanguageType _nLang)
{
	::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair> aNames;
	m_aCurrentLocale = ::com::sun::star::lang::Locale();
	if (m_xContext.is())
	{
		try
		{
			::com::sun::star::lang::Locale aSelectedLocale;;
			String sLanguage, sCountry;
			ConvertLanguageToIsoNames(_nLang, sLanguage, sCountry);
			aSelectedLocale.Language = sLanguage;
			aSelectedLocale.Country = sCountry;
			aNames = m_xContext->listAliases(aSelectedLocale);
			m_aCurrentLocale = aSelectedLocale;
		}
		catch(...)
		{
		}
		
	}
	implUpdate(aNames);
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implInsert()
{
	::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment >  xEnv(::utl::getProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.sdb.DatabaseEnvironment")), ::com::sun::star::uno::UNO_QUERY);
	if (!xEnv.is())
	{
		ShowServiceNotAvailableError(GetpApp()->GetDefDialogParent(), String::CreateFromAscii("com.sun.star.sdb.DatabaseEnvironment"), sal_True);
		return;
	}

	// first let the user choose an sdb file
	SfxFileDialog aChoose(GetParent(), WB_3DLOOK);
	aChoose.AddFilter(String(SbaResId(RID_STR_SDBFILE_DESCRIPTION)), String::CreateFromAscii("*.sdb"));
	aChoose.SetPath(SBA_MOD()->GetDatabasePath());
	if (aChoose.Execute() != RET_OK)
	{
		GrabFocus();
		return;
	}

	String sFile = aChoose.GetPath();
	// now calc a default title for that database
	::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  xDB;
	try { xDB = xEnv->getDatabaseAccess(sFile); } catch(::com::sun::star::sdbc::SQLException& e) { e; } 

	UniString sDefaultTitle;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xDBProps(xDB, ::com::sun::star::uno::UNO_QUERY);
	if (xDBProps.is())
	{
		try { sDefaultTitle = ::utl::getString(xDBProps->getPropertyValue(PROPERTY_TITLE)).getStr(); } catch(...) { } 
	}
	if (!sDefaultTitle.Len())
	{
		DirEntry aFile(sFile);
		sDefaultTitle = aFile.GetBase();
	}

	// insert the paint into my own structures
	m_aCurrentNames.realloc(m_aCurrentNames.getLength() + 1);
	::com::sun::star::util::AliasProgrammaticPair* pNewPair = m_aCurrentNames.getArray() + m_aCurrentNames.getLength() - 1;
	pNewPair->Alias = sDefaultTitle;
	pNewPair->ProgrammaticName = getProgrammaticUrl(sFile);

	// insert one row and start editing
	RowInserted(GetRowCount(), 1);
	implModify(GetRowCount() - 1);
	if (Controller().Is())
		Controller()->SetModified();
	m_bInserting = sal_True;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implModify(long _nRow)
{
	DBG_ASSERT(!IsEditing(), "SbaEditDbNameControl::implModify : invalid call (already editing) !");

//	SetMode(GetMode() & ~BROWSER_CURSOR_WO_FOCUS);
	SetMode(GetMode() | BROWSER_HIDESELECT | BROWSER_COLUMNSELECTION);

	GoToRowColumnId(_nRow, 1);
	m_nEditRow = _nRow;
	ActivateCell();

	if (!HasChildPathFocus() && IsEditing())
		Controller()->GetWindow().GrabFocus();
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implDelete(long _nRow)
{
	::com::sun::star::util::AliasProgrammaticPair& rCurrentlyEditing = m_aCurrentNames.getArray()[_nRow];
	String sOldURL = getProgrammaticUrl(rCurrentlyEditing.ProgrammaticName);

	String sMessage(SbaResId(RID_STR_CONFIRM_DBNAME_DELETION));
	while (sMessage.SearchAndReplaceAscii("$url$", sOldURL) != STRING_NOTFOUND)
		;
	while (sMessage.SearchAndReplaceAscii("$name$", rCurrentlyEditing.Alias) != STRING_NOTFOUND)
		;
	if (WarningBox(GetParent(), WB_YES_NO, sMessage).Execute() != RET_YES)
	{
		GrabFocus();
		return;
	}

	sal_Bool bSuccess = sal_False;
	try
	{
		m_xContext->unbindAliases(rCurrentlyEditing.ProgrammaticName);
		bSuccess = sal_True;
	}
	catch(...)
	{
		DBG_ERROR("SbaEditDbNameControl::implDelete : something went wrong !");
	}
	

	if (bSuccess)
	{
		RowRemoved(_nRow);
		for (long i=_nRow; i<m_aCurrentNames.getLength() - 1; ++i)
			m_aCurrentNames.getArray()[i] = m_aCurrentNames.getArray()[i + 1];
		m_aCurrentNames.realloc(m_aCurrentNames.getLength() - 1);
	}
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implChooseUrl(long _nRow)
{
	::com::sun::star::util::AliasProgrammaticPair& rCurrentlyEditing = m_aCurrentNames.getArray()[_nRow];
	String sOldURL = getProgrammaticUrl(rCurrentlyEditing.ProgrammaticName);

	SfxFileDialog aChoose(GetParent(), WB_3DLOOK);
	aChoose.AddFilter(String(SbaResId(RID_STR_SDBFILE_DESCRIPTION)), String::CreateFromAscii("*.sdb"));
	aChoose.SetPath(sOldURL);
	if (aChoose.Execute() != RET_OK)
	{
		GrabFocus();
		return;
	}

	// normalize the URLs
	String sNewURL = getProgrammaticUrl(aChoose.GetPath());
	sal_Bool bSuccess = sal_False;
	::com::sun::star::sdbc::SQLException aError;
	try
	{
		m_xContext->rebindAliases(rCurrentlyEditing.ProgrammaticName, sNewURL);
		bSuccess = sal_True;
	}
	catch(::com::sun::star::container::ElementExistException e)
	{
		::com::sun::star::sdb::SQLContext aNamingConflictDetails;
		aNamingConflictDetails.Message = String(SbaResId(RID_STR_HADNAMINGCONFLICT));
		aNamingConflictDetails.Details = e.Message;
		aError.NextException <<= aNamingConflictDetails;
	}
	catch(...)
	{
		::com::sun::star::sdb::SQLContext aNamingConflictDetails;
		aNamingConflictDetails.Message = String(SbaResId(RID_STR_HADUNKNOWNERROR));
		aError.NextException <<= aNamingConflictDetails;
	}
	
	if (bSuccess)
	{
		rCurrentlyEditing.ProgrammaticName = getProgrammaticUrl(sNewURL);
		RowModified(_nRow);
	}
	else
	{
		if (!aError.Message.getLength())
			aError.Message = String(SbaResId(RID_STR_COULDNOTSET_SDBFILE));
		SvxDBMsgBox(this, aError).Execute();
		GrabFocus();
		return;
	}
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implCancelEditName()
{
	if (IsEditing())
		DeactivateCell();
	if (m_bInserting)
	{
		// the currently edited cell was a new "virtual" entry which hasn't an equivalent in the access context,
		// though we already inserted it into m_aCurrentNames
		DBG_ASSERT(m_nEditRow == GetRowCount() - 1, "SbaEditDbNameControl::implCancelEditName : inserted, but not the last row ?");
			// makes reallocation of m_aCurrentNames easier
		DBG_ASSERT(GetRowCount() == m_aCurrentNames.getLength(), "SbaEditDbNameControl::implCancelEditName : inconsistent !");
		m_aCurrentNames.realloc(m_aCurrentNames.getLength() - 1);
		RowRemoved(m_nEditRow);
		m_bInserting = sal_False;
	}

	SetMode(GetMode() & ~(BROWSER_HIDESELECT | BROWSER_COLUMNSELECTION));
//	SetMode(GetMode() | BROWSER_CURSOR_WO_FOCUS);
	m_nEditRow = -1;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::implUpdate(const ::com::sun::star::uno::Sequence< ::com::sun::star::util::AliasProgrammaticPair>& _rNames)
{
	RowRemoved(0, GetRowCount());
	if (_rNames.getLength())
		RowInserted(0, _rNames.getLength());

	m_aCurrentNames = _rNames;
	if (m_aCurrentNames.getLength())
		qsort(m_aCurrentNames.getArray(), m_aCurrentNames.getLength(), sizeof(::com::sun::star::util::AliasProgrammaticPair), AliasProgrammaticPairCompareByName);
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::KeyInput(const KeyEvent& rKEvt)
{
	sal_uInt16 nCode = rKEvt.GetKeyCode().GetCode();
	sal_Bool   bShift = rKEvt.GetKeyCode().IsShift();
	sal_Bool   bCtrl = rKEvt.GetKeyCode().IsMod1();

	switch (nCode)
	{
		case KEY_RETURN:
			if (!IsEditing())
			{	// return while not editing -> don't pass it to the DbBrowseBox (it will translate it
				// into a CursorRight-Dispatch)
				if (!bCtrl && !bShift && IsTabAllowed(sal_True))
				{
					BrowseBox::KeyInput(rKEvt);
					return;
				}
			}
			break;
	}
	DbBrowseBox::KeyInput(rKEvt);
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::Command(const CommandEvent& _rCEvt)
{
	sal_Bool bHandled = sal_False;
	switch (_rCEvt.GetCommand())
	{
		case COMMAND_CONTEXTMENU:
		{
			if (!m_xContext.is())
				// can't do anything without context
				break;
			long nRow = -1;
			sal_uInt16 nColId = 0;
			Point aWhere;
			if (_rCEvt.IsMouseEvent())
			{
				aWhere = _rCEvt.GetMousePosPixel();
				nRow = GetRowAtYPosPixel(aWhere.Y());
				nColId = GetColumnId(GetColumnAtXPosPixel(aWhere.X()));
			}
			else
			{	// context menu via keyboard -> assume the center of the currently active cell as location
				nRow = GetCurRow();
				nColId = GetCurColumnId();
				aWhere = GetCellRect(nRow, nColId).Center();
			}
			PopupMenu aContextMenu(SbaResId(RID_DBOPTIONS_DBNAMES_POPUP));
			aContextMenu.SetMenuFlags(aContextMenu.GetMenuFlags() | MENU_FLAG_HIDEDISABLEDENTRIES);
			if ((nRow < 0) || (nRow >= GetRowCount()) || (nColId < 1) || (nColId > 2))
			{	// invalid row or column -> no modify, no delete
				aContextMenu.EnableItem(CMD_MODIFY_DBNAME, sal_False);
				aContextMenu.EnableItem(CMD_DELETE_DBNAME, sal_False);
				aContextMenu.EnableItem(CMD_BROWSE_FOR_DB, sal_False);
			}
			if (IsEditing())
				// we're already editing ....
				aContextMenu.EnableItem(CMD_MODIFY_DBNAME, sal_False);

			bHandled = sal_True;
			switch (aContextMenu.Execute(this, aWhere))
			{
				case CMD_NEW_DBNAME:
					implInsert();
					break;
				case CMD_MODIFY_DBNAME:
					implModify(nRow);
					break;
				case CMD_DELETE_DBNAME:
					implDelete(nRow);
					break;
				case CMD_BROWSE_FOR_DB:
					implChooseUrl(nRow);
					break;
			}
		}
		break;
	}
	if (!bHandled)
		DbBrowseBox::Command(_rCEvt);
}

//------------------------------------------------------------------------------
long SbaEditDbNameControl::PreNotify(NotifyEvent& rNEvt)
{
	if (rNEvt.GetType() == EVENT_KEYINPUT)
	{
		const KeyEvent* pKeyEvent = rNEvt.GetKeyEvent();
		sal_uInt16 nKey = pKeyEvent->GetKeyCode().GetCode();
		sal_Bool bShift = pKeyEvent->GetKeyCode().IsShift();
		sal_Bool bCtrl = pKeyEvent->GetKeyCode().IsMod1();
		sal_Bool bAlt = pKeyEvent->GetKeyCode().IsMod2();
		switch (nKey)
		{
			case KEY_ESCAPE:
				if (IsEditing() && Controller()->GetWindow().HasChildPathFocus())
				{	// the user pressed escape while editing a title -> stop editing
					implCancelEditName();
					return 1;	// handled
				}
				break;
			case KEY_F2:
				if (!bShift && !bCtrl && !bAlt)
				{	// a simple F2
					if (!IsEditing() && HasChildPathFocus())
					{	// we're active and not editing
						long nRow = GetCurRow();
						if ((GetCurColumnId() == 1) && (nRow >= 0) && (nRow < GetRowCount()))
						{	// we're on a valid title cell
							// -> start editing the title
							implModify(nRow);
							return 1;	// handled
						}
					}
				}
				break;
			case KEY_RETURN:
				if (!IsEditing() && IsTabAllowed(sal_True))
				{	// return while not editing -> don't pass it to the DbBrowseBox (it will translate it
					// into a CursorRight-Dispatch)
					return BrowseBox::PreNotify(rNEvt);
				}
				break;
		}
	}

	return DbBrowseBox::PreNotify(rNEvt);
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::MouseButtonDown(const BrowserMouseEvent& _rEvt)
{
	if (_rEvt.GetClicks() > 1)
	{	// it's on a valid row ?
		long nRow = _rEvt.GetRow();
		if ((nRow >= 0) && (nRow < GetRowCount()))
		{
			switch (_rEvt.GetColumnId())
			{
				case 1:
				{	// in a name cell ? -> start editing
					implModify(nRow);
				}
				break;
				case 2:
				{
					implChooseUrl(nRow);
				}
				break;
			}
		}
	}

	DbBrowseBox::MouseButtonDown(_rEvt);
}

//------------------------------------------------------------------------------
sal_Bool SbaEditDbNameControl::CursorMoving(long nNewRow, sal_uInt16 nNewCol)
{
	if (!DbBrowseBox::CursorMoving(nNewRow, nNewCol))
		return sal_False;

	// if we leave a cell where the user is editing all further editing is deactivated ('til it's explicit activation)
	if (m_nEditRow != -1)	// we were editing the current cell
		implCancelEditName();
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaEditDbNameControl::SaveModified()
{
	DbCellControllerRef aCurrentController = Controller();
	DBG_ASSERT(aCurrentController.Is(), "SbaEditDbNameControl::SaveModified : invalid call (have no controller) !");
	if (!aCurrentController.Is())
		return sal_True;

	String sNewTitle = aCurrentController->GetWindow().GetText();
	if (m_xContext.is())
	{
		::com::sun::star::util::AliasProgrammaticPair& rCurrentlyEditing = m_aCurrentNames.getArray()[GetCurRow()];

		// try to register the context
		sal_Bool bSuccess = sal_False;
		::com::sun::star::sdbc::SQLException aError;
		try
		{
			if (m_bInserting)
				m_xContext->bindAlias(rCurrentlyEditing.ProgrammaticName, m_aCurrentLocale, sNewTitle);
			else
				m_xContext->renameAlias(m_aCurrentLocale, rCurrentlyEditing.Alias, sNewTitle);
			bSuccess = sal_True;
		}
		catch(::com::sun::star::container::ElementExistException e)
		{
			::com::sun::star::sdb::SQLContext aNamingConflictDetails;
			aNamingConflictDetails.Message = UniString(SbaResId(RID_STR_HADNAMINGCONFLICT));
			aNamingConflictDetails.Details = e.Message;
			aError.NextException <<= aNamingConflictDetails;
		}
		catch(...)
		{
			::com::sun::star::sdb::SQLContext aNamingConflictDetails;
			aNamingConflictDetails.Message = String(SbaResId(RID_STR_HADUNKNOWNERROR));
			aError.NextException <<= aNamingConflictDetails;
		}
		
		if (bSuccess)
		{	// update my names sequence
			rCurrentlyEditing.Alias = sNewTitle;
			aCurrentController->ClearModified();

			// resort our names array
			qsort(m_aCurrentNames.getArray(), m_aCurrentNames.getLength(), sizeof(::com::sun::star::util::AliasProgrammaticPair), AliasProgrammaticPairCompareByName);
			// and select the row we just modified (async)
			// for this we need the new row
			::com::sun::star::util::AliasProgrammaticPair aCompare(sNewTitle, ::rtl::OUString());
			::com::sun::star::util::AliasProgrammaticPair* pNewPos = (::com::sun::star::util::AliasProgrammaticPair*)bsearch(&aCompare, m_aCurrentNames.getConstArray(), m_aCurrentNames.getLength(), sizeof(::com::sun::star::util::AliasProgrammaticPair), AliasProgrammaticPairCompareByName);
			DBG_ASSERT(pNewPos != NULL, "SbaEditDbNameControl::SaveModified : why not found ?");
			long nCurRow = GetCurRow();
			long nNewRow = nCurRow;
			if (pNewPos)
				nNewRow = pNewPos - m_aCurrentNames.getConstArray();
			if (nNewRow != nCurRow)
				PostUserEvent(LINK(this, SbaEditDbNameControl, OnAsyncCursorMove), (void*)nNewRow);

			// invalidate all the affected rows
			if (nNewRow < nCurRow)
			{	// swap them
				nNewRow = nCurRow + nNewRow;
				nCurRow = nNewRow - nCurRow;
				nNewRow = nNewRow - nCurRow;
			}
			for (long i=nCurRow; i<=nNewRow; ++i)
				RowModified(i);

			SetMode(GetMode() & ~(BROWSER_HIDESELECT | BROWSER_COLUMNSELECTION));
//			SetMode(GetMode() | BROWSER_CURSOR_WO_FOCUS);

			// we're not inserting anymore
			m_bInserting = sal_False;
		}
		else
		{
			if (!aError.Message.getLength())
				aError.Message = String(SbaResId(RID_STR_COULDNOTSET_DBNAME));
			SvxDBMsgBox(this, aError).Execute();
			GrabFocus();
			return sal_False;
		}
	}
	return sal_True;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::InitController( DbCellControllerRef& rController, long nRow, sal_uInt16 nCol )
{
	rController->GetWindow().SetText(GetCellText(nRow, nCol));
}

//------------------------------------------------------------------------------
DbCellController* SbaEditDbNameControl::GetController( long nRow, sal_uInt16 nCol )
{
	if (m_xContext.is() && (nCol == 1) && (m_nEditRow == nRow))
		// only the name column may be edited
		return new DbEditCellController(m_pNameEdit);
	return NULL;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::PaintCell( OutputDevice& rDev, const Rectangle& rRect, sal_uInt16 nColId ) const
{
	String sText;
	rDev.SetClipRegion(rRect);
	rDev.DrawText(rRect, GetCellText(m_nSeekRow, nColId));
	rDev.SetClipRegion();
}

//------------------------------------------------------------------------------
sal_Bool SbaEditDbNameControl::SeekRow( long nRow )
{
	DbBrowseBox::SeekRow(nRow);
	m_nSeekRow = nRow;
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaEditDbNameControl::IsTabAllowed(sal_Bool bForward) const
{
	long nRow = GetCurRow();
	sal_uInt16 nCol = GetCurColumnId();

	if (bForward && (nCol == 2) && (nRow == GetRowCount() - 1))
		return sal_False;

	if (!bForward && (nCol == 1) && (nRow == 0))
		return sal_False;

	return DbBrowseBox::IsTabAllowed(bForward);
}

//------------------------------------------------------------------------------
sal_uInt32 SbaEditDbNameControl::GetTotalCellWidth(long nRow, sal_uInt16 nColId)
{
	return GetDataWindow().GetTextWidth(GetCellText(nRow, nColId));
}

//------------------------------------------------------------------------------
String SbaEditDbNameControl::GetCellText(long nRow, sal_uInt16 nColId) const
{
	String sReturn;
	if (nRow < m_aCurrentNames.getLength())
	{
		const ::com::sun::star::util::AliasProgrammaticPair& rThisLine = m_aCurrentNames.getConstArray()[nRow];
		sReturn = (const sal_Unicode*)(nColId == 1 ? rThisLine.Alias : rThisLine.ProgrammaticName);
	}
	return sReturn;
}

//------------------------------------------------------------------------------
void SbaEditDbNameControl::CellModified()
{
	DbBrowseBox::CellModified();
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaEditDbNameControl, OnAsyncCursorMove, void*, _pRow)
{
	long nRow = (long)_pRow;
	GoToRowColumnId(nRow, 1);
	return 0L;
}

//==============================================================================
//------------------------------------------------------------------------------
SbaDatabaseNamesTabPage::SbaDatabaseNamesTabPage(Window* pParent, const SfxItemSet& rSet)
	:SfxTabPage(pParent, SbaResId(TAB_OPTIONS_DBNAMES), rSet)
	,m_aFrame			(this, ResId(GB_MAINFRAME))
	,m_aLanguageLabel	(this, ResId(FT_LANGLABEL))
	,m_aLanguages		(this, ResId(LB_LANGUAGES))
	,m_aAppLang			(this, ResId(FT_CURRENTAPPLANG))
	,m_pEditor			(new SbaEditDbNameControl(this, ResId(CTRL_ASSIGMENT)))
	,m_aCommands		(this, ResId(1))
	,m_pCommandsMenu(NULL)
{
	m_aLanguages.SetDropDownLineCount(8);

	m_aLanguages.SetSelectHdl(LINK(this, SbaDatabaseNamesTabPage, OnLanguageSelected));

	// get the ::com::sun::star::sdb::DatabaseAccessContext we're working with
	SFX_ITEMSET_GET(rSet, pNames, SbaDatabaseNamesItem, SID_SBA_DATABASENAMES, sal_True);
	::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases >  xContext;
	if (pNames)
		xContext = pNames->getAliases();

	m_pEditor->Init(xContext);
	m_pEditor->Show();

	sal_uInt16 nLangCount = International::GetAvailableFormatCount();
	SvxLanguageTable aLangNames;
	for (sal_uInt16 j=0; j<nLangCount; ++j)
	{
		LanguageType eLang = International::GetAvailableFormat(j);
		if (LANGUAGE_SYSTEM != eLang)
			m_aLanguages.InsertEntry(aLangNames.GetString(eLang));
	}
	LanguageType aAppLang = Application::GetAppInternational().GetLanguage();
	String sAppLang = aLangNames.GetString(aAppLang);
	m_aLanguages.SelectEntry(sAppLang);
	LINK(this, SbaDatabaseNamesTabPage, OnLanguageSelected).Call(&m_aLanguages);

	String sAppLangLabel(ResId(STR_CURRENTAPPLANG));
	sAppLangLabel.SearchAndReplaceAscii("$lang$", sAppLang);
	m_aAppLang.SetText(sAppLangLabel);

	FreeResource();

	m_pCommandsMenu = new PopupMenu(SbaResId(RID_DBOPTIONS_DBNAMES_POPUP));
	m_pCommandsMenu->SetMenuFlags(m_pCommandsMenu->GetMenuFlags() | MENU_FLAG_HIDEDISABLEDENTRIES);
	m_aCommands.SetPopupMenu(m_pCommandsMenu);
	m_aCommands.SetActivateHdl(LINK(this, SbaDatabaseNamesTabPage, OnCommandsActivate));
	m_aCommands.SetSelectHdl(LINK(this, SbaDatabaseNamesTabPage, OnCommandsSelected));

	if (HasChildPathFocus())
		m_pEditor->GrabFocus();

	SetExchangeSupport(sal_True);
		// want to get an DeactivatePage
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaDatabaseNamesTabPage, OnLanguageSelected, void*, EMPTYARG)
{
	SvxLanguageTable aAvailLangauges;
	m_pEditor->Update(aAvailLangauges.GetType(m_aLanguages.GetSelectEntry()));

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaDatabaseNamesTabPage, OnCommandsActivate, void*, EMPTYARG)
{
	PopupMenu* pUpcomingMenu = m_aCommands.GetPopupMenu();

	long nRow = m_pEditor->GetCurRow();
	sal_uInt16 nColId = m_pEditor->GetCurColumnId();

	sal_Bool bAlloweDelete = ((nRow >= 0) && (nRow < m_pEditor->GetRowCount()) && (nColId >= 1) && (nColId <= 2));
	sal_Bool bAllowModify = bAlloweDelete && !m_pEditor->IsEditing();
	pUpcomingMenu->EnableItem(CMD_MODIFY_DBNAME, bAlloweDelete);
	pUpcomingMenu->EnableItem(CMD_DELETE_DBNAME, bAllowModify);
	pUpcomingMenu->EnableItem(CMD_BROWSE_FOR_DB, bAllowModify);
	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaDatabaseNamesTabPage, OnCommandsSelected, void*, EMPTYARG)
{
	PopupMenu* pMenuExecuted = m_aCommands.GetPopupMenu();
	switch (pMenuExecuted->GetCurItemId())
	{
		case CMD_NEW_DBNAME:
			m_pEditor->InsertNew();
			break;
		case CMD_MODIFY_DBNAME:
			m_pEditor->ModifyCurrent();
			m_pEditor->GrabFocus();
			break;
		case CMD_DELETE_DBNAME:
			m_pEditor->DeleteCurrent();
			break;
		case CMD_BROWSE_FOR_DB:
			m_pEditor->ChooseURLCurrent();
			break;
		default:
			DBG_ERROR("SbaDatabaseNamesTabPage::OnCommandsSelected : selected what ?");
	}
	return 0L;
}

//------------------------------------------------------------------------------
SbaDatabaseNamesTabPage::~SbaDatabaseNamesTabPage()
{
	delete m_pEditor;
	delete m_pCommandsMenu;
}

//------------------------------------------------------------------------------
SfxTabPage*	SbaDatabaseNamesTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
{
	return new SbaDatabaseNamesTabPage(pParent, rAttrSet);
}

//------------------------------------------------------------------------------
sal_Bool SbaDatabaseNamesTabPage::FillItemSet( SfxItemSet& rSet )
{
	return sal_False;
}

//------------------------------------------------------------------------------
int SbaDatabaseNamesTabPage::DeactivatePage( SfxItemSet* pSet )
{
	if (!m_pEditor->Commit())
		return SfxTabPage::KEEP_PAGE;
	return SfxTabPage::DeactivatePage(pSet);
}

//------------------------------------------------------------------------------
void SbaDatabaseNamesTabPage::Reset( const SfxItemSet& rSet )
{
}

//==============================================================================
//==============================================================================
NameConflictDialog::NameConflictDialog(Window* _pParent, const String& _rInitialTitle, const String& _rUrl, sal_Bool _bUrgent)
	:ModalDialog(_pParent, SbaResId(DLG_NAMINCONFLICT))
	,m_aDescription		(this, ResId(FT_DESCRIPTION))
	,m_aFrame			(this, ResId(GB_NCFRAME))
	,m_aInputRequest	(this, ResId(FT_INPUTREQUEST))
	,m_aURLLabel		(this, ResId(FT_URLLABEL))
	,m_aURL				(this, ResId(FT_URL))
	,m_aTitleLabel		(this, ResId(FT_TITLELABEL))
	,m_aTitle			(this, ResId(ET_TITLE))
	,m_aAdministration	(this, ResId(PB_ADMINISTRATION))
	,m_aOK				(this, ResId(BT_OK))
	,m_aCancel			(this, ResId(BT_CANCEL))
{
	String sDescription(_bUrgent ? ResId(STR_NAMEISREQUIRED) : ResId(STR_SHOULDHAVEANAME));
	while (sDescription.SearchAndReplaceAscii("$title$", _rInitialTitle) != STRING_NOTFOUND)
		;
	m_aDescription.SetText(sDescription);

	String sInputRequest(_bUrgent ? ResId(STR_REQUEST_URGENT) : ResId(STR_REQUEST_STANDARD));
	m_aInputRequest.SetText(sInputRequest);

	m_aURL.SetText(_rUrl);
	m_aTitle.SetText(_rInitialTitle);

	m_aAdministration.SetClickHdl(LINK(this, NameConflictDialog, OnAdministrationClicked));
	m_aOK.SetClickHdl(LINK(this, NameConflictDialog, OnOkClicked));

	m_sURL = getProgrammaticUrl(_rUrl);
	FreeResource();
}

//------------------------------------------------------------------------------
IMPL_LINK(NameConflictDialog, OnAdministrationClicked, void*, EMPTYARG)
{
	// create an itemset (with the pool of the SbaObject)
	SfxItemSet* pItems = new SfxItemSet(SBA_MOD()->GetPool(), SID_SBA_DATABASENAMES, SID_SBA_OPTIONS_RESERVED_7, 0L);

	SbaDatabaseNamesItem* pOptions = new SbaDatabaseNamesItem(SID_SBA_DATABASENAMES, m_xContext);
	pItems->Put(*pOptions);

	SfxSingleTabDialog aAdministration(this, *pItems, 0);
	aAdministration.SetTabPage(new SbaDatabaseNamesTabPage(&aAdministration, *pItems));

	short nResult = aAdministration.Execute();
	m_aTitle.GrabFocus();
	if (nResult != RET_OK)
		return 0L;

	// check if we have a new name for the url
	String sTitle;
	try
	{
		sTitle = (const sal_Unicode*)m_xContext->lookupProgrammatic(m_aLocale, m_sURL);
	}
	catch(...)
	{
	}
	
	if (sTitle.Len())
	{	// yes, we have
		// ->outta here (that's all we existed for)
		m_sTitle = sTitle;
		EndDialog(RET_OK);
	}
	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(NameConflictDialog, OnOkClicked, void*, EMPTYARG)
{
	// try to set the new title
	m_sTitle = m_aTitle.GetText();

	::com::sun::star::sdbc::SQLException aError;
	sal_Bool bSuccess = sal_False;
	try
	{
		m_xContext->bindAlias(m_sURL, m_aLocale, m_sTitle);
		bSuccess = sal_True;
	}
	catch(::com::sun::star::container::ElementExistException e)
	{
		::com::sun::star::sdb::SQLContext aNamingConflictDetails;
		aNamingConflictDetails.Message = String(SbaResId(RID_STR_HADNAMINGCONFLICT));
		aNamingConflictDetails.Details = e.Message;
		aError.NextException <<= aNamingConflictDetails;
	}
	catch(...)
	{
		::com::sun::star::sdb::SQLContext aNamingConflictDetails;
		aNamingConflictDetails.Message = String(SbaResId(RID_STR_HADUNKNOWNERROR));
		aError.NextException <<= aNamingConflictDetails;
	}
	
	if (!bSuccess)
	{
		if (!aError.Message.getLength())
			aError.Message = String(SbaResId(RID_STR_COULDNOTSET_DBNAME));
		SvxDBMsgBox(this, aError).Execute();
		m_aTitle.GrabFocus();
		return 0L;
	}

	EndDialog(RET_OK);
	return 0L;
}
