/*************************************************************************
 *
 *  $RCSfile: adanewdb.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef SBA_ADANEWDB_HXX
#include "adanewdb.hxx"
#endif
#ifndef SBA_ADANEWDB_HRC
#include "adanewdb.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SFXFILEDLG_HXX
#include <sfx2/iodlg.hxx>
#endif
#ifndef _SFXINIPROP_HXX
#include <svtools/iniprop.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _PASSWD_HXX //autogen
#include <sfx2/passwd.hxx>
#endif
#ifndef _SBA_DLGERR_HXX
#include <dlgerr.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _FSYS_HXX
#include <tools/fsys.hxx>
#endif
#ifndef _BIGINT_HXX
#include <tools/bigint.hxx>
#endif
#ifndef _SBA_INIWRAP_HXX
#include "iniwrap.hxx"
#endif

DBG_NAME( SbaAdabasNewDbPage );
//========================================================================
SbaAdabasNewDbPage::SbaAdabasNewDbPage( Window* pParent,const String& _DbName,sal_Bool _bRestore):
	ModalDialog( pParent, SbaResId( DLG_ADABAS_NEWDB )),
	m_GB_USER(	             	this, ResId( GB_USER				) ),
	m_FT_CONUSR(             	this, ResId( FT_CONUSR				) ),
	m_FT_SYSUSR(             	this, ResId( FT_SYSUSR				) ),
	m_FT_DOMAIN_USR(           	this, ResId( FT_DOMAIN_USR			) ),
	m_ET_CONUSR(             	this, ResId( ET_CONUSR				) ),
	m_PB_CONPWD(             	this, ResId( PB_CONPWD				) ),
	m_ET_SYSUSR(             	this, ResId( ET_SYSUSR				) ),
	m_PB_SYSPWD(             	this, ResId( PB_SYSPWD				) ),
	m_ET_DOMAIN_USR(           	this, ResId( ET_DOMAIN_USR			) ),	
	m_PB_DOMAINPWD(           	this, ResId( PB_DOMAINPWD			) ),
	m_BMP_CON(           		this, ResId( BMP_CON				) ),
	m_BMP_SYS(           		this, ResId( BMP_SYS				) ),
	m_BMP_DOMAIN(           	this, ResId( BMP_DOMAIN				) ),
	m_FT_RESTORE(				this, ResId( FT_RESTORE				) ),
	m_ET_RESTORE(        		this, ResId( ET_RESTORE				) ),
	m_PB_RESTORE(        		this, ResId( PB_RESTORE				) ),
	m_GB_DBSETTINGS(	        this, ResId( GB_DBSETTINGS			) ),
	m_FT_SYSDEVSPACE(           this, ResId( FT_SYSDEVSPACE			) ),
	m_FT_TRANSACTIONLOG(        this, ResId( FT_TRANSACTIONLOG		) ),
	m_FT_DATADEVSPACE(        	this, ResId( FT_DATADEVSPACE		) ),
	m_ET_SYSDEVSPACE(        	this, ResId( ET_SYSDEVSPACE			) ),
	m_PB_SYSDEVSPACE(        	this, ResId( PB_SYSDEVSPACE			) ),
	m_ET_TRANSACTIONLOG(     	this, ResId( ET_TRANSACTIONLOG		) ),
	m_PB_TRANSACTIONLOG(     	this, ResId( PB_TRANSACTIONLOG		) ),
	m_ET_DATADEVSPACE(       	this, ResId( ET_DATADEVSPACE		) ),
	m_PB_DATADEVSPACE(       	this, ResId( PB_DATADEVSPACE		) ),
	m_FT_TRANSACTIONLOG_SIZE(	this, ResId( FT_TRANSACTIONLOG_SIZE	) ),
	m_NF_TRANSACTIONLOG_SIZE(	this, ResId( NF_TRANSACTIONLOG_SIZE	) ),
	m_FT_DATADEVSPACE_SIZE(  	this, ResId( FT_DATADEVSPACE_SIZE	) ),
	m_NF_DATADEVSPACE_SIZE(  	this, ResId( NF_DATADEVSPACE_SIZE	) ),
	m_FT_CACHE_SIZE(  			this, ResId( FT_CACHE_SIZE			) ),
	m_NF_CACHE_SIZE(  			this, ResId( NF_CACHE_SIZE			) ),
	m_PB_OK(					this, ResId( PB_OK					) ),
	m_PB_CANCEL(				this, ResId( PB_CANCEL				) ),
	m_DbName(_DbName),
	m_pFileDlg(NULL),
	m_bRestore(_bRestore),
	m_nSetBitmap(0)
{
	DBG_CTOR( SbaAdabasNewDbPage, NULL );

	if(m_bRestore)
	{
		m_GB_USER.SetSizePixel(LogicToPixel( Size(256,50), MAP_APPFONT ));


		m_GB_DBSETTINGS.SetPosPixel(m_GB_DBSETTINGS.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_SYSDEVSPACE.SetPosPixel(m_FT_SYSDEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_TRANSACTIONLOG.SetPosPixel(m_FT_TRANSACTIONLOG.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_DATADEVSPACE.SetPosPixel(m_FT_DATADEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_ET_SYSDEVSPACE.SetPosPixel(m_ET_SYSDEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_PB_SYSDEVSPACE.SetPosPixel(m_PB_SYSDEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_ET_TRANSACTIONLOG.SetPosPixel(m_ET_TRANSACTIONLOG.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_PB_TRANSACTIONLOG.SetPosPixel(m_PB_TRANSACTIONLOG.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_ET_DATADEVSPACE.SetPosPixel(m_ET_DATADEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_PB_DATADEVSPACE.SetPosPixel(m_PB_DATADEVSPACE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_TRANSACTIONLOG_SIZE.SetPosPixel(m_FT_TRANSACTIONLOG_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_NF_TRANSACTIONLOG_SIZE.SetPosPixel(m_NF_TRANSACTIONLOG_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_DATADEVSPACE_SIZE.SetPosPixel(m_FT_DATADEVSPACE_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_NF_DATADEVSPACE_SIZE.SetPosPixel(m_NF_DATADEVSPACE_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_FT_CACHE_SIZE.SetPosPixel(m_FT_CACHE_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_NF_CACHE_SIZE.SetPosPixel(m_NF_CACHE_SIZE.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_PB_OK.SetPosPixel(m_PB_OK.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));
		m_PB_CANCEL.SetPosPixel(m_PB_CANCEL.GetPosPixel()-LogicToPixel( Point(0,14), MAP_APPFONT ));

		Size aSize(GetSizePixel().Width(),GetSizePixel().Height()-LogicToPixel( Size(0,14), MAP_APPFONT ).Height());
		SetSizePixel(aSize);

		m_FT_SYSUSR.Hide();
		m_FT_DOMAIN_USR.Hide();
		m_GB_USER.SetText(ResId(STR_BACKUPFILE_LOAD));
		m_PB_SYSPWD.Hide();
		m_PB_DOMAINPWD.Hide();
		m_ET_SYSUSR.Hide();
		m_ET_DOMAIN_USR.Hide();

		m_ET_SYSUSR.SetText(String::CreateFromAscii("DUMMY"));
		m_BMP_SYS.Hide();
		m_BMP_DOMAIN.Hide();
		m_ET_RESTORE.SetModifyHdl(				LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
		m_ET_RESTORE.SetLoseFocusHdl(			LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
		m_ET_RESTORE.SetMaxTextLen(40);
	}
	else
	{
		m_FT_RESTORE.Hide();
		m_ET_RESTORE.Hide();
		m_PB_RESTORE.Hide();

		m_ET_SYSUSR.SetModifyHdl(				LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
		m_ET_CONUSR.SetModifyHdl(				LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
		m_ET_DOMAIN_USR.Enable(sal_False);

		m_ET_SYSUSR.EnableUpperCase();
		m_ET_CONUSR.EnableUpperCase();
	}


	m_ET_SYSDEVSPACE.SetLoseFocusHdl(		LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
	m_ET_TRANSACTIONLOG.SetLoseFocusHdl(	LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
	m_ET_DATADEVSPACE.SetLoseFocusHdl(		LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));

	m_ET_SYSDEVSPACE.SetMaxTextLen(40);
	m_ET_TRANSACTIONLOG.SetMaxTextLen(40);
	m_ET_DATADEVSPACE.SetMaxTextLen(40);

	m_NF_TRANSACTIONLOG_SIZE.SetModifyHdl(	LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
	m_NF_DATADEVSPACE_SIZE.SetModifyHdl(	LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));
	m_NF_CACHE_SIZE.SetModifyHdl(			LINK(this,SbaAdabasNewDbPage,LoseFocusHdl));

	m_NF_TRANSACTIONLOG_SIZE.SetMin(20);
	m_NF_DATADEVSPACE_SIZE.SetMin(20);
	m_NF_CACHE_SIZE.SetMin(4);

	m_NF_TRANSACTIONLOG_SIZE.SetMax(LONG_MAX);
	m_NF_DATADEVSPACE_SIZE.SetMax(LONG_MAX);
	m_NF_CACHE_SIZE.SetMax(LONG_MAX);

	m_NF_TRANSACTIONLOG_SIZE.SetValue(20);
	m_NF_DATADEVSPACE_SIZE.SetValue(20);
	m_NF_CACHE_SIZE.SetValue(4);

	m_NF_TRANSACTIONLOG_SIZE.SetDecimalDigits(0);
	m_NF_DATADEVSPACE_SIZE.SetDecimalDigits(0);
	m_NF_CACHE_SIZE.SetDecimalDigits(0);

	

	m_PB_CONPWD.SetClickHdl(			LINK(this,SbaAdabasNewDbPage,PwdClickHdl));
	m_PB_SYSPWD.SetClickHdl(			LINK(this,SbaAdabasNewDbPage,PwdClickHdl));
	m_PB_DOMAINPWD.SetClickHdl(			LINK(this,SbaAdabasNewDbPage,PwdClickHdl));

	m_PB_RESTORE.SetClickHdl(			LINK(this,SbaAdabasNewDbPage,LoadButtonClickHdl));

	m_PB_SYSDEVSPACE.SetClickHdl(		LINK(this,SbaAdabasNewDbPage,ButtonClickHdl));
	m_PB_TRANSACTIONLOG.SetClickHdl(	LINK(this,SbaAdabasNewDbPage,ButtonClickHdl));
	m_PB_DATADEVSPACE.SetClickHdl(		LINK(this,SbaAdabasNewDbPage,ButtonClickHdl));

	m_BMP_CON.SetImage(		SbaResId(UNCHECK_RED) );
	m_BMP_SYS.SetImage(		SbaResId(UNCHECK_RED) );
	m_BMP_DOMAIN.SetImage(	SbaResId(UNCHECK_RED) );

	String aPath(getenv("DBWORK"), gsl_getSystemTextEncoding());
	if (!aPath.Len())
		aPath = String(getenv("DBROOT"), gsl_getSystemTextEncoding());

	(((m_SYSDEV_File = aPath) += DirEntry::GetAccessDelimiter() ) += m_DbName).AppendAscii(".sys");
	(((m_TRANSDEV_File = aPath) += DirEntry::GetAccessDelimiter() ) += m_DbName).AppendAscii(".trs");
	(((m_DATADEV_File = aPath) += DirEntry::GetAccessDelimiter() ) += m_DbName).AppendAscii(".dat");

	m_ET_SYSDEVSPACE.SetText(m_SYSDEV_File );
	m_ET_TRANSACTIONLOG.SetText(m_TRANSDEV_File);
	m_ET_DATADEVSPACE.SetText(m_DATADEV_File);

	m_ET_CONUSR.SetText(String::CreateFromAscii("CONTROL"));

	m_PB_OK.SetClickHdl(					LINK(this,SbaAdabasNewDbPage,ImplOKHdl));
	m_PB_OK.Enable(sal_False);

	FreeResource();
}
// -----------------------------------------------------------------------
SbaAdabasNewDbPage::~SbaAdabasNewDbPage()
{
	delete m_pFileDlg;
	DBG_DTOR( SbaAdabasNewDbPage, NULL );
}

// -----------------------------------------------------------------------
String SbaAdabasNewDbPage::GenerateInitFile()
{
	DirEntry aEntry;
	aEntry = aEntry.TempName(FSYS_KIND_FILE);
	String aFileName = aEntry.GetFull();
	{
		SvFileStream aFileStream(aFileName,STREAM_WRITE);
		aFileStream << "* @(#)init.cmd  6.1.1   1994-11-10\n";
		aFileStream << "init config\n";
		aFileStream << "* default code:\n";
		aFileStream << "ascii\n";
		aFileStream << "* date time format\n";
		aFileStream << "internal\n";
		aFileStream << "* command timeout:\n";
		aFileStream << "900\n";
		aFileStream << "* lock timeout:\n";
		aFileStream << "360\n";
		aFileStream << "* request timeout:\n";
		aFileStream << "180\n";
		aFileStream << "* log mode:\n";
		aFileStream << "demo\n";
		aFileStream << "* log segment size:\n";
		aFileStream << "0\n";
		aFileStream << "* no of archive logs:\n";
		aFileStream << "0\n";
		aFileStream << "* no of data devspaces:\n";
		aFileStream << "1\n";
		aFileStream << "* mirror devspaces:\n";
		aFileStream << "n\n";
		aFileStream << "if $rc <> 0 then stop\n";
		aFileStream << "*---  device description ---\n";
		aFileStream << "* sys devspace name:\n";
		aFileStream << ByteString(m_SYSDEV_File, gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << "\n* log devspace size:\n";
		String aLogSize(m_NF_TRANSACTIONLOG_SIZE.GetValue()*256);
		aFileStream << ByteString(aLogSize, gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << "\n* log devspace name:\n";
		aFileStream << ByteString(m_TRANSDEV_File, gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << "\n* data devspace size:\n";
		String aDataSize(m_NF_DATADEVSPACE_SIZE.GetValue()*256); 
		aFileStream << ByteString(aDataSize, gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << "\n* data devspace name:\n";
		aFileStream << ByteString(m_DATADEV_File, gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << "\n* END INIT CONFIG\n";
		aFileStream << "if $rc <> 0 then stop\n";
		if(m_bRestore)
		{
			aFileStream << "RESTORE DATA QUICK FROM '";
			aFileStream << ByteString(m_Backup_File, gsl_getSystemTextEncoding()).GetBuffer() << "' BLOCKSIZE 8\n";
			aFileStream << "if $rc <> 0 then stop\n";
			aFileStream << "RESTART\n";
			
		}
		else
		{
			aFileStream << "ACTIVATE SERVERDB SYSDBA \"";
			aFileStream << ByteString(m_ET_SYSUSR.GetText(), gsl_getSystemTextEncoding()).GetBuffer();
			aFileStream << "\" PASSWORD \"";
			aFileStream << ByteString(m_SysPwd, gsl_getSystemTextEncoding()).GetBuffer();
			aFileStream << "\"\n";
		}
		aFileStream << "if $rc <> 0 then stop\n";
		aFileStream << "exit\n";
	}
	return aFileName;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasNewDbPage, ImplOKHdl, OKButton*, EMPTYARG )
{
	m_SYSDEV_File 	= m_ET_SYSDEVSPACE.GetText();
	m_TRANSDEV_File = m_ET_TRANSACTIONLOG.GetText();
	m_DATADEV_File	= m_ET_DATADEVSPACE.GetText();

	m_Backup_File	= m_ET_RESTORE.GetText();
	if(m_bRestore)
	{
		DirEntry aFile(m_Backup_File);
		if(!aFile.Exists() || FSYS_KIND_DIR == FileStat(aFile).GetKind())
		{
			SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_STR_ADABAS_NO_BACKUP_FILE))).Execute();
			return 0;
		}
		else if(m_Backup_File.Len() > 40)
		{
			InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
			String aMsg(aInfo.GetMessText());
			aMsg.SearchAndReplaceAscii("\'#\'", String::CreateFromAscii("40"));
			aInfo.SetMessText(aMsg);
			aInfo.Execute();
			return 0;
		}
	}
	else if(m_SYSDEV_File.Len() > 40 || m_TRANSDEV_File.Len() > 40 || m_DATADEV_File.Len() > 40)
	{
		InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
		String aMsg(aInfo.GetMessText());
		aMsg.SearchAndReplaceAscii("\'#\'",String::CreateFromAscii("40"));
		aInfo.SetMessText(aMsg);
		aInfo.Execute();
		return 0;
	}


	sal_Bool bOk = sal_False;
	String aErrorMessage = String(SbaResId(SBA_STR_DEVSPACE_NO_FILE));
	if(!m_SYSDEV_File.Len())
		aErrorMessage.SearchAndReplaceAscii("$name$",String::CreateFromAscii("SYSDEVSPACE"));
	else if(!m_TRANSDEV_File.Len())
		aErrorMessage.SearchAndReplaceAscii("$name$",String::CreateFromAscii("TRANSACTIONLOG"));
	else if(!m_DATADEV_File.Len())
		aErrorMessage.SearchAndReplaceAscii("$name$",String::CreateFromAscii("DATDEVSPACE"));
	else if(m_ET_SYSUSR.GetText() == m_ET_CONUSR.GetText())
		aErrorMessage = String(SbaResId(SBA_STR_NO_SAME_USER));
	else
		bOk = sal_True;

	if (!bOk)
	{
		ErrorBox(this, WB_OK, aErrorMessage).Execute();
		return sal_False;
	}

	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String aNewPath(aIniManProp.GetIniManager()->GetProgramPath());

	String aFileName = GenerateInitFile();

	DirEntry aDBEntry;
	aDBEntry = aDBEntry.TempName(FSYS_KIND_FILE);
	::rtl::OUString aDBFileName = aDBEntry.GetFull();
	{
		SvFileStream aFileStream(aDBFileName,STREAM_WRITE);
		aFileStream.WriteByteString(m_DbName, RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(m_ET_CONUSR.GetText(), RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(m_ConPwd, RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(m_ET_SYSUSR.GetText(), RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(m_SysPwd, RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(m_DomainPwd, RTL_TEXTENCODING_ASCII_US);
		String aCacheSize = String::CreateFromInt32(m_NF_CACHE_SIZE.GetValue()*256);
		aFileStream.WriteByteString(aCacheSize, RTL_TEXTENCODING_ASCII_US);
		aFileStream.WriteByteString(aFileName, RTL_TEXTENCODING_ASCII_US);
	}

	(aNewPath += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	aNewPath.AppendAscii(".exe");
#endif
	::rtl::OUString sRestoreParam;
	if (m_bRestore)
		sRestoreParam = ::rtl::OUString::createFromAscii("-x");

	::vos::OArgumentList aParams(2,
		&aDBFileName,
		&sRestoreParam);

	::vos::OProcess aApp( aNewPath);

	EnterWait();
#if DEBUG
	::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)
						(::vos::OProcess::TOption_Wait),
						aParams
					   );
#else
	::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)
						(::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait),
						aParams
					   );
#endif
	LeaveWait();
	switch(eError)
	{
		case ::vos::OProcess::E_NoPermission:
		{
			SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_STR_NO_PERMISSION))).Execute();
			return sal_False;
		}
		case ::vos::OProcess::E_NotFound:
		{
			SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),String(SbaResId(SBA_STR_FILE_OR_DIR_UNKNOWN))).Execute();
			return sal_False;
		}
	}

	aDBEntry.Kill();

	::vos::OProcess::TProcessInfo aInfo;
	if(aApp.getInfo(::vos::OProcess::TData_ExitCode,&aInfo) == ::vos::OProcess::E_None)
	{
		if(aInfo.Code)
			ShowErrorText(aInfo.Code);
	}

	EndDialog(sal_True);

	return sal_True;
}
//------------------------------------------------------------------------
void SbaAdabasNewDbPage::ShowErrorText(sal_Int32 _nError)
{
	String aErrorMsg;
	sal_Bool bError = sal_True;
	switch(_nError)
	{
		case -5:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_NO_NEW_CONFIG_FILE));
			break;
		case -7:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_WRONG_KERNEL_PARAMETER));
			break;
		case -8:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_NO_SERVER_START));
			break;
		case -9:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_NOT_ENOUGH_SPACE));
			aErrorMsg .SearchAndReplaceAscii("\'#\'",m_SYSDEV_File);
			break;
		case -10:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_NOT_ENOUGH_SPACE));
			aErrorMsg.SearchAndReplaceAscii("\'#\'",m_TRANSDEV_File);
			break;
		case -11:
			aErrorMsg = String(SbaResId(SBA_STR_ADABAS_NOT_ENOUGH_SPACE));
			aErrorMsg.SearchAndReplaceAscii("\'#\'",m_DATADEV_File);
			break;
		case 0:
		default:
			bError = sal_False;
	}
	if(bError)
		SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),aErrorMsg).Execute();
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasNewDbPage, LoseFocusHdl, Edit *, pEdit )
{					
	if(&m_ET_SYSDEVSPACE == pEdit)
		m_SYSDEV_File = pEdit->GetText();
	else if(&m_ET_TRANSACTIONLOG == pEdit)
		m_TRANSDEV_File = pEdit->GetText();
	else if(&m_ET_DATADEVSPACE == pEdit)
		m_DATADEV_File = pEdit->GetText();
	else if(&m_ET_RESTORE == pEdit)
		m_Backup_File = pEdit->GetText();

	CheckBitmaps();
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasNewDbPage, LoadButtonClickHdl, Button *, pButton )
{
	SfxFileDialog aLoad( this, WB_3DLOOK | WB_STDMODAL | WB_OPEN );
	if (!m_Backup_File.Len())
	{
		SbaIniWrap aIniWrap;
		aLoad.SetStandardDir(aIniWrap.GetDefaultDatabasePath());
	}
	else
		aLoad.SetStandardDir(m_Backup_File);
	if (aLoad.Execute())
	{
		INetURLObject aUrl(aLoad.GetPath());
		m_Backup_File = aUrl.PathToFileName();
		if(m_Backup_File.Len() > 40)
		{
			InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
			String aMsg(aInfo.GetMessText());
			aMsg.SearchAndReplaceAscii("\'#\'", String::CreateFromAscii("40"));
			aInfo.SetMessText(aMsg);
		}
		m_ET_RESTORE.SetText(m_Backup_File);
	}
	CheckBitmaps();
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasNewDbPage, ButtonClickHdl, Button *, pButton )
{
	if(!m_pFileDlg)
	{
		WinBits	nBits(WB_3DLOOK | WB_STDMODAL | WB_SAVEAS);
		m_pFileDlg = new SfxFileDialog( this, nBits ); //	new FileDialog( this, nBits );

		String aPath;
		if(pButton == &m_PB_SYSDEVSPACE)
			aPath = m_SYSDEV_File;
		else if(pButton == &m_PB_TRANSACTIONLOG)
			aPath = m_TRANSDEV_File;
		else if(pButton == &m_PB_DATADEVSPACE)
			aPath = m_DATADEV_File;
		
		m_pFileDlg->SetStandardDir(aPath);
	}

	if (m_pFileDlg->Execute())
	{
		INetURLObject aUrl(m_pFileDlg->GetPath());
		if(pButton == &m_PB_SYSDEVSPACE)
		{
			m_SYSDEV_File = aUrl.PathToFileName();
			if(m_SYSDEV_File.Len() > 40)
			{
				InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
				String aMsg(aInfo.GetMessText());
				aMsg.SearchAndReplaceAscii("\'#\'", String::CreateFromAscii("40"));
				aInfo.SetMessText(aMsg);
				aInfo.Execute();
				return 0;
			}
			m_ET_SYSDEVSPACE.SetText(m_SYSDEV_File);
		}
		else if(pButton == &m_PB_TRANSACTIONLOG)
		{
			m_TRANSDEV_File = aUrl.PathToFileName();
			if(m_TRANSDEV_File.Len() > 40)
			{
				InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
				String aMsg(aInfo.GetMessText());
				aMsg.SearchAndReplaceAscii("\'#\'", String::CreateFromAscii("40"));
				aInfo.SetMessText(aMsg);
				aInfo.Execute();
				return 0;
			}
			m_ET_TRANSACTIONLOG.SetText(m_TRANSDEV_File);
		}
		else if(pButton == &m_PB_DATADEVSPACE)
		{
			m_DATADEV_File = aUrl.PathToFileName();
			if(m_DATADEV_File.Len() > 40)
			{
				InfoBox aInfo(this,SbaResId(INFO_SBA_STR_MAX_FILE_LENGTH));
				String aMsg(aInfo.GetMessText());
				aMsg.SearchAndReplaceAscii("\'#\'", String::CreateFromAscii("40"));
				aInfo.SetMessText(aMsg);
				aInfo.Execute();
				return 0;
			}
			m_ET_DATADEVSPACE.SetText(m_DATADEV_File);
		}
	}

	CheckBitmaps();
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( SbaAdabasNewDbPage, PwdClickHdl, Button *, pButton )
{
	SfxPasswordDialog aDlg(this);
	aDlg.ShowExtras(SHOWEXTRAS_CONFIRM);
	if(aDlg.Execute())
	{
		String sPwd = aDlg.GetPassword().ToUpperAscii();
		if(pButton == &m_PB_CONPWD)
		{
			m_ConPwd = sPwd;
			m_nSetBitmap &=~2;
		}
		else if(pButton == &m_PB_SYSPWD)
		{
			m_SysPwd = sPwd;
			if(!m_DomainPwd.Len())
			{
				m_nSetBitmap = 1;
				m_DomainPwd = m_SysPwd;
			}
			if(!m_ConPwd.Len())
			{
				m_nSetBitmap |= 2;
				m_ConPwd = m_SysPwd;
			}
			
		}
		else if(pButton == &m_PB_DOMAINPWD)
		{
			m_DomainPwd = sPwd;
			m_nSetBitmap &=~1;
		}
	}
	CheckBitmaps();
	return 0;
}
//------------------------------------------------------------------------
void SbaAdabasNewDbPage::CheckBitmaps()
{
	sal_Int16 i=0;
	if(m_ConPwd.Len() && m_ET_CONUSR.GetText().Len())
			i++,m_BMP_CON.SetImage(SbaResId(((m_nSetBitmap & 2) == 2) ? DEFAULT_BLUE : CHECK_GREEN));
	else
		m_BMP_CON.SetImage(SbaResId(UNCHECK_RED));
	
	if(!m_bRestore)
	{
		if(m_SysPwd.Len() && m_ET_SYSUSR.GetText().Len())
			i++,m_BMP_SYS.SetImage(SbaResId(CHECK_GREEN));
		else
			m_BMP_SYS.SetImage(SbaResId(UNCHECK_RED));

		if(m_DomainPwd.Len() )
			i++,m_BMP_DOMAIN.SetImage(SbaResId(((m_nSetBitmap & 1) == 1) ? DEFAULT_BLUE : CHECK_GREEN));
		else
			m_BMP_DOMAIN.SetImage(SbaResId(UNCHECK_RED));
	}
	else if(m_Backup_File.Len())
		i+=2;

	if(m_ET_SYSDEVSPACE.GetText().Len() && m_ET_TRANSACTIONLOG.GetText().Len() && m_ET_DATADEVSPACE.GetText().Len() &&
		m_ET_SYSDEVSPACE.GetText() != m_ET_TRANSACTIONLOG.GetText() && m_ET_SYSDEVSPACE.GetText() != m_ET_DATADEVSPACE.GetText() && 
		m_ET_DATADEVSPACE.GetText() != m_ET_TRANSACTIONLOG.GetText())
		i++;

	m_PB_OK.Enable(i == 4);
}



