/*************************************************************************
 *
 *  $RCSfile: adastat.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_ADASTAT_HXX_
#include "adastat.hxx"
#endif

#ifndef _SBA_ADASTAT_HRC
#include "adastat.hrc"
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SDB_SDBCURS_HXX
#include <sdb/sdbcurs.hxx>
#endif

DBG_NAME(SbaAdabasStatistics);

SbaAdabasStatistics::SbaAdabasStatistics( Window* pParent,const SdbConnectionRef pCon) : ModalDialog( pParent, SbaResId(DLG_ADABASSTAT) )
	,m_GB_FILES(			this , SbaResId(GB_FILES))          
	,m_FT_SYSDEVSPACE(		this , SbaResId(FT_SYSDEVSPACE))   
	,m_ET_SYSDEVSPACE(		this , SbaResId(ET_SYSDEVSPACE))   
	,m_FT_TRANSACTIONLOG(	this , SbaResId(FT_TRANSACTIONLOG))
	,m_ET_TRANSACTIONLOG(	this , SbaResId(ET_TRANSACTIONLOG))
	,m_FT_DATADEVSPACE(		this , SbaResId(FT_DATADEVSPACE))  
	,m_LB_DATADEVS(			this , SbaResId(LB_DATADEVS))      
	,m_GB_SIZES(			this , SbaResId(GB_SIZES))          
	,m_FT_SIZE(				this , SbaResId(FT_SIZE))          
	,m_ET_SIZE(				this , SbaResId(ET_SIZE))          
	,m_FT_FREESIZE(			this , SbaResId(FT_FREESIZE))      
	,m_ET_FREESIZE(			this , SbaResId(ET_FREESIZE))      
	,m_FT_MEMORYUSING(		this , SbaResId(FT_MEMORYUSING))   
	,m_ET_MEMORYUSING(		this , SbaResId(ET_MEMORYUSING))  
	,m_PB_OK(				this , SbaResId(PB_OK))
	,m_xConnection(pCon)
{
	DBG_CTOR(SbaAdabasStatistics,NULL);
	DBG_ASSERT(m_xConnection.Is(),"No connection");

	SdbCursor* pCursor = m_xConnection->CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();

	// first the db sizes
	String aStmt; aStmt.AssignAscii("SELECT SERVERDBSIZE, UNUSEDPAGES FROM ");
	(aStmt += m_xConnection->GetUser()).AppendAscii(".SERVERDBSTATISTICS");
	pCursor->Open(aStmt);
	if(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		ODbVariantRef pVal = rRow[1];
		double nUsedPages = pVal->getDouble() / 256;
		pVal = rRow[2];
		double nFreePages = pVal->getDouble() / 256;

		m_ET_SIZE.SetText(String((sal_Int32)nUsedPages));
		m_ET_FREESIZE.SetText(String((sal_Int32)nFreePages));
		m_ET_MEMORYUSING.SetValue(((nUsedPages-nFreePages)/nUsedPages)*100);
	}

	pCursor->Close();

	// then the db files
	aStmt.AssignAscii("SELECT DEVSPACENAME FROM ");
	(aStmt += m_xConnection->GetUser()).AppendAscii(".DATADEVSPACES");
	pCursor->Open(aStmt);
	while(pCursor->IsInRange())
	{
		ODbRow& rRowDev = *pCursor->GetRow();
		ODbVariantRef pValPath = rRowDev[1];
		m_LB_DATADEVS.InsertEntry(pValPath->getString());
		pCursor->Next();
	}
	pCursor->Close();

	aStmt.AssignAscii("SELECT * FROM ");
	(aStmt += m_xConnection->GetUser()).AppendAscii(".CONFIGURATION WHERE DESCRIPTION LIKE 'SYS%DEVSPACE%NAME'");
	pCursor->Open(aStmt);
	if(pCursor->IsInRange())
	{
		ODbRow& rRowDev = *pCursor->GetRow();
		ODbVariantRef pValPath = rRowDev[2];
		m_ET_SYSDEVSPACE.SetText(pValPath->getString());
	}
	pCursor->Close();

	aStmt.AssignAscii("SELECT * FROM ");
	(aStmt += m_xConnection->GetUser()).AppendAscii(".CONFIGURATION WHERE DESCRIPTION = 'TRANSACTION LOG NAME'");
	pCursor->Open(aStmt);
	if(pCursor->IsInRange())
	{
		ODbRow& rRowDev = *pCursor->GetRow();
		ODbVariantRef pValPath = rRowDev[2];
		m_ET_TRANSACTIONLOG.SetText(pValPath->getString());
	}
	pCursor->Close();

	pCursor->ReleaseRef();

	FreeResource();
}
//------------------------------------------------------------------------
SbaAdabasStatistics::~SbaAdabasStatistics()
{
	DBG_DTOR(SbaAdabasStatistics,NULL);
}



