/*************************************************************************
 *
 *  $RCSfile: addrpi.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SBA_SBAUNOTL_HXX
#include "sbaunotl.hxx"
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif
#ifndef _SFXCANCEL_HXX //autogen
#include <svtools/cancel.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_INIMGR_HXX //autogen
#include <sfx2/inimgr.hxx>
#endif
#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SFXSMPLHINT_HXX //autogen
#include <svtools/smplhint.hxx>
#endif
#ifndef _SV_DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif
#ifndef _SBA_ADDRPI_HXX
#include "addrpi.hxx"
#endif
#ifndef _SBA_ADDRCNT_HXX
#include "addrcnt.hxx"
#endif
#ifndef _SBA_LDAPSRCH_HXX
#include "ldapsrch.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_SBASTR_HXX
#include "sbastr.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif
#ifndef _SBA_INIWRAP_HXX
#include "iniwrap.hxx"
#endif
#ifndef _SBA_DBEXCH_HXX
#include "dbexch.hxx"
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef SBA_ADDRPI_HRC
#include "addrpi.hrc"
#endif
#ifndef _OFA_LDAPSRCH_HRC
#include "ldapsrch.hrc"
#endif

#ifndef _SBA_SBADB_HXX //autogen
#include "sbadb.hxx"
#endif

#define NULL_VALUE	'\t'

// -----------------------------------------------------------------------

DBG_NAME( SbaAddrMan );

// class GotoEdit_Impl ---------------------------------------------------

void GotoEdit_Impl::KeyInput( const KeyEvent& rKeyEvent )
{
	if ( rKeyEvent.GetKeyCode().GetCode() == KEY_RETURN )
		aKeyLink.Call( this );
	else
	{
		ByteString aStr( rKeyEvent.GetCharCode(), RTL_TEXTENCODING_ASCII_US );
		if ( aStr.IsAlphaAscii() )
			return;
		Edit::KeyInput( rKeyEvent );
	}
}

// class DragButton_Impl -------------------------------------------------

DragButton_Impl::DragButton_Impl( SbaAddrPI* pParent ) : FixedImage( pParent )
{
	SetHelpId( HID_DLG_ADDR_PI_DRAGBTN );
	pAddrPI = pParent;
	SetBackground( pParent->GetBackground() );
	Image aImage( SbaResId( IMG_DRAGADDR ) );
	SetImage( aImage );
	Size aSize( aImage.GetSizePixel() );
	aSize.Width() += 4;
	SetSizePixel( aSize );
}

// -----------------------------------------------------------------------

void DragButton_Impl::Command ( const CommandEvent& rCEvt )
{
	if( rCEvt.GetCommand() != COMMAND_STARTDRAG )
		return;

	DragServer::Clear();

	// Daten draggen
	Pointer aMovePtr(POINTER_COPYDATA),
			aCopyPtr(POINTER_COPYDATA),
			aLinkPtr(POINTER_LINKDATA);

	SbaExplorerExchObjRef xExchange = pAddrPI->GetExchangeObject();
	if (xExchange.Is())
		xExchange->ExecuteDrag( this, aMovePtr, aCopyPtr, aLinkPtr, DRAG_COPYABLE | DRAG_LINKABLE );
}

// -----------------------------------------------------------------------

void DragButton_Impl::MouseMove( const MouseEvent& rEvt )
{
	SetPointer( Pointer( POINTER_HAND ) );
}

void DragButton_Impl::MouseButtonDown( const MouseEvent& rEvt )
{
}

// class SbaAddrContainer ------------------------------------------------

String SbaAddrContainer::GetField( sal_uInt16 nIdx ) const
{
	DBG_ASSERT( nIdx < ADDR_BOOK_FIELDS_CNT,
				"SbaAddrContainer::GetField [illegal index]" );
	return aStrArr[nIdx];
}

void SbaAddrContainer::SetField( sal_uInt16 nIdx, const String& rStr )
{
	DBG_ASSERT( nIdx < ADDR_BOOK_FIELDS_CNT,
				"SbaAddrContainer::SetField [illegal index]" );
	aStrArr[nIdx] = rStr;
}

sal_Bool SbaAddrContainer::operator==( const SbaAddrContainer& rCont ) const
{
	sal_Bool bResult(sal_True);

	for ( sal_uInt16 i = 0; bResult && i < Count(); ++i )
		bResult = ( aStrArr[i] == rCont.aStrArr[i] );
	return bResult;
}

// class SbaTabColInfo ---------------------------------------------------

/*	[Beschreibung]

	Enth"alt Information, welche ob die Tabellenspalte nach der INI-Datei
	"uberhaupt bearbeitet werden kann und ob diese in der ausgew"ahlten
	Tabelle enthalten ist
*/

class SbaTabColInfo
{
private:
	String	aColName;	// Name in INI-Datei
	sal_Bool	bVisible;	// Ist dieser auch in Tabelle?

public:
	SbaTabColInfo();
	~SbaTabColInfo(){};

	void SetName( const String& rName ){aColName=rName;};
	String GetName() const {return aColName;};
	void SetVisible( sal_Bool bVis ){bVisible=bVis;};
	sal_Bool IsVisible() const {return bVisible;};
};

SbaTabColInfo::SbaTabColInfo() : bVisible( sal_False )
{
}

// class SbaAddrMan ------------------------------------------------------

class SbaAddrMan
{
private:
	SbaDatabaseRef		aDB;			// die Datenbank
	SdbCursor*			pDataCursor;	// Cursor f"ur die Daten
	sal_uInt32				nCurrentRow;	// Aktuelle Row
	String				aTableName;		// Name der Adresstabelle
	String				aSelectCmd;		// SQL Statement fuer Daten
	String				aWhereCond;		// Filterkriterien
	String				aNameList;		// Feldnamen mit ; getrennt
	sal_Bool				bIsOk;			// ist die Connection OK?
	sal_uInt16				nColCount;		// wieviele Felder
	sal_Bool				bIsWritable;	// Datenbank schreibbar?
	SbaLDAPSearcher*	pLDAPSearcher;	// LDAP-Suche
	SbaObject*			pSbaObject;
	SbaStringList		aAnredeList;	// Stringliste um die Anreden zu sammeln
	SbaTabColInfo		aTabColInfo[ADDR_BOOK_FIELDS_CNT];

	sal_Bool				FetchRow( const SdbCursorPosition eCursorPosition, long nPos=1 );
	String				GetCurrentWhere();
	sal_Bool				ShowError( SdbCursor* pCur );
						// F"ullt aTabColInfo mit den Eintr"agen der INI-Datei
	void				SetTabColInfos();

public:
						SbaAddrMan( SbaDatabaseRef rD, SbaObject* pO );
						~SbaAddrMan();
	SbaTabColInfo		GetTabColInfo( sal_uInt16 index )
							{ return aTabColInfo[index]; }
	sal_uInt32				GetRowCount();
	inline sal_uInt32		GetCurRow() const { return nCurrentRow;}
	inline sal_Bool			IsOk() const { return bIsOk;}
	inline sal_Bool			IsWriteable() const { return bIsWritable;}
	inline sal_uInt16		GetColCount() const { return nColCount;}
	const String&		GetTableName() const { return aTableName; }
	sal_Bool				FetchNextRow();
	sal_Bool				FetchPrevRow();
	sal_Bool				FetchFirstRow();
	sal_Bool				FetchLastRow();
	sal_Bool				FetchRowAt( sal_uInt32 nPos );
	void				BuildSelectCmd( const String& rWherePart, sal_Bool bAllways = sal_False );
	sal_Bool				MayDeleteRow();
	sal_Bool				MayAppendRow();
	sal_Bool				MayUpdateRow();
	void				WriteRow( const SbaAddrContainer& rContainer );
	void				InsertRow( const SbaAddrContainer& rContainer );
	FASTBOOL			NewRow( const SbaAddrContainer& rContainer );
	void				UpdateRow( const SbaAddrContainer& rContainer );
	void				DeleteRow();
	void				ReadRow( SbaAddrContainer& rContainer );
	String				GetFilterWhere( const SbaAddrContainer& rContainer );
	sal_Bool				FindRow( const SbaAddrContainer& rContainer, sal_uInt32& rIndex );
	inline String		GetCurSelectCmd() const { return aSelectCmd; }
	inline String		GetCurWhereCond() const { return aWhereCond; }
	sal_Bool				PutUniqueAnrede( const String& rAnrede );
	const SbaStringList* GetAnredeList();
	void				InitAnredeList();
	void				InitDb();
	void                RefreshDb();
	SbaLDAPSearcher*	GetLDAPSearcher() const { return pLDAPSearcher; }
	void				SetLDAPSearcher( SbaLDAPSearcher* pSearcher ) { pLDAPSearcher = pSearcher; }
	sal_Bool				AddressAlreadyExists( const String& rSQL ) const;
};

//==================================================================

SbaAddrMan::SbaAddrMan( SbaDatabaseRef rDB, SbaObject* pObj ) :

	aDB				( rDB ),
	pDataCursor		( 0 ),
	bIsOk			( sal_False ),
	nColCount		( 0 ),
	nCurrentRow		( 0 ),
	bIsWritable		( sal_False ),
	pSbaObject		( pObj ),
	pLDAPSearcher	( NULL )

{
	DBG_CTOR( SbaAddrMan, NULL );

	if ( !aDB.Is() )
		return;

	aTableName = pSbaObject->GetAddrTableName();
	if ( aTableName.Len() == 0 )
		return;

	if (!aDB->HasObject(dbTable, aTableName ))
		return;

	// gibt es die Tabelle "uberhaupt
	// SDB_INDIRECT bedeutet, dass der Parser sich mit reinh"agt,
	// was f"ur ein Updaten notwendig ist
	// (nur bei File-basierten Cursorn wird das Flag automatisch gesetzt)
	pDataCursor	= aDB->CreateCursor(SDB_KEYSET, SDB_INDIRECT);

	if ( !pDataCursor )
		return;
	else
		pDataCursor->AddRef();

	//!!! Fehlerbehandlung
	bIsOk = sal_True;
	BuildSelectCmd( String(), sal_True );
	SetTabColInfos();
}

// -----------------------------------------------------------------------

SbaAddrMan::~SbaAddrMan()
{
	DBG_DTOR( SbaAddrMan, NULL );

	if ( pDataCursor )
		pDataCursor->ReleaseRef();
}

// -----------------------------------------------------------------------

void SbaAddrMan::SetTabColInfos()
{
	// Information ber darstellbare Spalten aus INI-String
	// Spalten, die nicht im INI-String vorhanden sind,
	// werden mit Leerstring initialisiert und im Dialog nicht dargestellt
	// Abfrage mit IsTableColumn()

	SbaIniWrap aIniWrapper;
	String aINIString( aIniWrapper.GetAddressFields());

	if ( !aINIString.Len() )
	{
		// Defaultwerte, d.h. deutsche Tabelle
		aTabColInfo[SbaIniWrap::COMPANY].SetName( String::CreateFromAscii("FIRMA") );
		aTabColInfo[SbaIniWrap::DEPARTMENT].SetName( String::CreateFromAscii("ABTEILUNG") );
		aTabColInfo[SbaIniWrap::FIRSTNAME].SetName( String::CreateFromAscii("VORNAME") );
		aTabColInfo[SbaIniWrap::LASTNAME].SetName( String::CreateFromAscii("NAME") );
		aTabColInfo[SbaIniWrap::ADDRESS].SetName( String::CreateFromAscii("STRASSE") );
		aTabColInfo[SbaIniWrap::COUNTRY].SetName( String::CreateFromAscii("LAND") );
		aTabColInfo[SbaIniWrap::POSTALCODE].SetName( String::CreateFromAscii("PLZ") );
		aTabColInfo[SbaIniWrap::CITY].SetName( String::CreateFromAscii("ORT") );
		aTabColInfo[SbaIniWrap::TITLE].SetName( String::CreateFromAscii("TITEL") );
		aTabColInfo[SbaIniWrap::POSITION].SetName( String::CreateFromAscii("POSITION") );
		aTabColInfo[SbaIniWrap::PREFIX].SetName( String::CreateFromAscii("ANREDE") );
		aTabColInfo[SbaIniWrap::INITIALS].SetName( String::CreateFromAscii("KUERZEL") );
		aTabColInfo[SbaIniWrap::SALUTATION].SetName( String::CreateFromAscii("BRIEFANRED") );
		aTabColInfo[SbaIniWrap::HOMEPHONE].SetName( String::CreateFromAscii("TELPRIV") );
		aTabColInfo[SbaIniWrap::WORKPHONE].SetName( String::CreateFromAscii("TELGESCH") );
		aTabColInfo[SbaIniWrap::FAX].SetName( String::CreateFromAscii("FAX") );
		aTabColInfo[SbaIniWrap::EMAIL].SetName( String::CreateFromAscii("EMAIL") );
		aTabColInfo[SbaIniWrap::URL].SetName( String::CreateFromAscii("URL") );
		aTabColInfo[SbaIniWrap::NOTE].SetName( String::CreateFromAscii("NOTIZ") );
		aTabColInfo[SbaIniWrap::OLDFIELD1].SetName( String::CreateFromAscii("ALTFELD1") );
		aTabColInfo[SbaIniWrap::OLDFIELD2].SetName( String::CreateFromAscii("ALTFELD2") );
		aTabColInfo[SbaIniWrap::OLDFIELD3].SetName( String::CreateFromAscii("ALTFELD3") );
		aTabColInfo[SbaIniWrap::OLDFIELD4].SetName( String::CreateFromAscii("ALTFELD4") );
		aTabColInfo[SbaIniWrap::STATE].SetName( String::CreateFromAscii("BUNDLAND") );
		aTabColInfo[SbaIniWrap::OFFICEPHONE].SetName( String::CreateFromAscii("TELBUERO") );
		aTabColInfo[SbaIniWrap::PAGER].SetName( String::CreateFromAscii("TELFUNK") );
		aTabColInfo[SbaIniWrap::HANDYPHONE].SetName( String::CreateFromAscii("TELHANDY") );
		aTabColInfo[SbaIniWrap::OTHERPHONE].SetName( String::CreateFromAscii("TELANDERE") );
		aTabColInfo[SbaIniWrap::CALENDARURL].SetName( String::CreateFromAscii("CALENDAUR") );	//!!!
		aTabColInfo[SbaIniWrap::INVITE].SetName( String::CreateFromAscii("INVITE") );			//!!!
	}
	else
	{
		for( sal_uInt16 i=0; i<ADDR_BOOK_FIELDS_CNT; i++ )
			aTabColInfo[i].SetName( aIniWrapper.GetAssocFieldName((SbaIniWrap::FieldKey)i) );
	}

	// Jetzt muss noch geprueft werden, ob die Spalten auch
	// in der Tabelle vorhanden sind, d.h. sichtbar sind
	SdbColumnsRef aColsRef=pDataCursor->GetColumns();
	const SdbColumn* pColumn;
	String aColName;
	String aStr;
	sal_uInt16 aCount=aColsRef->Count();

	for( sal_uInt16 i=0; i<(aColsRef->Count()); i++ )
	{
		pColumn = aColsRef->Column(i);
		aColName = pColumn->GetName();

		// Schauen, ob diese Spalte nach INI-Datei zugelassen ist
		// Wenn ja, Visible schalten
		for( sal_uInt16 j=0; j<=(sal_uInt16)SbaIniWrap::INVITE; j++ )
		{
			if ( (sal_uInt16)SbaIniWrap::ID != j )
			{
				aStr=aTabColInfo[j].GetName();
				if (aTabColInfo[j].GetName().Equals(pColumn->GetName()))
					aTabColInfo[j].SetVisible( sal_True );
			}
		}
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::ShowError( SdbCursor* pCur )
{
	if ( pCur->Status().IsError() )
	{
		pSbaObject->ShowDbStatus( (SdbStatus&)pCur->Status() );
		return sal_True;
	}
	return sal_False;
}

// -----------------------------------------------------------------------

void SbaAddrMan::InitDb()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if (bIsOk)
		bIsWritable = pDataCursor->IsUpdatable();
	if (bIsOk)
	{
		aNameList.Erase();
		const SdbColumnsRef	rCols(pDataCursor->GetColumns());
		sal_uInt16				nCnt(rCols->Count());//(sal_uInt16)

/*		for( i=1 ; i<nCnt ; i++ )
		{
			const SdbColumn* pCol = (*rCols)[i];
			aNameList += pCol->Name();
			aNameList += ';';
		}
*/
		for( sal_uInt16 i=0; i<ADDR_BOOK_FIELDS_CNT; i++ )
		{
			aNameList+=aTabColInfo[i].GetName();
			aNameList+=';';
		}
		aNameList.EraseTrailingChars( ';' );
	}
}

// -----------------------------------------------------------------------

void SbaAddrMan::RefreshDb()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( aDB.Is() )
		aDB->Refresh( dbTable );
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FindRow( const SbaAddrContainer& rContainer, sal_uInt32& rIndex )
{
	sal_Bool bResult(sal_False);
	SbaAddrContainer aCont;
	rIndex = 0;

	if ( bIsOk && pDataCursor->IsOpen() )
	{
		pDataCursor->First();

		while( bResult==sal_False && ! pDataCursor->IsOffRange() )
		{
			if ( ShowError( pDataCursor ) )
				break;

			ReadRow( aCont );

			if ( bResult = aCont==rContainer )
				break;
			pDataCursor->Next();
			rIndex++;
		}
	}
	return bResult;
}

// -----------------------------------------------------------------------

void SbaAddrMan::BuildSelectCmd( const String& rWherePart, sal_Bool bAllways )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( bIsOk && ( rWherePart != aWhereCond || bAllways ) )
	{
		aWhereCond = rWherePart;
		aSelectCmd.AssignAscii("SELECT * FROM ");

		String aQuotedTable = aDB->QuoteTableName( aTableName );
		aSelectCmd += aQuotedTable;

		if( aWhereCond.Len() )
		{
			aSelectCmd.AppendAscii(" WHERE ");
			aSelectCmd += aWhereCond;
		}

		if( pDataCursor->IsOpen() )
			pDataCursor->Close();
		pDataCursor->Open( aSelectCmd );

		if( ! pDataCursor->IsOpen() )
		{
			DBG_ASSERT( pDataCursor->IsOpen(), "Not Open" );
			bIsOk = sal_False;
		}
		ShowError( pDataCursor );

		if( bIsOk )
		{
			const SdbColumnsRef aCols( pDataCursor->GetColumns() );
			nColCount = aCols->Count() - 1;// ohne ::com::sun::star::text::Bookmark
		}
	}
}

// -----------------------------------------------------------------------

sal_uInt32 SbaAddrMan::GetRowCount()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( pLDAPSearcher )
		return pLDAPSearcher->GetRowCount();
	else
	{
		if ( bIsOk && !pDataCursor->IsRowCountFinal() )
			pDataCursor->DetermineRowCount();
		return pDataCursor ? pDataCursor->RowCount() : 0;
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchRow( const SdbCursorPosition eCursorPosition, long nPos )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( pLDAPSearcher )
		return pLDAPSearcher->FetchRow( eCursorPosition, nPos );
	else
	{
		sal_Bool bRet(sal_False);

		if ( bIsOk && pDataCursor->IsOpen() )
		{
			//XXX Fehlerbehandlungen fehlen noch!!!
			switch ( eCursorPosition )
			{
				case SDB_POS_FIRST:
					pDataCursor->First();
					break;
				case SDB_POS_LAST:
					pDataCursor->Last();
					break;
				case SDB_POS_NEXT:
					pDataCursor->Next();
					break;
				case SDB_POS_PRIOR:
					pDataCursor->Prev();
					break;
				case SDB_POS_ABSOLUTE:
					pDataCursor->MoveAbs(nPos);
					break;
				case SDB_POS_RELATIVE:
					pDataCursor->MoveRel(nPos);
					break;
			}
			bRet = !ShowError( pDataCursor );
		}
		return bRet;
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchRowAt( sal_uInt32 nPos )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	sal_Bool bRet = sal_False;
	sal_uInt32 nRowCnt = GetRowCount();
	if ( nRowCnt )
	{
		if ( nPos >= nRowCnt )
			nPos = nRowCnt - 1;
		bRet = FetchRow( SDB_POS_ABSOLUTE, nPos + 1 );
		nCurrentRow = nPos;
	}
	return bRet;
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchFirstRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	nCurrentRow = 0;
	return FetchRow( SDB_POS_FIRST );
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchLastRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	sal_Bool bRet = sal_False;
	sal_uInt32 nRowCnt = GetRowCount();
	bRet = FetchRow( SDB_POS_LAST );
	if ( bRet )
		nCurrentRow = nRowCnt ? nRowCnt - 1 : 0;
	return bRet;
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchNextRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	sal_Bool bRet = sal_False;
	sal_uInt32 nRowCnt = GetRowCount();
	if ( nRowCnt && nCurrentRow < ( nRowCnt - 1 ) )
	{
		bRet = FetchRow( SDB_POS_NEXT );
		if ( bRet )
			nCurrentRow++;
	}
	return bRet;
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::FetchPrevRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	sal_Bool bRet = sal_False;
	if ( nCurrentRow > 0 )
	{
		bRet = FetchRow( SDB_POS_PRIOR );
		if ( bRet )
			nCurrentRow--;
	}
	return bRet;
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::MayDeleteRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( pLDAPSearcher )
		return sal_False;
	else
	{
		DBG_ASSERT( pDataCursor->IsOpen(), "SbaAddrMan::MayDeleteRow [not open]" );
		return ( pDataCursor->CanDelete() &&
				 pDataCursor->GetRow().Is() &&
				 !pDataCursor->GetRow()->isDeleted() );
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::MayAppendRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	return pDataCursor->CanAppend();
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::MayUpdateRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	return pDataCursor->CanUpdate();
}

// -----------------------------------------------------------------------

void SbaAddrMan::WriteRow( const SbaAddrContainer& rContainer )
{
	// Eine Datenzeile wegschreiben
	String aNullValue( NULL_VALUE );
	SdbColumnsRef xColumns = pDataCursor->GetColumns();
	ODbRowRef aRow(pDataCursor->GetRow());
	const SdbColumn* pColumn;
	String aColName;

	for ( sal_uInt16 i = 0; i < ADDR_BOOK_FIELDS_CNT ; ++i )
	{
		aColName = aTabColInfo[i].GetName();

		if ( SbaIniWrap::INVITE != i && aTabColInfo[i].IsVisible() )
		{
			sal_uInt16 nColNum = xColumns->ColumnNumber( aColName );
			String aVal = rContainer.GetField(i);
			if ( !aVal.Len() )
			{
				// Ist f"ur diese Spalte ein NULL-Wert erlaubt?
				sal_Bool bNullAllowed = sal_False;
				sal_uInt16 nColNum = xColumns->ColumnNumber( aColName );
				if ( nColNum != SDB_COLUMN_NOTFOUND )
				{
					pColumn = xColumns->Column( nColNum );
					if ( pColumn && pColumn->IsNullAllowed() )
						bNullAllowed = sal_True;
				}

				if ( bNullAllowed )
					// dann NULL schreiben
					(*aRow)[nColNum]->setNull();
				else
					// oder Leerstring
					(*aRow)[nColNum]->setString( UniString(aVal) );
			}
			else if ( aVal != aNullValue )
				(*aRow)[nColNum]->setString( UniString(aVal) );
		}
		else if ( aTabColInfo[i].IsVisible() )
		{
			// f"ur Invite ein Bool-Wert schreiben
			String aFldVal = rContainer.GetField(i);
			sal_Bool bVal = ( aFldVal.EqualsAscii("1") ) ? sal_True : sal_False;
			sal_uInt16 nColNum = xColumns->ColumnNumber( aTabColInfo[i].GetName() );
			(*aRow)[nColNum]->setBOOL( bVal );
		}
	}
}

// -----------------------------------------------------------------------

void SbaAddrMan::InsertRow( const SbaAddrContainer& rContainer )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	pDataCursor->AppendRow();
	ShowError( pDataCursor );
	WriteRow( rContainer );

	if ( !pDataCursor->UpdateRow() )
	{
		ShowError( pDataCursor );
		pDataCursor->CancelRow();
	}
	else
	{
		// Da die Adressliste sortiert ausgegeben wird,
		// muss der DatenCursor die Daten neu lesen
		BuildSelectCmd( String(), sal_True );

		// Jetzt wieder auf den eben eingefuegten Satz positionieren
		sal_uInt32	nIndex;
		if (!FindRow(rContainer, nIndex))
		{									// Nicht gefunden, dann gehe auf die letzte gueltige Position
			nIndex = nCurrentRow;
			if (!FetchRowAt(nIndex))
				FetchFirstRow();			// Nicht geklappt, dann auf ersten Satz
		}
		else
			nCurrentRow = nIndex;

		SfxViewFrame* pFrame = SfxViewFrame::Current();
		SfxDispatcher* pDisp = 0;

		if( pFrame!=0 && (pDisp = pFrame->GetDispatcher())!=0 )
			pDisp->Execute( SID_SBA_QRY_DIRTY );
	}
}

// -----------------------------------------------------------------------

FASTBOOL SbaAddrMan::NewRow( const SbaAddrContainer& rContainer )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	sal_Bool bRet(sal_True);
	pDataCursor->AppendRow();
	ShowError( pDataCursor );
	WriteRow( rContainer );

	if ( !pDataCursor->UpdateRow() )
	{
		ShowError( pDataCursor );
		pDataCursor->CancelRow();
		bRet = sal_False;
	}
	return bRet;
}

// -----------------------------------------------------------------------

void SbaAddrMan::UpdateRow( const SbaAddrContainer& rContainer )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	DBG_ASSERT( pDataCursor->IsOpen(), "SbaAddrMan::UpdateRow [not open]" );
	DBG_ASSERT( pDataCursor->GetColumns()->Count() == rContainer.Count() + 1, "SbaAddrMan::UpdateRow [Parameter!]" );

	pDataCursor->EditRow();
	ShowError( pDataCursor );
	WriteRow( rContainer );

	if ( !pDataCursor->UpdateRow() )
	{
		ShowError( pDataCursor );
		pDataCursor->CancelRow();
	}
	else
	{
		// Da die Adressliste sortiert ausgegeben wird,
		// muss der DatenCursor die Daten neu lesen
		BuildSelectCmd( String(), sal_True );

		// Jetzt wieder auf den eben eingefuegten Satz positionieren
		sal_uInt32	nIndex;
		if (!FindRow(rContainer, nIndex))
		{
			// Nicht gefunden, dann gehe auf die letzte gueltige Position
			nIndex = nCurrentRow;
			if (!FetchRowAt(nIndex))
				FetchFirstRow();			// Nicht geklappt, dann auf ersten Satz
		}
		else
			nCurrentRow = nIndex;

		SfxViewFrame* pFrame = SfxViewFrame::Current();
		SfxDispatcher* pDisp = 0;

		if (pFrame!=0 && (pDisp = pFrame->GetDispatcher())!=0 )
			pDisp->Execute( SID_SBA_QRY_DIRTY );
	}
}

// -----------------------------------------------------------------------

String SbaAddrMan::GetCurrentWhere()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	DBG_ASSERT( pDataCursor->IsOpen(), "not opened" );

	xub_StrLen nCnt(aNameList.GetTokenCount()), i;
	String aResult; aResult.AssignAscii(" WHERE ");

	for ( i = 0 ; i < nCnt ; ++i )
	{
		aResult += aNameList.GetToken( i );
		const ODbVariantRef& xVar = (*pDataCursor->GetRow())[i+1];

		if (!xVar->isNull())
		{
			try
			{
				String aStr = xVar->toString();
				aResult.AppendAscii(" = ");
				aResult += SdbConnection::StringQuotation(aStr);
			}
			catch(...)
			{
				aResult.AppendAscii(" IS NOT NULL ");
			}

		}
		else
			aResult.AppendAscii(" IS NULL ");

		if ( i < (nCnt-1) )
			aResult.AppendAscii(" AND ");
	}
	return aResult;
}

// -----------------------------------------------------------------------

String SbaAddrMan::GetFilterWhere( const SbaAddrContainer& rContainer )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	String	aResult;
	String aEq( '=' );
	String aAnd; aAnd.AssignAscii( " AND " );
	String aLike; aLike.AssignAscii( " LIKE " );
	xub_StrLen nCount = aNameList.GetTokenCount();
	sal_Unicode cQuote = aDB->GetIdentifierQuote();

	for ( xub_StrLen n = 0; n < nCount; n++ )
	{
		String aField = rContainer.GetField(n);
		xub_StrLen nFldLen = aField.Len();

		if ( nFldLen > 0 )
		{
			sal_Bool bMatch = sal_False;

			if ( aResult.Len() > 0 )
				aResult += aAnd;

			while (aField.SearchAndReplace('*', '%') != STRING_NOTFOUND)
				bMatch = sal_True;
			while (aField.SearchAndReplace('?', '_') != STRING_NOTFOUND)
				bMatch = sal_True;

			if ( !bMatch )
			{
				aField += '%';
				bMatch = sal_True;
			}

			aResult += cQuote;
			aResult += aNameList.GetToken(n);
			aResult += cQuote;
			aResult += bMatch ? aLike : aEq ;
			aResult += '\'';
			aResult += aField;
			aResult += '\'';
		}
	}

	return aResult;
}

// -----------------------------------------------------------------------

void SbaAddrMan::DeleteRow()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );
	DBG_ASSERT( pDataCursor->IsOpen(), "SbaAddrMan::UpdateRow [not open]" );

	if (!pDataCursor->DeleteRow())
	{
		ShowError( pDataCursor );
		pDataCursor->CancelRow();
	}
	else
	{
		SfxViewFrame* pFrame = SfxViewFrame::Current();
		SfxDispatcher* pDisp = 0;

		if (pFrame!=0 && (pDisp = pFrame->GetDispatcher())!=0)
			pDisp->Execute( SID_SBA_QRY_DIRTY );
	}
}

// -----------------------------------------------------------------------

void SbaAddrMan::ReadRow( SbaAddrContainer& rContainer )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( pLDAPSearcher )
		pLDAPSearcher->ReadRow( rContainer );
	else
	{
		DBG_ASSERT( pDataCursor->IsOpen(), "SbaAddrMan::ReadRow [not open]" );

		sal_uInt16 i, nCnt(rContainer.Count()); //(sal_uInt16)
		ODbRowRef aRow(pDataCursor->GetRow());
		FASTBOOL bRow = ( aRow.Is() && aRow->size() );

//		for ( i = 0; i < nCnt; i++ )
		for ( i = 0; bRow && i < ADDR_BOOK_FIELDS_CNT; i++ )
		{
			String aDataStr;

			const SdbColumn* pCol = aRow->getColumns()->Column(aTabColInfo[i].GetName());
			if (pCol)
			{

				const ODbVariantRef& xVar = (*aRow)[pCol->GetId()];
				if (!xVar->isNull() )
				{
					try
					{
						if ( SbaIniWrap::INVITE == i )
						{
							if (xVar->toBOOL())
								aDataStr = '1';
							else
								aDataStr = '0';
						}
						else
							aDataStr = (const sal_Unicode*)xVar->toString();
					}
					catch(...)
					{
					}

				}
			}
			rContainer.SetField( i, aDataStr );
		}
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::PutUniqueAnrede( const String& rAnrede )
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	if ( !rAnrede.Len() )
		return sal_False;

	long nCnt = aAnredeList.Count();

	for ( long i = 0 ; i < nCnt ; i++ )
	{
		if ( rAnrede == *aAnredeList.GetObject(i) )
			return sal_False;// gab es schon
	}

	aAnredeList.InsertString( rAnrede );
	return sal_True; // es wurde eingefuegt
}

// -----------------------------------------------------------------------

const SbaStringList* SbaAddrMan::GetAnredeList()
{
	DBG_CHKTHIS( SbaAddrMan, NULL );

	return &aAnredeList;
}

// -----------------------------------------------------------------------

void SbaAddrMan::InitAnredeList()
{
	SbaAddrContainer aContainer;
	sal_Bool bDone = FetchFirstRow();

	while( bDone )
	{
		ReadRow( aContainer );
		PutUniqueAnrede( aContainer.GetAnrede() );
		bDone = FetchNextRow();
	}
	FetchFirstRow();
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrMan::AddressAlreadyExists( const String& rSQL ) const
{
	sal_Bool bRet = sal_False;
	SdbCursorRef xCrsr( aDB->CreateCursor() );

	if ( xCrsr.Is() )
	{
		xCrsr->Open( rSQL );
		bRet = ( xCrsr->Status().Result() == SDB_STAT_SUCCESS );
	}
	return bRet;
}

// class LDAPCancellable_Impl --------------------------------------------

class LDAPCancellable_Impl : public SfxCancellable
{
private:
	SbaAddrPI*	pAddrPI;

public:
	LDAPCancellable_Impl( SbaAddrPI* pPI, const String& rName ) :
		SfxCancellable( SFX_APP()->GetCancelManager(), rName ),
		pAddrPI( pPI ) {}

	virtual void	Cancel();
};

// -----------------------------------------------------------------------

void LDAPCancellable_Impl::Cancel()
{
	SfxCancellable::Cancel();

	if	( pAddrPI )
		pAddrPI->StopLDAPSearch();
}

// class SbaAddrPI -------------------------------------------------------

IMPL_LINK( SbaAddrPI, GotoRecord, void *, EMPTYARG )
{
	if ( bDontUseDBase )
		return 0;

	WriteRecord();

	sal_uInt16 nPos = aEdActualNumber.GetText().ToInt32();
	nPos--;  // Z"ahlung fuer Anwender ab 1

	if ( nPos >= pSbaAddrMan->GetRowCount() )
		aEdActualNumber.SetText( aEmptyStr );
	else
	{
		if ( pSbaAddrMan->FetchRowAt( nPos ) )
			GetDBaseData();
		aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );
	}
	EnableNavButtons();
	return 0;
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrPI::Close()
{
	pLDAPSearcher->Stop();
	Point aPos(GetPosPixel());
	Size aSize(GetSizePixel());
	SfxIniManager *pIniMgr = SFX_INIMANAGER();
	DBG_ASSERT( pIniMgr, "invalid IniMgr" );
	String aWinData( pIniMgr->GetString( aPos, aSize ) );
	aWinData += pIniMgr->GetToken();
	aWinData += IsRollUp() ? '1' : '0';
	pIniMgr->Set( aWinData, SFX_KEY_WINDOW, DLG_ADDR_PI );

	if ( eSearchMode != NoSearch )
		// Suche beenden
		SearchActiveImpl();
	else if ( bModified && bDontUseDBase == sal_False )
		WriteRecord();
	delete pSbaAddrMan;
	pSbaObject->ReleaseAddrPI();
	Shutdown();
	delete this;

	if ( SfxViewFrame::Current() )
	{
		SfxDispatcher* pDisp = SfxViewFrame::Current()->GetDispatcher();
		SfxBindings* pBind = pDisp ? pDisp->GetBindings() : NULL;

		if	( pBind )
			pBind->Invalidate( SID_SBA_ADDRPI );
	}
	return sal_True;
}

// -----------------------------------------------------------------------

void SbaAddrPI::EnableNavButtons()
{
	sal_uInt32 nCnt(pSbaAddrMan->GetRowCount());
	sal_uInt32 nPos(pSbaAddrMan->GetCurRow());

	// erstmal alles enablen
	aBTNext.Enable();
	aBTLast.Enable();
	aBTFirst.Enable();
	aBTPrev.Enable();
	aEdActualNumber.Enable();
	aDragBtn.Enable( nCnt > 0 && !pSbaAddrMan->GetLDAPSearcher() );

	// dann ggf. manches disablen
	if ( !nCnt || 1 == nCnt )
	{
		aBTFirst.Disable();
		aBTPrev.Disable();
		aBTNext.Disable();
		aBTLast.Disable();
		aEdActualNumber.Disable();
	}
	else if ( nPos == 0 )
	{
		aBTFirst.Disable();
		aBTPrev.Disable();
	}
	else if ( nPos >= nCnt - 1 )
	{
		aBTNext.Disable();
		aBTLast.Disable();
	}
}

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, NextButtonClickHdl, Button *, EMPTYARG )
{
	if ( bDontUseDBase )
		return 0;

	WriteRecord();

	if ( pSbaAddrMan->FetchNextRow() )
		GetDBaseData();

	aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );

	EnableNavButtons();
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, PrevButtonClickHdl, Button *, EMPTYARG )
{
	if ( bDontUseDBase )
		return 0;

	sal_Bool bGo(sal_False);
	sal_uInt32	nCnt = pSbaAddrMan->GetRowCount();

	if ( bAppendActualRecord && !bModified && nCnt > 0 )
		bGo = sal_True;

	WriteRecord();

	if ( bGo )
	{
		// Immer den letzten Datensatz nehmen, damit im Falle sortierten
		// Einfuegens der Anwender nicht verwirrt wird ( es wuerde normaler-
		// weise der *alphabetische* Vorgaenger des zuletzt eingefuegten
		// Datensatzes angezeigt werden)
		pSbaAddrMan->FetchRowAt( nCnt-1 );
		GetDBaseData();
	}
	else if ( pSbaAddrMan->FetchPrevRow() )
		GetDBaseData();

	aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );

	EnableNavButtons();
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, LastButtonClickHdl, Button *, EMPTYARG )
{
	if ( bDontUseDBase )
		return 0;

	WriteRecord();

	if ( pSbaAddrMan->FetchLastRow() )
		GetDBaseData();

	aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );

	EnableNavButtons();
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, FirstButtonClickHdl, Button *, EMPTYARG )
{
	if ( bDontUseDBase )
		return 0;

	WriteRecord();

	if ( pSbaAddrMan->FetchFirstRow() )
		GetDBaseData();

	aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );

	EnableNavButtons();
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, SearchHdl, Control *, pBtn )
{
	if ( bDontUseDBase )
		return 0;

	if ( &aSearchMenuBtn == pBtn )
	{
		sal_uInt16 nId = aSearchMenuBtn.GetCurItemId();
		bInLDAPMode = ( nId > nDefItemId );

		if ( bInLDAPMode )
		{
			nId -= ( nDefItemId + 1 );

			if ( pLDAPSearcher->GetServerName( nId, aLDAPServer ) )
					Enable4LDAP( sal_False, sal_False );
			aLDAPServer.EraseAllChars( '~' );
		}
	}

	// W"ahrend der Suche kein D&D
	aDragBtn.Disable();

	switch ( eSearchMode )
	{
		case NoSearch:
			NoSearchImpl();
			break;

		case SetSearchData:
			SetSearchDataImpl();
			break;

		case SearchActive:
			SearchActiveImpl();
			break;
	}
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SbaAddrPI, SearchEndHdl, Button *, EMPTYARG )
{
	if ( !bDontUseDBase )
	{
		Enable4LDAP( sal_True, sal_False );
		SearchActiveImpl();
	}
	return 0;
}
IMPL_LINK_INLINE_END( SbaAddrPI, SearchEndHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

IMPL_LINK( SbaAddrPI, FinishedHdl, SbaLDAPSearcher *, EMPTYARG )
{
	DELETEZ(pLDAPCancel);
	sal_uInt16 nCount = pLDAPSearcher->GetResultCount();

#ifdef DEBUG
	String aInfo; aInfo.AssignAscii( "Eintraege = " );
	( ( aInfo += nCount ) += '\n' ) += '\n';
	( ( aInfo += pLDAPSearcher->GetReplyString() ) += '\n' ) += '\n';
	sal_uInt16 nMax(10);
	nCount = min( pLDAPSearcher->GetResultCount(), nMax );

	for ( sal_uInt16 i = 0; i < nCount; ++i )
	{
		( aInfo += pLDAPSearcher->GetResultValue( SbaIniWrap::FIRSTNAME, i ) ) += ' ';
		( aInfo += pLDAPSearcher->GetResultValue( SbaIniWrap::LASTNAME, i ) ) += ' ';
		( aInfo += pLDAPSearcher->GetResultValue( SbaIniWrap::EMAIL, i ) ) += '\n';
	}
#endif

	sal_uInt32 nReplyCode = pLDAPSearcher->GetReplyCode();

	if ( !nReplyCode || nCount )
	{
		// entweder kein Fehler oder Fehler trotz gefundener Eintr"age
		Enable4LDAP( sal_True, sal_False );

		if ( !bAddRecordMode )
		{
			String aTmp( aActionBox.GetItemText( BT_NEU ));
			aActionBox.SetItemText( BT_NEU, aNewBtnStr );
			aNewBtnStr = aTmp;
			sal_uInt32 nTmp = aActionBox.GetHelpId( BT_NEU );
			aActionBox.SetHelpText( BT_NEU, aEmptyStr );
			aActionBox.SetHelpId( BT_NEU, nNewBtnHelpId );
			nNewBtnHelpId = nTmp;
			bAddRecordMode = sal_True;
		}

		if ( nReplyCode )
		{
			String aError; aError.AssignAscii("Error: ");
			aError += String::CreateFromInt32(nReplyCode);
			sal_uInt16 nErrorId = pLDAPSearcher->GetErrorResId();

			if ( nErrorId != LDAP_USER_CANCEL )
			{
				if ( nErrorId )
					aError = String( SbaResId( nErrorId ) );
				else if ( pLDAPSearcher->GetReplyString().Len() )
					( ( aError += '\n' ) += '\n' ) += pLDAPSearcher->GetReplyString();
				ErrorBox( this, WB_OK, aError ).Execute();
			}
		}

		if ( !nCount )
		{
			InfoBox( this, SbaResId( INFO_ADR_DATANOTFOUND ) ).Execute();
			SearchEndHdl( NULL );
		}
		else
		{
			pSbaAddrMan->SetLDAPSearcher( pLDAPSearcher );
			pSbaAddrMan->FetchFirstRow();
			GetDBaseData();
			DrawTitleBar( 0 );
			SetFocusInFirstControl();
		}
	}
	else
	{
		String aError; aError.AssignAscii("Error: ");
		aError += String::CreateFromInt32(nReplyCode);
		sal_uInt16 nErrorId = pLDAPSearcher->GetErrorResId();

		if ( nErrorId != LDAP_USER_CANCEL )
		{
			if ( nErrorId )
				aError = String( SbaResId( nErrorId ) );
			else if ( pLDAPSearcher->GetReplyString().Len() )
				( ( aError += '\n' ) += '\n' ) += pLDAPSearcher->GetReplyString();
			pLDAPSearcher->GetCommonError( aError );
			ErrorBox( this, WB_OK, aError ).Execute();
			NoSearchImpl( sal_False );
		}
		else
		{
			Enable4LDAP( sal_True, sal_False );
			SearchActiveImpl();
		}
	}
	EnableNavButtons();
	return 0;
}

/*------------------------------------------------------------------------
 Beschreibung:	ClickHandler der Toolbox
------------------------------------------------------------------------*/

IMPL_LINK( SbaAddrPI, ToolBoxClickHdl, ToolBox *, pBox )
{
	if ( bDontUseDBase )
		return 0;

	const sal_uInt16 nId(pBox->GetCurItemId());
	WriteRecord();
	SfxViewFrame* pFrame = SfxViewFrame::Current();
	SfxDispatcher* pDisp = pFrame ? pFrame->GetDispatcher() : NULL;

	if ( !pDisp || !pSbaAddrMan->GetRowCount() )
		return 0;

	sal_uInt16 nSlotId(0);

	switch ( nId )
	{
		case BT_EINFUEGEN:
			nSlotId = SID_SBA_BRW_INSERT; break;

		case BT_MISCHEN:
			nSlotId = SID_SBA_BRW_UPDATE; break;

		case BT_URL:
		{
			nSlotId = SID_AUTOBROWSE;
			SfxStringItem aURLItem( SID_SBA_QRY_URL, aEdURL.GetText() );
			SfxStringItem aNameItem( SID_AUTOBROWSE, aEdName.GetText() );
			pDisp->Execute( nSlotId, SFX_CALLMODE_SLOT,
							&aURLItem, &aNameItem, 0L );
			pBox->EndSelection();
			return 0;
		}

		case BT_MAIL:
		{
			nSlotId = SID_AUTOMAIL;
			String aEmail(aEdEmail.GetText());
			aEmail.InsertAscii( "mailto:", 0 );
			SfxStringItem aMailItem( SID_SBA_QRY_EMAIL, aEmail );
			String aName(aEdVorname.GetText());
			( aName += ' ' ) += aEdName.GetText();
			SfxStringItem aNameItem( SID_AUTOMAIL, aName );
			pDisp->Execute( nSlotId, SFX_CALLMODE_SLOT,
							&aMailItem, &aNameItem, 0L );
			pBox->EndSelection();
			return 0;
		}
	}

	if ( nSlotId )
	{
		SbaSelectionList* pSelectionList = new SbaSelectionList;
		sal_uInt32 nRow(pSbaAddrMan->GetCurRow() + 1);
		pSelectionList->Insert( (void*)nRow , LIST_APPEND );

		// nur so k"onnen die Applicationen damit etwas anfangen
		String sDBAlias = EnsureDBLink(aDB->Name(), sal_True /* allow ui */, sal_True /* really need an alias */ );

		if (sDBAlias.Len())
		{
			SfxStringItem aDatabaseItem( SID_ATTR_SBA_DATABASE, sDBAlias );
			SfxStringItem aNameItem( SID_ATTR_SBA_DBOBJ_NAME,
									 pSbaAddrMan->GetTableName() );
			SfxStringItem aStatementItem( SID_ATTR_SBA_STATEMENT,
										  pSbaAddrMan->GetCurSelectCmd() );
			SbaSelectionItem aSelectionItem( SID_ATTR_SBA_SELECTION,
											 pSelectionList );

			pDisp->Execute( nSlotId, SFX_CALLMODE_ASYNCHRON, &aDatabaseItem,
							&aNameItem, &aStatementItem, &aSelectionItem, 0L );
		}
		pBox->EndSelection();
	}
	return 0;
}

/*------------------------------------------------------------------------
 Beschreibung:	ClickHandler der 2. Toolbox
------------------------------------------------------------------------*/

IMPL_LINK( SbaAddrPI, ActionHdl, ToolBox *, pBox )
{
	if ( !bDontUseDBase )
	{
		const sal_uInt16 nId = pBox->GetCurItemId();

		switch ( nId )
		{
			case BT_NEU:
				if ( bAddRecordMode )
					AddRecord();
				else
					NewRecord();
				break;

			case BT_LOESCHEN:
				DeleteRecord();
				break;

			case BT_RUECKGAENGIG:
				ResetRecord();
				break;
		}
		pBox->EndSelection();
	}
	return 0;
}

/*------------------------------------------------------------------------
 Beschreibung:	Handler der TabBar
------------------------------------------------------------------------*/

IMPL_LINK( SbaAddrPI, TabSelectHdl, TabBar *, pBar )
{
	sal_Bool bShow = ( aTabBar.GetCurPageId() == TID_PERSONAL );

	aFTAnrede.Show( bShow );
	aCBAnrede.Show( bShow );
	aEdTitel.Show( bShow );
	aFTVorname.Show( bShow );
	aEdVorname.Show( bShow );
	aFTName.Show( bShow );
	aEdName.Show( bShow );
	aFTBriefanrede.Show( bShow );
	aEdBriefanrede.Show( bShow );
	aFTStrasse.Show( bShow );
	aEdStrasse.Show( bShow );
	aFTState.Show( bShow );
	aEdLand.Show( bShow );
	aEdState.Show( bShow );
	aFTOrt.Show( bShow );
	aEdPLZ.Show( bShow );
	aEdOrt.Show( bShow );
	aFTURL.Show( bShow );
	aEdURL.Show( bShow );

	aEdKuerzel.Show( bShow );
	aFTTelPriv.Show( bShow );
	aEdTelPriv.Show( bShow );
	aFTTelHandy.Show( bShow );
	aEdTelHandy.Show( bShow );
	aFTFax.Show( bShow );
	aEdFax.Show( bShow );
	aFTEmail.Show( bShow );
	aEdEmail.Show( bShow );

	String aFullName;

	if ( !bShow )
	{
		String aTmp = aEdVorname.GetText();

		if ( aTmp.Len() )
			aFullName += aTmp;
		aTmp = aEdName.GetText();

		if ( aTmp.Len() )
		{
			if ( aFullName.Len() )
				aFullName += ' ';
			aFullName += aTmp;
		}
	}
	aFTFullNameValue.SetText( aFullName );
	aFTFullName.Show( !bShow );
	aFTFullNameValue.Show( !bShow );

	bShow = ( aTabBar.GetCurPageId() == TID_BUSINESS );

	aFTFirma.Show( bShow );
	aEdFirma.Show( bShow );
	aFTAbteilung.Show( bShow );
	aEdAbteilung.Show( bShow );
	aFTPosition.Show( bShow );
	aEdPosition.Show( bShow );

	aFTTelGesch.Show( bShow );
	aEdTelGesch.Show( bShow );
	aFTTelOffice.Show( bShow );
	aEdTelOffice.Show( bShow );
	aFTTelOther.Show( bShow );
	aEdTelOther.Show( bShow );
	aFTPager.Show( bShow );
	aEdPager.Show( bShow );

	bShow = ( aTabBar.GetCurPageId() == TID_OTHER );

	aFTNote.Show( bShow );
	aEdNote.Show( bShow );
	aFTUser1.Show( bShow );
	aEdUser1.Show( bShow );
	aFTUser2.Show( bShow );
	aEdUser2.Show( bShow );
	aFTUser3.Show( bShow );
	aEdUser3.Show( bShow );
	aFTUser4.Show( bShow );
	aEdUser4.Show( bShow );
	aOtherLine.Show( bShow );
	aFTCalendarURL.Show( bShow );
	aEdCalendarURL.Show( bShow );
	aCBInvite.Show( bShow );

	SetFocusInFirstControl();
	return 0;
}

/*------------------------------------------------------------------------
 Beschreibung:	Handler der TabBar
------------------------------------------------------------------------*/

IMPL_LINK( SbaAddrPI, ModifyHdl, Control *, pControl )
{
	// Feld zur Angabe einer Datensatznummer soll den
	// 'R"uckg"angig'-Button nicht freigeben
	if (eSearchMode != SetSearchData && pControl != &aEdActualNumber)
	{
		if ( !bModified &&
			 !bAppendActualRecord && pSbaAddrMan->GetRowCount() > 0 )
			aActionBox.EnableItem( BT_RUECKGAENGIG, sal_True );
		bModified = sal_True;
	}

	if ( pControl == &aEdEmail )
		aSelectBox.EnableItem( BT_MAIL, (sal_Bool)aEdEmail.GetText().Len() );
	else if ( pControl == &aEdURL )
		aSelectBox.EnableItem( BT_URL, (sal_Bool)aEdURL.GetText().Len() );
	return 0;
}

// -----------------------------------------------------------------------

void SbaAddrPI::NoSearchImpl( sal_Bool bClear )
{
	if ( bDontUseDBase )
		return;

	if ( bModified )
		WriteRecord();

	eSearchMode = SetSearchData;
	aSearchMenuBtn.Hide();
	aBTSuchen.Enable();
	aBTSuchen.SetText( aStrSearchStart );

	if ( !bHasLDAPServer )
	{
		Size aSiz = aBTSuchen.GetSizePixel();
		long aW = aEndBtn.GetSizePixel().Width();

		if ( aSiz.Width() == aW )
			aSiz.Width() += aW;
		aBTSuchen.SetSizePixel( aSiz );
		aBTSuchen.Show();
	}
	else
		aEndBtn.Show();
	aBTSuchen.Show();
	FASTBOOL bEnable = ( !bReadOnlyDoc && NoSearch == eSearchMode );
	aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && bEnable );
	aSelectBox.EnableItem( BT_MISCHEN, bMischen && bEnable );
	aBTFirst.Disable();
	aBTPrev.Disable();
	aEdActualNumber.Disable();
	aBTNext.Disable();
	aBTLast.Disable();
	aActionBox.EnableItem( BT_NEU, sal_False );
	aActionBox.EnableItem( BT_LOESCHEN, sal_False );
	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );

	if ( bClear )
		ClearFields();

	SetReadOnly( sal_False );
	aTabBar.SetCurPageId( TID_PERSONAL );
	TabSelectHdl( &aTabBar );
	aEdName.GrabFocus();
	aCBInvite.EnableTriState( sal_True );
	aCBInvite.SetState( STATE_DONTKNOW );
}

// -----------------------------------------------------------------------

void SbaAddrPI::SetSearchDataImpl()
{
	SetReadOnly( !pSbaAddrMan->MayUpdateRow() );

	if ( bDontUseDBase )
		return;

	eSearchMode = SearchActive;
	bModified   = sal_False;
	FASTBOOL bEnable = ( !bReadOnlyDoc && NoSearch == eSearchMode );
	aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && bEnable );
	aSelectBox.EnableItem( BT_MISCHEN, bMischen && bEnable );

	aEdActualNumber.Enable();
	aActualSelection.Erase();

	SbaAddrContainer aContainer;
	GetFields( aContainer, sal_False );

	if ( bInLDAPMode )
	{
		String aFilter;
		String aTmp( aContainer.GetFirma());

		if ( aTmp.Len() )
		{
			aFilter.AssignAscii("o=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetAbteilung();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("ou=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetName();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("cn=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetLand();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("c=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetOrt();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("l=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetStrasse();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("street=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetTelPriv();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("telephoneNumber=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetEmail();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("mail=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aTmp = aContainer.GetState();

		if ( aTmp.Len() )
		{
			aFilter.AppendAscii("sp=");
			( aFilter += aTmp ) += LDAP_TOKEN_DELIMITER;
		}
		aFilter.EraseTrailingChars( LDAP_TOKEN_DELIMITER );
		sal_Bool bSearch(sal_False);
		pLDAPSearcher->Init();

		if ( aFilter.Len() )
		{
			if ( !bHasLDAPServer )
				aBTSuchen.SetText( aStrSearchStop );
			else
				aBTSuchen.Disable();
			bSearch = pLDAPSearcher->Search( aLDAPServer, aFilter );

			if ( bSearch )
			{
				pLDAPCancel = new LDAPCancellable_Impl( this, aLDAPServer );
				aActionBox.EnableItem( BT_NEU, pSbaAddrMan->MayAppendRow() );
			}
		}

		if ( !bSearch )
			pLDAPSearcher->Stop();
		EnableNavButtons();
		return;
	}
	aActualSelection = pSbaAddrMan->GetFilterWhere( aContainer );
	pSbaAddrMan->BuildSelectCmd( aActualSelection, sal_True );

	if ( aActualSelection.Len() > 0 )
	{
		if ( !bHasLDAPServer )
			aBTSuchen.SetText( aStrSearchStop );
		else
			aBTSuchen.Disable();

		if ( pSbaAddrMan->GetRowCount() == 0 )
		{
			InfoBox( this, SbaResId( INFO_ADR_DATANOTFOUND ) ).Execute();
			SearchActiveImpl();
		}
		else
		{
			pSbaAddrMan->FetchFirstRow();
			GetDBaseData();
			aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );
			DrawTitleBar( 0 );
			SetFocusInFirstControl();
		}
	}
	else
		SearchActiveImpl();
	EnableNavButtons();
}

// -----------------------------------------------------------------------

void SbaAddrPI::SearchActiveImpl()
{
	SetReadOnly( !pSbaAddrMan->MayUpdateRow() );
	sal_uInt32 nCnt = 0;
	FASTBOOL bExternSearcher = ( pSbaAddrMan->GetLDAPSearcher() != NULL );
	pLDAPSearcher->Stop();
	pSbaAddrMan->SetLDAPSearcher( NULL );
	aCBInvite.EnableTriState( sal_False );

	if ( bDontUseDBase )
		return;

	// bei aktiver Filterung kann nicht appended werden
	if ( !bExternSearcher && bModified && pSbaAddrMan->GetRowCount() > 0 )
		WriteRecord();

	aActualSelection.Erase();
	eSearchMode = NoSearch;
	aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && !bReadOnlyDoc );
	aSelectBox.EnableItem( BT_MISCHEN, bMischen && !bReadOnlyDoc );
	pSbaAddrMan->BuildSelectCmd( aActualSelection, sal_True );

	// jetzt ggf. appenden
	if ( !bExternSearcher && bModified && pSbaAddrMan->GetRowCount() == 0 )
		WriteRecord();

	if ( ( nCnt = pSbaAddrMan->GetRowCount() ) == 0 )
	{
		aActionBox.EnableItem( BT_LOESCHEN, sal_False );

		if ( !bHasLDAPServer )
		{
			aBTSuchen.Disable();
			aSearchMenuBtn.Disable();
		}
	}
	else
	{
		pSbaAddrMan->FetchFirstRow();
		GetDBaseData();
		aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );
	}
	aSearchMenuBtn.GetPopupMenu()->EnableItem( MN_ADDRESSBOOK, nCnt > 1 );
	aActionBox.EnableItem( BT_NEU, pSbaAddrMan->MayAppendRow() );

	if ( bHasLDAPServer )
	{
		aBTSuchen.Hide();
		aEndBtn.Hide();
		aSearchMenuBtn.Show();

		if ( bAddRecordMode )
		{
			String aTmp( aActionBox.GetItemText( BT_NEU ));
			aActionBox.SetItemText( BT_NEU, aNewBtnStr );
			aNewBtnStr = aTmp;
			sal_uInt32 nTmp = aActionBox.GetHelpId( BT_NEU );
			aActionBox.SetHelpText( BT_NEU, aEmptyStr );
			aActionBox.SetHelpId( BT_NEU, nNewBtnHelpId );
			nNewBtnHelpId = nTmp;
			bAddRecordMode = sal_False;
		}
		aActionBox.Show();
	}
	else
		aBTSuchen.SetText( aStrSearch );
	bInLDAPMode = sal_False;
	DrawTitleBar( nCnt );
	SetFocusInFirstControl();
	EnableNavButtons();

	if ( bMustUpdate )
		OnChangeAddrbook();
}

// -----------------------------------------------------------------------

void SbaAddrPI::ModifyNotify( Control* pControl )
{
	// Feld zur Angabe einer Datensatznummer soll den
	// 'R"uckg"angig'-Button nicht freigeben
	if (eSearchMode != SetSearchData && pControl != &aEdActualNumber)
	{
		if ( !bModified &&
			 !bAppendActualRecord && pSbaAddrMan->GetRowCount() > 0 )
			aActionBox.EnableItem( BT_RUECKGAENGIG, sal_True );
		bModified = sal_True;
	}

	if ( pControl == &aEdEmail )
		aSelectBox.EnableItem( BT_MAIL, (sal_Bool)aEdEmail.GetText().Len() );
	else if ( pControl == &aEdURL )
		aSelectBox.EnableItem( BT_URL, (sal_Bool)aEdURL.GetText().Len() );
}

//--------------------------------------------------------------------

void SbaAddrPI::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
	if ( bNotifyDisabled )
		return;

	const SfxSimpleHint* pHint = PTR_CAST(SfxSimpleHint, &rHint);

	if ( pHint && pHint->GetId() == SFX_HINT_DATACHANGED )
	{
		if ( NoSearch == eSearchMode )
			OnChangeAddrbook();
		else
			bMustUpdate = sal_True;
	}
}

//--------------------------------------------------------------------

long SbaAddrPI::Notify( NotifyEvent& rNEvt )
{
	long nHandled = 0;

	if ( rNEvt.GetType() == EVENT_KEYINPUT && rNEvt.GetKeyEvent() )
	{
		const KeyEvent* pKeyEvt = rNEvt.GetKeyEvent();
		const KeyCode& rCode = pKeyEvt->GetKeyCode();
		sal_uInt16 nCode = rCode.GetCode();

		if ( rCode.IsMod1() )
		{
			if ( KEY_1 == nCode || KEY_2 == nCode || KEY_3 == nCode ||
				 KEY_PAGEUP == nCode || KEY_PAGEDOWN == nCode )
			{
				sal_uInt16 nCurPageId = aTabBar.GetCurPageId();
				sal_uInt16 nPageId = TID_PERSONAL;

				if ( KEY_PAGEUP == nCode )
					nPageId = ( TID_OTHER == nCurPageId ) ? 0 : nCurPageId + 1;
				else if ( KEY_PAGEDOWN == nCode )
					nPageId = ( TID_PERSONAL == nCurPageId ) ? 0 : nCurPageId - 1;
				else if ( KEY_2 == nCode )
					nPageId = TID_BUSINESS;
				else if ( KEY_3 == nCode )
					nPageId = TID_OTHER;

				if ( nPageId && aTabBar.GetCurPageId() != nPageId )
				{
					aTabBar.SetCurPageId( nPageId );
					TabSelectHdl( NULL );
				}
				nHandled = 1;
			}
		}
		else if ( eSearchMode != NoSearch && KEY_ESCAPE == nCode )
		{
			SearchEndHdl( NULL );
			SetFocusInFirstControl();
			nHandled = 1;
		}
		else if ( SetSearchData == eSearchMode && KEY_RETURN == nCode )
		{
			SearchHdl( NULL );
			SetFocusInFirstControl();
			nHandled = 1;
		}
	}

	return nHandled ? nHandled : ModelessDialog::Notify( rNEvt );
}

// -----------------------------------------------------------------------

void SbaAddrPI::Paint( const Rectangle& rRect )
{
	ModelessDialog::Paint( rRect );
	Point aPnt = aDragBtn.GetPosPixel();
	aPnt.X() -= 2;
	aPnt.Y() -= 2;
	Size aSiz = aDragBtn.GetSizePixel();
	aSiz.Width() += 4;
	aSiz.Height() += 4;
	Rectangle aRect( aPnt, aSiz );
	sal_uInt16 nStyle = BUTTON_DRAW_NOFILL;
	aDecoView.DrawButton( aRect, nStyle );
	aRect.SetPos( aHiddenGB.GetPosPixel() );
	aRect.SetSize( aHiddenGB.GetSizePixel() );
	aDecoView.DrawButton( aRect, nStyle );
}

// -----------------------------------------------------------------------

void SbaAddrPI::GetDBaseData()
{
	if ( bDontUseDBase )
		return;

	SbaAddrContainer aContainer;
	pSbaAddrMan->ReadRow( aContainer );
	SetFields( aContainer );

	aSelectBox.EnableItem( BT_URL, (sal_Bool)aEdURL.GetText().Len() );
	aSelectBox.EnableItem( BT_MAIL, (sal_Bool)aEdEmail.GetText().Len() );
}

// -----------------------------------------------------------------------

void SbaAddrPI::SetFields( const SbaAddrContainer& rSbaCont )
{
	// Wenn in der Adressbuchtabelle eine Spalte fuer das Control
	// existiert, enablen, ansonsten disablen
	String aEmptyString;

#define SETTEXT_OR_DISABLE(n,m,g)						\
	if ( pSbaAddrMan->GetTabColInfo(n).IsVisible() )	\
	{													\
        m.SetText( rSbaCont.Get##g() );					\
		m.ClearModifyFlag();							\
	}													\
    else												\
        m.Disable();

	SETTEXT_OR_DISABLE(  0, aEdFirma,		Firma )
	SETTEXT_OR_DISABLE(	 1, aEdAbteilung,	Abteilung )
	SETTEXT_OR_DISABLE(  2, aEdVorname,		Vorname )
	SETTEXT_OR_DISABLE(  3, aEdName,		Name )
	SETTEXT_OR_DISABLE(  4, aEdStrasse,		Strasse )
	SETTEXT_OR_DISABLE(  5, aEdLand,		Land )
	SETTEXT_OR_DISABLE(  6, aEdPLZ,			Plz )
	SETTEXT_OR_DISABLE(  7, aEdOrt,			Ort )
	SETTEXT_OR_DISABLE(  8, aEdTitel,		Titel )
	SETTEXT_OR_DISABLE(  9, aEdPosition,	Position )
	SETTEXT_OR_DISABLE( 10, aCBAnrede,		Anrede )
	SETTEXT_OR_DISABLE( 11, aEdKuerzel,		Kuerzel )
	SETTEXT_OR_DISABLE( 12, aEdBriefanrede,	BriefAnrede )
	SETTEXT_OR_DISABLE( 13, aEdTelPriv,		TelPriv )
	SETTEXT_OR_DISABLE( 14, aEdTelGesch,	TelGesch )
	SETTEXT_OR_DISABLE( 15, aEdFax,			Fax )
	SETTEXT_OR_DISABLE( 16, aEdEmail,		Email )
	SETTEXT_OR_DISABLE( 17, aEdURL,			URL )
	SETTEXT_OR_DISABLE( 18, aEdNote,		Note )
	SETTEXT_OR_DISABLE( 19, aEdUser1,		UserField1 )
	SETTEXT_OR_DISABLE( 20, aEdUser2,		UserField2 )
	SETTEXT_OR_DISABLE( 21, aEdUser3,		UserField3 )
	SETTEXT_OR_DISABLE( 22, aEdUser4,		UserField4 )
	// Feld "ID" (23) wird nur intern benutzt
	SETTEXT_OR_DISABLE( 24, aEdState,		State )
	SETTEXT_OR_DISABLE( 25, aEdTelOffice,	OfficePhone )
	SETTEXT_OR_DISABLE( 26, aEdPager,		Pager )
	SETTEXT_OR_DISABLE( 27, aEdTelHandy,	HandyPhone )
	SETTEXT_OR_DISABLE( 28, aEdTelOther,	OtherPhone )
	SETTEXT_OR_DISABLE( 29, aEdCalendarURL,	CalendarURL )

	if ( !pSbaAddrMan->GetTabColInfo(29).IsVisible() )
		aFTCalendarURL.Disable();

	if ( pSbaAddrMan->GetTabColInfo(30).IsVisible() )
	{
		String aStr = rSbaCont.GetInvite();
		sal_Bool bInvite = aStr.ToInt32();
		aCBInvite.Check( bInvite );
	}
	else
		aCBInvite.Disable();

	String aFullName, aTmp = aEdVorname.GetText();

	if ( aTmp.Len() )
		aFullName += aTmp;
	aTmp = aEdName.GetText();

	if ( aTmp.Len() )
	{
		if ( aFullName.Len() )
			aFullName += ' ';
		aFullName += aTmp;
	}
	aFTFullNameValue.SetText( aFullName );
	aEdActualNumber.SetText ( String::CreateFromInt32( pSbaAddrMan->GetCurRow() + 1 ) );

	#undef SETTEXT_OR_DISABLE
}

// -----------------------------------------------------------------------

void SbaAddrPI::UpdateAnredeList()
{
	aCBAnrede.Clear();
	long i, j, nCnt = aStrAnreden.GetTokenCount();

	for ( i = 0; i < nCnt; ++i )
		aCBAnrede.InsertEntry( aStrAnreden.GetToken( (xub_StrLen)i ) );

	const SbaStringList* pList = pSbaAddrMan->GetAnredeList();
	nCnt = pList->Count();

	for ( i = 0; i < nCnt; ++i )
	{
		FASTBOOL bFound = sal_False;
		String aEntry( *pList->GetObject(i) );

		for ( j = 0; j < aStrAnreden.GetTokenCount(); ++j )
		{
			if ( aStrAnreden.GetToken( (xub_StrLen)j ) == aEntry )
			{
				bFound = sal_True;
				break;
			}
		}

		if ( !bFound )
			aCBAnrede.InsertEntry( aEntry );
	}
}

// -----------------------------------------------------------------------

void SbaAddrPI::ClearFields( void )
{
	aEdFirma.SetText( aEmptyStr );
	aEdVorname.SetText( aEmptyStr );
	aEdName.SetText( aEmptyStr );
	aEdStrasse.SetText( aEmptyStr );
	aEdLand.SetText( aEmptyStr );
	aEdPLZ.SetText( aEmptyStr );
	aEdOrt.SetText( aEmptyStr );
	aEdTitel.SetText( aEmptyStr );
	aEdPosition.SetText( aEmptyStr );

	if ( eSearchMode != SetSearchData )
		aCBAnrede.SetText( aCBAnrede.GetEntry(0) );
	else
		// bei Eingabe von Suchmustern keine Standardvorgabe
		aCBAnrede.SetText( aEmptyStr );

	aEdKuerzel.SetText( aEmptyStr );
	aEdBriefanrede.SetText( aEmptyStr );
	aEdTelPriv.SetText( aEmptyStr );
	aEdTelGesch.SetText( aEmptyStr );
	aEdFax.SetText( aEmptyStr );
	aEdEmail.SetText( aEmptyStr );
	aEdURL.SetText( aEmptyStr );
	aEdAbteilung.SetText( aEmptyStr );

	aEdNote.SetText( aEmptyStr );
	aEdUser1.SetText( aEmptyStr );
	aEdUser2.SetText( aEmptyStr );
	aEdUser3.SetText( aEmptyStr );
	aEdUser4.SetText( aEmptyStr );
	aEdState.SetText( aEmptyStr );
	aEdTelOffice.SetText( aEmptyStr );
	aEdPager.SetText( aEmptyStr );
	aEdTelHandy.SetText( aEmptyStr );
	aEdTelOther.SetText( aEmptyStr );
	aEdCalendarURL.SetText( aEmptyStr );
	aCBInvite.Check( sal_False );

	aEdActualNumber.SetText( aEmptyStr );
}

// -----------------------------------------------------------------------

void SbaAddrPI::GetFields( SbaAddrContainer& rSbaCont, sal_Bool bWrite )
{
	String aNullValue( NULL_VALUE );

#define GETTEXT_OR_SETNULL(c,f)								\
	if ( bWrite && !c.IsModified() && !c.GetText().Len() )	\
		rSbaCont.Set##f( aNullValue );						\
	else													\
		rSbaCont.Set##f( c.GetText() );

	GETTEXT_OR_SETNULL(aEdFirma,Firma)
	GETTEXT_OR_SETNULL(aEdAbteilung,Abteilung)
	GETTEXT_OR_SETNULL(aEdVorname,Vorname)
	GETTEXT_OR_SETNULL(aEdName,Name)
	GETTEXT_OR_SETNULL(aEdStrasse,Strasse)
	GETTEXT_OR_SETNULL(aEdLand,Land)
	GETTEXT_OR_SETNULL(aEdPLZ,Plz)
	GETTEXT_OR_SETNULL(aEdOrt,Ort)
	GETTEXT_OR_SETNULL(aEdTitel,Titel)
	GETTEXT_OR_SETNULL(aEdPosition,Position)
	GETTEXT_OR_SETNULL(aCBAnrede,Anrede)
	GETTEXT_OR_SETNULL(aEdKuerzel,Kuerzel)
	GETTEXT_OR_SETNULL(aEdBriefanrede,BriefAnrede)
	GETTEXT_OR_SETNULL(aEdTelPriv,TelPriv)
	GETTEXT_OR_SETNULL(aEdTelGesch,TelGesch)
	GETTEXT_OR_SETNULL(aEdFax,Fax)
	GETTEXT_OR_SETNULL(aEdEmail,Email)
	GETTEXT_OR_SETNULL(aEdURL,URL)
	GETTEXT_OR_SETNULL(aEdNote,Note)
	GETTEXT_OR_SETNULL(aEdUser1,UserField1)
	GETTEXT_OR_SETNULL(aEdUser2,UserField2)
	GETTEXT_OR_SETNULL(aEdUser3,UserField3)
	GETTEXT_OR_SETNULL(aEdUser4,UserField4)
	GETTEXT_OR_SETNULL(aEdState,State)
	GETTEXT_OR_SETNULL(aEdTelOffice,OfficePhone)
	GETTEXT_OR_SETNULL(aEdPager,Pager)
	GETTEXT_OR_SETNULL(aEdTelHandy,HandyPhone)
	GETTEXT_OR_SETNULL(aEdTelOther,OtherPhone)

	// Email-Adresse ggf. in eine mailto-::com::sun::star::util::URL verwandeln
	String aCalURL = aEdCalendarURL.GetText();
	if ( bWrite && aCalURL.Len() &&
		 aCalURL.EqualsIgnoreCaseAscii( ".schedule", 0, 9 ) != COMPARE_EQUAL &&
		 aCalURL.EqualsIgnoreCaseAscii( "mailto:", 0, 7 ) != COMPARE_EQUAL )
		aCalURL.InsertAscii( "mailto:", 0 );

	if ( bWrite && !aEdCalendarURL.IsModified() && !aEdCalendarURL.GetText().Len() )
		rSbaCont.SetCalendarURL( aNullValue );
	else
		rSbaCont.SetCalendarURL( aCalURL );

	if ( !aCBInvite.IsTriStateEnabled() )
	{
		String aBool = aCBInvite.IsChecked() ? '1' : '0';
		rSbaCont.SetInvite( aBool );
	}

#undef GETTEXT_OR_SETNULL
}

// -----------------------------------------------------------------------

void SbaAddrPI::WriteRecord()
{
	sal_uInt32 nCnt = pSbaAddrMan->GetRowCount();

	if ( bDontUseDBase )
		return;

	if ( bModified )
	{
		SbaAddrContainer aContainer;
		GetFields( aContainer, sal_True );
		if ( bAppendActualRecord || !nCnt )
		{
			if ( pSbaAddrMan->PutUniqueAnrede( aContainer.GetAnrede() ) )
				UpdateAnredeList();

			pSbaAddrMan->InsertRow( aContainer );
			nFirstRecordCount++;
			nCnt = pSbaAddrMan->GetRowCount();
			DrawTitleBar( nCnt );
		}
		else
		{
			if ( pSbaAddrMan->PutUniqueAnrede( aContainer.GetAnrede() ) )
				UpdateAnredeList();
			pSbaAddrMan->UpdateRow( aContainer );
		}
		BroadcastUpdate();
	}

	bModified = sal_False;

	if ( bAppendActualRecord )
	{
		if ( !pSbaAddrMan->MayUpdateRow() )
			SetReadOnly( sal_True );
		bAppendActualRecord = sal_False;
	}

	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );

	if ( nCnt > 1 || bHasLDAPServer )
	{
		// mehr als ein Eintrag oder LDAP -> Suchen lohnt sich
//		aBTSuchen.Enable();
		aSearchMenuBtn.Enable();
	}
	aSearchMenuBtn.GetPopupMenu()->EnableItem( MN_ADDRESSBOOK, nCnt > 1 );
}

// -----------------------------------------------------------------------

void SbaAddrPI::InsertRecord()
{
	if ( bDontUseDBase )
		return;

	SbaAddrContainer aContainer;
	GetFields( aContainer, sal_True );

	if ( pSbaAddrMan->PutUniqueAnrede( aContainer.GetAnrede() ) )
		UpdateAnredeList();

	if ( pSbaAddrMan->NewRow( aContainer ) )
		nFirstRecordCount++;
}

// -----------------------------------------------------------------------

SbaAddrPI::SbaAddrPI
(
	Window* pParent,
	sal_Bool& rSuccess,
	SbaObject* pSbaObj,
	sal_Bool bInsert,
	sal_Bool bMerge
) :

	ModelessDialog( pParent, SbaResId( DLG_ADDR_PI ) ),
	SfxControllerItem( SID_DOC_READONLY, SFX_BINDINGS() ),

	aTabBar			( this, WB_TOPBORDER | WB_TABSTOP ),

	aFTAnrede		( this, ResId( FT_ANREDE ) ),
	aCBAnrede		( this, ResId( COMBO_ANREDE ) ),
	aEdTitel		( this, ResId( ED_TITEL ) ),
	aFTVorname		( this, ResId( FT_VORNAME ) ),
	aEdVorname		( this, ResId( ED_VORNAME ) ),
	aFTName			( this, ResId( FT_NAME ) ),
	aEdName			( this, ResId( ED_NAME ) ),
	aFTBriefanrede	( this, ResId( FT_BRIEFANREDE ) ),
	aEdBriefanrede	( this, ResId( ED_BRIEFANREDE ) ),
	aFTStrasse		( this, ResId( FT_STRASSE ) ),
	aEdStrasse		( this, ResId( ED_STRASSE ) ),
	aFTState		( this, ResId( FT_STATE ) ),
	aEdLand			( this, ResId( ED_LAND ) ),
	aEdState		( this, ResId( ED_STATE ) ),
	aFTOrt			( this, ResId( FT_ORT ) ),
	aEdPLZ			( this, ResId( ED_PLZ ) ),
	aEdOrt			( this, ResId( ED_ORT ) ),
	aFTKuerzel		( this, ResId( FT_KUERZEL ) ),
	aEdKuerzel		( this, ResId( ED_KUERZEL ) ),
	aFTTelPriv		( this, ResId( FT_TELPRIV ) ),
	aEdTelPriv		( this, ResId( ED_TELPRIV ) ),
	aFTTelHandy		( this, ResId( FT_TEL_HANDY ) ),
	aEdTelHandy		( this, ResId( ED_TEL_HANDY ) ),
	aFTFax			( this, ResId( FT_FAX ) ),
	aEdFax			( this, ResId( ED_FAX ) ),
	aFTEmail		( this, ResId( FT_EMAIL ) ),
	aEdEmail		( this, ResId( ED_EMAIL ) ),
	aFTURL			( this, ResId( FT_URL ) ),
	aEdURL			( this, ResId( ED_URL ) ),

	aFTFullName		( this, ResId( FT_FULLNAME ) ),
	aFTFullNameValue( this, ResId( FT_FULLNAMEVALUE ) ),
	aFTFirma		( this, ResId( FT_FIRMA ) ),
	aEdFirma		( this, ResId( ED_FIRMA ) ),
	aFTAbteilung	( this, ResId( FT_ABTEILUNG ) ),
	aEdAbteilung	( this, ResId( ED_ABTEILUNG ) ),
	aFTPosition		( this, ResId( FT_POSITION ) ),
	aEdPosition		( this, ResId( ED_POSITION ) ),
	aFTTelGesch		( this, ResId( FT_TELGESCH ) ),
	aEdTelGesch		( this, ResId( ED_TELGESCH ) ),
	aFTTelOffice	( this, ResId( FT_TEL_OFFICE ) ),
	aEdTelOffice	( this, ResId( ED_TEL_OFFICE ) ),
	aFTTelOther		( this, ResId( FT_TEL_OTHER ) ),
	aEdTelOther		( this, ResId( ED_TEL_OTHER ) ),
	aFTPager		( this, ResId( FT_PAGER ) ),
	aEdPager		( this, ResId( ED_PAGER ) ),

	aFTUser1		( this, ResId( FT_USER1 ) ),
	aEdUser1		( this, ResId( ED_USER1 ) ),
	aFTUser2		( this, ResId( FT_USER2 ) ),
	aEdUser2		( this, ResId( ED_USER2 ) ),
	aFTUser3		( this, ResId( FT_USER3 ) ),
	aEdUser3		( this, ResId( ED_USER3 ) ),
	aFTUser4		( this, ResId( FT_USER4 ) ),
	aEdUser4		( this, ResId( ED_USER4 ) ),
	aFTNote			( this, ResId( FT_NOTE ) ),
	aEdNote			( this, ResId( ED_NOTE ) ),
	aOtherLine		( this, ResId( FL_OTHER ) ),
	aFTCalendarURL	( this, ResId( FT_CALENDARURL ) ),
	aEdCalendarURL	( this, ResId( ED_CALENDARURL ) ),
	aCBInvite		( this, ResId( CB_INVITE ) ),

	aSelectBox		( this, ResId( TB_1 ) ),

	aSearchMenuBtn	( this, ResId( BTN_SEARCH ) ),
	aBTSuchen		( this, ResId( BT_SUCHEN ) ),
	aEndBtn			( this, ResId( BTN_END ) ),

	aBTFirst		( this, ResId( BT_FIRST ) ),
	aBTPrev			( this, ResId( BT_PREV ) ),

	aEdActualNumber	( this, ResId( ED_ACTUALNUMBER ) ),

	aBTNext			( this, ResId( BT_NEXT ) ),
	aBTLast			( this, ResId( BT_LAST ) ),

	aActionBox		( this, ResId( TB_2 ) ),

	aDragBtn		( this ),
	aFTStatus		( this, ResId( FT_STATUS ) ),
	aHiddenGB		( this, ResId( GB_HIDDEN ) ),
	aDecoView		( this ),

	aStrSearch		( ResId( STR_ADDRPI_SUCHEN ) ),
	aStrSearchStart	( ResId( STR_ADDRPI_START ) ),
	aStrSearchStop	( ResId( STR_ADDRPI_ENDE ) ),
	aStrAnreden		( ResId( STR_ADDRPI_ANREDE ) ),
	aSearchStr		( ResId( STR_ADDRPI_SEARCH ) ),
	aNameStr		( ResId( STR_ADDRPI_NAME ) ),
	aPhoneStr		( ResId( STR_ADDRPI_PHONE ) ),
	aNewBtnStr		( ResId( STR_ADDRPI_NEWBTN ) ),
	aReadOnlyStr	( ResId ( STR_ADDRPI_READONLY ) ),

	nDefItemId		( 0 ),
	nNewBtnHelpId	( HID_ADDRPI_ADDADDRESS ),
	pLDAPSearcher	( NULL ),
	pLDAPCancel		( NULL ),
	pSbaAddrMan		( NULL ),
	pSbaObject		( pSbaObj ),
	bEinfuegen		( bInsert ),
	bMischen		( bMerge ),
	bReadOnlyDoc	( sal_False ),
	bInLDAPMode		( sal_False ),
	bHasLDAPServer	( sal_False ),
	bAddRecordMode  ( sal_False ),
	bMustUpdate     ( sal_False ),
	bNotifyDisabled ( sal_False ),
	bStatus			( sal_False ),
	bTextChanged	( sal_False )

{
	aTabBar.SetSelectColor( GetBackground().GetColor() );
	aTabBar.SetHelpId( HID_DLG_ADDR_PI_TABBAR );
	aTabBar.SetSelectHdl( LINK( this, SbaAddrPI, TabSelectHdl ) );
	aTabBar.InsertPage( TID_PERSONAL, String( ResId( STR_TABBAR_PERSONAL ) ) );
	aTabBar.InsertPage( TID_BUSINESS, String( ResId( STR_TABBAR_BUSINESS ) ) );
	aTabBar.InsertPage( TID_OTHER, String( ResId( STR_TABBAR_OTHER ) ) );
	aTabBar.SetCurPageId( 1 );
	aTabBar.Show();

	FreeResource();

	Point aHiddenGBPos = aHiddenGB.GetPosPixel();
	Size aHiddenGBSize = aHiddenGB.GetSizePixel();
	Point aPnt1 = aCBAnrede.GetPosPixel();
	Point aPnt2 = aHiddenGBPos;
	aPnt2.Y() += aHiddenGBSize.Height();
	aTabBar.SetPosPixel( aPnt2 );
	Size aSize = aTabBar.CalcWindowSizePixel();
	Size aDlgSize = GetOutputSizePixel();
	aTabBar.SetSizePixel( aSize );
	TabSelectHdl( &aTabBar );

	nStatusOffset = aPnt1.Y() + aFTStatus.GetSizePixel().Height();
	aSelectBox.SetSizePixel( aSelectBox.CalcWindowSizePixel() );
	Size aDragBtnSize = aSelectBox.GetSizePixel();
	aDragBtnSize.Height() -= 4;
	aDragBtnSize.Width() = ( aDragBtnSize.Width() / aSelectBox.GetItemCount() ) - 2;
	aDragBtn.SetSizePixel( aDragBtnSize );
	aPnt2 = aSelectBox.GetPosPixel();
	aPnt2.X() = aHiddenGBPos.X() + aHiddenGBSize.Width() - aDragBtn.GetSizePixel().Width() - 2;
	aPnt2.Y() += 2;
	aDragBtn.SetPosPixel( aPnt2 );
	aDragBtn.Show();

	// ToolBox ausrichten
	long nDelta = ( aSelectBox.GetSizePixel().Height() -
					aSearchMenuBtn.GetSizePixel().Height() ) / 2;
	Point aNewPnt( aFTFirma.GetPosPixel().X(),
				   aSearchMenuBtn.GetPosPixel().Y() - nDelta );
	aSelectBox.SetPosPixel( aNewPnt );
	long nXPos = aNewPnt.X() + aSelectBox.GetSizePixel().Width() + 6;
	aActionBox.SetSizePixel( aActionBox.CalcWindowSizePixel() );
	aNewPnt.X() = aActionBox.GetPosPixel().X();
	aActionBox.SetPosPixel( aNewPnt );
	nDelta = nXPos - aSearchMenuBtn.GetPosPixel().X();

	if ( nDelta > 0 )
	{
		// wenn die linke ToolBox in den Suchen-Button ragt, m"ussen alle
		// Controls ab dieser Position etwas nach links verschoben werden
		aNewPnt = aBTSuchen.GetPosPixel();
		aNewPnt.X() += nDelta;
		aBTSuchen.SetPosPixel( aNewPnt );
		aNewPnt = aSearchMenuBtn.GetPosPixel();
		aNewPnt.X() += nDelta;
		aSearchMenuBtn.SetPosPixel( aNewPnt );
		aNewPnt = aEndBtn.GetPosPixel();
		aNewPnt.X() += nDelta;
		aEndBtn.SetPosPixel( aNewPnt );
		aNewPnt = aBTFirst.GetPosPixel();
		aNewPnt.X() += nDelta;
		aBTFirst.SetPosPixel( aNewPnt );
		aNewPnt = aBTPrev.GetPosPixel();
		aNewPnt.X() += nDelta;
		aBTPrev.SetPosPixel( aNewPnt );
		aNewPnt = aEdActualNumber.GetPosPixel();
		aNewPnt.X() += nDelta;
		aEdActualNumber.SetPosPixel( aNewPnt );
		aNewPnt = aBTNext.GetPosPixel();
		aNewPnt.X() += nDelta;
		aBTNext.SetPosPixel( aNewPnt );
		aNewPnt = aBTLast.GetPosPixel();
		aNewPnt.X() += nDelta;
		aBTLast.SetPosPixel( aNewPnt );
		aNewPnt = aActionBox.GetPosPixel();
		aNewPnt.X() += nDelta;
		aActionBox.SetPosPixel( aNewPnt );
	}

	// Handler setzen
	aBTNext.SetClickHdl( LINK( this, SbaAddrPI,NextButtonClickHdl ) );
	aBTPrev.SetClickHdl( LINK( this, SbaAddrPI,PrevButtonClickHdl ) );
	aBTLast.SetClickHdl( LINK( this, SbaAddrPI,LastButtonClickHdl ) );
	aBTFirst.SetClickHdl( LINK( this, SbaAddrPI,FirstButtonClickHdl ) );
	Link aLink = LINK( this, SbaAddrPI, SearchHdl );
	aBTSuchen.SetClickHdl( aLink );
	aSearchMenuBtn.SetSelectHdl( aLink );
	aEndBtn.SetClickHdl( LINK( this, SbaAddrPI, SearchEndHdl ) );
	aSelectBox.SetClickHdl( LINK( this, SbaAddrPI, ToolBoxClickHdl ) );
	aActionBox.SetClickHdl( LINK( this, SbaAddrPI, ActionHdl ) );
	FASTBOOL bBtnEnable = ( !bReadOnlyDoc && NoSearch == eSearchMode );
	aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && bBtnEnable );
	aSelectBox.EnableItem( BT_MISCHEN, bMischen && bBtnEnable );

	aEdActualNumber.SetKeyReturnLink( LINK( this, SbaAddrPI, GotoRecord ) );
	aTitleTextBase = GetText();

	aLink = LINK( this, SbaAddrPI, ModifyHdl );
	aEdFirma.SetModifyHdl( aLink );
	aEdAbteilung.SetModifyHdl( aLink );
	aEdVorname.SetModifyHdl( aLink );
	aEdName.SetModifyHdl( aLink );
	aEdStrasse.SetModifyHdl( aLink );
	aEdLand.SetModifyHdl( aLink );
	aEdPLZ.SetModifyHdl( aLink );
	aEdOrt.SetModifyHdl( aLink );
	aEdTitel.SetModifyHdl( aLink );
	aEdPosition.SetModifyHdl( aLink );
	aCBAnrede.SetModifyHdl( aLink );
	aEdKuerzel.SetModifyHdl( aLink );
	aEdBriefanrede.SetModifyHdl( aLink );
	aEdTelPriv.SetModifyHdl( aLink );
	aEdTelGesch.SetModifyHdl( aLink );
	aEdFax.SetModifyHdl( aLink );
	aEdEmail.SetModifyHdl( aLink );
	aEdURL.SetModifyHdl( aLink );
	aEdNote.SetModifyHdl( aLink );
	aEdState.SetModifyHdl( aLink );
	aEdTelOffice.SetModifyHdl( aLink );
	aEdPager.SetModifyHdl( aLink );
	aEdTelHandy.SetModifyHdl( aLink );
	aEdTelOther.SetModifyHdl( aLink );
	aEdUser1.SetModifyHdl( aLink );
	aEdUser2.SetModifyHdl( aLink );
	aEdUser3.SetModifyHdl( aLink );
	aEdUser4.SetModifyHdl( aLink );
	aEdCalendarURL.SetModifyHdl( aLink );
	aCBInvite.SetClickHdl( aLink );

	// alle konfigurierten LDAP Server in den SearchMenuBtn und
	// in der Server-Liste einf"ugen
	pLDAPSearcher = new SbaLDAPSearcher( this );
	pLDAPSearcher->SetFinishedHdl( LINK( this, SbaAddrPI, FinishedHdl ) );
	PopupMenu* pMenu = aSearchMenuBtn.GetPopupMenu();
	sal_uInt16 i = 0;
	sal_uInt16 nId = nDefItemId = pMenu->GetItemId(0);
	String aServer;

	while ( pLDAPSearcher->GetServerName( i++, aServer ) )
	{
		if ( pMenu->GetItemCount() == 1 )
			pMenu->InsertSeparator();
		nId++;
		pMenu->InsertItem( nId,
			aServer.GetToken( LDAP_DESCRIPTION, LDAP_TOKEN_DELIMITER ) );
		pMenu->SetHelpId( nId, HID_ADDRPI_SEARCHLDAP );
	}

	bHasLDAPServer = ( pMenu->GetItemCount() > 1 );

	if ( !bHasLDAPServer )
	{
		aSearchMenuBtn.Hide();
		Size aSiz = aBTSuchen.GetSizePixel();
		long aW = aEndBtn.GetSizePixel().Width();

		if ( aSiz.Width() == aW )
			aSiz.Width() += aW;
		aBTSuchen.SetSizePixel( aSiz );
		aBTSuchen.Enable();
		aBTSuchen.Show();
	}
	else
		pMenu->SetMenuFlags( pMenu->GetMenuFlags() | MENU_FLAG_NOAUTOMNEMONICS );

	rSuccess = Init();

	// Position und Zoom-Status aus Ini
	SfxIniManager* pIniMgr = SFX_INIMANAGER();
	String aWinData( pIniMgr->Get( SFX_KEY_WINDOW, DLG_ADDR_PI ) );

	if ( aWinData.Len() )
	{
		Point aPos;
		Size aSize;

		if ( pIniMgr->GetPosSize( aWinData.GetToken( 0, pIniMgr->GetToken() ), aPos, aSize ) )
		{
			SetPosPixel( aPos );

			if ( aWinData.GetToken( 1, pIniMgr->GetToken() ).ToInt32() )
				RollUp();
			else
				RollDown();
		}
	}

	SetFocusInFirstControl();
	SfxApplication* pApp = SFX_APP();
	StartListening( *pApp );
}

// -----------------------------------------------------------------------

void SbaAddrPI::Shutdown()
{
	ModelessDialog::Hide();
}

// -----------------------------------------------------------------------

SbaAddrPI::~SbaAddrPI()
{
	DELETEZ(pLDAPCancel);
	delete pLDAPSearcher;
}

// -----------------------------------------------------------------------

void SbaAddrPI::DrawTitleBar( sal_uInt32 nCnt )
{
	String aTitle( aTitleTextBase );

	if ( !bDontUseDBase )
	{
		if ( bInLDAPMode )
		{
			aTitle = pLDAPSearcher->GetCurrentServer();
			aTitle += ' ';
			aTitle += aSearchStr;
			aTitle.AppendAscii( " (" );
			aTitle += String::CreateFromInt32( pLDAPSearcher->GetResultCount() );
			aTitle += ')';
		}
		else
		{
			sal_uInt32 nCnt = pSbaAddrMan->GetRowCount();

			if ( nCnt > 0 )
			{
				if ( eSearchMode == SearchActive )
				{
					aTitle += ' ';
					aTitle += aSearchStr;
					aTitle.AppendAscii( " (" );
					aTitle += String::CreateFromInt32( nCnt );
					aTitle += '/';
					aTitle += String::CreateFromInt32( nFirstRecordCount );
					aTitle += ')';
				}
				else
				{
					aTitle.AppendAscii( " (" );
					aTitle += String::CreateFromInt32( nCnt );
					aTitle += ')';
				}
			}
		}
	}

	if ( !pSbaAddrMan->MayDeleteRow() &&
		 !pSbaAddrMan->MayAppendRow() && !pSbaAddrMan->MayUpdateRow() )
	{
		aTitle += ' ';
		aTitle += aReadOnlyStr;
	}

	SetText( aTitle );
}

// -----------------------------------------------------------------------

void SbaAddrPI::SetReadOnly( sal_Bool bReadOnly )
{
	aEdFirma.SetReadOnly( bReadOnly );
	aEdVorname.SetReadOnly( bReadOnly );
	aEdName.SetReadOnly( bReadOnly );
	aEdStrasse.SetReadOnly( bReadOnly );
	aEdLand.SetReadOnly( bReadOnly );
	aEdPLZ.SetReadOnly( bReadOnly );
	aEdOrt.SetReadOnly( bReadOnly );
	aEdTitel.SetReadOnly( bReadOnly );
	aEdPosition.SetReadOnly( bReadOnly );
	aCBAnrede.SetReadOnly( bReadOnly );
	aEdKuerzel.SetReadOnly( bReadOnly );
	aEdBriefanrede.SetReadOnly( bReadOnly );
	aEdTelPriv.SetReadOnly( bReadOnly );
	aEdTelGesch.SetReadOnly( bReadOnly );
	aEdFax.SetReadOnly( bReadOnly );
	aEdEmail.SetReadOnly( bReadOnly );
	aEdURL.SetReadOnly( bReadOnly );
	aEdAbteilung.SetReadOnly( bReadOnly );
	aEdNote.SetReadOnly( bReadOnly );
	aEdUser1.SetReadOnly( bReadOnly );
	aEdUser2.SetReadOnly( bReadOnly );
	aEdUser3.SetReadOnly( bReadOnly );
	aEdUser4.SetReadOnly( bReadOnly );
	aEdState.SetReadOnly( bReadOnly );
	aEdTelOffice.SetReadOnly( bReadOnly );
	aEdPager.SetReadOnly( bReadOnly );
	aEdTelHandy.SetReadOnly( bReadOnly );
	aEdTelOther.SetReadOnly( bReadOnly );
	aEdCalendarURL.SetReadOnly( bReadOnly );
	aCBInvite.Enable( !bReadOnly && pSbaAddrMan->GetTabColInfo(30).IsVisible() );
}

// -----------------------------------------------------------------------

void SbaAddrPI::DisableAll()
{
	aEdFirma.Disable();
	aEdVorname.Disable();
	aEdName.Disable();
	aEdStrasse.Disable();
	aEdLand.Disable();
	aEdPLZ.Disable();
	aEdOrt.Disable();
	aEdTitel.Disable();
	aEdPosition.Disable();
	aCBAnrede.Disable();
	aEdKuerzel.Disable();
	aEdBriefanrede.Disable();
	aEdTelPriv.Disable();
	aEdTelGesch.Disable();
	aEdFax.Disable();
	aEdEmail.Disable();
	aEdURL.Disable();
	aEdAbteilung.Disable();
	aEdNote.Disable();
	aEdUser1.Disable();
	aEdUser2.Disable();
	aEdUser3.Disable();
	aEdUser4.Disable();
	aEdState.Disable();
	aEdTelOffice.Disable();
	aEdPager.Disable();
	aEdTelHandy.Disable();
	aEdTelOther.Disable();
	aEdCalendarURL.Disable();
	aCBInvite.Disable();

	aSelectBox.EnableItem( BT_EINFUEGEN, sal_False );
	aSelectBox.EnableItem( BT_MISCHEN, sal_False );
	aBTSuchen.Disable();
	aSearchMenuBtn.Disable();

	aBTFirst.Disable();
	aBTPrev.Disable();
	aEdActualNumber.Disable();
	aBTNext.Disable();
	aBTLast.Disable();
	aActionBox.EnableItem( BT_NEU, sal_False );
	aActionBox.EnableItem( BT_LOESCHEN, sal_False );
	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );
}

// -----------------------------------------------------------------------

void SbaAddrPI::EnableAll()
{
	aEdFirma.Enable();
	aEdVorname.Enable();
	aEdName.Enable();
	aEdStrasse.Enable();
	aEdLand.Enable();
	aEdPLZ.Enable();
	aEdOrt.Enable();
	aEdTitel.Enable();
	aEdPosition.Enable();
	aCBAnrede.Enable();
	aEdKuerzel.Enable();
	aEdBriefanrede.Enable();
	aEdTelPriv.Enable();
	aEdTelGesch.Enable();
	aEdFax.Enable();
	aEdEmail.Enable();
	aEdURL.Enable();
	aEdAbteilung.Enable();
	aEdNote.Enable();
	aEdUser1.Enable();
	aEdUser2.Enable();
	aEdUser3.Enable();
	aEdUser4.Enable();
	aEdState.Enable();
	aEdTelOffice.Enable();
	aEdPager.Enable();
	aEdTelHandy.Enable();
	aEdTelOther.Enable();
	aEdCalendarURL.Enable();
	aCBInvite.Enable();

	FASTBOOL bEnable = ( !bReadOnlyDoc && NoSearch == eSearchMode );
	aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && bEnable );
	aSelectBox.EnableItem( BT_MISCHEN, bMischen && bEnable );

	aBTSuchen.Enable();
	aSearchMenuBtn.Enable();

	aBTFirst.Enable();
	aBTPrev.Enable();
	aEdActualNumber.Enable();
	aBTNext.Enable();
	aBTLast.Enable();

	aActionBox.EnableItem( BT_NEU, pSbaAddrMan->MayAppendRow() );
	aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );
	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_True );
}

// -----------------------------------------------------------------------

void SbaAddrPI::Enable4LDAP( sal_Bool bEnable, sal_Bool bSchedule )
{
	if ( ( !bEnable && !bTextChanged ) || ( bEnable && bTextChanged ) )
	{
		// f"ur die LDAP-Such-Maske
		// andere Texte in den FixedTexten (zur"uck)setzen
		bTextChanged = !bTextChanged;
		String aOld( aFTName.GetText());
		aFTName.SetText( aNameStr );
		aNameStr = aOld;
		aOld = aFTTelPriv.GetText();
		aFTTelPriv.SetText( aPhoneStr );
		aPhoneStr = aOld;
	}

	// bestimmte Edits f"ur die LDAP-Suche disablen/enablen
	if ( bSchedule || bEnable )
	{
		aFTStrasse.Enable( bEnable );
		aEdStrasse.Enable( bEnable );
		aFTState.Enable( bEnable );
		aEdLand.Enable( bEnable );
		aFTOrt.Enable( bEnable );
		aEdPLZ.Enable( bEnable );
		aEdOrt.Enable( bEnable );
		aFTTelPriv.Enable( bEnable );
		aEdTelPriv.Enable( bEnable );
		aFTFirma.Enable( bEnable );
		aEdFirma.Enable( bEnable );
	}

	if ( !bSchedule || bEnable )
	{
		aFTKuerzel.Enable( bEnable );
		aEdKuerzel.Enable( bEnable );
	}

	aFTAnrede.Enable( bEnable );
	aCBAnrede.Enable( bEnable );
	aEdTitel.Enable( bEnable );
	aFTVorname.Enable( bEnable );
	aEdVorname.Enable( bEnable );
	aFTBriefanrede.Enable( bEnable );
	aEdBriefanrede.Enable( bEnable );
	aEdPLZ.Enable( bEnable );
	aFTTelHandy.Enable( bEnable );
	aEdTelHandy.Enable( bEnable );
	aFTFax.Enable( bEnable );
	aEdFax.Enable( bEnable );
	aFTURL.Enable( bEnable );
	aEdURL.Enable( bEnable );

	aFTPosition.Enable( bEnable );
	aEdPosition.Enable( bEnable );
	aFTTelGesch.Enable( bEnable );
	aEdTelGesch.Enable( bEnable );
	aFTTelOffice.Enable( bEnable );
	aEdTelOffice.Enable( bEnable );
	aFTTelOther.Enable( bEnable );
	aEdTelOther.Enable( bEnable );
	aFTPager.Enable( bEnable );
	aEdPager.Enable( bEnable );

	aFTUser1.Enable( bEnable );
	aEdUser1.Enable( bEnable );
	aFTUser2.Enable( bEnable );
	aEdUser2.Enable( bEnable );
	aFTUser3.Enable( bEnable );
	aEdUser3.Enable( bEnable );
	aFTUser4.Enable( bEnable );
	aEdUser4.Enable( bEnable );
	aFTNote.Enable( bEnable );
	aEdNote.Enable( bEnable );
	aFTCalendarURL.Enable( bEnable );
	aEdCalendarURL.Enable( bEnable );
	aCBInvite.Enable( bEnable );

//!	Button* pDefBtn = bEnable ? NULL : &aBTSuchen;
//!	SetDefaultButton( pDefBtn );

	if ( !bEnable )
	{
		String aText( SbaResId( RID_LDAP_STATUS_SEARCH ) );
		aText.SearchAndReplaceAscii( "%1", aLDAPServer );
		SetText( aText );
	}
}

// -----------------------------------------------------------------------

void SbaAddrPI::AutoSelect( const String& rName, SbaSearchField eInField )
{
	// In die Sucheingabe
	NoSearchImpl();

	// Feld besetzen
	switch ( eInField )
	{
		case SBA_NAMESEARCH:
			aEdName.SetText( rName );
			break;

		case SBA_FIRMASEARCH:
			aEdFirma.SetText( rName );
			break;
	}
	// Und Ausf"uhren
	SetSearchDataImpl();
}

// -----------------------------------------------------------------------

void SbaAddrPI::AutoInsert( const String& rName, SbaSearchField eInField )
{
	if ( !pSbaAddrMan->MayAppendRow() )
		return;

	NewRecord();

	// Feld besetzen
	switch( eInField )
	{
		case SBA_NAMESEARCH:
			aEdName.SetText( rName );
			break;

		case SBA_FIRMASEARCH:
			aEdFirma.SetText( rName );
			break;
	}
}

// -----------------------------------------------------------------------

void SbaAddrPI::StateChanged( sal_uInt16 nSID, SfxItemState eState, const SfxPoolItem* pState )
{
	switch ( nSID )
	{
		case SID_DOC_READONLY:
		{
			if ( eState >= SFX_ITEM_AVAILABLE )
			{
				SfxBoolItem* pItem = PTR_CAST(SfxBoolItem,pState);
				if (!pItem)
				{
					DBG_ERRORFILE("Falsches Item an den Adressbuch");
					return;
				}
				bReadOnlyDoc = pItem->GetValue();
			}
			else
				bReadOnlyDoc = sal_False;

			FASTBOOL bEnable = ( !bReadOnlyDoc && NoSearch == eSearchMode );
			aSelectBox.EnableItem( BT_EINFUEGEN, bEinfuegen && bEnable );
			aSelectBox.EnableItem( BT_MISCHEN, bMischen && bEnable );
		}	break;
	}
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrPI::OnChangeAddrbook()
{
	if ( bModified && bDontUseDBase == sal_False )
		WriteRecord();

	delete pSbaAddrMan;
	pSbaAddrMan = NULL;
	bMustUpdate = sal_False;
	return Init();
}

// -----------------------------------------------------------------------

void SbaAddrPI::ShowStatusText( const String& rStatus )
{
	if ( !bStatus )
	{
		bStatus = sal_True;
		Size aSize = GetOutputSizePixel();
		aSize.Height() += nStatusOffset;
		SetOutputSizePixel( aSize );
		aFTStatus.Show();
	}
	aFTStatus.SetText( rStatus );
}

// -----------------------------------------------------------------------

void SbaAddrPI::HideStatusText()
{
	if ( bStatus )
	{
		bStatus = sal_False;
		Size aSize = GetOutputSizePixel();
		aSize.Height() -= nStatusOffset;
		SetOutputSizePixel( aSize );
		aFTStatus.Hide();
	}
}

// -----------------------------------------------------------------------

SbaExplorerExchObj* SbaAddrPI::GetExchangeObject()
{
	WriteRecord();
	String sDBAlias = EnsureDBLink(aDB->Name(), sal_True /* allow ui */, sal_True /* really need an alias */ );
	if (!sDBAlias.Len())
		return NULL;

	String aFilter = pSbaAddrMan->GetCurSelectCmd();
	FASTBOOL bFilter = ( aFilter.Len() > 0 && pSbaAddrMan->GetCurWhereCond().Len() > 0 );
	String aTableName = pSbaAddrMan->GetTableName();
	String aCopyData = sDBAlias;
	aCopyData += char(11);
	if ( !bFilter )
		aCopyData += aTableName;
	aCopyData += char(11);
	if ( !bFilter )
		aCopyData += '1';
	else
		aCopyData += '0';
	aCopyData += char(11);
	if ( bFilter )
		aCopyData += aFilter;
	aCopyData += char(11);
	aCopyData += String::CreateFromInt32(pSbaAddrMan->GetCurRow() + 1);
	return new SbaExplorerExchObj( aDB->OpenDBDef( dbTable, aTableName ), aCopyData );
}

// -----------------------------------------------------------------------

sal_Bool SbaAddrPI::Init()
{
	ClearFields();
	DisableAll();

	aDB = (SbaDatabase*)pSbaObject->OpenAddrDatabase( sal_True, sal_True );
	if (!aDB.Is())
		return sal_False;
	pSbaAddrMan = new SbaAddrMan( aDB, pSbaObject );

	if ( !pSbaAddrMan->IsOk() )
	{
		String aName( pSbaObject->GetAddrDBName() );
		( aName += ' ' ) += pSbaObject->GetAddrTableName();
		SbaExtInfoBox( NULL, SbaResId( INFO_ADR_CANTOPEN ), aName ).Execute();
		return sal_False;
	}
	pSbaAddrMan->InitDb();
	bModified = sal_False;
	bDontUseDBase = !pSbaAddrMan->IsOk();
	bAppendActualRecord = sal_False;
	nFirstRecordCount = 0;
	eSearchMode = NoSearch;

	ClearFields();
	DisableAll();

	if ( bDontUseDBase )
		return sal_False;
	else
	{
		nFirstRecordCount = pSbaAddrMan->GetRowCount();
		EnableAll();
		SetReadOnly( !pSbaAddrMan->MayUpdateRow() );
		pSbaAddrMan->InitAnredeList();
		UpdateAnredeList();
		pSbaAddrMan->FetchFirstRow();
		GetDBaseData();
		sal_uInt32 nCnt = pSbaAddrMan->GetRowCount();
		DrawTitleBar( nCnt );
		aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );

		if ( nCnt < 2 && !bHasLDAPServer )
		{
			aBTSuchen.Disable();
			aSearchMenuBtn.Disable();
		}
		aSearchMenuBtn.GetPopupMenu()->EnableItem( MN_ADDRESSBOOK, nCnt > 1 );
	}
	EnableNavButtons();
	return sal_True;
}

// -----------------------------------------------------------------------

void SbaAddrPI::NewRecord()
{
	if ( bDontUseDBase )
		return;

	WriteRecord();
	ClearFields();
	SetReadOnly( sal_False );
	bAppendActualRecord = sal_True;
	aActionBox.EnableItem( BT_LOESCHEN, sal_False );
	aTabBar.SetCurPageId( TID_PERSONAL );
	TabSelectHdl( &aTabBar );
	SetFocusInFirstControl();
}

// -----------------------------------------------------------------------

void SbaAddrPI::AddRecord()
{
	if ( bDontUseDBase )
		return;

	SbaIniWrap aIniWrap;
	String aAddrTableName( aIniWrap.GetAdressTable());
	String aEMailFld( aIniWrap.GetAssocFieldName( SbaIniWrap::EMAIL ));
	String aEmail( aEdEmail.GetText());
	String aFirstNameFld( aIniWrap.GetAssocFieldName( SbaIniWrap::FIRSTNAME ));
	String aFirstName( aEdVorname.GetText());
	String aLastNameFld( aIniWrap.GetAssocFieldName( SbaIniWrap::LASTNAME ));
	String aLastName( aEdName.GetText());
	String aOrganizationFld( aIniWrap.GetAssocFieldName( SbaIniWrap::COMPANY ));
	String aOrganization( aEdFirma.GetText());

	FASTBOOL bField = sal_False;
	String aSQL; aSQL.AssignAscii( "SELECT * FROM " );
	( aSQL += aAddrTableName ).AppendAscii(" WHERE ");

	if ( aEmail.Len() )
	{
		bField = sal_True;
		( aSQL += aEMailFld ).AppendAscii(" LIKE \'");
		( aSQL += aEmail ) += '\'';
	}
	if ( aFirstName.Len() )
	{
		if ( bField )
			aSQL.AppendAscii(" AND ");
		else
			bField = sal_True;
		aSQL += aFirstNameFld;
		( ( aSQL.AppendAscii(" LIKE \'") ) += aFirstName ) += '\'';
	}
	if ( aLastName.Len() )
	{
		if ( bField )
			aSQL.AppendAscii(" AND ");
		else
			bField = sal_True;
		aSQL += aLastNameFld;
		( ( aSQL.AppendAscii(" LIKE \'") ) += aLastName ) += '\'';
	}
	if ( aOrganization.Len() )
	{
		if ( bField )
			aSQL.AppendAscii(" AND ");
		else
			bField = sal_True;
		aSQL += aOrganizationFld;
		( ( aSQL.AppendAscii(" LIKE \'") ) += aOrganization ) += '\'';
	}

	if ( !pSbaAddrMan->AddressAlreadyExists( aSQL ) ||
		 QueryBox( this, SbaResId( QUERY_ADR_ADDADDRESS ) ).Execute() == RET_YES )
		InsertRecord();
}

// -----------------------------------------------------------------------

void SbaAddrPI::DeleteRecord()
{
	if ( bDontUseDBase || bAppendActualRecord )
		return;

	if ( QueryBox( this, SbaResId( QUERY_DELETE_ADDRESS ) ).Execute() != RET_YES )
		return;

	sal_uInt32 nCur = pSbaAddrMan->GetCurRow();
	pSbaAddrMan->DeleteRow();
	sal_uInt32 nCnt = pSbaAddrMan->GetRowCount();

	if ( nCnt > 0 )
	{
		if( nCur >= nCnt )
			nCur = nCnt - 1;

		if ( !pSbaAddrMan->FetchRowAt( nCur ) )
			// Nicht geklappt, dann auf letzten Satz
			pSbaAddrMan->FetchLastRow();
		GetDBaseData();
		aActionBox.EnableItem( BT_LOESCHEN, pSbaAddrMan->MayDeleteRow() );
	}
	else
	{
		ClearFields();
		aActionBox.EnableItem( BT_LOESCHEN, sal_False );

		if ( pSbaAddrMan->MayDeleteRow() )
			bAppendActualRecord = sal_True;
		else
			DisableAll();
	}

	if ( nCnt < 2 && eSearchMode == NoSearch && !bHasLDAPServer )
	{
		aBTSuchen.Disable();
		aSearchMenuBtn.Disable();
	}
	aSearchMenuBtn.GetPopupMenu()->EnableItem( MN_ADDRESSBOOK, nCnt > 1 );
	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );
	bModified = sal_False;
	nFirstRecordCount--;
	DrawTitleBar( nCnt );
	EnableNavButtons();
}

// -----------------------------------------------------------------------

void SbaAddrPI::ResetRecord()
{
	if ( bDontUseDBase || bAppendActualRecord )
		return;

	if ( bModified && pSbaAddrMan->GetRowCount() > 0 )
	{
		SbaAddrContainer aContainer;
		pSbaAddrMan->ReadRow( aContainer );
		SetFields( aContainer );
		bModified = sal_False;
	}
	aActionBox.EnableItem( BT_RUECKGAENGIG, sal_False );
}

// -----------------------------------------------------------------------

void SbaAddrPI::BroadcastUpdate()
{
	bNotifyDisabled = sal_True;
	pSbaAddrMan->RefreshDb();
	SFX_APP()->Broadcast( SfxSimpleHint( SFX_HINT_DATACHANGED ) );
	bNotifyDisabled = sal_False;
}

// -----------------------------------------------------------------------

void SbaAddrPI::SetFocusInFirstControl()
{
	sal_uInt16 nPageId = aTabBar.GetCurPageId();

	if ( TID_PERSONAL == nPageId )
		aCBAnrede.GrabFocus();
	else if ( TID_BUSINESS == nPageId )
		aEdFirma.GrabFocus();
	else
		aEdUser1.GrabFocus();
}


