/*************************************************************************
 *
 *  $RCSfile: copytbl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef SBA_COPYTBL_HRC
#include "copytbl.hrc"
#endif
#ifndef _SBA_COPYTBL_HXX
#include "copytbl.hxx"
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif


#ifndef _SBA_DBEXCH_HXX
#include "dbexch.hxx"
#endif // _SBA_DBEXCH_HXX

//========================================================================
// DlgLongName
// Dialog fuer zu lange Feldnamen
//========================================================================

//------------------------------------------------------------------------
DlgLongName::DlgLongName( Window * pParent, String& rName, const String& rLongName, sal_Bool& rbAuto, SbaDBDataDef* pDestDef )
	: ModalDialog( pParent, SbaResId(DLG_LONGNAME) ),
	aPB_OK( this, ResId( PB_OK ) ),
	aPB_CANCEL( this, ResId( PB_CANCEL ) ),
	aPB_HELP( this, ResId( PB_HELP ) ),

	aFT_Info( this, SbaResId( FT_INFO ) ),
	aFT_Name( this, SbaResId( FT_NAME ) ),
	aET_Name( this, SbaResId( ET_NAME ) ),
	aPB_Auto( this, SbaResId( PB_AUTO ) ),

	rbAutoAdjust( rbAuto ),
	rFieldName( rName ),
	xDestDef( pDestDef )
{
	//////////////////////////////////////////////////////////////////////
	// Eingabeweite Edit und Auto Button-Hdl setzen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = xDestDef->GetDatabase()->GetMetaData();
	xub_StrLen nMaxTextLen = (xub_StrLen)rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN );

	aET_Name.SetMaxTextLen(	nMaxTextLen );
	aPB_Auto.SetClickHdl( LINK( this, DlgLongName, AutoClickHdl ) );
	aPB_OK.SetClickHdl( LINK( this, DlgLongName, OKClickHdl ) );

	//////////////////////////////////////////////////////////////////////
	// Info- und Edit-Text setzen
	String aInfoText = aFT_Info.GetText();
	aInfoText.SearchAndReplaceAscii( "$Name: OpenOffice605 $", rLongName );
	aFT_Info.SetText( aInfoText );

	aET_Name.SetText( rFieldName );
	aET_Name.GrabFocus();

	FreeResource();
}

//------------------------------------------------------------------------
DlgLongName::~DlgLongName()
{
}

//------------------------------------------------------------------------
IMPL_LINK( DlgLongName, AutoClickHdl, Button*, pButton )
{
	rbAutoAdjust = sal_True;
	OKClickHdl( NULL );

	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( DlgLongName, OKClickHdl, Button*, pButton )
{
	if( pButton )
		rFieldName = aET_Name.GetText();

	//////////////////////////////////////////////////////////////////////
	// Wenn Name bereits vorhanden, Infotext neu setzen
	SbaColumnList& rDestList = xDestDef->GetColumns();
	if( rDestList.Lookup(rFieldName, String()) )
	{
		String aInfoText( SbaResId(STR_DUPL_FIELDNAME) );
		aInfoText.SearchAndReplaceAscii("$Name: OpenOffice605 $", rFieldName );
		aFT_Info.SetText( aInfoText );
	}

	//////////////////////////////////////////////////////////////////////
	// ... ansonsten Dialog beenden
	else
		EndDialog( sal_True );

	return 0;
}


//========================================================================
// Klasse DlgCopyTable
//========================================================================
DBG_NAME(DlgCopyTable);
//------------------------------------------------------------------------
DlgCopyTable::DlgCopyTable( Window * pParent, SbaExplorerExchObj::ACTION_TYPE atWhat, sal_Bool bIsQuery, sal_uInt16 nLastAction )
	: SbaWizardPage( pParent, SbaResId(DLG_COPYTABLE		) ),
	m_aFBmpCopyTable(		this, ResId( BMP_COPYTABLE		) ),
	m_aGB_Temp(				this, ResId( GB_TEMP			) ),
	m_ftTableName(			this, ResId( FT_TABLENAME		) ),
	m_edTableName(			this, ResId( ET_TABLENAME		) ),
	m_aGB_Options(			this, ResId( GB_OPTIONS			) ),
	m_aRB_DefData(			this, ResId( RB_DEFDATA			) ),
	m_aRB_Def(				this, ResId( RB_DEF				) ),
	m_aRB_View(				this, ResId( RB_VIEW			) ),
	m_aRB_AppendData(		this, ResId( RB_APPENDDATA		) ),
	m_aCB_PrimaryColumn(	this, ResId( CB_PRIMARY_COLUMN	) ),
	m_aFT_KeyName(			this, ResId( FT_KEYNAME			) ),
	m_edKeyName(			this, ResId( ET_KEYNAME			) ),
	m_pPage2(NULL),
	m_pPage3(NULL),
	m_bIsViewAllowed(bIsQuery)
{
	DBG_CTOR(DlgCopyTable,NULL);

	//m_aFBmpCopyTable.SetBitmap(SbaResId(this,));

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(m_pParent->m_xDatabase->GetMetaData());
	m_bIsViewAllowed &= (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::VIEW_DEFINITION)) & ::com::sun::star::data::DatabaseViewDefinition::CREATE);
	if(!m_bIsViewAllowed)
		m_aRB_View.Disable();

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	m_bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE && m_pParent->m_xDatabase->IsTypeAvailable(dbNumeric,3);

	m_aCB_PrimaryColumn.Enable(m_bPKeyAllowed);

	switch(nLastAction)
	{
		case 0:
			m_aRB_DefData.Check(sal_True);
			break;
		case 1:
			m_aRB_Def.Check(sal_True);
			break;
		case 2:
			m_aRB_AppendData.Check(sal_True);
			m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,sal_False);
			break;
		case 3:
			if(m_bIsViewAllowed)
			{
				m_aRB_View.Check(sal_True);
				m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,sal_False);
			}
			else
				m_aRB_DefData.Check(sal_True);
	}
	m_aRB_AppendData.SetClickHdl(	LINK( this, DlgCopyTable, AppendDataClickHdl	) );

	m_aRB_DefData.SetClickHdl(		LINK( this, DlgCopyTable, RadioChangeHdl		) );
	m_aRB_Def.SetClickHdl(			LINK( this, DlgCopyTable, RadioChangeHdl		) );
	m_aRB_View.SetClickHdl(			LINK( this, DlgCopyTable, RadioChangeHdl		) );

	m_aCB_PrimaryColumn.SetClickHdl( LINK( this, DlgCopyTable, KeyClickHdl ) );

	m_aFT_KeyName.Enable(sal_False);
	m_edKeyName.Enable(sal_False);
	m_edKeyName.SetText(String::CreateFromAscii("ID"));
	sal_Int32 nMaxLen = xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN);
	if(nMaxLen)
		m_edKeyName.SetMaxTextLen(nMaxLen);

	FreeResource();

	if (SbaExplorerExchObj::AT_COPY == atWhat)
		SetText(String(SbaResId(RID_STR_COPYTABLE_TITLE_COPY)));
	else
	{
		SetText(String(SbaResId(RID_STR_COPYTABLE_TITLE_MOVE)));
		m_aRB_Def.Disable();
			// beim Verschieben ist der Punkt "nur Definition" nicht zulaessig
	}
}

//------------------------------------------------------------------------
DlgCopyTable::~DlgCopyTable()
{
	DBG_DTOR(DlgCopyTable,NULL);
}
//------------------------------------------------------------------------
IMPL_LINK( DlgCopyTable, AppendDataClickHdl, Button*, pButton )
{
	sal_Bool bChecked = m_aRB_AppendData.IsChecked();
	//m_pParent->EnableButton(CopyTableWizard::WIZARD_FINISH,bChecked);
	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,sal_True);
	m_aFT_KeyName.Enable(sal_False);
	m_aCB_PrimaryColumn.Enable(sal_False);
	m_edKeyName.Enable(sal_False);
	m_pParent->m_eCreateStyle = CopyTableWizard::WIZARD_APPEND_DATA;
	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( DlgCopyTable, RadioChangeHdl, Button*, pButton )
{
	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,pButton != &m_aRB_View);
	sal_Bool bKey = m_bPKeyAllowed && pButton != &m_aRB_View;
	m_aFT_KeyName.Enable(bKey && m_aCB_PrimaryColumn.IsChecked());
	m_edKeyName.Enable(bKey && m_aCB_PrimaryColumn.IsChecked());
	m_aCB_PrimaryColumn.Enable(bKey);

	// set typ what to do
	if( IsOptionDefData() )
		m_pParent->m_eCreateStyle = CopyTableWizard::WIZARD_DEF_DATA;
	else if( IsOptionDef() )
		m_pParent->m_eCreateStyle = CopyTableWizard::WIZARD_DEF;
	else if( IsOptionView() )
		m_pParent->m_eCreateStyle = CopyTableWizard::WIZARD_DEF_VIEW;

	return 0;
}
//------------------------------------------------------------------------
IMPL_LINK( DlgCopyTable, KeyClickHdl, Button*, pButton )
{
	m_edKeyName.Enable(m_aCB_PrimaryColumn.IsChecked());
	m_aFT_KeyName.Enable(m_aCB_PrimaryColumn.IsChecked());
	return 0;
}
//------------------------------------------------------------------------
sal_Bool DlgCopyTable::LeavePage()
{
	if(m_pParent->m_xSourceDef.Is() && m_pParent->m_xSourceDef->IsNew())
		m_pParent->m_xTableDef = (SbaTableDef*)&m_pParent->m_xSourceDef;

	m_pParent->m_bPrimaryColumn = (m_bPKeyAllowed && m_aCB_PrimaryColumn.IsEnabled()) ? m_aCB_PrimaryColumn.IsChecked() : sal_False;
	m_pParent->m_aKeyName		= m_edKeyName.GetText();

	// a table that comes from a html or rtf import already has a name that is valid in the db
	if(!(m_pParent->m_xTableDef.Is() && m_pParent->m_xTableDef->IsNew()) &&
		m_pParent->m_eCreateStyle != CopyTableWizard::WIZARD_APPEND_DATA && m_pParent->m_xSourceDef.Is() &&
		!m_pParent->m_xSourceDef->IsNew() && m_pParent->m_xDatabase->HasObject(dbTable, m_edTableName.GetText()))
	{
		String aInfoString( SbaResId(SBA_ERR_DUPL_TABLENAME) );
		aInfoString.SearchAndReplaceAscii("\'$name$\'",m_edTableName.GetText());
		InfoBox aNameInfoBox( this, aInfoString );
		aNameInfoBox.Execute();
		return sal_False;
	}

	if(m_pParent->m_xTableDef.Is() && !m_edTableName.GetSavedValue().Equals(m_edTableName.GetText()))
	{ // table exist and name has changed
		if(m_pParent->m_eCreateStyle == CopyTableWizard::WIZARD_APPEND_DATA)
		{
			m_pParent->m_lColumnList.Clear();
			m_pParent->m_xTableDef = NULL;
			m_pParent->m_xTableDef = (SbaTableDef*)m_pParent->m_xDatabase->OpenDBDef( dbTable, m_edTableName.GetText(), sal_False );
			if(!m_pParent->m_xTableDef.Is() || m_pParent->m_xTableDef->IsNew())
			{
				ErrorBox(this, SbaResId(ERROR_INVALID_TABLE_NAME)).Execute();
				return sal_False;
			}
		}
		else if(m_eOldStyle == CopyTableWizard::WIZARD_APPEND_DATA)
		{
			m_pParent->m_lColumnList.Clear();
			m_pParent->m_xTableDef = NULL;
			return LeavePage();
		}
		else if(!m_pParent->m_xTableDef->Rename(m_edTableName.GetText()))
		{
			String aInfoString( SbaResId(SBA_ERR_DUPL_TABLENAME) );
			aInfoString.SearchAndReplaceAscii("\'$name$\'",m_edTableName.GetText());
			InfoBox aNameInfoBox( this, aInfoString );
			aNameInfoBox.Execute();
			return sal_False;
		}
	}
	else if(!(m_pParent->m_xTableDef.Is() && !m_pParent->m_xTableDef->IsNew()) && (IsOptionAppendData() || (m_pParent->m_xSourceDef.Is() && !m_pParent->m_xSourceDef->IsNew())))
	{ // table exist and is not new or doesn't exist and so on
		switch(m_pParent->m_eCreateStyle)
		{
			case CopyTableWizard::WIZARD_APPEND_DATA:
			{
				m_pParent->m_lColumnList.Clear();
				m_pParent->m_xTableDef = (SbaTableDef*)m_pParent->m_xDatabase->OpenDBDef( dbTable, m_edTableName.GetText(), sal_False );

				if(!m_pParent->m_xTableDef.Is() || m_pParent->m_xTableDef->IsNew())
				{
					ErrorBox(this, SbaResId(ERROR_INVALID_TABLE_NAME)).Execute();
					m_edTableName.GrabFocus();
					return sal_False;
				}
				break;
			}
			case CopyTableWizard::WIZARD_DEF_DATA:
			case CopyTableWizard::WIZARD_DEF:
			{
				//////////////////////////////////////////////////////////////////////////
				// Immer neue Tabelle erzeugen
				if(!m_pParent->m_xTableDef.Is())
				{
					String sNewTableName = m_edTableName.GetText();
					// check for a valid name within the db
					if (!m_pParent->m_xDatabase->IsSQLNameValid(sNewTableName))
					{
						ErrorBox(this, SbaResId(ERROR_INVALID_TABLE_NAME)).Execute();
						m_edTableName.GrabFocus();
						return sal_False;
					}

					m_pParent->m_xTableDef = (SbaTableDef*)m_pParent->m_xDatabase->CreateDBDef( dbTable, sNewTableName, TRUE );
					if(!m_pParent->m_xTableDef.Is())
					{
						SBA_MOD()->ShowDbStatus(m_pParent->m_xDatabase->Status(), dbWriteError, this);
						m_edTableName.GrabFocus();
						return sal_False;
					}
				}
			}
		}
	}
	m_pParent->m_aTableName = m_edTableName.GetText();
	m_edTableName.SaveValue();

	if(!m_pParent->m_aTableName.Len())
	{
		ErrorBox(this, SbaResId(ERROR_INVALID_TABLE_NAME)).Execute();
		return sal_False;
	}

	return sal_True;
}
//------------------------------------------------------------------------
void DlgCopyTable::ActivatePage()
{
	m_eOldStyle = m_pParent->m_eCreateStyle;
	//////////////////////////////////////////////////////////////////////////
	// Ist der Name zu lang?
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xDestMetaData(m_pParent->m_xDatabase->GetMetaData());
	sal_Int32 nLen = xDestMetaData->getLimit(::com::sun::star::data::DatabaseLimit::TABLE_NAME_LEN);
	if(nLen)
		m_edTableName.SetMaxTextLen(nLen);
	//m_pParent->EnableButton(CopyTableWizard::WIZARD_FINISH,FALSE);

	if (m_pParent->m_xSourceDef.Is() && (m_pParent->m_xSourceDef->GetDatabase() == m_pParent->m_xDatabase))
		// copying within the same database -> assume that the name should be modified at first
		m_edTableName.GrabFocus();
	else 
		m_pParent->GetOKButton().GrabFocus();
}
//------------------------------------------------------------------------
String DlgCopyTable::GetTitle() const { return String(SbaResId(SBA_STR_WIZ_TABLE_COPY)); }
//------------------------------------------------------------------------
void DlgCopyTable::Reset()
{
	m_bFirstTime = sal_False;
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xDestMetaData(m_pParent->m_xDatabase->GetMetaData());
	sal_Int32 nLen = xDestMetaData->getLimit(::com::sun::star::data::DatabaseLimit::TABLE_NAME_LEN);
	if(nLen)
		m_edTableName.SetMaxTextLen(nLen);
	String aCatalog,aSchema,aTableName;

	if(m_pParent->m_xSourceDef.Is())
	{
		if(m_pParent->m_xSourceDef->GetKind() != dbQuery)
			m_pParent->m_xSourceDef->GetDatabase()->QualifiedNameComponents(m_pParent->m_xSourceDef->Name(),aCatalog,aSchema,aTableName);
		else
			aTableName = m_pParent->m_xSourceDef->Name();
	}
	else if(m_pParent->m_xTableDef.Is())
		m_pParent->m_xDatabase->QualifiedNameComponents(m_pParent->m_xTableDef->Name(),aCatalog,aSchema,aTableName);

	if(nLen && nLen < aTableName.Len())
		aTableName = m_pParent->m_xDatabase->ShortenTableName(aTableName,nLen);
	m_edTableName.SetText(aTableName);
	m_edTableName.SaveValue();
}
//------------------------------------------------------------------------

