/*************************************************************************
 *
 *  $RCSfile: dlgerr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif
#ifndef SB_DLGTEXT_HXX
#include "dlgtext.hxx"
#endif
#ifndef _SBA_SBASTAT_HXX
#include "dbstat.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#define BUTTONID_MORE	BUTTONID_RETRY + 1

#define DLG_LIMIT	320	// max Dialoggroesse
#define BTN_HEIGHT	14
#define BTN_WIDTH	50
#define BORDER_HEIGHT	6 // default Abstand von Control zu Dialog
#define BORDER_WIDTH	6 // default Abstand von Control zu Dialog

//------------------------------------------------------------------------------
SbaMsgDlg::SbaMsgDlg(Window* pParent)
		  :ButtonDialog(pParent,WB_HORZ | WB_STDDIALOG)
		  ,aInfoImage(this)
		  ,aFTTitle(this,WB_WORDBREAK | WB_LEFT)
		  ,aFTMessage(this,WB_WORDBREAK | WB_LEFT)
{
	SetText(String::CreateFromAscii("StarBase"));
	SetHelpId(HID_DLG_ERROR);
	SetSizePixel(LogicToPixel(Size(220, 30),MAP_APPFONT));

	aInfoImage.SetPosSizePixel(LogicToPixel(Point(6, 6),MAP_APPFONT),
							   LogicToPixel(Size(20, 20),MAP_APPFONT));
	aInfoImage.Show();

	aFTTitle.SetPosSizePixel(LogicToPixel(Point(45, 6),MAP_APPFONT),
							 LogicToPixel(Size(169, 20),MAP_APPFONT));

	Font  aFont = aFTTitle.GetFont();
	aFont.SetWeight(WEIGHT_SEMIBOLD);
	aFTTitle.SetFont(aFont);
	aFTTitle.Show();

	aFTMessage.SetPosSizePixel(LogicToPixel(Point(45, 29),MAP_APPFONT),
							   LogicToPixel(Size(169, 1),MAP_APPFONT));
	aFTMessage.Show();
}

//------------------------------------------------------------------------------
void SbaMsgBox::Construct(const String& rTitle,
						  const String& rMessage,
						  WinBits nStyle,
						  DlgImage eImage)
{
	pInfoButton = NULL;

	// Image festlegen
	switch (eImage)
	{
		case Info:
			aInfoImage.SetImage(InfoBox::GetStandardImage());
			break;
		case Warning:
			aInfoImage.SetImage(WarningBox::GetStandardImage());
			break;
		case Error:
			aInfoImage.SetImage(ErrorBox::GetStandardImage());
			break;
		case Query:
			aInfoImage.SetImage(QueryBox::GetStandardImage());
			break;
	}

	// Title setzen
	aFTTitle.SetText(rTitle);

	// Ermitteln der Hoehe des Textfeldes und des Dialogs
	Size aBorderSize = LogicToPixel(Size(BORDER_WIDTH, BORDER_HEIGHT),MAP_APPFONT);
	Rectangle aDlgRect(GetPosPixel(),GetSizePixel());
	Rectangle aMessageRect(aFTMessage.GetPosPixel(),aFTMessage.GetSizePixel());
	Rectangle aTextRect	 =
		GetTextRect(aMessageRect,rMessage, TEXT_DRAW_WORDBREAK |
										   TEXT_DRAW_MULTILINE | TEXT_DRAW_LEFT);

	long nHText	= aTextRect.Bottom() > aMessageRect.Bottom() ? aTextRect.Bottom() - aMessageRect.Bottom() : 0;

	aDlgRect.Bottom() += nHText + 2 * aBorderSize.Height();
	aMessageRect.Bottom() += nHText;

	// Dialog anpassen
	SetSizePixel(aDlgRect.GetSize());
	SetPageSizePixel(aDlgRect.GetSize());

	// Message Text anpassen und setzen
	aFTMessage.SetSizePixel(aMessageRect.GetSize());
	aFTMessage.SetText(rMessage);

	// Buttons anlegen
	long   nBtnCount = sInfo.Len() ? 1 : 0;
	sal_Bool   bHelp = sal_False; //aHelpBtn.IsVisible();

	if (nStyle & WB_YES_NO_CANCEL)
	{
		if (nStyle & WB_DEF_YES)
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,0);

		if (nStyle & WB_DEF_NO)
			AddButton(BUTTON_NO,BUTTONID_NO,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_NO,BUTTONID_NO, 0);

		if (nStyle & WB_DEF_CANCEL)
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON|BUTTONDIALOG_CANCELBUTTON);
		else
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL, BUTTONDIALOG_CANCELBUTTON);
	}
	else if (nStyle & WB_OK_CANCEL)
	{
		if (nStyle & WB_DEF_CANCEL)
		{
			AddButton(BUTTON_OK,BUTTONID_OK,0);
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON|BUTTONDIALOG_CANCELBUTTON);
		}
		else
		{
			AddButton(BUTTON_OK,BUTTONID_OK,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_CANCELBUTTON);
		}
	}
	else if (nStyle & WB_YES_NO)
	{
		if (nStyle & WB_DEF_YES)
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_OKBUTTON);

		if (nStyle & WB_DEF_NO)
			AddButton(BUTTON_NO,BUTTONID_NO,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON|BUTTONDIALOG_CANCELBUTTON);
		else
			AddButton(BUTTON_NO,BUTTONID_NO, BUTTONDIALOG_CANCELBUTTON);
	}
	else if (nStyle & WB_RETRY_CANCEL)
	{
		if (nStyle & WB_DEF_RETRY)
			AddButton(BUTTON_RETRY,BUTTONID_RETRY,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON);
		else
			AddButton(BUTTON_YES,BUTTONID_YES,BUTTONDIALOG_OKBUTTON);

		if (nStyle & WB_DEF_CANCEL)
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON|BUTTONDIALOG_CANCELBUTTON);
		else
			AddButton(BUTTON_CANCEL,BUTTONID_CANCEL, BUTTONDIALOG_CANCELBUTTON);
	}
	else
	{
		DBG_ASSERT(WB_OK & nStyle, "kein Button gesetzt");
		AddButton(BUTTON_OK,BUTTONID_OK,BUTTONDIALOG_DEFBUTTON|BUTTONDIALOG_FOCUSBUTTON|BUTTONDIALOG_CANCELBUTTON);
	}

	if (sInfo.Len())
	{
		pInfoButton = new PushButton(this);
		pInfoButton->SetText(Button::GetStandardText(BUTTON_MORE));
		pInfoButton->SetClickHdl(LINK(this,SbaMsgBox,ButtonClickHdl));
		pInfoButton->SetUniqueId(UID_SQLERROR_BUTTONMORE);
		pInfoButton->Show();
		AddButton(pInfoButton, BUTTONID_MORE, 0);
	}
}

//------------------------------------------------------------------------------
SbaMsgBox::SbaMsgBox(Window* pParent,
					 const String& rTitle,
					 const SdbStatus& rSdbStat,
					 WinBits nStyle,
					 DlgImage eImage)
		  :SbaMsgDlg(pParent)
{
	sInfo = rSdbStat.ErrorInfo();
	Construct(rTitle, rSdbStat.ErrorMessage(), nStyle, eImage);
}

//------------------------------------------------------------------------------
SbaMsgBox::SbaMsgBox(Window* pParent,
					 const SbaStatus& rStat,
					 WinBits nStyle,
					 DlgImage eImage)
		  :SbaMsgDlg(pParent)
{
	const SdbStatus& rSdbStat = rStat.SdbStatusObject();
	sInfo = rSdbStat.ErrorInfo();
	Construct(rStat.Message(), rSdbStat.ErrorMessage(), nStyle, eImage);
}

//------------------------------------------------------------------------------
SbaMsgBox::SbaMsgBox(Window* pParent,
					 const String& rTitle,
					 const String& rMessage,
					 WinBits nStyle,
					 DlgImage eImage)
		  :SbaMsgDlg(pParent)
{
	Construct(rTitle, rMessage, nStyle, eImage);
}

//------------------------------------------------------------------------------
SbaMsgBox::~SbaMsgBox()
{
	delete pInfoButton;
}

//--------------------------------------------------------------------------
IMPL_LINK( SbaMsgBox, ButtonClickHdl, Button *, pButton )
{
	SbaDlgText	aDlg(this, sInfo);
	aDlg.Execute();
	return 0;
}


