/*************************************************************************
 *
 *  $RCSfile: dlgrowht.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sv.hxx>
#include <segmentc.hxx>

#include "sbares.hxx"
#include "dlgrowht.hrc"
#include "dlgrowht.hxx"

DBG_NAME( DlgRowHeight );

SEG_EOFGLOBALS()

#define DEF_ROW_HEIGHT	16

//==================================================================
#pragma SEG_FUNCDEF(dlgrowht_01)

DlgRowHeight::DlgRowHeight( Window * pParent, sal_uInt16 nVal )
	: ModalDialog( pParent, SbaResId(DLG_ROWHEIGHT) ),
	aFT_VALUE(		this, ResId( FT_VALUE ) ),
	aMF_VALUE(		this, ResId( MF_VALUE ) ),
	aCB_STANDARD(	this, ResId( CB_STANDARD ) ),
	aPB_OK(			this, ResId( PB_OK ) ),
	aPB_CANCEL(		this, ResId( PB_CANCEL ) ),
	aPB_HELP(		this, ResId( PB_HELP ) ),

	nPrevValue( nVal )
{
	DBG_CTOR( DlgRowHeight, NULL );

	aCB_STANDARD.SetClickHdl(LINK(this,DlgRowHeight,CbClickHdl));
	SetValue( nVal );

	FreeResource();
}

//------------------------------------------------------------------------------
#pragma SEG_FUNCDEF(dlgrowht_02)

DlgRowHeight::~DlgRowHeight()
{
	DBG_DTOR( DlgRowHeight, NULL );

}

//------------------------------------------------------------------------------
#pragma SEG_FUNCDEF(dlgrowht_03)

void DlgRowHeight::SetValue( sal_uInt16 nVal )
{
	DBG_CHKTHIS( DlgRowHeight, NULL );

	::com::sun::star::awt::Point	aPix = PixelToLogic( ::com::sun::star::awt::Point( nVal, 0 ), MAP_100TH_MM );

	aMF_VALUE.SetValue( aPix.X(), FUNIT_MM );

}

//------------------------------------------------------------------------------
#pragma SEG_FUNCDEF(dlgrowht_04)

sal_uInt16 DlgRowHeight::GetValue()
{
	DBG_CHKTHIS( DlgRowHeight, NULL );

	sal_uInt16	nResult = DEF_ROW_HEIGHT;

	::com::sun::star::awt::Point	aPix;

	aPix.X() = aMF_VALUE.GetValue( FUNIT_MM );

	nResult = (sal_uInt16)LogicToPixel (aPix, MAP_100TH_MM ).X();

	return nResult;
}

//------------------------------------------------------------------------------
#pragma SEG_FUNCDEF(dlgrowht_05)

IMPL_LINK( DlgRowHeight, CbClickHdl, Button *, pButton )
{
	DBG_CHKTHIS( DlgRowHeight, NULL );

	if( pButton == &aCB_STANDARD )
	{
		if( aCB_STANDARD.IsChecked() )
		{
			nPrevValue = GetValue();
			SetValue( DEF_ROW_HEIGHT );
		}
		else
		{
			SetValue( nPrevValue );
		}
	}
	return 0;
}

#pragma SEG_EOFMODULE

