/*************************************************************************
 *
 *  $RCSfile: duplname.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef SBA_DUPLNAME_HRC
#include "duplname.hrc"
#endif
#ifndef _SBA_DUPLNAME_HXX
#include "duplname.hxx"
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif


//////////////////////////////////////////////////////////////////////////
// Klasse DlgDuplName
DlgDuplName::DlgDuplName( Window * pParent, DBObject eType, const String& rName, SbaDatabaseRef xDestDatabase )
	:ModalDialog( pParent, SbaResId(DLG_DUPLNAME) )
	,aFT_Info( this, SbaResId( FT_INFO ) )
	,aFT_Name( this, SbaResId( FT_NAME ) )
	,aET_Name( this, SbaResId( ET_NAME ) )
	,aPB_HELP( this, ResId( PB_HELP ) )
	,aPB_CANCEL( this, ResId( PB_CANCEL ) )
	,aPB_OK( this, ResId( PB_OK ) )
{
	aName = rName;
	eObj = eType;
	xDatabase = xDestDatabase;

	//////////////////////////////////////////////////////////////////////
	// Info Text setzen
	aInfoString = aFT_Info.GetText();
	String aInfoText = aInfoString;
	aInfoText.SearchAndReplaceAscii("$Name: OpenOffice605 $", aName );
	aFT_Info.SetText( aInfoText );

	//////////////////////////////////////////////////////////////////////
	// Eingabeweite Edit setzen
	switch (eObj)
	{
		case dbTable:
		{
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = xDatabase->GetMetaData();
			xub_StrLen nMaxTableNameLen = (xub_StrLen)rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::TABLE_NAME_LEN );
			aET_Name.SetMaxTextLen( nMaxTableNameLen );
		}
		break;
		case dbForm:
		case dbReport:
			// the name will be used as stream name within an storage, so limit it's length
			// FS - 68097 - 18.01.00
			aET_Name.SetMaxTextLen(32);
			break;
	}

	aPB_OK.SetClickHdl( LINK( this, DlgDuplName, OKClickHdl ) );
	FreeResource();
}

DlgDuplName::~DlgDuplName()
{
}

IMPL_LINK( DlgDuplName, OKClickHdl, Button*, pButton )
{
	aName = aET_Name.GetText();

	//////////////////////////////////////////////////////////////////////
	// Wenn Name bereits vorhanden, Infotext neu setzen
	if	(	xDatabase->HasObject( eObj, aName )
		||	((dbTable == eObj) && !xDatabase->IsSQLNameValid(aName))
		)
	{
		String aInfoText = aInfoString;
		aInfoText.SearchAndReplaceAscii("$Name: OpenOffice605 $", aName );
		aFT_Info.SetText( aInfoText );
	}
	//////////////////////////////////////////////////////////////////////
	// ... ansonsten Dialog beenden
	else
		EndDialog( sal_True );

	return 0;
}

