/*************************************************************************
 *
 *  $RCSfile: fldctrl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DATCONV_HXX_
#include "datconv.hxx"
#endif
#ifndef _SBA_FLDCTRL_HXX
#include "fldctrl.hxx"
#endif
#ifndef _SBA_SBATABED_HXX
#include "sbatabed.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif

#ifndef _SVX_NUMFMTSH_HXX //autogen
#include <svx/numfmtsh.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SBA_SBATTRDLG_HXX
#include "dlgattr.hxx"
#endif

#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SBAITEMS_HXX //autogen
#include <sbaitems.hxx>
#endif

#include "sbahlpid.hrc"

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE		// ohne das bekomme ich einen Compiler-Fehler in <svtools/zforlist.hxx>
#include <svtools/zforlist.hxx>
#endif

//==================================================================

// fuer die Controls auf der SbaFieldDescGenPage
#define CONTROL_SPACING_X	18	// 6
#define	CONTROL_SPACING_Y	5
#define CONTROL_HEIGHT		20
#define CONTROL_WIDTH_1		140	// 100
#define CONTROL_WIDTH_2		100 // 60
#define CONTROL_WIDTH_3		250
#define CONTROL_WIDTH_4		(CONTROL_WIDTH_3 - CONTROL_HEIGHT - 5)


#define HSCROLL_STEP		20
//==================================================================
// class SbaFieldDescControl
//==================================================================

DBG_NAME(SbaFieldDescControl);

//==================================================================
SbaFieldDescControl::SbaFieldDescControl( Window* pParent, const ResId& rResId, SbaTableDesignHelpBar* pHelpBar)
	:TabPage( pParent, rResId )
	,aPreviousType( dbNULL )
	,pHelp( pHelpBar )
	,nCurChildId(1)
	,pDefault(NULL)
	,pDefaultText(NULL)
	,pRequired(NULL)
	,pRequiredText(NULL)
	,pAutoIncrement(NULL)
	,pAutoIncrementText(NULL)
	,pTextLen(NULL)
	,pTextLenText(NULL)
	,pNumType(NULL)
	,pNumTypeText(NULL)
	,pLastFocusWindow(NULL)
	,pFormatSample(NULL)
	,pFormatText(NULL)
	,pFormat(NULL)
	,pLength(NULL)
	,pLengthText(NULL)
	,pScale(NULL)
	,pScaleText(NULL)
	,pBoolDefault(NULL)
	,pBoolDefaultText(NULL)
	,m_pColumnName(NULL)
	,m_pColumnNameText(NULL)
	,m_pType(NULL)
	,m_pTypeText(NULL)
	,nPos(-1)
	,aYes(SbaResId(STR_VALUE_YES))
	,aNo(SbaResId(STR_VALUE_NO))
	,m_pFormatterShell(NULL)
	,nDelayedGrabFocusEvent(0)
	,pActFieldDescr(0)
{
	DBG_CTOR(SbaFieldDescControl,NULL);

	m_pVertScroll = new ScrollBar(this, WB_VSCROLL | WB_REPEAT | WB_DRAG);
	m_pHorzScroll = new ScrollBar(this, WB_HSCROLL | WB_REPEAT | WB_DRAG);
	m_pVertScroll->SetScrollHdl(LINK(this, SbaFieldDescControl, OnScroll));
	m_pHorzScroll->SetScrollHdl(LINK(this, SbaFieldDescControl, OnScroll));
	m_pVertScroll->Show();
	m_pHorzScroll->Show();

	m_pVertScroll->EnableClipSiblings();
	m_pHorzScroll->EnableClipSiblings();

	m_pVertScroll->SetLineSize(1);
	m_pVertScroll->SetPageSize(1);
	m_pHorzScroll->SetLineSize(1);
	m_pHorzScroll->SetPageSize(1);

	m_nOldVThumb = m_nOldHThumb = 0;
}
//------------------------------------------------------------------------------
SbaFieldDescControl::SbaFieldDescControl( Window* pParent, SbaTableDesignHelpBar* pHelpBar )
	:TabPage( pParent, WB_3DLOOK | WB_DIALOGCONTROL )
	,aPreviousType( dbNULL )
	,pHelp( pHelpBar )
	,nCurChildId(1)
	,pDefault(NULL)
	,pDefaultText(NULL)
	,pRequired(NULL)
	,pRequiredText(NULL)
	,pAutoIncrement(NULL)
	,pAutoIncrementText(NULL)
	,pTextLen(NULL)
	,pTextLenText(NULL)
	,pNumType(NULL)
	,pNumTypeText(NULL)
	,pLastFocusWindow(NULL)
	,pFormatSample(NULL)
	,pFormatText(NULL)
	,pFormat(NULL)
	,pLength(NULL)
	,pLengthText(NULL)
	,pScale(NULL)
	,pScaleText(NULL)
	,pBoolDefault(NULL)
	,pBoolDefaultText(NULL)
	,m_pColumnName(NULL)
	,m_pColumnNameText(NULL)
	,m_pType(NULL)
	,m_pTypeText(NULL)
	,nPos(-1)
	,aYes(SbaResId(STR_VALUE_YES))
	,aNo(SbaResId(STR_VALUE_NO))
	,m_pFormatterShell(NULL)
	,nDelayedGrabFocusEvent(0)
	,pActFieldDescr(0)

{
	DBG_CTOR(SbaFieldDescControl,NULL);

	m_pVertScroll = new ScrollBar(this, WB_VSCROLL | WB_REPEAT | WB_DRAG);
	m_pHorzScroll = new ScrollBar(this, WB_HSCROLL | WB_REPEAT | WB_DRAG);
	m_pVertScroll->SetScrollHdl(LINK(this, SbaFieldDescControl, OnScroll));
	m_pHorzScroll->SetScrollHdl(LINK(this, SbaFieldDescControl, OnScroll));
	m_pVertScroll->Show();
	m_pHorzScroll->Show();

	m_pVertScroll->EnableClipSiblings();
	m_pHorzScroll->EnableClipSiblings();

	m_pVertScroll->SetLineSize(1);
	m_pVertScroll->SetPageSize(1);
	m_pHorzScroll->SetLineSize(1);
	m_pHorzScroll->SetPageSize(1);

	m_nOldVThumb = m_nOldHThumb = 0;
}

//------------------------------------------------------------------------------
SbaFieldDescControl::~SbaFieldDescControl()
{
	DBG_DTOR(SbaFieldDescControl,NULL);

	delete m_pFormatterShell;

	delete m_pVertScroll;
	delete m_pHorzScroll;

	//////////////////////////////////////////////////////////////////////
	// Childs zerstoeren
	DeactivateAggregate( tpDefault );
	DeactivateAggregate( tpRequired );
	DeactivateAggregate( tpTextLen );
	DeactivateAggregate( tpNumType );
	DeactivateAggregate( tpScale );
	DeactivateAggregate( tpLength );
	DeactivateAggregate( tpFormat );
	DeactivateAggregate( tpAutoIncrement );
	DeactivateAggregate( tpBoolDefault );
	DeactivateAggregate( tpColumnName );
	DeactivateAggregate( tpType );

	if(nDelayedGrabFocusEvent)
		Application::RemoveUserEvent(nDelayedGrabFocusEvent);
}

//------------------------------------------------------------------------------
String SbaFieldDescControl::BoolStringPersistent(const String& rUIString) const
{
	static String aZero('0');
	static String aOne('1');
	static String aNo(SbaResId(STR_VALUE_NO));
	static String aYes(SbaResId(STR_VALUE_YES));

	if (rUIString == aNo)
		return aZero;
	if (rUIString == aYes)
		return aOne;
	return String();
}

//------------------------------------------------------------------------------
String SbaFieldDescControl::BoolStringUI(const String& rPersistentString) const
{
	static String aZero('0');
	static String aOne('1');
	static String aYes(SbaResId(STR_VALUE_YES));
	static String aNo(SbaResId(STR_VALUE_NO));
	static String aNone(SbaResId(STR_VALUE_NONE));

	// FS - 66161 - 14.05.1999 - aeltere Versionen haben eventuell einen sprachabhaengigen String als Default gespeichert
	if (rPersistentString.Equals(aYes) || rPersistentString.Equals(aNo))
		return rPersistentString;

	if (rPersistentString == aZero)
		return aNo;
	if (rPersistentString == aOne)
		return aYes;

	return aNone;
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::Init()
{
	DBG_ASSERT(m_pFormatterShell == NULL, "SbaFieldDescControl::Init : I already have a formatter shell ! (called me twice or forgot to set to null in ctor ?)");

	InitFormatterShell();
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::InitFormatterShell(sal_uInt32 nFormatKey)
{
	if (m_pFormatterShell)
		delete m_pFormatterShell;

	m_pFormatterShell = new SvxNumberFormatShell(GetFormatter(),nFormatKey, SVX_VALUE_TYPE_UNDEFINED, String());

	// muss initialisiert werden
	SvStrings aFormatEntries;
	Color aColor;
	sal_uInt16 nCat = 0;
	sal_uInt16 nFmt = 0;
	LanguageType aLang = LANGUAGE_DONTKNOW;
	String strSample;
	m_pFormatterShell->GetInitSettings(nCat, aLang, nFmt, aFormatEntries, strSample, aColor);

	for (int i=0; i<aFormatEntries.Count(); ++i)
		delete aFormatEntries.GetObject(i);
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaFieldDescControl, OnScroll, ScrollBar*, pBar)
{
	ScrollAllAggregates();
	return 0;
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::CheckScrollBars()
{
	// ein paar Berechnungen zur neuen Position der ScrollBars
	Size szOverallSize = GetSizePixel();
	long nHScrollHeight = m_pHorzScroll->GetSizePixel().Height();
	long nVScrollWidth = m_pVertScroll->GetSizePixel().Width();

	long nNewHWidth = szOverallSize.Width() - nVScrollWidth;
	long nNewVHeight = szOverallSize.Height() - nHScrollHeight;

	sal_Bool bNeedHScrollBar(sal_False), bNeedVScrollBar(sal_False);

	// die Bereiche anpassen
	// brauche ich ScrollBars eigentlich ?
	// horizontal :
	long lMaxXPosition = 0;
	if (pRequired)
		lMaxXPosition = max(lMaxXPosition, pRequired->GetSizePixel().Width() + pRequired->GetPosPixel().X());
	if (pNumType)
		lMaxXPosition = max(lMaxXPosition, pNumType->GetSizePixel().Width() + pNumType->GetPosPixel().X());
	if (pAutoIncrement)
		lMaxXPosition = max(lMaxXPosition, pAutoIncrement->GetSizePixel().Width() + pAutoIncrement->GetPosPixel().X());
	if (pDefault)
		lMaxXPosition = max(lMaxXPosition, pDefault->GetSizePixel().Width() + pDefault->GetPosPixel().X());
	if (pTextLen)
		lMaxXPosition = max(lMaxXPosition, pTextLen->GetSizePixel().Width() + pTextLen->GetPosPixel().X());
	if (pLength)
		lMaxXPosition = max(lMaxXPosition, pLength->GetSizePixel().Width() + pLength->GetPosPixel().X());
	if (pScale)
		lMaxXPosition = max(lMaxXPosition, pScale->GetSizePixel().Width() + pScale->GetPosPixel().X());
	if (pFormat)
		lMaxXPosition = max(lMaxXPosition, pFormat->GetSizePixel().Width() + pFormat->GetPosPixel().X());
	if (m_pColumnName)
		lMaxXPosition = max(lMaxXPosition, m_pColumnName->GetSizePixel().Width() + m_pColumnName->GetPosPixel().X());
	if (m_pType)
		lMaxXPosition = max(lMaxXPosition, m_pType->GetSizePixel().Width() + m_pType->GetPosPixel().X());

	if (m_pHorzScroll)
		lMaxXPosition += m_pHorzScroll->GetThumbPos() * HSCROLL_STEP;

	long lMaxXAvailable = szOverallSize.Width();
	bNeedHScrollBar = lMaxXPosition > lMaxXAvailable;
		// aendert sich vielleicht noch

	// vertikal
	// wieviel Controls habe ich
	sal_uInt16 nActive = CountActiveAggregates();
	// welches ist das letzte, was ganz drauf passt ?
	sal_uInt16 nLastVisible;
	if (bNeedHScrollBar)
		nLastVisible = (szOverallSize.Height() - CONTROL_SPACING_Y - nHScrollHeight) / (CONTROL_SPACING_Y + CONTROL_HEIGHT);
	else
		nLastVisible = (szOverallSize.Height() - CONTROL_SPACING_Y) / (CONTROL_SPACING_Y + CONTROL_HEIGHT);
	bNeedVScrollBar = nActive>nLastVisible;

	if (bNeedVScrollBar)
	{
		// in die urspruengliche Berechnung von lMaxXAvailable ist nicht mit eingegangen, dass ich eine VScrollBar habe, also muss ich
		// das nachholen
		lMaxXAvailable -= nVScrollWidth;
		if (!bNeedHScrollBar && (lMaxXPosition > lMaxXAvailable))
		{
			// durch die vertikale brauche ich jetzt ploetzlich doch eine horizontale
			bNeedHScrollBar = sal_True;
			// nLastVisible anpassen
			nLastVisible = (szOverallSize.Height() - CONTROL_SPACING_Y - nHScrollHeight) / (CONTROL_SPACING_Y + CONTROL_HEIGHT);
				// bNeedVScrollBar aendert sich nicht : es ist schon auf sal_True und nLastVisible wird hoechstens kleiner
		}
	}

	// jetzt kann ich sie wirklich positionieren und ihre Parameter setzen
	if (bNeedVScrollBar)
	{
		m_pVertScroll->Show();
		m_pVertScroll->SetRangeMax(nActive - nLastVisible);
//		m_pVertScroll->SetThumbPos(0);

		m_pVertScroll->SetPosSizePixel( Point(nNewHWidth, 0), Size(nVScrollWidth, szOverallSize.Height()) );
	}
	else
	{
		m_pVertScroll->Hide();
		m_pVertScroll->SetRangeMax(0);
		m_pVertScroll->SetThumbPos(0);
	}

	if (bNeedHScrollBar)
	{
		m_pHorzScroll->Show();
		m_pHorzScroll->SetRangeMax((lMaxXPosition - lMaxXAvailable + HSCROLL_STEP - 1 )/HSCROLL_STEP);
//		m_pHorzScroll->SetThumbPos(0);

		m_pHorzScroll->SetPosSizePixel( Point(0, nNewVHeight), Size(bNeedVScrollBar ? nNewHWidth : szOverallSize.Width(), nHScrollHeight) );
	}
	else
	{
		m_pHorzScroll->Hide();
		m_pHorzScroll->SetRangeMax(0);
		m_pHorzScroll->SetThumbPos(0);
	}
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::Resize()
{
	CheckScrollBars();
	ScrollAllAggregates();
}

//------------------------------------------------------------------------------
inline void SbaFieldDescControl::ScrollAggregate(Control* pText, Control* pInput, Control* pButton, long nDeltaX, long nDeltaY)
{
	if  (!pText)
		return;
	pText->SetPosPixel(pText->GetPosPixel() + Point(nDeltaX, nDeltaY));
	pInput->SetPosPixel(pInput->GetPosPixel() + Point(nDeltaX, nDeltaY));
	if (pButton)
		pButton->SetPosPixel(pButton->GetPosPixel() + Point(nDeltaX, nDeltaY));
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::ScrollAllAggregates()
{
	long nDeltaX = 0, nDeltaY = 0;
	if (m_nOldHThumb != m_pHorzScroll->GetThumbPos())
	{
		nDeltaX = (m_nOldHThumb - m_pHorzScroll->GetThumbPos()) * HSCROLL_STEP;
		m_nOldHThumb = m_pHorzScroll->GetThumbPos();
	}

	if (m_nOldVThumb != m_pVertScroll->GetThumbPos())
	{
		nDeltaY = (m_nOldVThumb - m_pVertScroll->GetThumbPos()) * (CONTROL_SPACING_Y + CONTROL_HEIGHT);
		m_nOldVThumb = m_pVertScroll->GetThumbPos();
	}

	if (nDeltaX || nDeltaY)
	{
		ScrollAggregate(pRequiredText, pRequired, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pNumTypeText, pNumType, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pAutoIncrementText, pAutoIncrement, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pDefaultText, pDefault, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pTextLenText, pTextLen, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pLengthText, pLength, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pScaleText, pScale, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(pFormatText, pFormatSample, pFormat, nDeltaX, nDeltaY);
		ScrollAggregate(m_pColumnNameText, m_pColumnName, NULL, nDeltaX, nDeltaY);
		ScrollAggregate(m_pTypeText, m_pType, NULL, nDeltaX, nDeltaY);
	}
}

//------------------------------------------------------------------------------
sal_uInt16 SbaFieldDescControl::CountActiveAggregates() const
{
	Control* ppAggregates[] = { pRequired, pNumType, pAutoIncrement, pDefault, pTextLen, pLength, pScale, pFormat, m_pColumnName, m_pType};
	sal_uInt16 nVisibleAggregates = 0;
	for (sal_uInt16 i=0; i<sizeof(ppAggregates)/sizeof(ppAggregates[0]); ++i)
		if (ppAggregates[i])
			++nVisibleAggregates;
	return nVisibleAggregates;
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::SetReadOnly( sal_Bool bReadOnly )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls enablen/disablen
	if (pDefault)
	{
		pDefaultText->Enable( !bReadOnly );
		pDefault->Enable( !bReadOnly );
	}
	if (pBoolDefault)
	{
		pBoolDefaultText->Enable( !bReadOnly );
		pBoolDefault->Enable( !bReadOnly );
	}
	if( pRequired )
	{
		pRequiredText->Enable( !bReadOnly );
		pRequired->Enable( !bReadOnly );
	}
	if( pTextLen )
	{
		pTextLenText->Enable( !bReadOnly );
		pTextLen->Enable( !bReadOnly );
	}
	if( pNumType )
	{
		pNumTypeText->Enable( !bReadOnly );
		pNumType->Enable( !bReadOnly );
	}
	if( pFormat )
	{
		pFormatText->Enable( !bReadOnly );
		pFormat->Enable( !bReadOnly );
	}
	if( pLength )
	{
		pLengthText->Enable( !bReadOnly );
		pLength->Enable( !bReadOnly );
	}
	if( pScale )
	{
		pScaleText->Enable( !bReadOnly );
		pScale->Enable( !bReadOnly );
	}
	if( pAutoIncrement )
	{
		pAutoIncrementText->Enable( !bReadOnly );
		pAutoIncrement->Enable( !bReadOnly );
	}

	if( m_pColumnName )
	{
		m_pColumnNameText->Enable( !bReadOnly );
		m_pColumnName->Enable( !bReadOnly );
	}
	if( m_pType )
	{
		m_pTypeText->Enable( !bReadOnly );
		m_pType->Enable( !bReadOnly );
	}
}

//------------------------------------------------------------------------------
String SbaFieldDescControl::GetControlText( sal_uInt16 nControlId )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Texte der Controls auslesen
	switch( nControlId )
	{
		case FIELD_PROPERTY_BOOL_DEFAULT:
			if (pBoolDefault)
				return pBoolDefault->GetSelectEntry();
			break;
		case FIELD_PROPERTY_DEFAULT:
			if (pDefault)
				return pDefault->GetText();
			break;
		case FIELD_PROPERTY_REQUIRED:
			if (pRequired)
				return pRequired->GetSelectEntry();
			break;
		case FIELD_PROPERTY_TEXTLEN:
			if (pTextLen)
				return pTextLen->GetValue();
		case FIELD_PROPERTY_NUMTYPE:
			if (pNumType)
				return pNumType->GetSelectEntry();
			break;
		case FIELD_PROPERTY_AUTOINC:
			if (pAutoIncrement)
				return pAutoIncrement->GetSelectEntry();
			break;
		case FIELD_PROPERTY_LENGTH:
			if (pLength)
				return pLength->GetText();
			break;
		case FIELD_PROPERTY_SCALE:
			if (pScale)
				return pScale->GetText();
			break;
		case FIELD_PROPERTY_FORMAT:
			if (pFormatSample)
				return pFormatSample->GetText();
			break;
		case FIELD_PRPOERTY_COLUMNNAME:
			if(m_pColumnName)
				return m_pColumnName->GetText();
		case FIELD_PRPOERTY_TYPE:
			if(m_pType)
				return m_pType->GetSelectEntry();
			break;
	}

	return String();
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::SetControlText( sal_uInt16 nControlId, const String& rText )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Texte der Controls setzen
	switch( nControlId )
	{
		case FIELD_PROPERTY_BOOL_DEFAULT:
			if (pBoolDefault)
			{
				String sOld = pBoolDefault->GetSelectEntry();
				pBoolDefault->SelectEntry(rText);
				if (!sOld.Equals(rText))
					LINK(this, SbaFieldDescControl, ChangeHdl).Call(pBoolDefault);
			}
			break;
		case FIELD_PROPERTY_DEFAULT:
			if (pDefault)
			{
				pDefault->SetText(rText);
				UpdateFormatSample(pActFieldDescr);
			}
			break;

		case FIELD_PROPERTY_REQUIRED:
			if (pRequired)
				pRequired->SelectEntry(rText);
			break;


		case FIELD_PROPERTY_TEXTLEN:
			if (pTextLen)
				pTextLen->SetText(rText);
			break;

		case FIELD_PROPERTY_NUMTYPE:
			if (pNumType)
				pNumType->SelectEntry(rText);
			break;

		case FIELD_PROPERTY_AUTOINC:
			if (pAutoIncrement)
			{
				String sOld = pAutoIncrement->GetSelectEntry();
				pAutoIncrement->SelectEntry(rText);
				if (!sOld.Equals(rText))
					LINK(this, SbaFieldDescControl, ChangeHdl).Call(pAutoIncrement);
			}
			break;

		case FIELD_PROPERTY_LENGTH:
			if (pLength)
				pLength->SetText(rText);
			break;

		case FIELD_PROPERTY_SCALE:
			if (pScale)
				pScale->SetText(rText);
			break;

		case FIELD_PROPERTY_FORMAT:
			if (pActFieldDescr)
				UpdateFormatSample(pActFieldDescr);
			break;
		case FIELD_PRPOERTY_COLUMNNAME:
			if(m_pColumnName)
				m_pColumnName->SetText(rText);
			break;
		case FIELD_PRPOERTY_TYPE:
			if(m_pType)
				m_pType->SelectEntry(rText);
			break;

	}
}

//------------------------------------------------------------------------
IMPL_LINK( SbaFieldDescControl, FormatClickHdl, Button *, pButton )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Temporaere Column erzeugen, mit der Datenaustausch mit Dialog erfolgt
	if( !pActFieldDescr )
		return 0;

	SbaTableDef* pDef = (SbaTableDef*)GetDataDef();
	sal_uInt32 nOldFormatKey(pActFieldDescr->GetFormatKey());
	SbaFieldType aType = pActFieldDescr->GetFieldType();
	SvxCellHorJustify rOldJustify = pActFieldDescr->GetHorJustify();

	SbaColumnRef xTempCol = pDef->CreateColumn(String("TempCol", RTL_TEXTENCODING_ASCII_US), aType, 0, 0, sal_False, nOldFormatKey, 0 );
	xTempCol->Put(SvxHorJustifyItem(rOldJustify, SBA_ATTR_ALIGN_HOR_JUSTIFY));
	if ((dbText == aType) || (dbMemo == aType))
	{
		xTempCol->Put(SfxBoolItem(SID_ATTR_NUMBERFORMAT_ONE_AREA, sal_True));
		if (!pDef->GetFormatter()->IsTextFormat(nOldFormatKey))
		{
			// Since tables/queries are browsed using the new grid control, a non-text format has no effect on text columns
			// (the content will be displayed as if it isn't formatted).
			// So any non-text format on the column doesn't make any sense.
			// FS - 15.11.99
			nOldFormatKey = pDef->GetFormatter()->GetStandardFormat(NUMBERFORMAT_TEXT, Application::GetAppInternational().GetLanguage());
			xTempCol->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, nOldFormatKey));

			// We don't have to set the new key in the column's set : displaying and setting a new key are done as if this key
			// is used, so the user won't see the old format but always the "standard text format". And if he changes
			// this format to another text format (he can't change it to a non-text one) the column will be updated as usual.
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Dialog der Spaltenattribute
	SbaSbAttrDlg aDlg( NULL, xTempCol, pDef->GetFormatter(), TP_ATTR_ALIGN | TP_ATTR_NUMBER );
	if( aDlg.Execute() == RET_OK )
	{
		const SfxItemSet* pSet = aDlg.GetExampleSet();
			// GetExampleSet statt GetOutputItemSet, denn letzteres enthaelt nur die modifizierten Items

		sal_Bool bModified = sal_False;
		// den Formatkey
		SfxUInt32Item& rFormatItem = (SfxUInt32Item&)pSet->Get(SBA_DEF_FMTVALUE);
		sal_uInt32 nNewFormatKey(rFormatItem.GetValue());
		if (nNewFormatKey != nOldFormatKey)
		{
			SetModified(sal_True);
			bModified = sal_True;
		}

		if (m_pFormatterShell->GetListPos4Entry(nNewFormatKey) == -1)
			// Das neue Format ist meiner Formatter-Shell nicht bekannt, wurde also gerade neu angelegt
			// (oder ist in einer anderen Sprache als die aktuell eingestellte gehalten)
			// Das bedeutet, das ich die Shell updaten muss, sonst laeuft UpdateFormatSample in's Leere.
			InitFormatterShell(nNewFormatKey);

		// die horizontale Ausrichtung
		SvxHorJustifyItem& rHorJustifyItem = (SvxHorJustifyItem&)pSet->Get(SBA_ATTR_ALIGN_HOR_JUSTIFY);
		SvxCellHorJustify rNewJustify = (SvxCellHorJustify)rHorJustifyItem.GetValue();
		if (rNewJustify != rOldJustify)
		{
			SetModified(sal_True);
			bModified = sal_True;
		}

		if (bModified)
			CellModified(-1, FIELD_PROPERTY_FORMAT);

		// das Setzen an der FieldDecription NACH den CellModified, da das ein Undo-::com::sun::star::chaos::Action erzeugt und die auf die Description
		// zurueckgreift
		pActFieldDescr->SetFormatKey( nNewFormatKey );
		pActFieldDescr->SetHorJustify(rNewJustify);

		UpdateFormatSample(pActFieldDescr);

		SFX_BINDINGS().Invalidate(SID_SAVEDOC);
		//////////////////////////////////////////////////////////////////////
		// Formatter speichern
		pDef->GetDatabase()->AlterFormatter();
	}

	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaFieldDescControl, ChangeHdl, ListBox *, pAutoInc )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	if(pAutoInc->GetSavedValue() == pAutoInc->GetSelectEntryPos() || !pActFieldDescr)
		return 0;

	SetModified(sal_True);

	// Sonderbehandlund f"ur Bool Felder
	if(pAutoInc == pRequired && pBoolDefault && pActFieldDescr->ISA(SbaExtFieldDescr) )
	{
		// wenn pRequired auf sal_True gesetzt ist, dann darf das sal_Bool Feld nicht den Eintrag <<keiner>> besitzen
		String sDef = BoolStringUI((((SbaExtFieldDescr*)pActFieldDescr)->GetDefault()));

		if(pRequired->GetSelectEntryPos() == 0) // JA
		{
			pBoolDefault->RemoveEntry(String(SbaResId(STR_VALUE_NONE)));
			if (!sDef.Equals(aYes) && !sDef.Equals(aNo))
				pBoolDefault->SelectEntryPos(1);  // nein als Default
			else
				pBoolDefault->SelectEntry(sDef);
		}
		else if(pBoolDefault->GetEntryCount() < 3)
		{
			pBoolDefault->InsertEntry(String(SbaResId(STR_VALUE_NONE)));
			pBoolDefault->SelectEntry(sDef);
		}
	}

	// nur fuer AutoIncrement eine Sonderbehandlung
	if (pAutoInc == pAutoIncrement)
	{
		if(pAutoInc->GetSelectEntryPos() == 1)
		{ // no
			if(pActFieldDescr->IsPrimaryKey())
				DeactivateAggregate( tpRequired );
			else if( pActFieldDescr->ISA(SbaExtFieldDescr) )
			{
				ActivateAggregate( tpRequired );
				if(pRequired)
				{
					if( ((SbaExtFieldDescr*)pActFieldDescr)->IsRequired() )
						pRequired->SelectEntryPos( 0 ); // yes
					else
						pRequired->SelectEntryPos( 1 ); // no
				}
			}
			ActivateAggregate( tpDefault );
		}
		else
		{
			DeactivateAggregate( tpRequired );
			DeactivateAggregate( tpDefault );
		}
		// und jetzt alle nach oben schieben
		ArrangeAggregates();
	}

	if(pAutoInc == m_pType)
	{
		pAutoInc->SaveValue();
		String rType(m_pType->GetSelectEntry());

		SbaFieldType eType = dbNone;

		if( rType.Equals(GetTypeString(TYPE_UNKNOWN)) )
			eType = dbNone;
		else if( rType.Equals(GetTypeString(TYPE_TEXT)) )
			eType = dbText;
		else if( rType.Equals(GetTypeString(TYPE_NUMERIC)) )
			eType = dbNumeric;
		else if( rType.Equals(GetTypeString(TYPE_DATETIME)) )
			eType = dbDateTime;
		else if( rType.Equals(GetTypeString(TYPE_DATE)) )
			eType = dbDate;
		else if( rType.Equals(GetTypeString(TYPE_TIME)) )
			eType = dbTime;
		else if( rType.Equals(GetTypeString(TYPE_BOOL)) )
			eType = dbBool;
		else if( rType.Equals(GetTypeString(TYPE_CURRENCY)) )
			eType = dbCurrency;
		else if( rType.Equals(GetTypeString(TYPE_MEMO)) )
			eType = dbMemo;
		else if( rType.Equals(GetTypeString(TYPE_COUNTER)) )
			eType = dbCounter;
		else if( rType.Equals(GetTypeString(TYPE_IMAGE)) )
			eType = dbImage;
		else if( rType.Equals(GetTypeString(TYPE_CHAR)) )
			eType = dbChar;
		else if( rType.Equals(GetTypeString(TYPE_DECIMAL)) )
			eType = dbDecimal;
		else if( rType.Equals(GetTypeString(TYPE_BINARY)) )
			eType = dbBinary;
		else if( rType.Equals(GetTypeString(TYPE_VARBINARY)) )
			eType = dbVarBinary;


		SbaFieldDescr *pFieldDescr;
		switch(eType)
		{
			case dbNone:			// undefiniert: unbekannt
				 pFieldDescr = new SbaUnknownFieldDescr(); break;
			case dbText:				// var. Text:
				 pFieldDescr = new SbaTextFieldDescr(); break;
			case dbNumeric:			// Zahlen von Byte bis double:
				 pFieldDescr = new SbaNumericFieldDescr(); break;
			case dbDateTime:			// Datumzeit:
				 pFieldDescr = new SbaDateTimeFieldDescr(); break;
			case dbDate:				// Datum:
				 pFieldDescr = new SbaDateFieldDescr(); break;
			case dbTime:				// Zeit:
				 pFieldDescr = new SbaTimeFieldDescr(); break;
			case dbBool:				// Logical:
				 pFieldDescr = new SbaBoolFieldDescr(); break;
			case dbCurrency:			// Whrung:
				 pFieldDescr = new SbaCurrencyFieldDescr(); break;
			case dbMemo:				// Langer Text:
				 pFieldDescr = new SbaMemoFieldDescr(); break;
			case dbCounter:			// Zaehler:
				 pFieldDescr = new SbaCounterFieldDescr(); break;
			case dbImage:			// Bilder:
				 pFieldDescr = new SbaImageFieldDescr(); break;
			case dbChar:				// fixt. Text:
				 pFieldDescr = new SbaCharFieldDescr(); break;
			case dbDecimal:			// decimal Werte: mit Vor und Nachkommastellen:
				 pFieldDescr = new SbaDecimalFieldDescr(); break;
			case dbBinary:			// Binary Feld bis 255:
				 pFieldDescr = new SbaBinaryFieldDescr(); break;
			case dbVarBinary:		// VarBinary Feld bis 255:
				 pFieldDescr = new SbaVarBinaryFieldDescr(); break;
			case dbBigInt:			// Big integer:
				 pFieldDescr = new SbaBigIntFieldDescr(); break;

		}
		pFieldDescr->SetName(pActFieldDescr->GetName());
		pFieldDescr->SetFormatKey(pActFieldDescr->GetFormatKey());
		pFieldDescr->SetPrimaryKey(pActFieldDescr->IsPrimaryKey());
		pFieldDescr->SetDescription(pActFieldDescr->GetDescription());
		pFieldDescr->SetAutoIncrement(pActFieldDescr->IsAutoIncrement());
		pFieldDescr->SetHorJustify((SvxCellHorJustify)pActFieldDescr->GetHorJustify());

		//////////////////////////////////////////////////////////////////////
		// Spezielle Daten
		if( pFieldDescr->ISA(SbaExtFieldDescr) && pActFieldDescr->ISA(SbaExtFieldDescr))
		{
			((SbaExtFieldDescr*)pFieldDescr)->SetRequired(((SbaExtFieldDescr*)pActFieldDescr)->IsRequired());
			((SbaExtFieldDescr*)pFieldDescr)->SetDefault(((SbaExtFieldDescr*)pActFieldDescr)->GetDefault());
		}
		delete pActFieldDescr;
		pActFieldDescr = pFieldDescr;
		DisplayData(pActFieldDescr);
		CellModified(-1, m_pType->GetPos());
	}



	return 0;
}
//------------------------------------------------------------------------------
// alle Control neu anordnen, so dass sie in fester Reihenfolge und wirklich
// OBEN auf der DescriptionPage stehen
void SbaFieldDescControl::ArrangeAggregates()
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	// die Beschreibung eines Controls
	struct AGGREGATE_DESCRIPTION
	{
		Control*	pctrlInputControl;	// das eigentliche Control zur Eingabe
		Control*	pctrlTextControl;	// das Label dazu
		int			nPosSizeArgument;	// das zweite Argument fuer SetPosSize
	};
	AGGREGATE_DESCRIPTION adAggregates[] = {
		{ m_pColumnName, m_pColumnNameText, 1},
		{ m_pType, m_pTypeText, 1},
		{ pAutoIncrement, pAutoIncrementText, 1 },
		{ pNumType, pNumTypeText, 1 },
		{ pRequired, pRequiredText, 1 },
		{ pTextLen, pTextLenText, 1 },
		{ pLength, pLengthText, 1 },
		{ pScale, pScaleText, 1 },
		{ pDefault, pDefaultText, 3 },
		{ pFormatSample, pFormatText, 4 },
		{ pBoolDefault, pBoolDefaultText, 1 }
	};

	// und los ...
	int nCurrentControlPos = 0;
	Control* pZOrderPredecessor = NULL;
	for (int i=0; i<sizeof(adAggregates)/sizeof(adAggregates[0]); i++)
	{
		if (adAggregates[i].pctrlInputControl)
		{
			SetPosSize(&adAggregates[i].pctrlTextControl, nCurrentControlPos, 0);
			SetPosSize(&adAggregates[i].pctrlInputControl, nCurrentControlPos, adAggregates[i].nPosSizeArgument);

			// die Z-Order so, dass die Controls auch wirklich in derselben Reihenfolge durchwandert werden koennen, in der sie
			// hier angeordnet wurden
			adAggregates[i].pctrlInputControl->SetZOrder(pZOrderPredecessor, pZOrderPredecessor ? WINDOW_ZORDER_BEHIND : WINDOW_ZORDER_FIRST);
			pZOrderPredecessor = adAggregates[i].pctrlInputControl;

			if (adAggregates[i].pctrlInputControl == pFormatSample)
			{
				pFormat->SetZOrder(pZOrderPredecessor, WINDOW_ZORDER_BEHIND);
				pZOrderPredecessor = pFormat;
			}

			++nCurrentControlPos;
		}
	}

	// eine Sonderbehandlung fuer die Format-Controls
	if (pFormat)
	{
		Point ptSamplePos(pFormatSample->GetPosPixel());
		Size szSampleSize(pFormatSample->GetSizePixel());
		pFormat->SetPosPixel(Point(ptSamplePos.X() + szSampleSize.Width() + 5, ptSamplePos.Y()));
	}

	// als letztes noch die ScrollBars in der ZOrder ganz nach oben
	m_pVertScroll->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
	m_pHorzScroll->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::ActivateAggregate( SbaControlType eType )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls erzeugen
	switch( eType )
	{
	case tpDefault:
		if( pDefault )
			return;
		nPos++;
		pDefaultText = new FixedText( this );
		pDefaultText->SetText( SbaResId(STR_DEFAULT_VALUE) );
		pDefault = new SbaPropEditCtrl( this, STR_HELP_DEFAULT_VALUE, FIELD_PROPERTY_DEFAULT, WB_BORDER );
		pDefault->SetHelpId(HID_TAB_ENT_DEFAULT);
		SetPosSize( (Control**)&pDefaultText, nPos, 0 );
		SetPosSize( (Control**)&pDefault, nPos, 3 );

		pDefault->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pDefault->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pDefaultText->EnableClipSiblings();
		pDefault->EnableClipSiblings();
		break;

	case tpRequired:
	{
		if( pRequired )
			return;
		SbaDBDataDef* pDef = GetDataDef();
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(pDef->GetDatabase()->GetMetaData());

		if(xMetaData->isCapable(::com::sun::star::data::DatabaseCapability::NON_NULLABLE_COLUMNS))
		{
			nPos++;
			pRequiredText = new FixedText( this );
			pRequiredText->SetText( SbaResId(STR_FIELD_REQUIRED) );
			pRequired = new SbaPropListBoxCtrl( this, STR_HELP_FIELD_REQUIRED, FIELD_PROPERTY_REQUIRED, WB_DROPDOWN);
			pRequired->SetHelpId(HID_TAB_ENT_REQUIRED);

			pRequired->InsertEntry( aYes );
			pRequired->InsertEntry( aNo );
			pRequired->SelectEntryPos(1);
			pRequired->SetSelectHdl(LINK(this,SbaFieldDescControl,ChangeHdl));

			SetPosSize( (Control**)&pRequiredText, nPos, 0 );
			SetPosSize( (Control**)&pRequired, nPos, 2 );

			pRequired->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
			pRequired->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

			pRequiredText->EnableClipSiblings();
			pRequired->EnableClipSiblings();
		}
	}
	break;
	case tpAutoIncrement:
	{
		if( pAutoIncrement )
			return;
		nPos++;
		pAutoIncrementText = new FixedText( this );
		pAutoIncrementText->SetText( SbaResId(STR_FIELD_AUTOINCREMENT) );
		pAutoIncrement = new SbaPropListBoxCtrl( this, STR_HELP_AUTOINCREMENT, FIELD_PROPERTY_AUTOINC, WB_DROPDOWN );
		pAutoIncrement->SetHelpId(HID_TAB_ENT_AUTOINCREMENT);

		pAutoIncrement->InsertEntry( aYes );
		pAutoIncrement->InsertEntry( aNo );
		pAutoIncrement->SelectEntryPos(0);
		pAutoIncrement->SetSelectHdl(LINK(this,SbaFieldDescControl,ChangeHdl));

		SetPosSize( (Control**)&pAutoIncrementText, nPos, 0 );
		SetPosSize( (Control**)&pAutoIncrement, nPos, 2 );

		pAutoIncrement->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pAutoIncrement->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pAutoIncrementText->EnableClipSiblings();
		pAutoIncrement->EnableClipSiblings();
	}
	break;
	case tpTextLen:
		if( pTextLen )
			return;
		nPos++;
		pTextLenText = new FixedText( this );
		pTextLenText->SetText( SbaResId(STR_TEXT_LENGTH) );

		pTextLen = new SbaPropNumericEditCtrl( this, STR_HELP_TEXT_LENGTH, FIELD_PROPERTY_TEXTLEN, WB_BORDER );
		pTextLen->SetDecimalDigits(0);
		pTextLen->SetMin(0);
		pTextLen->SetMax(0x7FFFFFFF);	// soll draussen geaendert werden, wenn noetig

		pTextLen->SetHelpId(HID_TAB_ENT_TEXT_LEN);
		SetPosSize( (Control**)&pTextLenText, nPos, 0 );
		SetPosSize( (Control**)&pTextLen, nPos, 1 );

		pTextLen->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pTextLen->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pTextLenText->EnableClipSiblings();
		pTextLen->EnableClipSiblings();
		break;

	case tpType:
		if( m_pType)
			return;
		nPos++;
		m_pTypeText = new FixedText( this );
		m_pTypeText->SetText( SbaResId(STR_TAB_FIELD_DATATYPE) );
		m_pType = new SbaPropListBoxCtrl( this, STR_HELP_AUTOINCREMENT, FIELD_PRPOERTY_TYPE, WB_DROPDOWN );
		m_pType->SetHelpId(HID_TAB_ENT_TYPE);
		m_pType->SetDropDownLineCount(5);
		{
			for( int i=(int)dbText; i<=(int)dbVarBinary; i++ )
			{
				if( GetDataDef()->GetDatabase()->IsTypeAvailable((SbaFieldType)i) )
					m_pType->InsertEntry( GetDataDef()->TypeString((SbaFieldType)i) );
			}
		}
		m_pType->SelectEntryPos(0);
		m_pType->SetSelectHdl(LINK(this,SbaFieldDescControl,ChangeHdl));

		SetPosSize( (Control**)&m_pTypeText, nPos, 0 );
		SetPosSize( (Control**)&m_pType, nPos, 2 );

		m_pType->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		m_pType->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		m_pTypeText->EnableClipSiblings();
		m_pType->EnableClipSiblings();
		break;
	case tpColumnName:
		if( m_pColumnName )
			return;
		nPos++;
		m_pColumnNameText = new FixedText( this );
		m_pColumnNameText->SetText( SbaResId(STR_TAB_FIELD_NAME) );
		m_pColumnName = new SbaPropEditCtrl( this, STR_HELP_DEFAULT_VALUE, FIELD_PRPOERTY_COLUMNNAME, WB_BORDER );
		m_pColumnName->SetHelpId(HID_TAB_ENT_COLUMNNAME);
		{
			SbaDBDataDef* pDef = GetDataDef();
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(pDef->GetDatabase()->GetMetaData());
			sal_uInt32 nMax = xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN);
			m_pColumnName->SetMaxTextLen( nMax ? nMax : EDIT_NOLIMIT);
		}

		SetPosSize( (Control**)&m_pColumnNameText, nPos, 0 );
		SetPosSize( (Control**)&m_pColumnName, nPos, 1 );

		m_pColumnName->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		m_pColumnName->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		m_pColumnNameText->EnableClipSiblings();
		m_pColumnName->EnableClipSiblings();
		break;
	case tpNumType:
		if( pNumType )
			return;
		nPos++;
		pNumTypeText = new FixedText( this );
		pNumTypeText->SetText( SbaResId(STR_NUMERIC_TYPE) );

		pNumType = new SbaPropListBoxCtrl( this, STR_HELP_NUMERIC_TYPE, FIELD_PROPERTY_NUMTYPE, WB_DROPDOWN );
		pNumType->SetDropDownLineCount(5);
		pNumType->SetHelpId(HID_TAB_ENT_NUMTYP);

		pNumType->InsertEntry( String::CreateFromAscii("Byte") );
		pNumType->InsertEntry( String::CreateFromAscii("SmallInt") );
		pNumType->InsertEntry( String::CreateFromAscii("Integer") );
		pNumType->InsertEntry( String::CreateFromAscii("Single") );
		pNumType->InsertEntry( String::CreateFromAscii("Double") );
		pNumType->SelectEntryPos(2);
		pNumType->SetSelectHdl(LINK(this,SbaFieldDescControl,ChangeHdl));

		SetPosSize( (Control**)&pNumTypeText, nPos, 0 );
		SetPosSize( (Control**)&pNumType, nPos, 1 );

		pNumType->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pNumType->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pNumTypeText->EnableClipSiblings();
		pNumType->EnableClipSiblings();
		break;

	case tpLength:
		if( pLength )
			return;
		nPos++;
		pLengthText = new FixedText( this );
		pLengthText->SetText( SbaResId(STR_LENGTH) );

		pLength = new SbaPropNumericEditCtrl( this, STR_HELP_LENGTH, FIELD_PROPERTY_LENGTH, WB_BORDER );
		pLength->SetDecimalDigits(0);
		pLength->SetMin(0);
		pLength->SetMax(0x7FFFFFFF);	// soll draussen geaendert werden, wenn noetig

		pLength->SetHelpId(HID_TAB_ENT_LEN);
		SetPosSize( (Control**)&pLengthText, nPos, 0 );
		SetPosSize( (Control**)&pLength, nPos, 1 );

		pLength->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pLength->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pLengthText->EnableClipSiblings();
		pLength->EnableClipSiblings();
		break;

	case tpScale:
		if( pScale )
			return;
		nPos++;
		pScaleText = new FixedText( this );
		pScaleText->SetText( SbaResId(STR_SCALE) );
		pScale = new SbaPropNumericEditCtrl( this, STR_HELP_SCALE, FIELD_PROPERTY_SCALE, WB_BORDER );
		pScale->SetDecimalDigits(0);
		pScale->SetMin(0);
		pScale->SetMax(0x7FFFFFFF);	// soll draussen geaendert werden, wenn noetig

		pScale->SetHelpId(HID_TAB_ENT_SCALE);

		SetPosSize( (Control**)&pScaleText, nPos, 0 );
		SetPosSize( (Control**)&pScale, nPos, 1 );

		pScale->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pScale->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pScaleText->EnableClipSiblings();
		pScale->EnableClipSiblings();
		break;

	case tpFormat:
		if (!pFormat)
		{
			nPos++;
			pFormatText = new FixedText( this );
			pFormatText->SetText( SbaResId(STR_FORMAT) );

			pFormatSample = new SbaPropEditCtrl( this, STR_HELP_FORMAT_CODE, -1, WB_BORDER );
			pFormatSample->SetHelpId(HID_TAB_ENT_FORMAT_SAMPLE);
			pFormatSample->SetReadOnly(sal_True);
			pFormatSample->Enable(sal_False);

			pFormat = new PushButton( this, SbaResId(PB_FORMAT) );
			pFormat->SetHelpId(HID_TAB_ENT_FORMAT);
			pFormat->SetSizePixel(Size(CONTROL_HEIGHT, CONTROL_HEIGHT));
			pFormat->SetClickHdl( LINK( this, SbaFieldDescControl, FormatClickHdl ) );

			pFormatSample->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
			pFormatSample->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));
			pFormat->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
			pFormat->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

			pFormatText->EnableClipSiblings();
			pFormatSample->EnableClipSiblings();
			pFormat->EnableClipSiblings();
		}

		UpdateFormatSample(pActFieldDescr);
		break;
	case tpBoolDefault:
		if (pBoolDefault)
			return;

		nPos++;
		pBoolDefaultText = new FixedText(this);
		pBoolDefaultText->SetText(SbaResId(STR_DEFAULT_VALUE));
		pBoolDefault = new SbaPropListBoxCtrl( this, STR_HELP_BOOL_DEFAULT, FIELD_PROPERTY_BOOL_DEFAULT, WB_DROPDOWN );
		pBoolDefault->SetDropDownLineCount(3);
		pBoolDefault->InsertEntry(String(SbaResId(STR_VALUE_NONE)));
		pBoolDefault->InsertEntry(aYes);
		pBoolDefault->InsertEntry(aNo);
		pBoolDefault->SetHelpId(HID_TAB_ENT_BOOL_DEFAULT);
		SetPosSize( (Control**)&pBoolDefaultText, nPos, 0 );
		SetPosSize( (Control**)&pBoolDefault, nPos, 3 );

		pBoolDefault->SetGetFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusGot));
		pBoolDefault->SetLoseFocusHdl(LINK(this, SbaFieldDescControl, OnControlFocusLost));

		pBoolDefaultText->EnableClipSiblings();
		pBoolDefault->EnableClipSiblings();
		break;

	}
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::DeactivateAggregate( SbaControlType eType )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls zerstoeren
	switch( eType )
	{
	case tpDefault:
		if( !pDefault )
			return;
		nPos--;
		pDefault->Hide();
		pDefaultText->Hide();
		delete pDefault;
		delete pDefaultText;
		pDefault = NULL;
		pDefaultText = NULL;
		break;

	case tpColumnName:
		if( !m_pColumnName )
			return;
		nPos--;
		m_pColumnName->Hide();
		m_pColumnNameText->Hide();
		delete m_pColumnName;
		delete m_pColumnNameText;
		m_pColumnName = NULL;
		m_pColumnNameText = NULL;
		break;

	case tpType:
		if( !m_pType )
			return;
		nPos--;
		m_pType->Hide();
		m_pTypeText->Hide();
		delete m_pType;
		delete m_pTypeText;
		m_pType = NULL;
		m_pTypeText = NULL;
		break;

	case tpAutoIncrement:
		if( !pAutoIncrement )
			return;
		nPos--;
		pAutoIncrement->Hide();
		pAutoIncrementText->Hide();
		delete pAutoIncrement;
		delete pAutoIncrementText;
		pAutoIncrement = NULL;
		pAutoIncrementText = NULL;
		break;

	case tpRequired:
		if( !pRequired )
			return;
		nPos--;
		pRequired->Hide();
		pRequiredText->Hide();
		delete pRequired;
		delete pRequiredText;
		pRequired = NULL;
		pRequiredText = NULL;
		break;

	case tpTextLen:
		if( !pTextLen )
			return;
		nPos--;
		pTextLen->Hide();
		pTextLenText->Hide();
		delete pTextLen;
		delete pTextLenText;
		pTextLen = NULL;
		pTextLenText = NULL;
		break;

	case tpNumType:
		if( !pNumType )
			return;
		nPos--;
		pNumType->Hide();
		pNumTypeText->Hide();
		delete pNumType;
		delete pNumTypeText;
		pNumType = NULL;
		pNumTypeText = NULL;
		break;

	case tpLength:
		if( !pLength )
			return;
		nPos--;
		pLength->Hide();
		pLengthText->Hide();
		delete pLength;
		delete pLengthText;
		pLength = NULL;
		pLengthText = NULL;
		break;

	case tpScale:
		if( !pScale )
			return;
		nPos--;
		pScale->Hide();
		pScaleText->Hide();
		delete pScale;
		delete pScaleText;
		pScale = NULL;
		pScaleText = NULL;
		break;

	case tpFormat:
		if( !pFormat )
			return;
		pFormatText->Hide();
		pFormatSample->Hide();
		pFormat->Hide();
		delete pFormatText;
		delete pFormatSample;
		delete pFormat;
		pFormatText = NULL;
		pFormatSample = NULL;
		pFormat = NULL;
		break;
	case tpBoolDefault:
		if (!pBoolDefault)
			return;
		nPos--;
		pBoolDefault->Hide();
		pBoolDefaultText->Hide();
		delete pBoolDefault;
		delete pBoolDefaultText;
		pBoolDefault = NULL;
		pBoolDefaultText = NULL;
		break;

	}
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::SetPosSize( Control** ppControl, long nRow, sal_uInt16 nCol )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Position ermitteln
	Point aPosition;
	switch( nCol )
	{
	case 0:
		aPosition.X() = 0;
		break;
	case 1:
	case 2:
	case 3:
	case 4:
		aPosition.X() = CONTROL_WIDTH_1 + CONTROL_SPACING_X;
		break;
	default:
		aPosition.X() = 0;
	}

	aPosition.Y() = ((nRow+1)*CONTROL_SPACING_Y) +
					(nRow*CONTROL_HEIGHT);

	//////////////////////////////////////////////////////////////////////
	// Groesse ermitteln
	Size aSize;
	switch( nCol )
	{
	case 0:
		aSize.Width()  = CONTROL_WIDTH_1;
		aSize.Height() = CONTROL_HEIGHT;
		break;
	case 1:
		aSize.Width()  = CONTROL_WIDTH_2;
		aSize.Height() = CONTROL_HEIGHT;
		break;
	case 2:
		aSize.Width()  = CONTROL_WIDTH_2;
		aSize.Height() = 1.5*CONTROL_HEIGHT;
		break;
	case 3:
		aSize.Width()  = CONTROL_WIDTH_3;
		aSize.Height() = CONTROL_HEIGHT;
		break;
	case 4:
		aSize.Width()  = CONTROL_WIDTH_4;
		aSize.Height() = CONTROL_HEIGHT;
		break;
	default:
		aSize.Width()  = CONTROL_WIDTH_1;
		aSize.Height() = CONTROL_HEIGHT;
	}


	//////////////////////////////////////////////////////////////////////
	// Control anzeigen
	(*ppControl)->SetPosSizePixel( aPosition, aSize );
	(*ppControl)->Show();
}
//------------------------------------------------------------------------------
void SbaFieldDescControl::DisplayData(const SbaColumn* pColumn)
{
	if(pActFieldDescr)
		delete pActFieldDescr;

	SFX_ITEMSET_GET(*pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True);
	SFX_ITEMSET_GET(*pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
	SFX_ITEMSET_GET(*pColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, sal_True);
	SFX_ITEMSET_GET(*pColumn, pRequired, SfxBoolItem, SBA_DEF_FLTREQUIRED, sal_True);
	SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
	SFX_ITEMSET_GET(*pColumn, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, sal_True);
	SFX_ITEMSET_GET(*pColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True);
	SFX_ITEMSET_GET(*pColumn, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, sal_True);
	SFX_ITEMSET_GET(*pColumn, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, sal_True);
	SFX_ITEMSET_GET(*pColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, sal_True);
	SFX_ITEMSET_GET(*pColumn, pHorJustify, SvxHorJustifyItem, SBA_ATTR_ALIGN_HOR_JUSTIFY, sal_True);

	SbaFieldType aFieldType = pType->GetType();
	SbaFieldDescr* pFieldDescr;
	switch(aFieldType)
	{
		case dbNone:			// undefiniert: unbekannt
			pFieldDescr = new SbaUnknownFieldDescr(); break;
		case dbText:				// var. Text:
			pFieldDescr = new SbaTextFieldDescr(); break;
		case dbNumeric:			// Zahlen von Byte bis double:
			pFieldDescr = new SbaNumericFieldDescr(); break;
		case dbDateTime:			// Datumzeit:
			pFieldDescr = new SbaDateTimeFieldDescr(); break;
		case dbDate:				// Datum:
			pFieldDescr = new SbaDateFieldDescr(); break;
		case dbTime:				// Zeit:
			pFieldDescr = new SbaTimeFieldDescr(); break;
		case dbBool:				// Logical:
			pFieldDescr = new SbaBoolFieldDescr(); break;
		case dbCurrency:			// Whrung:
			pFieldDescr = new SbaCurrencyFieldDescr(); break;
		case dbMemo:				// Langer Text:
			pFieldDescr = new SbaMemoFieldDescr(); break;
		case dbCounter:			// Zaehler:
			pFieldDescr = new SbaCounterFieldDescr(); break;
		case dbImage:			// Bilder:
			pFieldDescr = new SbaImageFieldDescr(); break;
		case dbChar:				// fixt. Text:
			pFieldDescr = new SbaCharFieldDescr(); break;
		case dbDecimal:			// decimal Werte: mit Vor und Nachkommastellen:
			pFieldDescr = new SbaDecimalFieldDescr(); break;
		case dbBinary:			// Binary Feld bis 255:
			pFieldDescr = new SbaBinaryFieldDescr(); break;
		case dbVarBinary:		// VarBinary Feld bis 255:
			pFieldDescr = new SbaVarBinaryFieldDescr(); break;
		case dbBigInt:			// Big integer:
			pFieldDescr = new SbaBigIntFieldDescr(); break;

	}


	pFieldDescr->SetName(pName->GetValue());
	pFieldDescr->SetFormatKey(pFormat->GetValue());
	pFieldDescr->SetPrimaryKey(pPrimary->GetValue());
	pFieldDescr->SetDescription(pComment->GetValue());
	pFieldDescr->SetAutoIncrement(pAutoIncrement->GetValue());
	pFieldDescr->SetHorJustify((SvxCellHorJustify)pHorJustify->GetValue());

	//////////////////////////////////////////////////////////////////////
	// Spezielle Daten
	if( pFieldDescr->ISA(SbaExtFieldDescr) )
	{
		((SbaExtFieldDescr*)pFieldDescr)->SetRequired(pRequired->GetValue());
		((SbaExtFieldDescr*)pFieldDescr)->SetDefault(pDefault->GetValue());
	}

	switch( pFieldDescr->GetFieldType() )
	{
	case dbText:
		((SbaTextFieldDescr*)pFieldDescr )->SetTextLen( (xub_StrLen)(pLength->GetValue()) );
		break;

	case dbNumeric:
		( (SbaNumericFieldDescr*)pFieldDescr )->SetNumType(GetDataDef()->SizeString((SbaNumericSize)pLength->GetValue()) );
		break;

	case dbChar:
		((SbaCharFieldDescr*)pFieldDescr )->SetTextLen( (xub_StrLen)(pLength->GetValue()) );
		break;

	case dbDecimal:
		{
			SbaDecimalFieldDescr* pDecFieldDescr = (SbaDecimalFieldDescr*)pFieldDescr;
			pDecFieldDescr->SetLength( (xub_StrLen)(pLength->GetValue()) );
			pDecFieldDescr->SetScale( String::CreateFromInt32(pScale->GetValue()) );
		}
		break;
	case dbBinary:
		((SbaBinaryFieldDescr*)pFieldDescr )->SetLength( (xub_StrLen)(pLength->GetValue()) );
		break;

	case dbVarBinary:
		((SbaVarBinaryFieldDescr*)pFieldDescr )->SetLength( (xub_StrLen)(pLength->GetValue()) );
		break;
	}

	DisplayData(pFieldDescr);
}
//------------------------------------------------------------------------------
SvNumberFormatter*	SbaFieldDescControl::GetFormatter()
{
	return GetDataDef()->GetFormatter();
}
//------------------------------------------------------------------------------
void SbaFieldDescControl::DisplayData(SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	pActFieldDescr = pFieldDescr;
	SbaResId aSbaResId(STR_DBFIELDTYPES);
	String aFieldTypes( String( aSbaResId ));
	SbaFieldType aFieldType;
	if( pFieldDescr )
		aFieldType = pFieldDescr->GetFieldType();
	else
		aFieldType = dbNULL;

	ActivateAggregate( tpColumnName );
	ActivateAggregate( tpType );

	//////////////////////////////////////////////////////////////////////
	// Wenn sich der Typ geaendert hat, Controls austauschen
	SdbTypeInfo *pInfo = NULL;
	if( aPreviousType != aFieldType )
	{
		if (aFieldType != dbNULL && aFieldType != dbNone)
			pInfo = GetDataDef()->GetDatabase()->IsTypeAvailable(aFieldType,3);
		DBG_ASSERT(!(!pInfo && aFieldType != dbNULL && aFieldType != dbNone)," SbaFieldDescControl::DisplayData pInfo darf nicht NULL sein ;-(");
		if(!pInfo && aFieldType != dbNULL && aFieldType != dbNone)
			return;
		//////////////////////////////////////////////////////////////////////
		// Zeiger des gespeicherten Focus zuruecksetzen
		pLastFocusWindow = NULL;

		//////////////////////////////////////////////////////////////////////
		// Controls, die nicht mehr angezeigt werden duerfen

		//////////////////////////////////////////////////////////////////////
		// Loeschen bei keinem, unbekanntem oder Image-Feldtyp
		switch( aFieldType )
		{
			case dbImage:
				DeactivateAggregate( tpFormat );
				DeactivateAggregate( tpDefault );
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpBoolDefault );

				if(pInfo->bNullable)
					ActivateAggregate( tpRequired );
				else
					DeactivateAggregate( tpRequired );
				break;
			case dbNULL:
			case dbNone:
			//case dbImage:
				DeactivateAggregate( tpFormat );
				DeactivateAggregate( tpDefault );
				DeactivateAggregate( tpRequired );
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpBoolDefault );
				break;
			case dbCounter:
				DeactivateAggregate( tpFormat );
				DeactivateAggregate( tpDefault );
				DeactivateAggregate( tpRequired );
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpBoolDefault );

				ActivateAggregate( tpAutoIncrement );
				break;

			case dbText:
			case dbChar:
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpBoolDefault );

				//	ActivateAggregate( tpDefault );
				ActivateAggregate( tpTextLen );
				ActivateAggregate( tpFormat );

				if(pInfo && pInfo->bAutoIncrement)
				{
					DeactivateAggregate( tpRequired );
					DeactivateAggregate( tpDefault );
					ActivateAggregate( tpAutoIncrement );
				}
				else
				{
					DeactivateAggregate( tpAutoIncrement );
					if(pInfo->bNullable)
						ActivateAggregate( tpRequired );
					else
						DeactivateAggregate( tpRequired );
					ActivateAggregate( tpDefault );
				}

				if (pInfo->nPrecision)
					pTextLen->SetMax(pInfo->nPrecision);
				break;

			case dbNumeric:
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpBoolDefault );

				ActivateAggregate( tpNumType );
				ActivateAggregate( tpFormat );
				if(pInfo && pInfo->bAutoIncrement)
				{
					DeactivateAggregate( tpRequired );
					DeactivateAggregate( tpDefault );
					ActivateAggregate( tpAutoIncrement );
				}
				else
				{
					DeactivateAggregate( tpAutoIncrement );
					if(pInfo->bNullable)
						ActivateAggregate( tpRequired );
					else
						DeactivateAggregate( tpRequired );
					ActivateAggregate( tpDefault );
				}
				break;

			case dbDateTime:
			case dbDate:
			case dbTime:
			case dbCurrency:
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpBoolDefault );

				ActivateAggregate( tpDefault );
				ActivateAggregate( tpFormat );

				if(pInfo->bNullable)
					ActivateAggregate( tpRequired );
				else
					DeactivateAggregate( tpRequired );
				break;

			case dbBool:
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpFormat );
				DeactivateAggregate( tpDefault );

				ActivateAggregate( tpBoolDefault );

				if(pInfo->bNullable)
					ActivateAggregate( tpRequired );
				else
					DeactivateAggregate( tpRequired );
				break;
			case dbMemo:
				DeactivateAggregate( tpFormat );
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpLength );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpBoolDefault );

				ActivateAggregate( tpDefault );
				if(pInfo->bNullable)
					ActivateAggregate( tpRequired );
				else
					DeactivateAggregate( tpRequired );
				break;

			case dbDecimal:
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );

				ActivateAggregate( tpLength );
				ActivateAggregate( tpScale );
				ActivateAggregate( tpFormat );
				DeactivateAggregate( tpBoolDefault );

				if(pInfo && pInfo->bAutoIncrement)
				{
					DeactivateAggregate( tpRequired );
					DeactivateAggregate( tpDefault );
					ActivateAggregate( tpAutoIncrement );
				}
				else
				{
					DeactivateAggregate( tpAutoIncrement );
					if(pInfo->bNullable)
						ActivateAggregate( tpRequired );
					else
						DeactivateAggregate( tpRequired );
					ActivateAggregate( tpDefault );
				}

				if (pInfo->nPrecision)
					pLength->SetMax(pInfo->nPrecision);
				if (pInfo->nScale)
					pScale->SetMax(pInfo->nScale);
				break;

			case dbBinary:
			case dbVarBinary:
				DeactivateAggregate( tpDefault );
				DeactivateAggregate( tpRequired );
				DeactivateAggregate( tpTextLen );
				DeactivateAggregate( tpNumType );
				DeactivateAggregate( tpScale );
				DeactivateAggregate( tpAutoIncrement );
				DeactivateAggregate( tpBoolDefault );

				ActivateAggregate( tpLength );
				ActivateAggregate( tpFormat );

				if (pInfo->nPrecision)
					pLength->SetMax(pInfo->nPrecision);
				break;
		}
		aPreviousType = aFieldType;
	}
	if(pFieldDescr &&
		!(aFieldType == dbBinary || aFieldType == dbVarBinary || aFieldType == dbCounter ||
		  aFieldType == dbNULL || aFieldType == dbNone))
	{
		if(pFieldDescr->IsPrimaryKey())
		{
			DeactivateAggregate( tpRequired );
		}
		else if(!pAutoIncrement)
		{
			if(!pInfo)
				pInfo = GetDataDef()->GetDatabase()->IsTypeAvailable(aFieldType,3);
			if(pInfo)
			{
				if(pInfo->bNullable)
					ActivateAggregate( tpRequired );
				else
					DeactivateAggregate( tpRequired );
			}
		}
	}
	//////////////////////////////////////////////////////////////////////
	// Controls initialisieren
	if( pAutoIncrement )
	{
		if(pFieldDescr->IsAutoIncrement())
		{
			pAutoIncrement->SelectEntryPos( 0 ); // yes
			DeactivateAggregate( tpRequired );
			DeactivateAggregate( tpDefault );
		}
		else
		{
			// hat Auswirkungen auf pRequired
			pAutoIncrement->SelectEntryPos( 1 );		// no
			ActivateAggregate( tpDefault );
			if(!pFieldDescr->IsPrimaryKey())
				ActivateAggregate( tpRequired );
		}
	}

	if( pDefault )
	{
		if( pFieldDescr->ISA(SbaExtFieldDescr) )
			pDefault->SetText( ((SbaExtFieldDescr*)pFieldDescr)->GetDefault() );
		pDefault->ClearModifyFlag();

	}

	if( pBoolDefault )
	{
		if (pFieldDescr->ISA(SbaExtFieldDescr))
		{
			// wenn pRequired auf sal_True gesetzt ist, dann darf das sal_Bool Feld nicht den Eintrag <<keiner>> besitzen
			String sDef = BoolStringUI((((SbaExtFieldDescr*)pFieldDescr)->GetDefault()));

			// sicher stellen das <<keiner>> nur vorhanden ist, wenn das Feld NULL sein darf
			if(pInfo && !pInfo->bNullable || ((SbaExtFieldDescr*)pFieldDescr)->IsRequired() )
			{
				((SbaExtFieldDescr*)pFieldDescr)->SetRequired(sal_True); // der Typ sagt das

				pBoolDefault->RemoveEntry(String(SbaResId(STR_VALUE_NONE)));
				if (!sDef.Equals(aYes) && !sDef.Equals(aNo))
					pBoolDefault->SelectEntryPos(1);  // nein als Default
				else
					pBoolDefault->SelectEntry(sDef);

				((SbaExtFieldDescr*)pFieldDescr)->SetDefault(BoolStringPersistent(pBoolDefault->GetSelectEntry()));
			}
			else if(pBoolDefault->GetEntryCount() < 3)
			{
				pBoolDefault->InsertEntry(String(SbaResId(STR_VALUE_NONE)));
				pBoolDefault->SelectEntry(sDef);
			}
			else
				pBoolDefault->SelectEntry(sDef);
		}
	}

	if( pRequired )
	{
		if( pFieldDescr->ISA(SbaExtFieldDescr) )
		{
			if( ((SbaExtFieldDescr*)pFieldDescr)->IsRequired() )
				pRequired->SelectEntryPos( 0 );	// yes
			else
				pRequired->SelectEntryPos( 1 );	// no
		}
	}

	if( pTextLen )
	{
		if( aFieldType == dbText )
			pTextLen->SetText( ((SbaTextFieldDescr*)pFieldDescr)->GetTextLen() );
		else if( aFieldType == dbChar )
			pTextLen->SetText( ((SbaCharFieldDescr*)pFieldDescr)->GetTextLen() );
		pTextLen->ClearModifyFlag();
	}

	if( pNumType )
	{
		if( aFieldType == dbNumeric )
			pNumType->SelectEntry( ((SbaNumericFieldDescr*)pFieldDescr)->GetNumType() );
	}

	if( pLength )
	{
		if( aFieldType == dbDecimal )
			pLength->SetText( ((SbaDecimalFieldDescr*)pFieldDescr)->GetLength() );
		else if( aFieldType == dbBinary )
			pLength->SetText( ((SbaBinaryFieldDescr*)pFieldDescr)->GetLength() );
		else if( aFieldType == dbVarBinary )
			pLength->SetText( ((SbaVarBinaryFieldDescr*)pFieldDescr)->GetLength() );
	}

	if( pScale )
	{
		if( aFieldType == dbDecimal )
			pScale->SetText( ((SbaDecimalFieldDescr*)pFieldDescr)->GetScale() );
	}

	if( pFormat )
		UpdateFormatSample(pFieldDescr);

	if(m_pColumnName)
		m_pColumnName->SetText(pFieldDescr->GetName());

	if(m_pType)
		m_pType->SelectEntry(pFieldDescr->GetType());


	//////////////////////////////////////////////////////////////////////
	// Controls Enablen/Disablen
	sal_Bool bRead(IsReadOnly());


	ArrangeAggregates();
	CheckScrollBars();
	ScrollAllAggregates();

	SetReadOnly( bRead );
}

//------------------------------------------------------------------------------
short SbaFieldDescControl::GetFormatCategory(SbaFieldDescr* pFieldDescr)
{
	// The formatter shell has to be reinitialized if the format key is currently unknown, and this is expensive ...
	// So instead of asking our shell we use the formatter and translate the result.
	// (the shell is the wrong tool for what we are using it for, it has to be replaced somewhere along the way ....)
	switch (GetFormatter()->GetType(pFieldDescr->GetFormatKey()))
	{
		case NUMBERFORMAT_DEFINED	: return CAT_USERDEFINED;
		case NUMBERFORMAT_NUMBER	: return CAT_NUMBER;
		case NUMBERFORMAT_PERCENT	: return CAT_PERCENT;
		case NUMBERFORMAT_CURRENCY	: return CAT_CURRENCY;
		case NUMBERFORMAT_DATETIME	:
		case NUMBERFORMAT_DATE		: return CAT_DATE;
		case NUMBERFORMAT_TIME		: return CAT_TIME;
		case NUMBERFORMAT_SCIENTIFIC: return CAT_SCIENTIFIC;
		case NUMBERFORMAT_FRACTION	: return CAT_FRACTION;
		case NUMBERFORMAT_LOGICAL	: return CAT_BOOLEAN;
		case NUMBERFORMAT_TEXT		: return CAT_TEXT;
	}
	return CAT_ALL;
}

//------------------------------------------------------------------------
IMPL_LINK(SbaFieldDescControl, DelayedGrabFocus, Control**, ppControl)
{
	nDelayedGrabFocusEvent = 0;
	if (*ppControl)
		(*ppControl)->GrabFocus();

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaFieldDescControl, OnControlFocusGot, Control*, pControl )
{
	String strHelpText;
	if ((pControl == pLength) || (pControl == pScale) || (pControl == pTextLen))
	{
		((SbaPropNumericEditCtrl*)pControl)->SaveValue();
		strHelpText = ((SbaPropNumericEditCtrl*)pControl)->GetHelp();
	}
	if ((pControl == pDefault) || (pControl == pFormatSample) || (pControl == m_pColumnName))
	{
		((SbaPropEditCtrl*)pControl)->SaveValue();
		strHelpText = ((SbaPropEditCtrl*)pControl)->GetHelp();
	}
	else if ((pControl == pRequired) || (pControl == pNumType) || (pControl == pAutoIncrement) || (pControl == pBoolDefault) || (pControl == m_pType))
	{
		((SbaPropListBoxCtrl*)pControl)->SaveValue();
		strHelpText = ((SbaPropListBoxCtrl*)pControl)->GetHelp();
	}
	else if (pControl == pFormat)
		strHelpText = String(SbaResId(STR_HELP_FORMAT_BUTTON));

	if (strHelpText.Len() && (pHelp != NULL))
		pHelp->SetHelpText(strHelpText);

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaFieldDescControl, OnControlFocusLost, Control*, pControl )
{
	if ((pControl == pLength) || (pControl == pTextLen) || (pControl == pScale))
	{
		SbaPropNumericEditCtrl* pConverted = (SbaPropNumericEditCtrl*)pControl;
		if (pConverted->IsModified())
			CellModified(-1, pConverted->GetPos());
	}
	if ((pControl == pDefault) || (pControl == pFormatSample) || (pControl == m_pColumnName))
	{
		SbaPropEditCtrl* pConverted = (SbaPropEditCtrl*)pControl;
		if (pConverted->IsModified())
			CellModified(-1, pConverted->GetPos());
	}
	else if ((pControl == pRequired) || (pControl == pNumType) || (pControl == pAutoIncrement) || (pControl == pBoolDefault) || (pControl == m_pType))
	{
		SbaPropListBoxCtrl* pConverted = (SbaPropListBoxCtrl*)pControl;
		if (pConverted->IsModified())
			CellModified(-1, pConverted->GetPos());
	}

	if (pControl == pDefault)
		UpdateFormatSample(pActFieldDescr);

	implFocusLost(pControl);

	return 0L;
}
//------------------------------------------------------------------------------
void SbaFieldDescControl::ActivatePropertyField(sal_uInt16 nVirtualField)
{
	Control** ppToActivate = NULL;
	switch (nVirtualField)
	{
		case FIELD_PROPERTY_REQUIRED	: ppToActivate = (Control**)&pRequired; break;
		case FIELD_PROPERTY_NUMTYPE		: ppToActivate = (Control**)&pNumType; break;
		case FIELD_PROPERTY_AUTOINC		: ppToActivate = (Control**)&pAutoIncrement; break;
		case FIELD_PROPERTY_DEFAULT		: ppToActivate = (Control**)&pDefault; if (!*ppToActivate) ppToActivate = (Control**)&pBoolDefault; break;
												// da es immer nur eines der beiden Controls gibt, ist das hier eindeutig
		case FIELD_PROPERTY_TEXTLEN		: ppToActivate = (Control**)&pTextLen; break;
		case FIELD_PROPERTY_LENGTH		: ppToActivate = (Control**)&pLength; break;
		case FIELD_PROPERTY_SCALE		: ppToActivate = (Control**)&pScale; break;
		case FIELD_PROPERTY_FORMAT		: ppToActivate = (Control**)&pFormatSample; break;
		case FIELD_PRPOERTY_COLUMNNAME	: ppToActivate = (Control**)&m_pColumnName; break;
		case FIELD_PRPOERTY_TYPE		: ppToActivate = (Control**)&m_pType; break;

		default:
			DBG_ERROR("SbaFieldDescControl::ActivatePropertyField : ungueltiger Parameter !");
	}

	if (*ppToActivate)
		nDelayedGrabFocusEvent = Application::PostUserEvent(LINK(this, SbaFieldDescControl, DelayedGrabFocus), ppToActivate);
}
//------------------------------------------------------------------------------
void SbaFieldDescControl::SaveData( SbaColumn* pColumn)
{
}
//------------------------------------------------------------------------------
void SbaFieldDescControl::SaveData( SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	if( !pFieldDescr )
		return;

	SbaFieldType aFieldType = pFieldDescr->GetFieldType();

	//////////////////////////////////////////////////////////////////////
	// Controls auslesen
	if( pFieldDescr->ISA(SbaExtFieldDescr) )
	{
		SbaExtFieldDescr* pExtFieldDescr = (SbaExtFieldDescr*)pFieldDescr;
		String sDefault;
		if (pDefault)
			sDefault = pDefault->GetText();
		else if (pBoolDefault)
		{
			sDefault = BoolStringPersistent(pBoolDefault->GetSelectEntry());
		}
		pExtFieldDescr->SetDefault(sDefault);
		if((pRequired && pRequired->GetSelectEntryPos() == 0) || pExtFieldDescr->IsPrimaryKey() || (pBoolDefault && pBoolDefault->GetEntryCount() == 2))  // yes
		{
			pExtFieldDescr->SetRequired( sal_True );
		}else
			pExtFieldDescr->SetRequired( sal_False );
	}

	if(pAutoIncrement && pAutoIncrement->GetSelectEntryPos() == 0 )
		pFieldDescr->SetAutoIncrement( sal_True );
	else
		pFieldDescr->SetAutoIncrement( sal_False );

	switch( aFieldType )
	{
	case dbText:
		if( pTextLen )
			( (SbaTextFieldDescr*)pFieldDescr )->SetTextLen( String::CreateFromInt32(pTextLen->GetValue()) );
		break;

	case dbNumeric:
		if( pNumType )
			( (SbaNumericFieldDescr*)pFieldDescr )->SetNumType( pNumType->GetSelectEntry() );
		break;

	case dbChar:
		if( pTextLen )
			( (SbaCharFieldDescr*)pFieldDescr )->SetTextLen( String::CreateFromInt32(pTextLen->GetValue()) );
		break;

	case dbDecimal:
		if( pLength )
			( (SbaDecimalFieldDescr*)pFieldDescr )->SetLength( pLength->GetText() );
		if( pScale )
			( (SbaDecimalFieldDescr*)pFieldDescr )->SetScale( pScale->GetText() );
		break;

	case dbBinary:
		if( pLength )
			( (SbaBinaryFieldDescr*)pFieldDescr )->SetLength( pLength->GetText() );
		break;
	case dbVarBinary:
		if( pLength )
			( (SbaVarBinaryFieldDescr*)pFieldDescr )->SetLength( pLength->GetText() );
	}
	if(m_pColumnName)
		pFieldDescr->SetName(m_pColumnName->GetText());
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::UpdateFormatSample(SbaFieldDescr* pFieldDescr)
{
	if(!pFormatSample)
		return;
	DBG_ASSERT(m_pFormatterShell != NULL, "SbaFieldDescControl::UpdateFormatSample : invalid call, prepare for crash ...");

	SbaFieldType aType = pFieldDescr->GetFieldType();
	sal_uInt32 nFormatKey = pFieldDescr->GetFormatKey();

	if ((dbText == aType) || (dbMemo == aType))
	{
		if (!GetFormatter()->IsTextFormat(nFormatKey))
		{
			// Since tables/queries are browsed using the new grid control, a non-text format has no effect on text columns
			// (the content will be displayed as if it isn't formatted).
			// So any non-text format on the column doesn't make any sense.
			// FS - 15.11.99
			nFormatKey = GetFormatter()->GetStandardFormat(NUMBERFORMAT_TEXT, Application::GetAppInternational().GetLanguage());
		}
	}

	String sDefault = pFieldDescr->ISA(SbaExtFieldDescr) ? ((SbaExtFieldDescr*)pFieldDescr)->GetDefault() : String(String());

	short nEntryPos = m_pFormatterShell->GetListPos4Entry(nFormatKey);
	if (nEntryPos == -1)
	{
		InitFormatterShell(nFormatKey);
		nEntryPos = m_pFormatterShell->GetListPos4Entry(nFormatKey);
	}
	if (nEntryPos != -1)
	{
		String strFormatString = m_pFormatterShell->GetFormat4Entry(nEntryPos);

		String strSample;
		Color clrDummy;
		// wenn ich einen Default-Wert habe ...
		if (sDefault.Len())
		{
			// ... formatiere ich den als Sample
			SvNumberFormatter* pFormatter = GetFormatter();
			DBG_ASSERT(pFormatter != NULL, "SbaFieldDescControl::UpdateFormatSample : have no formatter ... this will crash !");
			SbaDbDataConverter aConverter(pFormatter);

			if (pFormatter->IsTextFormat(nFormatKey))
				strSample = sDefault;
			else
			{
				// es ist was numerisches -> zuerst in einen SbxValue umwandeln
				ODbVariantRef xVar = new ODbVariant;

				SbaNumericSize aNumSize = (aType == dbDecimal) || (aType == dbNumeric)
					? ((SbaNumericFieldDescr*)pFieldDescr)->GetNumericSize()
					: dbSizeNone;
				if (aConverter.String2Var(sDefault, aType, nFormatKey, aNumSize, *xVar))
				{	// der Default-String entspricht der aktuellen Formatierung
					try
					{
						double nVal = xVar->toDouble();
						m_pFormatterShell->MakePrevStringFromVal(strFormatString, strSample, clrDummy, nVal);
					}
					catch(...)
					{
					}

				}
				else
					// der Default-String entspricht nicht der aktuellen Formatierung -> die Shell ein Beispiel besorgen lassen
					m_pFormatterShell->MakePreviewString(strFormatString, strSample, clrDummy);
			}
		}
		else
			// ... ansonsten lasse ich mir einen Wert von der FormatShell geben
			m_pFormatterShell->MakePreviewString(strFormatString, strSample, clrDummy);
		pFormatSample->SetText(strSample);
	}
	else
		pFormatSample->SetText(String());
}

//------------------------------------------------------------------------------
sal_Bool SbaFieldDescControl::ChildHasFocus()
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Hat eines der Childs den Focus?
	Window* pChild;
	for( sal_uInt16 nChildId=0; nChildId<GetChildCount(); nChildId++ )
	{
		pChild = GetChild( nChildId );
		if( pChild->HasFocus() )
			return sal_True;
	}

	return sal_False;
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::GetFocus()
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Setzt den Focus auf das zuletzt aktive Control
	TabPage::GetFocus();
	if( pLastFocusWindow )
	{
		pLastFocusWindow->GrabFocus();
		pLastFocusWindow = NULL;
	}
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::implFocusLost(Window* _pWhich)
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);
	DBG_ASSERT(!_pWhich || IsChild(_pWhich), "SbaFieldDescControl::implFocusLost : invalid window !");

	//////////////////////////////////////////////////////////////////////
	// Das aktive Control merken
	if (!pLastFocusWindow)
		pLastFocusWindow = _pWhich;

	//////////////////////////////////////////////////////////////////////
	// HelpText zuruecksetzen
	if (pHelp && !pHelp->HasChildPathFocus())
		pHelp->SetHelpText( String() );
}

//------------------------------------------------------------------------------
void SbaFieldDescControl::LoseFocus()
{
	DBG_CHKTHIS(SbaFieldDescControl,NULL);

	implFocusLost(NULL);

	TabPage::LoseFocus();
}
