/*************************************************************************
 *
 *  $RCSfile: rtfcpydg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//#include "sbatabed.hxx"

#ifndef _SBA_RTFCPYDG_HXX
#include "rtfcpydg.hxx"
#endif
#ifndef _SBA_RTFCPYDG_HRC
#include "rtfcpydg.hrc"
#endif
#ifndef _SBA_SBARTF_HXX
#include "sbartf.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif

#ifndef _SBA_DBEXCH_HXX
#include "dbexch.hxx"
#endif // _SBA_DBEXCH_HXX

#ifndef _SBAITEMS_HXX //autogen
#include <sbaitems.hxx>
#endif

#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SBA_DBQRYOBJ_HXX
#include "dbqryobj.hxx"
#endif

#ifndef _SBA_DLGFLDMT_HXX
#include "dlgfldmt.hxx"
#endif
#ifndef _SV_SCRBAR_HXX
#include <vcl/scrbar.hxx>
#endif // _SV_SCRBAR_HXX

class SbaColumnString;

#define IS_CASE_SENSITIVE(pDB) pDB->GetIdentifierCase() == SDB_IC_ALL

// fuer die Controls auf der SbaFieldDescGenPage
#define CONTROL_SPACING_X	18	// 6
#define	CONTROL_SPACING_Y	5
#define CONTROL_HEIGHT		20
#define CONTROL_WIDTH_1		140	// 100
#define CONTROL_WIDTH_2		100 // 60
#define CONTROL_WIDTH_3		250
#define CONTROL_WIDTH_4		(CONTROL_WIDTH_3 - CONTROL_HEIGHT - 5)


#define MAX_PAGES	4	// max. Pages die angezeigt werden
DBG_NAME(CopyTableWizard);

// -----------------------------------------------------------------------
String SbaWizColumnSelect::GetTitle() const { return String(SbaResId(SBA_STR_WIZ_COLUMN_SELECT_TITEL)); }

// -----------------------------------------------------------------------
String SbaWizTypeSelect::GetTitle() const { return String(SbaResId(SBA_STR_WIZ_TYPE_SELECT_TITEL)); }

//------------------------------------------------------------------------
CopyTableWizard::CopyTableWizard( Window * pParent,const SbaDBDataDefRef& xSourceDef, SbaDatabase *pPasteDatabase)
	: WizardDialog( pParent, SbaResId(WIZ_RTFCOPYTABLE))
	,m_pbFinish( this , SbaResId(PB_OK))
	,m_pbCancel( this , SbaResId(PB_CANCEL))
	,m_pbNext( this , SbaResId(PB_NEXT))
	,m_pbPrev( this , SbaResId(PB_PREV))
	,m_nPageCount(0)
	,m_xSourceDef(xSourceDef)
	,m_xTableDef(NULL)
	,m_xDatabase(pPasteDatabase)
	,m_bPrimaryColumn(sal_False)
	,m_eCreateStyle(WIZARD_DEF_DATA)
{
	DBG_CTOR(CopyTableWizard,NULL);

	AddButton( &m_pbPrev );
	AddButton( &m_pbNext, WIZARDDIALOG_BUTTON_STDOFFSET_X );

	AddButton( &m_pbCancel, WIZARDDIALOG_BUTTON_STDOFFSET_X );
	AddButton( &m_pbFinish );

	m_pbPrev.SetClickHdl( LINK( this, CopyTableWizard, ImplPrevHdl ) );
	m_pbNext.SetClickHdl( LINK( this, CopyTableWizard, ImplNextHdl ) );
	m_pbFinish.SetClickHdl( LINK( this, CopyTableWizard, ImplOKHdl ) );

	SetActivatePageHdl( LINK( this, CopyTableWizard, ImplActivateHdl ) );

	SetPrevButton( &m_pbPrev );
	SetNextButton( &m_pbNext );

	ShowButtonFixedLine( sal_True );

	m_pbNext.GrabFocus();

	if (xSourceDef.Is() && xSourceDef->IsNew())
		// source is a html or rtf table
		m_pbNext.SetStyle(m_pbFinish.GetStyle() | WB_DEFBUTTON);
	else
		m_pbFinish.SetStyle(m_pbFinish.GetStyle() | WB_DEFBUTTON);

	//////////////////////////////////////////////////////////////////////////
	// Tabellennamen anpassen
	String aSchema,aCatalog;
	// Tabellennamen extrahieren
	if(m_xSourceDef.Is())
		if(m_xSourceDef->GetKind() != dbQuery)
			m_xSourceDef->GetDatabase()->QualifiedNameComponents(m_xSourceDef->Name(),aCatalog,aSchema,m_aTableName);
		else
			m_aTableName = m_xSourceDef->Name();
	else if(m_xTableDef.Is())
		m_xDatabase->QualifiedNameComponents(m_xTableDef->Name(),aCatalog,aSchema,m_aTableName);

	m_aTableName = m_xDatabase->CheckTableName(m_aTableName ,m_xSourceDef.Is() ? m_xSourceDef->GetDatabase() : (SbaDatabase*)m_xDatabase);

	FreeResource();
}
//------------------------------------------------------------------------
CopyTableWizard::~CopyTableWizard()
{
	TabPage *pPage=0;
	while(pPage = GetPage(0))
	{
		RemovePage( pPage );
		delete pPage;
	}
	DBG_DTOR(CopyTableWizard,NULL);
}
// -----------------------------------------------------------------------
IMPL_LINK( CopyTableWizard, ImplPrevHdl, PushButton*, EMPTYARG )
{
	m_ePressed = WIZARD_PREV;
	if ( GetCurLevel() )
	{
		if(m_eCreateStyle != WIZARD_APPEND_DATA)
		{
			if(GetCurLevel() == 2)
				ShowPage(GetCurLevel()-2);
			else
				ShowPrevPage();
		}
		else
			ShowPrevPage();
	}
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( CopyTableWizard, ImplNextHdl, PushButton*, EMPTYARG )
{
	m_ePressed = WIZARD_NEXT;
	if ( GetCurLevel() < MAX_PAGES )
	{
		if(m_eCreateStyle != WIZARD_APPEND_DATA)
		{
			if(GetCurLevel() == 0)
				ShowPage(GetCurLevel()+2);
			else
				ShowNextPage();
		}
		else
			ShowNextPage();
	}
	return 0;
}
// -----------------------------------------------------------------------
void CopyTableWizard::CheckColumns()
{
	m_vColumnPos.clear();
	m_vColumnTypes.clear();

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(m_xDatabase->GetMetaData());
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	sal_Bool bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE;

	const SbaColumnList& rList = m_xSourceDef->GetColumns();
	if(m_lColumnList.Count())
	{
		for(sal_uInt32 i=0;i<rList.Count();++i)
		{
			SbaColumn *pSrcColumn = rList.GetObject(i);
			SFX_ITEMSET_GET( *pSrcColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
			SbaColumn *pDestColumn = m_lColumnList.Lookup(m_mNameMapping[pName->GetValue()],String());

			if(pDestColumn)
			{
				sal_uInt32 nPos = m_lColumnList.GetPos(pDestColumn);
				m_vColumnPos.push_back(nPos+1);

				SFX_ITEMSET_GET(*pDestColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
				if(!bPKeyAllowed)
					pDestColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
				m_vColumnTypes.push_back((SbaFieldType)pType->GetValue());
			}
			else
			{
				m_vColumnPos.push_back(CONTAINER_ENTRY_NOTFOUND);
				m_vColumnTypes.push_back(dbNone);
			}
		}
	}
	else
	{
		DlgFieldMatch	dlgMissingFields(GetpApp()->GetDefDialogParent());
		ListBox*		pInfoBox = dlgMissingFields.GetInfoBox();
		String aColumnName,aOldColName;
		sal_Int32 nLen = xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN);
		for(sal_uInt32 i=0;i<rList.Count();++i)
		{
			SbaColumn *pSrcColumn = rList.GetObject(i);
			SFX_ITEMSET_GET( *pSrcColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
			if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))	
			{
				SFX_ITEMSET_GET( *pSrcColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
				aColumnName = pName->GetValue();
				aOldColName = aColumnName;

				if(!bPKeyAllowed)
					pSrcColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
				if(nLen && nLen < aColumnName.Len())
				{
					String aNewName( aColumnName.Copy( 0, (xub_StrLen)nLen ));
					String aBaseName( aColumnName.Copy( 0, (xub_StrLen)nLen-2 ));
					sal_uInt16 k=1;
					while( m_lColumnList.Lookup(aNewName,String()) != NULL && (k<100) )
					{
						aNewName = aBaseName;
						aNewName += String(k);
						k++;
					}
					m_mNameMapping[aOldColName] = aNewName;
					aColumnName = aNewName;
				}
				else
					m_mNameMapping[aOldColName] = aColumnName;

				SbaColumn* pSbaColumn = m_xTableDef->CreateColumn(*pSrcColumn,sal_True);
				if(pSbaColumn && m_xTableDef->AdjustType(pSrcColumn,pSbaColumn))
				{
					pSrcColumn = pSbaColumn;
					pSrcColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, aColumnName,IS_CASE_SENSITIVE(m_xDatabase)));
					m_lColumnList.InsertAt(aColumnName,pSrcColumn);
					m_vColumnPos.push_back(m_lColumnList.Count());
					SFX_ITEMSET_GET(*pSrcColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
					m_vColumnTypes.push_back((SbaFieldType)pType->GetValue());
				}
				else
				{
					m_vColumnPos.push_back(CONTAINER_ENTRY_NOTFOUND);
					m_vColumnTypes.push_back(dbNone);
					pInfoBox->InsertEntry( aOldColName );
				}
			}
			else
			{
				m_vColumnPos.push_back(CONTAINER_ENTRY_NOTFOUND);
				m_vColumnTypes.push_back(dbNone);
			}
		}

		if(pInfoBox->GetEntryCount())
			dlgMissingFields.Execute();
	}
}
// -----------------------------------------------------------------------
IMPL_LINK( CopyTableWizard, ImplOKHdl, OKButton*, EMPTYARG )
{
	m_ePressed = WIZARD_FINISH;
	sal_Bool bFinish = DeactivatePage();

	if(!bFinish)
		return sal_False;

	sal_Bool bWasEmpty = !m_lColumnList.Count();
	if(m_eCreateStyle != WIZARD_DEF_VIEW && m_eCreateStyle != WIZARD_APPEND_DATA )
		CheckColumns();

	switch(m_eCreateStyle)
	{
		case WIZARD_APPEND_DATA:
		{
			if(m_xTableDef->IsNew())
				m_xTableDef->Update();
			break;
		}
		case WIZARD_DEF_DATA:
		case WIZARD_DEF:
		{
			sal_Bool bPKey = sal_False;
			String aNameList;
			for(sal_uInt32 i=0;i < m_lColumnList.Count();++i)
			{
				SbaColumn* pColumn = m_lColumnList.GetObject(i);
				SFX_ITEMSET_GET( *pColumn, pPrimary	, SfxBoolItem, SBA_DEF_FLTPRIMARY	, sal_True);
				SFX_ITEMSET_GET( *pColumn, pName	, SbaNameItem, SBA_DEF_FLTNAME		, sal_True);
				bPKey = pPrimary->GetValue();
				if(bPKey)
					aNameList.AppendAscii(", ") += pName->GetValue();
			}

			aNameList.Erase(0,2);
			if(aNameList.Len() && m_bPrimaryColumn)
			{
				String aErr = String(SbaResId(SBA_STR_WIZ_PKEY_ALREADY_DEFINED));
				aErr += aNameList;
				SbaMsgBox(this,String(SbaResId(SBA_STAT_WARNING)),aErr).Execute();
				return sal_False;
			}
			else if(m_bPrimaryColumn)
			{
				String aPKname = m_lColumnList.ShortenFieldName(m_aKeyName,m_aKeyName.Len()+2);
				SdbTypeInfo *pInfo=NULL;
				if(pInfo = m_xTableDef->GetDatabase()->IsTypeAvailable(dbNumeric,3))
				{
					SbaColumnList aTmpList;
					SbaColumn* pNewColumn = m_xTableDef->CreateColumn(aPKname,dbNumeric,dbLong,0,sal_True,0,1);
					pNewColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_True));
					//pNewColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT,pInfo->bAutoIncrement));
					aTmpList.InsertAt(aPKname,pNewColumn);

					for(sal_uInt32 i=0;i < m_lColumnList.Count();++i)
					{
						SbaColumn* pColumn = m_lColumnList.GetObject(i);
						// move position one to right
						pColumn->Put(SfxUInt16Item(SBA_DEF_FLTPOS, i+2));
						SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
						aTmpList.InsertAt(pName->GetValue(),pColumn);
					}

					m_lColumnList = aTmpList;
				}
				else
				{
					DBG_ERROR("I found a database that doesn't support numbers");
				}
			}
			else
				m_bPrimaryColumn = sal_False; // I don't need a Pkey if I already have one

			if(&m_xTableDef != &m_xSourceDef)
			{
				// only when source and are not the same
				m_xTableDef->PutObjAttrs(*m_xSourceDef->GetObjAttrs()); // to copy all information

				if( !m_xTableDef->CopyStructure( m_lColumnList, m_xSourceDef->GetDatabase(),&m_vColumnPos) )
				{
/*
					if(!bPKey && m_bPrimaryColumn)
					{
						m_lColumnList.RemoveAt(0);
						for(sal_uInt32 i=0;i < m_lColumnList.Count();++i)
						{
							SbaColumn* pColumn = m_lColumnList.GetObject(i);
							pColumn->Put(SfxUInt16Item(SBA_DEF_FLTPOS, i+1));
						}
						m_bPrimaryColumn = sal_False; // I have no more a PKey
						m_xTableDef->GetColumns().Clear();
						if( !m_xTableDef->CopyStructure( m_lColumnList, m_xSourceDef->GetDatabase()) )
						{
							OnError();
							bFinish = sal_False;
						}
					}
					else
					{
*/
						OnError();
						bFinish = sal_False;
//					}
				}
				if( bFinish && m_xSourceDef->GetKind() == dbTable )
					m_xTableDef->CopyIndexes( (SbaTableDef*)&m_xSourceDef );
			}
			else // hear source and dest are the same and new, so I need a update
			{
				m_xTableDef->GetColumns() = m_lColumnList;
				if(!m_xTableDef->Update())
				{
/*
					if(!bPKey && m_bPrimaryColumn)
					{
						OnError();
						m_lColumnList.RemoveAt(0);
						for(sal_uInt32 i=0;i < m_lColumnList.Count();++i)
						{
							SbaColumn* pColumn = m_lColumnList.GetObject(i);
							pColumn->Put(SfxUInt16Item(SBA_DEF_FLTPOS, i+1));
						}
						m_bPrimaryColumn = sal_False; // I have no more a PKey
						m_xTableDef->GetColumns() = m_lColumnList;
						if( !m_xTableDef->Update())
						{
							OnError();
							bFinish = sal_False;
						}
					}
					else
					{
*/						OnError();
						bFinish = sal_False;
//					}
				}
			}
			if(bWasEmpty)
				m_lColumnList.Clear();
			if(m_bPrimaryColumn && bFinish)
			{
				for(vector<sal_uInt32>::iterator aIter=m_vColumnPos.begin();aIter != m_vColumnPos.end();++aIter)
				{
					if(*aIter != CONTAINER_ENTRY_NOTFOUND)
						(*aIter)++;
				}
				m_vColumnPos.insert(m_vColumnPos.begin(),CONTAINER_ENTRY_NOTFOUND);
			}
			break;
		}
		default:
		{
			m_xTableDef = (SbaTableDef*)m_xDatabase->CreateDBDef( dbView, m_aTableName, sal_True );
			if(!m_xTableDef.Is())
			{
				SdbStatus aTmp;
				if (!m_xDatabase->Status().IsSuccessful())
					ShowCreationError(m_xDatabase->Status(), aTmp);
				bFinish = sal_False;
			}
			else
			{
				const String &aSQL = ((SbaQueryDef*)&m_xSourceDef)->Statement();
				if(!m_xTableDef->Update(aSQL,((SbaQueryDef*)&m_xSourceDef)->IsNative()))
				{
					if (!(m_xSourceDef->Status().IsSuccessful() && m_xTableDef->Status().IsSuccessful()))
						ShowCreationError(m_xSourceDef->Status(), m_xTableDef->Status());
					bFinish = sal_False;
				}
			}
		}
	}

	if(bFinish)
		EndDialog(sal_True);
	return bFinish;
}
//------------------------------------------------------------------------
void CopyTableWizard::OnError()
{
	if(m_xTableDef.Is())
	{
		if (!(m_xSourceDef->Status().IsSuccessful() && m_xTableDef->Status().IsSuccessful()))
			ShowCreationError(m_xSourceDef->Status(), m_xTableDef->Status());
			// wenn beide Stati 'successful' sagen, dann lag der Fehler irgendwo ueberhalb der Defs, dann muss
			// CopyStructure das gehandelt haben
	}
	else
	{
		SdbStatus aTmp;
		if(m_xSourceDef.Is())
			ShowCreationError(m_xSourceDef->Status(), aTmp);
		else
			ShowCreationError(aTmp, aTmp);
	}
}
//------------------------------------------------------------------------
sal_Bool CopyTableWizard::SetAutoincrement() const
{
	return m_bPrimaryColumn;
}
//------------------------------------------------------------------------
void CopyTableWizard::ShowCreationError(const SdbStatus& rSourceError, const SdbStatus& rDestError) const
{
	SdbStatus aRealError(rSourceError);
	DBErrorContext aCtx = dbReadError;
	sal_Bool bSourceError = sal_True;
	if (rSourceError.IsSuccessful())
	{
		aRealError = rDestError;
		aCtx = dbWriteError;
	}

	if (aRealError.IsSuccessful())
	{
		DBG_ERROR("SbaExplorerExchObj::ShowCreationError : es ist was schief gegangen, aber keiner will's gewesen sein");
		aRealError.Set(SDB_STAT_ERROR);
		aCtx = dbWriteError;
			// das ist jetzt ziemlich willkuerlich ...
	}

	SBA_MOD()->ShowDbStatus(aRealError, aCtx);
}
// -----------------------------------------------------------------------

IMPL_LINK( CopyTableWizard, ImplActivateHdl, WizardDialog*, EMPTYARG )
{
	SbaWizardPage* pCurrent = (SbaWizardPage*)GetPage(GetCurLevel());
	if(!pCurrent)
		return 0;
	sal_Bool bFirstTime = pCurrent->IsFirstTime();
	if(bFirstTime)
		pCurrent->Reset();

	CheckButtons();

	SetText(pCurrent->GetTitle());

	Invalidate();
	return 0;
}
// -----------------------------------------------------------------------
void CopyTableWizard::CheckButtons()
{
	if(GetCurLevel() == 0) // erste Seite hat kein PrevButton
	{
		if(m_nPageCount > 1)
			m_pbNext.Enable(sal_True);
		else
			m_pbNext.Enable(sal_False);

		m_pbPrev.Enable(sal_False);
	}
	else if(GetCurLevel() == m_nPageCount-1) // letzte Seite hat keinen Next Button
	{
		m_pbNext.Enable(sal_False);
		m_pbPrev.Enable(sal_True);
	}
	else
	{
		m_pbPrev.Enable(sal_True);
		// next has already his state
	}
}
// -----------------------------------------------------------------------
void CopyTableWizard::EnableButton(Wizard_Button_Style eStyle,sal_Bool bEnable)
{
//	CheckButtons();
	Button* pButton;
	if(eStyle == WIZARD_NEXT)
		pButton = &m_pbNext;
	else if(eStyle == WIZARD_PREV)
		pButton = &m_pbPrev;
	else
		pButton = &m_pbFinish;
	pButton->Enable(bEnable);

}
// -----------------------------------------------------------------------
long CopyTableWizard::DeactivatePage()
{
	SbaWizardPage* pPage = (SbaWizardPage*)GetPage(GetCurLevel());
	return pPage ? pPage->LeavePage() : sal_False;
}
// -----------------------------------------------------------------------
void CopyTableWizard::AddWizardPage(SbaWizardPage* pPage)
{
	AddPage(pPage);
	++m_nPageCount;
}
// -----------------------------------------------------------------------
void CopyTableWizard::RemoveWizardPage(SbaWizardPage* pPage)
{
	RemovePage(pPage);
	--m_nPageCount;
}
// -----------------------------------------------------------------------
//========================================================================
// SbaWizColumnSelect
DBG_NAME(SbaWizColumnSelect);
//========================================================================
SbaWizColumnSelect::SbaWizColumnSelect( Window* pParent)
			   :SbaWizardPage( pParent, SbaResId( TAB_WIZ_COLUMN_SELECT )),
			   m_gpColumns( this, SbaResId( GB_COLUMN_SELECT ) ),
			   m_lbOrgColumnNames( this, SbaResId( LB_ORG_COLUMN_NAMES ) ),
			   m_pbColumn_RH( this, SbaResId( PB_COLUMN_RH ) ),
			   m_pbColumn_LH( this, SbaResId( PB_COLUMN_LH ) ),
			   m_pbColumns_RH( this, SbaResId( PB_COLUMNS_RH ) ),
			   m_pbColumns_LH( this, SbaResId( PB_COLUMNS_LH ) ),
			   m_lbNewColumnNames( this, SbaResId( LB_NEW_COLUMN_NAMES ) )
{
	DBG_CTOR(SbaWizColumnSelect,NULL);
	m_pbColumn_RH.SetClickHdl(LINK(this,SbaWizColumnSelect,ButtonClickHdl));
	m_pbColumn_LH.SetClickHdl(LINK(this,SbaWizColumnSelect,ButtonClickHdl));
	m_pbColumns_RH.SetClickHdl(LINK(this,SbaWizColumnSelect,ButtonClickHdl));
	m_pbColumns_LH.SetClickHdl(LINK(this,SbaWizColumnSelect,ButtonClickHdl));

	m_lbOrgColumnNames.EnableMultiSelection(sal_True);
	m_lbNewColumnNames.EnableMultiSelection(sal_True);

	m_lbOrgColumnNames.SetDoubleClickHdl(LINK(this,SbaWizColumnSelect,ListDoubleClickHdl));
	m_lbNewColumnNames.SetDoubleClickHdl(LINK(this,SbaWizColumnSelect,ListDoubleClickHdl));
	FreeResource();
}
// -----------------------------------------------------------------------
SbaWizColumnSelect::~SbaWizColumnSelect()
{
	DBG_DTOR(SbaWizColumnSelect,NULL);
}

// -----------------------------------------------------------------------
void SbaWizColumnSelect::Reset()
{
	// urspr"unglichen zustand wiederherstellen
	DBG_CHKTHIS(SbaWizColumnSelect,NULL);

	while(m_lbOrgColumnNames.GetEntryCount())
		m_lbOrgColumnNames.RemoveEntry(0);
	m_lbOrgColumnNames.Clear();

	while(m_lbNewColumnNames.GetEntryCount())
		m_lbNewColumnNames.RemoveEntry(0);
	m_lbNewColumnNames.Clear();

	//const SbaColumnList& rList = m_xTableDef->GetColumns();
	const SbaColumnList& rList = m_pParent->GetOriginalColumns();
	for(sal_uInt16 i=0,j=0;i< rList.Count();++i)
	{
		SbaColumn *pColumn = rList.GetObject(i);
		SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
		if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
		{
			SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
			m_lbOrgColumnNames.InsertEntry(pName->GetValue());
			m_lbOrgColumnNames.SetEntryData(j++,pColumn);
		}
	}
	m_pParent->m_lColumnList.Clear();

	if(m_lbOrgColumnNames.GetEntryCount())
		m_lbOrgColumnNames.SelectEntryPos(0);

	m_bFirstTime = sal_False;
}
// -----------------------------------------------------------------------
void SbaWizColumnSelect::ActivatePage( )
{
	DBG_CHKTHIS(SbaWizColumnSelect,NULL);
	if(m_pParent->m_lColumnList.Count() == 0)
		Reset();

	m_aColumnList = m_pParent->m_lColumnList;

	while(m_lbNewColumnNames.GetEntryCount())
		m_lbNewColumnNames.RemoveEntry(0);
	m_lbNewColumnNames.Clear();

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(m_pParent->m_xDatabase->GetMetaData());
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	sal_Bool bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE;

	for(sal_uInt32 j=0;j< m_aColumnList.Count();++j)
	{
		SbaColumn *pColumn = m_aColumnList.GetObject(j);
		SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
		if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
		{
			SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
			if(!bPKeyAllowed)
				pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
			m_lbNewColumnNames.InsertEntry(pName->GetValue());
			m_lbNewColumnNames.SetEntryData(j,pColumn);
			m_lbOrgColumnNames.RemoveEntry(pName->GetValue());
		}
	}
	m_pParent->GetOKButton().Enable(m_lbNewColumnNames.GetEntryCount());
	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,m_lbNewColumnNames.GetEntryCount() && m_pParent->m_eCreateStyle != CopyTableWizard::WIZARD_APPEND_DATA);
	m_pbColumns_RH.GrabFocus();
}
// -----------------------------------------------------------------------
sal_Bool SbaWizColumnSelect::LeavePage()
{
	DBG_CHKTHIS(SbaWizColumnSelect,NULL);

	for(sal_uInt32 j=m_pParent->m_lColumnList.Count();j;--j)
		m_pParent->m_lColumnList.RemoveAt(j-1);
	m_pParent->m_lColumnList.Clear();

	for(sal_uInt16 i=0 ; i< m_lbNewColumnNames.GetEntryCount();++i)
	{
		SbaColumn* pColumn = (SbaColumn*)m_lbNewColumnNames.GetEntryData(i);
		pColumn->Put(SfxUInt16Item(SBA_DEF_FLTPOS, i+1));
		m_pParent->m_lColumnList.InsertAt(m_lbNewColumnNames.GetEntry(i),pColumn);
	}

	if(m_pParent->WasButtonPressed() == CopyTableWizard::WIZARD_NEXT || m_pParent->WasButtonPressed() == CopyTableWizard::WIZARD_FINISH)
		return m_pParent->m_lColumnList.Count();
	else
		return sal_True;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaWizColumnSelect, ButtonClickHdl, Button *, pButton )
{
	MultiListBox *pLeft,*pRight;
	sal_Bool bAll = sal_False;
	if(pButton == &m_pbColumn_RH)
	{
		pLeft  = &m_lbOrgColumnNames;
		pRight = &m_lbNewColumnNames;
	}
	else if(pButton == &m_pbColumn_LH)
	{
		pLeft  = &m_lbNewColumnNames;
		pRight = &m_lbOrgColumnNames;
	}
	else if(pButton == &m_pbColumns_RH)
	{
		pLeft  = &m_lbOrgColumnNames;
		pRight = &m_lbNewColumnNames;
		bAll   = sal_True;
	}
	else if(pButton == &m_pbColumns_LH)
	{
		pLeft  = &m_lbNewColumnNames;
		pRight = &m_lbOrgColumnNames;
		bAll   = sal_True;
	}

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(m_pParent->m_xDatabase->GetMetaData());
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	sal_Bool bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE;
	sal_Int32 nLen = xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN);

	DlgFieldMatch	dlgMissingFields(GetpApp()->GetDefDialogParent());
	ListBox*		pInfoBox = dlgMissingFields.GetInfoBox();

	String aColumnName,aOldColName;
	if(!bAll)
	{
		for(sal_uInt16 i=0; i < pLeft->GetSelectEntryCount(); ++i)
		{
			aColumnName = pLeft->GetSelectEntry(i);
			aOldColName = aColumnName;
			if(pRight == &m_lbNewColumnNames)
			{
				SbaColumn *pColumn = (SbaColumn *)pLeft->GetEntryData(pLeft->GetEntryPos(aColumnName));
				if(!bPKeyAllowed)
					pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
				if(nLen && nLen < aColumnName.Len())
				{
					String aNewName( aColumnName.Copy( 0, (xub_StrLen)nLen ));
					String aBaseName( aColumnName.Copy( 0, (xub_StrLen)nLen-2 ));
					sal_uInt16 i=1;
					while( pLeft->GetEntryPos(aNewName) == CONTAINER_ENTRY_NOTFOUND && (i<100) )
					{
						aNewName = aBaseName;
						aNewName += String(i);
						i++;
					}
					m_pParent->m_mNameMapping[aOldColName] = aNewName;
					aColumnName = aNewName;
				}
				else
					m_pParent->m_mNameMapping[aOldColName] = aColumnName;

				SbaColumn* pSbaColumn = m_pParent->m_xTableDef->CreateColumn(*pColumn,sal_True);
				if(pSbaColumn && m_pParent->m_xTableDef->AdjustType(pColumn,pSbaColumn))
				{
					pColumn = pSbaColumn;
					pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, aColumnName,IS_CASE_SENSITIVE(m_pParent->m_xDatabase)));
					pRight->SetEntryData(pRight->InsertEntry(aColumnName),pColumn);
				}
				else
				{
					pInfoBox->InsertEntry( aOldColName );
					pLeft->SetEntryData(pLeft->InsertEntry(aColumnName),pColumn);
				}
			}
			else
			{
				for(map<String,String,SbaStringCompare>::iterator aIter = m_pParent->m_mNameMapping.begin();
					aIter != m_pParent->m_mNameMapping.end();++aIter)
				{
					if((*aIter).second == aColumnName)
						break;
				}
				DBG_ASSERT(aIter != m_pParent->m_mNameMapping.end(),"Column must to be defined");
				SbaColumn* pColumn = m_pParent->GetOriginalColumns().Lookup((*aIter).first,String());
				pRight->SetEntryData(pRight->InsertEntry((*aIter).first),pColumn);
			}

		}
		for(sal_uInt16 j=pLeft->GetSelectEntryCount(); j ; --j)
			pLeft->RemoveEntry(pLeft->GetSelectEntry(j-1));
	}
	else
	{
		for(sal_uInt16 i=pLeft->GetEntryCount(); i ; --i)
		{
			aColumnName = pLeft->GetEntry(i-1);
			aOldColName = aColumnName;

			if(pRight == &m_lbNewColumnNames)
			{
				SbaColumn *pColumn = (SbaColumn *)pLeft->GetEntryData(i-1);
				if(!bPKeyAllowed)
					pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
				if(nLen && nLen < aColumnName.Len())
				{
					String aNewName( aColumnName.Copy( 0, (xub_StrLen)nLen ));
					String aBaseName( aColumnName.Copy( 0, (xub_StrLen)nLen-2 ));
					sal_uInt16 i=1;
					while( pLeft->GetEntryPos(aNewName) == CONTAINER_ENTRY_NOTFOUND && (i<100) )
					{
						aNewName = aBaseName;
						aNewName += String(i);
						i++;
					}
					m_pParent->m_mNameMapping[aOldColName] = aNewName;
					aColumnName = aNewName;
				}
				else
					m_pParent->m_mNameMapping[aOldColName] = aColumnName;

				SbaColumn* pSbaColumn = m_pParent->m_xTableDef->CreateColumn(*pColumn,sal_True);
				if(pSbaColumn && m_pParent->m_xTableDef->AdjustType(pColumn,pSbaColumn))
				{
					pColumn = pSbaColumn;
					pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, aColumnName,IS_CASE_SENSITIVE(m_pParent->m_xDatabase)));
					pRight->SetEntryData(pRight->InsertEntry(aColumnName,0),pColumn);
					pLeft->RemoveEntry(pLeft->GetEntry(i-1));
				}
				else
					pInfoBox->InsertEntry( aOldColName );
			}
			else
			{
				for(map<String,String,SbaStringCompare>::iterator aIter = m_pParent->m_mNameMapping.begin();
					aIter != m_pParent->m_mNameMapping.end();++aIter)
				{
					if((*aIter).second == aColumnName)
						break;
				}
				DBG_ASSERT(aIter != m_pParent->m_mNameMapping.end(),"Column must to be defined");
				SbaColumn* pColumn = m_pParent->GetOriginalColumns().Lookup((*aIter).first,String());
				pRight->SetEntryData(pRight->InsertEntry((*aIter).first,0),pColumn);
				pLeft->RemoveEntry(pLeft->GetEntry(i-1));
			}
		}
	}

	if(pInfoBox->GetEntryCount())
		dlgMissingFields.Execute();

	m_pParent->GetOKButton().Enable(m_lbNewColumnNames.GetEntryCount());
	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,m_lbNewColumnNames.GetEntryCount() && m_pParent->m_eCreateStyle != CopyTableWizard::WIZARD_APPEND_DATA);

	if(m_lbOrgColumnNames.GetEntryCount())
		m_lbOrgColumnNames.SelectEntryPos(0);

	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaWizColumnSelect, ListDoubleClickHdl, MultiListBox *, pListBox )
{
	MultiListBox *pLeft,*pRight;
	if(pListBox == &m_lbOrgColumnNames)
	{
		pLeft  = &m_lbOrgColumnNames;
		pRight = &m_lbNewColumnNames;
	}
	else
	{
		pRight = &m_lbOrgColumnNames;
		pLeft  = &m_lbNewColumnNames;
	}

	//////////////////////////////////////////////////////////////////////
	// Wenn Datenbank PrimaryKeys verarbeiten kann, PrimaryKey anlegen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  xMetaData(m_pParent->m_xDatabase->GetMetaData());
	::com::sun::star::uno::Any aConformance(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE));
	sal_Bool bPKeyAllowed = (::utl::getINT16(xMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE;
	sal_Int32 nLen = xMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN);

	String aColumnName;
	for(sal_uInt16 i=0; i < pLeft->GetSelectEntryCount(); ++i)
	{
		aColumnName = pLeft->GetSelectEntry(i);

		// here I move columns from the left side to the right side
		if(pRight == &m_lbNewColumnNames)
		{
			SbaColumn *pColumn = (SbaColumn *)pLeft->GetEntryData(pLeft->GetEntryPos(aColumnName));
			if(!bPKeyAllowed)
				pColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
			if(nLen && nLen < aColumnName.Len())
			{
				String aNewName( aColumnName.Copy( 0, (xub_StrLen)nLen ));
				String aBaseName( aColumnName.Copy( 0, (xub_StrLen)nLen-2 ));
				sal_uInt16 i=1;
				while( pLeft->GetEntryPos(aColumnName) == CONTAINER_ENTRY_NOTFOUND && (i<100) )
				{
					aNewName = aBaseName;
					aNewName += String(i);
					i++;
				}
				m_pParent->m_mNameMapping[aColumnName] = aNewName;
				aColumnName = aNewName;
			}
			else
				m_pParent->m_mNameMapping[aColumnName] = aColumnName;

			SbaColumn* pSbaColumn = m_pParent->m_xTableDef->CreateColumn(*pColumn,sal_True);
			if(pSbaColumn && m_pParent->m_xTableDef->AdjustType(pColumn,pSbaColumn))
			{
				pColumn = pSbaColumn;
				pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, aColumnName,IS_CASE_SENSITIVE(m_pParent->m_xDatabase)));
				pRight->SetEntryData(pRight->InsertEntry(aColumnName),pColumn);
			}
			else
			{
				DlgFieldMatch	dlgMissingFields(GetpApp()->GetDefDialogParent());
				ListBox*		pInfoBox = dlgMissingFields.GetInfoBox();
				pInfoBox->InsertEntry( aColumnName );
				dlgMissingFields.Execute();
				pLeft->SetEntryData(pLeft->InsertEntry(aColumnName),pColumn);
			}
		}
		else
		{
			for(map<String,String,SbaStringCompare>::iterator aIter = m_pParent->m_mNameMapping.begin();
				aIter != m_pParent->m_mNameMapping.end();++aIter)
			{
				if((*aIter).second == aColumnName)
					break;
			}
			DBG_ASSERT(aIter != m_pParent->m_mNameMapping.end(),"Column must to be defined");
			SbaColumn* pColumn = m_pParent->GetOriginalColumns().Lookup((*aIter).first,String());
			pRight->SetEntryData(pRight->InsertEntry((*aIter).first),pColumn);
		}

	}
	for(sal_uInt16 j=pLeft->GetSelectEntryCount(); j ; --j)
		pLeft->RemoveEntry(pLeft->GetSelectEntry(j-1));

	m_pParent->GetOKButton().Enable(m_lbNewColumnNames.GetEntryCount());
	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,m_lbNewColumnNames.GetEntryCount() && m_pParent->m_eCreateStyle != CopyTableWizard::WIZARD_APPEND_DATA);
	return 0;
}
//========================================================================
// SbaWizTypeSelectControl
//========================================================================
SbaWizTypeSelectControl::~SbaWizTypeSelectControl()
{
	delete pActFieldDescr;
}
// -----------------------------------------------------------------------
void SbaWizTypeSelectControl::ActivateAggregate( SbaControlType eType )
{
	switch(eType )
	{
		case tpFormat:
		case tpDefault:
		case tpAutoIncrement:
			break;
		default:
			SbaFieldDescControl::ActivateAggregate( eType );
	}
}
// -----------------------------------------------------------------------
void SbaWizTypeSelectControl::DeactivateAggregate( SbaControlType eType )
{
	switch(eType )
	{
		case tpFormat:
		case tpDefault:
		case tpAutoIncrement:
			break;
		default:
			SbaFieldDescControl::DeactivateAggregate( eType );
	}
}
// -----------------------------------------------------------------------
void SbaWizTypeSelectControl::CellModified(long nRow, sal_uInt16 nColId )
{
	DBG_ASSERT(nRow == -1,"nRow muss -1 sein!");

	MultiListBox &aListBox = ((SbaWizTypeSelect*)GetParent())->m_lbColumnNames;

	sal_uInt16 nPos = aListBox.GetEntryPos(pActFieldDescr->GetName());
	SbaColumn* pColumn = (SbaColumn*)aListBox.GetEntryData(nPos);
	DBG_ASSERT(pColumn,"Kein Eintrag gefunden SbaColumn == NULL");
	if(!pColumn)
		return;

	SaveData(pActFieldDescr);
	switch(nColId)
	{
		case FIELD_PROPERTY_REQUIRED:
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTREQUIRED, ((SbaExtFieldDescr*)pActFieldDescr)->IsRequired()));
			break;
		case FIELD_PROPERTY_NUMTYPE:
			pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, (sal_uInt32)((SbaNumericFieldDescr*)pActFieldDescr)->GetNumericSize()));
			break;
		case FIELD_PROPERTY_AUTOINC:
			pColumn->Put(SfxBoolItem(SBA_DEF_FLTAUTOINCREMENT, pActFieldDescr->IsAutoIncrement()));
			break;
		case FIELD_PROPERTY_TEXTLEN:
			pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, ((SbaTextFieldDescr*)pActFieldDescr)->GetTextLen().ToInt32()));
			break;
		case FIELD_PROPERTY_SCALE:
		case FIELD_PROPERTY_LENGTH:
			{
				sal_uInt32 nLength = 0;
				sal_uInt16 nScale  = 0;
				switch( pActFieldDescr->GetFieldType() )
				{
					case dbText:
						nLength = ((SbaTextFieldDescr*)pActFieldDescr)->GetTextLen().ToInt32();
						break;

					case dbChar:
						nLength = ((SbaCharFieldDescr*)pActFieldDescr)->GetTextLen().ToInt32();
						break;

					case dbNumeric:
						nLength = (sal_uInt32)((SbaNumericFieldDescr*)pActFieldDescr)->GetNumericSize();
						break;

					case dbDecimal:
					{
						SbaDecimalFieldDescr* pDecFieldDescr = (SbaDecimalFieldDescr*)pActFieldDescr;
						nLength = pDecFieldDescr->GetLength().ToInt32();
						nScale = pDecFieldDescr->GetScale().ToInt32();
						break;
					}

					case dbBinary:
						nLength = ((SbaBinaryFieldDescr*)pActFieldDescr)->GetLength().ToInt32();
						break;

					case dbVarBinary:
						nLength = ((SbaVarBinaryFieldDescr*)pActFieldDescr)->GetLength().ToInt32();
						break;
				}
				if(nColId == FIELD_PROPERTY_LENGTH)
					pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
				else
					pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE, nScale));
			}
			break;
		case FIELD_PRPOERTY_COLUMNNAME:
			{
				SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
				map<String,String,SbaStringCompare>::iterator aIter = ((SbaWizTypeSelect*)GetParent())->m_pParent->m_mNameMapping.begin();
				for(;aIter != ((SbaWizTypeSelect*)GetParent())->m_pParent->m_mNameMapping.end();++aIter)
				{
					if((*aIter).second == pName->GetValue())
					{
						(*aIter).second = pActFieldDescr->GetName();
						break;
					}
				}

				pColumn->Put(SbaNameItem(SBA_DEF_FLTNAME, pActFieldDescr->GetName(),GetDataDef()->GetDatabase()->GetIdentifierCase() == SDB_IC_ALL));
				aListBox.RemoveEntry(nPos);
				aListBox.InsertEntry(pActFieldDescr->GetName(),nPos);
				aListBox.SetEntryData(nPos,pColumn);
			}
			break;
		case FIELD_PRPOERTY_TYPE:
			{
				SbaFieldType aFieldType = pActFieldDescr->GetFieldType();

				sal_uInt32 nLength = 0;
				sal_uInt16 nScale  = 0;
				switch( aFieldType )
				{
					case dbText:
						nLength = ((SbaTextFieldDescr*)pActFieldDescr)->GetTextLen().ToInt32();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						break;

					case dbChar:
						nLength = ((SbaCharFieldDescr*)pActFieldDescr)->GetTextLen().ToInt32();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						break;

					case dbNumeric:
						nLength = (sal_uInt32)((SbaNumericFieldDescr*)pActFieldDescr)->GetNumericSize();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						break;

					case dbDecimal:
					{
						SbaDecimalFieldDescr* pDecFieldDescr = (SbaDecimalFieldDescr*)pActFieldDescr;
						nLength = pDecFieldDescr->GetLength().ToInt32();
						nScale = pDecFieldDescr->GetScale().ToInt32();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						pColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE, nScale));
						break;
					}

					case dbBinary:
						nLength = ((SbaBinaryFieldDescr*)pActFieldDescr)->GetLength().ToInt32();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						break;

					case dbVarBinary:
						nLength = ((SbaVarBinaryFieldDescr*)pActFieldDescr)->GetLength().ToInt32();
						pColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH, nLength));
						break;
				}
				pColumn->Put(SbaDataFieldTypeItem(SBA_DEF_FLTTYPE, aFieldType));
			}
			break;
		case FIELD_PROPERTY_DEFAULT:
		case FIELD_PROPERTY_BOOL_DEFAULT:
			{
				SbaExtFieldDescr* pExtFieldDescr = (SbaExtFieldDescr*)pActFieldDescr;
				pColumn->Put(SfxStringItem(SBA_DEF_FLTDEFAULT,pExtFieldDescr->GetDefault()));
			}
			break;
	}
}
// -----------------------------------------------------------------------
SbaDBDataDef* SbaWizTypeSelectControl::GetDataDef()
{
	return ((SbaWizTypeSelect*)GetParent())->m_pParent->m_xTableDef;
}
// -----------------------------------------------------------------------
void SbaWizTypeSelectControl::SetModified(sal_Bool bModified) {}
//========================================================================
DBG_NAME(SbaWizTypeSelect);
//========================================================================
SbaWizTypeSelect::SbaWizTypeSelect( Window* pParent)
			   :SbaWizardPage( pParent, SbaResId( TAB_WIZ_TYPE_SELECT ))
			   ,m_lbColumnNames( this, SbaResId( LB_NEW_COLUMN_NAMES ) )
			   ,m_gpColumns( this, SbaResId( GB_COLUMN_NAME ) )
			   ,m_aTypeControl( this, SbaResId( CONTROL_CONTAINER ))
			   ,m_gpAutoType( this, SbaResId( GB_AUTO_TYPE ) )
			   ,m_ftAuto( this, SbaResId( FT_AUTO ) )
			   ,m_etAuto( this, SbaResId( ET_AUTO ) )
			   ,m_pbAuto( this, SbaResId( PB_AUTO ) )
			   ,m_imgPKey( SbaResId( IMG_PKEY ) )
{
	DBG_CTOR(SbaWizTypeSelect,NULL);
	m_lbColumnNames.SetSelectHdl(LINK(this,SbaWizTypeSelect,ColumnSelectHdl));

	m_aTypeControl.Show();
	m_etAuto.SetInternational(Application::GetAppInternational());
	m_etAuto.SetText(String("10", RTL_TEXTENCODING_ASCII_US));
	m_etAuto.SetDecimalDigits(0);
	m_pbAuto.SetClickHdl(LINK(this,SbaWizTypeSelect,ButtonClickHdl));

	m_lbColumnNames.EnableMultiSelection(sal_True);

	// Datenbank kann keine PrimKeys verarbeiten oder keine Zeilenselektion
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(m_pParent->m_xDatabase->GetMetaData());
	m_lbColumnNames.SetPKey(((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE));


	FreeResource();
}
// -----------------------------------------------------------------------
SbaWizTypeSelect::~SbaWizTypeSelect()
{
	DBG_DTOR(SbaWizTypeSelect,NULL);
}
// -----------------------------------------------------------------------
void SbaWizTypeSelect::Resize()
{
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaWizTypeSelect, ColumnSelectHdl, MultiListBox *, pListBox )
{
	String aColumnName( m_lbColumnNames.GetSelectEntry() );

	SbaColumn* pColumn = (SbaColumn*)m_lbColumnNames.GetEntryData(m_lbColumnNames.GetEntryPos(aColumnName));
	if(pColumn)
		m_aTypeControl.DisplayData(pColumn);
	return 0;
}

// -----------------------------------------------------------------------
void SbaWizTypeSelect::Reset()
{
	// urspr"unglichen zustand wiederherstellen
	DBG_CHKTHIS(SbaWizTypeSelect,NULL);

	while(m_lbColumnNames.GetEntryCount())
		m_lbColumnNames.RemoveEntry(0);
	m_lbColumnNames.Clear();

	m_aColumnList = m_pParent->m_lColumnList;
	for(sal_uInt32 i=0;i< m_aColumnList.Count();++i)
	{
		SbaColumn *pColumn = m_aColumnList.GetObject(i);
		SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
		if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
		{
			SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
			SFX_ITEMSET_GET( *pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
			if(pPrimary->GetValue())
				m_lbColumnNames.InsertEntry(pName->GetValue(), m_imgPKey );
			else
				m_lbColumnNames.InsertEntry(pName->GetValue());
			m_lbColumnNames.SetEntryData(i,pColumn);
		}
	}
	m_bFirstTime = sal_False;
}
// -----------------------------------------------------------------------
void SbaWizTypeSelect::ActivatePage( )
{
	DBG_CHKTHIS(SbaWizTypeSelect,NULL);

	while(m_lbColumnNames.GetEntryCount())
		m_lbColumnNames.RemoveEntry(0);
	m_lbColumnNames.Clear();

	m_aColumnList = m_pParent->m_lColumnList;
	for(sal_uInt32 j=0;j< m_aColumnList.Count();++j)
	{
		SbaColumn *pColumn = m_aColumnList.GetObject(j);
		SFX_ITEMSET_GET( *pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, sal_True);
		if(!pFlags || !(pFlags->GetValue() & SDB_FLAGS_VERSIONING))
		{
			SFX_ITEMSET_GET( *pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
			SFX_ITEMSET_GET( *pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
			if(pPrimary->GetValue())
				m_lbColumnNames.InsertEntry(pName->GetValue(), m_imgPKey );
			else
				m_lbColumnNames.InsertEntry(pName->GetValue());

			m_lbColumnNames.SetEntryData(j,pColumn);
		}
	}

	m_lbColumnNames.SelectEntryPos(0);
	m_lbColumnNames.GetSelectHdl().Call(&m_lbColumnNames);
}
// -----------------------------------------------------------------------
sal_Bool SbaWizTypeSelect::LeavePage()
{
	DBG_CHKTHIS(SbaWizTypeSelect,NULL);
	while(m_pParent->m_lColumnList.Count())
		m_pParent->m_lColumnList.RemoveAt(0);
	m_pParent->m_lColumnList.Clear();

	m_pParent->m_lColumnList = m_aColumnList;
	return sal_True;
}
//------------------------------------------------------------------------------
void SbaWizTypeSelect::EnableAuto(sal_Bool bEnable)
{
	if(bEnable)
	{
		m_ftAuto.Show();
		m_etAuto.Show();
		m_pbAuto.Show();
		m_gpAutoType.Show();
	}
	else
	{
		m_ftAuto.Hide();
		m_etAuto.Hide();
		m_pbAuto.Hide();
		m_gpAutoType.Hide();
	}
}
//------------------------------------------------------------------------------
IMPL_LINK( SbaWizTypeSelect, ButtonClickHdl, Button *, pButton )
{
	SbaColumnList &aList = FillColumnList(m_pParent->m_xTableDef->GetColumns(),m_etAuto.GetText().ToInt32());

	for(sal_uInt32 i=0;i<aList.Count();++i)
	{
		sal_uInt32 nPos = m_aColumnList.GetPos(aList.GetObject(i));
		SbaColumn *pSrcColumn = aList.GetObject(i);
		SFX_ITEMSET_GET( *pSrcColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True );
		SbaColumn *pDestColumn = m_pParent->m_lColumnList.Lookup(m_pParent->m_mNameMapping[pName->GetValue()],String());
		if(pDestColumn)
		{
			SbaColumn*	pNewColumn = pDestColumn;
			SbaColumn*	pColumn = aList.GetObject(i);

			SFX_ITEMSET_GET(*pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
			SFX_ITEMSET_GET(*pColumn, pLength, SfxUInt32Item, SBA_DEF_FLTLENGTH, sal_True);
			SFX_ITEMSET_GET(*pColumn, pScale, SfxUInt16Item, SBA_DEF_FLTSCALE, sal_True);
			SFX_ITEMSET_GET(*pColumn, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True );

			SdbTypeInfo* pInfo = m_pParent->m_xTableDef->GetDatabase()->IsTypeAvailable(pType->GetType(), pLength->GetValue());

			pNewColumn->Put(SbaDataFieldTypeItem(SBA_DEF_FLTTYPE,(SbaFieldType) pType->GetValue()));
			pNewColumn->Put(SfxUInt32Item(SBA_DEF_FLTLENGTH,pLength->GetValue()));
			pNewColumn->Put(SfxUInt16Item(SBA_DEF_FLTSCALE,pScale->GetValue()));
			pNewColumn->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, pFormat->GetValue()));

			if(!pInfo)
				m_pParent->m_xTableDef->AdjustType(pColumn,pNewColumn);

			SFX_ITEMSET_GET(*pNewColumn, pType2, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);

			switch(pType2->GetType())
			{
				case dbChar:
				case dbText:
					if(pInfo && pInfo->nPrecision && pInfo->nPrecision < pLength->GetValue()) // this type is to small for my data
						m_pParent->m_xTableDef->ConvertTypeTo(dbMemo, pNewColumn);
					break;
			}
		}
	}
	ActivatePage();

	return 0;
}
//------------------------------------------------------------------------
sal_Bool SbaWizTypeSelectList::IsPrimaryKeyAllowed() const
{
	for(sal_uInt16 j=0;m_bPKey && j<GetSelectEntryCount();++j)
	{
		SbaColumn *pColumn = (SbaColumn *)GetEntryData(GetSelectEntryPos(j));
		if(!pColumn)
			break;
		SFX_ITEMSET_GET(*pColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
		SbaFieldType eFieldType = (SbaFieldType)pType->GetValue();
		if(eFieldType == dbMemo || eFieldType == dbImage)
			break;
	}
	return j == GetSelectEntryCount();
}
//------------------------------------------------------------------------
long SbaWizTypeSelectList::PreNotify( NotifyEvent& rEvt )
{
	long nDone = 0;
	switch( rEvt.GetType() )
	{
		case EVENT_MOUSEBUTTONDOWN:
		{
			const MouseEvent* pMEvt = rEvt.GetMouseEvent();
			if(pMEvt->IsRight() && !pMEvt->GetModifier())
				nDone = 1;
		}
			break;
		case EVENT_COMMAND:
		{
			if(!IsPrimaryKeyAllowed())
				break;

			const CommandEvent* pComEvt = rEvt.GetCommandEvent();
			if(pComEvt->GetCommand() != COMMAND_CONTEXTMENU)
				break;
			// die Stelle, an der geklickt wurde
			Point ptWhere(0,0);
			if (pComEvt->IsMouseEvent())
				ptWhere = pComEvt->GetMousePosPixel();

			PopupMenu aContextMenu(SbaResId(RID_SBA_RTF_PKEYPOPUP));
			switch( aContextMenu.Execute( this, ptWhere ) )
			{
				case SID_SBA_TABED_PRIMARYKEY:
				{
					SbaColumn *pColumn = (SbaColumn *)GetEntryData(GetSelectEntryPos());
					if(!pColumn)
						break;
					SFX_ITEMSET_GET( *pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, sal_True);
					sal_Bool bPKey = pPrimary->GetValue();
					String aColumnName;
					for(sal_uInt16 j=0;j<GetEntryCount();++j)
					{
						if(!IsEntryPosSelected(j))
						{
							SbaColumn *pNewColumn = (SbaColumn *)GetEntryData(j);
							aColumnName = GetEntry(j);
							pNewColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, sal_False));
							RemoveEntry(j);
							InsertEntry(aColumnName,j);
							SetEntryData(j,pNewColumn);
						}
						else
						{
							aColumnName = GetEntry(j);
							SbaColumn *pNewColumn = (SbaColumn *)GetEntryData(j);
							RemoveEntry(j);
							pNewColumn->Put(SfxBoolItem(SBA_DEF_FLTPRIMARY, !bPKey ));
							if(bPKey)
								InsertEntry(aColumnName,j);
							else
							{
								pNewColumn->Put(SfxBoolItem(SBA_DEF_FLTREQUIRED, sal_True));
								InsertEntry(aColumnName,((SbaWizTypeSelect*)GetParent())->m_imgPKey,j);
							}
							SetEntryData(j,pNewColumn);
							SelectEntryPos(j);
						}
					}
					GetSelectHdl().Call(this);
				}
				break;
			}
			nDone = 1;
		}
		break;
	}
	return nDone ? nDone : MultiListBox::PreNotify(rEvt);
}
//========================================================================
SbaColumnList&	SbaWizHTMLExtend::FillColumnList(SbaColumnList& rList,sal_uInt32 nRows)
{
	sal_uInt32 nTell = m_pParserStream->Tell(); // verndert vielleicht die Position des Streams
	SbaHTMLReader *pReader = new SbaHTMLReader(*m_pParserStream,nRows,m_pParent->GetTableDef()->GetColumns().Count(),m_pParent->GetTableDef()->GetFormatter());
	pReader->AddRef();
	pReader->CallParser();
	SbaColumnList&	aList = pReader->FillColumnTypes(m_pParent->GetTableDef()->GetColumns());
	pReader->ReleaseRef();
	m_pParserStream->Seek(nTell);
	return aList;
}
//========================================================================
SbaColumnList&	SbaWizRTFExtend::FillColumnList(SbaColumnList& rList,sal_uInt32 nRows)
{
	sal_uInt32 nTell = m_pParserStream->Tell(); // verndert vielleicht die Position des Streams
	SbaRTFReader *pReader = new SbaRTFReader(*m_pParserStream,nRows,m_pParent->GetTableDef()->GetColumns().Count(),m_pParent->GetTableDef()->GetFormatter());
	pReader->AddRef();
	pReader->CallParser();
	SbaColumnList&	aList = pReader->FillColumnTypes(m_pParent->GetTableDef()->GetColumns());
	pReader->ReleaseRef();
	m_pParserStream->Seek(nTell);
	return aList;
}
//========================================================================
SbaWizNormalExtend::SbaWizNormalExtend(Window* pParent) : SbaWizTypeSelect( pParent)
{
	EnableAuto(sal_False);
	Size aSize( GetSizePixel() );
	Size agpSize( m_gpColumns.GetSizePixel() );
	Point aPos(m_gpColumns.GetPosPixel());

	sal_Int32 nHeight = m_lbColumnNames.GetSizePixel().Height() +6;
	m_gpColumns.SetPosSizePixel(aPos,Size(agpSize.Width(),nHeight));

	aPos = m_aTypeControl.GetPosPixel();
	Size aNewSize(m_aTypeControl.GetSizePixel().Width(),nHeight - aPos.Y()-6);

	agpSize = m_aTypeControl.GetSizePixel();
	m_aTypeControl.SetPosSizePixel(aPos,aNewSize);
}
//========================================================================
// class SbaColumnString
//========================================================================
class SbaColumnString : public SvLBoxString
{
	sal_Bool m_bReadOnly;
public:
	SbaColumnString( SvLBoxEntry* pEntry, sal_uInt16 nFlags, const String& rStr,sal_Bool _RO)
		:SvLBoxString(pEntry,nFlags,rStr)
		,m_bReadOnly(_RO)
	{
	}

	virtual void Paint(const Point& rPos, SvLBox& rDev, sal_uInt16 nFlags, SvLBoxEntry* pEntry);
	//virtual void InitViewData( SvLBox* pView,SvLBoxEntry* pEntry, SvViewDataItem* pViewData);
};



//------------------------------------------------------------------------
/*
void SbaColumnString::InitViewData( SvLBox* pView,SvLBoxEntry* pEntry, SvViewDataItem* pViewData)
{
	SvLBoxString::InitViewData(pView,pEntry,pViewData);
}
*/
//------------------------------------------------------------------------
void SbaColumnString::Paint(const Point& rPos, SvLBox& rDev, sal_uInt16 nFlags, SvLBoxEntry* pEntry )
{
	if(m_bReadOnly)
	{
		const StyleSettings& rStyleSettings = rDev.GetSettings().GetStyleSettings();
		rDev.SetTextColor( rStyleSettings.GetDisableColor() );
		rDev.SetTextFillColor( rStyleSettings.GetFieldColor() );
	}
	rDev.DrawText( rPos, GetText() );
}
//========================================================================
SbaColumnTreeBox::SbaColumnTreeBox( Window* pParent, WinBits nWinStyle ) : SbaTreeListBox(pParent,nWinStyle)
{
	SetDragDropMode( 0 );
	EnableInplaceEditing( sal_False );
	SetWindowBits(WB_BORDER | WB_HASBUTTONS | WB_HSCROLL);
	SetSelectionMode( SINGLE_SELECTION );
}
//------------------------------------------------------------------------
SbaColumnTreeBox::SbaColumnTreeBox( Window* pParent, const ResId& rResId )
	: SbaTreeListBox(pParent,rResId)
{
	SetDragDropMode( 0 );
	EnableInplaceEditing( sal_False );
	SetWindowBits(WB_BORDER | WB_HASBUTTONS | WB_HSCROLL);
	SetSelectionMode( SINGLE_SELECTION );
}
//------------------------------------------------------------------------
void SbaColumnTreeBox::InitEntry(SvLBoxEntry* pEntry, const String& rStr, const Image& rImg1, const Image& rImg2)
{
	SvTreeListBox::InitEntry( pEntry, rStr, rImg1, rImg2 );
	SvLBoxString* pString = new SbaColumnString(pEntry, 0, rStr,sal_False);
	if (pString)
		pEntry->ReplaceItem( pString, pEntry->ItemCount() - 1 );
}
//------------------------------------------------------------------------
sal_Bool SbaColumnTreeBox::Select( SvLBoxEntry* pEntry, sal_Bool bSelect )
{
	if(bSelect)
	{
		SbaColumn* pColumn = (SbaColumn*)pEntry->GetUserData();
		SFX_ITEMSET_GET(*pColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, sal_True);
		if(!(pAutoIncrement->GetValue() && m_bReadOnly))
			bSelect = SvTreeListBox::Select( pEntry,bSelect );
	}
	else
		bSelect = SvTreeListBox::Select( pEntry,bSelect );
	return bSelect;
}
//------------------------------------------------------------------------
void SbaColumnTreeBox::FillListBox( const SbaColumnList& _rList)
{
	Clear();
	for(sal_uInt32 i=0;i< _rList.Count();++i)
	{
		SbaColumn *pColumn = _rList.GetObject(i);

		SFX_ITEMSET_GET( *pColumn, pFlags,	SfxUInt16Item,	SBA_DEF_FLTSEARCH,	sal_True );

		if(!(pFlags && pFlags->GetValue() & SDB_FLAGS_VERSIONING))
		{
			SFX_ITEMSET_GET( *pColumn, pName,	SbaNameItem,	SBA_DEF_FLTNAME,	sal_True );
			SFX_ITEMSET_GET( *pColumn, pAutoIncrement, SfxBoolItem, SBA_DEF_FLTAUTOINCREMENT, sal_True);
			SvLBoxEntry* pEntry = InsertEntry(pName->GetValue(),0,sal_False,LIST_APPEND,pColumn);
			SvButtonState eState = !(m_bReadOnly && pAutoIncrement->GetValue()) ? SV_BUTTON_CHECKED : SV_BUTTON_UNCHECKED;
			SetCheckButtonState( pEntry, SV_BUTTON_CHECKED);
		}
	}
}

//========================================================================
// SbaWizColumnSelect
DBG_NAME(SbaWizNameMatching);
//========================================================================
SbaWizNameMatching::SbaWizNameMatching( Window* pParent)
		:SbaWizardPage( pParent, SbaResId( TAB_WIZ_NAME_MATCHING		) )
		,m_FT_TABLE_LEFT(		this, SbaResId( FT_TABLE_LEFT			) )
		,m_FT_TABLE_RIGHT(		this, SbaResId( FT_TABLE_RIGHT			) )
		,m_CTRL_LEFT(			this, SbaResId( CTRL_LEFT				) )
		,m_CTRL_RIGHT(			this, SbaResId( CTRL_RIGHT				) )
		,m_pbColumn_up(			this, SbaResId( PB_COLUMN_UP			) )
		,m_pbColumn_down(		this, SbaResId( PB_COLUMN_DOWN			) )
		,m_pbColumn_up_right(	this, SbaResId( PB_COLUMN_UP_RIGHT		) )
		,m_pbColumn_down_right(	this, SbaResId( PB_COLUMN_DOWN_RIGHT	) )
		,m_pbAll(				this, SbaResId( PB_ALL					) )
		,m_pbNone(				this, SbaResId( PB_NONE					) )

{
	DBG_CTOR(SbaWizNameMatching,NULL);

	m_pbColumn_up.SetClickHdl(LINK(this,SbaWizNameMatching,ButtonClickHdl));
	m_pbColumn_down.SetClickHdl(LINK(this,SbaWizNameMatching,ButtonClickHdl));

	m_pbColumn_up_right.SetClickHdl(LINK(this,SbaWizNameMatching,RightButtonClickHdl));
	m_pbColumn_down_right.SetClickHdl(LINK(this,SbaWizNameMatching,RightButtonClickHdl));

	m_pbAll.SetClickHdl(LINK(this,SbaWizNameMatching,AllNoneClickHdl));
	m_pbNone.SetClickHdl(LINK(this,SbaWizNameMatching,AllNoneClickHdl));

	m_CTRL_LEFT.SetSelectHdl(LINK(this,SbaWizNameMatching,TableListClickHdl));
	m_CTRL_RIGHT.SetSelectHdl(LINK(this,SbaWizNameMatching,TableListRightSelectHdl));
	m_CTRL_RIGHT.EnableCheckButton( NULL );

	m_CTRL_LEFT.SetWindowBits( WB_FORCE_MAKEVISIBLE );
	m_CTRL_RIGHT.SetWindowBits( WB_FORCE_MAKEVISIBLE );

	FreeResource();
}
// -----------------------------------------------------------------------
SbaWizNameMatching::~SbaWizNameMatching()
{
	DBG_DTOR(SbaWizNameMatching,NULL);
}

// -----------------------------------------------------------------------
void SbaWizNameMatching::Reset()
{
	// urspr"unglichen zustand wiederherstellen
	DBG_CHKTHIS(SbaWizNameMatching,NULL);
	m_bFirstTime = sal_False;
}
// -----------------------------------------------------------------------
void SbaWizNameMatching::ActivatePage( )
{
	DBG_CHKTHIS(SbaWizNameMatching,NULL);

	// set source table name
	String aName = m_FT_TABLE_LEFT.GetText().GetToken(0,':');
	aName.AppendAscii(": \n");
	String aCatalog,aSchema,aTableName;
	if(m_pParent->m_xSourceDef->GetKind() != dbQuery)
		m_pParent->m_xSourceDef->GetDatabase()->QualifiedNameComponents(m_pParent->m_xSourceDef->Name(),aCatalog,aSchema,aTableName);
	else
		aTableName = m_pParent->m_xSourceDef->Name();
	aName += aTableName;
	m_FT_TABLE_LEFT.SetText(aName);

	// set dest table name
	aCatalog=aSchema=aTableName = String();
	aName = m_FT_TABLE_RIGHT.GetText().GetToken(0,':');
	aName.AppendAscii(": \n");
	if(m_pParent->m_xSourceDef->GetKind() != dbQuery)
		m_pParent->m_xSourceDef->GetDatabase()->QualifiedNameComponents(m_pParent->m_xTableDef->Name(),aCatalog,aSchema,aTableName);
	else
		aTableName = m_pParent->m_xTableDef->Name();
	aName += aTableName;
	m_FT_TABLE_RIGHT.SetText(aName);

	m_CTRL_RIGHT.SetReadOnly(); // sets autoinc to readonly
	m_CTRL_LEFT.FillListBox(m_pParent->GetOriginalColumns());

	// the left tree contains bitmaps so i need to resize the right one
	m_CTRL_RIGHT.SetEntryHeight(m_CTRL_LEFT.GetEntryHeight());
	m_CTRL_RIGHT.SetIndent(m_CTRL_LEFT.GetIndent());
	m_CTRL_RIGHT.SetSpaceBetweenEntries(m_CTRL_LEFT.GetSpaceBetweenEntries());
	m_CTRL_RIGHT.FillListBox(m_pParent->GetTableDef()->GetColumns());

	m_pParent->EnableButton(CopyTableWizard::WIZARD_NEXT,sal_False);
	m_CTRL_LEFT.GrabFocus();
}
// -----------------------------------------------------------------------
sal_Bool SbaWizNameMatching::LeavePage()
{
	DBG_CHKTHIS(SbaWizNameMatching,NULL);

	const SbaColumnList& rOrgList = m_pParent->GetOriginalColumns();
	for(sal_uInt32 i=0;i<rOrgList.Count();++i)
	{
		m_pParent->m_vColumnPos.push_back(CONTAINER_ENTRY_NOTFOUND);
		m_pParent->m_vColumnTypes.push_back(dbNone);
	}

	const SbaColumnList& rList = m_pParent->GetTableDef()->GetColumns();

	SvLBoxEntry* pLeftEntry = m_CTRL_LEFT.GetModel()->First();
	SvLBoxEntry* pRightEntry = m_CTRL_RIGHT.GetModel()->First();
	while(pLeftEntry && pRightEntry)
	{
		SbaColumn* pColumn = (SbaColumn*)pLeftEntry->GetUserData();
		DBG_ASSERT(pColumn,"SbaWizNameMatching: SbaColumn can not be null!");

		sal_uInt32 nPos = rOrgList.GetPos(pColumn);

		SbaColumn* pRightColumn = (SbaColumn*)pRightEntry->GetUserData();
		DBG_ASSERT(pRightColumn,"SbaWizNameMatching: SbaColumn can not be null!");

		if(m_CTRL_LEFT.GetCheckButtonState(pLeftEntry) == SV_BUTTON_CHECKED)
		{
			m_pParent->m_vColumnPos[nPos] = rList.GetPos(pRightColumn)+1;
			SFX_ITEMSET_GET(*pRightColumn, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
			m_pParent->m_vColumnTypes[nPos] = (SbaFieldType)pType->GetValue();
		}
		else
			m_pParent->m_vColumnPos[nPos] = CONTAINER_ENTRY_NOTFOUND;

		pLeftEntry = m_CTRL_LEFT.GetModel()->Next(pLeftEntry);
		pRightEntry = m_CTRL_RIGHT.GetModel()->Next(pRightEntry);
	}

	return sal_True;
}
// -----------------------------------------------------------------------
String SbaWizNameMatching::GetTitle() const { return String(SbaResId(SBA_STR_WIZ_NAME_MATCHING_TITEL)); }
// -----------------------------------------------------------------------
IMPL_LINK( SbaWizNameMatching, ButtonClickHdl, Button *, pButton )
{
	SvLBoxEntry* pEntry = NULL;
	if(pEntry = m_CTRL_LEFT.FirstSelected())
	{
		sal_uInt16 nPos		= m_CTRL_LEFT.GetModel()->GetAbsPos(pEntry);
		if(pButton == &m_pbColumn_up && nPos)
			--nPos;
		else if(pButton == &m_pbColumn_down)
			nPos += 2;

		m_CTRL_LEFT.ModelIsMoving(pEntry,NULL,nPos);
		m_CTRL_LEFT.GetModel()->Move(pEntry,NULL,nPos);
		m_CTRL_LEFT.ModelHasMoved(pEntry);

		long nThumbPos		= m_CTRL_LEFT.GetVScroll()->GetThumbPos();
		long nVisibleSize	= m_CTRL_LEFT.GetVScroll()->GetVisibleSize();
		
		if(pButton == &m_pbColumn_down && (nThumbPos+nVisibleSize+1) < nPos)
		{
			m_CTRL_LEFT.GetVScroll()->DoScrollAction(SCROLL_LINEDOWN);
			//	m_CTRL_LEFT.MakeVisible(pEntry,sal_True);
		}

		TableListClickHdl(&m_CTRL_LEFT);
	}


	return 0;
}
//------------------------------------------------------------------------------
IMPL_LINK( SbaWizNameMatching, RightButtonClickHdl, Button *, pButton )
{
	SvLBoxEntry* pEntry = NULL;
	if(pEntry = m_CTRL_RIGHT.FirstSelected())
	{
		sal_uInt16 nPos		= m_CTRL_RIGHT.GetModel()->GetAbsPos(pEntry);
		if(pButton == &m_pbColumn_up_right && nPos)
			--nPos;
		else if(pButton == &m_pbColumn_down_right)
			nPos += 2;

		m_CTRL_RIGHT.ModelIsMoving(pEntry,NULL,nPos);
		m_CTRL_RIGHT.GetModel()->Move(pEntry,NULL,nPos);
		m_CTRL_RIGHT.ModelHasMoved(pEntry);
		long nThumbPos		= m_CTRL_RIGHT.GetVScroll()->GetThumbPos();
		long nVisibleSize	= m_CTRL_RIGHT.GetVScroll()->GetVisibleSize();
		
		if(pButton == &m_pbColumn_down_right && (nThumbPos+nVisibleSize+1) < nPos)
			m_CTRL_RIGHT.GetVScroll()->DoScrollAction(SCROLL_LINEDOWN);
		TableListRightSelectHdl(&m_CTRL_RIGHT);
	}
	return 0;
}
//------------------------------------------------------------------------------
IMPL_LINK( SbaWizNameMatching, TableListClickHdl, SvTreeListBox *, pListBox )
{
	SvLBoxEntry* pEntry = m_CTRL_LEFT.FirstSelected();
	if(pEntry)
	{
		sal_uInt16 nPos			= m_CTRL_LEFT.GetModel()->GetAbsPos(pEntry);
		SvLBoxEntry* pOldEntry = m_CTRL_RIGHT.FirstSelected();
		if(pOldEntry && nPos != m_CTRL_RIGHT.GetModel()->GetAbsPos(pOldEntry))
		{
			if(pOldEntry)
				m_CTRL_RIGHT.Select(pOldEntry,sal_False);
			sal_uInt16 nOldPos = m_CTRL_RIGHT.GetModel()->GetAbsPos(pOldEntry);
			pOldEntry = m_CTRL_RIGHT.GetEntry(nPos);
			if(pOldEntry)
			{
				sal_uInt16 nNewPos = m_CTRL_LEFT.GetModel()->GetAbsPos(m_CTRL_LEFT.GetFirstEntryInView());
				if(nPos - nNewPos == -1)
					nNewPos--;
				m_CTRL_RIGHT.MakeVisible(m_CTRL_RIGHT.GetEntry(nNewPos),sal_True);
				m_CTRL_RIGHT.Select(pOldEntry,sal_True);
			}
		}
		else if(!pOldEntry)
		{
			pOldEntry = m_CTRL_RIGHT.GetEntry(nPos);
			if(pOldEntry)
			{
				m_CTRL_RIGHT.Select(pOldEntry,sal_True);
			}
		}
	}

	return 0;
}
//------------------------------------------------------------------------------
IMPL_LINK( SbaWizNameMatching, TableListRightSelectHdl, SvTreeListBox *, pListBox )
{
	SvLBoxEntry* pEntry = m_CTRL_RIGHT.FirstSelected();
	if(pEntry)
	{
		sal_uInt16 nPos			= m_CTRL_RIGHT.GetModel()->GetAbsPos(pEntry);
		SvLBoxEntry* pOldEntry = m_CTRL_LEFT.FirstSelected();
		if(pOldEntry && nPos != m_CTRL_LEFT.GetModel()->GetAbsPos(pOldEntry))
		{
			if(pOldEntry)
				m_CTRL_LEFT.Select(pOldEntry,sal_False);
			sal_uInt16 nOldPos = m_CTRL_RIGHT.GetModel()->GetAbsPos(pOldEntry);
			pOldEntry = m_CTRL_LEFT.GetEntry(nPos);
			if(pOldEntry)
			{
				sal_uInt16 nNewPos = m_CTRL_RIGHT.GetModel()->GetAbsPos(m_CTRL_RIGHT.GetFirstEntryInView());
				if(nPos - nNewPos == -1)
					nNewPos--;
				m_CTRL_LEFT.MakeVisible(m_CTRL_LEFT.GetEntry(nNewPos),sal_True);
				m_CTRL_LEFT.Select(pOldEntry,sal_True);
			}
		}
		else if(!pOldEntry)
		{
			pOldEntry = m_CTRL_LEFT.GetEntry(nPos);
			if(pOldEntry)
			{
				m_CTRL_LEFT.Select(pOldEntry,sal_True);
			}
		}
	}

	return 0;
}
// -----------------------------------------------------------------------
IMPL_LINK( SbaWizNameMatching, AllNoneClickHdl, Button *, pButton )
{
	sal_Bool bAll = pButton == &m_pbAll;
	SvLBoxEntry* pEntry = m_CTRL_LEFT.First();
	while(pEntry)
	{
		m_CTRL_LEFT.SetCheckButtonState( pEntry, bAll ? SV_BUTTON_CHECKED : SV_BUTTON_UNCHECKED);
		pEntry = m_CTRL_LEFT.Next(pEntry);
	}

	return 0;
}
// -----------------------------------------------------------------------


