/*************************************************************************
 *
 *  $RCSfile: sqldlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef SBA_SQLDLG_HRC
#include "sqldlg.hrc"
#endif
#ifndef _SBA_SQLDLG_HXX
#include "sqldlg.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

//========================================================================
// SqlDlg
// Dialog fuer das Absenden von SQL-Statments direkt an die Datenbank
//========================================================================

//------------------------------------------------------------------------
SbaSqlDlg::SbaSqlDlg( Window* pParent, SbaDatabase* pDatabase ) :
	 ModalDialog( pParent, SbaResId(DLG_MANUAL_SQL) )
	,xDatabase( pDatabase )

	,aFT_Info( this, SbaResId( FT_INFO ) )
	,aMLE_Sql( this, SbaResId(MLE_SQL) )
	,aGB_Status( this, SbaResId( GB_STATUS ) )
	,aMLE_Status( this, SbaResId(MLE_STATUS) )
	,aPB_Execute( this, ResId( PB_EXECUTE ) )
	,aPB_Close( this, ResId( PB_CLOSE ) )
	,aPB_Help( this, ResId( PB_HELP ) )

{
	//////////////////////////////////////////////////////////////////////
	// Button-Hdl setzen
	aPB_Execute.SetClickHdl( LINK( this, SbaSqlDlg, ExecuteClickHdl ) );
	aPB_Close.SetClickHdl( LINK( this, SbaSqlDlg, CloseClickHdl ) );

	aMLE_Status.SetReadOnly( sal_True );
	aMLE_Status.SetText( String(SbaResId(SBA_STR_MANSQL_NOSTATUS)) );
	aMLE_Sql.GrabFocus();

	FreeResource();
}

//------------------------------------------------------------------------
SbaSqlDlg::~SbaSqlDlg()
{
}

//------------------------------------------------------------------------
IMPL_LINK( SbaSqlDlg, ExecuteClickHdl, Button*, pButton )
{
	String aSQLStatement = aMLE_Sql.GetText();
	xDatabase->ExecuteSQL( aSQLStatement );
	SdbStatus aStatus = (SdbStatus&)xDatabase->Status();
	String aStatusStr;
	if( aStatus.IsError() )
	{
		//SBAOBJ()->ShowDbStatus( (SdbStatus&)xDatabase->Status() );
		aStatusStr = aStatus.ErrorMessage();

		String aInfoStr = aStatus.ErrorInfo();
		if( aInfoStr.Len() )
		{
			aStatusStr += String(SbaResId(SBA_STR_SQLDIALOG_ERRORINFO));
			aStatusStr += aStatus.ErrorInfo();
		}
	}
	else
		aStatusStr = String( SbaResId(SBA_STR_MANSQL_STATUSSUCCESS) );

	aMLE_Status.SetText( aStatusStr );

	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaSqlDlg, CloseClickHdl, Button*, pButton )
{
	EndDialog( sal_True );

	return 0;
}



