/*************************************************************************
 *
 *  $RCSfile: frmds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/tools.hxx>
#include "sbaresid.hrc"
#include "sbasltid.hrc"

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#include "frmds.hxx"
#include "frmvs.hxx"
#include "sbares.hxx"
#include "sbaobj.hxx"
#include "sbaexpob.hxx"

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFX_FRMDESCRHXX //autogen
#include <sfx2/frmdescr.hxx>
#endif

#define SbaFormDocSh
#include "ofaslots.hxx"

#ifdef UNX
#define _cdecl
#define _CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

TYPEINIT1(SbaFormDocSh,SbaFileDefDocSh)
//=========================================================================

//-------------------------------------------------------------------------
SFX_IMPL_SIMPLE_OBJECTFACTORY_LOD(SbaFormDocSh, Sba, SBA_MOD());


//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaFormDocSh, SbaFileDefDocSh, SbaResId(0))
{
}

//-------------------------------------------------------------------------
SbaFormDocSh::SbaFormDocSh(SfxObjectCreateMode eMode)
		:SbaFileDefDocSh(eMode, String::CreateFromAscii("Layout")){
}

//-------------------------------------------------------------------------
BOOL SbaFormDocSh::InitNew( SvStorage* pSt)
{
	if (GetMedium())
	{
		INetURLObject aURL = GetFileUrl(GetMedium()->GetURLObject());

		// determine the factory for the new doc
		xub_StrLen nIndex	= 0;
		String aFactory;
		String sObjectURL = aURL.GetMainURL();
		sObjectURL.GetToken(1, ';', nIndex);
		if (STRING_NOTFOUND != nIndex)
		{
			aFactory = sObjectURL.Copy(0, nIndex);
			sObjectURL.Erase(0, nIndex);
			sObjectURL.EraseTrailingChars(';');
			sObjectURL.EraseLeadingChars(';');
		}

		// Factories haben leider '\'
		aFactory.SearchAndReplaceAll('\\','/');


		xDatabase   = SBA_MOD()->GetDatabase(sObjectURL);
		xDBDef		= SBA_MOD_EXT()->OpenDBDef(sObjectURL, FALSE, FALSE);

		// gibt es das Object, dann kann nicht new gemeint sein!
		if (xDBDef.Is())
		{
			if (xDBDef->Status().IsError())
				SBA_MOD()->ShowDbStatus(xDBDef->Status(), dbReadError);
			xDBDef = NULL;
			return TRUE;
		}
		else
		{
			// jetzt nochmal neu wegen der Fehlermeldungen
			xDBDef = SBA_MOD_EXT()->OpenDBDef( sObjectURL, TRUE, TRUE );

			if (xDBDef.Is() && xDBDef->IsNew())
			{
				//////////////////////////////////////////////////////////////////////
				// Dokument-Daten auf UI-Daten umsetzen
				// Erzeugen des Framesets
				SfxFrameSetDescriptor* pRootSet = new SfxFrameSetDescriptor(NULL);
				// neu erzeugen
				pRootSet->SetColSet(FALSE);

				// Den Frame erzeugen
				SfxFrameDescriptor* pFrame = new SfxFrameDescriptor(pRootSet);

				INetURLObject aUrlObj;
				aUrlObj.SetSmartProtocol(INET_PROT_PRIVATE);
				pFrame->SetURL(aFactory);
				pFrame->SetWidthRel(1);
				pFrame->SetScrollingMode(ScrollingYes);
				pFrame->SetMargin(Size(20, 20));
				pFrame->SetReadOnly(FALSE);
				pFrame->SetName(aFileFrameName);

				// Setzen der BaseUrl
				// Wird benoetigt zum relativen Speichern von verknpften Inhalten,
				// wie z.B. Grafiken #62159#
				SfxItemSet* pSet = pFrame->GetArgs();
				if (pSet && xDatabase.Is())
				{
					INetURLObject aDbURL;
					aDbURL.SetSmartProtocol(INET_PROT_FILE);
					aDbURL.SetSmartURL(xDatabase->Name());
					pSet->Put(SfxStringItem(SID_BASEURL, aDbURL.GetMainURL()));
				}
				TakeDescriptor(pRootSet);
				delete pRootSet;

				// wenn ich das Object modifizieren darf, muss ich es locken
				if (xDBDef.Is() && (IsReadOnly() || xDBDef->IsNew()))
					xDBDef->Lock();
			}
			if (xDBDef.Is() && xDBDef->Status().IsError())
				SBA_MOD()->ShowDbStatus(xDBDef->Status(), dbReadError);
		}
	}
	BOOL bRes = SbaFileDefDocSh::InitNew(pSt);
	return bRes;
}

//-------------------------------------------------------------------------
BOOL SbaFormDocSh::ConvertFrom(SfxMedium& rMedium)
{
	BOOL bRes(SbaFileDefDocSh::ConvertFrom(rMedium));
	FinishedLoading( SFX_LOADED_ALL );
	return bRes;
}

//-------------------------------------------------------------------------
void SbaFormDocSh::GetState(SfxItemSet &rSet)
{
	SbaFileDefDocSh::GetState(rSet);
}

//------------------------------------------------------------------------------
void SbaFormDocSh::Execute(SfxRequest& rReq)
{
	SbaFileDefDocSh::Execute(rReq);
}




