/*************************************************************************
 *
 *  $RCSfile: adtabdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef _SVX_ADTABDLG_HXX
#include "adtabdlg.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#include "adtabdlg.hrc"
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif
#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif // _SBARESID_HRC

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif // _SBA_DLGERR_HXX

#ifndef _SBASLTID_HRC //autogen
#include "sbasltid.hrc"
#endif

#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

DBG_NAME(SbaAddTableDlg);
//------------------------------------------------------------------------------
SbaAddTableDlg::SbaAddTableDlg(SfxBindings* pBindings, SfxChildWindow* pMgr, Window* pParent)
			 :SfxModelessDialog( pBindings, pMgr, pParent, SbaResId(DLG_JOIN_TABADD) )
			 ,SfxControllerItem(SID_SBA_JOINSH_ADDTBLDLG, *pBindings)
			 ,aFTTable( this, ResId( FT_TABLE ) )
			 ,aTableList( this, ResId( LB_TABLE ) )
			 ,aAddButton( this, ResId( PB_ADDTABLE ) )
			 ,aCloseButton( this, ResId( PB_CLOSE ) )
			 ,aHelpButton( this, ResId( PB_HELP ) )
			 ,aGroupBoxTable( this, ResId( GB_TABLE ) )
			 ,aDefaultString( ResId( STR_DEFAULT ) )
			 ,m_pShellAttachedTo(NULL)
{
	DBG_CTOR(SbaAddTableDlg,NULL);
	// der Close-Button hat schon einen Standard-Help-Text, den ich aber hier nicht haben moechte, also den Text ruecksetzen
	// und eine neue ID verteilen
	aCloseButton.SetHelpText(String());
	aCloseButton.SetHelpId(HID_JOINSH_ADDTAB_CLOSE);

	aTableList.SetHelpId(HID_JOINSH_ADDTAB_TABLELIST);

	//////////////////////////////////////////////////////////////////////
	// Handler setzen
	aAddButton.SetClickHdl( LINK(this,SbaAddTableDlg, AddClickHdl) );
	aCloseButton.SetClickHdl( LINK(this,SbaAddTableDlg, CloseClickHdl) );
	aTableList.SetDoubleClickHdl( LINK(this,SbaAddTableDlg, TableListDoubleClickHdl) );

	aTableList.EnableInplaceEditing( FALSE );
	aTableList.SetWindowBits(WB_BORDER | WB_HASLINES |WB_HASBUTTONS | WB_HASBUTTONSATROOT | WB_HASLINESATROOT | WB_SORT | WB_HSCROLL );
	aTableList.EnableCheckButton( NULL ); // do not show any buttons
	//aTableList.SetNodeBitmaps( Bitmap(SbaResId(PLUSBUTTON)),Bitmap(SbaResId(MINUSBUTTON)));
	aTableList.SetDefaultExpandedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
	aTableList.SetDefaultCollapsedEntryBmp( Image( SbaResId(TABLEFOLDER)) );
	aTableList.SetSelectionMode( SINGLE_SELECTION );

	Update(NULL);

	FreeResource();
}

//------------------------------------------------------------------------------
SbaAddTableDlg::~SbaAddTableDlg()
{
	DBG_DTOR(SbaAddTableDlg,NULL);
}

//-----------------------------------------------------------------------
void SbaAddTableDlg::StateChanged(USHORT nSID, SfxItemState eState, const SfxPoolItem* pState)
{
	if (!pState  || (SID_SBA_JOINSH_ADDTBLDLG != nSID))
		return;

	if (eState >= SFX_ITEM_AVAILABLE)
	{
		DBG_ASSERT(pState->ISA(SbaPointerItem), "SbaAddTableDlg::StateChanged : invalid parameter !");
		Update( (SbaJoinViewShExt*) ((SbaPointerItem*)pState)->GetValue() );
	}
}

//------------------------------------------------------------------------------
void SbaAddTableDlg::Update(SbaJoinViewShExt* pNewShell)
{
	if (m_pShellAttachedTo == pNewShell)
		return;

	m_pShellAttachedTo = pNewShell;
	if (m_pShellAttachedTo)
	{
		aTableList.Clear();
		xDatabase = m_pShellAttachedTo->GetDocShell()->GetJoinDocDatabase();
		UpdateTableList(m_pShellAttachedTo->IsViewAllowed());
	}

	//DetermineAddTable();
}

//------------------------------------------------------------------------------
void SbaAddTableDlg::AddTable()
{
	//////////////////////////////////////////////////////////////////
	// Tabelle hinzufuegen
	SvLBoxEntry* pEntry = aTableList.FirstSelected();
	if( pEntry && !aTableList.GetModel()->HasChilds(pEntry))
	{
		String aTableName,aDBName;
		SvLBoxEntry* pSchema = aTableList.GetParent(pEntry);
		if(pSchema)
		{
			SvLBoxEntry* pCatalog = aTableList.GetParent(pSchema);
			if(pCatalog)
				aDBName = aTableList.GetEntryText(pCatalog);
			if(xDatabase->GetUser().Len())	 // Falls nur Catalog und Tabellenname
				aTableName = aTableList.GetEntryText(pSchema);
			else if(!xDatabase->GetUser().Len())
				aDBName = aTableList.GetEntryText(pSchema);

		}

		if(aTableName.Len())
			aTableName += '.';
		aTableName += aTableList.GetEntryText(pEntry);

		// den Datenbank-Namen besorgen

		String aOrigTableName = SdbTable::GetFullName(*xDatabase,aTableName,aDBName);
		// aOrigTableName is used because AddTabWin would like to have this
		SbaTableDefRef xTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, aOrigTableName);
		if (!xTableDef.Is())
			return;
		if (xTableDef->IsLocked())
		{
			String strMessage(SbaResId(RID_STR_ADDTABLE_TABLELOCKED));
			strMessage.SearchAndReplace(String::CreateFromAscii("$name$"), aOrigTableName);
			SbaMsgBox( this, String(GetText()), strMessage, WB_OK ).Execute();
			aTableList.GrabFocus();
			return;
		}

		// und das Ganze dem Container uebergeben
		m_pShellAttachedTo->GetFrameWindow()->GetTabWinCont()->AddTabWin( aDBName, aOrigTableName,TRUE );
//		DetermineAddTable();
	}
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaAddTableDlg, AddClickHdl, Button*, pButton )
{
	if (IsAddAllowed())
		AddTable();

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaAddTableDlg, TableListDoubleClickHdl, ListBox *, pListBox )
{
	if (IsAddAllowed())
		AddTable();

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaAddTableDlg, CloseClickHdl, Button*, pButton )
{
	return Close();
}

//------------------------------------------------------------------------------
BOOL SbaAddTableDlg::Close()
{
	return SfxModelessDialog::Close();
}

//------------------------------------------------------------------------------
BOOL SbaAddTableDlg::IsAddAllowed()
{
	return	m_pShellAttachedTo &&
			m_pShellAttachedTo->GetFrameWindow() &&
			m_pShellAttachedTo->GetFrameWindow()->GetTabWinCont() &&
			m_pShellAttachedTo->GetFrameWindow()->GetTabWinCont()->IsAddAllowed();
}

//------------------------------------------------------------------------------
void SbaAddTableDlg::UpdateTableList(BOOL bViewsAllowed)
{
	//////////////////////////////////////////////////////////////////////
	// Datenbank- und Tabellennamen setzen
	aTableList.UpdateTableList(xDatabase,bViewsAllowed);
/*
	//////////////////////////////////////////////////////////////////////
	// Ersten Eintrag selektieren
	if( aTableList.GetEntryCount() )
		aTableList.SelectEntryPos( 0 );
*/
}

//=======================================================================

SFX_IMPL_MODELESSDIALOG(SbaAddTableDlgManager, SID_SBA_JOIN_ADDTABLE)

//-----------------------------------------------------------------------
SbaAddTableDlgManager::SbaAddTableDlgManager(Window *pParent, USHORT nId, SfxBindings *pBindings,
	SfxChildWinInfo* pInfo)
	:SfxChildWindow(pParent, nId)
{
	pWindow = new SbaAddTableDlg(pBindings, this, pParent);
	eChildAlignment = SFX_ALIGN_NOALIGNMENT;
	((SfxModelessDialog*)pWindow)->Initialize( pInfo );
}

