/*************************************************************************
 *
 *  $RCSfile: joinds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/sdbcurs.hxx>
#ifndef _SBA_SBADS_HXX
#include "sbads.hxx"
#endif // _SBA_SBADS_HXX

#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif

#ifndef _SBA_SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _SBA_SBASLTID_HRC
#include "sbasltid.hrc"
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SBA_SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

#ifndef _SFXFILEREC_HXX //autogen
#include <svtools/filerec.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

const UINT16	SbaJoinDocShExt::SBA_JOIN_UI_TABWIN_TAG		= 0x0010;
const BYTE		SbaJoinDocShExt::SBA_VERSION_SO50			= 0x01;

//========================================================================
// class SbaJoinDocShExt
//========================================================================

TYPEINIT0(SbaJoinDocShExt);

//-------------------------------------------------------------------------
SbaJoinDocShExt::SbaJoinDocShExt( SfxObjectShell* posRealDocShell )
	:m_posRealDocShell(posRealDocShell)
	,xJoinDocDatabase( NULL )
{
	DBG_ASSERT(m_posRealDocShell != NULL, "SbaJoinDocShExt::SbaJoinDocShExt : posRealDocShell darf nicht NULL sein");
	pTabWinDataList = new SbaJoinTabWinDataList;
	pTabConnDataList = new SbaJoinTabConnDataList;
}

//-------------------------------------------------------------------------
SbaJoinDocShExt::~SbaJoinDocShExt()
{
	SbaJoinTabWinData* pTabWinData;
	SbaJoinTabConnData* pTabConnData;

	while( pTabWinData=pTabWinDataList->Remove((ULONG)0) )
		delete pTabWinData;
	pTabWinDataList->Clear();

	while( pTabConnData=pTabConnDataList->Remove((ULONG)0) )
		delete pTabConnData;
	pTabConnDataList->Clear();

	delete pTabWinDataList;
	delete pTabConnDataList;
}

//-------------------------------------------------------------------------
BOOL SbaJoinDocShExt::InitNew(SvStorage *pStor)
{
	if (GetObjectShell()->GetMedium())
	{
		INetURLObject aURL = GetFileUrl(GetObjectShell()->GetMedium()->GetURLObject());
		xJoinDocDatabase = SBA_MOD()->GetDatabase(aURL.PathToFileName(), TRUE);
		if (xJoinDocDatabase.Is())
			return TRUE;
	}
	return FALSE;
}

//-------------------------------------------------------------------------
BOOL SbaJoinDocShExt::ConvertFrom( SfxMedium& rMedium )
{
	// Datenbank aus Itemset des Mediums holen
	SfxItemSet* pSet  = rMedium.GetItemSet();
	const SfxPoolItem* pItem = pSet->GetItem( SID_SBA_DATABASE );
	if ( pItem )
	{
		SbaDBDatabaseItem* pDBItem = PTR_CAST( SbaDBDatabaseItem, pItem );
		xJoinDocDatabase = pDBItem ? pDBItem->GetDatabase() : NULL;
	}
	else
	{	// es gibt in dem Medium kein Datenbank-Item ... das heisst, dass ich wahrscheinlich aus einem anderen Kontext
		// heraus aufgerufen wurde, dann versuche ich, ueber m_posRealDocShell an die Datenbank ranzukommen
		DBG_ASSERT(m_posRealDocShell != NULL, "SbaJoinDocShExt::ConvertFrom : habe keine ObjectShell !");
		if (m_posRealDocShell->ISA(SbaDBDataDefDocSh))
		{	// eine SbaDBDataDefDocSh sollte eine Datenbank haben
			xJoinDocDatabase = ((SbaDBDataDefDocSh*)m_posRealDocShell)->GetDatabase();
		}

		if (!xJoinDocDatabase.Is())
		{	// meine Real-DocShell kennt die DB auch noch nicht -> aus der URL des Mediums besorgen
			INetURLObject aURLObj = GetFileUrl(m_posRealDocShell->GetMedium()->GetURLObject());
			String aURL = aURLObj.GetMainURL();

			// zunaechst die Datenbank festhalten
			xJoinDocDatabase = SBA_MOD()->GetDatabase(aURLObj.PathToFileName());
			if (!xJoinDocDatabase.Is() || !xJoinDocDatabase->Status().IsSuccessful())
				// jetzt hab' ich auch keine Idee mehr ...
				return FALSE;
		}
	}

	return LoadData();
}

//------------------------------------------------------------------------------
void SbaJoinDocShExt::SaveUI( SvStream& rStream )
{
	SfxSingleRecordWriter aRecord( &rStream, GetUIInformationTag(), SBA_VERSION_SO50 );
	ULONG nCount = GetTabWinDataList()->Count();
	ULONG nPos = rStream.Tell();
	*aRecord << nCount;

	SbaJoinTabWinData* pTabWinData = GetTabWinDataList()->First();
	while (pTabWinData)
	{
		pTabWinData->Save(*aRecord);
		pTabWinData = GetTabWinDataList()->Next();
	}
}

//------------------------------------------------------------------------------
SbaJoinTabWinData* SbaJoinDocShExt::CreateTabWinDataObj()
{
	return new SbaJoinTabWinData();
}

//------------------------------------------------------------------------------
void SbaJoinDocShExt::LoadUI( SvStream& rStream )
{
	//////////////////////////////////////////////////////////////////////
	// Liste loeschen
	SbaJoinTabWinData* pTabWinData;
	while( pTabWinData = GetTabWinDataList()->Remove((ULONG)0) )
		delete pTabWinData;

	//////////////////////////////////////////////////////////////////////
	// Liste neu einlesen
	SfxSingleRecordReader aRecord( &rStream );
	if (aRecord.GetTag() == GetUIInformationTag())
		if ( aRecord.HasVersion(SBA_VERSION_SO50) )
		{
			ULONG nCount;
			*aRecord >> nCount;
			for( ULONG i=0; i<nCount; i++ )
			{
				pTabWinData = CreateTabWinDataObj();
				pTabWinData->Load( *aRecord );

				if (!CheckTabWinData(pTabWinData))
					delete pTabWinData;
				else
					GetTabWinDataList()->Insert(pTabWinData, LIST_APPEND);
			}
		}
}

//------------------------------------------------------------------------------
BOOL SbaJoinDocShExt::CheckTabWinData(const SbaJoinTabWinData* pData)
{
	if (xJoinDocDatabase.Is())
	{	// checken, ob die Datenbank die Tabelle ueberhaupt noch kennt (kann ja sein, sie z.B. ist gerade ausgeblendet)
		SbaTableDefRef xTableDef = (SbaTableDef*)xJoinDocDatabase->OpenDBDef(dbTable, pData->GetTableName(), FALSE);
		if (!xTableDef.Is())
			return FALSE;
	}

	return TRUE;
}

//------------------------------------------------------------------------------
BOOL SbaJoinDocShExt::LoadData()
{
	return TRUE;
}

//------------------------------------------------------------------------------
BOOL SbaJoinDocShExt::SaveData()
{
	// nennen wird es pseudo-abstrakt ...
	DBG_ASSERT(m_posRealDocShell != NULL, "SbaJoinDocShExt::SaveData : DocShell ist NULL !");
	m_posRealDocShell->SetModified( FALSE );
	return TRUE;
}

//------------------------------------------------------------------------------
USHORT SbaJoinDocShExt::CountWindows( const String& rWinName )
{
	//////////////////////////////////////////////////////////////////////
	// Fenster zaehlen, die gleichen Alias haben
	USHORT nRet = 0;
	SbaJoinTabWinData* pTabWinData = pTabWinDataList->First();
	BOOL bCase = (xJoinDocDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	while( pTabWinData )
	{
		if(bCase ? pTabWinData->GetWinName() == rWinName : pTabWinData->GetWinName().EqualsIgnoreCaseAscii(rWinName))
			nRet++;

		pTabWinData = pTabWinDataList->Next();
	}

	return nRet;
}

//------------------------------------------------------------------------------
void SbaJoinDocShExt::DeleteConnection( SbaJoinTabConnData* pConn )
{
	if( pConn )
		delete GetTabConnDataList()->Remove( pConn );
}



