/*************************************************************************
 *
 *  $RCSfile: joinvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "tabwin.hxx"
#include "twcont.hxx"
#include "joinvs.hxx"
#include "sbasltid.hrc"
#include "sbaitems.hxx"

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

//==================================================================
// class SbaJoinViewShExt
//==================================================================
TYPEINIT0(SbaJoinViewShExt)

//------------------------------------------------------------------------------
SbaJoinViewShExt::SbaJoinViewShExt( SfxViewShell* pvsRealViewShell )
	:m_pvsRealViewShell(pvsRealViewShell)
	,pDocSh(NULL)
	,pJoinFrameWindow(NULL)
{
}

//------------------------------------------------------------------------------
SbaJoinViewShExt::~SbaJoinViewShExt()
{
}

//------------------------------------------------------------------------------
void SbaJoinViewShExt::Execute( SfxRequest& rReq )
{
	switch( rReq.GetSlot() )
	{
		case SID_SBA_JOIN_ADDTABLE:
		{
			// SFX_APP()->ChildWindowExecute(rReq); TODo only from ViewFrame
			rReq.Done();
		} break;
	}
}

//------------------------------------------------------------------------------
void SbaJoinViewShExt::GetState( SfxItemSet& rSet )
{
	SfxWhichIter    aIter(rSet);
	USHORT          nWhich = aIter.FirstWhich();

	while (nWhich)
	{
		switch( nWhich )
		{
			case SID_SBA_JOINSH_ADDTBLDLG:
				// i need the viewshell
/*				if (!pJoinFrameWindow->GetTabWinCont()->IsAddAllowed())
					rSet.Put(SbaPointerItem(nWhich));
				else
*/				rSet.Put(SbaPointerItem(nWhich, this));
				break;
			case SID_SBA_JOIN_ADDTABLE:
			{
				/* only from ViewFrame
				SfxApplication *pApp = SFX_APP();
				if ( pApp->KnowsChildWindow(nWhich))
				{
					BOOL bAddAllowed = pJoinFrameWindow->GetTabWinCont()->IsAddAllowed();
					BOOL bHasChildWindow = pApp->HasChildWindow(nWhich);
					if (bAddAllowed)
						// nothing special, just test if it is already present
						rSet.Put( SfxBoolItem( nWhich, bHasChildWindow) );
					else
						if (bHasChildWindow)
							// no add allowed but the window is present -> allow deactivation
							rSet.Put( SfxBoolItem( nWhich, TRUE) );
						else
							// no add allowed and not present -> disable
							rSet.DisableItem(nWhich);
				}
				else*/
					rSet.DisableItem(nWhich);
			} break;
		}
		nWhich = aIter.NextWhich();
	}
}

//------------------------------------------------------------------------------
void SbaJoinViewShExt::InnerResizePixel( const Point &rPos, const Size &rSize )
{
	if( pJoinFrameWindow )
		pJoinFrameWindow->SetPosSizePixel( rPos, rSize );
}

//------------------------------------------------------------------------------
void SbaJoinViewShExt::OuterResizePixel( const Point &rPos, const Size &rSize )
{
	InnerResizePixel( rPos, rSize );
}

