/*************************************************************************
 *
 *  $RCSfile: tabwin.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STREAM_HXX
#define ENABLE_BYTESTRING_STREAM_OPERATORS
#include <tools/stream.hxx>
#endif

#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SV_IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _SV_PTRSTYLE_HXX
#include <vcl/ptrstyle.hxx>
#endif

#ifndef _SV_EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SVX_ADTABDLG_HXX
#include "adtabdlg.hxx"
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif
#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif
#ifndef _JOINSH_HRC
#include "joinsh.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef __JOINEXCH_HXX_
#include "joinexch.hxx"
#endif // __JOINEXCH_HXX_

#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif

#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

const long TABWIN_SIZING_AREA = 4;
const long LISTBOX_SCROLLING_AREA = 6;
const ULONG SCROLLING_TIMESPAN = 500;


TYPEINIT0(SbaJoinTabWin);
TYPEINIT0(SbaJoinTabWinData);

//==================================================================
// class SbaJoinTabWinData
//==================================================================
DBG_NAME(SbaJoinTabWinData);
//------------------------------------------------------------------------------
SbaJoinTabWinData::SbaJoinTabWinData()
	:aPosition( Point(-1,-1) )
	,aSize( Size(-1,-1) )
	,bShowAll( TRUE )
{
	DBG_CTOR(SbaJoinTabWinData,NULL);
}

//------------------------------------------------------------------------------
SbaJoinTabWinData::SbaJoinTabWinData( const String& strDatabaseName, const String& rTableName, const String& rWinName )
	:m_strDatabaseName(strDatabaseName)
	,aTableName( rTableName )
	,aWinName( rWinName )
	,aPosition( Point(-1,-1) )
	,aSize( Size(-1,-1) )
	,bShowAll( TRUE )
{
	DBG_CTOR(SbaJoinTabWinData,NULL);
	if( !aWinName.Len() )
		aWinName = aTableName;
}

//------------------------------------------------------------------------------
SbaJoinTabWinData::~SbaJoinTabWinData()
{
	DBG_DTOR(SbaJoinTabWinData,NULL);
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinData::HasPosition() const
{
	return ( (aPosition.X()==-1) && (aPosition.Y()==-1) );
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinData::HasSize() const
{
	return ( (aSize.Width()==-1) && (aSize.Height()==-1) );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinData::Load( SvStream& rStream )
{
	ByteString aTmp;
	rStream >> aTmp;
	aTableName.AssignAscii(aTmp.GetBuffer());
	rStream >> aTmp;
	aWinName.AssignAscii(aTmp.GetBuffer());
	rStream >> aPosition;
	rStream >> aSize;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinData::Save( SvStream& rStream )
{
	rStream << ByteString(aTableName,gsl_getSystemTextEncoding());
	rStream << ByteString(aWinName,gsl_getSystemTextEncoding());
	rStream << aPosition;
	rStream << aSize;
}

//========================================================================
// class SbaJoinTabWin
//========================================================================
DBG_NAME(SbaJoinTabWin);
//------------------------------------------------------------------------------
SbaJoinTabWin::SbaJoinTabWin( Window* pParent, SbaJoinTabWinData* pTabWinData )
		  :Window( pParent, WB_3DLOOK|WB_MOVEABLE )
		  ,aTitle( this )
		  ,nSizingFlags( SIZING_NONE )
		  ,bActive( FALSE )
		  ,pListBox(NULL)
{
	DBG_CTOR(SbaJoinTabWin,NULL);
	// ich uebernehme nicht die Verantwortung fuer die Daten, ich merke mir nur den Zeiger darauf
	pData = pTabWinData;

	// Position und Groesse bestimmen
	if( GetData()->HasPosition() )
		SetPosPixel( GetData()->GetPosition() );

	if( GetData()->HasSize() )
		SetSizePixel( GetData()->GetSize() );

	// Hintergrund setzen
	StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
	SetBackground(Wallpaper(Color(aSystemStyle.GetFaceColor())));
	// und Textfarbe (obwohl ich eigentlich keinen Text habe, aber wer weiss, was
	// abgeleitete Klassen machen)
	SetTextColor(aSystemStyle.GetButtonTextColor());

	EnableClipSiblings();
}

//------------------------------------------------------------------------------
SbaJoinTabWin::~SbaJoinTabWin()
{
	UnlockTable();
	if (pListBox)
	{
		EmptyListBox();
		delete pListBox;
	}
	DBG_DTOR(SbaJoinTabWin,NULL);
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::SetPosPixel( const Point& rNewPos )
{
	SbaJoinTabWinCont* pTabWinCont = (SbaJoinTabWinCont*)GetParent();
	Point aNewPosData = rNewPos+pTabWinCont->GetScrollOffset();
	GetData()->SetPosition( aNewPosData );
	Window::SetPosPixel( rNewPos );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::SetSizePixel( const Size& rNewSize )
{
	GetData()->SetSize( rNewSize );
	Window::SetSizePixel( rNewSize );
}
//------------------------------------------------------------------------------
void SbaJoinTabWin::SetPosSizePixel( const Point& rNewPos, const Size& rNewSize )
{
	SetPosPixel( rNewPos );
	SetSizePixel( rNewSize );
}

//------------------------------------------------------------------------------
SbaJoinTabWinListBox* SbaJoinTabWin::CreateListBox()
{
	return new SbaJoinTabWinListBox(this, GetDatabaseName(), GetTableName());
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWin::FillListBox()
{
	// die Datenbank ...

	SdbTable* pTable = m_xTableDef->GetTable();
	// und jetzt durch alle Spalten ...
	ImageList aImageList(SbaResId(IMG_JOINS));
	Image aPrimKeyImage = aImageList.GetImage(IMG_PRIMARY_KEY);
	SbaColumn* pColumn = NULL;
	xColumnList = (SbaColumnList*)&m_xTableDef->GetOriginalColumns();

	if (GetData()->IsShowAll())
		pListBox->InsertEntry( String::CreateFromAscii("*") );

	for (ULONG i=0; i<xColumnList->Count(); ++i)
	{
		// die aktuelle Spalte
		pColumn = xColumnList->GetObject(i);

		// don't show version columns
		// FS - 01.10.99 - 68386
		SFX_ITEMSET_GET(*pColumn, pFlags, SfxUInt16Item, SBA_DEF_FLTSEARCH, TRUE);
		if (pFlags && (pFlags->GetValue() & SDB_FLAGS_VERSIONING))
			continue;

		// der Name und die PrimKey-Eigenschaft
		SFX_ITEMSET_GET(*pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
		SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);

		// der eigentliche Eintrag
		if (pPrimary->GetValue())
			pListBox->InsertEntry(pName->GetValue(), aPrimKeyImage, aPrimKeyImage);
		else
			pListBox->InsertEntry(pName->GetValue());
	}

	return TRUE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::EmptyListBox()
{
	// da ich defaultmaessig keine USerData an die Items haenge, kann ich hier einfach loeschen
	SvLBoxEntry* pEntry = pListBox->First();

	while(pEntry)
	{
		SvLBoxEntry* pNextEntry = pListBox->Next(pEntry);
		pListBox->GetModel()->Remove(pEntry);
		pEntry = pNextEntry;
	}
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWin::Init()
{
	// Init wird beim (u.U. initialien) Umschalten auf eine andere Tabelle aufgerufen, also muss ich mein m_xTableDef anpassen
	// die Datenbank ...
	SbaJoinTabWinCont* pParent = (SbaJoinTabWinCont*)GetParent();
	DBG_ASSERT(pParent->ISA(SbaJoinTabWinCont), "SbaJoinTabWin darf nur als (direktes) Child einer SbaJoinTabWinCont-Instanz verwendet werden !");
	SbaDatabaseRef xDatabase = pParent->GetDatabase();
	if (!xDatabase.Is())
		return FALSE;
	// die alte Tabelle unlocken
	UnlockTable();
	// die neue anlegen ...
	m_xTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, GetTableName(), FALSE);
	if (!m_xTableDef.Is())
		return FALSE;
	// ... und locken
	LockTable();

	// ListBox anlegen, wenn notwendig
	if (!pListBox)
	{
		pListBox = CreateListBox();
		DBG_ASSERT(pListBox != NULL, "SbaJoinTabWin::Init() : CreateListBox hat NULL geliefert !");
		pListBox->SetSelectionMode(MULTIPLE_SELECTION);
	}

	// Titel setzen
	aTitle.SetText( pData->GetWinName() );
	aTitle.Show();

	pListBox->Show();

	// die Felder in die ListBox eintragen
	EmptyListBox();
	if (!FillListBox())
		return FALSE;
	pListBox->SelectAll(FALSE);
	return TRUE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::DataChanged(const DataChangedEvent& rDCEvt)
{
	if (rDCEvt.GetType() == DATACHANGED_SETTINGS)
	{
		// nehmen wir den worst-case an : die Farben haben sich geaendert, also
		// mich anpassen
		StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
		SetBackground(Wallpaper(Color(aSystemStyle.GetFaceColor())));
		SetTextColor(aSystemStyle.GetButtonTextColor());
	}
}

//------------------------------------------------------------------------------
SbaJoinDocShExt* SbaJoinTabWin::GetDocShell()
{
	return ( (SbaJoinTabWinCont*)GetParent() )->GetDocShell();
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::Paint( const Rectangle& rRect )
{
	Rectangle aRect( Point(0,0), GetOutputSizePixel() );
	Window::Paint( rRect );
	Draw3DBorder( aRect );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::SetTitle( const String& rTit )
{
	aTitle.SetText( rTit );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::Draw3DBorder(const Rectangle& rRect)
{
	// die Style-Settings des Systems fuer meine Farben
	StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();

	// Schwarze Linie unten und rechts
	SetLineColor(aSystemStyle.GetDarkShadowColor());
	DrawLine( rRect.BottomLeft(), rRect.BottomRight() );
	DrawLine( rRect.BottomRight(), rRect.TopRight() );

	// Dunkelgraue Linie ueber der schwarzen
	SetLineColor(aSystemStyle.GetShadowColor());
	DrawLine( rRect.BottomLeft()+Point(1,-1), rRect.BottomRight()-Point(1,1) );
	DrawLine( rRect.BottomRight()-Point(1,1), rRect.TopRight()+Point(-1,1) );

	// Hellgraue Linie links und oben
	SetLineColor(aSystemStyle.GetLightColor());
	DrawLine( rRect.BottomLeft()+Point(1,-2), rRect.TopLeft()+Point(1,1) );
	DrawLine( rRect.TopLeft()+Point(1,1), rRect.TopRight()+Point(-2,1) );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::MouseMove( const MouseEvent& rEvt )
{
	Window::MouseMove(rEvt);

	SbaJoinTabWinCont* pCont = (SbaJoinTabWinCont*)GetParent();
	if (pCont->IsReadOnly())
		return;

	Point	aPos = rEvt.GetPosPixel();
	Size	aOutSize = GetOutputSizePixel();
	Pointer	aPointer;

	//////////////////////////////////////////////////////////////////////
	// Flags anpassen, wenn Mauszeiger in sizingArea
	nSizingFlags = SIZING_NONE;

	if( aPos.X() < TABWIN_SIZING_AREA )
		nSizingFlags |= SIZING_LEFT;

	if( aPos.Y() < TABWIN_SIZING_AREA )
		nSizingFlags |= SIZING_TOP;

	if( aPos.X() > aOutSize.Width()-TABWIN_SIZING_AREA )
		nSizingFlags |= SIZING_RIGHT;

	if( aPos.Y() > aOutSize.Height()-TABWIN_SIZING_AREA )
		nSizingFlags |= SIZING_BOTTOM;

	//////////////////////////////////////////////////////////////////////
	// Mauszeiger anpassen, wenn Mauszeiger in sizingArea
	switch( nSizingFlags )
	{
	case SIZING_TOP:
	case SIZING_BOTTOM:
		aPointer = Pointer( POINTER_SSIZE );
		break;

	case SIZING_LEFT:
	case SIZING_RIGHT:
		aPointer = Pointer( POINTER_ESIZE );
		break;

	case SIZING_LEFT+SIZING_TOP:
	case SIZING_RIGHT+SIZING_BOTTOM:
		aPointer = Pointer( POINTER_SESIZE );
		break;

	case SIZING_RIGHT+SIZING_TOP:
	case SIZING_LEFT+SIZING_BOTTOM:
		aPointer = Pointer( POINTER_NESIZE );
		break;
	}

	SetPointer( aPointer );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::MouseButtonDown( const MouseEvent& rEvt )
{
	//////////////////////////////////////////////////////////////////////
	// Wenn sizing, dann bekommt Parent die Nachricht,
	// dass jetzt die Fenstergroesse seines Childs veraendert wird
	if( nSizingFlags )
		((SbaJoinTabWinCont*)GetParent())->BeginChildSizing( this, GetPointer() );

	Window::MouseButtonDown( rEvt );
}



//------------------------------------------------------------------------------
void SbaJoinTabWin::Resize()
{
	//////////////////////////////////////////////////////////////////////
	// Modify Flag des Documents nicht beim ersten Resize setzen
	if( IsVisible() )
	{
		SbaJoinTabWinCont* pTabWinCont = (SbaJoinTabWinCont*)GetParent();
//		pTabWinCont->GetViewShell()->GetShell->SetModified( TRUE );
	}

	//////////////////////////////////////////////////////////////////////
	// Das Fenster darf nicht verschwinden, deshalb min. Groesse setzen
	Size	aOutSize = GetOutputSizePixel();
	Point	aPos = GetPosPixel();

	if( aOutSize.Width() < TABWIN_WIDTH_MIN )
		aOutSize.Width() = TABWIN_WIDTH_MIN;
	if( aOutSize.Height() < TABWIN_HEIGHT_MIN )
		aOutSize.Height() = TABWIN_HEIGHT_MIN;

	SetPosSizePixel( aPos, aOutSize );
	pData->SetSize( aOutSize );

	//////////////////////////////////////////////////////////////////////
	// Titel und ListBox anpassen
	long nCharHeight = GetTextHeight() + 4;
	aTitle.SetPosSizePixel( Point(5,5), Size( aOutSize.Width()-10, nCharHeight) );
	pListBox->SetPosSizePixel( Point(5,nCharHeight+5), Size(aOutSize.Width()-10,aOutSize.Height()-nCharHeight-10) );

	Window::Invalidate();
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::SetBoldTitle( BOOL bBold )
{
	Font aFont = aTitle.GetFont();
	aFont.SetWeight( bBold?WEIGHT_BOLD:WEIGHT_NORMAL );
	aTitle.SetFont( aFont );
	aTitle.Invalidate();
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::GetFocus()
{
	SetBoldTitle( TRUE );
	bActive = TRUE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::LoseFocus()
{
	SetBoldTitle( FALSE );
	bActive = FALSE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::Remove()
{
	//////////////////////////////////////////////////////////////////
	// Fenster loeschen
	SbaJoinTabWinCont* pTabWinCont = (SbaJoinTabWinCont*)GetParent();
	pTabWinCont->RemoveTabWin( this );
	pTabWinCont->Invalidate();
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::KeyInput( const KeyEvent& rEvt )
{
	USHORT nCode = rEvt.GetKeyCode().GetCode();
	BOOL   bShift = rEvt.GetKeyCode().IsShift();
	BOOL   bCtrl = rEvt.GetKeyCode().IsMod1();

	if( !bCtrl && !bShift && (nCode==KEY_DELETE) )
	{
		Remove();
	}
	else
		Window::KeyInput( rEvt );
}

//------------------------------------------------------------------------------
void SbaJoinTabWin::InvalidateLines()
{
	((SbaJoinTabWinCont*)GetParent())->InvalidateConnections();
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWin::ExistsAConn() const
{
	return ((SbaJoinTabWinCont*)GetParent())->ExistsAConn(this);
}
//------------------------------------------------------------------------------
void SbaJoinTabWin::EnumValidFields(SvStringsDtor& arrstrFields)
{
	arrstrFields.Remove(0, arrstrFields.Count());
	// diese Default-Implementierung zaehlt einfach alles auf, was es in der ListBox gibt ... fuer anderes Verhalten ueberschreiben
	if (!pListBox)
		return;

	SvLBoxEntry* pEntryLoop = pListBox->First();
	while (pEntryLoop)
	{
		arrstrFields.Insert(new String(pListBox->GetEntryText(pEntryLoop)), arrstrFields.Count());
		pEntryLoop = pListBox->Next(pEntryLoop);
	}
}

//==================================================================
// class SbaJoinTabWinListBox
//==================================================================
DBG_NAME(SbaJoinTabWinListBox);
//------------------------------------------------------------------------------
SbaJoinTabWinListBox::SbaJoinTabWinListBox( SbaJoinTabWin* pParent, const String& rDatabaseName, const String& rTableName ) :
	 SvTreeListBox( pParent, WB_HASBUTTONS | WB_BORDER)
	,pTabWin( pParent )
	,aMousePos( Point(0,0) )
	,bDragSource( FALSE )
	,m_bReallyScrolled( FALSE )
{
	DBG_CTOR(SbaJoinTabWinListBox,NULL);
	EnableDrop();
	aScrollTimer.SetTimeout( SCROLLING_TIMESPAN );
	SetDoubleClickHdl( LINK(this, SbaJoinTabWinListBox, DoubleClickHdl) );
}

//------------------------------------------------------------------------------
SbaJoinTabWinListBox::~SbaJoinTabWinListBox()
{
	if( aScrollTimer.IsActive() )
		aScrollTimer.Stop();
	DBG_DTOR(SbaJoinTabWinListBox,NULL);
}

//------------------------------------------------------------------------------
SvLBoxEntry* SbaJoinTabWinListBox::GetEntryFromText( const String& rEntryText )
{
	//////////////////////////////////////////////////////////////////////
	// Liste durchiterieren
	SvTreeList* pTreeList = GetModel();
	SvLBoxEntry* pEntry = (SvLBoxEntry*)pTreeList->First();
	BOOL bCase = (pTabWin->GetDocShell()->GetJoinDocDatabase()->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	while( pEntry )
	{
		if((bCase ? rEntryText == GetEntryText(pEntry) : rEntryText.EqualsIgnoreCaseAscii(GetEntryText(pEntry))))
			return pEntry;
		pEntry = (SvLBoxEntry*)pTreeList->Next( pEntry );
	}

	return NULL;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinListBox::NotifyScrolled()
{
	m_bReallyScrolled = TRUE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinListBox::NotifyEndScroll()
{
	if (m_bReallyScrolled)
		// die Verbindungen, die diese Tabelle eventuell hat, muessen neu gezeichnet werden
		( (SbaJoinTabWinCont*)pTabWin->GetParent() )->Invalidate(INVALIDATE_NOCHILDREN);
		// ohne das INVALIDATE_NOCHILDREN wuerden auch alle Tabellen neu gezeichnet werden,
		// sprich : es flackert
	m_bReallyScrolled = FALSE;
}

//------------------------------------------------------------------------------
long SbaJoinTabWinListBox::PreNotify(NotifyEvent& rNEvt)
{
	BOOL bHandled = FALSE;
	switch (rNEvt.GetType())
	{
		case EVENT_KEYINPUT:
		{
			const KeyEvent* pKeyEvent =	rNEvt.GetKeyEvent();
			const KeyCode& rCode = pKeyEvent->GetKeyCode();
			if (rCode.IsMod1() || rCode.IsMod2() || rCode.IsShift())
				break;
			if (rCode.GetCode() != KEY_RETURN)
				break;

			if (FirstSelected())
				static_cast<SbaJoinTabWin*>(Window::GetParent())->OnEntryDoubleClicked(FirstSelected());
		}
		break;
	}

	if (!bHandled)
		return SvTreeListBox::PreNotify(rNEvt);
	return 0;
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinListBox::QueryDrop( DropEvent& rDEvt )
{
	// nur das richtige Format akzeptieren
	SvDataObjectRef xDataObj = SvDataObject::PasteDragServer( rDEvt );
	const SvDataTypeList& rTypeList = xDataObj->GetTypeList();
	if (!rTypeList.Get(Exchange::RegisterFormatName(String::CreateFromAscii(SBA_JOIN_EXCHANGE_FORMAT ))))
		return FALSE;

	// nicht ins gleiche Fenster droppen
	if (bDragSource)
		return FALSE;

	// wenn ich rausgehe, nehme ich meine Selektion weg
	if (rDEvt.IsLeaveWindow())
	{
		SelectAll(FALSE);
		return FALSE;
	}

	// Wenn der erste Eintrag der Quelle (*) gedraggt wird, lehne ich grundsaetzlich ab
	SbaJoinExchangeData jxdSource = ((SbaJoinExchObj*)&xDataObj)->GetSourceDescription();
	if (jxdSource.pListBox->GetTabWin()->GetData()->IsShowAll() && (jxdSource.pListBox->First() == jxdSource.pEntry))
		return FALSE;

	aMousePos = rDEvt.GetPosPixel();
	Size aOutputSize = GetOutputSizePixel();
	SvLBoxEntry* pEntry = GetEntry( aMousePos );
	if( !pEntry )
		return FALSE;

	// Scrolling Areas
	Rectangle aBottomScrollArea( Point(0, aOutputSize.Height()-LISTBOX_SCROLLING_AREA),
								 Size(aOutputSize.Width(), LISTBOX_SCROLLING_AREA) );
	Rectangle aTopScrollArea( Point(0,0), Size(aOutputSize.Width(), LISTBOX_SCROLLING_AREA) );

	// Wenn Zeiger auf der oberen ScrollingArea steht, nach oben scrollen
	if( aBottomScrollArea.IsInside(aMousePos) )
	{
		if( !aScrollTimer.IsActive() )
		{
			aScrollTimer.SetTimeoutHdl( LINK(this, SbaJoinTabWinListBox, ScrollUpHdl) );
			ScrollUpHdl( this );
		}
	}

	// Wenn Zeiger auf der oberen ScrollingArea steht, nach unten scrollen
	else if( aTopScrollArea.IsInside(aMousePos) )
	{
		if( !aScrollTimer.IsActive() )
		{
			aScrollTimer.SetTimeoutHdl( LINK(this, SbaJoinTabWinListBox, ScrollDownHdl) );
			ScrollDownHdl( this );
		}
	}
	else
	{
		if( aScrollTimer.IsActive() )
			aScrollTimer.Stop();
	}

	// Beim Drag automatisch den richtigen Eintrag selektieren
	if ((FirstSelected() != pEntry) || (FirstSelected() && NextSelected(FirstSelected())))
		SelectAll(FALSE);
	Select(pEntry, TRUE);

	// Auf den ersten Eintrag (*) kann nicht gedroppt werden
	if( pTabWin->GetData()->IsShowAll() && (pEntry==First()) )
		return FALSE;

	return TRUE;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaJoinTabWinListBox, ScrollUpHdl, SvTreeListBox*, pBox )
{
	SvLBoxEntry* pEntry = GetEntry( aMousePos );
	if( !pEntry )
		return 0;

	if( pEntry != Last() )
	{
		ScrollOutputArea( -1 );
		pEntry = GetEntry( aMousePos );
		Select( pEntry, TRUE );
//		aScrollTimer.Start();
	}

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaJoinTabWinListBox, ScrollDownHdl, SvTreeListBox*, pBox )
{
	SvLBoxEntry* pEntry = GetEntry( aMousePos );
	if( !pEntry )
		return 0;

	if( pEntry != Last() )
	{
		ScrollOutputArea( 1 );
		pEntry = GetEntry( aMousePos );
		Select( pEntry, TRUE );
//		aScrollTimer.Start();
	}

	return 0;
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinListBox::Drop( const DropEvent& rDEvt )
{
	// Hat das Object das richtige Format?
	SvDataObjectRef xDataObj = SvDataObject::PasteDragServer( rDEvt );

	const SvDataTypeList& rTypeList = xDataObj->GetTypeList();
	if( !rTypeList.Get(Exchange::RegisterFormatName(String::CreateFromAscii(SBA_JOIN_EXCHANGE_FORMAT))) )
		return FALSE;

	// die Beschreibung des Ziels
	SbaJoinExchangeData jxdDest(this);
	// die Quelle
	SbaJoinExchangeData jxdSource = ((SbaJoinExchObj*)&xDataObj)->GetSourceDescription();
	// Verbindung anlegen
	Window* pParent = GetTabWin()->GetParent();
	((SbaJoinTabWinCont*)pParent)->AddConnection(jxdSource, jxdDest);

	return TRUE;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinListBox::Command(const CommandEvent& rEvt)
{
	switch (rEvt.GetCommand())
	{
		case COMMAND_STARTDRAG:
		{
			SbaJoinTabWinCont* pCont = (SbaJoinTabWinCont*)pTabWin->GetParent();
			if (!pCont->IsReadOnly())
			{
				EndSelection();

				Pointer aMovePtr( POINTER_COPYDATA ),
						aCopyPtr( POINTER_COPYDATA ),
						aLinkPtr( POINTER_LINKDATA );

				// eine Beschreibung der Source
				SbaJoinExchangeData jxdSource(this);
				// in ein Exchange-Objekt packen
				SbaJoinExchObjRef xJoin = new SbaJoinExchObj(jxdSource);
				// und losschicken
				bDragSource = TRUE;
				xJoin->ExecuteDrag( this, aMovePtr, aCopyPtr, aLinkPtr, DRAG_MOVEABLE );
				bDragSource = FALSE;
			}
		}	break;
		default:
			Window::Command( rEvt );
	}
}



//------------------------------------------------------------------------------
void SbaJoinTabWinListBox::LoseFocus()
{
	pTabWin->LoseFocus();
	SvTreeListBox::LoseFocus();
}

//------------------------------------------------------------------------------
void SbaJoinTabWinListBox::GetFocus()
{
	pTabWin->GetFocus();
	SvTreeListBox::GetFocus();
	if (GetCurEntry() != NULL)
		if (GetSelectionCount() == 0)
			Select(GetCurEntry(), TRUE);
		else
			ShowFocusRect(FirstSelected());
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaJoinTabWinListBox, DoubleClickHdl, SvTreeListBox *, pBox )
{
	// meinem Elter Bescheid sagen
	Window* pParent = Window::GetParent();
	DBG_ASSERT(pParent != NULL, "SbaJoinTabWinListBox::DoubleClickHdl : habe kein Parent !");

	((SbaJoinTabWin*)pParent)->OnEntryDoubleClicked(GetHdlEntry());

	return 0;
}


//==================================================================
// class SbaJoinTabWinTitle
//==================================================================
DBG_NAME(SbaJoinTabWinTitle);
//------------------------------------------------------------------------------
SbaJoinTabWinTitle::SbaJoinTabWinTitle( SbaJoinTabWin* pParent ) :
	 Control( pParent, WB_3DLOOK )
	,pTabWin( pParent )
{
	DBG_CTOR(SbaJoinTabWinTitle,NULL);
	// Hintergrund- und Textfarbe setzen
	StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
	SetBackground(Wallpaper(Color(aSystemStyle.GetFaceColor())));
	SetTextColor(aSystemStyle.GetButtonTextColor());

	Font aFont( GetFont() );
	aFont.SetTransparent( TRUE );
	SetFont( aFont );
}

//------------------------------------------------------------------------------
SbaJoinTabWinTitle::~SbaJoinTabWinTitle()
{
	DBG_DTOR(SbaJoinTabWinTitle,NULL);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::GetFocus()
{
	pTabWin->GetFocus();
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::LoseFocus()
{
	pTabWin->LoseFocus();
}
//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::RequestHelp( const HelpEvent& rHEvt )
{
	SbaTableDefRef aTableRef(pTabWin->GetTableDef());
	if(aTableRef.Is())
	{
		String aHelpText = aTableRef->Name();
		if( aHelpText.Len())
		{
			// Hilfe anzeigen
			Rectangle aItemRect(Point(0,0),GetSizePixel());
			aItemRect = LogicToPixel( aItemRect );
			Point aPt = OutputToScreenPixel( aItemRect.TopLeft() );
			aItemRect.Left()   = aPt.X();
			aItemRect.Top()    = aPt.Y();
			aPt = OutputToScreenPixel( aItemRect.BottomRight() );
			aItemRect.Right()  = aPt.X();
			aItemRect.Bottom() = aPt.Y();
			if( rHEvt.GetMode() == HELPMODE_BALLOON )
				Help::ShowBalloon( this, aItemRect.Center(), aItemRect, aHelpText);
			else
				Help::ShowQuickHelp( this, aItemRect, aHelpText );
		}
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::Command( const CommandEvent& rEvt )
{
	if( !pTabWin->IsActive() )
		return;

	switch( rEvt.GetCommand() )
	{
		case COMMAND_CONTEXTMENU:
		{
			SbaJoinTabWinCont* pCont = (SbaJoinTabWinCont*)pTabWin->GetParent();
			if (!pCont->IsReadOnly())
			{
				Point aPoint = rEvt.GetMousePosPixel();
				PopupMenu aContextMenu( SbaResId(RID_QUERYCOLPOPUPMENU) );
				switch (aContextMenu.Execute(this, aPoint))
				{
				case SID_DELETE:
					pTabWin->Remove();

					break;
				default:
					Control::Command(rEvt);
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::Paint( const Rectangle& rRect )
{
	//////////////////////////////////////////////////////////////////////
	// Ausgabe des Textes in der Titelzeile
	Rectangle aWinRect( Point(0,0), GetSizePixel() );
	DrawText( aWinRect, GetText(), TEXT_DRAW_CENTER|TEXT_DRAW_VCENTER|TEXT_DRAW_ENDELLIPSIS );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::KeyInput( const KeyEvent& rEvt )
{
	pTabWin->KeyInput( rEvt );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::MouseButtonDown( const MouseEvent& rEvt )
{
	if( rEvt.IsLeft() )
	{
		if(	rEvt.GetClicks() == 2)
		{
			Size aSize(GetTextWidth(GetText()) + 20,
						pTabWin->GetSizePixel().Height() - pTabWin->GetListBox()->GetSizePixel().Height());

			aSize.Height() += (pTabWin->GetListBox()->GetEntryCount() + 2) * pTabWin->GetListBox()->GetEntryHeight();
			pTabWin->SetSizePixel(aSize);
			SbaJoinTabWinCont* pTabWinCont = (SbaJoinTabWinCont*)GetParent()->GetParent();
			SbaJoinTabConn* pFirst = pTabWinCont->GetTabConnList()->First();

			while(pFirst)
			{
				pFirst->RecalcLines();
				pFirst = pTabWinCont->GetTabConnList()->Next();
			}
			pTabWinCont->InvalidateConnections();
		}
		else
		{
			Point aPos = rEvt.GetPosPixel();
			aPos = OutputToScreenPixel( aPos );
			SbaJoinTabWinCont* pTabWinCont = (SbaJoinTabWinCont*)GetParent()->GetParent();
			pTabWinCont->NotifyTitleClicked( (SbaJoinTabWin*)GetParent(), aPos );
		}
		GrabFocus();
	}
	else
		Control::MouseButtonDown( rEvt );
}


//------------------------------------------------------------------------------
void SbaJoinTabWinTitle::DataChanged(const DataChangedEvent& rDCEvt)
{
	if (rDCEvt.GetType() == DATACHANGED_SETTINGS)
	{
		// nehmen wir den worst-case an : die Farben haben sich geaendert, also
		// mich anpassen
		StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
		SetBackground(Wallpaper(Color(aSystemStyle.GetFaceColor())));
		SetTextColor(aSystemStyle.GetButtonTextColor());
	}
}




