/*************************************************************************
 *
 *  $RCSfile: twcont.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif

#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _URLBMK_HXX //autogen
#include <svtools/urlbmk.hxx>
#endif

#ifndef _SV_DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _SV_PTRSTYLE_HXX
#include <vcl/ptrstyle.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef _SBA_TABCONN_HXX
#include "tabconn.hxx"
#endif
#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SVX_ADTABDLG_HXX
#include "adtabdlg.hxx"
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif
#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

TYPEINIT0(SbaJoinTabWinCont);

//==================================================================
// SbaJoinFrameWindow
//==================================================================
DBG_NAME(SbaJoinFrameWindow);
//------------------------------------------------------------------------------
SbaJoinFrameWindow::SbaJoinFrameWindow( Window* pParent, SbaJoinViewShExt* pView )
	:Window( pParent )
	,aHScrollBar( this, WB_HSCROLL|WB_REPEAT|WB_DRAG )
	,aVScrollBar( this, WB_VSCROLL|WB_REPEAT|WB_DRAG )
	,m_bReadOnly(FALSE)
{
	DBG_CTOR(SbaJoinFrameWindow,NULL);
	aHScrollBar.SetScrollHdl( LINK(this, SbaJoinFrameWindow, ScrollHdl) );
	aVScrollBar.SetScrollHdl( LINK(this, SbaJoinFrameWindow, ScrollHdl) );
}

//------------------------------------------------------------------------------
SbaJoinFrameWindow::~SbaJoinFrameWindow()
{
	DBG_DTOR(SbaJoinFrameWindow,NULL);
	pTabWinCont->Hide();
	delete pTabWinCont;
}

//------------------------------------------------------------------------------
void SbaJoinFrameWindow::SetReadOnly(BOOL bRO)
{
	m_bReadOnly = bRO;
	GetTabWinCont()->GetDocShell()->GetObjectShell()->SetReadOnlyUI( bRO );
}

//------------------------------------------------------------------------------
void SbaJoinFrameWindow::Resize()
{
	DBG_CHKTHIS(SbaJoinFrameWindow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Position und Groesse der ScrollBars setzen
	Size aTotalOutputSize = GetOutputSizePixel();
	long nHScrollHeight = aHScrollBar.GetSizePixel().Height();
	long nVScrollWidth = aVScrollBar.GetSizePixel().Width();

	aHScrollBar.SetPosSizePixel(
		Point( 0, aTotalOutputSize.Height()-nHScrollHeight ),
		Size( aTotalOutputSize.Width()-nVScrollWidth, nHScrollHeight )
		);

	aVScrollBar.SetPosSizePixel(
		Point( aTotalOutputSize.Width()-nVScrollWidth, 0 ),
		Size( nVScrollWidth, aTotalOutputSize.Height()-nHScrollHeight )
		);

	//////////////////////////////////////////////////////////////////////
	// Output ohne ScrollBars
	Size aTabWinContSize = aTotalOutputSize;
	aTabWinContSize.Width() -= nVScrollWidth;
	aTabWinContSize.Height() -= nHScrollHeight;
	pTabWinCont->SetPosSizePixel( Point(0,0), aTabWinContSize );
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaJoinFrameWindow, ScrollHdl, ScrollBar*, pScrollBar )
{
	DBG_CHKTHIS(SbaJoinFrameWindow,NULL);
	//////////////////////////////////////////////////////////////////////
	// Alle Fenster verschieben
	pTabWinCont->Scroll( pScrollBar->GetDelta(), (pScrollBar==&aHScrollBar), FALSE );

	return 0;
}

//------------------------------------------------------------------------------
void SbaJoinFrameWindow::GetFocus()
{
	Window::GetFocus();

	// forward the focus to the tab win container
	if (pTabWinCont)
		pTabWinCont->GrabTabWinFocus();
}

//==================================================================
// class SbaJoinTabWinCont
//==================================================================

//const long WINDOW_WIDTH = 1000;
//const long WINDOW_HEIGHT = 1000;
const long LINE_SIZE = 50;
DBG_NAME(SbaJoinTabWinCont);
//------------------------------------------------------------------------------
SbaJoinTabWinCont::SbaJoinTabWinCont( Window* pParent, SbaJoinViewShExt* pView ) :
	 Window( pParent )
	,pViewSh( pView )
	,pAddTabDlg( NULL )
	,pDragWin( NULL )
	,pSizingWin( NULL )
	,pSelectedConn( NULL )
	,aDragOffset( Point(0,0) )
	,aScrollOffset( Point(0,0) )
	,m_bTrackingInitiallyMoved(FALSE)
	,m_pLastFocusTabWin(NULL)
{
	DBG_CTOR(SbaJoinTabWinCont,NULL);
	SetSizePixel( Size(1000, 1000) );

	InitColors();

	//////////////////////////////////////////////////////////////////////
	// ScrollBars
	pHScrollBar = ((SbaJoinFrameWindow*)GetParent())->GetHScrollBar();
	pVScrollBar = ((SbaJoinFrameWindow*)GetParent())->GetVScrollBar();

	pHScrollBar->SetRange( Range(0, 1000) );
	pVScrollBar->SetRange( Range(0, 1000) );

	pHScrollBar->SetLineSize( LINE_SIZE );
	pVScrollBar->SetLineSize( LINE_SIZE );

	pHScrollBar->Show();
	pVScrollBar->Show();

	m_aDragScrollTimer.SetTimeoutHdl(LINK(this, SbaJoinTabWinCont, OnDragScrollTimer));
}

//------------------------------------------------------------------------------
SbaJoinTabWinCont::~SbaJoinTabWinCont()
{
	DBG_DTOR(SbaJoinTabWinCont,NULL);
	if( pAddTabDlg )
		delete pAddTabDlg;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::Resize()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	aOutputSize = GetSizePixel();

	Size aSz(GetOutputSizePixel());

	pHScrollBar->SetPageSize( aSz.Width() );
	pHScrollBar->SetVisibleSize( aSz.Width() );

	pVScrollBar->SetPageSize( aSz.Height() );
	pVScrollBar->SetVisibleSize( aSz.Height() );

	// adjust the ranges of the scrollbars if neccessary
	long lRange = pHScrollBar->GetRange().Max() - pHScrollBar->GetRange().Min();
	if (GetScrollOffset().X() + aSz.Width() > lRange)
		pHScrollBar->SetRangeMax(GetScrollOffset().X() + aSz.Width() + pHScrollBar->GetRange().Min());

	lRange = pVScrollBar->GetRange().Max() - pVScrollBar->GetRange().Min();
	if (GetScrollOffset().Y() + aSz.Height() > lRange)
		pVScrollBar->SetRangeMax(GetScrollOffset().Y() + aSz.Height() + pVScrollBar->GetRange().Min());

	// tab win positions may not be up-to-date
	if (!aTabWinMap.Count())
		// no tab wins ...
		return;

	aScrollOffset.X() = pHScrollBar->GetThumbPos();
	aScrollOffset.Y() = pVScrollBar->GetThumbPos();

	SbaJoinTabWin* pCheck = aTabWinMap.GetObject(0);
	Point aRealPos = pCheck->GetPosPixel();
	Point aAssumedPos = pCheck->GetData()->GetPosition() - GetScrollOffset();

	if (aRealPos == aAssumedPos)
		// all ok
		return;

	for (INT32 i=0; i<aTabWinMap.Count(); ++i)
	{
		SbaJoinTabWin* pCurrent = aTabWinMap.GetObject(i);
		pCurrent->SetPosPixel(pCurrent->GetData()->GetPosition() - GetScrollOffset());
	}
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::Drop( const DropEvent& rEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	BOOL bDrop = FALSE;

	//////////////////////////////////////////////////////////////////////
	// Nach dem richtigen Format suchen
	for(USHORT i = 0; i < DragServer::GetItemCount(); ++i)
	{
		if (INetBookmark::DragServerHasFormat(i) )
		{
			INetBookmark aBmk;
			if (aBmk.PasteDragServer(i))
			{
				//////////////////////////////////////////////////////////////////////
				// Tabellenname aus URL-Obj holen
				INetURLObject aObj(aBmk.GetURL());
				aObj.SetSmartProtocol(INET_PROT_FILE);
				String aMark(aObj.GetMark());
				aMark.Erase(0, strlen(SDB_TABLEMARK_HEADER));

				//////////////////////////////////////////////////////////////////////
				// Stammt die Tabelle aus derselben Datenbank?
				String aDatabaseName = aObj.PathToFileName();
				DirEntry aDBEntry(aDatabaseName);
				SbaDatabase* pDatabase = GetDatabase();
				if (aDBEntry == DirEntry(pDatabase->Name()))
				{
					//////////////////////////////////////////////////////////////////////
					// Neue Tabelle hinzufuegen
					SbaDBDefRef xDef = pDatabase->OpenDBDef( dbTable, aMark );
					if (xDef.Is())
					{
						SdbTable* pTable = ((SbaTableDef*)&xDef)->GetTable();
						if (pTable && pTable->IsOpen())
						{
							AddTabWin( pTable->QualifierName(), pTable->Name() );
							bDrop = TRUE;
						}
					}
				}

				if (!bDrop)
					Sound::Beep();
				break;
			}
		}
	}
	return bDrop;
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::QueryDrop( DropEvent& rEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////////
	// Wenn Bookmark-Format, Drop erlaubt
	BOOL bDrop = FALSE;
	DropAction eAction = rEvt.GetAction();

	for (USHORT i = 0; i < DragServer::GetItemCount(); ++i)
	{
		if (INetBookmark::DragServerHasFormat(i) && eAction != DROP_MOVE)
		{
			bDrop = TRUE;
			break;
		}
	}
	return bDrop;
}

//------------------------------------------------------------------------------
ULONG SbaJoinTabWinCont::GetTabWinCount()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	return GetTabWinMap()->Count();
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::AddConnection(const SbaJoinExchangeData& jxdSource, const SbaJoinExchangeData& jxdDest)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::RemoveConnection( SbaJoinTabConn* pConn )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DeselectConn(pConn);

	pConn->Invalidate();
		// damit der Bereich neu gezeichntet wird

	delete GetDocShell()->GetTabConnDataList()->Remove( pConn->GetData() );
	delete GetTabConnList()->Remove( pConn );

	return TRUE;
}

//------------------------------------------------------------------------
SbaJoinTabWin* SbaJoinTabWinCont::GetWindow( const String& rName )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	return GetTabWinMap()->Lookup(rName);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::AddTabWin(const String& strDatabase, const String& rWinName, BOOL bNewTable)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	String aDBName = strDatabase.Len() ? strDatabase : GetDatabase()->Name();
	DBG_ASSERT(aDBName.Len(), "SbaJoinTabWinCont::AddTabWin : habe keine Datenbank !");

	//////////////////////////////////////////////////////////////////
	// Neue Datenstruktur in DocShell eintragen
	SbaJoinTabWinData* pNewTabWinData = new SbaJoinTabWinData( aDBName, rWinName );
	GetDocShell()->GetTabWinDataList()->Insert( pNewTabWinData, LIST_APPEND );

	//////////////////////////////////////////////////////////////////
	// Neues Fenster in Fensterliste eintragen
	SbaJoinTabWin* pNewTabWin = new SbaJoinTabWin( this, pNewTabWinData );
	pNewTabWin->Init();

	GetTabWinMap()->InsertAt(rWinName, pNewTabWin);
	SetDefaultTabWinPosSize( pNewTabWin );
	pNewTabWin->Show();

	GetDocShell()->GetObjectShell()->SetModified( TRUE );
	SFX_BINDINGS().Invalidate(SID_SBA_JOIN_ADDTABLE);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::RemoveTabWin( SbaJoinTabWin* pTabWin )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////////
	// Zuerst alle Connections loeschen, die mit dem Fenster verbunden sind
	String aWinName = pTabWin->GetWinName();
	ULONG nCount = GetTabConnList()->Count();
	SbaJoinTabConn* pTabConn;
	BOOL bRemove = TRUE;
	for( long i=(nCount-1); bRemove && i>-1; i-- )
	{
		pTabConn = GetTabConnList()->GetObject(i);
		if(
			( aWinName == pTabConn->GetData()->GetSourceWinName()) ||
			( aWinName == pTabConn->GetData()->GetDestWinName())
		  )
			bRemove = RemoveConnection( pTabConn );
	}

	//////////////////////////////////////////////////////////////////////
	// Dann Fenster selbst loeschen
	if(bRemove)
	{
		pTabWin->Hide();
		delete GetDocShell()->GetTabWinDataList()->Remove( pTabWin->GetData() );
		delete GetTabWinMap()->Remove( pTabWin );
	}

	if (pTabWin == m_pLastFocusTabWin)
		m_pLastFocusTabWin = NULL;

	if(bRemove && i < (nCount-1)) // if some connections could be removed
	{
		GetDocShell()->GetObjectShell()->SetModified( TRUE );
		SFX_BINDINGS().Invalidate( SID_SAVEDOC );
		SFX_BINDINGS().Invalidate(SID_SBA_JOIN_ADDTABLE);
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::EnsureVisible(const SbaJoinTabWin* _pWin)
{
	// data about the tab win
	SbaJoinTabWinData* pData = _pWin->GetData();
	Point aUpperLeft = pData->GetPosition();
	// normalize with respect to visibility
	aUpperLeft.X() -= GetScrollOffset().X();
	aUpperLeft.Y() -= GetScrollOffset().Y();
	Point aLowerRight(aUpperLeft.X() + pData->GetSize().Width(), aUpperLeft.Y() + pData->GetSize().Height());
	//	aLowerRight.Y() -= GetScrollOffset().Y();

	// data about ourself
	Size aSize = GetOutputSizePixel();

	BOOL bFitsHor = (aUpperLeft.X() >= 0) && (aLowerRight.X() <= aSize.Width());
	BOOL bFitsVert = (aUpperLeft.Y() >= 0) && (aLowerRight.Y() <= aSize.Height());
	if (bFitsHor && bFitsVert)
		// nothing to do
		return;

	long nScrollX(0);
	if (!bFitsHor)
	{
		// ensure the visibility of the right border
		if (aLowerRight.X() > aSize.Width())
			nScrollX = (aLowerRight.X() - aSize.Width() + TABWIN_SPACING_X);

		// ensure the cisibility of the left border (higher priority)
		if (aUpperLeft.X() - nScrollX < 0)
			nScrollX = aUpperLeft.X() - TABWIN_SPACING_X;
	}

	long nScrollY(0);
	if (!bFitsVert)
	{
		// lower border
		if (aLowerRight.Y() > aSize.Height())
			nScrollY = (aLowerRight.Y() - aSize.Height() + TABWIN_SPACING_Y);

		// upper border
		if (aUpperLeft.Y() - nScrollY < 0)
			nScrollY = aUpperLeft.Y() - TABWIN_SPACING_Y;
	}

	if (nScrollX)
		Scroll(nScrollX, TRUE, TRUE);

	if (nScrollY)
		Scroll(nScrollY, FALSE, TRUE);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::SetDefaultTabWinPosSize( SbaJoinTabWin* pTabWin )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////
	// Position bestimmen:
	// Das Fenster wird in Zeilen der Hoehe TABWIN_SPACING_Y+TABWIN_HEIGTH_STD aufgeteilt.
	// Dann wird fuer jede Zeile geprueft, ob noch Platz fuer ein weiteres Fenster ist.
	// Wenn kein Platz ist, wird die naechste Zeile ueberprueft.
	Size aOutSize = GetSizePixel();
	Point aNewPos( 0,0 );
	USHORT nRow = 0;
	BOOL bEnd = FALSE;
	while( !bEnd )
	{
		//////////////////////////////////////////////////////////////////
		// Neue Position auf Zeilenbeginn setzen
		aNewPos.X() = TABWIN_SPACING_X;
		aNewPos.Y() = (nRow+1) * TABWIN_SPACING_Y;

		//////////////////////////////////////////////////////////////////
		// Rectangle fuer die jeweilige Zeile bestimmen
		Rectangle aRowRect( Point(0,0), aOutSize );
		aRowRect.Top() = nRow * ( TABWIN_SPACING_Y + TABWIN_HEIGHT_STD );
		aRowRect.Bottom() = (nRow+1) * ( TABWIN_SPACING_Y + TABWIN_HEIGHT_STD );

		//////////////////////////////////////////////////////////////////
		// Belegte Bereiche dieser Zeile pruefen
		SbaJoinTabWin* pOtherTabWin;// = GetTabWinMap()->First();
		for(ULONG i=0;i<GetTabWinMap()->Count();i++)
		{
			pOtherTabWin = GetTabWinMap()->GetObject(i);
			Rectangle aOtherTabWinRect( pOtherTabWin->GetPosPixel(), pOtherTabWin->GetSizePixel() );

			if(
				( (aOtherTabWinRect.Top()>aRowRect.Top()) && (aOtherTabWinRect.Top()<aRowRect.Bottom()) ) ||
				( (aOtherTabWinRect.Bottom()>aRowRect.Top()) && (aOtherTabWinRect.Bottom()<aRowRect.Bottom()) )
			  )
			{
				//////////////////////////////////////////////////////////////////
				// TabWin liegt in der Zeile
				if( aOtherTabWinRect.Right()>aNewPos.X() )
					aNewPos.X() = aOtherTabWinRect.Right() + TABWIN_SPACING_X;
			}
		}

		//////////////////////////////////////////////////////////////////
		// Ist in dieser Zeile noch Platz?
		if( (aNewPos.X()+TABWIN_WIDTH_STD)<aRowRect.Right() )
		{
			aNewPos.Y() = aRowRect.Top() + TABWIN_SPACING_Y;
			bEnd = TRUE;
		}
		else
		{
			if( (aRowRect.Bottom()+aRowRect.GetHeight()) > aOutSize.Height() )
			{
				//////////////////////////////////////////////////////////////////
				// Letzte Zeile->Fehlermeldung kein Einfuegen moeglich
				bEnd = TRUE;
			}
			else
				nRow++;

		}
	}

	//////////////////////////////////////////////////////////////////
	// Groesse bestimmen
	Size aNewSize( TABWIN_WIDTH_STD, TABWIN_HEIGHT_STD );

//	Rectangle aRect( Point(0,0), aOutSize );
//	if(!aRect.IsInside(aNewPos))
//	{
//		Size aSize(aOutSize );
//		aSize.Height() += TABWIN_HEIGHT_STD;
//		SetSizePixel(aSize);
//		Invalidate();
//	}

	pTabWin->SetPosSizePixel( aNewPos, aNewSize );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::DataChanged(const DataChangedEvent& rDCEvt)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	if (rDCEvt.GetType() == DATACHANGED_SETTINGS)
	{
		// nehmen wir den worst-case an : die Farben haben sich geaendert, also
		// mich anpassen
		InitColors();
		Invalidate(INVALIDATE_NOCHILDREN);
		// durch das Invalidate werden auch die Connections neu gezeichnet, so dass die auch
		// gleich in den neuen Farben dargestellt werden
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::InitColors()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	// die Farben fuer die Darstellung sollten die Systemfarben sein
	StyleSettings aSystemStyle = Application::GetSettings().GetStyleSettings();
	SetBackground(Wallpaper(Color(aSystemStyle.GetWindowColor())));
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::BeginChildMove( SbaJoinTabWin* pTabWin, const Point& rMousePos  )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);

	if (IsReadOnly())
		return;

	pDragWin = pTabWin;
	SetPointer(Pointer(POINTER_MOVE));
	Point aMousePos = ScreenToOutputPixel( rMousePos );
	aDragOffset = aMousePos-pTabWin->GetPosPixel();
	pDragWin->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
	m_bTrackingInitiallyMoved = FALSE;
	StartTracking();
}

void SbaJoinTabWinCont::NotifyTitleClicked( SbaJoinTabWin* pTabWin, const Point rMousePos )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DeselectConn(GetSelectedConn());
	BeginChildMove(pTabWin, rMousePos);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::BeginChildSizing( SbaJoinTabWin* pTabWin, const Pointer& rPointer )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);

	if (IsReadOnly())
		return;

	SetPointer( rPointer );
	pSizingWin = pTabWin;
	StartTracking();
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::Scroll( long nDelta, BOOL bHoriz, BOOL bPaintScrollBars )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	BOOL bRet = TRUE;

	//////////////////////////////////////////////////////////////////////
	// ScrollBar-Positionen anpassen
	if( bPaintScrollBars )
	{
		if( bHoriz )
		{
			long nOldThumbPos = pHScrollBar->GetThumbPos();
			long nNewThumbPos = nOldThumbPos + nDelta;
			if( nNewThumbPos < 0 )
			{
				nNewThumbPos = 0;
				bRet = FALSE;
			}
			if( nNewThumbPos > pHScrollBar->GetRange().Max() )
			{
				nNewThumbPos = pHScrollBar->GetRange().Max();
				bRet = FALSE;
			}
			pHScrollBar->SetThumbPos( nNewThumbPos );
			nDelta = pHScrollBar->GetThumbPos() - nOldThumbPos;
		}
		else
		{
			long nOldThumbPos = pVScrollBar->GetThumbPos();
			long nNewThumbPos = nOldThumbPos+nDelta;
			if( nNewThumbPos < 0 )
			{
				nNewThumbPos = 0;
				bRet = FALSE;
			}
			if( nNewThumbPos > pVScrollBar->GetRange().Max() )
			{
				nNewThumbPos = pVScrollBar->GetRange().Max();
				bRet = FALSE;
			}
			pVScrollBar->SetThumbPos( nNewThumbPos );
			nDelta = pVScrollBar->GetThumbPos() - nOldThumbPos;
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Wenn ScrollOffset bereits an den Grenzen liegt, kein Neuzeichnen
	if( (pHScrollBar->GetThumbPos()==aScrollOffset.X()) &&
		(pVScrollBar->GetThumbPos()==aScrollOffset.Y()) )
		return FALSE;

	//////////////////////////////////////////////////////////////////////
	// ScrollOffset neu setzen
	if (bHoriz)
		aScrollOffset.X() = pHScrollBar->GetThumbPos();
	else
		aScrollOffset.Y() = pVScrollBar->GetThumbPos();

	//////////////////////////////////////////////////////////////////////
	// Alle Fenster verschieben
	SbaJoinTabWin* pTabWin;
	Point aPos;

	for( ULONG i=0; i<aTabWinMap.Count(); i++ )
	{
		pTabWin = aTabWinMap.GetObject( i );
		aPos = pTabWin->GetPosPixel();

		if( bHoriz )
			aPos.X() -= nDelta;
		else aPos.Y() -= nDelta;

		pTabWin->SetPosPixel( aPos );
	}

	Invalidate(INVALIDATE_NOCHILDREN);

	return bRet;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::Tracking( const TrackingEvent& rTEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	HideTracking();

	if (rTEvt.IsTrackingEnded())
	{
		if( pDragWin )
		{
			if (m_aDragScrollTimer.IsActive())
				m_aDragScrollTimer.Stop();

			//////////////////////////////////////////////////////////////////////
			// Position des Childs nach Verschieben anpassen
			//////////////////////////////////////////////////////////////////////
			// Fenster duerfen nicht aus Anzeigebereich herausbewegt werden
			Point aDragWinPos = rTEvt.GetMouseEvent().GetPosPixel() - aDragOffset;
			Size aDragWinSize = pDragWin->GetSizePixel();
			if( aDragWinPos.X() < 0 )
				aDragWinPos.X() = 0;
			if( aDragWinPos.Y() < 0 )
				aDragWinPos.Y() = 0;
			if( (aDragWinPos.X() + aDragWinSize.Width()) > aOutputSize.Width() )
				aDragWinPos.X() = aOutputSize.Width() - aDragWinSize.Width();
			if( (aDragWinPos.Y() + aDragWinSize.Height()) > aOutputSize.Height() )
				aDragWinPos.Y() = aOutputSize.Height() - aDragWinSize.Height();
			if( aDragWinPos.X() < 0 )
				aDragWinPos.X() = 0;
			if( aDragWinPos.Y() < 0 )
				aDragWinPos.Y() = 0;
			// TODO : nicht das Fenster neu positionieren, wenn es uebersteht, sondern einfach meinen Bereich erweitern

			// erst mal testen, ob ich mich ueberhaupt bewegt habe
			// (das verhindert das Setzen des modified-Flags, wenn sich eigentlich gar nichts getan hat)
			SbaJoinTabWinData* pData = pDragWin->GetData();
			if (pData && pData->HasPosition() && (pData->GetPosition() == aDragWinPos))
			{
				EndTracking();
				pDragWin->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
				pDragWin = NULL;
				SetPointer(Pointer(POINTER_ARROW));
				return;
			}

			//////////////////////////////////////////////////////////////////////
			// Fenster positionieren
			EndTracking();
			// die alten logischen Koordinaten
			Point ptOldPos = pDragWin->GetPosPixel() + Point(pHScrollBar->GetThumbPos(), pVScrollBar->GetThumbPos());
			// neu positionieren
			pDragWin->SetPosPixel(aDragWinPos);
			TabWinMoved(pDragWin, ptOldPos);

			Invalidate(INVALIDATE_NOCHILDREN);

			pDragWin->GrabFocus();
			pDragWin = NULL;
			SetPointer(Pointer(POINTER_ARROW));

			GetDocShell()->GetObjectShell()->SetModified( TRUE );
			SFX_BINDINGS().Invalidate( SID_SAVEDOC );
			return;
		}
		//////////////////////////////////////////////////////////////////////
		// Position des Childs nach Sizing anpassen
		if( pSizingWin )
		{
			SetPointer( Pointer() );
			EndTracking();

			// die alten physikalischen Koordinaten

			Size szOld = pSizingWin->GetSizePixel();
			Point ptOld = pSizingWin->GetPosPixel();
			pSizingWin->SetPosSizePixel( aSizingRect.TopLeft(), aSizingRect.GetSize() );
			TabWinSized(pSizingWin, ptOld, szOld);

			pSizingWin->Invalidate( aSizingRect );
			pSizingWin = NULL;

			Invalidate(INVALIDATE_NOCHILDREN);

			GetDocShell()->GetObjectShell()->SetModified( TRUE );
			SFX_BINDINGS().Invalidate( SID_SAVEDOC );
			return;
		}
	}
	else if (rTEvt.IsTrackingCanceled())
	{
		if (m_aDragScrollTimer.IsActive())
			m_aDragScrollTimer.Stop();
		EndTracking();
	}else
	{
		if( pDragWin )
		{
			m_ptPrevDraggingPos = rTEvt.GetMouseEvent().GetPosPixel();
			// an Fenstergrenzen scrollen
			ScrollWhileDragging();
		}

		if( pSizingWin )
		{
			Point aMousePos = rTEvt.GetMouseEvent().GetPosPixel();
			aSizingRect = Rectangle( pSizingWin->GetPosPixel(), pSizingWin->GetSizePixel() );
			UINT16 nSizingFlags = pSizingWin->GetSizingFlags();

			if( nSizingFlags & SIZING_TOP )
			{
				if( aMousePos.Y() < 0 )
					aSizingRect.Top() = 0;
				else
					aSizingRect.Top() = aMousePos.Y();
			}

			if( nSizingFlags & SIZING_BOTTOM )
			{
				if( aMousePos.Y() > aOutputSize.Height() )
					aSizingRect.Bottom() = aOutputSize.Height();
				else
					aSizingRect.Bottom() = aMousePos.Y();
			}


			if( nSizingFlags & SIZING_RIGHT )
			{
				if( aMousePos.X() > aOutputSize.Width() )
					aSizingRect.Right() = aOutputSize.Width();
				else
					aSizingRect.Right() = aMousePos.X();
			}

			if( nSizingFlags & SIZING_LEFT )
			{
				if( aMousePos.X() < 0 )
					aSizingRect.Left() = 0;
				else
					aSizingRect.Left() = aMousePos.X();
			}

			Update();
			ShowTracking( aSizingRect, SHOWTRACK_SMALL | SHOWTRACK_WINDOW );
		}
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::ConnDoubleClicked( SbaJoinTabConn* pConnection )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::MouseButtonDown( const MouseEvent& rEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	GrabFocus();
	Window::MouseButtonDown(rEvt);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::MouseButtonUp( const MouseEvent& rEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	Window::MouseButtonUp(rEvt);
	//////////////////////////////////////////////////////////////////////
	// Wurde eine Connection ausgewaehlt?
	SbaJoinTabConnList* pConnList = GetTabConnList();
	if( !pConnList->Count() )
		return;

	DeselectConn(GetSelectedConn());

	SbaJoinTabConn* pConn = pConnList->First();
	while( pConn )
	{
		if( pConn->CheckHit(rEvt.GetPosPixel()) )
		{
			SelectConn(pConn);

			// Doppelclick
			if( rEvt.GetClicks() == 2 )
				ConnDoubleClicked( pConn );

			break;
		}

		pConn = pConnList->Next();
	}

}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::KeyInput( const KeyEvent& rEvt )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	USHORT nCode = rEvt.GetKeyCode().GetCode();
	BOOL   bShift = rEvt.GetKeyCode().IsShift();
	BOOL   bCtrl = rEvt.GetKeyCode().IsMod1();

	if( !bCtrl && !bShift && (nCode==KEY_DELETE) )
	{
		if (GetSelectedConn())
			RemoveConnection(GetSelectedConn());
	}
	else
		Window::KeyInput( rEvt );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::DeselectConn(SbaJoinTabConn* pConn)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	if (!pConn) return;
	if (!pConn->IsSelected()) return;

	// die zugehoerigen Eitnraege in der ListBox des Tabellenfenster deselektieren
	SbaJoinTabWin* pWin = pConn->GetSourceWin();
	if (pWin && pWin->GetListBox())
		pWin->GetListBox()->SelectAll(FALSE);

	pWin = pConn->GetDestWin();
	if (pWin && pWin->GetListBox())
		pWin->GetListBox()->SelectAll(FALSE);

	pConn->Deselect();
	pSelectedConn = NULL;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::SelectConn(SbaJoinTabConn* pConn)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DeselectConn(GetSelectedConn());

	// die betroffenene Eintraege in den Windows selektieren
	SbaJoinTabWin* pConnSource = pConn->GetSourceWin();
	SbaJoinTabWin* pConnDest = pConn->GetDestWin();
	if (pConnSource && pConnDest)
	{
		SbaJoinTabWinListBox* pSourceBox = pConnSource->GetListBox();
		SbaJoinTabWinListBox* pDestBox = pConnDest->GetListBox();
		if (pSourceBox && pDestBox)
		{
			pSourceBox->SelectAll(FALSE);
			pDestBox->SelectAll(FALSE);

			SvLBoxEntry* pFirstSourceVisible = pSourceBox->GetFirstEntryInView();
			SvLBoxEntry* pFirstDestVisible = pDestBox->GetFirstEntryInView();

			SbaJoinConnLineList* pLines = pConn->GetConnLineList();
			SbaJoinConnLine* pLoop = pLines->Last();
			while (pLoop)
			{
				if (pLoop->IsValid())
				{
					SvLBoxEntry* pSourceEntry = pSourceBox->GetEntryFromText(pLoop->GetData()->GetSourceFieldName());
					if (pSourceEntry)
					{
						pSourceBox->Select(pSourceEntry, TRUE);
						pSourceBox->MakeVisible(pSourceEntry);
					}

					SvLBoxEntry* pDestEntry = pDestBox->GetEntryFromText(pLoop->GetData()->GetDestFieldName());
					if (pDestEntry)
					{
						pDestBox->Select(pDestEntry, TRUE);
						pDestBox->MakeVisible(pDestEntry);
					}
				}

				pLoop = pLines->Prev();
			}

			if ((pFirstSourceVisible != pSourceBox->GetFirstEntryInView())
				|| (pFirstDestVisible != pDestBox->GetFirstEntryInView()))
				// es wurde gescrollt -> neu zeichnen
				Invalidate(INVALIDATE_NOCHILDREN);
		}
	}

	pConn->Select();
	pSelectedConn = pConn;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::CreateAddTabDlg()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::DestroyAddTabDlg()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
}

//------------------------------------------------------------------------------
SbaDatabase* SbaJoinTabWinCont::GetDatabase()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	return GetDocShell()->GetJoinDocDatabase();
}


//------------------------------------------------------------------------------
SbaJoinDocShExt* SbaJoinTabWinCont::GetDocShell()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DBG_ASSERT(pViewSh!=NULL, "SbaJoinTabWinCont::GetDocShell() : habe keine ViewShell !");
	return pViewSh->GetDocShell();
}


//------------------------------------------------------------------------------
SbaJoinViewShExt* SbaJoinTabWinCont::GetViewShell()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	return pViewSh;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::Paint( const Rectangle& rRect )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DrawConnections( rRect );
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::InvalidateConnections()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////////
	// Die Joins zeichnen
	SbaJoinTabConnList* pConnList = GetTabConnList();
	SbaJoinTabConn* pConn;

	if( pConnList )
	{
		for( ULONG i = 0; i < pConnList->Count(); i++ )
		{
			pConn = pConnList->GetObject(i);
			pConn->Invalidate();
		}
	}
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::DrawConnections( const Rectangle& rRect )
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////////
	// Die Joins zeichnen
	SbaJoinTabConnList* pConnList = GetTabConnList();
	SbaJoinTabConn* pConn;

	if( pConnList )
	{
		for( ULONG i=0; i<pConnList->Count(); i++ )
		{
			pConn = pConnList->GetObject(i);
			pConn->Draw( rRect );
		}
	}

	// zum Schluss noch mal die selektierte ueber alle anderen drueber
	if (GetSelectedConn())
		GetSelectedConn()->Draw( rRect );
}


//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::ExistsAConn(const SbaJoinTabWin* pFrom) const
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	SbaJoinTabConnList* pList = ((SbaJoinTabWinCont*)this)->GetTabConnList();
	SbaJoinTabConn*	pEntry = NULL;

	if (pList)
	{
		pEntry = pList->First();

		while (pEntry)
		{
			if (pFrom == pEntry->GetSourceWin() || pFrom == pEntry->GetDestWin())
				break;

			pEntry = pList->Next();
		}
	}

	return (pEntry != NULL);
}

//------------------------------------------------------------------------
void SbaJoinTabWinCont::ClearAll()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	SetUpdateMode(FALSE);
	SbaJoinTabWinMap* pTabWins = GetTabWinMap();
	if (pTabWins)
	{
		SbaJoinTabWin* pEntry;// = pTabWins->First();
		for(ULONG i=0;i< pTabWins->Count();i++)
		{
			pEntry = pTabWins->GetObject(i);
			// die Daten der Tabelle loeschen (das erledigt NICHT der Destructor !)
			SbaJoinTabWinData* pData = pEntry->GetData();
			GetDocShell()->GetTabWinDataList()->Remove(pData);
			delete pData;
			delete pEntry;
		}
		pTabWins->Clear();
	}

	// und das selbe mit den Connections
	SbaJoinTabConnList* pConns = GetTabConnList();
	if (pConns)
	{
		SbaJoinTabConn* pEntry = pConns->First();

		while (pEntry)
		{
			SbaJoinTabConnData* pData = pEntry->GetData();
			GetDocShell()->GetTabConnDataList()->Remove(pData);
			delete pData;
			delete pEntry;
			pEntry = pConns->Next();
		}
		pConns->Clear();

	}

	// scroll to the upper left
	Scroll(-GetScrollOffset().X(), TRUE, TRUE);
	Scroll(-GetScrollOffset().Y(), FALSE, TRUE);
}

//------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::ScrollWhileDragging()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	DBG_ASSERT(pDragWin != NULL, "SbaJoinTabWinCont::ScrollWhileDragging darf nur waehrend Dragging eines Fensters aufgerufen werden !");

	// den Timer schon mal killen
	if (m_aDragScrollTimer.IsActive())
		m_aDragScrollTimer.Stop();

	Point aDragWinPos = m_ptPrevDraggingPos - aDragOffset;
	Size aDragWinSize = pDragWin->GetSizePixel();
	Point aLowerRight(aDragWinPos.X() + aDragWinSize.Width(), aDragWinPos.Y() + aDragWinSize.Height());

	if (!m_bTrackingInitiallyMoved && (aDragWinPos == pDragWin->GetPosPixel()))
		return TRUE;

	// Darstellungsfehler vermeiden (wenn bei aktivem TrackingRect gescrollt wird)
	HideTracking();

	BOOL bScrolling = FALSE;
	BOOL bNeedScrollTimer = FALSE;

	// An Fenstergrenzen scrollen
	// TODO : nur dann abfangen, wenn das Fenster komplett verschwinden wuerde (nicht, solange noch ein Pixel sichtbar ist)
	if( aDragWinPos.X() < 5 )
	{
		bScrolling = Scroll( -LINE_SIZE, TRUE, TRUE );
		if( !bScrolling && (aDragWinPos.X()<0) )
			aDragWinPos.X() = 0;

		// brauche ich weiteres (timergesteuertes) Scrolling ?
		bNeedScrollTimer = bScrolling && (aDragWinPos.X() < 5);
	}

	if( aLowerRight.X() > aOutputSize.Width() - 5 )
	{
		bScrolling = Scroll( LINE_SIZE, TRUE, TRUE ) ;
		if( !bScrolling && ( aLowerRight.X() > aOutputSize.Width() ) )
			aDragWinPos.X() = aOutputSize.Width() - aDragWinSize.Width();

		// brauche ich weiteres (timergesteuertes) Scrolling ?
		bNeedScrollTimer = bScrolling && (aLowerRight.X() > aOutputSize.Width() - 5);
	}

	if( aDragWinPos.Y() < 5 )
	{
		bScrolling = Scroll( -LINE_SIZE, FALSE, TRUE );
		if( !bScrolling && (aDragWinPos.Y()<0) )
			aDragWinPos.Y() = 0;

		bNeedScrollTimer = bScrolling && (aDragWinPos.Y() < 5);
	}

	if( aLowerRight.Y() > aOutputSize.Height() - 5 )
	{
		bScrolling = Scroll( LINE_SIZE, FALSE, TRUE );
		if( !bScrolling && ( (aDragWinPos.Y() + aDragWinSize.Height()) > aOutputSize.Height() ) )
			aDragWinPos.Y() =  aOutputSize.Height() - aDragWinSize.Height();

		bNeedScrollTimer = bScrolling && (aLowerRight.Y() > aOutputSize.Height() - 5);
	}

	// Timer neu setzen, wenn noch notwendig
	if (bNeedScrollTimer)
	{
		m_aDragScrollTimer.SetTimeout(100);
		m_aDragScrollTimer.Start();
	}

	// das DraggingRect neu zeichnen
	aDragRect = Rectangle(m_ptPrevDraggingPos - aDragOffset, pDragWin->GetSizePixel());
	Update();
	ShowTracking( aDragRect, SHOWTRACK_SMALL | SHOWTRACK_WINDOW );

	return bScrolling;
}

//------------------------------------------------------------------------
IMPL_LINK(SbaJoinTabWinCont, OnDragScrollTimer, void*, EMPTYARG)
{
	ScrollWhileDragging();
	return 0L;
}

//------------------------------------------------------------------------
void SbaJoinTabWinCont::TabWinMoved(SbaJoinTabWin* ptWhich, const Point& ptOldPosition)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	Point ptThumbPos(pHScrollBar->GetThumbPos(), pVScrollBar->GetThumbPos());
	ptWhich->GetData()->SetPosition(ptWhich->GetPosPixel() + ptThumbPos);
}

//------------------------------------------------------------------------
void SbaJoinTabWinCont::TabWinSized(SbaJoinTabWin* ptWhich, const Point& ptOldPosition, const Size& szOldSize)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);
	ptWhich->GetData()->SetSize(ptWhich->GetSizePixel());
	ptWhich->GetData()->SetPosition(ptWhich->GetPosPixel());
}

//------------------------------------------------------------------------------
BOOL SbaJoinTabWinCont::IsAddAllowed()
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);

	// nicht wenn Db readonly
	if (IsReadOnly())
		return FALSE;

	// nicht wenn schon zuviele Tabellen
	::com::sun::star::uno::Reference < ::com::sun::star::data::XDatabaseDescriptor >
		rMetaData( GetDatabase()->GetMetaData() );

	sal_Int32 nMax = rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::TABLES_IN_SELECT);
	if (nMax && nMax <= GetTabWinCount())
		return FALSE;

	// nicht wenn keine Joins moeglich
	if (!GetDatabase()->IsCapable(SDB_CAP_JOIN) && nMax <= GetTabWinCount())
		return FALSE;

	return TRUE;
}
//------------------------------------------------------------------------------
void SbaJoinTabWinCont::Command(const CommandEvent& rEvt)
{
	DBG_CHKTHIS(SbaJoinTabWinCont,NULL);

	BOOL bHandled = FALSE;

	switch (rEvt.GetCommand())
	{
		case COMMAND_CONTEXTMENU:
		{
			if (!rEvt.IsMouseEvent())
			{
				Window::Command(rEvt);
				return;
			}

			SbaJoinTabConnList* pConnList = GetTabConnList();
			if( !pConnList->Count() )
				return;
			DeselectConn(GetSelectedConn());
			SbaJoinTabConn* pConn = pConnList->First();
			while( pConn )
			{
				if( pConn->CheckHit(rEvt.GetMousePosPixel()) )
				{
					SelectConn(pConn);

					PopupMenu aContextMenu(SbaResId(RID_QUERYCOLPOPUPMENU));
					switch (aContextMenu.Execute(this, rEvt.GetMousePosPixel()))
					{
						case SID_DELETE:
							RemoveConnection(pConn);
							break;
					}
					break;
				}
				pConn = pConnList->Next();
			}
			bHandled = TRUE;
		}
	}
	if (!bHandled)
		Window::Command(rEvt);
}

//------------------------------------------------------------------------------
SbaJoinTabConn* SbaJoinTabWinCont::GetTabConn(SbaJoinTabWin* pLhs,SbaJoinTabWin* pRhs, SbaJoinTabConn* _rpFirstAfter)
{
	SbaJoinTabConn* pConn = NULL;
	DBG_ASSERT(pRhs || pLhs, "SbaJoinTabWinCont::GetTabConn : invalid args !");
		// only one NULL-arg allowed

	if ((!pLhs || pLhs->ExistsAConn()) && (!pRhs || pRhs->ExistsAConn()))
	{
		SbaJoinTabConnList* pDataList = GetTabConnList();

		BOOL bFoundStart = _rpFirstAfter ? FALSE : TRUE;

		for(ULONG i=0; i < pDataList->Count();++i)
		{
			SbaJoinTabConn* pData = pDataList->GetObject(i);

			if	(	(	(pData->GetSourceWin() == pLhs)
					&&	(	(pData->GetDestWin() == pRhs)
						||	(NULL == pRhs)
						)
					)
				||	(	(pData->GetSourceWin() == pRhs)
					&&	(	(pData->GetDestWin() == pLhs)
						||	(NULL == pLhs)
						)
					)
				)
			{
				if (bFoundStart)
				{
					pConn = pData;
					break;
				}

				if (!pConn)
					// used as fallback : if there is no conn after _rpFirstAfter the first conn between the two tables
					// will be used
					pConn = pData;

				if (pData == _rpFirstAfter)
					bFoundStart = TRUE;
			}
		}
	}
	return pConn;
}

//------------------------------------------------------------------------------
long SbaJoinTabWinCont::PreNotify(NotifyEvent& rNEvt)
{
	BOOL bHandled = FALSE;
	switch (rNEvt.GetType())
	{
		case EVENT_COMMAND:
		{
			const CommandEvent* pCommand = rNEvt.GetCommandEvent();
			if (pCommand->GetCommand() == COMMAND_WHEEL)
			{
				const CommandWheelData* pData = rNEvt.GetCommandEvent()->GetWheelData();
				if (pData->GetMode() == COMMAND_WHEEL_SCROLL)
				{
					if (pData->GetDelta() > 0)
						Scroll(-10 * pData->GetScrollLines(), pData->IsHorz(), TRUE);
					else
						Scroll(10 * pData->GetScrollLines(), pData->IsHorz(), TRUE);
					bHandled = TRUE;
				}
			}
		}
		break;
		case EVENT_KEYINPUT:
		{
			if (!aTabWinMap.Count())
				// no tab wins -> no conns -> no traveling
				break;

			const KeyEvent* pKeyEvent =	rNEvt.GetKeyEvent();
			if (!pKeyEvent->GetKeyCode().IsMod1())
			{
				switch (pKeyEvent->GetKeyCode().GetCode())
				{
					case KEY_TAB:
					{
						if (!HasChildPathFocus())
							break;

						if (aTabWinMap.Count() == 0)
							// no wins -> no conns -> nothing selectable
							break;

						BOOL bForward = !pKeyEvent->GetKeyCode().IsShift();
						// is there an active tab win ?
						INT32 i(0);
						for (; i<aTabWinMap.Count(); ++i)
							if (aTabWinMap.GetObject(i) && aTabWinMap.GetObject(i)->HasChildPathFocus())
								break;

						SbaJoinTabWin* pNextWin = NULL;
						SbaJoinTabConn* pNextConn = NULL;

						if (i<aTabWinMap.Count())
						{	// there is a currently active tab win
							// check if there is an "overflow" and we should select a conn instead of a win
							if (aTabConnList.Count())
							{
								if ((i == aTabWinMap.Count() - 1) && bForward)
									// the last win is active and we're travelling forward -> select the first conn
									pNextConn = aTabConnList.GetObject(0);
								if ((i == 0) && !bForward)
									// the first win is active an we're traveling backward -> select the last conn
									pNextConn = aTabConnList.GetObject(aTabConnList.Count() - 1);
							}

							if (!pNextConn)
								// no conn for any reason -> select the next or previous tab win
								pNextWin = aTabWinMap.GetObject(
									(i + (bForward ? 1 : aTabWinMap.Count() - 1)) % aTabWinMap.Count()
								);
						}
						else
						{	// no active tab win -> travel the connections
							// find the currently selected conn within the conn list
							INT32 i(0);
							for (i=0; i<aTabConnList.Count(); ++i)
							{
								if (aTabConnList.GetObject(i) == GetSelectedConn())
									break;
							}
							if ((i == aTabConnList.Count() - 1) && bForward)
								// the last conn is active and we're travelling forward -> select the first win
								pNextWin = aTabWinMap.GetObject(0);
							if ((i == 0) && !bForward && aTabWinMap.Count())
								// the first conn is active and we're travelling backward -> select the last win
								pNextWin = aTabWinMap.GetObject( aTabWinMap.Count() - 1 );

							if (pNextWin)
								DeselectConn(GetSelectedConn());
							else
								// no win for any reason -> select the next or previous conn
								if (i < aTabConnList.Count())
									// there is a currently active conn
									pNextConn = aTabConnList.GetObject(
										(i + (bForward ? 1 : aTabConnList.Count() - 1)) % aTabConnList.Count()
									);
								else
								{	// no tab win selected, no conn selected
									if (aTabConnList.Count())
										pNextConn = aTabConnList.GetObject(bForward ? 0 : aTabConnList.Count() - 1);
									else if (aTabWinMap.Count())
										pNextWin = aTabWinMap.GetObject(bForward ? 0 : aTabWinMap.Count() - 1);
								}
						}

						// now select the object
						if (pNextWin)
						{
							if (pNextWin->GetListBox())
								pNextWin->GetListBox()->GrabFocus();
							else
								pNextWin->GrabFocus();
							EnsureVisible(pNextWin);
						}
						else if (pNextConn)
						{
							SelectConn(pNextConn);
							GrabFocus();
								// neccessary : a conn may be selected even if a tab win has the focus, in this case
								// the next travel would select the same conn again if we would not reset te focus ...
						}
					}
					break;
					case KEY_RETURN:
					{
						if (!pKeyEvent->GetKeyCode().IsShift() && GetSelectedConn() && HasFocus())
							ConnDoubleClicked(GetSelectedConn());
						break;
					}
				}
			}
		}
		break;
		case EVENT_GETFOCUS:
		{
			Window* pSource = rNEvt.GetWindow();
			if (pSource)
			{
				Window* pSearchFor = NULL;
				if (pSource->GetParent() == this)
					// it may be one of the tab wins
					pSearchFor = pSource;
				else if (pSource->GetParent() && (pSource->GetParent()->GetParent() == this))
					// it may be one of th list boxes of one of the tab wins
					pSearchFor = pSource->GetParent();

				if (pSearchFor)
					for (ULONG i=0; i<aTabWinMap.Count(); ++i)
					{
						if (aTabWinMap.GetObject(i) == pSearchFor)
						{
							m_pLastFocusTabWin = aTabWinMap.GetObject(i);
							break;
						}
					}
			}
		}
		break;
	}

	if (!bHandled)
		return Window::PreNotify(rNEvt);
	return 0;
}

//------------------------------------------------------------------------------
void SbaJoinTabWinCont::GrabTabWinFocus()
{
	if (m_pLastFocusTabWin)
	{
		if (m_pLastFocusTabWin->GetListBox())
			m_pLastFocusTabWin->GetListBox()->GrabFocus();
		else
			m_pLastFocusTabWin->GrabFocus();
	}
	else if (aTabWinMap.Count() && aTabWinMap.GetObject(0))
	{
		SbaJoinTabWin* pFirstWin = aTabWinMap.GetObject(0);
		if (pFirstWin->GetListBox())
			pFirstWin->GetListBox()->GrabFocus();
		else
			pFirstWin->GrabFocus();
	}
}




