/*************************************************************************
 *
 *  $RCSfile: qryconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

#include "qryconn.hxx"

#ifndef _SBA_QRYDGN1_HXX
#include "qrydgn1.hxx"
#endif // _SBA_QRYDGN1_HXX

#ifndef _SBA_QRYTBWIN_HXX
#include "qrytbwin.hxx"
#endif // _SBA_QRYTBWIN_HXX

TYPEINIT1(QueryTabConn, SbaJoinTabConn);
TYPEINIT1(QueryTabConnData, SbaJoinTabConnData);

//========================================================================
// class QueryTabConnData
//========================================================================
DBG_NAME(QueryTabConnData);
//------------------------------------------------------------------------
QueryTabConnData::QueryTabConnData()
	:SbaJoinTabConnData()
	,eJoinType (SBA_INNER_JOIN)
{
	DBG_CTOR(QueryTabConnData,NULL);
}

//------------------------------------------------------------------------
QueryTabConnData::QueryTabConnData( const QueryTabConnData& rConnData )
	:SbaJoinTabConnData( rConnData )
{
	DBG_CTOR(QueryTabConnData,NULL);
	nFromEntryIndex = rConnData.nFromEntryIndex;
	nDestEntryIndex = rConnData.nDestEntryIndex;

	eFromType = rConnData.eFromType;
	eDestType = rConnData.eDestType;
	eJoinType = rConnData.eJoinType;
}

//------------------------------------------------------------------------
QueryTabConnData::QueryTabConnData(const String& strSourceTable, const String& strDestTable,
		const String& strSourceAlias, const String& strDestAlias, const String& rConnName)
	:SbaJoinTabConnData( strSourceAlias, strDestAlias, rConnName )
	,m_strSourceTableName(strSourceTable)
	,m_strDestTableName(strDestTable)
	,nFromEntryIndex(0)
	,nDestEntryIndex(0)
	,eFromType(TAB_NORMAL_FIELD)
	,eDestType(TAB_NORMAL_FIELD)
	,eJoinType (SBA_INNER_JOIN)
{
	DBG_CTOR(QueryTabConnData,NULL);
}

//------------------------------------------------------------------------
QueryTabConnData::~QueryTabConnData()
{
	DBG_DTOR(QueryTabConnData,NULL);
}

//------------------------------------------------------------------------
SbaJoinConnLineData* QueryTabConnData::CreateLineDataObj()
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	// keine Spezialisierung bei den LineDatas, also eine Instanz der Standard-Klasse
	return new SbaJoinConnLineData();
}

//------------------------------------------------------------------------
SbaJoinConnLineData* QueryTabConnData::CreateLineDataObj( const SbaJoinConnLineData& rConnLineData )
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	return new SbaJoinConnLineData( rConnLineData );
}

//------------------------------------------------------------------------
void QueryTabConnData::CopyFrom(const SbaJoinTabConnData& rSource)
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	DBG_ASSERT(rSource.ISA(QueryTabConnData), "QueryTabConn::CopyFrom : ungueltiger Parameter !");
	// wie in der Basisklasse zurueckziehen auf das (nicht-virtuelle) operator=
	*this = (const QueryTabConnData&)rSource;
}

//------------------------------------------------------------------------
QueryTabConnData& QueryTabConnData::operator=(const QueryTabConnData& rConnData)
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	if (&rConnData == this)
		return *this;

	SbaJoinTabConnData::operator=(rConnData);

	nFromEntryIndex = rConnData.nFromEntryIndex;
	nDestEntryIndex = rConnData.nDestEntryIndex;

	eFromType = rConnData.eFromType;
	eDestType = rConnData.eDestType;
	eJoinType = rConnData.eJoinType;

	return *this;
}

//------------------------------------------------------------------------------
String QueryTabConnData::GetTableName(JoinTabConnSide nWhich) const
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	return nWhich == JTCS_FROM ? m_strSourceTableName : m_strDestTableName;
}

//------------------------------------------------------------------------------
String QueryTabConnData::GetAliasName(JoinTabConnSide nWhich) const
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	return nWhich == JTCS_FROM ? GetSourceWinName() : GetDestWinName();
}

//------------------------------------------------------------------------------
void QueryTabConnData::InitFromDrag(const TabFieldDesc& rDragLeft, const TabFieldDesc& rDragRight)
{
	DBG_CHKTHIS(QueryTabConnData,NULL);
	// die Infos in rDrag in Parameter fuer das Basisklassen-Init umsetzen ...
	QueryTabWin* pSourceWin = (QueryTabWin*)rDragLeft.GetTabWindow();
	QueryTabWin* pDestWin = (QueryTabWin*)rDragRight.GetTabWindow();
	DBG_ASSERT(pSourceWin->GetDatabaseName() == pDestWin->GetDatabaseName(), "QueryTabConnData::QueryTabConnData : Fenster muessen zur selben Datenbank gehoeren !");
		// im Augenblick unterstuetzen wir wohl nix anderes ...

	Init(pSourceWin->GetWinName(), pDestWin->GetWinName());

	// und dann meine Members setzen
	SetFieldIndex(JTCS_FROM, rDragLeft.GetFieldIndex());
	SetFieldIndex(JTCS_TO, rDragRight.GetFieldIndex());

	SetFieldType(JTCS_FROM, rDragLeft.GetFieldType());
	SetFieldType(JTCS_TO, rDragRight.GetFieldType());

	m_strSourceTableName = pSourceWin->GetTableName();
	aSourceWinName = pSourceWin->GetWinName();

	m_strDestTableName = pDestWin->GetTableName();
	aDestWinName = pDestWin->GetWinName();

	AppendConnLine(rDragLeft.GetField(),rDragRight.GetField());
}

//========================================================================
// class QueryTabConn
//========================================================================
DBG_NAME(QueryTabConn);

//------------------------------------------------------------------------
QueryTabConn::QueryTabConn(QueryTabWinContainer* pContainer, QueryTabConnData* pTabConnData)
	:SbaJoinTabConn((SbaJoinTabWinCont*)pContainer, pTabConnData)
{
	DBG_CTOR(QueryTabConn,NULL);
}


//------------------------------------------------------------------------
QueryTabConn::QueryTabConn(const QueryTabConn& rConn)
	:SbaJoinTabConn( rConn )
{
	DBG_CTOR(QueryTabConn,NULL);
	// keine eigenen Members, also reicht die Basisklassenfunktionalitaet
}


//------------------------------------------------------------------------
QueryTabConn::~QueryTabConn()
{
	DBG_DTOR(QueryTabConn,NULL);
}

//------------------------------------------------------------------------
SbaJoinConnLine* QueryTabConn::CreateConnLine( const SbaJoinConnLine& rConnLine )
{
	// keine Spezialisierung bei den ConnectionLines, also eine Instanz der Standard-Klasse
	return new SbaJoinConnLine(rConnLine);
}

//------------------------------------------------------------------------
QueryTabConn& QueryTabConn::operator=(const QueryTabConn& rConn)
{
	if (&rConn == this)
		return *this;

	SbaJoinTabConn::operator=(rConn);
	// keine eigenen Members ...
	return *this;
}

//------------------------------------------------------------------------
sal_Bool QueryTabConn::operator==(const QueryTabConn& rCompare)
{
	DBG_ASSERT(GetData() && rCompare.GetData(), "QueryTabConn::operator== : einer der beiden Teilnehmer hat keine Daten !");

	// allzuviel brauche ich nicht vergleichen (schon gar nicht alle Member) : lediglich die Fenster, an denen wir haengen, und
	// die Indizies in der entsprechenden Tabelle muessen uebereinstimmen
	QueryTabConnData* pMyData = (QueryTabConnData*)GetData();
	QueryTabConnData* pCompData = (QueryTabConnData*)rCompare.GetData();

	// Connections werden als gleich angesehen, wenn sie in Source-/Dest-Fenstername und Source-/Dest-FieldIndex uebereinstimmen ...
	return	(	(	(pMyData->GetSourceWinName() == pCompData->GetSourceWinName()) &&
					(pMyData->GetDestWinName() == pCompData->GetDestWinName()) &&
					(pMyData->GetFieldIndex(JTCS_TO) == pCompData->GetFieldIndex(JTCS_TO)) &&
					(pMyData->GetFieldIndex(JTCS_FROM) == pCompData->GetFieldIndex(JTCS_FROM))
				)
				||	// ... oder diese Uebereinstimmung ueber Kreuz besteht
				(	(pMyData->GetSourceWinName() == pCompData->GetDestWinName()) &&
					(pMyData->GetDestWinName() == pCompData->GetSourceWinName()) &&
					(pMyData->GetFieldIndex(JTCS_TO) == pCompData->GetFieldIndex(JTCS_FROM)) &&
					(pMyData->GetFieldIndex(JTCS_FROM) == pCompData->GetFieldIndex(JTCS_TO))
				)
			);
}
