/*************************************************************************
 *
 *  $RCSfile: qrydgn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif

#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_QRYTXTVS_HXX
#include "qrytxtvs.hxx"
#endif
//#ifndef _SBA_DBCOLL_HXX
//#include "dbcoll.hxx"
//#endif
#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif
#ifndef _SBA_QRYDGN_HXX
#include "qrydgn.hxx"
#endif
#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif
#ifndef _SBA_QRYUNDO_HXX
#include "qryundo.hxx"
#endif
#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _SBA_QRYDGNVS_HXX
#include "qrydgnvs.hxx"
#endif
#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif
#ifndef _SBA_SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBADBIT_HXX
#include "sbadbit.hxx"
#endif

#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif

#ifndef _SBA_SBADBFLD_HXX
#include <sbadbfld.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#ifndef _NUMUNO_HXX
#include <svtools/numuno.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATTER_HPP_
#include <com/sun/star/util/XNumberFormatter.hpp>
#endif

#ifndef _SBA_QRYCONN_HXX
#include "qryconn.hxx"
#endif // _SBA_QRYCONN_HXX
#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

//==============================================================================

#define	SPLIT_WIDTH		4

//==============================================================================
DBG_NAME(QueryDesignWin);
//==============================================================================
QueryDesignWin::QueryDesignWin( Window* pParent, SbaQueryDesignViewSh* pV )
			   :SbaJoinFrameWindow( pParent, pV)
			   ,pView( pV )
			   ,pSelectionWindow( 0 )
			   ,aSplitter( this )
			   ,nSplitHeight(-1)
			   ,bNotifyModification(sal_True)

{
	DBG_CTOR(QueryDesignWin,NULL);
	SetHelpId( HID_VIEW_GRA );

	aDefScrollSize.Width() = aVScrollBar.GetSizePixel().Width();
	aDefScrollSize.Height() = aHScrollBar.GetSizePixel().Height();

	((WorkWindow*)pParent->GetParent())->SetMinOutputSizePixel( Size(aDefScrollSize.Width()*10,aDefScrollSize.Height()*10) );

	SetBackground( Wallpaper( Application::GetSettings().GetStyleSettings().GetFaceColor()) );

	// Splitter einrichten
	aSplitter.SetSplitHdl(LINK(this, QueryDesignWin,SplitHHdl));
	aSplitter.Show();

	pTabWinCont = new QueryTabWinContainer( this, pV );
	((QueryTabWinContainer*)pTabWinCont)->SetTabWinsChangeHandler(LINK(this, QueryDesignWin, OnTabWinsChanged));
	pTabWinCont->Show();

	SbaQueryDocSh* pDocSh = Shell();
	pSelectionWindow = new SelectionBrowseBox(this);
	pSelectionWindow->SetNoneVisbleRow(pDocSh->GetNoneVisibleRows());
	pSelectionWindow->Init();
	pSelectionWindow->Show();

	//XXX Test die Werte unten sind geschaetzt!!!!
	aHScrollBar.SetRange( Range( 0, 2000 ) );
	aVScrollBar.SetRange( Range( 0, 1000 ) );
	aHScrollBar.SetLineSize( aDefScrollSize.Width() );
	aVScrollBar.SetLineSize( aDefScrollSize.Width() );
	aHScrollBar.SetPageSize( aDefScrollSize.Width()*5 );
	aVScrollBar.SetPageSize( aDefScrollSize.Width()*5 );
}

//------------------------------------------------------------------------------
QueryDesignWin::~QueryDesignWin()
{
	bNotifyModification = sal_False;	// kein Modify aufrufen, da ein Statement von aussen gesetzt
	if (GetTabWinCont()->HasAddTabDlg())
		GetTabWinCont()->DestroyAddTabDlg();
	delete pSelectionWindow;
	bNotifyModification = sal_True;
	DBG_DTOR(QueryDesignWin,NULL);
}

//------------------------------------------------------------------------------
void QueryDesignWin::SetReadOnly(sal_Bool bRO)
{
	SbaJoinFrameWindow::SetReadOnly(bRO);
	pSelectionWindow->SetReadOnly(bRO);
}

//------------------------------------------------------------------------------
SbaQueryDocSh* QueryDesignWin::Shell() const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	return pView->GetQueryShell();
}

//------------------------------------------------------------------------------

void QueryDesignWin::UpdateSliders( const Point& rRange )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
/* XXX klappt noch nicht
	aHScrollBar.SetRange( Range( 0, rRange.X() ) );
	aVScrollBar.SetRange( Range( 0, rRange.Y() ) );
*/
}

//------------------------------------------------------------------------------
IMPL_LINK_INLINE_START( QueryDesignWin, SplitHHdl, Splitter *, pSplit )
{
	if (!IsReadOnly())
	{
		long nSplitPos = pSplit->GetSplitPosPixel();
		pSplit->SetPosPixel( Point(0, nSplitPos) );
		ArrangeChilds( nSplitPos );
	}
	return 0;
}
IMPL_LINK_INLINE_END( QueryDesignWin, SplitHHdl, Splitter *, pSplit )

//------------------------------------------------------------------------------
void QueryDesignWin::ArrangeChilds( long nSplitPos )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	Size		aSize( GetOutputSizePixel() );

	if( nSplitPos == -1 || nSplitPos >= aSize.Height())
		nSplitPos = aSize.Height()/2;

	pTabWinCont->SetPosSizePixel( Point(), Size(aSize.Width()-aDefScrollSize.Width(), nSplitPos-aDefScrollSize.Width()));

	aHScrollBar.SetPosSizePixel(
		Point(0,pTabWinCont->GetSizePixel().Height() ),
		Size(aSize.Width()-aDefScrollSize.Width(), aDefScrollSize.Width() )
		);

	aVScrollBar.SetPosSizePixel(
		Point(pTabWinCont->GetSizePixel().Width(), 0 ),
		Size( aDefScrollSize.Width(), pTabWinCont->GetSizePixel().Height() )
		);

	pSelectionWindow->SetPosSizePixel(
		Point(0, nSplitPos+SPLIT_WIDTH),
		Size(aSize.Width(), aSize.Height() - nSplitPos - SPLIT_WIDTH));

	aSplitter.SetPosSizePixel( Point( 0, nSplitPos ), Size(aSize.Width(), SPLIT_WIDTH));
	aSplitter.SetSplitPosPixel( nSplitPos );

	aSplitter.SetDragRectPixel(Rectangle(Point(0,aDefScrollSize.Width()),Size(aSize.Width(),aSize.Height() - 2 * aDefScrollSize.Width())), this );

	nSplitHeight = nSplitPos;
}

//------------------------------------------------------------------------------
void QueryDesignWin::Resize()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
//	ArrangeChilds( Shell()->GetSplitPos() );
	if (aSplitter.GetRelation()<0)
		ArrangeChilds( Shell()->GetSplitPos() );
	else
		ArrangeChilds( long((GetSizePixel().Height() - aSplitter.GetSizePixel().Height())*aSplitter.GetRelation()) );
}

//------------------------------------------------------------------------------
void QueryDesignWin::GetFocus()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	pSelectionWindow->GrabFocus();
}

//------------------------------------------------------------------------------
long QueryDesignWin::PreNotify(NotifyEvent& rNEvt)
{
	BOOL bHandled = FALSE;
	switch (rNEvt.GetType())
	{
		case EVENT_KEYINPUT:
		{
			const KeyEvent* pKeyEvent =	rNEvt.GetKeyEvent();
			const KeyCode& rCode = pKeyEvent->GetKeyCode();
			if (rCode.IsMod1() || rCode.IsMod2())
				break;
			if (rCode.GetCode() != KEY_F6)
				break;

			if (GetTabWinCont() && GetTabWinCont()->HasChildPathFocus())
			{
				if (GetSelectionWin())
				{
					GetSelectionWin()->GrabFocus();
					bHandled = TRUE;
				}
			}
			else if (GetSelectionWin() && GetSelectionWin()->HasChildPathFocus())
			{
				if (GetTabWinCont())
				{
					GetTabWinCont()->GrabTabWinFocus();
					bHandled = TRUE;
				}
			}
		}
		break;
	}

	if (!bHandled)
		return SbaJoinFrameWindow::PreNotify(rNEvt);
	return 0;
}

static const String C_AND = String::CreateFromAscii(" AND ");
static const String C_OR  = String::CreateFromAscii(" OR ");
//------------------------------------------------------------------------------
String ConvertAlias(const String& rName)
{
	if (!rName.Len())
		return rName;

	const sal_Unicode* pStr = rName.GetBuffer();
	sal_Bool bValid(!((*pStr >= 48) && (*pStr <=  57)));	// keine Zahl am Anfang

	String aTmp;
	if (bValid)
		aTmp = rName;

	for (sal_Int32 i=0; i < rName.Len() && *pStr;i++, pStr++ ){
		if ( ((*pStr >= 97) && (*pStr <= 122)) ||((*pStr >= 65) && (*pStr <=  90)) ||
			 ((*pStr >= 48) && (*pStr <=  57)) ||  *pStr == '_'	  			       )
			  ;
		else
			aTmp.SearchAndReplace(*pStr,'_');

	}

	return aTmp;
}
//------------------------------------------------------------------------------
sal_Bool QueryDesignWin::HasFields()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	TabFieldDescList*	pFieldList = pSelectionWindow->GetFieldDescList();
	String aFieldName;
	for (int i = 0; i < pFieldList->Count(); i++)
	{
		TabFieldDesc* pEntryField = pFieldList->GetObject(i);
		aFieldName = pEntryField->GetField();
		if (aFieldName.Len() != 0 && pEntryField->IsVisible())
			return sal_True;
	}
	return sal_False;
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildTable(QueryTabWin* pEntryTab) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	SdbDatabase* pDatabase = Shell()->GetDatabase();
	String aDBName(pEntryTab->GetDatabaseName());
	String aTableListStr;

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDatabase->GetMetaData());
	sal_Bool bQualifier	= ::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;
	sal_Bool bOwner		= ::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SCHEMA_USAGE))  & ::com::sun::star::data::DatabaseQualifier::IN_DML;

	if (bQualifier && aDBName.Len())
	{
		aTableListStr = pDatabase->IdentifierQuotation(aDBName);
		aTableListStr += pDatabase->GetQualifierSeparator();
	}
	// TabellenName, kann wieder Owner enthalten
	xub_StrLen nIndex = 0;
	String aTmpTable(pEntryTab->GetTableName());


	if(bOwner)
	{
		for (String aToken(aTmpTable.GetToken(0,'.',nIndex));
			 aToken.Len();
			 aToken = aTmpTable.GetToken(0,'.',nIndex))
		{
			aTableListStr += pDatabase->IdentifierQuotation(aToken);
			aTableListStr += '.';
		}
	}
	else // it is possible that I have a tablename like 'Artikel.txt' (ODBC Text Driver)
		aTableListStr += pDatabase->IdentifierQuotation(aTmpTable);

	aTableListStr.EraseTrailingChars('.');
	aTableListStr += ' ';
	aTableListStr += ConvertAlias(pEntryTab->GetAliasName());
	return aTableListStr;
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildJoin(QueryTabWin* pLh, QueryTabWin* pRh, QueryTabConnData* pData) const
{
	return BuildJoin(BuildTable(pLh),BuildTable(pRh),pData);
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildJoin(const String &rLh, QueryTabWin* pRh, QueryTabConnData* pData) const
{
	return BuildJoin(rLh,BuildTable(pRh),pData);
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildJoin(QueryTabWin* pLh, const String &rRh, QueryTabConnData* pData) const
{
	return BuildJoin(BuildTable(pLh),rRh,pData);
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildJoin(const String& rLh, const String& rRh, QueryTabConnData* pData) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	String aErg(rLh);
	switch(pData->GetJoinType())
	{
		case SBA_LEFT_JOIN:
			aErg.AppendAscii(" LEFT OUTER ");
			break;
		case SBA_RIGHT_JOIN:
			aErg.AppendAscii(" RIGHT OUTER ");
			break;
		case SBA_INNER_JOIN:
			DBG_ERROR("QueryDesignWin::BuildJoin: This should not happen!");
			//aErg.AppendAscii(" INNER ");
			break;
		default:
			aErg.AppendAscii(" FULL OUTER ");
			break;
	}
	aErg.AppendAscii("JOIN ");
	aErg += rRh;
	aErg.AppendAscii(" ON ");
	aErg += BuildJoinCriteria(pData->GetConnLineDataList(),pData);

	return aErg;
}
//------------------------------------------------------------------------------
String QueryDesignWin::BuildJoinCriteria(SbaJoinConnLineDataList* pLineDataList,QueryTabConnData* pData) const
{
	String aCondition;
	SdbDatabase* pDatabase = Shell()->GetDatabase();
	for(sal_uInt32 i=0;i < pLineDataList->Count();++i)
	{
		SbaJoinConnLineData* pLineData = pLineDataList->GetObject(i);
		if(pLineData->IsValid())
		{
			if(aCondition.Len())
				aCondition += C_AND;
			aCondition += ConvertAlias( pData->GetAliasName(JTCS_FROM) );
			aCondition += '.';
			aCondition += pDatabase->IdentifierQuotation( pLineData->GetFieldName(JTCS_FROM) );
			aCondition.AppendAscii(" = ");
			aCondition += ConvertAlias( pData->GetAliasName(JTCS_TO) );
			aCondition += '.';
			aCondition += pDatabase->IdentifierQuotation( pLineData->GetFieldName(JTCS_TO) );
		}
	}

	return aCondition;
}
//------------------------------------------------------------------------------
String QueryDesignWin::GenerateSelectList(const TabFieldDescList*	pFieldList,sal_Bool bAlias) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT(pFieldList,"GenerateSelectList: pFieldList == NULL. Prepare for GPF! ;-(");
	SdbDatabase* pDatabase = Shell()->GetDatabase();
	String aTmpStr,aFieldListStr;

	sal_Bool bAsterix = sal_False;
	int nVis = 0;
	for (sal_uInt16 j = 0; j < pFieldList->Count(); j++)
	{
		TabFieldDesc* pEntryField = pFieldList->GetObject(j);
		if(pEntryField->IsVisible())
		{
			if(pEntryField->GetField().GetChar(0) == '*')
				bAsterix = sal_True;
			nVis++;
		}
	}
	if(nVis == 1)
		bAsterix = sal_False;

	for (sal_uInt16 i = 0; i < pFieldList->Count(); i++)
	{
		TabFieldDesc* pEntryField = pFieldList->GetObject(i);
		const String& rFieldName = pEntryField->GetField();
		if (rFieldName.Len() && pEntryField->IsVisible())
		{
			aTmpStr.Erase();
			const String& rAlias = pEntryField->GetAlias();
			const String& rFieldAlias = pEntryField->GetFieldAlias();
			if(bAlias && rAlias.Len() || bAsterix)
			{
				aTmpStr += ConvertAlias(rAlias);
				aTmpStr += '.';
			}

			if(pEntryField->GetTable().Len() && rFieldName.GetChar(0) != '*')
				aTmpStr += pDatabase->IdentifierQuotation(rFieldName);
			else
				aTmpStr += rFieldName;

			if(pEntryField->GetFunctionType() == FKT_AGGREGATE)
			{
				DBG_ASSERT(pEntryField->GetFunction().Len(),"Functionname darf hier nicht leer sein! ;-(");
				String aTmpStr2(pEntryField->GetFunction());
				aTmpStr2 +=  '(';
				aTmpStr2 += aTmpStr;
				aTmpStr2 +=  ')';
				aTmpStr = aTmpStr2;
			}

			if(rFieldAlias.Len() && rFieldName.GetChar(0) != '*' )
			{
				aTmpStr.AppendAscii(" AS ");
				aTmpStr += pDatabase->IdentifierQuotation(rFieldAlias);
			}
			aFieldListStr += aTmpStr;
			aFieldListStr += ',';
		}
	}
	aFieldListStr.EraseTrailingChars( ',' );
	return aFieldListStr;
}
//------------------------------------------------------------------------------
void QueryDesignWin::JoinCycle(QueryTabConn* pEntryConn,String &rJoin,QueryTabWin* pEntryTabTo) const
{
	QueryTabConnData* pData = (QueryTabConnData*)pEntryConn->GetData();
	if(pData->GetJoinType() == SBA_INNER_JOIN)
		return;
	if(pEntryTabTo->ExistsAVisitedConn()) // then we have a cycle
	{

		SdbDatabase* pDatabase = Shell()->GetDatabase();
		sal_Bool bBrace = sal_False;
		if(rJoin.GetChar(rJoin.Len()-1) == ')')
		{
			bBrace = sal_True;
			rJoin.SetChar(rJoin.Len()-1,' ');
		}
		(rJoin += C_AND) += BuildJoinCriteria(pData->GetConnLineDataList(),pData);
		if(bBrace)
			rJoin += ')';
		pEntryConn->SetVisited(sal_True);
	}
}

//------------------------------------------------------------------------------
void QueryDesignWin::GenerateInnerJoinCriterias(String& _rJoinCrit,const SbaJoinTabConnList*	_pConnList) const
{
	for(sal_uInt32 i=0;i<_pConnList->Count();i++)
	{
		QueryTabConn* pEntryConn = (QueryTabConn*)_pConnList->GetObject(i);
		QueryTabConnData* pEntryConnData = (QueryTabConnData*)pEntryConn->GetData();
		if(pEntryConnData->GetJoinType() == SBA_INNER_JOIN)
		{
			if(_rJoinCrit.Len())
				_rJoinCrit += C_AND;
			_rJoinCrit += BuildJoinCriteria(pEntryConnData->GetConnLineDataList(),pEntryConnData);
		}
	}
}
//------------------------------------------------------------------------------
void QueryDesignWin::GetNextJoin(QueryTabConn* pEntryConn,String &aJoin,QueryTabWin* pEntryTabTo) const
{

	QueryTabConnData* pEntryConnData = (QueryTabConnData*)pEntryConn->GetData();
	if(pEntryConnData->GetJoinType() == SBA_INNER_JOIN)
		return;

	if(!aJoin.Len())
	{
		QueryTabWin* pEntryTabFrom = (QueryTabWin*)pEntryConn->GetSourceWin();
		aJoin = BuildJoin(pEntryTabFrom,pEntryTabTo,pEntryConnData);
	}
	else if(pEntryTabTo == pEntryConn->GetDestWin())
	{
		String aTmpJoin;aTmpJoin.AssignAscii("(");
		(aTmpJoin += aJoin) += ')';
		aJoin = BuildJoin(aTmpJoin,pEntryTabTo,pEntryConnData);
	}
	else if(pEntryTabTo == pEntryConn->GetSourceWin())
	{
		String aTmpJoin;aTmpJoin.AssignAscii("(");
		(aTmpJoin += aJoin) += ')';
		aJoin = BuildJoin(pEntryTabTo,aTmpJoin,pEntryConnData);
	}

	pEntryConn->SetVisited(sal_True);

	QueryTabConn* pNext = (QueryTabConn*)pEntryConn->GetParent()->GetTabConnList()->First();
	while(pNext)
	{
		if(!pNext->IsVisited() && (pNext->GetSourceWin() == pEntryTabTo || pNext->GetDestWin() == pEntryTabTo))
		{
			QueryTabWin* pEntryTab = pNext->GetSourceWin() == pEntryTabTo ? (QueryTabWin*)pNext->GetDestWin() : (QueryTabWin*)pNext->GetSourceWin();
			// exists there a connection to a QueryTabWin that holds a connection that has been already visited
			JoinCycle(pNext,aJoin,pEntryTab);
			if(!pNext->IsVisited())
				GetNextJoin(pNext,aJoin,pEntryTab);
		}
		pNext = (QueryTabConn*)pEntryConn->GetParent()->GetTabConnList()->Next();
	}

	if(!pNext)
	{
		QueryTabWin* pEntryTabFrom = (QueryTabWin*)pEntryConn->GetSourceWin();
		pNext = (QueryTabConn*)pEntryConn->GetParent()->GetTabConnList()->First();
		while(pNext)
		{
			if(!pNext->IsVisited() && (pNext->GetSourceWin() == pEntryTabFrom || pNext->GetDestWin() == pEntryTabFrom))
			{
				QueryTabWin* pEntryTab = pNext->GetSourceWin() == pEntryTabFrom ? (QueryTabWin*)pNext->GetDestWin() : (QueryTabWin*)pNext->GetSourceWin();
				// exists there a connection to a QueryTabWin that holds a connection that has been already visited
				JoinCycle(pNext,aJoin,pEntryTab);
				if(!pNext->IsVisited())
					GetNextJoin(pNext,aJoin,pEntryTab);
			}
			pNext = (QueryTabConn*)pEntryConn->GetParent()->GetTabConnList()->Next();
		}
	}
}

//------------------------------------------------------------------------------
String QueryDesignWin::GenerateFromClause(const SbaJoinTabWinMap*	pTabList,const SbaJoinTabConnList*	pConnList) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	String aTableListStr;
	// wird gebraucht um sicher zustelllen das eine Tabelle nicht doppelt vorkommt

	// generate outer join clause in from
	if(pConnList->Count())
	{
		for(sal_uInt32 i=0;i<pConnList->Count();i++)
		{
			QueryTabConn* pEntryConn = (QueryTabConn*)pConnList->GetObject(i);
			pEntryConn->SetVisited(sal_False);
		}

		for(i=0;i<pConnList->Count();i++)
		{
			QueryTabConn* pEntryConn = (QueryTabConn*)pConnList->GetObject(i);
			if(!pEntryConn->IsVisited())
			{
				String aJoin;
				GetNextJoin(pEntryConn,aJoin,(QueryTabWin*)pEntryConn->GetDestWin());
				if(aTableListStr.Len())
					aTableListStr += ',';
				aTableListStr += aJoin;
			}
		}
		aTableListStr.EraseTrailingChars( ',' );
		if(aTableListStr.Len())
		{
			String aStr;
			aStr.AssignAscii("{ OJ ");
			(aStr += aTableListStr).AppendAscii(" },");
			aTableListStr = aStr;
		}
		// and now all inner joins
		map<String,sal_Bool,::utl::UStringMixLess> aTableNames;
		for(i=0;i<pConnList->Count();i++)
		{
			QueryTabConn* pEntryConn = (QueryTabConn*)pConnList->GetObject(i);
			if(!pEntryConn->IsVisited())
			{
				String aTabName(BuildTable((QueryTabWin*)pEntryConn->GetSourceWin()));
				if(aTableNames.find(aTabName) == aTableNames.end())
				{
					aTableNames[aTabName] = sal_True;
					aTableListStr += aTabName;
					aTableListStr += ',';
				}
				aTabName = BuildTable((QueryTabWin*)pEntryConn->GetDestWin());
				if(aTableNames.find(aTabName) == aTableNames.end())
				{
					aTableNames[aTabName] = sal_True;
					aTableListStr += aTabName;
					aTableListStr += ',';
				}
			}
		}
	}
	// all tables that haven't a connection to anyone
	for(sal_uInt32 i=0;i<pTabList->Count();i++)
	{
		QueryTabWin* pEntryTab = (QueryTabWin*)pTabList->GetObject(i);
		if(!pEntryTab->ExistsAConn())
		{
			aTableListStr += BuildTable(pEntryTab);
			aTableListStr += ',';
		}
	}

	aTableListStr.EraseTrailingChars( ',' );
	return aTableListStr;
}
//------------------------------------------------------------------------------
String QueryDesignWin::GenerateSQL() const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	SdbDatabase* pDatabase = Shell()->GetDatabase();

	if (!pDatabase)			// ohne Verbindung geht nichts
		return String();

	pSelectionWindow->Save();	// Aktuelle eingabe uebernehmen
	TabFieldDescList*	pFieldList = pSelectionWindow->GetFieldDescList();
	SbaJoinTabWinMap*	pTabList   = pTabWinCont->GetTabWinMap();
	sal_uInt32 nTabCount	=	pTabList->Count();

	// ----------------- Feldliste aufbauen ----------------------
	// erst die Felder zaehlen
	sal_uInt32 nFieldCount = 0;
	for (sal_uInt32 i = 0; i < pFieldList->Count(); i++)
	{
		TabFieldDesc* pEntryField = pFieldList->GetObject(i);
		if(pEntryField->GetField().Len() && pEntryField->IsVisible())
			nFieldCount++;
	}
	if(!nFieldCount)	// keine Felder sichtbar also zur"uck
		return String();

	String	aFieldListStr(GenerateSelectList(pFieldList,nTabCount>1));
	if( !aFieldListStr.Len() )
		return String();
	// Ausnahmebehandlung, wenn keine Felder angegeben worden sind
	// Dann darf die Tabpage nicht gewechselt werden
	// Im TabBarSelectHdl wird der SQL-String auf STATEMENT_NOFIELDS abgefragt
	// und eine Errormeldung erzeugt
	// ----------------- Tabellenliste aufbauen ----------------------

	SbaJoinTabConnList*	pConnList  = pTabWinCont->GetTabConnList();
	String aTableListStr(GenerateFromClause(pTabList,pConnList));
	DBG_ASSERT(aTableListStr.Len(), "QueryDesignWin::GenerateSQL() : unerwartet : habe Felder, aber keine Tabellen !");
	// wenn es Felder gibt, koennen die nur durch Einfuegen aus einer schon existenten Tabelle entstanden sein; wenn andererseits
	// eine Tabelle geloescht wird, verschwinden auch die zugehoerigen Felder -> ergo KANN es das nicht geben, dass Felder
	// existieren, aber keine Tabellen (und aFieldListStr hat schon eine Laenge, das stelle ich oben sicher)
	String aHavingStr,aCriteriaListStr;
	// ----------------- Kriterien aufbauen ----------------------
	if (!GenerateCriterias(aCriteriaListStr,aHavingStr,pFieldList, nTabCount > 1))
		return String();

	String aJoinCrit;
	GenerateInnerJoinCriterias(aJoinCrit,pConnList);
	if(aJoinCrit.Len())
	{
		String aTmp;aTmp.AssignAscii("( ");
		(aTmp += aJoinCrit).AppendAscii(" )");
		if(aCriteriaListStr.Len())
		{
			aTmp += C_AND;
			aTmp += aCriteriaListStr;
		}
		aCriteriaListStr = aTmp;
	}
	// ----------------- Statement aufbauen ----------------------
	String aSqlCmd;aSqlCmd.AssignAscii("SELECT ");
	if(pSelectionWindow->IsDistinct())
		aSqlCmd.AppendAscii(" DISTINCT ");
	((aSqlCmd += aFieldListStr).AppendAscii(" FROM ")) += aTableListStr;

	if (aCriteriaListStr.Len())
	{
		aSqlCmd.AppendAscii(" WHERE ");
		aSqlCmd += aCriteriaListStr;
	}
	// ----------------- GroupBy aufbauen und Anh"angen ------------
	aSqlCmd += GenerateGroupBy(pFieldList,nTabCount > 1);
	// ----------------- having Anh"angen ------------
	if(aHavingStr.Len())
	{
		aSqlCmd.AppendAscii(" HAVING ");
		aSqlCmd += aHavingStr;
	}
	// ----------------- Sortierung aufbauen und Anh"angen ------------
	aSqlCmd += GenerateOrder(pFieldList,nTabCount > 1);

	return aSqlCmd;
}
//------------------------------------------------------------------------------
String QueryDesignWin::GenerateGroupBy(TabFieldDescList* pFieldList, sal_Bool bMulti ) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT( pFieldList!=0, "QueryDesignWin::GenerateGroupBy" );
	SdbDatabase* pDatabase = Shell()->GetDatabase();
	String aGroupByStr;
	for (sal_uInt32 j=0 ; j<pFieldList->Count() ; j++)
	{
		TabFieldDesc*	pEntryField = pFieldList->GetObject( j );
		if(pEntryField->IsGroupBy())
		{
			DBG_ASSERT(pEntryField->GetField().Len(),"Kein FieldName vorhanden!;-(");
			if (bMulti)
			{
				aGroupByStr += ConvertAlias(pEntryField->GetAlias());
				aGroupByStr += '.';
			}

			aGroupByStr += pDatabase->IdentifierQuotation(pEntryField->GetField());
			aGroupByStr += ',';
		}
	}
	if(aGroupByStr.Len())
	{
		aGroupByStr.EraseTrailingChars( ',' );
		String aGroupByStr2;aGroupByStr2.AssignAscii(" GROUP BY ");
		aGroupByStr2 += aGroupByStr;
		aGroupByStr = aGroupByStr2;
	}
	return aGroupByStr;
}
//------------------------------------------------------------------------------
sal_Bool QueryDesignWin::GenerateCriterias(String& rRetStr,String& rHavingStr/*,String& rOrderStr*/, TabFieldDescList* pFieldList, sal_Bool bMulti ) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT( pFieldList!=0, "QueryDesignWin::GenerateCriterias" );

	SdbDatabase* pDatabase = Shell()->GetDatabase();

	// * darf keine Filter enthalten : habe ich die entsprechende Warnung schon angezeigt ?
	sal_Bool bCritsOnAsterikWarning = sal_False;		// ** TMFS **

	String aFieldName,aCriteria,aWhereStr,aHavingStr,aWork/*,aOrderStr*/;
	// Zeilenweise werden die Ausdr"ucke mit AND verknuepft
	SdbSqlParser* pParser = pDatabase->GetSqlParser();
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(new SvNumberFormatsSupplierObj(pDatabase->GetFormatter()));
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >  xFormatter(::utl::getProcessServiceFactory()
										->createInstance(::rtl::OUString::createFromAscii("com.sun.star.util.NumberFormatter")), ::com::sun::star::uno::UNO_QUERY);
	xFormatter->attachNumberFormatsSupplier(xSupplier);
 	//	for (int i=0 ; i < MAX_CRITERIAS ; i++)
	sal_uInt32 nMaxCriteria = 0;
	for (ULONG k=0 ; k<pFieldList->Count() ; k++)
	{
		nMaxCriteria = ::std::max<sal_uInt32>(nMaxCriteria,(sal_uInt32)pFieldList->GetObject( k )->GetCriteria().size());
	}
	for (int i=0 ; i < nMaxCriteria ; i++)
	{
		aWhereStr.Erase();
		aHavingStr.Erase();
		for (sal_uInt32 j=0 ; j<pFieldList->Count() ; j++)
		{
			TabFieldDesc*	pEntryField = pFieldList->GetObject( j );
			aFieldName = pEntryField->GetField();

			if (!aFieldName.Len())
				continue;
			aCriteria = pEntryField->GetCriteria( i );
			if (aCriteria.Len())
			{
				if (aFieldName.GetChar(0) == '*')				// * darf keine Filter besitzen
				{
					// die entsprechende MessageBox nur beim ersten mal anzeigen
					if (!bCritsOnAsterikWarning)
						ErrorBox((QueryDesignWin*)this, SbaResId( ERR_QRY_CRITERIA_ON_ASTERISK)).Execute();
					bCritsOnAsterikWarning = sal_True;
					continue;
				}
				aWork.Erase();

				if (bMulti)
				{
					aWork += ConvertAlias(pEntryField->GetAlias());
					aWork += '.';
				}
				aWork += pDatabase->IdentifierQuotation(aFieldName);
				if(pEntryField->GetFunctionType() == FKT_AGGREGATE || pEntryField->IsGroupBy())
				{
					if (!aHavingStr.Len())			// noch keine Kriterien
						aHavingStr += '(';			// Klammern
					else
						aHavingStr += C_AND;

					if(pEntryField->GetFunctionType() == FKT_AGGREGATE)
					{
						aHavingStr += pEntryField->GetFunction();
						aHavingStr += '(';			// Klammern
						aHavingStr += aWork;
						aHavingStr += ')';			// Klammern
					}
					else
						aHavingStr += aWork;

					aHavingStr += aCriteria;
				}
				else
				{
					if (!aWhereStr.Len())			// noch keine Kriterien
						aWhereStr += '(';			// Klammern
					else
						aWhereStr += C_AND;

					aWhereStr += ' ';
					// aCriteria could have some german numbers so I have to be sure here
					String aTmp(aCriteria);
					QueryTabWin* pWin = ((QueryTabWin*)pEntryField->GetTabWindow());
					::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xField;
					if (pWin)
					{
						// field as propertyset
						SbaColumnList &xColumns = pWin->GetTableDef()->GetColumns();
						const SbaColumn* pCol = xColumns.Lookup(aFieldName,String());
						if(pCol)
							xField = new SbaXdbFieldDefinition(NULL, *pCol);
							//	xField = new SbaXdbFieldDefinition(NULL, *(*xColumns)[aFieldName]);
						//	SdbColumnsRef xColumns = pWin->GetTableDef()->GetTable()->Columns();
							
					}
					String aErrorMsg;
					SdbSqlParseNode* pParseNode = pParser->PredicateTree(aErrorMsg, aTmp, xFormatter, Application::GetAppInternational(), xField);
					if (pParseNode)
					{
						if (bMulti)
							pParseNode->Replace(ConvertAlias(pEntryField->GetAlias()),aFieldName);
						pParseNode->ParseNodeToStr(aWhereStr,pDatabase->GetMetaData(),sal_False,sal_True);
						delete pParseNode;
					}
					else
					{
						aWhereStr += aWork;
						aWhereStr += aCriteria;
					}

				}
			}
			// nur einmal fr jedes Feld
			else if(!i && pEntryField->GetFunctionType() == FKT_CONDITION)
			{
				if (!aWhereStr.Len())			// noch keine Kriterien
					aWhereStr += '(';			// Klammern
				else
					aWhereStr += C_AND;
				aWhereStr += pEntryField->GetField();
			}
		}
		if (aWhereStr.Len())
		{
			aWhereStr += ')';						// Klammern zu fuer 'AND' Zweig
			if (rRetStr.Len())							// schon Feldbedingungen ?
				rRetStr += C_OR;
			else										// Klammern auf fuer 'OR' Zweig
				rRetStr += '(';
			rRetStr += aWhereStr;
		}
		if (aHavingStr.Len())
		{
			aHavingStr += ')';						// Klammern zu fuer 'AND' Zweig
			if (rHavingStr.Len())							// schon Feldbedingungen ?
				rHavingStr += C_OR;
			else										// Klammern auf fuer 'OR' Zweig
				rHavingStr += '(';
			rHavingStr += aHavingStr;
		}
	}

	if (rRetStr.Len())
		rRetStr += ')';								// Klammern zu fuer 'OR' Zweig
	if (rHavingStr.Len())
		rHavingStr += ')';								// Klammern zu fuer 'OR' Zweig
	return sal_True;
}

//------------------------------------------------------------------------------

String QueryDesignWin::GenerateOrder( TabFieldDescList* pFieldList,sal_Bool bMulti ) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	String aRetStr, aWorkStr,aColumnName;
	SdbDatabase* pDatabase = Shell()->GetDatabase();
	DBG_ASSERT(pDatabase,"pDatabase == NULL");

	// * darf keine Filter enthalten : habe ich die entsprechende Warnung schon angezeigt ?
	sal_Bool bCritsOnAsterikWarning = sal_False;		// ** TMFS **
	for (sal_uInt32 i=0 ; i<pFieldList->Count() ; i++ )
	{
		TabFieldDesc*	pEntryField = pFieldList->GetObject( i );
		SbaOrderDir		eOrder = pEntryField->GetOrderDir();

		// nur wenn eine Sortierung und ein Tabellenname vorhanden ist-> erzeugen
		// sonst werden die Expressions vom Order By im GenerateCriteria mit erzeugt
		if (eOrder != ORDER_NONE && pEntryField->GetTable().Len())
		{
			aColumnName = pEntryField->GetField();
			if(aColumnName.GetChar(0) == '*')
			{
				// die entsprechende MessageBox nur beim ersten mal anzeigen
				if (!bCritsOnAsterikWarning)
					ErrorBox((QueryDesignWin*)this, SbaResId( ERR_QRY_ORDERBY_ON_ASTERISK)).Execute();
				bCritsOnAsterikWarning = sal_True;
				continue;
			}
			if(pEntryField->GetFunctionType() == FKT_NONE)
			{
				if (bMulti && pEntryField->GetAlias().Len())
				{
					aWorkStr += ConvertAlias(pEntryField->GetAlias());
					aWorkStr += '.';
				}
				aWorkStr += pDatabase->IdentifierQuotation(aColumnName);
			}
			else if(pEntryField->GetFieldAlias().Len())
			{
				aWorkStr += pDatabase->IdentifierQuotation(pEntryField->GetFieldAlias());
			}
			else if(pEntryField->GetFunctionType() == FKT_AGGREGATE)
			{
				DBG_ASSERT(pEntryField->GetFunction().Len(),"Functionname darf hier nicht leer sein! ;-(");
				aWorkStr += pEntryField->GetFunction();
				aWorkStr +=  '(';
				if (bMulti && pEntryField->GetAlias().Len())
				{
					aWorkStr += ConvertAlias(pEntryField->GetAlias());
					aWorkStr += '.';
				}
				aWorkStr += pDatabase->IdentifierQuotation(aColumnName);
				aWorkStr +=  ')';
			}
			else
			{
				if (bMulti && pEntryField->GetAlias().Len())
				{
					aWorkStr += ConvertAlias(pEntryField->GetAlias());
					aWorkStr += '.';
				}
				aWorkStr += pDatabase->IdentifierQuotation(aColumnName);
			}
			aWorkStr += ' ';
			aWorkStr += String::CreateFromAscii( ";ASC;DESC" ).GetToken( eOrder );
			aWorkStr += ',';
		}
	}
	aWorkStr.EraseTrailingChars( ',' );

	if( aWorkStr.Len() )
	{
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = pDatabase->GetMetaData();
		sal_Int32 nMaxOrder = rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMNS_IN_ORDERBY);
		if(nMaxOrder && nMaxOrder < aWorkStr.GetTokenCount(','))
		{
			ErrorBox aBox( (QueryDesignWin*)this, SbaResId( ERR_QRY_TOO_LONG_STATEMENT ) );
			aBox.Execute();
		}
		else
		{
			aRetStr.AssignAscii(" ORDER BY ");
			aRetStr += aWorkStr;
		}
	}

	return aRetStr;
}

//------------------------------------------------------------------------------

String QueryDesignWin::BuildACriteria( const String& rVal, SdbDatabaseType aType ) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	String	aRetStr;
	String	aVal;
	String aOpList;aOpList.AssignAscii("<>;>=;<=;<;>;=;LIKE");
	xub_StrLen	nOpListCnt = aOpList.GetTokenCount();

	String aToken;
	for( xub_StrLen nIdx=0 ; nIdx < nOpListCnt ; nIdx++ )
	{
		aToken = aOpList.GetToken(nIdx);
		if (rVal.Search( aToken ) == 0)
		{
			aRetStr = ' ';
			aRetStr += aToken;
			aRetStr += ' ';
			aVal = rVal.Copy( aToken.Len() );
			aVal.EraseLeadingChars( ' ' );
			if( aVal.Search( '\'' ) == STRING_NOTFOUND )//XXX O'Brien???
			{
				aVal = QuoteField( aVal, aType );
			}
			aRetStr += aVal;
			break;
		}
	}

	if( !aRetStr.Len()) //  == 0
	{
		aRetStr = rVal.Search( '%' ) == STRING_NOTFOUND ? String::CreateFromAscii(" = ") : String::CreateFromAscii(" LIKE ");
		aVal = rVal;
		if( aVal.Search( '\'' ) == STRING_NOTFOUND )//XXX O'Brien???
		{
			aVal = QuoteField( aVal, aType );
		}
		aRetStr += aVal;
	}

	return aRetStr;//XXX
}

//------------------------------------------------------------------------------
void QueryDesignWin::SaveUIConfig()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	SbaQueryDocSh* pDocSh = Shell();
	if (pDocSh)
	{
		pDocSh->SaveTabWinsPosSize( pTabWinCont->GetTabWinMap(), aHScrollBar.GetThumbPos(), aVScrollBar.GetThumbPos() );
		pDocSh->SaveTabFieldsWidth( pSelectionWindow );
		pDocSh->SaveNonVisibleRows( pSelectionWindow );
		pDocSh->SaveSplitPos( GetSplitPos() );
	}
}

//------------------------------------------------------------------------------
void QueryDesignWin::SaveTabWinUIConfig(QueryTabWin* pWin)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	SbaQueryDocSh* pDocSh = Shell();
	if (pDocSh)
		pDocSh->SaveTabWinPosSize(pWin, aHScrollBar.GetThumbPos(), aVScrollBar.GetThumbPos());
}

//------------------------------------------------------------------------------

sal_Bool QueryDesignWin::InsertField( const TabFieldDesc& rInfo, sal_Bool bVis, sal_Bool bActivate)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if(!pSelectionWindow->InsertField( rInfo, -1,bVis, bActivate ))
	{
		ErrorBox aBox(this, SbaResId( ERR_QRY_TOO_MANY_COLUMNS));
		aBox.Execute();
		return sal_False;
	}
	return sal_True;
}

//------------------------------------------------------------------------------
void QueryDesignWin::DeleteFields( const String& rAliasName )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	pSelectionWindow->DeleteFields( rAliasName );
}

//------------------------------------------------------------------------------
void QueryDesignWin::AddTable( const String& strCatName, const String& strTabName, const sal_Unicode* pAlias, sal_Bool bNewTable )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT(pTabWinCont->ISA(QueryTabWinContainer), "QueryDesignWin::AddTable : falscher ::com::sun::star::sdbcx::Container-Typ !");
	if (pAlias)
		((QueryTabWinContainer*)pTabWinCont)->AddTabWin( strCatName, strTabName, pAlias, bNewTable );
	else
	{
		SdbDatabase* pDatabase = Shell()->GetDatabase();
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDatabase->GetMetaData());
		sal_Bool bQualifier	= ::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::CATALOG_USAGE)) & ::com::sun::star::data::DatabaseQualifier::IN_DML;
		sal_Bool bOwner		= ::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SCHEMA_USAGE))  & ::com::sun::star::data::DatabaseQualifier::IN_DML;

		String aTabName = bOwner ? ( strTabName.GetTokenCount('.') ? strTabName.GetToken(1,'.') : strTabName) : strTabName;
		((QueryTabWinContainer*)pTabWinCont)->AddTabWin( strCatName, strTabName, ConvertAlias(aTabName), bNewTable );
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(QueryDesignWin, OnTabWinsChanged, TabWinsChangeNotification*, pHint)
{
	if (GetSelectionWin() && GetSelectionWin()->IsEditing())
	{
		GetSelectionWin()->DeactivateCell();
		GetSelectionWin()->ActivateCell();
	}
	return 0L;
}

//------------------------------------------------------------------------------
void QueryDesignWin::InitFromParseNode()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	SdbSqlParseNode* pParseTree = (SdbSqlParseNode*)Shell()->ParseTree();
	SdbSqlParseNode* pTableRefCommaList = 0;

	if (pParseTree)
	{
		if (Shell()->IsNative())
		{
			WarningBox( this, SbaResId(WARN_QRY_NATIVE) ).Execute();
		}
		else if (SDB_ISRULE(pParseTree,select_statement))
		{

			SdbSqlParseNode* pTree = pParseTree->GetChild(1);
			pSelectionWindow->SetDistinct(pTree && pTree->GetTokenID() == SDB_TOKEN_DISTINCT);
			const SbaParseIterator& aIter = Shell()->Iterator();
			const SdbTableRangeMap& aMap = aIter.GetSdbTableRangeMap();
			SdbDatabase* pDatabase = Shell()->GetDatabase();
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDatabase->GetMetaData());
			sal_Int32 nMax = rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::TABLES_IN_SELECT);
			if(!nMax || nMax >= aMap.Count()) // Anzahl der Tabellen im Select-Statement "uberpr"ufen
			{
				String aTableName;
				String aQualifierName;
				BOOL bCase = (pDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
				for(sal_uInt32 i=0;i<aMap.Count();i++)
				{
					SdbTableRef* pTableRef	= aMap.GetObject(i);
					const String& aAlias	= aMap.GetKey(pTableRef);
					aTableName				= *pTableRef != NULL ? (*pTableRef)->GetFullName() : String();

					String sCatalog, sSchema, sTable;
					pDatabase->QualifiedNameComponents(aTableName, sCatalog, sSchema, sTable);
					String sRealName(sSchema);
					if (sRealName.Len())
						sRealName+= '.';
					sRealName += sTable;

					aQualifierName			= *pTableRef != NULL ? (*pTableRef)->QualifierName() : String();

					QueryTabWin* pExistentWin	= ((QueryTabWinContainer*)pTabWinCont)->FindTable(aAlias);
					if (!pExistentWin)
					{
						AddTable(aQualifierName, sRealName, aAlias.GetBuffer());
					}
					else
					{
						// es existiert schon ein Fenster mit dem selben Alias ...
						String aFullWinName(pExistentWin->GetData()->GetDatabaseName());
						if(aFullWinName.Len())
							aFullWinName += pDatabase->GetQualifierSeparator();
						aFullWinName += pExistentWin->GetData()->GetTableName();

						if (bCase ? aTableName != aFullWinName : !aTableName.EqualsIgnoreCaseAscii(aFullWinName)) 
							// ... aber anderem Tabellennamen -> neues Fenster
							AddTable(aQualifierName, sRealName, aAlias.GetBuffer());
					}
				}

				FillOuterJoins(pParseTree->GetChild(3)->GetChild(0)->GetChild(1));

				if (!InstallFields(pParseTree, pTabWinCont->GetTabWinMap()))
				{
					// GetSelectionCriteria mu"s vor GetHavingCriteria aufgerufen werden
					int nLevel=0;

					::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier(new SvNumberFormatsSupplierObj(pDatabase->GetFormatter()));
					::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter >  xFormatter(::utl::getProcessServiceFactory()
										->createInstance(::rtl::OUString::createFromAscii("com.sun.star.util.NumberFormatter")), ::com::sun::star::uno::UNO_QUERY);
					xFormatter->attachNumberFormatsSupplier(xSupplier);

					GetSelectionCriteria(pParseTree,nLevel,xFormatter,sal_True);
					GetGroupCriteria(pParseTree);
					GetHavingCriteria(pParseTree,nLevel,xFormatter);
					GetOrderCriteria(pParseTree);
				}
			}
			else
			{
				ErrorBox aBox(this, SbaResId( ERR_QRY_TOO_MANY_TABLES));
				aBox.Execute();
			}
		}
		else
		{
			ErrorBox aBox(this, SbaResId( ERR_QRY_NOSELECT));
			aBox.Execute();
		}
	}

	// Durch das Neuerzeugen wurden wieder Undo-Actions in den Manager gestellt
	Shell()->GetUndoMgr()->Clear();
}

//------------------------------------------------------------------------------
sal_uInt32 QueryDesignWin::GetColumnFormatKey(const SdbSqlParseNode* pColumnRef)
{
	String aTableRange,aColumnName;
	Shell()->Iterator().GetColumnRange( pColumnRef, aColumnName, aTableRange );
	QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
	QueryTabWin* pSTW = NULL;
	if (aTableRange.Len())
		pSTW = (QueryTabWin*)pQueryTabWinCont->FindTable( aTableRange );
	else if(pQueryTabWinCont->GetTabWinMap()->Count())
		pSTW = (QueryTabWin*)pQueryTabWinCont->GetTabWinMap()->GetObject(0);
	sal_uInt32 nFormatKey = 0;
	if(pSTW)
	{
		SbaTableDefRef pTable = pSTW->GetTableDef();
		if(pTable.Is())
		{
			const SbaColumn* pCol = pTable->GetColumns().Lookup(aColumnName,String());
			if(pCol)
			{
				SFX_ITEMSET_GET(*pCol, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True );
				return pFormat ? pFormat->GetValue() : 0;
			}
		}
	}
	return nFormatKey;
}
//------------------------------------------------------------------------------
sal_Bool QueryDesignWin::FillDragInfo(SdbSqlParseNode* pColumnRef,TabFieldDesc& aDragInfo)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	sal_Bool bErg = sal_True;

	String aTableRange,aColumnName;
	sal_uInt16 nCntAccount;
	Shell()->Iterator().GetColumnRange( pColumnRef, aColumnName, aTableRange );
	QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
	if (aTableRange.Len())
	{
		QueryTabWin*	pSTW = pQueryTabWinCont->FindTable( aTableRange );
		if(!( pSTW && pSTW->ExistsField( aColumnName, aDragInfo ) ))
			bErg = sal_False;
	}
	else
		bErg = pQueryTabWinCont->FindTableFromField(aColumnName, aDragInfo, nCntAccount);

	return bErg;
}

//-----------------------------------------------------------------------------
sal_Bool QueryDesignWin::InsertJoin(SdbSqlParseNode *pNode)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT(SDB_ISRULE(pNode, qualified_join) || SDB_ISRULE(pNode, joined_table),
		"QueryDesignWin::InsertJoin: Fehler im Parse Tree");

	if (SDB_ISRULE(pNode,joined_table))
		return InsertJoin(pNode->GetChild(1));

	if (SDB_ISRULE(pNode->GetChild(0),qualified_join))
	{
		if (!InsertJoin(pNode->GetChild(0)))
			return sal_False;
	}
	else if (SDB_ISRULE(pNode->GetChild(0), joined_table))
	{
		if (!InsertJoin(pNode->GetChild(0)->GetChild(1)))
			return sal_False;
	}
	else if (!SDB_ISRULE(pNode->GetChild(0), table_ref) ||
		!SDB_ISRULE(pNode->GetChild(0)->GetChild(0), table_name))
		return sal_False;

	// geschachtelter join?
	if (SDB_ISRULE(pNode->GetChild(3),qualified_join))
	{
		if (!InsertJoin(pNode->GetChild(3)))
			return sal_False;
	}
	else if (SDB_ISRULE(pNode->GetChild(3), joined_table))
	{
		if (!InsertJoin(pNode->GetChild(3)->GetChild(1)))
			return sal_False;
	}
	// sonst sollte es eine Tabelle sein
	else if (!SDB_ISRULE(pNode->GetChild(3), table_ref) ||
		!SDB_ISRULE(pNode->GetChild(3)->GetChild(0), table_name))
		return sal_False;

	// named column join wird spter vieleicht noch implementiert
	// SDB_ISRULE(pNode->GetChild(4),named_columns_join)
	if (SDB_ISRULE(pNode->GetChild(4),join_condition))
	{
		SbaJoinType eJoinType;
		SdbSqlParseNode* pJoinType = pNode->GetChild(1); // join_type
		if (SDB_ISRULE(pJoinType,join_type) && SDB_ISTOKEN(pJoinType->GetChild(0),"INNER"))
		{
			eJoinType = SBA_INNER_JOIN;
		}
		else
		{
			if (SDB_ISRULE(pJoinType,join_type))	   // eine Ebene tiefer
				pJoinType = pJoinType->GetChild(0);

			if (SDB_ISTOKEN(pJoinType->GetChild(0),"LEFT"))
				eJoinType = SBA_LEFT_JOIN;
			else if(SDB_ISTOKEN(pJoinType->GetChild(0),"RIGHT"))
				eJoinType = SBA_RIGHT_JOIN;
			else
				eJoinType = SBA_FULL_JOIN;
		}
		if(!InsertJoinConnection(pNode->GetChild(4)->GetChild(1), eJoinType))
			return sal_False;
	}
	else
		return sal_False;

	return sal_True;
}

//-----------------------------------------------------------------------------
sal_Bool QueryDesignWin::InsertJoinConnection(SdbSqlParseNode *pNode, const SbaJoinType& _eJoinType)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);

	if (pNode->Count() == 3 &&	// Ausdruck is geklammert
		SDB_ISPUNCTUATION(pNode->GetChild(0),"(") &&
		SDB_ISPUNCTUATION(pNode->GetChild(2),")"))
	{
		return InsertJoinConnection(pNode->GetChild(1), _eJoinType);
	}
	else if (SDB_ISRULE(pNode,search_condition) ||
			 SDB_ISRULE(pNode,boolean_term)	&&			// AND/OR-Verknuepfung:
			 pNode->Count() == 3)
	{
		// nur AND Verknpfung zulassen
		if (!SDB_ISTOKEN(pNode->GetChild(1),"AND"))
			return sal_False;
		else
			return InsertJoinConnection(pNode->GetChild(0), _eJoinType) &&
				   InsertJoinConnection(pNode->GetChild(2), _eJoinType);
	}
	else if (SDB_ISRULE(pNode,comparison_predicate))
	{
		// Nur ein Vergleich auf Spalten ist erlaubt
		DBG_ASSERT(pNode->Count() == 3,"QueryDesignWin::InsertJoinConnection: Fehler im Parse Tree");
		if (!(SDB_ISRULE(pNode->GetChild(0),column_ref) &&
			  SDB_ISRULE(pNode->GetChild(2),column_ref) &&
			   pNode->GetChild(1)->GetNodeType() == SDB_SQL_EQUAL))
			return sal_False;

		TabFieldDesc aDragLeft, aDragRight;
		if (!FillDragInfo(pNode->GetChild(0),aDragLeft) ||
			!FillDragInfo(pNode->GetChild(2),aDragRight))
			return sal_False;

		QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
		QueryTabConn* pConn = (QueryTabConn*) pQueryTabWinCont->GetTabConn((QueryTabWin*)aDragLeft.GetTabWindow(),(QueryTabWin*)aDragRight.GetTabWindow());
		if(!pConn)
		{
			QueryTabConnData aInfoData;
			aInfoData.InitFromDrag(aDragLeft, aDragRight);
			aInfoData.SetJoinType(_eJoinType);

			QueryTabConn aInfo(pQueryTabWinCont, &aInfoData);
			// da ein QueryTabConn-Objekt nie den Besitz der uebergebenen Daten uebernimmt, sondern sich nur den Zeiger merkt,
			// ist dieser Zeiger auf eine lokale Variable hier unkritisch, denn aInfoData und aInfo haben die selbe Lebensdauer
			pQueryTabWinCont->NotifyTabConnection( aInfo );
		}
		else
		{
			String aSourceFieldName(aDragLeft.GetField());
			String aDestFieldName(aDragRight.GetField());
			// the connection could point on the other side
			if(pConn->GetSourceWin() == aDragRight.GetTabWindow())
			{
				String aTmp(aSourceFieldName);
				aSourceFieldName = aDestFieldName;
				aDestFieldName = aTmp;
			}
			pConn->GetData()->AppendConnLine( aSourceFieldName,aDestFieldName);
			pConn->UpdateLineList();
			// Modified-Flag
			SetModified();
			// und neu zeichnen
			pConn->RecalcLines();
				// fuer das unten folgende Invalidate muss ich dieser neuen Connection erst mal die Moeglichkeit geben,
				// ihr BoundingRect zu ermitteln
			pConn->Invalidate();
		}
		return sal_True;
	}
	else
		return sal_False;
}

//------------------------------------------------------------------------------
void QueryDesignWin::FillOuterJoins(SdbSqlParseNode* pTableRefList)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);

	sal_uInt16 nCount = pTableRefList->Count();

	if (nCount == 0)
	{
		ErrorBox( this, SbaResId( ERR_QRY_ILLEGAL_JOIN ) ).Execute();
		return;
	}
	else
	{
		for (sal_uInt16 i=0; i < nCount; i++)
		{
			SdbSqlParseNode* pParseNode = pTableRefList->GetChild(i);
			if (SDB_ISRULE(pParseNode , qualified_join)	||
				SDB_ISRULE(pParseNode , joined_table))
			{
				if (!InsertJoin(pParseNode))
				{
					ErrorBox( this, SbaResId( ERR_QRY_ILLEGAL_JOIN ) ).Execute();
					return;
				}
			}
			else if(pParseNode->Count() == 4 && SDB_ISPUNCTUATION(pParseNode->GetChild(0),"{") && SDB_ISRULE(pParseNode,table_ref))
			{
				if (!InsertJoin(pParseNode->GetChild(2)))
				{
					ErrorBox( this, SbaResId( ERR_QRY_ILLEGAL_JOIN ) ).Execute();
					return;
				}
			}
		}
	}
}

//------------------------------------------------------------------------------
void QueryDesignWin::GetHavingCriteria( SdbSqlParseNode* pSelectRoot, int &rLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if (!pSelectRoot->GetChild(3)->GetChild(3)->IsLeaf())
		GetORCriteria(pSelectRoot->GetChild(3)->GetChild(3)->GetChild(1),rLevel,xFormatter, sal_True);
}

//------------------------------------------------------------------------------
void QueryDesignWin::GetGroupCriteria( SdbSqlParseNode* pSelectRoot )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);

	QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
	if (!pSelectRoot->GetChild(3)->GetChild(2)->IsLeaf())
	{
		SdbSqlParseNode* pGroupBy = pSelectRoot->GetChild(3)->GetChild(2)->GetChild(2);
		TabFieldDesc aDragInfo;
		for( sal_uInt32 i=0 ; i < pGroupBy->Count() ; i++ )
		{
			SdbSqlParseNode* pColumnRef = pGroupBy->GetChild( i );
			if(SDB_ISRULE(pColumnRef,column_ref))
			{
				FillDragInfo(pColumnRef,aDragInfo);
				aDragInfo.SetGroupBy(sal_True);
				pSelectionWindow->AddGroupBy(aDragInfo);
			}
		}
	}
}

//------------------------------------------------------------------------------
void QueryDesignWin::GetOrderCriteria( SdbSqlParseNode* pParseRoot )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if (!pParseRoot->GetChild(3)->GetChild(4)->IsLeaf())
	{
		SdbSqlParseNode* pNode = pParseRoot->GetChild(3)->GetChild(4)->GetChild(2);
		SdbSqlParseNode* pParamRef = NULL;
		String	aField, aAlias;
		sal_uInt16 nPos = 0;

		SbaOrderDir eOrderDir;
		TabFieldDesc		aDragLeft;
		for( sal_uInt32 i=0 ; i<pNode->Count() ; i++ )
		{
			eOrderDir = ORDER_ASC;
			SdbSqlParseNode*	pChild = pNode->GetChild( i );
			
			if (SDB_ISTOKEN( pChild->GetChild(1), "DESC" ) )
				eOrderDir = ORDER_DESC;

			if(SDB_ISRULE(pChild->GetChild(0),column_ref))
			{
				if(FillDragInfo(pChild->GetChild(0),aDragLeft))
					pSelectionWindow->AddOrder( aDragLeft, eOrderDir, nPos);
				else // it could be a alias name for a field
				{
					String aTableRange,aColumnName;
					Shell()->Iterator().GetColumnRange( pChild->GetChild(0), aColumnName, aTableRange );
					const TabFieldDescList* pList = pSelectionWindow->GetFieldDescList();
					for(sal_Int32 i=0;i<pList->Count();++i)
					{
						TabFieldDesc* pEntry = pList->GetObject(i);
						if(pEntry && pEntry->GetFieldAlias() == aColumnName)
							pEntry->SetOrderDir( eOrderDir );
					}
				}
			}
			else if(SDB_ISRULE(pChild->GetChild(0),general_set_fct) &&
					SDB_ISRULE(pParamRef = pChild->GetChild(0)->GetChild(pChild->GetChild(0)->Count()-2),column_ref) && 
					FillDragInfo(pParamRef,aDragLeft))
				pSelectionWindow->AddOrder( aDragLeft, eOrderDir, nPos);
		}
	}
}

//------------------------------------------------------------------------------

int QueryDesignWin::InstallFields( SdbSqlParseNode* pNode, SbaJoinTabWinMap* pTabList )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if( pNode==0 || !SDB_ISRULE(pNode,select_statement))
	{
		ErrorBox	aBox( this, SbaResId( ERR_QRY_NOSELECT ) );
		aBox.Execute();
		return 1;
	}

	SdbSqlParseNode* pParseTree = pNode->GetChild(2);
	sal_Bool bFirstField = sal_True;	// bei der Initialisierung mu auf alle Faelle das erste Feld neu aktiviert werden

	if(pParseTree->IsRule() && SDB_ISPUNCTUATION(pParseTree->GetChild(0),"*"))
	{
		// SELECT * ...

		TabFieldDesc	aInfo;
		for (sal_uInt32 i=0 ; i < pTabList->Count() ; i++)
		{
			QueryTabWin* pTabWin = (QueryTabWin*)(pTabList->GetObject(i));

			if (pTabWin->ExistsField( String::CreateFromAscii("*"), aInfo ))
			{
				if(!InsertField(aInfo, sal_True, bFirstField))
					return 1;
				bFirstField = sal_False;
			}
		}

		// Einfach alle Columns der Datei direkt uebernehmen:
	}
	else if (SDB_ISRULE(pParseTree,scalar_exp_commalist) )
	{
		// SELECT column, ...

		String aColumnName,aTableRange;
		for (sal_uInt32 i = 0; i < pParseTree->Count(); i++)
		{
			SdbSqlParseNode * pColumnRef = pParseTree->GetChild(i);

			if (SDB_ISRULE(pColumnRef,select_sublist))
			{
				TabFieldDesc aInfo;
				for (sal_uInt32 i=0 ; i < pTabList->Count() ; i++)
				{
					QueryTabWin* pTabWin = (QueryTabWin*)(pTabList->GetObject(i));

					if (pTabWin->ExistsField( String::CreateFromAscii("*"), aInfo ))
					{
						if(!InsertField(aInfo, sal_True, bFirstField))
							return 1;

						bFirstField = sal_False;
					}
				}
			}
			else if (SDB_ISRULE(pColumnRef,derived_column))
			{
				String aColumnAlias(Shell()->Iterator().GetColumnAlias(pColumnRef)); // kann leer sein
				pColumnRef = pColumnRef->GetChild(0);
				if (SDB_ISRULE(pColumnRef,column_ref))
				{
					TabFieldDesc aInfo;
					switch(InsertColumnRef(pColumnRef,aColumnName,aColumnAlias,aTableRange,aInfo,pTabList))
					{
						case 5:
							ErrorBox( this, SbaResId( ERR_QRY_AMB_FIELD ) ).Execute();
							break;
						default:
							if(!InsertField(aInfo, sal_True, bFirstField))
							return 1;
						bFirstField = sal_False;
					}
				}
				else if(SDB_ISRULE(pColumnRef,general_set_fct)	|| SDB_ISRULE(pColumnRef,set_fct_spec)	||
						SDB_ISRULE(pColumnRef,position_exp)		|| SDB_ISRULE(pColumnRef,extract_exp)	||
						SDB_ISRULE(pColumnRef,length_exp)		|| SDB_ISRULE(pColumnRef,char_value_fct))
				{
					TabFieldDesc	aInfo;
					String aColumns;

					pColumnRef->ParseNodeToStr(aColumns,Shell()->GetDatabase()->GetMetaData(),sal_True,sal_False);

					SdbSqlParseNode * pParamRef = pColumnRef->GetChild(pColumnRef->Count()-2);
					if (SDB_ISRULE(pColumnRef,general_set_fct)
						&& SDB_ISRULE(pParamRef = pColumnRef->GetChild(pColumnRef->Count()-2),column_ref))
					{
						// Parameter auf Columnref pr"ufen
						switch(InsertColumnRef(pParamRef,aColumnName,aColumnAlias,aTableRange,aInfo,pTabList))
						{
							case 5:
								ErrorBox( this, SbaResId( ERR_QRY_AMB_FIELD ) ).Execute();
								break;
						}
					}
					else
					{
						if(pParamRef && pParamRef->TokenValue().GetChar(0) == '*')
						{
							for (sal_uInt32 i=0 ; i < pTabList->Count() ; i++)
							{
								QueryTabWin* pTabWin = (QueryTabWin*)(pTabList->GetObject(i));
								if (pTabWin->ExistsField( String::CreateFromAscii("*"), aInfo ))
									break;
							}
						}
						else
						{
							aInfo.SetDataType(SDB_DBTYPE_DOUBLE);
							aInfo.SetFieldType(TAB_NORMAL_FIELD);
							aInfo.SetTabWindow(NULL);
							aInfo.SetField(aColumns);
							aInfo.SetFieldAlias(aColumnAlias);
						}
					}

					if(SDB_ISRULE(pColumnRef,general_set_fct))
					{
						aInfo.SetFunctionType(FKT_AGGREGATE);
						aInfo.SetFunction(aColumns.GetToken(0,'(').EraseTrailingChars(' '));
					}
					else
						aInfo.SetFunctionType(FKT_OTHER);

					if(!InsertField(aInfo, sal_True, bFirstField))
						return 1;
					bFirstField = sal_False;
				}
				else //if(SDB_ISRULE(pColumnRef,num_value_exp)	|| SDB_ISRULE(pColumnRef,term))
				{
					String aColumns;
					pColumnRef->ParseNodeToStr(aColumns,Shell()->GetDatabase()->GetMetaData(),sal_True,sal_False);

					TabFieldDesc	aInfo;
					aInfo.SetDataType(SDB_DBTYPE_DOUBLE);
					aInfo.SetFieldType(TAB_NORMAL_FIELD);
					aInfo.SetTabWindow(NULL);
					aInfo.SetField(aColumns);
					aInfo.SetFieldAlias(aColumnAlias);
					aInfo.SetFunctionType(FKT_OTHER);

					if(!InsertField(aInfo, sal_True, bFirstField))
						return 1;
					bFirstField = sal_False;
				}
			}
		}
	}
	else
	{
		ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
		return 4;
	}

	return 0;
}

//------------------------------------------------------------------------------
int QueryDesignWin::InsertColumnRef(const SdbSqlParseNode * pColumnRef,String& aColumnName,const String& aColumnAlias,
									String& aTableRange,TabFieldDesc& aInfo, SbaJoinTabWinMap* pTabList) const
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	// Tabellennamen zusammen setzen
	Shell()->Iterator().GetColumnRange(pColumnRef,aColumnName,aTableRange);
	DBG_ASSERT(aColumnName.Len(),"Columnname darf nicht leer sein");
	if (!aTableRange.Len())
	{
		// SELECT column, ...
		sal_Bool bFound(sal_False);
		for (sal_uInt32 i=0 ; i < pTabList->Count() ; i++)
		{
			QueryTabWin* pTabWin = (QueryTabWin*)(pTabList->GetObject(i));
			if (pTabWin->ExistsField( aColumnName, aInfo ) )
			{
				if(aColumnName.GetChar(0) != '*')
					aInfo.SetFieldAlias(aColumnAlias);
				bFound = sal_True;
				break;
			}
		}
		if (!bFound)
		{
			aInfo.SetTable(String());
			aInfo.SetAlias(String());
			aInfo.SetField(aColumnName);
			aInfo.SetFieldAlias(aColumnAlias);	// nyi : hier ein fortlaufendes Expr_1, Expr_2 ...
			aInfo.SetFunctionType(FKT_OTHER);
		}
	}
	else
	{
		// SELECT range.column, ...
		QueryTabWin* pTabWin = ((QueryTabWinContainer*)pTabWinCont)->FindTable(aTableRange);

		if (pTabWin && pTabWin->ExistsField(aColumnName, aInfo))
		{
			if(aColumnName.GetChar(0) != '*')
				aInfo.SetFieldAlias(aColumnAlias);
		}
		else
		{
			aInfo.SetTable(String());
			aInfo.SetAlias(String());
			aInfo.SetField(aColumnName);
			aInfo.SetFieldAlias(aColumnAlias);	// nyi : hier ein fortlaufendes Expr_1, Expr_2 ...
			aInfo.SetFunctionType(FKT_OTHER);
		}
	}
	return 0;
}
//------------------------------------------------------------------------------
void QueryDesignWin::GetTable(String& rDatabase, String& rTable, String& rAlias, SdbSqlParseNode* pNode)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	Shell()->GetTable(rDatabase, rTable, rAlias, pNode);
}

//------------------------------------------------------------------------------
int QueryDesignWin::GetSelectionCriteria( SdbSqlParseNode* pNode, int& rLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bJoinWhere)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	// Naechster freier Satz ...
	int	nRet = 0;
	int	nJoins=0;

	if (!SDB_ISRULE(pNode, select_statement))
	{
		ErrorBox	aBox( this, SbaResId( ERR_QRY_NOSELECT ) );
		aBox.Execute();
		return 1;
	}

	// nyi: mehr Pruefung auf korrekte Struktur!
	pNode = pNode ? pNode->GetChild(3)->GetChild(1) : NULL;
	// Keine WHERE-Klausel.
	if (!pNode || pNode->IsLeaf())
		return nRet;

	SdbSqlParseNode * pCondition = pNode->GetChild(1);
	if (!pCondition) // kein where clause
		return nRet;

	// jetzt die anderen Bedingungen eintragen
	SdbSqlParseNode::NegateSearchCondition(pCondition);

	SdbSqlParseNode *pNodeTmp = pNode->GetChild(1);
	SdbSqlParseNode::DisjunctiveNormalForm(pNodeTmp);
	pNodeTmp = pNode->GetChild(1);
	SdbSqlParseNode::Absorptions(pNodeTmp);
	pNodeTmp = pNode->GetChild(1);

	// first extract the inner joins conditions
	GetInnerJoinCriteria(pNodeTmp);

	// it could happen that pCondition is not more valid
	nRet = GetORCriteria(pNodeTmp, rLevel,xFormatter);

	if (nRet != 0)											   // mindestens eine OR Verknuepfung
	{
		ErrorBox aBox( this, SbaResId( ERR_QRY_TOOCOMPLEX ) );
		aBox.Execute();
		return 99;
	}
	return nRet;
}
//------------------------------------------------------------------------------
sal_Bool QueryDesignWin::GetInnerJoinCriteria(SdbSqlParseNode *pCondition)
{
	sal_Bool bFoundInnerJoin = sal_False;
	SdbSqlParseNode *pTmp=NULL;
	bFoundInnerJoin = InsertJoinConnection(pCondition, SBA_INNER_JOIN);
	return bFoundInnerJoin;
}
//------------------------------------------------------------------------------

int QueryDesignWin::GetORCriteria(SdbSqlParseNode * pCondition, int& nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter ,sal_Bool bHaving)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	int	nRet = 0;

	// Runde Klammern um den Ausdruck
	if (pCondition->Count() == 3 &&
		SDB_ISPUNCTUATION(pCondition->GetChild(0),"(") &&
		SDB_ISPUNCTUATION(pCondition->GetChild(2),")"))
	{
		nRet = GetORCriteria(pCondition->GetChild(1),nLevel,xFormatter,bHaving);
	}
	// oder Verknuepfung
	// a searchcondition can only look like this: search_condition SDB_TOKEN_OR boolean_term
	else if (SDB_ISRULE(pCondition,search_condition))
	{
		for (int i = 0; i < 3; i+=2)
		{
			// Ist das erste Element wieder eine OR-Verknuepfung?
			// Dann rekursiv absteigen ...
			//if (!i && SDB_ISRULE(pCondition->GetChild(i),search_condition))
			if (SDB_ISRULE(pCondition->GetChild(i),search_condition))
			{
				nRet = GetORCriteria(pCondition->GetChild(i),nLevel,xFormatter,bHaving);
			}
			else if (!nRet)
			{
				nRet = GetANDCriteria(pCondition->GetChild(i), nLevel++,xFormatter,bHaving);
			}
			else
			{
				ErrorBox aBox( this, SbaResId( ERR_QRY_TOOMANYCOND ) );
				aBox.Execute();
				return 1;
			}
		}
	}
	else
	{
		nRet = GetANDCriteria( pCondition, nLevel,xFormatter, bHaving );
	}
	return nRet;
}


//--------------------------------------------------------------------------------------------------
int QueryDesignWin::GetANDCriteria( SdbSqlParseNode * pCondition, const int nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter,sal_Bool bHaving )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	// ich werde ein paar Mal einen gecasteten Pointer auf meinen ::com::sun::star::sdbcx::Container brauchen
	QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
	int nRet = 0;

	// Runde Klammern
	if (SDB_ISRULE(pCondition,boolean_primary))
	{
		int nLevel2 = nLevel;
		nRet = GetORCriteria(pCondition->GetChild(1), nLevel2,xFormatter,bHaving );
	}
	// Das erste Element ist (wieder) eine AND-Verknuepfung
	else if ( SDB_ISRULE(pCondition,boolean_term) && pCondition->Count() == 3 )
	{
		nRet = GetANDCriteria(pCondition->GetChild(0), nLevel,xFormatter,bHaving );
		if (!nRet)
			nRet = GetANDCriteria(pCondition->GetChild(2), nLevel,xFormatter,bHaving );
	}
	else if (SDB_ISRULE( pCondition, comparison_predicate))
	{
		nRet = ComparsionPredicate(pCondition,nLevel,xFormatter,bHaving);
	}
	else if((SDB_ISRULE(pCondition,like_predicate)))
	{
		String			aCondition;
		TabFieldDesc	aDragLeft;
		if(SDB_ISRULE(pCondition->GetChild(0), column_ref ))
		{
			String aColumnName;
			// the international doesn't matter I have a string
			pCondition->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());
			pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());

			// don't display the column name
			aCondition.Erase(0, aColumnName.Len());
			aCondition.EraseLeadingChars();

			if (FillDragInfo(pCondition->GetChild(0),aDragLeft))
				pSelectionWindow->AddCondition(aDragLeft, aCondition, nLevel);
			else
			{
				ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
				nRet = 5;
			}
		}
		else
		{
			ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
			nRet = 5;
		}
	}
	else if((SDB_ISRULE(pCondition,test_for_null) || SDB_ISRULE(pCondition,in_predicate) ||
						SDB_ISRULE(pCondition,all_or_any_predicate) || SDB_ISRULE(pCondition,between_predicate)))
	{
		String			aCondition;
		TabFieldDesc	aDragLeft;
		if(SDB_ISRULE(pCondition->GetChild(0), column_ref ))
		{
			International aInter(Shell()->BuildInternational(GetColumnFormatKey(pCondition->GetChild(0))));
			// Bedingung parsen
			for(sal_uInt16 i=1;i< pCondition->Count();i++)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, aInter);
		}

		if (FillDragInfo(pCondition->GetChild(0),aDragLeft))
			pSelectionWindow->AddCondition(aDragLeft, aCondition, nLevel);
		else
		{
			ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
			nRet = 5;
		}
	}
	else if((SDB_ISRULE(pCondition,existence_test) || SDB_ISRULE(pCondition,unique_test)))
	{
		String			aCondition;
		TabFieldDesc	aDragLeft;

		// Funktions-Bedingung parsen
		for(sal_uInt16 i=0;i< pCondition->Count();i++)
			pCondition->GetChild(i)->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());

		aDragLeft.SetField(aCondition);
		aDragLeft.SetFunctionType(FKT_CONDITION);

		pSelectionWindow->InsertField(aDragLeft,-1,sal_False,sal_True);
	}
	else
	{
		// Etwas anderes unterstuetzen wir (noch) nicht. Basta!
		ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
		nRet = 5;
	}
	// Fehler einfach weiterreichen.
	return nRet;
}
//------------------------------------------------------------------------------
int QueryDesignWin::ComparsionPredicate( SdbSqlParseNode * pCondition, const int nLevel, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatter > & xFormatter, sal_Bool bHaving )
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT(SDB_ISRULE( pCondition, comparison_predicate),"ComparsionPredicate: pCondition ist kein ComparsionPredicate");
	int nRet = 0;
	if(SDB_ISRULE(pCondition->GetChild(0), column_ref ) || SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref ))
	{
		String			aCondition;
		TabFieldDesc	aDragLeft;
		sal_uInt16 nPos;
		if(SDB_ISRULE(pCondition->GetChild(0), column_ref ) && SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref ))
		{
			TabFieldDesc aDragRight;
			if (!FillDragInfo(pCondition->GetChild(0),aDragLeft) ||
				!FillDragInfo(pCondition->GetChild(2),aDragRight))
				return nRet;

			QueryTabWinContainer* pQueryTabWinCont = (QueryTabWinContainer*)pTabWinCont;
			QueryTabConn* pConn = (QueryTabConn*) pQueryTabWinCont->GetTabConn((QueryTabWin*)aDragLeft.GetTabWindow(),(QueryTabWin*)aDragRight.GetTabWindow());
			if(pConn)
			{
				SbaJoinConnLineDataList* pLineDataList = pConn->GetData()->GetConnLineDataList();
				SbaJoinConnLineData* pLineData = pLineDataList->First();
				while(pLineData)
				{
					if(pLineData->GetSourceFieldName() == aDragLeft.GetField() ||
					   pLineData->GetDestFieldName() == aDragLeft.GetField() )
						break;
					pLineData = pLineDataList->Next();
				}
				if(pLineData)
					return nRet;
			}
		}

		if(SDB_ISRULE(pCondition->GetChild(0), column_ref ))
		{
			nPos = 0;
			sal_uInt16 i=1;

			// don't display the equal
			if (pCondition->GetChild(i)->GetNodeType() == SDB_SQL_EQUAL)
				i++;

			International aInter(Shell()->BuildInternational(GetColumnFormatKey(pCondition->GetChild(0))));
			// Bedingung parsen
			for(;i< pCondition->Count();i++)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, aInter);
		}
		else if(SDB_ISRULE(pCondition->GetChild(pCondition->Count()-1), column_ref ))
		{
			nPos = pCondition->Count()-1;

			sal_Int16 i = pCondition->Count() - 2;
			switch (pCondition->GetChild(i)->GetNodeType())
			{
				case SDB_SQL_EQUAL:
					// don't display the equal
					i--;
					break;
				case SDB_SQL_LESS:
					// take the opposite as we change the order
					i--;
					aCondition.AssignAscii(">");
					break;
				case SDB_SQL_LESSEQ:
					// take the opposite as we change the order
					i--;
					aCondition.AssignAscii(">=");
					break;
				case SDB_SQL_GREAT:
					// take the opposite as we change the order
					i--;
					aCondition.AssignAscii("<");
					break;
				case SDB_SQL_GREATEQ:
					// take the opposite as we change the order
					i--;
					aCondition.AssignAscii("<=");
					break;				
			}									
			International aInter(Shell()->BuildInternational(GetColumnFormatKey(pCondition->GetChild(pCondition->Count()-1))));

			// go backward
			for (; i >= 0; i--)
				pCondition->GetChild(i)->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, aInter);
		}
		if(FillDragInfo(pCondition->GetChild(nPos),aDragLeft))
		{
			if(bHaving)
				aDragLeft.SetGroupBy(sal_True);
			pSelectionWindow->AddCondition(aDragLeft, aCondition, nLevel);
		}
		else
		{
			ErrorBox( this, SbaResId( ERR_QRY_SYNTAX ) ).Execute();
			nRet = 5;
		}
	}
	else if(SDB_ISRULE(pCondition->GetChild(0), set_fct_spec ) || SDB_ISRULE(pCondition->GetChild(0), general_set_fct ))
	{
		String			aName,
						aCondition;
		TabFieldDesc	aDragLeft;

		String aColumnName;
		pCondition->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());
		pCondition->GetChild(0)->ParseNodeToPredicateStr(aColumnName,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());

		// don't display the column name
		aCondition.Erase(0, aColumnName.Len());
		aCondition.EraseLeadingChars();

		if(SDB_ISRULE(pCondition->GetChild(0), general_set_fct ))
		{
			if(!FillDragInfo(pCondition->GetChild(0)->GetChild(3),aDragLeft))
			{
				String aPara(aColumnName.GetToken(1,'('));
				aDragLeft.SetField(aPara.GetToken(aPara.GetTokenCount()-1,')'));
			}
			aDragLeft.SetFunctionType(FKT_AGGREGATE);
			if(bHaving)
				aDragLeft.SetGroupBy(sal_True);
			aDragLeft.SetFunction(aColumnName.GetToken(0,'('));
		}
		else
		{
			// bei unbekannten Funktionen wird der gesamte Text in das Field gechrieben
			aDragLeft.SetField(aColumnName);
			if(bHaving)
				aDragLeft.SetGroupBy(sal_True);
			aDragLeft.SetFunctionType(FKT_OTHER);
		}
		pSelectionWindow->AddCondition(aDragLeft, aCondition, nLevel);
	}
	else // kann sich nur um einen Expr. Ausdruck handeln
	{
		TabFieldDesc	aDragLeft;
		String aName,aCondition;

		SdbSqlParseNode *pLhs = pCondition->GetChild(0);
		SdbSqlParseNode *pRhs = pCondition->GetChild(2);
		// Feldnamen
		for(sal_uInt16 i=0;i< pLhs->Count();i++)
			pCondition->GetChild(i)->ParseNodeToStr(aName,Shell()->GetDatabase()->GetMetaData(),sal_True);
		// Kriterium
		aCondition = pCondition->GetChild(1)->TokenValue();
		for(i=0;i< pRhs->Count();i++)
			pCondition->GetChild(i)->ParseNodeToPredicateStr(aCondition,Shell()->GetDatabase()->GetMetaData(), xFormatter, Application::GetAppInternational());

		aDragLeft.SetField(aName);
		aDragLeft.SetFunctionType(FKT_OTHER);
		// und anh"angen
		pSelectionWindow->AddCondition(aDragLeft, aCondition, nLevel);
	}
	return nRet;
}
//------------------------------------------------------------------------------
void QueryDesignWin::UpdateAll()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	bNotifyModification = sal_False;	// kein Modify aufrufen, da ein Statement von aussen gesetzt

	ClearAll();
	pTabWinCont->ReSync();
	pSelectionWindow->Fill();
	InitFromParseNode();

	bNotifyModification = sal_True;
}

void QueryDesignWin::HideTabWins()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	bNotifyModification = sal_False;	// kein Modify aufrufen, da ein Statement von aussen gesetzt

	((QueryTabWinContainer*)pTabWinCont)->HideTabWins();
	pSelectionWindow->Fill();

	bNotifyModification = sal_True;
}

//------------------------------------------------------------------------------

void QueryDesignWin::ClearAll(sal_Bool nNewCols)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	pTabWinCont->ClearAll();
	pSelectionWindow->ClearAll();

	aSplitter.ClearRelation();
	Resize();
}

//------------------------------------------------------------------------------
void QueryDesignWin::TableDeleted(const String& rAliasName)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	// Nachricht, dass Tabelle aus dem Fenster gel"oscht wurde
	DeleteFields(rAliasName);

	SFX_DISPATCHER().GetBindings()->Invalidate(SID_SBA_QRY_ADDTABLE);	// view nochmal bescheid sagen
}

//------------------------------------------------------------------------------
void QueryDesignWin::SetModified()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if (bNotifyModification)
		ModifyHdl().Call(NULL);
}

//------------------------------------------------------------------------------
long QueryDesignWin::GetSplitPos()
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	if (IsReadOnly())
		return nSplitHeight;

	long nSplitPos = aSplitter.GetSplitPosPixel();
	return nSplitPos;
}

//------------------------------------------------------------------------------
void QueryDesignWin::FillValidFields(const String& sAliasName, ComboBox* pFieldList)
{
	DBG_CHKTHIS(QueryDesignWin,NULL);
	DBG_ASSERT(pFieldList != NULL, "QueryDesignWin::FillValidFields : What the hell do you think I can do with a NULL-ptr ? This will crash !");
	pFieldList->Clear();

	sal_Bool bAllTables = sAliasName.Len() == 0;

	SbaJoinTabWinMap* pTabWins = GetTabWinCont()->GetTabWinMap();
	String strCurrentPrefix;
	SvStringsDtor arrstrValidFields;
	for (sal_Int32 i=0; i<pTabWins->Count(); ++i)
	{
		QueryTabWin* pCurrentWin = (QueryTabWin*)pTabWins->GetObject(i);
		if (bAllTables || (pCurrentWin->GetAliasName() == sAliasName))
		{
			strCurrentPrefix = pCurrentWin->GetAliasName();
			strCurrentPrefix += '.';

			pCurrentWin->EnumValidFields(arrstrValidFields);

			for (sal_Int32 j=0; j<arrstrValidFields.Count(); ++j)
			{
				String* pstrCurrent = arrstrValidFields.GetObject(j);
				if (bAllTables || (*pstrCurrent).GetChar(0) == '*')
					pFieldList->InsertEntry(String(strCurrentPrefix) += *pstrCurrent);
				else
					pFieldList->InsertEntry(*pstrCurrent);
			}

			if (!bAllTables)
				// das heisst, dass ich in diesen Block kam, weil der Tabellenname genau der gesuchte war, also bin ich fertig
				// (dadurch verhindere ich auch das doppelte Einfuegen von Feldern, wenn eine Tabelle mehrmals als TabWin vorkommt)
				break;
		}
	}
}

DBG_NAME(SbaQuerySplitter);
//------------------------------------------------------------------------------
SbaQuerySplitter::SbaQuerySplitter( Window* pParent )
	:Splitter( pParent )
	,bFirstMove( 2 )
	,m_bLastRelation(-1)
{
	DBG_CTOR(SbaQuerySplitter,NULL);
}

//------------------------------------------------------------------------------
SbaQuerySplitter::~SbaQuerySplitter()
{
	DBG_DTOR(SbaQuerySplitter,NULL);
}

//------------------------------------------------------------------------------
void SbaQuerySplitter::Move()
{
	DBG_CHKTHIS(SbaQuerySplitter,NULL);
	if( bFirstMove > 0)	   // Vor dem ersten Show wird bereits ein Move() gerufen
		bFirstMove--;
	else
		( (QueryDesignWin*)GetParent() )->Shell()->SetModified();
	Window::Move();

	Size aSize = GetSizePixel();
	Point aPos = GetPosPixel();

	Size aParentSize = GetParent()->GetSizePixel();
	if (aParentSize.Height() == aSize.Height())
		m_bLastRelation = -1;
	else
	{
		m_bLastRelation = 1.0*aPos.Y()/(aParentSize.Height() - aSize.Height());
		if (m_bLastRelation <= 0)
			m_bLastRelation = -1;
	}
}



