/*************************************************************************
 *
 *  $RCSfile: qrydgn1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_QRYDGN_HXX
#include "qrydgn.hxx"
#endif
#ifndef _SBA_QRYDGN1_HXX
#include "qrydgn1.hxx"
#endif

#ifndef _DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif

#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

DBG_NAME(TabFieldDesc);
//==============================================================================
TabFieldDesc::TabFieldDesc()
			 :bVisible(sal_False)
			 ,pTabWindow(0)
			 ,eOrderDir( ORDER_NONE )
			 ,eFunctionType( FKT_NONE )
			 ,bGroupBy(sal_False)
			 ,nColWidth(0)
			 ,eFieldType(TAB_NORMAL_FIELD)
			 ,nIndex(0)
			 ,eDataType(SDB_DBTYPE_UNKNOWN)
{
	DBG_CTOR(TabFieldDesc,NULL);
}
//------------------------------------------------------------------------------
TabFieldDesc::TabFieldDesc(const TabFieldDesc& rRS)
		:aTableName(rRS.GetTable()),
		aAliasName(rRS.GetAlias()),		// table range
		aFieldName(rRS.GetField()),		// column
		aFieldAlias(rRS.GetFieldAlias()),	// column alias
		aDatabaseName(rRS.GetDatabase()),	// qualifier or catalog
		aFunctionName(rRS.GetFunction()),	// Funktionsname
		bVisible(rRS.IsVisible()),
		pTabWindow(rRS.GetTabWindow()),
		eDataType(rRS.GetDataType()),
		eOrderDir(rRS.GetOrderDir()),
		nColWidth(rRS.GetColWidth()),
		eFieldType(rRS.GetFieldType()),
		nIndex(rRS.GetFieldIndex()),
		eFunctionType( rRS.GetFunctionType() ),
		bGroupBy(rRS.IsGroupBy())

{
	DBG_CTOR(TabFieldDesc,NULL);
	m_vecCriteria = rRS.GetCriteria();
}

//------------------------------------------------------------------------------
TabFieldDesc::TabFieldDesc(const String& rT, const String& rF )
			 :bVisible(sal_False)
			 ,pTabWindow(0)
			 ,eOrderDir( ORDER_NONE )
			 ,eFunctionType( FKT_NONE )
			 ,bGroupBy(sal_False)
{
	DBG_CTOR(TabFieldDesc,NULL);
	SetField( rF );	SetTable( rT );
}

//------------------------------------------------------------------------------
TabFieldDesc::~TabFieldDesc()
{
	DBG_DTOR(TabFieldDesc,NULL);
}

//------------------------------------------------------------------------------
sal_Bool TabFieldDesc::operator==( const TabFieldDesc& rDesc )
{
	DBG_CHKTHIS(TabFieldDesc,NULL);

	return (	eOrderDir != rDesc.GetOrderDir()		||
		eDataType != rDesc.GetDataType()		||
		aAliasName != rDesc.GetAlias()	 		||
		aDatabaseName != rDesc.GetDatabase()	||
		aFunctionName != rDesc.GetFunction()	||
		aFieldName != rDesc.GetField()			||
		aTableName != rDesc.GetTable()	 		||
		bGroupBy != rDesc.IsGroupBy()			||
		m_vecCriteria != rDesc.GetCriteria()	||
		bVisible != rDesc.IsVisible() );

}

//------------------------------------------------------------------------------
void TabFieldDesc::NextOrderDir()
{
	DBG_CHKTHIS(TabFieldDesc,NULL);
	int	nTmp = ((int)eOrderDir);
	nTmp++;
	nTmp %= (ORDER_DESC+1);
	eOrderDir = SbaOrderDir(nTmp);
}

//------------------------------------------------------------------------------
void TabFieldDesc::SetCriteria( sal_uInt16 nIdx, const String& rCrit)
{
	DBG_CHKTHIS(TabFieldDesc,NULL);
	if (nIdx < m_vecCriteria.size())
		m_vecCriteria[nIdx] = rCrit;
	else
	{
		for(sal_Int32 i=m_vecCriteria.size();i<nIdx;++i)
			m_vecCriteria.push_back( String());
		m_vecCriteria.push_back(rCrit);
	}
}

//------------------------------------------------------------------------------
String TabFieldDesc::GetCriteria( sal_uInt16 nIdx ) const
{
	DBG_CHKTHIS(TabFieldDesc,NULL);
	String aRetStr;
	if( nIdx < m_vecCriteria.size())
		aRetStr = m_vecCriteria[nIdx];

	return aRetStr;
}

//------------------------------------------------------------------------------
sal_Bool TabFieldDesc::IsNumericDataType() const
{
	DBG_CHKTHIS(TabFieldDesc,NULL);
	sal_Bool bErg(sal_False);
	switch (eDataType)
	{
		case SDB_DBTYPE_BOOLEAN:
		case SDB_DBTYPE_CURRENCY:
		case SDB_DBTYPE_TINYINT:
		case SDB_DBTYPE_SMALLINT:
		case SDB_DBTYPE_INTEGER:
		case SDB_DBTYPE_REAL:
		case SDB_DBTYPE_DOUBLE:
		case SDB_DBTYPE_DECIMAL:
		case SDB_DBTYPE_NUMERIC:
			bErg = sal_True;
	}
	return bErg;
}

//==================================================================
// class TabFieldInfo
//==================================================================

DBG_NAME(TabFieldInfo);
TabFieldInfo::TabFieldInfo()  :
	eDataType(SDB_DBTYPE_UNKNOWN)
{
	DBG_CTOR(TabFieldInfo,NULL);
	eFieldType = TAB_NORMAL_FIELD;
}

//------------------------------------------------------------------------------
TabFieldInfo::~TabFieldInfo()
{
	DBG_DTOR(TabFieldInfo,NULL);
}

