/*************************************************************************
 *
 *  $RCSfile: qrydgnvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _SBA_QRYDGNVS_HXX
#include "qrydgnvs.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif
#ifndef _SBA_QRYDGN_HXX
#include "qrydgn.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif


#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif // _SBA_EXTBOX_HXX

//==============================================================================
TYPEINIT1(SbaQueryDesignViewSh, SbaQueryViewSh)

#define SbaQueryDesignViewSh
#include "ofaslots.hxx"

SFX_IMPL_INTERFACE(SbaQueryDesignViewSh,SbaQueryViewSh, SbaResId((sal_uInt16)0) )
{
	SFX_OBJECTBAR_REGISTRATION(SFX_OBJECTBAR_OBJECT | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_READONLYDOC, SbaResId(RID_QRY_TOOLBOX_DESIGN));
	SFX_FEATURED_CHILDWINDOW_REGISTRATION(SID_SBA_JOIN_ADDTABLE, 1);
}

SFX_IMPL_VIEWFACTORY(SbaQueryDesignViewSh, SbaResId(0))
{
	SFX_VIEW_REGISTRATION(SbaQueryDocSh);
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::Execute( SfxRequest& rReq )
{
	SbaQueryDocSh* pDoc = GetQueryShell();
	DBG_ASSERT(pDoc,"SbaQueryDesignViewSh::Execute: invalid Document Shell");

	switch( rReq.GetSlot() )
	{
		case SID_RELOAD:
		{
			if (pDoc->IsModified())
	            if (RET_YES != QueryBox(NULL, ResId(MSG_QUERY_LASTVERSION)).Execute())
					return;

			if (!pDoc->Refresh())
				return;

			pQueryDesignWin->ClearAll();
			// Doc neu lesen lassen
			pDoc->ConvertFrom(*pDoc->GetMedium());
			// UI wieder an's Doc anpassen
			pQueryDesignWin->UpdateAll();

			// sowohl die UI als auch das Doc sind jetzt jungfraeulich
			pDoc->SetModified(sal_False);
			SetModified(sal_False);

			// meine Slots invalidieren
			Invalidate();

			pDoc->GetUndoMgr()->Clear();
			pDoc->SetModified(sal_False);
			SFX_BINDINGS().Invalidate(SID_SAVEDOC);
		}
		break;

		case SID_SBA_QUERY_VIEW_FUNCTIONS:
			pQueryDesignWin->GetSelectionWin()->SetRowVisible(BROW_FUNCTION_ROW,
				!pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_FUNCTION_ROW));
			SFX_BINDINGS().Invalidate( SID_SBA_QUERY_VIEW_FUNCTIONS );
			break;

		case SID_SBA_QUERY_VIEW_TABLES:
			pQueryDesignWin->GetSelectionWin()->SetRowVisible(BROW_TABLE_ROW,
				!pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_TABLE_ROW));
			SFX_BINDINGS().Invalidate( SID_SBA_QUERY_VIEW_TABLES );
			break;

		case SID_SBA_QUERY_VIEW_ALIASES:
			pQueryDesignWin->GetSelectionWin()->SetRowVisible(BROW_COLUMNALIAS_ROW,
				!pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_COLUMNALIAS_ROW));
			SFX_BINDINGS().Invalidate( SID_SBA_QUERY_VIEW_ALIASES );
			break;

		case SID_SBA_QUERY_DISTINCT_VALUES:
			pQueryDesignWin->GetSelectionWin()->SetDistinct(!pQueryDesignWin->GetSelectionWin()->IsDistinct());
			pQueryDesignWin->SetModified();
			SFX_BINDINGS().Invalidate( SID_SBA_QUERY_DISTINCT_VALUES );
			break;

		case SID_MAIL_SENDDOC:
			SFX_APP()->ExecuteSlot(rReq);
			break;

		case SID_SAVEDOC:
		case SID_SAVEASDOC:
			// zuerst Speichern der UI-Informationen
			GetQueryDesignWin()->SaveUIConfig();
			GetQueryShell()->Execute( rReq );
			break;
		case SID_SBA_QRY_EXECUTE:
			pDoc->ExecuteStatement();
			rReq.Done();
			break;

		case SID_SBA_QRY_ADDTABLE:
			// darum kuemmert sich meine Basisklasse ausreichend
			SbaJoinViewShExt::Execute(rReq);
			break;
		case SID_SBA_CLEAR_QUERY:
			if (pQueryDesignWin)
			{
				SfxUndoManager* pUndoMgr = pDoc->GetUndoMgr();
				pUndoMgr->EnterListAction( String( SbaResId(STR_QUERY_UNDO_REMOVEFILTER) ), String() );
				pDoc->SetStatement(String(), sal_False, sal_True);
				pQueryDesignWin->HideTabWins();
				pUndoMgr->LeaveListAction();
				SFX_BINDINGS().Invalidate( SID_SBA_QRY_ADDTABLE );
			}
			rReq.Done();
			break;
		case SID_EDITDOC:
		{
			sal_Bool bGoOn = sal_True;
			SbaQueryDocSh* pDoc = GetQueryShell();
			if (pDoc->IsModified())
			{
				SbaExtQueryBox	aQry(NULL, SbaResId(RID_QRY_QRY_SAVEMODIFIED), pDoc->GetDBDef()->Name());
				switch (aQry.Execute())
				{
					case RET_YES:
					{
						// unsere eigenen UI-Informationen
						GetQueryDesignWin()->SaveUIConfig();
						// und das Doc speichern lassen
						SfxRequest aReq(SID_SAVEDOC, SFX_CALLMODE_SLOT | SFX_CALLMODE_SYNCHRON, GetPool());
						pDoc->ExecuteSlot(aReq);
						// Return-Wert ?
						const SfxPoolItem* pReturn = aReq.GetReturnValue();
						if (pReturn && pReturn->ISA(SfxBoolItem))
							bGoOn = ((SfxBoolItem*)pReturn)->GetValue();
						else
							bGoOn = sal_True;

						pDoc->SetModified(!bGoOn);
					} break;
					case RET_NO:
						// alles aufraeumen
						pQueryDesignWin->ClearAll();
						// Doc neu lesen lassen
						pDoc->ConvertFrom(*pDoc->GetMedium());
						// UI wieder an's Doc anpassen
						pQueryDesignWin->UpdateAll();

						// sowohl die UI als auch das Doc sind jetzt jungfraeulich
						pDoc->SetModified(sal_False);
						SetModified(sal_False);

						// meine Slots invalidieren
						Invalidate();

						bGoOn = sal_True;
						break;
					default:
						bGoOn = sal_False;
						break;
				}
			}
			if (bGoOn)
			{
				pQueryDesignWin->SetReadOnly(!pQueryDesignWin->IsReadOnly());
				SFX_BINDINGS().Invalidate( SID_SBA_QRY_ADDTABLE );
				SFX_BINDINGS().Invalidate( SID_SBA_CLEAR_QUERY );
				rReq.Done();
			}
		} break;
	}
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::GetState(SfxItemSet &rSet)
{
	if (!pQueryDesignWin)
		return;

	SfxWhichIter    aIter(rSet);
	sal_uInt16          nWhich = aIter.FirstWhich();

	SbaQueryDocSh*  pDoc = GetQueryShell();
	DBG_ASSERT(pDoc,"SbaQueryDesignViewSh::GetState: invalid Document Shell");

	while (nWhich)
	{
		switch( nWhich )
		{
			case SID_SBA_QUERY_VIEW_FUNCTIONS:
				rSet.Put(SfxBoolItem(nWhich, pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_FUNCTION_ROW)));
				break;

			case SID_SBA_QUERY_VIEW_TABLES:
				rSet.Put(SfxBoolItem(nWhich, pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_TABLE_ROW)));
				break;

			case SID_SBA_QUERY_VIEW_ALIASES:
				rSet.Put(SfxBoolItem(nWhich, pQueryDesignWin->GetSelectionWin()->IsRowVisible(BROW_COLUMNALIAS_ROW)));
				break;

			case SID_SBA_QUERY_DISTINCT_VALUES:
				rSet.Put(SfxBoolItem(nWhich, pQueryDesignWin->GetSelectionWin()->IsDistinct()));
				break;

			case SID_MAIL_SENDDOC:
				// Sonderbehandlung, Aenderung des Menuetextes
				rSet.Put( SfxStringItem( nWhich, String( SbaResId( RID_STR_MENU_NEWMAIL ) ) ) );
				break;
			case SID_SBA_JOINSH_ADDTBLDLG:
			case SID_SBA_JOIN_ADDTABLE:
				SbaJoinViewShExt::GetState( rSet );
				break;
			case SID_SBA_QRY_EXECUTE:
				if ( !pQueryDesignWin->GetSelectionWin()->FieldsCount() )
					rSet.DisableItem(nWhich);
				break;
			case SID_EDITDOC:
				if (GetQueryShell()->GetDatabase()->IsReadOnly())
					rSet.DisableItem(nWhich);
				else
					rSet.Put(SfxBoolItem(nWhich, !pQueryDesignWin->IsReadOnly()));
				break;
			case SID_SAVEASDOC:
				break;
			case SID_SBA_CLEAR_QUERY:
				if (pQueryDesignWin->IsReadOnly())
					rSet.DisableItem(nWhich);
				else if (!pQueryDesignWin->HasTable())
					rSet.DisableItem(nWhich);
				break;
			default:
				pDoc->GetState(rSet);
		}
		nWhich = aIter.NextWhich();
	}
}

//------------------------------------------------------------------------
sal_Bool SbaQueryDesignViewSh::HasUIFeature( sal_uInt32 nFeature )
{
	if ((nFeature & 1) == 1)
		return GetFrameWindow()->GetTabWinCont()->IsAddAllowed();

	return SfxViewShell::HasUIFeature(nFeature);
}
//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::Construct( SfxViewFrame *pFrame )
{
	SetHelpId(ID_SBA_QUERYDESIGNVIEWSH);
	if (GetShell()->GetDBDef())
	{
		SbaQueryDesignFrame* pDesignFrame = new SbaQueryGraphicalDesignFrame(&pFrame->GetWindow(), PTR_CAST(SbaDBDataDef, GetQueryShell()->GetDBDef()), this);
		pDesignFrame->SetHelpId(HID_QRY_DESIGN_FRAME);
		pQueryDesignWin = (QueryDesignWin*)pDesignFrame->GetMainWin();

		// our base class SbaJoinViewShExt needs (in it's members) the document ...
		pDocSh = GetQueryShell();
		// ... and the just created window
		pJoinFrameWindow = pQueryDesignWin;
			// as SbaJoinViewShExt doesn't delete pJoinFrameWindow iself this double reference isn't critical

		// do some missing initialisation of the main win (the frame couldn't do this because it hadn't the same free
		// access to our and the QueryDesignWin's members)
		sal_Bool bRO = GetQueryShell()->IsReadOnlyUI() || GetQueryShell()->GetDatabase()->IsReadOnly();
		pQueryDesignWin->SetReadOnly(bRO);
		pQueryDesignWin->UpdateAll();
		SetModified(sal_False);

		pQueryDesignWin->ModifyHdl(LINK(this, SbaQueryViewSh, ModifyHdl));
		aStatement = GetQueryShell()->Statement();

		SetWindow(pDesignFrame);
	}
}

DBG_NAME(SbaQueryDesignViewSh);
//------------------------------------------------------------------------------
SbaQueryDesignViewSh::SbaQueryDesignViewSh( SfxViewFrame *pFrame, SfxViewShell* pView )
					 :SbaQueryViewSh(pFrame)
					 ,SbaJoinViewShExt((SfxViewShell*)this)
					 ,pQueryDesignWin(NULL)
{
	DBG_CTOR(SbaQueryDesignViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaQueryDesignViewSh::SbaQueryDesignViewSh(SfxViewFrame *pFrame, Window *pParent)
					 :SbaQueryViewSh(pFrame)
					 ,SbaJoinViewShExt((SfxViewShell*)this)
					 ,pQueryDesignWin(NULL)
{
	DBG_CTOR(SbaQueryDesignViewSh,NULL);
	Construct( pFrame );
}


//------------------------------------------------------------------------------
SbaQueryDesignViewSh::SbaQueryDesignViewSh( SfxViewFrame *pFrame, const SbaQueryDesignViewSh& rSh )
					 :SbaQueryViewSh(pFrame)
					 ,SbaJoinViewShExt((SfxViewShell*)this)
					 ,pQueryDesignWin(NULL)
{
	DBG_CTOR(SbaQueryDesignViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaQueryDesignViewSh::~SbaQueryDesignViewSh()
{
	DBG_DTOR(SbaQueryDesignViewSh,NULL);
	delete pQueryDesignWin->GetParent();
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::InnerResizePixel( const Point &rPos, const Size &rSize )
{
	DBG_CHKTHIS(SbaQueryDesignViewSh,NULL);
	if (pQueryDesignWin && pQueryDesignWin->GetParent()) pQueryDesignWin->GetParent()->SetPosSizePixel( rPos, rSize );
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::OuterResizePixel( const Point &rPos, const Size &rSize )
{
	DBG_CHKTHIS(SbaQueryDesignViewSh,NULL);
	InnerResizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::Activate(sal_Bool IsMDIActivate)
{
	if (pQueryDesignWin && pQueryDesignWin->GetParent())
		((SbaViewSwitchFrame*)pQueryDesignWin->GetParent())->EnableAccelSwitch(sal_True);

	SbaQueryViewSh::Activate(IsMDIActivate);
	Invalidate();
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::Deactivate(sal_Bool IsMDIActivate)
{
	if (pQueryDesignWin && pQueryDesignWin->GetParent())
		((SbaViewSwitchFrame*)pQueryDesignWin->GetParent())->EnableAccelSwitch(sal_False);

	SbaQueryViewSh::Deactivate(IsMDIActivate);
}

//------------------------------------------------------------------------------
void SbaQueryDesignViewSh::SetStatement(const String& rStatement)
{
	DBG_CHKTHIS(SbaQueryDesignViewSh,NULL);
	// Anzeige updaten
	if (aStatement != rStatement || bInit)
	{
		aStatement = rStatement;
		pQueryDesignWin->UpdateAll();
		bInit = sal_False;
	}
	SetModified(sal_False);
}

//------------------------------------------------------------------------------
String SbaQueryDesignViewSh::GetStatement()
{
	DBG_CHKTHIS(SbaQueryDesignViewSh,NULL);
	aStatement = pQueryDesignWin->GenerateSQL();
	SdbDatabase* pDB = GetQueryShell()->GetDatabase();
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = pDB->GetMetaData();
	sal_Int32 nMaxStatement = rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::STATEMENT_LEN);
	if(nMaxStatement && nMaxStatement < aStatement.Len())
	{
		ErrorBox aBox( GetQueryDesignWin(), SbaResId( ERR_QRY_TOO_LONG_STATEMENT ) );
		aBox.Execute();
	}
	return aStatement;
}

sal_uInt16 SbaQueryDesignViewSh::PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing )
{
	DBG_CHKTHIS(SbaQueryDesignViewSh,NULL);
	if(pQueryDesignWin)
		pQueryDesignWin->SaveUIConfig();
	return sal_True;
}

//==================================================================
SbaQueryGraphicalDesignFrame::SbaQueryGraphicalDesignFrame(Window* pParent, SbaDBDataDef* pDef, SbaQueryDesignViewSh* pView)
	:SbaQueryDesignFrame(pParent, pDef, pView, SID_SBA_QRY_DESIGN)
{
	SbaQueryDocSh* pDoc = (SbaQueryDocSh*)GetDocShell();

	// jetzt das Hauptfenster
	QueryDesignWin* pQueryDesignWin = new QueryDesignWin(this, pView);
	m_pMainWin = pQueryDesignWin;
	m_pMainWin->Show();
}

//------------------------------------------------------------------------------
void SbaQueryGraphicalDesignFrame::GetFocus()
{
	SbaQueryDesignFrame::GetFocus();
	m_pMainWin->GrabFocus();
}

