/*************************************************************************
 *
 *  $RCSfile: qrydlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "qry.hrc"

#ifndef QRYDLG_HXX
#include "qrydlg.hxx"
#endif // QRYDLG_HXX

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif // _SBA_SBARES_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif

#ifndef _SBA_QRYWINCT_HXX
#include "qrywinct.hxx"
#endif // _SBA_QRYWINCT_HXX

#ifndef _UTL_UNO3_HXX_
#include <unotools/uno3.hxx>
#endif

//------------------------------------------------------------------------
DBG_NAME(DlgQryJoin);
DlgQryJoin::DlgQryJoin( Window * pParent,QueryTabConnData* pData,SbaDatabaseRef xDatabase )
	: ModalDialog( pParent, SbaResId(DLG_QRY_JOIN) ),
	aGB_Join( this, ResId( GB_JOIN ) ),
	aRB_Inner( this, ResId( RB_INNER ) ),
	aRB_Left( this, ResId( RB_LEFT ) ),
	aRB_Right( this, ResId( RB_RIGHT ) ),
	aRB_Full( this, ResId( RB_FULL ) ),
	aML_HelpText( this, ResId(ML_HELPTEXT) ),

	aPB_OK( this, ResId( PB_OK ) ),
	aPB_CANCEL( this, ResId( PB_CANCEL ) ),
	aPB_HELP( this, ResId( PB_HELP ) ),
	eJoinType(pData->GetJoinType()),
	rDatabase(xDatabase),
	pConnData(pData)

{
	DBG_CTOR(DlgQryJoin,NULL);

	aRB_Left.Disable();
	aRB_Right.Disable();
	aRB_Full.Disable();

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(rDatabase->GetMetaData());
	::com::sun::star::uno::Any aAny = rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::OUTER_JOIN_SUPPORT);
	if(::utl::getINT16(aAny) & ::com::sun::star::data::DatabaseOuterJoinSupport::FULL)
	{
		aRB_Left.Enable();
		aRB_Right.Enable();
		aRB_Full.Enable();
	}
	else if(::utl::getINT16(aAny) & ::com::sun::star::data::DatabaseOuterJoinSupport::YES)
	{
		aRB_Left.Enable();
		aRB_Right.Enable();
	}

	switch(eJoinType)
	{
		case SBA_INNER_JOIN:
			aRB_Inner.Check(sal_True);
			RBTogleHdl(&aRB_Inner);
			break;
		case SBA_LEFT_JOIN:
			aRB_Left.Check(sal_True);
			RBTogleHdl(&aRB_Left);
			break;
		case SBA_RIGHT_JOIN:
			aRB_Right.Check(sal_True);
			RBTogleHdl(&aRB_Right);
			break;
		case SBA_FULL_JOIN:
			aRB_Full.Check(sal_True);
			RBTogleHdl(&aRB_Full);
			break;
	}

	aPB_OK.SetClickHdl( LINK(this, DlgQryJoin, OKClickHdl) );

	aRB_Inner.SetToggleHdl(LINK(this,DlgQryJoin,RBTogleHdl));
	aRB_Left.SetToggleHdl(LINK(this,DlgQryJoin,RBTogleHdl));
	aRB_Right.SetToggleHdl(LINK(this,DlgQryJoin,RBTogleHdl));
	aRB_Full.SetToggleHdl(LINK(this,DlgQryJoin,RBTogleHdl));

	if (((QueryTabWinContainer*)pParent)->IsReadOnly())
	{
		aRB_Inner.Disable();
		aRB_Left.Disable();
		aRB_Right.Disable();
		aRB_Full.Disable();
	}

	FreeResource();
}

//------------------------------------------------------------------------
DlgQryJoin::~DlgQryJoin()
{
	DBG_DTOR(DlgQryJoin,NULL);
}
IMPL_LINK( DlgQryJoin, RBTogleHdl, RadioButton*, pButton )
{
	DBG_CHKTHIS(DlgQryJoin,NULL);
	aML_HelpText.SetText(String());
	String aStr;
	if(pButton == &aRB_Inner)
	{
		aStr = String(SbaResId(SBA_STR_QRY_INNER_JOIN));
	}
	else if(pButton == &aRB_Left)
	{
		aStr = String(SbaResId(SBA_STR_QRY_LEFTRIGHT_JOIN));
		aStr.SearchAndReplace(String::CreateFromAscii("%1"),pConnData->GetSourceWinName());
		aStr.SearchAndReplace(String::CreateFromAscii("%2"),pConnData->GetDestWinName());
	}
	else if(pButton == &aRB_Right)
	{
		aStr = String(SbaResId(SBA_STR_QRY_LEFTRIGHT_JOIN));
		aStr.SearchAndReplace(String::CreateFromAscii("%1"),pConnData->GetDestWinName());
		aStr.SearchAndReplace(String::CreateFromAscii("%2"),pConnData->GetSourceWinName());
	}
	else if(pButton == &aRB_Full)
	{
		aStr = String(SbaResId(SBA_STR_QRY_FULL_JOIN));
		aStr.SearchAndReplace(String::CreateFromAscii("%1"),pConnData->GetDestWinName());
		aStr.SearchAndReplace(String::CreateFromAscii("%2"),pConnData->GetSourceWinName());
	}
	aML_HelpText.SetText(aStr);
	return 1;
}

IMPL_LINK( DlgQryJoin, OKClickHdl, Button*, pButton )
{
	DBG_CHKTHIS(DlgQryJoin,NULL);
	if( aRB_Inner.IsChecked() )
		eJoinType = SBA_INNER_JOIN;
	else if( aRB_Left.IsChecked() )
		eJoinType = SBA_LEFT_JOIN;
	else if( aRB_Right.IsChecked() )
		eJoinType = SBA_RIGHT_JOIN;
	else if( aRB_Full.IsChecked() )
		eJoinType = SBA_FULL_JOIN;
	EndDialog();
	return 1;
}

//========================================================================
QueryMissingTableDialog::QueryMissingTableDialog(Window* pParent, sal_uInt16 nExplanationId, const String& strAffectedString)
	:ModalDialog(pParent, SbaResId(DLG_QUERY_MISSING_TABLE))
	,m_ftExplanantion	(this, ResId(FT_EXPLANATION))
	,m_gbChoose			(this, ResId(GB_CHOOSE))
	,m_rbOpenGraphic	(this, ResId(RB_OPEN_GRAPHIC))
	,m_rbOpenSql		(this, ResId(RB_OPEN_SQL))
	,m_rbDontOpen		(this, ResId(RB_DONT_OPEN))
	,m_cbIgnoreOther	(this, ResId(CB_IGNORE_OTHER))
	,m_ctrlCancel		(this, ResId(1))
	,m_ctrlOk			(this, ResId(1))
{
	String strExplanation = String(SbaResId(nExplanationId));
	strExplanation.SearchAndReplace(String::CreateFromAscii("$name$"), strAffectedString);
	m_ftExplanantion.SetText(strExplanation);

	m_rbOpenGraphic.Check();
	m_cbIgnoreOther.Enable(sal_True);
	m_cbIgnoreOther.Check();

	m_rbOpenGraphic.SetClickHdl(LINK(this, QueryMissingTableDialog, OnRadioClicked));
	m_rbOpenSql.SetClickHdl(LINK(this, QueryMissingTableDialog, OnRadioClicked));
	m_rbDontOpen.SetClickHdl(LINK(this, QueryMissingTableDialog, OnRadioClicked));

	FreeResource();
}

//------------------------------------------------------------------------
sal_uInt16 QueryMissingTableDialog::GetResponse() const
{
	if (m_rbOpenGraphic.IsChecked())
		return 1;
	else if (m_rbOpenSql.IsChecked())
		return 2;
	else
		return 3;
}

//------------------------------------------------------------------------
IMPL_LINK(QueryMissingTableDialog, OnRadioClicked, RadioButton*, prbButton)
{
	m_cbIgnoreOther.Enable(prbButton == &m_rbOpenGraphic);
	return 0L;
}


