/*************************************************************************
 *
 *  $RCSfile: qryorder.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBASTR_HXX
#include "sbastr.hxx"
#endif
#ifndef _SBA_SBADBIT_HXX
#include "sbadbit.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif
#ifndef _SBA_QRYORDER_HRC
#include "qryorder.hrc"
#endif
#ifndef _SBA_QRYORDER_HXX
#include "qryorder.hxx"
#endif

#ifndef _SDB_SDBCURS_HXX //autogen
#include <sdb/sdbcurs.hxx>
#endif
DBG_NAME(DlgOrderCrit);
//------------------------------------------------------------------------------
DlgOrderCrit::DlgOrderCrit(Window * pParent,
						   SbaParseIterator& rIter,
						   const SdbColumnsRef aCols)
			 :ModalDialog( pParent, SbaResId(DLG_ORDERCRIT) ),
			aLB_ORDERFIELD1(	this, ResId( LB_ORDERFIELD1 ) ),
			aLB_ORDERVALUE1(	this, ResId( LB_ORDERVALUE1 ) ),
			aLB_ORDERFIELD2(	this, ResId( LB_ORDERFIELD2 ) ),
			aLB_ORDERVALUE2(	this, ResId( LB_ORDERVALUE2 ) ),
			aLB_ORDERFIELD3(	this, ResId( LB_ORDERFIELD3 ) ),
			aLB_ORDERVALUE3(	this, ResId( LB_ORDERVALUE3 ) ),
			aFT_ORDERFIELD(		this, ResId( FT_ORDERFIELD ) ),
			aFT_ORDERVALUE(		this, ResId( FT_ORDERVALUE ) ),
			aFT_ORDERAFTER1(	this, ResId( FT_ORDERAFTER1 ) ),
			aFT_ORDERAFTER2(	this, ResId( FT_ORDERAFTER2 ) ),
			aFT_ORDEROPER(		this, ResId( FT_ORDEROPER ) ),
			aFT_ORDERDIR(		this, ResId( FT_ORDERDIR ) ),
			aBT_OK(				this, ResId( BT_OK ) ),
			aBT_CANCEL(			this, ResId( BT_CANCEL ) ),
			aBT_HELP(			this, ResId( BT_HELP ) ),
			aGB_ORDER(			this, ResId( GB_ORDER ) ),
			aSTR_NOENTRY(		ResId( STR_NOENTRY ) ),
			rIterator( rIter )
{
	DBG_CTOR(DlgOrderCrit,NULL);
	sal_uInt16	j=0, i;

	arrLbFields[0] = &aLB_ORDERFIELD1;
	arrLbFields[1] = &aLB_ORDERFIELD2;
	arrLbFields[2] = &aLB_ORDERFIELD3;

	arrLbValues[0] = &aLB_ORDERVALUE1;
	arrLbValues[1] = &aLB_ORDERVALUE2;
	arrLbValues[2] = &aLB_ORDERVALUE3;

	for( j=0 ; j < DOG_ROWS ; j++ )
	{
		arrLbFields[j]->InsertEntry( aSTR_NOENTRY );
	}

	for( j=0 ; j < DOG_ROWS ; j++ )
	{
		arrLbFields[j]->SelectEntryPos(0);
		arrLbValues[j]->SelectEntryPos(0);
	}
	String aName;
	for (i=1 ; i < aCols->Count() ; i++ )
	{
		const SdbColumn* pColumn = aCols->Column(i);
		if(pColumn->GetAllFlags() & (SDB_FLAGS_SEARCH_LIKE | SDB_FLAGS_SEARCH_EXCEPT_LIKE | SDB_FLAGS_SEARCH_ALL))
		{
			aName = pColumn->GetName();
			for( j=0 ; j < DOG_ROWS ; j++ )
			{
				arrLbFields[j]->InsertEntry(aName);
			}
		}
	}
	SbaOrderItemList aOrderList;
	if (rIterator.FillOrderList(aOrderList))
	{
		SetOrderList(&aOrderList);
		for( i=0 ; i < aOrderList.Count() ; i++ )
			delete aOrderList.GetObject(i);
		aOrderList.Clear();
	}
	else
		SBA_MOD()->ShowDbStatus(rIterator.IteratorStatus(), dbSyntaxError);

	aLB_ORDERFIELD1.SetSelectHdl(LINK(this,DlgOrderCrit,FieldListSelectHdl));
	aLB_ORDERFIELD2.SetSelectHdl(LINK(this,DlgOrderCrit,FieldListSelectHdl));
//	aLB_ORDERFIELD3.SetSelectHdl(LINK(this,DlgOrderCrit,FieldListSelectHdl));

	FreeResource();

}

//------------------------------------------------------------------------------
DlgOrderCrit::DlgOrderCrit( Window * pParent, SbaParseIterator& rIter, const SdbCursor& rCursor)
	: ModalDialog( pParent, SbaResId(DLG_ORDERCRIT) ),
	aLB_ORDERFIELD1(	this, ResId( LB_ORDERFIELD1 ) ),
	aLB_ORDERVALUE1(	this, ResId( LB_ORDERVALUE1 ) ),
	aLB_ORDERFIELD2(	this, ResId( LB_ORDERFIELD2 ) ),
	aLB_ORDERVALUE2(	this, ResId( LB_ORDERVALUE2 ) ),
	aLB_ORDERFIELD3(	this, ResId( LB_ORDERFIELD3 ) ),
	aLB_ORDERVALUE3(	this, ResId( LB_ORDERVALUE3 ) ),
	aFT_ORDERFIELD(		this, ResId( FT_ORDERFIELD ) ),
	aFT_ORDERVALUE(		this, ResId( FT_ORDERVALUE ) ),
	aFT_ORDERAFTER1(	this, ResId( FT_ORDERAFTER1 ) ),
	aFT_ORDERAFTER2(	this, ResId( FT_ORDERAFTER2 ) ),
	aFT_ORDEROPER(		this, ResId( FT_ORDEROPER ) ),
	aFT_ORDERDIR(		this, ResId( FT_ORDERDIR ) ),
	aBT_OK(				this, ResId( BT_OK ) ),
	aBT_CANCEL(			this, ResId( BT_CANCEL ) ),
	aBT_HELP(			this, ResId( BT_HELP ) ),
	aGB_ORDER(			this, ResId( GB_ORDER ) ),
	aSTR_NOENTRY(		ResId( STR_NOENTRY ) ),
	rIterator( rIter )
{
	DBG_CTOR(DlgOrderCrit,NULL);
	sal_uInt16	j=0, i;

	arrLbFields[0] = &aLB_ORDERFIELD1;
	arrLbFields[1] = &aLB_ORDERFIELD2;
	arrLbFields[2] = &aLB_ORDERFIELD3;

	arrLbValues[0] = &aLB_ORDERVALUE1;
	arrLbValues[1] = &aLB_ORDERVALUE2;
	arrLbValues[2] = &aLB_ORDERVALUE3;

	for( j=0 ; j < DOG_ROWS ; j++ )
	{
		arrLbFields[j]->InsertEntry( aSTR_NOENTRY );
	}

	for( j=0 ; j < DOG_ROWS ; j++ )
	{
		arrLbFields[j]->SelectEntryPos(0);
		arrLbValues[j]->SelectEntryPos(0);
	}

	//const SdbColumnsRef aCols = rCursor.ResultColumns();
	const SdbColumnsRef aCols = rIterator.GetSelectColumns();
	String aName;
	for (i=1 ; i < aCols->Count() ; i++ )
	{
		const SdbColumn* pColumn = aCols->Column(i);
		if(!pColumn->IsFunction() &&
			(pColumn->GetAllFlags() & (SDB_FLAGS_SEARCH_LIKE | SDB_FLAGS_SEARCH_EXCEPT_LIKE | SDB_FLAGS_SEARCH_ALL)))
		{
			aName = aCols->Column(i)->GetName();
			for( j=0 ; j < DOG_ROWS ; j++ )
			{
				arrLbFields[j]->InsertEntry(aName);
			}
		}
	}

	SbaOrderItemList aOrderList;
	if (rIterator.FillOrderList(aOrderList))
	{
		SetOrderList(&aOrderList);
		for( i=0 ; i < aOrderList.Count() ; i++ )
			delete aOrderList.GetObject(i);
		aOrderList.Clear();
	}
	else
		SBA_MOD()->ShowDbStatus(rIterator.IteratorStatus(), dbSyntaxError);

	aLB_ORDERFIELD1.SetSelectHdl(LINK(this,DlgOrderCrit,FieldListSelectHdl));
	aLB_ORDERFIELD2.SetSelectHdl(LINK(this,DlgOrderCrit,FieldListSelectHdl));

	FreeResource();
}

#define LbText(x)		((x).GetSelectEntry())
#define LbPos(x)		((x).GetSelectEntryPos())

//------------------------------------------------------------------------------
DlgOrderCrit::~DlgOrderCrit()
{
	DBG_DTOR(DlgOrderCrit,NULL);
}

//------------------------------------------------------------------------------
IMPL_LINK_INLINE_START( DlgOrderCrit, FieldListSelectHdl, ListBox *, pListBox )
{
	DBG_CHKTHIS(DlgOrderCrit,NULL);
	EnableLines();
	return 0;
}
IMPL_LINK_INLINE_END( DlgOrderCrit, FieldListSelectHdl, ListBox *, pListBox )

//------------------------------------------------------------------------------
void DlgOrderCrit::EnableLines()
{
	DBG_CHKTHIS(DlgOrderCrit,NULL);
	if( LbPos(aLB_ORDERFIELD1) == 0 )
	{
		SbaOrderItemList rItemList;
		GetOrderList(rItemList);
		if(rItemList.Count())
			SetOrderList(&rItemList);
		else
		{
			aLB_ORDERFIELD2.Disable();
			aLB_ORDERVALUE2.Disable();

			aLB_ORDERFIELD3.Disable();
			aLB_ORDERVALUE3.Disable();
		}
		for( sal_uInt16 i=0 ; i < rItemList.Count() ; i++ )
			delete rItemList.GetObject(i);
		rItemList.Clear();
	}
	else
	{
		aLB_ORDERFIELD2.Enable();
		aLB_ORDERVALUE2.Enable();

		aLB_ORDERFIELD3.Enable();
		aLB_ORDERVALUE3.Enable();
	}

	if( LbPos(aLB_ORDERFIELD2) == 0 )
	{
		SbaOrderItemList rItemList;
		GetOrderList(rItemList);
		if(rItemList.Count()>1)
			SetOrderList(&rItemList);
		else
		{
			aLB_ORDERFIELD3.Disable();
			aLB_ORDERVALUE3.Disable();
		}
		for( sal_uInt16 i=0 ; i < rItemList.Count() ; i++ )
			delete rItemList.GetObject(i);
		rItemList.Clear();
	}
	else
	{
		aLB_ORDERFIELD3.Enable();
		aLB_ORDERVALUE3.Enable();
	}
}

//------------------------------------------------------------------------------
void DlgOrderCrit::SetOrderList( const SbaOrderItemList* pItemList )
{
	DBG_CHKTHIS(DlgOrderCrit,NULL);
	if (pItemList)
	{
		for (sal_uInt16 i=0 ; i<pItemList->Count() && i<DOG_ROWS; ++i)
		{
			SbaOrderItem* pItem = pItemList->GetObject( i );
			arrLbFields[i]->SelectEntry( pItem->aFieldName );
			arrLbValues[i]->SelectEntryPos( pItem->bDirection );
		}
	}

	// die nicht gesetzten auf 'kein' 'aufsteigend'
	sal_uInt16 nItemsSet = pItemList ? min((sal_Int32)pItemList->Count(), sal_Int32(DOG_ROWS)) : 0;
	for (sal_uInt16 i=0 ; i<DOG_ROWS-nItemsSet; ++i)
	{
		arrLbFields[2-i]->SelectEntryPos( 0 );
		arrLbValues[2-i]->SelectEntryPos( 0 );
	}

	EnableLines();
}

//------------------------------------------------------------------------------
void DlgOrderCrit::GetOrderList( SbaOrderItemList& rItemList )
{
	DBG_CHKTHIS(DlgOrderCrit,NULL);
	for( sal_uInt16 i=0 ; i<DOG_ROWS; i++ )
	{
		if(arrLbFields[i]->GetSelectEntryPos() != 0)
		{
			SbaOrderItem	aItem;
			aItem.aFieldName = arrLbFields[i]->GetSelectEntry();
			aItem.bDirection = arrLbValues[i]->GetSelectEntryPos()!=0;
			rItemList.Insert( new SbaOrderItem( aItem ), LIST_APPEND );
		}
	}
}

//------------------------------------------------------------------------------
String DlgOrderCrit::BuildOrderPart()
{
	DBG_CHKTHIS(DlgOrderCrit,NULL);
	String	aResult;
	SbaOrderItemList	aList;
	GetOrderList( aList );

	if( aList.Count() )
	{
		aResult += rIterator.BuildOrderPart( aList );
		for( sal_uInt16 i=0 ; i < aList.Count() ; i++ )
			delete aList.GetObject(i);
		aList.Clear();
	}

	return aResult;
}


