/*************************************************************************
 *
 *  $RCSfile: qrytbwin.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ENABLE_BYTESTRING_STREAM_OPERATORS

#ifndef _SBA_SBAOBJ_HXX //autogen
#include <sbaobj.hxx>
#endif

#include "qrytbwin.hxx"
#include "sbahlpid.hrc"

#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

#ifndef _SBA_QRYDGN1_HXX
#include "qrydgn1.hxx"
#endif // _SBA_QRYDGN1_HXX

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SBA_QRYWINCT_HXX
#include "qrywinct.hxx"
#endif // _SBA_QRYWINCT_HXX

#ifndef _SBASLTID_HRC //autogen
#include <sbasltid.hrc>
#endif

#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif // _SBA_JOINVS_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif
#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif

TYPEINIT1(QueryTabWin, SbaJoinTabWin);
TYPEINIT1(QueryTabWinData, SbaJoinTabWinData);

DBG_NAME(QueryTabWinData);
//==================================================================
// class QueryTabWinData
//==================================================================

//------------------------------------------------------------------------------
QueryTabWinData::QueryTabWinData()
	:SbaJoinTabWinData()
{
	DBG_CTOR(QueryTabWinData,NULL);
	bShowAll = sal_True;
}

//------------------------------------------------------------------------------
QueryTabWinData::QueryTabWinData(const String& rDatabaseName, const String& rTableName, const String& rTableAlias )
	:SbaJoinTabWinData(rDatabaseName, rTableName, rTableAlias)
{
	DBG_CTOR(QueryTabWinData,NULL);
	bShowAll = sal_True;
}

//------------------------------------------------------------------------------
QueryTabWinData::~QueryTabWinData()
{
	DBG_DTOR(QueryTabWinData,NULL);
}


//------------------------------------------------------------------------------
void QueryTabWinData::Load(SvStream& rStream)
{
	ByteString strAliasName;
	rStream >> strAliasName;
	SetAliasName(String(strAliasName,gsl_getSystemTextEncoding()));

	ByteString aTmp;
	rStream >> aTmp;
	aTableName.AssignAscii(aTmp.GetBuffer());
	rStream >> aTmp;
	m_strDatabaseName.AssignAscii(aTmp.GetBuffer());

	Point aPos;
	rStream >> aPos.X();
	rStream >> aPos.Y();
	SetPosition(aPos);

	Size aSize;
	rStream >> aSize.Width();
	rStream >> aSize.Height();
	SetSize(aSize);
}

//------------------------------------------------------------------------------
void QueryTabWinData::Save(SvStream& rStream)
{
	rStream << ByteString(GetAliasName(),gsl_getSystemTextEncoding());
	rStream << ByteString(aTableName,gsl_getSystemTextEncoding());
	rStream << ByteString(m_strDatabaseName,gsl_getSystemTextEncoding());
	rStream << aPosition.X();
	rStream << aPosition.Y();
	rStream << aSize.Width();
	rStream << aSize.Height();
}

//========================================================================
// class QueryTabWin
//========================================================================
DBG_NAME(QueryTabWin);
//------------------------------------------------------------------------------
QueryTabWin::QueryTabWin( Window* pParent, QueryTabWinData* pTabWinData, char* pszInitialAlias)
	:SbaJoinTabWin( pParent, pTabWinData )
	,m_nAliasNum(0)
{
	DBG_CTOR(QueryTabWin,NULL);
	if (pszInitialAlias != NULL)
		m_strInitialAlias.AssignAscii(pszInitialAlias);
	else
		m_strInitialAlias = pTabWinData->GetAliasName();

	// wenn der Tabellen- gleich dem Aliasnamen ist, dann darf ich das nicht an InitialAlias weiterreichen, denn das Anhaengen
	// eines eventuelle Tokens nicht klappen ...
	if (m_strInitialAlias == pTabWinData->GetTableName())
		m_strInitialAlias.Erase();

	SetHelpId(HID_CTL_QRYDGNTAB);
}

//------------------------------------------------------------------------------
QueryTabWin::~QueryTabWin()
{
	EmptyListBox();
	DBG_DTOR(QueryTabWin,NULL);
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWin::Init()
{
	QueryTabWinContainer* pContainer = (QueryTabWinContainer*)GetParent();

	// zuerst Alias bestimmen
	String strAliasName;

	SbaJoinTabWinData* pWinData = GetData();
	DBG_ASSERT(pWinData->ISA(QueryTabWinData), "QueryTabWin::Init() : habe keine QueryTabWinData");

	if (m_strInitialAlias.Len() )
		// Der Alias wurde explizit mit angegeben
		strAliasName = m_strInitialAlias;
	else
	{
		String aInitialTitle = pWinData->GetTableName();
		sal_Bool bOwner	=  sal_False;
		if(m_xTableDef.Is())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(m_xTableDef->GetDatabase()->GetMetaData());
			bOwner		= ::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SCHEMA_USAGE))  & ::com::sun::star::data::DatabaseQualifier::IN_DML;
		}
		// Der Alias wurde im Tabellennamen mit angegeben
		xub_StrLen nToken = aInitialTitle.GetTokenCount('.');
		if( bOwner && nToken )
			strAliasName = aInitialTitle.GetToken(nToken - 1, '.');
		else
			strAliasName = aInitialTitle;
	}

	// Alias mit fortlaufender Nummer versehen
	if (pContainer->CountTableAlias(strAliasName, m_nAliasNum))
	{
		strAliasName += '_';
		strAliasName += String::CreateFromInt32(m_nAliasNum);
	}

	strAliasName.EraseAllChars('"');
	SetAliasName(strAliasName);
		// SetAliasName reicht das als WinName weiter, dadurch benutzt es die Basisklasse

	sal_Bool bSuccess(sal_True);
	if (GetTableName().Len())
		bSuccess = SbaJoinTabWin::Init();
	else
	{	// es soll nur ein Dummy-Window aufgemacht werden ...
		DBG_ASSERT(GetAliasName().Len(), "QueryTabWin::Init : kein Alias- UND kein Tabellenname geht nicht !");
			// .. aber das braucht wenigstens einen Alias

		// alte Tabelle wegwerfen
		UnlockTable();
		m_xTableDef = NULL;

		// ::com::sun::star::form::ListBox anlegen
		if (!pListBox)
			pListBox = CreateListBox();

		// Titel setzen
		aTitle.SetText(GetAliasName());
		aTitle.Show();

		EmptyListBox();
			// neu zu fuellen brauche ich die nicht, da ich ja keine Tabelle habe
		pListBox->Show();
	}

	SFX_BINDINGS().Invalidate(SID_SBA_QRY_EXECUTE);
	return bSuccess;
}

//------------------------------------------------------------------------------
SbaJoinTabWinListBox* QueryTabWin::CreateListBox()
{
	return new QueryTabWinListBox(this, GetDatabaseName(), GetTableName());
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWin::FillListBox()
{
	QueryTabWinContainer* pContainer = (QueryTabWinContainer*)GetParent();

	QueryTabWinData* pTabWinData = (QueryTabWinData*)GetData();

	DBG_ASSERT(m_xTableDef.Is(),"QueryTabWin m_xTableDef.is() == NULL !");
	SdbTable* pTable = m_xTableDef->GetTable();

	//////////////////////////////////////////////////////////////////////
	// ::com::sun::star::form::ListBox mit Feldnamen fuellen

	TabFieldInfo* pInfo = NULL;
	const SdbColumn* pColumn = NULL;
	const SdbColumnsRef xCols = pTable->OriginalColumns();
	DBG_ASSERT(xCols.is(),"SdbTable::OriginalColumns lieferte nichts zurck!");
	String aFieldName;

	SvLBoxEntry* pEntry = pListBox->InsertEntry( String::CreateFromAscii("*") );
	pEntry->SetUserData( new TabFieldInfo() );

	for( sal_uInt16 i=1; i<xCols->Count(); i++ )
	{
		pColumn = xCols->Column(i);
		aFieldName = pColumn->GetName();

		// don't show version columns
		// FS - 01.10.99 - 68386
		if (pColumn->GetAllFlags() & SDB_FLAGS_VERSIONING)
			continue;

		pInfo = new TabFieldInfo();
		pInfo->SetKey( pColumn->IsUnique() ? TAB_PRIMARY_FIELD : TAB_NORMAL_FIELD );
		pInfo->SetDataType( pColumn->GetType() );

		pEntry = pListBox->InsertEntry( aFieldName );
		pEntry->SetUserData( pInfo );
	}

	return sal_True;
}

//------------------------------------------------------------------------------
void QueryTabWin::EmptyListBox()
{
	if(pListBox)
	{
		SvLBoxEntry* pEntry = pListBox->First();

		while(pEntry)
		{
			TabFieldInfo* pInf = (TabFieldInfo*)pEntry->GetUserData();
			delete pInf;

			SvLBoxEntry* pNextEntry = pListBox->Next(pEntry);
			pListBox->GetModel()->Remove(pEntry);
			pEntry = pNextEntry;
		}
	}
}

//------------------------------------------------------------------------------
void QueryTabWin::OnEntryDoubleClicked(SvLBoxEntry* pEntry)
{
	DBG_ASSERT(pEntry != NULL, "QueryTabWin::OnEntryDoubleClicked : pEntry darf nicht NULL sein !");
		// man koennte das auch abfragen und dann ein return hinsetzen, aber so weist es vielleicht auf Fehler bei Aufrufer hin

	if (((QueryTabWinContainer*)GetParent())->IsReadOnly())
		return;

	TabFieldInfo* pInf = (TabFieldInfo*)pEntry->GetUserData();
	DBG_ASSERT(pInf != NULL, "QueryTabWin::OnEntryDoubleClicked : Feld hat keine FieldInfo !");

	// eine DragInfo aufbauen
	TabFieldDesc	aInfo;
	aInfo.SetTabWindow(this);
	aInfo.SetField(pListBox->GetEntryText(pEntry));
	aInfo.SetTable(GetTableName());
	aInfo.SetAlias(GetAliasName());
	aInfo.SetDatabase(GetDatabaseName());
	aInfo.SetFieldIndex(pListBox->GetModel()->GetAbsPos(pEntry));
	aInfo.SetDataType(pInf->GetDataType());

	// und das entsprechende Feld einfuegen
	((QueryTabWinContainer*)GetParent())->InsertField(aInfo);
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWin::ExistsField(const String& strFieldName, TabFieldDesc& rInfo)
{
	DBG_ASSERT(pListBox != NULL, "QueryTabWin::ExistsField : habe keine ::com::sun::star::form::ListBox !");
	SvLBoxEntry* pEntry = pListBox->First();
	sal_Bool bCase = (GetDocShell()->GetJoinDocDatabase()->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;

	while (pEntry)
	{
		if (bCase ? strFieldName == pListBox->GetEntryText(pEntry) : strFieldName.EqualsIgnoreCaseAscii(pListBox->GetEntryText(pEntry)))
		{
			TabFieldInfo* pInf = (TabFieldInfo*)pEntry->GetUserData();
			DBG_ASSERT(pInf != NULL, "QueryTabWin::ExistsField : Feld hat keine FieldInfo !");

			rInfo.SetTabWindow(this);
			rInfo.SetField(strFieldName);
			rInfo.SetTable(GetTableName());
			rInfo.SetAlias(GetAliasName());
			rInfo.SetDatabase(GetDatabaseName());
			rInfo.SetFieldIndex(pListBox->GetModel()->GetAbsPos(pEntry));
			rInfo.SetDataType(pInf->GetDataType());
			return sal_True;
		}
		pEntry = pListBox->Next(pEntry);
	}

	return sal_False;
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWin::ExistsAVisitedConn() const
{
	return ((QueryTabWinContainer*)GetParent())->ExistsAVisitedConn(this);
}

//------------------------------------------------------------------------------
void QueryTabWin::KeyInput( const KeyEvent& rEvt )
{
	SbaJoinTabWin::KeyInput( rEvt );
}


//========================================================================
// class QueryTabWinListBox
//========================================================================

QueryTabWinListBox::QueryTabWinListBox(SbaJoinTabWin* pParent, const String& strDatabase, const String& strTable)
	:SbaJoinTabWinListBox(pParent, strDatabase, strTable)
{
}

//------------------------------------------------------------------------------
void QueryTabWinListBox::InitEntry(SvLBoxEntry* pEntry, const String& rStr,const Image& rImg1,const Image& rImg2 )
{
	SbaJoinTabWinListBox::InitEntry( pEntry, rStr, rImg1, rImg2 );
	TabLBoxString* pItem = new TabLBoxString(pEntry, 0, rStr);
	pEntry->ReplaceItem( pItem, 1 ); //XXX HACK!!!
}

//------------------------------------------------------------------------------
void QueryTabWinListBox::NotifyEndScroll()
{
	SbaJoinTabWinListBox::NotifyEndScroll();
}

//------------------------------------------------------------------------------
void QueryTabWinListBox::ShowTargetEmphasis( SvLBoxEntry* pEntry, sal_Bool bShow )
{
	Select(pEntry, bShow);
}

//------------------------------------------------------------------------------
void QueryTabWinListBox::LoseFocus()
{
	SbaJoinTabWinListBox::LoseFocus();
	SelectAll( sal_False );
}

//------------------------------------------------------------------------------
void QueryTabWinListBox::Resize()
{
	SvTreeListBox::Resize();
	SetHighlightRange( );
}


//========================================================================
// class TabLBoxString
//========================================================================

//------------------------------------------------------------------------------
void TabLBoxString::Paint(const Point& rPos, SvLBox& rDev, sal_uInt16 nFlags,SvLBoxEntry* pEntry)
{
	TabFieldInfo* pInf = (TabFieldInfo*)pEntry->GetUserData();

	if (pInf->GetKeyType() == TAB_PRIMARY_FIELD)
	{
		Font aNewFont = rDev.GetFont();
		aNewFont.SetWeight( WEIGHT_BOLD );
		Font aOldFont = rDev.GetFont();
		rDev.SetFont(aNewFont);

		SvLBoxString::Paint( rPos, rDev, nFlags, pEntry );
		rDev.SetFont( aOldFont );
	}
	else
	{
		SvLBoxString::Paint( rPos, rDev, nFlags, pEntry );
	}
}

