/*************************************************************************
 *
 *  $RCSfile: qrytxtvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _SBA_QRYUNDO_HXX
#include "qryundo.hxx"
#endif
#ifndef _SBA_QRYTXTVS_HXX
#include "qrytxtvs.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBATABDN_HXX
#include "sbatabdn.hxx"
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#define _SVSTDARR_STRINGSSORTDTOR
#include <svtools/svstdarr.hxx>

#define SbaQueryTxtViewSh
#include "ofaslots.hxx"

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif // _SBA_EXTBOX_HXX

TYPEINIT1(SbaQueryTxtViewSh, SbaQueryViewSh)

//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaQueryTxtViewSh, SbaQueryViewSh, SbaResId(0))
{
	SFX_OBJECTBAR_REGISTRATION(SFX_OBJECTBAR_OBJECT | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_READONLYDOC, SbaResId(RID_QRY_TOOLBOX_SQL));
}

//------------------------------------------------------------------------------
SFX_IMPL_VIEWFACTORY(SbaQueryTxtViewSh, SbaResId(0))
{
	SFX_VIEW_REGISTRATION(SbaQueryDocSh);
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::Construct( SfxViewFrame *pFrame)
{
	SetHelpId(ID_SBA_QUERYTXTVIEWSH);
	if (GetQueryShell()->GetDBDef())
	{
		SbaQueryDesignFrame* pDesignFrame = new SbaQuerySqlDesignFrame(&pFrame->GetWindow(), PTR_CAST(SbaDBDataDef, GetQueryShell()->GetDBDef()), this);
		pDesignFrame->SetHelpId(HID_QRY_DESIGN_FRAME);
		pEdit = (SqlEdit*)pDesignFrame->GetMainWin();
		pEdit->SetTextModifyHdl(LINK(this, SbaQueryTxtViewSh, OnTextModified));
		SetWindow(pDesignFrame);

		DBG_ASSERT(m_nAsyncGetFocusEvent == 0, "SbaQueryTxtViewSh::Construct : already have an focus event !");
		if (m_nAsyncGetFocusEvent == 0)
			m_nAsyncGetFocusEvent = Application::PostUserEvent(LINK(this, SbaQueryTxtViewSh, OnAsyncGetFocus));
	}
	else
		DBG_ERROR("SbaQueryTxtViewSh::Construct : document has no definition object !");
}

//------------------------------------------------------------------------------
SbaQueryTxtViewSh::SbaQueryTxtViewSh(SfxViewFrame *pFrame, SfxViewShell* pView)
				  :SbaQueryViewSh(pFrame)
				  ,pEdit(NULL)
				  ,m_bHadParseError(sal_False)
				  ,m_nAsyncGetFocusEvent(0)
{
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaQueryTxtViewSh::SbaQueryTxtViewSh(SfxViewFrame *pFrame, Window* pWindow)
				  :SbaQueryViewSh(pFrame)
				  ,pEdit(NULL)
				  ,m_bHadParseError(sal_False)
				  ,m_nAsyncGetFocusEvent(0)
{
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaQueryTxtViewSh::SbaQueryTxtViewSh( SfxViewFrame *pFrame, const SbaQueryTxtViewSh& rSh )
				  :SbaQueryViewSh(pFrame)
				  ,pEdit(NULL)
				  ,m_bHadParseError(sal_False)
				  ,m_nAsyncGetFocusEvent(0)
{
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaQueryTxtViewSh::~SbaQueryTxtViewSh()
{
	if (m_nAsyncGetFocusEvent)
		Application::RemoveUserEvent(m_nAsyncGetFocusEvent);
	m_nAsyncGetFocusEvent = 0;

	delete pEdit->GetParent();
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::InnerResizePixel( const Point &rPos, const Size &rSize )
{
	pEdit->GetParent()->SetPosSizePixel(rPos, Size(rSize.Width(), rSize.Height()));
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::OuterResizePixel( const Point &rPos, const Size &rSize )
{
	InnerResizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::Activate(sal_Bool IsMDIActivate)
{
	if (pEdit && pEdit->GetParent())
		((SbaViewSwitchFrame*)pEdit->GetParent())->EnableAccelSwitch(sal_True);

	SbaQueryViewSh::Activate(IsMDIActivate);
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::Deactivate(sal_Bool IsMDIActivate)
{
	if (pEdit && pEdit->GetParent())
		((SbaViewSwitchFrame*)pEdit->GetParent())->EnableAccelSwitch(sal_False);

	SbaQueryViewSh::Deactivate(IsMDIActivate);
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::Execute( SfxRequest& rReq )
{
	SbaQueryDocSh*  pDoc = GetQueryShell();
	switch (rReq.GetSlot())
	{
		case SID_RELOAD:
		{
			if (pDoc->IsModified())
	            if (RET_YES != QueryBox(NULL, ResId(MSG_QUERY_LASTVERSION)).Execute())
					return;

			if (!pDoc->Refresh())
				return;

			pDoc->GetUndoMgr()->Clear();
			pDoc->SetModified(sal_False);
			SetModified(sal_False);
			SFX_BINDINGS().Invalidate(SID_SAVEDOC);

			pEdit->SetText(pDoc->Statement());
			pEdit->ClearModifyFlag();
			pEdit->SaveValue();
		}
		break;
		case SID_MAIL_SENDDOC:
			SFX_APP()->ExecuteSlot(rReq);
			break;

		case SID_EDITDOC:
		{
			sal_Bool bGoOn = sal_True;
			SbaQueryDocSh* pDoc = GetQueryShell();
			if (pDoc->IsModified())
			{
				SbaExtQueryBox	aQry(NULL, SbaResId(RID_QRY_QRY_SAVEMODIFIED), pDoc->GetDBDef()->Name());
				switch (aQry.Execute())
				{
					case RET_YES:
					{
						// das Doc speichern lassen
						SfxRequest aReq(SID_SAVEDOC, SFX_CALLMODE_SLOT | SFX_CALLMODE_SYNCHRON, GetPool());
						aReq.SetSynchronCall(sal_True);
						pDoc->ExecuteSlot(aReq);
						// Return-Wert ?
						const SfxPoolItem* pReturn = aReq.GetReturnValue();
						if (pReturn && pReturn->ISA(SfxBoolItem))
							bGoOn = ((SfxBoolItem*)pReturn)->GetValue();
						else
							bGoOn = sal_True;

						pDoc->SetModified(!bGoOn);
					} break;
					case RET_NO:
						// Doc neu lesen lassen
						pDoc->ConvertFrom(*pDoc->GetMedium());

						// Edit neu anpassen
						pEdit->SetText(GetQueryShell()->Statement());
						((SbaQueryDesignFrame*)pEdit->GetParent())->CheckGraphicalPageAvailability(pEdit->GetText());

						// sowohl die UI als auch das Doc sind jetzt jungfraeulich
						pDoc->SetModified(sal_False);
						SetModified(sal_False);

						// meine Slots invalidieren
						Invalidate();

						bGoOn = sal_True;
						break;
					default:
						bGoOn = sal_False;
						break;
				}
			}
			if (bGoOn)
			{
				pEdit->SetReadOnly(!pEdit->IsReadOnly());
				GetQueryShell()->SetReadOnlyUI(pEdit->IsReadOnly());
				SFX_BINDINGS().Invalidate( SID_SBA_QRY_NATIVESQL );
				rReq.Done();
			}
		} break;
		case SID_SAVEASDOC:
			GetQueryShell()->Execute( rReq );
			break;
		case SID_COPY:
			if( !pEdit->IsInAccelAct() )
				pEdit->Copy();
			break;
		case SID_CUT:
			if( !pEdit->IsInAccelAct() )
				pEdit->Cut();
			break;
		case SID_PASTE:
			if( !pEdit->IsInAccelAct() )
				pEdit->Paste();
			break;
		case SID_SBA_QRY_EXECUTE:
			if( pDoc->UpdateStatement(sal_True) )
				pDoc->ExecuteStatement();
			else
				CloseBeamer();
			rReq.Done();
			break;
		case SID_SBA_QRY_NATIVESQL:
		{
			// Handler fuer die Fehler beim Parsen
			Link lnkOldHandler = pDoc->SetParseErrorHandler(LINK(this, SbaQueryTxtViewSh, OnParseStatementError));
			m_bHadParseError = sal_False;
			//sal_Bool bWasEnabled = pDoc->IsShowParseErrorsEnabled();
			//pDoc->EnableShowParseErrors(sal_False);

			pDoc->SetStatement(GetStatement(), pDoc->IsNative(), sal_False, sal_False);
				// noch hat sich der native-Status nicht geaendert; keine Undo-::com::sun::star::chaos::Action; noch nicht parsen (das wird beim ToggleNative
				// erledigt, wenn noetig)
			if (pDoc->ToggleNative() && !m_bHadParseError)	// m_bHadParseError wird eventuell aus ToggleNative heraus gesetzt
			{
				SfxUndoManager* pUndoMgr = GetQueryShell()->GetUndoMgr();
				SbaSqlNativeUndoAct* pUndoAct = new SbaSqlNativeUndoAct( pEdit );
				pUndoAct->SetOriginalText( GetStatement() );
				pUndoAct->SetNative(!pDoc->IsNative());
				pUndoMgr->AddUndoAction( pUndoAct );

				SFX_BINDINGS().Invalidate( SID_UNDO );
				SFX_BINDINGS().Invalidate( SID_REDO );

				// Statement neu uebernehmen, wenn !Native, da es sich veraendert haben kann
				String strStatement = GetQueryShell()->Statement();
				if (!pDoc->IsNative())
					pEdit->SetText(strStatement);		// Statement der Shell setzen

				((SbaQueryDesignFrame*)pEdit->GetParent())->CheckGraphicalPageAvailability(strStatement);
			}

			m_bHadParseError = sal_False;
			//pDoc->EnableShowParseErrors(bWasEnabled);
			pDoc->SetParseErrorHandler(lnkOldHandler);
			rReq.Done();
		}
	}
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::SwitchToDesign()
{
	SbaQueryDocSh* pDoc = GetQueryShell();
	DBG_ASSERT(pDoc != NULL, "SbaQueryTxtViewSh::SwitchToDesign : working without a doc ... this will crash !");
	DBG_ASSERT(!pDoc->IsNative(), "SbaQueryTxtViewSh::SwitchToDesign shouldn't be called in native mode !");

	// in OnViewSwitch und BuildParseTree koennen Fehler auftreten, die will ich selber handeln
	sal_Bool bWasEnabled = pDoc->IsShowParseErrorsEnabled();
	pDoc->EnableShowParseErrors(sal_False);
	Link lnkOldHandler = pDoc->SetParseErrorHandler(LINK(this, SbaQueryTxtViewSh, OnParseStatementError));
	m_bHadParseError = sal_False;

	TabBar* pFrameTabBar = &((SbaQuerySqlDesignFrame*)pEdit->GetParent())->m_aTabBar;
	if (IsModified() && !pDoc->OnViewSwitch())
	{
		pFrameTabBar->SetCurPageId(SID_SBA_QRY_SQL);

		m_bHadParseError = sal_False;
		pDoc->SetParseErrorHandler(lnkOldHandler);
		pDoc->EnableShowParseErrors(bWasEnabled);

		return;
	}

	// das Dok das Statement parsen lassen
	sal_Bool bSuccess = pDoc->BuildParseTree(GetStatement()) && !m_bHadParseError && pDoc->ParseTree() && SDB_ISRULE(pDoc->ParseTree(),select_statement);

	m_bHadParseError = sal_False;
	pDoc->SetParseErrorHandler(lnkOldHandler);
	pDoc->EnableShowParseErrors(bWasEnabled);

	if (!bSuccess && GetStatement().Len())
	{
		pFrameTabBar->SetCurPageId(SID_SBA_QRY_SQL);
		ErrorBox(NULL,SbaResId(ERR_QRY_NO_SELECT)).Execute();
		return;
	}
	else
	{
		// Das Analysieren des Statements hat erst mal geklappt.
		// Jetzt muss ich noch testen, ob ich nicht zu viele Tabellen fuer den DB-Treiber habe. (unsere dBase-Implementation
		// zum Beispiel verkraftet nur eine Tabelle)
		::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = pDoc->GetDatabase()->GetMetaData();

		sal_Int32 nMaxTables = rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::TABLES_IN_SELECT);

		if ((nMaxTables > 0) && (pDoc->Iterator().GetSdbTableRangeMap().Count() > nMaxTables))
		{	// (0 heisst unbeschraenkt)
			String strError(SbaResId(RID_STR_TOMUCHTABLES));
			strError.SearchAndReplace(String::CreateFromAscii("#num#"), String(pDoc->Iterator().GetSdbTableRangeMap().Count()));
			strError.SearchAndReplace(String::CreateFromAscii("#maxnum#"), String(nMaxTables));
			ErrorBox(NULL, WB_OK, strError).Execute();
			pFrameTabBar->SetCurPageId(SID_SBA_QRY_SQL);
			return;
		}

		// das BuildPareseTree am Doc hat geklappt ... das heisst, dass ich ihm jetzt auch seine alten TabConnDatas
		// wegnehmen muss, die ergeben sich ja jetzt neu aus dem Statement
		SbaJoinTabConnDataList* pConns = GetQueryShell()->GetTabConnDataList();
		for (sal_uInt32 i=0; i<pConns->Count(); ++i)
			delete pConns->GetObject(i);
		pConns->Clear();

		// desgleichen die TabWinDatas, die in meinem Statement nicht mehr vorhanden sind
		// (hier kann ich nicht einfach alle loeschen, denn dann wuede bei jedem View-Umschalten die Positionierung der
		// TabWins - die in den TabWinData steht - verloren gehen)
		const SdbSqlParseNode* pParseTree = GetQueryShell()->ParseTree();
		if (pParseTree)
		{
			const SbaParseIterator& aIter = GetQueryShell()->Iterator();
			const SdbTableRangeMap& aMap = aIter.GetSdbTableRangeMap();
			SbaJoinTabWinDataList* pDataList = GetQueryShell()->GetTabWinDataList();
			for (i=pDataList->Count(); i>0; --i)
			{
				SbaJoinTabWinData* pCurrentData = pDataList->GetObject(i-1);

				if (!aMap.Lookup(((QueryTabWinData*)pCurrentData)->GetAliasName()))
				{
					pDataList->Remove(pCurrentData);
					delete pCurrentData;
				}
			}
		}

		// und dann die View-Umschaltung
		SfxUInt16Item aItem(SID_VIEWSHELL, pFrameTabBar->GetCurPageId());
		SFX_DISPATCHER().Execute( SID_VIEWSHELL, SFX_CALLMODE_ASYNCHRON, &aItem, 0L );
		return;
	}

	m_bHadParseError = sal_False;
	pDoc->SetParseErrorHandler(lnkOldHandler);
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::GetState(SfxItemSet &rSet)
{
	if (!pEdit)
		return;
	SfxWhichIter aIter(rSet);

	for (sal_uInt16 nSID = aIter.FirstWhich(); nSID; nSID = aIter.NextWhich())
	{
		switch ( nSID )
		{
			case SID_SAVEASDOC:
				break;
			case SID_CUT:
			case SID_COPY:
			{
				if (!pEdit->GetSelection().Len())
					rSet.DisableItem(nSID);
				break;
			}
			case SID_MAIL_SENDDOC:
				// Sonderbehandlung, Aenderung des Menuetextes
				rSet.Put( SfxStringItem( nSID, String( SbaResId( RID_STR_MENU_NEWMAIL ) ) ) );
				break;
			case SID_SBA_QRY_EXECUTE:
			{
				String strText = pEdit->GetText();
				if (!strText.Len())
					// 60546 : nicht !pEdit->GetText().Len() abfragen, das liefert unter OS/2 immer sal_False (mieser Compiler !!!)
					rSet.DisableItem(nSID);
				break;
			}
			case SID_SBA_QRY_NATIVESQL:
			{
				if (pEdit->IsReadOnly())
					rSet.DisableItem(nSID);
				else
				{
					SbaQueryDocSh* pDoc = GetQueryShell();
					rSet.Put(SfxBoolItem(SID_SBA_QRY_NATIVESQL, pDoc->IsNative()));
					sal_Bool bEnable;
					if(pDoc->ParseTree())
						bEnable = !pDoc->IsNative() && SDB_ISRULE(pDoc->ParseTree(),select_statement);
					else
						bEnable = !pDoc->IsNative();
				}
				break;
			}
			case SID_EDITDOC:
				if (GetQueryShell()->GetDatabase()->IsReadOnly())
					rSet.DisableItem(nSID);
				else
					rSet.Put(SfxBoolItem(nSID, !pEdit->IsReadOnly()));
				break;
			default:
				GetQueryShell()->GetState(rSet);
				break;
		}
	}
}

//------------------------------------------------------------------------------
void SbaQueryTxtViewSh::SetStatement(const String& rStatement)
{
	pEdit->SetText(rStatement);
	SetModified(sal_False);
}

//------------------------------------------------------------------------------
String SbaQueryTxtViewSh::GetStatement()
{
	return pEdit->GetText();
}

//-------------------------------------------------------------------------
IMPL_LINK(SbaQueryTxtViewSh, OnAsyncGetFocus, void*, EMPTYARG)
{
	m_nAsyncGetFocusEvent = 0;
	pEdit->GrabFocus();
	return 0;
}

//-------------------------------------------------------------------------
IMPL_LINK(SbaQueryTxtViewSh, OnParseStatementError, SdbParseIteratorErrorInfo*, pInfo)
{
	m_bHadParseError = sal_True;

	sal_Int32 nErrorID = 0;
	switch (pInfo->nErrorCode)
	{
		case 1 :
			nErrorID = RID_STR_TABLE_DOESNT_EXIST;
			break;
		case 2:
			nErrorID = RID_STR_FIELD_DOESNT_EXIST;
			break;
	}

	if (nErrorID != 0)
	{
		String strError = String(SbaResId(nErrorID));
		strError.SearchAndReplace(String::CreateFromAscii("$name$"), pInfo->aExpression);
		ErrorBox(NULL, WB_OK, strError).Execute();
		return RET_BREAK;
	}

	return RET_BREAK;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaQueryTxtViewSh, OnTextModified, void*, EMPTYARG)
{
	if (GetQueryShell()->IsNative())
		return 0L;

	String strCurrent = pEdit->GetText();
	((SbaQueryDesignFrame*)pEdit->GetParent())->CheckGraphicalPageAvailability(strCurrent);
	return 0L;
}

//////////////////////////////////////////////////////////////////////////
// SqlEdit
//------------------------------------------------------------------------------
DBG_NAME(SqlEdit);
SqlEdit::SqlEdit( Window* pParent, SbaQueryTxtViewSh* pViewSh, WinBits nWinStyle ) :
	MultiLineEdit( pParent, nWinStyle ),
	pView( pViewSh ),
	rBindings( View()->GetViewFrame()->GetBindings() ),
	bAccelAction( sal_False )
{
		DBG_CTOR(SqlEdit,NULL);
	SetHelpId( HID_CTL_QRYSQLEDIT );
	SetModifyHdl( LINK(this, SqlEdit, ModifyHdl) );

	m_timerUndoActionCreation.SetTimeout(1000);
	m_timerUndoActionCreation.SetTimeoutHdl(LINK(this, SqlEdit, OnUndoActionTimer));
}

//------------------------------------------------------------------------------
SqlEdit::~SqlEdit()
{
	if (m_timerUndoActionCreation.IsActive())
		m_timerUndoActionCreation.Stop();
	DBG_DTOR(SqlEdit,NULL);
}

//------------------------------------------------------------------------------
void SqlEdit::MouseButtonUp( const MouseEvent& rMEvt )
{
	DBG_CHKTHIS(SqlEdit,NULL);
	if( rMEvt.IsLeft() )
	{
		Bindings().Invalidate( SID_CUT );
		Bindings().Invalidate( SID_COPY );
		Bindings().Update( SID_CUT );
		Bindings().Update( SID_COPY );
	}

	MultiLineEdit::MouseButtonUp( rMEvt );
}

//------------------------------------------------------------------------------
void SqlEdit::KeyInput( const KeyEvent& rKEvt )
{
	DBG_CHKTHIS(SqlEdit,NULL);
	Bindings().Invalidate( SID_CUT );
	Bindings().Invalidate( SID_COPY );

	// Ist dies ein Cut, Copy, Paste Event?
	KeyFuncType aKeyFunc = rKEvt.GetKeyCode().GetFunction();
	if( (aKeyFunc==KEYFUNC_CUT)||(aKeyFunc==KEYFUNC_COPY)||(aKeyFunc==KEYFUNC_PASTE) )
		bAccelAction = sal_True;

	MultiLineEdit::KeyInput( rKEvt );

	if( bAccelAction )
		bAccelAction = sal_False;
}

//------------------------------------------------------------------------------
sal_Bool SqlEdit::IsInAccelAct()
{
	DBG_CHKTHIS(SqlEdit,NULL);
	// Das Cut, Copy, Paste per Accel. fuehrt neben der Aktion im Edit im View
	// auch die entsprechenden Slots aus. Die  Aktionen finden also zweimal statt.
	// Um dies zu verhindern, kann im View beim SlotExec diese Funktion
	// aufgerufen werden.

	return bAccelAction;
}

//------------------------------------------------------------------------------
void SqlEdit::GetFocus()
{
	DBG_CHKTHIS(SqlEdit,NULL);
	m_strOrigText = GetText();
	MultiLineEdit::GetFocus();
}

//------------------------------------------------------------------------------
IMPL_LINK(SqlEdit, OnUndoActionTimer, void*, EMPTYARG)
{
	SfxUndoManager* pUndoMgr = View()->GetQueryShell()->GetUndoMgr();
	SbaSqlEditUndoAct* pUndoAct = new SbaSqlEditUndoAct( this );
	pUndoAct->SetOriginalText( m_strOrigText );
	pUndoMgr->AddUndoAction( pUndoAct );

	Bindings().Invalidate( SID_UNDO );
	Bindings().Invalidate( SID_REDO );

	m_strOrigText = GetText();

	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SqlEdit, ModifyHdl, void*, EMPTYTAG)
{
	if (m_timerUndoActionCreation.IsActive())
		m_timerUndoActionCreation.Stop();
	m_timerUndoActionCreation.Start();

	if (!View()->IsModified())
	{
		View()->SetModified( sal_True );
		View()->GetShell()->SetModified(sal_True);
	}

	Bindings().Invalidate( SID_SBA_QRY_EXECUTE );
	Bindings().Invalidate( SID_CUT );
	Bindings().Invalidate( SID_COPY );

	Bindings().Update( SID_SBA_QRY_EXECUTE );
	Bindings().Update( SID_CUT );
	Bindings().Update( SID_COPY );

	m_lnkTextModifyHdl.Call(NULL);
	return 0;
}

//------------------------------------------------------------------------------
void SqlEdit::OverloadedSetText(const String& rNewText)
{
	DBG_CHKTHIS(SqlEdit,NULL);
	if (m_timerUndoActionCreation.IsActive())
	{	// die noch anstehenden Undo-::com::sun::star::chaos::Action erzeugen
		m_timerUndoActionCreation.Stop();
		LINK(this, SqlEdit, OnUndoActionTimer).Call(NULL);
	}

	MultiLineEdit::SetText(rNewText);
	m_strOrigText = rNewText;
	pView->SetModified(sal_True);
}

//==============================================================================

//------------------------------------------------------------------------------
SbaQuerySqlDesignFrame::SbaQuerySqlDesignFrame(Window* pParent, SbaDBDataDef* pDef, SbaQueryTxtViewSh* pView)
	:SbaQueryDesignFrame(pParent, pDef, pView, SID_SBA_QRY_SQL)
{
	SqlEdit* pEdit = new SqlEdit(this, pView);

	SbaQueryDocSh* pDoc = (SbaQueryDocSh*)GetDocShell();
	String sStatement = pDoc->Statement();
	pEdit->SetText(sStatement);
	pView->SetModified(sal_False);

	pEdit->ClearModifyFlag();
	pEdit->SaveValue();

	sal_Bool bRO = pDoc->IsReadOnlyUI() || pDoc->GetDatabase()->IsReadOnly();
	pEdit->SetReadOnly(bRO);

	m_pMainWin = pEdit;
	m_pMainWin->Show();

	CheckGraphicalPageAvailability(sStatement);
}

