/*************************************************************************
 *
 *  $RCSfile: qryundo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVDMODEL_HXX //autogen
#include <svx/svdmodel.hxx>
#endif
#ifndef _SBA_QRYUNDO_HXX
#include "qryundo.hxx"
#endif


#ifndef _SBA_QRYCONN_HXX
#include "qryconn.hxx"
#endif // _SBA_QRYCONN_HXX

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif
DBG_NAME(QueryTabConnUndoAction);
//==============================================================================
QueryTabWinUndoAct::~QueryTabWinUndoAct()
{
	if (m_bOwnerOfObjects)
	{	// wenn ich der alleinige Owner des Fenster bin, muss ich dafuer sorgen, dass es geloescht wird
		DBG_ASSERT(m_pTabWin != NULL, "QueryTabWinUndoAct::~QueryTabWinUndoAct() : m_pTabWin sollte nicht NULL sein");
		DBG_ASSERT(!m_pTabWin->IsVisible(), "QueryTabWinUndoAct::~QueryTabWinUndoAct() : *m_pTabWin sollte nicht sichtbar sein");

		delete m_pTabWin->GetData();
		delete m_pTabWin;

		// und natuerlich auch die entsprechenden Connections
		SbaJoinTabConn* pConnLoop = m_lstConnections.First();
		while (pConnLoop)
		{
			delete pConnLoop->GetData();
			SbaJoinTabConn* pTemp = m_lstConnections.Next();
			delete pConnLoop;
			pConnLoop = pTemp;
		}
	}
}

//------------------------------------------------------------------------------
void QueryMoveTabWinUndoAct::TogglePosition()
{
	SbaJoinFrameWindow* pFrame =  (SbaJoinFrameWindow*)m_pOwner->GetParent();

	Point ptFrameScrollPos(pFrame->GetHScrollBar()->GetThumbPos(), pFrame->GetVScrollBar()->GetThumbPos());
	Point ptNext = m_pTabWin->GetPosPixel() + ptFrameScrollPos;

	m_pTabWin->SetPosPixel(m_ptNextPosition - ptFrameScrollPos);
		// sieht so aus, als wenn das ptFrameScrollPos sinnlos ist, da ich es hier abziehe und auf das ptNext aufaddiere, wo
		// ich es das naechste Mal ja wieder abziehe ... Aber ptFrameScrollPos kann sich natuerlich beim naechsten Mal schon wieder
		// geaendert haben ...
	m_pOwner->EnsureVisible(m_pTabWin);

	m_ptNextPosition = ptNext;
}

//------------------------------------------------------------------------------
void SbaTabFieldCellModifiedUndoAct::Undo()
{
	String strNext = pOwner->GetCellContents(m_nCellIndex, m_nColId);
	pOwner->SetCellContents(m_nCellIndex, m_nColId, m_strNextCellContents);
	m_strNextCellContents = strNext;
}

//------------------------------------------------------------------------------
void SbaTabFieldSizedUndoAct::Undo()
{
	long nNextWidth = pOwner->GetColumnWidth(m_nColId);
	pOwner->SetColWidth(m_nColId, m_nNextWidth);
	m_nNextWidth = nNextWidth;
}

//////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------
void SbaSqlEditUndoAct::ToggleText()
{
	String strNext = pOwner->GetText();
	pOwner->OverloadedSetText(m_strNextText);
	m_strNextText = strNext;
}
//------------------------------------------------------------------------------
void SbaSqlNativeUndoAct::ToggleNative()
{
	pOwner->View()->GetQueryShell()->SetNative(m_bNative);
	m_bNative = !m_bNative;
}



