/*************************************************************************
 *
 *  $RCSfile: qryvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_QRYVS_HXX
#include "qryvs.hxx"
#endif
#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif
#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_QRYTXTVS_HXX
#include "qrytxtvs.hxx"
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

TYPEINIT1(SbaQueryViewSh, SbaDBDataDefViewSh)

//------------------------------------------------------------------------------
SbaQueryViewSh::SbaQueryViewSh(SfxViewFrame *pFrame)
			   :SbaDBDataDefViewSh(pFrame)
			   ,bModified(sal_False)
{
	StartListening(*GetObjectShell());
}

//------------------------------------------------------------------------------
SbaQueryViewSh::~SbaQueryViewSh()
{
	EndListening(*GetObjectShell());
}

//------------------------------------------------------------------------------
void SbaQueryViewSh::SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
								 const SfxHint& rHint, const TypeId& rHintType )
{
	if (!rHint.IsA(SbaHint::StaticType()))
		return;

	SbaViewUpdateQueryHint *pHint = PTR_CAST(SbaViewUpdateQueryHint,&rHint);
	if (pHint)
		SetStatement(pHint->Statement());
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaQueryViewSh, ModifyHdl, void*, EMPTYTAG)
{
	if (!IsModified())
	{
		((SbaQueryDocSh*)GetShell())->AddUndo();
		SetModified(sal_True);
	}
	return 0;
}

//------------------------------------------------------------------------------
void SbaQueryViewSh::SetStatement(const String&){}

//------------------------------------------------------------------------------
String SbaQueryViewSh::GetStatement(){return String();}

//------------------------------------------------------------------------------
SfxUndoManager* SbaQueryViewSh::GetUndoManager()
{
	return ((SbaQueryDocSh*)GetShell())->GetUndoMgr();
};

//------------------------------------------------------------------------------
void SbaQueryViewSh::CloseBeamer()
{
	SfxBoolItem aShowBrowser( SID_BROWSER, sal_False );
	SFX_DISPATCHER().Execute( SID_BROWSER, SID_BROWSER, &aShowBrowser, 0L );
};

//==============================================================================

//------------------------------------------------------------------------------
SbaQueryDesignFrame::SbaQueryDesignFrame(Window* pParent, SbaDBDataDef* pDef, SbaQueryViewSh* pView, sal_uInt16 nInitialId)
	:SbaViewSwitchFrame(pParent, pDef, pView)
{
	// initialize the tab bar
	m_aTabBar.InsertPage(SID_SBA_QRY_DESIGN, String(SbaResId(STR_QRY_DESIGN)));
	m_aTabBar.SetHelpId(SID_SBA_QRY_DESIGN, HID_TAB_BAR_PAGE_QUERY_DESIGN);
	m_aTabBar.InsertPage(SID_SBA_QRY_SQL, String(SbaResId(STR_QRY_SQL)));
	m_aTabBar.SetHelpId(SID_SBA_QRY_SQL, HID_TAB_BAR_PAGE_QUERY_SQL);

	m_aTabBar.SetHelpId(HID_QRYDGN_TABBAR);

	SbaQueryDef* pQuery = PTR_CAST(SbaQueryDef, pDef);
	if (pQuery)
		CheckGraphicalPageAvailability(pQuery->Statement());
#if DEBUG || DBG_UTIL
	else
		DBG_ASSERT(pDef && pDef->GetKind() == dbView, "SbaQueryDesignFrame::SbaQueryDesignFrame : invalid definition !");
#endif

	DBG_ASSERT(m_aTabBar.GetPagePos(nInitialId) != TAB_PAGE_NOTFOUND, "SbaQueryDesignFrame::SbaQueryDesignFrame : invalid initial id !");
	m_aTabBar.SetCurPageId(nInitialId);

	m_aTabBar.Show();
}

//------------------------------------------------------------------------------
static const String gsc_strSelect = String::CreateFromAscii("SELECT");
static const sal_uInt16 gsc_nSelectLen = gsc_strSelect.Len();

void SbaQueryDesignFrame::CheckGraphicalPageAvailability(const String& rStatementText)
{
	SbaQueryDocSh* pDoc = (SbaQueryDocSh*)GetDocShell();

	sal_Bool bAllowGraphicalDesign = sal_False;
	if (!pDoc->IsNative())
	{
		if (rStatementText.Len() == 0)
			bAllowGraphicalDesign = sal_True;
		else
		{
			String aTxt(rStatementText);
			aTxt.EraseLeadingChars();
			if (aTxt.Len() >= gsc_nSelectLen)
			{
				String strTest = aTxt.Copy(0, gsc_nSelectLen);
				strTest.ToUpperAscii();
				if (gsc_strSelect == strTest)
					bAllowGraphicalDesign = sal_True;
			}
		}
	}

	m_aTabBar.EnablePage( SID_SBA_QRY_DESIGN, bAllowGraphicalDesign);
}

//------------------------------------------------------------------------------
void SbaQueryDesignFrame::TabSelected(sal_uInt16 nId)
{
	switch (nId)
	{
		case SID_SBA_QRY_SQL:
		case SID_SBA_QRY_DESIGN:
			PostUserEvent(LINK(this, SbaQueryDesignFrame, OnAsyncViewSwitch), (void*)(nId));
				// Switch  asynchronously : when switching the view the shell is destroyed, i.e. this window
				// and it's tabbar) are destroyed, too.
				// Doing this synchronous would be deadly ...

			break;
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaQueryDesignFrame, OnAsyncViewSwitch, sal_uInt32, nSelectedPageId)
{
	switch ((sal_uInt16)nSelectedPageId)
	{
		case SID_SBA_QRY_DESIGN:
			if (m_pView->ISA(SbaQueryTxtViewSh))
				((SbaQueryTxtViewSh*)m_pView)->SwitchToDesign();
#ifdef DBG_UTIL
			else
				DBG_ERROR("SbaQueryDesignFrame::TabSelected : wrong type of query view shell !");
#endif // DBG_UTIL
			break;
		case SID_SBA_QRY_SQL:
		{
			((QueryDesignWin*)m_pMainWin)->SaveUIConfig();

			SbaQueryDocSh* pDoc = (SbaQueryDocSh*)GetDocShell();
			if (!pDoc->OnViewSwitch())
				m_aTabBar.SetCurPageId(SID_SBA_QRY_DESIGN);
			else
			{
				// Das Statement wird bereits im OnViewSwitch() aufgebaut, wenn sich etwas ge"andert hat
		//		String aStmt(pView->GetStatement());
				// ParseTree bauen und Seitenwechsel
		//		pDoc->SetStatement( aStmt, sal_False, sal_False, sal_True );	// Hier wird Parsetree aufgebaut

				SfxUInt16Item aItem(SID_VIEWSHELL, m_aTabBar.GetCurPageId());
				SFX_DISPATCHER().Execute( SID_VIEWSHELL, SFX_CALLMODE_ASYNCHRON, &aItem, 0L );
			}
		}
		break;
	}

	return 0L;
}

