/*************************************************************************
 *
 *  $RCSfile: qrywinct.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SBA_QRYCONN_HXX
#include "qryconn.hxx"
#endif // _SBA_QRYCONN_HXX

#ifndef _SBA_QRYWINCT_HXX
#include "qrywinct.hxx"
#endif
#include "qry.hrc"
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SBA_QRYTBWIN_HXX
#include "qrytbwin.hxx"
#endif	// _SBA_QRYTBWIN_HXX

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SDB_SDBREL_HXX //autogen
#include <sdb/sdbrel.hxx>
#endif

#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif // _SBA_QRYDS_HXX

#include "sbaitems.hrc"

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif

#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif

#ifndef _SV_DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif

#ifndef _URLBMK_HXX //autogen
#include <svtools/urlbmk.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SBA_SBAOBJ_HXX //autogen
#include <sbaobj.hxx>
#endif

#ifndef _SBA_QRYUNDO_HXX
#include "qryundo.hxx"
#endif // _SBA_QRYUNDO_HXX

#ifndef __JOINEXCH_HXX_
#include "joinexch.hxx"
#endif //  __JOINEXCH_HXX_

#define _SVSTDARR_STRINGSSORTDTOR
#include <svtools/svstdarr.hxx>

#ifndef QRYDLG_HXX
#include "qrydlg.hxx"
#endif // QRYDLG_HXX

#ifndef _SBA_QRYDGNVS_HXX
#include "qrydgnvs.hxx"
#endif

TYPEINIT1(QueryTabWinContainer, SbaJoinTabWinCont);


//==================================================================
// class QueryTabWinContainer
//==================================================================
DBG_NAME(QueryTabWinContainer);

//------------------------------------------------------------------------
inline SbaQueryDocSh* QueryTabWinContainer::GetQueryDocShell()
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	return (SbaQueryDocSh*)GetDocShell()->GetObjectShell();
}

//------------------------------------------------------------------------
QueryTabWinContainer::QueryTabWinContainer( Window* pParent, SbaJoinViewShExt* pView )
	: SbaJoinTabWinCont( pParent, pView )
{
	DBG_CTOR(QueryTabWinContainer,NULL);
	SetHelpId(HID_CTL_QRYDGNTAB);
	EnableDrop();
}

//------------------------------------------------------------------------
QueryTabWinContainer::~QueryTabWinContainer()
{
	DBG_DTOR(QueryTabWinContainer,NULL);
	//////////////////////////////////////////////////////////////////////
	// Listen loeschen
	for(sal_uInt32 i=0;i<GetTabWinMap()->Count();i++)
		delete GetTabWinMap()->GetObject(i);
	GetTabWinMap()->Clear();

	SbaJoinTabConn* pJoinConn;
	while( pJoinConn = GetTabConnList()->Remove((sal_uInt32)0) )
		delete pJoinConn;

	// den Undo-Manager des Dokuments leeren (da die UndoActions sich eventuell TabWins von mir halten, das gibt sonst eine
	// Assertion in Window::~Window)
	GetQueryDocShell()->GetUndoMgr()->Clear();
}

//------------------------------------------------------------------------
sal_uInt16 QueryTabWinContainer::CountTableAlias(const String& rName, sal_uInt16& rMax)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	sal_uInt16 nRet = 0;

	QueryTabWin* pTabWin = (QueryTabWin*)(GetTabWinMap()->Lookup(rName));

	String aNewName;
	while (pTabWin)
	{
		aNewName = rName;
		aNewName += '_';
		aNewName += String::CreateFromInt32(++nRet);

		pTabWin = (QueryTabWin*)(GetTabWinMap()->Lookup(aNewName));
	}

	rMax = nRet;

	return nRet;
}


//------------------------------------------------------------------------
void QueryTabWinContainer::TabWinMoved(SbaJoinTabWin* pWhich, const Point& ptOldPosition)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinCont::TabWinMoved(pWhich, ptOldPosition);

	SfxUndoAction* pUndoAction = new QueryMoveTabWinUndoAct(this, ptOldPosition, (QueryTabWin*)pWhich);
	GetQueryDocShell()->GetUndoMgr()->AddUndoAction(pUndoAction);
}

//------------------------------------------------------------------------
void QueryTabWinContainer::TabWinSized(SbaJoinTabWin* pWhich, const Point& ptOldPosition, const Size& szOldSize)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinCont::TabWinSized(pWhich, ptOldPosition, szOldSize);

	SfxUndoAction* pUndoAction = new QuerySizeTabWinUndoAct(this, ptOldPosition, szOldSize, (QueryTabWin*)pWhich);
	GetQueryDocShell()->GetUndoMgr()->AddUndoAction(pUndoAction);
}

//------------------------------------------------------------------------
void QueryTabWinContainer::ReSync()
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinDataList* pTabWinDataList = GetDocShell()->GetTabWinDataList();
	DBG_ASSERT((GetTabConnList()->Count()==0) && (GetTabWinMap()->Count()==0),
		"vor QueryTabWinContainer::ReSync() bitte ClearAll aufrufen !");

	// ich brauche eine Sammlung aller Fensternamen, deren Anlegen schief geht, damit ich die entsprechenden Connections
	// gar nicht erst anlege
	SvStringsSortDtor arrInvalidTables;

	// Fenster kreieren und einfuegen
	sal_uInt16 nCount = pTabWinDataList->Count();
	for (sal_uInt16 i=nCount; i>0; --i)
	{
		QueryTabWinData* pTabWinData = (QueryTabWinData*)pTabWinDataList->GetObject(i-1);
		QueryTabWin* pTabWin = new QueryTabWin(this, pTabWinData);

		// ich gehe jetzt NICHT ueber ShowTabWin, da dieses die Daten des Fensters in die Liste des Docs einfuegt, was
		// schlecht waere, denn genau von dort hole ich sie ja gerade
		// also Schritt fuer Schritt
		if (!pTabWin->Init())
		{
			// das Initialisieren ging schief, dass heisst, dieses TabWin steht nicht zur Verfuegung, also muss ich es inklusive
			// seiner Daten am Dokument aufraeumen
			delete pTabWin;
			arrInvalidTables.Insert(new String(pTabWinData->GetAliasName()));

			pTabWinDataList->Remove(pTabWinData);
			delete pTabWinData;
			continue;
		}

		GetTabWinMap()->InsertAt(pTabWinData->GetAliasName(),pTabWin);	// am Anfang einfuegen, da ich die DataList ja rueckwaerts durchlaufe
		// wenn in den Daten keine Position oder Groesse steht -> Default
		if (!pTabWinData->HasPosition() && !pTabWinData->HasSize())
			SetDefaultTabWinPosSize(pTabWin);

		pTabWin->Show();
	}

	// Verbindungen einfuegen
	SbaJoinTabConnDataList* pTabConnDataList = GetDocShell()->GetTabConnDataList();
	nCount = pTabConnDataList->Count();
	for (i=nCount; i>0; --i)
	{
		QueryTabConnData* pTabConnData = (QueryTabConnData*)pTabConnDataList->GetObject(i-1);

		// gibt es die beiden Tabellen zur Connection ?
		sal_uInt16 nPos;
		String strTabExistenceTest = pTabConnData->GetSourceWinName();
		sal_Bool bInvalid = arrInvalidTables.Seek_Entry(&strTabExistenceTest, &nPos);
		strTabExistenceTest = pTabConnData->GetDestWinName();
		bInvalid |= arrInvalidTables.Seek_Entry(&strTabExistenceTest, &nPos);

		if (bInvalid)
		{	// nein -> Pech gehabt, die Connection faellt weg
			pTabConnDataList->Remove(pTabConnData);
			delete pTabConnData;
			continue;
		}

		GetTabConnList()->Insert(new QueryTabConn(this, pTabConnData), sal_uInt32(0));
	}
}

//------------------------------------------------------------------------
void QueryTabWinContainer::ClearAll()
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinCont::ClearAll();

	QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
	pWin->SetModified();
	SetUpdateMode(sal_True);
	SFX_BINDINGS().Invalidate(SID_SBA_QRY_EXECUTE);
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::NotifyTabConnection(const QueryTabConn& rNewConn, sal_Bool _bCreateUndoAction)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	// erst mal schauen, ob ich diese Connection schon habe
	QueryTabConn* pTabConn = (QueryTabConn*)GetTabConnList()->First();
	while (pTabConn)
	{
		if (*pTabConn == rNewConn)
			break;
		pTabConn = (QueryTabConn*)GetTabConnList()->Next();
	}

	// nein -> einfuegen
	if (pTabConn == NULL)
	{
		// die neuen Daten ...
		QueryTabConnData* pNewData = (QueryTabConnData*)rNewConn.GetData()->NewInstance();
		pNewData->CopyFrom(*rNewConn.GetData());
		// ... an das Dokument anhaengen
		GetDocShell()->GetTabConnDataList()->Insert(pNewData, LIST_APPEND);
		// ... und an eine neue QueryTabConn-Instanz haengen, die ich mir gleich merke
		QueryTabConn* pNewConn = new QueryTabConn(this, pNewData);
		GetTabConnList()->Insert(pNewConn, LIST_APPEND);

		// Modified-Flag
		QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
		pWin->SetModified();

		// eine Undo-::com::sun::star::chaos::Action fuer die Connection
		if (_bCreateUndoAction)
		{
			QueryTabConnUndoAction* pUndoAction = new QueryAddTabConnUndoAction(this);
			pUndoAction->SetOwnership(sal_False);
			pUndoAction->SetConnection(pNewConn);
			GetQueryDocShell()->GetUndoMgr()->AddUndoAction(pUndoAction);
		}

		// und neu zeichnen
		pNewConn->RecalcLines();
			// fuer das unten folgende Invalidate muss ich dieser neuen Connection erst mal die Moeglichkeit geben,
			// ihr BoundingRect zu ermitteln
		pNewConn->Invalidate();
	}
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::AddTabWin(const String& strDatabase, const String& strTableName, sal_Bool bNewTable)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	// das ist die aus der Basisklasse geerbte Methode, die fuehre ich auf die an meinem Parent zurueck, die mir eventuell einen
	// Alias dazu bastelt und das an mein anderes AddTabWin weiterreicht

	// leider ist strTableName voll qualifiziert, das QueryDesignWin erwartet aber einen String, der
	// nur aus Schema und Tabelle besteht und keinen Katalog enthaelt.
	String sCatalog, sSchema, sTable;
	GetDatabase()->QualifiedNameComponents(strTableName, sCatalog, sSchema, sTable);
	String sRealName(sSchema);
	if (sRealName.Len())
		sRealName+= '.';
	sRealName += sTable;

	((QueryDesignWin*)GetParent())->AddTable(strDatabase, sRealName, NULL, bNewTable);
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::AddTabWin(const String& strDatabase, const String& strTableName, const String& strAlias, sal_Bool bNewTable)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(strTableName.Len() || strAlias.Len(), "QueryTabWinContainer::AddTabWin : kein Tabellen- und kein Aliasname !");
		// wenn der Tabellenname nicht gesetzt ist, steht das fuer ein Dummy-Fenster, das braucht aber wenigstens einen Alias-Namen

	String strDBName = strDatabase;

	// neue Datenstruktur erzeugen
	QueryTabWinData* pNewTabWinData = new QueryTabWinData(strDBName, strTableName, strAlias);
		// die TabWinData brauche ich nicht in die entsprechende Liste der DocShell eintragen, das macht ShowTabWin

	// neues Fenster erzeugen
	QueryTabWin* pNewTabWin = new QueryTabWin(this, pNewTabWinData);
	// das Init kann ich hier weglassen, da das in ShowTabWin passiert

	// Neue UndoAction
	QueryTabWinShowUndoAct* pUndoAction = new QueryTabWinShowUndoAct(this);
	pUndoAction->SetTabWin(pNewTabWin);	// Fenster
	sal_Bool bSuccess = ShowTabWin(pNewTabWin, pUndoAction);

	// Relationen zwischen den einzelnen Tabellen anzeigen
	SbaJoinTabWinMap* pTabWins = GetTabWinMap();
	if(bNewTable && pTabWins->Count() && strTableName.Len())
	{
		SbaDatabaseRef xDatabase(GetDatabase());
		SbaTableDefRef xTableDef((SbaTableDef*)xDatabase->OpenDBDef(dbTable, strTableName));
		sal_Bool bCase = (xDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
		if(xTableDef.Is() )
		{
			SdbTable* pTable = xTableDef->GetTable(); // pTable enthaelt die neu ausgewaehlte Tabelle
			//////////////////////////////////////////////////////////////////////
			// Relationen aus der Datenbank holen
			sal_uInt16 nRelCount(xDatabase->GetObjectCount( dbRelation ));
			for( sal_uInt16 i=0; i<nRelCount; i++ )
			{
				SdbRelationRef xRelation((SdbRelation*)xDatabase->OpenObject( dbRelation, i ));
				// alle Relationen durchlaufen und nach der ausgewaehlten suchen
				if (bCase ? xRelation->GetTableName() == strTableName : xRelation->GetTableName().EqualsIgnoreCaseAscii(strTableName))
				{
					// jetzt nach der foreign table im Entwurf suchen
					sal_Bool bNotFound(sal_True);
					for (sal_uInt16 i=0;bNotFound && i<pTabWins->Count();i++)
					{
						QueryTabWin* pTabWinTmp = (QueryTabWin*)pTabWins->GetObject(i);
						if (bCase ? pTabWinTmp->GetTableName() == xRelation->GetForeignTableName() : 
									pTabWinTmp->GetTableName().EqualsIgnoreCaseAscii(xRelation->GetForeignTableName()))
						{
							// Relationstabelle gefunden
							SdbColumnsRef xRelCols(xRelation->GetColumns());
							SbaTableDefRef xTableDest((SbaTableDef*)xDatabase->OpenDBDef( dbTable, xRelation->GetForeignTableName()));
							const SdbColumnsRef rDestColumns = xTableDest->GetTable()->Columns();
							const SdbColumnsRef rFromColumns = pTable->Columns();
							for (sal_uInt16 j=1; j<xRelCols->Count(); j++)
							{
								const SdbColumnRelation* pRelCol = (SdbColumnRelation*)xRelCols->Column(j);

								DBG_ASSERT(pNewTabWin->GetDatabaseName() == pTabWinTmp->GetDatabaseName(),
									"QueryTabWinContainer::AddTabWin : ups, Relation zwischen Tabellen verschiedener Datenbanken !");

								// QueryTabConnData aufbauen
								QueryTabConnData aNewConnData(pNewTabWin->GetTableName(), pTabWinTmp->GetTableName(),
									pNewTabWin->GetAliasName(), pTabWinTmp->GetAliasName());

								const SdbColumn *pFromColumn = rFromColumns->Column(pRelCol->GetName());
								const SdbColumn *pDestColumn = rDestColumns->Column(pRelCol->GetForeignName());

								aNewConnData.SetFieldType(JTCS_FROM,pFromColumn->IsPrimaryKey() ? TAB_PRIMARY_FIELD : TAB_NORMAL_FIELD);
								aNewConnData.SetFieldType(JTCS_TO,pDestColumn->IsPrimaryKey() ? TAB_PRIMARY_FIELD : TAB_NORMAL_FIELD);

								aNewConnData.SetFieldIndex(JTCS_FROM,pFromColumn->GetId());
								aNewConnData.SetFieldIndex(JTCS_TO,pDestColumn->GetId());

								aNewConnData.AppendConnLine(pFromColumn->GetName(),pDestColumn->GetName());

								// dann die Conn selber dazu
								QueryTabConn aNewConn(this, &aNewConnData);
									// der Verweis auf die lokale Variable ist unkritisch, da NotifyQueryTabConn eine neue Kopie anlegt
								// und mir hinzufuegen (wenn nicht schon existent)
								NotifyTabConnection(aNewConn, sal_False);
									// don't create an Undo-::com::sun::star::chaos::Action for the new connection : the connection is
									// covered by the Undo-::com::sun::star::chaos::Action for the tabwin, as the "Undo the insert" will
									// automatically remove all connections adjacent to the win.
									// (Because of this automatism we would have an ownerhsip ambiguity for
									// the connection data if we would insert the conn-Undo-::com::sun::star::chaos::Action)
									// FS - 21.10.99 - 69183
							}
							bNotFound = sal_False;
						}
					}
				}
				else if (bCase ? xRelation->GetForeignTableName() == strTableName : xRelation->GetForeignTableName().EqualsIgnoreCaseAscii(strTableName))
				{
					sal_Bool bNotFound(sal_True);
					for (sal_uInt16 i=0;bNotFound && i<pTabWins->Count();i++)
					{
						QueryTabWin* pTabWinTmp = (QueryTabWin*)pTabWins->GetObject(i);
						if (bCase ? pTabWinTmp->GetTableName() == xRelation->GetTableName() : pTabWinTmp->GetTableName().EqualsIgnoreCaseAscii(xRelation->GetTableName()))
						{
							// Relationstabelle gefunden
							SdbColumnsRef xRelCols(xRelation->GetColumns());
							SbaTableDefRef xTableDest((SbaTableDef*)xDatabase->OpenDBDef( dbTable, xRelation->GetTableName()));
							const SdbColumnsRef rDestColumns = xTableDest->GetTable()->Columns();
							const SdbColumnsRef rFromColumns = pTable->Columns();
							for ( sal_uInt16 j=1; j<xRelCols->Count(); j++)
							{
								const SdbColumnRelation* pRelCol = (SdbColumnRelation*)xRelCols->Column(j);

								// QueryTabConnData aufbauen
								QueryTabConnData aNewConnData(pNewTabWin->GetTableName(), pTabWinTmp->GetTableName(),
									pNewTabWin->GetAliasName(), pTabWinTmp->GetAliasName());

								const SdbColumn *pFromColumn = rFromColumns->Column(pRelCol->GetForeignName());
								const SdbColumn *pDestColumn = rDestColumns->Column(pRelCol->GetName());

								aNewConnData.SetFieldType(JTCS_TO, pDestColumn->IsPrimaryKey() ? TAB_PRIMARY_FIELD : TAB_NORMAL_FIELD);
								aNewConnData.SetFieldType(JTCS_FROM, pFromColumn->IsPrimaryKey() ? TAB_PRIMARY_FIELD : TAB_NORMAL_FIELD);

								aNewConnData.SetFieldIndex(JTCS_TO,pDestColumn->GetId());
								aNewConnData.SetFieldIndex(JTCS_FROM,pFromColumn->GetId());

								aNewConnData.AppendConnLine(pFromColumn->GetName(),pDestColumn->GetName());
								// dann die Conn selber dazu
								QueryTabConn aNewConn(this, &aNewConnData);
								// und mir hinzufuegen (wenn nicht schon existent)
								NotifyTabConnection(aNewConn, sal_False);
									// don't create an Undo-::com::sun::star::chaos::Action for the new connection : the connection is
									// covered by the Undo-::com::sun::star::chaos::Action for the tabwin, as the "Undo the insert" will
									// automatically remove all connections adjacent to the win.
									// (Because of this automatism we would have an ownerhsip ambiguity for
									// the connection data if we would insert the conn-Undo-::com::sun::star::chaos::Action)
									// FS - 21.10.99 - 69183
							}
							bNotFound = sal_False;
						}
					}
				}
			}
		}
	}
	// mein Parent brauche ich, da es vom Loeschen erfahren soll
	QueryDesignWin* pParent = (QueryDesignWin*)GetParent();
	pParent->View()->SetModified(sal_True);

	GetQueryDocShell()->GetUndoMgr()->AddUndoAction( pUndoAction );

	if (bSuccess && m_lnkTabWinsChangeHandler.IsSet())
	{
		TabWinsChangeNotification aHint(TabWinsChangeNotification::AT_ADDED_WIN, pNewTabWin->GetAliasName());
		m_lnkTabWinsChangeHandler.Call(&aHint);
	}

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	GetViewShell()->GetViewShell()->UIFeatureChanged();
}
//------------------------------------------------------------------------
void QueryTabWinContainer::AddConnection(const SbaJoinExchangeData& jxdSource, const SbaJoinExchangeData& jxdDest)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	QueryTabWin* pSourceWin = (QueryTabWin*)jxdSource.pListBox->GetTabWin();
	QueryTabWin* pDestWin = (QueryTabWin*)jxdDest.pListBox->GetTabWin();

	String aSourceFieldName, aDestFieldName;
	aSourceFieldName	= jxdSource.pListBox->GetEntryText(jxdSource.pEntry);
	aDestFieldName		= jxdDest.pListBox->GetEntryText(jxdDest.pEntry);

	SbaJoinTabConn* pConn = GetTabConn(pSourceWin,pDestWin);
	if(!pConn)
	{
		// neues Daten-Objekt
		QueryTabConnData aNewConnectionData(pSourceWin->GetTableName(), pDestWin->GetTableName(), pSourceWin->GetAliasName(), pDestWin->GetAliasName());

		sal_uInt32			nSourceFieldIndex, nDestFieldIndex;
		SbaTabFieldType	tSourceFieldType, tDestFieldType;

		// Namen/Position/Typ der beiden betroffenen Felder besorgen ...
		// Source

		nSourceFieldIndex = jxdSource.pListBox->GetModel()->GetAbsPos(jxdSource.pEntry);
		tSourceFieldType = ((TabFieldInfo*)jxdSource.pEntry->GetUserData())->GetKeyType();

		// Dest

		nDestFieldIndex = jxdDest.pListBox->GetModel()->GetAbsPos(jxdDest.pEntry);
		tDestFieldType = ((TabFieldInfo*)jxdDest.pEntry->GetUserData())->GetKeyType();

		// ... und setzen

		aNewConnectionData.SetFieldIndex(JTCS_FROM, nSourceFieldIndex);
		aNewConnectionData.SetFieldIndex(JTCS_TO, nDestFieldIndex);

		aNewConnectionData.SetFieldType(JTCS_FROM, tSourceFieldType);
		aNewConnectionData.SetFieldType(JTCS_TO, tDestFieldType);

		aNewConnectionData.AppendConnLine( aSourceFieldName,aDestFieldName );

		QueryTabConn aNewConnection(this, &aNewConnectionData);
		NotifyTabConnection(aNewConnection);
			// wie immer bei NotifyTabConnection ist das Verwenden lokaler Variablen unkritisch, da sowieso eine Kopie erzeugt wird
	}
	else
	{
		// the connection could point on the other side
		if(pConn->GetSourceWin() == pDestWin)
		{
			String aTmp(aSourceFieldName);
			aSourceFieldName = aDestFieldName;
			aDestFieldName = aTmp;
		}

		pConn->GetData()->AppendConnLine( aSourceFieldName,aDestFieldName );
		pConn->UpdateLineList();
		// Modified-Flag
		QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
		pWin->SetModified();

		// eine Undo-::com::sun::star::chaos::Action fuer die Connection
		QueryTabConnUndoAction* pUndoAction = new QueryAddTabConnUndoAction(this);
		pUndoAction->SetOwnership(sal_False);
		pUndoAction->SetConnection((QueryTabConn*)pConn);
		GetQueryDocShell()->GetUndoMgr()->AddUndoAction(pUndoAction);

		// und neu zeichnen
		pConn->RecalcLines();
			// fuer das unten folgende Invalidate muss ich dieser neuen Connection erst mal die Moeglichkeit geben,
			// ihr BoundingRect zu ermitteln
		pConn->Invalidate();
	}
}


//------------------------------------------------------------------------
void QueryTabWinContainer::ConnDoubleClicked(SbaJoinTabConn* pConnection)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(pConnection->ISA(QueryTabConn), "QueryTabWinContainer::ConnDoubleClicked : pConnection hat falschen Typ");
		// da ich nur solche selber verwende, duerfen auch nur solche hier ankommen

	DlgQryJoin aDlg(this,((QueryTabConnData*)pConnection->GetData()),GetDatabase());
	aDlg.Execute();
	if(((QueryTabConnData*)pConnection->GetData())->GetJoinType() != aDlg.GetJoinType())
	{
		((QueryTabConnData*)pConnection->GetData())->SetJoinType(aDlg.GetJoinType());
		((SbaQueryViewSh*)GetQueryDocShell()->GetCurView())->SetModified(sal_True);
	}
/*
	String strMessage(SbaResId(RID_STR_CONNECTION_DATA));
	strMessage.SearchAndReplace("$alias1$", ((QueryTabConn*)pConnection)->GetAliasName(JTCS_FROM));
	strMessage.SearchAndReplace("$alias2$", ((QueryTabConn*)pConnection)->GetAliasName(JTCS_TO));
	strMessage.SearchAndReplace("$field1$", ((QueryTabConn*)pConnection)->GetFieldName(JTCS_FROM));
	strMessage.SearchAndReplace("$field2$", ((QueryTabConn*)pConnection)->GetFieldName(JTCS_TO));

	InfoBox(this, strMessage).Execute();
*/
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::RemoveConnection( SbaJoinTabConn* pConn )
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(pConn->ISA(QueryTabConn), "QueryTabWinContainer::RemoveConnection : Connection ist vom falschen Typ !");
	// NICHT die Basisklasse erledigen lassen (die loescht die Connection hart, ich will sie aber ans Undo uebergeben)
	DropConnection((QueryTabConn*)pConn);

	// eine Undo-::com::sun::star::chaos::Action
	QueryTabConnUndoAction* pUndoAction = new QueryDelTabConnUndoAction(this);
	pUndoAction->SetOwnership(sal_True);
	pUndoAction->SetConnection((QueryTabConn*)pConn);
	GetQueryDocShell()->GetUndoMgr()->AddUndoAction(pUndoAction);

	// modified-Flag
	((QueryDesignWin*)GetParent())->SetModified();
	return sal_True;
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::KeyInput( const KeyEvent& rEvt )
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinCont::KeyInput( rEvt );
}

//------------------------------------------------------------------------------
QueryTabWin* QueryTabWinContainer::FindTable(const String& rAliasName)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(rAliasName.Len(), "QueryTabWinContainer::FindTable : der AliasName sollte nicht leer sein !");
		// (nicht dass es schadet, aber es ist sinnlos und weist vielleicht auf Fehler beim Aufrufer hin)
	QueryTabWin* pEntry = (QueryTabWin*)GetTabWinMap()->Lookup(rAliasName);
	return pEntry;
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::FindTableFromField(const String& rFieldName, TabFieldDesc& rInfo, sal_uInt16& rCnt)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	sal_Bool bRet = sal_False;
	rCnt = 0;
	for(sal_uInt32 i=0;i<GetTabWinMap()->Count();i++)
	{
		if (((QueryTabWin*)GetTabWinMap()->GetObject(i))->ExistsField(rFieldName, rInfo))
			rCnt++;
	}

	return rCnt == 1;
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::RemoveTabWin(const String& strAliasName)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	QueryTabWin* pTabWin = FindTable(strAliasName);
	if (!pTabWin)
		return sal_False;

	RemoveTabWin(pTabWin);
	return sal_True;
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::RemoveTabWin(SbaJoinTabWin* pTabWin)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(pTabWin != NULL, "QueryTabWinContainer::RemoveTabWin : Fenster sollte ungleich NULL sein !");
	DBG_ASSERT(pTabWin->ISA(QueryTabWin), "QueryTabWinContainer::RemoveTabWin : Fenster sollte ein QueryTabWin sein !");

	// mein Parent brauche ich, da es vom Loeschen erfahren soll
	QueryDesignWin* pParent = (QueryDesignWin*)GetParent();

	SfxUndoManager* pUndoMgr = GetQueryDocShell()->GetUndoMgr();
	pUndoMgr->EnterListAction( String( SbaResId(STR_QUERY_UNDO_TABWINDELETE) ), String() );

	// Undo Actions und Loeschen der Felder in SelectionBrowseBox
	pParent->TableDeleted( ((QueryTabWinData*)pTabWin->GetData())->GetAliasName() );
	pParent->View()->SetModified(sal_True);

	// Undo-::com::sun::star::chaos::Action anlegen
	QueryTabWinDelUndoAct* pUndoAction = new QueryTabWinDelUndoAct(this);
	pUndoAction->SetTabWin((QueryTabWin*)pTabWin);

	// und Fenster verstecken
	HideTabWin((QueryTabWin*)pTabWin, pUndoAction);

	pUndoMgr->AddUndoAction( pUndoAction );
	pUndoMgr->LeaveListAction();

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	GetViewShell()->GetViewShell()->UIFeatureChanged();

	if (m_lnkTabWinsChangeHandler.IsSet())
	{
		TabWinsChangeNotification aHint(TabWinsChangeNotification::AT_REMOVED_WIN, ((QueryTabWin*)pTabWin)->GetAliasName());
		m_lnkTabWinsChangeHandler.Call(&aHint);
	}
}

//------------------------------------------------------------------------------
void QueryTabWinContainer::HideTabWins()
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SetUpdateMode(sal_False);

	SbaJoinTabWinMap* pTabWins = GetTabWinMap();
	if (pTabWins)
	{
		QueryTabWin* pEntry;// = (QueryTabWin*)pTabWins->First();

		while (pTabWins->Count())
		{
			pEntry = (QueryTabWin*)pTabWins->GetObject(0);
			RemoveTabWin(pEntry);
		}
	}


	QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
	pWin->SetModified();

	SetUpdateMode(sal_True);
	SFX_BINDINGS().Invalidate(SID_SBA_QRY_EXECUTE);
	SFX_BINDINGS().Invalidate(SID_SBA_CLEAR_QUERY);
}

//------------------------------------------------------------------------
void QueryTabWinContainer::EnsureVisible(const SbaJoinTabWin* pWin)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinCont::EnsureVisible(pWin);
	Invalidate(INVALIDATE_NOCHILDREN);
	return;
}

//------------------------------------------------------------------------
void QueryTabWinContainer::GetConnection(QueryTabConn* pConn)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	// bei mir und dem Dokument einfuegen
	GetTabConnList()->Insert(pConn);
	GetDocShell()->GetTabConnDataList()->Insert(pConn->GetData());

	// invalidieren (damit es neu gezeichnet wird)
	pConn->Invalidate();

	// modified-Flag
	QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
	pWin->SetModified();
}

//------------------------------------------------------------------------
void QueryTabWinContainer::DropConnection(QueryTabConn* pConn)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	// Selektion beachten
	DeselectConn(GetSelectedConn());

	// bei mir und dem Dokument rausnehmen
	GetTabConnList()->Remove(pConn);
	GetDocShell()->GetTabConnDataList()->Remove(pConn->GetData());

	// invalidieren (damit es neu gezeichnet wird)
	pConn->Invalidate();

	// modified-Flag
	QueryDesignWin* pWin = (QueryDesignWin*)GetParent();
	pWin->SetModified();
}

//------------------------------------------------------------------------
void QueryTabWinContainer::HideTabWin( QueryTabWin* pTabWin, QueryTabWinUndoAct* pUndoAction )
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabWinMap* pTabWins = GetTabWinMap();
	DBG_ASSERT(pTabWins != NULL, "QueryTabWinContainer::HideTabWin : habe keine TabWins !");

	if (pTabWin)
	{
		// Fenster
		// die Position in seinen Daten speichern
		((QueryDesignWin*)GetParent())->SaveTabWinUIConfig(pTabWin);
			// (ich muss ueber das Parent gehen, da nur das die Position der Scrollbars kennt)
		// dann aus der Liste der TabWins raus und verstecken
		pTabWins->Remove(pTabWin);
		pTabWin->Hide();	// nicht zerstoeren, steht im Undo!!

		// die Daten zum TabWin muessen auch aus meiner Verantwortung entlassen werden
		GetDocShell()->GetTabWinDataList()->Remove(pTabWin->GetData());
			// NICHT loeschen, da ja das TabWin selber - das noch lebt - sie auch noch braucht
			// Entweder geht es irgendwann wieder in meine Verantwortung ueber, (ueber ShowTabWin), dann fuege ich
			// auch die Daten wieder ein, oder die Undo-::com::sun::star::chaos::Action, die im Augenblick die alleinige Verantwortung fuer das Fenster
			// und dessen Daten hat, wird zestoert, dann loescht es beides

		if (m_pLastFocusTabWin == pTabWin)
			m_pLastFocusTabWin = NULL;

		// Verbindungen, die zum Fenster gehoeren, einsammeln und der UndoAction uebergeben
		sal_uInt16 nCnt = 0;
		QueryTabConn* pConnEntry = (QueryTabConn*)GetTabConnList()->First();

		while (pConnEntry)
		{
			QueryTabConn* pTmpEntry = pConnEntry;
			pConnEntry = (QueryTabConn*)GetTabConnList()->Next();

			if( pTmpEntry->GetAliasName(JTCS_FROM) == pTabWin->GetAliasName() ||
				pTmpEntry->GetAliasName(JTCS_TO) == pTabWin->GetAliasName() )
			{
				pUndoAction->InsertConnection(pTmpEntry);
				// die Connection invalidieren (ich kann nicht unten einfach ein InvalidateConnections machen, da ja dann die Connection
				// in meiner Liste nicht mehr existiert !)
				pTmpEntry->Invalidate();

				// die Daten aus dem Doc entfernen (Kommentar wie oben bei den Tabellendaten)
				GetDocShell()->GetTabConnDataList()->Remove(pTmpEntry->GetData());

				// die Connection selber weg und weiter
				GetTabConnList()->Remove(pTmpEntry);
				nCnt++;
			}
		}

		if (nCnt)
			InvalidateConnections();

		SFX_DISPATCHER().GetBindings()->Invalidate(SID_SBA_QRY_ADDTABLE);

		// der UndoAction sagen, dass das Fenster (inklusive der Connections) jetzt in seinem Besitzt ist
		pUndoAction->SetOwnership(sal_True);

		// damit habe ich das Doc natuerlich modifiziert
		GetQueryDocShell()->SetModified( sal_True );
		SFX_BINDINGS().Invalidate( SID_SAVEDOC );
		SFX_BINDINGS().Invalidate(SID_SBA_CLEAR_QUERY);
	}
}

//------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::ShowTabWin( QueryTabWin* pTabWin, QueryTabWinUndoAct* pUndoAction )
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);

	sal_Bool bSuccess = sal_False;

	if (pTabWin)
	{
		if (pTabWin->Init())
		{
			DBG_ASSERT(GetQueryDocShell()->ISA(SbaQueryDocSh), "QueryTabWinContainer::ShowTabWin : Shell ist keine SbaQueryDocSh !");
			SbaJoinTabWinData* pData = pTabWin->GetData();
			DBG_ASSERT(pData != NULL, "QueryTabWinContainer::ShowTabWin : TabWin hat keine Daten !");
			// Wenn die Daten schon PosSize haben, diese benutzen
			if (pData->HasPosition() && pData->HasSize())
				pTabWin->SetPosSizePixel(pData->GetPosition(), pData->GetSize());
			else
				// ansonsten selber eine Default-Position ermitteln
				SetDefaultTabWinPosSize(pTabWin);

			// Fenster zeigen und in Liste eintragen
			GetTabWinMap()->InsertAt(((QueryTabWinData*)pData)->GetAliasName(),pTabWin);
			pTabWin->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
			pTabWin->Show();

			pTabWin->Update();
				// Das Update ist notwendig, damit die Connections an dem Fenster richtig gezeichnet werden. Klingt absurd,
				// ich weiss. Aber die Listbox haelt sich intern ein Member, was bei ersten Zeichnen (nachdem die Listbox im Init
				// gerade neu gefuellt wurde) initialisiert wird, und genau dieses Member wird irgendwann benoetigt fuer
				// GetEntryPos, und dieses wiederum von der Connection, wenn sie ihren Ansatzpunkt am Fenster feststellen will.

			// die Connections
			sal_uInt16 nCount(0);
			while (pUndoAction->ConnCount())
			{
				SbaJoinTabConn* pCurrent = pUndoAction->FirstConn();
				// aus der Undo-::com::sun::star::chaos::Action raus
				pUndoAction->RemoveConnection(pCurrent);
				// und in meine Liste rein
				GetTabConnList()->Insert(pCurrent);

				// die Daten wieder in das Doc einfuegen
				GetDocShell()->GetTabConnDataList()->Insert(pCurrent->GetData(), LIST_APPEND);
				++nCount;
			}

			if (nCount)
				InvalidateConnections();

			// und die Daten des Fensters ebenfalls in Liste (des Docs)
			GetDocShell()->GetTabWinDataList()->Insert(pTabWin->GetData(), LIST_APPEND);

			SFX_DISPATCHER().GetBindings()->Invalidate(SID_SBA_QRY_ADDTABLE);

			// und der UndoAction sagen, dass das Fenster jetzt meine ist ...
			pUndoAction->SetOwnership(sal_False);

			bSuccess = sal_True;
		}
		else
			//////////////////////////////////////////////////////////////////
			// Initialisierung fehlgeschlagen
			// (z.B. wenn Verbindung zur Datenbank in diesem Augenblick unterbrochen worden ist)
			delete pTabWin;
	}

	// damit habe ich das Doc natuerlich modifiziert
	if(GetQueryDocShell()->IsEnableSetModified())
		GetQueryDocShell()->SetModified( sal_True );
	SFX_BINDINGS().Invalidate( SID_SAVEDOC );
	SFX_BINDINGS().Invalidate(SID_SBA_CLEAR_QUERY);

	return bSuccess;
}


//------------------------------------------------------------------------
void QueryTabWinContainer::InsertField(const TabFieldDesc& rInfo)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	DBG_ASSERT(GetParent() != NULL, "QueryTabWinContainer::InsertField : habe kein Parent !");
	((QueryDesignWin*)GetParent())->InsertField(rInfo);
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::Drop(const DropEvent& rEvt)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaDatabaseRef xDatabase(GetDatabase());
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = xDatabase->GetMetaData();
	::com::sun::star::uno::Any aJoin = rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::OUTER_JOIN_SUPPORT);

	if (!xDatabase.Is() || !((::utl::getINT16(aJoin) & ::com::sun::star::data::DatabaseOuterJoinSupport::PARTIAL) || (::utl::getINT16(aJoin) & ::com::sun::star::data::DatabaseOuterJoinSupport::YES)) && GetTabWinMap()->Count())
	{
		Sound::Beep();
		return sal_False;
	}

	sal_Bool bDrop = sal_False;

	for (sal_uInt16 i = 0; i < DragServer::GetItemCount(); ++i)
	{
		if (INetBookmark::DragServerHasFormat(i) )
		{
			INetBookmark aBmk;
			if (aBmk.PasteDragServer(i))
			{
				INetURLObject aObj(aBmk.GetURL());
				aObj.SetSmartProtocol(INET_PROT_FILE);
				String aMark(aObj.GetMark());

				if (aMark.GetTokenCount(';') > 1)
				{
					String sType = aMark.GetToken(0, ';');
					sType += ';';
					if (sType == String::CreateFromAscii(SDB_TABLEMARK_HEADER))
					{
						aMark.Erase(0, strlen(SDB_TABLEMARK_HEADER));

						String aDatabaseName = aObj.PathToFileName();
						DirEntry aDBEntry(aDatabaseName);

						if (aDBEntry == DirEntry(xDatabase->Name()))
						{
							SbaDBDefRef aDef = xDatabase->OpenDBDef(dbTable, aMark);
							if (aDef.Is())
							{
								if (aDef->Status().IsError())
									SBA_MOD()->ShowDbStatus(aDef->Status(), dbReadError,NULL);

								SdbTable* pTable = ((SbaTableDef*)&aDef)->GetTable();
								if (pTable && pTable->IsOpen())
								{
									AddTabWin(pTable->QualifierName(),pTable->GetFullName());
									bDrop = sal_True;
								}
							}
						}
					}
				}

				if (!bDrop)
					Sound::Beep();
				break;
			}
		}
	}
	return bDrop;
}

//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::QueryDrop(DropEvent& rEvt)
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaDatabaseRef xDatabase(GetDatabase());

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = xDatabase->GetMetaData();
	::com::sun::star::uno::Any aJoin = rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::OUTER_JOIN_SUPPORT);
	if (!xDatabase.Is() || !((::utl::getINT16(aJoin) & ::com::sun::star::data::DatabaseOuterJoinSupport::PARTIAL) || (::utl::getINT16(aJoin) & ::com::sun::star::data::DatabaseOuterJoinSupport::YES)) && GetTabWinMap()->Count())
		return sal_False;

	sal_Bool bDrop = sal_False;
	DropAction eAction = rEvt.GetAction();

	for (sal_uInt16 i = 0; i < DragServer::GetItemCount(); ++i)
	{
		if (INetBookmark::DragServerHasFormat(i))
		{
			INetBookmark aBmk;
			if (aBmk.PasteDragServer(i))
			{	// it's a INetBookmark
				INetURLObject aObj(aBmk.GetURL());
				aObj.SetSmartProtocol(INET_PROT_FILE);
				String aMark(aObj.GetMark());

				// maybe it's a reference to a db object
				if (aMark.GetTokenCount(';') > 1)
				{
					String sType = aMark.GetToken(0, ';');
					sType += ';';
					if (sType == String::CreateFromAscii(SDB_TABLEMARK_HEADER))
					{	// it's a reference to a table
						aMark.Erase(0, strlen(SDB_TABLEMARK_HEADER));

						String aDatabaseName = aObj.PathToFileName();
						DirEntry aDBEntry(aDatabaseName);

						if (aDBEntry == DirEntry(xDatabase->Name()))
						{	// it's a reference to a table of our own database
							if (xDatabase->HasObjectByURL(aObj.GetMainURL()))
							{
								rEvt.SetAction(DROP_COPY);
								bDrop = sal_True;
								break;
							}
						}
					}
				}
			}
		}
	}
	return bDrop;
}
//------------------------------------------------------------------------------
sal_Bool QueryTabWinContainer::ExistsAVisitedConn(const QueryTabWin* pFrom) const
{
	DBG_CHKTHIS(QueryTabWinContainer,NULL);
	SbaJoinTabConnList*  pList = ((QueryTabWinContainer*)this)->GetTabConnList();
	QueryTabConn*	pEntry = NULL;

	if (pList)
	{
		pEntry = (QueryTabConn*)pList->First();

		while (pEntry)
		{
			if (pEntry->IsVisited() &&
				(pFrom == (QueryTabWin*)pEntry->GetSourceWin() || pFrom == (QueryTabWin*)pEntry->GetDestWin()))
				break;

			pEntry = (QueryTabConn*)pList->Next();
		}
	}

	return (pEntry != NULL);
}




