/*************************************************************************
 *
 *  $RCSfile: relconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_OUTDEV_HXX //autogen
#include <vcl/outdev.hxx>
#endif

#ifndef _SV_POLY_HXX //autogen
#include <vcl/poly.hxx>
#endif

#ifndef _SDB_SDBCONN_HXX
#include <sdb/sdbconn.hxx>
#endif

#ifndef _SDB_SDBREL_HXX //autogen
#include <sdb/sdbrel.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef _SBA_RELCONN_HXX
#include "relconn.hxx"
#endif
#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif

using namespace ::com::sun::star::data;

TYPEINIT1(SbaRelTabConn, SbaJoinTabConn);
TYPEINIT1(SbaRelTabConnData, SbaJoinTabConnData);
DBG_NAME(SbaRelTabConnData);
DBG_NAME(SbaRelTabConn);
//========================================================================
// class SbaRelTabConnData
//========================================================================

//------------------------------------------------------------------------
SbaRelTabConnData::SbaRelTabConnData()
	:SbaJoinTabConnData()
	,nUpdateRules(DatabaseKeyRule::NO_ACTION)
	,nDeleteRules(DatabaseKeyRule::NO_ACTION)
	,nCardinality(CARDINAL_UNDEFINED)
	,xDatabase(NULL)
	,xSourceTableDef(NULL)
	,xDestTableDef(NULL)
{
	DBG_CTOR(SbaRelTabConnData,NULL);
}

//------------------------------------------------------------------------
SbaRelTabConnData::SbaRelTabConnData( const SbaDatabaseRef rDatabase )
	:SbaJoinTabConnData()
	,nUpdateRules(DatabaseKeyRule::NO_ACTION)
	,nDeleteRules(DatabaseKeyRule::NO_ACTION)
	,nCardinality(CARDINAL_UNDEFINED)
	,xDatabase(rDatabase)
	,xSourceTableDef(NULL)
	,xDestTableDef(NULL)
{
	DBG_CTOR(SbaRelTabConnData,NULL);
	aDatabaseName = xDatabase->GetQualifier();
}

//------------------------------------------------------------------------
SbaRelTabConnData::SbaRelTabConnData( const SbaDatabaseRef rDatabase, const String& rSourceWinName, const String& rDestWinName, const String& rConnName )
	:SbaJoinTabConnData( rSourceWinName, rDestWinName, rConnName )

	,nUpdateRules(DatabaseKeyRule::NO_ACTION)
	,nDeleteRules(DatabaseKeyRule::NO_ACTION)
	,nCardinality(CARDINAL_UNDEFINED)
	,xSourceTableDef(NULL)
	,xDestTableDef(NULL)
{
	DBG_CTOR(SbaRelTabConnData,NULL);
	SetCardinality();

	xDatabase = rDatabase;
	// DB-Zeiger initialisieren
	DBG_ASSERT(xDatabase.Is(),"SbaRelTabConnData pDatabase == NULL");
	if(!xDatabase.Is())
		return;
	aDatabaseName = xDatabase->GetQualifier();

	// und die TableDefs
	xSourceTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, GetSourceWinName(), FALSE);
	xDestTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, GetDestWinName(), FALSE);
}

//------------------------------------------------------------------------
SbaRelTabConnData::SbaRelTabConnData( const SbaRelTabConnData& rConnData )
	:SbaJoinTabConnData( rConnData )
{
	DBG_CTOR(SbaRelTabConnData,NULL);
	*this = rConnData;
}

//------------------------------------------------------------------------
SbaRelTabConnData::~SbaRelTabConnData()
{
	DBG_DTOR(SbaRelTabConnData,NULL);
}

//------------------------------------------------------------------------
BOOL SbaRelTabConnData::DropRelation()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	////////////////////////////////////////////////////////////
	// Relation loeschen
	SdbRelationRef xRelation;
	if( GetConnName().Len() && xDatabase->HasObject(dbRelation, GetConnName()) )
	{
		xRelation = (SdbRelation*)xDatabase->OpenObject( dbRelation, GetConnName() );
		if (xRelation.Is())
			if (!xRelation->Drop())
			{
				SBA_MOD()->ShowDbStatus(xRelation->Status(),dbDeleteError);
				return FALSE;
			}
	}
	return TRUE;
}

//------------------------------------------------------------------------
void SbaRelTabConnData::ChangeOrientation()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	//////////////////////////////////////////////////////////////////////
	// Source- und DestFieldName der Linien austauschen
	SbaJoinConnLineData* pConnLineData = GetConnLineDataList()->First();
	String aTempString;

	while( pConnLineData )
	{
		aTempString = pConnLineData->GetSourceFieldName();
		pConnLineData->SetSourceFieldName( pConnLineData->GetDestFieldName() );
		pConnLineData->SetDestFieldName( aTempString );
		pConnLineData = GetConnLineDataList()->Next();
	}

	//////////////////////////////////////////////////////////////////////
	// Member anpassen
	SbaTableDefRef xTempDef;

	aTempString = aSourceWinName;
	aSourceWinName = aDestWinName;
	aDestWinName = aTempString;

	xTempDef = xSourceTableDef;
	xSourceTableDef = xDestTableDef;
	xDestTableDef = xTempDef;
}

//------------------------------------------------------------------------
void SbaRelTabConnData::SetSourceWinName( const String& rSourceWinName )
{
	SbaJoinTabConnData::SetSourceWinName(rSourceWinName);
	xSourceTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, rSourceWinName);
}

//------------------------------------------------------------------------
void SbaRelTabConnData::SetDestWinName( const String& rDestWinName )
{
	SbaJoinTabConnData::SetDestWinName(rDestWinName);
	xDestTableDef = (SbaTableDef*)xDatabase->OpenDBDef(dbTable, rDestWinName);
}

//------------------------------------------------------------------------
void SbaRelTabConnData::SetCardinality()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	nCardinality = CARDINAL_UNDEFINED;

	if( IsSourcePrimKey() )
	{
		if( IsDestPrimKey() )
			nCardinality = CARDINAL_ONE_ONE;
		else
			nCardinality = CARDINAL_ONE_MANY;
	}

	if( IsDestPrimKey() )
	{
		if( !IsSourcePrimKey() )
			nCardinality = CARDINAL_MANY_ONE;
	}

}

//------------------------------------------------------------------------
BOOL SbaRelTabConnData::IsSourcePrimKey()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	//////////////////////////////////////////////////////////////////////
	// Sind die SourceFelder der Linien ein Primary Key?
	if( !xSourceTableDef.Is() )
		return FALSE;
	const SbaColumnList& rSourceColumnList = xSourceTableDef->GetOriginalColumns();
	SbaColumn* pColumn;
	SbaJoinConnLineData* pConnLineData = GetConnLineDataList()->First();
	String aFieldName;
	USHORT nPrimKeysCount = 0;
	USHORT nValidLinesCount = 0;
	while( pConnLineData )
	{
		if( pConnLineData->IsValid() )
			nValidLinesCount++;
		aFieldName = pConnLineData->GetSourceFieldName();
		pColumn = rSourceColumnList.Lookup( aFieldName, String() );
		if( pColumn )
		{
			SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
			if( pPrimary->GetValue() )
				nPrimKeysCount++;
		}

		pConnLineData = GetConnLineDataList()->Next();
	}
	if( !nPrimKeysCount )
		return FALSE;
	if( nPrimKeysCount != nValidLinesCount )
		return FALSE;

	// jetzt noch testen, ob in der Relation wirklich _alle_ PK-Felder der Quelle involviert sind
	USHORT nSourcePKColumns = 0;
	for (int i=0; i<rSourceColumnList.Count(); ++i)
	{
		pColumn = rSourceColumnList.GetObject(i);
		if (pColumn)
		{
			SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
			if (pPrimary->GetValue())
				++nSourcePKColumns;
		}
	}
	if (nPrimKeysCount != nSourcePKColumns)
		return FALSE;

	return TRUE;
}

//------------------------------------------------------------------------
BOOL SbaRelTabConnData::IsDestPrimKey()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	//////////////////////////////////////////////////////////////////////
	// Sind die DestFelder der Linien ein Primary Key?
	if( !xDestTableDef.Is() )
		return FALSE;
	const SbaColumnList& rDestColumnList = xDestTableDef->GetOriginalColumns();
	SbaColumn* pColumn;
	SbaJoinConnLineData* pConnLineData = GetConnLineDataList()->First();
	String aFieldName;
	USHORT nPrimKeysCount = 0;
	USHORT nValidLinesCount = 0;
	while( pConnLineData )
	{
		if( pConnLineData->IsValid() )
			nValidLinesCount++;
		aFieldName = pConnLineData->GetDestFieldName();
		pColumn = rDestColumnList.Lookup( aFieldName, String() );
		if( pColumn )
		{
			SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
			if( pPrimary->GetValue() )
				nPrimKeysCount++;
		}

		pConnLineData = GetConnLineDataList()->Next();
	}
	if( !nPrimKeysCount )
		return FALSE;
	if( nPrimKeysCount != nValidLinesCount )
		return FALSE;

	// jetzt noch testen, ob in der Relation wirklich _alle_ PK-Felder des Ziels involviert sind
	USHORT nDestPKColumns = 0;
	for (int i=0; i<rDestColumnList.Count(); ++i)
	{
		pColumn = rDestColumnList.GetObject(i);
		if (pColumn)
		{
			SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
			if (pPrimary->GetValue())
				++nDestPKColumns;
		}
	}
	if (nPrimKeysCount != nDestPKColumns)
		return FALSE;

	return TRUE;
}

//------------------------------------------------------------------------
BOOL SbaRelTabConnData::IsConnectionPossible()
{
	DBG_CHKTHIS(SbaRelTabConnData,NULL);
	if( !xSourceTableDef.Is() || !xDestTableDef.Is() )
		return FALSE;

	if( !aSourceWinName.Len() || !aDestWinName.Len() )
		return FALSE;

	//////////////////////////////////////////////////////////////////////
	// Wenn die SourceFelder ein PrimKey sind, ist nur die Orientierung falsch
	if( IsSourcePrimKey() )
		ChangeOrientation();

	return TRUE;
}

//------------------------------------------------------------------------
SbaJoinConnLineData* SbaRelTabConnData::CreateLineDataObj()
{
	return new SbaJoinConnLineData();
}

//------------------------------------------------------------------------
SbaJoinConnLineData* SbaRelTabConnData::CreateLineDataObj( const SbaJoinConnLineData& rConnLineData )
{
	return new SbaJoinConnLineData( rConnLineData );
}

//------------------------------------------------------------------------
void SbaRelTabConnData::CopyFrom(const SbaJoinTabConnData& rSource)
{
	DBG_ASSERT(rSource.ISA(SbaRelTabConnData), "SbaRelTabConnData::CopyFrom : ungueltiger Parameter !");
	// wie in der Basisklasse zurueckziehen auf das (nicht-virtuelle) operator=
	*this = (const SbaRelTabConnData&)rSource;
}

//------------------------------------------------------------------------
SbaRelTabConnData& SbaRelTabConnData::operator=( const SbaRelTabConnData& rConnData )
{
	if (&rConnData == this)
		return *this;

	SbaJoinTabConnData::operator=( rConnData );
	nUpdateRules = rConnData.GetUpdateRules();
	nDeleteRules = rConnData.GetDeleteRules();
	nCardinality = rConnData.GetCardinality();

	aDatabaseName = rConnData.GetDatabaseName();

	xDatabase = rConnData.GetDatabase();
	xSourceTableDef = rConnData.GetSourceTableDef();
	xDestTableDef = rConnData.GetDestTableDef();

	return *this;
}

//------------------------------------------------------------------------
BOOL SbaRelTabConnData::Update()
{
	////////////////////////////////////////////////////////////
	// Alte Relation loeschen
	SdbRelationRef xRelation;
	if( aConnName.Len() && xDatabase->HasObject(dbRelation, aConnName) )
	{
		xRelation = (SdbRelation*)xDatabase->OpenObject( dbRelation, aConnName );
		if( xRelation.Is() )
			xRelation->Drop();
	}

	if( !IsConnectionPossible() )
		return FALSE;

	////////////////////////////////////////////////////////////
	// Neue Relation erzeugen
	xRelation = (SdbRelation*)xDatabase->CreateObject( dbRelation, String() );
	if( !xRelation.Is() )
		return FALSE;
	xRelation->SetTableName( aSourceWinName );
	xRelation->SetForeignTableName( aDestWinName );
	SdbColumnsRef xRelCols = xRelation->GetColumns();

	////////////////////////////////////////////////////////////
	// Felder in neue Relation einsetzen
	USHORT nCreatedCols = 0;
	SdbColumnRelation* pRelCol = NULL;
	const SdbColumn* pColumn;
	const SdbColumn* pInsertCol = NULL;
	SdbColumnsRef xSourceCols = xSourceTableDef->GetTable()->OriginalColumns();
	SbaJoinConnLineData* pConnLineData = GetConnLineDataList()->First();
	BOOL bCase = (xDatabase->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
	while( pConnLineData )
	{
		////////////////////////////////////////////////////////////
		// Column in den SourceCols suchen
		pInsertCol = NULL;
		for( USHORT i=0; i<xSourceCols->Count(); i++ )
		{
			pColumn = xSourceCols->Column(i);
			if (bCase ? pColumn->GetName() == pConnLineData->GetSourceFieldName() : pColumn->GetName().EqualsIgnoreCaseAscii(pConnLineData->GetSourceFieldName()))
			{
				pInsertCol = pColumn;
				break;
			}
		}

		////////////////////////////////////////////////////////////
		// Neue RelationCol einfuegen
		if( pInsertCol )
		{
			if( pConnLineData->GetDestFieldName().Len() )
			{
				pRelCol = xRelation->CreateColumn( *pColumn, pConnLineData->GetDestFieldName() );
				xRelCols->AddColumn( pRelCol );
				nCreatedCols++;
			}
		}

		pConnLineData = GetConnLineDataList()->Next();
	}

	////////////////////////////////////////////////////////////
	// Wenn keine neuen Felder erzeugt wurden, return FALSE
	if( nCreatedCols == 0 )
		return FALSE;

	////////////////////////////////////////////////////////////
	// Attribute setzen
	xRelation->SetUpdateRules( GetUpdateRules() );
	xRelation->SetDeleteRules( GetDeleteRules() );

	////////////////////////////////////////////////////////////
	// Relation updaten
	if( !xRelation->Update() )
	{
		SdbStatus aStatus(xRelation->Status());
		SBA_MOD()->ShowDbStatus( aStatus,dbWriteError );
		return FALSE;
	}
	aConnName = xRelation->GetName();

	// The fields the relation marks may not be the same as our LineDatas mark after the relation has been updated
	GetConnLineDataList()->Clear();
	for (USHORT i=1; i<xRelation->GetColumns()->Count(); ++i)
	{
		SdbColumnRelation* pCur = PTR_CAST(SdbColumnRelation, xRelation->GetColumns()->Column(i));
		if (pCur)
		{
			SbaJoinConnLineData* pNewData = CreateLineDataObj();
			pNewData->SetSourceFieldName(pCur->GetName());
			pNewData->SetDestFieldName(pCur->GetForeignName());
			GetConnLineDataList()->Insert(pNewData);
		}
	}
	// NOTE : the caller is resposible for updating any other objects referencing the old LineDatas (for instance a ConnLine)

	////////////////////////////////////////////////////////////
	// Kardinalitaet bestimmen
	SetCardinality();

	return TRUE;
}


//========================================================================
// class SbaRelTabConn
//========================================================================

//------------------------------------------------------------------------
SbaRelTabConn::SbaRelTabConn( SbaRelTabWinCont* pContainer, SbaRelTabConnData* pTabConnData )
	:SbaJoinTabConn( pContainer, pTabConnData )
{
	DBG_CTOR(SbaRelTabConn,NULL);
}

//------------------------------------------------------------------------
SbaRelTabConn::SbaRelTabConn( const SbaRelTabConn& rConn )
	: SbaJoinTabConn( rConn )
{
	DBG_CTOR(SbaRelTabConn,NULL);
	// keine eigenen Members, also reicht die Basisklassenfunktionalitaet
}

//------------------------------------------------------------------------
SbaRelTabConn::~SbaRelTabConn()
{
	DBG_DTOR(SbaRelTabConn,NULL);
}

//------------------------------------------------------------------------
SbaJoinConnLine* SbaRelTabConn::CreateConnLine( const SbaJoinConnLine& rConnLine )
{
	DBG_CHKTHIS(SbaRelTabConn,NULL);
	return new SbaJoinConnLine( rConnLine );
}

//------------------------------------------------------------------------
SbaRelTabConn& SbaRelTabConn::operator=( const SbaRelTabConn& rConn )
{
	DBG_CHKTHIS(SbaRelTabConn,NULL);
	// nicht dass es was aendern wuerde, da die Basisklasse das auch testet und ich keine eigenen Members zu kopieren habe
	if (&rConn == this)
		return *this;

	SbaJoinTabConn::operator=( rConn );
	return *this;
}


//------------------------------------------------------------------------
void SbaRelTabConn::Draw( const Rectangle& rRect )
{
	DBG_CHKTHIS(SbaRelTabConn,NULL);
	SbaJoinTabConn::Draw( rRect );
	SbaRelTabConnData* pData;

	if ((pData = (SbaRelTabConnData*) GetData()) &&
				(pData->GetCardinality() == CARDINAL_UNDEFINED) )
		return;

	//////////////////////////////////////////////////////////////////////
	// Linien nach oberster Linie durchsuchen
	Rectangle aBoundingRect;
	long nTop = GetBoundingRect().Bottom();
	long nTemp;

	SbaJoinConnLine* pConnLine = NULL;
	SbaJoinConnLine* pTopLine = NULL;
	SbaJoinConnLineList* pConnLineList = GetConnLineList();
	pConnLine = pConnLineList->First();
	while( pConnLine )
	{
		if( pConnLine->IsValid() )
		{
			aBoundingRect = pConnLine->GetBoundingRect();
			nTemp = aBoundingRect.Top();
			if( nTemp<nTop )
			{
				nTop = nTemp;
				pTopLine = pConnLine;
			}
		}

		pConnLine = pConnLineList->Next();
	}

	//////////////////////////////////////////////////////////////////////
	// Kardinalitaet antragen
	if( !pTopLine )
		return;

	Rectangle aSourcePos = pTopLine->GetSourceTextPos();
	Rectangle aDestPos = pTopLine->GetDestTextPos();

	String aSourceText;
	String aDestText;

	switch( ((SbaRelTabConnData*)GetData())->GetCardinality() )
	{
	case CARDINAL_ONE_MANY:
		aSourceText = '1';
		aDestText = 'n';
		break;

	case CARDINAL_MANY_ONE:
		aSourceText = 'n';
		aDestText = '1';
		break;

	case CARDINAL_ONE_ONE:
		aSourceText = '1';
		aDestText = '1';
		break;
	}

	if (IsSelected())
		GetParent()->SetTextColor(Application::GetSettings().GetStyleSettings().GetHighlightColor());
	else
		GetParent()->SetTextColor(Application::GetSettings().GetStyleSettings().GetWindowTextColor());


	GetParent()->DrawText( aSourcePos, aSourceText, TEXT_DRAW_CLIP | TEXT_DRAW_CENTER | TEXT_DRAW_BOTTOM);
	GetParent()->DrawText( aDestPos, aDestText, TEXT_DRAW_CLIP | TEXT_DRAW_CENTER | TEXT_DRAW_BOTTOM);
}




