/*************************************************************************
 *
 *  $RCSfile: reldlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TOOLS_RESMGR_HXX
#include <tools/resmgr.hxx>
#endif

#ifndef _SVX_TABWIN_HXX
#include "tabwin.hxx"
#endif
#ifndef SBA_RELDLG_HRC
#include "reldlg.hrc"
#endif
#ifndef _SBA_RELDLG_HXX
#include "reldlg.hxx"
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_DBTABOBJ_HXX
#include "dbtabobj.hxx"
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif

#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::data;


const USHORT SOURCE_COLUMN = 1;
const USHORT DEST_COLUMN = 2;

//========================================================================
// class SbaRelCtrl
//========================================================================
DBG_NAME(SbaRelCtrl);
//------------------------------------------------------------------------
SbaRelCtrl::SbaRelCtrl( SbaRelDlg* pParent )
	:DbBrowseBox( pParent, DBBF_NOROWPICTURE, WB_TABSTOP | WB_3DLOOK | WB_BORDER )
	,pListCell( NULL )
	,pConnData( NULL )
	,xSourceDef( NULL )
	,xDestDef( NULL )
	,m_nDeActivateEvent(0)
{
	DBG_CTOR(SbaRelCtrl,NULL);
}

//------------------------------------------------------------------------
SbaRelCtrl::~SbaRelCtrl()
{
	DBG_DTOR(SbaRelCtrl,NULL);
	if (m_nDeActivateEvent)
		Application::RemoveUserEvent(m_nDeActivateEvent);

	delete pListCell;
}

//------------------------------------------------------------------------
void SbaRelCtrl::Init(SbaRelTabConnData* _pConnData)
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);

	pConnData = _pConnData;
	xSourceDef = pConnData->GetSourceTableDef();
	xDestDef = pConnData->GetDestTableDef();

	BOOL bFirstCall = (ColCount() == 0);

	if (bFirstCall)
	{
		//////////////////////////////////////////////////////////////////////
		// Spalten einfuegen
		InsertDataColumn( 1, xSourceDef.Is() ? xSourceDef->Name() : String(), 100);
		InsertDataColumn( 2, xDestDef.Is() ? xDestDef->Name() : String(), 100);
			// wenn es die Defs noch nicht gibt, dann muessen sie noch mit SetSource-/-DestDef gesetzt werden !

		pListCell = new DbListBoxCtrl( &GetDataWindow() );

		//////////////////////////////////////////////////////////////////////
		// Browser Mode setzen
		BrowserMode nMode = BROWSER_COLUMNSELECTION |
			BROWSER_HLINESFULL | BROWSER_VLINESFULL |
			BROWSER_HIDECURSOR | BROWSER_HIDESELECT;

		SetMode(nMode);
	}
	else
		// not the first call
		RowRemoved(0, GetRowCount());

	RowInserted(0, pConnData->GetConnLineDataList()->Count(), TRUE);

}

//------------------------------------------------------------------------------
void SbaRelCtrl::Resize()
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	DbBrowseBox::Resize();
	long nOutputWidth = GetOutputSizePixel().Width()-20;
	SetColumnWidth(1, (long)(nOutputWidth*0.5));
	SetColumnWidth(2, (long)(nOutputWidth*0.5));
}

//------------------------------------------------------------------------------
long SbaRelCtrl::PreNotify(NotifyEvent& rNEvt)
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	if (rNEvt.GetType() == EVENT_LOSEFOCUS)
		if (!HasChildPathFocus())
		{
			if (m_nDeActivateEvent)
				Application::RemoveUserEvent(m_nDeActivateEvent);
			m_nDeActivateEvent = Application::PostUserEvent(LINK(this, SbaRelCtrl, AsynchDeactivate));
		}
	if (rNEvt.GetType() == EVENT_GETFOCUS)
	{
		if (m_nDeActivateEvent)
			Application::RemoveUserEvent(m_nDeActivateEvent);
		m_nDeActivateEvent = Application::PostUserEvent(LINK(this, SbaRelCtrl, AsynchActivate));
	}
	return DbBrowseBox::PreNotify(rNEvt);
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaRelCtrl, AsynchActivate, void*, EMPTYARG)
{
	m_nDeActivateEvent = 0;
	ActivateCell();
	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaRelCtrl, AsynchDeactivate, void*, EMPTYARG)
{
	m_nDeActivateEvent = 0;
	DeactivateCell();
	return 0L;
}

//------------------------------------------------------------------------------
BOOL SbaRelCtrl::IsTabAllowed(BOOL bForward) const
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	long nRow = GetCurRow();
	USHORT nCol = GetCurColumnId();

	if (bForward && (nCol == 2) && (nRow == GetRowCount() - 1))
		return FALSE;

	if (!bForward && (nCol == 1) && (nRow == 0))
		return FALSE;

	return DbBrowseBox::IsTabAllowed(bForward);
}

//------------------------------------------------------------------------------
BOOL SbaRelCtrl::SaveModified()
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	SbaJoinConnLineData* pConnLineData = pConnData->GetConnLineDataList()->GetObject( GetCurRow() );
	switch( GetCurColumnId() )
	{
	case SOURCE_COLUMN:
		pConnLineData->SetSourceFieldName( pListCell->GetSelectEntry() );
		break;

	case DEST_COLUMN:
		pConnLineData->SetDestFieldName( pListCell->GetSelectEntry() );
		break;
	}

	return TRUE;
}

//------------------------------------------------------------------------------
String SbaRelCtrl::GetCellText( long nRow, USHORT nColId )
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	SbaJoinConnLineData* pConnLineData = pConnData->GetConnLineDataList()->GetObject( nRow );

	if( !pConnLineData )
		return String();

	switch( nColId )
	{
	case SOURCE_COLUMN:
		return pConnLineData->GetSourceFieldName();
	case DEST_COLUMN:
		return pConnLineData->GetDestFieldName();
	}

	return String();
}

//------------------------------------------------------------------------------
void SbaRelCtrl::InitController( DbCellControllerRef& rController, long nRow, USHORT nColumnId )
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	String aText;

	switch (nColumnId)
	{
		case SOURCE_COLUMN:
			//////////////////////////////////////////////////////////////
			// Auffuellen der ComboBox
			pListCell->Clear();
			if( xSourceDef.Is() )
			{
				SdbTable* pTable = xSourceDef->GetTable();

				const SdbColumn* pColumn = NULL;
				const SdbColumnsRef xCols = pTable->OriginalColumns();
				String aFieldName;

				for( USHORT i=1; xCols.Is() && i<xCols->Count(); i++ )
				{
					pColumn = xCols->Column(i);
					aFieldName = pColumn->GetName();
					pListCell->InsertEntry( aFieldName );
				}
				pListCell->InsertEntry(String(), 0);
			}

			//////////////////////////////////////////////////////////////
			// Setzen des Edits
			aText = GetCellText( nRow, nColumnId );

			pListCell->SelectEntry(aText);

			pListCell->SetHelpId(HID_RELATIONDIALOG_LEFTFIELDCELL);
			pListCell->SetHelpText(String());
			break;
		case DEST_COLUMN:
			//////////////////////////////////////////////////////////////
			// Auffuellen der ComboBox
			pListCell->Clear();
			if( xDestDef.Is() )
			{
				SdbTable* pTable = xDestDef->GetTable();

				const SdbColumn* pColumn = NULL;
				const SdbColumnsRef xCols = pTable->OriginalColumns();
				String aFieldName;

				for( USHORT i=1; xCols.Is() && i<xCols->Count(); i++ )
				{
					pColumn = xCols->Column(i);
					aFieldName = pColumn->GetName();
					pListCell->InsertEntry( aFieldName );
				}
				pListCell->InsertEntry(String(), 0);
			}

			//////////////////////////////////////////////////////////////
			// Setzen des Edits
			aText = GetCellText( nRow, nColumnId );
			pListCell->SelectEntry(aText);
			pListCell->SetText( aText );

			pListCell->SetHelpId(HID_RELATIONDIALOG_RIGHTFIELDCELL);
			pListCell->SetHelpText(String());
			break;
	}
}

//------------------------------------------------------------------------------
DbCellController* SbaRelCtrl::GetController( long nRow, USHORT nColumnId )
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	return new DbListBoxCellController( pListCell );
}


//------------------------------------------------------------------------------
BOOL SbaRelCtrl::SeekRow( long nRow )
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	nDataPos = nRow;
	return TRUE;
}

//------------------------------------------------------------------------------
void SbaRelCtrl::PaintCell( OutputDevice& rDev, const Rectangle& rRect, USHORT nColumnId ) const
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	String aText = ((SbaRelCtrl*)this)->GetCellText( nDataPos, nColumnId );

	Point aPos( rRect.TopLeft() );
	Size aTextSize( GetDataWindow().GetTextHeight(),GetDataWindow().GetTextWidth( aText ));

	if( aPos.X() < rRect.Right() || aPos.X() + aTextSize.Width() > rRect.Right() ||
		aPos.Y() < rRect.Top() || aPos.Y() + aTextSize.Height() > rRect.Bottom() )
		rDev.SetClipRegion( rRect );

	rDev.DrawText( aPos, aText );

	if( rDev.IsClipRegion() )
		rDev.SetClipRegion();
}



//------------------------------------------------------------------------
void SbaRelCtrl::SetSourceDef(const SbaTableDefRef& xNewSource)
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	xSourceDef = xNewSource;
	// wenn ich hier gerade editiere, ausblenden
	BOOL bWasEditing = IsEditing();
	if (bWasEditing)
		DeactivateCell();

	// Spaltenname setzen
	SetColumnTitle(1, xSourceDef->Name());

	// beide (!) Spalten loeschen
	SbaJoinConnLineDataList* pLines = pConnData->GetConnLineDataList();
	SbaJoinConnLineData* pCurrentLine = pLines->First();
	while (pCurrentLine)
	{
		pCurrentLine->SetSourceFieldName(String());
		pCurrentLine->SetDestFieldName(String());
		pCurrentLine = pLines->Next();
	}
	// neu zeichnen
	Invalidate();

	if (bWasEditing)
	{
		GoToRow(0);
		ActivateCell();
	}
}

//------------------------------------------------------------------------
void SbaRelCtrl::SetDestDef(const SbaTableDefRef& xNewDest)
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	xDestDef = xNewDest;
	// wenn ich hier gerade editiere, ausblenden
	BOOL bWasEditing = IsEditing();
	if (bWasEditing)
		DeactivateCell();

	// Spaltenname setzen
	SetColumnTitle(2, xDestDef->Name());

	// beide (!) Spalten loeschen
	SbaJoinConnLineDataList* pLines = pConnData->GetConnLineDataList();
	SbaJoinConnLineData* pCurrentLine = pLines->First();
	while (pCurrentLine)
	{
		pCurrentLine->SetSourceFieldName(String());
		pCurrentLine->SetDestFieldName(String());
		pCurrentLine = pLines->Next();
	}
	// neu zeichnen
	Invalidate();

	if (bWasEditing)
	{
		GoToRow(0);
		ActivateCell();
	}
}

//------------------------------------------------------------------------
void SbaRelCtrl::CellModified()
{
	DBG_CHKTHIS(SbaRelCtrl,NULL);
	DbBrowseBox::CellModified();
	SaveModified();
	((SbaRelDlg*)GetParent())->NotifyCellChange();
}

//========================================================================
// class SbaRelDlg
//========================================================================

//------------------------------------------------------------------------
SbaRelDlg::SbaRelDlg( SbaJoinTabWinCont* pParent, SbaRelTabConnData* pConnectionData, BOOL bAllowTableSelect )
	: ModalDialog( pParent, SbaResId(DLG_REL_PROPERTIES) )
	,aGB_InvolvedTables(this, SbaResId(GB_INVOLVED_TABLES))
	,m_lmbLeftTable(this, SbaResId(LB_LEFT_TABLE))
	,m_lmbRightTable(this, SbaResId(LB_RIGHT_TABLE))

	,aGB_InvolvedFields(this, SbaResId(GB_INVOLVED_FIELDS))

	,aGB_CascUpd( this, SbaResId(GB_CASC_UPD) )
	,aRB_NoCascUpd( this, SbaResId(RB_NO_CASC_UPD) )
	,aRB_CascUpd( this, SbaResId(RB_CASC_UPD) )
	,aRB_CascUpdNull( this, SbaResId(RB_CASC_UPD_NULL) )
	,aRB_CascUpdDefault( this, SbaResId(RB_CASC_UPD_DEFAULT) )

	,aGB_CascDel( this, SbaResId(GB_CASC_DEL) )
	,aRB_NoCascDel( this, SbaResId(RB_NO_CASC_DEL) )
	,aRB_CascDel( this, SbaResId(RB_CASC_DEL) )
	,aRB_CascDelNull( this, SbaResId(RB_CASC_DEL_NULL) )
	,aRB_CascDelDefault( this, SbaResId(RB_CASC_DEL_DEFAULT) )
	,pOrigConnData( pConnectionData )

	,aPB_OK( this, ResId( PB_OK ) )
	,aPB_CANCEL( this, ResId( PB_CANCEL ) )
	,aPB_HELP( this, ResId( PB_HELP ) )
	,m_bTriedOneUpdate(FALSE)
{
	xDatabase = pParent->GetDatabase();

	//////////////////////////////////////////////////////////////////////
	// Connection kopieren
	pConnData = new SbaRelTabConnData( *pConnectionData );
	pRC_Tables = new SbaRelCtrl( this );
	pRC_Tables->SetHelpId(HID_RELDLG_KEYFIELDS);
	pRC_Tables->Init( );
	pRC_Tables->SetZOrder(&m_lmbRightTable, WINDOW_ZORDER_BEHIND);

	//////////////////////////////////////////////////////////////////////
	// BrowseBox positionieren
	Point aDlgPoint = LogicToPixel( Point(12,55), MAP_APPFONT );
	Size aDlgSize = LogicToPixel( Size(162,68), MAP_APPFONT );
	pRC_Tables->SetPosSizePixel( aDlgPoint, aDlgSize );
	pRC_Tables->Show();

	//////////////////////////////////////////////////////////////////////
	// Radio-Buttons enablen/disablen
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor > rMetaData = xDatabase->GetMetaData();

	// Update Rules
	sal_Int16 nAttributes;
	rMetaData->getInfo(DatabaseInfo::FOREIGN_KEY_UPDATE_RULE) >>= nAttributes;
	if( !(nAttributes & DatabaseKeyRule::NO_ACTION) ){
		aRB_NoCascUpd.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::CASCADE) ){
		aRB_CascUpd.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::SET_NULL) ){
		aRB_CascUpdNull.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::SET_DEFAULT) ){
		aRB_CascUpdDefault.Enable( FALSE );
	}

	// Delete Rules
	rMetaData->getInfo(DatabaseInfo::FOREIGN_KEY_DELETE_RULE) >>= nAttributes;
	if( !(nAttributes & DatabaseKeyRule::NO_ACTION) ){
		aRB_NoCascDel.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::CASCADE) ){
		aRB_CascDel.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::SET_NULL) ){
		aRB_CascDelNull.Enable( FALSE );
	}
	if( !(nAttributes & DatabaseKeyRule::SET_DEFAULT) ){
		aRB_CascDelDefault.Enable( FALSE );
	}


	Init(pConnData);


	aPB_OK.SetClickHdl( LINK(this, SbaRelDlg, OKClickHdl) );

	if (bAllowTableSelect)
	{
		SbaJoinTabWinMap*	pTabWins = pParent->GetTabWinMap();
		DBG_ASSERT(pTabWins->Count() >= 2, "SbaRelDlg::SbaRelDlg : brauche mindestens zwei TabWins !");
		SbaJoinTabWin* pInitialLeft = NULL;
		SbaJoinTabWin* pInitialRight = NULL;

		// die Namen aller TabWins einsammeln
		SbaJoinTabWin* pLoop;// = pTabWins->First();
		for(ULONG i=0;i< pTabWins->Count();i++)
		{
			pLoop = pTabWins->GetObject(i);
			m_lmbLeftTable.InsertEntry(pLoop->GetTableName());
			m_lmbRightTable.InsertEntry(pLoop->GetTableName());

			if (!pInitialLeft)
				pInitialLeft = pLoop;
			else if (!pInitialRight)
				pInitialRight = pLoop;
		}

		// links das erste, rechts das zweite selektieren
		m_lmbLeftTable.SelectEntryPos(0);
		m_lmbRightTable.SelectEntryPos(1);

		// die entsprechenden Defs an mein Controls
		pRC_Tables->SetSourceDef(pInitialLeft->GetTableDef());
		pRC_Tables->SetDestDef(pInitialRight->GetTableDef());

		// die in einer ComboBox ausgewaehlte Tabelle darf nicht in der anderen zur Verfuegung stehen
		m_strCurrentLeft = pInitialLeft->GetTableName();
		m_strCurrentRight = pInitialRight->GetTableName();
		if (pTabWins->Count() > 2)
		{
			m_lmbLeftTable.RemoveEntry(m_strCurrentRight);
			m_lmbRightTable.RemoveEntry(m_strCurrentLeft);
		}

		m_lmbLeftTable.SetSelectHdl(LINK(this, SbaRelDlg, OnTableChanged));
		m_lmbRightTable.SetSelectHdl(LINK(this, SbaRelDlg, OnTableChanged));

		m_lmbLeftTable.GrabFocus();
	}
	else
	{
		m_lmbLeftTable.InsertEntry(pConnectionData->GetSourceWinName());
		m_lmbLeftTable.SelectEntryPos(0);
		m_lmbLeftTable.Disable();

		m_lmbRightTable.InsertEntry(pConnectionData->GetDestWinName());
		m_lmbRightTable.SelectEntryPos(0);
		m_lmbRightTable.Disable();
	}

	NotifyCellChange();

	FreeResource();
}

//------------------------------------------------------------------------
void SbaRelDlg::Init(SbaRelTabConnData* _pConnData)
{
	// Update Rules
	switch (_pConnData->GetUpdateRules())
	{
	case DatabaseKeyRule::NO_ACTION:
		aRB_NoCascUpd.Check( TRUE );
		break;

	case DatabaseKeyRule::CASCADE:
		aRB_CascUpd.Check( TRUE );
		break;

	case DatabaseKeyRule::SET_NULL:
		aRB_CascUpdNull.Check( TRUE );
		break;
	case DatabaseKeyRule::SET_DEFAULT:
		aRB_CascUpdDefault.Check( TRUE );
		break;
	}

	// Delete Rules
	switch (_pConnData->GetDeleteRules())
	{
	case DatabaseKeyRule::NO_ACTION:
		aRB_NoCascDel.Check( TRUE );
		break;

	case DatabaseKeyRule::CASCADE:
		aRB_CascDel.Check( TRUE );
		break;

	case DatabaseKeyRule::SET_NULL:
		aRB_CascDelNull.Check( TRUE );
		break;
	case DatabaseKeyRule::SET_DEFAULT:
		aRB_CascDelDefault.Check( TRUE );
		break;
	}


	pRC_Tables->Init( _pConnData );
}

//------------------------------------------------------------------------
SbaRelDlg::~SbaRelDlg()
{
	delete pConnData;
	delete pRC_Tables;
}

//------------------------------------------------------------------------
void SbaRelDlg::NotifyCellChange()
{
	// den Ok-Button en- oder disablen, je nachdem, ob ich eine gueltige Situation habe
	BOOL bValid = TRUE;
	USHORT nEmptyRows = 0;
	SbaJoinConnLineDataList* pLines = pConnData->GetConnLineDataList();
	SbaJoinConnLineData* pLoop = pLines->First();
	while (pLoop)
	{
		if ((pLoop->GetDestFieldName().Len() != 0) != (pLoop->GetSourceFieldName().Len() != 0))
			bValid = FALSE;
			// wenn nich beide leer oder beide voll sind -> ungueltig
		if ((pLoop->GetDestFieldName().Len() == 0) && (pLoop->GetSourceFieldName().Len() == 0))
			++nEmptyRows;
		pLoop = pLines->Next();
	}
	aPB_OK.Enable(bValid && (nEmptyRows != pLines->Count()));
		// nur leere Zeilen -> ungueltig

	if (nEmptyRows == 0)
	{
		pConnData->AppendConnLine(String(), String());
		pRC_Tables->DeactivateCell();
		pRC_Tables->RowInserted(pRC_Tables->GetRowCount(), 1, TRUE);
		pRC_Tables->ActivateCell();
	}
}

//------------------------------------------------------------------------
IMPL_LINK( SbaRelDlg, OKClickHdl, Button*, pButton )
{
	//////////////////////////////////////////////////////////////////////
	// RadioButtons auslesen
	UINT16 nAttrib = 0;

	// Delete Rules
	if( aRB_NoCascDel.IsChecked() )
		nAttrib |= DatabaseKeyRule::NO_ACTION;
	if( aRB_CascDel.IsChecked() )
		nAttrib |= DatabaseKeyRule::CASCADE;
	if( aRB_CascDelNull.IsChecked() )
		nAttrib |= DatabaseKeyRule::SET_NULL;
	if( aRB_CascDelDefault.IsChecked() )
		nAttrib |= DatabaseKeyRule::SET_DEFAULT;

	pConnData->SetDeleteRules( nAttrib );


	// Update Rules
	nAttrib = 0;
	if( aRB_NoCascUpd.IsChecked() )
		nAttrib |= DatabaseKeyRule::NO_ACTION;
	if( aRB_CascUpd.IsChecked() )
		nAttrib |= DatabaseKeyRule::CASCADE;
	if( aRB_CascUpdNull.IsChecked() )
		nAttrib |= DatabaseKeyRule::SET_NULL;
	if( aRB_CascUpdDefault.IsChecked() )
		nAttrib |= DatabaseKeyRule::SET_DEFAULT;
	pConnData->SetUpdateRules( nAttrib );

	pRC_Tables->SaveModified();

	// wenn die ComboBoxen fuer die Tabellenauswahl enabled sind (Constructor mit bAllowTableSelect==TRUE), dann muss ich in die
	// Connection auch die Tabellennamen stecken
	pConnData->SetSourceWinName(m_lmbLeftTable.GetSelectEntry());
	pConnData->SetDestWinName(m_lmbRightTable.GetSelectEntry());

	// noch ein wenig Normalisierung auf den LineDatas : leere Lines vom Anfang an das Ende verschieben
	SbaJoinConnLineDataList* pLines = pConnData->GetConnLineDataList();
	SbaJoinConnLineData* pFirst = pLines->First();
	while (!pFirst->GetSourceFieldName().Len() && !pFirst->GetDestFieldName().Len())
	{
		pFirst = pLines->Remove((ULONG)0);
		pLines->Insert(pFirst, LIST_APPEND);
		pFirst = pLines->First();
	}

	// try to create the relation
	if (pConnData->Update())
	{
		*pOrigConnData = *pConnData;
		EndDialog( RET_OK );
		return 0L;
	}

	m_bTriedOneUpdate = TRUE;
	// this means that the original connection may be lost (if pConnData was not a newly created but an
	// existent conn to be modified), which we reflect by returning RET_NO (see ::Execute)

	// try again
	Init(pConnData);

	return 0;
}

//------------------------------------------------------------------------
IMPL_LINK( SbaRelDlg, OnTableChanged, ListBox*, pListBox )
{
	String strSelected(pListBox->GetSelectEntry());
	SbaJoinTabWinMap*	pTabWins = ((SbaJoinTabWinCont*)GetParent())->GetTabWinMap();

	// eine Sonderbehandlung : wenn es nur zwei Tabellen gibt, muss ich bei Wechsel in einer LB auch in der anderen umschalten
	if (pTabWins->Count() == 2)
	{
		ListBox* pOther;
		if (pListBox == &m_lmbLeftTable)
			pOther = &m_lmbRightTable;
		else
			pOther = &m_lmbLeftTable;
		pOther->SelectEntryPos(1 - pOther->GetSelectEntryPos());

		SbaJoinTabWin* pFirst = pTabWins->GetObject(0);
		SbaJoinTabWin* pSecond = pTabWins->GetObject(1);

		SbaTableDefRef xLeftTable, xRightTable;
		if (m_lmbLeftTable.GetSelectEntry() == pFirst->GetTableName())
		{
			xLeftTable = pFirst->GetTableDef();
			xRightTable = pSecond->GetTableDef();
		}
		else
		{
			xRightTable = pFirst->GetTableDef();
			xLeftTable = pSecond->GetTableDef();
		}
		pRC_Tables->SetSourceDef(xLeftTable);
		pRC_Tables->SetDestDef(xRightTable);
	}
	else
	{
		// zuerst brauche ich die TableDef zur Tabelle, dazu das TabWin
		SbaJoinTabWin* pLoop = pTabWins->Lookup(strSelected);
		DBG_ASSERT(pLoop != NULL, "SbaRelDlg::OnTableChanged : ungueltiger Eintrag in ListBox !");
			// da ich die ListBoxen selber mit eben diesen Tabellennamen, mit denen ich sie jetzt vergleiche, gefuellt habe,
			// MUSS ich strSelected finden
		if (pListBox == &m_lmbLeftTable)
		{
			pRC_Tables->SetSourceDef(pLoop->GetTableDef());

			// den vorher links selektierten Eintrag wieder rein rechts
			m_lmbRightTable.InsertEntry(m_strCurrentLeft);
			// und den jetzt selektierten raus
			m_lmbRightTable.RemoveEntry(strSelected);
			m_strCurrentLeft = strSelected;

			m_lmbLeftTable.GrabFocus();
		}
		else
		{
			pRC_Tables->SetDestDef(pLoop->GetTableDef());

			// den vorher rechts selektierten Eintrag wieder rein links
			m_lmbLeftTable.InsertEntry(m_strCurrentRight);
			// und den jetzt selektierten raus
			m_lmbLeftTable.RemoveEntry(strSelected);
			m_strCurrentRight = strSelected;
		}
	}

	pListBox->GrabFocus();

	NotifyCellChange();
	return 0;
}

//------------------------------------------------------------------------
short SbaRelDlg::Execute()
{
	short nResult = ModalDialog::Execute();
	if ((nResult != RET_OK) && m_bTriedOneUpdate)
		return RET_NO;

	return nResult;
}

