/*************************************************************************
 *
 *  $RCSfile: relds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/list.hxx>

#include "relds.hxx"
#include "relvs.hxx"
#include "sbaresid.hrc"
#include "sbasltid.hrc"
#include "sbares.hxx"
#include "sbaobj.hxx"
#include "sbaitems.hxx"
#include "relconn.hxx"
#include "relwin.hxx"

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SFX_OBJFAC_HXX
#include <sfx2/docfac.hxx>
#endif

#ifndef _SDB_SDBREL_HXX //autogen
#include <sdb/sdbrel.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#define SbaRelationsDocSh
#include "ofaslots.hxx"

//========================================================================
// class SbaRelationsDocSh
//========================================================================

TYPEINIT2( SbaRelationsDocSh, SfxObjectShell, SbaJoinDocShExt );

SFX_IMPL_SIMPLE_OBJECTFACTORY_LOD( SbaRelationsDocSh, Sba, SBA_MOD() );
SFX_IMPL_INTERFACE( SbaRelationsDocSh, SfxObjectShell, SbaResId(0) )
{
}
DBG_NAME(SbaRelationsDocSh);
//-------------------------------------------------------------------------
SbaRelationsDocSh::SbaRelationsDocSh( SfxObjectCreateMode eMode )
	:SfxObjectShell(eMode)
	,SbaJoinDocShExt((SfxObjectShell*)this)
	,bInPrepareClose(FALSE)
{
	InitMembers(NULL);
	SetPool( &SFX_APP()->GetPool() );
	DBG_CTOR(SbaRelationsDocSh,NULL);
}

//-------------------------------------------------------------------------
SbaRelationsDocSh::~SbaRelationsDocSh()
{
	DBG_DTOR(SbaRelationsDocSh,NULL);
}

//-------------------------------------------------------------------------
BOOL SbaRelationsDocSh::InitNew( SvStorage* )
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	return TRUE;
}

//-------------------------------------------------------------------------
SbaJoinTabWinData* SbaRelationsDocSh::CreateTabWinDataObj()
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	return new SbaRelTabWinData(GetJoinDocDatabase()->Name());
}

//-------------------------------------------------------------------------
BOOL SbaRelationsDocSh::LoadData()
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	// holen wir doch zuerst mal die UI-Informationen
	SvMemoryStream aMemStream( 0xFFFF, 0xFFFF );
	aMemStream.Seek( STREAM_SEEK_TO_BEGIN );
	if( GetJoinDocDatabase()->GetRelationLayout( aMemStream ) )
	{
		aMemStream.Seek( STREAM_SEEK_TO_BEGIN );
		LoadUI( aMemStream );
	}

	// Relationen aus der Datenbank holen
	USHORT nRelCount = GetJoinDocDatabase()->GetObjectCount( dbRelation );
	String aDatabaseName(GetJoinDocDatabase()->GetQualifier());//Name();

	SdbRelationRef xRelation;
	SbaJoinTabConnDataList* pTabConnDataList = GetTabConnDataList();
	SbaJoinTabWinDataList* pTabWinList = GetTabWinDataList();
	SbaRelTabConnData* pTabConnData;

	for( USHORT i=0; i<nRelCount; i++ )
	{
		xRelation = (SdbRelation*)GetJoinDocDatabase()->OpenObject( dbRelation, i );
		if(!xRelation.Is())
			continue;
		String aSourceTableName( xRelation->GetTableName() );
		String aDestTableName( xRelation->GetForeignTableName() );
		String aConnName( xRelation->GetName() );


		// Fenster einfuegen
		if( !CountWindows(aSourceTableName) )
			pTabWinDataList->Insert( new SbaRelTabWinData(aDatabaseName, aSourceTableName), LIST_APPEND );

		if( !CountWindows(aDestTableName) )
			pTabWinDataList->Insert( new SbaRelTabWinData(aDatabaseName, aDestTableName), LIST_APPEND );

		//////////////////////////////////////////////////////////////////////
		// Connection einfuegen
		pTabConnData = new SbaRelTabConnData( GetJoinDocDatabase(), aSourceTableName, aDestTableName, aConnName );
		pTabConnDataList->Insert( pTabConnData, LIST_APPEND );

		//////////////////////////////////////////////////////////////////////
		// ConnectionLines einfuegen
		SdbColumnsRef xRelCols = xRelation->GetColumns();
		SdbColumnRelation* pRelCol;
		for( USHORT j=1; j<xRelCols->Count(); j++ )
		{
			pRelCol = (SdbColumnRelation*)xRelCols->Column(j);
			pTabConnData->SetConnLine( j-1, pRelCol->GetName(), pRelCol->GetForeignName() );
		}

		//////////////////////////////////////////////////////////////////////
		// Update/Del-Flags setzen
		pTabConnData->SetUpdateRules( xRelation->GetUpdateRules() );
		pTabConnData->SetDeleteRules( xRelation->GetDeleteRules() );

		//////////////////////////////////////////////////////////////////////
		// Kardinalitaet setzen
		pTabConnData->SetCardinality();
	}

	return TRUE;
}

//-------------------------------------------------------------------------
BOOL SbaRelationsDocSh::SaveData()
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	// Speichern der UI-Informationen
	SvMemoryStream aMemStream( 65535, 65535 );
	aMemStream.Seek( STREAM_SEEK_TO_BEGIN );
	SaveUI( aMemStream );

	if (!GetJoinDocDatabase()->AlterRelationLayout(aMemStream))
		return FALSE;
	SbaJoinDocShExt::SaveData();
	return TRUE;
}

//-------------------------------------------------------------------------
BOOL SbaRelationsDocSh::ConvertFrom( SfxMedium& rMedium )
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	if( !SbaJoinDocShExt::ConvertFrom(rMedium) )
		return FALSE;

	//////////////////////////////////////////////////////////////////////
	// Titel der DocSh setzen
	DirEntry aDirEntry( GetJoinDocDatabase()->Name() );
	String aTitle = String( SbaResId(SBA_STR_REL_PREFIX_TITLE) );
	aTitle += ' ';
	aTitle += aDirEntry.GetBase();
	aTitle.AppendAscii(" [");
	aTitle += String( SbaResId(SBA_STR_REL_EXT_TITLE) );
	aTitle += ']';
	SetTitle( aTitle );

	rMedium.GetItemSet()->Put(SfxStringItem(SID_DOCINFO_TITLE, aTitle));

	FinishedLoading( SFX_LOADED_ALL );
	return TRUE;
}

//-------------------------------------------------------------------------
USHORT SbaRelationsDocSh::PrepareClose( BOOL bUI, BOOL bForBrowsing )
{
	DBG_CHKTHIS(SbaRelationsDocSh,NULL);
	// gegen Rekursion absichern ...
	if (bInPrepareClose)
		return TRUE;
	bInPrepareClose = TRUE;

	// die Basisklasse fragen (nuetzlich, da SfxObjectShell alle meine Vies fragt)
	if (!SfxObjectShell::PrepareClose(FALSE))
		// das FALSE heisst keine Dialoge
	{
		bInPrepareClose = FALSE;
		return FALSE;
	}

	USHORT nReturn = (USHORT)TRUE;
	if( bUI && IsModified() )
	{
		// ------------------------------------------------------------------------------
		// den folgenden Teil habe ich aus SfxObjectShell::PrepareClose geklaut
		// (der sorgt im Wesentlichen dafuer, dass der Frame, in dem meine aktuelle
		// View lebt, nach vorn kommt - so habe ich das jedenfalls verstanden)

		// nur fuer in sichtbaren Fenstern dargestellte Dokumente fragen
		SfxViewFrame *pFrame = SfxObjectShell::Current() == this
			? SfxViewFrame::Current() : SfxViewFrame::GetFirst( this );
		while ( pFrame && (pFrame->GetFrameType() & SFXFRAME_SERVER ) )
			pFrame = SfxViewFrame::GetNext( *pFrame, this );

		if ( pFrame )
		{
//			if ( Application::GetAppWindow()->IsActive() )
				pFrame->GetFrame()->Appear();

		}
		// ... bis hierher jedenfalls
		// ------------------------------------------------------------------------------

		// und hier die eigentliche Frage
		SbaExtQueryBox aQry( NULL, SbaResId(RID_QRY_REL_SAVEMODIFIED), String() );
		if (bForBrowsing)
			aQry.AddButton(ResId(RID_STR_NEW_TASK), RET_NEWTASK,
				BUTTONDIALOG_DEFBUTTON | BUTTONDIALOG_FOCUSBUTTON);
		switch( aQry.Execute() )
		{
			case RET_YES:
				nReturn = (USHORT)SaveData();
				break;

			case RET_CANCEL:
				nReturn = (USHORT)FALSE;
				break;
			case RET_NEWTASK:
				nReturn = RET_NEWTASK;
				break;
		}
	}

	bInPrepareClose = FALSE;
	return nReturn;
}





