/*************************************************************************
 *
 *  $RCSfile: relvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _SBA_RELVS_HXX
#include "relvs.hxx"
#endif
#ifndef _SBA_RELDS_HXX
#include "relds.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_RELWINCT_HXX
#include "relwinct.hxx"
#endif

#ifndef _SFXEVENT_HXX //autogen
#include <sfx2/event.hxx>
#endif

#ifndef _SFX_HRC
#include <sfx2/sfx.hrc>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#define SbaRelationsViewSh
#include "ofaslots.hxx"

//==================================================================
// class SbaRelationsViewSh
//==================================================================
TYPEINIT2( SbaRelationsViewSh, SfxViewShell, SbaJoinViewShExt )

SFX_IMPL_INTERFACE( SbaRelationsViewSh, SfxViewShell, SbaResId((USHORT)0) )
{
	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT | SFX_VISIBILITY_STANDARD|SFX_VISIBILITY_READONLYDOC, SbaResId(RID_REL_TOOLBOX) );
	SFX_FEATURED_CHILDWINDOW_REGISTRATION(SID_SBA_JOIN_ADDTABLE, 1);
}

SFX_IMPL_VIEWFACTORY( SbaRelationsViewSh, SbaResId(0) )
{
	SFX_VIEW_REGISTRATION( SbaRelationsDocSh );
}
DBG_NAME(SbaRelationsViewSh);
//------------------------------------------------------------------------------
SbaRelationsViewSh::SbaRelationsViewSh( SfxViewFrame *pFrame )
	:SfxViewShell(pFrame)
	,SbaJoinViewShExt((SfxViewShell*)this)
{
	DBG_CTOR(SbaRelationsViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaRelationsViewSh::SbaRelationsViewSh( SfxViewFrame* pFrame, const SbaRelationsViewSh& rView )
	:SfxViewShell(pFrame)
	,SbaJoinViewShExt((SfxViewShell*)this)
{
	DBG_CTOR(SbaRelationsViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaRelationsViewSh::SbaRelationsViewSh( SfxViewFrame* pFrame, SfxViewShell* pView )
	:SfxViewShell(pFrame)
	,SbaJoinViewShExt((SfxViewShell*)this)
{
	DBG_CTOR(SbaRelationsViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
void SbaRelationsViewSh::Construct( SfxViewFrame *pFrame )
{
	DBG_CHKTHIS(SbaRelationsViewSh,NULL);
	SetHelpId(ID_SBA_RELATIONSVIEWSH);
	SetName( String::CreateFromAscii("SbaRelationsView") );

	pDocSh = (SbaRelationsDocSh*)pFrame->GetObjectShell();
	pJoinFrameWindow = new SbaRelFrameWindow( &pFrame->GetWindow(), this );
	SetWindow( pJoinFrameWindow );
}

//------------------------------------------------------------------------------
SbaRelationsViewSh::~SbaRelationsViewSh()
{
	DBG_DTOR(SbaRelationsViewSh,NULL);
	pJoinFrameWindow->Hide();
	delete pJoinFrameWindow;
}

//------------------------------------------------------------------------
BOOL SbaRelationsViewSh::HasUIFeature( ULONG nFeature )
{
	if ((nFeature & 1) == 1)
		return TRUE;

	return SfxViewShell::HasUIFeature(nFeature);
}
//------------------------------------------------------------------------------
void SbaRelationsViewSh::Activate( BOOL bMDI )
{
	SfxViewShell::Activate( bMDI );
	Invalidate();
}

//------------------------------------------------------------------------------
void SbaRelationsViewSh::Execute( SfxRequest& rReq )
{
	DBG_CHKTHIS(SbaRelationsViewSh,NULL);
	UINT16 nSlot = rReq.GetSlot();
	switch (nSlot)
	{
	case SID_SAVEDOC:
		rReq.SetReturnValue( SfxBoolItem(nSlot, GetDocShell()->SaveData()) );
		break;
	case SID_SBA_JOINSH_ADDTBLDLG:
	case SID_SBA_JOIN_ADDTABLE:
		SbaJoinViewShExt::Execute( rReq );
		break;
	case SID_SBA_ADD_RELATION:
		((SbaRelTabWinCont*)pJoinFrameWindow->GetTabWinCont())->AddNewRelation();
		break;
	}
}

//------------------------------------------------------------------------------
void SbaRelationsViewSh::GetState(SfxItemSet &rSet)
{
	DBG_CHKTHIS(SbaRelationsViewSh,NULL);
	SfxWhichIter    aIter(rSet);
	USHORT          nWhich = aIter.FirstWhich();

	while (nWhich)
	{
		switch( nWhich )
		{
			case SID_SBA_JOINSH_ADDTBLDLG:
			case SID_SBA_JOIN_ADDTABLE:
				SbaJoinViewShExt::GetState( rSet );
				break;
			case SID_SAVEASDOC :
				rSet.DisableItem(nWhich);
				break;
			case SID_EDITDOC :
				rSet.DisableItem(nWhich);
				break;
			case SID_SAVEDOC:
				if( !GetDocShell()->GetObjectShell()->IsModified() )
					rSet.DisableItem(nWhich);
				break;
			case SID_SBA_ADD_RELATION:
				if (pJoinFrameWindow->GetTabWinCont()->GetTabWinMap()->Count() < 2)
					rSet.DisableItem(nWhich);
				break;
		}
		nWhich = aIter.NextWhich();
	}
}

