/*************************************************************************
 *
 *  $RCSfile: relwin.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_RELWIN_HXX
#include "relwin.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

#ifdef UNX
#define _cdecl
#define	_CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

const long TABWIN_SIZING_AREA = 4;
const long LISTBOX_SCROLLING_AREA = 6;
const ULONG SCROLLING_TIMESPAN = 500;

//==================================================================
// class SbaRelTabWinData
//==================================================================

DBG_NAME(SbaRelTabWinData);
//------------------------------------------------------------------------------
SbaRelTabWinData::SbaRelTabWinData( const String& strDatabaseName )
	:SbaJoinTabWinData()
{
	DBG_CTOR(SbaRelTabWinData,NULL);
	m_strDatabaseName = strDatabaseName;
	bShowAll = FALSE;
}

//------------------------------------------------------------------------------
SbaRelTabWinData::SbaRelTabWinData( const String& strDatabaseName, const String& rTableName, const String& rWinName )
	:SbaJoinTabWinData( strDatabaseName, rTableName, rWinName )
{
	DBG_CTOR(SbaRelTabWinData,NULL);
	bShowAll = FALSE;
}

//------------------------------------------------------------------------------
SbaRelTabWinData::~SbaRelTabWinData()
{
	DBG_DTOR(SbaRelTabWinData,NULL);
}


//========================================================================
// class SbaRelTabWin
//========================================================================
DBG_NAME(SbaRelTabWin);
//------------------------------------------------------------------------------
SbaRelTabWin::SbaRelTabWin( Window* pParent, SbaRelTabWinData* pTabWinData )
	:SbaJoinTabWin( pParent, pTabWinData )
{
	DBG_CTOR(SbaRelTabWin,NULL);
	SetHelpId(HID_CTL_RELATIONTAB);
}

//------------------------------------------------------------------------------
SbaRelTabWin::~SbaRelTabWin()
{
	DBG_DTOR(SbaRelTabWin,NULL);
}

//------------------------------------------------------------------------------
void SbaRelTabWin::KeyInput( const KeyEvent& rEvt )
{
	SbaJoinTabWin::KeyInput( rEvt );
}




