/*************************************************************************
 *
 *  $RCSfile: relwinct.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SBA_TWCONT_HXX
#include "twcont.hxx"
#endif
#ifndef _SBA_JOINDS_HXX
#include "joinds.hxx"
#endif
#ifndef _SBA_RELWINCT_HXX
#include "relwinct.hxx"
#endif
#ifndef _SBA_RELDLG_HXX
#include "reldlg.hxx"
#endif
#ifndef _SBA_RELWIN_HXX
#include "relwin.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_JOINVS_HXX
#include "joinvs.hxx"
#endif

#ifndef _SFXVIEWSH_HXX //autogen wg. SfxViewShell
#include <sfx2/viewsh.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _SBAITEMS_HXX //autogen
#include <sbaitems.hxx>
#endif

#define _SVSTDARR_STRINGSSORTDTOR
#include <svtools/svstdarr.hxx>

#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef __JOINEXCH_HXX_
#include "joinexch.hxx"
#endif // __JOINEXCH_HXX_

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _SBA_EXTBOX_HXX
#include "extbox.hxx"
#endif
//==================================================================
// SbaRelFrameWindow
//==================================================================

//------------------------------------------------------------------------------
SbaRelFrameWindow::SbaRelFrameWindow( Window* pParent, SbaJoinViewShExt* pView )
	:SbaJoinFrameWindow( pParent, pView )
{
	pTabWinCont = new SbaRelTabWinCont( this, pView );
	pTabWinCont->Show();
}

//------------------------------------------------------------------------------
SbaRelFrameWindow::~SbaRelFrameWindow()
{
}


//==================================================================
// class SbaRelTabWinCont
//==================================================================
DBG_NAME(SbaRelTabWinCont);
//------------------------------------------------------------------------
SbaRelTabWinCont::SbaRelTabWinCont( Window* pParent, SbaJoinViewShExt* pView )
	: SbaJoinTabWinCont( pParent, pView )
{
	DBG_CTOR(SbaRelTabWinCont,NULL);
	SetHelpId(HID_CTL_RELATIONTAB);
	ReSync();
}

//------------------------------------------------------------------------
SbaRelTabWinCont::~SbaRelTabWinCont()
{
	DBG_DTOR(SbaRelTabWinCont,NULL);
	//////////////////////////////////////////////////////////////////////
	// Listen loeschen
	for(ULONG i=0;i<GetTabWinMap()->Count();i++)
		delete GetTabWinMap()->GetObject(i);
	GetTabWinMap()->Clear();

	SbaJoinTabConn* pJoinConn;
	while( pJoinConn = GetTabConnList()->Remove((ULONG)0) )
		delete pJoinConn;

}

//------------------------------------------------------------------------
void SbaRelTabWinCont::ReSync()
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	// Es kann sein, dass in der DB Tabellen ausgeblendet wurden, die eigentlich Bestandteil einer Relation sind. Oder eine Tabelle
	// befand sich im Layout (durchaus ohne Relation), existiert aber nicht mehr. In beiden Faellen wird das Anlegen des TabWins schief
	// gehen, und alle solchen TabWinDatas oder darauf bezogenen ConnDatas muss ich dann loeschen.
	SvStringsSortDtor arrInvalidTables;

	//////////////////////////////////////////////////////////////////////
	// Fenster einfuegen
	SbaJoinTabWinDataList* pTabWinDataList = GetDocShell()->GetTabWinDataList();
	ULONG nCount = pTabWinDataList->Count();
	for (ULONG i=nCount; i>0; --i)
	{
		SbaRelTabWinData* pTabWinData = (SbaRelTabWinData*)pTabWinDataList->GetObject(i-1);
		SbaRelTabWin* pTabWin = new SbaRelTabWin(this, pTabWinData);

		if (!pTabWin->Init())
		{
			// das Initialisieren ging schief, dass heisst, dieses TabWin steht nicht zur Verfuegung, also muss ich es inklusive
			// seiner Daten am Dokument aufraeumen
			delete pTabWin;
			arrInvalidTables.Insert(new String(pTabWinData->GetTableName()));

			pTabWinDataList->Remove(pTabWinData);
			delete pTabWinData;
			continue;
		}

		GetTabWinMap()->InsertAt(pTabWinData->GetTableName(),pTabWin);	// am Anfang einfuegen, da ich die DataList ja rueckwaerts durchlaufe
		// wenn in den Daten keine Position oder Groesse steht -> Default
		if (!pTabWinData->HasPosition() && !pTabWinData->HasSize())
			SetDefaultTabWinPosSize(pTabWin);

		pTabWin->Show();
	}

	// Verbindungen einfuegen
	SbaJoinTabConnDataList* pTabConnDataList = GetDocShell()->GetTabConnDataList();
	nCount = pTabConnDataList->Count();
	for (i=nCount; i>0; --i)
	{
		SbaRelTabConnData* pTabConnData = (SbaRelTabConnData*)pTabConnDataList->GetObject(i-1);

		// gibt es die beiden Tabellen zur Connection ?
		USHORT nPos;
		String strTabExistenceTest = pTabConnData->GetSourceWinName();
		BOOL bInvalid = arrInvalidTables.Seek_Entry(&strTabExistenceTest, &nPos);
		strTabExistenceTest = pTabConnData->GetDestWinName();
		bInvalid |= arrInvalidTables.Seek_Entry(&strTabExistenceTest, &nPos);

		if (bInvalid)
		{	// nein -> Pech gehabt, die Connection faellt weg
			pTabConnDataList->Remove(pTabConnData);
			delete pTabConnData;
			continue;
		}

		GetTabConnList()->Insert(new SbaRelTabConn(this, pTabConnData), ULONG(0));
	}
}
//------------------------------------------------------------------------------
BOOL SbaRelTabWinCont::IsAddAllowed()
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor > rMetaData = GetDatabase()->GetMetaData();

	return (rMetaData->isCapable(::com::sun::star::data::DatabaseCapability::INTEGRITY) || !GetTabWinCount());
}
//------------------------------------------------------------------------------
void SbaRelTabWinCont::AddTabWin( const String& strDatabase, const String& rWinName, BOOL bNewTable )
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	// zuerst mal testen, ob schon eine Tabelle mit diesem Namen in meinem Entwurf habe
	SbaJoinTabWin* pTabWinIterator = GetTabWinMap()->Lookup(rWinName);
	if (pTabWinIterator)
	{	// diese Tabelle gibt es schon -> alte Instanz nach oben bringen
		pTabWinIterator->SetZOrder(NULL, WINDOW_ZORDER_FIRST);
		pTabWinIterator->GrabFocus();
		EnsureVisible(pTabWinIterator);
		// und KEINE neue anlegen
		return;
	}

	String strDBName = strDatabase.Len() ? strDatabase : GetDatabase()->GetQualifier();
	//////////////////////////////////////////////////////////////////
	// Neue Datenstruktur in DocShell eintragen
	SbaRelTabWinData* pNewTabWinData = new SbaRelTabWinData( strDBName, rWinName );
	pNewTabWinData->ShowAll( FALSE );
	GetDocShell()->GetTabWinDataList()->Insert( pNewTabWinData, LIST_APPEND );

	//////////////////////////////////////////////////////////////////
	// Neues Fenster in Fensterliste eintragen
	SbaRelTabWin* pNewTabWin = new SbaRelTabWin( this, pNewTabWinData );
	pNewTabWin->Init();

	GetTabWinMap()->InsertAt(rWinName, pNewTabWin);
	if( !pNewTabWin->GetData()->HasPosition() && !pNewTabWin->GetData()->HasSize() )
		SetDefaultTabWinPosSize( pNewTabWin );
	pNewTabWin->Show();

	GetDocShell()->GetObjectShell()->SetModified(TRUE);

	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
	SFX_BINDINGS().Invalidate(SID_SBA_ADD_RELATION);
	SFX_BINDINGS().Invalidate(SID_SBA_JOIN_ADDTABLE);
	GetViewShell()->GetViewShell()->UIFeatureChanged();
}


//------------------------------------------------------------------------
void SbaRelTabWinCont::RemoveTabWin( SbaJoinTabWin* pTabWin )
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	SbaJoinTabWinCont::RemoveTabWin(pTabWin);

	SFX_BINDINGS().Invalidate(SID_SBA_ADD_RELATION);
	SFX_BINDINGS().Invalidate(SID_SBA_JOIN_ADDTABLE);
	GetViewShell()->GetViewShell()->UIFeatureChanged();
}

//------------------------------------------------------------------------
void SbaRelTabWinCont::AddConnection(const SbaJoinExchangeData& jxdSource, const SbaJoinExchangeData& jxdDest)
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	// Aus selektierten Feldnamen LineDataObject setzen
	// check if relation already exists
	SbaRelTabWin* pSourceWin = (SbaRelTabWin*)jxdSource.pListBox->GetTabWin();
	SbaRelTabWin* pDestWin = (SbaRelTabWin*)jxdDest.pListBox->GetTabWin();
	const SbaJoinTabConnList* pList = GetTabConnList();
	SbaJoinTabConn* pFirst = GetTabConnList()->First();
	while(pFirst)
	{
		if((pFirst->GetSourceWin() == pSourceWin && pFirst->GetDestWin() == pDestWin) ||
		   (pFirst->GetSourceWin() == pDestWin  && pFirst->GetDestWin() == pSourceWin))
		{
			if(SbaExtQueryBox(this, SbaResId(QUERY_REL_EDIT_RELATION),String()).Execute() == RET_YES)
				ConnDoubleClicked(pFirst);
			return;
		}
		pFirst = GetTabConnList()->Next();
	}
	// Datenobjekt in DocShell einfuegen
	SbaRelTabConnData* pTabConnData = new SbaRelTabConnData(GetDatabase(),
		jxdSource.pListBox->GetTabWin()->GetWinName(), jxdDest.pListBox->GetTabWin()->GetWinName());

	// die Namen der betroffenen Felder
	String aSourceFieldName = jxdSource.pListBox->GetEntryText(jxdSource.pEntry);
	String aDestFieldName = jxdDest.pListBox->GetEntryText(jxdDest.pEntry);

	// die Anzahl der PKey-Felder in der Quelle
	UINT16 nSourceKeys(0);
	const SbaColumnList& rColumns = pSourceWin->GetOriginalColumns();
	for(USHORT i=0; i<rColumns.Count(); ++i)
	{
		SbaColumn* pColumn = rColumns.GetObject(i);
		SFX_ITEMSET_GET(*pColumn, pPrimary, SfxBoolItem, SBA_DEF_FLTPRIMARY, TRUE);
		if (pPrimary->GetValue())
		{
			SFX_ITEMSET_GET(*pColumn, pName, SbaNameItem, SBA_DEF_FLTNAME, TRUE);
			pTabConnData->SetConnLine( nSourceKeys, pName->GetValue(), String() );

			nSourceKeys++;
		}
	}


	if(nSourceKeys>1)
	{
		SbaRelDlg aRelDlg( this, pTabConnData );
		if (aRelDlg.Execute() == RET_OK)
		{
			//////////////////////////////////////////////////////////////////
			// Koennen die neuen Daten eine neue Relation erzeugen?
//			if (pTabConnData->Update())
			// already updated by the dialog
			GetDocShell()->GetTabConnDataList()->Insert( pTabConnData, LIST_APPEND );
			SbaRelTabConn* pTabConn = new SbaRelTabConn( this, pTabConnData );
			GetTabConnList()->Insert( pTabConn, LIST_APPEND );
			Invalidate();
		}
		else
			delete pTabConnData;
	}
	else
	{
		pTabConnData->ResetConnLines();
		pTabConnData->SetConnLine( 0, aSourceFieldName, aDestFieldName );

		//////////////////////////////////////////////////////////////////////
		// Daten der Datenbank uebergeben
		if( pTabConnData->Update() )
		{
			//////////////////////////////////////////////////////////////////////
			// UI-Object in ConnListe eintragen
			GetDocShell()->GetTabConnDataList()->Insert( pTabConnData, LIST_APPEND );
			SbaRelTabConn* pTabConn = new SbaRelTabConn( this, pTabConnData );
			GetTabConnList()->Insert( pTabConn, LIST_APPEND );
			Invalidate();
		}
		else
			delete pTabConnData;
	}
}


//------------------------------------------------------------------------
void SbaRelTabWinCont::ConnDoubleClicked( SbaJoinTabConn* pConnection )
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	SbaRelTabConnData* pRelTabConnData = (SbaRelTabConnData*)((SbaRelTabConn*)pConnection)->GetData();
	SbaRelDlg aRelDlg( this, pRelTabConnData );
	switch (aRelDlg.Execute())
	{
		case RET_OK:
			// successfully updated
			pConnection->UpdateLineList();
			// The connection references 1 ConnData and n ConnLines, each ConnData references n LineDatas, each Line exactly 1 LineData
			// As the Dialog and the ConnData->Update may have changed the LineDatas we have to restore the consistent state
			break;

		case RET_NO:
			// tried at least one update, but did not succeed -> the original connection is lost
			RemoveConnection( pConnection );
			break;

		case RET_CANCEL:
			// no break, as nothing happened and we don't need the code below
			return;

	}

	Invalidate(INVALIDATE_NOCHILDREN);
}

//------------------------------------------------------------------------------
void SbaRelTabWinCont::AddNewRelation()
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	SbaRelTabConnData* pNewConnData = new SbaRelTabConnData(GetDatabase());
	SbaRelDlg aRelDlg(this, pNewConnData, TRUE);

	BOOL bSuccess = (aRelDlg.Execute() == RET_OK);
	if (bSuccess)
	{
//		bSuccess = pNewConnData->Update();
		// already updated by the dialog
		// dem Dokument bekanntgeben
		GetDocShell()->GetTabConnDataList()->Insert(pNewConnData, LIST_APPEND);

		// das reale Connection-Objekt (bis jetzt haben wir nur die Datas)
		SbaRelTabConn* pTabConn = new SbaRelTabConn(this, pNewConnData);
		GetTabConnList()->Insert(pTabConn, LIST_APPEND);

		// neu zeichnen
		Invalidate(INVALIDATE_NOCHILDREN);
	}
	else
		delete pNewConnData;
}

//------------------------------------------------------------------------------
BOOL SbaRelTabWinCont::RemoveConnection( SbaJoinTabConn* pConn )
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	SbaRelTabConnData* pTabConnData = (SbaRelTabConnData*)pConn->GetData();
	BOOL bErg;
	if (bErg = pTabConnData->DropRelation())
		SbaJoinTabWinCont::RemoveConnection( pConn );
	return bErg;
}

//------------------------------------------------------------------------------
void SbaRelTabWinCont::KeyInput( const KeyEvent& rEvt )
{
	DBG_CHKTHIS(SbaRelTabWinCont,NULL);
	SbaJoinTabWinCont::KeyInput( rEvt );
}

