/*************************************************************************
 *
 *  $RCSfile: rptds.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/tools.hxx>
#include "sbaresid.hrc"
#include "sbasltid.hrc"

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#include "rptds.hxx"
#include "rptvs.hxx"
#include "sbares.hxx"
#include "sbaobj.hxx"

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif


#define SbaReportDocSh
#include "ofaslots.hxx"

#ifdef UNX
#define _cdecl
#define _CDECLARE_
#endif

#ifdef MAC
#define _cdecl
#endif

TYPEINIT1(SbaReportDocSh,SbaFileDefDocSh)
//=========================================================================

//-------------------------------------------------------------------------
SFX_IMPL_SIMPLE_OBJECTFACTORY_LOD(SbaReportDocSh, Sba, SBA_MOD());


//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaReportDocSh, SbaFileDefDocSh, SbaResId(0))
{
}

//-------------------------------------------------------------------------
SbaReportDocSh::SbaReportDocSh(SfxObjectCreateMode eMode)
	:SbaFileDefDocSh(eMode, String::CreateFromAscii("db-report")){
}

//-------------------------------------------------------------------------
BOOL SbaReportDocSh::ConvertFrom(SfxMedium& rMedium)
{
	BOOL bRes(SbaFileDefDocSh::ConvertFrom(rMedium));
	FinishedLoading( SFX_LOADED_ALL );
	return bRes;
}

//-------------------------------------------------------------------------
void SbaReportDocSh::GetState(SfxItemSet &rSet)
{
	SbaFileDefDocSh::GetState(rSet);
	SfxWhichIter aIter(rSet);
	for (USHORT nSID = aIter.FirstWhich(); nSID; nSID = aIter.NextWhich())
	{
		switch (nSID)
		{
			case SID_EDITDOC:
			{
				rSet.DisableItem(nSID);
				break;
			}
		}
	}
}

//------------------------------------------------------------------------------
void SbaReportDocSh::Execute(SfxRequest& rReq)
{
	SbaFileDefDocSh::Execute(rReq);
}
//------------------------------------------------------------------------------
BOOL SbaReportDocSh::InitNew( SvStorage* pSt)
{
	return SbaFileDefDocSh::InitNew(pSt);
}



