/*************************************************************************
 *
 *  $RCSfile: exsrcbrw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SBA_EXTCTRLR_HXX
#include "exsrcbrw.hxx"
#endif
#ifndef _SBA_API_HRC
#include "api.hrc"
#endif
#ifndef _COM_SUN_STAR_FORM_FORMCOMPONENTTYPE_HPP_
#include <com/sun/star/form/FormComponentType.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XGRIDCOLUMNFACTORY_HPP_
#include <com/sun/star/form/XGridColumnFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XFORMCONTROLLER_HPP_
#include <com/sun/star/form/XFormController.hpp>
#endif
#ifndef _SBA_FORMADAPTER_HXX
#include "formadapter.hxx"
#endif
#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

//==============================================================================
//= SbaExternalSourceBrowser
//==============================================================================

//------------------------------------------------------------------------------
//::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass >  SbaExternalSourceBrowser::getStaticIdlClass()
//{
//	static ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass >  xClass = createStandardClass(::rtl::OUString::createFromAscii("SbaExternalSourceBrowser"), SbaXDataBrowserController::getStaticIdlClass()
//		,3
//		,::getCppuType((const ::com::sun::star::util::XModifyBroadcaster*)0)
//		,::getCppuType((const ::com::sun::star::form::XLoadListener*)0)
//		,::getCppuType((const ::com::sun::star::form::XFormController*)0)
//	);
//	return xClass;
//}

//------------------------------------------------------------------------------
::com::sun::star::uno::Any	SAL_CALL SbaExternalSourceBrowser::queryInterface(const ::com::sun::star::uno::Type& _rType) throw (::com::sun::star::uno::RuntimeException)
{
	::com::sun::star::uno::Any	aRet = SbaXDataBrowserController::queryInterface(_rType);
	if(!aRet.hasValue())
	{
		aRet = ::cppu::queryInterface(_rType,
								(::com::sun::star::util::XModifyBroadcaster*)this,
								(::com::sun::star::form::XLoadListener*)this);
		if(!aRet.hasValue())
			aRet = m_xFormControllerImpl->queryAggregation(_rType);
	}

	return aRet;
}
//------------------------------------------------------------------------------
SbaExternalSourceBrowser::SbaExternalSourceBrowser(const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rM)
	:SbaXDataBrowserController(_rM)
	,m_pDataSourceImpl(NULL)
	,m_aModifyListeners(m_aPropertyMutex)
	,m_bInQueryDispatch(NULL)
{
	// create the aggregated object
	::utl::increment(m_refCount);
	{
		m_pFormControllerImpl = new FormControllerImpl(this);
		m_xFormControllerImpl = m_pFormControllerImpl;
		m_xFormControllerImpl->setDelegator(*this);
	}

	::utl::decrement(m_refCount);
}

//------------------------------------------------------------------------------
SbaExternalSourceBrowser::~SbaExternalSourceBrowser()
{
	// Freigeben der Aggregation
	if (m_xFormControllerImpl.is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >  xEmpty;
		m_xFormControllerImpl->setDelegator(xEmpty);
	}
}

//------------------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet >  SbaExternalSourceBrowser::CreateForm()
{
	m_pDataSourceImpl = new SbaXFormAdapter();
	return m_pDataSourceImpl;
}

//------------------------------------------------------------------------------
sal_Bool SbaExternalSourceBrowser::InitializeForm(const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > & xForm)
{
	return sal_True;
}

//------------------------------------------------------------------
sal_Bool SbaExternalSourceBrowser::InitializeGridModel(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XFormComponent > & xGrid)
{
	return sal_True;
}

//------------------------------------------------------------------
sal_Bool SbaExternalSourceBrowser::LoadForm()
{
	// as we don't have a main form (yet), we have nothing to do
	// we don't call FormLoaded, because this expects a working data source
	return sal_True;
}


//------------------------------------------------------------------
void SbaExternalSourceBrowser::modified(const ::com::sun::star::lang::EventObject& aEvent) throw( ::com::sun::star::uno::RuntimeException )
{
	SbaXDataBrowserController::modified(aEvent);

	// multiplex this event to all my listeners
	::com::sun::star::lang::EventObject aEvt(*this);
	::cppu::OInterfaceIteratorHelper aIt(m_aModifyListeners);
	while (aIt.hasMoreElements())
		((::com::sun::star::util::XModifyListener*)aIt.next())->modified(aEvt);
}

// -----------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::attachFrame(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame) throw( ::com::sun::star::uno::RuntimeException )
{
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener >  xAggListener;
	if (m_xFormControllerImpl.is())
		m_xFormControllerImpl->queryAggregation(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener>*)0)) >>= xAggListener;

	// log off my aggregated object
	if (m_xCurrentFrame.is() && xAggListener.is())
		m_xCurrentFrame->removeFrameActionListener(xAggListener);

	SbaXDataBrowserController::attachFrame(xFrame);

	// and log on to the new frame
	if (m_xCurrentFrame.is() && xAggListener.is())
		m_xCurrentFrame->addFrameActionListener(xAggListener);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::dispatch(const ::com::sun::star::util::URL& aURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>& aArgs)
{
	const ::com::sun::star::beans::PropertyValue* pArguments = aArgs.getConstArray();
	if (aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/AddGridColumn")))
	{
		// search the argument describing the column to create
		::rtl::OUString sControlType;
		sal_Int16 nControlPos = -1;
		::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue> aControlProps;
		for (sal_uInt16 i=0; i<aArgs.getLength(); ++i, ++pArguments)
		{
			if (pArguments->Name.equals(::rtl::OUString::createFromAscii("ColumnType")))
			{
				sal_Bool bCorrectType = pArguments->Value.getValueType().equals(::getCppuType((const ::rtl::OUString*)0));
				DBG_ASSERT(bCorrectType, "invalid type for argument \"ColumnType\" !");
				if (bCorrectType)
					sControlType = ::utl::getString(pArguments->Value);
			}
			else if (pArguments->Name.equals(::rtl::OUString::createFromAscii("ColumnPosition")))
			{
				sal_Bool bCorrectType = pArguments->Value.getValueType().equals(::getCppuType((const sal_Int16*)0));
				DBG_ASSERT(bCorrectType, "invalid type for argument \"ColumnPosition\" !");
				if (bCorrectType)
					nControlPos = ::utl::getINT16(pArguments->Value);
			}
			else if (pArguments->Name.equals(::rtl::OUString::createFromAscii("ColumnProperties")))
			{
				sal_Bool bCorrectType = pArguments->Value.getValueType().equals(::getCppuType((const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>*)0));
				DBG_ASSERT(bCorrectType, "invalid type for argument \"ColumnProperties\" !");
				if (bCorrectType)
					aControlProps = *(::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>*)pArguments->Value.getValue();
			}
			else
				DBG_ERROR(((ByteString("SbaExternalSourceBrowser::dispatch(AddGridColumn) : unknown argument (") += ByteString((const sal_Unicode*)pArguments->Name, gsl_getSystemTextEncoding()).GetBuffer()) += ") !").GetBuffer());
		}
		if (!sControlType.getLength())
		{
			DBG_ERROR("SbaExternalSourceBrowser::dispatch(AddGridColumn) : missing argument (::com::sun::star::sdbc::ColumnType) !");
			sControlType = ::rtl::OUString::createFromAscii("TextField");
		}
		DBG_ASSERT(aControlProps.getLength(), "SbaExternalSourceBrowser::dispatch(AddGridColumn) : missing argument (ColumnProperties) !");

		// create the col
		::com::sun::star::uno::Reference< ::com::sun::star::form::XGridColumnFactory >  xColFactory(getControlModel(), ::com::sun::star::uno::UNO_QUERY);
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xNewCol = xColFactory->createColumn(sControlType);
		// set it's properties
		const ::com::sun::star::beans::PropertyValue* pControlProps = aControlProps.getConstArray();
		for (i=0; i<aControlProps.getLength(); ++i, ++pControlProps)
		{
			try
			{
				xNewCol->setPropertyValue(pControlProps->Name, pControlProps->Value);
			}
			catch(...)
			{
				DBG_WARNING("SbaExternalSourceBrowser::dispatch : could not set a column property (maybe you forgot a READONLY attribute for a dispatch-argument ?) !");
			}
			;
		}

		// correct the position
		::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexContainer >  xColContainer(getControlModel(), ::com::sun::star::uno::UNO_QUERY);

		if (nControlPos > xColContainer->getCount())
			nControlPos = xColContainer->getCount();
		if (nControlPos < 0)
			nControlPos = 0;

		// append the column
		xColContainer->insertByIndex(nControlPos, ::com::sun::star::uno::makeAny(xNewCol));
	}
	else if (aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/ClearView")))
	{
		ClearView();
	}
	else if (aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/AttachToForm")))
	{
		if (!m_pDataSourceImpl)
			return;

		::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet >  xMasterForm;
		// search the arguments for he master form
		for (sal_uInt16 i=0; i<aArgs.getLength(); ++i, ++pArguments)
		{
			if ((pArguments->Name.equals(::rtl::OUString::createFromAscii("MasterForm"))) && (pArguments->Value.getValueTypeClass() == ::com::sun::star::uno::TypeClass_INTERFACE))
			{
				xMasterForm = ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > (*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)pArguments->Value.getValue(), ::com::sun::star::uno::UNO_QUERY);
				break;
			}
		}
		if (!xMasterForm.is())
		{
			DBG_ERROR("SbaExternalSourceBrowser::dispatch(FormSlots/AttachToForm) : please specify a form to attach to as argument !");
			return;
		}

		Attach(xMasterForm);
	}
	else
		SbaXDataBrowserController::dispatch(aURL, aArgs);
}

//------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  SAL_CALL SbaExternalSourceBrowser::queryDispatch(const ::com::sun::star::util::URL& aURL, const ::rtl::OUString& aTargetFrameName, sal_Int32 nSearchFlags) throw( ::com::sun::star::uno::RuntimeException )
{
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  xReturn;
	if (m_bInQueryDispatch)
		return xReturn;

	m_bInQueryDispatch = sal_True;

	if	(	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/AttachToForm")))
			// attach a new external form
		||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/AddGridColumn")))
			// add a column to the grid
		||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/ClearView")))
			// clear the grid
		)
		xReturn = (::com::sun::star::frame::XDispatch*)this;

	if	(	!xReturn.is()
		&&	(	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/moveToFirst")))
			||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/moveToPrev")))
			||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/moveToNext")))
			||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/moveToLast")))
			||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/moveToNew")))
			||	(aURL.Complete.equals(::rtl::OUString::createFromAscii(".uno:FormSlots/undoRecord")))
			)
		)
	{
		DBG_ASSERT(aURL.Mark.len() == 0, "SbaExternalSourceBrowser::queryDispatch : the ::com::sun::star::util::URL shouldn't have a mark !");
		::com::sun::star::util::URL aNewUrl = aURL;

		// split the ::com::sun::star::util::URL
		::com::sun::star::uno::Reference< ::com::sun::star::util::XURLTransformer >  xTransformer(::utl::getProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.frame.URLTransformer")), ::com::sun::star::uno::UNO_QUERY);
		if (xTransformer.is())
			xTransformer->parseStrict(aNewUrl);

		// set a new mark
		aNewUrl.Mark = ::rtl::OUString::createFromAscii("DB/FormGridView");
			// this controller is instantiated when somebody dispatches the ".component:DB/FormGridView" in any
			// frame, so we use "FormGridView" as mark that a dispatch request came from this view

		if (xTransformer.is())
			xTransformer->assemble(aNewUrl);

		::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  xFrameDispatcher(m_xCurrentFrame, ::com::sun::star::uno::UNO_QUERY);
		if (xFrameDispatcher.is())
			xReturn = xFrameDispatcher->queryDispatch(aNewUrl, aTargetFrameName, nSearchFlags);

#if SUPD<=548 && !PRIV_DEBUG
		xReturn = NULL;
		// in version 548 the dispatch interception and the task-local beamer will work ... me hopes
#endif
	}

	if (!xReturn.is())
		xReturn = SbaXDataBrowserController::queryDispatch(aURL, aTargetFrameName, nSearchFlags);

	m_bInQueryDispatch = sal_False;
	return xReturn;
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::dispose()
{
	// say our modify listeners goodbye
	::com::sun::star::lang::EventObject aEvt;
	aEvt.Source = (::com::sun::star::uno::XWeak*) this;
	m_aModifyListeners.disposeAndClear(aEvt);

	stopListening();

	if (m_xFormControllerImpl.is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >  xAggComp;
		m_xFormControllerImpl->queryAggregation(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent>*)0)) >>= xAggComp;
		if (xAggComp.is())
			xAggComp->dispose();
	}

	// our aggregated object doesn't handle its frame action listening itself, so we have to log it off
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener >  xAggListener;
	if (m_xFormControllerImpl.is())
	{
		m_xFormControllerImpl->queryAggregation( ::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener >*)0)) >>= xAggListener;
		m_xCurrentFrame->removeFrameActionListener(xAggListener);
	}

	SbaXDataBrowserController::dispose();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::addModifyListener(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XModifyListener > & aListener) throw( ::com::sun::star::uno::RuntimeException )
{
	m_aModifyListeners.addInterface(aListener);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::removeModifyListener(const ::com::sun::star::uno::Reference< ::com::sun::star::util::XModifyListener > & aListener) throw( ::com::sun::star::uno::RuntimeException )
{
	m_aModifyListeners.removeInterface(aListener);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::unloading(const ::com::sun::star::lang::EventObject& aEvent) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pDataSourceImpl && (m_pDataSourceImpl->getAttachedForm() == aEvent.Source))
	{
		ClearView();
	}

	SbaXDataBrowserController::unloading(aEvent);
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::Attach(const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > & xMaster)
{
	// switch the control to design mode
	if (getContent() && getContent()->getGridControl().is())
		getContent()->getGridControl()->setDesignMode(sal_True);

	// the grid will move the form's cursor to the first record, but we want the form to remain unchanged
	::com::sun::star::uno::Any aOldPos;
	::com::sun::star::uno::Reference< ::com::sun::star::sdbcx::XRowLocate >  xCursor(xMaster, ::com::sun::star::uno::UNO_QUERY);
	if (xCursor.is())
		aOldPos = xCursor->getBookmark();
	sal_Bool bWasInsertRow = sal_False;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xMasterProps(xMaster, ::com::sun::star::uno::UNO_QUERY);
	if (xMasterProps.is())
	{
		try { bWasInsertRow = ::utl::getBOOL(xMasterProps->getPropertyValue(PROPERTY_ISNEW)); }
		catch(...) { } ;
	}

	stopListening();
	m_pDataSourceImpl->AttachForm(xMaster);
	startListening();

	if (xMaster.is())
	{
		// assume that the master form is already loaded, we have no chance to check this
		m_bLoadCanceled = sal_False;
		FormLoaded(sal_True);

		::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XResultSetUpdate >  xUpdate(xMaster, ::com::sun::star::uno::UNO_QUERY);
		try
		{
			if (bWasInsertRow && xUpdate.is())
				xUpdate->moveToInsertRow();
			else if (xCursor.is() && aOldPos.hasValue())
				xCursor->moveToBookmark(aOldPos);
		}
		catch(...)
		{
			DBG_ERROR("SbaExternalSourceBrowser::Attach : couldn't restore the cursor position !");
		}
		
	}
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::ClearView()
{
	// set a new (empty) datasource
	Attach(::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > ());


	// clear all cols in the grid
	::com::sun::star::uno::Reference< ::com::sun::star::container::XIndexContainer >  xColContainer(getControlModel(), ::com::sun::star::uno::UNO_QUERY);
	while (xColContainer->getCount() > 0)
		xColContainer->removeByIndex(0);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::disposing(const ::com::sun::star::lang::EventObject& Source) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pDataSourceImpl && (m_pDataSourceImpl->getAttachedForm() == Source.Source))
	{
		ClearView();
	}

	if (m_xFormControllerImpl != Source.Source)
	{	// forward the event to my aggregate (if it isn't the source itself)
		::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener >  xAggListener;
		m_xFormControllerImpl->queryAggregation(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener >*)0)) >>= xAggListener;
		if (xAggListener.is())
			xAggListener->disposing(Source);
	}

	// the frame
	if (Source.Source == m_xCurrentFrame)
	{
		// our aggregated object doesn't handle its frame action listening itself, so we have to log it off
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener >  xAggListener;
		if (m_xFormControllerImpl.is())
		{
			m_xFormControllerImpl->queryAggregation(::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrameActionListener >*)0)) >>= xAggListener;
			m_xCurrentFrame->removeFrameActionListener(xAggListener);
		}
	}
}

//------------------------------------------------------------------
const ControllerFeature* SbaExternalSourceBrowser::GetSupportedFeatures() const
{
	// we are attaching to a foreign form, the owner of this form has to provide support for all UI-dispatches .....
	// we ourself do nothing
	static ControllerFeature* pReturn = new ControllerFeature();
	return pReturn;
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::addControlListeners(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > & _xGridControl)
{
	SbaXDataBrowserController::addControlListeners(_xGridControl);

	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWindow(_xGridControl, ::com::sun::star::uno::UNO_QUERY);
	if (xWindow.is())
		xWindow->addFocusListener(this);
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::removeControlListeners(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > & _xGridControl)
{
	SbaXDataBrowserController::removeControlListeners(_xGridControl);

	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWindow(_xGridControl, ::com::sun::star::uno::UNO_QUERY);
	if (xWindow.is())
		xWindow->removeFocusListener(this);
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::startListening()
{
	if (m_pDataSourceImpl && m_pDataSourceImpl->getAttachedForm().is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::form::XLoadable >  xLoadable(m_pDataSourceImpl->getAttachedForm(), ::com::sun::star::uno::UNO_QUERY);
		xLoadable->addLoadListener((::com::sun::star::form::XLoadListener*)this);
	}
}

//------------------------------------------------------------------
void SbaExternalSourceBrowser::stopListening()
{
	if (m_pDataSourceImpl && m_pDataSourceImpl->getAttachedForm().is())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::form::XLoadable >  xLoadable(m_pDataSourceImpl->getAttachedForm(), ::com::sun::star::uno::UNO_QUERY);
		xLoadable->removeLoadListener((::com::sun::star::form::XLoadListener*)this);
	}
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::focusGained(const ::com::sun::star::awt::FocusEvent& e) throw( ::com::sun::star::uno::RuntimeException )
{
	::com::sun::star::lang::EventObject aEvt(*this);
	::cppu::OInterfaceIteratorHelper aIter(m_pFormControllerImpl->m_aActivateListeners);
	while (aIter.hasMoreElements())
		((::com::sun::star::form::XFormControllerListener*)aIter.next())->formActivated(aEvt);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::focusLost(const ::com::sun::star::awt::FocusEvent& e) throw( ::com::sun::star::uno::RuntimeException )
{
	if (!getContent() || !getContent()->getGridControl().is())
		return;
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XVclWindowPeer >  xMyGridPeer(getContent()->getGridControl()->getPeer(), ::com::sun::star::uno::UNO_QUERY);
	if (!xMyGridPeer.is())
		return;
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindowPeer >  xNextControlPeer(e.NextFocus, ::com::sun::star::uno::UNO_QUERY);
	if (!xNextControlPeer.is())
		return;

	if (xMyGridPeer->isChild(xNextControlPeer))
		return;

	if (xMyGridPeer == xNextControlPeer)
		return;

	::com::sun::star::lang::EventObject aEvt(*this);
	::cppu::OInterfaceIteratorHelper aIter(m_pFormControllerImpl->m_aActivateListeners);
	while (aIter.hasMoreElements())
		((::com::sun::star::form::XFormControllerListener*)aIter.next())->formDeactivated(aEvt);

	// commit the changes of the grid control (as we're deactivated)
	::com::sun::star::uno::Reference< ::com::sun::star::form::XBoundComponent >  xCommitable(getContent()->getGridControl(), ::com::sun::star::uno::UNO_QUERY);
	if (xCommitable.is())
		xCommitable->commit();
	else
		DBG_ERROR("SbaExternalSourceBrowser::focusLost : why is my control not commitable ?");
}

//------------------------------------------------------------------
sal_uInt16 SbaExternalSourceBrowser::SaveData(sal_Bool bUI, sal_Bool bForBrowsing)
{
	if (m_bSuspending)
		// don't ask the user if we're beeing suspended currently
		// this is the responsibility of our owner, as we are only an external view to an existing form
		// 73384 - 22.02.00 - FS
		return (sal_uInt16)sal_True;

	return SbaXDataBrowserController::SaveData(bUI, bForBrowsing);
}

//==================================================================
//==================================================================

//------------------------------------------------------------------
SbaExternalSourceBrowser::FormControllerImpl::FormControllerImpl(SbaExternalSourceBrowser* m_pOwner)
	:m_pOwner(m_pOwner)
	,m_bActive(sal_False)
	,m_aActivateListeners(m_pOwner->m_aPropertyMutex)
{
	DBG_ASSERT(m_pOwner, "SbaExternalSourceBrowser::FormControllerImpl::FormControllerImpl : invalid Owner !");
}

//------------------------------------------------------------------
SbaExternalSourceBrowser::FormControllerImpl::~FormControllerImpl()
{
}

//------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl >  SbaExternalSourceBrowser::FormControllerImpl::getCurrentControl(void) throw( ::com::sun::star::uno::RuntimeException )
{
	return m_pOwner->getContent() ? m_pOwner->getContent()->getGridControl() : ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > ();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::addActivateListener(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XFormControllerListener > & l) throw( ::com::sun::star::uno::RuntimeException )
{
	m_aActivateListeners.addInterface(l);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::removeActivateListener(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XFormControllerListener > & l) throw( ::com::sun::star::uno::RuntimeException )
{
	m_aActivateListeners.removeInterface(l);
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::setModel(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTabControllerModel > & Model) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_ERROR("SbaExternalSourceBrowser::FormControllerImpl::setModel : invalid call, can't change my model !");
}

//------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::awt::XTabControllerModel >  SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::getModel(void) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("SbaExternalSourceBrowser::FormControllerImpl::getModel : don't (and won't) have a model !");
	if (m_pOwner->m_pDataSourceImpl)
		return ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTabControllerModel > ((::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > )*m_pOwner->m_pDataSourceImpl, ::com::sun::star::uno::UNO_QUERY);

	return ::com::sun::star::uno::Reference< ::com::sun::star::awt::XTabControllerModel > ();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::setContainer(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlContainer > & _Container) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_ERROR("SbaExternalSourceBrowser::FormControllerImpl::setContainer : invalid call, can't change my container !");
}

//------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlContainer >  SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::getContainer(void) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pOwner->getContent())
		return m_pOwner->getContent()->getContainer();
	return ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlContainer > ();
}

//------------------------------------------------------------------
::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > > SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::getControls(void) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pOwner->getContent())
	{
		::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl >  xGrid = m_pOwner->getContent()->getGridControl();
		return ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > >(&xGrid, 1);
	}
	return ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > >();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::autoTabOrder(void) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("SbaExternalSourceBrowser::FormControllerImpl::autoTabOrder : nothing to do (always have only one control) !");
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::activateTabOrder(void) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_WARNING("SbaExternalSourceBrowser::FormControllerImpl::activateTabOrder : nothing to do (always have only one control) !");
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::activateFirst(void) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pOwner->getContent())
		m_pOwner->getContent()->getVclControl()->ActivateCell();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::activateLast(void) throw( ::com::sun::star::uno::RuntimeException )
{
	if (m_pOwner->getContent())
		m_pOwner->getContent()->getVclControl()->ActivateCell();
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::frameAction(const ::com::sun::star::frame::FrameActionEvent& aEvent) throw( ::com::sun::star::uno::RuntimeException )
{
	DBG_ASSERT(aEvent.Source == m_pOwner->m_xCurrentFrame, "SbaExternalSourceBrowser::FormControllerImpl::frameAction : where did this come frome ?");

	::com::sun::star::lang::EventObject aEvt(*m_pOwner);
	::cppu::OInterfaceIteratorHelper aIter(m_aActivateListeners);
	switch (aEvent.Action)
	{
		case ::com::sun::star::frame::FrameAction_FRAME_ACTIVATED:
			// as the frame sends more ACTIVATED than DEACTIVATING events we check this with our own flag, so the listeners
			// will be notified only when the first activation occurs
//			if (!m_bActive)
				// TODO : when de DEACTIVATED-event is implemented (MBA) reinsert this line
//			{
//				while (aIter.hasMoreElements())
//					((::com::sun::star::form::XFormControllerListener*)aIter.next())->formActivated(aEvt);
//			}
//			m_bActive = sal_True;
			break;

		case ::com::sun::star::frame::FrameAction_FRAME_DEACTIVATING:
//			while (aIter.hasMoreElements())
//				((::com::sun::star::form::XFormControllerListener*)aIter.next())->formDeactivated(aEvt);
//			m_bActive = sal_False;
			break;
	}
}

//------------------------------------------------------------------
void SAL_CALL SbaExternalSourceBrowser::FormControllerImpl::disposing(const ::com::sun::star::lang::EventObject& Source) throw( ::com::sun::star::uno::RuntimeException )
{
	// nothing to do
	// we don't add ourself as listener to any broadcasters, so we are not resposible for removing us
}

