/*************************************************************************
 *
 *  $RCSfile: unodatbr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_GRIDCTRL_HXX
#include <svx/gridctrl.hxx>
#endif
#ifndef _SDB_TOOLS_HXX
#include <sdb/tools.hxx>
#endif
#ifndef _SBA_UNODATBR_HXX_
#include "unodatbr.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBA_SBADBCOM_HXX
#include "sbadbcom.hxx"
#endif
#ifndef _SBA_SBAUNOTL_HXX
#include "sbaunotl.hxx"
#endif
#ifndef _SBA_GRID_HXX
#include "sbagrid.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

#ifndef _DLGSIZE_HXX
#include "dlgsize.hxx"
#endif
#ifndef _SBA_SBATTRDLG_HXX
#include "dlgattr.hxx"
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SV_MULTISEL_HXX //autogen
#include <tools/multisel.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#include <api.hrc>

#ifndef _COM_SUN_STAR_SDB_COMMANDTYPE_HPP_
#include <com/sun/star/sdb/CommandType.hpp>
#endif

#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XGRIDCOLUMNFACTORY_HPP_
#include <com/sun/star/form/XGridColumnFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XFORM_HPP_
#include <com/sun/star/form/XForm.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_TEXTALIGN_HPP_
#include <com/sun/star/awt/TextAlign.hpp>
#endif

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif

#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif

#ifndef _SFX_BINDINGS_HXX //autogen wg. SFX_BINDINGS
#include <sfx2/bindings.hxx>
#endif

// -------------------------------------------------------------------------
void SafeAddPropertyListener(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xSet, const ::rtl::OUString& rPropName, ::com::sun::star::beans::XPropertyChangeListener* pListener)
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  xInfo = xSet->getPropertySetInfo();
	if (xInfo->hasPropertyByName(rPropName))
		xSet->addPropertyChangeListener(rPropName, pListener);
}

// -------------------------------------------------------------------------
void SafeRemovePropertyListener(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xSet, const ::rtl::OUString& rPropName, ::com::sun::star::beans::XPropertyChangeListener* pListener)
{
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo >  xInfo = xSet->getPropertySetInfo();
	if (xInfo->hasPropertyByName(rPropName))
		xSet->removePropertyChangeListener(rPropName, pListener);
}

//==================================================================
//= SbaTableQueryBrowser
//==================================================================

//------------------------------------------------------------------------------
SbaTableQueryBrowser::SbaTableQueryBrowser(SbaQueryObj* pDBDataObj,const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& _rM,SfxBindings &_rBindings)
	:SbaXDataBrowserController(_rM)
	// this SfxControllerItem has to be changed, component normaly don't use a SfxControllerItem
	// ask mba for more detail
	,SfxControllerItem(SID_SBA_BRW_STATE, _rBindings)//SFX_BINDINGS())
	,aUpdateForward(SID_SBA_BRW_UPDATE, *this)
	,aInsertForward(SID_SBA_BRW_INSERT, *this)
	,aMergeForward(SID_SBA_BRW_MERGE, *this)
	,m_pSelectionList(0)
	,m_bUsingDefinition(0)
{
	DBG_ASSERT(pDBDataObj, "SbaTableQueryBrowser::SbaTableQueryBrowser : invalid argument !");
	m_xDefinition = pDBDataObj->GetDataDef();
	m_xDatabase = m_xDefinition->GetDatabase();
	DBG_ASSERT(m_xDefinition.Is(), "SbaTableQueryBrowser::SbaTableQueryBrowser : the data object didn't have a definition !");

	// calc the title for the load stopper
	sal_uInt32 nTitleResId;
	switch (m_xDefinition->GetKind())
	{
		case dbTable : nTitleResId = RID_STR_TBL_TITLE; break;
		case dbQuery : nTitleResId = RID_STR_QRY_TITLE; break;
		default : DBG_ERROR("OpenDataObjectThread::run : invalid object !");
	}
	String sTemp = String(SbaResId(nTitleResId));
	sTemp.SearchAndReplace('#', m_xDefinition->Name());
	m_sLoadStopperCaption = String(SbaResId(RID_STR_OPEN_OBJECT));
	m_sLoadStopperCaption += ' ';
	m_sLoadStopperCaption += sTemp;
}

//------------------------------------------------------------------------------
SbaTableQueryBrowser::~SbaTableQueryBrowser()
{
	if (m_pSelectionList)
		m_pSelectionList->ReleaseRef();
}

//------------------------------------------------------------------------------
sal_Bool SbaTableQueryBrowser::Construct(Window* pParent)
{
	if (!SbaXDataBrowserController::Construct(pParent))
		return sal_False;

	// and now that we're displaying the table/query the usage counter of the definition has to reflect this
	if (getDefinition())
	{
		getDefinition()->AddUsage();
		m_bUsingDefinition = true;
	}

	// want to be notified of some events affecting the definition and its database
	StartListening(*SBA_MOD());

	// some help ids
	if (getContent() && getContent()->getVclControl())
	{
		getContent()->getVclControl()->GetDataWindow().SetUniqueId(UID_DATABROWSE_DATAWINDOW);
		getContent()->getVclControl()->SetHelpId(dbTable == m_xDefinition->GetKind() ? HID_CTL_TABBROWSER : HID_CTL_QRYBROWSER);
		if (getContent()->getVclControl()->GetHeaderBar())
			getContent()->getVclControl()->GetHeaderBar()->SetHelpId(HID_DATABROWSE_HEADER);
	}

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableQueryBrowser::InitializeForm(const ::com::sun::star::uno::Reference< ::com::sun::star::sdbc::XRowSet > & _rxForm)
{
	try
	{
		// set the parent of the ::com::sun::star::form::Form
		::com::sun::star::uno::Reference< ::com::sun::star::form::XForm >  xForm(_rxForm, ::com::sun::star::uno::UNO_QUERY);
		{
			DbEnvironmentAccess aEnv;
			if (aEnv.getEnv().is())
			{
				::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseAccess >  xDatabase = aEnv.getEnv()->getDatabaseAccess(m_xDatabase->Name());
				if (xDatabase.is())
					xForm->setParent(xDatabase->getConnection(::rtl::OUString(),::rtl::OUString()));
			}
		}

		// we send all properties at once, maybe the implementation is clever enough to handle one big PropertiesChanged
		// more effective than many small PropertyChanged ;)
		::com::sun::star::uno::Sequence< ::rtl::OUString> aProperties(6);
		::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any> aValues(6);

		// is the filter intially applied ?
		const SfxBoolItem* pFilterApplied = (const SfxBoolItem*)getDefinition()->GetObjAttrs()->GetItem(SBA_DEF_FILTERAPPLIED);
		aProperties.getArray()[0] = PROPERTY_APPLYFILTER;
		aValues.getArray()[0] = ::utl::makeBoolAny((sal_Bool)(pFilterApplied ? pFilterApplied->GetValue() : sal_False));

		// cursor source
		aProperties.getArray()[1] = PROPERTY_COMMAND;
		aValues.getArray()[1] <<= ::rtl::OUString(m_xDefinition->Name());
			// may be replaced with a sql statement below

		// cursor source type
		aProperties.getArray()[2] = PROPERTY_COMMANDTYPE;

		sal_Int32 nType = ::com::sun::star::sdb::CommandType::COMMAND;
		sal_Bool bEscapeProcessing = sal_True;
		switch (m_xDefinition->GetKind())
		{
			case dbTable : nType = ::com::sun::star::sdb::CommandType::TABLE; break;
			case dbQuery :
				if (m_xDefinition->Name().Len())
					nType = ::com::sun::star::sdb::CommandType::QUERY;
				else
				{	// it is a temporary query object
					SbaQueryDef* pQuery = PTR_CAST(SbaQueryDef, &m_xDefinition);
					DBG_ASSERT(pQuery, "SbaTableQueryBrowser::InitializeForm : the object is of kind dbQuery but no query def ?");

					if (pQuery->IsNative())
						bEscapeProcessing = sal_False;
					
					aValues.getArray()[1] <<= ::rtl::OUString(pQuery->Statement());
				}
				break;

			default : DBG_ERROR("SbaTableQueryBrowser::InitializeForm : the definition has to be a table or a query !");
		}
		aValues.getArray()[2] <<= nType;

		// escape processing ?
		aProperties.getArray()[3] = PROPERTY_USE_ESCAPE_PROCESSING;
		aValues.getArray()[3].setValue(&bEscapeProcessing,::getBooleanCppuType());

		// the initial filter
		const SfxStringItem* pFilterSort = (const SfxStringItem*)getDefinition()->GetObjAttrs()->GetItem(SBA_DEF_FILTER);
		aProperties.getArray()[4] = PROPERTY_FILTER;
		aValues.getArray()[4] <<= ::rtl::OUString(pFilterSort ? ::rtl::OUString(pFilterSort->GetValue()) : ::rtl::OUString());

		// the initial ordering
		pFilterSort = (const SfxStringItem*)getDefinition()->GetObjAttrs()->GetItem(SBA_DEF_SORT);
		aProperties.getArray()[5] = PROPERTY_ORDER;
		aValues.getArray()[5] <<= ::rtl::OUString(pFilterSort ? ::rtl::OUString(pFilterSort->GetValue()) : ::rtl::OUString());

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XMultiPropertySet >  xFormMultiSet(_rxForm, ::com::sun::star::uno::UNO_QUERY);
		xFormMultiSet->setPropertyValues(aProperties, aValues);
	}
	catch(...)
	{
		DBG_ERROR("SbaTableQueryBrowser::InitializeForm : something went wrong !");
		return sal_False;
	}
	

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableQueryBrowser::InitializeGridModel(const ::com::sun::star::uno::Reference< ::com::sun::star::form::XFormComponent > & xGrid)
{
	try
	{

	// we want to have a grid with a "flat" border
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xGridSet(xGrid, ::com::sun::star::uno::UNO_QUERY);
	if (xGridSet.is())
		xGridSet->setPropertyValue(PROP_NAME_BORDER, ::com::sun::star::uno::makeAny((sal_Int16)2));

	// get the formats supplier of the database we're working with
	::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier >  xSupplier;
	try
	{
		::com::sun::star::uno::Reference< ::com::sun::star::sdb::XDatabaseEnvironment >  xDbEnv = DbEnvironmentAccess().getEnv();
		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xDatabaseProps;
		if (xDbEnv.is())
			xDatabaseProps = ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > (xDbEnv->getDatabaseAccess(m_xDatabase->Name()), ::com::sun::star::uno::UNO_QUERY);
		::com::sun::star::uno::Any aSupplier;
		if (xDatabaseProps.is())
			aSupplier = xDatabaseProps->getPropertyValue(PROPERTY_NUMBERFORMATSSUPPLIER);
		if (aSupplier.getValueTypeClass() == ::com::sun::star::uno::TypeClass_INTERFACE)
			xSupplier = ::com::sun::star::uno::Reference< ::com::sun::star::util::XNumberFormatsSupplier > (*(::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > *)aSupplier.getValue(), ::com::sun::star::uno::UNO_QUERY);
	}
	catch(...)
	{
	}
	;

	// translate the definition properties into UNO properties
	::com::sun::star::uno::Reference< ::com::sun::star::form::XGridColumnFactory >  xColFactory(xGrid, ::com::sun::star::uno::UNO_QUERY);
	::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >  xColContainer(xGrid, ::com::sun::star::uno::UNO_QUERY);

	::com::sun::star::uno::Any aVoidKey;

	::rtl::OUString aCurrentModelType;
	::rtl::OUString aCurrentColName;
	SbaDBDataDef* pDef = getDefinition();
	for (sal_uInt16 i=0; i<pDef->Count(); ++i)
	{
		SbaColumn* pCurrentCol = pDef->GetColumn(i);

		// Name
		SFX_ITEMSET_GET(*pCurrentCol, pName, SbaNameItem, SBA_DEF_FLTNAME, sal_True);
		aCurrentColName = pName->GetValue();

		// Typ
		SFX_ITEMSET_GET(*pCurrentCol, pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
		sal_Bool bIsFormatted = sal_False;
		sal_Bool bFormattedIsNumeric = sal_True;
		switch (pType->GetType())
		{
			// TODO : die Strings fuer die Column-Typen irgendwo richtig platzieren
			case dbBool:
				aCurrentModelType = ::rtl::OUString::createFromAscii("CheckBox");
				break;

			case dbNone:
			case dbBinary:
			case dbVarBinary:
			case dbImage:
				aCurrentModelType = ::rtl::OUString::createFromAscii("TextField");
				break;

			case dbText:
			case dbMemo:
			case dbChar:
				bFormattedIsNumeric = sal_False;
				// _NO_ break !
			default:
				aCurrentModelType = ::rtl::OUString::createFromAscii("FormattedField");
				bIsFormatted = sal_True;
				break;
		}

		::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xCurrentCol = xColFactory->createColumn(aCurrentModelType);
		xCurrentCol->setPropertyValue(PROP_NAME_CONTROLSOURCE, ::com::sun::star::uno::makeAny(aCurrentColName));
		xCurrentCol->setPropertyValue(PROP_NAME_LABEL, ::com::sun::star::uno::makeAny(aCurrentColName));
		if (bIsFormatted)
		{
			SFX_ITEMSET_GET(*pCurrentCol, pFormat, SfxUInt32Item, SBA_DEF_FMTVALUE, sal_True);
			if (xSupplier.is())
				xCurrentCol->setPropertyValue(::rtl::OUString::createFromAscii("FormatsSupplier"), ::com::sun::star::uno::makeAny(xSupplier));
			xCurrentCol->setPropertyValue(PROP_NAME_FORMATKEY, pFormat ? ::com::sun::star::uno::makeAny((sal_Int32)pFormat->GetValue()) : aVoidKey);
			xCurrentCol->setPropertyValue(::rtl::OUString::createFromAscii("TreatAsNumber"), ::utl::makeBoolAny(bFormattedIsNumeric));
		}

		// default value
		if (pType->GetType() == dbBool)
		{
			::com::sun::star::uno::Any aDefault; aDefault <<= ((sal_Int16)STATE_DONTKNOW);
			SFX_ITEMSET_GET(*pCurrentCol, pDefault, SfxStringItem, SBA_DEF_FLTDEFAULT, sal_True);
			if (pDefault && pDefault->GetValue().Len())
				aDefault <<=  (sal_Int16)((pDefault->GetValue().Equals('0')) ? STATE_NOCHECK : STATE_CHECK);
				
			xCurrentCol->setPropertyValue(::rtl::OUString::createFromAscii("DefaultState"), aDefault);
		}

		// transfer properties from the definition to the UNO-model :
		// ... the hidden flag
		SFX_ITEMSET_GET(*pCurrentCol, pHidden, SfxBoolItem, SBA_DEF_FLTHIDE, sal_True);
		xCurrentCol->setPropertyValue(PROP_NAME_HIDDEN, ::utl::makeBoolAny((sal_Bool)(pHidden && pHidden->GetValue())));

		// ... the initial colum width
		SFX_ITEMSET_GET(*pCurrentCol, pWidth, SbaColRowSizeItem, SBA_DEF_FLTCOLWIDTH, sal_True);
		SFX_ITEMSET_GET(*pCurrentCol, pWidthDefault, SfxBoolItem, SBA_DEF_FLTCOLWIDTH_DEFAULT, sal_True);
		::com::sun::star::uno::Any aWidth;
		if (pWidthDefault->GetValue())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState >  xPropState(xCurrentCol, ::com::sun::star::uno::UNO_QUERY);
			if (xPropState.is())
			{
				try { aWidth = xPropState->getPropertyDefault(PROP_NAME_WIDTH); } catch(...) { } ;
			}
		}
		else
			aWidth <<= (sal_Int32)pWidth->GetLogicValue();
		xCurrentCol->setPropertyValue(PROP_NAME_WIDTH, aWidth);

		// ... horizontal justify
		SFX_ITEMSET_GET(*pCurrentCol, pHorJustify, SvxHorJustifyItem, SBA_ATTR_ALIGN_HOR_JUSTIFY, sal_True);
		::com::sun::star::uno::Any aAlignment;
		pHorJustify->QueryValue(aAlignment);
		if (aAlignment.hasValue())
			switch (*(SvxCellHorJustify*)aAlignment.getValue())
			{
				case SVX_HOR_JUSTIFY_LEFT:
					aAlignment <<= (sal_Int32)::com::sun::star::awt::TextAlign::LEFT;
					break;
				case SVX_HOR_JUSTIFY_CENTER:
					aAlignment <<= (sal_Int32)::com::sun::star::awt::TextAlign::CENTER;
					break;
				case SVX_HOR_JUSTIFY_RIGHT:
					aAlignment <<= (sal_Int32)::com::sun::star::awt::TextAlign::RIGHT;
					break;
				default:
					aAlignment.clear();
					break;
			}
		xCurrentCol->setPropertyValue(PROP_NAME_ALIGN, aAlignment);

		// ... the 'comment' property as helptext (will usually be shown as header-tooltip)
		SFX_ITEMSET_GET(*pCurrentCol, pComment, SfxStringItem, SBA_DEF_FLTCOMMENT, sal_True);
		xCurrentCol->setPropertyValue(PROP_NAME_HELPTEXT, ::com::sun::star::uno::makeAny(::rtl::OUString(pComment->GetValue())));

		xColContainer->insertByName(aCurrentColName, ::com::sun::star::uno::makeAny(xCurrentCol));
	}

	SFX_ITEMSET_GET(*pDef->GetObjAttrs(), pRowHeight, SbaColRowSizeItem, SBA_DEF_ROWHEIGHT, sal_True);
	SFX_ITEMSET_GET(*pDef->GetObjAttrs(), pRowHeightDefault, SfxBoolItem, SBA_DEF_ROWHEIGHT_DEFAULT, sal_True);
	if (xGridSet.is() && pRowHeight && pRowHeightDefault)
	{
		::com::sun::star::uno::Any aHeight;
		if (pRowHeightDefault->GetValue())
		{
			::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyState >  xPropState(xGridSet, ::com::sun::star::uno::UNO_QUERY);
			if (xPropState.is())
			{
				try { aHeight = xPropState->getPropertyDefault(PROP_NAME_ROW_HEIGHT); } catch(...) { } ;
			}
		}
		else
			aHeight <<= pRowHeight->GetLogicValue();
		xGridSet->setPropertyValue(PROP_NAME_ROW_HEIGHT, aHeight);
	}

	if (xGridSet.is())
	{
		::com::sun::star::awt::FontDescriptor aFont = BuildFontFromItems(pDef->GetObjAttrs(), Application::GetDefaultDevice()->GetFont());
		xGridSet->setPropertyValue(PROP_NAME_FONT, ::com::sun::star::uno::Any(&aFont, ::getCppuType((const ::com::sun::star::awt::FontDescriptor*)0)));

		SFX_ITEMSET_GET(*pDef->GetObjAttrs(), pColor, SvxColorItem, SBA_DEF_FONTCOLOR, sal_True);
		xGridSet->setPropertyValue(PROP_NAME_TEXTCOLOR, ::com::sun::star::uno::makeAny((sal_Int32)pColor->GetValue().GetColor()));
	}

	}
	catch(...)
	{
		DBG_ERROR("SbaTableQueryBrowser::InitializeGridModel : something went wrong !");
		return sal_False;
	}
	

	return sal_True;
}

//------------------------------------------------------------------------------
ToolBox* SbaTableQueryBrowser::CreateToolBox(Window* _pParent)
{
	sal_uInt16 nResId = 0;
	if (m_xDefinition.Is())
		switch (m_xDefinition->GetKind())
		{
			case dbTable : nResId = RID_BRW_TAB_TOOLBOX; break;
			case dbQuery : nResId = RID_BRW_QRY_TOOLBOX; break;
			default : return NULL;
		}

	ToolBox* pTB = new ToolBox(_pParent, SbaResId(nResId));
	if (!pTB)
		return NULL;

	if (pTB->GetItemPos(SID_EXPLORER_PREVLEVEL) != TOOLBOX_ITEM_NOTFOUND)
	{	// if we display the grid in the beamer we don't want a "prev level" button
		if (getFrame().is() && (getFrame()->getName().equals(::rtl::OUString::createFromAscii("_beamer"))))
			pTB->HideItem(SID_EXPLORER_PREVLEVEL);
	}

	return pTB;
}

// -----------------------------------------------------------------------
void SbaTableQueryBrowser::propertyChange(const ::com::sun::star::beans::PropertyChangeEvent& evt)
{
	SbaXDataBrowserController::propertyChange(evt);

	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSource(evt.Source, ::com::sun::star::uno::UNO_QUERY);
	if (!xSource.is())
		return;

	// one of the many properties which require us to update the definition ?
	// a column's width ?
	if (evt.PropertyName.equals(PROP_NAME_WIDTH))
	{	// a column width has changed -> update the model
		// (the update of the view is done elsewhere)
		SbaColumn* pAffectedCol = GetDefinitionCol(xSource);
		if (pAffectedCol)
		{
			SbaColRowSizeItem aNewWidth(SBA_DEF_FLTCOLWIDTH);
			sal_Bool bDefault = !evt.NewValue.hasValue();
			SfxBoolItem aDefault(SBA_DEF_FLTCOLWIDTH_DEFAULT, bDefault);
			if (bDefault)
				// this is for older versions which don't know the default flag
				aNewWidth.PutLogicValue((sal_uInt16)227);
			else
				aNewWidth.PutLogicValue((sal_uInt16)::utl::getINT32(evt.NewValue));

			pAffectedCol->Put(aNewWidth);
			pAffectedCol->Put(aDefault);
		}
	}

	// a column's 'visible' state ?
	if (evt.PropertyName.equals(PROP_NAME_HIDDEN))
	{
		SbaColumn* pAffectedCol = GetDefinitionCol(xSource);
		if (pAffectedCol)
			pAffectedCol->Put(SfxBoolItem(SBA_DEF_FLTHIDE, ::utl::getBOOL(evt.NewValue)));
	}

	// a columns alignment ?
	if (evt.PropertyName.equals(PROP_NAME_ALIGN))
	{
		SbaColumn* pAffectedCol = GetDefinitionCol(xSource);
		if (pAffectedCol)
		{
			SvxCellHorJustify eHorJustify = SVX_HOR_JUSTIFY_STANDARD;
			if (evt.NewValue.hasValue())
				switch (::utl::getINT16(evt.NewValue))
				{
					case ::com::sun::star::awt::TextAlign::LEFT:
						eHorJustify = SVX_HOR_JUSTIFY_LEFT;
						break;
					case ::com::sun::star::awt::TextAlign::CENTER:
						eHorJustify = SVX_HOR_JUSTIFY_CENTER;
						break;
					case ::com::sun::star::awt::TextAlign::RIGHT:
						eHorJustify = SVX_HOR_JUSTIFY_RIGHT;
						break;
				}

			pAffectedCol->Put(SvxHorJustifyItem(eHorJustify, SBA_ATTR_ALIGN_HOR_JUSTIFY));
		}
	}

	// a column's format ?
	if	(	(evt.PropertyName.equals(PROP_NAME_FORMATKEY))
		&&	(::com::sun::star::uno::TypeClass_LONG == evt.NewValue.getValueTypeClass())
		)
	{
		// update the model (means the definition object)
		SbaColumn* pAffectedCol = GetDefinitionCol(xSource);
		if (pAffectedCol)
			pAffectedCol->Put(SfxUInt32Item(SBA_DEF_FMTVALUE, ::utl::getINT32(evt.NewValue)));
	}

	// some table definition properties ?
	// the height of the rows in the grid ?
	if (evt.PropertyName.equals(PROP_NAME_ROW_HEIGHT))
	{
		if (getDefinition())
		{
			SbaColRowSizeItem aNewHeight(SBA_DEF_ROWHEIGHT);
			sal_Bool bDefault = !evt.NewValue.hasValue();
			SfxBoolItem aDefault(SBA_DEF_FLTCOLWIDTH_DEFAULT, bDefault);

			if (bDefault)
				aNewHeight.PutLogicValue((sal_uInt16)45);
			else
				aNewHeight.PutLogicValue((sal_uInt16)::utl::getINT32(evt.NewValue));

			getDefinition()->GetObjAttrs()->Put(aNewHeight);
			getDefinition()->GetObjAttrs()->Put(aDefault);
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}

	// the font of the grid ?
	if (evt.PropertyName.equals(PROP_NAME_FONT))
	{
		if (getDefinition())
		{
			BuildItemsFromFont(getDefinition()->GetObjAttrs(), *(::com::sun::star::awt::FontDescriptor*)evt.NewValue.getValue());
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}

	// the text color of the grid ?
	if (evt.PropertyName.equals(PROP_NAME_TEXTCOLOR))
	{
		if (getDefinition())
		{
			SvxColorItem aColor(Color(::utl::getINT32(evt.NewValue)), SBA_DEF_FONTCOLOR);
			getDefinition()->GetObjAttrs()->Put(aColor);
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}

	// the filter ?
	if (evt.PropertyName.equals(PROPERTY_FILTER))
	{
		if (getDefinition())
		{
			SfxStringItem aFilter(SBA_DEF_FILTER, ::utl::getString(evt.NewValue));
			getDefinition()->GetObjAttrs()->Put(aFilter);
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}

	// the sort ?
	if (evt.PropertyName.equals(PROPERTY_ORDER))
	{
		if (getDefinition())
		{
			SfxStringItem aSort(SBA_DEF_SORT, ::utl::getString(evt.NewValue));
			getDefinition()->GetObjAttrs()->Put(aSort);
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}

	// the appliance of the filter ?
	if (evt.PropertyName.equals(PROPERTY_APPLYFILTER))
	{
		if (getDefinition())
		{
			SfxBoolItem aApplied(SBA_DEF_FILTERAPPLIED, ::utl::getBOOL(evt.NewValue));
			getDefinition()->GetObjAttrs()->Put(aApplied);
			getDefinition()->PutObjAttrs(*(getDefinition()->GetObjAttrs()));
				// this sets the modified flagd
		}
	}
}

// -----------------------------------------------------------------------
sal_Bool SbaTableQueryBrowser::suspend(sal_Bool bSuspend) throw( ::com::sun::star::uno::RuntimeException )
{
	if (!SbaXDataBrowserController::suspend(bSuspend))
		return sal_False;

	if (getDefinition())
	{
		// let the definition save its UI settings
		SbaDBDataDef* pDef = getDefinition();
		if (pDef && !pDef->GetDatabase()->IsReadOnly() && pDef->IsModified())
			pDef->Update();

		// we aren't using the definition anymore
		if (m_bUsingDefinition)
		{
			pDef->ReleaseUsage();
			m_xDefinition = NULL;
			m_bUsingDefinition = false;
		}
		
	}

	// we don't need to listen at the definition and its database anymore
	EndListening(*SBA_MOD());

	return sal_True;
}

// -------------------------------------------------------------------------
void SbaTableQueryBrowser::attachFrame(const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & _xFrame) throw( ::com::sun::star::uno::RuntimeException )
{
	SbaXDataBrowserController::attachFrame(_xFrame);

	sal_Bool bIsBeamer = (getFrame().is() && (getFrame()->getName().equals(::rtl::OUString::createFromAscii("_beamer"))));
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xGridSet(getFormComponent(), ::com::sun::star::uno::UNO_QUERY);
	ToolBox* pTB = getContent() ? getContent()->getToolBox() : NULL;

	if (bIsBeamer)
	{
		// hide the "move a level up"-button
		sal_uInt16 nPos = pTB ? pTB->GetItemPos(SID_EXPLORER_PREVLEVEL) : TOOLBOX_ITEM_NOTFOUND;
		if ((nPos != TOOLBOX_ITEM_NOTFOUND) && pTB->IsItemVisible(SID_EXPLORER_PREVLEVEL))
		{
			DBG_ASSERT(nPos == 0, "SbaTableQueryBrowser::attachFrame : can't handle a prev-level-slot which isn't the first one within the TB !");
				// we check all slots behind the prev-level slot and don't deal with the ones before
			pTB->HideItem(SID_EXPLORER_PREVLEVEL);
			++nPos;
			if (pTB->GetItemType(nPos) == TOOLBOXITEM_SEPARATOR)
				pTB->RemoveItem(nPos);
		}
	}
	else
	{
		// show the "move a level up"-button
		sal_uInt16 nPos = pTB ? pTB->GetItemPos(SID_EXPLORER_PREVLEVEL) : TOOLBOX_ITEM_NOTFOUND;
		if ((nPos != TOOLBOX_ITEM_NOTFOUND) && !pTB->IsItemVisible(SID_EXPLORER_PREVLEVEL))
		{
			DBG_ASSERT(nPos == 0, "SbaTableQueryBrowser::attachFrame : can't handle a prev-level-slot which isn't the first one within the TB !");
				// we check all slots behind the prev-level slot and don't deal with the ones before
			pTB->ShowItem(SID_EXPLORER_PREVLEVEL);
			++nPos;
			if (pTB->GetItemType(nPos) != TOOLBOXITEM_SEPARATOR)
				pTB->InsertSeparator(nPos);
		}
	}
}

// -------------------------------------------------------------------------
void SbaTableQueryBrowser::addModelListeners(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlModel > & _xGridControlModel)
{
	SbaXDataBrowserController::addModelListeners(_xGridControlModel);
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xCols(_xGridControlModel, ::com::sun::star::uno::UNO_QUERY);
	if (xCols.is())
	{
		xCols->addPropertyChangeListener(PROP_NAME_ROW_HEIGHT, (::com::sun::star::beans::XPropertyChangeListener*)this);
		xCols->addPropertyChangeListener(PROP_NAME_FONT, (::com::sun::star::beans::XPropertyChangeListener*)this);
		xCols->addPropertyChangeListener(PROP_NAME_TEXTCOLOR, (::com::sun::star::beans::XPropertyChangeListener*)this);
	}

}

// -------------------------------------------------------------------------
void SbaTableQueryBrowser::removeModelListeners(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControlModel > & _xGridControlModel)
{
	SbaXDataBrowserController::removeModelListeners(_xGridControlModel);
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xSourceSet(_xGridControlModel, ::com::sun::star::uno::UNO_QUERY);
	if (xSourceSet.is())
	{
		xSourceSet->removePropertyChangeListener(PROP_NAME_ROW_HEIGHT, (::com::sun::star::beans::XPropertyChangeListener*)this);
		xSourceSet->removePropertyChangeListener(PROP_NAME_FONT, (::com::sun::star::beans::XPropertyChangeListener*)this);
		xSourceSet->removePropertyChangeListener(PROP_NAME_TEXTCOLOR, (::com::sun::star::beans::XPropertyChangeListener*)this);
	}
}

//------------------------------------------------------------------------
SbaColumn* SbaTableQueryBrowser::GetDefinitionCol(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xColumnSet)
{
	if (!getDefinition())
		return NULL;

	String sColName = ::utl::getString(xColumnSet->getPropertyValue(PROP_NAME_NAME));
	return getDefinition()->GetColumns().Lookup(sColName, String());
		// do NOT use getDefinition()->GetColumn(sColName), as this would provide the original columns
}

// -------------------------------------------------------------------------
String SbaTableQueryBrowser::getURL() const
{
	if (m_xDefinition.Is())
		return m_xDefinition->ToURL();
	return String();
}

// -----------------------------------------------------------------------
void SbaTableQueryBrowser::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType)
{
	if (!getDefinition())
		return;

	// will mein Def-Objekt losgelassen werden ?
	SbaDBDefHint *pDBDefHint = PTR_CAST(SbaDBDefHint,&rHint);
	sal_Bool bDefWantsRelease = pDBDefHint							// es ist der richtige Typ
		&& (*pDBDefHint->GetDBDef() == *getDefinition())			// es geht um meine Def
		&& (pDBDefHint->GetAction() == SbaDBDefHint::dbRelease)	// es geht um's release
		&& (pDBDefHint->CanRelease());							// es hat nicht schon jemand anders 'nein' gesagt

	// vielleicht meine Datenbank ?
	SbaDBHint *pDBHint = PTR_CAST(SbaDBHint,&rHint);
	sal_Bool bDBWantsRelease = pDBHint
		&& (pDBHint->GetDatabase() == getDefinition()->GetDatabase())
		&& (pDBHint->GetAction() == SbaDBHint::dbRelease)
		&& (pDBHint->CanRelease());

	if (bDefWantsRelease || bDBWantsRelease)
	{
		if (!suspend(sal_True))
			if (bDefWantsRelease)
				pDBDefHint->DenyRelease();
			else
				pDBHint->DenyRelease();
		else
			EmptyWindow();

		// in EmptyWindow we may have been deleted, so don't go any further
		return;
	}

	// ist meine Def gerade geloescht worden ?
	sal_Bool bDefReleased = pDBDefHint
		&& (*pDBDefHint->GetDBDef() == *getDefinition())
		&& (pDBDefHint->GetAction() == SbaDBDefHint::dbDelete);
	if (bDefReleased)
	{
		EmptyWindow();
	}
}

// -----------------------------------------------------------------------
void SbaTableQueryBrowser::InvalidateFeature(sal_uInt16 nId, const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XStatusListener > & xListener)
{
	switch (nId)
	{
		case SID_SBA_BRW_INSERT:
		case SID_SBA_BRW_UPDATE:
		case SID_SBA_BRW_MERGE:
			SFX_BINDINGS().Invalidate(nId, sal_True, sal_False);
			break;
		default:
			SbaXDataBrowserController::InvalidateFeature(nId, xListener);
	}
}

//------------------------------------------------------------------------------
void SbaTableQueryBrowser::AddColumnListener(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xCol)
{
	SbaXDataBrowserController::AddColumnListener(xCol);
	SafeAddPropertyListener(xCol, PROP_NAME_WIDTH, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeAddPropertyListener(xCol, PROP_NAME_HIDDEN, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeAddPropertyListener(xCol, PROP_NAME_ALIGN, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeAddPropertyListener(xCol, PROP_NAME_FORMATKEY, (::com::sun::star::beans::XPropertyChangeListener*)this);
}

//------------------------------------------------------------------------------
void SbaTableQueryBrowser::RemoveColumnListener(const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet > & xCol)
{
	SbaXDataBrowserController::RemoveColumnListener(xCol);
	SafeRemovePropertyListener(xCol, PROP_NAME_WIDTH, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeRemovePropertyListener(xCol, PROP_NAME_HIDDEN, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeRemovePropertyListener(xCol, PROP_NAME_ALIGN, (::com::sun::star::beans::XPropertyChangeListener*)this);
	SafeRemovePropertyListener(xCol, PROP_NAME_FORMATKEY, (::com::sun::star::beans::XPropertyChangeListener*)this);
}

//------------------------------------------------------------------------------
class ControllerFeatureHolder
{
public:
	ControllerFeature*	pFeatures;

	ControllerFeatureHolder() : pFeatures(NULL) { };
	~ControllerFeatureHolder() { delete pFeatures; pFeatures = NULL; }
};

//------------------------------------------------------------------------------
const ControllerFeature* SbaTableQueryBrowser::GetSupportedFeatures() const
{
	static ControllerFeatureHolder aFeatures;
	if (!aFeatures.pFeatures)
	{
		const ControllerFeature* pBaseClassFeatures = SbaXDataBrowserController::GetSupportedFeatures();
		static ControllerFeature aMyFeatures[] =
		{
			ControllerFeature( ::rtl::OUString::createFromAscii(".uno:Title"),						SID_DOCINFO_TITLE		),
			ControllerFeature( ::rtl::OUString::createFromAscii(".uno:WriterDB/MailInsert"),			SID_SBA_BRW_INSERT		),
			ControllerFeature( ::rtl::OUString::createFromAscii(".uno:WriterDB/MailMerge"),			SID_SBA_BRW_MERGE		),
			ControllerFeature( ::rtl::OUString::createFromAscii(".uno:WriterDB/MailUpdate"),			SID_SBA_BRW_UPDATE		)
			// TODO reenable our own code if we really have a handling for the formslots
//			ControllerFeature( ::rtl::OUString::createFromAscii("private:FormSlot/moveToFirst"),		SID_FM_RECORD_FIRST		),
//			ControllerFeature( ::rtl::OUString::createFromAscii("private:FormSlot/moveToLast"),		SID_FM_RECORD_LAST		),
//			ControllerFeature( ::rtl::OUString::createFromAscii("private:FormSlot/moveToNew"),		SID_FM_RECORD_NEW		),
//			ControllerFeature( ::rtl::OUString::createFromAscii("private:FormSlot/moveToNext"),		SID_FM_RECORD_NEXT		),
//			ControllerFeature( ::rtl::OUString::createFromAscii("private:FormSlot/moveToPrev"),		SID_FM_RECORD_PREV		)
		};

		// merge the two sequences, keep sort
		
		sal_uInt32 nBaseLen = 0;
		while(pBaseClassFeatures[nBaseLen++].sURL.getLength())
			;
		--nBaseLen;
		sal_uInt32 nMyLen = sizeof(aMyFeatures)/sizeof(aMyFeatures[0]);
		sal_uInt32 nOverallLen = nBaseLen + nMyLen;

		const ControllerFeature* pMyFeatures = aMyFeatures;

		ControllerFeature* pFeatures = new ControllerFeature[nOverallLen + 1];
			// + 1 because of the final "empty" feature
		aFeatures.pFeatures = pFeatures;

		for (sal_uInt32 i=0, nBaseUsed=0, nMyUsed=0; i<nOverallLen; ++i)
		{
			sal_Bool bUseBase;

			if (nBaseUsed>=nBaseLen)		// no more base class features
				bUseBase = sal_False;
			else if (nMyUsed>=nMyLen)		// no more own features
				bUseBase = sal_True;
			else							// compare both available features
				bUseBase = pBaseClassFeatures->sURL < pMyFeatures->sURL;

			if (bUseBase)
			{
				*pFeatures = *pBaseClassFeatures;
				++pBaseClassFeatures;
				++nBaseUsed;
			}
			else
			{
				*pFeatures = *pMyFeatures;
				++pMyFeatures;
				++nMyUsed;
			}
			++pFeatures;
		}
	}
	return aFeatures.pFeatures;
}

//------------------------------------------------------------------------------
FeatureState SbaTableQueryBrowser::GetState(sal_uInt16 nId)
{
	FeatureState aReturn;
		// (disabled automatically)

	try
	{
		// no chance without a view
		if (!getContent() || !getContent()->getVclControl())
			return aReturn;
		// no chance without valid models
		if (isValid() && !isValidCursor())
			return aReturn;
		// no chance while loading the form
		if (PendingLoad())
			return aReturn;

		switch (nId)
		{
			case SID_SBA_BRW_INSERT:
			case SID_SBA_BRW_UPDATE:
			case SID_SBA_BRW_MERGE:
			{
				SfxPoolItem* pState = NULL;
				SfxItemState eState = SFX_BINDINGS().QueryState(nId, pState);
				if (pState)
					delete pState;	// not interested in
				aReturn.bEnabled = (eState >= SFX_ITEM_AVAILABLE);

				if (SID_SBA_BRW_MERGE != nId)
					aReturn.bEnabled = aReturn.bEnabled && getContent()->getVclControl()->GetSelectRowCount();

				::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xDataSource(getDataSource(), ::com::sun::star::uno::UNO_QUERY);
				try
				{
					aReturn.bEnabled = aReturn.bEnabled && xDataSource.is();

					// disable them for native queries which are not saved within the database
					// 67706 - 23.08.99 - FS
					if (xDataSource.is())
					{
						sal_Int32 nType = ::utl::getINT32(xDataSource->getPropertyValue(PROPERTY_COMMANDTYPE));
						aReturn.bEnabled = aReturn.bEnabled && ((::utl::getBOOL(xDataSource->getPropertyValue(PROPERTY_USE_ESCAPE_PROCESSING)) || (nType == ::com::sun::star::sdb::CommandType::QUERY)));
					}
				}
				catch(...)
				{
				}
				
			}
			break;
			case SID_DOCINFO_TITLE:
				if (getDefinition())
				{
					String sTitle;
					switch (getDefinition()->GetKind())
					{
						case dbTable:
							sTitle = String(SbaResId(RID_STR_TBL_TITLE)); break;
						case dbView:
							sTitle = String(SbaResId(RID_STR_VW_TITLE)); break;
						case dbQuery:
							sTitle = String(SbaResId(RID_STR_QRY_TITLE)); break;
						default:
							DBG_ASSERT(0,"Unbekannte DBDef Art");
					}
					String sObject(getDefinition()->GetDatabase()->Title());
					sObject += '.';
					sObject += getDefinition()->Name();

					sTitle.SearchAndReplace('#',sObject);
					aReturn.aState <<= ::rtl::OUString(sTitle);
					aReturn.bEnabled = sal_True;
				}
				break;
			case SID_SBA_BRW_TABLEATTR:
			case SID_SBA_BRW_ROWHEIGHT:
			case SID_SBA_BRW_COLATTRSET:
			case SID_SBA_BRW_COLWIDTH:
				aReturn.bEnabled = getContent() && getContent()->getVclControl() && isValid() && isValidCursor();
				aReturn.bEnabled &= getDefinition() && !getDefinition()->GetDatabase()->IsReadOnly();
				break;

			case SID_EXPLORER_PREVLEVEL:
				aReturn.bEnabled = sal_True;
				break;

			case SID_EDITDOC:
				aReturn = SbaXDataBrowserController::GetState(nId);
				aReturn.bEnabled &= !getDefinition()->IsLocked();
					// somebody is modifying the definition -> no edit mode
				break;

			default:
				return SbaXDataBrowserController::GetState(nId);
		}
	}
	catch(::com::sun::star::uno::Exception& e)
	{
#if DBG_UTIL
		String sMessage("SbaXDataBrowserController::GetState(", RTL_TEXTENCODING_ASCII_US);
		sMessage += String::CreateFromInt32(nId);
		sMessage.AppendAscii(") : catched an exception ! message : ");
		sMessage += (const sal_Unicode*)e.Message;
		DBG_ERROR(ByteString(sMessage, gsl_getSystemTextEncoding()).GetBuffer());
#else
		e;	// make compiler happy
#endif
	}
	;

	return aReturn;

}

//------------------------------------------------------------------------------
void SbaTableQueryBrowser::Execute(sal_uInt16 nId)
{
	switch (nId)
	{
		case SID_EDITDOC:
			SbaXDataBrowserController::Execute(nId);
			if (getDefinition())
				if (getContent()->getVclControl()->GetOptions() > DbGridControl::OPT_READONLY)
				{
					getDefinition()->AddUsage();
					m_bUsingDefinition = true;
				}
				else
				{
					if (m_bUsingDefinition)
						getDefinition()->ReleaseUsage();
					m_bUsingDefinition = false;
				}
			break;

		case SID_SBA_BRW_INSERT:
		case SID_SBA_BRW_UPDATE:
		case SID_SBA_BRW_MERGE:
			SendInfo(nId);
			break;

		case SID_EXPLORER_PREVLEVEL:
		{
			INetURLObject aURL(getURL());
			DBG_ASSERT(aURL.HasMark(), "SbaTableQueryBrowser::Execute : invalid ::com::sun::star::util::URL !");
			String sMark = aURL.GetMark();
			xub_StrLen nSep = sMark.SearchBackward(';');
			DBG_ASSERT(nSep != STRING_NOTFOUND, "SbaTableQueryBrowser::Execute : invalid ::com::sun::star::util::URL !");
			String sParentContainerUrl; sParentContainerUrl.AssignAscii("file:///");
			sParentContainerUrl += aURL.GetURLPath();
			sParentContainerUrl += '#';
			sParentContainerUrl += sMark.Copy(0, nSep);

			::com::sun::star::util::URL aParentUrl;
			aParentUrl.Complete = sParentContainerUrl;

			::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchProvider >  xProvider(m_xCurrentFrame, ::com::sun::star::uno::UNO_QUERY);
			DBG_ASSERT(xProvider.is(), "SbaTableQueryBrowser::Execute(SID_EXPLORER_PREVLEVEL) : no DispatchPprovider !");
			::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  xDispatcher = xProvider->queryDispatch(aParentUrl, m_xCurrentFrame->getName(), 0);
			if (xDispatcher.is())
				xDispatcher->dispatch(aParentUrl, ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue>());
		}
		break;

		default:
			SbaXDataBrowserController::Execute(nId);
			break;
	}
}

//------------------------------------------------------------------------------
void SbaTableQueryBrowser::SendInfo(sal_uInt16 nSlotId)
{
	if (!getContent() || !isValidCursor())
		return;

	SbaGridControl* pGrid = getContent()->getVclControl();

	// build a SbaSelectionList according to the currently selected rows
	if (m_pSelectionList)
		m_pSelectionList->Clear();
	else
	{
		m_pSelectionList = new SbaSelectionList;
		m_pSelectionList->AddRef();
	}

	if (!pGrid->IsAllSelected())
	{
		MultiSelection* pSelection = (MultiSelection*)pGrid->GetSelection();
		// Yes, we're casting away the 'const' modifier. This is because the First-/NextSelected methods of
		// MultiSelection aren't const and we need to access them ...
		if (pSelection != NULL)
		{
			// create and fill the selection list with all selected rows
			long nIdx = pSelection->FirstSelected();
			while (nIdx >= 0)
			{
				m_pSelectionList->Insert((void*)(nIdx+1), LIST_APPEND);
				nIdx = pSelection->NextSelected();
			}
		}
		else
		{
			// -1 indicates that no rows are selected
			m_pSelectionList->Insert((void*)(-1), LIST_APPEND);
		}
	}

	// the applications need the db title as favorite ('database link' in SBA-terminology)
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xDataSourceProps(getDataSource(), ::com::sun::star::uno::UNO_QUERY);
	String sDBAlias = EnsureDBLink(GetFormDatabase(xDataSourceProps), sal_True /* allow ui */, sal_True /* really need an alias */ );
	if (!sDBAlias.Len())
		// the user did not allow us to create an alias
		return;

	// for the current SQL-statement we ask ...
	String sCurrentStatement;
	::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xFormSet(getDataSource(), ::com::sun::star::uno::UNO_QUERY);
	if (getParser().is())
	{	// ... our parser if we have one
		sCurrentStatement = (const sal_Unicode*)getParser()->getComposedQuery();
	}
	else
	{	// ... or our data source (which will be sufficient if we have no parser because the data source
		// can't be filtered or sorted without it)
		if (xFormSet.is())
			sCurrentStatement = (const sal_Unicode*)::utl::getString(xFormSet->getPropertyValue(PROPERTY_ACTIVECOMMAND));
	}

	// to behave like when dragging rows (which should have the same effect) we need to
	// do a further modification on the statement

	sal_Int32 nType = ::com::sun::star::sdb::CommandType::TABLE;
	::rtl::OUString sFilter, sSort;
	try
	{
		nType = ::utl::getINT32(xFormSet->getPropertyValue(PROPERTY_COMMANDTYPE));
		sFilter = ::utl::getString(xFormSet->getPropertyValue(PROPERTY_FILTER));
		sSort = ::utl::getString(xFormSet->getPropertyValue(PROPERTY_ORDER));
	}
	catch(...)
	{
		DBG_ERROR("SbaTableQueryBrowser::SendInfo : could not retrieve a needed data source property !");
	}
	
	if (::com::sun::star::sdb::CommandType::QUERY == nType)
	{	// check if it is filtered or sorted
		if (getDefinition()->Name().Len() && (!getParser().is() || (!sFilter.len() && !sSort.len())))
			// native query or query with the 'original' statement -> don't send the statement
			sCurrentStatement.Erase();
	}
	SfxStringItem aDatabaseItem(SID_ATTR_SBA_DATABASE, sDBAlias);
	SfxStringItem aNameItem(SID_ATTR_SBA_DBOBJ_NAME, getDefinition()->Name());
	SfxStringItem aStatementItem(SID_ATTR_SBA_STATEMENT, sCurrentStatement);
	SbaSelectionItem aSelectionItem(SID_ATTR_SBA_SELECTION,
		m_pSelectionList && m_pSelectionList->Count() ? m_pSelectionList : (SbaSelectionList*)NULL);

	SFX_DISPATCHER().Execute(nSlotId,SFX_CALLMODE_ASYNCHRON,
							 (const SfxPoolItem*)&aDatabaseItem,
							 (const SfxPoolItem*)&aNameItem,
							 (const SfxPoolItem*)&aStatementItem,
							 (const SfxPoolItem*)&aSelectionItem,
							 0L);
}

//------------------------------------------------------------------------------
void SbaTableQueryBrowser::StateChanged(sal_uInt16 nSID, SfxItemState eState, const SfxPoolItem* pState )
{
	if (!getContent() || !getContent()->getToolBox())
		return;

	ToolBox* pTB = getContent()->getToolBox();

	switch (nSID)
	{
		case SID_SBA_BRW_INSERT:
		case SID_SBA_BRW_UPDATE:
		case SID_SBA_BRW_MERGE:
		{
			if (eState >= SFX_ITEM_AVAILABLE)
			{
				if (!pTB->IsItemVisible(nSID))
					pTB->ShowItem(nSID);

				SfxBoolItem* pItem = PTR_CAST(SfxBoolItem, pState);
				if (!pItem)
				{
					DBG_ERROR("Falsches Item an den Sba-Browser");
					return;
				}

				sal_Bool bEnable = isValidCursor();	// it won't work without a data source
				bEnable = bEnable && pItem->GetValue();		// slot available
				if (SID_SBA_BRW_MERGE != nSID)
				{
					bEnable = bEnable && getContent()->getVclControl()->GetSelectRowCount();
															// at least on selected row
				}
				::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySet >  xDataSource(getDataSource(), ::com::sun::star::uno::UNO_QUERY);
				try
				{
					bEnable = bEnable && xDataSource.is();

					// disable them for native queries which are not saved within the database
					// 67706 - 23.08.99 - FS
					if (xDataSource.is())
					{
						sal_Int32 nType = ::utl::getINT32(xDataSource->getPropertyValue(PROPERTY_COMMANDTYPE));
						bEnable &= (::utl::getBOOL(xDataSource->getPropertyValue(PROPERTY_USE_ESCAPE_PROCESSING)) || (nType == ::com::sun::star::sdb::CommandType::QUERY));
					}
				}
				catch(...)
				{
				}
				
				pTB->EnableItem(nSID, bEnable);
			}
			else
				pTB->HideItem(nSID);

			// we have a translations of these slots into dispatchable URLs, so we have to notify the objects
			// listening to these urls
			InvalidateFeature(nSID);
		}
		break;

		case SID_SBA_BRW_STATE:
			if (eState >= SFX_ITEM_AVAILABLE && pState)
			{
				SfxUInt16Item* pItem = PTR_CAST(SfxUInt16Item, pState);
				if (!pItem)
				{
					DBG_ERROR("Falsches Item an den Sba-Browser");
					return;
				}
				switch (pItem->GetValue())
				{
					case SID_SBA_BRW_INSERT:
					case SID_SBA_BRW_UPDATE:
					case SID_SBA_BRW_MERGE:
						SendInfo(pItem->GetValue());
				}
			}
	}
}

