/*************************************************************************
 *
 *  $RCSfile: OptionItems.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _ISOLANG_HXX
#include <tools/isolang.hxx>
#endif
#ifndef _SBA_OPTION_ITEMS_HXX_
#include "OptionItems.hxx"
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
//#ifndef _USR_SERVICES_HXX
//#include <usr/services.hxx>
//#endif
#ifndef _COM_SUN_STAR_UTIL_XLOCALIZEDALIASES_HPP_
#include <com/sun/star/util/XLocalizedAliases.hpp>
#endif
#ifndef _SDB_SDBTOOLS_HXX
#include <sdb/sdbtools.hxx>
#endif
#ifndef _TOOLS_INTN_HXX
#include <tools/intn.hxx>
#endif

//------------------------------------------------------------------------------
SbaDatabaseNamesItem::SbaDatabaseNamesItem(sal_uInt16 _nWhich, const ::com::sun::star::uno::Reference< ::com::sun::star::util::XLocalizedAliases >& _rxContext)
	:SfxPoolItem(_nWhich)
	,m_xContext(_rxContext)
{
	DBG_ASSERT(m_xContext.is(), "SbaDatabaseNamesItem::SbaDatabaseNamesItem : please specify a context to work with !");
}

//------------------------------------------------------------------------------
SbaDatabaseNamesItem::SbaDatabaseNamesItem(const SbaDatabaseNamesItem& _rCloneFrom)
	:SfxPoolItem(_rCloneFrom.Which())
	,m_xContext(_rCloneFrom.m_xContext)
{
}

//------------------------------------------------------------------------------
SbaDatabaseNamesItem::~SbaDatabaseNamesItem()
{
}

//------------------------------------------------------------------------------
int SbaDatabaseNamesItem::operator==( const SfxPoolItem& _rComp ) const
{
	if (&_rComp == this)
		return sal_True;

	return m_xContext == ((const SbaDatabaseNamesItem&)_rComp).m_xContext;
}

//------------------------------------------------------------------------------
SfxPoolItem* SbaDatabaseNamesItem::Clone( SfxItemPool *pPool ) const
{
	return new SbaDatabaseNamesItem(*this);
}

