/*************************************************************************
 *
 *  $RCSfile: dbconfig.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/tools.hxx>
#ifndef _SFXITEMITER_HXX //autogen
#include <svtools/itemiter.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _SDB_CMDPARSE_HXX //autogen
#include <sdb/cmdparse.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _SBA_DLGERR_HXX
#include "dlgerr.hxx"
#endif // _SBA_DLGERR_HXX

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif // _SV_MSGBOX_HXX

#include <sbadb.hxx>

#include <ctype.h>
#include "sbaresid.hrc"
#include "sbares.hxx"
#ifdef WNT
#include <sdb/sdbwork.hxx>
#include <sdb/sdbenv.hxx>
#ifndef _SDB_SDBCONN_HXX
#include <sdb/sdbconn.hxx>
#endif //_SDB_SDBCONN_HXX
#endif

#include "sbares.hxx"
#include "sbaconn.hxx"
#include "dbconfig.hxx"
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXINIPROP_HXX
#include <svtools/iniprop.hxx>
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif


static const char *szTypeList = "ADABAS;JDBC;ODBC;ORCL7;DB2;DBF;StarBase;DAO;ADO;TXT;FMK;ADDRBOOK";
enum DBDriverType { DT_NONE, DT_ADABAS, DT_JDBC, DT_ODBC, DT_ORCL7, DT_DB2, DT_DBF, DT_OTER, DT_DAO,DT_ADO, DT_TXT, DT_WSQL, DT_FMK, DT_ADDRBOOK};

static USHORT	arrOdbc[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT	arrJdbc[] =
{	WID_CONN_TYP,WID_CONN_URL,WID_CONN_USER_ID,WID_CONN_TABLE,WID_CONN_USER_PWD,
	WID_CONN_CHARSET,WID_CONN_JDBCDRV,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT	arrDbase[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,
	WID_CONN_LONGTABLENAME,WID_CONN_DELETED,WID_CONN_CHARSET,WID_CONN_ISDIR,0
};
static USHORT	arrText[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,
	WID_CONN_FIX,WID_CONN_HDR,WID_CONN_CHARSET,WID_CONN_DEL,WID_CONN_STR,
	WID_CONN_ISDIR, WID_CONN_DATEDIR, WID_CONN_DATESEP, WID_CONN_DATEZERO,
	WID_CONN_DATEFOUR, WID_CONN_TIMEDEL, WID_CONN_DECDEL, WID_CONN_THODEL,
	WID_CONN_EXT, 0
};
static USHORT	arrDB2[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT	arrADABAS[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,
	WID_CONN_SHUTSERVICE,WID_CONN_DATAINC,WID_CONN_CTRLUSER,WID_CONN_CTRLPWD,WID_CONN_CACHESIZE,0
};
static USHORT	arrADDRBOOK[] =
{	WID_CONN_TYP,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT	arrADO[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,WID_CONN_USER_PWD,
	WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,WID_CONN_PROVIDER,0
};
static USHORT	arrWsql[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,0
};
static USHORT	arrFmk[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_FETCHALL,WID_CONN_MAXROWS,0
};
static USHORT arrORCL7[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_OPTIONS,WID_CONN_CHARSET,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT arrDAO[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,
	WID_CONN_USER_PWD,WID_CONN_DBPASSWD,WID_CONN_SYSTEMDB,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT arrOTER[] =
{	WID_CONN_TYP,WID_CONN_DSN,WID_CONN_TABLE,WID_CONN_USER_ID,WID_CONN_USER_PWD,WID_CONN_PWDSAVE,WID_CONN_DBNEW,
	WID_CONN_MULTI_USER_ON,WID_CONN_NEW_ADMIN_PWD,WID_CONN_TRANSACT,WID_CONN_HAS_OWNER,WID_CONN_ORIG_ADMIN_PWD,
	WID_CONN_ADMIN_PWD,WID_CONN_ADMIN_ID,WID_CONN_NEW_ADMIN_ID,WID_CONN_ASK_WHEN_EMPTY_PWD,0
};
static USHORT	*arrWidList[DT_ADDRBOOK] =//*arrWidList[DT_ORCL7] =
{
	arrADABAS,arrJdbc,arrOdbc,arrORCL7,arrDB2,arrDbase,arrOTER,arrDAO,arrADO,arrText,arrWsql,arrFmk,arrADDRBOOK
};

static const char szAddressName[] = "Address";


//------------------------------------------------------------------------------

static DBDriverType FindDBDriverType( const String& rType )
{
	DBDriverType	eRet = DT_NONE;
	String		aList;
	aList.AssignAscii( szTypeList );
	xub_StrLen nCnt = aList.GetTokenCount();

	for( xub_StrLen i=0 ; i<nCnt ; i++ )
	{
		if( aList.GetToken(i).EqualsIgnoreCaseAscii( rType ))
		{
			eRet = (DBDriverType)(i+1);
			break;
		}
	}

	return eRet;
}

//------------------------------------------------------------------------------

static BOOL IsValidWhich( DBDriverType eType, USHORT nWhich )
{
	int		nIdx = (int)eType - 1;
	BOOL	bResult = FALSE;

	if( nIdx >= 0 )
	{
		USHORT*	pArr = arrWidList[ nIdx ];

		while( *pArr && *pArr!=nWhich ) pArr++;

		bResult = (*pArr == nWhich);
	}

	return bResult;
}

//------------------------------------------------------------------------------

DBG_NAME( SbaDBConfig );

struct OptionKey
{
	String		aKey;
	USHORT		nWhich;
	OptionKey( const String& rS, USHORT nW )
		{ aKey = rS; nWhich=nW; }
};

static SfxItemInfo __READONLY_DATA aItemInfos[] =
{	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0},
	{0,0}
};

DECLARE_LIST( OptionKeyList, OptionKey* );

//==================================================================

SbaDBConfig::SbaDBConfig(const String& rFileName, BOOL bReadOnly, const String& rKey, const String& rConnect,SbaDatabase* pDatabase)
			:pPool(0)
			,ppPoolDefaults(0)
			,pOptionKeyList(0)
			,aKey(rKey)
			,aConnectionStr(rConnect)
			,aFileName(rFileName)
			,p_mDatabase(pDatabase)
{
	DBG_CTOR( SbaDBConfig, NULL );
	pOptionKeyList = new OptionKeyList;
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("typ"), WID_CONN_TYP ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("DSN"), WID_CONN_DSN ), LIST_APPEND ); // mu"ssen gros" bleiben
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("UID"), WID_CONN_USER_ID ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("PWD"), WID_CONN_USER_PWD ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("charset"), WID_CONN_CHARSET ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("fix"), WID_CONN_FIX ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("hdr"), WID_CONN_HDR ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("del"), WID_CONN_DEL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("str"), WID_CONN_STR ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("datedir"), WID_CONN_DATEDIR ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("datesep"), WID_CONN_DATESEP ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("datezero"), WID_CONN_DATEZERO ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("datefour"), WID_CONN_DATEFOUR ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("timedel"), WID_CONN_TIMEDEL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("decdel"), WID_CONN_DECDEL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("isdir"), WID_CONN_ISDIR ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("options"), WID_CONN_OPTIONS ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("table"), WID_CONN_TABLE ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("pwdsave"), WID_CONN_PWDSAVE ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("dbase4"), WID_CONN_DBASE4 ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("deleted"), WID_CONN_DELETED ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("fetchall"), WID_CONN_FETCHALL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("maxrows"), WID_CONN_MAXROWS ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("thodel"), WID_CONN_THODEL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("ext"), WID_CONN_EXT ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("nofilenamelimit"), WID_CONN_LONGTABLENAME ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("url"), WID_CONN_URL ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("jdbcdrv"), WID_CONN_JDBCDRV ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("dbnew"), WID_CONN_DBNEW ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("multiuser"), WID_CONN_MULTI_USER_ON ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("newpwd"), WID_CONN_NEW_ADMIN_PWD ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("transact"), WID_CONN_TRANSACT ), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("sdb"), WID_CONN_SYSTEMDB), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("dbpwd"), WID_CONN_DBPASSWD), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("hasowner"), WID_CONN_HAS_OWNER), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("origpwd"), WID_CONN_ORIG_ADMIN_PWD), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("adminpwd"), WID_CONN_ADMIN_PWD), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("adminid"), WID_CONN_ADMIN_ID), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("newadminid"), WID_CONN_NEW_ADMIN_ID), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("askwhenemptypwd"), WID_CONN_ASK_WHEN_EMPTY_PWD), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("PROVIDER"), WID_CONN_PROVIDER), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("DATAINC"), WID_CONN_DATAINC), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("SHUTSERVICE"), WID_CONN_SHUTSERVICE), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("CTRLUSER"), WID_CONN_CTRLUSER), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("CTRLPWD"), WID_CONN_CTRLPWD), LIST_APPEND );
	pOptionKeyList->Insert( new OptionKey( String::CreateFromAscii("CACHESIZE"), WID_CONN_CACHESIZE), LIST_APPEND );
	

	ppPoolDefaults = new SfxPoolItem* [WID_CONN_LAST-WID_CONN_FIRST];

	International aInt = Application::GetAppInternational();

	USHORT	nIdx = 0;
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_TYP, String::CreateFromAscii("ADABAS") );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_DSN, String() );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_USER_ID, String() );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_USER_PWD, String() );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_CHARSET, String::CreateFromAscii("IBMPC") );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_FIX );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_HDR, TRUE );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_DEL, ';' );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_STR, '"' );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_DATEDIR, String::CreateFromAscii("DMY") );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_DATESEP, '.' );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_DATEZERO );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_DATEFOUR );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_TIMEDEL, ':' );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_DECDEL, aInt.GetNumDecimalSep());
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_ISDIR, TRUE );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_OPTIONS, String() );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_TABLE, String::CreateFromAscii("*") );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_PWDSAVE );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_DBASE4 );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_DELETED, FALSE );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_ALIAS, String() );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_MODIFY, !bReadOnly);
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_FETCHALL );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_MAXROWS, String::CreateFromAscii("2000") );
	ppPoolDefaults[nIdx++] = new SfxUInt16Item( WID_CONN_THODEL, aInt.GetNumThousandSep());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_EXT,String::CreateFromAscii("txt"));
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_FILENAME, rFileName);
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_LONGTABLENAME, FALSE );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_URL, String::CreateFromAscii("jdbc:") );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_JDBCDRV, String::CreateFromAscii("sun.jdbc.odbc.JdbcOdbcDriver") );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_DBNEW);
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_MULTI_USER_ON,FALSE);
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_NEW_ADMIN_PWD, String() );
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_TRANSACT);
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_DBPASSWD, String());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_SYSTEMDB, String());
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_HAS_OWNER);
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_ORIG_ADMIN_PWD, String());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_ADMIN_PWD, String());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_ADMIN_ID, String());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_NEW_ADMIN_ID, String());
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_ASK_WHEN_EMPTY_PWD );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_PROVIDER, String());
	ppPoolDefaults[nIdx++] = new SfxInt32Item(  WID_CONN_DATAINC,20);
	ppPoolDefaults[nIdx++] = new SfxBoolItem( WID_CONN_SHUTSERVICE );
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_CTRLUSER, String());
	ppPoolDefaults[nIdx++] = new SfxStringItem( WID_CONN_CTRLPWD, String());
	ppPoolDefaults[nIdx++] = new SfxInt32Item(  WID_CONN_CACHESIZE,4);
	

	pPool = new SfxItemPool( String( String::CreateFromAscii("dummy") ) ,WID_CONN_FIRST,	WID_CONN_LAST-1, aItemInfos, ppPoolDefaults);
}

//------------------------------------------------------------------------------

SbaDBConfig::~SbaDBConfig()
{
	DBG_DTOR( SbaDBConfig, NULL );
	ULONG i;

	if (pPool)
	{
		pPool->ReleaseDefaults();
		delete pPool;
		for (i=0 ; i<(WID_CONN_LAST-WID_CONN_FIRST) ; i++)
			delete ppPoolDefaults[i];

		delete [] ppPoolDefaults;
	}

	if (pOptionKeyList)
	{
		for (i=0 ; i<pOptionKeyList->Count() ; i++)
			delete pOptionKeyList->GetObject( i );
		pOptionKeyList->Clear();
		delete pOptionKeyList;
	}
}

//------------------------------------------------------------------------------

void SbaDBConfig::ParseArgString( SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	CommandParser	aParser( aConnectionStr, ';', '=', TRUE );
	String			aLeaveList;

	DBDriverType		eType = FindDBDriverType( aParser.OptionString(String::CreateFromAscii("typ")) );//XXX

	for( ULONG i=0 ; i<pOptionKeyList->Count() ; i++ )
	{
		OptionKey* pKey = pOptionKeyList->GetObject( i );
		USHORT	nWhich = pKey->nWhich;

		if( ! IsValidWhich( eType, nWhich ) )//XXX
			continue;

		String	aKey( pKey->aKey );

		switch( nWhich )
		{
			case WID_CONN_TYP:
			case WID_CONN_DSN:
			case WID_CONN_EXT:
			case WID_CONN_USER_ID:
			case WID_CONN_USER_PWD:
			case WID_CONN_URL:
			case WID_CONN_JDBCDRV:
			case WID_CONN_CHARSET:
			case WID_CONN_DATEDIR:
			case WID_CONN_MAXROWS:
			case WID_CONN_NEW_ADMIN_PWD:
			case WID_CONN_DBPASSWD:
			case WID_CONN_SYSTEMDB:
			case WID_CONN_ORIG_ADMIN_PWD:
			case WID_CONN_ADMIN_PWD:
			case WID_CONN_ADMIN_ID:
			case WID_CONN_NEW_ADMIN_ID:
			case WID_CONN_PROVIDER:
			case WID_CONN_CTRLUSER:
			case WID_CONN_CTRLPWD:
			{
				aLeaveList += aKey;
				aLeaveList += ';';
				String	aTxt(aParser.OptionString(aKey));
				rSet.Put( (const SfxPoolItem&) SfxStringItem( nWhich, aTxt ) );
			}
			break;
			case WID_CONN_TABLE:
			{
				aLeaveList += aKey;
				aLeaveList += ';';
				String	aTxt = aParser.OptionString(aKey);
				if (!aParser.Exists(aKey))
					rSet.Put( (const SfxPoolItem&) SfxStringItem( nWhich, String::CreateFromAscii("*") ));
				else
				{
					String aTxt(aParser.OptionString(aKey));
					rSet.Put( (const SfxPoolItem&) SfxStringItem( nWhich, aTxt ) );
				}
			}
			break;
			case WID_CONN_HAS_OWNER:
			case WID_CONN_HDR:
			case WID_CONN_FIX:
			case WID_CONN_DBNEW:
			case WID_CONN_MULTI_USER_ON:
			case WID_CONN_TRANSACT:
			case WID_CONN_DATEZERO:
			case WID_CONN_DATEFOUR:
			case WID_CONN_ISDIR:
//			case WID_CONN_PWDSAVE:
			case WID_CONN_DBASE4:
			case WID_CONN_DELETED:
			case WID_CONN_LONGTABLENAME:
			case WID_CONN_FETCHALL:
			case WID_CONN_ASK_WHEN_EMPTY_PWD:
			case WID_CONN_SHUTSERVICE:
			{
				aLeaveList += aKey;
				aLeaveList += ';';
				BOOL	aBool(aParser.OptionBool(aKey));
//				if( aBool )//XXX
					rSet.Put( (const SfxPoolItem&) SfxBoolItem( nWhich, aBool ) );
			}
			break;

			case WID_CONN_DEL:
			case WID_CONN_STR:
			case WID_CONN_DATESEP:
			case WID_CONN_TIMEDEL:
			case WID_CONN_DECDEL:
			case WID_CONN_THODEL:
			{
				String	aTxt(aParser.OptionString(aKey));
				aLeaveList += aKey;
				aLeaveList += ';';
				UINT16 aInt(0);

				if( isdigit(aTxt.GetChar(0) ))
				{
					aInt = (UINT16)aParser.OptionInt(aKey);
				}
				else
				{
					aInt = (UINT16)aTxt.GetChar(0);
				}

//				if( aInt )//XXX
					rSet.Put( (const SfxPoolItem&) SfxUInt16Item( nWhich, aInt ) );
			}
			break;
			case WID_CONN_DATAINC:
			case WID_CONN_CACHESIZE:
				{
					String	aTxt(aParser.OptionString(aKey));
					aLeaveList += aKey;
					aLeaveList += ';';
					INT32 aInt(0);

					if( isdigit(aTxt.GetChar(0) ))
					{
						aInt = (INT32)aParser.OptionInt(aKey);
					}
					rSet.Put( (const SfxPoolItem&) SfxInt32Item( nWhich, aInt ) );
				}
				break;
		}
	}
	String	aOptions;
	aParser.Compose( aOptions, aLeaveList );
	rSet.Put( (const SfxPoolItem&)SfxStringItem( WID_CONN_OPTIONS, aOptions ) );

#ifdef WNT
	// zum Schluss noch fuer die Kompatiblitaet : unter StarBase sind jetzt der Admin und der normale Benutzter getrennt, aber alte
	// Datenbanken haben die neuen Felder nicht in ihrem DSN-String ...
	// nur bei StarBase ...
	String strConnType = ((const SfxStringItem&)rSet.Get(WID_CONN_TYP)).GetValue();
	if(strConnType.EqualsAscii("StarBase"))
	{
		// nur, wenn ein HasOwner gesetzt ist ...
		BOOL bHasOwner = ((const SfxBoolItem&)rSet.Get(WID_CONN_HAS_OWNER)).GetValue();
		if (bHasOwner)
		{
			// aber nicht der Admin und das Admin-Pwd
			String strAdmin = ((const SfxStringItem&)rSet.Get(WID_CONN_ADMIN_ID)).GetValue();
			String strAdminPwd = ((const SfxStringItem&)rSet.Get(WID_CONN_ADMIN_PWD)).GetValue();
			if (!strAdmin.Len() || !strAdminPwd.Len())
			{
				String strUserId = ((const SfxStringItem&)rSet.Get(WID_CONN_USER_ID)).GetValue();
				rSet.Put(SfxStringItem(WID_CONN_ADMIN_ID, strUserId));

				String strUserPwd = ((const SfxStringItem&)rSet.Get(WID_CONN_USER_PWD)).GetValue();
				rSet.Put(SfxStringItem(WID_CONN_ADMIN_PWD, strUserPwd));
			}
		}
	}

#endif
}
#define GET_ATTR(c,w)	(const c*)&(aSet.Get( (w) ))
//-----------------------------------------------------------------------------
BOOL GetDbNameFromDsn(const String& _rDsn,String &rDB)
{
	rDB = _rDsn.GetToken(0,':');
	BOOL bStartServer = TRUE;
	if(rDB.Len() && _rDsn.GetTokenCount(':') >= 2)
	{
		sal_uInt32 nLen = 255;
		rtl_uString *pHostName = new rtl_uString[nLen];
		osl_getLocalHostname(&pHostName);
		String aHst(pHostName);
		delete pHostName;
		if(aHst.CompareTo(rDB,rDB.Len()) != COMPARE_EQUAL)
			bStartServer = FALSE;
		else
			rDB = _rDsn.GetToken(1,':');
	}
	else if(_rDsn.GetTokenCount(':') >= 2)
		rDB = _rDsn.GetToken(1,':');
	return bStartServer;
}
//------------------------------------------------------------------------------
INT32 SbaDBConfig::ReadAdabasSettings(const String &_rDsn)
{
	// try to seperate the hostname from the database name
	
	String aDBName;
	if(!GetDbNameFromDsn(_rDsn,aDBName) || !_rDsn.Len())
		return 4;

	DirEntry aEntry;
	aEntry = aEntry.TempName(FSYS_KIND_FILE);
	String aFileName = aEntry.GetFull();

	::rtl::OUString sSwitch = ::rtl::OUString::createFromAscii("-c"), sDBName(aDBName), sEntry(aEntry.GetFull());
	::vos::OArgumentList aArgumentList(3,
										&sSwitch,
										&sDBName,
										&sEntry);
	
	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String ADABAS_BATCHFILE = aIniManProp.GetIniManager()->GetProgramPath();
	(ADABAS_BATCHFILE += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	ADABAS_BATCHFILE.AppendAscii(".exe");
#endif

	::vos::OProcess aApp1( ADABAS_BATCHFILE, String::CreateFromAscii(getenv("DBWORK")) );
	::vos::OProcess::TProcessError eError = aApp1.execute( 
		(::vos::OProcess::TProcessOption)
		(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
	
	INT32 nValue=4;
	if(::vos::OProcess::E_None == eError)
	{
		ByteString aValue;
		SvFileStream aFileStream(aFileName,STREAM_READ);
		BOOL bRead = FALSE;
		if(!aFileStream.IsEof())
			bRead = aFileStream.ReadLine(aValue);

		if(bRead)
		{
			nValue = (INT32)aValue.ToInt32();
			nValue = nValue / 256;
		}
	}
	aEntry.Kill();
	return nValue;
}

//------------------------------------------------------------------------------
void SbaDBConfig::SetAdabasSettings(const String &_rDsn,INT32 _nValue,const String &_Usr,const String &_Pwd)
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	String aDBName;
	if(!GetDbNameFromDsn(_rDsn,aDBName))
		return;
	
	String aValue = String::CreateFromInt32(_nValue*256);
	::rtl::OUString sRtlParam = ::rtl::OUString::createFromAscii("-p");
	::rtl::OUString sRtlDbName(aDBName);
	::rtl::OUString sRtlValue = ::rtl::OUString::valueOf(sal_Int32(_nValue*256));
	::rtl::OUString sRtlUsr(_Usr);
	::rtl::OUString sRtlPwd(_Pwd);

	::vos::OArgumentList aArgumentList(3,
										&sRtlParam,
										&sRtlDbName,
										&sRtlValue,
										&sRtlUsr,
										&sRtlPwd);
	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String ADABAS_BATCHFILE = aIniManProp.GetIniManager()->GetProgramPath();
	(ADABAS_BATCHFILE += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	ADABAS_BATCHFILE.AppendAscii(".exe");
#endif

	::vos::OProcess aApp1( ADABAS_BATCHFILE, String::CreateFromAscii(getenv("DBWORK")));
	::vos::OProcess::TProcessError eError = aApp1.execute( 
		(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
	
}
//------------------------------------------------------------------------------
void SbaDBConfig::SetStarBaseDep(SfxItemSet &aSet)
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
#ifdef WNT
	// StarBase Eigenschaften werden gesetzt
	SfxStringItem aTypItem( (const SfxStringItem&)aSet.Get( WID_CONN_TYP ) );
	if(aTypItem.GetValue().EqualsAscii("StarBase"))
	{
		SfxBoolItem aNewDbItem( (const SfxBoolItem&)aSet.Get( WID_CONN_DBNEW ) );

		SdbEnvironmentRef xEnv;
		if(aNewDbItem.GetValue())
		{ // falls DB neu, dann Resourcen kopieren
			SdbWorkspace *xWsp = xEnv->OpenWorkspace(0);
			xWsp->CreateNativeDatabase(aConnectionStr);
			aSet.Put( SfxBoolItem( WID_CONN_DBNEW ) );
		}
		else
		{ // pruefen ob Pwd gesetzt
			SfxStringItem aOldAdmin( (const SfxStringItem&)aSet.Get( WID_CONN_ADMIN_ID ) );
			SfxStringItem aNewAdmin( (const SfxStringItem&)aSet.Get( WID_CONN_NEW_ADMIN_ID ) );
			String strOldAdmin(aOldAdmin.GetValue());
			String strNewAdmin(aNewAdmin.GetValue());

			SfxStringItem aOrigAdminPwd( (const SfxStringItem&)aSet.Get(WID_CONN_ORIG_ADMIN_PWD));
			SfxStringItem aNewAdminPwd( (const SfxStringItem&)aSet.Get(WID_CONN_NEW_ADMIN_PWD));
			String strOldAdminPwd(aOrigAdminPwd.GetValue());
			String strNewAdminPwd(aNewAdminPwd.GetValue());

			// -------------------------------------------------
			// kuemmern wir uns zuerst um einen Eigentumswechsel
			if (strOldAdmin!= strNewAdmin)
			{
#if DBG_UTIL || DEBUG
				// fuer Kompatibilitaet : wenn das HasOwner-Item FALSE sagt, muss die AdminID der Leerstring sein (und vice versa)
				SfxBoolItem aHasOwner( (const SfxBoolItem&)aSet.Get( WID_CONN_HAS_OWNER ) );
				DBG_ASSERT((aHasOwner.GetValue() == TRUE) == (strOldAdmin.Len() > 0),
					"SbaDBConfig::SetStarBaseDep : unerwartetet : Inkonsistenz HasOwner<->NewAdminId !");
#endif

				// Umsetzen des Owners
				String strRenameOwner; 
				strRenameOwner.AssignAscii("RENAME OWNER ");
				strRenameOwner += strOldAdmin.Len() ? strOldAdmin : String::CreateFromAscii("PUBLIC");
				strRenameOwner.AppendAscii(" TO ");
				strRenameOwner += strNewAdmin.Len() ? strNewAdmin : String::CreateFromAscii("PUBLIC");

				SdbConnectionRef xOwnerRenamer;
				SdbStatus aOwnerRenameStatus = ExecuteSQL(strRenameOwner, aSet, strOldAdmin, strOldAdminPwd, xOwnerRenamer);

				// ein HACK : wenn man vor dieser Trennung in Admin/User eine DB angelegt und gleich beim Anlegen einen Admin
				// festgelegt hat, wurde der Admin gesetzt und auch gleich als User eingetragen, aber NICHT das HasOwner-Flag
				// im DSN-String ... Damit habe ich jetzt mit dieser neuen Version keine Moeglichkeit, den Owner ohne Umstaende
				// rauszukriegen.
				// Diese Umstaende - die ich mir jetzt doch machen muss - sind : wenn das Rename nicht klappte, aber das ExecuteSQL
				// wenigstens eine gueltige Connection hinbekommen hat und der Status mir sagt, dass es sich um einen
				// 'Owner identifier is incorrect'-Fehler von Starbase handelt, versuche ich einfach mal als neues Rename-Statement
				// eines, das den aktuellen Nutzer als Owner annimmt
				if (!aOwnerRenameStatus.IsSuccessful())
					if (xOwnerRenamer.Is())
						if (aOwnerRenameStatus.NativeErrorCode() == 267)	// diese 267 ist wohl das schlimmste am ganzen hack ...
						{
							strRenameOwner.SearchAndReplace(strOldAdmin.Len() ? strOldAdmin : String::CreateFromAscii("PUBLIC"),
								((const SfxStringItem&)aSet.Get(WID_CONN_USER_ID)).GetValue());
							// entweder OldAdmin oder NewAdmin - einer hat eine Laenge > 0, damit ist das PUBLIC eindeutig und richtig
							xOwnerRenamer->ExecuteSQL(strRenameOwner);
							aOwnerRenameStatus = xOwnerRenamer->Status();
						}
				// um wirklich nur den oben beschriebenen Fall zu erwischen, muesste ich noch testen, ob der alte Admin leer ist
				// So aber decke ich noch den in #59530 beschriebenen Fall ab : zwei sdb-Dateien verweisen auf die selbe StarBase-Datei,
				// in einer wird der Admin geaendert, dann diese DB geloescht (also NICHT die StarBase-Datei darunter). Dann laesst
				// sich ueber die zweite DB nicht mehr der Admin aendern, da ich ja hier den alten nicht kenne ...
				// Mit diesem Hack kann ich fuer den Fall, dass ich wenigstens ein gueltiges Login zur DB habe, noch einen letzten
				// Versuch unternehmen ...

				// und die Aenderung im ItemSet manifestieren
				if (aOwnerRenameStatus.IsSuccessful())
				{
					SdbStatus aSetPwdStatus;
					aSetPwdStatus.Set(SDB_STAT_SUCCESS);

					if (strNewAdmin.Len())
					{	// wenn der Besitz NICHT in public uebergeht
						String  strSetPassword;strSetPassword.AssignAscii( "SET USER ");
						strSetPassword += strNewAdmin;
						strSetPassword.AppendAscii(" ");

						DBG_ASSERT(strNewAdminPwd.Len(), "SbaDBConfig::SetStarBaseDep : NewAdminID und NewAdminPwd sind nicht konsistent !");
							// wenn sich die NewAdminId gegenueber der AdminId geaendert hat, muss auch dass Passwort gesetzt sein
						strSetPassword += strNewAdminPwd;

						aSetPwdStatus.Set(SDB_STAT_ERROR);
						if (xOwnerRenamer.Is())
						{
							xOwnerRenamer->ExecuteSQL(strSetPassword);
							aSetPwdStatus = xOwnerRenamer->Status();
						}

						if (!aSetPwdStatus.IsSuccessful())
						{
							if (xOwnerRenamer.Is())
								xOwnerRenamer = NULL;	// da ich ja gleich eine neue Connection aufmache, muss die alte geloescht werden
							aSetPwdStatus = ExecuteSQL(strSetPassword, aSet, strNewAdmin, strOldAdminPwd, xOwnerRenamer);
							// das ist absurd, aber bei Oterro hat nach dem Setzen des neuen Owners dieser das Passwort des alten ...
						}
					}

					if (aSetPwdStatus.IsSuccessful())
					{
						// und jetzt alles ins ItemSet packen
						aSet.Put(SfxStringItem(WID_CONN_ADMIN_ID, strNewAdmin));
						if (!strNewAdmin.Len())
							strNewAdminPwd.Erase();	// public-Besitz
						aSet.Put(SfxStringItem(WID_CONN_ADMIN_PWD, strNewAdminPwd));

						// das HasOwner fuer die Kompatibilitaet
						aSet.Put(SfxBoolItem(WID_CONN_HAS_OWNER, strNewAdmin.Len() != NULL));

						// wenn der alte Admin auch der alte Benutzer ist (ich mich also immer unter dem Admin-Namen eingelockt habe),
						// reiche ich die Besitzer-Aenderung auch gleich an die User-Items weiter, damit ich die nicht von
						// Hand umstellen muss
						SfxStringItem aCurrentUser((const SfxStringItem&)aSet.Get(WID_CONN_USER_ID));
						if (strOldAdmin== aCurrentUser.GetValue())
						{
							aSet.Put(SfxStringItem(WID_CONN_USER_ID, strNewAdmin));

							SfxStringItem aCurrentUserPwd((const SfxStringItem&)aSet.Get(WID_CONN_USER_PWD));
							if (!(aCurrentUser.GetValue().Len() && !aCurrentUserPwd.GetValue().Len()))
								aSet.Put(SfxStringItem(WID_CONN_USER_PWD, strNewAdminPwd));
							// wenn es vorher einen Benutzer-Namen gab, aber kein Pwd, setze ich auch das neue Pwd nicht ...
							// (schliesslich hatte der Benutzer entschieden, sein Pwd nicht zu speichern, und das sollte ich
							// respektieren)
						}
					}
					else
					{
						SbaMsgBox(NULL, String(SbaResId(RID_STR_COULDNT_SET_PWD)), aSetPwdStatus).Execute();

						// man koennte jetzt wieder den alten Admin einstellen ... leider wuerde fuer den das Setzen des Passwortes
						// auch schief gehen (mit ziemlicher Sicherheit jedenfalls), also lasse ich den Besitzt lieber wieder an
						// die Oeffentlichkeit uebergehen. Das ist die sicherste Methode - denke ich - eine Aussperrung von der Datenbank
						// zu umgehen
						String strRenameOwner;strRenameOwner.AssignAscii("RENAME OWNER ");
						strRenameOwner += strNewAdmin;
						strRenameOwner.AppendAscii(" TO PUBLIC");

						SdbConnectionRef xMakePublic;
						SdbStatus aOwnerRenameStatus = ExecuteSQL(strRenameOwner, aSet, strNewAdmin, strOldAdminPwd, xMakePublic);
							// auch hier die kleine Kuriositaet am Rande, dass nach dem Setzen eines neuen Owners dieser erst mal
							// das Pwd des alten hat ....
						if (aOwnerRenameStatus.IsSuccessful())
							InfoBox(NULL, String(SbaResId(RID_STR_RESET_ADMIN)));
						else
							DBG_ERROR("SbaDBConfig::SetStarBaseDep : konnte DB nicht oeffentlich machen .... haette NIE passieren duerfen ...");
					}
				}
				else
				{	// schon das Setzen des Benutzers hat nicht geklappt .... da hilft alles nix, also einfach Meldung und wech
					SbaMsgBox(NULL, String(SbaResId(RID_STR_COULDNT_SET_ADMIN)), aOwnerRenameStatus).Execute();

					// das HasOwner fuer die Kompatibilitaet
					aSet.Put( SfxBoolItem(WID_CONN_HAS_OWNER, strOldAdmin.Len() != NULL ) );
					// das AdminPwd und die AdminId brauche ich nicht setzen, das sind ja noch die alten
				}

			}
			else if (strNewAdmin.Len())
			// --------------------------------------------------------------------------------------
			{	// jetzt der Fall, dass der Admin der selbe ist, aber sich das Passwort geaendert hat

				DBG_ASSERT(strNewAdmin== strOldAdmin,
					"SbaDBConfig::SetStarBaseDep : Ablauflogik geaendert ? alter != neuer Admin !");
				// (wenn man an dem else hier ankommt, ist OldAdmin auf jeden Fall identisch NewAdmin)

				if (strOldAdminPwd!= strNewAdminPwd)
				{
					String strSetPassword;
					strSetPassword.AssignAscii("SET USER PASSWORD FOR ");
					strSetPassword += strOldAdmin;
					strSetPassword.AppendAscii(" TO ");
					strSetPassword += strNewAdminPwd;

					// das kann ich jetzt abschicken
					SdbConnectionRef xSetPassword;
					SdbStatus aResult = ExecuteSQL(strSetPassword, aSet, strOldAdmin, strOldAdminPwd, xSetPassword);

					if (aResult.IsSuccessful())
					{
						aSet.Put(SfxStringItem(WID_CONN_ADMIN_PWD, strNewAdminPwd));

						// wenn der Admin gleich dem gerade angegebenen Benutzer ist, reiche ich die Passwort-Aenderung an das
						// UserID-Item weiter
						SfxStringItem aCurrentUser((const SfxStringItem&)aSet.Get(WID_CONN_USER_ID));
						SfxStringItem aCurrentUserPwd((const SfxStringItem&)aSet.Get(WID_CONN_USER_PWD));
						if (strOldAdmin== aCurrentUser.GetValue())
						{
							if (!(aCurrentUser.GetValue().Len() && !aCurrentUserPwd.GetValue().Len()))
								aSet.Put(SfxStringItem(WID_CONN_USER_PWD, strNewAdminPwd));
							// Kommentar siehe analoge Situation ein paar Zeilen weiter oben
						}
					}
					else
						SbaMsgBox(NULL, String(SbaResId(RID_STR_COULDNT_CHANGE_PWD)), aResult).Execute();
				}
			}
		}
		aConnectionStr = BuildArgString(aSet);
	}
#endif
}
//------------------------------------------------------------------------------

BOOL SbaDBConfig::Config()
{
	DBG_CHKTHIS( SbaDBConfig, NULL );

	if (aKey.Len() == 0)	// neuer Eintrag
	{
		pPool->FreezeIdRanges();
		SfxItemSet	aSet( *pPool, TRUE );

		aSet.Put( (const SfxPoolItem&) SfxStringItem(WID_CONN_ALIAS, String(SbaResId(STR_DB_DEFAULTNAME))));
		aSet.Put( (const SfxPoolItem&) SfxBoolItem(WID_CONN_MODIFY, TRUE));
		aSet.Put( (const SfxPoolItem&) SfxStringItem(WID_CONN_FILENAME, String()));
#if !(defined(WIN) || defined(WNT) || ( defined(SOLARIS) && defined(SPARC)) || defined(LINUX))
		aSet.Put( (const SfxPoolItem&) SfxStringItem(WID_CONN_TYP, String::CreateFromAscii("DBF")));
#endif

		// NewAdminId/Pwd auf AdminId/Pwd, damit ich hinterher merke, ob sich was geaendert hat
		aSet.Put((const SfxPoolItem&)SfxStringItem(WID_CONN_NEW_ADMIN_ID, ((const SfxStringItem&)aSet.Get(WID_CONN_ADMIN_ID)).GetValue()));
		aSet.Put((const SfxPoolItem&)SfxStringItem(WID_CONN_NEW_ADMIN_PWD, ((const SfxStringItem&)aSet.Get(WID_CONN_ADMIN_PWD)).GetValue()));

		SbaDbtypeDlg aDlg(Application::GetDefDialogParent(), &aSet, this);

		if (aDlg.Execute())
		{
			const SfxItemSet* pSet = aDlg.GetOutputItemSet();

			SfxItemIter aIter( *pSet );
			const SfxPoolItem* pItem = aIter.FirstItem();

			aSet.Put( *pSet );
			SfxStringItem aAliasItem( (const SfxStringItem&)aSet.Get( WID_CONN_ALIAS ) );
			aKey = aAliasItem.GetValue();

			aConnectionStr = BuildArgString(aSet);

			SfxStringItem aTypItem( (const SfxStringItem&)aSet.Get( WID_CONN_TYP ) );
			if(aTypItem.GetValue().EqualsAscii("ADABAS"))
			{
				const SfxStringItem* pDsnItem = GET_ATTR(SfxStringItem,WID_CONN_DSN);
				String aDSN = pDsnItem->GetValue();
				INT32 nValue = ReadAdabasSettings(aDSN);
				const SfxInt32Item* pValueItem = GET_ATTR(SfxInt32Item,WID_CONN_CACHESIZE);
				if(pValueItem->GetValue() != nValue && nValue != 0)
				{
					const SfxStringItem* pUsrItem = GET_ATTR(SfxStringItem,WID_CONN_CTRLUSER);
					const SfxStringItem* pPwdItem = GET_ATTR(SfxStringItem,WID_CONN_CTRLPWD);
					SetAdabasSettings(aDSN,pValueItem->GetValue(),pUsrItem->GetValue(),pPwdItem->GetValue());
				}
			}
			
#ifdef WNT
			SetStarBaseDep(aSet);
#endif
		}
		else
			return FALSE;
	}
	else
	{
		pPool->FreezeIdRanges();
		SfxItemSet	aSet( *pPool, TRUE );
		ParseArgString( aSet );

		// erst mal testen, ob ich den Typ der Datenbank kenne
		SfxStringItem aType((const SfxStringItem&)aSet.Get(WID_CONN_TYP));
		String sKnownTypes = SdbEnvironmentRef()->ServerTypes();
		BOOL bKnowIt = FALSE;
		for (xub_StrLen i=0; i<sKnownTypes.GetTokenCount(';'); ++i)
			if (sKnownTypes.GetToken(i, ';').EqualsIgnoreCaseAscii(aType.GetValue()))
			{
				bKnowIt = TRUE;
				break;
			}
		if (!bKnowIt)
		{
			String strMessage(SbaResId(RID_STR_UNKNOWN_DBTYPE));
			INT16 nRet = ErrorBox(Application::GetDefDialogParent(), WB_YES_NO, strMessage).Execute();
			if (RET_YES != nRet)
				return FALSE;
		}

		aSet.Put( (const SfxPoolItem&) SfxStringItem( WID_CONN_ALIAS, aKey));
		aSet.Put( (const SfxPoolItem&) SfxStringItem(WID_CONN_FILENAME, aFileName));
		aSet.Put( (const SfxPoolItem&) SfxStringItem(WID_CONN_ORIG_ADMIN_PWD, ((const SfxStringItem&)aSet.Get( WID_CONN_ADMIN_PWD )).GetValue()));

		// NewAdminId/Pwd auf AdminId/Pwd, damit ich hinterher merke, ob sich was geaendert hat
		aSet.Put((const SfxPoolItem&)SfxStringItem(WID_CONN_NEW_ADMIN_ID, ((const SfxStringItem&)aSet.Get(WID_CONN_ADMIN_ID)).GetValue()));
		aSet.Put((const SfxPoolItem&)SfxStringItem(WID_CONN_NEW_ADMIN_PWD, ((const SfxStringItem&)aSet.Get(WID_CONN_ADMIN_PWD)).GetValue()));

		// if adabas read values from db
		if(aType.GetValue().EqualsAscii("ADABAS"))
		{
			const SfxStringItem* pDsnItem = GET_ATTR(SfxStringItem,WID_CONN_DSN);
			if(pDsnItem && pDsnItem->GetValue().Len())
			{
				INT32 nValue = ReadAdabasSettings(pDsnItem->GetValue());
				aSet.Put( (const SfxPoolItem&) SfxInt32Item( WID_CONN_CACHESIZE, nValue));
			}
		}

		SbaDbtypeDlg	aDlg(Application::GetDefDialogParent(), &aSet, this);

		if (aDlg.Execute())
		{
			aSet.Put( *aDlg.GetOutputItemSet() );

			SfxStringItem	aAliasItem( (const SfxStringItem&)aSet.Get( WID_CONN_ALIAS ) );
			aKey = aAliasItem.GetValue();

			SfxStringItem aTypeItem = (const SfxStringItem&)aSet.Get( WID_CONN_TYP );
			if(aTypeItem.GetValue().EqualsAscii("ADABAS"))
			{
				const SfxStringItem* pDsnItem = GET_ATTR(SfxStringItem,WID_CONN_DSN);
				if(pDsnItem && pDsnItem->GetValue().Len())
				{
					String aDSN = pDsnItem->GetValue();
					INT32 nValue = ReadAdabasSettings(aDSN);
					const SfxInt32Item* pValueItem = GET_ATTR(SfxInt32Item,WID_CONN_CACHESIZE);
					if(pValueItem->GetValue() != nValue && nValue != 0)
					{
						const SfxStringItem* pUsrItem = GET_ATTR(SfxStringItem,WID_CONN_CTRLUSER);
						const SfxStringItem* pPwdItem = GET_ATTR(SfxStringItem,WID_CONN_CTRLPWD);
						SetAdabasSettings(aDSN,pValueItem->GetValue(),pUsrItem->GetValue(),pPwdItem->GetValue());
					}
				}
			}

#ifdef WNT
			SetStarBaseDep(aSet);
#endif
			aConnectionStr = BuildArgString(aSet);
				// NACH dem SetStarBaseDep !
		}
		else
			return FALSE;
	}
	return TRUE;
}

//------------------------------------------------------------------------------

String SbaDBConfig::GetConnectionStr()
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	return aConnectionStr;
}

//------------------------------------------------------------------------------

String SbaDBConfig::GetConnectionKey()
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	return aKey;
}

//------------------------------------------------------------------------------
String QuoteString(const String & rStr)
{
	String aTxt;
	if(rStr.GetTokenCount() >= 2 || rStr.GetTokenCount('=') >= 2 )
	{
		aTxt += '"';
		aTxt += rStr;
		aTxt += '"';
	}
	else
		aTxt += rStr;
	return aTxt;
}
//------------------------------------------------------------------------------
String SbaDBConfig::BuildArgString( const SfxItemSet& rSet )
{
	DBG_CHKTHIS( SbaDBConfig, NULL );

	String			aArgStr;
	SfxStringItem	aDBDriverTypeItem( (const SfxStringItem&)rSet.Get( WID_CONN_TYP ) );
	DBDriverType		eType = FindDBDriverType( aDBDriverTypeItem.GetValue() );
	String			aPassword, aUID;

	for( ULONG i=0 ; i<pOptionKeyList->Count() ; i++ )
	{
		OptionKey* pKey = pOptionKeyList->GetObject( i );
		USHORT	nWhich(pKey->nWhich);

		if( ! IsValidWhich( eType, nWhich ) )
			continue;

		String	aKey( pKey->aKey );
		switch( nWhich )
		{
			case WID_CONN_EXT:
			{
				// auch schreiben wenn nicht drinsteht
				SfxStringItem aStringItem( (const SfxStringItem&)rSet.Get( nWhich ) );
				aArgStr += aKey;
				aArgStr += '=';
				aArgStr += QuoteString(aStringItem.GetValue());
				aArgStr += ';';
			}
			break;
			case WID_CONN_TYP:
			case WID_CONN_USER_ID:
			case WID_CONN_USER_PWD:
			case WID_CONN_URL:
			case WID_CONN_JDBCDRV:
			case WID_CONN_CHARSET:
			case WID_CONN_DATEDIR:
			case WID_CONN_MAXROWS:
			case WID_CONN_NEW_ADMIN_PWD:
			case WID_CONN_SYSTEMDB:
			case WID_CONN_DBPASSWD:
			case WID_CONN_ORIG_ADMIN_PWD:
			case WID_CONN_ADMIN_PWD:
			case WID_CONN_ADMIN_ID:
			case WID_CONN_NEW_ADMIN_ID:
			case WID_CONN_PROVIDER:
			case WID_CONN_CTRLUSER:
			case WID_CONN_CTRLPWD:
			{
				SfxStringItem aStringItem( (const SfxStringItem&)rSet.Get( nWhich ) );
				if( aStringItem.GetValue().Len() )
				{
					aArgStr += aKey;
					aArgStr += '=';
					aArgStr += QuoteString(aStringItem.GetValue());
					aArgStr += ';';
				}
			}
			break;
			case WID_CONN_TABLE:
			{
				SfxStringItem aStringItem( (const SfxStringItem&)rSet.Get( nWhich ) );
				// * steht fuer alle, dann wird keine Configeintrag uebergeben
				if (aStringItem.GetValue() != String::CreateFromAscii("*"))
				{
					aArgStr += aKey;
					aArgStr += '=';
					aArgStr += QuoteString(aStringItem.GetValue());
					aArgStr += ';';
				}
			}
			break;
			case WID_CONN_DSN:
			{
				SfxStringItem aStringItem( (const SfxStringItem&)rSet.Get( nWhich ) );
				if (aStringItem.GetValue().Len() )
				{
					aArgStr += aKey;
					aArgStr += '=';
					aArgStr += QuoteString(aStringItem.GetValue());
					aArgStr += ';';
				}
				// wird kein Pfad angegeben fuer file datenbanken, dann CurrentDir
				else if (eType == DT_DBF ||
						 eType == DT_TXT ||
						 eType == DT_FMK)
				{
					DirEntry aEntry;
					aEntry.ToAbs();
					aArgStr += aKey;
					aArgStr += '=';
					aArgStr += aEntry.GetFull();
					aArgStr += ';';
				}
			} break;
			case WID_CONN_OPTIONS:
			{
				SfxStringItem aStringItem( (const SfxStringItem&)rSet.Get( nWhich ) );
				if( aStringItem.GetValue().Len() )
				{
					aArgStr += QuoteString(aStringItem.GetValue());
					aArgStr += ';';
				}
			}
			break;
			case WID_CONN_HAS_OWNER:
			case WID_CONN_HDR:
			case WID_CONN_FIX:
			case WID_CONN_DBNEW:
			case WID_CONN_MULTI_USER_ON:
			case WID_CONN_TRANSACT:
			case WID_CONN_DATEZERO:
			case WID_CONN_DATEFOUR:
			case WID_CONN_ISDIR:
			case WID_CONN_DBASE4:
			case WID_CONN_DELETED:
			case WID_CONN_LONGTABLENAME:
			case WID_CONN_FETCHALL:
			case WID_CONN_ASK_WHEN_EMPTY_PWD:
			case WID_CONN_SHUTSERVICE:
			{
				SfxBoolItem aBoolItem( (const SfxBoolItem&)rSet.Get( nWhich ) );
				if( aBoolItem.GetValue() )
				{
					aArgStr += aKey;
					aArgStr += ';';
				}
				else
				{
					aArgStr += aKey;
					aArgStr.AppendAscii("=false;");//XXX
				}
			}
			break;

			case WID_CONN_DEL:
			case WID_CONN_STR:
			case WID_CONN_DATESEP:
			case WID_CONN_TIMEDEL:
			case WID_CONN_DECDEL:
			case WID_CONN_THODEL:
			{
				SfxUInt16Item aIntItem( (const SfxUInt16Item&)rSet.Get( nWhich ) );
				if( aIntItem.GetValue() )
				{
					aArgStr += aKey;
					aArgStr += '=';
					aArgStr += String::CreateFromInt32(aIntItem.GetValue());
					aArgStr += ';';
				}
			}
			break;
			case WID_CONN_DATAINC:
			case WID_CONN_CACHESIZE:
				{
					SfxInt32Item aIntItem( (const SfxInt32Item&)rSet.Get( nWhich ) );
					if( aIntItem.GetValue() )
					{
						aArgStr += aKey;
						aArgStr += '=';
						aArgStr += String::CreateFromInt32(aIntItem.GetValue());
						aArgStr += ';';
					}
				}
				break;
			case WID_CONN_PWDSAVE:
				break;

			default:
			DBG_ERROR( "SbaDBConfig::BuildArgString [no which]" );
			break;
		}
	}

	return aArgStr;
}

//------------------------------------------------------------------------------
String SbaDBConfig::GetUniqueName()
{
	aKey = String(ResId(STR_NONAME));
	return aKey;
}

//------------------------------------------------------------------------------
String SbaDBConfig::BuildUserConnectString(SfxItemSet& rSet, const String& strUid, const String& strPwd)
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	SfxStringItem aUidSafety((const SfxStringItem&)rSet.Get(WID_CONN_USER_ID));
	SfxStringItem aPwdSafety((const SfxStringItem&)rSet.Get(WID_CONN_USER_PWD));

	rSet.Put(SfxStringItem(WID_CONN_USER_ID, strUid));
	rSet.Put(SfxStringItem(WID_CONN_USER_PWD, strPwd));

	String strReturn = BuildArgString(rSet);

	rSet.Put(SfxStringItem(WID_CONN_USER_ID, aUidSafety.GetValue()));
	rSet.Put(SfxStringItem(WID_CONN_USER_PWD, aPwdSafety.GetValue()));

	return strReturn;
}

//------------------------------------------------------------------------------
SdbStatus SbaDBConfig::ExecuteSQL(const String& strSQL, SfxItemSet& rSet, const String& strAltUid, const String& strAltPwd, SdbConnectionRef& rConn)
{
	DBG_CHKTHIS( SbaDBConfig, NULL );
	SdbStatus aReturn;

	// erst mal schauen, ob die (eventuell) im mich reingesteckte Datenbank es kann
	if (p_mDatabase)
	{
		if (p_mDatabase->ExecuteSQL(strSQL))
			return p_mDatabase->Status();
		// wenn nicht, wurde ihre Connection vielleicht mit einem Benutzer erstellt, der nicht die Rechte dazu hat
	}

	SdbEnvironmentRef xEnv;

	CommandParser aParser(aConnectionStr, ';', '=', TRUE);
	String strCurrentUserId = aParser.OptionString(String::CreateFromAscii("uid"));
	String strCurrentUserPwd = aParser.OptionString(String::CreateFromAscii("pwd"));
	if (!strCurrentUserId.Len() || strCurrentUserPwd.Len())
	{	// nur, wenn es keinen Benutzer oder (Benutzer und Pwd) gibt, sonst kommt beim Oeffnen der Connection ein Dialog hoch,
		// der nach dem Pwd fragt, und das will ich hier nicht

		// die Datenbank konnte es nicht oder ich hatte keine, also bau' ich selber eine Connection, und zwar mit dem
		// alten Connect-String
		rConn = xEnv->OpenConnection(aConnectionStr);

		if (rConn.Is())
		{
			rConn->ExecuteSQL(strSQL);
			return rConn->Status();
		}
	}

	// und als letztes mit dem alternativen Benutzer
	DBG_ASSERT((strAltUid.Len()>0) == (strAltPwd.Len()>0), "SbaDBConfig::ExecuteSQL : ungueltige Parameter !");
		// entweder voellig ohne Benutzer oder sowohl Pwd als auch Uid, sonst fragt die Connection mit einem Dialog nach dem Pwd

	String strAlternativeAccess = BuildUserConnectString(rSet, strAltUid, strAltPwd);
	rConn = xEnv->OpenConnection(strAlternativeAccess);
	if (rConn.Is())
	{
		rConn->ExecuteSQL(strSQL);
		return rConn->Status();
	}

	aReturn.Set(SDB_STAT_ERROR);
	return aReturn;
}

