/*************************************************************************
 *
 *  $RCSfile: dbprogresshandler.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_DBPROGRESSHANDLER_HXX
#include "dbprogresshandler.hxx"
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif
#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXINIPROP_HXX
#include <svtools/iniprop.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

DBG_NAME(SbaProgressStatusBarControl);
//=========================================================================

void SbaProgressStatusBarControl::ModifyStatus()
{
	TaskStatusFieldItem aItem;
	if(!m_pStatusBar->GetStatusFieldItem( SID_SBA_ADABAS_KERNEL_STATES+m_nPos, aItem ))
	{
		aItem = TaskStatusFieldItem( this, m_aImageList.GetImage(1), m_aHelpText, m_aHelpText, 0 );
		m_pStatusBar->AddStatusFieldItem( SID_SBA_ADABAS_KERNEL_STATES + m_nPos, aItem );
	}
	Image aImage = m_aImageList.GetImage( m_nImageId);
	aItem.SetImage( aImage );
	m_pStatusBar->ModifyStatusFieldItem( SID_SBA_ADABAS_KERNEL_STATES+m_nPos, aItem );
}

// -----------------------------------------------------------------------

SbaProgressStatusBarControl::SbaProgressStatusBarControl(TaskStatusBar& rBar,sal_uInt16 _nPos,const String& _rDBName,
														 const String& _rCtrlUid,const String& _rCtrlPwd) :
	m_pStatusBar	( &rBar )
	,m_aImageList	( SbaResId( RID_IMGLIST_ADABAS_STATE ) )
	,m_nMaxProgress	( 0 )
	,m_nImageId		( 0 )
	,m_aHelpText	(_rDBName)
	,m_CtrlUid		(_rCtrlUid)
	,m_CtrlPwd		(_rCtrlPwd)
	,m_nPos			(_nPos)
	,m_aContextMenu (SbaResId(RID_DBSTATE_POPUPMENU))
{
	DBG_CTOR(SbaProgressStatusBarControl,NULL);
	DBG_ASSERT(m_nPos < 17,"_nPos to great for adabas kernel states");
	TaskStatusFieldItem aItem( this, m_aImageList.GetImage(1), m_aHelpText, m_aHelpText, 0 );
	m_pStatusBar->AddStatusFieldItem( SID_SBA_ADABAS_KERNEL_STATES + m_nPos, aItem );
	if(!m_CtrlPwd.Len() || !m_CtrlUid.Len())
	{
		m_aContextMenu.EnableItem(SID_DBSTATE_RESTART,sal_False);
		m_aContextMenu.EnableItem(SID_DBSTATE_SHUTDOWN,sal_False);
		m_aContextMenu.RemoveDisabledEntries();
	}
}

// -----------------------------------------------------------------------

SbaProgressStatusBarControl::~SbaProgressStatusBarControl()
{
	DBG_DTOR(SbaProgressStatusBarControl,NULL);
}

// -----------------------------------------------------------------------

void SbaProgressStatusBarControl::SetState(KernelState _eState)
{
	m_eState = _eState;
	if(m_eState == DEAD)
		m_nImageId = 1;
	else if(m_eState == COLD)
		m_nImageId = 2;
	else
		m_nImageId = 3;

	m_aContextMenu.EnableItem(SID_DBSTATE_SHUTDOWN,!(m_CtrlPwd.Len() && m_CtrlUid.Len() && m_eState == DEAD));
	//	m_aContextMenu.RemoveDisabledEntries();
	ModifyStatus();
}
// -----------------------------------------------------------------------
void SbaProgressStatusBarControl::EndProgress()
{
	//	ModifyStatus();
	m_pStatusBar->RemoveStatusFieldItem( SID_SBA_ADABAS_KERNEL_STATES +m_nPos);
}
// -----------------------------------------------------------------------
sal_Bool SbaProgressStatusBarControl::Command( sal_uInt16 nItemd, const CommandEvent& rEvt )
{
	if(nItemd != SID_SBA_ADABAS_KERNEL_STATES +m_nPos)
		return ITaskStatusNotify::Command(nItemd,rEvt);
	switch( rEvt.GetCommand() )
	{
		case COMMAND_CONTEXTMENU:
		{
			if (!rEvt.IsMouseEvent())
				return ITaskStatusNotify::Command(nItemd,rEvt);

			switch (m_aContextMenu.Execute(m_pStatusBar, rEvt.GetMousePosPixel()))
			{
				case SID_DBSTATE_RESTART:
					if(!m_CtrlPwd.Len() || !m_CtrlUid.Len())
						return sal_False;
					Restart();
					break;
				case SID_DBSTATE_SHUTDOWN:
					if(!m_CtrlPwd.Len() || !m_CtrlUid.Len())
						return sal_False;
					ShutDown();
					break;
				case SID_DBSTATE_ACTUALIZE:
					Actualize();
					break;
					
			}
			return sal_True;
		}
	}

	return ITaskStatusNotify::Command(nItemd,rEvt);	
}
//---------------------------------------------------------------------------------
void SbaProgressStatusBarControl::Restart()
{
	if(m_eState == WARM && !ShutDown())
		return;

	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String aExe = aIniManProp.GetIniManager()->GetProgramPath();
	(aExe += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	aExe.AppendAscii(".exe");
#endif

	String aName(m_aHelpText.GetToken(1,':'));
	aName.EraseLeadingChars();
	::vos::OProcess::TProcessError eError = ::vos::OProcess::E_None;
	if(m_eState == DEAD)
	{
		::rtl::OUString sRtlParam = ::rtl::OUString::createFromAscii("-k");
		::rtl::OUString sRtlName(aName);
		::vos::OArgumentList aArgumentList(2, &sRtlParam, &sRtlName);

		::vos::OProcess aApp( aExe,String::CreateFromAscii(getenv("DBWORK")));

		eError = aApp.execute( 
			(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );

#if ( defined(SOLARIS) && defined(SPARC)) || defined(LINUX)
		Actualize();
		if(m_eState == DEAD)
		{
			String aX_Clear = String::CreateFromAscii(getenv("DBROOT"));
			aX_Clear.AppendAscii("/bin/x_clear");
			::rtl::OUString sRtlName(aName);
			::vos::OArgumentList aArgumentList2(1,
										&sRtlName);
			::vos::OProcess aApp2( aX_Clear, String::CreateFromAscii(getenv("DBWORK")) );
			eError = aApp2.execute( 
					(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList2 );
			eError = aApp.execute( 
					(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
		}
#endif

	}
	if(eError == ::vos::OProcess::E_None)
	{
		::rtl::OUString sRtlParam = ::rtl::OUString::createFromAscii("-r");
		::rtl::OUString sRtlName(aName);
		::rtl::OUString sRtlUid(m_CtrlUid);
		::rtl::OUString sRtlPwd(m_CtrlPwd);
		::vos::OArgumentList aArgumentList2(4, &sRtlParam, &sRtlName, &sRtlUid, &sRtlPwd);
		
		::vos::OProcess aApp2( aExe,String::CreateFromAscii(getenv("DBWORK")));
		aApp2.execute(
			(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList2 );
	}
	Actualize();
}
//---------------------------------------------------------------------------------
void SbaProgressStatusBarControl::Actualize()
{
	DirEntry aOut(DirEntry().TempName(FSYS_KIND_FILE));

	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String aExe = aIniManProp.GetIniManager()->GetProgramPath();
	(aExe += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	aExe.AppendAscii(".exe");
#endif

	String aName(m_aHelpText.GetToken(1,':'));
	aName.EraseLeadingChars();
	String aFileName = aOut.GetFull();

		::rtl::OUString sRtlParam = ::rtl::OUString::createFromAscii("-d");
		::rtl::OUString sRtlName(aName);
		::rtl::OUString sRtlFileName(aOut.GetFull());
	::vos::OArgumentList aArgumentList2(3, &sRtlParam, &sRtlName, &sRtlFileName);
		
	::vos::OProcess aApp( aExe,String::CreateFromAscii(getenv("DBWORK")));

	aApp.execute( (::vos::OProcess::TProcessOption)
				  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait),aArgumentList2 );

	{
		SvFileStream aOutStream(aOut.GetFull(),STREAM_READ);
		KernelState eState = DEAD;
		sal_Bool bRead = sal_True;
		while(bRead && !aOutStream.IsEof())
		{
			ByteString aLine;
			bRead = aOutStream.ReadLine(aLine);
			if(aLine.Search("WARM") != STRING_NOTFOUND)
			{
				eState = WARM;
				break;
			}
			else if(aLine.Search("COLD") != STRING_NOTFOUND)
			{
				eState = COLD;
				break;
			}
		}
		SetState(eState);
	}
	aOut.Kill();
}
//---------------------------------------------------------------------------------
sal_Bool SbaProgressStatusBarControl::ShutDown()
{
	// is there any user still connected ?
	DirEntry aEntry;
	aEntry = aEntry.TempName(FSYS_KIND_FILE);
	String aFileName = aEntry.GetFull();
	String aName(m_aHelpText.GetToken(1,':'));
	aName.EraseLeadingChars();

	::rtl::OUString sRtlParam = ::rtl::OUString::createFromAscii("-f");
	::rtl::OUString sRtlName(aName);
	::rtl::OUString sRtlFileName(aEntry.GetFull());
	::vos::OArgumentList aArgumentList(3, &sRtlName, &sRtlParam,&sRtlFileName);
		
	

	
	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	String aExe = aIniManProp.GetIniManager()->GetProgramPath();
	(aExe += DirEntry::GetAccessDelimiter()).AppendAscii("kstart");
#if defined(WIN) || defined(WNT)
	aExe.AppendAscii(".exe");
#endif

	::vos::OProcess aApp1( aExe,String::CreateFromAscii(getenv("DBWORK")));
	::vos::OProcess::TProcessError eError = aApp1.execute( 
		(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
	sal_Bool bUserConnected = sal_False;
	{
		SvFileStream aFileStream(aFileName,STREAM_READ);
		ByteString aValue;
		sal_Bool bRead = sal_True;
		while(!bUserConnected && bRead && !aFileStream.IsEof())
		{
			bRead = aFileStream.ReadLine(aValue);
			bUserConnected = aValue.Search("USER") != STRING_NOTFOUND;
		}
	}
	aEntry.Kill();

	if(bUserConnected)
	{
		::vos::OGuard aGuard( Application::GetSolarMutex() );
		InfoBox(NULL,SbaResId(INFO_ADABAS_NO_SHUTDOWN_NOR_RESTART)).Execute();
		return sal_False;
	}

	::rtl::OUString sRtlParam2 = ::rtl::OUString::createFromAscii("-x");
	::rtl::OUString sRtlUid(m_CtrlUid);
	::rtl::OUString sRtlPwd(m_CtrlPwd);
	::vos::OArgumentList aArgumentList2(4, &sRtlParam2, &sRtlName, &sRtlUid, &sRtlPwd);

	::vos::OProcess aApp2( aExe, String::CreateFromAscii(getenv("DBWORK")) );

	eError = aApp2.execute( 
		(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList2 );
	if(eError == ::vos::OProcess::E_None)
	{
		::rtl::OUString sRtlParam3 = ::rtl::OUString::createFromAscii("-t");
		::vos::OArgumentList aArgumentList2(4, &sRtlParam3, &sRtlName, &sRtlUid, &sRtlPwd);

		aApp2.execute( (::vos::OProcess::TProcessOption)::vos::OProcess::TOption_Hidden,aArgumentList2);
	}
	Actualize();
	if(m_eState == DEAD)
		EndProgress();
	return sal_True;
}
DBG_NAME(DBProgressHandler);

//---------------------------------------------------------------------------------
DBProgressHandler::DBProgressHandler() : m_nAsyncState(0)
{
	DBG_CTOR(DBProgressHandler,NULL);	
}

//---------------------------------------------------------------------------------
DBProgressHandler::~DBProgressHandler()
{
	::osl::ClearableMutexGuard aGuard( m_aMutex);
	map<String,SbaProgressStatusBarControl*,::utl::UStringMixLess>::iterator aIter = m_KernelStates.begin();
	for(;aIter != m_KernelStates.end();++aIter)
	{
		SbaProgressStatusBarControl *pStatusBar = (*aIter).second;
		if(pStatusBar)
			delete pStatusBar;
	}
	if (m_nAsyncState)
		Application::RemoveUserEvent(m_nAsyncState);
	m_nAsyncState = 0;
	
	aGuard.clear();
	::osl::MutexGuard aGuard2( m_aMemberMutex);
	DBG_DTOR(DBProgressHandler,NULL);	
}

//---------------------------------------------------------------------------------
void DBProgressHandler::update(const ::com::sun::star::uno::Any& Status) throw( ::com::sun::star::uno::RuntimeException )
{
	::osl::MutexGuard aGuard( m_aMutex);

	sal_Int64 nWrappedPointer;
	if (Status >>= nWrappedPointer)
	{
		m_States.push_back(*reinterpret_cast<AdabasKernelState*>(nWrappedPointer));
		if (!m_nAsyncState)
			m_nAsyncState = Application::PostUserEvent(LINK(this, DBProgressHandler, OnAsyncState));
			// set statusbar
	}
}

//---------------------------------------------------------------------------------
IMPL_LINK(DBProgressHandler, OnAsyncState, void*, EMPTYARG)
{
/*		
	::osl::MutexGuard aGuard2( m_aMemberMutex);
	::osl::MutexGuard aGuard( m_aMutex);
	if(!m_nAsyncState)
		return 0;
	m_nAsyncState = 0;

	for	(	::std::vector< AdabasKernelState >::iterator aIter = m_States.begin();
			aIter < m_States.end();
			++aIter
		)
	{
		::std::map<String,SbaProgressStatusBarControl*,::utl::UStringMixLess>::const_iterator aMapIter = m_KernelStates.find(aIter->m_DBName);
		SbaProgressStatusBarControl *pStatusBar = NULL;
		::vos::OGuard aGuard( Application::GetSolarMutex() );
		if(aMapIter == m_KernelStates.end())
		{
			String aDbName;aDbName.AssignAscii("Adabas D: ");
			aDbName += aIter->m_DBName;
			pStatusBar = new SbaProgressStatusBarControl(*SFX_APP()->GetTaskBar()->GetStatusBar(),m_KernelStates.size(),aDbName,aIter->m_CtrlUid,aIter->m_CtrlPwd);
			m_KernelStates[aIter->m_DBName] = pStatusBar;
		}
		else										 
			pStatusBar = m_KernelStates[aIter->m_DBName];
		pStatusBar->SetState(aIter->m_KernelState);
	}

	m_States.erase(m_States.begin(),m_States.end());
*/
	return 0;
}

