/*************************************************************************
 *
 *  $RCSfile: sbaitems.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#include "sbaitems.hxx"

//==============================================================================
DBG_NAME(SbaSelectionItem);
SbaSelectionItem::SbaSelectionItem( USHORT nWhich ):
	SfxPoolItem( nWhich )
{
	DBG_CTOR(SbaSelectionItem,NULL);
	DBG_ERROR("SbaSelectionItem ctor should not be called");
}

//------------------------------------------------------------------------------
SbaSelectionItem::SbaSelectionItem( USHORT nWhich, const SbaSelectionListRef pNewSelectionList ):
	SfxPoolItem( nWhich )
{
	DBG_CTOR(SbaSelectionItem,NULL);
	pSelectionList = pNewSelectionList;
}

//------------------------------------------------------------------------------
int SbaSelectionItem::operator==( const SfxPoolItem& rItem ) const
{
	DBG_CHKTHIS(SbaSelectionItem,NULL);
	if( rItem.Type() == Type() )
	{
		SbaSelectionItem* pT = (SbaSelectionItem*)&rItem;
		if (pSelectionList.Is() && pT->pSelectionList.Is())
			return *pSelectionList == *pT->pSelectionList;
		else
			return pSelectionList.Is() == pT->pSelectionList.Is();
	}
	return 0;
}

//------------------------------------------------------------------------------
String SbaSelectionItem::GetValueText() const
{
	DBG_CHKTHIS(SbaSelectionItem,NULL);
	String aRetStr;

	if (pSelectionList.Is())
	{
		for( ULONG i=0 ; i<pSelectionList->Count(); i++ )
		{
			aRetStr += String::CreateFromInt32((ULONG)pSelectionList->GetObject(i));
			aRetStr += ';';
		}
		aRetStr.EraseTrailingChars( ';' );
	}
	return aRetStr;
}

//------------------------------------------------------------------------------
SfxPoolItem* SbaSelectionItem::Clone( SfxItemPool *pPool ) const
{
	DBG_CHKTHIS(SbaSelectionItem,NULL);
	return new SbaSelectionItem( Which(), pSelectionList );
}

//------------------------------------------------------------------------------
#if (SUPD >= 346)
USHORT SbaSelectionItem::GetVersion(USHORT) const
#else
USHORT SbaSelectionItem::GetVersion() const
#endif
{
	DBG_CHKTHIS(SbaSelectionItem,NULL);
	return 0x0100;
}

//========================================================================
// class SbaDBDatabaseItem
//========================================================================
TYPEINIT1( SbaDBDatabaseItem, SfxPoolItem );
DBG_NAME(SbaDBDatabaseItem);
//------------------------------------------------------------------------------
SfxPoolItem* SbaDBDatabaseItem::Clone( SfxItemPool *pPool ) const
{
	return new SbaDBDatabaseItem( Which(), xDatabase );
}

//------------------------------------------------------------------------------
int SbaDBDatabaseItem::operator==( const SfxPoolItem& rItem ) const
{
	if( rItem.Type() == Type() )
	{
		return( &xDatabase == PTR_CAST(SbaDBDatabaseItem, &rItem)->GetDatabase() );
	}
	else
		return 0;
}

//========================================================================
// class SbaPointerItem
//========================================================================
TYPEINIT1(SbaPointerItem, SfxPoolItem);
DBG_NAME(SbaPointerItem);

//------------------------------------------------------------------------------
SbaPointerItem::SbaPointerItem( USHORT nWhich, void* pPtr )
	: SfxPoolItem( nWhich ), m_pPtr( pPtr )
{
}

//------------------------------------------------------------------------------
SbaPointerItem::SbaPointerItem( const SbaPointerItem& rSource )
	: SfxPoolItem( rSource.Which() ), m_pPtr( rSource.m_pPtr )
{
}

//------------------------------------------------------------------------------
int SbaPointerItem::operator==( const SfxPoolItem& rItem ) const
{
	return ((SbaPointerItem&)rItem).m_pPtr == m_pPtr;
}

//------------------------------------------------------------------------------
SfxPoolItem* SbaPointerItem::Clone( SfxItemPool * ) const
{
	return new SbaPointerItem( *this );
}


