/*************************************************************************
 *
 *  $RCSfile: sbamod.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: fs $ $Date: 2000/09/20 08:21:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/tools.hxx>
#ifndef _SBA_SBADLL_HXX
#include "sbadll.hxx"
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif

#ifndef _SBA_QRYDS_HXX
#include "qryds.hxx"
#endif

#ifndef _SBA_QRYTXTVS_HXX
#include "qrytxtvs.hxx"
#endif

#ifndef _SBA_QRYBRWVS_HXX
#include "qrybrwvs.hxx"
#endif

#ifndef _SBA_QRYDGNVS_HXX
#include "qrydgnvs.hxx"
#endif

#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SBA_SBAEXPOB_HXX
#include "sbaexpob.hxx"
#endif

#ifndef _SBA_DBDATDEF_HXX
#include "dbdatdef.hxx"
#endif

#include "adtabdlg.hxx"

//==============================================================================

//==============================================================================

TYPEINIT1( SbaModuleDummy, SfxModule );

SFX_IMPL_MODULE_DLL(Sba);

//------------------------------------------------------------------------------
void SbaDLL::Init()
{
	// called directly after loading the DLL
	// do whatever you want, you may use Sd-DLL too

	// the SdModule must be created
	SbaModuleDummy** ppShlPtr = (SbaModuleDummy**) GetAppData(SHL_SBA);
	SfxObjectFactory* pQryFact = (*ppShlPtr)->pSbaQueryDocShFactory;

	delete (*ppShlPtr);
    SbaObject* pSbaObject = new SbaObject( pQryFact, NULL, NULL, NULL, NULL );
	(*ppShlPtr) = pSbaObject;

	// register your view-factories here
	RegisterFactorys();

	NAMESPACE_VOS(OGuard) aGuard(Application::GetSolarMutex());
		// needed for the upcoming vcl dependent registration stuff

	// register your shell-interfaces here
	RegisterInterfaces();

	SbaAddTableDlgManager::RegisterChildWindow();

	// don't register the the address book anymore
	// (szenario : somebody instantiates the DatabaseAccessContext service _before_ the SBA-dll is loaded
	// (e.g. from within a BASIC script). The createProvider-Function would do a call to SBA_DLL()->Load, which
	// would call this Init, which would register the address book, which needs an DatabaseAccessContext. Ooops.
	// So we can't do anything here which creates on of these various database services (see sbaservs.cxx for a list).
	// And for the same reason we don't call pSbaObject->SetEngine here anymore
}


//------------------------------------------------------------------------------
void SbaDLL::Exit()
{
	// called directly befor unloading the DLL
	// do whatever you want, Sd-DLL is accessible
	// Objekt-Factory austragen
	// the SdModule must be destroyed

	SbaModuleDummy** ppShlPtr = (SbaModuleDummy**) GetAppData(SHL_SBA);
	delete (*ppShlPtr);
	(*ppShlPtr) = NULL;

	// ppPoolDefaults l"oschen (NACH dem Loeschen des Modules, dort werden u.U. indirekt auch SbaDbDefs geloescht, welche wiederum
	// die PoolDefaults benoetigen koennen)
	for(USHORT i=0;i < SbaDBDataDef::nPoolDefaultsLen;i++)
		delete SbaDBDataDef::ppPoolDefaults[i];
}

//------------------------------------------------------------------------------
void SbaDLL::RegisterFactorys()
{
	SbaQueryTxtViewSh::RegisterFactory(SID_SBA_QRY_SQL);
	SbaQueryDesignViewSh::RegisterFactory(SID_SBA_QRY_DESIGN);
}

//------------------------------------------------------------------------------
void SbaDLL::RegisterInterfaces()
{
	SbaQueryDocSh::RegisterInterface();

	SbaQueryTxtViewSh::RegisterInterface(SBA_MOD());
	SbaQueryDesignViewSh::RegisterInterface(SBA_MOD());
}

/*************************************************************************
|*

|* Modul laden (nur Attrappe fuer das Linken der DLL)
|*
\************************************************************************/

SfxModule* SbaModuleDummy::Load()
{
	return (NULL);
}


