/*************************************************************************
 *
 *  $RCSfile: sbatabdn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_SBATABDN_HXX
#include "sbatabdn.hxx"
#endif

#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif

//--- Defines
#define HANDLE_ID 0

//------------------------------------------------------------------------
SbaTableDesignCtrl::SbaTableDesignCtrl(Window* pParent, SbaResId aResID)
				   :DbBrowseBox(pParent, aResID, DBBF_NONE,
								  BROWSER_COLUMNSELECTION | BROWSER_MULTISELECTION | BROWSER_KEEPSELECTION)
				   ,nDataPos(-1)
				   ,nCurrentPos(-1)
				   ,bUpdatable(FALSE)
				   ,bCurrentModified(FALSE)
				   ,bClipboardFilled(FALSE)
				   ,nCurUndoActId(0)
{
}

//------------------------------------------------------------------------
SbaTableDesignCtrl::~SbaTableDesignCtrl()
{
}

//------------------------------------------------------------------------
void SbaTableDesignCtrl::Init()
{
	DbBrowseBox::Init();

	Font aFont( GetDataWindow().GetFont() );
	aFont.SetWeight( WEIGHT_NORMAL );
	GetDataWindow().SetFont( aFont );

	// Font fuer die Ueberschriften auf Light setzen
	aFont = GetFont();
	aFont.SetWeight( WEIGHT_LIGHT );
	SetFont(aFont);

	// HandleColumn, fuer maximal fuenf Ziffern einrichten
	InsertHandleColumn(GetTextWidth('0') * 4/*, TRUE */);

	BrowserMode nMode = BROWSER_COLUMNSELECTION | BROWSER_MULTISELECTION | BROWSER_KEEPSELECTION |
						BROWSER_HLINESFULL | BROWSER_VLINESFULL;
	if (IsUpdatable())
		nMode |= BROWSER_HIDECURSOR;

	SetMode(nMode);
}

//------------------------------------------------------------------------
void SbaTableDesignCtrl::KeyInput( const KeyEvent& rEvt )
{
	if (IsUpdatable() && GetSelectRowCount())
	{
		if (rEvt.GetKeyCode().GetCode() == KEY_DELETE &&	// Delete rows
			!rEvt.GetKeyCode().IsShift() &&
			!rEvt.GetKeyCode().IsMod1())
		{
			DeleteRows();
			return;
		}
		if( rEvt.GetKeyCode().GetCode() == KEY_F2 )
			SFX_DISPATCHER().Execute( SID_EDITDOC, SFX_CALLMODE_ASYNCHRON );
	}
	DbBrowseBox::KeyInput(rEvt);
}

//------------------------------------------------------------------------
void SbaTableDesignCtrl::SetUpdatable( BOOL bUpdate )
{
	bUpdatable = bUpdate;

}

//------------------------------------------------------------------------
void SbaTableDesignCtrl::Command(const CommandEvent& rEvt)
{

	switch (rEvt.GetCommand())
	{
		case COMMAND_CONTEXTMENU:
		{
			if (!rEvt.IsMouseEvent())
			{
				DbBrowseBox::Command(rEvt);
				return;
			}

			USHORT nColId = GetColumnAtXPosPixel(rEvt.GetMousePosPixel().X());
			long   nRow = GetRowAtYPosPixel(rEvt.GetMousePosPixel().Y());
			long   nOldRow = GetCurRow();

			if ( nColId == HANDLE_ID )
			{
				PopupMenu aContextMenu(SbaResId(RID_TABDGNROWPOPUPMENU));
				long nSelectRowCount = GetSelectRowCount();
				aContextMenu.EnableItem( SID_CUT, nSelectRowCount );
				aContextMenu.EnableItem( SID_COPY, nSelectRowCount );
				aContextMenu.EnableItem( SID_PASTE, bClipboardFilled );
				aContextMenu.EnableItem( SID_DELETE, IsUpdatable() && nSelectRowCount );
				switch (aContextMenu.Execute(this, rEvt.GetMousePosPixel()))
				{
					case SID_CUT:
						Cut();
						break;
					case SID_COPY:
						Copy();
						break;
					case SID_PASTE:
						Paste( nRow );
						SetNoSelection();
						GoToRow( nRow );
						SeekRow( nRow );
						break;

					case SID_DELETE:
						DeleteRows();
						break;
					case SID_SBA_BRW_INSERTROWS:
						InsertNewRows( nRow );
						SetNoSelection();
						GoToRow( nRow );
						SeekRow( nRow );
						break;
					default:
						break;
				}
			}

		}
		default:
			DbBrowseBox::Command(rEvt);
	}

}

//------------------------------------------------------------------------------
void SbaTableDesignCtrl::Cut()
{
	CopyRows();
	DeleteRows();
}

//------------------------------------------------------------------------------
void SbaTableDesignCtrl::Copy()
{
	CopyRows();
}

//------------------------------------------------------------------------------
void SbaTableDesignCtrl::Paste()
{
	DBG_ERROR("SbaTableDesignCtrl::Paste : (pseudo-) abstract method called !");
}

//------------------------------------------------------------------------------
void SbaTableDesignCtrl::Paste( long nRow )
{
	InsertRows( nRow );
}

//------------------------------------------------------------------------------
DbBrowseBox::RowStatus SbaTableDesignCtrl::GetRowStatus(long nRow) const
{
	if (nCurrentPos >= 0 && nDataPos == nCurrentPos)
		return CURRENT;
	else
		return CLEAN;
}


