/*************************************************************************
 *
 *  $RCSfile: sbatabed.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVEDIT_HXX
#include <svtools/svmedit.hxx>
#endif
#ifndef _SBA_SBATABED_HXX
#include "sbatabed.hxx"
#endif

#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif
#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SBA_TABEDUNDO_HXX
#include "tabedund.hxx"
#endif
#ifndef _SBA_SBATTRDLG_HXX
#include "dlgattr.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif

#ifndef _WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif

#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>

#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SBA_EDITBRW_HXX
#include "editbrw.hxx"
#endif // _SBA_EDITBRW_HXX

#ifndef _SVX_ALGITEM_HXX //autogen
#include <svx/algitem.hxx>
#endif
#ifndef _MyEDITENG_HXX //autogen
#include <svx/editeng.hxx>
#endif


#ifndef _ZFORLIST_HXX //autogen
#define _ZFORLIST_DECLARE_TABLE		// ohne das bekomme ich einen Compiler-Fehler in <svtools/zforlist.hxx>
#include <svtools/zforlist.hxx>
#endif

#ifndef _SBA_DATCONV_HXX_
#include "datconv.hxx"
#endif // _SBA_DATCONV_HXX_

#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif

// MS-VC 4.1 Compiler has a problem with the stl
#define WB_LEFT 				((WinBits)0x00004000)

//==============================================================================

TYPEINIT1(SbaTableEditorCtrl, DBView);
DBG_NAME(SbaTableEditorCtrl);

//==============================================================================

#define HANDLE_ID		0

// Anzahl Spalten beim Neuanlegen
#define NEWCOLS		   128

// default Spaltenbreiten
#define FIELDNAME_WIDTH		100
#define FIELDTYPE_WIDTH		100
#define FIELDDESCR_WIDTH	300

// Maximale Eingabelaenge im Beschreibungsfeld
#define MAX_DESCR_LEN		256


#define CONTROL_SPACING_X	18	// 6
#define	CONTROL_SPACING_Y	5
#define CONTROL_HEIGHT		20
#define CONTROL_WIDTH_1		140	// 100
#define CONTROL_WIDTH_2		100 // 60
#define CONTROL_WIDTH_3		250
#define CONTROL_WIDTH_4		(CONTROL_WIDTH_3 - CONTROL_HEIGHT - 5)

//==================================================================
//------------------------------------------------------------------
SbaTableEditorCtrl::ClipboardInvalidator::ClipboardInvalidator(sal_uInt32 nTimeout)
{
	m_aInvalidateTimer.SetTimeout(nTimeout);
	m_aInvalidateTimer.SetTimeoutHdl(LINK(this, SbaTableEditorCtrl::ClipboardInvalidator, OnInvalidate));
	m_aInvalidateTimer.Start();
}

//------------------------------------------------------------------
SbaTableEditorCtrl::ClipboardInvalidator::~ClipboardInvalidator()
{
	m_aInvalidateTimer.Stop();
}

//------------------------------------------------------------------
IMPL_LINK(SbaTableEditorCtrl::ClipboardInvalidator, OnInvalidate, void*, EMPTYARG)
{
	SFX_BINDINGS().Invalidate(SID_CUT);
	SFX_BINDINGS().Invalidate(SID_COPY);
	SFX_BINDINGS().Invalidate(SID_PASTE);
	return 0L;
}

//==================================================================
void SbaTableEditorCtrl::Init()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	GetUndoManager()->Clear();
	SbaTableDesignCtrl::Init();


	//////////////////////////////////////////////////////////////////////
	// Soll der Entwurf ReadOnly geoeffnet werden ?
	sal_Bool bRead(sal_True);
	sal_Bool bDocReadOnlyUI(GetDocShell()->IsReadOnlyUI());

	sal_Bool bDocReadOnlyMedium(GetDocShell()->IsReadOnlyMedium());
	if (pTableDef && pTableDef->IsNew())
		// since the fixes for 69717/70160 the medium for new defs is always readonly, so ignore this
		// (the URLS for new objects are encoded since the latter fix)
		// (to be honest, it was a bug that it wasn't ro formerly, caused by our ::com::sun::star::util::URL scheme which was
		// misinterpreted by SFX)
		// FS - 01.12.99
		bDocReadOnlyMedium = sal_False;

	if( !bDocReadOnlyUI && !bDocReadOnlyMedium )
	{
		if( pTableDef && !pTableDef->IsUsed() )
		{
			if( !pTableDef->IsLocked() )
			{
				::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());

				if ((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) ||
					(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
				{
					if( pTableDef->GetTablePrivileges() & SDB_PR_ALTER || pTableDef->GetTable()->IsView())
						bRead = sal_False;
				}
			}
			else if( pTableDef->IsNew() )
				bRead = sal_False;
		}
	}

	SetReadOnly( bRead );

	//////////////////////////////////////////////////////////////////////
	// Spalten einfuegen
	String aColumnName( SbaResId(STR_TAB_FIELD_NAME) );
	InsertDataColumn( 1, aColumnName, FIELDNAME_WIDTH );

	aColumnName = String( SbaResId(STR_TAB_FIELD_DATATYPE) );
	InsertDataColumn( 2, aColumnName, FIELDTYPE_WIDTH );

	aColumnName = String( SbaResId(STR_TAB_FIELD_DESCR) );
	InsertDataColumn( 3, aColumnName, FIELDDESCR_WIDTH );

	InitCellController();

	//////////////////////////////////////////////////////////////////////
	// Zeilen einfuegen
	RowInserted(0, pRowList->Count(), sal_True);
}

//==================================================================
void SbaTableEditorCtrl::UpdateAll()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	RowRemoved(0, GetRowCount(), sal_False);
	nDataPos = 0;

	if (!DBObj().IsOpen())
		return;
	else // Einfuegen der Zeilen ins Fenster
	{
		nDataPos = 0;
	}

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
	Invalidate();
}
//==================================================================
//------------------------------------------------------------------
void SbaTableFieldControl::CellModified(long nRow, sal_uInt16 nColId )
{
	GetCtrl()->CellModified(nRow,nColId);
}
//------------------------------------------------------------------
SbaTableEditorCtrl* SbaTableFieldControl::GetCtrl()
{
	SbaTableDesignWin* pDesignWin = (SbaTableDesignWin*)GetParent()->GetParent()->GetParent();
	return pDesignWin->GetEditorCtrl();
}
//------------------------------------------------------------------
SbaDBDataDef* SbaTableFieldControl::GetDataDef()
{
	 return &GetCtrl()->DBObj();
}
//------------------------------------------------------------------
sal_Bool SbaTableFieldControl::IsReadOnly()
{
	sal_Bool bRead(GetCtrl()->IsReadOnly());
	if( !bRead )
	{
		// Die Spalten einer ::com::sun::star::sdbcx::View knnen nicht verndert werden
		SbaTableDef* pTableDef = (SbaTableDef*)GetDataDef();
		if(pTableDef && pTableDef->GetTable()->IsView())
			bRead = sal_True;
		else
		{
			SbaTabEdRow* pCurRow = GetCtrl()->GetActRow();
			if( pCurRow )
				bRead = pCurRow->IsReadOnly();
		}
	}
	return bRead;
}
//------------------------------------------------------------------
void SbaTableFieldControl::ActivateAggregate( SbaControlType eType )
{
	switch(eType)
	{
		case tpColumnName:
		case tpType:
			break;
		default:
			SbaFieldDescControl::ActivateAggregate(eType);
	}
}
//------------------------------------------------------------------
void SbaTableFieldControl::DeactivateAggregate( SbaControlType eType )
{
	switch(eType)
	{
		case tpColumnName:
		case tpType:
			break;
		default:
			SbaFieldDescControl::DeactivateAggregate(eType);
	}
}
//==================================================================
SbaTableEditorCtrl::SbaTableEditorCtrl(Window* pWindow, SbaTableDef* pDef, SbaTableViewSh* pV)
				   :SbaTableDesignCtrl(pWindow, SbaResId(RID_DB_TAB_EDITOR))
				   ,DBView(this,NULL)
				   ,m_aInvalidate(500)
				   ,pNameCell(NULL)
				   ,pTypeCell(NULL)
				   ,pDescrCell(NULL)
				   ,nIndexEvent(0)
				   ,pTableDef(pDef)
				   ,pViewSh(pV)
				   ,nOldDataPos(-1)
				   ,bSaveOnMove(sal_True)
				   ,nCutEvent(0)
				   ,nPasteEvent(0)
				   ,nDeleteEvent(0)
				   ,nInsNewRowsEvent(0)
				   ,nInvalidateTypeEvent(0)
				   ,nEntryNotFoundEvent(0)
				   ,bReadOnly(sal_True)
				   ,pActRow(NULL)
				   ,pDescrWin(NULL)
				   ,m_pTableDescWin(NULL)
{
	DBG_CTOR(SbaTableEditorCtrl,NULL);

	SetHelpId(HID_TABDESIGN_BACKGROUND);
	GetDataWindow().SetHelpId(HID_CTL_TABLEEDIT);

	//////////////////////////////////////////////////////////////////////
	// Titel fuer die Shell setzen (setzt Modify-Flag->deshalb Flag zuruecksetzen)
	SbaTableDocSh* pShell = GetDocShell();

	//////////////////////////////////////////////////////////////////////
	// Clipboard Format registrieren
	Clipboard::Clear();
	nClipboardFormat = Clipboard::RegisterFormatName( String::CreateFromAscii("Tabed") );
	pRowList = GetDocShell()->GetTabEdRowList();
//	pRowVerList = GetDocShell()->GetTabRowVerList();
	nDataPos = 0;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsReadOnly()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	return bReadOnly;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::SetReadOnly( sal_Bool bRead )
{
	GetDocShell()->SetReadOnlyUI( bRead ); // Ueberschrift auf schreibgeschuetzt

	// nix zu tun ?
	if (bRead == IsReadOnly())
		// diese Abfrage ist wichtig, da die zugrundeliegende Def sonst im folgenden gelockt oder ge-unlocked wird, obwohl es
		// nicht notwendig waere (und was schlimmer ist, das wuerde dann auch nicht wieder rueckgaengig gemacht)
		return;

	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	bReadOnly = bRead;
	pTableDef->SetLock( !bRead );

	//////////////////////////////////////////////////////////////////////
	// Aktive Zelle disablen
	long nRow(GetCurRow());
	sal_uInt16 nCol(GetCurColumnId());
	DeactivateCell();

	//////////////////////////////////////////////////////////////////////
	// ::com::sun::star::beans::Property Controls disablen
	if (pDescrWin)
		pDescrWin->SetReadOnly(bReadOnly || !SetDataPtr(nRow) || GetActRow()->IsReadOnly());
	if(m_pTableDescWin)
		m_pTableDescWin->SetReadOnly( bReadOnly );

	//////////////////////////////////////////////////////////////////////
	// Cursor des Browsers anpassen
	BrowserMode nMode(BROWSER_COLUMNSELECTION | BROWSER_MULTISELECTION | BROWSER_KEEPSELECTION |
					  BROWSER_HLINESFULL	  | BROWSER_VLINESFULL);
	if( !bReadOnly )
		nMode |= BROWSER_HIDECURSOR;
	SetMode(nMode);

	if( !bReadOnly )
		ActivateCell( nRow, nCol );
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::InitCellController()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Zelle Feldname
	pNameCell = new EditCtrl( &GetDataWindow(), WB_LEFT ,DBObj().GetDatabase());
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(DBObj().GetDatabase()->GetMetaData());

	xub_StrLen nMaxTextLen(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN));

	if( nMaxTextLen == 0 )
		nMaxTextLen = USHRT_MAX;	// TODO : need xub_MaxStrLen or something like that
	pNameCell->SetMaxTextLen( nMaxTextLen );

	//////////////////////////////////////////////////////////////////////
	// Zelle Typ
	pTypeCell = new DbListBoxCtrl( &GetDataWindow() );
//	pTypeCell->SetPreNotifyHdl( LINK(this, SbaTableEditorCtrl, ControlPreNotifyHdl) );	WTD ?

	//////////////////////////////////////////////////////////////////////
	// Zelle Beschreibung
	pDescrCell = new Edit( &GetDataWindow(), WB_LEFT );
	pDescrCell->SetMaxTextLen( MAX_DESCR_LEN );

	pNameCell->SetHelpId(HID_TABDESIGN_NAMECELL);
	pTypeCell->SetHelpId(HID_TABDESIGN_TYPECELL);
	pDescrCell->SetHelpId(HID_TABDESIGN_COMMENTCELL);

	ClearModified();
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::ClearModified()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	pNameCell->ClearModifyFlag();
	pDescrCell->ClearModifyFlag();
	pTypeCell->SaveValue();
}

//------------------------------------------------------------------------------
SbaTableEditorCtrl::~SbaTableEditorCtrl()
{
	DBG_DTOR(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Lock der Definition wieder zuruecksetzen
	if( !IsReadOnly() )
		pTableDef->SetLock( sal_False );

	//////////////////////////////////////////////////////////////////////
	// Undo-Manager zuruecksetzen
	GetUndoManager()->Clear();

	//////////////////////////////////////////////////////////////////////
	// Moegliche Events aus Queue entfernen
	if( nCutEvent )
		Application::RemoveUserEvent( nCutEvent );
	if( nPasteEvent )
		Application::RemoveUserEvent( nPasteEvent );
	if( nDeleteEvent )
		Application::RemoveUserEvent( nDeleteEvent );
	if( nInsNewRowsEvent )
		Application::RemoveUserEvent( nInsNewRowsEvent );
	if( nInvalidateTypeEvent )
		Application::RemoveUserEvent( nInvalidateTypeEvent );
	if( nEntryNotFoundEvent )
		Application::RemoveUserEvent( nEntryNotFoundEvent );

	//////////////////////////////////////////////////////////////////////
	// Controltypen zerstoeren
	delete pNameCell;
	delete pTypeCell;
	delete pDescrCell;
	while ( aClipboardList.Count() )
		delete aClipboardList.Remove( (sal_uInt32)0 );
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::SetDataPtr( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	pActRow = pRowList->GetObject( nRow );
	return pActRow ? sal_True : sal_False;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::SeekRow(long nRow)
{
	// die Basisklasse braucht den Aufruf, da sie sich dort merkt, welche Zeile gepainted wird
	DbBrowseBox::SeekRow(nRow);

	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	nCurrentPos = nRow;
	if (DBObj().IsOpen())
	{
		 return SetDataPtr(nRow);
	}
	return sal_False;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::PaintCell(OutputDevice& rDev, const Rectangle& rRect,
								   sal_uInt16 nColumnId ) const
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	String aText( GetCellText( nCurrentPos, nColumnId ));
	Point aPos(rRect.TopLeft());
	Size TxtSize(GetDataWindow().GetTextWidth(aText), GetDataWindow().GetTextHeight());

	if (aPos.X() < rRect.Right() || aPos.X() + TxtSize.Width() > rRect.Right() ||
		aPos.Y() < rRect.Top() || aPos.Y() + TxtSize.Height() > rRect.Bottom())
		rDev.SetClipRegion( rRect );

	rDev.DrawText(aPos, aText);

	if (rDev.IsClipRegion())
		rDev.SetClipRegion();
}

//------------------------------------------------------------------------------
DbCellController* SbaTableEditorCtrl::GetController(long nRow, sal_uInt16 nColumnId)
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Wenn EditorCtrl ReadOnly ist, darf nicht editiert werden
	if (IsReadOnly() || pTableDef->GetTable()->IsView())
		return NULL;

	//////////////////////////////////////////////////////////////////////
	// Wenn Zeile ReadOnly ist, darf sie nicht editiert werden
	SetDataPtr( nRow );
	if( pActRow->IsReadOnly() )
		return NULL;

	DBG_ASSERT(DBObj().IsOpen(), "Datenobjekt nicht geoeffnet!");

	SbaFieldDescr* pActFieldDescr = pActRow->GetActFieldDescr();
	switch (nColumnId)
	{
		case FIELD_NAME:
			return new DbEditCellController( pNameCell );
		case FIELD_TYPE:
			if (pActFieldDescr && (pActFieldDescr->GetName().Len() != 0))
				return new DbListBoxCellController( pTypeCell );
			else return NULL;
		case FIELD_DESCR:
			if (pActRow->GetActFieldDescr() && (pActFieldDescr->GetName().Len() != 0))
				return new DbEditCellController( pDescrCell );
			else return NULL;
		default:
			return NULL;
	}
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::InitController(DbCellControllerRef&, long nRow, sal_uInt16 nColumnId)
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	SeekRow( nRow == -1 ? GetCurRow() : nRow);
	SbaFieldDescr* pActFieldDescr = pActRow->GetActFieldDescr();
	String aInitString;

	switch (nColumnId)
	{
		case FIELD_NAME:
			if( pActFieldDescr )
				aInitString = pActFieldDescr->GetName();
			pNameCell->SetText( aInitString );
			break;
		case FIELD_TYPE:
			{
				if( pActFieldDescr )
					aInitString = pActFieldDescr->GetType();

				//////////////////////////////////////////////////////////////
				// Anpassen des ComboBoxInhalts
				pTypeCell->Clear();
				if( !pActFieldDescr )
					break;
				SbaFieldType aFieldType = pActFieldDescr->GetFieldType();
				if( aFieldType == dbNone )
					pTypeCell->InsertEntry( DBObj().TypeString(dbNone) );
				else
				{
					//for( int i=(int)dbText; i<=(int)dbBigInt; i++ )
					for( int i=(int)dbText; i<=(int)dbVarBinary; i++ )
					{
						if( DBObj().GetDatabase()->IsTypeAvailable((SbaFieldType)i) )
							pTypeCell->InsertEntry( DBObj().TypeString((SbaFieldType)i) );
					}
				}
				pTypeCell->SelectEntry( aInitString );
			}

			break;
		case FIELD_DESCR:
			if( pActFieldDescr )
				aInitString = pActFieldDescr->GetDescription();
			pDescrCell->SetText( aInitString );
			break;

	}
}

//------------------------------------------------------------------------------
DbBrowseBox::RowStatus SbaTableEditorCtrl::GetRowStatus(long nRow) const
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	( (SbaTableEditorCtrl*)this )->SetDataPtr( nRow );
	if( !pActRow )
		return DbBrowseBox::CLEAN;
	if (nRow >= 0 && nRow == nDataPos)
	{
		if( pActRow->IsPrimaryKey() )
			return DbBrowseBox::CURRENT_PRIMARYKEY;
		return DbBrowseBox::CURRENT;
	}
	else
	{
		if( pActRow->IsPrimaryKey() )
			return DbBrowseBox::PRIMARYKEY;
		return DbBrowseBox::CLEAN;
	}
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::SaveCurRow()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if (GetFieldDescr(GetCurRow()) == NULL)
		// in der Zeile, in der ich mich i.A. befinde, stehen keine Daten
		return sal_True;
	if (!SaveModified())
		return sal_False;

	SetDataPtr(GetCurRow());
	pDescrWin->SaveData( pActRow->GetActFieldDescr() );
	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::DisplayData(long nRow, sal_Bool bGrabFocus)
{
	// zur richtigen Zelle fahren
	SetDataPtr(nRow);

	// Editier-Modus temporaer aus
	sal_Bool bWasEditing = IsEditing();
	if (bWasEditing)
		DeactivateCell();

	DbCellControllerRef aTemp;
	InitController(aTemp, nRow, FIELD_NAME);
	InitController(aTemp, nRow, FIELD_TYPE);
	InitController(aTemp, nRow, FIELD_DESCR);

	GoToRow(nRow);
	// das Description-Window aktualisieren
	((SbaTableDesignWin*)GetParent())->GetDescWin()->DisplayData(GetFieldDescr(nRow));
	// neu zeichnen
	RowModified(nRow);

	// wieder an
	if (bWasEditing || bGrabFocus)
		ActivateCell(nRow, GetCurColumnId(), bGrabFocus);
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::CursorMoved()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Zeilenwechsel ?
	nDataPos = GetCurRow();
	if( nDataPos != nOldDataPos && nDataPos != -1)
	{
		DbCellControllerRef aTemp;
		InitController(aTemp,nDataPos,FIELD_NAME);
		InitController(aTemp,nDataPos,FIELD_TYPE);
		InitController(aTemp,nDataPos,FIELD_DESCR);
	}

	SbaTableDesignCtrl::CursorMoved();
}

//------------------------------------------------------------------------------
sal_Int32 SbaTableEditorCtrl::HasFieldName( const String& rFieldName )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	SbaTabEdRow* pRow = pRowList->First();
	SbaFieldDescr* pFieldDescr;
	sal_Int32 nCount(0);
	sal_Bool bCase = (GetDocShell()->GetDatabase()->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
	while( pRow )
	{
		pFieldDescr = pRow->GetActFieldDescr();
		if( pFieldDescr )
		{
			if(bCase ? rFieldName.Equals(pFieldDescr->GetName()) : SbaDBObj::EqualNamesInsensitive(rFieldName, pFieldDescr->GetName()))
				nCount++;
		}
		pRow = pRowList->Next();
	}
	return nCount;
}
// --------------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::SaveData(long nRow, sal_uInt16 nColId)
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////
	// Zellinhalte in Datenstruktur speichern
	SetDataPtr( nRow == -1 ? GetCurRow() : nRow);
	SbaFieldDescr* pActFieldDescr = pActRow->GetActFieldDescr();

	switch( nColId)
	{
		//////////////////////////////////////////////////////////////
		// Speichern Inhalt NameCell
		case FIELD_NAME:
		{
			//////////////////////////////////////////////////////////////
			// Wenn kein Name, nichts machen
			SbaDatabase* pDatabase = pTableDef->GetDatabase();
			String aName(pNameCell->GetText());

			if( !aName.Len() )
			{
				//////////////////////////////////////////////////////////////
				// Wenn FieldDescr existiert, wurde Feld geloescht und alter Inhalt wird wiederhergestellt
				if (pActFieldDescr)
				{
					SwitchType(String());
					pActFieldDescr = pActRow->GetActFieldDescr();
				}
				else
					return sal_True;
			}

			pActFieldDescr->SetName( aName );
			pNameCell->ClearModifyFlag();

			break;
		}

		//////////////////////////////////////////////////////////////
		// Speichern Inhalt TypeCell
		case FIELD_TYPE:
			break;

		//////////////////////////////////////////////////////////////
		// Speichern Inhalt DescrCell
		case FIELD_DESCR:
		{
			//////////////////////////////////////////////////////////////
			// Wenn aktuelle Feldbeschreibung NULL, Default setzen
			if( !pActFieldDescr )
				pDescrCell->SetText(String());
			else
				pActFieldDescr->SetDescription( pDescrCell->GetText() );
			break;
		}
		case FIELD_PROPERTY_DEFAULT:
		case FIELD_PROPERTY_REQUIRED:
		case FIELD_PROPERTY_TEXTLEN:
		case FIELD_PROPERTY_NUMTYPE:
		case FIELD_PROPERTY_AUTOINC:
		case FIELD_PROPERTY_LENGTH:
		case FIELD_PROPERTY_SCALE:
		case FIELD_PROPERTY_BOOL_DEFAULT:
			pDescrWin->SaveData(pActFieldDescr);
			break;
	}
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::SaveModified()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	sal_uInt16 nColId = GetCurColumnId();

	switch( nColId )
	{
		//////////////////////////////////////////////////////////////
		// NameCell
		case FIELD_NAME:
		{
			// removed the former duplicate-check. this is done in SbaTableDocShell::CheckDefConsistency now.
			// FS - 07.12.99 - 69575

		} break;

		//////////////////////////////////////////////////////////////
		// TypeCell
		case FIELD_TYPE:
		{
			//////////////////////////////////////////////////////////////////////
			// Type umstellen
			SwitchType(pTypeCell->GetSelectEntry());
		} break;
	}

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::CursorMoving(long nNewRow, sal_uInt16 nNewCol)
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);

	if (!DbBrowseBox::CursorMoving(nNewRow, nNewCol))
		return sal_False;

	//////////////////////////////////////////////////////////////////////
	// Wird nach SaveModified() gerufen, aktuelle Zeile ist noch die alte
	nDataPos = nNewRow;
	nOldDataPos = GetCurRow();

	//////////////////////////////////////////////////////////////////////
	// Marker umsetzen
	InvalidateStatusCell( nOldDataPos );
	InvalidateStatusCell( nDataPos );

	//////////////////////////////////////////////////////////////////////
	// Daten des Propertyfensters speichern
	if( SetDataPtr(nOldDataPos) && pDescrWin)
		pDescrWin->SaveData( pActRow->GetActFieldDescr() );

	//////////////////////////////////////////////////////////////////////
	// Neue Daten im Propertyfenster anzeigen
	if( SetDataPtr(nDataPos) && pDescrWin)
		pDescrWin->DisplayData( pActRow->GetActFieldDescr() );

	return sal_True;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, InvalidateFieldType, void*, EMPTYTAG )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	nInvalidateTypeEvent = 0;
	Invalidate( GetFieldRectPixel(nOldDataPos, FIELD_TYPE) );

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, EntryNotFound, void*, EMPTYTAG )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	nEntryNotFoundEvent = 0;
	ErrorBox( (SbaTableEditorCtrl*)this, SbaResId(ERR_SBA_INVALID_LISTBOX_ENTRY) ).Execute();

	return 0;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::CellModified( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);

	//////////////////////////////////////////////////////////////
	// Wenn aktuelle Feldbeschreibung NULL, Default setzen
	if(nRow == -1)
		nRow = GetCurRow();
	SetDataPtr( nRow );
	SbaFieldDescr* pActFieldDescr = pActRow->GetActFieldDescr();
	if (!pActFieldDescr || (pActFieldDescr->GetFieldType() == dbNone))
	{
		String aFieldTypes( SbaResId(STR_DBFIELDTYPES) );
		pActRow->SetFieldType( aFieldTypes.GetToken(TYPE_TEXT) );
		nInvalidateTypeEvent = Application::PostUserEvent( LINK(this, SbaTableEditorCtrl, InvalidateFieldType) );
		pActFieldDescr = pActRow->GetActFieldDescr();
		pDescrWin->DisplayData( pActFieldDescr );
		GetUndoManager()->AddUndoAction( new SbaTabEdTypeSelUndoAct(this, nRow, nColId+1, String()) );
		//RowModified(nRow,nColId+1);
	}

	if( nColId != FIELD_TYPE )
		GetUndoManager()->AddUndoAction( new SbaTabDgnCellUndoAct(this, nRow, nColId) );
	else
	{
		GetUndoManager()->AddUndoAction(new SbaTabEdTypeSelUndoAct(this, GetCurRow(), nColId, GetFieldDescr(GetCurRow())->GetType()));
		SwitchType( pTypeCell->GetSelectEntry() );
	}

	SaveData(nRow,nColId);
	RowModified(nRow);
	DbCellControllerRef xController(Controller());
	if(xController.Is())
		xController->SetModified();
	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);

	//////////////////////////////////////////////////////////////////////
	// Wenn der Feldname leer ist, werden alle

	//////////////////////////////////////////////////////////////////////
	// Das ModifyFlag der TableDocSh setzen
	GetDocShell()->SetModified( sal_True );
	m_pTableDescWin->SetReadOnly(sal_False);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::CellModified()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	CellModified( GetCurRow(), GetCurColumnId() );
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Undo()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	DBView::Undo();

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
}


//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Redo()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	DBView::Redo();

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::CopyRows()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Alte ClipboardListe loeschen
	while ( aClipboardList.Count() )
		delete aClipboardList.Remove( (sal_uInt32)0 );

	//////////////////////////////////////////////////////////////////////
	// Sichergehen, dass Daten aus dem PropertyWin schon gespeichert sind.
	if( SetDataPtr(nDataPos) )
		pDescrWin->SaveData( pActRow->GetActFieldDescr() );

	//////////////////////////////////////////////////////////////////////
	// Selektierte Zeilen in die ClipboardListe kopieren
	SbaTabEdRow* pClipboardRow;
	SbaTabEdRow* pRow;

	for( long nIndex=FirstSelectedRow(); nIndex>=0; nIndex=NextSelectedRow() )
	{
		pRow = pRowList->GetObject( nIndex );
		pClipboardRow = new SbaTabEdRow( *pRow );
		aClipboardList.Insert( pClipboardRow, LIST_APPEND );
	}

	if( aClipboardList.Count() )
		bClipboardFilled = sal_True;
}

//------------------------------------------------------------------------------
String SbaTableEditorCtrl::GenerateName( const String& rName )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Basisnamen zum Anhaengen einer Numerierung erstellen
	String aBaseName;
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());

	xub_StrLen nMaxLen(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN));

	if( (rName.Len()+2) >nMaxLen )
		aBaseName = rName.Copy( 0, nMaxLen-2 );
	else
		aBaseName = rName;

	//////////////////////////////////////////////////////////////////////
	// Namen durchnumerieren (bis 99)
	String aFieldName( rName);
	sal_uInt16 i=1;
	while( HasFieldName(aFieldName) )
	{
		aFieldName = aBaseName;
		aFieldName += String(i);
		i++;
	}

	return aFieldName;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::InsertRows( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Zeilen aus der Clipboardliste in die Datenstruktur einfgen
	long nInsertRow = nRow;
	SbaTabEdRow* pRow;
	SbaTabEdRow* pClipboardRow = aClipboardList.First();
	String aFieldName;

	while( pClipboardRow )
	{
		pRow = new SbaTabEdRow( *pClipboardRow );
		pRow->SetReadOnly( sal_False );

		//////////////////////////////////////////////////////////////////////
		// Anpassen des Feldnamens
		aFieldName = GenerateName( pRow->GetActFieldDescr()->GetName() );
		pRow->GetActFieldDescr()->SetName( aFieldName );

		pRowList->Insert( pRow, nInsertRow );

		pClipboardRow = aClipboardList.Next();
		nInsertRow++;
	}

	//////////////////////////////////////////////////////////////////////
	// Beim RowInserted wird CursorMoved gerufen.
	// Die UI-Daten duerfen hier beim CursorMoved nicht gespeichert werden.
	bSaveOnMove = sal_False;
	RowInserted( nRow,aClipboardList.Count() ,sal_True );
	bSaveOnMove = sal_True;

	//////////////////////////////////////////////////////////////////////
	// Undo-::com::sun::star::chaos::Action erzeugen
	GetUndoManager()->AddUndoAction( new SbaTabEdInsUndoAct(this, nRow) );

	GetDocShell()->SetModified( sal_True );
	m_pTableDescWin->SetReadOnly(sal_False);
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::DeleteRows()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Undo-::com::sun::star::chaos::Action erzeugen
	GetUndoManager()->AddUndoAction( new SbaTabEdDelUndoAct(this) );

	//////////////////////////////////////////////////////////////////////
	// Alle markierten Zeilen loeschen
	long nIndex = FirstSelectedRow();
	nOldDataPos = nIndex;
	bSaveOnMove = sal_False;

	while( nIndex >= 0 )
	{
		//////////////////////////////////////////////////////////////////////
		// Zeile entfernen
		delete pRowList->Remove( nIndex );
		RowRemoved( nIndex, 1, sal_True );

		//////////////////////////////////////////////////////////////////////
		// Leerzeile am Ende wieder einfuegen
		pRowList->Insert( new SbaTabEdRow, LIST_APPEND );
		RowInserted( GetRowCount()-1, 1, sal_True );

		nIndex = FirstSelectedRow();
	}

	bSaveOnMove = sal_True;

	//////////////////////////////////////////////////////////////////////
	// Erzwingen, dass der aktuelle Datensatz angezeigt wird
	nDataPos = GetCurRow();
	InvalidateStatusCell( nOldDataPos );
	InvalidateStatusCell( nDataPos );
	SetDataPtr( nDataPos );
	ActivateCell();
	pDescrWin->DisplayData( pActRow->GetActFieldDescr() );
	GetDocShell()->SetModified( sal_True );
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::InsertNewRows( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Undo-::com::sun::star::chaos::Action erzeugen
	long nInsertRows = GetSelectRowCount();
	if( !nInsertRows )
		nInsertRows = 1;
	GetUndoManager()->AddUndoAction( new SbaTabEdInsNewUndoAct(this, nRow, nInsertRows) );

	//////////////////////////////////////////////////////////////////////
	// Zahl der selektierten Zeilen werden neu eingefuegt
	for( long i=nRow; i<(nRow+nInsertRows); i++ )
		pRowList->Insert( new SbaTabEdRow, i );
	RowInserted( nRow, nInsertRows, sal_True );

	GetDocShell()->SetModified( sal_True );
	m_pTableDescWin->SetReadOnly(sal_False);
}

//------------------------------------------------------------------------------
String SbaTableEditorCtrl::GetControlText( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls des Browsers auslesen
	if( nColId < FIELD_FIRST_VIRTUAL_COLUMN )
	{
		GoToRow( nRow );
		GoToColumnId( nColId );
		DbCellControllerRef xController = Controller();
		if(xController.Is())
			return xController->GetWindow().GetText();
		else
			return GetCellText(nRow,nColId);
	}

	//////////////////////////////////////////////////////////////////////
	// Controls der Tabpage Auslesen
	else
		return pDescrWin->GetControlText( nColId );
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::SetControlText( long nRow, sal_uInt16 nColId, const String& rText )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls des Browsers setzen
	if( nColId < FIELD_FIRST_VIRTUAL_COLUMN )
	{
		GoToRow( nRow );
		GoToColumnId( nColId );
		DbCellControllerRef xController = Controller();
		if(xController.Is())
			xController->GetWindow().SetText( rText );
		else
			RowModified(nRow,nColId);
	}

	//////////////////////////////////////////////////////////////////////
	// Controls der Tabpage setzen
	else
	{
		pDescrWin->SetControlText( nColId, rText );
	}
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::SetData( long nRow, sal_uInt16 nColId, const String& rNewData )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Aktuellen Datenzeiger umsetzen
	if( nRow==-1 )
		nRow = GetCurRow();
	SbaFieldDescr* pFieldDescr = GetFieldDescr( nRow );
	if( !pFieldDescr && nColId != FIELD_TYPE)
		return;

	String strYes(SbaResId(STR_VALUE_YES));
	String strNo(SbaResId(STR_VALUE_NO));
	//////////////////////////////////////////////////////////////////////
	// Einzelne Felder setzen
	switch( nColId )
	{
		case FIELD_NAME:
			pFieldDescr->SetName( rNewData );
			break;

		case FIELD_TYPE:
			SwitchType( rNewData );
			break;

		case FIELD_DESCR:
			pFieldDescr->SetDescription( rNewData );
			break;

		case FIELD_PROPERTY_DEFAULT:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				((SbaExtFieldDescr*)pFieldDescr)->SetDefault( rNewData );
			break;

		case FIELD_PROPERTY_REQUIRED:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				((SbaExtFieldDescr*)pFieldDescr)->SetRequired( (rNewData.ToInt32() != 0) );
			break;

		case FIELD_PROPERTY_TEXTLEN:
			if (pFieldDescr->ISA(SbaTextFieldDescr))
				((SbaTextFieldDescr*)pFieldDescr)->SetTextLen( rNewData );
			break;

		case FIELD_PROPERTY_NUMTYPE:
			if (pFieldDescr->ISA(SbaNumericFieldDescr))
				((SbaNumericFieldDescr*)pFieldDescr)->SetNumType( rNewData );
			break;

		case FIELD_PROPERTY_AUTOINC:
			pFieldDescr->SetAutoIncrement(rNewData.Equals(strYes));
			break;

		case FIELD_PROPERTY_LENGTH:
			if (pFieldDescr->ISA(SbaDecimalFieldDescr))
				((SbaDecimalFieldDescr*)pFieldDescr)->SetLength(rNewData);
			else if (pFieldDescr->ISA(SbaBinaryFieldDescr))
				((SbaBinaryFieldDescr*)pFieldDescr)->SetLength(rNewData);
			else if (pFieldDescr->ISA(SbaVarBinaryFieldDescr))
				((SbaVarBinaryFieldDescr*)pFieldDescr)->SetLength(rNewData);
			break;

		case FIELD_PROPERTY_SCALE:
			if (pFieldDescr->ISA(SbaDecimalFieldDescr))
				((SbaDecimalFieldDescr*)pFieldDescr)->SetScale(rNewData);
			break;

		case FIELD_PROPERTY_BOOL_DEFAULT:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				((SbaExtFieldDescr*)pFieldDescr)->SetDefault(((SbaTableDesignWin*)GetParent())->GetDescWin()->BoolStringPersistent(rNewData));
			break;

		case FIELD_PROPERTY_FORMAT:
			pFieldDescr->SetFormatKey(rNewData.ToInt32());
			break;
	}

	SetControlText(nRow,nColId,rNewData);
}

//------------------------------------------------------------------------------
String SbaTableEditorCtrl::GetData( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	SbaFieldDescr* pFieldDescr = GetFieldDescr( nRow );
	if( !pFieldDescr )
		return String();

	//////////////////////////////////////////////////////////////////////
	// Aktuellen Datenzeiger umsetzen
	if( nRow==-1 )
		nRow = GetCurRow();
	SetDataPtr( nRow );

	static const String strYes(SbaResId(STR_VALUE_YES));
	static const String strNo(SbaResId(STR_VALUE_NO));
	//////////////////////////////////////////////////////////////////////
	// Einzelne Felder auslesen
	switch( nColId )
	{
		case FIELD_NAME:
			return pFieldDescr->GetName();

		case FIELD_TYPE:
			return pFieldDescr->GetType();

		case FIELD_DESCR:
			return pFieldDescr->GetDescription();

		case FIELD_PROPERTY_DEFAULT:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				return ((SbaExtFieldDescr*)pFieldDescr)->GetDefault();
			break;

		case FIELD_PROPERTY_REQUIRED:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				if (((SbaExtFieldDescr*)pFieldDescr)->IsRequired())
					return strYes;
				else
					return strNo;
			break;

		case FIELD_PROPERTY_TEXTLEN:
			if (pFieldDescr->ISA(SbaTextFieldDescr))
				return ((SbaTextFieldDescr*)pFieldDescr)->GetTextLen();
			break;

		case FIELD_PROPERTY_NUMTYPE:
			if (pFieldDescr->ISA(SbaNumericFieldDescr))
				return ((SbaNumericFieldDescr*)pFieldDescr)->GetNumType();
			break;

		case FIELD_PROPERTY_AUTOINC:
			if (pFieldDescr->IsAutoIncrement())
				return strYes;
			else
				return strNo;

		case FIELD_PROPERTY_LENGTH:
			if (pFieldDescr->ISA(SbaDecimalFieldDescr))
				return ((SbaDecimalFieldDescr*)pFieldDescr)->GetLength();
			else if (pFieldDescr->ISA(SbaBinaryFieldDescr))
				return ((SbaBinaryFieldDescr*)pFieldDescr)->GetLength();
			else if (pFieldDescr->ISA(SbaVarBinaryFieldDescr))
				return ((SbaVarBinaryFieldDescr*)pFieldDescr)->GetLength();
			break;

		case FIELD_PROPERTY_SCALE:
			if (pFieldDescr->ISA(SbaDecimalFieldDescr))
				return ((SbaDecimalFieldDescr*)pFieldDescr)->GetScale();
			break;

		case FIELD_PROPERTY_BOOL_DEFAULT:
			if (pFieldDescr->ISA(SbaExtFieldDescr))
				return ((SbaTableDesignWin*)GetParent())->GetDescWin()->BoolStringUI(((SbaExtFieldDescr*)pFieldDescr)->GetDefault());
			break;

		case FIELD_PROPERTY_FORMAT:
			return String(pFieldDescr->GetFormatKey());
	}

	return String();
}

//------------------------------------------------------------------------------
String SbaTableEditorCtrl::GetCellText( long nRow, sal_uInt16 nColId ) const
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Text aus Dokumentdaten holen
	return ((SbaTableEditorCtrl*)this)->GetData( nRow, nColId );
}

//------------------------------------------------------------------------------
sal_uInt32 SbaTableEditorCtrl::GetTotalCellWidth(long nRow, sal_uInt16 nColId) const
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	return GetDataWindow().GetTextWidth(GetCellText(nRow, nColId));
}

//------------------------------------------------------------------------------
SbaFieldDescr* SbaTableEditorCtrl::GetFieldDescr( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	sal_uInt16 nListCount(pRowList->Count());
	if( (nRow<0) || (nRow>=nListCount) )
		return NULL;
	SbaTabEdRow* pRow = pRowList->GetObject( nRow );
	if( !pRow )
		return NULL;
	return pRow->GetActFieldDescr();
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsCutAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if( !IsCopyAllowed(nRow) || pTableDef->GetTable()->IsView())
		return sal_False;

	return IsDeleteAllowed( nRow );
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsCopyAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if( !GetSelectRowCount() || pTableDef->GetTable()->IsView())
		return sal_False;

	//////////////////////////////////////////////////////////////////////
	// Wenn eine der markierten Zeilen leer ist, kein Copy moeglich
	SbaTabEdRow* pRow;
	long nIndex = FirstSelectedRow();
	while( nIndex >= 0 )
	{
		pRow = pRowList->GetObject( nIndex );
		if( !pRow->GetActFieldDescr() )
			return sal_False;

		nIndex = NextSelectedRow();
	}

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsPasteAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if( !bClipboardFilled || pTableDef->GetTable()->IsView())
		return sal_False;

	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Cut()
{
	if (nCutEvent)
		Application::RemoveUserEvent(nCutEvent);
	nCutEvent = Application::PostUserEvent(LINK(this, SbaTableEditorCtrl, DelayedCut));
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Copy()
{
	SbaTableDesignCtrl::Copy();
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Paste()
{
	if( nPasteEvent )
		Application::RemoveUserEvent( nPasteEvent );
	nPasteEvent = Application::PostUserEvent( LINK(this, SbaTableEditorCtrl, DelayedPaste) );
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsDeleteAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if( !GetSelectRowCount() || pTableDef->GetTable()->IsView())
		return sal_False;

	// Wenn nur Felder hinzugefuegt werden duerfen, Delete nur auf neuen Feldern
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());

	if (!pTableDef->IsNew() && !(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) &&
		 (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
	{
		long nIndex = FirstSelectedRow();
		SbaTabEdRow* pRow;
		while (nIndex >= 0)
		{
			pRow = pRowList->GetObject( nIndex );
			if (pRow)
				return sal_False;
			if (pRow->IsReadOnly())
				return sal_False;

			nIndex = NextSelectedRow();
		}
	}

	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsInsertNewAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if(pTableDef->GetTable()->IsView())
		return sal_False;
	if(pTableDef->IsNew())
		return sal_True;
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());
	//////////////////////////////////////////////////////////////
	// Wenn nur Felder geloescht werden duerfen, Paste disablen

	if ( (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) &&
		!(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
		return sal_False;

	//////////////////////////////////////////////////////////////
	// Wenn nur Felder hinzugefuegt werden duerfen, Paste nur in neue Felder
	if (!(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) &&
		 (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
	{
		SetDataPtr(nRow);
		if( GetActRow()->IsReadOnly() )
			return sal_False;
	}

	if (!pTableDef->GetDatabase()->IsCapable(SDB_CAP_INSERTTABCOLS))
		return sal_False;
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsPrimaryKeyAllowed( long nRow )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	if( !GetSelectRowCount() )
		return sal_False;

	//////////////////////////////////////////////////////////////
	// Datenbank kann keine PrimKeys verarbeiten oder keine Zeilenselektion
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());
	if(!((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::SQL_CONFORMANCE)) & ::com::sun::star::data::DatabaseSQLConformance::CORE) == ::com::sun::star::data::DatabaseSQLConformance::CORE))
		return sal_False;

	//////////////////////////////////////////////////////////////
	// Key darf nicht veraendert werden
	// Dies gilt jedoch nur, wenn die Tabelle nicht neu ist und keine ::com::sun::star::sdbcx::View. Ansonsten wird kein DROP ausgefhrt
	sal_Bool bDropNotAllowed = sal_False;
	if ((!((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) ||
			pTableDef->IsNew()) &&
		 (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN)) &&
			!pTableDef->GetTable()->IsView())
		bDropNotAllowed = sal_True;

	//////////////////////////////////////////////////////////////
	// Wenn leeres Feld, kein PrimKey
	// Eintrag wird nur erlaubt, wenn
	// - kein leerer Eintrag in der Selection ist
	// - kein Eintrag vom Typ Memo oder Image ist
	// - kein DROP erlaubt ist (s.o.) und die Spalte noch kein Required (not null) gesetzt hatte.
	long nIndex = FirstSelectedRow();
	SbaTabEdRow* pRow;
	SbaFieldType aFieldType;
	while( nIndex >= 0 )
	{
		pRow = pRowList->GetObject( nIndex );
		SbaFieldDescr *pFieldDescr = pRow->GetActFieldDescr();
		if(!pFieldDescr)
			return sal_False;
		else
		{
			//////////////////////////////////////////////////////////////
			// Wenn Feldtyp Memo oder Image, kein PrimKey
			// oder wenn Spalten nicht gedroped werden knnen und das Required Flag ist nicht gesetzt
			// oder wenn eine ::com::sun::star::sdbcx::View vorhanden ist und das Required Flag nicht gesetzt ist
			aFieldType = pFieldDescr->GetFieldType();
			if( (aFieldType==dbMemo) || (aFieldType==dbImage) ||
				(bDropNotAllowed && !((SbaExtFieldDescr*)pFieldDescr)->IsRequired()) ||
				(pTableDef->GetTable()->IsView() && !(((SbaExtFieldDescr*)pFieldDescr)->IsRequired() || pFieldDescr->IsAutoIncrement())))
				return sal_False;
		}

		nIndex = NextSelectedRow();
	}

	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::Command(const CommandEvent& rEvt)
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	switch (rEvt.GetCommand())
	{
		case COMMAND_CONTEXTMENU:
		{
			//////////////////////////////////////////////////////////////
			// Falls kein MouseEvent, an Basisklasse weiterleiten
			if (!rEvt.IsMouseEvent())
			{
				SbaTableDesignCtrl::Command(rEvt);
				return;
			}

			//////////////////////////////////////////////////////////////
			// Kontextmenu einblenden
			if( !IsReadOnly() )
			{
				sal_uInt16 nColId = GetColumnAtXPosPixel(rEvt.GetMousePosPixel().X());
				long   nRow = GetRowAtYPosPixel(rEvt.GetMousePosPixel().Y());

				if ( nColId == HANDLE_ID )
				{
					PopupMenu aContextMenu(SbaResId(RID_TABEDROWPOPUPMENU));
					long nSelectRowCount = GetSelectRowCount();
					sal_Bool bRowsSelected(nSelectRowCount ? sal_True : sal_False);

					aContextMenu.EnableItem( SID_CUT, IsCutAllowed(nRow) );
					aContextMenu.EnableItem( SID_COPY, IsCopyAllowed(nRow) );
					aContextMenu.EnableItem( SID_PASTE, IsPasteAllowed(nRow) );
					aContextMenu.EnableItem( SID_DELETE, IsDeleteAllowed(nRow) );
					aContextMenu.EnableItem( SID_SBA_TABED_PRIMARYKEY, IsPrimaryKeyAllowed(nRow) );
					aContextMenu.EnableItem( SID_SBA_BRW_INSERTROWS, IsInsertNewAllowed(nRow) );
					aContextMenu.CheckItem( SID_SBA_TABED_PRIMARYKEY, IsRowSelected(GetCurRow()) && IsPrimaryKey() );

					// jetzt alles, was disabled wurde, wech
					aContextMenu.RemoveDisabledEntries(sal_True, sal_True);

					//////////////////////////////////////////////////////////////
					// Alle Aktionen, die die Zeilenzahl veraendern, muessen asynchron
					// ausgefuehrt werden->sonst Probleme zwischen Kontextmenu u. Browser
					nDataPos = GetCurRow();
					switch (aContextMenu.Execute(this, rEvt.GetMousePosPixel()))
					{
						case SID_CUT:
							Cut();
							break;
						case SID_COPY:
							Copy();
							break;
						case SID_PASTE:
							Paste();
							break;
						case SID_DELETE:
							if( nDeleteEvent )
								Application::RemoveUserEvent( nDeleteEvent );
							nDeleteEvent = Application::PostUserEvent( LINK(this, SbaTableEditorCtrl, DelayedDelete) );
							break;
						case SID_SBA_BRW_INSERTROWS:
							if( nInsNewRowsEvent )
								Application::RemoveUserEvent( nInsNewRowsEvent );
							nInsNewRowsEvent = Application::PostUserEvent( LINK(this, SbaTableEditorCtrl, DelayedInsNewRows) );
							break;
						case SID_SBA_TABED_PRIMARYKEY:
							SetPrimaryKey( !IsPrimaryKey() );
							break;
						default:
							break;
					}
				}
			}
		}
		break;
		default:
			SbaTableDesignCtrl::Command(rEvt);
	}

}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, DelayedCut, void*, EMPTYTAG )
{
	nCutEvent = 0;
	SbaTableDesignCtrl::Cut();
	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, DelayedPaste, void*, EMPTYTAG )
{
	nPasteEvent = 0;

	// die Zeile, bei der eigefuegt werden wuerde
	sal_Int32 nPastePosition = GetSelectRowCount() ? FirstSelectedRow() : GetCurRow();

	if (!IsInsertNewAllowed(nPastePosition))
	{	// kein Einfuegen erlaubt, sondern nur anhaengen, also testen, ob hinter der PastePosition noch
		// belegte Zeilen erscheinen

		sal_Int32 nFreeFromPos;	// ab da nur freie Zeilen
		SbaTabEdRow* pRow;
		for(nFreeFromPos = pRowList->Count(), pRow = pRowList->Last();
			nFreeFromPos > 0  && (!pRow || !pRow->GetActFieldDescr() || !pRow->GetActFieldDescr()->GetName().Len());
			--nFreeFromPos, pRow = pRowList->Prev())
			;
		if (nPastePosition < nFreeFromPos)	// es gibt mindestens eine belegte hinter PastePosition -> ganz nach hinten
			nPastePosition = nFreeFromPos;
	}

	SbaTableDesignCtrl::Paste( nPastePosition );
	SetNoSelection();
	GoToRow( nPastePosition );

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, DelayedDelete, void*, EMPTYTAG )
{
	nDeleteEvent = 0;
	DeleteRows();
	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableEditorCtrl, DelayedInsNewRows, void*, EMPTYTAG )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	nInsNewRowsEvent = 0;
	InsertNewRows( GetSelectRowCount() ? FirstSelectedRow() : nDataPos );
	SetNoSelection();
	GoToRow( nDataPos );

	return 0;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::SetPrimaryKey( sal_Bool bSet )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Evtl. vorhandene Primary Keys loeschen
	MultiSelection aDeletedPrimKeys;
	aDeletedPrimKeys.SetTotalRange( Range(0,GetRowCount()) );
	SbaTabEdRow* pRow = pRowList->First();
	long nIndex;

	while( pRow )
	{
		SbaFieldDescr *pFieldDescr = pRow->GetActFieldDescr();
		if( pFieldDescr && pRow->IsPrimaryKey() )
		{
			pRow->SetPrimaryKey( sal_False );
			if( !bSet )
			{

				if(pFieldDescr->ISA(SbaExtFieldDescr))
				{
					((SbaExtFieldDescr*)pFieldDescr)->SetRequired(sal_True);
					((SbaExtFieldDescr*)pFieldDescr)->SetDefault(String());
					//////////////////////////////////////////////////////////////////////
					// Die Fielddesription updaten
					pDescrWin->DisplayData(pFieldDescr);
				}
			}

			nIndex = pRowList->GetPos( pRow );
			aDeletedPrimKeys.Insert( nIndex );
			aDeletedPrimKeys.Select( nIndex );
		}
		pRow = pRowList->Next();
	}

	//////////////////////////////////////////////////////////////////////
	// Die Primary Keys der markierten Zeilen setzen
	MultiSelection aInsertedPrimKeys;
	aInsertedPrimKeys.SetTotalRange( Range(0,GetRowCount()) );
	if( bSet )
	{
		nIndex = FirstSelectedRow();
		while( nIndex >= 0 )
		{
			//////////////////////////////////////////////////////////////////////
			// Key setzen
			pRow = pRowList->GetObject( nIndex );
			SbaFieldDescr *pFieldDescr = pRow->GetActFieldDescr();
			if(pFieldDescr)
			{
				pRow->SetPrimaryKey( sal_True );

				if(pFieldDescr->ISA(SbaExtFieldDescr))
				{
					((SbaExtFieldDescr*)pFieldDescr)->SetRequired(sal_True);
					((SbaExtFieldDescr*)pFieldDescr)->SetDefault(String());
					//////////////////////////////////////////////////////////////////////
					// Die Fielddesription updateten
					pDescrWin->DisplayData(pFieldDescr);
				}

				aInsertedPrimKeys.Insert( nIndex );
				aInsertedPrimKeys.Select( nIndex );
			}

			nIndex = NextSelectedRow();
		}
	}

	GetUndoManager()->AddUndoAction( new SbaPrimKeyUndoAct(this, aDeletedPrimKeys, aInsertedPrimKeys) );

	//////////////////////////////////////////////////////////////////////
	// Handle-Spalte invalidieren
	InvalidateHandleColumn();


	//////////////////////////////////////////////////////////////////////
	// Das ModifyFlag der TableDocSh setzen
	GetDocShell()->SetModified( sal_True );
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
}

//------------------------------------------------------------------------------
sal_Bool SbaTableEditorCtrl::IsPrimaryKey()
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Gehoeren alle markierten Felder zu einem Primary Key ?
	long nRow = 0;
	long nPrimaryKeys = 0;
	SbaTabEdRow* pRow = pRowList->First();
	while( pRow )
	{
		if( IsRowSelected(nRow) && !pRow->IsPrimaryKey() )
			return sal_False;
		if( pRow->IsPrimaryKey() )
			nPrimaryKeys++;

		pRow = pRowList->Next();
		nRow++;
	}

	//////////////////////////////////////////////////////////////////////
	// Gibt es unselektierte Felder, die noch zu dem Key gehoeren ?
	if( GetSelectRowCount() != nPrimaryKeys )
		return sal_False;

	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableEditorCtrl::SwitchType( const String& rType )
{
	DBG_CHKTHIS(SbaTableEditorCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Wenn noch kein Feldname vergeben wurde
	long nRow(GetCurRow());
	SbaFieldDescr* pActFieldDescr = GetFieldDescr( nRow );
	if( pActFieldDescr )
		//////////////////////////////////////////////////////////////////////
		// Alte Beschreibung speichern
		pDescrWin->SaveData( pActFieldDescr );

	//////////////////////////////////////////////////////////////////////
	// Neue Beschreibung darstellen
	SbaTabEdRow* pRow = pRowList->GetObject( nRow );
	pRow->SetFieldType( rType );
	pTypeCell->SelectEntry( rType );

	SbaFieldDescr* pNewDescr = pRow->GetActFieldDescr();
	// ich missbrauche mal die SbaColumn : sie liefert mir fuer den eingestellten Typ einen Standard-FormatKey
	// (nyi: es sollte eine unabhaengige Funktion GetStandardFormatKey(SbaFieldType) geben)
	if ((pNewDescr != NULL) && (pNewDescr->GetFormatKey() == 0) && pNewDescr->GetFieldType() != dbNone)
	{
		SbaColumnRef xTempCol = DBObj().CreateColumn(String::CreateFromAscii("TempCol"), pNewDescr->GetFieldType(), 0, 0, sal_False, 0, 0 );
		SfxUInt32Item& rFormatItem = (SfxUInt32Item&)xTempCol->Get(SBA_DEF_FMTVALUE);
		pNewDescr->SetFormatKey(rFormatItem.GetValue());
	}

	pDescrWin->DisplayData( pNewDescr );
}

//==================================================================
// class SbaTableDesignWin
//==================================================================
DBG_NAME(SbaTableDesignWin);
//------------------------------------------------------------------------------
SbaTableDesignWin::SbaTableDesignWin( Window* pParent, SbaTableDef* pDef, SbaTableDesignViewSh* pView ) :
	Window( pParent ),
	pViewSh( pView ),
	pTableDef( pDef ),
	m_aHorzSplitter( this ),
	m_aVertSplitter( this ,WB_HSCROLL),
	nStartIndexingEvent(0)
{
	DBG_CTOR(SbaTableDesignWin,NULL);
	ImplInitSettings( sal_True, sal_True, sal_True );

	//////////////////////////////////////////////////////////////////////
	// Childs erzeugen
	pEditorCtrl = new SbaTableEditorCtrl( this, pDef, (SbaTableViewSh*)pView );
	pEditorCtrl->Init();

	pFieldDescWin = new SbaTableFieldDescWin( this, pView );
	pFieldDescWin->Init();
	pFieldDescWin->SetHelpId(HID_TAB_DESIGN_DESCWIN);

	m_pDescWin = new SbaTableDescWin(this,pView );
	m_pDescWin->SetHelpId(HID_TAB_DESIGN_TABLE_PROPS);

	// set depending windows and controls
	pEditorCtrl->SetDescrWin(pFieldDescWin);
	pEditorCtrl->SetTableDescrWin(m_pDescWin);

	pFieldDescWin->SetEditorCtrl(pEditorCtrl);
	m_pDescWin->SetEditorCtrl(pEditorCtrl);

	// first call after the editctrl has been set
	m_pDescWin->Init();

	pEditorCtrl->Show();
	pFieldDescWin->Show();
	m_pDescWin->Show();

	//////////////////////////////////////////////////////////////////////
	// Splitter einrichten
	m_aHorzSplitter.SetSplitHdl( LINK(this, SbaTableDesignWin, SplitHdl) );
	m_aHorzSplitter.Show();

	m_aVertSplitter.SetSplitHdl( LINK(this, SbaTableDesignWin, SplitHdl) );
	m_aVertSplitter.Show();
}

//------------------------------------------------------------------------------
SbaTableDesignWin::~SbaTableDesignWin()
{
	DBG_DTOR(SbaTableDesignWin,NULL);
	//////////////////////////////////////////////////////////////////////
	// Childs zerstoeren
	pEditorCtrl->Hide();
	pFieldDescWin->Hide();
	m_pDescWin->Hide();

	delete pEditorCtrl;
	delete pFieldDescWin;
	delete m_pDescWin;
	if( nStartIndexingEvent )
		Application::RemoveUserEvent( nStartIndexingEvent );
}

//------------------------------------------------------------------------------

void SbaTableDesignWin::ImplInitSettings( sal_Bool bFont, sal_Bool bForeground, sal_Bool bBackground )
{
	DBG_CHKTHIS(SbaTableDesignWin,NULL);
	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();

	if ( bFont )
	{
		Font aFont = rStyleSettings.GetAppFont();
		if ( IsControlFont() )
			aFont.Merge( GetControlFont() );
		SetPointFont( aFont );
//		Set/*Zoomed*/PointFont( aFont );
	}

	if ( bFont || bForeground )
	{
		Color aTextColor = rStyleSettings.GetButtonTextColor();
		if ( IsControlForeground() )
			aTextColor = GetControlForeground();
		SetTextColor( aTextColor );
	}

	if ( bBackground )
	{
		if( IsControlBackground() )
			SetBackground( GetControlBackground() );
		else
			SetBackground( rStyleSettings.GetFaceColor() );
	}
}

// -----------------------------------------------------------------------

void SbaTableDesignWin::DataChanged( const DataChangedEvent& rDCEvt )
{
	DBG_CHKTHIS(SbaTableDesignWin,NULL);
	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
		 (rDCEvt.GetFlags() & SETTINGS_STYLE) )
	{
		ImplInitSettings( sal_True, sal_True, sal_True );
		Invalidate();
	}
	else
		Window::DataChanged( rDCEvt );
}

//------------------------------------------------------------------------------
void SbaTableDesignWin::Resize()
{
	DBG_CHKTHIS(SbaTableDesignWin,NULL);
	ArrangeChilds( m_aHorzSplitter.GetSplitPosPixel() );
	ArrangeChildsVert( m_aVertSplitter.GetSplitPosPixel() );
}

//------------------------------------------------------------------------------
void SbaTableDesignWin::ArrangeChilds( long nSplitPos )
{
	DBG_CHKTHIS(SbaTableDesignWin,NULL);
	const long nSplitterHeight(3);

	//////////////////////////////////////////////////////////////////////
	// Abmessungen parent window
	Size aOutputSize( GetOutputSizePixel() );
	long nOutputWidth = aOutputSize.Width();
	long nOutputHeight = aOutputSize.Height();
	long nVertSize = m_aVertSplitter.GetSplitPosPixel();

	//////////////////////////////////////////////////////////////////////
	// Verschiebebereich Splitter mittleres Drittel des Outputs
	long nDragPosY = nOutputHeight/3;
	long nDragSizeHeight = nOutputHeight/3;
	m_aHorzSplitter.SetDragRectPixel( Rectangle(Point(0,nDragPosY), Size(nOutputWidth,nDragSizeHeight) ), this );
	if( (nSplitPos < nDragPosY) || (nSplitPos > (nDragPosY+nDragSizeHeight)) )
		nSplitPos = nDragPosY+nDragSizeHeight-5;

	//////////////////////////////////////////////////////////////////////
	// Splitter setzen
	m_aHorzSplitter.SetPosSizePixel( Point( 0, nSplitPos ), Size(nOutputWidth, nSplitterHeight));
	m_aHorzSplitter.SetSplitPosPixel( nSplitPos );

	m_aVertSplitter.SetPosSizePixel( Point( nVertSize, 0 ), Size(nSplitterHeight,nSplitPos));

	//////////////////////////////////////////////////////////////////////
	// Fenster setzen
	long nEditCrtl_X = 0.3 * nOutputWidth;

	pEditorCtrl->SetPosSizePixel( Point(0, 0), Size(nVertSize-nSplitterHeight , nSplitPos) );

	pFieldDescWin->SetPosSizePixel(	Point(0, nSplitPos+nSplitterHeight),
						Size(nOutputWidth, nOutputHeight-nSplitPos-nSplitterHeight) );

	m_pDescWin->SetPosSizePixel(Point(nVertSize+nSplitterHeight, 0),Size(nOutputWidth-nVertSize-2*nSplitterHeight, nSplitPos));
}
//------------------------------------------------------------------------------
void SbaTableDesignWin::ArrangeChildsVert( long nSplitPos )
{
	DBG_CHKTHIS(SbaTableDesignWin,NULL);
	const long nSplitterWidth(3);

	//////////////////////////////////////////////////////////////////////
	// Abmessungen parent window
	Size aOutputSize( GetOutputSizePixel() );
	long nOutputWidth = aOutputSize.Width();
	long nOutputHeight = aOutputSize.Height();

	long nEditHeight = pEditorCtrl->GetSizePixel().Height();

	//////////////////////////////////////////////////////////////////////
	// Verschiebebereich Splitter mittleres Drittel des Outputs
	long nDragPosX = nOutputWidth/3;
	long nDragSizeWidth = nDragPosX;

	long nDescrHeight = pFieldDescWin->GetSizePixel().Height();

	m_aVertSplitter.SetDragRectPixel( Rectangle(Point(nDragPosX,0), Size(nDragSizeWidth,nOutputHeight-nSplitterWidth) ), this );
	if( (nSplitPos < nDragPosX) || (nSplitPos > (nDragPosX+nDragSizeWidth)) )
		nSplitPos = nDragPosX+nDragSizeWidth-5;

	//////////////////////////////////////////////////////////////////////
	// Splitter setzen
	m_aVertSplitter.SetPosSizePixel( Point( nSplitPos,0 ), Size(nSplitterWidth,nOutputHeight-nDescrHeight -nSplitterWidth));
	m_aVertSplitter.SetSplitPosPixel( nSplitPos );

	//////////////////////////////////////////////////////////////////////
	// Fenster setzen
	long nEditCrtl_X = 0.3 * nSplitPos;

	pEditorCtrl->SetPosSizePixel( Point(0,0), Size(nSplitPos-nSplitterWidth,nEditHeight) );

	m_pDescWin->SetPosSizePixel(Point(nSplitPos+nSplitterWidth ,0),Size(nOutputWidth-nSplitPos-nSplitterWidth, nEditHeight));
}
//------------------------------------------------------------------------------
IMPL_LINK( SbaTableDesignWin, SplitHdl, Splitter*, pSplit )
{
	long nSplitPos = pSplit->GetSplitPosPixel();

	if(pSplit == &m_aHorzSplitter)
	{
		pSplit->SetPosPixel( Point(0, nSplitPos) );
		ArrangeChilds( nSplitPos );
	}
	else
	{
		pSplit->SetPosPixel( Point(nSplitPos,0) );
		ArrangeChildsVert( nSplitPos );
	}

	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableDesignWin, SwitchHdl, Accelerator*, pAcc )
{
	if( pEditorCtrl->IsReadOnly() )
		return 0;

	if( pFieldDescWin->HasChildPathFocus() )
	{
		pFieldDescWin->LoseFocus();
		pEditorCtrl->GrabFocus();
	}
	else if (pEditorCtrl->HasChildPathFocus())
	{
		m_pDescWin->GrabFocus();
	}
	else
	{
		SbaTabEdRow* pRow = pEditorCtrl->GetRowList()->GetObject(pEditorCtrl->GetCurRow());
		SbaFieldDescr* pFieldDescr = pRow ? pRow->GetActFieldDescr() : NULL;
		if (pFieldDescr)
			pFieldDescWin->GrabFocus();
		else
			pEditorCtrl->GrabFocus();
	}

	return 0;
}

#define STANDARD_MARGIN					6
#define DETAILS_HEADER_HEIGHT			25
#define DETAILS_OPT_PAGE_WIDTH			(CONTROL_WIDTH_1 + CONTROL_SPACING_X + CONTROL_WIDTH_4 + 50)
#define DETAILS_OPT_PAGE_HEIGHT			((CONTROL_HEIGHT + CONTROL_SPACING_Y) * 5)
#define DETAILS_MIN_HELP_WIDTH			100
#define DETAILS_OPT_HELP_WIDTH			200
#define DETAILS_MIN_HELP_HEIGHT			50
#define DETAILS_OPT_HELP_HEIGHT			100

//==================================================================
// class SbaTableDescWin
//==================================================================
//------------------------------------------------------------------------------
SbaTableDescWin::SbaTableDescWin( Window* pParent, SbaTableDesignViewSh* pView )
	:TabPage(pParent, WB_3DLOOK)
	,m_pViewSh(pView)
	,m_pEditorCtrl(NULL)
	,m_bModified(sal_False)
	,m_pHeader(NULL)
{
	m_pTextWin = new MultiLineEdit( this, WB_VSCROLL | WB_LEFT | WB_BORDER );
	m_pTextWin->SetHelpId(HID_TAB_DESIGN_TABLE_DESC);
	m_pTextWin->SetModifyHdl(LINK(this, SbaTableDescWin, OnModified)) ;
	m_pTextWin->Show();

	m_pCBRowVersion = new CheckBox(this,WB_LEFT);
	m_pCBRowVersion->SetText(String(SbaResId(STR_TAB_ROWVERSION_COLUMN)));
	m_pCBRowVersion->SetHelpId(HID_TAB_DESIGN_VERSION_FIELD);
	m_pCBRowVersion->SetClickHdl(LINK(this, SbaTableDescWin, OnClick)) ;
	m_pCBRowVersion->Show();

	m_pFTTableDesc = new FixedText(this,WB_LEFT);
	m_pFTTableDesc->SetText(String(SbaResId(STR_TAB_TABLE_DESCRIPTION)));
	m_pFTTableDesc->Show();

	m_pHeader = new FixedText( this, WB_CENTER | WB_INFO );
	m_pHeader->SetText(String(SbaResId(STR_TAB_TABLE_PROPERTIES)));
	m_pHeader->Show();
}

//------------------------------------------------------------------------------
SbaTableDescWin::~SbaTableDescWin()
{
	delete m_pTextWin;
	delete m_pCBRowVersion;
	delete m_pFTTableDesc;
	delete m_pHeader;
}

//------------------------------------------------------------------------------
String SbaTableDescWin::GetTableDesc() const { return m_pTextWin->GetText(); }

//------------------------------------------------------------------------------
void SbaTableDescWin::SetReadOnly( sal_Bool bRead )
{
	if(m_bRowVersionAvailable)
		m_pCBRowVersion->Enable(!bRead);
	m_pTextWin->Enable(!bRead);
}

//------------------------------------------------------------------------------
void SbaTableDescWin::Init()
{
	DBG_ASSERT(m_pEditorCtrl,"The EditCtrl has to be set before this call! GPF!!!");
	if(m_bRowVersionAvailable = m_pEditorCtrl->GetDocShell()->GetDatabase()->GetRowVersionTypeInfo() != NULL)
		m_pCBRowVersion->Check(m_pEditorCtrl->GetDocShell()->IsRowVersionColumn());
	else
	{
		m_pCBRowVersion->Check(m_pEditorCtrl->GetDocShell()->GetDatabase()->IsCapable(SDB_CAP_VERSIONING));
		m_pCBRowVersion->Enable(sal_False);
	}

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(m_pEditorCtrl->GetDocShell()->GetDatabase()->GetMetaData());

	if (!m_pEditorCtrl->GetDocShell()->GetDBDef()->IsNew() &&
		!(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) &&
		 (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
	{
		m_pCBRowVersion->Enable(sal_False);
	}

	SfxStringItem aPropItem	(*PTR_CAST(SfxStringItem,&((SbaDBDataDef*)m_pEditorCtrl->GetDocShell()->GetDBDef())->GetObjAttrs()->Get( SBA_DEF_TABLEPROP )));
	m_pTextWin->SetText(aPropItem.GetValue());
	if(m_pEditorCtrl->IsReadOnly())
		SetReadOnly(sal_True);
}

//------------------------------------------------------------------------------
void SbaTableDescWin::GetFocus()
{
	TabPage::GetFocus();
	if (m_pTextWin)
		m_pTextWin->GrabFocus();
}

//------------------------------------------------------------------------------
void SbaTableDescWin::Paint( const Rectangle& rRect )
{
	//////////////////////////////////////////////////////////////////////
	// 3D-Linie am oberen Fensterrand
	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();

	//////////////////////////////////////////////////////////////////////
	// 3D-Linie zum Abtrennen des Headers
	SetLineColor(rStyleSettings.GetLightColor());
	DrawLine( Point(3, DETAILS_HEADER_HEIGHT), Point(GetSizePixel().Width()-6, DETAILS_HEADER_HEIGHT) );
	SetLineColor( rStyleSettings.GetShadowColor() );
	DrawLine( Point(3, DETAILS_HEADER_HEIGHT-1), Point(GetSizePixel().Width()-6, DETAILS_HEADER_HEIGHT-1) );
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableDescWin, OnModified, void*, EMPTYARG )
{
	m_bModified = sal_True;

	m_pEditorCtrl->GetDocShell()->SetModified( sal_True );

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
	return 0L;
}

//------------------------------------------------------------------------------
IMPL_LINK( SbaTableDescWin, OnClick, CheckBox*, pCheckBox )
{
	m_bModified = sal_True;

	m_pEditorCtrl->GetDocShell()->SetRowVersionColumn(pCheckBox->IsChecked());

	m_pEditorCtrl->GetDocShell()->SetModified( sal_True );
	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
	return 0L;
}
//------------------------------------------------------------------------------
void SbaTableDescWin::Resize()
{
	//////////////////////////////////////////////////////////////////////
	// Abmessungen parent window
	Size aOutputSize( GetSizePixel() );

	m_pHeader->SetPosSizePixel( Point(0, STANDARD_MARGIN), Size(aOutputSize.Width(), 15) );

	m_pCBRowVersion->SetPosSizePixel(Point(STANDARD_MARGIN+1,DETAILS_HEADER_HEIGHT+STANDARD_MARGIN+3),
									 Size(aOutputSize.Width()-(2*STANDARD_MARGIN)-2,20));
	//////////////////////////////////////////////////////////////////////
	// TextWin anpassen
	m_pFTTableDesc->SetPosSizePixel( Point(STANDARD_MARGIN+1, DETAILS_HEADER_HEIGHT+STANDARD_MARGIN+29),
		Size(aOutputSize.Width()-(2*STANDARD_MARGIN)-2,	20) );

	m_pTextWin->SetPosSizePixel( Point(STANDARD_MARGIN+1, DETAILS_HEADER_HEIGHT+STANDARD_MARGIN+52),
		Size(aOutputSize.Width()-(2*STANDARD_MARGIN)-2,aOutputSize.Height()-(2*STANDARD_MARGIN)-55-DETAILS_HEADER_HEIGHT) );
}
//==================================================================
// class SbaTableFieldDescWin
//==================================================================
DBG_NAME(SbaTableFieldDescWin);
//------------------------------------------------------------------------------
SbaTableFieldDescWin::SbaTableFieldDescWin( Window* pParent, SbaTableDesignViewSh* pView )
	:TabPage(pParent, WB_3DLOOK)
	,pViewSh(pView)
	,pEditorCtrl(NULL)
{
	DBG_CTOR(SbaTableFieldDescWin,NULL);
	//////////////////////////////////////////////////////////////////////
	// Header
	pHeader = new FixedText( this, WB_CENTER | WB_INFO );	//  | WB_3DLOOK
	pHeader->SetText( String(SbaResId(STR_TAB_PROPERTIES)) );
	pHeader->Show();

	//////////////////////////////////////////////////////////////////////
	// HelpBar
	pHelpBar = new SbaTableDesignHelpBar( this );
	pHelpBar->SetHelpId(HID_TAB_DESIGN_HELP_TEXT_FRAME);
	pHelpBar->Show();

	pGenPage = new SbaFieldDescGenPage( this, pHelpBar );
	pGenPage->SetHelpId( HID_TABLE_DESIGN_TABPAGE_GENERAL );
	pGenPage->Show();
}

//------------------------------------------------------------------------------
SbaTableFieldDescWin::~SbaTableFieldDescWin()
{
	DBG_DTOR(SbaTableFieldDescWin,NULL);
	//////////////////////////////////////////////////////////////////////
	// Childs zerstoeren
	pHelpBar->Hide();
	pGenPage->Hide();
	pHeader->Hide();

	delete pHelpBar;
	delete pGenPage;
	delete pHeader;
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::Init()
{
	DBG_ASSERT(pGenPage != NULL, "SbaTableFieldDescWin::Init : ups ... no GenericPage ... this will crash ...");
	pGenPage->Init();
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::SetReadOnly( sal_Bool bRead )
{
	DBG_CHKTHIS(SbaTableFieldDescWin,NULL);
	pGenPage->SetReadOnly( bRead );
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::DisplayData( SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaTableFieldDescWin,NULL);
	pGenPage->DisplayData( pFieldDescr );
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::SaveData( SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaTableFieldDescWin,NULL);
	pGenPage->SaveData( pFieldDescr );
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::Paint( const Rectangle& rRect )
{
	DBG_CHKTHIS(SbaTableFieldDescWin,NULL);
	//////////////////////////////////////////////////////////////////////
	// 3D-Linie am oberen Fensterrand
	const StyleSettings& rStyleSettings = GetSettings().GetStyleSettings();

	SetLineColor( rStyleSettings.GetLightColor() );
	DrawLine( Point(0,0), Point(GetSizePixel().Width(),0) );

	//////////////////////////////////////////////////////////////////////
	// 3D-Linie zum Abtrennen des Headers
	DrawLine( Point(3, DETAILS_HEADER_HEIGHT), Point(GetSizePixel().Width()-6, DETAILS_HEADER_HEIGHT) );
	SetLineColor( rStyleSettings.GetShadowColor() );
	DrawLine( Point(3, DETAILS_HEADER_HEIGHT-1), Point(GetSizePixel().Width()-6, DETAILS_HEADER_HEIGHT-1) );
}

//------------------------------------------------------------------------------
void SbaTableFieldDescWin::Resize()
{
	DBG_CHKTHIS(SbaTableFieldDescWin,NULL);
	//////////////////////////////////////////////////////////////////////
	// Abmessungen parent window
	Size aOutputSize( GetOutputSizePixel() );
	long nOutputWidth = aOutputSize.Width();
	long nOutputHeight = aOutputSize.Height();

	// da die GenPage scrollen kann, ich selber aber nicht, positioniere ich das HelpFenster, wenn ich zu schmal werde,
	// _unter_ der Genpage, nicht rechts daneben. Zuvor versuche ich aber noch, es etwas schmaler zu machen

	sal_uInt16 nHelpX, nHelpY;
	sal_uInt16 nHelpWidth, nHelpHeight;
	sal_uInt16 nPageWidth, nPageHeight;

	// passen beide nebeneinander (Rand + Page + Rand + Help) ?
	if (STANDARD_MARGIN + DETAILS_OPT_PAGE_WIDTH + STANDARD_MARGIN + DETAILS_MIN_HELP_WIDTH <= nOutputWidth)
	{	// ja -> dann ist die Frage, ob man der Hilfe ihre Optimal-Breite geben kann
		nHelpWidth = DETAILS_OPT_HELP_WIDTH;
		nPageWidth = nOutputWidth - nHelpWidth - STANDARD_MARGIN - STANDARD_MARGIN;
		if (nPageWidth < DETAILS_OPT_PAGE_WIDTH)
		{	// dann doch lieber die Hilfe von ihrer optimalen in Richtung auf die minimale Groesse
			sal_uInt16 nTransfer = DETAILS_OPT_PAGE_WIDTH - nPageWidth;
			nPageWidth += nTransfer;
			nHelpWidth -= nTransfer;
		}
		nHelpX = nOutputWidth - nHelpWidth;
		// die Hoehen sind dann einfach ...
		nHelpY = DETAILS_HEADER_HEIGHT + 1;
		nHelpHeight = nOutputHeight - nHelpY;
		nPageHeight = nOutputHeight - STANDARD_MARGIN - DETAILS_HEADER_HEIGHT - STANDARD_MARGIN;
	}
	else
	{	// nebeneinander geht nicht, also untereinander (Rand + Header + Page + Help)
		if (STANDARD_MARGIN + DETAILS_HEADER_HEIGHT + DETAILS_OPT_PAGE_HEIGHT + DETAILS_MIN_HELP_HEIGHT <= nOutputHeight)
		{	// es reicht zumindest, um beide untereinander (Page optimal, Help minimal) unterzubringen
			nHelpHeight = DETAILS_OPT_HELP_HEIGHT;
			nPageHeight = nOutputHeight - nHelpHeight - DETAILS_HEADER_HEIGHT - STANDARD_MARGIN;
			if (nPageHeight < DETAILS_OPT_PAGE_HEIGHT)
			{	// wie oben : Page optimal, Hilfe soviel wie eben bleibt (das ist groesser/gleich ihrem Minimum)
				sal_uInt16 nTransfer = DETAILS_OPT_PAGE_HEIGHT - nPageHeight;
				nPageHeight += nTransfer;
				nHelpHeight -= nTransfer;
			}
			nHelpY = nOutputHeight - nHelpHeight;
			// und ueber die ganze Breite
			nHelpX = 0;					// ohne Margin, da das HelpCtrl einen eigenen hat
			nHelpWidth = nOutputWidth;	// dito
			nPageWidth = nOutputWidth - STANDARD_MARGIN - STANDARD_MARGIN;
		}
		else
		{	// dummerweise reicht es nicht mal, um Page optimal und Help minimal zu zeigen
			nHelpX = nHelpY = nHelpWidth = nHelpHeight = 0;	// -> kein Help-Fenster
			nPageWidth = nOutputWidth - STANDARD_MARGIN - STANDARD_MARGIN;
			nPageHeight = nOutputHeight - STANDARD_MARGIN - DETAILS_HEADER_HEIGHT - STANDARD_MARGIN;
		}
	}

	pHeader->SetPosSizePixel( Point(0, STANDARD_MARGIN), Size(nOutputWidth, 15) );

	pGenPage->SetPosSizePixel(Point	(	STANDARD_MARGIN,
										STANDARD_MARGIN + DETAILS_HEADER_HEIGHT
									),
							  Size	(	nPageWidth,
										nPageHeight
									)
							 );
	if (nHelpHeight)
	{
		pHelpBar->Show();
		pHelpBar->SetPosSizePixel(Point	(	nHelpX,
											nHelpY
										),
								  Size	(	nHelpWidth,
											nHelpHeight
										)
								 );
	}
	else
	{
		pHelpBar->Hide();
	}
	Invalidate();
}


//==================================================================
// class SbaTableDesignHelpBar
//==================================================================
DBG_NAME(SbaTableDesignHelpBar);
//------------------------------------------------------------------------------
SbaTableDesignHelpBar::SbaTableDesignHelpBar( Window* pParent ) :
	 TabPage( pParent, WB_3DLOOK )
{
	DBG_CTOR(SbaTableDesignHelpBar,NULL);
	pTextWin = new MultiLineEdit( this, WB_VSCROLL | WB_LEFT | WB_BORDER | WB_NOTABSTOP | WB_READONLY);
	pTextWin->SetHelpId(HID_TABLE_DESIGN_HELP_WINDOW);
	pTextWin->SetReadOnly();
	pTextWin->SetControlBackground( GetSettings().GetStyleSettings().GetFaceColor() );
	pTextWin->Show();
}

//------------------------------------------------------------------------------
SbaTableDesignHelpBar::~SbaTableDesignHelpBar()
{
	DBG_DTOR(SbaTableDesignHelpBar,NULL);
	delete pTextWin;
}

//------------------------------------------------------------------------------
void SbaTableDesignHelpBar::SetHelpText( const String& rText )
{
	DBG_CHKTHIS(SbaTableDesignHelpBar,NULL);
	pTextWin->SetText( rText );
	Invalidate();
}

//------------------------------------------------------------------------------
void SbaTableDesignHelpBar::Resize()
{
	DBG_CHKTHIS(SbaTableDesignHelpBar,NULL);
	//////////////////////////////////////////////////////////////////////
	// Abmessungen parent window
	Size aOutputSize( GetOutputSizePixel() );

	//////////////////////////////////////////////////////////////////////
	// TextWin anpassen
	pTextWin->SetPosSizePixel( Point(STANDARD_MARGIN+1, STANDARD_MARGIN+1),
		Size(aOutputSize.Width()-(2*STANDARD_MARGIN)-2,
			 aOutputSize.Height()-(2*STANDARD_MARGIN)-2) );

}

//------------------------------------------------------------------------------
long SbaTableDesignHelpBar::PreNotify( NotifyEvent& rNEvt )
{
	if (rNEvt.GetType() == EVENT_LOSEFOCUS)
		SetHelpText(String());
	return TabPage::PreNotify(rNEvt);
}

//==================================================================
// class SbaFieldDescGenPage
//==================================================================

DBG_NAME(SbaFieldDescGenPage);
//==================================================================
//------------------------------------------------------------------------------
SbaFieldDescGenPage::SbaFieldDescGenPage( Window* pParent, SbaTableDesignHelpBar* pHelp ) :
	 TabPage( pParent, WB_3DLOOK | WB_DIALOGCONTROL )
{
	DBG_CTOR(SbaFieldDescGenPage,NULL);
	m_pFieldControl = new SbaTableFieldControl(this,pHelp);
	m_pFieldControl->SetHelpId(HID_TAB_DESIGN_FIELDCONTROL);
	m_pFieldControl->Show();
}
//------------------------------------------------------------------------------
SbaFieldDescGenPage::~SbaFieldDescGenPage()
{
	DBG_DTOR(SbaFieldDescGenPage,NULL);
	delete m_pFieldControl;
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::Init()
{
	DBG_ASSERT(GetEditorCtrl() != NULL, "SbaFieldDescGenPage::Init : have no editor control !");

	m_pFieldControl->Init();
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::Resize()
{
	m_pFieldControl->SetPosSizePixel(Point(0,0),GetSizePixel());
	m_pFieldControl->Resize();
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::SetReadOnly( sal_Bool bReadOnly )
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);

	m_pFieldControl->SetReadOnly(bReadOnly);
}
//------------------------------------------------------------------------------
String SbaFieldDescGenPage::GetControlText( sal_uInt16 nControlId )
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	return m_pFieldControl->GetControlText(nControlId);
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::SetControlText( sal_uInt16 nControlId, const String& rText )
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	//////////////////////////////////////////////////////////////////////
	// Texte der Controls setzen
	m_pFieldControl->SetControlText(nControlId,rText);
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::DisplayData( SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);

	m_pFieldControl->DisplayData(pFieldDescr);
}
//------------------------------------------------------------------------------
SbaTableEditorCtrl* SbaFieldDescGenPage::GetEditorCtrl()
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	SbaTableDesignWin* pDesignWin = (SbaTableDesignWin*)GetParent()->GetParent();
	return pDesignWin->GetEditorCtrl();
}
//------------------------------------------------------------------------------
short SbaFieldDescGenPage::GetFormatCategory(SbaFieldDescr* pFieldDescr)
{
	return m_pFieldControl->GetFormatCategory(pFieldDescr);
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::ActivatePropertyField(sal_uInt16 nVirtualField)
{
	m_pFieldControl->ActivatePropertyField(nVirtualField);
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::SaveData( SbaFieldDescr* pFieldDescr )
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	m_pFieldControl->SaveData(pFieldDescr);
}
//------------------------------------------------------------------------------
sal_Bool SbaFieldDescGenPage::ChildHasFocus()
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);

	return m_pFieldControl->ChildHasFocus();
}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::GetFocus()
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	//////////////////////////////////////////////////////////////////////
	// Setzt den Focus auf das zuletzt aktive Control
	TabPage::GetFocus();
	m_pFieldControl->GetFocus();

}
//------------------------------------------------------------------------------
void SbaFieldDescGenPage::LoseFocus()
{
	DBG_CHKTHIS(SbaFieldDescGenPage,NULL);
	m_pFieldControl->LoseFocus();
	TabPage::LoseFocus();
}

DBG_NAME(SbaFieldPropTabCtrl);
//==================================================================
SbaFieldPropTabCtrl::SbaFieldPropTabCtrl( Window* pParent, WinBits nWinStyle ) :
	TabControl( pParent, nWinStyle )
{
	DBG_CTOR(SbaFieldPropTabCtrl,NULL);
}

//------------------------------------------------------------------------------
SbaFieldPropTabCtrl::~SbaFieldPropTabCtrl()
{
	DBG_DTOR(SbaFieldPropTabCtrl,NULL);
}

