/*************************************************************************
 *
 *  $RCSfile: sbatabid.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <sdb/tools.hxx>
#include "sbasltid.hrc"
#include "sbaresid.hrc"
#include "sbahlpid.hrc"

#ifndef _SFX_BINDINGS_HXX //autogen
#include <sfx2/bindings.hxx>
#endif

#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif

#ifndef _MyEDITENG_HXX //autogen
#include <svx/editeng.hxx>
#endif

#ifndef _SBA_TABEDUNDO_HXX
#include "tabedund.hxx"
#endif

#ifndef _NEW_HXX
#include <tools/new.hxx>
#endif

#ifndef _SDB_SDBTAB_HXX //autogen
#include <sdb/sdbtab.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

#ifndef _SBA_EDITBRW_HXX
#include "editbrw.hxx"
#endif // _SBA_EDITBRW_HXX

#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif

#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif

#ifndef _SBA_SBATABID_HXX
#include "sbatabid.hxx"
#endif

#include <sbaobj.hxx>
// MS-VC 4.1 Compiler has a problem with the stl
#define WB_LEFT 				((WinBits)0x00004000)
#define WB_CENTER				((WinBits)0x00008000)
#define WB_RIGHT				((WinBits)0x00010000)

//==============================================================================

TYPEINIT1(SbaTableIndexCtrl, DBView);

//==============================================================================

#define HANDLE_ID		0

// Verwendete Spalten
#define INDEX_QUALIFIER	1
#define INDEX_NAME		2
#define FIELD_NAME		3
#define SORT_ORDER		4
#define INDEX_UNIQUE	5

// Anzahl Spalten beim Neuanlegen
#define NEWCOLS		   50

// default Spaltenbreiten
#define INDEXNAME_WIDTH		150
#define INDEXFIELD_WIDTH	150

//==================================================================

//==================================================================
DBG_NAME(SbaIndexUndoAction);
class SbaIndexUndoAction : public DBUndoAction
{
	friend class SbaTableIndexCtrl;
	SbaIndexInfo* pIndexInfo;

public:
	TYPEINFO();

	SbaIndexUndoAction(SbaTableIndexCtrl& rOwn, const SbaIndexInfo& rInfo, long nPos, sal_uInt16 nCol)
		:DBUndoAction(rOwn, nPos, nCol)
		,pIndexInfo(new SbaIndexInfo(rInfo)){DBG_CTOR(SbaIndexUndoAction,NULL);}

	virtual ~SbaIndexUndoAction() {DBG_DTOR(SbaIndexUndoAction,NULL);pIndexInfo->ReleaseRef();}

	SbaIndexInfo* GetInfo() const {return pIndexInfo;}
	void Set(SbaIndexInfo* pInfo, long nPos, sal_uInt16 nCol);
};

TYPEINIT1(SbaIndexUndoAction, DBUndoAction);

//------------------------------------------------------------------------------

void SbaIndexUndoAction::Set(SbaIndexInfo* pInfo, long nPos, sal_uInt16 nCol)
{
	pIndexInfo->ReleaseRef();
	pIndexInfo = pInfo;
	pIndexInfo->AddRef();

	SetColId(nCol);
	SetRow(nPos);
}

//==================================================================
DBG_NAME(SbaTableIndexCtrl);
void SbaTableIndexCtrl::Init()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	SbaTableDesignCtrl::Init();

	SbaTableDocSh* pShell = GetDocShell();

	// if we are constructed with an updatable doc UI, we have to lock the table def:
	// In our (ugly) locking mechanism the view is responsible for maintaining the def's locking state.
	// As the user can't open an index design view directly, a doc non-read-only UI means that the user
	// came from the table design view which was in update mode, hence it had the table def locked. Upon
	// destruction it will release this lock, so we have to adopt that locking state.
	if (!pShell->IsReadOnlyUI())
	{
		pTableDef->SetLock( TRUE );
		m_bDefObjectLocked = TRUE;
	}

	// initialies Updatable-Verhalten
	if (pTableDef->IsUsed())
		GetDocShell()->SetReadOnlyUI(sal_True);

	sal_Bool bDocReadOnlyUI(GetDocShell()->IsReadOnlyUI());

	sal_Bool bDocReadOnlyMedium(GetDocShell()->IsReadOnlyMedium());
	if (pTableDef->IsNew())
		// since the fixes for 69717/70160 the medium for new defs is always readonly, so ignore this
		// (the URLS for new objects are encoded since the latter fix)
		// (to be honest, it was a bug that it wasn't ro formerly, caused by our ::com::sun::star::util::URL scheme which was
		// misinterpreted by SFX)
		// FS - 01.12.99
		bDocReadOnlyMedium = sal_False;

	SetUpdatable(!IsStrongReadOnly() && !bDocReadOnlyUI && !bDocReadOnlyMedium);

	// die Spaltennamen
	String aColumnName(SbaResId(STR_TAB_INDEX_QUALIFIER));
	long nLabWidth = GetTextWidth(aColumnName) + GetTextWidth('0') * 4;
	InsertDataColumn(1, aColumnName, nLabWidth);

	aColumnName = String(SbaResId(STR_TAB_INDEX_NAME));
	InsertDataColumn(2, aColumnName, INDEXNAME_WIDTH);

	aColumnName = String(SbaResId(STR_TAB_INDEX_FIELD));
	InsertDataColumn(3, aColumnName, INDEXFIELD_WIDTH);

	aColumnName = String(SbaResId(STR_TAB_INDEX_SORTORDER));
	nLabWidth = GetTextWidth(aColumnName) + GetTextWidth('0') * 4;
	InsertDataColumn(4, aColumnName, nLabWidth);

	aColumnName = String(SbaResId(STR_TAB_INDEX_UNIQUE));
	nLabWidth = GetTextWidth(aColumnName) + GetTextWidth('0') * 4;
	InsertDataColumn(5, aColumnName, nLabWidth);

	UpdateAll();

	GoToRowColumnId(0, INDEX_NAME);
	ActivateCell();
}

//------------------------------------------------------------------------
void SbaTableIndexCtrl::UpdateAll()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);

	if (Controller().Is() && Controller()->IsModified())
		Controller()->ClearModified();

	RowRemoved(0, GetRowCount(), sal_False);
	nDataPos = 0;

	for (sal_uInt32 i = 0; i < aInfoCols.Count(); ++i)
		aInfoCols.GetObject(i)->ReleaseRef();
	aInfoCols.Clear();

	if (!DBObj().IsOpen())
		return;
	else
	{
		//////////////////////////////////////////////////////////////////
		// Einfuegen der Zeilen ins Fenster
		InitCellController();
		const SbaIndexList& rIndexDefs = pTableDef->GetOriginalIndexDefs();
		SbaDatabase* pDatabase = pTableDef->GetDatabase();

		for( sal_uInt32 i=0; i<rIndexDefs.Count(); i++ )
		{
			SbaIndexDef* pIndexDef = rIndexDefs.GetObject(i);
			const SdbColumnsRef xColumns = pIndexDef->GetColumns();
			sal_uInt16 nColCount = xColumns->Count();

			aInfoCols.Insert( new SbaIndexInfo(*(*xColumns)[1], pIndexDef->GetName(), pIndexDef->GetQualifier(), pIndexDef->IsUnique(),pIndexDef->IsSystemReadOnly()),LIST_APPEND );
			for (sal_uInt16 j = 2; j < nColCount; j++)
			{
				const SdbColumn* pTest = (*xColumns)[j];
				aInfoCols.Insert( new SbaIndexInfo(*pTest), LIST_APPEND );
			}

			RowInserted( GetRowCount(), nColCount - 1, sal_False );
		}

		//////////////////////////////////////////////////////////////////
		// Leere Zeilen auffuellen
		sal_uInt32 nRowCount = GetRowCount();
		for( i = nRowCount; i < NEWCOLS; i++ )
			aInfoCols.Insert( new SbaIndexInfo, LIST_APPEND );

		RowInserted( nRowCount, NEWCOLS - nRowCount, sal_False );
	}
}

//==================================================================

SbaTableIndexCtrl::SbaTableIndexCtrl(Window* pWindow, SbaTableDef* pDef, SbaTableViewSh* pV)
				   :SbaTableDesignCtrl(pWindow, SbaResId(RID_DB_INDEX_EDITOR))
				   ,DBView(this, NULL)
				   ,pDataCol(NULL)
				   ,pCurrentCol(NULL)
				   ,pIndexNameCell(NULL)
				   ,pIndexFieldCell(NULL)
				   ,pSortingCell(NULL)
				   ,pUniqueCell(NULL)
				   ,nTableEvent(0)
				   ,pTableDef(pDef)
				   ,pViewSh(pV)
				   ,nNoIndexNameEvent(0)
				   ,nNoFieldNameEvent(0)
				   ,nDuplicateIndexEvent(0)
				   ,m_bDefObjectLocked(0)
{
	DBG_CTOR(SbaTableIndexCtrl,NULL);
	SetHelpId(HID_INDEXDESIGN_BACKGROUND);
	GetDataWindow().SetHelpId(HID_CTL_INDEXEDIT);

	//////////////////////////////////////////////////////////////////////
	// Clipboard Format registrieren
	Clipboard::Clear();
	nClipboardFormat = Clipboard::RegisterFormatName( String::CreateFromAscii("Tabid") );

	// testen, ob alle harten Voraussetzungen fuer Editieren erfuellt sind
	SbaTableDocSh* pShell = GetDocShell();
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pTableDef->GetDatabase()->GetMetaData());
	m_bStrongReadOnly = !rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::INDEX_SIZE);
	m_bStrongReadOnly |= (pTableDef->GetTablePrivileges() & SDB_PR_ALTER) == 0;
}

//------------------------------------------------------------------------------

void SbaTableIndexCtrl::InitCellController()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	if (!DBObj().IsOpen() || pIndexNameCell)
		return;

	pIndexNameCell  = new EditCtrl( &GetDataWindow(), WB_LEFT ,DBObj().GetDatabase());
	pIndexNameCell->SetHelpId(HID_INDEXDESIGN_NAMECELL);
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData = DBObj().GetDatabase()->GetMetaData();
	xub_StrLen nMaxIndexLen(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::INDEX_SIZE));

	pIndexNameCell->SetMaxTextLen(nMaxIndexLen);

	pIndexFieldCell = new DbListBoxCtrl(&GetDataWindow());
	pIndexFieldCell->SetHelpId(HID_INDEXDESIGN_FIELDCELL);
	pIndexFieldCell->InsertEntry(String());
	const SdbColumnsRef aColumns = DBObj().GetTable()->OriginalColumns();
	for (sal_uInt16 i = 1; i < aColumns->Count(); i++)
	{
		const SdbColumn* pCol = (*aColumns)[i];
		switch(pCol->GetType())
		{
			case SDB_DBTYPE_LONGVARBINARY:
			case SDB_DBTYPE_VARBINARY:
			case SDB_DBTYPE_BINARY:
			case SDB_DBTYPE_LONGVARCHAR:
			case SDB_DBTYPE_UNKNOWN:
				break;
			default:
				pIndexFieldCell->InsertEntry(pCol->GetName());
		}

	}

	if (DBObj().GetDatabase()->IsCapable(SDB_CAP_DESC_INDEX))
	{
		pSortingCell = new DbListBoxCtrl(&GetDataWindow());
		pSortingCell->SetHelpId(HID_INDEXDESIGN_SORTCELL);
		pSortingCell->InsertEntry(String(SbaResId(STR_VALUE_ASC)));
		pSortingCell->InsertEntry(String(SbaResId(STR_VALUE_DESC)));
	}
	pUniqueCell = new DbCheckBoxCtrl(&GetDataWindow());
	pUniqueCell->SetHelpId(HID_INDEXDESIGN_UNIQUECELL);
	pUniqueCell->GetBox().EnableTriState(sal_False);
}

//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::PutData(String& rErrorText)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBG_ASSERT(DBObj().IsOpen(), "Datenobjekt nicht geoeffnet!");

	//////////////////////////////////////////////////////////////////////
	// Sicherstellen, da der aktuelle Wert gespeichert wird
	if( Controller().Is() && Controller()->IsModified() )
		SaveModified();

	SbaIndexList& rIndexDefs = pTableDef->GetIndexDefs();
	rIndexDefs.Clear();

	//////////////////////////////////////////////////////////////////////
	// Indexliste mit Inhalt des Browsers abstimmen
	SbaIndexDef* pIndexDef = NULL;
	SbaDatabase* pDatabase = pTableDef->GetDatabase();

	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDatabase->GetMetaData());
	sal_uInt32 nMaxColumnLen(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::INDEX_SIZE));
	sal_uInt32 nMaxColumns(rMetaData->getLimit( ::com::sun::star::data::DatabaseLimit::COLUMNS_IN_INDEX ));
	sal_uInt32 nRowCount(GetRowCount());

	for( sal_uInt32 i=0; i<nRowCount; i++ )
	{
		SbaIndexInfo* pInfo = aInfoCols.GetObject(i);
		if( !pInfo )
			continue;

		//////////////////////////////////////////////////////////////////////
		// Wird ein neuer Indexname gefunden, dann wird ein  neuer ::com::sun::star::sdbcx::Index erzeugt ...
		if( pInfo->aIndexName.Len() && !rIndexDefs.Lookup( pInfo->aIndexName,pInfo->aQualifierName))
		{
			//////////////////////////////////////////////////////////////////////
			// Ist der Indexname ein gueltiger Name?
			if( !(pInfo->bReadOnly || pDatabase->IsSQLNameValid(pInfo->aIndexName)) )
			{
				rErrorText = SbaResId(STR_ERR_SQL_NAME);
				rErrorText.SearchAndReplace('#',pInfo->aIndexName);
				break;
			}

			//////////////////////////////////////////////////////////////////////
			// Ist das angegebene Feld ein Feld der Tabelle?
			const SdbColumn* pColumn = pTableDef->GetTable()->OriginalColumns()->Column(pInfo->aColumnName);
			if( !pColumn )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_FIELD_NOT_FOUND);
				rErrorText.SearchAndReplace('#',pInfo->aColumnName);
				break;
			}

			//////////////////////////////////////////////////////////////////////
			// Stimmt die Feldlaenge?
			if( nMaxColumnLen && (pColumn->GetLength()>nMaxColumnLen) )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_FIELD_LENGTH);
				rErrorText.SearchAndReplace('#',nMaxColumnLen);
				break;
			}

			//////////////////////////////////////////////////////////////////////
			// Kopieren der Column, um sie dem ::com::sun::star::sdbcx::Index zuweisen
			SdbColumn* pIndexCol = pTableDef->GetTable()->CreateColumn( *pColumn );

			//////////////////////////////////////////////////////////////////////
			// An der neuen Column Descending-Flag setzen
			if( pInfo->bDescending )
				pIndexCol->SetFlag( SDB_FLAGS_DESCENDING );

			//////////////////////////////////////////////////////////////////////
			// Neuen ::com::sun::star::sdbcx::Index erzeugen
			pIndexDef = new SbaIndexDef( *pTableDef, pInfo->aQualifierName, pInfo->aIndexName, pInfo->bUnique ,pInfo->bReadOnly);
			pIndexDef->GetColumns()->AddColumn( pIndexCol );
			rIndexDefs.InsertAt( pIndexDef->aName, pIndexDef );
		}

		//////////////////////////////////////////////////////////////////////
		// ... ansonsten werden nur die Spalten angehngt
		else if( pInfo->aColumnName.Len() )
		{
			//////////////////////////////////////////////////////////////////////
			// ::com::sun::star::sdbcx::Index ist erste Zeile im Browser (pIndexDef==NULL)
			if( !pIndexDef )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_NAME_MISSING);	// Kein IndexName vergeben
				break;
			}

			//////////////////////////////////////////////////////////////////////
			// Existiert diese Column in der Tabelle
			const SdbColumn* pColumn = pTableDef->GetTable()->OriginalColumns()->Column(pInfo->aColumnName);
			if( !pColumn )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_FIELD_NOT_FOUND);
				rErrorText.SearchAndReplace('#',pInfo->aColumnName);
				break;
			}

			//////////////////////////////////////////////////////////////////////
			// Feld ist dem ::com::sun::star::sdbcx::Index bereits zugewiesen worden
			else if( (*pIndexDef->GetColumns())[pColumn->GetName()] )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_FIELD_EXISTS);
				rErrorText.SearchAndReplace('#',pInfo->aColumnName);
				break;
			}
			//////////////////////////////////////////////////////////////////////
			// Kopieren der Column, um sie dem ::com::sun::star::sdbcx::Index zuweisen
			SdbColumn* pIndexCol = pTableDef->GetTable()->CreateColumn( *pColumn );

			//////////////////////////////////////////////////////////////////////
			// An der neuen Column Descending-Flag setzen
			if( pInfo->bDescending )
				pIndexCol->SetFlag( SDB_FLAGS_DESCENDING );

			//////////////////////////////////////////////////////////////////////
			// Spalte der bereits vorhandenen IndexDef hinzufuegen
			pIndexDef->GetColumns()->AddColumn( pIndexCol );

			//////////////////////////////////////////////////////////////////////
			// Ist die Maximale Anzahl Spalten erreicht?
			if( pIndexDef->GetColumns()->Count()- 1 > (long)nMaxColumns )
			{
				rErrorText = SbaResId(STR_ERR_INDEX_FIELD_OVERFLOW);
				rErrorText.SearchAndReplace('#',nMaxColumns);
				break;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////
	// Wenn (i<nRowCount), wurde Schleife mit Fehler abgebrochen
	if( i<nRowCount )
	{
		GoToRow(i);
		DBObj().RestoreIndex();
		return sal_False;
	}

	return sal_True;
}

//------------------------------------------------------------------------------
SbaTableIndexCtrl::~SbaTableIndexCtrl()
{
	DBG_DTOR(SbaTableIndexCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Lock der Definition wieder zuruecksetzen
	if (m_bDefObjectLocked)
	{
		pTableDef->SetLock( FALSE );
		m_bDefObjectLocked = FALSE;
	}

	for (sal_uInt32 i = 0; i < aInfoCols.Count(); i++)
		aInfoCols.GetObject(i)->ReleaseRef();

	if( nNoIndexNameEvent )
		Application::RemoveUserEvent( nNoIndexNameEvent );
	if( nNoFieldNameEvent )
		Application::RemoveUserEvent( nNoFieldNameEvent );
	if (nTableEvent)
		Application::RemoveUserEvent(nTableEvent);
	if (nDuplicateIndexEvent)
		Application::RemoveUserEvent(nDuplicateIndexEvent);

	delete pIndexNameCell;
	delete pIndexFieldCell;
	delete pSortingCell;
	delete pUniqueCell;
}

//------------------------------------------------------------------------------

sal_Bool SbaTableIndexCtrl::SeekRow(long nRow)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DbBrowseBox::SeekRow(nRow);
	if (DBObj().GetTable())
	{
		nDataPos = nRow;
		pDataCol = aInfoCols.GetObject(nRow);
		return sal_True;
	}
	return sal_False;
}

//------------------------------------------------------------------------------

void SbaTableIndexCtrl::PaintCell(OutputDevice& rDev, const Rectangle& rRect,
								   sal_uInt16 nColumnId ) const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	if (!pDataCol)
		return;
	else if (nColumnId == INDEX_UNIQUE && pDataCol->aIndexName.Len())
	{
		rDev.SetClipRegion(rRect);
		//CheckBoxCtrl::Draw(&rDev, rRect, pDataCol->bUnique, sal_False);
		PaintTristate(rDev, rRect, pDataCol->bUnique ? STATE_CHECK : STATE_NOCHECK);
		if (rDev.IsClipRegion())
			rDev.SetClipRegion();
		return;
	}

	Point aPos(rRect.TopLeft());

	String aText = GetCellText(nDataPos, nColumnId);
	Size TxtSize(GetDataWindow().GetTextWidth(aText), GetDataWindow().GetTextHeight());

	if (aPos.X() < rRect.Right() || aPos.X() + TxtSize.Width() > rRect.Right() ||
		aPos.Y() < rRect.Top() || aPos.Y() + TxtSize.Height() > rRect.Bottom())
		rDev.SetClipRegion( rRect );

	rDev.DrawText(aPos, aText);

	if (rDev.IsClipRegion())
		rDev.SetClipRegion();
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::SetUpdatable(sal_Bool bUpdate)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBG_ASSERT(!bUpdate || !IsStrongReadOnly(), "SbaTableIndexCtrl::SetUpdatable : bUpdate darf nicht sal_True sein, wenn IsStrongReadOnly() sal_True liefert !");
		// wenn es Umstaende gibt, die das Editieren generell verbieten (IsStrongReadOnly()==sal_True), dann kann ich auch nicht updatable sein

	if (bUpdate != m_bDefObjectLocked)
	{
		// diese Abfrage ist wichtig, da die zugrundeliegende Def sonst im folgenden gelockt oder ge-unlocked wird, obwohl es
		// nicht notwendig waere (und was schlimmer ist, das wuerde dann auch nicht wieder rueckgaengig gemacht)
		pTableDef->SetLock( bUpdate );
		m_bDefObjectLocked = bUpdate;
	}

	// nix zu tun ?
	if (bUpdate == IsUpdatable())
		return;

	GetDocShell()->SetReadOnlyUI( !bUpdate );

	// Aktive Zelle disablen
	long nRow(GetCurRow());
	sal_uInt16 nCol(GetCurColumnId());
	DeactivateCell();

	// Cursor des Browsers anpassen
	BrowserMode nMode(BROWSER_COLUMNSELECTION | BROWSER_MULTISELECTION | BROWSER_KEEPSELECTION |
					  BROWSER_HLINESFULL	  | BROWSER_VLINESFULL);
	if (bUpdate)
		nMode |= BROWSER_HIDECURSOR;
	SetMode(nMode);

	if (bUpdate)
		ActivateCell(nRow, nCol);
}

//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::IsUpdatable() const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	return !((SbaTableIndexCtrl*)this)->GetDocShell()->IsReadOnlyUI();
}

//------------------------------------------------------------------------------
DbCellController* SbaTableIndexCtrl::GetController(long nRow, sal_uInt16 nColumnId)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	if (!IsUpdatable() || pCurrentCol->bReadOnly || pTableDef->IsUsed())
		return NULL;

	switch (nColumnId)
	{
		case INDEX_NAME:
			return new DbEditCellController(pIndexNameCell);
		case FIELD_NAME:
			return new DbListBoxCellController(pIndexFieldCell);
		case SORT_ORDER:
			if ((pCurrentCol->aColumnName.Len() != 0) && pSortingCell)
				return new DbListBoxCellController(pSortingCell);
			else
				return NULL;
		case INDEX_UNIQUE:
			if (pCurrentCol->aIndexName.Len())
				return new DbCheckBoxCellController(pUniqueCell);
			// sonst weiter
		default:
			return NULL;
	}
}

//------------------------------------------------------------------------------

void SbaTableIndexCtrl::InitController(DbCellControllerRef&, long nRow, sal_uInt16 nColumnId)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	switch (nColumnId)
	{
		case INDEX_NAME:
			pIndexNameCell->SetText(pCurrentCol->aIndexName);
			break;
		case FIELD_NAME:
		{
//			pIndexFieldCell->SetText(pCurrentCol->aColumnName);
//			pIndexFieldCell->SetSelection(Selection(0,SELECTION_MAX));
			pIndexFieldCell->SelectEntry(pCurrentCol->aColumnName);
		}	break;
		case SORT_ORDER:
		{
			String aText;

			if (pCurrentCol->bDescending)
				aText = String(SbaResId(STR_VALUE_DESC));
			else
				aText = String(SbaResId(STR_VALUE_ASC));

//			pSortingCell->SetText(aText);
//			pSortingCell->SetSelection(Selection(0,SELECTION_MAX));
			pSortingCell->SelectEntry(aText);
		}	break;
		case INDEX_UNIQUE:
		{
			pUniqueCell->GetBox().Check(pCurrentCol->bUnique);
			pUniqueCell->GetBox().SaveValue();
		}	break;
	}
}

//------------------------------------------------------------------------------

DbBrowseBox::RowStatus SbaTableIndexCtrl::GetRowStatus(long nRow) const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	return nRow == GetCurRow() ? DbBrowseBox::CURRENT : DbBrowseBox::CLEAN;
}

//------------------------------------------------------------------------------

void SbaTableIndexCtrl::CursorMoved()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	long nOldPos = nCurrentPos;
	nCurrentPos = GetCurRow();
	bCurrentModified = sal_False;

	if (nCurrentPos != nOldPos)
	{
		SeekRow(nCurrentPos);
		pCurrentCol = pDataCol;

		if (nOldPos >= 0)
		{
			if (nOldPos < nCurrentPos)
			{
				InvalidateStatusCell(nOldPos);
				InvalidateStatusCell(nCurrentPos);
			}
			else
			{
				InvalidateStatusCell(nCurrentPos);
				InvalidateStatusCell(nOldPos);
			}
		}
		else
			InvalidateStatusCell(nCurrentPos);
	}

	SbaTableDesignCtrl::CursorMoved();
}

//-------------------------------------------------------------------------
IMPL_LINK( SbaTableIndexCtrl, OnNoIndexName, void*, EMPTYARG )
{
	ErrorBox( this, SbaResId(ERR_SBA_NO_INDEXNAME) ).Execute();
	long nCurRow = GetCurRow();
	GoToColumnId( 0 );
	GoToColumnId( (sal_uInt16)INDEX_NAME );
	nNoIndexNameEvent = 0;

	ActivateCell(GetCurRow(), INDEX_NAME);

	return 0;
}

//-------------------------------------------------------------------------
IMPL_LINK( SbaTableIndexCtrl, OnNoFieldName, void*, EMPTYARG )
{
	ErrorBox( this, SbaResId(ERR_SBA_NO_FIELDNAME) ).Execute();
	long nCurRow = GetCurRow();
	GoToColumnId( 0 );
	GoToColumnId( (sal_uInt16)FIELD_NAME );
	nNoFieldNameEvent = 0;

	ActivateCell(GetCurRow(), INDEX_NAME);

	return 0;
}

//-------------------------------------------------------------------------
IMPL_LINK( SbaTableIndexCtrl, OnDuplicateIndex, void*, EMPTYARG )
{
	ErrorBox( this, SbaResId(ERR_SBA_DUPLICATE_INDEX) ).Execute();
	long nCurRow = GetCurRow();
	GoToColumnId( 0 );
	GoToColumnId( (sal_uInt16)FIELD_NAME );
	nDuplicateIndexEvent = 0;

	ActivateCell(GetCurRow(), FIELD_NAME);

	return 0;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::IsCursorMoveAllowed(long nNewRow, sal_uInt16 nNewColId) const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Erst Basisklasse fragen
	if( !SbaTableDesignCtrl::IsCursorMoveAllowed(nNewRow, nNewColId) )
		return sal_False;

	//////////////////////////////////////////////////////////////////////
	// Bei Zeilenwechsel Eingabepruefung
	long nCurRow = GetCurRow();
	if( nNewRow != nCurRow )
	{
		//////////////////////////////////////////////////////////////////////
		// Fehler, wenn Indexfeld ohne Indexnamen
		SbaIndexInfo* pInfo = aInfoCols.GetObject( nCurRow );
		sal_Bool bIsMultipleFieldIndex = sal_False;
		long nPrevRow = nCurRow - 1;
		while (nPrevRow >= 0)
		{
			SbaIndexInfo* pPrevInfo = aInfoCols.GetObject(nPrevRow);
			if (!pPrevInfo || pPrevInfo->aColumnName.Len() == 0)
				break;	// mit bIsMultipleFieldIndex == sal_False !

			if (pPrevInfo->aIndexName.Len() > 0)
			{
				bIsMultipleFieldIndex = sal_True;
				break;
			}
			--nPrevRow;
		}
		if( pInfo && (pInfo->aColumnName.Len() != 0) && (pInfo->aIndexName.Len() == 0) && !bIsMultipleFieldIndex )
		{
			((SbaTableIndexCtrl*)this)->nNoIndexNameEvent = Application::PostUserEvent( LINK(this, SbaTableIndexCtrl, OnNoIndexName) );
			return sal_False;
		}

		//////////////////////////////////////////////////////////////////////
		// Fehler, wenn Indexname ohne Indexfeld
		if( pInfo && !pInfo->aColumnName.Len() && pInfo->aIndexName.Len() )
		{
			((SbaTableIndexCtrl*)this)->nNoFieldNameEvent = Application::PostUserEvent( LINK(this, SbaTableIndexCtrl, OnNoFieldName) );
			return sal_False;
		}

		//////////////////////////////////////////////////////////////////////
		// Fehler, wenn ::com::sun::star::sdbcx::Index schon vorhanden
		if( pInfo && ((SbaTableIndexCtrl*)this)->IsDuplicateIndex(pInfo) )
		{
			((SbaTableIndexCtrl*)this)->nDuplicateIndexEvent = Application::PostUserEvent( LINK(this, SbaTableIndexCtrl, OnDuplicateIndex) );
			return sal_False;
		}

	}
	return sal_True;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::IsDuplicateIndex( SbaIndexInfo* pInfo )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
/*
fuer diese Funktion benoetige ich SbaTableIndexCtrl::operator==
Die Datei muss jedoch mit Dirks Aenderungen gemergt werden.
Um das Mergen nicht zu umfangreich werden zu lassen, auf 372a warten
*/
	return sal_False;
}

//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::SaveModified()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	switch (GetCurColumnId())
	{
		case INDEX_NAME:
		{
			sal_Bool bPrevEmpty(sal_False);

			if( !pCurrentCol->aIndexName.Len() )
				bPrevEmpty = sal_True;

			SbaDatabase* pDatabase = pTableDef->GetDatabase();
			pCurrentCol->aIndexName = pIndexNameCell->GetText();//eindeutigen Namen gen.
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDatabase->GetMetaData());
			sal_Int32 nMaxColumnNameLen(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::COLUMN_NAME_LEN ));
			if(nMaxColumnNameLen && pCurrentCol->aIndexName.Len() > nMaxColumnNameLen)
			{
				//////////////////////////////////////////////////////////////
				// Nur Fehler, wenn dies nicht der Name des aktuellen Satzes ist
				ErrorBox aErrorBox( this, SbaResId(ERR_SBA_NAME_TO_LONG) );
				aErrorBox.Execute();
				return sal_False;
			}


			//////////////////////////////////////////////////////////////
			// Wenn neuer Indexname, andere Zellen per Default setzen
			// (an der Column muss der Indexname gesetzt sein, damit
			//  die Zellen angezeigt werden)
			if( pCurrentCol->aIndexName.Len() && bPrevEmpty )
			{
				pCurrentCol->bUnique = sal_False;
				RowModified(nCurrentPos, INDEX_UNIQUE);
				pCurrentCol->bDescending = sal_False;
				RowModified(nCurrentPos, SORT_ORDER);
			}

			pIndexNameCell->ClearModifyFlag();
			break;
		}
		case FIELD_NAME:
		{
			if (!pIndexFieldCell->GetSelectEntry().Len())
			{
				pCurrentCol->aIndexName.Erase();
				pCurrentCol->aColumnName.Erase();
				RowModified(nCurrentPos, INDEX_NAME);
				RowModified(nCurrentPos, FIELD_NAME);
				RowModified(nCurrentPos, SORT_ORDER);
				RowModified(nCurrentPos, INDEX_UNIQUE);
				return sal_True;
			}

			sal_uInt16 nPos = pIndexFieldCell->GetSelectEntryPos();
			if (nPos == (sal_uInt16)-1)
			{
				ErrorBox((Window*)this, SbaResId(ERR_SBA_INVALID_LISTBOX_ENTRY)).Execute();
				// TODO : einen ordentliche Fehlermeldung
				return sal_False;
			}

			String aColumnName(pIndexFieldCell->GetSelectEntry());		// den Text der Listbox entnehmen
			if (pCurrentCol->aColumnName == aColumnName)					// es hat sich nichts getan
				return sal_True;

			if (!pCurrentCol->aColumnName.Len())						// noch keinen Namen angegeben
			{
				pCurrentCol->aColumnName = aColumnName;
				pCurrentCol->bDescending = sal_False;
				RowModified(nCurrentPos, SORT_ORDER);
			}
			else
				pCurrentCol->aColumnName = aColumnName;

			pIndexFieldCell->SaveValue();
		}	break;
		case SORT_ORDER:
		{
			sal_uInt16 nPos = pSortingCell->GetSelectEntryPos();
			if (nPos == (sal_uInt16)-1)
			{
				nPos = 0;
				pSortingCell->SelectEntryPos(nPos);
			}

			if (!nPos && !pCurrentCol->bDescending)					// Hat sich was getan
				return sal_True;

			pCurrentCol->bDescending = pSortingCell->GetSelectEntry() == String(SbaResId(STR_VALUE_DESC));
			pSortingCell->SaveValue();
			break;
		}
		case INDEX_UNIQUE:
		{
			pCurrentCol->bUnique = pUniqueCell->GetBox().IsChecked();
			pUniqueCell->GetBox().SaveValue();
		}	break;
	}

	return sal_True;
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::CellModified()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	// Beim Wechsel auf die aktuelle Zelle wird bCurrentModified auf sal_False gesetzt
	if( bCurrentModified != IsModified() )
	{
		bCurrentModified = IsModified();
		if (bCurrentModified)
		{
			// Zelle wurde modifiziert
			GetUndoManager()->AddUndoAction( new SbaTabDgnCellUndoAct(this, GetCurRow(), GetCurColumnId()) );
			SFX_BINDINGS().Invalidate(SID_UNDO);
			SFX_BINDINGS().Invalidate(SID_REDO);

			GetDocShell()->SetModified(sal_True);
			SFX_BINDINGS().Invalidate(SID_SAVEDOC);
		}
		// wenn es sich bei der modifizierten Zelle um die 'Eindeutig'-Spalte handelt, muss ich die Aenderung noch an
		// die Daten der aktuellen Zeile weiterreichen, da sich PaintCell von dort die Unique-Information holt (das fuehrt
		// sonst unter bestimmten Umstaenden zu Darstellunsfehlern)
		// (ich muss das im Uebrigen auch bei !bCurrentModified weiterreichen, da IsModified() in der Eindeutig-Spalte nur dann
		// sal_True liefert, wenn der Status der Checkbox ungleich dem beim Betreten der Zelle ist. pCurrentCol muss aber auch bei der
		// anderen Haelfte aller Modifikationen aktualisiert werden.)
		if ((GetCurColumnId() == INDEX_UNIQUE) && pCurrentCol)
		{
			DBG_ASSERT(pUniqueCell != NULL, "SbaTableIndexCtrl::CellModified() : pUniqueCell ist NULL !");
			pCurrentCol->bUnique = pUniqueCell->GetBox().IsChecked();
		}
	}
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::Undo()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBView::Undo();

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
}


//------------------------------------------------------------------------------
void SbaTableIndexCtrl::Redo()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBView::Redo();

	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);
	SFX_BINDINGS().Invalidate(SID_SAVEDOC);
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::CopyRows()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Setzt aus selektierten Feldinhalten einen String
	// zusammen, der ins ueber einen Stream ins
	// Clipboard kopiert wird

	String aClipboardItem;
	SbaIndexInfo* pInfo;
	SvMemoryStream aMemStream;
	aMemStream.ObjectOwnsMemory( sal_True );

	DBG_ASSERT(GetSelection(), "SbaTableIndexCtrl::CopyRows : no selection !");

	//////////////////////////////////////////////////////////////////////
	// Zuerst Dummy fuer die Anzahl der Datensaetze
	sal_uInt32 nDataCount = 0;
	aMemStream<<nDataCount;

	//////////////////////////////////////////////////////////////////////
	// dann die einzelnen Zeilen hineinschreiben
	long nIdx = FirstSelectedRow();
	while (nIdx >= 0)
	{
		pInfo = (SbaIndexInfo*)aInfoCols.GetObject(nIdx);
		if(!pInfo->bReadOnly){
			aClipboardItem = String();

			//////////////////////////////////////////////////////////////////////
			// Indexname
			aClipboardItem += pInfo->aIndexName;
			aClipboardItem += ';';

			//////////////////////////////////////////////////////////////////////
			// Indexfeld
			aClipboardItem += pInfo->aColumnName;
			aClipboardItem += ';';

			//////////////////////////////////////////////////////////////////////
			// Sortierreihenfolge
			aClipboardItem += String::CreateFromInt32((sal_Int32)pInfo->bDescending);
			aClipboardItem += ';';

			//////////////////////////////////////////////////////////////////////
			// Eindeutig
			aClipboardItem += String::CreateFromInt32((sal_Int32)pInfo->bUnique);
			aClipboardItem += ';';

			//////////////////////////////////////////////////////////////////////
			// Ausgabe in Stream
			aMemStream.WriteByteString( aClipboardItem, RTL_TEXTENCODING_UTF8 );
			nDataCount++;
		}
		nIdx = NextSelectedRow();
	}

	//////////////////////////////////////////////////////////////////////
	// Dummy fuellen
	aMemStream.Seek( STREAM_SEEK_TO_BEGIN );
	aMemStream<<nDataCount;

	//////////////////////////////////////////////////////////////////////
	// Daten ins Clipboard kopieren
	const void* pBuf = (const void*) aMemStream.GetData();
	sal_uInt32 nBufSize = aMemStream.Seek( STREAM_SEEK_TO_END );	// Reduziere auf wirkliche Laenge
	Clipboard::CopyData( pBuf, nBufSize, nClipboardFormat);
	bClipboardFilled = sal_True;
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::InsertRows( long nRow )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBG_ASSERT( Clipboard::GetFormatName( nClipboardFormat ).EqualsAscii("Tabed"), "Falsches Clipboardformat");

	String aClipboardItem;
	String aToken;
	SbaIndexInfo* pNewInfo;
	sal_uInt16 nIndex;

	// Zeile auswaehlen
	long nCurrRow = nRow;
	SelectRow( nRow, sal_False );

	// Erzeuge Clipboard-kompatiblen Stream
	sal_uInt32 nBufSize = Clipboard::GetDataLen( nClipboardFormat );
	void* pBuf = SvMemAlloc( nBufSize );
	SvMemoryStream aMemStream((char*)pBuf, nBufSize, STREAM_READ);
	aMemStream.ObjectOwnsMemory( sal_True );

	// Kopiere Daten in Stream
	Clipboard::PasteData( pBuf, nBufSize, nClipboardFormat );

	// Anzahl Datensaetze auslesen
	sal_uInt32 nDataCount = 0;
	sal_uInt32 nCurCount = 0;
	aMemStream>>nDataCount;

	// Auslesen der Datensaetze
	while( nCurCount < nDataCount )
	{
		aMemStream.ReadByteString( aClipboardItem, RTL_TEXTENCODING_UTF8 );
		nCurCount++;
		pNewInfo = new SbaIndexInfo;
		// String wieder zerlegen
		sal_uInt16 i = 1;
		nIndex = 0;
		for (aToken = aClipboardItem.GetToken(0,';',nIndex);
			 aToken.Len();
			 aToken = aClipboardItem.GetToken(0,';',nIndex))
		{
			// ... und Daten in ColInfo-Objekt schreiben
			switch(i)
			{
				case 1:
					pNewInfo->aIndexName = aToken;
					break;
				case 2:
					pNewInfo->aColumnName = aToken;
					break;
				case 3:
					pNewInfo->bDescending = (sal_Bool)(aToken.ToInt32());
					break;
				case 4:
					pNewInfo->bUnique = (sal_Bool)(aToken.ToInt32());
					break;

			}
			i++;

		}

		aInfoCols.Insert( pNewInfo, nCurrRow );
		RowInserted( nCurrRow,1 ,sal_False );
		nCurrRow++;
	}
	Invalidate();
	GetDocShell()->SetModified( sal_True );
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::DeleteRows()
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	DBG_ASSERT(GetSelection(), "keine selection!!!");

	// kein Undo nach Loeschen
	GetUndoManager()->Clear();
	SFX_BINDINGS().Invalidate(SID_UNDO);
	SFX_BINDINGS().Invalidate(SID_REDO);

	// Beim Loeschen von allen markierten Zellen nach letztem Datensatz abbrechen -> sonst Endlosschleife
	sal_uInt32 nMaxCount(aInfoCols.Count());
	sal_uInt32 nCurCount(0);

	long nIdx = FirstSelectedRow();
	while (nIdx >= 0)
	{
		nCurCount++;
		SbaIndexInfo* pColInfo = aInfoCols.GetObject(nIdx);

		DBG_ASSERT(pColInfo, "Feldinfo fehlt!");
		if ( (!pColInfo) || (nCurCount>nMaxCount) ) break;

		if(!pColInfo->bReadOnly){
			aInfoCols.Insert(new SbaIndexInfo, LIST_APPEND);	// Einfuegen einer neuen Zeile am Ende
			RowInserted(GetRowCount()-1, 1, sal_False);

			// Weg von der ungueltigen Position
			pDataCol = aInfoCols.GetObject(nIdx + 1);
			nDataPos = nIdx;

			if (nCurrentPos > nIdx)								// Korrigieren der aktuellen Position
				nCurrentPos--;
			else if (nCurrentPos == nIdx)
				pCurrentCol = pDataCol;

			aInfoCols.Remove(nIdx);								// Aktuelle Zeile loeschen
			pColInfo->ReleaseRef();

			RowRemoved(nIdx, 1, sal_True);
			InvalidateStatusCell(nCurrentPos);

			nIdx = FirstSelectedRow();
		}
	}

	GetDocShell()->SetModified( sal_True );
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::InsertNewRows( long nRow )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	long nInsertRows = GetSelectRowCount();
	if( !nInsertRows )
		nInsertRows = 1;	// default
	for( long i=nRow; i<(nRow+nInsertRows); i++ )
		aInfoCols.Insert( new SbaIndexInfo, i );
	RowInserted( nRow, nInsertRows, sal_True );
}

//==================================================================
sal_uInt16 SbaTableIndexCtrl::SaveData(sal_Bool bQuery, sal_Bool bForBrowsing)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	String aErrText;

	if (!IsUpdatable() || !DBObj().GetTable()->IsOpen())
		return sal_True;

	// erst mal die Indizies temporaer holen
	SbaIndexList rTemp;
	if (!PutData(aErrText))
	{
		ErrorBox(this, WB_OK, aErrText).Execute();
		return sal_False;
	}

	// hat sich ueberhaupt was geaendert ?
	if (!DBObj().IsIndexModified())
	{
		// sicherheitshalber noch das modified wieder zurueck
		GetDocShell()->SetModified(sal_False);
		return sal_True;
	}

	if (bQuery)
	{
		String aText(SbaResId(STR_QUERY_INDEX_MODIFIED));
		aText.SearchAndReplace('#',DBObj().Name());

		QueryBox aQry(this, WB_YES_NO_CANCEL, aText);
		if (bForBrowsing)
			aQry.AddButton(ResId(RID_STR_NEW_TASK), RET_NEWTASK,
				BUTTONDIALOG_DEFBUTTON | BUTTONDIALOG_FOCUSBUTTON);

		switch (aQry.Execute())
		{
			case RET_NO:
				GetDocShell()->SetModified(sal_False);
				DBObj().RestoreIndex();
				return sal_True;
			case RET_CANCEL:
				return sal_False;
			case RET_NEWTASK:
				return RET_NEWTASK;
		}
	}

	if (DBObj().UpdateIndex())
	{
		GetUndoManager()->Clear();
		bCurrentModified = sal_False;
		SFX_BINDINGS().Invalidate(SID_UNDO);
		SFX_BINDINGS().Invalidate(SID_REDO);
		GetDocShell()->SetModified(sal_False);
		return sal_True;
	}
	else if (DBObj().Status().IsError())
		SBA_MOD()->ShowDbStatus(DBObj().Status(), dbWriteError);
	return sal_False;
}

//------------------------------------------------------------------------------
String SbaTableIndexCtrl::GetControlText( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls des Browsers auslesen
	GoToRow( nRow );
	GoToColumnId( nColId );
	return Controller()->GetWindow().GetText();
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::SetControlText( long nRow, sal_uInt16 nColId, const String& rText )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	//////////////////////////////////////////////////////////////////////
	// Controls des Browsers setzen
	GoToRow( nRow );
	GoToColumnId( nColId );
	Controller()->GetWindow().SetText( rText );
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::SetData( long nRow, sal_uInt16 nColId, const String& rNewData )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	SeekRow(nRow);
	if (!pDataCol)
		return;

	switch (nColId)
	{
		case INDEX_QUALIFIER:
			pDataCol->aQualifierName = rNewData;
			break;
		case INDEX_NAME:
			pDataCol->aIndexName = rNewData;
			break;
		case FIELD_NAME:
			pDataCol->aColumnName = rNewData;
			break;
		case SORT_ORDER:
			if( rNewData.Equals( String(SbaResId(STR_VALUE_DESC)) ))
				pDataCol->bDescending = sal_True;
			else
				pDataCol->bDescending = sal_False;
			break;
		case INDEX_UNIQUE:
			if( rNewData.EqualsAscii("True"))
				pDataCol->bUnique = sal_True;
			else
				pDataCol->bUnique = sal_False;
			break;
	}
}

//------------------------------------------------------------------------------
String SbaTableIndexCtrl::GetData( long nRow, sal_uInt16 nColId )
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	SeekRow(nRow);
	if (!pDataCol)
		return String();

	String aText;
	switch (nColId)
	{
		case INDEX_QUALIFIER:
			aText = pDataCol->aQualifierName;
			break;
		case INDEX_NAME:
			aText = pDataCol->aIndexName;
			break;
		case FIELD_NAME:
			aText = pDataCol->aColumnName;
			break;
		case SORT_ORDER:
			if (!pDataCol->aColumnName.Len())
				aText = String();
			else if (pDataCol->bDescending)
				aText =	String(SbaResId(STR_VALUE_DESC));
			else
				aText = String(SbaResId(STR_VALUE_ASC));
			break;
		case INDEX_UNIQUE:
			aText.AssignAscii(pDataCol->bUnique ? "True" : "False");
			break;

	}
	return aText;
}


//==================================================================

void SbaTableIndexCtrl::Replace(DBUndoAction& rAction, long nRow, sal_uInt16 nColId)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	SbaIndexUndoAction* pIndexAction = PTR_CAST(SbaIndexUndoAction,&rAction);
	if (!pIndexAction) return;

	// den derzeitigen Wert uebernehmen, ohne Ueberpruefung
	SbaIndexInfo* pInfo = pIndexAction->GetInfo();
	pInfo->AddRef();

	SbaIndexInfo* pOldInfo = aInfoCols.Replace(pInfo, nRow);

	if (pOldInfo && nRow == nCurrentPos && IsEditing() && Controller()->IsModified())
	{
		switch (GetCurColumnId()) // aktuelle Editeinstellungen
		{
			case INDEX_NAME:
				pOldInfo->aIndexName = pIndexNameCell->GetText();
				break;
			case FIELD_NAME:
				pOldInfo->aColumnName = pIndexFieldCell->GetSelectEntry();
				break;
			case SORT_ORDER:
				pOldInfo->bDescending = pSortingCell->GetSelectEntry() == String(SbaResId(STR_VALUE_DESC));
				break;
			case INDEX_UNIQUE:
				pOldInfo->bUnique = pUniqueCell->GetBox().IsChecked();
		}
	}

	// Werte ueberschreiben

	SeekRow(nRow);								// positionieren auf den Datensatz
	bCurrentModified = sal_False;

	pIndexAction->Set(pOldInfo, nRow, nColId);

	if (nRow == nCurrentPos)					// alte informationen setzen
	{
		pCurrentCol = pInfo;
		if (nColId != GetCurColumnId())
			GoToColumnId(nColId);
		else if (Controller().Is())
		{
			DbCellControllerRef aController = Controller();
			InitController(aController, nRow, nColId);
			Controller()->ClearModified();
		}
	}
	else
	{
		GoToRow(nRow);
		if (nColId != GetCurColumnId())
			GoToColumnId(nColId);
	}

	if (pOldInfo->aIndexName != pCurrentCol->aIndexName)
		RowModified(nRow,INDEX_NAME);

	if (pOldInfo->aColumnName != pCurrentCol->aColumnName)
		RowModified(nRow,FIELD_NAME);

	if (!pCurrentCol->aColumnName.Len() || pOldInfo->bDescending != pCurrentCol->bDescending)
		RowModified(nRow,SORT_ORDER);

	if (!pCurrentCol->aIndexName.Len() || pOldInfo->bUnique != pCurrentCol->bUnique)
		RowModified(nRow,INDEX_UNIQUE);

	pOldInfo->ReleaseRef();
}

//------------------------------------------------------------------------------

String SbaTableIndexCtrl::GetCellText(long nRow, sal_uInt16 nColId) const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	if( nColId == INDEX_UNIQUE )
		return String();
	return ((SbaTableIndexCtrl*)this)->GetData(nRow, nColId);
}

//------------------------------------------------------------------------------

sal_uInt32 SbaTableIndexCtrl::GetTotalCellWidth(long nRow, sal_uInt16 nColId) const
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	if(nColId == INDEX_UNIQUE)
		return  GetColumnWidth(nColId);
	else
		return  GetDataWindow().GetTextWidth(GetCellText(nRow, nColId));
}

//------------------------------------------------------------------------------
void SbaTableIndexCtrl::ArrangeControls(sal_uInt16& nX, sal_uInt16 nY)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	SbaTableDesignCtrl::ArrangeControls(nX, nY);
}
//------------------------------------------------------------------------------
sal_Bool SbaTableIndexCtrl::IsSystemReadOnly(sal_uInt32 nRow)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	return aInfoCols.GetObject(nRow)->bReadOnly;
}
//------------------------------------------------------------------------------
void SbaTableIndexCtrl::Command(const CommandEvent& rEvt)
{
	DBG_CHKTHIS(SbaTableIndexCtrl,NULL);
	switch (rEvt.GetCommand())
	{
		case COMMAND_CONTEXTMENU:
		{
			if (!rEvt.IsMouseEvent())
			{
				DbBrowseBox::Command(rEvt);
				return;
			}

			sal_uInt16 nColId = GetColumnAtXPosPixel(rEvt.GetMousePosPixel().X());
			long   nRow = GetRowAtYPosPixel(rEvt.GetMousePosPixel().Y());
			long   nOldRow = GetCurRow();

			if ( nColId == HANDLE_ID )
			{
				PopupMenu aContextMenu(SbaResId(RID_TABDGNROWPOPUPMENU));
				long nSelectRowCount = GetSelectRowCount();
				aContextMenu.EnableItem( SID_CUT, nSelectRowCount && !IsSystemReadOnly(nRow) );
				aContextMenu.EnableItem( SID_COPY, nSelectRowCount && !IsSystemReadOnly(nRow));
				aContextMenu.EnableItem( SID_PASTE, bClipboardFilled && !IsSystemReadOnly(nRow));
				aContextMenu.EnableItem( SID_DELETE, IsUpdatable() && nSelectRowCount && !IsSystemReadOnly(nRow));
				switch (aContextMenu.Execute(this, rEvt.GetMousePosPixel()))
				{
					case SID_CUT:
						Cut();
						break;
					case SID_COPY:
						Copy();
						break;
					case SID_PASTE:
						Paste( nRow );
						SetNoSelection();
						GoToRow( nRow );
						SeekRow( nRow );
						break;

					case SID_DELETE:
						DeleteRows();
						break;
					case SID_SBA_BRW_INSERTROWS:
						InsertNewRows( nRow );
						SetNoSelection();
						GoToRow( nRow );
						SeekRow( nRow );
						break;
					default:
						break;
				}
			}

		}
		default:
			DbBrowseBox::Command(rEvt);
	}

}

//------------------------------------------------------------------------------
sal_Int32 SbaTableIndexCtrl::getFirstWritableIndex() const
{
	// search the first not-readonly col
	for (sal_Int32 nCol = 0; nCol < aInfoCols.Count(); ++nCol)
	{
		SbaIndexInfo* pCurrent = aInfoCols.GetObject(nCol);
		if (pCurrent && !pCurrent->bReadOnly)
			break;
	}
	if (!(nCol < aInfoCols.Count()))
	{	// did not find such a col ...
		if (nCol >= GetRowCount() - 1)
			// and no row in the column without an index info
			nCol = 0;	// activate the first row, no other chance
	}
	return nCol;
}


