/*************************************************************************
 *
 *  $RCSfile: tbldgnvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SBA_SBAHINTS_HXX
#include "sbahints.hxx"
#endif
#ifndef _SBA_SBAOBJ_HXX
#include "sbaobj.hxx"
#endif

#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif
#ifndef _SBA_TBLDGNVS_HXX
#include "tbldgnvs.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBA_SBATABED_HXX
#include "sbatabed.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif


#define SbaTableDesignViewSh
#include "ofaslots.hxx"

TYPEINIT1(SbaTableDesignViewSh, SbaTableViewSh)

//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaTableDesignViewSh, SbaTableViewSh, SbaResId(0))
{
}

//------------------------------------------------------------------------------
SFX_IMPL_VIEWFACTORY(SbaTableDesignViewSh, SbaResId(0))
{
	SFX_VIEW_REGISTRATION(SbaTableDocSh);
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::Construct( SfxViewFrame *pFrame )
{
	SetHelpId(ID_SBA_TABLEDESIGNVIEWSH);
	SbaTableDef* pDef = PTR_CAST(SbaTableDef, GetShell()->GetDBDef());

	if (pDef)
	{
		SbaTableDesignFrame* pDesignFrame = new SbaTableFieldDesignFrame(&pFrame->GetWindow(), pDef, this);
		pDesignFrame->SetHelpId(HID_TAB_DESIGN_FRAME);
		pWindow = (SbaTableDesignWin*)pDesignFrame->GetMainWin();
		SetUndoManager( &aUndoManager );
		SetWindow( pDesignFrame );
	}
}
DBG_NAME(SbaTableDesignViewSh);
//------------------------------------------------------------------------------
SbaTableDesignViewSh::SbaTableDesignViewSh(SfxViewFrame *pFrame, SfxViewShell* pView)
					 :SbaTableViewSh(pFrame)
					 ,pWindow(NULL)
					 ,nEventID(0)
{
	DBG_CTOR(SbaTableDesignViewSh,NULL);
	StartListening(*SBA_MOD());
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableDesignViewSh::SbaTableDesignViewSh(SfxViewFrame *pFrame, Window* pWindow)
					 :SbaTableViewSh(pFrame)
					 ,pWindow(NULL)
					 ,nEventID(0)
{
	DBG_CTOR(SbaTableDesignViewSh,NULL);
	StartListening(*SBA_MOD());
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableDesignViewSh::SbaTableDesignViewSh( SfxViewFrame *pFrame, const SbaTableDesignViewSh& rSh )
					 :SbaTableViewSh(pFrame)
					 ,pWindow(NULL)
					 ,nEventID(0)
{
	DBG_CTOR(SbaTableDesignViewSh,NULL);
	StartListening(*SBA_MOD());
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableDesignViewSh::~SbaTableDesignViewSh()
{
	EndListening(*SBA_MOD());

	// delete the frame
	pWindow->GetParent()->Hide();
	delete pWindow->GetParent();
	pWindow = NULL;

	if(nEventID)
		Application::RemoveUserEvent(nEventID);
	DBG_DTOR(SbaTableDesignViewSh,NULL);
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::SFX_NOTIFY(SfxBroadcaster& rBC,
								  const TypeId& rBCType,
								  const SfxHint& rHint,
								  const TypeId& rHintType )
{
	DBG_CHKTHIS(SbaTableDesignViewSh,NULL);
	SbaDBDefHint *pDBDefHint = PTR_CAST(SbaDBDefHint,&rHint);
	if (pDBDefHint && (GetDesignWin()->GetDocShell()->GetDataDef() == pDBDefHint->GetDBDef() ||
					   *GetDesignWin()->GetDocShell()->GetDataDef() == *pDBDefHint->GetDBDef()))
	{
		switch (pDBDefHint->GetAction())
		{
			case SbaDBDefHint::dbDelete:
				GetDesignWin()->GetEditorCtrl()->UpdateAll();
				GetDesignWin()->GetEditorCtrl()->DeactivateCell();
				break;
		}
	}
}

//-------------------------------------------------------------------------

void SbaTableDesignViewSh::InnerResizePixel( const Point &rPos, const Size &rSize )
{
	pWindow->GetParent()->SetPosSizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::OuterResizePixel( const Point &rPos, const Size &rSize )
{
	InnerResizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::Execute( SfxRequest& rReq )
{
	SbaTableEditorCtrl* pTabEdCtrl = GetDesignWin()->GetEditorCtrl();

	switch (rReq.GetSlot())
	{
		case SID_MAIL_SENDDOC:
			SFX_APP()->ExecuteSlot(rReq);
			break;

		case SID_CUT:
			pTabEdCtrl->Cut();
			rReq.Done();
			break;

		case SID_COPY:
			pTabEdCtrl->Copy();
			rReq.Done();
			break;

		case SID_PASTE:
			pTabEdCtrl->Paste();
			rReq.Done();
			break;

		case SID_RELOAD:
		case SID_SAVEDOC:
		{
			sal_Bool bExecutingSave = (SID_SAVEDOC == rReq.GetSlot());

			sal_Bool bWasRO = sal_False;
			if (!bExecutingSave)
			{
				bWasRO = pTabEdCtrl->IsReadOnly();
				if (GetShell()->IsModified())
					if (RET_YES != QueryBox(NULL, ResId(MSG_QUERY_LASTVERSION)).Execute())
						return;
			}

			//////////////////////////////////////////////////////////////////////
			// Aktuelle Zeile speichern
			if (bExecutingSave)
				if (!pTabEdCtrl->SaveCurRow())
					return;

			//////////////////////////////////////////////////////////////////////
			// Datenstruktur speichern
			SbaTableDocSh* pDoc = (SbaTableDocSh*)GetShell();
			sal_Bool bDocSuccess = bExecutingSave ? pDoc->Save() : pDoc->Refresh();

			if(!bDocSuccess)
			{
				if (bExecutingSave)
				{
					// fuer den Fall, dass waehrend des Save das zugrundeliegende Dokument veraendert wurde
					// (e.g. durch Einfuegen der Primaerschluessel-Spalte), muss ich das Ganze neu zeichnen
					pTabEdCtrl->Invalidate();
					pTabEdCtrl->SetReadOnly(pTabEdCtrl->IsReadOnly());
					// das hat den Nachteil, dass bei einem einfachen Abbruch des Speicherns auch alles neu
					// gezeichnet wird (sprich flackert), aber die Alternative waere, die Information
					// "Dokument waehrend des Speicherns geaendert ?" vom Dokument aus oeffentlich zugaenglich
					// zu machen
				}

				return;
			}

			pDoc->SetModified( sal_False );
			SFX_BINDINGS().Invalidate(SID_SAVEDOC);
			GetUndoManager()->Clear();

			//////////////////////////////////////////////////////////////////////
			// Im Save() Update auf Datenstruktur->neue Struktur anzeigen
			pTabEdCtrl->Invalidate();

			//////////////////////////////////////////////////////////////////////
			// ReadOnly-Flag der DocShell neu setzen
			sal_Bool bReadO(sal_True);
			SbaTableDef* pTableDef = (SbaTableDef*)pDoc->GetDBDef();
			::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData( pTableDef->GetDatabase()->GetMetaData() );

			if ((::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) ||
				(::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN))
			{
				if( pTableDef->GetTablePrivileges() & SDB_PR_ALTER || pTableDef->GetTable()->IsView())
				{
					bReadO = sal_False;
				}
			}
			pTabEdCtrl->SetReadOnly( bReadO || bWasRO );
			((SbaTableDesignFrame*)pWindow->GetParent())->CheckIndexPageAvailability();

			break;
		}
		case SID_EDITDOC:
			sal_Bool bReadOnly = pTabEdCtrl->IsReadOnly();

			SbaTableDocSh* pDoc = (SbaTableDocSh*)GetShell();
			// wenn ich gerade beim Bearbeiten war und das Doc modifiziert ist ...
			if ((!bReadOnly) && (pDoc->IsModified()))
			{
				// ... aktuelle Zeile speichern ...
				if (!pTabEdCtrl->SaveCurRow())
					return;

				// ... + ganze Datenstruktur ...
				if(!pDoc->Save())
					return;

				pDoc->SetModified(sal_False);
				SFX_BINDINGS().Invalidate(SID_SAVEDOC);
				GetUndoManager()->Clear();
			}
			pTabEdCtrl->SetReadOnly( !bReadOnly );
			break;
	}
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::GetState(SfxItemSet &rSet)
{
	SfxWhichIter aIter(rSet);
	for (sal_uInt16 nSID = aIter.FirstWhich(); nSID; nSID = aIter.NextWhich())
	{
		switch ( nSID )
		{
			case SID_RELOAD:
				if (GetShell()->GetDBDef()->IsNew())
					rSet.DisableItem(nSID);
				break;
			case SID_CUT:
				if (!pWindow->GetEditorCtrl()->IsCutAllowed())
					rSet.DisableItem(nSID);
				break;

			case SID_COPY:
				if (!pWindow->GetEditorCtrl()->IsCopyAllowed())
					rSet.DisableItem(nSID);
				break;

			case SID_PASTE:
				if (!pWindow->GetEditorCtrl()->IsPasteAllowed())
					rSet.DisableItem(nSID);
				break;

			case SID_SAVEDOC:
				if( !GetShell()->IsModified() )
					rSet.DisableItem(nSID);
				break;

			case SID_MAIL_SENDDOC:
				// Sonderbehandlung, Aenderung des Menuetextes
				rSet.Put( SfxStringItem( nSID, String( SbaResId( RID_STR_MENU_NEWMAIL ) ) ) );
				break;

			case SID_EDITDOC:
			{
				sal_Bool bReadOnly = pWindow->GetEditorCtrl()->IsReadOnly();

				SbaTableDef* pTableDef = (SbaTableDef*)GetShell()->GetDBDef();

				// view -> disable
				if (pTableDef->GetTable()->IsView())
					rSet.DisableItem(nSID);
				// no ALTER-privilege -> disable
				else if (!(pTableDef->GetTablePrivileges() & SDB_PR_ALTER))
					rSet.DisableItem(nSID);

				// Wenn ein Datenobjekt die Definition benutzt -> disablen
				else if (pTableDef->IsUsed())
				{
					rSet.DisableItem(nSID);
					if (!bReadOnly)
						nEventID = Application::PostUserEvent(LINK(this, SbaTableDesignViewSh, OnCorrectReadOnly));
					// die Tabelle is used, aber das Fenster nicht readonly -> es wurde, waehrend der design-modus an ist,
					// irgendwo eine BrowseAnsicht auf die Tabelle geoeffnet (z.B. im Beamer) -> ich muss in readonly uebergehen
				}

				// wenn mein Fenster readonly ist, aber die Tabelle trotzdem gelockt (weil zum beispiel jemand eine zweite
				// Entwurfsansicht aufgemacht hat) -> disablen
				else if (bReadOnly && pTableDef->IsLocked())
					rSet.DisableItem(nSID);

				// wenn es schreibgeschuetzt und nicht neu ist, darf es nicht veraendert werden
				else if(bReadOnly && !((SbaTableDef*)GetShell()->GetDBDef())->IsNew())
				{
					SbaTableDocSh* pDoc = (SbaTableDocSh*)GetShell();
					SbaTableDef* pTableDef = (SbaTableDef*)pDoc->GetDBDef();
					::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData( pTableDef->GetDatabase()->GetMetaData() );
					sal_Bool bCanDropColumn = (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_DROP_COLUMN) != 0;
					sal_Bool bCannAddColumn = (::utl::getINT16(rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::TABLE_DEFINITION)) & ::com::sun::star::data::DatabaseTableDefinition::ALTER_ADD_COLUMN) != 0;
					if (!bCanDropColumn && !bCannAddColumn)
						rSet.DisableItem(nSID);
					else
						rSet.Put( SfxBoolItem(nSID, !bReadOnly) );
				}
				else
					rSet.Put( SfxBoolItem(nSID, !bReadOnly) );
			}
			break;
		}
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableDesignViewSh, OnCorrectReadOnly, void*, EMPTYARG)
{
	nEventID = 0;
	pWindow->GetEditorCtrl()->SetReadOnly(sal_True);
	return 0;
}

//------------------------------------------------------------------------------
sal_uInt16 SbaTableDesignViewSh::PrepareClose( sal_Bool bUI, sal_Bool bForBrowsing )
{
	//////////////////////////////////////////////////////////////////////
	// Aktuelle Zeile speichern
	SbaTableEditorCtrl* pTabEdCtrl = GetDesignWin()->GetEditorCtrl();
	return (sal_uInt16)pTabEdCtrl->SaveCurRow();
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::Activate(sal_Bool IsMDIActivate)
{
	//////////////////////////////////////////////////////////////////////
	// Accelerator zum Wechseln der Fenster
	pSwitchPaneAccel = new Accelerator();
	pSwitchPaneAccel->InsertItem( 1, KeyCode( KEY_F6 ) );

	GetpApp()->InsertAccel( pSwitchPaneAccel );
	pSwitchPaneAccel->SetSelectHdl( LINK(GetDesignWin(), SbaTableDesignWin, SwitchHdl) );

	if (pWindow && pWindow->GetParent())
		((SbaViewSwitchFrame*)pWindow->GetParent())->EnableAccelSwitch(sal_True);

	SbaTableViewSh::Activate(IsMDIActivate);
}

//------------------------------------------------------------------------------
void SbaTableDesignViewSh::Deactivate(sal_Bool IsMDIActivate)
{
	GetpApp()->RemoveAccel( pSwitchPaneAccel );
	delete pSwitchPaneAccel;
	pSwitchPaneAccel = NULL;

	if (pWindow && pWindow->GetParent())
		((SbaViewSwitchFrame*)pWindow->GetParent())->EnableAccelSwitch(sal_False);

	SbaTableViewSh::Deactivate(IsMDIActivate);
}

//==============================================================================

//------------------------------------------------------------------------------
SbaTableFieldDesignFrame::SbaTableFieldDesignFrame(Window* pParent, SbaTableDef* pDef, SbaTableDesignViewSh* pView)
	:SbaTableDesignFrame(pParent, pDef, pView, STR_TAB_EDITOR)
{
	m_pMainWin = new SbaTableDesignWin( this, pDef, pView );
	m_pMainWin->SetHelpId(HID_TAB_DESIGN_MAINWIN);
	m_pMainWin->Show();
}

//------------------------------------------------------------------------------
void SbaTableFieldDesignFrame::GetFocus()
{
	SbaTableDesignFrame::GetFocus();

	// forward the focus to the current cell of the editor control
	SbaTableEditorCtrl* pEdCtrl = ((SbaTableDesignWin*)m_pMainWin)->GetEditorCtrl();
	if (pEdCtrl)
		pEdCtrl->GrabFocus();
}

