/*************************************************************************
 *
 *  $RCSfile: tblidxvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SBA_TBLIDXVS_HXX
#include "tblidxvs.hxx"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif
#ifndef _SBASLTID_HRC
#include "sbasltid.hrc"
#endif
#ifndef _SBA_SBATABID_HXX
#include "sbatabid.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif

#ifndef _SFXMSG_HXX //autogen
#include <sfx2/msg.hxx>
#endif

#ifndef _SFXOBJFACE_HXX //autogen
#include <sfx2/objface.hxx>
#endif

#ifndef _SFXREQUEST_HXX //autogen
#include <sfx2/request.hxx>
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif

#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#define SbaTableIdxViewSh
#include "ofaslots.hxx"

TYPEINIT1(SbaTableIdxViewSh, SbaTableViewSh)

//------------------------------------------------------------------------------
SFX_IMPL_INTERFACE(SbaTableIdxViewSh, SbaTableViewSh, SbaResId(0))
{
}

//------------------------------------------------------------------------------
SFX_IMPL_VIEWFACTORY(SbaTableIdxViewSh, SbaResId(0))
{
	SFX_VIEW_REGISTRATION(SbaTableDocSh);
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::Construct( SfxViewFrame *pFrame )
{
	SetHelpId(ID_SBA_TABLEIDXVIEWSH);
	SbaTableDef* pTableDef = PTR_CAST(SbaTableDef, GetShell()->GetDBDef());

	if (pTableDef)
	{
		SbaTableDesignFrame* pDesignFrame = new SbaTableIndexDesignFrame(&pFrame->GetWindow(), pTableDef, this);
		pDesignFrame->SetHelpId(HID_TAB_DESIGN_FRAME);
		pWindow = (SbaTableIndexCtrl*)pDesignFrame->GetMainWin();
		SetUndoManager(&aUndoManager);
		SetWindow(pDesignFrame);

		m_nSetInitialFocusEventID = Application::PostUserEvent(LINK(this, SbaTableIdxViewSh, OnSetInitialFocus));
	}
}

DBG_NAME(SbaTableIdxViewSh);
//------------------------------------------------------------------------------
SbaTableIdxViewSh::SbaTableIdxViewSh(SfxViewFrame *pFrame, SfxViewShell* pView)
				  :SbaTableViewSh(pFrame)
				  ,pWindow(NULL)
				  ,m_nCorrectUpdatableEventID(0)
				  ,m_nSetInitialFocusEventID(0)
{
	DBG_CTOR(SbaTableIdxViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableIdxViewSh::SbaTableIdxViewSh(SfxViewFrame *pFrame, Window* pWindow)
				  :SbaTableViewSh(pFrame)
				  ,pWindow(NULL)
				  ,m_nCorrectUpdatableEventID(0)
				  ,m_nSetInitialFocusEventID(0)
{
	DBG_CTOR(SbaTableIdxViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableIdxViewSh::SbaTableIdxViewSh( SfxViewFrame *pFrame, const SbaTableIdxViewSh& rSh )
				  :SbaTableViewSh(pFrame)
				  ,pWindow(NULL)
				  ,m_nCorrectUpdatableEventID(0)
				  ,m_nSetInitialFocusEventID(0)
{
	DBG_CTOR(SbaTableIdxViewSh,NULL);
	Construct( pFrame );
}

//------------------------------------------------------------------------------
SbaTableIdxViewSh::~SbaTableIdxViewSh()
{
	delete pWindow->GetParent();
	pWindow = NULL;

	if (m_nCorrectUpdatableEventID)
		Application::RemoveUserEvent(m_nCorrectUpdatableEventID);
	if (m_nSetInitialFocusEventID)
		Application::RemoveUserEvent(m_nSetInitialFocusEventID);
	DBG_DTOR(SbaTableIdxViewSh,NULL);
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::InnerResizePixel( const Point &rPos, const Size &rSize )
{
	pWindow->GetParent()->SetPosSizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::OuterResizePixel( const Point &rPos, const Size &rSize )
{
	InnerResizePixel(rPos, rSize);
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::Execute( SfxRequest& rReq )
{
	switch (rReq.GetSlot())
	{
		case SID_MAIL_SENDDOC:
			SFX_APP()->ExecuteSlot(rReq);
			break;
		case SID_RELOAD:
		case SID_SAVEDOC:
		{
			BOOL bExecutingSave = (SID_SAVEDOC == rReq.GetSlot());
			SbaTableDocSh* pDoc = (SbaTableDocSh*)GetShell();

			if (!bExecutingSave)
			{
				if (pDoc->IsModified())
					if (RET_YES != QueryBox(NULL, ResId(MSG_QUERY_LASTVERSION)).Execute())
						return;
			}

			BOOL bSuccess = bExecutingSave ? pWindow->SaveData(FALSE) : pDoc->Refresh();
			if (!bSuccess)
				return;

			GetShell()->SetModified( FALSE );
			SFX_BINDINGS().Invalidate(SID_SAVEDOC);

			pWindow->UpdateAll();
			pWindow->Invalidate();
		}
		break;
		case SID_EDITDOC:
			BOOL bUpdatable = pWindow->IsUpdatable();

			SbaTableDocSh* pDoc = (SbaTableDocSh*)GetShell();
			// wenn ich gerade beim Bearbeiten war und das Doc modifiziert ist ...
			if (bUpdatable && pDoc->IsModified())
			{
				// ... aktuelle Zelle + ganzes Doc speichern
				if (!pWindow->SaveData(TRUE) || !pDoc->Save())
					return;

				pDoc->SetModified(FALSE);
				SFX_BINDINGS().Invalidate(SID_SAVEDOC);
				GetUndoManager()->Clear();
			}
			pWindow->SetUpdatable(!bUpdatable);
			break;
	}
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::GetState(SfxItemSet &rSet)
{
	SfxWhichIter aIter(rSet);
	for (USHORT nSID = aIter.FirstWhich(); nSID; nSID = aIter.NextWhich())
	{
		switch ( nSID )
		{
			case SID_RELOAD:
				if (GetShell()->GetDBDef()->IsNew())
					rSet.DisableItem(nSID);
				break;
			case SID_MAIL_SENDDOC:
				// Sonderbehandlung, Aenderung des Menuetextes
				rSet.Put( SfxStringItem( nSID, String( SbaResId( RID_STR_MENU_NEWMAIL ) ) ) );
				break;
			case SID_SAVEDOC:
				if( !GetShell()->IsModified() )
					rSet.DisableItem(nSID);
				break;

			case SID_EDITDOC:
			{
				SbaTableDef* pTableDef = (SbaTableDef*)GetShell()->GetDBDef();
				BOOL bUpdatable = pWindow->IsUpdatable();

				// wenn das IndexControl der Meinung ist, dass es gar nicht geht -> disablen
				if (pWindow->IsStrongReadOnly())
					rSet.DisableItem(nSID);

				// wenn die Tabelle gerade benutzt wird -> kein edit erlauben
				else if (pTableDef->IsUsed())
				{
					rSet.DisableItem(nSID);
					if (bUpdatable)
						m_nCorrectUpdatableEventID = Application::PostUserEvent(LINK(this, SbaTableIdxViewSh, OnCorrectUpdatable));
					// die Tabelle is used, aber das Fenster updatable -> es wurde, waehrend der design-modus an ist,
					// irgendwo eine BrowseAnsicht auf die Tabelle geoeffnet -> ich muss in readonly uebergehen
				}

				// wenn die Tabelle gelockt ist (weil zum beispiel, waehrend ich sie read-only offen hatte, jemand eine
				// zweite Entwurfsansicht aufgemacht hat) -> disablen
				else if (!bUpdatable && pTableDef->IsLocked())
					rSet.DisableItem(nSID);

				// ansonsten das Fenster nach Updatable fragen
				else
					rSet.Put(SfxBoolItem(nSID, pWindow->IsUpdatable()));
			}
			break;
		}
	}
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableIdxViewSh, OnCorrectUpdatable, void*, EMPTYARG)
{
	m_nCorrectUpdatableEventID = 0;
	pWindow->SetUpdatable(FALSE);
	return 0;
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableIdxViewSh, OnSetInitialFocus, void*, EMPTYARG)
{
	m_nSetInitialFocusEventID = 0;

	SbaTableIndexCtrl* pIndexView = (SbaTableIndexCtrl*)pWindow;
	if (pIndexView)
	{
		SbaTableDef* pTableDef = PTR_CAST(SbaTableDef, GetShell()->GetDBDef());
		if (pIndexView->IsUpdatable() && !pTableDef->IsUsed())
		{	// all indicators say the control should be updatable
			if (!pIndexView->IsEditing())
			{	// but the control isn't editing
				// -> it's positioned on a readonly row (e.g. describing a implicit index
				// created by the driver)
				pIndexView->GoToRowColumnId(pIndexView->getFirstWritableIndex(), 2);
			}
		}
	}
	return 0L;
}

//------------------------------------------------------------------------------
USHORT SbaTableIdxViewSh::PrepareClose( BOOL bUI, BOOL bForBrowsing )
{
	if( GetShell()->IsModified() )
		return pWindow->SaveData( bUI, bForBrowsing );

	return (USHORT)TRUE;
}


//------------------------------------------------------------------------------
void SbaTableIdxViewSh::Activate(BOOL IsMDIActivate)
{
	if (pWindow && pWindow->GetParent())
		((SbaViewSwitchFrame*)pWindow->GetParent())->EnableAccelSwitch(TRUE);

	SbaTableViewSh::Activate(IsMDIActivate);
}

//------------------------------------------------------------------------------
void SbaTableIdxViewSh::Deactivate(BOOL IsMDIActivate)
{
	if (pWindow && pWindow->GetParent())
		((SbaViewSwitchFrame*)pWindow->GetParent())->EnableAccelSwitch(FALSE);

	SbaTableViewSh::Deactivate(IsMDIActivate);
}

//==============================================================================

//------------------------------------------------------------------------------
SbaTableIndexDesignFrame::SbaTableIndexDesignFrame(Window* pParent, SbaTableDef* pDef, SbaTableIdxViewSh* pView)
	:SbaTableDesignFrame(pParent, pDef, pView, STR_TAB_INDEX)
{
	m_pMainWin = new SbaTableIndexCtrl( this, pDef, pView );
	((SbaTableIndexCtrl*)m_pMainWin)->Init();
	m_pMainWin->Show();
}

//------------------------------------------------------------------------------
void SbaTableIndexDesignFrame::GetFocus()
{
	SbaTableDesignFrame::GetFocus();
	m_pMainWin->GrabFocus();
}

