/*************************************************************************
 *
 *  $RCSfile: tblvs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _SBA_TBLVS_HXX
#include "tblvs.hxx"
#endif
#ifndef _SBA_TBLDS_HXX
#include "tblds.hxx"
#endif
#ifndef _SBA_SBARES_HXX
#include "sbares.hxx"
#endif
#ifndef _SBAITEMS_HRC
#include "sbaitems.hrc"
#endif
#ifndef _SBAITEMS_HXX
#include "sbaitems.hxx"
#endif
#ifndef _SBAHLPID_HRC
#include "sbahlpid.hrc"
#endif
#ifndef _SBARESID_HRC
#include "sbaresid.hrc"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

TYPEINIT1(SbaTableViewSh, SbaDBDataDefViewSh)

//------------------------------------------------------------------------------
SbaTableViewSh::SbaTableViewSh(SfxViewFrame *pFrame)
			   :SbaDBDataDefViewSh(pFrame)
			   ,bPrepareCalled(sal_False)
{
}

//==============================================================================
//------------------------------------------------------------------------------
SbaTableDesignFrame::SbaTableDesignFrame(Window* pParent, SbaTableDef* pDef, SbaTableViewSh* pView, sal_uInt16 nInitialId)
	:SbaViewSwitchFrame(pParent, pDef, pView)
{
	// initialize the tab bar
	m_aTabBar.InsertPage(STR_TAB_EDITOR, String(SbaResId(STR_TAB_EDITOR)));
	m_aTabBar.SetHelpId(STR_TAB_EDITOR, HID_TAB_BAR_PAGE_TABLE_DESIGN);

	m_aTabBar.SetHelpId(HID_TBLDGN_TABBAR);

	// insert an index page - if the db is able to work with indicies
	::com::sun::star::uno::Reference< ::com::sun::star::data::XDatabaseDescriptor >  rMetaData(pDef->GetDatabase()->GetMetaData());

	::com::sun::star::uno::Any aAnsiUsage = rMetaData->getInfo(::com::sun::star::data::DatabaseInfo::ANSI_SQL_92);
	if(rMetaData->getLimit(::com::sun::star::data::DatabaseLimit::INDEX_SIZE))
	{
		m_aTabBar.InsertPage(STR_TAB_INDEX, String(SbaResId(STR_TAB_INDEX)));
		m_aTabBar.SetHelpId(STR_TAB_INDEX, HID_TAB_BAR_PAGE_TABLE_INDICIES);
	}

	DBG_ASSERT(m_aTabBar.GetPagePos(nInitialId) != TAB_PAGE_NOTFOUND, "SbaTableDesignFrame::SbaTableDesignFrame : invalid initial id !");
	m_aTabBar.SetCurPageId(nInitialId);

	// disable the index page (if needed)
	if (pDef->IsNew() || pDef->GetTable()->IsView())
		// new tables and views can't be indexed
		m_aTabBar.EnablePage( STR_TAB_INDEX, sal_False );
	else
		CheckIndexPageAvailability();
	DBG_ASSERT(m_aTabBar.IsPageEnabled(STR_TAB_INDEX) || (nInitialId != STR_TAB_INDEX),
		"SbaTableDesignFrame::SbaTableDesignFrame : invalid initial id !");

	m_aTabBar.Show();
}

//------------------------------------------------------------------------------
void SbaTableDesignFrame::CheckIndexPageAvailability()
{
	// we need at least one indexable column to enable the index page
	sal_Bool bIndexable = sal_False;

	const SbaColumnList& rColumnList = m_pDefinition->GetOriginalColumns();
	sal_uInt32 nColCount = rColumnList.Count();
	for (sal_uInt32 i=0;!bIndexable &&  i<nColCount; ++i)
	{
		SFX_ITEMSET_GET(*rColumnList.GetObject(i), pType, SbaDataFieldTypeItem, SBA_DEF_FLTTYPE, sal_True);
		SbaFieldType aFieldType = pType->GetType();
		switch(aFieldType)
		{
			case dbMemo:
			case dbBinary:
			case dbVarBinary:
			case dbImage:
				break;
			default:
				bIndexable = sal_True;
		}
	}
	m_aTabBar.EnablePage( STR_TAB_INDEX, bIndexable );
}

//------------------------------------------------------------------------------
void SbaTableDesignFrame::TabSelected(sal_uInt16 nId)
{
	sal_Bool bWasModified = GetDocShell()->IsModified();

	if (GetDocShell()->PrepareClose(sal_True, sal_False) == sal_True)
		PostUserEvent(LINK(this, SbaTableDesignFrame, OnAsyncViewSwitch), (void*)(STR_TAB_INDEX == nId ? SID_SBA_TBL_INDEX : SID_SBA_TBL_DESIGN));
			// Switch  asynchronously : when switching the view shell is destroyed, i.e. this window
			// and it's tabbar) are destroyed, too.
			// Doing this synchronous woul be deadly ...
	else
		m_aTabBar.SetCurPageId(STR_TAB_INDEX == nId ? STR_TAB_EDITOR : STR_TAB_INDEX);

	if (bWasModified && !GetDocShell()->IsModified())
		// This means the doc isn't modified anymore because the changes were saved or ignored.
		// In the latter case the doc shell has to reload it's data, but we don't have a possibility
		// to make a distinction so we always reload ...
		((SbaTableDocSh*)GetDocShell())->LoadData();
}

//------------------------------------------------------------------------------
IMPL_LINK(SbaTableDesignFrame, OnAsyncViewSwitch, sal_uInt32, nNewViewId)
{
	SbaDBDataDefDocSh* pDocShell = GetDocShell();
		// get the pointer to the shell because we may be destroyed when switching the view

	if (!pDocShell->SetCurView(nNewViewId))
	{
		m_aTabBar.SetCurPageId(SID_SBA_TBL_INDEX == nNewViewId ? STR_TAB_EDITOR : STR_TAB_INDEX);
	}

	pDocShell->SetModified(sal_False); // if we get here the doc should have been saved

	return 0L;
}

//==============================================================================

