/*************************************************************************
 *
 *  $RCSfile: ieditbrw.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vcl/sysdep.hxx>
#include <vcl/virdev.hxx>

#include "editbrw.hxx"

#define MOTIF_COMBO_WIDTH 25
#define MOTIF_COMBO_HEIGHT 25

Bitmap ComboBoxCtrl::GetComboBitmap()
{
  Bitmap aSvBitmap;               // this bitmap will contain the combo box
  VirtualDevice aVirtualDevice;   // we need a virtual device to paint the
								  // combo box

  if ( !aVirtualDevice.SetOutputSizePixel( Size( MOTIF_COMBO_WIDTH,
						 MOTIF_COMBO_HEIGHT ), TRUE ) )
	return aSvBitmap;    // if we can't even set the output size,
						 // return an empty bitmap

  Color a3DFaceColor( COL_3DFACE );
  Color a3DShadowColor( COL_3DSHADOW );
  Color a3DLightColor( COL_3DLIGHT );
  Brush aFillInBrush( a3DFaceColor );         // solid, 3dface brush
  Pen a3DShadowPen( a3DShadowColor );
  Pen a3DLightPen( a3DLightColor );

  aVirtualDevice.SetPen( a3DLightPen );
  aVirtualDevice.SetFillInBrush( aFillInBrush );
  aVirtualDevice.DrawRect( Rectangle( Point( 0, 0 ),
					  Point( MOTIF_COMBO_WIDTH-1,
						 MOTIF_COMBO_HEIGHT-1) ) );
  aVirtualDevice.DrawLine( Point( 3, 4 ), Point( 18, 4 ) );
  aVirtualDevice.DrawLine( Point( 3, 4 ), Point( 11, 16 ) );
  aVirtualDevice.DrawLine( Point( 4, 18 ), Point( 17, 18 ) );

  aVirtualDevice.SetPen( a3DShadowPen );
  aVirtualDevice.DrawLine( Point( 1, 22 ), Point( 22, 22 ) );
  aVirtualDevice.DrawLine( Point( 22, 22), Point( 22, 1 ) );
  aVirtualDevice.DrawLine( Point( 4, 19 ), Point( 17, 19 ) );
  aVirtualDevice.DrawPixel( Point( 18, 18 ), a3DShadowColor );
  aVirtualDevice.DrawLine( Point( 11, 16 ), Point( 18, 5) );

  aSvBitmap = aVirtualDevice.GetBitmap( Point( 0, 0 ),
						Size( MOTIF_COMBO_WIDTH,
						  MOTIF_COMBO_HEIGHT ) );

  return aSvBitmap;
}

