#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=SVX
TARGET=sbllink
LIBTARGET=NO

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

.IF "$(GUI)"=="WIN"
OPTLINKS=YES
NIXRC=YES
LINK=$(DEVROOT)$/bin\optlinks\optlinks
RCFLAGS=-k
RCLINK=echo nix RC
.IF "$(debug)" != ""
LINKFLAGS= /F /PACKCODE:65520 /PACKDATA /A:128 /NOD /NOE /MAP /COD /NOCV
.ELSE
LINKFLAGS= /F /PACKCODE:65520 /PACKDATA /A:128 /NOD /NOE /MAP
.ENDIF
.ENDIF

SVXSTDLIBS= tools.lib $(SVLIB) svtool.lib dg.lib \
		sfx.lib basic.lib sfxdebug.lib svmem.lib svx.lib so2.lib

# --- Files --------------------------------------------------------

CXXFILES=	sbllink.cxx

OBJFILES=	$(OBJ)$/sbllink.obj

APP1TARGET= $(TARGET)
APP1STDLIBS= \
	$(SVXLIB) \
	$(SFXLIB) \
	$(SFXDEBUGLIB) \
	$(SETUPLIB) \
	$(BASICLIB) \
	$(GOODIESLIB) \
	$(SO2LIB) \
	$(SVTOOLLIB) \
	$(SVLLIB)	\
	$(SVMEMLIB) \
	$(SJLIB) \
	$(TKLIB) \
	$(VCLLIB) \
	$(SOTLIB) \
	$(UNOLIB) \
	$(VOSLIB) \
	$(TOOLSLIB) \
	$(TECLIB) \
    $(CPPULIB) \
    $(CPPUHELPERLIB) \
    $(UNOTOOLSLIB) \
	$(SALLIB) \
	$(BASCTLLIB)

.IF "$(OS)" == "SOLARIS"
APP1STDLIBS += -lXm
.ENDIF
.IF "$(OS)" == "LINUX"
APP1STDLIBS += -lXaw
.ENDIF
.IF "$(GUI)" == "UNX"
APP1STDLIBS += -lXt -lX11
.ENDIF

.IF "$(GUI)" == "WNT"
APP1STDLIBS += gdi32.lib
.ENDIF

APP1DEPN=	$(L)$/sfx.lib $(L)$/svx.lib

APP1OBJS=	$(OBJ)$/sbllink.obj

# APP1DEF=	$(MISC)$/$(TARGET).def
APP1BASE=	0x10000000

RESLIB1NAME=$(TARGET)
RESLIB1SRSFILES=$(SOLARRESDIR)$/basic.srs


# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

# ------------------------------------------------------------------
# Windows
# ------------------------------------------------------------------

.IF "$(GUI)" == "WIN"

$(MISC)$/$(TARGET).def:
	echo  NAME			$(TARGET)							>$@
	echo  DESCRIPTION	'BASIC-IDE'                        >>$@
	echo  EXETYPE		WINDOWS 						   >>$@
	echo  STUB			'winSTUB.EXE'                      >>$@
	echo  PROTMODE										   >>$@
	echo  CODE			PRELOAD MOVEABLE DISCARDABLE	   >>$@
	echo  DATA			PRELOAD MOVEABLE MULTIPLE		   >>$@
	echo  HEAPSIZE		8192							   >>$@
	echo  STACKSIZE 	32768							   >>$@
#!IF "$(OPTLINKS)" == "YES"
#	echo  RC $(RCFLAGS) $(RES)$/sbllink2.res					>>$@
#!ENDIF

.ENDIF

# ------------------------------------------------------------------
# OS2
# ------------------------------------------------------------------

.IF "$(GUI)" == "OS2"

$(MISC)$/$(TARGET).def:
	echo  NAME			$(TARGET) WINDOWAPI 				>$@
	echo  DESCRIPTION	'BASIC-IDE'                        >>$@
.IF "$(COM)" != "BLC"
	echo  STUB			'os2STUB.EXE'                      >>$@
.ENDIF
	echo  EXETYPE		OS2 							   >>$@
	echo  PROTMODE										   >>$@
	echo  CODE			PRELOAD 						   >>$@
	echo  DATA			PRELOAD MULTIPLE				   >>$@
	echo  HEAPSIZE		8192							   >>$@
	echo  STACKSIZE 	32768							   >>$@

.ENDIF
