/*************************************************************************
 *
 *  $RCSfile: sbllink.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:32:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include <sbllink.hxx>

#include <tools/fsys.hxx>
#include <tools/stream.hxx>

#ifndef _SFX_BASMGR_HXX_
#include <sfx2/basmgr.hxx>
#endif

#include <basic/basrdll.hxx>
#include <svtools/sbx.hxx>
#include <basctl/vcsbxdef.hxx>
#include <basctl/sidll.hxx>
#include <svtools/iniman.hxx>
#include <tools/resmgr.hxx>

#ifndef _SB_SBMETH_HXX //autogen
#include <basic/sbmeth.hxx>
#endif

#ifndef _SB_SBMOD_HXX //autogen
#include <basic/sbmod.hxx>
#endif

#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _FACTORY_HXX //autogen
#include <so3/factory.hxx>
#endif

#include <vcl/wrkwin.hxx>

#define INFO_SEP	(char)0xFF

static const char __FAR_DATA szMain[] = "Main";
static const char __FAR_DATA szSBLDir[] = "SBL-Dir";
static const char __FAR_DATA szModDir[] = "Modules-Dir";

static const char __FAR_DATA szLibs[] = "Libs";
static const char __FAR_DATA szMods[] = "Modules";
static const char __FAR_DATA szDlgs[] = "Dialogs";
static const char __FAR_DATA szPassword[] = "Password";

static const char __FAR_DATA szSpecialComment[] = "'SBLLINK:";
static const char __FAR_DATA szSCModuleInfo[] = "ModuleInfo=";
static const char __FAR_DATA szSCMethodInfo[] = "MethodInfo=";

static const char __FAR_DATA szCharSet[] = "CharSet";

SV_IMPL_PTRARR( LibInfoArray, LibInfoPtr );

SBLLinkApplication aApp;

SBLLinkApplication::SBLLinkApplication()
{
	eCharSet = gsl_getSystemTextEncoding();
}

SBLLinkApplication::~SBLLinkApplication()
{
}

#include <osl/module.h>
#include <rtl/ustring.hxx>
#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <unotools/processfactory.hxx>
#endif
#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include <cppuhelper/servicefactory.hxx>
#endif
#include <cppuhelper/factory.hxx>

using namespace ::rtl;
using namespace ::cppu;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::container;

#ifndef _LIBCALL_HXX
#include <svtools/libcall.hxx>
#endif

void SBLLinkApplication::Main( )
{
    Reference< ::com::sun::star::lang::XMultiServiceFactory > xSMgr = createServiceFactory();
	::utl::setProcessServiceFactory( xSMgr );
	RegisterUnoServices();

	oslModule pModule = NULL;
	OUString locationUrl = OUString::createFromAscii( SVLIBRARY( "imr" ) );
	if (pModule = osl_loadModule( locationUrl.pData, SAL_LOADMODULE_GLOBAL | SAL_LOADMODULE_LAZY ))
	{
		// try to get the service factory from module
        component_getFactoryFunc pFactFunc = (component_getFactoryFunc) osl_getSymbol(pModule, OUString::createFromAscii( COMPONENT_GETFACTORY ).pData );
        if ( pFactFunc )
		{
            XSingleServiceFactory* pFact = (XSingleServiceFactory*) (*pFactFunc)( "com.sun.star.comp.extensions.ConfigManager", NULL, NULL );
            Reference< XSingleServiceFactory > xFact( pFact );
            Reference< XSet > xSet( xSMgr, UNO_QUERY );
            xSet->insert( Any( &xFact, ::getCppuType((Reference< ::com::sun::star::uno::XInterface >*)0) ) );
            pFact->release();
		}
	}

    String aIni( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "sbllink") ) );
    SfxIniManager::Create(&aIni );

	SiDLL		 	aSiDLL;
	BasicDLL     	aBasicDLL;
//	SvxDialogDll 	aDlgDll;

	ResMgr* pResMgr = CREATEVERSIONRESMGR( sbl);
	Resource::SetResManager( pResMgr );

	SetAppName( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SBLLink" ) ) );
	SvFactory::Init();

	// dummy workwin, prevent segementation fault
	WorkWindow aWin( NULL, WB_APP | WB_STDWORK );

	pLogFile = 0;

	StarBASIC::SetGlobalErrorHdl( LINK( this, SBLLinkApplication, GlobalBasicErrorHdl ) );

	BOOL bDone = FALSE;
#ifndef VCL
	for( USHORT i = 1; i < nArgs; i++ )
	{
		String aArg( pArgs[i] );
#else
	for( USHORT i = 0; i < GetCommandLineParamCount(); i++ )
	{
		String aArg( GetCommandLineParam(i) );
#endif
		if( aArg.CompareIgnoreCaseToAscii( "/Link:", 6 ) == COMPARE_EQUAL )
		{
			aArg.Erase( 0, 6 );
			ProcessSBL( aArg, FALSE );
			bDone = TRUE;
		}
		else if( aArg.CompareIgnoreCaseToAscii( "/Dump:", 6 ) == COMPARE_EQUAL )
		{
			// Trennen...
			aArg.Erase( 0, 6 );
			ProcessSBL( aArg, TRUE );
			bDone = TRUE;
		}
	}

	SvFactory::DeInit();

	Resource::SetResManager( NULL );
	delete pResMgr;

	if( pLogFile )
		delete pLogFile, pLogFile = 0;

	if ( !bDone )
	{
		InfoBox( 0, String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Usage:\nsbllink { /Link:Script | /Dump:Script }\n" ) ) ).Execute();
	}
}

void SBLLinkApplication::ProcessSBL( const String& rScriptName, BOOL bDump )
{
	DirEntry aDirEntry( rScriptName );
	aDirEntry.ToAbs();

	BOOL bScriptExist = aDirEntry.Exists();

	Config aCfg( aDirEntry.GetFull() );
	String aScriptName = aDirEntry.GetName();
	DirEntry aWorkingDir( aDirEntry.GetPath() );
	DirEntry aSBLDir( aWorkingDir );
	DirEntry aModulesDir( aWorkingDir );

	aCfg.SetGroup( szMain );
	String aSBLDirStr( aCfg.ReadKey( szSBLDir ), RTL_TEXTENCODING_UTF8 );
	if ( aSBLDirStr.Len() )
		aSBLDir += DirEntry( aSBLDirStr );
	String aMODDirStr( aCfg.ReadKey( szModDir ), RTL_TEXTENCODING_UTF8 );
	if ( aMODDirStr.Len() )
		aModulesDir += DirEntry( aMODDirStr );

	String sCharSet( aCfg.ReadKey( szCharSet ), RTL_TEXTENCODING_UTF8 );
	if( sCharSet.Len() )
		eCharSet = GetCharSet( sCharSet );

	aDirEntry.SetExtension( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "log" ) ) );
	pLogFile = new SvFileStream( aDirEntry.GetFull(), STREAM_WRITE|STREAM_TRUNC );

	DirEntry aSBL( aSBLDir );
	aSBL += DirEntry( aScriptName );
	aSBL.SetExtension( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "sbl" ) ) );
	if ( !bDump )
	{
		DirEntry aCopy( aSBL );
		aCopy.SetExtension( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "sb_" ) ) );
		FileCopier aCopier( aSBL, aCopy );
		aCopier.Execute( FSYS_ACTION_COPYFILE );
		aSBL.Kill();
	}
	SvStorageRef xStorage = new SvStorage( aSBL.GetFull(), bDump ?
									STREAM_READ | STREAM_SHARE_DENYWRITE :
									STREAM_READWRITE | STREAM_SHARE_DENYALL );
	BasicManager* pBasMgr = bDump ? new SfxBasicManager( *xStorage ) : NULL;
	LibInfoArray aLibs;

	if ( xStorage->GetError() )
		(*pLogFile) << "Error open storage: " << ByteString( aSBL.GetFull(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;
	else if ( !bScriptExist )
		(*pLogFile) << "Script not found: " << ByteString( rScriptName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;
	else if ( !pBasMgr || !pBasMgr->HasErrors() )
	{
		aCfg.SetGroup( szLibs );
		USHORT nLibs = aCfg.GetKeyCount();
		if ( bDump && ( nLibs != pBasMgr->GetLibCount() ) )
			(*pLogFile) << "Different LibCount: " << ByteString( aSBL.GetName(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;

		// -------------------------------------------------------
		// Libs
		// -------------------------------------------------------
		for ( USHORT nL = 0; nL < nLibs; nL++ )
		{
			aCfg.SetGroup( szLibs );
			String aLibName( aCfg.GetKeyName( nL ), RTL_TEXTENCODING_UTF8 );

			if( aLibName.CompareToAscii( szCharSet ) == COMPARE_EQUAL )
				continue;

			String aOption( aCfg.ReadKey( nL ), RTL_TEXTENCODING_UTF8 );

			StarBASIC* pLib = 0;
			LibInfo* pLibInfo = 0;
			if ( bDump )
			{
				USHORT nLibId = pBasMgr->GetLibId( aLibName );
				if ( !pBasMgr->IsLibLoaded( nLibId ) )
					pBasMgr->LoadLib( nLibId );

				pLib = pBasMgr->GetLib( nLibId );
			}
			else
			{
				pLib = new StarBASIC;
				pLib->SetName( aLibName );
				pLibInfo = new LibInfo( pLib, aOption );
				aLibs.Insert( pLibInfo, aLibs.Count() );
			}

			if ( pLib )
			{
				// -------------------------------------------------------
				// Password...
				// -------------------------------------------------------
				if ( !bDump )
				{
					String aPWSection( aLibName );
					aPWSection += '-';
					aPWSection += String::CreateFromAscii( szPassword );
					aCfg.SetGroup( ByteString( aPWSection, RTL_TEXTENCODING_UTF8 ) );
					String aPassword( aCfg.ReadKey( szPassword ), RTL_TEXTENCODING_UTF8 );
					pLibInfo->SetPassword( aPassword );
				}
				// -------------------------------------------------------
				// Module...
				// -------------------------------------------------------
				String aModSection( aLibName );
				aModSection += '-';
				aModSection += String::CreateFromAscii( szMods );
				aCfg.SetGroup( ByteString( aModSection, RTL_TEXTENCODING_UTF8 ) );
				USHORT nMods = aCfg.GetKeyCount();

				CharSet eCurCharSet = eCharSet;
				if( (sCharSet = String( aCfg.ReadKey( szCharSet ), RTL_TEXTENCODING_UTF8 ) ).Len() )
				{
					eCurCharSet = GetCharSet( sCharSet );
					if ( bDump && ( nMods-1 != pLib->GetModules()->Count() ) )
						(*pLogFile) << "Different ModulesCount: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer()  << ": Script=" << ByteString( nMods ).GetBuffer() << ", LIB=" << ByteString( pLib->GetModules()->Count() ).GetBuffer() << endl;
				}
				else if ( bDump && ( nMods != pLib->GetModules()->Count() ) )
					(*pLogFile) << "Different ModulesCount: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer()  << ": Script=" << ByteString( nMods ).GetBuffer() << ", LIB=" << ByteString( pLib->GetModules()->Count() ).GetBuffer() << endl;

				for ( USHORT nM = 0; nM < nMods; nM++ )
				{
					String aModuleName( aCfg.GetKeyName( nM ), RTL_TEXTENCODING_UTF8 );
					if( aModuleName.EqualsAscii( szCharSet ) )
						continue;

					String aFileName( aCfg.ReadKey( nM ), RTL_TEXTENCODING_UTF8 );
					DirEntry aFileEntry( aModulesDir );
					aFileEntry += DirEntry( aFileName );
					SvFileStream aStream( aFileEntry.GetFull(), bDump ?
						STREAM_WRITE|STREAM_TRUNC : STREAM_READ );

					aStream.SetStreamCharSet( eCurCharSet );

					SbModule* pMod = 0;
					if ( bDump )
						pMod = pLib->FindModule( aModuleName );
					else
						pMod = pLib->MakeModule( aModuleName, String() );

					if ( pMod )
					{
						if ( bDump && !aStream.IsWritable() )
							(*pLogFile) << "Error open stream for writing: " << ByteString( aFileEntry.GetFull(), RTL_TEXTENCODING_UTF8 ).GetBuffer();

						if ( bDump )
							WriteModule( aStream, *pMod );
						else
							ReadModule( aStream, *pMod );

						if ( aStream.GetError() )
							(*pLogFile) << "Error reading/writing Module: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "." << ByteString( aModuleName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "(" << ByteString( aFileEntry.GetFull(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << ")" << endl;

						// Modul austragen und spaeter die restlichen dumpen...
						if ( bDump )
							pLib->GetModules()->Remove( pMod );
					}
					else
						(*pLogFile) << "Module not found: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "." << ByteString( aModuleName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;
				}
				// restliche Module dumpen ?

				// -------------------------------------------------------
				// Dialoge...
				// -------------------------------------------------------
				ByteString aDlgSection( aLibName, RTL_TEXTENCODING_UTF8 );
				aDlgSection += '-';
				aDlgSection += szDlgs;
				aCfg.SetGroup( aDlgSection );
				USHORT nDlgs = aCfg.GetKeyCount();

				eCurCharSet = eCharSet;
				if( ( sCharSet = String( aCfg.ReadKey( szCharSet ), RTL_TEXTENCODING_UTF8 ) ).Len() )
				{
					eCurCharSet = GetCharSet( sCharSet );
					if ( bDump && ( nDlgs-1 != pLib->GetObjects()->Count() ) )
						(*pLogFile) << "Different DialogsCount: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << ": Script=" << ByteString( nDlgs ).GetBuffer() << ", LIB=" << ByteString( pLib->GetObjects()->Count() ).GetBuffer() << endl;
				}
				else if ( bDump && ( nDlgs != pLib->GetObjects()->Count() ) )
					(*pLogFile) << "Different DialogsCount: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << ": Script=" << ByteString( nDlgs ).GetBuffer() << ", LIB=" << ByteString( pLib->GetObjects()->Count() ).GetBuffer() << endl;

				for ( USHORT nO = 0; nO < nDlgs; nO++ )
				{
					String aObjName( aCfg.GetKeyName( nO ), RTL_TEXTENCODING_UTF8 );
					if( aObjName.EqualsAscii( szCharSet ) )
						continue;

					String aFileName( aCfg.ReadKey( nO ), RTL_TEXTENCODING_UTF8 );
					DirEntry aFileEntry( aModulesDir );
					aFileEntry += DirEntry( aFileName );
					SvFileStream aStream( aFileEntry.GetFull(), bDump ?
						STREAM_WRITE|STREAM_TRUNC : STREAM_READ );

					aStream.SetStreamCharSet( eCurCharSet );

					SbxVariable* pVar = 0;
					if ( bDump )
						pVar = pLib->GetObjects()->Find( aObjName, SbxCLASS_OBJECT );
					if ( !bDump || ( pVar && ( pVar->GetSbxId() == SBXID_DIALOG ) ) )
					{
						if ( bDump && !aStream.IsWritable() )
							(*pLogFile) << "Error open stream for writing: " << ByteString( aFileEntry.GetFull(), RTL_TEXTENCODING_UTF8 ).GetBuffer();

						if ( bDump )
							pVar->Store( aStream );
						else
						{
							pVar = (SbxVariable*)SbxBase::Load( aStream );
							if ( pVar )
								pLib->GetObjects()->Insert( pVar, pLib->GetObjects()->Count() );
						}

						if ( !pVar || aStream.GetError() )
							(*pLogFile) << "Error reading/writing Dialog: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "." << ByteString( aObjName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "(" << ByteString( aFileEntry.GetFull(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << ")" << endl;

						// Dialog austragen und spaeter die restlichen dumpen...
						if ( bDump )
							pLib->GetObjects()->Remove( pVar );
					}
					else
						(*pLogFile) << "Dialog not found: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << "." << ByteString( aObjName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;
				}
				// restliche Dialoge dumpen ?
			}
			else
				(*pLogFile) << "Libary not found: " << ByteString( aLibName, RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;

		}
	}
	else
		(*pLogFile) << "BasicManager-Error" << endl;

	if ( !bDump )
	{
		StarBASIC* pStdLib = 0;
		for ( USHORT nL = 0; nL < aLibs.Count(); nL++ )
		{
			StarBASIC* pLib = aLibs[nL]->GetLib();
			if ( pLib->GetName().CompareIgnoreCaseToAscii( "Standard" ) == COMPARE_EQUAL )
			{
				pStdLib = pLib;
				aLibs.DeleteAndDestroy( nL );
				break;
			}
		}
		if ( !pStdLib )
			pStdLib = new StarBASIC;

		// Libs nicht zerstoeren, werden im BasicManager verwaltet.
		pBasMgr = new SfxBasicManager( pStdLib );
		for ( nL = 0; nL < aLibs.Count(); nL++ )
		{
			LibInfo* pLibInfo = aLibs[nL];
			StarBASIC* pLib = pLibInfo->GetLib();
			pBasMgr->AddLib( pLib );
			if ( pLibInfo->GetPassword().Len() )
			{
				USHORT nLibId = pBasMgr->GetLibId( pLib );
				pBasMgr->SetPassword( nLibId, pLibInfo->GetPassword() );
			}
			if ( aLibs[nL]->GetStorageName().CompareIgnoreCaseToAscii( "embedded" ) != COMPARE_EQUAL )
			{
				DirEntry aRel( aSBLDir );
				aRel += aLibs[nL]->GetStorageName();
				USHORT nLibId = pBasMgr->GetLibId( pLib );
				pBasMgr->SetLibStorageName( nLibId, aRel.GetFull() );
			}
		}
		pBasMgr->Store( *xStorage );
		if ( pBasMgr->HasErrors() )
			(*pLogFile) << "Error writing BasicManager" << endl;
	}
	delete pBasMgr;
}

void SBLLinkApplication::WriteModule( SvStream& rStream, SbModule& rMod )
{
	// Kommentare von Modul und Makros....
	SbxInfo* pInfo = rMod.GetInfo();
	if ( pInfo )
	{
		rStream << szSpecialComment << szSCModuleInfo
					<< ByteString( rMod.GetName(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << INFO_SEP;
		WriteInfo( rStream, *pInfo );
	}

	for ( USHORT nMethod = 0; nMethod < rMod.GetMethods()->Count(); nMethod++ )
	{
		SbMethod* pMethod = (SbMethod*)rMod.GetMethods()->Get( nMethod );
		if ( pMethod && pMethod->GetInfo() )
		{
			rStream << szSpecialComment << szSCMethodInfo
					<< ByteString( pMethod->GetName(), RTL_TEXTENCODING_UTF8 ).GetBuffer() << INFO_SEP;
			WriteInfo( rStream, *pMethod->GetInfo() );
		}
	}

	// Und den Quelltext...
	String aSource( rMod.GetSource() );
	aSource.ConvertLineEnd( LINEEND_CRLF );

//    if( rStream.GetStreamCharSet() != rStream.GetTargetCharSet() )
//   	    // in StreamCharSet konvertieren
//       	aSource.Convert( rStream.GetTargetCharSet(), rStream.GetStreamCharSet());

	rStream << ByteString( aSource, RTL_TEXTENCODING_UTF8 ).GetBuffer();
}

void SBLLinkApplication::ReadModule( SvStream& rStream, SbModule& rMod )
{
	ULONG nLen = rStream.Seek( STREAM_SEEK_TO_END );
	if ( nLen < 0xFFFB )
	{
		rStream.Seek( STREAM_SEEK_TO_BEGIN );
		ByteString aSource;
		rStream.Read( aSource.AllocBuffer( nLen ), nLen );
		aSource.ConvertLineEnd( LINEEND_LF );


// no more TargetCharSet
//  		if( rStream.GetStreamCharSet() != rStream.GetTargetCharSet() )
//  			// in StreamCharSet konvertieren
//  			aSource.Convert( rStream.GetStreamCharSet(), rStream.GetTargetCharSet() );

		// Erstmal die relevanten Kommentar-Zeilen sichern, die SbxInfos
		// koennen erst am Schluss nach dem Compilieren angehaengt werden.
		SvStringsDtor aInfos( 0, 4 );
		USHORT nInfoStartLen = ByteString( szSpecialComment ).Len();
		USHORT nCommentEnd = 0;
		USHORT nTokenIdx = 0;
		while ( nTokenIdx != STRING_NOTFOUND )
		{
			ByteString aLine = aSource.GetToken( 0, LINE_SEP, nTokenIdx );
			if ( aLine.CompareTo( szSpecialComment, nInfoStartLen ) == COMPARE_EQUAL )
			{
				nCommentEnd = nTokenIdx;
				String* pLine = new String( aLine, RTL_TEXTENCODING_UTF8 );
				pLine->Erase( 0, nInfoStartLen );
				aInfos.Insert( pLine, aInfos.Count() );
			}
			else
				break;
		}
		aSource.Erase( 0, nCommentEnd );

		String aSource2( aSource, rStream.GetStreamCharSet() );
		rMod.SetSource( aSource2  );
		rMod.Compile();

		// Und die Infos reintreten...
		for ( USHORT n = 0; n < aInfos.Count(); n++ )
		{
			String* pLine = aInfos[n];
			String aType = pLine->GetToken( 0, '=' );
			pLine->Erase( 0, aType.Len()+1 );
			BOOL bModuleComment = ( aType.EqualsAscii( szSCModuleInfo ) );
			String aModOrMethod = pLine->GetToken( 0, INFO_SEP );
			SbxVariable* pObj =  0;
			if ( bModuleComment )
				pObj = &rMod;
			else
				pObj = rMod.GetMethods()->Find( aModOrMethod, SbxCLASS_METHOD );

			if ( pObj )
			{
				String aComment = pLine->GetToken( 1, INFO_SEP );
				String aHelpFile = pLine->GetToken( 2, INFO_SEP );
				String aHelpId = pLine->GetToken( 3, INFO_SEP );

				SbxInfo* pInfo = pObj->GetInfo();
				if( !pInfo )
				{
					pInfo = new SbxInfo;
					pObj->SetInfo( pInfo );
				}
				pInfo->SetComment( aComment );
				pInfo->SetHelpFile( aHelpFile );
				pInfo->SetHelpId( aHelpId.ToInt32() );
			}
		}
	}
	else
		rStream.SetError( 1 );
}

void SBLLinkApplication::WriteInfo( SvStream& rStream, SbxInfo& rInfo )
{
	rStream << ByteString( rInfo.GetComment(), RTL_TEXTENCODING_UTF8 ).GetBuffer()
			<< INFO_SEP
			<< ByteString( rInfo.GetHelpFile(), RTL_TEXTENCODING_UTF8 ).GetBuffer()
			<< INFO_SEP
			<< ByteString( rInfo.GetHelpId() ).GetBuffer()
			<< endl;
}


IMPL_LINK( SBLLinkApplication, GlobalBasicErrorHdl, StarBASIC *, pBasic )
{
	// ReturnWert: BOOL
	//	FALSE:	Abbrechen
	//	TRUE:	Weiter....

	String aErrorText( pBasic->GetErrorText() );
	USHORT nErrorLine = pBasic->GetLine();
	USHORT nErrCol1 = pBasic->GetCol1();
	USHORT nErrCol2 = pBasic->GetCol2();

	String aFullErrorText;
	if( pBasic->IsCompilerError() )
	{
		aFullErrorText.AssignAscii( RTL_CONSTASCII_STRINGPARAM( "Compiler-Fehler: " ) );
		aFullErrorText += pBasic->GetName();
		SbModule* pActiveModule = StarBASIC::GetActiveModule();
		if ( pActiveModule )
		{
			aFullErrorText += '.';
			aFullErrorText += pActiveModule->GetName();
		}
		aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " (" ) );
		aFullErrorText += String::CreateFromInt32(nErrorLine);
		aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "," ) );
		aFullErrorText += String::CreateFromInt32(nErrCol1);
		aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ") - " ) );
		aFullErrorText += aErrorText;
		if ( pActiveModule )
		{
			// Eine Zeile davor/dahinter ausgeben, weil z.B. bei 'Sub erwartet' die Zeile davor angegeben wird.
			USHORT nStart = nErrorLine-1;
			if ( nStart )
				nStart--;
			USHORT nEnd = nErrorLine;
			for ( USHORT n = nStart; n <= nEnd; n++ )
			{
				aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "\nSource #" ) );
				aFullErrorText += String::CreateFromInt32(n+1);
				aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ": " ) );
				aFullErrorText += pActiveModule->GetSource().GetToken( n, '\n' );
			}
		}
	}
	else
	{
		aFullErrorText.AssignAscii( RTL_CONSTASCII_STRINGPARAM( "Laufzeit-Fehler: #" ) );
		aFullErrorText += StarBASIC::GetVBErrorCode( pBasic->GetErrorCode() );
		aFullErrorText.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " " ) );
		aFullErrorText += aErrorText;
	}

	(*pLogFile) << ByteString( aFullErrorText, RTL_TEXTENCODING_UTF8 ).GetBuffer() << endl;

	return 0;	// Abbruch
}

CharSet SBLLinkApplication::GetCharSet( const String& rCharStr )
{
	CharSet eRet = eCharSet;
	ByteString aCharSet( rCharStr, RTL_TEXTENCODING_UTF8 );
	if( aCharSet.Len() )
	{
		aCharSet.ToUpperAscii();
		if( aCharSet == "IBMPC" )
			eRet =  RTL_TEXTENCODING_IBM_850;
		else if( aCharSet == "ANSI" )
			eRet = RTL_TEXTENCODING_MS_1252;
		else if( aCharSet == "MAC" )
			eRet = RTL_TEXTENCODING_APPLE_ROMAN;
		else if( aCharSet == "IBMPC_437" )
			eRet = RTL_TEXTENCODING_IBM_437;
		else if( aCharSet == "IBMPC_850" )
			eRet = RTL_TEXTENCODING_IBM_850;
		else if( aCharSet == "IBMPC_860" )
			eRet = RTL_TEXTENCODING_IBM_860;
		else if( aCharSet == "IBMPC_861" )
			eRet = RTL_TEXTENCODING_IBM_861;
		else if( aCharSet == "IBMPC_863" )
			eRet = RTL_TEXTENCODING_IBM_863;
		else if( aCharSet == "IBMPC_865" )
			eRet = RTL_TEXTENCODING_IBM_865;
		else
			(*pLogFile) << "unbekannter Zeichensatz" << endl;
	}
	return eRet;
}

