#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.8 $
#
#   last change: $Author: csaba $ $Date: 2000/10/16 14:56:19 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=ofa
TARGET=ofa
TARGET2=sba
GEN_HID=TRUE
.IF "$(CPU)"=="i386"
USE_LDUMP2=TRUE
.ENDIF

PROJECTPCH=ofapch
PDBTARGET=ofapch
PROJECTPCHSOURCE=$(PRJ)$/util$/ofapch

# --- Settings ------------------------------------------------------------

.INCLUDE :	settings.mk

.IF "$(prjpch)" != ""
CDEFS+=-DPRECOMPILED
.ENDIF

RSCLOCINC!:=$(RSCLOCINC);$(PRJ)$/RES
SOLARLIB+=-L$(LB)

# --- Allgemein -----------------------------------------------------------

RES1FILELIST=\
	$(SRS)$/ofaslots.srs \
	$(SRS)$/dialog.srs \
	$(SRS)$/app.srs \
	$(SOLARRESDIR)$/sfxslots.srs \
	$(SOLARRESDIR)$/svxslots.srs \
	$(SOLARRESDIR)$/svtools.srs \
	$(SOLARRESDIR)$/sfx.srs 	\
	$(SOLARRESDIR)$/so2.srs 	\
	$(SOLARRESDIR)$/basic.srs

.IF "$(SOLAR_JAVA)" != ""
#RES1FILELIST+=\
#	$(SOLARRESDIR)$/sj.srs
.ENDIF

RESLIB1NAME=$(TARGET)
RESLIB1SRSFILES=$(RES1FILELIST)

RES2FILELIST=\
		$(SRS)$/db.srs \
		$(SRS)$/sbauno.srs \
		$(SRS)$/ldap.srs \
		$(SRS)$/dlg.srs \
		$(SRS)$/common.srs \
		$(SRS)$/rptsh.srs \
		$(SRS)$/frmsh.srs \
		$(SRS)$/qrysh.srs \
		$(SRS)$/joinsh.srs \
		$(SRS)$/relsh.srs \
		$(SRS)$/sbabrw.srs \
		$(SRS)$/sbatab.srs \
		$(SRS)$/sbaobj.srs \
		$(SRS)$/ofaslots.srs

RESLIB2NAME= $(TARGET2)
RESLIB2SRSFILES=$(RES2FILELIST)

LIB1TARGET=$(SLB)$/$(TARGET2).lib
LIB1FILES=	\
		$(SLB)$/sbaobj.lib

LIB2TARGET=$(SLB)$/mhsba.lib
LIB2FILES=\
		$(SLB)$/db.lib \
		$(SLB)$/ldap.lib \
		$(SLB)$/util.lib \
		$(SLB)$/dlg.lib \
		$(SLB)$/editbrw.lib \
		$(SLB)$/common.lib \
		$(SLB)$/sbabrw.lib \
		$(SLB)$/qrysh.lib \
		$(SLB)$/joinsh.lib \
		$(SLB)$/sbatab.lib \
		$(SLB)$/sbaobj.lib \
		$(SLB)$/sbaapi.lib \
		$(SLB)$/sbauno.lib

SHL1TARGET= sba$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= sba
SHL1LIBS=	$(SLB)$/mhsba.lib

.IF "$(GUI)" != "UNX"
SHL1OBJS=	\
		$(SLO)$/sbaobj.obj	\
		$(SLO)$/dbcoll.obj
.ELSE
SHL1OBJS=	\
		$(SLO)$/dbcoll.obj
.ENDIF

SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

SHL1STDLIBS= \
	$(SVTOOLLIB)\
	$(SVLLIB)	\
	$(VOSLIB)\
	$(SFXLIB)\
	$(SFXDEBUGLIB) \
	$(SVMEMLIB) \
	$(SOTLIB) \
	$(SO2LIB)\
	$(BASICLIB)\
	$(SDBLIB)\
	$(SVXLIB)\
	$(SVLIB)\
	$(TOOLSLIB)\
	$(INETLIBSH)\
	$(TKLIB) \
	$(ONELIB) \
	$(SALLIB) \
	$(GOODIESLIB) \
	$(UUILIB) \
	$(CPPULIB) \
	$(CPPUHELPERLIB) \
	$(UNOTOOLSLIB) \
	$(BASCTLLIB)

.IF "$(TF_UCB)" == ""
SHL1STDLIBS+=\
		$(CHAOSLIB)
.ENDIF

.IF "$(GUI)" == "MAC"
SHL1STDLIBS+= \
			$(SOLARBINDIR)$/SDB$(UPD)$(DLLPOSTFIX).DLL \
			$(SOLARLIBDIR)$/plugctor.lib
.ENDIF

# -------------------------------------------------------------------------

LIB3TARGET= $(SLB)$/$(TARGET).lib
LIB3FILES=	$(SLB)$/app.lib 		\
			$(SLB)$/dialog.lib		\
			$(SLB)$/sbachaos.lib		

.IF "$(GUI)"!="UNX"
LIB3FILES	+=\
	$(LIBPRE) $(SOLARLIBDIR)$/ysim.lib	\
	$(LIBPRE) $(SOLARLIBDIR)$/ysch.lib	\
	$(LIBPRE) $(SOLARLIBDIR)$/ysm.lib
.ENDIF

SHL2TARGET= $(TARGET)$(UPD)$(DLLPOSTFIX)
SHL2IMPLIB= _$(TARGET)
SHL2LIBS=\
		$(SLB)$/$(TARGET).lib	\
		$(SLB)$/sbawrap.lib 	\
		$(SLB)$/util.lib

SHL2STDLIBS=$(TOOLSLIB) \
			$(SVTOOLLIB) \
			$(SVLLIB)	\
			$(SVLIB) \
			$(SO2LIB) \
			$(SVMEMLIB) \
			$(SOTLIB) \
			$(VOSLIB) \
			$(CHANELLIB) \
			$(SFX2LIB) \
			$(GOODIESLIB) \
			$(BASICLIB) \
			$(INETLIBSH) \
			$(SVXLIB) \
			$(TKLIB) \
			$(ONELIB) \
			$(SALLIB) \
			$(CPPULIB) \
			$(CPPUHELPERLIB) \
			$(UNOTOOLSLIB) \
			$(BASCTLLIB)

#			$(SBALIB) \

.IF "$(TF_UCB)" == ""
SHL2STDLIBS+=\
		$(CHAOSLIB)
.ENDIF

.IF "$(GUI)" == "MAC"
SHL2STDLIBS+= \
			$(SOLARBINDIR)$/SDB$(UPD)$(DLLPOSTFIX).DLL \
			$(SOLARLIBDIR)$/plugctor.lib \
			$(SOLARLIBDIR)$/ysch.lib \
			$(SOLARLIBDIR)$/ysim.lib \
			$(SOLARLIBDIR)$/ysm.lib
.ENDIF			# "$(GUI)" == "MAC"

.IF "$(GUI)" == "UNX"
SHL2STDLIBS+= \
		$(SCHLIB) \
		$(SIMLIB) \
		$(SMLIB)
.ENDIF			# "$(GUI)" == "UNX"

.IF "$(GUI)"=="WNT"
SHL2STDLIBS+=\
		$(LIBPRE) advapi32.lib
.ENDIF

#.IF "$(GUI)" != "UNX"
#SHL2OBJS=	\
#			$(SLO)$/app.obj
#.ENDIF

#SHL2RES=	 $(RES)$/$(TARGET).res
SHL2DEF=	$(MISC)$/$(SHL2TARGET).def
SHL2BASE=	0x1de00000

DEF2NAME=	$(SHL2TARGET)
DEF2DEPN=	$(MISC)$/$(SHL2TARGET).flt
DEFLIB2NAME =$(TARGET)
DEF2DES 	=offmgr app-interface

# -------------------------------------------------------------------------

.IF "$(GUI)"=="WNT"
LIB4TARGET= $(LB)$/a$(TARGET).lib
LIB4FILES=	$(LB)$/_$(TARGET).lib
.ENDIF


.IF "$(BUILD_SOSL)"==""
.IF "$(depend)" == ""
ALL:\
	$(INCCOM)$/sba.hrc		\
	$(LIB3TARGET)			\
	$(INCCOM)$/class.lst	\
	$(SRS)$/hidother.hid	\
	ALLTAR

.ENDIF			# "$(depend)" == ""
.ENDIF                  # "$(BUILD_SOSL)" == "" 

.INCLUDE :	target.mk

#	$(LB)$/_$(TARGET).lib
	
$(MISCX)$/$(SHL2TARGET).flt: makefile.mk
	@echo ------------------------------
	@echo Making: $@
	@echo WEP>$@
	@echo PlugInApplication>>$@
	@echo __dt__17OfficeApplication>>$@
	@echo LibMain>>$@
	@echo _Impl>>$@
	@echo _Imp>>$@
	@echo solver>>$@
	@echo bad_alloc>>$@
	@echo exception12>>$@
.IF "$(GUI)"=="WNT"
	@echo __CT>>$@
.ENDIF

# ------------------------------------------------------------------
# MAC
# ------------------------------------------------------------------

.IF "$(GUI)"=="MAC"

# --- SBA-Def-File ---

$(MISC)$/$(SHL1TARGET).def: 		$(HXX1FILES)
		delete -i $@
		$(LINK)  $(LINKFLAGS) $(LINKFLAGSSHL) $(SHL1OBJS) $(SHL1LIBS) -f $@.exp  dev:null
		duplicate -y $@.exp $@
		delete -i $@.exp
#$(MISC)$/$(SHL1TARGET).def:			$(HXX1FILES)
#	@echo ------------------------------
#	@echo Making: $@
#	@echo InitSbaDll					>  $@
#	@echo DeInitSbaDll					>> $@
#	@echo CreateObjSbaQueryDocShDll 	>> $@
#	@echo exService_writeRegEntry		>> $@
#	@echo exService_getFactory			>> $@

.ENDIF

# ------------------------------------------------------------------
# Windows NT
# ------------------------------------------------------------------

.IF "$(GUI)" == "WNT"

# --- SBA-Def-File ---

$(MISC)$/$(SHL1TARGET).def: 		$(HXX1FILES)
	@echo ------------------------------
	@echo Making: $@
	@echo ------------------------------
	@echo Making: $@
	@echo LIBRARY	  $(SHL1TARGET) 								 >$@
	@echo DESCRIPTION 'StarView SBA DLL'                             >>$@
	@echo DATA		  READ WRITE SHARED 						 >>$@
	@echo HEAPSIZE	  0 											>>$@
	@echo EXPORTS													>>$@
		@echo InitSbaDll @21					>>$@
		@echo DeInitSbaDll @22					>>$@
		@echo CreateObjSbaQueryDocShDll @23 	>>$@
		@echo component_writeInfo @28 >>$@
		@echo component_getFactory @29 >>$@
		@echo component_getImplementationEnvironment @30 >>$@
		@echo GetVersionInfo		>>$@

.ENDIF

$(INCCOM)$/class.lst:
.IF "$(BUILD_SOSL)"==""
.IF "$(GUI)$(CPU)$(UPDATER)"=="WNTIYES"
.IF "$(SOLARVERSION)"==""
	+incparse $(UPD)
.ELSE
	+incparse $(WORK_STAMP)
.ENDIF
	+-$(COPY) class.lst $@
.ELSE
	@+echo nix
.ENDIF
.ENDIF			# "$(BUILD_SOSL)"==""

$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)$(CPU)"=="WNTI"
.IF "$(BUILD_SOSL)"==""
	+-mhids hidother.src ..\$(INPATH)$/srs ofa hidother $(INCLUDE)
.ENDIF
.ELSE
	@+echo nix
.ENDIF

$(INCCOM)$/sba.hrc: $(INC)$/sbasltid.hrc
	@+-$(COPY) $(INC)$/sbasltid.hrc $(INCCOM)$/sba.hrc


