/*************************************************************************
 *
 *  $RCSfile: types.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _OSL_TYPES_H_
#define _OSL_TYPES_H_

#include <sal/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/********************************************************************************/
/* Data types
*/

/* alte Typen */
#if ! defined(OSL_NO_BOOL) && (defined(__cplusplus) && (_MSC_VER >= 1100))

	typedef bool Boolean;
#	define False false
#	define True  true

#else
	typedef int Boolean;
#	define False 0
#	define True  1

#endif

#if defined( _WIN16 )
#	define OSL_INT		long	
#else
#	define OSL_INT		int	
#endif

#ifndef OSL_NO_HYPER
#	if (_MSC_VER >= 1000)
#		define OSL_HYPER 	__int64	
#		define OSL_UHYPER 	unsigned __int64	
#	elif defined(__SUNPRO_CC) || defined(__SUNPRO_C) || defined (__GNUC__) || defined (__MWERKS__) || defined(__hpux)
#		define OSL_HYPER	long long
#		define OSL_UHYPER	unsigned long long
#	endif
#endif

typedef char 				Char;
typedef signed OSL_INT      Int;		
typedef unsigned OSL_INT	uInt;		
typedef signed short   	    Short;		
typedef unsigned short   	uShort;
typedef signed long     	Long;		
typedef unsigned long   	uLong;

typedef unsigned char		Byte;
typedef unsigned short  	Word;
typedef unsigned long   	Dword;
typedef float				Float;
typedef double				Double;

#ifdef	_WIN16
//typedef long				Enum;
typedef int    		        Enum;
#else
typedef int					Enum;
#endif

typedef void				Void;
typedef void*				Ptr;

typedef Char*				Str;
typedef const Char*		    cStr;
typedef unsigned OSL_INT	Size_t;
typedef	signed OSL_INT	    sSize_t;
typedef signed OSL_INT  	Ptrdiff_t;

typedef union
{
	struct {
		uLong	loPart;
		Long	hiPart;
	} p;
#ifdef OSL_HYPER
	OSL_HYPER v;
#endif
} Hyper_t;

typedef union
{
	struct {
		uLong	loPart;
		uLong	hiPart;
	} p;
#ifdef OSL_UHYPER
	OSL_UHYPER v;
#endif
} uHyper_t;

#ifdef OSL_HYPER
	typedef OSL_HYPER	    Hyper;
#else
    typedef Hyper_t         Hyper;
#endif

#ifdef OSL_UHYPER
	typedef OSL_UHYPER	   	uHyper;
#else
    typedef uHyper_t		uHyper;
#endif

#ifdef _WIN32
#	if defined(_M_IX86)
#		define _LITTLE_ENDIAN
#	elif defined(_M_MRX000)
#		define _LITTLE_ENDIAN
#	elif defined(_M_ALPHA)
#		define _LITTLE_ENDIAN
#	elif defined(_M_PPC)
#		define _LITTLE_ENDIAN
#	endif
#endif

#ifdef LINUX
#	include <endian.h>
#	if __BYTE_ORDER == __LITTLE_ENDIAN
#		define _LITTLE_ENDIAN
#	elif __BYTE_ORDER == __BIG_ENDIAN
#		define _BIG_ENDIAN
#	elif __BYTE_ORDER == __PDP_ENDIAN
#		define _PDP_ENDIAN
#	endif
#endif

#ifdef NETBSD
#   include <machine/endian.h>
#   if BYTE_ORDER == LITTLE_ENDIAN
#   	define _LITTLE_ENDIAN
#   elif BYTE_ORDER == BIG_ENDIAN
#   	define _BIG_ENDIAN
#   elif BYTE_ORDER == PDP_ENDIAN
#   	define _PDP_ENDIAN
#   endif
#endif

#ifdef SCO
#   include <sys/types.h>
#   include <sys/byteorder.h>
#   if BYTE_ORDER == LITTLE_ENDIAN
#   	define _LITTLE_ENDIAN
#   elif BYTE_ORDER == BIG_ENDIAN
#   	define _BIG_ENDIAN
#   elif BYTE_ORDER == PDP_ENDIAN
#   	define _PDP_ENDIAN
#   endif
#endif

#ifdef AIX
#	include <sys/machine.h>
#   if BYTE_ORDER == LITTLE_ENDIAN
#   	define _LITTLE_ENDIAN
#   elif BYTE_ORDER == BIG_ENDIAN
#   	define _BIG_ENDIAN
#   elif BYTE_ORDER == PDP_ENDIAN
#   	define _PDP_ENDIAN
#   endif
#endif

#ifdef HPUX
#	include <machine/param.h>
#endif

#ifdef IRIX
#   include <sys/endian.h>
#   if BYTE_ORDER == LITTLE_ENDIAN
#   	define _LITTLE_ENDIAN
#   elif BYTE_ORDER == BIG_ENDIAN
#   	define _BIG_ENDIAN
#   elif BYTE_ORDER == PDP_ENDIAN
#   	define _PDP_ENDIAN
#   endif
#endif

#ifdef S390
#	define  _BIG_ENDIAN
#endif

#ifdef _WIN16
#	define	_LITTLE_ENDIAN
#	define	OSL_PTR	_huge
#endif

#ifdef OS2
#	define	_LITTLE_ENDIAN
#endif

#ifdef SOLARIS
#	include <sys/isa_defs.h>
#endif

#ifdef MACOSX
#	include <machine/endian.h>
#	if BYTE_ORDER == LITTLE_ENDIAN
#		define _LITTLE_ENDIAN
#	elif BYTE_ORDER == BIG_ENDIAN
#		define _BIG_ENDIAN
#	elif BYTE_ORDER == PDP_ENDIAN
#		define _PDP_ENDIAN
#	endif
#endif

#ifdef MACOS
#	include <premac.h>
#	include <TextUtils.h>
#	include <Endian.h>
#	include <postmac.h>
#	if TARGET_RT_LITTLE_ENDIAN
#		define _LITTLE_ENDIAN
#	elif TARGET_RT_BIG_ENDIAN 
#		define _BIG_ENDIAN
#	endif
#endif

#if !defined(_WIN32)  && !defined(_WIN16) && !defined(OS2)  && \
    !defined(LINUX)   && !defined(NETBSD) && !defined(SCO)  && \
	!defined(AIX)     && !defined(HPUX)   && !defined(S390) && \
	!defined(SOLARIS) && !defined(IRIX)   && !defined(MACOS) && \
	!defined(MACOSX)
#	error "Target plattform not specified !"
#endif

#if defined _LITTLE_ENDIAN
#	define OSL_LITENDIAN
#elif defined _BIG_ENDIAN
#	define OSL_BIGENDIAN
#else
#	error undetermined endianess
#endif

#ifndef OSL_PTR
#	define OSL_PTR
#endif

/* Ende alte Typen */


#ifdef SAL_W32
#	pragma pack(push, 8)
#elif defined(SAL_OS2)
#	pragma pack(1)
#endif

/* Time since Jan-01-1970 */

typedef struct {
    sal_uInt32 Seconds;
    sal_uInt32 Nanosec;
} TimeValue;

#ifdef SAL_W32
#	pragma pack(pop)
#elif defined(SAL_OS2)
#	pragma pack()
#endif

#ifdef __cplusplus
}
#endif


#endif /*_OSL_TYPES_H_ */

/*************************************************************************
*
*    $Log: types.h,v $
*    Revision 1.1.1.1  2000/09/18 15:17:13  hr
*    initial import
*
*    Revision 1.8  2000/09/18 14:28:49  willem.vandorp
*    OpenOffice header added.
*
*    Revision 1.7  2000/06/11 09:52:33  patrick.luby
*    Updates to support SRC591 build on Mac OS X.
*
*    Revision 1.6  2000/05/23 09:54:41  mh
*    add: MACOSX from Patrick Luby
*
*    Revision 1.5  2000/05/17 14:50:15  mfe
*    comments upgraded
*
*    Revision 1.4  1999/11/25 17:43:53  br
*    typedef enum for win16
*
*    Revision 1.3  1999/11/04 13:41:02  mfe
*    added defined(__SUNPRO_C) for declaration of uHyper
*
*    Revision 1.2  1999/10/27 15:02:09  mfe
*    Change of Copyright, removed compiler warnings, code clean up, ...
*
*    Revision 1.1  1999/08/05 10:18:21  jsc
*    verschoben aus osl
*
*    Revision 1.27  1999/08/05 11:14:47  jsc
*    verschoben in root inc-Verzeichnis
*
*    Revision 1.26  1999/07/06 10:51:59  hro
*    Added comment to explain the meaning of TimeValue
*
*    Revision 1.25  1999/07/01 10:14:59  mhu
*    Fixed #define OSL_BIGENDIAN to mean _BIG_ENDIAN not _LITTLE_ENDIAN.
*
*    Revision 1.24  1999/01/20 18:53:41  jsc
*    #61011# Typumstellung
*
*    Revision 1.23  1998/07/20 17:17:33  rh
*    #53072, #53073 Bugfixes for 5.0
*
*    Revision 1.22  1998/06/15 13:40:08  hro
*    Beim MAC ist size_t unsigned long
*
*    Revision 1.21  1998/04/28 16:45:15  hro
*    Merging local W16 version
*
*    Revision 1.20  1998/03/22 19:00:34  rh
*    Changes for WIn16
*
*    Revision 1.19  1998/03/22 13:36:13  rh
*    Chnages for Win16
*
*    Revision 1.18  1998/03/05 14:12:14  hro
*    Merge
*
*    Revision 1.17  1998/03/05 14:10:27  hro
*    Hyper musss auch bei 16-Bit Env. definiert sein
*
*    Revision 1.16  1998/02/25 12:20:51  hro
*    Added target plattforms _WIN16 and MAC
*
*    Revision 1.15  1998/02/17 17:00:40  ts
*    Hyper = __int64 auf msvc41
*
*    Revision 1.14  1998/02/16 19:34:53  rh
*    Cleanup of ports, integration of Size_t, features for process
*
*    Revision 1.13  1997/09/09 12:03:30  fm
*    *** empty log message ***
*
*    Revision 1.12  1997/08/22 14:47:39  rh
*    TimeValue inserted
*
*    Revision 1.11  1997/08/12 14:23:25  rh
*    *** empty log message ***
*
*    Revision 1.10  1997/08/11 08:56:15  ts
*    *** empty log message ***
*
*    Revision 1.9  1997/08/07 11:27:47  ts
*    *** empty log message ***
*
*    Revision 1.8  1997/08/06 13:47:15  fm
*    *** empty log message ***
*
*    Revision 1.7  1997/07/31 18:28:55  rh
*    Standard types adapted
*
*    Revision 1.6  1997/07/29 16:07:37  rh
*    *** empty log message ***
*
*    Revision 1.5  1997/07/17 11:02:30  rh
*    Header adapted and profile added
*
*    Revision 1.4  1997/06/26 10:36:00  bho
*    changed types.h
*
*    Revision 1.3  1997/06/25 16:12:23  rh
*    Boolean fuer MSC 4.0 angepasst
*
*    Revision 1.2  1997/06/25 13:16:32  rh
*    Formatting
*
*    Revision 1.1  1997/06/19 13:10:15  bho
*    first version of OSL.
*
*************************************************************************/
