/*************************************************************************
 *
 *  $RCSfile: util.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _OSL_UTIL_H_
#define _OSL_UTIL_H_

#include "sal/types.h"

#ifdef __cplusplus
extern "C" {
#endif

/***
 *
 * @param pEthernetAddr 6 bytes of memory
 *
 * @return sal_True  if the ethernetaddress could be retrieved. <br>
 *         sal_False if no address could be found. This may be either because
 *         there is no ethernet card or there is no appropriate algorithm
 *         implemented on the platform. In this case, pEthernetAddr is
 *         unchanged.
 *
 ***/
sal_Bool SAL_CALL osl_getEthernetAddress( sal_uInt8 *pEthernetAddr );	

/**
	@deprecated
	Set the solar build number. Affect the profile function from osl and
	the ORealDynamicLoader class from vos.
	Default is the SUPD from the build process if it was build with the
	solar environment, otherwise 0.
 */
void SAL_CALL osl_setSUPD( sal_Int32 n );

/**
	@deprecated
	Return the solar build number
 */
sal_Int32 SAL_CALL osl_getSUPD();

#ifdef __cplusplus
}
#endif

#endif

/*************************************************************************
*
*    $Log: util.h,v $
*    Revision 1.1.1.1  2000/09/18 15:17:13  hr
*    initial import
*
*    Revision 1.7  2000/09/18 14:28:49  willem.vandorp
*    OpenOffice header added.
*
*    Revision 1.6  2000/05/26 10:12:13  hro
*    SAL_CALL for osl_getSUPD, osl_getSUPD
*
*    Revision 1.5  2000/05/17 14:50:15  mfe
*    comments upgraded
*
*    Revision 1.4  2000/03/16 16:43:53  obr
*    Unicode API changes
*
*    Revision 1.3  2000/03/16 14:16:34  mm
*    #74230# setSUPD
*
*    Revision 1.2  1999/12/06 14:59:18  jbu
*    osl_getEthernetAddress added
*
*    Revision 1.1  1999/10/25 09:48:05  mfe
*    added getEtherAddr
*
*************************************************************************/
