/*************************************************************************
 *
 *  $RCSfile: daemclie.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OSL_DEAMCLIE_H_
#define _OSL_DEAMCLIE_H_

#include <osl/daemon.h>

sal_Bool SAL_CALL osl_default_accessDaemonManager();
oslDaemonManagerError SAL_CALL osl_default_queryDaemonCount(sal_uInt32* pCount);
oslDaemonManagerError SAL_CALL osl_default_queryDaemonIdentifier(sal_uInt32 index, rtl_uString** pstrIdentifier);
oslDaemonManagerError SAL_CALL osl_default_isDaemonInstalled(rtl_uString* strIdentifier, sal_Bool* pRet);
oslDaemonManagerError SAL_CALL osl_default_queryDaemonStatus(rtl_uString* strIdentifier, oslDaemonStatus* pStatus);
oslDaemonManagerError SAL_CALL osl_default_queryDaemonInfo(rtl_uString* strIdentifier, oslDaemonInfo* pInfo);
oslDaemonManagerError SAL_CALL osl_default_startDaemon(rtl_uString* strIdentifier);
oslDaemonManagerError SAL_CALL osl_default_stopDaemon(rtl_uString* strIdentifier);
oslDaemonManagerError SAL_CALL osl_default_pauseDaemon(rtl_uString* strIdentifier);
oslDaemonManagerError SAL_CALL osl_default_continueDaemon(rtl_uString* strIdentifier);
oslDaemonManagerError SAL_CALL osl_default_installDaemon(const oslDaemonInfo* pInfo);
oslDaemonManagerError SAL_CALL osl_default_uninstallDaemon(rtl_uString* strIdentifier);
oslDaemonManagerError SAL_CALL osl_default_createDaemon(rtl_uString* strIdentifier,
								   		  	   oslDaemonControl pControl, 
								  		  	   void* pControlData,
											   oslDaemonPropertyAccess* pPropertyAccess,
								  		  	   void* pAccessData,
								  		  	   oslDaemonHandle* pHandle);
oslDaemonManagerError SAL_CALL osl_default_executeDaemon(oslDaemonHandle handle);
oslDaemonManagerError SAL_CALL osl_default_executeDaemons(oslDaemonHandle* pHandle, sal_uInt32 numOfDaemons);
oslDaemonManagerError SAL_CALL osl_default_setDaemonStatus(oslDaemonHandle handle, oslDaemonStatus Status);
oslDaemonManagerError SAL_CALL osl_default_endDaemon(oslDaemonHandle handle);
oslDaemonManagerError SAL_CALL osl_default_getDaemonPropertyCount(rtl_uString* strIdentifier, sal_uInt32* pCount);
oslDaemonManagerError SAL_CALL osl_default_getDaemonProperties(rtl_uString* strIdentifier, 
													  oslDaemonProperty** ppProps, 
													  sal_uInt32* pCount);
oslDaemonManagerError SAL_CALL osl_default_setDaemonProperties(rtl_uString* strIdentifier, 
													  oslDaemonProperty* pProps, 
													  sal_uInt32 count, 
													  sal_uInt32* pErrorCode, 
													  rtl_uString** strErrorText);
oslDaemonManagerError SAL_CALL osl_default_getDaemonProfileSections(rtl_uString* strIdentifier, 
														   sal_Unicode* buffer, 
														   sal_uInt32 bufferSize,
														   sal_uInt32* pRequiredSize);
oslDaemonManagerError SAL_CALL osl_default_getDaemonProfileEntries(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  sal_Unicode* buffer, 
														  sal_uInt32 bufferSize,
														  sal_uInt32* pRequiredSize);
oslDaemonManagerError SAL_CALL osl_default_readDaemonProfileString(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  rtl_uString** pstrValue, 
														  rtl_uString* strDefaultValue);
oslDaemonManagerError SAL_CALL osl_default_readDaemonProfileBool(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  sal_Bool* pValue, 
														  sal_Bool defaultValue);
oslDaemonManagerError SAL_CALL osl_default_readDaemonProfileIdent(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  sal_uInt32* pValue, 
														  sal_uInt32 firstId, 
														  rtl_uString* strStrings[], 
														  sal_uInt32 defaultValue);
oslDaemonManagerError SAL_CALL osl_default_writeDaemonProfileString(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  rtl_uString* strValue);
oslDaemonManagerError SAL_CALL osl_default_writeDaemonProfileBool(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  sal_Bool value);
oslDaemonManagerError SAL_CALL osl_default_writeDaemonProfileIdent(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry, 
														  sal_uInt32 value, 
														  sal_uInt32 firstId, 
														  rtl_uString* strStrings[]);
oslDaemonManagerError SAL_CALL osl_default_removeDaemonProfileEntry(rtl_uString* strIdentifier, 
														  rtl_uString* strSection, 
														  rtl_uString* strEntry );

oslDaemonManagerError SAL_CALL osl_default_queryDaemonChanges(TimeValue* pSince, sal_Bool* pBChanged);

#endif /* _OSL_DEAMCLIE_H_ */

