/*************************************************************************
 *
 *  $RCSfile: daemman.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OSL_DEAMMAN_H_
#define _OSL_DEAMMAN_H_


#ifndef _OSL_THREAD_H_
	#include <osl/thread.h>
#endif
#ifndef _OSL_DAEMPROT_H_
	#include "../all/daemprot.h"
#endif

/** error codes while startup
*/
typedef enum 
{
	osl_oslDaemonManagerStartupError_NoError,
	osl_oslDaemonManagerStartupError_AllreadyStarted,
	osl_oslDaemonManagerStartupError_CouldNotReadProfile,
	osl_oslDaemonManagerStartupError_Unknown = -1

} oslDaemonManagerStartupError;

typedef struct 
{
	sal_Bool   (SAL_CALL * hasDaemon)    (rtl_uString* strIdentifier);
	sal_uInt32 (SAL_CALL * getDaemons)   (sal_Unicode* pszBuffer, sal_uInt32 nMaxLen);
	sal_Bool   (SAL_CALL * addDaemon)    (rtl_uString* strIdentifier, rtl_uString* strDisplayName);
	void       (SAL_CALL * removeDaemon) (rtl_uString* strIdentifier);

	sal_Bool (SAL_CALL * readDaemonEntry)(rtl_uString* strIdentifier,	
							   	rtl_uString* strSection, 
								rtl_uString* strEntry, 
								sal_Unicode* pszValue, sal_uInt32 nMaxLen,
								const sal_Unicode* pszDefault);

	sal_Bool (SAL_CALL * writeDaemonEntry)(rtl_uString* strIdentifier,	
							   	 rtl_uString* strSection, 
								 rtl_uString* strEntry, 
								 const sal_Unicode* pszValue);

	sal_Bool (SAL_CALL * removeDaemonEntry)(rtl_uString* strIdentifier,	
								  rtl_uString* strSection, 
							      rtl_uString* strEntry);

	sal_uInt32 (SAL_CALL * getSections)(rtl_uString* strIdentifier,
							  sal_Unicode* pszBuffer, sal_uInt32 nMaxLen);

	sal_uInt32 (SAL_CALL * getEntries)(rtl_uString* strIdentifier,
						     rtl_uString* strSection,	
    					     sal_Unicode* pszBuffer, sal_uInt32 nMaxLen);

} DaemonRegistryApi;

/** initialize this process as daemon manager 
*/
oslDaemonManagerStartupError SAL_CALL osl_initDaemonManager(DaemonRegistryApi* pRegistry);

/** deinitialize this process as daemon manager 
*/
void SAL_CALL osl_deinitDaemonManager(void);

/**	send shutdown request to all running daemons
*/
sal_Bool SAL_CALL osl_shutdownDaemonManager(void);

/** handle a accepted connection
	creates a new thread which handle this connection and close it after work
*/
void SAL_CALL osl_handleConnection(oslDaemonConnection conn);

void SAL_CALL osl_startupAutomaticDaemons(void);

#endif /* _OSL_DEAMMAN_H_ */

