/*************************************************************************
 *
 *  $RCSfile: nspr.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>
#include <string.h>
#include <osl/process.h>

#ifdef WNT
extern oslFileHandle importFileHandle(sal_Int32 hFile, const char * name);
extern const char *  getPREnv(const char * envVar);
#endif

oslProcessError SAL_CALL osl_getIOResource(oslIOResource *pResource, const char * name)
{
    const char * envVar;
    const char * ptr;
    int len = strlen(name);
    int nColons;
    sal_Int32 osfd;
    sal_Int32 fileType;

#ifdef WNT
    envVar = getPREnv("NSPR_INHERIT_FDS");
    if (NULL == envVar || '\0' == envVar[0]) 
        return osl_Process_E_Unknown;
#endif

    ptr = envVar;
    while (1) {
        if ((ptr[len] == ':') && (strncmp(ptr, name, len) == 0)) {
            ptr += len + 1;
            sscanf(ptr, "%d:0x%lx", &fileType, &osfd);
            switch (fileType) {
#ifdef WNT
                case 1:
					pResource->Type = osl_Process_TypeFile;
					pResource->Descriptor.File = importFileHandle(osfd, NULL);
                    break;
#endif
#if 0
                case 2:
					pResource->Type = osl_Process_TypeSocket;
                    break;
                case 3:
					pResource->Type = osl_Process_TypeSocket;
                    break;
#endif
#ifdef WNT
                case 5:
					pResource->Type = osl_Process_TypePipe;
					pResource->Descriptor.File = importFileHandle(osfd, NULL);
                    break;
#endif
                default:
					return osl_Process_E_Unknown;
            }

            return osl_Process_E_None;
        }
        /* Skip three colons */
        nColons = 0;
        while (*ptr) {
            if (*ptr == ':') {
                if (++nColons == 3) {
                    break;
                }
            }
            ptr++;
        }
        if (*ptr == '\0')
			return osl_Process_E_Unknown;

        ptr++;
    }

}



