/*************************************************************************
 *
 *  $RCSfile: types.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _RTL_TYPES_H_
#include <sal/types.h>
#endif

static sal_Int16 endian = 1;

void SAL_CALL sal_setInt64(sal_Int64* newInt, sal_uInt32 lowInt, sal_Int32 highInt)
{
#ifdef SAL_INT64_IS_STRUCT
	if (*((unsigned char*)&endian) == 1)
	{
		newInt->Part1 = lowInt;
		newInt->Part2 = (sal_uInt32)highInt;
	} else
	{
		newInt->Part1 = (sal_uInt32)highInt;
		newInt->Part2 = lowInt;
	}
#else
	*newInt = (sal_Int64) highInt;
	*newInt <<= 32;		
	*newInt += lowInt;
#endif
}	

void SAL_CALL sal_getInt64(sal_Int64 newInt, sal_uInt32* lowInt, sal_Int32* highInt)
{
#ifdef SAL_INT64_IS_STRUCT
	if (*((unsigned char*)&endian) == 1)
	{
		*lowInt = newInt.Part1;
		*highInt = (sal_Int32)newInt.Part2;
	} else
	{
		*highInt = (sal_Int32)newInt.Part1;
		*lowInt = newInt.Part2;
	}
#else
	*highInt = (sal_Int32)(newInt >> 32);
	*lowInt = (sal_uInt32)(newInt & 0x00000000ffffffff);
#endif		
}	

void SAL_CALL sal_setUInt64(sal_uInt64* newInt, sal_uInt32 lowInt, sal_uInt32 highInt)
{
#ifdef SAL_INT64_IS_STRUCT
	if (*((unsigned char*)&endian) == 1)
	{
		newInt->Part1 = lowInt;
		newInt->Part2 = highInt;
	} else
	{
		newInt->Part1 = highInt;
		newInt->Part2 = lowInt;
	}
#else
	*newInt = (sal_Int64) highInt;
	*newInt <<= 32;		
	*newInt += lowInt;
#endif
}	

void SAL_CALL sal_getUInt64(sal_uInt64 newInt, sal_uInt32* lowInt, sal_uInt32* highInt)
{
#ifdef SAL_INT64_IS_STRUCT
	if (*((unsigned char*)&endian) == 1)
	{
		*lowInt = newInt.Part1;
		*highInt = newInt.Part2;
	} else
	{
		*highInt = newInt.Part1;
		*lowInt = newInt.Part2;
	}
#else
	*highInt = (sal_Int32)(newInt >> 32);
	*lowInt = (sal_Int32)(newInt & 0x00000000ffffffff);
#endif		
}	

