/*************************************************************************
 *
 *  $RCSfile: file.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include "system.h"
#include <osl/file.h>


oslFileError SAL_CALL osl_openDirectory( rtl_uString *strDirectoryPath, oslDirectory *pDirectory) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getNextDirectoryItem( oslDirectory Directory, oslDirectoryItem *pItem, sal_uInt32	 uHint ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_closeDirectory( oslDirectory Directory ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getDirectoryItem( rtl_uString *strFilePath, oslDirectoryItem *pItem ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_acquireDirectoryItem( oslDirectoryItem Item ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_releaseDirectoryItem( oslDirectoryItem Item ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getFileStatus( oslDirectoryItem Item, oslFileStatus *pStatus, sal_uInt32 uFieldMask ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_unmountVolumeDevice( oslVolumeDeviceHandle Handle ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_automountVolumeDevice( oslVolumeDeviceHandle Handle ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_releaseVolumeDeviceHandle( oslVolumeDeviceHandle Handle ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getVolumeDeviceMountPath( oslVolumeDeviceHandle Handle, rtl_uString **pstrPath ) 
{

    sal_Char Buffer[PATH_MAX] = "";

#ifdef DEBUG
        fprintf(stderr,"In  osl_getVolumeDeviceMountPath\n");
#endif  

    if ( pstrPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out osl_getVolumeDeviceMountPath, invalid argument \n");
#endif  
        return osl_File_E_INVAL;
    }

    strcpy( Buffer, "test");
    
    rtl_uString_newFromAscii(pstrPath,Buffer);
    
    return osl_File_E_None;
}

oslFileError SAL_CALL osl_getVolumeInformation( rtl_uString *strDirectory, oslVolumeInfo *pInfo, sal_uInt32 uFieldMask ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_openFile( rtl_uString *strPath, oslFileHandle *pHandle, sal_uInt32 uFlags ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_setFilePos( oslFileHandle Handle, sal_uInt32 uHow, sal_uInt64 uPos ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getFilePos( oslFileHandle Handle, sal_uInt64 *pPos ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_setFileSize( oslFileHandle Handle, sal_uInt64 uSize ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_readFile( oslFileHandle Handle, void *pBuffer, sal_uInt64 uBytesRequested, sal_uInt64 *pBytesRead ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_writeFile( oslFileHandle Handle, const void *pBuffer, sal_uInt64 uBytesToWrite, sal_uInt64 *pBytesWritten ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_closeFile( oslFileHandle Handle ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_createDirectoryItemFromHandle( oslFileHandle Handle, oslDirectoryItem *pItem ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_createDirectory( rtl_uString* strPath ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_removeDirectory( rtl_uString* strPath ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_removeFile( rtl_uString* strPath ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_copyFile( rtl_uString* strPath, rtl_uString *strDestPath ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_moveFile( rtl_uString* strPath, rtl_uString *strDestPath ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_getCanonicalName( rtl_uString *strRequested, rtl_uString **strValid) 
{ 
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_getCanonicalName\n");
#endif

    if ( strValid == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_getCanonicalName, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    
    rtl_uString_newFromAscii(strValid,strRequested);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_getAbsolutePath( rtl_uString* strDirBase, rtl_uString *strRelative, rtl_uString **strAbsolute )
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_getAbsolutePath\n");
#endif

    if ( strAbsolute == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_getAbsolutePath, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strAbsolute,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_normalizePath( rtl_uString *strSysPath, rtl_uString **strPath ) 
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_normalizePath\n");
#endif

    if ( strPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_normalizePath, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strPath,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_getNormalizedPathFromFileURL( rtl_uString *urlPath, rtl_uString **strPath ) 
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_getNormalizedPathFromFileURL\n");
#endif

    if ( strPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_getNormalizedPathFromFileURL, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strPath,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_getFileURLFromNormalizedPath( rtl_uString *normPath, rtl_uString **strPath) 
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_getFileURLFromNormalizedPath\n");
#endif

    if ( strPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_getFileURLFromNormalizedPath, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strPath,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_getSystemPathFromNormalizedPath( rtl_uString *normPath, rtl_uString **strPath)
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_getSystemPathFromNormalizedPath\n");
#endif

    if ( strPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_getSystemPathFromNormalizedPath, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strPath,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_searchNormalizedPath( rtl_uString *filePath, rtl_uString *searchPath, rtl_uString **strPath )
{
    sal_Char  Buffer[PATH_MAX] = "";
    
#ifdef DEBUG
        fprintf(stderr,"In  osl_searchNormalizedPath\n");
#endif

    if ( strPath == NULL )
    {
#ifdef DEBUG
        fprintf(stderr,"Out  osl_searchNormalizedPath, invalid argument\n");
#endif
        return osl_File_E_INVAL;
    }
    
    strcpy( Buffer, "test");
    rtl_uString_newFromAscii(strPath,Buffer);

    return osl_File_E_None;
}

oslFileError SAL_CALL osl_setFileAttributes( rtl_uString *filePath, sal_uInt64 uAttributes ) { return osl_File_E_ACCES; }

oslFileError SAL_CALL osl_setFileTime( rtl_uString *filePath, TimeValue *aCreationTime, TimeValue *aLastAccessTime, TimeValue *aLastWriteTime) { return osl_File_E_ACCES; }


/*************************************************************************
*
*    $Log: file.c,v $
*    Revision 1.1.1.1  2000/09/18 15:17:18  hr
*    initial import
*
*    Revision 1.5  2000/09/18 14:28:53  willem.vandorp
*    OpenOffice header added.
*
*    Revision 1.4  2000/08/11 21:50:56  ping.liao
*     Made Mac OS 9 stub functions alloate **rtl_uString memory.
*
*    Revision 1.1  2000/07/20 17:10:30  patrick.luby
*    Added stub implementation for file.h
*
*    Revision 1.24  2000/06/15 12:52:03  rs
*    comment fixes
*
*    Revision 1.23  2000/05/17 14:30:13  mfe
*    comments upgraded
*
*    Revision 1.22  2000/04/20 14:33:34  hro
*    osl_getSystemPathFromNormalizedPath
*
*    Revision 1.21  2000/04/03 11:38:03  hro
*    #73606# added osl_releaseVolumeDeviceHandle
*
*    Revision 1.20  2000/04/03 11:34:56  hro
*    #73606# added osl_releaseVolumeDeviceHandle
*
*    Revision 1.19  2000/03/29 16:21:14  hro
*    #73606# Interface changes for mount/unmount
*
*    Revision 1.18  2000/03/20 15:20:31  hro
*    #73606# New mount functions
*
*    Revision 1.17  2000/03/17 12:03:56  obr
*    Unicode API changes
*
*    Revision 1.16  2000/02/18 11:04:48  obr
*    #73177# c++ wrapper added
*
*    Revision 1.15  2000/02/17 11:15:56  mfe
*    #70473# : cleanup merge confusion
*
*    Revision 1.14  2000/02/14 13:37:53  mfe
*    #70473# : merged unicode version with cvs top-level
*
*    Revision 1.8  1999/11/24 10:23:19  rs
*    docu fixes
*
*    Revision 1.7  1999/11/23 10:02:34  rs
*    set filetime & fileattributes
*
*    Revision 1.6  1999/11/17 12:04:18  rs
*    normalizedPath-functions added
*
*    Revision 1.5  1999/11/02 17:52:09  rs
*    osl_normalizePath
*
*    Revision 1.4  1999/11/01 17:32:56  rs
*    rtl_Strings in UNICODE
*
*    Revision 1.3  1999/10/27 15:02:07  mfe
*    Change of Copyright, removed compiler warnings, code clean up, ...
*
*    Revision 1.2  1999/08/12 12:26:10  mfe
*    checkin of current revision
*
*    Revision 1.20  1999/08/05 12:34:26  jsc
*    verschoben in root inc-Verzeichnis
*
*    Revision 1.19  1999/08/03 14:17:47  mfe
*    updated docu for osl_getAbsolutePath
*
*    Revision 1.18  1999/08/02 11:58:24  mfe
*    typo and docu fixes
*
*    Revision 1.17  1999/07/30 15:42:14  hro
*    More docu, more function - time for holiday
*
*    Revision 1.16  1999/07/26 10:44:38  mfe
*    more docu again
*
*    Revision 1.15  1999/07/23 16:34:01  mfe
*    added documentation massively
*
*    Revision 1.14  1999/07/22 13:07:40  hro
*    It's blowing up
*
*    Revision 1.13  1999/07/22 10:13:59  mfe
*    New errors, setfilepos with How-arg and many SAL_CALLS added
*
*    Revision 1.12  1999/07/20 10:41:48  mfe
*    completed docu of osl_openDirectory
*
*    Revision 1.11  1999/07/19 16:18:09  mfe
*    oslFileHandle defined, rtl/string.hxx included, osl_File_E_USERS added
*
*    Revision 1.10  1999/07/19 13:49:25  hro
*    Some new file functions
*
*    Revision 1.9  1999/07/14 15:04:06  hro
*    No C++ comments in C header files !!!
*
*    Revision 1.8  1999/07/09 11:43:15  mfe
*    added E_LOOP , fixed typo in oslFileType
*
*    Revision 1.7  1999/07/06 17:54:39  hro
*    Type correction fsAttributes
*
*    Revision 1.6  1999/07/06 10:50:23  hro
*    Changed prototype names
*
*    Revision 1.5  1999/06/29 15:43:21  hro
*    Oops 2
*
*    Revision 1.4  1999/06/29 15:05:48  hro
*    Oops
*
*    Revision 1.3  1999/06/29 14:28:59  hro
*    Added first new file system functions
*
*    Revision 1.2  1999/01/20 18:53:40  jsc
*    #61011# Typumstellung
*
*    Revision 1.1  1998/02/24 18:41:19  rh
*    Moved getFullPath to new filesystem interface file.h
*
*************************************************************************/
