/*************************************************************************
 *
 *  $RCSfile: daemon.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "system.h"

#include <osl/diagnose.h>
#include <osl/daemon.h>
#include <osl/thread.h>
#include <osl/conditn.h>

#include "../all/daemclie.h"

#if defined(SOLARIS) 
void ChangeGlobalInit();
#endif


/*****************************************************************************/
/* osl_accessDaemonManager */
/*****************************************************************************/
sal_Bool SAL_CALL osl_accessDaemonManager()
{
	return(osl_default_accessDaemonManager());
}	

/*****************************************************************************/
/* osl_queryDaemonCount */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_queryDaemonCount(sal_uInt32* pCount)
{
	return(osl_default_queryDaemonCount(pCount));
}	

/*****************************************************************************/
/* osl_queryDaemonIdentifier */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_queryDaemonIdentifier(sal_uInt32 index, rtl_uString** ustrIdentifier)
{
    return(osl_default_queryDaemonIdentifier(index, ustrIdentifier));
}


/*  oslDaemonManagerError SAL_CALL osl_queryDaemonIdentifier(sal_uInt32 index, sal_Char* buffer, sal_uInt32 sizeOfBuffer) */
/*  { */
/*  	return(osl_default_queryDaemonIdentifier(index, buffer, sizeOfBuffer)); */
/*  }	 */

/*****************************************************************************/
/* osl_isDaemonInstalled */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_isDaemonInstalled(rtl_uString* ustrIdentifier, sal_Bool* pRet)
{
	return(osl_default_isDaemonInstalled(ustrIdentifier, pRet));
}

/*  oslDaemonManagerError SAL_CALL osl_isDaemonInstalled(const sal_Char* Identifier, sal_Bool* pRet) */
/*  { */
/*  	return(osl_default_isDaemonInstalled(Identifier, pRet)); */
/*  } */

/*****************************************************************************/
/* osl_queryDaemonStatus */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_queryDaemonStatus(rtl_uString* ustrIdentifier, oslDaemonStatus* pStatus)
{
	return(osl_default_queryDaemonStatus(ustrIdentifier, pStatus));
}	

/*****************************************************************************/
/* osl_queryDaemonInfo */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_queryDaemonInfo(rtl_uString* ustrIdentifier, oslDaemonInfo* pInfo)
{
	return(osl_default_queryDaemonInfo(ustrIdentifier, pInfo));
}	

/*****************************************************************************/
/* osl_startDaemon */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_startDaemon(rtl_uString* ustrIdentifier)
{
	return(osl_default_startDaemon(ustrIdentifier));
}	

/*****************************************************************************/
/* osl_stopDaemon */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_stopDaemon(rtl_uString* ustrIdentifier)
{
	return(osl_default_stopDaemon(ustrIdentifier));
}	

/*****************************************************************************/
/* osl_pauseDaemon */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_pauseDaemon(rtl_uString* ustrIdentifier)
{
	return(osl_default_pauseDaemon(ustrIdentifier));
}	

/*****************************************************************************/
/* osl_pauseDaemon */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_continueDaemon(rtl_uString* ustrIdentifier)
{
	return(osl_default_continueDaemon(ustrIdentifier));
}	

/*****************************************************************************/
/* osl_installDaemon */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_installDaemon(const oslDaemonInfo* pInfo)
{
	return(osl_default_installDaemon(pInfo));
}	

/*****************************************************************************/
/* osl_uninstallDaemon */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_uninstallDaemon(rtl_uString* ustrIdentifier)
{
	return(osl_default_uninstallDaemon(ustrIdentifier));
}	

/*****************************************************************************/
/* osl_createDaemon */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_createDaemon(rtl_uString*                ustrIdentifier,
                                                oslDaemonControl            pControl,
                                                void*                       pThisControlData,
                                                oslDaemonPropertyAccess*    pPropertyAccess,
                                                void*                       pThisAccessData,
                                                oslDaemonHandle*            pHandle)
{
#if defined(SOLARIS) 
	ChangeGlobalInit();
#endif
	return(osl_default_createDaemon(ustrIdentifier,
						   		  	pControl, 
						  		  	pThisControlData,
									pPropertyAccess,
						  		  	pThisAccessData,
						  		  	pHandle));
}	

/*****************************************************************************/
/* osl_executeDaemon */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_executeDaemon(oslDaemonHandle handle)
{
	return(osl_default_executeDaemon(handle));
}	

/*****************************************************************************/
/* osl_executeDaemons */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_executeDaemons(oslDaemonHandle* pHandle, sal_uInt32 numOfDaemons)
{
	return(osl_default_executeDaemons(pHandle, numOfDaemons));
}	


/*****************************************************************************/
/* osl_setDaemonStatus */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_setDaemonStatus(oslDaemonHandle handle, oslDaemonStatus Status)
{
	return(osl_default_setDaemonStatus(handle, Status));
}	

/*****************************************************************************/
/* osl_endDaemon */
/*****************************************************************************/

oslDaemonManagerError SAL_CALL osl_endDaemon(oslDaemonHandle handle)
{
	return(osl_default_endDaemon(handle));
}	

/*****************************************************************************/
/* osl_getDaemonPropertyCount */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_getDaemonPropertyCount(rtl_uString* ustrIdentifier, sal_uInt32* pCount)
{
	return(osl_default_getDaemonPropertyCount(ustrIdentifier, pCount));
}	

/*****************************************************************************/
/* osl_getDaemonProperties */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_getDaemonProperties(rtl_uString*         ustrIdentifier, 
                                                       oslDaemonProperty**  ppProps, 
                                                       sal_uInt32*          pCount)
{
	return(osl_default_getDaemonProperties(ustrIdentifier, 
										   ppProps, 
										   pCount));
}	

/*****************************************************************************/
/* osl_setDaemonProperties */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_setDaemonProperties(rtl_uString*        ustrIdentifier, 
                                                       oslDaemonProperty*  pProps, 
                                                       sal_uInt32          count, 
                                                       sal_uInt32*         pErrorCode, 
                                                       rtl_uString**       pustrError)
{
	return(osl_default_setDaemonProperties(ustrIdentifier, 
										   pProps, 
										   count, 
										   pErrorCode, 
										   pustrError));
}	

/*****************************************************************************/
/* osl_getDaemonProfileSections */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_getDaemonProfileSections(rtl_uString*   ustrIdentifier, 
                                                            sal_Unicode*   puBuffer, 
                                                            sal_uInt32     bufferSize, 
                                                            sal_uInt32*    pRequiredSize)
{
	return(osl_default_getDaemonProfileSections(ustrIdentifier, 
												puBuffer, 
												bufferSize,
												pRequiredSize));
}	

/*****************************************************************************/
/* osl_getDaemonProfileEntries */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_getDaemonProfileEntries(rtl_uString*    ustrIdentifier, 
                                                           rtl_uString*    ustrSection, 
                                                           sal_Unicode*    puBuffer, 
                                                           sal_uInt32      bufferSize,
                                                           sal_uInt32*     pRequiredSize)
{
	return(osl_default_getDaemonProfileEntries(ustrIdentifier, 
											   ustrSection, 
											   puBuffer, 
											   bufferSize,
											   pRequiredSize));
}	

/*****************************************************************************/
/* osl_readDaemonProfileString */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_readDaemonProfileString(rtl_uString*    ustrIdentifier, 
                                                           rtl_uString*    ustrSection, 
                                                           rtl_uString*    ustrEntry, 
                                                           rtl_uString**   pustrBuffer, 
                                                           rtl_uString*    ustrDefaultValue)
{
	return(osl_default_readDaemonProfileString(ustrIdentifier, 
											   ustrSection, 
											   ustrEntry, 
											   pustrBuffer, 
											   ustrDefaultValue));
}	

/*****************************************************************************/
/* osl_readDaemonProfileBool */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_readDaemonProfileBool(rtl_uString*      ustrIdentifier, 
                                                         rtl_uString*      ustrSection, 
                                                         rtl_uString*   ustrEntry, 
                                                         sal_Bool*         pValue, 
                                                         sal_Bool          defaultValue)
{
	return(osl_default_readDaemonProfileBool(ustrIdentifier, 
											 ustrSection, 
											 ustrEntry, 
											 pValue, 
											 defaultValue));
}

/*****************************************************************************/
/* osl_readDaemonProfileIdent */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_readDaemonProfileIdent(rtl_uString*     ustrIdentifier, 
                                                          rtl_uString*     ustrSection, 
                                                          rtl_uString*     ustrEntry, 
                                                          sal_uInt32*      pValue, 
                                                          sal_uInt32       firstId, 
                                                          rtl_uString**    pustrStrings, 
                                                          sal_uInt32       defaultValue)
{
	return(osl_default_readDaemonProfileIdent(ustrIdentifier, 
											  ustrSection, 
											  ustrEntry, 
											  pValue, 
											  firstId, 
											  pustrStrings, 
											  defaultValue));
}	

/*****************************************************************************/
/* osl_writeDaemonProfileString */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_writeDaemonProfileString(rtl_uString*    ustrIdentifier, 
                                                            rtl_uString*    ustrSection, 
                                                            rtl_uString*    ustrEntry, 
                                                            rtl_uString*    ustrValue)
{
	return(osl_default_writeDaemonProfileString(ustrIdentifier, 
												ustrSection, 
												ustrEntry, 
												ustrValue));
}	

/*****************************************************************************/
/* osl_writeDaemonProfileBool */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_writeDaemonProfileBool(rtl_uString*      ustrIdentifier, 
                                                          rtl_uString*      ustrSection, 
                                                          rtl_uString*      ustrEntry, 
                                                          sal_Bool          value)
{
	return(osl_default_writeDaemonProfileBool(ustrIdentifier,
											  ustrSection, 
											  ustrEntry, 
											  value));
}	

/*****************************************************************************/
/* osl_writeDaemonProfileIdent */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_writeDaemonProfileIdent(rtl_uString*     ustrIdentifier, 
                                                           rtl_uString*     ustrSection, 
                                                           rtl_uString*     ustrEntry, 
                                                           sal_uInt32       value, 
                                                           sal_uInt32       firstId, 
                                                           rtl_uString**    pustrStrings)
{
	return(osl_default_writeDaemonProfileIdent(ustrIdentifier, 
											   ustrSection, 
											   ustrEntry, 
											   value, 
											   firstId, 
											   pustrStrings));
}	

/*****************************************************************************/
/* osl_removeDaemonProfileEntry */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_removeDaemonProfileEntry(rtl_uString*    ustrIdentifier, 
                                                            rtl_uString*    ustrSection, 
                                                            rtl_uString*    ustrEntry)
{
	return(osl_default_removeDaemonProfileEntry(ustrIdentifier, 
												ustrSection, 
												ustrEntry));
}	

/*****************************************************************************/
/* osl_queryDaemonChanges */
/*****************************************************************************/
oslDaemonManagerError SAL_CALL osl_queryDaemonChanges(TimeValue* pSince, sal_Bool* pBChanged)
{
	return(osl_default_queryDaemonChanges(pSince, pBChanged));
}	

