/*************************************************************************
 *
 *  $RCSfile: tcwin16.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SAL_TYPES_H
#include <sal/types.h>
#endif

#ifndef _RTL_TEXTCVT_H
#include <rtl/textcvt.h>
#endif

#ifndef _RTL_TENCINFO_H
#include <rtl/tencinfo.h>
#endif

/** Unicode fuer Arme (Win16)
 Win16 unterstuetzt nur einen eingeschraenkten Unicode,
 der Ascii-Zeichen zwischen 0x80-0xBF behandelt.
 */

/* --- Tabellen fuer ASCII nach Unicode --------- */
static sal_Char __asc_sort[] =
{ /* sortierte Tabelle der ASCII-Werte */
    0x2D, /* MINUS SIGN                           */
    0x80, /* EURO SIGN                            */
    0x82, /* LOW SINGLE COMMA QUOTATION MARK      */
    0x83, /* LATIN SMALL LETTER SCRIPT F          */
    0x84, /* LOW DOUBLE COMMA QUOTATION MARK      */
    0x85, /* HORIZONTAL ELLIPSIS                  */
    0x86, /* DAGGER                               */
    0x87, /* DOUBLE DAGGER                        */
    0x88, /* MODIFIER LETTER CIRCUMFLEX           */
    0x89, /* PER MILE SIGN                        */
    0x8A, /* LATIN CAPITEL LETTER S HACEK         */
    0x8B, /* LEFT POINTING SINGLE GUILLEMENT      */
    0x8C, /* LATIN CAPITEL LETTER O E             */
    0x91, /* SINGLE TURNED COMMA QUOTATION MARK   */
    0x92, /* SINGLE COMMA QUOTATION MARK          */
    0x93, /* DOUBLE TURNED COMMA QUOTATION MARK   */
    0x94, /* DOUBLE COMMA QUOTATION MARK          */
    0x95, /* BULLET (!!! Bei 850 mappen wir auf Middle-Dot fuer SWG, was bei der Zurueckkonvertierung naturlich deneben geht) */
    0x96, /* EN DASH                              */
    0x97, /* EM DASH                              */
    0x98, /* SPACING TILDE                        */
    0x99, /* TRADEMARK                            */
    0x9A, /* LATIN SMALL LETTER S HACEK           */
    0x9B, /* RIGHT POINTING SINGLE GUILLEMENT     */
    0x9C, /* LATIN SMALL LETTER O E               */
    0x9F, /* LATIN CAPITEL LETTER Y DIAERESIS     */
    0xB0, /* SPACING RING ABOVE                   */
    0xB4, /* PRIME                                */
    0xB5  /* GREEK SMALL LETTER MU                */
};
#define W16MapSize (sizeof(__asc_sort)/sizeof(__asc_sort[0]))
static sal_Unicode __asc2uni[W16MapSize] =
{ /* die zur obigen Tabelle gehoerigen Unicode-Werte */
    0x2212, /* MINUS SIGN                         */
    0x20AC, /* EURO SIGN                          */
    0x201A, /* LOW SINGLE COMMA QUOTATION MARK    */
    0x0192, /* LATIN SMALL LETTER SCRIPT F        */
    0x201E, /* LOW DOUBLE COMMA QUOTATION MARK    */
    0x2026, /* HORIZONTAL ELLIPSIS                */
    0x2020, /* DAGGER                             */
    0x2021, /* DOUBLE DAGGER                      */
    0x02C6, /* MODIFIER LETTER CIRCUMFLEX         */
    0x2030, /* PER MILE SIGN                      */
    0x0160, /* LATIN CAPITEL LETTER S HACEK       */
    0x2039, /* LEFT POINTING SINGLE GUILLEMENT    */
    0x0152, /* LATIN CAPITEL LETTER O E           */
    0x2018, /* SINGLE TURNED COMMA QUOTATION MARK */
    0x2019, /* SINGLE COMMA QUOTATION MARK        */
    0x201C, /* DOUBLE TURNED COMMA QUOTATION MARK */
    0x201D, /* DOUBLE COMMA QUOTATION MARK        */
    0x2022, /* BULLET                             */
    0x2013, /* EN DASH                            */
    0x2014, /* EM DASH                            */
    0x02DC, /* SPACING TILDE                      */
    0x2122, /* TRADEMARK                          */
    0x0161, /* LATIN SMALL LETTER S HACEK         */
    0x203A, /* RIGHT POINTING SINGLE GUILLEMENT   */
    0x0153, /* LATIN SMALL LETTER O E             */
    0x0178, /* LATIN CAPITEL LETTER Y DIAERESIS   */
    0x02DA, /* SPACING RING ABOVE                 */
    0x2032, /* PRIME                              */
	0x03BC	/* GREEK SMALL LETTER MU              */
};

/* --- Tabellen fuer Unicode nach ASCII --------- */
static sal_Unicode __uni_sort[W16MapSize] =
{ /* sortierte Tabelle der Unicode-Werte */
	0x0152, /* LATIN CAPITEL LETTER O E           */
	0x0153, /* LATIN SMALL LETTER O E             */
    0x0160, /* LATIN CAPITEL LETTER S HACEK       */
	0x0161, /* LATIN SMALL LETTER S HACEK         */
	0x0178, /* LATIN CAPITEL LETTER Y DIAERESIS   */
	0x0192, /* LATIN SMALL LETTER SCRIPT F        */
	0x02C6, /* MODIFIER LETTER CIRCUMFLEX         */
	0x02DA, /* SPACING RING ABOVE                 */
	0x02DC, /* SPACING TILDE                      */
	0x03BC,	/* GREEK SMALL LETTER MU              */
	0x2013, /* EN DASH                            */
	0x2014, /* EM DASH                            */
	0x2018, /* SINGLE TURNED COMMA QUOTATION MARK */
	0x2019, /* SINGLE COMMA QUOTATION MARK        */
	0x201A, /* LOW SINGLE COMMA QUOTATION MARK    */
	0x201C, /* DOUBLE TURNED COMMA QUOTATION MARK */
	0x201D, /* DOUBLE COMMA QUOTATION MARK        */
	0x201E, /* LOW DOUBLE COMMA QUOTATION MARK    */
	0x2020, /* DAGGER                             */
	0x2021, /* DOUBLE DAGGER                      */
	0x2022, /* BULLET                             */
	0x2026, /* HORIZONTAL ELLIPSIS                */
	0x2030, /* PER MILE SIGN                      */
	0x2032, /* PRIME                              */
	0x2039, /* LEFT POINTING SINGLE GUILLEMENT    */
	0x203A, /* RIGHT POINTING SINGLE GUILLEMENT   */
	0x20AC, /* EURO SIGN                          */
	0x2122, /* TRADEMARK                          */
    0x2212  /* MINUS SIGN                         */
};
static sal_Char __uni2asc[W16MapSize] =
{ /* die zur obigen Tabelle gehoerigen ASCII-Werte */
    0x8C, /* LATIN CAPITEL LETTER O E             */
    0x9C, /* LATIN SMALL LETTER O E               */
    0x8A, /* LATIN CAPITEL LETTER S HACEK         */
    0x9A, /* LATIN SMALL LETTER S HACEK           */
    0x9F, /* LATIN CAPITEL LETTER Y DIAERESIS     */
    0x83, /* LATIN SMALL LETTER SCRIPT F          */
    0x88, /* MODIFIER LETTER CIRCUMFLEX           */
    0xB0, /* SPACING RING ABOVE                   */
    0x98, /* SPACING TILDE                        */
    0xB5, /* GREEK SMALL LETTER MU                */
    0x96, /* EN DASH                              */
    0x97, /* EM DASH                              */
    0x91, /* SINGLE TURNED COMMA QUOTATION MARK   */
    0x92, /* SINGLE COMMA QUOTATION MARK          */
    0x82, /* LOW SINGLE COMMA QUOTATION MARK      */
    0x93, /* DOUBLE TURNED COMMA QUOTATION MARK   */
    0x94, /* DOUBLE COMMA QUOTATION MARK          */
    0x84, /* LOW DOUBLE COMMA QUOTATION MARK      */
    0x86, /* DAGGER                               */
    0x87, /* DOUBLE DAGGER                        */
    0x95, /* BULLET (!!! Bei 850 mappen wir auf Middle-Dot fuer SWG, was bei der Zurueckkonvertierung naturlich deneben geht) */
    0x85, /* HORIZONTAL ELLIPSIS                  */
    0x89, /* PER MILE SIGN                        */
    0xB4, /* PRIME                                */
    0x8B, /* LEFT POINTING SINGLE GUILLEMENT      */
    0x9B, /* RIGHT POINTING SINGLE GUILLEMENT     */
    0x80, /* EURO SIGN                            */
    0x99, /* TRADEMARK                            */
    0x2D  /* MINUS SIGN                           */
};

sal_Unicode getUnicode(sal_Char ascii)
{
    int l, m, r;
    l = 0;
    r = W16MapSize;
    while (l < r)
    {
        m = (l + r) >> 1;
        /*   VVVVVVVVV  auf unsigned...  VVVVVVVV ...casten, damit der > - Verleich funzt */
        if ((sal_uChar) __asc_sort[m] > (sal_uChar) ascii) r = m; else l = m + 1;
    }
    if ((r < W16MapSize) && (__asc_sort[r] == ascii)) return __asc2uni[r];
    return 0;
}

sal_Char getAscii(sal_Unicode unicode)
{
    int l, m, r;
    l = 0;
    r = W16MapSize;
    while (l < r)
    {
        m = (l + r) >> 1;
        if (__uni_sort[m] > unicode) r = m; else l = m + 1;
    }
    if ((r < W16MapSize) && (__uni_sort[r] == unicode)) return __uni2asc[r];
    return 0;
}

#ifdef __cplusplus
extern "C" {
#endif

    sal_Bool SAL_CALL rtl_getTextEncodingInfo( rtl_TextEncoding eTextEncoding, rtl_TextEncodingInfo* pEncInfo )
    {
        return sal_True;
    }

    /* --- Unicode2Text ------------------------------------------------------------------------------------ */
    rtl_UnicodeToTextConverter SAL_CALL rtl_createUnicodeToTextConverter( rtl_TextEncoding eTextEncoding )
    {
        return 0;
    }

    sal_Size SAL_CALL rtl_convertUnicodeToText( rtl_UnicodeToTextConverter hConverter,
                                                rtl_UnicodeToTextContext hContext,
                                                const sal_Unicode* pSrcBuf, sal_Size nSrcChars,
                                                sal_Char* pDestBuf, sal_Size nDestBytes,
                                                sal_uInt32 nFlags, sal_uInt32* pInfo,
                                                sal_Size* pSrcCvtChars )
    {
        sal_Size i, j;
        j = 0;
        for (i = 0; (i < nSrcChars) && (j < nDestBytes); i++)
        {
            sal_Unicode unicode = pSrcBuf[i];
            if (unicode < 0x100)  pDestBuf[j++] = (sal_Char) (unicode & 0xff);
            else pDestBuf[j++] = getAscii(unicode);
        }
        *pSrcCvtChars = i;
        return j;
    }

    void SAL_CALL rtl_destroyUnicodeToTextConverter( rtl_UnicodeToTextConverter hConverter )
    {
    }

    /* --- Text2Unicode ------------------------------------------------------------------------------------ */
    rtl_TextToUnicodeConverter SAL_CALL rtl_createTextToUnicodeConverter( rtl_TextEncoding eTextEncoding )
    {
        return 0;
    }

    sal_Size SAL_CALL rtl_convertTextToUnicode( rtl_TextToUnicodeConverter hConverter,
                                                rtl_TextToUnicodeContext hContext,
                                                const sal_Char* pSrcBuf, sal_Size nSrcBytes,
                                                sal_Unicode* pDestBuf, sal_Size nDestChars,
                                                sal_uInt32 nFlags, sal_uInt32* pInfo,
                                                sal_Size* pSrcCvtBytes )
    {
        sal_Size i, j;
        j = 0;
        for (i = 0; (i < nSrcBytes) && (j < nDestChars); i++)
        {
            sal_Char ascii = (sal_uChar) pSrcBuf[i];
            if ((((sal_uChar) ascii) < 0x80) || (((sal_uChar) ascii) >= 0xc0))
            {
                if (ascii == 0x2d) pDestBuf[j++] = 0x2212; /* geht schneller, als aus der Tabelle zu suchen */
                else pDestBuf[j++] = (sal_Unicode) (ascii & 0x7f);
            }
            else pDestBuf[j++] = getUnicode(ascii);
        }
        *pSrcCvtBytes = i;
        return j;
    }

    void SAL_CALL rtl_destroyTextToUnicodeConverter( rtl_TextToUnicodeConverter hConverter )
    {
    }

#ifdef __cplusplus
}
#endif



