#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 15:17:25 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

$(PRJPCH)=

PRJNAME=sal
TARGET=sdaemon


.IF "$(GUI)"!="OS2" 
.IF "$(GUI)"!="WNT" 
.IF "$(GUI)"!="WIN" 
TARGETTYPE=CUI
.ENDIF
.ENDIF
.ENDIF

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- exe --------------------------------------------------------

APP1TARGET= $(TARGET)

APP1OBJS = $(OBJ)$/sdaemon.obj

.IF "$(GUI)"=="UNX"
.IF "$(OS)"=="SOLARIS"
APP1STDLIBS += -lpthread -lposix4 -lsocket -lnsl 
.ENDIF
.IF "$(OS)"=="LINUX"
APP1STDLIBS += -lcrypt
.ENDIF
.ENDIF

.IF "$(GUI)" == "WNT"
.IF "$(COM)" != "GCC"
APP1STDLIBS =	\
              advapi32.lib \
              advapi9x.lib \
              kernel9x.lib \
			  shell9x.lib \
              wsock32.lib \
              mpr.lib \
              ole32.lib \
              user32.lib\
			  cpprtl.lib\
			  textenc.lib\
			  oslall.lib\
			  cpposl.lib\
			  tools32.lib\
			  shell32.lib
.ELSE
APP1STDLIBS = -ladvapi32 -lwsock32 -lmpr -lole32 -luser32
.ENDIF
.ENDIF			# "$(GUI)" == "WNT"

.IF "$(GUI)" == "WIN"
APP1STDLIBS =	\
              winsock.lib

.ENDIF

.IF "$(GUI)"=="OS2"
STDLIBGUIST=cppom30.lib os2386.lib
STDLIBGUIMT=cppom30.lib os2386.lib

APP1STDLIBS=n:\toolkit4\lib\so32dll.lib\
            n:\toolkit4\lib\tcp32dll.lib\
	os2286.lib
APP1DEF=    $(MISC)$/$(TARGET).def
.ENDIF

.IF "$(GUI)"=="OS2" 
APP1NOSAL=TRUE
.ENDIF

.IF "$(GUI)"=="WNT" 
APP1NOSAL=TRUE
.ENDIF

.IF "$(GUI)"=="MAC"
APP1STDLIBS=-L$(shell $(UNIX2MACPATH) $(MW_HOME)$/Metrowerks\ CodeWarrior$/MacOS\ Support$/OpenTransport$/Open\ Tpt\ Client\ Developer$/PPC\ Libraries) \
  -weakimport -lOpenTransportLib -weakimport -lOpenTptInternetLib \
  -lOpenTransportExtnPPC.o -lOpenTptInetPPC.o
APP1STDLIBS+=-init InitLibrary -term ExitLibrary
.ENDIF

APP1LIBS = $(LB)$/asal.lib

#APP1LINKTYPE = STATIC

# --- Targets ------------------------------------------------------


.INCLUDE :  target.mk


.IF "$(GUI)" == "OS2"
$(MISC)$/$(APP1TARGET).def : makefile.mk
    echo  NAME          sdaemon WINDOWAPI                >$@
    echo  DESCRIPTION   'Star Service Daemon'            >>$@
    echo  STUB		'os2STUB.EXE'                    >>$@
    echo  EXETYPE	OS2 				 >>$@
    echo  PROTMODE					 >>$@
    echo  CODE		LOADONCALL			 >>$@
    echo  DATA		PRELOAD MULTIPLE		 >>$@
    echo  HEAPSIZE	8192				 >>$@
    echo  STACKSIZE 	256000				 >>$@
.ENDIF

