/*************************************************************************
 *
 *  $RCSfile: kernel9x.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <windows.h>

#include <LoadLibrary.h>
#include <GetModuleFileName.h>
#include <GetLogicalDriveStrings.h>
#include <DeleteFile.h>
#include <CopyFile.h>
#include <MoveFile.h>
#include <MoveFileEx.h>
#include <CreateFile.h>

#ifndef _DLL
	#include <systools/win32/Auto9xInit.hxx>
#endif


extern "C"
{

HMODULE (WINAPI *lpfnLoadLibraryExW) (
	LPCWSTR lpLibFileName,  // file name of module
	HANDLE hFile,           // reserved, must be NULL
	DWORD dwFlags           // entry-point execution option
) = LoadLibraryExW_9x;

DWORD (WINAPI *lpfnGetModuleFileNameW) (
	HMODULE hModule,    // handle to module
	LPWSTR lpFilename,  // file name of module
	DWORD nSize         // size of buffer 
) = GetModuleFileNameW_9x;

DWORD (WINAPI *lpfnGetLogicalDriveStringsW) (
	DWORD nBufferLength,	// size of buffer
	LPWSTR lpBuffer			// drive strings buffer
) = GetLogicalDriveStringsW_9x;

BOOL (WINAPI *lpfnDeleteFileW) (
	LPCWSTR	lpFileName			// file name
) = DeleteFileW_9x;

BOOL (WINAPI *lpfnMoveFileW) (
	LPCWSTR lpExistingFileName,	// file name
	LPCWSTR lpNewFileName		// new file name
) = MoveFileW_9x;

BOOL (WINAPI *lpfnMoveFileExW) (
  LPCWSTR lpExistingFileName,	// file name
  LPCWSTR lpNewFileName,		// new file name
  DWORD dwFlags					// move options
) = MoveFileExW_9x;


BOOL (WINAPI *lpfnCopyFileW) (
	LPCWSTR lpExistingFileName,	// file name
	LPCWSTR lpNewFileName,		// new file name
	BOOL	bFailIfExist		// operation if file exists
) = CopyFileW_9x;

HANDLE (WINAPI *lpfnCreateFileW) (
	LPCWSTR	lpFileName,
	DWORD	dwDesiredAccess,
	DWORD	dwShareMode,
	LPSECURITY_ATTRIBUTES	lpSecurityAttributes,
	DWORD	dwCreationDisposition,
	DWORD	dwFlagsAndAttributes,
	HANDLE	hTemplateFile
) = CreateFileW_9x;

void Kernel9xInit(LPOSVERSIONINFO lpVersionInfo)
{
	/* replace non functional stubs for Win9x only */
	if (/*0 && */ lpVersionInfo->dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		lpfnLoadLibraryExW			= LoadLibraryExW;
		lpfnGetModuleFileNameW		= GetModuleFileNameW;
		lpfnGetLogicalDriveStringsW = GetLogicalDriveStringsW;
		lpfnDeleteFileW				= DeleteFileW;
		lpfnCopyFileW				= CopyFileW;
		lpfnMoveFileW				= MoveFileW;
		lpfnMoveFileExW				= MoveFileExW;
		lpfnCreateFileW				= CreateFileW;
	}
}

void Kernel9xDeInit()
{
}

} /* extern C */

#ifndef _DLL
	static OAuto9xInit	initKernel9x( Kernel9xInit, Kernel9xDeInit );
#endif
