/*************************************************************************
 *
 *  $RCSfile: Shell9x.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <windows.h>
#include <shlobj.h>
#include <CommandLineToArgv.h>
#include "SHBrowseForFolder.h"
#include "SHGetPathFromIDList.h"
#include "SetWindowText.h"

#ifndef _DLL
	#include <systools/win32/Auto9xInit.hxx>
#endif

extern "C"
{

LPWSTR * (WINAPI * lpfnCommandLineToArgvW) (
  LPCWSTR lpCmdLine,  // pointer to a command-line string
  int *pNumArgs       // receives the argument count
) = CommandLineToArgvW_9x;


LPITEMIDLIST ( WINAPI * lpfnSHBrowseForFolderW ) (
	LPBROWSEINFOW lpbi
) = SHBrowseForFolderW_9x;


BOOL ( WINAPI * lpfnSHGetPathFromIDListW ) (
	LPCITEMIDLIST pidl, 
	LPWSTR pszPath
) = SHGetPathFromIDListW_9x;


BOOL ( WINAPI * lpfnSetWindowTextW ) (
    HWND hWnd,
    LPCWSTR lpString
) = SetWindowTextW_9x;


void Shell9xInit(LPOSVERSIONINFO lpVersionInfo)
{
	HMODULE hWinModule = NULL;

	if (lpVersionInfo->dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		hWinModule = GetModuleHandleA("Shell32");
		FARPROC fProc;

		// use NT function only if shell32.dll already loaded
		if ( hWinModule )
		{
			fProc = GetProcAddress(hWinModule, "CommandLineToArgvW");
			if (fProc)
				lpfnCommandLineToArgvW = (LPWSTR * (WINAPI *) (LPCWSTR, int *)) fProc;
		}
	
		lpfnSHBrowseForFolderW   = SHBrowseForFolderW;
		lpfnSHGetPathFromIDListW = SHGetPathFromIDListW;
		lpfnSetWindowTextW       = SetWindowTextW;
	}
}

void Shell9xDeInit()
{
}

} // extern "C"


#ifndef _DLL
	// create a static object which calls
	// Shell9xInit/Shell9xDeInit in ctor/dtor
	static OAuto9xInit	initShell9x( Shell9xInit, Shell9xDeInit );
#endif
