/*************************************************************************
 *
 *  $RCSfile: User9X.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <windows.h>
#include "SendMessage.h"
#include "CreateWindowEx.h"
#include "RegisterClassEx.h"
#include "UnregisterClass.h"

#ifndef _DLL
	#include <systools/win32/Auto9xInit.hxx>
#endif


extern "C"
{

LRESULT ( WINAPI * lpfnSendMessageW ) (
	HWND hWnd,		// handle to the destination window
	UINT Msg,		// message
	WPARAM wParam,	// first message parameter
	LPARAM lParam	// second message parameter
) = SendMessageW_9x;

typedef HWND ( WINAPI * CreateWindowExW_PROC ) (
	DWORD dwExStyle,      // extended window style
	LPCWSTR lpClassName,  // registered class name
	LPCWSTR lpWindowName, // window name
	DWORD dwStyle,        // window style
	int x,                // horizontal position of window
	int y,                // vertical position of window
	int nWidth,           // window width
	int nHeight,          // window height
	HWND hWndParent,      // handle to parent or owner window
	HMENU hMenu,          // menu handle or child identifier
	HINSTANCE hInstance,  // handle to application instance
	LPVOID lpParam        // window-creation data
);

ATOM ( WINAPI * lpfnRegisterClassExW ) ( 
	CONST WNDCLASSEXW* lpwcx // class data
) = RegisterClassExW_9x;

BOOL ( WINAPI * lpfnUnregisterClassW ) (
	LPCWSTR lpClassName, // class name
	HINSTANCE hInstance	 // handle to application instance
) = UnregisterClassW_9x;


CreateWindowExW_PROC lpfnCreateWindowExW = CreateWindowExW_9x;



void User9xInit(LPOSVERSIONINFO lpVersionInfo)
{
	HMODULE hWinModule = NULL;

	if (lpVersionInfo->dwPlatformId == VER_PLATFORM_WIN32_NT)
	{
		// use NT function only if user32.dll already loaded
		lpfnSendMessageW       = SendMessageW;
		lpfnCreateWindowExW    = CreateWindowExW;
		lpfnRegisterClassExW   = RegisterClassExW;
		lpfnUnregisterClassW = UnregisterClassW;
	}	
}

void User9xDeInit()
{
}

} // extern "C"

#ifndef _DLL
	// create a static object which calls
	// Comdlg9xInit/Comdlg9xDeInit in ctor/dtor
	static OAuto9xInit	initUser9x( User9xInit, User9xDeInit );
#endif
