/*************************************************************************
 *
 *  $RCSfile: teststring.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <string.h>
#include <stdio.h>

#ifndef	_OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif

#ifndef	_RTL_STRING_HXX
#include <rtl/string.hxx>
#endif

#ifdef _DEBUG
#define TEST_ENSHURE(c, m)   OSL_ENSHURE(c, m)
#else
#define TEST_ENSHURE(c, m)   OSL_VERIFY(c)
#endif

using namespace rtl;

void test_OString()
{
#ifdef _USE_NAMESPACE
	TEST_ENSHURE( sal_True, "_USENAMEPSACE defined");
#endif

	//          "Mein erster RTL OString\n"
	//	         |	  |    |    |	 |
	//	Index    0	  5	   10   15	 20
	OString s1("Mein erster RTL OString\n");
	TEST_ENSHURE( s1 == "Mein erster RTL OString\n", "test_OString error 1");
	TEST_ENSHURE( s1.getLength() == 24, "test_OString error 2");

	OString s2 = s1;
	TEST_ENSHURE( s2[16] == 'O', "test_OString error 3");
	TEST_ENSHURE( s2.equals(s1), "test_OString error 4");	
	TEST_ENSHURE( s2.indexOf('O') == 16, "test_OString error 5");
	TEST_ENSHURE( s2.indexOf('O', 5) == 16, "test_OString error 5a");
	TEST_ENSHURE( s2.lastIndexOf('r') == 19, "test_OString error 6");
	TEST_ENSHURE( s2[19] == 'r', "test_OString error 7");
	TEST_ENSHURE( s2[23] == '\n', "test_OString error 8");	
	TEST_ENSHURE( s2.lastIndexOf('\n') == 23, "test_OString error 9");
	TEST_ENSHURE( s2.lastIndexOf('M') == 0, "test_OString error 10");
	TEST_ENSHURE( s2.lastIndexOf('t', s2.getLength() - 8) == 8, "test_OString error 9");
	
	
	//          "Mein erster RTL OString ist ein String aus der RTL Library\n"
	//           |    |    |    |	 |	  |	   |	| 	 |	  |	   |	|
	//  Index    0    5	   10   15	 20   25   30	35	 40   45   50	55
	OString s3 = s2.copy(0, s2.getLength() - 1);
	OString s4 = s3.concat(" ist ein String aus der RTL Library\n");
	TEST_ENSHURE( s4.getLength() == 59, "test_OString error 11");
	
	s1 = s4.copy(0, 38);
	OString s5;
	s5 = s1 + " aus der RTL Library\n"; 
	TEST_ENSHURE( s5.compareTo(s4) == 0 , "test_OString error 12");	
	TEST_ENSHURE( s5.indexOf("RTL") == 12, "test_OString error 13");
	TEST_ENSHURE( s5.lastIndexOf("RTL") == 47, "test_OString error 13");

	sal_Bool b = False;
	OString s6 = s5.valueOf(b);
	TEST_ENSHURE( s6.compareTo("False") == 0, "test_OString error 14");
	s6 = s5.valueOf('H');
	TEST_ENSHURE( s6.compareTo("H") == 0, "test_OString error 15");
	sal_Int32 n = 123456789L;
	s6 = s5.valueOf(n);
	TEST_ENSHURE( s6.compareTo("123456789") == 0, "test_OString error 16");	

#ifndef SAL_OS2
#ifdef SAL_UNX
	sal_Int64 m = -3223372036854775807LL;
#elif defined(SAL_OS2)
    sal_Int64 m;
    sal_setInt64(&m, 3965190145L, -750499787L);
#else
	sal_Int64 m = -3223372036854775807;
#endif
	s6 = s5.valueOf(m);
	TEST_ENSHURE( s6.compareTo("-3223372036854775807") == 0, "test_OString error 17");	
#endif
    
	OString s7("HaLLo");
	s7 = s7.toLowerCase();
	TEST_ENSHURE( s7 == "hallo", "test_OString error 19");	
	s7 = s7.toUpperCase();
	TEST_ENSHURE( s7 == "HALLO", "test_OString error 20");	

	OString s8("HaLLo ICH BIn eIn StRiNg");
	s7 = s8.toLowerCase();

	TEST_ENSHURE( s8.equalsIgnoreCase(s7), "test_OString error 21");	
	
	s8 = s7.toUpperCase();
	TEST_ENSHURE( s8 == "HALLO ICH BIN EIN STRING", "test_OString error 22");	

	s7 = "          ";
	s8 = s7 + s8 + "          ";
	TEST_ENSHURE( s8 == "          HALLO ICH BIN EIN STRING          ", 
				  "test_OString error 23");	

	s7 = s8.trim();
	TEST_ENSHURE( s7 == "HALLO ICH BIN EIN STRING", "test_OString error 24");	
	TEST_ENSHURE( strcmp(s7.getStr(), "HALLO ICH BIN EIN STRING") == 0, 
				  "test_OString error 25");	

	s7 = "Hallo";
	s8 = "aber Hallo";

	TEST_ENSHURE( s7 < s8, "test_OString error 26");	
	TEST_ENSHURE( s8 > s7, "test_OString error 27");	
	TEST_ENSHURE( s7 != s8, "test_OString error 28");	
	TEST_ENSHURE( s7 != "blabla", "test_OString error 29");	
	TEST_ENSHURE( "blabla" != s7, "test_OString error 30");	
	
	s8 = "Hallo";	
	TEST_ENSHURE( s7 <= s8, "test_OString error 31");	
	TEST_ENSHURE( s7 >= s8, "test_OString error 32");	

	s8 = s8.replace('l', 'r');
	TEST_ENSHURE( s8 == "Harro", "test_OString error 33");	
	TEST_ENSHURE( s8.len() == 5, "test_OString error 34");	
	
	//       "Ich bin ein String mit einem A und C und vielen m, m, m, m"
	//		  |	   |	|	 |	  |	   |	|	 |	  |	   |	|	 |
	//index	  0	   5	10	 15	  20   25	30	 35	  40   45	50	 55
	s8 = "Ich bin ein String mit einem A und C und vielen m, m, m, m";
	TEST_ENSHURE( s8.search('I') == 0, "test_OString error 35");	
	TEST_ENSHURE( s8.search('A') == 29, "test_OString error 36");	
	s7 = "A und C";
	TEST_ENSHURE( s8.search(s7) == 29, "test_OString error 37");	
	TEST_ENSHURE( s8.search("mit einem A") == 19, "test_OString error 38");	

	s8 = "||token1|token2|token3||token4|token5||";
	TEST_ENSHURE( s8.getTokenCount('|') == 10, "test_OString error 39a");	
	TEST_ENSHURE( s8.getToken(10,'|') == "", "test_OString error 40a");	

	s8 = "token1";
	TEST_ENSHURE( s8.getTokenCount('|') == 1, "test_OString error 39b");	
	TEST_ENSHURE( s8.getToken(0,'|') == "token1", "test_OString error 40b");	
	TEST_ENSHURE( s8.getToken(-1,'|') == "", "test_OString error 40c");	
	TEST_ENSHURE( s8.getToken(1,'|') == "", "test_OString error 40d");	

	s8 = "|hallo1|hallo2|hallo3|hallo4|hallo5|hallo6|hallo7|hallo8|";
	TEST_ENSHURE( s8.getTokenCount('|') == 10, "test_OString error 39");	
	TEST_ENSHURE( s8.getToken(3,'|') == "hallo3", "test_OString error 40");	

	char* Tokens[10] = { "", "hallo1", "hallo2", "hallo3", "hallo4",
						 "hallo5", "hallo6", "hallo7", "hallo8", "" };
	
	for (sal_Int32 i = 0; i < s8.getTokenCount('|'); i++)
	{
		TEST_ENSHURE( s8.getToken(i,'|') == Tokens[i], "test_OString error 40e");	
	}

	s7 = "";
	s7 += s8;
	TEST_ENSHURE( s7 == s8, "test_OString error 41");	

	s7 = s8.replaceAt(8, 6, "mmmmmmmmmm");	
	TEST_ENSHURE( s7.getLength() == 61, "test_OString error 42");	

	s8 = s7.replaceAt(8, 11, "");	
	TEST_ENSHURE( s8.getLength() == 50, "test_OString error 43");	

	s7 = s8.replaceAt(8, 0, "hallo2|");	
	TEST_ENSHURE( s7.getLength() == 57, "test_OString error 44");	

	sal_Int32 pos = 0;
	while ((pos = s7.indexOf("|")) >= 0)
	{
		s8 = s7.replaceAt(pos, 1, "**");
		s7 = s8;
	}	
	TEST_ENSHURE( s7.getLength() == 66, "test_OString error 45");	

	TEST_ENSHURE( OString( "aaa" ).compareTo( OString( "bbb" ) ) < 0, "test_OString error 46" );
	TEST_ENSHURE( OString( "aaa" ).compareTo( OString( "aaa" ) ) == 0, "test_OString error 47" );
	TEST_ENSHURE( OString( "bbb" ).compareTo( OString( "aaa" ) ) > 0, "test_OString error 48" );
	TEST_ENSHURE( OString( "aaaa" ).compareTo( OString( "bbb" ) ) < 0, "test_OString error 49" );
	TEST_ENSHURE( OString( "aaa" ).compareTo( OString( "bbbb" ) ) < 0, "test_OString error 50" );
	TEST_ENSHURE( OString( "aaa" ).compareTo( OString( "aaaa" ) ) < 0, "test_OString error 51" );
	TEST_ENSHURE( OString( "aaaa" ).compareTo( OString( "aaa" ) ) > 0, "test_OString error 52" );
	TEST_ENSHURE( OString( "bbbb" ).compareTo( OString( "bbb" ) ) > 0, "test_OString error 53" );
	TEST_ENSHURE( OString( "bbb" ) == OString( "bbb" ), "test_OString error 54" );
	TEST_ENSHURE( OString( "bbb" ) == "bbb", "test_OString error 55" );

	s7 = "Hallo jetzt komm ich";
	s8 = s7.copy(0, s7.indexOf(':'));
	TEST_ENSHURE( s8.getLength() == 0, "test_OString error 56");			
	TEST_ENSHURE( s8.compareTo("") == 0, "test_OString error 57");			

	printf("test_OString OK !!!\n");
	return;
}


