/*************************************************************************
 *
 *  $RCSfile: textenc.c,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:17:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _RTL_TEXTENC_C

#ifndef _RTL_TENCHELP_H
#include <tenchelp.h>
#endif

/* ======================================================================= */

#include <tcvtuni1.tab>
#include <tcvtlat1.tab>
#include <tcvtest1.tab>
#include <tcvtarb1.tab>
#include <tcvteas1.tab>
#include <tcvtsym1.tab>
#include <tcvtmb1.tab>
#include <tcvtjp1.tab>
#include <tcvtjp2.tab>
#include <tcvtjp3.tab>
#include <tcvtjp4.tab>
#include <tcvtjp5.tab>
#include <tcvtjp6.tab>
#include <tcvtscn1.tab>
#include <tcvtscn2.tab>
#include <tcvtscn3.tab>
#include <tcvtscn4.tab>
#include <tcvtscn5.tab>
#include <tcvtscn6.tab>
#include <tcvttcn1.tab>
#include <tcvttcn2.tab>
#include <tcvttcn3.tab>
#include <tcvttcn4.tab>
#include <tcvttcn5.tab>
#include <tcvttcn6.tab>
#include <tcvtkr1.tab>
#include <tcvtkr2.tab>
#include <tcvtkr3.tab>
#include <tcvtkr4.tab>
#include <tcvtkr5.tab>
#include <tcvtkr6.tab>

/* ======================================================================= */

static const ImplTextEncodingData* const aImplTextEncodingDataTab[RTL_TEXTENCODING_STD_COUNT] =
{
	NULL,										/* RTL_TEXTENCODING_DONTKNOW */
	&aImplMS1252TextEncodingData,				/* RTL_TEXTENCODING_MS_1252 */
	&aImplAPPLEROMANTextEncodingData,			/* RTL_TEXTENCODING_APPLE_ROMAN */
	&aImplIBM437TextEncodingData,				/* RTL_TEXTENCODING_IBM_437 */
	&aImplIBM850TextEncodingData,				/* RTL_TEXTENCODING_IBM_850 */
	&aImplIBM860TextEncodingData,				/* RTL_TEXTENCODING_IBM_860 */
	&aImplIBM861TextEncodingData,				/* RTL_TEXTENCODING_IBM_861 */
	&aImplIBM863TextEncodingData,				/* RTL_TEXTENCODING_IBM_863 */
	&aImplIBM865TextEncodingData,				/* RTL_TEXTENCODING_IBM_865 */
	NULL,										/* Reserved: RTL_TEXTENCODING_SYSTEM */
	&aImplSYMBOLTextEncodingData,				/* RTL_TEXTENCODING_SYMBOL */
	&aImplUSASCIITextEncodingData,				/* RTL_TEXTENCODING_ASCII_US */
	&aImplISO88591TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_1 */
	&aImplISO88592TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_2 */
	&aImplISO88593TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_3 */
	&aImplISO88594TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_4 */
	&aImplISO88595TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_5 */
	&aImplISO88596TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_6 */
	&aImplISO88597TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_7 */
	&aImplISO88598TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_8 */
	&aImplISO88599TextEncodingData, 			/* RTL_TEXTENCODING_ISO_8859_9 */
	&aImplISO885914TextEncodingData,			/* RTL_TEXTENCODING_ISO_8859_14 */
	&aImplISO885915TextEncodingData,			/* RTL_TEXTENCODING_ISO_8859_15 */
	&aImplIBM737TextEncodingData,				/* RTL_TEXTENCODING_IBM_737 */
	&aImplIBM775TextEncodingData,				/* RTL_TEXTENCODING_IBM_775 */
	&aImplIBM852TextEncodingData,				/* RTL_TEXTENCODING_IBM_852 */
	&aImplIBM855TextEncodingData,				/* RTL_TEXTENCODING_IBM_855 */
	&aImplIBM857TextEncodingData,				/* RTL_TEXTENCODING_IBM_857 */
	&aImplIBM862TextEncodingData,				/* RTL_TEXTENCODING_IBM_862 */
	&aImplIBM864TextEncodingData,				/* RTL_TEXTENCODING_IBM_864 */
	&aImplIBM866TextEncodingData,				/* RTL_TEXTENCODING_IBM_866 */
	&aImplIBM869TextEncodingData,				/* RTL_TEXTENCODING_IBM_869 */
	&aImplMS874TextEncodingData,				/* RTL_TEXTENCODING_MS_874 */
	&aImplMS1250TextEncodingData,				/* RTL_TEXTENCODING_MS_1250 */
	&aImplMS1251TextEncodingData,				/* RTL_TEXTENCODING_MS_1251 */
	&aImplMS1253TextEncodingData,				/* RTL_TEXTENCODING_MS_1253 */
	&aImplMS1254TextEncodingData,				/* RTL_TEXTENCODING_MS_1254 */
	&aImplMS1255TextEncodingData,				/* RTL_TEXTENCODING_MS_1255 */
	&aImplMS1256TextEncodingData,				/* RTL_TEXTENCODING_MS_1256 */
	&aImplMS1257TextEncodingData,				/* RTL_TEXTENCODING_MS_1257 */
	&aImplMS1258TextEncodingData,				/* RTL_TEXTENCODING_MS_1258 */
	NULL,										/* RTL_TEXTENCODING_APPLE_ARABIC */
	&aImplAPPLECENTEUROTextEncodingData,		/* RTL_TEXTENCODING_APPLE_CENTEURO */
	&aImplAPPLECROATIANTextEncodingData,		/* RTL_TEXTENCODING_APPLE_CROATIAN */
	&aImplAPPLECYRILLICTextEncodingData,		/* RTL_TEXTENCODING_APPLE_CYRILLIC */
	NULL,										/* RTL_TEXTENCODING_APPLE_DEVANAGARI */
	NULL,										/* RTL_TEXTENCODING_APPLE_FARSI */
	&aImplAPPLEGREEKTextEncodingData,			/* RTL_TEXTENCODING_APPLE_GREEK */
	NULL,										/* RTL_TEXTENCODING_APPLE_GUJARATI */
	NULL,										/* RTL_TEXTENCODING_APPLE_GURMUKHI */
	NULL,										/* RTL_TEXTENCODING_APPLE_HEBREW */
	&aImplAPPLEICELANDTextEncodingData, 		/* RTL_TEXTENCODING_APPLE_ICELAND */
	&aImplAPPLEROMANIANTextEncodingData,		/* RTL_TEXTENCODING_APPLE_ROMANIAN */
	NULL,										/* RTL_TEXTENCODING_APPLE_THAI */
	&aImplAPPLETURKISHTextEncodingData, 		/* RTL_TEXTENCODING_APPLE_TURKISH */
	&aImplAPPLEUKRAINIANTextEncodingData,		/* RTL_TEXTENCODING_APPLE_UKRAINIAN */
	&aImplAPPLECHINSIMPTextEncodingData,		/* RTL_TEXTENCODING_APPLE_CHINSIMP */
	&aImplAPPLECHINTRADTextEncodingData,		/* RTL_TEXTENCODING_APPLE_CHINTRAD */
	&aImplAPPLEJAPANESETextEncodingData,		/* RTL_TEXTENCODING_APPLE_JAPANESE */
	&aImplAPPLEKOREANTextEncodingData,			/* RTL_TEXTENCODING_APPLE_KOREAN */
	&aImplMS932TextEncodingData,				/* RTL_TEXTENCODING_MS_932 */
	&aImplMS936TextEncodingData,				/* RTL_TEXTENCODING_MS_936 */
	&aImplMS949TextEncodingData,				/* RTL_TEXTENCODING_MS_949 */
	&aImplMS950TextEncodingData,				/* RTL_TEXTENCODING_MS_950 */
	&aImplSJISTextEncodingData, 				/* RTL_TEXTENCODING_SHIFT_JIS */
	&aImplGB2312TextEncodingData,				/* RTL_TEXTENCODING_GB_2312 */
	&aImplGBT12345TextEncodingData, 			/* RTL_TEXTENCODING_GBT_12345 */
	&aImplGBKTextEncodingData,					/* RTL_TEXTENCODING_GBK */
	&aImplBIG5TextEncodingData, 				/* RTL_TEXTENCODING_BIG5 */
	&aImplEUCJPTextEncodingData,				/* RTL_TEXTENCODING_EUC_JP */
	&aImplEUCCNTextEncodingData,				/* RTL_TEXTENCODING_EUC_CN */
	NULL,										/* RTL_TEXTENCODING_EUC_TW */
	NULL,										/* RTL_TEXTENCODING_ISO_2022_JP */
	NULL,										/* RTL_TEXTENCODING_ISO_2022_CN */
	&aImplKOI8RTextEncodingData,				/* RTL_TEXTENCODING_KOI8_R */
	&aImplUTF7TextEncodingData, 				/* RTL_TEXTENCODING_UTF7 */
	&aImplUTF8TextEncodingData, 				/* RTL_TEXTENCODING_UTF8 */
	&aImplISO885910TextEncodingData,			/* RTL_TEXTENCODING_ISO_8859_10 */
	&aImplISO885913TextEncodingData,			/* RTL_TEXTENCODING_ISO_8859_13 */
	&aImplEUCKRTextEncodingData,				/* RTL_TEXTENCODING_EUC_KR */
	NULL,										/* RTL_TEXTENCODING_ISO_2022_KR */
	&aImplJISX0201TextEncodingData, 			/* RTL_TEXTENCODING_JIS_X_0201 */
	&aImplJISX0208TextEncodingData, 			/* RTL_TEXTENCODING_JIS_X_0208 */
	&aImplJISX0212TextEncodingData				/* RTL_TEXTENCODING_JIS_X_0212 */
};

/* ======================================================================= */

const ImplTextEncodingData* Impl_getTextEncodingData( rtl_TextEncoding eTextEncoding )
{
	if ( eTextEncoding < RTL_TEXTENCODING_STD_COUNT )
		return aImplTextEncodingDataTab[eTextEncoding];
	else
		return NULL;
}

