/*************************************************************************
 *
 *  $RCSfile: readchrt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>

#include <tools/stack.hxx>
#include "scerrors.hxx"

#include "imp_op.hxx"
#include "excimp8.hxx"
#include "fltprgrs.hxx"
#include "excchart.hxx"


//enum STATE { S0_Root, S1_Chart, S2_Frame, S2_Series, S3_SeriesDataformat, S2_Text, S2_Dataformat,
//			S2_Axisparent, S3_ApAxis, S3_ApText, S3_ApFrame, S3_ApChartformat,
//			S4_ApCfLegend, S4_ApCfDropbar, S5_ApCfLText, S4_ApCfText, S4_ApCfDataformat,
//			S0_Error, Sx_Unknown, Sx_Begin, Sx_Error };
//
//
//
//class StateStack : protected Stack
//{
//public:
//	Stack::Clear;
//	Stack::Count;
//
//	inline void		Push( const STATE eState );
//	inline STATE	Pop( void );
//	inline STATE	Top( void ) const;
//};
//
//
//inline void StateStack::Push( const STATE e )
//{
//	Stack::Push( ( void* ) e );
//}
//
//
//inline STATE StateStack::Pop( void )
//{
//	return ( STATE ) ( ULONG ) Stack::Pop();
//}
//
//
//inline STATE StateStack::Top( void ) const
//{
//	return ( STATE ) ( ULONG ) Stack::Top();
//}




FltError ImportExcel8::ReadChart8( FilterProgressBar& rPrgrs, const UINT32 nLimitPos, const BOOL bOwnTab )
{
	UINT16				nOpcode;			// aktueller Opcode
	UINT16				nLaengeRec;			// Laenge aktueller Record
	UINT32				nNextRecord;		// Stream-Pos des naechsten Records

	pActChart = GetActChartData();
	if( !pActChart )
	{
		nNextRecord = aIn.Tell();

		do
		{
			aIn >> nOpcode >> nLaengeRec;
			if( aIn.IsEof() )
				break;

			nNextRecord += 4;
			nNextRecord += nLaengeRec;

			if( nNextRecord > nLimitPos )
				break;

			rPrgrs.Progress();

			aIn.Seek( nNextRecord );
		}
		while( nOpcode != 0x0A );		// EOF

		return eERR_OK;
	}

	FltError			eLastErr = eERR_OK;
	BOOL				bLoop = TRUE;

//	STATE				e = S0_Root;
//	STATE				eNext = Sx_Unknown;
//
//	StateStack			aStateStack;
//	aStateStack.Push( S0_Error );
//
//#define	NEWBEGIN(st)	aStateStack.Push( e ); e = Sx_Begin; eNext = st

	nNextRecord = aIn.Tell();

	while( bLoop )
	{
		aIn >> nOpcode >> nLaengeRec;
		if( aIn.IsEof() )
			bLoop = FALSE;

		nBytesLeft = nLaengeRec;
		nNextRecord += 4;
		nNextRecord += nLaengeRec;			// alles klar zum Seeken

		if( nNextRecord > nLimitPos )		// Notbremse fuer Bug #52321!
			bLoop = FALSE;

		rPrgrs.Progress();

		switch( nOpcode )
		{
			case 0x000A:	bLoop = FALSE;						break;	// EOF
			case 0x0014:	Header();							break;	// HEADER
			case 0x0015:	Footer();							break;	// FOOTER
			case 0x0026:	Leftmargin();						break;	// LEFTMARGIN
			case 0x0027:	Rightmargin();						break;	// RIGHTMARGIN
			case 0x0028:	Topmargin();						break;	// TOPMARGIN
			case 0x0029:	Bottommargin();						break;	// BOTTOMMARGIN
			case 0x002A:	Printheaders();						break;	// PRINTHEADERS
			case 0x00A0:	ChartScl();							break;	// SCL
			case 0x00A1:	if( bOwnTab ) Setup();				break;	// SETUP
			case 0x1002:	ChartChart();						break;	// CHART
			case 0x1003:	ChartSeries();						break;	// SERIES
			case 0x1006:	ChartDataformat();					break;	// DATAFORMAT
			case 0x1007:	ChartLineformat();					break;	// LINEFORMAT
			case 0x1009:	ChartMarkerformat();				break;	// MARKERFORMAT
			case 0x100A:	ChartAreaformat();					break;	// AREAFORMAT
			case 0x100B:	ChartPieformat();					break;	// PIEFORMAT
			case 0x100D:	ChartSeriestext();					break;	// SERIESTEXT
			case 0x1014:	ChartChartformat();					break;	// CHARTFORMAT
			case 0x1015:	ChartLegend();						break;	// LEGEND
			case 0x1017:	ChartBar();							break;	// BAR
			case 0x1018:	ChartLine();						break;	// LINE
			case 0x1019:	ChartPie();							break;	// PIE
			case 0x101A:	ChartArea();						break;	// AREA
			case 0x101B:	ChartScatter();						break;	// SCATTER
			case 0x101D:	ChartAxis();						break;	// AXIS
			case 0x101E:	ChartTick();						break;	// TICK
			case 0x101F:	ChartValuerange();					break;	// VALUERANGE
			case 0x1020:	ChartCatserrange();					break;	// CATSERRANGE
			case 0x1021:	ChartAxislineformat();				break;	// AXISLINEFORMAT
			case 0x1024:	ChartDefaulttext();					break;	// DEFAULTTEXT
			case 0x1025:	ChartText();						break;	// TEXT
			case 0x1026:	ChartFontx();						break;	// FONTX
			case 0x1027:	ChartObjectlink();					break;	// OBJECTLINK
			case 0x1032:	ChartFrame();						break;	// FRAME
			case 0x1033:	pActChart->ReadChartBegin();		break;	// BEGIN
			case 0x1034:	pActChart->ReadChartEnd();			break;	// END
			case 0x103A:	Chart3D();							break;	// 3D
			case 0x103D:	ChartDropbar();						break;	// DROPBAR
			case 0x103E:	ChartRadar();						break;	// RADAR
			case 0x103F:	ChartSurface();						break;	// SURFACE
			case 0x1041:	ChartAxisparent();					break;	// AXISPARENT
			case 0x1044:	ChartShtprops();					break;	// SHTPROPS
			case 0x1045:	ChartSertocrt();					break;	// SERTOCRT
			case 0x1046:	ChartAxesused();					break;	// AXESUSED
			case 0x104E:	ChartIfmt();						break;	// IFMT
			case 0x104F:	ChartPos();							break;	// POS
			case 0x1051:	ChartAi();							break;	// AI
			case 0x105F:	Chart3DDataformat();				break;	// 3DDATAFORMAT
			case 0x1060:	ChartFbi();							break;	// FBI
			case 0x1062:	ChartAxcext();						break;	// AXCEXT
			case 0x1064:	ChartPlotgrowth();					break;	// PLOTGROWTH
		}

//		if( nOpcode == 0x0A )									// EOF
//			bLoop = FALSE;
//		else if( nOpcode == 0x1034 )							// END
//		{
//			e = aStateStack.Pop();
//			pActChart->ReadChartEnd();
//		}
//		else if( nOpcode == 0x1033 && e != Sx_Begin )			// BEGIN
//		{
//			aStateStack.Push( e );
//			e = Sx_Unknown;
//			pActChart->ReadChartBegin();
//		}
//		else
//		{
//			switch( e )
//			{
//				case S0_Root:
//					switch( nOpcode )
//					{
//						case 0xA1:							// SETUP
//							if( bOwnTab )
//								Setup();
//							break;
//						case 0x14:	Header(); break;		// HEADER
//						case 0x15:	Footer(); break;		// FOOTER
//						case 0x26:	Leftmargin(); break;	// LEFTMARGIN
//						case 0x27:	Rightmargin(); break;	// RIGHTMARGIN
//						case 0x28:	Topmargin(); break;		// TOPMARGIN
//						case 0x29:	Bottommargin(); break;	// BOTTOMMARGIN
//						case 0x2A:	Printheaders(); break;	// PRINTHEADERS
//						case 0x1002:	ChartChart();		NEWBEGIN( S1_Chart );	break;
//						case 0x1060:	ChartFbi();									break;
//					}
//					break;
//				case S1_Chart:
//					switch( nOpcode )
//					{
//						case 0x00A0:	ChartScl();								break;
//						case 0x1003:	ChartSeries();		NEWBEGIN( S2_Series );		break;
//						case 0x1024:	ChartDefaulttext();								break;
//						case 0x1025:	ChartText();		NEWBEGIN( S2_Text );		break;
//						case 0x1032:	ChartFrame();		NEWBEGIN( S2_Frame );		break;
//						case 0x1041:	ChartAxisparent();	NEWBEGIN( S2_Axisparent );	break;
//						case 0x1044:	ChartShtprops();								break;
//						case 0x1046:	ChartAxesused();								break;
//						case 0x1064:	ChartPlotgrowth();								break;
//					}
//					break;
//				case S2_Frame:
//					switch( nOpcode )
//					{
//						case 0x1007:	ChartLineformat();							break;
//					}
//					break;
//				case S2_Series:
//					switch( nOpcode )
//					{
//						case 0x1006:	ChartDataformat2();	NEWBEGIN( S3_SeriesDataformat );	break;
//						case 0x1051:	ChartAi_2_Series();										break;
//						case 0x1045:	ChartSertocrt();										break;
//					}
//					break;
//				case S3_SeriesDataformat:
//					switch( nOpcode )
//					{
//						case 0x1007:	ChartLineformat2();							break;
//						case 0x1009:	ChartMarkerformat2();						break;
//						case 0x100A:	ChartAreaformat2();							break;
//						case 0x105F:	Chart3DDataForm();							break;
//					}
//					break;
//				case S2_Text:
//					switch( nOpcode )
//					{
//						case 0x100A:	ChartAreaformat();							break;
//						case 0x100D:	ChartSeriestext();							break;
//						case 0x1026:	ChartFontx();								break;
//						case 0x1027:	ChartObjectlink();							break;
//						case 0x104F:	ChartPos();									break;
//						case 0x1051:	ChartAi();									break;
//					}
//					break;
//				case S2_Dataformat:
//					break;
//				case S2_Axisparent:
//					switch( nOpcode )
//					{
//						case 0x1014:	ChartChartformat();	NEWBEGIN( S3_ApChartformat );	break;
//						case 0x101D:	ChartAxis();		NEWBEGIN( S3_ApAxis );			break;
//						case 0x1025:	ChartText();		NEWBEGIN( S3_ApText );			break;
//						case 0x1032:	ChartFrame();		NEWBEGIN( S3_ApFrame );			break;
//						case 0x104F:	ChartPos();											break;
//					}
//					break;
//				case S3_ApAxis:
//					switch( nOpcode )
//					{
//						case 0x1007:	ChartLineformat();							break;
//						case 0x101E:	ChartTick();								break;
//						case 0x101F:	ChartValuerange();							break;
//						case 0x1020:	ChartCatserrange();							break;
//						case 0x1021:	ChartAxislineformat();						break;
//						case 0x104E:	ChartIfmt();								break;
//						case 0x1062:	ChartAxcext();								break;
//					}
//					break;
//				case S3_ApText:
//					switch( nOpcode )
//					{
//						case 0x100D:	ChartSeriestext();							break;
//						case 0x1026:	ChartFontx();								break;
//						case 0x1027:	ChartObjectlink();							break;
//						case 0x104F:	ChartPos();									break;
//						case 0x1051:	ChartAi();									break;
//					}
//					break;
//				case S3_ApFrame:
//					switch( nOpcode )
//					{
//						case 0x1007:	ChartLineformat();							break;
//						case 0x100A:	ChartAreaformat1();							break;
//					}
//					break;
//				case S3_ApChartformat:
//					switch( nOpcode )
//					{
//						case 0x1006:	ChartDataformat();	NEWBEGIN( S4_ApCfDataformat );	break;
//						case 0x1015:	ChartLegend();		NEWBEGIN( S4_ApCfLegend );		break;
//						case 0x1017:	ChartBar();											break;
//						case 0x1018:	ChartLine();										break;
//						case 0x1019:	ChartPie();											break;
//						case 0x101A:	ChartArea();										break;
//						case 0x101B:	ChartScatter();										break;
//						case 0x1022:	break;	// Chartformatlink
//						case 0x1024:	ChartDefaulttext();									break;
//						case 0x1025:	ChartText();		NEWBEGIN( S4_ApCfText );		break;
//						case 0x103A:	Chart3D();											break;
//						case 0x103D:	ChartDropbar();		NEWBEGIN( S4_ApCfDropbar );		break;
//						case 0x103E:	ChartRadar();										break;
//						case 0x103F:	ChartSurface();										break;
//					}
//					break;
//				case S4_ApCfLegend:
//					switch( nOpcode )
//					{
//						case 0x1025:	ChartText();		NEWBEGIN( S5_ApCfLText );	break;
//						case 0x104F:	ChartPos();										break;
//					}
//					break;
//				case S4_ApCfDropbar:
//					switch( nOpcode )
//					{
//						case 0x1007:	ChartLineformat3();							break;
//						case 0x100A:	ChartAreaformat3();							break;
//					}
//					break;
//				case S5_ApCfLText:
//					switch( nOpcode )
//					{
//						case 0x104F:	ChartPos();									break;
//						case 0x1051:	ChartAi();									break;
//					}
//					break;
//				case S4_ApCfText:
//					switch( nOpcode )
//					{
//						case 0x104F:	ChartPos();									break;
//						case 0x1051:	ChartAi();									break;
//					}
//					break;
//				case S4_ApCfDataformat:
//					switch( nOpcode )
//					{
//						case 0x1009:	ChartMarkerformat();						break;
//						case 0x100B:	ChartPieformat();							break;
//					}
//					break;
//				case S0_Error:
//					eLastErr = SCERR_IMPORT_FORMAT;
//					bLoop = FALSE;
//					break;
//				case Sx_Begin:
//					if( nOpcode == 0x1033 )
//						e = eNext;
//					else
//						e = Sx_Error;
//					break;
//			}
//		}
		aIn.Seek( nNextRecord );		// zum naechsten Record
	}

	if( pActEscherObj )
	{
		aEscherObjList.Append( pActEscherObj );
		pActEscherObj = NULL;
	}

	EndChartObj();

	return eLastErr;

#undef NEWBEGIN
}

