/*************************************************************************
 *
 *  $RCSfile: flttools.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/



#ifndef _FLTTOOLS_HXX
#define _FLTTOOLS_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef _LIST_HXX
#include <tools/list.hxx>
#endif


enum IMPEXC_MARGINSIDE { IMPEXC_MARGINSIDE_TOP, IMPEXC_MARGINSIDE_RIGHT,
	IMPEXC_MARGINSIDE_BOTTOM, IMPEXC_MARGINSIDE_LEFT };


#define TRUEBOOL(expr)		((expr)!=0)
#define _STRING(p)			String::CreateFromAscii(p)
#define _STRINGCONST(s)		String(RTL_CONSTASCII_STRINGPARAM(s))


class ShStrTabEntry;
class SvStream;
class UINT32List;
class ScDocument;

extern const sal_Char*	GetExcBuiltInName( sal_Unicode nIndex );

extern CharSet			GetSystemCharSet( void );

extern ShStrTabEntry*	CreateUnicodeEntry( SvStream& rIn, INT32& rBytesLeft,
											CharSet eSrcCharSet,
											const UINT16 nPreLen = 0, UINT32List* pCutPosList = NULL );

extern String			ReadUnicodeString( SvStream& rIn, INT32& rBytesLeft,
											CharSet eSrcCharSet,
											const UINT16 nPreLen = 0 );

extern void				SkipUnicodeString( SvStream& rIn, INT32& rBytesLeft, const UINT16 nPreLen = 0 );

extern void				EncodeExternSheet( SvStream& rIn, String& rFile, String& rTabName,
											INT32& rBytesLeft, BOOL& rSameWorkbook, UINT16 nLen, BOOL b16Bit );

extern void				EncodeExternSheetUnicode( SvStream& rIn, String& rFile, String& rTabName,
											INT32& rBytesLeft, BOOL& rSameWorkbook, UINT16 nPreLen = 0 );

extern String			ScGetHexStr( UINT16 nValue );

						// Excel-Anchor -> Calc-Twips
extern long				CalcX( const UINT16 nTab, const UINT16 nCol, const UINT16 nOffsetCol,
									const double fScale, ScDocument* pDoc );
extern long				CalcY( const UINT16 nTab, const UINT16 nRow, const UINT16 nOffsetRow,
									const double fScale, ScDocument* pDoc );




class UINT16List : protected List
{
private:
protected:
public:
	List::Count;
	List::Clear;

	inline void			Append( const UINT16 nVal );

	inline UINT16		First( void );	// !0 zeigt auch hier Nicht-Verfuegbarkeit an!
	inline UINT16		Next( void );

	inline UINT16		Get( const UINT32 nIndex ) const;
};




class UINT32List : protected List
{
private:
protected:
public:
	List::Count;
	List::Clear;

	inline void			Append( const UINT32 nVal );

	inline UINT32		First( void );	// !0 zeigt auch hier Nicht-Verfuegbarkeit an!
	inline UINT32		Next( void );

	inline UINT32		Get( const UINT32 nIndex ) const;
};




inline void UINT16List::Append( const UINT16 n )
{
	List::Insert( ( void* ) n, LIST_APPEND );
}


inline UINT16 UINT16List::First( void )
{
	return ( UINT16 ) ( unsigned long ) List::First();
}


inline UINT16 UINT16List::Next( void )
{
	return ( UINT16 ) ( unsigned long ) List::Next();
}


inline UINT16 UINT16List::Get( const UINT32 n ) const
{
	return ( UINT16 ) ( unsigned long ) List::GetObject( n );
}




inline void UINT32List::Append( const UINT32 n )
{
	List::Insert( ( void* ) n, LIST_APPEND );
}


inline UINT32 UINT32List::First( void )
{
	return ( UINT32 ) List::First();
}


inline UINT32 UINT32List::Next( void )
{
	return ( UINT32 ) List::Next();
}


inline UINT32 UINT32List::Get( const UINT32 n ) const
{
	return ( UINT32 ) List::GetObject( n );
}




#endif

