/*************************************************************************
 *
 *  $RCSfile: xfbuff.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _XFBUFF_HXX
#define _XFBUFF_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
#ifndef SC_SCPATATR_HXX
#include <patattr.hxx>
#endif
#ifndef SC_ITEMS_HXX
#include <scitems.hxx>
#endif

#ifndef _ROOT_HXX
#include "root.hxx"
#endif


struct RootData;
class ScPatternAttr;
class ScDocument;
class SvxBorderLine;




enum ExcHorizAlign { EHA_General = 0, EHA_Left = 1, EHA_Center = 2,
	EHA_Right = 3, EHA_Fill = 4, EHA_Justify = 5, EHA_CentAcrSel = 6,
	EHA_Parent };

enum ExcVertAlign { EVA_Top = 0, EVA_Center = 1, EVA_Bottom = 2,
	EVA_Justify = 3, EVA_Parent };

enum ExcTextOrient { ETO_NoRot = 0, ETO_TopBottom = 1, ETO_90ccw = 2,
	ETO_90cw = 3, ETO_Parent, ETO_Rot };

enum ExcWrapText { EWT_NoWrap = 0, EWT_Wrap = 1, EWT_Parent };




struct CellBorder
{
	UINT16						nTopColor;
	UINT16						nLeftColor;
	UINT16						nBottomColor;
	UINT16						nRightColor;
	BYTE						nTopLine;
	BYTE						nLeftLine;
	BYTE						nBottomLine;
	BYTE						nRightLine;
};




struct CellFill
{
	UINT16						nForeColor;
	UINT16						nBackColor;
	BYTE						nPattern;
};




class XF_Data
{
private:
	CellFill*					pFill;
	CellBorder*					pBord;
	UINT32						nValForm;		// Id fuer Value-Format
	ExcWrapText					eWrap;
	ExcHorizAlign				eHoriz;
	ExcVertAlign				eVert;

	ExcTextOrient				eTextOrient;
	UINT8						nRotation;
	UINT16						nIndent;

	UINT16						nFont;			// Index auf zugehoerigen Font
	UINT16						nParent;		// Index zum Parent Style-XF
	BOOL						bCellXF : 1;	// Cell- oder Style-XF
	BOOL						bLocked : 1;
	BOOL						bHidden : 1;
	BOOL						bFormValid : 1;	// nValForm <> ValueForm vom Parent?
	BOOL						bFontValid : 1;	// nFont <> Font vom Parent?
	BOOL						bProtValid : 1;	// bLocked oder bHidden
											//  <> Parent-Gedoens?
	BOOL						bMerged : 1;
public:
								XF_Data( void );
								~XF_Data();

	inline BOOL					IsCellXF( void ) const;
	inline void					SetCellXF( void );
	inline void					SetCellXF( BOOL );
	inline void					SetStyleXF( void );

	inline BOOL					HasFont( void ) const;
	inline UINT16				Font( void ) const;
	inline void					SetFont( UINT16 );

	inline BOOL					HasValueFormat( void ) const;
	inline UINT32				ValueFormat( void ) const;
	inline void					SetValueFormat( UINT32 );

	inline BOOL					HasProt( void ) const;

	inline BOOL					IsLocked( void ) const;
	inline void					SetLocked( void );
	inline void					SetUnlocked( void );
	inline void					SetLocked( BOOL );

	inline BOOL					IsHidden( void ) const;
	inline void					SetHidden( void );
	inline void					SetVisible( void );
	inline void					SetHidden( BOOL );

	inline BOOL					HasWrap( void ) const;
	inline void					SetWrap( void );
	inline void					SetWrap( ExcWrapText );
	inline ExcWrapText			Wrap( void ) const;

	inline BOOL					HasHorizAlign( void ) const;
	inline void					SetAlign( ExcHorizAlign );
	inline ExcHorizAlign		HorizAlign( void ) const;

	inline BOOL					HasVertAlign( void ) const;
	inline void					SetAlign( ExcVertAlign );
	inline ExcVertAlign			VertAlign( void ) const;

	inline BOOL					HasTextOrient( void ) const;
	inline void					SetTextOrient( ExcTextOrient );
	inline ExcTextOrient		TextOrient( void ) const;
	inline void					SetTextOrient( const UINT8 nExcRot );
	inline UINT8				GetTextRotation( void ) const;

	inline BOOL					HasIndent( void ) const;
	inline void					SetIndent( const UINT16 nExcVal );
	inline UINT16				GetIndent( void ) const;

	inline void					SetParent( UINT16 );
	inline UINT16				Parent( void ) const;

	inline BOOL					HasFill( void ) const;
	void						SetFill( CellFill* );
	void						SetFill( const CellFill& );
	void						SetFill( BYTE nPattern, UINT16 nForeColor, UINT16 nBackColor );
	inline const CellFill*		Fill( void ) const;

	inline BOOL					HasBorder( void ) const;
	void						SetBorder( CellBorder* );
	void						SetBorder( const CellBorder& );
	void						SetBorder( BYTE nTopLine, BYTE nLeftLine,
											BYTE nBottomLine, BYTE nRightLine,
											UINT16 nTopColor, UINT16 nLeftColor,
											UINT16 nBottomColor, UINT16 nRightColor );
	inline const CellBorder*	Border( void ) const;

	inline void					Merge( void );
	inline BOOL					HasMerge( void ) const;
};




class XF_Buffer : private List, public ExcRoot
{
private:
struct ENTRY
{
	ScPatternAttr*			pPattern;
	XF_Data*				pData;
							ENTRY( void )						{ pPattern = NULL; pData = NULL; }
							ENTRY( ScPatternAttr& rPattAttr )	{ pPattern = &rPattAttr; pData = NULL; }
							ENTRY( XF_Data& rData )				{ pPattern = NULL; pData = &rData; }
							ENTRY( ScPatternAttr& rPattAttr, XF_Data& rData )
								{ pPattern = &rPattAttr; pData = &rData; }
							~ENTRY()
							{
								if( pPattern ) delete pPattern;
								if( pData ) delete pData;
							}
};

	ENTRY					aDefEntry;
	static const UINT16		nIndentFact;
	static void				ExcToScBorderLine( BYTE nLine, UINT16 nColor, SvxBorderLine*&, ColorBuffer& );
	void					CellXF( XF_Data& );
	void					StyleXF( XF_Data& rD );
	ScPatternAttr*			CreatePattern( UINT16 nIndex );
public:
							XF_Buffer( RootData* pRD );
							~XF_Buffer();

	inline void				NewXF( XF_Data* );
	ScPatternAttr&			GetPattern( UINT16 );
	inline UINT16			GetExcFont( UINT16 );

	void					Reset( void );

	inline const XF_Data*	GetXF( const UINT32 nIndex ) const;

	BOOL					HasAttribSuperOrSubscript( const UINT16 nXFIndex ) const;

	static void				SetBorder( SfxItemSet& rItemSet, ColorBuffer& rColorBuffer,
										const UINT8 nLineLeft, const UINT16 nColLeft,
										const UINT8 nLineRight, const UINT16 nColRight,
										const UINT8 nLineTop, const UINT16 nColTop,
										const UINT8 nLineBottom, const UINT16 nColBottom );
	static void				SetFill( SfxItemSet& rItemSet, ColorBuffer& rColorBuffer,
										const UINT8 nPattern,
										const UINT16 nForeColor, const UINT16 nBackColor );

	void					SetStyle( UINT16 nXFIndex, const String& rStyleName );
};




// --------------------------------------------------------------------------------------

inline BOOL XF_Data::IsCellXF( void ) const
{
	return bCellXF;
}

inline void XF_Data::SetCellXF( void )
{
	bCellXF = TRUE;
}

inline void XF_Data::SetCellXF( BOOL bNewCellXF )
{
	bCellXF = bNewCellXF;
}

inline void XF_Data::SetStyleXF( void )
{
	bCellXF = FALSE;
}

inline BOOL XF_Data::HasFont( void ) const
{
	return bFontValid;
}

inline UINT16 XF_Data::Font( void ) const
{
	return nFont;
}

inline void XF_Data::SetFont( UINT16 nNew )
{
	nFont = nNew;
	bFontValid = TRUE;
}

inline BOOL XF_Data::HasValueFormat( void ) const
{
	return bFormValid;
}

inline UINT32 XF_Data::ValueFormat( void ) const
{
	return nValForm;
}

inline void XF_Data::SetValueFormat( UINT32 nNew )
{
	nValForm=nNew;
	bFormValid=TRUE;
}

inline BOOL XF_Data::HasProt( void ) const
{
	return bProtValid;
}

inline BOOL XF_Data::IsLocked( void ) const
{
	return bLocked;
}

inline void XF_Data::SetLocked( void )
{
	bLocked = bProtValid = TRUE;
}

inline void XF_Data::SetUnlocked( void )
{
	bLocked = FALSE;
	bProtValid = TRUE;
}

inline void XF_Data::SetLocked( BOOL bNew )
{
	bLocked = bNew;
	bProtValid = TRUE;
}

inline BOOL XF_Data::IsHidden( void ) const
{
	return bHidden;
}

inline void XF_Data::SetHidden( void )
{
	bHidden = bProtValid = TRUE;
}

inline void XF_Data::SetVisible( void )
{
	bHidden = FALSE;
	bProtValid = TRUE;
}

inline void XF_Data::SetHidden( BOOL bNew )
{
	bHidden = bNew;
}

inline BOOL XF_Data::HasWrap( void ) const
{
	return ( eWrap != EWT_Parent );
}

inline void XF_Data::SetWrap( void )
{
	eWrap = EWT_Wrap;
}

inline void XF_Data::SetWrap( ExcWrapText eNew )
{
	eWrap = eNew;
}

inline ExcWrapText XF_Data::Wrap( void ) const
{
	return eWrap;
}

inline BOOL XF_Data::HasHorizAlign( void ) const
{
	return eHoriz != EHA_Parent;
}

inline void XF_Data::SetAlign( ExcHorizAlign eNew )
{
	eHoriz = eNew;
}

inline ExcHorizAlign XF_Data::HorizAlign( void ) const
{
	return eHoriz;
}

inline BOOL XF_Data::HasVertAlign( void ) const
{
	return eVert != EVA_Parent;
}

inline void XF_Data::SetAlign( ExcVertAlign eNew )
{
	eVert = eNew;
}

inline ExcVertAlign XF_Data::VertAlign( void ) const
{
	return eVert;
}

inline BOOL XF_Data::HasTextOrient( void ) const
{
	return eTextOrient != ETO_Parent;
}

inline void XF_Data::SetTextOrient( ExcTextOrient eNew )
{
	eTextOrient = eNew;
}

inline ExcTextOrient XF_Data::TextOrient( void ) const
{
	return eTextOrient;
}

inline void XF_Data::SetTextOrient( const UINT8 n )
{
	nRotation = n;
	eTextOrient = ETO_Rot;
}


inline UINT8 XF_Data::GetTextRotation( void ) const
{
	return nRotation;
}


inline BOOL XF_Data::HasIndent( void ) const
{
	return nIndent > 0;
}


inline void XF_Data::SetIndent( const UINT16 n )
{
	nIndent = n;
}


inline UINT16 XF_Data::GetIndent( void ) const
{
	return nIndent;
}


inline void XF_Data::SetParent( UINT16 nNew )
{
	nParent = nNew;
}


inline UINT16 XF_Data::Parent( void ) const
{
	return nParent;
}


inline BOOL XF_Data::HasFill() const
{
	return ( pFill != NULL );
}


inline const CellFill* XF_Data::Fill( void ) const
{
	return pFill;
}


inline BOOL XF_Data::HasBorder( void ) const
{
	return ( pBord != NULL );
}

inline const CellBorder* XF_Data::Border( void ) const
{
	return pBord;
}


inline void XF_Data::Merge( void )
{
	bMerged = TRUE;
}


inline BOOL XF_Data::HasMerge( void ) const
{
	return bMerged;
}




inline void XF_Buffer::NewXF( XF_Data* pD )
{
	// PREC: rD muss in rufender Routine ge-'new'-t werden,
	//			delete im ~XF_Buffer
	DBG_ASSERT( pD, "*XF_Buffer::NewXF() so nicht!" );

	Insert( new ENTRY( *pD ), LIST_APPEND );
}


inline UINT16 XF_Buffer::GetExcFont( UINT16 nIndex )
{
	ENTRY*	pEntry = ( ENTRY* ) GetObject( nIndex );
	UINT16	nRet;

	if( pEntry )
		nRet = pEntry->pData->Font();
	else
		nRet = 0;

	return nRet;
}


inline const XF_Data* XF_Buffer::GetXF( const UINT32 n ) const
{
	const ENTRY*	p = ( const ENTRY* ) GetObject( n );

	if( p )
		return p->pData;
	else
		return NULL;
}





#endif
