/*************************************************************************
 *
 *  $RCSfile: xcl97piv.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop

//_________________________________________________________
//
// xcl97piv.cxx: EXPORT xcl pivot cache and pivot table records
//_________________________________________________________

#include "xcl97piv.hxx"
//_________________________________________________________

// ApproxFloor()
#ifndef _TOOLS_SOLMATH_HXX
#include <tools/solmath.hxx>
#endif
// SvNumberformat
#ifndef _ZFORMAT_HXX
#include <svtools/zformat.hxx>
#endif
// ScAddress, ScRange, GetRscString
#ifndef SC_SCGLOB_HXX
#include "global.hxx"
#endif
// ScDocument
#ifndef SC_DOCUMENT_HXX
#include "document.hxx"
#endif
// ScDPObject, ScDPCollection
#ifndef SC_DPOBJECT_HXX
#include "dpobject.hxx"
#endif
// ScSheetSourceDesc
#ifndef SC_DPSHTTAB_HXX
#include "dpshttab.hxx"
#endif
// ScUnoHelpFunctions
#ifndef SC_MISCUNO_HXX
#include "miscuno.hxx"
#endif
// UINT16List
#ifndef _FLTTOOLS_HXX
#include "flttools.hxx"
#endif
//_________________________________________________________

// global strings
#include "globstr.hrc"
//_________________________________________________________

extern const sal_Char*	pPivotCacheStorageName;
//_________________________________________________________

#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMED_HPP_
#include <com/sun/star/container/XNamed.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_SHEET_XDIMENSIONSSUPPLIER_HPP_
#include <com/sun/star/sheet/XDimensionsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SHEET_XHIERARCHIESSUPPLIER_HPP_
#include <com/sun/star/sheet/XHierarchiesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SHEET_XLEVELSSUPPLIER_HPP_
#include <com/sun/star/sheet/XLevelsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_SHEET_DATAPILOTFIELDORIENTATION_HPP_
#include <com/sun/star/sheet/DataPilotFieldOrientation.hpp>
#endif
#ifndef _COM_SUN_STAR_SHEET_GENERALFUNCTION_HPP_
#include <com/sun/star/sheet/GeneralFunction.hpp>
#endif

#include <vos/xception.hxx>

//_________________________________________________________
//!	move to a header file
#define DP_PROP_COLUMNGRAND			"ColumnGrand"
#define DP_PROP_FUNCTION			"Function"
//#define DP_PROP_IGNOREEMPTY			"IgnoreEmptyRows"
#define DP_PROP_ISDATALAYOUT		"IsDataLayoutDimension"
//#define DP_PROP_ISVISIBLE			"IsVisible"
#define DP_PROP_ORIENTATION			"Orientation"
#define DP_PROP_ORIGINAL			"Original"
#define DP_PROP_POSITION			"Position"
//#define DP_PROP_REPEATIFEMPTY		"RepeatIfEmpty"
#define DP_PROP_ROWGRAND			"RowGrand"
//#define DP_PROP_SHOWDETAILS			"ShowDetails"
#define DP_PROP_SHOWEMPTY			"ShowEmpty"
#define DP_PROP_SUBTOTALS			"SubTotals"
#define DP_PROP_USEDHIERARCHY		"UsedHierarchy"
//_________________________________________________________

// flags for pivot table field orientation
#define PIVOT_AXIS_NONE				0x0000
#define PIVOT_AXIS_ROW				0x0001
#define PIVOT_AXIS_COL				0x0002
#define PIVOT_AXIS_PAGE				0x0004
#define PIVOT_AXIS_DATA				0x0008
#define PIVOT_AXIS_RCP_MASK			(PIVOT_AXIS_ROW|PIVOT_AXIS_COL|PIVOT_AXIS_PAGE)

// misc xcl record flags
#define SXVIEW_COMMON				0x0208
#define SXVIEW_ROWGRAND				0x0001
#define SXVIEW_COLGRAND				0x0002

#define SXVDEX_COMMON				0x0A00141E
#define SXVDEX_SHOWALL				0x00000001

//_________________________________________________________

using namespace com::sun::star;



//============================================================================
// local functions

//_________________________________________________________
// lcl_GetLevelProps() - subtotals, showempty

void lcl_GetLevelProps( XclPivotCacheField& rField,
						const uno::Reference< beans::XPropertySet >& xDimProp )
{
	uno::Reference< sheet::XHierarchiesSupplier > xDimSupp( xDimProp, uno::UNO_QUERY );
	if( xDimProp.is() && xDimSupp.is() )
	{
		uno::Reference< container::XIndexAccess > xHiersAcc =
			new ScNameToIndexAccess( xDimSupp->getHierarchies() );
		long nHierarchy = ScUnoHelpFunctions::GetLongProperty( xDimProp, rtl::OUString::createFromAscii( DP_PROP_USEDHIERARCHY ) );
		if( nHierarchy >= xHiersAcc->getCount() )
			nHierarchy = 0;

		uno::Reference< uno::XInterface > 			xHierInt =
			ScUnoHelpFunctions::AnyToInterface( xHiersAcc->getByIndex( nHierarchy ) );
		uno::Reference< sheet::XLevelsSupplier >	xHierSupp( xHierInt, uno::UNO_QUERY );
		if( xHierInt.is() && xHierSupp.is() )
		{
			uno::Reference< container::XIndexAccess > xLevAcc =
				new ScNameToIndexAccess( xHierSupp->getLevels() );
			uno::Reference< uno::XInterface > xLevInt =
				ScUnoHelpFunctions::AnyToInterface( xLevAcc->getByIndex( 0 ) );
			uno::Reference< beans::XPropertySet > xLevProp( xLevInt, uno::UNO_QUERY );
			if( xLevProp.is() )
			{
				uno::Any aSubAny;
				TRY
				{
					aSubAny = xLevProp->getPropertyValue( rtl::OUString::createFromAscii( DP_PROP_SUBTOTALS ) );
				}
				CATCH_ALL()
				{	}
				END_CATCH

				uno::Sequence< sheet::GeneralFunction > aSeq;
				if( aSubAny >>= aSeq )
				{
					const sheet::GeneralFunction* pArray = aSeq.getConstArray();

					for( long iSubT = 0; iSubT < aSeq.getLength(); iSubT++ )
						rField.AddSubTotal( (UINT16) pArray[iSubT] );
				}

				BOOL bShowAll = ScUnoHelpFunctions::GetBoolProperty( xLevProp, rtl::OUString::createFromAscii( DP_PROP_SHOWEMPTY ) );
				rField.SetShowAll( bShowAll );
			}
		}
	}
}

//_________________________________________________________
// lcl_SetDataFunc() - stores data field function in a cache field

void lcl_GetDataFunc( XclPivotCacheField& rField,
						const uno::Reference< beans::XPropertySet >& xDimProp )
{
	sheet::GeneralFunction eFunc =	(sheet::GeneralFunction) ScUnoHelpFunctions::GetEnumProperty(
									xDimProp, rtl::OUString::createFromAscii( DP_PROP_FUNCTION ), sheet::GeneralFunction_NONE );
	if ( eFunc < sheet::GeneralFunction_SUM )
		eFunc = sheet::GeneralFunction_SUM;
	rField.AddDataFunc( (UINT16)(eFunc - sheet::GeneralFunction_SUM) );
}

//_________________________________________________________
// lcl_CloneUINT16List - nothing to say...

void lcl_CloneUINT16List( const UINT16List& rSource, UINT16List& rDest )
{
	for( UINT16 nIndex = 0; nIndex < rSource.Count(); nIndex++ )
		rDest.Append( rSource.Get( nIndex ) );
}

//_________________________________________________________
// lcl_GetFuncName - stores (engl.) name of xcl-function
// 0x00 = sum, ..., 0x0A = varp

void lcl_GetFuncName( String& rStr, UINT16 nFunc )
{
	switch( nFunc )
	{
		case 0x0000: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("sum"));				break;
		case 0x0001: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("count"));			break;
		case 0x0002: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("average"));			break;
		case 0x0003: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("maximum"));			break;
		case 0x0004: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("minimum"));			break;
		case 0x0005: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("product"));			break;
		case 0x0006: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("count nums"));		break;
		case 0x0007: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("std deviation"));	break;
		case 0x0008: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("std deviationp"));	break;
		case 0x0009: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("variance"));		break;
		case 0x000A: rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("variancep"));		break;
		default:	 rStr = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("unknown"));
	}
}



//============================================================================
// pivot cache and additional pivot table data

//_________________________________________________________
// XclPivotCacheItem

XclPivotCacheItem::~XclPivotCacheItem()
{	}

BOOL XclPivotCacheItem::IsDouble() const
{
	return FALSE;
}

BOOL XclPivotCacheItem::IsString() const
{
	return FALSE;
}

BOOL XclPivotCacheItem::IsDate() const
{
	return FALSE;
}



//_________________________________________________________
// XclPivotCacheDblItem

XclPivotCacheDblItem::XclPivotCacheDblItem( double fNewVal ) :
		fVal( fNewVal )
{
	nTypeFlags = (fNewVal - floor( fNewVal ) != 0.0) ? 0x0520 : 0x0560;
}

BOOL XclPivotCacheDblItem::IsDouble() const
{
	return TRUE;
}

BOOL XclPivotCacheDblItem::operator==( XclPivotCacheItem& rItem )
{
	if( rItem.IsDouble() )
		return (((XclPivotCacheDblItem&) rItem).GetCont() == fVal);
	return FALSE;
}

void XclPivotCacheDblItem::Write( SvStorageStreamRef pOut )
{
	*pOut << (UINT16) 0x00C9 << (UINT16) 8 << GetCont();
}



//_________________________________________________________
// XclPivotCacheStrItem

BOOL XclPivotCacheStrItem::IsString() const
{
	return TRUE;
}

BOOL XclPivotCacheStrItem::operator==( XclPivotCacheItem& rItem )
{
	if( rItem.IsString() )
		return (((XclPivotCacheStrItem&) rItem).GetCont() == sText);
	return FALSE;
}

void XclPivotCacheStrItem::Write( SvStorageStreamRef pOut )
{
	XclRawUnicodeString	sTemp( sText );
	UINT16				nRecLen = (UINT16)(3 + sTemp.GetByteCount());

	*pOut	<< (UINT16) 0x00CD << nRecLen
			<< sTemp.GetLen()					// length of field name
			<< sTemp.GetGrbit();				// GrBit
	sTemp.WriteToStream( *pOut );				// item content
}



//_________________________________________________________
// XclPivotCacheDatItem

XclPivotCacheDatItem::XclPivotCacheDatItem( double fNewDate, RootData* pExcRoot )
{
	nTypeFlags = 0x0900;

	double	fDays	= SolarMath::ApproxFloor( fNewDate );
	double	fTime	= fNewDate - fDays;

	if( fDays > 0.0 )
	{
		Date*	pNullDate	= pExcRoot->pFormTable->GetNullDate();
		Date	aDate		= *pNullDate;

		aDate += fDays;
		nYear = (UINT16) aDate.GetYear();
		nMonth = (UINT16) aDate.GetMonth();
		nDay = (UINT8) aDate.GetDay();
	}
	else
		nYear = nMonth = nDay = 0;

	if( fTime > 0.0 )
	{
		fTime *= 24;
		nHour = (UINT8) fTime;
		fTime -= nHour;
		fTime *= 60;
		nMin = (UINT8) fTime;
		fTime -= nMin;
		fTime *= 60;
		nSec = (UINT8)(fTime + 0.001);
		if( nSec > 59 )
			nSec = 59;
	}
	else
		nHour = nMin = nSec = 0;

	fVal = nSec;
	fVal = (((fVal / 60) + nMin) / 60 + nHour) / 24 + fDays;
}


BOOL XclPivotCacheDatItem::IsDate() const
{
	return TRUE;
}

BOOL XclPivotCacheDatItem::operator==( XclPivotCacheItem& rItem )
{
	if( rItem.IsDate() )
		return (((XclPivotCacheDatItem&) rItem).GetCont() == fVal);
	return FALSE;
}

void XclPivotCacheDatItem::Write( SvStorageStreamRef pOut )
{
	*pOut	<< (UINT16) 0x00CE << (UINT16) 8
			<< nYear << nMonth << nDay << nHour << nMin << nSec;
}



//_________________________________________________________
// XclPivotCacheField

XclPivotCacheField::XclPivotCacheField( RootData* pRD, ScRange& rRange ) :
		ExcRoot( pRD ),
		nFlags( 0x0001 ),
		pCurr( NULL ),
		nIndex( 0 ),
		bShowAllItems( FALSE )
{
	// pivot cache data
	ScDocument&			rDoc	= *pExcRoot->pDoc;
	SvNumberFormatter&	rFTab	= *pExcRoot->pFormTable;
	ScAddress			aAddr	= rRange.aStart;
	XclPivotCacheItem*	pItem	= NULL;

	rDoc.GetString( aAddr.Col(), aAddr.Row(), aAddr.Tab(), sName );

	for( USHORT nRow = rRange.aStart.Row() + 1; nRow <= rRange.aEnd.Row(); nRow++ )
	{
		aAddr.SetRow( nRow );

		if( rDoc.HasValueData( aAddr.Col(), aAddr.Row(), aAddr.Tab() ) )
		{
			double					fValue		= rDoc.GetValue( aAddr );
			ULONG					nNumForm	= rDoc.GetNumberFormat( aAddr );
			const SvNumberformat*	pEntry		= rFTab.GetEntry( nNumForm );

			BOOL bIsDate = pEntry ? (pEntry->GetType() & NUMBERFORMAT_DATETIME) : FALSE;

			if( bIsDate )
				pItem = new XclPivotCacheDatItem( fValue, pExcRoot );
			else
				pItem = new XclPivotCacheDblItem( fValue );
			Insert( pItem );
		}
		else
		{
			String sStr;
			rDoc.GetString( aAddr.Col(), aAddr.Row(), aAddr.Tab(), sStr );
			pItem = new XclPivotCacheStrItem( sStr );
			Insert( pItem );
		}
	}

	// pivot table data
	nAxis = nSubTotalMask = nPosition = 0;
}


XclPivotCacheField::~XclPivotCacheField()
{
	for( XclPivotCacheItem* pItem = _First(); pItem; pItem = _Next() )
		delete pItem;
}


UINT16 XclPivotCacheField::_Find( XclPivotCacheItem& rItem )
{
	if( pCurr )
		if( *pCurr == rItem )
			return nIndex;

	BOOL bFound = FALSE;

	pCurr	= _First();
	nIndex	= 0;

	while( !bFound && pCurr )
	{
		bFound = (*pCurr == rItem);
		if( !bFound )
		{
			pCurr = _Next();
			nIndex++;
		}
	}

	if( !bFound )
		pCurr = &rItem;
	return nIndex;
}


void XclPivotCacheField::Insert( XclPivotCacheItem*& rpItem )
{
	if( rpItem )
	{
		UINT16 nPos = _Find( *rpItem );

		if( nPos == List::Count() )			// not found
		{
			UINT16 nType = rpItem->GetTypeFlags();

			switch( nType )
			{
				case 0x0480:				// string
					nFlags |= nType;
					break;
				case 0x0520:				// double
				case 0x0560:				// double (int only)
					if( nFlags & 0x0800 )
						nFlags |= 0x0400;
					else
					{
						if( (nFlags & 0x0560) == 0x0520 )
							nType &= ~0x0040;
						nFlags &= ~0x0560;
						nFlags |= nType;
					}
					break;
				case 0x0900:				// date/time
					nFlags &= ~0x0060;
					nFlags |= nType;
					break;
			}
			List::Insert( rpItem, LIST_APPEND );

			if( List::Count() == 0x0100 )	// 16bit column in index list
				nFlags |= 0x0200;
		}
		else								// already in list, forget it
		{
			delete rpItem;
			rpItem = NULL;
		}

		aIndexList.Append( nPos );
	}
}


void XclPivotCacheField::AddSubTotal( UINT16 nSubT )
{
	aSubTotalList.Append( nSubT );
	if( nSubT )
		nSubTotalMask |= (0x0001 << (nSubT - 1));
}


void XclPivotCacheField::SetPosition( UINT16 nPos, UINT16 nAxisFlag )
{
	if( nAxisFlag == PIVOT_AXIS_DATA )
		aDataPosList.Append( nPos );
	else
		nPosition = nPos;
}


BOOL XclPivotCacheField::IsInDataPosList( UINT16 nPos ) const
{
	BOOL bFound = FALSE;
	for( UINT16 nInd = 0; (nInd < aDataPosList.Count()) && !bFound; nInd++ )
		bFound = (aDataPosList.Get( nInd ) == nPos);
	return bFound;
}


UINT16 XclPivotCacheField::GetFunction( UINT16 nPos ) const
{
	BOOL	bFound	= FALSE;
	UINT16	nInd	= 0;

	while( (nInd < aDataPosList.Count()) && !bFound )
	{
		bFound = (aDataPosList.Get( nInd ) == nPos);
		if( !bFound )
			nInd++;
	}

	if( bFound )
		return aDataFuncList.Get( nInd );
	return 0;
}


void XclPivotCacheField::WriteIndex( SvStorageStreamRef pOut, UINT16 nRow )
{
	if( GetIndexWidth() == 1 )
	{
		UINT8 nInd = (UINT8) aIndexList.Get( nRow );
		*pOut << nInd;
	}
	else
		*pOut << aIndexList.Get( nRow );
}


void XclPivotCacheField::WriteFieldHeader( SvStorageStreamRef pOut )
{
	XclRawUnicodeString	sTemp( sName );
	UINT16				nRecLen = (UINT16)(17 + sTemp.GetByteCount());

	// field record
	*pOut	<< (UINT16) 0x00C7 << nRecLen
			<< nFlags							// type
			<< (UINT16) 0x0000					// undoc'ed
			<< (UINT16) 0x0000					// undoc'ed
			<< (UINT16) List::Count()			// num of items
			<< (UINT16) 0x0000					// undoc'ed
			<< (UINT16) 0x0000					// undoc'ed
			<< (UINT16) List::Count()			// num of items
			<< sTemp.GetLen()					// len of field name
			<< sTemp.GetGrbit();				// GrBit
	sTemp.WriteToStream( *pOut );				// field name

	// SQL data type
	*pOut	<< (UINT16) 0x01BB << (UINT16) 2
			<< (UINT16) 0x0000;					// SQL data type
}


void XclPivotCacheField::Write( SvStorageStreamRef pOut )
{
	WriteFieldHeader( pOut );

	for( XclPivotCacheItem* pItem = _First(); pItem; pItem = _Next() )
		pItem->Write( pOut );
}



//_________________________________________________________
// XclPivotCache

XclPivotCache::XclPivotCache( RootData* pRD, ScDPObject& rObject, UINT16 nInd ) :
		ExcRoot( pRD ),
		nIndex( nInd ),
		aOutRange( rObject.GetOutRange() ),
		sTableName( rObject.GetName() ),
		sDataName( ScGlobal::GetRscString( STR_PIVOT_DATA ) ),
		nDataFAxis( PIVOT_AXIS_NONE ),
		bMultiData( FALSE )
{
	// remaining inits
	nColF = nRowF = nPageF = nDataF = nDataFPos = 0;

	// sheet source data only
	if( !rObject.GetSheetDesc() )
		return;

	// pivot cache data
	aSourceRange = rObject.GetSheetDesc()->aSourceRange;
	pExcRoot->pDoc->GetName( aSourceRange.aStart.Tab(), sSourceName );
	nSrcRecs = aSourceRange.aEnd.Row() - aSourceRange.aStart.Row();

	ScRange aColRange( aSourceRange );

	for( USHORT nCol = aSourceRange.aStart.Col(); nCol <= aSourceRange.aEnd.Col(); nCol++ )
	{
		aColRange.aStart.SetCol( nCol );
		aColRange.aEnd.SetCol( nCol );
		Append( new XclPivotCacheField( pRD, aColRange ) );
	}

	// pivot table data
	aOutRange.aStart.IncRow( 2 );		//! skip filter button; works with sheet source only!
	bRowGrand = bColGrand = TRUE;

	uno::Reference< sheet::XDimensionsSupplier > xSource = rObject.GetSource();
	if( !xSource.is() )
		return;

	// row & col grands
	uno::Reference< beans::XPropertySet >	xSrcProp( xSource, uno::UNO_QUERY );
	if( xSrcProp.is() )
	{
		bRowGrand = ScUnoHelpFunctions::GetBoolProperty( xSrcProp, rtl::OUString::createFromAscii( DP_PROP_ROWGRAND ), TRUE );
		bColGrand = ScUnoHelpFunctions::GetBoolProperty( xSrcProp, rtl::OUString::createFromAscii( DP_PROP_COLUMNGRAND ), TRUE );
	}

	uno::Reference< container::XIndexAccess >	xDimsIndex =
		new ScNameToIndexAccess( xSource->getDimensions() );
	if( !xDimsIndex.is() )
		return;

	// pivot field properties - index order to get DataLayoutDimension
	long nDimCount = xDimsIndex->getCount();
	for( long nDim = 0; nDim < nDimCount; nDim++ )
	{
		uno::Reference< uno::XInterface >		xIntDim =
			ScUnoHelpFunctions::AnyToInterface( xDimsIndex->getByIndex( nDim ) );

		uno::Reference< container::XNamed >		xDimName( xIntDim, uno::UNO_QUERY );
		uno::Reference< beans::XPropertySet >	xDimProp( xIntDim, uno::UNO_QUERY );

		if( xDimName.is() && xDimProp.is() )
		{
			// store orientation & position info
			UINT16	nAxisFlag		= PIVOT_AXIS_NONE;
			BOOL	bIsDataLayout	= ScUnoHelpFunctions::GetBoolProperty( xDimProp, rtl::OUString::createFromAscii( DP_PROP_ISDATALAYOUT ) );
			long	nPosition 		= ScUnoHelpFunctions::GetLongProperty( xDimProp, rtl::OUString::createFromAscii( DP_PROP_POSITION ) );

			sheet::DataPilotFieldOrientation	eOrientation =
				(sheet::DataPilotFieldOrientation) ScUnoHelpFunctions::GetEnumProperty(
					xDimProp, rtl::OUString::createFromAscii( DP_PROP_ORIENTATION ), sheet::DataPilotFieldOrientation_HIDDEN );

			switch( eOrientation )
			{
				case sheet::DataPilotFieldOrientation_COLUMN:
					if( bIsDataLayout )
						nDataFAxis = PIVOT_AXIS_COL;
					nColF++;
					nAxisFlag = PIVOT_AXIS_COL;
					break;
				case sheet::DataPilotFieldOrientation_ROW:
					if( bIsDataLayout )
						nDataFAxis = PIVOT_AXIS_ROW;
					nRowF++;
					nAxisFlag = PIVOT_AXIS_ROW;
					break;
				case sheet::DataPilotFieldOrientation_PAGE:
					nPageF++;
					nAxisFlag = PIVOT_AXIS_PAGE;
					break;
				case sheet::DataPilotFieldOrientation_DATA:
					nDataF++;
					nAxisFlag = PIVOT_AXIS_DATA;
					break;

			}

			if( bIsDataLayout )
				nDataFPos = nPosition;
			else
			{
				// find correct cache entry
				String sName = xDimName->getName();

				XclPivotCacheField* pField = _GetByName( sName );
				if( !pField )
				{
					uno::Any aOrigAny;
					TRY
					{
						aOrigAny = xDimProp->getPropertyValue( rtl::OUString::createFromAscii( DP_PROP_ORIGINAL ) );
					}
					CATCH_ALL()
					{	}
					END_CATCH
					uno::Reference< uno::XInterface >	xIntOrig =
						ScUnoHelpFunctions::AnyToInterface( aOrigAny );
					uno::Reference< container::XNamed >	xNameOrig( xIntOrig, uno::UNO_QUERY );
					if ( xNameOrig.is() )
					{
						sName	= String( xNameOrig->getName() );
						pField	= _GetByName( sName );
					}
				}

				// set field and item properties
				if( pField )
				{
					pField->AddAxis( nAxisFlag );
					if( nAxisFlag == PIVOT_AXIS_DATA )
						lcl_GetDataFunc( *pField, xDimProp );
					else
						lcl_GetLevelProps( *pField, xDimProp );
					pField->SetPosition( nPosition, nAxisFlag );
				}
			}
		}
	}
	bMultiData = (nDataF > 1);

	// find order of fields
	BuildPosList( aRowPosList, nRowF, PIVOT_AXIS_ROW );
	BuildPosList( aColPosList, nColF, PIVOT_AXIS_COL );
	BuildPosList( aDataPosList, nDataF, PIVOT_AXIS_DATA );
}


XclPivotCache::~XclPivotCache()
{
	for( XclPivotCacheField* pField = _First(); pField; pField = _Next() )
		delete pField;
}


XclPivotCacheField* XclPivotCache::_GetByName( const String& rName )
{
	XclPivotCacheField* pField = _First();
	BOOL				bFound = FALSE;

	while( pField && !bFound )
	{
		bFound = (pField->GetName() == rName);
		if( !bFound )
			pField = _Next();
	}

	return pField;
}


UINT16 XclPivotCache::GetIndexRecLen()
{
	UINT16				nRecLen	= 0;

	for( XclPivotCacheField* pField = _First(); pField; pField = _Next() )
		nRecLen += pField->GetIndexWidth();

	return nRecLen;
}


void XclPivotCache::WriteCacheHeader( SvStorageStreamRef pOut )
{
	// SXDB
	*pOut	<< (UINT16) 0x00C6 << (UINT16) 21
			<< (UINT32) nSrcRecs				// number of source records
			<< nIndex							// SXIDSTM index
			<< (UINT16) 0x0021					// flags
			<< (UINT16) 0x1FFF					// num of DB recs (from xcl)
			<< (UINT16) List::Count()			// base fields
			<< (UINT16) List::Count()			// base, grouped, calc'ed fields
			<< (UINT16) 0x0000					// unused
			<< (UINT16) 0x0001					// source: Xcl worksheet
			<< (UINT16) 0x0000					// unicode user name
			<< (UINT8) 0x00;

	// SXDBEX
	*pOut	<< (UINT16) 0x0122 << (UINT16) 12
			<< (double) 51901.029652778			// last change
			<< (UINT32) 0x00000000;				// num of SXFORMULA
}


void XclPivotCache::WriteCacheEnd( SvStorageStreamRef pOut )
	{
	*pOut << (UINT16) 0x000A << (UINT16) 0;
	}


void XclPivotCache::WriteIndexList( SvStorageStreamRef pOut )
{
	UINT16 nIndLen = GetIndexRecLen();

	for( UINT16 nRow = 0; nRow < nSrcRecs; nRow++ )
	{
		*pOut << (UINT16) 0x00C8 << nIndLen;

		for( XclPivotCacheField* pField = _First(); pField; pField = _Next() )
			pField->WriteIndex( pOut, nRow );
	}
}


void XclPivotCache::Write()
{
	SvStorageStreamRef pOut = pExcRoot->pPivotCacheStorage->OpenStream(
		ScGetHexStr( nIndex ), STREAM_READWRITE | STREAM_TRUNC );
	if( !pOut )
		return;

	pOut->SetBufferSize( 32768 );

	WriteCacheHeader( pOut );

	for( XclPivotCacheField* pField = _First(); pField; pField = _Next() )
		pField->Write( pOut );

	WriteIndexList( pOut );
	WriteCacheEnd( pOut );
	pOut->Commit();
}


BOOL XclPivotCache::HasGrandTotal( UINT16 nAxisFlag ) const
{
	switch( nAxisFlag )
	{
		case PIVOT_AXIS_ROW:	return bRowGrand;
		case PIVOT_AXIS_COL:	return bColGrand;
		default:				return FALSE;
	}
}


const UINT16List* XclPivotCache::GetPosList( UINT16 nAxisFlag ) const
{
	switch( nAxisFlag )
	{
		case PIVOT_AXIS_ROW:	return &aRowPosList;
		case PIVOT_AXIS_COL:	return &aColPosList;
		case PIVOT_AXIS_DATA:	return &aDataPosList;
		default:				return NULL;
	}
}


void XclPivotCache::BuildPosList( UINT16List& rList, UINT16& rCount, UINT16 nAxisFlag )
{
	for( UINT16 nPos = 0; nPos < rCount; nPos++ )
	{
		BOOL bFound	= FALSE;
		BOOL bMulti	= FALSE;
		for( UINT16 nField = 0; (nField < Count()) && !bFound; nField++ )
		{
			XclPivotCacheField* pField = _Get( nField );
			if( pField )
			{
				if( nAxisFlag == PIVOT_AXIS_DATA )
					bFound = pField->IsInDataPosList( nPos );
				else
				{
					bFound = bMulti = (HasMultiData( nAxisFlag ) && (nDataFPos == nPos));
					if( !bFound )
						bFound = (pField->GetAxis() & nAxisFlag) && (pField->GetPosition() == nPos);
				}
			}
			if( bFound )
				rList.Append( bMulti ? 0xFFFE : nField );
		}
	}
	if( (nDataFAxis == nAxisFlag) && !HasMultiData( nAxisFlag ) )
		rCount--;
}



//_________________________________________________________
// XclPivotCacheList

XclPivotCacheList::XclPivotCacheList( RootData* pRD, ScDPCollection& rDPColl ) :
		ExcRoot( pRD )
{
	for( USHORT nObjCnt = 0; nObjCnt < rDPColl.GetCount(); nObjCnt++ )
	{
		ScDPObject* pDPObject = rDPColl[ nObjCnt ];
		if( pDPObject )
			Append( new XclPivotCache( pRD, *pDPObject, nObjCnt + 1 ) );
	}
}


XclPivotCacheList::~XclPivotCacheList()
{
	for( XclPivotCache* pCache = _First(); pCache; pCache = _Next() )
		delete pCache;
}


void XclPivotCacheList::Write()
{
	if( !pExcRoot->pPivotCacheStorage )
		pExcRoot->pPivotCacheStorage =
			pExcRoot->pRootStorage->OpenStorage(
				String::CreateFromAscii(pPivotCacheStorageName), STREAM_STD_WRITE );
	if( !pExcRoot->pPivotCacheStorage )
		return;

	for( XclPivotCache* pCache = _First(); pCache; pCache = _Next() )
		pCache->Write();
}



//============================================================================
// biff records

//_________________________________________________________
// XclSxIdStm

void XclSxIdStm::SaveCont( SvStream& rStrm )
{
	rStrm << nIndex;
}

UINT16 XclSxIdStm::GetNum() const
{
	return 0x00D5;
}

UINT16 XclSxIdStm::GetLen() const
{
	return 2;
}



//_________________________________________________________
// XclSxVs

void XclSxVs::SaveCont( SvStream& rStrm )
{
	rStrm << nSource;
}

UINT16 XclSxVs::GetNum() const
{
	return 0x00E3;
}

UINT16 XclSxVs::GetLen() const
{
	return 2;
}



//_________________________________________________________
// XclSxView

XclSxView::XclSxView( const XclPivotCache& rCache, UINT16 nCacheInd ) :
		nIndex( nCacheInd ),
		sTableName( rCache.GetTableName() ),
		sDataName( rCache.GetDataName() ),
		aOutRange( rCache.GetOutRange() ),
		nFields( rCache.Count() ),
		nRowF( rCache.GetRowFCount() ),
		nColF( rCache.GetColFCount() ),
		nPageF( rCache.GetPageFCount() ),
		nDataF( rCache.GetDataFCount() )
{
	nDataFAxis = rCache.GetDataFAxis();
	if( nDataFAxis == PIVOT_AXIS_NONE )
		nDataFAxis = PIVOT_AXIS_ROW;
	nDataFPos = rCache.HasMultiData() ? rCache.GetDataFPos() : 0xFFFF;

	aFirstData = aOutRange.aStart;
	aFirstData.IncRow( nColF + 1 );
	aFirstData.IncCol( nRowF );

	nFirstHeading = aOutRange.aStart.Row();
	if( nColF )
		nFirstHeading++;

	if( nDataF )
	{
		nDataRows = (UINT16)(aOutRange.aEnd.Row() - aFirstData.Row() + 1);
		nDataCols = (UINT16)(aOutRange.aEnd.Col() - aFirstData.Col() + 1);
	}
	else
		nDataRows = nDataCols = 0;

	nFlags = SXVIEW_COMMON;
	if( rCache.HasGrandTotal( PIVOT_AXIS_ROW ) )
		nFlags |= SXVIEW_ROWGRAND;
	if( rCache.HasGrandTotal( PIVOT_AXIS_COL ) )
		nFlags |= SXVIEW_COLGRAND;
}


void XclSxView::SaveCont( SvStream& rStrm )
{
	rStrm	<< (UINT16) aOutRange.aStart.Row()	// 1st row
			<< (UINT16) aOutRange.aEnd.Row()	// last row
			<< (UINT16) aOutRange.aStart.Col()	// 1st col
			<< (UINT16) aOutRange.aEnd.Col()	// last col
			<< nFirstHeading					// 1st heading row
			<< (UINT16) aFirstData.Row()		// 1st data row
			<< (UINT16) aFirstData.Col()		// 1st data col
			<< nIndex							// cache index
			<< (UINT16) 0x0000					// reserved
			<< nDataFAxis						// axis for data
			<< nDataFPos						// pos for data
			<< nFields							// num of fields
			<< nRowF							// num of row fields
			<< nColF							// num of col fields
			<< nPageF							// num of page fields
			<< nDataF							// num of data fields
			<< nDataRows						// num of data rows
			<< nDataCols						// num of data cols
			<< nFlags							// flags
			<< (UINT16) 0x0001					// index autoformat
			<< sTableName.GetLen()
			<< sDataName.GetLen()
			<< sTableName.GetGrbit();
	sTableName.WriteToStream( rStrm );
	rStrm	<< sDataName.GetGrbit();
	sDataName.WriteToStream( rStrm );
}


UINT16 XclSxView::GetNum() const
{
	return 0x00B0;
}

UINT16 XclSxView::GetLen() const
{
	return 46 + sTableName.GetByteCount() + sDataName.GetByteCount();
}



//_________________________________________________________
// XclSxVi

void XclSxVi::SaveCont( SvStream& rStrm )
{
	rStrm	<< nItemType						// item type flag
			<< (UINT16) 0x0000					// flags
			<< nCacheInd						// cache item index
			<< (UINT16) 0xFFFF;					// name in cache
}


UINT16 XclSxVi::GetNum() const
{
	return 0x00B2;
}

UINT16 XclSxVi::GetLen() const
{
	return 8;
}



//_________________________________________________________
// XclSxViList

XclSxViList::XclSxViList( const XclPivotCacheField& rField )
{
	if( rField.GetAxis() & PIVOT_AXIS_RCP_MASK )
	{
		// data items
		for( UINT16 iItem = 0; iItem < rField.Count(); iItem++ )
			Append( new XclSxVi( 0x0000, iItem ) );
		// subtotal items
		for( UINT16 iSubT = 0; iSubT < rField.GetSubTotalCount(); iSubT++ )
			Append( new XclSxVi( rField.GetSubTotal( iSubT ), 0xFFFF ) );
	}
}


XclSxViList::~XclSxViList()
{
	for( XclSxVi* pSxVi = _First(); pSxVi; pSxVi = _Next() )
		delete pSxVi;
}


void XclSxViList::SaveList( SvStream& rStrm )
{
	for( XclSxVi* pSxVi = _First(); pSxVi; pSxVi = _Next() )
		pSxVi->Save( rStrm );
}



//_________________________________________________________
// XclSxVdex

XclSxVdex::XclSxVdex( const XclPivotCacheField& rField )
{
	nFlags = SXVDEX_COMMON;
	if( rField.IsShowAll() )
		nFlags |= SXVDEX_SHOWALL;
}


void XclSxVdex::SaveCont( SvStream& rStrm )
{
	rStrm	<< nFlags							// flags
			<< (UINT16) 0xFFFF					// autoshow items
			<< (UINT16) 0xFFFF					// autosort field
			<< (UINT16) 0x0000					// autoshow field
			<< (UINT16) 0xFFFF					// number format
			<< (UINT32) 0x00000000				// unknown
			<< (UINT32) 0x00000000;				// unknown
}


UINT16 XclSxVdex::GetNum() const
{
	return 0x0100;
}

UINT16 XclSxVdex::GetLen() const
{
	return 20;
}



//_________________________________________________________
// XclSxVd

XclSxVd::XclSxVd( const XclPivotCacheField& rField ) :
	nAxis( rField.GetAxis() ),
	nSubTotalCount( rField.GetSubTotalCount() ),
	nSubTotalMask( rField.GetSubTotalMask() ),
	aSxViList( rField ),
	aSxVdex( rField )
{	}


XclSxVd::~XclSxVd()
{	}


void XclSxVd::SaveCont( SvStream& rStrm )
{
	rStrm	<< nAxis							// Orientation
			<< nSubTotalCount					// num of subtotals
			<< nSubTotalMask					// type flags
			<< (UINT16) aSxViList.Count()		// num of items
			<< (UINT16) 0xFFFF;					// name in cache
	aSxViList.SaveList( rStrm );
	aSxVdex.Save( rStrm );
}


UINT16 XclSxVd::GetNum() const
{
	return 0x00B1;
}

UINT16 XclSxVd::GetLen() const
{
	return 10;
}



//_________________________________________________________
// XclSxVdList

XclSxVdList::XclSxVdList( const XclPivotCache& rCache )
{
	const XclPivotCacheField* pField;

	for( UINT16 iField = 0; iField < rCache.Count(); iField++ )
	{
		pField = rCache.Get( iField );
		if( pField )
			Append( new XclSxVd( *pField ) );
	}
}


XclSxVdList::~XclSxVdList()
{
	for( XclSxVd* pSxVd = _First(); pSxVd; pSxVd = _Next() )
		delete pSxVd;
}


void XclSxVdList::SaveList( SvStream& rStrm )
{
	for( XclSxVd* pSxVd = _First(); pSxVd; pSxVd = _Next() )
		pSxVd->Save( rStrm );
}



//_________________________________________________________
// XclSxIvd

XclSxIvd::XclSxIvd( const XclPivotCache& rCache, UINT16 nAxis )
{
	const UINT16List* pList = rCache.GetPosList( nAxis );

	if( pList )
		lcl_CloneUINT16List( *pList, aIndexList );
}


void XclSxIvd::Save( SvStream& rStrm )
{
	if( aIndexList.Count() )
		ExcRecord::Save( rStrm );
}


void XclSxIvd::SaveCont( SvStream& rStrm )
{
	for( UINT16 iEntry = 0; iEntry < aIndexList.Count(); iEntry++ )
		rStrm << aIndexList.Get( iEntry );
}


UINT16 XclSxIvd::GetNum() const
{
	return 0x00B4;
}

UINT16 XclSxIvd::GetLen() const
{
	return aIndexList.Count() * 2;
}



//_________________________________________________________
// XclSxDi

void XclSxDi::SaveCont( SvStream& rStrm )
{
	rStrm	<< nIndex							// index to SXVD
			<< nFunction						// function index
			<< (UINT16) 0x0000					// data display
			<< (UINT16) 0x0000					// data disp SXVD ind
			<< (UINT16) 0x0000					// data disp SXVI ind
			<< (UINT16) 0x0000					// format table ind
			<< (UINT16) sFieldName.GetLen()
			<< (UINT8) sFieldName.GetGrbit();
	sFieldName.WriteToStream( rStrm );
}

UINT16 XclSxDi::GetNum() const
{
	return 0x00C5;
}

UINT16 XclSxDi::GetLen() const
{
	return 15 + sFieldName.GetByteCount();
}



//_________________________________________________________
// XclSxDiList

XclSxDiList::XclSxDiList( const XclPivotCache& rCache )
{
	const UINT16List* pList = rCache.GetPosList( PIVOT_AXIS_DATA );
	if( pList )
	{
		for( UINT16 nPos = 0; nPos < pList->Count(); nPos++ )
		{
			UINT16						nInd	= pList->Get( nPos );
			const XclPivotCacheField*	pField	= rCache.Get( nInd );

			if( pField )
			{
				String sName;
				UINT16 nFunc = pField->GetFunction( nPos );
				lcl_GetFuncName( sName, nFunc );
				sName.AppendAscii(RTL_CONSTASCII_STRINGPARAM( " - " ));
				sName += pField->GetName();
				Append( new XclSxDi( nInd, nFunc, sName ) );
			}
		}
	}
}


XclSxDiList::~XclSxDiList()
{
	for( XclSxDi* pSxDi = _First(); pSxDi; pSxDi = _Next() )
		delete pSxDi;
}


void XclSxDiList::SaveList( SvStream& rStrm )
{
	for( XclSxDi* pSxDi = _First(); pSxDi; pSxDi = _Next() )
		pSxDi->Save( rStrm );
}


//_________________________________________________________
// XclSxLi

XclSxLi::XclSxLi( const XclPivotCache& rCache, UINT16 nAxisFlag, UINT16 nLines )
{
	const UINT16List* pRCList = rCache.GetPosList( nAxisFlag );

	nLineCount	= rCache.GetDataFCount() ? nLines : 0;
	nIndCount	= pRCList ? pRCList->Count() : 0;
}


void XclSxLi::SaveCont( SvStream& rStrm )
{
	UINT32 nCount = nLineCount * (4 + nIndCount);
	UINT32 nBytes = nCount << 1;
	if( !nCount )
		return;

	UINT32 nLastRec	= (nBytes - 1 ) / 8224;
	UINT32 nCurrRec	= 0;
	UINT16 nCurrLen	= 0;

	for( UINT32 iInd = 0; iInd < nCount; iInd++ )
	{
		if( nCurrLen == 8224 )
		{
			nCurrRec++;
			rStrm << (UINT16) 0x003C;
			if( nCurrRec == nLastRec )
				rStrm << (UINT16)(nBytes % 8224);
			else
				rStrm << (UINT16) 8224;
			nCurrLen = 0;
		}
		rStrm << (UINT16) 0x0000;
		nCurrLen += 2;
	}
}


UINT16 XclSxLi::GetNum() const
{
	return 0x00B5;
}

UINT16 XclSxLi::GetLen() const
{
	UINT32 nLen = nLineCount * 2 * (4 + nIndCount);
	if( nLen > 8224 )
		nLen = 8224;
	return (UINT16) nLen;
}



//_________________________________________________________
// XclSxEx

void XclSxEx::SaveCont( SvStream& rStrm )
{
	rStrm	<< (UINT16) 0x0000					// num of SXFORMULA
			<< (UINT16) 0xFFFF					// DisplayErrorString chars
			<< (UINT16) 0xFFFF					// DisplayNullString chars
			<< (UINT16) 0xFFFF					// tag string chars
			<< (UINT16) 0x0000					// num of RTSXSELECT
			<< (UINT16) 0x0000					// ?? page field p row
			<< (UINT16) 0x0000					// ?? page field p col
			<< (UINT16) 0x0200					// flags 1
			<< (UINT16) 0x004F					// flags 2
			<< (UINT16) 0xFFFF					// page field style str chars
			<< (UINT16) 0xFFFF					// table style string chars
			<< (UINT16) 0xFFFF;					// vacate style string chars
}

UINT16 XclSxEx::GetNum() const
{
	return 0x00F1;
}

UINT16 XclSxEx::GetLen() const
{
	return 24;
}



//_________________________________________________________
// XclPivotTableRecs

XclPivotTableRecs::XclPivotTableRecs( const XclPivotCache& rCache, UINT16 nCacheInd ) :
		aSxView( rCache, nCacheInd ),
		aSxVdList( rCache ),
		aSxIvdRow( rCache, PIVOT_AXIS_ROW ),
		aSxIvdCol( rCache, PIVOT_AXIS_COL ),
		aSxDiList( rCache ),
		pSxLiRow( NULL ),
		pSxLiCol( NULL )
{
	if( rCache.GetDataFCount() )
	{
		pSxLiRow = new XclSxLi( rCache, PIVOT_AXIS_ROW, aSxView.GetDataRows() );
		pSxLiCol = new XclSxLi( rCache, PIVOT_AXIS_COL, aSxView.GetDataCols() );
	}
}


XclPivotTableRecs::~XclPivotTableRecs()
{
	if( pSxLiRow )
		delete pSxLiRow;
	if( pSxLiCol )
		delete pSxLiCol;
}


void XclPivotTableRecs::_Save( SvStream& Strm )
{	}				// nothing to do


void XclPivotTableRecs::SaveCont( SvStream& rStrm )
{
	aSxView.Save( rStrm );
	aSxVdList.SaveList( rStrm );
	aSxIvdRow.Save( rStrm );
	aSxIvdCol.Save( rStrm );
	aSxDiList.SaveList( rStrm );
	if( pSxLiRow )
		pSxLiRow->Save( rStrm );
	if( pSxLiCol )
		pSxLiCol->Save( rStrm );
	aSxEx.Save( rStrm );
}


UINT16 XclPivotTableRecs::GetNum() const
{
	return 0;		// not used
}

UINT16 XclPivotTableRecs::GetLen() const
{
	return 0;		// not used
}



