/*************************************************************************
 *
 *  $RCSfile: sclib.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:44:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define _SCALC_EXE

#ifdef WIN
#include <svwin.h>
#endif

#include <svtools/inettype.hxx>
#include <svtools/parhtml.hxx>
#include <so3/clsids.hxx>
#include <sfx2/inimgr.hxx>
#include <sfx2/docfilt.hxx>
#include <sfx2/fcontnr.hxx>
#include <sfx2/docfile.hxx>
#include <sfx2/app.hxx>
#include <svtools/libcall.hxx>
#include <vcl/exchange.hxx>

#include <sot/formats.hxx>
#define SOT_FORMATSTR_ID_STARCALC_30 SOT_FORMATSTR_ID_STARCALC

#include <signal.h>

#include "scdll.hxx"

#include "docsh.hxx"
#include "sc.hrc"
#include "scdll0.hxx"


//------------------------------------------------------------------

//	Filter-Namen (wie in docsh.cxx)

static const sal_Char __FAR_DATA pFilterSc50[]		= "StarCalc 5.0";
static const sal_Char __FAR_DATA pFilterSc50Temp[]	= "StarCalc 5.0 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterSc40[]		= "StarCalc 4.0";
static const sal_Char __FAR_DATA pFilterSc40Temp[]	= "StarCalc 4.0 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterSc30[]		= "StarCalc 3.0";
static const sal_Char __FAR_DATA pFilterSc30Temp[]	= "StarCalc 3.0 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterSc10[]		= "StarCalc 1.0";
static const sal_Char __FAR_DATA pFilterXML[]		= "StarOffice XML (Calc)";
static const sal_Char __FAR_DATA pFilterAscii[]		= "Text - txt - csv (StarCalc)";
static const sal_Char __FAR_DATA pFilterLotus[]		= "Lotus";
static const sal_Char __FAR_DATA pFilterExcel4[]	= "MS Excel 4.0";
static const sal_Char __FAR_DATA pFilterEx4Temp[]	= "MS Excel 4.0 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterExcel5[]	= "MS Excel 5.0/95";
static const sal_Char __FAR_DATA pFilterEx5Temp[]	= "MS Excel 5.0/95 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterExcel95[]	= "MS Excel 95";
static const sal_Char __FAR_DATA pFilterEx95Temp[]	= "MS Excel 95 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterExcel97[]	= "MS Excel 97";
static const sal_Char __FAR_DATA pFilterEx97Temp[]	= "MS Excel 97 Vorlage/Template";
static const sal_Char __FAR_DATA pFilterDBase[]		= "dBase";
static const sal_Char __FAR_DATA pFilterDif[]		= "DIF";
static const sal_Char __FAR_DATA pFilterSylk[]		= "SYLK";
static const sal_Char __FAR_DATA pFilterHtml[]		= "HTML (StarCalc)";
static const sal_Char __FAR_DATA pFilterRtf[]		= "Rich Text Format (StarCalc)";

//------------------------------------------------------------------

//	GlobalName der aktuellen Version:
SFX_IMPL_OBJECTFACTORY_LIB(ScDocShell, SFXOBJECTSHELL_STD_NORMAL, scalc,
							SvGlobalName(SO3_SC_CLASSID), Sc,
							String( RTL_CONSTASCII_USTRINGPARAM( DLL_NAME ) ))
{
	((SfxObjectFactory&)Factory()).
			SetDocumentServiceName( rtl::OUString::createFromAscii(
					"com.sun.star.sheet.SpreadsheetDocument" ) );

	const String	aEmptyStr;
									// Clipboard-IDs:
	const ULONG		nSc50Format	 = SOT_FORMATSTR_ID_STARCALC_50;

	String aVndCalc = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(CONTENT_TYPE_STR_APP_VND_CALC));

	//	5.0 muss mit vnd-Mime-Type registriert werden, aeltere mit dem alten x-starcalc

	SFX_OWN_FILTER_REGISTRATION( ScDLL::DetectFilter,
						String::CreateFromAscii(pFilterSc50),
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("*.sdc")),
						SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
						SFX_FILTER_IMPORT | SFX_FILTER_EXPORT,
						nSc50Format,
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("SVsc0.sdc")),
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("StarCalc 5.0")),
						RID_SCICN_DOCUMENT,
						aVndCalc, aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( ScDLL::DetectFilter,
						String::CreateFromAscii(pFilterSc50Temp),
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("*.vor")),
						SFX_FILTER_OWN | SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
						SFX_FILTER_IMPORT | SFX_FILTER_EXPORT,
						nSc50Format,
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("SVsc1.vor")),
						String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("StarCalc 5.0")),
						RID_SCICN_TEMPLATE,
						aVndCalc, aEmptyStr );

	//	alle Im-/Exportfilter werden nur noch per install.ini registriert,
	//	damit sie bei der Installation weggelassen werden koennen.
}


// this is the right place for SFX_OBJECTFACTORY_LIB

//------------------------------------------------------------------
//
//	ScModuleDummy::Load() muss zur App gelinkt werden:
//
//------------------------------------------------------------------

ScSigCatchFunc ScLibSignal( int nSig, ScSigCatchFunc pFunc )
{
#ifndef ICC
	return signal( nSig, pFunc );
#else
	return (ScSigCatchFunc)signal( nSig, (_SigFunc)pFunc );
#endif
}

SfxModule* ScModuleDummy::Load()
{
	if ( LoadLibSc() )
	{
		ScModuleDummy* pMod = SC_DLL();
		pMod->pSignalFunc = &ScLibSignal;
		return pMod;
	}
	return NULL;
}

SvGlobalName ScModuleDummy::GetID(USHORT nFileFormat)
{
	SvGlobalName aName;

	switch (nFileFormat)
	{
		//	GlobalNames der ScDocShell:

		case SOFFICE_FILEFORMAT_31:
			aName = SvGlobalName( SO3_SC_CLASSID_30 );
			break;

		case SOFFICE_FILEFORMAT_40:
			aName = SvGlobalName( SO3_SC_CLASSID_40 );
			break;

		case SOFFICE_FILEFORMAT_50:
			aName = SvGlobalName( SO3_SC_CLASSID_50 );
			break;

		default:
			DBG_ERROR("ScModuleDummy::GetID: unbekanntes Fileformat");
			break;
	}
	return aName;
}

USHORT ScModuleDummy::HasID(const SvGlobalName& rName)
{
	if (GetID(SOFFICE_FILEFORMAT_31) == rName)
		return SOFFICE_FILEFORMAT_31;

	if (GetID(SOFFICE_FILEFORMAT_40) == rName)
		return SOFFICE_FILEFORMAT_40;

	if (GetID(SOFFICE_FILEFORMAT_50) == rName)
		return SOFFICE_FILEFORMAT_50;

	return 0;           // unbekannter Name: kein passendes Fileformat
}

//------------------------------------------------------------------

ScDLL::ScDLL()
{
	// the ctor is called at the beginning of SfxApplication-subclass::Main()
	// do whatever you want, but no calls to Sxx-DLL-code!
}

ScDLL::~ScDLL()
{
	// the dtor is called at the end of SfxApplication-subclass::Main()
	// do whatever you want, but no calls to Sxx-DLL-code!
}

void ScDLL::LibInit()
{
	// this method is called before Application::Execute()
	// do whatever you want, but no calls to Sxx-DLL-code!

	// RegisterFactory must now be before ScModuleDummy is created
	ScDocShell::RegisterFactory( SDT_SC_DOCFACTPRIO );

	// create a dummy-module for Object-Factory-Pointer
	ScModuleDummy* pMod = new ScModuleDummy( NULL, TRUE, &ScDocShell::Factory() );
	pMod->pSignalFunc = &ScLibSignal;
	SC_DLL() = pMod;
}

void ScDLL::PreExit()
{
	//	PreExit wird aus Exit() gerufen und loescht das Module.
	//	Der Module-dtor muss alle Daten loeschen, die z.B. noch die Svx-DLL brauchen.

	ScModuleDummy **ppShlPtr = (ScModuleDummy**) GetAppData(SHL_CALC);
#ifndef SO3
	SvFactory *pFact = (*ppShlPtr)->pScDocShellFactory;
#else
	SvFactory *pFact = (SvFactory*)(*ppShlPtr)->pScDocShellFactory;
#endif
	delete (*ppShlPtr);
	(*ppShlPtr) = new ScModuleDummy( NULL, TRUE, NULL);
	(*ppShlPtr)->pScDocShellFactory = pFact;

	//	Der ModuleDummy mit der Factory wird z.B. noch bei SvFactory::DeInit() gebraucht.
}

void ScDLL::LibExit()
{
	//	LibExit wird am Ende von Main() gerufen und gibt die DLL selber frei

	FreeLibSc();	// DLL freigeben (ruft ScDLL::Exit)

	//	das sollte jetzt nur noch ein Dummy sein:

	ScModuleDummy **ppShlPtr = (ScModuleDummy**) GetAppData(SHL_CALC);
	delete (*ppShlPtr);
	(*ppShlPtr) = NULL;
}

//------------------------------------------------------------------

ULONG __EXPORT ScDLL::DetectFilter( SfxMedium& rMedium, const SfxFilter** ppFilter,
									SfxFilterFlags nMust, SfxFilterFlags nDont )
{
	//	#59915# laut MBA darf hier nur ERRCODE_NONE, ERRCODE_ABORT und ERRCODE_FORCEQUIET
	//	zurueckgegeben werden...

	if ( SVSTREAM_OK != rMedium.GetError() )
		return ERRCODE_ABORT;	// ERRCODE_IO_GENERAL

	//	Formate, die sicher erkannt werden:

	if ( rMedium.IsStorage() )
	{
		String		aStreamName;
		SvStorage*	pStorage = rMedium.GetStorage();

		if ( pStorage == NULL )
			return ERRCODE_ABORT;	// ERRCODE_IO_GENERAL

		// Erkennung ueber contained streams
		// Excel-5 / StarCalc 3.0

		aStreamName = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("Workbook"));
		if ( pStorage->IsContained( aStreamName ) && pStorage->IsStream( aStreamName ) )
		{
			if ( *ppFilter && (*ppFilter)->GetFilterName().EqualsAscii(pFilterEx97Temp) )
			{
				//	Excel 97-Vorlage eingestellt -> auch gut
			}
			else
			{
				//	sonst Excel 97-Datei
				*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
									  String::CreateFromAscii(pFilterExcel97) );
			}
			return ERRCODE_NONE;
		}
		aStreamName = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("Book"));
		if ( pStorage->IsContained( aStreamName ) && pStorage->IsStream( aStreamName ) )
		{
			String aOldName;
			if ( *ppFilter ) aOldName = (*ppFilter)->GetFilterName();
			if ( aOldName.EqualsAscii(pFilterExcel95) || aOldName.EqualsAscii(pFilterEx95Temp) ||
					aOldName.EqualsAscii(pFilterEx5Temp) )
			{
				//	Excel 95 oder Vorlage (5 oder 95) eingestellt -> auch gut
			}
			else
			{
				//	sonst wird als Excel 5-Datei erkannt
				*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
										String::CreateFromAscii(pFilterExcel5) );
			}
			return ERRCODE_NONE;
		}

		aStreamName = String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(STRING_SCSTREAM));
		if ( pStorage->IsContained( aStreamName ) && pStorage->IsStream( aStreamName ) )
		{
			//	Unterscheidung 3.0 / 4.0 / 5.0 ueber Clipboard-Id
			ULONG nStorFmt = pStorage->GetFormat();
			if ( nStorFmt == SOT_FORMATSTR_ID_STARCALC_30 )
				*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
											String::CreateFromAscii(pFilterSc30) );
			else if ( nStorFmt == SOT_FORMATSTR_ID_STARCALC_40 )
				*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
											String::CreateFromAscii(pFilterSc40) );
			else
				*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
											String::CreateFromAscii(pFilterSc50) );
			return ERRCODE_NONE;
		}
	}
	else // if ( !bIsStorage )
	{
		SvStream &rStr = *rMedium.GetInStream();
		if ( &rStr == NULL )
			return ERRCODE_ABORT;	// ERRCODE_IO_GENERAL

		// Tabelle mit Suchmustern
		// Bedeutung der Sequenzen
		// 0x00??: genau Byte 0x?? muss an dieser Stelle stehen
		// 0x0100: ein Byte ueberlesen (don't care)
		// 0x02nn: ein Byte aus 0xnn Alternativen folgt
		// 0x8000: Erkennung abgeschlossen
		//
		const UINT16 nAnzMuster = 9;	// sollte fuer indiz. Zugriff stimmen...

#define M_DC		0x0100
#define M_ALT(ANZ)	0x0200+ANZ
#define M_ENDE		0x8000

		const UINT16 pLotus[] = 		// Lotus 1/1A/2
			{ 0x0000, 0x0000, 0x0002, 0x0000,
			  M_ALT(2), 0x0004, 0x0006,
			  0x0004, M_ENDE };

		const UINT16 pExcel1[] =		// Excel Biff/3/4 Tabellen
			{ 0x0009,
			  M_ALT(2), 0x0002, 0x0004,
			  0x0006, 0x0000, M_DC, M_DC, 0x0010, 0x0000,
			  M_DC, M_DC, M_ENDE };

		const UINT16 pExcel2[] =		// Excel Biff3/4 Workbooks
			{ 0x0009,
			  M_ALT(2), 0x0002, 0x0004,
			  0x0006, 0x0000, M_DC, M_DC, 0x0000, 0x0001,
			  M_DC, M_DC, M_ENDE };

		const UINT16 pExcel3[] =		// Excel Biff2 Tabellen
			{ 0x0009, 0x0000, 0x0004, 0x0000,
			  M_DC, M_DC, 0x0010, 0x0000, M_ENDE };

		const UINT16 pSc10[] =			// StarCalc 1.0 Dokumente
			{ 'B', 'l', 'a', 'i', 's', 'e', '-', 'T', 'a', 'b', 'e', 'l', 'l',
			  'e', 0x000A, 0x000D, 0x0000,    // Sc10CopyRight[16]
			  M_DC, M_DC, M_DC, M_DC, M_DC, M_DC, M_DC, M_DC, M_DC, M_DC, M_DC,
			  M_DC, M_DC, 					// Sc10CopyRight[29]
			  M_ALT(2), 0x0065, 0x0066,		// Versionsnummer 101 oder 102
			  0x0000,
			  M_ENDE };

		const UINT16 pLotus2[] =		// Lotus >3
			{ 0x0000, 0x0000, 0x001A, 0x0000,	// Rec# + Len (26)
			  M_ALT(2), 0x0000, 0x0002,			// File Revision Code
			  0x0010,
			  0x0004, 0x0000,					// File Revision Subcode
			  M_ENDE };

		const UINT16 pDIF1[] =			// DIF mit CR-LF
			{
			'T', 'A', 'B', 'L', 'E',
			M_DC, M_DC,
			'0', ',', '1',
			M_DC, M_DC,
			'\"',
			M_ENDE };

		const UINT16 pDIF2[] =			// DIF mit CR oder LF
			{
			'T', 'A', 'B', 'L', 'E',
			M_DC,
			'0', ',', '1',
			M_DC,
			'\"',
			M_ENDE };

		const UINT16 pSylk[] =			// Sylk
			{
			'I', 'D', ';', 'P',
			M_ENDE };

#ifdef SINIX
		UINT16 *ppMuster[ nAnzMuster ];			// Arrays mit Suchmustern
		ppMuster[ 0 ] = pLotus;
		ppMuster[ 1 ] = pExcel1;
		ppMuster[ 2 ] = pExcel2;
		ppMuster[ 3 ] = pExcel3;
		ppMuster[ 4 ] = pSc10;
		ppMuster[ 5 ] = pDIF1;
		ppMuster[ 6 ] = pDIF2;
		ppMuster[ 7 ] = pSylk;
		ppMuster[ 8 ] = pLotus2;				// Lotus immer ganz hinten wegen Ini-Eintrag
#else
		const UINT16 *ppMuster[] =		// Arrays mit Suchmustern
			{
			pLotus,
			pExcel1,
			pExcel2,
			pExcel3,
			pSc10,
			pDIF1,
			pDIF2,
			pSylk,
			pLotus2
			};
#endif

		const sal_Char* pFilterName[] = 	// zugehoerige Filter
			{
			pFilterLotus,
			pFilterExcel4,
			pFilterExcel4,
			pFilterExcel4,
			pFilterSc10,
			pFilterDif,
			pFilterDif,
			pFilterSylk,
			pFilterLotus
			};

		const UINT16 nByteMask = 0xFF;

		// suchen Sie jetzt!
		// ... realisiert ueber 'Mustererkennung'

		BYTE			nAkt;
		BOOL			bSync;			// Datei und Muster stimmen ueberein
		USHORT			nFilter;		// Zaehler ueber alle Filter
		const UINT16	*pSearch;		// aktuelles Musterwort
		UINT16			nFilterLimit = nAnzMuster;

		// nur solange, bis es etwas Globales gibt
		// funzt nur, solange Eintraege fuer WK3 letzte Muster-Tabelle ist!
		SfxIniManager	*pIniManager = SFX_INIMANAGER();

		DBG_ASSERT( pIniManager,
			"-ScApplication::DetectFilter(): no manager -> rums!" );

		if( pIniManager->Get( SFX_GROUP_COMMON,
				String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("WK3")) ) != '1' )
			nFilterLimit--;

		for ( nFilter = 0 ; nFilter < nFilterLimit ; nFilter++ )
		{
			rStr.Seek( 0 ); // am Anfang war alles Uebel...
			rStr >> nAkt;
			pSearch = ppMuster[ nFilter ];
			bSync = TRUE;
			while( !rStr.IsEof() && bSync )
			{
				register UINT16 nMuster = *pSearch;

				if( nMuster < 0x0100 )
				{ // 								direkter Byte-Vergleich
					if( ( BYTE ) nMuster != nAkt )
						bSync = FALSE;
				}
				else if( nMuster & M_DC )
				{ // 											 don't care
				}
				else if( nMuster & M_ALT(0) )
				{ // 									  alternative Bytes
					BYTE nAnzAlt = ( BYTE ) nMuster;
					bSync = FALSE;			// zunaechst unsynchron
					while( nAnzAlt > 0 )
					{
						pSearch++;
						if( ( BYTE ) *pSearch == nAkt )
							bSync = TRUE;	// jetzt erst Synchronisierung
						nAnzAlt--;
					}
				}
				else if( nMuster & M_ENDE )
				{ // 										Format detected
					if ( pFilterName[nFilter] == pFilterExcel4 && *ppFilter &&
							(*ppFilter)->GetFilterName().EqualsAscii(pFilterEx4Temp) )
					{
						//	Excel 4 erkannt, Excel 4 Vorlage eingestellt -> auch gut
					}
					else
					{	// gefundenen Filter einstellen
						*ppFilter = SFX_APP()->GetFilter(
							ScDocShell::Factory(),
							String::CreateFromAscii(pFilterName[ nFilter ]) );
					}

					return ERRCODE_NONE;
				}
				else
				{ // 										 Tabellenfehler
					DBG_ERROR( "-ScApplication::DetectFilter(): Fehler in Mustertabelle");
				}

				pSearch++;
				rStr >> nAkt;
			}
		}

		// HTML testen

		rStr.Seek( 0 );
		const int nTrySize = 80;
		ByteString aHeader;
		for ( int j = 0; j < nTrySize && !rStr.IsEof(); j++ )
		{
			sal_Char c;
			rStr >> c;
			aHeader += c;
		}
		aHeader += '\0';
		if ( HTMLParser::IsHTMLFormat( aHeader.GetBuffer() ) )
		{
			*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
											  String::CreateFromAscii(pFilterHtml) );
			return ERRCODE_NONE;
		}
	}

	//	Das Item SID_FILTER_NAME am Medium wird nicht mehr ausgewertet (wegen Bug 32455)

	//	ASCII, dBase und RTF koennen wir nicht erkennen, darum muessen wir glauben,
	//	wenn jemand behauptet, dass es das waere (#34922#):

	if ( *ppFilter && !rMedium.IsStorage() )
	{
		String aName = (*ppFilter)->GetFilterName();
		if ( aName.EqualsAscii(pFilterAscii) || aName.EqualsAscii(pFilterDBase) ||
			 aName.EqualsAscii(pFilterRtf) || aName.EqualsAscii(pFilterXML) )
			return ERRCODE_NONE;
	}


	//	Wenn sonst nichts geht, dann halt ASCII (wenn kein Storage)
	//!	vorher RTF/dBase erkennen !!!

#if 0
// #33511# laut TLX kein GetFilter/DetectFilter mehr an SFX_APP, dat is jetzt DeskTop
	if ( !rMedium.IsStorage() )
		*ppFilter = SFX_APP()->GetFilter( ScDocShell::Factory(),
										  String(pFilterAscii) );

	// rate mal mit dem Sfx:

	return SFX_APP()->DetectFilter( rMedium, ppFilter );
#endif

	return ERRCODE_ABORT;		// war nix
}

/*------------------------------------------------------------------------

	$Log: sclib.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:44:53  hr
	initial import
	
	Revision 1.44  2000/09/17 14:08:54  willem.vandorp
	OpenOffice header added.
	
	Revision 1.43  2000/08/31 16:38:18  willem.vandorp
	Header and footer replaced
	
	Revision 1.42  2000/05/11 17:00:15  nn
	LibString for SFX_IMPL_OBJECTFACTORY_LIB must be a string
	
	Revision 1.41  2000/04/19 16:40:17  nn
	unicode changes
	
	Revision 1.40  2000/04/17 13:26:28  nn
	unicode changes
	
	Revision 1.39  2000/03/08 16:12:48  nn
	xml filter
	
	Revision 1.38  2000/02/11 12:22:07  hr
	#70473# changes for unicode ( patched by automated patchtool )
	
	Revision 1.37  1999/11/22 15:28:48  nn
	new module names
	
	Revision 1.36  1999/11/19 08:37:42  nn
	LibInit: create ModuleDummy after RegisterFactory, with Factory pointer
	
	Revision 1.35  1999/05/28 09:18:34  NN
	#65310# SetDocumentServiceName (fuer StarOne Filter)
	

	  Rev 1.34   28 May 1999 11:18:34   NN
   #65310# SetDocumentServiceName (fuer StarOne Filter)

	  Rev 1.33   19 Feb 1999 18:04:18   NN
   #60723# Excel-Vorlagen-Filter bei DetectFilter beruecksichtigen

	  Rev 1.32   11 Jan 1999 09:49:02   TJ
   Cast

	  Rev 1.31   27 Nov 1998 14:19:08   NN
   #59398# Clipboard-IDs fuer StarCalc Dokumente

	  Rev 1.30   10 Nov 1998 21:51:10   NN
   #59115# DetectFilter darf nicht 1 zurueckgeben

	  Rev 1.29   22 Jul 1998 16:52:22   NN
   #53074# nur noch Calc5 und Vorlage hart als Filter registieren

	  Rev 1.28   14 Jul 1998 20:00:28   NN
   #52430# 5.0-Filter mit neuem Mime-Type registrieren

	  Rev 1.27   02 Jul 1998 12:20:28   NN
   Excel 95, 97

	  Rev 1.26   20 Feb 1998 22:09:44   NN
   381: Headerfiles verschoben

	  Rev 1.25   13 Feb 1998 15:18:58   MH
   del: ifndef UNX

	  Rev 1.24   07 Jan 1998 10:56:56   NN
   Umstellung 4.0 -> 5.0

	  Rev 1.23   05 Dec 1997 20:06:08   ANK
   Includes geaendert

	  Rev 1.22   03 Sep 1997 17:49:06   RG
   change header

	  Rev 1.21   06 Aug 1997 15:42:48   TRI
   VCL: Anpassungen

	  Rev 1.20   11 Jun 1997 11:22:34   NN
   DetectFilter mit SfxFilterFlags

	  Rev 1.19   23 Apr 1997 11:45:26   TRI
   ICC brauchte diverse Casts

	  Rev 1.18   21 Apr 1997 20:47:00   NN
   #39039# Module-Dummy darf nach PreExit doch nicht 0 sein

	  Rev 1.17   21 Apr 1997 18:27:22   NN
   #39039# PreExit (Module loeschen)

	  Rev 1.16   18 Apr 1997 13:07:24   NN
   FreeLibSc im LibExit

	  Rev 1.15   20 Mar 1997 12:49:42   NN
   MS Excel 4 -> MS Excel 4.0, MS Excel 5 -> MS Excel 5.0/95

	  Rev 1.14   12 Mar 1997 17:32:12   NN
   Excel und Lotus Filter ohne (StarCalc) hintendran

	  Rev 1.13   11 Mar 1997 16:39:58   NN
   Filter-Namen vereindeutigt

	  Rev 1.12   16 Jan 1997 19:41:42   NN
   #34922# bei nicht erkennbaren Formaten keinen Fehler zurueck

	  Rev 1.11   23 Nov 1996 12:34:54   ER
   #33511# laut TLX kein GetFilter/DetectFilter mehr an SFX_APP rufen

	  Rev 1.10   22 Nov 1996 11:55:32   ER
   #33275# signal() Wrapper an der App wg. BLC-Dummbatz

	  Rev 1.9   22 Nov 1996 11:18:46   mda
   scdll0.hxx unter UNIX nicht included

	  Rev 1.8   21 Nov 1996 15:29:30   NN
   scalc3 -> scalc4

	  Rev 1.7   20 Nov 1996 12:43:10   NN
   GetID/HasID, 4.0-Format

	  Rev 1.6   19 Nov 1996 16:35:18   NN
   DetectFilter: richtige Factory

	  Rev 1.5   14 Nov 1996 11:55:04   NN
   Filter-Registrierung/DetectFilter ohne Calc-ResourceDLL

	  Rev 1.4   11 Nov 1996 17:33:32   NN
   Load ueberladen

	  Rev 1.3   08 Nov 1996 15:04:42   NF
   ScGlobal mit #define _SCALC_EXE ausdeffiniert

	  Rev 1.2   07 Nov 1996 16:03:58   TRI
   WIN16 braucht svwin.h

	  Rev 1.1   06 Nov 1996 14:19:40   NN
   Prio bei RegisterFactory, ModuleDummy mit Calc-ResourceManager

	  Rev 1.0   05 Nov 1996 14:34:02   NN
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


