/*************************************************************************
 *
 *  $RCSfile: drawsh1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:44:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------


//------------------------------------------------------------------

#include "scitems.hxx"
#include <tools/list.hxx>
#include <sfx2/bindings.hxx>
#include <sfx2/app.hxx>
#include <sfx2/request.hxx>
#include <sfx2/viewfrm.hxx>

#include "drawsh.hxx"
#include "sc.hrc"
#include "drawview.hxx"
#include "viewdata.hxx"
#include "tabvwsh.hxx"

USHORT ScGetFontWorkId();		// wegen CLOOKs - in drtxtob2

//------------------------------------------------------------------

//
//			Funktionen auf Drawing-Objekten
//

void ScDrawShell::ExecDrawFunc( SfxRequest& rReq )
{
	SfxBindings& rBindings = SFX_BINDINGS();
	ScTabView*	 pTabView  = pViewData->GetView();
	ScDrawView*  pView	   = pTabView->GetScDrawView();
	Window* 	 pWin	   = pTabView->GetActiveWin();
	const SfxItemSet *pArgs = rReq.GetArgs();
	USHORT nSlotId = rReq.GetSlot();

	//!!!
	// wer weiss, wie lange das funktioniert? (->vom Abreisscontrol funktioniert es)
	//
	if (nSlotId == SID_OBJECT_ALIGN && pArgs)
		nSlotId = SID_OBJECT_ALIGN + ((SfxEnumItem&)pArgs->Get(SID_OBJECT_ALIGN)).GetValue() + 1;

	switch (nSlotId)
	{
		case SID_OBJECT_HEAVEN:
			pView->SetMarkedToLayer( SC_LAYER_FRONT );
			rBindings.Invalidate(SID_OBJECT_HEAVEN);
			rBindings.Invalidate(SID_OBJECT_HELL);
			break;
		case SID_OBJECT_HELL:
			pView->SetMarkedToLayer( SC_LAYER_BACK );
			rBindings.Invalidate(SID_OBJECT_HEAVEN);
			rBindings.Invalidate(SID_OBJECT_HELL);
			break;

		case SID_FRAME_TO_TOP:
			pView->PutMarkedToTop();
			break;
		case SID_FRAME_TO_BOTTOM:
			pView->PutMarkedToBtm();
			break;
		case SID_FRAME_UP:
			pView->MovMarkedToTop();
			break;
		case SID_FRAME_DOWN:
			pView->MovMarkedToBtm();
			break;

		case SID_GROUP:
			pView->GroupMarked();
			break;
		case SID_UNGROUP:
			pView->UnGroupMarked();
			break;
		case SID_ENTER_GROUP:
			pView->EnterMarkedGroup();
			break;
		case SID_LEAVE_GROUP:
			pView->LeaveOneGroup();
			break;

		case SID_MIRROR_HORIZONTAL:
			pView->MirrorAllMarkedHorizontal();
			break;
		case SID_MIRROR_VERTICAL:
			pView->MirrorAllMarkedVertical();
			break;

		case SID_OBJECT_ALIGN_LEFT:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_LEFT, SDRVALIGN_NONE);
			break;
		case SID_OBJECT_ALIGN_CENTER:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_CENTER, SDRVALIGN_NONE);
			break;
		case SID_OBJECT_ALIGN_RIGHT:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_RIGHT, SDRVALIGN_NONE);
			break;
		case SID_OBJECT_ALIGN_UP:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_TOP);
			break;
		case SID_OBJECT_ALIGN_MIDDLE:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_CENTER);
			break;
		case SID_OBJECT_ALIGN_DOWN:
			if (pView->IsAlignPossible())
				pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_BOTTOM);
			break;

		case SID_DELETE:
		case SID_DELETE_CONTENTS:
			pView->DeleteMarked();
			if (!pTabView->IsDrawSelMode())
				pViewData->GetViewShell()->SetDrawShell( FALSE );
			break;

		case SID_CUT:
			pView->DoCut();
			if (!pTabView->IsDrawSelMode())
				pViewData->GetViewShell()->SetDrawShell( FALSE );
			break;

		case SID_COPY:
			pView->DoCopy();
			break;

		case SID_PASTE:
			pView->PasteClipboard( pWin );			// Fenster fuer Position
			break;

		case SID_SELECTALL:
			pView->MarkAll();
			break;

		case SID_ANCHOR_PAGE:
			pView->SetAnchor( SCA_PAGE );
			rBindings.Invalidate( SID_ANCHOR_PAGE );
			rBindings.Invalidate( SID_ANCHOR_CELL );
			break;

		case SID_ANCHOR_CELL:
			pView->SetAnchor( SCA_CELL );
			rBindings.Invalidate( SID_ANCHOR_PAGE );
			rBindings.Invalidate( SID_ANCHOR_CELL );
			break;

		case SID_ANCHOR_TOGGLE:
			{
				switch( pView->GetAnchor() )
				{
					case SCA_CELL:
					pView->SetAnchor( SCA_PAGE );
					break;
					default:
					pView->SetAnchor( SCA_CELL );
					break;
				}
			}
			rBindings.Invalidate( SID_ANCHOR_PAGE );
			rBindings.Invalidate( SID_ANCHOR_CELL );
			break;

		case SID_OBJECT_ROTATE:
			{
				SdrDragMode eMode;
				if (pView->GetDragMode() == SDRDRAG_ROTATE)
					eMode = SDRDRAG_MOVE;
				else
					eMode = SDRDRAG_ROTATE;
				pView->SetDragMode( eMode );
				rBindings.Invalidate( SID_OBJECT_ROTATE );
				rBindings.Invalidate( SID_OBJECT_MIRROR );
				if (eMode == SDRDRAG_ROTATE && !pView->IsFrameDragSingles())
				{
					pView->SetFrameDragSingles( TRUE );
					rBindings.Invalidate( SID_BEZIER_EDIT );
				}
			}
			break;
		case SID_OBJECT_MIRROR:
			{
				SdrDragMode eMode;
				if (pView->GetDragMode() == SDRDRAG_MIRROR)
					eMode = SDRDRAG_MOVE;
				else
					eMode = SDRDRAG_MIRROR;
				pView->SetDragMode( eMode );
				rBindings.Invalidate( SID_OBJECT_ROTATE );
				rBindings.Invalidate( SID_OBJECT_MIRROR );
				if (eMode == SDRDRAG_MIRROR && !pView->IsFrameDragSingles())
				{
					pView->SetFrameDragSingles( TRUE );
					rBindings.Invalidate( SID_BEZIER_EDIT );
				}
			}
			break;
		case SID_BEZIER_EDIT:
			{
				BOOL bOld = pView->IsFrameDragSingles();
				pView->SetFrameDragSingles( !bOld );
				rBindings.Invalidate( SID_BEZIER_EDIT );
				if (bOld && pView->GetDragMode() != SDRDRAG_MOVE)
				{
					pView->SetDragMode( SDRDRAG_MOVE );
					rBindings.Invalidate( SID_OBJECT_ROTATE );
					rBindings.Invalidate( SID_OBJECT_MIRROR );
				}
			}
			break;

		case SID_FONTWORK:
		{
			USHORT nId = ScGetFontWorkId();
			SfxViewFrame* pViewFrm = pViewData->GetViewShell()->GetViewFrame();

			if ( rReq.GetArgs() )
				pViewFrm->SetChildWindow( nId,
										   ((const SfxBoolItem&)
											(rReq.GetArgs()->Get(SID_FONTWORK))).
												GetValue() );
			else
				pViewFrm->ToggleChildWindow( nId );

			rBindings.Invalidate( SID_FONTWORK );
			rReq.Done();
		}
		break;

		case SID_ORIGINALSIZE:
			pView->SetMarkedOriginalSize();
			break;

		default:
			break;
	}
}



