/*************************************************************************
 *
 *  $RCSfile: optload.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:45:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

#include <svx/dlgutil.hxx>
#include <svx/drawitem.hxx>
#include <svx/xtable.hxx>
#include <offmgr/app.hxx>

#include "appoptio.hxx"
#include "scmod.hxx"
#include "scitems.hxx"
#include "tpview.hxx"
#include "global.hxx"
#include "viewopti.hxx"
#include "tabvwsh.hxx"
#include "uiitems.hxx"
#include "scresid.hxx"
#include "docsh.hxx"
#include "sc.hrc"       // -> Slot-IDs
#include "optdlg.hrc"
#include "globstr.hrc"

#include "optload.hrc"
#include "optload.hxx"

/* -----------------22.10.98 15:12-------------------
 *
 * --------------------------------------------------*/

ScLoadOptPage::ScLoadOptPage( Window* pParent, const SfxItemSet& rSet ) :
	SfxTabPage(pParent, ScResId(RID_SCPAGE_OPTLOAD), rSet),
	aLinkFT(this, ResId(FT_UPDATE_LINKS	)),
	aAlwaysRB	(this, ResId(RB_ALWAYS	)),
	aRequestRB	(this, ResId(RB_REQUEST	)),
	aNeverRB	(this, ResId(RB_NEVER	)),
	aDocOnlyCB  (this, ResId(CB_DOCONLY )),
	aLinkGB		(this, ResId(GB_LINK	)),
	pDoc(NULL)
{
	FreeResource();
}

ScLoadOptPage::~ScLoadOptPage()
{
}

IMPL_LINK(	ScLoadOptPage, UpdateHdl, CheckBox*, pBox )
{
	return 0;
}

SfxTabPage*	__EXPORT ScLoadOptPage::Create( Window* pParent,
								const SfxItemSet& rAttrSet )
{
	ScLoadOptPage* pNew = new ScLoadOptPage(pParent, rAttrSet );
	ScDocShell* pDocSh = PTR_CAST(ScDocShell,SfxObjectShell::Current());

	if(pDocSh!=NULL)
		pNew->SetDocument(pDocSh->GetDocument());

	return pNew;
}

BOOL __EXPORT ScLoadOptPage::FillItemSet( SfxItemSet& rSet )
{
	BOOL bRet = FALSE;
	bRet = TRUE;

	ScLkUpdMode nSet=LM_ALWAYS;

	if(aRequestRB.IsChecked())
	{
		nSet=LM_ON_DEMAND;
	}
	else if(aNeverRB.IsChecked())
	{
		nSet=LM_NEVER;
	}

	if(pDoc!=NULL)
	{
		pDoc->SetLinkMode(nSet);
	}

	if(!aDocOnlyCB.IsChecked())
	{
		ScAppOptions aAppOptions=SC_MOD()->GetAppOptions();

		aAppOptions.SetLinkMode(nSet );

		SC_MOD()->SetAppOptions(aAppOptions);
	}

	return bRet;
}

void __EXPORT ScLoadOptPage::Reset( const SfxItemSet& rSet)
{
	ScLkUpdMode nSet=LM_UNKNOWN;

	if(pDoc!=NULL)
	{
		nSet=pDoc->GetLinkMode();
	}

	if(nSet==LM_UNKNOWN)
	{
		ScAppOptions aAppOptions=SC_MOD()->GetAppOptions();
		nSet=aAppOptions.GetLinkMode();
	}

	switch(nSet)
	{
		case LM_ALWAYS:		aAlwaysRB.	Check();	break;
		case LM_NEVER:		aNeverRB.	Check();	break;
		case LM_ON_DEMAND:	aRequestRB.	Check();	break;
	}
}

void __EXPORT ScLoadOptPage::SetDocument(ScDocument* pPtr)
{
	pDoc=pPtr;

	if(pDoc!=NULL)
	{
		aDocOnlyCB.Enable();
	}
	else
	{
		aDocOnlyCB.Disable();
	}
}

