/*************************************************************************
 *
 *  $RCSfile: chtmodel.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _CHTMODEL_HXX
#define _CHTMODEL_HXX

//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------
class SdrObjGroup;
class SdrRectObj;

#ifndef _E3D_POLYGON3D_HXX //autogen
#include <svx/polygn3d.hxx>
#endif
#ifndef _E3D_EXTRUD3D_HXX //autogen
#include <svx/extrud3d.hxx>
#endif
#ifndef _E3D_OBJ3D_HXX
#include "svx/obj3d.hxx"
#endif

#ifndef _SVX_VCATTR_HXX //autogen
#include <basctl/vcattr.hxx>
#endif

#ifndef _POLY3D_HXX
#include "svx/poly3d.hxx"
#endif

#ifndef _VIEWPT3D_HXX //autogen
#include <svx/viewpt3d.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SVDTRANS_HXX //autogen
#include <svx/svdtrans.hxx>
#endif
#ifndef _GEN_HXX //autogen
#include <tools/gen.hxx>
#endif
#ifndef _SV_COLOR_HXX //autogen
#include <vcl/color.hxx>
#endif
#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _SVX_CHRTITEM_HXX //autogen
#include <svx/chrtitem.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _OUTLINER_HXX //autogen
#include <svx/svdoutl.hxx>
#endif
#ifndef _SCH_ADJUST_HXX //autogen
#include "adjust.hxx"
#endif
#ifndef _SVDOTEXT_HXX //autogen
#include <svx/svdotext.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif
#ifndef _SVDMODEL_HXX //autogen
#include <svx/svdmodel.hxx>
#endif
#ifndef _PERSIST_HXX //autogen
#include <so3/persist.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif
#ifndef _DEFINES_HXX
#include "defines.hxx"
#endif
#include "chartbar.hxx"


class SchObjectId;
class ChartAxis;
class SvNumberFormatter;
class SvULONGTable;
class SchItemPool;
class SchMemChart;
class Vector3D;
class ChartScene;
class E3dPolyObj;
class Polygon3D;
class E3dCompoundObject;
class E3dObject;
class SfxPrinter;
class E3dLabelObj;
class SchDataLogBook;
class SvxShape;
class SchShape;
class E3dLabelObj;
struct DataDescription;
class SchRectObj;

DECLARE_LIST(ItemSetList, SfxItemSet*);
DECLARE_LIST(DescrList, E3dLabelObj*);

#define VERTICAL_LINE aLine[0].Y() = rRect.Bottom(); aLine[1].Y() = rRect.Top();
#define HORIZONTAL_LINE aLine[0].X() = rRect.Left(); aLine[1].X() = rRect.Right();
#define LONGMARKS ((nMarkLen * 3) / 2)
#define TEXTHEIGHT_OFS 2
#define DEFAULT_COLCNT 3
#define DEFAULT_ROWCNT 4

//Die war mal in Ui/DiagrTyp.hxx

#define CHTYPE_INVALID			0

#define CHTYPE_LINE				1
#define CHTYPE_LINESYMB			2	// this one has to be removed !! (why?)
#define CHTYPE_AREA				3
#define CHTYPE_COLUMN			4	// is also a bar-type
#define CHTYPE_BAR				5
#define CHTYPE_CIRCLE			6
#define CHTYPE_XY				7
#define CHTYPE_NET				8
#define CHTYPE_DONUT			9
#define CHTYPE_STOCK		   10

#define SETLINES_BLACK			1
#define SETLINES_FILLCOLOR		2
#define SETLINES_COMPAT			3
#define SETLINES_REVERSE		4

#define SYMBOLMODE_LEGEND       1   // symbol for leged (default)
#define SYMBOLMODE_DESCRIPTION  2   // symbol for series data description
#define SYMBOLMODE_LINE         3   // unused (line as symbol)
#define SYMBOLMODE_ROW          4   // unused (symbol for series)

#define   SETFLAG( status, flag )   (status)|= (flag)
#define RESETFLAG( status, flag )   (status) = ((status) | (flag)) - (flag)
#define ISFLAGSET( status, flag )	(status) & (flag)

#define CHS_USER_QUERY			0	// ask for sorting data for xy charts
#define CHS_USER_NOQUERY		1	// do not ask for sorting

#define CHART_NUM_SYMBOLS		8	// number of different polygons as symbols

#define CHART_AXIS_PRIMARY_X	1	// never change these defines (persistent) !!!
#define CHART_AXIS_PRIMARY_Y	2
#define CHART_AXIS_PRIMARY_Z	3
#define CHART_AXIS_SECONDARY_Y	4
#define CHART_AXIS_SECONDARY_X	5

#ifdef DBG_UTIL
#define CHART_TRACE(  w )			DBG_TRACE1( "SCH(%lx):" ##w, (long)this )
#define CHART_TRACE1( w,a )			DBG_TRACE2( "SCH(%lx):" ##w, (long)this, a )
#define CHART_TRACE2( w,a,b )		DBG_TRACE3( "SCH(%lx):" ##w, (long)this, a,b )
#define CHART_TRACE3( w,a,b,c )		DBG_TRACE4( "SCH(%lx):" ##w, (long)this, a,b,c )
#define CHART_TRACE4( w,a,b,c,d )	DBG_TRACE5( "SCH(%lx):" ##w, (long)this, a,b,c,d )
#else
#define CHART_TRACE(  w )
#define CHART_TRACE1( w,a )
#define CHART_TRACE2( w,a,b )
#define CHART_TRACE3( w,a,b,c )
#define CHART_TRACE4( w,a,b,c,d )
#endif

class ChartModel : public SdrModel
{
private:
	ChartBarDescriptor aBarY1;
	ChartBarDescriptor aBarY2;

	DescrList aXDescrList;
	DescrList aYDescrList;
	DescrList aZDescrList;

	BOOL bClearDepth;

	BOOL bNewOrLoadCompleted;
	BOOL bFreshLoaded;

	SfxObjectShell*	pDocShell;
	VCItemPool*	   	pVCItemPool;


	SchShape* pMainTitleShape;
	SchShape* pSubTitleShape;
	SchShape* pXAxisTitleShape;
	SchShape* pYAxisTitleShape;
	SchShape* pZAxisTitleShape;
	SchShape* pLegendShape;
	SchShape* pAreaShape;

	BOOL bAttrAutoStorage;

	// save data in buffer while editing chart #61907#
	SchMemChart*    pChartDataBuffered;


	//Aus Globfunc


	OutputDevice *pChartRefOutDev;
	long nChartStatus;

	Window* pAutoPilot;//#46895#

	SdrObjList *pSdrObjList;

	Matrix4D aSceneMatrix;

	BOOL bResizePie;
	long nPieRadius;

	SvNumberFormatter*  pNumFormatter;		// points either to pOwnNumFormatter or calc's number formatter

	//n2==-1 => lschen!
	void SwapDataPointAttr(long n1,long n2=-1);

public:



	void SetTextFromObject( SdrTextObj* pObj, OutlinerParaObject* pTextObject );
	void PrepareOld3DStorage();
	void CleanupOld3DStorage();

	void Segment3DDescr (DataDescription &rDescr,
				   const Rectangle &rRect,
				   long            nStartAng,
				   long            nEndAng,
				   long            nHeight,
				   double          a,
				   double          b,
				   double		   fZ);


	BOOL IsReal3D()const {return (Is3DChart() /*&& !IsPieChart()*/);};
	BOOL HasBarConnectors(long nRow) const
	{
		return (BOOL)(m_nDefaultColorSet&CHSPECIAL_TRACELINES);
	}
	void SetBarConnectors(BOOL bOn,long nRow)
	{
		m_nDefaultColorSet = bOn
			? m_nDefaultColorSet|CHSPECIAL_TRACELINES
			:(m_nDefaultColorSet|CHSPECIAL_TRACELINES) - CHSPECIAL_TRACELINES;
	}


	BOOL IsCol(long nRow) const;
	BOOL IsArea(long nRow);

	BOOL CanAxis(long nAxisId) const;

	SdrObject *CreateDefaultSymbol(long nRow);
	SdrObject *CreateSymbol (Point      aPoint,
						 int        nRow,
						 int        nColumn,
						 SfxItemSet &aDataAttr,
						 long       nSymbolSize,
						 BOOL       bInsert = TRUE);


	void GenerateSymbolAttr(SfxItemSet& rSymbolAttr,const long nRow,const long nMode=SYMBOLMODE_LEGEND);//#63904#
	SdrObjList *GetSdrObjList();
	void DrawStockBars(SdrObjList* pList,const Rectangle& rRect);
	BOOL HasStockBars( SvxChartStyle* pStyle=NULL );
	ChartAxis* GetAxisByUID(long nUId);
	void PrepareAxisStorage();
	ChartAxis* GetAxis(long nId);
	BOOL HasSecondYAxis() const;
	inline BOOL IsXVertikal() const { return IsBar(); }
	void DrawStockLines(SdrObjList* pList,const Rectangle& rRect);
	BOOL HasStockLines( SvxChartStyle* pStyle=NULL );
	BOOL HasStockRects( SvxChartStyle* pStyle=NULL );

	void LockBuild();
	void UnlockBuild();
	BOOL IsLockedBuild();

	void SwapRowAttr(long nRow1,long nRow2);
	BOOL MoveRow(long nRow,BOOL bUp=TRUE);
	long GetChartShapeType();
	long GetChartShapeType(long nRow);

	void SetAttributes(const long nId,const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	void CopyAxisAttributes(const ChartModel* pModel,BOOL bMerge=TRUE);
	void CopyAxisMembers(const ChartModel* pModel);
	void SetAutoPilot(Window *pWindow){pAutoPilot=pWindow;};//#46895#

	void Create2DXYTitles(Rectangle& rRect,BOOL bSwitchColRow);

	void SetChartStatus(const long  nStatus)	{ nChartStatus = nStatus; }
	void SetChartStatusFlag(const long flag)	{ SETFLAG( nChartStatus, flag ); }
	void ResetChartStatusFlag(const long flag)	{ RESETFLAG( nChartStatus, flag ); }	
	long GetChartStatus()						{ return nChartStatus; }
	BOOL GetChartStatusFlag(const long flag)	{ return ISFLAGSET( nChartStatus, flag ); }

	void SetupLineColors(const long nMode);//#54870#

	//Einige (bald alle) Objekte setzen durch Implementation der NbcSetAttributes-Methode
	//die ChartModel-Attributsspeicher automatisch. Dies ist nicht immer notwendig und
	//sollte dann abgeschaltet werden, z.B. whrend des BuildChart
	BOOL SetAttrAutoStorage(const BOOL b)
	{
		BOOL ret=bAttrAutoStorage;
		bAttrAutoStorage=b;
		return ret;
	}

	void SetTitle(const long nId, const String& rTitle);
	String GetTitle( const long nId );	// BM
	void SetHasBeenMoved(const long nId,BOOL bMoved=TRUE);
	SdrObject* GetObjectWithId(const long nId,const long nCol=0,const long nRow=0);

	void StoreObjectsAttributes(SdrObject* pObj,const SfxItemSet& rAttr, FASTBOOL bReplaceAll);//#52277#

	SvxShape* GetShape(long nId);

	void			   GetAttr(const long nObjId, SfxItemSet& rAttr,const long nIndex1=-1);
	SfxItemSet&		   GetAttr(const long nObjId,const long nIndex1=-1) const;
	SfxItemSet&		   GetAttr(const SdrObject* pObj);
	BOOL               ChangeAttr(const SfxItemSet& rAttr,const long nId,const long nIndex1=-1);

	void        Rescue3DObjAttr(SdrObjList* pList);//#52277#

	void DetachShape(long nWhich);

	void SetNumLinesColChart(const long nSet, BOOL bForceStyleChange = FALSE);
	long GetNumLinesColChart() const {return nNumLinesInColChart;}//#50212#

	void SetBarPercentWidth(const long nWidth){if(nWidth<=100 && nWidth>0)
													nBarPercentWidth=nWidth;};//#50116#
	long GetBarPercentWidth()const{return nBarPercentWidth;};//#50116#

	void SetDefaultColorSet(long nSet); //#50037#
	long GetDefaultColorSet() const {return m_nDefaultColorSet;}//#50037#



protected:

	long nBarPercentWidth; //#50116#
	long nNumLinesInColChart;
	long m_nDefaultColorSet;//#50037#

	USHORT GetRegressStrId( long nRow );
	void ResizeText( SfxItemSet *pTextAttr, Size aPageSize, BOOL bResizePage=TRUE );

	SchDataLogBook*   pLogBook;
	Rectangle         aChartRect;
	Size              aInitialSize;

	SchItemPool*    pChItemPool;
	ChartScene*     pScene;

	Vector3D*       aLightVec;

	SchMemChart*    pChartData;
	double          fMinData;
	double          fMaxData;
	double          fAmbientIntensity;
	Color           aAmbientColor;
	double          fSpotIntensity;
	Color           aSpotColor;
	SvxChartStyle   eChartStyle;
	SvxChartStyle   eOldChartStyle;
	int             eChartLinePoints[LINE_POINT_COUNT];

	// pDefaultColors ersetzt aRowColors
	List*           pDefaultColors;

	BOOL              bTextScalable;
	BOOL              bIsCopied;
	BOOL              bLegendVisible;
	BOOL              bShowAverage;
	SvxChartKindError eErrorKind;
	SvxChartIndicate  eIndicate;
	SvxChartRegress   eRegression;
	double            fIndicatePercent;
	double            fIndicateBigError;
	double            fIndicatePlus;
	double            fIndicateMinus;
	int               nSplineDeepth;
	int               nGranularity;
	BOOL              bSwitch3DColRow; // FG: Reiner Zwischenspeicher, wird in chtmod3d.cxx
									   //     gesetzt und im selben File in Position3DAxisTitles
									   //     im selben File abgefragt, weil die
									   //     ChartScene::FitInSnapRect das nicht als Parameter bekommen kann,
									   //     da diese von der Polyscene gerufen wird.

	long        nMarkLen;
	long        nPieHeight;
	long*       pPieSegOfs;
	short       nPieSegCount;
	short       nXAngle;
	short       nYAngle;
	short       nZAngle;

	BOOL    bCanRebuild;
	BOOL    bShowMainTitle;
	String  aMainTitle;
	BOOL    bShowSubTitle;
	String  aSubTitle;
	BOOL    bShowXAxisTitle;
	String  aXAxisTitle;
	BOOL    bShowYAxisTitle;
	String  aYAxisTitle;
	BOOL    bShowZAxisTitle;
	String  aZAxisTitle;

//ToDo: nach ChartAxis verlegen:
	BOOL    bShowXGridMain;
	BOOL    bShowXGridHelp;
	BOOL    bShowYGridMain;
	BOOL    bShowYGridHelp;
	BOOL    bShowZGridMain;
	BOOL    bShowZGridHelp;
/*
	BOOL    bShowZDescr;
	BOOL    bShowXAxis;
	BOOL    bShowZAxis;
	BOOL    bShowYDescr;
	BOOL    bShowXDescr;
	BOOL    bShowYAxis;
*/
	BOOL    bShowDataDescr; //zeige Datadescr., vorallem fuer Autopiloten wichtig

	SfxItemSet* pTitleAttr;
	SfxItemSet* pMainTitleAttr;
	SfxItemSet* pSubTitleAttr;
	SfxItemSet* pXAxisTitleAttr;
	SfxItemSet* pYAxisTitleAttr;
	SfxItemSet* pZAxisTitleAttr;
	SfxItemSet* pAxisAttr;

	ChartAxis* pChartXAxis;
	ChartAxis* pChartYAxis;
	ChartAxis* pChartZAxis;
	ChartAxis* pChartBAxis;//2.Y-Achse
	ChartAxis* pChartAAxis;//2.X-Achse

	SfxItemSet* pGridAttr;
	SfxItemSet* pXGridMainAttr;
	SfxItemSet* pYGridMainAttr;
	SfxItemSet* pZGridMainAttr;
	SfxItemSet* pXGridHelpAttr;
	SfxItemSet* pYGridHelpAttr;
	SfxItemSet* pZGridHelpAttr;
	SfxItemSet* pDiagramAreaAttr;
	SfxItemSet* pDiagramWallAttr;
	SfxItemSet* pDiagramFloorAttr;
	SfxItemSet* pLegendAttr;
	SfxItemSet* pDummyAttr;

	SfxItemSet* pStockLineAttr;
	SfxItemSet* pStockLossAttr;
	SfxItemSet* pStockPlusAttr;


	SfxItemSet *pTmpXItems,*pTmpYItems,*pTmpZItems;

	SfxItemSet* pChartAttr;

	ItemSetList aDataRowAttrList;
	ItemSetList aDataPointAttrList;
	ItemSetList aSwitchDataPointAttrList;
	ItemSetList aRegressAttrList;
	ItemSetList aAverageAttrList;
	ItemSetList aErrorAttrList;


	ItemSetList aTmpDataRowAttrList;
	ItemSetList aTmpDataPointAttrList;
	ItemSetList aTmpSwitchDataPointAttrList;


	SvxChartDataDescr   eDataDescr;
	BOOL                bShowSym;
	BOOL                bSwitchData;

	BOOL bNoBuildChart;
	BOOL bShouldBuildChart;
	BOOL bReadError;

	SvNumberFormatter*  pOwnNumFormatter;
	SdrOutliner*        pOutliner;

	// FG: Falls ja wird der Legendentext und die Achsenbeschriftung umgebrochen
	BOOL    bFormatXAxisTextInMultipleLinesIfNecessary;
	BOOL    bFormatYAxisTextInMultipleLinesIfNecessary;
	BOOL    bFormatZAxisTextInMultipleLinesIfNecessary;
	BOOL    bFormatLegendTextInMultipleLinesIfNecessary;

	// FG: Maximale Anzahl Zeilen, die beim Umbruch erstellt werden
	int     nXAxisTextMaximumNumberOfLines;
	int     nYAxisTextMaximumNumberOfLines;
	int     nZAxisTextMaximumNumberOfLines;

	// FG: Nur Zwecks leichterem Handling, merke ich mir die Breite des ersten und letzten
	//     Textes der X-Achse. Die wird gebraucht um den linken und rechten Rand nachzuregeln.
	//     Die Funktion ist analog eines Globalen Zwischenspeichers.
	//     Das sollte man aendern, aber derzeit weiss ich nicht wie! (20.02.97)
	long    nWidthOfFirstXAxisText;
	long    nWidthOfLastXAxisText;

	// FG: Dies sind Positionen der unterschiedlichen Gruppen im Chart
	//     bei einem Resize koennen diese relativen Positionen damit erhlaten bleiben
	Point   aTitleTopCenter;
	Point   aSubTitleTopCenter;
	Rectangle   aDiagramRectangle, aLastDiagramRectangle;
	Point   aLegendTopLeft;
	Point   aTitleXAxisPosition;
	ChartAdjust eAdjustXAxesTitle;
	Point   aTitleYAxisPosition;
	ChartAdjust eAdjustYAxesTitle;
	Point   aTitleZAxisPosition;
	ChartAdjust eAdjustZAxesTitle;

	// FG: Falls dieser gesetzt ist so wird bei einem Resize (eigentlich bei jedem Buildchart)
	//     die relative Position der Gruppenobjekte zur Seite beachtet.
	//     Je nach Objekt bleibt die linke obere Ecke oder das Zentrum an der gleichen Stelle.
	BOOL    bUseRelativePositionsForChartGroups;

	// FG: Da man ja (7.3.1997) jetzt die Chart-Gruppen verschieben kann, sollte man
	//     angeben koennen ob die Lage der Legende in die Berichtigung des Platzes fuer
	//     die Legende mit aufgenommen werden soll.
	BOOL    bAdjustMarginsForLegend;
	BOOL    bAdjustMarginsForMainTitle;
	BOOL    bAdjustMarginsForSubTitle;
	BOOL    bAdjustMarginsForXAxisTitle;
	BOOL    bAdjustMarginsForYAxisTitle;
	BOOL    bAdjustMarginsForZAxisTitle;

	// FG: Ich muss mir merken ob Teile des Charts bewegt worden sind, um von einer
	//     Default-Plazierung auf eine Plazierung umzuschalten bei der die relativen
	//     Koordinaten erhalten bleiben. Sobald ein Objekt aus dieser Liste vom Benutzer
	//     verschoben wurde oder Resized wurde (an den Handles) werden diese Variablen
	//     auf TRUE gesetzt.
	BOOL    bDiagramHasBeenMovedOrResized;
	BOOL    bMainTitleHasBeenMoved;
	BOOL    bSubTitleHasBeenMoved;
	BOOL    bLegendHasBeenMoved;
	BOOL    bXAxisTitleHasBeenMoved;
	BOOL    bYAxisTitleHasBeenMoved;
	BOOL    bZAxisTitleHasBeenMoved;

	// FG : Das hier braucht es weil bei 3D-Charts der Bildchsimraufbau von der ChartScene
	//      erst beim ersten Paint initiiert wird. Erst dann werden die Achsentitel ausgegeben
	//      da ist aber BuildChart, dass die InitialSize setzt schon gelaufen. Deshalb diese
	//      "Chart-Globale" Variable;
	Size    aInitialSizefor3d;

	// FG: 21.4.97 Das ist hier definiert damit man die Hoehe von 2 Zeilen in chtmode1.cxx
	//     in GetHeightOfnRows so abfragen kann, dass nicht jedesmal extra dafuer ein neues
	//     Textobjekt angelegt werden muss.
	SdrRectObj* pTestTextObj;

	INT32	nXLastNumFmt;
	INT32	nYLastNumFmt;
	INT32	nBLastNumFmt;	

	void DeleteObject(SdrObject* pObj);

		// FG : Falls MaximumWidth groesser als 0 ist wird der Wert beachtet und bei dieser
		//      Breite umgebrochen. Es kommen hoechstens 2 Textzeilen raus und das muss bei
		//      CalcMaxDescrSize auch beruecksichtigt werden.
		//      nMaximumWidth < 0 bedeutet keinen Umbruch
public:
	SdrTextObj* CreateTextObj(UINT16           nId,
							  const Point      &rPos,
							  const String     &rText,
							  const SfxItemSet &rAttr,
							  BOOL             bIsTitle,
							  ChartAdjust      eAdjust = CHADJUST_TOP_LEFT,
							  const long       nMaximumWidth = -1);
protected:
		// FG. Auch hier kann sich der Umbruch aendern und nMaximumWidth muss beachtet werden.
	void SetTextString (SdrTextObj         &rTextObj,
						const String       &rText,
						SvxChartTextOrient eOrient = CHTXTORIENT_AUTOMATIC,
						const long nMaximumWidth = -1);

	void SetTextAttr (SdrTextObj       &rTextObj,
					  const SfxItemSet &rAttr,
					  const long nMaximumWidth = -1);

	// FG: (13.2.97) Dies berechnet die Groesse des umschliessendes Rechtecks des
	//               auszugebenden Textes. Falls MaximumWidth > 0 wird der Text
	//               an dieser Breite genau einmal umgebrochen.
	//               Im Outliner muss der Text bereits per SetText gesetzt worden sein!
	//               Falls der Schalter ChangeBorder auf TRUE steht wird der untere
	//               Rand nachgeregelt, dass muss uber den Schalter passieren, da sonst nicht
	//               zwischen reinen Abfragen und einer Abfrage um eine Aenderung zu erzielen
	//               unterschieden werden kann.

	Size CalcTextSizeOfOneText (SvxChartTextOrient eOrient,
										SfxItemSet         &rTextAttr,
										SdrOutliner        *pOutliner,
										const long         MaximumWidth,
										const BOOL		   bGetRotated=FALSE);
public:

	Size CalcMaxDescrSize (BOOL					 bRowDescr,
						   SvxChartTextOrient	 eOrient,
						   const UINT32			 nNumberFormat,
						   long					 nAxisUId,
						   const long			 MaximumWidth = -1,
						   Pair					*pFirstAndLast=NULL );

	long GetLineHeight (const SfxItemSet &rAttr);
	void CreateDataDescr (DataDescription &rDescr,short nCol,short nRow,ChartAxis *pAxis,BOOL bRowDescr,BOOL bIsPercent=FALSE);
protected:
	// FG: beide Funktionen koennen eine maximale Breite als Parameter akzeptieren.
	//     Der stellt die maximale Breite des Textes in der Beschriftung der Achsen und darunter
	//     in der Legende dar. Der Wert -1 ist default, dann wird ein hart kodierter Wert genommen.


	SdrObjGroup* CreateLegend (const Rectangle &aRect);

	void StoreAttributes(SvStream& rOut) const;
	void LoadAttributes(SvStream& rIn);

	void Create2DBackplane (Rectangle  &rRect,
							SdrObjList &rObjList,
							BOOL       bPartDescr,
							USHORT     eStackMode);

	SdrObjGroup* Create2DColChart     (Rectangle aRect);
	SdrObjGroup* Create2DRowLineChart (Rectangle aRect);
	SdrObjGroup* Create2DPieChart     (Rectangle aRect);
	SdrObjGroup* Create2DDonutChart   (Rectangle aRect);
	SdrObjGroup* Create2DNetChart     (Rectangle aRect);
	SdrObjGroup* Create2DXYChart      (Rectangle aRect);

	void Create3DBackplanes (Rectangle		&rRect,
							 Vector3D       aPos,
							 Vector3D       aSizeVec,
							 ChartScene     &rScene,
							 BOOL           bPartDescr,
							 BOOL           bXLogarithm,
							 BOOL           bYLogarithm,
							 BOOL           bZLogarithm,
							 USHORT         eStackMode,
							 BOOL           bPercent,
							 BOOL           bFlatChart,
							 BOOL           bSwitchColRow);

	SdrObjGroup* Create3DDeepChart (Rectangle &rRect);
	SdrObjGroup* Create3DFlatChart (Rectangle &rRect);
//    SdrObjGroup* Create3DPieChart  (Rectangle &rRect);
	SdrObjGroup* Create3DNewPieChart  (Rectangle &rRect);

	// FG: 14.3.97 Diese Funktion ermittlt die Ausrichtung des Titels und die muss beim
	//             Resize des Charts beachtet werden, sonst faengt der Text zu springen
	//             an, nachdem er das erste Mal verschoben wurde.
	SdrTextObj *CreateTitle (SfxItemSet   *pTitleAttr,
							 short        nID,
							 BOOL         bSwitchColRow,
							 const String &rText,
							 BOOL         bVert,
							 ChartAdjust  *pTextDirection = NULL);

	// FG: erzeugt die Achsen fuer alle 3d-Charts gleich (durch aufruf von Create-Title);
	void CreateAndInsert3DAxesTitles (Rectangle &rRect, BOOL bSwitchColRow);


	//ehemals in globfunc.cxx, nun Methoden vom Model
	E3dCompoundObject* Create3DBar(Vector3D aPos,
						Vector3D         aSizeVec,
						long             nCol,
						long             nRow,
						SfxItemSet		 &rAttr,
						BOOL             bIsSimple,
						double nMinPos=0.0,
						double nOriPos=0.0,
						double nMaxPos=0.0);

	E3dObject *Create3DObject (UINT16     ID);
	E3dObject *Create3DAxisObj( UINT16 nId );	

	void Create3DPolyObject (const SfxItemSet  *pAttr,
						 E3dPolygonObj     *pMyObject,
						 UINT16            nID,
						 E3dObject *pParent);



	void  Create3DExtrudePolyObj(const SfxItemSet  *pAttr,
						 E3dExtrudeObj     *pMyObject,
						 UINT16            nID,
						 E3dObject *pParent);


	ChartScene* CreateScene (const Rectangle &rRect,
						 const Vector3D  &aLightVec,
						 double          fSpotIntensity,
						 Color&          aSpotColor,
						 double          fAmbientIntensity,
						 Color&          aAmbientColor);

	void SetAxisAttributes (const SfxItemSet  *pAttr,
							const SdrObjGroup *pAxisObj);

	BOOL SetAllAxisAttributes ();

	BOOL TitleOrientChanged (const SdrTextObj   *pTitleObj,
							 const SfxItemSet   *pAttr,
							 SvxChartTextOrient eOldOrient,
							 SvxChartTextOrient eNewOrient);

	BOOL SetAllTitleAttributes (const SfxItemSet &rAttr);

	void Dirty2D (long            nRowCnt,
				  long            nCol,
				  SdrObjList      **pDescrLists,
				  BOOL            bRowDescr,
				  DataDescription *pDescription);

/*	void Dirty3D (long            nRowCnt,
				  long            nCol,
				  BOOL            bRowDescr,
				  DataDescription *pDescription,
				  ChartScene      *pScene);*/

	double GetAverageValueY (long nRow);

	SdrObject *AverageValueY (long      nRow,
							  BOOL      bIsVertical,
							  Rectangle &rRect,
							  double    fAverageValue);

	//Diese Funktion sollte benutzt werden, obige ist nicht Achsenorientiert!
	SdrObject *AverageValueY (long      nRow,
							  BOOL      bIsVertical,
							  ChartAxis *pAxis,
							  double    fAverageValue);
public:
	double GetVariantY (long nRow);

	double GetSigmaY (long nRow);

	double GetBigErrorY (long   nRow,
						 double fError);

	void AverageErrorY (long       nRow,
						double     fData,
						const Point& aPos,
						BOOL       bVertical,
						SfxItemSet &rAttr,
						SdrObjList *pList,
						ChartAxis  *pAxis);

	void RegressionYX (long            nRow,
					   double          &fAverageX,
					   double          &fAverageY,
					   double          &fBetaYX,
					   SvxChartRegress eMyRegress);
protected:

	void CreateDefaultColors ();

	void DestroyDefaultColors ();

	// FG: Die Zeilenhoehe von n Zeilen ermitteln!
	long GetHeightOfnRows (const SfxItemSet &rAttr, int n);

	//Projectionsart 3D Chart:
	ProjectionType eProjection;

	void CopyPointAttrToPage(short nRow);

public:

	BOOL IsAttrChangeNeedsBuildChart(const SfxItemSet& rAttr);

protected:
	// Subroutinen
	void ClearDataDescription(DataDescription *pDescription,long nElements);

	//ChangeData...Attr Subroutinen
	SdrObject* CDRAGetDataRowObj(const long nDataRow);
	void CDRAAttrGroup(SdrObject* pDataRowObj,const long nDataRow,const SfxItemSet& rDataRowAttr);
	void ChangeRowDescrSymbolAttr(const long nDataRow,const SfxItemSet& rDataRowAttr);

	SdrObject* CDPAGetDataPointObj(const long nDatacol,const long nDataRow);
	void ChangePointDescrSymbolAttr(const long nDataCol,const long nDataRow,const SfxItemSet& rDataPointAttr);

	void ChangeLegendPointAttr(const long nDataCol,const SfxItemSet& rDataPointAttr);
	void ChangeLegendRowAttr(  const long nDataRow,const SfxItemSet& rDataRowAttr);


	// BuildChart-Submethoden:
	void CreateRectsAndTitles(long whatTitle);

	void CalculateUpperBorder();

	void ResizeChart(const Size& rPageSize);

	BOOL CheckRanges(BOOL bCheckAlways);

	void DeleteChartObjects();

	void ScaleText(long nTitle,const Size& rPageSize);

	void DoShowMainTitle(USHORT& rIndex,const long nYOfs);
	void DoShowSubTitle(USHORT& rIndex,const long nYOfs);
	void DoShowLegend(const Rectangle& rWholeRect,
					  const long nXOfs,const long nYOfs,USHORT& rIndex);


	void CopySpecialPointAttrToPage(short nRow);

	void LogBookAttrData();

	void SetDefAttrRow(SfxItemSet* pDataRowAttr,const long i);

	//aus globfunc.?xx:
	SdrRectObj *CreateRect( Rectangle &rRect,
							long       nCol,
							long       nRow,
							SfxItemSet &rAttr);

	SdrObject* CreatePieSegment(   SfxItemSet& rAttr, Rectangle& rRect,
								   long nCol,		  long nRow,
								   long nStartAngle,  long nEndAngle,
								   long nColCnt);
	SdrObject* CreateDonutSegment( SfxItemSet& aAttr, Rectangle& aRect, ULONG nWidth,
								   long nCol,		  long nRow,
								   long nStartAngle,  long nEndAngle,
								   long nColCnt);

	void Position2DAxisTitles(const Rectangle& rRect,BOOL bSwitchColRow,long nTitleLeft,long nTitleBottom);

public:

	SdrObject* GetDataRowGroup(const long nRow);

	BOOL SetBaseType(long nBaseType);

	//Darstellungsoptionen, siehe chtmode7.cxx:
	long GetBaseType() const;
	BOOL IsPercent()  const;
	BOOL IsStacked()  const;
	BOOL IsBar()      const;
	BOOL HasSymbols(const long nRow=0) const;
	BOOL IsLine(const long nRow=0) const;
	BOOL IsPieChart() const;

	BOOL IsPieOrDonutChart() const;

	//Ersatz-GetDataRowObj fuer PieCharts
	SdrObject* GetPieDataRowObj(const short nRow);


	SvxChartStyle GetRowChartStyle(const long nRow);

	void SetDataLogBook(SchDataLogBook* pLog);


	//aus SchChartDocument ->
	ChartModel(SfxObjectShell* pDocSh);
	virtual ~ChartModel();

	SfxItemPool& GetPool() { return *pItemPool; }
	SfxObjectShell* GetObjectShell() { return pDocShell; }

	VCItemPool* GetVCItemPool() const;
	virtual void SetChanged(FASTBOOL bFlag = TRUE);
	void ResetFreshLoaded ();

	BOOL FreshLoaded () const
	{
		return bFreshLoaded;
	}

	BOOL &FreshLoaded ()
	{
		return bFreshLoaded;
	}
	virtual SdrModel* AllocModel() const;
	virtual SdrPage* AllocPage(FASTBOOL bMasterPage);
	virtual void NewOrLoadCompleted(USHORT eMode);
	//  <- aus SchChartDocument

	friend SvStream& operator << (SvStream& rOut, const ChartModel& rDoc);
	friend SvStream& operator >> (SvStream& rIn, ChartModel& rDoc);


	ProjectionType GetProjection(){ return eProjection;}
//    void SetProjection(ProjectionType ePrj){eProjection=ePrj;}

	// FG: 11.3.97 Hier wird das Diagramm erstellt. Also die Grafik mit der Achsenbeschriftung
	//             und zwar innerhalb des Rechtecks rRect. Es wird eigentlich eine SchObjGroup
	//             erzeugt, die von SdrObjGroup abgeleitet ist.
	SdrObjGroup* CreateChart (const Rectangle &rRect);

	// avoid BuildChart invocation during edit. remember changes in data for later change (SP2)
	// #61907#
	void SetChartDataBuffered (SchMemChart &rData,
							   BOOL        bNewTitles = TRUE);

	void CatchUpBufferedData();

	void SetChartData (SchMemChart &rData,
					   BOOL        bNewTitles = TRUE);

	BOOL ChangeChartData (SchMemChart &rData,
						  BOOL        bNewTitles = TRUE,
						  BOOL bDontBuild=FALSE);

	SchMemChart* GetChartData() const;

	void InitDataAttrs();

	short GetColCount() const;

	short GetRowCount() const;

	double GetData (short nCol,
					short nRow,
					BOOL  bPercent = FALSE,
					BOOL  bRowData = TRUE) const;

	BOOL ChangeSwitchData(BOOL bSwitch);

	BOOL Is3DChart() const;
	BOOL IsStatisticChart() const;
	BOOL IsNetChart() const;
	BOOL IsStackedChart() const;
	BOOL IsPercentChart() const;
	BOOL IsAxisChart() const;
	BOOL IsNegativeChart() const;
	BOOL IsSignedChart() const;
	BOOL IsXYChart( SvxChartStyle* pStyle=NULL ) const;
	BOOL IsSplineChart() const;
	BOOL ChangeChart(SvxChartStyle eStyle/*, long nGap, long nOver*/);

	SdrObject* GetChartObj(UINT16 nId);
	SdrObject* GetDataRowObj(short nRow);
	SdrObject* GetDataPointObj(short nCol, short nRow);

	BOOL ChangeTitle (BOOL         bShowMain,
					  const String &rMainTitle,
					  BOOL         bShowSub,
					  const String &rSubTitle,
					  BOOL         bShowX,
					  const String &rXAxisTitle,
					  BOOL         bShowY,
					  const String &rYAxisTitle,
					  BOOL         bShowZ,
					  const String &rZAxisTitle);

	BOOL HasTitle() const;

	BOOL HasAxis() const;

	BOOL HasGrid() const;

	BOOL ChangeAxis( BOOL bXAxis,
					 BOOL bXDescr,
					 BOOL bYAxis,
					 BOOL bYDescr,
					 BOOL bZAxis,
					 BOOL bZDescr,
					 BOOL b2YAxis,
					 BOOL b2YDescr,
					 BOOL b2XAxis,
					 BOOL b2XDescr,
					 BOOL bAllowBuildChart = TRUE );

	BOOL ChangeGrid( BOOL bXMain,
					 BOOL bXHelp,
					 BOOL bYMain,
					 BOOL bYHelp,
					 BOOL bZMain,
					 BOOL bZHelp,
					 BOOL bAllowBuildChart = TRUE );
	
	void PutTitleAttr(const SfxItemSet& rAttr,BOOL bMerge = TRUE);
	const SfxItemSet& GetTitleAttr() const;

	const SfxItemSet& GetTitleAttr(const SdrTextObj* pTitleObj) const;
	SfxItemSet GetFullTitleAttr(const SdrTextObj* pTitleObj) const;
	BOOL ChangeTitleAttr(const SfxItemSet &rAttr,
						 SdrTextObj       *pTitleObj,
						 BOOL             bMerge = TRUE);
	BOOL ChangeTitleAttr(const SfxItemSet& rMainTitleAttr,
						 const SfxItemSet& rSubTitleAttr,
						 const SfxItemSet& rXAxisTitleAttr,
						 const SfxItemSet& rYAxisTitleAttr,
						 const SfxItemSet& rZAxisTitleAttr,
						 BOOL bMerge = TRUE);

	void PutMainTitleAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetMainTitleAttr() const;

	void PutSubTitleAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetSubTitleAttr() const;

	void PutXAxisTitleAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetXAxisTitleAttr() const;

	void PutYAxisTitleAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetYAxisTitleAttr() const;

	void PutZAxisTitleAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetZAxisTitleAttr() const;

	void PutLegendAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetLegendAttr() const;

	void PutChartAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetChartAttr() const;
	void ChangeChartAttr(const SfxItemSet& rAttr,BOOL  bMerge);



	SfxItemSet GetFullLegendAttr() const;
	void ChangeLegendAttr(const SfxItemSet& rAttr,BOOL  bMerge = TRUE);
	void PutAxisAttr(const SfxItemSet& rAttr,BOOL bMerge = TRUE);
	const SfxItemSet& GetAxisAttr() const;

	const SfxItemSet& GetAxisAttr(const SdrObjGroup* pAxisObj) const;
	SfxItemSet GetFullAxisAttr(const SdrObjGroup* pAxisObj) const;

	BOOL ChangeAxisAttr(const SfxItemSet& rAttr,
						SdrObjGroup* pAxisObj, BOOL bMerge = TRUE);
	BOOL ChangeAxisAttr(const SfxItemSet& rXAxisAttr,
						const SfxItemSet& rYAxisAttr,
						const SfxItemSet& rZAxisAttr,
						BOOL bMerge = TRUE);
	void PutGridAttr(const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetGridAttr() const;

	const SfxItemSet& GetGridAttr(const SdrObject* pGridObj) const;
	BOOL ChangeGridAttr(const SfxItemSet& rAttr,
						SdrObject* pGridObj, BOOL bMerge = TRUE);

	void PutXGridMainAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetXGridMainAttr() const;

	void PutYGridMainAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetYGridMainAttr() const;

	void PutZGridMainAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetZGridMainAttr() const;

	void PutXGridHelpAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetXGridHelpAttr() const;

	void PutYGridHelpAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetYGridHelpAttr() const;

	void PutZGridHelpAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetZGridHelpAttr() const;

	void PutDiagramAreaAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetDiagramAreaAttr() const;

	void ChangeDiagramAreaAttr(const SfxItemSet& rAttr,
							   SdrRectObj*       pDiagramAreaObj=NULL,
							   BOOL              bMerge = TRUE);
	void PutDiagramWallAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetDiagramWallAttr() const;

	void ChangeDiagramWallAttr(const SfxItemSet& rAttr,
							   SdrObject*        pDiagramWallObj=NULL,
							   BOOL              bMerge = TRUE);

	void PutDiagramFloorAttr(const SfxItemSet& rAttr, BOOL bMerge = TRUE);
	const SfxItemSet& GetDiagramFloorAttr() const;

	void ChangeDiagramFloorAttr( const SfxItemSet& rAttr,
								 E3dExtrudeObj* pDiagramFloorObj = NULL,
								 BOOL			bMerge = TRUE );

	void PutDataRowAttrAll(const SfxItemSet& rAttr,
						BOOL bMerge		 =TRUE,
						BOOL bClearPoints=TRUE);

	void PutDataRowAttr(long             nRow,
						const SfxItemSet& rAttr,
						BOOL bMerge		 =TRUE,
						BOOL bClearPoints=TRUE);

	const SfxItemSet& GetDataRowAttr(short nRow) const;

	BOOL ChangeDataRowAttr(const SfxItemSet& rAttr,
						   long              nRow,    //#54870# nRow statt pObj
						   BOOL              bMerge = TRUE);

	void PutRegressAttr(short nRow,const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetRegressAttr(short nRow) const;
	void ChangeRegressAttr(const SfxItemSet& rAttr,long nRow,BOOL bMerge = TRUE);

	void PutAverageAttr(short nRow, const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetAverageAttr(short nRow) const;
	void ChangeAverageAttr(const SfxItemSet& rAttr,long nRow,BOOL bMerge = TRUE);

	void PutErrorAttr(short nRow,const SfxItemSet& rAttr,BOOL bMerge=TRUE);
	const SfxItemSet& GetErrorAttr(short nRow) const;
	void ChangeErrorAttr(const SfxItemSet& rAttr, long nRow,BOOL bMerge = TRUE);

	void PutDataPointAttr(short             nCol,
						  short             nRow,
						  const SfxItemSet& rAttr,
						  BOOL bMerge		 =TRUE);

	const SfxItemSet& GetDataPointAttr(short nCol,short nRow) const;
	void ClearDataPointAttr(short nCol, short nRow,const SfxItemSet& rAttr);
	SfxItemSet GetFullDataPointAttr(short nCol, short nRow, BOOL=FALSE) const;
	SfxItemSet& MergeDataPointAttr(SfxItemSet& rAttr,short nCol, short nRow) const;


	BOOL ChangeDataPointAttr(const SfxItemSet& rAttr,
							 SdrObject&        rObj,
							 BOOL              bMerge = TRUE,
							 BOOL              bBuildChart = TRUE);

	// FG: 19.3.1997 Die Aenderung soll einfach ermoeglichen dass
	//     ein unnoetiges Buildchart verhindert werden kann
	//     24.4.1997
	void ChangeDataDescr(SvxChartDataDescr eDescr, BOOL bSym,
						 long nRowToChange = -1,
						 BOOL bBuildChart = TRUE);

	BOOL ResizePage(const Size& rNewSize);

	SvNumberFormatter* GetNumFormatter() const;

	SdrOutliner* GetOutliner() const;

	void PrepareEdit(SdrTextObj& rTextObj);
	void CommitEdit(SdrTextObj& rTextObj);

	void GetAttr(SfxItemSet& rAttr);
	void PutAttr(const SfxItemSet& rAttr);
	BOOL ChangeAttr(const SfxItemSet& rAttr);

	BOOL IsInitialized() const;

	void Initialize();
	void BuildChart(BOOL bCheckRange,
					long whatTitle     = 0);

	void InitChartData(BOOL bNewTitles = TRUE);

	virtual FASTBOOL IsReadOnly () const;

	ChartScene *GetScene();

	const SchMemChart *GetMemChart () const;


	const Rectangle &GetChartRect () const;

	void CanRebuild (BOOL bNewRebuild);

	void GetStatistics (BOOL              &GetShowAverage,
						SvxChartKindError &GetErrorKind,
						SvxChartIndicate  &GetIndicate,
						double            &GetIndicatePercent,
						double            &GetIndicateBigError,
						double            &GetIndicatePlus,
						double            &GetIndicateMinus,
						SvxChartRegress   &GetRegression) const;

	BOOL ChangeStatistics (const SfxItemSet &rNewAttr);

	BOOL TextScalability () const;
	BOOL &TextScalability ();

	BOOL ShowAverage () const;
	BOOL &ShowAverage ();

	BOOL GetShowLegend () const;
	void SetShowLegend (BOOL bNewShow);

	BOOL IsCopied () const;
	BOOL &IsCopied ();

	SvxChartKindError ChartKindError () const;
	SvxChartKindError &ChartKindError ();

	SvxChartIndicate ChartIndicate () const;
	SvxChartIndicate &ChartIndicate ();

	SvxChartRegress ChartRegress () const;
	SvxChartRegress &ChartRegress ();

	double IndicatePercent () const;
	double &IndicatePercent ();

	double IndicateBigError () const;
	double &IndicateBigError ();

	double IndicatePlus () const;
	double &IndicatePlus ();

	double IndicateMinus () const;
	double &IndicateMinus ();

	int SplineDeepth () const;
	int &SplineDeepth ();

	int Granularity () const;
	int &Granularity ();

	void SetOverlap(long nPercent,long nRow);
	void SetGap(long nPercent,long nRow);
	long GetOverlap(long nRow);
	long GetGap(long nRow);

	long GetAxisUID(long nRow);

	void SetSwitchData (BOOL b);


	inline BOOL IsDonutChart() const //#63904# extrem hufig gerufene Methoden:
	{
		return (eChartStyle==CHSTYLE_2D_DONUT1 || eChartStyle==CHSTYLE_2D_DONUT2);
	};
	//Diese Methode liefert den Status des Buttons
	inline BOOL IsSwitchData () const
	{
		return bSwitchData;
	};
	//Diese Statusmethode ist im Gegensatz IsSwitchData() ABHAENGIG vom Chart-Typen,
	//und sollte ueberall verwendet werden, wo Daten zur Darstellung geholt werden
	// z.B: GetData(col,row) etc.:
	inline BOOL IsDataSwitched() const
	{
		if(IsDonutChart())
			return !bSwitchData;
		else
			return bSwitchData;
	}






	SvxChartStyle ChartStyle() const;
	SvxChartStyle &ChartStyle();

	SvxChartStyle OldChartStyle() const;
	SvxChartStyle &OldChartStyle();

	long PieSegOfs (short nCol) const;
	long &PieSegOfs (short nCol);

	BOOL ShowMainTitle () const;
	BOOL &ShowMainTitle ();

	void SetShowDataDescr(const BOOL b) {bShowDataDescr=b;};

	const String &MainTitle () const;
	String &MainTitle ();

	BOOL ShowSubTitle () const;
	BOOL &ShowSubTitle ();

	const String &SubTitle () const;
	String &SubTitle ();

	BOOL ShowXAxisTitle () const;
	BOOL &ShowXAxisTitle ();

	const String &XAxisTitle () const;
	String &XAxisTitle ();

	BOOL ShowYAxisTitle () const;
	BOOL &ShowYAxisTitle ();

	const String &YAxisTitle () const;
	String &YAxisTitle ();

	BOOL ShowZAxisTitle () const;
	BOOL &ShowZAxisTitle ();

	const String &ZAxisTitle () const;
	String &ZAxisTitle ();


	BOOL ShowXGridMain () const;
	BOOL &ShowXGridMain ();

	BOOL ShowXGridHelp () const;
	BOOL &ShowXGridHelp ();

	BOOL ShowXDescr () const;
	void ShowXDescr (BOOL b);
	BOOL ShowYDescr () const;
	void ShowYDescr (BOOL b);
	BOOL ShowZAxis () const;
	void ShowZAxis(BOOL b);
	BOOL ShowXAxis () const;
	void ShowXAxis(BOOL b);
	BOOL ShowYAxis () const;
	void ShowYAxis(BOOL b);
	BOOL ShowZDescr () const;
	void ShowZDescr (BOOL b);

	BOOL ShowYGridMain () const;
	BOOL &ShowYGridMain ();

	BOOL ShowYGridHelp () const;
	BOOL &ShowYGridHelp ();


	BOOL ShowZGridMain () const;
	BOOL &ShowZGridMain ();

	BOOL ShowZGridHelp () const;
	BOOL &ShowZGridHelp ();

	SvxChartDataDescr DataDescr () const;
	SvxChartDataDescr &DataDescr ();

	BOOL ShowSym () const;
	BOOL &ShowSym ();


	UINT32 GetNumFmt(long nObjId,BOOL bPercent);
	void   SetNumFmt(long nObjId,UINT32 nFmt,BOOL bPercent);

	BOOL ReadError () const;
	BOOL &ReadError ();

	double SpotIntensity () const;
	double &SpotIntensity ();

	//const Color& GetSpotColor() const { return aSpotColor; }
	void   SetSpotColor(const Color& rCol)  { aSpotColor = rCol; }

	void SetAmbientIntensity (const double fIntensity)  {fAmbientIntensity=fIntensity;};

	//const Color& GetAmbientColor() const { return aAmbientColor; }
	void   SetAmbientColor(const Color& rCol)  { aAmbientColor = rCol; }

	const Size &InitialSize () const;
	Size &InitialSize ();

	const Vector3D &LightVec () const;
	Vector3D &LightVec ();

	long PieHeight () const;
	long &PieHeight ();

	short PieSegCount () const;
	short &PieSegCount ();

	const String &ColText (short nCol) const;
	String& ColText (short nCol);

	const String &RowText (short nRow) const;
	String& RowText (short nRow);

	// FG: Wird nur von der ChartScene::FitInSnapRect gerufen. Es muss bSwitch3DRowCol gesetzt sein.
	void Position3DAxisTitles(const Rectangle& rXDescrOutRect);

	void SetAngles (short nNewXAngle,
					short nNewYAngle,
					short nNewZAngle);

	void GetAngles (short &rNewXAngle,
					short &rNewYAngle,
					short &rNewZAngle);

	void SetPieSegOfs (short nCol,
					   long  nOfs);

	void ClearItemSetLists();
	void SetItemSetLists(const ChartModel &rSource);
	void CopyDefaultColors (List* pOtherColors);

	void AllocPieSegOfs (long nPieSegCount);

		// FG: Diese Abfrage soll ermoeglichen, dass man den linken und den rechten Rand
		//     Notfalls nachregeln kann, wenn die Beschriftung unter den Datenpunkten zentriert ist,
		//     da der erste Datenpunkt auf der Y-Achse liegt und der letzte Datenpunkt meist genau
		//     da, wo das Diagramm aufhoert.
	BOOL IsDescriptionCenteredUnderDataPoint ();

	// FG: Inline-Methode zur Abfrage ob der Text an bestimmten Achsen oder der Legende umgebrochen
	//     werden soll oder nicht (20.02.1997)
	BOOL   GetFormatXAxisTextInMultipleLinesIfNecessary()
		{ return bFormatXAxisTextInMultipleLinesIfNecessary;}
	void SetFormatXAxisTextInMultipleLinesIfNecessary(BOOL value)
		{ bFormatXAxisTextInMultipleLinesIfNecessary = value;}

	BOOL   GetFormatYAxisTextInMultipleLinesIfNecessary()
		{ return bFormatYAxisTextInMultipleLinesIfNecessary;}
	void SetFormatYAxisTextInMultipleLinesIfNecessary(BOOL value)
		{ bFormatYAxisTextInMultipleLinesIfNecessary = value;}

	BOOL   GetFormatZAxisTextInMultipleLinesIfNecessary()
		{ return bFormatZAxisTextInMultipleLinesIfNecessary;}
	void SetFormatZAxisTextInMultipleLinesIfNecessary(BOOL value)
		{ bFormatZAxisTextInMultipleLinesIfNecessary = value;}

	BOOL   GetFormatLegendTextInMultipleLinesIfNecessary()
		{ return bFormatLegendTextInMultipleLinesIfNecessary;}
	void SetFormatLegendTextInMultipleLinesIfNecessary(BOOL value)
		{ bFormatLegendTextInMultipleLinesIfNecessary = value;}

	void AdjustPrinter();

	// FG: 9.3.97, Falls der Schalter TRUE ist, so werden die Positionen der einzelnen
	//             Objekte beim Aufbau des Charts beruecksichtigt.
	void SetUseRelativePositions (BOOL value);
	BOOL GetUseRelativePositions() {return (bUseRelativePositionsForChartGroups);}

	// FG: Da man ja (7.3.1997) jetzt die Chart-Gruppen verschieben kann, sollte man
	//     angeben koennen ob die Lage der Legende in die Berichtigung des Platzes fuer
	//     die Legende mit aufgenommen werden soll.
	void SetAdjustMarginsForLegend(BOOL value) {bAdjustMarginsForLegend = value;}
	BOOL GetAdjustMarginsForLegend() {return bAdjustMarginsForLegend;}

	void SetAdjustMarginsForMainTitle(BOOL value) {bAdjustMarginsForMainTitle = value;}
	BOOL GetAdjustMarginsForMainTitle() { return bAdjustMarginsForMainTitle; }

	void SetAdjustMarginsForSubTitle(BOOL value) {bAdjustMarginsForSubTitle = value;}
	BOOL GetAdjustMarginsForSubTitle() {return bAdjustMarginsForSubTitle;}

	void SetAdjustMarginsForXAxisTitle(BOOL value) {bAdjustMarginsForXAxisTitle = value;}
	BOOL GetAdjustMarginsForXAxisTitle() {return bAdjustMarginsForXAxisTitle;}

	void SetAdjustMarginsForYAxisTitle(BOOL value) {bAdjustMarginsForYAxisTitle = value;}
	BOOL GetAdjustMarginsForYAxisTitle() {return bAdjustMarginsForYAxisTitle;}

	void SetAdjustMarginsForZAxisTitle(BOOL value) {bAdjustMarginsForZAxisTitle = value;}
	BOOL GetAdjustMarginsForZAxisTitle() {return bAdjustMarginsForZAxisTitle;}

	// FG: 11.3.97 Diese Routinen sollten verwendet werden um festzulegen und abzufragen ob
	//     bestimmte Chart-Gruppen verschoben wurden oder nicht.
	BOOL GetDiagramHasBeenMovedOrResized()				{ return bDiagramHasBeenMovedOrResized; }
	void SetDiagramHasBeenMovedOrResized(BOOL value)	{ bDiagramHasBeenMovedOrResized=value; }

	BOOL GetMainTitleHasBeenMoved()				{ return bMainTitleHasBeenMoved; }
	void SetMainTitleHasBeenMoved(BOOL value)	{ bMainTitleHasBeenMoved = value; }

	BOOL GetSubTitleHasBeenMoved()				{ return bSubTitleHasBeenMoved; }
	void SetSubTitleHasBeenMoved(BOOL value)	{ bSubTitleHasBeenMoved = value; }

	BOOL GetLegendHasBeenMoved()				{ return bLegendHasBeenMoved; }
	void SetLegendHasBeenMoved(BOOL value)		{ bLegendHasBeenMoved = value; }

	BOOL GetXAxisTitleHasBeenMoved()			{ return bXAxisTitleHasBeenMoved; }
	void SetXAxisTitleHasBeenMoved(BOOL value)	{ bXAxisTitleHasBeenMoved = value; }

	BOOL GetYAxisTitleHasBeenMoved()			{ return bYAxisTitleHasBeenMoved; }
	void SetYAxisTitleHasBeenMoved(BOOL value)	{ bYAxisTitleHasBeenMoved = value; }

	BOOL GetZAxisTitleHasBeenMoved()			{ return bZAxisTitleHasBeenMoved; }
	void SetZAxisTitleHasBeenMoved(BOOL value)	{ bZAxisTitleHasBeenMoved = value; }

	void SetDiagramRectangle(Rectangle &rNewRect)
	{
		aLastDiagramRectangle = aDiagramRectangle; 
		aDiagramRectangle = rNewRect;
	}

	void SetChartRect(Rectangle &rValue)	{ aChartRect = rValue; }
	Rectangle& GetChartRect()				{ return aChartRect; }

	BOOL CheckForNewAxisNumFormat();

	long GetPieRadius() const				{ return nPieRadius; }
	BOOL HasDefaultGrayArea( SvxChartStyle* pStyle = NULL ) const;
	BOOL HasDefaultGrayWall( SvxChartStyle* pStyle = NULL ) const;

	void SetNumberFormatter( SvNumberFormatter* );
	void DataRangeChanged( short _nOldRowCnt = 0, short _nOldColCnt = 0 );
	void TranslateAllNumFormatIds( SvULONGTable* );

	// set new doc shell if there was no one before
	// returns true if new shell was set
	BOOL SetObjectShell( SfxObjectShell* pDocSh );
};

#endif // _CHTMODEL_HXX

