/*************************************************************************
 *
 *  $RCSfile: chartdoc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:29:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <svx/eeitem.hxx>

#ifndef _SVX_VCATTR_HXX
#include <basctl/vcattr.hxx>
#endif
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif
#ifndef _SFX_INTERNO_HXX //autogen
#include <sfx2/interno.hxx>
#endif
#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif

#ifndef _ZFORLIST_HXX
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#endif


#ifndef _SFXPOOLITEM_HXX //autogen
#include <svtools/poolitem.hxx>
#endif

#ifndef _SFX_PRINTER_HXX //autogen
#include <sfx2/printer.hxx>
#endif

#ifndef _SCHATTR_HXX
#include "schattr.hxx"
#endif
#ifndef _SVX_CHRTITEM_HXX //autogen
#define ITEMID_DOUBLE	        0
#define ITEMID_CHARTDATADESCR   SCHATTR_DATADESCR_DESCR
#include <svx/chrtitem.hxx>
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#ifndef _SCH_STLPOOL_HXX
#include "stlpool.hxx"
#endif
#ifndef _SCH_SCHIOCMP_HXX
#include "schiocmp.hxx"
#endif
#ifndef _SCH_SCHRESID_HXX
#include "schresid.hxx"
#endif
#ifndef _SCH_DOCSHELL_HXX
#include "docshell.hxx"
#endif
#define ITEMID_FONT        EE_CHAR_FONTINFO
#define ITEMID_COLOR       EE_CHAR_COLOR
#define ITEMID_FONTHEIGHT  EE_CHAR_FONTHEIGHT

#include "glob.hrc"
#include "chtmodel.hxx"
#include "globfunc.hxx"

#include <svx/fontitem.hxx>
#include <svx/fhgtitem.hxx>

#ifndef _SVX_COLRITEM_HXX //autogen
#include <svx/colritem.hxx>
#endif
#ifndef _SVDLAYER_HXX //autogen
#include <svx/svdlayer.hxx>
#endif
#ifndef _SVDPAGE_HXX //autogen
#include <svx/svdpage.hxx>
#endif


#include "pairs.hxx"

/*************************************************************************
|*
|* Diese Methode erzeugt ein neues Dokument (ChartModel) und gibt einen
|* Zeiger darauf zurueck. Die Drawing Engine benutzt diese Methode um das
|* Dokument oder Teile davon ins Clipboard/DragServer stellen zu koennen.
|*
|* this method works like a copy constructor. So make sure to copy all
|* members inside this method !!!
|*
\************************************************************************/
SdrModel* ChartModel::AllocModel() const
{
#ifdef DBG_UTIL
	ByteString aBStr( aMainTitle, RTL_TEXTENCODING_ASCII_US );
	CHART_TRACE1( "ChartModel::AllocModel (%s)", aBStr.GetBuffer() );
#endif

	ChartModel *pNewModel = new ChartModel(NULL);
	pNewModel->SetChartData (*pChartData, TRUE);

	pNewModel->TextScalability ()      = bTextScalable;
	pNewModel->IsCopied ()             = bIsCopied;
	pNewModel->ShowAverage ()          = bShowAverage;
	pNewModel->ChartKindError ()       = eErrorKind;
	pNewModel->ChartIndicate ()        = eIndicate;
	pNewModel->ChartRegress ()         = eRegression;

	pNewModel->IndicatePercent ()      = fIndicatePercent;
	pNewModel->IndicateBigError ()     = fIndicateBigError;
	pNewModel->IndicatePlus ()         = fIndicatePlus;
	pNewModel->IndicateMinus ()        = fIndicateMinus;
	pNewModel->SplineDeepth ()         = nSplineDeepth;
	pNewModel->Granularity ()          = nGranularity;

	pNewModel->InitialSize ()          = aInitialSize;
	pNewModel->LightVec ()             = *aLightVec;
	pNewModel->SetAmbientIntensity (fAmbientIntensity);
	pNewModel->SetAmbientColor(aAmbientColor);
	pNewModel->SpotIntensity ()        = fSpotIntensity;
	pNewModel->SetSpotColor(aSpotColor);
	pNewModel->ChartStyle ()           = eChartStyle;
	pNewModel->OldChartStyle ()        = eOldChartStyle;
	pNewModel->PieHeight ()            = nPieHeight;
	pNewModel->PieSegCount ()          = nPieSegCount;
	pNewModel->ShowMainTitle ()        = bShowMainTitle;
	pNewModel->ShowSubTitle ()         = bShowSubTitle;
	pNewModel->ShowXAxisTitle ()       = bShowXAxisTitle;
	pNewModel->ShowYAxisTitle ()       = bShowYAxisTitle;
	pNewModel->ShowZAxisTitle ()       = bShowZAxisTitle;
//    pNewModel->ShowXAxis ()            = bShowXAxis;
//    pNewModel->ShowYAxis ()            = bShowYAxis;
//    pNewModel->ShowZAxis ()            = bShowZAxis;
	pNewModel->ShowXGridMain ()        = bShowXGridMain;
	pNewModel->ShowYGridMain ()        = bShowYGridMain;
	pNewModel->ShowZGridMain ()        = bShowZGridMain;
	pNewModel->ShowXGridHelp ()        = bShowXGridHelp;
	pNewModel->ShowYGridHelp ()        = bShowYGridHelp;
	pNewModel->ShowZGridHelp()         = bShowZGridHelp;
//    pNewModel->ShowXDescr ()           = bShowXDescr;
//    pNewModel->ShowYDescr ()           = bShowYDescr;
//    pNewModel->ShowZDescr ()           = bShowZDescr;
	pNewModel->MainTitle ()            = aMainTitle;
	pNewModel->SubTitle ()             = aSubTitle;
	pNewModel->XAxisTitle ()           = aXAxisTitle;
	pNewModel->YAxisTitle ()           = aYAxisTitle;
	pNewModel->ZAxisTitle ()           = aZAxisTitle;

	pNewModel->ShowSym ()              = bShowSym;
	pNewModel->SetSwitchData(bSwitchData);

	pNewModel->aBarY1 = aBarY1;
	pNewModel->aBarY2 = aBarY2;

	pNewModel->ReadError ()            = bReadError;
	pNewModel->DataDescr  ()           = eDataDescr;

	pNewModel->CopyDefaultColors (pDefaultColors);
	pNewModel->SetShowLegend (bLegendVisible);
//    pNewModel->SetChartData (*pChartData, TRUE); #64058#
	pNewModel->SetAngles (nXAngle, nYAngle, nZAngle);

	pNewModel->AllocPieSegOfs (nPieSegCount);
/* TVM: ???:
	for (short i = 1; i < nPieSegCount; i++)
		pNewModel->SetPieSegOfs(i, 0);
*/
	for (short i = 0; i < nPieSegCount; i++)
		pNewModel->SetPieSegOfs(i,pPieSegOfs[i]);

	// #68527# BM: some attributes have been missing

	pNewModel->SetUseRelativePositions( bUseRelativePositionsForChartGroups );
	pNewModel->aDiagramRectangle				= aDiagramRectangle;
	pNewModel->aLastDiagramRectangle			= aDiagramRectangle;
	pNewModel->bDiagramHasBeenMovedOrResized	= bDiagramHasBeenMovedOrResized;
	pNewModel->aLegendTopLeft					= aLegendTopLeft;
	pNewModel->aTitleTopCenter					= aTitleTopCenter;
	pNewModel->aSubTitleTopCenter				= aSubTitleTopCenter;
	pNewModel->aTitleXAxisPosition				= aTitleXAxisPosition;
	pNewModel->aTitleYAxisPosition				= aTitleYAxisPosition;
	pNewModel->aTitleZAxisPosition				= aTitleZAxisPosition;
	pNewModel->bAdjustMarginsForLegend			= bAdjustMarginsForLegend;
	pNewModel->bAdjustMarginsForMainTitle		= bAdjustMarginsForMainTitle;
	pNewModel->bAdjustMarginsForSubTitle		= bAdjustMarginsForSubTitle;
	pNewModel->bAdjustMarginsForXAxisTitle		= bAdjustMarginsForXAxisTitle;
	pNewModel->bAdjustMarginsForYAxisTitle		= bAdjustMarginsForYAxisTitle;
	pNewModel->bAdjustMarginsForZAxisTitle		= bAdjustMarginsForZAxisTitle;
	pNewModel->bDiagramHasBeenMovedOrResized	= bDiagramHasBeenMovedOrResized;
	pNewModel->bMainTitleHasBeenMoved			= bMainTitleHasBeenMoved;
	pNewModel->bSubTitleHasBeenMoved			= bSubTitleHasBeenMoved;
	pNewModel->bLegendHasBeenMoved				= bLegendHasBeenMoved;
	pNewModel->bXAxisTitleHasBeenMoved			= bXAxisTitleHasBeenMoved;
	pNewModel->bYAxisTitleHasBeenMoved			= bYAxisTitleHasBeenMoved;
	pNewModel->bZAxisTitleHasBeenMoved			= bZAxisTitleHasBeenMoved;
	pNewModel->bSwitch3DColRow					= bSwitch3DColRow;
	pNewModel->nMarkLen							= nMarkLen;
	pNewModel->bCanRebuild						= bCanRebuild;
	pNewModel->bShowDataDescr					= bShowDataDescr;
	pNewModel->eAdjustXAxesTitle				= eAdjustXAxesTitle;
	pNewModel->eAdjustYAxesTitle				= eAdjustYAxesTitle;
	pNewModel->eAdjustZAxesTitle				= eAdjustZAxesTitle;
	pNewModel->nBarPercentWidth					= nBarPercentWidth;
	pNewModel->nNumLinesInColChart				= nNumLinesInColChart;
	pNewModel->aChartRect						= aChartRect;
	pNewModel->aInitialSize						= aInitialSize;
	pNewModel->nChartStatus						= nChartStatus;
	pNewModel->bAttrAutoStorage					= bAttrAutoStorage;

	// #68527# BM: End

	pNewModel->PutTitleAttr(	 *pTitleAttr     ,FALSE);
	pNewModel->PutMainTitleAttr( *pMainTitleAttr ,FALSE);
	pNewModel->PutSubTitleAttr(  *pSubTitleAttr  ,FALSE);
	pNewModel->PutXAxisTitleAttr(*pXAxisTitleAttr,FALSE);
	pNewModel->PutYAxisTitleAttr(*pYAxisTitleAttr,FALSE);
	pNewModel->PutZAxisTitleAttr(*pZAxisTitleAttr,FALSE);

	// merge numberformatters
	if( pNewModel->pOwnNumFormatter && pNumFormatter )
	{
		SvULONGTable* pTransTable =
			pNewModel->pOwnNumFormatter->MergeFormatter( *pNumFormatter );

		if( pTransTable && pTransTable->Count() )
		{
			// we have to merge some formats
			DBG_ERROR1( "Unexpected situation: %d number format(s) have to be merged.", pTransTable->Count() );
		}
	}

	pNewModel->PutAxisAttr (*pAxisAttr,FALSE);

	pNewModel->CopyAxisMembers(this);
	pNewModel->CopyAxisAttributes(this,FALSE);

	pNewModel->PutGridAttr (*pGridAttr,FALSE);
	pNewModel->PutXGridMainAttr(*pXGridMainAttr,FALSE);
	pNewModel->PutYGridMainAttr(*pYGridMainAttr,FALSE);
	pNewModel->PutZGridMainAttr(*pZGridMainAttr,FALSE);
	pNewModel->PutXGridHelpAttr(*pXGridHelpAttr,FALSE);
	pNewModel->PutYGridHelpAttr(*pYGridHelpAttr,FALSE);
	pNewModel->PutZGridHelpAttr(*pZGridHelpAttr,FALSE);

	pNewModel->PutDiagramAreaAttr(*pDiagramAreaAttr,FALSE);
	pNewModel->PutDiagramWallAttr(*pDiagramWallAttr,FALSE);
	pNewModel->PutDiagramFloorAttr(*pDiagramFloorAttr,FALSE);

	pNewModel->PutLegendAttr (*pLegendAttr,FALSE);
	pNewModel->SetItemSetLists(*this);
	pNewModel->PutChartAttr(*pChartAttr,FALSE);

	pNewModel->SetAttributes(CHOBJID_DIAGRAM_STOCKLINE_GROUP,*pStockLineAttr,FALSE);
	pNewModel->SetAttributes(CHOBJID_DIAGRAM_STOCKLOSS_GROUP,*pStockLossAttr,FALSE);
	pNewModel->SetAttributes(CHOBJID_DIAGRAM_STOCKPLUS_GROUP,*pStockPlusAttr,FALSE);

	DBG_ITEMS((SfxItemSet&)pNewModel->GetDataRowAttr(0),pNewModel);
	DBG_ITEMS((SfxItemSet&)GetDataRowAttr(0),(ChartModel*)this);

	return pNewModel;
}

/*************************************************************************
|*
|* Diese Methode erzeugt eine neue Seite (SchPage) und gibt einen Zeiger
|* darauf zurueck. Die Drawing Engine benutzt diese Methode beim Laden
|* zur Erzeugung von Seiten (deren Typ sie ja nicht kennt, da es ABLEITUNGEN
|* der SdrPage sind).
|*
\************************************************************************/

SdrPage* ChartModel::AllocPage(FASTBOOL bMasterPage)
{
	return new SdrPage(*this, bMasterPage);
}
/*************************************************************************
|*
|* Inserter fuer SvStream zum Speichern
|*
\************************************************************************/
SvStream& operator << (SvStream& rOut, const ChartModel& rDoc)
{
	// die daemlichen blockklammern muessen erhalten bleiben, damit
	// im destruktor ~SchIOCompat dei korrekte blockgre geschrieben
	// wird. ansonsten gibt es beim einlesen mit der 304 jede menge
	// aerger
	{
		SchIOCompat aIO(rOut, STREAM_WRITE, 1);

		if(rDoc.GetVCItemPool())
		{
			rOut << (ULONG)1L;
			rDoc.GetVCItemPool()->Store(rOut);
		}
		else
			rOut << (ULONG)0L;

		/**************************************************************************
		* Frueher (StarChart Version 3.0, File-Format Version 1) wurde hier das
		* JobSetup geschrieben, nun der Printer (binaer-kompatibel, daher wurde
		* die Version des File-Formats nicht geaendert)
		**************************************************************************/
		if (rDoc.pDocShell)
		{
			SfxPrinter* pPrinter =
				 ((SchChartDocShell*)rDoc.pDocShell)->GetPrinter();


			if (pPrinter)
			{
				pPrinter->Store(rOut);
			}
			else
			{
				// Es ist kein Printer vorhanden -> muss erzeugt werden
				SfxBoolItem aItem(SID_PRINTER_NOTFOUND_WARN, TRUE);
				SfxItemSet* pSet = new SfxItemSet(((ChartModel&) rDoc).GetPool(),
								SID_PRINTER_NOTFOUND_WARN,
								SID_PRINTER_NOTFOUND_WARN, 0);
				pSet->Put(aItem);
				SfxPrinter* pPrinter = new SfxPrinter(pSet);

				MapMode aMapMode = pPrinter->GetMapMode();
				aMapMode.SetMapUnit(MAP_100TH_MM);
				pPrinter->SetMapMode(aMapMode);

				pPrinter->Store(rOut);
				delete pPrinter;
				//delete pSet; bloss nicht! Killt der Printer gleich mit!
			}
		}
		else
		{
			// Keine DocShell, daher wird ein JobSetup geschrieben
			JobSetup aJobSetup;
			rOut << aJobSetup;
		}
	}


	rOut << (SdrModel&) rDoc;

	SchIOCompat aIO(rOut, STREAM_WRITE, 0);

	rDoc.StoreAttributes(rOut);
	//<- ehemals Basisklasse



	return rOut;
}

/*************************************************************************
|*
|* Extractor fuer SvStream zum Laden
|*
\************************************************************************/

SvStream& operator >> (SvStream& rIn, ChartModel& rDoc)
{
	// auch hier muessen die blockklammern erhalten bleiben,
	// um 304-er dokumente sauber lesen zu koennen.
	{
		SchIOCompat aIO(rIn, STREAM_READ);

		ULONG n;
		rIn >> n;
		// must be 0 or 1. Otherwise we have an error
		// most probably a wrong password
		if( n == 1L )
		{
			VCItemPool* pPool = rDoc.GetVCItemPool();
			pPool->Load(rIn);
		}
		else if( n != 0L )
		{
			rIn.SetError( ERRCODE_IO_GENERAL );
			return rIn;
		}

		if (aIO.GetVersion() >= 1)
		{

			/******************************************************************
			* Frueher (StarChart Version 3.0, File-Format Version 1) wurde hier
			* das JobSetup eingelesen, nun wird der Printer erzeugt
			* (binaer-kompatibel)
			*******************************************************************/
			// ItemSet mit speziellem Poolbereich anlegen
			SfxItemSet* pSet =
				new SfxItemSet(rDoc.GetPool(),
							   SID_PRINTER_NOTFOUND_WARN,
							   SID_PRINTER_NOTFOUND_WARN, 0);
			pSet->Put(SfxBoolItem(SID_PRINTER_NOTFOUND_WARN, TRUE));

			SfxPrinter* pPrinter = SfxPrinter::Create(rIn, pSet);

			MapMode aMM(pPrinter->GetMapMode());
			aMM.SetMapUnit(MAP_100TH_MM);
			pPrinter->SetMapMode(aMM);

			if (rDoc.pDocShell->GetCreateMode() != SFX_CREATE_MODE_EMBEDDED)
			{
				((SchChartDocShell*)rDoc.pDocShell)->SetPrinter( pPrinter, TRUE );	// will be deleted by DocShell
			}
			else
			{
				delete pPrinter;
			}
		}
	}

	// statt Basisklassenaufruf [    rIn >> (ChartModel&)rDoc;] direkt:
	rIn >> (SdrModel&)rDoc;

	if (rIn.GetError() != SVSTREAM_FILEFORMAT_ERROR)
	{
		SchIOCompat aIO(rIn, STREAM_READ);

		rDoc.LoadAttributes(rIn);
	}
	// <- Basisaufruf

	rDoc.GetItemPool().LoadCompleted();

	rDoc.ReadError () = FALSE;

	// alle 3D-Objekte werden bei einem Paint erstmailg sortiert, damit wird auch
	// das Dokument als geaendert gekennzeichnet. Diese Variable wird in der
	// CHVIEWSH-Paint-Methode abgefragt und bei Bedarf wird der Modified-Status
	// des Dokuments zurueckgesetzt.
	rDoc.FreshLoaded () = TRUE;

	return rIn;
}

/*************************************************************************
|*
|* SetChanged(), das Model wurde geaendert
|*
\************************************************************************/

void ChartModel::SetChanged(FASTBOOL bFlag)
{
	if (pDocShell)
	{
		if (bNewOrLoadCompleted && pDocShell->IsEnableSetModified())
		{
			// weitergeben an Basisklasse
			//ChartModel
			SdrModel::SetChanged(bFlag);

			// an ObjectShell weiterleiten
			pDocShell->SetModified(bFlag);
		}
	}
	else
	{
		// weitergeben an Basisklasse
		//ChartModel
		SdrModel::SetChanged(bFlag);
	}
}

/*************************************************************************
|*
|* NewOrLoadCompleted
|*
|* Wird gerufen, wenn das Dokument geladen wurde bzw. feststeht, dass es
|* nicht mehr geladen wird.
|*
\************************************************************************/

void ChartModel::NewOrLoadCompleted(USHORT eMode)
{
	if (eMode == NEW_DOC)
	{
		// StyleSheets generieren
		Font aRomanFont = System::GetStandardFont(STDFONT_ROMAN);
		SvxFontItem aRomanFontItem(aRomanFont.GetFamily(),
								   aRomanFont.GetName(), String(),
								   aRomanFont.GetPitch(),
								   aRomanFont.GetCharSet());

		Font aSwissFont = System::GetStandardFont(STDFONT_SWISS);
		SvxFontItem aSwissFontItem(aSwissFont.GetFamily(),
								   aSwissFont.GetName(), String(),
								   aSwissFont.GetPitch(),
								   aSwissFont.GetCharSet());

		SfxStyleSheetBase* pSheet =
			&pStyleSheetPool->Make(String(SchResId(STR_STLSHEET_TITLE_MAIN)),
										  SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(493));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_TITLE_SUB)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(423));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_TITLE_X_AXIS)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(352));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_TITLE_Y_AXIS)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(352));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_TITLE_Z_AXIS)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(352));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_DATAROWS)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(282));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_DATACOLS)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(282));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_DATAVALUES)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(282));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_DATADESCR)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(282));

		pSheet = &pStyleSheetPool->
					Make(String(SchResId(STR_STLSHEET_LEGEND)),
						 SFX_STYLE_FAMILY_PARA);
		pSheet->GetItemSet().Put(aSwissFontItem);
		pSheet->GetItemSet().Put(SvxColorItem(RGBColor(COL_BLACK)));
		pSheet->GetItemSet().Put(SvxFontHeightItem(282));
	}
	else if (eMode == DOC_LOADED)
	{
		// momentan nichts
	}

	bNewOrLoadCompleted = TRUE;
#ifdef DBG_UTIL
	if(pChartData && GetRowCount() && GetColCount())
	{
		CHART_TRACE1( "ChartModel::NewOrLoadCompleted debugging ChartItems Model %s ",
					  (eMode==DOC_LOADED)? "was loaded": ((eMode==NEW_DOC)? "is new" : "don't know") );
		DBG_ITEMS((SfxItemSet&)GetDataRowAttr(0),this);
		DBG_ITEMS((SfxItemSet&)GetDataPointAttr(0,0),this);
	}
#endif
}

/*************************************************************************
|*
|* GetVCItemPool(), gibt den Pool fuer VControls zurueck
|*
\************************************************************************/

VCItemPool* ChartModel::GetVCItemPool() const
{
	if(!pVCItemPool) ((ChartModel*)this)->pVCItemPool = new VCItemPool;

	return pVCItemPool;
}

/*************************************************************************
|*
|* Setze den Modified-Status zurueck, wenn ein Dokument mit
|* 3D-Objekten geladen und ausgegeben wurde
|*
\************************************************************************/

void ChartModel::ResetFreshLoaded ()
{
	bFreshLoaded = FALSE;
	SetChanged (FALSE);
}



