/*************************************************************************
 *
 *  $RCSfile: chtmodel.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:29:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#pragma optimize("e",off)

#pragma hdrstop

class SbxArray;

#include "schshape.hxx"

#ifndef _OUTLINER_HXX
#include <svx/svdoutl.hxx>
#endif

#include "itempool.hxx"

#ifndef _SVDPAGE_HXX
#include <svx/svdpage.hxx>
#endif

#include <svx/svdetc.hxx>

#ifndef _EEITEM_HXX
#include <svx/eeitem.hxx>
#endif
#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif
#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _ZFORLIST_HXX
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#endif
#ifndef _SVDORECT_HXX
#include <svx/svdorect.hxx>
#endif
#ifndef _XLNCLIT_HXX
#include <svx/xlnclit.hxx>
#endif
#ifndef _XLNWTIT_HXX
#include <svx/xlnwtit.hxx>
#endif
#ifndef _XFLCLIT_HXX
#include <svx/xflclit.hxx>
#endif
#ifndef _SCHATTR_HXX
#include "schattr.hxx"
#endif
#ifndef _SCH_MEMCHRT_HXX
#include "memchrt.hxx"
#endif

#ifndef _SVX_CHRTITEM_HXX
#define ITEMID_DOUBLE	        0
#define ITEMID_CHARTTEXTORDER   SCHATTR_TEXT_ORDER
#define ITEMID_CHARTTEXTORIENT	SCHATTR_TEXT_ORIENT
#define ITEMID_CHARTLEGENDPOS   SCHATTR_LEGEND_POS
#define ITEMID_CHARTDATADESCR   SCHATTR_DATADESCR_DESCR
#include <svx/chrtitem.hxx>
#endif

#define ITEMID_FONT        EE_CHAR_FONTINFO
#define ITEMID_COLOR       EE_CHAR_COLOR
#define ITEMID_FONTHEIGHT  EE_CHAR_FONTHEIGHT
#include <svx/fontitem.hxx>
#include <svx/fhgtitem.hxx>
#include <svx/colritem.hxx>
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _LANG_HXX
#include <tools/lang.hxx>
#endif
#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif

#ifndef _SVX_XLINEIT0_HXX
#include <svx/xlineit0.hxx>
#endif

// header for XHyphenator
#ifndef _COM_SUN_STAR_LINGUISTIC_XHYPHENATOR_HPP_
#include <com/sun/star/linguistic/XHyphenator.hpp>
#endif
// header for SvxGetLinguPropertySet
#ifndef _UNO_LINGU_HXX
#include <svx/unolingu.hxx>
#endif
// header for getProcessServiceFactory
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#ifndef _CHTMODEL_HXX
#include <chtmodel.hxx>
#include <globfunc.hxx>
#endif
#ifndef _SCHATTR_HXX
#include "schattr.hxx"
#endif
#include "charttyp.hxx"

#include "float.h"


#include "pairs.hxx"
#include "stlpool.hxx"
#include "schresid.hxx"
#include "glob.hrc"

#include "datalog.hxx"
#include "chaxis.hxx"

#include "chtscene.hxx"
#include "svx/def3d.hxx"
/************************************************************************/

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

using namespace com::sun::star;

ChartModel::ChartModel(SfxObjectShell* pDocSh) :
	pChartDataBuffered(NULL),
	pAutoPilot(NULL),//#46895#
	bClearDepth(FALSE),
	bNewOrLoadCompleted(FALSE),//aus SchChartDocument::
	nChartStatus( CHS_USER_QUERY ),
	SdrModel(SFX_APP()->GetAppIniManager()->Get( SFX_KEY_PALETTE_PATH ), NULL,(SvPersist *) pDocSh),
	aChartRect (Rectangle ()),
	aInitialSize (Size ()),
	bTextScalable (TRUE),
	bIsCopied (FALSE),
	bLegendVisible (TRUE),
	bShowAverage (FALSE),
	eErrorKind (CHERROR_NONE),
	eIndicate (CHINDICATE_NONE),
	eRegression (CHREGRESS_NONE),
	fIndicatePercent (0.0),
	fIndicateBigError (0.0),
	fIndicatePlus (0.0),
	fIndicateMinus (0.0),
	nSplineDeepth (3),
	nGranularity (20),
	bSwitch3DColRow (FALSE), // FG: reiner Zwischenspeicher, damit die ChartScene das nicht als Parameter bekommt
							 //     ist immer gleich bSwitchRowCol, das aber wird durchs Chart als Parameter
							 //     durchgereicht.
	pChItemPool (new SchItemPool),
	pScene (0),
	aLightVec (new Vector3D (1, 1, 1)), // old: aLightVec (new Vector3D (0, 0, 1)),
	pChartData (0),
	fMinData (0.0),
	fMaxData (0.0),
	fAmbientIntensity(0.6),
	aAmbientColor(RGBColor(COL_WHITE)),
	fSpotIntensity (0.6),
	aSpotColor(RGBColor(COL_WHITE)),
	eChartStyle (CHSTYLE_2D_COLUMN),
	eOldChartStyle (CHSTYLE_3D_XYZSYMBOLS),
	pDefaultColors (0),
	nMarkLen (100),
	nPieHeight (20),
	pPieSegOfs (0),
	nPieSegCount (0),
	nXAngle (100), // old: nXAngle (200),
	nYAngle (250), // old: nYAngle (350),
	nZAngle (0),
	bCanRebuild (TRUE),
	bShowMainTitle (TRUE),
	aMainTitle (String ()),
	bShowSubTitle (FALSE),
	aSubTitle (String ()),
	bShowXAxisTitle (FALSE),
	aXAxisTitle (String ()),
	bShowYAxisTitle (FALSE),
	aYAxisTitle (String ()),
	bShowZAxisTitle (FALSE),
	aZAxisTitle (String ()),
	bShowXGridMain (TRUE),
	bShowXGridHelp (FALSE),
	bShowYGridMain (FALSE),
	bShowYGridHelp (FALSE),
	bShowZGridMain (FALSE),
	bShowZGridHelp (FALSE),
	eDataDescr (CHDESCR_NONE),
	bShowSym (FALSE),
	bSwitchData (TRUE),
	bNoBuildChart( FALSE ),
	bShouldBuildChart( TRUE ),
	bReadError (FALSE),
	pOwnNumFormatter(FALSE),
	pOutliner( SdrMakeOutliner( OUTLINERMODE_TEXTOBJECT, this) ),
		// FG: nMoreData >=12
	bFormatXAxisTextInMultipleLinesIfNecessary (TRUE),
	bFormatYAxisTextInMultipleLinesIfNecessary (FALSE),
	bFormatZAxisTextInMultipleLinesIfNecessary (FALSE),
	bFormatLegendTextInMultipleLinesIfNecessary (TRUE),
		// FG: nMoreData >=13
	nXAxisTextMaximumNumberOfLines(2),
	nYAxisTextMaximumNumberOfLines(1),
	nZAxisTextMaximumNumberOfLines(1),
	nWidthOfFirstXAxisText (0),
	nWidthOfLastXAxisText (0),
	aTitleTopCenter(-1,-1),
	aSubTitleTopCenter(-1,-1),
	aDiagramRectangle(-1,-1,-1,-1),
	aLastDiagramRectangle(-1,-1,-1,-1),
	aLegendTopLeft(-1,-1),
	aTitleXAxisPosition (-1,-1),
	eAdjustXAxesTitle(CHADJUST_TOP_CENTER),
	aTitleYAxisPosition(-1,-1),
	eAdjustYAxesTitle(CHADJUST_TOP_CENTER),
	aTitleZAxisPosition (-1,-1),
	eAdjustZAxesTitle(CHADJUST_TOP_CENTER),
	bUseRelativePositionsForChartGroups(FALSE),
	bAdjustMarginsForLegend(TRUE),
	bAdjustMarginsForMainTitle(TRUE),
	bAdjustMarginsForSubTitle(TRUE),
	bAdjustMarginsForXAxisTitle(TRUE),
	bAdjustMarginsForYAxisTitle(TRUE),
	bAdjustMarginsForZAxisTitle(TRUE),
	bDiagramHasBeenMovedOrResized(FALSE),
	bMainTitleHasBeenMoved(FALSE),
	bSubTitleHasBeenMoved(FALSE),
	bLegendHasBeenMoved(FALSE),
	bXAxisTitleHasBeenMoved(FALSE),
	bYAxisTitleHasBeenMoved(FALSE),
	bZAxisTitleHasBeenMoved(FALSE),
	aInitialSizefor3d (-1,-1),    // FG: Zwischenspeicher fuer InitalSize (siehe chtmod3d.cxx, Position3DAxisTitles
	pTestTextObj(NULL),  //  FG: fuer GetHeightOfnRows, ein Dummy-Textpointer
	pLogBook(NULL),
	bShowDataDescr(TRUE),

	pDocShell(pDocSh), //aus SchChartDocument::
	pVCItemPool(NULL),
	bFreshLoaded (FALSE),
	m_nDefaultColorSet(0),  //#50037#
	nBarPercentWidth(100),   //#50116#
	nNumLinesInColChart(1),   //#50212#
	pMainTitleShape(NULL),
	pSubTitleShape(NULL),
	pXAxisTitleShape(NULL),
	pYAxisTitleShape(NULL),
	pZAxisTitleShape(NULL),
	pLegendShape(NULL),
	pAreaShape(NULL),
	bAttrAutoStorage(FALSE),
	pChartRefOutDev(NULL),
	pChartXAxis(NULL),
	pChartYAxis(NULL),
	pChartZAxis(NULL),
	pChartBAxis(NULL),
	pChartAAxis(NULL),
	pTmpXItems(NULL),
	pTmpYItems(NULL),
	pTmpZItems(NULL),
	pSdrObjList(NULL),
	eProjection(PR_PERSPECTIVE),
	bResizePie(TRUE),
	nPieRadius(0),
	pNumFormatter(NULL),
	nXLastNumFmt(-1),
	nYLastNumFmt(-1),
	nBLastNumFmt(-1)
{

	aLightVec->Normalize ();

	SetScaleUnit(MAP_100TH_MM);
	SetScaleFraction(Fraction(1, 1));
	SetDefaultFontHeight(847);     // 24pt

	SfxItemPool* pPool = &GetItemPool();
	pPool->SetDefaultMetric(SFX_MAPUNIT_100TH_MM);
	pPool->SetPoolDefaultItem( SfxBoolItem(EE_PARA_HYPHENATE, TRUE) );

	pOwnNumFormatter = new SvNumberFormatter( LANGUAGE_SYSTEM );
	pOwnNumFormatter->ChangeStandardPrec( 15 );

	// append pool to end of pool chain
	for (;;)
	{
		SfxItemPool* pSecondary = pPool->GetSecondaryPool();
		if (!pSecondary)
			break;

		pPool = pSecondary;
	}

	pPool->SetSecondaryPool(pChItemPool);

	SfxItemPool* pMasterPool = &GetItemPool();
	pMasterPool->FreezeIdRanges();

	// get current language
	LanguageType eLanguage = Application::GetAppInternational().GetLanguage();
	if (eLanguage == LANGUAGE_SYSTEM)
		eLanguage = System::GetLanguage();
	if (eLanguage == LANGUAGE_DONTKNOW)
		eLanguage = LANGUAGE_ENGLISH_US;

	SdrOutliner& rDrawOutliner = GetDrawOutliner();
	uno::Reference< lang::XMultiServiceFactory > xMgr( ::utl::getProcessServiceFactory() );

	uno::Reference< linguistic::XHyphenator > xHyph( SvxGetHyphenator() );
	uno::Reference< beans::XPropertySet > xProp( xMgr->createInstance(
		::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.linguistic.LinguProperties" ))), uno::UNO_QUERY );

	LanguageType nDefaultLanguage;
	if( xProp.is() )
	{
		uno::Any aAny = xProp->getPropertyValue(
			::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "DefaultLanguage" )));
		aAny >>= nDefaultLanguage;
	}
	else
	{
		nDefaultLanguage = Application::GetAppInternational().GetLanguage();
		if( nDefaultLanguage == LANGUAGE_SYSTEM )
			nDefaultLanguage = System::GetLanguage();
	}

	// set language and hyphenator at both outliners
	rDrawOutliner.SetDefaultLanguage( nDefaultLanguage );
	if( xHyph.is() )
	{
		rDrawOutliner.SetHyphenator( xHyph );
	}

	// nDefaultLanguage and xHyph are defined in last else branch
	pOutliner->SetDefaultLanguage( nDefaultLanguage );

	if( xHyph.is() )
	{
		rDrawOutliner.SetHyphenator( xHyph );
		pOutliner->SetHyphenator( xHyph );
	}

	// init item sets for chart objects
	pTitleAttr          = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pMainTitleAttr      = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pSubTitleAttr       = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pXAxisTitleAttr     = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pYAxisTitleAttr     = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pZAxisTitleAttr     = new SfxItemSet(*pItemPool, nTitleWhichPairs);
	pAxisAttr           = new SfxItemSet(*pItemPool, nAllAxisWhichPairs);
	pGridAttr           = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pXGridMainAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pYGridMainAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pZGridMainAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pXGridHelpAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pYGridHelpAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pZGridHelpAttr      = new SfxItemSet(*pItemPool, nGridWhichPairs);
	pDiagramAreaAttr    = new SfxItemSet(*pItemPool, nDiagramAreaWhichPairs);
	pDiagramWallAttr    = new SfxItemSet(*pItemPool, nDiagramAreaWhichPairs);
	pDiagramFloorAttr   = new SfxItemSet(*pItemPool, nDiagramAreaWhichPairs);
	pLegendAttr         = new SfxItemSet(*pItemPool, nLegendWhichPairs);
	pChartAttr          = new SfxItemSet(*pItemPool, nChartWhichPairs);
	pDummyAttr          = new SfxItemSet(*pItemPool, nRowWhichPairs);

	pStockLineAttr		= new SfxItemSet(*pItemPool, nRowWhichPairs);
	pStockLossAttr		= new SfxItemSet(*pItemPool, nRowWhichPairs);
	pStockPlusAttr		= new SfxItemSet(*pItemPool, nRowWhichPairs);

	SdrPage* pPage = GetPage(0);
	if (pPage) aInitialSize = pPage->GetSize();

	CreateDefaultColors ();
	eChartLinePoints[0] =
	eChartLinePoints[1] =
	eChartLinePoints[2] =
	eChartLinePoints[3] =
	eChartLinePoints[4] =
	eChartLinePoints[5] =
	eChartLinePoints[6] =
	eChartLinePoints[7] =
	eChartLinePoints[8] = 0;

	Font aRomanFont = System::GetStandardFont(STDFONT_ROMAN);
	Font aSwissFont = System::GetStandardFont(STDFONT_SWISS);

	// main title
	pTitleAttr->Put(SvxFontItem(aSwissFont.GetFamily(),
								aSwissFont.GetName(), String(),
								aSwissFont.GetPitch(),
								aSwissFont.GetCharSet()));
	pTitleAttr->Put(SvxColorItem(RGBColor(COL_BLACK)));
	pTitleAttr->Put(SvxFontHeightItem( 459 ));	// 13pt
	pTitleAttr->Put(XLineStyleItem(XLINE_NONE));
	pTitleAttr->Put(XFillStyleItem(XFILL_NONE));
	pTitleAttr->Put(SvxChartTextOrientItem(CHTXTORIENT_AUTOMATIC));
	pMainTitleAttr->Put(*pTitleAttr);

	// sub title
	pTitleAttr->Put(SvxFontHeightItem( 388 ));	// 11pt
	pSubTitleAttr->Put(*pTitleAttr);

	// axis titles
	pTitleAttr->Put(SvxFontHeightItem( 318 ));	// 9pt
	pXAxisTitleAttr->Put(*pTitleAttr);
	pYAxisTitleAttr->Put(*pTitleAttr);
	pZAxisTitleAttr->Put(*pTitleAttr);

	// general axis attributies: are also set in class ChartAxis()
	// (BM) => deprecated and therefore removed here

	pDiagramAreaAttr->Put(XLineStyleItem(XLINE_NONE));
	pDiagramAreaAttr->Put(XFillColorItem(String(), RGBColor(COL_WHITE)));

	pDiagramWallAttr->Put(XLineStyleItem(XLINE_NONE));
	pDiagramWallAttr->Put(XFillStyleItem(XFILL_NONE));

	pDiagramFloorAttr->Put(XLineStyleItem(XLINE_NONE));
	pDiagramFloorAttr->Put(XFillColorItem(String(), Color(153, 153, 153)));

	pLegendAttr->Put(SvxFontItem(aSwissFont.GetFamily(),
								 aSwissFont.GetName(), String(),
								 aSwissFont.GetPitch(),
								 aSwissFont.GetCharSet()));
	pLegendAttr->Put(SvxFontHeightItem( 212 ));	// 6pt #72012#
	pLegendAttr->Put(XFillStyleItem(XFILL_NONE));

	//Todo: ueberpruefen, ob noch korekkt, es wird der default-ChartTyp erzeugt und der
	//AttrSet in pChartAttr gesetzt
	ChartType aTyp((SvxChartStyle) CHSTYLE_2D_COLUMN);
	aTyp.GetAttrSet(pChartAttr);

	// the dummy attribute is (mainly!) used for data row defaults
	// so avoid setting (pool) default values here as fixed
	pDummyAttr->Put( SvxFontItem( aSwissFont.GetFamily(),
								  aSwissFont.GetName(), String(),
								  aSwissFont.GetPitch(),
								  aSwissFont.GetCharSet()));
	pDummyAttr->Put( SvxFontHeightItem( 212 ));	// 6pt used for data labels

	// what are these needed for?
	pDummyAttr->Put (SfxInt32Item (SCHATTR_DUMMY0, (INT32) eChartStyle));
	pDummyAttr->Put (SfxInt32Item (SCHATTR_DUMMY1, 0));


	pStockLossAttr->Put(XFillColorItem(String(), RGBColor(COL_BLACK)));
	pStockPlusAttr->Put(XFillColorItem(String(), RGBColor(COL_WHITE)));

	// this test object is for calculating the text height in GetHeightOfnRows
	// (chtmode1.cxx) without creating a new object for each call.
	pTestTextObj = new SdrRectObj (OBJ_TEXT, Rectangle(0, 0, 10, 10) /*, aTestStr*/);

	//Aus SchChartDocument::
	SetStyleSheetPool(new SchStyleSheetPool(*pItemPool));
	((SdrOutliner*)pDrawOutliner)->SetStyleSheetPool((SfxStyleSheetPool*)pStyleSheetPool);
	pOutliner->SetStyleSheetPool((SfxStyleSheetPool*)pStyleSheetPool);

	// Layer anlegen

	SdrLayerAdmin& rLayerAdmin = GetLayerAdmin();
	rLayerAdmin.NewLayer( String( SchResId( STR_LAYOUT )));
	rLayerAdmin.NewLayer( String( SchResId( STR_CONTROLS )));


	//Wichtig! die Achsen muessen jetzt erstellt werden, dies darf erst nach dem
	//anlegen des ItemPools und der Defaults passieren!
	pChartXAxis = new ChartAxis( this, CHART_AXIS_X, CHAXIS_AXIS_X );
	pChartYAxis = new ChartAxis( this, CHART_AXIS_Y, CHAXIS_AXIS_Y );
	pChartZAxis = new ChartAxis( this, CHART_AXIS_Z, CHAXIS_AXIS_Z );
	pChartBAxis = new ChartAxis( this, CHART_AXIS_Y, CHAXIS_AXIS_B );
	pChartAAxis = new ChartAxis( this, CHART_AXIS_X, CHAXIS_AXIS_A );

	pChartYAxis->IfNoDataLookAt( CHAXIS_AXIS_B ); //Falls Achse nur ein Spiegelbild ist....
	pChartBAxis->IfNoDataLookAt( CHAXIS_AXIS_Y ); //d.h. keine eigenen Datenreihen besitzt

	aBarY1.Assign(this,pChartYAxis);
	aBarY2.Assign(this,pChartBAxis);

	pChartXAxis->SetAllAxisAttr(pAxisAttr);
	pChartYAxis->SetAllAxisAttr(pAxisAttr);
	pChartZAxis->SetAllAxisAttr(pAxisAttr);
	pChartAAxis->SetAllAxisAttr(pAxisAttr);
	pChartBAxis->SetAllAxisAttr(pAxisAttr);

	pChartXAxis->SetGridAttrList(pYGridMainAttr);//XGrid->YAchse :(  (u.U.)
	pChartYAxis->SetGridAttrList(pXGridMainAttr);

	SetNumberFormatter( pOwnNumFormatter );				// sets number formatter also for all axes

	long nTmp=pNumFormatter->GetStandardFormat(NUMBERFORMAT_NUMBER, LANGUAGE_SYSTEM);
	SetNumFmt(CHOBJID_DIAGRAM_X_AXIS,nTmp,FALSE);
	SetNumFmt(CHOBJID_DIAGRAM_Y_AXIS,nTmp,FALSE);
	SetNumFmt(CHOBJID_DIAGRAM_Z_AXIS,nTmp,FALSE);
	SetNumFmt(CHOBJID_DIAGRAM_A_AXIS,nTmp,FALSE);
	SetNumFmt(CHOBJID_DIAGRAM_B_AXIS,nTmp,FALSE);

	pChartBAxis->ShowAxis(FALSE);
	pChartBAxis->ShowDescr(FALSE);
	pChartAAxis->ShowAxis(FALSE);
	pChartAAxis->ShowDescr(FALSE);

	pSdrObjList=new SdrObjList(this,NULL);
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/
void ChartModel::ClearItemSetLists()
{
	long i, nCount;

	nCount = aDataRowAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aDataRowAttrList.GetObject(i);
	aDataRowAttrList.Clear();

	nCount = aRegressAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aRegressAttrList.GetObject(i);
	aRegressAttrList.Clear();

	nCount = aDataPointAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aDataPointAttrList.GetObject(i);
	aDataPointAttrList.Clear();

	nCount = aSwitchDataPointAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aSwitchDataPointAttrList.GetObject(i);
	aSwitchDataPointAttrList.Clear();

	nCount =  aAverageAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aAverageAttrList.GetObject(i);
	aAverageAttrList.Clear();

	nCount =  aErrorAttrList.Count();
	for (i = 0 ; i < nCount; i++)
		delete aErrorAttrList.GetObject(i);
	aErrorAttrList.Clear();
}
ChartModel::~ChartModel()
{
	if(pTmpXItems)
		delete pTmpXItems;
	if(pTmpYItems)
		delete pTmpYItems;
	if(pTmpZItems)
		delete pTmpZItems;

	if(pChartRefOutDev)
		delete pChartRefOutDev;

	Clear();//aus SchChartDocument::
	delete pVCItemPool;

	delete pTitleAttr;
	delete pMainTitleAttr;
	delete pSubTitleAttr;
	delete pXAxisTitleAttr;
	delete pYAxisTitleAttr;
	delete pZAxisTitleAttr;
	delete pAxisAttr;

	delete pChartXAxis;
	delete pChartYAxis;
	delete pChartZAxis;
	delete pChartAAxis;
	delete pChartBAxis;

	delete pGridAttr;
	delete pXGridMainAttr;
	delete pYGridMainAttr;
	delete pZGridMainAttr;
	delete pXGridHelpAttr;
	delete pYGridHelpAttr;
	delete pZGridHelpAttr;
	delete pDiagramAreaAttr;
	delete pDiagramWallAttr;
	delete pDiagramFloorAttr;
	delete pLegendAttr;
	delete pChartAttr;
	delete pDummyAttr;
	delete aLightVec;

	delete pStockLineAttr;
	delete pStockLossAttr;
	delete pStockPlusAttr;

	DestroyDefaultColors();
	ClearItemSetLists();

	// suche nach dem ChartPool in der Poolkette, loesche alle verbindungen
	// und vernichte den pool. vorgehen ist unabhaengig von der anzahl
	// der vorangehendem pools. [RB]
	SfxItemPool* pPool = &GetItemPool();

	for (;;)
	{
		SfxItemPool* pSecondary = pPool->GetSecondaryPool();
		if (pSecondary == pChItemPool)
		{
			pPool->SetSecondaryPool (NULL);
			break;
		}

		pPool = pSecondary;
	}

	delete pChItemPool;

	delete pOwnNumFormatter;

	delete pOutliner;

	delete[] pPieSegOfs;

	if(pChartData)
	{
		if(pChartData->DecreaseRefCount())
			delete pChartData;
		pChartData=NULL;
	}

	if (pTestTextObj != NULL) delete pTestTextObj;
	if (pLogBook) delete pLogBook;



	SdrObject *pObj;
	while(pSdrObjList->GetObjCount())
		if(pObj=pSdrObjList->RemoveObject(0))
			delete	pObj;
	delete pSdrObjList;
}
SdrObjList *ChartModel::GetSdrObjList()
{
	if(pSdrObjList)
	{
		SdrObject *pObj;
		while(pSdrObjList->GetObjCount())
			if(pObj=pSdrObjList->RemoveObject(0))
				delete	pObj;
	}

	ULONG nLegendHeight = ((SvxFontHeightItem &) pLegendAttr->Get (EE_CHAR_FONTHEIGHT)).GetHeight();

	SfxItemSet aSet(*pDummyAttr);
	aSet.ClearItem(SCHATTR_SYMBOL_BRUSH);
	aSet.ClearItem(SCHATTR_SYMBOL_SIZE);
	for(long n=0;n<CHART_NUM_SYMBOLS;n++)
	{
		aSet.Put(SfxInt32Item(SCHATTR_STYLE_SYMBOL,n));
		pSdrObjList->NbcInsertObject(CreateSymbol(Point(0,0),n,0,aSet,nLegendHeight,FALSE));
	}

	return pSdrObjList;
}
SdrObject *ChartModel::CreateDefaultSymbol(long nRow)
{
	ULONG nLegendHeight = ((SvxFontHeightItem &) pLegendAttr->Get (EE_CHAR_FONTHEIGHT)).GetHeight();
	SfxItemSet aSet(GetDataRowAttr(nRow));
	aSet.ClearItem(SCHATTR_STYLE_SYMBOL);
	aSet.ClearItem(SCHATTR_SYMBOL_BRUSH);
	aSet.ClearItem(SCHATTR_SYMBOL_SIZE);

	return CreateSymbol(Point(0,0),nRow,0,aSet,nLegendHeight,FALSE);
}
/*************************************************************************
|*
|* Das Logbuch dient zur ReAttributierung, nachdem die DataBrowseBox
|* aufgerufen und Daten hinzugefuegt wurden. Die BrowseBox setzt
|* eine
|*
\************************************************************************/
void ChartModel::SetDataLogBook(SchDataLogBook* pLog)
{
	if(pLogBook)
		delete pLogBook;
	pLogBook=pLog;
}


/*************************************************************************
|*
|* Chart-Datenstruktur auswechseln; bisherige wird ggf. geloescht;
|* Liefert TRUE, wenn die Chart-Datenstruktur gewechselt wurde.
|*
\************************************************************************/

BOOL ChartModel::ChangeChartData(SchMemChart& rData, BOOL bNewTitles,BOOL bDontBuild)
{
	if (pChartData == &rData) return FALSE;
	else
	{
		SetChartData(rData, bNewTitles);
		if(!bDontBuild)
			BuildChart(FALSE);
		return TRUE;
	}
}

/*************************************************************************
|*
|* Datenzeilen in Reihen/Spalten umschalten;
|* Liefert bei Umschaltung TRUE
|*
\************************************************************************/

BOOL ChartModel::ChangeSwitchData(BOOL bSwitch)
{
	if (bSwitchData == bSwitch) return FALSE;
	else
	{
		bSwitchData = bSwitch;

#ifndef NO_56798_FIX //#56798# QuickFix 5.0-Final
		if( IsReal3D() )
		{
			bClearDepth=TRUE;
			long i,nORow=aDataRowAttrList.Count();
			for(i=0;i<nORow;i++)
				aDataRowAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);
			nORow=aDataPointAttrList.Count();
			for(i=0;i<nORow;i++)
				aDataPointAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);
			nORow=aSwitchDataPointAttrList.Count();
			for(i=0;i<nORow;i++)
				aSwitchDataPointAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);
		}
#endif

		// BM: #68764#
		// if global data descriptions are on transfer them to new rows
		if( eDataDescr != CHDESCR_NONE )
		{
			ChangeDataDescr( eDataDescr, bShowSym, -1, FALSE );
		}

		BuildChart(FALSE);
		return TRUE;
	}
}


/*************************************************************************
|*
|* Charttyp aendern;
|* Liefert bei neuem Charttyp TRUE.
|*
\************************************************************************/
//Sub von ChangeChart
void ChartModel::SetupLineColors(const long nMode) //#54870#
{

	SfxItemSet rAttr(GetItemPool(),XATTR_START,XATTR_END);

	if(nMode != SETLINES_COMPAT) //Dann nur Farbe korrigieren!
	{							 //sonst einige defaultwerte
		rAttr.Put(XLineStyleItem(XLINE_SOLID));
		rAttr.Put(XLineColorItem(String(),RGBColor(COL_BLACK)));
		rAttr.Put(XLineWidthItem (0));
	}

	long nRow,nRowCnt=aDataRowAttrList.Count();//=GetRowCount();

	for(nRow=0;nRow<nRowCnt;nRow++)
	{
		if(IsLine(nRow) || nMode==SETLINES_BLACK)
		{
			switch(nMode)
			{
				case SETLINES_COMPAT:
				case SETLINES_FILLCOLOR:
					rAttr.Put(XLineColorItem(String(),
							((XFillColorItem &)GetDataRowAttr(nRow).Get(XATTR_FILLCOLOR)).GetValue()));
					break;
				case SETLINES_REVERSE:
					rAttr.Put(XFillColorItem(String(),
							((XLineColorItem &)GetDataRowAttr(nRow).Get(XATTR_LINECOLOR)).GetValue()));
				default:
					break;
			}

			aDataRowAttrList.GetObject(nRow)->Put(rAttr);
			//PutDataRowAttr(nRow,rAttr);
		}
	}
}

// BM: src566b: ChangeChart doesn't execute BuildChart any more!
BOOL ChartModel::ChangeChart(SvxChartStyle eStyle/*, long nGap, long nOver*/)
{
	if (eStyle == eChartStyle/* && nGap == nGapWidth && nOver == nOverlap*/)
		return FALSE;
	else
	{
		bResizePie=TRUE;

		// OldChartStyle merken
		eOldChartStyle = eChartStyle;

		//########### Ab hier werden defaultwerte umgesetzt:######### :

		//Wenn Linien, aber nicht 3D, dann muss evtl. bei
		//Typwechsel die Linienfarbe neu defaultet werden!

		long nRefLine=0;//Bei StockChart 3,4 ist die erste Zeile keine Linie
		if(GetRowCount()>1)
			nRefLine=1;

		BOOL bOldIsLine=IsLine(nRefLine)&& !Is3DChart();//#54870#//Verbund-Charts OK???
		BOOL bOldIsStock=HasStockLines();
		BOOL bOldIs3D=IsReal3D();
		BOOL bOldHadStockBars=HasStockBars();
		BOOL bOldXY = IsXYChart();
		BOOL bOldNet = IsNetChart();

		eChartStyle = eStyle;

		BOOL bNewIsLine=IsLine(nRefLine) && !Is3DChart();//#54870#
		BOOL bNewIs3D=IsReal3D();

		if( eStyle == CHSTYLE_3D_PIE )
		{
			for( short i = 0; i < nPieSegCount; i++ )
				PieSegOfs( i ) = 0;
		}

		// BM: use gray (15%) background (wall) for some charts
		if( HasDefaultGrayWall() != HasDefaultGrayWall( &eOldChartStyle ) )
		{
			if( HasDefaultGrayWall() )
			{
				pDiagramWallAttr->Put( XFillStyleItem( XFILL_SOLID ));
				pDiagramWallAttr->Put( XFillColorItem( String(), RGBColor( RGB_COLORDATA( 0xd9, 0xd9, 0xd9 ) )) );

				pLegendAttr->Put( XFillStyleItem( XFILL_SOLID ));
				pLegendAttr->Put( XFillColorItem( String(), RGBColor( RGB_COLORDATA( 0xd9, 0xd9, 0xd9 ) )) );
			}
			else
			{
				pDiagramWallAttr->Put( XFillStyleItem( XFILL_NONE ));
				pDiagramWallAttr->Put( XFillColorItem( String(), RGBColor( COL_WHITE )) );

				pLegendAttr->Put( XFillStyleItem( XFILL_NONE ));
				pLegendAttr->Put( XFillColorItem( String(), RGBColor( COL_WHITE )) );
			}
		}

		// BM: use gray (15%) background (area) for some charts
		if( HasDefaultGrayArea() != HasDefaultGrayArea( &eOldChartStyle ) )
		{
			if( HasDefaultGrayArea() )
			{
				pDiagramAreaAttr->Put( XFillStyleItem( XFILL_SOLID ));
				pDiagramAreaAttr->Put( XFillColorItem( String(), RGBColor( RGB_COLORDATA( 0xd9, 0xd9, 0xd9 ) )) );

				pLegendAttr->Put( XFillStyleItem( XFILL_SOLID ));
				pLegendAttr->Put( XFillColorItem( String(), RGBColor( RGB_COLORDATA( 0xd9, 0xd9, 0xd9 ) )) );
			}
			else
			{
				pDiagramAreaAttr->Put( XFillColorItem( String(), RGBColor( COL_WHITE )) );

				pLegendAttr->Put( XFillStyleItem( XFILL_NONE ));
				pLegendAttr->Put( XFillColorItem( String(), RGBColor( COL_WHITE )) );
			}
		}

		if(bOldXY!=IsXYChart())
		{
			if(bOldXY)
				aDataRowAttrList.GetObject(0)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_Y));//wird evtl. unten gendert, s.u. StockCharts
			else
				aDataRowAttrList.GetObject(0)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_X));

			CheckForNewAxisNumFormat();			// BM #59532#
		}

		if(bNewIsLine != bOldIsLine)
		{
			SetupLineColors( (bNewIsLine) ? SETLINES_FILLCOLOR : SETLINES_BLACK );
		}
		long nRowCnt=aDataRowAttrList.Count();//=GetRowCount();
		if( (bOldIsStock && !HasStockLines()) || (bOldIs3D && !bNewIs3D) )
		{
			for(long n=0;n<nRowCnt;n++)
				aDataRowAttrList.GetObject(n)->Put(XLineStyleItem(XLINE_SOLID));
			long nColCnt=aDataPointAttrList.Count();
			for(n=0;n<nColCnt;n++)
				aDataPointAttrList.GetObject(n)->ClearItem(XATTR_LINESTYLE);
			nColCnt=aSwitchDataPointAttrList.Count();
			for(n=0;n<nColCnt;n++)
				aDataPointAttrList.GetObject(n)->ClearItem(XATTR_LINESTYLE);

		}
		if(!bOldIsStock && HasStockLines() || (!bOldIs3D && bNewIs3D) )
		{
			for(long n=0;n<nRowCnt;n++)
				aDataRowAttrList.GetObject(n)->Put(XLineStyleItem(XLINE_NONE));
			long nColCnt=aDataPointAttrList.Count();
			for(n=0;n<nColCnt;n++)
				aDataPointAttrList.GetObject(n)->ClearItem(XATTR_LINESTYLE);
			nColCnt=aSwitchDataPointAttrList.Count();
			for(n=0;n<nColCnt;n++)
				aDataPointAttrList.GetObject(n)->ClearItem(XATTR_LINESTYLE);
		}
		if(/*!bOldHadStockBars && */HasStockBars())//Hat Balken im Hintergrund (ab jetzt oder Typ 3 <-> 4, #65070#)
		{
			if(nRowCnt)
			{
				aDataRowAttrList.GetObject(0)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_Y));
				aDataRowAttrList.GetObject(0)->Put(XLineStyleItem(XLINE_SOLID));
			}
			for(long n=1;n<nRowCnt;n++)
				aDataRowAttrList.GetObject(n)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_SECONDARY_Y));
			pChartBAxis->ShowAxis(TRUE);
			pChartBAxis->ShowDescr(TRUE);
			SfxItemSet aSet(*pItemPool,SCHATTR_AXIS_AUTO_ORIGIN,SCHATTR_AXIS_AUTO_ORIGIN);
			aSet.Put(SfxBoolItem(SCHATTR_AXIS_AUTO_ORIGIN,1));
			pChartBAxis->SetAttributes(aSet);
		}

		if(bOldHadStockBars && !HasStockBars())//hat jetzt keine Balken mehr
		{
			for(long n=0;n<nRowCnt;n++)
				aDataRowAttrList.GetObject(n)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_Y));
			if(IsXYChart())
				aDataRowAttrList.GetObject(0)->Put(SfxInt32Item(SCHATTR_AXIS,CHART_AXIS_PRIMARY_X));
			pChartBAxis->ShowAxis(FALSE);
			pChartBAxis->ShowDescr(FALSE);
		}

		SetUseRelativePositions(FALSE);//Neu ausrichten! (18.5.98)#50274#

		Matrix4D aTmp;
		aSceneMatrix = aTmp;
		if(IsPieChart() && IsReal3D() )
		{
			aSceneMatrix.RotateX(-F_PI/3);
			if(pScene)
				pScene->NbcSetTransform(aSceneMatrix);
		}
		else if(pScene)
			pScene->NbcSetTransform(aSceneMatrix);


		if( IsReal3D()) //#56798# QuickFix 5.0-Final
		{
			bClearDepth=TRUE;
			long i,nORow=aDataRowAttrList.Count();
			for(i=0;i<nORow;i++)
			{
				aDataRowAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);
				if(eChartStyle == CHSTYLE_3D_STRIPE || eChartStyle==CHSTYLE_3D_PIE)
					aDataRowAttrList.GetObject(i)->Put(SfxBoolItem(SID_ATTR_3D_DOUBLE_SIDED,TRUE));
				else
					aDataRowAttrList.GetObject(i)->Put(SfxBoolItem(SID_ATTR_3D_DOUBLE_SIDED,FALSE));
			}
			nORow=aDataPointAttrList.Count();
			for(i=0;i<nORow;i++)
				aDataPointAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);
			nORow=aSwitchDataPointAttrList.Count();
			for(i=0;i<nORow;i++)
				aSwitchDataPointAttrList.GetObject(i)->ClearItem(SID_ATTR_3D_DEPTH);

			// switch off rounded edges for:
			// area charts
			UINT16 nPercentDiagonal = 5;

			if( eStyle == CHSTYLE_3D_AREA ||
				eStyle == CHSTYLE_3D_STACKEDAREA ||
				eStyle == CHSTYLE_3D_PERCENTAREA )
			{
				pDummyAttr->Put( SfxUInt16Item( SID_ATTR_3D_PERCENT_DIAGONAL, 0 ) );
			}
			else
			{
				pDummyAttr->Put( SfxUInt16Item( SID_ATTR_3D_PERCENT_DIAGONAL, 5 ) );
			}
			SfxUInt16Item aItem( SID_ATTR_3D_PERCENT_DIAGONAL,
								 (eStyle == CHSTYLE_3D_AREA ||
								  eStyle == CHSTYLE_3D_STACKEDAREA ||
								  eStyle == CHSTYLE_3D_PERCENTAREA ) ? 0 :
								 5 );

			for( i = 0; i < aDataRowAttrList.Count(); i++ )
			{
  				aDataRowAttrList.GetObject( i )->Put( aItem );
			}
		}

		SetUseRelativePositions(TRUE);// New arrangement (see SID_NEW_ARRANGEMENT)
		eOldChartStyle = eChartStyle;

		return TRUE;
	}
}

/*************************************************************************
|*
|*
\************************************************************************/

FASTBOOL ChartModel::IsReadOnly () const
{
	return FALSE;
}



