/*************************************************************************
 *
 *  $RCSfile: memchrt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:29:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STREAM_HXX
// enable stream operators >>/<< for UniString (8 Bit !)
#ifndef ENABLE_STRING_STREAM_OPERATORS
#define ENABLE_STRING_STREAM_OPERATORS
#endif
#include <tools/stream.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#endif

#include <float.h>
#include <math.h>
#include "schiocmp.hxx"
#include "memchrt.hxx"

#include "schresid.hxx"
#include "glob.hrc"

#define MIN(a,b) ( ((a)<(b))? (a) : (b) )
/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchMemChart::SchMemChart() :
	nTranslated(TRANS_NONE),
	nRefCount (0),
	mpColNameBuffer(NULL),
	mpRowNameBuffer(NULL),
	nRowCnt (0),
	nColCnt (0),
	eDataType(NUMBERFORMAT_NUMBER),
	pData (0),
	pColText (0),
	pRowText (0),
	myID (CHDATAID_MEMCHART_PLUS),
	mpNumFormatter(NULL),
	pRowNumFmtId(NULL),
	pColNumFmtId(NULL),
	pRowTable(NULL),
	pColTable(NULL),
	bReadOnly(FALSE),
	nLastSelInfoReturn(0)
{
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchMemChart::SchMemChart(ChartDataId nMyID) :
	nTranslated(TRANS_NONE),
	nRefCount (0),
	mpColNameBuffer(NULL),
	mpRowNameBuffer(NULL),
	nRowCnt (0),
	nColCnt (0),
	eDataType(NUMBERFORMAT_NUMBER),
	pData (0),
	pColText (0),
	pRowText (0),
	myID (nMyID),
	mpNumFormatter(NULL),
	pRowNumFmtId(NULL),
	pColNumFmtId(NULL),
	pRowTable(NULL),
	pColTable(NULL),
	bReadOnly(FALSE),
	nLastSelInfoReturn(0)
{
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchMemChart::SchMemChart(short nCols, short nRows) :
	nTranslated(TRANS_NONE),
	nRefCount (0),
	mpColNameBuffer(NULL),
	mpRowNameBuffer(NULL),
	eDataType(NUMBERFORMAT_NUMBER),
	pData (0),
	pColText (0),
	pRowText (0),
	myID (CHDATAID_MEMCHART_PLUS),
	mpNumFormatter(NULL),
	pRowNumFmtId(NULL),
	pColNumFmtId(NULL),
	pRowTable(NULL),
	pColTable(NULL),
	bReadOnly(FALSE),
	nLastSelInfoReturn(0)
{
	nRowCnt = nRows;
	nColCnt = nCols;
	pData   = new double[nColCnt * nRowCnt];

	pRowNumFmtId= new long [nRowCnt];
	pColNumFmtId= new long [nColCnt];
	InitNumFmt();

	pRowTable	= new long [nRowCnt];
	pColTable	= new long [nColCnt];
	ResetTranslation(pRowTable,nRowCnt);
	ResetTranslation(pColTable,nColCnt);

	if (pData)
	{
		double *pFill = pData;

		for (short i = 0; i < nColCnt; i++)
			for (short j = 0; j < nRowCnt; j++)
				*(pFill ++) = 0.0;
	}

	pColText = new String[nColCnt];
	pRowText = new String[nRowCnt];
}
/*************************************************************************
|*
|* Kopiere alles ausser den numerischen Daten (d.h. Texte!)
|*
\************************************************************************/
void SchMemChart::SetNonNumericData(const SchMemChart &rMemChart)
{
	aMainTitle  = rMemChart.aMainTitle;
	aSubTitle   = rMemChart.aSubTitle;
	aXAxisTitle = rMemChart.aXAxisTitle;
	aYAxisTitle = rMemChart.aYAxisTitle;
	aZAxisTitle = rMemChart.aZAxisTitle;
	eDataType   = rMemChart.eDataType;
	aSomeData1  = ((SchMemChart&) rMemChart).SomeData1 ();
	aSomeData2  = ((SchMemChart&) rMemChart).SomeData2 ();
	aSomeData3  = ((SchMemChart&) rMemChart).SomeData3 ();
	aSomeData4  = ((SchMemChart&) rMemChart).SomeData4 ();

	long nCols=MIN(nColCnt,rMemChart.nColCnt);
	long nRows=MIN(nRowCnt,rMemChart.nRowCnt);

	short i;
	for (i = 0; i < nCols; i++)
		pColText[i] = rMemChart.pColText[i];
	for (i = 0; i < nRows; i++)
		pRowText[i] = rMemChart.pRowText[i];
}
/*************************************************************************
|*
|* Kopier-Konstruktor
|*
\************************************************************************/

SchMemChart::SchMemChart(const SchMemChart& rMemChart) :
	nTranslated(TRANS_NONE),
	nRefCount (0),
	mpColNameBuffer(NULL),
	mpRowNameBuffer(NULL),
	myID (CHDATAID_MEMCHART_PLUS),
	mpNumFormatter(NULL),
	pRowNumFmtId(NULL),
	pColNumFmtId(NULL),
	pRowTable(NULL),
	pColTable(NULL),
	nLastSelInfoReturn(0)
{
	nColCnt     = rMemChart.nColCnt;
	nRowCnt     = rMemChart.nRowCnt;
	aMainTitle  = rMemChart.aMainTitle;
	aSubTitle   = rMemChart.aSubTitle;
	aXAxisTitle = rMemChart.aXAxisTitle;
	aYAxisTitle = rMemChart.aYAxisTitle;
	aZAxisTitle = rMemChart.aZAxisTitle;
	eDataType   = rMemChart.eDataType;
	aSomeData1  = ((SchMemChart&) rMemChart).SomeData1 ();
	aSomeData2  = ((SchMemChart&) rMemChart).SomeData2 ();
	aSomeData3  = ((SchMemChart&) rMemChart).SomeData3 ();
	aSomeData4  = ((SchMemChart&) rMemChart).SomeData4 ();
	pData       = new double[nColCnt * nRowCnt];

	pRowNumFmtId= new long [nRowCnt];
	pColNumFmtId= new long [nColCnt];
	pRowTable	= new long [nRowCnt];
	pColTable	= new long [nColCnt];

	nTranslated = rMemChart.nTranslated;
	long i;
	for(i=0;i<nColCnt;i++)
	{
		pColTable[i]	= rMemChart.pColTable[i];
		pColNumFmtId[i]	= rMemChart.pColNumFmtId[i];
	}
	for(i=0;i<nRowCnt;i++)
	{
		pRowTable[i]	= rMemChart.pRowTable[i];
		pRowNumFmtId[i]	= rMemChart.pRowNumFmtId[i];
	}
	mpNumFormatter=rMemChart.mpNumFormatter;

	if (pData)
	{
		double *pDest   = pData;
		double *pSource = rMemChart.pData;

		for (short i = 0; i < nColCnt; i++)
			for (short j = 0; j < nRowCnt; j++)
				*(pDest ++) = *(pSource ++);
	}

	pColText = new String[nColCnt];

	for (i = 0; i < nColCnt; i++)
		pColText[i] = rMemChart.pColText[i];

	pRowText = new String[nRowCnt];

	for (i = 0; i < nRowCnt; i++)
		pRowText[i] = rMemChart.pRowText[i];
	
	bReadOnly = rMemChart.bReadOnly;			// bm #69410#

	// copy address members
	maCategoriesRangeAddress = rMemChart.maCategoriesRangeAddress;
	maSeriesAddresses = rMemChart.maSeriesAddresses;
}

long SchMemChart::GetTableIndexRow(long nRow) const
{
	long nTmp=-1;
	if(nRow<nRowCnt && nRow>=0)
		for(long i=0;i<nRowCnt;i++)
			if(pRowTable[i]==nRow)
				nTmp=i;
	if(nTmp!=-1)
		nRow=nTmp;

	return nRow;
}
long SchMemChart::GetTableIndexCol(long nCol) const
{
	long nTmp=-1;
	if(nCol<nColCnt && nCol>=0)
		for(long i=0;i<nColCnt;i++)
			if(pColTable[i]==nCol)
				nTmp=i;
	if(nTmp!=-1)
		nCol=nTmp;

	return nCol;
}
long SchMemChart::SubmitSelection(const ChartSelectionInfo& aInfo)
{
	ChartSelectionInfo aNewInfo=aInfo;

	//aNewInfo der Translationstabelle anpassen
	if(nTranslated == TRANS_ROW)
		aNewInfo.nRow=GetTableIndexRow(aInfo.nRow);
	else if(nTranslated == TRANS_COL)
		aNewInfo.nCol=GetTableIndexCol(aInfo.nCol);

	if(aNewInfo == aSelectionInfo || aNewInfo.nSelection==0)
		return nLastSelInfoReturn; //reduzieren doppelter Selektionen bzw. speziell der Deselektion!
	aSelectionInfo = aNewInfo;
	if(aAppLink.IsSet())
	{
		return nLastSelInfoReturn=aAppLink.Call(&aSelectionInfo);
	}
	else
	{
		return nLastSelInfoReturn=0;
	}
}
BOOL SchMemChart::TransCol(long nCol,BOOL bUp)
{
	if(nTranslated==TRANS_ROW)
		return FALSE;

	if(bUp)
	{
		if(nCol+1 >= nColCnt)
			return FALSE;

		long tmp=pColTable[nCol];
		pColTable[nCol]=pColTable[nCol+1];
		pColTable[nCol+1]=tmp;
	}
	else
	{
		if(nCol-1 <= 0)
			return FALSE;

		long tmp=pColTable[nCol];
		pColTable[nCol]=pColTable[nCol-1];
		pColTable[nCol-1]=tmp;
	}
	nTranslated=TRANS_COL;
	return TRUE;
}
BOOL SchMemChart::TransRow(long nRow,BOOL bUp)
{
	if(nTranslated==TRANS_COL)
		return FALSE;

	if(bUp)
	{
		if(nRow+1 >= nRowCnt)
			return FALSE;

		long tmp=pRowTable[nRow];
		pRowTable[nRow]=pRowTable[nRow+1];
		pRowTable[nRow+1]=tmp;
	}
	else
	{
		if(nRow-1 <= 0)
			return FALSE;

		long tmp=pRowTable[nRow];
		pRowTable[nRow]=pRowTable[nRow-1];
		pRowTable[nRow-1]=tmp;
	}
	nTranslated=TRANS_ROW;
	return TRUE;
}

//berprft, ob die Umordnung/Translation OK ist, Fehlerfall, wenn :
// a) Spaltenumordnung aber Reihen vertauscht (FALSE,TRANS_ERROR)
// b) Reihenumordnung aber Spalten vertauscht (FALSE,TRANS_ERROR)
// c) keine Umordnung, Reihen oder Spalten vertauscht (FALSE,TRANS_ERROR)
// d) Umordnungsflag gesetzt (auf TRANS_ROW,TRANS_COL oder TRANS_ERROR) aber
//		keine Umordnung (mehr) vorhanden (FALSE,TRANS_NONE)
// sonst wird TRUE zurckgegeben

BOOL SchMemChart::VerifyTranslation()
{
	//Fehler ?
	if(nTranslated!=TRANS_COL)
	{
		for(long nCol=0;nCol<nColCnt;nCol++)
		{
			if(pColTable[nCol]!=nCol)
			{
				//nTranslated=TRANS_ERROR;
				if(nTranslated==TRANS_NONE)
				{
					DBG_ERROR("SchMemChart::Correcting Translationmode");
					nTranslated=TRANS_COL;
				}
				else
				{
					DBG_ERROR("fatal error in SchMemChart-translation");
					return FALSE;
				}
			}
		}
	}
	if(nTranslated!=TRANS_ROW)
	{
		for(long nRow=0;nRow<nRowCnt;nRow++)
		{
			if(pRowTable[nRow]!=nRow)
			{
				//nTranslated=TRANS_ERROR;
				if(nTranslated==TRANS_NONE)
				{
					DBG_ERROR("SchMemChart::Correcting Translationmode");
					nTranslated=TRANS_ROW;
				}
				else
				{
					DBG_ERROR("fatal error in SchMemChart-translation");
					return FALSE;
				}
			}
		}
	}

	// Sortierung besteht noch ?
	if(nTranslated==TRANS_ROW)
	{
		for(long nRow=0;nRow<nRowCnt;nRow++)
		{
			if(pRowTable[nRow]!=nRow)
				return TRUE;
		}
	}
	if(nTranslated==TRANS_COL)
	{
		for(long nCol=0;nCol<nColCnt;nCol++)
		{
			if(pColTable[nCol]!=nCol)
				return TRUE;
		}
	}

	if(nTranslated!=TRANS_NONE)
	{
		nTranslated=TRANS_NONE;
		return FALSE;
	}
	return TRUE;

}

double SchMemChart::GetTransData(long nCol,long nRow)
{
	DBG_ASSERT(VerifyTranslation(), "Translation table corrupted in MemChart");
	return GetData( (short)pColTable[nCol], (short)pRowTable[nRow]);
}
double SchMemChart::GetTransDataInPercent(long nCol, long nRow, BOOL bRowData) const
{
	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(), "Translation table corrupted in MemChart");
	return GetDataInPercent( (short)pColTable[nCol], (short)pRowTable[nRow], bRowData);
}
const String& SchMemChart::GetTransColText(long nCol) const
{
	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(), "Translation table corrupted in MemChart");
	return GetColText( (short)pColTable[nCol] );
}
const String& SchMemChart::GetTransRowText(long nRow) const
{														  
	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(), "Translation table corrupted in MemChart");
	return GetRowText( (short)pRowTable[nRow] );
}
long SchMemChart::GetTransNumFormatIdRow(const long nRow) const
{
	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(), "Translation table corrupted in MemChart");
	return ( nTranslated == TRANS_ROW )? pRowNumFmtId[ pRowTable[ nRow ]]: pRowNumFmtId[ nRow ];
}
long SchMemChart::GetTransNumFormatIdCol(const long nCol) const
{
	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(), "Translation table corrupted in MemChart");
	return ( nTranslated == TRANS_COL ) ? pColNumFmtId[ pColTable[ nCol ]]: pColNumFmtId[ nCol ];
}


BOOL SchMemChart::SwapRowTranslation(long n1,long n2)
{
	if(nTranslated==TRANS_COL)
	{
		DBG_ERROR("Chart: Invalid Reorganisation of Chart attempted");
		return FALSE;
	}
	if(!(n1>=0 && n2>=0 && n1<nRowCnt && n2<nRowCnt))
	{
		DBG_ERROR("Chart: Invalid Reorganisation of Chart attempted, index error");
		return FALSE;
	}

	long nTmp=pRowTable[n1];
	pRowTable[n1]=pRowTable[n2];
	pRowTable[n2]=nTmp;

	nTranslated=TRANS_ROW;

	VerifyTranslation(); //evtl. wurde mit dieser Aktion die Umordnung aufgehoben!
	return TRUE;
}
BOOL SchMemChart::SwapColTranslation(long n1,long n2)
{
	if(!(n1>=0 && n2>=0 && n1<nColCnt && n2<nColCnt))
	{
		DBG_ERROR("Chart: Invalid Reorganisation of Chart attempted, index error");
		return FALSE;
	}

	if(nTranslated==TRANS_ROW)
	{
		DBG_ERROR("Chart: Invalid Reorganisation of Chart attempted");
		return FALSE;
	}

	long nTmp=pColTable[n1];
	pColTable[n1]=pColTable[n2];
	pColTable[n2]=nTmp;

	nTranslated=TRANS_COL;

	DBG_ASSERT(((SchMemChart*)this)->VerifyTranslation(),"Translation table corrupted in MemChart");
	return TRUE;
}
/*************************************************************************
|*
|* Wie GetData, aber in Prozentwerten
|* Optimierungsvorschlag: fTotal fuer jede Zeile und Spalte buffern,
|*                        dazu muessen alle Schnittstellen bekannt sein,
|*                        die Daten am MemChart veraendern koennen.
|*
\************************************************************************/
double SchMemChart::GetDataInPercent(const short nCol , const short nRow, const BOOL bRowData) const
{
   double fTotal=0.0,fTemp,fData;
   short i;

   fData = GetData(nCol,nRow);

   if(bRowData)
   {
	   for(i=0;i<nRowCnt;i++)
	   {
		   fTemp=GetData(nCol,i);

		   if(fTemp != DBL_MIN)   fTotal += fabs(fTemp);
	   }
   }
   else
   {
	   for(i=0;i<nColCnt;i++)
	   {
		   fTemp=GetData(i,nRow);

		   if(fTemp != DBL_MIN)   fTotal += fabs(fTemp);
	   }

   }
   return fTotal ? ( (fabs(fData) / fTotal) * 100.0 ) : DBL_MIN;
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchMemChart::~SchMemChart()
{
	__DELETE(nRowCnt) pRowText;
	__DELETE(nColCnt) pColText;
	delete[] pData;

	if(pRowNumFmtId)
		delete [] pRowNumFmtId;
	if(pColNumFmtId)
		delete [] pColNumFmtId;
	if(pRowTable)
		delete [] pRowTable;
	if(pColTable)
		delete [] pColTable;
	delete[] mpRowNameBuffer;
	delete[] mpColNameBuffer;
}

/*************************************************************************
|*
|* Inserter fuer SvStream zum Speichern
|*
\************************************************************************/

SvStream& operator << (SvStream& rOut, const SchMemChart& rMemChart)
{
	CharSet aSysCharSet = ::GetStoreCharSet( gsl_getSystemTextEncoding() );		// #71375#
	rOut.SetStreamCharSet( aSysCharSet );

	//Version 1: Abspeichern der pRow,pColTable (long-array)
	SchIOCompat aIO(rOut, STREAM_WRITE, 2);

	rOut << (INT16)rMemChart.nColCnt;
	rOut << (INT16)rMemChart.nRowCnt;

	double *pOut = rMemChart.pData;

	short i;
	for (i = 0; i < rMemChart.nColCnt; i++)
		for (short j = 0; j < rMemChart.nRowCnt; j++)
			rOut << *(pOut ++);

	rOut << (INT16)aSysCharSet;
	rOut << rMemChart.aMainTitle;
	rOut << rMemChart.aSubTitle;
	rOut << rMemChart.aXAxisTitle;
	rOut << rMemChart.aYAxisTitle;
	rOut << rMemChart.aZAxisTitle;

	for (i = 0; i < rMemChart.nColCnt; i++)
		rOut << rMemChart.pColText[ i ];

	for (i = 0; i < rMemChart.nRowCnt; i++)
		rOut << rMemChart.pRowText[ i ];

	rOut << (INT16)rMemChart.eDataType;

	//IOVersion = 1
	long nIndex;
	for (nIndex = 0; nIndex < rMemChart.nColCnt; nIndex++)
		rOut << rMemChart.pColTable[nIndex];

	for (nIndex = 0; nIndex < rMemChart.nRowCnt; nIndex++)
		rOut << rMemChart.pRowTable[nIndex];

	//IOVersion = 2
	rOut << rMemChart.nTranslated;


	return rOut;
}

/*************************************************************************
|*
|* Extractor fuer SvStream zum Laden
|*
\************************************************************************/

SvStream& operator >> (SvStream& rIn, SchMemChart& rMemChart)
{
	INT16 nInt16;

	SchIOCompat aIO(rIn, STREAM_READ);

	rIn >> nInt16; rMemChart.nColCnt = (short)nInt16;
	rIn >> nInt16; rMemChart.nRowCnt = (short)nInt16;

	rMemChart.pData = new double[rMemChart.nColCnt * rMemChart.nRowCnt];

	double *pIn = rMemChart.pData;

	short i;
	for (i = 0; i < rMemChart.nColCnt; i++)
		for (short j = 0; j < rMemChart.nRowCnt; j++)
			rIn >> *(pIn ++);

	INT16 nCharSet;
	rIn >> nCharSet;

	CharSet aCharSet = (CharSet)nCharSet;
	rIn.SetStreamCharSet( aCharSet );

	rIn >> rMemChart.aMainTitle;
	rIn >> rMemChart.aSubTitle;
	rIn >> rMemChart.aXAxisTitle;
	rIn >> rMemChart.aYAxisTitle;
	rIn >> rMemChart.aZAxisTitle;

	rMemChart.pColText = new String[rMemChart.nColCnt];

	for (i = 0; i < rMemChart.nColCnt; i++)
	{
		rIn >> rMemChart.pColText[ i ];
	}

	rMemChart.pRowText = new String[rMemChart.nRowCnt];

	for (i = 0; i < rMemChart.nRowCnt; i++)
	{
		rIn >> rMemChart.pRowText[ i ];
	}

	rIn >> nInt16; rMemChart.eDataType = (short)nInt16;

	rMemChart.pRowNumFmtId	= new long [rMemChart.nRowCnt];
	rMemChart.pColNumFmtId	= new long [rMemChart.nColCnt];
	rMemChart.pRowTable		= new long [rMemChart.nRowCnt];
	rMemChart.pColTable		= new long [rMemChart.nColCnt];

	if(aIO.GetVersion()>=1)
	{
		long i;
		for (i = 0; i < rMemChart.nColCnt; i++)
			rIn >> rMemChart.pColTable[i];

		for (i = 0; i < rMemChart.nRowCnt; i++)
			rIn >> rMemChart.pRowTable[i];

		if(aIO.GetVersion()>=2)
			rIn >> rMemChart.nTranslated;

	}
	else
	{
		rMemChart.ResetTranslation(rMemChart.pRowTable,rMemChart.nRowCnt);
		rMemChart.ResetTranslation(rMemChart.pColTable,rMemChart.nColCnt);
	}

	rMemChart.InitNumFmt(); //ab IOVersion 2 (ToDo:)

	return rIn;
}

/*************************************************************************
|*
|* Spalten einfuegen
|*
\************************************************************************/

void SchMemChart::InsertCols(short nAtCol, short nCount)
{
	double* pOldData = pData;

	short nNewColCnt = nColCnt + nCount;

	pData			= new double[nNewColCnt * nRowCnt];

	short i, j, nOld, nMax;

	for (i = 0, nOld = 0; i < nAtCol; i++, nOld++)
	{
		for (j = 0; j < nRowCnt; j++)
		{
			pData[i * nRowCnt + j] = pOldData[nOld * nRowCnt + j];
		}
	}

	nMax = nAtCol + nCount;

	for (; i < nMax; i++)
	{
		for (j = 0; j < nRowCnt; j++)
		{
			pData[i * nRowCnt + j] = 0.0;
		}
	}

	for (; i < nNewColCnt; i++, nOld++)
	{
		for (j = 0; j < nRowCnt; j++)
		{
			pData[i * nRowCnt + j] = pOldData[nOld * nRowCnt + j];
		}
	}
	delete pOldData;

	String *pOldColText     = pColText;
	long   *pOldColNumFmtId = pColNumFmtId;
	long   *pOldColTable    = pColTable;

	pColNumFmtId	= new long  [nNewColCnt];
	pColTable		= new long  [nNewColCnt];
	pColText		= new String[nNewColCnt];

	long nC=nNewColCnt;
	while(nC--)
	{
		pColTable[nC]    = -1; //init
		pColNumFmtId[nC] = -1;
	}

	for (i = 0, nOld = 0;; i++, nOld++)
	{
		if (i == nAtCol)
			i += nCount;
		if (i >= nNewColCnt)
			break;

		pColText[i]     = pOldColText[nOld];
		pColTable[i]    = pOldColTable[nOld];
		pColNumFmtId[i] = pOldColNumFmtId[nOld];
	}

	__DELETE(nColCnt) pOldColNumFmtId;
	__DELETE(nColCnt) pOldColTable;
	__DELETE(nColCnt) pOldColText;

	nColCnt = nNewColCnt;

	UpdateTranslation(pColTable,nColCnt);
}

/*************************************************************************
|*
|* Spalten loeschen
|*
\************************************************************************/

void SchMemChart::RemoveCols(short nAtCol, short nCount)
{
	DBG_ASSERT( nAtCol < nColCnt, "column index overflow");

	if (nAtCol + nCount > nColCnt)
		nCount = nColCnt - nAtCol;

	short nNewColCnt = nColCnt - nCount;

	double* pOldData = pData;
	pData = new double[nNewColCnt * nRowCnt];

	String* pOldColText		= pColText;
	long*   pOldColNumFmtId	= pColNumFmtId;
	long*   pOldColTable	= pColTable;

	pColText		= new String[nNewColCnt];
	pColNumFmtId	= new long  [nNewColCnt];
	pColTable		= new long  [nNewColCnt];


	short i, j, nOld;

	for (i = 0, nOld = 0;; i++, nOld++)
	{
		if (nOld == nAtCol)
			nOld += nCount;
		if (nOld >= nColCnt)
			break;

		for (j = 0; j < nRowCnt; j++)
			pData[i * nRowCnt + j] = pOldData[nOld * nRowCnt + j];

		pColText[i]		= pOldColText[nOld];
		pColTable[i]    = pOldColTable[nOld];
		pColNumFmtId[i] = pOldColNumFmtId[nOld];
	}

	delete pOldData;
	__DELETE(nColCnt) pOldColText;
	__DELETE(nColCnt) pOldColTable;
	__DELETE(nColCnt) pOldColNumFmtId;

	nColCnt = nNewColCnt;

	UpdateTranslation(pColTable,nColCnt);
}

/*************************************************************************
|*
|* Zeilen einfuegen
|*
\************************************************************************/

void SchMemChart::InsertRows(short nAtRow, short nCount)
{
	double* pOldData = pData;

	short nNewRowCnt = nRowCnt + nCount;

	pData = new double[nColCnt * nNewRowCnt];

	short i, j, nOld, nMax, nGapEnd;

	for (i = 0; i < nColCnt; i++)
	{
		for (j = 0, nOld= 0; j < nAtRow; j++, nOld++)
		{
			pData[i * nNewRowCnt + j] = pOldData[i * nRowCnt + nOld];
		}
	}


	nMax = nAtRow + nCount;

	for (i = 0; i < nColCnt; i++)
	{
		for (j = nAtRow; j < nMax; j++)
		{
			pData[i * nNewRowCnt + j] = 0.0;
		}
	}

	nGapEnd = nMax;

	for (i = 0; i < nColCnt; i++)
	{
		for (j = nGapEnd, nOld = nAtRow; j < nNewRowCnt; j++, nOld++)
		{
			pData[i * nNewRowCnt + j] = pOldData[i * nRowCnt + nOld];
		}
	}
	delete pOldData;



	String *pOldRowText     =pRowText;
	long   *pOldRowNumFmtId =pRowNumFmtId;
	long   *pOldRowTable    =pRowTable;

	pRowNumFmtId	= new long  [nNewRowCnt];
	pRowTable		= new long  [nNewRowCnt];
	pRowText        = new String[nNewRowCnt];

	long nC=nNewRowCnt;
	while(nC--) //init
	{
		pRowNumFmtId[nC]	= -1;
		pRowTable[nC]	= -1;
	}


	for (i = 0, nOld = 0;; i++, nOld++)
	{
		if (i == nAtRow)
			i += nCount;
		if (i >= nNewRowCnt)
			break;

		pRowNumFmtId[i]	= pOldRowNumFmtId[nOld];
		pRowTable[i]	= pOldRowTable[nOld];
		pRowText[i]     = pOldRowText[nOld];
	}

	__DELETE(nRowCnt) pOldRowText;
	__DELETE(nRowCnt) pOldRowTable;
	__DELETE(nRowCnt) pOldRowNumFmtId;

	nRowCnt = nNewRowCnt;

	UpdateTranslation(pRowTable,nRowCnt);
}

/*************************************************************************
|*
|* Zeilen loeschen
|*
\************************************************************************/

void SchMemChart::RemoveRows(short nAtRow, short nCount)
{
	DBG_ASSERT( nAtRow < nRowCnt, "row  index overflow" );

	if (nAtRow + nCount > nRowCnt)
		nCount = nRowCnt - nAtRow;

	short nNewRowCnt = nRowCnt - nCount;

	double* pOldData = pData;
	pData = new double[nColCnt * nNewRowCnt];

	short i, j, nOld;

	for (i = 0; i < nColCnt; i++)
		for (j = 0, nOld = 0;; j++, nOld++)
		{
			if (nOld == nAtRow)
				nOld += nCount;
			if (nOld >= nRowCnt)
				break;

			pData[i * nNewRowCnt + j] = pOldData[i * nRowCnt + nOld];
		}


	delete pOldData;

	String* pOldRowText		= pRowText;
	long*   pOldRowNumFmtId	= pRowNumFmtId;
	long*   pOldRowTable	= pRowTable;

	pRowText		= new String[nNewRowCnt];
	pRowNumFmtId	= new long  [nNewRowCnt];
	pRowTable		= new long  [nNewRowCnt];


	for (i = 0, nOld = 0;; i++, nOld++)
	{
		if (nOld == nAtRow)
			nOld += nCount;
		if (nOld >= nRowCnt)
			break;

		pRowText[i] = pOldRowText[nOld];
		pRowTable[i] = pOldRowTable[nOld];
		pRowNumFmtId[i] = pOldRowNumFmtId[nOld];
	}

	__DELETE(nRowCnt) pOldRowText;
	__DELETE(nRowCnt) pOldRowTable;
	__DELETE(nRowCnt) pOldRowNumFmtId;

	nRowCnt = nNewRowCnt;

	UpdateTranslation(pRowTable,nRowCnt);
}

/*************************************************************************
|*
|* Spalten tauschen
|*
\************************************************************************/

void SchMemChart::SwapCols(int nAtCol1, int nAtCol2)
{
	// Wenn hier Aenderungen Stattfinden, mu auch im Logbuch
	// angepasst werden
	if (nAtCol1 > nAtCol2)
	{
		long nTemp = nAtCol1;

		nAtCol1 = nAtCol2;
		nAtCol2 = nTemp;
	}

	if (nAtCol1 >= nColCnt - 1) nAtCol1 = nColCnt - 2;
	if (nAtCol2 >= nColCnt) nAtCol2 = nColCnt - 1;

	nAtCol1 = Max(nAtCol1, 0);
	nAtCol2 = Max(nAtCol2, 0);
	//Insbesondere bis hier,, da dieses Handling autokorrigierend ist

	double *pSrc  = pData + nAtCol1 * nRowCnt;
	double *pDest = pData + nAtCol2 * nRowCnt;

	for (long nSwaps = 0;
			  nSwaps < nRowCnt;
			  nSwaps ++)
	{
		double fSwap = *pSrc;

		*pSrc  = *pDest;
		*pDest = fSwap;

		pSrc ++;
		pDest ++;
	}

	String aTemp = pColText [nAtCol1];
	pColText [nAtCol1] = pColText [nAtCol2];
	pColText [nAtCol2] = aTemp;

	long nTmp = pColTable [nAtCol1];
	pColTable [nAtCol1] = pColTable [nAtCol2];
	pColTable [nAtCol2] = nTmp;

	nTmp = pColNumFmtId[nAtCol1];
	pColNumFmtId [nAtCol1] = pColNumFmtId [nAtCol2];
	pColNumFmtId [nAtCol2] = nTmp;

	ResetTranslation(pColTable,nColCnt); //ToDo:???
}

/*************************************************************************
|*
|* Zeilen tauschen
|*
\************************************************************************/

void SchMemChart::SwapRows(int nAtRow1,int nAtRow2)
{

	// Wenn hier Aenderungen Stattfinden, mu auch im Logbuch
	// angepasst werden
	if (nAtRow1 > nAtRow2)
	{
		long nTemp = nAtRow1;

		nAtRow1 = nAtRow2;
		nAtRow2 = nTemp;
	}

	if (nAtRow1 >= nRowCnt - 1) nAtRow1 = nRowCnt - 2;
	if (nAtRow2 >= nRowCnt) nAtRow2 = nRowCnt - 1;

	nAtRow1 = Max(nAtRow1, 0);
	nAtRow2 = Max(nAtRow2, 0);
	//Insbesondere bis hier,, da dieses Handling autokorrigierend ist

	double *pSrc  = pData + nAtRow1;
	double *pDest = pData + nAtRow2;

	for (long nSwaps = 0;
			  nSwaps < nColCnt;
			  nSwaps ++)
	{
		double fSwap = *pSrc;

		*pSrc  = *pDest;
		*pDest = fSwap;

		pSrc  += nRowCnt;
		pDest += nRowCnt;
	}

	String aTemp = pRowText [nAtRow1];
	pRowText [nAtRow1] = pRowText [nAtRow2];
	pRowText [nAtRow2] = aTemp;

	long nTmp = pRowTable [nAtRow1];
	pRowTable [nAtRow1] = pRowTable [nAtRow2];
	pRowTable [nAtRow2] = nTmp;

	nTmp = pRowNumFmtId[nAtRow1];
	pRowNumFmtId [nAtRow1] = pRowNumFmtId [nAtRow2];
	pRowNumFmtId [nAtRow2] = nTmp;

	ResetTranslation(pRowTable,nRowCnt);//ToDo:???
}

/*************************************************************************
|*
|* QuickSort ueber Spalten
|*
\************************************************************************/

void SchMemChart::QuickSortTableCols (long l,long r,long nRow)
{
	if (r > l)
	{
		double v = *(pData + r * nRowCnt + nRow);
		long   i = l - 1;
		long   j = r;

		while (TRUE)
		{
			while (*(pData + (++ i) * nRowCnt + nRow) < v)
				;
			while (*(pData + (-- j) * nRowCnt + nRow) > v)
				;

			if (i >= j) break;
			else SwapCols (i, j);
		}

		if (i != r) SwapCols (i, r);
		QuickSortTableCols (l, i - 1, nRow);
		QuickSortTableCols (i + 1, r, nRow);
	}
}

/*************************************************************************
|*
|* QuickSort ueber Zeilen
|*
\************************************************************************/

void SchMemChart::QuickSortTableRows (long l,long r,long nCol)
{
	if (r > l)
	{
		double v = *(pData + r + nCol * nRowCnt);
		long   i = l - 1;
		long   j = r;

		while (TRUE)
		{
			while (*(pData + (++ i) + nCol * nRowCnt) < v)
				;
			while (*(pData + (-- j) + nCol * nRowCnt) > v)
				;

			if (i >= j) break;
			else SwapRows (i, j);
		}

		if (i != r) SwapRows (i, r);
		QuickSortTableRows (l, i - 1, nCol);
		QuickSortTableRows (i + 1, r, nCol);
	}
}

void SchMemChart::ResetTranslation(long *pTable,long nCnt)
{
	long i;
	if(pTable)
		for(i=0;i<nCnt;i++)
			pTable[i]=i;

	if(pTable==pRowTable && nTranslated==TRANS_ROW)
		nTranslated=TRANS_NONE;
	if(pTable==pColTable && nTranslated==TRANS_COL)
		nTranslated=TRANS_NONE;
}

void SchMemChart::InitNumFmt()
{
	long i;
	for(i=0;i<nColCnt;i++)
		pColNumFmtId[i]=-1; //uninitialised!

	for(i=0;i<nRowCnt;i++)
		pRowNumFmtId[i]=-1;
}

void SchMemChart::UpdateTranslation(long *pTable,long nCnt)
{
	if( (pTable==pRowTable && nTranslated==TRANS_ROW)
	  ||(pTable==pColTable && nTranslated==TRANS_COL))
	{
		long i,nMax=0;
		for(i=0;i<nCnt;i++)
			nMax=Max(nMax,pTable[i]);

		if(nMax>=nCnt)//something added
		{
			long nStart=-1,nEnd=-1;
			for(i=0;i<nCnt;i++)
			{
				if(pTable[i]==-1)//markierung gefunden
				{
					if(nStart!=-1)
						nEnd=i;
					else
						nStart=i;
				}
			}


			long nDiff=nEnd-nStart;//soviele sind neu

			DBG_ASSERT( (nDiff>0) && ((nEnd-nStart) == (nCnt-nMax)),"MemChart::Something went wrong!");

			if( (nDiff<=0) || ((nEnd-nStart)!=(nCnt-nMax)))
				return;

			long nNew = nStart;

			for(i=0;i<nCnt;i++)
			{
				if(pTable[i]>nStart)
				{
					pTable[i]+=nDiff;   //nach hinten verschieben
				}
				else if (pTable[i]==-1)
				{
					pTable[i]=nNew;     //"einfuegen"
					nNew++;
				}
			}
		}
		else //something removed
		{
			ResetTranslation(pTable,nCnt); //keine schoene Loesung....(ToDo:), Aufwand recht hoch...
		}
	}
	else
	{
		ResetTranslation(pTable,nCnt); //Normale Reihenfolge, da nicht die Sortierte Tabelll geupdated wird
	}
}

/*************************************************************************
|*
|* QuickSort ueber Spalten
|*
\************************************************************************/

void SchMemChart::QuickSortCols(long l,long r,long nRow)
{
	if (r > l)
	{
		double v = *(pData + r * nRowCnt + nRow);
		long   i = l - 1;
		long   j = r;

		while (TRUE)
		{
			while (*(pData + (++ i) * nRowCnt + nRow) < v)
				;
			while (*(pData + (-- j) * nRowCnt + nRow) > v)
				;

			if (i >= j) break;
			else
			{
				double temp = *(pData + i * nRowCnt + nRow);
				*(pData + i * nRowCnt + nRow) = *(pData + j * nRowCnt + nRow);
				*(pData + j * nRowCnt + nRow) = temp;
			}
		}

		if (i != r)
		{
			double temp = *(pData + r * nRowCnt + nRow);
			*(pData + r * nRowCnt + nRow) = *(pData + i * nRowCnt + nRow);
			*(pData + i * nRowCnt + nRow) = temp;
		}

		QuickSortCols (l, i - 1, nRow);
		QuickSortCols (i + 1, r, nRow);
	}
}

/*************************************************************************
|*
|* QuickSort ueber Zeilen
|*
\************************************************************************/

void SchMemChart::QuickSortRows (long l,
								 long r,
								 long nCol)
{
	if (r > l)
	{
		double v = *(pData + r + nCol * nRowCnt);
		long   i = l - 1;
		long   j = r;

		while (TRUE)
		{
			while (*(pData + (++ i) + nCol * nRowCnt) < v)
				;
			while (*(pData + (-- j) + nCol * nRowCnt) > v)
				;

			if (i >= j) break;
			else
			{
				double temp = *(pData + i + nCol * nRowCnt);
				*(pData + i + nCol * nRowCnt) = *(pData + j + nCol * nRowCnt);
				*(pData + j + nCol * nRowCnt) = temp;
			}
		}

		if (i != r)
		{
			double temp = *(pData + r + nCol * nRowCnt);
			*(pData + r + nCol * nRowCnt) = *(pData + i + nCol * nRowCnt);
			*(pData + i + nCol * nRowCnt) = temp;
		}

		QuickSortRows (l, i - 1, nCol);
		QuickSortRows (i + 1, r, nCol);
	}
}

String SchMemChart::GetDefaultColumnText( sal_Int32 nCol ) const
{
	if( !mpColNameBuffer )
	{
		// initialize resource string
		mpColNameBuffer = new String[ 2 ];
		DBG_ASSERT( mpColNameBuffer, "couldn't create two strings!" );
		String aResStr( SchResId( STR_COLUMN ));
		xub_StrLen nPos = aResStr.SearchAscii( "$(N)" );
		if( nPos != STRING_NOTFOUND )
		{
			mpColNameBuffer[ 0 ] = String( aResStr, 0, nPos );
			mpColNameBuffer[ 1 ] = String( aResStr, nPos + sizeof( "$(N)" ) - 1, STRING_LEN );
		}
		else
			mpColNameBuffer[ 0 ] = aResStr;
	}

	if( mpColNameBuffer )
	{
		String aResult( mpColNameBuffer[ 0 ] );
		aResult.Append( String::CreateFromInt32( nCol + 1 ));
		aResult.Append( mpColNameBuffer[ 1 ] );
		return aResult;
	}
	else
		return String();
}

String SchMemChart::GetDefaultRowText( sal_Int32 nRow ) const
{
	if( !mpRowNameBuffer )
	{
		// initialize resource string
		mpRowNameBuffer = new String[ 2 ];
		DBG_ASSERT( mpRowNameBuffer, "couldn't create two strings!" );
		String aResStr( SchResId( STR_ROW ));
		xub_StrLen nPos = aResStr.SearchAscii( "$(N)" );
		if( nPos != STRING_NOTFOUND )
		{
			mpRowNameBuffer[ 0 ] = String( aResStr, 0, nPos );
			mpRowNameBuffer[ 1 ] = String( aResStr, nPos + sizeof( "$(N)" ) - 1, STRING_LEN );
		}
		else
			mpRowNameBuffer[ 0 ] = aResStr;
	}

	if( mpRowNameBuffer )
	{
		String aResult( mpRowNameBuffer[ 0 ] );
		aResult.Append( String::CreateFromInt32( nRow + 1 ));
		aResult.Append( mpRowNameBuffer[ 1 ] );
		return aResult;
	}
	else
		return String();
}



