/*************************************************************************
 *
 *  $RCSfile: app.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop
#include <svx/sidll.hxx>
#ifndef _EDITDLL_HXX //autogen
#include <svx/editdll.hxx>
#endif
#include <svx/dialdll.hxx>
#ifndef _SFXNEW_HXX //autogen
#include <sfx2/new.hxx>
#endif
#ifndef _SVDETC_HXX //autogen
#include <svx/svdetc.hxx>
#endif
#ifdef UNX
#include <svx/sidll.hxx>
#endif

#include "docshell.hxx"
#include "app.hrc"
#include "strings.hrc"
#include "app.hxx"



/*************************************************************************
|*
|* Anlegen des Applikationsobjekts sowie anderer globaler Objekte
|*
\************************************************************************/

SchApp aSchApp;
#ifdef __MWERKS__
	Application* pApp = &aSchApp;
#endif

String aEmptyStr;


//==================================================================

#include "schslots.hxx"
#include "glob.hrc"


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchApp::SchApp() :
	SfxApplication("StarChart")
{
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchApp::~SchApp()
{
}

/*************************************************************************
|*
|* Originalkommentar SFX:
|* This virtual function becomes called from the SFx to initialize the
|* application. It is called from Application::Main(), though you can
|* create StarView objects. The Application Window does exist, but
|* isn't visible. No controller does exist and the configuration isn't
|* loaded.
|*
\************************************************************************/

void __EXPORT SchApp::Init()
{
	Font aSwissFont = System::GetStandardFont(STDFONT_SWISS);

	SdrEngineDefaults::SetFontName(aSwissFont.GetName());
	SdrEngineDefaults::SetFontFamily(aSwissFont.GetFamily());
	SdrEngineDefaults::SetFontColor(COL_BLACK);

//    SfxApplication::RegisterInterface();
	SchDLL::LibInit();

	// Applikationsfunktionen aktivieren
	IntroSlide();
	pSvxErrorHandler = new SvxErrorHandler();
}

/*************************************************************************
|*
|* Originalkommentar SFX:
|* This virtual function becomes called from the SFx to deinitialize
|* the appication. It is called from Application::Main() after
|* Application::Execute(). The Application Window does exist, but
|* isn't visible. All Controllers, Documents and Views are destroyed
|* and the configuration is already stored.
|*
\************************************************************************/

void __EXPORT SchApp::Exit()
{
	DeleteGlobalOutliner();
	delete pSvxErrorHandler;
}

/*************************************************************************
|*
|* Methode wird nach Init() gerufen
|*
\************************************************************************/

void __EXPORT SchApp::OpenClients()
{
	SFX_DISPATCHER().Execute(SID_START_APP, SFX_CALLMODE_SYNCHRON);
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

SfxNewFileDialog* __EXPORT SchApp::CreateNewDialog()
{
	return new SfxNewFileDialog(Application::GetAppWindow(),		// #67730#
								SFXWB_PREVIEW | SFXWB_DOCINFO);
}

/*************************************************************************
|*
|* Main
|*
\************************************************************************/

void __EXPORT SchApp::Main()
{
	SetAppName("schart3");          // Nicht uebersetzen!

	// Ressource-Manager erzeugen
	ResMgr* pResMgr = SFX_APP()->CreateResManager("sch");
	Resource::SetResManager(pResMgr);

	SvxDialogDll	aSvxDll;
	SchDLL			aSchDll;
	SiDLL           aSiDLL;
	EditDLL			aEditDLL;

	SfxApplication::Main();

	Resource::SetResManager(NULL);
	delete pResMgr;

	SchDLL::LibExit();
}



