/*************************************************************************
 *
 *  $RCSfile: appopt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// header for SID_SCH_TP_DEFCOLORS
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
// header for SFX_INIMANAGER
#ifndef _SFX_INIMGR_HXX
#include <sfx2/inimgr.hxx>
#endif
// header for SFX_APP
#ifndef _SFXAPP_HXX
#include <sfx2/app.hxx>
#endif
// header for SFX_BINDINGS
#ifndef _SFX_BINDINGS_HXX
#include <sfx2/bindings.hxx>
#endif

#include "schmod.hxx"
#include "schopt.hxx"
#include "tpappopt.hxx"

SfxItemSet*	 SchModule::CreateItemSet( USHORT nSlot )
{
	SchOptions* pOptions = GetSchOptions();
	SfxItemSet* pRet = new SfxItemSet( GetPool(),
									   CHATTR_DEFCOLORS, CHATTR_DEFCOLORS,
									   0 );
	
	pRet->Put( SchColorTableItem( CHATTR_DEFCOLORS, pOptions->GetDefaultColors() ) );

	return pRet;
}

void SchModule::ApplyItemSet( USHORT nSlot, const SfxItemSet& rSet )
{
	SchOptions* pOptions = GetSchOptions();

	const SfxPoolItem* pItem = NULL;

	if( rSet.GetItemState( CHATTR_DEFCOLORS, FALSE, &pItem ) == SFX_ITEM_SET )
	{
		((const SchColorTableItem*)pItem)->SetOptions( pOptions );
	}

	pOptions->SetDefault( FALSE );
	pOptions->StoreConfig();
	SFX_APP()->SaveConfiguration();
	SFX_BINDINGS().InvalidateAll( TRUE );
}

SfxTabPage*	 SchModule::CreateTabPage( USHORT nId, Window* pParent, const SfxItemSet& rSet )
{
	SfxTabPage* pRet = NULL;

	switch( nId )
	{
		case SID_SCH_TP_DEFCOLORS:
			pRet = SchDefaultColorOptPage::Create( pParent, rSet );
			break;
	}

	DBG_ASSERT( pRet, "Chart:CreateTabPage: unknown slot id");

	return pRet;
}

