/*************************************************************************
 *
 *  $RCSfile: attrib.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define ITEMID_FONTLIST 	SID_ATTR_CHAR_FONTLIST
#define ITEMID_ESCAPEMENT	SID_ATTR_CHAR_ESCAPEMENT
#define ITEMID_CASEMAP		SID_ATTR_CHAR_CASEMAP
#define ITEMID_NUMBERINFO	SID_ATTR_NUMBERFORMAT_INFO

#include "svx/xoutx.hxx"
#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif

#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#include <svx/numfmt.hxx>
#include <svx/dialogs.hrc>
#include <svx/chardlg.hxx>
#include <svx/tabline.hxx>

#include "schresid.hxx"
#include "attrib.hrc"
#include "schdll.hxx"
#include "chtmodel.hxx"
#include "schattr.hxx"
#include "attrib.hxx"

#include "tplabel.hxx"
#include "tplabel.hrc"
#include "tpscaley.hxx"
#include "tpscaley.hrc"

#include <svx/numinf.hxx>

/************************************************************************/

const USHORT nNoArrowDlg			= 1100;
const USHORT nNoArrowNoShadowDlg	= 1101;

/*************************************************************************
|*
|* Liefert die Ressourcen-Id fuer den angegebenen Attributs-Typ
|*
\************************************************************************/

USHORT SchAttribTabDlg::GetResId(AttrType eType)
{
	switch (eType)
	{
		case ATTR_TITLE:			return TAB_TITLE;
		case ATTR_LEGEND:			return TAB_LEGEND;
		case ATTR_DATA_ROW:			return TAB_DATA_ROW;
		case ATTR_DATA_LINE:		return TAB_DATA_LINE;
		case ATTR_DATA_POINT:		return TAB_DATA_POINT;
		case ATTR_AXIS:				return TAB_AXIS;
		case ATTR_X_AXIS_2D:
		case ATTR_X_AXIS_3D:		return TAB_X_AXIS;
		case ATTR_Y_AXIS_2D:
		case ATTR_Y_AXIS_3D:		return TAB_Y_AXIS;
		case ATTR_Z_AXIS:			return TAB_Z_AXIS;
		case ATTR_GRID:				return TAB_GRID;
		case ATTR_LINE:             return TAB_LINE;
		case ATTR_DIAGRAM_AREA:		return TAB_DIAGRAM_AREA;
		case ATTR_DIAGRAM_WALL:		return TAB_DIAGRAM_WALL;
		case ATTR_DIAGRAM_FLOOR:	return TAB_DIAGRAM_FLOOR;
		case ATTR_DIAGRAM_STOCK_LOSS: return TAB_DIAGRAM_STOCK_LOSS;
		case ATTR_DIAGRAM_STOCK_PLUS: return TAB_DIAGRAM_STOCK_PLUS;

		default:					return 0;
	}
}

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

SchAttribTabDlg::SchAttribTabDlg(Window* pParent, AttrType eType,
								 const SfxItemSet* pAttr,
								 const SfxObjectShell* pDocShell,
								 const ChartModel* pModel,
								 int   nID,
								 int   nType,
								 const SfxItemSet* pSymbolAttr,
								 Graphic aGraphic) :
	SfxTabDialog(pParent, SchResId(GetResId(eType)), pAttr),
	pColorTab(pModel->GetColorTable()),
	maSymbolGraphic(aGraphic),
	pDashList(pModel->GetDashList()),
	pLineEndList(pModel->GetLineEndList()),
	pGradientList(pModel->GetGradientList()),
	pHatchingList(pModel->GetHatchList()),
	pBitmapList(pModel->GetBitmapList()),
	nPageType(0),
	nDlgType(2),
	nPos(0),
	mpSymbolAttr(pSymbolAttr),
	nColorTableState(CT_NONE),
	nBitmapListState(CT_NONE),
	nGradientListState(CT_NONE),
	nHatchingListState(CT_NONE),
	eAttrType(eType),
	rDocShell(*pDocShell)
{
	pMyModel = (ChartModel*) pModel;
	FreeResource();

	switch (eAttrType)
	{
		case ATTR_TITLE:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_ALIGNMENT, SchAlignmentTabPage::Create, NULL);
			/*if (//(nID == CHOBJID_DIAGRAM_TITLE_X_AXIS) || (nID == CHOBJID_DIAGRAM_TITLE_Z_AXIS) ||
				(nID == CHOBJID_TITLE_MAIN) || (nID == CHOBJID_TITLE_SUB))
				RemoveTabPage (TP_ALIGNMENT);*/
			nDlgType = nNoArrowDlg;
			break;

		case ATTR_LEGEND:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_LEGEND_POS, SchLegendPosTabPage::Create, NULL);
			nDlgType = nNoArrowDlg;
			break;

		case ATTR_DATA_ROW:
		case ATTR_DATA_POINT:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_DATA_DESCR, SchDataDescrTabPage::Create, NULL);
			AddTabPage(TP_STAT, SchStatisticTabPage::Create, NULL);
			AddTabPage(TP_LAYOUT,SchLayoutTabPage::Create, NULL);
			AddTabPage(TP_OPTIONS,SchOptionTabPage::Create, NULL);
			if ((((const SfxInt32Item &)pAttr->Get (SCHATTR_DUMMY1)).GetValue () == CHOBJID_DIAGRAM_DATA) ||
				!pMyModel->IsStatisticChart())
				RemoveTabPage (TP_STAT);
			if(eAttrType==ATTR_DATA_POINT)
			{
				RemoveTabPage(TP_OPTIONS);
			}
			if(!pMyModel->Is3DChart())
				RemoveTabPage(TP_LAYOUT);

			if(!pMyModel->CanAxis(CHART_AXIS_SECONDARY_Y))
				RemoveTabPage(TP_OPTIONS);

			if(pMyModel->ChartStyle() == CHSTYLE_3D_PIE)
			{
//				RemoveTabPage (RID_SVXPAGE_LINE);
				RemoveTabPage(TP_LAYOUT);
			}

			nDlgType = nNoArrowNoShadowDlg;
			break;

		case ATTR_DATA_LINE:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_DATA_DESCR, SchDataDescrTabPage::Create, NULL);
			//if (pMyModel->IsStatisticChart())
			AddTabPage(TP_STAT, SchStatisticTabPage::Create, NULL);
			AddTabPage(TP_OPTIONS,SchOptionTabPage::Create, NULL);
			if (!pMyModel->IsStatisticChart())
				RemoveTabPage (TP_STAT);
			if(!pMyModel->CanAxis(CHART_AXIS_SECONDARY_Y))
				RemoveTabPage(TP_OPTIONS);
			nDlgType = nNoArrowDlg;
			break;


		case ATTR_AXIS:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
			nDlgType = nNoArrowDlg;
			break;

		case ATTR_X_AXIS_2D:
		case ATTR_X_AXIS_3D:
		{
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
			AddTabPage(TP_SCALE_Y, SchScaleYAxisTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_NUMBERFORMAT, SvxNumberFormatTabPage::Create, NULL);

			if (! pModel->IsXYChart ())
			{
				RemoveTabPage (TP_SCALE_Y);
				RemoveTabPage (RID_SVXPAGE_NUMBERFORMAT);
			}
			nDlgType = nNoArrowDlg;
			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_X));

			nAxisType = 1;
			break;
		}

		case ATTR_Y_AXIS_2D:
		case ATTR_Y_AXIS_3D:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_SCALE_Y, SchScaleYAxisTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_NUMBERFORMAT, SvxNumberFormatTabPage::Create, NULL);
			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
			nDlgType = nNoArrowDlg;
			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_Y));

			nAxisType = 2;
			break;

		case ATTR_Z_AXIS:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_CHAR_STD, SvxCharStdPage::Create, NULL);
			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
			nDlgType = nNoArrowDlg;
			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_Z));

			nAxisType = 3;
			break;

		case ATTR_GRID:
		case ATTR_LINE:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			nDlgType = nNoArrowDlg;
			break;

		case ATTR_DIAGRAM_STOCK_LOSS:
		case ATTR_DIAGRAM_STOCK_PLUS:
		case ATTR_DIAGRAM_AREA:
		case ATTR_DIAGRAM_FLOOR:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
			nDlgType = nNoArrowNoShadowDlg;
			break;

		case ATTR_DIAGRAM_WALL:
			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
			nDlgType = nNoArrowNoShadowDlg;
			break;

	}
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchAttribTabDlg::~SchAttribTabDlg()
{
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchAttribTabDlg::PageCreated(USHORT nId, SfxTabPage &rPage)
{
	switch (nId)
	{
		case TP_LAYOUT:
		break;
		case RID_SVXPAGE_LINE:
			((SvxLineTabPage&)rPage).SetColorTable(pColorTab);
			((SvxLineTabPage&)rPage).SetDashList(pDashList);
			((SvxLineTabPage&)rPage).SetLineEndList(pLineEndList);
			((SvxLineTabPage&)rPage).SetPageType(&nPageType);
			((SvxLineTabPage&)rPage).SetDlgType(&nDlgType);
			((SvxLineTabPage&)rPage).Construct();
			((SvxLineTabPage&)rPage).ActivatePage(*GetInputSetImpl());
			if(mpSymbolAttr)//unfein, aber wenn man schon die Attribute setzt, wird es wohl ne Linie
			{               //mit Symbolen sein.
				((SvxLineTabPage&)rPage).ShowSymbolControls(TRUE);
				((SvxLineTabPage&)rPage).SetSymbolList(pMyModel->GetSdrObjList());
				((SvxLineTabPage&)rPage).SetSymbolAttr(mpSymbolAttr);
				((SvxLineTabPage&)rPage).SetAutoSymbolGraphic(&maSymbolGraphic);
			}
			break;

		case RID_SVXPAGE_AREA:
			((SvxAreaTabPage&)rPage).SetColorTable(pColorTab);
			((SvxAreaTabPage&)rPage).SetGradientList(pGradientList);
			((SvxAreaTabPage&)rPage).SetHatchingList(pHatchingList);
			((SvxAreaTabPage&)rPage).SetBitmapList(pBitmapList);
			((SvxAreaTabPage&)rPage).SetPageType(&nPageType);
			((SvxAreaTabPage&)rPage).SetDlgType(&nDlgType);
			((SvxAreaTabPage&)rPage).SetGrdChgd(&nGradientListState);
			((SvxAreaTabPage&)rPage).SetHtchChgd(&nHatchingListState);
			((SvxAreaTabPage&)rPage).SetBmpChgd(&nBitmapListState);
			((SvxAreaTabPage&)rPage).SetColorChgd(&nColorTableState);
			((SvxAreaTabPage&)rPage).Construct();
			((SvxAreaTabPage&)rPage).ActivatePage(*GetInputSetImpl());
			break;

		case RID_SVXPAGE_TRANSPARENCE:
			( (SvxTransparenceTabPage&) rPage ).SetPageType( &nPageType );
			( (SvxTransparenceTabPage&) rPage ).SetDlgType( &nDlgType );
			( (SvxTransparenceTabPage&) rPage ).Construct();
			break;

		case RID_SVXPAGE_CHAR_STD:
			((SvxCharStdPage&)rPage).
				SetFontList(*(const SvxFontListItem*)
							 rDocShell.GetItem(SID_ATTR_CHAR_FONTLIST));
			break;

		case TP_AXIS_LABEL:
		{
			OrderMode eMode;
			switch( eAttrType )
			{
				case ATTR_X_AXIS_2D:
					eMode = CHORDMODE_X_AXIS;
					break;

				case ATTR_Y_AXIS_2D:
					eMode = CHORDMODE_Y_AXIS;
					break;

				default:
					eMode = CHORDMODE_NONE;
					break;
			}
			((SchAxisLabelTabPage&)rPage).SetOrderMode( eMode );
			((SchAxisLabelTabPage&)rPage).AllowTextOverlap( TRUE );
			break;
		}

		case TP_ALIGNMENT:
		{
			OrderMode eMode;
			switch (eAttrType)
			{
				case ATTR_X_AXIS_2D:
					eMode = CHORDMODE_X_AXIS;
					break;

				case ATTR_Y_AXIS_2D:
					eMode = CHORDMODE_Y_AXIS;
					break;

				default:
					eMode = CHORDMODE_NONE;
					break;
			}
			((SchAlignmentTabPage&)rPage).SetOrderMode(eMode);
			((SchAlignmentTabPage&)rPage).SetTextCanOverlap(/*pMyModel->IsReal3D()*/TRUE);
			break;
		}

		case TP_SCALE_Y:
			 ((SchScaleYAxisTabPage&)rPage).SetNumFormatter(pMyModel->GetNumFormatter());
			 ((SchScaleYAxisTabPage&)rPage).SetModel(pMyModel);
			break;

		case RID_SVXPAGE_NUMBERFORMAT:
			((SvxNumberFormatTabPage&)rPage).SetNumberFormatList(pMyModel->GetNumFormatter());
			break;
	}
}


