/*************************************************************************
 *
 *  $RCSfile: viewdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include "schresid.hxx"
#include "viewdlg.hxx"
#include "viewdlg.hrc"



/*************************************************************************
|*
|* Dialog
|*
\************************************************************************/

SchView3DDlg::SchView3DDlg( Window* pWindow , short nXAngle,
							short nYAngle, short nZAngle) :
				ModalDialog 	( pWindow, SchResId( DLG_3D_VIEW ) ),
				aFtXAxis		( this, ResId( FT_X_AXIS ) ),
				aMtrFldXAxis	( this, ResId( MTR_FLD_X_AXIS ) ),
				aFtYAxis		( this, ResId( FT_Y_AXIS ) ),
				aMtrFldYAxis	( this, ResId( MTR_FLD_Y_AXIS ) ),
				aFtZAxis		( this, ResId( FT_Z_AXIS ) ),
				aMtrFldZAxis	( this, ResId( MTR_FLD_Z_AXIS ) ),
				aGrpAxis		( this, ResId( GRP_AXIS ) ),
				aBtnOK			( this, ResId( BTN_OK ) ),
				aBtnCancel		( this, ResId( BTN_CANCEL ) ),
				aBtnHelp		( this, ResId( BTN_HELP ) )
{
	FreeResource();

	aMtrFldXAxis.SetValue(nXAngle);
	aMtrFldYAxis.SetValue(nYAngle);
	aMtrFldZAxis.SetValue(nZAngle);
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

SchView3DDlg::~SchView3DDlg()
{
}

/*************************************************************************
|*
|* Maxima setzen
|*
\************************************************************************/

void SchView3DDlg::SetMax(short nXMax, short nYMax, short nZMax)
{
	aMtrFldXAxis.SetMax(nXMax);
	aMtrFldXAxis.SetFirst(nXMax);
	aMtrFldYAxis.SetMax(nYMax);
	aMtrFldYAxis.SetFirst(nYMax);
	aMtrFldZAxis.SetMax(nZMax);
	aMtrFldZAxis.SetFirst(nZMax);
}

/*************************************************************************
|*
|* Minima setzen
|*
\************************************************************************/

void SchView3DDlg::SetMin(short nXMin, short nYMin, short nZMin)
{
	if ( nXMin == -1 )
	{
		aFtXAxis.Disable();
		aMtrFldXAxis.Disable();
	}
	else
	{
		aMtrFldXAxis.SetMin(nXMin);
		aMtrFldXAxis.SetLast(nXMin);
	}
	if ( nYMin == -1 )
	{
		aFtYAxis.Disable();
		aMtrFldYAxis.Disable();
	}
	else
	{
		aMtrFldYAxis.SetMin(nYMin);
		aMtrFldYAxis.SetLast(nYMin);
	}
	if ( nZMin == -1 )
	{
		aFtZAxis.Disable();
		aMtrFldZAxis.Disable();
	}
	else
	{
		aMtrFldZAxis.SetMin(nZMin);
		aMtrFldZAxis.SetLast(nZMin);
	}
}

/*************************************************************************
|*
|* Pie-Charts koennen nur an einer Achse gedreht werden
|*
\************************************************************************/

void SchView3DDlg::DisableOnPie ()
{
//    aMtrFldYAxis.Disable();
	aMtrFldZAxis.Disable();
}



