/*************************************************************************
 *
 *  $RCSfile: docshell.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define ITEMID_FONTLIST 		SID_ATTR_CHAR_FONTLIST
#define ITEMID_NUMBERINFO		SID_ATTR_NUMBERFORMAT_INFO
#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_GRADIENT_LIST	SID_GRADIENT_LIST
#define ITEMID_HATCH_LIST		SID_HATCH_LIST
#define ITEMID_BITMAP_LIST		SID_BITMAP_LIST
#define ITEMID_DASH_LIST		SID_DASH_LIST
#define ITEMID_LINEEND_LIST 	SID_LINEEND_LIST

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#include <svx/svxids.hrc>
#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif
#ifndef _SO_CLSIDS_HXX //autogen
#include <so3/clsids.hxx>
#endif
#ifndef _SFX_PRINTER_HXX //autogen
#include <sfx2/printer.hxx>
#endif
#ifndef _UNDO_HXX 
#include <svtools/undo.hxx>
#endif
#ifndef _CTRLTOOL_HXX 
#include <svtools/ctrltool.hxx>
#endif
#ifndef _IPMENU_HXX 
#include <so3/ipmenu.hxx>
#endif
#ifndef _SFXMNUMGR_HXX 
#include <sfx2/mnumgr.hxx>
#endif
#ifndef _SFX_PROGRESS_HXX
#include <sfx2/progress.hxx>
#endif
#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif
#ifndef _SFXSTBMGR_HXX //autogen
#include <sfx2/stbmgr.hxx>
#endif
#ifndef _SFXECODE_HXX //autogen
#include <svtools/sfxecode.hxx>
#endif
#ifndef _SVX_DRAWITEM_HXX //autogen
#include <svx/drawitem.hxx>
#endif
#ifndef _SFXSTYLE_HXX //autogen
#include <svtools/style.hxx>
#endif
#ifndef _SCH_DLL_HXX //autogen
#include <schdll.hxx>
#endif
#ifndef _SV_EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#include <sot/formats.hxx>
#include <svx/flstitem.hxx>
#include <svx/svxids.hrc>

#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
#include "schresid.hxx"
#include "schview.hxx"
#include "docshell.hxx"
#include "dragserv.hxx"

#include "ChXChartDocument.hxx"
#include "ChXChartData.hxx"

// header for class SfxFilter
#ifndef _SFX_DOCFILT_HACK_HXX
#include <sfx2/docfilt.hxx>
#endif

// XML filter
#include "SchXMLWrapper.hxx"

#define POOL_BUFFER_SIZE		(USHORT)32768
#define BASIC_BUFFER_SIZE		(USHORT)8192
#define DOCUMENT_BUFFER_SIZE	(USHORT)32768

#define SCH_STYLE_SHEET_NAME	String( RTL_CONSTASCII_USTRINGPARAM( "SfxStyleSheets" ))

// STATIC DATA -----------------------------------------------------------

static const String __FAR_DATA aStarChartDoc = String( RTL_CONSTASCII_USTRINGPARAM( "StarChartDocument" ));

//----------------------------------------------------------------------

/*************************************************************************
|*
|* SFX-Slotmaps und -Definitionen
|*
\************************************************************************/

#define SchChartDocShell
#include "schslots.hxx"

SFX_IMPL_INTERFACE( SchChartDocShell, SfxObjectShell, SchResId( 0 ) )
// from macro: void SchChartDocShell::InitInterface_Impl()
{}

using namespace com::sun::star;

SFX_IMPL_OBJECTFACTORY_DLL(SchChartDocShell, schart,
						   SvGlobalName(SO3_SCH_CLASSID_50), Sch)

TYPEINIT1(SchChartDocShell, SfxObjectShell);

/*************************************************************************
|*
|* Geimeinsamer Konstruktor-Teil
|*
\************************************************************************/

void SchChartDocShell::Construct() throw()
{
	//Wird fuer die ModelCollection benoetigt
	SetBaseModel( new ChXChartDocument( this ) );//#58232#
	SetPool(&pChDoc->GetItemPool());
	pUndoManager = new SfxUndoManager;

	// Listen, bzw. Tables im ItemSet der DocShell anlegen
	UpdateTablePointers();

	if (pChDoc->GetPageCount() == 0L)
	{
		// Seite einfuegen
		SdrPage* pPage = pChDoc->AllocPage(FALSE);
		pPage->SetSize(GetVisArea(ASPECT_CONTENT).GetSize());
		pChDoc->InsertPage(pPage);
	}
}

void SchChartDocShell::DataModified( chart::ChartDataChangeEvent& aEvent ) throw()
{
	uno::Reference< chart::XChartDocument > xChartDoc( GetBaseModel(), uno::UNO_QUERY );
	if( xChartDoc.is() )
	{
		uno::Reference< chart::XChartData > xData = xChartDoc->getData();
		if( xData.is() )
		{
			ChXChartData* pChXData = ChXChartData::getImplementation( xData );
			if( pChXData )
			{
				pChXData->DataModified( aEvent );
			}
		}
	}
}


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchChartDocShell::SchChartDocShell(SfxObjectCreateMode eMode) throw() :
	SfxObjectShell(eMode),
	pUndoManager(NULL),
	pPrinter(NULL),
	pFontList(NULL),
	pChDoc(NULL),
	bInitNewNoNewDoc(FALSE),
	bOwnPrinter(FALSE)
{
	CHART_TRACE( "SchChartDocShell::SchChartDocShell(SfxObjectCreateMode)" );
	SetShell(this);
}

/*************************************************************************
|*
|* Konstruktor 2
|*
\************************************************************************/

SchChartDocShell::SchChartDocShell(ChartModel* pDoc,
								   SfxObjectCreateMode eMode) throw() :
	SfxObjectShell(eMode),
	pUndoManager(NULL),
	pPrinter(NULL),
	pFontList(NULL),
	pChDoc(pDoc),
	bInitNewNoNewDoc(TRUE),
	bOwnPrinter(FALSE)
{
	CHART_TRACE1( "SchChartDocShell::SchChartDocShell(pDoc,eMode) pDoc=%lx", (long)pDoc );
	SetShell(this);
	Construct();
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchChartDocShell::~SchChartDocShell() throw()
{
	CHART_TRACE( "SchChartDocShell::~SchChartDocShell" );

	delete pFontList;

	delete pUndoManager;

	if( pChDoc )
	{
		pChDoc->ClearUndoBuffer();				// clear draw undo actions
		pChDoc->SetMaxUndoActionCount( 1 );		// don't add further undo actions
	}

	if(bOwnPrinter)
		delete pPrinter;

	delete pChDoc;
}

/*************************************************************************
|*
|* SFX-Requests bearbeiten
|*
\************************************************************************/

void SchChartDocShell::Execute(SfxRequest& rReq) throw()
{
	switch (rReq.GetSlot())
	{
		case SID_CLOSEDOC:
			SfxObjectShell::DoClose();
			break;

		case SID_UPDATE:
			pChDoc->InitDataAttrs();
			pChDoc->BuildChart(FALSE);
			break;
	}
}

/*************************************************************************
|*
|* Slot-Stati setzen
|*
\************************************************************************/

void SchChartDocShell::GetState(SfxItemSet &rSet) throw()
{
	SfxWhichIter aIter(rSet);
	USHORT nWhich = aIter.FirstWhich();

	while (nWhich)
	{
		USHORT nSlotId = SfxItemPool::IsWhich(nWhich) ?
						 GetPool().GetSlotId(nWhich) : nWhich;

		switch (nSlotId)
		{
/*            case SID_DOC_MODIFIED:
				rSet.Put( SfxStringItem( SID_DOC_MODIFIED,
										 IsModified() ? '*' : ' ' ) );
				//rSet.Put(SfxBoolItem(SID_DOC_MODIFIED, IsModified()));
				break;
*/
			case SID_DOCTEMPLATE :
				rSet.DisableItem (SID_DOCTEMPLATE);
				break;
		}

		nWhich = aIter.NextWhich();
	}
}

/*************************************************************************
|*
|* SFX-Aktivierung
|*
\************************************************************************/

void SchChartDocShell::Activate() throw()
{
}

/*************************************************************************
|*
|* SFX-Deaktivierung
|*
\************************************************************************/

void SchChartDocShell::Deactivate() throw()
{
}

/*************************************************************************
|*
|* SFX-Undomanager zurueckgeben
|*
\************************************************************************/

SfxUndoManager* SchChartDocShell::GetUndoManager() throw()
{
	return pUndoManager;
}

/*************************************************************************
|*
|* SfxPrinter ggf. erzeugen und zurueckgeben
|*
\************************************************************************/
SfxPrinter* SchChartDocShell::GetPrinter() throw()
{
	if (!pPrinter)
	{
		SfxBoolItem aItem(SID_PRINTER_NOTFOUND_WARN, TRUE);
		// ItemSet mit speziellem Poolbereich anlegen
		SfxItemSet* pSet = new SfxItemSet(GetPool(),
										  SID_PRINTER_NOTFOUND_WARN,
										  SID_PRINTER_NOTFOUND_WARN, 0);
		pSet->Put(aItem);
		pPrinter = new SfxPrinter(pSet);
		bOwnPrinter = TRUE;

		MapMode aMapMode = pPrinter->GetMapMode();
		aMapMode.SetMapUnit(MAP_100TH_MM);
		pPrinter->SetMapMode(aMapMode);

		if (pChDoc)
		{
			if (pPrinter != pChDoc->GetRefDevice())
				pChDoc->SetRefDevice(pPrinter);

			if (pPrinter != pChDoc->GetOutliner()->GetRefDevice())
				pChDoc->GetOutliner()->SetRefDevice(pPrinter);
		}
	}

	return pPrinter;
}


/*************************************************************************
|*
|* neuen SfxPrinter setzen
|*
\************************************************************************/
void SchChartDocShell::SetPrinter( SfxPrinter* pNewPrinter, BOOL bIsDeletedHere ) throw()
{
	if( pNewPrinter->GetMapMode().GetMapUnit() == MAP_100TH_MM )
	{
		// Printer kann nur verwendet werden, wenn die MapUnit stimmt
		if (pPrinter && bOwnPrinter && (pPrinter != pNewPrinter))
		{
			delete pPrinter;
			bOwnPrinter = FALSE;
		}

		bOwnPrinter = bIsDeletedHere;

		pPrinter = pNewPrinter;
		if(pFontList)delete pFontList;
		OutputDevice* pOut = Application::GetDefaultDevice();	// #67730#
		pFontList = new FontList( pPrinter, pOut, FALSE );
		PutItem(SvxFontListItem(pFontList));

		if (pChDoc)
		{
			if (pPrinter != pChDoc->GetRefDevice())
				pChDoc->SetRefDevice(pPrinter);

			if (pPrinter != pChDoc->GetOutliner()->GetRefDevice())
				pChDoc->GetOutliner()->SetRefDevice(pPrinter);
		}
	}
	else
		if( bIsDeletedHere )
			delete pNewPrinter;
}



/*************************************************************************
|*
|*
|*
\************************************************************************/
Printer* SchChartDocShell::GetDocumentPrinter() throw()
{
	return GetPrinter();
}

/*************************************************************************
|*
|*
|*
\************************************************************************/
void SchChartDocShell::OnDocumentPrinterChanged(Printer* pNewPrinter) throw()
{
//	if (pPrinter->IsA(SfxPrinter))
	{
		// Da kein RTTI verfuegbar, wird hart gecasted (...)
		SetPrinter((SfxPrinter*) pNewPrinter);
	}
}



/*************************************************************************
|*
|* InitNew, (Dokument wird neu erzeugt): Streams oeffnen
|*
\************************************************************************/

BOOL SchChartDocShell::InitNew(SvStorage * pStor) throw()
{
	CHART_TRACE1( "SchChartDocShell::InitNew pModel=%lx", (long)pChDoc );

	BOOL bRet = SfxInPlaceObject::InitNew(pStor);

	if (bRet)
	{


		if(!pChDoc)
		{
			pChDoc = new ChartModel(this);
			Construct();
		}

		SvStorage* pStor2 = GetStorage();
		aPoolStm = pStor2->OpenStream( SCH_STYLE_SHEET_NAME );
		aPoolStm->SetVersion (pStor2->GetVersion ());
		aDocStm = pStor2->OpenStream(aStarChartDoc);
		aDocStm->SetVersion (pStor2->GetVersion ());

		if (pChDoc)
		{
			if(bInitNewNoNewDoc)
				pChDoc->NewOrLoadCompleted(DOC_LOADED);
			else
				pChDoc->NewOrLoadCompleted(NEW_DOC);
		}

		SetVisArea(Rectangle(Point(0, 0), Size(8000, 7000)));

		bRet = aPoolStm->GetError() == 0;
	}

	return bRet;
}

/*************************************************************************
|*
|* Load: Pools und Dokument laden
|*
\************************************************************************/

BOOL SchChartDocShell::Load(SvStorage * pStor) throw()
{

	CHART_TRACE( "SchChartDocShell::Load" );

	BOOL bRet = FALSE;

	ULONG nStorFmt = pStor->GetFormat();
	String aFormat = Exchange::GetFormatName(nStorFmt);

	if ( nStorFmt == SOT_FORMATSTR_ID_STARCHART_50 ||
		 nStorFmt == SOT_FORMATSTR_ID_STARCHART_40 ||
		 nStorFmt == SOT_FORMATSTR_ID_STARCHART    ||
		 nStorFmt == SOT_FORMATSTR_ID_STARCHARTDOCUMENT_50
		 )
	{
		pChDoc = new ChartModel(this);
		SetPool(&pChDoc->GetItemPool());
		SetBaseModel( new ChXChartDocument( this ) );//#58232#

		pUndoManager = new SfxUndoManager;

		if( GetCreateMode() == SFX_CREATE_MODE_EMBEDDED )
			pProgress = NULL;
		else
			pProgress = new SfxProgress( this, String( SchResId( STR_OPEN_DOCUMENT )), 100 );

		if( pProgress )
			pProgress->SetState( 0, 100 );

		bRet = SfxInPlaceObject::Load(pStor);

		if( pProgress )
			pProgress->SetState( 30 );

		if( bRet )
		{
			SetWaitCursor( TRUE );

			// Pool und StyleSheet Pool laden
			String aStyleSheetsStr( SCH_STYLE_SHEET_NAME );

			if (pStor->IsStream(aStyleSheetsStr))
			{
				ULONG nError;
				aPoolStm = pStor->OpenStream(aStyleSheetsStr);
				aPoolStm->SetVersion (pStor->GetVersion ());
				if (!aPoolStm->GetError())
				{
					aPoolStm->SetBufferSize(POOL_BUFFER_SIZE);
					nError = aPoolStm->GetError();
					GetPool().SetFileFormatVersion (pStor->GetVersion ());
					nError = aPoolStm->GetError();
					GetPool().Load(*aPoolStm);
					nError = aPoolStm->GetError();
					if( nError )
					{
						DBG_ERROR1( "Errorcode 0x%x loading Pool", nError );
						aPoolStm->ResetError();
						SetError( ERRCODE_WARNING_MASK | nError );
					}
					GetStyleSheetPool()->Load(*aPoolStm);
					nError = aPoolStm->GetError();
					if( nError )
					{
						DBG_ERROR1( "Errorcode 0x%x loading StyleSheet-Pool", nError );
						aPoolStm->ResetError();
						SetError( ERRCODE_WARNING_MASK | nError );
					}
					aPoolStm->SetBufferSize(0);
				}
				else bRet = FALSE;
			}
			else bRet = FALSE;

			if( pProgress )
				pProgress->SetState( 70 );

			// wenn gewuenscht, das Dokument laden
			if (bRet && (GetCreateMode() != SFX_CREATE_MODE_ORGANIZER))
			{
				// Model der Drawing Engine laden
				if (pStor->IsStream(aStarChartDoc))
				{
					aDocStm = pStor->OpenStream(aStarChartDoc);
					aDocStm->SetVersion (pStor->GetVersion ());
					GetPool ().SetFileFormatVersion (pStor->GetVersion ());
					if (!aDocStm->GetError())
					{
						aDocStm->SetBufferSize(DOCUMENT_BUFFER_SIZE);
						aDocStm->SetKey(pStor->GetKey()); // Passwort setzen
						*aDocStm >> *pChDoc;
						bRet = aDocStm->GetError() == 0;

						if (!bRet)
						{
							if (pStor->GetKey().Len() == 0)
							{
								// kein Passwort gesetzt --> Datei marode
								SetError(ERRCODE_SFX_DOLOADFAILED);
							}
							else
							{
								// Passwort gesetzt --> war wohl falsch
								SetError(ERRCODE_SFX_WRONGPASSWORD);
							}
						}

						aDocStm->SetBufferSize(0);
						DBG_ASSERT(bRet, "Fehler beim Laden des Models");
					}
					else bRet = FALSE;
				}
				else bRet = FALSE;
			}

			if( pProgress )
				pProgress->SetState( 100 );

			// (noch) keine ungesicherten Aenderungen im Model
			if (bRet)
			{
				pChDoc->SetChanged(FALSE);
				pChDoc->NewOrLoadCompleted(DOC_LOADED);
			}

			SetWaitCursor( FALSE );
		}

		if( pProgress )
			pProgress->SetState( 100 );

		if (bRet)
		{
			UpdateTablePointers();
			FinishedLoading(SFX_LOADED_ALL);
		}
	}
	else
	{
		pStor->SetError(SVSTREAM_WRONGVERSION);
	}

	if( pProgress )
	{
		delete pProgress;
		pProgress = NULL;
	}

	return bRet;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

sal_Bool SchChartDocShell::ConvertTo( SfxMedium &rMedium )
{
	BOOL			bRet = FALSE;

	String aFilterName( rMedium.GetFilter()->GetFilterName() );
	if( aFilterName.EqualsAscii( "StarOffice XML (Chart)" ))
	{
		/**********************************************************************
		 * StarOffice XML-Filter Export
		 **********************************************************************/
		SchXMLWrapper aFilter( GetModel(), rMedium, TRUE );

		// update user info before writing
		UpdateDocInfoForSave();

		bRet = aFilter.Export();
	}

	return  bRet;
}

sal_Bool SchChartDocShell::ConvertFrom( SfxMedium &rMedium )
{
	BOOL bRet = FALSE;

	const String aFilterName(rMedium.GetFilter()->GetFilterName());

	if( aFilterName.EqualsAscii( "StarOffice XML (Chart)" ))
	{
		/**********************************************************************
		* StarOffice XML-Filter Import
		**********************************************************************/
		SchXMLWrapper aFilter( GetModel(), rMedium, TRUE );

		bRet = aFilter.Import();
	}

	FinishedLoading( SFX_LOADED_MAINDOCUMENT );

	return bRet;
}



/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchChartDocShell::HandsOff() throw()
{
	aDocStm.Clear();
	aPoolStm.Clear();
	SfxInPlaceObject::HandsOff();
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchChartDocShell::Save() throw()
{
	CHART_TRACE( "SchChartDocShell::Save" );

	pChDoc->PrepareAxisStorage();
	long nFileFormat = aDocStm->GetVersion();
	if(nFileFormat <= SOFFICE_FILEFORMAT_40 && pChDoc->IsReal3D())
	{
		CHART_TRACE( "Fileformat 4.0" );
		pChDoc->PrepareOld3DStorage();
	}


	BOOL bRet = SfxInPlaceObject::Save();
	SfxStatusBarManager* pStbMgr =
		(GetCreateMode() == SFX_CREATE_MODE_EMBEDDED) ?
		NULL : SFX_APP()->GetStatusBarManager();

	if (pStbMgr)
		pStbMgr->StartProgressMode(SchResId(STR_SAVE_DOCUMENT), 100);
	if(bRet)
	{
		SetWaitCursor( TRUE );

		if (!aPoolStm->GetError())
		{
			aPoolStm->SetSize(0);
			aPoolStm->SetBufferSize(POOL_BUFFER_SIZE);
			GetPool().Store(*aPoolStm);

			if (pStbMgr)
				pStbMgr->SetProgressState(20);

			// der StyleSheetPool benutzt beim Speichern intern First()/Next(),
			// setzt aber nicht die Suchmasken zurueck, darum machen
			// wir das selbst
			GetStyleSheetPool()->SetSearchMask(SFX_STYLE_FAMILY_ALL);
			// FALSE = auch unbenutzte Vorlagen speichern
			GetStyleSheetPool()->Store(*aPoolStm, FALSE);
			aPoolStm->SetBufferSize(0);

			if (pStbMgr)
				pStbMgr->SetProgressState(50);
		}
		else bRet = FALSE;
		if (bRet)
			bRet = aPoolStm->GetError() == 0;
		DBG_ASSERT(bRet, "Fehler beim Schreiben der Pools");

		if (!aDocStm->GetError())
		{
			aDocStm->SetSize(0);
			aDocStm->SetBufferSize(DOCUMENT_BUFFER_SIZE);
			*aDocStm << *pChDoc;
			aDocStm->SetBufferSize(0);
		}
		else
			bRet = FALSE;

		if (bRet)
			bRet = aDocStm->GetError() == 0;
		DBG_ASSERT(bRet, "Fehler beim Schreiben des Models");

		if (pStbMgr)
			pStbMgr->SetProgressState(100);

		SetWaitCursor( FALSE );
	}

	if (pStbMgr)
		pStbMgr->EndProgressMode();

	if(nFileFormat <= SOFFICE_FILEFORMAT_40 && pChDoc->IsReal3D())
	{
		pChDoc->CleanupOld3DStorage();
	}

	return bRet;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchChartDocShell::SaveAs(SvStorage * pStor) throw()
{
	CHART_TRACE( "SchChartDocShell::SaveAs" );


	pChDoc->PrepareAxisStorage();
	long nFileFormat = pStor->GetVersion();
	if(nFileFormat <= SOFFICE_FILEFORMAT_40 && pChDoc->IsReal3D())
	{
		pChDoc->PrepareOld3DStorage();
		CHART_TRACE( "Fileformat 4.0" );
	}

	BOOL bRet = SfxInPlaceObject::SaveAs(pStor);
	SfxStatusBarManager* pStbMgr =
		(GetCreateMode() == SFX_CREATE_MODE_EMBEDDED) ?
		NULL : SFX_APP()->GetStatusBarManager();
	if (pStbMgr)
		pStbMgr->StartProgressMode(SchResId(STR_SAVE_DOCUMENT), 100);
	if (bRet)
	{
		SvStorageStreamRef aStm = pStor->OpenStream( SCH_STYLE_SHEET_NAME );
		aStm->SetVersion (pStor->GetVersion ());

		SetWaitCursor( TRUE );

		if (!aStm->GetError())
		{
			aStm->SetBufferSize(POOL_BUFFER_SIZE);
			GetPool().SetFileFormatVersion (pStor->GetVersion ());
			GetPool().Store(*aStm);

			if (pStbMgr)
				pStbMgr->SetProgressState(20);

			// der StyleSheetPool benutzt beim Speichern intern First()/Next(),
			// setzt aber nicht die Suchmasken zurueck, darum machen
			// wir das selbst
			GetStyleSheetPool()->SetSearchMask(SFX_STYLE_FAMILY_ALL);
			// FALSE = auch unbenutzte Vorlagen speichern
			GetStyleSheetPool()->Store(*aStm, FALSE);
			aStm->SetBufferSize(0);

			if (pStbMgr)
				pStbMgr->SetProgressState(50);
		}
		else
			bRet = FALSE;

		if (bRet)
			bRet = aStm->GetError() == 0;
		DBG_ASSERT(bRet, "Fehler beim Schreiben der Pools");

		aStm = pStor->OpenStream(aStarChartDoc);
		aStm->SetVersion (pStor->GetVersion ());
		GetPool ().SetFileFormatVersion (pStor->GetVersion ());

		if (!aStm->GetError())
		{
			aStm->SetBufferSize(DOCUMENT_BUFFER_SIZE);
			aStm->SetKey(pStor->GetKey());	// Passwort setzen
			*aStm << *pChDoc;
			aStm->SetBufferSize(0);
		}
		else bRet = FALSE;
		if (bRet)
			bRet = aStm->GetError() == 0;
		DBG_ASSERT(bRet, "Fehler beim Schreiben des Models");

		if (pStbMgr)
			pStbMgr->SetProgressState(100);

		SetWaitCursor( FALSE );
	}

	if (pStbMgr)
		pStbMgr->EndProgressMode();

	if(nFileFormat <= SOFFICE_FILEFORMAT_40 && pChDoc->IsReal3D())
	{
		pChDoc->CleanupOld3DStorage();
	}

	return bRet;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchChartDocShell::SaveCompleted(SvStorage * pStor) throw()
{
	CHART_TRACE( "SchChartDocShell::SaveCompleted" );

	BOOL bRet = FALSE;

	if (SfxInPlaceObject::SaveCompleted(pStor))
	{
		if (pStor)
		{
			aDocStm.Clear();
			aPoolStm.Clear();
			aDocStm = pStor->OpenStream( aStarChartDoc );
			aDocStm->SetVersion (pStor->GetVersion ());
			GetPool ().SetFileFormatVersion (pStor->GetVersion ());
			aPoolStm = pStor->OpenStream( SCH_STYLE_SHEET_NAME );
			aPoolStm->SetVersion (pStor->GetVersion ());
			bRet = !aDocStm->GetError() && !aPoolStm->GetError();
		}
		else
			bRet = TRUE;

		// keine ungesicherten Aenderungen mehr im Model

		pChDoc->SetChanged(FALSE);
	}
	return bRet;
}


/*************************************************************************
|*
|* CreateSnapshot
|*
\************************************************************************/

SvDataMemberObjectRef SchChartDocShell::CreateSnapshot() throw()
{
	// Dokument vorhanden, View muss erzeugt werden
	CHART_TRACE( "SchChartDocShell::CreateSnapshot" );

	OutputDevice* pOut = Application::GetDefaultDevice();
	DBG_ASSERT( pOut, "couldn't get default device" );
	VirtualDevice* pVDev = new VirtualDevice( *pOut );	// #67730#
	DBG_ASSERT( pVDev, "couldn't create virtual device" );
	MapMode aMap = pVDev->GetMapMode();
	aMap.SetMapUnit(pChDoc->GetScaleUnit());
	aMap.SetScaleX(pChDoc->GetScaleFraction());
	aMap.SetScaleY(pChDoc->GetScaleFraction());
	pVDev->SetMapMode(aMap);

	SchView* pSchViewIntern = new SchView(pChDoc, pVDev);
	pSchViewIntern->SetMarkHdlHidden(TRUE);

	pSchViewIntern->SetActualWin (pVDev);
	Point aPos;
	SdrPageView* pPageView = pSchViewIntern->ShowPagePgNum(0, aPos);
	pSchViewIntern->MarkAll();
//	Rectangle aVisArea = pSchViewIntern->GetAllMarkedRect();
	Rectangle aVisArea = GetVisArea (ASPECT_CONTENT);

	SdrPage* pPage = pChDoc->GetPage(0);
	pPage->SetSize(aVisArea.GetSize());

	ULONG nObjCount = pPage->GetObjCount();
	SdrObject* pObj = NULL;
	Point aOrigin = aVisArea.TopLeft();
	Size aVector(-aOrigin.X(), -aOrigin.Y());

	for (ULONG nObj = 0; nObj < nObjCount; nObj++)
	{
		// Das BoundingRect aller Objekte wird auf (0, 0) positioniert

		pObj = pPage->GetObj(nObj);
		pObj->NbcMove(aVector);
	}

	ChartModel* pDocument = (ChartModel*)pSchViewIntern->GetAllMarkedModel();

	delete pSchViewIntern;
	delete pVDev;

	// DataObject aufbauen und uebergeben

	return new SchDragServer(pDocument);
}

/*************************************************************************
|*
|* Tabellenzeiger auffrischen
|*
\************************************************************************/
void SchChartDocShell::UpdateTablePointers() throw()
{
	PutItem(SvxColorTableItem(pChDoc->GetColorTable()));
	PutItem(SvxGradientListItem(pChDoc->GetGradientList()));
	PutItem(SvxHatchListItem(pChDoc->GetHatchList()));
	PutItem(SvxBitmapListItem(pChDoc->GetBitmapList()));
	PutItem(SvxDashListItem(pChDoc->GetDashList()));
	PutItem(SvxLineEndListItem(pChDoc->GetLineEndList()));

	if(pFontList)delete pFontList;

	if ( GetCreateMode() == SFX_CREATE_MODE_EMBEDDED && !pPrinter )
	{
		// OLE-Objekt: kein Printer anlegen
		pFontList = new FontList( Application::GetDefaultDevice(), NULL, FALSE );	// #67730#
	}
	else
	{
		pFontList = new FontList(GetPrinter(), NULL, FALSE);
	}

	SvxFontListItem aFontListItem(pFontList);
	PutItem(aFontListItem);

//	PutItem(SvxNumberInfoItem(pChDoc->GetNumFormatter()));
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchChartDocShell::FillRegInfo( SvEmbeddedRegistryInfo * pInfo ) throw()
{
	SfxInPlaceObject::FillRegInfo( pInfo );
	pInfo->aObjName = aStarChartDoc;
	pInfo->nMajorVers = 5;
	pInfo->nMinorVers = 0;
	pInfo->aHumanShortTypeName = String(SchResId(STR_CHART_DOCUMENT));
	pInfo->aExt.AssignAscii( RTL_CONSTASCII_STRINGPARAM( ".sds" ));
	pInfo->nIconResId = REG_ICON_RESID_CHART;
}


/*************************************************************************
|*
|* FillClass
|*
\************************************************************************/

void SchChartDocShell::FillClass(SvGlobalName* pClassName,
								 ULONG*  pFormat,
								 String* pAppName,
								 String* pFullTypeName,
								 String* pShortTypeName,
								 long    nFileFormat) const throw()
{
#ifdef DBG_UTIL
	if( pFormat )
	{
		ByteString aBuf( Exchange::GetFormatName( *pFormat ), RTL_TEXTENCODING_ASCII_US );
		CHART_TRACE2( "SchChartDocShell::FillClass Fmt=%s #%ld", aBuf.GetBuffer(), nFileFormat );
	}
#endif

	SfxInPlaceObject::FillClass(pClassName, pFormat, pAppName, pFullTypeName,
								pShortTypeName, nFileFormat);

	String aFormat = Exchange::GetFormatName(*pFormat);

	if (nFileFormat == SOFFICE_FILEFORMAT_31)
	{
		*pClassName     = SvGlobalName(SO3_SCH_CLASSID_30);
		*pFormat        = SOT_FORMATSTR_ID_STARCHART;
		(*pAppName).AssignAscii( RTL_CONSTASCII_STRINGPARAM( "Schart 3.1" ));
		*pFullTypeName  = String(SchResId(STR_CHART_DOCUMENT_FULLTYPE_31));
		*pShortTypeName = String(SchResId(STR_CHART_DOCUMENT));
	}
	else if (nFileFormat == SOFFICE_FILEFORMAT_40)
	{
		*pClassName     = SvGlobalName(SO3_SCH_CLASSID_40);
		*pFormat        = SOT_FORMATSTR_ID_STARCHART_40;
		*pFullTypeName  = String(SchResId(STR_CHART_DOCUMENT_FULLTYPE_40));
		*pShortTypeName = String(SchResId(STR_CHART_DOCUMENT));
	}
	else if (nFileFormat == SOFFICE_FILEFORMAT_NOW)
	{
		*pFullTypeName  = String(SchResId(STR_CHART_DOCUMENT_FULLTYPE_50));
		*pShortTypeName = String(SchResId(STR_CHART_DOCUMENT));
	}
}

void SchChartDocShell::InPlaceActivate( BOOL b ) throw()
{
	if( pChDoc )
	{
		pChDoc->CatchUpBufferedData();
	}
	SfxInPlaceObject::InPlaceActivate( b );
}



