/*************************************************************************
 *
 *  $RCSfile: fuchrmap.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX //autogen
#include <svtools/poolitem.hxx>
#endif
#define ITEMID_FONT 			EE_CHAR_FONTINFO
#include <svx/fontitem.hxx>

#include "fuchrmap.hxx"
#include "schview.hxx"
#include "strings.hrc"
#include "schresid.hxx"

#ifndef _OUTLINER_HXX //autogen
#include <svx/svdoutl.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVX_CHARMAP_HXX //autogen
#include <svx/charmap.hxx>
#endif

#ifdef IRIX
#ifndef _SBXCLASS_HXX
#include <svtools/sbx.hxx>
#endif
#endif

TYPEINIT1( SchFuCharMap, SchFuPoor );

/*************************************************************************
|*
|* constructor
|*
|* creates a dialog for insertion of special characters
|* there ist no font support yet.
|* (for info. see sd/source/ui/func/fubullet.cxx)
|*
\************************************************************************/

SchFuCharMap::SchFuCharMap( SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
							ChartModel* pModel, SfxRequest& rReq)
	   : SchFuPoor(pViewSh, pWin, pView, pModel, rReq)
{

	SvxCharacterMap* pDlg = new SvxCharacterMap( NULL, FALSE );

	OutlinerView* pOV = NULL;
	SdrOutliner*  pOL = NULL;
	
	pOV = pView->GetTextEditOutlinerView();
	
	if( pOV )
	{
		// set the current font
		pOL = pView->GetTextEditOutliner();
		OutputDevice *pOut = pOL->GetRefDevice();

		pDlg->SetFont( pOut->GetFont() );
	}

	// the font mustn't be changed
	pDlg->DisableFontSelection();
	USHORT nResult = pDlg->Execute();

	String aString;

	if( nResult == RET_OK )
	{
		aString = pDlg->GetCharacters();
	}
	delete( pDlg );

	if( nResult == RET_OK && pOV )
	{
		// insert string

		// prevent flicker
		pOV->HideCursor();
		pOL->SetUpdateMode(FALSE);

		// delete current selection by inserting empty String, so current
		// attributes become unique (sel. has to be erased anyway)
        pOV->InsertText(String());

        SfxUndoManager& rUndoMgr =  pOL->GetUndoManager();
        rUndoMgr.EnterListAction( String( SchResId( STR_UNDO_INSERT_SPECCHAR )), String( SchResId( STR_UNDO_INSERT_SPECCHAR )));
		pOV->InsertText(aString, TRUE);

        ESelection aSel = pOV->GetSelection();
		aSel.nStartPara = aSel.nEndPara;
		aSel.nStartPos = aSel.nEndPos;
		pOV->SetSelection(aSel);

        rUndoMgr.LeaveListAction();

        // show changes
		pOL->SetUpdateMode(TRUE);
		pOV->ShowCursor();
	}
}

