/*************************************************************************
 *
 *  $RCSfile: fudgraut.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#pragma hdrstop

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS
#include <svx/chrtitem.hxx>

#include "app.hrc"
#include "schresid.hxx"
#include "strings.hrc"
#include "schview.hxx"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "viewshel.hxx"
#include "dlggraut.hxx"
#include "undgraut.hxx"
#include "fudgraut.hxx"

#include "chtscene.hxx"

TYPEINIT1(SchFuDiagramAutoPilot, SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchFuDiagramAutoPilot::SchFuDiagramAutoPilot(SchViewShell* pViewSh,
											 SchWindow* pWin, SchView* pView,
											 ChartModel* pDoc,
											 SfxRequest& rReq) :
	SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
{
	SvxChartStyle eOldStyle		= pDoc->ChartStyle();
//	long nOldGapWidth			= pDoc->GapWidth();
//	long nOldOverlap			= pDoc->Overlap();

	short i;
	short nPieSegCnt = pDoc->PieSegCount();
	long *pOldPieSegOfs = new long[nPieSegCnt];
	for (i = 0; i < nPieSegCnt; i++)
		pOldPieSegOfs[i] = pDoc->PieSegOfs(i);

	BOOL   bOldShowMainTitle	= pDoc->ShowMainTitle();
	String aOldMainTitle		= pDoc->MainTitle();
	BOOL   bOldShowSubTitle		= pDoc->ShowSubTitle();
	String aOldSubTitle			= pDoc->SubTitle();
	BOOL   bOldShowXAxisTitle	= pDoc->ShowXAxisTitle();
	String aOldXAxisTitle		= pDoc->XAxisTitle();
	BOOL   bOldShowYAxisTitle	= pDoc->ShowYAxisTitle();
	String aOldYAxisTitle		= pDoc->YAxisTitle();
	BOOL   bOldShowZAxisTitle	= pDoc->ShowZAxisTitle();
	String aOldZAxisTitle		= pDoc->ZAxisTitle();
	BOOL   bOldShowXAxis		= pDoc->ShowXAxis();
	BOOL   bOldShowXGridMain	= pDoc->ShowXGridMain();
	BOOL   bOldShowXGridHelp	= pDoc->ShowXGridHelp();
	BOOL   bOldShowXDescr		= pDoc->ShowXDescr();
	BOOL   bOldShowYAxis		= pDoc->ShowYAxis();
	BOOL   bOldShowYGridMain	= pDoc->ShowYGridMain();
	BOOL   bOldShowYGridHelp	= pDoc->ShowYGridHelp();
	BOOL   bOldShowYDescr		= pDoc->ShowYDescr();
	BOOL   bOldShowZAxis		= pDoc->ShowZAxis();
	BOOL   bOldShowZGridMain	= pDoc->ShowZGridMain();
	BOOL   bOldShowZGridHelp	= pDoc->ShowZGridHelp();
	BOOL   bOldShowZDescr		= pDoc->ShowZDescr();
	BOOL   bOldSwitchData		= pDoc->IsSwitchData();
	long   nOldChartShapeType   = pDoc->GetChartShapeType();

	const SfxPoolItem *pPoolItem = NULL;
	SfxItemSet aAttr(pDoc->GetLegendAttr());
	SvxChartLegendPos eOldLegendPos =
		(aAttr.GetItemState(SCHATTR_LEGEND_POS, TRUE, &pPoolItem)
			== SFX_ITEM_SET) ?
		((const SvxChartLegendPosItem*)pPoolItem)->GetValue() : CHLEGEND_NONE;

	SchChartDocShell* pChDocSh =
				new SchChartDocShell(SFX_CREATE_MODE_PREVIEW);
	SfxObjectShellLock aDocShellRef = pChDocSh;
	aDocShellRef->DoInitNew(NULL);

	ChartModel &rChDoc    = pChDocSh->GetDoc();
	BOOL             bOldLegend = pDoc->GetShowLegend();
	short            nXAngle;
	short            nYAngle;
	short            nZAngle;

	rChDoc.SetChartData(*pDoc->GetChartData());
	pDoc->GetAngles (nXAngle, nYAngle, nZAngle);
	rChDoc.SetAngles (nXAngle, nYAngle, nZAngle);
	rChDoc.SetShowLegend (pDoc->GetShowLegend());

	rChDoc.ChartStyle ()         = eOldStyle;
//	rChDoc.GapWidth ()           = nOldGapWidth;
//	rChDoc.Overlap ()            = nOldOverlap;
	rChDoc.ShowMainTitle ()      = bOldShowMainTitle;
	rChDoc.MainTitle ()          = aOldMainTitle;
	rChDoc.SubTitle ()           = aOldSubTitle;
	rChDoc.ShowSubTitle ()       = bOldShowSubTitle;
	rChDoc.ShowXAxisTitle ()     = bOldShowXAxisTitle;
	rChDoc.XAxisTitle ()         = aOldXAxisTitle;
	rChDoc.ShowYAxisTitle ()     = bOldShowYAxisTitle;
	rChDoc.YAxisTitle ()         = aOldYAxisTitle;
	rChDoc.ShowZAxisTitle ()     = bOldShowZAxisTitle;
	rChDoc.ZAxisTitle ()         = aOldZAxisTitle;
	rChDoc.ShowXAxis (bOldShowXAxis);
	rChDoc.ShowXGridMain ()      = bOldShowXGridMain;
	rChDoc.ShowXGridHelp ()      = bOldShowXGridHelp;
	rChDoc.ShowXDescr (bOldShowXDescr);
	rChDoc.ShowYAxis (bOldShowYAxis);
	rChDoc.ShowYGridMain ()      = bOldShowYGridMain;
	rChDoc.ShowYGridHelp ()      = bOldShowYGridHelp;
	rChDoc.ShowYDescr (bOldShowYDescr);
	rChDoc.ShowZAxis (bOldShowZAxis);
	rChDoc.ShowZGridMain ()      = bOldShowZGridMain;
	rChDoc.ShowZGridHelp ()      = bOldShowZGridHelp;
	rChDoc.ShowZDescr (bOldShowZDescr);
	rChDoc.DataDescr ()          = CHDESCR_NONE;
	rChDoc.ShowSym ()            = FALSE;
/*	In den Achsenattributen enthalten
	rChDoc.Val Format ()          = pDoc->Va lFormat();
	rChDoc.Perc entValFormat ()   = pDoc->Per centValFormat();
	rChDoc.Desc rFormat ()        = pDoc->Des crFormat();
	rChDoc.Percen tDescrFormat () = pDoc->Des crFormat(); */
	rChDoc.SetSwitchData (pDoc->IsSwitchData());

	rChDoc.PutTitleAttr(pDoc->GetTitleAttr());
	rChDoc.PutMainTitleAttr(pDoc->GetMainTitleAttr());
	rChDoc.PutSubTitleAttr(pDoc->GetSubTitleAttr());
	rChDoc.PutXAxisTitleAttr(pDoc->GetXAxisTitleAttr());
	rChDoc.PutYAxisTitleAttr(pDoc->GetYAxisTitleAttr());
	rChDoc.PutZAxisTitleAttr(pDoc->GetZAxisTitleAttr());
	rChDoc.PutAxisAttr(pDoc->GetAxisAttr());

	rChDoc.CopyAxisAttributes(pDoc,TRUE);

	rChDoc.PutGridAttr(pDoc->GetGridAttr());
	rChDoc.PutXGridMainAttr(pDoc->GetXGridMainAttr());
	rChDoc.PutYGridMainAttr(pDoc->GetYGridMainAttr());
	rChDoc.PutZGridMainAttr(pDoc->GetZGridMainAttr());
	rChDoc.PutXGridHelpAttr(pDoc->GetXGridHelpAttr());
	rChDoc.PutYGridHelpAttr(pDoc->GetYGridHelpAttr());
	rChDoc.PutZGridHelpAttr(pDoc->GetZGridHelpAttr());
	rChDoc.PutDiagramAreaAttr(pDoc->GetDiagramAreaAttr());
	rChDoc.PutDiagramWallAttr(pDoc->GetDiagramWallAttr());
	rChDoc.PutDiagramFloorAttr(pDoc->GetDiagramFloorAttr());
	rChDoc.PutLegendAttr(pDoc->GetLegendAttr());

	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKLOSS_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKLOSS_GROUP),FALSE);
	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKPLUS_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKPLUS_GROUP),FALSE);
	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKLINE_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKLINE_GROUP),FALSE);
	//Textgroesse wird falsch skaliert, da alle Textattr. relativ zu aInitialSize sind #47892#
	rChDoc.InitialSize() = pDoc->InitialSize();

	rChDoc.SetShowDataDescr(FALSE); //die Datenbeschriftung wird im Autopiloten aus Platzmangel verboten

	short nColCnt, nRowCnt, nMax, j;

	nMax = pDoc->GetRowCount();
	for (i = 0; i < nMax; i++)
		rChDoc.PutDataRowAttr(i, pDoc->GetDataRowAttr(i));

	nColCnt = pDoc->GetColCount();
	nRowCnt = pDoc->GetRowCount();

	for (i = 0; i < nColCnt; i++)
		for (j = 0; j < nRowCnt; j++)
			rChDoc.PutDataPointAttr(i, j, pDoc->GetDataPointAttr(i, j));

//      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//      stattfindet waehrend dieser Dialog geoeffnet ist.
//	SchDiagramAutoPilotDlg* pDlg = new SchDiagramAutoPilotDlg(&pViewSh->GetViewFrame()->GetWindow(),
//			                                                  aDocShellRef);
	SchDiagramAutoPilotDlg* pDlg = new SchDiagramAutoPilotDlg(NULL, aDocShellRef);

	// #74709# this is just a fix for this place again and no general enhancement :-(
	if( rChDoc.IsPieChart() && rChDoc.IsReal3D() )
	{
		ChartScene* pScene = rChDoc.GetScene();
		if( pScene )
		{
			Matrix4D aSceneMatrix;
			aSceneMatrix.RotateX( -F_PI/3 );
			pScene->SetTransform( aSceneMatrix );
		}
	}

		// FG: 13.3.97 folgendes ist aus dem Draw fuinsfil.cxx uebernommen
		// Ev. wird eine QueryBox geoeffnet ("Links aktualisieren?"),
		// daher wird der Dialog der aktuelle DefModalDialogParent
	Window* pDefParent = GetpApp()->GetDefDialogParent();
	GetpApp()->SetDefDialogParent(pDlg);

	pDlg->SetLegendPos(eOldLegendPos);

	USHORT nResult = pDlg->Execute();

	GetpApp()->SetDefDialogParent(pDefParent);

	delete pDlg;

	if (nResult == RET_OK)
	{
		rReq.Done();

		SFX_DISPATCHER().Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);

		SvxChartStyle eNewStyle		= rChDoc.ChartStyle();
//		long nNewGapWidth			= rChDoc.GapWidth();
//		long nNewOverlap			= rChDoc.Overlap();

		long *pNewPieSegOfs = new long[nPieSegCnt];
		BOOL bNewPieSegOfs = FALSE;
		for (i = 0; i < nPieSegCnt; i++)
		{
			pNewPieSegOfs[i] = rChDoc.PieSegOfs(i);
			bNewPieSegOfs =
				(bNewPieSegOfs || pNewPieSegOfs[i] != pOldPieSegOfs[i]);
		}

		BOOL   bNewShowMainTitle	= rChDoc.ShowMainTitle();
		String aNewMainTitle		= rChDoc.MainTitle();
		BOOL   bNewShowSubTitle		= rChDoc.ShowSubTitle();
		String aNewSubTitle			= rChDoc.SubTitle();
		BOOL   bNewShowXAxisTitle	= rChDoc.ShowXAxisTitle();
		String aNewXAxisTitle		= rChDoc.XAxisTitle();
		BOOL   bNewShowYAxisTitle	= rChDoc.ShowYAxisTitle();
		String aNewYAxisTitle		= rChDoc.YAxisTitle();
		BOOL   bNewShowZAxisTitle	= rChDoc.ShowZAxisTitle();
		String aNewZAxisTitle		= rChDoc.ZAxisTitle();
		BOOL   bNewShowXAxis		= rChDoc.ShowXAxis();
		BOOL   bNewShowXGridMain	= rChDoc.ShowXGridMain();
		BOOL   bNewShowXGridHelp	= rChDoc.ShowXGridHelp();
		BOOL   bNewShowXDescr		= rChDoc.ShowXDescr();
		BOOL   bNewShowYAxis		= rChDoc.ShowYAxis();
		BOOL   bNewShowYGridMain	= rChDoc.ShowYGridMain();
		BOOL   bNewShowYGridHelp	= rChDoc.ShowYGridHelp();
		BOOL   bNewShowYDescr		= rChDoc.ShowYDescr();
		BOOL   bNewShowZAxis		= rChDoc.ShowZAxis();
		BOOL   bNewShowZGridMain	= rChDoc.ShowZGridMain();
		BOOL   bNewShowZGridHelp	= rChDoc.ShowZGridHelp();
		BOOL   bNewShowZDescr		= rChDoc.ShowZDescr();
		BOOL   bNewSwitchData		= rChDoc.IsSwitchData();
		BOOL   bNewShowLegend		= rChDoc.GetShowLegend();
		long   nNewChartShapeType   = rChDoc.GetChartShapeType();

		if (nNewChartShapeType != nOldChartShapeType   ||
			eNewStyle != eOldStyle || /*nNewGapWidth != nOldGapWidth ||
			nNewOverlap != nOldOverlap ||*/ bNewPieSegOfs ||
			bNewShowMainTitle != bOldShowMainTitle ||
			aNewMainTitle != aOldMainTitle ||
			bNewShowSubTitle != bOldShowSubTitle ||
			aNewSubTitle != aOldSubTitle ||
			bNewShowXAxisTitle != bOldShowXAxisTitle ||
			aNewXAxisTitle != aOldXAxisTitle ||
			bNewShowYAxisTitle != bOldShowYAxisTitle ||
			aNewYAxisTitle != aOldYAxisTitle ||
			bNewShowZAxisTitle != bOldShowZAxisTitle ||
			aNewZAxisTitle != aOldZAxisTitle ||
			bNewShowXAxis != bOldShowXAxis ||
			bNewShowXGridMain != bOldShowXGridMain ||
			bNewShowXGridHelp != bOldShowXGridHelp ||
			bNewShowXDescr != bOldShowXDescr ||
			bNewShowYAxis != bOldShowYAxis ||
			bNewShowYGridMain != bOldShowYGridMain ||
			bNewShowYGridHelp != bOldShowYGridHelp ||
			bNewShowYDescr != bOldShowYDescr ||
			bNewShowZAxis != bOldShowZAxis ||
			bNewShowZGridMain != bOldShowZGridMain ||
			bNewShowZGridHelp != bOldShowZGridHelp ||
			bNewShowZDescr != bOldShowZDescr ||
			bNewSwitchData != bOldSwitchData ||
			bNewShowLegend != bOldLegend )
		{
			for (i = 0; i < nPieSegCnt; i++)
				pDoc->PieSegOfs (i) = pNewPieSegOfs[i];

			pDoc->ShowMainTitle ()  = bNewShowMainTitle;
			pDoc->MainTitle ()      = aNewMainTitle;
			pDoc->ShowSubTitle ()   = bNewShowSubTitle;
			pDoc->SubTitle ()       = aNewSubTitle;
			pDoc->ShowXAxisTitle () = bNewShowXAxisTitle;
			pDoc->XAxisTitle ()     = aNewXAxisTitle;
			pDoc->ShowYAxisTitle () = bNewShowYAxisTitle;
			pDoc->YAxisTitle ()     = aNewYAxisTitle;
			pDoc->ShowZAxisTitle () = bNewShowZAxisTitle;
			pDoc->ZAxisTitle ()     = aNewZAxisTitle;
			pDoc->ShowXAxis (bOldShowXAxis);
			pDoc->ShowXGridMain ()  = bNewShowXGridMain;
			pDoc->ShowXGridHelp ()  = bNewShowXGridHelp;
			pDoc->ShowXDescr (bNewShowXDescr);
			pDoc->ShowYAxis (bNewShowYAxis);
			pDoc->ShowYGridMain ()  = bNewShowYGridMain;
			pDoc->ShowYGridMain ()  = bNewShowYGridMain;
			pDoc->ShowYGridHelp ()  = bNewShowYGridHelp;
			pDoc->ShowYDescr (bNewShowYDescr);
			pDoc->ShowZAxis (bNewShowZAxis);
			pDoc->ShowZGridMain ()  = bNewShowZGridMain;
			pDoc->ShowZGridHelp ()  = bNewShowZGridHelp;
			pDoc->ShowZDescr (bNewShowZDescr);
			pDoc->SetSwitchData (bNewSwitchData);
			pDoc->SetShowLegend (bNewShowLegend);

			if(nNewChartShapeType != nOldChartShapeType)
			{
				SfxItemSet aSet(pDoc->GetPool(),SCHATTR_STYLE_SHAPE,SCHATTR_STYLE_SHAPE);
				aSet.Put(SfxInt32Item(SCHATTR_STYLE_SHAPE,nNewChartShapeType));
//				long nCnt=pDoc->GetRowCount();
//				while(nCnt--)
				pDoc->PutDataRowAttrAll(aSet);
			}


			pDoc->ChangeChart( eNewStyle );
			pDoc->BuildChart(FALSE);

			SchUndoDiagramAutoPilot* pUndo =
				new SchUndoDiagramAutoPilot(*pDoc, eOldStyle, /*nOldGapWidth,
											nOldOverlap,*/ pOldPieSegOfs,
											nPieSegCnt, bOldShowMainTitle,
											aOldMainTitle, bOldShowSubTitle,
											aOldSubTitle, bOldShowXAxisTitle,
											aOldXAxisTitle, bOldShowYAxisTitle,
											aOldYAxisTitle, bOldShowZAxisTitle,
											aOldZAxisTitle, bOldShowXAxis,
											bOldShowXGridMain,
											bOldShowXGridHelp,
											bOldShowXDescr, bOldShowYAxis,
											bOldShowYGridMain,
											bOldShowYGridHelp,
											bOldShowYDescr, bOldShowZAxis,
											bOldShowZGridMain,
											bOldShowZGridHelp,
											bOldShowZDescr, bOldSwitchData,
											eOldLegendPos,
											eNewStyle, /*nNewGapWidth,
											nNewOverlap*/ pNewPieSegOfs,
											nPieSegCnt, bNewShowMainTitle,
											aNewMainTitle, bNewShowSubTitle,
											aNewSubTitle, bNewShowXAxisTitle,
											aNewXAxisTitle, bNewShowYAxisTitle,
											aNewYAxisTitle, bNewShowZAxisTitle,
											aNewZAxisTitle, bNewShowXAxis,
											bNewShowXGridMain,
											bNewShowXGridHelp,
											bNewShowXDescr, bNewShowYAxis,
											bNewShowYGridMain,
											bNewShowYGridHelp,
											bNewShowYDescr, bNewShowZAxis,
											bNewShowZGridMain,
											bNewShowZGridHelp,
											bNewShowZDescr, bNewSwitchData,
											bNewShowLegend);

			pUndo->SetComment(String(SchResId(STR_UNDO_AUTOFORMAT)));

			pViewSh->GetViewFrame()->GetObjectShell()->
				GetUndoManager()->AddUndoAction(pUndo);

			return;

		}

		delete[] pNewPieSegOfs;
	}

	delete[] pOldPieSegOfs;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchFuDiagramAutoPilot::Activate()
{
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchFuDiagramAutoPilot::Deactivate()
{
}



