/*************************************************************************
 *
 *  $RCSfile: fupoor.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SI_NOSBXCONTROLS
#define _SI_NOOTHERFORMS
#define _SI_NOCONTROL
#define _SI_NOSBXCONTROLS

#include "datarow.hxx"
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif
#ifndef _SV_SELENG_HXX //autogen
#include <vcl/seleng.hxx>
#endif
#ifndef _SFXSTBMGR_HXX //autogen
#include <sfx2/stbmgr.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif

#ifndef _AEITEM_HXX //autogen
#include <svtools/aeitem.hxx>
#endif

#include <svx/flstitem.hxx>

#pragma hdrstop

// Fuer SvxChooseControlEnum
//#define _BASIDESH_HXX
//#define _TBXCTL_HXX
//#include <basicsh.hxx>
//#include <svxids.hrc>

#include "schview.hxx"
#include "viewshel.hxx"
#include "chwindow.hxx"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "dragserv.hxx"
#include "docshell.hxx"
#include "fusel.hxx"
#include "fupoor.hxx"

TYPEINIT0(SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchFuPoor::SchFuPoor(SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
					 ChartModel* pDoc, SfxRequest& rReq) :
	pViewShell(pViewSh),
	pWindow(pWin),
	pView(pView),
	pChDoc(pDoc),
	nSlotId(rReq.GetSlot()),
	pDialog(NULL),
	bIsInDragMode(FALSE),
	bFirstMouseMove(FALSE)
{
	nSlotValue   = 0;
	pMarkedObj   = 0;
	pMarkedObjId = 0;
	nMarkedID    = 0;

	const SfxItemSet* pSet = rReq.GetArgs();
	if (pSet)
	{
		if (pSet->GetItemState(nSlotId) == SFX_ITEM_SET)
		{
			const SfxPoolItem& rItem = pSet->Get(nSlotId);
			if( rItem.ISA(SfxAllEnumItem))
				nSlotValue = ((const SfxAllEnumItem&)rItem).GetValue();
		}
	}

	aDragTimer.SetTimeoutHdl(LINK(this, SchFuPoor, DragHdl));
	aDragTimer.SetTimeout(SELENG_DRAGDROP_TIMEOUT);

	if (pView->GetMarkList().GetMarkCount() >= 1)
	{
		pMarkedObj   = pView->GetMarkList().GetMark(0)->GetObj();
		pMarkedObjId = GetObjectId(*pMarkedObj);
		if (pMarkedObjId) nMarkedID = pMarkedObjId->GetObjId();

		if (nMarkedID == CHOBJID_DIAGRAM) nMarkedID = CHOBJID_DIAGRAM_WALL;
	}
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchFuPoor::~SchFuPoor()
{
	aDragTimer.Stop();

	delete pDialog;
}

/*************************************************************************
|*
|* Function aktivieren
|*
\************************************************************************/

void SchFuPoor::Activate()
{
	if (pDialog)
		pDialog->Show();
}

/*************************************************************************
|*
|* Function deaktivieren
|*
\************************************************************************/

void SchFuPoor::Deactivate()
{
	aDragTimer.Stop();

	if (pDialog)
		pDialog->Hide();

	if (pWindow)
		pWindow->ReleaseMouse();
}

//	SFX_APP()->SetHelpText(aStr);


/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

BOOL SchFuPoor::KeyInput(const KeyEvent& rKEvt)
{
	BOOL bReturn = FALSE;

	switch (rKEvt.GetKeyCode().GetCode())
	{
		case KEY_ESCAPE:
		{
			// InPlace-Modus abbrechen
			SchChartDocShell* pDocSh = (SchChartDocShell*) pViewShell->
															GetViewFrame()->
																GetObjectShell();
			if ( pDocSh )
			{
				pDocSh->DoInPlaceActivate( FALSE );
				bReturn = TRUE;
			}
		}
		break;
	}

	return bReturn;
}

/*************************************************************************
|*
|* Cut object to clipboard
|*
\************************************************************************/

BOOL SchFuPoor::DoCut()
{
	return pView && pView->DoCut(pWindow);
}

/*************************************************************************
|*
|* Copy object to clipboard
|*
\************************************************************************/

void SchFuPoor::DoCopy()
{
	if (pView)
		pView->DoCopy(pWindow);
}

/*************************************************************************
|*
|* Paste object from clipboard
|*
\************************************************************************/

void SchFuPoor::DoPaste()
{
	if (pView)
		pView->DoPaste(pWindow);
}

/*************************************************************************
|*
|* Timer-Handler fuer Drag&Drop
|*
\************************************************************************/

IMPL_LINK( SchFuPoor, DragHdl, Timer *, pTimer )
{
	USHORT nHitLog = (USHORT)pWindow->PixelToLogic(Size(HITPIX,0)).Width();
	SdrHdl* pHdl = pView->HitHandle(aMDPos, *pWindow);

	if (pHdl==NULL && pView->IsMarkedHit(aMDPos, nHitLog))
	{
		pWindow->ReleaseMouse();
		bIsInDragMode = TRUE;

		pView->BeginDrag(pWindow, aMDPos);
	}
	return 0;
}

/*************************************************************************
|*
|* Command-event
|*
\************************************************************************/

BOOL SchFuPoor::Command(const CommandEvent& rCEvt)
{
	return pView->Command(rCEvt, pWindow);
}

/*************************************************************************
|*
|* Handler fuer Mausbewegung
|*
\************************************************************************/

BOOL SchFuPoor::MouseMove(const MouseEvent& rMEvt)
{
	return FALSE;
}

/*************************************************************************
|*
|* Handler fuer Maustaste
|*
\************************************************************************/

BOOL SchFuPoor::MouseButtonDown(const MouseEvent& rMEvt)
{
	return FALSE;
}

/*************************************************************************
|*
|* Handler fuer Maustaste
|*
\************************************************************************/

BOOL SchFuPoor::MouseButtonUp(const MouseEvent& rMEvt)
{
	return FALSE;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchFuPoor::Paint(const Rectangle& rRect, SchWindow* pWin)
{
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchFuPoor::SelectionHasChanged()
{
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchFuPoor::RemarkObject()
{
	if (nMarkedID)
	{

		/* if (pChDoc->Is3DChart ()) aehnlich zu #48352#
		{
			((SchViewShell *) pViewShell)->SetRepaintPossible (FALSE);
			pView->InitRedraw (pWindow, Region (Rectangle (pWindow->GetViewOrigin (),
														   pWindow->GetViewSize ())));
		}
		*/

		SdrPage *pPage = pChDoc->GetPage(0);

		if (pPage)
		{
			SdrObject *pObj = GetObjWithId (nMarkedID, *pPage, 0, IM_DEEPWITHGROUPS);

			if (pObj)
			{
				SdrPageView* pPV = pView->GetPageViewPvNum (0);

				pView->UnmarkAll ();
				pView->LeaveAllGroup ();
				pView->SetMarkHdlHidden(TRUE);

				// FG: Das selektiert natuerlich nur ein Gruppenobjekt wie das Diagramm
				//     die Legende oder aehnliches, man hat ja vorher alle Gruppen verlassen.
				//     Das bezieht sich auf den Bug #38436#. Damit bleibt die Selektion
				//     erhalten. Derjenige der RemarkObject aufruft muss nMarkedID setzen.
				// pView->PickObj (aMDPos, 50, pObj, pPV);

				pView->MarkObj (pObj, pPV);
				pView->SetMarkHdlHidden(FALSE);
			}
		}
	}
}

/*************************************************************************
|*
|* Alle 3DCubes einzeln selektieren:
|*
\************************************************************************/

void SchFuPoor::Select3DGroupMembers(SdrObject *pObj,	SdrPageView* pPV)
{

	USHORT nHitLog = (USHORT)pWindow->PixelToLogic(Size(HITPIX,0)).Width();
	SdrPage *pPage = pChDoc->GetPage(0);
	ULONG   nIndex = 0;


	pView->MarkObj(aMDPos, nHitLog);
	pView->EnterMarkedGroup();
	pView->PickObj(aMDPos, nHitLog, pObj, pPV);
	if(!pObj)
		return;

	pView->UnmarkAll();

	SchObjectId* pObjId   = GetObjectId(*pObj);
	short        nDataRow = 32767;

	if (pObjId && (pObjId->GetObjId() == CHOBJID_DIAGRAM_SPECIAL_GROUP))
		nDataRow = GetDataRow(*pObj)->GetRow();

	SdrObjListIter aIterator(*pPage, IM_DEEPWITHGROUPS);
	while (aIterator.IsMore())
	{
		SdrObject* pObj = aIterator.Next();
		SchObjectId* pObjId = GetObjectId(*pObj);

		if (pObjId && (pObjId->GetObjId() == CHOBJID_DIAGRAM_SPECIAL_GROUP))
			if (nDataRow == GetDataRow(*pObj)->GetRow()) pView->MarkObj (pObj, pPV);
	}


}



