/*************************************************************************
 *
 *  $RCSfile: undatpnt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//svdraw.hxx
//#define _SVDRAW_HXX
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
//#define _SDR_NOOBJECTS
//#define _SDR_NOVIEWS
#define _SDR_NOVIEWMARKER
#define _SDR_NODRAGMETHODS
#define _SDR_NOUNDO
#define _SDR_NOXOUTDEV

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif








#pragma hdrstop
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif

#include "schdll.hxx"
#include "schresid.hxx"
#include "strings.hrc"
#include "schview.hxx"
#include "datapoin.hxx"
#include "undatpnt.hxx"

TYPEINIT1(SchUndoDataPoint, SchUndoAttr);


/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDataPoint::Undo()
{
	SdrObject *pObj=rDoc.GetDataPointObj(nCol, nRow);
	if(pObj)
	{
		rDoc.ChangeDataPointAttr(*pOldAttr,*pObj, FALSE);
	}
	else
	{
		DBG_ERROR("SchUndoDataPoint::Undo : Datapointobject not found");
	}
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDataPoint::Redo()
{
	rDoc.ChangeDataPointAttr(*pNewAttr, *rDoc.GetDataPointObj(nCol, nRow));
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDataPoint::Repeat(SfxRepeatTarget& rView)
{
	if (((SchView&)rView).HasMarkedObj())
	{
		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
			SchDataPoint* pDataPoint = GetDataPoint(*pObj);

			if (pDataPoint)
			{
				short nCol = pDataPoint->GetCol();
				short nRow = pDataPoint->GetRow();

				SfxItemSet aOldAttr(rDoc.GetDataPointAttr(nCol, nRow));

				if (rDoc.ChangeDataPointAttr(*pNewAttr, *pObj))
				{
					SchUndoDataPoint* pUndo =
						new SchUndoDataPoint(rDoc, nCol, nRow,
											 aOldAttr, *pNewAttr);
					pUndo->SetComment(String(SchResId(STR_UNDO_DATA_POINT)));

					rDoc.GetObjectShell()->
						GetUndoManager()->AddUndoAction(pUndo);
				}
			}
		}
	}
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchUndoDataPoint::CanRepeat(SfxRepeatTarget& rView) const
{
	if (((SchView&)rView).HasMarkedObj())
	{
		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();

		if (rMarkList.GetMarkCount() == 1 &&
			GetDataPoint(*rMarkList.GetMark(0)->GetObj()))
			return TRUE;
	}

	return FALSE;
}



