/*************************************************************************
 *
 *  $RCSfile: undgraxi.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX

//SV
//#define _CLIP_HXX
//#define _CONFIG_HXX ***
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX
//#define _TOOLBOX_HXX
//#define _STATUS_HXX
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
//#define _FILDLG_HXX
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX


#pragma hdrstop

#ifndef _SFX_OBJSH_HXX //autogen
#include <sfx2/objsh.hxx>
#endif





#include "schdll.hxx"
#include "schresid.hxx"
#include "strings.hrc"
#include "schview.hxx"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "objid.hxx"
#include "undgraxi.hxx"

TYPEINIT1(SchUndoDiagramAxis, SchUndoAttr);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

SchUndoDiagramAxis::SchUndoDiagramAxis(ChartModel& rChDoc, UINT16 nId,
									   const SfxItemSet& rOldXAxisAttr,
									   const SfxItemSet& rOldYAxisAttr,
									   const SfxItemSet& rOldZAxisAttr,
									   const SfxItemSet& rOldAttr,
									   const SfxItemSet& rNewAttr) :
	SchUndoAttr(rChDoc, rOldAttr, rNewAttr),
	nAxisId(nId),
	pOldXAxisAttr(new SfxItemSet(rOldXAxisAttr)),
	pOldYAxisAttr(new SfxItemSet(rOldYAxisAttr)),
	pOldZAxisAttr(new SfxItemSet(rOldZAxisAttr))
{
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchUndoDiagramAxis::~SchUndoDiagramAxis()
{
	delete pOldXAxisAttr;
	delete pOldYAxisAttr;
	delete pOldZAxisAttr;
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDiagramAxis::Undo()
{
	if (nAxisId == 0)
		rDoc.ChangeAxisAttr(*pOldXAxisAttr, *pOldYAxisAttr,
							*pOldZAxisAttr, FALSE);
	else
		rDoc.ChangeAxisAttr(*pOldAttr,
							(SdrObjGroup*)rDoc.GetChartObj(nAxisId),
							FALSE);
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDiagramAxis::Redo()
{
	rDoc.ChangeAxisAttr(*pNewAttr,
						(SdrObjGroup*)rDoc.GetChartObj(nAxisId));
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

void SchUndoDiagramAxis::Repeat(SfxRepeatTarget& rView)
{
	if (((SchView&)rView).HasMarkedObj())
	{
		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
			SchObjectId* pObjId = GetObjectId(*pObj);

			if (pObjId)
			{
				UINT16 nId = pObjId->GetObjId();

				switch (nId)
				{
					//TVM: Tja, so ein Sch*, die Ids hier wurden nie gesetzt und sind zu
					//allem berflu auch noch doppelt belegt (weia!)
					//ToDo: Testen, _GROUP entfernen, testen, IDs aus defines.hxx lschen!
					case CHOBJID_DIAGRAM_X_AXIS_GROUP:
					case CHOBJID_DIAGRAM_Y_AXIS_GROUP:
					case CHOBJID_DIAGRAM_Z_AXIS_GROUP:
					{
						SfxItemSet aOldAttr(rDoc.GetAxisAttr((SdrObjGroup*)pObj));
						SfxItemSet aOldXAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_X_AXIS));
						SfxItemSet aOldYAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_Y_AXIS));
						SfxItemSet aOldZAxisAttr ( rDoc.GetAttr(CHOBJID_DIAGRAM_Z_AXIS));

						if (rDoc.ChangeAxisAttr(*pNewAttr,
												 (SdrObjGroup*)pObj))
						{
							SchUndoDiagramAxis* pUndo =
								new SchUndoDiagramAxis(rDoc, nId,
													   aOldXAxisAttr,
													   aOldYAxisAttr,
													   aOldZAxisAttr,
													   aOldAttr, *pNewAttr);
							pUndo->SetComment
								(String(SchResId(STR_UNDO_DIAGRAM_AXIS)));

							rDoc.GetObjectShell()->
								GetUndoManager()->AddUndoAction(pUndo);
						}
						break;
					}
				}
			}
		}
	}
}

/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SchUndoDiagramAxis::CanRepeat(SfxRepeatTarget& rView) const
{
	if (((SchView&)rView).HasMarkedObj())
	{
		const SdrMarkList& rMarkList = ((SchView&)rView).GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SchObjectId* pObjId =
				GetObjectId(*rMarkList.GetMark(0)->GetObj());

			if (pObjId)
				switch (pObjId->GetObjId())
				{
					case CHOBJID_DIAGRAM_X_AXIS:
					case CHOBJID_DIAGRAM_Y_AXIS:
					case CHOBJID_DIAGRAM_Z_AXIS:
						return TRUE;
				}
		}
	}

	return FALSE;
}



