/*************************************************************************
 *
 *  $RCSfile: ChXChartDocument.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XCHARTDOCUMENT_HPP_
#include <com/sun/star/chart/XChartDocument.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_ 
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XCHARTDATA_HPP_
#include <com/sun/star/chart/XChartData.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XCHARTDATACHANGEEVENTLISTENER_HPP_
#include <com/sun/star/chart/XChartDataChangeEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XDIAGRAM_HPP_
#include <com/sun/star/chart/XDiagram.hpp>
#endif

// header for SfxBaseModel
#ifndef _SFX_SFXBASEMODEL_HXX_
#include <sfx2/sfxbasemodel.hxx>
#endif

// header for SvxItemPropertySet
#ifndef SVX_UNOPROV_HXX
#include <svx/unoprov.hxx>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

#include "ChXDiagram.hxx"

// header for SvxChartLegendPosItem
// is needed in cxx, but has to be before docshell.hxx
#ifndef _SVX_CHRTITEM_HXX
#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS   SCHATTR_LEGEND_POS
#include <svx/chrtitem.hxx>
#endif

#include "docshell.hxx"

class ChartModel;

class ChXChartDocument :
	public com::sun::star::lang::XMultiServiceFactory,
	public com::sun::star::beans::XPropertySet,
	public com::sun::star::chart::XChartDocument,
	public com::sun::star::lang::XServiceInfo,
	public com::sun::star::util::XNumberFormatsSupplier,
	public SfxBaseModel
{
private:
	SchChartDocShell*	m_pDocShell;
	ChartModel*			m_pModel;
	SvxItemPropertySet	m_aPropSet;
	ChXDiagram*			m_pDiagram;
	SchChartDocShellRef	m_rDocShell;

	com::sun::star::uno::Sequence< com::sun::star::uno::Type > maTypeSequence;

	com::sun::star::uno::Reference< com::sun::star::chart::XDiagram > m_rXDiagram;
	com::sun::star::uno::Reference< com::sun::star::chart::XChartData > m_xChartData;
	com::sun::star::uno::Reference< com::sun::star::chart::XChartDataChangeEventListener > m_xEventListener;
	com::sun::star::uno::Reference< com::sun::star::util::XNumberFormatsSupplier > rNumberFormatter;

	com::sun::star::uno::Reference< com::sun::star::drawing::XShape > getShapeById( long nId );
	com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > getObjectByMapAndId( const long nMapId, const long nObjId );

public:
	ChXChartDocument( SchChartDocShell* pShell );
	virtual ~ChXChartDocument();

	void setDiagramType( const ::rtl::OUString& ) throw();
	::rtl::OUString getDiagramType() const throw();

	void SetChartModel( ChartModel* ) throw();
	void RefreshData( const com::sun::star::chart::ChartDataChangeEvent& ) throw();
	void InitNumberFormatter() throw( com::sun::star::uno::RuntimeException );

	// XInterface
	virtual com::sun::star::uno::Any SAL_CALL queryInterface( const com::sun::star::uno::Type & rType )
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL acquire() throw();
    virtual void SAL_CALL release() throw();

	// XMultiServiceFactory
    virtual com::sun::star::uno::Reference< com::sun::star::uno::XInterface > SAL_CALL createInstance(
		const ::rtl::OUString& aServiceSpecifier )
		throw( com::sun::star::uno::Exception, com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::uno::XInterface > SAL_CALL createInstanceWithArguments(
		const ::rtl::OUString& ServiceSpecifier,
		const com::sun::star::uno::Sequence< com::sun::star::uno::Any >& Arguments )
		throw( com::sun::star::uno::Exception, com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getAvailableServiceNames()
		throw( com::sun::star::uno::RuntimeException );

	// XPropertySet
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySetInfo > SAL_CALL getPropertySetInfo()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setPropertyValue( const ::rtl::OUString& aPropertyName,
											const com::sun::star::uno::Any& aValue )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::beans::PropertyVetoException,
			   com::sun::star::lang::IllegalArgumentException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Any SAL_CALL getPropertyValue( const ::rtl::OUString& PropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XPropertyChangeListener >& xListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XPropertyChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL addVetoableChangeListener( const ::rtl::OUString& PropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XVetoableChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL removeVetoableChangeListener( const ::rtl::OUString& PropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XVetoableChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );

	// XChartDocument
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getTitle()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getSubTitle()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getLegend()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getArea()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::chart::XDiagram > SAL_CALL getDiagram()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setDiagram( const com::sun::star::uno::Reference< com::sun::star::chart::XDiagram >& )
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::chart::XChartData > SAL_CALL getData()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL attachData( const com::sun::star::uno::Reference< com::sun::star::chart::XChartData >& )
		throw( com::sun::star::uno::RuntimeException );

	// XModel ( ::SfxBaseModel )
	virtual sal_Bool SAL_CALL attachResource(
		const ::rtl::OUString& aURL,
		const com::sun::star::uno::Sequence< com::sun::star::beans::PropertyValue >& aArgs )
		throw( com::sun::star::uno::RuntimeException);
    virtual ::rtl::OUString SAL_CALL getURL() throw( com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Sequence< com::sun::star::beans::PropertyValue > SAL_CALL getArgs()
		throw( com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL connectController(
		const com::sun::star::uno::Reference< com::sun::star::frame::XController >& xController )
		throw( com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL disconnectController(
		const com::sun::star::uno::Reference< com::sun::star::frame::XController >& xController )
		throw( com::sun::star::uno::RuntimeException);
	virtual void SAL_CALL lockControllers() throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL unlockControllers() throw( com::sun::star::uno::RuntimeException );
	virtual sal_Bool SAL_CALL hasControllersLocked() throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::frame::XController > SAL_CALL getCurrentController()
		throw( com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL setCurrentController(
		const com::sun::star::uno::Reference< com::sun::star::frame::XController >& xController )
		throw( com::sun::star::container::NoSuchElementException, com::sun::star::uno::RuntimeException);
    virtual com::sun::star::uno::Reference< com::sun::star::uno::XInterface > SAL_CALL getCurrentSelection()
		throw( com::sun::star::uno::RuntimeException);

	// XTypeProvider ( ::SfxBaseModel )
	virtual com::sun::star::uno::Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Sequence< sal_Int8 > SAL_CALL getImplementationId()
		throw( com::sun::star::uno::RuntimeException );

	// XComponent ( ::XModel ::SfxBaseModel )
	virtual void SAL_CALL dispose() throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL addEventListener(
		const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& xListener )
		throw( com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL removeEventListener(
		const com::sun::star::uno::Reference< com::sun::star::lang::XEventListener >& aListener )
		throw( com::sun::star::uno::RuntimeException );

	// XNumberFormatsSupplier
    virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getNumberFormatSettings()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::util::XNumberFormats > SAL_CALL getNumberFormats()
		throw( com::sun::star::uno::RuntimeException );

	// XServiceInfo
	virtual rtl::OUString SAL_CALL getImplementationName()
		throw( com::sun::star::uno::RuntimeException );
    virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName )
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Sequence< rtl::OUString > SAL_CALL getSupportedServiceNames()
		throw( com::sun::star::uno::RuntimeException );
};

