/*************************************************************************
 *
 *  $RCSfile: ChXDiagram.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CHART_DIAGRAM_HXX
#define _CHART_DIAGRAM_HXX

#include <cppuhelper/implbase10.hxx>	// helper for implementations

#ifndef _COM_SUN_STAR_CHART_XDIAGRAM_HPP_
#include <com/sun/star/chart/XDiagram.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISXSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisXSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISYSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisYSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISZSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisZSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XSTATISTICDISPLAY_HPP_
#include <com/sun/star/chart/XStatisticDisplay.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_X3DDISPLAY_HPP_
#include <com/sun/star/chart/X3DDisplay.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATE_HPP_
#include <com/sun/star/beans/XPropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XUNOTUNNEL_HPP_
#include <com/sun/star/lang/XUnoTunnel.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_INDEXOUTOFBOUNDSEXCEPTION_HPP_
#include <com/sun/star/lang/IndexOutOfBoundsException.hpp>
#endif

// header for SvxItemPropertySet
#ifndef SVX_UNOPROV_HXX
#include <svx/unoprov.hxx>
#endif

class SchChartDocShell;
class ChartModel;

class ChXDiagram : public cppu::WeakImplHelper10<
	com::sun::star::chart::XDiagram,
	com::sun::star::chart::XAxisZSupplier,
	com::sun::star::chart::XTwoAxisXSupplier,	//	: XAxisXSupplier
	com::sun::star::chart::XTwoAxisYSupplier,	//	: XAxisYSupplier
	com::sun::star::chart::XStatisticDisplay,
	com::sun::star::chart::X3DDisplay,
	com::sun::star::beans::XPropertySet,
	com::sun::star::beans::XPropertyState,
	com::sun::star::lang::XServiceInfo,
	com::sun::star::lang::XUnoTunnel >
{
private:
	::rtl::OUString maServiceName;
	ChartModel* mpModel;
	SvxItemPropertySet maPropSet;
	SfxItemPropertySet maSfxPropSet;

	com::sun::star::uno::Any GetAnyByItem( SfxItemSet& aSet, const SfxItemPropertyMap* pMap );

public:
	ChXDiagram( SchChartDocShell* pShell = NULL, sal_Bool bPreInit = sal_True );
	virtual ~ChXDiagram();

	void SetServiceName( const rtl::OUString& u ) throw()	{ maServiceName = u; }
	const rtl::OUString& getServiceName() throw()			{ return maServiceName; }
	sal_Bool SetDocShell( SchChartDocShell* pDocShell, sal_Bool bKeepModel = sal_False ) throw();
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > getObject(
		long nMapId, long nObjId, long nIndex1 = -1 ) throw();

	static const com::sun::star::uno::Sequence< sal_Int8 > & getUnoTunnelId() throw();
	static ChXDiagram* getImplementation( com::sun::star::uno::Reference< com::sun::star::uno::XInterface > ) throw();

	// XDiagram
	virtual ::rtl::OUString SAL_CALL getDiagramType() throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getDataRowProperties( sal_Int32 Row )
		throw( com::sun::star::uno::RuntimeException,
			   com::sun::star::lang::IndexOutOfBoundsException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getDataPointProperties( sal_Int32 Column, sal_Int32 Row )
		throw( com::sun::star::uno::RuntimeException,
			   com::sun::star::lang::IndexOutOfBoundsException );

	// XShape ( ::XDiagram )
	virtual com::sun::star::awt::Size SAL_CALL getSize()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setSize( const com::sun::star::awt::Size& )
		throw( com::sun::star::beans::PropertyVetoException,
		       com::sun::star::uno::RuntimeException );
	virtual com::sun::star::awt::Point SAL_CALL getPosition()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setPosition( const com::sun::star::awt::Point& )
		throw( com::sun::star::uno::RuntimeException );

	// XShapeDescriptor ( ::XShape ::XDiagram )
    virtual rtl::OUString SAL_CALL getShapeType() throw( com::sun::star::uno::RuntimeException );


	// XAxisXSupplier, XAxisYSupplier, XAxisZSupplier,
	// XTwoAxisXSupplier, XTwoAxisYSupplier
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getXAxisTitle()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getYAxisTitle()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::drawing::XShape > SAL_CALL getZAxisTitle()
		throw( com::sun::star::uno::RuntimeException );

	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getXAxis()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getYAxis()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getZAxis()
		throw( com::sun::star::uno::RuntimeException );

	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getSecondaryXAxis()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getSecondaryYAxis()
		throw( com::sun::star::uno::RuntimeException );

	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getXMainGrid()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getYMainGrid()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getZMainGrid()
		throw( com::sun::star::uno::RuntimeException );

	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getXHelpGrid()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getYHelpGrid()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getZHelpGrid()
		throw( com::sun::star::uno::RuntimeException );


	// XStatisticDisplay
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getMinMaxLine()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getUpBar()
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getDownBar()
		throw( com::sun::star::uno::RuntimeException );


	// X3DDisplay
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getWall()
		throw( com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySet > SAL_CALL getFloor()
		throw( com::sun::star::uno::RuntimeException );

	// XPropertySet
	virtual com::sun::star::uno::Reference< com::sun::star::beans::XPropertySetInfo > SAL_CALL getPropertySetInfo()
		throw( com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL setPropertyValue( const ::rtl::OUString& aPropertyName,
											const com::sun::star::uno::Any& aValue )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::beans::PropertyVetoException,
			   com::sun::star::lang::IllegalArgumentException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Any SAL_CALL getPropertyValue( const ::rtl::OUString& PropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XPropertyChangeListener >& xListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XPropertyChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL addVetoableChangeListener( const ::rtl::OUString& PropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XVetoableChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );
	virtual void SAL_CALL removeVetoableChangeListener( const ::rtl::OUString& PropertyName,
				const com::sun::star::uno::Reference< com::sun::star::beans::XVetoableChangeListener >& aListener )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );

	// XPropertyState
    virtual com::sun::star::beans::PropertyState SAL_CALL getPropertyState( const ::rtl::OUString& PropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyState > SAL_CALL getPropertyStates(
		const com::sun::star::uno::Sequence< ::rtl::OUString >& aPropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::uno::RuntimeException );
    virtual void SAL_CALL setPropertyToDefault( const ::rtl::OUString& PropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::uno::RuntimeException );
    virtual com::sun::star::uno::Any SAL_CALL getPropertyDefault( const ::rtl::OUString& aPropertyName )
		throw( com::sun::star::beans::UnknownPropertyException,
			   com::sun::star::lang::WrappedTargetException,
			   com::sun::star::uno::RuntimeException );

	// XServiceInfo
	// supportsService is handled by SvxServiceInfoHelper
	virtual ::rtl::OUString SAL_CALL getImplementationName()
		throw( com::sun::star::uno::RuntimeException );
    virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName )
		throw( com::sun::star::uno::RuntimeException );
	virtual com::sun::star::uno::Sequence< rtl::OUString > SAL_CALL getSupportedServiceNames()
		throw( com::sun::star::uno::RuntimeException );


	// XUnoTunnel
    virtual sal_Int64 SAL_CALL getSomething( const com::sun::star::uno::Sequence< sal_Int8 >& aIdentifier )
		throw( com::sun::star::uno::RuntimeException );
};

#endif	// _CHART_DIAGRAM_HXX

