/*************************************************************************
 *
 *  $RCSfile: dragserv.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_DRAGSERVER_HXX
#define _SCH_DRAGSERVER_HXX
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------

#ifndef _EMBOBJ_HXX
#include <so3/embobj.hxx>
#endif

#ifndef _SV_VIRDEV_HXX //autog
#include <vcl/virdev.hxx>
#endif
#ifndef _GEN_HXX //autogen
#include <tools/gen.hxx>
#endif
#ifndef _DTRANS_HXX //autogen
#include <so3/dtrans.hxx>
#endif


class SchView;
class ChartModel;
class SvObjectDescriptor;
class Graphic;

/*************************************************************************
|*
|* StarChart-DragServer
|*
\************************************************************************/
class SchDragServer : public SvDataMemberObject
{
	SvDataTypeList		aTypeList;
	SvEmbeddedObjectRef aDocShellRef;
	SvObjectDescriptor*	pObjectDescriptor;
	SchView*			pSchViewIntern;
	ChartModel*	pChartModelIntern;
	VirtualDevice*		pVDev;
	Graphic*			pGraphic;
	BOOL				bOwnView;
	BOOL				bOwnDocument;
	BOOL				bHoleDocument;

 public:
	SchDragServer(SchView* pView);
	SchDragServer(ChartModel* pModel, BOOL bHoleDocument = FALSE );
	~SchDragServer();

	BOOL				bInternalMove;
	Point				aStartPos;
	SchView*			pSchView;
	ChartModel*	pChartModel;

	virtual BOOL GetData(SvData*);
	virtual BOOL GetDataHere(SvData*);
	virtual const SvDataTypeList& GetTypeList() const;

	void SetObjectDescriptor(SvObjectDescriptor* pObjDescr);
};

SO2_DECL_IMPL_REF (SchDragServer)


#endif		// _SCH_DRAGSERVER_HXX

