/*************************************************************************
 *
 *  $RCSfile: tpscaley.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_TPSCALEY_HXX_
#define _SCH_TPSCALEY_HXX_

// header for SfxTabPage
#ifndef _SFXTABDLG_HXX
#include <sfx2/tabdlg.hxx>
#endif
// header for GroupBox
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
// header for FixedText
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
// header for Edit
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
// header for CheckBox
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
// header for MetricField
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
// header for class FormattedField
#ifndef _FMTFIELD_HXX_
#include <svtools/fmtfield.hxx>
#endif

class ChartModel;
class SvNumberFormatter;

class SchScaleYAxisTabPage : public SfxTabPage
{
private:
	ChartModel          *pMyModel;

	GroupBox			aGrpScale;
	FixedText			aTxtMin;
	FormattedField		aFmtFldMin;
	CheckBox			aCbxAutoMin;
	FixedText			aTxtMax;
	FormattedField		aFmtFldMax;
	CheckBox			aCbxAutoMax;
	FixedText           aTxtMain;
	FormattedField		aFmtFldStepMain;
	CheckBox			aCbxAutoStepMain;
	FixedText           aTxtHelp;
	FormattedField		aFmtFldStepHelp;
	MetricField         aMtStepHelp;
	CheckBox			aCbxAutoStepHelp;
	FixedText           aTxtOrigin;
	FormattedField		aFmtFldOrigin;
	CheckBox			aCbxAutoOrigin;
	CheckBox			aCbxLogarithm;

	GroupBox aGrpTicks;
	CheckBox aCbxTicksInner;
	CheckBox aCbxTicksOuter;

	GroupBox aGrpHelpTicks;
	CheckBox aCbxHelpTicksInner;
	CheckBox aCbxHelpTicksOuter;

	double				fMin;
	double				fMax;
	double				fStepMain;
	double				fStepHelp;
	double				fOrigin;
	int                 nAxisType;
	const SfxItemSet&	rOutAttrs;
	SvNumberFormatter*	pNumFormatter;

	BOOL				bLastStepMain;

	void CheckLogs ();
	void CheckLogControls ();

	BOOL GetHelpValue ();

	DECL_LINK( EnableValueHdl, CheckBox* );
	DECL_LINK( HandleLogs, CheckBox * );

public:
	SchScaleYAxisTabPage( Window* pParent, const SfxItemSet& rInAttrs );

	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rInAttrs );
	virtual BOOL FillItemSet( SfxItemSet& rOutAttrs );
	virtual void Reset( const SfxItemSet& rInAttrs );
	virtual int DeactivatePage( SfxItemSet* pItemSet = NULL );

	void SetNumFormatter( SvNumberFormatter* pFormatter );
	void SetNumFormat();

	void SetModel( ChartModel *pModel )						{ pMyModel = pModel; }
};

#endif // _SCH_TPSCALEY_HXX_

