/*************************************************************************
 *
 *  $RCSfile: ChXDiagram.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// header for class OGuard
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
// header for class Application
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#include "schattr.hxx"
// header for SvxChartDataDescrItem
#ifndef _SVX_CHRTITEM_HXX
#define ITEMID_CHARTDATADESCR   SCHATTR_DATADESCR_DESCR
#include <svx/chrtitem.hxx>
#endif

#include "ChXDiagram.hxx"
#include "ChXChartObject.hxx"
#include "ChXChartAxis.hxx"
#include "ChXDataRow.hxx"
#include "ChXDataPoint.hxx"

#include "mapprov.hxx"

#include "docshell.hxx"
#include "chtmodel.hxx"
#include "globfunc.hxx"			// for GlobalGenerate3DAttrDefaultItem
#include "schattr.hxx"
#include "charttyp.hxx"
#include "datarow.hxx"
#include "datapoin.hxx"

#ifndef _SVX_UNOSHAPE_HXX
#include <svx/unoshape.hxx>
#endif
// for OWN_ATTR_...
#ifndef _SVX_UNOSHPRP_HXX
#include <svx/unoshprp.hxx>
#endif
// for SID_ATTR_...
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>
#endif
#ifndef _RTL_UUID_H_
#include <rtl/uuid.h>
#endif
#ifndef _RTL_MEMORY_H_
#include <rtl/memory.h>
#endif
// header for any2enum
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif

#ifndef _COM_SUN_STAR_CHART_CHARTDATAROWSOURCE_HPP_
#include <com/sun/star/chart/ChartDataRowSource.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTERRORCATEGORY_HPP_
#include <com/sun/star/chart/ChartErrorCategory.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTERRORINDICATORTYPE_HPP_
#include <com/sun/star/chart/ChartErrorIndicatorType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTREGRESSIONCURVETYPE_HPP_
#include <com/sun/star/chart/ChartRegressionCurveType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATACAPTION_HPP_
#include <com/sun/star/chart/ChartDataCaption.hpp>
#endif


using namespace vos;
using namespace com::sun::star;

extern SchUnoPropertyMapProvider aSchMapProvider;


ChXDiagram::ChXDiagram( SchChartDocShell* pDocShell, sal_Bool bPreInit ) :
		mpModel( NULL ),
		maPropSet( aSchMapProvider.GetMap( CHMAP_CHART, NULL )),
		maSfxPropSet( aSchMapProvider.GetMap( CHMAP_CHART, NULL ))
{
	if( bPreInit )
	{
		DBG_ASSERT( pDocShell, "Cannot do PreInit when using invalid DocShell." );
		SetDocShell( pDocShell );
	}

}

ChXDiagram::~ChXDiagram() {}

// bKeepModel = sal_True => try to keep model. If model is invalid take the one from DocShell
sal_Bool ChXDiagram::SetDocShell( SchChartDocShell* pDocShell, sal_Bool bKeepModel ) throw()
{
	OGuard aGuard( Application::GetSolarMutex() );
	sal_Bool bModelKept = sal_False;

	if( pDocShell )
	{
		if( bKeepModel && mpModel )
		{
			// copy current model
			ChartModel* pModel = SAL_STATIC_CAST( ChartModel*, mpModel->AllocModel());
			if( pModel )
			{
				pDocShell->SetModelPtr( pModel );
				DBG_ASSERT( pModel->SetObjectShell( pDocShell ), "Couldn't set docshell" );

				delete mpModel;
				mpModel = pModel;
				bModelKept = sal_True;
			}
		}
		else
		{
			// use model of new DocShell
			mpModel = pDocShell->GetModelPtr();
			if( ! bKeepModel && mpModel )
			{
				maPropSet = SvxItemPropertySet( aSchMapProvider.GetMap( CHMAP_CHART, mpModel ));
				maServiceName = getDiagramType();
			}
		}
	}
	else
		mpModel = NULL;

	return bModelKept;
}

uno::Reference< beans::XPropertySet > ChXDiagram::getObject( long nMapId, long nObjId, long nIndex1 ) throw()
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		ChXChartObject* pSet;
		switch( nObjId )
		{
			case CHOBJID_DIAGRAM_X_AXIS:
			case CHOBJID_DIAGRAM_Y_AXIS:
			case CHOBJID_DIAGRAM_Z_AXIS:
			case CHOBJID_DIAGRAM_A_AXIS:
			case CHOBJID_DIAGRAM_B_AXIS:
				pSet = new ChXChartAxis( mpModel, nObjId );
				break;

//			case CHOBJID_DIAGRAM_WALL:
//				{
//					uno::Reference< beans::XPropertySet > xProp(
//						SAL_STATIC_CAST( drawing::XShape*, mpModel->GetShape( nObjId )),
//						uno::UNO_QUERY );
//					return xProp;
//				}

			default:
				pSet = new ChXChartObject( nMapId, mpModel, nObjId );
				break;
		}
		uno::Reference< beans::XPropertySet > xRef( SAL_STATIC_CAST( beans::XPropertySet*, pSet ) );
		return xRef;
	}
	else
	{
		return uno::Reference< beans::XPropertySet >();		// empty reference
	}
}

// generate a uniqueId
const uno::Sequence< sal_Int8 > & ChXDiagram::getUnoTunnelId() throw()
{
	static uno::Sequence< sal_Int8 > * pSeq = 0;
	if( !pSeq )
	{
		osl::Guard< osl::Mutex > aGuard( osl::Mutex::getGlobalMutex() );
		if( !pSeq )
		{
			static uno::Sequence< sal_Int8 > aSeq( 16 );
			rtl_createUuid( (sal_uInt8*)aSeq.getArray(), 0, sal_True );
			pSeq = &aSeq;
		}
	}
	return *pSeq;
}

ChXDiagram* ChXDiagram::getImplementation( uno::Reference< uno::XInterface > xData ) throw()
{
	uno::Reference< lang::XUnoTunnel > xUT( xData, uno::UNO_QUERY );
	if( xUT.is() )
		return (ChXDiagram*)xUT->getSomething( ChXDiagram::getUnoTunnelId() );
	else
		return NULL;
}

uno::Any ChXDiagram::GetAnyByItem( SfxItemSet& aSet, const SfxItemPropertyMap* pMap )
{
	DBG_ASSERT( pMap, "GetAnyByItem: invalid Map!" );
	DBG_ASSERT( mpModel, "GetAnyByItem: invalid Model!" );

	uno::Any aAny;

	switch( pMap->nWID )
	{
		case CHATTR_DATA_SWITCH:	// BM: SwitchData is enum now
			{
				sal_Bool bIsOn = SAL_STATIC_CAST( const SfxBoolItem&, aSet.Get( CHATTR_DATA_SWITCH ) ).GetValue();
				chart::ChartDataRowSource eRowSource =
					bIsOn ? chart::ChartDataRowSource_COLUMNS : chart::ChartDataRowSource_ROWS;
				aAny <<= eRowSource;
			}
			break;

		case SCHATTR_STYLE_SHAPE:
			aAny <<= SAL_STATIC_CAST( sal_Int32, mpModel->GetChartShapeType() );
			break;

		case SCHATTR_DATADESCR_DESCR:
			{
				BOOL bShowSymbol = ((const SfxBoolItem&)
									(aSet.Get(SCHATTR_DATADESCR_SHOW_SYM))).GetValue();
				SvxChartDataDescr eDescr = ((const SvxChartDataDescrItem&)
											(aSet.Get(SCHATTR_DATADESCR_DESCR))).GetValue();

				sal_Int32 nVal = 0;
				switch( eDescr )
				{
					case CHDESCR_NONE:
						nVal = chart::ChartDataCaption::NONE;
						break;
					case CHDESCR_VALUE:
						nVal = chart::ChartDataCaption::VALUE;
						break;
					case CHDESCR_PERCENT:
						nVal = chart::ChartDataCaption::PERCENT;
						break;
					case CHDESCR_TEXT:
						nVal = chart::ChartDataCaption::TEXT;
						break;
					case CHDESCR_TEXTANDPERCENT:
						nVal = chart::ChartDataCaption::PERCENT | chart::ChartDataCaption::TEXT;
						break;
					case CHDESCR_TEXTANDVALUE:
						nVal = chart::ChartDataCaption::VALUE | chart::ChartDataCaption::TEXT;
				}
				if( bShowSymbol ) nVal |= chart::ChartDataCaption::SYMBOL;

				aAny <<= nVal;
			}
			break;

		default:
			aAny = maPropSet.getPropertyValue( pMap, aSet );
	}
	return aAny;
}

// XDiagram
::rtl::OUString SAL_CALL ChXDiagram::getDiagramType() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		long nType = mpModel->GetBaseType();
		switch( nType )
		{
			case CHTYPE_LINE:
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_LINE ));
			case CHTYPE_AREA:
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_AREA ));
			case CHTYPE_DONUT :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_DONUT ));
			case CHTYPE_COLUMN:		// is also treated as (vertical) bar chart
			case CHTYPE_BAR :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_BAR ));
			case CHTYPE_CIRCLE :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_PIE ));
			case CHTYPE_XY :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_XY ));
			case CHTYPE_NET :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_NET ));
			case CHTYPE_STOCK :
				return ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( SCH_X_STR_CHTYPE_NAMESPACE SCH_X_STR_CHTYPE_STOCK ));
		}
	}
	else
	{
		DBG_ERROR( "No Model" );
	}
	return SCH_ASCII_TO_OU( "UnknownChartType" );
}

uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getDataRowProperties( sal_Int32 Row )
	throw( uno::RuntimeException, lang::IndexOutOfBoundsException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		if( Row >= 0 &&
			Row < mpModel->GetRowCount() )
		{
			ChXDataRow* pRet = new ChXDataRow( Row, mpModel );
			return uno::Reference< beans::XPropertySet >( SAL_STATIC_CAST( beans::XPropertySet*, pRet ));
		}
		else
		{
			throw lang::IndexOutOfBoundsException();
		}
	}
	else
	{
		DBG_ERROR( "No Model" );
	}

	return uno::Reference< beans::XPropertySet >();
}

uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getDataPointProperties( sal_Int32 Column, sal_Int32 Row )
	throw( uno::RuntimeException, lang::IndexOutOfBoundsException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		if( Row >= 0 && Column >= 0 &&
			(Row < mpModel->GetRowCount()) &&
			(Column < mpModel->GetColCount()) )
		{
			ChXDataPoint* pRet = new ChXDataPoint( Column, Row, mpModel );
			return uno::Reference< beans::XPropertySet >( SAL_STATIC_CAST( beans::XPropertySet*, pRet ));
		}
		else
		{
			throw lang::IndexOutOfBoundsException();
		}
	}
	else
	{
		DBG_ERROR( "No Model" );
	}

	return uno::Reference< beans::XPropertySet >();
}

// XShape ( ::XDiagram)
awt::Size SAL_CALL ChXDiagram::getSize() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		Size aSize = mpModel->GetChartRect().GetSize();
		return awt::Size( aSize.Width(), aSize.Height() );
	}
	else
		return awt::Size( 0, 0 );
}

void SAL_CALL ChXDiagram::setSize( const awt::Size& aSize )
	throw( uno::RuntimeException,
		   beans::PropertyVetoException )
{
	OGuard aGuard( Application::GetSolarMutex() );
	if( mpModel )
	{
		mpModel->SetUseRelativePositions( TRUE );
		mpModel->SetDiagramHasBeenMovedOrResized( TRUE );
		Rectangle aRect = mpModel->GetChartRect();
		aRect.SetSize( Size( aSize.Width, aSize.Height ) );
		mpModel->SetChartRect( aRect );
		mpModel->BuildChart( FALSE );
	}
	else
	{
		DBG_ERROR( "No Model" );
	}
}

awt::Point SAL_CALL ChXDiagram::getPosition() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );
	if( mpModel )
	{
		Point aPoint = mpModel->GetChartRect().TopLeft();
		return awt::Point( aPoint.X(), aPoint.Y() );
	}
	else
	{
		DBG_ERROR( "No Model" );
	}
	return awt::Point( 0, 0 );
}

void SAL_CALL ChXDiagram::setPosition( const awt::Point& aPosition ) throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		mpModel->SetDiagramHasBeenMovedOrResized( TRUE );
		mpModel->SetUseRelativePositions ( TRUE );
		Rectangle aRect=mpModel->GetChartRect();
		aRect.SetPos( Point( aPosition.X, aPosition.Y ) );
		mpModel->SetChartRect( aRect );
		mpModel->BuildChart( FALSE );
	}
	else
	{
		DBG_ERROR( "No Model" );
	}
}

// XShapeDescriptor ( ::XShape ::XDiagram )
::rtl::OUString SAL_CALL ChXDiagram::getShapeType() throw( uno::RuntimeException )
{
	return SCH_ASCII_TO_OU( "com.sun.star.chart.Diagram" );
}

// XAxisXSupplier, XAxisYSupplier, XAxisZSupplier,
// XTwoAxisXSupplier, XTwoAxisYSupplier
uno::Reference< drawing::XShape > SAL_CALL ChXDiagram::getXAxisTitle()
	throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
		return uno::Reference< drawing::XShape > (
			SAL_STATIC_CAST( drawing::XShape*, mpModel->GetShape( CHOBJID_DIAGRAM_TITLE_X_AXIS )));
	else
	{
		DBG_ERROR( "No Model" );
	}
	return 	uno::Reference< drawing::XShape >();
}

uno::Reference< drawing::XShape > SAL_CALL ChXDiagram::getYAxisTitle()
	throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
		return uno::Reference< drawing::XShape > (
			SAL_STATIC_CAST( drawing::XShape*, mpModel->GetShape( CHOBJID_DIAGRAM_TITLE_Y_AXIS )));
	else
	{
		DBG_ERROR( "No Model" );
	}
	return 	uno::Reference< drawing::XShape >();
}

uno::Reference< drawing::XShape > SAL_CALL ChXDiagram::getZAxisTitle()
	throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
		return uno::Reference< drawing::XShape > (
			SAL_STATIC_CAST( drawing::XShape*, mpModel->GetShape( CHOBJID_DIAGRAM_TITLE_Z_AXIS )));
	else
	{
		DBG_ERROR( "No Model" );
	}
	return 	uno::Reference< drawing::XShape >();
}

uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getXAxis() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AXIS, CHOBJID_DIAGRAM_X_AXIS );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getYAxis() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AXIS, CHOBJID_DIAGRAM_Y_AXIS );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getZAxis() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AXIS, CHOBJID_DIAGRAM_Z_AXIS );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getSecondaryXAxis() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AXIS,CHOBJID_DIAGRAM_A_AXIS );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getSecondaryYAxis() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AXIS,CHOBJID_DIAGRAM_B_AXIS );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getXMainGrid() throw( com::sun::star::uno::RuntimeException )
{
	// attention: x and y grids are interchanged
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_Y_GRID_MAIN_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getYMainGrid() throw( com::sun::star::uno::RuntimeException )
{
	// attention: x and y grids are interchanged
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_X_GRID_MAIN_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getZMainGrid() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_Z_GRID_MAIN_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getXHelpGrid() throw( com::sun::star::uno::RuntimeException )
{
	// attention: x and y grids are interchanged
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_Y_GRID_HELP_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getYHelpGrid() throw( com::sun::star::uno::RuntimeException )
{
	// attention: x and y grids are interchanged
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_X_GRID_HELP_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getZHelpGrid() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_Z_GRID_HELP_GROUP );
}

// XStatisticDisplay
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getMinMaxLine() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_LINE, CHOBJID_DIAGRAM_STOCKLINE_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getUpBar() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AREA, CHOBJID_DIAGRAM_STOCKPLUS_GROUP );
}
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getDownBar() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AREA, CHOBJID_DIAGRAM_STOCKLOSS_GROUP );
}

// X3DDisplay
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getFloor() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AREA, CHOBJID_DIAGRAM_FLOOR );
}
// note: this method is also valid for 2d charts
uno::Reference< beans::XPropertySet > SAL_CALL ChXDiagram::getWall() throw( com::sun::star::uno::RuntimeException )
{
	return getObject( CHMAP_AREA, CHOBJID_DIAGRAM_WALL );
}


// XPropertySet
uno::Reference< beans::XPropertySetInfo > SAL_CALL ChXDiagram::getPropertySetInfo() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );
	return maPropSet.getPropertySetInfo();
}

void SAL_CALL ChXDiagram::setPropertyValue( const ::rtl::OUString& aPropertyName, const uno::Any& aValue )
		throw( beans::UnknownPropertyException,
			   beans::PropertyVetoException,
			   lang::IllegalArgumentException,
			   lang::WrappedTargetException,
			   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( mpModel )
	{
		const SfxItemPropertyMap* pMap = maPropSet.getPropertyMapEntry( aPropertyName );

		if( pMap && pMap->nWID )
		{
			long nWID = pMap->nWID;

			SfxItemSet* pSet;
			switch( nWID )
			{
				case SCHATTR_DATADESCR_DESCR:
				case SCHATTR_DATADESCR_SHOW_SYM:
					// the Property DataCaption needs two Which Ids
					pSet = new SfxItemSet( mpModel->GetItemPool(),
										   SCHATTR_DATADESCR_DESCR, SCHATTR_DATADESCR_DESCR,
										   SCHATTR_DATADESCR_SHOW_SYM, SCHATTR_DATADESCR_SHOW_SYM, 0 );
					break;

				case CHATTR_NUM_OF_LINES_FOR_BAR:
					{
						sal_Int32 nVal;
						aValue >>= nVal;
						if( mpModel->GetBaseType() == CHTYPE_COLUMN )
							mpModel->SetNumLinesColChart( nVal, TRUE );
						mpModel->BuildChart( FALSE );
						return;									// RETURN
					}

				default:
					pSet = new SfxItemSet( mpModel->GetPool(), nWID, nWID );
			}

			// fill item: (should be optimized)
			ChartType aType( mpModel );
			aType.GetAttrSet( pSet );
			mpModel->GetAttr( *pSet );

			if( !pSet->Count() )
			{
				// get default from ItemPool
				if( mpModel->GetItemPool().IsWhich( nWID ) )
				{
					pSet->Put( mpModel->GetItemPool().GetDefaultItem( pMap->nWID ) );
				}
				else
				{
#ifdef DBG_UTIL
					String aTmpString( aPropertyName );
					ByteString aProp( aTmpString, RTL_TEXTENCODING_ASCII_US );
					DBG_ERROR2( "Diagram: Property %s has an invalid ID (%d)", aProp.GetBuffer(), nWID );
#endif
				}
			}

			if( pSet->Count() )
			{
				switch( nWID )
				{
					case SCHATTR_STAT_KIND_ERROR:
						{
							chart::ChartErrorCategory eCat;
							cppu::any2enum< chart::ChartErrorCategory >( eCat, aValue );
							pSet->Put( SfxInt32Item( nWID, SAL_STATIC_CAST( sal_Int32, eCat )));
							break;
						}
					case SCHATTR_STAT_INDICATE:
						{
							chart::ChartErrorIndicatorType eInd;
							cppu::any2enum< chart::ChartErrorIndicatorType >( eInd, aValue );
							pSet->Put( SfxInt32Item( nWID, SAL_STATIC_CAST( sal_Int32, eInd )));
							break;
						}
					case SCHATTR_STAT_REGRESSTYPE:
						{
							chart::ChartRegressionCurveType eRegType;
							cppu::any2enum< chart::ChartRegressionCurveType >( eRegType, aValue );
							pSet->Put( SfxInt32Item( nWID, SAL_STATIC_CAST( sal_Int32, eRegType )));
							break;
						}
					case CHATTR_DATA_SWITCH:
						{
							chart::ChartDataRowSource eRowSource;
							cppu::any2enum< chart::ChartDataRowSource >( eRowSource, aValue );
							pSet->Put( SfxBoolItem( nWID, (eRowSource == chart::ChartDataRowSource_COLUMNS)) );
							break;
						}
					case SCHATTR_DATADESCR_DESCR:
						{
							// symbol
							sal_Int32 nVal;
							aValue >>= nVal;
							pSet->Put( SfxBoolItem( SCHATTR_DATADESCR_SHOW_SYM,
													(nVal & chart::ChartDataCaption::SYMBOL)) );

							// display text, percent or both or value
							SvxChartDataDescr eDescr = CHDESCR_NONE;
							if( nVal & chart::ChartDataCaption::TEXT )
							{
								if( nVal & chart::ChartDataCaption::PERCENT )
									eDescr = CHDESCR_TEXTANDPERCENT;
								else if( (nVal & chart::ChartDataCaption::VALUE) )
									eDescr = CHDESCR_TEXTANDVALUE;
								else
									eDescr = CHDESCR_TEXT;
							}
							else if( (nVal & chart::ChartDataCaption::VALUE) )
							{
								eDescr = CHDESCR_VALUE;
							}
							else
							{
								if( (nVal & chart::ChartDataCaption::PERCENT) )
									eDescr = CHDESCR_PERCENT;
							}

							// chart::ChartDataCaption::FORMAT (missing)

							pSet->Put( SvxChartDataDescrItem( eDescr ) );
						}
						break;

					default:
						maPropSet.setPropertyValue( pMap, aValue, *pSet );
						break;
				}
				aType.SetType( pSet );
				mpModel->PutAttr( *pSet );

				if( mpModel->ChangeChart( aType.GetChartStyle()) )
				{
					mpModel->BuildChart( FALSE );
				}
				else if( ! mpModel->ChangeStatistics ( *pSet ) )
				{
					mpModel->BuildChart( FALSE );
				}
			}
			else
			{
				throw beans::UnknownPropertyException();
			}
			delete pSet;
		}
		else
		{
			throw beans::UnknownPropertyException();
		}
	}
	else
	{
		DBG_WARNING( "No Model" );
	}
}

uno::Any SAL_CALL ChXDiagram::getPropertyValue( const ::rtl::OUString& PropertyName )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	uno::Any aAny;

	if( mpModel )
	{
		const SfxItemPropertyMap* pMap = maPropSet.getPropertyMapEntry( PropertyName );

		if( pMap && pMap->nWID )
		{
			long nWID = pMap->nWID;
			SfxItemSet* pSet;

			switch( nWID )
			{
				case CHATTR_NUM_OF_LINES_FOR_BAR:
					aAny <<= SAL_STATIC_CAST( sal_Int32, mpModel->GetNumLinesColChart() );
					return aAny;			  // RETURN

				case SCHATTR_DATADESCR_DESCR:
					pSet = new SfxItemSet( mpModel->GetItemPool(),
										   SCHATTR_DATADESCR_DESCR, SCHATTR_DATADESCR_DESCR,
										   SCHATTR_DATADESCR_SHOW_SYM, SCHATTR_DATADESCR_SHOW_SYM, 0 );
					break;

				default:
					pSet = new SfxItemSet( mpModel->GetItemPool(), nWID, nWID );
			}

			// set attributes
			ChartType aType( mpModel );
			aType.GetAttrSet( pSet );
			mpModel->GetAttr( *pSet );	// copy SHOW_HIDE_PROPERTIES into ItemSet

			if( ! pSet->Count() )
			{
				// get default from ItemPool
				if( SID_ATTR_3D_START <= nWID && nWID <= SID_ATTR_3D_END )
				{
					GlobalGenerate3DAttrDefaultItem( nWID, *pSet );
				}
				else if( mpModel->GetItemPool().IsWhich( nWID ) )
				{
					if( ! ( OWN_ATTR_VALUE_START <= nWID && nWID <= OWN_ATTR_VALUE_END ))	// properties from SvxShape
					{
						pSet->Put( mpModel->GetItemPool().GetDefaultItem( nWID ) );
					}
				}
				else
				{
#ifdef DBG_UTIL
					String aTmpString( PropertyName );
					ByteString aProp( aTmpString, RTL_TEXTENCODING_ASCII_US );
					DBG_ERROR2( "Diagram: Property %s has an invalid ID (%d)", aProp.GetBuffer(), nWID );
#endif
				}
			}

			if( pSet->Count() )
			{
				aAny = GetAnyByItem( *pSet, pMap );
			}
			else
				throw beans::UnknownPropertyException();

			delete pSet;
		}
		else
			throw beans::UnknownPropertyException();
	}
	else
	{
		DBG_ERROR( "No Model" );
	}
	return aAny;
}

void SAL_CALL ChXDiagram::addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
													 const uno::Reference< beans::XPropertyChangeListener >& xListener )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{}

void SAL_CALL ChXDiagram::removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
														const uno::Reference< beans::XPropertyChangeListener >& aListener )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{}

void SAL_CALL ChXDiagram::addVetoableChangeListener( const ::rtl::OUString& PropertyName,
													 const uno::Reference< beans::XVetoableChangeListener >& aListener )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{}

void SAL_CALL ChXDiagram::removeVetoableChangeListener( const ::rtl::OUString& PropertyName,
														const uno::Reference< beans::XVetoableChangeListener >& aListener )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{}

// XPropertyState
beans::PropertyState SAL_CALL ChXDiagram::getPropertyState( const ::rtl::OUString& PropertyName )
	throw( beans::UnknownPropertyException, uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	const SfxItemPropertyMap* pMap = maPropSet.getPropertyMapEntry( PropertyName );

	if( mpModel &&
		pMap && pMap->nWID )
	{
		if( pMap->nWID != CHATTR_NUM_OF_LINES_FOR_BAR &&
			pMap->nWID != SCHATTR_STYLE_SHAPE &&
			pMap->nWID != SCHATTR_DATADESCR_DESCR )
		{
			SfxItemSet aSet( mpModel->GetItemPool(), pMap->nWID, pMap->nWID );
			ChartType aType( mpModel );
			aType.GetAttrSet( &aSet );
			mpModel->GetAttr( aSet );

			return maSfxPropSet.getPropertyState( PropertyName, aSet );
		}
	}

	return beans::PropertyState_DIRECT_VALUE;
}

uno::Sequence< beans::PropertyState > SAL_CALL ChXDiagram::getPropertyStates(
		const uno::Sequence< ::rtl::OUString >& aPropertyName )
		throw( beans::UnknownPropertyException,
			   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	const sal_Int32 nCount = aPropertyName.getLength();
	const rtl::OUString* pNames = aPropertyName.getConstArray();

	uno::Sequence< beans::PropertyState > aRet( nCount );
	beans::PropertyState* pState = aRet.getArray();

	for( sal_Int32 nIdx = 0; nIdx < nCount; nIdx++ )
		pState[ nIdx ] = getPropertyState( pNames[ nIdx ] );

	return aRet;
}

void SAL_CALL ChXDiagram::setPropertyToDefault( const ::rtl::OUString& PropertyName )
		throw( beans::UnknownPropertyException,
			   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	const SfxItemPropertyMap* pMap = maPropSet.getPropertyMapEntry( PropertyName );

	if( pMap && pMap->nWID &&
		( pMap->nWID == CHATTR_NUM_OF_LINES_FOR_BAR ||
		  pMap->nWID == SCHATTR_STYLE_SHAPE ||
		  pMap->nWID == SCHATTR_DATADESCR_DESCR ))
	{
		return;
	}

	if( mpModel )
	{
		SfxItemSet aSet( mpModel->GetItemPool(), pMap->nWID, pMap->nWID );
		ChartType aType( mpModel );
		aType.GetAttrSet( &aSet );
		mpModel->GetAttr( aSet );

		aSet.ClearItem( pMap->nWID );

		aType.SetType( &aSet );
		mpModel->PutAttr( aSet );

		if( mpModel->ChangeChart( aType.GetChartStyle()) )
		{
			mpModel->BuildChart( FALSE );
		}
		else if( ! mpModel->ChangeStatistics ( aSet ) )
		{
			mpModel->BuildChart( FALSE );
		}
	}
}

uno::Any SAL_CALL ChXDiagram::getPropertyDefault( const ::rtl::OUString& aPropertyName )
		throw( beans::UnknownPropertyException,
			   lang::WrappedTargetException,
			   uno::RuntimeException )
{
	const SfxItemPropertyMap* pMap = maPropSet.getPropertyMapEntry( aPropertyName );

	if( pMap && pMap->nWID &&
		( pMap->nWID == CHATTR_NUM_OF_LINES_FOR_BAR ||
		  pMap->nWID == SCHATTR_STYLE_SHAPE ||
		  pMap->nWID == SCHATTR_DATADESCR_DESCR ))
	{
		return getPropertyValue( aPropertyName );
	}

	if( ! mpModel->GetItemPool().IsWhich( pMap->nWID ))
		throw beans::UnknownPropertyException();

	SfxItemSet aSet( mpModel->GetItemPool(), pMap->nWID, pMap->nWID );
	aSet.Put( mpModel->GetItemPool().GetDefaultItem( pMap->nWID ));

	return GetAnyByItem( aSet, pMap );
}

// XServiceInfo
rtl::OUString SAL_CALL ChXDiagram::getImplementationName() throw( uno::RuntimeException )
{
	return SCH_ASCII_TO_OU( "ChXDiagram" );
}

sal_Bool SAL_CALL ChXDiagram::supportsService( const ::rtl::OUString& ServiceName )
	throw( uno::RuntimeException )
{
	return SvxServiceInfoHelper::supportsService( ServiceName, getSupportedServiceNames() );
}

uno::Sequence< rtl::OUString > SAL_CALL ChXDiagram::getSupportedServiceNames() throw( uno::RuntimeException )
{
	uno::Sequence< rtl::OUString > aSeq;
	SvxServiceInfoHelper::addToSequence(
		aSeq, 2,
		"com.sun.star.chart.Diagram",
		"com.sun.star.drawing.ShapeDescriptor" );
	if( mpModel )
	{
		long nType = mpModel->GetBaseType();
		switch( nType )
		{
			case CHTYPE_LINE:
				SvxServiceInfoHelper::addToSequence(
					aSeq, 7,
					"com.sun.star.chart.LineDiagram",
					"com.sun.star.chart.ChartAxisXSupplier",
					"com.sun.star.chart.ChartTwoAxisXSupplier",
					"com.sun.star.chart.ChartAxisYSupplier",
					"com.sun.star.chart.ChartTwoAxisYSupplier",
					"com.sun.star.chart.StackableDiagram",
					"com.sun.star.chart.Dim3DDiagram" );
				if( mpModel->Is3DChart() )
					SvxServiceInfoHelper::addToSequence( aSeq, 1, "com.sun.star.chart.ChartAxisZSupplier" );
				break;
			case CHTYPE_AREA:
				SvxServiceInfoHelper::addToSequence(
					aSeq, 7,
					"com.sun.star.chart.AreaDiagram",
					"com.sun.star.chart.ChartAxisXSupplier",
					"com.sun.star.chart.ChartTwoAxisXSupplier",
					"com.sun.star.chart.ChartAxisYSupplier",
					"com.sun.star.chart.ChartTwoAxisYSupplier",
					"com.sun.star.chart.StackableDiagram",
					"com.sun.star.chart.Dim3DDiagram" );
			if( mpModel->Is3DChart() )
				SvxServiceInfoHelper::addToSequence( aSeq, 1, "com.sun.star.chart.ChartAxisZSupplier" );
			break;
			case CHTYPE_DONUT :
				SvxServiceInfoHelper::addToSequence( aSeq, 1, "com.sun.star.chart.DonutDiagram" );
				break;
			case CHTYPE_COLUMN : // also treated as bar chart
			case CHTYPE_BAR :
				SvxServiceInfoHelper::addToSequence(
					aSeq, 7,
					"com.sun.star.chart.BarDiagram",
					"com.sun.star.chart.ChartAxisXSupplier",
					"com.sun.star.chart.ChartTwoAxisXSupplier",
					"com.sun.star.chart.ChartAxisYSupplier",
					"com.sun.star.chart.ChartTwoAxisYSupplier",
					"com.sun.star.chart.StackableDiagram",
					"com.sun.star.chart.Dim3DDiagram" );
				if( mpModel->Is3DChart() )
					SvxServiceInfoHelper::addToSequence(aSeq, 1, "com.sun.star.chart.ChartAxisZSupplier" );
				break;
			case CHTYPE_CIRCLE :
				SvxServiceInfoHelper::addToSequence(
					aSeq, 2,
					"com.sun.star.chart.PieDiagram",
					"com.sun.star.chart.Dim3DDiagram");
				break;
			case CHTYPE_XY :
				SvxServiceInfoHelper::addToSequence(
					aSeq, 6,
					"com.sun.star.chart.XYDiagram",
					"com.sun.star.chart.LineDiagram",
					"com.sun.star.chart.ChartAxisXSupplier",
					"com.sun.star.chart.ChartTwoAxisXSupplier",
					"com.sun.star.chart.ChartAxisYSupplier",
					"com.sun.star.chart.ChartTwoAxisYSupplier" );
				break;
			case CHTYPE_NET :
				SvxServiceInfoHelper::addToSequence(
					aSeq, 3,
					"com.sun.star.chart.NetDiagram",
					"com.sun.star.chart.StackableDiagram",
					"com.sun.star.chart.ChartAxisYSupplier" );
				break;
			case CHTYPE_STOCK :
				SvxServiceInfoHelper::addToSequence(
					aSeq, 5,
					"com.sun.star.chart.StockDiagram",
					"com.sun.star.chart.ChartAxisXSupplier",
					"com.sun.star.chart.ChartTwoAxisXSupplier",
					"com.sun.star.chart.ChartAxisYSupplier",
					"com.sun.star.chart.ChartTwoAxisYSupplier" );
				break;
		}
	}
	else
	{
		DBG_ERROR( "No Model" );
	}

	return aSeq;
}

// XUnoTunnel
sal_Int64 SAL_CALL ChXDiagram::getSomething( const uno::Sequence< sal_Int8 >& aIdentifier )
	throw( uno::RuntimeException )
{
	if( aIdentifier.getLength() == 16 && 0 == rtl_compareMemory( getUnoTunnelId().getConstArray(),
																 aIdentifier.getConstArray(), 16 ) )
	{
		return (sal_Int64)this;
	}
	return 0;
}

