/*************************************************************************
 *
 *  $RCSfile: mapprov.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "mapprov.hxx"
#include "schattr.hxx"
#include "defines.hxx"
#include "chtmodel.hxx"
#include "schshape.hxx"
#include "datapoin.hxx"
#include "datarow.hxx"
#include "chtscene.hxx"

#ifndef _SCH_APP_HRC
#include "app.hrc"			// for SID_TEXTBREAK
#endif
#ifndef _SVX_SVXIDS_HRC
#include <svx/svxids.hrc>	// for SID_ATTR_NUMBERFORMAT_VALUE
#endif

// for SdrObject
#ifndef _SVDOBJ_HXX
#include <svx/svdobj.hxx>
#endif
// for SdrObjList
#ifndef _SVDPAGE_HXX
#include <svx/svdpage.hxx>
#endif
// for SdrObjListIter
#ifndef _SVDITER_HXX
#include <svx/svditer.hxx>
#endif
// header for E3dExtrudeObj
#ifndef _E3D_EXTRUD3D_HXX
#include <svx/extrud3d.hxx>
#endif
#ifndef _E3D_LATHE3D_HXX
#include <svx/lathe3d.hxx>
#endif
#ifndef _POLY3D_HXX
#include <svx/poly3d.hxx>
#endif
// for SVX_UNOEDIT_CHAR_PROPERTIES, SVX_UNOEDIT_FONT_PROPERTIES
#ifndef _SVX_UNOTEXT_HXX
#include <svx/unotext.hxx>
#endif
#ifndef _SVX_UNOSHPRP_HXX
#include <svx/unoshprp.hxx>
#endif

#ifndef _COM_SUN_STAR_CHART_CHARTLEGENDPOSITION_HPP_
#include <com/sun/star/chart/ChartLegendPosition.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTERRORINDICATORTYPE_HPP_
#include <com/sun/star/chart/ChartErrorIndicatorType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTERRORCATEGORY_HPP_
#include <com/sun/star/chart/ChartErrorCategory.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTREGRESSIONCURVETYPE_HPP_
#include <com/sun/star/chart/ChartRegressionCurveType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATAROWSOURCE_HPP_
#include <com/sun/star/chart/ChartDataRowSource.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTAXISARRANGEORDERTYPE_HPP_
#include <com/sun/star/chart/ChartAxisArrangeOrderType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSERIESADDRESS_HPP_
#include <com/sun/star/chart/ChartSeriesAddress.hpp>
#endif

using namespace com::sun::star;

// ----------------------------------
// create one global instance for use
// from all uno implemetations
// ----------------------------------
SchUnoPropertyMapProvider aSchMapProvider;


// ----------------------
// shared property ranges
// ----------------------

#define SCH_DATA_DESCR_PROPERTIES \
	{ MAP_CHAR_LEN( UNONAME_DATACAPTION ),			SCHATTR_DATADESCR_DESCR,		&::getCppuType( (sal_Int32*)0 ),	0,	0 }

// attention: x and y grids are interchanged
#define SCH_SHOW_HIDE_PROPERTIES \
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_2X_AXIS ),	CHATTR_AXISGRID_SHOW_2X_AXIS,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_2X_DESCR ),	CHATTR_AXISGRID_SHOW_2X_DESCR,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_2Y_AXIS ),	CHATTR_AXISGRID_SHOW_2Y_AXIS,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_2Y_DESCR ),	CHATTR_AXISGRID_SHOW_2Y_DESCR,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_X_AXIS ),		CHATTR_AXISGRID_SHOW_X_AXIS,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_X_DESCR ),	CHATTR_AXISGRID_SHOW_X_DESCR,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_X_HELP ),		CHATTR_AXISGRID_SHOW_Y_HELP,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_X_MAIN ),		CHATTR_AXISGRID_SHOW_Y_MAIN,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Y_AXIS ),		CHATTR_AXISGRID_SHOW_Y_AXIS,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Y_DESCR ),	CHATTR_AXISGRID_SHOW_Y_DESCR,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Y_HELP ),		CHATTR_AXISGRID_SHOW_X_HELP,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Y_MAIN ),		CHATTR_AXISGRID_SHOW_X_MAIN,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Z_AXIS ),		CHATTR_AXISGRID_SHOW_Z_AXIS,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Z_DESCR ),	CHATTR_AXISGRID_SHOW_Z_DESCR,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Z_HELP ),		CHATTR_AXISGRID_SHOW_Z_HELP,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_AXISGRID_SHOW_Z_MAIN ),		CHATTR_AXISGRID_SHOW_Z_MAIN,	&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_TITLE_SHOW_X_AXIS ),		CHATTR_TITLE_SHOW_X_AXIS,		&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_TITLE_SHOW_Y_AXIS ),		CHATTR_TITLE_SHOW_Y_AXIS,		&::getBooleanCppuType(),	0,	0 },\
    { MAP_CHAR_LEN( UNONAME_TITLE_SHOW_Z_AXIS ),		CHATTR_TITLE_SHOW_Z_AXIS,		&::getBooleanCppuType(),	0,	0 }

#define SCH_STAT_PROPERTIES \
	{ MAP_CHAR_LEN( UNONAME_STAT_AVERAGE ),				SCHATTR_STAT_AVERAGE,			&::getBooleanCppuType(),			0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_BIGERROR ),			SCHATTR_STAT_BIGERROR,			&::getCppuType((const double*)0),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_CONSTMINUS ),			SCHATTR_STAT_CONSTMINUS,		&::getCppuType((const double*)0),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_CONSTPLUS ),			SCHATTR_STAT_CONSTPLUS,			&::getCppuType((const double*)0),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_INDICATE ),			SCHATTR_STAT_INDICATE,			&::getCppuType((const chart::ChartErrorIndicatorType*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_KIND_ERROR ),			SCHATTR_STAT_KIND_ERROR,		&::getCppuType((const chart::ChartErrorCategory*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_PERCENT ),				SCHATTR_STAT_PERCENT,			&::getCppuType((const double*)0),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STAT_REGRESSTYPE ),			SCHATTR_STAT_REGRESSTYPE,		&::getCppuType((const chart::ChartRegressionCurveType*)0), 0, 0 }

#define SCH_SUBTYPE_PROPERTIES \
    { MAP_CHAR_LEN( UNONAME_NUM_OF_LINES_FOR_BAR ),		CHATTR_NUM_OF_LINES_FOR_BAR,	&::getCppuType((const sal_Int32*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STOCK_UPDOWN ),				SCHATTR_STOCK_UPDOWN,			&::getBooleanCppuType(),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STOCK_VOLUME ),				SCHATTR_STOCK_VOLUME,			&::getBooleanCppuType(),	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_3D ),					SCHATTR_STYLE_3D,				&::getBooleanCppuType(),  	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_DEEP ),				SCHATTR_STYLE_DEEP,				&::getBooleanCppuType() ,	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_LINES ),				SCHATTR_STYLE_LINES,			&::getBooleanCppuType(),  	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_PERCENT ),			SCHATTR_STYLE_PERCENT,			&::getBooleanCppuType() ,	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_SHAPE ),				SCHATTR_STYLE_SHAPE,			&::getCppuType((const sal_Int32*)0), 0, 0 },\
    { MAP_CHAR_LEN( UNONAME_STYLE_SPLINES ),			SCHATTR_STYLE_SPLINES,			&::getCppuType((const sal_Int32*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_STACKED ),			SCHATTR_STYLE_STACKED,			&::getBooleanCppuType()  ,	0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_SYMBOL ),				SCHATTR_STYLE_SYMBOL,			&::getCppuType((const sal_Int32*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_VERTICAL ),			SCHATTR_STYLE_VERTICAL,			&::getBooleanCppuType(),	0, 0 }

#define SCH_TEXT2_PROPERTIES \
    { MAP_CHAR_LEN( UNONAME_TEXT_DEGREES ),			SCHATTR_TEXT_DEGREES,			&::getCppuType((const sal_Int32*)0), 0, 0 },\
    { MAP_CHAR_LEN( UNONAME_TEXT_OVERLAP ),			SCHATTR_TEXT_OVERLAP,			&::getBooleanCppuType(),	0, 0 }


#define	SCH_GFX_PROPERTIES \
	{ MAP_CHAR_LEN( UNONAME_STYLE_SHAPE ),			SCHATTR_STYLE_SHAPE,			&::getCppuType((const sal_Int32*)0), 0, 0 },\
	{ MAP_CHAR_LEN( UNONAME_STYLE_SYMBOL ),			SCHATTR_STYLE_SYMBOL,			&::getCppuType((const sal_Int32*)0), 0, 0 }

#define SCH_MAP_END { 0,0,0,0,0 }

// ---------------
// map definitions
// ---------------

// see SchUnoPropertyMapProvider::GetMap()

// ------------------------------------------------------------
//
// Implementation for SchUnoPropertyMapProvider
//
// ------------------------------------------------------------

SchUnoPropertyMapProvider::SchUnoPropertyMapProvider()
{
	for( long i = 0; i < CHMAP_END; i++ )
		pMapArr[i] = 0;
}

SchUnoPropertyMapProvider::~SchUnoPropertyMapProvider()
{
/* CHECKME: Why is this gpf'ing?
	for( long i = 0; i < CHMAP_END; i++ )
		if( pMapArr[i] )
			delete pMapArr[i];
*/
}

// -------------- copied from SwUnoPropertyMapProvider --------------
EXTERN_C
#if defined( PM2 ) && (!defined( CSET ) && !defined ( MTW ) && !defined( WTC ))
int _stdcall
#else
#ifdef WNT
int _cdecl
#else
int
#endif
#endif
Sch_CompareMap( const void* pSmaller, const void* pBigger )
{
	int nDiff = strcmp( ((const SfxItemPropertyMap*)pSmaller)->pName,
						((const SfxItemPropertyMap*)pBigger)->pName );
	return nDiff;
}

void SchUnoPropertyMapProvider::Sort(short nId)
{
	SfxItemPropertyMap* pTemp = pMapArr[ nId ];
	short i = 0;
	while( pTemp[i].pName )
		i++;

	qsort( pMapArr[ nId ], i, sizeof(SfxItemPropertyMap), Sch_CompareMap );
}

SfxItemPropertyMap* SchUnoPropertyMapProvider::ConcatMaps( const SfxItemPropertyMap* pMap1, const SfxItemPropertyMap* pMap2 )
{
	long nCnt1 = 0,
		nCnt2 = 0;

	while( pMap1[nCnt1].pName )
		nCnt1++;

	while( pMap2[nCnt2].pName )
		nCnt2++;

	SfxItemPropertyMap* pNewMap = new SfxItemPropertyMap[ nCnt1 + nCnt2 + 1 ];

	memcpy( pNewMap, pMap1, sizeof(SfxItemPropertyMap) * nCnt1 );
	memcpy( &pNewMap[nCnt1], pMap2, sizeof(SfxItemPropertyMap) * (nCnt2 + 1) );

	return pNewMap;
}

SfxItemPropertyMap* SchUnoPropertyMapProvider::CopyMap( const SfxItemPropertyMap* pMap1 )
{
	long nCnt = 0;

	while( pMap1[ nCnt ].pName )
		nCnt++;

	nCnt++;

	SfxItemPropertyMap* pNewMap = new SfxItemPropertyMap[ nCnt ];
	memcpy( pNewMap, pMap1, sizeof(SfxItemPropertyMap) * nCnt );
	return pNewMap;
}

SdrObject *GetFirst3DDataObject( const SdrObjList& rObjList )
{

	SdrObjListIter aIterator( rObjList, IM_DEEPWITHGROUPS );
	while( aIterator.IsMore() )
	{
		SdrObject* pObj = aIterator.Next();
//  		if( pObj->ISA( E3dExtrudeObj ) ||
//  			pObj->ISA( E3dLatheObj ) ||
//  			pObj->ISA( E3dPolygonObj ))
//  		{
		// return if data point or series found
		if( GetDataRow( *pObj ) ||
			GetDataPoint( *pObj ))
			return pObj;
//  		}
	}
	return NULL;
}

SfxItemPropertyMap* SchUnoPropertyMapProvider::GetMap( short nPropertyId, ChartModel *pModel )
{
	// ---------------
	// map definitions
	// ---------------

	static SfxItemPropertyMap aEmptyMap[] = { SCH_MAP_END };

	static SfxItemPropertyMap aChartDocumentPropertyMap_Impl[] =
	{
		{ MAP_CHAR_LEN( UNONAME_HASLEGEND ),			CHATTR_DIAGRAM_START,	&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_TITLE_SHOW_MAIN ),		CHATTR_TITLE_SHOW_MAIN,	&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_TITLE_SHOW_SUB ),		CHATTR_TITLE_SHOW_SUB,	&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_CATEGORIES_RANGE_ADDRESS ), CHATTR_ADDR_CATEGORIES,	&::getCppuType((const ::rtl::OUString*)0),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_SERIES_ADDRESSES ),		CHATTR_ADDR_SERIES,		&::getCppuType(( uno::Sequence< chart::ChartSeriesAddress >*)0), 0, 0 },
//  		{ MAP_CHAR_LEN( UNONAME_MAINTITLE_ADDRESS ), 	CHATTR_ADDR_MAIN_TITLE,	&::getCppuType((const ::rtl::OUString*)0),	0, 0 },
//  		{ MAP_CHAR_LEN( UNONAME_SUBTITLE_ADDRESS ),		CHATTR_ADDR_SUB_TITLE,	&::getCppuType((const ::rtl::OUString*)0),	0, 0 },
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartTitleShapePropertyMap_Impl[] =
	{
		SVX_UNOEDIT_CHAR_PROPERTIES,
		SVX_UNOEDIT_SIMPLE_FONT_PROPERTIES,
		{ MAP_CHAR_LEN( UNONAME_TEXT_DEGREES ),		SCHATTR_TEXT_DEGREES,	&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_TEXT_STRING ),		CHATTR_TITLE_MAIN,		&::getCppuType((const ::rtl::OUString*)0), 0, 0 },	// CHATTR_TEXT_TITLE_MAIN is just a 'placeholder' to select the uno property 'String' from the which id
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartLegendPropertyMap_Impl[] =
	{
		SVX_UNOEDIT_CHAR_PROPERTIES,
		SVX_UNOEDIT_SIMPLE_FONT_PROPERTIES,
		{ MAP_CHAR_LEN( UNONAME_CHARTLEGENDALIGN ),	CHATTR_LEGEND_POS,		&::getCppuType((const chart::ChartLegendPosition*)0), 0, 0 },
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartPropertyMap_Impl[] =
	{
		SCH_STAT_PROPERTIES,
		SCH_SHOW_HIDE_PROPERTIES,
		SCH_SUBTYPE_PROPERTIES,
		SCH_DATA_DESCR_PROPERTIES,
		{ MAP_CHAR_LEN( UNONAME_DATAROWSOURCE ),		CHATTR_DATA_SWITCH,		&::getCppuType((const chart::ChartDataRowSource*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_STACKCONNECTORS ),		CHATTR_BARCONNECT,		&::getBooleanCppuType(),  0, 0 },
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartAxisStylePropertyMap_Impl[] =
	{
		SCH_TEXT2_PROPERTIES,
		SVX_UNOEDIT_CHAR_PROPERTIES,
		SVX_UNOEDIT_SIMPLE_FONT_PROPERTIES,
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		{ MAP_CHAR_LEN( UNONAME_AXIS_AUTO_MAX ),			SCHATTR_AXIS_AUTO_MAX,			&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_AUTO_MIN ),			SCHATTR_AXIS_AUTO_MIN,			&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_AUTO_ORIGIN ),			SCHATTR_AXIS_AUTO_ORIGIN,		&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_AUTO_STEP_HELP ),		SCHATTR_AXIS_AUTO_STEP_HELP,	&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_AUTO_STEP_MAIN ),		SCHATTR_AXIS_AUTO_STEP_MAIN,	&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_HELPTICKS ),			SCHATTR_AXIS_HELPTICKS,			&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_LOGARITHM ),			SCHATTR_AXIS_LOGARITHM,			&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_MAX ),					SCHATTR_AXIS_MAX,				&::getCppuType((const double*)0),	 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_MIN ),					SCHATTR_AXIS_MIN,				&::getCppuType((const double*)0),	 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_ORIGIN ),				SCHATTR_AXIS_ORIGIN,			&::getCppuType((const double*)0),	 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_STEP_HELP ),			SCHATTR_AXIS_STEP_HELP,			&::getCppuType((const double*)0),	 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_STEP_MAIN ),			SCHATTR_AXIS_STEP_MAIN,			&::getCppuType((const double*)0),	 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_AXIS_TICKS ),				SCHATTR_AXIS_TICKS,				&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_DIAGRAM_GAPWIDTH ),			SCHATTR_BAR_GAPWIDTH,			&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_DIAGRAM_OVERLAP ),			SCHATTR_BAR_OVERLAP,			&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_NUMBERFORMAT ),				SID_ATTR_NUMBERFORMAT_VALUE,	&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_TEXTBREAK ),				SID_TEXTBREAK,					&::getBooleanCppuType(),	0, 0 },
		{ MAP_CHAR_LEN( UNONAME_TEXT_ORDER ),				SCHATTR_TEXT_ORDER,				&::getCppuType((const chart::ChartAxisArrangeOrderType*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_DISPLAY_LABELS ),			SCHATTR_AXIS_SHOWDESCR,			&::getBooleanCppuType(),	0, 0 },
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartDataRowPropertyMap_Impl[] =
	{
		SCH_GFX_PROPERTIES,
		SCH_DATA_DESCR_PROPERTIES,
		SCH_STAT_PROPERTIES,
		SVX_UNOEDIT_CHAR_PROPERTIES,
		SVX_UNOEDIT_SIMPLE_FONT_PROPERTIES,
		{ MAP_CHAR_LEN( UNONAME_AXIS ),					SCHATTR_AXIS,					&::getCppuType((const sal_Int32*)0), 0, 0 },
		{ MAP_CHAR_LEN( UNONAME_REGRESSION_PROPS ),		CHATTR_REGRESSION_PROPS,		&::getCppuType((const uno::Reference< beans::XPropertySet >*)0), 0, 0},
		{ MAP_CHAR_LEN( UNONAME_ERROR_PROPS ),			CHATTR_ERROR_PROPS,				&::getCppuType((const uno::Reference< beans::XPropertySet >*)0), 0, 0},
		{ MAP_CHAR_LEN( UNONAME_AVERAGE_PROPS ),		CHATTR_AVERAGE_PROPS,			&::getCppuType((const uno::Reference< beans::XPropertySet >*)0), 0, 0},
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aChartDataPointPropertyMap_Impl[] =
	{
		SCH_GFX_PROPERTIES,
		SCH_DATA_DESCR_PROPERTIES,
		SVX_UNOEDIT_CHAR_PROPERTIES,
		SVX_UNOEDIT_SIMPLE_FONT_PROPERTIES,
		{ MAP_CHAR_LEN( UNONAME_PIE_SEGMENT_OFFSET ),	CHATTR_PIE_SEGMENT_OFFSET,		&::getCppuType((const sal_Int32*)0), 0, 0 },
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap a3DSceneObjectPropertyMap_Impl[] =
	{
		SPECIAL_3DSCENEOBJECT_PROPERTIES
		SCH_MAP_END
	};

	static SfxItemPropertyMap aFilledShapePropertyMap_Impl[] =
	{
		FILL_PROPERTIES
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aLineShapePropertyMap_Impl[] =
	{
		LINE_PROPERTIES
		LINE_PROPERTIES_START_END
		SCH_MAP_END
	};

	static SfxItemPropertyMap aExtrudePropertyMap_Impl[] =
	{
		MISC_3D_OBJ_PROPERTIES
		SPECIAL_3DEXTRUDEOBJECT_PROPERTIES
		SPECIAL_3DBACKSCALE_PROPERTIES
		SCH_MAP_END
	};

	static SfxItemPropertyMap aLathePropertyMap_Impl[] =
	{
		MISC_3D_OBJ_PROPERTIES
		SPECIAL_3DLATHEOBJECT_PROPERTIES
		SPECIAL_3DBACKSCALE_PROPERTIES
		SCH_MAP_END
	};

	static SfxItemPropertyMap a3DPolyPropertyMap_Impl[] =
	{
		MISC_3D_OBJ_PROPERTIES
		SPECIAL_3DPOLYGONOBJECT_PROPERTIES
		SCH_MAP_END
	};

	// ------------
	// program code
	// ------------

	if( nPropertyId >= CHMAP_END )
		DBG_ERROR2( "Invalid Id %d (>=%d)", nPropertyId, CHMAP_END );

	// determine correct map for different 3d objects
	if( pModel )
	{
		SdrObject* pObj = pModel->GetScene();
		if( pObj )
		{
			switch( nPropertyId )
			{
				case CHMAP_CHART:
					nPropertyId = CHMAP_3D_CHART;
					break;

				case CHMAP_DATAROW:
					pObj = GetFirst3DDataObject( *(pObj->GetSubList()) );
					if( pObj )
					{
						if( pObj->ISA( E3dExtrudeObj ) )
							nPropertyId = CHMAP_DATAROW_EXTRUDE;
						else if( pObj->ISA( E3dLatheObj ))
							nPropertyId = CHMAP_DATAROW_LATHE;
						else
							nPropertyId = CHMAP_DATAROW_POLY;
					}
					break;
				case CHMAP_DATAPOINT:
					pObj = GetFirst3DDataObject( *(pObj->GetSubList()) );
					if( pObj )
					{
						if( pObj->ISA( E3dExtrudeObj ) )
							nPropertyId = CHMAP_DATAPOINT_EXTRUDE;
						else if( pObj->ISA( E3dLatheObj ))
							nPropertyId = CHMAP_DATAPOINT_LATHE;
						else
							nPropertyId = CHMAP_DATAPOINT_POLY;
					}
					break;
			}
		}
	}

	if( ! pMapArr[ nPropertyId ] )
	{
		switch( nPropertyId )
		{
			case CHMAP_CHART:
				pMapArr[ CHMAP_CHART ] = aChartPropertyMap_Impl;
				break;
			case CHMAP_3D_CHART:
				pMapArr[ CHMAP_3D_CHART ] = ConcatMaps( a3DSceneObjectPropertyMap_Impl,
														aChartPropertyMap_Impl );
				break;
			case  CHMAP_AREA:
				pMapArr[ CHMAP_AREA ] = aFilledShapePropertyMap_Impl;
				break;
			case  CHMAP_LINE:
				pMapArr[ CHMAP_LINE ] = aLineShapePropertyMap_Impl;
				break;
			case CHMAP_DOC:
				pMapArr[ CHMAP_DOC ] = aChartDocumentPropertyMap_Impl;
				break;
			case CHMAP_AXIS:
				pMapArr[ CHMAP_AXIS ] = aChartAxisStylePropertyMap_Impl;
				break;
			case CHMAP_LEGEND:
				pMapArr[ CHMAP_LEGEND ] = aChartLegendPropertyMap_Impl;
				break;
			case CHMAP_TITLE:
				pMapArr[ CHMAP_TITLE ] = aChartTitleShapePropertyMap_Impl;
				break;
			case CHMAP_DATAROW:
				pMapArr[ CHMAP_DATAROW ] = aChartDataRowPropertyMap_Impl;
				break;
			case CHMAP_DATAPOINT:
				pMapArr[ CHMAP_DATAPOINT ] = aChartDataPointPropertyMap_Impl;
				break;
			case CHMAP_DATAROW_EXTRUDE:
				pMapArr[ CHMAP_DATAROW_EXTRUDE ] = ConcatMaps( aExtrudePropertyMap_Impl,
															   aChartDataRowPropertyMap_Impl );
				break;
			case CHMAP_DATAPOINT_EXTRUDE:
				pMapArr[ CHMAP_DATAPOINT_EXTRUDE ] = ConcatMaps( aExtrudePropertyMap_Impl,
																 aChartDataPointPropertyMap_Impl );
				break;
			case CHMAP_DATAROW_LATHE:
				pMapArr[ CHMAP_DATAROW_LATHE ] = ConcatMaps( aLathePropertyMap_Impl,
															 aChartDataRowPropertyMap_Impl );
				break;
			case CHMAP_DATAPOINT_LATHE:
				pMapArr[ CHMAP_DATAPOINT_LATHE ] = ConcatMaps( aLathePropertyMap_Impl,
															   aChartDataPointPropertyMap_Impl );
				break;
			case CHMAP_DATAROW_POLY:
				pMapArr[ CHMAP_DATAROW_POLY ] = ConcatMaps( a3DPolyPropertyMap_Impl,
															aChartDataRowPropertyMap_Impl );
				break;
			case CHMAP_DATAPOINT_POLY:
				pMapArr[ CHMAP_DATAPOINT_POLY ] = ConcatMaps( a3DPolyPropertyMap_Impl,
															  aChartDataPointPropertyMap_Impl );
				break;

			case CHMAP_NONE:
			default:
				pMapArr[ nPropertyId ] = CopyMap( aEmptyMap );
				DBG_WARNING( "Using empty PropertyMap!" );
				break;
		}
	}
	Sort( nPropertyId );

	return pMapArr[ nPropertyId ];
}

long SchUnoPropertyMapProvider::GetMapIdByObjId( long nObjId )
{
	switch( nObjId )
	{
		case CHOBJID_DIAGRAM_X_AXIS:
		case CHOBJID_DIAGRAM_A_AXIS:
		case CHOBJID_DIAGRAM_Y_AXIS:
		case CHOBJID_DIAGRAM_B_AXIS:
		case CHOBJID_DIAGRAM_Z_AXIS:
			return CHMAP_AXIS;

		case CHOBJID_DIAGRAM_FLOOR:
		case CHOBJID_DIAGRAM_WALL:
		case CHOBJID_DIAGRAM_AREA:
			return CHMAP_AREA;

		case CHOBJID_DIAGRAM_X_GRID_MAIN:
		case CHOBJID_DIAGRAM_Y_GRID_MAIN:
		case CHOBJID_DIAGRAM_Z_GRID_MAIN:
		case CHOBJID_DIAGRAM_X_GRID_HELP:
		case CHOBJID_DIAGRAM_Y_GRID_HELP:
		case CHOBJID_DIAGRAM_Z_GRID_HELP:
		case CHOBJID_DIAGRAM_X_GRID_MAIN_GROUP:
		case CHOBJID_DIAGRAM_Y_GRID_MAIN_GROUP:
		case CHOBJID_DIAGRAM_Z_GRID_MAIN_GROUP:
		case CHOBJID_DIAGRAM_X_GRID_HELP_GROUP:
		case CHOBJID_DIAGRAM_Y_GRID_HELP_GROUP:
		case CHOBJID_DIAGRAM_Z_GRID_HELP_GROUP:
			return CHMAP_LINE;

		default:
			DBG_WARNING1( "PropertyMapId for unknown Object (Id=%d) requested!", nObjId );
			return CHMAP_NONE;
	}
}

SfxItemPropertyMap* SchUnoPropertyMapProvider::GetMapByObjId( long nObjId, ChartModel* pModel )
{
	return GetMap( GetMapIdByObjId( nObjId ), pModel );
}

