/*************************************************************************
 *
 *  $RCSfile: schshape.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "schattr.hxx"
#include "schshape.hxx"

#ifndef _SVX_UNOEDSRC_HXX
#include <svx/unoedsrc.hxx>
#endif

#ifndef SVX_UNOSHTXT_HXX
#include <svx/unoshtxt.hxx>
#endif

#ifndef _SVX_UNOTEXT_HXX //autogen
#include <svx/unotext.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _XDEF_HXX //autogen
#include <svx/xdef.hxx>
#endif
#ifndef _SVDDEF_HXX //autogen
#include <svx/svddef.hxx>
#endif
#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif
#ifndef _RTL_UUID_H_
#include <rtl/uuid.h>
#endif
#ifndef _RTL_MEMORY_H_
#include <rtl/memory.h>
#endif
// header for any2enum
#ifndef _CPPUHELPER_EXTRACT_HXX_
#include <cppuhelper/extract.hxx>
#endif


#ifndef _SVX_SVXIDS_HRC //autogen
#include <svx/svxids.hrc>
#endif

#ifndef _SVX_CHRTITEM_HXX //autogen
#define ITEMID_DOUBLE           0
#define ITEMID_CHARTTEXTORDER   SCHATTR_TEXT_ORDER
#define ITEMID_CHARTTEXTORIENT  SCHATTR_TEXT_ORIENT
#define ITEMID_CHARTLEGENDPOS   SCHATTR_LEGEND_POS
#define ITEMID_CHARTDATADESCR   SCHATTR_DATADESCR_DESCR
#include <svx/chrtitem.hxx>
#endif

// has to be after chrtitem !
#include "globfunc.hxx"			// for GlobalGenerate3DAttrDefaultItem

#ifndef _COM_SUN_STAR_CHART_CHARTLEGENDPOSITION_HPP_
#include <com/sun/star/chart/ChartLegendPosition.hpp>
#endif

#include "chtmodel.hxx"
#include "globfunc.hxx"
#include "docshell.hxx"

#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
// header for class Application
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif

#ifndef _SVX_UNOSHPRP_HXX
#include <svx/unoshprp.hxx>		// for OWN_ATTR_...
#endif

extern SchUnoPropertyMapProvider aSchMapProvider;

// for SvxServiceInfoHelper
#ifndef SVX_UNOPROV_HXX
#include <svx/unoprov.hxx>
#endif

using namespace vos;
using namespace com::sun::star;

SchShape::SchShape() throw() :
		SvxShape(),
		pItemSet( NULL ),
		nObjId( 0 ),
		pChModel( NULL ),
		pOldModel( NULL )
{}

SchShape::SchShape( ChartModel* pModel, SfxItemSet* pSet, SdrObject* pNewObj, long nId, long nMapId ) throw() :
		SvxShape( pNewObj, aSchMapProvider.GetMap( nMapId, pModel )),
		pItemSet( pSet ),
		nObjId( nId ),
		pChModel( pModel ),
		pOldModel( NULL )
{
	Init();
}

SchShape::~SchShape() throw()
{
	if( pChModel )
		pChModel->DetachShape( nObjId );
}

// private
void SchShape::Init()
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( pObj )
	{
		pModel = pObj->GetModel();
		if( pModel && (pModel != pOldModel) )
		{
			// the following line was disabled in Version 1.2, but why?
			// and why has this code been written anyway?
//            StartListening( *(SfxBroadcaster*)pModel );
		}
	}
	pOldModel = pModel;
}

// generate a uniqueId
const uno::Sequence< sal_Int8 > & SchShape::getUnoTunnelId() throw()
{
	static uno::Sequence< sal_Int8 > * pSeq = 0;
	if( !pSeq )
	{
		osl::Guard< osl::Mutex > aGuard( osl::Mutex::getGlobalMutex() );
		if( !pSeq )
		{
			static uno::Sequence< sal_Int8 > aSeq( 16 );
			rtl_createUuid( (sal_uInt8*)aSeq.getArray(), 0, sal_True );
			pSeq = &aSeq;
		}
	}
	return *pSeq;
}

SchShape* SchShape::getImplementation( uno::Reference< uno::XInterface > xData ) throw()
{
	uno::Reference< lang::XUnoTunnel > xUT( xData, uno::UNO_QUERY );
	if( xUT.is() )
		return (SchShape*)xUT->getSomething( SchShape::getUnoTunnelId() );
	else
		return NULL;
}

long SchShape::GetId() throw()
{
	return nObjId;
}

const SfxItemPropertyMap* SchShape::getPropertyMap() const throw()
{
	OGuard aGuard( Application::GetSolarMutex() );
	return aPropSet.getPropertyMap();
}

void SchShape::SetSdrObject( SdrObject* pNewObj, long nId, SfxItemSet* pSet ) throw()
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( pObj )
	{
		// pseudo-dtor of SvxShape
		if( pModel )
			EndListening( *pModel );
	}
	if( xTextAgg.is() )
		xTextAgg->setDelegator( uno::Reference< uno::XInterface >() );

	xTextAgg = NULL;

	pObj = pNewObj;

	// the model remains, also if BuildChart sets pObj to NULL temporarily
	if( nId != CHOBJID_ANY )
		nObjId = nId;

	if( pSet )
		pItemSet = pSet;

	Init();
};


// XShapeDescriptor
::rtl::OUString SAL_CALL SchShape::getShapeType() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	switch( nObjId )
	{
		case CHOBJID_DIAGRAM_AREA:
		case CHOBJID_DIAGRAM_WALL:
		case CHOBJID_DIAGRAM_FLOOR:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartArea" );

		case CHOBJID_DIAGRAM_X_GRID_MAIN:
		case CHOBJID_DIAGRAM_Y_GRID_MAIN:
		case CHOBJID_DIAGRAM_Z_GRID_MAIN:
		case CHOBJID_DIAGRAM_X_GRID_HELP:
		case CHOBJID_DIAGRAM_Y_GRID_HELP:
		case CHOBJID_DIAGRAM_Z_GRID_HELP:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartGrid" );

		case CHOBJID_LINE:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartLine" );

		case CHOBJID_LEGEND:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartLegend" );

		case CHOBJID_DIAGRAM_TITLE_X_AXIS:
		case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
		case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
		case CHOBJID_TITLE_MAIN:
		case CHOBJID_TITLE_SUB:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartTitle" );

		case CHOBJID_DIAGRAM_X_AXIS:
		case CHOBJID_DIAGRAM_Y_AXIS:
		case CHOBJID_DIAGRAM_Z_AXIS:
			return SCH_ASCII_TO_OU( "com.sun.star.chart.ChartAxis" );

		default:
			return SvxShape::getShapeType();
	}
}

// XShape
void SAL_CALL SchShape::setPosition( const awt::Point& aPosition )
	throw( com::sun::star::uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	// area, wall can't be moved
	if( nObjId == CHOBJID_DIAGRAM_AREA ||
		nObjId == CHOBJID_DIAGRAM_WALL )
		throw uno::RuntimeException();

	SvxShape::setPosition( aPosition );

	if( pChModel )
	{
		pChModel->SetUseRelativePositions( TRUE );
		pChModel->SetHasBeenMoved( nObjId );
	}
}

void SAL_CALL SchShape::setSize( const awt::Size& aSize )
	throw( beans::PropertyVetoException, uno::RuntimeException )
{
	// setSize is not possible for chart objects, so throw
	// RuntimeException (as there is no better choice)
	throw uno::RuntimeException();
}

// XComponent
void SAL_CALL SchShape::dispose() throw( uno::RuntimeException )
{
	SvxShape::dispose();

	sal_Bool bChangeProperty = sal_False;
	rtl::OUString aProperty;

	switch( nObjId )
	{
		case CHOBJID_TITLE_MAIN:
			aProperty = rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( UNONAME_TITLE_SHOW_MAIN ));
			bChangeProperty = sal_True;
			break;
		case CHOBJID_TITLE_SUB:
			aProperty = rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( UNONAME_TITLE_SHOW_SUB ));
			bChangeProperty = sal_True;
			break;
		case CHOBJID_LEGEND:
			aProperty = rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( UNONAME_HASLEGEND ));
			bChangeProperty = sal_True;
			break;
	}
	if( bChangeProperty )
	{
		if( pChModel )
		{
			SchChartDocShell* pDocSh = (SchChartDocShell*)(pChModel->GetObjectShell());
			if( pDocSh )
			{
				uno::Reference< beans::XPropertySet > xDocProp( pDocSh->GetBaseModel(), uno::UNO_QUERY );
				if( xDocProp.is())
				{
					uno::Any aFalseBool;
					aFalseBool <<= (sal_Bool)(sal_False);
					try
					{
						xDocProp->setPropertyValue( aProperty, aFalseBool );
					}
					catch( beans::UnknownPropertyException )
					{
						DBG_WARNING( "cannot set property to false" );
					}
				}
			}
		}
	}
}

// XPropertySet
uno::Reference< beans::XPropertySetInfo > SAL_CALL SchShape::getPropertySetInfo()
	throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex());

	return aPropSet.getPropertySetInfo();
}

void SAL_CALL SchShape::setPropertyValue( const ::rtl::OUString& aPropertyName, const uno::Any& aValue )
	throw( beans::UnknownPropertyException,
		   beans::PropertyVetoException,
		   lang::IllegalArgumentException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	if( pObj )
	{
		const SfxItemPropertyMap* pMap = aPropSet.getPropertyMapEntry( aPropertyName );

		if( pMap && pMap->nWID )
		{
			long nWID = pMap->nWID;
			
			ChartModel *pModel = SAL_STATIC_CAST( ChartModel*, pObj->GetModel() );
			SfxItemSet aSet( pModel->GetItemPool(), nWID, nWID );

			if( aPropertyName.compareToAscii( UNONAME_TEXT_STRING ) == 0 )
			{
				::rtl::OUString aStr;
				aValue >>= aStr;
				pModel->SetTitle( nObjId, aStr );
				pModel->BuildChart( FALSE );
			}
			else
			{
				if( nObjId == CHOBJID_LEGEND && aPropertyName.compareToAscii( UNONAME_CHARTLEGENDALIGN ) == 0 )
				{
					chart::ChartLegendPosition ePos;
					cppu::any2enum< chart::ChartLegendPosition >( ePos, aValue );
					// I don't know why NONE shouldn't be set, so I allow it (was disabled once)
					pModel->SetShowLegend( ePos != chart::ChartLegendPosition_NONE );
					pModel->SetLegendHasBeenMoved( FALSE );
					// note: SetShowLegend sets pos to CHLEGEND_RIGHT
					if( pItemSet )
						pItemSet->Put( SvxChartLegendPosItem( 
						    SAL_STATIC_CAST( SvxChartLegendPos, SAL_STATIC_CAST( int, ePos ))));
					pModel->BuildChart( FALSE );

					return;			// RETURN
				}

				if( pItemSet )
					aSet.Put( *pItemSet );
				else
					pObj->TakeAttributes( aSet, FALSE, FALSE );

				if( ! aSet.Count() )
				{
					// get default from pool
					if( SID_ATTR_3D_START <= nWID && nWID <= SID_ATTR_3D_END )
					{
						GlobalGenerate3DAttrDefaultItem( nWID, aSet );
					}
					else if( pModel->GetItemPool().IsWhich( nWID ))
					{
						if( ! (OWN_ATTR_VALUE_START <= nWID && nWID <= OWN_ATTR_VALUE_END))
						{
							aSet.Put( pModel->GetItemPool().GetDefaultItem( nWID ));
						}
					}
					else
					{
#ifdef DBG_UTIL
						String aTmpString( aPropertyName );
						ByteString aProp( aTmpString, RTL_TEXTENCODING_ASCII_US );
						DBG_ERROR2( "Diagram: Property %s has an invalid ID (%d)", aProp.GetBuffer(), nWID );
#endif
					}
				}

				if( aSet.Count() )
				{
					// CL: convert special character properties
					if( ! SvxUnoTextRangeBase::SetPropertyValueHelper( aSet, pMap, aValue, aSet ))
						aPropSet.setPropertyValue( pMap, aValue, aSet );

					if( pItemSet )
					{
						pItemSet->Put( aSet );
					}
					pObj->SetAttributes( aSet, FALSE );

					pModel->BuildChart(FALSE);

					SvData aEmpty;
					SchChartDocShell* pShell = (SchChartDocShell*)(pModel->GetObjectShell());
					if( pShell )
					{
						pShell->DataChanged( aEmpty );
					}
				}
				else
				{
					throw beans::UnknownPropertyException();
				}
			}
		}
		else
		{
			throw beans::UnknownPropertyException();
		}
	}
}


uno::Any SAL_CALL SchShape::getPropertyValue( const ::rtl::OUString& aPropertyName )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex());
	
	uno::Any aAny;
	if( pObj )
	{
		ChartModel *pModel = SAL_STATIC_CAST( ChartModel*, pObj->GetModel() );
		const SfxItemPropertyMap* pMap = aPropSet.getPropertyMapEntry( aPropertyName );

		if( pMap && pMap->nWID )
		{
			long nWID = pMap->nWID;
			
			SfxItemSet aSet( pModel->GetItemPool(), nWID, nWID );

			if( aPropertyName.compareToAscii( UNONAME_TEXT_STRING ) == 0 )
			{
				aAny <<= ::rtl::OUString( pModel->GetTitle( nObjId ));
			}
			else
			{
				if( nObjId==CHOBJID_LEGEND && aPropertyName.compareToAscii( UNONAME_CHARTLEGENDALIGN ) == 0 )
				{
					SfxItemSet rSet=pModel->GetLegendAttr();
					const SfxPoolItem *pPoolItem = NULL;
					SvxChartLegendPos ePos =
						rSet.GetItemState( SCHATTR_LEGEND_POS,TRUE, &pPoolItem) == SFX_ITEM_SET
						? ((const SvxChartLegendPosItem*)pPoolItem)->GetValue()
						: CHLEGEND_RIGHT;
					chart::ChartLegendPosition ePosition = (chart::ChartLegendPosition)ePos;
					aAny <<= ePosition;
					return aAny;		// RETURN
				}

				if( pItemSet )
					aSet.Put( *pItemSet );
				else
					pObj->TakeAttributes( aSet, FALSE, FALSE );

				if( SvxUnoTextRangeBase::GetPropertyValueHelper( aSet, pMap, aAny ))
					return aAny;

				if( ! aSet.Count() )
				{
					// get default from pool
					if( SID_ATTR_3D_START <= nWID && nWID <= SID_ATTR_3D_END )
					{
						GlobalGenerate3DAttrDefaultItem( nWID, aSet );
					}
					else if( pModel->GetItemPool().IsWhich( nWID ))
					{
						if( OWN_ATTR_VALUE_START <= nWID && nWID <= OWN_ATTR_VALUE_END )
						{
							return SvxShape::getPropertyValue( aPropertyName );
						}
						else
						{
							aSet.Put( pModel->GetItemPool().GetDefaultItem( nWID ));
						}
					}
					else
					{
#ifdef DBG_UTIL
						String aTmpString( aPropertyName );
						ByteString aProp( aTmpString, RTL_TEXTENCODING_ASCII_US );
						DBG_ERROR2( "Diagram: Property %s has an invalid ID (%d)", aProp.GetBuffer(), nWID );
#endif
					}
				}

				if( aSet.Count() )
				{
					// get value
					aAny = aPropSet.getPropertyValue( pMap, aSet );
				}
			}
		}
		else
		{
			throw beans::UnknownPropertyException();
		}
	}
	return aAny;
}


void SAL_CALL SchShape::addPropertyChangeListener( const ::rtl::OUString& aPropertyName,
										 const uno::Reference< beans::XPropertyChangeListener >& xListener )
	throw( beans::UnknownPropertyException,
		   lang::WrappedTargetException,
		   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	// ToDo: enable listeners for chart specific properties
	SvxShape::addPropertyChangeListener( aPropertyName, xListener );
}

void SAL_CALL SchShape::removePropertyChangeListener( const ::rtl::OUString& aPropertyName,
											const uno::Reference< beans::XPropertyChangeListener >& aListener )
	throw( beans::UnknownPropertyException, lang::WrappedTargetException, uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	// ToDo: enable listeners for chart specific properties
	SvxShape::removePropertyChangeListener( aPropertyName, aListener );
}

void SAL_CALL SchShape::addVetoableChangeListener( const ::rtl::OUString& PropertyName,
										 const uno::Reference< beans::XVetoableChangeListener >& aListener )
	throw( beans::UnknownPropertyException, lang::WrappedTargetException, uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	// ToDo: enable listeners for chart specific properties
	SvxShape::addVetoableChangeListener( PropertyName, aListener );
}

void SAL_CALL SchShape::removeVetoableChangeListener( const ::rtl::OUString& PropertyName,
											const uno::Reference< beans::XVetoableChangeListener >& aListener )
	throw( beans::UnknownPropertyException, lang::WrappedTargetException, uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	// ToDo: enable listeners for chart specific properties
	SvxShape::removeVetoableChangeListener( PropertyName, aListener );
}

// XPropertyState
beans::PropertyState SAL_CALL SchShape::getPropertyState( const ::rtl::OUString& PropertyName )
	throw( beans::UnknownPropertyException, uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	const SfxItemPropertyMap* pMap = aPropSet.getPropertyMapEntry( PropertyName );
	if( pMap )
	{
		sal_Int32 nWID = pMap->nWID;

		if( nObjId == CHOBJID_LEGEND &&
			nWID == CHATTR_LEGEND_POS )
		{
			SfxItemSet rSet = SAL_STATIC_CAST( ChartModel*, pModel )->GetLegendAttr();
			SfxItemState aState = rSet.GetItemState( SCHATTR_LEGEND_POS, sal_False );

			if( aState == SFX_ITEM_DEFAULT )
				return beans::PropertyState_DEFAULT_VALUE;
			else
				return beans::PropertyState_DIRECT_VALUE;
		}
		else if( nWID == CHATTR_TITLE_MAIN )	// property String for all titles
		{
			return beans::PropertyState_DIRECT_VALUE;
		}
		else if( SCHATTR_START <= nWID && nWID <= SCHATTR_END )
		{
			SfxItemSet aSet( pModel->GetItemPool(), nWID, nWID );
			pObj->TakeAttributes( aSet, FALSE, FALSE );
			switch( aSet.GetItemState( nWID, sal_False ) )
			{
				case SFX_ITEM_DONTCARE:
				case SFX_ITEM_DISABLED:
					return beans::PropertyState_AMBIGUOUS_VALUE;
				case SFX_ITEM_READONLY:
				case SFX_ITEM_SET:
					return beans::PropertyState_DIRECT_VALUE;
				case SFX_ITEM_DEFAULT:
					return beans::PropertyState_DEFAULT_VALUE;
				case SFX_ITEM_UNKNOWN:
				default:
					throw beans::UnknownPropertyException();
			}
		}
	}

	return SvxShape::getPropertyState( PropertyName );
}

void SAL_CALL SchShape::setPropertyToDefault( const ::rtl::OUString& PropertyName )
		throw( beans::UnknownPropertyException,
			   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	const SfxItemPropertyMap* pMap = aPropSet.getPropertyMapEntry( PropertyName );

	if( pMap &&
		( pMap->nWID == CHATTR_LEGEND_POS ||
		  pMap->nWID == CHATTR_TITLE_MAIN ))
		return;

	SvxShape::setPropertyToDefault( PropertyName );
}

uno::Any SAL_CALL SchShape::getPropertyDefault( const ::rtl::OUString& aPropertyName )
		throw( beans::UnknownPropertyException,
			   lang::WrappedTargetException,
			   uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );
	const SfxItemPropertyMap* pMap = aPropSet.getPropertyMapEntry( aPropertyName );

	if( pMap &&
		( pMap->nWID == CHATTR_LEGEND_POS ||
		  pMap->nWID == CHATTR_TITLE_MAIN ))
	{
		getPropertyValue( aPropertyName );
	}
	
	return SvxShape::getPropertyDefault( aPropertyName );
}

// XServiceInfo
::rtl::OUString SAL_CALL SchShape::getImplementationName() throw( uno::RuntimeException )
{
	return SCH_ASCII_TO_OU( "SchShape" );
}

uno::Sequence< ::rtl::OUString > SAL_CALL SchShape::getSupportedServiceNames() throw( uno::RuntimeException )
{
	OGuard aGuard( Application::GetSolarMutex() );

	uno::Sequence< rtl::OUString > aSeq( SvxShape::getSupportedServiceNames() );

	switch( nObjId )
	{
		case CHOBJID_LEGEND:
			SvxServiceInfoHelper::addToSequence(
				aSeq, 4,
				"com.sun.star.chart.ChartLegend",
				"com.sun.star.drawing.Shape",
				"com.sun.star.drawing.ShapeDescriptor",
				"com.sun.star.style.CharacterProperties" );
			break;

		case  CHOBJID_TITLE_MAIN:
		case  CHOBJID_TITLE_SUB:
			SvxServiceInfoHelper::addToSequence(
				aSeq, 3,
				"com.sun.star.chart.ChartTitle",
				"com.sun.star.drawing.Shape",
				"com.sun.star.drawing.ShapeDescriptor");
			break;

		case CHOBJID_DIAGRAM_AREA:
			SvxServiceInfoHelper::addToSequence(
				aSeq, 4,
				"com.sun.star.chart.ChartArea",
				"com.sun.star.drawing.AreaShapeDescriptor",
				"com.sun.star.drawing.LineShapeDescriptor",
				"com.sun.star.drawing.ShapeDescriptor" );
			break;
	}

	return aSeq;
}

// XUnoTunnel
sal_Int64 SAL_CALL SchShape::getSomething( const uno::Sequence< sal_Int8 >& aIdentifier )
	throw( uno::RuntimeException )
{
	if( aIdentifier.getLength() == 16 && 0 == rtl_compareMemory( getUnoTunnelId().getConstArray(),
																 aIdentifier.getConstArray(), 16 ) )
	{
		return (sal_Int64)this;
	}
	return 0;
}


