/*************************************************************************
 *
 *  $RCSfile: schview.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SVDOGRAF_HXX //autogen
#include <svx/svdograf.hxx>
#endif
#ifndef _SOT_EXCHANGE_HXX //autogen
#include <sot/exchange.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SOT_FORMATS_HXX //autogen
#include <sot/formats.hxx>
#endif
#ifndef _SVX_XLNCLIT_HXX //autogen
#include <svx/xlnclit.hxx>
#endif
#ifndef _SVX_XFLCLIT_HXX //autogen
#include <svx/xflclit.hxx>
#endif
#ifndef _SVDPAGV_HXX //autogen
#include <svx/svdpagv.hxx>
#endif
#ifndef _SVDOOLE2_HXX //autogen
#include <svx/svdoole2.hxx>
#endif
#ifndef _ZFORLIST_HXX //autogen
#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#endif
#ifndef _SV_GRAPH_HXX //autogen
#include <vcl/graph.hxx>
#endif
#ifndef _SV_DRAG_HXX //autogen
#include <vcl/drag.hxx>
#endif
#ifndef _STRING_HXX //autogen wg. String
#include <tools/string.hxx>
#endif

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#include "schview.hxx"
#include "schmod.hxx"
#include "schresid.hxx"
#include "chwindow.hxx"
#include "docshell.hxx"
#include "dragserv.hxx"
#include "objid.hxx"
#include "datarow.hxx"
#include "datapoin.hxx"
#include "uninstit.hxx"
#include "uninsleg.hxx"
#include "unmultdp.hxx"
#include "viewshel.hxx"
#include "strings.hrc"
#include "glob.hrc"
#include "schgroup.hxx"
#include "eetext.hxx"
#include "docshell.hxx"
#include "viewshel.hxx"
#include "chaxis.hxx"
#include "axisobj.hxx"
#include "memchrt.hxx"

/*************************************************************************
|*
|* Konstruktor 1
|*
\************************************************************************/

SchView::SchView(SchChartDocShell* pDocShell,
				 OutputDevice* pOutDev,
				 SchViewShell* pViewShell)
  : E3dView(&pDocShell->GetDoc(), pOutDev),
	pDoc(&pDocShell->GetDoc()),
	pDocSh(pDocShell),
	pViewSh(pViewShell),
	bDragActive (FALSE),
	nLogicalMarked(FALSE),
	nLogicalEntered(FALSE)
{
	Construct();
}

/*************************************************************************
|*
|* Konstruktor 2
|*
\************************************************************************/

SchView::SchView(ChartModel* pDocument,
				 OutputDevice* pOutDev)
  : E3dView(pDocument, pOutDev),
	pDoc(pDocument),
	pDocSh(NULL),
	pViewSh(NULL),
	bDragActive (FALSE),
	nLogicalMarked(FALSE),
	nLogicalEntered(FALSE)
{
	Construct();
}

/*************************************************************************
|*
|* Construct
|*
\************************************************************************/

void SchView::Construct()
{
	SetUseIncompatiblePathCreateInterface(TRUE);

	OutputDevice* pOut = GetWin(0);

	if (pOut)
		SetMinMoveDistancePixel (pOut->PixelToLogic(Size(2, 0)).Width());

	SetHitTolerancePixel (2);
	EnableExtendedKeyInputDispatcher (FALSE);
	EnableExtendedMouseEventDispatcher (FALSE);
	EnableExtendedCommandEventDispatcher (FALSE);
	bBordVisible = FALSE;

	if (pDocSh && pDocSh->GetCreateMode() != SFX_CREATE_MODE_EMBEDDED)
		bPageVisible = FALSE;

	bGlueVisible  =
	bGlueVisible2 =
	bGlueVisible3 = TRUE;
	SetCurrentObj(OBJ_RECT, SdrInventor);

	if (pDoc->GetPageCount() == 0L)
	{
		// Seite einfuegen
		BOOL bChanged = pDoc->IsChanged();
		SdrPage* pPage = pDoc->AllocPage(FALSE);

		if (pDocSh)
			pPage->SetSize(pDocSh->GetVisArea(ASPECT_CONTENT).GetSize());

		pDoc->InsertPage(pPage);
		pDoc->BuildChart(FALSE);
		pDoc->SetChanged(bChanged);
	}
}

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

SchView::~SchView()
{
	aTimer.Stop();
	for (USHORT nWin = 0; nWin < GetWinCount(); nWin++)
	{
		OutputDevice* pOutDev = GetWin(nWin);

		if (pOutDev->GetOutDevType() == OUTDEV_WINDOW)
			DelWin((SchWindow*)pOutDev);
	}
}

/*************************************************************************
|*
|* virtuelle Methode von SdrView, der die anfallenden Undo-Aktionen
|* uebergeben werden
|*
\************************************************************************/

BOOL SchView::NotifyNewUndoAction()
{
	return TRUE;
}

/*************************************************************************
|*
|* virtuelle Methode von SdrView, wird bei Selektionsaenderung gerufen
|*
\************************************************************************/

void SchView::MarkListHasChanged()
{
	E3dView::MarkListHasChanged();
	if ( pViewSh )
		pViewSh->SelectionHasChanged();

	aTimer.SetTimeoutHdl( LINK( this, SchView, NotifySelection) );
	// Timer reset
	aTimer.SetTimeout(100);
	aTimer.Start();
}

/*************************************************************************
|*
|* Entfernt Chart-Userdaten
|*
\************************************************************************/

void SchView::DeleteChartUserData(ChartModel& rDoc)
{
	SdrPage* pPage = rDoc.GetPage(0);
	DBG_ASSERT(pPage, "Keine Seite vorhanden!");

	SdrObjListIter aIterator(*pPage, IM_DEEPWITHGROUPS);
	while (aIterator.IsMore())
	{
		SdrObject* pObj = aIterator.Next();

		USHORT nPos = 0;

		do
		{
			SdrObjUserData *pData = pObj->GetUserData(nPos);

			if (pData)
				switch (pData->GetId())
				{
					case SCH_LIGHTFACTOR_ID:
						DBG_ERROR("SCH_LIGHTFACTOR_ID ist im Chart abgeschafft!");
					case SCH_OBJECTID_ID:
					case SCH_OBJECTADJUST_ID:
					case SCH_DATAROW_ID:
					case SCH_DATAPOINT_ID:
						pObj->DeleteUserData(nPos);
						break;

					default:
						nPos++;
						break;
				}
				else
				nPos++;
		}
		while (nPos < pObj->GetUserDataCount());
	}
}

/*************************************************************************
|*
|* DataObject fuer Drag&Drop erzeugen
|*
\************************************************************************/

SchDragServerRef SchView::CreateDataObject(SchView* pView,
										   const Point& rDragPos)
{
	CHART_TRACE( "SchView::CreateDataObject( SchView* )" );

	SchDragServerRef pDataObject = new SchDragServer(pView);
		SCH_MOD1()->SetDragData(pDataObject);

	// ObjectDescriptor aufbauen
	SchChartDocShell* pDocShell = (SchChartDocShell*)pDoc->GetObjectShell();
	SvObjectDescriptor* pObjDesc = new SvObjectDescriptor(pDocShell, rDragPos);
	pObjDesc->SetSize(GetAllMarkedRect().GetSize());

	// Wenn der selektierte Bereich gelinkt werden kann
	String aLinkName = GetStatusText();
//	  pObjDesc->SetDisplayName(aLinkName);

	// Wenn das Dokument, nicht aber der selektierte Bereich gelinkt werden kann
	pObjDesc->SetCanLink(FALSE);

	// Eigentuemeruebergang
	pDataObject->SetObjectDescriptor(pObjDesc);

	pDataObject->pSchView = pView;
	pDataObject->aStartPos = rDragPos;

	return pDataObject;
}


/*************************************************************************
|*
|* DataObject fuers Clipboard erzeugen
|*
\************************************************************************/

SchDragServerRef SchView::CreateDataObject(ChartModel* pDocument)
{
	CHART_TRACE( "SchView::CreateDataObject(pModel)" );
	// DataObject aufbauen
	SchDragServerRef pDataObject = new SchDragServer(pDocument);
		SCH_MOD1()->SetClipboardData(pDataObject);

	// ObjectDescriptor aufbauen
	SchChartDocShell* pDocShell = (SchChartDocShell*)pDoc->GetObjectShell();
	SvObjectDescriptor* pObjDesc = new SvObjectDescriptor(pDocShell, Point());
	pObjDesc->SetSize(GetAllMarkedRect().GetSize());

	// Wenn der selektierte Bereich gelinkt werden kann
	String aLinkName = GetStatusText();
//	  pObjDesc->SetDisplayName(aLinkName);

	// Wenn das Dokument, nicht aber der selektierte Bereich gelinkt werden kann
	pObjDesc->SetCanLink(FALSE);

	// Eigentuemeruebergang
	pDataObject->SetObjectDescriptor(pObjDesc);

	pDataObject->CopyClipboard();

	return pDataObject;
}

/*************************************************************************
|*
|* QueryDrop-Event
|*
\************************************************************************/

BOOL SchView::QueryDrop(DropEvent& rEvt, SchWindow* pWin,
					   USHORT nPage, USHORT nLayer)
{
	CHART_TRACE( "SchView::QueryDrop" );

	if(pDocSh->IsReadOnly())return FALSE;

	BOOL bReturn = FALSE;

	SdrPageView* pPV = GetPageViewPvNum(0);

	if (!pPV->IsLayerLocked(GetActiveLayer()))
	{
		// Drop nur moeglich, wenn der aktive Layer nicht gesperrt

		BOOL bIsInsideOutlinerView = FALSE;

		const OutlinerView* pOLV = GetTextEditOutlinerView();

		if (pOLV)
		{
			Rectangle aRect(pOLV->GetOutputArea());

			Point aPos = pWin->PixelToLogic(rEvt.GetPosPixel());

			if (aRect.IsInside(aPos))
			{
				bIsInsideOutlinerView = TRUE;
				bReturn = ((OutlinerView*)pOLV)->QueryDrop(rEvt);
			}
		}

		if (!bIsInsideOutlinerView)
		{
		   SchDragServerRef pDataObject = SCH_MOD1()->GetDragData();

			if (pDataObject)
			{
				// Pointer auf Source-View
				SchView* pSourceView = pDataObject->pSchView;

				if (pSourceView)
				{
					// Eigenes Format innerhalb einer View immer

					bReturn = TRUE;

					if (pSourceView != this)
					{
						SdrPage* pPage = NULL;
						SdrLayer* pLayer = NULL;

						if (nPage != SDRPAGE_NOTFOUND)
							pPage = GetDoc().GetPage(nPage);

						if (nLayer != SDRLAYER_NOTFOUND)
						{
							SdrLayerAdmin& rLayerAdmin = GetDoc().GetLayerAdmin();
							pLayer = rLayerAdmin.GetLayer(nLayer);
						}

						if (pPage || pLayer)
							// Unterschiedliche Views: Drop auf Page oder Layer
							// z.Z. nicht moeglich

							bReturn = FALSE;
					}
				}
			}
			else
			{
				// zusaetzlich wird jetzt auch das FILE-Format
				// fuer einzufuegende OLE-Objekte unterstuetzt
				// (KA 02.08.1995)
				bReturn = IsDragDropFormatSupported() ||
						  DragServer::HasFormat(0, FORMAT_FILE);
			}
		}
	}

	return bReturn;
}

/*************************************************************************
|*
|* Drop-Event
|*
\************************************************************************/

BOOL SchView::Drop(const DropEvent& rMEvt, SchWindow* pWin,
				  USHORT nPage, USHORT nLayer)
{

	if(pDocSh->IsReadOnly())return FALSE;
	BOOL bReturn = FALSE;

	SdrPageView* pPV = GetPageViewPvNum(0);

	if (!pPV->IsLayerLocked(GetActiveLayer()))
	{
		// Drop nur moeglich, wenn der aktive Layer nicht gesperrt

		const OutlinerView* pOLV = GetTextEditOutlinerView();

		if (pOLV)
		{
			Rectangle aRect(pOLV->GetOutputArea());

			Point aPos = pWin->PixelToLogic(rMEvt.GetPosPixel());

			if (aRect.IsInside(aPos))
			{
				bReturn = TRUE;
				((OutlinerView*)pOLV)->Drop(rMEvt);
			}
		}

		if (!bReturn)
		{
			Point aPos (0, 0);

			if (pWin)
				aPos = pWin->PixelToLogic(rMEvt.GetPosPixel());

						SvDataObjectRef aDataObj = SCH_MOD1()->GetDragData();

			if (!aDataObj.Is())
				aDataObj = SvDataObject::PasteDragServer(rMEvt);

			if (aDataObj.Is())
			{
				bReturn = InsertData(aDataObj, aPos, rMEvt.GetAction() == DROP_COPY,
									 0, nPage, nLayer);
			}
		}
	}

	return bReturn;
}

/*************************************************************************
|*
|* Cut object to clipboard
|*
\************************************************************************/

BOOL SchView::DoCut(Window* pWindow)
{
	CHART_TRACE( "SchView::DoCut" );

	const OutlinerView* pOLV = GetTextEditOutlinerView();

	if(pDocSh->IsReadOnly())return FALSE;

	if (pOLV)
		((OutlinerView*)pOLV)->Cut();
	else if (HasMarkedObj() && CanDeleteMarkedObjects())
	{
		BrkAction();

		SdrOle2Obj* pOle2Obj = NULL;

		const SdrMarkList& rMarkList = GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SdrMark* pMark = rMarkList.GetMark(0);
			SdrObject* pObj = pMark->GetObj();

			UINT16 nSdrObjKind = pObj->GetObjIdentifier();

			if (nSdrObjKind == OBJ_OLE2)
				pOle2Obj = (SdrOle2Obj*)pObj;
		}

		if ( pOle2Obj && pOle2Obj->GetObjRef().Is() )
			pOle2Obj->GetObjRef()->CopyClipboard();
		else
			SchDragServerRef pDataObject =
				CreateDataObject((ChartModel*)GetAllMarkedModel());

		DeleteMarkedObjects(String(SchResId(STR_UNDO_CUT)));
	}
	else
		return FALSE;

	return TRUE;
}

/*************************************************************************
|*
|* Copy object to clipboard
|*
\************************************************************************/

void SchView::DoCopy(Window* pWindow)
{
	CHART_TRACE( "SchView::DoCopy" );
	const OutlinerView* pOLV = GetTextEditOutlinerView();

	if (pOLV)
		( (OutlinerView*) pOLV)->Copy();
	else if (HasMarkedObj())
	{
		BrkAction();

		SdrOle2Obj* pOle2Obj = NULL;

		const SdrMarkList& rMarkList = GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SdrMark* pMark = rMarkList.GetMark(0);
			SdrObject* pObj = pMark->GetObj();

			UINT16 nSdrObjKind = pObj->GetObjIdentifier();

			if (nSdrObjKind == OBJ_OLE2)
				pOle2Obj = (SdrOle2Obj*) pObj;
		}

		if ( pOle2Obj && pOle2Obj->GetObjRef().Is() )
			pOle2Obj->GetObjRef()->CopyClipboard();
		else
			SchDragServerRef pDataObject =
				CreateDataObject((ChartModel*)GetAllMarkedModel());
	}
}

/*************************************************************************
|*
|* Paste object from clipboard
|*
\************************************************************************/

void SchView::DoPaste(Window* pWindow)
{
	CHART_TRACE( "SchView::DoPaste" );

	if(!pDocSh->IsReadOnly())
	{

		const OutlinerView* pOLV = GetTextEditOutlinerView();

		if (pOLV)
			((OutlinerView*)pOLV)->PasteSpecial();
		else
		{
			Point aPos;

			if (pWindow)
			{
				Size aSize = pWindow->GetOutputSizePixel();
				Rectangle aRect(aPos, aSize);
				aPos = aRect.Center();
				aPos = pWindow->PixelToLogic(aPos);
			}

					SvDataObjectRef aDataObj = SCH_MOD1()->GetClipboardData();

			if (!aDataObj.Is())
				aDataObj = SvDataObject::PasteClipboard();

			if (aDataObj.Is())
			{
				InsertData(aDataObj, aPos, TRUE);
			}
		}
	}
}

/*************************************************************************
|*
|* Texteingabe beginnen
|*
\************************************************************************/

FASTBOOL SchView::BegTextEdit(SdrObject* pObj, SdrPageView* pPV, Window* pWin,
							  FASTBOOL bIsNewObj, SdrOutliner* pGivenOutliner,
							  OutlinerView* pGivenOutlinerView,
							  FASTBOOL bDontDeleteOutliner,
							  FASTBOOL bOnlyOneView)
{
	BOOL bReturn =
				E3dView::BegTextEdit(pObj, pPV, pWin, bIsNewObj, pGivenOutliner,
							 pGivenOutlinerView, bDontDeleteOutliner,
							 bOnlyOneView);

	if (bReturn)
	{
		// UndoManager an der obersten Shell (SdDrawTextObjectBar) setzen
		SdrOutliner* pOutliner = GetTextEditOutliner();
		SFX_DISPATCHER().GetShell(0)->
			SetUndoManager(&pOutliner->GetUndoManager());
	}

	return bReturn;
}

/*************************************************************************
|*
|* Texteingabe beenden
|*
\************************************************************************/

SdrEndTextEditKind SchView::EndTextEdit()
{
	SdrEndTextEditKind eKind = E3dView::EndTextEdit( TRUE );

	// UndoManager an der obersten Shell setzen
	SchChartDocShell* pDocShell = (SchChartDocShell*)pDoc->GetObjectShell();
	SfxUndoManager* pUndoMgr = pDocShell->GetUndoManager();

	SfxShell* pShell = SFX_DISPATCHER().GetShell(0);

	if (pShell->ISA(SchViewShell))
	{
		pShell->SetUndoManager(pUndoMgr);
	}
	Window& rWin = (Window&)(*GetWin( 0 ));
	Rectangle aAll = Rectangle( 0, 0, 0, 0 );
	aAll.SetSize( rWin.GetOutputSize() );
	MakeVisible( aAll, rWin );

	return eKind;
}

/*************************************************************************
|*
|* Ermittelt, ob Chart-Objekt selektiert ist
|*
\************************************************************************/

BOOL SchView::IsChartObjSelected()
{
	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();

		for (ULONG i = 0; i < nCount; i++)
			if (GetObjectId(*aMark.GetMark(i)->GetObj()))
				return TRUE;
	}

	return FALSE;
}

/*************************************************************************
|*
|* Prueft, ob Objekte geloescht werden koennen
|*
\************************************************************************/

BOOL SchView::CanDeleteMarkedObjects()
{

	if(pDocSh->IsReadOnly())return FALSE;
	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();

		for (ULONG i = 0; i < nCount; i++)
		{
			SchObjectId* pId = GetObjectId(*aMark.GetMark(i)->GetObj());
			if (pId)
			{
				if (nCount > 1)
					return FALSE;

				switch (pId->GetObjId())
				{
					case CHOBJID_TITLE_MAIN:
					case CHOBJID_TITLE_SUB:
					case CHOBJID_DIAGRAM_TITLE_X_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
					case CHOBJID_LEGEND:
						return TRUE;

					default:
						return FALSE;
				}
			}
		}
	}

	return TRUE;
}

/*************************************************************************
|*
|* Loescht ggf. markierte Objekte;
|* Liefert FALSE, wenn ein markiertes Chart-Objekt nicht geloescht
|* werden konnte.
|*
\************************************************************************/

BOOL SchView::DeleteMarkedObjects(const String& rUndoStr)
{
	if(pDocSh->IsReadOnly())return FALSE;
	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();

		for (ULONG i = 0; i < nCount; i++)
		{
			SchObjectId* pId = GetObjectId(*aMark.GetMark(i)->GetObj());
			if (pId)
			{
				if (nCount > 1)
					return FALSE;

				UINT16 nId = pId->GetObjId();

				switch (nId)
				{
					case CHOBJID_TITLE_MAIN:
					case CHOBJID_TITLE_SUB:
					case CHOBJID_DIAGRAM_TITLE_X_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
					{
						BOOL bOldShowMain   = pDoc->ShowMainTitle();
						String aOldMain     = pDoc->MainTitle();
						BOOL bOldShowSub    = pDoc->ShowSubTitle();
						String aOldSub      = pDoc->SubTitle();
						BOOL bOldShowXAxis  = pDoc->ShowXAxisTitle();
						String aOldXAxis    = pDoc->XAxisTitle();
						BOOL bOldShowYAxis  = pDoc->ShowYAxisTitle();
						String aOldYAxis    = pDoc->YAxisTitle();
						BOOL bOldShowZAxis  = pDoc->ShowZAxisTitle();
						String aOldZAxis    = pDoc->ZAxisTitle();

						BOOL bNewShowMain	= (nId == CHOBJID_TITLE_MAIN) ?
											  FALSE : bOldShowMain;
						BOOL bNewShowSub	= (nId == CHOBJID_TITLE_SUB) ?
											  FALSE : bOldShowSub;
						BOOL bNewShowXAxis	= (nId == CHOBJID_DIAGRAM_TITLE_X_AXIS) ?
											  FALSE : bOldShowXAxis;
						BOOL bNewShowYAxis	= (nId == CHOBJID_DIAGRAM_TITLE_Y_AXIS) ?
											  FALSE : bOldShowYAxis;
						BOOL bNewShowZAxis	= (nId == CHOBJID_DIAGRAM_TITLE_Z_AXIS) ?
											  FALSE : bOldShowZAxis;

						pDoc->ChangeTitle(bNewShowMain, aOldMain,
											bNewShowSub, aOldSub,
											bNewShowXAxis, aOldXAxis,
											bNewShowYAxis, aOldYAxis,
											bNewShowZAxis, aOldZAxis);

						SchUndoInsertTitle* pUndo =
							new SchUndoInsertTitle(*pDoc, bOldShowMain,
												   aOldMain, bOldShowSub,
												   aOldSub, bOldShowXAxis,
												   aOldXAxis, bOldShowYAxis,
												   aOldYAxis, bOldShowZAxis,
												   aOldZAxis,
												   bNewShowMain, aOldMain,
												   bNewShowSub, aOldSub,
												   bNewShowXAxis, aOldXAxis,
												   bNewShowYAxis, aOldYAxis,
												   bNewShowZAxis, aOldZAxis);
						pUndo->SetComment(rUndoStr);

						pDoc->GetObjectShell()->
							GetUndoManager()->AddUndoAction(pUndo);
						return TRUE;
					}

					case CHOBJID_LEGEND:
					{
						SfxItemSet aAttr = pDoc->GetLegendAttr();
						const SfxPoolItem *pPoolItem = NULL;
						BOOL bVisible = pDoc->GetShowLegend ();
						SvxChartLegendPos eOldPos =	(aAttr.GetItemState(SCHATTR_LEGEND_POS,
																		TRUE, &pPoolItem) == SFX_ITEM_SET)
														? ((const SvxChartLegendPosItem*)pPoolItem)->GetValue()
														: CHLEGEND_NONE;
						aAttr.Put(SvxChartLegendPosItem(CHLEGEND_NONE));
						pDoc->SetShowLegend (FALSE);
						pDoc->ChangeLegendAttr(aAttr);//, TRUE);
						SchUndoInsertLegend* pUndo = new SchUndoInsertLegend(*pDoc, eOldPos, CHLEGEND_NONE,
																			 bVisible, FALSE);
						pUndo->SetComment(rUndoStr);

						pDoc->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
						return TRUE;
					}

					default:
						return FALSE;
				}
			}
		}

		BegUndo(rUndoStr);
		DeleteMarked();
		EndUndo();
	}

	return TRUE;
}

/*************************************************************************
|*
|* Ermittelt, ob Daten-Reihen/Punkt-Attribute gesetzt werden koennen
|*
\************************************************************************/

BOOL SchView::CanSetDataAttr()
{
	if (HasMarkedObj() && aMark.GetMarkCount() == 1)
	{
		SdrObject* pObj = aMark.GetMark(0)->GetObj();

		return GetDataRow(*pObj) || GetDataPoint(*pObj);
	}

	return FALSE;
}

/*************************************************************************
|*
|* Verschiebt die markierten Objekte an den angegebenen Objekt-Index
|*
\************************************************************************/

void SchView::PutMarkedToPos(ULONG nObjPos)
{
	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();

		for (ULONG i = 0; i < nCount; i++)
		{
			SdrObject*	pObj = aMark.GetMark(i)->GetObj();
			SdrObjList* pList = pObj->GetObjList();
			DBG_ASSERT(pList, "Objekt ist in keiner Liste");
			pList->SetObjectOrdNum(pObj->GetOrdNum(), nObjPos++);
			MarkListHasChanged();
		}
	}
}

/*************************************************************************
|*
|* Verschiebt die markierten Objekte um eine Indexposition zum
|* angegebenen Objekt-Index
|*
\************************************************************************/

void SchView::MovMarkedToPos(ULONG nObjPos)
{
	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();

		for (ULONG i = 0; i < nCount; i++)
		{
			SdrObject*	pObj = aMark.GetMark(i)->GetObj();
			SdrObjList* pList = pObj->GetObjList();
			DBG_ASSERT(pList, "Objekt ist in keiner Liste");
			ULONG nIndex = pObj->GetOrdNum();
			if (nIndex	> nObjPos)
			{
				pList->SetObjectOrdNum(pObj->GetOrdNum(), nIndex - 1);
				MarkListHasChanged();
			}
			else if (nIndex < nObjPos)
			{
				pList->SetObjectOrdNum(pObj->GetOrdNum(), nIndex + 1);
				MarkListHasChanged();
			}
		}
	}
}

/*************************************************************************
|*
|* Kontext-String fuer Statusbar
|*
\************************************************************************/

String SchView::GetContext()
{
	SdrObject	 *pObj  = NULL;
	SchDataRow	 *pRow  = NULL;
	SchDataPoint *pPoint= NULL;

	long nSubRow=-1;
	String aResult( SchResId( STR_MARKED ));

	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();
		if (nCount >= 1)//>=, da im 3D alle Unterobjekte markiert
		{
			pObj=aMark.GetMark(0)->GetObj();
			SchObjectId* pId = GetObjectId(*pObj);
			if (pId)
			{
				USHORT nId;

				switch (pId->GetObjId())
				{
					case CHOBJID_DIAGRAM_AREA:
						nId = STR_DIAGRAM_AREA;
						break;

					case CHOBJID_TITLE_MAIN:
						nId = STR_TITLE_MAIN;
						break;;

					case CHOBJID_TITLE_SUB:
						nId = STR_TITLE_SUB;
						break;

					case CHOBJID_DIAGRAM:
						nId = STR_DIAGRAM;
						break;

					case CHOBJID_DIAGRAM_WALL:
						nId = STR_DIAGRAM_WALL;
						break;

					case CHOBJID_DIAGRAM_FLOOR:
						nId = STR_DIAGRAM_FLOOR;
						break;

					case CHOBJID_DIAGRAM_TITLE_X_AXIS:
						nId = STR_DIAGRAM_TITLE_X_AXIS;
						break;

					case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
						nId = STR_DIAGRAM_TITLE_Y_AXIS;
						break;

					case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
						nId = STR_DIAGRAM_TITLE_Z_AXIS;
						break;

					case CHOBJID_DIAGRAM_A_AXIS:
					case CHOBJID_DIAGRAM_X_AXIS:
						nId = STR_DIAGRAM_X_AXIS;
						break;

					case CHOBJID_DIAGRAM_B_AXIS:
					case CHOBJID_DIAGRAM_Y_AXIS:
						nId = STR_DIAGRAM_Y_AXIS;
						break;

					case CHOBJID_DIAGRAM_C_AXIS:
					case CHOBJID_DIAGRAM_Z_AXIS:
						nId = STR_DIAGRAM_Z_AXIS;
						break;

					case CHOBJID_DIAGRAM_X_GRID_MAIN:
						nId = STR_DIAGRAM_X_GRID_MAIN;
						break;

					case CHOBJID_DIAGRAM_Y_GRID_MAIN:
						nId = STR_DIAGRAM_Y_GRID_MAIN;
						break;

					case CHOBJID_DIAGRAM_Z_GRID_MAIN:
						nId = STR_DIAGRAM_Z_GRID_MAIN;
						break;

					case CHOBJID_DIAGRAM_X_GRID_HELP:
						nId = STR_DIAGRAM_X_GRID_HELP;
						break;

					case CHOBJID_DIAGRAM_Y_GRID_HELP:
						nId = STR_DIAGRAM_Y_GRID_HELP;
						break;

					case CHOBJID_DIAGRAM_Z_GRID_HELP:
						nId = STR_DIAGRAM_Z_GRID_HELP;
						break;

					case CHOBJID_DIAGRAM_ROWGROUP:
					case CHOBJID_DIAGRAM_ROWS:
					case CHOBJID_DIAGRAM_ROWSLINE:
					case CHOBJID_DIAGRAM_SPECIAL_GROUP:
					case CHOBJID_DIAGRAM_STACKEDGROUP:
						pRow = GetDataRow(*pObj);
						if(!pRow)
						{
							pPoint  = GetDataPoint(*pObj);
							nSubRow = pPoint->GetRow();
							pPoint  = NULL;
						}
						nId = STR_DIAGRAM_ROW;
						break;

					case CHOBJID_DIAGRAM_DATA:
						nId    = STR_STATUS_DATAPOINT_MARKED;
						pPoint = GetDataPoint(*pObj);
						break;

					case CHOBJID_DIAGRAM_DESCRGROUP:
						nId = STR_DIAGRAM_DESCRGROUP;
						break;

					case CHOBJID_DIAGRAM_DESCR_ROW:
						nId = STR_DIAGRAM_DESCR_ROW;
						break;

					case CHOBJID_DIAGRAM_DESCR_COL:
						nId = STR_DIAGRAM_DESCR_COL;
						break;

					case CHOBJID_LEGEND:
						nId = STR_LEGEND;
						break;

					case CHOBJID_LEGEND_SYMBOL_ROW:
						nId = STR_LEGEND_SYMBOL_ROW;
						//pRow = GetDataRow(*pObj);
						break;

					case CHOBJID_LEGEND_SYMBOL_COL:
						nId = STR_LEGEND_SYMBOL_COL;
						break;

					default:
						nId = 0;
						break;
				}

				if (nId != 0)
				{
					if(pRow)
					{
						SchResId aSchResId(nId);
						String aStrObj( aSchResId );
						aStrObj.SearchAndReplaceAscii( "$(ROW)", String::CreateFromInt32( pRow->GetRow() + 1 ));
						aResult.SearchAndReplaceAscii( "$(OBJ)", aStrObj);
						return aResult;
					}
					else if(nSubRow!=-1) //3D-Unterobjekte
					{
						SchResId aSchResId(nId);
						String aStrObj( aSchResId );
						aStrObj.SearchAndReplaceAscii( "$(ROW)", String::CreateFromInt32( nSubRow + 1 ));
						aResult.SearchAndReplaceAscii( "$(OBJ)", aStrObj);
						return aResult;
					}
					if(pPoint)
					{
						long nCol=pPoint->GetCol();
						long nRow=pPoint->GetRow();
						String aText;
						long nUId=((const SfxInt32Item&)pDoc->GetDataRowAttr(nRow).Get(SCHATTR_AXIS)).GetValue();
						ChartAxis *pAxis=pDoc->GetAxisByUID(nUId);
						long nNumf=pAxis->GetNumFormat(FALSE);

						Color* pDummy = NULL;
						pDoc->GetNumFormatter()->GetOutputString(
							pDoc->GetData(nCol,nRow),nNumf,aText,&pDummy);

						aResult = String( SchResId( STR_STATUS_DATAPOINT_MARKED ));
						aResult.SearchAndReplaceAscii( "$(PT_NUM)",  String::CreateFromInt32( nCol + 1 ) );
						aResult.SearchAndReplaceAscii( "$(ROW_NUM)", String::CreateFromInt32( nRow + 1 ) );
						aResult.SearchAndReplaceAscii( "$(VALUE)",   aText );

						return  aResult;
					}

					aResult.SearchAndReplaceAscii( "$(OBJ)", String( SchResId( nId )) );
					return  aResult;
				}
			}
		}
	}

	return E3dView::GetStatusText();
}

/*************************************************************************
|*
|* Kontext-Typ-String fuer Statusbar
|*
\************************************************************************/

String SchView::GetContextType()
{
	USHORT nDimId, nTypeId, nVariantId;
	String aString;

	switch (pDoc->ChartStyle())
	{
		case CHSTYLE_2D_LINE:
			nDimId		= STR_2D;
			nTypeId		= STR_LINES;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_2D_STACKEDLINE:
			nDimId		= STR_2D;
			nTypeId		= STR_LINES;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_2D_PERCENTLINE:
			nDimId		= STR_2D;
			nTypeId		= STR_LINES;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_2D_COLUMN:
			nDimId		= STR_2D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_2D_STACKEDCOLUMN:
			nDimId		= STR_2D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_2D_PERCENTCOLUMN:
			nDimId		= STR_2D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_2D_BAR:
			nDimId		= STR_2D;
			nTypeId		= STR_BARS;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_2D_STACKEDBAR:
			nDimId		= STR_2D;
			nTypeId		= STR_BARS;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_2D_PERCENTBAR:
			nDimId		= STR_2D;
			nTypeId		= STR_BARS;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_2D_AREA:
			nDimId		= STR_2D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_2D_STACKEDAREA:
			nDimId		= STR_2D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_2D_PERCENTAREA:
			nDimId		= STR_2D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_2D_PIE:
			nDimId		= STR_2D;
			nTypeId		= STR_CIRCLES;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_3D_STRIPE:
			nDimId		= STR_3D;
			nTypeId		= STR_LINES;
			nVariantId	= STR_DEEP;
			break;

		case CHSTYLE_3D_COLUMN:
			nDimId		= STR_3D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_DEEP;
			break;

		case CHSTYLE_3D_FLATCOLUMN:
			nDimId		= STR_3D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_NORMAL;
			break;

		case CHSTYLE_3D_STACKEDFLATCOLUMN:
			nDimId		= STR_3D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_3D_PERCENTFLATCOLUMN:
			nDimId		= STR_3D;
			nTypeId		= STR_COLUMNS;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_3D_AREA:
			nDimId		= STR_3D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_DEEP;
			break;

		case CHSTYLE_3D_STACKEDAREA:
			nDimId		= STR_3D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_STACKED;
			break;

		case CHSTYLE_3D_PERCENTAREA:
			nDimId		= STR_3D;
			nTypeId		= STR_AREAS;
			nVariantId	= STR_PERCENT;
			break;

		case CHSTYLE_3D_PIE:
			nDimId		= STR_3D;
			nTypeId		= STR_CIRCLES;
			nVariantId	= STR_NORMAL;
			break;

		default:
			return aString;
	}

	aString += String(SchResId(nDimId));
	aString += String(SchResId(nTypeId));
	aString += sal_Unicode( ' ' );
	aString += String(SchResId(nVariantId));

	return aString;
}

/*************************************************************************
|*
|* DragServer starten
|*
\************************************************************************/

BOOL SchView::BeginDrag(Window* pWindow, Point aStartPos)
{
	CHART_TRACE( "SchView::BeginDrag" );

	BOOL bReturn = FALSE;

	if (HasMarkedObj())
	{
		BrkAction();

		SdrOle2Obj* pOle2Obj = NULL;

		const SdrMarkList& rMarkList = GetMarkList();

		if (rMarkList.GetMarkCount() == 1)
		{
			SdrMark* pMark = rMarkList.GetMark(0);
			SdrObject* pObj = pMark->GetObj();

			UINT16 nSdrObjKind = pObj->GetObjIdentifier();

			if (nSdrObjKind == OBJ_OLE2)
				pOle2Obj = (SdrOle2Obj*)pObj;
		}

		SchDragServerRef pDataObject = CreateDataObject(this, aStartPos);

		SdrMarkList aMarkList (GetMarkList());

		BegUndo(String(SchResId(STR_UNDO_DRAGDROP)));

		DropAction eDropAction;

		Region aRegion(GetAllMarkedRect()) ;

		bDragActive = TRUE;
		if (pOle2Obj && pOle2Obj->GetObjRef().Is())
			eDropAction = pOle2Obj->GetObjRef()->ExecuteDrag(pWindow,
												POINTER_MOVEDATA,
												POINTER_COPYDATA,
												DRAG_ALL,
												&aRegion);
		else
			eDropAction = pDataObject->ExecuteDrag(pWindow, POINTER_MOVEDATA,
												   POINTER_COPYDATA, DRAG_ALL,
												   &aRegion);
		bDragActive = FALSE;

		pDataObject->pSchView = NULL; // Source-View nicht mehr vorhanden
		switch (eDropAction)
		{
			case DROP_MOVE:
			case DROP_DISCARD:
				if (!pDataObject->bInternalMove)
				{
//					DeleteMarked(aMarkList);
					DeleteMarked();
//					GetModel()->SendSomeObjChgBroadcast();
				}
				break;

			case DROP_NONE:
			case DROP_COPY:
			case DROP_LINK:
			case DROP_PRINT:
				break;

			default:
				break;
		}

		if (eDropAction != DROP_NONE)
			bReturn = TRUE;

		pDataObject->bInternalMove = FALSE;

		EndUndo();
	}

	return bReturn;
}

/*************************************************************************
|*
|* Paste
|*
\************************************************************************/

BOOL SchView::InsertData(SvDataObject* pDataObject, const Point& rPos,
						 BOOL bCopy, ULONG nFormat, USHORT nPage,
						 USHORT nLayer)
{
	CHART_TRACE( "SchView::InsertData" );

	BOOL bReturn = FALSE;

	SdrPage*	pPage = NULL;
	const ULONG nGraphicExchangeFormat = SOT_FORMATSTR_ID_SVXB;

	if (nPage != SDRPAGE_NOTFOUND)
		pPage = GetDoc().GetPage(nPage);

	SchDragServer* pOwnData = NULL;
		if (pDataObject == SCH_MOD1()->GetDragData())
				pOwnData = SCH_MOD1()->GetDragData();
		else if (pDataObject == SCH_MOD1()->GetClipboardData())
				pOwnData = SCH_MOD1()->GetClipboardData();

	if (pOwnData && nFormat==0)
	{
		// Eigene Daten

		SchView* pSourceView = NULL;

		// Pointer auf Source-View

		pSourceView = pOwnData->pSchView;

		if (pSourceView)
		{
			// Internes Drop

			if (pSourceView == this)
			{
				// View intern

				if (pPage)
				{
					// Drop auf Seiten-TabBar

					SdrMarkList aMarkList = GetMarkList();
					aMarkList.ForceSort();

					for (ULONG nM = 0; nM < aMarkList.GetMarkCount(); nM++)
					{
						SdrMark* pM = aMarkList.GetMark(nM);
						SdrObject* pO = pM->GetObj()->Clone();

						if (pO)
							pPage->InsertObject(pO);
					}

					bReturn = TRUE;
				}
				else if (nLayer != SDRLAYER_NOTFOUND)
				{
					// Drop auf Layer-TabBar

					pOwnData->bInternalMove = TRUE;
					SdrMarkList aMarkList = GetMarkList();
					aMarkList.ForceSort();

					for (ULONG nM = 0; nM < aMarkList.GetMarkCount(); nM++)
					{
						SdrMark* pM = aMarkList.GetMark(nM);
						SdrObject* pO = pM->GetObj()->Clone();

						if (pO)
							pO->SetLayer( (SdrLayerID) nLayer);
					}

					bReturn = TRUE;
				}
				else
				{
					pOwnData->bInternalMove = TRUE;

					Size aVector(rPos.X() - pOwnData->aStartPos.X(),
								 rPos.Y() - pOwnData->aStartPos.Y());
					MoveAllMarked(aVector, bCopy);
				}
			}
			else
			{
				// Unterschiedliche Views

				ChartModel* pDoc =
					(ChartModel*)pSourceView->GetAllMarkedModel();
				DeleteChartUserData(*pDoc);
				bReturn = Paste(*pDoc, rPos, pPage);
				delete pDoc;
			}
		}
		else
		{
			// Internes Paste

			ChartModel* pDoc = pOwnData->pChartModel;
			DeleteChartUserData(*pDoc);
			bReturn = Paste(*pDoc, rPos, pPage);
		}
	}
	else if ( pDataObject->HasFormat( nGraphicExchangeFormat ) &&
			  ( nFormat == nGraphicExchangeFormat || nFormat==0 ) )
	{
		SvData aData( nGraphicExchangeFormat );

		if ( pDataObject->GetData( &aData ) )
		{
			Graphic* pGraphic = NULL;

			if ( aData.GetData( (SvDataCopyStream**) &pGraphic, Graphic::StaticType(), TRANSFER_MOVE ) )
				bReturn = InsertGraphic( *pGraphic, rPos );

			if ( pGraphic )
				delete pGraphic;
		}
	}
	else if (pDataObject->HasFormat(FORMAT_GDIMETAFILE) &&
			 (nFormat == FORMAT_GDIMETAFILE || nFormat == 0))
	{
		SvData aData (FORMAT_GDIMETAFILE);

		if (pDataObject->GetData(&aData))
		{
			GDIMetaFile* pMtf;

			if (aData.GetData(&pMtf, TRANSFER_MOVE))
				bReturn = SdrExchangeView::Paste(*pMtf, rPos, pPage);
		}
	}
	else if (pDataObject->HasFormat(FORMAT_BITMAP) &&
			 (nFormat == FORMAT_BITMAP || nFormat == 0))
	{
		SvData aData(FORMAT_BITMAP);

		if (pDataObject->GetData(&aData))
		{
			Bitmap* pBitmap;

			if (aData.GetData(&pBitmap, TRANSFER_MOVE))
				bReturn = SdrExchangeView::Paste(*pBitmap, rPos, pPage);
		}
	}
	else if (pDataObject->HasFormat(FORMAT_RTF) &&
			 (nFormat==FORMAT_RTF || nFormat==0))
	{
		SvData aData(FORMAT_RTF);

		if (pDataObject->GetData(&aData))
		{
			SvStorageStreamRef aStrm;

			if (aData.GetData(aStrm))
				bReturn = SdrExchangeView::Paste(*aStrm, EE_FORMAT_RTF, rPos, pPage);
		}
	}
	else if (pDataObject->HasFormat(FORMAT_STRING) &&
			 (nFormat == FORMAT_STRING || nFormat == 0))
	{
		SvData aData(FORMAT_STRING);

		if (pDataObject->GetData(&aData))
		{
			String aString;

			if (aData.GetData(aString))
				bReturn = SdrExchangeView::Paste(aString, rPos, pPage);
		}
	}

	MarkListHasChanged();

	return bReturn;
}


/*************************************************************************
|*
|*  ein Fenster invalidieren
|*
\************************************************************************/

BOOL SchView::InsertGraphic( const Graphic& rGraphic, const Point& rPos )
{
	/**********************************************************************
	* Es wird ein neues Objekt erzeugt
	**********************************************************************/
	const SdrPage*	pPage = GetPageViewPvNum( 0 )->GetPage();
	const MapMode	aMap100( MAP_100TH_MM );
	Size			aPageSize( pPage->GetSize() );
	Size			aSize;

	// Falls der PrefMapMode der Graphic MAP_PIXEL ist,
	// machen wir die logische Umrechnung ueber das Fenster,
	// um eine 1:1-Abbildung auf Pixel zu erreichen
	OutputDevice* pOut = GetWin( 0 );
	if( pOut && rGraphic.GetPrefMapMode().GetMapUnit() == MAP_PIXEL )
		aSize = pOut->PixelToLogic( rGraphic.GetPrefSize(), aMap100 );	// #67730#
	else
		aSize = OutputDevice::LogicToLogic( rGraphic.GetPrefSize(), rGraphic.GetPrefMapMode(), aMap100 );

	// Groesse ggf. auf Seitengroesse begrenzen
	aPageSize.Width() -= pPage->GetLftBorder() + pPage->GetRgtBorder();
	aPageSize.Height() -= pPage->GetUppBorder() + pPage->GetLwrBorder();

	// Falls Grafik zu gross, wird die Grafik
	// in die Seite eingepasst
	if ( aSize.Height() && aPageSize.Height() &&
		( aSize.Height() > aPageSize.Height() ) || ( aSize.Width()	> aPageSize.Width() ) )
	{
		double fGrfWH =	(double) aSize.Width() / aSize.Height();
		double fWinWH =	(double) aPageSize.Width() / aPageSize.Height();

		// Grafik an Pagesize anpassen (skaliert)
		if ( fGrfWH < fWinWH )
		{
			aSize.Width() = (long) ( aPageSize.Height() * fGrfWH );
			aSize.Height()= aPageSize.Height();
		}
		else if ( fGrfWH > 0. )
		{
			aSize.Width() = aPageSize.Width();
			aSize.Height()= (long) ( aPageSize.Width() / fGrfWH );
		}
	}

	const Point	aPos( rPos.X() - ( aSize.Width() >> 1 ), rPos.Y() - ( aSize.Height() >> 1 ) );

	InsertObject( new SdrGrafObj( rGraphic, Rectangle( aPos, aSize ) ),
				  *GetPageViewPvNum( 0 ), SDRINSERT_SETDEFLAYER );

	return TRUE;
}


/*************************************************************************
|*
|*  ein Fenster invalidieren
|*
\************************************************************************/

void SchView::InvalidateOneWin(Window& rWin, const Rectangle& rRect)
{
	rWin.Invalidate(rRect);
}
/*************************************************************************
|*
|* ex-IsDataRowSelected()
|*
\************************************************************************/

long SchView::GetSelectedRow() const
{
	long nRow=-1;

	if (HasMarkedObj())
	{
		const SdrMarkList& rMarkList = GetMarkList();

		for (USHORT nMark = 0;
			 nMark < rMarkList.GetMarkCount();// && bResult;
			 nMark++)
		{
			SdrMark* pMark = rMarkList.GetMark( 0 );
			SdrObject* pObj = pMark->GetObj();
			SchDataRow *pRow=GetDataRow(*pObj);
			if(pRow)
				nRow=pRow->GetRow();
		}
	}
	return nRow;
}

/*************************************************************************
|*
|* SetDefault, die Datenpunktattribute der selektierten Datenreihe(n) loeschen
|*
\************************************************************************/

void SchView::SetDefault()
{
	CHART_TRACE( "Chart SchView::SetDefault Datenpunktattribute der selektierten Datenreihe(n) loeschen" );
	const SdrMarkList& rMarkList = GetMarkList();

	for (USHORT nMark = 0; nMark < rMarkList.GetMarkCount(); nMark++)
	{
		SdrMark* pMark = rMarkList.GetMark(0);
		SdrObject* pObj = pMark->GetObj();
		SchObjectId* pObjId = GetObjectId(*pObj);

		UINT16 nObjId = pObjId->GetObjId();

		if (nObjId == CHOBJID_DIAGRAM_ROWGROUP)
		{
			// das MUSS eine Gruppe sein
			SchObjGroup* pGroup = (SchObjGroup*)pObj;
			SdrObjList* pSubList = pObj->GetSubList();

			USHORT nSubCount = (USHORT)pSubList->GetObjCount();


			if (nSubCount)
			{
				// UndoAction erzeugen
				SchUndoMultipleDataPoints* pUndoAction =
					new SchUndoMultipleDataPoints(*pDoc);

				SvxChartStyle aStyle = GetDoc().ChartStyle();

				// keine Datenpunkt-Objekte im Drawing-Layer?
				if (aStyle == CHSTYLE_2D_LINE           ||
					aStyle == CHSTYLE_2D_STACKEDLINE    ||
					aStyle == CHSTYLE_2D_PERCENTLINE    ||
					aStyle == CHSTYLE_2D_AREA           ||
					aStyle == CHSTYLE_2D_STACKEDAREA    ||
					aStyle == CHSTYLE_2D_PERCENTAREA    ||
					aStyle == CHSTYLE_3D_STRIPE         ||
					aStyle == CHSTYLE_3D_AREA           ||
					aStyle == CHSTYLE_3D_STACKEDAREA    ||
					aStyle == CHSTYLE_3D_PERCENTAREA    ||
					aStyle == CHSTYLE_3D_SURFACE        ||
					aStyle == CHSTYLE_2D_NET            ||
					aStyle == CHSTYLE_2D_NET_STACK      ||
					aStyle == CHSTYLE_2D_NET_PERCENT    ||
					aStyle == CHSTYLE_2D_CUBIC_SPLINE   ||
					aStyle == CHSTYLE_2D_B_SPLINE       ||
					aStyle == CHSTYLE_2D_CUBIC_SPLINE_XY ||
					aStyle == CHSTYLE_2D_B_SPLINE_XY    ||
					aStyle == CHSTYLE_3D_COLUMN         ||
					aStyle == CHSTYLE_3D_BAR)
				{
					SdrObject* pRow = pSubList->GetObj(0);
					SchDataRow* pDataRow = GetDataRow(*pRow);
					short nRow = pDataRow->GetRow();

					short nColCount = GetDoc().GetColCount();
					for (USHORT nCol = 0; nCol < nColCount; nCol++)
					{
						// an der UndoAction registrieren
						pUndoAction->AddPoint(nCol, nRow);

						SfxItemSet aSet(GetDoc().GetDataPointAttr(nCol, nRow));
						aSet.ClearItem();
						GetDoc().PutDataPointAttr(nCol, nRow, aSet,FALSE);
					}
				}
				else
				{
					for (USHORT nObj = 0; nObj < nSubCount; nObj++)
					{
						SdrObject* pPoint = pSubList->GetObj(nObj);
						SchDataPoint* pDataPoint = GetDataPoint(*pPoint);
						short nCol = pDataPoint->GetCol();
						short nRow = pDataPoint->GetRow();

						// an der UndoAction registrieren
						pUndoAction->AddPoint(nCol, nRow);

						SfxItemSet aSet(GetDoc().GetDataPointAttr(nCol, nRow));
						aSet.ClearItem();
							// nicht mergen, nicht BuildChart rufen
						GetDoc().ChangeDataPointAttr(aSet, *pPoint, FALSE, FALSE);
					}
				}

				// die neuen Attribute in der UndoAction speichern und die
				// Action dem UndoManager uebergeben
				pUndoAction->CopyNewAttributes();
				SfxUndoManager* pUndoMgr = SFX_DISPATCHER().GetShell(0)->
												GetUndoManager();
				pUndoMgr->AddUndoAction(pUndoAction);
			}
		}
	}
}


/*************************************************************************
|*
|* Markierungs-Handles setzen, ggf. logische 3D-Gruppen beruecksichtigen
|*
\************************************************************************/

void SchView::SetMarkHandles()
{
	SdrView::SetMarkHandles();

	SdrMark* pMark = aMark.GetMark(0);
	if( pMark )
	{
		SdrPageView* pPageView = pMark->GetPageView();
		if( pPageView )
		{
			SdrObject* pObj = pMark->GetObj();

			if( pObj->ISA( Sch3dAxisObj ) )
			{
				aHdl.Clear();
				pObj->AddToHdlList( aHdl );
			}
			else
			if( ( nLogicalMarked != 0 && aMark.GetMarkCount() == 1 ) && pObj->ISA(E3dObject) )
			{
				E3dObject* p3DObj = (E3dObject*) pObj;
				USHORT nGroup = p3DObj->GetLogicalGroup();

				if ( nGroup > 0 )
				{
					SdrObjListIter a3DIterator(*((SdrObject*) p3DObj->GetScene()),
											   IM_DEEPWITHGROUPS);

					while ( a3DIterator.IsMore() )
					{
						p3DObj = (E3dObject*) a3DIterator.Next();
						DBG_ASSERT(p3DObj->ISA(E3dObject), "In Szenen sind nur 3D-Objekte erlaubt!");
						
						if ( p3DObj != pObj && p3DObj->GetLogicalGroup() == nGroup )
							p3DObj->AddToHdlList(aHdl);
					}
				}
			}
		}
	}
}

/*************************************************************************
|*
|* logische Gruppe betreten
|*
\************************************************************************/

FASTBOOL SchView::EnterMarkedGroup()
{
	if ( nLogicalMarked != 0 )
	{
		nLogicalEntered = nLogicalMarked;
		nLogicalMarked = 0;
		UnmarkAll();
		return TRUE;
	}
	else
	{
		nLogicalEntered = 0;
		return SdrView::EnterMarkedGroup();
	}
}

/*************************************************************************
|*
|* logische Gruppe verlassen
|*
\************************************************************************/

void SchView::LeaveOneGroup()
{
	nLogicalMarked = 0;

	if ( nLogicalEntered != 0 )
		nLogicalEntered = 0;
	else
		SdrView::LeaveOneGroup();
}

/*************************************************************************
|*
|* alle Gruppen verlassen
|*
\************************************************************************/

void SchView::LeaveAllGroup()
{
	nLogicalMarked = 0;
	nLogicalEntered = 0;
	SdrView::LeaveAllGroup();
}


/*************************************************************************
|*
|* logische Gruppe markieren
|*
\************************************************************************/

void SchView::MarkLogicalGroup()
{
	if ( nLogicalEntered == 0 && aMark.GetMarkCount() == 1 )
	{
		SdrObject* pObj = aMark.GetMark(0)->GetObj();

		if ( pObj->ISA(E3dObject) )
			nLogicalMarked = ((E3dObject*) pObj)->GetLogicalGroup();

		if ( nLogicalMarked )
		{
			FASTBOOL bVis = bHdlShown;
			if ( bVis ) HideMarkHdl(NULL);
			CheckMarked();
			SetMarkRects();
			SetMarkHandles();
			if ( bVis ) ShowMarkHdl(NULL);
		}
	}
	else
		nLogicalMarked = 0;
}

/*************************************************************************
|*
|* Objekt an Position vorhanden?
|*
\************************************************************************/

FASTBOOL SchView::PickObj(const Point& rPnt, short nTol, SdrObject*& prObj,
					 SdrPageView*& prPV,ULONG nOptions) const
{
	FASTBOOL bRet = SdrView::PickObj(rPnt, nTol, prObj, prPV, nOptions);

	if ( bRet && nLogicalEntered != 0 && prObj->ISA(E3dObject) )
	{
		E3dObject* p3DObj = (E3dObject*&) prObj;
		E3dObject* pParent = p3DObj->GetParentObj();

		if ( p3DObj->GetLogicalGroup() != nLogicalEntered && pParent &&
			 pParent->GetLogicalGroup() != nLogicalEntered )
		{
			bRet = FALSE;
			prObj = NULL;
			prPV = NULL;
		}
	}
	return bRet;
}

/*************************************************************************
|*
|* markiertes Objekt (auch von logischer Gruppe) getroffen?
|*
\************************************************************************/

FASTBOOL SchView::IsMarkedHit(const Point& rPnt, short nTol) const
{
	FASTBOOL bRet = SdrView::IsMarkedHit(rPnt, nTol);

	// falls SvDraw kein Objekt gefunden hat, ggf. auch logische Gruppe pruefen
	if ( !bRet && nLogicalMarked != 0 )
	{
		SdrObject*	 pObj;
		SdrPageView* pPV;

		// wenn Objekt vorhanden und Gruppe uebereinstimmt -> TRUE
		if ( PickObj(rPnt, nTol, pObj, pPV) && pObj->ISA(E3dObject) &&
			((E3dObject*) pObj)->GetLogicalGroup() == nLogicalMarked )
			bRet = TRUE;
	}
	return bRet;
}

/*************************************************************************
|*
|* Liste der markierten Objekte einer logischen Gruppe zurueckgeben
|*
\************************************************************************/

E3dLogicalObjList SchView::GetLogicalObjList()
{
	E3dLogicalObjList aObjList;

	if ( nLogicalMarked != 0 && aMark.GetMarkCount() == 1 )
	{
		SdrMark*	pMark = aMark.GetMark(0);
		SdrObject*	pObj = pMark->GetObj();

		if ( pObj->ISA(E3dObject) )
		{
			E3dObject* p3DObj = (E3dObject*) pObj;
			USHORT nGroup = p3DObj->GetLogicalGroup();

			if ( nGroup > 0 )
			{
				SdrObjListIter a3DIterator(*((SdrObject*) p3DObj->GetScene()),
											IM_DEEPWITHGROUPS);

				while ( a3DIterator.IsMore() )
				{
					p3DObj = (E3dObject*) a3DIterator.Next();
					DBG_ASSERT(p3DObj->ISA(E3dObject), "In Szenen sind nur 3D-Objekte erlaubt!");

					if ( p3DObj != pObj && p3DObj->GetLogicalGroup() == nGroup )
						aObjList.Insert(p3DObj, LIST_APPEND);
				}
			}
		}
	}
	return aObjList;
}

IMPL_LINK(SchView,NotifySelection ,void*, EMPTYARG)
//void ::NotifySelection()
{

	ChartSelectionInfo aInfo;

	SdrObject	 *pObj  = NULL;
	SchDataRow	 *pRow  = NULL;
	SchDataPoint *pPoint= NULL;

	aInfo.nSelection=CHART_SEL_NONE;

	if (HasMarkedObj())
	{
		ULONG nCount = aMark.GetMarkCount();
		if (nCount == 1)
		{
			pObj=aMark.GetMark(0)->GetObj();
			SchObjectId* pId = GetObjectId(*pObj);
			if (pId)
			{
				switch (pId->GetObjId())
				{
					case CHOBJID_DIAGRAM_AREA:
					case CHOBJID_DIAGRAM:
						aInfo.nSelection=CHART_SEL_NONE | CHART_SEL_ALL;
						break;

					case CHOBJID_LEGEND_SYMBOL_ROW:
					case CHOBJID_DIAGRAM_ROWGROUP:
					case CHOBJID_DIAGRAM_ROWS:
					case CHOBJID_DIAGRAM_ROWSLINE:
					case CHOBJID_DIAGRAM_SPECIAL_GROUP:
						{
							pRow=GetDataRow(*pObj);
							if(pRow)
							{
								if(!pDoc->IsDataSwitched())
								{
									aInfo.nSelection=CHART_SEL_NONE | CHART_SEL_ROW;
									aInfo.nRow=pRow->GetRow();
								}
								else
								{
									aInfo.nSelection=CHART_SEL_NONE | CHART_SEL_COL;
									aInfo.nCol=pRow->GetRow();
								}
							}
						}
						break;
					case CHOBJID_LEGEND_SYMBOL_COL:
					case CHOBJID_DIAGRAM_DATA:
						{
							pPoint=GetDataPoint(*pObj);
							if(pPoint)
							{
							/*	SfxItemSet aAttr=pDoc->GetDataRowAttr(pPoint->GetRow());
								aAttr.Put(pDoc->GetDataPointAttr(pPoint->GetCol(),pPoint->GetRow()));	*/
								if(!pDoc->IsDataSwitched())
								{
									aInfo.nSelection=CHART_SEL_NONE | CHART_SEL_POINT;
									aInfo.nCol=pPoint->GetCol();
									aInfo.nRow=pPoint->GetRow();
								}
								else
								{
									aInfo.nSelection=CHART_SEL_NONE | CHART_SEL_POINT;
									aInfo.nCol=pPoint->GetRow();
									aInfo.nRow=pPoint->GetCol();
								}
							}
						}
						break;

/*					case CHOBJID_DIAGRAM_DESCRGROUP:
					case CHOBJID_DIAGRAM_DESCR_ROW:
					case CHOBJID_DIAGRAM_DESCR_COL:
					case CHOBJID_LEGEND:

					case CHOBJID_TITLE_MAIN:
					case CHOBJID_TITLE_SUB:
					case CHOBJID_DIAGRAM_WALL:
					case CHOBJID_DIAGRAM_FLOOR:
					case CHOBJID_DIAGRAM_TITLE_X_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
					case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
					case CHOBJID_DIAGRAM_X_AXIS:
					case CHOBJID_DIAGRAM_Y_AXIS:       sowie auch A,B,C:
					case CHOBJID_DIAGRAM_Z_AXIS:
					case CHOBJID_DIAGRAM_X_GRID_MAIN:
					case CHOBJID_DIAGRAM_Y_GRID_MAIN:
					case CHOBJID_DIAGRAM_Z_GRID_MAIN:
					case CHOBJID_DIAGRAM_X_GRID_HELP:
					case CHOBJID_DIAGRAM_Y_GRID_HELP:
					case CHOBJID_DIAGRAM_Z_GRID_HELP:*/
					default:
						break;
				}
			}
		}
	}
	((SchMemChart*)pDoc->GetMemChart())->SubmitSelection(aInfo);
	return 0;
}




