/*************************************************************************
 *
 *  $RCSfile: viewshel.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:46:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------
#pragma hdrstop

#define ITEMID_LRSPACE			EE_PARA_LRSPACE
#define ITEMID_ULSPACE			EE_PARA_ULSPACE

#ifndef _B3D_BASE3D_HXX
#include "goodies/base3d.hxx"
#endif

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFXSTBMGR_HXX //autogen
#include <sfx2/stbmgr.hxx>
#endif
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <sfx2/viewfrm.hxx>
#endif
#include <svx/flstitem.hxx>

#include <svtools/style.hrc>
#include <svx/dialogs.hrc>

#include "res_bmp.hrc"
#include "viewshel.hxx"
#include "chwindow.hxx"
#include "schview.hxx"
#include "docshell.hxx"
#include "fupoor.hxx"
#include "eetext.hxx"


/*************************************************************************
|*
|* Diese Methode deaktiviert und loescht die aktuelle Funktion. Falls es
|* eine alte Funktion gibt, wird sie als aktuelle Funktion eingesetzt und
|* aktiviert.
|*
\************************************************************************/

void SchViewShell::Cancel()
{
	if (pFuActual)
	{
		SchFuPoor* pTemp = pFuActual;
		pFuActual	  = NULL;
		pTemp->Deactivate();
		delete pTemp;
	}

	if (pFuOld)
	{
		pFuActual = pFuOld;
		pFuActual->Activate();
	}
}

/*************************************************************************
|*
|* Aktivierung: Arbeitsfenster den Fokus zuweisen
|*
\************************************************************************/

void SchViewShell::Activate(BOOL bIsMDIActivate)
{
	SfxViewShell::Activate(bIsMDIActivate);
	bFirstStart = FALSE;

	if (pFuActual)
		pFuActual->Activate();
}

/*************************************************************************
|*
|* Deaktivierung
|*
\************************************************************************/

void SchViewShell::Deactivate(BOOL bIsMDIActivate)
{
	if (pFuActual)
		pFuActual->Deactivate();

	if (bIsMDIActivate) GetView ()->EndTextEdit ();

	SfxViewShell::Deactivate(bIsMDIActivate);
}

/*************************************************************************
|*
|* innere Groessenanpassung
|*
\************************************************************************/

void SchViewShell::InnerResizePixel(const Point &rOfs, const Size &rSize)
{
	SchWindow* pWin = GetWindow();
	pWin->SetViewSize(pWin->PixelToLogic(rSize));

	SetBorderPixel(SvBorder());

	GetView()->SetWorkArea(GetWindow()->PixelToLogic(Rectangle(rOfs, rSize)));
}

/*************************************************************************
|*
|* aeussere Groessenanpassung
|*
\************************************************************************/

void SchViewShell::OuterResizePixel(const Point &rOfs, const Size &rSize)
{
	SchWindow* pWin = GetWindow();
	pWin->SetViewSize(pWin->PixelToLogic(rSize));

	SetBorderPixel(SvBorder());

	Rectangle aLogicRect = GetWindow()->PixelToLogic(Rectangle(rOfs, rSize));
	Size aSize           = GetWindow ()->GetSizePixel ();
	Size aOutputSize     = GetWindow ()->GetOutputSizePixel ();

	if (aSize.Width () <= 50 && aSize.Height () <= 50 ||
	aOutputSize.Width () <= 50 && aOutputSize.Height () <= 50) aLogicRect = Rectangle ();

	((SchChartDocShell*)GetViewFrame()->GetObjectShell())->SetVisArea(aLogicRect);
	GetView()->SetWorkArea(aLogicRect);
}

/*************************************************************************
|*
|* Nur fuer MAC !?
|*
\************************************************************************/

Size SchViewShell::GetOptimalSizePixel() const
{
	return Size(560, 320);
}

/*************************************************************************
|*
|* Keyboard event
|*
\************************************************************************/

FASTBOOL SchViewShell::KeyInput(const KeyEvent& rKEvt)
{
	BOOL bReturn = SfxViewShell::KeyInput(rKEvt);


	if (!bReturn)
	{
		if (pFuActual)
			bReturn = pFuActual->KeyInput(rKEvt);

		if (!bReturn && GetWindow())
		{
			KeyCode aKeyCode = rKEvt.GetKeyCode();

			if (aKeyCode.IsMod1() && aKeyCode.IsShift()
				&& aKeyCode.GetCode() == KEY_R)
			{
				 // 3D-Kontext wieder zerstoeren
				Base3D* pBase3D = (Base3D*) GetWindow()->Get3DContext();

				if (pBase3D)
				{
					pBase3D->Destroy(GetWindow());
				}
				GetWindow()->Invalidate();
				bReturn = TRUE;
			}
		}
	}

	return bReturn;
}

/*************************************************************************
|*
|* MouseButtonDown event
|*
\************************************************************************/

FASTBOOL SchViewShell::MouseButtonDown(const MouseEvent& rMEvt)
{
	if ( MOUSE_LEFT == rMEvt.GetButtons() )
		GetWindow()->GrabFocus();
	if (pFuActual)
	{
		pFuActual->SetWindow(GetWindow());
		return pFuActual->MouseButtonDown(rMEvt);
	}

	return FALSE;
}

/*************************************************************************
|*
|* MouseMove event
|*
\************************************************************************/

FASTBOOL SchViewShell::MouseMove(const MouseEvent& rMEvt)
{
	if (pFuActual)
	{
		pFuActual->SetWindow(GetWindow());
		return pFuActual->MouseMove(rMEvt);
	}

	return FALSE;
}

/*************************************************************************
|*
|* MouseButtonUp event
|*
\************************************************************************/

FASTBOOL SchViewShell::MouseButtonUp(const MouseEvent& rMEvt)
{
	if (pFuActual)
	{
		pFuActual->SetWindow(GetWindow());
		return pFuActual->MouseButtonUp(rMEvt);
	}

	return FALSE;
}

/*************************************************************************
|*
|* Den Zoomfaktor setzen
|*
\************************************************************************/

void SchViewShell::SetZoom(long nZoom)
{
	GetWindow()->SetZoom(nZoom);
}

/*************************************************************************
|*
|* ObjectBar umschalten, ResourceID der alten ObjectBar-ID zurueckgeben
|*
\************************************************************************/

USHORT SchViewShell::SwitchObjectBar(USHORT nResId)
{
	USHORT nReturn = nCurrentObjectBar;

	// muss Object Bar gewechselt werden?
	if (nCurrentObjectBar != nResId && bObjectBarSwitchEnabled)
	{
		// SfxDispatcher* pDispatcher = GetViewFrame()->GetDispatcher();

		if (nCurrentObjectBar)
		{
			// pDispatcher->Pop(*(SfxShell*)aShellTable.Get(nCurrentObjectBar));
			SetSubShell( NULL );
		}

		nCurrentObjectBar = nResId;

		if (nCurrentObjectBar)
		{
			// pDispatcher->Push(*(SfxShell*)aShellTable.Get(nCurrentObjectBar));
			SetSubShell( (SfxShell*) aShellTable.Get( nCurrentObjectBar ) );
		}
	}
	return nReturn;
}

/*************************************************************************
|*
|* Auf allen Split-Windows ein Markierungsrechteck zeichnen
|*
\************************************************************************/

#ifndef NOOLDSV

void SchViewShell::DrawMarkRect(const Rectangle& rRect, const Pen& rPen)
{
	SchWindow* pWin = GetWindow();

	RasterOp aROp = pWin->GetRasterOp();
	pWin->SetRasterOp(ROP_INVERT);
	Pen aPen	  = pWin->GetPen();
	pWin->SetPen(rPen);
	Brush aBrush  = pWin->GetFillInBrush();
	pWin->SetFillInBrush(BRUSH_NULL);
	pWin->DrawRect(rRect);
	pWin->SetRasterOp(aROp);
	pWin->SetPen(aPen);
	pWin->SetFillInBrush(aBrush);
}

#endif

void SchViewShell::DrawMarkRect(const Rectangle& rRect, const Color& rColor )
{
	SchWindow* pWin = GetWindow();

	RasterOp aROp = pWin->GetRasterOp();
	pWin->SetRasterOp(ROP_INVERT);

	Color aOldLineColor( pWin->GetLineColor() );
	pWin->SetLineColor( rColor );
	Color aOldFillColor( pWin->GetFillColor() );
	pWin->SetFillColor();
	pWin->DrawRect(rRect);
	pWin->SetRasterOp(aROp);
	pWin->SetLineColor( aOldLineColor );
	pWin->SetFillColor( aOldFillColor );
}

/*************************************************************************
|*
|* Auf allen Split-Windows ein Rechteck zeichnen.
|*
\************************************************************************/

#ifndef NOOLDSV

void SchViewShell::DrawFilledRect(const Rectangle& rRect, const Pen& rPen,
								 const Brush& rFillInBrush) const
{
	SchWindow* pWin = GetWindow();

	Pen aPen	 = pWin->GetPen();
	pWin->SetPen(rPen);
	Brush aBrush = pWin->GetFillInBrush();
	pWin->SetFillInBrush(rFillInBrush);
	pWin->DrawRect(rRect);
	pWin->SetPen(aPen);
	pWin->SetFillInBrush(aBrush);
}

#endif

void SchViewShell::DrawFilledRect(const Rectangle& rRect, const Color& rColor,
								 const Color& rFillColor ) const
{
	SchWindow* pWin = GetWindow();

	Color aOldLineColor( pWin->GetLineColor() );
	Color aOldFillColor( pWin->GetFillColor() );
	pWin->SetLineColor( rColor );
	pWin->SetFillColor( rFillColor );

	pWin->DrawRect(rRect);
	
	pWin->SetLineColor( aOldLineColor );
	pWin->SetFillColor( aOldFillColor );
}

/*************************************************************************
|*
|* QueryDrop-Event
|*
\************************************************************************/

BOOL SchViewShell::QueryDrop(DropEvent& rEvt, USHORT nPage,
							 USHORT nLayer)
{
	SchView* pView = GetView();

	return pView && pView->QueryDrop(rEvt, GetWindow(), nPage, nLayer);
}

/*************************************************************************
|*
|* Drop-Event
|*
\************************************************************************/

BOOL SchViewShell::Drop(const DropEvent& rEvt, USHORT nPage,
						USHORT nLayer)
{
	SchView* pView = GetView();

	return pView && pView->Drop(rEvt, GetWindow(), nPage, nLayer);
}

/*************************************************************************
|*
|* Zoom-Faktor fuer InPlace einstellen
|*
\************************************************************************/

void SchViewShell::SetZoomFactor(const Fraction& rZoomX,
								 const Fraction& rZoomY)
{
	long nZoom = (long)((double) rZoomX * 100);
	SetZoom(nZoom);
}



