#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.2 $
#
#   last change: $Author: csaba $ $Date: 2000/10/16 14:59:22 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=sch
TARGET=schart3
LIBTARGET=NO
GEN_HID=TRUE

# --- Settings -----------------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
#.INCLUDE :  sch.mk
.INCLUDE :  sv.mk

IENV!:=$(IENV);$(RES);..$/res

# --- Files --------------------------------------------------------

RESLIB1LIST=\
	$(SRS)$/app.srs	\
	$(SRS)$/dlg.srs	\
	$(SRS)$/core.srs	\
	$(SRS)$/schslots.srs \
	$(SOLARVERSION)$/$(INPATH)$/res$(EXT_UPDMINOR)$/sfx.srs

.IF "$(GUI)" == "WIN"
RESLIBSPLIT1NAME=sch
RESLIBSPLIT1SRSFILES=\
	$(RESLIB1LIST)
.ELSE
RESLIB1NAME=sch
RESLIB1SRSFILES=\
	$(RESLIB1LIST)
.ENDIF

LIB2TARGET= $(SLB)$/schmod.lib
LIB2OBJFILES=	$(SLO)$/schmod.obj

LIB3TARGET= $(SLB)$/sch.lib
LIB3FILES=	$(SLB)$/core.lib	\
		$(SLB)$/ui.lib	  	\
		$(SLB)$/filter.lib	\
		$(SLB)$/xml.lib


SHL1TARGET= sch$(UPD)$(DLLPOSTFIX)
SHL1VERSIONMAP= sch.map 
.IF "$(GUI)" == "WNT" || "$(GUI)" == "WIN"
SHL1RES=	$(RCTARGET)
.ENDIF

SHL1IMPLIB= schi

SHL1STDLIBS=\
	$(BASICLIB)	\
	$(SFXLIB)	\
	$(SFXDEBUGLIB)	\
	$(SO2LIB)	\
	$(CHANELLIB)	\
	$(SVLIB)	\
	$(VOSLIB)	\
	$(SALLIB)	\
	$(SVMEMLIB)	\
	$(SVTOOLLIB)	\
	$(SVLLIB)	\
	$(SVXLIB)	\
	$(GOODIESLIB)	\
	$(TOOLSLIB)	\
	$(UNOLIB)	\
	$(ONELIB)	\
	$(SMARTLIB)	\
	$(SOTLIB)	\
	$(OFFSMARTLIB) \
	$(CPPULIB) \
	$(CPPUHELPERLIB) \
	$(UNOTOOLSLIB) \
	$(XMLOFFLIB)	\
	$(BASCTLLIB)

SHL1DEPN=   $(L)$/itools.lib
SHL1LIBS=   $(LIB3TARGET)
.IF "$(GUI)"!="UNX"
SHL1OBJS=   $(SLO)$/schdll.obj
.ENDIF
SHL1DEF=    $(MISC)$/$(SHL1TARGET).def
SHL1BASE=	0x1d100000

DEF1DEPN	=$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME	=schmod
DEF1DES		=StarChart

.IF "$(depend)" == ""

ALL: \
	$(SRS)$/hidother.hid\
	ALLTAR
.ENDIF

# --- Targets -------------------------------------------------------------

.INCLUDE :  target.mk


.IF "$(depend)" == ""


# -------------------------------------------------------------------------
# MAC
# -------------------------------------------------------------------------
.IF "$(GUI)" == "MAC"

MACRES= $(SV_RES)MPWToolCfrg.r -d SVTOOLNAME=""SV TOOL""

$(MISCX)$/$(APP1TARGET).def : 
	@echo Kein def-File fuer Applikationen auf Mac


$(MISC)$/$(SHL1TARGET).def:  
	@echo ------------------------------
	@echo Making: $@
	@echo 	CreateSchChartDocShellDll                       	>  $@
	@echo 	CreateObjSchChartDocShellDll   		    			>> $@
	@echo 	InitSchDll 											>> $@
	@echo 	DeInitSchDll 										>> $@
	@echo 	SchUpdate 											>> $@
	@echo 	SchUpdateAttr 										>> $@
	@echo 	SchCreateDiagramAutoPilotDlg 						>> $@
	@echo 	SchChangeChartData 									>> $@
	@echo 	SchCreateOptionsDlg 								>> $@
	@echo   SchGetChartData                                     >> $@
	@echo   SchNewMemChartNone                                  >> $@
	@echo   SchNewMemChartXY                                    >> $@
	@echo   SchNewMemChartCopy                                  >> $@

.ENDIF

# -------------------------------------------------------------------------
# WindowsNT
# -------------------------------------------------------------------------
.IF "$(GUI)" == "WNT"


$(MISC)$/$(SHL1TARGET).def:  makefile.mk
    @echo ------------------------------
    @echo Making: $@
    @echo LIBRARY     $(SHL1TARGET)                                  >$@
    @echo DESCRIPTION 'SCHAR3 DLL'                                  >>$@
    @echo DATA        READ WRITE NONSHARED                          >>$@
    @echo EXPORTS                                                   >>$@
	@echo 	CreateSchChartDocShellDll @20                         	>>$@
	@echo 	CreateObjSchChartDocShellDll @21   		    			>>$@
	@echo 	InitSchDll @22 											>>$@
	@echo 	DeInitSchDll @23										>>$@
	@echo 	SchUpdate @24 											>>$@
	@echo 	SchUpdateAttr @25 										>>$@
	@echo 	SchCreateDiagramAutoPilotDlg @26						>>$@
	@echo 	SchChangeChartData @27 									>>$@
	@echo 	SchCreateOptionsDlg @28									>>$@
    @echo   SchGetChartData @29                                     >>$@
    @echo   SchNewMemChartNone @30                                  >>$@
    @echo   SchNewMemChartXY @31                                    >>$@
    @echo   SchNewMemChartCopy @32                                  >>$@
    @echo   SchSetTransparent @33                                   >>$@
    @echo   SchGetDefaultForColumnText @34                          >>$@
    @echo   SchGetDefaultForRowText @35                             >>$@
.ENDIF

# -------------------------------------------------------------------------
# Presentation Manager 2.0
# -------------------------------------------------------------------------

.IF "$(GUI)" == "OS2"

$(MISC)$/$(SHL1TARGET).def:  makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
.IF "$(COM)"!="WTC"
	echo  LIBRARY		INITINSTANCE TERMINSTANCE		>$@
	echo  DESCRIPTION	'SchDLL'           				>>$@
	echo  PROTMODE										>>$@
    @echo CODE        LOADONCALL 			            >>$@
	@echo DATA		  PRELOAD MULTIPLE NONSHARED		>>$@
    @echo EXPORTS                                       >>$@
.IF "$(COM)"!="ICC"
	@echo _CreateSchChartDocShellDll @2 				>>$@
	@echo _CreateObjSchChartDocShellDll @3				>>$@
	@echo _InitSchDll @4								>>$@
	@echo _DeInitSchDll @5								>>$@
	@echo _SchUpdate @6 								>>$@
	@echo _SchUpdateAttr @7								>>$@
	@echo _SchCreateDiagramAutoPilotDlg @8 				>>$@
	@echo _SchChangeChartData @9  						>>$@
	@echo _SchCreateOptionsDlg @10						>>$@
    @echo _SchGetChartData @11                          >>$@
    @echo _SchNewMemChartNone @12                       >>$@
    @echo _SchNewMemChartXY @13                         >>$@
    @echo _SchNewMemChartCopy @14                       >>$@
.ELSE
	@echo CreateSchChartDocShellDll @2 					>>$@
	@echo CreateObjSchChartDocShellDll @3				>>$@
	@echo InitSchDll @4									>>$@
	@echo DeInitSchDll @5								>>$@
	@echo SchUpdate @6 									>>$@
	@echo SchUpdateAttr @7								>>$@
	@echo SchCreateDiagramAutoPilotDlg @8 				>>$@
	@echo SchChangeChartData @9  						>>$@
	@echo SchCreateOptionsDlg @10						>>$@
    @echo SchGetChartData @11                           >>$@
    @echo SchNewMemChartNone @12                        >>$@
    @echo SchNewMemChartXY @13                          >>$@
    @echo SchNewMemChartCopy @14                        >>$@
    @echo SchSetTransparent @15                         >>$@
.ENDIF
.ELSE
    @echo option DESCRIPTION 'SchDLL'		        >$@
    @echo name $(BIN)$/$(SHL1TARGET).dll            >>$@
	@echo CreateSchChartDocShellDll_ @2 		>>temp.def
	@echo CreateObjSchChartDocShellDll_ @3		>>temp.def
	@echo InitSchDll_ @4						>>temp.def
	@echo DeInitSchDll_ @5						>>temp.def
	@echo SchUpdate_ @6 						>>temp.def
	@echo SchUpdateAttr_ @7						>>temp.def
	@echo SchCreateDiagramAutoPilotDlg_ @8 		>>temp.def
	@echo SchChangeChartData_ @9  				>>temp.def
	@echo SchCreateOptionsDlg_ @10				>>temp.def
    @echo SchGetChartData_ @11				    >>temp.def
        @echo SchNewMemChartNone_ @12           >>temp.def
        @echo SchNewMemChartXY_ @13             >>temp.def
        @echo SchNewMemChartCopy_ @14           >>temp.def
	@gawk -f s:\util\exp.awk temp.def			>>$@
	del temp.def
.ENDIF
.ENDIF


$(MISCX)$/$(SHL1TARGET).flt:
    @echo ------------------------------
    @echo Making: $@
    @echo WEP>$@
    @echo LIBMAIN>>$@
    @echo LibMain>>$@
    @echo FuDiagramType>>$@
    @echo SchApp>>$@
    @echo SchAxisGridDlg>>$@
    @echo ChartModel>>$@
    @echo SchChartStdObjectBar>>$@
    @echo SchChartView>>$@
    @echo SchChartViewShell>>$@
    @echo SchDataDescriptionDlg>>$@
    @echo SchDiagramTypeDlg>>$@
    @echo SchDragServer>>$@
    @echo SchDynChart>>$@
    @echo SchDynChart>>$@
    @echo SchFuDraw>>$@
    @echo SchFuGrid>>$@
    @echo SchFuPoor>>$@
    @echo SchFuScale>>$@
    @echo SchFuSelection>>$@
    @echo SchFuZoom>>$@
    @echo SchLegendDlg>>$@
    @echo SchLight3DDlg>>$@
    @echo SchMemChart>>$@
    @echo SchNodeIdx>>$@
    @echo SchObjectFactory>>$@
    @echo SchPage>>$@
    @echo SchPageDlg>>$@
    @echo SchPool>>$@
    @echo SchPopupWindowTbx>>$@
    @echo SchPosition>>$@
    @echo SchRTFParser>>$@
    @echo SchRectCtl3D>>$@
    @echo SchTabControl>>$@
    @echo SchTbxCtlAlignment>>$@
    @echo SchTitleDlg>>$@
    @echo SchView>>$@
    @echo SchView3DDlg>>$@
    @echo SchViewShell>>$@
    @echo SchWindow>>$@
    @echo SdStyleSheet>>$@
    @echo ChartModel>>$@
    @echo Vector>>$@
    @echo Viewport>>$@
    @echo SdGrid>>$@
    @echo SdClip>>$@
    @echo Matrix>>$@
    @echo TbxDummyItem>>$@
    @echo foo>>$@

.ENDIF

$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)$(CPU)"=="WNTI"
.IF "$(BUILD_SOSL)"==""
	@+-mhids hidother.src ..\$(INPATH)$/srs sch hidother
	@+echo NO HIDS !!!
.ENDIF
.ELSE
	@echo nix
.ENDIF

