#ifndef GCFG_INC
#define GCFG_INC

/* =====================================================
 *      SO_ROOT definition
 * =====================================================*/

#ifdef SRV_PRODUCT
#define GID_MODULE_SO_ROOT GID_MODULE_OFFICE_SERVER
#elif defined WEB_PRODUCT
#define GID_MODULE_SO_ROOT GID_MODULE_FAT_OFFICE
#else
#define GID_MODULE_SO_ROOT GID_MODULE_ROOT
#endif

/* =====================================================
 *       Styles = (DONT_SELECT_BY_USER);    definition
 * =====================================================*/

#if defined( SRV_PRODUCT ) || defined( WEB_PRODUCT )
#define NO_DONT_SELECT_PRODUCT
#endif

/* =====================================================
 *       Making Classic Fat-Product available
 * =====================================================*/

#if defined( FAT_PRODUCT )
#define CLASSIC_FAT_PRODUCT
#endif

/* =====================================================
 *		StarOffice FAT
 * =====================================================*/

#if defined( FAM_PRODUCT ) || defined( SFX_PRODUCT ) || defined( OSL_PRODUCT ) || defined( RVP_PRODUCT ) || defined( WEB_PRODUCT )
#define FAT_PRODUCT
#endif

#ifdef FAT_PRODUCT

#ifdef UNX
#define         GCFG_DEF_DESTPATH                   "office60"
#else
#define         GCFG_DEF_DESTPATH                   "c:\Office60"
#endif

#ifdef OSL_PRODUCT
    #define         GCFG_DATACARRIER                    "OpenOffice 6.0"
#else
    #define         GCFG_DATACARRIER                    "StarOffice 6.0"
#endif

#ifdef OSL_PRODUCT
    #define         GCFG_TIME_STAMP                     "0600"
#else
    #define         GCFG_TIME_STAMP                     "0600"
#endif

#define         GCFG_DATE_STAMP                     "08102000"
#define         GCFG_BINARY_DIR                     GID_DIR_PROGRAM
#define         GCFG_RESOURCE_DIR                   GID_DIR_RESOURCE

/* =====================================================
 *		StarOffice Server
 * =====================================================*/
#elif SRV_PRODUCT

#ifdef UNX
#define         GCFG_DEF_DESTPATH                   "portal"
#else
#define         GCFG_DEF_DESTPATH                   "c:\Portal"
#endif

#define         GCFG_DATACARRIER                    "StarPortal"
#define         GCFG_DATE_STAMP                     "08052000"
#define			GCFG_TIME_STAMP						"0520"
#define         GCFG_BINARY_DIR                     GID_DIR_PROGRAM
#define         GCFG_RESOURCE_DIR                   GID_DIR_RESOURCE

/* =====================================================
 *		StarImpress Player
 * =====================================================*/
#elif IPL_PRODUCT

#ifdef UNX
#define			GCFG_DEF_DESTPATH		   			"soplayer"
#else
#define			GCFG_DEF_DESTPATH	 				"c:\SOPlayer"
#endif

#define			GCFG_STARIMPRESS_FOLDER				"StarOffice Player 5.2"
#define			GCFG_STARIMPRESS_FOLDERENTRY		"StarOffice Player 5.2"
#define			GCFG_STARIMPRESS_SETUP				"StarOffice Player Setup"
#define			GCFG_STARIMPRESS_VERSIONKEY			"StarOffice Player 5.2"

#define			GCFG_DATACARRIER	  		 		"StarOffice Player 5.2"
#define         GCFG_DATE_STAMP                     "08052000"
#define			GCFG_TIME_STAMP				 		"0520"

#define			GCFG_BINARY_DIR						PREDEFINED_PROGDIR
#define         GCFG_RESOURCE_DIR                   PREDEFINED_PROGDIR

/* =====================================================
 *		StarSchedule Server
 * =====================================================*/
#elif SSS_PRODUCT

#ifdef UNX
#define			GCFG_DEF_DESTPATH		   			"SdlSrv52"
#else
#define			GCFG_DEF_DESTPATH	 				"c:\SdlSrv52"
#endif

#define			GCFG_SCHEDULESERVER_FOLDER	  		"StarOffice Schedule Server 5.2"
#define			GCFG_SCHEDULESERVER_FOLDERENTRY		"Service Manager 5.2"
#define			GCFG_SCHEDULESERVER_SETUP			"Setup"
#define			GCFG_SCHEDULESERVER_VERSIONKEY		"StarOffice Schedule Server 5.2"

#define			GCFG_DATACARRIER	  		 		"StarOffice Schedule Server 5.2"
#define         GCFG_DATE_STAMP                     "08052000"
#define			GCFG_TIME_STAMP				 		"0520"

#define			GCFG_BINARY_DIR						GID_DIR_SERVICE
#define         GCFG_RESOURCE_DIR                   GID_DIR_SERVICE

/* =====================================================
 *		Adabas Setup
 * =====================================================*/
#elif ADA_PRODUCT

#ifdef UNX
#define			GCFG_DEF_DESTPATH		   			"adabas"
#else
#define			GCFG_DEF_DESTPATH	 				"c:\Adabas"
#endif

#define         GCFG_ADABAS_FOLDER                  "Adabas"
#define         GCFG_ADABAS_FOLDERENTRY             "Adabas"
#define         GCFG_ADABAS_SETUP                   "Adabas Setup"
#define         GCFG_ADABAS_VERSIONKEY              "Adabas"

#define			GCFG_DATACARRIER	  		 		"Adabas"
#define         GCFG_DATE_STAMP                     "08052000"
#define			GCFG_TIME_STAMP				 		"0520"

#define         GCFG_BINARY_DIR                     GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_RESOURCE_DIR                   GID_DIR_DATABASE_ADABAS_ADABAS

/* =====================================================
 *		Adabas Multikulti Setup
 * =====================================================*/
#elif ADM_PRODUCT

#ifdef UNX
#define			GCFG_DEF_DESTPATH		   			"adabas"
#else
#define			GCFG_DEF_DESTPATH	 				"c:\Adabas"
#endif

#define         GCFG_ADABAS_FOLDER                  "Adabas"
#define         GCFG_ADABAS_FOLDERENTRY             "Adabas"
#define         GCFG_ADABAS_SETUP                   "Adabas Setup"
#define         GCFG_ADABAS_VERSIONKEY              "Adabas"

#define			GCFG_DATACARRIER	  		 		"Adabas"
#define         GCFG_DATE_STAMP                     "22022000"
#define			GCFG_TIME_STAMP				 		"0520"

#define         GCFG_BINARY_DIR                     GID_DIR_DATABASE_ADABAS_ADABAS
#define         GCFG_RESOURCE_DIR                   GID_DIR_DATABASE_ADABAS_ADABAS
#endif

/* =====================================================
 * global helper macros
 * =====================================================*/

#define DOSTRING( x )			   			#x
#define STRING( x )				   			DOSTRING( x )

#define DOCONCAT2( x, y )					x##y
#define CONCAT2( x, y)						DOCONCAT2(x,y)
#define DOCONCAT3( x, y, z )				x##y##z
#define CONCAT3( x, y, z )		   			DOCONCAT3(x,y,z)
#define DOCONCAT4( x, y, z, a )				x##y##z##a
#define CONCAT4( x, y, z, a )				DOCONCAT4(x,y,z,a)
#define DOCONCAT5( x, y, z, a, b )			x##y##z##a##b
#define CONCAT5( x, y, z, a, b )	 		DOCONCAT5(x,y,z,a,b)
#define DOCONCAT6( x, y, z, a, b, c )		x##y##z##a##b##c
#define CONCAT6( x, y, z, a, b, c )			DOCONCAT6(x,y,z,a,b,c)

/* --------------------------------------------------*/

#ifdef UNX
#define LIBNAME(name)			   			STRING(CONCAT5(lib,name,SUPD,DLLSUFFIX,.so))
#define FILTER_LIBNAME(name)	   			LIBNAME(name)
#define EXENAME(name)			  			STRING(name)
#define PROFILENAME(name)		  			STRING(CONCAT2(name,rc))
#else
#define LIBNAME(name)			  			STRING(CONCAT4(name,SUPD,DLLSUFFIX,.dll))
#define FILTER_LIBNAME(name)	   			LIBNAME(name)
#define EXENAME(name)						STRING(CONCAT2(name,.exe))
#define PROFILENAME(name)					STRING(CONCAT2(name,.ini))
#endif

#define RESFILENAME(name,lang)				STRING(CONCAT4(name,SUPD,lang,.res))
#define HELPFILENAME(name,endung) 			STRING(CONCAT3(name,.,endung))
#define EXTRAFILENAME(name,lang) 			STRING(CONCAT3(name,lang,.zip))

#define ALL_LANG(ident, resid) \
	ident (01) 		= resid; \
	ident (03) 		= resid; \
	ident (07) 		= resid; \
    ident (30)      = resid; \
	ident (31) 		= resid; \
	ident (33) 		= resid; \
	ident (34) 		= resid; \
	ident (39) 		= resid; \
	ident (45) 		= resid; \
	ident (46) 		= resid; \
	ident (48) 		= resid; \
	ident (49) 		= resid; \
	ident (81) 		= resid; \
	ident (82) 		= resid; \
	ident (86) 		= resid; \
    ident (88)      = resid; \
    ident (90)      = resid; \
    ident (96)      = resid

#define RESFILE_ALL_LANG(name) \
	Name (01) 		= RESFILENAME(name,01);		\
	Name (03) 		= RESFILENAME(name,03);		\
	Name (07) 		= RESFILENAME(name,07);		\
    Name (30)       = RESFILENAME(name,30);     \
	Name (31) 		= RESFILENAME(name,31);		\
	Name (33) 		= RESFILENAME(name,33);		\
	Name (34) 		= RESFILENAME(name,34);		\
	Name (39) 		= RESFILENAME(name,39);		\
	Name (45) 		= RESFILENAME(name,45);		\
	Name (46) 		= RESFILENAME(name,46);		\
	Name (48) 		= RESFILENAME(name,48);		\
	Name (49) 		= RESFILENAME(name,49);		\
	Name (81) 		= RESFILENAME(name,81);		\
	Name (82) 		= RESFILENAME(name,82);		\
	Name (86) 		= RESFILENAME(name,86);		\
    Name (88)       = RESFILENAME(name,88);     \
    Name (90)       = RESFILENAME(name,90);     \
    Name (96)       = RESFILENAME(name,96)

#define EXTRA_ALL_LANG(name) \
    Name (01)       = EXTRAFILENAME(name,01);     \
    Name (03)       = EXTRAFILENAME(name,03);     \
    Name (07)       = EXTRAFILENAME(name,07);     \
    Name (30)       = EXTRAFILENAME(name,30);     \
    Name (31)       = EXTRAFILENAME(name,31);     \
    Name (33)       = EXTRAFILENAME(name,33);     \
    Name (34)       = EXTRAFILENAME(name,34);     \
    Name (39)       = EXTRAFILENAME(name,39);     \
    Name (45)       = EXTRAFILENAME(name,45);     \
    Name (46)       = EXTRAFILENAME(name,46);     \
    Name (48)       = EXTRAFILENAME(name,48);     \
    Name (49)       = EXTRAFILENAME(name,49);     \
    Name (81)       = EXTRAFILENAME(name,81);     \
    Name (82)       = EXTRAFILENAME(name,82);     \
    Name (86)       = EXTRAFILENAME(name,86);     \
    Name (88)       = EXTRAFILENAME(name,88);     \
    Name (90)       = EXTRAFILENAME(name,90);     \
    Name (96)       = EXTRAFILENAME(name,96)

#define EXTRA_IDENT_ALL_LANG(name) \
    Name (01)       = STRING(name);     \
    Name (03)       = STRING(name);     \
    Name (07)       = STRING(name);     \
    Name (30)       = STRING(name);     \
    Name (31)       = STRING(name);     \
    Name (33)       = STRING(name);     \
    Name (34)       = STRING(name);     \
    Name (39)       = STRING(name);     \
    Name (45)       = STRING(name);     \
    Name (46)       = STRING(name);     \
    Name (48)       = STRING(name);     \
    Name (49)       = STRING(name);     \
    Name (81)       = STRING(name);     \
    Name (82)       = STRING(name);     \
    Name (86)       = STRING(name);     \
    Name (88)       = STRING(name);     \
    Name (90)       = STRING(name);     \
    Name (96)       = STRING(name)

#define CONFIGHELPFILE_ALL_LANG(name) \
    Name (01)       = HELPFILENAME(name,01);     \
    Name (03)       = HELPFILENAME(name,03);     \
    Name (07)       = HELPFILENAME(name,07);     \
    Name (30)       = HELPFILENAME(name,30);     \
    Name (31)       = HELPFILENAME(name,31);     \
    Name (33)       = HELPFILENAME(name,33);     \
    Name (34)       = HELPFILENAME(name,34);     \
    Name (39)       = HELPFILENAME(name,39);     \
    Name (45)       = HELPFILENAME(name,45);     \
    Name (46)       = HELPFILENAME(name,46);     \
    Name (48)       = HELPFILENAME(name,48);     \
    Name (49)       = HELPFILENAME(name,49);     \
    Name (81)       = HELPFILENAME(name,81);     \
    Name (82)       = HELPFILENAME(name,82);     \
    Name (86)       = HELPFILENAME(name,86);     \
    Name (88)       = HELPFILENAME(name,88);     \
    Name (90)       = HELPFILENAME(name,90);     \
    Name (96)       = HELPFILENAME(name,96)

#define DELCONFIGHELPFILE_ALL_LANG(name) \
    Name (01)       = HELPFILENAME(name,01x);     \
    Name (03)       = HELPFILENAME(name,03x);     \
    Name (07)       = HELPFILENAME(name,07x);     \
    Name (30)       = HELPFILENAME(name,30x);     \
    Name (31)       = HELPFILENAME(name,31x);     \
    Name (33)       = HELPFILENAME(name,33x);     \
    Name (34)       = HELPFILENAME(name,34x);     \
    Name (39)       = HELPFILENAME(name,39x);     \
    Name (45)       = HELPFILENAME(name,45x);     \
    Name (46)       = HELPFILENAME(name,46x);     \
    Name (48)       = HELPFILENAME(name,48x);     \
    Name (49)       = HELPFILENAME(name,49x);     \
    Name (81)       = HELPFILENAME(name,81x);     \
    Name (82)       = HELPFILENAME(name,82x);     \
    Name (86)       = HELPFILENAME(name,86x);     \
    Name (88)       = HELPFILENAME(name,88x);     \
    Name (90)       = HELPFILENAME(name,90x);     \
    Name (96)       = HELPFILENAME(name,96x)

#define HELPFILENAME_ALL_LANG(name, endung) \
    Name (01)       = HELPFILENAME(name,endung);     \
    Name (03)       = HELPFILENAME(name,endung);     \
    Name (07)       = HELPFILENAME(name,endung);     \
    Name (30)       = HELPFILENAME(name,endung);     \
    Name (31)       = HELPFILENAME(name,endung);     \
    Name (33)       = HELPFILENAME(name,endung);     \
    Name (34)       = HELPFILENAME(name,endung);     \
    Name (39)       = HELPFILENAME(name,endung);     \
    Name (45)       = HELPFILENAME(name,endung);     \
    Name (46)       = HELPFILENAME(name,endung);     \
    Name (48)       = HELPFILENAME(name,endung);     \
    Name (49)       = HELPFILENAME(name,endung);     \
    Name (81)       = HELPFILENAME(name,endung);     \
    Name (82)       = HELPFILENAME(name,endung);     \
    Name (86)       = HELPFILENAME(name,endung);     \
    Name (88)       = HELPFILENAME(name,endung);     \
    Name (90)       = HELPFILENAME(name,endung);     \
    Name (96)       = HELPFILENAME(name,endung)

#define HELPDIRNAME_ALL_LANG \
    Dir (01)       = GID_DIR_HELP_01;     \
    Dir (03)       = GID_DIR_HELP_03;     \
    Dir (07)       = GID_DIR_HELP_07;     \
    Dir (30)       = GID_DIR_HELP_30;     \
    Dir (31)       = GID_DIR_HELP_31;     \
    Dir (33)       = GID_DIR_HELP_33;     \
    Dir (34)       = GID_DIR_HELP_34;     \
    Dir (39)       = GID_DIR_HELP_39;     \
    Dir (45)       = GID_DIR_HELP_45;     \
    Dir (46)       = GID_DIR_HELP_46;     \
    Dir (48)       = GID_DIR_HELP_48;     \
    Dir (49)       = GID_DIR_HELP_49;     \
    Dir (81)       = GID_DIR_HELP_81;     \
    Dir (82)       = GID_DIR_HELP_82;     \
    Dir (86)       = GID_DIR_HELP_86;     \
    Dir (88)       = GID_DIR_HELP_88;     \
    Dir (90)       = GID_DIR_HELP_90;     \
    Dir (96)       = GID_DIR_HELP_96

#define DIR_IDENT_ALL_LANG(name) \
    DosName (01)       = STRING(name);     \
    DosName (03)       = STRING(name);     \
    DosName (07)       = STRING(name);     \
    DosName (30)       = STRING(name);     \
    DosName (31)       = STRING(name);     \
    DosName (33)       = STRING(name);     \
    DosName (34)       = STRING(name);     \
    DosName (39)       = STRING(name);     \
    DosName (45)       = STRING(name);     \
    DosName (46)       = STRING(name);     \
    DosName (48)       = STRING(name);     \
    DosName (49)       = STRING(name);     \
    DosName (81)       = STRING(name);     \
    DosName (82)       = STRING(name);     \
    DosName (86)       = STRING(name);     \
    DosName (88)       = STRING(name);     \
    DosName (90)       = STRING(name);     \
    DosName (96)       = STRING(name)


/* --------------------------------------------------*/

#define FILE_BODY \
	Carrier			= GID_DATACARRIER;	\
	Date			= GCFG_DATE_STAMP;	\
	Time			= GCFG_TIME_STAMP;

#define BIN_FILE_BODY FILE_BODY \
	UnixRights		= 755

#define TXT_FILE_BODY FILE_BODY \
	UnixRights		= 644

/* --------------------------------------------------*/

#endif /* GCFG_INC */
