/*************************************************************************
 *
 *  $RCSfile: dwin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:47:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _DWIN_HXX
#define _DWIN_HXX

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_DOCKWIN_HXX
#include <vcl/dockwin.hxx>
#endif

#ifndef _SVTABBX_HXX
#include <svtools/svtabbx.hxx>
#endif

#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif

class SplitWindow;
class ToolBox;
class StatusBar;

class SvLBoxButtonData;
class PrjList;

/////////////////////////////////////////////////////////////////////

class ProjectView : public SvTabListBox
{
	SvLBoxButtonData*		m_pButtons;

	DECL_LINK( DblClickHdl, void* );
public:
		ProjectView( Window* pParent, WinBits nWinStyle );
		~ProjectView();
	virtual void			CheckButtonHdl();
	SvLBoxEntry* 			InsertEntry( const ByteString& rLine, SvLBoxEntry* pParent = NULL,
										 SvButtonState eState = SV_BUTTON_UNCHECKED,
										 Project* pPrj = NULL );
};

class UpperWin : public DockingWindow
{
	ProjectView*			m_pPrjView;
public:
		UpperWin( Window* pParent, WinBits nWinBits );
		~UpperWin();
	void					ListProjects(PrjList* pLst);
	void   					Resize();
};

/////////////////////////////////////////////////////////////////////

class LowerWin : public DockingWindow
{
		ListBox*			m_pList;
public:
		LowerWin( Window* pParent, WinBits nWinBits );
		~LowerWin();

	void   					Resize();
	void   					Log( const ByteString& rMsg );
};

/////////////////////////////////////////////////////////////////////

class QueueWin : public DockingWindow
{
		ListBox*			m_pList;
		void 				InsertEntry( ZipJob* pJob );

			DECL_LINK( DblClickHdl, void* );
public:
		QueueWin( Window* pParent, WinBits nWinBits );
		~QueueWin();

	void   					Resize();
	void   					Update( JobQueue* pQueue );
};

/////////////////////////////////////////////////////////////////////

class MainWin : public WorkWindow
{
	SplitWindow* 		m_pSplitWin;
	UpperWin* 	 		m_pUpperWin;
	LowerWin* 	  		m_pLowerWin;
	QueueWin*			m_pQueueWin;

	ToolBox*			m_pToolBox;
	StatusBar*			m_pStatusBar;

	DECL_LINK( SelectHdl, ToolBox* );
public:
		MainWin(Window* pParent, WinBits nWinStyle );
		~MainWin();

	void   					Resize();

	void 					EnableToolbar( BOOL bOn );

	void 					SetQueuePending( USHORT n );
	void 					SetQueueProcess( USHORT n );
	void 					SetVolume( ULONG n );

	UpperWin* 	 			GetUpperWin() const { return m_pUpperWin; }
	LowerWin* 	  			GetLowerWin() const { return m_pLowerWin; }
	QueueWin*				GetQueueWin() const { return m_pQueueWin; }
};

#endif // _DWIN_HXX
