/*************************************************************************
 *
 *  $RCSfile: dragserv.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_FORM_FORMBUTTONTYPE_HPP_
#include <com/sun/star/form/FormButtonType.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif
#define ITEMID_FIELD    EE_FEATURE_FIELD
#ifndef _SVX_FLDITEM_HXX //autogen
#include <svx/flditem.hxx>
#endif
#ifndef _SVDPAGV_HXX //autogen
#include <svx/svdpagv.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVDOOLE2_HXX //autogen
#include <svx/svdoole2.hxx>
#endif
#ifndef _SVDOGRAF_HXX //autogen
#include <svx/svdograf.hxx>
#endif
#ifndef _SVDOTEXT_HXX //autogen
#include <svx/svdotext.hxx>
#endif
#ifndef _OUTLOBJ_HXX //autogen
#include <svx/outlobj.hxx>
#endif
#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif
#ifndef _SFXITEMPOOL_HXX //autogen
#include <svtools/itempool.hxx>
#endif
#ifndef _EDITOBJ_HXX //autogen
#include <svx/editobj.hxx>
#endif
#ifndef _SV_CLIP_HXX //autogen
#include <vcl/clip.hxx>
#endif
#ifndef _SVX_FMGLOB_HXX
#include <svx/fmglob.hxx>
#endif
#ifndef _SVDOUNO_HXX //autogen
#include <svx/svdouno.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SOT_FORMATS_HXX //autogen
#include <sot/formats.hxx>
#endif

#pragma hdrstop

#include <svtools/urlbmk.hxx>
#include <svx/outliner.hxx>
#include <svx/svdetc.hxx>

#include "dragserv.hxx"
#include "docshell.hxx"
#include "sdview.hxx"
#include "sdpage.hxx"
#include "drawview.hxx"
#include "drawdoc.hxx"
#include "stlpool.hxx"
#include "strings.hrc"
#include "sdresid.hxx"
#include "imapinfo.hxx"

using namespace ::rtl;
using namespace ::com::sun::star;

#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif

/*************************************************************************
|*
|* Ctor
|*
\************************************************************************/

SdDataObject::SdDataObject(SdDrawDocument* pSrcDoc, SdView* pView)
	: SvDataMemberObject(),
	pSourceDoc(pSrcDoc),
	pSdViewIntern(pView),
	pSdView(pView),
	pSdDrawDocumentIntern(NULL),
	pSdDrawDocument(NULL),
	pObjectDescriptor(NULL),
	pVDev(NULL),
	bInternalMove(FALSE),
	bOwnView(FALSE),
	bOwnDocument(FALSE),
	pBookmark( NULL ),
	pGraphic( NULL ),
	pImageMap( NULL )
{
	if ( pSdView )
	{
		const SdrMarkList&	rMarkList = pSdView->GetMarkList();

		if ( rMarkList.GetMarkCount() == 1 )
		{
			const SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();

			if ( pObj )
			{
				UINT32 nInv = pObj->GetObjInventor();
				UINT16 nIdent = pObj->GetObjIdentifier();

				if (nInv == SdrInventor && nIdent == OBJ_OLE2)
				{
					const SvInPlaceObjectRef& rOldObjRef = ((SdrOle2Obj*)pObj)->GetObjRef();
					if ( rOldObjRef.Is() )
						aOleRef = rOldObjRef->CreateSnapshot();
				}
				else if (nInv == SdrInventor && nIdent == OBJ_GRAF )
				{
					pGraphic = new Graphic( ( (SdrGrafObj*) pObj )->GetTransformedGraphic() );
				}
				else if (pObj->IsUnoObj() && FmFormInventor == pObj->GetObjInventor() &&
						 (nIdent == (UINT16) OBJ_FM_BUTTON))
				{
					SdrUnoObj* pUnoCtrl = (SdrUnoObj*) pObj;
					if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
					{
						uno::Reference< awt::XControlModel > xControlModel( pUnoCtrl->GetUnoControlModel() );

						if( !xControlModel.is() )
							return;

						uno::Reference< beans::XPropertySet > xPropSet( xControlModel, uno::UNO_QUERY );
						if(!xPropSet.is())
							return;

						uno::Any aTmp;

						form::FormButtonType eButtonType;
						aTmp = xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM("ButtonType")));
						if( aTmp >>= eButtonType )
						{
							// Label
							OUString aLabel;
							xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM("Label"))) >>= aLabel;

							// URL
							OUString aURL;
							xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM("TargetURL"))) >>= aURL;

							pBookmark = new INetBookmark( String(aURL), String(aLabel) );
						}
					}
				}
				else if ( pObj->ISA( SdrTextObj ) )
				{
					const OutlinerParaObject* pPara;
					if ( pPara = ( (SdrTextObj*) pObj )->GetOutlinerParaObject() )
					{
						const SvxFieldItem* pField;
						if ( pField = pPara->GetTextObject().GetField() )
						{
							const SvxFieldData* pData = pField->GetField();
							if ( pData && pData->ISA( SvxURLField ) )
							{
								const SvxURLField* pURL = (const SvxURLField*) pData;
								pBookmark = new INetBookmark( pURL->GetURL(),
															  pURL->GetRepresentation() );
							}
						}
					}
				}

				// ggf. ImageMap besorgen
				SdIMapInfo*	pInfo = ( (SdDrawDocument*) pObj->GetModel() )->GetIMapInfo( (SdrObject*) pObj );

				if ( pInfo )
					pImageMap = new ImageMap( pInfo->GetImageMap() );
			}
		}
	}
}


/*************************************************************************
|*
|* Ctor
|*
\************************************************************************/

SdDataObject::SdDataObject(SdDrawDocument* pSrcDoc)
	: SvDataMemberObject(),
	pSourceDoc(pSrcDoc),
	pSdViewIntern(NULL),
	pSdView(NULL),
	pSdDrawDocumentIntern(NULL),
	pSdDrawDocument(NULL),
	pObjectDescriptor(NULL),
	pVDev(NULL),
	bInternalMove(FALSE),
	bOwnView(FALSE),
	bOwnDocument(FALSE),
	pBookmark( NULL ),
	pGraphic( NULL ),
	pImageMap( NULL )
{
}


/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

SdDataObject::~SdDataObject()
{
	if (this == SD_MOD()->pDragData)
	{
		SD_MOD()->pDragData = NULL;
	}

	if (this == SD_MOD()->pClipboardData)
	{
		SD_MOD()->pClipboardData = NULL;
	}

	if (bOwnView)
	{
		delete pSdViewIntern;
		delete pVDev;
	}

	if (bOwnDocument)
	{
		delete pSdDrawDocumentIntern;
	}

	aTypeList.Clear();

	if ( aDocShellRef.Is() )
	{
		SvEmbeddedObject* pObj = aDocShellRef;
		SdDrawDocShell* pDocSh = (SdDrawDocShell*) pObj;
		pDocSh->DoClose();
	}

	aDocShellRef.Clear();

	aOleRef.Clear();

	delete pObjectDescriptor;

	if ( pBookmark )
		delete pBookmark;

	if ( pGraphic )
		delete pGraphic;

	if ( pImageMap )
		delete pImageMap;
}


/*************************************************************************
|*
|* Dokument bekannt geben
|*
\************************************************************************/

void SdDataObject::SetDocument(SdDrawDocument* pDoc)
{
	pSdDrawDocumentIntern = pDoc;
	pSdDrawDocument = pDoc;
}



/*************************************************************************
|*
|*
|*
\************************************************************************/

void SdDataObject::CreateData()
{
	if (pSdDrawDocument && !pSdViewIntern)
	{
		/**********************************************************************
		* Dokument vorhanden, View muss erzeugt werden
		**********************************************************************/
		SdPage* pPage = pSdDrawDocument->GetSdPage(0, PK_STANDARD);
		ULONG nObjCount = pPage->GetObjCount();

		if (nObjCount == 1)
		{
			SdrObject* pObj = pPage->GetObj(0);
			UINT32 nInv = pObj->GetObjInventor();
			UINT16 nIdent = pObj->GetObjIdentifier();

			if (nInv = SdrInventor && nIdent == OBJ_OLE2)
			{
				const SvInPlaceObjectRef& rOldObjRef = ((SdrOle2Obj*)pObj)->GetObjRef();
				if ( rOldObjRef.Is() )
					aOleRef = rOldObjRef->CreateSnapshot();
			}
			else if (nInv = SdrInventor && nIdent == OBJ_GRAF)
			{
				if ( pGraphic )
					delete pGraphic;

				pGraphic = new Graphic( ( (SdrGrafObj*) pObj )->GetTransformedGraphic() );
			}

			// ggf. noch die ImageMap besorgen
			SdIMapInfo*	pInfo = ( (SdDrawDocument*) pObj->GetModel() )->GetIMapInfo( pObj );
			if ( pInfo )
			{
				if ( pImageMap )
					delete pImageMap;

				pImageMap = new ImageMap( pInfo->GetImageMap() );
			}
		}

		ULONG nExportObjCount = nObjCount;
		SdrObject* pObj = NULL;
		SdrObject* pDelObj = NULL;

		USHORT nDemoKind =	SFX_APP()->GetDemoKind();

		if ( nDemoKind == SFX_DEMOKIND_DEMO || nDemoKind == SFX_DEMOKIND_INVALID )
		{
			/******************************************************************
			* Demoversion: Es werden nur 10 Objekte exportiert
			******************************************************************/
			nExportObjCount = 10;

			if ( nObjCount >= nExportObjCount )
			{
				InfoBox( NULL, String(SdResId(STR_DEMO_EXPORT_LIMIT) ) ).Execute();

				for (ULONG nObj = nObjCount - 1; nObj >= nExportObjCount; nObj--)
				{
					// Es werden nur die ersten 10 Objekte exportiert,
					// die anderen entfallen.
					pDelObj = pPage->NbcRemoveObject(nObj);
					delete pDelObj;
				}
			}
		}

		pVDev = new VirtualDevice( *Application::GetDefaultDevice() );
		MapMode aMap = pVDev->GetMapMode();
		aMap.SetMapUnit( pSdDrawDocumentIntern->GetScaleUnit() );
		aMap.SetScaleX( pSdDrawDocumentIntern->GetScaleFraction() );
		aMap.SetScaleY( pSdDrawDocumentIntern->GetScaleFraction() );
		pVDev->SetMapMode(aMap);

		bOwnView = TRUE;
		pSdViewIntern = new SdView(pSdDrawDocumentIntern, pVDev);
		pSdViewIntern->EndListening(*pSdDrawDocumentIntern);
		pSdViewIntern->SetMarkHdlHidden(TRUE);
		SdrPageView* pPageView = pSdViewIntern->ShowPage(pPage, Point());
		((SdrMarkView*)pSdViewIntern)->MarkAll(pPageView);

		if (pSdDrawDocumentIntern->GetPageCount() == 1)
		{
			// Dokument wurde fuer den Zeichentisch erstellt
			// (im Gegensatz zum Diatisch)
			aVisArea = pSdViewIntern->GetAllMarkedRect();

			nObjCount = pPage->GetObjCount();
			Point aOrigin = aVisArea.TopLeft();
			Size aVector( -aOrigin.X(), -aOrigin.Y() );

			for (ULONG nObj = 0; nObj < nObjCount; nObj++)
			{
				// Das BoundingRect aller Objekte wird auf (0, 0) positioniert
				pObj = pPage->GetObj(nObj);
				pObj->NbcMove(aVector);
			}
		}
		else
		{
			aVisArea.SetSize(pPage->GetSize());
		}

		// Die Ausgabe soll am Nullpunkt erfolgen
		aVisArea.SetPos( Point() );
	}
	else if (pSdView && !pSdDrawDocumentIntern)
	{
		/**********************************************************************
		* View vorhanden, Dokument muss erzeugt werden
		**********************************************************************/
		bOwnDocument = TRUE;
		pSdDrawDocumentIntern = (SdDrawDocument*) pSdView->GetAllMarkedModel();

		if ( !aDocShellRef.Is() && pSdDrawDocumentIntern->GetDocSh() )
		{
			// DocShell schon vorhanden ( AllocModel() )
			aDocShellRef = pSdDrawDocumentIntern->GetDocSh();
			bOwnDocument = FALSE;	   // Eigentuemeruebergang
		}

		// Groesse der Source-Seite uebernehmen
		SdrPageView* pPgView = pSdView->GetPageViewPvNum(0);
		SdPage* pOldPage = (SdPage*) pPgView->GetPage();
		SdPage* pPage = pSdDrawDocumentIntern->GetSdPage(0, PK_STANDARD);
		pPage->SetSize( pOldPage->GetSize() );

		// Am neuen Dokument wird der StyleSheetPool gesetzt
		String aOldLayoutName(pOldPage->GetLayoutName());
		pPage->SetLayoutName(aOldLayoutName);

		SdrModel* pOldModel = pSdView->GetModel();
		SdStyleSheetPool* pOldStylePool = (SdStyleSheetPool*) pOldModel->GetStyleSheetPool();
		SdStyleSheetPool* pNewStylePool = (SdStyleSheetPool*) pSdDrawDocumentIntern->GetStyleSheetPool();
		pNewStylePool->CopyGraphicSheets(*pOldStylePool);
		aOldLayoutName.Erase( aOldLayoutName.SearchAscii( SD_LT_SEPARATOR ) );
		pNewStylePool->CopyLayoutSheets(aOldLayoutName, *pOldStylePool);

		ULONG nObjCount = pPage->GetObjCount();
		ULONG nExportObjCount = nObjCount;
		SdrObject* pObj = NULL;
		SdrObject* pDelObj = NULL;

		USHORT nDemoKind =	SFX_APP()->GetDemoKind();

		if ( nDemoKind == SFX_DEMOKIND_DEMO || nDemoKind == SFX_DEMOKIND_INVALID )
		{
			/******************************************************************
			* Demoversion: Es werden nur 10 Objekte exportiert
			******************************************************************/
			nExportObjCount = 10;

			if ( nObjCount >= nExportObjCount )
			{
				InfoBox( NULL, String(SdResId(STR_DEMO_EXPORT_LIMIT) ) ).Execute();

				for (ULONG nObj = nObjCount - 1; nObj >= nExportObjCount; nObj--)
				{
					// Es werden nur die ersten 10 Objekte exportiert,
					// die anderen entfallen.
					pDelObj = pPage->NbcRemoveObject(nObj);
					delete pDelObj;
				}
			}
		}

		if (pSdDrawDocumentIntern->GetPageCount() == 1)
		{
			// Dokument wurde fuer den Zeichentisch erstellt
			// (im Gegensatz zum Diatisch)
			aVisArea = pSdView->GetAllMarkedRect();

			nObjCount = pPage->GetObjCount();
			Point aOrigin = aVisArea.TopLeft();
			Size aVector( -aOrigin.X(), -aOrigin.Y() );

			for (ULONG nObj = 0; nObj < nObjCount; nObj++)
			{
				// Das BoundingRect aller Objekte wird auf (0, 0) positioniert
				pObj = pPage->GetObj(nObj);
				pObj->NbcMove(aVector);
			}
		}
		else
		{
			aVisArea.SetSize(pPage->GetSize());
		}

		// Die Ausgabe soll am Nullpunkt erfolgen
		aVisArea.SetPos( Point() );
	}
}



/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SdDataObject::GetData(SvData * pData)
{
	BOOL bOK = FALSE;

	if ( !GetTypeList().Get(*pData) )
	{
		return(bOK);
	}

	CreateData();

	ULONG nFormat = pData->GetFormat();

	if ( pObjectDescriptor && ( nFormat == SOT_FORMATSTR_ID_LINKSRCDESCRIPTOR ||
								nFormat == SOT_FORMATSTR_ID_OBJECTDESCRIPTOR ) )
	{
		SvMemoryStream aStream;
		aStream << *pObjectDescriptor;
		pData->SetData( (void*) aStream.GetData(), aStream.GetSize() );
		bOK = TRUE;
	}
	else if ( nFormat == SOT_FORMATSTR_ID_DRAWING)
	{
		SdDrawDocument* pDoc = pSdDrawDocumentIntern;

		if (pSdViewIntern)
		{
			pDoc = (SdDrawDocument*) pSdViewIntern->GetAllMarkedModel();
		}
		else if (pSdView)
		{
			pDoc = (SdDrawDocument*) pSdView->GetAllMarkedModel();
		}

		// StyleSheet-Attribute in harte Attribute ueberfuehren
		pDoc->BurnInStyleSheetAttributes();

		pDoc->SetStreamingSdrModel(TRUE);
		bOwnDocument = FALSE;		   // Eigentuemeruebergang

		// OLE-Objekte entfernen (und ggf. von Verbindern trennen)
		pDoc->RemoveNotPersistentObjects(TRUE);

		SvStorageStreamRef xStream(new SvStorageStream(String()));
		xStream->SetVersion(SOFFICE_FILEFORMAT_NOW);
		xStream->SetBufferSize(16348);
		pDoc->GetItemPool().Store(*xStream);
		*xStream << *pDoc;
		xStream->Seek(0);
		pData->SetData(xStream, xStream->GetSize(), TRANSFER_MOVE);
		pDoc->SetStreamingSdrModel(FALSE);
		delete pDoc;
		bOK = TRUE;
	}
	else if (nFormat == FORMAT_GDIMETAFILE)
	{
		GDIMetaFile aMtf ( pSdViewIntern->GetAllMarkedMetaFile(TRUE) );
		pData->SetData(&aMtf);
		bOK = TRUE;
	}
	else if (nFormat == FORMAT_BITMAP)
	{
		Bitmap aBmp ( pSdViewIntern->GetAllMarkedBitmap(TRUE) );
		pData->SetData(&aBmp);
		bOK = TRUE;
	}
	else if (nFormat == FORMAT_STRING)
	{
//  	  String aString;
//		  SdrTextObj* pTextObj = pSdViewIntern->GetTextObj();
//
//		  if (pTextObj)
//		  {
//			  aString = pTextObj->GetText();
//		  }

		pData->SetData( String() );
		bOK = TRUE;
	}
	else if ( ( nFormat == SOT_FORMATSTR_ID_SVXB ) && pGraphic )
	{
		pData->SetData( pGraphic );
		bOK = TRUE;
	}
	else if ( ( nFormat == SOT_FORMATSTR_ID_SVIM ) && pImageMap )
	{
		pData->SetData( pImageMap );
		bOK = TRUE;
	}
	else if ( pBookmark )
		bOK = pBookmark->SetData( *pData );
	else
	{
		ULONG nOldSwapMode;

		if( pSdDrawDocumentIntern )
		{
			nOldSwapMode = pSdDrawDocumentIntern->GetSwapGraphicsMode();
			pSdDrawDocumentIntern->SetSwapGraphicsMode( SDR_SWAPGRAPHICSMODE_PURGE );
		}

		if ( aOleRef.Is() )
		{
			bOK = aOleRef->GetData( pData );
		}
		else
		{
			if ( !aDocShellRef.Is() )
			{
				aDocShellRef = new SdDrawDocShell(pSdDrawDocumentIntern,
								   SFX_CREATE_MODE_EMBEDDED, TRUE,
								   pSdDrawDocumentIntern->GetDocumentType());
				bOwnDocument = FALSE;	   // Eigentuemeruebergang
				aDocShellRef->DoInitNew(NULL);
			}

			aDocShellRef->SetVisArea(aVisArea);
			bOK = aDocShellRef->GetData(pData);
		}

		if( pSdDrawDocumentIntern )
			pSdDrawDocumentIntern->SetSwapGraphicsMode( nOldSwapMode );
	}

	return (bOK);
}



/*************************************************************************
|*
|*
|*
\************************************************************************/

BOOL SdDataObject::GetDataHere(SvData* pData)
{
	BOOL bOK = FALSE;

	if ( !GetTypeList().Get(*pData) )
	{
		return(bOK);
	}

	CreateData();

	ULONG nFormat = pData->GetFormat();

	if ( nFormat == FORMAT_GDIMETAFILE	     ||
		 nFormat == FORMAT_BITMAP		     ||
		 nFormat == SOT_FORMATSTR_ID_HTML    ||
		 nFormat == FORMAT_RTF			     ||
		 nFormat == FORMAT_STRING		     ||
		 nFormat == SOT_FORMATSTR_ID_DRAWING ||
		 nFormat == SOT_FORMATSTR_ID_SVXB    ||
		 nFormat == SOT_FORMATSTR_ID_SVIM )
	{
		bOK = SvDataObject::GetDataHere( pData );
	}
	else
	{
		if ( aOleRef.Is() )
		{
			bOK = aOleRef->GetDataHere( pData );
		}
		else
		{
			if ( !aDocShellRef.Is() )
			{
				aDocShellRef = new SdDrawDocShell(pSdDrawDocumentIntern,
								   SFX_CREATE_MODE_EMBEDDED, TRUE,
								   pSdDrawDocumentIntern->GetDocumentType());
				bOwnDocument = FALSE;	   // Eigentuemeruebergang
				aDocShellRef->DoInitNew(NULL);
			}

			aDocShellRef->SetVisArea(aVisArea);
			bOK = aDocShellRef->GetDataHere(pData);
		}
	}

	return (bOK);
}



/*************************************************************************
|*
|*
|*
\************************************************************************/

const SvDataTypeList& SdDataObject::GetTypeList() const
{
	SdDataObject* pDataObj = (SdDataObject*) this;

	if ( !aTypeList.Count() )
	{
		if (!pSdViewIntern)
		{
			pDataObj->CreateData();
		}

		SdrGrafObj* pGraphObj = NULL;
		SdDrawDocument* pDoc = NULL;
		const SdrMarkList&	rMarkList = pSdViewIntern->GetMarkList();
		const BOOL			bOneMarked = rMarkList.GetMarkCount() == 1;

		if (bOneMarked)
		{
			SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();

			if (pObj && pObj->GetObjInventor() == SdrInventor &&
				pObj->GetObjIdentifier() == OBJ_GRAF)
			{
				pGraphObj = (SdrGrafObj*) pObj;
				pDoc = (SdDrawDocument*) pGraphObj->GetModel();
			}
		}

		if (pGraphObj && !pDoc->GetAnimationInfo(pGraphObj))
		{
			/******************************************************************
			* Genau ein Graphik-Objekt selektiert (Bmp oder Mtf) und
			* keine Animations-Info vorhanden
			******************************************************************/
			if (pGraphObj && pGraphObj->GetGraphicType() == GRAPHIC_BITMAP)
			{
				pDataObj->aTypeList.Append(SvDataType(SOT_FORMATSTR_ID_SVXB, MEDIUM_STREAM | MEDIUM_MEMORY));
				pDataObj->aTypeList.Append(SvDataType(FORMAT_BITMAP));
				pDataObj->aTypeList.Append(SvDataType(FORMAT_GDIMETAFILE));
			}
			else
			{
				pDataObj->aTypeList.Append(SvDataType(FORMAT_GDIMETAFILE));
				pDataObj->aTypeList.Append(SvDataType(FORMAT_BITMAP));
			}
		}
		else if (pBookmark)
		{
			/******************************************************************
			* Genau ein Bookmark-Objekt selektiert
			******************************************************************/
			pDataObj->aTypeList = SvEmbeddedObject::GetStdFormatList();
			pDataObj->aTypeList.Remove( SvDataType( FORMAT_GDIMETAFILE ) );
			pBookmark->Copy(*pDataObj);
		}
		else
		{
			pDataObj->aTypeList = SvEmbeddedObject::GetStdFormatList();

			if (pGraphObj && pGraphObj->GetGraphicType() == GRAPHIC_BITMAP)
			{
				if (pGraphObj->IsAnimated() || pGraphObj->IsTransparent())
					pDataObj->aTypeList.Append(SvDataType(SOT_FORMATSTR_ID_SVXB, MEDIUM_STREAM | MEDIUM_MEMORY));

				pDataObj->aTypeList.Insert(SvDataType(SOT_FORMATSTR_ID_DRAWING, MEDIUM_STREAM | MEDIUM_MEMORY), 1);
				pDataObj->aTypeList.Remove(SvDataType(FORMAT_GDIMETAFILE));
				pDataObj->aTypeList.Append(SvDataType(FORMAT_BITMAP));
				pDataObj->aTypeList.Append(SvDataType(FORMAT_GDIMETAFILE));
			}
			else
			{
				pDataObj->aTypeList.Insert(SvDataType(SOT_FORMATSTR_ID_DRAWING, MEDIUM_STREAM | MEDIUM_MEMORY), 1);
				pDataObj->aTypeList.Append(SvDataType(FORMAT_BITMAP));
			}

			if (aOleRef.Is())
			{
				pDataObj->aTypeList.Remove(SvDataType(SOT_FORMATSTR_ID_DRAWING, MEDIUM_STREAM | MEDIUM_MEMORY));
			}
		}

		// ggf. ImageMap-Format zusaetzlich ins Clipboard
		if ( bOneMarked )
		{
			SdrObject*	pObj = rMarkList.GetMark( 0 )->GetObj();
			SdIMapInfo*	pInfo = ( (SdDrawDocument*) pObj->GetModel() )->GetIMapInfo( pObj );

			if ( pInfo )
			{
				pDataObj->aTypeList.Append(SvDataType(SOT_FORMATSTR_ID_SVIM, MEDIUM_STREAM | MEDIUM_MEMORY));
			}
		}
	}

	return aTypeList;
}


/*************************************************************************
|*
|*
|*
\************************************************************************/

void SdDataObject::ResetPageView()
{
	if (pSdViewIntern)
	{
		pSdViewIntern->HideAllPages();
	}
}


/*************************************************************************
|*
|*
|*
\************************************************************************/

void SdDataObject::UpdatePageView()
{
	if (pSdViewIntern && pSdDrawDocument)
	{
		SdPage* pPage = pSdDrawDocument->GetSdPage(0, PK_STANDARD);

		if (pPage)
		{
			SdrPageView* pPageView = pSdViewIntern->ShowPage(pPage, Point());
			((SdrMarkView*)pSdViewIntern)->MarkAll(pPageView);
		}
	}
}



