/*************************************************************************
 *
 *  $RCSfile: sdlib.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/urlobj.hxx>
#include <so3/clsids.hxx>
#include <svx/svxids.hrc>
#include <svx/impgrf.hxx>
#include <svtools/libcall.hxx>
#include <svtools/inettype.hxx>
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif
#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif
#ifndef _SV_EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _SFXECODE_HXX //autogen
#include <svtools/sfxecode.hxx>
#endif
#ifndef _SOT_FORMATS_HXX //autogen
#include <sot/formats.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SFX_DOCFILT_HACK_HXX
#include <sfx2/docfilt.hxx>
#endif

#ifndef _COM_SUN_STAR_UTIL_XARCHIVER_HPP_
#include <com/sun/star/util/XArchiver.hpp>
#endif

#include <unotools/processfactory.hxx>

using namespace ::rtl;
using namespace ::com::sun::star;


#pragma hdrstop

#include "sddll.hxx"

#ifdef UNX
#define DLL_NAME SVLIBRARY( "sd" )
#else
#include "sddll0.hxx"         // wird durchs Makefile generiert
#endif

#include "docshell.hxx"
#include "grdocsh.hxx"
#include "res_bmp.hrc"
#include "strings.hrc"
#include "app.hrc"
#include "strmname.h"

TYPEINIT1( SdModuleDummy, SfxModule );

SFX_IMPL_MODULE_LIB(Sd, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( DLL_NAME ) ) )

/*************************************************************************
|*
|* Impress-ObjectFactory registrieren
|*
\************************************************************************/

SFX_IMPL_OBJECTFACTORY_MOD(SdDrawDocShell, SFXOBJECTSHELL_STD_NORMAL, simpress,
						   SvGlobalName(SO3_SIMPRESS_CLASSID_50), Sd, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( DLL_NAME ) ) )
{
	ULONG nImpress50   = SOT_FORMATSTR_ID_STARIMPRESS_50;
	ULONG nDraw50      = SOT_FORMATSTR_ID_STARDRAW_50;
	ULONG nImpress40   = SOT_FORMATSTR_ID_STARDRAW_40;
	ULONG nDraw31      = SOT_FORMATSTR_ID_STARDRAW;
	ULONG nAlienFormat = 0L;
	String             aEmptyStr;

	// Hinweis zum Mac-Format, erst VIER Buchstaben TYPE, dann Extension
	// zusaetzliche Typen bei KH/DV/WKC erfragen

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
		                         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sdd" ) ),
						         SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
						         SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
								 nImpress50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsd0.sdd" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0" ) ), 
								 RID_IMPRESS_DOCWINDOWICON,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_IMPRESS ) ),
								 aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0 Vorlage" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.vor" ) ),
						         SFX_FILTER_OWN | SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
						         SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
						         nImpress50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsd1.vor" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0" ) ), 
								 RID_IMPRESS_DOCWINDOWICON,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_IMPRESS ) ),
						         aEmptyStr );

  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarImpress 4.0", "*.sdd",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nImpress40, "SVsd0.sdd", "StarImpress 4.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-starimpress"),
  //                      String());
  //
  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarImpress 4.0 Vorlage", "*.vor",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nImpress40, "SVsd1.vor", "StarImpress 4.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-starimpress"),
  //                      String());

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0 (StarImpress)" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sda" ) ),
						         SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
						         SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
						         nDraw50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsa0.sda" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0" ) ), 
								 RID_DRAW_DOCWINDOWICON,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_IMPRESS ) ),
						         aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0 Vorlage (StarImpress)" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.vor" ) ),
						         SFX_FILTER_OWN | SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
						         SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
						         nDraw50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsa1.vor" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0" ) ), 
								 RID_DRAW_DOCWINDOWICON,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_IMPRESS ) ),
						         aEmptyStr );

  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarDraw 3.0", "*.sdd",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nDraw31, "SVsd0.sdd", "StarDraw 3.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-stardraw"),
  //                      String());
  //
  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarDraw 3.0 Vorlage", "*.vor",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nDraw31, "SVsd1.vor", "StarDraw 3.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-stardraw"),
  //                      String());
  //
  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      String(pFilterPowerPoint97), "*.ppt",
  //						SFX_FILTER_IMPORT,
  //                      nAlienFormat, "PPT70.ppt", "Microsoft PowerPoint 97", RID_IMPRESS_DOCWINDOWICON,
  //                      aEmptyStr, aEmptyStr );

	SdDrawDocShell::Factory().SetCreateNewSlotId(SID_SD_AUTOPILOT);
}



/*************************************************************************
|*
|* Draw-ObjectFactory registrieren
|*
\************************************************************************/

SFX_IMPL_OBJECTFACTORY_MOD(SdGraphicDocShell, SFXOBJECTSHELL_STD_NORMAL, sdraw,
						   SvGlobalName(SO3_SDRAW_CLASSID_50), Sd, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( DLL_NAME ) ) )
{
	ULONG nImpress50   = SOT_FORMATSTR_ID_STARIMPRESS_50;
	ULONG nDraw50      = SOT_FORMATSTR_ID_STARDRAW_50;
	ULONG nImpress40   = SOT_FORMATSTR_ID_STARDRAW_40;
	ULONG nDraw31      = SOT_FORMATSTR_ID_STARDRAW;
	ULONG nAlienFormat = 0L;
	String             aEmptyStr;

	// Hinweis zum Mac-Format, erst VIER Buchstaben TYPE, dann Extension
	// zusaetzliche Typen bei KH/DV/WKC erfragen

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
						         UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sda" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
								 SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
								 nDraw50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsa0.sda" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0" ) ), 
								 RID_DRAW_DOCWINDOWICON,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_DRAW ) ),
								 aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0 Vorlage" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.vor" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
								 SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
								 nDraw50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsa1.vor" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarDraw 5.0" ) ), 
								 RID_DRAW_DOCWINDOWICON,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_DRAW ) ),
								 aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0 (StarDraw)" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sdd" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
								 SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
								 nImpress50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsd0.sdd" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0" ) ), 
								 RID_IMPRESS_DOCWINDOWICON,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_DRAW ) ),
								 aEmptyStr );

	SFX_OWN_FILTER_REGISTRATION( SdDLL::DetectFilter,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0 Vorlage (StarDraw)" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.vor" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
								 SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
								 nImpress50, 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "SVsd1.vor" ) ), 
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "StarImpress 5.0" ) ), 
								 RID_IMPRESS_DOCWINDOWICON,
								 UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( CONTENT_TYPE_STR_APP_VND_DRAW ) ),
								 aEmptyStr );

  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarDraw 3.0 (StarDraw)", "*.sdd",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nDraw31, "SVsd0.sdd", "StarDraw 3.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-stardraw"),
  //                      String());
  //
  //  SFX_OWN_FILTER_REGISTRATION(SdDLL::DetectFilter,
  //                      "StarDraw 3.0 Vorlage (StarDraw)", "*.vor",
  //                      SFX_FILTER_OWN | SFX_FILTER_ALIEN |
  //                      SFX_FILTER_TEMPLATE | SFX_FILTER_TEMPLATEPATH |
  //                      SFX_FILTER_EXPORT | SFX_FILTER_IMPORT,
  //                      nDraw31, "SVsd1.vor", "StarDraw 3.0", RID_IMPRESS_DOCWINDOWICON,
  //                      String("application/x-stardraw"),
  //                      String());
}


/*************************************************************************
|*
|* Ctor
|* the ctor is called at the beginning of SfxApplication-subclass::Main()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/

SdDLL::SdDLL()
{
}



/*************************************************************************
|*
|* Dtor
|* the dtor is called at the end of SfxApplication-subclass::Main()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/

SdDLL::~SdDLL()
{
}



/*************************************************************************
|*
|* LibInit
|* method is called before Application::Execute()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/

void SdDLL::LibInit()
{
	// in most cases you must initialize your document-factory here
	SfxApplication* pApp = SFX_APP();

	// create a dummy-module for Object-Factory-Pointer
	SfxObjectFactory *p1 = NULL;
	if (pApp->HasFeature(SFX_FEATURE_SIMPRESS))
	{
		SdDrawDocShell::RegisterFactory(SDT_SD_DOCFACTPRIO);
		p1 = &SdDrawDocShell::Factory();
	}

	SfxObjectFactory *p2 = NULL;
	if (pApp->HasFeature(SFX_FEATURE_SDRAW))
	{
		SdGraphicDocShell::RegisterFactory(SDT_SD_DOCFACTPRIO);
		p2 = &SdGraphicDocShell::Factory();
	}

    SD_MOD() = new SdModuleDummy( NULL, TRUE, p1, p2 );
}



/*************************************************************************
|*
|* LibExit
|* this method is called after Application::Execute()
|* do whatever you want, but no calls to Sd-DLL-code!
|*
\************************************************************************/

void SdDLL::LibExit()
{
	// Innerhalb von FreeLibSd wird Exit() gerufen
	FreeLibSd();

	// destroy the dummy-module with Object-Factory-Pointer
	DELETEZ( SD_MOD() );
}


/*************************************************************************
|*
|* Filter bestimmen
|* (wird fuer normales Laden eines Dokuments mit nClass == USHRT_MAX gerufen)
|*
\************************************************************************/

ULONG __EXPORT SdDLL::DetectFilter(SfxMedium& rMedium, const SfxFilter** pFilter,
						  SfxFilterFlags nMust, SfxFilterFlags nDont)
{
	ULONG nReturn = ERRCODE_ABORT;  // Erkennung fehlgeschlagen, Filter ungueltig
	BOOL bStorage = FALSE;

	if( *pFilter && (*pFilter)->GetFilterFlags() & SFX_FILTER_PACKED )
	{
		uno::Reference< lang::XMultiServiceFactory > xSMgr( ::utl::getProcessServiceFactory() );
		uno::Reference< util::XArchiver > xPacker( xSMgr->createInstance( OUString::createFromAscii( "com.sun.star.util.Archiver" ) ), uno::UNO_QUERY );
		if( xPacker.is() )
		{
			// extract extra data
			OUString aPath( rMedium.GetOrigURL() );
			OUString aExtraData( xPacker->getExtraData( aPath ) );
			const OUString aSig1= OUString::createFromAscii( "private:" );
			String aTmp;
			aTmp += sal_Unicode( '?' );
			aTmp += (*pFilter)->GetFilterContainer()->GetName();
			const OUString aSig2( aTmp );
			INT32 nIndex1 = aExtraData.indexOf( aSig1 );
			INT32 nIndex2 = aExtraData.indexOf( aSig2 );
			if( nIndex1 == 0 && nIndex2 != -1 )
				return ERRCODE_NONE;
		}
	}
	else if (rMedium.GetError() == SVSTREAM_OK)
	{
		if (rMedium.IsStorage())
		{
			bStorage = TRUE;
			// Storage
			SvStorage* pStorage = rMedium.GetStorage();
			if ( pStorage == NULL ) return ULONG_MAX;


			// Erkennung ueber contained streams (StarDraw 3.0)
			if ((pStorage->IsContained(pStarDrawDoc)  &&
				 pStorage->IsStream(pStarDrawDoc))		 ||
				(pStorage->IsContained(pStarDrawDoc3) &&
				 pStorage->IsStream(pStarDrawDoc3)))
			{
				const SfxFilter* pFilt = NULL;
				SfxFilterMatcher& rMatcher = SFX_APP()->GetFilterMatcher();
				SfxFilterContainer *pDraw = rMatcher.GetContainer( 
					                        UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "sdraw" ) ) ); // Name kennt ihr besser
				SfxFilterContainer *pImpr = rMatcher.GetContainer( 
					                        UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "simpress" ) )); // dito
				ULONG nStorFmt = pStorage->GetFormat();
				if (*pFilter)
				{
					// Da leider die FilterName-Abfrage untauglich ist ( Star Draw 3.0 heit in eurem
					// Impress-Container eben nicht so, sondern Star Draw 3.0 ( impress ), schlage ich
					// vor, zum Suchen den MimeType zu nehmen, der ist in beiden Containern gleich
					// Die HasFeature-Abfragen scheinen mir ueberfluessig. In dem Fall koennte auch
					// der dritte Block entfallen.
					if ( (*pFilter)->GetFilterContainer() == pDraw)
					{
						if (SFX_APP()->HasFeature(SFX_FEATURE_SDRAW) )
						{
							pFilt = *pFilter;
							nReturn = ERRCODE_NONE;
						}
						else
						{
							pFilt = pImpr->GetFilter4ClipBoardId( nStorFmt );
							nReturn = ERRCODE_SFX_FORCEQUIET;
						}
					}
					else if ( (*pFilter)->GetFilterContainer() == pImpr)
					{
						if (SFX_APP()->HasFeature(SFX_FEATURE_SIMPRESS) )
						{
							pFilt = *pFilter;
							nReturn = ERRCODE_NONE;
						}
						else
						{
							pFilt = pDraw->GetFilter4ClipBoardId( nStorFmt );
							nReturn = ERRCODE_SFX_FORCEQUIET;
						}
					}
				}
				else if (SFX_APP()->HasFeature(SFX_FEATURE_SIMPRESS))
				{
					pFilt = pImpr->GetFilter4ClipBoardId( nStorFmt );
					nReturn = ERRCODE_NONE;
				}
				else if (SFX_APP()->HasFeature(SFX_FEATURE_SDRAW))
				{
					pFilt = pDraw->GetFilter4ClipBoardId( nStorFmt );
					nReturn = ERRCODE_NONE;
				}

				if (pFilt &&
					(pFilt->GetFilterFlags() & nMust) == nMust &&
					(pFilt->GetFilterFlags() & nDont) == 0)
				{
					*pFilter = pFilt;
				}
				else
				{
					*pFilter = NULL;
					nReturn = ERRCODE_NONE;
				}
			}
			else if (SFX_APP()->HasFeature(SFX_FEATURE_SIMPRESS))
			{
				// Erkennung ueber contained streams (PowerPoint 97-Filter)
				String aStreamName = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "PowerPoint Document" ) );
				if (pStorage->IsContained( aStreamName ) &&
					pStorage->IsStream( aStreamName ) )
				{
					String aFileName(rMedium.GetName());
					aFileName.ToUpperAscii();
					if( aFileName.SearchAscii( ".POT" ) == STRING_NOTFOUND )
					{
						*pFilter = SFX_APP()->GetFilter(SdDrawDocShell::Factory(),
											   pFilterPowerPoint97);
					}
					else
					{
						*pFilter = SFX_APP()->GetFilter(SdDrawDocShell::Factory(),
											   pFilterPowerPoint97Template);
					}

					return ERRCODE_NONE;
				}
			}
		}

		// XML filter(s)
		if(*pFilter && !rMedium.IsStorage())
		{
			String aName = (*pFilter)->GetFilterName();
			if(aName.EqualsAscii( "StarOffice XML (Draw)") 
				|| aName.EqualsAscii( "StarOffice XML (Impress)"))
				nReturn = ERRCODE_NONE;
		}

		String aFileName(rMedium.GetName());
		aFileName.ToUpperAscii();

		if (nReturn == ERRCODE_ABORT)
		{
			if( bStorage )         // aber keine Clipboard-Id #55337#
			{
				*pFilter = NULL;
			}
			else
			{
				// Vektorgraphik?
				SvStream* pStm = rMedium.GetInStream();

				if( !pStm )
					nReturn = ERRCODE_IO_GENERAL;
				else
				{
					pStm->Seek( STREAM_SEEK_TO_BEGIN );

					const String		aFileName( rMedium.GetURLObject().GetName() );
					GraphicDescriptor	aDesc( *pStm, &aFileName );
					GraphicFilter*		pGrfFilter = GetGrfFilter();

					if( !aDesc.Detect( FALSE ) )
					{
						INetURLObject aURL;

						aURL.SetSmartURL( aFileName );
						
						if( aURL.getExtension().EqualsIgnoreCaseAscii( "cgm" ) )
						{
							const String aName = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "CGM - Computer Graphics Metafile" ) );
							*pFilter = SFX_APP()->GetFilter( SdDrawDocShell::Factory(), aName );
							nReturn = ERRCODE_NONE;
						}
						else
						{
							nReturn = ERRCODE_ABORT;
							*pFilter = NULL;
						}
					}
					else
					{
						USHORT	nFilter = aDesc.GetFileFormat();
						USHORT	nFilterNumber = aDesc.GetImportFormatNumber( nFilter, pGrfFilter->GetConfig() );

						if( SFX_APP()->HasFeature(SFX_FEATURE_SDRAW) )
						{
							const String aName( pGrfFilter->GetImportFormatName( nFilterNumber ) );
							*pFilter = SFX_APP()->GetFilter( SdGraphicDocShell::Factory(), aName );
							nReturn = ERRCODE_NONE;
						}
						else
						{
							nReturn = ERRCODE_ABORT;
							*pFilter = NULL;
						}
					}
				}
			}
		}
	}
	else
	{
		nReturn = rMedium.GetError();
	}

	return nReturn;
}



/*************************************************************************
|*
|* Modul laden
|*
\************************************************************************/

SfxModule* SdModuleDummy::Load()
{
	return (LoadLibSd() ? SD_MOD() : NULL);
}




/*************************************************************************
|*
|* GetID(), ID zu einer Fileformat-Version liefern
|*
\************************************************************************/

SvGlobalName SdModuleDummy::GetID(USHORT nFileFormat)
{
	SvGlobalName aName;

	switch (nFileFormat)
	{
		case SOFFICE_FILEFORMAT_50:
		{
			aName = SvGlobalName(SO3_SIMPRESS_CLASSID_50);
		}
		break;

		case SOFFICE_FILEFORMAT_40:
		{
			aName = SvGlobalName(SO3_SIMPRESS_CLASSID_40);
		}
		break;

		case SOFFICE_FILEFORMAT_31:
		{
			aName = SvGlobalName(SO3_SIMPRESS_CLASSID_30);
		}
		break;

		default:
		{
			DBG_ASSERT(FALSE, "Unbekanntes Fileformat!");
		}
		break;
	}

	return aName;
}


/*************************************************************************
|*
|* HasID(), zu einer ID die Fileformat-Version liefern
|*
\************************************************************************/

USHORT SdModuleDummy::HasID(const SvGlobalName& rName)
{
	USHORT nRet = 0;

	if (GetID(SOFFICE_FILEFORMAT_31) == rName)
	{
		// Draw 3.1
		nRet = SOFFICE_FILEFORMAT_31;
	}
	else if (GetID(SOFFICE_FILEFORMAT_40) == rName)
	{
		// Impress 4.0
		nRet = SOFFICE_FILEFORMAT_40;
	}
	else if (GetID(SOFFICE_FILEFORMAT_50) == rName)
	{
		// Impress 5.0
		nRet = SOFFICE_FILEFORMAT_50;
	}
	else if (SvGlobalName(SO3_SDRAW_CLASSID_50) == rName)
	{
		// Draw 5.0
		nRet = SOFFICE_FILEFORMAT_50;
	}

	return(nRet);
}




