/*************************************************************************
 *
 *  $RCSfile: design3d.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SVX_DLGUTIL_HXX //autogen
#include <svx/dlgutil.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_SAVEOPT_HXX //autogen
#include <sfx2/saveopt.hxx>
#endif

#include <svx/viewpt3d.hxx> // ProjectionType

#ifndef _SFXMODULE_HXX //autogen
#include <sfx2/module.hxx>
#endif

#include <svx/svxids.hrc>

#include "sdattr.hxx"
#define ITEMID_COLOR			ATTR_ANIMATION_COLOR
#include <svx/colritem.hxx>
#include <svx/e3ditem.hxx>

#include "design3d.hxx"

#include "design3d.hrc"
#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"

#include "sdresid.hxx"
#include "sdview.hxx"
#include "drawdoc.hxx"

SFX_IMPL_DOCKINGWINDOW( Sd3DChildWindow, SID_3D_WIN )

/*************************************************************************
|*	Sd3DWin - FloatingWindow
\************************************************************************/
__EXPORT Sd3DWin::Sd3DWin( SfxBindings* pInBindings,
				SfxChildWindow *pCW, Window* pParent, const SdResId& rSdResId ) :
		SfxDockingWindow    ( pInBindings, pCW, pParent, rSdResId ),

		aBtnFavorites		( this, SdResId( BTN_FAVORITES ) ),
		aBtnGeo				( this, SdResId( BTN_GEO ) ),
		aBtnRepresentation	( this, SdResId( BTN_REPRESENTATION ) ),
		aBtnLight			( this, SdResId( BTN_LIGHT ) ),
		aBtnTexture			( this, SdResId( BTN_TEXTURE ) ),
		aBtnMaterial		( this, SdResId( BTN_MATERIAL ) ),
		aBtnUpdate			( this, SdResId( BTN_UPDATE ) ),
		aBtnAssign			( this, SdResId( BTN_ASSIGN ) ),

		aCtlFavorites		( this, SdResId( CTL_FAVORITES ) ),
		aGrpFavorites		( this, SdResId( GRP_FAVORITES ) ),

		aFtHorizontal		( this, SdResId( FT_HORIZONTAL ) ),
		aNumHorizontal		( this, SdResId( NUM_HORIZONTAL ) ),
		aFtVertical			( this, SdResId( FT_VERTICAL ) ),
		aNumVertical		( this, SdResId( NUM_VERTICAL ) ),
		aGrpSegments		( this, SdResId( GRP_SEGMENTS ) ),
		aFtPercentDiagonal	( this, SdResId( FT_PERCENT_DIAGONAL ) ),
		aMtrPercentDiagonal	( this, SdResId( MTR_PERCENT_DIAGONAL ) ),
		aFtBackscale		( this, SdResId( FT_BACKSCALE ) ),
		aMtrBackscale		( this, SdResId( MTR_BACKSCALE ) ),
		aFtEndAngle			( this, SdResId( FT_END_ANGLE ) ),
		aMtrEndAngle		( this, SdResId( MTR_END_ANGLE ) ),
		aGrpGeometrie		( this, SdResId( GRP_GEOMETRIE ) ),

		aCtlMaterial 		( this, SdResId( CTL_MATERIAL ) ),
		aGrpMaterial 		( this, SdResId( GRP_MATERIAL ) ),

		aBtnPerspective		( this, SdResId( BTN_PERSPECTIVE ) ),
		aBtnConvertTo3D		( this, SdResId( BTN_CHANGE_TO_3D ) ),
		aBtnLatheObject		( this, SdResId( BTN_LATHE_OBJ ) ),
		aCtlPreview 		( this, SdResId( CTL_PREVIEW ) ),
		aGrpPreview 		( this, SdResId( GRP_PREVIEW ) ),

		bUpdate				( FALSE ),
		eViewType			( VIEWTYPE_FAVORITES ),

		pBindings			( pInBindings ),
		pPool				( NULL )
{
	FreeResource();

	// Metrik einstellen
	GET_MODULE_FIELDUNIT( eFUnit );
	//aMtrFldDepth.SetUnit( eFUnit );

	pControllerItem = new Sd3DCtrlItem( SID_EFFECT_STATE, this, pBindings );

	aBtnAssign.SetClickHdl( LINK( this, Sd3DWin, ClickAssignHdl ) );
	aBtnUpdate.SetClickHdl( LINK( this, Sd3DWin, ClickUpdateHdl ) );

	Link aLink( LINK( this, Sd3DWin, ClickViewTypeHdl ) );
	aBtnFavorites.SetClickHdl( aLink );
	aBtnGeo.SetClickHdl( aLink );
	aBtnRepresentation.SetClickHdl( aLink );
	aBtnLight.SetClickHdl( aLink );
	aBtnTexture.SetClickHdl( aLink );
	aBtnMaterial.SetClickHdl( aLink );

	aLink = LINK( this, Sd3DWin, ClickHdl );
	aBtnPerspective.SetClickHdl( aLink );
	aBtnConvertTo3D.SetClickHdl( aLink );
	aBtnLatheObject.SetClickHdl( aLink );

	aSize = GetOutputSizePixel();
	SetMinOutputSizePixel( aSize );

	Construct();

	// ViewType-Button initialisieren
	ClickViewTypeHdl( &aBtnFavorites );

	Reset();

	// Initiierung der Initialisierung der ColorLBs
	SfxBoolItem aItem( SID_3D_INIT, TRUE );
	SFX_DISPATCHER().Execute( SID_3D_INIT, SFX_CALLMODE_ASYNCHRON |
								SFX_CALLMODE_RECORD, &aItem, 0L );
}

// -----------------------------------------------------------------------
__EXPORT Sd3DWin::~Sd3DWin()
{
	delete pControllerItem;
}

// -----------------------------------------------------------------------
void Sd3DWin::Construct()
{
	// ValueSet Effect
	aCtlFavorites.SetWinStyle( aCtlFavorites.GetWinStyle() |
							WB_ITEMBORDER |
							WB_DOUBLEBORDER |
							//WB_VSCROLL |
							WB_NAMEFIELD );
	aCtlFavorites.SetColCount( 3 );
	aCtlFavorites.SetLineCount( 3 );
	aCtlFavorites.SetExtraSpacing( 2 );
	aCtlFavorites.Show();

	// Dummy
	String aStr("Favorit X");
	for( USHORT i = 1; i <= 9; i++ )
	{
		aStr[(USHORT)8] = String(i);
		aCtlFavorites.InsertItem( i,
				Bitmap( SdResId( BMP_EFFECT_RANDOM ) ),
				String( aStr ) );
	}
}

// -----------------------------------------------------------------------
void Sd3DWin::Reset()
{
	ClickUpdateHdl( NULL );
}

// -----------------------------------------------------------------------
void Sd3DWin::Update( SfxItemSet& rAttrs )
{
#ifdef BLA_SOH
	const SfxPoolItem* pItem;

	Vector3D aVector( -1, -1, -1 );
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_LIGHT, FALSE, &pItem ) )
	{
		Vector3D aVector = ( ( const SvxVector3DItem* ) pItem )->GetValue();
		aCtlLight.SetPoint( aVector );
		//aNumFldLightX.SetValue( (long) ( aVector.X() * 100.0 ) );
		//aNumFldLightY.SetValue( (long) ( aVector.Y() * 100.0 ) );
		//aNumFldLightZ.SetValue( (long) ( aVector.Z() * 100.0 ) );
	}
	else
	{
		aCtlLight.SetPoint( aVector );
		aCtlLight.Invalidate();
	}

	SfxItemState eState = rAttrs.GetItemState( SID_ATTR_3D_LIGHTINTENSITY, FALSE, &pItem );
	if( SFX_ITEM_DONTCARE != eState )
		aMtrFldLightIntensity.SetValue( ( ( const SfxUInt32Item* )pItem )->GetValue() );
	else
		aMtrFldLightIntensity.SetEmptyFieldValue();

	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_LIGHTCOLOR, FALSE, &pItem ) )
		aLbLightColor.SelectEntry( ( ( const SvxColorItem* )pItem )->GetValue() );
	else
		aLbLightColor.SetNoSelection();

	// Perspektive
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_PERSPECTIVE, FALSE, &pItem ) )
	{
		ProjectionType ePT = (ProjectionType) ( ( const SfxUInt16Item* )pItem )->GetValue();
		if( ePT == PR_PERSPECTIVE )
			aBtnPerspective.Check();
		else // PR_PARALLEL
			aBtnPerspective.Check( FALSE );
	}
	else
		aBtnPerspective.SetState( STATE_DONTKNOW );

	/*
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_AMBIENTINTENSITY, FALSE, &pItem ) )
		aMtrFldIntensity.SetValue( ( ( const SfxUInt32Item* )pItem )->GetValue() );
	else
		aMtrFldIntensity.SetText( GetEmptySStr() );

	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_AMBIENTCOLOR, FALSE, &pItem ) )
		aLbColor.SelectEntry( ( ( const SvxColorItem* )pItem )->GetValue() );
	else
		aLbColor.SetEmptyValue();
	*/

	// Anzahl Segmente (horizontal)
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_HORZ_SEGS, FALSE, &pItem ) )
		aNumFldHorzSegs.SetValue( ( ( const SfxUInt32Item* )pItem )->GetValue() );
	else
		aNumFldHorzSegs.SetEmptyFieldValue();

	// Anzahl Segmente (vertikal)
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_VERT_SEGS, FALSE, &pItem ) )
		aNumFldVertSegs.SetValue( ( ( const SfxUInt32Item* )pItem )->GetValue() );
	else
		aNumFldVertSegs.SetEmptyFieldValue();

	// Segmentanzahl aenderbar ?
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_INTERN, FALSE, &pItem ) )
	{
		UINT32 nState = ( ( const SfxUInt32Item* )pItem )->GetValue();
		BOOL bEnable = !( nState & 1 );

		aFtSegments.Enable( bEnable );
		aNumFldHorzSegs.Enable( bEnable );
		aNumFldVertSegs.Enable( bEnable );
	}

	// Tiefe
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( SID_ATTR_3D_DEPTH, FALSE, &pItem ) )
	{
		long nValue = ( ( const SfxUInt32Item* )pItem )->GetValue();

		// evtl. PoolUnit ermitteln
		if( !pPool )
		{
			pPool = rAttrs.GetPool();
			DBG_ASSERT( pPool, "Wo ist der Pool?" );
			ePoolUnit = pPool->GetMetric( SID_ATTR_LINE_WIDTH );
		}
		// evtl. FieldUnit setzen
		//eFUnit = SFX_APP()->GetOptions().GetMetric();
		GET_MODULE_FIELDUNIT( eFUnit );
		if( eFUnit != aMtrFldDepth.GetUnit() )
			SetFieldUnit( aMtrFldDepth, eFUnit );

		SetMetricValue( aMtrFldDepth, nValue, ePoolUnit );
	}
	else
		aMtrFldDepth.SetEmptyFieldValue();

	// Doppelwandig/-seitig
	/*
	pItem = GetItem( rAttrs, SID_ATTR_3D_DOUBLE_SIDED );
	if( pItem )
	{
		aTsbDoubleSided.SetState( ( ( const SfxBoolItem* )pItem )->GetValue() ?
										STATE_CHECK : STATE_NOCHECK );
		aTsbDoubleSided.EnableTriState( FALSE );
	}
	else
		aTsbDoubleSided.SetState( STATE_DONTKNOW );
	*/
#endif
}

// -----------------------------------------------------------------------
void Sd3DWin::GetAttr( SfxItemSet& rAttrs )
{
#ifdef BLA_SOH
	Color	 aColor;
	UINT32	 nValue;

	Vector3D aVector = aCtlLight.GetVector();
	if( aVector.X() == -1.0 && aVector.Y() == -1.0 && aVector.Z() == -1.0 )
		rAttrs.InvalidateItem( SID_ATTR_3D_LIGHT );
	else
		rAttrs.Put( SvxVector3DItem( SID_ATTR_3D_LIGHT, aVector ) );

	/*
	if( !aNumFldLightX.IsEmptyValue() &&
		!aNumFldLightY.IsEmptyValue() &&
		!aNumFldLightZ.IsEmptyValue() )
	{
		Vector3D aVector;
		aVector.X() = (double)aNumFldLightX.GetValue() / 100.0;
		aVector.Y() = (double)aNumFldLightY.GetValue() / 100.0;
		aVector.Z() = (double)aNumFldLightZ.GetValue() / 100.0;

		rAttrs.Put( SvxVector3DItem( SID_ATTR_3D_LIGHT, aVector ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_LIGHT );
	*/
	if( !aMtrFldLightIntensity.IsEmptyFieldValue() )
	{
		nValue = aMtrFldLightIntensity.GetValue();
		rAttrs.Put( SfxUInt32Item( SID_ATTR_3D_LIGHTINTENSITY, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_LIGHTINTENSITY );

	if( aLbLightColor.GetSelectEntryCount() )
	{
		aColor = aLbLightColor.GetSelectEntryColor();
		rAttrs.Put( SvxColorItem( aColor, SID_ATTR_3D_LIGHTCOLOR ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_LIGHTCOLOR );

	if( aBtnPerspective.GetState() != STATE_DONTKNOW )
	{
		UINT16 nValue;
		if( aBtnPerspective.IsChecked() )
			nValue = PR_PERSPECTIVE;
		else
			nValue = PR_PARALLEL;
		rAttrs.Put( SfxUInt16Item( SID_ATTR_3D_PERSPECTIVE, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_PERSPECTIVE );

	/*
	if( !aMtrFldIntensity.IsEmptyValue() )
	{
		nValue = aMtrFldIntensity.GetValue();
		rAttrs.Put( SfxUInt32Item( SID_ATTR_3D_AMBIENTINTENSITY, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_AMBIENTINTENSITY );

	if( aLbColor.GetSelectEntryCount()  )
	{
		aColor = aLbColor.GetSelectEntryColor();
		rAttrs.Put( SvxColorItem( aColor, SID_ATTR_3D_AMBIENTCOLOR ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_AMBIENTCOLOR );
*/

	// Anzahl Segmente (horizontal)
	if( !aNumFldHorzSegs.IsEmptyFieldValue() )
	{
		nValue = aNumFldHorzSegs.GetValue();
		rAttrs.Put( SfxUInt32Item( SID_ATTR_3D_HORZ_SEGS, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_HORZ_SEGS );

	// Anzahl Segmente (vertikal)
	if( !aNumFldVertSegs.IsEmptyFieldValue() )
	{
		nValue = aNumFldVertSegs.GetValue();
		rAttrs.Put( SfxUInt32Item( SID_ATTR_3D_VERT_SEGS, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_VERT_SEGS );

	// Tiefe
	if( !aMtrFldDepth.IsEmptyFieldValue() )
	{
		nValue = GetCoreValue( aMtrFldDepth, ePoolUnit );
		rAttrs.Put( SfxUInt32Item( SID_ATTR_3D_DEPTH, nValue ) );
	}
	else
		rAttrs.InvalidateItem( SID_ATTR_3D_DEPTH );

	// Doppelseitig
	/*
	TriState eState = aTsbDoubleSided.GetState();
	if( eState != aTsbDoubleSided.GetSavedValue() )
	{
		BOOL bValue = STATE_CHECK == eState;
		rAttrs.Put( SfxBoolItem( SID_ATTR_3D_DOUBLE_SIDED, bValue ) );
		bModified = TRUE;
	}
	*/
#endif
}

// -----------------------------------------------------------------------
void __EXPORT Sd3DWin::Resize()
{
/*
	if ( !IsFloatingMode() ||
		 !GetFloatingWindow()->IsZoomedIn() )
	{
		Size aWinSize( GetOutputSizePixel() ); // vorher rSize im Resizing()

		if( aWinSize.Height() >= GetMinOutputSizePixel().Height() &&
			aWinSize.Width() >= GetMinOutputSizePixel().Width() )
		{
			Size aDiffSize;
			aDiffSize.Width() = aWinSize.Width() - aSize.Width();
			aDiffSize.Height() = aWinSize.Height() - aSize.Height();

			Point aXPt;
			Point aYPt;
			aXPt.X() = aDiffSize.Width();
			aYPt.Y() = aDiffSize.Height();

			// Verschieben der anderen Controls
			Size aObjSize;

			aBtnUpdate.Hide();
			aBtnAssign.Hide();
			aLbEffect.Hide();

			aBtnUpdate.SetPosPixel( aBtnUpdate.GetPosPixel() + aXPt );
			aBtnAssign.SetPosPixel( aBtnAssign.GetPosPixel() + aXPt );

			// LB Effect
			aObjSize = aLbEffect.GetOutputSizePixel();
			aObjSize.Width() += aDiffSize.Width();
			aLbEffect.SetOutputSizePixel( aObjSize );

			// Y-Position der Extras Controls
			aLbTranspColor.SetPosPixel( Point(
				aLbTranspColor.GetPosPixel().X(), aLbTranspColorPosY + aYPt.Y() ) );

			aBtnUpdate.Show();
			aBtnAssign.Show();

			aSize = aWinSize;
		}
	}
*/
	SfxDockingWindow::Resize();
}

// -----------------------------------------------------------------------
IMPL_LINK( Sd3DWin, ClickUpdateHdl, void *, EMPTYARG )
{
	bUpdate = !aBtnUpdate.IsChecked();
	aBtnUpdate.Check( bUpdate );

	if( bUpdate )
	{
		SfxBoolItem aItem( SID_3D_STATE, TRUE );
		SFX_DISPATCHER().Execute( SID_3D_STATE, SFX_CALLMODE_ASYNCHRON |
									SFX_CALLMODE_RECORD, &aItem, 0L );
	}
	else
	{
		// Controls koennen u.U. disabled sein
		/*
		aFtSegments.Enable();
		aNumFldHorzSegs.Enable();
		aNumFldVertSegs.Enable();
		*/
	}

	return( 0L );
}

// -----------------------------------------------------------------------
IMPL_LINK( Sd3DWin, ClickAssignHdl, void *, EMPTYARG )
{
	SfxBoolItem aItem( SID_3D_ASSIGN, TRUE );
	SFX_DISPATCHER().Execute( SID_3D_ASSIGN, SFX_CALLMODE_ASYNCHRON |
									SFX_CALLMODE_RECORD, &aItem, 0L );

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( Sd3DWin, ClickViewTypeHdl, void *, pBtn )
{
	if( pBtn )
	{
		aBtnFavorites.Check( &aBtnFavorites	== pBtn );
		aBtnGeo.Check( &aBtnGeo	== pBtn );
		aBtnRepresentation.Check( &aBtnRepresentation == pBtn );
		aBtnLight.Check( &aBtnLight	== pBtn );
		aBtnTexture.Check( &aBtnTexture	== pBtn );
		aBtnMaterial.Check( &aBtnMaterial == pBtn );

		if( aBtnFavorites.IsChecked() )
			eViewType = VIEWTYPE_FAVORITES;
		if( aBtnGeo.IsChecked() )
			eViewType = VIEWTYPE_GEO;
		if( aBtnRepresentation.IsChecked() )
			eViewType = VIEWTYPE_REPRESENTATION;
		if( aBtnLight.IsChecked() )
			eViewType = VIEWTYPE_LIGHT;
		if( aBtnTexture.IsChecked() )
			eViewType = VIEWTYPE_TEXTURE;
		if( aBtnMaterial.IsChecked() )
			eViewType = VIEWTYPE_MATERIAL;

		// Favoriten
		if( eViewType == VIEWTYPE_FAVORITES )
		{
			aCtlFavorites.Show();
			aGrpFavorites.Show();
		}
		else
		{
			aCtlFavorites.Hide();
			aGrpFavorites.Hide();
		}

		// Geometrie
		if( eViewType == VIEWTYPE_GEO )
		{
			aFtHorizontal.Show();
			aNumHorizontal.Show();
			aFtVertical.Show();
			aNumVertical.Show();
			aGrpSegments.Show();
			aFtPercentDiagonal.Show();
			aMtrPercentDiagonal.Show();
			aFtBackscale.Show();
			aMtrBackscale.Show();
			aFtEndAngle.Show();
			aMtrEndAngle.Show();
			aGrpGeometrie.Show();
		}
		else
		{
			aFtHorizontal.Hide();
			aNumHorizontal.Hide();
			aFtVertical.Hide();
			aNumVertical.Hide();
			aGrpSegments.Hide();
			aFtPercentDiagonal.Hide();
			aMtrPercentDiagonal.Hide();
			aFtBackscale.Hide();
			aMtrBackscale.Hide();
			aFtEndAngle.Hide();
			aMtrEndAngle.Hide();
			aGrpGeometrie.Hide();
		}

		// Darstellung
		if( eViewType == VIEWTYPE_REPRESENTATION )
		{
		}
		else
		{
		}

		// Beleuchtung
		if( eViewType == VIEWTYPE_LIGHT )
		{
		}
		else
		{
		}

		// Texturen
		if( eViewType == VIEWTYPE_TEXTURE )
		{
		}
		else
		{
		}

		// Material
		if( eViewType == VIEWTYPE_MATERIAL )
		{
			aCtlMaterial.Show();
			aGrpMaterial.Show();
		}
		else
		{
			aCtlMaterial.Hide();
			aGrpMaterial.Hide();
		}

	}
	else
	{
		aBtnFavorites.Check( eViewType == VIEWTYPE_FAVORITES );
		aBtnGeo.Check( eViewType == VIEWTYPE_GEO );
		aBtnRepresentation.Check( eViewType == VIEWTYPE_REPRESENTATION );
		aBtnLight.Check( eViewType == VIEWTYPE_LIGHT );
		aBtnTexture.Check( eViewType == VIEWTYPE_TEXTURE );
		aBtnMaterial.Check( eViewType == VIEWTYPE_MATERIAL );
	}
	return( 0L );
}

// -----------------------------------------------------------------------
IMPL_LINK( Sd3DWin, ClickHdl, PushButton *, pBtn )
{
	if( pBtn )
	{
		USHORT nSId = 0;

		if( pBtn == &aBtnPerspective )
		{
			pBtn->Check( !pBtn->IsChecked() );
		}
		else if( pBtn == &aBtnConvertTo3D )
		{
			nSId = SID_CONVERT_TO_3D;
		}
		else if( pBtn == &aBtnLatheObject )
		{
			nSId = SID_CONVERT_TO_3D_LATHE_FAST;
		}

		if( nSId > 0 )
		{
			SfxBoolItem aItem( nSId, TRUE );
			SFX_DISPATCHER().Execute( nSId, SFX_CALLMODE_ASYNCHRON |
										SFX_CALLMODE_RECORD, &aItem, 0L );
		}
	}

	return( 0L );
}

// -----------------------------------------------------------------------
void Sd3DWin::InitColorLB( const SdrModel* pDoc )
{
	//aLbLightColor.Fill( pDoc->GetColorTable() );
	//aLbAmbientColor.CopyEntries( aLbTranspColor );
}

/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Effekte
|*
\************************************************************************/
__EXPORT Sd3DChildWindow::Sd3DChildWindow( Window* pParent,
														 USHORT nId,
														 SfxBindings* pBindings,
														 SfxChildWinInfo* pInfo ) :
	SfxChildWindow( pParent, nId )
{
	Sd3DWin* pWin = new Sd3DWin( pBindings, this, pParent,
										SdResId( FLT_WIN_3D ) );
	pWindow = pWin;

	eChildAlignment = SFX_ALIGN_NOALIGNMENT;

	pWin->Initialize( pInfo );
}

/*************************************************************************
|*
|* ControllerItem fuer 3DStatus
|*
\************************************************************************/
Sd3DCtrlItem::Sd3DCtrlItem( USHORT nId,
								Sd3DWin* pWin,
								SfxBindings* pBindings) :
	SfxControllerItem( nId, *pBindings ),
	p3DWin( pWin )
{
}

// -----------------------------------------------------------------------
void __EXPORT Sd3DCtrlItem::StateChanged( USHORT nSId,
						SfxItemState eState, const SfxPoolItem* pItem )
{
	/*
	if( eState >= SFX_ITEM_AVAILABLE && nSId == SID_3D_STATE )
	{
		const SfxUInt32Item* pStateItem = PTR_CAST( SfxUInt32Item, pItem );
		DBG_ASSERT( pStateItem, "SfxUInt32Item erwartet");
		UINT32 nState = pStateItem->GetValue();
		p3DWin->bCount = (BOOL) (nState & 3D_COUNT);
	}
	*/
}

