/*************************************************************************
 *
 *  $RCSfile: enumdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <svx/dialogs.hrc>

#define ITEMID_FONT 		SID_ATTR_CHAR_FONT
#define ITEMID_FONTHEIGHT	SID_ATTR_CHAR_FONTHEIGHT
#define ITEMID_COLOR		SID_ATTR_CHAR_COLOR
#define ITEMID_POSTURE		SID_ATTR_CHAR_POSTURE
#define ITEMID_WEIGHT		SID_ATTR_CHAR_WEIGHT
#define ITEMID_SHADOWED 	SID_ATTR_CHAR_SHADOWED
#define ITEMID_CONTOUR		SID_ATTR_CHAR_CONTOUR
#define ITEMID_CROSSEDOUT	SID_ATTR_CHAR_STRIKEOUT
#define ITEMID_UNDERLINE	SID_ATTR_CHAR_UNDERLINE

#include <svx/fhgtitem.hxx>
#include <svx/wghtitem.hxx>
#include <svx/udlnitem.hxx>
#include <svx/crsditem.hxx>
#include <svx/postitem.hxx>
#include <svx/cntritem.hxx>
#include <svx/shdditem.hxx>
#include <svx/fontitem.hxx>
#include <svx/charmap.hxx>
#include <svx/editdata.hxx>
#ifndef _SVX_BULITEM_HXX //autogen
#include <svx/bulitem.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif

#include "sdattr.hxx"
#include "enumdlg.hrc"
#include "sdresid.hxx"
#include "enumdlg.hxx"

#define DLGWIN			this->GetParent()->GetParent()

static USHORT pRanges[] =
{
	SID_ATTR_PARA_BULLET,
	0
};


/*************************************************************************
|*
|*	Dialog: Aufzaehlung, Nummerierung und Bullet
|*
\************************************************************************/

SdEnumTabPage::SdEnumTabPage( Window* pParent, const SfxItemSet& rInAttrs  ) :
		SfxTabPage          ( pParent, SdResId( TP_ENUM_BULLET ), rInAttrs ),
		aLbStyle            ( this, SdResId( LB_STYLE ) ),
		aGrpStyle           ( this, SdResId( GRP_STYLE ) ),
		aFtEnum             ( this, SdResId( FT_ENUM ) ),
		aNumFldEnum         ( this, SdResId( NUM_FLD_ENUM ) ),
		aFtSample           ( this, SdResId( FT_SAMPLE ) ),
		aFiPreviewEnum      ( this, SdResId( FT_PREVIEW_ENUM ) ),
		aGrpEnum            ( this, SdResId( GRP_ENUM ) ),
		aBtnBullet          ( this, SdResId( BTN_GET_BULLET ) ),
		aTsbUseBullet       ( this, SdResId( TSB_USE_BULLET ) ),
		aFtBulletSize       ( this, SdResId( FT_BULLET_SIZE ) ),
		aMtrFldSize         ( this, SdResId( MTR_FLD_SIZE ) ),
		aFtBulletColor      ( this, SdResId( FT_BULLET_COLOR ) ),
		aLbBulletColor      ( this, SdResId( LB_BULLET_COLOR ) ),
		aCtlPreviewBullet   ( this, SdResId( CTL_BULLET_PREVIEW ) ),
		aGrpBullet          ( this, SdResId( GRP_BULLET ) ),
		pColorTab			( NULL ),
		rOutAttrs			( rInAttrs )
{
	FreeResource();

	aLbStyle.SetSelectHdl( LINK( this, SdEnumTabPage, ChangeStyleHdl ) );
	aNumFldEnum.SetModifyHdl( LINK( this, SdEnumTabPage, ModifyBeginHdl ) );
	aBtnBullet.SetClickHdl( LINK( this, SdEnumTabPage, ClickBulletHdl ) );
	aLbBulletColor.SetSelectHdl( LINK( this, SdEnumTabPage, ChangeColorHdl ) );
	aMtrFldSize.SetModifyHdl( LINK( this, SdEnumTabPage, ModifySizeHdl ) );

	aChar = ' ';
}

// -----------------------------------------------------------------------

__EXPORT SdEnumTabPage::~SdEnumTabPage()
{
}

// -----------------------------------------------------------------------

void SdEnumTabPage::Construct()
{
	if( pColorTab )
	{
//		  aLbBulletColor.SetSizes( 128 );
		aLbBulletColor.Fill( pColorTab );

		ChangeStyleHdl( this );
	}
}

// -----------------------------------------------------------------------

BOOL __EXPORT SdEnumTabPage::FillItemSet( SfxItemSet& rAttrs )
{
	BOOL bModified = FALSE;
	USHORT nValidMask = 0;

	SvxBulletItem aItem(GetWhich(SID_ATTR_PARA_BULLET));
	Font aMyFont(aFont);
	aMyFont.SetSize(aFontSize); // auf urspruengliche Groesse setzen
	aMyFont.SetTransparent(TRUE);


	if( aLbStyle.GetSavedValue() != aLbStyle.GetSelectEntryPos())
	{
		EnumStyle eStyle = (EnumStyle)aLbStyle.GetSelectEntryPos();
		USHORT	  nStyle;
		switch (eStyle)
		{
			case ES_ABC_BIG   : nStyle = BS_ABC_BIG;	 break;
			case ES_ABC_SMALL : nStyle = BS_ABC_SMALL;	 break;
			case ES_III_BIG   : nStyle = BS_ROMAN_BIG;	 break;
			case ES_III_SMALL : nStyle = BS_ROMAN_SMALL; break;
			case ES_123 	  : nStyle = BS_123;		 break;
			case ES_NONE	  : nStyle = BS_NONE;		 break;
			case ES_BULLET	  : nStyle = BS_BULLET; 	 break;

			default 		  : nStyle = BS_NONE;		 break;
		}
		aItem.SetStyle(nStyle);
		nValidMask |= VALID_STYLE;

		// wenn Aufzaehlung statt Bullet gewaehlt wurde, wird der Bullet-Font
		// dem Vorlagen-Font angeglichen
		if (eStyle != ES_BULLET && eStyle != ES_NONE)
		{
			const SvxFontItem& rFItem =
				(SvxFontItem&)rOutAttrs.Get(GetWhich(ITEMID_FONT));
			aMyFont.SetFamily(rFItem.GetFamily());
			aMyFont.SetName(rFItem.GetFamilyName());
			aMyFont.SetCharSet(rFItem.GetCharSet());
			aMyFont.SetPitch(rFItem.GetPitch());

			const SvxFontHeightItem& rFHItem =
				(SvxFontHeightItem&)rOutAttrs.Get(GetWhich(ITEMID_FONTHEIGHT));
			aMyFont.SetSize(Size(0, rFHItem.GetHeight()));

			const SvxWeightItem& rWItem =
				(SvxWeightItem&)rOutAttrs.Get(GetWhich(ITEMID_WEIGHT));
			aMyFont.SetWeight(rWItem.GetWeight());

			const SvxUnderlineItem& rUItem =
				(SvxUnderlineItem&)rOutAttrs.Get(GetWhich(ITEMID_UNDERLINE));
			aMyFont.SetUnderline(rUItem.GetUnderline());

			const SvxCrossedOutItem& rCOItem =
				(SvxCrossedOutItem&)rOutAttrs.Get(GetWhich(ITEMID_CROSSEDOUT));
			aMyFont.SetStrikeout(rCOItem.GetStrikeout());

			const SvxPostureItem& rPItem =
				(SvxPostureItem&)rOutAttrs.Get(GetWhich(ITEMID_POSTURE));
			aMyFont.SetItalic(rPItem.GetPosture());

			const SvxContourItem& rCItem =
				(SvxContourItem&)rOutAttrs.Get(GetWhich(ITEMID_CONTOUR));
			aMyFont.SetOutline(rCItem.GetValue());

			const SvxShadowedItem& rSItem =
				(SvxShadowedItem&)rOutAttrs.Get(GetWhich(ITEMID_SHADOWED));
			aMyFont.SetShadow(rSItem.GetValue());

			nValidMask |= VALID_FONTNAME;

		}
	}



	if (aNumFldEnum.GetSavedValue() != aNumFldEnum.GetText())
	{
		aItem.SetStart((USHORT)aNumFldEnum.GetValue());
		nValidMask |= VALID_START;
	}

	if (aMtrFldSize.GetSavedValue() != aMtrFldSize.GetText())
	{
		aItem.SetScale((USHORT)aMtrFldSize.GetValue());
		nValidMask |= VALID_SCALE;
	}

	if (aLbBulletColor.GetSavedValue() != aLbBulletColor.GetSelectEntryPos())
	{
		nValidMask |= VALID_FONTCOLOR;
	}

	if (aCharSave != aChar)
	{
		aItem.SetSymbol(aChar);
		nValidMask |= VALID_SYMBOL;
	}

	if (aFontSave.GetName() != aFont.GetName())
	{
		nValidMask |= VALID_FONTNAME;
	}


	aItem.SetFont(aMyFont);
	aItem.GetValidMask() = nValidMask;

	if (nValidMask != 0)
	{
		rAttrs.Put(aItem);
		bModified = TRUE;
	}
	else
	{
		// Um einen DONTCARE-Zustand anzuzeigen wird normalerweise invalidiert.
		// Outliner/EditEngine ist mal wieder die Ausnahme und braucht
		// dafuer ein ClearItem()!
		// rAttrs.InvalidateItem(GetWhich(SID_ATTR_PARA_BULLET));
		rAttrs.ClearItem(GetWhich(SID_ATTR_PARA_BULLET));
	}

	// Bullet verwenden
	if( aTsbUseBullet.IsVisible() )
	{
		TriState eState = aTsbUseBullet.GetState();
		if( aTsbUseBullet.GetSavedValue() != eState )
		{
			if( eState != STATE_DONTKNOW )
			{
				rAttrs.Put( SfxUInt16Item( EE_PARA_BULLETSTATE,
									eState == STATE_CHECK ? 1 : 0 ) );

				bModified = TRUE;
			}
		}
		else
		{
			// Um einen DONTCARE-Zustand anzuzeigen wird normalerweise invalidiert.
			// Outliner/EditEngine ist mal wieder die Ausnahme und braucht
			// dafuer ein ClearItem()!
			// rAttrs.InvalidateItem(EE_PARA_BULLETSTATE));
			rAttrs.ClearItem(EE_PARA_BULLETSTATE);
		}
	}

	return( bModified );
}

// -----------------------------------------------------------------------
void __EXPORT SdEnumTabPage::Reset( const SfxItemSet& rOutAttrs )
{
	USHORT nWhich = GetWhich( SID_ATTR_PARA_BULLET );
	if ( rOutAttrs.GetItemState( nWhich ) >= SFX_ITEM_AVAILABLE )
	{
		const SvxBulletItem& rItem = (SvxBulletItem&) rOutAttrs.Get( nWhich );
		USHORT nValidMask = rItem.GetValidMask();

		if (nValidMask & VALID_STYLE)
		{

			USHORT    nStyle = rItem.GetStyle();
			EnumStyle eStyle;
			switch (nStyle)
			{
				case BS_ABC_BIG    : eStyle = ES_ABC_BIG;   break;
				case BS_ABC_SMALL  : eStyle = ES_ABC_SMALL; break;
				case BS_ROMAN_BIG  : eStyle = ES_III_BIG;   break;
				case BS_ROMAN_SMALL: eStyle = ES_III_SMALL; break;
				case BS_123        : eStyle = ES_123;       break;
				case BS_NONE       : eStyle = ES_NONE;      break;
				case BS_BULLET     : eStyle = ES_BULLET;    break;

				default            : eStyle = ES_NONE;      break;
			}
			aLbStyle.SelectEntryPos(eStyle);
		}
		else
		{
			aLbStyle.SetNoSelection();
		}

		if (nValidMask & VALID_FONTNAME)
		{
			aFont     = rItem.GetFont();
		}

		if (nValidMask & VALID_SCALE)
		{
			aFontSize = aFont.GetSize();

			Size aTempSize(aFont.GetSize());
			aTempSize.Width()  *= rItem.GetScale();    // Skalierungsfaktor in %
			aTempSize.Width()  /= 100;
			aTempSize.Height() *= rItem.GetScale();
			aTempSize.Height() /= 100;
			aFont.SetSize(aTempSize);
			aMtrFldSize.SetValue((long)rItem.GetScale());
		}
		else
		{
			aMtrFldSize.SetEmptyFieldValue();
		}

		if (nValidMask & VALID_FONTCOLOR)
		{
			aLbBulletColor.SelectEntry(rItem.GetFont().GetColor());
		}
		else
		{
			aLbBulletColor.SetNoSelection();
		}

		if (nValidMask & VALID_START)
		{
			aNumFldEnum.SetValue((long)rItem.GetStart());
		}
		else
		{
			aNumFldEnum.SetEmptyFieldValue();
		}

		if (nValidMask & VALID_SYMBOL)
		{
			aChar = rItem.GetSymbol();
		}
	}

	if( rOutAttrs.GetItemState( EE_PARA_BULLETSTATE ) >= SFX_ITEM_AVAILABLE )
	{
		aTsbUseBullet.EnableTriState( FALSE );
		UINT16 nVal = ( (SfxUInt16Item&) rOutAttrs.Get( EE_PARA_BULLETSTATE ) ).GetValue();
		aTsbUseBullet.SetState( nVal == 0 ? STATE_NOCHECK : STATE_CHECK );
	}
	else
		aTsbUseBullet.SetState( STATE_DONTKNOW );

	aLbStyle.SaveValue();
	aNumFldEnum.SaveValue();
	aTsbUseBullet.SaveValue();
	aMtrFldSize.SaveValue();
	aLbBulletColor.SaveValue();

	aCharSave = aChar;
	aFontSave = aFont;

	ChangeStyleHdl( this );
}

// -----------------------------------------------------------------------

SfxTabPage* __EXPORT SdEnumTabPage::Create( Window* pWindow,
				const SfxItemSet& rOutAttrs )
{
	return( new SdEnumTabPage( pWindow, rOutAttrs ) );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdEnumTabPage, ChangeStyleHdl, void *, EMPTYARG )
{
	EnumStyle eES = ES_NONE;
	USHORT nPos = aLbStyle.GetSelectEntryPos();
	if( nPos != LISTBOX_ENTRY_NOTFOUND )
		eES = (EnumStyle) nPos;

	switch( eES )
	{
		case ES_ABC_BIG:
		case ES_ABC_SMALL:
		case ES_III_BIG:
		case ES_III_SMALL:
		case ES_123:
		{
			aFtEnum.Enable();
			aNumFldEnum.Enable();
			aFtSample.Enable();
			aFiPreviewEnum.Enable();
			aGrpEnum.Enable();
			aBtnBullet.Disable();
			aFtBulletSize.Disable();
			aMtrFldSize.Disable();
			aFtBulletColor.Disable();
			aLbBulletColor.Disable();
			aCtlPreviewBullet.Disable();
			aGrpBullet.Disable();

			switch( eES )
			{
				case ES_ABC_BIG:
					aFiPreviewEnum.SetText( UniString( RTL_CONSTASCII_USTRINGPARAM( "A.B.C" ) ) );
				break;

				case ES_ABC_SMALL:
					aFiPreviewEnum.SetText( UniString( RTL_CONSTASCII_USTRINGPARAM( "a.b.c" ) ) );
				break;

				case ES_III_BIG:
					aFiPreviewEnum.SetText( UniString( RTL_CONSTASCII_USTRINGPARAM( "I.II.III" ) ) );
				break;

				case ES_III_SMALL:
					aFiPreviewEnum.SetText( UniString( RTL_CONSTASCII_USTRINGPARAM( "i.ii.iii" ) ) );
				break;

				case ES_123:
					aFiPreviewEnum.SetText( UniString( RTL_CONSTASCII_USTRINGPARAM( "1.2.3" ) ) );
				break;

			}

			aCtlPreviewBullet.Clear();
			aCtlPreviewBullet.Invalidate();
		}
		break;

		case ES_NONE:
		{
			aFtEnum.Disable();
			aNumFldEnum.Disable();
			aFtSample.Disable();
			aFiPreviewEnum.Disable();
			aGrpEnum.Disable();
			aBtnBullet.Disable();
			aFtBulletSize.Disable();
			aMtrFldSize.Disable();
			aFtBulletColor.Disable();
			aLbBulletColor.Disable();
			aCtlPreviewBullet.Disable();
			aGrpBullet.Disable();

			aFiPreviewEnum.SetText( String() );

			aCtlPreviewBullet.Clear();
			aCtlPreviewBullet.Invalidate();
		}
		break;

		case ES_BULLET:
		{
			aFtEnum.Disable();
			aNumFldEnum.Disable();
			aFtSample.Disable();
			aFiPreviewEnum.Disable();
			aGrpEnum.Disable();
			aBtnBullet.Enable();
			aFtBulletSize.Enable();
			aMtrFldSize.Enable();
			aFtBulletColor.Enable();
			aLbBulletColor.Enable();
			aCtlPreviewBullet.Enable();
			aGrpBullet.Enable();

			aFiPreviewEnum.SetText( String() );

			aCtlPreviewBullet.SetCharFont( aFont );
			aCtlPreviewBullet.SetChar( aChar );
			aCtlPreviewBullet.Invalidate();
		}
		break;
	}
	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SdEnumTabPage, ModifyBeginHdl, void *, EMPTYARG )
{
	return( 0L );
}
IMPL_LINK_INLINE_END( SdEnumTabPage, ModifyBeginHdl, void *, EMPTYARG )

// -----------------------------------------------------------------------

IMPL_LINK( SdEnumTabPage, ClickBulletHdl, void *, EMPTYARG )
{
	SvxCharacterMap* pDlg = new SvxCharacterMap( this, TRUE );

	Color aTmpColor( aFont.GetColor() );
	Color aTmpFillColor( aFont.GetFillColor() );
	BOOL  bTransparent = aFont.IsTransparent();

	Font aTmpFont( aFont );
	aTmpFont.SetSize( aFontSize );
	aTmpFont.SetColor( COL_BLACK );

	pDlg->SetCharFont( aTmpFont );
	pDlg->SetChar( aChar );

	USHORT nResult = pDlg->Execute();

	if( nResult == RET_OK )
	{
		aChar  = pDlg->GetChar();
		aFont  = pDlg->GetCharFont();
		aFont.SetColor( aTmpColor );
		aFont.SetFillColor( aTmpFillColor );
		aFont.SetTransparent( bTransparent );
	}
	delete( pDlg );

	// aFontSize = aFont.GetSize();

	ModifySizeHdl( this );
/*
	aCtlPreviewBullet.SetChar( aChar );
	aCtlPreviewBullet.SetCharFont( aFont );
	aCtlPreviewBullet.Invalidate();
*/
	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdEnumTabPage, ChangeColorHdl, void *, EMPTYARG )
{
	aFont.SetColor( aLbBulletColor.GetSelectEntryColor() );
	aCtlPreviewBullet.SetFont( aFont );

	aCtlPreviewBullet.SetCharFont( aFont );
	aCtlPreviewBullet.Invalidate();

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdEnumTabPage, ModifySizeHdl, void *, EMPTYARG )
{
	aFont.SetSize( Size( aFontSize.Width() * aMtrFldSize.GetValue() / 100,
							aFontSize.Height() * aMtrFldSize.GetValue() / 100 ) );
	aCtlPreviewBullet.SetFont( aFont );

	aCtlPreviewBullet.SetCharFont( aFont );
	// Um die Position neu zu berechnen
	aCtlPreviewBullet.SetChar( aChar );
	aCtlPreviewBullet.Invalidate();

	return( 0L );
}

/*************************************************************************
|*
|*	Control zur Anzeige des Bullets
|*
\************************************************************************/

BulletPreview::BulletPreview( Window* pParent, const SdResId& rSdResId ) :
								Control( pParent, rSdResId )
{
	SetMapMode( MAP_100TH_MM );
	Size aSize( GetOutputSize() );

	aPtMM = Point( aSize.Width() / 2, aSize.Height() / 2 );
}

// -----------------------------------------------------------------------

BulletPreview::~BulletPreview()
{
}

// -----------------------------------------------------------------------

void __EXPORT BulletPreview::Paint( const Rectangle& rRect )
{
	String aStr; aStr += aChar;
	DrawText( aPtTL, aStr );
}

// -----------------------------------------------------------------------

void BulletPreview::SetCharFont( const Font& rInFont )
{
	SetFont( rInFont );
/*
	long lHeight = GetFont().GetSize().Height();
	long lWidth  = GetFont().GetSize().Width();
	if( lWidth == 0L )
		lWidth = lHeight;

	aPtTL.X() = aPtMM.X() - lWidth / 2;
	aPtTL.Y() = aPtMM.Y() - lHeight / 2;
*/
}

// -----------------------------------------------------------------------

void BulletPreview::SetChar( sal_Unicode c )
{
	aChar = c;

	String aStr; aStr += c;
	Size aTmpSize( GetTextWidth( aStr ), GetTextHeight() );

	aPtTL.X() = aPtMM.X() - aTmpSize.Width() / 2;
	aPtTL.Y() = aPtMM.Y() - aTmpSize.Height() / 2;
}

/*************************************************************************
|*
|* Array mit SlotIds zurueckgeben
|*
\************************************************************************/

USHORT* SdEnumTabPage::GetRanges()
{
	return pRanges;
}


/*************************************************************************
|*
|* Moeglichkeit von Aussen Controls zu hiden (z.Z. nur TsbUseBullet)
|*
\************************************************************************/

void SdEnumTabPage::HideControl( UINT16 nCtrl )
{
	aTsbUseBullet.Hide();
}




