/*************************************************************************
 *
 *  $RCSfile: inspage.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#include "strings.hrc"
#include "sdattr.hxx"
#include "sdresid.hxx"
#include "ins_page.hxx"
#include "ins_page.hrc"

/*************************************************************************
|*
|*    SdInsertLayerDlg::SdInsertLayerDlg()
|*
|*    Beschreibung      Dialog-Klasse zum Einfuegen einer Ebene
|*    Ersterstellung    13.10.94
|*    Letzte Aenderung  13.10.94
|*
*************************************************************************/

SdInsertLayerDlg::SdInsertLayerDlg( Window* pWindow,
								  const SfxItemSet& rInAttrs,
								  BOOL bDeletable,
								  String aStr ) :
				ModalDialog             ( pWindow, SdResId( DLG_INSERT_LAYER ) ),
				aFtName                 ( this, SdResId( FT_NAME ) ),
				aEdtName                ( this, SdResId( EDT_NAME ) ),
				aCbxVisible             ( this, SdResId( CBX_VISIBLE ) ),
				aCbxPrintable           ( this, SdResId( CBX_PRINTABLE ) ),
				aCbxLocked              ( this, SdResId( CBX_LOCKED ) ),
				//aRbtThisPage          ( this, SdResId( RBT_THISPAGE ) ),
				//aRbtAllPages          ( this, SdResId( RBT_ALLPAGES ) ),
				aGrpOptions             ( this, SdResId( GRP_OPTIONS ) ),
				aBtnOK                  ( this, SdResId( BTN_OK ) ),
				aBtnCancel              ( this, SdResId( BTN_CANCEL ) ),
				aBtnHelp                ( this, SdResId( BTN_HELP ) ),
				aBtnDelete              ( this, SdResId( BTN_DELETE ) ),
				rOutAttrs               ( rInAttrs )
{
	FreeResource();

	aBtnDelete.SetClickHdl( LINK ( this, SdInsertLayerDlg, DeleteButtonHdl ) );

	SetText( aStr );
	if( aStr == String(SdResId( STR_INSERTLAYER )) )
		aBtnDelete.Hide();

	aEdtName.SetText( ( ( const SdAttrLayerName& ) rOutAttrs.Get( ATTR_LAYER_NAME ) ).GetValue() );
	aCbxVisible.Check( ( ( const SdAttrLayerVisible& ) rOutAttrs.Get( ATTR_LAYER_VISIBLE ) ).GetValue() );
	aCbxPrintable.Check( ( ( const SdAttrLayerPrintable& ) rOutAttrs.Get( ATTR_LAYER_PRINTABLE ) ).GetValue() );
	aCbxLocked.Check( ( ( const SdAttrLayerLocked& ) rOutAttrs.Get( ATTR_LAYER_LOCKED ) ).GetValue() );

	if( !bDeletable )
	{
		aFtName.Disable();
		aEdtName.Disable();
		aBtnDelete.Disable();
	}
	else
		aBtnDelete.Disable(); // Temporr !!! (wird noch gendert)
}

#if defined HP9000 || defined SINIX
SdInsertLayerDlg::SdInsertLayerDlg( Window* pWindow,
								  const SfxItemSet& rInAttrs,
								  BOOL bDeletable):
				ModalDialog             ( pWindow, SdResId( DLG_INSERT_LAYER ) ),
				aFtName                 ( this, SdResId( FT_NAME ) ),
				aEdtName                ( this, SdResId( EDT_NAME ) ),
				aCbxVisible             ( this, SdResId( CBX_VISIBLE ) ),
				aCbxPrintable           ( this, SdResId( CBX_PRINTABLE ) ),
				aCbxLocked              ( this, SdResId( CBX_LOCKED ) ),
				//aRbtThisPage          ( this, SdResId( RBT_THISPAGE ) ),
				//aRbtAllPages          ( this, SdResId( RBT_ALLPAGES ) ),
				aGrpOptions             ( this, SdResId( GRP_OPTIONS ) ),
				aBtnOK                  ( this, SdResId( BTN_OK ) ),
				aBtnCancel              ( this, SdResId( BTN_CANCEL ) ),
				aBtnHelp                ( this, SdResId( BTN_HELP ) ),
				aBtnDelete              ( this, SdResId( BTN_DELETE ) ),
				rOutAttrs               ( rInAttrs )
{
	FreeResource();

	aBtnDelete.SetClickHdl( LINK ( this, SdInsertLayerDlg, DeleteButtonHdl ) );
	String aStr( SdResId( STR_INSERTLAYER ) );
	SetText( aStr );
	aBtnDelete.Hide();

	aEdtName.SetText( ( ( const SdAttrLayerName& ) rOutAttrs.Get( ATTR_LAYER_NAME ) ).GetValue() );
	aCbxVisible.Check( ( ( const SdAttrLayerVisible& ) rOutAttrs.Get( ATTR_LAYER_VISIBLE ) ).GetValue() );
	aCbxPrintable.Check( ( ( const SdAttrLayerPrintable& ) rOutAttrs.Get( ATTR_LAYER_PRINTABLE ) ).GetValue() );
	aCbxLocked.Check( ( ( const SdAttrLayerLocked& ) rOutAttrs.Get( ATTR_LAYER_LOCKED ) ).GetValue() );

	if( !bDeletable )
	{
		aFtName.Disable();
		aEdtName.Disable();
		aBtnDelete.Disable();
	}
	else
		aBtnDelete.Disable(); // Temporr !!! (wird noch gendert)
}

#endif

/*************************************************************************
|*
|*    SdInsertLayerDlg::GetAttr()
|*
|*    Beschreibung      Fuellt uebergebenen Item-Set mit Dialogbox-
|*                                              Attributen
|*    Letzte Aenderung  13.10.94
|*
*************************************************************************/

void SdInsertLayerDlg::GetAttr( SfxItemSet& rOutAttrs )
{
	rOutAttrs.Put( SdAttrLayerName( aEdtName.GetText() ) );
	rOutAttrs.Put( SdAttrLayerVisible( aCbxVisible.IsChecked() ) );
	rOutAttrs.Put( SdAttrLayerPrintable( aCbxPrintable.IsChecked() ) );
	rOutAttrs.Put( SdAttrLayerLocked( aCbxLocked.IsChecked() ) );

	//rOutAttrs.Put( SdAttrLayerThisPage( aRbtThisPage.IsChecked() ) );
}


/*************************************************************************
|*      Handler: beendet Dialog und liefert
\************************************************************************/

IMPL_LINK_INLINE_START( SdInsertLayerDlg, DeleteButtonHdl, Button *, EMPTYARG )
{
	EndDialog( RET_DELETE );
	return 0;
}
IMPL_LINK_INLINE_END( SdInsertLayerDlg, DeleteButtonHdl, Button *, EMPTYARG )

/*************************************************************************

	  Source Code Control System - History

	  $Log: inspage.cxx,v $
	  Revision 1.1.1.1  2000/09/18 16:48:33  hr
	  initial import
	
	  Revision 1.25  2000/09/17 15:23:35  willem.vandorp
	  OpenOffice header added.
	
	  Revision 1.24  2000/09/06 13:47:52  willem.vandorp
	  Header and footer replaced.
	
	  Revision 1.23  1998/01/14 16:40:00  DL
	  includes
	

	  Rev 1.22   14 Jan 1998 17:40:00   DL
   includes

	  Rev 1.21   29 Oct 1996 10:51:42   DL
   Neu: SdResId

	  Rev 1.20   10 Jul 1996 09:46:18   TRI
   sdattr.hxx included

	  Rev 1.19   30 Jan 1996 12:03:52   mk
   SINIX

	  Rev 1.18   05 Dec 1995 08:29:16   DL
   Neuer Link

	  Rev 1.17   07 Nov 1995 16:15:18   TRI
   Change->Set

	  Rev 1.16   17 May 1995 15:19:44   SOH
   2 Radiobuttons entfernt

	  Rev 1.15   26 Apr 1995 12:03:30   SOH
   Seitendialog auskommentiert

	  Rev 1.14   23 Mar 1995 14:40:44   TRI
   __EXPORT eingebaut

	  Rev 1.13   23 Mar 1995 11:55:44   TRI
   Segmentierung

	  Rev 1.12   04 Jan 1995 10:17:36   SOH
   Mac-Anpassung

	  Rev 1.11   28 Nov 1994 10:08:24   SOH
   Referenzen sind const

	  Rev 1.10   11 Nov 1994 09:45:42   ESO
   Anpassung fuer OS2

	  Rev 1.9   02 Nov 1994 10:13:00   SOH
   #include-Modifikation wegen Aufteilung der ???_IDs

	  Rev 1.8   25 Oct 1994 10:18:56   SOH
   Neu: #pragma hdrstop statt #include <sd.hxx>

	  Rev 1.7   14 Oct 1994 11:00:44   SOH
   erweitert um Lschen( Hide, disabled...)

	  Rev 1.6   13 Oct 1994 15:56:22   SOH
   Neu: Layer-Dialog

	  Rev 1.5   10 Oct 1994 13:21:36   SOH
   Ctor um String (Ueberschrift) erweitert

	  Rev 1.4   06 Oct 1994 14:44:50   SOH
   (Wieder) auf Stand mit Items gebracht

	  Rev 1.3   30 Sep 1994 17:02:12   ESO
   precompiled Header

	  Rev 1.2   30 Sep 1994 07:55:04   SOH
   Auf letzten Stand (ohne Items) geaendert

	  Rev 1.1   29 Sep 1994 17:03:58   SOH
   Namen geaendert

	  Rev 1.0   27 Sep 1994 15:35:22   SOH
   Initial revision.

*************************************************************************/

#pragma SEG_EOFMODULE

