/*************************************************************************
 *
 *  $RCSfile: optdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define ITEMID_SPELLCHECK	0

#include <svx/dialogs.hrc>
#include <svx/checklbx.hxx>
#include <svx/optgrid.hxx>

#include "tpoption.hxx"
#include "tpscale.hxx"
#include "prntopts.hxx"
#include "frmview.hxx"
#include "app.hxx"
#include "sdattr.hxx"
#include "optdlg.hrc"
#include "tpoption.hrc"
#include "tpscale.hrc"
#include "docshell.hxx"
#include "drawdoc.hxx"
#include "sdresid.hxx"
#include "optsitem.hxx"
#include "splcfg.hxx"
#include "optdlg.hxx"



//==================================================================

SdOptionsDlg::SdOptionsDlg( Window* pParent, const SfxItemSet& rInAttrs,
							DocumentType eType ) :
			SfxTabDialog( pParent,
						  SdResId( eType == DOCUMENT_TYPE_DRAW ?
								TAB_DLG_DRAW_OPTIONS : TAB_DLG_IMPRESS_OPTIONS ),
						  &rInAttrs ),
			eDocType	( eType )
{
	FreeResource();

	AddTabPage( TP_OPTIONS_CONTENTS,&SdTpOptionsContents::Create,	0, FALSE );
	AddTabPage( TP_OPTIONS_LAYOUT,	&SdTpOptionsLayout::Create,	0, FALSE );
	AddTabPage( TP_OPTIONS_SNAP,	&SdTpOptionsSnap::Create,	0, FALSE );

	if( eDocType == DOCUMENT_TYPE_DRAW )
	{
		AddTabPage( TP_SCALE, &SdTpScale::Create, 0, FALSE );
	}

	AddTabPage( RID_SVXPAGE_GRID,	&SvxGridTabPage::Create,	0, FALSE );
	AddTabPage( TP_PRINT,			&SdPrintOptions::Create,	0, FALSE );
	AddTabPage( TP_OPTIONS_MISC,	&SdTpOptionsMisc::Create,	0, FALSE );
}

//-------------------------------------------------------------------

__EXPORT SdOptionsDlg::~SdOptionsDlg()
{
};

// -----------------------------------------------------------------------

void __EXPORT SdOptionsDlg::PageCreated( USHORT nId, SfxTabPage &rPage )
{
	switch( nId )
	{
		case TP_OPTIONS_MISC:
		{
			if( eDocType == DOCUMENT_TYPE_DRAW )
			{
				( (SdTpOptionsMisc&) rPage ).aCbxStartWithTemplate.Hide();
				( (SdTpOptionsMisc&) rPage ).aGrpProgramStart.Hide();

				( (SdTpOptionsMisc&) rPage ).aCbxStartWithActualPage.Hide();
				( (SdTpOptionsMisc&) rPage ).aGrpStartWithActualPage.Hide();
			}
		}
		break;

		case TP_PRINT:
		{
			if( eDocType == DOCUMENT_TYPE_DRAW )
			{
				( (SdPrintOptions&) rPage ).aCbxNotes.Hide();
				( (SdPrintOptions&) rPage ).aCbxHandout.Hide();
				( (SdPrintOptions&) rPage ).aCbxOutline.Hide();

				( (SdPrintOptions&) rPage ).aCbxDraw.Check(); // Wohl nicht noetig !?
				( (SdPrintOptions&) rPage ).aCbxDraw.Disable();
				( (SdPrintOptions&) rPage ).aGrpPrint.Disable();
			}
		}
		break;

		default:
			break;
	}
}


