/*************************************************************************
 *
 *  $RCSfile: packgdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif

#include "sdattr.hxx"
#include "sdresid.hxx"

#include "strings.hrc"
#include "packgdlg.hxx"
#include "packgdlg.hrc"



/*************************************************************************
|* Ctor
\************************************************************************/
SdPackNGoDlg::SdPackNGoDlg ( Window* pWindow, const SfxItemSet* pInAttrs ) :
			  SfxModalDialog	( pWindow, SdResId( DLG_PACKNGO ) ),
			  aCbxUnlink		( this, SdResId(CBX_UNLINK) ),
			  aGrpDokuOption	( this, SdResId(GRP_DOKU) ),
			  aFtGrpDokuDescr	( this, SdResId(FT_DOKU_DESCR) ),
			  aFtStoreMedium	( this, SdResId(FT_STOREMEDIUM) ),
			  aLbStoreMedium	( this, SdResId(LB_STOREMEDIUM) ),
			  aMtrUserDefined	( this, SdResId(MTR_USERDEFINED) ),
			  aGrpStoreOption	( this, SdResId(GRP_STORE) ),
			  aFtGrpStoreDescr	( this, SdResId(FT_STORE_DESCR) ),
			  aBtnOK			( this, SdResId(BTN_OK) ),
			  aBtnCancel		( this, SdResId(BTN_CANCEL) ),
			  aBtnHelp			( this, SdResId(BTN_HELP) ),
			  rOutAttrs         ( *pInAttrs )
{
	FreeResource();

	aLbStoreMedium.SetSelectHdl( LINK( this, SdPackNGoDlg, SelectMediumHdl_Impl ) );

	// set checkboxes
	aCbxUnlink.Check  ( ( ( const SfxBoolItem& ) rOutAttrs.Get( ATTR_PACKNGO_UNLINK   ) ).GetValue() );

	// en/disable listbox	
	for( int i=STMED_FIRST; i<STMED_LAST+1; i++ )
	{
		if( nStoreSize[i] == ( ( const SfxUInt32Item& ) rOutAttrs.Get( ATTR_PACKNGO_MEDIUMSIZE ) ).GetValue() )
		{
			aLbStoreMedium.SelectEntryPos( i );
			break;
		}
	}

	// set default
	aMtrUserDefined.SetValue( 100, FUNIT_CUSTOM );
}

/*************************************************************************
|* transfer data to ItemSet
\************************************************************************/
void SdPackNGoDlg::GetAttr( SfxItemSet* pOutAttrs )
{
	pOutAttrs->Put( SfxBoolItem ( ATTR_PACKNGO_UNLINK, aCbxUnlink.IsChecked() ) );

	USHORT nPos = aLbStoreMedium.GetSelectEntryPos ();
	if( nPos == LISTBOX_ENTRY_NOTFOUND )
		nPos=0;
	
	if( nPos == STMED_USERDEFINED )
		pOutAttrs->Put( SfxUInt32Item ( ATTR_PACKNGO_MEDIUMSIZE, aMtrUserDefined.GetValue()*1024 ) );
	else
		pOutAttrs->Put( SfxUInt32Item ( ATTR_PACKNGO_MEDIUMSIZE, nStoreSize[nPos] ) );
}

/*************************************************************************
|*      Handler: Selection at Listbox "Speichermedium"
\************************************************************************/
IMPL_LINK( SdPackNGoDlg, SelectMediumHdl_Impl, void *, EMPTYARG )
{
	USHORT nPos = aLbStoreMedium.GetSelectEntryPos ();
	if( nPos == STMED_USERDEFINED )
		aMtrUserDefined.Show( TRUE );
	else
		aMtrUserDefined.Show( FALSE );

	return (0L);
}


