/*************************************************************************
 *
 *  $RCSfile: slchghdl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

#ifndef _SFXDISPATCH_HXX //autogen
#include <sfx2/dispatch.hxx>
#endif
#include <svtools/filedlg.hxx>
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _IODLG_HXX
#include <sfx2/iodlg.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#include "slidechg.hxx"
#include "slidechg.hrc"
#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
#include "sdattr.hxx"
#include "sdresid.hxx"
#include "sdview.hxx"
#include "drawdoc.hxx"

using namespace ::com::sun::star;

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickPreviewHdl, void *, EMPTYARG )
{
	BOOL bCheck = !aBtnPreview.IsChecked();
	aBtnPreview.Check( bCheck );

	SfxBoolItem aItem( SID_PREVIEW_WIN, bCheck );
	SFX_DISPATCHER().Execute( SID_PREVIEW_WIN, SFX_CALLMODE_ASYNCHRON |
								SFX_CALLMODE_RECORD, &aItem, 0L );

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickUpdateHdl, void *, EMPTYARG )
{
	bUpdate = !aBtnUpdate.IsChecked();
	aBtnUpdate.Check( bUpdate );

	if( bUpdate )
	{
		SfxBoolItem aItem( SID_SLIDE_CHANGE_STATE, TRUE );
		SFX_DISPATCHER().Execute( SID_SLIDE_CHANGE_STATE, SFX_CALLMODE_ASYNCHRON |
									SFX_CALLMODE_RECORD, &aItem, 0L );
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickAssignHdl, void *, EMPTYARG )
{
	SfxBoolItem aItem( SID_SLIDE_CHANGE_ASSIGN, TRUE );
	SFX_DISPATCHER().Execute( SID_SLIDE_CHANGE_ASSIGN, SFX_CALLMODE_ASYNCHRON |
								SFX_CALLMODE_RECORD, &aItem, 0L );

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, SelectEffectHdl, void *, p )
{
	if( p != &aCtlEffect )
		FillValueSet();

	if( aLbSpeed.GetSelectEntryPos() == LISTBOX_ENTRY_NOTFOUND )
		aLbSpeed.SelectEntryPos( 1 );

	// Favorit ?
	USHORT nPos = aLbEffect.GetSelectEntryPos();
	if( nPos == 0 )
	{
		USHORT nId  = aCtlEffect.GetSelectItemId();
		if( nId != 1 )
			aLbSound.SelectEntry( GetSoundById( nId ) );
		aBtnSound.SetState( nId == 1 ? STATE_NOCHECK : STATE_CHECK );
		ClickSoundHdl( NULL );
	}
	return( 0L );
}

// -----------------------------------------------------------------------
//	In Abhaengigkeit vom Sound werden Favoriten gesetzt oder entfernt
// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, SelectSoundHdl, void *, p )
{
	presentation::FadeEffect eFE = GetFadeEffect();

	if( p )
	{
		USHORT nPos = aLbEffect.GetSelectEntryPos();
		SetFadeEffect( eFE );
	}
	else
	{
		if( eFE != presentation::FadeEffect_NONE )
			SetFadeEffect( eFE );
	}
	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickAutoHdl, ImageButton *, pBtn )
{
	if( pBtn )
		pBtn->Check( !pBtn->IsChecked() );

	BOOL bCheck = aBtnAuto.IsChecked();

	if( bCheck )
	{
		aBtnManual.Check( FALSE );
		aBtnSemi.Check( FALSE );
		aFldTime.Enable();
		if( pBtn )
			aFldTime.Reformat();
	}
	else
	{
		aFldTime.Enable( FALSE );
		aFldTime.SetEmptyTime();
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickSemiHdl, ImageButton *, pBtn )
{
	if( pBtn )
		pBtn->Check( !pBtn->IsChecked() );

	BOOL bCheck = aBtnSemi.IsChecked();

	if( bCheck )
	{
		aBtnManual.Check( FALSE );
		aBtnAuto.Check( FALSE );
		aFldTime.Enable( FALSE );
		aFldTime.SetEmptyTime();
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickManualHdl, ImageButton *, pBtn )
{
	if( pBtn )
		pBtn->Check( !pBtn->IsChecked() );

	BOOL bCheck = aBtnManual.IsChecked();

	if( bCheck )
	{
		aBtnAuto.Check( FALSE );
		aBtnSemi.Check( FALSE );
		aFldTime.Enable( FALSE );
		aFldTime.SetEmptyTime();
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickSoundHdl, ImageButton *, pBtn )
{
	if( pBtn )
		pBtn->Check( !pBtn->IsChecked() );

	BOOL bCheck = aBtnSound.IsChecked();

	aBtnSearch.Enable( bCheck );
	aLbSound.Enable( bCheck );

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickSearchHdl, ImageButton *, pBtn )
{
	OpenFileDialog();

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickViewTypeHdl, ImageButton *, pBtn )
{
	/* Der folgende Code ist notwendig, wenn mehr als 2 Sichten
		im Effekte-Window moeglich sind: */
	/*
	if( pBtn )
	{
		PopupMenu* pMenu = new PopupMenu;

		for( USHORT nID = VIEWTYPE_SC_EFFECT;
			 nID <= VIEWTYPE_SC_EXTRAS;
			 nID++ )
		{
			USHORT nRId = GetViewTypeResId( (ViewType) nID );
			if( nRId > 0 )
				pMenu->InsertItem( nID, String( SdResId( nRId ) ) );

		}
		// nur temporaer !
		// VIEWTYPE_SC_TEXT wird z.Z. nicht untertstuetzt
		// pMenu->EnableItem( VIEWTYPE_SC_TEXT, FALSE );

		if( bBreakEven )
			pMenu->EnableItem( VIEWTYPE_SC_EXTRAS, FALSE );

		pMenu->CheckItem( eViewType );
		pMenu->PushSelectHdl( LINK( this, SdSlideChangeWin, MenuSelectHdl ) );

		Point aPt;
		Size aSize( pBtn->GetOutputSizePixel() );
		aPt.Y() += aSize.Height();

		aPt = pBtn->OutputToScreenPixel( aPt );
		pMenu->Execute( aPt );

		delete pMenu;
	}
	else
	{
		aBtnViewType.SetImage( SdResId( GetViewTypeResId( eViewType, TRUE ) ) );
	}
	*/

	// Der folgende Code ist nur bestimmt fuer 2 Sichten
	/*
	if( pBtn )
	{
		pBtn->Check( !pBtn->IsChecked() );
		if( pBtn->IsChecked() ) // Extras
		{
			eViewType = VIEWTYPE_SC_EXTRAS;

			aLbEffect.Hide();
			aCtlEffect.Hide();
			aLbSpeed.Hide();

			aBtnAuto.Show();
			aBtnManual.Show();
			aFldTime.Show();
			aBtnSound.Show();
			aBtnSearch.Show();
			aEdtSound.Show();
		}
		else
		{
			eViewType = VIEWTYPE_SC_EFFECT;

			aLbEffect.Show();
			aCtlEffect.Show();
			aLbSpeed.Show();

			aBtnAuto.Hide();
			aBtnManual.Hide();
			aFldTime.Hide();
			aBtnSound.Hide();
			aBtnSearch.Hide();
			aEdtSound.Hide();
		}
		aGrpEffect.SetText( SdResId( GetViewTypeResId( eViewType ) ) );
	}
	aBtnViewType.SetImage( SdResId( GetViewTypeResId( eViewType, TRUE ) ) );
	*/

	// Der folgende Code ist bestimmt fuer 2 Sichten (und 2 Buttons)
	if( pBtn )
	{
		aBtnVTEffect.Check( &aBtnVTEffect == pBtn );
		aBtnVTExtras.Check( &aBtnVTExtras == pBtn || bBreakEven );

		if( aBtnVTEffect.IsChecked() )
			eViewType = VIEWTYPE_SC_EFFECT;
		else if( aBtnVTExtras.IsChecked() )
			eViewType = VIEWTYPE_SC_EXTRAS;

		if( eViewType == VIEWTYPE_SC_EFFECT )
		{
			aLbEffect.Show();
			aCtlEffect.Show();
			aLbSpeed.Show();
		}
		else if( eViewType == VIEWTYPE_SC_EXTRAS )
		{
			aLbEffect.Hide();
			aCtlEffect.Hide();
			aLbSpeed.Hide();
		}
		if( eViewType == VIEWTYPE_SC_EXTRAS || bBreakEven )
		{
			aBtnAuto.Show();
			aBtnSemi.Show();
			aBtnManual.Show();
			aFldTime.Show();
			aBtnSound.Show();
			aBtnSearch.Show();
			aLbSound.Show();
		}
		else
		{
			aBtnAuto.Hide();
			aBtnSemi.Hide();
			aBtnManual.Hide();
			aFldTime.Hide();
			aBtnSound.Hide();
			aBtnSearch.Hide();
			aLbSound.Hide();
		}

		aGrpEffect.SetText( String( SdResId( GetViewTypeResId( eViewType ) ) ) );
	}
	else
	{
		aBtnVTEffect.Check( eViewType == VIEWTYPE_SC_EFFECT );
		aBtnVTExtras.Check( eViewType == VIEWTYPE_SC_EXTRAS || bBreakEven );
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, MenuSelectHdl, Menu *, pMenu )
{
	/*
	USHORT nMenuId;
	if( pMenu )
		nMenuId = pMenu->GetCurItemId();
	else
		nMenuId = VIEWTYPE_SC_EFFECT;

	if( nMenuId != USHRT_MAX ) // Notwendig ?
	{
		ViewType eVT = (ViewType) nMenuId;
		if( eViewType != eVT )
		{
			eViewType = eVT;
			aBtnViewType.SetImage( SdResId( GetViewTypeResId( eViewType, TRUE ) ) );

			if( eViewType == VIEWTYPE_SC_EFFECT )
			{
				aLbEffect.Show();
				aCtlEffect.Show();
				aLbSpeed.Show();

				aLbTextEffect.Hide();
				aCtlTextEffect.Hide();
			}
			else if( eViewType == VIEWTYPE_SC_TEXT )
			{
				aLbEffect.Hide();
				aCtlEffect.Hide();
				aLbSpeed.Hide();

				aLbTextEffect.Show();
				aCtlTextEffect.Show();
			}
			else if( eViewType == VIEWTYPE_SC_EXTRAS )
			{
				aLbEffect.Hide();
				aCtlEffect.Hide();
				aLbSpeed.Hide();

				aLbTextEffect.Hide();
				aCtlTextEffect.Hide();
			}
			if( eViewType == VIEWTYPE_SC_EXTRAS || bBreakEven )
			{
				aFtTranspColor.Show();
				aLbTranspColor.Show();
				aBtnInvisible.Show();
				aBtnFadeOut.Show();
				aLbFadeOutColor.Show();
				aBtnSound.Show();
				aBtnPlayFull.Show();
				aBtnSearch.Show();
				aEdtSound.Show();
			}
			else
			{
				aFtTranspColor.Hide();
				aLbTranspColor.Hide();
				aBtnInvisible.Hide();
				aBtnFadeOut.Hide();
				aLbFadeOutColor.Hide();
				aBtnSound.Hide();
				aBtnPlayFull.Hide();
				aBtnSearch.Hide();
				aEdtSound.Hide();
			}

			aGrpEffect.SetText( SdResId( GetViewTypeResId( eViewType ) ) );
		}
	}
	*/
	return( 0 );
}

//------------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, ClickSoundPreviewHdl, void *, EMPTYARG )
{
	if( pFileDialog )
	{
		if( aSound.IsPlaying() )
			aSound.Stop();
		else
		{
			INetURLObject	aUrl; aUrl.SetSmartURL( pFileDialog->GetPath() );
			String			aSoundFile( aUrl.PathToFileName() );

			if( aSoundFile.Len() > 0 )
			{
				aSound.SetNotifyHdl( LINK( this, SdSlideChangeWin, StopMusicHdl ) );
				aSound.SetSoundName( aSoundFile );
				aSound.Play();

				if( aSound.IsPlaying() )
					pBtnPreview->SetText( String( SdResId( STR_STOP ) ) );
			}
		}
	}
	return( 0L );
}

//------------------------------------------------------------------------

IMPL_LINK( SdSlideChangeWin, StopMusicHdl, void *, EMPTYARG )
{
	// Zuruecksetzen, damit das Soundfile nicht gelocked bleibt
	aSound.SetNotifyHdl( Link() );
	aSound.SetSoundName( String() );

	if( pBtnPreview )
		pBtnPreview->SetText( String( SdResId( STR_PLAY ) ) );

	return( 0L );
}



