/*************************************************************************
 *
 *  $RCSfile: tpeffect.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONEFFECT_HPP_
#include <com/sun/star/presentation/AnimationEffect.hpp>
#endif
#ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONSPEED_HPP_
#include <com/sun/star/presentation/AnimationSpeed.hpp>
#endif

#define ITEMID_COLOR SID_COLOR_TABLE

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#include "sdattr.hxx"
#include <svtools/urihelper.hxx>
#include <svx/svxids.hrc>

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _AEITEM_HXX //autogen
#include <svtools/aeitem.hxx>
#endif

#ifndef _SFX_FILDLG_HXX
#include <sfx2/iodlg.hxx>
#endif
#ifndef _XTABLE_HXX
#include <svx/xtable.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#include <svx/colritem.hxx>

#ifdef MAC
#ifdef ITEMID_COLOR
#undef ITEMID_COLOR
#endif
#endif
#define ITEMID_COLOR			ATTR_ANIMATION_COLOR
#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE

#ifndef _SVX_DRAWITEM_HXX
#include <svx/drawitem.hxx>
#endif

#include "tpeffect.hxx"
#include "tpeffect.hrc"

#include "sdview.hxx"
#include "sdresid.hxx"
#include "docshell.hxx"
#include "viewshel.hxx"

#include "strings.hrc"
#include "res_bmp.hrc"


static USHORT pEffectRanges[] =
{
	ATTR_ANIMATION_START,
	ATTR_ANIMATION_END,
	0
};

using namespace ::com::sun::star;

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

SdEffectTabDialog::SdEffectTabDialog( Window* pParent,
								const SfxItemSet* pAttr,
								SdView* pSdView,
								USHORT nDlgId ) :
		SfxTabDialog( pParent, SdResId( nDlgId ), pAttr ),
		rOutAttrs	( *pAttr ),
		pView		( pSdView )
{
	FreeResource();

	DBG_ASSERT( pView, "Keine gueltige View Uebergeben!" );

	if (nDlgId == TAB_ANIMATION)
	{
		AddTabPage( TP_ANIMATION_EFFECT, SdTPEffect::Create,
										SdTPEffect::GetRanges );
		AddTabPage( TP_ANIMATION_ACTION, SdTPAction::Create,
										SdTPAction::GetRanges );
	}
	else if (nDlgId == TAB_ACTIONSONLY)
	{
		AddTabPage( TP_ANIMATION_ACTION, SdTPAction::Create,
										SdTPAction::GetRanges );
	}
}

// -----------------------------------------------------------------------

SdEffectTabDialog::~SdEffectTabDialog()
{
}

// -----------------------------------------------------------------------

void __EXPORT SdEffectTabDialog::PageCreated( USHORT nId, SfxTabPage &rPage )
{
	switch( nId )
	{
		case TP_ANIMATION_EFFECT:
			( (SdTPEffect&) rPage ).SetView( pView );
			( (SdTPEffect&) rPage ).Construct();
		break;

		case TP_ANIMATION_ACTION:
			( (SdTPAction&) rPage ).SetView( pView );
			( (SdTPAction&) rPage ).Construct();
		break;
	}
}

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

SdActionDlg::SdActionDlg( Window* pParent, const SfxItemSet* pAttr,
								SdView* pView ) :
		SfxSingleTabDialog	( pParent, *pAttr, TP_ANIMATION_ACTION, FALSE ),
		rOutAttrs			( *pAttr )
{
	// FreeResource();
	SfxTabPage* pPage = SdTPAction::Create( this, rOutAttrs );
	DBG_ASSERT( pPage, "Seite konnte nicht erzeugt werden");

	// Ehemals in PageCreated
	( (SdTPAction*) pPage )->SetView( pView );
	( (SdTPAction*) pPage )->Construct();

	SetTabPage( pPage );

	String aStr( pPage->GetText() );
	if( aStr.Len() )
		SetText( aStr );
}

/*************************************************************************
|*
|*	Animations-TabPage (Basisklasse)
|*
\************************************************************************/

SdTPAnimation::SdTPAnimation( Window* pWindow, const SfxItemSet& rInAttrs ) :
			SfxTabPage  ( pWindow, SdResId( TP_ANIMATION ), rInAttrs ),
		aTsbAnimation   ( this, SdResId( TSB_ANIMATION ) ),
		aLbAction       ( this, SdResId( LB_ACTION ) ),
		aFtAction       ( this, SdResId( FT_ACTION ) ),
		aLbEffect       ( this, SdResId( LB_EFFECT ) ),
		aLbTree         ( this, SdResId( LB_TREE ) ),
		aLbTreeDocument ( this, SdResId( LB_TREE_DOCUMENT ) ),
		aLbOLEAction    ( this, SdResId( LB_OLE_ACTION ) ),
		aFtTranspColor  ( this, SdResId( FT_TRANSPCOLOR ) ),
		aLbTranspColor  ( this, SdResId( LB_TRANSPCOLOR ) ),
		aRbtSlow        ( this, SdResId( RBT_SLOW ) ),
		aRbtMedium      ( this, SdResId( RBT_MEDIUM ) ),
		aRbtFast        ( this, SdResId( RBT_FAST ) ),
		aGrpEffect      ( this, SdResId( GRP_EFFECT ) ),
		aTsbInvisible   ( this, SdResId( TSB_INVISIBLE ) ),
		aTsbFadeOut     ( this, SdResId( TSB_FADE_OUT ) ),
		aLbColor        ( this, SdResId( LB_COLOR ) ),
		aGrpObjects     ( this, SdResId( GRP_OBJECTS ) ),
		aTsbSound       ( this, SdResId( TSB_SOUND ) ),
		aEdtSound       ( this, SdResId( EDT_SOUND ) ),
		aEdtPage        ( this, SdResId( EDT_PAGE ) ),
		aEdtDocument    ( this, SdResId( EDT_DOCUMENT ) ),
		aEdtObject      ( this, SdResId( EDT_OBJECT ) ),
		aTsbPlayFull    ( this, SdResId( TSB_PLAY_FULL ) ),
		aBtnSearch      ( this, SdResId( BTN_SEARCH ) ),
		aBtnSeek        ( this, SdResId( BTN_SEEK ) ),
		aGrpSound       ( this, SdResId( GRP_SOUND ) ),
		pFileDialog 	( NULL ),
		pView			( NULL ),
		pDoc			( NULL ),
		rOutAttrs		( rInAttrs )
{
	FreeResource();

	aTsbInvisible.SetClickHdl( LINK( this, SdTPAnimation, ClickFadeOutHdl ) );
	aTsbFadeOut.SetClickHdl( LINK( this, SdTPAnimation, ClickFadeOutHdl ) );
	aTsbSound.SetClickHdl( LINK( this, SdTPAnimation, ClickSoundHdl ) );
	aLbEffect.SetSelectHdl( LINK( this, SdTPAnimation, ChangeEffectHdl ) );
	aBtnSearch.SetClickHdl( LINK( this, SdTPAnimation, ClickSearchHdl ) );
	aBtnSeek.SetClickHdl( LINK( this, SdTPAnimation, ClickSearchHdl ) );
}

// -----------------------------------------------------------------------

SdTPAnimation::~SdTPAnimation()
{
}


void SdTPAnimation::SetView( const SdView* pSdView )
{
	pView = pSdView;

	// Holen der ColorTable und Fuellen der ListBox
	SdDrawDocShell* pDocSh = ( (SdView*) pView )->GetDocSh();
	pDoc = pDocSh->GetDoc();
	SfxViewFrame* pFrame = pDocSh->GetViewShell()->GetViewFrame();
	aLbTree.SetViewFrame( pFrame );
	aLbTreeDocument.SetViewFrame( pFrame );

	SvxColorTableItem aItem( *(const SvxColorTableItem*)( pDocSh->GetItem( SID_COLOR_TABLE ) ) );
	pColTab = aItem.GetColorTable();
	DBG_ASSERT( pColTab, "Keine Farbtabelle vorhanden!" );
	aLbColor.Fill( pColTab );
	FillColorLB();
}
//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, ChangeEffectHdl, void *, EMPTYARG )
{
	USHORT nPos = GetActualAnimationEffect();
	if( nPos == presentation::AnimationEffect_NONE &&
		aLbEffect.GetSelectEntryCount() > 0 )
	{
		aRbtSlow.Disable();
		aRbtMedium.Disable();
		aRbtFast.Disable();
	}
	else if( !aTsbAnimation. IsVisible() ||
			 aTsbAnimation.GetState() != STATE_NOCHECK )
	{
		aRbtSlow.Enable();
		aRbtMedium.Enable();
		aRbtFast.Enable();

		// Damit wenigstens ein Radiobutton gechecked wird:
		if( !aRbtSlow.IsChecked() &&
			!aRbtMedium.IsChecked() &&
			!aRbtFast.IsChecked() )
			aRbtSlow.Check();
	}

	// Erstmal auf diese Weise:
	// Effekte-TP
	if( aTsbAnimation.IsVisible() )
	{
		if( nPos == presentation::AnimationEffect_MOVE_FROM_LEFT 		||
			nPos == presentation::AnimationEffect_MOVE_FROM_TOP			||
			nPos == presentation::AnimationEffect_MOVE_FROM_RIGHT		||
			nPos == presentation::AnimationEffect_MOVE_FROM_BOTTOM		||
			nPos == presentation::AnimationEffect_LASER_FROM_LEFT		||
			nPos == presentation::AnimationEffect_LASER_FROM_TOP 		||
			nPos == presentation::AnimationEffect_LASER_FROM_RIGHT		||
			nPos == presentation::AnimationEffect_LASER_FROM_BOTTOM		||
			nPos == presentation::AnimationEffect_LASER_FROM_UPPERLEFT	||
			nPos == presentation::AnimationEffect_LASER_FROM_UPPERRIGHT	||
			nPos == presentation::AnimationEffect_LASER_FROM_LOWERLEFT	||
			nPos == presentation::AnimationEffect_LASER_FROM_LOWERRIGHT	||
			nPos == presentation::AnimationEffect_PATH					||
			nPos == presentation::AnimationEffect_NONE ) 	// fuer Animator-Objekte
		{
			if( aTsbAnimation.GetState() == STATE_NOCHECK )
			{
				aFtTranspColor.Disable();
				aLbTranspColor.Disable();
			}
			else
			{
				aFtTranspColor.Enable();
				aLbTranspColor.Enable();
			}
		}
		else
		{
			aFtTranspColor.Disable();
			aLbTranspColor.Disable();
		}
		ClickFadeOutHdl( NULL );
	}
	else
	// Interaktions-TP
	{
		if( nPos == presentation::AnimationEffect_MOVE_TO_LEFT	 ||
			nPos == presentation::AnimationEffect_MOVE_TO_RIGHT	 ||
			nPos == presentation::AnimationEffect_MOVE_TO_TOP	 ||
			nPos == presentation::AnimationEffect_MOVE_TO_BOTTOM )
		{
			aFtTranspColor.Enable();
			aLbTranspColor.Enable();
		}
		else
		{
			aFtTranspColor.Disable();
			aLbTranspColor.Disable();
		}
	}
	return( 0L );
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, ClickFadeOutHdl, void *, EMPTYARG )
{
	if( aTsbAnimation.IsVisible() )
	{
		USHORT nPos = GetActualAnimationEffect();
		if( nPos == presentation::AnimationEffect_NONE )
		{
			aGrpObjects.Disable();
			aTsbInvisible.Disable();
			aTsbFadeOut.Disable();
			aLbColor.Disable();
		}
		else
		{
			aGrpObjects.Enable();

			if( aTsbFadeOut.GetState() == STATE_NOCHECK )
			{
				aTsbInvisible.Enable();
				aLbColor.Disable();
			}
			else
			{
				aTsbInvisible.Disable();
				aLbColor.Enable();
			}
			if( aTsbInvisible.GetState() == STATE_NOCHECK )
			{
				aTsbFadeOut.Enable();
			}
			else
			{
				aTsbFadeOut.Disable();
			}
		}
	}
	return( 0L );
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, ClickSoundHdl, void *, EMPTYARG )
{
	if( aTsbSound.GetState() == STATE_NOCHECK)
	{
		aEdtSound.Disable();
		aBtnSearch.Disable();
		aTsbPlayFull.Disable();
	}
	else
	{
		aEdtSound.Enable();
		aBtnSearch.Enable();
		aTsbPlayFull.Enable();
	}
	bSoundFileInvalide = FALSE;

	return( 0L );
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, ClickSearchHdl, void *, EMPTYARG )
{
	OpenFileDialog();

	return( 0L );
}

//------------------------------------------------------------------------

void SdTPAnimation::OpenFileDialog()
{
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, ClickPreviewHdl, void *, EMPTYARG )
{
	if( pFileDialog )
	{
		if( aSound.IsPlaying() )
			aSound.Stop();
		else
		{
			INetURLObject	aUrl; aUrl.SetSmartURL( pFileDialog->GetPath() );
			String			aSoundFile( aUrl.PathToFileName() );

			if( aSoundFile.Len() > 0 )
			{
				aSound.SetNotifyHdl( LINK( this, SdTPAnimation, StopMusicHdl ) );
				aSound.SetSoundName( aSoundFile );
				aSound.Play();

				if( aSound.IsPlaying() )
					pBtnPreview->SetText( String( SdResId( STR_STOP ) ) );
			}
		}
	}
	return( 0L );
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPAnimation, StopMusicHdl, void *, EMPTYARG )
{
	aSound.SetNotifyHdl( Link() );
	aSound.SetSoundName( String() );

	if( pBtnPreview )
		pBtnPreview->SetText( String( SdResId( STR_PLAY ) ) );

	return( 0L );
}

//------------------------------------------------------------------------

void SdTPAnimation::FillColorLB()
{
	Color aColorArray[16];
	BOOL  aBoolArray[16];
	long  aEntryArray[16];

	for( int i = 0; i < 16; i++ )
		aBoolArray[ i ] = FALSE;

	aColorArray[ 0 ] = Color( COL_BLACK );
	aColorArray[ 1 ] = Color( COL_BLUE );
	aColorArray[ 2 ] = Color( COL_GREEN );
	aColorArray[ 3 ] = Color( COL_CYAN );
	aColorArray[ 4 ] = Color( COL_RED );
	aColorArray[ 5 ] = Color( COL_MAGENTA );
	aColorArray[ 6 ] = Color( COL_BROWN );
	aColorArray[ 7 ] = Color( COL_GRAY );
	aColorArray[ 8 ] = Color( COL_LIGHTGRAY );
	aColorArray[ 9 ] = Color( COL_LIGHTBLUE );
	aColorArray[ 10 ] = Color( COL_LIGHTGREEN );
	aColorArray[ 11 ] = Color( COL_LIGHTCYAN );
	aColorArray[ 12 ] = Color( COL_LIGHTRED );
	aColorArray[ 13 ] = Color( COL_LIGHTMAGENTA );
	aColorArray[ 14 ] = Color( COL_YELLOW );
	aColorArray[ 15 ] = Color( COL_WHITE );

	for( long j = 0, nCount = pColTab->Count(); j < nCount; j++ )
	{
		XColorEntry* pEntry = pColTab->Get( j );
		Color& rColor = pEntry->GetColor();
		for( int k = 0; k <= 15; k++ )
		{
			if( !aBoolArray[ k ] )
			{
				if( rColor.IsRGBEqual( aColorArray[ k ] ) )
				{
					aBoolArray[ k ] = TRUE;
					aEntryArray[ k ] = j;
				}
			}
		}
		// Abbruch, wenn alle Bools TRUE sind
	}

	for( i = 0; i < 16; i++ )
	{
		if( aBoolArray[ i ] )
		{
			XColorEntry* pEntry = pColTab->Get( aEntryArray[ i ] );
			aLbTranspColor.InsertEntry( pEntry->GetColor(), pEntry->GetName() );
		}
		else
			aLbTranspColor.InsertEntry( aColorArray[ i ], String() );
	}
}

/*************************************************************************
|*
|*	Effekte-TabPage
|*
\************************************************************************/

SdTPEffect::SdTPEffect( Window* pWindow, const SfxItemSet& rInAttrs ) :
		SdTPAnimation( pWindow, rInAttrs )
{
	// diese Page braucht ExchangeSupport
	SetExchangeSupport();

	pCurrentEffects = new List;

	aTsbAnimation.SetClickHdl( LINK( this, SdTPEffect, ClickAnimationHdl ) );

	aTsbAnimation.Show();
	aLbEffect.Show();
	aFtTranspColor.Show();
	aLbTranspColor.Show();
	aRbtSlow.Show();
	aRbtMedium.Show();
	aRbtFast.Show();
	aGrpEffect.Show();
	aTsbInvisible.Show();
	aTsbFadeOut.Show();
	aLbColor.Show();
	aGrpObjects.Show();
	aTsbSound.Show();
	aEdtSound.Show();
	aTsbPlayFull.Show();
	aBtnSearch.Show();
	aGrpSound.Show();

}

// -----------------------------------------------------------------------

SdTPEffect::~SdTPEffect()
{
	delete pCurrentEffects;
}

// -----------------------------------------------------------------------

void SdTPEffect::Construct()
{
	// fuer den Pfad-Effekt; diesen Effekt nur dann anbieten, wenn genau zwei
	// Objekte selektiert sind, eines davon eine Kurve und das andere kein
	// Gliederungstext ist
	BOOL bAllowPathEffect = FALSE;
	const SdrMarkList& rMarkList  = pView->GetMarkList();
	ULONG nCount = rMarkList.GetMarkCount();

	if( nCount == 2 )
	{
		SdrObject* pObject1 = rMarkList.GetMark(0)->GetObj();
		SdrObject* pObject2 = rMarkList.GetMark(1)->GetObj();
		SdrObjKind eKind1	= (SdrObjKind)pObject1->GetObjIdentifier();
		SdrObjKind eKind2	= (SdrObjKind)pObject2->GetObjIdentifier();

		if( ( pObject1->GetObjInventor() == SdrInventor &&
			  ( eKind1 == OBJ_LINE	||		   // 2-Punkt-Linie
				eKind1 == OBJ_PLIN	||		   // Polygon
				eKind1 == OBJ_PATHLINE ) &&    // Bezier-Kurve
			  eKind2 != OBJ_OUTLINETEXT )		||
			( pObject2->GetObjInventor() == SdrInventor &&
			  ( eKind2 == OBJ_LINE ||		  // 2-Punkt-Linie
				eKind2 == OBJ_PLIN ||		  // Polygon
				eKind2 == OBJ_PATHLINE ) &&   // Bezier-Kurve
			   eKind1 != OBJ_OUTLINETEXT ) )
		{
			bAllowPathEffect = TRUE;
		}
	}

	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_NONE, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_TOP, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_BOTTOM, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_TO_CENTER, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_CENTER, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_TOP, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_BOTTOM, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_VERTICAL_STRIPES, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_HORIZONTAL_STRIPES, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOCKWISE, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_COUNTERCLOCKWISE, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_UPPERLEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_UPPERRIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LOWERLEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LOWERRIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOSE_VERTICAL, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOSE_HORIZONTAL, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_OPEN_VERTICAL, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_OPEN_HORIZONTAL, LIST_APPEND);
	if (bAllowPathEffect)
		pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_PATH, LIST_APPEND);
	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_LEFT, LIST_APPEND);
	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_TOP, LIST_APPEND);
	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_RIGHT, LIST_APPEND);
	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_BOTTOM
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALIN_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALIN_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALOUT_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALOUT_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_DISSOLVE, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_TOP, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_RANDOM, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_VERTICAL_LINES, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_HORIZONTAL_LINES, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_LEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_TOP, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_RIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_BOTTOM, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_UPPERLEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_UPPERRIGHT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_LOWERLEFT, LIST_APPEND);
	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_LASER_FROM_LOWERRIGHT, LIST_APPEND);

	// Listbox mit Effekten fuellen
	for (ULONG nEffect = 0; nEffect < pCurrentEffects->Count(); nEffect++)
	{
		presentation::AnimationEffect eEffect = (presentation::AnimationEffect)(ULONG)pCurrentEffects->
											GetObject(nEffect);
		USHORT nRId = GetAnimationEffectSdResId(eEffect);
		aLbEffect.InsertEntry( String( SdResId( nRId ) ) );
	}

	ChangeEffectHdl( this );
	ClickAnimationHdl( this );
}

// -----------------------------------------------------------------------

BOOL __EXPORT SdTPEffect::FillItemSet( SfxItemSet& rAttrs )
{
	if( aLbEffect.GetSelectEntryCount() &&
		aLbEffect.GetSavedValue() != aLbEffect.GetSelectEntryPos() )
		rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_EFFECT, GetActualAnimationEffect() ) );
	else
		rAttrs.InvalidateItem( ATTR_ANIMATION_EFFECT );

	if( aRbtSlow.IsChecked() )
		rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_SPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_SLOW ) );
	else if( aRbtMedium.IsChecked() )
		rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_SPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_MEDIUM ) );
	else if( aRbtFast.IsChecked() )
		rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_SPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_FAST ) );
	else
		rAttrs.InvalidateItem( ATTR_ANIMATION_SPEED );


	TriState eState = aTsbAnimation.GetState();
	if( eState != aTsbAnimation.GetSavedValue() )
	{
		if( eState == STATE_DONTKNOW )
			rAttrs.InvalidateItem( ATTR_ANIMATION_ACTIVE );
		else if( eState == STATE_CHECK )
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_ACTIVE, TRUE ) );
		else
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_ACTIVE, FALSE ) );
	}

	eState = aTsbFadeOut.GetState();
	if( eState != aTsbFadeOut.GetSavedValue() )
	{
		if( eState == STATE_DONTKNOW )
			rAttrs.InvalidateItem( ATTR_ANIMATION_FADEOUT );
		else if( eState == STATE_CHECK )
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_FADEOUT, TRUE ) );
		else
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_FADEOUT, FALSE ) );
	}

	eState = aTsbInvisible.GetState();
	if( eState != aTsbInvisible.GetSavedValue() )
	{
		if( eState == STATE_DONTKNOW )
			rAttrs.InvalidateItem( ATTR_ANIMATION_INVISIBLE );
		else if( eState == STATE_CHECK )
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_INVISIBLE, TRUE ) );
		else
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_INVISIBLE, FALSE ) );
	}

	if( aLbColor.GetSelectEntryCount() &&
		aLbColor.GetSavedValue() != aLbColor.GetSelectEntryPos() )
		rAttrs.Put( SvxColorItem( aLbColor.GetSelectEntryColor() ) );
	else
		rAttrs.InvalidateItem( ATTR_ANIMATION_COLOR );


	eState = aTsbSound.GetState();
	if( eState != aTsbSound.GetSavedValue() )
	{
		if( eState == STATE_DONTKNOW )
			rAttrs.InvalidateItem( ATTR_ANIMATION_SOUNDON );
		else if( eState == STATE_CHECK )
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_SOUNDON, TRUE ) );
		else
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_SOUNDON, FALSE ) );
	}

	if( bSoundFileInvalide )
		rAttrs.InvalidateItem( ATTR_ANIMATION_SOUNDFILE );
	else
	{
		String aTmpStr( aEdtSound.GetText() );
		rAttrs.Put( SfxStringItem( ATTR_ANIMATION_SOUNDFILE, aTmpStr ) );
	}

	// Transparenzfarbe
	if( aLbTranspColor.GetSelectEntryPos() != LISTBOX_ENTRY_NOTFOUND &&
		aLbTranspColor.GetSavedValue() != aLbTranspColor.GetSelectEntryPos() )
	{
		SvxColorItem aColorItem( aLbTranspColor.GetSelectEntryColor(),
								 ATTR_ANIMATION_TRANSPCOLOR );
		rAttrs.Put( aColorItem );
	}

	// vollstaendig abspielen
	eState = aTsbPlayFull.GetState();
	if( eState != aTsbPlayFull.GetSavedValue() )
	{
		if( eState == STATE_DONTKNOW )
			rAttrs.InvalidateItem( ATTR_ANIMATION_PLAYFULL );
		else if( eState == STATE_CHECK )
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_PLAYFULL, TRUE ) );
		else
			rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_PLAYFULL, FALSE ) );
	}
	return( TRUE );
}

//------------------------------------------------------------------------

void __EXPORT SdTPEffect::Reset( const SfxItemSet& rAttrs )
{
	presentation::AnimationEffect eAE;
	presentation::AnimationSpeed	eAS;

	if( rAttrs.GetItemState( ATTR_ANIMATION_EFFECT ) != SFX_ITEM_DONTCARE )
	{
		eAE = (presentation::AnimationEffect) ( ( const SfxAllEnumItem& ) rAttrs.
					Get( ATTR_ANIMATION_EFFECT ) ).GetValue();
		SetActualAnimationEffect( eAE );
	}
	else
		aLbEffect.SetNoSelection();

	if( rAttrs.GetItemState( ATTR_ANIMATION_SPEED ) != SFX_ITEM_DONTCARE )
	{
		eAS = (presentation::AnimationSpeed) ( ( const SfxAllEnumItem& ) rAttrs.
					Get( ATTR_ANIMATION_SPEED ) ).GetValue();

		if( eAS == presentation::AnimationSpeed_SLOW )
			aRbtSlow.Check();
		else if( eAS == presentation::AnimationSpeed_MEDIUM )
			aRbtMedium.Check();
		else if( eAS == presentation::AnimationSpeed_FAST )
			aRbtFast.Check();
	}

	if( rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_DONTCARE )
	{
		aTsbAnimation.EnableTriState( FALSE );
		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_ACTIVE ) ).GetValue() )
			aTsbAnimation.SetState( STATE_CHECK );
		else
			aTsbAnimation.SetState( STATE_NOCHECK );
	}
	else
		aTsbAnimation.SetState( STATE_DONTKNOW );


	if( rAttrs.GetItemState( ATTR_ANIMATION_FADEOUT ) != SFX_ITEM_DONTCARE )
	{
		aTsbFadeOut.EnableTriState( FALSE );
		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_FADEOUT ) ).GetValue() )
			aTsbFadeOut.SetState( STATE_CHECK );
		else
			aTsbFadeOut.SetState( STATE_NOCHECK );
	}
	else
		aTsbFadeOut.SetState( STATE_DONTKNOW );


	if( rAttrs.GetItemState( ATTR_ANIMATION_INVISIBLE ) != SFX_ITEM_DONTCARE )
	{
		aTsbInvisible.EnableTriState( FALSE );
		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_INVISIBLE ) ).GetValue() )
			aTsbInvisible.SetState( STATE_CHECK );
		else
			aTsbInvisible.SetState( STATE_NOCHECK );
	}
	else
		aTsbInvisible.SetState( STATE_DONTKNOW );

	DBG_ASSERT( !( aTsbInvisible.GetState() == STATE_CHECK &&
				   aTsbFadeOut.GetState() == STATE_CHECK ),
				"Beide Werte (FadeOut und Invisible) koennen nicht gechecked sein!" );

	if( rAttrs.GetItemState( ATTR_ANIMATION_COLOR ) != SFX_ITEM_DONTCARE )
	{
		aLbColor.SelectEntry( ( ( const SvxColorItem& ) rAttrs.Get( ATTR_ANIMATION_COLOR ) ).GetValue() );
	}
	else
		aLbColor.SetNoSelection();

	if( rAttrs.GetItemState( ATTR_ANIMATION_SOUNDON ) != SFX_ITEM_DONTCARE )
	{
		aTsbSound.EnableTriState( FALSE );
		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_SOUNDON ) ).GetValue() )
			aTsbSound.SetState( STATE_CHECK );
		else
			aTsbSound.SetState( STATE_NOCHECK );
	}
	else
		aTsbSound.SetState( STATE_DONTKNOW );

	if( rAttrs.GetItemState( ATTR_ANIMATION_SOUNDFILE ) != SFX_ITEM_DONTCARE )
	{
		aEdtSound.SetText( ( ( const SfxStringItem& ) rAttrs.Get( ATTR_ANIMATION_SOUNDFILE ) ).GetValue() );
		bSoundFileInvalide = FALSE;
		ClickSoundHdl( this );
	}
	else
		bSoundFileInvalide = TRUE;

	// Transparenzfarbe
	const SfxPoolItem* pPoolItem;
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( ATTR_ANIMATION_TRANSPCOLOR, FALSE, &pPoolItem ) )
	{
		Color aColor = ( ( const SvxColorItem* ) pPoolItem )->GetValue();
		aLbTranspColor.SelectEntry( aColor );
	}

	// vollstaendig abspielen
	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( ATTR_ANIMATION_PLAYFULL, FALSE, &pPoolItem ) )
	{
		aTsbPlayFull.EnableTriState( FALSE );
		if( ( ( const SfxBoolItem* ) pPoolItem )->GetValue() )
			aTsbPlayFull.SetState( STATE_CHECK );
		else
			aTsbPlayFull.SetState( STATE_NOCHECK );
	}
	else
		aTsbPlayFull.SetState( STATE_DONTKNOW );

	ChangeEffectHdl( this );
	ClickAnimationHdl( this );

	aLbEffect.SaveValue();
	aLbColor.SaveValue();
	aLbTranspColor.SaveValue();
	aTsbAnimation.SaveValue();
	aTsbSound.SaveValue();
	aTsbFadeOut.SaveValue();
	aTsbInvisible.SaveValue();
	aTsbPlayFull.SaveValue();
}

// -----------------------------------------------------------------------

void __EXPORT SdTPEffect::ActivatePage( const SfxItemSet& rSet )
{
	const SvxColorItem* pColorItem;
	if( SFX_ITEM_SET == rSet.GetItemState( ATTR_ANIMATION_TRANSPCOLOR, FALSE,
									(const SfxPoolItem**) &pColorItem ) )
	{
		Color aColor = pColorItem->GetValue();
		aLbTranspColor.SelectEntry( aColor );
	}
}

// -----------------------------------------------------------------------

int __EXPORT SdTPEffect::DeactivatePage( SfxItemSet* pSet )
{
	if( pSet  )
	{
		SvxColorItem aColorItem( aLbTranspColor.GetSelectEntryColor(),
									ATTR_ANIMATION_TRANSPCOLOR );
		pSet->Put( aColorItem );

		FillItemSet( *pSet );
	}

	return( LEAVE_PAGE );
}

// -----------------------------------------------------------------------

SfxTabPage* __EXPORT SdTPEffect::Create( Window* pWindow,
				const SfxItemSet& rAttrs )
{
	return( new SdTPEffect( pWindow, rAttrs ) );
}

//------------------------------------------------------------------------

USHORT* __EXPORT SdTPEffect::GetRanges()
{
	return( pEffectRanges );
}

//------------------------------------------------------------------------

IMPL_LINK( SdTPEffect, ClickAnimationHdl, void *, EMPTYARG )
{
	if( aTsbAnimation.GetState() == STATE_NOCHECK )
	{
		aLbEffect.Disable();
		aGrpEffect.Disable();
		aTsbFadeOut.Disable();
		aTsbInvisible.Disable();
		aLbColor.Disable();
		aGrpObjects.Disable();
		aRbtSlow.Disable();
		aRbtMedium.Disable();
		aRbtFast.Disable();
		aFtTranspColor.Disable();
		aLbTranspColor.Disable();
		aTsbSound.Disable();
	}
	else
	{
		aLbEffect.Enable();
		aGrpEffect.Enable();
		//aTsbFadeOut.Enable();
		//aTsbInvisible.Enable();
		//aLbColor.Enable();
		aGrpObjects.Enable();
		aTsbSound.Enable();
		ChangeEffectHdl( this );

		ClickFadeOutHdl( NULL );
	}
	ClickSoundHdl( NULL );

	return( 0L );
}

//------------------------------------------------------------------------

void SdTPEffect::OpenFileDialog()
{
	pFileDialog = new SfxSimpleFileDialog (
						this, WB_OPEN | WB_3DLOOK | WB_STDMODAL );

	pBtnPreview = new PushButton( pFileDialog, SdResId( RID_PREVIEW_BUTTON ) );
	pBtnPreview->SetClickHdl( LINK( this, SdTPAnimation, ClickPreviewHdl ) );
	pBtnPreview->Show();

#if defined MAC
	String aDescr1;
	aDescr1 = String(SdResId(STR_SOUNDFILE1));
	pFileDialog->AddFilter (aDescr1, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.snd" ) ), "sfil0");

	String aDescr2;
	aDescr2 = String(SdResId(STR_SOUNDFILE2));
	pFileDialog->AddFilter (aDescr2, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.aif" ) ), "AIFF0");

	pFileDialog->SetDefaultExt( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "snd" ) ) );
#elif defined UNX
   String aDescr;
   aDescr = String(SdResId(STR_AU_FILE));
   pFileDialog->AddFilter( aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.au;*.snd" ) ) );
   aDescr = String(SdResId(STR_VOC_FILE));
   pFileDialog->AddFilter( aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.voc" ) ) );
   aDescr = String(SdResId(STR_WAV_FILE));
   pFileDialog->AddFilter( aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.wav" ) ) );
   aDescr = String(SdResId(STR_AIFF_FILE));
   pFileDialog->AddFilter( aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.aiff" ) ) );
   aDescr = String(SdResId(STR_SVX_FILE));
   pFileDialog->AddFilter( aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.svx" ) ) );

   pFileDialog->SetDefaultExt( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "au" ) ) );
#else
	String aDescr;
	aDescr = String(SdResId(STR_WAV_FILE));
	pFileDialog->AddFilter (aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.wav" ) ) );
	aDescr = String(SdResId(STR_MIDI_FILE));
	pFileDialog->AddFilter (aDescr, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.mid" ) ) );

	pFileDialog->SetDefaultExt( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "wav" ) ) );
#endif

	String aFile( aEdtSound.GetText() );
	if( !aFile.Len() )
	{
		aFile = SFX_APP()->GetAppIniManager()->Get( SFX_KEY_GRAPHICS_PATH );
	}
	pFileDialog->SetPath( aFile );

	if ( pFileDialog->Execute() )
	{
		aFile = pFileDialog->GetPath();
		aEdtSound.SetText( aFile );
	}

	if( aSound.IsPlaying() )
		aSound.Stop();

	delete pBtnPreview; pBtnPreview = NULL;
	delete pFileDialog;
}

//------------------------------------------------------------------------

presentation::AnimationEffect SdTPEffect::GetActualAnimationEffect()
{
	presentation::AnimationEffect eAE = presentation::AnimationEffect_NONE;
	USHORT nPos = aLbEffect.GetSelectEntryPos();
	if (nPos != LISTBOX_ENTRY_NOTFOUND)
		eAE = (presentation::AnimationEffect)(ULONG)pCurrentEffects->GetObject((ULONG)nPos);
	return( eAE );
}

//------------------------------------------------------------------------

void SdTPEffect::SetActualAnimationEffect( presentation::AnimationEffect eAE )
{
	USHORT nPos = (USHORT)pCurrentEffects->GetPos((void*)(ULONG)eAE);
	DBG_ASSERT(nPos != LIST_ENTRY_NOTFOUND, "unbekannter Effekt");
	aLbEffect.SelectEntryPos(nPos);
}

//------------------------------------------------------------------------

USHORT SdTPEffect::GetAnimationEffectSdResId( presentation::AnimationEffect eAE )
{
	switch( eAE )
	{
		case presentation::AnimationEffect_NONE: 			return STR_EFFECT_NONE;
		case presentation::AnimationEffect_FADE_FROM_LEFT:	return STR_EFFECT_FADE_FROM_LEFT;
		case presentation::AnimationEffect_FADE_FROM_TOP:	return STR_EFFECT_FADE_FROM_TOP;
		case presentation::AnimationEffect_FADE_FROM_RIGHT:	return STR_EFFECT_FADE_FROM_RIGHT;
		case presentation::AnimationEffect_FADE_FROM_BOTTOM: return STR_EFFECT_FADE_FROM_BOTTOM;
		case presentation::AnimationEffect_FADE_TO_CENTER:	return STR_EFFECT_FADE_TO_CENTER;
		case presentation::AnimationEffect_FADE_FROM_CENTER: return STR_EFFECT_FADE_FROM_CENTER;
		case presentation::AnimationEffect_MOVE_FROM_LEFT:	  return STR_EFFECT_DISCARD_FROM_LEFT;
		case presentation::AnimationEffect_MOVE_FROM_TOP:	  return STR_EFFECT_DISCARD_FROM_TOP;
		case presentation::AnimationEffect_MOVE_FROM_RIGHT:	  return STR_EFFECT_DISCARD_FROM_RIGHT;
		case presentation::AnimationEffect_MOVE_FROM_BOTTOM:   return STR_EFFECT_DISCARD_FROM_BOTTOM;
		case presentation::AnimationEffect_VERTICAL_STRIPES: 	return STR_EFFECT_VERTICAL_STRIPES;
		case presentation::AnimationEffect_HORIZONTAL_STRIPES:	return STR_EFFECT_HORIZONTAL_STRIPES;
		case presentation::AnimationEffect_CLOCKWISE:			return STR_EFFECT_CLOCKWISE;
		case presentation::AnimationEffect_COUNTERCLOCKWISE: 	return STR_EFFECT_COUNTERCLOCKWISE;
		case presentation::AnimationEffect_FADE_FROM_UPPERLEFT:	return STR_EFFECT_FADE_FROM_UPPERLEFT;
		case presentation::AnimationEffect_FADE_FROM_UPPERRIGHT: return STR_EFFECT_FADE_FROM_UPPERRIGHT;
		case presentation::AnimationEffect_FADE_FROM_LOWERLEFT:	return STR_EFFECT_FADE_FROM_LOWERLEFT;
		case presentation::AnimationEffect_FADE_FROM_LOWERRIGHT: return STR_EFFECT_FADE_FROM_LOWERRIGHT;
		case presentation::AnimationEffect_CLOSE_VERTICAL:		return STR_EFFECT_CLOSE_VERTICAL;
		case presentation::AnimationEffect_CLOSE_HORIZONTAL: 	return STR_EFFECT_CLOSE_HORIZONTAL;
		case presentation::AnimationEffect_OPEN_VERTICAL:		return STR_EFFECT_OPEN_VERTICAL;
		case presentation::AnimationEffect_OPEN_HORIZONTAL:		return STR_EFFECT_OPEN_HORIZONTAL;
		case presentation::AnimationEffect_PATH: 			  return STR_EFFECT_PATH;
		case presentation::AnimationEffect_MOVE_TO_LEFT: 		return 0;
		case presentation::AnimationEffect_MOVE_TO_TOP:			return 0;
		case presentation::AnimationEffect_MOVE_TO_RIGHT:		return 0;
		case presentation::AnimationEffect_MOVE_TO_BOTTOM:		return 0;
		case presentation::AnimationEffect_SPIRALIN_LEFT:	return STR_EFFECT_SPIRALIN_LEFT;
		case presentation::AnimationEffect_SPIRALIN_RIGHT:	return STR_EFFECT_SPIRALIN_RIGHT;
		case presentation::AnimationEffect_SPIRALOUT_LEFT:	return STR_EFFECT_SPIRALOUT_LEFT;
		case presentation::AnimationEffect_SPIRALOUT_RIGHT:	return STR_EFFECT_SPIRALOUT_RIGHT;
		case presentation::AnimationEffect_DISSOLVE: 		return STR_EFFECT_DISSOLVE;
		case presentation::AnimationEffect_WAVYLINE_FROM_LEFT:	return STR_EFFECT_WAVYLINE_FROM_LEFT;
		case presentation::AnimationEffect_WAVYLINE_FROM_RIGHT:	return STR_EFFECT_WAVYLINE_FROM_RIGHT;
		case presentation::AnimationEffect_WAVYLINE_FROM_TOP:	return STR_EFFECT_WAVYLINE_FROM_TOP;
		case presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM: return STR_EFFECT_WAVYLINE_FROM_BOTTOM;
		case presentation::AnimationEffect_VERTICAL_LINES:		return STR_EFFECT_VERTICAL_LINES;
		case presentation::AnimationEffect_HORIZONTAL_LINES: 	return STR_EFFECT_HORIZONTAL_LINES;
		case presentation::AnimationEffect_RANDOM:				return STR_EFFECT_RANDOM;
		case presentation::AnimationEffect_LASER_FROM_LEFT:		 return STR_EFFECT_LASER_FROM_LEFT;
		case presentation::AnimationEffect_LASER_FROM_TOP:		 return STR_EFFECT_LASER_FROM_TOP;
		case presentation::AnimationEffect_LASER_FROM_RIGHT: 	 return STR_EFFECT_LASER_FROM_RIGHT;
		case presentation::AnimationEffect_LASER_FROM_BOTTOM:	 return STR_EFFECT_LASER_FROM_BOTTOM;
		case presentation::AnimationEffect_LASER_FROM_UPPERLEFT:  return STR_EFFECT_LASER_FROM_UPPERLEFT;
		case presentation::AnimationEffect_LASER_FROM_UPPERRIGHT: return STR_EFFECT_LASER_FROM_UPPERRIGHT;
		case presentation::AnimationEffect_LASER_FROM_LOWERLEFT:  return STR_EFFECT_LASER_FROM_LOWERLEFT;
		case presentation::AnimationEffect_LASER_FROM_LOWERRIGHT: return STR_EFFECT_LASER_FROM_LOWERRIGHT;
		case presentation::AnimationEffect_APPEAR:				 return STR_EFFECT_APPEAR;
		default: DBG_ERROR( "Keine StringResource fuer AnimationEffect vorhanden!" );
	}
	return( 0 );
}


