/*************************************************************************
 *
 *  $RCSfile: tpscale.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SFXMODULE_HXX //autogen
#include <sfx2/module.hxx>
#endif
#include <svx/svxids.hrc>
#include <sfx2/app.hxx>
#include <svx/dlgutil.hxx>
#ifndef _SFX_SAVEOPT_HXX //autogen
#include <sfx2/saveopt.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#include "sdattr.hxx"
#include "sdresid.hxx"
#include "strings.hrc"
#include "tpscale.hrc"
#include "tpscale.hxx"


#define TOKEN (sal_Unicode(':'))
#define TABLE_COUNT 12


/*************************************************************************
|*
|*	TabPage zum Einstellen des Massstabs
|*
\************************************************************************/

SdTpScale::SdTpScale( Window* pParent, const SfxItemSet& rInAttrs  ) :
		SfxTabPage          ( pParent, SdResId( TP_SCALE ), rInAttrs ),
		aCbScale                ( this, SdResId( CB_SCALE ) ),
		aFtPageWidth            ( this, SdResId( FT_PAGEWIDTH ) ),
		aFiInfo1                ( this, SdResId( FI_INFO_1 ) ),
		aFtPageHeight           ( this, SdResId( FT_PAGEHEIGHT ) ),
		aFiInfo2                ( this, SdResId( FI_INFO_2 ) ),
		aFtOriginalWidth        ( this, SdResId( FT_ORIGINAL_WIDTH ) ),
		aMtrFldOriginalWidth    ( this, SdResId( MTR_FLD_ORIGINAL_WIDTH ) ),
		aFtOriginalHeight       ( this, SdResId( FT_ORIGINAL_HEIGHT ) ),
		aMtrFldOriginalHeight   ( this, SdResId( MTR_FLD_ORIGINAL_HEIGHT ) ),
		aGrpScale               ( this, SdResId( GRP_SCALE ) ),
		rOutAttrs				( rInAttrs ),
		aMtrFldInfo1			( this, WinBits( WB_HIDE ) ),
		aMtrFldInfo2			( this, WinBits( WB_HIDE ) )
{
	FreeResource();

	SetExchangeSupport();

	// Metrik einstellen
	FieldUnit eFUnit;// = SFX_APP()->GetOptions().GetMetric();
	GET_MODULE_FIELDUNIT( eFUnit );

	SetFieldUnit( aMtrFldOriginalWidth, eFUnit );
	SetFieldUnit( aMtrFldOriginalHeight, eFUnit );
	aMtrFldOriginalWidth.SetLast( 999999999 );
	aMtrFldOriginalWidth.SetMax( 999999999 );
	aMtrFldOriginalHeight.SetLast( 999999999 );
	aMtrFldOriginalHeight.SetMax( 999999999 );

	// Temporaere Fields fuer Info-Texte (fuer Formatierung/Berechnung)
	aMtrFldInfo1.SetUnit( eFUnit );
	aMtrFldInfo1.SetMax( 999999999 );
	aMtrFldInfo1.SetDecimalDigits( 2 );
	aMtrFldInfo2.SetUnit( eFUnit );
	aMtrFldInfo2.SetMax( 999999999 );
	aMtrFldInfo2.SetDecimalDigits( 2 );

	// PoolUnit ermitteln
	SfxItemPool* pPool = rOutAttrs.GetPool();
	DBG_ASSERT( pPool, "Wo ist der Pool?" );
	ePoolUnit = pPool->GetMetric( SID_ATTR_FILL_HATCH );

	// Fuellen der CB
	USHORT aTable[ TABLE_COUNT ] =
		{ 1, 2, 4, 5, 8, 10, 16, 20, 30, 40, 50, 100 };

	for( int i = 0; i < TABLE_COUNT; i++ )
		aCbScale.InsertEntry( GetScale( 1, aTable[i] ) );
	for( i = 1; i < TABLE_COUNT; i++ )
		aCbScale.InsertEntry( GetScale(  aTable[i], 1 ) );
}

// -----------------------------------------------------------------------

SdTpScale::~SdTpScale()
{
}

// -----------------------------------------------------------------------

BOOL SdTpScale::FillItemSet( SfxItemSet& rAttrs )
{
	BOOL bModified = FALSE;
	INT32 nX, nY;

	if( SetScale( aCbScale.GetText(), nX, nY ) )
	{
		rAttrs.Put( SfxInt32Item( ATTR_OPTIONS_SCALE_X, nX ) );
		rAttrs.Put( SfxInt32Item( ATTR_OPTIONS_SCALE_Y, nY ) );

		bModified = TRUE;
	}
	return( bModified );
}

// -----------------------------------------------------------------------

void __EXPORT SdTpScale::Reset( const SfxItemSet& rAttrs )
{
	INT32 nX = ( (const SfxInt32Item&) rAttrs.
				 Get( ATTR_OPTIONS_SCALE_X ) ).GetValue();
	INT32 nY = ( (const SfxInt32Item&) rAttrs.
				 Get( ATTR_OPTIONS_SCALE_Y ) ).GetValue();
	nWidth = ( (const SfxUInt32Item&) rAttrs.
					Get( ATTR_OPTIONS_SCALE_WIDTH ) ).GetValue();
	nHeight = ( (const SfxUInt32Item&) rAttrs.
					Get( ATTR_OPTIONS_SCALE_HEIGHT ) ).GetValue();

	aCbScale.SetText( GetScale( nX, nY ) );

	if( nWidth == 0 || nHeight == 0 )
	{
		aFtOriginalWidth.Disable();
		aMtrFldOriginalWidth.Disable();
		aMtrFldOriginalWidth.SetText( aInfo1 ); // leer
		aFtOriginalHeight.Disable();
		aMtrFldOriginalHeight.Disable();
		aMtrFldOriginalHeight.SetText( aInfo2 ); //leer
		aFtPageWidth.Hide();
		aFtPageHeight.Hide();
	}
	else
	{
		// Links setzen
		aCbScale.SetModifyHdl( LINK( this, SdTpScale, ModifyScaleHdl ) );
		aCbScale.SetSelectHdl( LINK( this, SdTpScale, ModifyScaleHdl ) );
		aMtrFldOriginalWidth.SetModifyHdl( LINK( this, SdTpScale, ModifyOriginalScaleHdl ) );
		aMtrFldOriginalHeight.SetModifyHdl( LINK( this, SdTpScale, ModifyOriginalScaleHdl ) );

		// Hier werden die MetricFields zur Hilfe genommen, um
		// die Seiteninformation richtig auszugeben.
		// Die MetricFields werden erst im ModifyScaleHdl() richtig gesetzt.
		SetMetricValue( aMtrFldInfo1, nWidth, ePoolUnit );
		aInfo1 = aMtrFldInfo1.GetText();
		SetMetricValue( aMtrFldInfo2, nHeight, ePoolUnit );
		aInfo2 = aMtrFldInfo2.GetText();

		aFiInfo1.SetText( aInfo1 );
		aFiInfo2.SetText( aInfo2 );

		ModifyScaleHdl( NULL );
	}
}

// -----------------------------------------------------------------------

SfxTabPage* __EXPORT SdTpScale::Create( Window* pWindow,
				const SfxItemSet& rAttrs )
{
	return( new SdTpScale( pWindow, rAttrs ) );
}

// -----------------------------------------------------------------------

void SdTpScale::ActivatePage( const SfxItemSet& rSet )
{
	// Metrik ggfs. aendern (da TabPage im Dialog liegt,
	// wo die Metrik eingestellt werden kann
	const SfxPoolItem* pAttr = NULL;
	if( SFX_ITEM_SET == rSet.GetItemState( SID_ATTR_METRIC , FALSE,
									(const SfxPoolItem**)&pAttr ))
	{
		const SfxUInt16Item* pItem = (SfxUInt16Item*) pAttr;

		FieldUnit eFUnit = (FieldUnit)(long)pItem->GetValue();

		if( eFUnit != aMtrFldOriginalWidth.GetUnit() )
		{
			// Metriken einstellen
			long nVal = aMtrFldOriginalWidth.Denormalize( aMtrFldOriginalWidth.GetValue( FUNIT_TWIP ) );
			SetFieldUnit( aMtrFldOriginalWidth, eFUnit, TRUE );
			aMtrFldOriginalWidth.SetValue( aMtrFldOriginalWidth.Normalize( nVal ), FUNIT_TWIP );

			nVal = aMtrFldOriginalHeight.Denormalize( aMtrFldOriginalHeight.GetValue( FUNIT_TWIP ) );
			SetFieldUnit( aMtrFldOriginalHeight, eFUnit, TRUE );
			aMtrFldOriginalHeight.SetValue( aMtrFldOriginalHeight.Normalize( nVal ), FUNIT_TWIP );


			if( nWidth != 0 && nHeight != 0 )
			{
				aMtrFldInfo1.SetUnit( eFUnit );
				aMtrFldInfo2.SetUnit( eFUnit );

				SetMetricValue( aMtrFldInfo1, nWidth, ePoolUnit );
				aInfo1 = aMtrFldInfo1.GetText();
				aFiInfo1.SetText( aInfo1 );

				SetMetricValue( aMtrFldInfo2, nHeight, ePoolUnit );
				aInfo2 = aMtrFldInfo2.GetText();
				aFiInfo2.SetText( aInfo2 );
			}
		}
	}
}

// -----------------------------------------------------------------------

int SdTpScale::DeactivatePage( SfxItemSet* pSet )
{
	// Parsercheck
	INT32 nX, nY;
	if( SetScale( aCbScale.GetText(), nX, nY ) )
	{
		FillItemSet( *pSet );
		return( LEAVE_PAGE );
	}

	WarningBox aWarnBox( GetParent(), WB_YES_NO, String( SdResId( STR_WARN_SCALE_FAIL ) ) );
	short nReturn = aWarnBox.Execute();

	if( nReturn == RET_YES )
		return( KEEP_PAGE );

	FillItemSet( *pSet );

	return( LEAVE_PAGE );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdTpScale, ModifyScaleHdl, void *, p )
{
	// Originalgroesse berechnen
	INT32 nX, nY;
	if( SetScale( aCbScale.GetText(), nX, nY ) )
	{
		INT32 nW = nWidth * nY / nX;
		INT32 nH = nHeight * nY / nX;

		SetMetricValue( aMtrFldOriginalWidth, nW, ePoolUnit );
		SetMetricValue( aMtrFldOriginalHeight, nH, ePoolUnit );
	}

	return( 0L );
}

// -----------------------------------------------------------------------

IMPL_LINK( SdTpScale, ModifyOriginalScaleHdl, void *, p )
{
	// Berechnen des Massstabs
	long nOrgW = aMtrFldOriginalWidth.GetValue();
	long nOrgH = aMtrFldOriginalHeight.GetValue();

	if( nOrgW == 0 || nOrgH == 0 )
		return( 0L );

	Fraction aFract1( nOrgW, aMtrFldInfo1.GetValue() );
	Fraction aFract2( nOrgH, aMtrFldInfo2.GetValue() );
	Fraction aFract( aFract1 > aFract2 ? aFract1 : aFract2 );

	long nValue;
	if( aFract < Fraction( 1, 1 ) )
	{
		// Fraction umdrehen
		aFract1 = aFract;
		aFract = Fraction( aFract1.GetDenominator(), aFract1.GetNumerator() );
		nValue = aFract;
		aCbScale.SetText( GetScale( 1, nValue ) );
	}
	else
	{
		double fValue = aFract;
		nValue = aFract;
		if( fValue > (double)nValue )
			nValue++;
		aCbScale.SetText( GetScale( nValue, 1 ) );
	}
	return( 0L );
}

// -----------------------------------------------------------------------

String SdTpScale::GetScale( INT32 nX, INT32 nY )
{
	String aScale( UniString::CreateFromInt32( nX ) );
	aScale.Append( TOKEN );
	aScale.Append( UniString::CreateFromInt32( nY ) );

	return( aScale );
}

// -----------------------------------------------------------------------

BOOL SdTpScale::SetScale( const String& aScale, INT32& rX, INT32& rY )
{
	if( aScale.GetTokenCount( TOKEN ) != 2 )
		return( FALSE );

	ByteString aTmp( aScale.GetToken( 0, TOKEN ), RTL_TEXTENCODING_ASCII_US );
	if( !aTmp.IsNumericAscii() )
		return( FALSE );

	rX = (long) aTmp.ToInt32();
	if( rX == 0 )
		return( FALSE );

	aTmp = ByteString( aScale.GetToken( 1, TOKEN ), RTL_TEXTENCODING_ASCII_US );
	if( !aTmp.IsNumericAscii() )
		return( FALSE );

	rY = (long) aTmp.ToInt32();
	if( rY == 0 )
		return( FALSE );

	return( TRUE );
}



