/*************************************************************************
 *
 *  $RCSfile: fupngdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONHANDLER_HPP_
#include <com/sun/star/task/XInteractionHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XARCHIVER_HPP_
#include <com/sun/star/util/XArchiver.hpp>
#endif

/*
#ifndef UUI_IAHNDL_HXX
#include <chaos/iahndl.hxx>
#endif
*/

#ifndef _TOOLS_TEMPFILE_HXX
#include <tools/tempfile.hxx>
#endif
#ifndef __RSC //autogen
#include <tools/errinf.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFXDISPATCH_HXX
#include <sfx2/dispatch.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFXFILEDLG_HXX //autogen wg. SfxFileDialog
#include <sfx2/iodlg.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SVXLINKMGR_HXX //autogen wg. SvxLinkManager
#include <svx/linkmgr.hxx>
#endif
#ifndef _LNKBASE_HXX //autogen wg. SvBaseLink
#include <so3/lnkbase.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen wg. INetURLObject
#include <tools/urlobj.hxx>
#endif
#ifndef _ZCODEC_HXX //autogen wg. ZCodec
#include <tools/zcodec.hxx>
#endif
#ifndef _STREAM_HXX //autogen wg. SvFileStream
#include <tools/stream.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen wg. ErrorBox
#include <vcl/msgbox.hxx>
#endif
#ifndef _SD_ANMINFO_HXX
#include <anminfo.hxx>
#endif

#include <unotools/processfactory.hxx>

#ifndef _SVDETC_HXX
#include <svx/svdetc.hxx>
#endif

#include <sdpage.hxx>
#include "fupngdlg.hxx"
#include "sdattr.hxx"
#include "sdresid.hxx"
#include "strings.hrc"
#include "viewshel.hxx"
#include "docshell.hxx"

using namespace ::rtl;
using namespace ::vos;
using namespace ::com::sun::star;

// local ErrorCode
#define LOCAL_ERRCODE_CANCEL	-1000
#define LOCAL_ERRCODE_RETRY		-1001

#define ITEMVALUE(ItemSet,Id,Cast) ((const Cast&)(ItemSet)->Get(Id)).GetValue()

struct ImplCastSvBaseLink : public SvAdviseSink
{
	void CallClosed () {Closed();}
};


/*************************************************************************
|*
|* Help-method to put and find filename in array
|*
\************************************************************************/

void FuPackNGoDlg::AddFilename( String aStrFilename )
{
	INetURLObject aFilename( aStrFilename, INET_PROT_FILE, INetURLObject::WAS_ENCODED, RTL_TEXTENCODING_UTF8 );
	maFilenameList.Insert( new String( aFilename.getFSysPath( INetURLObject::FSYS_VOS ) ), CONTAINER_APPEND );
}

BOOL FuPackNGoDlg::FilenameInArry ( String aStrFilename )
{
	for( String* pFileName = maFilenameList.First() ; pFileName; pFileName = maFilenameList.Next() )
		if (aStrFilename == *pFileName)
			return TRUE;

	return FALSE;
}

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

FuPackNGoDlg::FuPackNGoDlg ( SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
							 SdDrawDocument* pDoc, SfxRequest& rReq)
	: FuPoor( pViewSh, pWin, pView, pDoc, rReq )
{
	// get old doc-status
	bChangesInOrgDoc = pDoc->IsChanged();

	// Create empty ItemSet
	mpItemSet = new SfxItemSet( pDoc->GetPool(), ATTR_PACKNGO_START,
												 ATTR_PACKNGO_END );
}

 FuPackNGoDlg::~FuPackNGoDlg()
 {
	delete mpItemSet;

	for( String* pFileName = maFilenameList.First() ; pFileName; pFileName = maFilenameList.Next() )
		delete pFileName;
 }


/*************************************************************************
|*
|* start Pack & Go
|*
\************************************************************************/

void FuPackNGoDlg::DoExecute ()
{
	BOOL bSaveSuccess=FALSE;

	// Reset errors
	mnLastErrorCode = ERRCODE_NONE;

	///////////////////////////////////////////////////////////////////////////
	// Don't swap ole2-objects, so i have to resize the
	// appropriate container ( no other interface available )
	ULONG nOldOLEContainerSize = GetSdrGlobalData().GetOLEObjCache().GetSize();
	GetSdrGlobalData().GetOLEObjCache().SetSize( ULONG_MAX );

	// add Document-Name to List
	String aStrOrgFilename ( pDoc->GetDocSh()->GetTitle() );
	if( aStrOrgFilename.SearchBackward( sal_Unicode('.') ) == STRING_NOTFOUND )
		aStrOrgFilename.AppendAscii( ".sdd" );

	///////////////////////////////////////////////////////////////////////////
	// Set defaultvalues at ItemSet
	mpItemSet->Put( SfxBoolItem( ATTR_PACKNGO_UNLINK  , FALSE ) );
	mpItemSet->Put( SfxBoolItem( ATTR_PACKNGO_COMPRESS, TRUE ) );
	mpItemSet->Put( SfxBoolItem( ATTR_PACKNGO_SPANNING, TRUE ) );
	mpItemSet->Put( SfxUInt32Item( ATTR_PACKNGO_MEDIUMSIZE, nStoreSize[STMED_DEFAULT] ) );

	///////////////////////////////////////////////////////////////////////////
	// Create and start dialog
	SdPackNGoDlg aDlg((Window*)pWindow, mpItemSet);

	if( aDlg.Execute() == RET_OK )
	{
		// Open filedialog (where to save?)
		SfxFileDialog aFileDlg ( (Window *)pWindow, SFXWB_INSERT |
								WB_3DLOOK | WB_STDMODAL | WB_SAVEAS );
		String aStrTitle( SdResId(STR_PACKNGO_FILEDLG_TITLE) );
		String aStrFilter( SdResId(STR_PACKNGO_FILTER) );
		aFileDlg.SetText( aStrTitle );
		aFileDlg.AddFilter( aStrFilter, UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sdp" ) ) );
		aFileDlg.SetCurFilter( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sdp" ) ) );
		aFileDlg.SetDefaultExt( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.sdp" ) ) );

		if (aFileDlg.Execute() == RET_OK)
		{
			// Waitcursor on
			pDocSh->SetWaitCursor( TRUE );

			// Get ItemSet from dialog
			aDlg.GetAttr( mpItemSet );

			///////////////////////////////////////////////////////////////////
			// save 1st temporar document
			//

			// get temp. filename for 1. temporar document
			TempFile aTmpFile1;
			aTmpFile1.EnableKillingFile();
			String aStrTmpFilename = aTmpFile1.GetName();

			// don't swap embedded graphics while pack&go
			const ULONG nOldSwapMode = pDoc->GetSwapGraphicsMode();
			pDoc->SetSwapGraphicsMode( SDR_SWAPGRAPHICSMODE_PURGE );

			// save
			bSaveSuccess = SaveDoc (pDoc, aStrTmpFilename);

			// now, please swap embedded graphics again
			pDoc->SetSwapGraphicsMode( nOldSwapMode );

			//
			///////////////////////////////////////////////////////////////////

			if (bSaveSuccess)
			{
				// Load tmp-document to work with it
				SfxStringItem aFile( SID_FILE_NAME, aStrTmpFilename );
				SfxStringItem aReferer( SID_REFERER, String() );
				SfxBoolItem aView( SID_VIEW, FALSE );

				SfxObjectShellItem* pTmpDocItem = (SfxObjectShellItem*)	SFX_DISPATCHER().Execute(
												  SID_OPENDOC, SFX_CALLMODE_SYNCHRON,
												  &aFile, &aReferer, &aView, 0L );

				// Load the doc successfull ?
				if( pTmpDocItem && pTmpDocItem->GetObjectShell() )
				{
					SdDrawDocShell *pTmpDocShell = (SdDrawDocShell *) pTmpDocItem->GetObjectShell();
					SdDrawDocument* pTmpDoc = (SdDrawDocument *) ( ( ( SdDrawDocShell *)
											  pTmpDocItem->GetObjectShell () )->GetDoc() );

					// don't swap embedded graphics at the temp. document
					pTmpDoc->SetSwapGraphicsMode( SDR_SWAPGRAPHICSMODE_PURGE );

					///////////////////////////////////////////////////////////
					// modify temporar document for pack&go
					//

					// resolve/bend links
					if ( ITEMVALUE( mpItemSet, ATTR_PACKNGO_UNLINK, SfxBoolItem) )
					{
						// resolve links
						RemoveLinks (pTmpDoc);
					}
					else
					{
						// bend links
						BendLinks (pTmpDoc);
					}

					// bend all sounds
					BendSounds(pTmpDoc);

					// save preview of ole-objects
					pTmpDoc->SetSaveOLEPreview ( FASTBOOL(TRUE) );

					//
					///////////////////////////////////////////////////////////

					///////////////////////////////////////////////////////////
					// save 2. tmp document (modified for pack&go)
					//

					// get temp. filename
					TempFile aTmpOrgFile( NULL, sal_True ); // create a temp dir
					aTmpOrgFile.EnableKillingFile();
					{
						INetURLObject aURL; aURL.SetSmartProtocol( INET_PROT_FILE ); aURL.SetSmartURL( aTmpOrgFile.GetName() );
						aURL.Append( aStrOrgFilename );
						aStrTmpFilename = aURL.GetMainURL();
					}

					// save temp. doc. rehandle
					bSaveSuccess = SaveDoc ( pTmpDocShell, aStrTmpFilename );

					//
					///////////////////////////////////////////////////////////

					// generate extra data from temp doc filter name
					String aExtraData = UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "private:" ) );
					aExtraData.Append( aStrOrgFilename );
					aExtraData.Append( sal_Unicode('?') );
  					if( pTmpDocShell && pTmpDocShell->GetMedium() && pTmpDocShell->GetMedium()->GetFilter() )
						aExtraData += pTmpDocShell->GetMedium()->GetFilter()->GetName();

					// delete 1. temporary document
//                    pTmpDocShell->DoHandsOff();
                    pTmpDocShell->DoClose();

					// last save successfull ( if not, the modified doc doesn't exist)
					if (bSaveSuccess)
					{
						// pack ( & compress) files
						AddFilename (aStrTmpFilename);

						// Save document as pack&go-doc
						WritePackNGoFile (aFileDlg.GetPath(),
										  aExtraData,
										  ITEMVALUE( mpItemSet, ATTR_PACKNGO_COMPRESS, SfxBoolItem),
										  ITEMVALUE( mpItemSet, ATTR_PACKNGO_SPANNING, SfxBoolItem),
										  /*nStoreSize [*/ITEMVALUE( mpItemSet, ATTR_PACKNGO_MEDIUMSIZE, SfxUInt32Item)/*]*/ );
					}
				}
			}

			// any errors ?
			if (mnLastErrorCode != ERRCODE_NONE && mnLastErrorCode != LOCAL_ERRCODE_CANCEL)
				ErrorHandler::HandleError(mnLastErrorCode);

			// Waitcursor off
			pDocSh->SetWaitCursor( FALSE );
		}
	}

	// set old doc-status
	pDoc->SetChanged(bChangesInOrgDoc);

	// now, please swap ole-objects again
	ULONG nCurrentOLEContainerSize = GetSdrGlobalData().GetOLEObjCache().Count();
	GetSdrGlobalData().GetOLEObjCache().SetSize( nOldOLEContainerSize<nCurrentOLEContainerSize?
                                                 nCurrentOLEContainerSize+1 :
	                                             nOldOLEContainerSize+1 );
}

/*************************************************************************
|*
|* resolve links in the doc
|*
\************************************************************************/

void FuPackNGoDlg::RemoveLinks (SdDrawDocument *pDocument)
{
	// resolve links
	SvxLinkManager* pLinkManager = pDocument->GetLinkManager();
	if (pLinkManager)
	{
		// release BaseLinks
		for ( USHORT n = pLinkManager->GetLinks().Count(); n; )
		{
			SvBaseLinkRef rLinkObj (*pLinkManager->GetLinks()[--n]);
			if ( rLinkObj.Is() )
			{
				SvData aData( rLinkObj->GetContentType() );
				aData.SetAspect( ASPECT_DOCPRINT );
				SvPseudoObject* pObj = rLinkObj->GetObj();
				pObj->GetData( &aData );

				((ImplCastSvBaseLink *)&rLinkObj)->CallClosed();
			}
		}

		if ( pLinkManager->GetLinks().Count() )
		{
			pLinkManager->Remove( 0, pLinkManager->GetLinks().Count() );
		}
	}
}

/*************************************************************************
|*
|* transform pathes of links to relativ path (the same path as the doc)
|*
\************************************************************************/

void FuPackNGoDlg::BendLinks(SdDrawDocument *pDocument)
{
	// bend all links
	SvxLinkManager* pLinkManager = pDocument->GetLinkManager();
	if (pLinkManager)
	{
		// for each link-obj.
		for ( USHORT n = pLinkManager->GetLinks().Count(); n; )
		{
			SvBaseLinkRef rLinkObj (*pLinkManager->GetLinks()[--n]);

			// get path of link-obj.
			String aStrTypeName, aStrFilename, aStrLinkName, aStrFilter;
			pLinkManager->GetDisplayNames (*rLinkObj, &aStrTypeName, &aStrFilename,
										   &aStrLinkName, &aStrFilter);
			if ( !FilenameInArry( aStrFilename ) )
				AddFilename( aStrFilename );

			// set new path
			INetURLObject aURL; aURL.SetSmartURL( aStrFilename );
			String aStrNewPath ( aURL.getName( INetURLObject::LAST_SEGMENT, TRUE, INetURLObject::DECODE_UNAMBIGUOUS ) );
			INetURLObject aUrl(aStrNewPath);
			aUrl.SetSmartProtocol (INET_PROT_FILE);
			aUrl.SetURL (aStrNewPath);

			String aStrNewLinkName;
			::MakeLnkName( aStrNewLinkName, 0, aUrl.GetName(), aStrLinkName,
						   &aStrFilter);
			SvLinkNameRef rLinkName = new SvLinkName(aStrNewLinkName);
			rLinkObj->SetLinkSourceName( &rLinkName );
			rLinkObj->Update();
		}

		if( pLinkManager->GetCacheContainer() )
			pLinkManager->GetCacheContainer()->SetModified();
	}
}

/*************************************************************************
|*
|* transform pathes of sounds to relativ path and add sound to file list
|*
\************************************************************************/

void FuPackNGoDlg::BendSounds(SdDrawDocument *pDocument)
{
	const USHORT nPageCnt = pDoc->GetSdPageCount(PK_STANDARD);
	for (USHORT nPage = 0; nPage < nPageCnt; nPage++)
	{
		SdPage* pPage = pDoc->GetSdPage(nPage, PK_STANDARD);
		DBG_ASSERT( pPage, "FATAL: NULL in page list!" );
		if(pPage == NULL)
			break;

		const ULONG nObjCnt = pPage->GetObjCount();
		for ( ULONG nObj = 0; nObj < nObjCnt; nObj++ )
		{
			SdrObject* pObj = pPage->GetObj( nObj );
			SdAnimationInfo* pInfo = pDoc->GetAnimationInfo(pObj);
			if( pInfo != NULL && pInfo->aSoundFile.Len() != 0 )
			{
				INetURLObject aURL;

				aURL.SetSmartURL( pInfo->aSoundFile );
				pInfo->aSoundFile = aURL.getName( INetURLObject::LAST_SEGMENT, TRUE, INetURLObject::DECODE_UNAMBIGUOUS );

				if ( !FilenameInArry( pInfo->aSoundFile ) )
				{
					AddFilename ( pInfo->aSoundFile );
				}
			}
		}
	}
}

/*************************************************************************
|*
|* Save Document
|*
\************************************************************************/

BOOL FuPackNGoDlg::SaveDoc (SdDrawDocument* pDocument, String aStrFilename)
{
	//////////////////////////////////////////////////////////////////////////
	// Because I save the file temporary, it's ok to use the first filter
	// of the factory, instead of the document-specific filter
	// ( #71387 )
	SfxFilter* pFilter = ( SfxFilter* )SdDrawDocShell::Factory().GetFilter(0);
	String aFilterName;
	if(pFilter)
		aFilterName = pFilter->GetName();

	SfxStringItem aFilter( SID_FILTER_NAME, aFilterName );
	SfxStringItem aFileName( SID_FILE_NAME, aStrFilename );
	SfxBoolItem aPicklist( SID_PICKLIST, FALSE );
	SfxBoolItem aSaveTo( SID_SAVETO, TRUE );
	SfxStringItem aFilterOptions( SID_FILE_FILTEROPTIONS,
		                          UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "9,34,SYSTEM" ) ) );

	SdViewShell* pViewShell = pDocument->GetDocSh()->GetViewShell();
	SfxBoolItem *pRet;
	if ( pViewShell)
	{
		pRet = (SfxBoolItem*)pViewShell->GetViewFrame()->GetDispatcher()->
				Execute( SID_SAVEASDOC, SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_API,
				&aFilter, &aFileName, &aSaveTo, &aPicklist, &aFilterOptions, 0L );
	}

	DBG_ASSERT  (pViewShell, "FuPackNGoDlg::SaveDoc : Document has no ViewShell !");

	if (!pRet->GetValue() )
		mnLastErrorCode = ERRCODE_IO_GENERAL;

	return pRet->GetValue();
}

BOOL FuPackNGoDlg::SaveDoc (SdDrawDocShell* pDocumentShell, String aStrFilename)
{
	BOOL bSaved=FALSE;

	// get filter
	SfxFilterMatcher& rMatcher = SFX_APP()->GetFilterMatcher();
	SfxFilterContainer *pImpr = rMatcher.GetContainer( UniString::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "simpress" ) ) );

	SvStorage* pStorage = pDocumentShell->GetMedium()->GetStorage();
	ULONG nStorFmt = pStorage->GetFormat();

	const SfxFilter* pFilter = pImpr->GetFilter4ClipBoardId( nStorFmt );
	if(pFilter == NULL)
		pFilter = SdDrawDocShell::Factory().GetFilter(0);

	// create medium
	SfxMedium *pMed = new SfxMedium(aStrFilename, STREAM_READWRITE |
									STREAM_SHARE_DENYWRITE,	sal_False, sal_True, pFilter );
	// save
	bSaved = pDocumentShell->DoSaveAs( *pMed );
	if ( bSaved )
	{
		bSaved = pDocumentShell->DoSaveCompleted( pMed );
	}
	else
	{
		delete pMed;
		mnLastErrorCode = ERRCODE_IO_GENERAL;
	}

	return bSaved;
}

/*************************************************************************
|*
|* write pack & go - file
|*
\************************************************************************/

ULONG FuPackNGoDlg::WritePackNGoFile( String aStrDest, String aExtraData,
									  BOOL bCompressed, BOOL bChunked,
									  ULONG nChunkSize)
{
	uno::Reference< lang::XMultiServiceFactory > xSMgr( ::utl::getProcessServiceFactory() );
	if( !xSMgr.is() )
		return ERRCODE_ABORT;

	uno::Reference< util::XArchiver > xPacker( xSMgr->createInstance( OUString::createFromAscii( "com.sun.star.util.Archiver" ) ), uno::UNO_QUERY );
	if( xPacker.is() )
	{
		const ULONG nCount = maFilenameList.Count();
		uno::Sequence< OUString > input(nCount);
		OUString* pFiles = input.getArray();

		ULONG nIndex = 0;
		for( String* pFileName = maFilenameList.First(); pFileName && nIndex < nCount; pFileName = maFilenameList.Next() )
			pFiles[nIndex++] = OUString( *pFileName );

		uno::Sequence<beans::PropertyValue> aArgs(bChunked?3:2);
//		aArgs.getArray()[0].Name = L"InteractionHandler";
//		aArgs.getArray()[0].Value <<= xHandler;
		aArgs.getArray()[0].Name = OUString::createFromAscii( "Compression" );
		aArgs.getArray()[0].Value <<= (sal_Int16) ( bCompressed ? 1 : 0 );
		aArgs.getArray()[1].Name = OUString::createFromAscii( "ExtraData" );
		aArgs.getArray()[1].Value <<= OUString( aExtraData );
		if( bChunked )
		{
			aArgs.getArray()[2].Name = OUString::createFromAscii( "VolumeSize" );
			aArgs.getArray()[2].Value <<= (sal_Int32)( nChunkSize / 1024 );
		}

		if(xPacker->pack( input, aStrDest, aArgs ) )
			return ERRCODE_NONE;
	}
	return ERRCODE_ABORT;
}

