/*************************************************************************
 *
 *  $RCSfile: design3d.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SVX_3DFLOAT_HXX
#define _SVX_3DFLOAT_HXX

#ifndef _SVX_DLGCTL3D_HXX //autogen
#include <svx/dlgctl3d.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <sfx2/ctrlitem.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SVX_DLG_CTRL_HXX //autogen
#include <svx/dlgctrl.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX //autogen
#include <sfx2/dockwin.hxx>
#endif
#ifndef _IMAGEBTN_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif

// Basiert z.Z. noch auf's Draw
#ifndef _SD_SDRESID_HXX
#include "sdresid.hxx"
#endif

// Basiert z.Z. noch auf's Draw
//#ifndef _SVX_3DCHLD_HXX
#include "3dchld.hxx"
//#endif

enum ViewType3D
{
	VIEWTYPE_FAVORITES = 1,
	VIEWTYPE_GEO,
	VIEWTYPE_REPRESENTATION,
	VIEWTYPE_LIGHT,
	VIEWTYPE_TEXTURE,
	VIEWTYPE_MATERIAL
};

class SdrModel;

//------------------------------------------------------------------------

class Sd3DWin : public SfxDockingWindow
{
 friend class Sd3DChildWindow;
 friend class Sd3DCtrlItem;

private:
	PushButton			aBtnFavorites;
	PushButton			aBtnGeo;
	PushButton			aBtnRepresentation;
	PushButton			aBtnLight;
	PushButton			aBtnTexture;
	PushButton			aBtnMaterial;
	ImageButton			aBtnUpdate;
	ImageButton			aBtnAssign;

// Favoriten
	ValueSet			aCtlFavorites;
	GroupBox			aGrpFavorites;

// Geometrie
	FixedText			aFtHorizontal;
	NumericField		aNumHorizontal;
	FixedText			aFtVertical;
	NumericField		aNumVertical;
	GroupBox			aGrpSegments;
	FixedText			aFtPercentDiagonal;
	MetricField			aMtrPercentDiagonal;
	FixedText			aFtBackscale;
	MetricField			aMtrBackscale;
	FixedText			aFtEndAngle;
	MetricField			aMtrEndAngle;
	GroupBox			aGrpGeometrie;

// Favoriten
	ValueSet			aCtlMaterial;
	GroupBox			aGrpMaterial;

// Unterer Teil
	PushButton			aBtnConvertTo3D;
	PushButton			aBtnLatheObject;
	PushButton			aBtnPerspective;
	SvxRectCtl3D		aCtlPreview; // Hier kommt noch Armins Preview-Control
	GroupBox			aGrpPreview;

	BOOL				bUpdate;
	ViewType3D			eViewType;
	Size				aSize;

	SfxBindings*		pBindings;
	Sd3DCtrlItem*		pControllerItem;

	SfxItemPool*		pPool;
	SfxMapUnit          ePoolUnit;
	FieldUnit           eFUnit;

	//------------------------------------

	DECL_LINK( ClickViewTypeHdl, void * );
	DECL_LINK( ClickUpdateHdl, void * );
	DECL_LINK( ClickAssignHdl, void * );
	DECL_LINK( ClickHdl, PushButton * ); // Bald ImageButton !!!


	void			Construct();
	void			Reset();

protected:
	virtual void	Resize();

public:
			Sd3DWin( SfxBindings* pBindings, SfxChildWindow *pCW,
						Window* pParent, const SdResId& rSdResId );
			~Sd3DWin();

	void	InitColorLB( const SdrModel* pDoc );
	BOOL	IsUpdateMode() const { return bUpdate; }

	void	Update( SfxItemSet& rSet );
	void	GetAttr( SfxItemSet& rSet );
};


/*************************************************************************
|*
|* ControllerItem fuer 3D-Window (Floating/Docking)
|*
\************************************************************************/

class Sd3DCtrlItem : public SfxControllerItem
{
	Sd3DWin* p3DWin;

 protected:
	virtual void StateChanged( USHORT nSId, SfxItemState eState,
								const SfxPoolItem* pState );

 public:
	Sd3DCtrlItem( USHORT, Sd3DWin*, SfxBindings* );
};


#endif		// _SVX_3DFLOAT_HXX


