/*************************************************************************
 *
 *  $RCSfile: dia_dlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SD_DIA_DLG_HXX
#define _SD_DIA_DLG_HXX

#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif
#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef SD_DLGCTRLS_HXX
#include "dlgctrls.hxx"
#endif

class SfxItemSet;
class SfxSimpleFileDialog;

//------------------------------------------------------------------------

class SdDiaDlg : public ModalDialog
{
private:
	FadeEffectLB		aLbEffect;
	RadioButton			aRbtSlow;
	RadioButton			aRbtMedium;
	RadioButton			aRbtFast;
	GroupBox			aGrpEffect;
	RadioButton			aRbtManuel;
	RadioButton			aRbtSemiAuto;
	RadioButton			aRbtAutomatic;
	TimeField			aTmeField;
	GroupBox			aGrpChange;
	TriStateBox			aTsbSound;
	Edit				aEdtSound;
	GroupBox			aGrpSound;
	PushButton			aBtnSearch;
	Control				aCtlPreview;
	OKButton			aBtnOk;
	CancelButton		aBtnCancel;
	HelpButton			aBtnHelp;

	SfxSimpleFileDialog*pFileDialog;
	PushButton*			pBtnPreview;
	Sound				aSound;

	const SfxItemSet&	rOutAttrs;
	BOOL				bEffectInvalide;
	BOOL				bSoundFileInvalide;
	BOOL				bTimeInvalide;

	//------------------------------------

	DECL_LINK( ClickChangeHdl, void * );
	DECL_LINK( ClickSoundHdl, void * );
	DECL_LINK( ChangeEffectHdl, void * );
	DECL_LINK( ModifyTimeHdl, void * );
	DECL_LINK( LoseTimeHdl, void * );
	DECL_LINK( GetTimeHdl, void * );
	DECL_LINK( ClickSearchHdl, void * );
	DECL_LINK( ClickPreviewHdl, void * );
	DECL_LINK( StopMusicHdl, void * );

	void ResetAttrs();

public:
		 SdDiaDlg( Window* pParent, const SfxItemSet& rInAttrs  );

	BOOL GetAttr( SfxItemSet& rOutAttrs );
};

#endif		// _SD_DIA_DLG_HXX

