/*************************************************************************
 *
 *  $RCSfile: drviewsh.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_DRVIEWSH_HXX
#define _SD_DRVIEWSH_HXX

#ifndef _VIEWFAC_HXX //autogen
#include <sfx2/viewfac.hxx>
#endif
#ifndef _SFXVIEWSH_HXX //autogen
#include <sfx2/viewsh.hxx>
#endif

#ifndef _SD_TABCONTR_HXX
#include "tabcontr.hxx"
#endif
#ifndef _SD_LAYERTAB_HXX
#include "layertab.hxx"
#endif
#ifndef _SD_VIEWSHEL_HXX
#include "viewshel.hxx"
#endif
#ifndef _PRESENTATION_HXX
#include "pres.hxx"
#endif

#ifndef _COM_SUN_STAR_LANG_XEVENTLISTENER_HPP_
#include <com/sun/star/lang/XEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_SCANNER_XSCANNERMANAGER_HPP_
#include <com/sun/star/scanner/XScannerManager.hpp>
#endif

class SdPage;
class SdDrawView;
class SdDrawDocShell;
class SdAnimationWin;
class SdRuler;
class TabBar;
class SdrObject;
class XPolygon;
class SdXImpressView;
class SdrPageView;


#define CHECK_RANGE(nMin, nValue, nMax) ((nValue >= nMin) && (nValue <= nMax))

/*************************************************************************
|*
|* Ableitung von SdViewShell fuer Drawing
|*
\************************************************************************/

class SdDrawViewShell : public SdViewShell
{
private:
	
	::com::sun::star::uno::Reference< ::com::sun::star::scanner::XScannerManager >	mxScannerManager;
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener >		mxScannerListener;

protected:

	SdDrawView* 	pDrView;
	SdPage* 		pActualPage;
	SdXImpressView*	pController;

	// Slot fuer die Forms
	UINT16 nLastSlot;

	// Rechteck der aktuell markierten Objekte
	Rectangle		aMarkRect;
	Point			aMousePos;
	BOOL			bMousePosFreezed;

	SdTabControl	aTabControl;
	SdLayerTab		aLayerTab;

	ImageButton 	aPageBtn;
	ImageButton 	aMasterPageBtn;
	ImageButton 	aLayerBtn;

	EditMode		eEditMode;
	BOOL			bLayerMode;

	PageKind		ePageKind;

	BOOL			bZoomOnPage;

	BOOL			bIsRulerDrag;

	XPolygon*		pXPolygon;
	USHORT			nPolygonIndex;
	BOOL			bLineError;
	BOOL			bLastWasLineTo;
	BOOL			bLastWasMoveTo;
	BOOL			bLastWasBezierTo;

	Color			aGradStartColor;
	Color			aGradEndColor;
	Color			aHatchColor;

	ULONG			nLockCount;

	static BOOL 	bPipette;
	Timer			aCloseTimer;

	BOOL 			bReadOnly;
	BOOL			bInEffectAssignment;

	void	Construct(SdDrawDocShell* pDocSh);
	DECL_LINK( TabSplitHdl, TabBar * );
	DECL_LINK( TabModeBtnHdl, Button * );

	void	DeleteActualPage();
	void	DeleteActualLayer();

	virtual SvxRuler* CreateHRuler(SdWindow* pWin, BOOL bIsFirst);
	virtual SvxRuler* CreateVRuler(SdWindow* pWin);
	virtual void UpdateHRuler();
	virtual void UpdateVRuler();

	virtual long GetHCtrlWidth();

	virtual void SetZoomFactor(const Fraction& rZoomX, const Fraction& rZoomY);

	virtual void InnerResizePixel(const Point& rPos, const Size& rSize);
	virtual Size GetOptimalSizePixel() const;

	void DestroyPolygons();

	void SetupPage (Size &rSize, long nLeft, long nRight, long nUpper, long nLower,
					BOOL bSize, BOOL bMargin, BOOL bScaleAll);

	USHORT	GetIdBySubId( USHORT nSId );
	void	MapSlot( USHORT nSId );
	void	UpdateToolboxImages( SfxItemSet &rSet, BOOL bPermanent = TRUE );
	USHORT	GetMappedSlot( USHORT nSId );
	USHORT	GetArrayId( USHORT nSId );

	void	GetMenuStateSel(SfxItemSet& rSet);

	virtual void SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType);

 public:
	TYPEINFO();

	SFX_DECL_VIEWFACTORY(SdDrawViewShell);
	SFX_DECL_INTERFACE(SD_IF_SDDRAWVIEWSHELL);

	 SdDrawViewShell(SfxViewFrame* pFrame, const SdDrawViewShell& rShell);
	 SdDrawViewShell(SfxViewFrame* pFrame, SfxViewShell* pOldShell);
	~SdDrawViewShell();

	virtual void	Paint(const Rectangle& rRect, SdWindow* pWin);
	virtual void	AdjustPosSizePixel(const Point &rPos, const Size &rSize);
			void 	HidePage(SdrPageView* pPV);

	virtual BOOL KeyInput(const KeyEvent& rKEvt, SdWindow* pWin);
	virtual void MouseMove(const MouseEvent& rMEvt, SdWindow* pWin);
	virtual void MouseButtonUp(const MouseEvent& rMEvt, SdWindow* pWin);
	virtual void MouseButtonDown(const MouseEvent& rMEvt, SdWindow* pWin);
	virtual void Command(const CommandEvent& rCEvt, SdWindow* pWin);

	virtual void OuterResizePixel(const Point& rPos, const Size& rSize);

	void    ShowMousePosInfo(const Rectangle& rRect, SdWindow* pWin);

	virtual void AddWindow(SdWindow* pWin);
	virtual void RemoveWindow(SdWindow* pWin);

	void	ChangeEditMode(EditMode eMode, BOOL bLMode);

	virtual void SetZoom( long nZoom );
	virtual void SetZoomRect( const Rectangle& rZoomRect );

	virtual BOOL QueryDrop(DropEvent& rEvt, SdWindow* pWin, USHORT nPage, USHORT nLayer);
	virtual BOOL Drop(const DropEvent& rEvt, SdWindow* pWin, USHORT nPage, USHORT nLayer);

	void	InsertURLField(const String& rURL, const String& rText, const String& rTarget,
						   const Point* pPos);
	void	InsertURLButton(const String& rURL, const String& rText, const String& rTarget,
							const Point* pPos);

	virtual void SetUIUnit(FieldUnit eUnit);

	void		 SelectionHasChanged();
	void		 ModelHasChanged();
	virtual void Activate(BOOL bIsMDIActivate);
	virtual void Deactivate(BOOL IsMDIActivate);
	virtual String	GetSelectionText( BOOL bCompleteWords = FALSE );
	virtual BOOL    HasSelection( BOOL bText = TRUE ) const;
	void 	SetHelpIdBySelection();

	void	ExecCtrl(SfxRequest& rReq);
	void	GetCtrlState(SfxItemSet& rSet);
	void	GetMenuState(SfxItemSet& rSet);
	void	GetAttrState(SfxItemSet& rSet);
	void	GetSnapItemState(SfxItemSet& rSet);

	void	ExecStatusBar(SfxRequest& rReq);
	void	GetStatusBarState(SfxItemSet& rSet);

	void	ExecOptionsBar(SfxRequest& rReq);
	void	GetOptionsBarState(SfxItemSet& rSet);

	void	ExecRuler(SfxRequest& rReq);
	void	GetRulerState(SfxItemSet& rSet);

	void	ExecFormText(SfxRequest& rReq);
	void	GetFormTextState(SfxItemSet& rSet);

	void	ExecObjPalette(SfxRequest& rReq);
	void	GetObjPaletteState(SfxItemSet& rSet);

	void	ExecAnimationWin(SfxRequest& rReq);
	void	GetAnimationWinState(SfxItemSet& rSet);

	void	ExecNavigatorWin(SfxRequest& rReq);
	void	GetNavigatorWinState(SfxItemSet& rSet);

	void	ExecEffectWin(SfxRequest& rReq);
	void	GetEffectWinState(SfxItemSet& rSet);
	void	UpdateEffectWindow();
	void	AssignFromEffectWindow();

	void	Update3DWindow();
	void	AssignFrom3DWindow();

	void	ExecGallery(SfxRequest& rReq);
	void	GetGalleryState(SfxItemSet& rSet);

	void	ExecBmpMask( SfxRequest& rReq );
	void	GetBmpMaskState( SfxItemSet& rSet );

	void	ExecIMap( SfxRequest& rReq );
	void	GetIMapState( SfxItemSet& rSet );

	void	FuTemporary(SfxRequest& rReq);
	void	FuPermanent(SfxRequest& rReq);
	void	FuSupport(SfxRequest& rReq);

	void	AttrExec (SfxRequest& rReq);
	void	AttrState (SfxItemSet& rSet);

	void	StartRulerDrag(const SdRuler& rRuler, const MouseEvent& rMEvt);

	virtual USHORT PrepareClose( BOOL bUI = TRUE, BOOL bForBrowsing = FALSE );

	PageKind	 GetPageKind() { return ePageKind; }

	Point		 GetMousePos() { return aMousePos; }
	BOOL 		 IsMousePosFreezed() { return bMousePosFreezed; }
	void 		 SetMousePosFreezed( BOOL bIn ) { bMousePosFreezed = bIn; }

	EditMode	 GetEditMode() const { return eEditMode; }
	virtual SdPage*	GetActualPage() { return pActualPage; }

	void		 ResetActualPage();
	void		 ResetActualLayer();
	BOOL		 SwitchPage(USHORT nPage);
	BOOL		 IsSwitchPageAllowed() const;

	BOOL		 GotoBookmark(const String& rBookmark);
	void         MakeVisible(const Rectangle& rRect, Window& rWin);

	virtual void ReadFrameViewData(FrameView* pView);
	virtual void WriteFrameViewData();

	virtual ErrCode DoVerb(long nVerb);
	virtual BOOL ActivateObject(SdrOle2Obj* pObj, long nVerb);

	void		 SetZoomOnPage( BOOL bZoom = TRUE ) { bZoomOnPage = bZoom; }
	BOOL		 IsZoomOnPage() { return bZoomOnPage; }
	void		 CheckLineTo (SfxRequest& rReq);
	void		 FuTemp01(SfxRequest& rReq);
	void		 FuTemp02(SfxRequest& rReq);
	void		 FuTemp03(SfxRequest& rReq);
	void		 FuTemp04(SfxRequest& rReq);
	void		 SetChildWindowState( SfxItemSet& rSet );

	void		 UpdateIMapDlg( SdrObject* pObj );

	void		 LockInput();
	void		 UnlockInput();
	BOOL		 IsInputLocked() const { return nLockCount > 0UL; }

	USHORT		 GetCurPageId() { return( aTabControl.GetCurPageId() ); }

	void		 PreparePresentation();
	void		 EndPresentation();

	void		 ScannerEvent( const ::com::sun::star::lang::EventObject& rEventObject );

	DECL_LINK( CloseHdl, Timer* pTimer );

	SdXImpressView *GetController() const { return pController; }
	BOOL			GetLayerMode() const { return bLayerMode; }
};



#endif		// _SD_DRVIEWSH_HXX

