/*************************************************************************
 *
 *  $RCSfile: enumdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_ENUMDLG_HXX
#define _SD_ENUMDLG_HXX

#ifndef _SV_CTRL_HXX //autogen
#include <vcl/ctrl.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <sfx2/tabdlg.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SVX_DLG_CTRL_HXX //autogen
#include <svx/dlgctrl.hxx>
#endif

#ifndef _SD_SDRESID_HXX
#include "sdresid.hxx"
#endif

/*---------------------------------------------------------------------------*/

enum EnumStyle
{
	ES_ABC_BIG,
	ES_ABC_SMALL,
	ES_III_BIG,
	ES_III_SMALL,
	ES_123,
	ES_NONE,
	ES_BULLET
};

/* Forward declarations -----------------------------------------------------*/

class XColorTable;

/*---------------------------------------------------------------------------*/

class BulletPreview : public Control
{
private:
	sal_Unicode	aChar;
	Point   aPtMM, aPtTL;

public:
			BulletPreview( Window* pParent, const SdResId& rSdResId );
			~BulletPreview();

	virtual void Paint( const Rectangle& rRect );

			void SetCharFont( const Font& rInFont );
			void SetChar( sal_Unicode c );
			void Clear() { aChar = ' '; }
};

/*---------------------------------------------------------------------------*/

class SdEnumTabPage : public SfxTabPage
{
private:
	ListBox				aLbStyle;
	GroupBox			aGrpStyle;
	FixedText			aFtEnum;
	NumericField		aNumFldEnum;
	FixedText			aFtSample;
	FixedInfo   		aFiPreviewEnum;
	GroupBox			aGrpEnum;
	PushButton			aBtnBullet;
	TriStateBox 		aTsbUseBullet;
	FixedText			aFtBulletSize;
	MetricField			aMtrFldSize;
	FixedText			aFtBulletColor;
	ColorLB				aLbBulletColor;
	BulletPreview   	aCtlPreviewBullet;
	GroupBox			aGrpBullet;

	XColorTable*		pColorTab;
	sal_Unicode			aChar;
	sal_Unicode         aCharSave;
	Font				aFont;
	Font                aFontSave;
	Size				aFontSize;

	const SfxItemSet&	rOutAttrs;

	DECL_LINK( ChangeStyleHdl, void * );
	DECL_LINK( ModifyBeginHdl, void * );
	DECL_LINK( ClickBulletHdl, void * );
	DECL_LINK( ChangeColorHdl, void * );
	DECL_LINK( ModifySizeHdl, void * );

public:
			SdEnumTabPage( Window* pParent, const SfxItemSet& rInAttrs );
			~SdEnumTabPage();
	void	Construct();

	static	SfxTabPage* Create( Window*, const SfxItemSet& );
	virtual BOOL FillItemSet( SfxItemSet& );
	virtual void Reset( const SfxItemSet & );

	void	SetColorTable( XColorTable* pColTab ) { pColorTab = pColTab; }
	static USHORT* GetRanges();

	void	HideControl( UINT16 nCtrl = 0 );
};



#endif // _SD_ENUMDLG_HXX


