/*************************************************************************
 *
 *  $RCSfile: optsite2.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OPTSITE2_HXX
#define _OPTSITE2_HXX

#ifndef _SFXPOOLITEM_HXX //autogen
#include <svtools/poolitem.hxx>
#endif

// class SdOptionsPrint ----------------------------------------------

class SdOptionsPrint
{
protected:
	BOOL bDraw					: 1;
	BOOL bNotes 				: 1;
	BOOL bHandout				: 1;
	BOOL bOutline				: 1;
	BOOL bDate					: 1;
	BOOL bTime					: 1;
	BOOL bPagename				: 1;
	BOOL bHiddenPages			: 1;
	BOOL bPagesize				: 1;
	BOOL bPagetile				: 1;
	BOOL bWarningPrinter		: 1;
	BOOL bWarningSize			: 1;
	BOOL bWarningOrientation	: 1;
	BOOL bBooklet				: 1;
	BOOL bFront 				: 1;
	BOOL bBack					: 1;
	BOOL bCutPage   			: 1;	// Nicht persistent
	BOOL bPaperbin  			: 1;	// Papierschacht aus Druckereinstellung
/// Neu
	UINT16 nQuality; // 0 == Color; 1 == Grayscale; 2 == BlackWhite
/// Neu

public:
	SdOptionsPrint();
	~SdOptionsPrint() {}

	BOOL IsDraw() const { return (BOOL) bDraw; }
	BOOL IsNotes() const { return (BOOL) bNotes; }
	BOOL IsHandout() const { return (BOOL) bHandout; }
	BOOL IsOutline() const { return (BOOL) bOutline; }
	BOOL IsDate() const { return (BOOL) bDate; }
	BOOL IsTime() const { return (BOOL) bTime; }
	BOOL IsPagename() const { return (BOOL) bPagename; }
	BOOL IsHiddenPages() const { return (BOOL) bHiddenPages; }
	BOOL IsPagesize() const { return (BOOL) bPagesize; }
	BOOL IsPagetile() const { return (BOOL) bPagetile; }
	BOOL IsWarningPrinter() const { return (BOOL) bWarningPrinter; }
	BOOL IsWarningSize() const { return (BOOL) bWarningSize; }
	BOOL IsWarningOrientation() const { return (BOOL) bWarningOrientation; }
	BOOL IsBooklet() const { return (BOOL) bBooklet; }
	BOOL IsFrontPage() const { return (BOOL) bFront; }
	BOOL IsBackPage() const { return (BOOL) bBack; }
	BOOL IsCutPage() const { return (BOOL) bCutPage; }
	BOOL IsPaperbin() const { return (BOOL) bPaperbin; }
/// Neu
	UINT16 GetOutputQuality() const { return nQuality; }
/// Neu

	void SetDraw( BOOL bOn = TRUE ) { bDraw = bOn; }
	void SetNotes( BOOL bOn = TRUE ) { bNotes = bOn; }
	void SetHandout( BOOL bOn = TRUE ) { bHandout = bOn; }
	void SetOutline( BOOL bOn = TRUE ) { bOutline = bOn; }
	void SetDate( BOOL bOn = TRUE ) { bDate = bOn; }
	void SetTime( BOOL bOn = TRUE ) { bTime = bOn; }
	void SetPagename( BOOL bOn = TRUE ) { bPagename = bOn; }
	void SetHiddenPages( BOOL bOn = TRUE ) { bHiddenPages = bOn; }
	void SetPagesize( BOOL bOn = TRUE ) { bPagesize = bOn; }
	void SetPagetile( BOOL bOn = TRUE ) { bPagetile = bOn; }
	void SetWarningPrinter( BOOL bOn = TRUE ) { bWarningPrinter = bOn; }
	void SetWarningSize( BOOL bOn = TRUE ) { bWarningSize = bOn; }
	void SetWarningOrientation( BOOL bOn = TRUE ) { bWarningOrientation = bOn; }
	void SetBooklet( BOOL bOn = TRUE ) { bBooklet = bOn; }
	void SetFrontPage( BOOL bOn = TRUE ) { bFront = bOn; }
	void SetBackPage( BOOL bOn = TRUE ) { bBack = bOn; }
	void SetCutPage( BOOL bOn = TRUE ) { bCutPage = bOn; }
	void SetPaperbin( BOOL bOn = TRUE ) { bPaperbin = bOn; }
/// Neu
	void SetOutputQuality( UINT16 nInQuality ) { nQuality = nInQuality; }
/// Neu
};

class SdOptions;

class SdOptionsPrintItem : public SfxPoolItem, public SdOptionsPrint
{

public:
	SdOptionsPrintItem( USHORT nWhich);
	SdOptionsPrintItem( USHORT nWhich, SdOptions* pOpts );

	virtual SfxPoolItem*	Clone( SfxItemPool *pPool = 0 ) const;
	virtual int 			operator==( const SfxPoolItem& ) const;
	void					SetOptions( SdOptions* pOpts ) const;

};

#endif

