/*************************************************************************
 *
 *  $RCSfile: packgdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:48:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SD_PACKNGO_HXX_
#define _SD_PACKNGO_HXX_

#ifndef _SV_BUTTON_HXX //autogen wg. OKButton
#include <vcl/button.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen wg. GroupBox
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen wg. FixedText
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen wg. CheckBox
#include <vcl/button.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen wg. ListBox
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif

#ifndef _BASEDLGS_HXX //autogen wg. SfxModalDialog
#include <sfx2/basedlgs.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen wg. FixedInfo
#include <svtools/stdctrl.hxx>
#endif

class SfxItemSet;

// Mediumsize in byte
static const ULONG nStoreSize[4] = { 0, 0, 1457664, 720000 };

// Defines for mediumsize
#define STMED_DISK_VARIABLE	0
#define STMED_USERDEFINED	1
#define STMED_DISK_1_44_MB	2
#define STMED_DISK_720_KB	3
#define STMED_DEFAULT		STMED_DISK_VARIABLE
#define STMED_FIRST			STMED_DISK_VARIABLE
#define STMED_LAST			STMED_DISK_720_KB

/*************************************************************************
|* Pack & Go Dialog
\************************************************************************/

class SdPackNGoDlg : public SfxModalDialog
{
private:
	CheckBox			aCbxUnlink;
	GroupBox			aGrpDokuOption;
	FixedInfo			aFtGrpDokuDescr;

	FixedText			aFtStoreMedium;
	ListBox				aLbStoreMedium;
	MetricField			aMtrUserDefined;
	GroupBox			aGrpStoreOption;
	FixedInfo			aFtGrpStoreDescr;

	OKButton			aBtnOK;
	CancelButton		aBtnCancel;
	HelpButton			aBtnHelp;

	const SfxItemSet&	rOutAttrs;

	DECL_LINK( SelectMediumHdl_Impl , void * );

public:
						SdPackNGoDlg ( Window *pParent, 
							           const SfxItemSet* pInAttrs );
						~SdPackNGoDlg() {}

	void				GetAttr( SfxItemSet* pOutAttrs );

};

#endif // _SD_PACKNGO_HXX_

