/*************************************************************************
 *
 *  $RCSfile: sdbref.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_SDBREF_HXX
#define _SDB_SDBREF_HXX 1

class UseCount
{
	INT32 *pCount;

public:
	UseCount():pCount(new INT32(1)){}
	UseCount(const UseCount& rU):pCount(rU.pCount) {++*pCount;}
	~UseCount() {if (--*pCount == 0) delete pCount;}

	BOOL IsOnly() const {return *pCount==1;}
	BOOL Reattach(const UseCount& rU);

private:
	UseCount& operator=(const UseCount&) {return *this;}
};

inline BOOL UseCount::Reattach(const UseCount& rU)
{
	++*rU.pCount;
	if (--*pCount == 0)
	{
		delete pCount;
		pCount = rU.pCount;
		return TRUE;
	}
	pCount = rU.pCount;
	return FALSE;
}

#define SDB_DECL_REF(ClassName)														\
private:																			\
	ClassName* pObj;																\
	UseCount   aCount;																\
																					\
public:   																			\
	ClassName##Ref(const ClassName& rObj):pObj(new ClassName(rObj)){}				\
	ClassName##Ref(const ClassName##Ref& rRef):pObj(rRef.pObj)                      \
						    				  ,aCount(rRef.aCount){}				\
	~ClassName##Ref() {if (aCount.IsOnly()) delete pObj;}							\
																					\
	ClassName##Ref & operator= (const ClassName##Ref& rRef);						\
	BOOL operator== (const ClassName##Ref& rRef)									\
					{return pObj == rRef.pObj;}										\
	BOOL operator!= (const ClassName##Ref& rRef)									\
					{return pObj != rRef.pObj;}										\
	BOOL 			IS() const {return pObj != NULL;}								\
	ClassName*		 operator & () const { return pObj;}							\
	ClassName*		 operator -> () const { return pObj;}							\
	ClassName&		 operator *  () const { return *pObj;}							\
private:


#define SDB_DECL_REF_DEF_CTOR(ClassName)											\
	SDB_DECL_REF(ClassName) 														\
public:																				\
	ClassName##Ref():pObj(new ClassName()){};										\
private:



#define SDB_IMPL_REF(ClassName)														\
	ClassName##Ref & ClassName##Ref::operator= (const ClassName##Ref& rRef)			\
	{																				\
		if (aCount.Reattach(rRef.aCount))											\
			delete pObj;															\
		pObj = rRef.pObj;															\
		return *this;																\
	};

#endif

