/*************************************************************************
 *
 *  $RCSfile: sdbtools.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_SDBTOOLS_HXX
#define _SDB_SDBTOOLS_HXX

#ifndef _SDB_SDBCOL_HXX
#include <sdbcol.hxx>
#endif

#ifndef _SVT_SDBSQL_HXX
#include <svtools/sdbsql.hxx>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

class SvNumberFormatter;
class ODbVariant;

//==============================================================================
// Tools fuer SDB, Sammelsurium an Funktionen
//==============================================================================
class SdbTools
{
public:
	// Funktionen fuer Quotes
	static String SetQuotation(const String& rValue, const String& rQuot, const String& rQuotToReplace);
	// static String DBString(SdbDatabaseType eType, const ODbVariant& rVal, BOOL bOuote = TRUE);
	static UINT32 DefaultFormat(SvNumberFormatter& rFormatter, SdbDatabaseType eType, UINT16 nScale);

	//	Date conversions
	static BOOL ToDateTime(double& fResult, const String& rStr);
	static double ToDouble(const DateTime& rTS);
	static double ToDouble(const Date& rTS);
	static double ToDouble(const Time& rTS);
	static DateTime ToDateTime(const double& fDate);
	static Date ToDate(const double& fSbxDate);
	static Time ToTime(const double& fSbxDate);	
	static String ToDateString(const Date& rDate);
	static String ToTimeString(const Time& rTime);
	static String ToDateTimeString(const DateTime& rDateTime);
	
	static double ToStandardDate(SvNumberFormatter& rFormatter, double rVal);
	static double ToFormatterDate(SvNumberFormatter& rFormatter, double rVal);
	
	// double conversions
	static double ToDouble(const String& rString);
	static double ToDouble(const ByteString& rString);
	static String ToString(double fValue, int nScale, char cOp = 'F');

	// SQL conform String of value
	static String SQLString(SdbDatabaseType eType, const ODbVariant& rVal, BOOL bQuote);
	static SdbSqlParseNode* MakeANDNode(SdbSqlParseNode *pLeftLeaf,SdbSqlParseNode *pRightLeaf);
};

#endif

