/*************************************************************************
 *
 *  $RCSfile: typeconv.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_TYPECONV_HXX
#define _SDB_TYPECONV_HXX 1

#ifndef _SDB_VARIANT_HXX
#include <variant.hxx>
#endif

#ifndef _COM_SUN_STAR_SCRIPT_CANNOTCONVERTEXCEPTION_HPP_
#include <com/sun/star/script/CannotConvertException.hpp>
#endif

namespace com { namespace sun { namespace star { namespace script {
class XTypeConverter;
}}}}

//************************************************************
//  ODbTypeConversion
//	Typeconversion which follows the database convensions
//************************************************************
/*		| Bool | Int8 | Int16 | Int32 | Int64 | float | double | String | Date | Time | DateTime | Bytes | Stream
//------|----------------------------------------------------------------------------------------------------------------------
Bool	|  x   |  x   |   x   |   x   | x	|	x	|	x	|	x	|	x	 |	x	  |		 |		|		   |	x  |
Int8	|  x   |  x   |   x   |   x	  |	x	|	x	|	x	|	x	|	x	 |	x	  |		 |		|		   |	   |
Int16	|  x   |  x   |   x   |   x   |		|		|		|		|		 |		  |		 |		|		   |	   |	
Int32	|  x   |  x   |   x   |	  x	  |		|		|		|		|		 |		  |		 |		|		   |	   |	
Int64	|  x   |  x   |   x   |	  x	  |		|		|		|		|		 |		  |		 |		|		   |	   |	
float	|  x   |  x   |   x   |	  x	  |		|		|		|		|		 |		  |		 |		|		   |	   |	
double	|  x   |  x   |   x   |	  x	  |		|		|		|		|		 |		  |		 |		|		   |	   |	
String	|      |  	  |		|		|		|		|		 |		  |		 |		|		   |	   |	
Date	|      |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
Time	|      |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
DateTime|      |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
Bytes	|	   |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
Stream	|	   |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
		|	   |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
		|	   |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
		|	   |		|		|		|		|		|		 |		  |		 |		|		   |	   |	
		| 	   |		|		|		|		|		|		 |		  |		 |		|		   |  	   |	
*/


class ODbTypeConversion
{
	friend class SdbEnvironment;
	static ::com::sun::star::uno::Reference< ::com::sun::star::script::XTypeConverter >  xTypeConverter;

public:
	static sal_Bool		toBOOL(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static sal_Int8		toBYTE(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static sal_Int16	toINT16(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static sal_Int32	toINT32(const ODbVariant& rValue)  throw( ::com::sun::star::script::CannotConvertException );	
	static sal_Int64	toINT64(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static float		toFloat(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static double		toDouble(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static rtl::OUString toString(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static Date			toDate(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static Time			toTime(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static DateTime		toDateTime(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );
	static ::com::sun::star::uno::Sequence< sal_Int8 >	toBytes(const ODbVariant& rValue) throw( ::com::sun::star::script::CannotConvertException );	
};

#endif

