/*************************************************************************
 *
 *  $RCSfile: variant.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_VARIANT_HXX
#define _SDB_VARIANT_HXX 1

#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_TIME_HPP_
#include <com/sun/star/util/Time.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _VOS_REFERNCE_HXX_
#include <vos/refernce.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif
#ifndef _SDB_TOOLS_HXX
#include <tools.hxx>
#endif

namespace com { namespace sun { namespace star { namespace script {
	class CannotConvertException;
}}}}


//************************************************************
//  OVariant
//	General Variant which is based on the ::com::sun::star::uno::Any, but it should
//	be possible to change the data holder if neccessary
//************************************************************
class OVariant
{
protected:
	::com::sun::star::uno::Any	m_aData;

public:
	OVariant(){};
	OVariant(const OVariant& rVar):m_aData(rVar.m_aData){}
	OVariant(const void *pValue, const com::sun::star::uno::Type& rType):m_aData(pValue, rType){}
	OVariant(sal_Bool Val):m_aData(&Val, ::getCppuBooleanType()){}
	OVariant(sal_Int16 Val):m_aData(&Val, ::getCppuType((const sal_Int16 *)0)){}
	OVariant(sal_Int32 Val):m_aData(&Val, ::getCppuType((const sal_Int32 *)0)){}
	OVariant(float Val):m_aData(&Val, ::getCppuType((const float *)0)){}
	OVariant(double Val):m_aData(&Val, ::getCppuType((const double *)0)){}
	OVariant(const rtl::OUString & Val):m_aData(&Val, ::getCppuType((const ::rtl::OUString *)0)){}

	OVariant&			operator= (const OVariant& rVar)
	{
		if (this != &rVar)
			m_aData = rVar.m_aData;
		return *this;
	}

	::com::sun::star::uno::Type		getValueType() const { return m_aData.getValueType(); }
	::com::sun::star::uno::TypeClass getValueTypeClass() const { return m_aData.getValueTypeClass(); }

	virtual void		set( const void* pValue, const ::com::sun::star::uno::Type& rType);
	const void*			get() const {return m_aData.getValue();}

	void				setVoid()								{set(NULL, ::getVoidCppuType());}
	void				setBOOL( sal_Bool Val )					{set(&Val, ::getBooleanCppuType());}
	sal_Bool			getBOOL() const							{return *(sal_Bool*)m_aData.getValue();}
	//	void				setChar( sal_Unicode Val )				{set(&Val, ::getCppuType((const sal_Unicode*)0));}
	sal_Unicode			getChar() const							{return *(sal_Unicode*)m_aData.getValue();}
	void				setBYTE( sal_Int8 Val )					{set(&Val, ::getCppuType((const sal_Int8*)0));}
	sal_Int8			getBYTE() const							{return *(sal_Int8*)m_aData.getValue();}
	void				setINT16( sal_Int16 Val )				{set(&Val, ::getCppuType((const sal_Int16*)0));}
	sal_Int16			getINT16() const						{return *(sal_Int16*)m_aData.getValue();}
	void				setINT32( sal_Int32 Val )				{set(&Val, ::getCppuType((const sal_Int32*)0));}
	sal_Int32			getINT32() const						{return *(sal_Int32*)m_aData.getValue();}
	void				setINT64( sal_Int64 Val )				{set(&Val, ::getCppuType((const sal_Int64*)0));}
	sal_Int64			getINT64() const						{return *(sal_Int64*)m_aData.getValue();}
	void				setFloat( float Val )					{set(&Val, ::getCppuType((const float*)0));}
	float				getFloat() const						{return *(float*)m_aData.getValue();}
	void				setDouble( double Val )					{set(&Val, ::getCppuType((const double*)0));}
	double				getDouble() const						{return *(double*)m_aData.getValue();}
	void				setString( const rtl::OUString & Val )	{set(&Val, ::getCppuType((const rtl::OUString*)0));}
	const rtl::OUString&	getString() const					{return *(rtl::OUString*)m_aData.getValue();}
};

//************************************************************
// ::com::sun::star::uno::Any comparision for database variants
sal_Bool areEqual(const ::com::sun::star::uno::Any& rLeft, const ::com::sun::star::uno::Any& rRight);

//************************************************************
//  ODbVariant
//	Special type conversion
//************************************************************
class ODbVariant : public OVariant, public ::vos::OReference
{
	sal_Bool		m_bModified;

public:
	ODbVariant():m_bModified(sal_False){}
	ODbVariant(const ODbVariant& rVar):OVariant(rVar),m_bModified(sal_False){}
	ODbVariant(const void *pValue, const com::sun::star::uno::Type& rType):OVariant(pValue, rType),m_bModified(sal_False){}
	ODbVariant(sal_Bool Val):OVariant(Val),m_bModified(sal_False){}
	ODbVariant(sal_Int16 Val):OVariant(Val),m_bModified(sal_False){}
	ODbVariant(sal_Int32 Val):OVariant(Val),m_bModified(sal_False){}
	ODbVariant(float Val):OVariant(Val),m_bModified(sal_False){}
	ODbVariant(double Val):OVariant(Val),m_bModified(sal_False){}
	ODbVariant(const Date & Val){setDate(Val); m_bModified = sal_False;}
	ODbVariant(const Time & Val){setTime(Val); m_bModified = sal_False;}
	ODbVariant(const DateTime & Val){setDateTime(Val); m_bModified = sal_False;}
	ODbVariant(const ::com::sun::star::uno::Sequence< sal_Int8 > & Val){setBytes(Val); m_bModified = sal_False;}

	ODbVariant& operator= (const ODbVariant &rVar) {return (ODbVariant&)OVariant::operator=(rVar);}
	sal_Bool operator== (const ODbVariant &rVar) const {return ::areEqual(m_aData, rVar.m_aData);}
	sal_Bool operator!= (const ODbVariant &rVar) const {return !::areEqual(m_aData, rVar.m_aData);}

	virtual void		set( const void* pValue, const ::com::sun::star::uno::Type& rType);
	void				reset(); // null and not modified

	// the variant provides a modified flag
	void				setModified(sal_Bool bMod = sal_True) {m_bModified = bMod;}
	sal_Bool			isModified() const {return m_bModified;}

	void				setNull()								{setVoid();}
	sal_Bool			isNull() const							{return !m_aData.hasValue();}
	inline void			setDate(const Date& x);
	inline Date			getDate(void) const;
	inline void			setTime(const Time& x);
	inline Time			getTime(void) const;
	inline void			setDateTime(const DateTime& x);
	inline DateTime		getDateTime(void) const;
	inline void			setBytes(const ::com::sun::star::uno::Sequence< sal_Int8 >& x);
	inline const ::com::sun::star::uno::Sequence< sal_Int8 >&	getBytes(void) const;

	void				setAny(const ::com::sun::star::uno::Any& x)				   {m_aData = x;}
	const ::com::sun::star::uno::Any&		getAny() const						   {return m_aData;}
	sal_Bool			equals(const ::com::sun::star::uno::Any& x) const		   {return ::areEqual(x, m_aData);}

//  TypeConversion
	virtual sal_Bool	toBOOL() const throw( ::com::sun::star::script::CannotConvertException );
	virtual sal_Int8	toBYTE() const throw( ::com::sun::star::script::CannotConvertException );
	virtual sal_Int16	toINT16() const throw( ::com::sun::star::script::CannotConvertException );
	virtual sal_Int32	toINT32()  const throw( ::com::sun::star::script::CannotConvertException );
	virtual sal_Int64	toINT64() const throw( ::com::sun::star::script::CannotConvertException );
	virtual float		toFloat() const throw( ::com::sun::star::script::CannotConvertException );
	virtual double		toDouble() const throw( ::com::sun::star::script::CannotConvertException );
	virtual rtl::OUString toString() const throw( ::com::sun::star::script::CannotConvertException );
	virtual Date		toDate() const throw( ::com::sun::star::script::CannotConvertException );
	virtual Time		toTime() const throw( ::com::sun::star::script::CannotConvertException );
	virtual DateTime	toDateTime() const throw( ::com::sun::star::script::CannotConvertException );
	virtual ::com::sun::star::uno::Sequence< sal_Int8 > toBytes() const throw( ::com::sun::star::script::CannotConvertException );
};

//************************************************************
// ODbVariantRef
//************************************************************
typedef ODbRef< ODbVariant > ODbVariantRef;

//-----------------------------------------------------------------------------
inline void	ODbVariant::reset()
{
	setNull(); m_bModified = sal_False;
}


//-----------------------------------------------------------------------------
inline void	ODbVariant::setDate(const Date& x)
{
	::com::sun::star::util::Date aConverted;
	aConverted.Day = x.GetDay();
	aConverted.Month = x.GetMonth();
	aConverted.Year = x.GetYear();
	set(&aConverted,::getCppuType((const ::com::sun::star::util::Date*)0));
}


//-----------------------------------------------------------------------------
inline Date ODbVariant::getDate(void) const
{
	DBG_ASSERT(getValueType() == ::getCppuType((const ::com::sun::star::util::Date*)0), "not a Date" );
	::com::sun::star::util::Date aDate;
	m_aData >>= aDate;
	return Date(aDate.Day, aDate.Month, aDate.Year);	
}

//-----------------------------------------------------------------------------
inline void	ODbVariant::setTime(const Time& x)
{
	::com::sun::star::util::Time aConverted;
	aConverted.Hours = x.GetHour();
	aConverted.Minutes = x.GetMin();
	aConverted.Seconds = x.GetSec();
	aConverted.HundredthSeconds = x.Get100Sec();
	set(&aConverted,::getCppuType((const ::com::sun::star::util::Time*)0));
}

//-----------------------------------------------------------------------------
inline Time ODbVariant::getTime(void) const
{
	DBG_ASSERT(getValueType() == ::getCppuType((const ::com::sun::star::util::Time*)0), "not a ::com::sun::star::util::Time" );
	::com::sun::star::util::Time aTime;
	m_aData >>= aTime;
	return Time(aTime.Hours, aTime.Minutes, aTime.Seconds, aTime.HundredthSeconds);
}

//-----------------------------------------------------------------------------
inline void	ODbVariant::setDateTime(const DateTime& x)
{
	com::sun::star::util::DateTime aConverted;
	aConverted.Year = x.GetYear();
	aConverted.Month = x.GetMonth();
	aConverted.Day = x.GetDay();
	aConverted.Hours = x.GetHour();
	aConverted.Minutes = x.GetMin();
	aConverted.Seconds = x.GetSec();
	aConverted.HundredthSeconds = x.Get100Sec();
	set(&aConverted,::getCppuType((const com::sun::star::util::DateTime*)0));
}

//-----------------------------------------------------------------------------
inline DateTime ODbVariant::getDateTime(void) const
{
	DBG_ASSERT(getValueType() == ::getCppuType((const ::com::sun::star::util::DateTime*)0), "not a ::com::sun::star::util::DateTime" );
	::com::sun::star::util::DateTime aDateTime;
	m_aData >>= aDateTime;
	return DateTime(Date(aDateTime.Day, aDateTime.Month, aDateTime.Year),
					Time(aDateTime.Hours, aDateTime.Minutes, aDateTime.Seconds, aDateTime.HundredthSeconds));	
}

//-----------------------------------------------------------------------------
inline void	ODbVariant::setBytes(const ::com::sun::star::uno::Sequence< sal_Int8 >& x)
{
	m_aData <<= x;
	m_bModified = sal_True;
}

//-----------------------------------------------------------------------------
inline const ::com::sun::star::uno::Sequence< sal_Int8 >& ODbVariant::getBytes(void) const
{
	DBG_ASSERT(getValueType() == ::getCppuType((const ::com::sun::star::uno::Sequence< sal_Int8 > *)0),"not a Binary sequence" );
	return *(::com::sun::star::uno::Sequence< sal_Int8 >*)get();
}								  

#endif

