/*************************************************************************
 *
 *  $RCSfile: oterimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/debug.hxx>
#include "oterinc.hxx"
#ifndef _SFXINIPROP_HXX //autogen wg. SfxAppIniManagerProperty
#include <svtools/iniprop.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen wg. SfxIniManager
#include <svtools/iniman.hxx>
#endif
#ifndef _OSL_MODULE_H_
#include <osl/module.h>
#endif
#include <sdbenv.hxx>

static BOOL bLoaded = FALSE;
static oslModule pso = NULL;

// Dynamisches Laden der DLL/shared lib und Adressen der Funktionen besorgen:
// Liefert TRUE bei Erfolg.
BOOL LoadLibrary_OTER(String &_rPath)
{
	SfxAppIniManagerProperty aIniManProp;
	GetpApp()->Property(aIniManProp);
	_rPath = aIniManProp.GetIniManager()->GetProgramPath();
	_rPath += String::CreateFromAscii("\\OT10_32.DLL");

	if (bLoaded) 
		return TRUE;
	
	
	pso = osl_loadModule( ::rtl::OUString(_rPath.GetBuffer()).pData,SAL_LOADMODULE_NOW );
	if(!pso)
		return sal_False;

	if( ( pOtSQLAllocConnect	=	(TOSQLAllocConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocConnect").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLAllocEnv		=	(TOSQLAllocEnv)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocEnv").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLAllocStmt		=	(TOSQLAllocStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocStmt").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLBindCol			=	(TOSQLBindCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindCol").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLBindParameter	=	(TOSQLBindParameter)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindParameter").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLBrowseConnect	=	(TOSQLBrowseConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBrowseConnect").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLCancel			=	(TOSQLCancel)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLCancel").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLColAttributes	=	(TOSQLColAttributes)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColAttributes").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLConnect			=	(TOSQLConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLConnect").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLDescribeCol		=	(TOSQLDescribeCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeCol").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLDisconnect		=	(TOSQLDisconnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDisconnect").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLError			=	(TOSQLError)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLError").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLExecDirect		=	(TOSQLExecDirect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecDirect").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLExecute			=	(TOSQLExecute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecute").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLFetch			=	(TOSQLFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFetch").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLFreeConnect		=	(TOSQLFreeConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeConnect").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLFreeEnv			=	(TOSQLFreeEnv)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeEnv").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLFreeStmt		=	(TOSQLFreeStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLGetCursorName	=	(TOSQLGetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetCursorName").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLNumResultCols	=	(TOSQLNumResultCols)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumResultCols").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLPrepare			=	(TOSQLPrepare)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrepare").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLRowCount		=	(TOSQLRowCount)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLRowCount").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLSetCursorName	=	(TOSQLSetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetCursorName").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLTransact		=	(TOSQLTransact)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTransact").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLColumns			=	(TOSQLColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumns").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLDriverConnect	=	(TOSQLDriverConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDriverConnect").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLGetConnectOption =  (TOSQLGetConnectOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetConnectOption").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLGetData		=	(TOSQLGetData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetData").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLGetFunctions	=	(TOSQLGetFunctions)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetFunctions").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLGetInfo		=	(TOSQLGetInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetInfo").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLGetStmtOption =	(TOSQLGetStmtOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetStmtOption").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLGetTypeInfo	=	(TOSQLGetTypeInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetTypeInfo").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLParamData		=	(TOSQLParamData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamData").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLPutData		=	(TOSQLPutData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPutData").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLSetConnectOption =  (TOSQLSetConnectOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetConnectOption").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLSetStmtOption =   (TOSQLSetStmtOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetStmtOption").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLSpecialColumns =  (TOSQLSpecialColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSpecialColumns").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLStatistics	=   (TOSQLStatistics)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLStatistics").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLTables		=   (TOSQLTables)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTables").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLColumnPrivileges = (TOSQLColumnPrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumnPrivileges").pData )) == NULL )
		return FALSE;*/
	//if( ( pOtSQLDataSources	=   (TOSQLDataSources)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDataSources").pData )) == NULL )
	//	return FALSE;
	/*if( ( pOtSQLDescribeParam =   (TOSQLDescribeParam)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeParam").pData )) == NULL )
		return FALSE;*/
	/*if( ( pOtSQLExtendedFetch =   (TOSQLExtendedFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExtendedFetch").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLForeignKeys	=	(TOSQLForeignKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLForeignKeys").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLMoreResults	=	(TOSQLMoreResults)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLMoreResults").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLNativeSql		=	(TOSQLNativeSql)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNativeSql").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLNumParams		=	(TOSQLNumParams)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumParams").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLParamOptions	=	(TOSQLParamOptions)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamOptions").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLPrimaryKeys	=	(TOSQLPrimaryKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrimaryKeys").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLProcedureColumns =  (TOSQLProcedureColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedureColumns").pData )) == NULL )
		return FALSE;
	if( ( pOtSQLProcedures	=	(TOSQLProcedures)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedures").pData )) == NULL )
		return FALSE;
	/*if( ( pOtSQLSetPos		=	(TOSQLSetPos)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetPos").pData )) == NULL )
		return FALSE;*/
	if( ( pOtSQLTablePrivileges =	(TOSQLTablePrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTablePrivileges").pData )) == NULL )
		return FALSE;

	bLoaded = TRUE;
	return TRUE;
}

BOOL FreeLibrary_OTER()
{
	if (!bLoaded)
		return FALSE;

	osl_unloadModule(pso);
	bLoaded = FALSE;
	return TRUE;
}

TOSQLAllocConnect pOtSQLAllocConnect;
TOSQLAllocEnv pOtSQLAllocEnv;
TOSQLAllocStmt pOtSQLAllocStmt;
TOSQLBindCol pOtSQLBindCol;
TOSQLBindParameter pOtSQLBindParameter;
TOSQLBrowseConnect pOtSQLBrowseConnect;
TOSQLCancel pOtSQLCancel;
TOSQLColAttributes pOtSQLColAttributes;
TOSQLColumnPrivileges pOtSQLColumnPrivileges;
TOSQLColumns pOtSQLColumns;
TOSQLConnect pOtSQLConnect;
TOSQLDataSources pOtSQLDataSources;
TOSQLDescribeCol pOtSQLDescribeCol;
TOSQLDescribeParam pOtSQLDescribeParam;
TOSQLDisconnect pOtSQLDisconnect;
TOSQLDriverConnect pOtSQLDriverConnect;
TOSQLDrivers pOtSQLDrivers;
TOSQLError pOtSQLError;
TOSQLExecDirect pOtSQLExecDirect;
TOSQLExecute pOtSQLExecute;
TOSQLExtendedFetch pOtSQLExtendedFetch;
TOSQLFetch pOtSQLFetch;
TOSQLForeignKeys pOtSQLForeignKeys;
TOSQLFreeConnect pOtSQLFreeConnect;
TOSQLFreeEnv pOtSQLFreeEnv;
TOSQLFreeStmt pOtSQLFreeStmt;
TOSQLGetConnectOption pOtSQLGetConnectOption;
TOSQLGetCursorName pOtSQLGetCursorName;
TOSQLGetData pOtSQLGetData;
TOSQLGetFunctions pOtSQLGetFunctions;
TOSQLGetInfo pOtSQLGetInfo;
TOSQLGetStmtOption pOtSQLGetStmtOption;
TOSQLGetTypeInfo pOtSQLGetTypeInfo;
TOSQLMoreResults pOtSQLMoreResults;
TOSQLNativeSql pOtSQLNativeSql;
TOSQLNumParams pOtSQLNumParams;
TOSQLNumResultCols pOtSQLNumResultCols;
TOSQLParamData pOtSQLParamData;
TOSQLParamOptions pOtSQLParamOptions;
TOSQLPrepare pOtSQLPrepare;
TOSQLPrimaryKeys pOtSQLPrimaryKeys;
TOSQLProcedureColumns pOtSQLProcedureColumns;
TOSQLProcedures pOtSQLProcedures;
TOSQLRowCount pOtSQLRowCount;
TOSQLPutData pOtSQLPutData;
TOSQLSetConnectOption pOtSQLSetConnectOption;
TOSQLSetCursorName pOtSQLSetCursorName;
TOSQLSetPos pOtSQLSetPos;
TOSQLSetStmtOption pOtSQLSetStmtOption;
TOSQLSpecialColumns pOtSQLSpecialColumns;
TOSQLStatistics pOtSQLStatistics;
TOSQLTables pOtSQLTables;
TOSQLTablePrivileges pOtSQLTablePrivileges;
TOSQLTransact pOtSQLTransact;
