/*************************************************************************
 *
 *  $RCSfile: otermd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_OTERCONN_HXX
#include <oterconn.hxx>
#endif


#ifdef SQL_KEYWORDS
#define SQL_KEYWORDS1     89
#undef SQL_KEYWORDS
#endif

#ifdef IN
#undef IN
#endif

#include <otermd.hxx>

#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQL92_HPP_
#include <com/sun/star/data/DatabaseSQL92.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

//------------------------------------------------------------------
sal_Bool SdbOTERMetaData::isCapableImpl(sal_Int16 nCapability) const
{
	sal_Bool erg(sal_False);
	switch(nCapability)
	{
		case ::stardata::DatabaseCapability::CONVERT:
		case ::stardata::DatabaseCapability::TABLE_CORRELATION_NAME:
		case ::stardata::DatabaseCapability::GROUPBY:
		case ::stardata::DatabaseCapability::GROUPBY_BEYONDSELECT:
		case ::stardata::DatabaseCapability::GROUPBY_UNRELATED:
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
		case ::stardata::DatabaseCapability::INTEGRITY:
		case ::stardata::DatabaseCapability::COLUMN_ALIAS:
		case ::stardata::DatabaseCapability::UNION:
		case ::stardata::DatabaseCapability::UNION_ALL:
		case ::stardata::DatabaseCapability::ORDERBY_UNRELATED:
			erg = sal_True;
			break;
		case ::stardata::DatabaseCapability::EXPRESSION_ORDERBY:
			break;
		case ::stardata::DatabaseCapability::TRANSACTIONS:
			erg = ((SdbOTERConnection*)pCon)->IsTransactOn();
			break;
	}
	return erg;
}
//------------------------------------------------------------------
::staruno::Any SdbOTERMetaData::getInfoImpl(sal_Int16 nInfo) const
{
	::staruno::Any erg;
	switch(nInfo)
	{
		case ::stardata::DatabaseInfo::READ_ONLY:
			erg <<= (sal_Bool)(((SdbOTERConnection*)pCon)->IsCapable(SDB_CAP_UPDATABLE) == sal_False);
			break;
		case ::stardata::DatabaseInfo::CATALOG_AT_START:
			erg <<= (sal_Bool)sal_False;
			break;
		case ::stardata::DatabaseInfo::NULLPLUSNONNULLISNULL:
			erg <<= (sal_Bool)sal_True;
			break;
		case ::stardata::DatabaseInfo::TABLE_DEFINITION:
//			if (!(((SdbOTERConnection*)pCon)->IsMultiUserOn() || ((SdbOTERConnection*)pCon)->IsTransactOn()))
//				erg <<= (sal_Int16)::stardata::DatabaseTableDefinition::CREATE | ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN |
//						 ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN | ::stardata::DatabaseTableDefinition::DROP);
			break;
		case ::stardata::DatabaseInfo::VIEW_DEFINITION:
//			if (!(((SdbOTERConnection*)pCon)->IsMultiUserOn() || ((SdbOTERConnection*)pCon)->IsTransactOn()))
//				erg <<= (sal_Int16)::stardata::DatabaseViewDefinition::DROP | ::stardata::DatabaseViewDefinition::CREATE);
			break;
		case ::stardata::DatabaseInfo::INDEX_DEFINITION:
//			if (!(((SdbOTERConnection*)pCon)->IsMultiUserOn() || ((SdbOTERConnection*)pCon)->IsTransactOn()))
//				erg <<= (sal_Int16)::stardata::DatabaseIndexDefinition::DROP | ::stardata::DatabaseIndexDefinition::CREATE);
			break;
		case ::stardata::DatabaseInfo::IDENT_CASE:
		case ::stardata::DatabaseInfo::IDENT_CASE_QUOTED:
			erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			break;
		case ::stardata::DatabaseInfo::NULLS_SORT:
			erg <<= (sal_Int16)::stardata::DatabaseNullsSort::LOW;
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_UPDATE_RULE:
			erg <<= (sal_Int16)::stardata::DatabaseKeyRule::NO_ACTION;
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_DELETE_RULE:
			erg <<= (sal_Int16)::stardata::DatabaseKeyRule::NO_ACTION;
			break;
		case ::stardata::DatabaseInfo::SCHEMA_USAGE:
		case ::stardata::DatabaseInfo::CATALOG_USAGE:
			erg <<= (sal_Int16)0;
			break;
		case ::stardata::DatabaseInfo::SUBQUERIES:
			erg <<= (sal_Int16)(::stardata::DatabaseSubquery::CORRELATED|::stardata::DatabaseSubquery::COMPARSION|::stardata::DatabaseSubquery::EXISTS|::stardata::DatabaseSubquery::IN|::stardata::DatabaseSubquery::QUANTIFIED);
			break;
		case ::stardata::DatabaseInfo::SUPPORTED_ISOLATION_LEVELS:
			erg <<= (sal_Int16)::stardata::DatabaseIsolationLevel::REPEAT_READ;
			break;
		case ::stardata::DatabaseInfo::ANSI_SQL_92:
			erg <<= (sal_Int16)::stardata::DatabaseSQL92::ENTRY_LEVEL;
			break;
		case ::stardata::DatabaseInfo::DSN_URL:
		{
			INetURLObject aUrl;
			aUrl.SetSmartProtocol(INET_PROT_FILE);
			aUrl.SetURL(((SdbOTERConnection*)pCon)->GetDsn());
			erg <<= rtl::OUString(UniString(aUrl.GetMainURL()));
		}	break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			erg <<= rtl::OUString::createFromAscii("StarBase");
			break;
		case ::stardata::DatabaseInfo::DRIVER_VERSION:
			erg <<= rtl::OUString::createFromAscii("1.0");
			break;
		case ::stardata::DatabaseInfo::DBMS_VERSION:
			erg <<= rtl::OUString::createFromAscii("1.0");
			break;
		case ::stardata::DatabaseInfo::DBMS_NAME:
			erg <<= rtl::OUString(UniString());
			break;
		case ::stardata::DatabaseInfo::PROC_TERM:
		case ::stardata::DatabaseInfo::CATALOG_TERM:
			erg <<= rtl::OUString(UniString());
			break;
		case ::stardata::DatabaseInfo::SCHEMA_TERM:
			erg <<= rtl::OUString::createFromAscii("OWNER");
			break;
		case ::stardata::DatabaseInfo::TABLE_TERM:
			erg <<= rtl::OUString::createFromAscii("TABLE");
			break;
		case ::stardata::DatabaseInfo::IDENTIFIER_QUOTE_CHAR:
			{
				String aStr;
				((SdbOTERConnection*)pCon)->GetOTERInfo(SQL_IDENTIFIER_QUOTE_CHAR,aStr);
				erg <<= rtl::OUString(UniString(aStr));
			}
			break;
		case ::stardata::DatabaseInfo::SQL_KEYWORDS:
		case ::stardata::DatabaseInfo::CATALOG_SEPARATOR:
			erg <<= rtl::OUString(UniString());
			break;
		case ::stardata::DatabaseInfo::SEARCH_PATTERN_ESCAPE:
		case ::stardata::DatabaseInfo::SPECIAL_CHARACTERS:
			erg <<= rtl::OUString(UniString());
			break;
		case ::stardata::DatabaseInfo::STRING_FUNCTIONS:
			erg <<= rtl::OUString::createFromAscii("CHAR");			
			break;
		case ::stardata::DatabaseInfo::SYSTEM_FUNCTIONS:
			erg <<= rtl::OUString(UniString('0'));
			break;
		case ::stardata::DatabaseInfo::NUMERIC_FUNCTIONS:
			erg <<= rtl::OUString::createFromAscii("ABS,ACOS,ASIN,ATAN,ATAN2,COS,EXP,LOG,LOG10,MOD,SIGN,SIN,SQRT,TAN");
			break;
		case ::stardata::DatabaseInfo::SQL_CONFORMANCE:
			erg <<= (sal_Int16)::stardata::DatabaseSQLConformance::CORE;
			break;
		case ::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT:
			erg <<= (sal_Int16)(::stardata::DatabaseOuterJoinSupport::YES|::stardata::DatabaseOuterJoinSupport::PARTIAL|::stardata::DatabaseOuterJoinSupport::FULL);
			break;
		default:
			erg <<= (sal_Int16)0;			
	}
	return erg;
}

//------------------------------------------------------------------
sal_Int32 SdbOTERMetaData::getLimitImpl(sal_Int16 nLimit) const
{
	sal_uInt32 erg(0);
	switch(nLimit)
	{
		case ::stardata::DatabaseLimit::BINARAY_LITERAL_LEN:
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			erg = 0;
			break;
		case ::stardata::DatabaseLimit::USER_NAME_LEN:
		case ::stardata::DatabaseLimit::SCHEMA_NAME_LEN:
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
		case ::stardata::DatabaseLimit::TABLE_NAME_LEN:
			erg = 18;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			erg = 8;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			erg = 400;
			break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			erg = 200;
			break;
	}
	return erg;
}

//------------------------------------------------------------------
static sal_Int32 convertFrom(sal_Int16 nIn)
{
	sal_Int32 nOut;
	switch(nIn)
	{
		case ::stardata::DatabaseFieldType::VARCHAR:
			nOut = SQL_CONVERT_VARCHAR;
			break;
		case ::stardata::DatabaseFieldType::CHAR:
			nOut = SQL_CONVERT_CHAR;
			break;
		case ::stardata::DatabaseFieldType::BOOL:
			nOut = SQL_CONVERT_BIT;
			break;
		case ::stardata::DatabaseFieldType::TINYINT:
			nOut = SQL_CONVERT_TINYINT;
			break;
		case ::stardata::DatabaseFieldType::SMALLINT:
			nOut = SQL_CONVERT_SMALLINT;
			break;
		case ::stardata::DatabaseFieldType::INTEGER:
			nOut = SQL_CONVERT_INTEGER;
			break;
		case ::stardata::DatabaseFieldType::BIGINT:
			nOut = SQL_CONVERT_BIGINT;
			break;
		case ::stardata::DatabaseFieldType::REAL:
			nOut = SQL_CONVERT_FLOAT;
			break;
		case ::stardata::DatabaseFieldType::DOUBLE:
			nOut = SQL_CONVERT_DOUBLE;
			break;
		case ::stardata::DatabaseFieldType::DECIMAL:
			nOut = SQL_CONVERT_DECIMAL;
			break;
		case ::stardata::DatabaseFieldType::NUMERIC:
		case ::stardata::DatabaseFieldType::CURRENCY:
			nOut = SQL_CONVERT_NUMERIC;
			break;
		case ::stardata::DatabaseFieldType::DATETIME:
			nOut = SQL_CONVERT_TIMESTAMP;
			break;
		case ::stardata::DatabaseFieldType::DATE:
			nOut = SQL_CONVERT_DATE;
			break;
		case ::stardata::DatabaseFieldType::TIME:
			nOut = SQL_CONVERT_TIME;
			break;
		case ::stardata::DatabaseFieldType::LONGVARCHAR:
			nOut = SQL_CONVERT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::OTHER:
		case ::stardata::DatabaseFieldType::LONGVARBINARY:
			nOut = SQL_CONVERT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::VARBINARY:
			nOut = SQL_CONVERT_VARBINARY;
			break;
		case ::stardata::DatabaseFieldType::BINARY:
			nOut = SQL_CONVERT_BINARY;
			break;
	}
	return nOut;
}
//------------------------------------------------------------------
static sal_Int32 convertTo(sal_Int16 nIn)
{
	sal_Int32 nOut;
	switch (nIn)
	{
		case ::stardata::DatabaseFieldType::VARCHAR:
			nOut = SQL_CVT_VARCHAR;
			break;
		case ::stardata::DatabaseFieldType::CHAR:
			nOut = SQL_CVT_CHAR;
			break;
		case ::stardata::DatabaseFieldType::BOOL:
			nOut = SQL_CVT_BIT;
			break;
		case ::stardata::DatabaseFieldType::TINYINT:
			nOut = SQL_CVT_TINYINT;
			break;
		case ::stardata::DatabaseFieldType::SMALLINT:
			nOut = SQL_CVT_SMALLINT;
			break;
		case ::stardata::DatabaseFieldType::INTEGER:
			nOut = SQL_CVT_INTEGER;
			break;
		case ::stardata::DatabaseFieldType::BIGINT:
			nOut = SQL_CVT_BIGINT;
			break;
		case ::stardata::DatabaseFieldType::REAL:
			nOut = SQL_CVT_FLOAT;
			break;
		case ::stardata::DatabaseFieldType::DOUBLE:
			nOut = SQL_CVT_DOUBLE;
			break;
		case ::stardata::DatabaseFieldType::DECIMAL:
			nOut = SQL_CVT_DECIMAL;
			break;
		case ::stardata::DatabaseFieldType::NUMERIC:
		case ::stardata::DatabaseFieldType::CURRENCY:
			nOut = SQL_CVT_NUMERIC;
			break;
		case ::stardata::DatabaseFieldType::DATETIME:
			nOut = SQL_CVT_TIMESTAMP;
			break;
		case ::stardata::DatabaseFieldType::DATE:
			nOut = SQL_CVT_DATE;
			break;
		case ::stardata::DatabaseFieldType::TIME:
			nOut = SQL_CVT_TIME;
			break;
		case ::stardata::DatabaseFieldType::LONGVARCHAR:
			nOut = SQL_CVT_LONGVARCHAR;
			break;
		case ::stardata::DatabaseFieldType::OTHER:
		case ::stardata::DatabaseFieldType::LONGVARBINARY:
			nOut = SQL_CVT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::VARBINARY:
			nOut = SQL_CVT_VARBINARY;
			break;
		case ::stardata::DatabaseFieldType::BINARY:
			nOut = SQL_CVT_BINARY;
			break;
	}
	return nOut;
}

//------------------------------------------------------------------
sal_Bool SdbOTERMetaData::canConvertImpl(sal_Int16 nFrom, sal_Int16 nTo) const
{
	sal_uInt32 erg;
	((SdbOTERConnection*)pCon)->GetOTERInfo(convertFrom(nFrom),erg);
	return erg==convertTo(nTo);

}


