echo off

if "%DBROOT%"			== "" goto error
if "%DBWORK%"			== "" set DBWORK=%DBROOT%
if "%DBCONFIG%"			== "" set DBCONFIG=%DBROOT%

if "%1"			== "-f" goto file
if "%1"			== "-sdb" goto sdb
if "%1"			== "-c" goto c_ache
if "%1"			== "-p" goto put_cache
if "%1"			== "-n" goto new_devspace

set DBNAME=%1
set CONUSR=%2
set CONPWD=%3
set SYSUSR=%4
set SYSPWD=%5
set DOMPWD=%6
set SYSDEV=%7
set TRANSLOGDEV=%8
set CACHESIZE=%9
shift 1
set INITCMD=%9
shift 1
set ERRORLOG=%9
shift 1
set CURPWD=%9
set RUNDIRECTORY=%DBWORK%\wrk\%DBNAME%
set DBSERVICE=0

if "%DBNAME%"			== "" goto error
if "%CONUSR%"			== "" goto error
if "%CONPWD%"			== "" goto error
if "%SYSUSR%"			== "" goto error
if "%SYSPWD%"			== "" goto error
if "%SYSDEV%"			== "" goto error
if "%TRANSLOGDEV%"		== "" goto error
if "%DOMPWD%"			== "" goto error
if "%CACHESIZE%"		== "" goto error
if "%INITCMD%"			== "" goto error

goto start
:sdb
set SDB=%1
set DBNAME=%2
set CONUSR=%3
set CONPWD=%4
set SYSUSR=%5
set SYSPWD=%6
set DOMPWD=%7
set SYSDEV=%8
set TRANSLOGDEV=%9
shift 1
set CATALOG=%9
shift 1
set TAB1=%9
shift 1
set LOADCMD=%9
shift 1
set ERRORLOG=%9

set CACHESIZE=1000
set RUNDIRECTORY=%DBWORK%\wrk\%DBNAME%
goto start

:start

rem SETDOS /Y1
set DEVNULL=nul
%DBROOT%\bin\x_cons %DBNAME% stop
%DBROOT%\bin\x_cons %DBNAME% show state
%DBROOT%\bin\x_cons %DBNAME% show state

echo Anlegen des param-Files fuer %DBNAME%
echo -------------------------------

rem  Werte aus der DB-Konfigurationsdatei abfragen
set GETPARAM=%DBROOT%\pgm\getparam %DBNAME%   
rem  Werte in der DB-Konfigurationsdatei berschreiben
set PUTPARAM=%DBROOT%\pgm\putparam %DBNAME%   
rem  !! ES ERFOLGT KEIN KONSISTENZCHECK !!
set XPARAM=%DBROOT%\bin\x_param -d %DBNAME%

rem  Ablageverzeichnis fr DB-Konfigurationsdateien ggf. erzeugen
if not exist %DBWORK% mkdir %DBWORK%
if not exist %DBWORK%\wrk mkdir %DBWORK%\wrk
if not exist %DBWORK%\wrk\config mkdir %DBWORK%\wrk\config
if not exist %DBCONFIG% mkdir %DBCONFIG%
if not exist %DBCONFIG%\config mkdir %DBCONFIG%\config
if not exist %RUNDIRECTORY% mkdir %RUNDIRECTORY%


rem  ein ggf. schon vorhandene DB-Konfigurationsdatei fr die 
rem  Datenbank %DBNAME% loeschen

echo y | %DBROOT%\bin\x_param -CLEAR %DBNAME% 

rem  "leere" DB-Konfigurationsdatei erzeugen
%XPARAM% -u %CONUSR%,%CONPWD% BINIT
if   not errorlevel == 0 goto error3

rem  Die DEVSPACES in die DB-Konfigurationsdatei patchen
%PUTPARAM% SYSDEVSPACE      %SYSDEV%
if   not errorlevel == 0 goto error4

%PUTPARAM% TRANSACTION_LOG  %TRANSLOGDEV%
if   not errorlevel == 0 goto error4

rem  Limit der Personal Edition
%PUTPARAM% MAXUSERTASKS     3  
if   not errorlevel == 0 goto error4     

rem  Anzahl von DEVSPACEs
rem  = SYSDEVSPACE + TRANSACTION_LOG
rem    + MAXDATADEVSPACES
%PUTPARAM% MAXDEVSPACES     7  
if   not errorlevel == 0 goto error4     

rem  Anzahl von DATADEVSPACEs
rem  = Realanzahl + 1(Reserve)
%PUTPARAM% MAXDATADEVSPACES 5  
if   not errorlevel == 0 goto error4     

rem  Verwaltbare Menge an Datapages
%PUTPARAM% MAXDATAPAGES     25000
if   not errorlevel == 0 goto error4

rem  = Realanzahl(Initialwert DATASIZE_INIT)
rem    + Increment(Reserve DATASIZE_INC) Anzahl von Backupdevices
%PUTPARAM% MAXBACKUPDEVS    1  
if   not errorlevel == 0 goto error4                  

%PUTPARAM% MAXSERVERDB      1
if   not errorlevel == 0 goto error4

rem  Gre DATA_CACHE 4 MB (Shared Memory !!)
%PUTPARAM% DATA_CACHE_PAGES %CACHESIZE%
if   not errorlevel == 0 goto error4

%PUTPARAM% CONV_CACHE_PAGES 23
if   not errorlevel == 0 goto error4

rem  PROC_DATA_PAGES = 20 * Anzahl der gleichzeitig User, die
rem                    DDL-Trigger auslvsen kvnnen
rem  Bei zu kleinen Werten kvnnen -9XXX Fehler wegen Mangel an PROC_DATA_PAGES auftreten
%PUTPARAM% PROC_DATA_PAGES  40
if   not errorlevel == 0 goto error4

%PUTPARAM% RUNDIRECTORY     %RUNDIRECTORY%
if   not errorlevel == 0 goto error4

rem  Tracen unwahrscheinlich, also Datei
%PUTPARAM% KERNELTRACESIZE  100
if   not errorlevel == 0 goto error4          

rem  nicht so gro
%PUTPARAM% LOG_QUEUE_PAGES  10
if   not errorlevel == 0 goto error4

rem  Operatormessages nicht auf die Console
rem %PUTPARAM% OPMSG1 %DEVNULL%                               

rem  DB-Konfigurationsdatei berprfen,
rem  abh. Parameter neu berechnen
%XPARAM% -u %CONUSR%,%CONPWD% BCHECK
if   not errorlevel == 0 goto error5   

rem  RUNDIRECTORY ggf. anlegen
if not exist %RUNDIRECTORY%  mkdir %RUNDIRECTORY% 

echo "Param Datei erstellt"
rem  Datenbankkonfigurationsdatei generieren
rem  LZU starten

SETDOS /Y1
%CURPWD%\kstart %DBROOT%\pgm\kernel -q %DBNAME% 
rem if   not errorlevel == 0 goto error5   	  

%DBROOT%\bin\x_cons %DBNAME% show state

%DBROOT%\bin\xutil -d %DBNAME% -u %CONUSR%,%CONPWD% -b %INITCMD% 
rem if not errorlevel == 0 goto error7

rem  Laden der Systemtabellen

%DBROOT%\bin\x_dbinst %DBNAME% %CONUSR%,%CONPWD% %SYSUSR%,%SYSPWD% %DOMPWD%
if not errorlevel == 0 goto error8

rem install sample db 
if "%SDB%" == "-sdb" goto sdb_load

goto end
:error
echo 9 > %ERRORLOG%
rem echo adabas DBNAME CONUSR CONPWD SYSUSR SYSPWD DOMPWD SYSDEV TRANSLOGDEV > %ERRORLOG%
:error1
echo 1 > %ERRORLOG%
goto end
:error2
echo 2 > %ERRORLOG%
goto end
:error3
echo 3 > %ERRORLOG%
goto end
:error4
echo 4 > %ERRORLOG%
goto end
:error5
echo 5 > %ERRORLOG%
goto end
:error6
echo 6 > %ERRORLOG%
goto end
:error7
echo 7 > %ERRORLOG%
goto end
:error8
echo 8 > %ERRORLOG%

goto end

:file
x_cons %2 SHOW TASKS > %3
goto end

:c_ache
rem  Werte aus der DB-Konfigurationsdatei abfragen
%DBROOT%\pgm\getparam %2 DATA_CACHE_PAGES > %3
goto end

:put_cache
%DBROOT%\pgm\putparam %2 DATA_CACHE_PAGES %3
goto end

:new_devspace
%DBROOT%\bin\xutil -u %2,%3 -d %4 -b %5
goto end

:sdb_load
%DBROOT%\bin\xload -d %DBNAME% -u %SYSUSR%,%SYSPWD% -b %LOADCMD% .\sources\%CATALOG% .\sources\%TAB1% %DEVNULL%

:end
rem unset all variables
set DBNAME=
set CONUSR=
set CONPWD=
set SYSUSR=
set SYSPWD=
set SYSDEV=
set TRANSLOGDEV=
set DOMPWD=
set CACHESIZE=
