#*************************************************************************
#
#   $RCSfile: adabas_linux.sh,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRUNTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRUNTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc..
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
:
#!/bin/sh
# @(#) 
# modifizierter muti
set -x
if test -z $DBROOT 
then
	echo "DBROOT is not set!"
	exit 1
fi
if test -z $DBCONFIG 
then
	echo "DBCONFIG is not set!"
	exit 1
fi
OLDPWD=`pwd`

ECHO="/bin/echo"      # Shells contain built-in echo subcommands
export ECHO

# DEVSPACES ggf. per touch anlegen
check_dev()
{
  FIRST_CHR=`$ECHO $1 | cut -c1`
  if [ "$FIRST_CHR" = "/" ]
  then
      DEV_NAME=$1
  else
      DEV_NAME=$RUNDIRECTORY/$1
  fi
  if [ ! -f $DEV_NAME ]
  then
      touch $DEV_NAME || {
                        $ECHO touch $DEV_NAME failed
                        $ECHO please check Paths, Permissions etc.
                        kill 0
                        }
      $ECHO $DEV_NAME touched
      # Platz f|r die DEVSPACEs sicher reservieren
      dd if=/dev/zero bs=4k of=$DEV_NAME count=$2 || {
                        $ECHO filling $DEV_NAME failed
                        $ECHO please check the free space of the filesystem
                        $ECHO containig the RUNDIRECTORY $RUNDIRECTORY
                        kill 0
                        }
      $ECHO Space for DEVSPACE $DEV_NAME reserved.
  fi
}

if [ "$1" = "-sdb" ]
then
SDB=$1
DBNAME=$2
CONUSR=$3
CONPWD=$4
SYSUSR=$5
SYSPWD=$6
DOMPWD=$7
SYSDEV=$8
TRANSLOGDEV=$9
shift 1
DATADEV=$9
shift 1
CATALOG=$9
shift 1
TAB1=$9

DATASIZE_INIT=2000
MAXDATA_SIZE=4000
LOGSIZE=2000
RUNDIRECTORY=$DBROOT/wrk/DBNAME
  
elif [ "$1" = "-f" ]
then
  $DBROOT/bin/x_cons $2 SHOW TASKS > $3
  exit $RC

elif [ "$1" = "-c" ]
then
	$DBROOT/pgm/getparam $2 DATA_CACHE_PAGES > $3
	exit $RC

elif [ "$1" = "-p" ]
then
	$DBROOT/pgm/putparam $2 DATA_CACHE_PAGES $3
	exit $RC

elif [ "$1" = "-n" ]
then
	RUNDIRECTORY=$DBROOT/wrk/$4
	check_dev $5 $6
	$DBROOT/bin/xutil -u $2,$3 -d $4 -b $7
	exit $RC
else
# Wichtige Parameter der Konfiguration festlegen
DBNAME=$1
CONUSR=$2
CONPWD=$3
SYSUSR=$4
SYSPWD=$5
DOMPWD=$6
SYSDEV=$7
TRANSLOGDEV=$8
DATADEV=$9
shift 1
DATASIZE_INIT=$9
shift 1
MAXDATA_SIZE=$9
shift 1
LOGSIZE=$9
shift 1
CACHESIZE=$9
shift 1
INITCMD=$9
RUNDIRECTORY=$DBROOT/wrk/$DBNAME
# end of parameter settings

fi



soparam ()
{
DEVNULL=/dev/null

$ECHO "Anlegen des param-Files fuer $DBNAME"
$ECHO "-------------------------------"
sleep 5

# Ablageverzeichnis f|r DB-Konfigurationsdateien ggf. erzeugen
if test ! -d $DBROOT/wrk
then
    mkdir -p $DBROOT/wrk
    if test $? -ne 0
    then
	exit 1
    fi
fi
if test ! -d $DBROOT/wrk/config
then
    mkdir -p $DBROOT/wrk/config
    if test $? -ne 0
    then
	exit 1
    fi
fi

if test ! -d $DBCONFIG
then
    mkdir -p $DBCONFIG
    if test $? -ne 0
    then
	exit 1
    fi
fi
if test ! -d $DBCONFIG/config
then
    mkdir -p $DBCONFIG/config
    if test $? -ne 0
    then
	exit 1
    fi
fi
if test ! -d $DBCONFIG/diag
then
    mkdir -p $DBCONFIG/diag
    if test $? -ne 0
    then
	exit 1
    fi
fi

cd $DBCONFIG

GETPARAM="$DBROOT/pgm/getparam $DBNAME"   # Werte aus der DB-Konfigurationsdatei abfragen
PUTPARAM="$DBROOT/pgm/putparam $DBNAME"   # Werte in der DB-Konfigurationsdatei |berschreiben
                                          # !! ES ERFOLGT KEIN KONSISTENZCHECK !!
XPARAM="$DBROOT/bin/x_param -d $DBNAME"

# ein ggf. schon vorhandene DB-Konfigurationsdatei f|r die
# Datenbank $DBNAME lvschen
$ECHO 'y' | $DBROOT/bin/x_param -CLEAR $DBNAME > $DEVNULL
# "leere" DB-Konfigurationsdatei erzeugen
$XPARAM -u $CONUSR,$CONPWD BINIT

# Die DEVSPACES in die DB-Konfigurationsdatei patchen
$PUTPARAM SYSDEVSPACE      $SYSDEV
$PUTPARAM TRANSACTION_LOG  $TRANSLOGDEV
$PUTPARAM MAXUSERTASKS     3                    # Limit der Personal Edition
$PUTPARAM MAXDEVSPACES     7        # Anzahl von DEVSPACEs
                                    # = SYSDEVSPACE + TRANSACTION_LOG
                                    #   + MAXDATADEVSPACES
$PUTPARAM MAXDATADEVSPACES 5        # Anzahl von DATADEVSPACEs
                                    # = Realanzahl + 1(Reserve)
#MAXDATA_SIZE=`expr $DATASIZE_INIT + $DATASIZE_INC`
# $PUTPARAM MAXDATAPAGES     $MAXDATA_SIZE                # Verwaltbare Menge an Datapages
$PUTPARAM MAXDATAPAGES     25000 # Verwaltbare Menge an Datapages
                                                                                                                        # = Realanzahl(Initialwert DATASIZE_INIT)
                                                                                                                        #   + Increment(Reserve DATASIZE_INC)
$PUTPARAM MAXBACKUPDEVS    1                    # Anzahl von Backupdevices
$PUTPARAM MAXSERVERDB      1
$PUTPARAM DATA_CACHE_PAGES $CACHESIZE         # Grv_e DATA_CACHE 4 MB (Shared Memory !!)
$PUTPARAM CONV_CACHE_PAGES 23

# PROC_DATA_PAGES = 20 * Anzahl der gleichzeitig User, die
#                   DDL-Trigger auslvsen kvnnen
# Bei zu kleinen Werten kvnnen -9XXX Fehler wegen Mangel an PROC_DATA_PAGES auftreten
$PUTPARAM PROC_DATA_PAGES   20

$PUTPARAM RUNDIRECTORY     $RUNDIRECTORY

$PUTPARAM KERNELTRACESIZE  100          # Tracen unwahrscheinlich, also Datei
                                                                                                # nicht so gro_
$PUTPARAM LOG_QUEUE_PAGES  10

$PUTPARAM OPMSG1 $DEVNULL                               # Operatormessages nicht auf die Console

$XPARAM -u $CONUSR,$CONPWD BCHECK   # DB-Konfigurationsdatei |berpr|fen,
                                    # abh. Parameter neu berechnen

# RUNDIRECTORY ggf. anlegen
if [ ! -d $RUNDIRECTORY ]
then
        {
   mkdir $RUNDIRECTORY || {
                $ECHO "mkdir $RUNDIRECTORY failed"
                $ECHO "please check Paths, Permissions etc."
      exit 4
                }
   $ECHO RUNDIRECTORY $RUNDIRECTORY created.
        }
fi

SYSDEV_SIZE=`expr $DATASIZE_INIT / 50`
check_dev $SYSDEV $SYSDEV_SIZE
check_dev $TRANSLOGDEV $LOGSIZE
check_dev $DATADEV $DATASIZE_INIT

}
export DBNAME SYSUSR SYSPWD

$DBROOT/bin/x_clear $DBNAME  # hartes Herunterfahren der LZU, falls schon gestartet

soparam $DBNAME         # Datenbankkonfigurationsdatei generieren

$DBROOT/bin/x_start $DBNAME # LZU starten
RC=$?
if [ $RC -ne 0 ]
then
     echo "Database not started - RC=$RC"
     exit $RC
fi

# Namen der DEVSPACE aus der DB-Konfigurationsdatei ermitteln
LOG=`$DBROOT/pgm/getparam $DBNAME TRANSACTION_LOG`
SYS=`$DBROOT/pgm/getparam $DBNAME SYSDEVSPACE`
DATA=`$DBROOT/pgm/getparam $DBNAME DATADEV`
# DATA="DATADEV"

# Parameter von INIT.cmd <SYSDEVSPACE> <LOGDEVSPACESIZE> <TRANSACTIONLOG>
#                       <DATADEVSPACESIZE> <DATADEVSPACE> <SYSDBANAME> <SYSDBAPASSWORD>
$DBROOT/bin/xutil -d $DBNAME -u $CONUSR,$CONPWD -b $INITCMD $SYSDEV $LOGSIZE $TRANSLOGDEV \
         $DATASIZE_INIT $DATADEV $SYSUSR $SYSPWD
RC=$?
if [ $RC -ne 0 ]
then
       echo "Error in xutil - RC=$RC"
       exit $RC
fi
# x_server
# Laden der Systemtabellen
$DBROOT/bin/x_dbinst -u $SYSUSR,$SYSPWD -w $DOMPWD -b -i all
# $DBROOT/bin/x_dbinst $DBNAME $CONUSR,$CONPWD $SYSUSR,$SYSPWD $DOMPWD
RC=$?
if [ $RC -ne 0 ]
then
       echo "Error in x_dbinst - RC=$RC"
       exit $RC
fi

# Hier kvnnten f|r SO n|tzliche Tabellen geladen bzw. User angelegt werden
# xload -u $SYSUSR,$SYSPWD -d $DBNAME -b Ladedatei

if [ "$SDB" == "-sdb" ]
then
$DBROOT/bin/xload -d $DBNAME -u $SYSUSR,$SYSPWD -r LOAD.cmd ./sources/CATALOG ./sources/TAB1 $DEVNULL
fi

cd $OLDPWD


