/*************************************************************************
 *
 *  $RCSfile: adaconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef SDB_ADAINC_HXX
#include "adainc.hxx"
#endif
#ifndef SDB_ADACONN_HXX
#include "adaconn.hxx"
#endif
#ifndef _SDB_SDBRESID_HRC
#include "sdbresid.hrc"
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _SFXFILEDLG_HXX
#include <sfx2/iodlg.hxx>
#endif

#ifndef _SV_WAITOBJ_HXX
#include <vcl/waitobj.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif

#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif

#ifndef _SFXINIPROP_HXX
#include <svtools/iniprop.hxx>
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif

#ifndef _SDB_SDBREL_HXX
#include <sdbrel.hxx>
#endif

#ifndef _SDB_SDBENV_HXX
#include "sdbenv.hxx"
#endif

#include "adatab.hxx"
#include "adacurs.hxx"

#ifndef _SDB_ADASTAT_HXX
#include "adastat.hxx"
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _SDB_ADAMD_HXX
#include <adamd.hxx>
#endif

#ifndef _COM_SUN_STAR_UCB_XPROGRESSHANDLER_HPP_
#include <com/sun/star/ucb/XProgressHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;


static String ADABAS_BATCHFILE;
#include "sdbmap.hxx"

#if defined(MAC)
const char __FAR_DATA sNewLine = '\015';
#elif defined(UNX)
const char __FAR_DATA sNewLine = '\012';
#else
const char __FAR_DATA sNewLine[] = "\015\012";
#endif
#include <sys/types.h>
#include <sys/stat.h>

DBG_NAME(SdbAdaConnection);
map< ::rtl::OUString,SdbAdaConnection::AdaServerInfo,::utl::UStringMixLess> SdbAdaConnection::st_ServerMap;
//-----------------------------------------------------------------------------
SQLHANDLE SdbAdaConnection::EnvironmentHandle() const
{
	String aPath;
	return EnvironmentHandle(GetEnvironment(),aPath);
}

//-----------------------------------------------------------------------------
// DB2 Environment (gemeinsam fuer alle Connections):
SQLHANDLE SdbAdaConnection::EnvironmentHandle(SdbEnvironment* pEnv,String &_rPath)
{
	// Ist (fuer diese Instanz) bereits ein Environment erzeugt worden?
	if (pEnv && pEnv->aADAHandle == NULL)
	{
		SQLHANDLE h = SQL_NULL_HANDLE;
		// Environment allozieren

		// ADABAS-DLL jetzt laden:
		if (!LoadLibrary_Adabas(pEnv,_rPath))
			return SQL_NULL_HANDLE;

		if (NADAAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &h) != SQL_SUCCESS)
			return SQL_NULL_HANDLE;

		// In globaler Struktur merken ...
		pEnv->aADAHandle = (void *) h;
	}

	return (SQLHANDLE) pEnv ? pEnv->aADAHandle : SQL_NULL_HANDLE;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::IsDriverCapable(UWORD nInfoType, ULONG nInfoFlag) const
{
	ULONG n;
	((SdbAdaConnection *)this)->GetAdaInfo(nInfoType,n);
	if (!aStatus.IsSuccessful())
	{
		((SdbAdaConnection *)this)->aStatus.Clear();
		return FALSE;
	}

	return (n & nInfoFlag) == nInfoFlag;
}

//-----------------------------------------------------------------------------
SdbAdaConnection::SdbAdaConnection(SdbEnvironment* pEnv, const String & rNewOptions)
				  :SdbConnection(pEnv, rNewOptions)
{
	DBG_CTOR(SdbAdaConnection,NULL);
	Construct(pEnv);
}

//-----------------------------------------------------------------------------
// Copy CTOR nur fuer den internen Gebrauch
SdbAdaConnection::SdbAdaConnection(const SdbAdaConnection& rConn)
				 :SdbConnection(rConn.GetEnvironment(),rConn.Options())
{
	DBG_CTOR(SdbAdaConnection,NULL);
	Construct(rConn.GetEnvironment());
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::Construct(SdbEnvironment* pEnv)
{
	// Environment Handle besorgen (einmal beim Anlegen des Objektes -
	// wird aus Effizienzgrunden in jedem DB2Connection-Objekt gespeichert)
	String aPath;
	aEnvironmentHandle = EnvironmentHandle(pEnv,aPath);
	aConnectionHandle  = SQL_NULL_HANDLE;
	if (aEnvironmentHandle == SQL_NULL_HANDLE)
	{
		String aText = String(SdbResId(STR_STAT_ADABAS_NOT_FOUND));
		aText.SearchAndReplace(String::CreateFromAscii("#DLL#"),aPath);
		aStatus.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					aStatus.CreateErrorMessage(aText),
					0, String() );
		return;
	}

	// Connection allozieren
	// (Eine DB2-Connection pro SdbConnection).
	SetStatus(NADAAllocHandle(SQL_HANDLE_DBC, aEnvironmentHandle,&aConnectionHandle),
			  SQL_HANDLE_ENV, aEnvironmentHandle);

	if (!aStatus.IsSuccessful()) return;

	aStatus.SetComponent(String::CreateFromAscii("Sdb ADABAS Driver"));

	// Wenn kein Default-Schemaname vorhanden, den Benutzernamen verwenden.
	if (aUserName.Len() == 0 && aOptionsParser.OptionString(String::CreateFromAscii("UID")).Len() > 0)
		aUserName = aOptionsParser.OptionString(String::CreateFromAscii("UID"));
}


//-----------------------------------------------------------------------------
SdbAdaConnection::~SdbAdaConnection()
{
	DBG_DTOR(SdbAdaConnection,NULL);

	if (aConnectionHandle != SQL_NULL_HANDLE)
		NADAFreeHandle(SQL_HANDLE_DBC, aConnectionHandle);
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::GetAdaInfo(UWORD nInfoType, String & rString) const
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	char aValue[512];
	SWORD nValueLen;
	RETCODE nRetCode =
		NADAGetInfo(aConnectionHandle,nInfoType,aValue,sizeof aValue,&nValueLen);

	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetAdaInfo -> ADABAS Info not available");
	}
	else
		rString.AssignAscii((const char*)aValue);

	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::GetAdaInfo(UWORD nInfoType, USHORT & rNumber) const
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	UWORD nValue;
	SWORD nValueLen;
	RETCODE nRetCode =
		NADAGetInfo(aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetAdaInfo -> ADABAS Info not available");
	}
	else
		rNumber = (USHORT)nValue;
	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::GetAdaInfo(UWORD nInfoType, ULONG& rNumber) const
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	ULONG nValue;
	SWORD nValueLen;
	RETCODE nRetCode =
		NADAGetInfo(aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetAdaInfo -> ADABAS Info not available");
	}
	else
		rNumber = (ULONG)nValue;
	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::GetAdaInfo(UWORD nInfoType, BOOL &rBool) const
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	String aString;
	BOOL bResult = GetAdaInfo(nInfoType,aString);
	if (bResult)
		rBool = (aString == String('Y'));
	return bResult;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::OpenImpl()
{
	if (aConnectionHandle == SQL_NULL_HANDLE)
		return FALSE;

	String aOptions = ConnectStr();
	aDsn = aOptionsParser.OptionString(String::CreateFromAscii("DSN"));

	// Verbindung aufbauen

	RETCODE nRetCode = OpenConnection(aOptions,GetEnvironment()->GetLoginTimeOut());
	if (nRetCode == SQL_ERROR)
	{
		SetStatus(nRetCode, SQL_HANDLE_DBC, aConnectionHandle);
		if(aStatus.NativeErrorCode() == -813 && aStatus.SQLState().EqualsAscii("08001"))
		{
			aStatus.Clear();
			nRetCode = OpenConnection(aOptions,GetEnvironment()->GetLoginTimeOut());
			if (nRetCode == SQL_ERROR)
				SetStatus(nRetCode, SQL_HANDLE_DBC, aConnectionHandle);
		}
	}
	else if	(nRetCode == SQL_NO_DATA_FOUND)
	{
		aStatus.Set(SDB_STAT_NO_DATA_FOUND);
	}
	if (!aStatus.IsSuccessful()) return FALSE;

	String aIdentifierQuotation;
	GetAdaInfo(SQL_IDENTIFIER_QUOTE_CHAR,aIdentifierQuotation);
	aIdentifierQuotation.EraseLeadingChars(' ');
	cIdentifierQuotation = aIdentifierQuotation.GetChar(0);

	GetAdaInfo(SQL_SPECIAL_CHARACTERS,aSpecialCharStr);
	aSpecialCharStr.EraseLeadingChars(' ');

	// name des User in der Datenbank, kann unterschiedlich zum login name sein
	GetAdaInfo(SQL_USER_NAME,aUserName);

	// CaseSensitivity
	UINT16 nCaseSensitive = SQL_IC_MIXED;
	GetAdaInfo(SQL_QUOTED_IDENTIFIER_CASE,nCaseSensitive);
	switch (nCaseSensitive)
	{
		case SQL_IC_UPPER:
			eIdentifierCase = SDB_IC_UPPER;
			break;
		case SQL_IC_LOWER:
			eIdentifierCase = SDB_IC_LOWER;
			break;
		case SQL_IC_SENSITIVE:
			eIdentifierCase = SDB_IC_ALL;
			break;
		default:
			eIdentifierCase = SDB_IC_MIXED;
	}

	pTableNames = new SdbStringStlMap(::utl::UStringMixLess((eIdentifierCase & SDB_IC_OBJECT)==SDB_IC_OBJECT));
	aStatus.Clear(); //Ergebnis ignorieren
	return TRUE;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::CloseImpl()
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	DBG_ASSERT(IsOpen(),"SdbAdaConnection: interner Fehler: Verbindung nicht geoeffnet");
	DBG_ASSERT(aEnvironmentHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(aConnectionHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: ConnectionHandle ungueltig");

	SetStatus(NADADisconnect(aConnectionHandle), SQL_HANDLE_DBC, aConnectionHandle);
	return aStatus.IsSuccessful();
}


//-----------------------------------------------------------------------------
void SdbAdaConnection::SetAutoCommit(BOOL bAuto)
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);
	SetStatus(NADASetConnectAttr(aConnectionHandle,
								   SQL_ATTR_AUTOCOMMIT,
								   (SQLPOINTER)((bAuto) ? SQL_AUTOCOMMIT_ON : SQL_AUTOCOMMIT_OFF) ,SQL_IS_INTEGER),
								   SQL_HANDLE_DBC, aConnectionHandle);
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::CommitImpl()
{
	DBG_ASSERT(aEnvironmentHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(aConnectionHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: ConnectionHandle ungueltig");

	SetStatus(NADAEndTran(SQL_HANDLE_DBC,aConnectionHandle,SQL_COMMIT),SQL_HANDLE_DBC, aConnectionHandle);
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::RollbackImpl()
{
	DBG_ASSERT(aEnvironmentHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(aConnectionHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: ConnectionHandle ungueltig");

	SetStatus(NADAEndTran(SQL_HANDLE_DBC,aConnectionHandle,SQL_ROLLBACK),SQL_HANDLE_DBC, aConnectionHandle);
}

//-----------------------------------------------------------------------------
SdbCursor* SdbAdaConnection::CreateCursorImpl(SdbCursorType eType,
											  UINT16 nOptions)
{
	DBG_ASSERT(aEnvironmentHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(aConnectionHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: ConnectionHandle ungueltig");

	return new SdbAdaCursor(this, eType, nOptions);
}

//-----------------------------------------------------------------------------
SdbTable* SdbAdaConnection::CreateTableImpl()
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	DBG_ASSERT(aEnvironmentHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(aConnectionHandle != SQL_NULL_HANDLE,"SdbAdaConnection: interner Fehler: ConnectionHandle ungueltig");

	return new SdbAdaTable(this);
}


//-----------------------------------------------------------------------------
String SdbAdaConnection::ServerNames(SdbStatus& rStat, SdbEnvironment* pEnv)
{
	String aDBCONFIG; aDBCONFIG.AssignAscii(getenv("DBCONFIG"));
	String aDBs;
	if(aDBCONFIG.Len())
	{
		String aDelim = DirEntry::GetAccessDelimiter();
		String aConfigStr(aDBCONFIG);
		(aConfigStr += aDelim) += String::CreateFromAscii("config");
		DirEntry aConfig(aConfigStr);
		if (aConfig.IsValid())
		{
			aConfig += String::CreateFromAscii("*");
			aConfig.ToAbs();
			Dir aDir(aConfig, FSYS_KIND_FILE, FSYS_SORT_NAME | FSYS_SORT_ASCENDING | FSYS_SORT_END);

			for (UINT16 nDirPos = 0;	nDirPos < aDir.Count(); nDirPos++)
				(aDBs += aDir[nDirPos].GetBase()) += SDB_SEPARATOR;
			aDBs.EraseTrailingChars(SDB_SEPARATOR);
		}
	}
	return aDBs;
}

//==================================================================
// Ableitung nur fr das Erzeugen
//==================================================================
class SdbAdaRelation : public SdbRelation
{
	friend class SdbAdaConnection;

protected:
	SdbAdaRelation(SdbConnection* _pConn, const String& _rName)
		:SdbRelation(_pConn, _rName){}

	virtual BOOL DoRefresh();
	void SetName(const String& _rName) {aName = _rName;}
public:
	// Relation loeschen
	virtual BOOL Drop();
	virtual BOOL Update();
};

//------------------------------------------------------------------
BOOL SdbAdaRelation::Update()
{
	SDB_CHK_OPEN_BOOL();
	SDB_CHK_CONNECT_BOOL();

	aStatus.Clear();
	BOOL bResult = FALSE;

	if (!bNew) // nur neu anlegen mglich
	{
		aStatus.SetSequenceError();
	}
	else
	{
		String aCommand;aCommand.AssignAscii("ALTER TABLE ");
		aCommand += pConnection->QuoteTableName(GetTableName());
		aCommand.AppendAscii(" FOREIGN KEY ");
		if (aName.Len() && !IsTempName(aName))
			aCommand += pConnection->IdentifierQuotation(GetName());

		aCommand.AppendAscii(" ( ");
		USHORT i;
		for (i = 1; i < GetColumns()->Count(); i++)
		{
			aCommand += pConnection->IdentifierQuotation(GetColumns()->Column(i)->GetName());
			aCommand.AppendAscii(",");
		}
		aCommand.SetChar(aCommand.Len()-1,')');
		aCommand.AppendAscii(" REFERENCES ");
		aCommand += pConnection->QuoteTableName(GetForeignTableName());
		aCommand.AppendAscii(" (");
		for (i = 1; i < GetColumns()->Count(); i++)
		{
			SdbColumnRelationRef xCol = PTR_CAST(SdbColumnRelation, GetColumns()->Column(i));
			aCommand += pConnection->IdentifierQuotation(xCol.Is() ? xCol->GetForeignName() : String());
			aCommand.AppendAscii(",");
		}
		aCommand.SetChar(aCommand.Len()-1,')');

		UINT16 nDeleteRules = GetDeleteRules();
		// delete rules
		if ((nDeleteRules & ::stardata::DatabaseKeyRule::CASCADE) == ::stardata::DatabaseKeyRule::CASCADE)
			aCommand.AppendAscii(" ON DELETE CASCADE ");
		else if ((nDeleteRules & ::stardata::DatabaseKeyRule::SET_NULL) == ::stardata::DatabaseKeyRule::SET_NULL)
			aCommand.AppendAscii(" ON DELETE SET NULL ");
		else if ((nDeleteRules & ::stardata::DatabaseKeyRule::SET_DEFAULT) == ::stardata::DatabaseKeyRule::SET_DEFAULT)
			aCommand.AppendAscii(" ON DELETE DEFAULT ");

		if (!pConnection->ExecuteSQL(aCommand))
			aStatus = pConnection->Status();

		bResult = aStatus.IsSuccessful();
		if (bResult)
		{
			bNew = FALSE;
			if (IsTempName(aName))
			{
				if (!Refresh())		// temp Name behalten
					aStatus.Clear();
			}
		}
	}
	return bResult;
}

//------------------------------------------------------------------
BOOL SdbAdaRelation::Drop()
{
	SDB_CHK_OPEN_BOOL();
	SDB_CHK_CONNECT_BOOL();

	aStatus.Clear();
	BOOL bResult = FALSE;

	if (!bNew)
	{
		String aCommand;aCommand.AssignAscii("ALTER TABLE ");
		aCommand += pConnection->QuoteTableName(GetTableName());
		aCommand.AppendAscii(" DROP FOREIGN KEY ");

		if (aName.Len() && !IsTempName(aName))
			aCommand += pConnection->IdentifierQuotation(GetName());

		if (!pConnection->ExecuteSQL(aCommand))
			aStatus = pConnection->Status();

		bResult = aStatus.IsSuccessful();
	}
	else
	{
		bResult = TRUE;
	}

	if (bResult)	// beim Vater abmelden
	{
		((SdbAdaConnection*)pConnection)->RemoveChild(this);
		bNew = bOpen = FALSE;
	}
	return bResult;
}

//------------------------------------------------------------------
BOOL SdbAdaRelation::DoRefresh()
{
	SDB_CHK_OPEN_BOOL();
	SDB_CHK_CONNECT_BOOL();

	// den Namen merken, da sich dieser durchaus geaendert haben kann
	if (!((SdbAdaConnection*)pConnection)->FillRelation(*this))
		aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}

//==================================================================
SdbRelation* SdbAdaConnection::CreateRelationImpl(const String& _rName)
{
	return new SdbAdaRelation(this,_rName);
}

//------------------------------------------------------------------
BOOL SdbAdaConnection::FillRelation(SdbAdaRelation& rRel)
{
	// aktualisieren einer Relation
	SDB_CHK_OPEN_BOOL();

	SdbTableRef xTable = OpenTable(rRel.GetTableName()),
				xForeignTable;
	if (xTable)
		xForeignTable = OpenTable(rRel.GetForeignTableName());
	if (xForeignTable)
	{
		SdbCursor* pCursor = OpenRelationCursor(xTable->OwnerName(), xTable->Name());
		if (!pCursor)
			aStatus.SetError(ERRCODE_IO_NOTEXISTS,RELATION,rRel.GetName());
		else
		{
			pCursor->AddRef();
			SdbTableRef	   xRefTable;
			while (pCursor->IsInRange())
			{
				ODbRow& rRow = *pCursor->GetRow();
				// Auswerten der KeySeq
				ODbVariantRef pVal = rRow[9];
				if (!pVal.is() || pVal->isNull())	// ohne Name geht nichts
					break;

				if (pVal->getINT16() == 1)	// gibt es eine neue Relation
				{
					if (xRefTable.Is())			// Relation bereits ausgelesen
						break;

					String aConstraintName;
					ODbVariantRef pVal = rRow[12];
					if (!pVal.is() || pVal->isNull())	// ohne Name einen generieren
						aConstraintName = SdbRelation::CreateTempName();
					else
						aConstraintName = pVal->getString().getStr();

					String aRefTableName;
					String aTableName;
					// Zugriff auf referenzierte Tabelle
					pVal = rRow[2];
					if (pVal.is() && !pVal->isNull())
					{
						aRefTableName += pVal->getString().getStr();
						aRefTableName.EraseTrailingChars(' ');
						aRefTableName += '.';
						aTableName += xTable->OwnerName();
						aTableName += '.';
					}
					pVal = rRow[3];
					if (pVal.is() && !pVal->isNull())
					{
						aRefTableName += pVal->getString().getStr();
						aTableName += xTable->Name();
					}

					xRefTable = OpenTable(aRefTableName);
					// Tabelle gefunden
					if (&xRefTable == &xForeignTable)
					{
						rRel.SetName(aConstraintName);
						// jetzt noch die Attributierungen
						UINT16 nAttributes = 0;
						rRel.SetUpdateRules(nAttributes);

						// Delete rules
						nAttributes = 0;
						pVal = rRow[11];
						UINT16 nAdaAttributes = 0;
						if (pVal.is() && !pVal->isNull())
						{
							nAdaAttributes = pVal->getINT16();
							if (nAdaAttributes & SQL_CASCADE)
								nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
							else if (nAdaAttributes & SQL_RESTRICT)
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
							else if (nAdaAttributes & SQL_SET_NULL)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
							else if (nAdaAttributes & SQL_SET_DEFAULT)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
							else
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
						}

						rRel.SetDeleteRules(nAttributes);
					}
					else
						xRefTable = NULL;
				}

				if (xRefTable.Is())
				{
					const SdbColumn* pColumn = NULL;
					pVal = rRow[8];
					if (pVal.is() && !pVal->isNull())
						pColumn = xTable->OriginalColumns()->Column(pVal->getString().getStr());

					String aForeignName;
					pVal = rRow[4];
					if (pVal.is() && !pVal->isNull())
						aForeignName = pVal->getString().getStr();

					if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName))
					{
						SdbColumnRelation* pRelColumn = rRel.CreateColumn(*pColumn, aForeignName);
						rRel.GetColumns()->AddColumn(pRelColumn);
					}
					else
					{
						// falsche struktur
						aStatus.Set(SDB_STAT_ERROR);
						break;
					}
				}
				pCursor->Next();
			}
			pCursor->ReleaseRef();
		}
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
SdbCursor* SdbAdaConnection::OpenRelationCursor(const String& rSchema, const String& rName)
{
	SdbAdaCursor* pCursor = (SdbAdaCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);

	pCursor->OpenForeignKeys(NULL,NULL, NULL,
		NULL,
		rSchema.GetBuffer(),
		rName.GetBuffer());
	// Spaltennamen
/*		1 	PKTABLE_CAT
		2	PKTABLE_SCHEM
		3	PKTABLE_NAME
		4	PKCOLUMN_NAME
		5 	FKTABLE_CAT
		6 	FKTABLE_SCHEM
		7 	FKTABLE_NAME
		8 	FKCOLUMN_NAME
		9 	KEY_SEQ
		10 	UPDATE_RULE
		11 	DELETE_RULE
		12 	FK_NAME			// constraint name
		13  PK_NAME
		14  DEFERRABILITY
*/
	if (!pCursor->IsInRange())
	{
		pCursor->AddRef();
		pCursor->ReleaseRef();
		pCursor = NULL;
	}
	return pCursor;
}
//------------------------------------------------------------------
// Anzahl der Relationen, ggf. Relationenliste fuellen - fuer alle Tabellen
void SdbAdaConnection::FillAllRelations(SdbRelationList& _rList)
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);
	SdbAdaCursor* pCursor = (SdbAdaCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	String aSQL;aSQL.AssignAscii("SELECT * FROM DOMAIN.SHOW_FOREIGN_KEY");
	pCursor->Open(aSQL);

	SdbRelationRef xRelation;
	SdbTableRef    xRefTable,xRefFKTable;

	String aConstraintName,aRefTableName,aTableName;
	while(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		// alte uebernehmen
		if (xRelation.Is())
		{
			((SdbAdaRelation*)&xRelation)->Open(); // nur das open flag setzen
			_rList.InsertAt(xRelation->GetName(), &xRelation);
			xRelation = NULL;
		}

		ODbVariantRef pVal = rRow[4];
		if (!pVal.is() || pVal->isNull())    // ohne Name einen generieren
			aConstraintName = SdbRelation::CreateTempName();
		else
			aConstraintName = pVal->getString().getStr();

		aTableName.Erase();
		aRefTableName.Erase();
		// Zugriff auf Tabelle
		pVal = rRow[1];
		if (pVal.is() && !pVal->isNull())
		{
			aTableName		= pVal->getString().getStr();
			aTableName.EraseTrailingChars(' ');
			aTableName		+= '.';
		}

		pVal = rRow[2];
		if (pVal.is() && !pVal->isNull())
			aTableName += pVal->getString().getStr();

		// Zugriff auf referenzierte Tabelle
		pVal = rRow[5];
		if (pVal.is() && !pVal->isNull())
		{
			aRefTableName	= pVal->getString().getStr();
			aRefTableName.EraseTrailingChars(' ');
			aRefTableName	+= '.';
		}

		pVal = rRow[6];
		if (pVal.is() && !pVal->isNull())
			aRefTableName += pVal->getString().getStr();

		xRelation = NULL;
		xRefTable = OpenTable(aRefTableName);
		xRefFKTable = OpenTable(aTableName);
		if (xRefTable.Is() && xRefFKTable.Is())
			xRelation = new SdbAdaRelation(this, aConstraintName);

		if (!xRelation.Is())
		{
			xRefTable = NULL;
			xRefFKTable = NULL;
			xRelation = NULL;
		}
		else
		{
			xRelation->SetTableName(aTableName);
			xRelation->SetForeignTableName(aRefTableName);

			// jetzt noch die Attributierungen
			UINT16 nAttributes = 0,
				nAdaAttributes = 0;
			// Delete rules
			pVal = rRow[8];
			nAdaAttributes = 0;
			if (pVal.is() && !pVal->isNull())
			{
				String aAttr(pVal->getString());

				if (aAttr.EqualsAscii("DELETE CASCADE"))
					nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
				else if (aAttr.EqualsAscii("DELETE RESTRICT"))
					nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				else if (aAttr.EqualsAscii("DELETE SET NULL"))
					nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
				else if (aAttr.EqualsAscii("DELETE SET DEFAULT"))
					nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
				else
					nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
			}
			xRelation->SetDeleteRules(nAttributes);
			nAttributes = 0;
			xRelation->SetUpdateRules(nAttributes);
		}
		if (xRelation.Is())
		{

			pVal = rRow[7];
			if (pVal.is() && !pVal->isNull())
			{
				String aForeignName = pVal->getString().getStr();
				pVal = rRow[3];
				if (pVal.is() && !pVal->isNull())
				{
					String aColNames = pVal->getString().getStr();
					aColNames.EraseLeadingChars(' ');
					aForeignName.EraseLeadingChars(' ');
					aColNames.EraseTrailingChars(' ');
					aForeignName.EraseTrailingChars(' ');
					xub_StrLen nCount = aColNames.GetTokenCount(' ');
					String aColName;
					for(xub_StrLen i=0; i < nCount;i++)
					{
						aColName = aColNames.GetToken(i,' ');
						if(aColName.Len())
						{
							const SdbColumn *pColumn = xRefFKTable->OriginalColumns()->Column(aColName);
							if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName.GetToken(i,' ')))
							{
								SdbColumnRelation* pRelColumn = xRelation->CreateColumn(*pColumn, aForeignName.GetToken(i,' '));
								xRelation->GetColumns()->AddColumn(pRelColumn);
							}
							else
							{
								((SdbAdaRelation*)&xRelation)->RemoveFromParent();
								xRelation = NULL;
								pCursor->Next();
								continue;
							}
						}
					}
				}

			}


		}
		pCursor->Next();
	}
	if (xRelation.Is())
	{
		((SdbAdaRelation*)&xRelation)->Open(); // nur das open flag setzen
		_rList.InsertAt(xRelation->GetName(), &xRelation);
	}
	pCursor->ReleaseRef();
}
//------------------------------------------------------------------
//void SdbAdaConnection::FillRelations(SdbRelationList& _rList, const SdbTable& rTable)
void SdbAdaConnection::FillRelations(SdbRelationList& _rList, const String& rName)
{
	String sCatalog, sSchema, sName;
	if (!QualifiedNameComponents(rName, sCatalog, sSchema, sName))
		return;

	DBG_CHKTHIS(SdbAdaConnection,NULL);
	SdbCursor* pCursor = OpenRelationCursor(sSchema, sName);
	if (!pCursor)
		return;

	pCursor->AddRef();
	SdbRelationRef	xRelation;
	SdbTableRef		xRefTable;
	SdbTableRef		xTable;

	while (pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		// Auswerten der KeySeq
		ODbVariantRef pVal = rRow[9];
		if (!pVal.is() || pVal->isNull())	// ohne Name geht nichts
			break;

		if (pVal->getINT16() == 1)	// gibt es eine neue Relation
		{
			// alte uebernehmen
			if (xRelation.Is())
			{
				((SdbAdaRelation*)&xRelation)->Open(); // nur das open flag setzen
				_rList.InsertAt(xRelation->GetName(), &xRelation);
				xRelation = NULL;
			}

			String aConstraintName;
			ODbVariantRef pVal = rRow[12];
			if (!pVal.is() || pVal->isNull())	// ohne Name einen generieren
				aConstraintName = SdbRelation::CreateTempName();
			else
				aConstraintName = pVal->getString().getStr();

			String aRefTableName;
			String aTableName;
			// Zugriff auf referenzierte Tabelle
			pVal = rRow[2];
			if (pVal.is() && !pVal->isNull())
			{
				aRefTableName += pVal->getString().getStr();
				aRefTableName.EraseTrailingChars(' ');
				aRefTableName += '.';
				aTableName += sSchema;
				aTableName += '.';
			}
			pVal = rRow[3];
			if (pVal.is() && !pVal->isNull())
			{
				aRefTableName += pVal->getString().getStr();
				aTableName += sName;
			}

			xRelation = NULL;
			xRefTable = OpenTable(aRefTableName);
			if (xRefTable.Is())
				xRelation = new SdbAdaRelation(this, aConstraintName);
			if (!xRelation.Is())
			{
				xRefTable = NULL;
				xRelation = NULL;
			}
			else
			{
				xRelation->SetTableName(aTableName);
				xRelation->SetForeignTableName(aRefTableName);

				// jetzt noch die Attributierungen
				UINT16 nAttributes = 0,
					nAdaAttributes = 0;

				// Update rules
				pVal = rRow[10];
				if (pVal.is() && !pVal->isNull())
				{
					nAdaAttributes = pVal->getINT16();
					if (nAdaAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nAdaAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nAdaAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
					else if (nAdaAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetUpdateRules(nAttributes);
				nAttributes = 0;


				// Delete rules
				pVal = rRow[11];
				nAdaAttributes = 0;
				if (pVal.is() && !pVal->isNull())
				{
					nAdaAttributes = pVal->getINT16();
					if (nAdaAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nAdaAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nAdaAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
					else if (nAdaAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetDeleteRules(nAttributes);
			}
		}

		if (xRelation.Is())
		{
			// die Tabelle ist vielleicht noch nicht auf
			if (!xTable.Is())
			{
				xTable = OpenTable(rName);
				if (!xTable.Is())
				{
					pCursor->ReleaseRef();
					return;
				}
			}

			const SdbColumn* pColumn = NULL;
			pVal = rRow[8];
			if (pVal.is() && !pVal->isNull())
				pColumn = xTable->OriginalColumns()->Column(pVal->getString().getStr());

			String aForeignName;
			pVal = rRow[4];
			if (pVal.is() && !pVal->isNull())
				aForeignName = pVal->getString().getStr();

			if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName))
			{
				SdbColumnRelation* pRelColumn = xRelation->CreateColumn(*pColumn, aForeignName);
				xRelation->GetColumns()->AddColumn(pRelColumn);
			}
			else
			{
				((SdbAdaRelation*)&xRelation)->RemoveFromParent();
				xRelation = NULL;
			}
		}
		pCursor->Next();
	}
	if (xRelation.Is())
	{
		((SdbAdaRelation*)&xRelation)->Open(); // nur das open flag setzen
		_rList.InsertAt(xRelation->GetName(), &xRelation);
	}

	pCursor->ReleaseRef();
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::FillTableNames(SdbStringStlMap* _pList)
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	// SdbAdaCursor handelt, daher Type Cast:
	SdbAdaCursor* pCursor = (SdbAdaCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	// Einen ganz speziellen Cursor oeffnen: anstelle von
	// Prepare und Execute wird Tables ausgefuehrt; die
	// Ergebnismenge enthaelt die gewuenschten Informationen

	// Zugriff auf die Ergebnismenge normalerweise mit Spaltennamen
	// da manche Treiber aber nicht die Standardnamen verwenden, versuchen wir es bei denen
	// mit der Position
	pCursor->AddRef();
	// Auswahl der Tabellenart
	String aTableType; aTableType.AssignAscii("TABLE;SYNONYM;VIEW;ALIAS");
	for (xub_StrLen i = 0, j = 0; i < 4; i++)
	{
		pCursor->OpenTables(NULL,NULL,NULL,aTableType.GetToken(i,';').GetBuffer());
	/*	Reihenfolge
		1	TABLE_QUALIFIER
		2	TABLE_OWNER
		3	TABLE_NAME
	 */
		String aNewName;
		ODbVariantRef pVal;
		while (pCursor->IsInRange())
		{
			ODbRow& rRow = *pCursor->GetRow();

			pVal = rRow[2];
			if (pVal.is() && !pVal->isNull())
			{
				aNewName = pVal->getString().getStr();
				aNewName += '.';
			}

			pVal = rRow[3];
			if (pVal.is() && !pVal->isNull())
				aNewName += pVal->getString().getStr();
			(*_pList)[aNewName] = i != 2;
			pCursor->Next();
		}
		pCursor->Close();
	}
	pCursor->ReleaseRef();
}

static const UINT16 TYPE_NAME			= 1;
static const UINT16 DATA_TYPE			= 2;
static const UINT16 COLUMN_SIZE			= 3;
static const UINT16 LITERAL_PREFIX		= 4;
static const UINT16 LITERAL_SUFFIX		= 5;
static const UINT16 CREATE_PARAMS		= 6;
static const UINT16 NULLABLE			= 7;
static const UINT16 CASE_SENSITIVE		= 8;
static const UINT16 SEARCHABLE			= 9;
static const UINT16 UNSIGNED_ATTRIBUTE	= 10;
static const UINT16 FIXED_PREC_SCALE	= 11;
static const UINT16 AUTO_UNIQUE_VALUE	= 12;
static const UINT16 LOCAL_TYPE_NAME		= 13;
static const UINT16 MINIMUM_SCALE		= 14;
static const UINT16 MAXIMUM_SCALE		= 15;
static const UINT16 SQL_DATA_TYPE		= 16;
static const UINT16 SQL_DATETIME_SUB	= 17;
static const UINT16 NUM_PREC_RADIX		= 18;
static const UINT16 USER_TYPE			= 19;

//-----------------------------------------------------------------------------
void SdbAdaConnection::FillTypeList(SdbTypeInfoList& rList)
{
	// Typ informationen sammeln
	SdbAdaCursor* pCur = (SdbAdaCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCur->AddRef();

	pCur->OpenTypeInfo(SQL_ALL_TYPES);
	aStatus = pCur->Status();

	SdbTypeInfo* pInfoTimestamp = NULL;
	while (pCur->IsInRange())
	{
		ODbRow& rRow = *pCur->GetRow();
		INT32 nTypeNum = rRow[DATA_TYPE]->getINT16();

		SdbDatabaseType eType = (SdbDatabaseType)MapType(nTypeNum);
		if (eType == SDB_DBTYPE_UNKNOWN)
		{
			pCur->Next();
			continue;
		}

		SdbTypeInfo* pInfo = new SdbTypeInfo;
		pInfo->eType = eType;
		pInfo->aTypeName            = rRow[TYPE_NAME]->getString().getStr();

		// i need a type for the rowver for SQLSpecialColumns
		// this can't be done at the moment, as the timestamp column doesn't work probally
		/*if (pInfo->aTypeName.ICompare("timestamp") == COMPARE_EQUAL)
			pInfoTimestamp	= pInfo;		*/

		ODbVariantRef pValue =   rRow[COLUMN_SIZE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nPrecision       =  0;
		else
			pInfo->nPrecision       = pValue->getINT32();

		pValue = rRow[MINIMUM_SCALE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nMinimumScale       = 0;
		else
			pInfo->nMinimumScale       = pValue->getINT16();

		pValue = rRow[MAXIMUM_SCALE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nScale           = 0;
		else
			pInfo->nScale           = pValue->getINT16();

		pValue = rRow[FIXED_PREC_SCALE];
		pInfo->bCurrency                = pValue.is() && (BOOL)pValue->getINT16();

		pValue = rRow[LITERAL_PREFIX];
		if(pValue.is() && !pValue->isNull())
			pInfo->aLiteralPrefix = pValue->getString().getStr();

		pValue = rRow[LITERAL_SUFFIX];
		if(pValue.is() && !pValue->isNull())
			pInfo->aLiteralSuffix = pValue->getString().getStr();

		pValue = rRow[CREATE_PARAMS];
		if (pInfo->bCurrency && (!pValue.is() || pValue->isNull()))   // wenn keine Parameter zum Kreieren angegeben
			pInfo->eType = SDB_DBTYPE_CURRENCY;                  // dann kann der Datentyp ruhig als Currency angesehen werden

		pValue = rRow[AUTO_UNIQUE_VALUE];
		if (pValue.is() && !pValue->isNull())
			pInfo->bAutoIncrement = pValue->getBOOL();

		if (eType == SDB_DBTYPE_CHAR)
			pInfo->bAutoIncrement = TRUE;

		pValue = rRow[NULLABLE];
		pInfo->bNullable                = !pValue.is() || (BOOL)pValue->getINT16();

		pValue = rRow[SEARCHABLE];
		switch (pValue->getINT16())
		{
			case SQL_UNSEARCHABLE:		pInfo->eSearchType = Search_None;			break;
			case SQL_LIKE_ONLY:			pInfo->eSearchType = Search_Like_Only;		break;
			case SQL_ALL_EXCEPT_LIKE:	pInfo->eSearchType = Search_Except_Like;	break;
			default:					pInfo->eSearchType = Search_All;			break;
		}

		rList.Insert(pInfo, LIST_APPEND);
		pCur->Next();
	}

	// check if there is already a timestamp type like datetime
	if (pInfoTimestamp)
	{
		SdbTypeInfo* pInfo = new SdbTypeInfo;
		*pInfo = *pInfoTimestamp;
		pInfo->bRowVersion = TRUE;
		rList.Insert(pInfo, LIST_APPEND);
	}
	pCur->ReleaseRef();
}

//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::IsCapableImpl(SdbCapability eCapability) const
{
	BOOL bResult=FALSE;
	switch (eCapability)
	{
		// Von DB2 erfragbare Capabilities:
		// Updatebar, wenn
		case SDB_CAP_UPDATABLE:
			bResult = SdbConnection::IsCapableImpl(eCapability);
			break;
		case SDB_CAP_BULKOPTIMIZE:
			bResult = TRUE; break;
		case SDB_CAP_READ_UNCOMMITTED:	bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_UNCOMMITTED); break;
		case SDB_CAP_READ_COMMITTED:	bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_COMMITTED); break;
		case SDB_CAP_REPEATABLE_READ:	bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_REPEATABLE_READ); break;
		case SDB_CAP_SERIALIZABLE:		bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_SERIALIZABLE); break;

	// Sonstige Capabilities:
		case SDB_CAP_COMMIT_AUTO:
		case SDB_CAP_COMMIT_MANUAL:

		case SDB_CAP_JOIN:
		case SDB_CAP_CREATE_TABLE:
		case SDB_CAP_ALTER_TABLE:
		case SDB_CAP_RENAME_TABLE:
		case SDB_CAP_CREATE_INDEX:
		case SDB_CAP_CREATE_VIEW:
		case SDB_CAP_PRIMARYKEYS:
		case SDB_CAP_FOREIGNKEYS:
		case SDB_CAP_DESC_INDEX:
		case SDB_CAP_USERSETTINGS:
		case SDB_CAP_STATIC_PRIOR:
		case SDB_CAP_KEYSET_PRIOR:
			bResult = TRUE; break;
		case SDB_CAP_BACKUP:
			{
				String aDBName;
				if(GetDbNameFromDsn(aOptionsParser.OptionString(String::CreateFromAscii("DSN")),aDBName) &&
				   aOptionsParser.OptionString(String::CreateFromAscii("CTRLUSER")).Len() && aOptionsParser.OptionString(String::CreateFromAscii("CTRLPWD")).Len())
				{
					bResult = TRUE;
				}
			}
			break;
		default:
			bResult = SdbConnection::IsCapableImpl(eCapability);
	}
	return bResult;
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::SetIsolationLevelImpl(SdbIsolationLevel eNewIsolationLevel)
{
	DBG_CHKTHIS(SdbAdaConnection,NULL);

	UDWORD nValue;
	switch (eNewIsolationLevel)
	{
		case SDB_ISO_READ_UNCOMMITTED:	nValue = SQL_TXN_READ_UNCOMMITTED; break;
		case SDB_ISO_READ_COMMITTED:	nValue = SQL_TXN_READ_COMMITTED; break;
		case SDB_ISO_REPEATABLE_READ:	nValue = SQL_TXN_REPEATABLE_READ; break;
		case SDB_ISO_SERIALIZABLE:		nValue = SQL_TXN_SERIALIZABLE; break;
		//case SDB_ISO_VERSIONING:		nValue = SQL_TXN_VERSIONING; break;
		default:						aStatus.SetDriverNotCapableError();
										return;
	}

	SetStatus(NADASetConnectAttr(aConnectionHandle,
								   SQL_ATTR_TXN_ISOLATION,
								   (SQLPOINTER)nValue,SQL_IS_INTEGER),
								   SQL_HANDLE_DBC, aConnectionHandle);
	if (! aStatus.IsSuccessful()) return;

	eIsolationLevel = eNewIsolationLevel;
}

//-----------------------------------------------------------------------------
SdbDatabaseType SdbAdaConnection::MapType(INT16 nDB2Type)
{
	switch(nDB2Type)
	{
		case SQL_CHAR:			return SDB_DBTYPE_CHAR;
		case SQL_VARCHAR: 		return SDB_DBTYPE_VARCHAR;
		case SQL_LONGVARCHAR: 	return SDB_DBTYPE_LONGVARCHAR;
		case SQL_DECIMAL:		return SDB_DBTYPE_DECIMAL;
		case SQL_NUMERIC:		return SDB_DBTYPE_NUMERIC;
		case SQL_BIT: 			return SDB_DBTYPE_BOOLEAN;
		case SQL_TINYINT:		return SDB_DBTYPE_TINYINT;
		case SQL_SMALLINT:		return SDB_DBTYPE_SMALLINT;
		case SQL_INTEGER:		return SDB_DBTYPE_INTEGER;
		case SQL_BIGINT: 		return SDB_DBTYPE_BIGINT;
		case SQL_REAL: 			return SDB_DBTYPE_REAL;
		case SQL_FLOAT:
		case SQL_DOUBLE:		return SDB_DBTYPE_DOUBLE;
		case SQL_BINARY:		return SDB_DBTYPE_BINARY;
		case SQL_VARBINARY: 	return SDB_DBTYPE_VARBINARY;
		case SQL_LONGVARBINARY:	return SDB_DBTYPE_LONGVARBINARY;
		case SQL_DATE: 			return SDB_DBTYPE_DATE;
		case SQL_TIME: 			return SDB_DBTYPE_TIME;
		case SQL_TIMESTAMP: 	return SDB_DBTYPE_TIMESTAMP;
		default:				return SDB_DBTYPE_UNKNOWN;
	}
}
//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::DoCmdImpl(UINT16 nCmd,const String &rArgs)
{
	switch(nCmd)
	{
		case SDB_CAP_BACKUP:
			{
				String aDelim = DirEntry::GetAccessDelimiter();
				String aPath;
				aPath.AssignAscii(getenv("DBROOT"));
				(((aPath += aDelim) += String::CreateFromAscii("bin")) += aDelim) += String::CreateFromAscii("xutil");
#if defined(WIN) || defined(WNT)
				aPath.AppendAscii(".exe");
#endif
				String aDSN = aOptionsParser.OptionString(String::CreateFromAscii("DSN"));
				String aDBName;
				if(GetDbNameFromDsn(aDSN,aDBName))
				{
					//	xutil -U CONTROL "SAVE DATA QUICK TO '$SAVE_PATH' BLOCKSIZE 8"

					DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));

					String aFileName = aEntry.GetFull();
					{
						SvFileStream aFileStream(aFileName,STREAM_WRITE);
						aFileStream << "SAVE DATA QUICK TO '";
						aFileStream << ByteString(rArgs,gsl_getSystemTextEncoding()).GetBuffer();
						aFileStream << "' BLOCKSIZE 8" << sNewLine;
					}
					
					String aUs;
					((aUs = aOptionsParser.OptionString(String::CreateFromAscii("CTRLUSER"))) += ',') += aOptionsParser.OptionString(String::CreateFromAscii("CTRLPWD"));

					::rtl::OUString aArgs[] = {
											String::CreateFromAscii("-u"),
											aUs,
											String::CreateFromAscii("-d"),
											aDBName,
											String::CreateFromAscii("-b"),
											aFileName
					};
					::vos::OArgumentList aArgumentList(aArgs,6);

					String aWorkDir;
					aWorkDir.AssignAscii(getenv("DBWORK"));
					::vos::OProcess aApp2( aPath,aWorkDir);

					::vos::OProcess::TProcessError eError = aApp2.execute(
						(::vos::OProcess::TProcessOption)
						(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );

					aEntry.Kill();

					return eError == ::vos::OProcess::E_None;
				}
			}
			break;
		default:
			DBG_ERROR("Not supported by this driver");
			;
	}
	return TRUE;
}														   // restore data quick from 'hh' blocksize 8
//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::GetDbNameFromDsn(const String& _rDsn,String &rDB) const
{
	rDB = _rDsn.GetToken(0,':');
	BOOL bStartServer = TRUE;
	if(rDB.Len() && _rDsn.GetTokenCount(':') >= 2)
	{
		sal_uInt32 nLen = 255;
		rtl_uString *pHostName = new rtl_uString[nLen];
		osl_getLocalHostname(&pHostName);
		String aHst(pHostName);
		delete pHostName;
		if(aHst.CompareTo(rDB,rDB.Len()) != COMPARE_EQUAL)
			bStartServer = FALSE;
		else
			rDB = _rDsn.GetToken(1,':');
	}
	else if(_rDsn.GetTokenCount(':') >= 2)
		rDB = _rDsn.GetToken(1,':');
	return bStartServer;
}
//-----------------------------------------------------------------------------
RETCODE SdbAdaConnection::OpenConnection(const String& aConnectStr, INT32 nTimeOut)
{
	if (aConnectionHandle == SQL_NULL_HANDLE)
		return -1;

	NADASetConnectAttr(aConnectionHandle,SQL_ATTR_LOGIN_TIMEOUT,(SQLPOINTER)nTimeOut,SQL_IS_INTEGER);

	// now set the adabas specific parameters
	String aDSN = aOptionsParser.OptionString(String::CreateFromAscii("DSN"));
	if(aDSN.GetTokenCount(':') == 1)
	{
		String aTmp = String::CreateFromAscii(":");
		aTmp += aDSN;
		aDSN = aTmp;
	}

	ByteString aDSN1(aDSN,gsl_getSystemTextEncoding());
	ByteString aUID(aOptionsParser.OptionString(String::CreateFromAscii("UID")),gsl_getSystemTextEncoding());
	ByteString aPWD(aOptionsParser.OptionString(String::CreateFromAscii("PWD")),gsl_getSystemTextEncoding());

	SWORD nDsnLen = aDSN1.Len() ? aDSN1.Len() : 1;
	SWORD nUidLen = aUID.Len() ? aUID.Len() : 1;
	SWORD nPwdLen = aPWD.Len() ? aPWD.Len() : 1;

	SDB_ADA_CHAR *szDSN = new SDB_ADA_CHAR[nDsnLen + 1];
	SDB_ADA_CHAR *szUID = new SDB_ADA_CHAR[nUidLen + 1];
	SDB_ADA_CHAR *szPWD = new SDB_ADA_CHAR[nPwdLen + 1];

	memcpy(szDSN, (SDB_ADA_CHAR*) aDSN1.GetBuffer(), nDsnLen);
	memcpy(szUID, (SDB_ADA_CHAR*) aUID.GetBuffer(), nUidLen);
	memcpy(szPWD, (SDB_ADA_CHAR*) aPWD.GetBuffer(), nPwdLen);

	szDSN[nDsnLen] = 0;
	szUID[nUidLen] = 0;
	szPWD[nPwdLen] = 0;

	String aHostname;
	BOOL bStartServer = GetDbNameFromDsn(aDSN,aHostname);

	SdbEnvironmentRef xEnv = SdbEnvironmentRef();
	::com::sun::star::uno::Reference< ::com::sun::star::ucb::XProgressHandler > xProg;
	if (xEnv.Is())
		xProg = xEnv->GetProgressHandler();

	BOOL bTryAgain = TRUE;
	if (bStartServer && getenv("DBROOT"))
	{
		map< ::rtl::OUString,AdaServerInfo, ::utl::UStringMixLess>::iterator aIter = st_ServerMap.find(aHostname);
		if(aIter == st_ServerMap.end())
		{
			if(!ADABAS_BATCHFILE.Len()) // XXXX I have to remember the batch file
			{
				SfxAppIniManagerProperty aIniManProp;
				GetpApp()->Property(aIniManProp);
				ADABAS_BATCHFILE = aIniManProp.GetIniManager()->GetProgramPath();
				(ADABAS_BATCHFILE += DirEntry::GetAccessDelimiter()) += String::CreateFromAscii("kstart");
#if defined(WIN) || defined(WNT)
				ADABAS_BATCHFILE += String::CreateFromAscii(".exe");
#endif

			}
			AdaServerInfo aInfo;
			aInfo.aCtrlUser = aOptionsParser.OptionString(String::CreateFromAscii("CTRLUSER"));
			aInfo.aCtrlPwd	= aOptionsParser.OptionString(String::CreateFromAscii("CTRLPWD"));
			aInfo.aShutdown = aOptionsParser.OptionBool(String::CreateFromAscii("SHUTSERVICE"));
			if(aInfo.aCtrlPwd.Len() && aInfo.aCtrlUser.Len())
				st_ServerMap[aHostname] = aInfo;

			if(NADAConnect(aConnectionHandle, szDSN, nDsnLen, szUID, nUidLen, szPWD, nPwdLen) == -1 )
			{
				if(aInfo.aCtrlUser.Len() && aInfo.aCtrlPwd.Len() && aDSN.Len()) // I only can restart when I have this info
				{
					if(xProg.is())
					{
						AdabasKernelState aNewState;
						aNewState.m_DBName = aHostname;
						aNewState.m_CtrlUid = aInfo.aCtrlUser;
						aNewState.m_CtrlPwd = aInfo.aCtrlPwd;
						aNewState.m_KernelState = DEAD;

						// as this call is synchron we can just put the pointer
						::staruno::Any aState;
						aState <<= sal_Int64(&aNewState);
						xProg->update(aState);
					}
					String aStart; aStart.AssignAscii(getenv("DBROOT"));

					::vos::OProcess::TProcessError eError = ::vos::OProcess::E_None;
					if(Actualize(aHostname) == DEAD)
					{
						::rtl::OUString aArgs[] = {
										String::CreateFromAscii("-k"),
										aHostname
						};
						::vos::OArgumentList aArgumentList(aArgs,2);

						String aWorkDir;
						aWorkDir.AssignAscii(getenv("DBWORK"));
						::vos::OProcess aApp( ADABAS_BATCHFILE,aWorkDir);

					//	WaitObject aWait;
						eError = aApp.execute(
							(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait) ,aArgumentList);
#if ( defined(SOLARIS) && defined(SPARC)) || defined(LINUX)
						if(Actualize(aHostname) == DEAD)
						{
							String aX_Clear(aStart);
							aX_Clear += String::CreateFromAscii("/bin/x_clear");
							rtl::OUString aTmpStr(aHostname);
							::vos::OArgumentList aArgumentList2(1,&aTmpStr);
							::vos::OProcess aApp2( aX_Clear, aWorkDir);
							eError = aApp2.execute(
									(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList2 );
							eError = aApp.execute(
									(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
						}
#endif
					}
					if(eError == ::vos::OProcess::E_None)
					{
						if(xProg.is())
						{
							AdabasKernelState aNewState;
							aNewState.m_DBName = aHostname;
							aNewState.m_KernelState = Actualize(aHostname);
							::staruno::Any aState;
							aState <<= sal_Int64(&aNewState);
							xProg->update(aState);
						}
						String aUsr(aOptionsParser.OptionString(String::CreateFromAscii("CTRLUSER")));
						String aPwd(aOptionsParser.OptionString(String::CreateFromAscii("CTRLPWD")));

						::rtl::OUString aArgs[] = {
											String::CreateFromAscii("-r"),
											aHostname,
											aUsr,
											aPwd
						};
						::vos::OArgumentList aArgumentList(aArgs,4);

						String aWorkDir;
						aWorkDir.AssignAscii(getenv("DBWORK"));
						::vos::OProcess aApp( ADABAS_BATCHFILE,aWorkDir);

						eError = aApp.execute(
							(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait) ,aArgumentList);
						if(xProg.is())
						{
							AdabasKernelState aNewState;
							aNewState.m_DBName = aHostname;
							aNewState.m_KernelState = Actualize(aHostname);
							::staruno::Any aState;
							aState <<= sal_Int64(&aNewState);
							xProg->update(aState);
						}
					}
				}
				bTryAgain = TRUE;
			}
			else
				bTryAgain = FALSE;
		}
		else
			(*aIter).second.aShutdown = aOptionsParser.OptionBool(String::CreateFromAscii("SHUTSERVICE"));
	}

	if(bTryAgain && NADAConnect(aConnectionHandle, szDSN, nDsnLen, szUID, nUidLen, szPWD, nPwdLen) == -1)
	{
		map< ::rtl::OUString,AdaServerInfo,::utl::UStringMixLess>::iterator aIter = st_ServerMap.find(aHostname);
		if(aIter != st_ServerMap.end())
			st_ServerMap.erase(aIter);

		delete szDSN;
		delete szUID;
		delete szPWD;
		return -1;
	}
	else if(bStartServer && xProg.is())
	{
		AdabasKernelState aNewState;
		aNewState.m_DBName = aHostname;
		aNewState.m_CtrlUid = aOptionsParser.OptionString(String::CreateFromAscii("CTRLUSER"));
		aNewState.m_CtrlPwd = aOptionsParser.OptionString(String::CreateFromAscii("CTRLPWD"));
		aNewState.m_KernelState = Actualize(aHostname);
		
		::staruno::Any aState;
		aState <<= sal_Int64(&aNewState);
	}

//	if(!aDSN.Len())
//		return -1;

	if(CheckNewDevSpace(aHostname))
	{
		if(NADAConnect(aConnectionHandle, szDSN, nDsnLen, szUID, nUidLen, szPWD, nPwdLen) == -1)
		{
			map< ::rtl::OUString,AdaServerInfo,::utl::UStringMixLess>::iterator aIter = st_ServerMap.find(aHostname);
			if(aIter != st_ServerMap.end())
				st_ServerMap.erase(aIter);
			delete szDSN;
			delete szUID;
			delete szPWD;
			return -1;
		}
	}
	delete szDSN;
	delete szUID;
	delete szPWD;
	return 0;
}
//-----------------------------------------------------------------------------
KernelState SdbAdaConnection::Actualize(const String& _rHost) const
{
	DirEntry aOut(DirEntry().TempName(FSYS_KIND_FILE));
	String aFileName(aOut.GetFull());

	::rtl::OUString aArgs[] = {
					String::CreateFromAscii("-d"),
					_rHost,
					aFileName
	};
	::vos::OArgumentList aArgumentList(aArgs,3);

	String aWorkDir;
	aWorkDir.AssignAscii(getenv("DBWORK"));
	::vos::OProcess aApp( ADABAS_BATCHFILE,aWorkDir);
	aApp.execute( (::vos::OProcess::TProcessOption)
				  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait) ,aArgumentList);

	KernelState eServiceRunning = DEAD;
	{// only for killing the file
		SvFileStream aOutStream(aFileName,STREAM_READ);
		BOOL bRead = TRUE;
		while(bRead && !aOutStream.IsEof())
		{
			ByteString aLine;
			bRead = aOutStream.ReadLine(aLine);
			if(aLine.Search("WARM") != STRING_NOTFOUND)
			{
				eServiceRunning = WARM;
				break;
			}
			else if(aLine.Search("COLD") != STRING_NOTFOUND)
			{
				eServiceRunning = COLD;
				break;
			}
		}
	}
	aOut.Kill();
	return eServiceRunning;
}
//-----------------------------------------------------------------------------
BOOL SdbAdaConnection::CheckNewDevSpace(const String& _rHostname)
{
	INT32 nDataInc = aOptionsParser.OptionInt(String::CreateFromAscii("DATAINC")) * 256;
	if(!nDataInc) // no new datadevspace
		return FALSE;
	bOpen = TRUE;
	String aUID(aOptionsParser.OptionString(String::CreateFromAscii("UID")));
	SdbAdaCursor* pCursor = (SdbAdaCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	pCursor->OpenDatabaseSize(aUID);
	if (!pCursor->IsInRange())
	{
		pCursor->ReleaseRef();
		pCursor = NULL;
		return FALSE;
	}
	// there is only one row
	ODbRow& rRow = *pCursor->GetRow();
	ODbVariantRef pVal = rRow[1];
	double nUsedPages = pVal->getDouble();
	pVal = rRow[2];
	double nFreePages = pVal->getDouble();

	if(nFreePages < (nUsedPages/3)) // now I need a new datadevspace
	{
		pCursor->Close();
		pCursor->OpenDatabaseDevPaths(aUID);
		::rtl::OUString aPath;
		INT32 nDevCount=0;
		ODbVariantRef pValPath;
		while(pCursor->IsInRange())
		{
			ODbRow& rRowDev = *pCursor->GetRow();
			pValPath = rRowDev[1];
			aPath = pValPath->getString();
			nDevCount++;
			pCursor->Next();
		}
		String aNewPath(aPath);
		aNewPath.Erase(aNewPath.Len()-1);
		aNewPath += String::CreateFromInt32(nDevCount);
		DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
		String aFileName = aEntry.GetFull();
		{
			SvFileStream aFileStream(aFileName,STREAM_WRITE);
			aFileStream << "ADD DATA DEVSPACE \'";
			aFileStream << ByteString(aNewPath,gsl_getSystemTextEncoding()).GetBuffer();
			aFileStream << "\' PAGES ";
			aFileStream << ByteString::CreateFromInt32(nDataInc).GetBuffer();
			aFileStream << sNewLine;
		}

		::rtl::OUString aArgs[] = {
						String::CreateFromAscii("-n"),
						aUID,
						aOptionsParser.OptionString(String::CreateFromAscii("PWD")),
						_rHostname,
						aFileName
		};
		::vos::OArgumentList aArgumentList(aArgs,5);

		String aWorkDir;
		aWorkDir.AssignAscii(getenv("DBWORK"));
		::vos::OProcess aApp1( ADABAS_BATCHFILE,aWorkDir);

		pCursor->ReleaseRef();
		// before I execute I have to close the connection because I don't know in which mode I am
		NADADisconnect(aConnectionHandle);

		::vos::OProcess::TProcessError eError = aApp1.execute(
				(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),
				aArgumentList);
		aEntry.Kill();
		return TRUE;
	}
	else
		pCursor->ReleaseRef();
	bOpen = FALSE;
	return FALSE;
}
//-----------------------------------------------------------------------------
String SdbAdaConnection::ConnectStr() const
{
	String aOptions;
	aOptionsParser.Compose(aOptions,String::CreateFromAscii(pReservedOptions));	// Alles ausser den Sdb-internen Optionen weiterreichen
	aOptions.EraseLeadingChars(';');
	aOptions.EraseTrailingChars(';');
	return aOptions;
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::SetStatus(RETCODE nRetcode, SQLSMALLINT HandleType, SQLHANDLE aHandle,
								 const String& rErrorInfo)
{
	SdbAda_SetStatus(aStatus, nRetcode, HandleType, aHandle, rErrorInfo);
}

//-----------------------------------------------------------------------------
::stardata::XDatabaseDescriptor* SdbAdaConnection::GetMetaDataImpl()
{
	SdbAdaMetaData* pMetaData = new SdbAdaMetaData(this);
	return pMetaData;
}

//-----------------------------------------------------------------------------
void SdbAdaConnection::FreeEnv(SdbEnvironment* pEnv)
{
	NADAFreeHandle(SQL_HANDLE_ENV, pEnv->aADAHandle);
	String aWorkDir;
	aWorkDir.AssignAscii(getenv("DBWORK"));

	for(map< ::rtl::OUString,AdaServerInfo,::utl::UStringMixLess>::const_iterator aIter = st_ServerMap.begin();aIter != st_ServerMap.end();++aIter)
	{
		AdaServerInfo aInfo = (*aIter).second;
		if(aInfo.aShutdown && aInfo.aCtrlUser.Len() && aInfo.aCtrlPwd.Len())
		{
			DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
			String aFileName(aEntry.GetFull());
			// is there any user still connected ?
			::rtl::OUString aArgs[] = {
							String::CreateFromAscii("-f"),
							(*aIter).first,
							aFileName
			};
			::vos::OArgumentList aArgumentList(aArgs,3);

			::vos::OProcess aApp1( ADABAS_BATCHFILE,aWorkDir);

			::vos::OProcess::TProcessError eError = aApp1.execute(
				(::vos::OProcess::TProcessOption)(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList );
			{
				SvFileStream aFileStream(aFileName,STREAM_READ);
				ByteString aValue;
				BOOL bUserConnected = FALSE;
				BOOL bRead = TRUE;
				while(bRead && !bUserConnected && !aFileStream.IsEof())
				{
					bRead = aFileStream.ReadLine(aValue);
					bUserConnected = aValue.Search("User") != STRING_NOTFOUND;
				}

				if(!bUserConnected)
				{
					::rtl::OUString aArgs2[] = {
									String::CreateFromAscii("-x"),
									(*aIter).first,
									aInfo.aCtrlUser,
									aInfo.aCtrlPwd
					};
					::vos::OArgumentList aArgumentList2(aArgs2,4);

					::vos::OProcess aApp2( ADABAS_BATCHFILE,aWorkDir);

					eError = aApp2.execute(
						(::vos::OProcess::TProcessOption)
						(::vos::OProcess::TOption_Hidden|::vos::OProcess::TOption_Wait),aArgumentList2 );
					if(eError == ::vos::OProcess::E_None)
					{
						::rtl::OUString aArgs3[] = {
													String::CreateFromAscii("-t"),
													(*aIter).first
						};
						::vos::OArgumentList aArgumentList3(aArgs3,2);

						::vos::OProcess aApp3( ADABAS_BATCHFILE,aWorkDir);
						aApp3.execute( (::vos::OProcess::TProcessOption)::vos::OProcess::TOption_Hidden,aArgumentList3);
					}
				}
			}
			aEntry.Kill();
		}
	}
	st_ServerMap.clear();
}


