/*************************************************************************
 *
 *  $RCSfile: adaimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "adainc.hxx"

#ifndef _OSL_MODULE_H_
#include <osl/module.h>
#endif
#include <sdbenv.hxx>
#ifndef _SFXINIPROP_HXX //autogen wg. SfxAppIniManagerProperty
#include <svtools/iniprop.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen wg. SfxIniManager
#include <svtools/iniman.hxx>
#endif

sal_Bool LoadFunctions(oslModule pso, sal_Bool _bDS);
// Dynamisches Laden der DLL/shared lib und Adressen der Funktionen besorgen:
// Liefert TRUE bei Erfolg.
BOOL LoadLibrary_Adabas(SdbEnvironment* pEnv,String &_rPath)
{
	static sal_Bool bLoaded = sal_False;
	static oslModule pso = NULL;

	if (bLoaded)
		return TRUE;

	char *pPath =getenv("DBROOT");
	if(pPath)
	{
		_rPath = String::CreateFromAscii(pPath);
#if defined(WIN) || defined(WNT)
		_rPath += String::CreateFromAscii("\\pgm\\");
#elif ( defined(SOLARIS) && defined(SPARC)) || defined(LINUX)
		_rPath += String::CreateFromAscii("/lib/");
#endif
	}
#if defined(WIN) || defined(WNT)
	_rPath += String::CreateFromAscii("SQLOD32.DLL");
#elif ( defined(SOLARIS) && defined(SPARC)) || defined(LINUX)
	_rPath += String::CreateFromAscii("odbclib.so");
#else
	return sal_False;
#endif

	pso = osl_loadModule( ::rtl::OUString(_rPath.GetBuffer()).pData,SAL_LOADMODULE_NOW );
	if( !pso)
		return sal_False;

	bLoaded = LoadFunctions(pso,sal_False);
	pEnv->AppendLibrary(pso);
	return bLoaded;
}

sal_Bool LoadFunctions(oslModule pso, sal_Bool _bDS)
{
	if( ( pADAAllocHandle	=	(TADAAllocHandle)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocHandle").pData )) == NULL )
		return sal_False;
	if( ( pADAConnect		=	(TADAConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLConnect").pData )) == NULL )
		return sal_False;
	if( ( pADADriverConnect =	(TADADriverConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDriverConnect").pData )) == NULL )
		return sal_False;
	if( ( pADABrowseConnect =   (TADABrowseConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBrowseConnect").pData )) == NULL )
		return sal_False;
	if( ( pADAGetInfo		=	(TADAGetInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetInfo").pData )) == NULL )
		return sal_False;
	if( ( pADAGetTypeInfo	=	(TADAGetTypeInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetTypeInfo").pData )) == NULL )
		return sal_False;
	if( ( pADASetConnectAttr	=	(TADASetConnectAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetConnectAttr").pData )) == NULL )
		return sal_False;
	if( ( pADASetStmtAttr	=	(TADASetStmtAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetStmtAttr").pData )) == NULL )
		return sal_False;
	if( ( pADAGetStmtAttr	=	(TADAGetStmtAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetStmtAttr").pData )) == NULL )
		return sal_False;
	/*if( ( pADASetDescField	=	(TADASetDescField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetDescField").pData )) == NULL )
		return sal_False;
	if( ( pADAGetDescField	=	(TADAGetDescField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDescField").pData )) == NULL )
		return sal_False;*/
	/*if( ( pADAGetDescRec	=	(TADAGetDescRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDescRec").pData )) == NULL )
		return sal_False;
	if( ( pADASetDescRec	=	(TADASetDescRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetDescRec").pData )) == NULL )
		return sal_False;*/
	if( ( pADAPrepare		=	(TADAPrepare)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrepare").pData )) == NULL )
		return sal_False;
	if( ( pADABindParameter =	(TADABindParameter)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindParameter").pData )) == NULL )
		return sal_False;
//	if( ( pADAGetCursorName =	(TADAGetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetCursorName").pData )) == NULL )
//		return sal_False;
	if( ( pADAExecute		=	(TADAExecute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecute").pData )) == NULL )
		return sal_False;
	if( ( pADAExecDirect	=	(TADAExecDirect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecDirect").pData )) == NULL )
		return sal_False;
	/*if( ( pADANativeSql		=	(TADANativeSql)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNativeSql").pData )) == NULL )
		return sal_False;*/
	if( ( pADADescribeParam =   (TADADescribeParam)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeParam").pData )) == NULL )
		return sal_False;
	if( ( pADANumParams		=	(TADANumParams)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumParams").pData )) == NULL )
		return sal_False;
	if( ( pADAParamData		=	(TADAParamData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamData").pData )) == NULL )
		return sal_False;
	if( ( pADAPutData		=	(TADAPutData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPutData").pData )) == NULL )
		return sal_False;
	if( ( pADARowCount		=	(TADARowCount)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLRowCount").pData )) == NULL )
		return sal_False;
	if( ( pADANumResultCols =	(TADANumResultCols)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumResultCols").pData )) == NULL )
		return sal_False;
	if( ( pADADescribeCol	=	(TADADescribeCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeCol").pData )) == NULL )
		return sal_False;
	if( ( pADAColAttribute =	(TADAColAttribute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColAttribute").pData )) == NULL )
		return sal_False;
	if( ( pADABindCol		=	(TADABindCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindCol").pData )) == NULL )
		return sal_False;
	if( ( pADAFetch			=	(TADAFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFetch").pData )) == NULL )
		return sal_False;
	if( ( pADAGetData		=	(TADAGetData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetData").pData )) == NULL )
		return sal_False;
	/*if( ( pADAGetDiagField	=	(TADAGetDiagField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDiagField").pData )) == NULL )
		return sal_False;*/
	if( ( pADAGetDiagRec	=	(TADAGetDiagRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDiagRec").pData )) == NULL )
		return sal_False;
	if( ( pADAColumnPrivileges = (TADAColumnPrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumnPrivileges").pData )) == NULL )
		return sal_False;
	if( ( pADAColumns		=	(TADAColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumns").pData )) == NULL )
		return sal_False;
	if( ( pADAForeignKeys	=	(TADAForeignKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLForeignKeys").pData )) == NULL )
		return sal_False;
	if( ( pADAPrimaryKeys	=	(TADAPrimaryKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrimaryKeys").pData )) == NULL )
		return sal_False;
	if( ( pADAProcedureColumns =  (TADAProcedureColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedureColumns").pData )) == NULL )
		return sal_False;
	if( ( pADAProcedures	=	(TADAProcedures)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedures").pData )) == NULL )
		return sal_False;
	if( ( pADASpecialColumns =  (TADASpecialColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSpecialColumns").pData )) == NULL )
		return sal_False;
	if( ( pADAStatistics	=   (TADAStatistics)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLStatistics").pData )) == NULL )
		return sal_False;
	if( ( pADATablePrivileges =	(TADATablePrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTablePrivileges").pData )) == NULL )
		return sal_False;
	if( ( pADATables		=   (TADATables)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTables").pData )) == NULL )
		return sal_False;					
	if( ( pADAFreeStmt		=	(TADAFreeStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return sal_False;
	if( ( pADACancel		=	(TADACancel)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLCancel").pData )) == NULL )
		return sal_False;
	if( ( pADAEndTran		=	(TADAEndTran)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLEndTran").pData )) == NULL )
		return sal_False;
	if( ( pADADisconnect	=	(TADADisconnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDisconnect").pData )) == NULL )
		return sal_False;
	if( ( pADAFreeHandle	=	(TADAFreeHandle)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeHandle").pData )) == NULL )
		return sal_False;

	return TRUE;
}

TADAAllocHandle pADAAllocHandle;
TADAFreeHandle pADAFreeHandle;
TADAFreeStmt pADAFreeStmt;
TADAGetDiagRec pADAGetDiagRec;
TADADisconnect pADADisconnect;	
TADASetConnectAttr pADASetConnectAttr;
TADABindCol pADABindCol;
TADACancel pADACancel;
TADAColAttribute pADAColAttribute;
TADAConnect pADAConnect;
TADADescribeCol pADADescribeCol;
TADAExecDirect pADAExecDirect;
TADAExecute pADAExecute;
TADAFetch pADAFetch;
TADANumResultCols pADANumResultCols;
TADAPrepare pADAPrepare;
TADARowCount pADARowCount;
TADAEndTran pADAEndTran;
TADAColumns pADAColumns;
TADADriverConnect pADADriverConnect;
TADAGetData pADAGetData;
TADAGetInfo pADAGetInfo;
TADAGetStmtAttr pADAGetStmtAttr;
TADAGetTypeInfo pADAGetTypeInfo;
TADAParamData pADAParamData;
TADAPutData pADAPutData;
TADASetStmtAttr pADASetStmtAttr;
TADASpecialColumns pADASpecialColumns;
TADAStatistics pADAStatistics;
TADATables pADATables;
TADABrowseConnect pADABrowseConnect;
TADAColumnPrivileges pADAColumnPrivileges;
TADADescribeParam pADADescribeParam;
TADAForeignKeys pADAForeignKeys;
TADANumParams pADANumParams;
TADAPrimaryKeys pADAPrimaryKeys;
TADAProcedureColumns pADAProcedureColumns;
TADAProcedures pADAProcedures;
TADATablePrivileges pADATablePrivileges;
TADABindParameter pADABindParameter;

