/*************************************************************************
 *
 *  $RCSfile: adaimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SDB_ADAIMP_HXX
#define SDB_ADAIMP_HXX

#ifdef UNX
#include <odbc/qeodbc.h>
#define EXPORT
#define CALLBACK
#include <odbc/sqlext.h>
#undef BOOL
#endif

#include <tools/solar.h>
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

class SdbEnvironment;
BOOL LoadLibrary_Adabas(SdbEnvironment* pEnv,String &_rPath);

typedef RETCODE  (SQL_API  *TADAAllocHandle) (SQLSMALLINT Type, SQLHANDLE hInput, SQLHANDLE* hOutput);
extern TADAAllocHandle pADAAllocHandle;
#define NADAAllocHandle(a, b, c) (*pADAAllocHandle)(a, b, c)

typedef RETCODE  (SQL_API  *TADAFreeHandle) (SQLSMALLINT Type, SQLHANDLE hInput);
extern TADAFreeHandle pADAFreeHandle;
#define NADAFreeHandle(a, b) (*pADAFreeHandle)(a, b)

typedef RETCODE  (SQL_API  *TADAFreeStmt) (SQLHANDLE hstmt, SQLUSMALLINT fOption);
extern TADAFreeStmt pADAFreeStmt;
#define NADAFreeStmt(a,b) (*pADAFreeStmt)(a,b)

typedef SQLRETURN  (SQL_API  *TADAGetDiagRec) (	SQLSMALLINT			HandleType,
												SQLHANDLE			Handle,
												SQLSMALLINT			RecNumber,
												SQLCHAR *			Sqlstate,
												SQLINTEGER *		NativeErrorPtr,
												SQLCHAR *			MessageText,
												SQLSMALLINT			BufferLength,
												SQLSMALLINT *		TextLengthPtr);

extern TADAGetDiagRec pADAGetDiagRec;
#define NADAGetDiagRec(a,b,c,d,e,f,g,h) (*pADAGetDiagRec)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TADASetConnectAttr) (SQLHANDLE hdbc , SQLINTEGER fOption, SQLPOINTER ValuePtr, SQLINTEGER StringLength);
extern TADASetConnectAttr pADASetConnectAttr;
#define NADASetConnectAttr(a,b,c,d) (*pADASetConnectAttr)(a,b,c,d)

typedef RETCODE  (SQL_API  *TADAGetStmtAttr) (SQLHANDLE hstmt , SQLINTEGER fOption , SQLPOINTER ValuePtr, SQLINTEGER BufferLength, SQLINTEGER* StringLengthPtr);
extern TADAGetStmtAttr pADAGetStmtAttr;
#define NADAGetStmtAttr(a,b,c,d,e) (*pADAGetStmtAttr)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TADAGetInfo) (SQLHANDLE hdbc , SQLINTEGER fInfoType , PTR rgbInfoValue , SWORD cbInfoValueMax , SWORD FAR * pcbInfoValue);
extern TADAGetInfo pADAGetInfo;
#define NADAGetInfo(a,b,c,d,e) (*pADAGetInfo)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TADAEndTran) (SQLSMALLINT Type, SQLHANDLE hInput , SQLINTEGER fType);
extern TADAEndTran pADAEndTran;
#define NADAEndTran(a,b,c) (*pADAEndTran)(a,b,c)

typedef RETCODE  (SQL_API  *TADABindCol) (SQLHANDLE hstmt , SQLINTEGER icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TADABindCol pADABindCol;
#define NADABindCol(a,b,c,d,e,f) (*pADABindCol)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TADACancel) (SQLHANDLE hstmt);
extern TADACancel pADACancel;
#define NADACancel(a) (*pADACancel)(a)

typedef RETCODE  (SQL_API  *TADAColAttribute) (SQLHANDLE hstmt , SQLINTEGER icol , SQLINTEGER fDescType , PTR rgbDesc , SWORD cbDescMax , SWORD FAR * pcbDesc , SDWORD FAR * pfDesc);
extern TADAColAttribute pADAColAttribute;
#define NADAColAttribute(a,b,c,d,e,f,g) (*pADAColAttribute)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TADAConnect) (SQLHANDLE hdbc , UCHAR FAR * szDSN , SWORD cbDSN , UCHAR FAR * szUID , SWORD cbUID , UCHAR FAR * szAuthStr , SWORD cbAuthStr);
extern TADAConnect pADAConnect;
#define NADAConnect(a,b,c,d,e,f,g) (*pADAConnect)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TADADescribeCol) (SQLHANDLE hstmt , SQLINTEGER icol , UCHAR FAR * szColName , SWORD cbColNameMax , SWORD FAR * pcbColName , SWORD FAR * pfDB2Type , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TADADescribeCol pADADescribeCol;
#define NADADescribeCol(a,b,c,d,e,f,g,h,i) (*pADADescribeCol)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADADisconnect) (SQLHANDLE hdbc);
extern TADADisconnect pADADisconnect;
#define NADADisconnect(a) (*pADADisconnect)(a)

typedef RETCODE  (SQL_API  *TADAExecDirect) (SQLHANDLE hstmt , UCHAR FAR * szDB2Str , SDWORD cbDB2Str);
extern TADAExecDirect pADAExecDirect;
#define NADAExecDirect(a,b,c) (*pADAExecDirect)(a,b,c)

typedef RETCODE  (SQL_API  *TADAExecute) (SQLHANDLE hstmt);
extern TADAExecute pADAExecute;
#define NADAExecute(a) (*pADAExecute)(a)

typedef RETCODE  (SQL_API  *TADAFetch) (SQLHANDLE hstmt);
extern TADAFetch pADAFetch;
#define NADAFetch(a) (*pADAFetch)(a)

typedef RETCODE  (SQL_API  *TADANumResultCols) (SQLHANDLE hstmt , SWORD FAR * pccol);
extern TADANumResultCols pADANumResultCols;
#define NADANumResultCols(a,b) (*pADANumResultCols)(a,b)

typedef RETCODE  (SQL_API  *TADAPrepare) (SQLHANDLE hstmt , UCHAR FAR * szDB2Str , SDWORD cbDB2Str);
extern TADAPrepare pADAPrepare;
#define NADAPrepare(a,b,c) (*pADAPrepare)(a,b,c)

typedef RETCODE  (SQL_API  *TADARowCount) (SQLHANDLE hstmt , SDWORD FAR * pcrow);
extern TADARowCount pADARowCount;
#define NADARowCount(a,b) (*pADARowCount)(a,b)

typedef RETCODE  (SQL_API  *TADAColumns) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TADAColumns pADAColumns;
#define NADAColumns(a,b,c,d,e,f,g,h,i) (*pADAColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADADriverConnect) (SQLHANDLE hdbc , SQLHWND hwnd , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut , SQLINTEGER fDriverCompletion);
extern TADADriverConnect pADADriverConnect;
#define NADADriverConnect(a,b,c,d,e,f,g,h) (*pADADriverConnect)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TADAGetData) (SQLHANDLE hstmt , SQLINTEGER icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TADAGetData pADAGetData;
#define NADAGetData(a,b,c,d,e,f) (*pADAGetData)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TADAGetTypeInfo) (SQLHANDLE hstmt , SWORD fDB2Type);
extern TADAGetTypeInfo pADAGetTypeInfo;
#define NADAGetTypeInfo(a,b) (*pADAGetTypeInfo)(a,b)

typedef RETCODE  (SQL_API  *TADAParamData) (SQLHANDLE hstmt , PTR FAR * prgbValue);
extern TADAParamData pADAParamData;
#define NADAParamData(a,b) (*pADAParamData)(a,b)

typedef RETCODE  (SQL_API  *TADAPutData) (SQLHANDLE hstmt , PTR rgbValue , SDWORD cbValue);
extern TADAPutData pADAPutData;
#define NADAPutData(a,b,c) (*pADAPutData)(a,b,c)

typedef RETCODE  (SQL_API  *TADASetStmtAttr) (SQLHANDLE hstmt, SQLINTEGER fOption, SQLPOINTER ValuePtr, SQLINTEGER StringLength);
extern TADASetStmtAttr pADASetStmtAttr;
#define NADASetStmtAttr(a,b,c,d) (*pADASetStmtAttr)(a,b,c,d)

typedef RETCODE  (SQL_API  *TADASpecialColumns) (SQLHANDLE hstmt , SQLINTEGER fColType , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , SQLINTEGER fScope , SQLINTEGER fNullable);
extern TADASpecialColumns pADASpecialColumns;
#define NADASpecialColumns(a,b,c,d,e,f,g,h,i,j) (*pADASpecialColumns)(a,b,c,d,e,f,g,h,i,j)

typedef RETCODE  (SQL_API  *TADAStatistics) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , SQLINTEGER fUnique , SQLINTEGER fAccuracy);
extern TADAStatistics pADAStatistics;
#define NADAStatistics(a,b,c,d,e,f,g,h,i) (*pADAStatistics)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADATables) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szTableType , SWORD cbTableType);
extern TADATables pADATables;
#define NADATables(a,b,c,d,e,f,g,h,i) (*pADATables)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADABrowseConnect) (SQLHANDLE hdbc , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut);
extern TADABrowseConnect pADABrowseConnect;
#define NADABrowseConnect(a,b,c,d,e,f) (*pADABrowseConnect)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TADAColumnPrivileges) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TADAColumnPrivileges pADAColumnPrivileges;
#define NADAColumnPrivileges(a,b,c,d,e,f,g,h,i) (*pADAColumnPrivileges)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADADescribeParam) (SQLHANDLE hstmt , SQLINTEGER ipar , SWORD FAR * pfDB2Type , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TADADescribeParam pADADescribeParam;
#define NADADescribeParam(a,b,c,d,e,f) (*pADADescribeParam)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TADAForeignKeys) (SQLHANDLE hstmt , UCHAR FAR * szPkTableQualifier , SWORD cbPkTableQualifier , UCHAR FAR * szPkTableOwner , SWORD cbPkTableOwner , UCHAR FAR * szPkTableName , SWORD cbPkTableName , UCHAR FAR * szFkTableQualifier , SWORD cbFkTableQualifier , UCHAR FAR * szFkTableOwner , SWORD cbFkTableOwner , UCHAR FAR * szFkTableName , SWORD cbFkTableName);
extern TADAForeignKeys pADAForeignKeys;
#define NADAForeignKeys(a,b,c,d,e,f,g,h,i,j,k,l,m) (*pADAForeignKeys)(a,b,c,d,e,f,g,h,i,j,k,l,m)

typedef RETCODE  (SQL_API  *TADANumParams) (SQLHANDLE hstmt , SWORD FAR * pcpar);
extern TADANumParams pADANumParams;
#define NADANumParams(a,b) (*pADANumParams)(a,b)

typedef RETCODE  (SQL_API  *TADAPrimaryKeys) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TADAPrimaryKeys pADAPrimaryKeys;
#define NADAPrimaryKeys(a,b,c,d,e,f,g) (*pADAPrimaryKeys)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TADAProcedureColumns) (SQLHANDLE hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TADAProcedureColumns pADAProcedureColumns;
#define NADAProcedureColumns(a,b,c,d,e,f,g,h,i) (*pADAProcedureColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TADAProcedures) (SQLHANDLE hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName);
extern TADAProcedures pADAProcedures;
#define NADAProcedures(a,b,c,d,e,f,g) (*pADAProcedures)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TADATablePrivileges) (SQLHANDLE hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TADATablePrivileges pADATablePrivileges;
#define NADATablePrivileges(a,b,c,d,e,f,g) (*pADATablePrivileges)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TADABindParameter) (SQLHANDLE hstmt , SQLINTEGER ipar , SWORD fParamType , SWORD fCType , SWORD fDB2Type , UDWORD cbColDef , SWORD ibScale , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TADABindParameter pADABindParameter;
#define NADABindParameter(a,b,c,d,e,f,g,h,i,j) (*pADABindParameter)(a,b,c,d,e,f,g,h,i,j)

#endif

