/*************************************************************************
 *
 *  $RCSfile: adatab.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_ADAINC_HXX
#include "adainc.hxx"
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifndef _SDB_ADATAB_HXX
#include "adatab.hxx"
#endif

#ifndef _SDB_ADACURS_HXX
#include "adacurs.hxx"
#endif

#ifndef _SDB_ADACONN_HXX
#include "adaconn.hxx"
#endif

#ifndef _SDB_ADAIDX_HXX
#include "adaidx.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;
#ifndef _SDB_SDBRESID_HRC
#include "sdbresid.hrc"
#endif
#ifndef _SDB_SDBREL_HXX
#include "sdbrel.hxx"
#endif
#ifndef _UTL_TYPES_HXX_
#include <unotools/types.hxx>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

static char __READONLY_DATA privilegeSelect[]		= "SELECT";
static char __READONLY_DATA privilegeInsert[]		= "INSERT";
static char __READONLY_DATA privilegeUpdate[]		= "UPDATE";
static char __READONLY_DATA privilegeDelete[]		= "DELETE";
static char __READONLY_DATA privilegeAlter[]		= "ALTER";
static char __READONLY_DATA privilegeReferences[]	= "REFERENCES";


DBG_NAME(SdbAdaTable);

//-----------------------------------------------------------------------------
SdbAdaTable::SdbAdaTable(SdbAdaConnection* pConnection)
			 :SdbTable(pConnection)
{
	DBG_CTOR(SdbAdaTable,NULL);
	aStatus.SetComponent(String::CreateFromAscii("Sdb ADABAS Driver"));
}
//-----------------------------------------------------------------------------
SdbAdaTable::~SdbAdaTable()
{
	DBG_DTOR(SdbAdaTable,NULL);
}
//-----------------------------------------------------------------------------
BOOL SdbAdaTable::OpenImpl()
{
	DBG_ASSERT(aName.Len(),"Table is empty!");
	// Hier ist bekannt, dass es sich eigentlich um einen
	// SdbAdaCursor handelt, daher Type Cast:
	SdbConnection* pConnection = GetConnection();
	SdbAdaCursor* pCursor = (SdbAdaCursor *) pConnection->CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();

	// Handelt es sich um eine Tabelle oder View
	pCursor->OpenTables(NULL,aOwnerName.GetBuffer(),aName.GetBuffer(), String::CreateFromAscii("VIEW").GetBuffer());
	bView = pCursor->IsInRange();	

	// Angaben zu den Columns:
	// Einen ganz speziellen Cursor oeffnen: anstelle von
	// Prepare und Execute wird Columns ausgefuehrt; die
	// Ergebnismenge enthaelt die gewuenschten Informationen
	pCursor->Close();
	pCursor->OpenColumns(NULL,aOwnerName.GetBuffer(),aName.GetBuffer(), NULL);
	aStatus = pCursor->Status();
	if (!aStatus.IsSuccessful())
	{
		if (aStatus.IsNoDataFound())	// Tabelle existiert nicht
			aStatus.Clear();
		pCursor->ReleaseRef();
		return FALSE;
	}

	// db2 verwendet immer gleiche Reihenfolge
/*		1 	TABLE_QUALIFIER
		2	TABLE_OWNER
		3	TABLE_NAME
		4	COLUMN_NAME
		5 	DATA_TYPE
		6 	TYPE_NAME
		7 	PRECISION
		8 	LENGTH
		9 	SCALE
		10 	RADIX
		11 	NULLABLE
		12 	REMARKS		*/

	String aColumnName;
	int i = 1;
	UINT32 nLength;
	UINT16 nScale;
	UINT16 nFlags;
	BOOL bNullAllowed;
	SdbDatabaseType eType;
	ODbVariantRef pValue;
	SdbColumn* pColumn;
	while (!pCursor->IsOffRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		nLength = 0;
		nFlags	= nScale = 0;
		bNullAllowed = FALSE;

		// Column-Info aufbauen ...
		aColumnName = rRow[4]->getString().getStr();
		eType = SdbAdaConnection::MapType(rRow[5]->getINT16());
		
		::rtl::OUString aComment,aDefault;

		pValue = rRow[7];
		if (pValue.is() && !pValue->isNull())
			nLength = (UINT32)pValue->getINT32();
		pValue = rRow[9];
		if (pValue.is() && !pValue->isNull())
			nScale = (UINT16)pValue->getINT16();
		pValue = rRow[11];
		if (pValue.is() && !pValue->isNull())
			bNullAllowed = pValue->getINT16() != SQL_NO_NULLS;

		pValue = rRow[12];
		if (pValue.is() && !pValue->isNull())
			aComment = pValue->getString();

		pValue = rRow[13];
		if (pValue.is() && !pValue->isNull())
			aDefault = pValue->getString();

		// Sonderbehandlung fuer Currency
		const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(rRow[6]->getString());
		if(!pInfo)
			pInfo = pConnection->GetColumnTypeInfo(eType); // das ist die letzte M"oglichkeit einen Typ zu bestimmen
		DBG_ASSERT(pInfo, "keine TypeInfo");

		// Zusaetzliche Flags:
		// bei unbekannten Typen ist pInfo NULL, z.B. benutzerdefinierten
		if (pInfo)
		{
			if (bNullAllowed && pInfo->bNullable)
				nFlags |= SDB_FLAGS_NULLALLOWED;
			// in real this type is a "CHAR() BYTE"
			if((eType == SDB_DBTYPE_BINARY || eType == SDB_DBTYPE_VARBINARY) &&
				pCursor->IsAutoIncrement(aOwnerName,aName,aColumnName))
			{
				nFlags |= SDB_FLAGS_AUTOINCREMENT;
				eType = SDB_DBTYPE_CHAR;
				aDefault = ::rtl::OUString::createFromAscii("DEFAULT STAMP");
			}
			if (pInfo->bCurrency)
				eType = SDB_DBTYPE_CURRENCY;
			switch (pInfo->eSearchType)
			{
				case Search_Like_Only  :	nFlags |= SDB_FLAGS_SEARCH_LIKE; break;
				case Search_Except_Like:	nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE; break;
				case Search_All:			nFlags |= SDB_FLAGS_SEARCH_ALL; break;
			}
		}
		else // keine TypeInfo dann nullable
			nFlags |= SDB_FLAGS_NULLALLOWED;

		pColumn = CreateColumn(aColumnName,eType,nLength,nScale,nFlags);
		pColumn->SetComment(aComment);

		pColumn->SetDefaultValue(aDefault);
		


		// ... und in Columns-Struktur einfuegen
		aOriginalColumns->AddColumn(pColumn);
		pCursor->Next();
	}

	// Unique felder finden
	pCursor->Close();
	pCursor->OpenIndices(NULL,aOwnerName.GetBuffer(),aName.GetBuffer(),TRUE);
	aStatus = pCursor->Status();

/*	Reihenfolge
		1	TABLE_QUALIFIER
		2	TABLE_OWNER
		3	TABLE_NAME
		4	NON_UNIQUE
		5	INDEX_QUALIFIER
		6	INDEX_NAME
		7	TYPE
		8	SEQ_IN_INDEX
		9	COLUMN_NAME
*/
	// setzen der uniqueflags
	::rtl::OUString aIndexName,aQualifierName;
	::rtl::OUString aNewName;
	ODbVariantRef pQualifier;
	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		if (rRow[7]->getINT16() != SQL_TABLE_STAT)
		{
			SdbColumn* pColumn = NULL;
			pQualifier = rRow[5];
			aNewName = rRow[6]->getString();

			if (aIndexName == aNewName &&
				(!pQualifier.is() || pQualifier->isNull() || pQualifier->getString() == aQualifierName))
				// naechste Spalte des aktuellen Index
				pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[9]->getString().getStr()];
			else	// neuer Index
			{
				if ((rRow[4])->getINT16() == 0)
				{
					aIndexName = aNewName;
					if (pQualifier.is() && !pQualifier->isNull())
						aQualifierName = pQualifier->getString();
					pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[9]->getString().getStr()];
				}
			}
			if (pColumn)
				pColumn->SetFlag(SDB_FLAGS_UNIQUE);
		}
		pCursor->Next();
	}
	// Primarykeys auslesen
	pCursor->Close();
	pCursor->OpenPrimaryKeys(NULL,aOwnerName.GetBuffer(),aName.GetBuffer());
	aStatus = pCursor->Status();
	/*	Reihenfolge
		1	TABLE_QUALIFIER
		2	TABLE_OWNER
		3	TABLE_NAME
		4	COLUMN_NAME
		5	KEY_SEQ
		6	PK_NAME
	*/
	// setzen der uniqueflags
	if (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		// Name des PKeys
		ODbVariantRef pPKName = rRow[6];
		if (pPKName.is() && !pPKName->isNull())
			aPKeyName = pPKName->getString().getStr();
		else
			aPKeyName = SdbRelation::CreateTempName();
	}
	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		SdbColumn* pColumn = (SdbColumn*)aOriginalColumns->Column(rRow[4]->getString());
		if (pColumn)
			pColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
		pCursor->Next();
	}	
	
	pCursor->Close();
	// setzen der Privileges
	nPrivileges = 0;
	pCursor->OpenTablePrivileges(NULL,aOwnerName.GetBuffer(),aName.GetBuffer());
	aStatus = pCursor->Status();
	/*	Reihenfolge
	1	TABLE_QUALIFIER
	2	TABLE_OWNER
	3	TABLE_NAME
	4	GRANTOR
	5	GRANTEE
	6	PRIVILEGE
	*/
	::rtl::OUString usUser(pConnection->GetUser());
	String aPrivilege;
	ODbVariantRef pGrantee;
	ODbVariantRef pPrivilege;
	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		pGrantee = rRow[5];
		if (pGrantee.is() && !pGrantee->isNull() && pGrantee->getString() == usUser)
		{
			pPrivilege = rRow[6];
			aPrivilege = (pPrivilege.is() && !pPrivilege->isNull()) ? String(pPrivilege->getString().getStr()) : String();
			if (aPrivilege.EqualsAscii(privilegeSelect))
					nPrivileges |= SDB_PR_READ;
			else if (aPrivilege.EqualsAscii(privilegeInsert))
				nPrivileges |= SDB_PR_INSERT;
			else if (aPrivilege.EqualsAscii(privilegeUpdate))
				nPrivileges |= SDB_PR_UPDATE;
			else if (aPrivilege.EqualsAscii(privilegeDelete))
				nPrivileges |= SDB_PR_DELETE;
			else if (aPrivilege.EqualsAscii(privilegeReferences))
				nPrivileges |= SDB_PR_REFERENCES;
			else if (aPrivilege.EqualsAscii(privilegeAlter))
				nPrivileges |= SDB_PR_ALTER | SDB_PR_DROP;
		}
		pCursor->Next();
	}		

	pCursor->Close();
	pCursor->OpenSpecialColumns(String().GetBuffer(),aOwnerName.GetBuffer(),aName.GetBuffer());
	aStatus = pCursor->Status();
	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[2]->getString()];
		if(pColumn)
			pColumn->SetFlag(SDB_FLAGS_VERSIONING);
		else
		{
			aColumnName = rRow[2]->getString().getStr();
			SdbDatabaseType eType = SdbAdaConnection::MapType(rRow[3]->getINT16());
			if(eType == SDB_DBTYPE_BIGINT)
				eType = SDB_DBTYPE_DOUBLE;

			nLength = 0;
			nScale  = 0;
			nFlags  = SDB_FLAGS_VERSIONING;
			bNullAllowed = FALSE;
			String aComment;

			pValue = rRow[5];
			if (pValue.is() && !pValue->isNull())
				nLength = (UINT32)pValue->getINT32();
			pValue = rRow[7];
			if (pValue.is() && !pValue->isNull())
				nScale = (UINT16)pValue->getINT32();

			// Sonderbehandlung fuer Currency ,Autoincrement
			const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(rRow[4]->getString());
			if(!pInfo)
			{
				pInfo = pConnection->GetColumnTypeInfo(eType); // das ist die letzte M"oglichkeit einen Typ zu bestimmen
			}
			DBG_ASSERT(pInfo, "keine TypeInfo");

			// Zusaetzliche Flags:
			// bei unbekannten Typen ist pInfo NULL, z.B. benutzerdefinierten
			if (pInfo)
			{
				if (bNullAllowed && pInfo->bNullable)
					nFlags |= SDB_FLAGS_NULLALLOWED;
				if (pInfo && pInfo->bCurrency)
					eType = SDB_DBTYPE_CURRENCY;
				else if (pInfo->bAutoIncrement)
					nFlags |= SDB_FLAGS_AUTOINCREMENT;
				switch (pInfo->eSearchType)
				{
					case Search_Like_Only  : nFlags |= SDB_FLAGS_SEARCH_LIKE; break;
					case Search_Except_Like: nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE; break;
					case Search_All: nFlags |= SDB_FLAGS_SEARCH_ALL; break;
				}
			}
			else // keine TypeInfo dann nullable
				nFlags |= SDB_FLAGS_NULLALLOWED;

			pColumn = CreateColumn(aColumnName,eType,nLength,nScale,nFlags);
			pColumn->SetComment(aComment);

			// ... und in Columns-Struktur einfuegen
			aOriginalColumns->AddColumn(pColumn);
		}
		pCursor->Next();
	}
	pCursor->ReleaseRef();
	if (aStatus.IsNoDataFound())
		aStatus.Clear();
	return aOriginalColumns->Count() > 1;
}

//-----------------------------------------------------------------------------
BOOL SdbAdaTable::DropImpl()
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	SdbConnection* pConnection = GetConnection();

	String aCommand;aCommand.AssignAscii("DROP TABLE ");
	if (aOwnerName.Len() > 0)
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}
	aCommand += pConnection->IdentifierQuotation(aName);

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}

//-----------------------------------------------------------------------------
BOOL SdbAdaTable::CreateImpl()
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	SdbConnection* pConnection = GetConnection();
	String aCommand;aCommand.AssignAscii("CREATE TABLE ");
	if (aOwnerName.Len() > 0)
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}
	aCommand += pConnection->IdentifierQuotation(aName);
	aCommand += ' ';
	aCommand += '(';

	
	if (!GenerateAddCommands(aCommand)) return FALSE;

	String aPColumns;
	for (USHORT i = 1; i < aColumns->Count(); i++)
	{
		if (aColumns->Column(i)->IsPrimaryKey())
		{
			aPColumns += pConnection->IdentifierQuotation(aColumns->Column(i)->GetName());
			aPColumns += ',';
		}
	}
	if (aPColumns.Len())
	{
		// Ein Komma ist sicherlich noch zuviel ...
		aPColumns.SetChar(aPColumns.Len()-1,')');
		aCommand.AppendAscii(" PRIMARY KEY (");
		aCommand += aPColumns;
		aCommand += ',';
	}
	// Ein Komma ist sicherlich noch zuviel ...
	aCommand.SetChar(aCommand.Len() - 1,')');

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();

	if (aStatus.IsSuccessful())
		nPrivileges = SDB_PR_READ | SDB_PR_INSERT |
				SDB_PR_UPDATE | SDB_PR_DELETE |
				SDB_PR_REFERENCES | SDB_PR_ALTER | SDB_PR_DROP;
	return aStatus.IsSuccessful();
}

//-----------------------------------------------------------------------------
BOOL SdbAdaTable::GenerateAddCommands(String& rStatement)
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	// Welche neuen Columns gibt es jetzt?
	// (Erkennbar an "fehlender" Identitaet (Id == 0))
	for (int i = 1; i < aColumns->Count(); i++)
	{
		const SdbColumn * pColumn = (*aColumns)[i];
		if (!GenerateColumnCommand(rStatement, *pColumn)) return FALSE;

		rStatement += ',';
	}
	return TRUE;
}

//-----------------------------------------------------------------------------
void SdbAdaTable::CloseImpl(){DBG_CHKTHIS(SdbAdaTable,NULL);}
//-----------------------------------------------------------------------------
BOOL SdbAdaTable::DeletePkeys(SdbConnectionRef xConnection,const String& aTableName)
{
	String aStmt;aStmt.AssignAscii("ALTER TABLE ");
	aStmt += aTableName;
	aStmt.AppendAscii(" DROP PRIMARY KEY");
	xConnection->ExecuteSQL(aStmt);
	aStatus = xConnection->Status();
	if(aStatus.IsSuccessful())
		aPKeyName.Erase();
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbAdaTable::AlterImpl()
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	// Alter wird immer ueber eine Transaktion ausgefuehrt
	SdbConnectionRef xConnection = GetConnection();
	// new connection is not allowed because there are some users which have exclusiv access

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(xConnection->GetMetaData());

	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	BOOL bNotNullAllowed = rMetaData->isCapable(::com::sun::star::data::DatabaseCapability::NON_NULLABLE_COLUMNS);

	String aStatement;
	String aTableName;	 

	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::com::sun::star::data::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aQualifierName);
		aTableName += xConnection->GetQualifierSeparator();
	}

	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::com::sun::star::data::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aOwnerName);
		aTableName += '.';
	}
	aTableName += xConnection->IdentifierQuotation(aName);
	BOOL *bSet = new BOOL[aOriginalColumns->Count()];

	// erst alle identischen und die, wo sich die Struktur gendert hat heraus filtern
	for (UINT16 i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn	= (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		bSet[i] = FALSE;
		if(pRefColumn && pRefColumn->Compare(*pColumn,SDB_FLAGS_NULLALLOWED|SDB_FLAGS_PRIMARYKEY))
		{
			// Falls vorhanden, nichts machen
			bSet[i] = TRUE;
		}
		else if(pRefColumn  && !pRefColumn->Compare(*pColumn,SDB_FLAGS_NULLALLOWED) &&
			!(pRefColumn->IsAutoIncrement() && pColumn->IsAutoIncrement()))
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" COLUMN ");
			BOOL bNull = pRefColumn->IsNullAllowed();
			((SdbColumn*)pRefColumn)->SetFlag(SDB_FLAGS_NULLALLOWED);
			if(GenerateColumnCommand(aStatement, *pRefColumn,!pRefColumn->IsAutoIncrement()))
			{
				if(!bNull)
					((SdbColumn*)pRefColumn)->ResetFlag(SDB_FLAGS_NULLALLOWED);
				
				if(!(pColumn->GetAllFlags() & SDB_FLAGS_FOREIGNKEY))
				{
					// gibt es eine neue Schluesselspalte, dann PKey loeschen
					if (aPKeyName.Len() && pRefColumn->IsPrimaryKey())
					{
						if(!DeletePkeys(xConnection,aTableName))
							continue;
					}
					// sobald die Column ein Fkey ist, kann sie nicht gealtered werden
					xConnection->ExecuteSQL(aStatement);
					aStatus = xConnection->Status();
					if (aStatus.IsSuccessful())
					{
						if(pColumn->IsNullAllowed() != pRefColumn->IsNullAllowed())
						{
							aStatement.AssignAscii("ALTER TABLE ");
							aStatement += aTableName;
							aStatement.AppendAscii(" COLUMN ");
							aStatement += xConnection->IdentifierQuotation(pRefColumn->GetName());
							if (bNull)
								aStatement.AppendAscii(" DEFAULT NULL ");
							else
								aStatement.AppendAscii(" NOT NULL");

							xConnection->ExecuteSQL(aStatement);
							aStatus = xConnection->Status();
						}
						if(aStatus.IsSuccessful() && pRefColumn->IsAutoIncrement())
						{
							aStatement.AssignAscii("ALTER TABLE ");
							aStatement += aTableName;
							aStatement.AppendAscii(" COLUMN ");
							aStatement += xConnection->IdentifierQuotation(pRefColumn->GetName());
							if(pRefColumn->GetDefaultValue().Len())
								aStatement.AppendAscii("ALTER");
							else
								aStatement.AppendAscii("ADD");
							aStatement.AppendAscii(" DEFAULT STAMP");
							xConnection->ExecuteSQL(aStatement);
							aStatus = xConnection->Status();
						}
						if (aStatus.IsSuccessful())
							aOriginalColumns->ReplaceColumn(CreateColumn(*pRefColumn),i);
					}
					
					bSet[i] = TRUE;
				}
				else
				{
					String aTmp(SdbResId(STR_FOREIGN_KEY_NOT_ALTER));
					aStatus.Set(SDB_STAT_ERROR,String::CreateFromAscii("S1000"),aStatus.CreateErrorMessage(aTmp),0, String(String()) );
				}
			}
		}
		else if(pRefColumn  && !pRefColumn->Compare(*pColumn,SDB_FLAGS_PRIMARYKEY))
			bSet[i] = TRUE; // nur PKkey hat sich geaendert
	}	

	// jetzt die nicht verwendeten lschen
	for ( i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		if(!bSet[i])
		{
			const SdbColumn* pColumn = (*aOriginalColumns)[i];
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());
			// vorhandene Pkeys loeschen
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				if(!DeletePkeys(xConnection,aTableName))
					continue;
			}
			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(pColumn->GetName());
		}
	}
	delete [] bSet;
	// und jetzt die neuen hinzufuegen
	for (i = 1; aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (!pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" ADD ");
			if(GenerateColumnCommand(aStatement, *pColumn,FALSE))
			{
				// gibt es eine neue Schluesselspalte, dann PKey loeschen
				if (aPKeyName.Len() && pColumn->IsPrimaryKey())
				{
					if(!DeletePkeys(xConnection,aTableName))
						continue;
				}
			
				xConnection->ExecuteSQL(aStatement);
				aStatus = xConnection->Status();
				if (aStatus.IsSuccessful())
					aOriginalColumns->AddColumn(CreateColumn(*pColumn));
			}
		}
	}

	// gibt es noch Aenderungen am Schluessel
	for (i = 1; aPKeyName.Len() && aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (pRefColumn && pColumn->IsPrimaryKey() != pRefColumn->IsPrimaryKey())
			DeletePkeys(xConnection,aTableName);
	}


	if (!aPKeyName.Len() && aStatus.IsSuccessful()) // muss jetzt noch ein PKey hinzugefuegt werden ?
	{
		String aPColumns;
		for (UINT16 i = 1; i < aColumns->Count(); i++)
		{
			if ((*aColumns)[i]->IsPrimaryKey())
			{
				aPColumns += xConnection->IdentifierQuotation((*aColumns)[i]->GetName());
				aPColumns += ',';
			}
		}
		if (aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');

			String aCommand;aCommand.AssignAscii("ALTER TABLE ");
			aCommand += aTableName;
			aCommand.AppendAscii(" ADD PRIMARY KEY (");
			aCommand += aPColumns;

			xConnection->ExecuteSQL(aCommand);
			aStatus = xConnection->Status();
		}
	}

#if 0
	// Zunaechst werden die Felder, die nicht mehr benoetigt werden, geloescht.
	UINT16 i;
	for (i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (!pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (pColumn->IsPrimaryKey())
			{
				String aStmt;aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP PRIMARY KEY");
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// Die Felder, die sich geaendert haben, geloescht
	for (i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (pRefColumn && !pColumn->Compare(*pRefColumn, SDB_FLAGS_NULLALLOWED))
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (pColumn->IsPrimaryKey())
			{
				String aStmt;aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP PRIMARY KEY");
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();

			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// und jetzt die neuen bzw. geaenderten hinzufuegen
	for (i = 1; aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (!pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" ADD ");
			GenerateColumnCommand(aStatement, *pColumn);

			// gibt es eine neue Schluesselspalte, dann PKey loeschen
			if (pColumn->IsPrimaryKey())
			{
				String aStmt;aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP PRIMARY KEY");
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->AddColumn(CreateColumn(*pColumn));
		}
	}

	// gibt es noch Aenderungen am Schluessel
	for (i = 1; aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (pRefColumn && pColumn->IsPrimaryKey() != pRefColumn->IsPrimaryKey())
		{
			String aStmt;aStmt.AssignAscii("ALTER TABLE ");
			aStmt += aTableName;
			aStmt.AppendAscii(" DROP PRIMARY KEY");
			xConnection->ExecuteSQL(aStmt);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aPKeyName.Erase();
		}
	}

	if (!aPKeyName.Len()) // muss jetzt noch ein PKey hinzugefuegt werden ?
	{
		String aPColumns;
		for (UINT16 i = 1; i < aColumns->Count(); i++)
		{
			if ((*aColumns)[i]->IsPrimaryKey())
			{
				aPColumns += xConnection->IdentifierQuotation((*aColumns)[i]->GetName());
				aPColumns += ',';
			}
		}
		if (aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');

			String aCommand;aCommand.AssignAscii(" ALTER TABLE ");
			aCommand += aTableName;
			aCommand.AppendAscii(" ADD PRIMARY KEY (");
			aCommand += aPColumns;

			xConnection->ExecuteSQL(aCommand);
			aStatus = xConnection->Status();
		}
	}
#endif
	return aStatus.IsSuccessful();
}				

//-----------------------------------------------------------------------------
BOOL SdbAdaTable::GenerateColumnCommand(String& rStatement, const SdbColumn& rColumn,BOOL bAuto)
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	// Gibt es zu dieser Column eine Typinformationen
	SdbConnection* pConnection = GetConnection();
	const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(rColumn);

	if (!pInfo)
	{
		pInfo = pConnection->GetColumnTypeInfo(rColumn.GetType());
		if(!pInfo){
			DBG_ASSERT(0,"Adabas Table: GetColumnTypeInfo == NULL");
			aStatus.SetDriverNotCapableError();
			return FALSE;
		}
	}

	rStatement += pConnection->IdentifierQuotation(rColumn.GetName());
	rStatement += ' ';
	

	switch(pInfo->eType)
	{
		case SDB_DBTYPE_CHAR:
		case SDB_DBTYPE_VARCHAR:
			if(rColumn.IsAutoIncrement())
			{
				rStatement.AppendAscii("CHAR(");
				rStatement += String::CreateFromInt32((rColumn.GetLength() < 8) ? 8 : rColumn.GetLength());
				rStatement.AppendAscii(") BYTE");
				if(bAuto)
					rStatement.AppendAscii(" DEFAULT STAMP"); // our special autoincrement
				break;
			}
			else
			{
				rStatement += pInfo->aTypeName;
				// Typen mit Precision und Scale
				rStatement += '(';
				rStatement += String::CreateFromInt32(rColumn.GetLength());
				rStatement += ')';
			}
			break;
		case SDB_DBTYPE_BINARY:
		case SDB_DBTYPE_VARBINARY:
			{
				// Typen mit Laengenangabe
				String aType = pInfo->aTypeName;
				String aLen;aLen.AssignAscii("(");
				(aLen += String::CreateFromInt32(rColumn.GetLength())) += ')';
				aType.SearchAndReplace(String::CreateFromAscii("()"),aLen);
				rStatement += aType;
			}
			break;		
		case SDB_DBTYPE_TIMESTAMP:
			rStatement += pInfo->aTypeName;
			if (pInfo->bRowVersion)
			{	
				rStatement.AppendAscii(" DEFAULT TIMESTAMP ");				
			}
			break;
		case SDB_DBTYPE_DECIMAL:
		case SDB_DBTYPE_NUMERIC:
			rStatement += pInfo->aTypeName;
			// Typen mit Precision und Scale
			rStatement += '(';
			rStatement += String::CreateFromInt32(rColumn.GetPrecision());
			rStatement += ',';
			rStatement += String::CreateFromInt32(rColumn.GetScale());
			rStatement += ')';
			break;
		default:
			rStatement += pInfo->aTypeName;
	}

	if (!rColumn.IsNullAllowed())
		rStatement.AppendAscii(" NOT NULL");

	return TRUE;
}


//-----------------------------------------------------------------------------
SdbIndex* SdbAdaTable::CreateIndexImpl()
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	return new SdbAdaIndex(this);
}

//-----------------------------------------------------------------------------
void SdbAdaTable::FillIndexNames(SvStringsDtor& _rList)
{
	DBG_CHKTHIS(SdbAdaTable,NULL);
	SdbConnection* pConnection = GetConnection();
	BOOL bCase = (pConnection->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
	// Einlesen aller Indices
	SdbAdaCursor* pCursor = (SdbAdaCursor *) pConnection->CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();

	String aIndexName;
	pCursor->OpenIndices(NULL,aOwnerName.GetBuffer(),aName.GetBuffer());
	/*	Reihenfolge
	1	TABLE_QUALIFIER
	2	TABLE_OWNER
	3	TABLE_NAME
	4	NON_UNIQUE
	5	INDEX_QUALIFIER
	6	INDEX_NAME
	7	TYPE
	8	SEQ_IN_INDEX
	9	COLUMN_NAME
	10	COLLATION
	*/
	USHORT i = 0;
	while (pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();

		ODbVariantRef pVal = rRow[6];
		ODbVariantRef pQualifier = rRow[5];
		String aNewIndexName;

		if (rRow[7]->getINT16() == SQL_TABLE_STAT)
		{
			pCursor->Next();
			continue;
		}
		if (pQualifier.is() && !pQualifier->isNull())
		{
			aNewIndexName = pQualifier->getString().getStr();
			aNewIndexName += '.';
		}
		aNewIndexName += pVal->getString().getStr();
		if (aIndexName != aNewIndexName)
		{
			aIndexName = aNewIndexName;
			_rList.Insert(new String(aIndexName), i++);
		}
		pCursor->Next();
	}
	pCursor->ReleaseRef();
}

//-----------------------------------------------------------------------------
BOOL SdbAdaTable::RenameImpl(const String& rNewName)
{
	DBG_CHKTHIS(SdbAdaTable,NULL);

	SdbConnection* pConnection = GetConnection();
	if (aName == rNewName)
		return TRUE;

	String aQualified;
	if (aOwnerName.Len() > 0)
	{
		aQualified += pConnection->IdentifierQuotation(aOwnerName);
		aQualified += '.';
	}

	String aStatement;aStatement.AssignAscii("RENAME TABLE ");
	aStatement += aQualified;
	aStatement += pConnection->IdentifierQuotation(aName);	
	aStatement.AppendAscii(" TO ");
	aStatement += pConnection->IdentifierQuotation(rNewName);
	BOOL bErg(pConnection->ExecuteSQL(aStatement));
	aStatus = pConnection->Status();
	return bErg;
}


