/*************************************************************************
 *
 *  $RCSfile: adoimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include "adoimp.hxx"

#define MYADOID(l) {l, 0,0x10,0x80,0,0,0xAA,0,0x6D,0x2E,0xA4};

const CLSID ADOS::CLSID_ADOCONNECTION_21	=	MYADOID(0x00000514);
const IID	ADOS::IID_ADOCONNECTION_21		=	MYADOID(0x00000550);

const CLSID ADOS::CLSID_ADOCOMMAND_21		=	MYADOID(0x00000507);
const IID	ADOS::IID_ADOCOMMAND_21			=	MYADOID(0x0000054E);

const CLSID ADOS::CLSID_ADORECORDSET_21		=	MYADOID(0x00000535);
const IID	ADOS::IID_ADORECORDSET_21		=	MYADOID(0x0000054F);


SdbDatabaseType ADOS::SdbTypeFromADOType(DataTypeEnum eType,BOOL &bUnsigned)
{

	switch (eType)
	{
		case adUnsignedSmallInt:	bUnsigned = TRUE;
		case adSmallInt:			return SDB_DBTYPE_SMALLINT;		break;
		case adUnsignedInt:			bUnsigned = TRUE;							
		case adInteger:				return SDB_DBTYPE_INTEGER;		break;
		case adUnsignedBigInt:		bUnsigned = TRUE;								
		case adBigInt:				return SDB_DBTYPE_BIGINT;		break;
		case adSingle:				return SDB_DBTYPE_REAL;			break;
		case adDouble:				return SDB_DBTYPE_DOUBLE;		break;
		case adCurrency:			return SDB_DBTYPE_CURRENCY;		break;
		case adVarNumeric:
		case adNumeric:				return SDB_DBTYPE_NUMERIC;		break;
		case adDecimal:				return SDB_DBTYPE_DECIMAL;		break;
		case adDate:
		case adDBDate:				return SDB_DBTYPE_DATE;			break;
		case adDBTime:				return SDB_DBTYPE_TIME;			break;
		case adDBTimeStamp:			return SDB_DBTYPE_TIMESTAMP;	break;
		case adBoolean:				return SDB_DBTYPE_BOOLEAN;		break;
		case adBinary:												
		case adGUID:				return SDB_DBTYPE_BINARY;		break;
		case adBSTR:
		case adVarWChar:
		case adVarChar:				return SDB_DBTYPE_VARCHAR;		break;
		case adLongVarWChar:
		case adLongVarChar:			return SDB_DBTYPE_LONGVARCHAR;	break;
		case adVarBinary:			return SDB_DBTYPE_VARBINARY;	break;
		case adLongVarBinary:		return SDB_DBTYPE_LONGVARBINARY;break;
		case adWChar:
		case adChar:				return SDB_DBTYPE_CHAR;			break;
		case adUnsignedTinyInt:		bUnsigned = TRUE;
		case adTinyInt:				return SDB_DBTYPE_TINYINT;		break;
		default:					return SDB_DBTYPE_UNKNOWN;
	}
};

DataTypeEnum ADOS::ADOTypeFromSdbType(SdbDatabaseType _eType,BOOL bUnsigned)
{
	DataTypeEnum eType;
	switch (_eType)
	{
		case SDB_DBTYPE_SMALLINT:		bUnsigned ? eType = adUnsignedSmallInt	:	eType = adSmallInt;		break;
		case SDB_DBTYPE_INTEGER:		bUnsigned ? eType = adUnsignedInt		:	eType = adInteger;		break;
		case SDB_DBTYPE_BIGINT:			bUnsigned ? eType = adUnsignedBigInt	:	eType = adBigInt;		break;
		case SDB_DBTYPE_REAL:			eType = adSingle;			break;
		case SDB_DBTYPE_DOUBLE:			eType = adDouble;			break;
		case SDB_DBTYPE_CURRENCY:		eType = adCurrency;			break;
		case SDB_DBTYPE_NUMERIC:		eType = adNumeric;			break;
		case SDB_DBTYPE_DECIMAL:		eType = adDecimal;			break;
		case SDB_DBTYPE_DATE:			eType = adDBDate;			break;
		case SDB_DBTYPE_TIME:			eType = adDBTime;			break;
		case SDB_DBTYPE_TIMESTAMP:		eType = adDBTimeStamp;		break;
		case SDB_DBTYPE_BOOLEAN:		eType = adBoolean;			break;
		case SDB_DBTYPE_BINARY:			eType = adBinary;			break;
		case SDB_DBTYPE_VARCHAR:		eType = adVarChar;			break;
		case SDB_DBTYPE_LONGVARCHAR:	eType = adLongVarChar;		break;
		case SDB_DBTYPE_VARBINARY:		eType = adVarBinary;		break;
		case SDB_DBTYPE_LONGVARBINARY:	eType = adLongVarBinary;	break;
		case SDB_DBTYPE_CHAR:			eType = adChar;				break;
		case SDB_DBTYPE_TINYINT:		bUnsigned ? eType = adUnsignedTinyInt	:	eType = adTinyInt;		break;
		default:						eType = adChar;
	}
	return eType;
}





