/*************************************************************************
 *
 *  $RCSfile: adomd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_ADOCONN_HXX
#include <adoconn.hxx>
#endif
#include "adomd.hxx"
#include <odbc/sqlext.h>

// is defined in windef header
// but we use it for subqueries
#ifdef IN
#undef IN
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQL92_HPP_
#include <com/sun/star/data/DatabaseSQL92.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

#include <oledb.h>

#define ADO_PROP(ItemName)								\
		ADOProperty* pProp = NULL;						\
		pProps->get_Item(OLEVariant(ItemName),&pProp);	\
		WpADOProperty aProp(pProp);						\
		OLEVariant aVar;								\
		if(aProp.IsValid())								\
			aVar = aProp.GetValue();


//------------------------------------------------------------------
sal_Bool SdbADOMetaData::isCapableImpl(sal_Int16 nCapability) const
{
	const WpADOConnection* pADOCon = ((SdbADOConnection*)pCon)->GetADOConnection();
	ADOProperties* pProps = pADOCon->get_Properties();
	DBG_ASSERT(pProps,"There are no properties at the connection");
	pProps->AddRef();

	sal_Bool erg(sal_False);
	switch(nCapability)
	{
		case ::stardata::DatabaseCapability::COLUMN_ALIAS:
			{
				//	ADO_PROP(DBLITERAL_COLUMN_ALIAS);
				//	erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() != SQL_GB_NOT_SUPPORTED : sal_False);
				erg = sal_True;
			}
			break;
		case ::stardata::DatabaseCapability::TABLE_CORRELATION_NAME:
			erg = sal_True;
			break;
		case ::stardata::DatabaseCapability::CONVERT:
			erg = sal_False;
			break;
		case ::stardata::DatabaseCapability::EXPRESSION_ORDERBY:
			{
				ADO_PROP(DBPROP_ORDERBYCOLUMNSINSELECT);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetBool() : sal_False);
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY:
			{
				ADO_PROP(DBPROP_GROUPBY);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() != DBPROPVAL_GB_NOT_SUPPORTED : sal_False);
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY_BEYONDSELECT:
			{
				ADO_PROP(DBPROP_GROUPBY);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() != DBPROPVAL_GB_CONTAINS_SELECT : sal_False);
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY_UNRELATED:
			{
				ADO_PROP(DBPROP_GROUPBY);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() == DBPROPVAL_GB_NO_RELATION : sal_False);
			}
			break;
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
			{
				ADO_PROP(DBPROP_COLUMNDEFINITION);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() == DBPROPVAL_CD_NOTNULL: sal_False);
			}
			break;
		case ::stardata::DatabaseCapability::INTEGRITY:
			{
				erg = sal_True;
			}
			break;
		case ::stardata::DatabaseCapability::ORDERBY_UNRELATED:
			{
				ADO_PROP(DBPROP_ORDERBYCOLUMNSINSELECT);
				erg =  (!aVar.IsNull() && !aVar.IsEmpty() ? aVar : sal_False);
			}	break;
		case ::stardata::DatabaseCapability::UNION:
			break;
		case ::stardata::DatabaseCapability::UNION_ALL:
			break;
		case ::stardata::DatabaseCapability::TRANSACTIONS:
			{
				ADO_PROP(DBPROP_SUPPORTEDTXNDDL);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar.GetInt32() != DBPROPVAL_TC_NONE;
			}
			break;
	}
	pProps->Release();
	return erg;
}

//------------------------------------------------------------------
::staruno::Any SdbADOMetaData::getInfoImpl(sal_Int16 nInfo) const
{
	::staruno::Any erg;
	WpADOConnection* pADOCon = ((SdbADOConnection*)pCon)->GetADOConnection();
	ADOProperties* pProps = pADOCon->get_Properties();
	DBG_ASSERT(pProps,"There are no properties at the connection");
	pProps->AddRef();

	switch(nInfo)
	{
		case ::stardata::DatabaseInfo::CATALOG_AT_START:
		{
			ADO_PROP(DBPROP_CATALOGLOCATION);
			erg <<= !aVar.IsNull() && !aVar.IsEmpty() ? (sal_Bool)(BOOL)aVar : sal_False;
		}	break;
		case ::stardata::DatabaseInfo::READ_ONLY:
		{
			ConnectModeEnum eMode = pADOCon->get_Mode();
			erg <<= sal_Bool((eMode & adModeRead) == adModeRead);
		}	break;
		case ::stardata::DatabaseInfo::NULLPLUSNONNULLISNULL:
		{
			ADO_PROP(DBPROP_CONCATNULLBEHAVIOR);
			erg <<= sal_Bool(!aVar.IsNull() && !aVar.IsEmpty() ? aVar.GetInt32() == DBPROPVAL_CB_NON_NULL : sal_False);
		}	break;
		case ::stardata::DatabaseInfo::TABLE_DEFINITION:
		{
			sal_Int16 nResults(::stardata::DatabaseTableDefinition::DROP | ::stardata::DatabaseTableDefinition::CREATE);

			ADO_PROP(DBPROP_ALTERCOLUMN);
			if (!aVar.IsNull() && !aVar.IsEmpty())
			{
				sal_Int32 nProp = aVar.GetInt32();
				// XXXXX nProp should be checked
				nResults |= ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN | ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN;
			}
			erg <<= nResults;
		}	break;
		case ::stardata::DatabaseInfo::VIEW_DEFINITION:
			break;
		case ::stardata::DatabaseInfo::INDEX_DEFINITION:
			erg <<= sal_Int16(::stardata::DatabaseIndexDefinition::DROP | ::stardata::DatabaseIndexDefinition::CREATE);
			break;
		case ::stardata::DatabaseInfo::IDENT_CASE:
		{
			ADO_PROP(DBPROP_IDENTIFIERCASE);
			if(!aVar.IsNull() && !aVar.IsEmpty())
			{
				sal_Int16 nResults;
				UWORD nUS = aVar.GetInt32();
				if (nUS & DBPROPVAL_IC_UPPER)
					nResults = ::stardata::DatabaseIdentifierCase::UPPER;
				else if(nUS & DBPROPVAL_IC_LOWER)
					nResults = ::stardata::DatabaseIdentifierCase::LOWER;
				else if(nUS & DBPROPVAL_IC_MIXED)
					nResults = ::stardata::DatabaseIdentifierCase::MIXED;
				else if(nUS & DBPROPVAL_IC_SENSITIVE)
					nResults = ::stardata::DatabaseIdentifierCase::SENSITIVE;
				else
					nResults = ::stardata::DatabaseIdentifierCase::MIXED;

				erg <<= nResults;
			}
		}	break;
		case ::stardata::DatabaseInfo::IDENT_CASE_QUOTED:
		{
			ADO_PROP(DBPROP_QUOTEDIDENTIFIERCASE);
			if(!aVar.IsNull() && !aVar.IsEmpty())
			{
				sal_Int16 nResults;
				UWORD nUS = aVar.GetInt32();
				if(nUS & DBPROPVAL_IC_UPPER)
					nResults = ::stardata::DatabaseIdentifierCase::UPPER;
				else if(nUS & DBPROPVAL_IC_LOWER)
					nResults = ::stardata::DatabaseIdentifierCase::LOWER;
				else if(nUS & DBPROPVAL_IC_MIXED)
					nResults = ::stardata::DatabaseIdentifierCase::MIXED;
				else if(nUS & DBPROPVAL_IC_SENSITIVE)
					nResults = ::stardata::DatabaseIdentifierCase::SENSITIVE;
				else
					nResults = ::stardata::DatabaseIdentifierCase::MIXED;

				erg <<= nResults;
			}
		}	break;
		case ::stardata::DatabaseInfo::NULLS_SORT:
			{
				ADO_PROP(DBPROP_NULLCOLLATION);
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nResults;
					UWORD nUS = aVar.GetInt32();
					if (nUS & SQL_NC_END)
						nResults = ::stardata::DatabaseNullsSort::AT_END;
					else if(nUS & SQL_NC_START)
						nResults = ::stardata::DatabaseNullsSort::AT_START;
					else if(nUS & SQL_NC_HIGH)
						nResults = ::stardata::DatabaseNullsSort::HIGH;
					else if(nUS & SQL_NC_LOW)
						nResults = ::stardata::DatabaseNullsSort::LOW;
					else
						nResults = ::stardata::DatabaseNullsSort::AT_START;

					erg <<= nResults;
				}
			}
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_UPDATE_RULE:
		case ::stardata::DatabaseInfo::FOREIGN_KEY_DELETE_RULE:
			erg <<= (sal_Int16) (::stardata::DatabaseKeyRule::CASCADE | ::stardata::DatabaseKeyRule::NO_ACTION);
			break;
		case ::stardata::DatabaseInfo::SCHEMA_USAGE:
			{
				ADO_PROP(String::CreateFromAscii("File Usage"));
				if(!aVar.IsNull() || !aVar.GetInt16())
				{

					ADO_PROP(DBPROP_SCHEMAUSAGE);
					if(!aVar.IsNull() && !aVar.IsEmpty())
						erg <<= (sal_Int16)aVar.GetInt16();
					else
					{
						ADO_PROP(String::CreateFromAscii("Schema Usage"));
						if(!aVar.IsNull() && !aVar.IsEmpty())
							erg <<= (sal_Int16)aVar.GetInt16();
					}
				}
			}	break;
		case ::stardata::DatabaseInfo::CATALOG_USAGE:
			{
				ADO_PROP(String::CreateFromAscii("File Usage"));
				if(!aVar.IsNull() || !aVar.GetInt16())
				{
					ADO_PROP(DBPROP_CATALOGUSAGE);
					if(!aVar.IsNull() && !aVar.IsEmpty())
						erg <<= (sal_Int16)aVar.GetInt16();
				}
			}	break;
		case ::stardata::DatabaseInfo::SUBQUERIES:
			{
				ADO_PROP(DBPROP_SUBQUERIES);
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nUsage(0);
					sal_uInt32 nUS = aVar.GetInt32();
					if(nUS & DBPROPVAL_SQ_CORRELATEDSUBQUERIES)
						nUsage = ::stardata::DatabaseSubquery::CORRELATED;
					if(nUS & DBPROPVAL_SQ_COMPARISON)
						nUsage |= ::stardata::DatabaseSubquery::COMPARSION;
					if(nUS & DBPROPVAL_SQ_EXISTS)
						nUsage |= ::stardata::DatabaseSubquery::EXISTS;
					if(nUS & DBPROPVAL_SQ_IN)
						nUsage |= ::stardata::DatabaseSubquery::IN;
					if(nUS & DBPROPVAL_SQ_QUANTIFIED)
						nUsage |= ::stardata::DatabaseSubquery::QUANTIFIED;
					erg <<= (sal_Int16)nUsage;
				}
			}
			break;
		case ::stardata::DatabaseInfo::SUPPORTED_ISOLATION_LEVELS:
			{
				ADO_PROP(DBPROP_SUPPORTEDTXNISOLEVELS);
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nUsage(0);
					sal_uInt32 nUS = aVar.GetInt32();

					if(nUS & DBPROPVAL_TI_READCOMMITTED)
						nUsage |= ::stardata::DatabaseIsolationLevel::READ_COMMIT;
					else if(nUS & DBPROPVAL_TI_READUNCOMMITTED)
						nUsage |= ::stardata::DatabaseIsolationLevel::READ_UNCOMMIT;
					else if(nUS & DBPROPVAL_TI_REPEATABLEREAD)
						nUsage |= ::stardata::DatabaseIsolationLevel::REPEAT_READ;
					else if(nUS & DBPROPVAL_TI_SERIALIZABLE)
						nUsage |= ::stardata::DatabaseIsolationLevel::SERIALIZABLE;
					else
						nUsage = ::stardata::DatabaseIsolationLevel::NONE;
					erg <<= (sal_Int16)nUsage;
				}
			}
			break;
		case ::stardata::DatabaseInfo::ANSI_SQL_92:
			{
				ADO_PROP(DBPROP_SQLSUPPORT);
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nUsage(0);
					sal_uInt32 nUS = aVar.GetInt32();
					if(!(nUS & DBPROPVAL_SQL_ANSI92_FULL))
					{
						if(!(nUS & DBPROPVAL_SQL_ANSI92_INTERMEDIATE))
						{
							if(!(nUS & DBPROPVAL_SQL_ANSI92_ENTRY))
								nUsage = ::stardata::DatabaseSQL92::ENTRY_LEVEL;
						}
						else
							nUsage |= ::stardata::DatabaseSQL92::INTERMEDIATE | ::stardata::DatabaseSQL92::ENTRY_LEVEL;
					}else
						nUsage |= ::stardata::DatabaseSQL92::FULL | ::stardata::DatabaseSQL92::ENTRY_LEVEL | ::stardata::DatabaseSQL92::INTERMEDIATE;
				}
			}
			break;
		case ::stardata::DatabaseInfo::DSN_URL:
			{
				ADO_PROP(DBPROP_DATASOURCENAME);
				if (!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			{
				ADO_PROP(DBPROP_PROVIDERNAME);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::DRIVER_VERSION:
			{
				ADO_PROP(DBPROP_PROVIDERVER);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::DBMS_VERSION:
			{
				ADO_PROP(String::CreateFromAscii("Driver Version"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::DBMS_NAME:
			{
				ADO_PROP(String::CreateFromAscii("Driver Name"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::PROC_TERM:
			{
				ADO_PROP(DBPROP_PROCEDURETERM);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_TERM:
			{
				ADO_PROP(DBPROP_CATALOGTERM);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::SCHEMA_TERM:
			{
				ADO_PROP(DBPROP_SCHEMATERM);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::TABLE_TERM:
			{
				ADO_PROP(DBPROP_TABLETERM);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
				else
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::IDENTIFIER_QUOTE_CHAR:
			{
				ADORecordset *pRecordset = NULL;
				OLEVariant  vtEmpty;
				vtEmpty.SetNoArg();
				pADOCon->OpenSchema(adSchemaDBInfoLiterals,vtEmpty,vtEmpty,&pRecordset);
				if(!pRecordset)
					break;
				WpADORecordset aRecordset(pRecordset);

				aRecordset.MoveFirst();
				OLEVariant  aValue;
				sal_Bool bSet = sal_False;
				while(!aRecordset.IsAtEOF())
				{
					ADOFields  *pFields = aRecordset.GetFields();
					pFields->AddRef();
					ADOField* pField=NULL;
					pFields->get_Item(OLEVariant(4),&pField);
					WpADOField aField(pField);
					aField.get_Value(aValue);
					if(aValue.GetUInt32() == DBLITERAL_QUOTE_PREFIX)
					{
						pFields->get_Item(OLEVariant(5),&pField);
						aField = WpADOField(pField);
						aField.get_Value(aValue);
						if(aValue.GetBool())
						{
							pFields->get_Item(OLEVariant(1),&pField);
							aField = WpADOField(pField);
							aField.get_Value(aValue);
							if(!aValue.IsNull())
							{
								erg <<= (rtl::OUString)aValue;
								bSet = sal_True;
							}
						}
					}

					pFields->Release();
					aRecordset.MoveNext();
				}
				aRecordset.Close();
				if(!bSet)
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::SQL_KEYWORDS:
			{
				ADO_PROP(String::CreateFromAscii("SQL Keywords"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_SEPARATOR:
			{
				ADORecordset *pRecordset = NULL;
				OLEVariant  vtEmpty;
				vtEmpty.SetNoArg();
				pADOCon->OpenSchema(adSchemaDBInfoLiterals,vtEmpty,vtEmpty,&pRecordset);
				if(!pRecordset)
					break;
				WpADORecordset aRecordset(pRecordset);

				aRecordset.MoveFirst();
				OLEVariant  aValue;
				sal_Bool bSet = sal_False;
				while(!aRecordset.IsAtEOF())
				{
					ADOFields  *pFields = aRecordset.GetFields();
					pFields->AddRef();
					ADOField* pField=NULL;
					pFields->get_Item(OLEVariant(4),&pField);
					WpADOField aField(pField);
					aField.get_Value(aValue);
					if(aValue.GetUInt32() == DBLITERAL_CATALOG_SEPARATOR)
					{
						pFields->get_Item(OLEVariant(5),&pField);
						aField = WpADOField(pField);
						aField.get_Value(aValue);
						if(aValue.GetBool())
						{
							pFields->get_Item(OLEVariant(1),&pField);
							aField = WpADOField(pField);
							aField.get_Value(aValue);
							if(!aValue.IsNull())
							{
								erg <<= (rtl::OUString)aValue;
								bSet = sal_True;
							}
						}
					}

					pFields->Release();
					aRecordset.MoveNext();
				}
				aRecordset.Close();
				if(!bSet)
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::SEARCH_PATTERN_ESCAPE:
			{
				ADORecordset *pRecordset = NULL;
				OLEVariant  vtEmpty;
				vtEmpty.SetNoArg();
				pADOCon->OpenSchema(adSchemaDBInfoLiterals,vtEmpty,vtEmpty,&pRecordset);
				if(!pRecordset)
					break;
				WpADORecordset aRecordset(pRecordset);

				aRecordset.MoveFirst();
				OLEVariant  aValue;
				sal_Bool bSet = sal_False;
				while(!aRecordset.IsAtEOF())
				{
					ADOFields  *pFields = aRecordset.GetFields();
					pFields->AddRef();
					ADOField* pField=NULL;
					pFields->get_Item(OLEVariant(4),&pField);
					WpADOField aField(pField);
					aField.get_Value(aValue);
					if(aValue.GetUInt32() == DBLITERAL_ESCAPE_PERCENT)
					{
						pFields->get_Item(OLEVariant(5),&pField);
						aField = WpADOField(pField);
						aField.get_Value(aValue);
						if(aValue.GetBool())
						{
							pFields->get_Item(OLEVariant(1),&pField);
							aField = WpADOField(pField);
							aField.get_Value(aValue);
							if(!aValue.IsNull())
							{
								erg <<= (rtl::OUString)aValue;
								bSet = sal_True;
							}
						}
					}

					pFields->Release();
					aRecordset.MoveNext();
				}
				aRecordset.Close();
				if(!bSet)
					erg <<= rtl::OUString();
			}
			break;
		case ::stardata::DatabaseInfo::SPECIAL_CHARACTERS:
			{
				ADO_PROP(String::CreateFromAscii("Special Characters"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::STRING_FUNCTIONS:
			{
				ADO_PROP(String::CreateFromAscii("String Functions"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::SYSTEM_FUNCTIONS:
			{
				ADO_PROP(String::CreateFromAscii("System Functions"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::NUMERIC_FUNCTIONS:
			{
				ADO_PROP(MDPROP_MDX_NUMERIC_FUNCTIONS);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg <<= (rtl::OUString) aVar;
			}
			break;
		case ::stardata::DatabaseInfo::SQL_CONFORMANCE:
			{
				ADO_PROP(DBPROP_SQLSUPPORT);
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nUsage(0);
					sal_Int32 nUS = aVar.GetInt32();
					if(!(nUS & DBPROPVAL_SQL_ODBC_EXTENDED))
					{
						if(!(nUS & DBPROPVAL_SQL_ODBC_CORE))
						{
							if(!(nUS & DBPROPVAL_SQL_ODBC_MINIMUM))
								nUsage = ::stardata::DatabaseSQLConformance::MINIMUM;
						}
						else
							nUsage |= ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
					}
					else
						nUsage |= ::stardata::DatabaseSQLConformance::EXTENDED | ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
					erg <<= (sal_Int16)nUsage;
				}
			}
			break;
		case ::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT:
			{
				ADO_PROP(String::CreateFromAscii("Outer Join Capabilities"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
				{
					sal_Int16 nUsage(0);

					sal_uInt32 nOJ = aVar.GetInt32();

					if(nOJ & SQL_OJ_FULL)
						nUsage |= ::stardata::DatabaseOuterJoinSupport::FULL;
					if(nOJ & SQL_OJ_NESTED)
						nUsage |= ::stardata::DatabaseOuterJoinSupport::PARTIAL;
					if(nOJ & (SQL_OJ_LEFT|SQL_OJ_RIGHT|SQL_OJ_INNER))
						nUsage |= ::stardata::DatabaseOuterJoinSupport::YES;

					erg <<= (sal_Int16)nUsage;
				}
			}

	}
	pProps->Release();
	return erg;
}
//------------------------------------------------------------------
sal_Int32 SdbADOMetaData::getLimitImpl(sal_Int16 nLimit) const
{
	const WpADOConnection* pADOCon = ((SdbADOConnection*)pCon)->GetADOConnection();
	ADOProperties* pProps = pADOCon->get_Properties();
	DBG_ASSERT(pProps,"There are no properties at the connection");
	pProps->AddRef();

	sal_Int32 erg(0);
	switch(nLimit)
	{
		case ::stardata::DatabaseLimit::BINARAY_LITERAL_LEN:
			{
				ADO_PROP(DBPROP_MAXROWSIZEINCLUDESBLOB);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;
			} break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_SELECT:
			{
				ADO_PROP(String::CreateFromAscii("Max Columns in Select"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;
			} break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			{
				ADO_PROP(String::CreateFromAscii("Max Columns in Table"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			{
				ADO_PROP(DBPROP_MAXINDEXSIZE);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			break;
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_GROUPBY:
			{
				ADO_PROP(String::CreateFromAscii("Max Columns in ::com::sun::star::sdbcx::Group By"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			{
				ADO_PROP(String::CreateFromAscii("Max Columns in ::com::sun::star::sdbcx::Index"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_ORDERBY:
			{
				ADO_PROP(String::CreateFromAscii("Max Columns in Order By"));
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::CATALOG_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::SCHEMA_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::STATEMENT_LEN:
			break;
		case ::stardata::DatabaseLimit::TABLE_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::TABLES_IN_SELECT:
			{
				ADO_PROP(DBPROP_MAXTABLESINSELECT);
				if(!aVar.IsNull() && !aVar.IsEmpty())
					erg = aVar;

			} break;
		case ::stardata::DatabaseLimit::USER_NAME_LEN:
			break;
	}
	pProps->Release();
	return erg;
}
//------------------------------------------------------------------
sal_Bool SdbADOMetaData::canConvertImpl(sal_Int16 nFrom, sal_Int16 nIn) const
{
	return sal_False;
}



