/*************************************************************************
 *
 *  $RCSfile: adotab.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef SDB_ADOTAB_HXX
#include "adotab.hxx"
#endif

#ifndef SDB_ADOCON_HXX
#include "adoconn.hxx"
#endif

#ifndef _TOOLS_INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _ZFORMAT_HXX
#include <svtools\zformat.hxx>
#endif

#ifndef _SDB_SDBDB_HXX
#include "sdbdb.hxx"
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _SDB_SDBRESID_HRC
#include "sdbresid.hrc"
#endif

static char __READONLY_DATA privilegeSelect[] = "SELECT";
static char __READONLY_DATA privilegeInsert[] = "INSERT";
static char __READONLY_DATA privilegeUpdate[] = "UPDATE";
static char __READONLY_DATA privilegeDelete[] = "DELETE";
static char __READONLY_DATA privilegeReferences[] = "REFERENCES";

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

DBG_NAME(SdbADOTable);
//------------------------------------------------------------------------
SdbADOTable::SdbADOTable(SdbADOConnection* pConnection)
			 :SdbTable(pConnection)
{
	DBG_CTOR(SdbADOTable,NULL);
}


#define ADO_GETFIELD_BOOL(Name)	\
	pFields->get_Item(OLEVariant(Name),&pField);	\
	aField = WpADOField(pField);					\
	if(pField)										\
		aField.get_Value(aVar);

//------------------------------------------------------------------------
BOOL SdbADOTable::OpenImpl()
{
	SdbADOConnection *pConnection = (SdbADOConnection *)GetConnection();
	WpADOConnection* pADOConnection = pConnection->GetADOConnection();
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(pConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	BOOL bCase = pConnection->GetIdentifierCase() == SDB_IC_ALL;

	INT32 nPos = 0;
	HRESULT hr = S_OK;
	SAFEARRAYBOUND rgsabound[1];
	SAFEARRAY *psa				= NULL;
	OLEVariant aEmpty;
	aEmpty.SetNoArg();

	try
	{
		// Create elements used in the array
		OLEVariant varCriteria[4];
		const int nCrit = sizeof varCriteria / 
						 sizeof varCriteria[0];
		// Create SafeArray Bounds and initialize the array
		rgsabound[0].lLbound   = 0;   
		rgsabound[0].cElements = nCrit;
		psa         = SafeArrayCreate( VT_VARIANT, 1, rgsabound );
		
		if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria[nPos].SetString(aQualifierName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria[nPos]);nPos++; // TABLE_CATALOG

		if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria[nPos].SetString(aOwnerName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria[nPos]);nPos++; // TABLE_SCHEMA
		
		varCriteria[nPos].SetString(aName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria[nPos]);nPos++; // TABLE_NAME
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria[nPos]);nPos++; // COLUMN_NAME

		DBG_ASSERT(nPos == rgsabound[0].cElements,"Array not big enough");
		// Initialize and fill the SafeArray
		OLEVariant vsa;
		vsa.SetArray(psa,VT_VARIANT);

		ADORecordset*  pRecordset	= NULL;
		pADOConnection->OpenSchema(adSchemaColumns,vsa,aEmpty,&pRecordset);
		//SafeArrayDestroy(psa);
		if(!pRecordset)
			return FALSE;

		WpADORecordset aRecordset(pRecordset);
		INT16  nFlags = 0;
		BYTE nPrec;					// Precision (ggf. 0)
		BYTE nScale;				// Scale (ggf. 0)
		SdbDatabaseType eType;
		String aColumnName;			// Spaltenname
		aRecordset.MoveFirst();
		vector<SdbColumn*> vecColumns;
		while(!aRecordset.IsAtEOF())
		{
			nFlags = nPrec = nScale = 0;

			ADOFields  *pFields = aRecordset.GetFields(); 
			pFields->AddRef();
			ADOField* pField = NULL;
			WpADOField aField;
			OLEVariant aVar;

			ADO_GETFIELD_BOOL(String::CreateFromAscii("COLUMN_NAME"));
			aColumnName = (String)aVar;
			
			ADO_GETFIELD_BOOL(String::CreateFromAscii("DATA_TYPE"));
			DataTypeEnum eDataType = (DataTypeEnum )aVar.GetInt32();
			BOOL bUnsigned = FALSE;
			eType = ADOS::SdbTypeFromADOType(eDataType,bUnsigned);
			if(eType == SDB_DBTYPE_BIGINT)
				eType = SDB_DBTYPE_DOUBLE;

			ADO_GETFIELD_BOOL(String::CreateFromAscii("IS_NULLABLE"));
			BOOL bNullAllowed = aVar.IsNull() ? FALSE : (BOOL)aVar;

			String aComment;
			ADO_GETFIELD_BOOL(String::CreateFromAscii("DESCRIPTION"));
			if(!aVar.IsNull())
				aComment = (String)aVar;

			String aDefault;
			ADO_GETFIELD_BOOL(String::CreateFromAscii("COLUMN_DEFAULT"));
			if(!aVar.IsNull())
				aDefault = (String)aVar;

			switch(eType)
			{
				case SDB_DBTYPE_TINYINT:
				case SDB_DBTYPE_SMALLINT:	
				case SDB_DBTYPE_INTEGER:	
				case SDB_DBTYPE_BIGINT:		
				case SDB_DBTYPE_REAL:			
				case SDB_DBTYPE_DOUBLE:			
				{
					ADO_GETFIELD_BOOL(String::CreateFromAscii("NUMERIC_PRECISION"));
					nPrec = aVar.IsNull() ? 0 : aVar.GetByte();
				}	break;
				case SDB_DBTYPE_BOOLEAN:		
				case SDB_DBTYPE_BINARY:			
				case SDB_DBTYPE_VARCHAR:		
				case SDB_DBTYPE_LONGVARCHAR:	
				case SDB_DBTYPE_VARBINARY:		
				case SDB_DBTYPE_LONGVARBINARY:	
				case SDB_DBTYPE_CHAR:	
				case SDB_DBTYPE_CURRENCY:
				{
					ADO_GETFIELD_BOOL(String::CreateFromAscii("CHARACTER_OCTET_LENGTH"));
					nPrec = aVar.IsNull() ? 0 : aVar.GetInt32();
				}	break;
				case SDB_DBTYPE_DATE:			
				case SDB_DBTYPE_TIME:			
				case SDB_DBTYPE_TIMESTAMP:		
				{
					ADO_GETFIELD_BOOL(String::CreateFromAscii("DATETIME_PRECISION"));
					nPrec = aVar.IsNull() ? 0 : aVar.GetInt32();
				}	break;
				case SDB_DBTYPE_NUMERIC:
				case SDB_DBTYPE_DECIMAL:
				{
					ADO_GETFIELD_BOOL(String::CreateFromAscii("NUMERIC_PRECISION"));
					nPrec = aVar.IsNull() ? 0 : aVar.GetByte();

					ADO_GETFIELD_BOOL(String::CreateFromAscii("NUMERIC_SCALE"));
					nScale = aVar.IsNull() ? 0 : aVar.GetByte();
				}	break;
			}

			ULONG kk(0);
			const SdbTypeInfoList& aTypeList = pConnection->GetTypeInfo();
			const SdbTypeInfo* pInfo = aTypeList.GetObject(kk++);
			// Suchen ob entsprechende Typinformationen vorhanden sind
			while (pInfo)
			{
				// Ist der Typ vorhanden

				if (pInfo->eType == eType							&& 
					pInfo->nPrecision	>= nPrec 					&&
					pInfo->nScale >= nScale							&&
					(bNullAllowed ? pInfo->bNullable : TRUE))
				{
					break;
				}
				pInfo = aTypeList.GetObject(kk++);
			}
			// Sonderbehandlung fuer Currency ,Autoincrement
			if(!pInfo)
			{
				pInfo = pConnection->GetColumnTypeInfo(eType); // das ist die letzte M"oglichkeit einen Typ zu bestimmen
			}
			DBG_ASSERT(pInfo, "keine TypeInfo");

			// Zusaetzliche Flags:
			// bei unbekannten Typen ist pInfo NULL, z.B. benutzerdefinierten
			if (pInfo)
			{
				if (bNullAllowed && pInfo->bNullable)
					nFlags |= SDB_FLAGS_NULLALLOWED;
	#if 0
				if (pInfo && pInfo->bCurrency)
					eType = SDB_DBTYPE_CURRENCY;

				else
	#endif
				if (pInfo->bAutoIncrement)
					nFlags |= SDB_FLAGS_AUTOINCREMENT;
				switch (pInfo->eSearchType)
				{
					case Search_Like_Only  :	nFlags |= SDB_FLAGS_SEARCH_LIKE; break;
					case Search_Except_Like:	nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE; break;
					case Search_All:			nFlags |= SDB_FLAGS_SEARCH_ALL; break;
				}
			}
			else // keine TypeInfo dann nullable
				nFlags |= SDB_FLAGS_NULLALLOWED;

			SdbColumn* pColumn = CreateColumn(aColumnName,eType,nPrec,nScale,nFlags);
			pColumn->SetDefaultValue(aDefault);
			pColumn->SetComment(aComment);

			// ... und in Columns-Struktur einfuegen
			//	aOriginalColumns->AddColumn(pColumn);
			ADO_GETFIELD_BOOL(String::CreateFromAscii("ORDINAL_POSITION"));
			if(!aVar.IsNull())
			{
				nPos = aVar.GetUInt32();
				if(nPos > vecColumns.size())
				{
					for(INT32 i=0;i<(vecColumns.size()-nPos);++i)
						vecColumns.push_back(NULL);
					vecColumns[nPos-1] = pColumn;
				}
				else
					vecColumns[nPos-1] = pColumn;
			}
			else
			{
				nPos = aOriginalColumns->Count();
				vecColumns.push_back(pColumn);
			}

			pFields->Release();
			aRecordset.MoveNext();
		}
		aRecordset.Close();
		for(vector<SdbColumn*>::const_iterator aIter=vecColumns.begin();aIter != vecColumns.end();++aIter)
			aOriginalColumns->AddColumn(*aIter);
	}
	catch (...)
	{
		DBG_ERROR("Exception from OLE: adSchemaColumns");
	}
	
	// check for indexes
	try
	{
		// Create elements used in the array
		OLEVariant varCriteria2[5];
		
		// Create SafeArray Bounds and initialize the array
		rgsabound[0].lLbound   = 0;   
		rgsabound[0].cElements = 5;
		psa         = SafeArrayCreate( VT_VARIANT, 1, rgsabound );
		
		nPos = 0;
		if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria2[nPos].SetString(aQualifierName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria2[nPos]);nPos++;

		if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria2[nPos].SetString(aOwnerName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria2[nPos]);nPos++;
		
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria2[nPos]);nPos++;// INDEX_NAME
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria2[nPos]);nPos++;// TYPE
		varCriteria2[nPos].SetString(aName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria2[nPos]);nPos++;// TABLE_NAME

		DBG_ASSERT(nPos == rgsabound[0].cElements,"Array not big enough");
		// Initialize and fill the SafeArray
		OLEVariant vsa;
		vsa.SetArray(psa,VT_VARIANT);

		ADORecordset*  pRecordset	= NULL;
		pADOConnection->OpenSchema(adSchemaIndexes,vsa,aEmpty,&pRecordset);
		//SafeArrayDestroy(psa);
		if(pRecordset)
		{
			WpADORecordset aRecordset(pRecordset);
			String aIndexName,aIndexQualifier,aNewName;
			while(!aRecordset.IsAtEOF())
			{
				ADOFields  *pFields = aRecordset.GetFields(); 
				pFields->AddRef();
				ADOField* pField = NULL;
				WpADOField aField;
				OLEVariant aVar;
				SdbColumn *pColumn = NULL;

				ADO_GETFIELD_BOOL(String::CreateFromAscii("TYPE"));
				if(!aVar.IsNull() && aVar.GetInt32() != 0)
				{
					ADO_GETFIELD_BOOL(String::CreateFromAscii("INDEX_NAME"));
					aNewName = (String)aVar;
					ADO_GETFIELD_BOOL(String::CreateFromAscii("INDEX_CATALOG"));
					if ((bCase ? aIndexName == aNewName : aIndexName.EqualsIgnoreCaseAscii(aNewName)) &&
						(aVar.IsNull() || (bCase ? aVar.GetString() == aIndexQualifier : aVar.GetString().EqualsIgnoreCaseAscii(aIndexQualifier))))
					{
						// naechste Spalte des aktuellen Index
						ADO_GETFIELD_BOOL(String::CreateFromAscii("COLUMN_NAME"));
						pColumn = (SdbColumn*)(*aOriginalColumns)[aVar];
					}
					else	// neuer Index
					{	
						ADO_GETFIELD_BOOL(String::CreateFromAscii("UNIQUE"));
						if (!aVar.IsNull() && aVar.GetBool())
						{
							aIndexName = aNewName;
							ADO_GETFIELD_BOOL(String::CreateFromAscii("INDEX_CATALOG"));
							if (!aVar.IsNull())
								aIndexQualifier = (String)aVar;
							ADO_GETFIELD_BOOL(String::CreateFromAscii("COLUMN_NAME"));
							pColumn = (SdbColumn*)(*aOriginalColumns)[aVar];
						}
					}
					if (pColumn)
						pColumn->SetFlag(SDB_FLAGS_UNIQUE);
				}

				pFields->Release();
				aRecordset.MoveNext();
			}
			aRecordset.Close();
		}
	}
	catch (...)
	{
		DBG_ERROR("Exception from OLE: adSchemaIndexes");
	}
	
	try
	{
		// Create elements used in the array
		OLEVariant varCriteria3[3];
		
		// Create SafeArray Bounds and initialize the array
		rgsabound[0].lLbound   = 0;   
		rgsabound[0].cElements = 3;
		psa         = SafeArrayCreate( VT_VARIANT, 1, rgsabound );
		
		nPos = 0;
		if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria3[nPos].SetString(aQualifierName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria3[nPos]);nPos++;

		if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
			varCriteria3[nPos].SetString(aOwnerName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria3[nPos]);nPos++;
		
		varCriteria3[nPos].SetString(aName);
		hr = SafeArrayPutElement(psa,&nPos,&varCriteria3[nPos]);nPos++;
		DBG_ASSERT(nPos == rgsabound[0].cElements,"Array not big enough");

		// Initialize and fill the SafeArray
		OLEVariant vsa;
		vsa.SetArray(psa,VT_VARIANT);

		ADORecordset*  pRecordset	= NULL;
		pADOConnection->OpenSchema(adSchemaPrimaryKeys,vsa,aEmpty,&pRecordset);
		//SafeArrayDestroy(psa);
		if(pRecordset)
		{
			WpADORecordset aRecordset(pRecordset);
			while(!aRecordset.IsAtEOF())
			{
				ADOFields  *pFields = aRecordset.GetFields(); 
				pFields->AddRef();
				ADOField* pField = NULL;
				WpADOField aField;
				OLEVariant aVar;

				ADO_GETFIELD_BOOL(String::CreateFromAscii("PK_NAME"));
				if(!aVar.IsNull())
					aPKeyName = (String)aVar;

				ADO_GETFIELD_BOOL(String::CreateFromAscii("COLUMN_NAME"));
				SdbColumn* pColumn = (SdbColumn*)aOriginalColumns->Column(aVar);
				if (pColumn)
					pColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
				pFields->Release();
				aRecordset.MoveNext();
			}
			aRecordset.Close();
		}
	}
	catch ( ... )
	{
		DBG_ERROR("Exception from OLE: adSchemaPrimaryKeys");
	}
	
	// setzen der Privileges
	nPrivileges = SDB_PR_READ;
	if (!pConnection->IsCapable(SDB_CAP_UPDATABLE))
		nPrivileges = SDB_PR_READ;
	else
	{
		try
		{
			// Create elements used in the array
			OLEVariant varCriteria4[5];
			
			// Create SafeArray Bounds and initialize the array
			rgsabound[0].lLbound   = 0;   
			rgsabound[0].cElements = 5;
			psa         = SafeArrayCreate( VT_VARIANT, 1, rgsabound );
			
			nPos = 0;
			if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
				varCriteria4[nPos].SetString(aQualifierName);
			hr = SafeArrayPutElement(psa,&nPos,&varCriteria4[nPos]);nPos++;

			if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
				varCriteria4[nPos].SetString(aOwnerName);
			hr = SafeArrayPutElement(psa,&nPos,&varCriteria4[nPos]);nPos++;
			
			varCriteria4[nPos].SetString(aName);
			hr = SafeArrayPutElement(psa,&nPos,&varCriteria4[nPos]);nPos++;
			hr = SafeArrayPutElement(psa,&nPos,&varCriteria4[nPos]);nPos++;
			hr = SafeArrayPutElement(psa,&nPos,&varCriteria4[nPos]);nPos++;
			DBG_ASSERT(nPos == rgsabound[0].cElements,"Array not big enough");

			// Initialize and fill the SafeArray
			OLEVariant vsa;
			vsa.SetArray(psa,VT_VARIANT);

			ADORecordset*  pRecordset	= NULL;
			pADOConnection->OpenSchema(adSchemaTablePrivileges,vsa,aEmpty,&pRecordset);
			//SafeArrayDestroy(psa);
			if(pRecordset)
			{
				WpADORecordset aRecordset(pRecordset);
				while(!aRecordset.IsAtEOF())
				{
					ADOFields  *pFields = aRecordset.GetFields(); 
					pFields->AddRef();
					ADOField* pField = NULL;
					WpADOField aField;
					OLEVariant aVar;

					ADO_GETFIELD_BOOL(String::CreateFromAscii("GRANTEE"));
					if(!aVar.IsNull() && ((bCase) ? aVar.GetString() == pConnection->GetUser() :
						aVar.GetString().EqualsIgnoreCaseAscii(pConnection->GetUser())))
					{
						ADO_GETFIELD_BOOL(String::CreateFromAscii("PRIVILEGE"));
						
						String aPrivilege = !aVar.IsNull() ? aVar : String();
						if (aPrivilege.EqualsAscii(privilegeSelect))
							nPrivileges |= SDB_PR_READ;
						else if (aPrivilege.EqualsAscii(privilegeInsert))
							nPrivileges |= SDB_PR_INSERT;
						else if (aPrivilege.EqualsAscii(privilegeUpdate))
							nPrivileges |= SDB_PR_UPDATE;
						else if (aPrivilege.EqualsAscii(privilegeDelete))
							nPrivileges |= SDB_PR_DELETE;
						else if (aPrivilege.EqualsAscii(privilegeReferences))
							nPrivileges |= SDB_PR_REFERENCES;
					}
					pFields->Release();
					aRecordset.MoveNext();
				}
			}
			else	// if we don't get a result we think everything is possible
				nPrivileges |= SDB_PR_INSERT | SDB_PR_UPDATE | SDB_PR_DELETE | SDB_PR_REFERENCES;


		}
		catch (...)
		{
			DBG_ERROR("Exception from OLE: adSchemaTablePrivileges");
		}				
	}
	
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------
BOOL SdbADOTable::DropImpl()
{
	String aCommand;
	aCommand.AssignAscii("DROP TABLE ");

	SdbConnection* pConnection = GetConnection();
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(pConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aQualifierName);
		aCommand += pConnection->GetQualifierSeparator();
	}

	if (aOwnerName.Len() > 0 && (nSchemaUsage  & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}
	aCommand += pConnection->IdentifierQuotation(aName);

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}

//-----------------------------------------------------------------------------
BOOL SdbADOTable::AlterImpl()
{
	SdbConnectionRef xConnection(GetConnection()->GetEnvironment()->OpenConnection(*GetConnection()));
	if (!xConnection.Is())
	{
		aStatus = GetConnection()->GetEnvironment()->Status();
		return FALSE;
	}

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(xConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	BOOL bNotNullAllowed = rMetaData->isCapable(::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS);
	xConnection->BeginTrans();
	aStatus = xConnection->Status();
	if (!aStatus.IsSuccessful())
		return FALSE;

	String aStatement;
	String aTableName;


	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aQualifierName);
		aTableName += xConnection->GetQualifierSeparator();
	}

	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aOwnerName);
		aTableName += '.';
	}
	aTableName += xConnection->IdentifierQuotation(aName);

	// Zunaechst werden die Felder, die nicht mehr benoetigt werden, geloescht.
	for (UINT16 i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (!pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt;
				aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// Die Felder, die sich geaendert haben, geloescht
	for (i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (pRefColumn && !pColumn->Compare(*pRefColumn, SDB_FLAGS_NULLALLOWED))
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt;
				aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();

			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// und jetzt die neuen bzw. geaenderten hinzufuegen
	for (i = 1; aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (!pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AppendAscii(" ADD ");
			GenerateColumnCommand(aStatement, *pColumn, bNotNullAllowed);

			// gibt es eine neue Schluesselspalte, dann PKey loeschen
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt;
				aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AppendAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->AddColumn(CreateColumn(*pColumn));
		}
	}

	// gibt es noch Aenderungen am Schluessel
	for (i = 1; aPKeyName.Len() && aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (pRefColumn && pColumn->IsPrimaryKey() != pRefColumn->IsPrimaryKey())
		{
			String aStmt;
			aStmt.AssignAscii("ALTER TABLE ");
			aStmt += aTableName;
			aStmt.AppendAscii(" DROP CONSTRAINT ");
			aStmt += aPKeyName;
			xConnection->ExecuteSQL(aStmt);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aPKeyName.Erase();
		}
	}

	if (!aStatus.IsSuccessful())
	{
		xConnection->RollbackTrans();
		goto End;
	}

	if (!aPKeyName.Len()) // muss jetzt noch ein PKey hinzugefuegt werden ?
	{
		String aPColumns;
		for (UINT16 i = 1; i < aColumns->Count(); i++)
		{
			if ((*aColumns)[i]->IsPrimaryKey())
			{
				aPColumns += xConnection->IdentifierQuotation((*aColumns)[i]->GetName());
				aPColumns += ',';
			}
		}
		if (aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');

			String aCommand;
			aCommand.AssignAscii(" ALTER TABLE ");
			aCommand += aTableName;
			aCommand.AppendAscii(" ADD PRIMARY KEY (");
			aCommand += aPColumns;

			xConnection->ExecuteSQL(aCommand);
			aStatus = xConnection->Status();
		}
	}

	if (!aStatus.IsSuccessful() || !xConnection->CommitTrans())
	{
		aStatus = xConnection->Status();
		xConnection->RollbackTrans();
	}

End: // zum schlu nochmals einlesen
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbADOTable::GenerateColumnCommand(String& rStatement, const SdbColumn& rColumn, BOOL bNotNullAllowed)
{
	DBG_CHKTHIS(SdbADOTable,NULL);
	SdbConnection* pConnection = GetConnection();
	// Gibt es zu dieser Column eine Typinformationen
	const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(rColumn);

	if (!pInfo)
	{
		pInfo = pConnection->GetColumnTypeInfo(rColumn.GetType());
		if(!pInfo)
		{
			DBG_ASSERT(0,"ODBC Table: GetColumnTypeInfo == NULL");
			aStatus.SetDriverNotCapableError();
			return FALSE;
		}
	}

	rStatement += pConnection->IdentifierQuotation(rColumn.GetName());
	rStatement += ' ';
	rStatement += pInfo->aTypeName;

	switch(pInfo->eType)
	{
		case SDB_DBTYPE_CHAR:
		case SDB_DBTYPE_VARCHAR:
		case SDB_DBTYPE_BINARY:
		case SDB_DBTYPE_VARBINARY:
			// Typen mit Laengenangabe
			if(pInfo->aCreateParams.Len()) // only when the driver accepts create params
			{
				rStatement += '(';
				rStatement += String::CreateFromInt32(rColumn.GetLength());
				rStatement += ')';
			}
			break;
		case SDB_DBTYPE_DECIMAL:
		case SDB_DBTYPE_NUMERIC:
			// Typen mit Precision und Scale
			if(pInfo->aCreateParams.Len()) // only when the driver accepts create params
			{
				rStatement += '(';
				rStatement += String::CreateFromInt32(rColumn.GetPrecision());
				rStatement += ',';
				rStatement += String::CreateFromInt32(rColumn.GetScale());
				rStatement += ')';
			}
			break;
	}

	if (!rColumn.IsNullAllowed() && bNotNullAllowed)
		rStatement.AppendAscii(" NOT NULL");

	return TRUE;
}
//------------------------------------------------------------------------
inline void SdbADOTable::SetADOError()
{
	GetADOConnection()->SetADOError(aStatus);
}

//------------------------------------------------------------------------
BOOL SdbADOTable::CreateImpl()
{
	SdbConnection* pConnection = GetConnection();

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(pConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	BOOL bNotNullAllowed = rMetaData->isCapable(::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS);
	String aCommand;
	aCommand.AssignAscii("CREATE TABLE ");

	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aQualifierName);
		aCommand += pConnection->GetQualifierSeparator();
	}

	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}
	aCommand += pConnection->IdentifierQuotation(aName);
	aCommand += ' ';
	aCommand += '(';

	if (!GenerateAddCommands(aCommand,bNotNullAllowed)) return FALSE;

	sal_Int16 nConformance;
	rMetaData->getInfo(::stardata::DatabaseInfo::SQL_CONFORMANCE) >>= nConformance;
	
	if (nConformance & ::stardata::DatabaseSQLConformance::CORE)
	{
		String aPColumns;
		for (USHORT i = 1; i < aColumns->Count(); i++)
		{
			if (aColumns->Column(i)->IsPrimaryKey())
			{
				aPColumns += pConnection->IdentifierQuotation(aColumns->Column(i)->GetName());
				aPColumns += ',';
			}
		}
		if (aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');
			aCommand.AppendAscii(" PRIMARY KEY (");
			aCommand += aPColumns;
			aCommand += ',';
		}
	}
	// Ein Komma ist sicherlich noch zuviel ...
	aCommand.SetChar(aCommand.Len() - 1,')');

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();
	if (aStatus.IsSuccessful())
	{
		nPrivileges = SDB_PR_READ | SDB_PR_INSERT | SDB_PR_UPDATE | SDB_PR_DELETE | SDB_PR_DROP;

		sal_Int16 nInfo;
		rMetaData->getInfo(::stardata::DatabaseInfo::TABLE_DEFINITION) >>= nInfo;

		if ((nInfo & ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN) ||
			(nInfo & ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN))
			nPrivileges |= SDB_PR_ALTER | SDB_PR_REFERENCES;
	}
	return aStatus.IsSuccessful();	
}

//-----------------------------------------------------------------------------
BOOL SdbADOTable::GenerateAddCommands(String& rStatement, BOOL bNotNullAllowed)
{
	DBG_CHKTHIS(SdbADOTable,NULL);
	// Welche neuen Columns gibt es jetzt?
	// (Erkennbar an "fehlender" Identitaet (Id == 0))
	for (int i = 1; i < aColumns->Count(); i++)
	{
		const SdbColumn * pColumn = (*aColumns)[i];
		if (!GenerateColumnCommand(rStatement, *pColumn, bNotNullAllowed))
			return FALSE;

		rStatement += ',';
	}
	return TRUE;
}
//------------------------------------------------------------------------
SdbADOTable::~SdbADOTable()
{
	DBG_DTOR(SdbADOTable,NULL);

}

//------------------------------------------------------------------------
void SdbADOTable::CloseImpl()
{
}
//------------------------------------------------------------------------
BOOL SdbADOTable::RenameImpl(const String& rNewName)
{
	DBG_CHKTHIS(SdbADOTable,NULL);
	// eine Warnung, dass wir Umbenennen nur durch Kopieren erreichen koennen
	SdbUiActionDescription aAsk;
	aAsk.eType = SdbUiActionDescription::YES_NO;
	aAsk.sMessage = String(SdbResId(RID_STR_WARNING_RENAME));
	SdbUiActionDescription::RETURN eResult = DoUiAction(aAsk);
	if ((eResult != SdbUiActionDescription::RETURN_YES) && (eResult != SdbUiActionDescription::RETURN_OK))
	{
		aStatus.Set(SDB_STAT_CANCELED);
		return FALSE;
	}

	
	SdbConnection* pConnection = GetConnection();

	String aOldName(aName);
	aName = rNewName;

	// Neue Tabelle unter neuen Namen anlegen
	if (!CreateImpl())
	{
		aName = aOldName;
		return FALSE;
	}

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(pConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	String aQualified;

	if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		aQualified += pConnection->IdentifierQuotation(aQualifierName);
		aQualified += pConnection->GetQualifierSeparator();
	}

	if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		aQualified += pConnection->IdentifierQuotation(aOwnerName);
		aQualified += '.';
	}

	// Daten in die neue Tabelle kopieren
	String aStatement;
	aStatement.AssignAscii("INSERT INTO ");
	aStatement += aQualified;
	aStatement += pConnection->IdentifierQuotation(rNewName);
	aStatement.AppendAscii(" SELECT * FROM ");
	aStatement += aQualified;
	aStatement += pConnection->IdentifierQuotation(aOldName);

	if (!pConnection->ExecuteSQL(aStatement)) // bei Mierfolg alten Zustand wiederherstellen
	{
		SdbStatus aExecuteStatus = pConnection->Status();
		DropImpl();
		aStatus = aExecuteStatus;
		aName = aOldName;
		return FALSE;
	}

	// Alte Tabelle wegwerfen
	aName = aOldName;

	return DropImpl();
}
//------------------------------------------------------------------------
void SdbADOTable::FillIndexNames(SvStringsDtor& _rList)
{
	DBG_CHKTHIS(SdbADOTable,NULL);
	SdbADOConnection *pConnection = (SdbADOConnection *)GetConnection();
	WpADOConnection* pADOConnection = pConnection->GetADOConnection();
	BOOL bCase = (pConnection->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
		// Einlesen aller Indices
	SAFEARRAY *pSafeArray = SafeArrayCreateVector(VT_BSTR,0,5);
	if(!pSafeArray)
		return;

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(pConnection->GetMetaData());
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;

	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	INT32 ix[1];
	HRESULT hr = S_OK;
	if (aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		ix[0] = 0;
		hr = SafeArrayPutElement(pSafeArray,ix,(void*)aQualifierName.GetBuffer());
	}
	if (aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		ix[0] = 1;
		hr = SafeArrayPutElement(pSafeArray,ix,(void*)aOwnerName.GetBuffer());
	}
	ix[0] = 4;
	hr = SafeArrayPutElement(pSafeArray,ix,(void*)aName.GetBuffer());
	
	OLEVariant aTableRes,aTmp;
	aTmp.SetNoArg();
	aTableRes.SetArray(pSafeArray,VT_BSTR);

	ADORecordset*  pRecordset = NULL;
	pADOConnection->OpenSchema(adSchemaIndexes,aTableRes,aTmp,&pRecordset);
	//SafeArrayDestroy(pSafeArray);
	if(!pRecordset)
		return;

	String aIndexName;
	USHORT i (0);
	WpADORecordset aRecordset(pRecordset);
	while(!aRecordset.IsAtEOF())
	{
		ADOFields  *pFields = aRecordset.GetFields(); 
		pFields->AddRef();
		ADOField* pField = NULL;
		WpADOField aField;
		OLEVariant aVar;
		String aNewIndexName,aName;

		ADO_GETFIELD_BOOL(String::CreateFromAscii("INDEX_NAME"));
		aName = (String)aVar;
		ADO_GETFIELD_BOOL(String::CreateFromAscii("TYPE"));
		if(aVar.GetInt32() == 0 || aName == aPKeyName)
		{
			pFields->Release();
			aRecordset.MoveNext();
			continue;
		}
		ADO_GETFIELD_BOOL(String::CreateFromAscii("INDEX_CATALOG"));
		if(!aVar.IsNull())
		{
			(aNewIndexName = (String)aVar) += '.';
		}
		aNewIndexName += aName;
		BOOL bNewIndex = (bCase) ? aIndexName != aNewIndexName
								 : !aIndexName.EqualsIgnoreCaseAscii(aNewIndexName);
		if (bNewIndex)
		{
			aIndexName = aNewIndexName;
			_rList.Insert(new String(aIndexName), i++);
		}
		pFields->Release();
		aRecordset.MoveNext();
	}
	aRecordset.Close();
}


//------------------------------------------------------------------------
SdbIndex* SdbADOTable::CreateIndexImpl()
{
	return NULL;//new SdbADOIndex(this);
}







