/*************************************************************************
 *
 *  $RCSfile: odbcconf.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:17:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// odbcinc.hxx ganz am Anfang!
#ifndef _SDB_ODBCINC_HXX
#include "odbc2inc.hxx"
#endif

#include "sdbenv.hxx"
#include "odbcconn.hxx"
#include "odbcconf.hxx"
#include <odbcinst.h>

void* SdbODBCConfig::pInstanceHandle=NULL;

BYTE  aBuffer[512];

#if defined(WIN) || defined(WNT)
typedef BOOL (INSTAPI  *TSQLConfigDataSource) (HWND       hwndParent,
											   WORD       fRequest,
											   LPCSTR     lpszDriver,
											   LPCSTR     lpszAttributes);

typedef BOOL (INSTAPI  *TSQLManageDataSource) (HWND       hwndParent);

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#include <windows.h>
#endif

TSQLConfigDataSource pSQLConfigDataSource;
TSQLManageDataSource pSQLManageDataSource;

#define NSQLConfigDataSource(a,b,c,d) (*pSQLConfigDataSource)(a,b,c,d)
#define NSQLManageDataSource(a) (*pSQLManageDataSource)(a)

DBG_NAME(SdbODBCConfig);
//------------------------------------------------------------------------------
SdbODBCConfig::SdbODBCConfig()
{
	DBG_ASSERT(pInstanceHandle == NULL, "Configklasse mehrfachverwendet");

#ifdef WIN
	UINT nOldErrorMode(SetErrorMode(SEM_FAILCRITICALERRORS|SEM_NOOPENFILEERRORBOX));
	HINSTANCE hLib = LoadLibrary("ODBCINST.DLL");
	SetErrorMode(nOldErrorMode);
	if (hLib <= HINSTANCE_ERROR) return;
	pInstanceHandle = (void*) hLib;
#endif
#ifdef WNT
	UINT nOldErrorMode(SetErrorMode(SEM_FAILCRITICALERRORS|SEM_NOOPENFILEERRORBOX));
	HINSTANCE hLib = LoadLibrary("ODBCCP32.DLL");
	SetErrorMode(nOldErrorMode);
	if (hLib == NULL) return;
	pInstanceHandle = (void*) hLib;
#endif

	if (pInstanceHandle)
	{
#if defined(WIN) || defined(WNT)
	pSQLConfigDataSource = (TSQLConfigDataSource)GetProcAddress(HINSTANCE(pInstanceHandle),"SQLConfigDataSource");
	pSQLManageDataSource = (TSQLManageDataSource)GetProcAddress(HINSTANCE(pInstanceHandle),"SQLManageDataSources");
#endif
	}
	DBG_CTOR(SdbODBCConfig,NULL);
}

//------------------------------------------------------------------------------
SdbODBCConfig::~SdbODBCConfig()
{
	if (!pInstanceHandle)
		return;

#ifdef WIN
	FreeLibrary(HINSTANCE(pInstanceHandle));
#endif
#ifdef WNT
	FreeLibrary(HINSTANCE(pInstanceHandle));
#endif

	pInstanceHandle = NULL;
	DBG_DTOR(SdbODBCConfig,NULL);
}

//------------------------------------------------------------------------------
BOOL SdbODBCConfig::IsLoaded() const
{
	return pInstanceHandle != NULL;
}

//------------------------------------------------------------------------------
BOOL SdbODBCConfig::ManageDataSource(const Window& rParent) const
{
	DBG_ASSERT(IsLoaded(), "Configklasse nicht initialisiert");
	((SdbODBCConfig*)this)->aStatus.Clear();

#if defined(WIN) || defined(WNT)
	if (Application::IsRemoteServer() || !pSQLManageDataSource || !NSQLManageDataSource(GetActiveWindow()))
		((SdbODBCConfig*)this)->aStatus.SetDriverNotCapableError();
#else
	((SdbODBCConfig*)this)->aStatus.SetDriverNotCapableError();
#endif

	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SdbODBCConfig::AddDataSource(const ByteString& rDriver, const ByteString& rAttributes) const
{
	DBG_ASSERT(IsLoaded(), "Configklasse nicht initialisiert");
	((SdbODBCConfig*)this)->aStatus.Clear();

	// Microsoft wie wir es kennen: klare Schnittstellen
	// Die einzelenen Einstellungen werden mit '\0' separiert
	// und der der letzte Eintrag wird mit '\0' '\0' abgeschlossen
	// Warum einfach wenn es auch schwer geht
	UCHAR* pBuffer = aBuffer;
	xub_StrLen nIndex(0);
	ByteString aToken(rAttributes.GetToken(0,';', nIndex));
	memcpy(pBuffer, aToken.GetBuffer(), aToken.Len() + 1);
	pBuffer += (UCHAR)(aToken.Len()) + 1;

	for (aToken = rAttributes.GetToken(0,';',nIndex);
		 aToken.Len();
		 aToken = rAttributes.GetToken(0,';',nIndex))
	{
		memcpy(pBuffer, aToken.GetBuffer(), aToken.Len() + 1);
		pBuffer += (UCHAR)(aToken.Len() + 1);
	}
	pBuffer = 0;

	if (!NSQLConfigDataSource(NULL, ODBC_ADD_DSN,
									  (LPCSTR) (const char *) rDriver.GetBuffer(),
									  (LPCSTR) aBuffer))
		((SdbODBCConfig*)this)->aStatus.Set(SDB_STAT_ERROR);

	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SdbODBCConfig::RemoveDataSource(const ByteString& rDriver, const ByteString& rAttributes) const
{
	DBG_ASSERT(IsLoaded(), "Configklasse nicht initialisiert");
	((SdbODBCConfig*)this)->aStatus.Clear();
	if (!NSQLConfigDataSource(NULL, ODBC_REMOVE_DSN,
									  (LPCSTR) (const char *) rDriver.GetBuffer(),
									  (LPCSTR) (const char *) rAttributes.GetBuffer()))
		((SdbODBCConfig*)this)->aStatus.Set(SDB_STAT_ERROR);
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SdbODBCConfig::ModifyDataSource(const ByteString& rDriver, const ByteString& rAttributes) const
{
	DBG_ASSERT(IsLoaded(), "Configklasse nicht initialisiert");
	((SdbODBCConfig*)this)->aStatus.Clear();

	UCHAR* pBuffer = aBuffer;
	xub_StrLen nIndex(0);
	ByteString aToken(rAttributes.GetToken(0,';', nIndex));
	memcpy(pBuffer, aToken.GetBuffer(), aToken.Len() + 1);
	pBuffer += (UCHAR)(aToken.Len() + 1);

	for (aToken = rAttributes.GetToken(0,';',nIndex);
		 aToken.Len();
		 aToken = rAttributes.GetToken(0,';',nIndex))
	{
		memcpy(pBuffer, aToken.GetBuffer(), aToken.Len() + 1);
		pBuffer += (UCHAR)(aToken.Len() + 1);
	}
	pBuffer = 0;

	if (!NSQLConfigDataSource(NULL, ODBC_CONFIG_DSN,
									  (LPCSTR) (const char *) rDriver.GetBuffer(),
									  (LPCSTR) aBuffer))
		((SdbODBCConfig*)this)->aStatus.Set(SDB_STAT_ERROR);
	return aStatus.IsSuccessful();
}


