/*************************************************************************
 *
 *  $RCSfile: sdbdll.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:17:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef _DLL_

#if defined(WIN) || defined(WNT)
// Anziehen von Windows.h
#include <tools/prewin.h>
#include <windows.h>
#include <tools/postwin.h>
#endif


#include "sdbenv.hxx"

// Deklarationen von globalen Funktionen, die angezogene
// DLLs wieder freigeben.
BOOL FreeLibrary_ODBC();
BOOL FreeLibrary_ODBC3();

//-----------------------------------------------------------
#if defined(WIN) || defined(WNT)
void SetInstance(void * hInstance)
{
	SdbEnvironment::aInstanceHandle = hInstance;
}
#endif

#ifdef WIN
extern "C" int CALLBACK LibMain( HINSTANCE hDLL, WORD, WORD nHeap, LPSTR )
{
	SetInstance((void*)hDLL);
	return TRUE;
}

extern "C"
{
int CALLBACK WEP(int nExitType)
{
#ifdef ODBCIMP
	// ODBC-DLL wieder freigeben:
	FreeLibrary_ODBC();
	FreeLibrary_ODBC3();
#endif

	return 1;
}
}
#endif

//-----------------------------------------------------------

#ifdef WNT
extern "C" {
BOOL WINAPI DllMain(
	HINSTANCE  hinstDLL,	// handle of DLL module
	DWORD  fdwReason,	// reason for calling function
	LPVOID  lpvReserved 	// reserved
   )
{
#ifdef DLLMAIN_DEBUG
MessageBox(NULL,"In DllMain","Debug",MB_OK);
#endif

	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		SetInstance((void*)hinstDLL);
	}
	else if (fdwReason == DLL_PROCESS_DETACH)
	{
#ifdef ODBCIMP

#ifdef DLLMAIN_DEBUG
MessageBox(NULL,"DllMain before FreeLibrary_ODBC","Debug",MB_OK);
#endif

		// ODBC-DLL wieder freigeben:
		FreeLibrary_ODBC();
		FreeLibrary_ODBC3();
#endif
	}

	return 1;
}
}
#endif

//-----------------------------------------------------------

#ifdef OS2
// nyi
#endif

//-----------------------------------------------------------

#ifdef MAC
// nyi
#endif

//-----------------------------------------------------------

#ifdef UNX
// nyi
#endif

//-----------------------------------------------------------

#endif

