/*************************************************************************
 *
 *  $RCSfile: sdbenv.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:17:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TOOLS_SIMPLERESMGR_HXX_
#include <tools/simplerm.hxx>
#endif

#include "sdbenv.hxx"

#include <com/sun/star/lang/XMultiServiceFactory.hpp>

// ODBC ganz am Anfang (wegen der "svwin"-Include-Problematik)
#if defined( SOLARIS ) || defined(WIN) || defined(WNT) || ( defined(OS2) && (defined(ODBCIMP) || defined(SDB_OS2_ODBC)) ) || defined ( MAC ) || defined ( LINUX )
#include "odbc3conn.hxx"
#include "odbc2conn.hxx"
BOOL LoadLibrary_ODBC3(SdbEnvironment*,String &_rPath);
#endif

#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
#include "adaconn.hxx"
#endif

#if defined(WNT)
#ifndef SDB_ADOCONN_HXX
#include "adoconn.hxx"
#endif // SDB_ADOCONN_HXX

#endif //WNT


#ifndef _SDB_JDBCCONN_HXX
#include <jdbcconn.hxx>
#endif

#if WNT
#ifndef _SDB_OTERCONN_HXX
#include <oterconn.hxx>
#endif
#endif

#if defined(MAC)
#include "Fmconn.hxx"
#endif

#include "dbfconn.hxx"
#include "flatconn.hxx"

#ifndef _SDB_SDBDB_HXX
#include "sdbdb.hxx"
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#ifndef _SDB_SDBWORK_HXX
#include "sdbwork.hxx"
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _RC_HXX //autogen
#include <vcl/rc.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif

#include <typeconv.hxx>
#include "sdbresid.hrc"

#ifndef _COM_SUN_STAR_UCB_XPROGRESSHANDLER_HPP_
#include <com/sun/star/ucb/XProgressHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_SCRIPT_XTYPECONVERTER_HPP_
#include <com/sun/star/script/XTypeConverter.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#define SDB_DATABASE_MARK "explorer/database/"

// list of all dynamic loaded libraries
vector<oslModule>	aLibraryList;

namespace staruno = com::sun::star::uno;
namespace stardata = com::sun::star::data;


DBG_NAME(SdbEnvironment);

TYPEINIT1(SdbEnvironment, SdbObj);

//------------------------------------------------------------------------------
SdbEnvironmentRef::SdbEnvironmentRef()
{
	SdbEnvironment** ppGlobal = (SdbEnvironment **) GetAppData(SHL_SDB);
	if (*ppGlobal == NULL)
		pObj = new SdbEnvironment();
	else
		pObj = *ppGlobal;

	if (pObj)
		pObj->AddRef();
}

//------------------------------------------------------------------------------
SdbConnection* SdbEnvironment::OpenConnection(const SdbConnection& rConn)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	String aOptions = rConn.Options();
	// Optionen parsen (nur um den TYP auszuwerten):
	CommandParser aOptionsParser(aOptions,';','=',TRUE);
	SdbConnection* pConnection = NULL;

	// Konstruktor der Connection des jeweiligen Treibers (je nach TYP) aufrufen:
	String aTyp(aOptionsParser.OptionString(String::CreateFromAscii("TYP")));

//	ODBC
	if (aTyp.EqualsIgnoreCaseAscii("ODBC"))
#if defined( SOLARIS ) || defined(WIN) || defined(WNT) || ( defined(OS2) && (defined(ODBCIMP) || defined(SDB_OS2_ODBC)) ) || defined ( MAC ) || defined(LINUX)
	{
		String aPath;
		if(LoadLibrary_ODBC3(this,aPath))
		{
			pConnection = new SdbODBC3Connection((const SdbODBC3Connection&) rConn);
			if(!((SdbODBC3Connection*)pConnection)->IsValid())
			{
				delete pConnection;
				pConnection = new SdbODBC2Connection((const SdbODBC2Connection&) rConn);
			}
		}
		else
			pConnection = new SdbODBC2Connection((const SdbODBC2Connection&) rConn);
	}
#else
		aStatus.SetDriverNotCapableError();
#endif
// ADO
	else if (aTyp.EqualsIgnoreCaseAscii("ADO"))
#ifdef WNT
		pConnection = new SdbADOConnection((const SdbADOConnection&) rConn);
#else
		aStatus.SetDriverNotCapableError();
#endif //WNT

//StarBase
	else if (aTyp.EqualsIgnoreCaseAscii("StarBase"))
#ifdef WNT
		pConnection = new SdbOTERConnection((const SdbOTERConnection&) rConn);
#else
		aStatus.SetDriverNotCapableError();
#endif //WNT
	else if (aTyp.EqualsIgnoreCaseAscii("ADABAS"))
#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
		pConnection = new SdbAdaConnection((const SdbAdaConnection&) rConn);
#else
		aStatus.SetDriverNotCapableError();
#endif //WNT
	else if (aTyp.EqualsIgnoreCaseAscii("JDBC"))
		pConnection = new SdbJDBCConnection((const SdbJDBCConnection&) rConn);
	else
		pConnection = OpenConnection(aOptions);

	if (pConnection)
	{
		if (pConnection->Status().IsError())
		{
			aStatus = pConnection->Status();
			pConnection->RemoveFromParent();
			pConnection = NULL;
		}
		else if (!pConnection->Open())
		{
			SdbODBC3Connection* pODBC3Conn = PTR_CAST(SdbODBC3Connection,pConnection);
			if(pODBC3Conn && !pODBC3Conn->IsValid())
			{
				pConnection->RemoveFromParent();
				pConnection = NULL;
				pConnection = new SdbODBC2Connection(this,aOptions);
				if (!pConnection->Status().IsError() && pConnection->Open())
				{
					m_aConnectionList.push_back(pConnection);
					return pConnection;
				}
			}
			aStatus = pConnection->Status();
			pConnection->RemoveFromParent();
			pConnection = NULL;
		}
		else
			m_aConnectionList.push_back(pConnection);
	}
	return pConnection;

}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::IsFileServer(const String& rServerType)
{
	if (rServerType.EqualsIgnoreCaseAscii("DBF") ||
		rServerType.EqualsIgnoreCaseAscii("TXT") ||
		rServerType.EqualsIgnoreCaseAscii("StarBase") )
		return TRUE;
	else
		return FALSE;
}

//------------------------------------------------------------------------------
SdbConnection* SdbEnvironment::CreateConnection(const String& rNewOptions)
{
	aStatus.Clear();
	String aOptions(rNewOptions);

	// Optionen parsen (nur um den TYP auszuwerten):
	CommandParser aOptionsParser(aOptions,';','=',TRUE);

	// Konstruktor der Connection des jeweiligen Treibers (je nach TYP) aufrufen:
	String aTyp(aOptionsParser.OptionString(String::CreateFromAscii("TYP")));
	SdbConnection* pConnection = NULL;

	if (aTyp.EqualsIgnoreCaseAscii("DBF")) pConnection = new SdbDBFConnection(this, aOptions);
	else if (aTyp.EqualsIgnoreCaseAscii("TXT")) pConnection = new SdbFLATConnection(this, aOptions);

#if defined( SOLARIS ) || defined(WIN) || defined(WNT) || ( defined(OS2) && (defined(ODBCIMP) || defined(SDB_OS2_ODBC)) ) || defined ( MAC ) || defined(LINUX)
	else if (aTyp.EqualsIgnoreCaseAscii("ODBC"))
	{
		String aPath;
		if(LoadLibrary_ODBC3(this,aPath))
		{
			pConnection = new SdbODBC3Connection(this, aOptions);
			if(!((SdbODBC3Connection*)pConnection)->IsValid())
			{
				delete pConnection;
				pConnection = new SdbODBC2Connection(this,aOptions);
			}
		}
		else
			pConnection = new SdbODBC2Connection(this, aOptions);
	}
#endif

	else if (aTyp.EqualsIgnoreCaseAscii("JDBC")) pConnection = new SdbJDBCConnection(this, aOptions);

#ifdef WNT
	else if (aTyp.EqualsIgnoreCaseAscii("StarBase")) pConnection = new SdbOTERConnection(this, aOptions);
#endif
#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
	else if (aTyp.EqualsIgnoreCaseAscii("ADABAS")) pConnection = new SdbAdaConnection(this, aOptions);
#endif
#ifdef WNT
	else if (aTyp.EqualsIgnoreCaseAscii("ADO"))
		pConnection = new SdbADOConnection(this, aOptions);
#endif //WNT


#if defined(MAC)
	else if (aTyp.EqualsIgnoreCaseAscii("FMK")) pConnection = new SdbFmConnection(this, aOptions);
#endif
	else
	{
		String strMainMessage = String(SdbResId(STR_STAT_UNKNOWN_DBVERSION));
		String strDetailedMessage = String(SdbResId(STR_STAT_UNKNOWN_DBVERSION_DETAILED));
		aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("S1000"), aStatus.CreateErrorMessage(strMainMessage), 0, strDetailedMessage);
	}

	return pConnection;
}


//------------------------------------------------------------------------------
SdbConnection* SdbEnvironment::OpenConnection(const String& rNewOptions)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	SdbConnection* pConnection = CreateConnection(rNewOptions);
	if (pConnection)
	{
		if (pConnection->Status().IsError())
		{
			aStatus = pConnection->Status();
			pConnection->RemoveFromParent();
			pConnection = NULL;
		}
		else if (!pConnection->Open())
		{
			SdbODBC3Connection* pODBC3Conn = PTR_CAST(SdbODBC3Connection,pConnection);
			if(pODBC3Conn && !pODBC3Conn->IsValid())
			{
				pConnection->RemoveFromParent();
				pConnection = NULL;
				pConnection = new SdbODBC2Connection(this,rNewOptions);
				if (!pConnection->Status().IsError() && pConnection->Open())
				{
					m_aConnectionList.push_back(pConnection);
					return pConnection;
				}
			}

			aStatus = pConnection->Status();
			pConnection->RemoveFromParent();
			pConnection = NULL;
		}
		else
			m_aConnectionList.push_back(pConnection);
	}
	return pConnection;
}

//------------------------------------------------------------------------------
	// Liste der verfuegbaren Server-Typen (als String mit Semikolon getrennt,
	// z. B. "ODBC;TXT;DBF") [Parameter "TYP=..." bei CreateConnection].
String SdbEnvironment::ServerTypes() const
{
	((SdbEnvironment*) this)->aStatus.Clear();
	String aString;

	aString.AppendAscii("DBF;");
	aString.AppendAscii("TXT;");

#if defined( SOLARIS ) || defined(WIN) || defined(WNT) || ( defined(OS2) && (defined(ODBCIMP) || defined(SDB_OS2_ODBC)) ) || defined ( MAC ) || defined(LINUX)
	aString.AppendAscii("ODBC;");
#endif

#ifdef WNT
	aString.AppendAscii("StarBase;");
	aString.AppendAscii("ADO;");
#endif //WNT
#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
	aString.AppendAscii("ADABAS;");
#endif

#ifdef MAC
	aString.AppendAscii("FMK;");		// Filemaker
#endif

	aString.AppendAscii("JDBC;");
	aString.EraseTrailingChars(';');
	return aString;
}

//------------------------------------------------------------------------------
String SdbEnvironment::ServerNames(const String& aTyp)
{
	aStatus.Clear();

	if (aTyp.EqualsIgnoreCaseAscii("DBF")) return SdbDBFConnection::ServerNames(aStatus, this);
	if (aTyp.EqualsIgnoreCaseAscii("TXT")) return SdbFLATConnection::ServerNames(aStatus, this);

#if defined( SOLARIS ) || defined(WIN) || defined(WNT) || ( defined(OS2) && (defined(ODBCIMP) || defined(SDB_OS2_ODBC)) ) || defined ( MAC ) || defined(LINUX)
	if (aTyp.EqualsIgnoreCaseAscii("ODBC"))
	{
		String aPath;
		if(LoadLibrary_ODBC3(this,aPath))
			return SdbODBC3Connection::ServerNames(aStatus, this);
		else
			return SdbODBC2Connection::ServerNames(aStatus, this);
	}
#endif

#if defined(MAC)
	if (aTyp.EqualsIgnoreCaseAscii("FMK")) return SdbFmConnection::ServerNames(aStatus,this);
#endif

	if (aTyp.EqualsIgnoreCaseAscii("JDBC")) return SdbJDBCConnection::ServerNames(aStatus, this);

#if WNT
	if (aTyp.EqualsIgnoreCaseAscii("StarBase")) return String::CreateFromAscii("*.rb1");
	if (aTyp.EqualsIgnoreCaseAscii("ADO")) return String();
#endif //WNT
#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
	if (aTyp.EqualsIgnoreCaseAscii("ADABAS")) return SdbAdaConnection::ServerNames(aStatus, this);
#endif

	// Sonst Fehler!
	DBG_ERROR("SdbConnection: unbekannter oder unimplementierter Server-Typ");
	return String(); // unbekannter oder unimplementierter Server-Typ
}

//------------------------------------------------------------------------------
SdbEnvironment::SdbEnvironment()
			   :SdbObj(NULL,FALSE)
			   ,aEnvironmentHandle(NULL)
			   ,aODBC3EnvironmentHandle(NULL)
			   ,aADAHandle(NULL)
#if WNT
			   ,pOterroHandle(NULL)
#endif //WNT
			   ,m_pSqlParser(NULL)
			   ,nTimeOut(20)
{
	// Eintragen in den AppDaten
	SdbEnvironment** ppGlobal = (SdbEnvironment **) GetAppData(SHL_SDB);
	*ppGlobal = this;

	LanguageType nType = GetpApp()->GetAppInternational().GetLanguage();
	ByteString aMgrName;
	aMgrName += "sdb";
	aMgrName += ByteString::CreateFromInt32( SUPD );
	pResMgr = SimpleResMgr::Create(aMgrName.GetBuffer(), nType);

	pStandardFormatter = new SvNumberFormatter(nType);
	m_pSqlParser	   = new SdbSqlParser(nType);
	bOpen = TRUE;	// benoetigt kein Open

	pDefaultWorkspace = CreateWorkspace(String::CreateFromAscii(DEFAULT_WORKSPACENAME));	// fester Name
	pDefaultWorkspace->AddRef();
	AppendWorkspace(pDefaultWorkspace);
#if defined(WNT)
	pOterroHandle = new SdbOTERHandleRef();
#endif
	::staruno::Reference< ::com::sun::star::lang::XMultiServiceFactory> xFac = utl::getProcessServiceFactory();

	::com::sun::star::lang::XMultiServiceFactory* pInt = (::com::sun::star::lang::XMultiServiceFactory*)xFac.get();

	::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > xInt = pInt->createInstance( ::rtl::OUString::createFromAscii("com.sun.star.script.Converter"));
	::staruno::Reference< com::sun::star::script::XTypeConverter > xType(xInt, ::staruno::UNO_QUERY);
	ODbTypeConversion::xTypeConverter = xType;
//		::staruno::Reference< com::sun::star::script::XTypeConverter >(utl::getProcessServiceFactory()
//			->createInstance(rtl::OUString::createFromAscii("com.sun.star.script.Converter")), ::staruno::UNO_QUERY);

	DBG_CTOR(SdbEnvironment,NULL);
}

//------------------------------------------------------------------------------
SdbEnvironment::~SdbEnvironment()
{
	// default muss explizit entfernt werden
	RemoveWorkspace(pDefaultWorkspace);
	RemoveChildren();
	pDefaultWorkspace->ReleaseRef();

	ODbTypeConversion::xTypeConverter = NULL;

	delete pResMgr;
	delete m_pSqlParser;
	delete pStandardFormatter;
	if(aEnvironmentHandle)
		SdbODBC2Connection::FreeEnv(this);
	if(aODBC3EnvironmentHandle)
		SdbODBC3Connection::FreeEnv(this);
#if defined(WNT)
	delete pOterroHandle;
#endif
#if ( defined(SOLARIS) && defined(SPARC)) || defined(WIN) || defined(WNT) || defined(LINUX)
	if (aADAHandle)
		SdbAdaConnection::FreeEnv(this);
#endif

	// free alll libraries
	for (vector<oslModule>::iterator i = aLibraryList.begin(); i != aLibraryList.end(); i++)
		osl_unloadModule(*i);

	*GetAppData(SHL_SDB) = NULL;
	DBG_DTOR(SdbEnvironment,NULL);
}

//------------------------------------------------------------------
String SdbEnvironment::GetWorkspaceName(USHORT _nPos)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	String aName;
	SdbWorkspace* pWS = m_aWspList[_nPos];
	if (pWS)
		aName = pWS->GetName();
	return aName;
}

//------------------------------------------------------------------
USHORT SdbEnvironment::GetWorkspaceCount()
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	return (USHORT)m_aWspList.size();
}

//------------------------------------------------------------------
SdbWorkspace* SdbEnvironment::CreateWorkspace(const String& _rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	SDB_CHK_OPEN_NULL();

	SdbWorkspace* pWorkspace = new SdbWorkspace(this, _rName);

	// zunaechst nur temp Workspace
	m_aTempWspList.push_back(pWorkspace);
	return pWorkspace;
}

//------------------------------------------------------------------
BOOL SdbEnvironment::AppendWorkspace(SdbWorkspace* pWsp)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	SDB_CHK_OPEN_NULL();

	::std::map< ::rtl::OUString, SdbWorkspace*, ::utl::UStringLess>::const_iterator i = m_aWspMap.find(pWsp->GetName());
	if (i != m_aWspMap.end())
	{
		aStatus.SetError(ERRCODE_IO_ALREADYEXISTS,dbWorkspace,pWsp->GetName());
		return FALSE;
	}
	else
	{
		// aus der templist entfernen
		vector<SdbWorkspace*>::iterator i = find(m_aTempWspList.begin(), m_aTempWspList.end(), pWsp);
		if (i != m_aTempWspList.end())
			m_aTempWspList.erase(i);

		m_aWspList.push_back(pWsp);
		m_aWspMap[pWsp->GetName()] = pWsp;
		pWsp->SetPersistent(TRUE);
		return TRUE;
	}
}

//------------------------------------------------------------------
SdbWorkspace* SdbEnvironment::RemoveWorkspace(SdbWorkspace* pWsp)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	SDB_CHK_OPEN_NULL();

	::std::map< ::rtl::OUString, SdbWorkspace*, ::utl::UStringLess>::iterator i = m_aWspMap.find(pWsp->GetName());
	if (i == m_aWspMap.end())
	{
		return NULL;
	}
	else
	{
		// aus Workliste entfernen
		m_aWspMap.erase(i);

		vector<SdbWorkspace*>::iterator j = find(m_aWspList.begin(), m_aWspList.end(), pWsp);
		if (j != m_aWspList.end())
			m_aWspList.erase(j);

		pWsp->SetPersistent(FALSE);		// Object ist nicht mehr Persistent

		// in die temp liste uebernehmen
		m_aTempWspList.push_back(pWsp);
		return pWsp;
	}
}

//------------------------------------------------------------------
SdbWorkspace* SdbEnvironment::OpenWorkspace(const String& _rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	SDB_CHK_OPEN_NULL();
	::std::map< ::rtl::OUString, SdbWorkspace*, ::utl::UStringLess>::const_iterator i = m_aWspMap.find(_rName);
	return i != m_aWspMap.end() ? (*i).second : NULL;
}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::CreateDatabase(const String& rName, const String& rTitle, const String& rConnectStr)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	// erzeugen einer Datenbank, diese wird nicht in der Liste aufgenommen
	// da sie nicht geoeffnet wird
	aStatus.Clear();
	if (!pDefaultWorkspace->CreateDatabase(rName, rTitle, rConnectStr))
		aStatus = pDefaultWorkspace->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::DropDatabase(const String& _rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	if (!pDefaultWorkspace->DropDatabase(_rName))
		aStatus = pDefaultWorkspace->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
SdbDatabase* SdbEnvironment::OpenDatabase(const String& _rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	SdbDatabase* pDB = pDefaultWorkspace->OpenDatabase(_rName);
	if (!pDB)
		aStatus = pDefaultWorkspace->Status();
	return pDB;
}

//------------------------------------------------------------------------------
SdbDatabase* SdbEnvironment::GetDatabaseNoOpen(const String& rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	return pDefaultWorkspace->GetDatabaseNoOpen(rName);
}

//------------------------------------------------------------------------------
SdbDatabase* SdbEnvironment::LoadDatabase(const String& _rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	// do we already have the opened (or laoded) database ?
	SdbDatabase* pReturn = pDefaultWorkspace->GetDatabaseNoOpen(_rName);
	if (!pReturn)
	{
		// no -> let the wsp load it
		pReturn = pDefaultWorkspace->LoadDatabase(_rName);
		if (!pReturn)
			aStatus = pDefaultWorkspace->Status();
	}
	return pReturn;
}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::AlterDatabase(const String& rName, const String& rConnectStr)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	if (!pDefaultWorkspace->AlterDatabase(rName, rConnectStr))
		aStatus = pDefaultWorkspace->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
String SdbEnvironment::GetDatabaseConnectStr(const String& rName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	return pDefaultWorkspace->GetDatabaseConnectStr(rName);
}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::AlterDatabaseName(const String& _rOldName, const String& _rNewName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	if (!pDefaultWorkspace->AlterDatabaseName(_rOldName, _rNewName))
		aStatus = pDefaultWorkspace->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
BOOL SdbEnvironment::AlterDatabaseTitle(const String& rName, const String& rTitle)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	aStatus.Clear();
	if (!pDefaultWorkspace->AlterDatabaseTitle(rName, rTitle))
		aStatus = pDefaultWorkspace->Status();
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------------------
void SdbEnvironment::RemoveChildren()
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	while (!m_aWspList.empty())
		RemoveChild(m_aWspList.front());
	while (!m_aTempWspList.empty())
		RemoveChild(m_aTempWspList.front());
	while (!m_aConnectionList.empty())
		RemoveChild(m_aConnectionList.front());
}

//------------------------------------------------------------------
void SdbEnvironment::RemoveChild(SdbObj* pObj)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);

	if (pObj->IsA(TYPE(SdbConnection)))
	{
		vector<SdbConnection*>::iterator i = find(m_aConnectionList.begin(), m_aConnectionList.end(), PTR_CAST(SdbConnection,pObj));
		if (i != m_aConnectionList.end())
			m_aConnectionList.erase(i);
	}
	else if (pObj->IsA(TYPE(SdbWorkspace)))
	{
		SdbWorkspace* pWsp = PTR_CAST(SdbWorkspace,pObj);

		::std::map< ::rtl::OUString, SdbWorkspace*, ::utl::UStringLess>::iterator j = m_aWspMap.find(pWsp->GetName());
		if (j != m_aWspMap.end())
			m_aWspMap.erase(j);

		vector<SdbWorkspace*>::iterator i = find(m_aWspList.begin(), m_aWspList.end(), pWsp);
		if (i != m_aWspList.end())
			m_aWspList.erase(i);

		i = find(m_aTempWspList.begin(), m_aTempWspList.end(), pWsp);
		if (i != m_aTempWspList.end())
			m_aTempWspList.erase(i);
	}
	else
		return;

	SdbObj::RemoveChild(pObj);
}

//------------------------------------------------------------------
BOOL SdbEnvironment::Open()
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	bOpen = TRUE;
	return TRUE;
}

//------------------------------------------------------------------
void SdbEnvironment::WorkspaceRenamed(SdbWorkspace* pWsp, const String& rOldName)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	::std::map< ::rtl::OUString, SdbWorkspace*, ::utl::UStringLess>::iterator j = m_aWspMap.find(rOldName);
	if (j != m_aWspMap.end())
		m_aWspMap.erase(j);
	m_aWspMap[pWsp->GetName()] = pWsp;
}

//------------------------------------------------------------------
void SdbEnvironment::AppendLibrary(oslModule pLib)
{
	NAMESPACE_VOS(OGuard) aGuard(m_aMutex);
	aLibraryList.push_back(pLib);
}

//------------------------------------------------------------------
void SdbEnvironment::SetProgressHandler(const ::com::sun::star::uno::Reference< com::sun::star::ucb::XProgressHandler >& _Prog)
{
	m_xProgressHandler = _Prog;
}

//------------------------------------------------------------------
const ::com::sun::star::uno::Reference< com::sun::star::ucb::XProgressHandler >&
		SdbEnvironment::GetProgressHandler() const { return m_xProgressHandler; }


