/*************************************************************************
 *
 *  $RCSfile: dbfmd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_FILECONN_HXX
#include "fileconn.hxx"
#endif // _SDB_FILECONN_HXX

#include <dbfmd.hxx>

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

//------------------------------------------------------------------
sal_Bool SdbDBFMetaData::isCapableImpl(sal_Int16 nCapability) const
{
	sal_Bool erg(sal_False);
	switch (nCapability)
	{
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
			erg = sal_False;
			break;
		default:
			erg = SdbFILEMetaData::isCapableImpl(nCapability);
	}
	return erg;
}

//------------------------------------------------------------------
::staruno::Any SdbDBFMetaData::getInfoImpl(sal_Int16 nInfo) const
{
	::staruno::Any erg;
	const String aFilePath(((SdbFILEConnection*)pCon)->DirectoryName());
	sal_Bool bIsReadOnly = FileStat::GetReadOnlyFlag( DirEntry(aFilePath) );
	switch(nInfo)
	{
		case ::stardata::DatabaseInfo::READ_ONLY:
			erg <<= bIsReadOnly;
			break;
		case ::stardata::DatabaseInfo::TABLE_DEFINITION:
			if (bIsReadOnly)
				erg <<= (sal_Int16)0;
			else
				erg <<= (sal_Int16)(::stardata::DatabaseTableDefinition::CREATE | 
									::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN | 
									::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN | 
									::stardata::DatabaseTableDefinition::DROP);
			break;
		case ::stardata::DatabaseInfo::INDEX_DEFINITION:
			if (bIsReadOnly)
				erg <<= (sal_Int16)0;
			else
				erg <<= (sal_Int16)(::stardata::DatabaseIndexDefinition::CREATE | 
									::stardata::DatabaseIndexDefinition::DROP);
			break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			erg <<= rtl::OUString::createFromAscii("DBF");
			break;
		default:
			erg = SdbFILEMetaData::getInfoImpl(nInfo);
	}
	return erg;
}

//------------------------------------------------------------------
sal_Int32 SdbDBFMetaData::getLimitImpl(sal_Int16 nLimit) const
{
	sal_Int32 erg(0);
	switch (nLimit)
	{
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			erg = 254;
			break;
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
			erg = 10;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			erg = 1;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			erg = 128;
			break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			erg = 118;
			break;
		default:
			erg = SdbFILEMetaData::getLimitImpl(nLimit);
	}
	return erg;
}



