/*************************************************************************
 *
 *  $RCSfile: filemd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_FILECONN_HXX
#include <fileconn.hxx>
#endif

#include <filemd.hxx>

#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

//------------------------------------------------------------------
sal_Bool SdbFILEMetaData::canConvertImpl(sal_Int16 nFrom, sal_Int16 nIn) const
{
	return sal_False;
}

//------------------------------------------------------------------
sal_Bool SdbFILEMetaData::isCapableImpl(sal_Int16 nCapability) const
{
	sal_Bool erg(sal_False);
	switch (nCapability)
	{
		case ::stardata::DatabaseCapability::TABLE_CORRELATION_NAME:
		case ::stardata::DatabaseCapability::EXPRESSION_ORDERBY:
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
		case ::stardata::DatabaseCapability::ORDERBY_UNRELATED:
			erg = sal_True;
			break;
	}
	return erg;
}

//------------------------------------------------------------------
::staruno::Any SdbFILEMetaData::getInfoImpl(sal_Int16 nInfo) const
{
	::staruno::Any erg;
	switch (nInfo)
	{
		case ::stardata::DatabaseInfo::CATALOG_AT_START:
			erg <<= sal_False;
			break;
		case ::stardata::DatabaseInfo::READ_ONLY:
		case ::stardata::DatabaseInfo::NULLPLUSNONNULLISNULL:
			erg <<= sal_True;
			break;
		case ::stardata::DatabaseInfo::IDENT_CASE:
		case ::stardata::DatabaseInfo::IDENT_CASE_QUOTED:
			erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			break;
		case ::stardata::DatabaseInfo::NULLS_SORT:
			erg <<= (sal_Int16)::stardata::DatabaseNullsSort::AT_START;
			break;
		case ::stardata::DatabaseInfo::SUPPORTED_ISOLATION_LEVELS:
			erg <<= (sal_Int16)::stardata::DatabaseIsolationLevel::NONE;
			break;
		case ::stardata::DatabaseInfo::DSN_URL:
		{
			INetURLObject aUrl;
			aUrl.SetSmartProtocol(INET_PROT_FILE);
			aUrl.SetURL(((SdbFILEConnection*)pCon)->DirectoryName());
			erg <<= rtl::OUString(aUrl.GetMainURL());
		}	break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			erg <<= rtl::OUString::createFromAscii("TXT");
			break;
		case ::stardata::DatabaseInfo::DBMS_VERSION:
		case ::stardata::DatabaseInfo::DRIVER_VERSION:
		case ::stardata::DatabaseInfo::DBMS_NAME:
		case ::stardata::DatabaseInfo::PROC_TERM:
		case ::stardata::DatabaseInfo::CATALOG_TERM:
		case ::stardata::DatabaseInfo::SCHEMA_TERM:
		case ::stardata::DatabaseInfo::TABLE_TERM:
		case ::stardata::DatabaseInfo::SQL_KEYWORDS:
		case ::stardata::DatabaseInfo::CATALOG_SEPARATOR:
		case ::stardata::DatabaseInfo::SEARCH_PATTERN_ESCAPE:
		case ::stardata::DatabaseInfo::SPECIAL_CHARACTERS:
		case ::stardata::DatabaseInfo::STRING_FUNCTIONS:
		case ::stardata::DatabaseInfo::SYSTEM_FUNCTIONS:
		case ::stardata::DatabaseInfo::NUMERIC_FUNCTIONS:
			erg <<= rtl::OUString();
			break;
		case ::stardata::DatabaseInfo::IDENTIFIER_QUOTE_CHAR:
			erg <<= rtl::OUString::createFromAscii("\"");
			break;
		case ::stardata::DatabaseInfo::SQL_CONFORMANCE:
			erg <<= (sal_Int16)::stardata::DatabaseSQLConformance::MINIMUM;
			break;
		default:
			erg <<= (sal_Int16)0;


	}
	return erg;
}

//------------------------------------------------------------------
sal_Int32 SdbFILEMetaData::getLimitImpl(sal_Int16 nLimit) const
{
	sal_Int32 erg(0);
	switch(nLimit)
	{
		case ::stardata::DatabaseLimit::BINARAY_LITERAL_LEN:
			break;
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			erg = STRING_MAXLEN;
			break;
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
			erg = 0;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_GROUPBY:
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			erg = 0;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_ORDERBY:
			erg = 10;
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_SELECT:
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			erg = 0;
			break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			erg = 0;
			break;
		case ::stardata::DatabaseLimit::CATALOG_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::SCHEMA_NAME_LEN:
			break;
		case ::stardata::DatabaseLimit::STATEMENT_LEN:
			break;
		case ::stardata::DatabaseLimit::TABLE_NAME_LEN:
			if (!((SdbFILEConnection*)pCon)->bNoFileNameLimit)
				erg = 8;
			break;
		case ::stardata::DatabaseLimit::TABLES_IN_SELECT:
			erg = 1;
			break;
		case ::stardata::DatabaseLimit::USER_NAME_LEN:
			break;
	}
	return erg;
}




