/*************************************************************************
 *
 *  $RCSfile: flattab.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_SDBTOOLS_HXX
#include <sdbtools.hxx>
#endif

#include <ctype.h>
#include <stdlib.h>
#ifndef _SDB_FLATCONN_HXX
#include "flatconn.hxx"
#endif
#ifndef _SDB_FLATTAB_HXX
#include "flattab.hxx"
#endif

#ifndef _SDB_FILECOL_HXX
#include "filecol.hxx"
#endif

#ifndef _ZFORLIST_HXX //autogen
#include <svtools/zforlist.hxx>
#endif

#ifndef _APP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif


DBG_NAME(SdbFLATTable);

//------------------------------------------------------------------
xub_StrLen SdbFLATString::GetTokenCount( char cTok, char cStrDel ) const
{
	if ( !Len() )
		return 0;

	xub_StrLen nTokCount = 1;
	BOOL bStart = TRUE;		// Stehen wir auf dem ersten Zeichen im Token?
	BOOL bInString = FALSE;	// Befinden wir uns INNERHALB eines (cStrDel delimited) String?

	// Suche bis Stringende nach dem ersten nicht uebereinstimmenden Zeichen
	for( xub_StrLen i = 0; i < Len(); i++ )
	{
		if (bStart)
		{
			bStart = FALSE;
			// Erstes Zeichen ein String-Delimiter?
			if ((*this).GetChar(i) == cStrDel)
			{
				bInString = TRUE;	// dann sind wir jetzt INNERHALB des Strings!
				continue;			// dieses Zeichen ueberlesen!
			}
		}

		if (bInString) {
			// Wenn jetzt das String-Delimiter-Zeichen auftritt ...
			if ( (*this).GetChar(i) == cStrDel ) 
			{
				if ((i+1 < Len()) && ((*this).GetChar(i+1) == cStrDel)) 
				{
					// Verdoppeltes String-Delimiter-Zeichen:
					i++;	// kein String-Ende, naechstes Zeichen ueberlesen.
				} 
				else 
				{
					// String-Ende
					bInString = FALSE;
				}
			}
		} else {
			// Stimmt das Tokenzeichen ueberein, dann erhoehe TokCount
			if ( (*this).GetChar(i) == cTok )
			{
				nTokCount++;
				bStart = TRUE;
			}
		}
	}

	return nTokCount;
}

//------------------------------------------------------------------
ByteString SdbFLATString::GetToken( xub_StrLen nToken, char cTok, char cStrDel ) const
{
	if ( !Len() )
		return ByteString();

	xub_StrLen nTok = 0;
	BOOL bStart = TRUE;		// Stehen wir auf dem ersten Zeichen im Token?
	BOOL bInString = FALSE;	// Befinden wir uns INNERHALB eines (cStrDel delimited) String?
	ByteString aResult;			// Ergebnisstring

	// Suche bis Stringende nach dem ersten nicht uebereinstimmenden Zeichen
	for( xub_StrLen i = 0; i < Len(); i++ )
	{
		if (bStart) {
			bStart = FALSE;
			// Erstes Zeichen ein String-Delimiter?
			if ((*this).GetChar(i) == cStrDel) {
				bInString = TRUE;	// dann sind wir jetzt INNERHALB des Strings!
				continue;			// dieses Zeichen ueberlesen!
			}
		}

		if (bInString) {
			// Wenn jetzt das String-Delimiter-Zeichen auftritt ...
			if ( (*this).GetChar(i) == cStrDel ) {
				if ((i+1 < Len()) && ((*this).GetChar(i+1) == cStrDel)) 
				{
					// Verdoppeltes String-Delimiter-Zeichen:
					i++;	// kein String-Ende, naechstes Zeichen ueberlesen.

					if (nTok == nToken) 
					{
						aResult += (*this).GetChar(i);	// Zeichen gehoert zum Resultat-String
					}
				} 
				else 
				{
					// String-Ende
					bInString = FALSE;
				}
			} else {
				if (nTok == nToken) {
					aResult += (*this).GetChar(i);	// Zeichen gehoert zum Resultat-String
				}
			}

		} else {
			// Stimmt das Tokenzeichen ueberein, dann erhoehe nTok
			if ( (*this).GetChar(i) == cTok ) {
				nTok++;
				bStart = TRUE;

				if ( nTok > nToken )
				{
					// Vorzeitiger Abbruch der Schleife moeglich, denn
					// wir haben, was wir wollten.
					return aResult;
				}
			} else {
				if (nTok == nToken) {
					aResult += (*this).GetChar(i);	// Zeichen gehoert zum Resultat-String
				}
			}
		}
	}

	return aResult;
}

//------------------------------------------------------------------
SdbFLATTable::SdbFLATTable(SdbFLATConnection* pConnection)
			 :SdbFILETable(pConnection)
			 ,rSvNumberFormatter(*pConnection->GetEnvironment()->GetStandardFormatter())
{
	DBG_CTOR(SdbFLATTable,NULL);
}

//------------------------------------------------------------------
SdbFLATTable::~SdbFLATTable()
{
	DBG_DTOR(SdbFLATTable,NULL);
}

//------------------------------------------------------------------
BOOL SdbFLATTable::FileOpen(BOOL bReadOnly)
{
	DBG_CHKTHIS(SdbFLATTable,NULL);

	if (!bReadOnly)
		return FALSE;

	// Sicherheitshalber erst ein Close (ohne Fehlerabfrage) ...
	FileClose();
	aStatus.Clear();

	DirEntry aFileEntry = GetFLATConnection()->FileEntry(aName);
	aFileStream.Open(aFileEntry.GetFull(), STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYWRITE);
	if (aStatus.SetError(aFileStream,TABLE))
		return FALSE;

	// einen Puffer abhaengig von der Filegroesse anlegen
	TRY_FILE(aFileStream.Seek(STREAM_SEEK_TO_END),TABLE);
	UINT32 nFileSize = aFileStream.Tell();
	TRY_FILE(aFileStream.Seek(STREAM_SEEK_TO_BEGIN),TABLE);

	// Buffersize abhaengig von der Filegroesse
	aFileStream.SetBufferSize(nFileSize > 100000 ? 16384 : 4096);

	return TRUE;
}

//------------------------------------------------------------------
void SdbFLATTable::FileClose()
{
	DBG_CHKTHIS(SdbFLATTable,NULL);
	aFileStream.Close();
}

//------------------------------------------------------------------
BOOL SdbFLATTable::IsFileOpen() const
{
	return aFileStream.IsOpen();
}

//------------------------------------------------------------------
BOOL SdbFLATTable::OpenImpl()
{
	BOOL bResult = SdbFILETable::OpenImpl();
	if (bResult)
	{
		SdbFILEConnection* pConnection = GetFILEConnection();
		// was darf der Benutzer
		if (FileStat::GetReadOnlyFlag(pConnection->FileEntry(aName)))
			nPrivileges = SDB_PR_READ;
		else
			nPrivileges = SDB_PR_READ | SDB_PR_DROP;
	}
	return bResult;
}


//------------------------------------------------------------------
BOOL SdbFLATTable::DescribeColumns()
{
	DBG_CHKTHIS(SdbFLATTable,NULL);
	// Dateistruktur ermitteln und neue Strukturbeschreibung anlegen:
	DBG_ASSERT(aOriginalColumns.Is(), "keine Filestruktur angelegt");

	// Felder bereits gelesen
	if (aOriginalColumns->Count() > 1)
		return TRUE;

	SdbFLATConnection* pConnection = GetFLATConnection();
	BOOL bRead = TRUE;
	// Header Line lesen:
	TRY_FILE(aFileStream.Seek(STREAM_SEEK_TO_BEGIN),TABLE);

	SdbFLATString aHeaderLine;
	if (GetFLATConnection()->IsHeaderLine())
	{
		while(bRead && !aHeaderLine.Len() && aStatus.IsSuccessful())
		{
			TRY_FILE(bRead = aFileStream.ReadLine(aHeaderLine),TABLE);
		}
	}

	// Erste Datenzeile lesen:
	SdbFLATString aFirstLine;


	TRY_FILE(bRead = aFileStream.ReadLine(aFirstLine),TABLE);

	if (!GetFLATConnection()->IsHeaderLine() || !aHeaderLine.Len())
	{
		while(bRead && !aFirstLine.Len() && aStatus.IsSuccessful())
		{
			TRY_FILE(bRead = aFileStream.ReadLine(aFirstLine),TABLE);
		}
		// Erste Datenzeile als Header Line benutzen, auch wenn die Headerline leer ist
		// (zumindest hinsichtlich der Anzahl der Felder)
		aHeaderLine = aFirstLine;
	}

	// Anzahl Felder:
	xub_StrLen nFieldCount = aHeaderLine.GetTokenCount(pConnection->FieldDelimiter(),pConnection->StringDelimiter());
	// Feldbeschreibungen lesen:
	char cDecimalDelimiter = pConnection->DecimalDelimiter();
	char cThousandDelimiter = pConnection->ThousandDelimiter();
	ByteString aColumnName;
	for (xub_StrLen i = 0; i < nFieldCount; i++)
	{
		if (pConnection->IsHeaderLine())
		{
			aColumnName = aHeaderLine.GetToken(i,pConnection->FieldDelimiter(),pConnection->StringDelimiter());
			aColumnName.Convert(pConnection->GetCharacterSet(),gsl_getSystemTextEncoding());
		}
		else
		{
			// Durchnumerieren: C1, C2, ...
			aColumnName = 'C';
			aColumnName += ByteString::CreateFromInt32(i+1);
		}
		SdbDatabaseType eType;
		UINT16 nPrecision = 0;
		UINT16 nScale = 0;

		BOOL bNumeric = FALSE;
		double nRes=0.0;
		ULONG  nIndex = 0;

		// zunaechst ohne Felddelimeter suchen
		ByteString aField(aFirstLine.GetToken(i,pConnection->FieldDelimiter(),'\0'));
		if (aField.Len() == 0 ||
			(pConnection->StringDelimiter() && pConnection->StringDelimiter() == aField.GetChar(0)))
		{
			bNumeric = FALSE;
		}
		else
		{
			ByteString aField(aFirstLine.GetToken(i,pConnection->FieldDelimiter(),
											pConnection->StringDelimiter()));

			if (aField.Len() == 0)
			{
				bNumeric = FALSE;
			}
			else
			{
				bNumeric = TRUE;
				xub_StrLen nDot = 0;
				for (xub_StrLen j = 0; j < aField.Len(); j++)
				{
					char c = aField.GetChar(j);
					// nur Ziffern und Dezimalpunkt und Tausender-Trennzeichen?
					if ((!cDecimalDelimiter || c != cDecimalDelimiter) &&
						(!cThousandDelimiter || c != cThousandDelimiter) &&
						!isdigit(c))
					{
						bNumeric = FALSE;
						break;
					}
					if (cDecimalDelimiter && c == cDecimalDelimiter)
					{
						nPrecision = 15; // we have an decimal value
						nScale = 2;
						nDot++;
					}
				}
				// Bei mehr als einem Dezimalpunkt keine Zahl!
				if (nDot > 1) bNumeric = FALSE;
				if (bNumeric && cThousandDelimiter)
				{
					// Ist der Trenner richtig angegeben?
					ByteString aValue = aField.GetToken(0,cDecimalDelimiter);
					for (xub_StrLen j = aValue.Len() - 4; j >= 0; j -= 4)
					{
						char c = aField.GetChar(j);
						// nur Ziffern und Dezimalpunkt und Tausender-Trennzeichen?
						if (c == cThousandDelimiter && j)
							continue;
						else
						{
							bNumeric = FALSE;
							break;
						}
					}
				}

				// jetzt knnte es noch ein Datumsfeld sein
				if (!bNumeric)
				{
					rSvNumberFormatter.IsNumberFormat(String(aField,pConnection->GetCharacterSet()),nIndex,nRes);
				}
			}
		}

		USHORT nFlags = 0;
		if (bNumeric)
		{
			if (cDecimalDelimiter)
				eType = (nPrecision) ? SDB_DBTYPE_DECIMAL : SDB_DBTYPE_DOUBLE;
			else
				eType = SDB_DBTYPE_INTEGER;
			nFlags = SDB_FLAGS_SEARCH_EXCEPT_LIKE;
		}
		else
		{
			switch (rSvNumberFormatter.GetType(nIndex))
			{
				case NUMBERFORMAT_DATE:
					eType = SDB_DBTYPE_DATE;
					break;
				case NUMBERFORMAT_DATETIME:
					eType = SDB_DBTYPE_TIMESTAMP;
					break;
				case NUMBERFORMAT_TIME:
					eType = SDB_DBTYPE_TIME;
					break;
				default:
					eType = SDB_DBTYPE_VARCHAR;
					nPrecision = 255;	// nyi: Daten koennen aber laenger sein!
					nScale = 0;
			};
			nFlags |= SDB_FLAGS_SEARCH_ALL;
		}

		String aAlias(aColumnName,pConnection->GetCharacterSet());
		const SdbColumn* pPrevCol = aOriginalColumns->Column(aAlias);

		ULONG nExprCnt(0);
		while(pPrevCol)
		{
			(aAlias = String(aColumnName,pConnection->GetCharacterSet())) += String::CreateFromInt32(++nExprCnt);
			pPrevCol = aOriginalColumns->Column(aAlias);
		}
		SdbColumn* pColumn = new SdbFILEColumn(aAlias,eType,nPrecision,nScale,nFlags);

		if (!bNumeric)
			// CHARACTER-Felder koennen leer (NULL) sein.
			pColumn->SetFlag(SDB_FLAGS_NULLALLOWED);

		// Column-Beschreibung hinzufuegen.
		aOriginalColumns->AddColumn(pColumn);
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
BOOL SdbFLATTable::SeekRow(SdbFileCursorPosition eCursorPosition, INT32 nOffset, INT32& nCurPos)
{
	SdbFLATConnection* pConnection = GetFLATConnection();
	// ----------------------------------------------------------
	// Positionierung vorbereiten:
	nFilePos = nCurPos;

	switch(eCursorPosition)
	{
		case FILE_FIRST:
			nFilePos	= 0;
		case FILE_NEXT:
			TRY_FILE(aFileStream.Seek(nFilePos),TABLE);
			if (aFileStream.IsEof())
			{
				aStatus.Set(SDB_STAT_NO_DATA_FOUND);
				break;
			}
			if (nFilePos == 0 && pConnection->IsHeaderLine())
			{

				BOOL bRead2;
				do
				{
					TRY_FILE(bRead2 = aFileStream.ReadLine(aCurrentLine),TABLE);
				}
				while(bRead2 && !aCurrentLine.Len() && aStatus.IsSuccessful());

				nFilePos = aFileStream.Tell();
				if (aFileStream.IsEof())
				{
					aStatus.Set(SDB_STAT_NO_DATA_FOUND);
					break;
				}
			}
			TRY_FILE(aFileStream.ReadLine(aCurrentLine),TABLE);
			if (aFileStream.IsEof())
			{
				aStatus.Set(SDB_STAT_NO_DATA_FOUND);
				break;
			}
			nCurPos = aFileStream.Tell();
			break;
		case FILE_PRIOR:
		case FILE_LAST:
		case FILE_RELATIVE:
		case FILE_ABSOLUTE:
			aStatus.SetDriverNotCapableError();
			break;
		case FILE_BOOKMARK:
			// Bookmark ist hier die Byte-Position in der Datei (zu Beginn des Datensatzes)
			TRY_FILE(aFileStream.Seek(nOffset),TABLE);
			if (aFileStream.IsEof())
			{
				aStatus.Set(SDB_STAT_NO_DATA_FOUND);
				break;
			}
			nFilePos = aFileStream.Tell();	// Byte-Position in der Datei merken (am ZeilenANFANG)
			TRY_FILE(aFileStream.ReadLine(aCurrentLine),TABLE);
			if (aFileStream.IsEof())
			{
				aStatus.Set(SDB_STAT_NO_DATA_FOUND);
				break;
			}
			nCurPos  = aFileStream.Tell();

	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
BOOL SdbFLATTable::FetchRow(ODbRow& rRow, SdbColumns& rColumns, BOOL bRetrieveData)
{
	// Aktuelle Record Number:
	ODbVariant* pVal = rRow.front().getBodyPtr();
	SdbFLATConnection* pConnection = GetFLATConnection();

	if (pVal)
		pVal->setINT32((long)nFilePos);

	if (!bRetrieveData)
		return TRUE;

	// Felder:
	for (xub_StrLen i = 1; i < rColumns.Count(); i++)
	{
		pVal = rRow[i].getBodyPtr();

		if (pVal == NULL)
			continue;

		const SdbColumn * pColumn = rColumns[i];

		ByteString aStr(aCurrentLine.GetToken(i-1,pConnection->FieldDelimiter(),pConnection->StringDelimiter()));

		if (aStr.Len() == 0)
			pVal->setNull();
		else switch(pColumn->GetType())
		{
			case SDB_DBTYPE_TIMESTAMP:
			case SDB_DBTYPE_DATE:
			case SDB_DBTYPE_TIME:
			{
				double nRes;
				ULONG  nIndex;
				if (rSvNumberFormatter.IsNumberFormat(String(aStr, pConnection->GetCharacterSet()),nIndex,nRes))
					pVal->setDouble(SdbTools::ToStandardDate(rSvNumberFormatter, nRes));
				else
					pVal->setNull();
			}	break;
			case SDB_DBTYPE_DECIMAL:
			case SDB_DBTYPE_NUMERIC:
			case SDB_DBTYPE_DOUBLE:
			case SDB_DBTYPE_INTEGER:
			{
				char cDecimalDelimiter = pConnection->DecimalDelimiter();
				char cThousandDelimiter = pConnection->ThousandDelimiter();
				ByteString aStrConverted;

				DBG_ASSERT(cDecimalDelimiter && pColumn->GetType() != SDB_DBTYPE_INTEGER ||
						   !cDecimalDelimiter && pColumn->GetType() == SDB_DBTYPE_INTEGER,
						   "FalscherTyp");

				// In Standard-Notation (DezimalPUNKT ohne Tausender-Komma) umwandeln:
				for (xub_StrLen j = 0; j < aStr.Len(); j++)
				{
					if (cDecimalDelimiter && aStr.GetChar(j) == cDecimalDelimiter)
						aStrConverted += '.';
					else if (cThousandDelimiter && aStr.GetChar(j) == cThousandDelimiter)
					{
						// weglassen
					}
					else
						aStrConverted += aStr.GetChar(j) ;
				}
				pVal->setDouble(SdbTools::ToDouble(aStrConverted));
			} break;
			default:
			{
				// Wert als String in Variable der Row uebernehmen
				pVal->setString(UniString(aStr, pConnection->GetCharacterSet()));
			}
			break;
		}
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
BOOL SdbFLATTable::CreateImpl() {return FALSE;}
//------------------------------------------------------------------
BOOL SdbFLATTable::AlterImpl() {return FALSE;}


