/*************************************************************************
 *
 *  $RCSfile: impout.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "impout.hxx"

// Prototypen des zu generierenden Codes (Base Strings):

extern const String aModuleHeader1(
"// Implib-Definitionen fuer #MODNAME#-DLL/shared library:\n"
"// AUTOMATISCH GENERIERT - NICHT EDITIEREN!\n"
"#ifndef IMPLIB_#FILENAME#_HXX\n"
"#define IMPLIB_#FILENAME#_HXX\n"
"#if defined(WIN) || defined(WNT)\n"
"#include <prewin.h>\n"
"#include <#INCFILE#>\n"
"#include <postwin.h>\n"
"#endif\n"
"#if defined(OS2)\n"
"#define INCL_DOSMODULEMGR\n"
"#include <svpm.h>\n"
"#include <#INCFILE#>\n"
"#endif\n"
"\n"
"#include <tools.hxx>\n"
"\n"
"BOOL LoadLibrary_#MODNAME#();\n"
"BOOL FreeLibrary_#MODNAME#();\n"
"\n"
);

extern const String aModuleHeader2(
"\n"
"#endif\n"
);

extern const String aFunctionHeader1(
"typedef #RETTYP# (#MODIFIER# *T#FUNCNAME#) (#FUNCPARAM#);\n"
"extern T#FUNCNAME# p#FUNCNAME#;\n"
"#define #FUNCPREFIX##FUNCNAME#(#MACPARAM#) (*p#FUNCNAME#)(#MACPARAM#)\n"
"\n"
);

extern const String aModuleBody1(
"// Implib-Definitionen fuer #MODNAME#-DLL/shared library:\n"
"// AUTOMATISCH GENERIERT - NICHT EDITIEREN!\n"
"#include \"#FILENAME#.hxx\"\n"
"\n"
"static BOOL bLoaded;"
"\n"
"// Handle fuer die DLL/shared lib\n"
"#if defined(WIN) || defined(WNT)\n"
"static HINSTANCE hLib;\n"
"#endif\n"
"#if defined(OS2)\n"
"static HMODULE hLib;\n"
"#endif\n"
"\n"
"// Dynamisches Laden der DLL/shared lib und Adressen der Funktionen besorgen:\n"
"// Liefert TRUE bei Erfolg.\n"
"BOOL LoadLibrary_#MODNAME#()\n"
"{\n"
"	if (bLoaded) return TRUE;\n"
"\n"
"#ifdef WIN\n"
"	hLib = LoadLibrary(\"#MODNAME#.DLL\");\n"
"	if (hLib <= HINSTANCE_ERROR) return FALSE;\n"
"#endif\n"
"#ifdef WNT\n"
"	hLib = LoadLibrary(\"#MODNAME#32.DLL\");\n"
"	if (hLib == NULL) return FALSE;\n"
"#endif\n"
"#ifdef OS2\n"
"	char aErr[256];\n"
"	if (DosLoadModule((PSZ) aErr, sizeof aErr, (PSZ) \"#MODNAME#\", (HMODULE *) &hLib)) {\n"
"		hLib = NULL;\n"
"	}\n"
"	if (hLib == NULL) return FALSE;\n"
"#endif\n"
"\n"
);

extern const String aFunctionBody1(
"#if defined(WIN) || defined(WNT)\n"
"	if ((p#FUNCNAME# = (T#FUNCNAME#)GetProcAddress(hLib,\"#FUNCNAME#\")) == NULL) return FALSE;\n"
"#endif\n"
"#if defined(OS2)\n"
"	if (DosQueryProcAddr((HMODULE)hLib, 0, \"#FUNCNAME#\", (PFN *) &p#FUNCNAME#)) return FALSE;\n"
"#endif\n"
"\n"
);

extern const String aModuleBody2(
"	bLoaded = TRUE;\n"
"	return TRUE;\n"
"}\n"
"\n"
"BOOL FreeLibrary_#MODNAME#()\n"
"{\n"
"	if (! bLoaded) return FALSE;\n"
"\n"
"#ifdef WIN\n"
"	FreeLibrary(hLib);\n"
"#endif\n"
"#ifdef WNT\n"
"	if (! FreeLibrary(hLib)) return FALSE;\n"
"#endif\n"
"#ifdef OS2\n"
"	DosFreeModule((HMODULE)hLib);\n"
"#endif\n"
"\n"
"	bLoaded = FALSE;\n"
"	return TRUE;\n"
"}\n"
"\n"
);

extern const String aFunctionBody2(
"T#FUNCNAME# p#FUNCNAME#;\n"
);


// Im rProtoString alle auftretenden rToken durch rValue ersetzen.
// Annahme: im Value treten keine Token auf!
static void ReplaceToken(String & rString, const String & rToken, const String & rValue)
{
	// Solange noch Token vorhanden ...
	while (1) {
		// Token suchen
		USHORT n = rString.Search(rToken);
		if (n == STRING_NOTFOUND) break;

		// Token loeschen
		rString.Erase(n,rToken.Len());

		// Wert einfuegen
		rString.Insert(rValue,n);
	}
}

String ImpModule(const String & rBaseString,
					 const String & rModName,
					 const String & rFileName,
					 const String & rIncFile)
{
	String aResult(rBaseString);
	ReplaceToken(aResult,"#MODNAME#",rModName);
	ReplaceToken(aResult,"#FILENAME#",rFileName);
	ReplaceToken(aResult,"#INCFILE#",rIncFile);
	return aResult;
}

String ImpFunction(const String & rBaseString,
					   const String & rRettyp,
					   const String & rModifier,
					   const String & rFuncName,
					   const String & rFuncParam,
					   int nNumParam,
					   const String & rFuncPrefix)
{
	String aResult(rBaseString);
	ReplaceToken(aResult,"#RETTYP#",rRettyp);
	ReplaceToken(aResult,"#MODIFIER#",rModifier);
	ReplaceToken(aResult,"#FUNCNAME#",rFuncName);
	ReplaceToken(aResult,"#FUNCPARAM#",rFuncParam);
	ReplaceToken(aResult,"#FUNCPREFIX#",rFuncPrefix);

	String aMacParam;
	for (int i = 0; i < nNumParam; i++) {
		aMacParam += (char)('a'+i);
		aMacParam += ',';
	}
	aMacParam.EraseTrailingChars(',');
	ReplaceToken(aResult,"#MACPARAM#",aMacParam);

	return aResult;
}

