/*************************************************************************
 *
 *  $RCSfile: adoconn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SDB_ADOCONN_HXX
#define SDB_ADOCONN_HXX

#ifndef _SDB_SDBCONN_HXX
#include "sdbconn.hxx"
#endif
#ifndef SDB_ADOTAB_HXX
#include "adotab.hxx"
#endif
#ifndef SDB_ADOCUR_HXX
#include "adocurs.hxx"
#endif
#ifndef _SDB_ADOMD_HXX
#include "adomd.hxx"
#endif


//========================================================================

class SdbADOConnection : public SdbConnection
{
	friend class SdbEnvironment;
	friend class SdbADOCursor;
	friend class SdbADOTable;
	friend class SdbADOMetaData;
	friend class SdbADORelation;

private:

	// weviele Connections sind zur Zeit geoeffnet?
	static UINT16 ConnectionCount;

	WpADOConnection*	pADOConnection;

	// wird von den Konstruktoren gerufen,
	// ruft ggf. CoInitializeEx() aus der OLE-Lib.
	void Construct();

	virtual ::com::sun::star::data::XDatabaseDescriptor* GetMetaDataImpl();

	BOOL IsCapableImpl(SdbCapability eCap) const;
	BOOL OpenADOConnection();
	void FillRelation(SdbRelationList& _rList, const String& rName);
	BOOL OpenRelationCursor(const String& rCatalog, const String& rSchema, const String& rName, ADORecordset*& _pCursor);
	BOOL FillRelation(SdbADORelation& rRel);

protected:
	SdbADOConnection(SdbEnvironment* pEnv, const String& rNewOptions);
	SdbADOConnection(const SdbADOConnection& rConn);
	~SdbADOConnection();

	void CommitImpl();
	void RollbackImpl();

	BOOL OpenImpl();
	BOOL CloseImpl();

	// gibt eine jungfraeulichen SdbADOTable zurueck
	SdbTable* CreateTableImpl();

	// gibt eine jungfraeulichen SdbADORelation zurueck
	SdbRelation* CreateRelationImpl(const String& _rName);

	// gibt einen passenden SdbADOCursor zurueck
	SdbCursor* CreateCursorImpl(SdbCursorType eType, UINT16 nOptions);

	// spezieller View-Wrapper, um korrektes Loeschen der Views						 c
	// zu ermoeglichen (ADO-Views sind ja bloss Access-Queries
	// vom Typ "SELECT", und koennen NICHT mit "DROP VIEW...."
	// geloescht werden!)
	SdbView* CreateViewImpl();


	// fuellt die Typenliste mit den unter ADO zur Verfuegung stehenden Typen
	void FillTypeList(SdbTypeInfoList& _rList);

	INT32 GetTablePrivileges(const String& rTableName) const;

	// fuellt die Relationenliste mit allen Relationen auf, die von der uebergebenen
	// Tabelle auf andere verweisen. Ausgenommen sind jene, die auf Tabellen verweisen,
	// welche nicht fuer die Relationensicht ausgewaehlt sind
	virtual void FillRelations(SdbRelationList& _rList, const String& rName){};


	// die Namen aller fuer den Benutzer sichtbaren Tabellen werden in die
	// uebergebene Liste abgelegt
	virtual void FillTableNames(SdbStringStlMap* _pList);

	WpADOConnection* GetADOConnection() const {return pADOConnection;};
	// Anzahl der Relationen, ggf. Relationenliste fuellen - fuer alle Tabellen
	virtual void FillAllRelations(SdbRelationList& _rList);

public:
	void SetADOError(SdbStatus& anotherStatus);
	inline void SetAutoCommit(BOOL _bAutoCommit) {bAutoCommit = _bAutoCommit;};
};



#endif //SDB_ADOCONN_HXX

