/*************************************************************************
 *
 *  $RCSfile: filecol.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_FILECOL_HXX
#define _SDB_FILECOL_HXX 1

#ifndef _SDB_SDBCOL_HXX
#include "sdbcol.hxx"
#endif

#ifndef _SDB_FILEIDX_HXX
#include "fileidx.hxx"
#endif

class SdbFILEIndex;

//==================================================================
// File Spalte, wird fuer die SQL-Auswertung benoetigt
//==================================================================
class SdbFILEColumn : public SdbColumn
{
	// Zeiger auf eine IndexStruktur, sollte nur im Rahmen der SQLAuswertung
	// Verwendung finden;
	SdbFILEIndexRef	xIndex;

public:
	SdbFILEColumn(const String &rNewName, SdbDatabaseType eNewType,
				  UINT32 nNewLength = 0, UINT16 nNewScale = 0,
				  INT16 nNewFlags = 0, UINT32 nFormatKey = 0);

	SdbFILEColumn(const SdbColumn& rCol);
	SdbFILEColumn(const String& rAlias, const SdbColumn& rCol);

	void SetIndex(SdbFILEIndex*);
	SdbFILEIndex* GetIndex() const {return &xIndex;}
	BOOL IsIndexed() const {return xIndex.Is();}

	virtual SdbColumn* Clone() const {return new SdbFILEColumn(*this);}
};

//==================================================================
// File basierte Spalten werden nicht case senitive ausgewertet
// allerdings koennen die Tabellen durchaus case sensitive sein (UNX)
// daher ist eine eigene Klasse notwendig
//==================================================================
class SdbFILEColumns : public SdbColumns
{
	friend class SdbFILEConnection;
protected:
	SdbFILEColumns(SdbConnection& _rConn):SdbColumns(_rConn){};
	// Die Columns-Liste und alle enthaltenen Columns werden kopiert
	// (aber nicht die Anzahl der Referenzen - die wird auf 1 gesetzt!)
	SdbFILEColumns(SdbConnection& _rConn, const SdbColumns &_rColumns):SdbColumns(_rConn, _rColumns){};
};

#endif

