/*************************************************************************
 *
 *  $RCSfile: fmcurs.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_FMCURS_HXX
#define _SDB_FMCURS_HXX 1

#ifndef _SDB_FILECURS_HXX
#include "filecurs.hxx"
#endif

#include <mac_start.h>
#include <Types.h>
#include <AppleEvents.h>
#include <mac_end.h>

class String;

class SdbEnvironment;

class SdbFmCursor : public SdbFILECursor
{
	friend class SdbFmConnection;
	friend class SdbFmTable;

	SdbFmCursor(SdbFmConnection & rSdbConnection,
				SdbCursorObject eObj,
				SdbCursorType eType,
				UINT16 nOptions);
private:

	// Eigene Member dieser Implementation:
	AEAddressDesc	aFileMakerAdress;
	AEDesc			aDatabaseSpec;

	String	aFmFileName;
	long	nFmMaxPos;
	BOOL	bFileIsOpen;

	// Private Hilfsfunktionen
	inline AEAddressDesc* GetFMAdressDesc() { return &aFileMakerAdress; }
	inline AEDesc* 		  GetDatabaseSpec() { return &aDatabaseSpec; }

	OSErr OpenFMDatabase(const String& rFileName);

	// Baut aDatabaseSpec anhand des rDatabaseName auf
	OSErr BuildDatabaseDesc(const String& rDatabaseName);

	OSErr GetRecordCount();
	OSErr GetRecord(long 							nNumber,
					SdbRow& rRow,
					SdbColumns& rColumns);


  protected:
	// Oeffnen/Schliessen der Fm-Datei (und Ermittlung der Struktur)
	virtual void FileOpen(const DirEntry& aFileEntry, BOOL bForUpdate=FALSE);
	virtual void FileClose();

	// Ruecksetzen der Datei auf den Anfang (neues Execute),
	// ggf. Header neu lesen, ...
	virtual void FileReset();
	virtual BOOL OnOpen();

	// Dateistruktur ermitteln;
	void FileReadColumns();

	// Lesen/Schreiben/Loeschen von Datensaetzen:
	virtual void Seek(SdbCursorPosition eCursorPosition, INT32 nOffset);
	virtual void FetchRow(SdbRow& rRow, SdbColumns& rColumns, BOOL);

	virtual void FileInsertRow(SdbRowRef& pRow);
	virtual void FileUpdateRow(const SdbRowRef& pRow);
	virtual void FileDeleteRow();

	virtual INT32 MaxRowCount() const;
};

#endif


