/*************************************************************************
 *
 *  $RCSfile: ja_lg_pg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SDB_JA_LG_PG_HXX
#define _SDB_JA_LG_PG_HXX

#ifndef _SDB_JA_LG_OB_HXX
#include <ja_lg_ob.hxx>
#endif

#include <tools/string.hxx>
// Die Fkt. ConvStr2WStr konvertiert einen String nach UniString (Unicode)
UniString ConvStr2WStr(const String& aStr);
//**************************************************************
//************ Class: java.lang.String
//**************************************************************
class java_lang_StringBuffer;
class java_lang_Object;
class java_lang_Array;
class java_lang_String;
class java_util_Locale;
class java_lang_Class;
class java_lang_ClassLoader;
class java_lang_reflect_Field;
class java_lang_reflect_Method;
class java_lang_reflect_Constructor;
class java_io_InputStream;
class java_net_URL;

class java_lang_String : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_String();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_String( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	java_lang_String( const String& _par0 );
};
/*
//**************************************************************
//************ Class: java.lang.Double
//**************************************************************
class java_lang_Double;

class java_lang_Double : public java_lang_Number{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Double();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Double( JNIEnv * pEnv, jobject myObj ) : java_lang_Number( pEnv, myObj ){}

	java_lang_Double( double _par0 );
};
  */

//**************************************************************
//************ Class: java.lang.Boolean
//**************************************************************
class java_lang_Boolean;

class java_lang_Boolean : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Boolean();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Boolean( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	java_lang_Boolean( BOOL _par0 );
};

//**************************************************************
//************ Class: java.lang.Class
//**************************************************************


class java_lang_Class : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Class();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Class( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	static java_lang_Class * forName( const String *_par0 );
	 BOOL isAssignableFrom( java_lang_Class * _par0 );
	 java_lang_Object * newInstance();
	 String getName();
};

//**************************************************************
//************ Class: java.lang.Number
//**************************************************************

class java_lang_Number : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Number();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Number( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

};

//**************************************************************
//************ Class: java.lang.Throwable
//**************************************************************
class java_lang_Throwable : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Throwable();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Throwable( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}
	String getMessage();
	String getLocalizedMessage();
	String toString();
};

//**************************************************************
//************ Class: java.lang.Exception
//**************************************************************
class java_lang_Exception : public java_lang_Throwable{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_lang_Exception();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_lang_Exception( JNIEnv * pEnv, jobject myObj ) : java_lang_Throwable( pEnv, myObj ){}

};

#endif //_SDB_JA_LG_PG_HXX

