/*************************************************************************
 *
 *  $RCSfile: ja_sq_pg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SDB_JA_SQ_PG_HXX
#define _SDB_JA_SQ_PG_HXX

#ifndef _SDB_JA_LG_OB_HXX
//#include <ja_lg_ob.hxx>
#endif

#ifndef _SDB_JA_LG_PG_HXX
#include <ja_lg_pg.hxx>
#endif

#ifndef _SDB_JA_UT_PG_HXX
#include <ja_ut_pg.hxx>
#endif

#ifndef _SDB_JA_IO_PG_HXX
#include <ja_io_pg.hxx>
#endif

#ifndef _SVSTDARR_STRINGSDTOR
//#define _SVSTDARR_STRINGSDTOR
//#include <svtools/svstdarr.hxx>
#endif


//**************************************************************
//************ Class: java.sql.Connection
//**************************************************************
class java_sql_Statement;
class java_sql_PreparedStatement;
class java_lang_String;
class java_sql_CallableStatement;
class java_sql_DatabaseMetaData;
class java_sql_SQLWarning;
class java_lang_Object;
class java_sql_Connection;
class java_util_Properties;
class java_sql_Driver;
class java_util_Enumeration;
class java_io_PrintStream;
class java_lang_Exception;



class java_sql_Connection : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static int TRANSACTION_NONE;
	static int TRANSACTION_READ_COMMITTED;
	static int TRANSACTION_READ_UNCOMMITTED;
	static int TRANSACTION_REPEATABLE_READ;
	static int TRANSACTION_SERIALIZABLE;

	static jclass getMyClass();
	virtual ~java_sql_Connection();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_Connection( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}
	String getCatalog();
	java_sql_DatabaseMetaData * getMetaData();
	void close();
	void commit();
	BOOL isClosed();
	void rollback();
	void setAutoCommit( BOOL _par0 );
	void setTransactionIsolation( INT32 _par0 );
	java_sql_Statement * createStatement();
	java_sql_PreparedStatement * prepareStatement( const String* _par0 );
	java_sql_CallableStatement * prepareCall( const String* _par0 );
	BOOL isReadOnly();
	java_sql_SQLWarning * getWarnings();
};



//**************************************************************
//************ Class: java.sql.DriverManager
//**************************************************************


class java_sql_DriverManager : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_DriverManager();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_DriverManager( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	static java_sql_Connection * getConnection( const String* _par0 );
	static java_sql_Connection * getConnection( const String* _par0, java_util_Properties * _par1 );
	static java_sql_Connection * getConnection( const String* _par0, const String* _par1, const String* _par2 );
	static java_util_Enumeration * getDrivers();
	static void setLoginTimeout(INT32 _par0);
};

class java_math_BigDecimal;
class java_sql_Date;
class java_sql_ResultSetMetaData;
class java_sql_Time;
class java_sql_Timestamp;
class SbxMemoryStreamRef;

/*
**	java_sql_ResultSet
*/
class java_sql_ResultSet : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_ResultSet();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_ResultSet( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	 INT32 findColumn( const String* _par0 );
	 BOOL wasNull();
	 java_io_InputStream * getAsciiStream( const String* _par0 );
	 java_io_InputStream * getAsciiStream( INT32 _par0 );
	 java_math_BigDecimal * getBigDecimal( INT32 _par0, INT32 _par1 );
	 java_math_BigDecimal * getBigDecimal( const String* _par0, INT32 _par1 );
	 java_io_InputStream * getBinaryStream( const String* _par0 );
	 java_io_InputStream * getBinaryStream( INT32 _par0 );
	 BOOL getBoolean( INT32 _par0 );
	 BOOL getBoolean( const String* _par0 );
	 BYTE getByte( INT32 _par0 );
	 BYTE getByte( const String* _par0 );

	 BOOL getBytes( INT32 _par0 , BYTE* &aData,INT32 &nLen);
	 BOOL getBytes( const String* _par0 , BYTE* &aData,INT32 &nLen);

	 java_sql_Date * getDate( INT32 _par0 );
	 double getDouble( INT32 _par0 );
	 double getDouble( const String* _par0 );
	 float getFloat( INT32 _par0 );
	 float getFloat( const String* _par0 );
	 INT32 getInt( INT32 _par0 );
	 INT32 getInt( const String* _par0 );
	 jlong getLong( INT32 _par0 );
	 jlong getLong( const String* _par0 );
	 java_sql_ResultSetMetaData * getMetaData();
	 java_lang_Object * getObject( INT32 _par0 );
	 java_lang_Object * getObject( const String* _par0 );
	 short getShort( INT32 _par0 );
	 short getShort( const String* _par0 );
	 String getString( INT32 _par0);
	 String getString( const String* _par0);
	 java_sql_Time * getTime( INT32 _par0 );
	 java_sql_Time * getTime( const String* _par0 );
	 java_sql_Timestamp * getTimestamp( INT32 _par0 );
	 java_sql_Timestamp * getTimestamp( const String* _par0 );
	 java_io_InputStream * getUnicodeStream( INT32 _par0 );
	 java_io_InputStream * getUnicodeStream( const String* _par0 );
	 BOOL next();
};

//**************************************************************
//************ Class: java.sql.DatabaseMetaDataDate
//**************************************************************

class java_sql_DatabaseMetaData : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_DatabaseMetaData();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_DatabaseMetaData( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	// Dokumentation siehe JDBC API
	 java_sql_ResultSet * getTypeInfo();
	 java_sql_ResultSet * getCatalogs();
	 String getCatalogSeparator();
	 String getCatalogTerm();
	 java_sql_ResultSet * getTables(const String* _par0,const String* _par1,const String* _par2,const String &_par3);
	 INT32 getMaxBinaryLiteralLength();
	 INT32 getMaxCatalogNameLength();
	 INT32 getMaxCharLiteralLength();
	 INT32 getMaxColumnNameLength();
	 INT32 getMaxColumnsInIndex();
	 INT32 getMaxColumnsInTable();
	 INT32 getMaxIndexLength();
	 INT32 getMaxSchemaNameLength();
	 INT32 getMaxStatementLength();
	 INT32 getMaxStatements();
	 INT32 getMaxTableNameLength();
	 INT32 getMaxTablesInSelect();
	 java_sql_ResultSet * getTablePrivileges( const String* _par0, const String* _par1, const String* _par2 );
	 java_sql_ResultSet * getPrimaryKeys( const String* _par0, const String* _par1, const String* _par2 );
	 java_sql_ResultSet * getIndexInfo( const String* _par0, const String* _par1, const String* _par2, BOOL _par3, BOOL _par4 =FALSE);
	 java_sql_ResultSet * getColumns( const String* _par0, const String* _par1, const String* _par2, const String* _par3 );
	 java_sql_ResultSet * getCrossReference( const String* _par0, const String* _par1, const String* _par2, const String* _par3, const String* _par4, const String* _par5 );
	 java_sql_ResultSet * getProcedures( const String* _par0, const String* _par1, const String* _par2 );
	 java_sql_ResultSet * getVersionColumns( const String* _par0, const String* _par1, const String* _par2 );
	 BOOL isCatalogAtStart();
	 BOOL storesLowerCaseIdentifiers();
	 BOOL storesMixedCaseIdentifiers();
	 BOOL storesUpperCaseIdentifiers();
	 BOOL storesUpperCaseQuotedIdentifiers();
	 BOOL storesLowerCaseQuotedIdentifiers();
	 BOOL storesMixedCaseQuotedIdentifiers();
	 BOOL supportsAlterTableWithAddColumn();
	 BOOL supportsAlterTableWithDropColumn();
	 BOOL supportsANSI92FullSQL();
	 BOOL supportsANSI92EntryLevelSQL();
	 BOOL supportsNonNullableColumns();
	 String getIdentifierQuoteString();
	 String getExtraNameCharacters();
	 BOOL supportsDataDefinitionAndDataManipulationTransactions();
	 BOOL supportsPositionedDelete();
	 BOOL supportsPositionedUpdate();
	 BOOL supportsOpenCursorsAcrossCommit();
	 BOOL supportsOpenCursorsAcrossRollback();
	 BOOL supportsTransactions();
	 BOOL supportsTransactionIsolationLevel( INT32 _par0 );
	 BOOL supportsSchemasInDataManipulation();
	 BOOL supportsSchemasInIndexDefinitions();
	 BOOL supportsSchemasInTableDefinitions();
	 BOOL supportsCatalogsInTableDefinitions();
	 BOOL supportsCatalogsInIndexDefinitions();
	 BOOL supportsCatalogsInDataManipulation();
	 BOOL supportsOuterJoins();
	 BOOL supportsIntegrityEnhancementFacility();
	 java_sql_ResultSet * getTableTypes();

	 BOOL allProceduresAreCallable();
	 BOOL allTablesAreSelectable();
	 BOOL isReadOnly();
	 BOOL usesLocalFiles();
	 BOOL usesLocalFilePerTable();
	 BOOL nullPlusNonNullIsNull();
	 BOOL supportsColumnAliasing();
	 BOOL supportsTableCorrelationNames();
	 BOOL supportsConvert();
	 BOOL supportsConvert( INT32 _par0, INT32 _par1 );
	 BOOL supportsExpressionsInOrderBy();
	 BOOL supportsGroupBy();
	 BOOL supportsGroupByBeyondSelect();
	 BOOL supportsGroupByUnrelated();
	 BOOL supportsOrderByUnrelated();
	 BOOL supportsUnion();
	 BOOL supportsUnionAll();
	 BOOL supportsMixedCaseIdentifiers();
	 BOOL supportsMixedCaseQuotedIdentifiers();
	 BOOL nullsAreSortedAtEnd();
	 BOOL nullsAreSortedAtStart();
	 BOOL nullsAreSortedHigh();
	 BOOL nullsAreSortedLow();
	 BOOL supportsSchemasInProcedureCalls();
	 BOOL supportsSchemasInPrivilegeDefinitions();
	 BOOL supportsCatalogsInProcedureCalls();
	 BOOL supportsCatalogsInPrivilegeDefinitions();
	 BOOL supportsCorrelatedSubqueries();
	 BOOL supportsSubqueriesInComparisons();
	 BOOL supportsSubqueriesInExists();
	 BOOL supportsSubqueriesInIns();
	 BOOL supportsSubqueriesInQuantifieds();
	 BOOL supportsANSI92IntermediateSQL();
	 String getURL();
	 String getDriverName();
	 String getDriverVersion();
	 String getDatabaseProductVersion();
	 String getDatabaseProductName();
	 String getProcedureTerm();
	 String getSchemaTerm();
	 INT32 getDriverMajorVersion();
	 INT32 getDriverMinorVersion();
	 String getSQLKeywords();
	 String getSearchStringEscape();
	 String getStringFunctions();
	 String getSystemFunctions();
	 String getNumericFunctions();
	 BOOL supportsExtendedSQLGrammar();
	 BOOL supportsCoreSQLGrammar();
	 BOOL supportsMinimumSQLGrammar();
	 BOOL supportsFullOuterJoins();
	 BOOL supportsLimitedOuterJoins();
	 INT32 getMaxColumnsInGroupBy();
	 INT32 getMaxColumnsInOrderBy();
	 INT32 getMaxColumnsInSelect();
	 INT32 getMaxUserNameLength();
};


//**************************************************************
//************ Class: java.sql.ResultSetMetaData
//**************************************************************

class java_sql_ResultSetMetaData : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_ResultSetMetaData();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_ResultSetMetaData( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	INT32 getColumnCount();
	BOOL isCurrency(INT32 _par0);
	BOOL isAutoIncrement(INT32 _par0);
	INT32 isNullable( INT32 _par0 );
	BOOL isSearchable( INT32 _par0 );
	BOOL isWritable( INT32 _par0 );
	BOOL isReadOnly( INT32 _par0 );
	INT32 getScale( INT32 _par0 );
	INT32 getPrecision( INT32 _par0 );
	INT32 getColumnDisplaySize( INT32 _par0 );
	INT32 getColumnType( INT32 _par0 );
	String getColumnName( INT32 _par0 );

};

//**************************************************************
//************ Class: java.sql.Date
//**************************************************************

class java_sql_Date : public java_util_Date{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_Date();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_Date( JNIEnv * pEnv, jobject myObj ) : java_util_Date( pEnv, myObj ){}
	java_sql_Date( INT32 _year, INT32 _month, INT32 _days );
	static java_sql_Date* valueOf(const String& rDate);
};


//**************************************************************
//************ Class: java.sql.Time
//**************************************************************

class java_sql_Time : public java_util_Date{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_Time();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_Time( JNIEnv * pEnv, jobject myObj ) : java_util_Date( pEnv, myObj ){}
	java_sql_Time( INT32 _hour, INT32 _minute, INT32 _seconds );
};

//**************************************************************
//************ Class: java.sql.Timestamp
//**************************************************************
class java_sql_Timestamp : public java_util_Date{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_Timestamp();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_Timestamp( JNIEnv * pEnv, jobject myObj ) : java_util_Date( pEnv, myObj ){}
	java_sql_Timestamp( INT32 _year, INT32 _month, INT32 _day, INT32 hour = 0, INT32 minute = 0,
						INT32 _nSecond = 0, INT32 _nNano = 0);

	INT32 getNanos();
	void  setNanos(INT32 n);
};

//**************************************************************
//************ Class: java.sql.Statement
//**************************************************************
class java_sql_Statement : public java_lang_Object{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_Statement();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_Statement( JNIEnv * pEnv, jobject myObj ) : java_lang_Object( pEnv, myObj ){}

	 void cancel();
	 void close();
	 BOOL execute( const String* _par0 );
	 java_sql_ResultSet * executeQuery( const String* _par0 );
	 INT32 executeUpdate( const String* _par0 );
	 INT32 getMaxRows();
	 void setMaxFieldSize(INT32 _par0 );
	 java_sql_ResultSet * getResultSet();
	 INT32 getUpdateCount();
	 void setCursorName( const String* _par0 );
	 void setMaxRows( INT32 _par0 );
};

//**************************************************************
//************ Class: java.sql.PreparedStatement
//**************************************************************

class java_sql_PreparedStatement : public java_sql_Statement{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_PreparedStatement();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_PreparedStatement( JNIEnv * pEnv, jobject myObj ) : java_sql_Statement( pEnv, myObj ){}

	BOOL execute();
	INT32 executeUpdate();
	void setString( INT32 _par0, const String* _par1 );
	java_sql_ResultSet * executeQuery();
	void setBigDecimal( INT32 _par0, java_math_BigDecimal * _par1 );
	void setBoolean( INT32 _par0, BOOL _par1 );
	void setByte( INT32 _par0, BYTE _par1 );
	void setBytes( INT32 _par0,BYTE* _par1,ULONG _par2 );
	void setDate( INT32 _par0, java_sql_Date * _par1 );
	void setTime( INT32 _par0, java_sql_Time * _par1 );
	void setTimestamp( INT32 _par0, java_sql_Timestamp * _par1 );
	void setDouble( INT32 _par0, double _par1 );
	void setFloat( INT32 _par0, float _par1 );
	void setInt( INT32 _par0, INT32 _par1 );
	void setLong( INT32 _par0, jlong _par1 );
	void setNull( INT32 _par0, INT32 _par1 );
	void setObject( INT32 _par0, java_lang_Object * _par1 );
	void setShort( INT32 _par0, short _par1 );
	void clearParameters();
	void setBinaryStream( INT32 _par0, BYTE* _par1,ULONG _par2 );
};
//**************************************************************
//************ Class: java.sql.CallableStatement
//**************************************************************

class java_sql_CallableStatement : public java_sql_PreparedStatement {
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_CallableStatement() {} ;
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_CallableStatement( JNIEnv * pEnv, jobject myObj ) : java_sql_PreparedStatement( pEnv, myObj ){}

	BOOL wasNull();
	BOOL execute();
	BOOL getBoolean( INT32 _par0 );
	BYTE getByte( INT32 _par0 );
	BOOL getBytes( INT32 _par0 , BYTE* &pData,INT32 &nLen);
	java_sql_Date * getDate( INT32 _par0 );
	double getDouble( INT32 _par0 );
	float getFloat( INT32 _par0 );
	INT32 getInt( INT32 _par0 );
	jlong getLong( INT32 _par0 );
	java_lang_Object * getObject( INT32 _par0 );
	short getShort( INT32 _par0 );
	String getString( INT32 _par0);
	java_sql_Time * getTime( INT32 _par0 );
	java_sql_Timestamp * getTimestamp( INT32 _par0 );
	java_math_BigDecimal * getBigDecimal( INT32 _par0, INT32 _par1 );

	void registerOutParameter(INT32 _par0,INT32 _type);
};

//**************************************************************
//************ Class: java.sql.SQLException
//**************************************************************
class java_sql_SQLException : public java_lang_Exception{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_SQLException();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_SQLException( JNIEnv * pEnv, jobject myObj ) : java_lang_Exception( pEnv, myObj ){}

	String getSQLState();
	INT32 getErrorCode();
};
//**************************************************************
//************ Class: java.sql.SQLWarning
//**************************************************************
class java_sql_SQLWarning : public java_sql_SQLException{
protected:
// statische Daten fuer die Klasse
	static jclass theClass;
	// der Destruktor um den Object-Counter zu aktualisieren
	static void saveClassRef( jclass pClass );
public:
	static jclass getMyClass();
	virtual ~java_sql_SQLWarning();
	// ein Konstruktor, der fuer das Returnen des Objektes benoetigt wird:
	java_sql_SQLWarning( JNIEnv * pEnv, jobject myObj ) : java_sql_SQLException( pEnv, myObj ){}

};
#endif //_SDB_JA_SQ_PG_HXX

