/*************************************************************************
 *
 *  $RCSfile: jdbcconn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_JDBCCONN_HXX
#define _SDB_JDBCCONN_HXX

#ifndef _SDB_SDBCONN_HXX
#include "sdbconn.hxx"
#endif
/*
#ifndef _SDB_JA_SQ_PG_HXX
#include <ja_sq_pg.hxx>
#endif
*/
#define TABLE_CAT	1
#define TABLE_SCHEM	2
#define TABLE_NAME	3

class SdbJDBCRelation;
class XDatabaseDescriptor;
class java_sql_Connection;
class java_sql_DatabaseMetaData;
class SdbJDBCConnection : public SdbConnection
{
	friend class SdbEnvironment;
	friend class SdbJDBCTable;
	friend class SdbView;
	friend class SdbJDBCCursor;
	friend class SdbJDBCRelation;
	friend SdbDatabaseType javaTyp2SdbTyp(INT32 typ);
	friend INT32 sdbTyp2JavaTyp(SdbDatabaseType eType);
protected:
	// Die Angaben zum Verbindungsaufbau werden aufbewahrt,
	// Dadurch ist der Aufbau zusaetzlicher Verbindungen ohne erneute
	// Abfrage der Benutzerdaten moeglich (siehe Copy-Constructur).

	// Optionen zum Verbindungsaufbau (aus einem String im Format
	// "option=wert;option=wert;option=wert").
	// Immer vorhanden:
	//		"TYP=..."		Server-Typ (siehe SdbEnvironment)
	// Weitere haeufig verwendete Optionen:
	//		"DSN=..."		"Data Source Name", Aliasname fuer eine Datenquelle,
	//						unter dem eine Reihe anderer Parameter zusammengefasst
	//						werden koennen (z. B. bei ODBC).
	// 		"UID=..." 		Benutzername
	//		"PWD=..." 		Passwort
	// sowie beliebige treiberspezifische Optionen.
	//	CommandParser aOptionsParser;
public:
	enum SdbJDBCTypes{
	BIT				= -7,
	TINYINT			= -6,
	SMALLINT		= 5,
	INTEGER			= 4,
	BIGINT			= -5,

	FLOAT			= 6,
	REAL			= 7,
	DOUBLE			= 8,

	NUMERIC			= 2,
	DECIMAL			= 3,

	JCHAR			= 1,
	VARCHAR			= 12,
	LONGVARCHAR		= -1,

	// Dokumentation fr Datum/Zeit ist ungenau

	DATE			= 91,	// aber auch 9
	TIME			= 92,	// 10
	TIMESTAMP		= 93,	// 11	siehe javaTyp2SdbTyp

	BINARY			= -2,
	VARBINARY		= -3,
	LONGVARBINARY	= -4,

	JNULL			= 0,
	OTHER			= 1111
};
	virtual void SetAutoCommit(BOOL bAuto);

	// Zugriff auf java_sql_Connection: darf nicht deleted werden
	java_sql_Connection* GetJAVAConnection() const;
	java_sql_DatabaseMetaData* GetJAVADatabaseMetaData() const;

	// Namen aller verfuegbaren Server:
	static String ServerNames(SdbStatus& rStat, SdbEnvironment* pEnv);
	BOOL HasFreeStatement() const {return nMaxStmt == 0 || nActStmt < nMaxStmt;}
	ULONG GetQualifierUsage() const { return nUseCatalog; }
	ULONG GetOwnerUsage() const { return nUseSchema; }
protected:
	// Neue Verbindungen werden nur mit Create (Factory)
	// angelegt, daher ist der Constructor nicht public.
	SdbJDBCConnection(SdbEnvironment* pEnv, const String& rOptions);
	SdbJDBCConnection(const SdbJDBCConnection& rConn);
	virtual ~SdbJDBCConnection();


	virtual void RemoveChild(SdbObj* pObj);
	// Anforderungen an Treiber
	// virtual void Automatisches Commit
	// COMMIT ausfuehren
	virtual void CommitImpl();

	// ROLLBACK ausfuehren
	virtual void RollbackImpl();

	// Verbindung aufbauen
	virtual BOOL OpenImpl();

	// Verbindung schliessen
	virtual BOOL CloseImpl();

	// Tabellenobject erstellen
	virtual SdbTable*  CreateTableImpl();

	// Cursor erstellen
	virtual SdbCursor* CreateCursorImpl(SdbCursorType eType,UINT16 nOptions);

	// TypInformation fuellen
	virtual void FillTypeList(SdbTypeInfoList& _rList);
	virtual void FillTableNames(SdbStringStlMap* _pList);
	virtual void FillRelations(SdbRelationList& _rList, const String& rName);
	virtual void FillAllRelations(SdbRelationList& _rList);

	virtual BOOL IsCapableImpl(SdbCapability eCapability) const;
	virtual ::com::sun::star::data::XDatabaseDescriptor* GetMetaDataImpl();
	virtual void SetIsolationLevelImpl(SdbIsolationLevel eNewIsolationLevel);

	// Erzeugen von Relationen, default liefert NULL
	virtual SdbRelation* CreateRelationImpl(const String& _rName);

private:
	BOOL FillRelation(SdbJDBCRelation& rRel);
	SdbCursor* OpenRelationCursor(const String& rCatalog, const String& rSchema, const String& rName);

	// member java
	java_sql_Connection *pCon;
	java_sql_DatabaseMetaData *pDbMeta;// aus Performancegruenden
	INT32 nMaxStmt;						// max. Anzahl von Statements
	INT32 nActStmt;						// aktuelle Anzehl von Statements
	ULONG nUseCatalog;					// bei 0 wird kein Catalog untersttzt
	ULONG nUseSchema;					// bei 0 wird kein Schemata untersttzt

};
SdbDatabaseType javaTyp2SdbTyp(INT32 typ); // friend function

#endif	  //_SDB_JDBCCONN_HXX

