/*************************************************************************
 *
 *  $RCSfile: odbc2imp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef IMPLIB_odbc2imp_HXX
#define IMPLIB_odbc2imp_HXX
#if defined(WIN) || defined(WNT)
//#include <tools/prewin.h>
//#include <sqlext.h>
//#include <tools/postwin.h>
#endif
#if defined(OS2)
#define INCL_DOSMODULEMGR
#include <tools/svpm.h>

#ifndef ODBC_OS2
#define ODBC_OS2
#endif
#include <odbc.h>

#ifdef __BORLANDC__
#define SQL_API __syscall
#else
#define SQL_API _System
#endif

#ifndef SQL_MAX_MESSAGE_LENGTH
#define SQL_MAX_MESSAGE_LENGTH MAX_MESSAGE_LENGTH
#endif
#ifndef SQL_MAX_DSN_LENGTH
#define SQL_MAX_DSN_LENGTH MAX_DSN_LENGTH
#endif
#ifndef SQL_AUTOCOMMIT_ON
#define SQL_AUTOCOMMIT_ON 1UL
#endif
#ifndef SQL_AUTOCOMMIT_OFF
#define SQL_AUTOCOMMIT_OFF 0UL
#endif

#define SQL_FETCH_PRIOR SQL_FETCH_PREV
#define SQL_NO_TOTAL (-4)

#endif
#ifdef UNX
#include <odbc/qeodbc.h>
#define EXPORT
#define CALLBACK
#include <odbc/sqlext.h>
#undef BOOL
#endif

#include <tools/solar.h>
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

class SdbEnvironment;
BOOL LoadLibrary_ODBC(SdbEnvironment* pEnv,String &_rPath);

typedef RETCODE  (SQL_API  *TSQLAllocConnect) (HENV henv , HDBC FAR * phdbc);
extern TSQLAllocConnect pSQLAllocConnect;
#define NSQLAllocConnect(a,b) (*pSQLAllocConnect)(a,b)

typedef RETCODE  (SQL_API  *TSQLAllocEnv) (HENV FAR * phenv);
extern TSQLAllocEnv pSQLAllocEnv;
#define NSQLAllocEnv(a) (*pSQLAllocEnv)(a)

typedef RETCODE  (SQL_API  *TSQLAllocStmt) (HDBC hdbc , HSTMT FAR * phstmt);
extern TSQLAllocStmt pSQLAllocStmt;
#define NSQLAllocStmt(a,b) (*pSQLAllocStmt)(a,b)

typedef RETCODE  (SQL_API  *TSQLBindCol) (HSTMT hstmt , UWORD icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TSQLBindCol pSQLBindCol;
#define NSQLBindCol(a,b,c,d,e,f) (*pSQLBindCol)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TSQLCancel) (HSTMT hstmt);
extern TSQLCancel pSQLCancel;
#define NSQLCancel(a) (*pSQLCancel)(a)

typedef RETCODE  (SQL_API  *TSQLColAttributes) (HSTMT hstmt , UWORD icol , UWORD fDescType , PTR rgbDesc , SWORD cbDescMax , SWORD FAR * pcbDesc , SDWORD FAR * pfDesc);
extern TSQLColAttributes pSQLColAttributes;
#define NSQLColAttributes(a,b,c,d,e,f,g) (*pSQLColAttributes)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TSQLConnect) (HDBC hdbc , UCHAR FAR * szDSN , SWORD cbDSN , UCHAR FAR * szUID , SWORD cbUID , UCHAR FAR * szAuthStr , SWORD cbAuthStr);
extern TSQLConnect pSQLConnect;
#define NSQLConnect(a,b,c,d,e,f,g) (*pSQLConnect)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TSQLDescribeCol) (HSTMT hstmt , UWORD icol , UCHAR FAR * szColName , SWORD cbColNameMax , SWORD FAR * pcbColName , SWORD FAR * pfSqlType , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TSQLDescribeCol pSQLDescribeCol;
#define NSQLDescribeCol(a,b,c,d,e,f,g,h,i) (*pSQLDescribeCol)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLDisconnect) (HDBC hdbc);
extern TSQLDisconnect pSQLDisconnect;
#define NSQLDisconnect(a) (*pSQLDisconnect)(a)

typedef RETCODE  (SQL_API  *TSQLError) (HENV henv , HDBC hdbc , HSTMT hstmt , UCHAR FAR * szSqlState , SDWORD FAR * pfNativeError , UCHAR FAR * szErrorMsg , SWORD cbErrorMsgMax , SWORD FAR * pcbErrorMsg);
extern TSQLError pSQLError;
#define NSQLError(a,b,c,d,e,f,g,h) (*pSQLError)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TSQLExecDirect) (HSTMT hstmt , UCHAR FAR * szSqlStr , SDWORD cbSqlStr);
extern TSQLExecDirect pSQLExecDirect;
#define NSQLExecDirect(a,b,c) (*pSQLExecDirect)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLExecute) (HSTMT hstmt);
extern TSQLExecute pSQLExecute;
#define NSQLExecute(a) (*pSQLExecute)(a)

typedef RETCODE  (SQL_API  *TSQLFetch) (HSTMT hstmt);
extern TSQLFetch pSQLFetch;
#define NSQLFetch(a) (*pSQLFetch)(a)

typedef RETCODE  (SQL_API  *TSQLFreeConnect) (HDBC hdbc);
extern TSQLFreeConnect pSQLFreeConnect;
#define NSQLFreeConnect(a) (*pSQLFreeConnect)(a)

typedef RETCODE  (SQL_API  *TSQLFreeEnv) (HENV henv);
extern TSQLFreeEnv pSQLFreeEnv;
#define NSQLFreeEnv(a) (*pSQLFreeEnv)(a)

typedef RETCODE  (SQL_API  *TSQLFreeStmt) (HSTMT hstmt , UWORD fOption);
extern TSQLFreeStmt pSQLFreeStmt;
#define NSQLFreeStmt(a,b) (*pSQLFreeStmt)(a,b)

typedef RETCODE  (SQL_API  *TSQLGetCursorName) (HSTMT hstmt , UCHAR FAR * szCursor , SWORD cbCursorMax , SWORD FAR * pcbCursor);
extern TSQLGetCursorName pSQLGetCursorName;
#define NSQLGetCursorName(a,b,c,d) (*pSQLGetCursorName)(a,b,c,d)

typedef RETCODE  (SQL_API  *TSQLNumResultCols) (HSTMT hstmt , SWORD FAR * pccol);
extern TSQLNumResultCols pSQLNumResultCols;
#define NSQLNumResultCols(a,b) (*pSQLNumResultCols)(a,b)

typedef RETCODE  (SQL_API  *TSQLPrepare) (HSTMT hstmt , UCHAR FAR * szSqlStr , SDWORD cbSqlStr);
extern TSQLPrepare pSQLPrepare;
#define NSQLPrepare(a,b,c) (*pSQLPrepare)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLRowCount) (HSTMT hstmt , SDWORD FAR * pcrow);
extern TSQLRowCount pSQLRowCount;
#define NSQLRowCount(a,b) (*pSQLRowCount)(a,b)

typedef RETCODE  (SQL_API  *TSQLSetCursorName) (HSTMT hstmt , UCHAR FAR * szCursor , SWORD cbCursor);
extern TSQLSetCursorName pSQLSetCursorName;
#define NSQLSetCursorName(a,b,c) (*pSQLSetCursorName)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLTransact) (HENV henv , HDBC hdbc , UWORD fType);
extern TSQLTransact pSQLTransact;
#define NSQLTransact(a,b,c) (*pSQLTransact)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLColumns) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TSQLColumns pSQLColumns;
#define NSQLColumns(a,b,c,d,e,f,g,h,i) (*pSQLColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLDriverConnect) (HDBC hdbc , HWND hwnd , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut , UWORD fDriverCompletion);
extern TSQLDriverConnect pSQLDriverConnect;
#define NSQLDriverConnect(a,b,c,d,e,f,g,h) (*pSQLDriverConnect)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TSQLGetConnectOption) (HDBC hdbc , UWORD fOption , PTR pvParam);
extern TSQLGetConnectOption pSQLGetConnectOption;
#define NSQLGetConnectOption(a,b,c) (*pSQLGetConnectOption)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLGetData) (HSTMT hstmt , UWORD icol , SWORD fCType , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TSQLGetData pSQLGetData;
#define NSQLGetData(a,b,c,d,e,f) (*pSQLGetData)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TSQLGetFunctions) (HDBC hdbc , UWORD fFunction , UWORD FAR * pfExists);
extern TSQLGetFunctions pSQLGetFunctions;
#define NSQLGetFunctions(a,b,c) (*pSQLGetFunctions)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLGetInfo) (HDBC hdbc , UWORD fInfoType , PTR rgbInfoValue , SWORD cbInfoValueMax , SWORD FAR * pcbInfoValue);
extern TSQLGetInfo pSQLGetInfo;
#define NSQLGetInfo(a,b,c,d,e) (*pSQLGetInfo)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TSQLGetStmtOption) (HSTMT hstmt , UWORD fOption , PTR pvParam);
extern TSQLGetStmtOption pSQLGetStmtOption;
#define NSQLGetStmtOption(a,b,c) (*pSQLGetStmtOption)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLGetTypeInfo) (HSTMT hstmt , SWORD fSqlType);
extern TSQLGetTypeInfo pSQLGetTypeInfo;
#define NSQLGetTypeInfo(a,b) (*pSQLGetTypeInfo)(a,b)

typedef RETCODE  (SQL_API  *TSQLParamData) (HSTMT hstmt , PTR FAR * prgbValue);
extern TSQLParamData pSQLParamData;
#define NSQLParamData(a,b) (*pSQLParamData)(a,b)

typedef RETCODE  (SQL_API  *TSQLPutData) (HSTMT hstmt , PTR rgbValue , SDWORD cbValue);
extern TSQLPutData pSQLPutData;
#define NSQLPutData(a,b,c) (*pSQLPutData)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLSetConnectOption) (HDBC hdbc , UWORD fOption , UDWORD vParam);
extern TSQLSetConnectOption pSQLSetConnectOption;
#define NSQLSetConnectOption(a,b,c) (*pSQLSetConnectOption)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLSetStmtOption) (HSTMT hstmt , UWORD fOption , UDWORD vParam);
extern TSQLSetStmtOption pSQLSetStmtOption;
#define NSQLSetStmtOption(a,b,c) (*pSQLSetStmtOption)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLSpecialColumns) (HSTMT hstmt , UWORD fColType , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UWORD fScope , UWORD fNullable);
extern TSQLSpecialColumns pSQLSpecialColumns;
#define NSQLSpecialColumns(a,b,c,d,e,f,g,h,i,j) (*pSQLSpecialColumns)(a,b,c,d,e,f,g,h,i,j)

typedef RETCODE  (SQL_API  *TSQLStatistics) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UWORD fUnique , UWORD fAccuracy);
extern TSQLStatistics pSQLStatistics;
#define NSQLStatistics(a,b,c,d,e,f,g,h,i) (*pSQLStatistics)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLTables) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szTableType , SWORD cbTableType);
extern TSQLTables pSQLTables;
#define NSQLTables(a,b,c,d,e,f,g,h,i) (*pSQLTables)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLBrowseConnect) (HDBC hdbc , UCHAR FAR * szConnStrIn , SWORD cbConnStrIn , UCHAR FAR * szConnStrOut , SWORD cbConnStrOutMax , SWORD FAR * pcbConnStrOut);
extern TSQLBrowseConnect pSQLBrowseConnect;
#define NSQLBrowseConnect(a,b,c,d,e,f) (*pSQLBrowseConnect)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TSQLColumnPrivileges) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TSQLColumnPrivileges pSQLColumnPrivileges;
#define NSQLColumnPrivileges(a,b,c,d,e,f,g,h,i) (*pSQLColumnPrivileges)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLDataSources) (HENV henv , UWORD fDirection , UCHAR FAR * szDSN , SWORD cbDSNMax , SWORD FAR * pcbDSN , UCHAR FAR * szDescription , SWORD cbDescriptionMax , SWORD FAR * pcbDescription);
extern TSQLDataSources pSQLDataSources;
#define NSQLDataSources(a,b,c,d,e,f,g,h) (*pSQLDataSources)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TSQLDescribeParam) (HSTMT hstmt , UWORD ipar , SWORD FAR * pfSqlType , UDWORD FAR * pcbColDef , SWORD FAR * pibScale , SWORD FAR * pfNullable);
extern TSQLDescribeParam pSQLDescribeParam;
#define NSQLDescribeParam(a,b,c,d,e,f) (*pSQLDescribeParam)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TSQLExtendedFetch) (HSTMT hstmt , UWORD fFetchType , SDWORD irow , UDWORD FAR * pcrow , UWORD FAR * rgfRowStatus);
extern TSQLExtendedFetch pSQLExtendedFetch;
#define NSQLExtendedFetch(a,b,c,d,e) (*pSQLExtendedFetch)(a,b,c,d,e)

typedef RETCODE  (SQL_API  *TSQLForeignKeys) (HSTMT hstmt , UCHAR FAR * szPkTableQualifier , SWORD cbPkTableQualifier , UCHAR FAR * szPkTableOwner , SWORD cbPkTableOwner , UCHAR FAR * szPkTableName , SWORD cbPkTableName , UCHAR FAR * szFkTableQualifier , SWORD cbFkTableQualifier , UCHAR FAR * szFkTableOwner , SWORD cbFkTableOwner , UCHAR FAR * szFkTableName , SWORD cbFkTableName);
extern TSQLForeignKeys pSQLForeignKeys;
#define NSQLForeignKeys(a,b,c,d,e,f,g,h,i,j,k,l,m) (*pSQLForeignKeys)(a,b,c,d,e,f,g,h,i,j,k,l,m)

typedef RETCODE  (SQL_API  *TSQLMoreResults) (HSTMT hstmt);
extern TSQLMoreResults pSQLMoreResults;
#define NSQLMoreResults(a) (*pSQLMoreResults)(a)

typedef RETCODE  (SQL_API  *TSQLNativeSql) (HDBC hdbc , UCHAR FAR * szSqlStrIn , SDWORD cbSqlStrIn , UCHAR FAR * szSqlStr , SDWORD cbSqlStrMax , SDWORD FAR * pcbSqlStr);
extern TSQLNativeSql pSQLNativeSql;
#define NSQLNativeSql(a,b,c,d,e,f) (*pSQLNativeSql)(a,b,c,d,e,f)

typedef RETCODE  (SQL_API  *TSQLNumParams) (HSTMT hstmt , SWORD FAR * pcpar);
extern TSQLNumParams pSQLNumParams;
#define NSQLNumParams(a,b) (*pSQLNumParams)(a,b)

typedef RETCODE  (SQL_API  *TSQLParamOptions) (HSTMT hstmt , UDWORD crow , UDWORD FAR * pirow);
extern TSQLParamOptions pSQLParamOptions;
#define NSQLParamOptions(a,b,c) (*pSQLParamOptions)(a,b,c)

typedef RETCODE  (SQL_API  *TSQLPrimaryKeys) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TSQLPrimaryKeys pSQLPrimaryKeys;
#define NSQLPrimaryKeys(a,b,c,d,e,f,g) (*pSQLPrimaryKeys)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TSQLProcedureColumns) (HSTMT hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName , UCHAR FAR * szColumnName , SWORD cbColumnName);
extern TSQLProcedureColumns pSQLProcedureColumns;
#define NSQLProcedureColumns(a,b,c,d,e,f,g,h,i) (*pSQLProcedureColumns)(a,b,c,d,e,f,g,h,i)

typedef RETCODE  (SQL_API  *TSQLProcedures) (HSTMT hstmt , UCHAR FAR * szProcQualifier , SWORD cbProcQualifier , UCHAR FAR * szProcOwner , SWORD cbProcOwner , UCHAR FAR * szProcName , SWORD cbProcName);
extern TSQLProcedures pSQLProcedures;
#define NSQLProcedures(a,b,c,d,e,f,g) (*pSQLProcedures)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TSQLSetPos) (HSTMT hstmt , UWORD irow , UWORD fOption , UWORD fLock);
extern TSQLSetPos pSQLSetPos;
#define NSQLSetPos(a,b,c,d) (*pSQLSetPos)(a,b,c,d)

typedef RETCODE  (SQL_API  *TSQLTablePrivileges) (HSTMT hstmt , UCHAR FAR * szTableQualifier , SWORD cbTableQualifier , UCHAR FAR * szTableOwner , SWORD cbTableOwner , UCHAR FAR * szTableName , SWORD cbTableName);
extern TSQLTablePrivileges pSQLTablePrivileges;
#define NSQLTablePrivileges(a,b,c,d,e,f,g) (*pSQLTablePrivileges)(a,b,c,d,e,f,g)

typedef RETCODE  (SQL_API  *TSQLDrivers) (HENV henv , UWORD fDirection , UCHAR FAR * szDriverDesc , SWORD cbDriverDescMax , SWORD FAR * pcbDriverDesc , UCHAR FAR * szDriverAttributes , SWORD cbDrvrAttrMax , SWORD FAR * pcbDrvrAttr);
extern TSQLDrivers pSQLDrivers;
#define NSQLDrivers(a,b,c,d,e,f,g,h) (*pSQLDrivers)(a,b,c,d,e,f,g,h)

typedef RETCODE  (SQL_API  *TSQLBindParameter) (HSTMT hstmt , UWORD ipar , SWORD fParamType , SWORD fCType , SWORD fSqlType , UDWORD cbColDef , SWORD ibScale , PTR rgbValue , SDWORD cbValueMax , SDWORD FAR * pcbValue);
extern TSQLBindParameter pSQLBindParameter;
#define NSQLBindParameter(a,b,c,d,e,f,g,h,i,j) (*pSQLBindParameter)(a,b,c,d,e,f,g,h,i,j)

#endif
