/*************************************************************************
 *
 *  $RCSfile: oterinc.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//--------------------------------------------------------------------------

#ifndef _SDB_OTERINC_HXX
#define _SDB_OTERINC_HXX 1

#if defined(WIN) || defined(WNT)

// Stub-Version: dynamische Bindung an die DLL zur Laufzeit.
// oterstub definiert die in den Quellen benutzten NSQL...-Methoden
// als indirekte Funktionsaufrufe.
#include <tools/prewin.h>
#include <odbc/sqlext.h>
#include <tools/postwin.h>

#include "oterimp.hxx"

#ifndef SQL_C_BOOKMARK
#define SQL_C_BOOKMARK   SQL_C_ULONG                     /* BOOKMARK         */
#endif


#define SDB_OTER_CHAR UCHAR

#endif

#ifndef __SQLEXT
  #include <odbc/sqlext.h>
#endif

//--------------------------------------------------------------------------

// Wenn nicht im Makefile explizit angegeben:
// herausfinden, ob wir die OTER2-Schnittstelle zur Verfuegung haben ...
// (Achtung: SDB_ODBC2 wird als (1) oder (0) definiert!)
#if !defined(SDB_ODBC2)

// OTER2 kann automatisch erkannt werden:
#if defined(ODBCVER)
#if (ODBCVER >= 0x0200)
#define SDB_ODBC2 (1)
#endif
#endif

// Default: kein OTER2
#if ! defined(SDB_ODBC2)
#define SDB_ODBC2 (0)
#endif

#endif

#if !defined(SDB_ODBC3)

// OTER2 kann automatisch erkannt werden:
#if defined(ODBCVER)
#if (ODBCVER >= 0x0300)
#define SDB_ODBC3 (1)
#endif
#endif

// Default: kein OTER3
#if ! defined(SDB_ODBC3)
#define SDB_ODBC3 (0)
#endif

#endif


// Unter WIN und WNT wird OTER2 vorausgesetzt:
#if defined(WIN) || defined(WNT)
#if ! SDB_ODBC2
#error Unter WIN und WNT wird mindestens ODBC 2.0 benoetigt (setsolar -ODBC2 verwenden)!
#endif
#endif

#endif

