/*************************************************************************
 *
 *  $RCSfile: otertab.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_OTERTAB_HXX
#define _SDB_OTERTAB_HXX 1

// oterinc.hxx ganz am Anfang!
#ifndef _SDB_OTERINC_HXX
#include "oterinc.hxx"
#endif

#ifndef _SDB_SDBTAB_HXX
#include "sdbtab.hxx"
#endif

#ifndef _SDB_OTERSTAT_HXX
#include "oterstat.hxx"
#endif

class SdbOTERCursor;

// Class SdbOTERTable
//
//
class SdbOTERTable : public SdbTable
{
	friend class SdbOTERConnection;
	friend class SdbOTERIndex;

	SdbOTERTable(SdbOTERConnection* pConnection);
	~SdbOTERTable();

	// Interne Hilfsroutinen zur Generierung von CREATE/ALTER TABLE-Statements:
	BOOL GenerateAddCommands(String& rStatement);
	BOOL GenerateColumnCommand(String& rStatement, const SdbColumn& rColumn);

	SdbOTERConnection* GetOTERConnection() const {return (SdbOTERConnection*) GetConnection();}
	BOOL DeletePkeys(SdbOTERConnection* xConnection,const String& aTableName);
	BOOL DeleteAutoNum(const SdbColumn* pRefColumn,SdbOTERConnection* xConnection,const String& aTableName);

protected:
	virtual SdbIndex* CreateIndexImpl();
	virtual void FillIndexNames(SvStringsDtor& _rList);

	virtual BOOL OpenImpl();
	virtual BOOL CreateImpl();
	virtual BOOL RenameImpl(const String& rNewName);
	virtual BOOL DropImpl();
	virtual BOOL AlterImpl();
	virtual void CloseImpl();

protected:
	String aPKeyName;		// Name des Constraint fuer PKeys
};


// Inline-Implementationen:

#endif



