/*************************************************************************
 *
 *  $RCSfile: sdbmd.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_SDBMD_HXX
#define _SDB_SDBMD_HXX

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASELIMIT_HPP_
#include <com/sun/star/data/DatabaseLimit.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif

#ifndef _CPPUHELPER_INTERFACECONTAINER_HXX_
#include <cppuhelper/interfacecontainer.hxx>
#endif

class SdbConnection;
//************************************************************
//   Declaration of interface  SdbMetaData
//************************************************************
class SdbMetaData : public cppu::WeakImplHelper2< ::com::sun::star::data::XDatabaseDescriptor, ::com::sun::star::lang::XComponent>
{
	// Bitte mit pflegen, wenn sich die Anzahl in geLimitsImpl !"andert
	sal_Int32 nLimits[::com::sun::star::data::DatabaseLimit::USER_NAME_LEN+1];
	sal_Int8  nCapas[::com::sun::star::data::DatabaseCapability::TRANSACTIONS+1];
	::com::sun::star::uno::Any aInfos[::com::sun::star::data::DatabaseInfo::USER_NAME+1];

	
	::osl::Mutex m_aMutex;
	::cppu::OInterfaceContainerHelper m_aDisposeListeners;

protected:
	SdbConnection *pCon;

public:
	SdbMetaData(SdbConnection *pConnection);

	// ::com::sun::star::lang::XComponent
    virtual void SAL_CALL dispose(  ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL addEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener >& xListener ) throw(::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL removeEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener >& aListener ) throw(::com::sun::star::uno::RuntimeException);

	// ::com::sun::star::data::XDatabaseDescriptor
private:
    virtual sal_Bool SAL_CALL isCapable( sal_Int16 nCapability ) throw(::com::sun::star::data::DatabaseException, ::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Any SAL_CALL getInfo( sal_Int16 nInfo ) throw(::com::sun::star::data::DatabaseException, ::com::sun::star::uno::RuntimeException);
    virtual sal_Int32 SAL_CALL getLimit( sal_Int16 Limit ) throw(::com::sun::star::data::DatabaseException, ::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL canConvert( sal_Int16 nFrom, sal_Int16 nIn ) throw(::com::sun::star::data::DatabaseException, ::com::sun::star::uno::RuntimeException);

protected:
	virtual sal_Bool isCapableImpl(sal_Int16 nCapability) const = 0;
	virtual ::com::sun::star::uno::Any getInfoImpl(sal_Int16 nInfo) const = 0;
	virtual sal_Int32 getLimitImpl(sal_Int16 nLimit) const = 0;
	virtual sal_Bool canConvertImpl(sal_Int16 nFrom, sal_Int16 nIn) const = 0;
};

#endif // _SDB_SDBMD_HXX

