/*************************************************************************
 *
 *  $RCSfile: sqlcol.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SDB_SQLCOL_HXX
#define SDB_SQLCOL_HXX

#ifndef _SDB_SDBCOL_HXX
#include "sdbcol.hxx"
#endif


//========================================================================
//
// Class SdbSqlColumn
//
// Beschreibung:
//
// Spezialisierung der SdbColumn. Insbesondere geht es um die Methode
// AlterCompare(), welche dazu dient, eine SdbSqlColumn emulationsinvariant
// zu vergleichen.
//
// An einem Beispiel erlutert: der Type SDB_DBTYPE_BOOLEAN wird z.B.
// unter Oracle durch einen Integer (genauer SDB_DBTYPE_TINYINT) emuliert.
// Deswegen darf ein Vergleich zweier Spalten, die sich nur im Typ unterscheiden
// in der Hinsicht, da eine den Typ SDB_DBTYPE_BOOLEAN und die andere den Typ
// SDB_DBTYPE_TINYINT hat, nicht zu einem negativen Ergebnis fuehren.
//
//========================================================================


class SdbSqlColumn:public SdbColumn
{
protected:

	SdbSqlColumn(const String &rNewName, SdbDatabaseType eNewType,
					 UINT32 nNewLength, UINT16 nNewScale,
					 UINT16 nNewFlags, UINT32 nKey)
					 : SdbColumn(rNewName, eNewType, nNewLength, nNewScale, nNewFlags, nKey) {};

	virtual ~SdbSqlColumn() {}

public:



	virtual BOOL AlterCompare(const SdbSqlColumn& rColumn, INT16 nFlagMask) const = 0;
};




#endif // SDB_SQLCOL_HXX


