/*************************************************************************
 *
 *  $RCSfile: sqltab.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef SDB_SQLTAB_HXX
#define SDB_SQLTAB_HXX

#ifndef _SDB_SDBTAB_HXX
#include "sdbtab.hxx"
#endif

//========================================================================
//
// class SdbSqlTable
//
// Beschreibung:
// Diese Klasse fuegt zu SdbTable einige Implementationen hinzu
// (bzgl. CREATE, ALTER etc.) fuer Datenbanken, die eines "vernuenftigen"
// SQL maechtig sind.
//
//========================================================================
class SdbSqlTable : public SdbTable
{
protected:

	// erweitert den uebergebenen String um eine Typbeschreibung der uebergebenen
	// Column (z.B. um "<Column Name> NUMBER(7,7)")
	BOOL AddColumnTypeString(String& rBaseString, const SdbColumn& rColumn);

	String aPKeyName;

	SdbSqlTable(SdbConnection* pConnection);

	virtual ~SdbSqlTable() {}

	virtual BOOL CreateImpl() = 0;

	// Analysiert die Unterschiede zwischen aOriginalColumns und aColumns
	// und bildet diese auf den Table in der DB ab. Dabei werden die
	// nachfolgenden Methoden benutzt
	virtual BOOL AlterImpl();

	//--------------------------------------------------------------------
	// Von AlterImpl() gerufene Methoden

	// Dropt den bisherigen Primary Key Constraint
	virtual BOOL DropPrimaryKey();

	// Erzeugt einen neuen Primary Key Constraint basierend auf aColumns
	virtual BOOL CreatePrimaryKey();

	// soll die uebergebene Column aus dem Table in der DB loeschen
	virtual BOOL DropColumn(const SdbColumn*) = 0;

	// soll die in der Liste uebergebenen Columns dem Table in der DB hinzufuegen
	virtual BOOL AddColumns( const List& AddColList) = 0;

	// soll die Column im DB-Table modifizieren
	virtual BOOL AlterColumn(const SdbColumn* OldColumn,const SdbColumn* NewColumn) = 0;

	//--------------------------------------------------------------------

public:





};




#endif //SDB_SQL_TAB_HXX

