/*************************************************************************
 *
 *  $RCSfile: wrapado.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SDB_WRAPADO_HXX
#define SDB_WRAPADO_HXX

#ifndef SDB_ADOTAB_IMPL
#include "adoimp.hxx"
#endif

#ifndef SDB_WPDAOTMP_HXX
#include "olewrap.hxx"
#endif

class WpADOConnection;
class WpADOCommand;
class WpADORecordset;
class WpADOField;
class WpADOParameter;
class WpADOError;
class WpADOProperty;


DBG_NAMEEX(WpADOConnection);
DBG_NAMEEX(WpADOCommand);
DBG_NAMEEX(WpADOField);
DBG_NAMEEX(WpADOParameter);
DBG_NAMEEX(WpADOError);
DBG_NAMEEX(WpADOProperty);
DBG_NAMEEX(WpADORecordset);

//------------------------------------------------------------------------
class WpADOConnection : public WpOLEBase<ADOConnection>
{
	friend class WpADOCommand;
public:

	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOConnection() {DBG_CTOR(WpADOConnection,NULL);}

	WpADOConnection(ADOConnection* pInt)	:	WpOLEBase<ADOConnection>(pInt){DBG_CTOR(WpADOConnection,NULL);}

	WpADOConnection(const WpADOConnection& rhs){DBG_CTOR(WpADOConnection,NULL);operator=(rhs);}

	inline WpADOConnection& operator=(const WpADOConnection& rhs)
		{WpOLEBase<ADOConnection>::operator=(rhs); return *this;}

	~WpADOConnection() {DBG_DTOR(WpADOConnection,NULL);}
	//////////////////////////////////////////////////////////////////////

	inline ADOProperties* get_Properties() const
	{
		ADOProperties* pProps=NULL;
		pInterface->get_Properties(&pProps);
		return pProps;
	}

	inline rtl::OUString GetConnectionString() const
	{
		BSTR aBSTR; pInterface->get_ConnectionString(&aBSTR);
		rtl::OUString sRetStr((sal_Unicode*)aBSTR);
		SysFreeString(aBSTR); 
		return sRetStr;
	}

	inline BOOL PutConnectionString(const String &aCon) const
	{
		return SUCCEEDED(pInterface->put_ConnectionString(SysAllocString(aCon.GetBuffer())));
	}

	inline INT32 GetCommandTimeout() const
	{
		INT32 nRet;
		pInterface->get_CommandTimeout(&nRet);
		return nRet;
	}

	inline void PutCommandTimeout(INT32 nRet)
	{
		pInterface->put_CommandTimeout(nRet);
	}

	inline INT32 GetConnectionTimeout() const
	{
		INT32 nRet;
		pInterface->get_ConnectionTimeout(&nRet);
		return nRet;
	}

	inline void PutConnectionTimeout(INT32 nRet)
	{
		pInterface->put_ConnectionTimeout(nRet);
	}

	inline BOOL Close( ) 
	{
		return (SUCCEEDED(pInterface->Close()));
	}

	inline BOOL Execute(const String& _CommandText,OLEVariant& RecordsAffected,long Options, WpADORecordset** ppiRset)
	{
		return SUCCEEDED(pInterface->Execute(SysAllocString(_CommandText.GetBuffer()),&RecordsAffected,Options,(_ADORecordset**)ppiRset));
	}

	inline BOOL BeginTrans( long TransactionLevel)
	{
		return SUCCEEDED(pInterface->BeginTrans(&TransactionLevel));
	}

	inline BOOL CommitTrans( ) 
	{
		return SUCCEEDED(pInterface->CommitTrans());
	}

	inline BOOL RollbackTrans( ) 
	{
		return SUCCEEDED(pInterface->RollbackTrans());
	}

	inline BOOL Open(const String& ConnectionString, const String& UserID,const String& Password,long Options)
	{
		return SUCCEEDED(pInterface->Open(SysAllocString(ConnectionString.GetBuffer()),SysAllocString(UserID.GetBuffer()),SysAllocString(Password.GetBuffer()),Options));
	}

	inline BOOL GetErrors(ADOErrors** pErrors)
	{
		return SUCCEEDED(pInterface->get_Errors(pErrors));
	}

	inline String GetDefaultDatabase() const
	{
		BSTR aBSTR; pInterface->get_DefaultDatabase(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline BOOL PutDefaultDatabase(const String& bstr)
	{
		return SUCCEEDED(pInterface->put_DefaultDatabase(SysAllocString(bstr.GetBuffer())));
	}

	inline IsolationLevelEnum get_IsolationLevel() const 
	{
		IsolationLevelEnum eNum;
		pInterface->get_IsolationLevel(&eNum);
		return eNum;
	}

	inline BOOL put_IsolationLevel(const IsolationLevelEnum& eNum) 
	{
		return SUCCEEDED(pInterface->put_IsolationLevel(eNum));
	}

	inline INT32 get_Attributes() const
	{
		INT32 nRet;
		pInterface->get_Attributes(&nRet);
		return nRet;
	}

	inline BOOL put_Attributes(INT32 nRet)
	{
		return SUCCEEDED(pInterface->put_Attributes(nRet));
	}

	inline CursorLocationEnum get_CursorLocation() const
	{
		CursorLocationEnum eNum;
		pInterface->get_CursorLocation(&eNum);
		return eNum;
	}

	inline BOOL put_CursorLocation(const CursorLocationEnum &eNum) 
	{
		return SUCCEEDED(pInterface->put_CursorLocation(eNum));
	}

	inline ConnectModeEnum get_Mode() const
	{
		ConnectModeEnum eNum;
		pInterface->get_Mode(&eNum);
		return eNum;
	}

	inline BOOL put_Mode(const ConnectModeEnum &eNum) 
	{
		
		return SUCCEEDED(pInterface->put_Mode(eNum));
	}

	inline String get_Provider() const
	{
		BSTR aBSTR; pInterface->get_Provider(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline BOOL put_Provider(const String& bstr)
	{
		return SUCCEEDED(pInterface->put_Provider(SysAllocString(bstr.GetBuffer())));
	}

	inline INT32 get_State() const
	{
		INT32 nRet;
		pInterface->get_State(&nRet);
		return nRet;
	}

	inline BOOL OpenSchema(SchemaEnum eNum,OLEVariant& Restrictions,OLEVariant& SchemaID,ADORecordset**pprset)
	{
		return SUCCEEDED(pInterface->OpenSchema(eNum,Restrictions,SchemaID,pprset));
	}

	inline String get_Version() const
	{
		BSTR aBSTR; 
		pInterface->get_Version(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}
};

//------------------------------------------------------------------------
class WpADOCommand : public WpOLEBase<ADOCommand>
{
public:

	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOCommand() {DBG_CTOR(WpADOCommand,NULL);}

	WpADOCommand(ADOCommand* pInt)	:	WpOLEBase<ADOCommand>(pInt){DBG_CTOR(WpADOCommand,NULL);}

	WpADOCommand(const WpADOCommand& rhs){DBG_CTOR(WpADOCommand,NULL);operator=(rhs);}

	inline WpADOCommand& operator=(const WpADOCommand& rhs)
	{
		WpOLEBase<ADOCommand>::operator=(rhs); return *this;}

	~WpADOCommand() {DBG_DTOR(WpADOCommand,NULL);}
	//////////////////////////////////////////////////////////////////////

	BOOL putref_ActiveConnection( WpADOConnection *pCon)
	{
		return SUCCEEDED(pInterface->putref_ActiveConnection(pCon->pInterface));
	}

	void put_ActiveConnection(/* [in] */ const OLEVariant& vConn)
	{
		pInterface->put_ActiveConnection(vConn);
	}

	inline INT32 get_State() const
	{
		INT32 nRet;
		pInterface->get_State(&nRet);
		return nRet;
	}

	inline String get_CommandText() const
	{
		BSTR aBSTR; pInterface->get_CommandText(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline BOOL put_CommandText(const String &aCon) const
	{
		BSTR bstr = SysAllocString(aCon.GetBuffer());
		BOOL bErg = SUCCEEDED(pInterface->put_CommandText(bstr));
		SysFreeString(bstr);
		return bErg;
	}

	inline INT32 get_CommandTimeout() const
	{
		INT32 nRet;
		pInterface->get_CommandTimeout(&nRet);
		return nRet;
	}

	inline void put_CommandTimeout(INT32 nRet)
	{
		pInterface->put_CommandTimeout(nRet);
	}

	inline BOOL get_Prepared() const
	{
		VARIANT_BOOL bPrepared;
		pInterface->get_Prepared(&bPrepared);
		return bPrepared;
	}

	inline BOOL put_Prepared(VARIANT_BOOL bPrepared) const
	{
		return SUCCEEDED(pInterface->put_Prepared(bPrepared));
	}

	inline BOOL Execute(OLEVariant& RecordsAffected,OLEVariant& Parameters,long Options, ADORecordset** ppiRset)
	{
		return SUCCEEDED(pInterface->Execute(&RecordsAffected,&Parameters,Options,ppiRset));
	}

	inline ADOParameter* CreateParameter(const String &bstr,DataTypeEnum Type,ParameterDirectionEnum Direction,long nSize,const OLEVariant &Value)
	{
		ADOParameter* pPara;
		pInterface->CreateParameter(SysAllocString(bstr.GetBuffer()),Type,Direction,nSize,Value,&pPara);
		return pPara;
	}

	inline ADOParameters* get_Parameters() const
	{
		ADOParameters* pPara;
		pInterface->get_Parameters(&pPara);
		return pPara;
	}

	inline BOOL put_CommandType( /* [in] */ CommandTypeEnum lCmdType)
	{
		return SUCCEEDED(pInterface->put_CommandType(lCmdType));
	}

	inline CommandTypeEnum get_CommandType( ) const 
	{
		CommandTypeEnum eNum;
		pInterface->put_CommandType(eNum);
		return eNum;
	}

	// gibt den Namen des Feldes zur"ueck
	inline String GetName() const 
	{
		BSTR aBSTR; pInterface->get_Name(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline BOOL put_Name(const String& _Name)
	{
		return SUCCEEDED(pInterface->put_Name(SysAllocString(_Name.GetBuffer())));
	}
};
//------------------------------------------------------------------------
class WpADOError:public WpOLEBase<ADOError>
{
public:

	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOError() {DBG_CTOR(WpADOError,NULL);}

	WpADOError(ADOError* pInt):WpOLEBase<ADOError>(pInt){DBG_CTOR(WpADOError,NULL);}

	WpADOError(const WpADOError& rhs){DBG_CTOR(WpADOError,NULL);operator=(rhs);}

	inline WpADOError& operator=(const WpADOError& rhs)
		{WpOLEBase<ADOError>::operator=(rhs); return *this;}

	~WpADOError() {DBG_DTOR(WpADOError,NULL);}
	//////////////////////////////////////////////////////////////////////

	inline String GetDescription() const
	{
		BSTR aBSTR; pInterface->get_Description(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline String GetSource() const {BSTR aBSTR; pInterface->get_Source(&aBSTR);
						String sRetStr(aBSTR);
						SysFreeString(aBSTR); return sRetStr;}

	inline INT32 GetNumber() const {INT32 nErrNr; pInterface->get_Number(&nErrNr);
							return nErrNr;}

	inline String GetSQLState() const 
	{ 
		BSTR aBSTR; pInterface->get_SQLState(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline INT32 GetNativeError() const 
	{
		INT32 nErrNr; pInterface->get_NativeError(&nErrNr);
		return nErrNr;
	}
};



//------------------------------------------------------------------------
class WpADOField : public WpOLEBase<ADOField>
{
	friend class WpADOFields;
public:

	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOField() {DBG_CTOR(WpADOField,NULL);}
	WpADOField(ADOField* pInt):WpOLEBase<ADOField>(pInt){DBG_CTOR(WpADOField,NULL);}
	WpADOField(const WpADOField& rhs){DBG_CTOR(WpADOField,NULL); operator=(rhs);}

	inline WpADOField& operator=(const WpADOField& rhs)
		{WpOLEBase<ADOField>::operator=(rhs); return *this;}
	~WpADOField() {  DBG_DTOR(WpADOField,NULL); }
	//////////////////////////////////////////////////////////////////////

	inline ADOProperties* get_Properties()
	{
		ADOProperties* pProps = NULL;
		pInterface->get_Properties(&pProps);
		return pProps;
	}

	inline INT32 GetActualSize() const 
	{
		INT32 nActualSize; pInterface->get_ActualSize(&nActualSize);
		return nActualSize;
	}
	
	inline INT32 GetAttributes() const 
	{
		INT32 eADOSFieldAttributes; pInterface->get_Attributes(&eADOSFieldAttributes);
		return eADOSFieldAttributes;
	}

	inline INT32 GetDefinedSize() const 
	{
		INT32 nDefinedSize; pInterface->get_DefinedSize(&nDefinedSize);
		return nDefinedSize;
	}

	// gibt den Namen des Feldes zur"ueck
	inline String GetName() const 
	{
		BSTR aBSTR; pInterface->get_Name(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline DataTypeEnum GetADOType() const 
	{
		DataTypeEnum eType; pInterface->get_Type(&eType);
		return eType;
	}

	inline SdbDatabaseType GetSdbType() const
	{
		BOOL bUnsigned=FALSE;
		return ADOS::SdbTypeFromADOType(GetADOType(),bUnsigned);
	}

	inline void get_Value(OLEVariant& aValVar) const 
	{
		aValVar.SetEmpty();
		pInterface->get_Value(&aValVar);
	}

	inline OLEVariant get_Value() const
	{
		OLEVariant aValVar;
		pInterface->get_Value(&aValVar);
		return aValVar;
	}

	inline BOOL PutValue(const OLEVariant& aVariant)
	{
		return (SUCCEEDED(pInterface->put_Value(aVariant)));
	}

	inline BYTE GetPrecision() const 
	{
		BYTE eType; pInterface->get_Precision(&eType);
		return eType;
	}

	inline BYTE GetNumericScale() const 
	{
		BYTE eType; pInterface->get_NumericScale(&eType);
		return eType;
	}

	inline BOOL AppendChunk(const OLEVariant& _Variant)
	{
		return (SUCCEEDED(pInterface->AppendChunk(_Variant)));
	}

	inline OLEVariant GetChunk(long Length) const
	{
		OLEVariant aValVar;
		pInterface->GetChunk(Length,&aValVar);
		return aValVar;
	}

	inline void GetChunk(long Length,OLEVariant &aValVar) const
	{
		pInterface->GetChunk(Length,&aValVar);
	}

	inline OLEVariant GetOriginalValue() const
	{
		OLEVariant aValVar;
		pInterface->get_OriginalValue(&aValVar);
		return aValVar;
	}

	inline void GetOriginalValue(OLEVariant &aValVar) const
	{
		pInterface->get_OriginalValue(&aValVar);
	}

	inline OLEVariant GetUnderlyingValue() const
	{
		OLEVariant aValVar;
		pInterface->get_UnderlyingValue(&aValVar);
		return aValVar;
	}

	inline void GetUnderlyingValue(OLEVariant &aValVar) const
	{
		pInterface->get_UnderlyingValue(&aValVar);
	}

	inline BOOL PutPrecision(INT16 _prec)
	{
		return (SUCCEEDED(pInterface->put_Precision(_prec)));
	}

	inline BOOL PutNumericScale(INT16 _prec)
	{
		return (SUCCEEDED(pInterface->put_NumericScale(_prec)));
	}

	inline void PutADOType(DataTypeEnum eType) 
	{
		pInterface->put_Type(eType);
	}

	inline void SetSdbType(SdbDatabaseType eType) 
	{
		BOOL bUnsigned=FALSE;
		DataTypeEnum eDBType = ADOS::ADOTypeFromSdbType(eType,bUnsigned);
		PutADOType(eDBType);
	}

	inline BOOL PutDefinedSize(INT32 _nDefSize)
	{
		return (SUCCEEDED(pInterface->put_DefinedSize(_nDefSize)));
	}

	inline BOOL PutAttributes(INT32 _nDefSize)
	{
		return (SUCCEEDED(pInterface->put_Attributes(_nDefSize)));
	}
};



//------------------------------------------------------------------------
class WpADOProperty: public WpOLEBase<ADOProperty>
{
	friend class WpADOProperties;

public:
	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOProperty() {DBG_CTOR(WpADOProperty,NULL);}
	WpADOProperty(ADOProperty* pInt):WpOLEBase<ADOProperty>(pInt){DBG_CTOR(WpADOProperty,NULL);}
	WpADOProperty(const WpADOProperty& rhs){DBG_CTOR(WpADOProperty,NULL);operator=(rhs);}
	inline WpADOProperty& operator=(const WpADOProperty& rhs)
		{WpOLEBase<ADOProperty>::operator=(rhs); return *this;}
	~WpADOProperty() { DBG_DTOR(WpADOProperty,NULL); }
	//////////////////////////////////////////////////////////////////////

	inline OLEVariant GetValue() const
	{
		OLEVariant aValVar;
		pInterface->get_Value(&aValVar);
		return aValVar;
	}

	inline void GetValue(OLEVariant &aValVar) const
	{
		pInterface->get_Value(&aValVar);
	}

	inline BOOL PutValue(const OLEVariant &aValVar) 
	{
		return (SUCCEEDED(pInterface->put_Value(aValVar)));
	}

	inline String GetName() const 
	{
		BSTR aBSTR; pInterface->get_Name(&aBSTR);
		String sRetStr(aBSTR);
		SysFreeString(aBSTR); return sRetStr;
	}

	inline DataTypeEnum GetADOType() const 
	{
		DataTypeEnum eType; pInterface->get_Type(&eType);
		return eType;
	}

	inline SdbDatabaseType GetSdbType() const
	{
		BOOL bUnsigned=FALSE;
		return ADOS::SdbTypeFromADOType(GetADOType(),bUnsigned);
	}

	inline INT32 GetAttributes() const 
	{
		INT32 eADOSFieldAttributes; pInterface->get_Attributes(&eADOSFieldAttributes);
		return eADOSFieldAttributes;
	}

	inline BOOL PutAttributes(INT32 _nDefSize)
	{
		return (SUCCEEDED(pInterface->put_Attributes(_nDefSize)));
	}
};


class WpADORecordset:public WpOLEBase<ADORecordset>
{

public:
	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADORecordset() {DBG_CTOR(WpADORecordset,NULL);}
	WpADORecordset(ADORecordset* pInt):WpOLEBase<ADORecordset>(pInt){DBG_CTOR(WpADORecordset,NULL);}
	WpADORecordset(const WpADORecordset& rhs){DBG_CTOR(WpADORecordset,NULL);operator=(rhs);}
	inline WpADORecordset& operator=(const WpADORecordset& rhs)
	{
		WpOLEBase<ADORecordset>::operator=(rhs);
		return *this;
	}
	~WpADORecordset() 
	{ 
		if(pInterface && get_State() == adStateOpen)
			Close();
		DBG_DTOR(WpADORecordset,NULL); 
	}
	//////////////////////////////////////////////////////////////////////
	inline void Create()
	{
		IClassFactory2* pIUnknown	= NULL;
		IUnknown        *pOuter		= NULL;
		HRESULT         hr;
		hr = CoGetClassObject( ADOS::CLSID_ADORECORDSET_21,
							  CLSCTX_INPROC_SERVER,
							  NULL,
							  IID_IClassFactory2,
							  (void**)&pIUnknown );
		
		if( !FAILED( hr ) )
		{
			pIUnknown->AddRef();

			ADORecordset *pRec = NULL;
			hr = pIUnknown->CreateInstanceLic(  pOuter,
												NULL,
												ADOS::IID_ADORECORDSET_21,
												ADOS::GetKeyStr(),
												(void**) &pRec);
		
			if( !FAILED( hr ) )
			{
				pInterface = pRec;
				pInterface->AddRef();
			}
			pIUnknown->Release();
		}
	}

	inline BOOL Open( 
            /* [optional][in] */ VARIANT Source,
            /* [optional][in] */ VARIANT ActiveConnection,
            /* [defaultvalue][in] */ CursorTypeEnum CursorType,
            /* [defaultvalue][in] */ LockTypeEnum LockType,
            /* [defaultvalue][in] */ INT32 Options)
	{
		return (SUCCEEDED(pInterface->Open(Source,ActiveConnection,CursorType,LockType,Options)));
	}


	inline LockTypeEnum GetLockType()
	{		
		LockTypeEnum eType;
		pInterface->get_LockType(&eType);		
		return eType;
	}

	inline void Close()
	{
		pInterface->Close();
	}

	inline BOOL Cancel() const
	{
		return (SUCCEEDED(pInterface->Cancel()));
	}

	inline INT32 get_State( )
	{
		INT32 nState = 0;
		pInterface->get_State(&nState);
		return nState;
	}

	inline BOOL Supports( /* [in] */ CursorOptionEnum CursorOptions)
	{
		VARIANT_BOOL bSupports;
		pInterface->Supports(CursorOptions,&bSupports);
		return (BOOL) bSupports;
	}

	inline void GetDataSource(IUnknown** pIUnknown) const 
	{
		pInterface->get_DataSource(pIUnknown);
	}

	inline void PutRefDataSource(IUnknown** pIUnknown)
	{
		pInterface->putref_DataSource(*pIUnknown);
	}

	inline void GetBookmark(VARIANT& var)
	{		
		pInterface->get_Bookmark(&var);		
	}

	inline BOOL SetBookmark(const OLEVariant &pSafeAr)
	{
		return SUCCEEDED(pInterface->put_Bookmark(pSafeAr));
	}


	inline ADOFields* GetFields() const
	{
		ADOFields* pFields;
		pInterface->get_Fields(&pFields);
		return pFields;
	}


	inline BOOL Move(INT32 nRows, VARIANT aBmk)	{return SUCCEEDED(pInterface->Move(nRows, aBmk));}
	inline BOOL MoveNext() {return SUCCEEDED(pInterface->MoveNext());}
	inline BOOL MovePrevious() {return SUCCEEDED(pInterface->MovePrevious());}
	inline BOOL MoveFirst() {return SUCCEEDED(pInterface->MoveFirst());}
	inline BOOL MoveLast()	{return SUCCEEDED(pInterface->MoveLast());}

	inline BOOL IsAtBOF() const
	{
		VARIANT_BOOL bIsAtBOF;
		pInterface->get_BOF(&bIsAtBOF);
		return (BOOL) bIsAtBOF;
	}

	inline BOOL IsAtEOF() const
	{
		VARIANT_BOOL bIsAtEOF;
		pInterface->get_EOF(&bIsAtEOF);
		return (BOOL) bIsAtEOF;
	}

	inline BOOL Delete(AffectEnum eNum)
	{
		return SUCCEEDED(pInterface->Delete(eNum));
	}

	inline BOOL AddNew(const OLEVariant &FieldList,const OLEVariant &Values)
	{
		return SUCCEEDED(pInterface->AddNew(FieldList,Values));
	}

	inline BOOL Update(const OLEVariant &FieldList,const OLEVariant &Values)
	{
		return SUCCEEDED(pInterface->Update(FieldList,Values));
	}

	inline BOOL CancelUpdate()
	{
		return SUCCEEDED(pInterface->CancelUpdate());
	}
};

//------------------------------------------------------------------------
class WpADOParameter:public WpOLEBase<ADOParameter>
{
public:
	// Konstruktoren, operator=
	// diese rufen nur die Oberklasse
	WpADOParameter() {DBG_CTOR(WpADOParameter,NULL);}
	WpADOParameter(ADOParameter* pInt):WpOLEBase<ADOParameter>(pInt){DBG_CTOR(WpADOParameter,NULL);}
	WpADOParameter(const WpADOParameter& rhs):WpOLEBase<ADOParameter>(rhs){DBG_CTOR(WpADOParameter,NULL);}
	inline WpADOParameter& operator=(const WpADOParameter& rhs)
		{WpOLEBase<ADOParameter>::operator=(rhs); return *this;}
	~WpADOParameter() {DBG_DTOR(WpADOParameter,NULL); }
	//////////////////////////////////////////////////////////////////////

	inline String GetName() const {BSTR aBSTR; pInterface->get_Name(&aBSTR);
						String sRetStr(aBSTR);
						SysFreeString(aBSTR); return sRetStr;}

	inline DataTypeEnum GetADOType() const 
	{
		DataTypeEnum eType; pInterface->get_Type(&eType);
		return eType;
	}

	inline SdbDatabaseType GetSdbType() const 
	{
		BOOL bUnsigned=FALSE;
		return ADOS::SdbTypeFromADOType(GetADOType(),bUnsigned);
	}

	inline INT32 GetAttributes() const 
	{
		INT32 eADOSFieldAttributes; pInterface->get_Attributes(&eADOSFieldAttributes);
		return eADOSFieldAttributes;
	}

	inline BYTE GetPrecision() const 
	{
		BYTE eType; pInterface->get_Precision(&eType);
		return eType;
	}

	inline BYTE GetNumericScale() const 
	{
		BYTE eType; pInterface->get_NumericScale(&eType);
		return eType;
	}

	inline ParameterDirectionEnum get_Direction() const
	{
		ParameterDirectionEnum alParmDirection;
		pInterface->get_Direction(&alParmDirection);
		return alParmDirection;
	}
            
	inline void GetValue(OLEVariant& aValVar) const 
	{
		pInterface->get_Value(&aValVar);
	}

	inline OLEVariant GetValue() const
	{
		OLEVariant aValVar;
		pInterface->get_Value(&aValVar);
		return aValVar;
	}

	inline BOOL PutValue(const OLEVariant& aVariant)
	{
		return (SUCCEEDED(pInterface->put_Value(aVariant)));
	}
};

#endif //SDB_WRAPADO_HXX

