/*************************************************************************
 *
 *  $RCSfile: ja_io_pg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_JA_IO_PG_HXX
#include <ja_io_pg.hxx>
#endif
#include <tools/debug.hxx>
//**************************************************************
//************ Class: java.io.InputStream
//**************************************************************

jclass java_io_InputStream::theClass = 0;

java_io_InputStream::~java_io_InputStream()
{}

jclass java_io_InputStream::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/io/InputStream" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_io_InputStream::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

INT32 java_io_InputStream::available()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "()I";
		char * cMethodName = "available";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			out = t.pEnv->CallIntMethod( object, mID);
	} //t.pEnv
	return (INT32)out;
}
// -----------------------------------------------------
INT32 java_io_InputStream::read(BYTE*& pData,INT32 off,INT32 len)
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		jbyteArray pByteArray = t.pEnv->NewByteArray(len);
		char * cSignature = "([BII)I";
		char * cMethodName = "read";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
		{
			while(!(out = t.pEnv->CallIntMethod( object, mID,pByteArray,off,len)))
			{
				if(t.pEnv->ExceptionOccurred())
				{
					t.pEnv->ExceptionDescribe();
					t.pEnv->ExceptionClear();
					break;
				}
			}
			if(out > 0)
			{
				jboolean p = FALSE;
				pData = (BYTE*)t.pEnv->GetByteArrayElements(pByteArray,&p);
/*
				INT32 nBytes = (INT32)t.pEnv->GetArrayLength(pByteArray);
				INT32 nLen = aData.getLen();
				aData.realloc( nLen + nBytes);
				memcpy(aData.getArray() + nLen, pData, nBytes);
*/
			}
		}
		t.pEnv->DeleteLocalRef(pByteArray);
	} //t.pEnv
	return (INT32)out;
}


jclass java_io_ByteArrayInputStream::theClass = 0;

java_io_ByteArrayInputStream::~java_io_ByteArrayInputStream()
{}

jclass java_io_ByteArrayInputStream::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/io/ByteArrayInputStream" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_io_ByteArrayInputStream::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

INT32 java_io_ByteArrayInputStream::available()
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "()I";
		char * cMethodName = "available";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			out = t.pEnv->CallIntMethod( object, mID);
	} //t.pEnv
	return (INT32)out;
}
// -----------------------------------------------------
INT32 java_io_ByteArrayInputStream::read(BYTE *pByte,INT32 off,INT32 len)
{
	jint out(0);
	SDBThreadAttach t; DBG_ASSERT(t.pEnv,"Java Enviroment gelscht worden!");
	if( t.pEnv )
	{
		char * cSignature = "([BII)I";
		char * cMethodName = "read";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID )
			out = t.pEnv->CallIntMethod( object, mID,pByte,off,len);
	} //t.pEnv
	return (INT32)out;
}
