/*************************************************************************
 *
 *  $RCSfile: ja_lg_pg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SDB_JA_LG_OB_HXX
#include <ja_lg_ob.hxx>
#endif

#ifndef _SDB_JA_LG_PG_HXX
#include <ja_lg_pg.hxx>
#endif


// Die Fkt. ConvStr2WStr konvertiert einen String nach UniString (Unicode)
//UniString ConvStr2WStr(const String& aStr){
//	INT32 len = aStr.Len();
//	UniString aWStr("");
//	for(INT32 i=0;i<len;i++){
//		aWStr += aStr.ConvertToUnicode(aStr[(USHORT)i]);
//	}
//	return aWStr;
//}


//**************************************************************
//************ Class: java.lang.String
//**************************************************************

jclass java_lang_String::theClass = 0;

java_lang_String::~java_lang_String()
{}

jclass java_lang_String::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/String"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_String::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_lang_String::java_lang_String( const String& _par0 ): java_lang_Object( NULL, (jobject)NULL ){
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[1];
	// Parameter konvertieren
	::rtl::OString aT = ::rtl::OUStringToOString(_par0,RTL_TEXTENCODING_UTF8);
	args[0].l = t.pEnv->NewString((const unsigned short *)aT.getStr(), aT.getLength());
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(Ljava/lang/String;)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	t.pEnv->DeleteLocalRef((jstring)args[0].l);
	// und aufraeumen
//SDBThreadAttach::removeWSString_glob( (jstring)args[0].l, NULL );
}

/*
//**************************************************************
//************ Class: java.lang.Double
//**************************************************************

jclass java_lang_Double::theClass = 0;

java_lang_Double::~java_lang_Double()
{}

jclass java_lang_Double::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Double"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Double::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_lang_Double::java_lang_Double( double _par0 ): java_lang_Number( NULL, (jobject)NULL ){
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[1];
		// Parameter konvertieren
		args[0].d = Conversion::convertdouble( _par0 );
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(D)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}
*/

//**************************************************************
//************ Class: java.lang.Boolean
//**************************************************************

jclass java_lang_Boolean::theClass = 0;

java_lang_Boolean::~java_lang_Boolean()
{}

jclass java_lang_Boolean::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Boolean"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Boolean::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_lang_Boolean::java_lang_Boolean( BOOL _par0 ): java_lang_Object( NULL, (jobject)NULL ){
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[1];
		// Parameter konvertieren
		args[0].z = _par0;
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(Z)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}

//**************************************************************
//************ Class: java.lang.Class
//**************************************************************

jclass java_lang_Class::theClass = 0;

java_lang_Class::~java_lang_Class()
{}

jclass java_lang_Class::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Class"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Class::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

java_lang_Class * java_lang_Class::forName( const String* _par0 )
{
	jobject out(NULL);
	SDBThreadAttach t;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		::rtl::OString aT;
		if(_par0)
			aT = ::rtl::OUStringToOString(*_par0,RTL_TEXTENCODING_UTF8);
		args[0].l = _par0 ? t.pEnv ->NewString((const unsigned short *)aT.getStr(),aT.getLength()) : 0;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/String;)Ljava/lang/Class;";
		char * cMethodName = "forName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetStaticMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallStaticObjectMethod( getMyClass(), mID, args[0].l );
			// und aufraeumen
			t.pEnv->DeleteLocalRef((jstring)args[0].l);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? NULL : new java_lang_Class( t.pEnv, out );
}

BOOL java_lang_Class::isAssignableFrom( java_lang_Class * _par0 )
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv ){
		jvalue args[1];
		// Parameter konvertieren
		args[0].l = _par0 != NULL ? ((java_lang_Object *)_par0)->getJavaObject() : NULL;
		// temporaere Variable initialisieren
		char * cSignature = "(Ljava/lang/Class;)Z";
		char * cMethodName = "isAssignableFrom";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID, args[0].l );
			// und aufraeumen
		} //mID
	} //t.pEnv
	return out;
}

java_lang_Object * java_lang_Class::newInstance()
{
	jobject out(NULL);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/Object;";
		char * cMethodName = "newInstance";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? NULL : new java_lang_Object( t.pEnv, out );
}

String java_lang_Class::getName()
{
	jstring out = (jstring)NULL;
	SDBThreadAttach t;
	String aStr;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getName";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			jboolean bCopy(FALSE);
			const char* pChar = t.pEnv->GetStringUTFChars(out,&bCopy);
			aStr = String(pChar,RTL_TEXTENCODING_UTF8);
			if(bCopy)
				t.pEnv->DeleteLocalRef(out);
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}
//**************************************************************
//************ Class: java.lang.Number
//**************************************************************
jclass java_lang_Number::theClass = 0;

java_lang_Number::~java_lang_Number()
{}

jclass java_lang_Number::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Number"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Number::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

//**************************************************************
//************ Class: java.lang.Throwable
//**************************************************************

jclass java_lang_Throwable::theClass = 0;

java_lang_Throwable::~java_lang_Throwable()
{}

jclass java_lang_Throwable::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Throwable"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Throwable::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

String java_lang_Throwable::getMessage()
{
	String aStr;
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getMessage";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			jstring out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);

				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				t.pEnv->ReleaseStringChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}

String java_lang_Throwable::getLocalizedMessage()
{
	String aStr;
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "getLocalizedMessage";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			jstring out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);

				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				t.pEnv->ReleaseStringChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}
String java_lang_Throwable::toString()
{
	String aStr;
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/String;";
		char * cMethodName = "toString";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			jstring out = (jstring)t.pEnv->CallObjectMethod( object, mID);
			if(out){
				jboolean bCopy(FALSE);
				const jchar* pChar = t.pEnv->GetStringChars(out,&bCopy);
				jsize len = t.pEnv->GetStringLength(out);

				aStr = String(pChar,RTL_TEXTENCODING_UTF8);

				t.pEnv->ReleaseStringChars(out,pChar);
				//if(bCopy)
				t.pEnv->DeleteLocalRef(out);
			}
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return aStr;
}
//**************************************************************
//************ Class: java.lang.Exception
//**************************************************************

jclass java_lang_Exception::theClass = 0;

java_lang_Exception::~java_lang_Exception()
{}

jclass java_lang_Exception::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass("java/lang/Exception"); DBG_ASSERT(tempClass,"Java : FindClass nicht erfolgreich!");
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_lang_Exception::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}
