/*************************************************************************
 *
 *  $RCSfile: ja_ut_pg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_JA_UT_PG_HXX
#include <ja_ut_pg.hxx>
#endif


//**************************************************************
//************ Class: java.util.Date
//**************************************************************

jclass java_util_Date::theClass = 0;

java_util_Date::java_util_Date( INT32 _par0, INT32 _par1, INT32 _par2 ) //: java_lang_Object( NULL, (jobject)NULL ){
{
	SDBThreadAttach t;
	if( !t.pEnv )
		return;
	jvalue args[3];
		// Parameter konvertieren
		args[0].i = (INT32)_par0;
		args[1].i = (INT32)_par1;
		args[2].i = (INT32)_par2;
	// Java-Call fuer den Konstruktor absetzen
	// temporaere Variable initialisieren
	char * cSignature = "(III)V";
	jobject tempObj;
	jmethodID mID = t.pEnv->GetMethodID( getMyClass(), "<init>", cSignature );
	tempObj = t.pEnv->NewObjectA( getMyClass(), mID, args );
	saveRef( t.pEnv, tempObj );
	t.pEnv->DeleteLocalRef( tempObj );
	// und aufraeumen
}

java_util_Date::~java_util_Date()
{}

jclass java_util_Date::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/util/Date" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_util_Date::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

INT32 java_util_Date::getMinutes()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMinutes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_util_Date::getMonth()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getMonth";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_util_Date::getSeconds()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getSeconds";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_util_Date::getYear()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getYear";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_util_Date::getDate()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getDate";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

INT32 java_util_Date::getHours()
{
	jint out(0);
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "()I";
		char * cMethodName = "getHours";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallIntMethod( object, mID);
		} //mID
	} //t.pEnv
	return (INT32)out;
}

void java_util_Date::setSeconds( INT32 _par0 )
{
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setSeconds";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_util_Date::setMinutes( INT32 _par0 )
{
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setMinutes";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

void java_util_Date::setHours( INT32 _par0 )
{
	SDBThreadAttach t;
	if( t.pEnv ){
		// temporaere Variable initialisieren
		char * cSignature = "(I)V";
		char * cMethodName = "setHours";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			t.pEnv->CallVoidMethod( object, mID, _par0 );
			// und aufraeumen
		} //mID
	} //t.pEnv
}

//**************************************************************
//************ Class: java.util.Enumeration
//**************************************************************

jclass java_util_Enumeration::theClass = 0;

java_util_Enumeration::~java_util_Enumeration()
{}

jclass java_util_Enumeration::getMyClass()
{
	// die Klasse muss nur einmal geholt werden, daher statisch
	if( !theClass ){
		SDBThreadAttach t;
		if( !t.pEnv ) return (jclass)NULL;
		jclass tempClass = t.pEnv->FindClass( "java/util/Enumeration" );
		jclass globClass = (jclass)t.pEnv->NewGlobalRef( tempClass );
		t.pEnv->DeleteLocalRef( tempClass );
		saveClassRef( globClass );
	}
	return theClass;
}

void java_util_Enumeration::saveClassRef( jclass pClass )
{
	if( SDBThreadAttach::IsJavaErrorOccured() || pClass==NULL  )
		return;
	// der uebergebe Klassen-Handle ist schon global, daher einfach speichern
	theClass = pClass;
}

BOOL java_util_Enumeration::hasMoreElements()
{
	jboolean out;
	SDBThreadAttach t;
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "()Z";
		char * cMethodName = "hasMoreElements";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallBooleanMethod( object, mID);
		} //mID
	} //t.pEnv
	return out;
}

java_lang_Object * java_util_Enumeration::nextElement()
{
	jobject out = (jobject)NULL;
	SDBThreadAttach t;
	if( t.pEnv )
	{
		// temporaere Variable initialisieren
		char * cSignature = "()Ljava/lang/Object;";
		char * cMethodName = "nextElement";
		// Java-Call absetzen
		jmethodID mID = t.pEnv->GetMethodID( getMyClass(), cMethodName, cSignature );
		if( mID ){
			out = t.pEnv->CallObjectMethod( object, mID );
		} //mID
	} //t.pEnv
	// ACHTUNG: der Aufrufer wird Eigentuemer des zurueckgelieferten Zeigers !!!
	return out==0 ? NULL : new java_lang_Object( t.pEnv, out );
}

