/*************************************************************************
 *
 *  $RCSfile: jdbcconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "sdbmap.hxx"

#ifndef _SDB_JDBCCONN_HXX
#include <jdbcconn.hxx>
#endif

#ifndef _SDB_JDBCCURS_HXX
#include <jdbccurs.hxx>
#endif

#ifndef _SDB_JDBCTAB_HXX
#include <jdbctab.hxx>
#endif

#ifndef _SDB_SDBREL_HXX
#include <sdbrel.hxx>
#endif

#ifndef _SDB_ODBCINC_HXX
#include <odbc2inc.hxx>
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _SDB_JDBCMD_HXX
#include <jdbcmd.hxx>
#endif

// statt des bool.h aus den JDK wird das bool.h aus der STL included
#ifndef  __SGI_STL_BOOL_H
#define  __SGI_STL_BOOL_H
#define __SGI_STL_BOOL_H_HACK
#endif

#ifndef _SDB_JA_SQ_PG_HXX
#include <ja_sq_pg.hxx>
#endif

#ifndef _SDB_JA_LG_PG_HXX
#include <ja_lg_pg.hxx>
#endif

#ifdef __SGI_STL_BOOL_H_HACK
#undef __SGI_STL_BOOL_H
#undef __SGI_STL_BOOL_H_HACK
#endif

#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif


namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

#include <sdbresid.hrc>

// friend Funktion von SdbJDBCConnection und SdbJDBCCursor
/*
	SdbDatabaseType javaTyp2SdbTyp(INT32 typ)
	wandelt Java Typen in SdbDatabaseType's um
*/

SdbDatabaseType javaTyp2SdbTyp(INT32 typ)
{
	SdbDatabaseType aTyp;
	switch(typ)
	{
		case SdbJDBCConnection::BIT:
			aTyp = SDB_DBTYPE_BOOLEAN;
			break;
		case SdbJDBCConnection::TINYINT:
			aTyp = SDB_DBTYPE_TINYINT;
			break;
		case SdbJDBCConnection::SMALLINT:
			aTyp = SDB_DBTYPE_SMALLINT;
			break;
		case SdbJDBCConnection::INTEGER:
			aTyp = SDB_DBTYPE_INTEGER;
			break;
// XXX hack da wir zur Zeit keinen Typ BIGINT unterstuetzen
		case SdbJDBCConnection::BIGINT:
			aTyp = SDB_DBTYPE_BIGINT;
			break;
		case SdbJDBCConnection::REAL:
			aTyp = SDB_DBTYPE_REAL;
			break;
		case SdbJDBCConnection::FLOAT:
		case SdbJDBCConnection::DOUBLE:
			aTyp = SDB_DBTYPE_DOUBLE;
			break;
		case SdbJDBCConnection::NUMERIC:
			aTyp = SDB_DBTYPE_NUMERIC;
			break;
		case SdbJDBCConnection::DECIMAL:
			aTyp = SDB_DBTYPE_DECIMAL;
			break;
		case SdbJDBCConnection::JCHAR:
			aTyp = SDB_DBTYPE_CHAR;
			break;
		case SdbJDBCConnection::VARCHAR:
			aTyp = SDB_DBTYPE_VARCHAR;
			break;
		case SdbJDBCConnection::LONGVARCHAR:
			aTyp = SDB_DBTYPE_LONGVARCHAR;
			break;
		case SdbJDBCConnection::DATE:
		case 9:	// siehe header
			aTyp = SDB_DBTYPE_DATE;
			break;
		case SdbJDBCConnection::TIME:
		case 10:	// siehe header
			aTyp = SDB_DBTYPE_TIME;
			break;
		case SdbJDBCConnection::TIMESTAMP:
		case 11:	// siehe header
			aTyp = SDB_DBTYPE_TIMESTAMP;
			break;
		case SdbJDBCConnection::BINARY:
			aTyp = SDB_DBTYPE_BINARY;
			break;
		case SdbJDBCConnection::VARBINARY:
			aTyp = SDB_DBTYPE_VARBINARY;
			break;
		case SdbJDBCConnection::LONGVARBINARY:
			aTyp = SDB_DBTYPE_LONGVARBINARY;
			break;
		case SdbJDBCConnection::JNULL:
			aTyp = SDB_DBTYPE_BOOLEAN;
			break;
		case SdbJDBCConnection::OTHER:
		default:
			aTyp = SDB_DBTYPE_UNKNOWN;
	}
	return aTyp;
}

INT32 sdbTyp2JavaTyp(SdbDatabaseType eType)
{
	INT32 nType;
	switch(eType)
	{
		case SDB_DBTYPE_BOOLEAN:
			nType = SdbJDBCConnection::BIT;
			break;
		case SDB_DBTYPE_TINYINT:
			nType = SdbJDBCConnection::TINYINT;
			break;
		case SDB_DBTYPE_SMALLINT:
			nType = SdbJDBCConnection::SMALLINT;
			break;
		case SDB_DBTYPE_BOOKMARK:
		case SDB_DBTYPE_INTEGER:
			nType = SdbJDBCConnection::INTEGER;
			break;
		case SDB_DBTYPE_BIGINT:
			nType = SdbJDBCConnection::BIGINT;
			break;
		case SDB_DBTYPE_REAL:
			nType = SdbJDBCConnection::REAL;
			break;
#ifndef TF_ONE51
		case SDB_DBTYPE_FLOAT:
#endif
		case SDB_DBTYPE_DOUBLE:
			nType = SdbJDBCConnection::DOUBLE;
			break;
		case SDB_DBTYPE_NUMERIC:
		case SDB_DBTYPE_CURRENCY:
			nType = SdbJDBCConnection::NUMERIC;
			break;
		case SDB_DBTYPE_DECIMAL:
			nType = SdbJDBCConnection::DECIMAL;
			break;
		case SDB_DBTYPE_CHAR:
			nType = SdbJDBCConnection::JCHAR;
			break;
		case SDB_DBTYPE_VARCHAR:
			nType = SdbJDBCConnection::VARCHAR;
			break;
		case SDB_DBTYPE_LONGVARCHAR:
			nType = SdbJDBCConnection::LONGVARCHAR;
			break;
		case SDB_DBTYPE_DATE:
			nType = SdbJDBCConnection::DATE;
			break;
		case SDB_DBTYPE_TIME:
			nType = SdbJDBCConnection::TIME;
			break;
		case SDB_DBTYPE_TIMESTAMP:
			nType = SdbJDBCConnection::TIMESTAMP;
			break;
		case SDB_DBTYPE_BINARY:
			nType = SdbJDBCConnection::BINARY;
			break;
		case SDB_DBTYPE_VARBINARY:
			nType = SdbJDBCConnection::VARBINARY;
			break;
		case SDB_DBTYPE_LONGVARBINARY:
			nType = SdbJDBCConnection::LONGVARBINARY;
			break;
		case SDB_DBTYPE_UNKNOWN:
		default:
			nType = SdbJDBCConnection::OTHER;
			break;
	}
	return nType;
}
DBG_NAME(SdbJDBCConnection);
//-----------------------------------------------------------------------------
SdbJDBCConnection::SdbJDBCConnection(SdbEnvironment* pEnv, const String& rNewOptions)
			 : SdbConnection(pEnv, rNewOptions),
			 pCon(0),
			 pDbMeta(0),
			 nActStmt(0),
			 nMaxStmt(0),
			 nUseCatalog(0),
			 nUseSchema(0)
{
	DBG_CTOR(SdbJDBCConnection,NULL);
}
//-----------------------------------------------------------------------------
// Copy CTOR nur fuer den internen Gebrauch
SdbJDBCConnection::SdbJDBCConnection(const SdbJDBCConnection& rConn)
				  :SdbConnection(rConn.GetEnvironment(),rConn.Options()),
				  pCon(0),
				  pDbMeta(0),
				  nActStmt(0),
				  nMaxStmt(0),
				  nUseCatalog(0),
				  nUseSchema(0)
{
	DBG_CTOR(SdbJDBCConnection,NULL);
}
//-----------------------------------------------------------------------------
SdbJDBCConnection::~SdbJDBCConnection()
{
	DBG_DTOR(SdbJDBCConnection,NULL);
	if(pCon)
		delete pCon;
	if(pDbMeta)
		delete pDbMeta;
}
//-----------------------------------------------------------------------------
// TypInformation fuellen
void SdbJDBCConnection::FillTypeList(SdbTypeInfoList& _rList)
{

	java_sql_ResultSet *pRs	= pDbMeta->getTypeInfo();
	SdbJDBCCursor::SetStatus(aStatus, pCon);

	if(!pRs || !aStatus.IsSuccessful())
	{
		aStatus.Set(SDB_STAT_ERROR,String(),String(SdbResId(STR_STAT_NO_DATABASE_TYPES)),0,String());
		return;
	}

	while(pRs->next() && aStatus.IsSuccessful())
	{// Konstanten sind dem HelpFile der java.sql.* entnommen
		SdbTypeInfo *pTypeInfo		= new SdbTypeInfo();
		String aTypeName			= pRs->getString(1/*"TYPE_NAME"*/);
		aTypeName.EraseTrailingChars();
		pTypeInfo->aTypeName		= aTypeName;
		
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		INT8 nJavaType = (INT8)pRs->getInt(2/*"DATA_TYPE"*/);
		pTypeInfo->eType			= javaTyp2SdbTyp(nJavaType);
#if SUPD < 532
		pTypeInfo->nMinimumScale	= nJavaType;
#endif
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		pTypeInfo->nPrecision		= pRs->getInt(3/*"PRECISION"*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->aLiteralPrefix = pRs->getString(4);// LITERAL_PREFIX
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->aLiteralSuffix = pRs->getString(5);// LITERAL_SUFFIX
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->aCreateParams = pRs->getString(6/* CREATE_PARAMS*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->bNullable		= (BYTE)pRs->getShort(7/*"NULLABLE"*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		switch(pRs->getShort(9/*"SEARCHABLE"*/))
		{
		case 0:
			pTypeInfo->eSearchType	= Search_None;
			break;
		case 1:
			pTypeInfo->eSearchType	= Search_Like_Only;
			break;
		case 2:
			pTypeInfo->eSearchType	= Search_Except_Like;
			break;
		case 3:
			pTypeInfo->eSearchType	= Search_All;
			break;
		};
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		BOOL bCur(pRs->getBoolean(11/*"FIXED_PREC_SCALE"*/));
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->bCurrency = bCur;
		//pTypeInfo->eType = (bCur) ? SDB_DBTYPE_CURRENCY : pTypeInfo->eType;

		pTypeInfo->bAutoIncrement	= pRs->getBoolean(12/*"AUTO_INCREMENT"*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		pTypeInfo->nMinimumScale	= (BYTE)pRs->getShort(14/*"MINIMUM_SCALE"*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		pTypeInfo->nScale			= (BYTE)pRs->getShort(15/*"MAXIMUM_SCALE"*/);
		SdbJDBCCursor::SetStatus(aStatus, pCon);

		_rList.Insert(pTypeInfo, LIST_APPEND);
	}
	delete pRs;//Freigabe mu erfolgen da meist nur ein Cursor erlaubt ist
	SdbJDBCCursor::SetStatus(aStatus, pCon);

	// wir brauchen schon ein paar Typinformationen um zuarbeiten
	if(_rList.Count() && aStatus.IsSuccessful())
	{
	}
	else if(aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR,String(),String(SdbResId(STR_STAT_NO_DATABASE_TYPES)),0,String());
}
//-----------------------------------------------------------------------------
void SdbJDBCConnection::FillTableNames(SdbStringStlMap* _pList)
{
	SdbJDBCCursor *pCursor = (SdbJDBCCursor*)CreateCursor();
	pCursor->AddRef();
	// Tabletypes
	String aTableType; aTableType.AssignAscii("TABLE;VIEW;ALIAS;SYNONYM");
	String aTabPat('%');
	String *aSchemaPat = 0;
	if(nUseSchema)
		aSchemaPat = new String('%');
	for (xub_StrLen i = 0; i < 4; i++)
	{
		BOOL bView = i != 1;
		pCursor->OpenTables(0,aSchemaPat,&aTabPat,aTableType.GetToken(i,';'));

		BOOL bCatAtStart = FALSE;
		if(pDbMeta)
			bCatAtStart = pDbMeta->isCatalogAtStart(); // hack
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		if(aStatus.IsSuccessful())
		{
			String aNewName;
			while(pCursor->IsInRange())
			{
				ODbRow& rRow = *pCursor->GetRow();
				ODbVariantRef pVal;
				aNewName.Erase();
				if(nUseCatalog & bCatAtStart)
				{
					pVal = rRow[TABLE_CAT];
					if (pVal.is() && !pVal->isNull())
					{
						aNewName += pVal->getString().getStr();
						aNewName.EraseTrailingChars();
						aNewName += cQualifierSeparator;
					}
				}
				if(nUseSchema)
				{
					pVal = rRow[TABLE_SCHEM];
					if (pVal.is() && !pVal->isNull())
					{
						aNewName += pVal->getString().getStr();
						aNewName.EraseTrailingChars();
						aNewName += '.';
					}
				}
				pVal = rRow[TABLE_NAME];
				if(pVal.is() && !pVal->isNull())
					aNewName += pVal->getString().getStr();
				aNewName.EraseTrailingChars();

				(*_pList)[aNewName] = bView; // Typ festlegen
				pCursor->Next();
			}
		}
		pCursor->Close();
	}
	delete aSchemaPat;
	pCursor->ReleaseRef();
}

//-----------------------------------------------------------------------------
void SdbJDBCConnection::CommitImpl()
{
	if(pCon)
		pCon->commit();
}
//-----------------------------------------------------------------------------
	// ROLLBACK ausfuehren
void SdbJDBCConnection::RollbackImpl()
{
	if(pCon)
		pCon->rollback();
	SdbJDBCCursor::SetStatus(aStatus, pCon);
}
//-----------------------------------------------------------------------------
	// Verbindung aufbauen
BOOL SdbJDBCConnection::OpenImpl()
{
	SDBThreadAttach t;
	if(!t.pEnv) // Existiert berhaupt ein JAVA Environment
	{
		String aTxt(SdbResId(STR_STAT_VIRTUAL_MACHINE_DOWN));
		aStatus.Set(SDB_STAT_ERROR,
							String::CreateFromAscii("S1000"),
							aStatus.CreateErrorMessage(aTxt),
							0, String() );
		return FALSE;
	}

	// XXXXX
	// Klassen werden sonst nicht gefunden
	java_sql_SQLException::getMyClass();
	java_lang_Throwable::getMyClass();


	//Datenbanktreiber wird ueber einen Klassennamen erzeugt
	String aFiTmpstr(aOptionsParser.OptionString(String::CreateFromAscii("JDBCDRV")));
	java_lang_Class *pDrvClass = java_lang_Class::forName(&aFiTmpstr);
	SdbJDBCCursor::SetStatus(aStatus, pCon);
	if(!pDrvClass && aStatus.IsSuccessful())
	{
		String aTxt(SdbResId(STR_STAT_DRIVER_CLASS_NOT_FOUND));
		aTxt.SearchAndReplace(String::CreateFromAscii("%1"),aFiTmpstr);
		aStatus.Set(SDB_STAT_ERROR,
							String::CreateFromAscii("S1000"),
							aStatus.CreateErrorMessage(aTxt),
							0, String() );
		return FALSE;
	}
	else if(!pDrvClass)
		return FALSE;

	delete pDrvClass; // brauchen wir hier nicht mehr

	String pwd(aOptionsParser.OptionString(String::CreateFromAscii("PWD")));
	aUserName = aOptionsParser.OptionString(String::CreateFromAscii("UID"));
	String aTmpUrl(aOptionsParser.OptionString(String::CreateFromAscii("URL")));


	java_sql_DriverManager::setLoginTimeout(GetEnvironment()->GetLoginTimeOut());

	pCon = java_sql_DriverManager::getConnection(&aTmpUrl,&aUserName,&pwd);
	SdbJDBCCursor::SetStatus(aStatus, pCon);
	if(!pCon && aStatus.IsSuccessful())
	{
		String aError(SdbResId(STR_STAT_CONN_FAILED));
		aStatus.Set(SDB_STAT_ERROR,String::CreateFromAscii("S1000"),aError,0,String());
		return FALSE;
	}
	else if(!pCon)
		return FALSE;

	pDbMeta = pCon->getMetaData();
	SdbJDBCCursor::SetStatus(aStatus, pCon);
	if(!pDbMeta  && aStatus.IsSuccessful())
	{
		aStatus.Set(SDB_STAT_ERROR);
		return FALSE;
	}
	else if(!pDbMeta)
		return FALSE;

	nMaxStmt = pDbMeta->getMaxStatements();
	SdbJDBCCursor::SetStatus(aStatus, pCon);

	if(aStatus.IsSuccessful() && !pDbMeta->usesLocalFiles())
	{
		//nUseCatalog = pDbMeta->supportsCatalogsInDataManipulation();
		// Catalog
		if(pDbMeta->supportsCatalogsInDataManipulation())
			nUseCatalog  |= ::stardata::DatabaseQualifier::IN_DML;

		if(pDbMeta->supportsCatalogsInIndexDefinitions())
			nUseCatalog  |= ::stardata::DatabaseQualifier::IN_INDEX;

		if(pDbMeta->supportsCatalogsInTableDefinitions())
			nUseCatalog  = ::stardata::DatabaseQualifier::IN_TABLE;

		if(pDbMeta->supportsCatalogsInProcedureCalls())
			nUseCatalog  |= ::stardata::DatabaseQualifier::IN_PROCEDURE;

		if(pDbMeta->supportsCatalogsInPrivilegeDefinitions())
			nUseCatalog  |= ::stardata::DatabaseQualifier::IN_PRIVILEGE;
		// Schemata
		if(pDbMeta->supportsSchemasInDataManipulation())
			nUseSchema  = ::stardata::DatabaseQualifier::IN_DML;

		if(pDbMeta->supportsSchemasInIndexDefinitions())
			nUseSchema  |= ::stardata::DatabaseQualifier::IN_INDEX;

		if(pDbMeta->supportsSchemasInTableDefinitions())
			nUseSchema  |= ::stardata::DatabaseQualifier::IN_TABLE;

		if(pDbMeta->supportsSchemasInProcedureCalls())
			nUseSchema  |= ::stardata::DatabaseQualifier::IN_PROCEDURE;

		if(pDbMeta->supportsSchemasInPrivilegeDefinitions())
			nUseSchema  |= ::stardata::DatabaseQualifier::IN_PRIVILEGE;
	}

	if ((nUseCatalog &  ::stardata::DatabaseQualifier::IN_DML) ==  ::stardata::DatabaseQualifier::IN_DML)
	{
		cQualifierSeparator = pDbMeta->getCatalogSeparator().GetChar(0);
		SdbJDBCCursor::SetStatus(aStatus, pCon);
	}

	String aIdentQuote(pDbMeta->getIdentifierQuoteString());
	SdbJDBCCursor::SetStatus(aStatus, pCon);
	aIdentQuote.EraseLeadingChars(' ');
	cIdentifierQuotation = aIdentQuote.GetChar(0);
	aQualifierName = pCon->getCatalog();
	SdbJDBCCursor::SetStatus(aStatus, pCon);

	// hack um festzustellen ob der Qualifierusage auch gerechtfertigt ist
	bOpen = TRUE;
	SdbJDBCCursor* pCursor = (SdbJDBCCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	String aTabPat('%');
	pCursor->OpenTables(NULL,NULL,&aTabPat,String(String::CreateFromAscii("TABLE")));
	/*      Reihenfolge
		1       TABLE_QUALIFIER
		2       TABLE_OWNER
		3       TABLE_NAME
	 */
	if(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		ODbVariantRef pVal;
		if ((nUseCatalog &  ::stardata::DatabaseQualifier::IN_DML) ==  ::stardata::DatabaseQualifier::IN_DML)
		{
			pVal = rRow[1];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nUseCatalog = 0;
			if (!pDbMeta->getCatalogTerm().Len())
				nUseCatalog = 0;
			SdbJDBCCursor::SetStatus(aStatus, pCon);
			// es gibt JDBC-Informix-Treiber, die keine Kataloge unterstuetzen, das aber nicht richtig sagen,
			// fuer die brauchen wir die Abfrage des Catalog-Terms (62216)
		}
		if ((nUseSchema &  ::stardata::DatabaseQualifier::IN_DML) ==  ::stardata::DatabaseQualifier::IN_DML)
		{
			pVal = rRow[2];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nUseSchema = 0;
		}
	}
	pCursor->ReleaseRef();

	if(!nUseCatalog)
		aQualifierName = String();

	aSpecialCharStr = pDbMeta->getExtraNameCharacters();
	SdbJDBCCursor::SetStatus(aStatus, pCon);

	if(aIdentQuote.Len())
	{
		if (pDbMeta->storesUpperCaseQuotedIdentifiers())
			eIdentifierCase = SDB_IC_UPPER;
		else
		{
			if(pDbMeta->storesLowerCaseQuotedIdentifiers())
				eIdentifierCase = SDB_IC_LOWER;
			else
			{
				
				if(pDbMeta->storesMixedCaseQuotedIdentifiers())
					eIdentifierCase = SDB_IC_MIXED;
				else
					eIdentifierCase = SDB_IC_ALL;
			}
		}
	}
	else
	{
		if (pDbMeta->storesUpperCaseIdentifiers())
			eIdentifierCase = SDB_IC_UPPER;
		else
		{
			if(pDbMeta->storesLowerCaseIdentifiers())
				eIdentifierCase = SDB_IC_LOWER;

			SdbJDBCCursor::SetStatus(aStatus, pCon);
			if(pDbMeta->storesMixedCaseQuotedIdentifiers())
				eIdentifierCase = SDB_IC_MIXED;
			else
			{
				if(pDbMeta->storesMixedCaseIdentifiers())
					eIdentifierCase = SDB_IC_MIXED;
				else
					eIdentifierCase = SDB_IC_ALL;
			}
		}
	}

	SdbJDBCCursor::SetStatus(aStatus, pCon);
	if(pTableNames)
		delete pTableNames;
	pTableNames = new SdbStringStlMap(::utl::UStringMixLess(eIdentifierCase & SDB_IC_OBJECT ? true : false));
	return TRUE;
}
//-----------------------------------------------------------------------------
	// Verbindung schliessen
BOOL SdbJDBCConnection::CloseImpl()
{
	if(!pCon->isClosed())
	{
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		pCon->close();
	}
	SdbJDBCCursor::SetStatus(aStatus, pCon);
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
	// Tabellenobject erstellen
SdbTable*  SdbJDBCConnection::CreateTableImpl()
{
	return new SdbJDBCTable(this);
}

//==================================================================
// Ableitung nur fr das Erzeugen und Refresh, fuer eigenes file
// zu geringfgig
//==================================================================
class SdbJDBCRelation : public SdbRelation
{
	friend class SdbJDBCConnection;

protected:
	SdbJDBCRelation(SdbConnection* _pConn, const String& _rName):SdbRelation(_pConn, _rName){}

	virtual BOOL DoRefresh();
	void SetName(const String& _rName) {aName = _rName;}
};

//------------------------------------------------------------------
BOOL SdbJDBCRelation::DoRefresh()
{
	SDB_CHK_OPEN_BOOL();
	SDB_CHK_CONNECT_BOOL();

	// den Namen merken, da sich dieser durchaus geaendert haben kann
	if (!((SdbJDBCConnection*)pConnection)->FillRelation(*this))
		aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}


//-----------------------------------------------------------------------------
SdbRelation* SdbJDBCConnection::CreateRelationImpl(const String& _rName)
{
	return new SdbJDBCRelation(this,_rName);
}
//-----------------------------------------------------------------------------
	// Cursor erstellen
SdbCursor* SdbJDBCConnection::CreateCursorImpl(SdbCursorType eType,UINT16 nOptions)
{
	SdbJDBCCursor* pCursor = new SdbJDBCCursor(this, eType, nOptions);
	if(pCursor)
		nActStmt++;
	return pCursor;
}
//-----------------------------------------------------------------------------
void SdbJDBCConnection::SetIsolationLevelImpl(SdbIsolationLevel eNewIsolationLevel)
{
	long nValue;
	switch (eNewIsolationLevel)
	{
		case SDB_ISO_READ_UNCOMMITTED:
			nValue = java_sql_Connection::TRANSACTION_READ_UNCOMMITTED;
			break;
		case SDB_ISO_READ_COMMITTED:
			nValue = java_sql_Connection::TRANSACTION_READ_COMMITTED;
			break;
		case SDB_ISO_REPEATABLE_READ:
			nValue = java_sql_Connection::TRANSACTION_REPEATABLE_READ;
			break;
		case SDB_ISO_SERIALIZABLE:
			nValue = java_sql_Connection::TRANSACTION_SERIALIZABLE;
			break;
		default:
			nValue = java_sql_Connection::TRANSACTION_NONE;
			break;
	}

	if(pCon)
	{
		pCon->setTransactionIsolation(nValue);
		SdbJDBCCursor::SetStatus(aStatus, pCon);
		eIsolationLevel = eNewIsolationLevel;
	}
	else
		aStatus.Set(SDB_STAT_ERROR);
}
//------------------------------------------------------------------
BOOL SdbJDBCConnection::FillRelation(SdbJDBCRelation& rRel)
{
	// aktualisieren einer Relation
	SDB_CHK_OPEN_BOOL();

	SdbTableRef xTable( OpenTable(rRel.GetTableName()) ),
				xForeignTable;
	if (xTable)
		xForeignTable = OpenTable(rRel.GetForeignTableName());
	if (xForeignTable)
	{
		SdbCursor* pCursor = OpenRelationCursor(xTable->QualifierName(), xTable->OwnerName(), xTable->Name());
		if (!pCursor)
			aStatus.SetError(ERRCODE_IO_NOTEXISTS,RELATION,rRel.GetName());
		else
		{
			pCursor->AddRef();
			SdbTableRef	   xRefTable;
			String aConstraintName;
			while (pCursor->IsInRange())
			{
				ODbRow& rRow = *pCursor->GetRow();
				// Auswerten der KeySeq
				ODbVariantRef pVal = rRow[9];
				if (!pVal.is() || pVal->isNull())	// ohne Name geht nichts
					break;

				if (pVal->getINT16() == 1){	// gibt es eine neue Relation
					if (xRefTable.Is())			// Relation bereits ausgelesen
						break;

					ODbVariantRef pVal = rRow[12];
					if (!pVal.is() || pVal->isNull())	// ohne Name einen generieren
						aConstraintName = SdbRelation::CreateTempName();
					else
						aConstraintName = pVal->getString().getStr();

					String aRefTableName;
					String aTableName;
					// Zugriff auf referenzierte Tabelle
					if (nUseCatalog)
					{
						pVal = rRow[1];
						if (pVal.is() && !pVal->isNull())
						{
							aRefTableName	+= pVal->getString().getStr();
							aRefTableName	+= cQualifierSeparator;
							aTableName		+= xTable->QualifierName();
							aTableName		+= cQualifierSeparator;
						}
					}
					if (nUseSchema)
					{
						pVal = rRow[2];
						if (pVal.is() && !pVal->isNull())
						{
							aRefTableName	+= pVal->getString().getStr();
							aRefTableName	+= '.';
							aTableName		+= xTable->OwnerName();
							aTableName		+= '.';
						}
					}
					pVal = rRow[3];
					if (pVal.is() && !pVal->isNull())
					{
						aRefTableName		+= pVal->getString().getStr();
						aTableName			+= xTable->Name();
					}

					xRefTable = OpenTable(aRefTableName);
					// Tabelle gefunden
					if (&xRefTable == &xForeignTable)
					{
						rRel.SetName(aConstraintName);
						// jetzt noch die Attributierungen
						UINT16 nAttributes(0),
							   nODBCAttributes(0);

						// Update rules
						pVal = rRow[10];
						if (pVal.is() && !pVal->isNull())
						{
							nODBCAttributes = pVal->getINT16();

							if (nODBCAttributes & SQL_CASCADE)
								nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
							else if (nODBCAttributes & SQL_RESTRICT)
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
							else if (nODBCAttributes & SQL_SET_NULL)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
#if SDB_ODBC3
							else if (nODBCAttributes & SQL_SET_DEFAULT)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
#endif
							else
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
						}
						rRel.SetUpdateRules(nAttributes);
						nAttributes = 0;


						// Delete rules
						pVal = rRow[11];
						nODBCAttributes = 0;
						if (pVal.is() && !pVal->isNull())
						{
							nODBCAttributes = pVal->getINT16();

							if (nODBCAttributes & SQL_CASCADE)
								nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
							else if (nODBCAttributes & SQL_RESTRICT)
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
							else if (nODBCAttributes & SQL_SET_NULL)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
#if SDB_ODBC3
							else if (nODBCAttributes & SQL_SET_DEFAULT)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
#endif
							else
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
						}
						rRel.SetDeleteRules(nAttributes);
					}
					else
						xRefTable = 0;
				}

				if (xRefTable.Is())
				{
					const SdbColumn* pColumn = 0;
					pVal = rRow[8];
					if (pVal.is() && !pVal->isNull())
						pColumn = xTable->OriginalColumns()->Column(pVal->getString().getStr());

					String aForeignName;
					pVal = rRow[4];
					if (pVal.is() && !pVal->isNull())
						aForeignName = pVal->getString().getStr();

					if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName))
					{
						SdbColumnRelation* pRelColumn = rRel.CreateColumn(*pColumn, aForeignName);
						rRel.GetColumns()->AddColumn(pRelColumn);
					}
					else
					{
						// falsche struktur
						aStatus.Set(SDB_STAT_ERROR);
						break;
					}
				}
				pCursor->Next();
			}
			pCursor->ReleaseRef();
		}
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
SdbCursor* SdbJDBCConnection::OpenRelationCursor(const String& rCatalog, const String& rSchema, const String& rName)
{
	SdbJDBCCursor* pCursor = (SdbJDBCCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);

	String* pQualifier = NULL;
	String* pOwner = NULL;

	if(nUseCatalog && (bool)rCatalog.Len())
		pQualifier = new String(rCatalog);
	if(nUseSchema && (bool)rSchema.Len())
		pOwner = new String(rSchema);

	String *pStr = rName.Len() ? new String(rName) : NULL;
	pCursor->OpenForeignKeys(NULL, NULL, NULL, pQualifier, pOwner, pStr);
	delete pStr;
	delete pOwner;
	delete pQualifier;
	// Spaltennamen
/*		1 	PKTABLE_CAT
		2	PKTABLE_SCHEM
		3	PKTABLE_NAME
		4	PKCOLUMN_NAME
		5 	FKTABLE_CAT
		6 	FKTABLE_SCHEM
		7 	FKTABLE_NAME
		8 	FKCOLUMN_NAME
		9 	KEY_SEQ
		10 	UPDATE_RULE
		11 	DELETE_RULE
		12 	FK_NAME			// constraint name
		13  PK_NAME
		14  DEFERRABILITY
*/
	if (!pCursor->IsInRange())
	{
		pCursor->AddRef();
		pCursor->ReleaseRef();
		pCursor = 0;
	}
	return pCursor;
}

//------------------------------------------------------------------
void SdbJDBCConnection::FillRelations(SdbRelationList& _rList, const String& rName)
{
	String sCatalog, sSchema, sName;
	if (rName.Len() && !QualifiedNameComponents(rName, sCatalog, sSchema, sName))
		return;

	SdbCursor* pCursor = OpenRelationCursor(sCatalog, sSchema, sName);
	if (!pCursor)
		return;

	pCursor->AddRef();

	SdbRelationRef	xRelation;
	SdbTableRef		xRefTable;
	SdbTableRef		xTable;

	while (pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		// Auswerten der KeySeq
		ODbVariantRef pVal = rRow[9];
		if (!pVal.is() || pVal->isNull())	// ohne Name geht nichts
		{
			DBG_ERROR("SdbJDBCConnection::FillRelations : unexpected : noe key sequence entry for relation record !");
			pCursor->Next();
			continue;
		}

		if (pVal->getINT16() == 1)	// es ist das erste Feld in einer neuen Relation
		{
			// die alte noch abspeichern
			if (xRelation.Is())
			{
				((SdbJDBCRelation*)&xRelation)->Open(); // nur das open flag setzen
				_rList.InsertAt(xRelation->GetName(), &xRelation);
				xRelation = 0;
			}

			String aConstraintName;
			ODbVariantRef pVal = rRow[12];
			ODbVariantRef pPrimVal = NULL;
			ODbVariantRef pForeignVal = NULL;
			if (!pVal.is() || pVal->isNull())	// ohne Name einen generieren
				aConstraintName = SdbRelation::CreateTempName();
			else
				aConstraintName = pVal->getString().getStr();

			// zusammenstoepseln der (qualifizierten) Tabellennamen
			String aRefTableName;
			String aTableName;
			// Katalog
			if ((nUseCatalog &  ::stardata::DatabaseQualifier::IN_DML) ==  ::stardata::DatabaseQualifier::IN_DML)
			{
				pPrimVal = rRow[1];
				pForeignVal = rRow[5];
				if (pPrimVal.is() && !pPrimVal->isNull())
				{
					aRefTableName += pPrimVal->getString().getStr();
					aRefTableName += cQualifierSeparator;
				}
				if (pForeignVal.is() && !pForeignVal->isNull())
				{
					aTableName += pForeignVal->getString().getStr();
					aTableName += cQualifierSeparator;
				}
			}
			// Schema
			if ((nUseSchema &  ::stardata::DatabaseQualifier::IN_DML) ==  ::stardata::DatabaseQualifier::IN_DML)
			{
				pPrimVal = rRow[2];
				pForeignVal = rRow[6];
				if (pPrimVal.is() && !pPrimVal->isNull())
				{
					aRefTableName += pPrimVal->getString().getStr();
					aRefTableName += '.';
				}
				if (pForeignVal.is() && !pForeignVal->isNull())
				{
					aTableName += pForeignVal->getString().getStr();
					aTableName += '.';
				}
			}
			// Name
			pPrimVal = rRow[3];
			pForeignVal = rRow[7];
			if (pPrimVal.is() && !pPrimVal->isNull())
				aRefTableName += pPrimVal->getString().getStr();
			if (pForeignVal.is() && !pForeignVal->isNull())
				aTableName += pForeignVal->getString().getStr();

			// testen, ob die Tabelle zugreifbar ist
			xRelation = 0;
			xRefTable = OpenTable(aRefTableName);
			if (xRefTable.Is())
				xTable = OpenTable(aTableName);
			if (xRefTable.Is() && xTable.Is())
				xRelation = new SdbJDBCRelation(this, aConstraintName);

			if (!xRelation.Is())
			{
				xRefTable = 0;
				xRelation = 0;
			}
			else
			{
				xRelation->SetTableName(aTableName);
				xRelation->SetForeignTableName(aRefTableName);

				// jetzt noch die Attributierungen
				UINT16 nAttributes = 0,
					nODBCAttributes = 0;

				// Update rules
				pVal = rRow[10];
				if (pVal.is() && !pVal->isNull())
				{
					nODBCAttributes = pVal->getINT16();

					if (nODBCAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nODBCAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nODBCAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
#if SDB_ODBC3
					else if (nODBCAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
#endif
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetUpdateRules(nAttributes);
				nAttributes = 0;



				// Delete rules
				pVal = rRow[11];
				nODBCAttributes = 0;
				if (pVal.is() && !pVal->isNull())
				{
					nODBCAttributes = pVal->getINT16();
					if (nODBCAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nODBCAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nODBCAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
#if SDB_ODBC3
					else if (nODBCAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
#endif
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetDeleteRules(nAttributes);
			}
		}

		if (xRelation.Is())
		{
			ODbVariantRef pForeignVal = rRow[8];
			ODbVariantRef pPrimaryVal = rRow[4];

			// FK-Spalte in der referenzierenden Tabelle
			const SdbColumn* pForeignColumn = 0;
			if (pForeignVal.is() && !pForeignVal->isNull())
				pForeignColumn = xTable->OriginalColumns()->Column(pForeignVal->getString().getStr());

			// PK-Spalte in der referenzierten Tabelle
			const SdbColumn* pPrimaryColumn = 0;
			if (pPrimaryVal.is() && !pPrimaryVal->isNull())
				pPrimaryColumn = xRefTable->OriginalColumns()->Column(pPrimaryVal->getString().getStr());

			if (pForeignColumn && pPrimaryColumn)
			{
				SdbColumnRelation* pRelColumn = xRelation->CreateColumn(*pForeignColumn, pPrimaryColumn->GetName());
				xRelation->GetColumns()->AddColumn(pRelColumn);
			}
			else
			{
				_rList.RemoveAt(xRelation->GetName());
				((SdbJDBCRelation*)&xRelation)->RemoveFromParent();
				xRelation = 0;
			}
		}
		pCursor->Next();
	}
	if(xRelation.Is())
	{
		((SdbJDBCRelation*)&xRelation)->Open(); // nur das open flag setzen
		_rList.InsertAt(xRelation->GetName(), &xRelation);
	}

	pCursor->ReleaseRef();
}

//-----------------------------------------------------------------------------
void SdbJDBCConnection::FillAllRelations(SdbRelationList& _rList)
{
	FillRelations(_rList, String());
}

//-----------------------------------------------------------------------------
::stardata::XDatabaseDescriptor* SdbJDBCConnection::GetMetaDataImpl()
{
	SdbJDBCMetaData* pMetaData = new SdbJDBCMetaData(this);
	return pMetaData;
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCConnection::IsCapableImpl(SdbCapability eCapability) const
{
	if(!pCon || !pDbMeta)
		return FALSE;

	SdbStatus aStatus; // lokal
	BOOL bResult(FALSE);
	switch(eCapability)
	{
		case SDB_CAP_MULTITHREADACCESS:
#ifdef OS2
			bResult = FALSE;
#else
			bResult = TRUE;
#endif
			break;
		case SDB_CAP_CREATE_TABLE:			// Tabellen erzeugen
		case SDB_CAP_RENAME_TABLE:
		case SDB_CAP_UPDATABLE:
			bResult = !pCon->isReadOnly();
			break;
		case SDB_CAP_READ_UNCOMMITTED:
			bResult = pDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_READ_UNCOMMITTED);
			break;
		case SDB_CAP_READ_COMMITTED:
			bResult = pDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_READ_COMMITTED);
			break;
		case SDB_CAP_REPEATABLE_READ:
			bResult = pDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_REPEATABLE_READ);
			break;
		case SDB_CAP_SERIALIZABLE:
			bResult = pDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_SERIALIZABLE);
			break;
		case SDB_CAP_COMMIT_AUTO:
		case SDB_CAP_COMMIT_MANUAL:
			bResult = pDbMeta->supportsTransactions();
			break;

		case SDB_CAP_JOIN:
			bResult = pDbMeta->supportsOuterJoins();
			break;
		case SDB_CAP_FOREIGNKEYS:
			bResult = pDbMeta->supportsIntegrityEnhancementFacility();
			break;
		case SDB_CAP_PRIMARYKEYS:
		case SDB_CAP_CREATE_INDEX:
			bResult = pDbMeta->supportsANSI92EntryLevelSQL();
			break;
		case SDB_CAP_ALTER_TABLE:
			bResult = pDbMeta->supportsAlterTableWithAddColumn() &
					  pDbMeta->supportsAlterTableWithDropColumn();
			break;
		case SDB_CAP_DESC_INDEX:
			bResult = TRUE;
			break;
		case SDB_CAP_CREATE_VIEW:
			{
			java_sql_ResultSet *pRs = pDbMeta->getTableTypes();
			SdbJDBCCursor::SetStatus(aStatus, pCon);
			while(pRs->next() && bResult == FALSE && aStatus.IsSuccessful())
			{
				SdbJDBCCursor::SetStatus(aStatus, pCon);
				if(pRs->getString(1/*"TABLE_TYPE"*/).EqualsIgnoreCaseAscii("VIEW"))
					bResult = TRUE;
				SdbJDBCCursor::SetStatus(aStatus, pCon);
			}
			delete pRs;
			}break;
		case SDB_CAP_BULKOPTIMIZE:
			bResult = TRUE;
			break;
	}

	SdbJDBCCursor::SetStatus(aStatus, pCon);
	return bResult && aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
void SdbJDBCConnection::SetAutoCommit(BOOL bAuto)
{
	if(pCon)
		pCon->setAutoCommit(bAuto);
	SdbJDBCCursor::SetStatus(aStatus, pCon);
}
//-----------------------------------------------------------------------------
java_sql_Connection* SdbJDBCConnection::GetJAVAConnection() const
{
	return pCon;
}
//-----------------------------------------------------------------------------
java_sql_DatabaseMetaData* SdbJDBCConnection::GetJAVADatabaseMetaData() const
{
	return pDbMeta;
}
//-----------------------------------------------------------------------------
String SdbJDBCConnection::ServerNames(SdbStatus& rStat, SdbEnvironment* pEnv)
{
	String stemp;
	java_util_Enumeration *pEnum;
	for(pEnum = java_sql_DriverManager::getDrivers();pEnum->hasMoreElements();)
	{
		SdbStatus aStatus;
		SdbJDBCCursor::SetStatus(aStatus, NULL);
		java_lang_Object *pObj = pEnum->nextElement();
		SdbJDBCCursor::SetStatus(aStatus, NULL);
		java_lang_Class *pCl = pObj->getClass();
		SdbJDBCCursor::SetStatus(aStatus, NULL);
		delete pObj;
		stemp += String(pCl->getName());
		SdbJDBCCursor::SetStatus(aStatus, NULL);
		stemp += ';';
		delete pCl;
	}
	delete pEnum;
	return stemp;
}
//-----------------------------------------------------------------------------
void SdbJDBCConnection::RemoveChild(SdbObj* _pChild)
{
	SdbJDBCCursor* pCursor = (SdbJDBCCursor*)PTR_CAST(SdbCursor,_pChild);
	if(pCursor)
		nActStmt--;
	SdbConnection::RemoveChild(_pChild);
}
//-----------------------------------------------------------------------------
