/*************************************************************************
 *
 *  $RCSfile: jdbccurs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_JDBCCURS_HXX
#include <jdbccurs.hxx>
#endif

#ifndef _SDB_JA_MA_PG_HXX
#include <ja_ma_pg.hxx>
#endif

#ifndef _SDB_JA_SQ_PG_HXX
#include <ja_sq_pg.hxx>
#endif

#ifndef _SDB_JDBCCONN_HXX
#include <jdbcconn.hxx>
#endif

#ifndef _SVT_SDBPARSE_HXX
#include <svtools/sdbparse.hxx>
#endif

#include "sdbresid.hrc"

#ifndef _SDB_TYPECONV_HXX
#include <typeconv.hxx>
#endif

#ifndef _DATE_HXX //autogen
#include <tools/date.hxx>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

DBG_NAME(SdbJDBCCursor);
//-------------------------------------------------------------------------------------------
SdbJDBCCursor::SdbJDBCCursor(SdbConnection* pConnection,SdbCursorType eType,UINT16 nOptions)
		: SdbCursor(pConnection,eType,nOptions)
		,pRs(0),
		pStatem(0),
		pPreStatem(0),
		pCallableStatem(0),
		pConnect(0),
		bOwnCon(FALSE),
		nRows(0),
		nMaxRowsOld(nMaxRows),
		nMaxFieldLenOld(nMaxFieldLen)
{
	DBG_CTOR(SdbJDBCCursor,NULL);

	aStatus.SetComponent(String::CreateFromAscii("Sdb JDBC Driver"));
#ifdef OS2
	bIsCancelable = FALSE;
#else
	bIsCancelable = TRUE;
#endif // SUPD>531 || PRIV_DEBUG

	SdbJDBCConnection* pCon = (SdbJDBCConnection*)GetConnection();
	if (!pCon->HasFreeStatement())
	{
		String pwd(pCon->GetOptionsParser().OptionString(String::CreateFromAscii("PWD")));
		String aSecTmpStr(pCon->GetOptionsParser().OptionString(String::CreateFromAscii("UID")));
		String aTmpUrl(pCon->GetOptionsParser().OptionString(String::CreateFromAscii("URL")));

		pConnect = java_sql_DriverManager::getConnection(&aTmpUrl,&aSecTmpStr,&pwd);
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if(pConnect)
			bOwnCon = TRUE;
		else
			aStatus.Set(SDB_STAT_ERROR,String(),String(SdbResId(STR_STAT_NO_MORE_CONNECTIONS_ALLOWED)),0,String());
	}
	else
		pConnect = pCon->pCon;
	if(!pConnect)
		aStatus.Set(SDB_STAT_ERROR,String(),String(SdbResId(STR_STAT_NO_MORE_CONNECTIONS_ALLOWED)),0,String());
}
//-----------------------------------------------------------------------------
SdbJDBCCursor::~SdbJDBCCursor()
{
	DELETEZ(pRs);
	DELETEZ(pStatem);
	DELETEZ(pPreStatem);
	DELETEZ(pCallableStatem);
	if(bOwnCon)
		DELETEZ(pConnect);
	DBG_DTOR(SdbJDBCCursor,NULL);
}

//-----------------------------------------------------------------------------
void SdbJDBCCursor::RemovingFromParent()
{
	DBG_ASSERT(!IsOpen(), "SdbJDBCCursor::RemovingFromParent : expected to be called _after_ Close !");

	DELETEZ(pRs);
	DELETEZ(pStatem);
	DELETEZ(pPreStatem);
	DELETEZ(pCallableStatem);
	if(bOwnCon)
		DELETEZ(pConnect);
}

//-----------------------------------------------------------------------------
void SdbJDBCCursor::SetStatus(SdbStatus& aStatus,java_sql_Connection* _pConn)
{
	SDBThreadAttach t;
	jthrowable jThrow = NULL;
	if(t.pEnv && (jThrow = t.pEnv->ExceptionOccurred()))
	{
		if(aStatus.IsSuccessful()) // nur einmal einen Fehler setzen
		{
			if(t.pEnv->IsInstanceOf(jThrow,java_sql_SQLException::getMyClass()))
			{
				java_sql_SQLException *pThrow = new java_sql_SQLException(t.pEnv,jThrow);
				String sMessage = pThrow->getMessage();
				String sException = pThrow->toString();
				if (!sMessage.Len())
					(sMessage = String(SdbResId(STR_STAT_EXCEPTION_OCCURED))) += sException;
				aStatus.Set(SDB_STAT_ERROR,String(pThrow->getLocalizedMessage()), sMessage, 0, sException);
				delete pThrow;
			}
			else if(t.pEnv->IsInstanceOf(jThrow,java_lang_Throwable::getMyClass()))
			{
				java_lang_Throwable *pThrow = new java_lang_Throwable(t.pEnv,jThrow);
				aStatus.Set(SDB_STAT_ERROR,String(pThrow->getLocalizedMessage()),pThrow->getMessage(),0,pThrow->toString());
				delete pThrow;
			}
		}
		t.pEnv->ExceptionClear();
	}
	else if(_pConn)
	{
		java_sql_SQLWarning * pSql = _pConn->getWarnings();
		if(pSql)
		{
			String sMessage = pSql->getMessage();
			String sException = pSql->toString();
			if (!sMessage.Len())
				(sMessage = String(SdbResId(STR_STAT_EXCEPTION_OCCURED))) += sException;
			aStatus.Set(SDB_STAT_ERROR,String(pSql->getLocalizedMessage()), sMessage, 0, sException);
		}
	}
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::CancelExecution()
{
	if(pStatem)
		pStatem->cancel();

	if(pPreStatem)
		pPreStatem->cancel();

	if (pCallableStatem)
		pCallableStatem->cancel();

	SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	DELETEZ(pRs);
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::PrepareImpl()
{
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(GetConnection()->GetMetaData());
	sal_Int16 nInfo;	
	rMetaData->getInfo(::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT) >>= nInfo;;
	BOOL bInnerJoin = (nInfo & ::stardata::DatabaseOuterJoinSupport::YES || nInfo & ::stardata::DatabaseOuterJoinSupport::PARTIAL);
	// Statement vorbereiten
	Translate(bInnerJoin);
	if(! aStatus.IsSuccessful())
		return FALSE;

	DELETEZ(pCallableStatem);
	DELETEZ(pPreStatem);
	DELETEZ(pStatem);// Falls vorhanden werden sie geloescht
	// neues Prepared Statement erzeugen  Bei Umstellung auf String kann auf ConvStr2WStr
	// verzichtet werden
	String aFiTempStr(aSQLStatement);
	if(pConnect)
	{
		if (SQLParseNode() && SQLParseNode()->Count() == 3 && SDB_ISRULE(SQLParseNode()->GetChild(1),odbc_call_spec))
		{
			pCallableStatem = pConnect->prepareCall(&aFiTempStr);
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			if(!pCallableStatem || !aStatus.IsSuccessful())
			{
				//aStatus.Set(SDB_STAT_ERROR);
				return FALSE;
			}
			if(nMaxFieldLen != nMaxFieldLenOld)
			{
				pCallableStatem->setMaxFieldSize(nMaxFieldLen);
				nMaxFieldLen = nMaxFieldLenOld;
			}
			if(nMaxRows != nMaxRowsOld)
			{
				pCallableStatem->setMaxRows(nMaxRows);
				nMaxRows  = nMaxRowsOld;
				SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			}
		}
		else
		{
			pPreStatem = pConnect->prepareStatement(&aFiTempStr);
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			if(!pPreStatem || !aStatus.IsSuccessful())
			{
				//aStatus.Set(SDB_STAT_ERROR);
				return FALSE;
			}
			if(nMaxFieldLen != nMaxFieldLenOld)
			{
				pPreStatem->setMaxFieldSize(nMaxFieldLen);
				nMaxFieldLen = nMaxFieldLenOld;
				SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			}

			if(nMaxRows != nMaxRowsOld)
			{
				pPreStatem->setMaxRows(nMaxRows);
				nMaxRows  = nMaxRowsOld;
				SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			}
		}
	}
	else
		return FALSE;

	if(aParameterColumns->Count() < 2)// <2 wegen BOOKMARK ist in jeder Column vorhanden
		DescribeParameter();

	SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::IsSelectStatement()
{
	BOOL bRes = FALSE;
	if(aSQLStatement.GetToken(0,' ').EqualsIgnoreCaseAscii("select"))
		bRes = TRUE;
	return bRes;
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::OpenImpl(SdbCursorType eType ,UINT16 eOpt)
{
	// OpenImpl fuehrt die SQL Anweisung aus
	DELETEZ(pRs);
	BOOL err(FALSE);
	nRows = 0;
	if(IsPrepared())
	{
		if(pPreStatem)
		{
			FillPreStatement(); // PreparedStatement fllen
			if(IsSelectStatement())
			{
				BEGIN_CANCELABLE();
				pRs = pPreStatem->executeQuery();
				END_CANCELABLE();
			}
			else
			{
				BEGIN_CANCELABLE();
				nRows = pPreStatem->executeUpdate();
				END_CANCELABLE();
			}
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		}
		else if(pCallableStatem)
		{
			FillCallStatement();
			if(IsSelectStatement())
			{
				BEGIN_CANCELABLE();
				pRs = pCallableStatem->executeQuery();
				END_CANCELABLE();
			}
			else
			{
				BEGIN_CANCELABLE();
				nRows = pCallableStatem->executeUpdate();
				END_CANCELABLE();
			}
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

			if(aStatus.IsSuccessful() && !FillParameterRow())
				SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		}
		else
			aStatus.Set(SDB_STAT_ERROR,String(),String(SdbResId(STR_STAT_STATEMENT_WAS_DELETED)),0,String());
	}
	else
	{
		::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData(GetConnection()->GetMetaData());
		sal_Int16 nInfo;	
		rMetaData->getInfo(::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT) >>= nInfo;;
	
		BOOL bInnerJoin = (nInfo & ::stardata::DatabaseOuterJoinSupport::YES || nInfo & ::stardata::DatabaseOuterJoinSupport::PARTIAL);
		Translate(bInnerJoin);
		if (! aStatus.IsSuccessful())
			return FALSE;
		if(pStatem)
			DELETEZ(pStatem);
		if(((SdbJDBCConnection*)GetConnection())->GetJAVAConnection())
		{
			pStatem = ((SdbJDBCConnection*)GetConnection())->GetJAVAConnection()->createStatement();
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

			String aFiTmpStr(aSQLStatement);
			if(pStatem && aStatus.IsSuccessful())
			{
				if(nMaxFieldLen != nMaxFieldLenOld)
				{
					pStatem->setMaxFieldSize(nMaxFieldLen);
					nMaxFieldLen = nMaxFieldLenOld;
					SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
				}
				if(nMaxRows != nMaxRowsOld && aStatus.IsSuccessful())
				{
					pStatem->setMaxRows(nMaxRows);
					nMaxRows  = nMaxRowsOld;
					SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
				}

				BEGIN_CANCELABLE();
				BOOL bHasResultSet = pStatem->execute(&aFiTmpStr);
				END_CANCELABLE();
				SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
					// damit unten das SetStatus mir nicht wieder alles kaputt macht, denn die Exception am Environment wurde
					// durch dieses hier schon geloescht
				if (aStatus.IsSuccessful())
				{
					if(bHasResultSet) // ResultSet vorhanden
						pRs = pStatem->getResultSet();
					else
						nRows = pStatem->getUpdateCount();
					SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
				}
			}
		}
	}
#ifdef OS2
	bThreadSafe = FALSE; // JDBC unter OS2 nicht threadsafe und sonst noch nicht abgest"urzt
#endif
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::CloseImpl()
{
	if(pStatem)
		pStatem->close();
	if(pPreStatem)
		pPreStatem->close();
	SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	DELETEZ(pRs);
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------

BOOL SdbJDBCCursor::MoveImpl(SdbCursorPosition eCursorPosition, INT32 nOffset,SdbCursorMode& rMode)
{
	if(eCursorPosition != SDB_POS_NEXT)
	{
		aStatus.SetDriverNotCapableError();
		return FALSE;
	}

	if(pRs && !pRs->next())
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		aStatus.Set(SDB_STAT_NO_DATA_FOUND);
		return FALSE;
	}
	if(FillResultRow())
		rMode = SDB_MOD_NONE;
	else if(aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::DescribeResult()
{
	if(!pRs || aResultColumns->Count() > 1)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	java_sql_ResultSetMetaData *pRsM = pRs->getMetaData();
	SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	if(pRsM && aStatus.IsSuccessful())
	{
		DescribeColumns(aResultColumns,pRsM->getColumnCount(),pRsM);
		DELETEZ(pRsM);
	}
	else
		aStatus.SetDriverNotCapableError();

}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::DescribeParameter()
{
	aStatus.Clear();
	SdbCursor::DescribeParameter();
}

// in jdbc we have a fraction part for time values, a single unit is 1/100000000
const ULONG JDBC_FRACTION_UNITS_PER_HSECOND = 10000000L;

//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::FillResultRow()
{
	if(!pRs)
		return FALSE;
	// aResultRow wird mittels pRs gefuellt

	UINT16 len = aResultColumns->Count();

	for(UINT16 i = 1 ; i < len && aStatus.IsSuccessful(); i++)
	{// i ab 1 wegen der BOOKMARK
		const  SdbColumn& rCol	= *(*aResultColumns)[i];
		ODbVariantRef pVal		= (*aResultRow)[i];
		if(!pVal.is())
			continue;

		switch(rCol.GetType()){
			case SDB_DBTYPE_BOOLEAN:
				pVal->setBOOL(pRs->getBoolean(i));
				break;
			case SDB_DBTYPE_TINYINT:
			case SDB_DBTYPE_SMALLINT:
				pVal->setINT16(pRs->getShort(i));
				break;
			case SDB_DBTYPE_INTEGER:
				pVal->setINT32(pRs->getInt(i));
				break;
			case SDB_DBTYPE_BIGINT:
				pVal->setDouble(pRs->getDouble(i));
				break;
			case SDB_DBTYPE_REAL:
				pVal->setFloat(pRs->getFloat(i));
				break;
			case SDB_DBTYPE_DOUBLE:
				pVal->setDouble(pRs->getDouble(i));
				break;
			case SDB_DBTYPE_NUMERIC:
			case SDB_DBTYPE_DECIMAL:
			case SDB_DBTYPE_CURRENCY:
				{
					java_math_BigDecimal *pBig = pRs->getBigDecimal(i,rCol.GetScale());
					SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
					if(aStatus.IsSuccessful())
					{
						if(pBig)
							pVal->setDouble(pBig->doubleValue());
						else
							pVal->setNull();
					}

					delete pBig;
				}
				break;
			case SDB_DBTYPE_CHAR:
			case SDB_DBTYPE_VARCHAR:
			case SDB_DBTYPE_LONGVARCHAR:
					pVal->setString(pRs->getString(i));
				break;
			case SDB_DBTYPE_DATE:
				{
					java_sql_Date *pDate = pRs->getDate(i);
					if (pDate)
					{
						INT32 nDate = pDate->getDate();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						INT32 nMonth = 1 + pDate->getMonth();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						INT32 nYear = 1900 + pDate->getYear();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						pVal->setDate(Date(nDate,nMonth,nYear));
						delete pDate;
					}
					else
						pVal->setNull();
				}
				break;
			case SDB_DBTYPE_TIME:
				{
					java_sql_Time *pTime = pRs->getTime(i);
					if (pTime)
					{
						ULONG nTime = pTime->getHours();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						ULONG nMin = pTime->getMinutes();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						ULONG nSec = pTime->getSeconds();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						pVal->setTime(Time(nTime,nMin,nSec));
						delete pTime;
					}
					else
						pVal->setNull();
				}
				break;
			case SDB_DBTYPE_TIMESTAMP:
				{
					java_sql_Timestamp *pTs = pRs->getTimestamp(i);
					if (pTs)
					{
						INT32 nDate = pTs->getDate();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						INT32 nMonth = 1 + pTs->getMonth();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						INT32 nYear = 1900 + pTs->getYear();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						ULONG nTime = pTs->getHours();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						ULONG nMin = pTs->getMinutes();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						ULONG nSec = pTs->getSeconds();
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

						DateTime aDateTime(Date(nDate,nMonth,nYear),
										   Time(nTime,nMin,nSec, long (pTs->getNanos() / JDBC_FRACTION_UNITS_PER_HSECOND)));

						pVal->setDateTime(aDateTime);
						delete pTs;
					}
					else
						pVal->setNull();
				}
				break;
			case SDB_DBTYPE_BINARY:
			case SDB_DBTYPE_VARBINARY:
				{
					BYTE* pData=NULL;
					INT32 nLen = 0;
					if (pRs->getBytes(i,pData,nLen) && pData && nLen)
					{
						::staruno::Sequence<sal_Int8> aData((sal_Int8*)pData,nLen);
						pVal->setBytes(aData);
					}
					else
						pVal->setNull();
				}
				break;
			case SDB_DBTYPE_LONGVARBINARY:
				{
					java_io_InputStream* pInputStream = pRs->getBinaryStream(i);
					SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
					if(pInputStream)
					{
						BYTE* pData = NULL;
						INT32 nLen = pInputStream->read(pData,0,8192);
						if(nLen != -1)
						{
							::staruno::Sequence<sal_Int8> aData((sal_Int8*)pData, nLen);
							INT32 nCurPos = nLen;
							while((nLen = pInputStream->read(pData,nCurPos,8192)) != -1 && nLen && aStatus.IsSuccessful())
							{
								SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
								aData.realloc( nLen + nCurPos);
								memcpy(aData.getArray() + nCurPos, pData, nLen);
								nCurPos += nLen;
							}
							pVal->setBytes(aData);
						}
						delete pInputStream;
					}
				}
				break;
			case SDB_DBTYPE_UNKNOWN:
				pVal->setNull();
				break;
			default:
				DBG_ASSERT(0,"Java Unknown Type in JDBCCursor::FillResult");
		}
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if(!aStatus.IsSuccessful() && !pRs->wasNull())
		{
			aStatus.Clear();
			pVal->setString(pRs->getString(i));
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		}
		if (pRs->wasNull())
			pVal->setNull();

		pVal->setModified(FALSE);
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	}

	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::FillParameterRow()
{
	if(!pCallableStatem)
		return FALSE;
	// aResultRow wird mittels pRs gefuellt
	UINT16 len = aParameterColumns->Count();
	for(UINT16 i = 1 ; i < len && aStatus.IsSuccessful(); i++)
	{// i ab 1 wegen der BOOKMARK
		const  SdbColumn& rCol	= *(*aParameterColumns)[i];
		if(rCol.IsOutParameter())
		{
			ODbVariantRef pVal		= (*aParameterRow)[i];
			if(!pVal.is())
				continue;

			switch(rCol.GetType())
			{
				case SDB_DBTYPE_BOOLEAN:
					pVal->setBOOL(pCallableStatem->getBoolean(i));
					break;
				case SDB_DBTYPE_TINYINT:
				case SDB_DBTYPE_SMALLINT:
					pVal->setINT16(pCallableStatem->getShort(i));
					break;
				case SDB_DBTYPE_INTEGER:
					pVal->setINT32(pCallableStatem->getInt(i));
					break;
				case SDB_DBTYPE_BIGINT:
					pVal->setDouble(pCallableStatem->getDouble(i));
					break;
				case SDB_DBTYPE_REAL:
					pVal->setFloat(pCallableStatem->getFloat(i));
					break;
				case SDB_DBTYPE_DOUBLE:
					pVal->setDouble(pCallableStatem->getDouble(i));
					break;
				case SDB_DBTYPE_NUMERIC:
				case SDB_DBTYPE_DECIMAL:
				case SDB_DBTYPE_CURRENCY:
					{
						java_math_BigDecimal *pBig = pCallableStatem->getBigDecimal(i,rCol.GetScale());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						if(pBig)
							pVal->setDouble(pBig->doubleValue());
						else
							pVal->setNull();

						delete pBig;
					}
					break;
				case SDB_DBTYPE_CHAR:
				case SDB_DBTYPE_VARCHAR:
				case SDB_DBTYPE_LONGVARCHAR:
					pVal->setString(pCallableStatem->getString(i));
					break;
				case SDB_DBTYPE_DATE:
					{
						java_sql_Date *pDate = pCallableStatem->getDate(i);
						if (pDate)
						{
							INT32 nDate = pDate->getDate();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							INT32 nMonth = 1 + pDate->getMonth();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							INT32 nYear = 1900 + pDate->getYear();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

							pVal->setDate(Date(nDate,nMonth,nYear));
							delete pDate;
						}
						else
							pVal->setNull();
					}
					break;
				case SDB_DBTYPE_TIME:
					{
						java_sql_Time *pTime = pCallableStatem->getTime(i);
						if (pTime)
						{
							ULONG nTime = pTime->getHours();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							ULONG nMin = pTime->getMinutes();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							ULONG nSec = pTime->getSeconds();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							pVal->setTime(Time(nTime,nMin,nSec));
							delete pTime;
						}
						else
							pVal->setNull();
					}
					break;
				case SDB_DBTYPE_TIMESTAMP:
					{
						java_sql_Timestamp *pTs = pCallableStatem->getTimestamp(i);
						if (pTs)
						{
							INT32 nDate = pTs->getDate();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							INT32 nMonth = 1 + pTs->getMonth();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							INT32 nYear = 1900 + pTs->getYear();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							ULONG nTime = pTs->getHours();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							ULONG nMin = pTs->getMinutes();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							ULONG nSec = pTs->getSeconds();
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

							DateTime aDateTime(Date(nDate,nMonth,nYear),
											   Time(nTime,nMin,nSec, long (pTs->getNanos() / JDBC_FRACTION_UNITS_PER_HSECOND)));

							pVal->setDate(aDateTime);
							delete pTs;
						}
						else
							pVal->setNull();
					}
					break;
				case SDB_DBTYPE_BINARY:
				case SDB_DBTYPE_VARBINARY:
				case SDB_DBTYPE_LONGVARBINARY:
					{
						BYTE* pData=NULL;
						INT32 nLen = 0;
						if (pCallableStatem->getBytes(i,pData,nLen) && pData && nLen)
						{
							::staruno::Sequence<sal_Int8> aData((sal_Int8*)pData,nLen);
							pVal->setBytes(aData);
						}
						else
							pVal->setNull();
					}
					break;
				case SDB_DBTYPE_UNKNOWN:
					pVal->setNull();
					break;
				default:
					DBG_ASSERT(0,"Java Unknown Type in JDBCCursor::FillResult");
			}

			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			if (pCallableStatem->wasNull())
				pVal->setNull();
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		}
	}
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::OnOpen()
{
	SdbStatus aTempStat(aStatus);

	// wird nach OpenImpl aufgerufen
	if (!IsOpen())
	{  		// resultset erst nach execute beschreiben!!!
							// und nur wenn noch nicht geffnet
		SdbJDBCConnection* pConnection = (SdbJDBCConnection*)GetConnection();
		if(!aResultColumns.Is())
			aResultColumns = pConnection->CreateColumns();
		DescribeResult();
	}
	// Bei Statements, die keine Results liefern (insb. UPDATE, DELETE, INSERT)
	// ist die Anzahl der vom Statement betroffenen Datensaetze interessant:
	if (aResultColumns->Count() == 1)
	{
		if (nRows >= 0)
			SetRowCount((UINT32)nRows);
	}
	// wenn ich hier schon mit einem nicht erfolgreichen Status reingekommen bin, muss ich das fuer die Basisklasse
	// wiederherstellen
	if (!aTempStat.IsSuccessful())
		aStatus = aTempStat;

	return SdbCursor::OnOpen();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCCursor::DetermineRowCountImpl(INT32& nNewCount)
{
	return FALSE;// nicht direkt aus der Datenbank abfragbar
}

//-----------------------------------------------------------------------------
void SdbJDBCCursor::DescribeColumns(SdbColumnsRef &cols,INT32 len,java_sql_ResultSetMetaData *pRsM)
{
	if(!pRsM)
		return;

	SdbJDBCConnection* pConnection = (SdbJDBCConnection*)GetConnection();
	SdbDatabaseType eType;
	for(INT32 i=1;i <= len && aStatus.IsSuccessful() ;i++)
	{// <= da von java kommend
		INT16 nFlags(0);
		eType = javaTyp2SdbTyp(pRsM->getColumnType(i));
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

		if(eType == SDB_DBTYPE_BIGINT)
			eType = SDB_DBTYPE_DOUBLE;

		if(pRsM->isNullable(i) == 1) // 1 = columnNullable
			nFlags = SDB_FLAGS_NULLALLOWED;
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if(!pRsM->isReadOnly(i))
			nFlags |= SDB_FLAGS_UPDATEALLOWED;
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if(pRsM->isSearchable(i))
			nFlags |= SDB_FLAGS_SEARCH_ALL;
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if (pRsM->isAutoIncrement(i))
		{
			nFlags |= SDB_FLAGS_AUTOINCREMENT;
			nFlags &= ~SDB_FLAGS_UPDATEALLOWED;	    // darf nicht updatebar sein
		}
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

		INT32 nPrec		= pRsM->getPrecision(i);SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if ((nPrec == 0) && (eType == SDB_DBTYPE_VARCHAR))
		{	// einige Treiber (konkret : der Thin-Jdbc-Treiber fuer Oracle) liefern als Precision
			// fuer eine Text-Spalte 0, die eigentliche Laenge speichern sie in der DisplaySize
			nPrec = pRsM->getColumnDisplaySize(i);SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		}
		UINT16 nScale	= (UINT16)pRsM->getScale(i);SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		if(nScale > nPrec)
			nScale = 0; // tritt nur bei Typen auf die sowieso keine Scale besitzen
		SdbColumn * pColumn = pConnection->CreateColumn(pRsM->getColumnName(i),
														pRsM->isCurrency(i) ? SDB_DBTYPE_CURRENCY : eType,
														nPrec,nScale, nFlags);
		// Column-Beschreibung hinzufuegen.
		cols->AddColumn(pColumn);
	}
}

//-----------------------------------------------------------------------------
void SdbJDBCCursor::FillPreStatement()
{
	if(!pPreStatem)
		return;

	// aParameterRow fuellt pPreStatem
	UINT16 len(aParameterColumns->Count());
	for(UINT16 i =1;i<len && aStatus.IsSuccessful();i++)
	{
		const  SdbColumn& rCol	= *(*aParameterColumns)[i];
		ODbVariantRef pVal		= (*aParameterRow)[i];
		if (!pVal.is() || pVal->isNull())
			pPreStatem->setNull(i,sdbTyp2JavaTyp(rCol.GetType()));
		else
		{
			try
			{
				switch(rCol.GetType())
				{
					case SDB_DBTYPE_BOOLEAN:
						pPreStatem->setBoolean(i,pVal->toBOOL());
						break;
					case SDB_DBTYPE_TINYINT:
					case SDB_DBTYPE_SMALLINT:
						pPreStatem->setShort(i,pVal->toINT16());
						break;
					case SDB_DBTYPE_BOOKMARK:
					case SDB_DBTYPE_INTEGER:
						pPreStatem->setInt(i,pVal->toINT32());
						break;
					case SDB_DBTYPE_REAL:
						pPreStatem->setFloat(i,pVal->toFloat());
						break;
					case SDB_DBTYPE_BIGINT:
					case SDB_DBTYPE_DOUBLE:
					case SDB_DBTYPE_NUMERIC:
					case SDB_DBTYPE_DECIMAL:
					case SDB_DBTYPE_CURRENCY://XXXX
						pPreStatem->setDouble(i,pVal->toDouble());
						break;
					case SDB_DBTYPE_CHAR:
					case SDB_DBTYPE_VARCHAR:
						{
							String aFiTmpStr(pVal->toString().getStr());
							pPreStatem->setString(i,&aFiTmpStr);
						}
						break;
					case SDB_DBTYPE_LONGVARCHAR:
						{
							String aFiTmpStr(pVal->toString().getStr());
							pPreStatem->setString(i,&aFiTmpStr);
						}
						break;
					case SDB_DBTYPE_DATE:
					{
						Date aDate( pVal->toDate() );
						java_sql_Date aTmp(aDate.GetYear()-1900,aDate.GetMonth()-1,aDate.GetDay());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	#if DEBUG
						String aTimeStamp = aTmp.toString();
	#endif
						pPreStatem->setDate(i,&aTmp);
					}	break;
					case SDB_DBTYPE_TIME:
					{
						Time aTime( pVal->toTime() );
						java_sql_Time aTmp(aTime.GetHour(),aTime.GetMin(),aTime.GetSec());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						pPreStatem->setTime(i,&aTmp);
					}	break;
					case SDB_DBTYPE_TIMESTAMP:
					{
						DateTime aDate( pVal->toDateTime());
						java_sql_Timestamp aTmp(aDate.GetYear()-1900,aDate.GetMonth()-1,aDate.GetDay());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	#if DEBUG
						String aTimeStamp = aTmp.toString();
	#endif

						aTmp.setHours(aDate.GetHour());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						aTmp.setMinutes(aDate.GetMin());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						aTmp.setSeconds(aDate.GetSec());
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
						aTmp.setNanos(aDate.Get100Sec() * JDBC_FRACTION_UNITS_PER_HSECOND);
						SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

						pPreStatem->setTimestamp(i,&aTmp);
					}	break;
					case SDB_DBTYPE_BINARY:
					case SDB_DBTYPE_VARBINARY:
					case SDB_DBTYPE_LONGVARBINARY:
						if (pVal->getValueType() == ::getCppuType((const ::com::sun::star::uno::Sequence< sal_Int8 > *)0))
						{
							const ::staruno::Sequence<sal_Int8>& rData = pVal->getBytes();
							pPreStatem->setBinaryStream(i,(BYTE*)rData.getConstArray(),rData.getLength());
						}	break;
					case SDB_DBTYPE_UNKNOWN:
					default:
						DBG_ERROR("Java Unknown Type in JDBCCursor::FillParamater");
				}
			}
			catch ( ... )
			{
				String strError(SdbResId(STR_STAT_VALUE_CAN_NOT_CONVERTED));
				strError.SearchAndReplace(String::CreateFromAscii("$name$"), rCol.GetName());
				aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("S1000"), aStatus.CreateErrorMessage(strError), 0, String());
				return;
			}

		}
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	}
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::FillCallStatement()
{
	if(!pCallableStatem)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	// aParameterRow fuellt pPreStatem
	UINT16 len(aParameterColumns->Count());

	for(UINT16 i =1;i<len && aStatus.IsSuccessful();i++)
	{
		const  SdbColumn& rCol	= *(*aParameterColumns)[i];
		if(rCol.IsOutParameter())
			pCallableStatem->registerOutParameter(i,sdbTyp2JavaTyp(rCol.GetType()));
		else
		{
			ODbVariantRef pVal = (*aParameterRow)[i];
			if (!pVal.is() || pVal->isNull())
				pCallableStatem->setNull(i,sdbTyp2JavaTyp(rCol.GetType()));
			else
			{
				try
				{
					switch(rCol.GetType())
					{
						case SDB_DBTYPE_BOOLEAN:
							pCallableStatem->setBoolean(i,pVal->toBOOL());
							break;
						case SDB_DBTYPE_TINYINT:
						case SDB_DBTYPE_SMALLINT:
							pCallableStatem->setShort(i,pVal->toINT16());
							break;
						case SDB_DBTYPE_BOOKMARK:
						case SDB_DBTYPE_INTEGER:
							pCallableStatem->setInt(i,pVal->toINT32());
							break;
						case SDB_DBTYPE_REAL:
							pCallableStatem->setFloat(i,pVal->toFloat());
							break;
						case SDB_DBTYPE_BIGINT:
						case SDB_DBTYPE_DOUBLE:
						case SDB_DBTYPE_NUMERIC:
						case SDB_DBTYPE_DECIMAL:
						case SDB_DBTYPE_CURRENCY://XXXX
							pCallableStatem->setDouble(i,pVal->toDouble());
							break;
						case SDB_DBTYPE_CHAR:
						case SDB_DBTYPE_VARCHAR:
							{
								String aFiTmpStr(pVal->toString().getStr());
								pCallableStatem->setString(i,&aFiTmpStr);
							}
							break;
						case SDB_DBTYPE_LONGVARCHAR:
							{
								String aFiTmpStr(pVal->toString().getStr());
								pCallableStatem->setString(i,&aFiTmpStr);
							}
							break;
						case SDB_DBTYPE_DATE:
						{
							Date aDate = pVal->toDate();
							java_sql_Date aTmp(aDate.GetYear()-1900,aDate.GetMonth()-1,aDate.GetDay());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							pCallableStatem->setDate(i,&aTmp);
						}	break;
						case SDB_DBTYPE_TIME:
						{
							Time aTime = pVal->toTime();
							java_sql_Time aTmp(aTime.GetHour(),aTime.GetMin(),aTime.GetSec());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							pCallableStatem->setTime(i,&aTmp);
						}	break;
						case SDB_DBTYPE_TIMESTAMP:
						{
							DateTime aDate = pVal->toDateTime();
							java_sql_Timestamp aTmp(aDate.GetYear()-1900,aDate.GetMonth()-1,aDate.GetDay());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							aTmp.setHours(aDate.GetHour());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							aTmp.setMinutes(aDate.GetMin());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							aTmp.setSeconds(aDate.GetSec());
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							aTmp.setNanos(aDate.Get100Sec() * JDBC_FRACTION_UNITS_PER_HSECOND);
							SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
							pCallableStatem->setTimestamp(i,&aTmp);
						}	break;
						case SDB_DBTYPE_BINARY:
						case SDB_DBTYPE_VARBINARY:
						case SDB_DBTYPE_LONGVARBINARY:
							{
								if (pVal->getValueType() == ::getCppuType((const ::com::sun::star::uno::Sequence< sal_Int8 > *)0))
								{
									const ::staruno::Sequence<sal_Int8>& rData = pVal->getBytes();
									pCallableStatem->setBytes(i,(BYTE*)rData.getConstArray(),rData.getLength());
								}
							}
							break;
						case SDB_DBTYPE_UNKNOWN:
						default:
							DBG_ASSERT(0,"Java Unknown Type in JDBCCursor::FillParamater");
					}
				}
				catch ( ... )
				{
					String strError(SdbResId(STR_STAT_VALUE_CAN_NOT_CONVERTED));
					strError.SearchAndReplace(String::CreateFromAscii("$name$"), rCol.GetName());
					aStatus.Set(SDB_STAT_ERROR, String::CreateFromAscii("S1000"), aStatus.CreateErrorMessage(strError), 0, String());
					return;
				}

			}
		}
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	}
}

//-----------------------------------------------------------------------------
void SdbJDBCCursor::OpenTables(const String* pQualifier, const String* pOwner,const String* pTable,const String& aList)
{

	SdbJDBCConnection *pCon = (SdbJDBCConnection*)GetConnection();
	DBG_ASSERT(pCon,"SdbJDBCCursor::OpenTables: pCon == NULL :-)");
	DELETEZ(pRs);

	String aNewList;
	if(aList.GetChar(0) != '%')
	{ // aList == "%" gibt alle Tabellentypen zurueck
	// Pruefen welche TABLEN Typen unterstuetzt werden
		pRs = pCon->pDbMeta->getTableTypes();
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);

		DBG_ASSERT(pRs,"ResultSet darf an dieser Stelle nicht NULL sein!");
		String aStr;
		while(pRs && aStatus.IsSuccessful() && pRs->next())
		{
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			aStr += pRs->getString(1);
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
			aStr += ';';
		}
		DELETEZ(pRs);
		aStr.EraseTrailingChars(';');
		xub_StrLen nWLen = aStr.Len();

		String aTe;
		for(xub_StrLen i=0;i<aList.GetTokenCount(';');i++)
		{
			aTe = aList.GetToken(i);
			xub_StrLen nPos = aStr.Search(aTe);
			if(nPos < nWLen)
			{
				aNewList += aTe;
				aNewList += ';';
			}
		}
	}
	else
		aNewList = aList;
	aNewList.EraseTrailingChars(';');
	if(aNewList.Len())
	{
		pRs = pCon->pDbMeta->getTables(pQualifier,pOwner,pTable,aNewList);
		if(pRs)
		{
			if(!Open4Info() && aStatus.IsSuccessful())
				aStatus.Set(SDB_STAT_ERROR);
		}
		else
			SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
	}
	else if(aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
// Spezielle Methode anstelle von Execute, die Informationen ueber die Columns
// eines Primaerschluessels einer Tabelle als Ergebnismenge liefert.
void SdbJDBCCursor::OpenPrimaryKeys(const String* pQualifier, const String* pOwner, const String* pTable)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}

	DELETEZ(pRs);

	pRs =  ((SdbJDBCConnection*)GetConnection())->pDbMeta->getPrimaryKeys(pQualifier,pOwner,pTable);
	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
// Spezielle Methode anstelle von Execute, die Informationen ueber die Rechte
// des Benutzers fuer eine gegebene Tabelle liefert
void SdbJDBCCursor::OpenTablePrivileges(const String* pQua, const String* pOwn, const String* pTab)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs =  ((SdbJDBCConnection*)GetConnection())->pDbMeta->getTablePrivileges(pQua,pOwn,pTab);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::OpenIndices(const String* pQua, const String* pOwn, const String* pTab, BOOL bUnique)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs =  ((SdbJDBCConnection*)GetConnection())->pDbMeta->getIndexInfo(pQua,pOwn,pTab,bUnique);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
// Spezielle Methode anstelle von Execute, die die Namen der bekannten
// Columns in einer Tabelle als Ergebnismenge liefert.
void SdbJDBCCursor::OpenColumns(const String* pQua, const String* pOwn,const String* pTab, const String* pCol)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs =  ((SdbJDBCConnection*)GetConnection())->pDbMeta->getColumns(pQua,pOwn,pTab,pCol);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::OpenForeignKeys(const String* pPKQua, const String* pPKOwn, const String* pPKNa,
									const String* pFKQua, const String* pFKOwn, const String* pFKNa)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs = ((SdbJDBCConnection*)GetConnection())->pDbMeta->getCrossReference(pPKQua,pPKOwn,pPKNa,pFKQua,pFKOwn,pFKNa);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
// Spezielle Methode anstelle von Execute, die die Namen der bekannten
// Prozeduren als Ergebnismenge liefert.
void SdbJDBCCursor::OpenProcedures(const String* rQualifier, const String* rSchema, const String* rProcName)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs = ((SdbJDBCConnection*)GetConnection())->pDbMeta->getProcedures(rQualifier,rSchema,rProcName);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//-----------------------------------------------------------------------------
void SdbJDBCCursor::OpenVersionColumns(const String* rQualifier, const String* rSchema, const String* rTabName)
{
	if(!((SdbJDBCConnection*)GetConnection())->pDbMeta)
		return;

	DELETEZ(pRs);
	pRs = ((SdbJDBCConnection*)GetConnection())->pDbMeta->getVersionColumns(rQualifier,rSchema,rTabName);

	if(!pRs)
	{
		SdbJDBCCursor::SetStatus(aStatus,((SdbJDBCConnection*)GetConnection())->pCon);
		return;
	}
	if(!Open4Info() && aStatus.IsSuccessful())
		aStatus.Set(SDB_STAT_ERROR);
}
//------------------------------------------------------------------------
BOOL SdbJDBCCursor::IsCapable(SdbCursorCapability eCapability) const
{
	BOOL bResult=FALSE;
	switch(eCapability)
	{
		case SDB_CAP_FETCH:		bResult = TRUE;break;
		case SDB_CAP_FETCH_NEXT:
			bResult = ((SdbJDBCConnection*)GetConnection())->pDbMeta->supportsOpenCursorsAcrossCommit() &
					  ((SdbJDBCConnection*)GetConnection())->pDbMeta->supportsOpenCursorsAcrossRollback();
			break;
	}
	return bResult;
}

