/*************************************************************************
 *
 *  $RCSfile: jdbcmd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_JDBCCONN_HXX
#include <jdbcconn.hxx>
#endif

#include <jdbcmd.hxx>

#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQL92_HPP_
#include <com/sun/star/data/DatabaseSQL92.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

#ifndef _SDB_JA_SQ_PG_HXX
#include <ja_sq_pg.hxx>
#endif

#include "jdbccurs.hxx"


//------------------------------------------------------------------
sal_Int32 convert2Java(sal_Int16 nFrom)
{
	sal_Int32 nFromJava;
	if (nFrom == ::stardata::DatabaseFieldType::CURRENCY)
		nFromJava = SdbJDBCConnection::NUMERIC;
	else
		nFromJava = nFrom;
	return nFromJava;
}

//------------------------------------------------------------------
sal_Bool SdbJDBCMetaData::isCapableImpl(sal_Int16 nCapability) const
{
	java_sql_DatabaseMetaData *pJavaDbMeta =
			((SdbJDBCConnection*)pCon)->GetJAVADatabaseMetaData();

	sal_Bool erg;
	switch(nCapability)
	{
		case ::stardata::DatabaseCapability::COLUMN_ALIAS:
			erg = pJavaDbMeta->supportsColumnAliasing();
			break;
		case ::stardata::DatabaseCapability::TABLE_CORRELATION_NAME:
			erg = pJavaDbMeta->supportsTableCorrelationNames();
			break;
		case ::stardata::DatabaseCapability::CONVERT:
			erg = pJavaDbMeta->supportsConvert();
			break;
		case ::stardata::DatabaseCapability::EXPRESSION_ORDERBY:
			erg = pJavaDbMeta->supportsExpressionsInOrderBy();
			break;
		case ::stardata::DatabaseCapability::GROUPBY:
			erg = pJavaDbMeta->supportsGroupBy();
			break;
		case ::stardata::DatabaseCapability::GROUPBY_BEYONDSELECT:
			erg = pJavaDbMeta->supportsGroupByBeyondSelect();
			break;
		case ::stardata::DatabaseCapability::GROUPBY_UNRELATED:
			erg = pJavaDbMeta->supportsGroupByUnrelated();
			break;
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
			erg = pJavaDbMeta->supportsNonNullableColumns();
			break;
		case ::stardata::DatabaseCapability::INTEGRITY:
			erg = pJavaDbMeta->supportsCoreSQLGrammar();
			if(!erg)
				erg = pJavaDbMeta->supportsIntegrityEnhancementFacility();
			break;
		case ::stardata::DatabaseCapability::ORDERBY_UNRELATED:
			erg = pJavaDbMeta->supportsOrderByUnrelated();
			break;
		case ::stardata::DatabaseCapability::UNION:
			erg = pJavaDbMeta->supportsUnion();
			break;
		case ::stardata::DatabaseCapability::UNION_ALL:
			erg = pJavaDbMeta->supportsUnionAll();
			break;
		case ::stardata::DatabaseCapability::TRANSACTIONS:
			erg = pJavaDbMeta->supportsTransactions();
			break;
	}
	SdbStatus aStatus;
	SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
	return erg && aStatus.IsSuccessful();
}
//------------------------------------------------------------------
::staruno::Any SdbJDBCMetaData::getInfoImpl(sal_Int16 nInfo) const
{
	java_sql_DatabaseMetaData *pJavaDbMeta = ((SdbJDBCConnection*)pCon)->GetJAVADatabaseMetaData();

	::staruno::Any erg;
	SdbStatus aStatus;

	switch(nInfo)
	{
		case ::stardata::DatabaseInfo::CATALOG_AT_START:
			erg <<= (sal_Bool)pJavaDbMeta->isCatalogAtStart();
			break;
		case ::stardata::DatabaseInfo::READ_ONLY:
			erg <<= (sal_Bool)pJavaDbMeta->isReadOnly();
			break;
		case ::stardata::DatabaseInfo::NULLPLUSNONNULLISNULL:
			erg <<= (sal_Bool)pJavaDbMeta->nullPlusNonNullIsNull();
			break;
		case ::stardata::DatabaseInfo::TABLE_DEFINITION:
		{
			sal_Int16 nResults(::stardata::DatabaseTableDefinition::DROP | ::stardata::DatabaseTableDefinition::CREATE);
			if (pJavaDbMeta->supportsAlterTableWithDropColumn())
				nResults |= ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN;
			SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
			if (pJavaDbMeta->supportsAlterTableWithAddColumn())
				nResults |= ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN;
			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::VIEW_DEFINITION:
		{
			sal_Int16 nResults(0);
			java_sql_ResultSet *pRs = pJavaDbMeta->getTableTypes();
			SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
			while (pRs->next() && !nResults && aStatus.IsSuccessful())
			{
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection()); // f"ur das next
				if (pRs->getString(1/*"TABLE_TYPE"*/).EqualsAscii("VIEW"))
					nResults |= ::stardata::DatabaseViewDefinition::DROP | ::stardata::DatabaseViewDefinition::CREATE;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());

			}
			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::INDEX_DEFINITION:
		{
			sal_Int16 nResults(0);
			if (pJavaDbMeta->getMaxIndexLength())
				nResults |= ::stardata::DatabaseIndexDefinition::DROP | ::stardata::DatabaseIndexDefinition::CREATE;
			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::IDENT_CASE:
			if(pJavaDbMeta->storesUpperCaseIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::UPPER;
			else if(pJavaDbMeta->storesLowerCaseIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::LOWER;
			else if(pJavaDbMeta->storesMixedCaseIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			else if(pJavaDbMeta->supportsMixedCaseIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::SENSITIVE;
			break;
		case ::stardata::DatabaseInfo::IDENT_CASE_QUOTED:
			if(pJavaDbMeta->storesUpperCaseQuotedIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::UPPER;
			else if(pJavaDbMeta->storesLowerCaseQuotedIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::LOWER;
			else if(pJavaDbMeta->storesMixedCaseQuotedIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			else if(pJavaDbMeta->supportsMixedCaseQuotedIdentifiers())
				erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::SENSITIVE;
			break;
		case ::stardata::DatabaseInfo::NULLS_SORT:
			if(pJavaDbMeta->nullsAreSortedAtEnd())
				erg <<= (sal_Int16)::stardata::DatabaseNullsSort::AT_END;
			else if(pJavaDbMeta->nullsAreSortedAtStart())
				erg <<= (sal_Int16)::stardata::DatabaseNullsSort::AT_START;
			else if(pJavaDbMeta->nullsAreSortedHigh())
				erg <<= (sal_Int16)::stardata::DatabaseNullsSort::HIGH;
			else if(pJavaDbMeta->nullsAreSortedLow())
				erg <<= (sal_Int16)::stardata::DatabaseNullsSort::LOW;
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_UPDATE_RULE:
		case ::stardata::DatabaseInfo::FOREIGN_KEY_DELETE_RULE:
			{
				sal_Int16 nInfo;
				getInfoImpl(::stardata::DatabaseInfo::ANSI_SQL_92) >>= nInfo;
				if (nInfo & ::stardata::DatabaseSQL92::ENTRY_LEVEL)
					erg <<= (sal_Int16)(::stardata::DatabaseKeyRule::NO_ACTION|::stardata::DatabaseKeyRule::CASCADE|::stardata::DatabaseKeyRule::SET_DEFAULT|::stardata::DatabaseKeyRule::SET_NULL);
				else
					erg <<= (sal_Int16)::stardata::DatabaseKeyRule::NO_ACTION;
			}
			break;
		case ::stardata::DatabaseInfo::SCHEMA_USAGE:
			{
				sal_Int16 nUsage(0);
				if(!pJavaDbMeta->usesLocalFiles())
					nUsage = ((SdbJDBCConnection*)pCon)->GetOwnerUsage();

				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_USAGE:
			{
				sal_Int16 nUsage(0);
				if(!pJavaDbMeta->usesLocalFiles())
					nUsage = ((SdbJDBCConnection*)pCon)->GetQualifierUsage();
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::SUBQUERIES:
			{
				sal_Int16 nUsage(0);
				if(pJavaDbMeta->supportsCorrelatedSubqueries())
					nUsage = ::stardata::DatabaseSubquery::CORRELATED;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsSubqueriesInComparisons())
					nUsage |= ::stardata::DatabaseSubquery::COMPARSION;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsSubqueriesInExists())
					nUsage |= ::stardata::DatabaseSubquery::EXISTS;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsSubqueriesInIns())
					nUsage |= ::stardata::DatabaseSubquery::IN;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsSubqueriesInQuantifieds())
					nUsage |= ::stardata::DatabaseSubquery::QUANTIFIED;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::SUPPORTED_ISOLATION_LEVELS:
			{
				sal_Int16 nUsage(0);
				if(pJavaDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_NONE))
					nUsage = ::stardata::DatabaseIsolationLevel::NONE;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_READ_COMMITTED))
					nUsage |= ::stardata::DatabaseIsolationLevel::READ_COMMIT;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_READ_UNCOMMITTED))
					nUsage |= ::stardata::DatabaseIsolationLevel::READ_UNCOMMIT;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_REPEATABLE_READ))
					nUsage |= ::stardata::DatabaseIsolationLevel::REPEAT_READ;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsTransactionIsolationLevel(java_sql_Connection::TRANSACTION_SERIALIZABLE))
					nUsage |= ::stardata::DatabaseIsolationLevel::SERIALIZABLE;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::ANSI_SQL_92:
			{
				sal_Int16 nUsage(0);
				if(!pJavaDbMeta->supportsANSI92FullSQL())
				{
					if(!pJavaDbMeta->supportsANSI92IntermediateSQL())
					{
						if(pJavaDbMeta->supportsANSI92EntryLevelSQL())
							nUsage = ::stardata::DatabaseSQL92::ENTRY_LEVEL;
						SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
					}
					else
						nUsage |= ::stardata::DatabaseSQL92::INTERMEDIATE | ::stardata::DatabaseSQL92::ENTRY_LEVEL;
					SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				}
				else
					nUsage |= ::stardata::DatabaseSQL92::FULL | ::stardata::DatabaseSQL92::ENTRY_LEVEL | ::stardata::DatabaseSQL92::INTERMEDIATE;
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::DSN_URL:
			erg <<= rtl::OUString(pJavaDbMeta->getURL());
			break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			erg <<= rtl::OUString(pJavaDbMeta->getDriverName());
			break;
		case ::stardata::DatabaseInfo::DRIVER_VERSION:
			erg <<= rtl::OUString(pJavaDbMeta->getDriverVersion());
			break;
		case ::stardata::DatabaseInfo::DBMS_VERSION:
			erg <<= rtl::OUString(pJavaDbMeta->getDatabaseProductVersion());
			break;
		case ::stardata::DatabaseInfo::DBMS_NAME:
			erg <<= rtl::OUString(pJavaDbMeta->getDatabaseProductName());
			break;
		case ::stardata::DatabaseInfo::PROC_TERM:
			erg <<= rtl::OUString(pJavaDbMeta->getProcedureTerm());
			break;
		case ::stardata::DatabaseInfo::CATALOG_TERM:
			erg <<= rtl::OUString(pJavaDbMeta->getCatalogTerm());
			break;
		case ::stardata::DatabaseInfo::SCHEMA_TERM:
			erg <<= rtl::OUString(pJavaDbMeta->getSchemaTerm());
			break;
		case ::stardata::DatabaseInfo::TABLE_TERM:
			erg <<= rtl::OUString::createFromAscii("TABLE");
			break;
		case ::stardata::DatabaseInfo::IDENTIFIER_QUOTE_CHAR:
			erg <<= rtl::OUString(pJavaDbMeta->getIdentifierQuoteString());
			break;
		case ::stardata::DatabaseInfo::SQL_KEYWORDS:
			erg <<= rtl::OUString(pJavaDbMeta->getSQLKeywords());
			break;
		case ::stardata::DatabaseInfo::CATALOG_SEPARATOR:
			erg <<= rtl::OUString(pJavaDbMeta->getCatalogSeparator());
			break;
		case ::stardata::DatabaseInfo::SEARCH_PATTERN_ESCAPE:
			erg <<= rtl::OUString(pJavaDbMeta->getSearchStringEscape());
			break;
		case ::stardata::DatabaseInfo::SPECIAL_CHARACTERS:
			erg <<= rtl::OUString(pJavaDbMeta->getExtraNameCharacters());
			break;
		case ::stardata::DatabaseInfo::STRING_FUNCTIONS:
			erg <<= rtl::OUString(pJavaDbMeta->getStringFunctions());
			break;
		case ::stardata::DatabaseInfo::SYSTEM_FUNCTIONS:
			erg <<= rtl::OUString(pJavaDbMeta->getSystemFunctions());
			break;
		case ::stardata::DatabaseInfo::NUMERIC_FUNCTIONS:
			erg <<= rtl::OUString(pJavaDbMeta->getNumericFunctions());
			break;
		case ::stardata::DatabaseInfo::SQL_CONFORMANCE:
			{
				sal_Int16 nUsage(0);
				if(!pJavaDbMeta->supportsExtendedSQLGrammar())
				{
					SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
					if(!pJavaDbMeta->supportsCoreSQLGrammar())
					{
						SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
						if(pJavaDbMeta->supportsMinimumSQLGrammar())
							nUsage = ::stardata::DatabaseSQLConformance::MINIMUM;
						SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
					}
					else
					{
						SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
						nUsage |= ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
					}
				}else
				{
					SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
					nUsage |= ::stardata::DatabaseSQLConformance::EXTENDED | ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
				}
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT:
			{
				sal_Int16 nUsage(0);
				if(pJavaDbMeta->supportsFullOuterJoins())
					nUsage |= ::stardata::DatabaseOuterJoinSupport::FULL;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsLimitedOuterJoins())
					nUsage |= ::stardata::DatabaseOuterJoinSupport::PARTIAL ;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				if(pJavaDbMeta->supportsOuterJoins())
					nUsage |= ::stardata::DatabaseOuterJoinSupport::YES;
				SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
				erg <<= (sal_Int16)nUsage;
			}
			break;
		default:
			erg <<= (sal_Int16)0;

	}
	SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
	return erg;
}
//------------------------------------------------------------------
sal_Int32 SdbJDBCMetaData::getLimitImpl(sal_Int16 nLimit) const
{
	java_sql_DatabaseMetaData *pJavaDbMeta =
			((SdbJDBCConnection*)pCon)->GetJAVADatabaseMetaData();
	sal_Int32 erg(0);

	switch(nLimit)
	{
		case ::stardata::DatabaseLimit::BINARAY_LITERAL_LEN:
			erg = pJavaDbMeta->getMaxBinaryLiteralLength();
			break;
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			erg = pJavaDbMeta->getMaxCharLiteralLength();
			break;
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
			erg = pJavaDbMeta->getMaxColumnNameLength();
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_GROUPBY:
			erg = pJavaDbMeta->getMaxColumnsInGroupBy();
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			erg = pJavaDbMeta->getMaxColumnsInIndex();
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_ORDERBY:
			erg = pJavaDbMeta->getMaxColumnsInOrderBy();
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_SELECT:
			erg = pJavaDbMeta->getMaxColumnsInSelect();
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			erg = pJavaDbMeta->getMaxColumnsInTable();
			break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			erg = pJavaDbMeta->getMaxIndexLength();
			break;
		case ::stardata::DatabaseLimit::CATALOG_NAME_LEN:
			erg = pJavaDbMeta->getMaxCatalogNameLength();
			break;
		case ::stardata::DatabaseLimit::SCHEMA_NAME_LEN:
			erg = pJavaDbMeta->getMaxSchemaNameLength();
			break;
		case ::stardata::DatabaseLimit::STATEMENT_LEN:
			erg = pJavaDbMeta->getMaxStatementLength();
			break;
		case ::stardata::DatabaseLimit::TABLE_NAME_LEN:
			erg = pJavaDbMeta->getMaxTableNameLength();
			break;
		case ::stardata::DatabaseLimit::TABLES_IN_SELECT:
			erg = pJavaDbMeta->getMaxTablesInSelect();
			break;
		case ::stardata::DatabaseLimit::USER_NAME_LEN:
			erg = pJavaDbMeta->getMaxUserNameLength();
			break;
	}

	SdbStatus aStatus;
	SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
	return erg;
}

//------------------------------------------------------------------
sal_Bool SdbJDBCMetaData::canConvertImpl(sal_Int16 nFrom, sal_Int16 nIn) const
{
	java_sql_DatabaseMetaData *pJavaDbMeta = ((SdbJDBCConnection*)pCon)->GetJAVADatabaseMetaData();

	sal_Int32 nFromJava,nInJava;
	nFromJava = convert2Java(nFrom);
	nInJava = convert2Java(nIn);
	sal_Bool bCanConvert = pJavaDbMeta->supportsConvert(nFromJava,nInJava);
	SdbStatus aStatus;
	SdbJDBCCursor::SetStatus(aStatus, ((SdbJDBCConnection*)pCon)->GetJAVAConnection());
	return bCanConvert && aStatus.IsSuccessful();
}


