/*************************************************************************
 *
 *  $RCSfile: jdbctab.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SDB_JDBCCONN_HXX
#include <jdbcconn.hxx>
#endif

#ifndef _SDB_JDBCCURS_HXX
#include <jdbccurs.hxx>
#endif

#ifndef _SDB_JDBCTAB_HXX
#include <jdbctab.hxx>
#endif

#ifndef _SDB_JDBCIDX_HXX
#include <jdbcidx.hxx>												  
#endif

#ifndef _SDB_JA_LG_PG_HXX
#include <ja_lg_pg.hxx>
#endif

#ifndef _COM_SUN_STAR_DATA_XDATABASEDESCRIPTOR_HPP_
#include <com/sun/star/data/XDatabaseDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINFO_HPP_
#include <com/sun/star/data/DatabaseInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASECAPABILITY_HPP_
#include <com/sun/star/data/DatabaseCapability.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

#include "sdbresid.hrc"

static char __READONLY_DATA privilegeSelect[]		= "SELECT";
static char __READONLY_DATA privilegeInsert[]		= "INSERT";
static char __READONLY_DATA privilegeUpdate[]		= "UPDATE";
static char __READONLY_DATA privilegeDelete[]		= "DELETE";
static char __READONLY_DATA privilegeReferences[]	= "REFERENCES";

//-----------------------------------------------------------------------------
SdbJDBCTable::SdbJDBCTable(SdbJDBCConnection* pConnection):SdbTable(pConnection){
	aStatus.SetComponent(String::CreateFromAscii("Sdb JDBC Driver"));
}
//-----------------------------------------------------------------------------
SdbIndex* SdbJDBCTable::CreateIndexImpl(){
	return new SdbJDBCIndex(this);
}
//-----------------------------------------------------------------------------
void SdbJDBCTable::FillIndexNames(SvStringsDtor& _rList)
{
	SdbJDBCConnection* pConnection = (SdbJDBCConnection*)GetConnection();
	SdbJDBCCursor* pCursor = (SdbJDBCCursor *) pConnection->CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	BOOL bCase = (pConnection->GetIdentifierCase() & SDB_IC_OBJECT) == SDB_IC_OBJECT;
	pCursor->AddRef();

	String* pQualifier = 0;
	if (aQualifierName.Len())
		pQualifier = new String(aQualifierName);

	String* pOwner = 0;
	if (aOwnerName.Len())
		pOwner = new String(aOwnerName);

	pCursor->OpenIndices(pQualifier,pOwner,&aName,FALSE);
	delete pQualifier;
	delete pOwner;
	/*	Reihenfolge
	1	TABLE_QUALIFIER
	2	TABLE_OWNER
	3	TABLE_NAME
	4	NON_UNIQUE
	5	INDEX_QUALIFIER
	6	INDEX_NAME
	7	TYPE
	8	SEQ_IN_INDEX
	9	COLUMN_NAME
	10	COLLATION
	*/
	USHORT i = 0;
	String aIndexName;
	while(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();

		ODbVariantRef pVal = rRow[6];
		ODbVariantRef pQualifier = rRow[5];
		String aNewIndexName;

		if(rRow[7]->toINT16() == 0 || pVal->getString().getStr() == aPKeyName)
		{		// Index des Pkeys rausfiltern
			pCursor->Next();
			continue;
		}
		if(pQualifier.is() && !pQualifier->isNull())
		{
			aNewIndexName = pQualifier->getString().getStr();
			aNewIndexName += '.';
		}
		aNewIndexName += pVal->getString().getStr();
		BOOL bNewIndex = (bCase) ? aIndexName != aNewIndexName
								 : !aIndexName.EqualsIgnoreCaseAscii(aNewIndexName);
		if(bNewIndex)
		{
			aIndexName = aNewIndexName;
			_rList.Insert(new String(aIndexName), i++);
		}
		pCursor->Next();
	}
	pCursor->Close();
	pCursor->ReleaseRef();

}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::OpenImpl()
{
	// Hier ist bekannt, dass es sich eigentlich um einen
	// SdbJDBCCursor handelt, daher Type Cast:
	SdbJDBCConnection* pConnection = (SdbJDBCConnection*)GetConnection();
	SdbJDBCCursor* pCursor = (SdbJDBCCursor *) pConnection->CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	aStatus = pCursor->Status();

	if(!aStatus.IsSuccessful()){
		pCursor->ReleaseRef();
		return FALSE;
	}

	BOOL bCase = pConnection->GetIdentifierCase() == SDB_IC_ALL;

	// Metadaten Interface
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = pConnection->GetMetaData();


	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	String* pQualifier = 0;
	if(aQualifierName.Len() && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
		pQualifier = new String(aQualifierName);

	String* pOwner = 0;
	if(aOwnerName.Len() && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
		pOwner = new String(aOwnerName);

	// Handelt es sich um eine Tabelle oder View
	String aStr; aStr.AssignAscii("VIEW");
	String aStr2(aName);
	pCursor->OpenTables(pQualifier,pOwner,&aStr2,aStr);
	if(pCursor->Status().IsSuccessful())
		bView = pCursor->IsInRange();
	pCursor->Close();

	// Columns auslesen
	String aStr3; aStr3.AssignAscii("%");
	pCursor->OpenColumns(pQualifier,pOwner,&aStr2,&aStr3);
	if(!pCursor->Status().IsSuccessful())
	{
		aStatus = pCursor->Status();
		aStatus = pCursor->Status();
		if(!aStatus.IsError())
		{
			String aErrMsg(SdbResId(STR_STAT_INVALID_TABLE_DEF));
			aErrMsg.SearchAndReplace(String::CreateFromAscii("'#'"),QualifiedName());
			aStatus.Set(SDB_STAT_ERROR,String::CreateFromAscii("S1000"),aErrMsg,0,String());
		}
		return FALSE;
	}

	INT32 i = 1;
	String aColumnName,aTypeName,aComment;
	try
	{
		while(pCursor->IsInRange())
		{
			ODbRow& rRow = *pCursor->GetRow();
			// Column-Info aufbauen ...
			aColumnName = rRow[4]->getString().getStr();
			int nJavaType = rRow[5]->toINT32();

			SdbDatabaseType eType(javaTyp2SdbTyp(nJavaType));
			if(eType == SDB_DBTYPE_BIGINT)
				eType = SDB_DBTYPE_DOUBLE;
			UINT32 nLength(0);
			UINT16 nScale(0);
			UINT16 nFlags(0);
			BOOL bNullAllowed(FALSE);

			aTypeName = rRow[6]->getString().getStr();

			ODbVariantRef pValue = rRow[7];
			if (pValue.is() && !pValue->isNull())
				nLength = (UINT32)pValue->toINT32();

			pValue = rRow[9];
			if (pValue.is() && !pValue->isNull())
				nScale = (UINT16)pValue->toINT32();

			pValue = rRow[11];
			if (pValue.is() && !pValue->isNull())
				bNullAllowed = (BOOL)pValue->toINT32();

			pValue = rRow[12];
			if (pValue.is() && !pValue->isNull())
				aComment = pValue->toString().getStr();

			// Sonderbehandlung fuer Currency ,Autoincrement
			const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(aTypeName,nLength,nScale,bNullAllowed,nJavaType);
			if(!pInfo)
			{
				pInfo = pConnection->GetColumnTypeInfo(eType); // das ist die letzte M"oglichkeit einen Typ zu bestimmen
			}
			DBG_ASSERT(pInfo, "Java Table: keine TypeInfo");

			// Zusaetzliche Flags:
			// bei unbekannten Typen ist pInfo NULL, z.B. benutzerdefinierten
			if (pInfo)
			{
//				if (bNullAllowed && pInfo->bNullable)
//					nFlags |= SDB_FLAGS_NULLALLOWED;
//				if (pInfo && pInfo->bCurrency)
//					eType = SDB_DBTYPE_CURRENCY;
//				else if (pInfo->bAutoIncrement)
//					nFlags |= SDB_FLAGS_AUTOINCREMENT;
				switch (pInfo->eSearchType)
				{
					case Search_Like_Only :
						nFlags |= SDB_FLAGS_SEARCH_LIKE;
						break;
					case Search_Except_Like:
						nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE;
						break;
					case Search_All:
						nFlags |= SDB_FLAGS_SEARCH_ALL;
						break;
				}
			}else // keine TypeInfo dann nullable
				nFlags |= SDB_FLAGS_NULLALLOWED;

			SdbColumn* pColumn = CreateColumn(aColumnName,eType,nLength,nScale,nFlags);
			pColumn->SetComment(aComment);

			// ... und in Columns-Struktur einfuegen
			aOriginalColumns->AddColumn(pColumn);
			pCursor->Next();
		}
	}
	catch ( ... )
	{
	}

	pCursor->Close();

	String aSelect; aSelect.AssignAscii("SELECT * FROM ");

	if(pQualifier)
	{
		aSelect += pConnection->IdentifierQuotation(aQualifierName);
		aSelect += pConnection->GetQualifierSeparator();
	}

	if(pOwner)
	{
		aSelect += pConnection->IdentifierQuotation(aOwnerName);
		aSelect += '.';
	}

	aSelect += pConnection->IdentifierQuotation(aName);
	aSelect.AssignAscii(" WHERE 0 = 1");
	if(pCursor->Open(aSelect))
	{
		SdbColumnsRef aColumns(pCursor->GetColumns());
		for(UINT16 i=0;i<aColumns->Count();i++)
		{
			const SdbColumn* pResCol = (*aColumns)[i];
			SdbColumn* pCol	 = (SdbColumn*)(*aOriginalColumns)[pResCol->GetName()];
			if(pCol)
			{
				pCol->SetType(pResCol->GetType());
				pCol->SetLength(max(pResCol->GetLength(),pCol->GetLength()));
				pCol->SetScale(max(pResCol->GetScale(),pCol->GetScale()));
				pCol->SetAllFlags(pResCol->GetAllFlags());
				pCol->SetFormatKey(pResCol->GetFormatKey());
			}
		}
	}
	pCursor->Close();

	pCursor->OpenPrimaryKeys(pQualifier,pOwner,&aStr2);
	aStatus = pCursor->Status();
	// setzen der uniqueflags
	if (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		// Name des PKeys
		ODbVariantRef pPKName = rRow[6/*PK_NAME*/];
		if (pPKName.is() && !pPKName->isNull())
			aPKeyName = pPKName->getString().getStr();
	}

	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		SdbColumn* pColumn = (SdbColumn*)aOriginalColumns->Column(rRow[4/*ColumnName*/]->getString().getStr());
		if (pColumn)
			pColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
		pCursor->Next();
	}
	pCursor->Close();

// Unique felder finden

	pCursor->OpenIndices(pQualifier,pOwner,&aStr2,TRUE);
	aStatus = pCursor->Status();
	String aIndexName,aIndexQualifier;

	try
	{
		// setzen der uniqueflags
		while (aStatus.IsSuccessful() && pCursor->IsInRange())
		{
			ODbRow& rRow = *pCursor->GetRow();
			if (rRow[7]->toINT16() != 0 ){//SQL_TABLE_STAT){
				SdbColumn* pColumn = NULL;
				ODbVariantRef pIndexQualifier = rRow[5];
				String aNewName = rRow[6]->getString().getStr();

				if ((bCase ? aIndexName == aNewName : aIndexName.EqualsIgnoreCaseAscii(aNewName))
					&& (!pIndexQualifier.is() || pIndexQualifier->isNull() ||
					(bCase ? pIndexQualifier->getString().getStr() == aIndexQualifier : pIndexQualifier->getString().equalsIgnoreCase(UniString(aIndexQualifier)))))
					pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[9]->getString().getStr()];
				else if (!aIndexName.Len())
				{
					if (rRow[4]->toString().equalsIgnoreCase(String::CreateFromAscii("false")))
					{
						aIndexName = aNewName;
						if (pIndexQualifier.is() && !pIndexQualifier->isNull())
							aIndexQualifier = pIndexQualifier->getString().getStr();
						pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[9]->getString().getStr()];
					}
				}
				if (pColumn)
					pColumn->SetFlag(SDB_FLAGS_UNIQUE);
			}
			pCursor->Next();
		}

	}
	catch ( ... )
	{
	}


	pCursor->Close();
	// setzen der Privileges
	nPrivileges = 0;
	sal_Bool bInfo;
	rMetaData->getInfo(::stardata::DatabaseInfo::READ_ONLY) >>= bInfo;
	if (bInfo)
		nPrivileges = SDB_PR_READ;
	else if (!aOwnerName.Len() || (bCase ? aOwnerName == pConnection->GetUser() : aOwnerName.EqualsIgnoreCaseAscii(pConnection->GetUser())))
	{
		// Tabelle gehoert dem Benutzer
		// der darf alles
		if(!bView)
		{
			nPrivileges |= (SDB_PR_READ	| SDB_PR_INSERT	| SDB_PR_UPDATE
				| SDB_PR_DELETE | SDB_PR_DROP
				| SDB_PR_REFERENCES );

			// Metadaten Interface
			::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = pConnection->GetMetaData();
			sal_Int16 nInfo;
			rMetaData->getInfo(::stardata::DatabaseInfo::TABLE_DEFINITION) >>= nInfo;
			if ((nInfo & ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN) ||
				(nInfo & ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN))
				nPrivileges |= SDB_PR_ALTER;
		}
		else
			nPrivileges |= (SDB_PR_READ	| SDB_PR_DROP);
	}
	else
	{
		pCursor->OpenTablePrivileges(pQualifier,pOwner,&aStr2);
		aStatus = pCursor->Status();
		if(!pCursor->IsInRange())
			nPrivileges = SDB_PR_READ;

		while (aStatus.IsSuccessful() && pCursor->IsInRange())
		{
			ODbRow& rRow = *pCursor->GetRow();
			ODbVariantRef pGrantee = rRow[5/*GRANTEE*/];
			if (pGrantee.is() &&
				!pGrantee->isNull() &&
				((bCase) ? pGrantee->getString().getStr() == aOwnerName :
				 pGrantee->getString().equalsIgnoreCase(UniString(aOwnerName))))
			{
				ODbVariantRef pPrivilege = rRow[6];
				String aPrivilege = pPrivilege.is() && !pPrivilege->isNull() ? String(pPrivilege->getString().getStr()) : String();
				if (aPrivilege.EqualsIgnoreCaseAscii(privilegeSelect))
					nPrivileges |= SDB_PR_READ;
				else if (aPrivilege.EqualsIgnoreCaseAscii(privilegeInsert))
					nPrivileges |= SDB_PR_INSERT;
				else if (aPrivilege.EqualsIgnoreCaseAscii(privilegeUpdate))
					nPrivileges |= SDB_PR_UPDATE;
				else if (aPrivilege.EqualsIgnoreCaseAscii(privilegeDelete))
					nPrivileges |= SDB_PR_DELETE;
				else if (aPrivilege.EqualsIgnoreCaseAscii(privilegeReferences))
					nPrivileges |= SDB_PR_REFERENCES;

			}
			pCursor->Next();
		}
		pCursor->Close();
	}

	String aTempName(aName);
	pCursor->OpenVersionColumns(pQualifier,pOwner,&aTempName);
	aStatus = pCursor->Status();
	while (aStatus.IsSuccessful() && pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		SdbColumn* pColumn = (SdbColumn*)(*aOriginalColumns)[rRow[2]->getString().getStr()];
		if(pColumn)
			pColumn->SetFlag(SDB_FLAGS_VERSIONING);
		else
		{
			// Column-Info aufbauen ...
			aColumnName = rRow[2]->getString().getStr();
			int nJavaType = rRow[3]->getINT16();

			SdbDatabaseType eType(javaTyp2SdbTyp(nJavaType));
			if(eType == SDB_DBTYPE_BIGINT)
				eType = SDB_DBTYPE_DOUBLE;
			UINT32 nLength(0);
			UINT16 nScale(0);
			UINT16 nFlags(SDB_FLAGS_VERSIONING);
			BOOL bNullAllowed(FALSE);

			aTypeName = rRow[4]->getString().getStr();

			ODbVariantRef pValue = rRow[5];
			if (pValue.is() && !pValue->isNull())
				nLength = (UINT32)pValue->getINT32();

			pValue = rRow[7];
			if (pValue.is() && !pValue->isNull())
				nScale = (UINT16)pValue->getINT32();

			// Sonderbehandlung fuer Currency ,Autoincrement
			const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(aTypeName,nLength,nScale,bNullAllowed,nJavaType);
			if(!pInfo)
				pInfo = pConnection->GetColumnTypeInfo(eType); // das ist die letzte M"oglichkeit einen Typ zu bestimmen

			DBG_ASSERT(pInfo, "Java Table: keine TypeInfo");

			// Zusaetzliche Flags:
			// bei unbekannten Typen ist pInfo NULL, z.B. benutzerdefinierten
			if (pInfo)
			{
				if (bNullAllowed && pInfo->bNullable)
					nFlags |= SDB_FLAGS_NULLALLOWED;
				if (pInfo && pInfo->bCurrency)
					eType = SDB_DBTYPE_CURRENCY;
				else if (pInfo->bAutoIncrement)
					nFlags |= SDB_FLAGS_AUTOINCREMENT;
				switch (pInfo->eSearchType)
				{
					case Search_Like_Only :
						nFlags |= SDB_FLAGS_SEARCH_LIKE;
						break;
					case Search_Except_Like:
						nFlags |= SDB_FLAGS_SEARCH_EXCEPT_LIKE;
						break;
					case Search_All:
						nFlags |= SDB_FLAGS_SEARCH_ALL;
						break;
				}
			}else // keine TypeInfo dann nullable
				nFlags |= SDB_FLAGS_NULLALLOWED;

			SdbColumn* pColumn = CreateColumn(aColumnName,eType,nLength,nScale,nFlags);
			// ... und in Columns-Struktur einfuegen
			aOriginalColumns->AddColumn(pColumn);
		}

		pCursor->Next();
	}

	delete pQualifier;
	delete pOwner;
	pCursor->ReleaseRef();
	if (aStatus.IsNoDataFound())
		aStatus.Clear();

	return aOriginalColumns->Count() > 1;
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::CreateImpl()
{
	SdbConnection* pConnection = GetConnection();
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = pConnection->GetMetaData();

	BOOL bNotNullAllowed = rMetaData->isCapable(::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS);

	// Metadaten nur einmal holen

	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	String aCommand; aCommand.AssignAscii("CREATE TABLE ");

	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aQualifierName);
		aCommand += pConnection->GetQualifierSeparator();
	}
	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}
	aCommand += pConnection->IdentifierQuotation(aName);
	aCommand += ' ';
	aCommand += '(';


	if(!GenerateAddCommands(aCommand,bNotNullAllowed)) // aCommand wird innerhalb veraendert
		return FALSE;


	sal_Int16 nConformance;
	rMetaData->getInfo(::stardata::DatabaseInfo::SQL_CONFORMANCE) >>= nConformance;;
	if ((nConformance & ::stardata::DatabaseSQLConformance::CORE) == ::stardata::DatabaseSQLConformance::CORE)
	{	//dann PRIMARY_KEYS
		String aPColumns;
		for (USHORT i = 1; i < aColumns->Count(); i++)
		{
			if (aColumns->Column(i)->IsPrimaryKey())
			{
				String aTmp2Str( aColumns->Column(i)->GetName());
				aPColumns += pConnection->IdentifierQuotation(aTmp2Str);
				aPColumns += ',';
			}
		}
		if (aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');
			aCommand.AssignAscii(" PRIMARY KEY (");
			aCommand += aPColumns;
			aCommand += ',';
		}
	}

	// Ein Komma ist sicherlich noch zuviel ...
	aCommand.SetChar(aCommand.Len() - 1,')');

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();
	if (aStatus.IsSuccessful())
	{
		nPrivileges = SDB_PR_READ | SDB_PR_INSERT |
				SDB_PR_UPDATE | SDB_PR_DELETE | SDB_PR_DROP;

		sal_Int16 nDefInfo;
		rMetaData->getInfo(::stardata::DatabaseInfo::TABLE_DEFINITION) >>= nDefInfo;
		if ((nDefInfo & ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN) || (nDefInfo & ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN))
			nPrivileges |= SDB_PR_ALTER | SDB_PR_REFERENCES;
	}
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::RenameImpl(const String& rNewName)
{
	// eine Warnung, dass wir Umbenennen nur durch Kopieren erreichen koennen
	SdbUiActionDescription aAsk;
	aAsk.eType = SdbUiActionDescription::YES_NO;
	aAsk.sMessage = String(SdbResId(RID_STR_WARNING_RENAME));
	SdbUiActionDescription::RETURN eResult = DoUiAction(aAsk);
	if ((eResult != SdbUiActionDescription::RETURN_YES) && (eResult != SdbUiActionDescription::RETURN_OK))
	{
		aStatus.Set(SDB_STAT_CANCELED);
		return FALSE;
	}

	SdbConnection* pConnection = GetConnection();
	// Metadaten nur einmal holen
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = pConnection->GetMetaData();

	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	String aOldName(aName);
	aName = rNewName;

	// Neue Tabelle unter neuen Namen anlegen
	if (!CreateImpl()){
		aName = aOldName;
		return FALSE;
	}


	String aQualified;
	if(aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		aQualified += pConnection->IdentifierQuotation(aQualifierName);
		aQualified += pConnection->GetQualifierSeparator();
	}
	if(aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML))
	{
		aQualified += pConnection->IdentifierQuotation(aOwnerName);
		aQualified += '.';
	}

	// Daten in die neue Tabelle kopieren
	String aStatement; aStatement.AssignAscii("INSERT INTO ");
	aStatement += aQualified;
	aStatement += pConnection->IdentifierQuotation(rNewName);
	aStatement.AssignAscii(" SELECT * FROM ");
	aStatement += aQualified;
	aStatement += pConnection->IdentifierQuotation(aOldName);

	if (!pConnection->ExecuteSQL(aStatement))
	{ // bei Mierfolg alten Zustand wiederherstellen
		SdbStatus aExecuteStatus = pConnection->Status();
		DropImpl();
		aStatus = aExecuteStatus;
		aName = aOldName;
		return FALSE;
	}

	// Alte Tabelle wegwerfen
	aName = aOldName;
	return DropImpl();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::DropImpl()
{
	SdbConnection* pConnection = GetConnection();
	// Metadaten nur einmal holen
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = pConnection->GetMetaData();

	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	String aCommand; aCommand.AssignAscii("DROP TABLE ");

	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aQualifierName);
		aCommand += pConnection->GetQualifierSeparator();
	}
	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aCommand += pConnection->IdentifierQuotation(aOwnerName);
		aCommand += '.';
	}

	aCommand += pConnection->IdentifierQuotation(aName);

	pConnection->ExecuteSQL(aCommand);
	aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::AlterImpl()
{
	// Alter wird immer ueber eine Transaktion ausgefuehrt
	SdbConnectionRef xConnection = GetConnection()->GetEnvironment()->OpenConnection(*GetConnection());
	if (!xConnection.Is())
	{
		aStatus = GetConnection()->GetEnvironment()->Status();
		return FALSE;
	}
		// Metadaten nur einmal holen
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetConnection()->GetMetaData();

	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	xConnection->BeginTrans();
	aStatus = xConnection->Status();
	if (!aStatus.IsSuccessful())
		return FALSE;


	BOOL bNotNullAllowed = rMetaData->isCapable(::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS);

	String aStatement;
	String aTableName;


	if (aQualifierName.Len() > 0 && (nCatalogUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aQualifierName);
		aTableName += xConnection->GetQualifierSeparator();
	}
	if (aOwnerName.Len() > 0 && (nSchemaUsage & ::stardata::DatabaseQualifier::IN_TABLE))
	{
		aTableName += xConnection->IdentifierQuotation(aOwnerName);
		aTableName += '.';
	}
	aTableName += xConnection->IdentifierQuotation(aName);

	// are drop and add allowed
	sal_Int16 nInfo;
	rMetaData->getInfo(::stardata::DatabaseInfo::TABLE_DEFINITION) >>= nInfo;

	BOOL bAddColumn = (nInfo & ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN) == ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN;
	BOOL bDropColumn = (nInfo & ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN) == ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN;
	// Zunaechst werden die Felder, die nicht mehr benoetigt werden, geloescht.
	UINT16 i;
	for(i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (bDropColumn && !pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AssignAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt; aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AssignAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if(!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// Die Felder, die sich geaendert haben, geloescht
	for (i = aOriginalColumns->Count() - 1; aStatus.IsSuccessful() && i > 0; i--)
	{
		const SdbColumn* pColumn = (*aOriginalColumns)[i];
		const SdbColumn* pRefColumn = (*aColumns)[pColumn->GetName()];
		if (bDropColumn && pRefColumn && !pColumn->Compare(*pRefColumn, SDB_FLAGS_NULLALLOWED))
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AssignAscii(" DROP ");
			aStatement += xConnection->IdentifierQuotation(pColumn->GetName());

			// wird eine Spalte mit PKeyInfo geloescht ?
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt; aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AssignAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();

			if (aStatus.IsSuccessful())
				aOriginalColumns->RemoveColumn(i);
		}
	}

	// und jetzt die neuen bzw. geaenderten hinzufuegen
	for (i = 1; aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (bAddColumn && !pRefColumn)
		{
			aStatement.AssignAscii("ALTER TABLE ");
			aStatement += aTableName;
			aStatement.AssignAscii(" ADD ");
			GenerateColumnCommand(aStatement, *pColumn, bNotNullAllowed);

			// gibt es eine neue Schluesselspalte, dann PKey loeschen
			if (aPKeyName.Len() && pColumn->IsPrimaryKey())
			{
				String aStmt; aStmt.AssignAscii("ALTER TABLE ");
				aStmt += aTableName;
				aStmt.AssignAscii(" DROP CONSTRAINT ");
				aStmt += aPKeyName;
				xConnection->ExecuteSQL(aStmt);
				aStatus = xConnection->Status();
				if (!aStatus.IsSuccessful())
					continue;
				else
					aPKeyName.Erase();
			}

			xConnection->ExecuteSQL(aStatement);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aOriginalColumns->AddColumn(CreateColumn(*pColumn));
		}
	}

	// gibt es noch Aenderungen am Schluessel
	for (i = 1; aPKeyName.Len() && aStatus.IsSuccessful() && i < aColumns->Count(); i++)
	{
		const SdbColumn* pColumn = (*aColumns)[i];
		const SdbColumn* pRefColumn = (*aOriginalColumns)[pColumn->GetName()];
		if (bDropColumn && pRefColumn && pColumn->IsPrimaryKey() != pRefColumn->IsPrimaryKey())
		{
			String aStmt; aStmt.AssignAscii("ALTER TABLE ");
			aStmt += aTableName;
			aStmt.AssignAscii(" DROP CONSTRAINT ");
			aStmt += aPKeyName;
			xConnection->ExecuteSQL(aStmt);
			aStatus = xConnection->Status();
			if (aStatus.IsSuccessful())
				aPKeyName.Erase();
		}
	}

	if(!aStatus.IsSuccessful())
	{
		xConnection->RollbackTrans();
		goto End;
	}

	if(!aPKeyName.Len())
	{ // muss jetzt noch ein PKey hinzugefuegt werden ?
		String aPColumns;
		for(UINT16 i = 1; i < aColumns->Count(); i++)
		{
			if((*aColumns)[i]->IsPrimaryKey())
			{
				aPColumns += xConnection->IdentifierQuotation((*aColumns)[i]->GetName());
				aPColumns += ',';
			}
		}
		if(bAddColumn && aPColumns.Len())
		{
			// Ein Komma ist sicherlich noch zuviel ...
			aPColumns.SetChar(aPColumns.Len()-1,')');

			String aCommand; aCommand.AssignAscii(" ALTER TABLE ");
			aCommand += aTableName;
			aCommand.AssignAscii(" ADD PRIMARY KEY (");
			aCommand += aPColumns;

			xConnection->ExecuteSQL(aCommand);
			aStatus = xConnection->Status();
		}
	}

	if (!aStatus.IsSuccessful() || !xConnection->CommitTrans())
	{
		aStatus = xConnection->Status();
		xConnection->RollbackTrans();
	}

End: // zum schlu nochmals einlesen
	return aStatus.IsSuccessful();
}
//-----------------------------------------------------------------------------
void SdbJDBCTable::CloseImpl(){}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::GenerateAddCommands(String& rStatement, BOOL bNotNullAllowed)
{
	// Welche neuen Columns gibt es jetzt?
	// (Erkennbar an "fehlender" Identitaet (Id == 0))
	for (INT32 i = 1; i < aColumns->Count(); i++)
	{
		const SdbColumn * pColumn = (*aColumns)[i];
		if (!GenerateColumnCommand(rStatement, *pColumn, bNotNullAllowed))
			return FALSE;

		rStatement += ',';
	}
	return TRUE;
}
//-----------------------------------------------------------------------------
BOOL SdbJDBCTable::GenerateColumnCommand(String& rStatement, const SdbColumn& rColumn, BOOL bNotNullAllowed)
{
	SdbConnection* pConnection = GetConnection();
	// Gibt es zu dieser Column eine Typinformationen
	const SdbTypeInfo* pInfo = pConnection->GetColumnTypeInfo(rColumn);

	if (!pInfo)
	{
		pInfo = pConnection->GetColumnTypeInfo(rColumn.GetType());
		if(!pInfo)
		{
			DBG_ASSERT(0,"Java Table: GetColumnTypeInfo == NULL");
			aStatus.SetDriverNotCapableError();
			return FALSE;
		}
	}

	rStatement += pConnection->IdentifierQuotation(rColumn.GetName());
	rStatement += ' ';
	rStatement += pInfo->aTypeName;

	switch(pInfo->eType)
	{
		case SDB_DBTYPE_CHAR:
		case SDB_DBTYPE_VARCHAR:
		case SDB_DBTYPE_BINARY:
		case SDB_DBTYPE_VARBINARY:
			// Typen mit Laengenangabe
			if(pInfo->aCreateParams.Len()) // only when the driver accepts create params
			{
				rStatement += '(';
				rStatement += String::CreateFromInt32(rColumn.GetLength());
				rStatement += ')';
			}
			break;
		case SDB_DBTYPE_DECIMAL:
		case SDB_DBTYPE_NUMERIC:
			// Typen mit Precision und Scale
			if(pInfo->aCreateParams.Len()) // only when the driver accepts create params
			{
				rStatement += '(';
				rStatement += String::CreateFromInt32(rColumn.GetPrecision());
				rStatement += ',';
				rStatement += String::CreateFromInt32(rColumn.GetScale());
				rStatement += ')';
			}
			break;
	}

	if (!rColumn.IsNullAllowed() && bNotNullAllowed)
		rStatement.AssignAscii(" NOT NULL");

	return TRUE;
}

