/*************************************************************************
 *
 *  $RCSfile: kstart.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#define ENABLE_BYTESTRING_STREAM_OPERATORS
#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _FSYS_HXX
#include <tools/fsys.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SDB_SDBENV_HXX
#include "sdbenv.hxx"
#endif

#ifndef _INC_TYPES
#include <sys/types.h>
#endif
#ifndef _INC_STAT
#include <sys/stat.h>
#endif

#if defined(MAC)
const char __FAR_DATA sNewLine = '\015';
#elif defined(UNX)
const char __FAR_DATA sNewLine = '\012';
#else
const char __FAR_DATA sNewLine[] = "\015\012";
#endif
// comands from adabas
static ByteString aDelimit(DirEntry::GetAccessDelimiter(),gsl_getSystemTextEncoding());
static String xutil;
static String x_cons;
static String xload;
static String x_param;
static String getparam;
static String putparam;

#define EXECUTE(name) \
	::vos::OProcess::TProcessError eError = name.execute((::vos::OProcess::TProcessOption)		\
							(::vos::OProcess::TOption_Wait)										\
							,aArgumentList);
//-------------------------------------------------------------------------------------------------
int X_START(const ByteString& _DBNAME)
{
	ByteString aExe(getenv("DBROOT") ? getenv("DBROOT") : "");

#if defined(WIN) || defined(WNT)
	(((aExe += aDelimit ) += "pgm") += aDelimit) += "strt.exe";
	::rtl::OUString aArgs[] = {
						String::CreateFromAscii("-d"),
						String::CreateFromAscii(_DBNAME.GetBuffer()),
						String::CreateFromAscii("-NoDBWindow"),
						String::CreateFromAscii("-NoDBService")
	};

	::vos::OArgumentList aArgumentList(aArgs,4);
#else
	(((aExe += aDelimit ) += "bin") += aDelimit) += "x_start";
	rtl::OUString aArgStr(rtl::OUString::createFromAscii(_DBNAME.GetBuffer()));
	::vos::OArgumentList aArgumentList(1,&aArgStr);
#endif

	::vos::OProcess aApp( String::CreateFromAscii(aExe.GetBuffer()),String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));

	EXECUTE(aApp);

	if(eError != ::vos::OProcess::E_None)
		return 1;
	::vos::OProcess::TProcessInfo aInfo;
	if(aApp.getInfo(::vos::OProcess::TData_ExitCode,&aInfo) == ::vos::OProcess::E_None && aInfo.Code)
		return aInfo.Code;

	return 0;
}
//-------------------------------------------------------------------------------------------------
int X_STOP(const ByteString& _DBNAME)
{
	ByteString aExe(getenv("DBROOT") ? getenv("DBROOT") : "");
#if defined(WIN) || defined(WNT)
	(((aExe += aDelimit ) += "pgm") += aDelimit) += "stp.exe";
	::rtl::OUString aArgs[] = {
						String::CreateFromAscii("-d"),
						String::CreateFromAscii(_DBNAME.GetBuffer()),
						String::CreateFromAscii("-NoDBService")
	};
	::vos::OArgumentList aArgumentList(aArgs,3);
#else
	(((aExe += aDelimit ) += "bin") += aDelimit) += "x_stop";
	rtl::OUString aArgStr(rtl::OUString::createFromAscii(_DBNAME.GetBuffer()));
	::vos::OArgumentList aArgumentList(1,&aArgStr);

#endif
	::vos::OProcess aApp( String::CreateFromAscii(aExe.GetBuffer()),String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));

	EXECUTE(aApp);

	if(eError != ::vos::OProcess::E_None)
		return 1;
		::vos::OProcess::TProcessInfo aInfo;
	if(aApp.getInfo(::vos::OProcess::TData_ExitCode,&aInfo) == ::vos::OProcess::E_None && aInfo.Code)
		return aInfo.Code;

	return 0;
}
//-------------------------------------------------------------------------------------------------
void PutParam(const ByteString& rDBNAME,const ByteString& rWhat,const ByteString& rHow)
{
	::rtl::OUString aArgs[] = {
						String::CreateFromAscii(rDBNAME.GetBuffer()),
						String::CreateFromAscii(rWhat.GetBuffer()),
						String::CreateFromAscii(rHow.GetBuffer())
	};
	::vos::OArgumentList aArgumentList(aArgs,3);

	::vos::OProcess aApp( putparam,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	EXECUTE(aApp);

	DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at putparam");
}
//-------------------------------------------------------------------------------------------------
void LoadBatch(const ByteString& _DBNAME,const ByteString& _USR,const ByteString& _PWD,const ByteString& _rBatch)
{
#if defined(WIN) || defined(WNT)
	ByteString DBROOT = getenv("DBROOT") ? getenv("DBROOT") : "";
	ByteString aExe( DBROOT);
	aExe += "\\bin\\xload.exe";

	String aU;
	((aU.AssignAscii(_USR.GetBuffer())) += ',').AppendAscii(_PWD.GetBuffer());
	::rtl::OUString aArgs[] = {
						String::CreateFromAscii("-u"),
						aU,
						String::CreateFromAscii("-d"),
						String::CreateFromAscii(_DBNAME.GetBuffer()),
						String::CreateFromAscii("-S"),
						String::CreateFromAscii("adabas"),
						String::CreateFromAscii("-b"),
						String::CreateFromAscii(_rBatch.GetBuffer())
	};
	::vos::OArgumentList aArgumentList(aArgs,8);

	::vos::OProcess aApp( xload,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	EXECUTE(aApp);

	DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at LoadBatch");
#else

	DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
	String aFileName = aEntry.GetFull();
	{
		SvFileStream aFileStream(aFileName,STREAM_WRITE);
		aFileStream << "#!/bin/sh" << sNewLine;
		aFileStream << "cd \"$DBWORK\"" << sNewLine;
		aFileStream << ByteString(xload,gsl_getSystemTextEncoding()).GetBuffer()
					<< " -d " << _DBNAME.GetBuffer();
		aFileStream << " -u "<< _USR.GetBuffer() << "," << _PWD.GetBuffer();
		aFileStream << " -S adabas " << _rBatch.GetBuffer();
#if defined (DEBUG) || defined(DBG_UTIL)
		aFileStream << " >> /tmp/kstart.log";
#else
		aFileStream << " > /dev/null";
#endif
		aFileStream << sNewLine;
	}
	DirEntry aBatchEntry(aEntry);

	chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);

	aFileName = aBatchEntry.GetFull();
	::vos::OProcess aApp( aFileName ,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)
				  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait) );
	DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at LoadBatch");
	aBatchEntry.Kill();
#endif
}
//-------------------------------------------------------------------------------------------------
#define SHOW_STATE()																					\
	{																									\
		::rtl::OUString aArgs[] = {																				\
						String::CreateFromAscii(DBNAME.GetBuffer()),									\
						String::CreateFromAscii("show"),												\
						String::CreateFromAscii("state")												\
		};																								\
		::vos::OArgumentList aArgumentList(aArgs,3);													\
		::vos::OProcess aApp( x_cons,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));						\
		::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)			\
					  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait),aArgumentList ); \
		DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at SHOWSTATE");								\
	}
//-------------------------------------------------------------------------------------------------
void XUTIL(const ByteString& _rParam,const ByteString& _DBNAME,const ByteString& _USRNAME,const ByteString& _USRPWD)
{
	DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
	String aFileName = aEntry.GetFull();
	{
		SvFileStream aFileStream(aFileName,STREAM_WRITE);
#if !(defined(WIN) || defined(WNT))
		aFileStream << "#!/bin/sh" << sNewLine;
		aFileStream << "cd \"$DBWORK\"" << sNewLine;
#endif
		aFileStream << ByteString(xutil,gsl_getSystemTextEncoding()).GetBuffer();
		aFileStream << " -u "<< _USRNAME.GetBuffer() << "," << _USRPWD.GetBuffer();
		aFileStream << " -d " << _DBNAME.GetBuffer();
		aFileStream << " " << _rParam.GetBuffer();
#if !(defined(WIN) || defined(WNT))
#if defined(DEBUG) || defined(DBG_UTIL)
		aFileStream << " >> /tmp/kstart.log";
#else
		aFileStream << " > /dev/null";
#endif
#endif
		aFileStream << sNewLine;
	}
	DirEntry aBatchEntry(aEntry);

#if defined(WIN) || defined(WNT)
	aBatchEntry.SetExtension(String::CreateFromAscii("bat"));
	aEntry.MoveTo(aBatchEntry);
#else
	chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);
#endif


	aFileName = aBatchEntry.GetFull();
	::vos::OProcess aApp( aFileName,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	aApp.execute( (::vos::OProcess::TProcessOption)
#if DEBUG
				(::vos::OProcess::TOption_Wait)
#else
				(::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait)
#endif
				);
	aBatchEntry.Kill();
}
//-------------------------------------------------------------------------------------------------
#define XUTIL_COMMAND1(pParam)																			\
	{																									\
		ByteString aU(CONUSR);																			\
		(aU += ",") += CONPWD;																			\
		::rtl::OUString aArgs[] = {																				\
						String::CreateFromAscii("-u"),													\
						String::CreateFromAscii(aU.GetBuffer()),										\
						String::CreateFromAscii("-d"),													\
						String::CreateFromAscii(DBNAME.GetBuffer()),									\
						String::CreateFromAscii(pParam)													\
		};																								\
		::vos::OArgumentList aArgumentList(aArgs,5);													\
		::vos::OProcess aApp( xutil,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));							\
		::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)			\
					  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait),aArgumentList );\
		DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at XUTIL_COMMAND");							\
	}

//-------------------------------------------------------------------------------------------------
#define XUTIL_COMMAND2(pParam, pParam1)																	\
	{																									\
		ByteString aU(CONUSR);																			\
		(aU += ",") += CONPWD;																			\
		::rtl::OUString aArgs[] = {																				\
						String::CreateFromAscii("-u"),													\
						String::CreateFromAscii(aU.GetBuffer()),										\
						String::CreateFromAscii("-d"),													\
						String::CreateFromAscii(DBNAME.GetBuffer()),									\
						String::CreateFromAscii(pParam),												\
						String::CreateFromAscii(pParam1)												\
		};																								\
		::vos::OArgumentList aArgumentList(aArgs,6);													\
																										\
		::vos::OProcess aApp( xutil,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));							\
		::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)			\
					  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait),aArgumentList );\
		DBG_ASSERT(eError == ::vos::OProcess::E_None,"Error at XUTIL_COMMAND");							\
	}

//-------------------------------------------------------------------------------------------------
void LoadTables(const ByteString &DBNAME,const ByteString &USR,const ByteString &PWD,const ByteString &LOADCMD)
{
	ByteString aU;
	((aU += USR) += ",") += PWD;
	::rtl::OUString aArgs[] = {
						String::CreateFromAscii("-d"),
						String::CreateFromAscii(DBNAME.GetBuffer()),
						String::CreateFromAscii("-u"),
						String::CreateFromAscii(aU.GetBuffer()),
						String::CreateFromAscii("-b"),
						String::CreateFromAscii(LOADCMD.GetBuffer())
	};
	::vos::OArgumentList aArgumentList(aArgs,6);
	::vos::OProcess aApp( xutil,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	EXECUTE(aApp);
}
//-------------------------------------------------------------------------------------------------
void X_CONS(const ByteString& _DBNAME,const ByteString& _ACTION,const ByteString& _FILENAME)
{
	DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
	String aFileName = aEntry.GetFull();
	{
		SvFileStream aFileStream(aFileName,STREAM_WRITE);
#if !(defined(WIN) || defined(WNT))
		aFileStream << "#!/bin/sh" << sNewLine;
		aFileStream << "cd \"$DBWORK\"" << sNewLine;
		//aFileStream << "cd $DBWORK" << sNewLine;
#endif
		aFileStream << ByteString(x_cons,gsl_getSystemTextEncoding()).GetBuffer()
					<< " "
					<< _DBNAME.GetBuffer()
					<< " SHOW "
					<< _ACTION.GetBuffer()
					<< " > "
					<< _FILENAME.GetBuffer()
					<< sNewLine;
	}
	DirEntry aBatchEntry(aEntry);

#if defined(WIN) || defined(WNT)
	aBatchEntry.SetExtension(String::CreateFromAscii("bat"));
	aEntry.MoveTo(aBatchEntry);
#else
	chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);
#endif

	aFileName = aBatchEntry.GetFull();
	::vos::OProcess aApp( aFileName,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	aApp.execute( (::vos::OProcess::TProcessOption)
				  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait) );

	aBatchEntry.Kill();
}
//-------------------------------------------------------------------------------------------------
BOOL ExistDB(const ByteString &DBNAME,const ByteString &USR,const ByteString &PWD)
{
	String aTest;aTest.AssignAscii(getenv("DBCONFIG") ? getenv("DBCONFIG") : "");
	aTest += DirEntry::GetAccessDelimiter();
	aTest.AppendAscii("config");
	aTest += DirEntry::GetAccessDelimiter();
	aTest.AppendAscii(DBNAME.GetBuffer());
	DirEntry aDBName(aTest);
	if(aDBName.Exists())
	{
		DirEntry aOut(DirEntry().TempName(FSYS_KIND_FILE));
		X_CONS(DBNAME,"STATE",ByteString(aOut.GetFull(),gsl_getSystemTextEncoding()));
		{
			SvFileStream aOutStream(aOut.GetFull(),STREAM_READ);
			KernelState eState = DEAD;
			BOOL bRead = TRUE;
			int nStart = 2;
			while(bRead && !aOutStream.IsEof())
			{
				ByteString aLine;
				bRead = aOutStream.ReadLine(aLine);
				if(aLine.Search("WARM") != STRING_NOTFOUND)
				{
					nStart = 0;
					break;
				}
				else if(aLine.Search("COLD") != STRING_NOTFOUND)
				{
					nStart = 1;
					break;
				}
			}
			switch(nStart)
			{
				case 2:
					X_START(DBNAME);
				case 1:
					XUTIL("RESTART",DBNAME,USR,PWD);
				case 0:
					break;
			}
		}
		aOut.Kill();
		return TRUE;
	}
	return FALSE;
}
//-------------------------------------------------------------------------------------------------
BOOL CreateFile(const ByteString &_FileName,INT32 _nSize)
{
	BOOL bOK = TRUE;
	String aFn(_FileName,gsl_getSystemTextEncoding());
	DirEntry aFile(aFn);
	if(!aFile.Exists())
	{
		SvFileStream aFileStream(aFn,STREAM_WRITE);
		aFileStream.SetFiller('\0');
		bOK = aFileStream.SetStreamSize(_nSize*4096);
	}
	return bOK;
	// dd if=/dev/zero bs=4k of=$DEV_NAME count=$2
}
//-------------------------------------------------------------------------------------------------
void CreateBspFile(const ByteString& _File,const String& _New)
{
	ByteString aDBWORK(getenv("DBWORK") ? getenv("DBWORK") : "");
	aDBWORK += aDelimit;
	SvFileStream aFileStream(String(_File,gsl_getSystemTextEncoding()),STREAM_READ);
	SvFileStream aStream(_New,STREAM_WRITE);
	BOOL bRead = TRUE;
	ByteString aValue;
	while(bRead && !aFileStream.IsEof())
	{
		bRead = aFileStream.ReadLine(aValue);
		if(aValue.Search("* sys devspace name:") != STRING_NOTFOUND ||
			aValue.Search("* log devspace name:") != STRING_NOTFOUND ||
			aValue.Search("* data devspace name:") != STRING_NOTFOUND)
		{
			aStream << aValue.GetBuffer()	<< sNewLine;
			bRead = aFileStream.ReadLine(aValue);
			ByteString aTmp = aDBWORK;
			aTmp += aValue;
			aStream << aTmp.GetBuffer()		<< sNewLine;
		}
		else
			aStream << aValue.GetBuffer()	<< sNewLine;

	}
}
//-------------------------------------------------------------------------------------------------
int CreateFiles(const ByteString& _INITCMD,ByteString &_SysDefOut,ByteString &_TransDefOut)
{
	SvFileStream aFileStream(String(_INITCMD,gsl_getSystemTextEncoding()),STREAM_READ);
	BOOL bRead = TRUE;
	ByteString aSysDevSpace,aLogDevSpace,aDatadevSpace;
	INT32 nLogSize,nDatadevSize;
	ByteString aValue;
	while(bRead && !aFileStream.IsEof())
	{
		bRead = aFileStream.ReadLine(aValue);
		if(aValue.Search("* sys devspace name:") != STRING_NOTFOUND)
			break;
	}
	if(!bRead)
		return 1;
	aFileStream.ReadLine(aSysDevSpace);
	bRead = aFileStream.ReadLine(aValue);
	if(aValue.Search("* log devspace size:") != STRING_NOTFOUND)
	{
		aFileStream.ReadLine(aValue);
		nLogSize = (INT32)aValue.ToInt32();
	}
	bRead = aFileStream.ReadLine(aValue);
	if(aValue.Search("* log devspace name:") != STRING_NOTFOUND)
	{
		aFileStream.ReadLine(aLogDevSpace);
	}
	bRead = aFileStream.ReadLine(aValue);
	if(aValue.Search("* data devspace size:") != STRING_NOTFOUND)
	{
		aFileStream.ReadLine(aValue);
		nDatadevSize = (INT32)aValue.ToInt32();
	}
	bRead = aFileStream.ReadLine(aValue);
	if(aValue.Search("* data devspace name:") != STRING_NOTFOUND)
	{
		aFileStream.ReadLine(aDatadevSpace);
	}

	int nRet = CreateFile(aSysDevSpace,nDatadevSize/50) ? 0 : -9;
	if(!nRet)
		nRet = CreateFile(aLogDevSpace,nLogSize) ? 0 : -10;
	if(!nRet)
		nRet = CreateFile(aDatadevSpace,nDatadevSize) ? 0 : -11;

	_SysDefOut   = aSysDevSpace;
	_TransDefOut = aLogDevSpace;
	return nRet;

}
//-------------------------------------------------------------------------------------------------
int X_PARAM(const ByteString& _DBNAME,const ByteString& _USR,const ByteString& _PWD,const ByteString& _CMD)
{
	//	%XPARAM% -u %CONUSR%,%CONPWD% BINIT
	DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
	String aFileName = aEntry.GetFull();
	{
		SvFileStream aFileStream(aFileName,STREAM_WRITE);
#if !(defined(WIN) || defined(WNT))
		aFileStream << "#!/bin/sh" << sNewLine;
		aFileStream << "cd \"$DBWORK\"" << sNewLine;
#endif
		aFileStream << ByteString(x_param,gsl_getSystemTextEncoding()).GetBuffer()
					<< " -d " << _DBNAME.GetBuffer();
		aFileStream << " -u "<< _USR.GetBuffer()
					<< "," << _PWD.GetBuffer();
		aFileStream << " " << _CMD.GetBuffer();
#if !(defined(WIN) || defined(WNT))
#if defined(DEBUG) || defined(DBG_UTIL)
		aFileStream << " >> /tmp/kstart.log";
#else
		aFileStream << " > /dev/null";
#endif
#endif
		aFileStream << sNewLine;
	}
	DirEntry aBatchEntry(aEntry);

#if defined(WIN) || defined(WNT)
	aBatchEntry.SetExtension(String::CreateFromAscii("bat"));
	aEntry.MoveTo(aBatchEntry);
#else
	chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);
#endif

	aFileName = aBatchEntry.GetFull();
	::vos::OProcess aApp( aFileName ,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
	::vos::OProcess::TProcessError eError = aApp.execute( (::vos::OProcess::TProcessOption)
				  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait) );

	aBatchEntry.Kill();

	if(eError != ::vos::OProcess::E_None)
		return -1;

	::vos::OProcess::TProcessInfo aInfo;
	if(aApp.getInfo(::vos::OProcess::TData_ExitCode,&aInfo) == ::vos::OProcess::E_None && aInfo.Code)
		return aInfo.Code;

	return 0;
}
//-------------------------------------------------------------------------------------------------
//	-d	x_cons show state
//	-k	x_start
//	-c	getparam DATA_CACHE_PAGES
//	-p	putparam DATA_CACHE_PAGES
//	-n	xutil BATCHFILE
//	-x	xutil SHUTDOWN QUICK
//	-r	xutil RESTART
//	-t	x_stop DBNAME

// Error Codes
//	-1	no argument
//	-2	DBROOT or DBWORK or DBCONFIG are not set
//	-3	not (or too) enough arguments
//	-4	some needed values are not set, check arguments
//	-5	x_param with BINIT returns error
//	-6	Files could not be readed from the init script
//	-7	x_param with BCHECK returns error
//	-8	the database could not be started
//	-9	SysDevSpace could be created
//	-10	LogDevSpace could be created
//	-11	DataDevSpace could be created

int
#ifdef WNT
__cdecl
#endif
main(int argc, char * argv[])
{
	if(argc == 1)
		return -1;

	ByteString DBROOT	= getenv("DBROOT") ? getenv("DBROOT") : "";
	ByteString DBWORK	= getenv("DBWORK") ? getenv("DBWORK") : "";
	ByteString DBCONFIG	= getenv("DBCONFIG") ? getenv("DBCONFIG") : "";
	ByteString aT1;
#if defined(WIN) || defined(WNT)
	((((aT1		= DBROOT)	+= aDelimit) += "bin") += aDelimit) += "xutil";
#else
	((((aT1		= DBROOT)	+= aDelimit) += "pgm") += aDelimit) += "utility";
#endif
	xutil.AssignAscii(aT1.GetBuffer());
	((((aT1		= DBROOT)	+= aDelimit) += "bin") += aDelimit) += "x_cons";
	x_cons.AssignAscii(aT1.GetBuffer());
	((((aT1		= DBROOT)	+= aDelimit) += "bin") += aDelimit) += "xload";
	xload.AssignAscii(aT1.GetBuffer());
	((((aT1		= DBROOT)	+= aDelimit) += "bin") += aDelimit) += "x_param";
	x_param.AssignAscii(aT1.GetBuffer());
	((((aT1		= DBROOT)	+= aDelimit) += "pgm") += aDelimit) += "getparam";
	getparam.AssignAscii(aT1.GetBuffer());
	((((aT1		= DBROOT)	+= aDelimit) += "pgm") += aDelimit) += "putparam";
	putparam.AssignAscii(aT1.GetBuffer());


#if defined(WIN) || defined(WNT)
	xutil.AppendAscii(".exe");
	x_cons.AppendAscii(".exe");
	xload.AppendAscii(".exe");
	x_param.AppendAscii(".exe");
	getparam.AppendAscii(".exe");
	putparam.AppendAscii(".exe");
#endif

	BOOL bNewDb = FALSE;

	if(!DBROOT.Len() && !DBWORK.Len() && !DBCONFIG.Len())
		return -2;

	if(ByteString(argv[1]) == "-d" && argc == 4)
	{
		X_CONS(argv[2],"STATE",argv[3]);
	}
	else if(ByteString(argv[1]) == "-x" && argc == 5)
	{
		ByteString DBNAME = argv[2];
		ByteString CONUSR = argv[3];
		ByteString CONPWD = argv[4];
#if defined(WIN) || defined(WNT)
		XUTIL_COMMAND2("SHUTDOWN","QUICK");
#else
		XUTIL("SHUTDOWN QUICK",DBNAME,CONUSR,CONPWD);
#endif
	}
	else if(ByteString(argv[1]) == "-r" && argc == 5)
	{
		ByteString DBNAME = argv[2];
		ByteString CONUSR = argv[3];
		ByteString CONPWD = argv[4];
#if defined(WIN) || defined(WNT)
		XUTIL_COMMAND1("RESTART");
#else
		XUTIL("RESTART",DBNAME,CONUSR,CONPWD);
#endif
	}
	else if(ByteString(argv[1]) == "-k" && argc == 3)
	{
		X_START(argv[2]);
	}
	else if(ByteString(argv[1]) == "-t" && argc == 3)
	{
		X_STOP(argv[2]);
	}
	else if(ByteString(argv[1]) == "-f" && argc == 4)
	{
		//	x_cons %2 SHOW TASKS > %3
		X_CONS(argv[2],"TASKS",argv[3]);
	}
	else if(ByteString(argv[1]) == "-c")
	{
		//	%DBROOT%\pgm\getparam %2 DATA_CACHE_PAGES > %3
		DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
		String aFileName = aEntry.GetFull();
		{
			SvFileStream aFileStream(aFileName,STREAM_WRITE);
#if !(defined(WIN) || defined(WNT))
			aFileStream << "#!/bin/sh" << sNewLine;
			aFileStream << "cd \"$DBWORK\"" << sNewLine;
#endif
			aFileStream << ByteString(getparam,gsl_getSystemTextEncoding()).GetBuffer()
						<< " " << argv[2] << " DATA_CACHE_PAGES > " << argv[3] << sNewLine;
		}
		DirEntry aBatchEntry(aEntry);
#if defined(WIN) || defined(WNT)
		aBatchEntry.SetExtension(String::CreateFromAscii("bat"));
		aEntry.MoveTo(aBatchEntry);
#else
		chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);
#endif

		::vos::OProcess aApp( aBatchEntry.GetFull(),String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
		aApp.execute( (::vos::OProcess::TProcessOption)
					  (::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait) );
		aBatchEntry.Kill();
	}
	else if(ByteString(argv[1]) == "-p")
	{
		//	%DBROOT%\pgm\putparam %2 DATA_CACHE_PAGES %3
		PutParam(argv[2],"DATA_CACHE_PAGES",argv[3]);
		if(X_PARAM(argv[2],argv[4],argv[5],"BCHECK"))
			return -7;
	}
	else if(ByteString(argv[1]) == "-n")
	{
		//	%DBROOT%\bin\xutil -u %2,%3 -d %4 -b %5
		{ // first create the file
			SvFileStream aFileStream(String::CreateFromAscii(argv[5]),STREAM_READ);
			ByteString aLine;
			aFileStream.ReadLine(aLine);
			xub_StrLen nPos = aLine.Search("'");
			xub_StrLen nPos2 = aLine.Search("'",nPos+1);
			xub_StrLen nPos3 = aLine.Search("PAGES ");

			CreateFile(aLine.Copy(nPos+1,nPos2-nPos-2),aLine.Copy(nPos3).ToInt32());
		}
		ByteString aTmp("-b");
		aTmp += argv[5];

		XUTIL(aTmp,argv[4],argv[2],argv[3]);
	}
	else
	{

		ByteString DBNAME,CONUSR,CONPWD,SYSUSR,SYSPWD,DOMPWD,SYSDEV,TRANSLOGDEV,CACHESIZE,INITCMD,ERRORLOG,USRNAME,USRPWD,CATFILE,TABFILE;
		BOOL bNewDb = TRUE;
		BOOL bBsp = TRUE;
		if(ByteString(argv[1]) == "-s")
		{
			SvFileStream aFileStream(String::CreateFromAscii(argv[2]),STREAM_READ);
			vector<ByteString> aSTR;
			BOOL bRead = TRUE;
			while(bRead && !aFileStream.IsEof())
			{
				ByteString aLine;
				bRead = aFileStream.ReadLine(aLine);
				INT32 nCount = aLine.GetQuotedTokenCount("\"\"",' ');
				for(INT32 i=0;i<nCount;++i)
					aSTR.push_back(aLine.GetQuotedToken(i,"\"\"",' '));
			}
			if(aSTR.size() != 12)
				return -3;
			vector<ByteString>::const_iterator aIter = aSTR.begin();
			DBNAME		= (*aIter); aIter++;
			CONUSR		= (*aIter); aIter++;
			CONPWD		= (*aIter); aIter++;
			SYSUSR		= (*aIter); aIter++;
			SYSPWD		= (*aIter); aIter++;
			DOMPWD		= (*aIter); aIter++;
			CACHESIZE	= (*aIter); aIter++;
			INITCMD		= (*aIter); aIter++;
			CATFILE		= (*aIter); aIter++;
			TABFILE		= (*aIter); aIter++;
			USRNAME		= (*aIter); aIter++;
			USRPWD		= (*aIter); aIter++;
			bNewDb = !ExistDB(DBNAME,CONUSR,CONPWD);
			INITCMD.EraseLeadingChars('\"');
			INITCMD.EraseTrailingChars('\"');
			CATFILE.EraseLeadingChars('\"');
			CATFILE.EraseTrailingChars('\"');
			TABFILE.EraseLeadingChars('\"');
			TABFILE.EraseTrailingChars('\"');
		}
		else
		{
			ByteString aLine(argv[1]);

			SvFileStream aFileStream(String(aLine.GetQuotedToken(0,"\"\"",' '),gsl_getSystemTextEncoding()),STREAM_READ);
			aFileStream >> DBNAME;
			aFileStream >> CONUSR;
			aFileStream >> CONPWD;
			aFileStream >> SYSUSR;
			aFileStream >> SYSPWD;
			aFileStream >> DOMPWD;
			aFileStream >> CACHESIZE;
			aFileStream >> INITCMD;
			bBsp = FALSE;
		}

		putenv("DBSERVICE=0");


		if(	!DBNAME.Len() && !CONUSR.Len()	&& !CONPWD.Len() && !SYSUSR.Len() &&
			!SYSPWD.Len() && !DOMPWD.Len()	&& !SYSDEV.Len() && !TRANSLOGDEV.Len() &&
			!CACHESIZE.Len() && !INITCMD.Len())
			return -4;

		if(bNewDb)
		{
			// create dirs
			{
				DirEntry aWork(String::CreateFromAscii(DBWORK.GetBuffer()));
				if(!aWork.Exists())
					aWork.MakeDir();
			}
			{
				String aTmp(String::CreateFromAscii(DBWORK.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("wrk");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}

			{
				String aTmp(String::CreateFromAscii(DBWORK.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("wrk");
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("config");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}
			{
				DirEntry aWork(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				if(!aWork.Exists())
					aWork.MakeDir();
			}
			{
				String aTmp(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("config");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}
#if !(defined(WIN) || defined(WNT))
			{
				String aTmp(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("diag");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}
			{
				String aTmp(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("ipc");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}
			{
				String aTmp(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("spool");
				DirEntry aWork(aTmp);
				if(!aWork.Exists())
					aWork.MakeDir();
			}
#endif

			ByteString RUNDIRECTORY	= DBWORK;
			(((RUNDIRECTORY += aDelimit) +="wrk") += aDelimit) += DBNAME;
			{
				DirEntry aWork(String::CreateFromAscii(RUNDIRECTORY.GetBuffer()));
				if(!aWork.Exists())
					aWork.MakeDir();
			}

			{
				String aTmp(String::CreateFromAscii(DBCONFIG.GetBuffer()));
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii("config");
				aTmp += DirEntry::GetAccessDelimiter();
				aTmp.AppendAscii(DBNAME.GetBuffer());
				DirEntry aWork(aTmp);
				if(aWork.Exists())
					aWork.Kill();
			}

			{
				String aExe;
#if defined(WIN) || defined(WNT)
				::rtl::OUString aArgs[] = {
							String::CreateFromAscii(DBNAME.GetBuffer()),
							String::CreateFromAscii("stop")
				};
				::vos::OArgumentList aArgumentList(aArgs,2);
				aExe = x_cons;
#else
				::rtl::OUString aArgs[] = {
							String::CreateFromAscii(DBNAME.GetBuffer())
				};

				::vos::OArgumentList aArgumentList(aArgs,1);
				aExe.AssignAscii(DBROOT.GetBuffer());
				aExe += DirEntry::GetAccessDelimiter();
				aExe.AppendAscii("bin");
				aExe += DirEntry::GetAccessDelimiter();
				aExe.AppendAscii("x_clear");
#endif
				::vos::OProcess aApp( aExe,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
				EXECUTE(aApp);
			}

			if(X_PARAM(DBNAME,CONUSR,CONPWD,"BINIT"))
				return -5;

			DirEntry aInitFile = DirEntry().TempName(FSYS_KIND_FILE);
			BOOL bDeleteInit=FALSE;
			if(bBsp)
			{
				bDeleteInit=TRUE;
				String aNew = aInitFile.GetFull();
				CreateBspFile(INITCMD,aNew);
				INITCMD = ByteString(aNew,gsl_getSystemTextEncoding());
			}
			int nRet = 0;
			if(nRet = CreateFiles(INITCMD,SYSDEV,TRANSLOGDEV))
				return nRet;

			PutParam(DBNAME,"SYSDEVSPACE",SYSDEV);
			PutParam(DBNAME,"TRANSACTION_LOG",TRANSLOGDEV);
			PutParam(DBNAME,"MAXUSERTASKS","3");
			PutParam(DBNAME,"MAXDEVSPACES","7");
			PutParam(DBNAME,"MAXDATADEVSPACES","5");
			PutParam(DBNAME,"MAXDATAPAGES","25599");
			PutParam(DBNAME,"MAXBACKUPDEVS","1");
			PutParam(DBNAME,"MAXSERVERDB","1");
			PutParam(DBNAME,"DATA_CACHE_PAGES",CACHESIZE);
			PutParam(DBNAME,"CONV_CACHE_PAGES","23");
			PutParam(DBNAME,"PROC_DATA_PAGES","40");
			PutParam(DBNAME,"RUNDIRECTORY",RUNDIRECTORY);
			PutParam(DBNAME,"KERNELTRACESIZE","100");
			PutParam(DBNAME,"LOG_QUEUE_PAGES","10");

#if !(defined(WIN) || defined(WNT))
			PutParam(DBNAME,"OPMSG1","/dev/null");
#endif

			if(X_PARAM(DBNAME,CONUSR,CONPWD,"BCHECK"))
				return -7;

			X_START(DBNAME);
//				return -8;

			//	SHOW_STATE()
			//	%DBROOT%\bin\xutil -d %DBNAME% -u %CONUSR%,%CONPWD% -b %INITCMD%
			ByteString aBatch2("-b ");

			if(!bBsp && INITCMD.Len() >= 40)
			{
				bDeleteInit=TRUE;
				DirEntry aTmp(String(INITCMD,gsl_getSystemTextEncoding()));
				aTmp.CopyTo(aInitFile, FSYS_ACTION_COPYFILE);
				INITCMD = ByteString(aInitFile.GetFull(),gsl_getSystemTextEncoding());
			}
			aBatch2 += INITCMD;
			XUTIL(aBatch2,DBNAME,CONUSR,CONPWD);
			if(bDeleteInit)
//				DirEntry(String(INITCMD,gsl_getSystemTextEncoding())).Kill();
//Changed by OBO, above line gives parse-error with linux compiler
				{
					String aDummy(INITCMD,gsl_getSystemTextEncoding());
					DirEntry(aDummy).Kill();
				}
//end of changes
			if(ByteString(argv[argc-1] ? argv[argc-1] : "") != "-x")
			{
				// install system tables
#if defined(WIN) || defined(WNT)
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD% -b %DBROOT%\env\TERMCHAR.ind
				ByteString aBatch("-b ");
				((((aBatch += DBROOT) += aDelimit) += "env") += aDelimit) += "TERMCHAR.ind";
				XUTIL(aBatch,DBNAME,CONUSR,CONPWD);
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD% DIAGNOSE TRIGGER OFF
				XUTIL("DIAGNOSE TRIGGER OFF",DBNAME,CONUSR,CONPWD);
				//	xload -d %_DBNAME% -u %_SYSDBA_USER%,%_SYSDBA_PWD% -S adabas -b %DBROOT%\env\DBS.ins %_DOMAINPWD%
				(((((aBatch = DBROOT) += aDelimit) += "env") += aDelimit) += "DBS.ins ")+=DOMPWD;
				LoadBatch(DBNAME,SYSUSR,SYSPWD,aBatch);
				//	xload -d %_DBNAME% -u DOMAIN,%_DOMAINPWD% -S adabas -b %DBROOT%\env\XDD.ins
				(((((aBatch = DBROOT) += aDelimit) += "env") += aDelimit) += "XDD.ins ");
				LoadBatch(DBNAME,"DOMAIN",DOMPWD,aBatch);
				//	xload -d %_DBNAME% -u %_SYSDBA_USER%,%_SYSDBA_PWD% -S adabas -b %DBROOT%\env\QP.ins
				(((((aBatch = DBROOT) += aDelimit) += "env") += aDelimit) += "QP.ins ");
				LoadBatch(DBNAME,SYSUSR,SYSPWD,aBatch);
				//	xload  -d %_DBNAME% -u DOMAIN,%_DOMAINPWD% -S adabas -b %DBROOT%\env\SPROC.ins
				(((((aBatch = DBROOT) += aDelimit) += "env") += aDelimit) += "SPROC.ins ");
				LoadBatch(DBNAME,"DOMAIN",DOMPWD,aBatch);
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD%  DIAGNOSE TRIGGER ON
				XUTIL("DIAGNOSE TRIGGER ON",DBNAME,CONUSR,CONPWD);
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD%  SET NOLOG OFF
				XUTIL("SET NOLOG OFF",DBNAME,CONUSR,CONPWD);
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD%  SHUTDOWN QUICK
				XUTIL("SHUTDOWN QUICK",DBNAME,CONUSR,CONPWD);
				//	xutil -d %_DBNAME% -u %_CONTROL_USER%,%_CONTROL_PWD%  RESTART
				XUTIL("RESTART",DBNAME,CONUSR,CONPWD);
#else // only for UNX
				DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
				String aFileName = aEntry.GetFull();
				{
					ByteString aExe(DBROOT);
					(((aExe += aDelimit) += "bin") += aDelimit) += "x_dbinst";
					SvFileStream aFileStream(aFileName,STREAM_WRITE);
					aFileStream << "#!/bin/sh" << sNewLine;
					aFileStream << "cd \"$DBWORK\"" << sNewLine;
					aFileStream << aExe.GetBuffer()	<< " -d  " << DBNAME.GetBuffer();
					aFileStream << " -u " << SYSUSR.GetBuffer() << "," << SYSPWD.GetBuffer();
					aFileStream << " -w " << DOMPWD.GetBuffer() << " -b -i all";
#if defined(DEBUG) || defined(DBG_UTIL)
					aFileStream << " >> /tmp/kstart.log";
#else
					aFileStream << " > /dev/null";
#endif
					aFileStream << sNewLine;
				}
				DirEntry aBatchEntry(aEntry);
				aEntry.MoveTo(aBatchEntry);
				chmod(ByteString(aBatchEntry.GetFull(),gsl_getSystemTextEncoding()).GetBuffer(),S_IRUSR|S_IWUSR|S_IXUSR);

				aFileName = aBatchEntry.GetFull();
				::vos::OProcess aApp( aFileName,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));
				aApp.execute( (::vos::OProcess::TProcessOption)
#if DEBUG
							(::vos::OProcess::TOption_Wait)
						   );
#else
							(::vos::OProcess::TOption_Hidden | ::vos::OProcess::TOption_Wait)
						   );
#endif

				aBatchEntry.Kill();
#endif
				//	SHOW_STATE()
			}
		}

		if(ByteString(argv[1]) == "-s")
		{
			DirEntry aEntry(DirEntry().TempName(FSYS_KIND_FILE));
			String aFileName = aEntry.GetFull();
			{
				SvFileStream aFileStream(aFileName,STREAM_WRITE);
				aFileStream << "CREATE USER \""
							<< USRNAME.GetBuffer()	<< "\" PASSWORD \""
							<< USRPWD.GetBuffer()	<< "\" RESOURCE"	<< sNewLine;
			}
			LoadTables(DBNAME,SYSUSR,SYSPWD,ByteString(aFileName,gsl_getSystemTextEncoding()));
			aEntry.Kill();

			DirEntry aCatFile( DirEntry().TempName(FSYS_KIND_FILE));
			DirEntry aTabFile( DirEntry().TempName(FSYS_KIND_FILE));
			{
				{
					DirEntry aTmp(String(CATFILE,gsl_getSystemTextEncoding()));
					aTmp.CopyTo(aCatFile, FSYS_ACTION_COPYFILE);
					CATFILE = ByteString(aCatFile.GetFull(),gsl_getSystemTextEncoding());
				}
				{
					DirEntry aTmp(String(TABFILE,gsl_getSystemTextEncoding()));
					aTmp.CopyTo(aTabFile, FSYS_ACTION_COPYFILE);
					TABFILE = ByteString(aTabFile.GetFull(),gsl_getSystemTextEncoding());
				}
				aEntry = DirEntry().TempName(FSYS_KIND_FILE);
				{
					aFileName = aEntry.GetFull();
					{
						SvFileStream aFileStream(aFileName,STREAM_WRITE);
						aFileStream << "CATALOGLOAD USER; INFILE " << CATFILE.GetBuffer() << sNewLine;
						aFileStream << "/ *" << sNewLine;
						aFileStream << "TABLELOAD USER; INFILE " << TABFILE.GetBuffer() << "; OUTFILE nul";
						aFileStream << sNewLine;
					}
					LoadTables(DBNAME,USRNAME,USRPWD,ByteString(aFileName,gsl_getSystemTextEncoding()));
				}
				aEntry.Kill();
			}
			aCatFile.Kill();
			aTabFile.Kill();
			// make db writeable
			{
				aEntry = DirEntry().TempName(FSYS_KIND_FILE);
#if defined(WIN) || defined(WNT)
				DirEntry aSaveData(DirEntry().TempName(FSYS_KIND_FILE));
#endif

				aFileName = aEntry.GetFull();
				{
					SvFileStream aFileStream(aFileName,STREAM_WRITE);
					aFileStream << "SAVE DATA QUICK TO '";
#if defined(WIN) || defined(WNT)
					aFileStream << ByteString(aSaveData.GetFull(),gsl_getSystemTextEncoding()).GetBuffer();
#else
					aFileStream << "/dev/null";
#endif
					//	aFileStream << rArgs.GetStr();
					aFileStream << "' BLOCKSIZE 8" << sNewLine;
				}
				ByteString aU;
				((aU = CONUSR) += ",") += CONPWD;
				::rtl::OUString aArgs[] = {
							String::CreateFromAscii("-u"),
							String::CreateFromAscii(aU.GetBuffer()),
							String::CreateFromAscii("-d"),
							String::CreateFromAscii(DBNAME.GetBuffer()),
							String::CreateFromAscii("-b"),
							aFileName
				};
				::vos::OArgumentList aArgumentList(aArgs,6);

				String aPath;
				aPath.AssignAscii(getenv("DBROOT") ? getenv("DBROOT") : "");
				aPath += DirEntry::GetAccessDelimiter();
				aPath.AppendAscii("bin");
				aPath += DirEntry::GetAccessDelimiter();
				aPath.AppendAscii("xutil");
#if defined(WIN) || defined(WNT)
				aPath.AppendAscii(".exe");
#endif
				::vos::OProcess aApp2( aPath,String::CreateFromAscii(getenv("DBWORK") ? getenv("DBWORK") : ""));

				EXECUTE(aApp2);

				aEntry.Kill();
#if defined(WIN) || defined(WNT)
				aSaveData.Kill();
#endif
			}
		}
	}
	return 0;
}

