/*************************************************************************
 *
 *  $RCSfile: odbcconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_ODBCCONN_HXX
#include "odbcconn.hxx"
#endif

#ifndef _SDB_ODBCCURS_HXX
#include "odbccurs.hxx"
#endif
#if defined(WIN) || defined(WNT)

#include <tools/prewin.h>
#include <odbc/sql.h>
#include <tools/postwin.h>
#else
#include <odbc/sql.h>
#endif

#ifndef _SDB_ODBCTAB_HXX
#include "odbctab.hxx"
#endif
#ifndef _SDB_SDBRESID_HRC
#include "sdbresid.hrc"
#endif

#ifndef _SDB_SDBREL_HXX
#include <sdbrel.hxx>
#endif

#include "odbc.hrc"

#ifndef _SDB_SDBENV_HXX
#include "sdbenv.hxx"
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _SDB_ODBCMD_HXX
#include <odbcmd.hxx>
#endif // _SDB_ODBCMD_HXX

#include "sdbmap.hxx"

#ifndef _COM_SUN_STAR_DATA_DATABASEQUALIFIER_HPP_
#include <com/sun/star/data/DatabaseQualifier.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif


namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;


DBG_NAME(SdbODBCConnection);

static char __READONLY_DATA ALL[] = "%";
TYPEINIT1(SdbODBCConnection,SdbConnection);

//-----------------------------------------------------------------------------
SdbODBCConnection::SdbODBCConnection(SdbEnvironment* pEnv, const String& rNewOptions)
					:SdbConnection(pEnv, rNewOptions)
					,bNoPrompt(FALSE)
					,bNeedLen(FALSE)
					,nDriverConcurrency(SQL_SCCO_READ_ONLY)
					,nFetchDirection(SQL_FD_FETCH_NEXT)
					,nStaticSensitivity(0)
					,nPosOperations(0)
					,nOwnerUsage(0)
					,nQualifierUsage(0)
					,nMaxStmts(0)
					,nActiveStmts(0)
					,nCommitBehavior(0)
					,bReadOnly(TRUE)
					,m_bUserWChar(FALSE)
{
	DBG_CTOR(SdbODBCConnection,NULL);
	// Wenn kein Default-Schemaname vorhanden, den Benutzernamen verwenden.
	if (aUserName.Len() == 0 && aOptionsParser.OptionString(String::CreateFromAscii("UID")).Len() > 0)
		aUserName = aOptionsParser.OptionString(String::CreateFromAscii("UID"));
}

//-----------------------------------------------------------------------------
// Copy CTOR nur fuer den internen Gebrauch
SdbODBCConnection::SdbODBCConnection(const SdbODBCConnection& rConn)
					:SdbConnection(rConn.GetEnvironment(),rConn.Options())
					,bNoPrompt(TRUE)
					,bNeedLen(FALSE)
					,nDriverConcurrency(SQL_SCCO_READ_ONLY)
					,nFetchDirection(SQL_FD_FETCH_NEXT)
					,nStaticSensitivity(0)
					,nPosOperations(0)
					,nOwnerUsage(0)
					,nQualifierUsage(0)
					,nMaxStmts(0)
					,nActiveStmts(0)
					,nCommitBehavior(0)
					,bReadOnly(TRUE)
					,m_bUserWChar(FALSE)

{
	DBG_CTOR(SdbODBCConnection,NULL);
	// Wenn kein Default-Schemaname vorhanden, den Benutzernamen verwenden.
	if (aUserName.Len() == 0 && aOptionsParser.OptionString(String::CreateFromAscii("UID")).Len() > 0)
		aUserName = aOptionsParser.OptionString(String::CreateFromAscii("UID"));
}

//-----------------------------------------------------------------------------
SdbODBCConnection::~SdbODBCConnection()
{
	DBG_DTOR(SdbODBCConnection,NULL);
}


//-----------------------------------------------------------------------------
void SdbODBCConnection::RemoveChild(SdbObj* _pChild)
{
	SdbODBCCursor* pCursor = (SdbODBCCursor*)PTR_CAST(SdbCursor,_pChild);
	if (pCursor)
	{
		if (!pCursor->ConnectionHandle() &&	pCursor->StmtHandle() )
			nActiveStmts--;
	}
	SdbConnection::RemoveChild(_pChild);
}

//-----------------------------------------------------------------------------
BOOL SdbODBCConnection::OpenImpl()
{
	CheckODBCCapabilities();
	if (!aStatus.IsSuccessful())
		return FALSE;

	// CaseSensitivity
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetMetaData();
	sal_Int16 nInfo;
	rMetaData->getInfo(::stardata::DatabaseInfo::IDENT_CASE_QUOTED) <<= nInfo;
	switch (nInfo)
	{
		case ::stardata::DatabaseIdentifierCase::UPPER:
			eIdentifierCase = SDB_IC_UPPER;
			break;
		case ::stardata::DatabaseIdentifierCase::LOWER:
			eIdentifierCase = SDB_IC_LOWER;
			break;
		case ::stardata::DatabaseIdentifierCase::SENSITIVE:
			eIdentifierCase = SDB_IC_ALL;
			break;
		default:
			eIdentifierCase = SDB_IC_MIXED;
	}

	aStatus.Clear();        //Ergebnis ignorieren
	pTableNames = new SdbStringStlMap(::utl::UStringMixLess((eIdentifierCase & SDB_IC_OBJECT) == SDB_IC_OBJECT));
	return TRUE;
}
//-----------------------------------------------------------------------------
SdbTable* SdbODBCConnection::CreateTableImpl()
{
	DBG_CHKTHIS(SdbODBCConnection,NULL);

	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HENV,"SdbODBCConnection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HDBC,"SdbODBCConnection: interner Fehler: ConnectionHandle ungueltig");

	return new SdbODBCTable(this);
}

//==================================================================
// Ableitung nur fr das Erzeugen und Refresh, fuer eigenes file
// zu geringfgig
//==================================================================
class SdbODBCRelation : public SdbRelation
{
	friend class SdbODBCConnection;

protected:
	SdbODBCRelation(SdbConnection* _pConn, const String& _rName)
		:SdbRelation(_pConn, _rName){}

	virtual BOOL DoRefresh();
	void SetName(const String& _rName) {aName = _rName;}
};

//------------------------------------------------------------------
BOOL SdbODBCRelation::DoRefresh()
{
	SDB_CHK_OPEN_BOOL();
	SDB_CHK_CONNECT_BOOL();

	// den Namen merken, da sich dieser durchaus geaendert haben kann
	if (!((SdbODBCConnection*)pConnection)->FillRelation(*this))
		aStatus = pConnection->Status();

	return aStatus.IsSuccessful();
}


//==================================================================
SdbRelation* SdbODBCConnection::CreateRelationImpl(const String& _rName)
{
	return new SdbODBCRelation(this,_rName);
}

//------------------------------------------------------------------
BOOL SdbODBCConnection::FillRelation(SdbODBCRelation& rRel)
{
	// aktualisieren einer Relation
	SDB_CHK_OPEN_BOOL();

	SdbTableRef xTable = OpenTable(rRel.GetTableName()),
				xForeignTable;
	if (xTable)
		xForeignTable = OpenTable(rRel.GetForeignTableName());
	if (xForeignTable)
	{
		SdbCursorRef xCursor;
		if (!OpenRelationCursor(xTable->QualifierName(), xTable->OwnerName(), xTable->Name(), xCursor))
			aStatus.SetError(ERRCODE_IO_NOTEXISTS,RELATION,rRel.GetName());
		else
		{
			::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetMetaData();
			sal_Int16 nCatalogUsage;
			rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
			sal_Int16 nSchemaUsage;
			rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

			SdbTableRef xRefTable;
			while (xCursor->IsInRange())
			{
				ODbRow& rRow = *xCursor->GetRow();
				// Auswerten der KeySeq
				ODbVariantRef pVal = rRow[9];
				if (!pVal.is() || pVal->isNull())    // ohne Name geht nichts
					break;

				if (pVal->getINT16() == 1)    // gibt es eine neue Relation
				{
					if (xRefTable.Is())                     // Relation bereits ausgelesen
						break;

					String aConstraintName;
					ODbVariantRef pVal = rRow[12];
					if (!pVal.is() || pVal->isNull())    // ohne Name einen generieren
						aConstraintName = SdbRelation::CreateTempName();
					else
						aConstraintName = pVal->getString().getStr();

					String aRefTableName;
					String aTableName;
					// Zugriff auf referenzierte Tabelle
					if (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML)
					{
						pVal = rRow[1];
						if (pVal.is() && !pVal->isNull() && pVal->getString().getLength())
						{
							aRefTableName += pVal->getString().getStr();
							aRefTableName += cQualifierSeparator;
							aTableName += xTable->QualifierName();
							aTableName += cQualifierSeparator;
						}
					}
					if (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML)
					{
						pVal = rRow[2];
						if (pVal.is() && !pVal->isNull())
						{
							aRefTableName += pVal->getString().getStr();
							aRefTableName += '.';
							aTableName += xTable->OwnerName();
							aTableName += '.';
						}
					}
					pVal = rRow[3];
					if (pVal.is() && !pVal->isNull())
					{
						aRefTableName += pVal->getString().getStr();
						aTableName += xTable->Name();
					}

					xRefTable = OpenTable(aRefTableName);
					// Tabelle gefunden
					if (&xRefTable == &xForeignTable)
					{
						rRel.SetName(aConstraintName);
						// jetzt noch die Attributierungen
						UINT16 nAttributes = 0,
						nODBCAttributes = 0;

						// Update rules
						pVal = rRow[10];
						if (pVal.is() && !pVal->isNull())
						{
							nODBCAttributes = pVal->getINT16();
							if (nODBCAttributes & SQL_CASCADE)
								nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
							else if (nODBCAttributes & SQL_RESTRICT)
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
							else if (nODBCAttributes & SQL_SET_NULL)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
							else if (nODBCAttributes & SQL_SET_DEFAULT)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
							else
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
						}
						rRel.SetUpdateRules(nAttributes);
						nAttributes = 0;


						// Delete rules
						pVal = rRow[11];
						nODBCAttributes = 0;
						if (pVal.is() && !pVal->isNull())
						{
							nODBCAttributes = pVal->getINT16();
							if (nODBCAttributes & SQL_CASCADE)
								nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
							else if (nODBCAttributes & SQL_RESTRICT)
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
							else if (nODBCAttributes & SQL_SET_NULL)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
							else if (nODBCAttributes & SQL_SET_DEFAULT)
								nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
							else
								nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
						}
						rRel.SetDeleteRules(nAttributes);


					}
					else
						xRefTable = NULL;
				}

				if (xRefTable.Is())
				{
					const SdbColumn* pColumn = NULL;
					pVal = rRow[8];
					if (pVal.is() && !pVal->isNull())
						pColumn = xTable->OriginalColumns()->Column(pVal->getString().getStr());

					String aForeignName;
					pVal = rRow[4];
					if (pVal.is() && !pVal->isNull())
						aForeignName = pVal->getString().getStr();

					if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName))
					{
						SdbColumnRelation* pRelColumn = rRel.CreateColumn(*pColumn, aForeignName);
						rRel.GetColumns()->AddColumn(pRelColumn);
					}
					else
					{
						// falsche struktur
						aStatus.Set(SDB_STAT_ERROR);
						break;
					}
				}
				xCursor->Next();
			}
		}
	}
	return aStatus.IsSuccessful();
}

//------------------------------------------------------------------
BOOL SdbODBCConnection::OpenRelationCursor(const String& rCatalog, const String& rSchema, const String& rName, SdbCursorRef& rxCursor)
{
	if (!rxCursor)
		rxCursor = CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	else
		rxCursor->Close();

	const sal_Unicode* pQualifier = NULL;
	const sal_Unicode* pOwner = NULL;

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetMetaData();
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	if (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML)
		pQualifier = rCatalog.GetBuffer();
	if (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML)
		pOwner = rSchema.GetBuffer();

	((SdbODBCCursor &)(*rxCursor)).OpenForeignKeys(NULL,NULL, NULL,pQualifier,pOwner,rName.GetBuffer());
	// Spaltennamen
/*              1       PKTABLE_CAT
		2       PKTABLE_SCHEM
		3       PKTABLE_NAME
		4       PKCOLUMN_NAME
		5       FKTABLE_CAT
		6       FKTABLE_SCHEM
		7       FKTABLE_NAME
		8       FKCOLUMN_NAME
		9       KEY_SEQ
		10      UPDATE_RULE
		11      DELETE_RULE
		12      FK_NAME                 // constraint name
		13  PK_NAME
		14  DEFERRABILITY
*/
	return rxCursor && rxCursor->IsInRange();
}

//------------------------------------------------------------------------
// Oeffnen aller Relationen
void SdbODBCConnection::FillAllRelations(SdbRelationList& _rList)
{
	SdbCursorRef xCursor;
	for (SdbStringStlMap::const_iterator aIter = pTableNames->begin();aIter != pTableNames->end();++aIter)
	{
		if ((*aIter).second)		// es ist keine View
			FillRelation(_rList, (*aIter).first, xCursor);
	}
}

//------------------------------------------------------------------
//Oeffnen der Relation fuer eine Tabelle
void SdbODBCConnection::FillRelation(SdbRelationList& _rList, const String& rName, SdbCursorRef& rxCursor)
{
	String sCatalog, sSchema, sName;
	if (!QualifiedNameComponents(rName, sCatalog, sSchema, sName) ||
		!OpenRelationCursor(sCatalog, sSchema, sName, rxCursor))
		return;

	SdbRelationRef	xRelation;
	SdbTableRef		xRefTable;
	SdbTableRef		xTable;
	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetMetaData();
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	while (rxCursor->IsInRange())
	{
		ODbRow& rRow = *rxCursor->GetRow();
		// Auswerten der KeySeq
		ODbVariantRef pVal = rRow[9];
		if (!pVal.is() || pVal->isNull())    // ohne Name geht nichts
			break;

		if (pVal->getINT16() == 1)    // gibt es eine neue Relation
		{
			// alte uebernehmen
			if (xRelation.Is())
			{
				((SdbODBCRelation*)&xRelation)->Open(); // nur das open flag setzen
				_rList.InsertAt(xRelation->GetName(), &xRelation);
				xRelation = NULL;
			}

			String aConstraintName;
			ODbVariantRef pVal = rRow[12];
			if (!pVal.is() || pVal->isNull())    // ohne Name einen generieren
				aConstraintName = SdbRelation::CreateTempName();
			else
				aConstraintName = pVal->getString().getStr();

			String aRefTableName;
			String aTableName;
			// Zugriff auf referenzierte Tabelle
			if (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML)
			{
				pVal = rRow[1];
				if (pVal.is() && !pVal->isNull() && pVal->getString().getLength())
				{
					aRefTableName += pVal->getString().getStr();
					aRefTableName += cQualifierSeparator;
					aTableName += sCatalog;
					aTableName += cQualifierSeparator;
				}
			}
			if (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML)
			{
				pVal = rRow[2];
				if (pVal.is() && !pVal->isNull())
				{
					aRefTableName += pVal->getString().getStr();
					aRefTableName += '.';
					aTableName += sSchema;
					aTableName += '.';
				}
			}
			pVal = rRow[3];
			if (pVal.is() && !pVal->isNull())
			{
				aRefTableName += pVal->getString().getStr();
				aTableName += sName;
			}

			xRelation = NULL;
			xRefTable = OpenTable(aRefTableName);
			if (xRefTable.Is())
				xRelation = new SdbODBCRelation(this, aConstraintName);
			if (!xRelation.Is())
			{
				xRefTable = NULL;
				xRelation = NULL;
			}
			else
			{
				xRelation->SetTableName(aTableName);
				xRelation->SetForeignTableName(aRefTableName);

				// jetzt noch die Attributierungen
				UINT16 nAttributes = 0,
					nODBCAttributes = 0;

				// Update rules
				pVal = rRow[10];
				if (pVal.is() && !pVal->isNull())
				{
					nODBCAttributes = pVal->getINT16();
					if (nODBCAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nODBCAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nODBCAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
					else if (nODBCAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetUpdateRules(nAttributes);
				nAttributes = 0;

				// Delete rules
				pVal = rRow[11];
				nODBCAttributes = 0;
				if (pVal.is() && !pVal->isNull())
				{
					nODBCAttributes = pVal->getINT16();
					if (nODBCAttributes & SQL_CASCADE)
						nAttributes |= ::stardata::DatabaseKeyRule::CASCADE;
					else if (nODBCAttributes & SQL_RESTRICT)
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
					else if (nODBCAttributes & SQL_SET_NULL)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_NULL;
					else if (nODBCAttributes & SQL_SET_DEFAULT)
						nAttributes |= ::stardata::DatabaseKeyRule::SET_DEFAULT;
					else
						nAttributes |= ::stardata::DatabaseKeyRule::NO_ACTION;
				}
				xRelation->SetDeleteRules(nAttributes);
			}
		}

		if (xRelation.Is())
		{
			// die Tabelle ist vielleicht noch nicht auf
			if (!xTable.Is())
			{
				xTable = OpenTable(rName);
				if (!xTable.Is())
					return;
			}

			const SdbColumn* pColumn = NULL;
			pVal = rRow[8];
			if (pVal.is() && !pVal->isNull())
				pColumn = xTable->OriginalColumns()->Column(pVal->getString().getStr());

			String aForeignName;
			pVal = rRow[4];
			if (pVal.is() && !pVal->isNull())
				aForeignName = pVal->getString().getStr();

			if (pColumn && xRefTable->OriginalColumns()->Column(aForeignName))
			{
				SdbColumnRelation* pRelColumn = xRelation->CreateColumn(*pColumn, aForeignName);
				xRelation->GetColumns()->AddColumn(pRelColumn);
			}
			else
			{
				((SdbODBCRelation*)&xRelation)->RemoveFromParent();
				xRelation = NULL;
			}
		}
		rxCursor->Next();
	}

	if (xRelation.Is())
	{
		((SdbODBCRelation*)&xRelation)->Open(); // nur das open flag setzen
		_rList.InsertAt(xRelation->GetName(), &xRelation);
	}
}


//-----------------------------------------------------------------------------
void SdbODBCConnection::FillTableNames(SdbStringStlMap* _pList)
{
	DBG_CHKTHIS(SdbODBCConnection,NULL);

	// SdbODBCCursor handelt, daher Type Cast:
	SdbODBCCursor* pCursor = (SdbODBCCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	// Einen ganz speziellen Cursor oeffnen: anstelle von
	// Prepare und Execute wird Tables ausgefuehrt; die
	// Ergebnismenge enthaelt die gewuenschten Informationen

	// Zugriff auf die Ergebnismenge normalerweise mit Spaltennamen
	// da manche Treiber aber nicht die Standardnamen verwenden, versuchen wir es bei denen
	// mit der Position

	// Auswahl der Tabellenart
	String aTableType; aTableType.AssignAscii("TABLE;SYNONYM;VIEW;ALIAS");
	// Nur Typen vom Typ TABLE gelten als Tabelle

	::staruno::Reference< ::stardata::XDatabaseDescriptor > rMetaData = GetMetaData();
	sal_Int16 nCatalogUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::CATALOG_USAGE) >>= nCatalogUsage;
	sal_Int16 nSchemaUsage;
	rMetaData->getInfo(::stardata::DatabaseInfo::SCHEMA_USAGE) >>= nSchemaUsage;

	for (xub_StrLen i = 0; i < 4; i++)
	{
		pCursor->OpenTables(NULL,NULL,NULL,aTableType.GetToken(i,';').GetBuffer());
		/*      Reihenfolge
			1       TABLE_QUALIFIER
			2       TABLE_OWNER
			3       TABLE_NAME
		 */
		while (pCursor->IsInRange())
		{
			ODbRow& rRow = *pCursor->GetRow();
			String aNewName ;
			ODbVariantRef pVal;
			if (nCatalogUsage & ::stardata::DatabaseQualifier::IN_DML)
			{
				pVal = rRow[1];
				if (pVal.is() && !pVal->isNull() && pVal->getString().getLength())
				{
					aNewName += pVal->getString().getStr();
					aNewName += cQualifierSeparator;
				}
			}
			if (nSchemaUsage & ::stardata::DatabaseQualifier::IN_DML)
			{
				pVal = rRow[2];
				if (pVal.is() && !pVal->isNull())
				{
					aNewName += pVal->getString().getStr();
					aNewName += '.';
				}
			}
			pVal = rRow[3];
			if (pVal.is() && !pVal->isNull())
				aNewName += pVal->getString().getStr();

			(*_pList)[aNewName] = i != 2;

			pCursor->Next();
		}
		pCursor->Close();
	}
	pCursor->ReleaseRef();
}

static const UINT16 TYPE_NAME			= 1;
static const UINT16 DATA_TYPE2			= 2;
static const UINT16 COLUMN_SIZE			= 3;
static const UINT16 LITERAL_PREFIX		= 4;
static const UINT16 LITERAL_SUFFIX		= 5;
static const UINT16 CREATE_PARAMS		= 6;
static const UINT16 NULLABLE			= 7;
static const UINT16 CASE_SENSITIVE		= 8;
static const UINT16 SEARCHABLE			= 9;
static const UINT16 UNSIGNED_ATTRIBUTE	= 10;
static const UINT16 FIXED_PREC_SCALE	= 11;
static const UINT16 AUTO_UNIQUE_VALUE	= 12;
static const UINT16 LOCAL_TYPE_NAME		= 13;
static const UINT16 MINIMUM_SCALE		= 14;
static const UINT16 MAXIMUM_SCALE		= 15;
static const UINT16 SQL_DATA_TYPE		= 16;
static const UINT16 SQL_DATETIME_SUB	= 17;
static const UINT16 NUM_PREC_RADIX		= 18;
static const UINT16 USER_TYPE			= 19;
//-----------------------------------------------------------------------------
void SdbODBCConnection::FillTypeList(SdbTypeInfoList& rList)
{
	// Typ informationen sammeln
	SdbODBCCursor* pCur =
		(SdbODBCCursor *) ((SdbODBCConnection *) this)->CreateCursor(SDB_SNAPSHOT, SDB_READONLY | SDB_FORWARDONLY);
	pCur->AddRef();

	pCur->OpenTypeInfo(SQL_ALL_TYPES);
	aStatus = pCur->Status();


	SdbTypeInfo* pInfoTimestamp = NULL;
	INT32 nTimestampTypeNum=0;
	while (pCur->IsInRange())
	{
		ODbRow& rRow = *pCur->GetRow();
		INT32 nTypeNum = rRow[DATA_TYPE2]->getINT16();

		SdbDatabaseType eType = (SdbDatabaseType)MapType(nTypeNum);
		if (eType == SDB_DBTYPE_UNKNOWN)
		{
			pCur->Next();
			continue;
		}

		SdbTypeInfo* pInfo = new SdbTypeInfo;
		pInfo->eType = eType;
		pInfo->aTypeName        = rRow[TYPE_NAME]->getString().getStr();

		// i need a type for the rowver for SQLSpecialColumns
		if(String(pInfo->aTypeName).EqualsIgnoreCaseAscii("timestamp"))
		{
			pInfoTimestamp		= pInfo;
			nTimestampTypeNum	= nTypeNum;
		}

		ODbVariantRef pValue =   rRow[COLUMN_SIZE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nPrecision   =  0;
		else
			pInfo->nPrecision   = pValue->getINT32();

		pValue = rRow[MINIMUM_SCALE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nMinimumScale       = 0;
		else
			pInfo->nMinimumScale       = pValue->getINT16();

		pValue = rRow[MAXIMUM_SCALE];
		if (!pValue.is() || pValue->isNull())
			pInfo->nScale       = 0;
		else
			pInfo->nScale       = pValue->getINT16();

		pValue = rRow[FIXED_PREC_SCALE];
		pInfo->bCurrency        = pValue.is() && pValue->getINT16();

		pValue = rRow[LITERAL_PREFIX];
		if(pValue.is() && !pValue->isNull())
			pInfo->aLiteralPrefix = pValue->getString().getStr();

		pValue = rRow[LITERAL_SUFFIX];
		if(pValue.is() && !pValue->isNull())
			pInfo->aLiteralSuffix = pValue->getString().getStr();

		pValue = rRow[CREATE_PARAMS];
		if(pValue.is() && !pValue->isNull())
			pInfo->aCreateParams = pValue->getString().getStr();

		if (pInfo->bCurrency && (!pValue.is() || pValue->isNull()))   // wenn keine Parameter zum Kreieren angegeben
			pInfo->eType = SDB_DBTYPE_CURRENCY;                  // dann kann der Datentyp ruhig als Currency angesehen werden

		pValue = rRow[AUTO_UNIQUE_VALUE];
		if (pValue.is() && !pValue->isNull())
			pInfo->bAutoIncrement = (BOOL)pValue->getINT16();

		pValue = rRow[NULLABLE];
		pInfo->bNullable        = !pValue.is() || (BOOL)pValue->getINT16();

		pValue = rRow[SEARCHABLE];
		pInfo->eSearchType = GetSearchType(pValue->getINT16());

		rList.Insert(pInfo, LIST_APPEND);
		pCur->Next();
	}
	// check if there is already a timestamp type like datetime
	if(pInfoTimestamp)
	{
		if(nTimestampTypeNum == SQL_TIMESTAMP || nTimestampTypeNum == SQL_TYPE_TIMESTAMP)
		{
			// perhaps I already have a timestamp type with a different name
			for(ULONG i=0;i<rList.Count();++i)
			{
				SdbTypeInfo* pInfo = rList.GetObject(i);
				if(pInfo->eType == SQL_TIMESTAMP && pInfo != pInfoTimestamp)
				{
					pInfoTimestamp->bRowVersion = TRUE;
					break;
				}
			}
		}
		else
			pInfoTimestamp->bRowVersion = TRUE;
	}
	pCur->ReleaseRef();
}

//-----------------------------------------------------------------------------
BOOL SdbODBCConnection::IsDriverCapable(UWORD nInfoType, ULONG nInfoFlag) const
{
	ULONG n;
	return GetODBCInfo(nInfoType,n) && ((n & nInfoFlag) == nInfoFlag);
}
//-----------------------------------------------------------------------------
String SdbODBCConnection::ConnectStr() const
{
	String aOptions;
	aOptionsParser.Compose(aOptions,String::CreateFromAscii(pReservedOptions));      // Alles ausser den Sdb-internen Optionen weiterreichen
	if(!aOptionsParser.OptionString(String::CreateFromAscii("PWD")).Len())
		aOptions.AppendAscii(";PWD=");
	aOptions.EraseLeadingChars(';');
	aOptions.EraseTrailingChars(';');
	return aOptions;
}

