/*************************************************************************
 *
 *  $RCSfile: odbc2conn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_ODBC2CURS_HXX
#include "odbc2curs.hxx"
#endif
#ifndef _SDB_ODBC2CONN_HXX
#include "odbc2conn.hxx"
#endif
#ifndef IMPLIB_odbc2imp_HXX
#include "odbc2imp.hxx"
#endif
#ifndef _SDB_SDBMAP_HXX
#include "sdbmap.hxx"
#endif



/*
#if defined(LINUX) || defined(SOLARIS) || defined(WNT)
TSQLDriverConnect pSQLDriverConnect;
#endif
*/	// DG: was soll das, das ist im ODBC2imp definiert!


#ifndef _SDB_ODBCTAB_HXX
#include "odbctab.hxx"
#endif
#ifndef _SDB_SDBRESID_HRC
#include "sdbresid.hrc"
#endif

#ifndef _SDB_SDBREL_HXX
#include <sdbrel.hxx>
#endif

#ifndef _SDB_SDBENV_HXX
#include "sdbenv.hxx"
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _SDB_ODBC2MD_HXX
#include <odbc2md.hxx>
#endif // _SDB_ODBCMD_HXX

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

DBG_NAME(SdbODBC2Connection);
TYPEINIT1(SdbODBC2Connection,SdbODBCConnection);


const UWORD aRequiredODBCFunctions[] =
{
//		SQL_API_SQLALLOCCONNECT,
//		SQL_API_SQLALLOCENV,
//		SQL_API_SQLALLOCSTMT,
//		SQL_API_SQLCANCEL,
	SQL_API_SQLCOLUMNS,
	SQL_API_SQLCOLATTRIBUTES,
//	SQL_API_SQLDATASOURCES,                         // Level 2 (Driver Manager)
	SQL_API_SQLDESCRIBECOL,
//      SQL_API_SQLDESCRIBEPARAM,                       // Level 2
	SQL_API_SQLDISCONNECT,
	SQL_API_SQLDRIVERCONNECT,
	SQL_API_SQLERROR,
	SQL_API_SQLEXECDIRECT,
	SQL_API_SQLEXECUTE,
	SQL_API_SQLFETCH,
//      SQL_API_SQLFOREIGNKEYS,                         // Level 2
//		SQL_API_SQLFREECONNECT,
//		SQL_API_SQLFREESTMT,
	SQL_API_SQLGETCONNECTOPTION,
	SQL_API_SQLGETDATA,
	SQL_API_SQLGETFUNCTIONS,
	SQL_API_SQLGETINFO,
	SQL_API_SQLGETSTMTOPTION,
	SQL_API_SQLGETTYPEINFO,
//      SQL_API_SQLNUMPARAMS,                           // Level 2
	SQL_API_SQLNUMRESULTCOLS,
	SQL_API_SQLPARAMDATA,
	SQL_API_SQLPREPARE,
//      SQL_API_SQLPRIMARYKEYS,                         // Level 2
//      SQL_API_SQLPROCEDURECOLUMNS,            // Level 2
//      SQL_API_SQLPROCEDURES,                          // Level 2
	SQL_API_SQLPUTDATA,
//		SQL_API_SQLROWCOUNT,
	SQL_API_SQLSETCONNECTOPTION,
//      SQL_API_SQLSETPARAM,                            // Level 2
	SQL_API_SQLTABLES
//      SQL_API_SQLTRANSACT                                     // wird nicht unbedingt benoetigt
};

static char __READONLY_DATA ALL[] = "%";

//-----------------------------------------------------------------------------
void* SdbODBC2Connection::EnvironmentHandle()
{
	String aPath;
	return EnvironmentHandle(GetEnvironment(),aPath);
}
//-----------------------------------------------------------------------------
// ODBC Environment (gemeinsam fuer alle Connections):
HENV SdbODBC2Connection::EnvironmentHandle(SdbEnvironment* pEnv,String &_rPath)
{
	// Ist (fuer diese Instanz) bereits ein Environment erzeugt worden?
	if (pEnv && pEnv->aEnvironmentHandle == NULL)
	{
		HENV h = SQL_NULL_HENV;
		// Environment allozieren

#ifdef ODBCIMP
		// ODBC-DLL jetzt laden:
		if (!LoadLibrary_ODBC(pEnv,_rPath))
			return SQL_NULL_HENV;
#endif

#ifdef MAC
		if (kUnresolvedCFragSymbolAddress == ((long) SQLAllocEnv))
			return SQL_NULL_HENV;
#endif
		if (NSQLAllocEnv(&h) != SQL_SUCCESS)
			return SQL_NULL_HENV;

		// In globaler Struktur merken ...
		pEnv->aEnvironmentHandle = (void *) h;
	}

	return (HENV) pEnv ? pEnv->aEnvironmentHandle : SQL_NULL_HENV;
}


//-----------------------------------------------------------------------------
void SdbODBC2Connection::Construct(SdbEnvironment* pEnv)
{
	// Environment Handle besorgen (einmal beim Anlegen des Objektes -
	// wird aus Effizienzgrunden in jedem ODBCConnection-Objekt gespeichert)
	String aPath;
	m_aEnvironmentHandle = EnvironmentHandle(pEnv,aPath);
	m_aConnectionHandle  = SQL_NULL_HDBC;
	if (m_aEnvironmentHandle == SQL_NULL_HENV)
	{
		String aText = String(SdbResId(STR_STAT_ODBC_NOT_FOUND));
		aText.SearchAndReplace(String::CreateFromAscii("#DLL#"),aPath);
		aStatus.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					aStatus.CreateErrorMessage(aText),
					0, String() );
		return;
	}

	// Connection allozieren
	// (Eine ODBC-Connection pro SdbConnection).
	SetStatus(NSQLAllocConnect(m_aEnvironmentHandle,&m_aConnectionHandle),m_aConnectionHandle);
	if (! aStatus.IsSuccessful())
		return;

	nODBCVer  = 2;
	aStatus.SetComponent(String::CreateFromAscii("Sdb ODBC Driver 2.0"));
}

//-----------------------------------------------------------------------------
SdbODBC2Connection::SdbODBC2Connection(SdbEnvironment* pEnv, const String& rNewOptions)
				  :SdbODBCConnection(pEnv, rNewOptions)
{
	DBG_CTOR(SdbODBC2Connection,NULL);
	Construct(pEnv);
}

//-----------------------------------------------------------------------------
// Copy CTOR nur fuer den internen Gebrauch
SdbODBC2Connection::SdbODBC2Connection(const SdbODBC2Connection& rConn)
				  :SdbODBCConnection(rConn.GetEnvironment(),rConn.Options())
{
	DBG_CTOR(SdbODBC2Connection,NULL);
	Construct(rConn.GetEnvironment());
}

//-----------------------------------------------------------------------------
SdbODBC2Connection::~SdbODBC2Connection()
{
	DBG_DTOR(SdbODBC2Connection,NULL);
	// KH: wenn m_aConnectionHandle nicht existiert wurde hoechstwahrscheinlich
	// die Library nicht angezogen, also ist es Unsinn SQLFreeConnect aufzurufen
	// da es moeglicherweise nicht existiert.

	if (m_aConnectionHandle != SQL_NULL_HDBC)
	{
#ifdef ODBCIMP
		if( pSQLFreeConnect )
			NSQLFreeConnect(m_aConnectionHandle);
#else
		NSQLFreeConnect(m_aConnectionHandle);
#endif
	}
}
//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::IsODBCFunctionAvailable(UWORD nFunction) const
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	UWORD nExists;
	RETCODE nRetCode = NSQLGetFunctions(m_aConnectionHandle,nFunction,&nExists);
	return nRetCode == SQL_SUCCESS && (BOOL)nExists;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::GetODBCInfo(UWORD nInfoType, String & rString) const
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	char aValue[512];
	SWORD nValueLen;
	RETCODE nRetCode =
		NSQLGetInfo(m_aConnectionHandle,nInfoType,aValue,sizeof aValue,&nValueLen);

	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetODBCInfo -> ODBCInfo not available");
	}
	else
		rString.AppendAscii((const char*)aValue);

	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::GetODBCInfo(UWORD nInfoType, USHORT & rNumber) const
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	UWORD nValue;
	SWORD nValueLen;
	RETCODE nRetCode =
		NSQLGetInfo(m_aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetODBCInfo -> ODBCInfo not available");
	}
	else
		rNumber = (USHORT)nValue;
	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::GetODBCInfo(UWORD nInfoType, ULONG& rNumber) const
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	ULONG nValue;
	SWORD nValueLen;
	RETCODE nRetCode =
		NSQLGetInfo(m_aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nRetCode == SQL_ERROR)
	{
		DBG_ERROR("GetODBCInfo -> ODBCInfo not available");
	}
	else
		rNumber = (ULONG)nValue;
	return nRetCode == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::GetODBCInfo(UWORD nInfoType, BOOL &rBool) const
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	String aString;
	BOOL bResult = GetODBCInfo(nInfoType,aString);
	if (bResult)
		rBool = (aString == String('Y'));
	return bResult;
}

//-----------------------------------------------------------------------------
void SdbODBC2Connection::CheckODBCCapabilities()
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	// Sind alle erforderlichen ODBC-Funktionen da?
	for (int i = 0; i < (sizeof aRequiredODBCFunctions / sizeof *aRequiredODBCFunctions); i++)
	{
		if (!IsODBCFunctionAvailable(aRequiredODBCFunctions[i]))
		{
			if (aStatus.IsSuccessful())
				aStatus.SetDriverNotCapableError();
			return;
		}
	}

	// steht die Info nicht zur Verfuegung -> !readonly
	BOOL bTest(FALSE);
	if (GetODBCInfo(SQL_DATA_SOURCE_READ_ONLY,bTest))
		bReadOnly = bTest;

	GetODBCInfo(SQL_NEED_LONG_DATA_LEN,bNeedLen);

	// Commitbehaviour (Rollback)
	GetODBCInfo(SQL_CURSOR_COMMIT_BEHAVIOR,nCommitBehavior);
	// SQL_CB_PRESERVE heit, alle Cursor einer Connection bleiben erhalten
	// Ist das beim Rollback auch so?
	if (nCommitBehavior == SQL_CB_PRESERVE)
		GetODBCInfo(SQL_CURSOR_ROLLBACK_BEHAVIOR,nCommitBehavior);

	// bestimmen der OdbcVersion als Major version
	String aOdbcVer;
	if (GetODBCInfo(SQL_ODBC_VER,aOdbcVer))
	{
		String aMajor = aOdbcVer.GetToken(0,'.');
		nODBCVer = aMajor.ToInt32();
		if (!nODBCVer)
			nODBCVer = String(aMajor.GetChar(1)).ToInt32();
	}

	// Werden die Cursor einer Connection alle nach einem Commit oder
	// Rollback geschlossen, dann folgt daraus: wenn Transaktionen, dann immer
	// eigene Connection!!!

	// kann kein AutoCommit durchgefuert werden, dann gilt die Datenquelle
	// dann als readonly, wenn Commit oder rollback immer alle Cursor einer
	// Connection schlieen, da hierdurch sehr viele Seiteneffekte auftreten knnen
	// die nicht zu kontrollieren sind
	ULONG nOption = 0;
	SetStatus(NSQLGetConnectOption(m_aConnectionHandle,
								   SQL_AUTOCOMMIT, &nOption),m_aConnectionHandle);
	if (!aStatus.IsSuccessful())
	{
		// immer manual commit
		bAutoCommit = FALSE;
		// nach einem Commit werden alle Cursor weggeschmissen
		// das kann unser Treiber nun wirklich nicht
		if (nCommitBehavior != SQL_CB_PRESERVE)
			bReadOnly = TRUE;
	}
	else
		bAutoCommit = nOption == SQL_AUTOCOMMIT_ON;

	GetODBCInfo(SQL_CURSOR_COMMIT_BEHAVIOR,nCommitBehavior);

	// Zusaetzlich: Funktionen aus ODBC Version 2 (oder deren Ersatz aus ODBC1):
	BOOL bBindParameterAvailable = FALSE;
#if SDB_ODBC2
	bBindParameterAvailable = IsODBCFunctionAvailable(SQL_API_SQLBINDPARAMETER);
	// Fehler ignorieren, Ergebnis in diesem Fall FALSE
	aStatus.Clear();
#endif
	if (! bBindParameterAvailable)
	{
		// Dann wird aber zumindest SetParam benoetigt!
		if (!IsODBCFunctionAvailable(SQL_API_SQLSETPARAM))
			aStatus.SetDriverNotCapableError();
	}

	// IdentifierQuotation
	String aIdentifierQuotation;
	GetODBCInfo(SQL_IDENTIFIER_QUOTE_CHAR,aIdentifierQuotation);
	aIdentifierQuotation.EraseLeadingChars(' ');
	cIdentifierQuotation = aIdentifierQuotation.GetChar(0);

#if SDB_ODBC2
	GetODBCInfo(SQL_SPECIAL_CHARACTERS,aSpecialCharStr);
	aSpecialCharStr.EraseLeadingChars(' ');
#endif

	// In welcher Art ist der Treiber Updatebar
	GetODBCInfo(SQL_SCROLL_CONCURRENCY,nDriverConcurrency);
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::OpenImpl()
{
	if (m_aConnectionHandle == SQL_NULL_HDBC)
		return FALSE;

	String aOptions = ConnectStr();

	// Verbindung aufbauen
	RETCODE nRetCode = SdbODBC2Connection::OpenConnection(m_aConnectionHandle, aOptions,GetEnvironment()->GetLoginTimeOut(), bNoPrompt);
	if (nRetCode == SQL_ERROR)
	{
		aStatus.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					aStatus.CreateErrorMessage(String(SdbResId(STR_STAT_INVALID_CONNECTION))),
					0, String() );
	}
	else if (nRetCode == SQL_NO_DATA_FOUND)
	{
		aStatus.Set(SDB_STAT_NO_DATA_FOUND);
	}
	if (!aStatus.IsSuccessful())
		return FALSE;


	if(!SdbODBCConnection::OpenImpl())
		return FALSE;


	// name des User in der Datenbank, kann unterschiedlich zum login name sein
	GetODBCInfo(SQL_USER_NAME,aUserName);

// den aktuellen Datenbanknamen ermitteln
#if SDB_ODBC2
	char cCurrentQualifier[SQL_MAX_OPTION_STRING_LENGTH + 1] = "";
	if (NSQLGetConnectOption(m_aConnectionHandle,SQL_CURRENT_QUALIFIER,cCurrentQualifier) == SQL_SUCCESS)
		aQualifierName.AssignAscii((const char*)cCurrentQualifier);
	else
		GetODBCInfo(SQL_DATABASE_NAME,aQualifierName);

	UINT16 nFileUsage = 0;
	GetODBCInfo(SQL_FILE_USAGE,nFileUsage);

	// sind ungueltige flags vom Treiber uebergeben worden?
	UINT32 nTempUsage = nFileUsage | SQL_FILE_TABLE | SQL_FILE_QUALIFIER;
	if (nTempUsage ^ (SQL_FILE_TABLE | SQL_FILE_QUALIFIER))
		nFileUsage = 0;

	// fuer einfache Filetreiber keinen Quailifier oder Owner
	if (!nFileUsage)
	{
		BOOL bHasInfo = TRUE;
		// treiber konnte keine auskunft geben
		if (!GetODBCInfo(SQL_OWNER_USAGE,nOwnerUsage) || !nOwnerUsage)
		{
			String aStr;
			GetODBCInfo(SQL_DBMS_NAME,aStr);
			if(aStr.Search(String::CreateFromAscii("Oracle")) != STRING_NOTFOUND) // XXX hack Oracle 7.3
				bHasInfo = FALSE;
		}
		else
		{
			// sind ungueltige flags vom Treiber uebergeben worden?
			UINT32 nTempUsage = nOwnerUsage | SQL_OU_DML_STATEMENTS | SQL_OU_PROCEDURE_INVOCATION |
						 SQL_OU_TABLE_DEFINITION | SQL_OU_INDEX_DEFINITION | SQL_OU_PRIVILEGE_DEFINITION;

			if (nTempUsage ^ (SQL_OU_DML_STATEMENTS |
							  SQL_OU_PROCEDURE_INVOCATION |
							  SQL_OU_TABLE_DEFINITION |
							  SQL_OU_INDEX_DEFINITION |
							  SQL_OU_PRIVILEGE_DEFINITION))
			{
				nOwnerUsage = 0;
				bHasInfo = FALSE;
			}
		}

		if (!bHasInfo)
		{
			// wenn keine Info verfuegbar, aber die Datenbank den Begriff
			// Qualifier kennt, dann werden eigene Annahmen getroffen
			String aOwnerTerm;
			GetODBCInfo(SQL_OWNER_TERM,aOwnerTerm);
			if (aOwnerTerm.Len())
				nOwnerUsage = SQL_OU_DML_STATEMENTS | SQL_OU_TABLE_DEFINITION;
		}

		bHasInfo = TRUE;
		if (!GetODBCInfo(SQL_QUALIFIER_USAGE,nQualifierUsage) || !nQualifierUsage)
		{
			String aStr;
			GetODBCInfo(SQL_DBMS_NAME,aStr);
			if(aStr.Search(String::CreateFromAscii("Oracle")) != STRING_NOTFOUND) // XXX hack Oracle 7.3
				bHasInfo = FALSE;
			nQualifierUsage = 0;
		}
		else
		{
			UINT32 nTempUsage = nQualifierUsage | SQL_QU_DML_STATEMENTS | SQL_QU_PROCEDURE_INVOCATION |
						 SQL_QU_TABLE_DEFINITION | SQL_QU_INDEX_DEFINITION | SQL_QU_PRIVILEGE_DEFINITION;

			if (nTempUsage ^ (SQL_OU_DML_STATEMENTS |
							  SQL_OU_PROCEDURE_INVOCATION |
							  SQL_OU_TABLE_DEFINITION |
							  SQL_OU_INDEX_DEFINITION |
							  SQL_OU_PRIVILEGE_DEFINITION))
			{
				bHasInfo = FALSE;
				nQualifierUsage = 0;
			}
		}

		if (!bHasInfo)
		{
			// wenn keine Info verfuegbar, aber die Datenbank den Begriff
			// Qualifier kennt, dann werden eigene Annahmen getroffen
			String aQualifierTerm;
			GetODBCInfo(SQL_QUALIFIER_TERM,aQualifierTerm);
			if (aQualifierTerm.Len())
				nQualifierUsage = SQL_QU_DML_STATEMENTS | SQL_QU_TABLE_DEFINITION;
		}
	}

	// Datenbankname noch nicht ermittelt
	if ((nQualifierUsage & SQL_QU_DML_STATEMENTS) == SQL_QU_DML_STATEMENTS)
	{
		String aQualifierSeparator;
		GetODBCInfo(SQL_QUALIFIER_NAME_SEPARATOR,aQualifierSeparator);
		aQualifierSeparator.EraseLeadingChars(' ');
		cQualifierSeparator = aQualifierSeparator.GetChar(0);
	}
#else
	GetODBCInfo(SQL_DATABASE_NAME,aQualifierName);
#endif

	// dient nur dazu festzustellen ob die Datenbank Qualiefer und Owner auch wirklich verwendet
	bOpen = TRUE;
	SdbODBCCursor* pCursor = (SdbODBCCursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	// Einen ganz speziellen Cursor oeffnen: anstelle von
	// Prepare und Execute wird Tables ausgefuehrt; die
	// Ergebnismenge enthaelt die gewuenschten Informationen

	pCursor->OpenTables(NULL,NULL,NULL,String::CreateFromAscii("TABLE").GetBuffer());
	/*      Reihenfolge
		1       TABLE_QUALIFIER
		2       TABLE_OWNER
		3       TABLE_NAME
	 */
	if(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		ODbVariantRef pVal;
		if ((nQualifierUsage &  SQL_QU_DML_STATEMENTS) ==  SQL_QU_DML_STATEMENTS)
		{
			pVal = rRow[1];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nQualifierUsage = 0;
		}
		if ((nOwnerUsage &  SQL_OU_DML_STATEMENTS) ==  SQL_OU_DML_STATEMENTS)
		{
			pVal = rRow[2];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nOwnerUsage = 0;
		}
	}
	pCursor->ReleaseRef();

	if(!nQualifierUsage)
		aQualifierName = String();
	// Wie sieht's mit der Navigation aus
	GetODBCInfo(SQL_FETCH_DIRECTION,nFetchDirection);
	GetODBCInfo(SQL_STATIC_SENSITIVITY,nStaticSensitivity);
	GetODBCInfo(SQL_POS_OPERATIONS,nPosOperations);

	// wieviel Stmts pro Connection
	GetODBCInfo(SQL_ACTIVE_STATEMENTS,nMaxStmts);
	aStatus.Clear();        //Ergebnis ignorieren
	return TRUE;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::CloseImpl()
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	DBG_ASSERT(IsOpen(),"SdbODBC2Connection: interner Fehler: Verbindung nicht geoeffnet");
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HENV,"SdbODBC2Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HDBC,"SdbODBC2Connection: interner Fehler: ConnectionHandle ungueltig");

	SetStatus(NSQLDisconnect(m_aConnectionHandle),m_aConnectionHandle);
	return aStatus.IsSuccessful();
}


//-----------------------------------------------------------------------------
void SdbODBC2Connection::SetAutoCommit(BOOL bAuto)
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);

	if (bAuto == bAutoCommit)
		return;

#ifndef MAC
	if (!bReadOnly) SetStatus(NSQLSetConnectOption(m_aConnectionHandle,
								   SQL_AUTOCOMMIT,
								   (bAuto) ? SQL_AUTOCOMMIT_ON : SQL_AUTOCOMMIT_OFF),
								   m_aConnectionHandle);
	if (aStatus.IsSuccessful())
	{
		bAutoCommit = bAuto;
	}

#else
	aStatus.Set( SDB_STAT_ERROR );
#endif
}

//-----------------------------------------------------------------------------
void SdbODBC2Connection::CommitImpl()
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HENV,"SdbODBC2Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HDBC,"SdbODBC2Connection: interner Fehler: ConnectionHandle ungueltig");
	DBG_ASSERT(IsODBCFunctionAvailable(SQL_API_SQLTRANSACT), "Transactionen werden nicht unterstuetzt");

	SetStatus(NSQLTransact(m_aEnvironmentHandle,m_aConnectionHandle,SQL_COMMIT),m_aConnectionHandle);
}

//-----------------------------------------------------------------------------
void SdbODBC2Connection::RollbackImpl()
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HENV,"SdbODBC2Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HDBC,"SdbODBC2Connection: interner Fehler: ConnectionHandle ungueltig");
	DBG_ASSERT(IsODBCFunctionAvailable(SQL_API_SQLTRANSACT), "Transactionen werden nicht unterstuetzt");

	SetStatus(NSQLTransact(m_aEnvironmentHandle,m_aConnectionHandle,SQL_ROLLBACK),m_aConnectionHandle);
}

//-----------------------------------------------------------------------------
SdbCursor* SdbODBC2Connection::CreateCursorImpl(SdbCursorType eType,
											   UINT16 nOptions)
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HENV,"SdbODBC2Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HDBC,"SdbODBC2Connection: interner Fehler: ConnectionHandle ungueltig");

	SdbODBC2Cursor* pCursor = new SdbODBC2Cursor(this, eType, nOptions);
	if (!pCursor->ConnectionHandle() && pCursor->StmtHandle())
		nActiveStmts++;
	return pCursor;
}

//-----------------------------------------------------------------------------
String SdbODBC2Connection::ServerNames(SdbStatus& rStat, SdbEnvironment* pEnv)
{
	String aString;
	String aPath;
	HENV hEnv = EnvironmentHandle(pEnv,aPath);

	// Fehler beim Allozieren des Environment ignorieren
	if (hEnv == SQL_NULL_HENV)
	{
		String aText = String(SdbResId(STR_STAT_ODBC_NOT_FOUND));
		aText.SearchAndReplace(String::CreateFromAscii("#DLL#"),aPath);
		rStat.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					rStat.CreateErrorMessage(aText),
					0, String() );

		return aString;
	}

	SDB_ODBC_CHAR szDSN[SQL_MAX_DSN_LENGTH+1];
	SWORD pcbDSN;
	SDB_ODBC_CHAR szDescription[1024+1];
	SWORD pcbDescription;
	RETCODE nRetCode = SQL_SUCCESS;
	BOOL bFirst = TRUE;

	for (;;)
	{

		// Datenquellen-Name von ODBC abholen:
		nRetCode = NSQLDataSources(hEnv,
						   (bFirst) ? SQL_FETCH_FIRST : SQL_FETCH_NEXT,
						   szDSN, sizeof szDSN, &pcbDSN,
						   szDescription, sizeof szDescription, &pcbDescription);
		if (nRetCode != SQL_SUCCESS)
				// Vorlaeufig keine weitere Fehlerbehandlung
			break;
		else
		{
			bFirst = FALSE;
			aString += String::CreateFromAscii((const char *)szDSN);

			// Description als Kommentar mit aufnehmen
			if (*szDescription)
			{
				aString.AppendAscii(" (");
				aString += String::CreateFromAscii((const char *)szDescription);
				aString += ')';
			}

			aString += SDB_SEPARATOR;
		}
	}

#if defined(LINUX)
	// manche haben einfach keine Implementierung, schade
	if (bFirst && nRetCode == SQL_SUCCESS && szDSN[0] == 0)
	{
//		String aName = getenv("HOME");
		String aName; aName.AssignAscii( getenv("HOME") );
		DirEntry aOdbcIni(aName);
		aOdbcIni += DirEntry(String::CreateFromAscii(".odbc.ini"));
		SvFileStream aIniStr(aOdbcIni.GetFull(), STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYNONE);
		if (!aIniStr.IsOpen())
			return aString;

		// Implementierung noch Fehlerhaft

		/* String aSource; = ReadToken(aIniStr);
		if (aSource.Len())
		{
			aString += aSource;
			aString += SDB_SEPARATOR;
		}*/
	}
#endif //LINUX


	aString.EraseTrailingChars(SDB_SEPARATOR);
	return aString;
}


//-----------------------------------------------------------------------------
BOOL SdbODBC2Connection::IsCapableImpl(SdbCapability eCapability) const
{
	BOOL bResult;
	switch(eCapability)
	{
	// Von ODBC erfragbare Capabilities:
	// Updatebar, wenn
		case SDB_CAP_UPDATABLE:
			bResult = (bReadOnly) ? FALSE : SdbConnection::IsCapableImpl(eCapability);
			break;

		case SDB_CAP_READ_UNCOMMITTED:  bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_UNCOMMITTED); break;
		case SDB_CAP_READ_COMMITTED:    bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_COMMITTED); break;
		case SDB_CAP_REPEATABLE_READ:   bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_REPEATABLE_READ); break;
		case SDB_CAP_SERIALIZABLE:      bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_SERIALIZABLE); break;

	// Sonstige Capabilities:

		case SDB_CAP_COMMIT_AUTO:
		case SDB_CAP_COMMIT_MANUAL:             bResult = !bReadOnly; break;
		case SDB_CAP_JOIN:                              bResult = TRUE; break;

		case SDB_CAP_CREATE_TABLE:
		case SDB_CAP_RENAME_TABLE:              bResult = TRUE; break;
		case SDB_CAP_PRIMARYKEYS:
			bResult = IsODBCFunctionAvailable(SQL_API_SQLPRIMARYKEYS); break;
		case SDB_CAP_FOREIGNKEYS:
			bResult = IsODBCFunctionAvailable(SQL_API_SQLFOREIGNKEYS); break;
#if SDB_ODBC2
		case SDB_CAP_ALTER_TABLE:               bResult = IsDriverCapable(SQL_ALTER_TABLE, SQL_AT_ADD_COLUMN) || IsDriverCapable(SQL_ALTER_TABLE, SQL_AT_DROP_COLUMN);
												break;
		case SDB_CAP_CREATE_INDEX:              bResult = ((SdbODBC2Connection *)this)->IsODBCFunctionAvailable(SQL_API_SQLSTATISTICS); break;
		case SDB_CAP_DESC_INDEX:                bResult = TRUE; break;
#endif
		case SDB_CAP_BULKOPTIMIZE:              bResult = TRUE; break;
		case SDB_CAP_STATIC_PRIOR:
		case SDB_CAP_KEYSET_PRIOR:				bResult = (nFetchDirection & SQL_FD_FETCH_PREV) == SQL_FD_FETCH_PREV; break;
		default:
			bResult = SdbConnection::IsCapableImpl(eCapability);
	}
	return bResult;
}


//-----------------------------------------------------------------------------
void SdbODBC2Connection::SetIsolationLevelImpl(SdbIsolationLevel eNewIsolationLevel)
{
	DBG_CHKTHIS(SdbODBC2Connection,NULL);
	UDWORD nValue;
	switch (eNewIsolationLevel)
	{
		case SDB_ISO_READ_UNCOMMITTED:  nValue = SQL_TXN_READ_UNCOMMITTED; break;
		case SDB_ISO_READ_COMMITTED:    nValue = SQL_TXN_READ_COMMITTED; break;
		case SDB_ISO_REPEATABLE_READ:   nValue = SQL_TXN_REPEATABLE_READ; break;
		case SDB_ISO_SERIALIZABLE:              nValue = SQL_TXN_SERIALIZABLE; break;
		// case SDB_ISO_VERSIONING:                nValue = SQL_TXN_VERSIONING; break;
		// veraltet
		default:                                                aStatus.SetDriverNotCapableError();
										return;
	}

	SetStatus(NSQLSetConnectOption(m_aConnectionHandle,
								   SQL_TXN_ISOLATION,
								   nValue),
								   m_aConnectionHandle);
	if (! aStatus.IsSuccessful()) return;
	eIsolationLevel = eNewIsolationLevel;
}

//-----------------------------------------------------------------------------
SdbDatabaseType SdbODBC2Connection::MapType(INT16 nODBCType)
{
	switch(nODBCType)
	{
		case SQL_WCHAR:					m_bUserWChar = TRUE;
		case SQL_CHAR:                  return SDB_DBTYPE_CHAR;
		case SQL_WVARCHAR:				m_bUserWChar = TRUE;
		case SQL_VARCHAR:               return SDB_DBTYPE_VARCHAR;
		case SQL_WLONGVARCHAR:			m_bUserWChar = TRUE;
		case SQL_LONGVARCHAR:			return SDB_DBTYPE_LONGVARCHAR;
		case SQL_DECIMAL:               return SDB_DBTYPE_DECIMAL;
		case SQL_NUMERIC:               return SDB_DBTYPE_NUMERIC;
		case SQL_BIT:                   return SDB_DBTYPE_BOOLEAN;
		case SQL_TINYINT:               return SDB_DBTYPE_TINYINT;
		case SQL_SMALLINT:              return SDB_DBTYPE_SMALLINT;
		case SQL_INTEGER:               return SDB_DBTYPE_INTEGER;
		case SQL_BIGINT:                return SDB_DBTYPE_BIGINT;
		case SQL_REAL:                  return SDB_DBTYPE_REAL;
		case SQL_FLOAT:
		case SQL_DOUBLE:                return SDB_DBTYPE_DOUBLE;
		case SQL_BINARY:                return SDB_DBTYPE_BINARY;
		case SQL_VARBINARY:     return SDB_DBTYPE_VARBINARY;
		case SQL_LONGVARBINARY: return SDB_DBTYPE_LONGVARBINARY;
		case SQL_DATE:                  return SDB_DBTYPE_DATE;
		case SQL_TIME:                  return SDB_DBTYPE_TIME;
		case SQL_TIMESTAMP:     return SDB_DBTYPE_TIMESTAMP;
		default:                                return SDB_DBTYPE_UNKNOWN;
	}
}



//-----------------------------------------------------------------------------
// bSilent wird dann verwendet, wenn eine Connection als Copy einer anderen
// verwendet wird
RETCODE SdbODBC2Connection::OpenConnection(HDBC hDBC, const String& aConnectStr,UINT32 nTimeOut, BOOL bSilent)
{
	if (hDBC == SQL_NULL_HDBC)
		return -1;

	BOOL bReadOnly; //weil Methode statisch hier noch einmal ein lokales bReadOnly
	RETCODE nRetCode = 0;
	SDB_ODBC_CHAR szConnStrOut[1024];
	SDB_ODBC_CHAR szConnStrIn[2048];
	SWORD cbConnStrOut;
	memset(szConnStrOut,'\0',1024);
	memset(szConnStrIn,'\0',2048);
	ByteString aConStr(aConnectStr,gsl_getSystemTextEncoding());
	memcpy(szConnStrIn, (SDB_ODBC_CHAR*) aConStr.GetBuffer(), Min((xub_StrLen)2048,aConStr.Len()));


#ifndef DEBUG
	NSQLSetConnectOption(hDBC,SQL_OPT_TRACE,SQL_OPT_TRACE_OFF);
#endif

	NSQLSetConnectOption(hDBC,SQL_LOGIN_TIMEOUT,nTimeOut);
	// Verbindung aufbauen

#ifdef LINUX

	nRetCode = NSQLDriverConnect(hDBC,
					  NULL,
					  szConnStrIn,
					  (SWORD) Min((xub_StrLen)2048,aConStr.Len()),
					  szConnStrOut,
					  (SWORD) sizeof szConnStrOut,
					  &cbConnStrOut,
					  SQL_DRIVER_NOPROMPT);
	if (nRetCode == SQL_ERROR || nRetCode == SQL_NO_DATA_FOUND)
		return nRetCode;
#else

	nRetCode = NSQLDriverConnect(hDBC,
					  NULL,
					  szConnStrIn,
					  (SWORD) Min((xub_StrLen)2048,aConStr.Len()),
					  szConnStrOut,
					  (SWORD) sizeof szConnStrOut,
					  &cbConnStrOut,
					  bSilent ? SQL_DRIVER_NOPROMPT : SQL_DRIVER_COMPLETE);
	if (nRetCode == SQL_ERROR || nRetCode == SQL_NO_DATA_FOUND)
		return nRetCode;

#endif //LINUX

SWORD nValueLen;
nRetCode = NSQLGetInfo(hDBC,SQL_DATA_SOURCE_READ_ONLY,&bReadOnly,sizeof bReadOnly,&nValueLen);
if (nRetCode != SQL_SUCCESS) return nRetCode;

// db2 wird etwa um Faktor 50 langsamer unter OS/2
#if defined(WIN) || defined(WNT)
//      NSQLSetConnectOption(hDBC, SQL_ASYNC_ENABLE, SQL_ASYNC_ENABLE_ON);
#endif

#if SDB_ODBC2
/*      NSQLSetConnectOption(hDBC,
						 SQL_ODBC_CURSORS,
						 SQL_CUR_USE_IF_NEEDED);*/
#endif

#ifndef MAC
	// autocoomit ist immer default
		if (!bReadOnly) NSQLSetConnectOption(hDBC,SQL_AUTOCOMMIT,
							  SQL_AUTOCOMMIT_ON);
#endif
	return nRetCode;
}

//-----------------------------------------------------------------------------
void SdbODBC2Connection::FreeEnv(SdbEnvironment* pEnv){
	NSQLFreeEnv(pEnv->aEnvironmentHandle);
}

//------------------------------------------------------------------
SdbTypeSearch SdbODBC2Connection::GetSearchType(int nType)
{
	SdbTypeSearch eType = Search_All;
	switch (nType)
	{
		case SQL_UNSEARCHABLE:		eType = Search_None;			break;
		case SQL_LIKE_ONLY:			eType = Search_Like_Only;		break;
		case SQL_ALL_EXCEPT_LIKE:	eType = Search_Except_Like;	break;
	}
	return eType;
}
//-----------------------------------------------------------------------------
::stardata::XDatabaseDescriptor* SdbODBC2Connection::GetMetaDataImpl()
{
	SdbODBC2MetaData* pMetaData = new SdbODBC2MetaData(this);
	return pMetaData;
}

