/*************************************************************************
 *
 *  $RCSfile: odbc2imp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_ODBCINC_HXX
#include "odbc2inc.hxx"
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SDB_SDBENV_HXX
#include <sdbenv.hxx>
#endif
#ifndef _OSL_MODULE_H_
#include <osl/module.h>
#endif
// Dynamisches Laden der DLL/shared lib und Adressen der Funktionen besorgen:
// Liefert TRUE bei Erfolg.
BOOL LoadLibrary_ODBC(SdbEnvironment* pEnv,String &_rPath)
{
	static sal_Bool bLoaded = sal_False;
	static oslModule pso = NULL;

	if (bLoaded)
		return TRUE;
	

#ifdef WIN
	_rPath = String::CreateFromAscii("ODBC.DLL");
	
#endif
#ifdef WNT
	_rPath = String::CreateFromAscii("ODBC32.DLL");
#endif
#ifdef UNX
	_rPath = String::CreateFromAscii("libodbc.so");
#endif
#ifdef OS2
	_rPath = String::CreateFromAscii("ODBC");
#endif

	pso = osl_loadModule( ::rtl::OUString(_rPath.GetBuffer()).pData,SAL_LOADMODULE_NOW );
	if( !pso)
#ifdef OS2
	{
		delete pso;
		_rPath = String::CreateFromAscii("WOD402");
		pso = osl_loadModule( _rPath.pData,SAL_LOADMODULE_NOW );
		if( !pODBCso)
			return sal_False;
	}
#else
		return sal_False;
#endif

	if( ( pSQLAllocConnect	=	(TSQLAllocConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocConnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLAllocEnv		=	(TSQLAllocEnv)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocEnv").pData )) == NULL )
		return FALSE;
	if( ( pSQLAllocStmt		=	(TSQLAllocStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocStmt").pData )) == NULL )
		return FALSE;
	if( ( pSQLBindCol		=	(TSQLBindCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindCol").pData )) == NULL )
		return FALSE;
	if( ( pSQLCancel		=	(TSQLCancel)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLCancel").pData )) == NULL )
		return FALSE;
	if( ( pSQLColAttributes =	(TSQLColAttributes)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColAttributes").pData )) == NULL )
		return FALSE;
	if( ( pSQLConnect		=	(TSQLConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLConnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLDescribeCol	=	(TSQLDescribeCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeCol").pData )) == NULL )
		return FALSE;
	if( ( pSQLDisconnect	=	(TSQLDisconnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDisconnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLError			=	(TSQLError)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLError").pData )) == NULL )
		return FALSE;
	if( ( pSQLExecDirect	=	(TSQLExecDirect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecDirect").pData )) == NULL )
		return FALSE;
	if( ( pSQLExecute		=	(TSQLExecute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecute").pData )) == NULL )
		return FALSE;
	if( ( pSQLFetch			=	(TSQLFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFetch").pData )) == NULL )
		return FALSE;
	if( ( pSQLFreeConnect	=	(TSQLFreeConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeConnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLFreeEnv		=	(TSQLFreeEnv)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeEnv").pData )) == NULL )
		return FALSE;
	if( ( pSQLFreeStmt		=	(TSQLFreeStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetCursorName =	(TSQLGetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetCursorName").pData )) == NULL )
		return FALSE;
	if( ( pSQLNumResultCols =	(TSQLNumResultCols)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumResultCols").pData )) == NULL )
		return FALSE;
	if( ( pSQLPrepare		=	(TSQLPrepare)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrepare").pData )) == NULL )
		return FALSE;
	if( ( pSQLRowCount		=	(TSQLRowCount)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLRowCount").pData )) == NULL )
		return FALSE;
	if( ( pSQLSetCursorName =	(TSQLSetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetCursorName").pData )) == NULL )
		return FALSE;
	if( ( pSQLTransact		=	(TSQLTransact)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTransact").pData )) == NULL )
		return FALSE;
	if( ( pSQLColumns		=	(TSQLColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumns").pData )) == NULL )
		return FALSE;
	if( ( pSQLDriverConnect =	(TSQLDriverConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDriverConnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetConnectOption =  (TSQLGetConnectOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetConnectOption").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetData		=	(TSQLGetData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetData").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetFunctions	=	(TSQLGetFunctions)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetFunctions").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetInfo		=	(TSQLGetInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetInfo").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetStmtOption =	(TSQLGetStmtOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetStmtOption").pData )) == NULL )
		return FALSE;
	if( ( pSQLGetTypeInfo	=	(TSQLGetTypeInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetTypeInfo").pData )) == NULL )
		return FALSE;
	if( ( pSQLParamData		=	(TSQLParamData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamData").pData )) == NULL )
		return FALSE;
	if( ( pSQLPutData		=	(TSQLPutData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPutData").pData )) == NULL )
		return FALSE;
	if( ( pSQLSetConnectOption =  (TSQLSetConnectOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetConnectOption").pData )) == NULL )
		return FALSE;
	if( ( pSQLSetStmtOption =   (TSQLSetStmtOption)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetStmtOption").pData )) == NULL )
		return FALSE;
	if( ( pSQLSpecialColumns =  (TSQLSpecialColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSpecialColumns").pData )) == NULL )
		return FALSE;
	if( ( pSQLStatistics	=   (TSQLStatistics)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLStatistics").pData )) == NULL )
		return FALSE;
	if( ( pSQLTables		=   (TSQLTables)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTables").pData )) == NULL )
		return FALSE;
	if( ( pSQLBrowseConnect =   (TSQLBrowseConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBrowseConnect").pData )) == NULL )
		return FALSE;
	if( ( pSQLColumnPrivileges = (TSQLColumnPrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumnPrivileges").pData )) == NULL )
		return FALSE;
	if( ( pSQLDataSources	=   (TSQLDataSources)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDataSources").pData )) == NULL )
		return FALSE;
	if( ( pSQLDescribeParam =   (TSQLDescribeParam)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeParam").pData )) == NULL )
		return FALSE;
	if( ( pSQLExtendedFetch =   (TSQLExtendedFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExtendedFetch").pData )) == NULL )
		return FALSE;
	if( ( pSQLForeignKeys	=	(TSQLForeignKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLForeignKeys").pData )) == NULL )
		return FALSE;
	if( ( pSQLMoreResults	=	(TSQLMoreResults)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLMoreResults").pData )) == NULL )
		return FALSE;
	/*if( ( pSQLNativeSql		=	(TSQLNativeSql)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNativeSql").pData )) == NULL )
		return FALSE;*/
	if( ( pSQLNumParams		=	(TSQLNumParams)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumParams").pData )) == NULL )
		return FALSE;
	if( ( pSQLParamOptions	=	(TSQLParamOptions)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamOptions").pData )) == NULL )
		return FALSE;
	if( ( pSQLPrimaryKeys	=	(TSQLPrimaryKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrimaryKeys").pData )) == NULL )
		return FALSE;
	if( ( pSQLProcedureColumns =  (TSQLProcedureColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedureColumns").pData )) == NULL )
		return FALSE;
	if( ( pSQLProcedures	=	(TSQLProcedures)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedures").pData )) == NULL )
		return FALSE;
	if( ( pSQLSetPos		=	(TSQLSetPos)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetPos").pData )) == NULL )
		return FALSE;
	if( ( pSQLTablePrivileges =	(TSQLTablePrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTablePrivileges").pData )) == NULL )
		return FALSE;
	if( ( pSQLBindParameter =	(TSQLBindParameter)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindParameter").pData )) == NULL )
		return FALSE;

	bLoaded = TRUE;
	pEnv->AppendLibrary(pso);
	return TRUE;
}

TSQLAllocConnect pSQLAllocConnect;
TSQLAllocEnv pSQLAllocEnv;
TSQLAllocStmt pSQLAllocStmt;
TSQLBindCol pSQLBindCol;
TSQLCancel pSQLCancel;
TSQLColAttributes pSQLColAttributes;
TSQLConnect pSQLConnect;
TSQLDescribeCol pSQLDescribeCol;
TSQLDisconnect pSQLDisconnect;
TSQLError pSQLError;
TSQLExecDirect pSQLExecDirect;
TSQLExecute pSQLExecute;
TSQLFetch pSQLFetch;
TSQLFreeConnect pSQLFreeConnect;
TSQLFreeEnv pSQLFreeEnv;
TSQLFreeStmt pSQLFreeStmt;
TSQLGetCursorName pSQLGetCursorName;
TSQLNumResultCols pSQLNumResultCols;
TSQLPrepare pSQLPrepare;
TSQLRowCount pSQLRowCount;
TSQLSetCursorName pSQLSetCursorName;
TSQLTransact pSQLTransact;
TSQLColumns pSQLColumns;
TSQLDriverConnect pSQLDriverConnect;
TSQLGetConnectOption pSQLGetConnectOption;
TSQLGetData pSQLGetData;
TSQLGetFunctions pSQLGetFunctions;
TSQLGetInfo pSQLGetInfo;
TSQLGetStmtOption pSQLGetStmtOption;
TSQLGetTypeInfo pSQLGetTypeInfo;
TSQLParamData pSQLParamData;
TSQLPutData pSQLPutData;
TSQLSetConnectOption pSQLSetConnectOption;
TSQLSetStmtOption pSQLSetStmtOption;
TSQLSpecialColumns pSQLSpecialColumns;
TSQLStatistics pSQLStatistics;
TSQLTables pSQLTables;
TSQLBrowseConnect pSQLBrowseConnect;
TSQLColumnPrivileges pSQLColumnPrivileges;
TSQLDataSources pSQLDataSources;
TSQLDescribeParam pSQLDescribeParam;
TSQLExtendedFetch pSQLExtendedFetch;
TSQLForeignKeys pSQLForeignKeys;
TSQLMoreResults pSQLMoreResults;
TSQLNativeSql pSQLNativeSql;
TSQLNumParams pSQLNumParams;
TSQLParamOptions pSQLParamOptions;
TSQLPrimaryKeys pSQLPrimaryKeys;
TSQLProcedureColumns pSQLProcedureColumns;
TSQLProcedures pSQLProcedures;
TSQLSetPos pSQLSetPos;
TSQLTablePrivileges pSQLTablePrivileges;
TSQLDrivers pSQLDrivers;
#if defined(WIN) || defined(WNT) || defined( UNX ) || defined(OS2)
TSQLBindParameter pSQLBindParameter;
#else
TSQLSetParam pSQLSetParam;
#endif
