/*************************************************************************
 *
 *  $RCSfile: odbc3conn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "odbc3conn.hxx"

#include "odbc3curs.hxx"

#include "odbc3imp.hxx"


#include "odbctab.hxx"
#include "sdbresid.hrc"

#ifndef _SDB_SDBREL_HXX
#include <sdbrel.hxx>
#endif

#ifndef _SDB_SDBENV_HXX
#include "sdbenv.hxx"
#endif

#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifdef SQL_KEYWORDS
#undef SQL_KEYWORDS
#endif

#ifndef _SDB_ODBCMD_HXX
#include <odbc3md.hxx>
#endif // _SDB_ODBCMD_HXX

#include "sdbmap.hxx"

DBG_NAME(SdbODBC3Connection);
TYPEINIT1(SdbODBC3Connection,SdbODBCConnection);

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

const UWORD aRequiredODBCFunctions[] =
{
//		SQL_API_SQLALLOCCONNECT,
//		SQL_API_SQLALLOCENV,
//		SQL_API_SQLALLOCSTMT,
//		SQL_API_SQLCANCEL,
	SQL_API_SQLCOLUMNS,
	SQL_API_SQLCOLATTRIBUTE,
//	SQL_API_SQLDATASOURCES,                         // Level 2 (Driver Manager)
	SQL_API_SQLDESCRIBECOL,
//      SQL_API_SQLDESCRIBEPARAM,                       // Level 2
	SQL_API_SQLDISCONNECT,
	SQL_API_SQLDRIVERCONNECT,
	SQL_API_SQLGETDIAGREC,
	SQL_API_SQLEXECDIRECT,
	SQL_API_SQLEXECUTE,
	SQL_API_SQLFETCH,
//      SQL_API_SQLFOREIGNKEYS,                         // Level 2
//		SQL_API_SQLFREECONNECT,
//		SQL_API_SQLFREESTMT,
	SQL_API_SQLGETCONNECTATTR,
	SQL_API_SQLGETDATA,
	SQL_API_SQLGETFUNCTIONS,
	SQL_API_SQLGETINFO,
	SQL_API_SQLGETSTMTATTR,
	SQL_API_SQLGETTYPEINFO,
//      SQL_API_SQLNUMPARAMS,                           // Level 2
	SQL_API_SQLNUMRESULTCOLS,
	SQL_API_SQLPARAMDATA,
	SQL_API_SQLPREPARE,
//      SQL_API_SQLPRIMARYKEYS,                         // Level 2
//      SQL_API_SQLPROCEDURECOLUMNS,            // Level 2
//      SQL_API_SQLPROCEDURES,                          // Level 2
	SQL_API_SQLPUTDATA,
//		SQL_API_SQLROWCOUNT,
	SQL_API_SQLSETCONNECTATTR,
//      SQL_API_SQLSETPARAM,                            // Level 2
	SQL_API_SQLTABLES
//      SQL_API_SQLTRANSACT                                     // wird nicht unbedingt benoetigt
};

static char __READONLY_DATA ALL[] = "%";

//-----------------------------------------------------------------------------
void* SdbODBC3Connection::EnvironmentHandle()
{
	if(m_pODBC2Env )
		return m_pODBC2Env;
	String aPath;
	return EnvironmentHandle(GetEnvironment(),aPath);
}
//-----------------------------------------------------------------------------
// ODBC Environment (gemeinsam fuer alle Connections):
SQLHANDLE SdbODBC3Connection::EnvironmentHandle(SdbEnvironment* pEnv,String &_rPath)
{
	// Ist (fuer diese Instanz) bereits ein Environment erzeugt worden?
	if (pEnv && pEnv->aODBC3EnvironmentHandle == NULL)
	{
		SQLHANDLE h = SQL_NULL_HANDLE;
		// Environment allozieren

#ifdef ODBCIMP
		// ODBC-DLL jetzt laden:
		if (!LoadLibrary_ODBC3(pEnv,_rPath))
			return SQL_NULL_HANDLE;
#endif

#ifdef MAC
		if (kUnresolvedCFragSymbolAddress == ((long) SQLAllocHandle))
			return SQL_NULL_HANDLE;
#endif

		if (N3SQLAllocHandle(SQL_HANDLE_ENV,SQL_NULL_HANDLE,&h) != SQL_SUCCESS)
			return SQL_NULL_HANDLE;

		// In globaler Struktur merken ...
		pEnv->aODBC3EnvironmentHandle = (void *) h;
		SQLRETURN nError = N3SQLSetEnvAttr(h, SQL_ATTR_ODBC_VERSION,(SQLPOINTER) SQL_OV_ODBC3, SQL_IS_INTEGER);
		//N3SQLSetEnvAttr(h, SQL_ATTR_CONNECTION_POOLING,(SQLPOINTER) SQL_CP_ONE_PER_HENV, SQL_IS_INTEGER);
	}

	return (SQLHANDLE) pEnv ? pEnv->aODBC3EnvironmentHandle : SQL_NULL_HANDLE;
}

//-----------------------------------------------------------------------------
void SdbODBC3Connection::Construct(SdbEnvironment* pEnv)
{
	// Environment Handle besorgen (einmal beim Anlegen des Objektes -
	// wird aus Effizienzgrunden in jedem ODBCConnection-Objekt gespeichert)
	String aPath;
	m_aEnvironmentHandle = EnvironmentHandle(pEnv,aPath);
	if (! aStatus.IsSuccessful())
		return;

	m_aConnectionHandle  = SQL_NULL_HANDLE;
	if (m_aEnvironmentHandle == SQL_NULL_HANDLE)
	{
		String aText = String(SdbResId(STR_STAT_ODBC_NOT_FOUND));
		aText.SearchAndReplace(String::CreateFromAscii("#DLL#"),aPath);
		aStatus.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					aStatus.CreateErrorMessage(aText),
					0, String() );
		return;
	}

	// Connection allozieren
	// (Eine ODBC-Connection pro SdbConnection).
	SetStatus(N3SQLAllocHandle(SQL_HANDLE_DBC,m_aEnvironmentHandle,&m_aConnectionHandle),m_aEnvironmentHandle);
	if (! aStatus.IsSuccessful()) return;

	nODBCVer  = 3;
	aStatus.SetComponent(String::CreateFromAscii("Sdb ODBC Driver 3.0"));

}

//-----------------------------------------------------------------------------
SdbODBC3Connection::SdbODBC3Connection(SdbEnvironment* pEnv, const String& rNewOptions)
				  :SdbODBCConnection(pEnv, rNewOptions)
				  ,m_nForwardOnlyAttr1(0)
				  ,m_nForwardOnlyAttr2(0)
				  ,m_nKeySetAttr1(0)
				  ,m_nKeySetAttr2(0)
				  ,m_nStaticAttr1(0)
				  ,m_nStaticAttr2(0)
				  ,m_bUseOldTimeDate(FALSE)
				  ,m_pODBC2Env(NULL)
				  ,m_bIsValid(TRUE)
{
	DBG_CTOR(SdbODBC3Connection,NULL);
	Construct(pEnv);
}

//-----------------------------------------------------------------------------
// Copy CTOR nur fuer den internen Gebrauch
SdbODBC3Connection::SdbODBC3Connection(const SdbODBC3Connection& rConn)
				  :SdbODBCConnection(rConn.GetEnvironment(),rConn.Options())
				  ,m_nForwardOnlyAttr1(0)
				  ,m_nForwardOnlyAttr2(0)
				  ,m_nKeySetAttr1(0)
				  ,m_nKeySetAttr2(0)
				  ,m_bUseOldTimeDate(FALSE)
				  ,m_pODBC2Env(rConn.m_pODBC2Env)
				  ,m_bIsValid(TRUE)
{
	DBG_CTOR(SdbODBC3Connection,NULL);
	Construct(rConn.GetEnvironment());
}

//-----------------------------------------------------------------------------
SdbODBC3Connection::~SdbODBC3Connection()
{
	DBG_DTOR(SdbODBC3Connection,NULL);
	// KH: wenn m_aConnectionHandle nicht existiert wurde hoechstwahrscheinlich
	// die Library nicht angezogen, also ist es Unsinn SQLFreeConnect aufzurufen
	// da es moeglicherweise nicht existiert.

	if (m_aConnectionHandle != SQL_NULL_HANDLE)
		N3SQLFreeHandle(SQL_HANDLE_DBC,m_aConnectionHandle);
}
//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::IsODBCFunctionAvailable(UWORD nFunction) const
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	SQLUSMALLINT nExists=0;
	((SdbODBC3Connection*)this)->SetStatus(N3SQLGetFunctions(m_aConnectionHandle,nFunction,&nExists),m_aConnectionHandle);
	return (BOOL)nExists;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::GetODBCInfo(UWORD nInfoType, String & rString) const
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	char aValue[512];
	SWORD nValueLen;
	SQLRETURN nSQLRETURN = N3SQLGetInfo(m_aConnectionHandle,nInfoType,aValue,sizeof aValue,&nValueLen);

	if (nSQLRETURN == SQL_ERROR)
	{
		((SdbODBC3Connection*)this)->SetStatus(nSQLRETURN,m_aConnectionHandle);
		DBG_ASSERT(String::CreateFromAscii("IM001") == aStatus.SQLState() ||
			String::CreateFromAscii("HY096")== aStatus.SQLState(),"GetODBCInfo -> ODBCInfo not available");
		((SdbODBC3Connection*)this)->aStatus.Clear();
	}
	else
		rString.AssignAscii(aValue);

	return nSQLRETURN == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::GetODBCInfo(UWORD nInfoType, USHORT & rNumber) const
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	UWORD nValue;
	SWORD nValueLen;
	SQLRETURN nSQLRETURN =
		N3SQLGetInfo(m_aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nSQLRETURN == SQL_ERROR)
	{
		((SdbODBC3Connection*)this)->SetStatus(nSQLRETURN,m_aConnectionHandle);
		DBG_ASSERT(String::CreateFromAscii("IM001") == aStatus.SQLState() ||
			String::CreateFromAscii("HY096")== aStatus.SQLState(),"GetODBCInfo -> ODBCInfo not available");
		((SdbODBC3Connection*)this)->aStatus.Clear();
	}
	else
		rNumber = (USHORT)nValue;
	return nSQLRETURN == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::GetODBCInfo(UWORD nInfoType, ULONG& rNumber) const
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	ULONG nValue;
	SWORD nValueLen;
	SQLRETURN nSQLRETURN =
		N3SQLGetInfo(m_aConnectionHandle,nInfoType,&nValue,sizeof nValue,&nValueLen);
	if (nSQLRETURN == SQL_ERROR)
	{
		((SdbODBC3Connection*)this)->SetStatus(nSQLRETURN,m_aConnectionHandle);
		DBG_ASSERT(String::CreateFromAscii("IM001") == aStatus.SQLState() ||
			String::CreateFromAscii("HY096")== aStatus.SQLState(),"GetODBCInfo -> ODBCInfo not available");
		((SdbODBC3Connection*)this)->aStatus.Clear();
	}
	else
		rNumber = (ULONG)nValue;
	return nSQLRETURN == SQL_SUCCESS;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::GetODBCInfo(UWORD nInfoType, BOOL &rBool) const
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	String aString;
	BOOL bResult = GetODBCInfo(nInfoType,aString);
	if (bResult)
		rBool = (aString == String('Y'));
	return bResult;
}

//-----------------------------------------------------------------------------
void SdbODBC3Connection::CheckODBCCapabilities()
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	// Sind alle erforderlichen ODBC-Funktionen da?
	for (int i = 0; i < (sizeof aRequiredODBCFunctions / sizeof *aRequiredODBCFunctions); i++)
	{
		if (!IsODBCFunctionAvailable(aRequiredODBCFunctions[i]))
		{
			if (aStatus.IsSuccessful())
				aStatus.SetDriverNotCapableError();
			return;
		}
	}

	// steht die Info nicht zur Verfuegung -> !readonly
	BOOL bTest(FALSE);
	if (GetODBCInfo(SQL_DATA_SOURCE_READ_ONLY,bTest))
		bReadOnly = bTest;

	GetODBCInfo(SQL_NEED_LONG_DATA_LEN,bNeedLen);

	// Commitbehaviour (Rollback)
	GetODBCInfo(SQL_CURSOR_COMMIT_BEHAVIOR,nCommitBehavior);
	// SQL_CB_PRESERVE heit, alle Cursor einer Connection bleiben erhalten
	// Ist das beim Rollback auch so?
	if (nCommitBehavior == SQL_CB_PRESERVE)
		GetODBCInfo(SQL_CURSOR_ROLLBACK_BEHAVIOR,nCommitBehavior);

	// bestimmen der OdbcVersion als Major version
	String aOdbcVer;
	if (GetODBCInfo(SQL_ODBC_VER,aOdbcVer))
	{
		String aMajor = aOdbcVer.GetToken(0,'.');
		nODBCVer = aMajor.ToInt32();
		if (!nODBCVer)
			nODBCVer = String(aMajor.GetChar(1)).ToInt32();
	}

	// Werden die Cursor einer Connection alle nach einem Commit oder
	// Rollback geschlossen, dann folgt daraus: wenn Transaktionen, dann immer
	// eigene Connection!!!

	// kann kein AutoCommit durchgefuert werden, dann gilt die Datenquelle
	// dann als readonly, wenn Commit oder rollback immer alle Cursor einer
	// Connection schlieen, da hierdurch sehr viele Seiteneffekte auftreten knnen
	// die nicht zu kontrollieren sind
	ULONG nOption = 0;
	SetStatus(N3SQLGetConnectAttr(m_aConnectionHandle,
								   SQL_ATTR_AUTOCOMMIT, &nOption,0,0),m_aConnectionHandle);
	if (!aStatus.IsSuccessful())
	{
		// immer manual commit
		bAutoCommit = FALSE;
		// nach einem Commit werden alle Cursor weggeschmissen
		// das kann unser Treiber nun wirklich nicht
		if (nCommitBehavior != SQL_CB_PRESERVE)
			bReadOnly = TRUE;
	}
	else
		bAutoCommit = nOption == SQL_AUTOCOMMIT_ON;

	GetODBCInfo(SQL_CURSOR_COMMIT_BEHAVIOR,nCommitBehavior);

	BOOL bBindParameterAvailable = FALSE;
	bBindParameterAvailable = IsODBCFunctionAvailable(SQL_API_SQLBINDPARAMETER);
	// Fehler ignorieren, Ergebnis in diesem Fall FALSE
	aStatus.Clear();
	if (! bBindParameterAvailable)
		aStatus.SetDriverNotCapableError();

	// IdentifierQuotation
	String aIdentifierQuotation;
	GetODBCInfo(SQL_IDENTIFIER_QUOTE_CHAR,aIdentifierQuotation);
	aIdentifierQuotation.EraseLeadingChars(' ');
	cIdentifierQuotation = aIdentifierQuotation.GetChar(0);

	GetODBCInfo(SQL_SPECIAL_CHARACTERS,aSpecialCharStr);
	aSpecialCharStr.EraseLeadingChars(' ');

	// which attribs have the different cursor types
	GetODBCInfo(SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1,m_nForwardOnlyAttr1);
	GetODBCInfo(SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2,m_nForwardOnlyAttr2);

	GetODBCInfo(SQL_KEYSET_CURSOR_ATTRIBUTES1,m_nKeySetAttr1);
	GetODBCInfo(SQL_KEYSET_CURSOR_ATTRIBUTES2,m_nKeySetAttr2);

	GetODBCInfo(SQL_STATIC_CURSOR_ATTRIBUTES1,m_nStaticAttr1);
	GetODBCInfo(SQL_STATIC_CURSOR_ATTRIBUTES2,m_nStaticAttr2);
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::OpenImpl()
{
	if (m_aConnectionHandle == SQL_NULL_HANDLE)
		return FALSE;

	String aOptions = ConnectStr();

	// Verbindung aufbauen
	SQLRETURN nSQLRETURN = SdbODBC3Connection::OpenConnection(m_aConnectionHandle, aOptions,GetEnvironment()->GetLoginTimeOut(), bNoPrompt);
	if (nSQLRETURN == SQL_ERROR || nSQLRETURN == SQL_NO_DATA)
	{
		aStatus.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					aStatus.CreateErrorMessage(String(SdbResId(STR_STAT_INVALID_CONNECTION))),
					0, String() );
	}
	else if(SQL_SUCCESS_WITH_INFO == nSQLRETURN) // this driver does not support odbc3
	{
		SetStatus(nSQLRETURN,m_aConnectionHandle);
		String aMsg();
		if(aStatus.ErrorMessage().Search(String::CreateFromAscii("SQL_OV_ODBC")) != STRING_NOTFOUND || aStatus.ErrorMessage().Search(String::CreateFromAscii("SQL_OV_ODBC")) != STRING_NOTFOUND)
		{
			m_bIsValid = FALSE;
			return FALSE;
		}
		aStatus.Clear();
	}
	if (!aStatus.IsSuccessful())
		return FALSE;


	if(!SdbODBCConnection::OpenImpl())
		return FALSE;

	// name des User in der Datenbank, kann unterschiedlich zum login name sein
	GetODBCInfo(SQL_USER_NAME,aUserName);


// den aktuellen Datenbanknamen ermitteln

	char cCurrentQualifier[SQL_MAX_OPTION_STRING_LENGTH + 1] = "";
	INT32 nLen=0;
	if (N3SQLGetConnectAttr(m_aConnectionHandle,
							 SQL_ATTR_CURRENT_CATALOG,
							 cCurrentQualifier,SQL_MAX_OPTION_STRING_LENGTH,&nLen) == SQL_SUCCESS)
		aQualifierName.AssignAscii(cCurrentQualifier);
	else
		GetODBCInfo(SQL_DATABASE_NAME,aQualifierName);

	UINT16 nFileUsage = 0;
	GetODBCInfo(SQL_FILE_USAGE,nFileUsage);

	// sind ungueltige flags vom Treiber uebergeben worden?
	UINT32 nTempUsage = nFileUsage | SQL_FILE_TABLE | SQL_FILE_QUALIFIER;
	if (nTempUsage ^ (SQL_FILE_TABLE | SQL_FILE_QUALIFIER))
		nFileUsage = 0;

	// fuer einfache Filetreiber keinen Quailifier oder Owner
	if (!nFileUsage)
	{
		BOOL bHasInfo = TRUE;
		// treiber konnte keine auskunft geben
		if (!GetODBCInfo(SQL_SCHEMA_USAGE,nOwnerUsage) || !nOwnerUsage)
		{
			String aStr;
			GetODBCInfo(SQL_DBMS_NAME,aStr);
			if(aStr.Search(String::CreateFromAscii("Oracle")) != STRING_NOTFOUND) // XXX hack Oracle 7.3
				bHasInfo = FALSE;
		}
		else
		{
			// sind ungueltige flags vom Treiber uebergeben worden?
			UINT32 nTempUsage = nOwnerUsage | SQL_SU_DML_STATEMENTS | SQL_SU_PROCEDURE_INVOCATION |
						 SQL_SU_TABLE_DEFINITION | SQL_SU_INDEX_DEFINITION | SQL_SU_PRIVILEGE_DEFINITION;

			if (nTempUsage ^ (SQL_SU_DML_STATEMENTS |
							  SQL_SU_PROCEDURE_INVOCATION |
							  SQL_SU_TABLE_DEFINITION |
							  SQL_SU_INDEX_DEFINITION |
							  SQL_SU_PRIVILEGE_DEFINITION))
			{
				nOwnerUsage = 0;
				bHasInfo = FALSE;
			}
		}

		if (!bHasInfo)
		{
			// wenn keine Info verfuegbar, aber die Datenbank den Begriff
			// Qualifier kennt, dann werden eigene Annahmen getroffen
			String aOwnerTerm;
			GetODBCInfo(SQL_SCHEMA_TERM,aOwnerTerm);
			if (aOwnerTerm.Len())
				nOwnerUsage = SQL_SU_DML_STATEMENTS | SQL_SU_TABLE_DEFINITION;
		}

		bHasInfo = TRUE;
		if (!GetODBCInfo(SQL_CATALOG_USAGE,nQualifierUsage) || !nQualifierUsage)
		{
			String aStr;
			GetODBCInfo(SQL_DBMS_NAME,aStr);
			if(aStr.Search(String::CreateFromAscii("Oracle")) != STRING_NOTFOUND) // XXX hack Oracle 7.3
				bHasInfo = FALSE;
			nQualifierUsage = 0;
		}
		else
		{
			UINT32 nTempUsage = nQualifierUsage | SQL_CU_DML_STATEMENTS | SQL_QU_PROCEDURE_INVOCATION |
						 SQL_CU_TABLE_DEFINITION | SQL_QU_INDEX_DEFINITION | SQL_QU_PRIVILEGE_DEFINITION;

			if (nTempUsage ^ (SQL_SU_DML_STATEMENTS |
							  SQL_SU_PROCEDURE_INVOCATION |
							  SQL_SU_TABLE_DEFINITION |
							  SQL_SU_INDEX_DEFINITION |
							  SQL_SU_PRIVILEGE_DEFINITION))
			{
				bHasInfo = FALSE;
				nQualifierUsage = 0;
			}
		}

		if (!bHasInfo)
		{
			// wenn keine Info verfuegbar, aber die Datenbank den Begriff
			// Qualifier kennt, dann werden eigene Annahmen getroffen
			String aQualifierTerm;
			GetODBCInfo(SQL_QUALIFIER_TERM,aQualifierTerm);
			if (aQualifierTerm.Len())
				nQualifierUsage = SQL_CU_DML_STATEMENTS | SQL_CU_TABLE_DEFINITION;
		}
	}

	// Datenbankname noch nicht ermittelt
	if ((nQualifierUsage & SQL_CU_DML_STATEMENTS) == SQL_CU_DML_STATEMENTS)
	{
		String aQualifierSeparator;
		GetODBCInfo(SQL_CATALOG_NAME_SEPARATOR,aQualifierSeparator);
		aQualifierSeparator.EraseLeadingChars(' ');
		cQualifierSeparator = aQualifierSeparator.GetChar(0);
	}

	// dient nur dazu festzustellen ob die Datenbank Qualiefer und Owner auch wirklich verwendet
	bOpen = TRUE;
	SdbODBC3Cursor* pCursor = (SdbODBC3Cursor *) CreateCursor(SDB_SNAPSHOT,SDB_FORWARDONLY | SDB_READONLY);
	pCursor->AddRef();
	// Einen ganz speziellen Cursor oeffnen: anstelle von
	// Prepare und Execute wird Tables ausgefuehrt; die
	// Ergebnismenge enthaelt die gewuenschten Informationen

	pCursor->OpenTables(NULL,NULL,NULL,String::CreateFromAscii("TABLE").GetBuffer());
	/*      Reihenfolge
		1       TABLE_QUALIFIER
		2       TABLE_OWNER
		3       TABLE_NAME
	 */
	if(pCursor->IsInRange())
	{
		ODbRow& rRow = *pCursor->GetRow();
		ODbVariantRef pVal = NULL;
		if ((nQualifierUsage &  SQL_CU_DML_STATEMENTS) ==  SQL_CU_DML_STATEMENTS)
		{
			pVal = rRow[1];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nQualifierUsage = 0;
		}
		if ((nQualifierUsage &  SQL_SU_DML_STATEMENTS) ==  SQL_SU_DML_STATEMENTS)
		{
			pVal = rRow[2];
			if (pVal.is() && (pVal->isNull() || !pVal->getString().getLength()))
				nQualifierUsage = 0;
		}
	}
	pCursor->ReleaseRef();

	if(!nQualifierUsage)
		aQualifierName = String();
	// wieviel Stmts pro Connection
	GetODBCInfo(SQL_MAX_CONCURRENT_ACTIVITIES,nMaxStmts);
	aStatus.Clear();        //Ergebnis ignorieren
	return TRUE;
}

//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::CloseImpl()
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	DBG_ASSERT(IsOpen(),"SdbODBC3Connection: interner Fehler: Verbindung nicht geoeffnet");
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: ConnectionHandle ungueltig");

	SetStatus(N3SQLDisconnect(m_aConnectionHandle),m_aConnectionHandle);
	return aStatus.IsSuccessful();
}


//-----------------------------------------------------------------------------
void SdbODBC3Connection::SetAutoCommit(BOOL bAuto)
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);

	if (bAuto == bAutoCommit)
		return;

#ifndef MAC
	if (!bReadOnly)
		SetStatus(N3SQLSetConnectAttr(m_aConnectionHandle,
								   SQL_ATTR_AUTOCOMMIT,
								   (SQLPOINTER)((bAuto) ? SQL_AUTOCOMMIT_ON : SQL_AUTOCOMMIT_OFF) ,SQL_IS_INTEGER),
								   m_aConnectionHandle);
	if (aStatus.IsSuccessful())
		bAutoCommit = bAuto;

#else
	aStatus.Set( SDB_STAT_ERROR );
#endif
}

//-----------------------------------------------------------------------------
void SdbODBC3Connection::CommitImpl()
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: ConnectionHandle ungueltig");
	DBG_ASSERT(IsODBCFunctionAvailable(SQL_API_SQLTRANSACT), "Transactionen werden nicht unterstuetzt");

	SetStatus(N3SQLEndTran(SQL_HANDLE_DBC,m_aConnectionHandle,SQL_COMMIT),m_aConnectionHandle);
}

//-----------------------------------------------------------------------------
void SdbODBC3Connection::RollbackImpl()
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: ConnectionHandle ungueltig");
	DBG_ASSERT(IsODBCFunctionAvailable(SQL_API_SQLTRANSACT), "Transactionen werden nicht unterstuetzt");

	SetStatus(N3SQLEndTran(SQL_HANDLE_DBC,m_aConnectionHandle,SQL_ROLLBACK),m_aConnectionHandle);
}

//-----------------------------------------------------------------------------
SdbCursor* SdbODBC3Connection::CreateCursorImpl(SdbCursorType eType,
											   UINT16 nOptions)
{
	DBG_ASSERT(m_aEnvironmentHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: EnvironmentHandle ungueltig");
	DBG_ASSERT(m_aConnectionHandle != SQL_NULL_HANDLE,"SdbODBC3Connection: interner Fehler: ConnectionHandle ungueltig");

	SdbODBC3Cursor* pCursor = new SdbODBC3Cursor(this, eType, nOptions);
	if (!pCursor->ConnectionHandle() && pCursor->StmtHandle())
		nActiveStmts++;
	return pCursor;
}

//-----------------------------------------------------------------------------
String SdbODBC3Connection::ServerNames(SdbStatus& rStat, SdbEnvironment* pEnv)
{
	String aString,aPath;

	SQLHANDLE hEnv = EnvironmentHandle(pEnv,aPath);

	// Fehler beim Allozieren des Environment ignorieren
	if (hEnv == SQL_NULL_HANDLE)
	{
		String aText = String(SdbResId(STR_STAT_ODBC_NOT_FOUND));
		aText.SearchAndReplace(String::CreateFromAscii("#DLL#"),aPath);
		rStat.Set(SDB_STAT_ERROR,
					String::CreateFromAscii("01000"),
					rStat.CreateErrorMessage(aText),
					0, String() );

		return aString;
	}

	SDB_ODBC_CHAR szDSN[SQL_MAX_DSN_LENGTH+1];
	SWORD pcbDSN;
	SDB_ODBC_CHAR szDescription[1024+1];
	SWORD pcbDescription;
	SQLRETURN nSQLRETURN = SQL_SUCCESS;
	BOOL bFirst = TRUE;

	for (;;)
	{

		// Datenquellen-Name von ODBC abholen:
		nSQLRETURN = N3SQLDataSources(hEnv,
						   (bFirst) ? SQL_FETCH_FIRST : SQL_FETCH_NEXT,
						   szDSN, sizeof szDSN, &pcbDSN,
						   szDescription, sizeof szDescription, &pcbDescription);
		if (nSQLRETURN != SQL_SUCCESS)
				// Vorlaeufig keine weitere Fehlerbehandlung
			break;
		else
		{
			bFirst = FALSE;
			aString.AppendAscii((const char*)szDSN);

			// Description als Kommentar mit aufnehmen
			if (*szDescription)
			{
				aString.AppendAscii(" (");
				aString.AppendAscii((const char*)szDescription);
				aString += ')';
			}

			aString += SDB_SEPARATOR;
		}
	}

#if defined(LINUX)
	// manche haben einfach keine Implementierung, schade
	if (bFirst && nSQLRETURN == SQL_SUCCESS && szDSN[0] == 0)
	{
//		String aName = getenv("HOME");
		String aName; aName.AssignAscii( getenv("HOME") );
		DirEntry aOdbcIni(aName);
		aOdbcIni += DirEntry(String::CreateFromAscii(".odbc.ini"));
		SvFileStream aIniStr(aOdbcIni.GetFull(), STREAM_READ | STREAM_NOCREATE | STREAM_SHARE_DENYNONE);
		if (!aIniStr.IsOpen())
			return aString;

		// Implementierung noch Fehlerhaft

		/* String aSource; = ReadToken(aIniStr);
		if (aSource.Len())
		{
			aString += aSource;
			aString += SDB_SEPARATOR;
		}*/
	}
#endif //LINUX


	aString.EraseTrailingChars(SDB_SEPARATOR);
	return aString;
}
//-----------------------------------------------------------------------------
BOOL SdbODBC3Connection::IsCapableImpl(SdbCapability eCapability) const
{
	BOOL bResult;
	switch(eCapability)
	{
	// Von ODBC erfragbare Capabilities:
	// Updatebar, wenn
		case SDB_CAP_UPDATABLE:
			bResult = (bReadOnly) ? FALSE : SdbConnection::IsCapableImpl(eCapability);
			break;

		case SDB_CAP_READ_UNCOMMITTED:  bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_UNCOMMITTED); break;
		case SDB_CAP_READ_COMMITTED:    bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_READ_COMMITTED); break;
		case SDB_CAP_REPEATABLE_READ:   bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_REPEATABLE_READ); break;
		case SDB_CAP_SERIALIZABLE:      bResult = IsDriverCapable(SQL_TXN_ISOLATION_OPTION,SQL_TXN_SERIALIZABLE); break;

	// Sonstige Capabilities:

		case SDB_CAP_COMMIT_AUTO:
		case SDB_CAP_COMMIT_MANUAL:     bResult = !bReadOnly; break;

		case SDB_CAP_JOIN:
		case SDB_CAP_CREATE_TABLE:
		case SDB_CAP_RENAME_TABLE:
			bResult = TRUE;
			break;
		case SDB_CAP_ALTER_TABLE:
		case SDB_CAP_CREATE_INDEX:
			DBG_ERROR("Use Metadata instead of IsCapable()");
			bResult = TRUE;
			break;
		case SDB_CAP_PRIMARYKEYS:
			bResult = IsODBCFunctionAvailable(SQL_API_SQLPRIMARYKEYS); break;
		case SDB_CAP_FOREIGNKEYS:
			bResult = IsODBCFunctionAvailable(SQL_API_SQLFOREIGNKEYS); break;

		case SDB_CAP_BULKOPTIMIZE:      bResult = TRUE; break;
		case SDB_CAP_STATIC_PRIOR:		bResult = (SQL_FETCH_PRIOR	 & m_nStaticAttr1) > 0;	break;
		case SDB_CAP_KEYSET_PRIOR:		bResult = (SQL_FETCH_PRIOR	 & m_nKeySetAttr1) > 0;	break;
		default:
			bResult = SdbConnection::IsCapableImpl(eCapability);
	}
	return bResult;
}


//-----------------------------------------------------------------------------
void SdbODBC3Connection::SetIsolationLevelImpl(SdbIsolationLevel eNewIsolationLevel)
{
	DBG_CHKTHIS(SdbODBC3Connection,NULL);
	UDWORD nValue;
	switch (eNewIsolationLevel)
	{
		case SDB_ISO_READ_UNCOMMITTED:  nValue = SQL_TXN_READ_UNCOMMITTED; break;
		case SDB_ISO_READ_COMMITTED:    nValue = SQL_TXN_READ_COMMITTED; break;
		case SDB_ISO_REPEATABLE_READ:   nValue = SQL_TXN_REPEATABLE_READ; break;
		case SDB_ISO_SERIALIZABLE:              nValue = SQL_TXN_SERIALIZABLE; break;
		// case SDB_ISO_VERSIONING:                nValue = SQL_TXN_VERSIONING; break;
		// veraltet
		default:                                                aStatus.SetDriverNotCapableError();
										return;
	}

	SetStatus(N3SQLSetConnectAttr(m_aConnectionHandle,
								   SQL_ATTR_TXN_ISOLATION,
								   (SQLPOINTER)nValue,SQL_IS_INTEGER),
								   m_aConnectionHandle);
	if (! aStatus.IsSuccessful()) return;
	eIsolationLevel = eNewIsolationLevel;
}

//-----------------------------------------------------------------------------
SdbDatabaseType SdbODBC3Connection::MapType(INT16 nODBCType)
{
	switch(nODBCType)
	{
		case SQL_WCHAR:					m_bUserWChar = TRUE;
		case SQL_CHAR:                  return SDB_DBTYPE_CHAR;
		case SQL_WVARCHAR:				m_bUserWChar = TRUE;
		case SQL_VARCHAR:               return SDB_DBTYPE_VARCHAR;
		case SQL_WLONGVARCHAR:			m_bUserWChar = TRUE;
		case SQL_LONGVARCHAR:			return SDB_DBTYPE_LONGVARCHAR;
		case SQL_DECIMAL:               return SDB_DBTYPE_DECIMAL;
		case SQL_NUMERIC:               return SDB_DBTYPE_NUMERIC;
		case SQL_BIT:                   return SDB_DBTYPE_BOOLEAN;
		case SQL_TINYINT:               return SDB_DBTYPE_TINYINT;
		case SQL_SMALLINT:              return SDB_DBTYPE_SMALLINT;
		case SQL_INTEGER:               return SDB_DBTYPE_INTEGER;
		case SQL_BIGINT:                return SDB_DBTYPE_BIGINT;
		case SQL_REAL:                  return SDB_DBTYPE_REAL;
		case SQL_FLOAT:
		case SQL_DOUBLE:                return SDB_DBTYPE_DOUBLE;
		case SQL_BINARY:                return SDB_DBTYPE_BINARY;
		case SQL_VARBINARY:				return SDB_DBTYPE_VARBINARY;
		case SQL_LONGVARBINARY:			return SDB_DBTYPE_LONGVARBINARY;
		case SQL_DATE:					m_bUseOldTimeDate = TRUE;
		case SQL_TYPE_DATE:             return SDB_DBTYPE_DATE;
		case SQL_TIME:					m_bUseOldTimeDate = TRUE;
		case SQL_TYPE_TIME:				return SDB_DBTYPE_TIME;
		case SQL_TIMESTAMP:				m_bUseOldTimeDate = TRUE;
		case SQL_TYPE_TIMESTAMP:		return SDB_DBTYPE_TIMESTAMP;
		default:                        return SDB_DBTYPE_UNKNOWN;
	}
}



//-----------------------------------------------------------------------------
// bSilent wird dann verwendet, wenn eine Connection als Copy einer anderen
// verwendet wird
SQLRETURN SdbODBC3Connection::OpenConnection(HDBC hDBC, const String& aConnectStr,UINT32 nTimeOut, BOOL bSilent)
{
	if (hDBC == SQL_NULL_HANDLE)
		return -1;

	BOOL bReadOnly; //weil Methode statisch hier noch einmal ein lokales bReadOnly
	SQLRETURN nSQLRETURN = 0;
	SDB_ODBC_CHAR szConnStrOut[4096];
	SDB_ODBC_CHAR szConnStrIn[2048];
	SWORD cbConnStrOut;
	memset(szConnStrOut,'\0',4096);
	memset(szConnStrIn,'\0',2048);
	ByteString aConStr(aConnectStr,gsl_getSystemTextEncoding());
	memcpy(szConnStrIn, (SDB_ODBC_CHAR*) aConStr.GetBuffer(), Min((xub_StrLen)2048,aConStr.Len()));


#ifndef DEBUG
	N3SQLSetConnectAttr(hDBC,SQL_ATTR_TRACE,(SQLPOINTER)SQL_OPT_TRACE_OFF,SQL_IS_INTEGER);
#endif

	N3SQLSetConnectAttr(hDBC,SQL_ATTR_LOGIN_TIMEOUT,(SQLPOINTER)nTimeOut,SQL_IS_INTEGER);
	// Verbindung aufbauen

#ifdef LINUX

	nSQLRETURN = N3SQLDriverConnect(hDBC,
					  NULL,
					  szConnStrIn,
					  (SQLSMALLINT) Min((xub_StrLen)2048,aConStr.Len()),
					  szConnStrOut,
					  (SQLSMALLINT) sizeof szConnStrOut,
					  &cbConnStrOut,
					  SQL_DRIVER_NOPROMPT);
	if (nSQLRETURN == SQL_ERROR || nSQLRETURN == SQL_NO_DATA || SQL_SUCCESS_WITH_INFO == nSQLRETURN)
		return nSQLRETURN;
#else

	SQLUSMALLINT nSilent =  bSilent ? SQL_DRIVER_NOPROMPT : SQL_DRIVER_COMPLETE;
	nSQLRETURN = N3SQLDriverConnect(hDBC,
					  NULL,
					  szConnStrIn,
					  (SQLSMALLINT) Min((xub_StrLen)2048,aConStr.Len()),
					  szConnStrOut,
					  (SQLSMALLINT) sizeof szConnStrOut,
					  &cbConnStrOut,
					  nSilent);
	if (nSQLRETURN == SQL_ERROR || nSQLRETURN == SQL_NO_DATA)
		return nSQLRETURN;

#endif //LINUX

	SWORD nValueLen;
	nSQLRETURN = N3SQLGetInfo(hDBC,SQL_DATA_SOURCE_READ_ONLY,&bReadOnly,sizeof bReadOnly,&nValueLen);
	if (nSQLRETURN != SQL_SUCCESS) return nSQLRETURN;

// db2 wird etwa um Faktor 50 langsamer unter OS/2
#if defined(WIN) || defined(WNT)
//      N3SQLSetConnectOption(hDBC, SQL_ASYNC_ENABLE, SQL_ASYNC_ENABLE_ON);
#endif

#if SDB_ODBC2
/*      N3SQLSetConnectOption(hDBC,
						 SQL_ODBC_CURSORS,
						 SQL_CUR_USE_IF_NEEDED);*/
#endif

#ifndef MAC
	// autocoomit ist immer default

	if (!bReadOnly)
		N3SQLSetConnectAttr(hDBC,SQL_ATTR_AUTOCOMMIT,(SQLPOINTER)SQL_AUTOCOMMIT_ON,SQL_IS_INTEGER);
#endif
	return nSQLRETURN;
}
//-----------------------------------------------------------------------------
void SdbODBC3Connection::FreeEnv(SdbEnvironment* pEnv)
{
	N3SQLFreeHandle(SQL_HANDLE_ENV,pEnv->aODBC3EnvironmentHandle);
}
//-----------------------------------------------------------------------------
SdbTypeSearch SdbODBC3Connection::GetSearchType(int nType)
{
	SdbTypeSearch eType = Search_All;
	switch (nType)
	{
		case SQL_PRED_NONE:		eType = Search_None;			break;
		case SQL_PRED_CHAR:		eType = Search_Like_Only;		break;
		case SQL_PRED_BASIC:	eType = Search_Except_Like;		break;
	}
	return eType;
}
//-----------------------------------------------------------------------------
::stardata::XDatabaseDescriptor* SdbODBC3Connection::GetMetaDataImpl()
{
	SdbODBC3MetaData* pMetaData = new SdbODBC3MetaData(this);
	return pMetaData;
}

