/*************************************************************************
 *
 *  $RCSfile: odbc3imp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _SDB_ODBCINC_HXX
#include "odbc3inc.hxx"
#endif
#ifndef _OSL_MODULE_H_
#include <osl/module.h>
#endif
#ifndef _SDB_SDBENV_HXX
#include <sdbenv.hxx>
#endif

// Dynamisches Laden der DLL/shared lib und Adressen der Funktionen besorgen:
// Liefert TRUE bei Erfolg.
BOOL LoadLibrary_ODBC3(SdbEnvironment* pEnv,String &_rPath)
{
	static sal_Bool bLoaded = sal_False;
	static oslModule pso = NULL;

	if (bLoaded)
		return TRUE;
	

#ifdef WIN
	_rPath = String::CreateFromAscii("ODBC.DLL");
	
#endif
#ifdef WNT
	_rPath = String::CreateFromAscii("ODBC32.DLL");
#endif
#ifdef UNX
	_rPath = String::CreateFromAscii("libodbc.so");
#endif
#ifdef OS2
	_rPath = String::CreateFromAscii("ODBC");
#endif

	pso = osl_loadModule( ::rtl::OUString(_rPath.GetBuffer()).pData,SAL_LOADMODULE_NOW );
	if( !pso)
#ifdef OS2
	{
		delete pso;
		_rPath = String::CreateFromAscii("WOD402");
		pso = osl_loadModule( _rPath.pData,SAL_LOADMODULE_NOW );
		if( !pODBCso)
			return sal_False;
	}
#else
		return sal_False;
#endif

	if( ( pODBC3SQLAllocHandle	=	(T3SQLAllocHandle)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLAllocHandle").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLConnect		=	(T3SQLConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLConnect").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLDriverConnect =	(T3SQLDriverConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDriverConnect").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLBrowseConnect =   (T3SQLBrowseConnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBrowseConnect").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLDataSources	=   (T3SQLDataSources)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDataSources").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLDrivers		=   (T3SQLDrivers)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDrivers").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetInfo		=	(T3SQLGetInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetInfo").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetFunctions	=	(T3SQLGetFunctions)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetFunctions").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetTypeInfo	=	(T3SQLGetTypeInfo)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetTypeInfo").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetConnectAttr	=	(T3SQLSetConnectAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetConnectAttr").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetConnectAttr	=	(T3SQLGetConnectAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetConnectAttr").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetEnvAttr	=	(T3SQLSetEnvAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetEnvAttr").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetEnvAttr	=	(T3SQLGetEnvAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetEnvAttr").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetStmtAttr	=	(T3SQLSetStmtAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetStmtAttr").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetStmtAttr	=	(T3SQLGetStmtAttr)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetStmtAttr").pData )) == NULL )
		return FALSE;
	/*if( ( pODBC3SQLSetDescField	=	(T3SQLSetDescField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetDescField").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLGetDescField	=	(T3SQLGetDescField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDescField").pData )) == NULL )
		return FALSE;*/
	/*if( ( pODBC3SQLGetDescRec	=	(T3SQLGetDescRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDescRec").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetDescRec	=	(T3SQLSetDescRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetDescRec").pData )) == NULL )
		return FALSE;*/
	if( ( pODBC3SQLPrepare		=	(T3SQLPrepare)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrepare").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLBindParameter =	(T3SQLBindParameter)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindParameter").pData )) == NULL )
		return FALSE;
	/*if( ( pODBC3SQLGetCursorName =	(T3SQLGetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetCursorName").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetCursorName =	(T3SQLSetCursorName)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetCursorName").pData )) == NULL )
		return FALSE;*/
	if( ( pODBC3SQLExecute		=	(T3SQLExecute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecute").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLExecDirect	=	(T3SQLExecDirect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLExecDirect").pData )) == NULL )
		return FALSE;
	/*if( ( pODBC3SQLNativeSql		=	(T3SQLNativeSql)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNativeSql").pData )) == NULL )
		return FALSE;*/
	if( ( pODBC3SQLDescribeParam =   (T3SQLDescribeParam)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeParam").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLNumParams		=	(T3SQLNumParams)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumParams").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLParamData		=	(T3SQLParamData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLParamData").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLPutData		=	(T3SQLPutData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPutData").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLRowCount		=	(T3SQLRowCount)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLRowCount").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLNumResultCols =	(T3SQLNumResultCols)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLNumResultCols").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLDescribeCol	=	(T3SQLDescribeCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDescribeCol").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLColAttribute =	(T3SQLColAttribute)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColAttribute").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLBindCol		=	(T3SQLBindCol)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBindCol").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLFetch			=	(T3SQLFetch)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFetch").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLFetchScroll	=	(T3SQLFetchScroll)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFetchScroll").pData )) == NULL )
		return FALSE;					
	if( ( pODBC3SQLGetData		=	(T3SQLGetData)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetData").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSetPos		=	(T3SQLSetPos)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSetPos").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLBulkOperations	=	(T3SQLBulkOperations)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLBulkOperations").pData )) == NULL )
		return FALSE;
	/*if( ( pODBC3SQLMoreResults	=	(T3SQLMoreResults)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLMoreResults").pData )) == NULL )
		return FALSE;*/
	/*if( ( pODBC3SQLGetDiagField	=	(T3SQLGetDiagField)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDiagField").pData )) == NULL )
		return FALSE;*/
	if( ( pODBC3SQLGetDiagRec	=	(T3SQLGetDiagRec)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLGetDiagRec").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLColumnPrivileges = (T3SQLColumnPrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumnPrivileges").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLColumns		=	(T3SQLColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLColumns").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLForeignKeys	=	(T3SQLForeignKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLForeignKeys").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLPrimaryKeys	=	(T3SQLPrimaryKeys)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLPrimaryKeys").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLProcedureColumns =  (T3SQLProcedureColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedureColumns").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLProcedures	=	(T3SQLProcedures)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLProcedures").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLSpecialColumns =  (T3SQLSpecialColumns)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLSpecialColumns").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLStatistics	=   (T3SQLStatistics)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLStatistics").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLTablePrivileges =	(T3SQLTablePrivileges)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTablePrivileges").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLTables		=   (T3SQLTables)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLTables").pData )) == NULL )
		return FALSE;					
	if( ( pODBC3SQLFreeStmt		=	(T3SQLFreeStmt)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeStmt").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLCloseCursor	=	(T3SQLCloseCursor)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLCloseCursor").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLCancel		=	(T3SQLCancel)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLCancel").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLEndTran		=	(T3SQLEndTran)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLEndTran").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLDisconnect	=	(T3SQLDisconnect)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLDisconnect").pData )) == NULL )
		return FALSE;
	if( ( pODBC3SQLFreeHandle	=	(T3SQLFreeHandle)osl_getSymbol(pso, ::rtl::OUString::createFromAscii("SQLFreeHandle").pData )) == NULL )
		return FALSE;

	bLoaded = TRUE;
	pEnv->AppendLibrary(pso);
	return TRUE;
}

T3SQLAllocHandle pODBC3SQLAllocHandle;
T3SQLConnect pODBC3SQLConnect;
T3SQLDriverConnect pODBC3SQLDriverConnect;
T3SQLBrowseConnect pODBC3SQLBrowseConnect;
T3SQLDataSources pODBC3SQLDataSources;
T3SQLDrivers pODBC3SQLDrivers; 
T3SQLGetInfo pODBC3SQLGetInfo;
T3SQLGetFunctions pODBC3SQLGetFunctions;
T3SQLGetTypeInfo pODBC3SQLGetTypeInfo;
T3SQLSetConnectAttr pODBC3SQLSetConnectAttr;
T3SQLGetConnectAttr pODBC3SQLGetConnectAttr;
T3SQLSetEnvAttr pODBC3SQLSetEnvAttr;
T3SQLGetEnvAttr pODBC3SQLGetEnvAttr;
T3SQLSetStmtAttr pODBC3SQLSetStmtAttr;
T3SQLGetStmtAttr pODBC3SQLGetStmtAttr;
//T3SQLSetDescField pODBC3SQLSetDescField;
//T3SQLGetDescField pODBC3SQLGetDescField;
//T3SQLGetDescRec pODBC3SQLGetDescRec;
//T3SQLSetDescRec pODBC3SQLSetDescRec;
T3SQLPrepare pODBC3SQLPrepare;
T3SQLBindParameter pODBC3SQLBindParameter;
//T3SQLGetCursorName pODBC3SQLGetCursorName;
//T3SQLSetCursorName pODBC3SQLSetCursorName;
T3SQLExecute pODBC3SQLExecute;
T3SQLExecDirect pODBC3SQLExecDirect;
//T3SQLNativeSql pODBC3SQLNativeSql;
T3SQLDescribeParam pODBC3SQLDescribeParam;
T3SQLNumParams pODBC3SQLNumParams;
T3SQLParamData pODBC3SQLParamData;
T3SQLPutData pODBC3SQLPutData;
T3SQLRowCount pODBC3SQLRowCount;
T3SQLNumResultCols pODBC3SQLNumResultCols;
T3SQLDescribeCol pODBC3SQLDescribeCol;
T3SQLColAttribute pODBC3SQLColAttribute;
T3SQLBindCol pODBC3SQLBindCol;
T3SQLFetch pODBC3SQLFetch;
T3SQLFetchScroll pODBC3SQLFetchScroll;
T3SQLGetData pODBC3SQLGetData;
T3SQLSetPos pODBC3SQLSetPos;
T3SQLBulkOperations pODBC3SQLBulkOperations;
//T3SQLMoreResults pODBC3SQLMoreResults;
//T3SQLGetDiagField pODBC3SQLGetDiagField;
T3SQLGetDiagRec pODBC3SQLGetDiagRec;
T3SQLColumnPrivileges pODBC3SQLColumnPrivileges;
T3SQLColumns pODBC3SQLColumns;
T3SQLForeignKeys pODBC3SQLForeignKeys;
T3SQLPrimaryKeys pODBC3SQLPrimaryKeys;
T3SQLProcedureColumns pODBC3SQLProcedureColumns;
T3SQLProcedures pODBC3SQLProcedures;
T3SQLSpecialColumns pODBC3SQLSpecialColumns;						
T3SQLStatistics pODBC3SQLStatistics;
T3SQLTablePrivileges pODBC3SQLTablePrivileges;
T3SQLTables pODBC3SQLTables;
T3SQLFreeStmt pODBC3SQLFreeStmt;
T3SQLCloseCursor pODBC3SQLCloseCursor;
T3SQLCancel pODBC3SQLCancel;
T3SQLEndTran pODBC3SQLEndTran;
T3SQLDisconnect pODBC3SQLDisconnect;
T3SQLFreeHandle pODBC3SQLFreeHandle;
