/*************************************************************************
 *
 *  $RCSfile: odbc3md.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SDB_ODBCCONN_HXX
#include <odbc3inc.hxx>
#include <odbc3conn.hxx>
#endif

#ifdef SQL_KEYWORDS
#define SQL_KEYWORDS1     89
#undef SQL_KEYWORDS
#endif

#ifdef IN
#undef IN
#endif

#include <odbc3md.hxx>

#ifndef _COM_SUN_STAR_DATA_DATABASEVIEWDEFINITION_HPP_
#include <com/sun/star/data/DatabaseViewDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASETABLEDEFINITION_HPP_
#include <com/sun/star/data/DatabaseTableDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEINDEXDEFINITION_HPP_
#include <com/sun/star/data/DatabaseIndexDefinition.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESUBQUERY_HPP_
#include <com/sun/star/data/DatabaseSubquery.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQL92_HPP_
#include <com/sun/star/data/DatabaseSQL92.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASESQLCONFORMANCE_HPP_
#include <com/sun/star/data/DatabaseSQLConformance.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEOUTERJOINSUPPORT_HPP_
#include <com/sun/star/data/DatabaseOuterJoinSupport.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASEIDENTIFIERCASE_HPP_
#include <com/sun/star/data/DatabaseIdentifierCase.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENULLSSORT_HPP_
#include <com/sun/star/data/DatabaseNullsSort.hpp>
#endif
#ifndef _COM_SUN_STAR_DATA_DATABASENKEYRULE_HPP_
#include <com/sun/star/data/DatabaseKeyRule.hpp>
#endif

namespace stardata = com::sun::star::data;
namespace staruno = com::sun::star::uno;

//------------------------------------------------------------------
sal_Bool SdbODBC3MetaData::isCapableImpl(sal_Int16 nCapability) const
{
	sal_Bool erg(sal_False);
	switch (nCapability)
	{
		case ::stardata::DatabaseCapability::COLUMN_ALIAS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_COLUMN_ALIAS,aStr);
				erg = aStr.GetChar(0) == 'Y';
			}
			break;
		case ::stardata::DatabaseCapability::TABLE_CORRELATION_NAME:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_CORRELATION_NAME,n) && n != SQL_CN_NONE;
			}
			break;
		case ::stardata::DatabaseCapability::CONVERT:
			erg = sal_True;
			break;
		case ::stardata::DatabaseCapability::EXPRESSION_ORDERBY:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_EXPRESSIONS_IN_ORDERBY,aStr);
				erg = aStr.GetChar(0) == 'Y';
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_GROUP_BY,n) && n != SQL_GB_NOT_SUPPORTED;
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY_BEYONDSELECT:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_GROUP_BY,n) && n != SQL_GB_GROUP_BY_CONTAINS_SELECT;
			}
			break;
		case ::stardata::DatabaseCapability::GROUPBY_UNRELATED:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_GROUP_BY,n) && n == SQL_GB_NO_RELATION;
			}
			break;
		case ::stardata::DatabaseCapability::NON_NULLABLE_COLUMNS:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_NON_NULLABLE_COLUMNS,n) && (n == SQL_NNC_NON_NULL);
			}
			break;
		case ::stardata::DatabaseCapability::INTEGRITY:
			{
				String aStr;
				sal_Bool bResult1(((SdbODBC3Connection*)pCon)->IsODBCFunctionAvailable(SQL_API_SQLPRIMARYKEYS));
				sal_Bool bResult2(((SdbODBC3Connection*)pCon)->IsODBCFunctionAvailable(SQL_API_SQLFOREIGNKEYS));
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_INTEGRITY,aStr);
				erg = (bResult1 && bResult2) || aStr.GetChar(0) == 'Y';
			}
			break;
		case ::stardata::DatabaseCapability::ORDERBY_UNRELATED:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_ORDER_BY_COLUMNS_IN_SELECT,aStr);
				 // Bedeutung bei jdbc genau umgekehrt
				erg = aStr.GetChar(0) == 'N';
			}
			break;
		case ::stardata::DatabaseCapability::UNION:
			erg = ((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_UNION,SQL_U_UNION);
			break;
		case ::stardata::DatabaseCapability::UNION_ALL:
			erg = ((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_UNION,SQL_U_UNION_ALL);
			break;
		case ::stardata::DatabaseCapability::TRANSACTIONS:
			{
				UWORD n;
				erg = ((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_TXN_CAPABLE,n) && n != SQL_TC_NONE;
			}
			break;
	}
	return erg;
}
//------------------------------------------------------------------
::staruno::Any SdbODBC3MetaData::getInfoImpl(sal_Int16 nInfo) const
{
	::staruno::Any erg;
	switch(nInfo)
	{
		case ::stardata::DatabaseInfo::CATALOG_AT_START:
		{
			UWORD n;
			erg <<= (sal_Bool)(((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_CATALOG_LOCATION,n) && n == SQL_CL_START);
		}	break;
		case ::stardata::DatabaseInfo::READ_ONLY:
		{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DATA_SOURCE_READ_ONLY,aStr);
				erg <<= (sal_Bool)(aStr.GetChar(0) == 'Y');
		}	break;
		case ::stardata::DatabaseInfo::NULLPLUSNONNULLISNULL:
		{
			UWORD n;
			erg <<= (sal_Bool)(((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_CONCAT_NULL_BEHAVIOR,n) && n == SQL_CB_NULL);
		}	break;
		case ::stardata::DatabaseInfo::TABLE_DEFINITION:
		{
			sal_Int16 nResults(::stardata::DatabaseTableDefinition::DROP | ::stardata::DatabaseTableDefinition::CREATE);
			if (((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_ALTER_TABLE,SQL_AT_DROP_COLUMN))
				nResults |= ::stardata::DatabaseTableDefinition::ALTER_DROP_COLUMN;
			if (((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_ALTER_TABLE,SQL_AT_ADD_COLUMN))
				nResults |= ::stardata::DatabaseTableDefinition::ALTER_ADD_COLUMN;
			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::VIEW_DEFINITION:
		{
			sal_Int16 nResults(0);
			if (((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_CREATE_VIEW, SQL_CV_CREATE_VIEW))
				nResults |= ::stardata::DatabaseViewDefinition::DROP | ::stardata::DatabaseViewDefinition::CREATE;

			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::INDEX_DEFINITION:
		{
			sal_Int16 nResults(0);
			if (((SdbODBC3Connection *)this)->IsODBCFunctionAvailable(SQL_API_SQLSTATISTICS))
				nResults |= ::stardata::DatabaseIndexDefinition::DROP | ::stardata::DatabaseIndexDefinition::CREATE;
			erg <<= (sal_Int16)nResults;
		}	break;
		case ::stardata::DatabaseInfo::IDENT_CASE:
			{
				UWORD nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_IDENTIFIER_CASE,nUS);

				if(nUS == SQL_IC_UPPER)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::UPPER;
				else if(nUS == SQL_IC_LOWER)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::LOWER;
				else if(nUS == SQL_IC_MIXED)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
				else if(nUS == SQL_IC_SENSITIVE)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::SENSITIVE;
				else
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			}
			break;
		case ::stardata::DatabaseInfo::IDENT_CASE_QUOTED:
			{
				UWORD nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_QUOTED_IDENTIFIER_CASE,nUS);

				if(nUS == SQL_IC_UPPER)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::UPPER;
				else if(nUS == SQL_IC_LOWER)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::LOWER;
				else if(nUS == SQL_IC_MIXED)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
				else if(nUS == SQL_IC_SENSITIVE)
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::SENSITIVE;
				else
					erg <<= (sal_Int16)::stardata::DatabaseIdentifierCase::MIXED;
			}
			break;
		case ::stardata::DatabaseInfo::NULLS_SORT:
			{
				UWORD nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_NULL_COLLATION,nUS);

				if(nUS & SQL_NC_END)
					erg <<= (sal_Int16)::stardata::DatabaseNullsSort::AT_END;
				else if(nUS & SQL_NC_START)
					erg <<= (sal_Int16)::stardata::DatabaseNullsSort::AT_START;
				else if(nUS & SQL_NC_HIGH)
					erg <<= (sal_Int16)::stardata::DatabaseNullsSort::HIGH;
				else if(nUS & SQL_NC_LOW)
					erg <<= (sal_Int16)::stardata::DatabaseNullsSort::LOW;
			}
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_UPDATE_RULE:
			if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,SQL_SFKU_CASCADE))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::CASCADE;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,SQL_SFKU_NO_ACTION))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::NO_ACTION;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,SQL_SFKU_SET_DEFAULT))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::SET_DEFAULT;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,SQL_SFKU_SET_NULL))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::SET_NULL;
			break;
		case ::stardata::DatabaseInfo::FOREIGN_KEY_DELETE_RULE:
			if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_DELETE_RULE,SQL_SFKD_CASCADE))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::CASCADE;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_DELETE_RULE,SQL_SFKD_NO_ACTION))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::NO_ACTION;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_DELETE_RULE,SQL_SFKD_SET_DEFAULT))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::SET_DEFAULT;
			else if(((SdbODBC3Connection*)pCon)->IsDriverCapable(SQL_SQL92_FOREIGN_KEY_DELETE_RULE,SQL_SFKD_SET_NULL))
				erg <<= (sal_Int16)::stardata::DatabaseKeyRule::SET_NULL;
			break;
		case ::stardata::DatabaseInfo::SCHEMA_USAGE:
			{
				sal_Int16 nUsage(0);
				sal_uInt16 nFileUsage(0);
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_FILE_USAGE,nFileUsage);
				if(!nFileUsage)
					nUsage = ((SdbODBC3Connection*)pCon)->GetOwnerUsage();
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_USAGE:
			{
				sal_Int16 nUsage(0);
				sal_uInt16 nFileUsage(0);
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_FILE_USAGE,nFileUsage);
				if(!nFileUsage)
					nUsage = ((SdbODBC3Connection*)pCon)->GetQualifierUsage();
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::SUBQUERIES:
			{
				sal_Int16 nUsage(0);
				sal_uInt32 nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SUBQUERIES,nUS);
				if(nUS & SQL_SQ_CORRELATED_SUBQUERIES)
					nUsage = ::stardata::DatabaseSubquery::CORRELATED;
				if(nUS & SQL_SQ_COMPARISON)
					nUsage |= ::stardata::DatabaseSubquery::COMPARSION;
				if(nUS & SQL_SQ_EXISTS)
					nUsage |= ::stardata::DatabaseSubquery::EXISTS;
				if(nUS & SQL_SQ_IN)
					nUsage |= ::stardata::DatabaseSubquery::IN;
				if(nUS & SQL_SQ_QUANTIFIED)
					nUsage |= ::stardata::DatabaseSubquery::QUANTIFIED;
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::SUPPORTED_ISOLATION_LEVELS:
			{
				sal_Int16 nUsage(0);
				sal_uInt32 nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_TXN_ISOLATION_OPTION,nUS);

				if(nUS & SQL_TXN_READ_COMMITTED)
					nUsage |= ::stardata::DatabaseIsolationLevel::READ_COMMIT;
				else if(nUS & SQL_TXN_READ_UNCOMMITTED)
					nUsage |= ::stardata::DatabaseIsolationLevel::READ_UNCOMMIT;
				else if(nUS & SQL_TXN_REPEATABLE_READ)
					nUsage |= ::stardata::DatabaseIsolationLevel::REPEAT_READ;
				else if(nUS & SQL_TXN_SERIALIZABLE)
					nUsage |= ::stardata::DatabaseIsolationLevel::SERIALIZABLE;
				else
					nUsage = ::stardata::DatabaseIsolationLevel::NONE;
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::ANSI_SQL_92:
			{
				sal_Int16 nUsage(0);
				sal_uInt32 nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SQL_CONFORMANCE,nUS);
				if(!(nUS & SQL_SC_SQL92_FULL))
				{
					if(!(nUS & SQL_SC_SQL92_INTERMEDIATE))
					{
						if(!(nUS & SQL_SC_SQL92_ENTRY))
							nUsage = ::stardata::DatabaseSQL92::ENTRY_LEVEL;
					}
					else
						nUsage |= ::stardata::DatabaseSQL92::INTERMEDIATE | ::stardata::DatabaseSQL92::ENTRY_LEVEL;
				}else
					nUsage |= ::stardata::DatabaseSQL92::FULL | ::stardata::DatabaseSQL92::ENTRY_LEVEL | ::stardata::DatabaseSQL92::INTERMEDIATE;
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::DSN_URL:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DATA_SOURCE_NAME,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::DRIVER_NAME:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DRIVER_NAME,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::DRIVER_VERSION:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DRIVER_ODBC_VER,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::DBMS_VERSION:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DRIVER_VER,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::DBMS_NAME:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_DBMS_NAME,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::PROC_TERM:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_PROCEDURE_TERM,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_TERM:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_CATALOG_TERM,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SCHEMA_TERM:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SCHEMA_TERM,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::TABLE_TERM:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_TABLE_TERM,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::IDENTIFIER_QUOTE_CHAR:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_IDENTIFIER_QUOTE_CHAR,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SQL_KEYWORDS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_KEYWORDS1,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::CATALOG_SEPARATOR:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_CATALOG_NAME_SEPARATOR,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SEARCH_PATTERN_ESCAPE:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SEARCH_PATTERN_ESCAPE,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SPECIAL_CHARACTERS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SPECIAL_CHARACTERS,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::STRING_FUNCTIONS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_STRING_FUNCTIONS,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SYSTEM_FUNCTIONS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_SYSTEM_FUNCTIONS,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::NUMERIC_FUNCTIONS:
			{
				String aStr;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_NUMERIC_FUNCTIONS,aStr);
				erg <<= rtl::OUString(aStr);
			}
			break;
		case ::stardata::DatabaseInfo::SQL_CONFORMANCE:
			{
				sal_Int16 nUsage(0);
				UWORD nUS;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_ODBC_SQL_CONFORMANCE,nUS);
				if(!(nUS & SQL_OSC_EXTENDED)){
					if(!(nUS & SQL_OSC_CORE))
					{
						if(!(nUS & SQL_OSC_MINIMUM))
							nUsage = ::stardata::DatabaseSQLConformance::MINIMUM;
					}
					else
						nUsage |= ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
				}else
					nUsage |= ::stardata::DatabaseSQLConformance::EXTENDED | ::stardata::DatabaseSQLConformance::CORE | ::stardata::DatabaseSQLConformance::MINIMUM;
				erg <<= (sal_Int16)nUsage;
			}
			break;
		case ::stardata::DatabaseInfo::OUTER_JOIN_SUPPORT:
			{
				sal_Int16 nUsage(0);

				sal_uInt32 nOJ;
				((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_OJ_CAPABILITIES,nOJ);
				if(nOJ & SQL_OJ_FULL)
					nUsage |= ::stardata::DatabaseOuterJoinSupport::FULL;
				if(nOJ & SQL_OJ_NESTED)
					nUsage |= ::stardata::DatabaseOuterJoinSupport::PARTIAL;
				if(nOJ & (SQL_OJ_LEFT|SQL_OJ_RIGHT|SQL_OJ_INNER))
					nUsage |= ::stardata::DatabaseOuterJoinSupport::YES;

				erg <<= (sal_Int16)nUsage;
			}
			break;
		default:
			;

	}
	return erg;
}
//------------------------------------------------------------------
sal_Int32 SdbODBC3MetaData::getLimitImpl(sal_Int16 nLimit) const
{
	sal_uInt32 erg(0);
	switch(nLimit)
	{
		case ::stardata::DatabaseLimit::BINARAY_LITERAL_LEN:
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_BINARY_LITERAL_LEN,erg);
			break;
		case ::stardata::DatabaseLimit::CHAR_LITERAL_LEN:
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_CHAR_LITERAL_LEN,erg);
			break;
		case ::stardata::DatabaseLimit::COLUMN_NAME_LEN:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMN_NAME_LEN,nTmp);
			erg = nTmp;
			}break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_GROUPBY:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMNS_IN_GROUP_BY,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_INDEX:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMNS_IN_INDEX,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_ORDERBY:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMNS_IN_ORDER_BY,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_SELECT:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMNS_IN_SELECT,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::COLUMNS_IN_TABLE:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_COLUMNS_IN_TABLE,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::INDEX_SIZE:
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_INDEX_SIZE,erg);
			break;
		case ::stardata::DatabaseLimit::CATALOG_NAME_LEN:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_CATALOG_NAME_LEN,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::SCHEMA_NAME_LEN:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_SCHEMA_NAME_LEN,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::STATEMENT_LEN:
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_STATEMENT_LEN,erg);
			break;
		case ::stardata::DatabaseLimit::TABLE_NAME_LEN:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_TABLE_NAME_LEN,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::TABLES_IN_SELECT:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_TABLES_IN_SELECT,nTmp);
			erg = nTmp;
			}
			break;
		case ::stardata::DatabaseLimit::USER_NAME_LEN:
			{sal_uInt16 nTmp=0;
			((SdbODBC3Connection*)pCon)->GetODBCInfo(SQL_MAX_USER_NAME_LEN,nTmp);
			erg = nTmp;
			}
			break;
		default:
			erg <<= (sal_Int16)0;
	}
	return erg;
}

//------------------------------------------------------------------
static sal_Int32 convertFrom(sal_Int16 nIn)
{
	sal_Int32 nOut;
	switch(nIn)
	{
		case ::stardata::DatabaseFieldType::VARCHAR:
			nOut = SQL_CONVERT_VARCHAR;
			break;
		case ::stardata::DatabaseFieldType::CHAR:
			nOut = SQL_CONVERT_CHAR;
			break;
		case ::stardata::DatabaseFieldType::BOOL:
			nOut = SQL_CONVERT_BIT;
			break;
		case ::stardata::DatabaseFieldType::TINYINT:
			nOut = SQL_CONVERT_TINYINT;
			break;
		case ::stardata::DatabaseFieldType::SMALLINT:
			nOut = SQL_CONVERT_SMALLINT;
			break;
		case ::stardata::DatabaseFieldType::INTEGER:
			nOut = SQL_CONVERT_INTEGER;
			break;
		case ::stardata::DatabaseFieldType::BIGINT:
			nOut = SQL_CONVERT_BIGINT;
			break;
		case ::stardata::DatabaseFieldType::REAL:
			nOut = SQL_CONVERT_FLOAT;
			break;
		case ::stardata::DatabaseFieldType::DOUBLE:
			nOut = SQL_CONVERT_DOUBLE;
			break;
		case ::stardata::DatabaseFieldType::DECIMAL:
			nOut = SQL_CONVERT_DECIMAL;
			break;
		case ::stardata::DatabaseFieldType::NUMERIC:
		case ::stardata::DatabaseFieldType::CURRENCY:
			nOut = SQL_CONVERT_NUMERIC;
			break;
		case ::stardata::DatabaseFieldType::DATETIME:
			nOut = SQL_CONVERT_TIMESTAMP;
			break;
		case ::stardata::DatabaseFieldType::DATE:
			nOut = SQL_CONVERT_DATE;
			break;
		case ::stardata::DatabaseFieldType::TIME:
			nOut = SQL_CONVERT_TIME;
			break;
		case ::stardata::DatabaseFieldType::LONGVARCHAR:
			nOut = SQL_CONVERT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::OTHER:
		case ::stardata::DatabaseFieldType::LONGVARBINARY:
			nOut = SQL_CONVERT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::VARBINARY:
			nOut = SQL_CONVERT_VARBINARY;
			break;
		case ::stardata::DatabaseFieldType::BINARY:
			nOut = SQL_CONVERT_BINARY;
			break;
	}
	return nOut;
}
//------------------------------------------------------------------
static sal_Int32 convertTo(sal_Int16 nIn)
{
	sal_Int32 nOut;
	switch (nIn)
	{
		case ::stardata::DatabaseFieldType::VARCHAR:
			nOut = SQL_CVT_VARCHAR;
			break;
		case ::stardata::DatabaseFieldType::CHAR:
			nOut = SQL_CVT_CHAR;
			break;
		case ::stardata::DatabaseFieldType::BOOL:
			nOut = SQL_CVT_BIT;
			break;
		case ::stardata::DatabaseFieldType::TINYINT:
			nOut = SQL_CVT_TINYINT;
			break;
		case ::stardata::DatabaseFieldType::SMALLINT:
			nOut = SQL_CVT_SMALLINT;
			break;
		case ::stardata::DatabaseFieldType::INTEGER:
			nOut = SQL_CVT_INTEGER;
			break;
		case ::stardata::DatabaseFieldType::BIGINT:
			nOut = SQL_CVT_BIGINT;
			break;
		case ::stardata::DatabaseFieldType::REAL:
			nOut = SQL_CVT_FLOAT;
			break;
		case ::stardata::DatabaseFieldType::DOUBLE:
			nOut = SQL_CVT_DOUBLE;
			break;
		case ::stardata::DatabaseFieldType::DECIMAL:
			nOut = SQL_CVT_DECIMAL;
			break;
		case ::stardata::DatabaseFieldType::NUMERIC:
		case ::stardata::DatabaseFieldType::CURRENCY:
			nOut = SQL_CVT_NUMERIC;
			break;
		case ::stardata::DatabaseFieldType::DATETIME:
			nOut = SQL_CVT_TIMESTAMP;
			break;
		case ::stardata::DatabaseFieldType::DATE:
			nOut = SQL_CVT_DATE;
			break;
		case ::stardata::DatabaseFieldType::TIME:
			nOut = SQL_CVT_TIME;
			break;
		case ::stardata::DatabaseFieldType::LONGVARCHAR:
			nOut = SQL_CVT_LONGVARCHAR;
			break;
		case ::stardata::DatabaseFieldType::OTHER:
		case ::stardata::DatabaseFieldType::LONGVARBINARY:
			nOut = SQL_CVT_LONGVARBINARY;
			break;
		case ::stardata::DatabaseFieldType::VARBINARY:
			nOut = SQL_CVT_VARBINARY;
			break;
		case ::stardata::DatabaseFieldType::BINARY:
			nOut = SQL_CVT_BINARY;
			break;
	}
	return nOut;
}

//------------------------------------------------------------------
sal_Bool SdbODBC3MetaData::canConvertImpl(sal_Int16 nFrom, sal_Int16 nTo) const
{
	sal_uInt32 erg;
	((SdbODBC3Connection*)pCon)->GetODBCInfo(convertFrom(nFrom),erg);
	return erg==convertTo(nTo);
}


