/*************************************************************************
 *
 *  $RCSfile: tcharset.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "test.hxx"

#ifdef WNT
__cdecl
#endif
main()
{
	cout << "ServerTypes:\n";
	enum SdbServerType eServerType;
	String aName;
	String aDescription;
	BOOL bFirst;

	for (bFirst = TRUE; SdbConnection::GetServerType(eServerType, bFirst); bFirst = FALSE) {
		cout << "Type " << (int)eServerType << "\n";
	}
	cout << "\n";

	for (UINT16 k = 0; k < SdbConnection::ServerCount(); k++) {
		SdbConnection::GetServerTypeByIndex(eServerType,k);
		cout << "Type " << (int)eServerType << "\n";
	}
	cout << "\n";

	cout << "ServerNames: ";
	if (! SdbConnection::IsServerNameAvailable(SDB_SERVER_SBA)) cout << "(not available)";
	if (SdbConnection::IsServerNamePath(SDB_SERVER_SBA)) cout << "(pathname)";
	for (bFirst = TRUE; SdbConnection::GetServerName(SDB_SERVER_SBA,aName, aDescription, bFirst); bFirst = FALSE) {
		cout << "Name: " << (const char *)aName << ", Description: " << (const char *)aDescription << "\n";
	}
	cout << "\n";

	SdbConnection * conn1 = SdbConnection::CreateConnection(SDB_SERVER_SBA,String("sample"),String("admin"),String("school"),String());
//	SdbConnection * conn1 = SdbConnection::CreateConnection(SDB_SERVER_ODBC,String("sample"),String("admin"),String("school"),String());
//	SdbConnection * conn1 = SdbConnection::CreateConnection(SDB_SERVER_SBA,String("stardiv"),String("starsell"),String("sql"),String());
	if (conn1 == NULL) return 1;

	show_status("conn1 CreateConnection",conn1->Status());

	conn1->Connect();
	show_status("conn1 Connect",conn1->Status());

	show_cursors("conn1",conn1);

	String aSchemaName;
/***
	for (bFirst = TRUE; conn1->GetSchemaName(aSchemaName, bFirst); bFirst = FALSE) {
		cout << "Schema " << (const char *)aSchemaName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetSchemaName",conn1->Status());

	conn1->MakeSchema("rdm");
//	conn1->DropSchema("rdm");
	show_status("conn1 Make/DropSchema",conn1->Status());

	for (bFirst = TRUE; conn1->GetSchemaName(aSchemaName, bFirst); bFirst = FALSE) {
		cout << "Schema " << (const char *)aSchemaName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetSchemaName",conn1->Status());


conn1->Delete();
return 0;
 ***/

	for (bFirst = TRUE; conn1->GetSchemaName(aSchemaName, bFirst); bFirst = FALSE) {
		cout << "Schema " << (const char *)aSchemaName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetSchemaName",conn1->Status());

	String aTableName;
	for (bFirst = TRUE; conn1->GetTableName(aTableName, bFirst); bFirst = FALSE) {
		cout << "Table " << (const char *)aTableName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetTableName",conn1->Status());

	for (bFirst = TRUE; conn1->GetTableName(aTableName, bFirst, SDB_TABTYP_VIEW); bFirst = FALSE) {
		cout << "View " << (const char *)aTableName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetTableName",conn1->Status());

	for (bFirst = TRUE; conn1->GetTableName(aTableName, bFirst, SDB_TABTYP_TABLE, "rdm"); bFirst = FALSE) {
		cout << "Table in Schema rdm " << (const char *)aTableName << "\n";
	}
	cout << "\n";
	show_status("conn1 GetTableName",conn1->Status());

//	SdbCursor * curs1 = conn1->CreateCursor("SELECT * FROM STUDENT");
	SdbCursor * curs1 = conn1->CreateCursor("SELECT * FROM X");
//	SdbCursor * curs1 = conn1->CreateCursor("SELECT * FROM ORT");
//	SdbCursor * curs1 = conn1->CreateCursor("SELECT * FROM RDM.SBASYSTAB1");
//	SdbCursor * curs1 = conn1->CreateCursor();
	show_status("conn1 CreateCursor",conn1->Status());
	if (curs1) show_status("curs1 CreateCursor",curs1->Status());

	show_cursors("conn1",conn1);
	//if (! conn1->Status().IsSuccessful()) return 0;

//	show_columns("curs1",curs1->ResultColumns());
	if (curs1->IsPrepared()) show_columns("curs1",curs1->ResultColumns());
//	show_columns("curs1",curs1->ResultColumns());


	curs1->Execute();
	show_status("curs1 Execute",curs1->Status());

	show_cursors("conn1",conn1);

//	fetch_rows("conn1/curs1",curs1,5);
	fetch_rows("conn1/curs1",curs1);

	curs1->Close();

	curs1->Execute();
	show_status("curs1 Execute (again)",curs1->Status());

//	conn1->SetCharacterSet(CHARSET_IBMPC_850);
//	fetch_rows("conn1/curs1",curs1);


	SdbCursor * curs2 = conn1->CreateCursor();
//	SdbCursor * curs2 = conn1->CreateCursor("SELECT COUNT(*) FROM BES");
	show_status("curs2 CreateCursor",curs2->Status());

	curs2->SetName("Hallo");
	curs2->Execute("SELECT COUNT(*) FROM REGISTER");
	show_status("curs2 Execute",curs2->Status());

	fetch_rows("conn1/curs2",curs2);
	show_cursors("conn1",conn1);

	curs1->Close();
	show_status("curs1 Close",curs1->Status());

	show_cursors("conn1",conn1);

	curs2->Close();
	show_status("curs2 Close",curs2->Status());

	show_cursors("conn1",conn1);

/***
	curs1->Prepare();
	show_status("curs1 Close",curs1->Status());

	show_cursors("conn1",conn1);

	show_columns("curs1 (SELECT * FROM STUDENT)",curs1->ResultColumns());

	curs1->Close();
	show_status("curs1 Close",curs1->Status());

	show_cursors("conn1",conn1);
 ***/

	conn1->Disconnect();
	show_status("conn1 Disconnect",conn1->Status());

	conn1->Delete();

/***
	conn1->Connect();
	show_status("conn1 Connect",conn1->Status());

	// delete (gekapselt durch Methode Delete):
	conn1->Delete();
#ifdef MIGHT_CRASH
	show_status("conn1 Release",conn1->Status());
#endif
 ***/

/***
	const char * ibm850 = "rger bel sterreich ";
	cout << ibm850 << "\n";
	cout << (const char *)String(ibm850).Convert(CHARSET_IBMPC_850);
 ***/

	return 0;
}
