/*************************************************************************
 *
 *  $RCSfile: tcmd.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <tools.hxx>
#include <iostream.h>

#include "cmdparse.hxx"

void show_command(const CommandParser & rCommandParser)
{
		UINT32 i;

		if (rCommandParser.IsInvalid()) {
			cout << "InvalidOptions: " << (const char *) rCommandParser.InvalidOptions() << "\n";
		}

		for (i = 0; i < rCommandParser.ParameterCount(); i++) {
			cout << "Parameter[" << i << "]: "
				 << (const char *) rCommandParser.ParameterString(i)
				 << "/"
				 << (int)rCommandParser.ParameterBool(i)
				 << "/"
				 << rCommandParser.ParameterInt(i)
				 << "/"
				 << rCommandParser.ParameterUInt(i)
				 << "\n";
		}
		for (i = 0; i < rCommandParser.OptionCount(); i++) {
			cout << "Option[" << i << "] ("
				 << (const char *) rCommandParser.OptionName(i) << ") "
				 << (const char *) rCommandParser.OptionString(i)
				 << "/"
				 << (int)rCommandParser.OptionBool(i)
				 << "/"
				 << rCommandParser.OptionInt(i)
				 << "/"
				 << rCommandParser.OptionUInt(i)
				 << "\n";
		}

		cout << "\n";

		// Wieder zusammensetzen:
		cout << "Compose: ";
		String aString;
		rCommandParser.Compose(aString,String("/a/c"));
		cout << (const char *)aString << "\n";
}

int
#ifdef WNT
__cdecl
#endif
main()
{
	while (1) {
		char aCmdLine[1000];

		cout << "Command: ";
		cin.getline(aCmdLine,sizeof aCmdLine);

		CommandParser aCommandParser(aCmdLine,'/',':');
		show_command(aCommandParser);

		if (aCommandParser.ParameterString(0).Upper() == "TEST") {
			aCommandParser.Parse("A B C /HELLO /World:47");
			show_command(aCommandParser);
		} else if (aCommandParser.ParameterString(0).Upper() == "COPY") {
			CommandParser aCommandParser2(aCommandParser);
			show_command(aCommandParser2);
			cout << "aCommandParser == aCommandParser2: " << (int) (aCommandParser == aCommandParser2) << "\n";
			aCommandParser2.Parse("A B C /HELLO /World:47");
			show_command(aCommandParser2);
			cout << "aCommandParser == aCommandParser2: " << (int) (aCommandParser == aCommandParser2) << "\n";
		} else if (aCommandParser.ParameterCount() == 1 &&
			aCommandParser.ParameterString(0).Upper() == "EXIT") {

			if (aCommandParser.OptionUInt("RETURN")) {
				UINT32 i = aCommandParser.OptionUInt("RETURN");
				cout << "Option: /RETURN:" << i << "\n";
				return i;
			}
			if (aCommandParser.OptionBool("abort"))
				cout << "Option: /ABORT\n";
			else
				break;
		}
	}

	return 0;
}
