/*************************************************************************
 *
 *  $RCSfile: tconn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "tutil.hxx"


#ifdef WNT
__cdecl
#endif
main()
{
	DBG_INIT();

	cout << "ServerTypes:\n";
	enum SdbServerType eServerType;
	String aName;
	String aDescription;
	BOOL bFirst;

	SdbEnvironment * pEnv = SdbEnvironment::GetAddress();
	DBG_ASSERT(pEnv != NULL,"pEnv");

/***/
	for (bFirst = TRUE; pEnv->GetServerType(eServerType, bFirst); bFirst = FALSE) {
		cout << "Type " << (int)eServerType << "\n";
	}
	cout << "\n";

	for (UINT16 k = 0; k < pEnv->ServerCount(); k++) {
		pEnv->GetServerTypeByIndex(eServerType,k);
		cout << "Type " << (int)eServerType << "\n";
	}
	cout << "\n";

	cout << "ServerNames: ";
	if (! pEnv->IsServerNameAvailable(SDB_SERVER_ODBC)) cout << "(not available)";
	if (pEnv->IsServerNamePath(SDB_SERVER_ODBC)) cout << "(pathname)";
	for (bFirst = TRUE; pEnv->GetServerName(SDB_SERVER_ODBC,aName, aDescription, bFirst); bFirst = FALSE) {
		cout << "Name: " << (const char *)aName << ", Description: " << (const char *)aDescription << "\n";
	}
	cout << "\n";
/***/

	SdbConnection * conn1 = pEnv->CreateConnection(SDB_SERVER_ODBC,String("sample"),String("admin"),String("school"),String());

//	SdbConnection * conn1 = pEnv->CreateConnection("TYP=ODBC;DRIVER={Watcom SQL 4.0};DBF=d:\\prog\\wsql40\\sample.db;UID=admin;PWD=school");
//  geht nicht (koennen nur ODBC2-Treiber)

//	SdbConnection * conn1 = pEnv->CreateConnection("TYP=ODBC;DSN=sample;DBF=d:\\prog\\wsql40\\sample.db;UID=admin;PWD=school");

	DBG_ASSERT(conn1 != NULL,"conn1 == NULL (wahrscheinlich unbekannter Server-Typ)");
	show_status("conn1 CreateConnection",conn1->Status());

	conn1->Connect();
	show_status("conn1 Connect",conn1->Status());

	cout << "SchemaNames: ";
	for (bFirst = TRUE; conn1->GetSchemaName(aName, bFirst); bFirst = FALSE) {
		cout << "Name: " << (const char *)aName << "\n";
	}
	cout << "\n";

	show_cursors("conn1",conn1);

	SdbCursor * curs1 = conn1->CreateCursor("SELECT * FROM STUDENT");
	show_status("conn1 CreateCursor",conn1->Status());
	if (curs1 == NULL || conn1->Status().IsError()) return 0;
	if (curs1) show_status("curs1 CreateCursor",curs1->Status());
	if (curs1->Status().IsError()) return 0;

	show_cursors("conn1",conn1);

	show_columns("curs1 (SELECT * FROM STUDENT)",curs1->ResultColumns());


	curs1->Execute();
	show_status("curs1 Execute",curs1->Status());

	show_cursors("conn1",conn1);

	fetch_rows("conn1/curs1",curs1,1);

	SdbCursor * curs2 = conn1->CreateCursor("SELECT COUNT(*) FROM REGISTER");
	show_status("curs2 CreateCursor",curs2->Status());
	cout << "Native SQL: " << (const char *) curs2->NativeSQLStatement();

	curs2->Execute();
	show_status("curs2 Execute",curs2->Status());

	fetch_rows("conn1/curs2",curs2);

	curs1->Close();
	show_status("curs1 Close",curs1->Status());


	curs1->Execute();
	show_status("curs1 Execute",curs1->Status());

	fetch_rows("conn1/curs1",curs1,1);

////	show_cursors("conn1",conn1);

////	curs2->Close();
////	show_status("curs2 Close",curs2->Status());

	show_cursors("conn1",conn1);

/***
	curs1->Prepare();
	show_status("curs1 Close",curs1->Status());

	show_cursors("conn1",conn1);

	show_columns("curs1 (SELECT * FROM STUDENT)",curs1->ResultColumns());

	curs1->Close();
	show_status("curs1 Close",curs1->Status());

	show_cursors("conn1",conn1);
 ***/

	curs1->Close();

	conn1->Disconnect();
	show_status("conn1 Disconnect",conn1->Status());

/***
	conn1->Connect();
	show_status("conn1 Connect",conn1->Status());

	// delete (gekapselt durch Methode Delete):
	conn1->Delete();
#ifdef MIGHT_CRASH
	show_status("conn1 Release",conn1->Status());
#endif
 ***/

	return 0;
}
