/*************************************************************************
 *
 *  $RCSfile: tcurs.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "tutil.hxx"

#ifdef WNT
__cdecl
#endif
main()
{
	DBG_INIT();

	SdbConnection * conn1 = do_connect();
	if (conn1 == NULL) return 1;

#define SHOW_TABLES
#ifdef SHOW_TABLES
	cout << "TableNames: ";
	String aName;
	for (BOOL bFirst = TRUE; conn1->GetTableName(aName, bFirst); bFirst = FALSE) {
		cout << "Name: " << (const char *)aName << "\n";
	}
	cout << "\n";

	cout << "Default Schema: " << (const char *) conn1->DefaultSchemaName() << "\n";
	cout << "Default Table:  " << (const char *) conn1->DefaultTableName() << "\n";
#endif

	SdbCursor * curs1 = conn1->CreateCursor();
	if (! conn1->Status().IsSuccessful()) show_status("conn1 CreateCursor",conn1->Status());
	if (! curs1->Status().IsSuccessful()) show_status("curs1 CreateCursor",curs1->Status());
	if (curs1 == NULL) return 1;

	while (1) {
		char s[2000];
		cout << "Statement: ";
		cin.getline(s,sizeof s);

		if (String(s) == "exit") break;

/***
		char n[100];
		cout << "Native (1/0): ";
		cin.getline(n,sizeof n);
		String aNativeFlag(n);

		curs1->Prepare(s,(int)aNativeFlag);
 ***/
		curs1->Prepare(s);

		if (! curs1->Status().IsSuccessful()) {
			show_status("curs1 Prepare",curs1->Status());
		}

		if (curs1->Status().IsSuccessful()) {
			cout << "Native SQL: " << (const char *) curs1->NativeSQLStatement();

			show_columns("curs1 - Result Columns",curs1->ResultColumns());
			show_columns("curs1 - Parameter Columns",curs1->ParameterColumns());

			const SdbColumns * pParameterColumns = curs1->ParameterColumns();
			SdbRow * pParameterRow = curs1->EmptyParameterRow();
			curs1->BindParameterRow(pParameterRow);

			// Test: ggf. mehrfach ausfuehren ...
			const int nLoopCount = 1;
			for (int j = 0; j < nLoopCount; j++) {
				for (UINT16 i = 1; i < pParameterColumns->Count(); i++) {

					cout << "Parameter #" << i << " [" << (const char *)pParameterColumns->Column(i)->Name() << "]: ";
					cin.getline(s,sizeof s);

					if (*s) {
						if (*s == '$') {
							SbxMemoryStreamRef pMemoryStream = new SbxMemoryStream();
							*pMemoryStream << (long) 0 << String(s+1) << (short) 4711 << "das war's ...";

							pParameterRow->Variable(i)->PutObject(pMemoryStream);
						} else {
							pParameterRow->Variable(i)->PutString(s);
						}
					} else{
						pParameterRow->Variable(i)->PutNull();
					}
					show_variable("Variable",pParameterRow->Variable(i));
				}

				curs1->Execute();
				if (! curs1->Status().IsSuccessful()) show_status("curs1 Execute",curs1->Status());

				if (curs1->ResultColumns()->Count() > 1) {
					fetch_rows("curs1 Result",curs1);
				} else {
					cout << (const char *) "Number of rows affected: " << curs1->RowCount() << "\n";
				}
			}

			curs1->Close();
			if (! curs1->Status().IsSuccessful()) show_status("curs1 Close",curs1->Status());
		}
	}

	conn1->Disconnect();
	if (! conn1->Status().IsSuccessful()) show_status("conn1 Disconnect",conn1->Status());

	return 0;
}
