/*************************************************************************
 *
 *  $RCSfile: todbc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <prewin.h>
#include <sqlext.h>
#include <postwin.h>
#include <tools.hxx>

#include <iostream.h>
#include <string.h>



typedef
RETCODE (SQL_API *TSQLAllocEnv) (
	HENV   FAR *phenv);

#define XSQLAllocEnv(phenv) (*((TSQLAllocEnv)p))(phenv)

typedef
RETCODE (SQL_API *TSQLAllocConnect) (
	HENV        henv,
	HDBC   FAR *phdbc);

typedef
RETCODE (SQL_API *TSQLFreeEnv) (
	HENV        henv);

typedef
RETCODE (SQL_API *TSQLFreeConnect) (
	HDBC        hdbc);

typedef
RETCODE (SQL_API *TSQLConnect) (
	HDBC        hdbc,
	UCHAR  FAR *szDSN,
	SWORD       cbDSN,
	UCHAR  FAR *szUID,
	SWORD       cbUID,
	UCHAR  FAR *szAuthStr,
	SWORD       cbAuthStr);

typedef
RETCODE (SQL_API *TSQLDisconnect) (
	HDBC        hdbc);


int
#ifdef WNT
__cdecl
#endif
main()
{
	char s[100];
	cout << "Library name: ";
	cin >> s;


	HINSTANCE hLib;

	hLib = LoadLibrary(s);
	cout << hLib << "\n";

#ifdef WNT
	if (hLib == NULL) return 1;
#endif
#ifdef WIN
	if (hLib <= HINSTANCE_ERROR) return 1;
#endif


	while (1) {
		cout << "Function name: ";
		cin >> s;

		if (*s == '.') break;

		FARPROC p = GetProcAddress(hLib,s);
		cout << "p == " << p << "\n";
		if (s == NULL) continue;

		RETCODE r;
		HENV henv;
		HDBC hdbc;
		if (strcmp(s,"SQLAllocEnv") == 0) {
			r = XSQLAllocEnv(&henv);

			cout << "r == " << r << "\n";
			cout << "henv == " << henv << "\n";
		}
		else if (strcmp(s,"SQLFreeEnv") == 0) {
			r = (*((TSQLFreeEnv)p))(henv);
			cout << "r == " << r << "\n";
		}
		else if (strcmp(s,"SQLAllocConnect") == 0) {
			r = (*((TSQLAllocConnect)p))(henv,&hdbc);

			cout << "r == " << r << "\n";
			cout << "hdbc == " << hdbc << "\n";
		}
		else if (strcmp(s,"SQLFreeConnect") == 0) {
			r = (*((TSQLFreeConnect)p))(hdbc);
			cout << "r == " << r << "\n";
		}
		else if (strcmp(s,"SQLConnect") == 0) {
#ifdef WIN
			r = (*((TSQLConnect)p))(hdbc,
									(UCHAR *)"sample",strlen("sample"),
									(UCHAR *)"admin",strlen("admin"),
									(UCHAR *)"school",strlen("school"));
#endif
#ifdef WNT
			r = (*((TSQLConnect)p))(hdbc,
									(UCHAR *)"db3",strlen("db3"),
									(UCHAR *)"",strlen(""),
									(UCHAR *)"",strlen(""));
#endif

			cout << "r == " << r << "\n";
			cout << "hdbc == " << hdbc << "\n";
		}
		else if (strcmp(s,"SQLDisconnect") == 0) {
			r = (*((TSQLDisconnect)p))(hdbc);
			cout << "r == " << r << "\n";
		}

	}


#ifdef WNT
	if (! FreeLibrary(hLib)) {
		cout << "FreeLibrary failed.\n";
	}
#endif
#ifdef WIN
	FreeLibrary(hLib);
#endif

	return 0;
}
