/*************************************************************************
 *
 *  $RCSfile: trowc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "tutil.hxx"


#ifdef WNT
__cdecl
#endif
main()
{
	DBG_INIT();

/***
	DirEntry aCurrentDir;
	aCurrentDir.ToAbs();
	cout << "Current: " << (const char *) (aCurrentDir.GetFull()) << "\n";
	Dir * pDir = NULL;
	String aWildcard("*.obj");
	// Liste aller Dateien (entsprechend der Wildcard) bilden:
	pDir = new Dir(aWildcard, FSYS_KIND_FILE, FSYS_SORT_NAME, FSYS_SORT_END);
	cout << "pDir->Count(): " << pDir->Count() << "\n";
	for (int nDirPos = 0; nDirPos < pDir->Count(); nDirPos++) {
		cout << (const char *) ((*pDir)[nDirPos].GetBase()) << "\n";
	}
 ***/

	char opt[512];
	cout << "Options: "; cin.getline(opt,sizeof opt);

	SdbEnvironment * pEnv = SdbEnvironment::GetAddress();
	DBG_ASSERT(pEnv != NULL,"Kein SdbEnvironment");

	SdbConnection * conn1 = pEnv->CreateConnection(opt);
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 CreateConnection",conn1->Status());
		return 1;
	}

	conn1->Connect();
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 Connect",conn1->Status());
		return 1;
	}

	cout << "Connected.\n\n";

/***
	char sch[100];
	cout << "Schema: "; cin.getline(sch,sizeof sch);
	conn1->SetSchema(sch);
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 SetSchema",conn1->Status());
		return 1;
	}
***/

	cout << "\n";

	cout << "Cache Size: ";
	char cachesize[1024];
	cin.getline(cachesize,sizeof cachesize);

	cout << "Table: ";
	char table[1024];
	cin.getline(table,sizeof table);
	cout << "SQL Statement: ";
	char stmt[1024];
	cin.getline(stmt,sizeof stmt);
	//cout << "'" << (const char *) String(stmt) << "'";

	SdbRowCache * rc1 = conn1->CreateRowCache(String(cachesize));
	rc1->Execute(table,stmt);

	if (! rc1->Status().IsSuccessful()) {
		show_status("rc1->Execute",rc1->Status());
		return 1;
	}

	show_columns("rc1->ReadCursor()->ResultColumns()",rc1->ReadCursor()->ResultColumns());
	show_columns("rc1->Columns()",rc1->Columns());

	show_rowcache("initial rc1",rc1);

	for (BOOL bGetCommand = TRUE; bGetCommand;) {
		cout << "Command [+ - = < > (a)ppend (e)dit (u)pdate (c)ancel (d)elete set(v)ariable show(r)ow e(x)it]: ";
		char cmd[1025];
		cin >> cmd;
		char c = cmd[0];
		UINT32 nNumRows;
		UINT32 nReqRows;


		switch(c) {
			case '+':
					cout << "# of rows:  ";
					cin >> cmd;
					nNumRows = String(cmd);
					if (nNumRows == 0) nNumRows = 1;

					cout << "cache rows: ";
					cin >> cmd;
					nReqRows = String(cmd);
					if (nReqRows == 0) nReqRows = 1;


					cout << "next: " << rc1->SeekNext(nNumRows,nReqRows) << "\n";
					show_rowcache("rc1",rc1);
					break;
			case '-':
					cout << "# of rows:  ";
					cin >> cmd;
					nNumRows = String(cmd);
					if (nNumRows == 0) nNumRows = 1;

					cout << "cache rows: ";
					cin >> cmd;
					nReqRows = String(cmd);
					if (nReqRows == 0) nReqRows = 1;


					cout << "prior: " << rc1->SeekPrior(nNumRows,nReqRows) << "\n";
					show_rowcache("rc1",rc1);
					break;
			case '=':
					cout << "rows #:  ";
					cin >> cmd;
					nNumRows = String(cmd);
					if (nNumRows == 0) nNumRows = 1;

					cout << "cache rows: ";
					cin >> cmd;
					nReqRows = String(cmd);
					if (nReqRows == 0) nReqRows = 1;


					rc1->SeekAbsolute(nNumRows /* eigentlich Row Number! */,nReqRows);
					show_rowcache("rc1",rc1);
					break;
			case '<':
					cout << "cache rows: ";
					cin >> cmd;
					nReqRows = String(cmd);
					if (nReqRows == 0) nReqRows = 1;


					rc1->SeekFirst(nReqRows);
					show_rowcache("rc1",rc1);
					break;
			case '>':
					rc1->SeekLast();
					show_rowcache("rc1",rc1);
					break;
			case 'a':		// append
					cout << "AppendRow\n";
					rc1->AppendRow();
					if (! rc1->Status().IsSuccessful()) show_status("rc1->AppendRow",rc1->Status());
					break;
			case 'e':		// edit
					cout << "EditRow\n";
					rc1->EditRow();
					if (! rc1->Status().IsSuccessful()) show_status("rc1->EditRow",rc1->Status());
					break;
			case 'u':		// update
					cout << "UpdateRow\n";
					rc1->UpdateRow();
					if (! rc1->Status().IsSuccessful()) show_status("rc1->UpdateRow",rc1->Status());
					break;
			case 'c':		// cancel
					cout << "CancelRow\n";
					rc1->CancelRow();
					if (! rc1->Status().IsSuccessful()) show_status("rc1->CancelRow",rc1->Status());
					break;
			case 'd':		// delete
					cout << "DeleteRow\n";
					rc1->DeleteRow();
					if (! rc1->Status().IsSuccessful()) show_status("rc1->DeleteRow",rc1->Status());
					break;
			case 'v':		// set new variable value
					{
						cout << "Set new variable value:\n";
						SdbRow * pCurrentRow = rc1->CurrentRow();
						if (pCurrentRow == NULL) {
							cout << "No current row.\n";
							break;
						}
						char s[1000];
						cout << "Variable: ";
						cin >> s;
						String aName(s);
						SbxVariable * pVar = pCurrentRow->Variable(aName);
						if (pVar == NULL) {
							cout << "No variable called '" << (const char *)aName << "'.\n";
							break;
						}
						cout << "Value: ";
						cin >> s;
						pVar->PutString(String(s));
					}
					// gleich weiter und anzeigen ...
			case 'r':
					if (rc1->CurrentRow() == NULL) {
						cout << "No current row.\n";
						break;
					}
					show_row("rc1->CurrentRow",rc1->CurrentRow());
					break;
			case 'x':
					cout << "exit\n";
					bGetCommand = FALSE;
					break;
			default:
					cout << "???\n";
					break;
		}

	}
	rc1->Delete();

	conn1->Close();
	conn1->Delete();

	return 0;
}
