/*************************************************************************
 *
 *  $RCSfile: tstat.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <iostream.h>

#include "sdb.hxx"

class Test : public LinkHdl {
	SdbStatus aStatus;

  public:
	inline void Doit1() { aStatus.Init(); aStatus.Set(SDB_SUCCESS); }
	inline void Doit1a() { aStatus.Init(); aStatus.Set(SDB_SUCCESS, String("forget it"), String("Doit1a"), 31); }

	inline void Doit2() { aStatus.Init(); aStatus.Set(SDB_SUCCESS_WITH_INFO); }
	inline void Doit2a() { aStatus.Init(); aStatus.Set(SDB_SUCCESS_WITH_INFO, String("warning ..."), String("Doit2a"), 32); }

	inline void Doit3() { aStatus.Init(); aStatus.Set(SDB_NO_DATA_FOUND); }
	inline void Doit3a() { aStatus.Init(); aStatus.Set(SDB_NO_DATA_FOUND, String("forget it 2"), String("Doit3a"), 33); }

	inline void Doit4() { aStatus.Init(); aStatus.Set(SDB_ERROR); }
	inline void Doit4a() { aStatus.Init(); aStatus.Set(SDB_ERROR, String("the error"), String("Doit4a"), 34); }

	inline void Doit5() { aStatus.Init(); }

	inline void Doit6() { aStatus.Init(); aStatus.Set(SDB_STILL_EXECUTING); }
	inline void Doit6a() { aStatus.Init(); aStatus.Set(SDB_STILL_EXECUTING, String("forget it 3"), String("Doit5a"), 35); }

	inline const SdbStatus & Status() const { return aStatus; }


	inline void SetCallback() { aStatus.SetStatusChangeHdl( LINK(this, Test, MyCallback) ); }

	void MyCallback(const SdbStatus * pStatus);
};

void show_status(const SdbStatus & rStatus)
{
		cout << "Result: " << (int)rStatus.Result() << "\n";
		cout << "SQLState: " << (const char *)rStatus.SQLState() << "\n";
		cout << "ErrorMessage: " << (const char *)rStatus.ErrorMessage() << "\n";
		cout << "NativeErrorCode: " << rStatus.NativeErrorCode() << "\n";
		cout << "\n";
}

void Test::MyCallback(const SdbStatus * pStatus)
{
	cout << "Status changed:\n";
	show_status(* pStatus);
}

int main() {
	Test t;

// Setzen und Abfragen des Status:

// Sonderfall: Setzen von STILL_EXECUTING (-> Assertion)
//	for (int i=0; i<11; i++) {

	for (int i=0; i<9; i++) {

		switch(i) {
		  case 0: cout << "Doit1:\n"; t.Doit1(); break;
		  case 1: cout << "Doit1a:\n"; t.Doit1a(); break;
		  case 2: cout << "Doit2:\n"; t.Doit2(); break;
		  case 3: cout << "Doit2a:\n"; t.Doit2a(); break;
		  case 4: cout << "Doit3:\n"; t.Doit3(); break;
		  case 5: cout << "Doit3a:\n"; t.Doit3a(); break;
		  case 6: cout << "Doit4:\n"; t.Doit4(); break;
		  case 7: cout << "Doit4a:\n"; t.Doit4a(); break;
		  case 8: cout << "Doit5:\n"; t.Doit5(); break;
		  case 9: cout << "Doit6:\n"; t.Doit6a(); break;
		  case 10: cout << "Doit6a:\n"; t.Doit6a(); break;
		}

		show_status(t.Status());
	}


	cout << "--------------------------------------------------------------------\n";
	// Callback-Registrierung (Links) und Benachrichtigung:
	t.SetCallback();

	t.Doit2a();
	t.Doit3a();


	cout << "--------------------------------------------------------------------\n";
	// Kopieren von Status-Objekten
	SdbStatus s2(t.Status());

	t.Doit2a;

	SdbStatus s3;
	s3 = t.Status();

	t.Doit4a;

	cout << "Status von t:\n";
	show_status(t.Status());

	cout << "\ns2:\n";
	show_status(s2);

	cout << "\ns3:\n";
	show_status(s3);

	return 0;
}
