/*************************************************************************
 *
 *  $RCSfile: ttab.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "tutil.hxx"

#ifdef WNT
__cdecl
#endif
main()
{
	DBG_INIT();

	char opt[512];
	cout << "Options: "; cin.getline(opt,sizeof opt);

	SdbEnvironment * pEnv = SdbEnvironment::GetAddress();
	DBG_ASSERT(pEnv != NULL,"Kein SdbEnvironment");

	SdbConnection * conn1 = pEnv->CreateConnection(opt);
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 CreateConnection",conn1->Status());
		return 1;
	}

	conn1->Connect();
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 Connect",conn1->Status());
		return 1;
	}

	cout << "Connected.\n\n";

	char sch[100];
	cout << "Schema: "; cin.getline(sch,sizeof sch);
	conn1->SetSchema(sch);
	if (! conn1->Status().IsSuccessful()) {
		show_status("conn1 SetSchema",conn1->Status());
		return 1;
	}

	cout << "\n";



	SdbTable * tab1 = conn1->CreateTable();
	show_status("conn1 CreateTable",conn1->Status());

	if (! tab1) return 1;

	char aTableName[200];
	char aMode[100];
	while (TRUE) {
again:
		cout << "Mode: (O)pen/(N)ew/e(X)it: ";
		cin >> aMode;

		if (*aMode == 'o' || *aMode == 'O') {
			cout << "TableName: ";
			cin >> aTableName;
		}
		if (*aMode == 'o' || *aMode == 'O') {
			tab1->Open(aTableName);
			show_status("tab1 Open",tab1->Status());
		} else if (*aMode == 'n' || *aMode == 'N') {
			tab1->OpenNew();
			show_status("tab1 OpenNew",tab1->Status());
		} else if (*aMode == 'x' || *aMode == 'X') {
			break;
		} else goto again;

		cout << "isopen: " << (int) tab1->IsOpen() << "\n";
		if (tab1->Status().IsSuccessful()) {

			cout << "Primary Key Name: " << (const char *) tab1->PrimaryKeyName() << "\n";


		char aCmd[100];
keepopen:
			while (TRUE) {
				show_columns("tab1->OriginalColumns",tab1->OriginalColumns());
				show_columns("tab1->Colunmns",tab1->Columns());

				// Aenderungen:
				cout << "(A)dd/(M)odify/(D)elete/(R)ename/(C)lose/(F)orget: ";
				cin >> aCmd;
				char aName[100];
				if (*aCmd == 'c' || *aCmd == 'C' || *aCmd == 'f' || *aCmd == 'F') {
					break;
				}
				cout << "Column Name: ";
				cin >> aName;

				char aNewName[100];

				SdbColumn * pNewColumn;
				int eType, nPrecision, nScale;
				BOOL bPrimaryKey = FALSE, bNullAllowed = FALSE;

				if (*aCmd == 'A' || *aCmd == 'a' || *aCmd == 'M' || *aCmd == 'm') {
					cout << "DatabaseType: ";
					cin >> eType;
					cout << "Length/Precision: ";
					cin >> nPrecision;
					cout << "Scale: ";
					cin >> nScale;

					cout << "Flags: (P)rimary key, (N)ull allowed, (-)none: ";
					char s[20];
					cin >> s;
					for (char * p = s; *p; p++) {
						switch(*p) {
							case 'p':
							case 'P': bPrimaryKey = TRUE;
									  break;
							case 'n':
							case 'N': bNullAllowed = TRUE;
									  break;
						}
					}
				}

				switch (*aCmd) {
					case 'A':
					case 'a':
								pNewColumn = new SdbColumn(aName,(enum SdbDatabaseType)eType,nPrecision,nScale);
								if (bPrimaryKey) pNewColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
								if (bNullAllowed) pNewColumn->SetFlag(SDB_FLAGS_NULLALLOWED);
								tab1->Columns()->AddColumn(pNewColumn);
								break;
					case 'M':
					case 'm':
								pNewColumn = new SdbColumn(aName,(enum SdbDatabaseType)eType,nPrecision,nScale);
								if (bPrimaryKey) pNewColumn->SetFlag(SDB_FLAGS_PRIMARYKEY);
								if (bNullAllowed) pNewColumn->SetFlag(SDB_FLAGS_NULLALLOWED);
								tab1->Columns()->ReplaceColumn(pNewColumn,aName);
								break;
					case 'D':
					case 'd':
								tab1->Columns()->RemoveColumn(aName);
								break;
					case 'R':
					case 'r':
								cout << "New Name: ";
								cin >> aNewName;
								pNewColumn = new SdbColumn(aNewName,tab1->Columns()->Column(aName)->Type(),10,0);
								tab1->Columns()->ReplaceColumn(pNewColumn,aName);
								break;
				}
			}

			if (*aCmd == 'f' || *aCmd == 'F') {
				// Forget changes
				tab1->Close(TRUE);
				show_status("tab1 Close",tab1->Status());
				if (tab1->Status().IsError()) goto keepopen;
			} else {
				if (*aMode == 'n' || *aMode == 'N') {
					cout << "TableName: ";
					cin >> aTableName;
					tab1->CloseAs(aTableName);
					show_status("tab1 SaveAs",tab1->Status());
					if (tab1->Status().IsError()) goto keepopen;
				}
				if (*aMode == 'o' || *aMode == 'O') {
					tab1->Close();
					show_status("tab1 Close",tab1->Status());
					if (tab1->Status().IsError()) goto keepopen;
				}
			}
		}
	}

	conn1->Delete();
	return 0;
}
