#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=sdb
TARGET=sdb
VERSION=$(UPD)

# --- Settings -----------------------------------------------------

.INCLUDE :  $(PRJ)$/inc$/sdbpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  $(PRJ)$/inc$/sdb.mk


.IF "$(DEPEND)" == ""

# --- Betriebssysteme und Treiber ----------------------------------
#

# ------------------------------------------------------------------
# MAC
# ------------------------------------------------------------------
.IF "$(GUI)"=="MAC"
SDBODBCLIB=     $(SLB)$/sdbodbc.lib \
				$(SLB)$/sdbodbc2.lib \
			    $(SLB)$/sdbodbc3.lib

SDBDTFSTDLIBS=-weakimport "$(MWPPCLibraries)ODBC Driver Manager PPC" \
			-weakimport "$(MWPPCLibraries)ODBC Cursor Library PPC"  \
			-weakimport "$(MWPPCLibraries)ODBC Configuration Manager PPC"
.ENDIF

# ------------------------------------------------------------------
# Windows
# ------------------------------------------------------------------
.IF "$(GUI)"=="WIN"
SDBODBCLIB=     $(SLB)$/sdbodbc.lib \
				$(SLB)$/sdbodbc2.lib \
			    $(SLB)$/sdbodbc3.lib


SDBDTFSTDLIBS=dtfswl1.lib dtfswl2.lib dtfswcr.lib
.ENDIF


# ------------------------------------------------------------------
# Windows NT
# ------------------------------------------------------------------
.IF "$(GUI)"=="WNT"
SDBODBCLIB=     $(SLB)$/sdbodbc.lib \
				$(SLB)$/sdbodbc2.lib \
			    $(SLB)$/sdbodbc3.lib

SDBDAOSTDLIBS=ole32.lib uuid.lib oleaut32.lib

.ENDIF


# ------------------------------------------------------------------
# OS2
# ------------------------------------------------------------------
.IF "$(GUI)"=="OS2"
SDBODBCLIB=     $(SLB)$/sdbodbc.lib \
				$(SLB)$/sdbodbc2.lib \
			    $(SLB)$/sdbodbc3.lib

.IF "$(ODBCIMP)" == ""
SDBODBCSTDLIBS=$(DEVROOT)$/odbc\os2i.21\lib\wod402.lib
SDBODBCSTDDEPN=$(DEVROOT)$/odbc\os2i.21\lib\wod402.lib
.ENDIF

#SHL3=YES

.ENDIF

# ------------------------------------------------------------------
# UNIX
# ------------------------------------------------------------------
.IF "$(GUI)"=="UNX"
SDBODBCLIB=     $(SLB)$/sdbodbc.lib \
				$(SLB)$/sdbodbc2.lib \
			    $(SLB)$/sdbodbc3.lib


.ENDIF





# --- Allgemein ----------------------------------------------------

# Exportierte Header Files zur SDBxxxxx.DLL:
HXX1TARGET= sdb
HXX1EXT=    hxx
HXX1FILES= \
		$(INC)$/cmdparse.hxx \
		$(INC)$/sdbqry.hxx \
		$(INC)$/sdbdb.hxx \
		$(INC)$/sdbstat.hxx \
 		$(INC)$/sdbsqlit.hxx \
 		$(INC)$/sdbcol.hxx \
		$(INC)$/variant.hxx \
		$(INC)$/row.hxx \
		$(INC)$/sdbcurs.hxx \
		$(INC)$/sdbtab.hxx \
		$(INC)$/sdbenv.hxx \
		$(INC)$/sdbconn.hxx \
		$(INC)$/odbcconf.hxx
HXX1EXCL=       -E:*include*
#HXX1DEPN=
#HXX1EXE1=
#HXX1EXE2=

SHL1TARGET= sdb$(VERSION)$(DLLPOSTFIX)
SHL1IMPLIB= sdb

RESLIB1NAME=$(TARGET)
RESLIB1SRSFILES= \
		$(SRS)$/sdbres.srs

# Symbole aus LIB1 werden exportiert:
LIB1TARGET=     $(SLB)$/$(TARGET).lib
LIB1FILES= \
		$(SLB)$/common.lib \
		$(SLB)$/parse.lib \
		$(SLB)$/cmdparse.lib

# LIB2 enthaelt alle Module, die Bestandteil von SDBxxxxx.DLL werden:
LIB2TARGET=     $(SLB)$/allsdb.lib

LIB2FILES=      \
		    $(SLB)$/common.lib          \
			$(SLB)$/parse.lib               \
			$(SLB)$/cmdparse.lib            \
			$(SDBODBCLIB)                   \
			$(SLB)$/sdbfile.lib             \
			$(SLB)$/sdbflat.lib \
			$(SLB)$/sdbdbf.lib \
			$(SLB)$/sdbsql.lib

.IF "$(OS)$(CPU)"!="SOLARISI"
LIB2FILES+=	$(SLB)$/sdbada.lib
.ENDIF

.IF "$(GUI)" != "MAC"
LIB2FILES += $(SLB)$/sdbjdbc.lib
.ENDIF


.IF "$(GUI)"=="WNT"
LIB2FILES+=\
			$(SLB)$/sdboter.lib \
			$(SLB)$/sdbado.lib
.ENDIF

.IF "$(GUI)" == "MAC"
LIB2FILES += $(SLB)$/SdbFm.lib
.ENDIF

.IF "$(GUI)" != "UNX"
SHL1OBJS=   $(SLO)$/sdbobj.obj
.ENDIF

SHL1DEF=    $(MISC)$/$(SHL1TARGET).def

.IF "$(GUI)" != "MAC"
SHL1STDLIBS= \
			$(SO2LIB) \
			$(SVTOOLLIB) \
			$(SVLLIB)	\
			$(SVLIB) \
			$(TOOLSLIB) \
			$(UNOTOOLSLIB) \
			$(CPPULIB) \
			$(CPPUHELPERLIB) \
			$(SDBODBCSTDLIBS) \
			$(SJLIB) \
			$(VOSLIB) \
			$(SALLIB)
.ELSE
SHL1STDLIBS=$(TOOLSLIB) \
			$(SVLIB) \
			$(SVTOOLLIB) \
			$(SVLLIB)	\
			$(SO2LIB) \
			$(UNOTOOLSLIB)
.ENDIF

.IF "$(GUI)"=="MAC"
SHL1STDLIBS += $(MWPPCLibraries)ObjectSupportLib
.ENDIF

.IF "$(GUI)"=="WIN"
SHL1STDLIBS+=\
			$(SVMEMLIB)
.ENDIF
.IF "$(VCL)" != ""
SHL1STDLIBS+=\
			$(SOTLIB)
.ENDIF


.IF "$(GUI)" == "MAC"
SHL1DEPN=       $(SOLARBINDIR)$/TL$(UPD)$(DLLPOSTFIX).DLL \
			$(SOLARBINDIR)$/SVT$(UPD)$(DLLPOSTFIX).DLL \
			$(SOLARBINDIR)$/VCL$(UPD)$(DLLPOSTFIX).DLL \
			$(SOLARBINDIR)$/SO$(UPD)$(DLLPOSTFIX).DLL
.ENDIF
SHL1LIBS=   $(SLB)$/allsdb.lib

DEF1NAME        =$(SHL1TARGET)
DEF1DEPN        =$(MISC)$/$(SHL1TARGET).flt \
			 $(HXX1FILES)
DEFLIB1NAME     =sdb
DEF1DES         =Sdb

.IF "$(GUI)"=="WNT"
SHL1STDLIBS+=$(SDBDAOSTDLIBS)
.ENDIF

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

# --- Export-Filter  ---

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
    @echo ------------------------------
    @echo Making: $@
    @echo Imp > $@
    @echo Dbg >> $@
    @echo LibMain >> $@
    @echo LIBMAIN >> $@
    @echo WEP >> $@
    @echo __CT >> $@
    @echo __alloc >> $@
    @echo __malloc >> $@

.IF "$(SHL3)" != ""
$(MISC)$/$(SHL3TARGET).flt: makefile.mk
    @echo ------------------------------
    @echo Making: $@
    @echo Imp>$@
    @echo Dbg>>$@
    @echo LibMain>>$@
    @echo LIBMAIN>>$@
    @echo WEP>>$@
    @echo __CT >> $@
    @echo __alloc >> $@
    @echo __malloc >> $@
.ENDIF

.ENDIF


