/*************************************************************************
 *
 *  $RCSfile: dumppoly.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>


#ifndef _XPOLY_HXX //autogen
#include <svx/xpoly.hxx>
#endif
#ifndef _XOUTX_HXX //autogen
#include <svx/xoutx.hxx>
#endif
#ifndef _SV_GEN_HXX //autogen
#include <tools/gen.hxx>
#endif
#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_METRIC_HXX //autogen
#include <vcl/metric.hxx>
#endif
#ifndef _SV_WINDOW_HXX //autogen
#include <vcl/window.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#define BYTES_PER_LINE	80
#define INIT_SIZE		1024
#define INC_SIZE		1024


class MyApp : public Application
{
public:
	virtual void Main();
};


MyApp  aMyApp;


ULONG BinDataTextOut(INT16 ik,SvFileStream &rMemStrm, SvFileStream &rOutStrm);

////////////////////////////////////////
// Mit diesem kleinen Programm werden die Polygon Daten erzeugt, die in den
// StarMath resource Dateien verwendet werden.
// Das Executable ist spter im bin Verzeichnis des Projects.
//

void MyApp::Main()
{
	if(GetCommandLineParamCount() == 0)
	{
		printf("dump RESOURCE_NAME file(s).. outputfile");
		return;
	}

	SvFileStream    aOutStrm (GetCommandLineParam(GetCommandLineParamCount()-1), STREAM_WRITE  | STREAM_TRUNC);

	for(INT16 i=0;i<GetCommandLineParamCount()-2;i++)
	{
		SvFileStream    aInStrm (GetCommandLineParam(i), STREAM_READ);
		String aName("Resource STARBASE");
		aName += i;
		aOutStrm.WriteLine(aName);
		aOutStrm.WriteLine("{");
		aOutStrm.WriteLine("\tExtraData = \n\t{");
		BinDataTextOut(i,aInStrm, aOutStrm);
		aOutStrm.WriteLine("\t};");
		aOutStrm.WriteLine("};");
	}
}


ULONG BinDataTextOut(INT16 iK,SvFileStream &rMemStrm, SvFileStream &rOutStrm)
{
	unsigned char  aLineBuf[BYTES_PER_LINE],
				   a2ByteBuf[2*BYTES_PER_LINE+1];
	ULONG  i, k, n;
	rMemStrm.Seek(STREAM_SEEK_TO_BEGIN);

	XubString aTmpStr;
	k = 0;
	ULONG nLineCount=0;
	USHORT nResCnt=0;
	while (!rMemStrm.IsEof())
	{
		memset(aLineBuf, 0,BYTES_PER_LINE);
		n = rMemStrm.Read( aLineBuf, BYTES_PER_LINE );
		if (n)
		{
			for(i = 0;  i < n;  i+=2)
			{
				// wir sind hier auf einem LittleEndian
				// daher Bytes vertauschen fuer BigEndian Darstellung
				//INT16 nVal = ((USHORT) aLineBuf[i+1]) << 8 | aLineBuf[i];
				INT16 nVal = ((USHORT) aLineBuf[i]) << 8 | aLineBuf[i+1];

				sprintf((char *) a2ByteBuf,"%6hd;  ", nVal);
//				sprintf((char *) aByteBuf, "\\x%02X", (unsigned) aLineBuf[i]);
				aTmpStr += XubString((char *) a2ByteBuf);
			}
			k += BYTES_PER_LINE >> 1;
			//aTmpStr += "\n";
		}
		rOutStrm.WriteLine(aTmpStr);
		if(++nLineCount == 84)
		{
			nLineCount = 0;
			rOutStrm.WriteLine("\t};");
			rOutStrm.WriteLine("};");
			String aName("Resource STARBASE");
			(aName += iK) += nResCnt++;
			rOutStrm.WriteLine(aName);
			rOutStrm.WriteLine("{");
			rOutStrm.WriteLine("\tExtraData = \n\t{");
		}
		aTmpStr.Erase(0);
	}
	return rOutStrm.GetError();
}


