/*************************************************************************
 *
 *  $RCSfile: democonn.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "democonn.hxx"

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_MDIAPP_HXX //autogen
#include <vcl/mdiapp.hxx>
#endif

#ifndef _TOOLS_RC_HXX //autogen
#include <tools/rc.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX //autogen
#include <tools/resmgr.hxx>
#endif

#ifndef SOLAR_HRC
#include <svtools/solar.hrc>
#endif


#include "sdbtab.hxx"
#include "sdbconn.hxx"
#include "sdbrel.hxx"

#include <svtools/sdbparse.hxx>

#include "sdbsqlit.hxx"

// global
SdbDatabaseRef AppWindow::xDB = NULL;

//------------------------------------------------------------------
SQLDialog::SQLDialog()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_SQL))
		  ,aConnectEdit(this, ResId(CID_CONNECT))
		  ,aConnectBtn(this, ResId(CID_CB_CONNECT))
		  ,aSQLEdit(this, ResId(CID_SQL))
		  ,aSQLExecBtn(this, ResId(CID_CB_EXEC))
		  ,aConnectCB(this, ResId(CID_CX_CONNECTED))
		  ,aText1(this, ResId(10))
		  ,aText2(this, ResId(11))
{
	FreeResource();

	Config aConfig("democonn.ini");
	aConfig.SetGroup("Last Connect");
	aConnectEdit.SetText(aConfig.ReadKey("ConnectString",""));
	aSQLEdit.SetText(aConfig.ReadKey("SQL",""));

	aSQLExecBtn.SetClickHdl( LINK(this, SQLDialog, OnExec ) );
	aConnectBtn.SetClickHdl( LINK(this, SQLDialog, OnConnect ) );
}

IMPL_LINK(SQLDialog, OnConnect, PushButton*, EMPTYARG )
{
	AppWindow::xDB = SdbEnvironmentRef()->OpenDatabase(aConnectEdit.GetText());
	DBG_ASSERT(AppWindow::xDB != NULL,"AppWindow::xDB == NULL");
	if (!AppWindow::xDB.Is())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::xDB = NULL;
		return TRUE;
	}
	if (!AppWindow::xDB->Status().IsSuccessful())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::xDB = NULL;
	}
	else
	{
		Config aConfig("democonn.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("ConnectString",aConnectEdit.GetText());

		aConnectCB.Check();
		aSQLExecBtn.Enable();
		aConnectBtn.Disable();
	}
	return TRUE;
}

//------------------------------------------------------------------
IMPL_LINK( SQLDialog, OnExec, PushButton*, EMPTYARG )
{

	SdbCursorRef xCurs = AppWindow::xDB->CreateCursor(SDB_KEYSET,SDB_FORWARDONLY);
	DBG_ASSERT(xCurs != NULL,"xCurs == NULL");
	if (!AppWindow::xDB->Status().IsSuccessful() || ! xCurs->Status().IsSuccessful())
	{
		ErrorBox(NULL, WinBits(WB_OK|RET_OK), "Unable to Execute!").Execute();
		xCurs = NULL;
		return FALSE;
	}
	xCurs->SetCacheSize(100);
	xCurs->Open(aSQLEdit.GetText());
	if (!xCurs->Status().IsSuccessful())
	{
		ErrorBox(NULL, WinBits(WB_OK|RET_OK), "Unable to Execute!").Execute();
		return FALSE;
	}
	Config aConfig("democonn.ini");
	aConfig.SetGroup("Last Connect");
	aConfig.WriteKey("SQL",aSQLEdit.GetText());

	BrowseWindow* pBrowseWin = new BrowseWindow(xCurs);
	if (pBrowseWin) pBrowseWin->Show();

	EndDialog();
	return TRUE;
}

//------------------------------------------------------------------

CreateTableDialog::CreateTableDialog()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_CREATE_TABLE))
		  ,aConnectEdit(this, ResId(CID_CONNECT))
		  ,aConnectBtn(this, ResId(CID_CB_CONNECT))
		  ,aTableEdit(this, ResId(CID_TABLE))
		  ,aCreateBtn(this, ResId(CID_CB_CREATE))
		  ,aDropBtn(this, ResId(CID_CB_DROP))
		  ,aCancelBtn(this, ResId(CID_CANCEL))
		  ,aText1(this, ResId(1000))
		  ,aText2(this, ResId(1001))
{
	FreeResource();

	Config aConfig("democonn.ini");
	aConfig.SetGroup("Last Connect");
	aConnectEdit.SetText(aConfig.ReadKey("ConnectString",""));


	aConnectBtn.SetClickHdl( LINK(this, CreateTableDialog, OnConnect ) );
	aCreateBtn.SetClickHdl( LINK(this, CreateTableDialog, OnCreate ) );
	aDropBtn.SetClickHdl( LINK(this, CreateTableDialog, OnDrop ) );

}
//------------------------------------------------------------------
IMPL_LINK( CreateTableDialog, OnConnect, PushButton*, EMPTYARG )
{
	AppWindow::xDB = SdbEnvironmentRef()->OpenDatabase(aConnectEdit.GetText());
	if (!AppWindow::xDB.Is())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::xDB = NULL;
	}
	else
	{
		Config aConfig("democonn.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("ConnectString",aConnectEdit.GetText());

		aConnectBtn.Disable();
	}
	return TRUE;
}


//------------------------------------------------------------------
IMPL_LINK( CreateTableDialog, OnCreate, PushButton*, EMPTYARG )
{
	EndDialog();
	return TRUE;
}

IMPL_LINK( CreateTableDialog, OnDrop, PushButton*, EMPTYARG )
{
	EndDialog();
	return TRUE;
}

//------------------------------------------------------------------

class BrowseApp: public MDIApplication
{
	Font	aFont;
protected:
	virtual void Main();

public:
	BrowseApp();
};

//==================================================================

BrowseApp aApp;

//==================================================================

Browser::Browser(BrowseWindow* pParent, BrowserMode eMode, SdbCursorRef xCursor)
		:BrowseBox( pParent, WinBits(WB_DRAG), eMode )
		,bInverse(FALSE)
		,xCur(xCursor)
{}

void Browser::Fill()
{
	const SdbColumnsRef aColumns = xCur->GetColumns();

	InsertHandleColumn(aColumns->Count());
	for (int i = 0; i < aColumns->Count(); i++)
		InsertDataColumn(i + 1, (*aColumns)[i]->GetName(), 85);

	if (i)
		FreezeColumn(1);
}


//------------------------------------------------------------------

long Browser::GetRowCount() const
{
	return 50;
}

//------------------------------------------------------------------
BOOL Browser::SeekRow( long nRow )
{
	if (nRow >= 0 && nRow < GetRowCount())
	{
		 xCur->MoveAbs(nRow + 1);
		return TRUE;
	}
	return FALSE;
}

//------------------------------------------------------------------

void Browser::PaintField( OutputDevice& rDev, const Rectangle& rRect,
						  USHORT nColumnId ) const
{
	rDev.SetClipRegion(rRect);
	const ODbRowRef& rRow = xCur->GetRow();
	if (rRow.Is())
	{
		ODbVariantRef aVar((*rRow)[nColumnId-1]);
		rDev.DrawText(rRect.TopLeft(),S(aVar->getString()));
	}
}

Browser::~Browser()
{
}


//==================================================================

AppWindow::AppWindow()
		  :WorkWindow( 0, WinBits(WB_APP|WB_STDWORK) )
		  ,aMenu(ResId(MID_MENUBAR))
{
	AppWindow::xDB = NULL;
	SetText( "Database Browse Application" );
	aMenu.GetPopupMenu( MID_FILE )->PushSelectHdl( LINK( this ,AppWindow, OnFile));
	aMenu.GetPopupMenu( MID_TABLE_OP )->PushSelectHdl( LINK( this ,AppWindow, OnMenu));
	aMenu.GetPopupMenu( MID_RELATIONS )->PushSelectHdl( LINK( GetParent() ,AppWindow, OnMenu));

	Show();
}

//------------------------------------------------------------------
AppWindow::~AppWindow()
{
	GetpApp()->SetAppMenu();
}

//------------------------------------------------------------------

IMPL_LINK( AppWindow, OnFile, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_OPEN:
		{
			if (AppWindow::xDB)
			{
				AppWindow::xDB = NULL;
			}

			SQLDialog aDlg;
			aDlg.Execute();
		}break;
		case MID_CREATE:
		{
			if (AppWindow::xDB)
			{
				AppWindow::xDB = NULL;
			}
			CreateTableDialog aDlg;
			aDlg.Execute();
		}break;
		case MID_QUIT:
			Close();
			break;
	}
	return TRUE;
}


IMPL_LINK( AppWindow, OnMenu, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_CONNECT:
		{
			if (AppWindow::xDB)
			{
				AppWindow::xDB = NULL;
			}
			SQLConnect aDlg;
			aDlg.Execute();
			if (AppWindow::xDB)
			{
				pMenu->EnableItem(MID_CREATETABLES, TRUE);
				pMenu->EnableItem(MID_FILL, TRUE);
				pMenu->EnableItem(MID_DROPTABLES, TRUE);
				pMenu->EnableItem(MID_CREATEDB, TRUE);
				pMenu->EnableItem(MID_DROPDB, TRUE);
				pMenu->EnableItem(MID_MOD, TRUE);
				pMenu->EnableItem(MID_DEL, TRUE);
				pMenu->EnableItem(MID_CREATEREL, TRUE);
				pMenu->EnableItem(MID_DROPREL, TRUE);
			}
			else
			{
				pMenu->EnableItem(MID_CREATETABLES, FALSE);
				pMenu->EnableItem(MID_CREATEDB, FALSE);
				pMenu->EnableItem(MID_DROPDB, FALSE);
				pMenu->EnableItem(MID_FILL, FALSE);
				pMenu->EnableItem(MID_MOD, FALSE);
				pMenu->EnableItem(MID_DEL, FALSE);
				pMenu->EnableItem(MID_DROPTABLES, FALSE);
				pMenu->EnableItem(MID_CREATEREL, TRUE);
				pMenu->EnableItem(MID_DROPREL, TRUE);
			}
		}break;
		case MID_CREATETABLES:
			CreateTables();
			break;
		case MID_FILL:
			FillTables();
			break;
		case MID_MOD:
			ModifyRows();
			break;
		case MID_DEL:
			DeleteRows();
			break;
		case MID_DROPTABLES:
			DropTables();
			break;
		case MID_CREATEDB:
		{
			SQLDatabase aDlg(TRUE);
			aDlg.Execute();
			break;
		}
		case MID_DROPDB:
		{
			SQLDatabase aDlg(FALSE);
			aDlg.Execute();
			break;
		}
		case MID_DROPREL:
		{
			// Anlegen von Relationen
			USHORT nRelCount = AppWindow::xDB->GetObjectCount(dbRelation);
			for (USHORT i = nRelCount; i > 0; i--)
			{
				SdbRelationRef xRelation = (SdbRelation*)AppWindow::xDB->OpenObject(dbRelation,i-1);
				xRelation->Drop();
			}
		}	break;
		case MID_CREATEREL:
		{
		} break;

		case MID_PARSE:
		{
			SQLParse aDlg;
			aDlg.Execute();
		}
			break;

	}
	return TRUE;
}


//------------------------------------------------------------------
void AppWindow::Activate()
{
	GetpApp()->SetAppMenu( &aMenu );
}

BOOL AppWindow::Close()
{
	if (MDIApplication::CloseAll())
	{
		if (AppWindow::xDB)
		{
			AppWindow::xDB == NULL;
		}
		GetpApp()->Quit();
		return TRUE;
	}
	else
		return FALSE;
}

//==================================================================
BrowseWindow::BrowseWindow(SdbCursorRef xCur)
			 :MDIWindow(GetpApp()->GetAppWindow(), WinBits(WB_CLOSEABLE) )
			 ,aBrowser( this, 0 , xCur)
			 ,eCurMode( 0 )
			 ,nNewRowNo( 2000L )
			 ,aBrowseMenu(ResId( MID_BROWSEBAR))

{
	SetText("Database Browsing");
	aBrowseMenu.GetPopupMenu(MID_FILE )->PushSelectHdl( LINK( this ,BrowseWindow, OnFile) );
	aBrowseMenu.GetPopupMenu( MID_TABLE_OP )->PushSelectHdl( LINK( GetParent() ,AppWindow, OnMenu));
	//aBrowseMenu.GetPopupMenu( MID_RELATIONS )->PushSelectHdl( LINK( GetParent() ,AppWindow, OnMenu));

	aBrowser.Fill();

	Font aFont("MS Sans Serif",Size(0,8));
	aBrowser.SetFont(aFont);
	aFont.SetWeight(WEIGHT_BOLD);
	aBrowser.SetTitleFont(aFont);
	aBrowser.Show();
}

//------------------------------------------------------------------
BrowseWindow::~BrowseWindow()
{
	if (MDIApplication::GetVisibleWindowCount() == 1)
		GetpApp()->SetAppMenu(&((AppWindow *)GetParent())->aMenu);
}

void BrowseWindow::Activate()
{
	if (IsMDIActivate()) GetpApp()->SetAppMenu(&aBrowseMenu);
	aBrowser.GrabFocus();
}

//------------------------------------------------------------------
void BrowseWindow::Resize()
{
	Size aOutSz( GetOutputSizePixel() );
	aBrowser.SetPosSizePixel(
		Point(0,0),
		Size(aOutSz.Width(), aOutSz.Height()));
}

IMPL_LINK(BrowseWindow, OnFile, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_CLOSE:
			Close();
			break;
		default:
			return ((AppWindow*)GetParent())->OnFile(pMenu);
	}
	return TRUE;
}

IMPL_LINK( BrowseWindow, OnMenu, Menu *, pMenu )
{
	return ((AppWindow *)GetParent())->OnMenu(pMenu);
}

//------------------------------------------------------------------
BrowseApp::BrowseApp()
		  :aFont("MS Sans Serif",Size(0,8))
{
}


void BrowseApp::Main()
{
	ResMgr* pResMgr = ResMgr::CreateResMgr(String("dem") + String(SOLARUPD));
	Resource::SetResManager(pResMgr);
	EnableSVLook();

	SetAppFont(aFont);
	AppWindow aAppWin;
	Execute();
	AppWindow::xDB = NULL;
}


SQLConnect::SQLConnect()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_CONNECT))
		  ,aConnectEdit(this, ResId(CID_CONNECT))
		  ,aConnectBtn(this, ResId(CID_CB_CONNECT))
		  ,aConnectCB(this, ResId(CID_CX_CONNECTED))
		  ,aText1(this, ResId(10))
{
	Config aConfig("democonn.ini");
	aConfig.SetGroup("Last Connect");
	aConnectEdit.SetText(aConfig.ReadKey("ConnectString",""));

	aConnectBtn.SetClickHdl( LINK(this, SQLConnect, OnConnect ) );
	FreeResource();
}

//------------------------------------------------------------------
IMPL_LINK( SQLConnect, OnConnect, PushButton*, EMPTYARG )
{
	AppWindow::xDB = SdbEnvironmentRef()->OpenDatabase(aConnectEdit.GetText());
	if (!AppWindow::xDB.Is())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::xDB = NULL;
	}
	else
	{
		Config aConfig("democonn.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("ConnectString",aConnectEdit.GetText());

		aConnectCB.Check();
		aConnectBtn.Disable();
	}
	return TRUE;
}

SQLDatabase::SQLDatabase(BOOL bCreate)
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_CREATEDROPDB))
		  ,aDBNameEdit(this, ResId(CID_DBNAME))
		  ,aCreateBtn(this, ResId(CID_CB_CREATE))
		  ,aDropBtn(this, ResId(CID_CB_DROP))
		  ,aText1(this, ResId(10))
{
	FreeResource();
	aCreateBtn.SetClickHdl( LINK(this, SQLDatabase, OnCreate ) );
	aDropBtn.SetClickHdl( LINK(this, SQLDatabase, OnDrop ) );
	if ( bCreate )
	{
		aCreateBtn.Enable();
		aDropBtn.Disable();
	}
	else
	{
		aCreateBtn.Disable();
		aDropBtn.Enable();
	}
}

//------------------------------------------------------------------
IMPL_LINK( SQLDatabase, OnCreate, PushButton*, EMPTYARG )
{
	if (!AppWindow::xDB.Is())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Keine Verbindung aufgebaut").Execute();
		return TRUE;
	}
	String Text = aDBNameEdit.GetText();

	return TRUE;
}

IMPL_LINK( SQLDatabase, OnDrop, PushButton*, EMPTYARG )
{
	return TRUE;
}

//------------------------------------------------------------------
void AppWindow::CreateTables()
{
}

void AppWindow::DropTables()
{
}
void AppWindow::FillTables()
{
}

void AppWindow::ModifyRows()
{
}

void AppWindow::DeleteRows()
{
}


SQLParse::SQLParse()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_SQLPARSER))
		  ,aInsertEdit(this, ResId(CID_SQLINSERT))
		  ,aExecuteBtn(this, ResId(CID_CB_EXECUTE))
		  ,aClearBtn(this, ResId(CID_CB_CLEAR))
		  ,m_ftStatus(this, ResId(FT_STATUS))
		  ,m_etStatus(this, ResId(ET_STATUS))
		  ,aPrintEdit(this, ResId(CID_SQLPRINT))
{
	Config aConfig("democonn.ini");
	aConfig.SetGroup("Last Connect");
	aInsertEdit.SetText(aConfig.ReadKey("Parsed SQL",""));

	aExecuteBtn.SetClickHdl( LINK(this, SQLParse, OnExecute ) );
	aClearBtn.SetClickHdl( LINK(this, SQLParse, OnClear ) );
	aPrintEdit.SetDragDropMode( 0 );
	aPrintEdit.EnableInplaceEditing( TRUE );
	aPrintEdit.SetWindowBits(WB_BORDER | WB_HASLINES | WB_HASBUTTONS | WB_HSCROLL);
	aPrintEdit.SetNodeBitmaps(aPrintEdit.GetDefaultCollapsedEntryBmp(), aPrintEdit.GetDefaultExpandedEntryBmp());
	FreeResource();
}
//------------------------------------------------------------------
IMPL_LINK( SQLParse, OnClear, PushButton*, EMPTYARG )
{
	aPrintEdit.Clear();
	return TRUE;
}
//------------------------------------------------------------------
IMPL_LINK( SQLParse, OnExecute, PushButton*, EMPTYARG )
{
	if (AppWindow::xDB.Is())
	{
		String aSql = aInsertEdit.GetText();
		SdbSqlParser* pParser = AppWindow::xDB->GetSqlParser();
		String aError;
		SdbSqlParseNode* pParseNode = pParser->ParseTree(aError, aSql);

		Config aConfig("democonn.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("Parsed SQL", aSql);

		if (pParseNode)
		{
			aSql.Erase();
			pParseNode->ParseNodeToStr(aSql,AppWindow::xDB->GetMetaData(),FALSE,TRUE);
			FillTreeListBox(pParseNode,aPrintEdit.InsertEntry(aSql));
			SdbSqlParseTreeIterator aIter(AppWindow::xDB,pParseNode);
/*
			aIter.TraverseAll();
			const SdbTableRangeMap& aMap = aIter.GetSdbTableRangeMap();
			String aTableName,aQualifierName;
			for(ULONG i=0;i<aMap.Count();i++)
			{
				SdbTableRef* pTableRef	= aMap.GetObject(i);
				const String& aAlias	= aMap.GetKey(pTableRef);
				aTableName				= *pTableRef != NULL ? (*pTableRef)->GetFullName() : String("");
				aQualifierName			= *pTableRef != NULL ? (*pTableRef)->QualifierName() : String("");
			}

			const SdbColumnsRef rCols = aIter.GetSelectColumns();

			UINT16 nPos = 2;
			pParser->SetColumn((*rCols)[nPos]);
			pParser->SetNumberFormatter(AppWindow::xDB->GetFormatter());
			SdbSqlParseNode* pNewTree = pParser->ParseTree(aSql);
			m_etStatus.SetText(pParser->Status().ErrorMessage());
			pParser->SetColumn(NULL);
			if(pNewTree)
			{
				aSql.Erase();
				pNewTree->ParseNodeToStr(aSql,*AppWindow::xDB,FALSE,TRUE);
				FillTreeListBox(pNewTree,aPrintEdit.InsertEntry(aSql));
			}
			delete pNewTree;
*/
			m_etStatus.SetText("");
			delete pParseNode;
		}
		else
			m_etStatus.SetText(aError);


	}
	return TRUE;
}

//-----------------------------------------------------------------------------
SdbSqlParseNode* MakeANDNode(SdbSqlParseNode *pLeftLeaf,SdbSqlParseNode *pRightLeaf)
{
	SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::boolean_term));
	pNewNode->Append(pLeftLeaf);
	pNewNode->Append(new SdbSqlParseNode("AND",SDB_SQL_KEYWORD,SDB_TOKEN_AND));
	pNewNode->Append(pRightLeaf);
	return pNewNode;
}
//-----------------------------------------------------------------------------
SdbSqlParseNode* MakeORNode(SdbSqlParseNode *pLeftLeaf,SdbSqlParseNode *pRightLeaf)
{
	SdbSqlParseNode* pNewNode = new SdbSqlParseNode(String(),SDB_SQL_RULE,SdbSqlParser::RuleID(SdbSqlParseNode::search_condition));
	pNewNode->Append(pLeftLeaf);
	pNewNode->Append(new SdbSqlParseNode("OR",SDB_SQL_KEYWORD,SDB_TOKEN_OR));
	pNewNode->Append(pRightLeaf);
	return pNewNode;
}
//-----------------------------------------------------------------------------
void SQLParse::NegateTree(SdbSqlParseNode *pSearchCondition,BOOL bNegate)
{
	String aDebug;

}
void SQLParse::FillTreeListBox(SdbSqlParseNode *pNode, SvLBoxEntry* pParent)
{
	for (USHORT i = 0; i < pNode->Count();i++)
	{
		SdbSqlParseNode *pChild = pNode->GetChild(i);
		if (!pChild)
			continue;

		String rString;
		if (!pChild->IsToken())
		{
			// Regelnamen als rule: ...
			rString += "RULE_ID: ";
			rString += (String) pChild->GetRuleID();
			rString += "(";
			rString += SdbSqlParser::RuleIDToStr(pChild->GetRuleID());
			rString += ")";
		}
		else
		{
			// ein Token gefunden
			// tabs fuer das Einruecken entsprechend nLevel
			switch (pChild->GetNodeType()) {

			case SDB_SQL_KEYWORD:
				{rString += "SQL_KEYWORD:";
				 rString += SdbSqlParser::TokenIDToStr(pChild->GetTokenID());
				 break;}

			case SDB_SQL_COMPARISON:
				{rString += "SQL_COMPARISON:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;}

			case SDB_SQL_NAME:
				{rString += "SQL_NAME:";
				 rString += "\"";
				 rString += pChild->TokenValue();
				 rString += "\"";
				 break;}

			case SDB_SQL_STRING:
				{rString += "SQL_STRING:'";
				 rString += pChild->TokenValue();
				 rString += "'";
				 break;}

			case SDB_SQL_INTNUM:
				{rString += "SQL_INTNUM:";
				 rString += pChild->TokenValue();
				 break;}

			case SDB_SQL_APPROXNUM:
				{rString += "SQL_APPROXNUM:";
				 rString += pChild->TokenValue();
				 break;}

			case SDB_SQL_PUNCTUATION:
				{rString += "SQL_PUNCTUATION:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;}

			case SDB_SQL_AMMSC:
				{rString += "SQL_AMMSC:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;}
			case SDB_SQL_EQUAL:
				rString += "SDB_SQL_EQUAL:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			case SDB_SQL_NOTEQUAL:
				rString += "SDB_SQL_NOTEQUAL:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			case SDB_SQL_LESS:
				rString += "SDB_SQL_LESS:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			case SDB_SQL_LESSEQ:
				rString += "SDB_SQL_LESSEQ:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			case SDB_SQL_GREATEQ:
				rString += "SDB_SQL_GREATEQ:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			case SDB_SQL_GREAT:
				rString += "SDB_SQL_GREAT:";
				rString += pChild->TokenValue();	// haenge Nodevalue an
				break;
			default:
				;
				DBG_ERROR("SdbSqlParser::ShowParseTree: unzulaessiger NodeType");
			}
		}
		FillTreeListBox(pChild,aPrintEdit.InsertEntry(rString, pParent));
	}
}

