/*************************************************************************
 *
 *  $RCSfile: dbbrows.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "dbbrows.hxx"

// global
SdbConnection*	AppWindow::pConn = NULL;

//------------------------------------------------------------------
SQLDialog::SQLDialog()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_SQL))
		  ,aConnectEdit(this, ResId(CID_CONNECT))
		  ,aConnectBtn(this, ResId(CID_CB_CONNECT))
		  ,aSQLEdit(this, ResId(CID_SQL))
		  ,aSQLExecBtn(this, ResId(CID_CB_EXEC))
		  ,aConnectCB(this, ResId(CID_CX_CONNECTED))
		  ,aText1(this, ResId(10))
		  ,aText2(this, ResId(11))
{
	FreeResource();

	Config aConfig("dbbrows.ini");
	aConfig.SetGroup("Last Connect");
	aConnectEdit.SetText(aConfig.ReadKey("ConnectString",""));
	aSQLEdit.SetText(aConfig.ReadKey("SQL",""));

	aSQLExecBtn.SetClickHdl( LINK(this, SQLDialog, OnExec ) );
	aConnectBtn.SetClickHdl( LINK(this, SQLDialog, OnConnect ) );
}


IMPL_LINK( SQLDialog, OnConnect, PushButton*, EMPTYARG )
{
	AppWindow::pConn = SdbEnvironmentRef()->CreateConnection(aConnectEdit.GetText());
	DBG_ASSERT(AppWindow::pConn != NULL,"AppWindow::pConn == NULL");
	if (!AppWindow::pConn->Status().IsSuccessful())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::pConn->Delete();
		AppWindow::pConn = NULL;
		return TRUE;
	}
	AppWindow::pConn->Open();
	if (!AppWindow::pConn->Status().IsSuccessful())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::pConn->Delete();
		AppWindow::pConn = NULL;
	}
	else
	{
		Config aConfig("dbbrows.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("ConnectString",aConnectEdit.GetText());

		aConnectCB.Check();
		aSQLExecBtn.Enable();
		aConnectBtn.Disable();
	}
	return TRUE;
}

//------------------------------------------------------------------
IMPL_LINK( SQLDialog, OnExec, PushButton*, EMPTYARG )
{
	SdbCursor *pCurs = AppWindow::pConn->CreateCursor();
	DBG_ASSERT(pCurs != NULL,"pCurs == NULL");
	if (!AppWindow::pConn->Status().IsSuccessful() || ! pCurs->Status().IsSuccessful())
	{
		ErrorBox(NULL, WinBits(WB_OK|RET_OK), "Unable to Execute!").Execute();
		pCurs->Delete();
		return FALSE;
	}
	pCurs->SetCacheSize(100);
	pCurs->Open(aSQLEdit.GetText());
	if (!pCurs->Status().IsSuccessful())
	{
		ErrorBox(NULL, WinBits(WB_OK|RET_OK), "Unable to Execute!").Execute();
		return FALSE;
	}
	Config aConfig("dbbrows.ini");
	aConfig.SetGroup("Last Connect");
	aConfig.WriteKey("SQL",aSQLEdit.GetText());

	BrowseWindow* pBrowseWin = new BrowseWindow(*pCurs);
	if (pBrowseWin) pBrowseWin->Show();

	EndDialog();
	return TRUE;
}

//------------------------------------------------------------------

CreateTableDialog::CreateTableDialog()
		  :ModalDialog(GetpApp()->GetAppWindow(), ResId(DID_CREATE_TABLE))
		  ,aConnectEdit(this, ResId(CID_CONNECT))
		  ,aConnectBtn(this, ResId(CID_CB_CONNECT))
		  ,aTableEdit(this, ResId(CID_TABLE))
		  ,aCreateBtn(this, ResId(CID_CB_CREATE))
		  ,aDropBtn(this, ResId(CID_CB_DROP))
		  ,aCancelBtn(this, ResId(CID_CANCEL))
		  ,aText1(this, ResId(1000))
		  ,aText2(this, ResId(1001))
{
	FreeResource();

	Config aConfig("dbbrows.ini");
	aConfig.SetGroup("Last Connect");
	aConnectEdit.SetText(aConfig.ReadKey("ConnectString",""));


	aConnectBtn.SetClickHdl( LINK(this, CreateTableDialog, OnConnect ) );
	aCreateBtn.SetClickHdl( LINK(this, CreateTableDialog, OnCreate ) );
	aDropBtn.SetClickHdl( LINK(this, CreateTableDialog, OnDrop ) );

}
//------------------------------------------------------------------
IMPL_LINK( CreateTableDialog, OnConnect, PushButton*, EMPTYARG )
{
	AppWindow::pConn = SdbEnvironmentRef()->CreateConnection(aConnectEdit.GetText());
	DBG_ASSERT(AppWindow::pConn != NULL,"AppWindow::pConn == NULL");
	if (!AppWindow::pConn->Status().IsSuccessful())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::pConn->Delete();
		AppWindow::pConn = NULL;
		return TRUE;
	}
	AppWindow::pConn->Open();
	if (!AppWindow::pConn->Status().IsSuccessful())
	{
		ErrorBox(this, WinBits(WB_OK|RET_OK), "Unable to Connect!").Execute();
		AppWindow::pConn->Delete();
		AppWindow::pConn = NULL;
	}
	else
	{
		Config aConfig("dbbrows.ini");
		aConfig.SetGroup("Last Connect");
		aConfig.WriteKey("ConnectString",aConnectEdit.GetText());

		aConnectBtn.Disable();
	}
	return TRUE;
}


//------------------------------------------------------------------
IMPL_LINK( CreateTableDialog, OnCreate, PushButton*, EMPTYARG )
{
	SdbTable* pTable = AppWindow::pConn->CreateTable();  // Erzeugen der Tabellenstruktur
	if (!pTable) return TRUE;
	pTable->Create(aTableEdit.GetText());					// TabellenName

	SdbColumnsRef aTblCol = pTable->Columns();  // leere struktur holen
	aTblCol->AddColumn(new SdbColumn("Name",				// feld name (max 10 Zeichen)
									 SDB_DBTYPE_CHAR,	// typ
									 30,					// feldlnge
									 0));					// Nachkommastellen

	aTblCol->AddColumn(new SdbColumn("Zahl",				// feld name
									 SDB_DBTYPE_CHAR,	// typ
									 10,					// feldlnge
									 0));						// Nachkommastellen


	//aTblCol->AddColumn(new SdbColumn("Noch1eZahl",			// feld name
	//								 SDB_DBTYPE_DECIMAL,	// typ
	//								 10,					// feldlnge
	//								 0));					// Nachkommastellen

/*	aTblCol->AddColumn(new SdbColumn("Memo",				// feld name
									 SDB_DBTYPE_LONGVARCHAR,	// typ
									 0,						// feldlnge
									 0));					// Nachkommastellen

	aTblCol->AddColumn(new SdbColumn("BOOL",				// feld name
									 SDB_DBTYPE_BIT,		// typ
									 0,						// feldlnge
									 0));					// Nachkommastellen */


	pTable->Update();

	if (pTable->Status().IsError())
	{
		pTable->Delete();
	}
	else
	{
		pTable->Delete();

		SdbCursor* pCur = AppWindow::pConn->CreateCursor();

		String aBuffer;
		aBuffer = "Select * from ";
		aBuffer += aTableEdit.GetText();
		pCur->Open(aBuffer);


		for (int i = 0; i < 100; i++)
		{
			pCur->AppendRow();
			SdbVariable* pVar = NULL;

			pVar = pCur->Variable("Name");

			pVar->PutLong(i);

			pVar = pCur->Variable("Zahl");
			pVar->PutLong(i+5);

			//pVar = pCur->Variable("Noch1eZahl");
			//pVar->PutLong(i);

			/*pVar = pCur->Variable("Memo");
			pVar->PutString("MemoFeld");

			pVar = pCur->Variable("BOOL");
			pVar->PutLong(i % 2);*/

			pCur->UpdateRow();

			/*pCur->EditRow();

			pVar = pCur->Variable("Zahl");
			pVar->PutString("5");

			pCur->UpdateRow();*/
		}

		pCur->Delete();
	}

	EndDialog();
	return TRUE;
}

IMPL_LINK( CreateTableDialog, OnDrop, PushButton*, EMPTYARG )
{
	SdbTable* pTable = AppWindow::pConn->CreateTable();  // Erzeugen der Tabellenstruktur
	if (!pTable) return TRUE;
	pTable->Drop(aTableEdit.GetText());					// TabellenName

	pTable->Delete();
	EndDialog();
	return TRUE;
}

//------------------------------------------------------------------

class BrowseApp: public MDIApplication
{
	Font	aFont;
protected:
	virtual void Main( int, char *[] );

public:
	BrowseApp();
};

//==================================================================

BrowseApp aApp;

//==================================================================

Browser::Browser(BrowseWindow* pParent, BrowserMode eMode, SdbCursor& rCursor)
		:BrowseBox( pParent, WinBits(WB_DRAG), eMode )
		,bInverse(FALSE)
		,rCur(rCursor)
{}

void Browser::Fill()
{
	const SdbColumnsRef aColumns = rCur.ResultColumns();

	InsertHandleColumn(aColumns->Count());
	for (int i = 0; i < aColumns->Count(); i++)
		InsertDataColumn(i + 1, aColumns[i]->Name(), 85);

	if (i)
		FreezeColumn(1);
}


//------------------------------------------------------------------

long Browser::GetRowCount() const
{
	return rCur.RowCount();
}

//------------------------------------------------------------------
BOOL Browser::SeekRow( long nRow )
{
	if (nRow >= 0 && nRow < GetRowCount())
	{
		 rCur.MoveAbs(nRow + 1);
		return TRUE;
	}
	return FALSE;
}

//------------------------------------------------------------------

void Browser::PaintField( OutputDevice& rDev, const Rectangle& rRect,
						  USHORT nColumnId ) const
{
	rDev.SetClipRegion(rRect);
	if (rCur.ResultColumns()[nColumnId - 1]->Type() == SDB_DBTYPE_LONGVARCHAR)
	{
		SbxBase* pObj = rCur[nColumnId - 1]->GetObject();
		if (pObj && pObj->GetType() == SbxMEMORYSTREAM)
			rDev.DrawText(rRect.TopLeft(), String(*((SbxMemoryStream*) pObj)));
		else
			rDev.DrawText(rRect.TopLeft(),rCur[nColumnId - 1]->GetString());
	}
	else
	{
		SdbVariable *pVar = rCur[nColumnId-1];
		rDev.DrawText(rRect.TopLeft(),pVar->GetString());
	}
}

Browser::~Browser()
{
	rCur.Delete();
}


//==================================================================

AppWindow::AppWindow()
		  :WorkWindow( 0, WinBits(WB_APP|WB_STDWORK) )
		  ,aMenu(ResId(MID_MENUBAR))
{
	AppWindow::pConn = NULL;
	SetText( "Database Browse Application" );
	aMenu.GetPopupMenu( MID_FILE )->PushSelectHdl( LINK( this ,AppWindow, OnFile));
	aMenu.GetPopupMenu( MID_TABLE_OP )->PushSelectHdl( LINK( this ,AppWindow, OnTestTable));

	Show();
}

//------------------------------------------------------------------
AppWindow::~AppWindow()
{
	pApp->SetAppMenu();
}

//------------------------------------------------------------------

IMPL_LINK( AppWindow, OnFile, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_OPEN:
		{
			if (AppWindow::pConn)
			{
				AppWindow::pConn->Delete();
				AppWindow::pConn = NULL;
			}

			SQLDialog aDlg;
			aDlg.Execute();
		}break;
		case MID_CREATE:
		{
			if (AppWindow::pConn)
			{
				AppWindow::pConn->Delete();
				AppWindow::pConn = NULL;
			}
			CreateTableDialog aDlg;
			aDlg.Execute();
		}break;
		case MID_QUIT:
			Close();
			break;
	}
	return TRUE;
}


IMPL_LINK( AppWindow, OnTestTable, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_CONNECT:
		{
			if (AppWindow::pConn)
			{
				AppWindow::pConn->Delete();
				AppWindow::pConn = NULL;
			}
			SQLConnect aDlg;
			aDlg.Execute();
			if (AppWindow::pConn)
			{
				pMenu->EnableItem(MID_CREATETABLES, TRUE);
				pMenu->EnableItem(MID_FILL, TRUE);
				pMenu->EnableItem(MID_DROPTABLES, TRUE);
				pMenu->EnableItem(MID_CREATEDB, TRUE);
				pMenu->EnableItem(MID_DROPDB, TRUE);
				pMenu->EnableItem(MID_MOD, TRUE);
				pMenu->EnableItem(MID_DEL, TRUE);
			}
			else
			{
				pMenu->EnableItem(MID_CREATETABLES, FALSE);
				pMenu->EnableItem(MID_CREATEDB, FALSE);
				pMenu->EnableItem(MID_DROPDB, FALSE);
				pMenu->EnableItem(MID_FILL, FALSE);
				pMenu->EnableItem(MID_MOD, FALSE);
				pMenu->EnableItem(MID_DEL, FALSE);
				pMenu->EnableItem(MID_DROPTABLES, FALSE);
			}
		}break;
		case MID_CREATETABLES:
			CreateTables();
			break;
		case MID_FILL:
			FillTables();
			break;
		case MID_MOD:
			ModifyRows();
			break;
		case MID_DEL:
			DeleteRows();
			break;
		case MID_DROPTABLES:
			DropTables();
			break;
		case MID_CREATEDB:
		{
			SQLDatabase aDlg(TRUE);
			aDlg.Execute();
			break;
		}
		case MID_DROPDB:
		{
			SQLDatabase aDlg(FALSE);
			aDlg.Execute();
			break;
		}
	}
	return TRUE;
}


//------------------------------------------------------------------
void AppWindow::Activate()
{
	pApp->SetAppMenu( &aMenu );
}

BOOL AppWindow::Close()
{
	if (MDIApplication::CloseAll())
	{
		if (AppWindow::pConn)
		{
			AppWindow::pConn->Delete();
			AppWindow::pConn == NULL;
		}
		GetpApp()->Quit();
		return TRUE;
	}
	else
		return FALSE;
}

//==================================================================
BrowseWindow::BrowseWindow(SdbCursor& rCur)
			 :MDIWindow(GetpApp()->GetAppWindow(), WinBits(WB_CLOSEABLE) )
			 ,aBrowser( this, 0 , rCur)
			 ,eCurMode( 0 )
			 ,nNewRowNo( 2000L )
			 ,aBrowseMenu(ResId( MID_BROWSEBAR))

{
	SetText("Database Browsing");
	aBrowseMenu.GetPopupMenu(MID_FILE )->PushSelectHdl( LINK( this ,BrowseWindow, OnFile) );
	aBrowseMenu.GetPopupMenu( MID_TABLE_OP )->PushSelectHdl( LINK( GetParent() ,AppWindow, OnTestTable));

	aBrowser.Fill();

	Font aFont("MS Sans Serif",Size(0,8));
	aBrowser.SetFont(aFont);
	aFont.SetWeight(WEIGHT_BOLD);
	aBrowser.SetTitleFont(aFont);
	aBrowser.Show();
}

//------------------------------------------------------------------
BrowseWindow::~BrowseWindow()
{
	if (MDIApplication::GetVisibleWindowCount() == 1)
		GetpApp()->SetAppMenu(&((AppWindow *)GetParent())->aMenu);
}

void BrowseWindow::Activate()
{
	if (IsMDIActivate()) GetpApp()->SetAppMenu(&aBrowseMenu);
	aBrowser.GrabFocus();
}

//------------------------------------------------------------------
void BrowseWindow::Resize()
{
	Size aOutSz( GetOutputSizePixel() );
	aBrowser.SetPosSizePixel(
		Point(0,0),
		Size(aOutSz.Width(), aOutSz.Height()));
}

IMPL_LINK(BrowseWindow, OnFile, Menu *, pMenu )
{
	switch ( pMenu->GetCurItemId() )
	{
		case MID_CLOSE:
			Close();
			break;
		default:
			return ((AppWindow*)GetParent())->OnFile(pMenu);
	}
	return TRUE;
}

IMPL_LINK( BrowseWindow, OnTestTable, Menu *, pMenu )
{
	return ((AppWindow *)GetParent())->OnTestTable(pMenu);
}



//------------------------------------------------------------------
BrowseApp::BrowseApp()
		  :aFont("MS Sans Serif",Size(0,8))
{
}


void BrowseApp::Main( int, char *[] )
{
	EnableSVLook();
	SetAppFont(aFont);
	AppWindow aAppWin;

	Execute();
}

