/*************************************************************************
 *
 *  $RCSfile: sdbtestc.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SDB_SDBTESTC_HXX
#define SDB_SDBTESTC_HXX

#include <sv.hxx>
#include <sdb.hxx>

class SdbTestCommand
{
  protected:
	Edit & rOutputWindow;

  public:
	SdbTestCommand(Edit & rNewOutputWindow, const String & rCommand);
	virtual ~SdbTestCommand() {};

	virtual void Execute(const String & rCommand) = 0;

	// Zugriff auf das Ausgabefenster ueber folgende Routinen:
	void Clear();
	void Write(const String & rString);
	inline void Write(const UINT32 nValue);
	inline void Write(const INT32 nValue);

	void show_status(const char * title, const SdbStatus & s);
	void show_column(const char * title, const SdbColumn * c);
	void show_columns(const char * title, const SdbColumns * cs);
	void show_variable(const char * title, const SdbVariable * v);
	void show_row(const char * title, const SdbRowRef& aRow);
	void show_cursors(const char * title, const SdbConnection * conn1);
	void fetch_rows(const char * title, SdbCursor * curs1, const UINT32 nShowRows = 0xffffffff);
};

inline void SdbTestCommand::Write(const UINT32 nValue)
{
	Write(String(nValue));
}

inline void SdbTestCommand::Write(const INT32 nValue)
{
	Write(String(nValue));
}

#endif


