/*************************************************************************
 *
 *  $RCSfile: test1.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:49:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "test1.hxx"
#include "sdb.hxx"




SdbTest1::SdbTest1(Edit & r, const String & rCommand) : SdbTestCommand(r, rCommand)
{
}

SdbTest1::~SdbTest1()
{
}

void SdbTest1::Execute(const String & rCommand)
{
	String aResult;
	SdbSqlParser & rParser = SdbEnvironmentRef()->SqlParser();
	// wirf den Parser an
	SdbSqlParseNode * pSdbSqlParseTreeRoot = rParser.ParseTree(rCommand);



	if(pSdbSqlParseTreeRoot) {
		// kopier den Knoten
		// SdbSqlParseNode * pAnotherParseTreeRoot = new SdbSqlParseNode(*pSdbSqlParseTreeRoot);

		Write("Der Parse-Tree:\n");
		pSdbSqlParseTreeRoot->ShowParseTree(aResult);
		Write(aResult);
		Write("\n");
		aResult.Erase();

		Write("...und der aus dem Parse-Tree erzeugte String:\n");
		pSdbSqlParseTreeRoot->ParseNodeToStr(aResult);
		Write(aResult);
		Write("SQL parse worked\n");


		Write("\n");
		Write("\n");
		Write("\n");
		aResult.Erase();

		// trenne dich vom ParseTree
		delete pSdbSqlParseTreeRoot;

		Write ("den urspruenglichen Baum geloescht ...\n");
		// Write ("... und hier nun die Kopie\n");
		// pAnotherParseTreeRoot->ShowParseTree(aResult);
		// Write (aResult);

		// Write("\n");
		// Write("\n");
		// if (*pSdbSqlParseTreeRoot == *pAnotherParseTreeRoot) {
		//	Write("Beide Baeume gleich!\n");
		// };



		// und trenne dich von der Kopie
		// delete pAnotherParseTreeRoot;

	}
	else
		Write("SQL parse failed\n");

	aResult.Erase();
}
