/*************************************************************************
 *
 *  $RCSfile: instmode.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SETUP_INSTMODE_HXX
#define _SETUP_INSTMODE_HXX

// include ---------------------------------------------------------------



#ifndef NOOLDSV //autogen
#include <vcl/icon.hxx>
#endif

#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

// class SetupInstallModeDialog ------------------------------------------

class SetupInstallModeDialog : public ModelessDialog
{
private:
#ifndef VCL
	FixedIcon       m_a1Icon;
#endif

	FixedText       m_a2Text;
	FixedText       m_a3Text;

	ImageButton     m_aMaxiButton;
	FixedText       m_aMaximalText;
	FixedText       m_aMaxi1Text;
	FixedText       m_aMaxi2Text;

	ImageButton     m_aUserButton;
	FixedText       m_aUserText;
	FixedText       m_aUser1Text;
	FixedText       m_aUser2Text;
	FixedText       m_aUser3Text;

	ImageButton     m_aMiniButton;
	FixedText       m_aMinimalText;
	FixedText       m_aMini1Text;
	FixedText       m_aMini2Text;
	FixedText       m_aMini3Text;

	ImageButton     m_aWorkstationButton;
	FixedText       m_aWorkstationText;
	FixedText       m_aWork1Text;
	FixedText       m_aWork2Text;
	FixedText       m_aWork3Text;

	DECL_LINK( MaxiHdl, Button * );
	DECL_LINK( UserHdl, Button * );
	DECL_LINK( MiniHdl, Button * );
	DECL_LINK( WorkstationHdl,  Button * );

protected:
	virtual void KeyInput(KeyEvent const&);
	virtual BOOL Close();

public:

	SetupInstallModeDialog
	(
		Window		* pParent,
		ByteString const& aProgramName,
		BOOL		  bUserInst,
		BOOL		  bMinimalInst,
		BOOL		  bWorkstationInst,
		ULONG		  nMinimalSize,
		ULONG		  nDefaultSize,
		ULONG		  nWorkstationSize,
		ULONG		  nTempSize,
		ULONG		  nTempSizeMini
	);
};

#endif
