/*************************************************************************
 *
 *  $RCSfile: nunxos.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <utime.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statvfs.h>

#include "svunzip.h"

#ifndef _NUNXOS_HXX
#include "nunxos.hxx"
#endif

// ============================================================================
// ============================================================================
// ============================================================================

UnxOS::UnxOS( int argc, char* argv[] )
{
}

//DONE
int UnxOS::Startup( int argc, char* argv[] )
{
	return 0;
}

//DONE
void UnxOS::Terminate()
{
}

//DONE
void UnxOS::GetSVersion( char* buf, int len )
{
	strcpy( buf, getenv("HOME") );
	strcat( buf, "/.sversionrc" );
}

//DONE
BOOL UnxOS::makeDir( char* path, int rights )
{
	mode_t  mode;
	int     right;

	// rights z.B. 644
	right = rights / 100;
	rights %= 100;
	if ( right == 7 )
	{
		mode = S_IRWXU;
	}
	else if ( right == 6 )
	{
		mode = S_IRUSR | S_IWUSR;
	}
	else if ( right == 5 )
	{
		mode = S_IRUSR | S_IXUSR;
	}
	else if ( right == 4 )
	{
		mode = S_IRUSR;
	}
	else if ( right == 3 )
	{
		mode = S_IWUSR | S_IXUSR;
	}
	else if ( right == 2 )
	{
		mode = S_IWUSR;
	}
	else if ( right == 1 )
	{
		mode = S_IXUSR;
	}
	right = rights / 10;
	rights %= 10;
	if ( right == 7 )
	{
		mode |= S_IRWXG;
	}
	else if ( right == 6 )
	{
		mode |= S_IRGRP | S_IWGRP;
	}
	else if ( right == 5 )
	{
		mode |= S_IRGRP | S_IXGRP;
	}
	else if ( right == 4 )
	{
		mode |= S_IRGRP;
	}
	else if ( right == 3 )
	{
		mode |= S_IWGRP | S_IXGRP;
	}
	else if ( right == 2 )
	{
		mode |= S_IWGRP;
	}
	else if ( right == 1 )
	{
		mode |= S_IXGRP;
	}
	right = rights;
	if ( right == 7 )
	{
		mode |= S_IRWXO;
	}
	else if ( right == 6 )
	{
		mode |= S_IROTH | S_IWOTH;
	}
	else if ( right == 5 )
	{
		mode |= S_IROTH | S_IXOTH;
	}
	else if ( right == 4 )
	{
		mode |= S_IROTH;
	}
	else if ( right == 3 )
	{
		mode |= S_IWOTH | S_IXOTH;
	}
	else if ( right == 2 )
	{
		mode |= S_IWOTH;
	}
	else if ( right == 1 )
	{
		mode |= S_IXOTH;
	}

	return mkdir( path, mode ) == 0 ? TRUE : FALSE;
}

//DONE
BOOL UnxOS::removeDir( char* path )
{
	return rmdir( path ) == 0 ? TRUE : FALSE;
}

//DONE
BOOL UnxOS::deleteFile(char* path, char* pattern)
{
	DIR*  dirp = opendir( path );
	struct dirent *dp = NULL;
	char   file[1024];

	if ( strcmp( pattern, "*" ) != 0 )
	{
		sprintf(file, "%s/%s", path, pattern);
		if ( access( file, F_OK ) == 0 )
		{
			unlink(file);
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	while ( ( dp = readdir( dirp ) ) != NULL )
	{
		sprintf(file, "%s/%s", path, dp->d_name);
		unlink(file);
	}
	closedir(dirp);
	return TRUE;
}

BOOL UnxOS::copyFile(char* source, char* destination)
{
	FILE*  file1 = fopen( source, "rb" );
	FILE*  file2 = fopen( destination, "wb" );
	char   buf[1024];
	int    num = 0;

	if ( ( file1 != NULL) && ( file2 != NULL ) )
	{
		while ( ( num = fread( buf, sizeof( char ), 1024, file1 ) ) > 0 )
		{
			fwrite( buf, sizeof( char ), num, file2 );
		}
		fclose( file1 );
		fclose( file2 );
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

BOOL UnxOS::unzipFile(char* source, char* pattern, char* destination)
{
/*    if( chdir(destination) == -1 ) return FALSE;
    ::SVUnzip( source, pattern, (const char*)"qq", NULL );
*/
	return TRUE;
}

//DONE
void UnxOS::setDateTime(char* filename, int hour, int min, int sec, int day, int month, int year )
{
	time_t  t;
	struct tm times, *t1, *t2;

	t1 = localtime( &t ); // get time adjusted to local timezone and daylightsavings
	t2 = gmtime( &t );	  // get the internal time
	times.tm_year = year  - 1900 + t2->tm_year - t1->tm_year;  	// 1997 -> 97
	times.tm_mon  = month - 1 + t2->tm_mon - t1->tm_mon;		// 0=Januar!
	times.tm_mday = day + t2->tm_mday - t1->tm_mday;

	times.tm_hour = hour + t2->tm_hour - t1->tm_hour;
	times.tm_min  = min + t2->tm_min - t1->tm_min;
	times.tm_sec  = 0;

	times.tm_wday  = 0;
	times.tm_yday  = 0;
	times.tm_isdst = 0;

	time_t time = mktime (&times);
	if (time != (time_t) -1)
	{
		struct utimbuf u_time;
		u_time.actime = time;
		u_time.modtime = time;
		utime (filename, &u_time);
	}
}

void UnxOS::setRights(char* filename, int rights)
{
	int nOctal = 0;
	int nRights = rights;

	nOctal 	 = nRights / 100;
	nRights %= 100;

	nOctal  *= 8;
	nOctal  += nRights / 10;
	nRights %= 10;

	nOctal  *= 8;
	nOctal  += nRights;

	chmod( filename, nOctal );
}

//DONE
unsigned long UnxOS::GetFreeDriveSize( char* _cDrive )
{
	struct statvfs buf;
	char*  pDir = _cDrive;

	while (( pDir != NULL) && ( statvfs (pDir, &buf) == -1 ) )
	{
		char*  pPart = strrchr(pDir, '/');

		if ( pPart == NULL )
			pDir = NULL;
		else
			pDir[strlen( pDir ) - strlen( pPart )] = '\0';
	}
	if ( pDir == NULL )
		return 0;
#ifdef LINUX
	const unsigned long nSize = buf.f_bsize;
#else
	const unsigned long nSize = (buf.f_frsize ? buf.f_frsize : buf.f_bsize);
#endif

	return (nSize < 1024 ? buf.f_bavail / (1024 / nSize)
		: nSize > 1024 ? buf.f_bavail * (nSize / 1024)
		: buf.f_bavail);
}

//DONE
unsigned long UnxOS::GetClusterSize( char* _cDrive )
{
	struct statvfs buf;
	char*  pDir = _cDrive;

	while (( pDir != NULL) && ( statvfs (pDir, &buf) == -1 ) )
	{
		char*  pPart = strrchr(pDir, '/');

		if ( pPart == NULL )
			pDir = NULL;
		else
			pDir[strlen( pDir ) - strlen( pPart )] = '\0';
	}
	if ( pDir == NULL )
		return 0;

#ifdef LINUX
	return buf.f_bsize;
#else
	return (buf.f_frsize ? buf.f_frsize : buf.f_bsize);
#endif
}

//DONE
void UnxOS::getNSPluginDir(char* buf)
{
	const char* pEnv = getenv( "HOME" );
	if( pEnv )
	{
		strcat( buf, pEnv );
		strcat( buf, "/.netscape/plugins" );

		if ( access( buf, F_OK ) != 0 )
		{	// create the directory
			makeDir( buf, 755 );
		}
		return;
	}

	pEnv = getenv( "NPX_PLUGIN_PATH" );
	if( pEnv )
	{
		strcpy( buf, pEnv );
		if ( access( buf, F_OK ) == 0 )
		{
			return;
		}
	}

	strcpy( buf, "/usr/lib/netscape/plugins" );
	if ( access( buf, F_OK ) == 0 )
	{
		return;
	}
	// plugin directory not found
	strcpy( buf, "" );
	return;
}

//DONE
void UnxOS::getOSDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getOSSystemDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getOSsystemFontDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getHomeDir(char* buf)
{
	strcpy( buf, getenv("HOME") );
}

//DONE
void UnxOS::getConfigDir(char* buf)
{
	strcpy( buf, getenv("HOME") );
}

//DONE
void UnxOS::getServiceDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getOSShellnewDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getAutoStart(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getOSDesktopDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getBookmarkDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getPersonalDir(char* buf)
{
	strcpy( buf, "" );
}

//DONE
void UnxOS::getIEPluginDir(char* buf, BOOL bPlugin )
{
	return;
}

void UnxOS::getIEDir(char* buf)
{
	return;
}

//DONE
void UnxOS::createProgramFolder(char* name, BOOL user)
{
	return;
}

//DONE
void UnxOS::createProgramFolderItem(char* foldername, char* itemname, char* destpath, char* destexec, char* param, BOOL user )
{
	return;
}

//DONE
void UnxOS::removeProgramFolder(char* name, BOOL user)
{
	return;
}

//DONE
void UnxOS::removeProgramFolderItem(char* foldername, char* itemname, BOOL user)
{
	return;
}

//DONE
void UnxOS::winRegistry(char* key, char* subkey, char* name, char* value, BOOL create, BOOL hex, BOOL deleteall, BOOL expand, BOOL bKeyOnly )
{
	return;
}

//DONE
void UnxOS::addFont(char* fontfile, char* fontname )
{
	return;
}

//DONE
void UnxOS::removeFont(char* fontfile, char* fontname )
{
	return;
}
