/*************************************************************************
 *
 *  $RCSfile: profile.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _PROFILE_HXX
#define _PROFILE_HXX

typedef void*				oslProfile;
typedef unsigned long		oslProfileOption;

#define	osl_Profile_DEFAULT     0x0000
#define	osl_Profile_SYSTEM      0x0001
#define	osl_Profile_READLOCK    0x0002
#define	osl_Profile_WRITELOCK   0x0004
#define	osl_Profile_FLUSHWRITE  0x0010

extern oslProfile		osl_openProfile(char *pszProfileName, oslProfileOption Options);

extern BOOL				osl_closeProfile(oslProfile Profile);

extern BOOL				osl_readProfileString(oslProfile Profile,
							const char* pszSection, const char* pszEntry,
							char* pszString, unsigned long MaxLen, const char* pszDefault);

extern BOOL				osl_writeProfileString(oslProfile Profile,
                    		const char* pszSection, const char* pszEntry, const char* pszString);

extern BOOL				osl_removeProfileEntry(oslProfile Profile,
							const char *pszSection, const char *pszEntry);

extern unsigned long	getSectionCount(oslProfile Profile);

#endif // _PROFILE_HXX
