/*************************************************************************
 *
 *  $RCSfile: aservdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXSTYLE_HXX
#include <svtools/style.hxx>
#endif

#pragma hdrstop

#include "aservdlg.hrc"
#include "aservdlg.hxx"

//------------------------------------------------------------------------

ServerSetupDialog::ServerSetupDialog( Window* pParent, ResMgr* pResMgr ):
	ModalDialog			(pParent,	ResId(DLG_APPSERV,		pResMgr)),
	maOK				(this,		ResId(BT_OK,			pResMgr)),
	maCancel			(this,		ResId(BT_CANCEL,		pResMgr)),
//	maHelp				(this,		ResId(BT_HELP,			pResMgr)),

	maPortalBox			(this,		ResId(ED_PORTAL,		pResMgr)),
	maPortalAdminBox	(this,		ResId(ED_PORTALADMIN,	pResMgr)),
	maShutdownBox		(this,		ResId(ED_SHUTDOWN,		pResMgr)),
	maSetupServerBox	(this,		ResId(ED_SETUPSERVER,	pResMgr)),
	maLBMBox			(this,		ResId(ED_LBM,			pResMgr)),
	maLBShttpBox		(this,		ResId(ED_LBSHTTP,		pResMgr)),
	maLBShttpsBox		(this,		ResId(ED_LBSHTTPS,		pResMgr)),
	maLBSShutdownBox	(this,		ResId(ED_LBSSHUTDOWN,	pResMgr)),
	maLBSunoBox			(this,		ResId(ED_LBSUNO,		pResMgr)),
	maLBSunoCompBox		(this,		ResId(ED_LBSUNOCOMP,	pResMgr)),
	maLBSunoTLSBox		(this,		ResId(ED_LBSUNOTLS,		pResMgr)),
	maLBSunoCompTLSBox	(this,		ResId(ED_LBSUNOCOMPTLS,	pResMgr)),
	maSPdaemonBox		(this,		ResId(ED_SPDAEMON,		pResMgr)),
	maConfigServerBox	(this,		ResId(ED_CONFSERVER,	pResMgr)),

	maPortalLabel		(this,		ResId(FT_PORTAL,		pResMgr)),
	maPortalAdminLabel	(this,		ResId(FT_PORTALADMIN,	pResMgr)),
	maSetupServerLabel	(this,		ResId(FT_SETUPSERVER,	pResMgr)),
	maShutdownLabel		(this,		ResId(FT_SHUTDOWN,		pResMgr)),
	maLBMLabel			(this,		ResId(FT_LBM,			pResMgr)),
	maLBShttpLabel		(this,		ResId(FT_LBSHTTP,		pResMgr)),
	maLBShttpsLabel		(this,		ResId(FT_LBSHTTPS,		pResMgr)),
	maLBSShutdownLabel	(this,		ResId(FT_LBSSHUTDOWN,	pResMgr)),
	maLBSunoLabel		(this,		ResId(FT_LBSUNO,		pResMgr)),
	maLBSunoCompLabel	(this,		ResId(FT_LBSUNOCOMP,	pResMgr)),
	maLBSunoTLSLabel	(this,		ResId(FT_LBSUNOTLS,		pResMgr)),
	maLBSunoCompTLSLabel(this,		ResId(FT_LBSUNOCOMPTLS,	pResMgr)),
	maSPdaemonLabel		(this,		ResId(FT_SPDAEMON,		pResMgr)),
	maConfigServerLabel	(this,		ResId(FT_CONFSERVER,	pResMgr))
//	maInstall			(this,		ResId(CB_INSTALL,		pResMgr))
//	maStart				(this,		ResId(CB_START,			pResMgr))
{
	FreeResource();
	
	disableDots(maPortalBox);
	disableDots(maPortalAdminBox);
	disableDots(maSetupServerBox);
	disableDots(maShutdownBox);
	disableDots(maLBMBox);
	disableDots(maLBShttpBox);
	disableDots(maLBShttpsBox);
	disableDots(maLBSShutdownBox);
	disableDots(maLBSunoBox);
	disableDots(maLBSunoCompBox);
	disableDots(maLBSunoTLSBox);
	disableDots(maLBSunoCompTLSBox);
	disableDots(maSPdaemonBox);
	disableDots(maConfigServerBox);
}

ServerSetupDialog::~ServerSetupDialog()
{
}

void	ServerSetupDialog::grayPortal( BOOL bGray )			{grayNumericField(bGray, maPortalBox);}
void	ServerSetupDialog::setPortal( String aPort )		{maPortalBox.SetText( aPort );}
String	ServerSetupDialog::getPortal()						{return maPortalBox.GetText();}

void	ServerSetupDialog::grayPortalAdmin( BOOL bGray )	{grayNumericField(bGray, maPortalAdminBox);}
void	ServerSetupDialog::setPortalAdmin( String aPort )	{maPortalAdminBox.SetText( aPort );}
String	ServerSetupDialog::getPortalAdmin()					{return maPortalAdminBox.GetText();}

void	ServerSetupDialog::graySetupServer( BOOL bGray )	{grayNumericField(bGray, maSetupServerBox);}
void	ServerSetupDialog::setSetupServer( String aPort )	{maSetupServerBox.SetText( aPort );}
String	ServerSetupDialog::getSetupServer()					{return maSetupServerBox.GetText();}

void	ServerSetupDialog::grayShutdown( BOOL bGray )		{grayNumericField(bGray, maShutdownBox);}
void	ServerSetupDialog::setShutdown( String aPort )		{maShutdownBox.SetText( aPort );}
String	ServerSetupDialog::getShutdown()					{return maShutdownBox.GetText();}

void	ServerSetupDialog::grayLBM( BOOL bGray )			{grayNumericField(bGray, maLBMBox);}
void	ServerSetupDialog::setLBM( String aPort )			{maLBMBox.SetText( aPort );}
String	ServerSetupDialog::getLBM()							{return maLBMBox.GetText();}

void	ServerSetupDialog::grayLBShttp( BOOL bGray )		{grayNumericField(bGray, maLBShttpBox);}
void	ServerSetupDialog::setLBShttp( String aPort )		{maLBShttpBox.SetText( aPort );}
String	ServerSetupDialog::getLBShttp()						{return maLBShttpBox.GetText();}

void	ServerSetupDialog::grayLBShttps( BOOL bGray )		{grayNumericField(bGray, maLBShttpsBox);}
void	ServerSetupDialog::setLBShttps( String aPort )		{maLBShttpsBox.SetText( aPort );}
String	ServerSetupDialog::getLBShttps()					{return maLBShttpsBox.GetText();}

void	ServerSetupDialog::grayLBSShutdown( BOOL bGray )	{grayNumericField(bGray, maLBSShutdownBox);}
void	ServerSetupDialog::setLBSShutdown( String aPort )	{maLBSShutdownBox.SetText( aPort );}
String	ServerSetupDialog::getLBSShutdown()					{return maLBSShutdownBox.GetText();}

void	ServerSetupDialog::grayLBSuno( BOOL bGray )			{grayNumericField(bGray, maLBSunoBox);}
void	ServerSetupDialog::setLBSuno( String aPort )		{maLBSunoBox.SetText( aPort );}
String	ServerSetupDialog::getLBSuno()						{return maLBSunoBox.GetText();}

void	ServerSetupDialog::grayLBSunoComp( BOOL bGray )		{grayNumericField(bGray, maLBSunoCompBox);}
void	ServerSetupDialog::setLBSunoComp( String aPort )	{maLBSunoCompBox.SetText( aPort );}
String	ServerSetupDialog::getLBSunoComp()					{return maLBSunoCompBox.GetText();}

void	ServerSetupDialog::grayLBSunoTLS( BOOL bGray )		{grayNumericField(bGray, maLBSunoTLSBox);}
void	ServerSetupDialog::setLBSunoTLS( String aPort )		{maLBSunoTLSBox.SetText( aPort );}
String	ServerSetupDialog::getLBSunoTLS()					{return maLBSunoTLSBox.GetText();}

void	ServerSetupDialog::grayLBSunoCompTLS( BOOL bGray )	{grayNumericField(bGray, maLBSunoCompTLSBox);}
void	ServerSetupDialog::setLBSunoCompTLS( String aPort )	{maLBSunoCompTLSBox.SetText( aPort );}
String	ServerSetupDialog::getLBSunoCompTLS()				{return maLBSunoCompTLSBox.GetText();}

void	ServerSetupDialog::graySPdaemon( BOOL bGray )		{grayNumericField(bGray, maSPdaemonBox);}
void	ServerSetupDialog::setSPdaemon( String aPort )		{maSPdaemonBox.SetText( aPort );}
String	ServerSetupDialog::getSPdaemon()					{return maSPdaemonBox.GetText();}

void	ServerSetupDialog::grayConfigServer( BOOL bGray )	{grayNumericField(bGray, maConfigServerBox);}
void	ServerSetupDialog::setConfigServer( String aPort )	{maConfigServerBox.SetText( aPort );}
String	ServerSetupDialog::getConfigServer()				{return maConfigServerBox.GetText();}

/*
void	ServerSetupDialog::grayInstall( BOOL bGray )		{maInstall.Enable( !bGray );}
void	ServerSetupDialog::setInstall( BOOL bEnable )		{maInstall.Check( bEnable );}
BOOL	ServerSetupDialog::getInstall()						{return maInstall.IsChecked();}
*/             

/*
void	ServerSetupDialog::grayStart( BOOL bGray )			{maStart.Enable( !bGray );}
void	ServerSetupDialog::setStart( BOOL bEnable )			{maStart.Check( bEnable );}
BOOL	ServerSetupDialog::getStart()						{return maStart.IsChecked();}
*/

void	ServerSetupDialog::grayNumericField(BOOL bGray, NumericField & aField)
{
	if (bGray)
	{
		aField.Enable( FALSE );
		aField.SetControlBackground(Color(COL_LIGHTGRAY));
	}
}

void	ServerSetupDialog::disableDots(NumericField & aField)
{
	International aInter = aField.GetInternational();
	aInter.EnableNumThousandSep(FALSE);
	aField.SetInternational(aInter);
}

short	ServerSetupDialog::execute()
{
	return ModalDialog::Execute();
}

//------------------------------------------------------------------------

ServerSetupLoginDialog::ServerSetupLoginDialog( Window* pParent, ResMgr* pResMgr ):
	ModalDialog			(pParent,	ResId( DLG_LOGIN, pResMgr )),
	maOK				(this,		ResId(BT_OK2, pResMgr) ),
	maCancel			(this,		ResId(BT_CANCEL2, pResMgr) ),
	maDescription		(this,		ResId(FT_DESC, pResMgr)),
	maNameBox			(this,		ResId(ED_NAME, pResMgr)),
	maPasswordBox		(this,		ResId(ED_PASSWORD, pResMgr)),
	maNameLabel			(this,		ResId(FT_NAME, pResMgr)),
	maPasswordLabel		(this,		ResId(FT_PASSWORD, pResMgr))
{
}

ServerSetupLoginDialog::~ServerSetupLoginDialog()
{
	FreeResource();
}

short ServerSetupLoginDialog::execute()
{
	Enable();
	ToTop(); // for Windows 2000
	GrabFocusToFirstControl();

	return ModalDialog::Execute();
}

String ServerSetupLoginDialog::getName()
{
	return maNameBox.GetText();
}

String ServerSetupLoginDialog::getPassword()
{
	return maPasswordBox.GetText();
}

void ServerSetupLoginDialog::clearPassword()
{
	maPasswordBox.SetText( UniString::CreateFromAscii( "" ) );
}

//------------------------------------------------------------------------

ServerSetupInfoWindow::ServerSetupInfoWindow( ResMgr* pResMgr ) :
	WorkWindow( NULL, ResId( WIN_INFO, pResMgr ) ),
	aInfoFT( this, ResId( FT_INFO ) )
{
	m_pRscMgr = pResMgr;

	WinBits aStyle = aInfoFT.GetStyle();
	aStyle &= ~WB_TOP;
	aStyle |= WB_VCENTER;
	aStyle |= WB_CENTER;
	aStyle |= WB_WORDBREAK;
	aInfoFT.SetStyle(aStyle);

	FreeResource();
	
	Hide();
};

ServerSetupInfoWindow::~ServerSetupInfoWindow()
{
	Hide();
	Flush();
};

void ServerSetupInfoWindow::execute()
{
	Enable();
	Show();
	Update();
	ToTop();	// for Windows 2000
}

void ServerSetupInfoWindow::changeInfo(const InfoTextDescriptor aInfoTextDescriptor )
{
	USHORT nInfoResId = 0;

	switch (aInfoTextDescriptor)
	{
		case InfoTextDescriptor_PORTS:			nInfoResId = STR_PORTS;			break;
		case InfoTextDescriptor_WRITEPROPS:		nInfoResId = STR_WRITEPROPS;	break;
		case InfoTextDescriptor_INSTALLDAEMONS:	nInfoResId = STR_INSTALLDAEMONS;break;
		case InfoTextDescriptor_STARTDAEMONS:	nInfoResId = STR_STARTDAEMONS;	break;
		default:								nInfoResId = STR_EMPTY;			break;
	}

	aInfoFT.SetText( String(ResId(nInfoResId, m_pRscMgr)) );
	Update();
	Flush();
};

