/*************************************************************************
 *
 *  $RCSfile: aservdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _ASERVDLG_HXX
#define _ASERVDLG_HXX

#include <vcl/button.hxx>
#include <vcl/dialog.hxx>
#include <vcl/fixed.hxx>
#include <vcl/edit.hxx>
#include <vcl/field.hxx>
#include <vcl/wrkwin.hxx>

enum InfoTextDescriptor
{
	InfoTextDescriptor_PORTS			= 0,
	InfoTextDescriptor_WRITEPROPS		= 1,
	InfoTextDescriptor_INSTALLDAEMONS	= 2,
	InfoTextDescriptor_STARTDAEMONS		= 3
};

class ServerSetupDialog : public ModalDialog
{
	public:
				ServerSetupDialog( Window* pParent, ResMgr* pResMgr );
				~ServerSetupDialog();

		virtual short execute	();

		void	grayPortal		( BOOL bGray );
		void	setPortal		( String aPort );
		String	getPortal		();

		void	grayPortalAdmin	( BOOL bGray );
		void	setPortalAdmin	( String aPort );
		String	getPortalAdmin	();

		void	graySetupServer	( BOOL bGray );
		void	setSetupServer	( String aPort );
		String	getSetupServer	();

		void	grayShutdown	( BOOL bGray );
		void	setShutdown		( String aPort );
		String	getShutdown		();

		void	grayLBM			( BOOL bGray );
		void	setLBM			( String aPort );
		String	getLBM			();

		void	grayLBShttp		( BOOL bGray );
		void	setLBShttp		( String aPort );
		String	getLBShttp		();

		void	grayLBShttps	( BOOL bGray );
		void	setLBShttps		( String aPort );
		String	getLBShttps		();

		void	grayLBSShutdown	( BOOL bGray );
		void	setLBSShutdown	( String aPort );
		String	getLBSShutdown	();

		void	grayLBSuno		( BOOL bGray );
		void	setLBSuno		( String aPort );
		String	getLBSuno		();

		void	grayLBSunoComp	( BOOL bGray );
		void	setLBSunoComp	( String aPort );
		String	getLBSunoComp	();

		void	grayLBSunoTLS	( BOOL bGray );
		void	setLBSunoTLS	( String aPort );
		String	getLBSunoTLS	();

		void	grayLBSunoCompTLS( BOOL bGray );
		void	setLBSunoCompTLS( String aPort );
		String	getLBSunoCompTLS();

		void	graySPdaemon	( BOOL bGray );
		void	setSPdaemon		( String aPort );
		String	getSPdaemon		();

		void	grayConfigServer( BOOL bGray );
		void	setConfigServer	( String aPort );
		String	getConfigServer	();
/*
		void	grayInstall		( BOOL bGray );
		void	setInstall		( BOOL bEnable );
		BOOL	getInstall		();
*/		
/*
		void	grayStart		( BOOL bGray );
		void	setStart		( BOOL bEnable );
		BOOL	getStart		();
*/


	private:
		void	disableDots		( NumericField & aField);
		void	grayNumericField( BOOL bGray,
								  NumericField & aField);
		OKButton		maOK;
		CancelButton	maCancel;
//		PushButton		maHelp;
		NumericField	maPortalBox;
		NumericField	maPortalAdminBox;
		NumericField	maShutdownBox;
		NumericField	maSetupServerBox;
		NumericField	maLBMBox;
		NumericField	maLBShttpBox;
		NumericField	maLBShttpsBox;
		NumericField	maLBSShutdownBox;
		NumericField	maLBSunoBox;
		NumericField	maLBSunoCompBox;
		NumericField	maLBSunoTLSBox;
		NumericField	maLBSunoCompTLSBox;
		NumericField	maSPdaemonBox;
		NumericField	maConfigServerBox;

		FixedText		maPortalLabel;
		FixedText		maPortalAdminLabel;
		FixedText		maShutdownLabel;
		FixedText		maSetupServerLabel;
		FixedText		maLBMLabel;
		FixedText		maLBShttpLabel;
		FixedText		maLBShttpsLabel;
		FixedText		maLBSShutdownLabel;
		FixedText		maLBSunoLabel;
		FixedText		maLBSunoCompLabel;
		FixedText		maLBSunoTLSLabel;
		FixedText		maLBSunoCompTLSLabel;
		FixedText		maSPdaemonLabel;
		FixedText		maConfigServerLabel;

//		CheckBox		maInstall;
//		CheckBox		maStart;
};

class ServerSetupLoginDialog : public ModalDialog
{
	public:
						ServerSetupLoginDialog( Window* pParent, ResMgr* pResMgr );
						~ServerSetupLoginDialog();

		virtual short	execute();

		String			getName();
		String			getPassword();
		void			clearPassword();

	private:
		OKButton		maOK;
		CancelButton	maCancel;
		FixedText		maDescription;
		Edit			maNameBox;
		Edit			maPasswordBox;
		FixedText		maNameLabel;
		FixedText		maPasswordLabel;
};

class ServerSetupInfoWindow : public WorkWindow
{
	public:
						ServerSetupInfoWindow	( ResMgr* pResMgr );
		virtual 		~ServerSetupInfoWindow	();
		virtual void	changeInfo				(const InfoTextDescriptor	aInfoTextDescriptor);
		virtual void	execute					();

	private:
		FixedText	aInfoFT;
		ResMgr*		m_pRscMgr;
};


#endif
