/*************************************************************************
 *
 *  $RCSfile: jvmscan.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef JVM_SCAN_HXX
#define JVM_SCAN_HXX

#if STLPORT_VERSION < 321
#include <tools/presys.h>
#include <hash_map.h>
#include <tools/postsys.h>
#else
//#include <stl/hash_map>
#endif

#include <stl/vector>
#include <stl/hash_map>
#include <cstdarg>			// std::va_list and friends

#ifndef _VOS_MACROS_HXX_
#include <vos/macros.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef _RTL_STRING_HXX_
#include <rtl/string.hxx>
#endif

#ifdef UNX
#define PATH_DELIMITER "/"
#else
#define PATH_DELIMITER "\\"
#endif

#define INSTALLATION_PACKAGE			"InstallationPackage"
#define PACKAGE_INSTALL_DIR				"PackageInstallationDirectory"
#define INSTALLATION_PATH				"InstallationPath"
#define REQUIRED_VERSION				"RequiredVersion"
#define VERIFIED_VERSION				"VerifiedVersion"
#define EXCLUDE_VERSION					"ExcludeVersion"
#define ADDITIONAL_SEARCH_PATH			"AdditionalSearchPath"
#define VENDOR							"Vendor"
#define VERSION							"Version"
#define VM_TYPE                         "VMType"
#define JRE_TYPE                        "jre"
#define JDK_TYPE                        "jdk"
#define ADDITIONAL_CLASSPATH			"AdditionalClasspath"
#define CLASSDIR						"<OFFICE_CLASSDIR>"

#define PGP_MODULE_ID					"gid_Module_Optional_Pgp_Unix"



// Hashtable fuer die Suche nach Namen
struct hashName_Impl
{
	size_t operator()(const ByteString & aStr) const
	{
		rtl::OString aTmpStr( aStr );
		return (size_t) aTmpStr.hashCode();
	}
};

struct eqName_Impl
{
	bool operator()( const ByteString& aStr1, const ByteString&  aStr2 ) const
	{
		return (aStr1 == aStr2)? TRUE : FALSE;
	}
};


//typedef hash_map< ByteString, ByteString, hashName_Impl, eqName_Impl > STRING_STRING_HashMap;
typedef NAMESPACE_STD( hash_map )
<
	ByteString,
	ByteString,
	hashName_Impl,
	eqName_Impl
> STRING_STRING_HashMap;
typedef STRING_STRING_HashMap JavaInstProps;

extern JavaInstProps aJavaInstProps;

struct JVMEntry
{
	ByteString	mVendor;
	ByteString	mName;
	ByteString	mVersion;
	ByteString	mHome;
	ByteString	mRuntimeLib;
	ByteString	mClasspath;
	ByteString  mLibPath;
	ByteString  mJVMType;
	ByteString  mEnvType;
	BOOL		bIsVerified;
	BOOL		bIsBestVersion;
};

extern USHORT	GetJavaVirtualMachine( JVMEntry * pJVM );
extern BOOL		GetInstalledVM( JVMEntry& entry, const ByteString destPath );
extern BOOL		CheckJava( JVMEntry& entry );

#endif

