/*************************************************************************
 *
 *  $RCSfile: jvmapp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SISYS_HXX
#include <sifsys.hxx>
#endif

#ifndef _TOOLS_INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _TOOLS_RESMGR_HXX
#include <tools/resmgr.hxx>
#endif

#ifndef _TOOLS_RC_HXX
#include <tools/rc.hxx>
#endif

#include <vcl/svapp.hxx>
#include "sicustom.hxx"
#include <vos/profile.hxx>

#ifndef _OSL_FILE_HXX_ 
#include <osl/file.hxx>
#endif

#ifdef UNX
#include <unistd.h>
#include <limits.h>
#define _MAX_PATH PATH_MAX
#endif

#include <stdio.h>
extern "C"
{
	BOOL _SV_CALL CustomInit( SiSetupFnc* pSetupFunction, SiCustomFnc* pCustomFunction );
};

/*************************************************************************/

#ifdef _USE_NAMESPACE
using namespace vos;
using namespace rtl;
#endif

/*************************************************************************/


/*************************************************************************/

class SetUpPlugInAppl: public Application
{
  public:

	void Main ();
};


class MySiCustomEnvironment: public SiCustomEnvironment
{
public:
	MySiCustomEnvironment(const ByteString& srcpath, const ByteString& destpath);
};


MySiCustomEnvironment::MySiCustomEnvironment(const ByteString& srcpath, const ByteString& destpath)
{
	SetResponse( FALSE );

	SetStartPath( srcpath );
	SetSourcePath( srcpath );
	
	rtl::OUString aOfficeIni;
	rtl::OUString tmpStr;
	
	vos::OProfile::getProfileName( tmpStr, 
				   OUString(RTL_CONSTASCII_USTRINGPARAM("soffice")), 
				   OUString(RTL_CONSTASCII_USTRINGPARAM(STAROFFICE_SVERSION_KEY)) );

	::osl::File::getSystemPathFromNormalizedPath( tmpStr, aOfficeIni );
#ifdef UNX
	const char* searchChar = "/";
#else
	const char* searchChar = "\\";
#endif
	ByteString aFileName = OUStringToOString( aOfficeIni, osl_getThreadTextEncoding() );

	USHORT nStartIndex;
	nStartIndex	= aFileName.SearchCharBackward( searchChar );
	nStartIndex = aFileName.SearchCharBackward( searchChar, nStartIndex );
	ByteString aOfficeHome = aFileName.Erase(nStartIndex, aFileName.Len() - nStartIndex);

	SetInstalledPath( aOfficeHome );
	SetDestPath( destpath );

	OProfile aIniFile( tmpStr );
	
	char buf[10];

	// set resouce manager
	LanguageType nLangType = LANGUAGE_ENGLISH;

	if ( aIniFile.readString("User", "Language", buf, 10, "") )
		nLangType = (LanguageType) atoi(buf);

	International aIntn( nLangType, LANGUAGE_SYSTEM );
	Application::SetAppInternational( aIntn );
}

/*************************************************************************/

SetUpPlugInAppl theApplication;

/*************************************************************************/

void SetUpPlugInAppl::Main()
{
	SiSetupFnc		setupFunction;
	SiCustomFnc		customFunction;

	setupFunction.nVersion = SICUSTOM_VERSION;
	customFunction.fncMain = 0;

//	fprintf( stderr, "the app file name is %s\n", GetAppFileName().GetBuffer() );

	ByteString aFileName = OUStringToOString( GetAppFileName(), osl_getThreadTextEncoding() );

#ifdef UNX
	const char* searchChar = "/";
#else
	const char* searchChar = "\\";
#endif

	USHORT nStartIndex = aFileName.SearchCharBackward( searchChar );
	ByteString aSrcPath = aFileName.Erase(nStartIndex, aFileName.Len() - nStartIndex);
	nStartIndex = aFileName.SearchCharBackward( searchChar, nStartIndex );

	ByteString aDestPath = aFileName.Erase(nStartIndex, aFileName.Len() - nStartIndex);

	//fprintf(stderr, "set source path to %s\n", aSrcPath.GetBuffer());
	//fprintf(stderr, "set dest path to %s\n", aDestPath.GetBuffer());

	if( CustomInit( &setupFunction, &customFunction ) )
	{
		if( customFunction.fncMain != 0 )
		{
			MySiCustomEnvironment env( aSrcPath, aDestPath );

			( *customFunction.fncMain )( &env, 0 );
		}
	}
}

