/*************************************************************************
 *
 *  $RCSfile: infotext.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _TLSTREAM_HXX
#include <tlstream.hxx>
#endif
#ifndef _TLFSYS_HXX
#include <tlfsys.hxx>
#endif

#include "infotext.hxx"

#pragma hdrstop

#include "dialog.hrc"
#include "error.hrc"

// class SetupInfoTextDialog ---------------------------------------------

SetupInfoTextDialog::SetupInfoTextDialog
(
	Window *pParent,
	ByteString const& aProgramName,
	ByteString const& aReadMePath
)
: ModalDialog (pParent, ResId(DLG_INFOTEXTDLG))
, aTextEdit (this, ResId(CNT_INFOTEXTDLG_TEXT))
, aOKButton (this, ResId(BTN_OK))
, a1Button  (this, ResId(1))
#ifndef VCL
, a2Icon    (this, ResId(2))
#endif
, a3Text    (this, ResId(3))
{
	a1Button.SetClickHdl( LINK( this, SetupInfoTextDialog, ZipHdl ) );

	// load text to edit control
	SiDirEntry aName = aReadMePath;
#if defined(MAC)
	aName += SiDirEntry( "read_me" );
#elif defined(UNX)
	aName += SiDirEntry( "README" );
#else
	aName += SiDirEntry( "readme.txt" );
#endif
	Font aNewFont( ByteString( ResId( STR_FONTNAME ) ), GetFont().GetSize() );
	aTextEdit.SetFont( aNewFont );

	SvFileStream aReadStrm(aName.GetFull(), STREAM_READ);
	if( aReadStrm.IsOpen() )
	{
		char* pBuf = new char[32000];
		ULONG nRead = aReadStrm.Read( pBuf, 32000 );
		aReadStrm.Close();
		pBuf[nRead] = 0x00;

		ByteString aStr(pBuf);
		delete pBuf;

		ULONG nPos;
		while ( ( nPos = aStr.Search( (char) 12 ) ) != STRING_NOTFOUND )
			aStr.Erase( (USHORT)nPos, 1 );
		aTextEdit.SetText( aStr );
	}
	else
	{
#ifdef MAC
		aTextEdit.SetText( ByteString( ResId( ERR_README ) ) );
#else
		ByteString aErrorText( ResId( ERR_README ) );
		aErrorText.SearchAndReplace( "%", aName.GetName() );
		aTextEdit.SetText( aErrorText );
#endif
	}
	aReadStrm.Close();

	ByteString aText(aProgramName);
	aText += ByteString( ResId( STR_DLG_TITLE ) );
	SetText( aText );
	FreeResource();
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupInfoTextDialog, ZipHdl, Button *, EMPTYARG )
{
	InfoBox( this, ByteString( ResId( STR_ZIPINFO ) ) ).Execute();
	return 0;
}
IMPL_LINK_INLINE_END( SetupInfoTextDialog, ZipHdl, Button *, EMPTYARG )
