/*************************************************************************
 *
 *  $RCSfile: instmode.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SV_SVAPP_HXX //autogen
#include <vcl/svapp.hxx>
#endif

#include "instmode.hxx"
#include "event.hxx"
#pragma hdrstop

#include "dialog.hrc"
#include "instmode.hrc"

ByteString GetSizeByteString(ULONG lSize)
{
	ULONG lMB = ((1024L * 1024L) / 10L); // Umrechnung: Bytes -> 100 KB
	lSize /= lMB;

	ByteString aSize;
	FormatTable aIntl;

	aSize  = lSize / 10;
	aSize += aIntl.GetNumDecimalSep();
	aSize += lSize % 10;
	return aSize;
}


// class SetupInstallModeDialog ------------------------------------------

SetupInstallModeDialog::SetupInstallModeDialog
(
	Window		* pParent,
	ByteString const& aProgramName,
	BOOL		  bUserInst,
	BOOL		  bMinimalInst,
	BOOL		  bWorkstationInst,
	ULONG		  nMinimalSize,
	ULONG		  nDefaultSize,
	ULONG		  nWorkstationSize,
	ULONG		  nTempSize,
	ULONG		  nTempSizeMini
)
: ModelessDialog( pParent, ResId( RID_INSTALLMODE_DLG ) )
#ifndef VCL
, m_a1Icon     ( this, ResId( IC_INSTMODE ) )
#endif
, m_a2Text     ( this, ResId( FT_INSTMODE_INFO1 ) )
, m_a3Text     ( this, ResId( FT_INSTMODE_INFO2 ) )
, m_aMaxiButton( this, ResId( BTN_MAXIMAL ) )
, m_aMaximalText( this, ResId( FT_MAXIMAL ) )
, m_aMaxi1Text ( this, ResId( FT_MAXI1 ) )
, m_aMaxi2Text ( this, ResId( FT_MAXI2 ) )
, m_aUserButton( this, ResId( BTN_USERDEFINED ) )
, m_aUserText     ( this, ResId( FT_USERDEFINED ) )
, m_aUser1Text    ( this, ResId( FT_USER1 ) )
, m_aUser2Text    ( this, ResId( FT_USER2 ) )
, m_aUser3Text    ( this, ResId( FT_USER3 ) )
, m_aMiniButton	  ( this, ResId( BTN_MINIMAL ) )
, m_aMinimalText     ( this, ResId( FT_MINIMAL ) )
, m_aMini1Text    ( this, ResId( FT_MINI1 ) )
, m_aMini2Text    ( this, ResId( FT_MINI2 ) )
, m_aMini3Text	  ( this, ResId( FT_MINI3 ) )
, m_aWorkstationButton ( this, ResId( BTN_WORKSTATION ) )
, m_aWorkstationText ( this, ResId( FT_WORKSTATION ) )
, m_aWork1Text ( this, ResId( FT_WORK1 ) )
, m_aWork2Text ( this, ResId( FT_WORK2 ) )
, m_aWork3Text ( this, ResId( FT_WORK3 ) )
{
	Size aButtonSize = m_aMaxiButton.GetImage().GetSizePixel();
	aButtonSize.Width()  += 8;
	aButtonSize.Height() += 8;
	m_aMaxiButton.SetOutputSizePixel( aButtonSize );
	m_aUserButton.SetOutputSizePixel( aButtonSize );
	m_aMiniButton.SetOutputSizePixel( aButtonSize );
	m_aWorkstationButton.SetOutputSizePixel( aButtonSize );

	m_aMaxiButton.SetClickHdl( LINK( this, SetupInstallModeDialog, MaxiHdl ) );
	m_aUserButton.SetClickHdl( LINK( this, SetupInstallModeDialog, UserHdl ) );
	m_aMiniButton.SetClickHdl( LINK( this, SetupInstallModeDialog, MiniHdl ) );
	m_aWorkstationButton.SetClickHdl ( LINK( this, SetupInstallModeDialog, WorkstationHdl ) );

	FreeResource();

	// Programm-Name in die Texte setzen
	//
	ByteString sTmp;

	sTmp = m_aMaxi1Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aMaxi1Text.SetText( sTmp );

	sTmp = m_aMaxi2Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aMaxi2Text.SetText( sTmp );

	sTmp = m_aUser1Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aUser1Text.SetText( sTmp );

	sTmp = m_aUser2Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aUser2Text.SetText( sTmp );

	sTmp = m_aMini1Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aMini1Text.SetText( sTmp );

	sTmp = m_aMini2Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aMini2Text.SetText( sTmp );

	sTmp = m_aWork1Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aWork1Text.SetText( sTmp );

	sTmp = m_aWork2Text.GetText();
	sTmp.SearchAndReplace( "%s", aProgramName );
	m_aWork2Text.SetText( sTmp );

	// Groessen setzen
	//
	sTmp = m_aMaxi2Text.GetText();
	sTmp.SearchAndReplace("%1", GetSizeByteString(nDefaultSize));
	sTmp.SearchAndReplace("%2", GetSizeByteString(nDefaultSize+nTempSize));
	m_aMaxi2Text.SetText(sTmp);

	sTmp = m_aMini3Text.GetText();
	sTmp.SearchAndReplace("%1", GetSizeByteString(nMinimalSize));
	sTmp.SearchAndReplace("%2", GetSizeByteString(nMinimalSize+nTempSizeMini));
	m_aMini3Text.SetText(sTmp);

	sTmp = m_aWork3Text.GetText();
	sTmp.SearchAndReplace("%1", GetSizeByteString(nWorkstationSize));
	m_aWork3Text.SetText(sTmp);

	m_aMaxiButton.GrabFocus();

	if (!bUserInst)
	{
		// User-Button disablen
		m_aUserButton.Disable();
		m_aUserText.Disable();
		m_aUser1Text.Disable();
		m_aUser2Text.Disable();
		m_aUser3Text.Disable();
	}

	if (!bMinimalInst)
	{
		// Minimal-Button disablen
		m_aMiniButton.Disable();
		m_aMinimalText.Disable();
		m_aMini1Text.Disable();
		m_aMini2Text.Disable();
		m_aMini3Text.Disable();
		// m_aMini4Text.Disable();
	}

	if (!bWorkstationInst)
	{
		m_aWorkstationButton.Disable();
		m_aWorkstationText.Disable();
		m_aWork1Text.Disable();
		m_aWork2Text.Disable();
		m_aWork3Text.Disable();
	}

	sTmp = aProgramName;
	sTmp += ByteString(ResId(STR_DLG_TITLE));
	SetText(sTmp);

	/** UI - Hack FixedTexte zusammenfassen **/
	ByteString aStr;

	m_aMaxi2Text.Hide();
	aStr = m_aMaxi1Text.GetText();
	aStr += " ";
	aStr += m_aMaxi2Text.GetText();
	m_aMaxi1Text.SetText(aStr);

	m_aUser2Text.Hide();
	m_aUser3Text.Hide();
	aStr = m_aUser1Text.GetText();
	aStr += " ";
	aStr += m_aUser2Text.GetText();
	aStr += " ";
	aStr += m_aUser3Text.GetText();
	m_aUser1Text.SetText(aStr);

	m_aMini2Text.Hide();
	m_aMini3Text.Hide();
	aStr = m_aMini1Text.GetText();
	aStr += " ";
	aStr += m_aMini2Text.GetText();
	aStr += " ";
	aStr += m_aMini3Text.GetText();
	m_aMini1Text.SetText(aStr);

	m_aWork2Text.Hide();
	m_aWork3Text.Hide();
	aStr = m_aWork1Text.GetText();
	aStr += " ";
	aStr += m_aWork2Text.GetText();
	aStr += " ";
	aStr += m_aWork3Text.GetText();
	m_aWork1Text.SetText(aStr);
	/** Ende UI - Hack **/
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupInstallModeDialog, MaxiHdl, Button *, EMPTYARG )
{
	Application::PostUserEvent(SETUP_EVENT_MAXI);
	return 0;
}
IMPL_LINK_INLINE_END( SetupInstallModeDialog, MaxiHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupInstallModeDialog, UserHdl, Button *, EMPTYARG )
{
	Application::PostUserEvent(SETUP_EVENT_USER);
	return 0;
}
IMPL_LINK_INLINE_END( SetupInstallModeDialog, UserHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupInstallModeDialog, MiniHdl, Button *, EMPTYARG )
{
	Application::PostUserEvent(SETUP_EVENT_MINI);
	return 0;
}
IMPL_LINK_INLINE_END( SetupInstallModeDialog, MiniHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupInstallModeDialog, WorkstationHdl, Button *, EMPTYARG )
{
	Application::PostUserEvent(SETUP_EVENT_WORKSTATION);
	return 0;
}
IMPL_LINK_INLINE_END( SetupInstallModeDialog, WorkstationHdl, Button *, EMPTYARG )

// -----------------------------------------------------------------------

BOOL SetupInstallModeDialog::Close()
{
	Application::PostUserEvent(SETUP_EVENT_END);
	return TRUE;
}

// -----------------------------------------------------------------------

void SetupInstallModeDialog::KeyInput( const KeyEvent& rKEvt )
{
	const KeyCode& rKeyCode = rKEvt.GetKeyCode();
	USHORT nCode = rKeyCode.GetCode();

	if ( ( KEY_ESCAPE == nCode && rKeyCode.GetModifier() == 0 ) ||
		 ( KEY_POINT == nCode  && rKeyCode.IsMod1() ) )
		Close();
	else
		ModelessDialog::KeyInput( rKEvt );
}
