/*************************************************************************
 *
 *  $RCSfile: start.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#include "start.hxx"

#include "dialog.hrc"
#include "start.hrc"

#include "event.hxx"

// class SetupStartDialog ------------------------------------------------

SetupStartDialog::SetupStartDialog
(
	Window      * pParent,
	ByteString const& aProgramName,
	Point  const& aPoint,
	Point  const& aParentPosPixel,
	Size   const& aParentSizePixel,
	BOOL		  bLocal
)
: ModelessDialog(pParent, ResId(RID_START_DLG))
#ifndef VCL
, m_a1Icon        (this, ResId(IC_START))
#endif
, m_aWelcomeText  (this, ResId(FT_WELCOME))
, m_aProgramText  (this, ResId(FT_PROGRAM))
, m_aInfo1Text    (this, ResId(FT_INFO1))
, m_aInfo2Text    (this, ResId(FT_INFO2))
, m_aLocalButton  (this, ResId(BTN_START_OK))
, m_aCancelButton (this, ResId(BTN_START_CANCEL))
, m_aNetworkButton(this, ResId(BTN_START_NETWORK))
, m_bLocal(bLocal)
{
	FreeResource();

	Size aSizePix  = GetOutputSizePixel();
	SetPosPixel( Point((aParentSizePixel.Width() - aSizePix.Width()) / 2,
					   (aParentSizePixel.Height() - aSizePix.Height()) / 2) );

	#ifdef MAC
	m_aInfo2Text.Hide();
	#else
	ByteString aStr = m_aInfo2Text.GetText();
	aStr.SearchAndReplace("%s", m_aCancelButton.GetText());
	m_aInfo2Text.SetText(aStr);
	#endif

	// Programm-Name in die Texte setzen
	ByteString sProgName(aProgramName);
	ByteString sTmp(aProgramName);
	sTmp += ByteString( ResId( STR_DLG_TITLE ) );
	SetText( sTmp  );
	m_aProgramText.SetText( sProgName );
	sTmp = m_aInfo1Text.GetText();
	sTmp.SearchAndReplace( "%s", sProgName );
	m_aInfo1Text.SetText( sTmp );

	m_aLocalButton.SetClickHdl( LINK( this, SetupStartDialog, OKHdl ) );
	m_aCancelButton.SetClickHdl( LINK( this, SetupStartDialog, CancelHdl ) );
	m_aNetworkButton.SetClickHdl( LINK( this, SetupStartDialog, OKHdl ) );

	#ifdef MAC

		if (bLocal)
			m_aNetworkButton.Hide();
	#else

		m_aNetworkButton.Hide();

	#endif

	m_aLocalButton.GrabFocus();
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupStartDialog, OKHdl, Button *, pButton )
{
#ifdef MAC
	m_bLocal = (pButton == &m_aLocalButton);
	Application::PostUserEvent(SETUP_EVENT_SELECTINSTALLMODE, m_bLocal ? NULL : ((void*)1));
#else
	Application::PostUserEvent(SETUP_EVENT_SELECTINSTALLMODE);
#endif

	return 0;
}
IMPL_LINK_INLINE_END( SetupStartDialog, OKHdl, Button *, pButton )

// -----------------------------------------------------------------------

BOOL SetupStartDialog::Close()
{
	Application::PostUserEvent(SETUP_EVENT_END);
	return TRUE;
}

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SetupStartDialog, CancelHdl, Button *, EMPTYARG )
{
	Application::PostUserEvent(SETUP_EVENT_END);
	return 0;
}
IMPL_LINK_INLINE_END( SetupStartDialog, CancelHdl, Button *, EMPTYARG )
