/*************************************************************************
 *
 *  $RCSfile: main.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <stdlib.h>

#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif

#ifndef NOOLDSV //autogen
#include <vcl/system.hxx>
#endif

#ifdef VCL
#include <sot/factory.hxx>
#endif

#ifndef _SV_RESMGR_HXX //autogen
#include <vcl/resmgr.hxx>
#endif

#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _PVER_HXX
#include <svtools/pver.hxx>
#endif

#if SUPD >= 513
#if SUPD < 600
#ifndef SVTOOLS_TESTTOOL_HXX //autogen
#include <svtools/testtool.hxx>
#endif
#else
#ifndef AUTOMATION_HXX //autogen
#include <automation/automation.hxx>
#endif
#endif
#endif


#include "main.hxx"
#include "mainwnd.hxx"
#include "maindlg.hxx"
#include "arch.hxx"
#include "critical.hxx"
#include "script.hxx"
#include "sihelp.hxx"
#include "respfile.hxx"
#include "texec.hxx"

#include "agenda.hxx"
#include "environ.hxx"
#include "sibasic.hxx"
#include "compiler.hxx"
#include "fields.hxx"
#include "infodlg.hxx"

#include <svtools/solar.hrc>
#include "strings.hrc"
#include "app.hrc"
#include "error.hrc"


static BOOL param_bModuleDump	= FALSE;
static BOOL param_bRepair		= FALSE;
static BOOL param_bOfficeMode	= FALSE;

#define WEBRESPONSE_FILENAME 			"response.ini"
#define WEBRESPONSE_SEC_INSTALLATION 	"Installation"
#define WEBRESPONSE_SEC_USERDATA	 	"UserData"
#define WEBRESPONSE_SEC_MODULE 		 	"Modules"

const char SETUP_INI[]					= "setup.ini";
const char SETUP_TEMPFILE[] 			= "_setup.tmp";

#if defined(WIN) || defined(WNT)
char SETUP_SCRIPT_FILE[] 				= "setup.inf";
char SETUP_INSTDB_FILE[] 				= "instdb.inf";
#else
char SETUP_SCRIPT_FILE[] 				= "setup.ins";
char SETUP_INSTDB_FILE[] 				= "instdb.ins";
#endif

// SetupApp --------------------------------------------------------------

SetupApp::SetupApp()
{
	#if defined(OS2)
	if( Os2OS::DoesTempFileExists() )
	{
		Os2OS::KillTempFile();
		exit(0);
	}
	#endif

	m_pMainWin			= NULL;
	m_bPerformInstall	= FALSE;
	m_bInterrupt		= FALSE;
	m_bParamDoCRCCheck	= FALSE;
	m_bOfficeMode		= FALSE;
	m_nLanguage			= 0;
	m_nWorkStationCnt	= 0;
	m_nWorkStationIdx	= 0;

	#if defined WIN || defined WNT
	m_bShare            = TRUE;
	#endif

	m_pExecuter			= NULL;
	m_pExitAccel      	= NULL;
	m_pEnv            	= new SiEnvironment;
	m_pCompiledScript	= NULL;
//	m_pAgenda         	= NULL;
	m_pResponseFile		= NULL;

	pTopLevelStack		= NULL;
	pSetupApp 			= this;

	Critical::AllocStaticInstance();
	Critical::GetStaticInstance()->SetStdOut( TRUE );
}

SetupApp::~SetupApp()
{
	if( m_pMainDlg )
		delete m_pMainDlg;

	delete m_pEnv;
	delete m_pCompiledScript;

	Critical::DeleteStaticInstance();

	delete m_pRemoteControl;
}

// -----------------------------------------------------------------------

SetupApp aSetupApp;
SetupApp *pSetupApp = &aSetupApp;

#include "../service/progressdlg.hxx"

// -----------------------------------------------------------------------
#ifndef VCL
void SetupApp::Main( int nArgc, char* pArgv[])
#else
void SetupApp::Main()
#endif
{
	m_pRemoteControl = new RemoteControl;

	EnterMultiThread(TRUE);
	Help::EnableBalloonHelp();

//	SetAppFont( System::GetStandardFont(STDFONT_APP) );
	SetAccelerators();

	EnableAutoHelpId();

	m_pResMan = LoadRessources();
	if( !m_pResMan )
	{
		Critical_Error( ERR_RESFILE_NOTFOUND );
	}

	m_pEnv->InitStartPath();
	ReadParams();
	m_pEnv->SetUILanguage( m_nLanguage );

	SetupWindow aMainWin( m_pResMan );
	aMainWin.SetPen( Pen(PEN_NULL) );
	m_pMainWin = &aMainWin;

   if( !FindAndReadScript() )
	{
		Exit();
		return;
	}

	if( m_pEnv->IsFirstInstallation() )
	{
		// es wird alles fuer Default voreingestellt, wenn die Page InstallMode
		// angezeigt wird passt diese den Mode event. wieder an!
		m_pEnv->SetInstallType( IT_MAXIMAL );
		m_pCompiledScript->GetRootModule()->Select( SiModule::ALL_DEFAULT );
	}

	m_pEnv->SetProductName( ByteString(GetProgrammName(), osl_getThreadTextEncoding()) );

	#if defined(UNX) || defined(MAC)
	m_pMainWin->ShowFullScreenMode(FALSE);
	#endif

	#if defined(UNX) || defined(OS2)
	// StartFullScreenMode();
	#else
	m_pMainWin->ShowFullScreenMode();
	#endif

	// Set MainWindow title
	String aTitle( m_pMainWin->GetText() );
	aTitle += GetProgrammName();
	aTitle += ' ';
	aTitle += String( ResId(STR_DLG_TITLE) );
	m_pMainWin->SetText( aTitle );

	////////////////////////////////
	// webinstall mode
	SiDirEntry aWebResponse( m_pEnv->GetStartPath() );
	aWebResponse += ByteString( WEBRESPONSE_FILENAME );
	if( !aWebResponse.Exists() )
	{
		aWebResponse  = m_pEnv->GetSourcePath();
		aWebResponse += ByteString( WEBRESPONSE_FILENAME );
	}
	if( aWebResponse.Exists() )
	{
		Config aCfg( aWebResponse.GetFullUni() );

		aCfg.SetGroup( WEBRESPONSE_SEC_INSTALLATION );
		m_pEnv->SetDestPath( aCfg.ReadKey("installDir") );
		ByteString aLanguages = aCfg.ReadKey("installLang");

		USHORT nDelimTok = 0;
		USHORT nTokCount = aLanguages.GetTokenCount(';');
		for( USHORT x = 0; x < nTokCount; ++x )
		{
			ByteString a( aLanguages.GetToken(0, ';', nDelimTok) );

			LanguageContext* pCtx = new LanguageContext;
			pCtx->nLanguage	= a.GetToken( 0, ':' ).ToInt32();
			pCtx->isProg   	= a.GetToken( 1, ':' ) == "1"? TRUE : FALSE;
			pCtx->isDoc		= a.GetToken( 2, ':' ) == "1"? TRUE : FALSE;

			m_pEnv->AddLanguageContext( pCtx );
		}

		aCfg.SetGroup( WEBRESPONSE_SEC_USERDATA );
		m_pEnv->SetUserName			( aCfg.ReadKey("lastName") );
		m_pEnv->SetUserFirstName	( aCfg.ReadKey("firstName") );
		m_pEnv->SetUserEMail		( aCfg.ReadKey("email") );
		m_pEnv->SetCompanyName		( aCfg.ReadKey("firm") );
		m_pEnv->SetStreet			( aCfg.ReadKey("address") );
		m_pEnv->SetZip				( aCfg.ReadKey("zip") );
		m_pEnv->SetCity				( aCfg.ReadKey("city") );
		m_pEnv->SetTitle			( aCfg.ReadKey("title") );
		m_pEnv->SetPosition			( aCfg.ReadKey("position") );
		m_pEnv->SetFax				( aCfg.ReadKey("fax") );
		m_pEnv->SetTelefonWork		( aCfg.ReadKey("telOffice") );
		m_pEnv->SetTelefonHome		( aCfg.ReadKey("telHome") );
		m_pEnv->SetState			( aCfg.ReadKey("state") );
		m_pEnv->SetCountry			( aCfg.ReadKey("country") );
		m_pEnv->SetUserFatherName	( aCfg.ReadKey("fatherName") );
		m_pEnv->SetApartment   		( aCfg.ReadKey("apartment") );
		m_pEnv->SetUserAddress		( SiHelp::GetAddressByteString(
											m_pEnv->GetCompanyName(),
											m_pEnv->GetStreet(),
											m_pEnv->GetCountry(),
											m_pEnv->GetZip(),
											m_pEnv->GetCity(),
											m_pEnv->GetTitle(),
											m_pEnv->GetPosition(),
											m_pEnv->GetTelefonHome(),
											m_pEnv->GetTelefonWork(),
											m_pEnv->GetFax(),
											m_pEnv->GetUserEMail(),
											m_pEnv->GetState(),
											m_pEnv->GetUserFatherName(),
											m_pEnv->GetApartment()) );

		m_pCompiledScript->GetRootModule()->Select(SiModule::ALL_UNSEL);
		aCfg.SetGroup( WEBRESPONSE_SEC_MODULE );
		for( USHORT i = 0; i < aCfg.GetKeyCount(); ++i )
		{
			BOOL bRegister = aCfg.ReadKey(i) == "1" ? TRUE : FALSE;
			if( bRegister )
			{
				ByteString aModuleID( aCfg.GetKeyName(i) );
				SiModule* pMod = PTR_CAST( SiModule, m_pCompiledScript->Find(aModuleID) );
				if( pMod ) pMod->Select( SiModule::THIS_SEL );
			}
		}

		m_pMainWin->Show();
		m_pMainWin->GetLeftWin()->ShowInstInfo( TRUE, ISM_ADD );
		if( m_pCompiledScript->GetInstallation()->GetProductBMP().Len() )
			aMainWin.SetProductBMP( m_pCompiledScript->GetInstallation()->GetProductBMP() );
		else
			aMainWin.SetProductName( GetProgrammName() );
		PostUserEvent( EVT_START_INSTALL );

		Execute();

		aWebResponse.Kill();
	}
	else
	////////////////////////////////
	// moduledump mode
	if( param_bModuleDump )
	{
		SiDirEntry aEntry( m_pEnv->GetSourcePath() );
		if( m_aParamDestPath.Len() )
			aEntry += m_aParamDestPath;
		aEntry += ByteString( "script.htm" );
		aEntry.ToAbs();
		if( aEntry.GetPath().Exists() ) aEntry.GetPath().MakeDir();
		SiHelp::ModuleDump( m_pCompiledScript->GetRootModule(), aEntry.GetFull() );
		Exit();
		return;
	}
	else
	////////////////////////////////
	// repair mode
	if( param_bRepair )
	{
		ByteString aInstalledPath;
		if( SiHelp::IsVersionAlreadyInstalled(aInstalledPath, m_pCompiledScript, m_pEnv) &&
			aInstalledPath.CompareIgnoreCaseToAscii(m_pEnv->GetStartPath()) != COMPARE_EQUAL  )
		{
			// Setup wurde vom Installations-Medium aufgerufen.
			ByteString strInstDB( SETUP_INSTDB_FILE );
			SiDirEntry aInstDB( aInstalledPath );
			aInstDB += strInstDB;
			while( (!aInstDB.Exists()) && (aInstDB.Level() > 2) )
			{
				aInstDB = aInstDB[2];
				aInstDB += strInstDB;
			}

			if( aInstDB.Exists() )
				ReadScript( aInstDB );

			m_pEnv->SetInstalledPath( aInstalledPath );
			m_pEnv->SetDestPath( aInstalledPath );
			m_pEnv->SetFirstInstallation( FALSE );

			if( m_pCompiledScript->GetInstallation() )
				m_pEnv->SetSourcePath( m_pCompiledScript->GetInstallation()->GetSourcePath() );
		}

		aMainWin.Show();
		aMainWin.Update();
		if( m_pCompiledScript->GetInstallation()->GetProductBMP().Len() )
			aMainWin.SetProductBMP( m_pCompiledScript->GetInstallation()->GetProductBMP() );
		else
			aMainWin.SetProductName( GetProgrammName() );

		m_pEnv->SetInstallType( IT_RECOVER );
		PostUserEvent( EVT_REINST_RECOVER );
		Execute();
	}
	else
	////////////////////////////////
	// response mode
	if( m_aParamResponseFile.Len() )
	{
		/*
		 *	ResponseFile nur fuer bestimmte Lizenz?
		 *
		LicenseModel eLic = ProductVersion::GetLicenseModel();
		if( eLic != LicenseCampus && eLic != LicensePilot &&
			eLic != LicenseInternal && eLic != LicenseNoReg )
		{
			ErrorBox( NULL, WB_OK, "no responsefile support for this licensemodel" ).Execute();
			Quit();
			return ;
		}
		 */
		SiDirEntry aDestPath( m_pEnv->GetDestPath() );
		aDestPath.MakeDir();

		SiDirEntry aFile( m_aParamResponseFile );
		if( !aFile.Exists() )
		{
			aFile = m_pEnv->GetStartPath();
			aFile += m_aParamResponseFile;
			if( !aFile.Exists() )
			{
				aFile = m_pEnv->GetSourcePath();
				aFile += m_aParamResponseFile;
				if( !aFile.Exists() )
					Critical_Error( ERR_RESPONSEFILE_NOTFOUND );
			}
		}

		aFile.ToAbs();
		m_pEnv->SetResponseFilename( aFile.GetFull() );

		ResponseFile aRFile( m_pEnv, m_pCompiledScript );
		m_pResponseFile = &aRFile;
		m_pEnv->SetResponsefileMode( TRUE );

		aRFile.Read( aFile.GetFull() );
		USHORT nEvt = aRFile.ProcessEvents();

		if( nEvt == EVT_START_INSTALL )
			m_pMainWin->GetLeftWin()->ShowInstInfo( TRUE, ISM_ADD );

		if( m_pCompiledScript->GetInstallation()->GetProductBMP().Len() )
			aMainWin.SetProductBMP( m_pCompiledScript->GetInstallation()->GetProductBMP() );
		else
			aMainWin.SetProductName( GetProgrammName() );

		ByteString aMsg( aRFile.GetInstallMode() );
		aMsg += " ";
		aMsg += aRFile.GetInstallType();
		Critical_Log( aMsg );

		aRFile.ExecStartProcedure();
		PostUserEvent( nEvt );

		Execute();
	}
	else
	////////////////////////////////
	// normal- & officemode
	{
		if( param_bOfficeMode &&
			m_pCompiledScript->GetInstallation()->GetInstallMode() != IM_NETWORK )
			m_bOfficeMode = TRUE;

		aMainWin.Show();
		aMainWin.Update();
		if( m_pCompiledScript->GetInstallation()->GetProductBMP().Len() )
			aMainWin.SetProductBMP( m_pCompiledScript->GetInstallation()->GetProductBMP() );
		else
			aMainWin.SetProductName( GetProgrammName() );

		PostUserEvent(EVT_START);
		Execute();
	}

	DELETEZ(m_pExitAccel);
	Resource::SetResManager( NULL );
	DELETEZ( m_pResMan );
}

ResMgr* SetupApp::LoadRessources()
{
	LanguageType nType = System::GetLanguage();

	ByteString aMgrName( "set" );
	aMgrName += ByteString::CreateFromInt32( SOLARUPD );
	ResMgr* pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), nType);

	if (!pResMgr)
	{
		// passende Language-DLL nicht gefunden, dann English default
		pResMgr = ResMgr::CreateResMgr( aMgrName.GetBuffer(), LANGUAGE_ENGLISH_US );
		nType   = LANGUAGE_ENGLISH_US;

		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_FRENCH);
			nType   = LANGUAGE_FRENCH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_ITALIAN);
			nType   = LANGUAGE_ITALIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_SPANISH);
			nType   = LANGUAGE_SPANISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_DUTCH);
			nType   = LANGUAGE_DUTCH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_SWEDISH);
			nType   = LANGUAGE_SWEDISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_TURKISH);
			nType   = LANGUAGE_TURKISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_SWEDISH_FINLAND);
			nType   = LANGUAGE_SWEDISH_FINLAND;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_SWEDISH);
			nType   = LANGUAGE_SWEDISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_PORTUGUESE_BRAZILIAN);
			nType   = LANGUAGE_PORTUGUESE_BRAZILIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_PORTUGUESE);
			nType   = LANGUAGE_PORTUGUESE;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_POLISH);
			nType   = LANGUAGE_POLISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_NORWEGIAN_NYNORSK);
			nType   = LANGUAGE_NORWEGIAN_NYNORSK;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_NORWEGIAN_BOKMAL);
			nType   = LANGUAGE_NORWEGIAN_BOKMAL;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_NORWEGIAN);
			nType   = LANGUAGE_NORWEGIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_FINNISH);
			nType   = LANGUAGE_FINNISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_DUTCH_BELGIAN);
			nType   = LANGUAGE_DUTCH_BELGIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_DANISH);
			nType   = LANGUAGE_DANISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_CATALAN);
			nType   = LANGUAGE_CATALAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_CHINESE_SIMPLIFIED);
			nType   = LANGUAGE_CHINESE_SIMPLIFIED;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_CHINESE_TRADITIONAL);
			nType   = LANGUAGE_CHINESE_TRADITIONAL;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_JAPANESE);
			nType   = LANGUAGE_JAPANESE;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_HUNGARIAN);
			nType   = LANGUAGE_HUNGARIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_CZECH);
			nType   = LANGUAGE_CZECH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_POLISH);
			nType   = LANGUAGE_POLISH;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_RUSSIAN);
			nType   = LANGUAGE_RUSSIAN;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_ARABIC);
			nType   = LANGUAGE_ARABIC;
		}
		if (pResMgr == NULL)
		{
			pResMgr = ResMgr::CreateResMgr(aMgrName.GetBuffer(), LANGUAGE_GREEK);
			nType   = LANGUAGE_GREEK;
		}
	}

	if( pResMgr )
	{
		Resource::SetResManager( pResMgr );
		International aIntn( nType, LANGUAGE_SYSTEM );
		SetAppInternational( aIntn );
	}
	else
		return NULL;

	#ifndef UNX
		// init icon, svlook
		InitAppRes(ResId(APP_ID));
	#endif

	UniString aUniFilename( pResMgr->GetFileName() );
	ByteString aFileName = ByteString(aUniFilename, osl_getThreadTextEncoding()).ToLowerAscii();

	m_nLanguage = aFileName.Copy( aFileName.Search(aMgrName.ToLowerAscii()) + aMgrName.Len(), 2).ToInt32();

	return pResMgr;
}

#ifdef MAC
void SetupApp::ReadParams()
{
	if (MacOS::IsKeyPressed(42 /* = 'n' fuer Netz */))
		m_pEnv->SetLocal(FALSE);
}

#else

void SetupApp::ReadParams()
{
	SiDirEntry aSetupIni  = m_pEnv->GetStartPath();
			 aSetupIni += SiDirEntry(SETUP_INI);

	if (aSetupIni.Exists())
	{
		Config aCfg(aSetupIni.GetFullUni());

		aCfg.SetGroup("Source");
		m_SetupIniSourcePath = aCfg.ReadKey("Path");
		m_pEnv->SetSourcePath(m_SetupIniSourcePath);

		ByteString aTmpBool( aCfg.ReadKey("big", "0") );
		m_pEnv->SetBigMode( (BOOL)(USHORT)aTmpBool.ToInt32() );

		if( m_pEnv->IsBigMode() )
		{
			ByteString aTmpOffset( aCfg.ReadKey("offset", "0") );
		}

		// Share geladen?
		#ifdef WIN
		aCfg.SetGroup( "share" );
		ByteString sKey = aCfg.ReadKey( "load" );
		m_bShare = ( sKey == "1" );
		#endif
	}

#ifdef OS2

#ifndef VCL
	if (pArgv[1] == NULL)
#else
	if (!GetCommandLineParamCount())
#endif
	{
		if (aSetupIni.Exists())
		{
			Config aIniCfg(aSetupIni.GetFull());
			aIniCfg.SetGroup( "extra" );
			ByteString aVal = aIniCfg.ReadKey( "network" );
			m_pEnv->SetLocal( aVal != "1" );
		}
	}

#endif

#ifndef VCL
	for ( int i = 1; i < nArgc; ++i )
	{
		ByteString  aParam = pArgv[i];
#else
	for ( int i = 0; i < GetCommandLineParamCount(); ++i )
	{
		ByteString  aParam = ByteString(GetCommandLineParam(i), osl_getThreadTextEncoding());
#endif
		BOOL	bError = FALSE;

		if( aParam.GetChar(0) == '/' ||
			aParam.GetChar(0) == '-' )
		{
			ByteString aParamName   = aParam.Copy(1);
			ByteString aParamPrefix = aParam.Copy(1,2);

			aParamName.ToUpperAscii();
			aParamPrefix.ToUpperAscii();

			//////////////////////////////////////
			//	CRC
			if( aParamName == "CRC" ||
				aParamName == "C" )
			{
				m_bParamDoCRCCheck = TRUE;
			}
			else
			//////////////////////////////////////
			//	NET
			if( aParamName == "NET" ||
				aParamName == "N" )
			{
				m_pEnv->SetLocal( FALSE );
			}
			else
			//////////////////////////////////////
			//	VIRTUAL
			if( aParamName == "VIRTUAL" ||
				aParamName == "V" )
			{
				m_pEnv->SetVirtualMode( TRUE );
			}
			else
			//////////////////////////////////////
			//	DEBUG
			if( aParamName == "DEBUG" )
			{
				if( Critical::GetStaticInstance() )
					Critical::GetStaticInstance()->SetDebug( TRUE );
			}
			else
			//////////////////////////////////////
			//	SDUMP
			if( aParamName == "SDUMP" )
			{
				param_bModuleDump = TRUE;
			}
			else
			//////////////////////////////////////
			//	OFFICEMODE
			if( aParamName == "OFFICEMODE" )
			{
				 param_bOfficeMode = TRUE;
			}
			else
			//////////////////////////////////////
			//	SDUMP
			if( aParamName == "REPAIR" )
			{
				param_bRepair = TRUE;
			}
			else
			//////////////////////////////////////
			//	NOREG
			if( aParamName == "NOREG" )
			{
				m_pEnv->SetNoRegistration( TRUE );
			}
			else
			//////////////////////////////////////
			//	AUSE
			if( aParamName == "AUSE" )
			{
				m_pEnv->SetAUSEStreamFlush( TRUE );
			}
			else
			//////////////////////////////////////
			//	R:(RESPONSE FILE)
			if( aParamPrefix == "R:" )
			{
				m_aParamResponseFile = aParam.Copy(3);
			}
			else
			//////////////////////////////////////
			//	D:(DESTINATION PATH)
			if( aParamPrefix == "D:" )
			{
				m_aParamDestPath = aParam.Copy(3);
				m_pEnv->SetParamDestPath(TRUE);
			}
			else
			//////////////////////////////////////
			//	F:(FOLLOW APP)
			if( aParamPrefix == "F:" )
			{
				m_aParamFollowApp = aParam.Copy(3);
			}
			else
				bError = TRUE;
		}
		else
			bError = TRUE;

		if( bError )
		{
			if( !IsResponseMode() )
			{
				UniString anError(ResId(ERR_COMMAND_PARAM));
				anError.SearchAndReplace(UniString::CreateFromAscii("%1"), UniString::CreateFromAscii(aParam.GetBuffer()) );

				ErrorBox aBox(GetAppWindow(), WB_OK, anError);
				aBox.Execute();
				Quit();
			}
			else
				Critical_Error( ERR_WRONGPARAMETER );
		}
	}
}

#endif

// -----------------------------------------------------------------------

String SetupApp::GetProgrammName() const
{
	return m_pCompiledScript?
		   UniString::CreateFromAscii(m_pCompiledScript->GetRootModule()->GetName().GetBuffer()) :
		   UniString();
}

// -----------------------------------------------------------------------

BOOL SetupApp::FindAndReadScript()
{
	BOOL bWorkstation = FALSE;

	// Im Startpfad suchen
	ByteString aScriptName( SETUP_INSTDB_FILE );
	SiDirEntry aScript (m_pEnv->GetStartPath());
	aScript += aScriptName;

	// Inst-DB vorhanden ?
	while( (!aScript.Exists()) && (aScript.Level() > 2) )
	{
		aScript = aScript[2];
		aScript += aScriptName;
	}

	if( aScript.Exists() )
	{
/*		m_pEnv->SetInstalledPath(aScript.GetPath().GetFull());
		m_pEnv->SetDestPath(aScript.GetPath().GetFull());
		m_pEnv->SetSourcePath(aScript.GetPath().GetFull());
*/		m_pEnv->SetFirstInstallation(FALSE);
	}
	else // Setupscript vorhanden ?
	{
		m_pEnv->SetFirstInstallation();

		if( m_pEnv->IsBigMode() )
		{
			ArchDirectory* pArch = new ArchDirectory;
			SiDirEntry aEntry( m_SetupIniSourcePath );
			if( !pArch->SetArchFile(aEntry.GetFull().GetBuffer()) )
			{
				if( !IsResponseMode() )
				{
					aEntry.ToAbs();
					m_pEnv->SetInstalledPath(aEntry.GetFull());
					ShowScriptNotFound();

					delete pArch;
					return FALSE;
				}
				else
					Critical_Error( ERR_SCRIPT_NOTFOUND );
			}
			else
				m_pEnv->SetArchive( pArch, FindArch );

			ByteString aScrt(SETUP_SCRIPT_FILE);
			pArch->GetFile( aScrt.GetBuffer(), m_pEnv->GetStartPath().GetBuffer() );
		}

		aScript  = m_pEnv->GetStartPath();
		aScript += ByteString(SETUP_SCRIPT_FILE);

		if (!aScript.Exists())
		{
			aScript	 = m_SetupIniSourcePath;
			aScript += ByteString(SETUP_SCRIPT_FILE);

			if( !aScript.Exists() )
			{
				if( !IsResponseMode() )
				{
					aScript.ToAbs();
					m_pEnv->SetInstalledPath(aScript.GetFull());
					ShowScriptNotFound();
					return FALSE;
				}
				else
					Critical_Error( ERR_SCRIPT_NOTFOUND );
			}
		}
	}

	if( !ReadScript(aScript) )
	{
		if( !IsResponseMode() )
		{
			ErrorBox( NULL, WB_OK, ResId(ERR_SCRIPT) ).Execute();
			return FALSE;
		}
		else
			Critical_Error( ERR_SCRIPT_NOTFOUND );
	}

	if( !m_pCompiledScript->GetInstallation() )
		return FALSE;

	if( !m_pEnv->IsFirstInstallation() )
	{
		m_pEnv->SetInstalledPath( m_pCompiledScript->GetInstallation()->GetDestPath() );
		m_pEnv->SetDestPath( m_pCompiledScript->GetInstallation()->GetDestPath() );
		if( m_pCompiledScript->GetInstallation()->GetInstallMode() == IM_NETWORK )
		{
			SiDirEntry aStartRoot( m_pEnv->GetStartPath() );
			aStartRoot = aStartRoot[1];
			aStartRoot.ToAbs();
			m_pEnv->SetSourcePath( aStartRoot.GetFull() );
		}
		else
			m_pEnv->SetSourcePath( m_pCompiledScript->GetInstallation()->GetSourcePath() );

		if( !(m_pEnv->IsLocal() && m_pCompiledScript->GetInstallation()->GetInstallMode() == IM_NETWORK) )
		{
			ArchDirectory* pArch = new ArchDirectory;
			if( pArch->SetArchFile(m_pCompiledScript->GetInstallation()->GetSourcePath().GetBuffer()) )
			{
				m_pEnv->SetBigMode( TRUE );
				m_pEnv->SetArchive( pArch, FindArch );
				m_pEnv->SetSourcePath( m_pCompiledScript->GetInstallation()->GetSourcePath() );
			}
			else
				delete pArch;
		}
	}

	// Wenn der MODE == APPSERVER m_bIsLocal auf FALSE setzen
	if( m_pEnv->IsLocal() &&
		m_pCompiledScript->GetInstallation()->GetInstallMode() == IM_APPSERVER )
		m_pEnv->SetLocal( FALSE );

	// Bei Netzinstallation noch ermitteln, ob vielleicht die
	// Arbeitsplatzinstallation gemeint war.
	if( m_pEnv->IsLocal() &&
		m_pCompiledScript->GetInstallation()->GetInstallMode() == IM_NETWORK)
	{
		// In z.B. sversion.ini nachschauen, ob es dort einen Verweis auf das installierte
		// Programm gibt.
		SiProfileItem *pItem = m_pCompiledScript->GetInstallInfo();

		if (pItem != NULL)
		{
			aScript  = GetValue(pItem,"__empty__");
			aScript += ByteString(SETUP_INSTDB_FILE);

			// Eintrag muss existieren und gueltig sein
			if( aScript.Exists() )
			{
				if( !ReadScript(aScript) )
				{
					if( !IsResponseMode() )
					{
						ErrorBox(NULL,WB_OK,ResId(ERR_SCRIPT)).Execute();
						return FALSE;
					}
					else
						Critical_Error( ERR_SETUPSCRIPT );
				}

				m_pEnv->SetInstalledPath( ((SiDirEntry&)aScript.GetPath()).GetFull() );
				m_pEnv->SetDestPath( ((SiDirEntry&)aScript.GetPath()).GetFull() );
				m_pEnv->SetFirstInstallation(FALSE); // in bezug auf Arbeitsplatz ...
			}
			else
			{
				bWorkstation = TRUE;
				m_pEnv->SetFirstInstallation(); // in bezug auf Arbeitsplatz ...
			}
		}
		else
			bWorkstation = TRUE;
	}

	// Wenn eine Erstinstallation basierend auf einer Netzinstallation
	// durchgefuhert werden soll.
	if( bWorkstation &&
		m_pEnv->IsFirstInstallation() &&
		m_pCompiledScript->GetInstallation()->GetInstallMode() == IM_NETWORK )
	{
		m_pCompiledScript->PrepareForLocalInstallation();
	}

	if( m_pEnv->IsFirstInstallation() )
	{
		#if defined(UNX)
		SiDirEntry aUNXDefPath( UnixOS::GetHomeDir() );
		aUNXDefPath += m_pCompiledScript->GetInstallation()->GetDefaultDestPath();
		aUNXDefPath.ToAbs();
		m_pEnv->SetDestPath( aUNXDefPath.GetFull() );
		#elif defined(MAC)
		ByteString aTemp = MacOS::GetSystemVolumeName();
		ByteString aRelPath = m_pCompiledScript->GetInstallation()->GetDefaultDestPath();
		if (aRelPath[(USHORT)0] != ':')
			aTemp += ':';
		aTemp += aRelPath;
		m_pEnv->SetDestPath(aTemp);
		#else
		m_pEnv->SetDestPath(m_pCompiledScript->GetInstallation()->GetDefaultDestPath());
		#endif

		if (m_aParamDestPath.Len() != 0)
			m_pEnv->SetDestPath(m_aParamDestPath);
	}
	else
	{
		DBG_ASSERT(m_pEnv->GetDestPath().Len() != 0, "kein Zielpfad");
	}

	if( m_pCompiledScript &&
		!m_pCompiledScript->GetInstallInfo() &&
		m_pCompiledScript->GetInstallation()->GetInstallMode() != IM_TOPLEVEL )
	{
		if( !IsResponseMode() )
		{
			ErrorBox aBox(NULL, WB_OK, UniString::CreateFromAscii("INSTALL_INFO\nis missing!") );
			aBox.Execute();
		}
		else
			Critical_Error( ERR_INSTALLINFOMISSING );
		return FALSE;
	}

	// Installation FollowApp
	if( m_pCompiledScript->GetInstallation()->GetFollowApp().Len() &&
		m_pEnv->IsFirstInstallation() && m_pEnv->IsLocal() )
	{
		SiDirEntry aEntry( m_pCompiledScript->GetInstallation()->GetFollowApp() );
		if( !aEntry.Exists() )
		{
			aEntry = m_pEnv->GetSourcePath();
			aEntry += m_pCompiledScript->GetInstallation()->GetFollowApp();
		}
		if( aEntry.Exists() )
		{
			aEntry.ToAbs();
			ByteString* pNew = new ByteString( aEntry.GetFull() );
			m_pEnv->AddFollowAppList( pNew );
		}
	}

	// Languages
	SiInstallation* pInst = m_pCompiledScript->GetInstallation();
	ByteString aLanguages( pInst->GetLanguages() );

	USHORT nDelimTok = 0;
	USHORT nTokCount = aLanguages.GetTokenCount(',');

	for( USHORT x = 0; x < nTokCount; ++x )
	{
		USHORT nLang = aLanguages.GetToken(0, ',', nDelimTok).ToInt32();
		LanguageContext* pNew = new LanguageContext;

		// nLang = nLang == (USHORT)pInst->GetDefLanguage()? LANG_DEFAULT : nLang;
		pNew->nLanguage = nLang;

		BOOL bProg	= FALSE;
		BOOL bDoc	= FALSE;
		pInst->IsLanguageInstalled(nLang, bProg, bDoc);

		pNew->isProg	= bProg;
		pNew->isDoc		= bDoc;

		m_pEnv->AddUILanguageContext( pNew );
	}

	// Execute PreSelectProcedure
	if( m_pEnv->IsFirstInstallation() )
	{
		SiProcedure* pProc = (SiProcedure*)m_pCompiledScript->FindPreSelectProc();
		if( pProc )
		{
			SiBasic aBasic( *m_pCompiledScript, *m_pEnv );
			aBasic.Call( pProc->GetProcName(), pProc->GetCode() );
		}
	}

	return TRUE;
}

BOOL SetupApp::ReadScript(SiDirEntry const& aScript)
{
	// eventuell vorhandenes Script loeschen
	if (m_pCompiledScript != NULL)
		delete m_pCompiledScript;
	m_pCompiledScript = new SiCompiledScript;

	SetupInfoDialog* pInfDlg = NULL;
	if( !IsResponseMode() )
	{
		pInfDlg = new SetupInfoDialog( m_pMainWin->GetContWin() );
		pInfDlg->Show();
		pInfDlg->Update(); // sonst ist event. der Dialog nicht zu sehen
	}

	BOOL bSuccess = ReadScript( aScript, m_pCompiledScript );

	if( bSuccess )
	{
		SiModule *pModule = m_pCompiledScript->GetRootModule();
		if( pModule == NULL )
			bSuccess = FALSE; // nicht mal ein Modul!
	}

	if( !IsResponseMode() )
	{
		pInfDlg->Hide();
		delete pInfDlg;
	}
	return bSuccess;
}

BOOL SetupApp::ReadScript(SiDirEntry const& aScript, SiCompiledScript *pCS)
{
	SiAnsiFileStream aStream;

	aStream.Open( aScript.GetFullUni(), STREAM_READ );

	if( !aStream.IsOpen() )
		if( aScript.GetName().CompareIgnoreCaseToAscii("instdb.inf") == COMPARE_EQUAL )
		{	// wir suchten nach einer installierten Version!
			// Probieren wir es noch einmal mit dem 'alten' Scriptnamen
			SiDirEntry aOldScript = aScript;
			aOldScript.SetName(UniString::CreateFromAscii("setup.inf"));
			aStream.Open( aOldScript.GetFullUni(), STREAM_READ );
			if( !aStream.IsOpen() )
				return FALSE;
		}

	SiCompilerRef xCompiler = new SiCompiler( aStream, OS::GetType() );

	char aFirstChar;
	aStream >> aFirstChar;
	aStream.Seek(0);

	if( aFirstChar == '[' )
	{
		if( !IsResponseMode() )
		{
			InfoBox aBox(NULL, UniString::CreateFromAscii("Alte Scripts werden nicht mehr unterstuetzt!"));
			aBox.Execute();
		}
		else
			Critical_Error( ERR_OLDSCRIPTVERSION );
		return FALSE;
	}
	else
		return xCompiler->CompileTo( pCS );
}

void SetupApp::PrepareLanguageContext()
{
	SiLangCtxList& rUILst = m_pEnv->GetUILanguageContext();
	SiInstallation* pInst = m_pCompiledScript->GetInstallation();
	USHORT nDefLang = pInst->GetDefLanguage().ToInt32();

	for( USHORT i = 0; i < rUILst.Count(); ++i )
	{
		LanguageContext* pAct = rUILst.GetObject(i);

		BOOL isprog = FALSE;
		BOOL isdoc  = FALSE;
		BOOL isInst = pInst->IsLanguageInstalled(pAct->nLanguage, isprog, isdoc);

		if( !isInst && !pAct->isProg && !pAct->isDoc )
			// war noch nie installiert und soll auch nicht;
			// also weiter
			continue;

		LanguageContext* pCtx = new LanguageContext;
		pCtx->nLanguage	= pAct->nLanguage == nDefLang? LANG_DEFAULT : pAct->nLanguage;
		pCtx->isProg   	= pAct->isProg;
		pCtx->isDoc		= pAct->isDoc;

		m_pEnv->AddLanguageContext( pCtx );
	}

	// bei einem event. Languagewechsel mssen die Switch Ctx'e fuer
	// die Agenda aufgebaut werden.
	if( m_pEnv->GetInstallType() == IT_CHANGE )
	{
		ByteString aInstLanguages = pInst->GetLanguages();
		USHORT nDelimTok = 0;
		USHORT nTokCount = aInstLanguages.GetTokenCount(',');

		for( USHORT x = 0; x < nTokCount; ++x )
		{
			USHORT nLang = aInstLanguages.GetToken(0, ',', nDelimTok).ToInt32();
			LanguageContext* pUICtx = NULL;

			for( USHORT xx = 0; xx < rUILst.Count(); ++xx )
			{
				pUICtx = rUILst.GetObject(xx);
				if( pUICtx->nLanguage == nLang )
					break;
			}
			if( !pUICtx ) continue;

			BOOL isprog = FALSE;
			BOOL isdoc  = FALSE;
			BOOL isInst = pInst->IsLanguageInstalled(pUICtx->nLanguage, isprog, isdoc);

			if( isprog != pUICtx->isProg )
			{
				LanguageContext* pSwitch = new LanguageContext;
				pSwitch->nLanguage	= nLang;
				pSwitch->isProg		= TRUE;
				pSwitch->isDoc		= FALSE;

				if( pUICtx->isProg )
					m_pEnv->AddSwitchContextInstall(pSwitch);
				else
					m_pEnv->AddSwitchContextDelete(pSwitch);
			}
			if( isdoc != pUICtx->isDoc )
			{
				LanguageContext* pSwitch = new LanguageContext;
				pSwitch->nLanguage	= nLang;
				pSwitch->isProg		= FALSE;
				pSwitch->isDoc		= TRUE;
				if( pUICtx->isDoc )
					m_pEnv->AddSwitchContextInstall(pSwitch);
				else
					m_pEnv->AddSwitchContextDelete(pSwitch);
			}
		}
	}

	pInst->SetInstalledLanguages( m_pEnv );
}

ByteString SetupApp::GetValue(SiProfileItem const* pItem, ByteString const& aDefault) const
{
	SiDirEntry anIniPath  = pItem->GetProfile()->GetDirectory()->GetName();
			 anIniPath += pItem->GetProfile()->GetName();
	Config   anIni(anIniPath.GetFullUni());

	anIni.SetGroup(pItem->GetSection());

	return anIni.ReadKey(pItem->GetKey(),aDefault);
}

// -----------------------------------------------------------------------

void SetupApp::SetAccelerators()
{
#ifdef MAC
	m_pExitAccel = new Accelerator;
	m_pExitAccel->InsertItem( 1, KeyCode( KEY_ESCAPE ) );
	m_pExitAccel->InsertItem( 2, KeyCode( KEY_POINT, KEY_MOD1 ) );
	m_pExitAccel->PushSelectHdl( LINK( this, SetupApp, ExitHdl ) );
	InsertAccel(m_pExitAccel, ACCEL_STANDARD );
#else
	m_pExitAccel = new Accelerator;
	#if !defined(UNX) && !defined(OS2)
	m_pExitAccel->InsertItem( 1, KeyCode(KEY_I, KEY_SHIFT | KEY_MOD1) );
	#endif
	m_pExitAccel->SetSelectHdl( LINK( this, SetupApp, ExitHdl ) );
	InsertAccel( m_pExitAccel );
#endif
}

// -----------------------------------------------------------------------

#ifdef MAC
void SetupApp::AppEvent(ApplicationEvent const& rAppEvent)
{
}
#endif

// -----------------------------------------------------------------------

IMPL_LINK( SetupApp, WindowHideHdl, void*, pFoo )
{
	if( pFoo )
		m_pMainWin->Hide();
	else
	{
		m_pMainWin->Show();
		m_pMainWin->GrabFocus();
	}
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SetupApp, ExitHdl, Accelerator*, pAccel )
{
	if( m_pExitAccel == pAccel )
	{
		if( m_pMainWin->IsFullScreenMode() )
			m_pMainWin->EndFullScreenMode();
		else
			m_pMainWin->ShowFullScreenMode();
		return 0;
	}

	if (m_bPerformInstall)
	{
		m_bInterrupt = TRUE;

		if( QueryBox( GetAppWindow(), ResId( DLG_QUERYEXITBOX ) ).Execute() ==
			RET_YES )
		{
			m_bPerformInstall = FALSE;
			if( m_pAgenda != NULL )
				m_pAgenda->StopRunning();
		}
		m_bInterrupt = FALSE;
	}
	else
		PostUserEvent(EVT_END);

	return 0;
}

// -----------------------------------------------------------------------

#ifdef MAC

IMPL_LINK( SetupApp, ExitMenuHdl, Menu *, pMenu )
{
	if ( pMenu->GetCurItemId() == MN_ABOUT )
		InfoBox( GetAppWindow(), ByteString( ResId( STR_ABOUT ) ) ).Execute();

	if ( pMenu->GetCurItemId() == MN_QUIT )
	{
		ExitHdl(NULL);
	}
	return 0;
}

#endif

// -----------------------------------------------------------------------

void SetupApp::MainWindowResize()
{
	if( m_pMainDlg )
	{
		Point aPnt = m_pMainWin->GetContWin()->GetPosPixel();
		Size aSiz = m_pMainDlg->GetSizePixel(),
			aWinSiz = m_pMainWin->GetContWin()->GetSizePixel();

		long nXDelta = ( aWinSiz.Width() - aSiz.Width()  ) / 2;
		long nYDelta = ( aWinSiz.Height() - aSiz.Height()  ) / 2;

		if ( nXDelta > 0 )
			aPnt.X() += nXDelta;
		if ( nYDelta > 0 )
			aPnt.Y() += nYDelta;
		m_pMainDlg->SetPosPixel( aPnt );
	}
}

// -----------------------------------------------------------------------

void SetupApp::ShowScriptNotFound()
{
	m_pMainDlg = new SetupAgentDialog( ((SetupWindow*)GetAppWindow())->GetContWin(), m_pResMan );

	m_pMainDlg->SetLanguage(GetLanguage());
	m_pMainDlg->SetEnv(m_pEnv);

	m_pMainDlg->CreateModel_ScriptNotFound();
	m_pMainDlg->StartAgentDlg();
	m_pMainDlg->Show();

	m_pMainDlg->DoModal();

	delete m_pMainDlg;
	m_pMainDlg = NULL;
}

