/*************************************************************************
 *
 *  $RCSfile: mainwnd.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:50:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SETUP_MAINWND_HXX
#define _SETUP_MAINWND_HXX

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#include "actntype.hxx"
#include "stpwatch.hxx"
#include "textani.hxx"
#include "fadedef.h"

class SiSlide;
class SiProgressBar;
class Texture;
class VirtualDevice;

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------

class HeadWin : public Window
{
	ImageButton		m_aRestoreBtn;

	TextAnimation   m_aTextAni;
	BOOL 			m_bAnimReady;
	BOOL 			m_bTextMode;
	Timer 			m_aAniStartTimer;
	VirtualDevice*	m_pVDev;
	Image			m_aProductBMP;
	Point			m_aAnimPoint;

	Font			m_aProductFont;
	String 			m_aProductName;

	void 			SetButtonPos();

	void 			DrawODev(OutputDevice* pOutDev);
	void			RedrawVDev();

	DECL_LINK(AnimStartHdl, TextAnimation*);
	DECL_LINK(AnimReadyHdl, TextAnimation*);
	DECL_LINK(RestoreHdl, Button*);
public:
		HeadWin(Window* pParent, WinBits nWinBits, ResMgr* pMgr);
		~HeadWin();
	virtual void 			Resize();
	virtual void			Paint( const Rectangle& rRect );

	void 					SetProductName( const String& rNew );
	void 					SetProductBMP( const ByteString& rNew );
};

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------
class UnknownProgress;

class LeftWin : public Window
{
	Image				m_aButterFlyImg;
	Image				m_aClockImg;

	FixedText			m_aFTPrepare;
	FixedText			m_aFTMkDir;
	FixedText			m_aFTCopy;
	FixedText			m_aFTLocal;
	FixedText			m_aFTHelp;
	FixedText			m_aFTRegisterUno;
	FixedText			m_aFTChange;

	FixedText			m_aFTDelete;
	FixedText			m_aFTRmDir;
	FixedText			m_aFTUnregister;

	FixedText			m_aFTRecoverFiles;
	FixedText			m_aFTRecoverLocal;
	FixedText			m_aFTRecoverHelp;

	SiInstallSubMode	eActiveMode;
	BOOL				m_bInProgress;
	SiProgressBar*		m_pProgress;
	UnknownProgress*	m_pUnknownProgress;
	USHORT 				m_nPercent;

	SiStopWatch			m_aStopWatch;
	Time 				m_aLastTime;
	AutoTimer			m_aTimer;
	long				m_lGuess;
	SiActionType		m_eOldActionType;

	AutoTimer			m_aKnightRider;


	void					SetFTColor(FixedText& rText, BOOL bActive = FALSE);
	void					DrawTime(Time* pTime = NULL);
	DECL_LINK(TimeoutHdl, void*);
	DECL_LINK(KnightRiderHdl, void*);
public:
		LeftWin(Window* pParent, WinBits nWinBits, ResMgr* pMgr);
		~LeftWin();
	virtual void 			Resize();
	virtual void			Paint(const Rectangle& rRect);

	void 					StartUnknownProgress();
	void					StopUnknownProgress();

	void					StartProgress();
	void					StopProgress();

	void					SetPercentage(USHORT nPercent);
	void					ShowInstInfo(BOOL bShow, SiInstallSubMode eMode = ISM_INVALID,
										 SiEnvironment* pEnv = NULL, USHORT nUserProf = 0,
										 USHORT nMaxProf = 0);
	void 					SetActionType(SiActionType eType);
};

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------

class ContWin : public Window
{
	VirtualDevice*		m_pVDev;
	Texture*			m_pTexture;
	SiSlide*			m_pActSlide;

	Point				m_aTextPos;
	Image				m_aImg;
	BOOL 				m_bDoFade;
	::com::sun::star::presentation::FadeEffect m_eFadeType;
	FadeSpeed			m_eFadeSpeed;

	void					ReDrawVDev();
	void 					DrawSlideText(OutputDevice* pOutDev, BOOL bDraw = TRUE);
	void					DrawSlideBitmap(OutputDevice* pOutDev);
public:
		ContWin(Window* pParent, WinBits nWinBits, ResMgr* pMgr);
		~ContWin();

	virtual void 			Resize();
	virtual void			Paint(const Rectangle& rRect);

	void 					Reset();
	void					AnimSlide(const SiSlide* pSlide);
};

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------

class SetupWindow : public WorkWindow
{
	HeadWin*				m_pHeadWin;
	LeftWin*				m_pLeftWin;
	ContWin*				m_pContWin;
public:
		SetupWindow(ResMgr* pMgr);
		~SetupWindow();

	virtual BOOL    	Close();
	virtual void		Resize();

	HeadWin*			GetHeadWin() const { return m_pHeadWin; }
	LeftWin*			GetLeftWin() const { return m_pLeftWin; }
	ContWin*			GetContWin() const { return m_pContWin; }

	void				SetProductName(const String& rNew)
						{ m_pHeadWin->SetProductName(rNew); }
	void 				SetProductBMP( const ByteString& rNew )
						{ m_pHeadWin->SetProductBMP(rNew); }
};

// ---------------------------------------------------------------------
// ---------------------------------------------------------------------

class UnknownProgress
{
	BOOL			bUp;
	UINT8			nStart;
	UINT8			nEnd;
	OutputDevice*	pOutDev;
	Rectangle		aRect;

public:
		UnknownProgress(OutputDevice* pOut, const Rectangle& rRect);

	void				TickIt();
	const Rectangle&	GetRect() const { return aRect; }
};

#endif // __MAINWND_HXX

