/*************************************************************************
 *
 *  $RCSfile: maindlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: ok $ $Date: 2000/09/26 07:56:58 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SISYS_HXX
#include <sifsys.hxx>
#endif

#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#ifndef _PVER_HXX
#include <svtools/pver.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#include <tools/l2txtenc.hxx>

#include "maindlg.hxx"
#include "main.hxx"
#include "environ.hxx"
#include "script.hxx"
#include "decltor.hxx"
#include "arch.hxx"
#include "sihelp.hxx"

#include "maindlg.hrc"
#include "pages.hrc"
#include "strings.hrc"

#include "pupdate.hxx"
#include "pwelcome.hxx"
#include "plicense.hxx"
#include "pimode.hxx"
#include "pipath.hxx"
#include "pusrinst.hxx"
#include "preadygo.hxx"
#include "preadme.hxx"
#include "phavefun.hxx"
#include "paddr.hxx"
#include "pwsetup.hxx"
#include "preins.hxx"
#include "puninst.hxx"
#include "precover.hxx"
#include "ptoplvl.hxx"
#include "pcrc.hxx"
#include "plang.hxx"
#include "preguser.hxx"
#include "pasreins.hxx"
#include "pasuinst.hxx"
#include "prepair.hxx"
#include "pmigrate.hxx"
#include "pscript.hxx"

#define EVENT_NOT_SET		0xffffffff

SetupAgentDialog::SetupAgentDialog( Window* pParent, ResMgr* pMgr ) :
	SvAgentDlg	( pParent, pMgr, RESID_MAINDLG_LOGO/*, TRUE*/ )
{
	nSuccEventID = EVENT_NOT_SET;
	nFailEventID = EVENT_NOT_SET;
	eModelType 	 = MODEL_NOTSET;

	bModalFlag	= FALSE;
	bModalSucc	= FALSE;
	bAskOnExit	= TRUE;

	nLanguage	= 0;
	pEnv		= NULL;
	pCScript	= NULL;

	SetInitHdl( LINK(this,SetupAgentDialog,InitPage) );

	if( pParent )
	{
		Point aPnt = pParent->GetPosPixel();
		Size aSiz = GetSizePixel(),
			aWinSiz = pParent->GetSizePixel();

		long nXDelta = ( aWinSiz.Width() - aSiz.Width()  ) / 2;
		long nYDelta = ( aWinSiz.Height() - aSiz.Height()  ) / 2;

		if ( nXDelta > 0 )
			aPnt.X() += nXDelta;
		if ( nYDelta > 0 )
			aPnt.Y() += nYDelta;

		SetPosPixel( aPnt );
	}
}

SetupAgentDialog::~SetupAgentDialog()
{
}

BOOL SetupAgentDialog::AskExit()
{
	if( !bAskOnExit ) return TRUE;
	String aMsg( ResId(STR_EXITSETUP) );
	aMsg.SearchAndReplace( UniString::CreateFromAscii("%1"),
				UniString::CreateFromAscii(pEnv->GetProductName().GetBuffer()) );

	QueryBox aBox( this, WB_YES_NO | WB_DEF_NO, aMsg );
	if( aBox.Execute() == RET_YES )
		return TRUE;
	return FALSE;
}

BOOL SetupAgentDialog::Close()
{
	if( !AskExit() )
		return FALSE;

	if( nFailEventID != EVENT_NOT_SET )
		Application::PostUserEvent( nFailEventID );
	else
		Application::PostUserEvent( EVT_END );

	return TRUE;
}

BOOL SetupAgentDialog::EndAgentDlg(BOOL bSucc)
{
	if( bSucc && nSuccEventID != EVENT_NOT_SET )
		Application::PostUserEvent( nSuccEventID );
	else if( !bSucc && nFailEventID != EVENT_NOT_SET )
	{
		if( !AskExit() )
			return FALSE;
		Application::PostUserEvent( nFailEventID );
	}

	bModalSucc = bSucc;
	bModalFlag = TRUE;

	return TRUE;
}

BOOL SetupAgentDialog::DoModal()
{
	bModalFlag = FALSE;
	bModalSucc = FALSE;

	Window* pOldParent = Application::GetDefModalDialogParent();
	Application::SetDefModalDialogParent( this );

	if( Application::GetAppWindow() )
		#ifndef VCL
		Application::GetAppWindow()->Disable();
		#else
		Application::GetAppWindow()->EnableInput( FALSE, TRUE );
		#endif

	while( !bModalFlag && IsVisible() )
	{
		#ifndef VCL
		Application::Reschedule();
		#else
		Application::Yield();
		#endif
	}

	if( Application::GetAppWindow() )
		#ifndef VCL
		Application::GetAppWindow()->Enable();
		#else
		Application::GetAppWindow()->EnableInput( TRUE, TRUE );
		#endif

	Application::SetDefModalDialogParent( pOldParent );
	return bModalSucc;
}

IMPL_LINK(SetupAgentDialog,InitPage,SvAgentPage*,pPage)
{
	SiHelpText* pText = pCScript ? pCScript->GetHelpTextForId( pPage->GetId(), nLanguage ) : NULL;
	if( pText )
	{
		ByteString aHelpText( pText->GetHelpText() );
		while( aHelpText.SearchAndReplace("\\n", "\n") != STRING_NOTFOUND )
		{}
		UniString aHelp( aHelpText, Langcode2TextEncoding(nLanguage) );
		SetHelpAvailable( aHelp );
	}

	switch( pPage->GetId() )
	{
		//////////////////////////////////////////////
		//	RESID_PAGE_PAGERECOVER
		case RESID_PAGE_PAGERECOVER :
			if( eModelType == MODEL_REINSTALL )
				SuccEvent( EVT_REINST_RECOVER );
			break;

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEUNINSTALL
		case RESID_PAGE_PAGEUNINSTALL :
			if( eModelType == MODEL_REINSTALL )
				SuccEvent( EVT_REINST_UNINSTALL );
			break;

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEUSERDEFINED
		case RESID_PAGE_PAGEUSERDEFINED :
			if( eModelType == MODEL_REINSTALL )
				SuccEvent( EVT_REINST_CHANGE );
			break;

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEHAVEFUN
		case RESID_PAGE_PAGEHAVEFUN	:
			SetButtonState( BSTATE_DISABLE_CANCEL );

			if( eModelType == MODEL_END_FIRST_INST_BOOT )
				((PageHaveFun*)pPage)->ShowReboot();
			else
			if( eModelType == MODEL_END_INST_BOOT ||
				eModelType == MODEL_END_INST )
			{
				if( pEnv->GetInstallType() == IT_CHANGE )
					((PageHaveFun*)pPage)->ShowChange();
				else if( pEnv->GetInstallType() == IT_RECOVER )
					((PageHaveFun*)pPage)->ShowRecover();
				else if( pEnv->GetInstallType() == IT_UNINSTALL )
					((PageHaveFun*)pPage)->ShowUnInstall( pEnv->IsReboot() || pEnv->IsLogout() );

				if( eModelType == MODEL_END_INST_BOOT &&
					pEnv->GetInstallType() != IT_UNINSTALL )  // grumpf &%(%&!"(%&!" (siehe zwei Zeilen drueber)
					((PageHaveFun*)pPage)->ShowReboot();
			}
			break;

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEREADME
		case RESID_PAGE_PAGEREADME :
		{
			GetButtonNext()->Enable( FALSE );

			aTempReadmePath = SiHelp::UnzipReadmeZIP( nLanguage, pCScript, pEnv );

			SiDirEntry aReadmeFile;
			if( aTempReadmePath.Len() ) {
				aReadmeFile =  pEnv->GetSourcePath();
				aReadmeFile += aTempReadmePath;
				aReadmeFile += SiHelp::GetReadmeFilename( nLanguage, 1 );
			}
			else {
				aReadmeFile =  pEnv->GetStartPath();
				aReadmeFile += ByteString(README_FILE_NAME);
			}

			if( !aReadmeFile.Exists() )
			{
				aReadmeFile = pEnv->GetInstalledPath();
				aReadmeFile += ByteString(README_FILE_NAME);
				if( !aReadmeFile.Exists() )
				{
					if( pEnv->IsBigMode() &&
						pEnv->GetArchive()->ExistsFile(README_FILE_NAME) )
					{	// in this case give another try
						pEnv->GetArchive()->GetFile( README_FILE_NAME, pEnv->GetStartPath().GetBuffer() );
						aReadmeFile =  pEnv->GetStartPath();
						aReadmeFile += ByteString(README_FILE_NAME);
					}
					if( !aReadmeFile.Exists() && !pEnv->IsBigMode() )
					{
						aReadmeFile = pEnv->GetSourcePath();
   						aReadmeFile += ByteString(README_FILE_NAME);
					}
   				}
			}

			aReadmeFile.ToAbs();
			((PageReadme*)pPage)->SetReadmeFile( aReadmeFile.GetFullUni() );

			GetButtonNext()->Enable( TRUE );
			GetButtonNext()->GrabFocus();
			break;
		}

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGELICENSE
		case RESID_PAGE_PAGELICENSE :
		{
			SetNextText( UniString::CreateFromAscii("") );
			SetBackText( UniString::CreateFromAscii("") );

			SiDirEntry aLicenseFile;
			if( aTempReadmePath.Len() ) {
				aLicenseFile =  pEnv->GetSourcePath();
				aLicenseFile += aTempReadmePath;
				aLicenseFile += SiHelp::GetReadmeFilename( nLanguage, 2 );
			}
			else {
				aLicenseFile =  pEnv->GetStartPath();
				aLicenseFile += ByteString(LICENSE_FILE_NAME);
			}

			if( !aLicenseFile.Exists() )
			{
				aLicenseFile =	pEnv->GetInstalledPath();
				aLicenseFile +=	ByteString(LICENSE_FILE_NAME);
				if( !aLicenseFile.Exists() )
				{
					if( pEnv->IsBigMode() &&
						pEnv->GetArchive()->ExistsFile(LICENSE_FILE_NAME) )
					{	// in this case give another try
						pEnv->GetArchive()->GetFile( LICENSE_FILE_NAME, pEnv->GetStartPath().GetBuffer() );
						aLicenseFile =  pEnv->GetStartPath();
						aLicenseFile += ByteString(LICENSE_FILE_NAME);
					}
					if( !aLicenseFile.Exists() && !pEnv->IsBigMode() )
					{
						aLicenseFile =	pEnv->GetSourcePath();
						aLicenseFile +=	ByteString(LICENSE_FILE_NAME);
					}
				}
		   	}

			aLicenseFile.ToAbs();
			((PageLicense*)pPage)->SetLicenseFile( aLicenseFile.GetFullUni() );

			break;
		}

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEASRV_USERNAME
		case RESID_PAGE_PAGEASRV_USERNAME :
			if( eModelType == MODEL_REINST_APPSERVER )
				SuccEvent( EVT_REINST_APPSERVER_USERADD );
			break;

		//////////////////////////////////////////////
		//	RESID_PAGE_PAGEASRV_UNINSTALL
		case RESID_PAGE_PAGEASRV_UNINSTALL :
			if( eModelType == MODEL_REINST_APPSERVER )
				SuccEvent( EVT_REINST_APPSERVER_DEINSTALL );
			break;
	}
	return 1;
}

// ============================================================================
//
void SetupAgentDialog::AddAllPages()
{
	InsertPage( RESID_PAGE_PAGELANGUAGE,			PageLanguage::Create,	 	   		SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEADDRESS,				PageAddress::Create,	 	   		LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGECRCCHECK,			PageCRCCheck::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEHAVEFUN,				PageHaveFun::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTALLMODE,			PageInstallMode::Create,			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTPATH,			PageInstPath::Create,		   		SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGELICENSE,				PageLicense::Create,				LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEREADME,				PageReadme::Create,					LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEREADYGO,				PageReadyGo::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGERECOVER,				PageRecover::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEREINSTALLATION,		PageReInstallation::Create,			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGETOPLEVEL,			PageTopLevel::Create,				LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEUNINSTALL,			PageUnInstall::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEUSERDEFINED,			PageUserDefined::Create,			LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEWELCOME,				PageWelcome::Create,	   			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEWRONGSETUP,			PageWrongSetup::Create,				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEUPDATEINSTALL,		PageUpdateInstall::Create,			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEUSERREGISTRATION,	PageUserRegistration::Create,		SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEREPAIR,				PageRepair::Create,	   				SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGESCRIPTNOTFOUND,	 	PageScriptNotFound::Create,	   	   	SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEMIGRATION,	  		 PageMigration::Create,	   	   		SMALL_PAGE );
}

// ============================================================================
//								Page Model's
// ============================================================================
// FirstInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_FirstInstallation()
{
	eModelType = MODEL_FIRST_INST;

	BOOL bHasLanguages  = pEnv->GetUILanguageContext().Count() > 1 ? TRUE : FALSE;
	BOOL bHasSubModules	= pCScript->GetRootModule()->HasUISubModules();
	BOOL bOnlyCustom	= pCScript->GetInstallation()->IsOnlyCustom();

	InsertPage( RESID_PAGE_PAGEWELCOME, 		PageWelcome::Create,			SMALL_PAGE,
				AGENT_STARTPAGE );
	InsertPage( RESID_PAGE_PAGELICENSE,			PageLicense::Create,			LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEADDRESS,     	PageAddress::Create,	 		LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTALLMODE,     PageInstallMode::Create,	  	SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTPATH,		PageInstPath::Create,			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEUSERDEFINED,     PageUserDefined::Create,	  	LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEREADYGO,     	PageReadyGo::Create,	   		SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEREADME,			PageReadme::Create,				LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGELANGUAGE,		PageLanguage::Create,	 	   	SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEMIGRATION,		PageMigration::Create,			SMALL_PAGE );

	if( pEnv->IsLocal() )
	{
	//	================================
	//	keine Registrierung
	//	================================
		Rule( RESID_PAGE_PAGEWELCOME,				   		RESID_PAGE_PAGEREADME );
		Rule( RESID_PAGE_PAGEREADME, 						RESID_PAGE_PAGELICENSE );

		if( bHasSubModules && !bOnlyCustom )
		{
			if( pEnv->IsMigrationAvailable() )
			Rule( RESID_PAGE_PAGELICENSE,					  	RESID_PAGE_PAGEMIGRATION );
			else
			Rule( RESID_PAGE_PAGELICENSE,					  	RESID_PAGE_PAGEADDRESS );

			if( bHasLanguages )
			{
				if( pEnv->IsMigrationAvailable() )
				{
				RuleIf( RESID_PAGE_PAGEMIGRATION,	PMIGRATION_YES,	RESID_PAGE_PAGELANGUAGE );
				RuleIf( RESID_PAGE_PAGEMIGRATION,	PMIGRATION_NO,	RESID_PAGE_PAGEADDRESS );
				}

				RuleIf( RESID_PAGE_PAGEADDRESS,		PADDR_NORMAL, 	RESID_PAGE_PAGELANGUAGE );
				RuleIf( RESID_PAGE_PAGEADDRESS,		PADDR_WARN,  	RESID_PAGE_PAGELANGUAGE );

				Rule( RESID_PAGE_PAGELANGUAGE, 				 		RESID_PAGE_PAGEINSTALLMODE );
			}
			else
			{
				if( pEnv->IsMigrationAvailable() )
				{
				RuleIf( RESID_PAGE_PAGEMIGRATION,	PMIGRATION_YES,	RESID_PAGE_PAGEINSTALLMODE );
				RuleIf( RESID_PAGE_PAGEMIGRATION,	PMIGRATION_NO,	RESID_PAGE_PAGEADDRESS );
				}

				RuleIf( RESID_PAGE_PAGEADDRESS,		PADDR_NORMAL, 	RESID_PAGE_PAGEINSTALLMODE );
				RuleIf( RESID_PAGE_PAGEADDRESS,		PADDR_WARN,  	RESID_PAGE_PAGEINSTALLMODE );
			}
		}
		else
		{
			if( bHasLanguages )
			{
				Rule( RESID_PAGE_PAGELICENSE, 				 		RESID_PAGE_PAGELANGUAGE );
				Rule( RESID_PAGE_PAGELANGUAGE, 				 		RESID_PAGE_PAGEINSTPATH );
			}
			else
			{
				Rule( RESID_PAGE_PAGELICENSE,					  	RESID_PAGE_PAGEINSTPATH );
			}
		}
	}
	else
	{
		Rule	( RESID_PAGE_PAGEWELCOME,				   		RESID_PAGE_PAGEREADME );
		Rule	( RESID_PAGE_PAGEREADME,				   		RESID_PAGE_PAGELICENSE );
		if( bHasSubModules && !bOnlyCustom )
		{
			if( bHasLanguages )
			{
				Rule( RESID_PAGE_PAGELICENSE,				   		RESID_PAGE_PAGELANGUAGE );
				Rule( RESID_PAGE_PAGELANGUAGE,				   		RESID_PAGE_PAGEINSTALLMODE );
			}
			else
			{
				Rule( RESID_PAGE_PAGELICENSE,				   		RESID_PAGE_PAGEINSTALLMODE );
			}
		}
		else
		{
			if( bHasLanguages )
			{
				Rule( RESID_PAGE_PAGELICENSE,				   		RESID_PAGE_PAGELANGUAGE );
				Rule( RESID_PAGE_PAGELANGUAGE,				   		RESID_PAGE_PAGEINSTPATH );
			}
			else
			{
				Rule( RESID_PAGE_PAGELICENSE,				   		RESID_PAGE_PAGEINSTPATH );
			}
		}
	}

	if( bHasSubModules && !bOnlyCustom )
		Rule( RESID_PAGE_PAGEINSTALLMODE,					RESID_PAGE_PAGEINSTPATH );

	RuleIf	( RESID_PAGE_PAGEINSTPATH, RETURN_NORMAL,  		RESID_PAGE_PAGEREADYGO );
	RuleIf	( RESID_PAGE_PAGEINSTPATH, RETURN_USERDEFINED, 	RESID_PAGE_PAGEUSERDEFINED );
	Rule	( RESID_PAGE_PAGEUSERDEFINED,	   				RESID_PAGE_PAGEREADYGO );
}

// ============================================================================
// EndFirstInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_EndFirstInstallation( BOOL bReboot )
{
	eModelType = bReboot? MODEL_END_FIRST_INST_BOOT : MODEL_END_FIRST_INST;
	InsertPage( RESID_PAGE_PAGEHAVEFUN, PageHaveFun::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// EndInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_EndInstallation( BOOL bReboot )
{
	eModelType = bReboot? MODEL_END_INST_BOOT : MODEL_END_INST;
	InsertPage( RESID_PAGE_PAGEHAVEFUN, PageHaveFun::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// ReInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_ReInstallation()
{
	eModelType = MODEL_REINSTALL;

	BOOL bHasLanguages 	= pEnv->GetUILanguageContext().Count() > 1 ? TRUE : FALSE;

	InsertPage( RESID_PAGE_PAGEREINSTALLATION,	PageReInstallation::Create,		SMALL_PAGE,
				AGENT_STARTPAGE );
	InsertPage( RESID_PAGE_PAGEUSERDEFINED,     PageUserDefined::Create,	  	LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEUNINSTALL, 		PageUnInstall::Create,			SMALL_PAGE);
	InsertPage( RESID_PAGE_PAGERECOVER, 		PageRecover::Create,			SMALL_PAGE);
	InsertPage( RESID_PAGE_PAGELANGUAGE,		PageLanguage::Create,	 	   	SMALL_PAGE );

	if( bHasLanguages )
		RuleIf( RESID_PAGE_PAGEREINSTALLATION, 	RETURN_CHANGE,			RESID_PAGE_PAGELANGUAGE );
	else
		RuleIf( RESID_PAGE_PAGEREINSTALLATION, 	RETURN_CHANGE,			RESID_PAGE_PAGEUSERDEFINED );

	RuleIf( RESID_PAGE_PAGEREINSTALLATION, 	RETURN_UNINSTALL,	  	RESID_PAGE_PAGEUNINSTALL );
	RuleIf( RESID_PAGE_PAGEREINSTALLATION, 	RETURN_RECOVER,	  		RESID_PAGE_PAGERECOVER );

	Rule  ( RESID_PAGE_PAGELANGUAGE,	   							RESID_PAGE_PAGEUSERDEFINED );
}

// ============================================================================
// WrongSetup
// ============================================================================
void SetupAgentDialog::CreateModel_WrongSetup()
{
	eModelType = MODEL_WRONG_SETUP;
	InsertPage( RESID_PAGE_PAGEWRONGSETUP, PageWrongSetup::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// Script not found
// ============================================================================
void SetupAgentDialog::CreateModel_ScriptNotFound()
{
	eModelType = MODEL_SCRIPT_NOT_FOUND;
	InsertPage( RESID_PAGE_PAGESCRIPTNOTFOUND, PageScriptNotFound::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// WrongSetup
// ============================================================================
void SetupAgentDialog::CreateModel_UpdateOldVersion()
{
	eModelType = MODEL_UPDATE_OLD_VERSION;
	InsertPage( RESID_PAGE_PAGEUPDATEINSTALL,	   		PageUpdateInstall::Create,	 	SMALL_PAGE,
				AGENT_STARTPAGE );
}

// ============================================================================
// AppServerInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_AppServerInstallation()
{
	BOOL bHasLanguages  = pEnv->GetUILanguageContext().Count() > 1 ? TRUE : FALSE;
	BOOL bOnlyCustom	= pCScript->GetInstallation()->IsOnlyCustom();

	eModelType = MODEL_FIRST_INST_APPSERVER;

	InsertPage( RESID_PAGE_PAGEWELCOME, 		PageWelcome::Create,			SMALL_PAGE,
				AGENT_STARTPAGE );
	InsertPage( RESID_PAGE_PAGELICENSE, 		PageLicense::Create,			LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEREADME,			PageReadme::Create,				LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTALLMODE,     PageInstallMode::Create,	  	SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEINSTPATH,		PageInstPath::Create,			SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEUSERDEFINED,     PageUserDefined::Create,	  	LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGELANGUAGE,		PageLanguage::Create,	 	   	SMALL_PAGE );
	InsertPage( RESID_PAGE_PAGEREADYGO,     	PageReadyGo::Create,	   		SMALL_PAGE );

	Rule	( RESID_PAGE_PAGEWELCOME,			   		RESID_PAGE_PAGEREADME );
	Rule	( RESID_PAGE_PAGEREADME,			  		RESID_PAGE_PAGELICENSE );
	if( bHasLanguages )
	{
		Rule	( RESID_PAGE_PAGELICENSE,			  	RESID_PAGE_PAGELANGUAGE );
		if( bOnlyCustom )
			Rule( RESID_PAGE_PAGELANGUAGE,				RESID_PAGE_PAGEINSTPATH );
		else

			Rule( RESID_PAGE_PAGELANGUAGE,				RESID_PAGE_PAGEINSTALLMODE );
	}
	else
	{
		if( bOnlyCustom )
			Rule( RESID_PAGE_PAGELICENSE,				RESID_PAGE_PAGEINSTPATH );
		else
			Rule( RESID_PAGE_PAGELICENSE,				RESID_PAGE_PAGEINSTALLMODE );
	}

	if( !bOnlyCustom )
		Rule( RESID_PAGE_PAGEINSTALLMODE,				RESID_PAGE_PAGEINSTPATH );

	RuleIf	( RESID_PAGE_PAGEINSTPATH, RETURN_NORMAL,  		RESID_PAGE_PAGEREADYGO );
	RuleIf	( RESID_PAGE_PAGEINSTPATH, RETURN_USERDEFINED, 	RESID_PAGE_PAGEUSERDEFINED );

	Rule	( RESID_PAGE_PAGEUSERDEFINED,	   				RESID_PAGE_PAGEREADYGO );
}

// ============================================================================
// AppServerReInstallation
// ============================================================================
void SetupAgentDialog::CreateModel_AppServerReInstallation()
{
	eModelType = MODEL_REINST_APPSERVER;

	InsertPage( RESID_PAGE_PAGEASRV_REINSTALLATION,	PageASrvReInstallation::Create, SMALL_PAGE,
				AGENT_STARTPAGE );
/*	InsertPage( RESID_PAGE_PAGEASRV_USERNAME,   	PageASrvUserName::Create,		SMALL_PAGE);
	InsertPage( RESID_PAGE_PAGEASRV_USERPATH,   	PageASrvUserPath::Create,		SMALL_PAGE);
*/	InsertPage( RESID_PAGE_PAGEASRV_UNINSTALL, 		PageASrvUnInstall::Create,		SMALL_PAGE);

//	RuleIf	( RESID_PAGE_PAGEASRV_REINSTALLATION, RETURN_APS_ADDUSER, RESID_PAGE_PAGEASRV_USERNAME );
	RuleIf	( RESID_PAGE_PAGEASRV_REINSTALLATION, RETURN_APS_DEINSTALL, RESID_PAGE_PAGEASRV_UNINSTALL );
}

// ============================================================================
// TopLevel
// ============================================================================
void SetupAgentDialog::CreateModel_TopLevel()
{
	eModelType = MODEL_TOPLEVEL;
	InsertPage( RESID_PAGE_PAGETOPLEVEL, PageTopLevel::Create, LARGE_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// CRCCheck
// ============================================================================
void SetupAgentDialog::CreateModel_CRCCheck()
{
	eModelType = MODEL_CRCCHECK;
	InsertPage( RESID_PAGE_PAGECRCCHECK, PageCRCCheck::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

// ============================================================================
// CRCCheck
// ============================================================================
void SetupAgentDialog::CreateModel_UserDataOnly()
{
	eModelType = MODEL_USERDATAONLY;

	InsertPage( RESID_PAGE_PAGEUSERREGISTRATION,	PageUserRegistration::Create,	LARGE_PAGE, AGENT_STARTPAGE );
	InsertPage( RESID_PAGE_PAGELICENSE, 			PageLicense::Create,			LARGE_PAGE );
	InsertPage( RESID_PAGE_PAGEADDRESS,     		PageAddress::Create,	 		LARGE_PAGE );

	Rule	( RESID_PAGE_PAGEUSERREGISTRATION,		RESID_PAGE_PAGELICENSE );
	Rule	( RESID_PAGE_PAGELICENSE,				RESID_PAGE_PAGEADDRESS );
}

// ============================================================================
// OfficeRepair
// ============================================================================
void SetupAgentDialog::CreateModel_OfficeRepair()
{
	eModelType = MODEL_OFFICEREPAIR;
	InsertPage( RESID_PAGE_PAGEREPAIR, PageRepair::Create, SMALL_PAGE, AGENT_STARTPAGE );
}

