/*************************************************************************
 *
 *  $RCSfile: paddr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdlib.h>

#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef NOOLDSV //autogen
#include <vcl/system.hxx>
#endif

#ifndef _PVER_HXX
#include <svtools/pver.hxx>
#endif

#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif

#ifndef _SVTDEMO_HXX //autogen
#include <svtools/demo.hxx>
#endif

#include "maindlg.hxx"
#include "environ.hxx"
#include "os.hxx"
#include "sihelp.hxx"

#include "paddr.hxx"
#include "paddr.hrc"

static String C2Sys( const ByteString& rStr, AddressToken eToken )
{
	UniString aAddress( rStr, osl_getThreadTextEncoding() );
	String aToken;
	USHORT i = 0, nTxt = 0;

	while ( i < aAddress.Len() )
	{
		while ( i < aAddress.Len() && aAddress.GetChar(i) != '#' )
		{
			if ( aAddress.GetChar(i) == '\\' )
				i++;
			aToken += aAddress.GetChar(i++);
		}
		i++;

		if ( eToken == (AddressToken)nTxt )
			break;
		else if ( i >= aAddress.Len() )
		{
			aToken.Erase();
			break;
		}
		else
		{
			aToken.Erase();
			nTxt++;
		}
	}

//	aToken.Convert( CHARSET_IBMPC, CHARSET_SYSTEM );
	return aToken;
}

PageAddress::PageAddress( SvAgentDlg* pParent, const ResId& rResId ) :
	SvAgentPage			( pParent, rResId ),
	m_aFTInfo1			( this, ResId(FT_INFO1, rResId.GetResMgr()) ),
	m_aCompanyLbl		( this, ResId( FT_COMPANY ) ),
	m_aCompanyEdit		( this, ResId( ED_COMPANY ) ),
	m_aNameLbl			( this, ResId( FT_NAME ) ),
	m_aNameLblRuss		( this, ResId( FT_NAME_RUSS ) ),
	m_aFatherName		( this, ResId( ED_FATHERNAME ) ),
	m_aFirstName 		( this, ResId( ED_FIRSTNAME ) ),
	m_aName				( this, ResId( ED_NAME ) ),
	m_aShortName 		( this, ResId( ED_SHORTNAME ) ),
	m_aStreetLbl 		( this, ResId( FT_STREET ) ),
	m_aStreetLblRuss	( this, ResId( FT_STREET_RUSS ) ),
	m_aStreetEdit		( this, ResId( ED_STREET ) ),
	m_aApartmentEdit	( this, ResId( ED_APARTMENTNR_RUSS ) ),
	m_aCityLbl			( this, ResId( FT_CITY ) ),
//	m_aCountryEdit		( this, ResId( ED_COUNTRY ) ),
	m_aPLZEdit			( this, ResId( ED_PLZ ) ),
	m_aCityEdit			( this, ResId( ED_CITY ) ),
	m_aUsCityEdit		( this, ResId( ED_US_CITY ) ),
	m_aStateLbl			( this, ResId( FT_STATE ) ),
	m_aStateEdit 		( this, ResId( ED_STATE ) ),
	m_aUsStateEdit		( this, ResId( ED_US_STATE ) ),
	m_aUsPLZEdit 		( this, ResId( ED_US_ZIP ) ),
//	m_aUsCountryEdit	( this, ResId( ED_US_COUNTRY ) ),
	m_aCountryLbl  		( this, ResId( FT_COUNTRY ) ),
	m_aCountryList 		( this, ResId( LB_COUNTRY ) ),
	m_aTitlePosLbl		( this, ResId( FT_TITLEPOS ) ),
	m_aTitleEdit		( this, ResId( ED_TITLE ) ),
	m_aPositionEdit		( this, ResId( ED_POSITION ) ),
	m_aTelPrivLbl		( this, ResId( FT_TELPRIVAT ) ),
	m_aTelPrivEdit		( this, ResId( ED_TELPRIVAT ) ),
	m_aTelCompanyLbl	( this, ResId( FT_TELCOMPANY ) ),
	m_aTelCompanyEdit	( this, ResId( ED_TELCOMPANY ) ),
	m_aFaxLbl	 		( this, ResId( FT_FAX ) ),
	m_aFaxEdit	 		( this, ResId( ED_FAX ) ),
	m_aEmailLbl	 		( this, ResId( FT_EMAIL ) ),
	m_aEmailEdit  		( this, ResId( ED_EMAIL ) ),
	m_aWarnUser  		( ResId( STR_WARN_USER ) ),
	m_aWarnUserPuff		( ResId( STR_WARN_USER_PUFF ) ),
	m_aWarnUserCampus	( ResId( STR_WARN_USER_CAMPUS ) )
{
	String aTitle( ResId(STR_TITLE, rResId.GetResMgr()) );
	pParent->SetTitleStr( aTitle );

	m_aNameLblRuss.Hide();
	m_aFatherName.Hide();
	m_aStreetLblRuss.Hide();
	m_aApartmentEdit.Hide();
	m_aFTInfo1.Hide();

	if( GETDLG()->GetLanguage() == 1 /* LANGUAGE_ENGLISH_US */ )
	{
		m_aCityEdit.Hide();
//		m_aCountryEdit.Hide();
		m_aPLZEdit.Hide();
		m_aStateEdit.Hide();

		m_aUsCityEdit.Show();
//		m_aUsCountryEdit.Show();
		m_aUsPLZEdit.Show();
		m_aUsStateEdit.Show();

		m_aCityLbl.SetText( UniString( ResId(STR_US_CITY) ) );
		m_aStateLbl.SetText( UniString( ResId(STR_US_STATE) ) );
	}
	else if( GETDLG()->GetLanguage() == 7 /* LANGUAGE_RUSSIAN */ )
	{
		m_aNameLbl.Hide();
		m_aStreetLbl.Hide();

		m_aFirstName.SetPosSizePixel( LogicToPixel(Point(118,24), MAP_APPFONT) ,
								 LogicToPixel(Size(47,12), MAP_APPFONT) );
		m_aName.SetPosSizePixel( LogicToPixel(Point(218,24), MAP_APPFONT) ,
								 LogicToPixel(Size(47,12), MAP_APPFONT) );
		m_aShortName.SetPosSizePixel( LogicToPixel(Point(268,24), MAP_APPFONT) ,
								 LogicToPixel(Size(15,12), MAP_APPFONT) );
		m_aStreetEdit.SetPosSizePixel( LogicToPixel(Point(118,39), MAP_APPFONT) ,
								 LogicToPixel(Size(115,12), MAP_APPFONT) );

		m_aNameLblRuss.Show();
		m_aFatherName.Show();
		m_aStreetLblRuss.Show();
		m_aApartmentEdit.Show();
	}

	FreeResource();

	m_aCountryList.SetDropDownLineCount( 5 );

	#ifdef UNX
	m_aShortName.SetText( UniString::CreateFromAscii(getenv("LOGNAME")) );
	#else
	m_aFirstName.SetModifyHdl( LINK( this, PageAddress, ModifyHdl ) );
	m_aName.SetModifyHdl( LINK( this, PageAddress, ModifyHdl ) );
	#endif

	SiEnvironment* pEnv = GETDLG()->GetEnv();
	if( pEnv->GetUserAddress().Len() )
		SetAddress( pEnv->GetUserAddress() );
	if( pEnv->GetUserName().Len() )
		m_aName.SetText( UniString(pEnv->GetUserName(), osl_getThreadTextEncoding()) );
	if( pEnv->GetUserFirstName().Len() )
		m_aFirstName.SetText( UniString(pEnv->GetUserFirstName(), osl_getThreadTextEncoding()) );
	if( pEnv->GetUserId().Len() )
		m_aShortName.SetText( UniString(pEnv->GetUserId(), osl_getThreadTextEncoding()) );
	if( pEnv->GetCountryIdx() != 0 )
		SelectLanguageByIdx( pEnv->GetCountryIdx() );
	else
		SelectInitialLanguage();
	m_aCompanyEdit.GrabFocus();
}

PageAddress::~PageAddress()
{
}

SvAgentPage* PageAddress::Create( SvAgentDlg* pParent, const ResId& rResId )
{
	return new PageAddress( pParent, rResId );
}

void PageAddress::SelectInitialLanguage()
{
	USHORT nIdx = 0;
	switch( System::GetLanguage() )
	{
		case LANGUAGE_DANISH:					nIdx = DAENEMARK; break;
		case LANGUAGE_DUTCH:                    nIdx = NIEDERLANDE; break;
		case LANGUAGE_DUTCH_BELGIAN:			nIdx = BELGIEN; break;
		case LANGUAGE_ENGLISH:
		case LANGUAGE_ENGLISH_UK:
		case LANGUAGE_ENGLISH_EIRE:
		case LANGUAGE_ENGLISH_SAFRICA:
		case LANGUAGE_ENGLISH_JAMAICA:
		case LANGUAGE_ENGLISH_BELIZE:
		case LANGUAGE_ENGLISH_TRINIDAD:
		case LANGUAGE_ENGLISH_ZIMBABWE:
		case LANGUAGE_ENGLISH_PHILIPPINES:		nIdx = GROSSBRITANNIEN; break;
		case LANGUAGE_ENGLISH_US:
		case LANGUAGE_ENGLISH_CAN:				nIdx = VEREINIGTE_STAATEN_VON_AMERIKA; break;
		case LANGUAGE_ENGLISH_AUS:
		case LANGUAGE_ENGLISH_NZ:				nIdx = AUSTRALIEN; break;
		case LANGUAGE_FINNISH:					nIdx = FINNLAND; break;
		case LANGUAGE_FRENCH_CANADIAN:			nIdx = VEREINIGTE_STAATEN_VON_AMERIKA; break;
		case LANGUAGE_FRENCH:
		case LANGUAGE_FRENCH_BELGIAN:
		case LANGUAGE_FRENCH_SWISS:
		case LANGUAGE_FRENCH_LUXEMBOURG:
		case LANGUAGE_FRENCH_MONACO:			nIdx = FRANKREICH; break;
		case LANGUAGE_GERMAN:
		case LANGUAGE_GERMAN_SWISS:
		case LANGUAGE_GERMAN_AUSTRIAN:
		case LANGUAGE_GERMAN_LUXEMBOURG:
		case LANGUAGE_GERMAN_LIECHTENSTEIN:		nIdx = BUNDESREPUBLIK_DEUTSCHLAND; break;
		case LANGUAGE_ITALIAN:
		case LANGUAGE_ITALIAN_SWISS:			nIdx = ITALIEN; break;
		case LANGUAGE_NORWEGIAN:
		case LANGUAGE_NORWEGIAN_BOKMAL:			nIdx = NORWEGEN; break;
		case LANGUAGE_PORTUGUESE:				nIdx = PORTUGAL; break;
		case LANGUAGE_PORTUGUESE_BRAZILIAN:		nIdx = BRASILIEN; break;
		case LANGUAGE_SPANISH_MODERN:
		case LANGUAGE_SPANISH:					nIdx = SPANIEN; break;
		case LANGUAGE_SPANISH_MEXICAN:			nIdx = MEXIKO; break;
		case LANGUAGE_SPANISH_GUATEMALA:		nIdx = GUATEMALA; break;
		case LANGUAGE_SPANISH_COSTARICA:		nIdx = COSTA_RICA; break;
		case LANGUAGE_SPANISH_PANAMA:			nIdx = PANAMA; break;
// 		case LANGUAGE_SPANISH_DOMINICAN:		nIdx = DOMINIKANISCHE_REPUBLIK; break;
		case LANGUAGE_SPANISH_VENEZUELA:		nIdx = VENEZUELA; break;
		case LANGUAGE_SPANISH_COLOMBIA:			nIdx = KOLUMBIEN; break;
		case LANGUAGE_SPANISH_PERU:				nIdx = PERU; break;
		case LANGUAGE_SPANISH_ARGENTINA:		nIdx = ARGENTINIEN; break;
		case LANGUAGE_SPANISH_ECUADOR:			nIdx = ECUADOR; break;
		case LANGUAGE_SPANISH_CHILE:			nIdx = CHILE; break;
		case LANGUAGE_SPANISH_URUGUAY:			nIdx = URUGUAY; break;
		case LANGUAGE_SPANISH_PARAGUAY:			nIdx = PARAGUAY; break;
		case LANGUAGE_SPANISH_BOLIVIA:			nIdx = SPANIEN; break;
		case LANGUAGE_SWEDISH:					nIdx = SCHWEDEN; break;
		case LANGUAGE_POLISH:					nIdx = POLEN; break;
		case LANGUAGE_CZECH:					nIdx = TSCHECHIEN; break;
		case LANGUAGE_HUNGARIAN:				nIdx = UNGARN; break;
		case LANGUAGE_RUSSIAN:					nIdx = RUSSISCHE_FOEDERATION; break;
		case LANGUAGE_SLOVAK:					nIdx = SLOWAKEI; break;
		case LANGUAGE_CHINESE_SIMPLIFIED:		nIdx = CHINA; break;
		case LANGUAGE_JAPANESE:					nIdx = JAPAN; break;
	}

	if( !nIdx )
	{
		m_aCountryList.SetNoSelection();
		return;
	}
	SelectLanguageByIdx( nIdx );
}

void PageAddress::SelectLanguageByIdx( USHORT nIdx )
{
	for( USHORT i = 0; i < m_aCountryList.GetEntryCount(); ++i )
	{
		USHORT nID = (USHORT) (ULONG) m_aCountryList.GetEntryData(i);
		if( nID == nIdx )
		{
			m_aCountryList.SelectEntryPos(i);
			break;
		}
	}
}

USHORT PageAddress::GetReturnVal()
{
	return PADDR_NORMAL;
}

ULONG PageAddress::GetProperty()
{
	Userdata2Env();
	return PROP_NOTSET;
}

BOOL PageAddress::AllowNext()
{
	Userdata2Env();
	return TRUE;
}

void PageAddress::Userdata2Env()
{
	SiEnvironment* pEnv = GETDLG()->GetEnv();

	USHORT nLangIdx = (USHORT)(ULONG) m_aCountryList.GetEntryData( m_aCountryList.GetSelectEntryPos() );

	pEnv->SetCountry( ByteString(m_aCountryList.GetSelectEntry(), osl_getThreadTextEncoding()) );
	pEnv->SetCountryIdx( nLangIdx );

	pEnv->SetUserAddress( GetAddress() );
	pEnv->SetUserName( GetUserName() );
	pEnv->SetUserFirstName( GetUserFirstName() );

	pEnv->SetUserId( GetUserId() );
	pEnv->SetUserEMail( GetEMail() );
	pEnv->SetCompanyName( GetCompanyName() );
	pEnv->SetStreet( GetCtrl(m_aStreetEdit) );

	pEnv->SetCity( GetCtrl(m_aCityEdit) );
	pEnv->SetTitle( GetCtrl(m_aTitleEdit) );
	pEnv->SetPosition( GetCtrl(m_aPositionEdit) );
	pEnv->SetFax( GetCtrl(m_aFaxEdit) );
	pEnv->SetTelefonWork( GetCtrl(m_aTelCompanyEdit) );
	pEnv->SetTelefonHome( GetCtrl(m_aTelPrivEdit) );
	pEnv->SetState( GetCtrl(m_aStateEdit) );

	if( GETDLG()->GetLanguage() == 1 )
	{
		pEnv->SetZip( GetCtrl(m_aUsPLZEdit) );
		pEnv->SetCity( GetCtrl(m_aUsCityEdit) );
	}
	else
	{
		pEnv->SetZip( GetCtrl(m_aPLZEdit) );
		pEnv->SetCity( GetCtrl(m_aCityEdit) );
	}
}

void PageAddress::SetAddress( const ByteString& rAddr )
{
	const char cAddrToken = '#';
	USHORT nDelimTok = 0;
	USHORT nTokCount = rAddr.GetTokenCount(cAddrToken);

	m_aCompanyEdit.SetText( C2Sys(rAddr, ADDRESS_COMPANY) );
	m_aStreetEdit.SetText( C2Sys(rAddr, ADDRESS_STREET) );

	if( GETDLG()->GetLanguage() == 1 /* LANGUAGE_ENGLISH_US */ )
	{
		m_aUsPLZEdit.SetText( C2Sys(rAddr, ADDRESS_PLZ) );
		m_aUsCityEdit.SetText( C2Sys(rAddr, ADDRESS_CITY) );
	}
	else
	{
		m_aPLZEdit.SetText( C2Sys(rAddr, ADDRESS_PLZ) );
		m_aCityEdit.SetText( C2Sys(rAddr, ADDRESS_CITY) );
	}

	if( GETDLG()->GetLanguage() == 7 /* LANGUAGE_ENGLISH_US */ )
	{
		m_aFatherName.SetText( C2Sys(rAddr, ADDRESS_FATHERSNAME) );
		m_aApartmentEdit.SetText( C2Sys(rAddr, ADDRESS_APARTMENT) );
	}

	m_aTitleEdit.SetText( C2Sys(rAddr, ADDRESS_TITLE) );
	m_aPositionEdit.SetText( C2Sys(rAddr, ADDRESS_POSITION) );
	m_aTelPrivEdit.SetText( C2Sys(rAddr, ADDRESS_TEL_PRIVATE) );
	m_aTelCompanyEdit.SetText( C2Sys(rAddr, ADDRESS_TEL_COMPANY) );
	m_aFaxEdit.SetText( C2Sys(rAddr, ADDRESS_FAX) );
	m_aEmailEdit.SetText( C2Sys(rAddr, ADDRESS_EMAIL) );

	if( GETDLG()->GetLanguage() == 1 )
		m_aUsStateEdit.SetText( C2Sys(rAddr, ADDRESS_STATE) );
	else
		m_aStateEdit.SetText( C2Sys(rAddr, ADDRESS_STATE) );
}

ByteString PageAddress::GetAddress() const
{
	SiEnvironment* pEnv = GETDLG()->GetEnv();

	ByteString aAddressStr;
	ByteString aCountry( SiHelp::Get2AlphaCountryCode(pEnv->GetCountryIdx() - 1) );

	if( GETDLG()->GetLanguage() == 1 /* LANGUAGE_ENGLISH_US */ )
		aAddressStr = SiHelp::GetAddressByteString(
							ByteString(m_aCompanyEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aStreetEdit.GetText(), osl_getThreadTextEncoding()),
							aCountry,
							ByteString(m_aUsPLZEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aUsCityEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTitleEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aPositionEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTelPrivEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTelCompanyEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aFaxEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aEmailEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aUsStateEdit.GetText(), osl_getThreadTextEncoding()),
							"",
							"" );
	else
		aAddressStr = SiHelp::GetAddressByteString(
							ByteString(m_aCompanyEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aStreetEdit.GetText(), osl_getThreadTextEncoding()),
							aCountry,
							ByteString(m_aPLZEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aCityEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTitleEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aPositionEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTelPrivEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aTelCompanyEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aFaxEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aEmailEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aStateEdit.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aFatherName.GetText(), osl_getThreadTextEncoding()),
							ByteString(m_aApartmentEdit.GetText(), osl_getThreadTextEncoding()) );

	return aAddressStr;
}

ByteString PageAddress::GetCompanyName() const
{
	String aStr( m_aCompanyEdit.GetText() );
	aStr.EraseTrailingChars();
	aStr.EraseLeadingChars();
	return ByteString(aStr, osl_getThreadTextEncoding());
}

ByteString PageAddress::GetUserName() const
{
	String aStr( m_aName.GetText() );
	aStr.EraseTrailingChars();
	aStr.EraseLeadingChars();
	return ByteString(aStr, osl_getThreadTextEncoding());
}

ByteString PageAddress::GetUserFirstName() const
{
	String aStr( m_aFirstName.GetText() );
	aStr.EraseTrailingChars();
	aStr.EraseLeadingChars();
	return ByteString(aStr, osl_getThreadTextEncoding());
}

ByteString PageAddress::GetUserId() const
{
	String aStr( m_aShortName.GetText() );
	return ByteString(aStr, osl_getThreadTextEncoding());
}

ByteString PageAddress::GetEMail() const
{
	String aStr( m_aEmailEdit.GetText() );
	aStr.EraseTrailingChars();
	aStr.EraseLeadingChars();
	return ByteString(aStr, osl_getThreadTextEncoding());
}

ByteString PageAddress::GetCtrl(const Edit& rEdit) const
{
	String aStr( rEdit.GetText() );
	aStr.EraseTrailingChars();
	aStr.EraseLeadingChars();
	return ByteString(aStr, osl_getThreadTextEncoding());
}

IMPL_LINK( PageAddress, ModifyHdl, Edit*, pEdit )
{
	#ifndef UNX
	UniString aShort( m_aShortName.GetText() );
	switch( aShort.Len() )
	{
		case 0:	aShort = UniString::CreateFromAscii("  "); break;
		case 1: aShort += UniString::CreateFromAscii(" "); break;
	}
	if( pEdit == &m_aFirstName )
	{
		aShort.Erase( 0, 1 );
		if( m_aFirstName.GetText().Len() )
			aShort.Insert( m_aFirstName.GetText().GetChar(0), 0 );
		else
			aShort.Insert( ' ', 0 );
	}
	else if( pEdit == &m_aName )
	{
		aShort.Erase( 1, 1 );
		if( m_aName.GetText().Len() )
			aShort.Insert( m_aName.GetText().GetChar(0), 1 );
		else
			aShort.Insert( ' ', 1 );
	}
	m_aShortName.SetText( aShort );
	#endif

	return 0;
}

