/*************************************************************************
 *
 *  $RCSfile: phavefun.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _PHAVEFUN_HXX
#define _PHAVEFUN_HXX

#ifndef _AGENTPG_HXX
#include "agentpg.hxx"
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

class PageHaveFun : public SvAgentPage
{
		FixedText		aFTInfo1;
		FixedText		aFTInfo2;
		FixedText		aFTReboot;
		FixedText		aFTReboot2;
		FixedText		aFTLogout;
		FixedText		aFTLogout2;

		String			aStrRebootYes;
		String			aStrRebootNo;
		String			aStrLogoutYes;
		String			aStrLogoutNo;

		FixedText		aFTChange;
		FixedText		aFTRecover;
		FixedText		aFTUnInstall;
		FixedText		aFTUnInstall2;
		FixedText		aFTUnInstallReboot;

		FixedImage 		aFILogo;

		BOOL 			bReboot;
public:
		PageHaveFun( SvAgentDlg* pParent, const ResId& rResId );
		~PageHaveFun();

	static SvAgentPage*		Create(SvAgentDlg* pParent, const ResId& rResId);
	virtual BOOL 			NotifyBack() const;
	virtual BOOL			AllowNext();

	String					GetNextText() const { return aStrRebootYes; }
	String					GetBackText() const { return aStrRebootNo; }

	void 					ShowReboot();
	void					ShowChange();
	void					ShowRecover();
	void					ShowUnInstall(BOOL Reboot = FALSE);
};

#endif //_PHAVEFUN_HXX
