/*************************************************************************
 *
 *  $RCSfile: psnr.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

#ifndef _SV_SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif

#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif

#ifndef _PVER_HXX
#include <svtools/pver.hxx>
#endif

#ifndef _SVTDEMO_HXX //autogen
#include <svtools/demo.hxx>
#endif

#ifndef _SISYS_HXX
#include <sifsys.hxx>
#endif

#include "maindlg.hxx"
#include "environ.hxx"
#include "maindlg.hxx"

#include "psnr.hxx"
#include "psnr.hrc"

#define 	LK_TYPE 		1
#define 	PLK_TYPE 		2
#define 	PALK_TYPE 		3

const char LK_EDIT_MASK[]	= "CCCCLCCCCLCCCCLCCCC";
const char LK_LITE_MASK[]	= "    -    -    -    ";

const char PLK_EDIT_MASK[]	= "CCCCLCCCCLCCCCCCLCCCCLCCCC";
const char PLK_LITE_MASK[]	= "    -    -      -    -    ";

const char PALK_EDIT_MASK[]	= "CCCCLCCCCLCCCCCCLCCCCCCLCCCCLCCCC";
const char PALK_LITE_MASK[]	= "    -    -      -      -    -    ";

PageSerialNumber::PageSerialNumber( SvAgentDlg* pParent, const ResId& rResId ) :
	SvAgentPage		( pParent, rResId ),
	aFILogo			( this, ResId(IMG_REG_LOGO, rResId.GetResMgr()) ),
	aFTInfo1		( this, ResId(FT_INFO1, rResId.GetResMgr()) ),
	aRB_PK			( this, ResId(RB_LK, rResId.GetResMgr()) ),
	aRB_PLK			( this, ResId(RB_PLK, rResId.GetResMgr()) ),
	aRB_PALK		( this, ResId(RB_PALK, rResId.GetResMgr()) ),
	aFTCustomerNr	( this, ResId(FT_CUSTOMERNR, rResId.GetResMgr()) ),
	aEDCustomerNr	( this, ResId(ED_CUSTOMERNR, rResId.GetResMgr()) ),
	aFTSNbr			( this, ResId(FT_LICENSENR, rResId.GetResMgr()) ),
	aEDSNbr			( this, ResId(ED_LICENSENR, rResId.GetResMgr()) ),
	aMediaKey		( ResId(STR_MEDIA_KEY, rResId.GetResMgr()) ),
	aPersonalKey	( ResId(STR_PERSONAL_KEY, rResId.GetResMgr()) ),
	aRegistrationKey( ResId(STR_REGISTRATION_KEY, rResId.GetResMgr()) )
{
	String aTitle(ResId(STR_TITLE, rResId.GetResMgr()));
	pParent->SetTitleStr( aTitle );

	FreeResource();

	nKeyType = 0;

	aRB_PK.		SetText( aMediaKey );
	aRB_PLK.	SetText( aPersonalKey );
	aRB_PALK.	SetText( aRegistrationKey );

	aRB_PK.		SetClickHdl( LINK(this, PageSerialNumber, ClickHdl) );
	aRB_PLK.	SetClickHdl( LINK(this, PageSerialNumber, ClickHdl) );
	aRB_PALK.	SetClickHdl( LINK(this, PageSerialNumber, ClickHdl) );

	aUpperPos1 = aFTCustomerNr.GetPosPixel();
	aUpperPos2 = aEDCustomerNr.GetPosPixel();
	aLowerPos1 = aFTSNbr.GetPosPixel();
	aLowerPos2 = aEDSNbr.GetPosPixel();

	if( getenv("STAR_LICFILE") )
	{
		SiDirEntry aEntry(getenv("STAR_LICFILE"));
		if( aEntry.Exists() )
		{
			Config aCfg( aEntry.GetFull() );
			ByteString aSection( "keys_" );
			aSection += ProductVersion::GetSystemID();
			aSection += "_";
			aSection += ProductVersion::GetLanguage();

			aCfg.SetGroup(aSection);
			static_Key_LK	= aCfg.ReadKey("LK");
			static_Key_PLK	= aCfg.ReadKey("PLK");
			static_Key_PALK	= aCfg.ReadKey("PALK");

			aCfg.SetGroup("user");
			static_CustomerNr = aCfg.ReadKey("customernr");
		}
	}
}

PageSerialNumber::~PageSerialNumber()
{

}

SvAgentPage* PageSerialNumber::Create( SvAgentDlg* pParent, const ResId& rResId )
{
	return new PageSerialNumber( pParent, rResId );
}

BOOL PageSerialNumber::AllowNext()
{
	if( ProductVersion::GetLicenseModel() == LicenseInternal )
		return TRUE;

	SiEnvironment* pEnv = GETDLG()->GetEnv();
	LicenseKeyInfo aInf;
	aKey = GetStripedKey();

	if( aEDCustomerNr.IsVisible() )
	{
		USHORT nLen = aEDCustomerNr.GetText().Len();
		if( !nLen )
		{
			ErrorBox(this, WB_OK, SvDemo::RequestErrorByteString(SvDemo::InvalidCustomerNr)).Execute();
			aEDCustomerNr.GrabFocus();
			return FALSE;
		} else if( nLen != 7 )
		{
			ErrorBox(this, WB_OK, SvDemo::RequestErrorByteString(SvDemo::InvalidCustomerNrLen)).Execute();
			aEDCustomerNr.GrabFocus();
			return FALSE;
		}
	}

	if( !::GetLicenseKeyInfo(aKey, aInf) ||
		((nKeyType == LK_TYPE) && !CheckLK(aKey)) )
	{
		ErrorBox( this, WB_OK, SvDemo::RequestErrorByteString(SvDemo::InvalidKey) ).Execute();
		return FALSE;
	}

	/*
	 *		dynamic edition for		LicenseStar
	 */
	ProductVersion::SetDynamicLicenseModel( aInf.eModel );
	if( ProductVersion::GetLicenseModel() == LicenseStar )
	{
		switch( aInf.aSerialNumber.GetChar(2) )
		{
			case '0' : ProductVersion::SetDynamicKeyEdition( PersonalDeLuxe ); break;
			case '1' : ProductVersion::SetDynamicKeyEdition( Professional ); break;
		}
	}
	/*
	 *		dynamic edition for		LicenseCampus
	 */
	else if( ProductVersion::GetLicenseModel() == LicenseCampus )
	{
		switch( aInf.aSerialNumber.GetChar(2) )
		{
			case '0' : ProductVersion::SetDynamicKeyEdition( Campus ); break;
			case '1' : ProductVersion::SetDynamicKeyEdition( Partner ); break;
			case '2' : ProductVersion::SetDynamicKeyEdition( Enterprice ); break;
			case '3' : ProductVersion::SetDynamicKeyEdition( Business ); break;
		}
	}
	//	 dynamic edition for		LicenseOEM2
	else if( ProductVersion::GetLicenseModel() == LicenseOEM2 )
	{
		switch( aInf.aSerialNumber.GetChar(2) )
		{
			case '0' :	ProductVersion::SetDynamicKeyEdition( OEM ); break;
			case '1' :	ProductVersion::SetDynamicKeyEdition( OEMProfessional ); break;
			default :	ProductVersion::SetDynamicKeyEdition( OEM ); break;
		}
	}
	//	dynamic edition for		LicensePUFF
	else if( ProductVersion::GetLicenseModel() == LicensePUFF )
		ProductVersion::SetDynamicKeyEdition( Personal );
	//	dynamic edition for		LicenseSmallBusiness
	else if( ProductVersion::GetLicenseModel() == LicenseSmallBusiness )
		ProductVersion::SetDynamicKeyEdition( SmallBusiness );

	USHORT nSysID = ProductVersion::GetSystemID();
	USHORT nLang  = ProductVersion::GetLanguage();

	if( ProductVersion::GetLicenseModel() != LicenseCampus &&
		ProductVersion::GetLicenseModel() != LicenseSmallBusiness )
	{	// bei Campus sind Sprache und Plattform egal
		if( aInf.nSystem != nSysID )
		{
			ErrorBox( this, WB_OK, SvDemo::RequestErrorByteString(SvDemo::InvalidOS) ).Execute();
			return FALSE;
		}
		else if( aInf.nLanguage != 0 &&
				 aInf.nLanguage != nLang )
		{
			ErrorBox( this, WB_OK, SvDemo::RequestErrorByteString(SvDemo::InvalidLanguage) ).Execute();
			return FALSE;
		}
	}

	pEnv->SetLicenseKey( aKey );
	return TRUE;
}

ByteString PageSerialNumber::GetStripedKey()
{
	ByteString aRet( aEDSNbr.GetText() );
	while( aRet.SearchAndReplace( "-", "") != STRING_NOTFOUND )
		;
	aRet.EraseTrailingChars();
	aRet.EraseLeadingChars();
	return aRet;
}

ULONG PageSerialNumber::GetProperty()
{
	SiEnvironment* pEnv = GETDLG()->GetEnv();
	if( aKey.Len() )
		pEnv->SetLicenseKey( aKey );
	else
		pEnv->SetLicenseKey( GetStripedKey() );

	pEnv->SetHumanLicenseKey( GetStripedKey() );

	if( nKeyType == PALK_TYPE )
		pEnv->SetCustomerNr( aEDCustomerNr.GetText() );
	else
		pEnv->SetCustomerNr( "" );

	if( ProductVersion::GetLicenseModel() != LicenseInternal )
		GetAgentDlg()->SetButtonState();

	return nKeyType;
}

void PageSerialNumber::InitProperty(ULONG nProp)
{
	if( nProp != PROP_NOTSET )
		SetKeyType( (USHORT)nProp );
	else
		SetKeyType( PALK_TYPE );

	SiEnvironment* pEnv = GETDLG()->GetEnv();
	if( pEnv->GetHumanLicenseKey().Len() )
	{
		aEDSNbr.SetByteString( pEnv->GetHumanLicenseKey() );
		aEDSNbr.Reformat();
	}
	if( pEnv->GetCustomerNr().Len() )
		aEDCustomerNr.SetText( pEnv->GetCustomerNr() );

	if( aEDCustomerNr.IsVisible() )
		aEDCustomerNr.GrabFocus();
	else
		aEDSNbr.GrabFocus();

	SiDirEntry aCLK_File(pEnv->GetStartPath());
	#ifdef UNX
	aCLK_File += ByteString( ".." ) ;
	#endif
	aCLK_File += ByteString("clk.ini");
	if( aCLK_File.Exists() )
	{
		Config aCfg( aCLK_File.GetFull() );
		aCfg.SetGroup("license");

		SetKeyType( PLK_TYPE );
		aEDSNbr.SetByteString( aCfg.ReadKey("KEY") );
		aEDSNbr.Reformat();
	}
}

IMPL_LINK( PageSerialNumber, ClickHdl, RadioButton*, pRBtn )
{
	if( aRB_PK.IsChecked() )
		SetKeyType( LK_TYPE );
	else if( aRB_PLK.IsChecked() )
		SetKeyType( PLK_TYPE );
	else if( aRB_PALK.IsChecked() )
		SetKeyType( PALK_TYPE );

	return 0;
}

void PageSerialNumber::SetKeyType( USHORT nType )
{
	ByteString aEditMask;
	ByteString aLiteMask;
	ByteString aKeyName;

	switch( nType )
	{
		case LK_TYPE :
			aRB_PK.Check(TRUE);
			nKeyType = LK_TYPE;
			aKeyName = aMediaKey;
			aFTCustomerNr.Hide();
			aEDCustomerNr.Hide();
			aEditMask = LK_EDIT_MASK;
			aLiteMask = LK_LITE_MASK;
			break;

		case PLK_TYPE :
			aRB_PLK.Check(TRUE);
			nKeyType = PLK_TYPE;
			aKeyName = aPersonalKey;
			aFTCustomerNr.Hide();
			aEDCustomerNr.Hide();
			aEditMask = PLK_EDIT_MASK;
			aLiteMask = PLK_LITE_MASK;
			break;

		case PALK_TYPE :
			aRB_PALK.Check(TRUE);
			nKeyType = PALK_TYPE;
			aKeyName = aRegistrationKey;
			aFTCustomerNr.Show();
			aEDCustomerNr.Show();
			aEditMask = PALK_EDIT_MASK;
			aLiteMask = PALK_LITE_MASK;
			break;
	}

	if( nKeyType == PALK_TYPE )
	{
		aFTCustomerNr.SetPosPixel( aUpperPos1 );
		aEDCustomerNr.SetPosPixel( aUpperPos2 );
		aFTSNbr.SetPosPixel( aLowerPos1 );
		aEDSNbr.SetPosPixel( aLowerPos2 );
	}
	else
	{
		aFTSNbr.SetPosPixel( aUpperPos1 );
		aEDSNbr.SetPosPixel( aUpperPos2 );
	}

	aKeyName += ':';
	aFTSNbr.SetText( aKeyName );

	aEDSNbr.SetMask( aEditMask, aLiteMask );
	aEDSNbr.SetStyle( aEDSNbr.GetStyle() | WB_NOHIDESELECTION );
	aEDSNbr.SetStrictFormat( TRUE );

	Font aFont = System::GetStandardFont( STDFONT_FIXED );
	aFont.SetSize( aEDSNbr.GetPointFont().GetSize() );
	aEDSNbr.SetControlFont( aFont );
	aEDCustomerNr.SetControlFont( aFont );

	long nWidth = aEDSNbr.GetTextSize( aEDSNbr.GetLiteralMask() ).Width();
	aEDSNbr.SetPosSizePixel( 0, 0, nWidth+12, 0, WINDOW_POSSIZE_WIDTH );
	aEDCustomerNr.SetPosSizePixel( 0, 0, nWidth+12, 0, WINDOW_POSSIZE_WIDTH );

	if( static_Key_LK.Len() && nType == LK_TYPE )
	{
		aEDSNbr.SetByteString( static_Key_LK );
		aEDSNbr.Reformat();
	} else if( static_Key_PLK.Len() && nType == PLK_TYPE )
	{
		aEDSNbr.SetByteString( static_Key_PLK );
		aEDSNbr.Reformat();
	} else if( static_Key_PALK.Len() && nType == PALK_TYPE )
	{
		aEDSNbr.SetByteString( static_Key_PALK );
		aEDSNbr.Reformat();
		aEDCustomerNr.SetText( static_CustomerNr );
	}
}

