/*************************************************************************
 *
 *  $RCSfile: puninst.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:51:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "maindlg.hxx"
#include "environ.hxx"

#include "puninst.hxx"
#include "puninst.hrc"

PageUnInstall::PageUnInstall( SvAgentDlg* pParent, const ResId& rResId ) :
	SvAgentPage		( pParent, rResId ),
	aExpMark		( this, ResId(IMG_EXPMARK, rResId.GetResMgr()) ),
	aFTInfo1		( this, ResId(FT_INFO1, rResId.GetResMgr()) ),
	aFTTimeCheck	( this, ResId(FT_TIMECHECK, rResId.GetResMgr()) ),
	aCBTimeCheck	( this, ResId(CB_TIMECHECK, rResId.GetResMgr()) )
{
	String aText( ResId(STR_TITLE, rResId.GetResMgr()) );
	aText.SearchAndReplace( UniString::CreateFromAscii("%1"),
			UniString::CreateFromAscii(GETDLG()->GetEnv()->GetProductName().GetBuffer()) );
	pParent->SetTitleStr( aText );
	FreeResource();

	aText = aFTInfo1.GetText();
	aText.SearchAndReplace( UniString::CreateFromAscii("%1"),
			UniString::CreateFromAscii(GETDLG()->GetEnv()->GetProductName().GetBuffer()) );
	aText.SearchAndReplace( UniString::CreateFromAscii("%2"),
			UniString::CreateFromAscii(GETDLG()->GetEnv()->GetInstalledPath().GetBuffer()) );
	aText.SearchAndReplace( UniString::CreateFromAscii("%3"), pParent->GetNextText() );
	aFTInfo1.SetText( aText );

	aText = aFTTimeCheck.GetText();
	aText.SearchAndReplace( UniString::CreateFromAscii("%1"),
			UniString::CreateFromAscii(GETDLG()->GetEnv()->GetProductName().GetBuffer()) );
	aFTTimeCheck.SetText( aText );
}

PageUnInstall::~PageUnInstall()
{
}

SvAgentPage* PageUnInstall::Create( SvAgentDlg* pParent, const ResId& rResId )
{
	return new PageUnInstall( pParent, rResId );
}

ULONG PageUnInstall::GetProperty()
{
	SiEnvironment* pEnv = GETDLG()->GetEnv();
	if( aCBTimeCheck.IsChecked() )
		pEnv->SetTimeCheck( FALSE );
	else
		pEnv->SetTimeCheck( TRUE );
	return 0;
}

void PageUnInstall::InitProperty(ULONG nProp)
{
	SiEnvironment* pEnv = GETDLG()->GetEnv();
	aCBTimeCheck.Check( !pEnv->IsTimeCheck() );
}

