#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:51:06 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..

PRJNAME=SETUP2
TARGET=setup

VERSION=$(UPD)
GEN_HID=TRUE
USE_LDUMP2=TRUE

# --- Settings -----------------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

VERINFONAME=verinfo

.IF "$(GUI)" == "WNT" || "$(GUI)" == "WIN"
RCFILES=verinfo.rc
.ENDIF

.IF "$(solarlang)" != "deut"
BIN!:=$(BIN)$/$(solarlang)
.ENDIF

.IF "$(GUI)"=="WIN"
LINKFLAGS=$(LINKFLAGS) /PACKC:32768
.ENDIF

.IF "$(GUI)"=="OS2"
# Das OS2 - Setup wird mit der statischen C-Runtime gelinkt !
STDLIBGUIST=cppom30.lib os2386.lib
STDLIBGUIMT=cppom30.lib os2386.lib
.ENDIF

.IF "$(GUI)"=="WNT"
#LIBCMT:=libcmt.lib
#LIBCIMT:=libcimt.lib
.ENDIF
.IF "$(GUI)" == "WIN"
STDLIB+=llibce.lib
.ENDIF

RSCLOCINC!:=$(PRJ)$/res -I$(RSCLOCINC)

RESLIB1NAME=set
RESLIB1SRSFILES=\
	$(SRS)$/service.srs	\
	$(SRS)$/uibase.srs	\
	$(SRS)$/pages.srs	\
	$(SRS)$/ui.srs		\
	$(SRS)$/dialog.srs

# --- setup dynamic link library -----------------------------------------

LIB1TARGET = $(SLB)$/set.lib
LIB1FILES = \
		$(SLB)$/pages.lib      	\
		$(SLB)$/agenda.lib     	\
		$(SLB)$/compiler.lib	\
		$(SLB)$/sibasic.lib    	\
		$(SLB)$/other.lib      	\
		$(SLB)$/sicustom.lib	\
		$(SLB)$/service.lib	\
		$(SLB)$/uibase.lib

.IF "$(GUI)"=="MAC"
LIB1FILES += $(SLB)$/macos.lib
.ENDIF
.IF "$(GUI)"=="OS2"
LIB1FILES += $(SLB)$/os2os.lib
.ENDIF
.IF "$(GUI)"=="UNX"
LIB1FILES += $(SLB)$/mowos.lib
.ENDIF
.IF "$(GUIBASE)"=="WIN"
LIB1FILES += $(SLB)$/winos.lib
.ENDIF

# ---------------------------------

.IF "$(solarlang)" == "deut"
SHL1TARGET = set$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB = iset
SHL1LIBS = $(LIB1TARGET)
SHL1DEF=    $(MISC)$/$(SHL1TARGET).def

SHL1DEPN = $(L)$/itools.lib $(SVLIBDEPEND)

.IF "$(GUI)"=="UNX"

SHL1STDLIBS=\
		$(VOSLIB) $(SALLIB) $(SOTLIB) \
		$(TOOLSLIB) $(SVLIB) $(SVTOOLLIB) $(SVLLIB) $(BASICLIB)	\
		$(CPPUHELPERLIB)

SHL1STDLIBS += \
	-Bdynamic $(THREADLIB) \
	-lXt \
	-lX11 \
	-lXext \
	-lXmu

.ELSE			# "$(GUI)"=="UNX"
SHL1OBJS = $(SLO)$/agenda.obj

SHL1STDLIBS=\
		$(VOSLIB) $(SALLIB) $(SOTLIB) \
		$(TOOLSLIB) $(SVLIB) $(SVTOOLLIB) $(SVLLIB) $(BASICLIB) \
		$(SVUNZIPDLL) $(CPPUHELPERLIB)
.ENDIF			# "$(GUI)"=="UNX"

.IF "$(GUI)"=="WNT"
SHL1STDLIBS += \
		advapi32.lib gdi32.lib shell32.lib ole32.lib uuid.lib version.lib \
		winmm.lib
.ENDIF

.IF "$(GUI)"=="OS2"
SHL1STDLIBS += \
		eaimp
.ENDIF

.IF "$(UPD)" >= "560"
SHL1STDLIBS += \
		$(CPPULIB)
.ENDIF

DEF1NAME    =$(SHL1TARGET)
DEF1DEPN    =$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =set
DEF1DES     =S.E.T.U.P.

.IF "$(GUI)"=="WNT"
DEF1EXPORT1 = component_writeInfo
DEF1EXPORT2 = component_getFactory
DEF1EXPORT3 = component_getImplementationEnvironment
.ELSE
.IF "$(COM)"=="ICC"
DEF1EXPORT1 = component_writeInfo
DEF1EXPORT2 = component_getFactory
DEF1EXPORT3 = component_getImplementationEnvironment
.ELSE
DEF1EXPORT1 = _component_writeInfo
DEF1EXPORT2 = _component_getFactory
DEF1EXPORT3 = _component_getImplementationEnvironment
.ENDIF
.ENDIF


# --- setup binary --------------------------------------------------------

APP2TARGET = $(TARGET)

APP2ICON= setup.ico
APP2VERINFO=verinfo.rc
APP2LINKRES=$(MISC)$/$(TARGET).res

APP2LIBS+=\
		$(LB)$/ui.lib			\
		$(LB)$/dialog.lib		\
		$(LB)$/iset.lib


APP2STDLIBS=\
		$(VOSLIB) $(SALLIB) $(SOTLIB) $(UNOLIB) \
		$(TOOLSLIB) $(SVLIB) $(SVTOOLLIB) $(SVLLIB) $(SJLIB) $(BASICLIB) \
		$(AUTOMATIONLIB)

.IF "$(GUI)"=="WNT"
APP2STDLIBS += \
		advapi32.lib gdi32.lib shell32.lib ole32.lib uuid.lib version.lib \
		winmm.lib
.ENDIF

.IF "$(GUI)"=="OS2"
APP2STDLIBS += \
		eaimp
.ENDIF

.IF "$(GUI)"=="UNX"

.IF "$(OS)"=="LINUX"
APP2STDLIBS+= 	\
	$(RTLLIB)	\
	$(TECLIB)	\
	$(TKLIB)	\
	$(CPPULIB)
.ENDIF

.IF "$(OS)" == "SOLARIS"
APP2STDLIBS += \
	-lset$(UPD)$(DLLPOSTFIX) \
	-Bdynamic $(THREADLIB) \
	-lXm \
	-lXt \
	-lX11 \
	-lXext \
	-lXmu
.ENDIF

.IF "$(OS)"=="LINUX"
APP2STDLIBS+= 	\
	-lset$(UPD)$(DLLPOSTFIX) \
	-Wl,-Bdynamic $(THREADLIB) \
	-lXt \
	-lX11 \
	-lXext \
	-lXmu \
	-lSM \
	-lICE
.ENDIF

.ENDIF

APP2DEPN=\
	$(LB)$/ui.lib 				\
	$(SLB)$/pages.lib			\
	$(LB)$/dialog.lib			\
	makefile.mk

.IF "$(GUI)" != "UNX"
APP2OBJS+=\
		$(OBJ)$/main.obj		\
		$(OBJ)$/mainwnd.obj		\
		$(OBJ)$/mainevt.obj		\
		$(OBJ)$/magenda.obj		\
		$(OBJ)$/textani.obj
.ENDIF

APP2DEF=   $(MISCX)$/$(TARGET).def

.ENDIF			# "$(solarlang)" == "deut"

# --- setup --------------------------------------------------------------


.IF "$(GUI)"!="UNX"

	#
	#	Loader
	#

APP3NOSAL=TRUE
APP3TARGET=loader
.IF "$(GUI)"=="WNT"
APP3STDLIBS=svunzip.lib gdi32.lib advapi32.lib libcmt.lib
.ENDIF
.IF "$(GUI)"=="WIN"
APP3STDLIBS=svunzip
.ENDIF
.IF "$(GUI)"=="OS2"
APP3STDLIBS=$(SVUNZIPLIB)
.ENDIF
.IF "$(GUI)"=="WNT"
APP3OBJS = $(OBJ)$/loader.obj $(OBJ)$/larch.obj
.ELSE
APP3OBJS = $(OBJ)$/loader.obj $(OBJ)$/arch.obj
.ENDIF
APP3DEF = $(MISCX)$/loader.def
APP3RES = $(RES)$/loader.res
APP3NOSVRES = $(RES)$/loader.res

.ENDIF			# "$(GUI)"!="UNX"

# -------------------------------------------------------------------------
# --- Targets -------------------------------------------------------------

.IF "$(depend)" == ""

ALL: \
	$(LIB1TARGET)		\
	ALLTAR

# -------------------------------------------------------------------------
# -------------------------------------------------------------------------
UPDATE_TEST : makefile.mk setup.inf f_zip f_zipdir
	@echo ------------------------------
.IF "$(GUI)"!="MAC"
.IF "$(UPDATER)"=="YES"
	+-$(COPY) setup.inf $(BIN)$
	+-$(COPY) setup.inf $(BIN)$/setup.ins
	+-$(COPY) f_zip $(BIN)$
	+-$(COPY) f_zipdir $(BIN)$
	+-$(COPY) $(SOLARBINDIR)$/vcl???49.res $(BIN)$
.ENDIF
.ENDIF

# -------------------------------------------------------------------------
# Filter fuer set?????.dll
# -------------------------------------------------------------------------
$(MISC)$/$(SHL1TARGET).flt : makefile.mk
    @echo ------------------------------
    @echo Making: 						$@
    @echo Impl							>$@
    @echo Registry_Api					>>$@

# -------------------------------------------------------------------------
# UNX
# -------------------------------------------------------------------------
.IF "$(GUI)" == "UNX"
$(MISCX)$/$(TARGET).def : makefile.mk
	echo  Kein def-File fuer unx

.ENDIF

# -------------------------------------------------------------------------
# Windows 3.1
# -------------------------------------------------------------------------
.IF "$(GUI)" == "WIN"

$(MISCX)$/$(TARGET).def : makefile.mk
	echo  NAME			$(TARGET)							          >$@
	echo  DESCRIPTION	'StarDivision Setup-Programm Version 2.00'   >>$@
	echo  EXETYPE		WINDOWS 									 >>$@
	echo  STUB			'winSTUB.EXE'								 >>$@
	echo  PROTMODE													 >>$@
	echo  CODE			LOADONCALL MOVEABLE DISCARDABLE				 >>$@
	echo  DATA			PRELOAD MOVEABLE MULTIPLE					 >>$@
	echo  HEAPSIZE		8192										 >>$@
	echo  STACKSIZE 	32000										 >>$@

.IF "$(product)" != ""
winloader:
	copy $(RES)$/eloader.res $(RES)$/loader.res
#	copy $(RES)$/eloader.res $(RES)$/enus\loader.res
	cd $(PRJ)$/win\source\loader
	nmake -f makefile.old product=full -a
	cd ..\..\..\util
.ELSE
winloader:
	copy $(RES)$/enus\eloader.res $(RES)$/loader.res
	copy $(RES)$/enus\eloader.res $(RES)$/enus\loader.res
	cd $(PRJ)$/win\source\loader
	nmake -f makefile.old -a
	cd ..\..\..\util
.ENDIF

$(MISCX)$/loader.def : makefile.mk
	echo  NAME			LOADER							   >$@
	echo  DESCRIPTION	'Loader Version 4.00'              >>$@
	echo  EXETYPE		WINDOWS 						   >>$@
	echo  STUB			'winSTUB.EXE'                      >>$@
	echo  PROTMODE										   >>$@
	echo  CODE			PRELOAD NONDISCARDABLE			   >>$@
	echo  DATA			PRELOAD MOVEABLE MULTIPLE		   >>$@
	echo  HEAPSIZE		8192							   >>$@
	echo  STACKSIZE 	16384							   >>$@

.ENDIF

# -------------------------------------------------------------------------
# Presentation Manager 2.0
# -------------------------------------------------------------------------

.IF "$(GUI)" == "OS2"

$(MISCX)$/$(TARGET).def : makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  NAME			$(TARGET) WINDOWAPI 						  >$@
	echo  DESCRIPTION	'StarDivision Setup-Programm Version 2.00'   >>$@
.IF "$(COM)" != "BLC"
	echo  STUB			'os2STUB.EXE'								 >>$@
.ENDIF
	echo  EXETYPE		OS2 										 >>$@
	echo  PROTMODE													 >>$@
	echo  CODE			LOADONCALL									 >>$@
	echo  DATA			PRELOAD MULTIPLE							 >>$@
	echo  HEAPSIZE		8192										 >>$@
	echo  STACKSIZE		524288										 >>$@

$(MISCX)$/loader.def : makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  NAME			SETUP WINDOWAPI				 	   >$@
	echo  DESCRIPTION	'Loader - Version 4.00'            >>$@
.IF "$(COM)" != "BLC"
	echo  STUB			'os2STUB.EXE'                      >>$@
.ENDIF
	echo  EXETYPE		OS2 							   >>$@
	echo  CODE			PRELOAD 						   >>$@
	echo  DATA			PRELOAD MULTIPLE				   >>$@
	echo  STACKSIZE 	16000							   >>$@

$(MISCX)\pguard.def : makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  NAME			$(TARGET) WINDOWAPI 						  >$@
	echo  DESCRIPTION	'StarDivision PGuard 4.00'   >>$@
.IF "$(COM)" != "BLC"
	echo  STUB			'os2STUB.EXE'								 >>$@
.ENDIF
	echo  EXETYPE		OS2 										 >>$@
	echo  PROTMODE													 >>$@
	echo  CODE			LOADONCALL									 >>$@
	echo  DATA			PRELOAD MULTIPLE							 >>$@
	echo  HEAPSIZE		8192										 >>$@
	echo  STACKSIZE 	30000										 >>$@

ea:
	call swos2.cmd

.ENDIF

.ENDIF

.INCLUDE :  target.mk

