/*************************************************************************
 *
 *  $RCSfile: loader.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: ok $ $Date: 2000/10/09 12:18:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <windows.h>

#define _LOADER_CXX
#include "arch.hxx"

#include "loader.h"
#include "svunzip.h"

#include <ctype.h>
#include <direct.h>
#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\stat.h>
#include <sys\locking.h>
#include <dos.h>


//////////////////////////////////////////////////////////////////////////
// defines

#define OS_ERROR				0
#define OS_WIN95				1
#define OS_WIN98				2
#define OS_NT35					3
#define OS_NT4					4
#define OS_NT5					5

#define APPQUIT_TIMER			1
#define MAX_LINE_BUF			_MAX_PATH

#define W16_MAX_WAIT 			18000	// EnumWindows count
#define WNT_MAX_WAIT			30000	// milisec.

#define	MAX_IDENTIFYER_LEN		30
#define MAX_LINE_BUF			_MAX_PATH
#define LPARAM_ENUMWINDOWS		100
#define CPY_BUF_SZ				32000

#define UNLOADER_FILENAME		"uinst001.exe"

//////////////////////////////////////////////////////////////////////////
// globals
HINSTANCE	hInst;
#ifdef WIN
HANDLE	hInstallInst;
#else
UINT	hInstallInst;
#endif
HWND	hWnd;
char	szModuleFileName[260];
char	szSourcePath[260];
char	szTempPath[260];
char	szSetupEXE[260];
char	szEXE[260];
char	szSetupOrgZIP[260];
char	szSetupZIP[260];
char	szSetupINI[260];
char	szOldPath[260];
char	szCommandLine[100];
BOOL	bError = FALSE;
BOOL	bShow = TRUE;
int 	nOldDrive, nCommand = 0;
ULONG	nMinTempSize = 0;
ULONG	nBigDataOffset = 0;
ULONG	nUnloaderOffset = 0;
BOOL 	bExtractBIG = FALSE;
static char strExtractPath[MAX_PATH];

char 	strLoaderTemp[260];
char 	strWEBStartPath[_MAX_PATH];
HFILE	hLoaderTemp;

char 	strProcessIdentifyer[MAX_IDENTIFYER_LEN];
int 	nProcessIdentifyerLen;
DWORD	nProcessID = 0;

static const char strUnloaderPatch[]	= "UNLOAD:xxxxxxxxxxxxxxx";
static const char strExePatch[]			= "BIGFILE:patchpatchpatch";

//////////////////////////////////////////////////////////////////////////
// GETDISKFREESPACE

#if defined (TCPP) && defined (WIN)
#define _stat stat
#define _diskfree_t diskfree_t
#endif

#ifdef WIN
#define GETDISKFREESPACE(nBytes,sRootName) \
	{ \
		nBytes = 0; \
		unsigned attr; \
		if ( _dos_getfileattr(sRootName,&attr) == 0 ) { \
			struct	_diskfree_t info; \
			_dos_getdiskfree( 1 + toupper( (sRootName)[0] ) - 'A', &info ); \
			nBytes = (DWORD)info.avail_clusters * \
				(DWORD)info.sectors_per_cluster * \
				(DWORD)info.bytes_per_sector; } \
	}
#define GETTEXTEVENT( aHDC, cpText, nTxtLen, nWidth ) \
	nWidth = LOWORD ( GetTextExtent( aHDC, cpText, nTxtLen ) )
#else
#define GETDISKFREESPACE(nBytes,sRootName) \
	{ \
		nBytes = 0; \
		if ( GetFileAttributes(sRootName) != 0xFFFFFFFF ) { \
			char cpDrive[4]; \
			strncpy( cpDrive, sRootName, 3 ); \
			cpDrive[3] = '\0'; \
			DWORD nSecPerClu, nBytesPerSec, nFreeClu, nClu; \
			if ( GetDiskFreeSpace( cpDrive, &nSecPerClu, \
								   &nBytesPerSec, &nFreeClu, &nClu ) ) \
				nBytes = nSecPerClu * nBytesPerSec * nFreeClu; } \
	}
#define GETTEXTEVENT( aHDC, cpText, nTxtLen, nWidth ) \
	{ \
		SIZE aSize; \
		GetTextExtentPoint32( aHDC, cpText, nTxtLen, &aSize ); \
		nWidth = aSize.cx; \
	}
#endif

//////////////////////////////////////////////////////////////////////////
//	BOOL CALLBACK _EnumCallBack( HWND hWnd, LPARAM lParam )
//	BOOL _GetAppPID()
//	BOOL _WaitForObject( const char* pWinTitle )

BOOL CALLBACK _EnumCallBack( HWND hWnd, LPARAM lParam )
{
	char cWinTitle[MAX_IDENTIFYER_LEN];
	char cClassName[MAX_IDENTIFYER_LEN];

	memset( cWinTitle, 0, MAX_IDENTIFYER_LEN );
	memset( cClassName, 0, MAX_IDENTIFYER_LEN );

	GetWindowText( hWnd, cWinTitle, MAX_IDENTIFYER_LEN );
	GetClassName( hWnd, cClassName, MAX_IDENTIFYER_LEN );

	if( (strncmp(cWinTitle, strProcessIdentifyer, nProcessIdentifyerLen) == 0) &&
	#ifdef VCL
		(strcmp(cClassName, "SALFRAME") == 0) )
	#else
		(strcmp(cClassName, "SVMDIFRAME") == 0) )
	#endif
	{
	#ifdef WNT
		GetWindowThreadProcessId( hWnd, &nProcessID );
	#else
		nProcessID = GetWindowTask( hWnd );
	#endif
		return FALSE;
	}
	return TRUE;
}

BOOL _GetAppPID()
{
	BOOL bResult = EnumWindows( (WNDENUMPROC)_EnumCallBack, LPARAM_ENUMWINDOWS );
	return !bResult;
}

BOOL _WaitForObject( const char* pWinTitle )
{
	strcpy( strProcessIdentifyer, pWinTitle );
	nProcessIdentifyerLen = strlen( strProcessIdentifyer );

	BOOL bSuccess = TRUE;

	#ifdef WIN
	{
		MSG aMsg;
		unsigned short nSaveCnt = 0;

		while( _GetAppPID() && nSaveCnt < W16_MAX_WAIT )
			PeekMessage(&aMsg, 0, 0, 0, PM_REMOVE);

		if( nSaveCnt == W16_MAX_WAIT )
			bSuccess = FALSE;
	}
	#else
	{
		if( _GetAppPID() )
		{
			HANDLE hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, nProcessID);
			DWORD nResult = WaitForSingleObject(hProcess, WNT_MAX_WAIT);
			bSuccess = nResult == WAIT_TIMEOUT? FALSE : TRUE;
		}
	}
	#endif

	return bSuccess;
}

//////////////////////////////////////////////////////////////////////////
// IsShareLoaded()
int IsShareLoaded()
{
#ifdef WIN
	int bShare = 0;
	union REGS aInRegs;
	union REGS aOutRegs;

	aInRegs.x.ax = 0x1000;

	int86( 0x2F, &aInRegs, &aOutRegs ); // Interrupt-Aufruf

	if ( aOutRegs.h.al == 0xFF )
	{
		// temporaeres File erzeugen
		FILE* pFile = fopen( "c:\\sy1.tmp", "a" );
		if ( pFile )
		{
			fprintf( pFile, "Das ist nur temporaer. Wird gleich wieder geloescht" );
			fclose( pFile );
		}

		int rc, handle = _lopen( "c:\\sy1.tmp",
								 READ_WRITE | OF_SHARE_DENY_NONE );

		if ( handle > -1 )
		{
			rc =  locking( handle, LK_NBLCK, 10 ) ;

			if ( rc == 0 )
			{
				bShare = 1;
				locking( handle, LK_UNLCK, 10 ) ;
			}
			_lclose( handle );
		}
		else
			bShare = 1;
		_unlink( "c:\\sy1.tmp" );
	}
	return bShare;
#else
	return 1;
#endif
}

USHORT GetOSVersion()
{
	USHORT nOS = OS_ERROR;
	WORD nGUIVersion = (WORD) GetVersion();
	USHORT nVer = ((((USHORT)LOBYTE(nGUIVersion))*100)+HIBYTE(nGUIVersion));

	if( nVer == 351 )
	{
		nOS = OS_NT35;
		return nOS;
	}
	else if( nVer == 400 || nVer == 395 )    // win95 || w16 unter win95
		nOS = OS_WIN95;
	else if( nVer == 410 )
		nOS = OS_WIN98;

#ifdef WNT
	OSVERSIONINFO aVerInfo;
	aVerInfo.dwOSVersionInfoSize = sizeof( aVerInfo );
	if ( GetVersionEx( &aVerInfo ) )
	{
		if ( aVerInfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
			if( aVerInfo.dwBuildNumber >= 1382 )
				nOS = OS_NT5;
			else
				nOS = OS_NT4;
	}
#endif
	return nOS;
}

//////////////////////////////////////////////////////////////////////////
// CopyZipFile()
BOOL CopyZipFile( const char* pFrom, const char* pTo )
{
	OFSTRUCT ofSource, ofDest;
	HFILE	 hSource, hDest;
	int 	 nRead;
	PBYTE	 pbBuf;

	hSource = OpenFile( pFrom, &ofSource, OF_READ  );
	hDest = OpenFile( pTo, &ofDest, OF_CREATE );
	BOOL bOpen = TRUE;

	if ( HFILE_ERROR == hSource )
	{
		char cErr[_MAX_PATH];
		LoadString( hInst, IDS_NOOPEN, cErr, sizeof(cErr) );
		strcat( cErr, pFrom );
		InfoBox( hWnd, cErr );
		bOpen = FALSE;
	}

	if ( HFILE_ERROR == hDest )
	{
		char cErr[_MAX_PATH];
		LoadString( hInst, IDS_NOOPEN, cErr, sizeof(cErr) );
		strcat( cErr, pTo );
		InfoBox( hWnd, cErr );
		bOpen = FALSE;
	}

	if ( !bOpen )
		return FALSE;

	/* allocate a buffer for file I/O */
	pbBuf = (PBYTE)LocalAlloc( LMEM_FIXED, 2048 );

	/* copy the source file to the dest file */
	do
	{
		nRead = _lread( hSource, pbBuf, 2048 );
		_lwrite( hDest, (LPCSTR)pbBuf, nRead );
	} while ( nRead != 0 );

	/* free the buffer and close the files */
	LocalFree( (HLOCAL)pbBuf );

	_lclose( hSource );
	_lclose( hDest );

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// trim()
void trim(char *pTmpPath)
{
	if (pTmpPath[0] == '\0')
		return;

	int i=0;

	while(pTmpPath[i] == ' ')
		i++;

	if (i != 0)
		strcpy(pTmpPath,pTmpPath+i);
}


//////////////////////////////////////////////////////////////////////////
// GetTempPath()
const char* GetTempPath(char* pBuf)
{
	char	cpTmpPath[_MAX_PATH] = "";
	DWORD	dwSize = 0;
	BOOL	bTempFound = FALSE;

#ifdef WIN
	// dieser Code stammt aus der Hilfe zum Windows SDK (GetDOSEnvironment)
	LPSTR pEnv = GetDOSEnvironment();

	while (*pEnv != 0 && !bTempFound)
	{
		short nNameLen = strchr( pEnv, '=' ) - pEnv;

		if (strncmp(pEnv, "TEMP", nNameLen) == 0
		||  strncmp(pEnv, "TMP",  nNameLen) == 0)
		{
			bTempFound = TRUE;
			strcpy( cpTmpPath, pEnv + nNameLen + 1 );
		}

		// Move to the next environment string
		pEnv += strlen(pEnv) + 1;
	}

#else
	// Windows NT kennt kein GetDOSEnvironment
	if (GetEnvironmentVariable("TMP",  cpTmpPath, _MAX_PATH)
	||  GetEnvironmentVariable("TEMP", cpTmpPath, _MAX_PATH)
	||  GetEnvironmentVariable("tmp",  cpTmpPath, _MAX_PATH)
	||  GetEnvironmentVariable("temp", cpTmpPath, _MAX_PATH))
	{
		bTempFound = TRUE;
	}
#endif

	if( bTempFound )
	{
		struct _stat aStat;

		trim(cpTmpPath);

		if (_stat(cpTmpPath, &aStat) != 0  // nicht vorhanden
		|| (aStat.st_mode & S_IFDIR)  == 0) // oder kein Verzeichnis
		{
			strcpy(&cpTmpPath[1], ":\\"); // "d:\falsch" -> "d:\"
		}

		if (_stat(cpTmpPath, &aStat) == 0  // vorhanden
		&& (aStat.st_mode & S_IFDIR) != 0) // und ein Verzeichnis
		{
			strcpy( pBuf, cpTmpPath );
			return pBuf;
		}
	}

	if (GetWindowsDirectory( pBuf, _MAX_PATH))
	{
		return pBuf;
	}

	strcpy( pBuf, "c:\\" );
	return pBuf;
}


//////////////////////////////////////////////////////////////////////////
// GetTempFile()
void GetTempFile( char* cpTemp )
{
	// source stammt aus FSYS
	const char* dir;
	char*		ret_val;
	size_t		i;

	// dertermine Directory, Prefix and Extension
	char		pfx[6];
	char		ext[5];
	strcpy( pfx, "sv" );
	strcpy( ext, ".tmp" );

	char sBuf[_MAX_PATH];
	dir = GetTempPath(sBuf);
	if ( !dir )
		return;

	// ab hier leicht modifizierter Code von VB
	i = strlen(dir);
	ret_val = new char[i+2 /* '\0' & '\\' */ + 8 /*root*/ + 4 /*.ext*/];
	if (ret_val)
	{
		unsigned u;
		strcpy(ret_val,dir);

		/* Make sure directory ends with a separator	*/
		if ( i>0 && ret_val[i-1] != '\\' && ret_val[i-1] != '/' &&
			 ret_val[i-1] != ':')
			ret_val[i++] = '\\';

		strncpy(ret_val + i, pfx, 5);
		ret_val[i + 5] = '\0';      /* strncpy doesn't put a 0 if more  */
		i = strlen(ret_val);		/* than 'n' chars.          */

		/* Prefix can have 5 chars, leaving 3 for numbers.
		   26 ** 3 == 17576
		 */
		for (u = 1; u < 26*26*26; u++)
		{
			itoa(u,ret_val + i,26);
			strcat(ret_val,ext);
			struct stat aStat;
			if ( stat( ret_val, &aStat ) )
			{
				strcpy( cpTemp, ret_val );
				break;
			}
		}
		delete ret_val;
		ret_val = 0;
	}
}


//////////////////////////////////////////////////////////////////////////
// KillTempPath()
void KillTempPath( const char* pPath )
{
	if ( toupper( pPath[0] ) == 'A' || toupper( pPath[0] ) == 'B' )
		return;

	// Existiert Pfad ueberhaupt
	if (_access(pPath,0) < 0)
		return;

	char aRootPath[4];
	char* pPattern = (char*)malloc(256);

	strcpy( pPattern, pPath );
	strcat( pPattern, "\\*.*" );

#ifdef WIN
	struct find_t ffblk;
	int done = _dos_findfirst( pPattern, _A_NORMAL, &ffblk );
	while ( !done )
	{
		remove( ffblk.name );
		done = _dos_findnext( &ffblk );
	}
#else
	WIN32_FIND_DATA aFind;
	HANDLE aHdl;

	aHdl = FindFirstFile( pPattern, &aFind );

	if ( aHdl == INVALID_HANDLE_VALUE )
	{
		free( (char*)pPattern );
		return;
	}

	do
	{
		// voller Pfad zusammenbauen
		char cFullFile[260];
		strcpy( cFullFile, pPath );
		strcat( cFullFile, "\\" );
		strcat( cFullFile, aFind.cFileName );
		remove( cFullFile );
	}
	while ( FindNextFile( aHdl, &aFind ) );
	FindClose( aHdl );
#endif

	// Nach dem Inhalt ist die directory selbst faellig
	// voerher fluechten wir aber in die root, sonst ist nix mit loeschen
	int nError = 0;
	strncpy( aRootPath, pPath, 3);
	aRootPath[3] = 0;

	chdir( aRootPath );
	nError = _rmdir( pPath ) != 0;

#ifdef WNT
	if (nError)
	{
		WORD   nVer    = (WORD)GetVersion();
		USHORT nWinVer = (((USHORT)LOBYTE(nVer)) * 100) + HIBYTE(nVer);

		if (nWinVer < 400)		// == WNT351
		{
			char buf[100];
			strcpy(buf,"rmdir ");
			strcat(buf,pPath);
			strcat(buf," /s");
			system(buf);
		}
	}
#endif

	free( (char*)pPattern );
}


//////////////////////////////////////////////////////////////////////////
// WinMain()
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	message;

	// only one instance can run
	if ( hPrevInstance )
		return FALSE;
	else if ( !InitApplication( hInstance ) )
		return FALSE;

	if ( !InitInstance( hInstance, nCmdShow ) )
		return FALSE;

	// get module filename
	GetModuleFileName( hInst, szModuleFileName, sizeof(szModuleFileName) );

	// test, ob schon gestartet
	GetTempPath( strLoaderTemp );
	if ( strlen(strLoaderTemp) == 3 )
		// z.B. c:\ -> c:
		strLoaderTemp[2] = '\0';
	strcat( strLoaderTemp, "\\__loader.tmp" );

	// Testdatei anlegen
	OFSTRUCT OpenBuff;
	UINT fuMode = OF_CREATE;
	HFILE hFile = OpenFile( (LPCSTR)strLoaderTemp, &OpenBuff, fuMode );

	// wenn nicht geklappt, gleich wieder beenden
	if ( hFile == HFILE_ERROR )
		return FALSE;

	// sonst schlie/sen und gelockt "offnen
	_lclose( hFile );
	fuMode = OF_READWRITE | OF_SHARE_DENY_NONE;
	hLoaderTemp = OpenFile( (LPCSTR)strLoaderTemp, &OpenBuff, fuMode );

	if( hLoaderTemp == HFILE_ERROR )
		return FALSE;

	// copy command line
	if( strncmp(lpCmdLine, "-extract", 8) == 0 )
	{
		bExtractBIG = TRUE;
		char* ptr = strchr( &(lpCmdLine[3]), ' ' );
		if( ptr )
			strcpy( strExtractPath, ptr + 1 );
	}
	strcpy( szCommandLine, lpCmdLine );

	while ( GetMessage( &message, 0, 0, 0 ) )
	{
		TranslateMessage( &message );
		DispatchMessage( &message );
	}

	CleanupSetupFile();

	return message.wParam;
}


//////////////////////////////////////////////////////////////////////////
// InitApplication()
BOOL InitApplication( HINSTANCE hInstance )
{
	WNDCLASS  wc;

	wc.style		 = 0;
	wc.lpfnWndProc	 = MainWndProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra	 = 0;
	wc.hInstance	 = hInstance;
	wc.hIcon		 = 0;
	wc.hCursor		 = LoadCursor( 0, IDC_ARROW );
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = "SetupWClass";

	return RegisterClass( &wc );
}


//////////////////////////////////////////////////////////////////////////
// InitInstance()
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
	// save instance handle
	hInst = hInstance;
	#if (WINVER >= 0x0400)
	hWnd = CreateWindowEx( WS_EX_TOOLWINDOW, "SetupWClass", 0, WS_POPUP | WS_DLGFRAME,
		( GetSystemMetrics( SM_CXSCREEN ) - WINDOW_WIDTH )	/ 2,
		( GetSystemMetrics( SM_CYSCREEN ) - WINDOW_HEIGHT ) / 2,
		WINDOW_WIDTH, WINDOW_HEIGHT, 0, 0, hInstance, 0 );
	#else
	hWnd = CreateWindow( "SetupWClass", 0, WS_POPUP | WS_DLGFRAME,
		( GetSystemMetrics( SM_CXSCREEN ) - WINDOW_WIDTH )	/ 2,
		( GetSystemMetrics( SM_CYSCREEN ) - WINDOW_HEIGHT ) / 2,
		WINDOW_WIDTH, WINDOW_HEIGHT, 0, 0, hInstance, 0 );
	#endif


	if ( hWnd )
	{
//		ShowWindow( hWnd, nCmdShow );
//		UpdateWindow( hWnd );
		return TRUE;
	}
	else
		return FALSE;
}


//////////////////////////////////////////////////////////////////////////
// MainWndProc()
LONG FAR PASCAL MainWndProc( HWND hWnd, UINT message, WPARAM wParam,
	LPARAM lParam )
{
	switch (message)
	{
		//////////////////////////////////////////////////////////////////
		case WM_CREATE: {
			WORD nGUIVersion = (WORD) GetVersion();
			USHORT nVer = ((((USHORT)LOBYTE(nGUIVersion))*100)+HIBYTE(nGUIVersion));
			if( nVer == 351 )
			{
				ErrorBox( hWnd, IDS_WRONGOS, NULL );
				return 0;
			}

			char pULoad[50];
			strcpy(pULoad, &(strUnloaderPatch[7]) );

			if( pULoad[0] != 'x' )
			{
				for( USHORT i = 0; i < strlen(pULoad); ++i )
					if( pULoad[i] == 'x' )
					{
						pULoad[i] = 0x00;
						break;
					}
				nUnloaderOffset	= atol(pULoad);
			}

			nBigDataOffset	= atol(&(strExePatch[8]));

			if(  !nBigDataOffset )
				PostMessage( hWnd, WM_COMMAND, ID_INSTALL, 0 );
			else
				PostMessage( hWnd, WM_COMMAND, ID_INSTALL_BIG, 0 );
		} break;

		//////////////////////////////////////////////////////////////////
		case WM_COMMAND: {
			if ( wParam == ID_INSTALL )
			{
				InstallSetupFile( hWnd );
				return 0;
			}
			else if ( wParam == ID_INSTALL_BIG )
			{
				InstallBigSetupFile( hWnd );
			}
			else
				return DefWindowProc( hWnd, message, wParam, lParam );
		} break;

		//////////////////////////////////////////////////////////////////
		case WM_PAINT: {
			PAINTSTRUCT ps;

			BeginPaint( hWnd, &ps );

			HBITMAP hBmp = ::LoadBitmap( hInst, MAKEINTRESOURCE(3) );

			HDC 		hBmpDC = CreateCompatibleDC( ps.hdc );
			HBITMAP		hOldBmp = (HBITMAP) SelectObject( hBmpDC, hBmp );
			const int	nOldStretchMode = SetStretchBltMode( ps.hdc, STRETCH_DELETESCANS );

			StretchBlt( ps.hdc,
						0, 0, 280, 80, hBmpDC,
						0, 0, 280, 80, SRCCOPY );

			SetStretchBltMode( ps.hdc, nOldStretchMode );
			SelectObject( hBmpDC, hOldBmp );
			DeleteDC( hBmpDC );

			EndPaint( hWnd, &ps );
			return 0;
		} break;

		//////////////////////////////////////////////////////////////////
		case WM_TIMER: {
#ifdef WIN
			if( (wParam == APPQUIT_TIMER) && !GetModuleUsage( hInstallInst ) )
#else
			if( (wParam == APPQUIT_TIMER) && !remove(szEXE) )
#endif
			{
				BOOL bShutDown = FALSE;
				BOOL bLogoutOnly = FALSE;
				KillTimer( hWnd, APPQUIT_TIMER );

				FILE* pFile = fopen( "shutdown.me", "r" );
				if( pFile )
				{
					bShutDown = TRUE;
					char cBuf[100];
					memset( cBuf, 0, 100 );
					fread( cBuf, 1, 100, pFile );
					if( strcmp(cBuf,"logout") == 0 )
						bLogoutOnly = TRUE;
					fclose( pFile );
				}

				CleanupSetupFile();

				if( bShutDown )
				{
					USHORT nOS = GetOSVersion();
					if( nOS == OS_NT35 || nOS == OS_NT4 || nOS == OS_NT5 )
					{
						HANDLE hToken;
						if( OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &hToken) )
						{
							TOKEN_PRIVILEGES tp;
							tp.PrivilegeCount = 1;
							LookupPrivilegeValue( NULL, SE_SHUTDOWN_NAME, &tp.Privileges[0].Luid );
							tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
							AdjustTokenPrivileges( hToken, FALSE, &tp, sizeof(tp), NULL, NULL );
							if( bLogoutOnly )
								ExitWindowsEx( EWX_LOGOFF, 0 );
							else
								ExitWindowsEx( EWX_REBOOT, 0 );
							CloseHandle( hToken );
						}
					}
					else
						ExitWindowsEx( EWX_REBOOT, 0 );
				}

				PostMessage( hWnd, WM_CLOSE, 0, 0 );
			}
		} break;

		//////////////////////////////////////////////////////////////////
		case WM_DESTROY: {
			PostQuitMessage(0);
		} break;

		//////////////////////////////////////////////////////////////////
		default: {
			return DefWindowProc( hWnd, message, wParam, lParam );
		} break;
	}
	return 0;
}


//////////////////////////////////////////////////////////////////////////
// InstallSetupFile()

void __EnumFilesCallBack( char *pFile, ULONG nSize, void *pObject )
{ nMinTempSize += nSize; }

void __UnzipCallback(long lBytesWritten)
{
	MSG message;
	if( PeekMessage(&message, 0, 0, 0, PM_REMOVE) )
	{
		TranslateMessage( &message );
		DispatchMessage( &message );
	}
}

void UnpackBIG2Temp( ArchDirectory* pBigDir, BOOL bSize )
{
	ULONG nCnt			= pBigDir->GetCount();
	ArchEntry** ppRaw	= pBigDir->GetRawList();

	for( ULONG i = 0; i < nCnt; ++i )
	{
		ArchEntry* pEntry = (ArchEntry*)ppRaw[i];
		if( strncmp(pEntry->pName, "f0_", 3) == 0 )
			if( bSize )
				nMinTempSize += pEntry->nSize;
			else
			{
				pBigDir->GetFile( pEntry->pName, szTempPath );
				::SVUnzip( pEntry->pName, "*.*", (const char*)"qq", (UnzipCallBack*) __UnzipCallback );
				unlink( pEntry->pName );
			}
	}
}

void Unpack2Temp( BOOL bSize )
{
	char buf[MAX_PATH];
	strcpy( buf, szSourcePath );
	strcat( buf, "\\f0_*.*" );

	WIN32_FIND_DATA wfData;
	HANDLE hfnd = FindFirstFile( buf, &wfData );
	int nNextFile = 1;

	while( hfnd != INVALID_HANDLE_VALUE && nNextFile != 0 )
	{
		char file[16*1024];
		strcpy( file, szSourcePath );
	 	strcat( file, "\\" );
	 	strcat( file, wfData.cFileName );

		if( bSize )
			::SVUnzipEnumFiles( file, "*", (UnzipEnumFilesCallBack*)__EnumFilesCallBack, NULL );
		else
			::SVUnzip( file, "*.*", (const char*)"qq", (UnzipCallBack*) __UnzipCallback );

		nNextFile = FindNextFile( hfnd, &wfData );
	}
	FindClose( hfnd );
}

void InstallSetupFile( HWND hWnd, ArchDirectory* pBigDir )
{
	int 	nErr, nIndex;
	DWORD	dwFreeSize = 0;
	FILE*	pFile;
	char	cError[250];

	// create source path
	nIndex = lstrlen( szModuleFileName );
	while ( szModuleFileName[nIndex] != '\\' )
		nIndex--;
	strncpy( szSourcePath, szModuleFileName, nIndex );

	// get temp path
	GetTempFile( szTempPath );

	if ( szTempPath[0] != '\0' )
		nErr = mkdir( szTempPath );
	else
	{
		ErrorBox( hWnd, IDS_NOTEMPDIR, NULL );
		return;
	}

	if( nErr == -1 )
	{
		char szTmp[100];
		LoadString( hInst, IDS_TEMPDIR, szTmp, sizeof(szTmp) );
		strcpy( cError, szTmp );
		strcat( cError, szTempPath );
		LoadString( hInst, IDS_MAKEDIR, szTmp, sizeof(szTmp) );
		strcat( cError, szTmp );
		ErrorBox( hWnd, 0, cError );
		return;
	}

	nOldDrive = _getdrive();
	getcwd( szOldPath, 256 );

	// Ins Zielverzeichnis wechseln
	_chdrive( toupper( szTempPath[0] ) - 'A' + 1 );

	if( chdir( szTempPath ) == -1 )
	{
		char szTmp[100];
		LoadString( hInst, IDS_TEMPDIR, szTmp, sizeof(szTmp) );
		strcpy( cError, szTmp );
		strcat( cError, szTempPath );
		LoadString( hInst, IDS_SETCWD, szTmp, sizeof(szTmp) );
		strcat( cError, szTmp );
		ErrorBox( hWnd, 0, cError );
		return;
	}

	ExtractUnloader();

	if( !pBigDir )
		Unpack2Temp( TRUE );
	else
		UnpackBIG2Temp( pBigDir, TRUE );
	nMinTempSize += 512000; // ein Halbes geht noch.

	GETDISKFREESPACE(dwFreeSize, szTempPath);
	if( dwFreeSize < nMinTempSize )
	{
		ErrorBox( hWnd, IDS_NOTEMPSPACE, NULL );
		return;
	}

	if( !pBigDir )
		Unpack2Temp( FALSE );
	else
		UnpackBIG2Temp( pBigDir, FALSE );

	if ( nErr > 1 && nErr != 50 )
	{
		char szErr[250];
		char cErrCode[10];
		ltoa( nErr, cErrCode, 10 );
		LoadString( hInst, IDS_NOUNZIP, szErr, sizeof(szErr) );
		strcat( szErr, "\nErrorcode: " );
		strcat( szErr, cErrCode );
		ErrorBox( hWnd, 0, szErr );
		return;
	}

	strcpy( szSetupINI, szTempPath );
	strcat( szSetupINI, "\\setup.ini" );
	pFile = fopen( szSetupINI, "w+" );

	if ( pFile )
	{
		fprintf( pFile, "[source]\n" );

		if( pBigDir )
		{
			fprintf( pFile, "path=%s\n", szModuleFileName );
			fprintf( pFile, "big=1\n" );
			fprintf( pFile, "offset=%ld\n", nBigDataOffset );
		}
		else if ( strlen(szSourcePath) == 2 )
		{
			char szTmp[4];
			strncpy( szTmp, szSourcePath, 2 );
			szTmp[2] = '\\';
			szTmp[3] = 0;
			fprintf( pFile, "path=%s\n", szTmp );
		}
		else
			if( strlen(strWEBStartPath) )
				fprintf( pFile, "path=%s\n", strWEBStartPath );
			else
				fprintf( pFile, "path=%s\n", szSourcePath );
		fprintf( pFile, "[share]\n" );
		fprintf( pFile, "load=0\n" );
		fclose( pFile );
	}

	// Das eigentliche Setup Programm starten
	strcpy( szSetupEXE, szTempPath );
	strcat( szSetupEXE, "\\setup.exe" );
	strcpy( szEXE, szSetupEXE );
	strcat( szSetupEXE, " " );
	strcat( szSetupEXE, szCommandLine );

	// set command
	nCommand = 1 + szSourcePath[0] - 'A';

	// vorher mein Fenster schliessen
	ShowWindow( hWnd, SW_HIDE );
	UpdateWindow( hWnd );

	hInstallInst = WinExec( szSetupEXE, SW_SHOW );
	if( hInstallInst < 32 )
	{
		// Error occured
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		return;
	}
	SetTimer( hWnd, APPQUIT_TIMER, 100, NULL );
}

//////////////////////////////////////////////////////////////////////////
// ExtractUnloader()

void ExtractUnloader()
{
	if( !nUnloaderOffset )
		return;

	FILE* pThisFile = fopen( szModuleFileName, "rb" );
	if( !pThisFile )
		return;

	fseek( pThisFile, 0, SEEK_END );
	DWORD nSz = ftell( pThisFile );
	DWORD nUnloaderSz = nBigDataOffset? nBigDataOffset - nUnloaderOffset :
						nSz - nUnloaderOffset;

	char cFilename[_MAX_PATH];
	GetWindowsDirectory( cFilename, _MAX_PATH );

	strcat( cFilename, "\\" );
	strcat( cFilename, UNLOADER_FILENAME );

	FILE* pUnloaderFile = fopen(cFilename, "r");
	if( pUnloaderFile )
	{
		fclose( pUnloaderFile );
		DeleteFile( cFilename );
	}

	pUnloaderFile = fopen(cFilename, "wb");
	if( !pUnloaderFile )
	{
		fclose( pThisFile );
		return;
	}

	char cBuf[CPY_BUF_SZ];
	fseek( pThisFile, nUnloaderOffset, SEEK_SET );

	while( nUnloaderSz )
	{
		DWORD nToRead = nUnloaderSz > CPY_BUF_SZ? CPY_BUF_SZ : nUnloaderSz;
		DWORD nRead   = fread( cBuf, 1, nToRead, pThisFile );

		fwrite( cBuf, nToRead, 1, pUnloaderFile );
		nUnloaderSz -= nToRead;
	}

	fclose( pThisFile );
	fclose( pUnloaderFile );
}

//////////////////////////////////////////////////////////////////////////
// InstallBigSetupFile()

void InstallBigSetupFile( HWND hWnd )
{
	ArchDirectory aDir;
	if( !aDir.SetArchFile(szModuleFileName) )
	{
		ErrorBox( hWnd, 0, aDir.GetErrorMsg() );
		exit( -1 );
	}

	if( bExtractBIG )
	{
		USHORT nLen = strlen(strExtractPath);
		if( nLen ) {
			if( chdir(strExtractPath) == -1 ) {
				char cError[255];
				sprintf( cError, "ERROR: could not change directory (%s)", strExtractPath );
				ErrorBox( hWnd, 0, cError );
				exit( -1 );
			}
		}
		else strcpy( strExtractPath, "." );

		aDir.ExtractAll( strExtractPath );
		exit( 0 );
	}
	else
		InstallSetupFile( hWnd, &aDir );
}

//////////////////////////////////////////////////////////////////////////
// CleanupSetupFile()

void CleanupSetupFile()
{
	if ( szTempPath[0] == '\0' )
		return;

	// Testdatei schliesen und loeschen
	_lclose( hLoaderTemp );
	remove( strLoaderTemp );

	// Temp-Verzeichnis loeschen
	KillTempPath( szTempPath );

	// Vorheriges Arbeitsverzeichnis wiederherstellen
	chdir( szOldPath );
	_chdrive( nOldDrive );
}

//////////////////////////////////////////////////////////////////////////
// ErrorBox()

void ErrorBox( HWND hWnd, UINT nErrorID, LPSTR pError )
{
	char szTitle[50];
	char szMessage[250];

	LoadString( hInst, IDS_TITLE, szTitle, sizeof(szTitle) );

	if ( !pError )
	{
		LoadString( hInst, nErrorID, szMessage, sizeof(szMessage) );
		MessageBox( hWnd, szMessage, szTitle, MB_OK | MB_ICONSTOP );
	}
	else
		MessageBox( hWnd, pError, szTitle, MB_OK | MB_ICONSTOP );

	bError = TRUE;
	PostMessage( hWnd, WM_CLOSE, 0, 0 );
}


//////////////////////////////////////////////////////////////////////////
// InfoBox()

void InfoBox( HWND hWnd, LPSTR pInfo )
{
	char szTitle[50];
	LoadString( hInst, IDS_TITLE, szTitle, sizeof(szTitle) );
	MessageBox( hWnd, pInfo, szTitle, MB_OK | MB_ICONINFORMATION );
}


