#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:52:21 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ= ..

PRJNAME=sfx2
TARGET=sdesktop
RESTARGET=sdt

AUTOSEG=true
ENABLE_EXCEPTIONS=	TRUE

LIBTARGET=NO

# --- Settings -----------------------------------------------------

SVIDLINC=$(PRJ)$/source$/ui$/inc

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

.INCLUDE :  $(UPD)minor.mk
RSCUPDVER=$(RSCREVISION)(SV$(UPD)$(UPDMINOR))

# IENV!=$(IENV);..\res

# w.g. compilerbugs
.IF "$(GUI)"=="WNT"
CFLAGS+=-Od
.ENDIF

# --- Files --------------------------------------------------------

SRS2NAME=sdt
SRC2FILES =\
        sdt.src

OBJFILES = \
        $(OBJ)$/sdtapp.obj \
        $(OBJ)$/optuno.obj

RESLIB2NAME=$(RESTARGET)
RESLIB2SRSFILES= $(SRS)$/sdt.srs \
	$(SRS)$/sfxslots.srs \
	$(SOLARRESDIR)$/svtools.srs \
	$(SRS)$/sfx.srs		\
    $(SOLARRESDIR)$/so2.srs		\
    $(SOLARRESDIR)$/basic.srs

APP1TARGET=$(TARGET)
APP1STDLIBS=\
	$(SALLIB) \
	$(SVTOOLLIB) \
	$(SVLLIB) \
	$(SOTLIB) \
	$(SO2LIB) \
	$(SVLIB) \
	$(HELPLIB) \
	$(TOOLSLIB) \
        $(UNOTOOLSLIB) \
        $(CPPULIB)\
        $(CPPUHELPERLIB)\
	$(VOSLIB) \
	$(GOODIESLIB)

.IF "$(GUI)"=="UNX"
APP1STDLIBS+= $(VOSLIB)
.IF "$(OS)"=="LINUX"
APP1STDLIBS+= $(CPPULIB) -lsfx$(UPD)li
.ENDIF
.IF "$(OS)$(CPU)"=="SOLARISS"
APP1STDLIBS+= -lsfx$(UPD)ss
.ENDIF
.END
.IF "$(OS)"=="WNT"
APP1STDLIBS+= sfx.lib
.ENDIF
APP1DEPN=$(L)$/itools.lib $(L)$/ivcl.lib $(L)$/svtool.lib $(L)$/so2.lib \
		$(L)$/basic.lib  $(APP1RES)

APP1OBJS=   $(OBJ)$/sdtapp.obj $(OBJ)$/optuno.obj
APP1STACK=64000

APP1DEF=    $(MISCX)$/$(TARGET).def
APP1RES=    $(RES)$/desktop.res

# --- Targets ------------------------------------------------------

.IF "$(depend)" != ""
SRCFILES=$(SRC1FILES)
.ENDIF

.INCLUDE :  target.mk

$(MISCX)$/sdt.hrc: $(PRJ)$/inc\sdt.hrc
	$(COPY) $(PRJ)$/inc\sdt.hrc $@

.IF "$(GUI)" == "WNT"

$(MISCX)$/$(APP1TARGET).def :
	echo  NAME			simage								>$@
    echo  DESCRIPTION   'StarOfficeDemo Version 5.1'           >>$@
	echo  DATA		READ WRITE NONSHARED		   >>$@
	echo  HEAPSIZE		0							   >>$@
	echo  STACKSIZE 	32000							   >>$@
.IF "$(OPTLINKS)" == "YES"
    echo  RC $(RCFLAGS) $(RES)$/desktop.res                    >>$@
.ENDIF
.ENDIF

.IF "$(GUI)" == "OS2"

$(MISCX)$/$(APP1TARGET).def : makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
    echo  NAME          soffice WINDOWAPI                        >$@
    echo  DESCRIPTION   'StarOfficeDemo Version 5.1'           >>$@
.IF "$(COM)" != "TCPP"
	echo  STUB			'os2STUB.EXE'                      >>$@
.ENDIF
	echo  EXETYPE		OS2 							   >>$@
	echo  PROTMODE										   >>$@
	echo  CODE			LOADONCALL						   >>$@
	echo  DATA			PRELOAD MULTIPLE				   >>$@
	echo  HEAPSIZE		8192							   >>$@
	echo  STACKSIZE 	49152							   >>$@
.ENDIF

