/*************************************************************************
 *
 *  $RCSfile: sdtapp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDDE_HXX //autogen
#include <svtools/svdde.hxx>
#endif
#include <svtools/sbxfac.hxx>
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINER_HPP_
#include <com/sun/star/container/XContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEREPLACE_HPP_
#include <com/sun/star/container/XNameReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINERLISTENER_HPP_
#include <com/sun/star/container/XContainerListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_CONTAINEREVENT_HPP_
#include <com/sun/star/container/ContainerEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXREPLACE_HPP_
#include <com/sun/star/container/XIndexReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#include <unotools/processfactory.hxx>
#pragma hdrstop

#include "sdtapp.hxx"
#include "objface.hxx"
#include "appwin.hxx"
#include "optuno.hxx"

#include <svtools/solar.hrc>

#if defined( WIN ) || defined( WNT ) || defined( PM2 )
#define DDE_AVAILABLE
#endif

SfxDesktopApplication aDesktop;
ResMgr *pDeskResMgr = 0;

//=========================================================================

SfxDesktopApplication::SfxDesktopApplication():
	SfxApplicationClass("sdt")
{
}

SfxDesktopApplication::~SfxDesktopApplication()
{
}

void __EXPORT SfxDesktopApplication::Main( )
{
    SetAppName( String::CreateFromAscii("sdesktop") );
	RegisterServices();

    ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xSMgr = utl::getProcessServiceFactory();
    ::com::sun::star::uno::Reference< ::com::sun::star::container::XSet >  xSet( xSMgr, com::sun::star::uno::UNO_QUERY );
    xSet->insert( ::com::sun::star::uno::Any( &SfxSettingsContainer::impl_createFactory(xSMgr), ::getCppuType( ( const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >*)0 ) ) );

    String aMgrName = String::CreateFromAscii( "sdt" );
    aMgrName += String::CreateFromInt32(SOLARUPD); // aktuelle Versionsnummer
    pDeskResMgr = ResMgr::CreateResMgr(U2S(aMgrName));
	Resource::SetResManager( pDeskResMgr );

    SFX_APP()->SetName( String::CreateFromAscii("StarDesktop") );

    xSMgr->createInstance(::rtl::OUString::createFromAscii("com.sun.star.frame.Desktop"));

	SfxApplicationClass::Main();

	Resource::SetResManager( NULL );
}


