/*************************************************************************
 *
 *  $RCSfile: view.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#include <tools/urlobj.hxx>
#include <svtools/svmedit.hxx>

#ifndef _SV_STATUS_HXX //autogen
#include <vcl/status.hxx>
#endif

#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#ifndef _HTMLVIEW_HXX //autogen
#include <goodies/htmlview.hxx>
#endif

#ifndef _SV_WALL_HXX //autogen
#include <vcl/wall.hxx>
#endif

#ifndef _PARHTML_HXX //autogen
#include <svtools/parhtml.hxx>
#endif
#ifndef _HTMLKYWD_HXX
#include <svtools/htmlkywd.hxx>
#endif
#ifndef _HTMLOUT_HXX
#include <svtools/htmlout.hxx>
#endif

#pragma hdrstop

#include "view.hxx"
#include "sfxsids.hrc"
#include "doc.hxx"
#include "objface.hxx"
#include "app.hxx"
#include "docfile.hxx"
#include "viewfrm.hxx"
#include "doc.hxx"
#include "sdt.hrc"

#define SfxSampleViewShell
#include "sdtslots.hxx"

DBG_NAME(SfxSampleViewShell);

TYPEINIT1(SfxSampleViewShell, SfxViewShell);

SFX_IMPL_IDL_INTERFACE(SfxSampleViewShell,SfxViewShell,ResId(0,0))
{
	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT |
		SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT,
		RID_OBJECTBAR );
	SFX_STATUSBAR_REGISTRATION( ID_STATUSBAR );
}

SFX_IMPL_VIEWFACTORY(SfxSampleViewShell, ResId(0,0) )
{
	SFX_VIEW_REGISTRATION(SfxSampleObjectShell);
}

void SfxSampleViewShell::FillStatusBar( StatusBar& rBar )
{
	rBar.InsertItem( SID_MAIL_NOTIFY, 18, SIB_IN|SIB_USERDRAW );
	rBar.InsertItem( SID_DOC_MODIFIED, 18 );
	rBar.InsertItem( SID_EXPLORER_SELECTIONSIZE, 200, SIB_IN|SIB_LEFT|SIB_AUTOSIZE );
	rBar.InsertItem( SID_CURRENTTIME, rBar.GetTextSize(
		::rtl::OUString("::") + Application::GetAppInternational().GetTime( ::com::sun::star::util::Time() ) ).Width() );
	rBar.InsertItem( SID_CURRENTDATE, rBar.GetTextSize(
		::rtl::OUString("::") + Application::GetAppInternational().GetDate( Date() ) ).Width() );
}

void SfxSampleViewShell::Construct()
{
	SfxObjectShell* pSh = GetViewFrame()->GetObjectShell();

	SimpleHTMLViewer *pViewer = new SimpleHTMLViewer( &GetViewFrame()->GetWindow() );
	SetWindow( pViewer );
	Wallpaper aWall( Color( COL_WHITE ) );
	aWall.SetStyle( WALLPAPER_SCALE );
	pViewer->SetBackground( aWall );

	if ( pSh->GetMedium()->GetFilter()->GetFilterName() == "Sample" )
	{
		SfxSampleObjectShell *pObj = PTR_CAST( SfxSampleObjectShell, pSh );

		SvMemoryStream aStrm;
		HTMLOutFuncs::Out_Tag( aStrm, sHTML_html, sal_True );
		aStrm << "\r\n";
		HTMLOutFuncs::Out_Tag( aStrm, sHTML_body, sal_True );
		aStrm << "\r\n";

		HTMLOutFuncs::Out_Tag( aStrm, sHTML_parabreak, sal_True );

		SvStream *pStream = pSh->GetMedium()->GetInStream();
		pStream->Seek(0);
		::rtl::OUString aTmp;
		while ( pStream->ReadLine( aTmp ) )
		{
			aTmp.EraseLeadingChars();
			if ( aTmp.getLength() )
				HTMLOutFuncs::Out_String( aStrm, aTmp );
			else
				aStrm << "\r\n";
		}

		HTMLOutFuncs::Out_Tag( aStrm, sHTML_parabreak, sal_False );

		HTMLOutFuncs::Out_Tag( aStrm, sHTML_body, sal_False );
		aStrm << "\r\n";
		HTMLOutFuncs::Out_Tag( aStrm, sHTML_html, sal_False );
		aStrm << "\r\n";

		aStrm.Seek(0);

		SvFileStream aFile( "D:\\str.htm", STREAM_STD_WRITE | STREAM_TRUNC );
		aFile << aStrm;

		aStrm.Seek(0);

		pViewer->ShowHTML( aStrm );
	}
	else
	{
		pSh->GetMedium()->GetInStream()->Seek(0);
		pViewer->ShowHTML( *pSh->GetMedium()->GetInStream() );
	}

	::rtl::OUString aName( pSh->GetMedium()->GetURLObject().GetMainURL() );
	GetWindow()->SetSizePixel( GetViewFrame()->GetWindow().GetOutputSizePixel() );
	aName += ::rtl::OUString( ":View" );
	SetName( aName );
}

SfxSampleViewShell::SfxSampleViewShell(	SfxViewFrame *pFrame,
	const SfxSampleViewShell& rWin ):
	SfxViewShell( pFrame, SFX_VIEW_MAXIMIZE_FIRST )
{
	DBG_CTOR(SfxSampleViewShell, 0);
	Construct();
}

SfxSampleViewShell::SfxSampleViewShell( SfxViewFrame *pFrame, SfxViewShell* )
	: SfxViewShell( pFrame, SFX_VIEW_MAXIMIZE_FIRST  )
{
	DBG_CTOR(SfxSampleViewShell, 0);
	Construct();
}

SfxSampleViewShell::~SfxSampleViewShell()
{
	DBG_DTOR(SfxSampleViewShell, 0);

	delete GetWindow();
	SetWindow(0);
}

void SfxSampleViewShell::OuterResizePixel(
	const Point &rOfs, const ::com::sun::star::awt::Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

void SfxSampleViewShell::InnerResizePixel(
	const Point &rOfs, const ::com::sun::star::awt::Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

sal_uInt16 SfxSampleViewShell::PrepareClose( sal_Bool, sal_Bool )
{
	sal_Bool bClose = sal_True;
	GetWindow()->UserEvent( SID_CLOSEWIN, &bClose );
	return bClose;
}

void SfxSampleViewShell::Activate(sal_Bool bIsMDIActivate)
{
	if ( bIsMDIActivate )
		GetWindow()->UserEvent( SID_ACTIVATE, (void*) sal_True );
}

void SfxSampleViewShell::Deactivate(sal_Bool bIsMDIActivate)
{
	if ( bIsMDIActivate )
		GetWindow()->UserEvent( SID_ACTIVATE, (void*) sal_False );
}

IMPL_LINK( SfxSampleViewShell, ModifyHdl, void*, pVoid )
{
	SfxSampleObjectShell *pObj = PTR_CAST( SfxSampleObjectShell,
			GetViewFrame()->GetObjectShell() );

	pObj->SetModified( sal_True );
	pObj->SetText( GetWindow()->GetText() );

	return 0L;
}
