/*************************************************************************
 *
 *  $RCSfile: iodlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IODLG_HXX
#define _IODLG_HXX

#ifndef _DIALOG_HXX
#include <vcl/filedlg.hxx>
#endif
#ifndef _BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _INETTYPE_HXX
#include <svtools/inettype.hxx>
#endif

//*****************************************************************************

class CntBrowseBox;
class SfxExpFileDlg_Impl;
class SfxExplorerFileDialog;
class SfxObjectFactory;
class INetFtpConnection;
class SfxSimpleFileDialog_Impl;
class ListBox;
class SvTabListBox;

#if __PRIVATE
//class CntAnchor;
#endif

class SvStringsDtor;
class SfxFileView_Impl;

//*****************************************************************************

#define SFXWB_INSERT			( 0x04000000L | WB_OPEN )
#define SFXWB_PASSWORD			WB_PASSWORD
#define SFXWB_READONLY			WB_READONLY
#define SFXWB_PATHDIALOG		WB_PATH
#define SFXWB_CLASSPATH			( 0x08000000L | SFXWB_PATHDIALOG )
#define SFXWB_SHOWALLFOLDER		0x10000000L		// alle Ordner auch Mail/News/...
#define SFXWB_MULTISELECTION	0x20000000L		// Multiselection an
#define SFXWB_NOREMOTE          0x40000000L
#define SFXWB_SHOWVERSIONS		0x80000000L  	// Versionsauswahl anzeigen

#define RET_MANAGER				100

#define FILEDIALOG_FILTER_ALL	"*.*"

//*****************************************************************************
// SfxUrlDialog
//*****************************************************************************

class SfxUrlDialog : public ModalDialog
{
private:
	Edit			aEdit;
	OKButton		aOk;
	CancelButton	aCancel;

public:
	SfxUrlDialog( Window* pParent );

	String			GetUrl() const { return aEdit.GetText(); }
	void 			SetUrl( const String& rUrl ) { aEdit.SetText( rUrl ); }
};

//*****************************************************************************
// SfxFileDialog
//*****************************************************************************

class SfxFileDialog : public VclFileDialog, public SfxListener
{
private:
	FixedText					_aFtDummy1;
	Edit						_aEdDummy1;

	FixedText					_aFtDummy2;
	ListBox						_aLbDummy2;

	FixedText					_aFtDummy3;
	ComboBox					_aCmbDummy3;

	CheckBox*					_pCbReadOnly;
	SfxFileView_Impl*			_pFileView;

	PushButton					_aBtnDummy1;
	CancelButton				_aBtnDummy2;

	ImageButton					_aBtnDummy3;
	ImageButton					_aBtnDummy4;
	ImageButton					_aBtnDummy5;

	SfxExpFileDlg_Impl*			_pImp;
	SfxAllItemSet*				_pOutputItemSet;

	static SfxFileDialog*		_pActiveDlg;

#if __PRIVATE

	DECL_STATIC_LINK( SfxFileDialog, FilterSelectHdl_Impl, ListBox* );
	DECL_STATIC_LINK( SfxFileDialog, NewFolderHdl_Impl, PushButton* );
	DECL_STATIC_LINK( SfxFileDialog, ViewHdl_Impl, ImageButton* );
	DECL_STATIC_LINK( SfxFileDialog, OpenHdl_Impl, void* );
	DECL_STATIC_LINK( SfxFileDialog, FileNameGetFocusHdl_Impl, void* );
	DECL_STATIC_LINK( SfxFileDialog, FileNameModifiedHdl_Impl, void* );

	void						Init_Impl( ULONG nBits );
	void						ConfigControls_Impl();
	BOOL						FindFilter_Impl( const String& rFilter,
												 BOOL bMultiExt,
												 BOOL& rbFilterChanged );
	void						ScrollToTop_Impl();
	void						EnablePasswordBox_Impl();

	void						ExecuteFilter();
	void						SaveSettings_Impl();
	void						UpdateHistory_Impl();
	void						OpenMultiSelection_Impl();
	void						UpdateHistory();

	DECL_LINK( SelectHdl_Impl, SvTabListBox* );
	DECL_LINK( DblClickHdl_Impl, SvTabListBox* );
	DECL_LINK( EntrySelectHdl_Impl, ComboBox* );
	DECL_LINK( OpenDoneHdl_Impl, SfxFileView_Impl* );
	DECL_LINK( ResetCursorHdl_Impl, Timer* );

#endif	// __PRIVATE

	// entfernt einen Filter mit Wildcards aus dem Path und gibt in zurck
	BOOL IsolateFilterFromPath_Impl( String& rPath, String& rFilter );

protected:
	virtual long				PreNotify( NotifyEvent& rNEvt );
	virtual void				Notify( SfxBroadcaster& rBC,
										const SfxHint& rHint );
	virtual void				FillItemSet( SfxItemSet& rSet );

	void						EnableInternet( BOOL bInternet );

public:
	SfxFileDialog( Window* pParent, ULONG nBits,
				   const SfxObjectFactory& rDocFac, const SfxItemSet& );
	SfxFileDialog( Window* pParent, ULONG nBits );
	~SfxFileDialog();

	virtual long				OK();
	virtual short				Execute();

	virtual void				FileSelect();
	virtual void				FilterSelect();

	inline BOOL					IsReadOnly() const;
	inline const SfxItemSet*	GetItemSet() const;
	INetFtpConnection*			GetFtpConnection() const;
	void						SetSmartPath( const String& rNewPath );
	void						SetStandardDir( const String& rStdDir );
	const String&				GetStandardDir() const;
	const String&				GetViewURL() const;
	SvStringsDtor*				GetViewURLList() const;		// bei MultiSelektion
	SvStringsDtor*				GetPathList() const;		// bei MultiSelektion

	virtual void				AddFilter( const String& rFilter,
										   const String& rType, ULONG nFlags = 0 );
	virtual void				AddFilter( const String& rFilter,
										   const String& rType,
										   const String& rSysType, ULONG nFlags = 0 );

	virtual void				RemoveFilter( const String& rFilter );
	virtual void				RemoveAllFilter();
	virtual void				SetCurFilter( const String& rFilter );
	virtual String				GetCurFilter() const;
	virtual USHORT				GetFilterCount() const;
	virtual const String&		GetFilterName( USHORT nPos ) const;
	virtual const String&		GetFilterType( USHORT nPos ) const;
	virtual ULONG				GetFilterFlags( USHORT nPos ) const;
	virtual void				Resize();

	void						PrevLevel_Impl();
	void						OpenURL_Impl( const String& rURL );

	inline SfxFileView_Impl*	GetView() const;

	inline static SfxFileDialog* GetActive();

	void						SetDefaultButtonText( const XubString& rText, ULONG nHelpId = 0 );
	void						EnableEmptyFilename();
	void						DisableSaveLastDirectory();
	void                        InitSize( const String& rIniKey );
	void						ToggleBrowserMode();
	void						SetFocusInViewControl();
	DECL_LINK(					HandleNotify, void* );

	void						AddPathType( INetContentType eType );
	void						SetPathURL( const XubString& rPathURL );

	Image*						GetDocumentImage() const;
	Image*						GetFolderImage() const;
};

//*****************************************************************************

inline BOOL SfxFileDialog::IsReadOnly() const
{
	return _pCbReadOnly && _pCbReadOnly->IsChecked();
}

//*****************************************************************************

inline const SfxItemSet* SfxFileDialog::GetItemSet() const
{
	return _pOutputItemSet;
}

//*****************************************************************************

inline SfxFileDialog* SfxFileDialog::GetActive()
{
	return _pActiveDlg;
}

//*****************************************************************************

inline SfxFileView_Impl* SfxFileDialog::GetView() const
{
	return _pFileView;
}

//*****************************************************************************
// SfxSimpleFileDialog
//*****************************************************************************

class SfxSimpleFileDialog : public SfxFileDialog
{
private:
	SfxSimpleFileDialog_Impl*	_pImp;

public:
	SfxSimpleFileDialog( Window* pParent, ULONG nBits );
	~SfxSimpleFileDialog();

	virtual short				Execute();
};

#endif // #ifndef _IODLG_HXX


