/*************************************************************************
 *
 *  $RCSfile: srchitem.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_SRCHITEM_HXX
#define _SFX_SRCHITEM_HXX

// include ---------------------------------------------------------------
#ifndef _COM_SUN_STAR_UTIL_XSEARCHDESCRIPTOR_HPP_
#include <com/sun/star/util/XSearchDescriptor.hpp>
#endif

#ifndef _RSCSFX_HXX //autogen
#include <rsc/rscsfx.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX //autogen
#include <svtools/poolitem.hxx>
#endif
#ifndef _SFXMSG_HXX //autogen
#include <msg.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

// defines ---------------------------------------------------------------

#define SEARCH_OPTIONS_SEARCH       ((sal_uInt16)0x0001)
#define SEARCH_OPTIONS_SEARCH_ALL   ((sal_uInt16)0x0002)
#define SEARCH_OPTIONS_REPLACE      ((sal_uInt16)0x0004)
#define SEARCH_OPTIONS_REPLACE_ALL  ((sal_uInt16)0x0008)
#define SEARCH_OPTIONS_WHOLE_WORDS  ((sal_uInt16)0x0010)
#define SEARCH_OPTIONS_BACKWARDS    ((sal_uInt16)0x0020)
#define SEARCH_OPTIONS_REG_EXP      ((sal_uInt16)0x0040)
#define SEARCH_OPTIONS_EXACT        ((sal_uInt16)0x0080)
#define SEARCH_OPTIONS_SELECTION    ((sal_uInt16)0x0100)
#define SEARCH_OPTIONS_FAMILIES     ((sal_uInt16)0x0200)
#define SEARCH_OPTIONS_FORMAT       ((sal_uInt16)0x0400)
#define SEARCH_OPTIONS_MORE			((sal_uInt16)0x0800)
#define SEARCH_OPTIONS_SIMILARITY	((sal_uInt16)0x1000)
#define SEARCH_OPTIONS_CONTENT		((sal_uInt16)0x2000)

// Kommandos
#define		SVX_SEARCHCMD_FIND			((sal_uInt16)0)
#define		SVX_SEARCHCMD_FIND_ALL		((sal_uInt16)1)
#define		SVX_SEARCHCMD_REPLACE		((sal_uInt16)2)
#define		SVX_SEARCHCMD_REPLACE_ALL	((sal_uInt16)3)

// Suche in (fuer Calc)
#define		SVX_SEARCHIN_FORMULA		((sal_uInt16)0)
#define		SVX_SEARCHIN_VALUE			((sal_uInt16)1)
#define		SVX_SEARCHIN_NOTE			((sal_uInt16)2)

// Applicationsflag
#define		SVX_SEARCHAPP_WRITER		((sal_uInt16)0)
#define		SVX_SEARCHAPP_CALC			((sal_uInt16)1)
#define		SVX_SEARCHAPP_DRAW			((sal_uInt16)2)
#define		SVX_SEARCHAPP_BASE			((sal_uInt16)3)

// class SvxSearchItem ---------------------------------------------------

#ifdef ITEMID_SEARCH

/*	[Beschreibung]

	In diesem Item werden alle Such-Attribute gespeichert.
*/
class SvxSearchItem : public SfxPoolItem
{
private:
	sal_uInt16		nCommand;			// Kommando (Suchen, Alle Suchen, Ersetzen, Alle Ersetzen)
#ifndef ENABLEUNICODE
	String		aSearchString;      // Der gesuchte Begriff
	String		aReplaceString;     // Der Ersetzungs Begriff
#else
	UniString		aSearchString;      // Der gesuchte Begriff
	UniString		aReplaceString;     // Der Ersetzungs Begriff
#endif
	sal_Bool		bWordOnly;          // Nur ganze Worte suchen
	sal_Bool		bExact;             // Exakte suche (Ignore Case)
	sal_Bool		bBackward;          // Suche Rueckwaerts
	sal_Bool		bSelection;         // Suche in ::com::sun::star::awt::Selection
	sal_Bool		bRegExp;            // Suche mit regulaerem Ausdruck
	sal_Bool		bPattern;           // Suche nach Vorlagen
	sal_Bool		bContent;			// Suche im Inhalt

	SfxStyleFamily	eFamily;		// Vorlagen-Familie

	// Calc-Spezifische Daten
	sal_Bool		bRowDirection;		// Suchrichtung Zeilenweise/Spaltenweise
	sal_Bool		bAllTables;			// in alle Tabellen suchen
	sal_uInt16		nCellType;			// Suche in Formeln/Werten/Notizen
	sal_uInt16		nAppFlag;   		// Fuer welche Applikation ist der Dialog ueberhaupt

	// Parameter fuer Aehnlichkeitssuche
	sal_Bool 		bLevenshtein;		//
	sal_Bool 		bLEVRelaxed; 		// X/Y/Z additiv oder exclusiv
	sal_uInt16 		nLEVOther;			// maximal X Ersetzungen
	sal_uInt16 		nLEVShorter;		// maximal Y Einfuegungen
	sal_uInt16 		nLEVLonger;			// maximal Z Loeschungen

public:
	TYPEINFO();

	SvxSearchItem( const sal_uInt16 nId = ITEMID_SEARCH );
	SvxSearchItem( const SvxSearchItem& rItem );

	virtual int 			 operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const
								 { return new SvxSearchItem(*this); }
#ifndef ENABLEUNICODE
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
									SfxMapUnit eCoreMetric,
									SfxMapUnit ePresMetric,
									String &rText, const International * = 0 ) const;
#else
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
									SfxMapUnit eCoreMetric,
									SfxMapUnit ePresMetric,
									UniString &rText, const International * = 0 ) const;
#endif

			sal_uInt16			GetCommand() const { return nCommand; }
			void			SetCommand(sal_uInt16 nNewCommand) { nCommand = nNewCommand; }

#ifndef ENABLEUNICODE
	const	String&			GetSearchString() const { return aSearchString; }
			void			SetSearchString(const String& rNewString) { aSearchString = rNewString; }

	const	String& 		GetReplaceString() const { return aReplaceString; }
			void			SetReplaceString(const String& rNewString) { aReplaceString = rNewString; }
#else
	const	UniString&		GetSearchString() const { return aSearchString; }
			void			SetSearchString(const UniString& rNewString) { aSearchString = rNewString; }

	const	UniString& 		GetReplaceString() const { return aReplaceString; }
			void			SetReplaceString(const UniString& rNewString) { aReplaceString = rNewString; }
#endif

			sal_Bool			GetWordOnly() const { return bWordOnly; }
			void			SetWordOnly(sal_Bool bNewWordOnly) { bWordOnly = bNewWordOnly; }

			sal_Bool			GetExact() const { return bExact; }
			void			SetExact(sal_Bool bNewExact) { bExact = bNewExact; }

			sal_Bool			GetBackward() const { return bBackward; }
			void			SetBackward(sal_Bool bNewBackward) { bBackward = bNewBackward; }

			sal_Bool			GetSelection() const { return bSelection; }
			void			SetSelection(sal_Bool bNewSelection) { bSelection = bNewSelection; }

			sal_Bool			GetRegExp() const { return bRegExp; }
			void			SetRegExp(sal_Bool bNewRegExp) { bRegExp = bNewRegExp; }

			sal_Bool			GetPattern() const { return bPattern; }
			void			SetPattern(sal_Bool bNewPattern) { bPattern = bNewPattern; }

			sal_Bool			IsContent() const { return bContent; }
			void			SetContent( sal_Bool bNew ) { bContent = bNew; }

			SfxStyleFamily	GetFamily() const { return eFamily; }
			void			SetFamily( SfxStyleFamily eNewFamily )
								{ eFamily = eNewFamily; }

			sal_Bool			GetRowDirection() const { return bRowDirection; }
			void			SetRowDirection(sal_Bool bNewRowDirection) { bRowDirection = bNewRowDirection; }

			sal_Bool			IsAllTables() const { return bAllTables; }
			void			SetAllTables(sal_Bool bNew) { bAllTables = bNew; }

			sal_uInt16			GetCellType() const { return nCellType; }
			void			SetCellType(sal_uInt16 nNewCellType) { nCellType = nNewCellType; }

			sal_uInt16			GetAppFlag() const { return nAppFlag; }
			void			SetAppFlag(sal_uInt16 nNewAppFlag) { nAppFlag = nNewAppFlag; }

			sal_Bool 			IsLevenshtein() const {return bLevenshtein;}
			void			SetLevenshtein(sal_Bool bSet) {bLevenshtein = bSet;}

			sal_Bool 			IsLEVRelaxed() const {return bLEVRelaxed; }
			void	        SetLEVRelaxed(sal_Bool bSet) {bLEVRelaxed = bSet;}

			sal_uInt16			GetLEVOther() const {return nLEVOther;}
			void			SetLEVOther(sal_uInt16 nSet) {nLEVOther = nSet;}

			sal_uInt16			GetLEVShorter() const {return nLEVShorter;}
			void			SetLEVShorter(sal_uInt16 nSet) {nLEVShorter = nSet;}

			sal_uInt16			GetLEVLonger() const {return nLEVLonger;}
			void			SetLEVLonger(sal_uInt16 nSet) {nLEVLonger = nSet;}

			void			GetFromDescriptor( const ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > & rDescr );
			void			SetToDescriptor( ::com::sun::star::uno::Reference< ::com::sun::star::util::XSearchDescriptor > & rDescr );
};

#endif


#endif

