#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:52:25 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..

PRJNAME=odk
TARGET=odk
TARGET2=cli
USE_DEFFILE=TRUE
LIBTARGET=NO
ENABLE_EXCEPTIONS=TRUE
PACKAGE=odk
NOSMARTUNO=TRUE

# --- Settings -----------------------------------------------------
.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------
IDLFILES= 	odkdisp.idl

SLOFILES= \
           $(SLO)$/odkserv.obj \
           $(SLO)$/odkclie.obj

# --- Targets ------------------------------------------------------

SHL1TARGET= 	$(TARGET)$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= 	$(TARGET)

SHL1STDLIBS=\
            $(VCLLIB) \
            $(SFXLIB) \
            $(SVTOOLLIB) \
			$(SVLLIB)	\
            $(UNOLIB) \
            $(VOSLIB) \
            $(TOOLSLIB) \
            $(SALLIB)

.IF "$(GUI)"=="WNT"
SHL1STDLIBS+=kernel32.lib user32.lib
.ENDIF

SHL1OBJS = \
           $(SLO)$/$(PACKAGE)$/odkdisp.obj \
           $(SLO)$/odkserv.obj

SHL1DEF=$(MISC)$/$(SHL1TARGET).def

SHL2TARGET= 	$(TARGET2)$(UPD)$(DLLPOSTFIX)
SHL2IMPLIB= 	$(TARGET2)

SHL2STDLIBS=\
            $(UNOLIB) \
            $(VOSLIB) \
            $(TOOLSLIB) \
            $(SALLIB)

.IF "$(GUI)"=="WNT"
SHL2STDLIBS+=kernel32.lib user32.lib
.ENDIF

SHL2OBJS = \
           $(SLO)$/$(PACKAGE)$/odkdisp.obj \
           $(SLO)$/odkclie.obj

SHL2DEF=$(MISC)$/$(SHL2TARGET).def

.INCLUDE : target.mk

.IF "$(GUI)" == "WNT"

$(MISC)$/$(SHL1TARGET).def:
    @echo ------------------------------
    @echo Making: $@
    @echo LIBRARY     $(SHL1TARGET)                                  >$@
    @echo DESCRIPTION 'StarOne Test-DLL'                                 >>$@
    @echo DATA        READ WRITE NONSHARED                          >>$@
    @echo EXPORTS                                                   >>$@
	@echo ODKInit >>$@
	@echo ODKExit >>$@

.ENDIF

.IF "$(GUI)" == "OS2"

$(MISC)$/$(SHL1TARGET).def:
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  LIBRARY		INITINSTANCE TERMINSTANCE			>$@
	echo  DESCRIPTION	'StarOne Test-DLL'           					>>$@
	echo  PROTMODE										   >>$@
    	@echo CODE        LOADONCALL 			              >>$@
	@echo DATA		  PRELOAD MULTIPLE NONSHARED					  >>$@
    	@echo EXPORTS                                                   >>$@
.ENDIF

.IF "$(GUI)" == "WNT"

$(MISC)$/$(SHL2TARGET).def:
    @echo ------------------------------
    @echo Making: $@
    @echo LIBRARY     $(SHL2TARGET)                                  >$@
    @echo DESCRIPTION 'StarOne Test-DLL'                                 >>$@
    @echo DATA        READ WRITE NONSHARED                          >>$@
    @echo EXPORTS                                                   >>$@
	@echo ODKConnect >>$@
	@echo ODKDisconnect >>$@
	@echo ODKFreeMemory >>$@
	@echo ODKCallFunction >>$@

.ENDIF

.IF "$(GUI)" == "OS2"

$(MISC)$/$(SHL2TARGET).def:
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  LIBRARY		INITINSTANCE TERMINSTANCE			>$@
	echo  DESCRIPTION	'StarOne Test-DLL'           					>>$@
	echo  PROTMODE										   >>$@
    	@echo CODE        LOADONCALL 			              >>$@
	@echo DATA		  PRELOAD MULTIPLE NONSHARED					  >>$@
    	@echo EXPORTS                                                   >>$@
.ENDIF

