/*************************************************************************
 *
 *  $RCSfile: soexp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _CNTRNMGR_HXX //autogen
#include <sfx2/cntrnmgr.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SVT_FILEDLG_HXX //autogen
#include <svtools/filedlg.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _LCKBITEM_HXX //autogen
#include <svtools/lckbitem.hxx>
#endif
#ifndef _BIGINT_HXX //autogen
#include <tools/bigint.hxx>
#endif
#ifndef _FSYS_HXX //autogen
#include <tools/fsys.hxx>
#endif
#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif

#ifndef _SOEXP_HRC
#include <soexp.hrc>
#endif
#ifndef _SOEXP_HXX
#include <soexp.hxx>
#endif

#if defined UNX
#define ALLFILES "*"
#else // UNX
#define ALLFILES "*.*"
#endif // UNX

#define CONFIG_FILE_VERSION "sversion"
#define CONFIG_FILE_OFFICE "soffice"
#define CONFIG_GROUP_VERSIONS "Versions"
#if defined WIN // cf. svtools/source/misc/iniman.cxx:
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-Windows"
#elif defined WNT
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-WindowsNT"
#elif defined UNX
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-UNIX"
#elif defined MAC
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-Macintosh"
#elif defined OS2
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-OS/2"
#else
#define CONFIG_GROUP_DIRECTORIES_SYS "Directories-GUI"
#endif
#define CONFIG_GROUP_DIRECTORIES_DEFAULT "Directories"
#define CONFIG_KEY_OFFICE40 "StarOffice 4.0"
#define CONFIG_KEY_CACHE "Cache-Dir"
#define CONFIG_KEY_CONFIG "Config-Dir"
#define CONFIG_KEY_EXPLORER "Explorer"

#define CACHE_DIR "cache"
#define CONFIG_DIR "config"
#define EXPLORER_DIR "explorer"

#define CACHE_PARAM "-ca"
#define CACHE_PARAM_LEN 3
#define CONFIG_PARAM "-co"
#define CONFIG_PARAM_LEN 3
#define OUT_PARAM "-o"
#define OUT_PARAM_LEN 2

//============================================================================
ExportApplication aExportApplication;

//============================================================================
//
//  CCPathsDialog
//
//============================================================================

IMPL_LINK(CCPathsDialog, PathEditModifyHandler, Edit *, pEdit)
{
	String aText(pEdit->GetText());
	BOOL bValid;
	if (aText.Len())
	{
		DirEntry aPath(pEdit->GetText());
		aPath.ToAbs();
		bValid = aPath.Exists() && FileStat(aPath).IsKind(FSYS_KIND_DIR);
	}
	else
		bValid = FALSE;
	if (pEdit == &m_aEDCachePath)
		m_bCachePathValid = bValid;
	else
		m_bConfigPathValid = bValid;
	bValid = m_bCachePathValid && m_bConfigPathValid;
	if (bValid)
	{
		DirEntry aCachePath(m_aEDCachePath.GetText());
		aCachePath.ToAbs();
		DirEntry aConfigPath(m_aEDConfigPath.GetText());
		aConfigPath.ToAbs();
		bValid = aCachePath != aConfigPath;
	}
	m_aPBOK.Enable(bValid);
	return 0;
}

//============================================================================
IMPL_LINK(CCPathsDialog, BrowseButtonClickHandler, PushButton *, pButton)
{
	Edit * pEdit;
	Edit * pOtherEdit;
	String aOtherDir;
	if (pButton == &m_aPBCacheBrowse)
	{
		pEdit = &m_aEDCachePath;
		pOtherEdit = &m_aEDConfigPath;
		aOtherDir = CONFIG_DIR;
	}
	else
	{
		pEdit = &m_aEDConfigPath;
		pOtherEdit = &m_aEDCachePath;
		aOtherDir = CACHE_DIR;
	}
	pEdit->Disable();
	pButton->Disable();
	PathDialog * pDialog = new PathDialog(0);
	if (pDialog->Execute() == RET_OK)
	{
		String aPath(pDialog->GetPath());
		pEdit->SetText(aPath);
		PathEditModifyHandler(pEdit);
		if (!pOtherEdit->GetText())
		{
			pOtherEdit->SetText(ExportApplication::ChangePath(aPath,
															  aOtherDir));
			PathEditModifyHandler(pOtherEdit);
		}
	}
	delete pDialog;
	pEdit->Enable();
	pButton->Enable();
	return 0;
}

//============================================================================
CCPathsDialog::CCPathsDialog(const String & rCacheDirectory,
							 const String & rConfigDirectory):
	ModalDialog(0, ResId(RID_DIALOG_PATHS)),
	m_aFTIntro(this, ResId(FT_PDLG_INTRO)),
	m_aFTCache(this, ResId(FT_PDLG_CACHE)),
	m_aEDCachePath(this, ResId(ED_PDLG_CACHE_PATH)),
	m_aPBCacheBrowse(this, ResId(PB_PDLG_CACHE_BROWSE)),
	m_aFTConfig(this, ResId(FT_PDLG_CONFIG)),
	m_aEDConfigPath(this, ResId(ED_PDLG_CONFIG_PATH)),
	m_aPBConfigBrowse(this, ResId(PB_PDLG_CONFIG_BROWSE)),
	m_aPBOK(this, ResId(PB_PDLG_OK)),
	m_aPBCancel(this, ResId(PB_PDLG_CANCEL)),
	m_aFTWarning(this, ResId(FT_PDLG_WARNING)),
	m_bCachePathValid(FALSE),
	m_bConfigPathValid(FALSE)
{
	FreeResource();

	m_aEDCachePath.SetModifyHdl(LINK(this, CCPathsDialog,
									 PathEditModifyHandler));
	m_aEDConfigPath.SetModifyHdl(LINK(this, CCPathsDialog,
									  PathEditModifyHandler));
	m_aPBCacheBrowse.SetClickHdl(LINK(this, CCPathsDialog,
									  BrowseButtonClickHandler));
	m_aPBConfigBrowse.SetClickHdl(LINK(this, CCPathsDialog,
									   BrowseButtonClickHandler));

	m_aEDCachePath.SetText(rCacheDirectory);
	m_aEDConfigPath.SetText(rConfigDirectory);

	m_aPBOK.Disable();
	PathEditModifyHandler(&m_aEDCachePath);
	PathEditModifyHandler(&m_aEDConfigPath);
}

//============================================================================
String CCPathsDialog::GetCacheDirectory() const
{
	return DirEntry(m_aEDCachePath.GetText()).GetFull();
}

//============================================================================
String CCPathsDialog::GetConfigDirectory() const
{
	return DirEntry(m_aEDConfigPath.GetText()).GetFull();
}

//============================================================================
//
//  WaitingDialog
//
//============================================================================

WaitingDialog::WaitingDialog():
	ModelessDialog(0, ResId(RID_DIALOG_WAITING))
{
	FreeResource();
}

//============================================================================
// virtual
void WaitingDialog::Paint(const Rectangle &)
{
	DrawText(Rectangle(Point(0, 0), GetOutputSizePixel()),
			 ResId(RID_STR_WAITING_MSG),
			 TEXT_DRAW_CENTER | TEXT_DRAW_VCENTER);
}

//============================================================================
//
//  ExportApplication
//
//============================================================================

void ExportApplication::UndoConversions()
{
	for (CntRootNodeMgrConversionEntry * pEntry = m_pConversionList->m_pList;
		 pEntry; pEntry = pEntry->m_pNext)
		if (pEntry->m_aStorageName.Len() && pEntry->m_aBackUpName.Len())
		{
			DirEntry aStorageFile(pEntry->m_aStorageName);
			for (int i = 0; i < 2; ++i)
			{
				ErrCode nError = aStorageFile.Kill();
				if (nError == ERRCODE_NONE)
				{
// 					DirEntry(pEntry->m_aBackUpName).MoveTo(aStorageFile);
					pEntry->m_aStorageName.Erase();
					pEntry->m_aBackUpName.Erase();
					break;
				}
				Reschedule();
			}
		}
}

//============================================================================
// virtual
void __EXPORT ExportApplication::Main()
{
	ResMgr * pResMgr = CreateResManager("soe");
	Resource::SetResManager(pResMgr);

	PreInit();

	m_pConversionList = 0;
	if (Initialize())
	{
		// Check for command line parameters:
		String aCachePath;
		String aConfigPath;
		String aLogFileName;
		USHORT nCommandCount = GetCommandLineParamCount();
		BOOL bCommandArgs = FALSE;
		for (USHORT i = 0; i < nCommandCount; ++i)
		{
			String aParam(GetCommandLineParam(i));
			if (String(CACHE_PARAM).Match(aParam) == STRING_MATCH)
			{
				if (!aCachePath)
					if (aParam.Len() > CACHE_PARAM_LEN)
					{
						DirEntry aPath(aParam.Copy(CACHE_PARAM_LEN));
						aPath.ToAbs();
						if (aPath.Exists()
							&& FileStat(aPath).IsKind(FSYS_KIND_DIR))
							aCachePath = aPath.GetFull();
					}
					else if (i < nCommandCount - 1)
					{
						aParam = GetCommandLineParam(i + 1);
						if (String(CACHE_PARAM).Match(aParam) != STRING_MATCH
							&& String(CONFIG_PARAM).Match(aParam)
								!= STRING_MATCH
							&& String(OUT_PARAM).Match(aParam)
								!= STRING_MATCH)
						{
							DirEntry aPath(aParam);
							aPath.ToAbs();
							if (aPath.Exists()
								&& FileStat(aPath).IsKind(FSYS_KIND_DIR))
								aCachePath = aPath.GetFull();
							++i;
						}
					}
			}
			else if (String(CONFIG_PARAM).Match(aParam) == STRING_MATCH)
			{
				if (!aConfigPath)
					if (aParam.Len() > CONFIG_PARAM_LEN)
					{
						DirEntry aPath(aParam.Copy(CONFIG_PARAM_LEN));
						aPath.ToAbs();
						if (aPath.Exists()
							&& FileStat(aPath).IsKind(FSYS_KIND_DIR))
							aConfigPath = aPath.GetFull();
					}
					else if (i < nCommandCount - 1)
					{
						aParam = GetCommandLineParam(i + 1);
						if (String(CACHE_PARAM).Match(aParam) != STRING_MATCH
							&& String(CONFIG_PARAM).Match(aParam)
								!= STRING_MATCH
							&& String(OUT_PARAM).Match(aParam)
								!= STRING_MATCH)
						{
							DirEntry aPath(aParam);
							aPath.ToAbs();
							if (aPath.Exists()
								&& FileStat(aPath).IsKind(FSYS_KIND_DIR))
								aConfigPath = aPath.GetFull();
							++i;
						}
					}
			}
			else if (String(OUT_PARAM).Match(aParam) == STRING_MATCH)
			{
				if (!aLogFileName)
					if (aParam.Len() > OUT_PARAM_LEN)
						aLogFileName = aParam.Copy(OUT_PARAM_LEN);
					else if (i < nCommandCount - 1)
					{
						aParam = GetCommandLineParam(i + 1);
						if (String(CACHE_PARAM).Match(aParam) != STRING_MATCH
							&& String(CONFIG_PARAM).Match(aParam)
								!= STRING_MATCH
							&& String(OUT_PARAM).Match(aParam)
								!= STRING_MATCH)
						{
							aLogFileName = aParam;
							++i;
						}
					}
			}
			else
				bCommandArgs = TRUE;
		}
		if (aCachePath.Len())
		{
			if (!aConfigPath)
				aConfigPath = ChangePath(aCachePath, CONFIG_DIR);
		}
		else if (aConfigPath.Len())
			aCachePath = ChangePath(aConfigPath, CACHE_DIR);

		// Open log file:
		SvFileStream * pLogFile = 0;
		if (aLogFileName.Len())
		{
			pLogFile = new SvFileStream(aLogFileName, STREAM_STD_WRITE);
			pLogFile->Seek(STREAM_SEEK_TO_END);
			*pLogFile << "\r\n------------------------------------------\r\n";
		}

		// Set cache/config paths of StarOffice 4.0:
		String aExplorerPath;
		BOOL bStart = TRUE;
		if (pLogFile)
		{
			*pLogFile << "Cache: " << aCachePath.GetStr() << "\r\nConfig: "
					  << aConfigPath.GetStr() << "\r\n\r\n";
			bStart = aCachePath.Len() && aConfigPath.Len();
		}
		else if (!aCachePath || !aConfigPath)
		{
#if 0
			Config
			 aVersionConfig(Config::GetConfigName(Config::GetDefDirectory(),
												  CONFIG_FILE_VERSION));
			aVersionConfig.SetGroup(CONFIG_GROUP_VERSIONS);
			String aOfficePath(aVersionConfig.ReadKey(CONFIG_KEY_OFFICE40));
			if (aOfficePath.Len())
			{
				Config
				 aOfficeConfig(Config::GetConfigName(aOfficePath,
													 CONFIG_FILE_OFFICE));
				aOfficeConfig.SetGroup(CONFIG_GROUP_DIRECTORIES_SYS);
				if (!aCachePath)
					aCachePath = aOfficeConfig.ReadKey(CONFIG_KEY_CACHE);
				if (!aConfigPath)
					aConfigPath = aOfficeConfig.ReadKey(CONFIG_KEY_CONFIG);
				aExplorerPath = aOfficeConfig.ReadKey(CONFIG_KEY_EXPLORER);
				if (!aCachePath || !aConfigPath || !aExplorerPath)
				{
					aOfficeConfig.SetGroup(CONFIG_GROUP_DIRECTORIES_DEFAULT);
					if (!aCachePath)
						aCachePath = aOfficeConfig.ReadKey(CONFIG_KEY_CACHE);
					if (!aConfigPath)
						aConfigPath
						 = aOfficeConfig.ReadKey(CONFIG_KEY_CONFIG);
					if (!aExplorerPath)
						aExplorerPath
						 = aOfficeConfig.ReadKey(CONFIG_KEY_EXPLORER);
				}
			}
#else
			SfxIniManager * pIniManager = GetAppIniManager();
			if (pIniManager)
			{
				if (!aCachePath)
					aCachePath = pIniManager->Get(SFX_GROUP_DIR,
												  CONFIG_KEY_CACHE);
				if (!aConfigPath)
					aConfigPath = pIniManager->Get(SFX_GROUP_DIR,
												   CONFIG_KEY_CONFIG);
				aExplorerPath = pIniManager->Get(SFX_GROUP_DIR,
												 CONFIG_KEY_EXPLORER);
			}
#endif

			CCPathsDialog * pPathsDialog = new CCPathsDialog(aCachePath,
															 aConfigPath);
			bStart = pPathsDialog->Execute() == RET_OK;
			if (bStart)
			{
				aCachePath = pPathsDialog->GetCacheDirectory();
				aConfigPath = pPathsDialog->GetConfigDirectory();
			}
			delete pPathsDialog;
		}

		if (bStart)
		{
			if (!aExplorerPath)
				aExplorerPath = ChangePath(aConfigPath, EXPLORER_DIR);

			// Late init CHAOS:
			CntRootNodeMgr::SetCacheDirectory(DirEntry(aCachePath).
											   GetFull(FSYS_STYLE_URL, TRUE));
			CntRootNodeMgr::SetConfigDirectory(DirEntry(aConfigPath).
												GetFull(FSYS_STYLE_URL,
														TRUE));
			CntRootNodeMgr::SetCallErrorHandler(!pLogFile);
			m_pConversionList = CntRootNodeMgr::Get()->GetConversionList();
			LateInitCHAOSReg();
			CntRootNodeMgr::RegisterFactories();

			USHORT nCommandArg = 0;
			for (BOOL bFirst = TRUE;; bFirst = FALSE)
			{
				// Get .scc file name:
				String aFile;
				if (bCommandArgs)
				{
					String aParam;
					for (; nCommandArg < nCommandCount; ++nCommandArg)
					{
						aParam = GetCommandLineParam(nCommandArg);
						if (String(CACHE_PARAM).Match(aParam) == STRING_MATCH)
						{
							if (aParam.Len() == CACHE_PARAM_LEN)
								++nCommandArg;
						}
						else if (String(CONFIG_PARAM).Match(aParam)
								  == STRING_MATCH)
						{
							if (aParam.Len() == CONFIG_PARAM_LEN)
								++nCommandArg;
						}
						else if (String(OUT_PARAM).Match(aParam)
								  == STRING_MATCH)
						{
							if (aParam.Len() == OUT_PARAM_LEN)
								++nCommandArg;
						}
						else
							break;
					}
					if (nCommandArg >= nCommandCount)
						break;
					++nCommandArg;
					DirEntry aDirEntry(aParam);
					aDirEntry.ToAbs();
					if (aDirEntry.Exists()
						&& FileStat(aDirEntry).IsKind(FSYS_KIND_FILE))
						aFile = aDirEntry.GetFull();
					else
						continue;
				}
				else if (pLogFile)
					break;
				else
				{
					FileDialog * pFileDialog = new FileDialog(0, WB_OPEN);
					pFileDialog->SetText(ResId(RID_STR_EXPORT_FROM));
					if (bFirst)
						pFileDialog->SetPath(aExplorerPath);
					pFileDialog->SetDefaultExt("scc");
					pFileDialog->AddFilter(ResId(RID_STR_ALL_FILTER),
										   ALLFILES);
					String aFilter(ResId(RID_STR_SCC_FILTER));
					pFileDialog->AddFilter(aFilter, "*.scc");
					pFileDialog->SetCurFilter(aFilter);
					if (pFileDialog->Execute() != RET_OK)
					{
						delete pFileDialog;
						break;
					}

					aFile = pFileDialog->GetPath();
					delete pFileDialog;
				}
				if (pLogFile)
					*pLogFile << aFile.GetStr() << "\r\n";

				// Approximate disk space consumption:
				String aCacheNodeURL;
				{
					// Scan the .scc file for the .cache URL:
					enum Mode { MODE_SCAN, MODE_DOT, MODE_C, MODE_A, MODE_C2,
								MODE_H, MODE_E };
					SvFileStream aStream(aFile, STREAM_STD_READ);
					ULONG nRead;
					for (Mode eMode = MODE_SCAN;;)
					{
						unsigned char c;
						aStream >> c;
						if (aStream.IsEof() || aStream.GetError())
							break;
						++nRead;
						switch (eMode)
						{
							case MODE_SCAN:
								if (c == '.')
									eMode = MODE_DOT;
								break;

							case MODE_DOT:
								eMode = c == 'c' ?
										 MODE_C :
										c == '.' ?
										 MODE_DOT : MODE_SCAN;
								break;

							case MODE_C:
								eMode = c == 'a' ?
										 MODE_A :
										c == '.' ?
										 MODE_DOT : MODE_SCAN;
								break;

							case MODE_A:
								eMode = c == 'c' ?
										 MODE_C2 :
										c == '.' ?
										 MODE_DOT : MODE_SCAN;
								break;

							case MODE_C2:
								eMode = c == 'h' ?
										 MODE_H :
										c == '.' ?
										 MODE_DOT : MODE_SCAN;
								break;

							case MODE_H:
								eMode = c == 'e' ?
										 MODE_E :
										c == '.' ?
										 MODE_DOT : MODE_SCAN;
								break;

							case MODE_E:
								if (c == ':' && nRead >= 9)
								{
									aStream.SeekRel(-9);
									aStream >> aCacheNodeURL;
									goto done;
								}
								else
									eMode = c == '.' ? MODE_DOT : MODE_SCAN;
								break;
						}
					}
				done:;
				}

				BOOL bExport = TRUE;
				if (aCacheNodeURL.Len())
				{
					String aUserNodeURL(aCacheNodeURL);
					aUserNodeURL.Replace(1, 5, "user");

					CntRootNodeMgr::Own2FileURL(aCacheNodeURL);
					DirEntry aDirEntry(aCacheNodeURL);
					String aLongCacheName(aDirEntry.GetName());
					String aShortCacheName;
					if (CntRootNodeMgr::Get()->GetFileEntry(aLongCacheName,
															aShortCacheName))
					{
						aDirEntry.SetName(aShortCacheName);
						aCacheNodeURL = aDirEntry.GetFull(FSYS_STYLE_URL);
					}

					CntRootNodeMgr::Own2FileURL(aUserNodeURL);
					aDirEntry = aUserNodeURL;
					String aLongUserName(aDirEntry.GetName());
					String aShortUserName;
					if (CntRootNodeMgr::Get()->GetFileEntry(aLongUserName,
															aShortUserName))
					{
						aDirEntry.SetName(aShortUserName);
						aUserNodeURL = aDirEntry.GetFull(FSYS_STYLE_URL);
					}

					aDirEntry = aFile;
					FileStat aFileStat(aDirEntry);
					BigInt aSize = aFileStat.GetSize();
					BigInt aFreeBytes;
					BigInt aTotalBytes;
					ErrCode nError
					 = FileStat::QueryDiskSpace(aDirEntry.GetPath().GetFull(),
												aFreeBytes, aTotalBytes);
					BOOL bKnownMinFree = FALSE;
					BigInt aMinFree;
					if (nError == ERRCODE_NONE)
					{
						bKnownMinFree = TRUE;
						aMinFree = aFreeBytes;
					}

					aDirEntry = aCacheNodeURL;
					aFileStat = aDirEntry;
					BOOL bCacheNodeExists
					 = aDirEntry.Exists() && aFileStat.IsKind(FSYS_KIND_FILE);
					aSize += aFileStat.GetSize();
					nError
					 = FileStat::QueryDiskSpace(aDirEntry.GetPath().GetFull(),
												aFreeBytes, aTotalBytes);
					if (nError == ERRCODE_NONE)
						if (!bKnownMinFree)
						{
							bKnownMinFree = TRUE;
							aMinFree = aFreeBytes;
						}
						else if (aFreeBytes < aMinFree)
							aMinFree = aFreeBytes;

					aDirEntry = aUserNodeURL;
					aFileStat = aDirEntry;
					BOOL bConfigNodeExists
					 = aDirEntry.Exists() && aFileStat.IsKind(FSYS_KIND_FILE);
					aSize += aFileStat.GetSize();
					nError
					 = FileStat::QueryDiskSpace(aDirEntry.GetPath().GetFull(),
												aFreeBytes, aTotalBytes);
					if (nError == ERRCODE_NONE)
						if (!bKnownMinFree)
						{
							bKnownMinFree = TRUE;
							aMinFree = aFreeBytes;
						}
						else if (aFreeBytes < aMinFree)
							aMinFree = aFreeBytes;

					// Warn if no cache or user file:
					if (!(bCacheNodeExists && bConfigNodeExists))
					{
						WarningBox * pBox
						  = new WarningBox
							 (0,
							  ResId(bCacheNodeExists ?
									 RID_WARNINGBOX_NO_CONFIG :
									bConfigNodeExists ?
									 RID_WARNINGBOX_NO_CACHE :
									 RID_WARNINGBOX_NO_CACHE_CONFIG));
						if (pLogFile)
							*pLogFile << "  " << pBox->GetMessText().GetStr()
									  << "\r\n";
						else
							pBox->Execute();
						delete pBox;
					}

					BigInt aEstimateSize(aSize);
					aEstimateSize *= 4;
					BOOL bDiskFull = bKnownMinFree
									 && aEstimateSize > aMinFree;

					if (!bDiskFull)
					{
						BigInt aEstimateTempSize(aSize);
						aEstimateTempSize *= 2;
						aDirEntry = DirEntry("*").TempName();
						nError = FileStat::QueryDiskSpace(aDirEntry.GetPath().
														   GetFull(),
														  aFreeBytes,
														  aTotalBytes);
						bDiskFull = nError == ERRCODE_NONE
									&& aEstimateTempSize > aFreeBytes;
					}

					if (bDiskFull)
						if (pLogFile)
						{
							*pLogFile
							 << "  "
							 << String(ResId(RID_STR_DISKSPACE)).GetStr()
							 << "\r\n";
							bExport = FALSE;
						}
						else
						{
							QueryBox * pBox
							 = new QueryBox(0, ResId(RID_QUERYBOX_DISKSPACE));
							bExport = pBox->Execute() == RET_YES;
							delete pBox;
						}
				}

				if (bExport)
				{
					// Export account:
					DirEntry aDirEntry(aFile);
					aDirEntry.ToAbs();
					String aInFileName(aDirEntry.GetFull());
					if (!(aDirEntry.Exists()
						  && FileStat(aDirEntry).IsKind(FSYS_KIND_FILE)))
					{
						ErrorBox * pBox
						 = new ErrorBox(0, ResId(RID_ERRBOX_NO_EXPORT));
						String aText(pBox->GetMessText());
						aText.SearchAndReplace("$(ARG1)", aInFileName);
						if (pLogFile)
							*pLogFile << "  " << aText.GetStr() << "\r\n";
						else
						{
							pBox->SetMessText(aText);
							pBox->Execute();
						}
						delete pBox;
						continue;
					}

					WaitingDialog * pWaitingDialog = 0;
					if (!pLogFile)
					{
						pWaitingDialog = new WaitingDialog();
						pWaitingDialog->Show();
						pWaitingDialog->Update();
						Reschedule();
					}

					m_xAnchor
					 = new CntAnchor(0, aDirEntry.GetFull(FSYS_STYLE_URL));
					if (m_xAnchor->GetError()
						|| m_xAnchor->GetItemState(WID_EXPORT)
							< SFX_ITEM_DONTCARE)
					{
						if (!pLogFile)
						{
							pWaitingDialog->Hide();
							delete pWaitingDialog;
						}

						m_xAnchor.Clear();
						ErrorBox * pBox
						 = new ErrorBox(0, ResId(RID_ERRBOX_NO_EXPORT));
						String aText(pBox->GetMessText());
						aText.SearchAndReplace("$(ARG1)", aInFileName);
						if (pLogFile)
							*pLogFile << "  " << aText.GetStr() << "\r\n";
						else
						{
							pBox->SetMessText(aText);
							pBox->Execute();
						}
						delete pBox;
						continue;
					}

					aDirEntry.SetExtension("mbx");
					String aOutFileName(aDirEntry.GetFull());
					SvFileStream * pStream
					 = new SvFileStream(aOutFileName,
										STREAM_STD_WRITE | STREAM_TRUNC);
					if (pStream->GetError())
					{
						delete pStream;
						m_xAnchor.Clear();

						if (!pLogFile)
						{
							pWaitingDialog->Hide();
							delete pWaitingDialog;
						}

						ErrorBox * pBox
						 = new ErrorBox(0, ResId(RID_ERRBOX_NO_WRITE));
						String aText(pBox->GetMessText());
						aText.SearchAndReplace("$(ARG1)", aOutFileName);
						if (pLogFile)
							*pLogFile << "  " << aText.GetStr() << "\r\n";
						else
						{
							pBox->SetMessText(aText);
							pBox->Execute();
						}
						delete pBox;
						continue;
					}

					m_eStatus = STATUS_WAITING;
					SvLockBytes * pLockBytes = new SvLockBytes(pStream, TRUE);
					StartListening(*m_xAnchor);
					m_xAnchor->Put(SfxLockBytesItem(WID_EXPORT, pLockBytes));

					while (m_eStatus == STATUS_WAITING)
						Reschedule();

					UndoConversions();

					if (!pLogFile)
					{
						pWaitingDialog->Hide();
						delete pWaitingDialog;
					}

					if (m_eStatus == STATUS_FAILED)
					{
						ErrorBox * pBox
						 = new ErrorBox(0, ResId(RID_ERRBOX_FAILED));
						String aText(pBox->GetMessText());
						aText.SearchAndReplace("$(ARG1)", aInFileName);
						if (pLogFile)
							*pLogFile << "  " << aText.GetStr() << "\r\n";
						else
						{
							pBox->SetMessText(aText);
							pBox->Execute();
						}
						delete pBox;
					}
					else
					{
						InfoBox * pBox
						 = new InfoBox(0, ResId(RID_INFOBOX_SUCCESS));
						String aText(pBox->GetMessText());
						aText.SearchAndReplace("$(ARG1)", aInFileName);
						aText.SearchAndReplace("$(ARG2)", aOutFileName);
						if (pLogFile)
							*pLogFile << "  " << aText.GetStr() << "\r\n";
						else
						{
							pBox->SetMessText(aText);
							pBox->Execute();
						}
						delete pBox;
					}
				}
			}
		}

		Deinitialize();
		delete pLogFile;
	}

	if (m_pConversionList)
	{
		UndoConversions();
		for (CntRootNodeMgrConversionEntry * pEntry
			  = m_pConversionList->m_pList;
			 pEntry;)
		{
			CntRootNodeMgrConversionEntry * pNext = pEntry->m_pNext;
			delete pEntry;
			pEntry = pNext;
		}
	}

	Resource::SetResManager(0);
	delete pResMgr;
}

//============================================================================
// virtual
void ExportApplication::Notify(SfxBroadcaster & rBroadcaster,
							   const SfxHint & rHint)
{
	if (&rBroadcaster && &rBroadcaster == &m_xAnchor)
	{
		CntAnchorHint * pAnchorHint = PTR_CAST(CntAnchorHint, &rHint);
		if (pAnchorHint)
			switch (pAnchorHint->GetAction())
			{
				case CNT_ACTION_ABORTED:
				{
					EndListening(*m_xAnchor);
					m_xAnchor.Clear();
					m_eStatus = STATUS_FAILED;
					return;
				}

				case CNT_ACTION_EXPORT_DONE:
				{
					EndListening(*m_xAnchor);
					m_xAnchor.Clear();
					m_eStatus = STATUS_DONE;
					return;
				}
			}
	}
}

//============================================================================
// static
String ExportApplication::ChangePath(const String & rPath,
									 const String & rDir)
{
	String aOldPath = DirEntry(rPath).GetFull(FSYS_STYLE_URL, TRUE);
	if (aOldPath.Len())
		for (USHORT i = aOldPath.Len() - 1; i; --i)
			if (aOldPath.GetChar(i - 1) == '/')
			{
				aOldPath.Erase(i);
				aOldPath += rDir;
				aOldPath += '/';
				DirEntry aNewPath(aOldPath);
				if (aNewPath.Exists()
					&& FileStat(aNewPath).IsKind(FSYS_KIND_DIR))
					return aNewPath.GetFull();
				break;
			}
	return String();
}

