/*************************************************************************
 *
 *  $RCSfile: soexp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SOEXP_HXX
#define _SOEXP_HXX

#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _CNTAPI_HXX //autogen
#include <sfx2/cntapi.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _TOOLS_RC_HXX //autogen
#include <tools/rc.hxx>
#endif

//============================================================================
class CCPathsDialog: public ModalDialog
{
private:
	FixedText m_aFTIntro;
	FixedText m_aFTCache;
	Edit m_aEDCachePath;
	PushButton m_aPBCacheBrowse;
	FixedText m_aFTConfig;
	Edit m_aEDConfigPath;
	PushButton m_aPBConfigBrowse;
	OKButton m_aPBOK;
	CancelButton m_aPBCancel;
	FixedText m_aFTWarning;

	BOOL m_bCachePathValid;
	BOOL m_bConfigPathValid;

	DECL_LINK(PathEditModifyHandler, Edit *);
	DECL_LINK(BrowseButtonClickHandler, PushButton *);

public:
	CCPathsDialog(const String & rCacheDirectory,
				  const String & rConfigDirectory);
	virtual ~CCPathsDialog() {}

	String GetCacheDirectory() const;
	String GetConfigDirectory() const;
};

//============================================================================
class WaitingDialog: public ModelessDialog
{
public:
	WaitingDialog();
	virtual ~WaitingDialog() {}

	virtual void Paint(const Rectangle &);
};

//============================================================================
class ExportApplication: public SfxApplication, public SfxListener
{
private:
	enum Status { STATUS_WAITING, STATUS_FAILED, STATUS_DONE };

	CntRootNodeMgrConversionList * m_pConversionList;
	Status m_eStatus;
	CntAnchorRef m_xAnchor;

	void UndoConversions();

	virtual void Main();

public:
	ExportApplication(): SfxApplication("soe") {}
	virtual ~ExportApplication() {}

	virtual void AppEvent(const ApplicationEvent & rAppEvent)
	{ Application::AppEvent(rAppEvent); }

	virtual void Notify(SfxBroadcaster & rBroadcaster, const SfxHint & rHint);

	static String ChangePath(const String & rPath, const String & rDir);
};

#endif // _SOEXP_HXX

