/*************************************************************************
 *
 *  $RCSfile: appdemo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVTDEMO_HXX //autogen
#include <svtools/svtdemo.hxx>
#endif
#ifndef _INIMAN_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _SV_CONFIG_HXX //autogen
#include <vcl/config.hxx>
#endif
#ifndef _PVER_HXX //autogen
#include <svtools/pver.hxx>
#endif

#pragma hdrstop

#include "inimgr.hxx"
#include "dispatch.hxx"
#include "register.hxx"

#include "sfxtypes.hxx"
#include "saveopt.hxx"
#include "sfxresid.hxx"
#include "appdata.hxx"
#include "app.hxx"
#include "app.hrc"
//#include "resmgr.hxx"

//=========================================================================

//--------------------------------------------------------------------

FASTBOOL SfxApplication::IsDemo()

/*  [Beschreibung]

	Diese virtuelle Methode sollte von den Applikationen "ubrladen
	werden, damit aus dem SFx erfragt werden kann, ob es sich um eine
	Demo-Version handelt.
*/

{
	return FALSE;
}

//--------------------------------------------------------------------

const char pDemoIndicator[] =	"tlxsayshere";

//--------------------------------------------------------------------

BOOL SfxApplication::CheckTryBuy_Impl()
{
	SvDemo::Init( pDemoIndicator, DEMO_LIB_NAME );
    return TRUE;
}

//--------------------------------------------------------------------

USHORT SfxApplication::GetDemoKind() const

/*  [Beschreibung]

	Durch diese Methode teilt der Sfx der Applikation mit, ob es sich um eine Demo handelt.
*/

{
	USHORT& rnDemoKind = Get_Impl()->nDemoKind;
	if( !rnDemoKind )
	{
		// (pb) SvDemo is buggy under Unix -> Task #76122#, Owner 'OK'
#ifndef UNX
		rnDemoKind =  SvDemo::GetDemoKind( Application::GetAppName() );
#else
		rnDemoKind = SFX_DEMOKIND_FULL;
#endif
	}
	return rnDemoKind;
}

//--------------------------------------------------------------------

/*  [Beschreibung]

	handelt es sich um eine Demoversion, so schreibe eine Bitmap auf den
	Outputdevice ("TESTVERSION" oder Finger)

*/

void SfxApplication::SpoilDemoOutput(
	OutputDevice &rDevice, const Rectangle& rRect) const
{
//    SvDemo::SpoilDemoOutput( Application::GetAppName(), rDevice, rRect );
}

