/*************************************************************************
 *
 *  $RCSfile: applicat.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
 //==================================================================
// class SfxApplication
//
// Copyright 2000 Sun Microsystems, Inc. All rights reserved.
// $Author: hr $ $Date: 2000/09/18 16:52:26 $ $Revision: 1.1.1.1 $
// $Logfile:   T:/sfx2/source/appl/applicat.cxv  $ $Workfile:   applicat.cxx  $
//------------------------------------------------------------------

#include <stdio.h>

#include "app.hxx"
#include <unotools/regpathhelper.hxx>

#pragma hdrstop

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _LIBCALL_HXX //autogen
#include <svtools/libcall.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#if SUPD < 600
#ifndef SVTOOLS_TESTTOOL_HXX //autogen
#include <svtools/testtool.hxx>
#endif
#else
#ifndef AUTOMATION_HXX //autogen
#include <automation/automation.hxx>
#endif
#endif
#ifndef _EXTATTR_HXX //autogen
#include <svtools/extattr.hxx>
#endif
#ifndef _SV_HELP_HXX //autogen
#include <vcl/help.hxx>
#endif
#ifndef _VOS_PROFILE_HXX_
#include <vos/profile.hxx>
#endif
#include <vos/process.hxx>
#ifndef _COM_SUN_STAR_BRIDGE_XCONNECTCALLBACK_HPP_
#include <com/sun/star/bridge/XConnectCallback.hpp>
#endif
#ifndef _COM_SUN_STAR_BRIDGE_XCONNECTIONSERVERSIDE_HPP_
#include <com/sun/star/bridge/XConnectionServerSide.hpp>
#endif
#ifndef _COM_SUN_STAR_BRIDGE_XCONNECTIONBROKER_HPP_
#include <com/sun/star/bridge/XConnectionBroker.hpp>
#endif
#ifndef _COM_SUN_STAR_BRIDGE_XCONNECTIONCLIENTSIDE_HPP_
#include <com/sun/star/bridge/XConnectionClientSide.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINER_HPP_
#include <com/sun/star/container/XContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEREPLACE_HPP_
#include <com/sun/star/container/XNameReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINERLISTENER_HPP_
#include <com/sun/star/container/XContainerListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_CONTAINEREVENT_HPP_
#include <com/sun/star/container/ContainerEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXREPLACE_HPP_
#include <com/sun/star/container/XIndexReplace.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HPP_
#include <com/sun/star/loader/CannotActivateFactoryException.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTENTENUMERATIONACCESS_HPP_
#include <com/sun/star/container/XContentEnumerationAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XENUMERATION_HPP_
#include <com/sun/star/container/XEnumeration.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <unotools/processfactory.hxx>
#endif
#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include <cppuhelper/servicefactory.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif

#include <tools/tempfile.hxx>
#include <vos/process.hxx>
#include <vos/thread.hxx>
#include <vos/timer.hxx>

//#include <daemons/cryptor.hxx>
#define LOGIN_DECRYPT_PASSWORD			"U^gZ~@s2"

#if defined(UNX)
#include <limits.h>
#define _MAX_PATH PATH_MAX
#endif

#include <osl/file.hxx>

#include "app.hrc"
#include "sfxresid.hxx"
#include "rmacceptor.hxx"
#include "sfxhelp.hxx"

// Registrierte Services
#include "objuno.hxx"
#include "docfile.hxx"
#include "appuno.hxx"
#include "downloadcontroller.hxx"
#include "sfxuno.hxx"
#include "viewfrm.hxx"
#include "helper.hxx"	// SfxContentHelper::Kill()
#include "ucbhelp.hxx"

/*-* HACK FOR PLUGIN ******************************************************************************************************************/
#include "opipeconnection.hxx"
#include "oinstanceprovider.hxx"
#include "appdata.hxx"
#ifndef _COM_SUN_STAR_CONNECTION_XConnection_HPP_
#include <com/sun/star/connection/XConnection.hpp>
#endif
#ifndef _COM_SUN_STAR_BRIDGE_XBridgeFactory_HPP_
#include <com/sun/star/bridge/XBridgeFactory.hpp>
#endif
using namespace ::com::sun::star::connection	;
using namespace ::com::sun::star::bridge		;
/*-* HACK FOR PLUGIN ******************************************************************************************************************/

using namespace ::vos;
using namespace ::rtl;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::registry;
using namespace ::com::sun::star::lang;


#ifndef _SVDDE_HXX //autogen
#include <svtools/svdde.hxx>
#endif

SvFileStream *pOfficeLock_Impl = 0;

String SfxServiceName_Impl( const String& sIn )
{
	ByteString sTemp = U2S( sIn );
	ByteString sReturn;

	for ( sal_uInt16 n = sTemp.Len(); n; --n )
		if ( sTemp.Copy( n-1, 1 ).IsAlphaNumericAscii() )
			sReturn += sTemp.GetChar(n-1);

	return S2U( sReturn );
}

#define SFX_TEMPNAMEBASE_DIR        "$(userurl)/temp" //"soffice.tmp"
#define SFX_KEY_TEMPNAMEBASE		"Temp-Dir"

static String aTempNameBaseDir;
static String aTempBase;

/*-* HACK FOR PLUGIN ******************************************************************************************************************/
#define	COMMANDARGUMENT_PLUGIN					OUString(RTL_CONSTASCII_USTRINGPARAM("/plugin"								))
#define	NAME_PLUGINBRIDGE						OUString(RTL_CONSTASCII_USTRINGPARAM("mozilla plugin bridge"				))
#define	PROTOCOL_PLUGINBRIDGE					OUString(RTL_CONSTASCII_USTRINGPARAM("urp"									))
#define	SERVICENAME_BRIDGEFACTORY				OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.bridge.BridgeFactory"	))
/*-* HACK FOR PLUGIN ******************************************************************************************************************/

int GetModulePathName( const char*, char*, unsigned short );


//***********************************************************************************************************************

#define SERVICE_SIMPLEREGISTRY             "com.sun.star.registry.SimpleRegistry"

#if 0

#if defined( WNT ) || defined( OS2 )
#define PATH_DELEMITTER						'\\'
#elif defined( UNX )
#define PATH_DELEMITTER						'/'
#elif defined( MAC )
#define PATH_DELEMITTER						':'
#else
#define PATH_DELEMITTER						'/'
#endif

#define USER_REGISTRY_NAME_ENV 				"STAR_USER_REGISTRY"
#define SYSTEM_REGISTRY_NAME_ENV 			"STAR_REGISTRY"
#define SVERSION_NAME						"sversion"
#define REGISTRY_SECTION					"Registry"
#define REGISTRY_VERSION_KEY				"UserRegistry 5.2"
#define REGISTRY_LOCAL_NAME					"user52.rdb"
#define REGISTRY_SYSTEM_NAME				"applicat.rdb"
#define LOCALREGISTRY_DEFAULTLOCATION		"?^"
#define SVERSION_LOCATION					"?^"
#define SVERSION_FALLBACK					"?$"

static OString getLocalRegistry()
{
	OUString	sFileName						;
	OString		registryName					;
	sal_Char	buffer[_MAX_PATH]	= ""		;
	FILE*		f					= NULL		;
	sal_Bool	findProfile			= sal_False	;

	// search the environment STAR_USER_REGISTRY
	registryName = getenv(USER_REGISTRY_NAME_ENV) ;
	if (registryName.getLength() > 0)
	{
		f = fopen(registryName.getStr(), "r");

		if (f != NULL)
		{
			fclose(f);
			return registryName;
		}
	}

	// search for entry in sversion.ini in config directory
	if ( ::vos::OProfile::getProfileName(sFileName, DEFINE_CONST_UNICODE(SVERSION_NAME), DEFINE_CONST_UNICODE(SVERSION_LOCATION)))
	{
		::vos::OProfile profile;

		if ( profile.open(sFileName) )
		{
			findProfile = sal_True;

			OString userRegistryKey(REGISTRY_VERSION_KEY);
			userRegistryKey += "/";
			userRegistryKey += OString::valueOf((sal_Int32)SUPD);

			if ( profile.readString(REGISTRY_SECTION, userRegistryKey.getStr(), buffer, _MAX_PATH, "") )
			{
				if ( buffer[0] == '\0' )
				{
					if ( profile.readString(REGISTRY_SECTION, REGISTRY_VERSION_KEY, buffer, _MAX_PATH, "") )
						registryName = buffer;
				} else
				{
					registryName = buffer;
				}
			}
		}

		if ( registryName.getLength() > 0 )
		{
			f = fopen(registryName.getStr(), "r");

			if (f != NULL)
			{
				fclose(f);
				return registryName;
			}
		}
	}
	// search for entry in sversion.ini in system directory
	if ( !findProfile && ::vos::OProfile::getProfileName(sFileName, DEFINE_CONST_UNICODE(SVERSION_NAME) , DEFINE_CONST_UNICODE(SVERSION_FALLBACK)))
	{
		::vos::OProfile profile;

		if ( profile.open(sFileName) )
		{
			OString userRegistryKey(REGISTRY_VERSION_KEY);
			userRegistryKey += "/";
			userRegistryKey += OString::valueOf((sal_Int32)SUPD);

			if ( profile.readString(REGISTRY_SECTION, userRegistryKey.getStr(), buffer, _MAX_PATH, "") )
			{
				if (buffer[0] == '\0')
				{
					if (profile.readString(REGISTRY_SECTION, REGISTRY_VERSION_KEY, buffer, _MAX_PATH, ""))
						registryName = buffer;
				} else
				{
					registryName = buffer;
				}
			}
		}

		if ( registryName.getLength() > 0 )
		{
			f = fopen(registryName.getStr(), "r");

			if (f != NULL)
			{
				fclose(f);
				return registryName;
			}
		}
	}

	// default security of logged in user
	OSecurity sec;
	OUString  sConfigDir;

	if ( sec.getConfigDir(sConfigDir) && sConfigDir.getLength() > 0 )
	{
		// search without dot
		registryName = U2S( sConfigDir );
		if ( registryName.getLength() > 0 )
			registryName += OString::valueOf(PATH_DELEMITTER);
		registryName += REGISTRY_LOCAL_NAME;

		f = fopen(registryName.getStr(), "r");

		if (f == NULL)
		{
			// search with dot
			registryName = U2S( sConfigDir );
			if ( registryName.getLength() > 0 )
				registryName += OString::valueOf(PATH_DELEMITTER);

			registryName += ".";
			registryName += REGISTRY_LOCAL_NAME;

			f = fopen(registryName.getStr(), "r");

			if (f == NULL)
			{
				registryName = "";
			}
		}

		if (f != NULL)
		{
			fclose(f);
		}
	}

	return registryName;
}

// search for the system registry:
// The system registry will always be searched in the same directory of the
// executable. If not found the environemnt variable STAR_REGISTRY will be checked.
static OString getSystemRegistry()
{
	OUString buffer ;
	OString registryBaseName = REGISTRY_SYSTEM_NAME;
	OString registryName;
	FILE  *f=NULL;

	// search in the directory of the executable
	if( OStartupInfo::E_None ==
		OStartupInfo().getExecutableFile(buffer) )
	{
		OString 	tmpStr = U2S(buffer);
		sal_Int32 	lastIndex = tmpStr.lastIndexOf(PATH_DELEMITTER);

		if (lastIndex > 0)
		{
			registryName = tmpStr.copy(0, tmpStr.lastIndexOf(PATH_DELEMITTER) + 1);
		}

		registryName += registryBaseName;

		f = fopen(registryName.getStr(), "r");
	}

	if (f == NULL)
	{
		// search the environment STAR_REGISTRY
		registryName = getenv(SYSTEM_REGISTRY_NAME_ENV);
		if (registryName.getLength() > 0)
		{
			f = fopen(registryName.getStr(), "r");

			if (f != NULL)
			{
				fclose(f);
				return registryName;
			} else
			{
				registryName = "";
			}
		}
	} else
	{
		fclose(f);
	}

	return registryName;
}

static OString getDefaultLocalRegistry()
{
	OUString buffer;
	OString registryName;

	if ( ::vos::OProfile::getProfileName(buffer, DEFINE_CONST_UNICODE(REGISTRY_LOCAL_NAME), DEFINE_CONST_UNICODE(LOCALREGISTRY_DEFAULTLOCATION)) )
	{
		registryName = U2S( buffer );
	}

	return registryName;
}

#endif

::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > createApplicationServiceManager()
{
	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory > xReturn = ::cppu::createServiceFactory();

	try
	{

	if ( xReturn.is() )
	{
        Reference< XInitialization > xInit ( xReturn, UNO_QUERY ) ;
		if ( xInit.is() )
		{
            ::rtl::OUString localRegistry = ::utl::getPathToUserRegistry();
            ::rtl::OUString systemRegistry = ::utl::getPathToSystemRegistry();

            Reference< XSimpleRegistry > xLocalRegistry   ( xReturn->createInstance( DEFINE_CONST_UNICODE(SERVICE_SIMPLEREGISTRY) ), UNO_QUERY );
            Reference< XSimpleRegistry > xSystemRegistry ( xReturn->createInstance( DEFINE_CONST_UNICODE(SERVICE_SIMPLEREGISTRY) ), UNO_QUERY );
			if ( xLocalRegistry.is() && (localRegistry.getLength() > 0) )
			{
                try
                {
                    xLocalRegistry->open( localRegistry, sal_False, sal_True);
                }
                catch ( InvalidRegistryException& )
                {
                }

                if ( !xLocalRegistry->isValid() )
                    xLocalRegistry->open(localRegistry, sal_True, sal_True);
			}

			if ( xSystemRegistry.is() && (systemRegistry.getLength() > 0) )
                xSystemRegistry->open( systemRegistry, sal_True, sal_False);

			if ( (xLocalRegistry.is() && xLocalRegistry->isValid()) &&
			 	(xSystemRegistry.is() && xSystemRegistry->isValid()) )
			{
                Sequence< Any > seqAnys(2);
				seqAnys[0] <<= xLocalRegistry ;
				seqAnys[1] <<= xSystemRegistry ;

                Reference < XSimpleRegistry > xReg(
                            xReturn->createInstanceWithArguments(
                            DEFINE_CONST_UNICODE("com.sun.star.registry.NestedRegistry"), seqAnys ), UNO_QUERY );

                seqAnys = Sequence< Any >( 1 );
                seqAnys[0] <<= xReg;
                if ( xReg.is() )
                    xInit->initialize( seqAnys );
			}
		}
		else
		{
			xReturn = ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >();
		}
	}
	}

	catch( ::com::sun::star::uno::Exception& )
	{
	}

	return xReturn ;
}

//***********************************************************************************************************************

void RegisterServices()
{
#if 0	//(dv!)
	UNO_setJavaEnvironment(getJavaVM_sj2,
						   enterJavaCall_sj2,
						   leaveJavaCall_sj2,
						   calledFromJavaBegin_sj2,
						   calledFromJavaEnd_sj2);
#endif	//(dv!)

    ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xSMgr = createApplicationServiceManager();
    if( ! xSMgr.is() )
      {
	fprintf( stderr , "Failed to load necessary components\n" );
	exit(0);
      }

	::utl::setProcessServiceFactory( xSMgr );
	::com::sun::star::uno::Reference< ::com::sun::star::container::XSet >  xSet( xSMgr, ::com::sun::star::uno::UNO_QUERY );

	xSet->insert( ::com::sun::star::uno::Any( &SfxStandaloneDocumentInfoObject::impl_createFactory(xSMgr), ::getCppuType((const ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface >*)0) ) );

/*
	if (xSMgr.is())
	{
		static ::com::sun::star::uno::Reference< ::com::sun::star::bridge::XConnectionClientSide >  xUcbConnection(xSMgr->createInstance("com.sun.star.bridge.PortalConnection"), ::com::sun::star::uno::UNO_QUERY);

		OUString serverUrl;
		OUString userName;
		OUString password;
		OUString userParamPrefix("userid:");

		OStartupInfo info;

		// get the uno url for connecting to the UCB
		sal_Char buffer[1024] = "";

		info.getEnvironment("SOFFICE_UCB_URL", buffer, sizeof(buffer));

		serverUrl = OUString::createFromAscii(buffer);

		// get the password for connecting to the UCB and decrypt it, if neccesary
		info.getEnvironment("SOFFICE_UCB_TOKEN", buffer, sizeof(buffer));

		const sal_Char cCryptFlag = buffer[0];

		if (cCryptFlag != '\0')
		{
			if(cCryptFlag != ' ')
			{
				Cryptor		cryptor;

				cryptor.decryptString( buffer + 1, strlen(buffer) - 1, LOGIN_DECRYPT_PASSWORD );
				password = OUString::createFromAscii(cryptor.getResult());
			}
			else
			{
				password = OUString::createFromAscii(buffer + 1);
			}
		}


		// get the user name for connecting to the UCB
		info.getCommandArgs(buffer, sizeof(buffer));

		sal_Char* pChar = buffer;
		sal_Bool bBean = sal_False;

		while( *pChar != '\0' )
		{
			OUString param = OUString::createFromAscii( pChar );
			sal_Int32 index = param.indexOf( userParamPrefix );
			if( index < 0 )
			{
				index = param.indexOf( "-bean" );
				if( index >= 0 )
					bBean = sal_True;
			}
			else
			{
				userName = param.copy( index + userParamPrefix.getLength() );
				index = userName.indexOf( L'[' );
				if( index > 0 )
					userName = userName.copy( 0, index );
			}

			pChar += 1 + strlen( pChar );
		}

		if (xUcbConnection.is() && (serverUrl.getLength() > 0) && (bBean == sal_True) )
		{
			try
			{
				// conect and get remote service manager
				if (xUcbConnection->connect(serverUrl, userName, password))
				{
					::com::sun::star::uno::Reference< ::com::sun::star::container::XSet >  xRemoteManager(xUcbConnection->getRemoteObject(), ::com::sun::star::uno::UNO_QUERY);

					if (xRemoteManager.is())
					{
						// replace denoted service names in remote manager
						// by local provider factories
						::com::sun::star::uno::Reference< ::com::sun::star::container::XContentEnumerationAccess >  xRemoteAccess(xRemoteManager, ::com::sun::star::uno::UNO_QUERY);
						::com::sun::star::uno::Reference< ::com::sun::star::container::XContentEnumerationAccess >  xLocalAccess(xSet, ::com::sun::star::uno::UNO_QUERY);

						for (int i = 0; i < NUM_OF_REMOTE_SERVICES; i++)
						{
							OUString aServiceName(OUString::createFromAscii(REMOTE_SERVICES[i]));

							::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration >  xRemoteEnum(xRemoteAccess->createContentEnumeration(aServiceName));
							::com::sun::star::uno::Reference< ::com::sun::star::container::XEnumeration >  xLocalEnum(xLocalAccess->createContentEnumeration(aServiceName));

							while (xLocalEnum.is() && xLocalEnum->hasMoreElements())
							{
								::com::sun::star::uno::Any aServiceFactory = xLocalEnum->nextElement();

								xSet->remove(aServiceFactory);
							}

							while (xRemoteEnum.is() && xRemoteEnum->hasMoreElements())
							{
								::com::sun::star::uno::Any aServiceFactory = xRemoteEnum->nextElement();

								xSet->insert(aServiceFactory);
							}
						}
					}
				}
			}
			catch (::com::sun::star::uno::Exception& )
			{
			}
		}
	}
*/
	// try to start OLE registration service.
	// on success (WIN32 only) this process will work
	// as OLE automation server for standard UNO objects.
	xSMgr->createInstance(DEFINE_CONST_UNICODE("com.sun.star.bridge.OleApplicationRegistration"));

	SfxIniManager* pIniMgr;
	try
	{
    	pIniMgr = SfxIniManager::Create();
    }
    catch ( ::com::sun::star::registry::InvalidRegistryException& )
    {
		// If some configurtation files are missing or corrupt
		// try to start setup. If starting failed show a errorbox and exit application with an error code.
		INetURLObject aSetupObj( Application::GetAppFileName(), INET_PROT_FILE );
		#if defined(UNX)
		aSetupObj.setName( DEFINE_CONST_UNICODE("setup") );
		#endif
		#if defined(WIN) || defined(WNT) || defined(OS2)
		aSetupObj.setName( DEFINE_CONST_UNICODE("setup.exe") );
		#endif
		#if defined(MAC)
		aSetupObj.setName( DEFINE_CONST_UNICODE("Setup") );
		#endif

		// We must use different messages for fat office and portal.
		// A fat office can be repaired by user himself ...
		// but portal problems must fixed by an admin!
		String aMsg;
		if( Application::IsRemoteServer())
		{
			aMsg += DEFINE_CONST_UNICODE("Your user account is not configured correctly.\n");
    		aMsg += DEFINE_CONST_UNICODE("Please contact your StarPortal administator.\n");
		}
		else
		{
			aMsg += DEFINE_CONST_UNICODE("Configuration files could not be found.\n");
    		aMsg += DEFINE_CONST_UNICODE("Can't start neither StarOffice nor Setup.\n");
			aMsg += DEFINE_CONST_UNICODE("Please try to start setup by yourself.");
		}

		String aImageName( aSetupObj.PathToFileName() );
		VOS_NAMESPACE(OProcess,vos) aProcess( aImageName.GetBuffer(), DEFINE_CONST_UNICODE("/officemode") );
		if ( 0 != aProcess.execute( VOS_NAMESPACE(OProcess,vos)::TOption_Detached ) )
			Application::Abort( aMsg );
		exit(-1);
    }

    INetURLObject aOfficeLockObj( pIniMgr->Get( SFX_KEY_USERCONFIG_PATH ), INET_PROT_FILE );
	aOfficeLockObj.insertName( DEFINE_CONST_UNICODE( "soffice.lck" ) );
	pOfficeLock_Impl = Application::IsRemoteServer() ? NULL :
			new SvFileStream( aOfficeLockObj.GetMainURL(), STREAM_WRITE | STREAM_SHARE_DENYALL );

	// Prevent from multiple starts from the same user directory by trying to lock the common lock file
	if ( pOfficeLock_Impl && pOfficeLock_Impl->GetError() )
	{
		String aService( SfxServiceName_Impl( aOfficeLockObj.PathToFileName() ) );
		aService.ToUpperAscii();

		// trigger first instance
		DdeConnection aTriggerConn( aService, DEFINE_CONST_UNICODE( "TRIGGER" ) );
		DdeConnection aSystemConn( Application::GetAppName(), DEFINE_CONST_UNICODE( "System" ) );
		if ( !aTriggerConn.GetError() && !aSystemConn.GetError() )
		{
			// bring to front
			::DdeExecute aCommand(aTriggerConn, DEFINE_CONST_UNICODE( "APPEAR" ) );
			aCommand.Execute();

			// pass command line arguments
			for ( sal_uInt16 i = 0; i < Application::GetCommandLineParamCount(); i++ )
			{
				String aCmd;
				String aParam( Application::GetCommandLineParam(i) );
				if	(
						( aParam.CompareToAscii( "/p" ) == COMPARE_EQUAL )	||
						( aParam.CompareToAscii( "-p" ) == COMPARE_EQUAL )
					)
				{
                    aCmd = DEFINE_CONST_UNICODE( "Print(\"" );
					if ( ++i >= Application::GetCommandLineParamCount() )
						break;
					aParam = Application::GetCommandLineParam(i);
					if ( aParam.GetChar(0) == 0x0040 ) // '@' = 40h
					{
						aCmd += DEFINE_CONST_UNICODE( "\", \"" );
						aCmd += aParam;
						if ( ++i >= Application::GetCommandLineParamCount() )
							break;
					}
				}
				else
                    aCmd = DEFINE_CONST_UNICODE( "Open(\"" );
				aCmd += Application::GetCommandLineParam(i);
				aCmd += DEFINE_CONST_UNICODE("\")");

				::DdeExecute aCommand(aSystemConn, aCmd);
				aCommand.Execute();
			}

            exit(0);
		}

		// first instance not accessible ( perhaps also starting )
//        ErrorBox( 0, WB_OK, SfxResId( STR_NODOUBLE ) ).Execute();
//        return;
        exit(0);
	}

    // remove old temp dir
    String aTemp( DEFINE_CONST_UNICODE( SFX_TEMPNAMEBASE_DIR ) );
    aTempNameBaseDir = pIniMgr->SubstPathVars( aTemp );

    String aOldTempBase( pIniMgr->Get( SFX_GROUP_DIR, DEFINE_CONST_UNICODE( SFX_KEY_TEMPNAMEBASE ) ) );
    if ( STRING_NOTFOUND != aOldTempBase.Search( aTempNameBaseDir ) )
		SfxContentHelper::Kill( aOldTempBase );

	// set temp base directory
    ::rtl::OUString aRet;
    ::osl::FileBase::getNormalizedPathFromFileURL( aTempNameBaseDir, aRet );
    aTempBase = TempFile::SetTempNameBaseDirectory( aRet );
    pIniMgr->Set( aTempBase, SFX_GROUP_DIR, DEFINE_CONST_UNICODE( SFX_KEY_TEMPNAMEBASE ) );
}

void SfxApplicationClass::Main( )
{
    Application::SetSystemWindowMode( SYSTEMWINDOW_MODE_DIALOG );

	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >	xSMgr = ::utl::getProcessServiceFactory();
	::com::sun::star::uno::Reference< ::com::sun::star::bridge::XConnectionBroker >		xServiceManagerBroker;
	::com::sun::star::uno::Reference< ::com::sun::star::bridge::XConnectionBroker >		xPalmPilotManagerBroker;
	::sfx2_rmacceptor::OAcceptorThread *pAcceptor = 0;

	// dv - there is no cancel manager
	UCB_Helper::Initialize();

    SfxIniManager* pIni = SfxIniManager::Get();
    if ( !pIni )
        pIni = SfxIniManager::Create();

//  	if ( !Application::IsRemoteServer() )
//  	{
/*ASMUSS
		String aPort = pIni->Get( DEFINE_CONST_UNICODE( "Common" ), 0, 0, DEFINE_CONST_UNICODE( "Port" ) );
		char *pEnv=0;
#if defined( WNT )
		pEnv = getenv( "SOPORT" );
#endif
		if ( (sal_uInt32) aPort.ToInt32() || pEnv )
		{
			String aURL = "uno://*:" ;
			aURL += pEnv ? pEnv : aPort;

			xServiceManagerBroker = ::com::sun::star::uno::Reference< ::com::sun::star::bridge::XConnectionBroker > ( xSMgr->createInstance(OUString::createFromAscii("com.sun.star.bridge.ConnectionBroker")), ::com::sun::star::uno::UNO_QUERY );
			if( xServiceManagerBroker.is() )
			{
				::com::sun::star::uno::Reference< ::com::sun::star::bridge::XConnectCallback >  xCallback = new RemoteManager_Impl( xSMgr );
				xServiceManagerBroker->acceptConnections( StringToOUString( aURL, RTL_TEXTENCODING_UTF8 ), xCallback );
			}
		}
ASMUSS*/
		//-----
		// create TestPort for the new Uno-Languagebinding
		//-----
	OSL_TRACE("before accepting\n");
		String sURL = pIni->Get( DEFINE_CONST_UNICODE( "Common" ), 0 , 0 , DEFINE_CONST_UNICODE( "Connection" ) );
		if( sURL.Len() )
		{
	OSL_TRACE("in accepting\n");
			pAcceptor = new ::sfx2_rmacceptor::OAcceptorThread(xSMgr, sURL );
			pAcceptor->create();
		}
//  	}

	RemoteControl aControl;

	// At the moment a SfxApplication is used for application services
	SfxApplication *pApp = SFX_APP();

    Reference < XComponent > xDesktop( xSMgr->createInstance(OUString::createFromAscii("com.sun.star.frame.Desktop")), UNO_QUERY );

//    pApp->Main();

	/*-* HACK FOR PLUGIN ******************************************************************************************************************/
	if ( pApp->Get_Impl()->bIBMTitle == sal_True )
	{
		Reference< XConnection >	xConnection			= new OPipeConnection( xSMgr );
		Reference< XBridgeFactory >	xBridgeFactory		( xSMgr->createInstance( SERVICENAME_BRIDGEFACTORY	), UNO_QUERY );
		if	(
				( xConnection.is()			== sal_True )	&&
				( xBridgeFactory.is()		== sal_True )
			)
		{
			Reference< XBridge > xBridge = xBridgeFactory->createBridge(	NAME_PLUGINBRIDGE				,
																			PROTOCOL_PLUGINBRIDGE			,
																			xConnection						,
																			new OInstanceProvider( xSMgr )	);
		}
		else
		{
        	DBG_ERROR( "No connect to plugin! Initialization of bridge failed." );
		}
	}
	/*-* HACK FOR PLUGIN ******************************************************************************************************************/
    {
        // use one scope for Help instance because it must be destroyed before Deinit (sends AppEvent in DTOR)
        SfxHelp_Impl aHelp;
        Application::SetHelp( &aHelp );
        String aString;
        if ( SfxObjectFactory::HasObjectFactories() )
        {
            aString = SfxObjectFactory::GetDefaultFactory().GetHelpFile();
        }
        else
        {
			INetURLObject aAppNameObj( Application::GetAppFileName(), INET_PROT_FILE );
            aAppNameObj.setExtension( String::CreateFromAscii( "hlp" ) );
            aString = aAppNameObj.PathToFileName();
        }

        aHelp.SetHelpFile( aString );
        Execute();
    }

    xDesktop->dispose();

	// remove temp directory
    if ( STRING_NOTFOUND != aTempBase.Search( aTempNameBaseDir ) )
	{
		if ( SfxContentHelper::Kill( aTempBase ) )
		{
			pIni->Set( String(), SFX_GROUP_DIR, DEFINE_CONST_UNICODE( SFX_KEY_TEMPNAMEBASE ) );
			INetURLObject aObj( aTempBase, INET_PROT_FILE );
			aObj.removeSegment();
			SfxContentHelper::Kill( aObj.GetMainURL() );
		}
	}

	// unlock lock file
	if ( pOfficeLock_Impl )
	{
		pOfficeLock_Impl->Close();
		SfxContentHelper::Kill( pOfficeLock_Impl->GetFileName() );
		delete pOfficeLock_Impl;
	}

	if( xPalmPilotManagerBroker.is() )
		xPalmPilotManagerBroker->stopAccepting();
	if( xServiceManagerBroker.is() )
		xServiceManagerBroker->stopAccepting();

	if( pAcceptor )
	{
		pAcceptor->stopAccepting();
		delete pAcceptor;
	}

	UCB_Helper::Deinitialize();
}

//--------------------------------------------------------------------
extern void FATToVFat_Impl( String& );

void SfxApplicationClass::AppEvent
(
	const ApplicationEvent&     rAppEvent   // zu dispatchendes Event
)

/*  [Beschreibung]

	StarView-Handler zum Ausfuehrend eines AppEvents.

	Der SFx verarbeitet die Events OPEN, PRINT und APPEAR. Wird diese
	Methode ueberladen, mu"s die Basisimplementierung gerufen werden.
*/

{
//#define APPEVENT_DBG
#ifdef APPEVENT_DBG
	SvFileStream aStream("c:\\open.log",STREAM_STD_READWRITE);
	aStream.Seek(STREAM_SEEK_TO_END);
	aStream << "AppEvent: \n";
#endif

//    if ( Application::IsInModalMode() )
//        return;

	SfxApplication* pApp = SFX_APP();
    if ( pApp )
		SFX_APP()->HandleAppEvent( rAppEvent );
}

void SfxApplicationClass::FocusChanged()
{
    SfxApplication* pApp = SFX_APP();
    if ( pApp )
        pApp->FocusChanged();
}

sal_uInt16 SfxApplicationClass::Exception( sal_uInt16 nError )

/*  [Beschreibung]

	Starview ::com::sun::star::uno::Exception-Handler; er behandelt:
	- Resource nicht gefunden
	- Systemobjekt konnte nicht erzeugt werden

	Sollte eigentlich beide nicht auftreten; erhalten hierdurch
	auch im Produkt eine entsprechende Fehlermeldung.
*/
{
#if 0
	// Lock-Datei freigeben
	if ( pOfficeLock_Impl )
	{
		pOfficeLock_Impl->Close();
		// nicht loeschen um Problem deutlich zu machen
		DELETEZ(pOfficeLock_Impl);
	}
#endif

    sal_uInt16 nOldMode = Application::GetSystemWindowMode();
	Application::SetSystemWindowMode( nOldMode & ~SYSTEMWINDOW_MODE_NOAUTOMODE );
	SfxApplication* pApp = SFX_APP();
    if ( pApp )
        pApp->Exception( nError );
	return Application::Exception( nError );
}

void SfxApplicationClass::ShowStatusText( const String& rText )
{
    SfxApplication* pApp = SFX_APP();
    if ( pApp )
    {
        SfxViewFrame *pViewFrame = pApp->GetViewFrame();
        if ( Help::IsExtHelpActive() )
        {
            String aText( SfxResId(STR_EXTHELPSTATUS) );
            if ( pViewFrame )
                pViewFrame->ShowStatusText(aText);
        }
        else
        {
            if ( pViewFrame )
                pViewFrame->ShowStatusText(rText);
        }
    }
}

//------------------------------------------------------------------------

void SfxApplicationClass::HideStatusText()
{
    SfxApplication* pApp = SFX_APP();
    if ( pApp )
    {
        SfxViewFrame *pViewFrame = pApp->GetViewFrame();
        if ( !Help::IsExtHelpActive() )
        {
            if ( pViewFrame )
                pViewFrame->HideStatusText();
        }
    }
}


