/*************************************************************************
 *
 *  $RCSfile: loadenv.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVSTOR_HXX //autogen
#include <so3/svstor.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SBX_SBXOBJECT_HXX //autogen
#include <svtools/sbxbase.hxx>
#endif
#ifndef _SFXINIMGR_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXECODE_HXX
#include <svtools/sfxecode.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#include <svtools/ehdl.hxx>
#include <com/sun/star/uno/Reference.h>
#include <com/sun/star/ucb/XContent.hpp>
#include <rtl/ustring>

#pragma hdrstop

#include "doctempl.hxx"
#include "loadenv.hxx"
#include "docfile.hxx"
#include "objitem.hxx"
#include "request.hxx"
#include "objshimp.hxx"
#include "docfilt.hxx"
#include "openflag.hxx"
#include "docinf.hxx"
#include "fcontnr.hxx"
#include "fltfnc.hxx"
#include "picklist.hxx"
#include "dispatch.hxx"
#include "frmdescr.hxx"
#include "fsetvwsh.hxx"
#include "dataurl.hxx"
#include "appdata.hxx"
#include "topfrm.hxx"
#include "ucbhelp.hxx"
#include "docfac.hxx"
#include "sfxresid.hxx"
#include "app.hrc"

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::ucb;
using namespace ::rtl;

//========================================================================

// diese Funktionen sind in appopen.cxx definiert

extern void SetTemplate_Impl( SvStorage*, const String&, const String&, SfxObjectShell* );
extern sal_uInt32 CheckPasswd_Impl( Window*, SfxItemPool&, SfxMedium* );

// class SfxLoadEnvironment ----------------------------------------------

SfxLoadEnvironment::SfxLoadEnvironment( LoadEnvironment_Impl* pImpl )
	: _pImpl( pImpl )
{
	pImpl->AddRef();
}

SfxLoadEnvironment::~SfxLoadEnvironment()
{
	_pImpl->ReleaseRef();
}

ErrCode SfxLoadEnvironment::DocumentDetected( SfxObjectShell* pObjSh, ErrCode nErr )
{
	return _pImpl->DocumentDetected( pObjSh, nErr );
}

void SfxLoadEnvironment::SetDataAvailableLink( const Link& rLink )
{
	_pImpl->SetDataAvailableLink(  rLink );
}

class SfxLoadCancellable : public SfxCancellable
{
	SfxFrameWeak    wFrame;
public:
					SfxLoadCancellable( SfxFrame* pFrameP, SfxMedium* pMedium )
						: wFrame( pFrameP ),
		  				SfxCancellable( pMedium->GetCancelManager_Impl(), pMedium->GetURLObject().GetURLNoPass() )
					{}
	virtual void	Cancel();
};

void SfxLoadCancellable::Cancel()
{
	SfxCancellable::Cancel();
	// Damit wir beim loeschen des Frames nicht an den
	// AppCancelManager wandern
	SetManager( 0 );
	if( wFrame.Is() )
		wFrame->CancelTransfers();
}

LoadEnvironment_Impl::~LoadEnvironment_Impl()
{
	aDecoupleLink.ClearPendingCall();

	if ( aDoneLink.IsSet() )
	{
		SfxPoolItem* pRet;
		if( !IsPlugin() && pFrame )
			pRet = new SfxViewFrameItem( 0, &xDoc ? pFrame->GetCurrentViewFrame() : 0);
		else
			pRet = new SfxObjectShellItem( 0, xDoc );

		aDoneLink.Call( pRet );
		delete pRet;
	}

	if( pMedium )
	{
		Link aLink;
		if( pMedium->GetDataAvailableLink() ==
			LINK( this, LoadEnvironment_Impl, LoadDataAvailable_Impl ) )
			pMedium->SetDataAvailableLink( aLink );
		if( pMedium->GetDoneLink() ==
			LINK( this, LoadEnvironment_Impl, LoadDataAvailable_Impl ) )
			pMedium->SetDoneLink( aLink );
		SFX_ITEMSET_ARG( pMedium->GetItemSet(), pIsChildLoad,
						 SfxBoolItem, SID_ISCHILDFRAMELOAD, sal_False );
		if ( pFrame && pIsChildLoad && pIsChildLoad->GetValue() )
			pFrame->LoadFinished_Impl();

		if ( pFrame &&
			 ( !pFrame->GetCurrentDocument() ||
			 pFrame->GetCurrentDocument() == &xDoc && pFrame->GetCurrentDocument()->GetMedium() != pMedium ) )
//		if ( pFrame && pFrame->GetCurrentDocument() && pFrame->GetCurrentDocument()->GetMedium() != pMedium &&
//			 pFrame->GetCurrentDocument() == &xDoc )
			DELETEZ( pMedium );
	}

	if( pFrame && pFrame->GetLoadEnvironment_Impl() == this )
		pFrame->SetLoadEnvironment_Impl( 0 );
	if( pFrame && (
		!xDoc.Is() || xDoc->Get_Impl()->nLoadedFlags == SFX_LOADED_ALL ) )
		pFrame->SetLoadCancelable_Impl( 0 );
	if( bOwnsFrame && pFrame )
		pFrame->DoClose();
}

LoadEnvironment_Impl* LoadEnvironment_Impl::Create( const SfxItemSet& rConstSet, BOOL bAllowRO )
{
    // File-Flags
    SfxAllItemSet *pArgs = new SfxAllItemSet( rConstSet );

    SFX_ITEMSET_ARG(pArgs, pFileFlagsItem, SfxStringItem, SID_OPTIONS, FALSE);
    if ( pFileFlagsItem )
    {
        // Werte auf einzelne Items verteilen
        String aFileFlags = pFileFlagsItem->GetValue();
        aFileFlags.ToUpperAscii();
        if ( STRING_NOTFOUND != aFileFlags.Search( 0x0054 ) )               // T = 54h
            pArgs->Put( SfxBoolItem( SID_TEMPLATE, TRUE ) );
        if ( STRING_NOTFOUND != aFileFlags.Search( 0x0048 ) )               // H = 48h
            pArgs->Put( SfxBoolItem( SID_HIDDEN, TRUE ) );
        if ( STRING_NOTFOUND != aFileFlags.Search( 0x0052 ) )               // R = 52h
            pArgs->Put( SfxBoolItem( SID_DOC_READONLY, TRUE ) );
        if ( STRING_NOTFOUND != aFileFlags.Search( 0x0042 ) )               // B = 42h
            pArgs->Put( SfxBoolItem( SID_PREVIEW, TRUE ) );
        if ( STRING_NOTFOUND != aFileFlags.Search( 0x0053 ) )               // S = 53h
            pArgs->Put( SfxBoolItem( SID_SILENT, TRUE ) );
    }

    // File Name ermitteln
    String aDocFileName;
    String aErrCtxName;

    // Template "offnen?
    BOOL bTemplate = FALSE;
    SFX_ITEMSET_ARG(pArgs, pTemplRegItem, SfxStringItem, SID_TEMPLATE_REGIONNAME, FALSE);
    SFX_ITEMSET_ARG(pArgs, pTemplNamItem, SfxStringItem, SID_TEMPLATE_NAME, FALSE);
    if( pTemplRegItem || pTemplNamItem )
    {
        // Template-Region
        String aTemplateRegion;
        if ( pTemplRegItem )
            aTemplateRegion = pTemplRegItem->GetValue();

        // Template-Name
        String aTemplateName;
        if ( pTemplNamItem )
        {
            aTemplateName = pTemplNamItem->GetValue();
            pArgs->Put( SfxStringItem( SID_FILE_LONGNAME, aTemplateName ) );
        }

        // File Name aus Region/TemplateName holen
        SfxDocumentTemplates aTemplates;
        aTemplates.Construct();
        if ( !aTemplates.GetFull( aTemplateRegion, aTemplateName, aDocFileName) )
        {
            aErrCtxName = aTemplateRegion;
            aErrCtxName += String::CreateFromAscii(" / ");
            aErrCtxName += aTemplateName;
        }
        else
		{
            aErrCtxName = aDocFileName;
            bTemplate = TRUE;
		}
    }
    else
    {
        // File-Name
        SFX_ITEMSET_ARG(pArgs, pFileNameItem, SfxStringItem, SID_FILE_NAME, FALSE);
        DBG_ASSERT( pFileNameItem, "FileName-Arg missing" );

		String aFileURL = pFileNameItem->GetValue();
		aErrCtxName = aDocFileName = aFileURL;
    }

	// optional original-URL( z.B. bei Salvage )
    SFX_ITEMSET_ARG(pArgs, pUrlItem, SfxStringItem, SID_ORIGURL, FALSE );
	if ( pUrlItem )
	{
		// Mark von original-URL an aDocFileName anh"angen
		INetURLObject aURL;
		aURL.SetSmartProtocol( INET_PROT_FILE );
		aURL.SetSmartURL( aDocFileName );
		aDocFileName = aURL.GetMainURL();
		String aMark = INetURLObject( pUrlItem->GetValue() ).GetMark();
		if( aMark.Len() )
		{
			aDocFileName += '#';
			aDocFileName += aMark;
		}
	}

    String aFileName = aDocFileName;
	SfxViewFrame* pCurViewFrame = SfxViewFrame::Current();

    SFX_ITEMSET_ARG(pArgs, pFrmItem, SfxFrameItem, SID_DOCFRAME, FALSE);
	SfxObjectShell *pCur = 0;
	if( pFrmItem )
        pCur = pFrmItem->GetFrame() ? pFrmItem->GetFrame()->GetCurrentDocument() : 0;
	if( !pCur )
		pCur = SfxObjectShell::Current();

    // Es kommen hier entweder Marks ohne URL oder absolute URLS rein.
    // SmartRelToAbs erlaubt ausserdem z.B. ueber Basic existente
    // Pfadnamen..

	// Marks ohne URLs duerfen sich nur auf das Target beziehen.
	INetURLObject aObj;
    String aMark;
    if( aFileName.Len() && aFileName.GetChar(0) == '#' && pCur ) // Mark ohne URL
    {
        aMark = aFileName.Copy(1);
		if( pCur->HasName())
		{
			aObj.SetURL(  pCur->GetMedium()->GetName() );
			aObj.SetMark( aMark );
		}
		else
		{
			String aURL = String::CreateFromAscii( "private:local#" );
			aURL += aMark;
			aObj.SetURL( aURL );
		}
		aErrCtxName  = aObj.GetURLNoMark();
		aErrCtxName += aFileName;
    }
    else
    {
        aObj.SetURL( aFileName );
        aMark = aObj.GetMark();
    }

    // ErrorContext aufziehen
    SfxErrorContext aEc( ERRCTX_SFX_OPENDOC, aErrCtxName );

    // optional filter name
    String aFilterName;
    SFX_ITEMSET_ARG(pArgs, pFilterItem, SfxStringItem, SID_FILTER_NAME, FALSE );
    if ( pFilterItem )
        aFilterName = pFilterItem->GetValue();

    // Hidden-Item
    BOOL bHidden = FALSE;
    SFX_ITEMSET_ARG(pArgs, pHidItem, SfxBoolItem, SID_HIDDEN, FALSE);
    if ( pHidItem )
        bHidden = pHidItem->GetValue();

    // optional dont-touch-history-flag
    BOOL bAddToHistory = TRUE;
    SFX_ITEMSET_ARG(pArgs, pBrowsingItem, SfxBoolItem, SID_BROWSING, FALSE );
	USHORT nMode = BROWSE_NORMAL;
    if ( pBrowsingItem )
    {
        bAddToHistory = pBrowsingItem->GetValue();
        if ( SFX_APP()->GetIniManager()->Get(SFX_KEY_BROWSEREADONLY).CompareToAscii("1") == COMPARE_EQUAL )
            pArgs->Put( SfxBoolItem( SID_DOC_READONLY, TRUE ) );
		if( !bAddToHistory ) nMode = NO_BROWSE;
    }

    SFX_ITEMSET_ARG(pArgs, pBrowseMode, SfxUInt16Item, SID_BROWSEMODE, FALSE );
    if ( !pBrowseMode )
        pArgs->Put( SfxUInt16Item( SID_BROWSEMODE, nMode ) );

    // optional read-only-flag
    BOOL bReadOnly = FALSE;
    SFX_ITEMSET_ARG(pArgs, pReadOnlyItem, SfxBoolItem, SID_DOC_READONLY, FALSE );
    if ( pReadOnlyItem && pReadOnlyItem->GetValue() )
        bReadOnly = TRUE;

	// mailto:-URL per http-post?
    SFX_ITEMSET_ARG(pArgs, pPostItem, SfxStringItem, SID_POSTSTRING, FALSE );
    SFX_ITEMSET_ARG(pArgs, pSendItem, SfxBoolItem, SID_MAIL_SEND, FALSE );
	if ( ( !pSendItem || pSendItem->GetValue() ) && INET_PROT_MAILTO == aObj.GetProtocol() && pPostItem )
	{
		WarningBox aBox( 0, SfxResId( RID_WARN_POST_MAILTO ) );
		if ( RET_CANCEL == aBox.Execute() )
        {
            delete pArgs;
            return 0;;
        }
	}

	if( pFrmItem && pFrmItem->FrameKilled() )
	{
		DBG_ERROR( "FrameHack schlaegt zu!" );
        delete pArgs;
        return 0;;
	}

    const SfxFilter* pFilter = 0;
	if ( aFilterName.Len() )
        pFilter = SFX_APP()->GetFilterMatcher().GetFilter(aFilterName);

    SfxMedium* pFile = new SfxMedium( aFileName, bReadOnly ? SFX_STREAM_READONLY : SFX_STREAM_READWRITE, FALSE, TRUE, pFilter, pArgs );
	if ( pUrlItem )
	{
		pFile->SetName( pUrlItem->GetValue(), TRUE );
		pFile->SetTemporary( TRUE );
	}

	// Soll evtl. keine View erzeugt werden ?
	BOOL bCreateView = TRUE;
    SFX_ITEMSET_ARG(pArgs, pCreateViewItem, SfxBoolItem, SID_VIEW, FALSE );
	if ( pCreateViewItem && !pCreateViewItem->GetValue() )
		bCreateView = FALSE;

	USHORT nToDo = LEI_DETECTFILTER |  LEI_LOAD;
	if ( bCreateView )
		nToDo |= LEI_CREATEVIEW;

    BOOL bUseCache = TRUE;
    SFX_ITEMSET_ARG(pArgs, pForceReloadItem, SfxBoolItem, SID_NOCACHE, FALSE );
	if ( pForceReloadItem && pForceReloadItem->GetValue() )
	{
        bUseCache = sal_False;
        pFile->SetUsesCache( FALSE );
	}

    SFX_ITEMSET_ARG(pArgs, pFrameItem, SfxFrameItem, SID_DOCFRAME, FALSE );
    LoadEnvironment_Impl* pLoader = new LoadEnvironment_Impl( pFile, pFrameItem ? pFrameItem->GetFrame() : NULL, nToDo, bAllowRO, bUseCache );
    if ( bTemplate )
        pLoader->pMedium->GetItemSet()->Put( SfxBoolItem( SID_TEMPLATE, TRUE ) );
    pLoader->SetMark( aMark );
    return pLoader;
}


LoadEnvironment_Impl::LoadEnvironment_Impl( SfxMedium* pMed, SfxFrame* pFrameP, sal_uInt32 eTodoP, sal_Bool bAllowReadOnlyP, sal_Bool bAllowCache )
	: pMedium( pMed )
    , pFrame( pFrameP )
    , bOpenTemplate( sal_False )
    , bNewView( sal_False )
    , bSalvage( sal_False )
    , bReadOnly( sal_False )
    , bAllowReadOnly( bAllowReadOnlyP )
    , bUseCache( bAllowCache )
	, nTodo( eTodoP )
	, bHidden( sal_False )
	, nError( 0 )
	, bDocCreated( sal_False )
	, nStartEvent( 0 )
    , bLocal( sal_False )
	, bIsApi( sal_False )
	, bTemplate( sal_False )
	, bPlugIn( sal_False )
	, pNewFrame( 0 )
	, bUsableForLocal( sal_False )
    , bOwnsFrame( sal_False )
	, pAntiImpl( 0 )
	, aDecoupleLink( LINK( this, LoadEnvironment_Impl, LoadDataAvailable_Impl ) )
	, pMatcher( &SFX_APP()->GetFilterMatcher() )
	, bWaitingForFilterDetection( sal_False )
	, bProcessing( sal_False )
{
    SFX_ITEMSET_ARG(pMed->GetItemSet(), pNewViewItem, SfxBoolItem, SID_OPEN_NEW_VIEW, FALSE );
    if ( pNewViewItem )
        bNewView = pNewViewItem->GetValue();

    SFX_ITEMSET_ARG(pMed->GetItemSet(), pTemplItem, SfxBoolItem, SID_TEMPLATE, FALSE );
    if ( pTemplItem )
        bOpenTemplate = pTemplItem->GetValue();

	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pSalvageItem, SfxStringItem, SID_DOC_SALVAGE, sal_False );
    if ( pSalvageItem )
        bSalvage = sal_True;

	SFX_ITEMSET_ARG(pMed->GetItemSet(), pReadOnlyItem, SfxBoolItem, SID_DOC_READONLY, sal_False);
	if ( pReadOnlyItem )
		bReadOnly = pReadOnlyItem->GetValue();

	SFX_ITEMSET_ARG(pMed->GetItemSet(), pHidItem, SfxBoolItem, SID_HIDDEN, sal_False);
	if ( pHidItem )
		bHidden = pHidItem->GetValue();

	SFX_ITEMSET_ARG( pMed->GetItemSet(), pOwnsItem, SfxBoolItem, SID_OWNS_FRAME, sal_False );
	if ( pOwnsItem )
	{
    	bOwnsFrame = pOwnsItem->GetValue();
    	pMed->GetItemSet()->ClearItem( SID_OWNS_FRAME );
	}

	if( pFrame )
		StartListening( pFrame->GetBroadcaster() );

	pMed->SetTransferPriority( SFX_TFPRIO_DOC );
}

void LoadEnvironment_Impl::CancelTransfers()
{
	// Im CancelTransfers am Medium wird die Ref xThis weggenommen
	SvRefBaseRef xRef( this );
	if( xDoc.Is()  )
	{
		// Falls im DetectFilter gecancelled wurde, gibt es noch kein Medium
		if( !xDoc->GetMedium() )
			xDoc.Clear();
		else xDoc->CancelTransfers();
	}
	else if( pMedium )
	{
		pMedium->CancelTransfers();
	}

	nError = ERRCODE_ABORT;

	// aktiv abbrechen, da vielleicht keine Daten mehr kommen
	if( xOldEnv.Is() )
		xOldEnv->CancelTransfers();
    if ( bProcessing )
    {
        aDecoupleLink.ClearPendingCall();
        aDecoupleLink.Call( this, sal_False, sal_True );
    }
    else
        LoadDataAvailable_Impl( 0 );
}

sal_Bool UsableForOpen_Impl( SfxObjectShell* pShell, SfxMedium* pMedium  )
{
	if( !pShell )
		return sal_False;

	SfxItemSet* pSet = pMedium->GetItemSet();

	SFX_ITEMSET_ARG( pSet, pTemplateItem, SfxBoolItem, SID_TEMPLATE, sal_False );
	if( pTemplateItem && pTemplateItem->GetValue() )
		return sal_False;

	SfxMedium* pOld = pShell->GetMedium();

	// Dies ist der Filename, falls nur ein Mark im Opendoc mitkam
	String aLocal( DEFINE_CONST_UNICODE("private:local#") );

	// Falls URLs nicht uebereinstimmen und der zu oeffnende Name nicht #xxx
	// ist, nicht verwenden
	if( INetURLObject( pOld->GetOrigURL()) !=
		INetURLObject( pMedium->GetOrigURL() ) && pMedium->GetOrigURL().CompareIgnoreCaseToAscii( aLocal, aLocal.Len() ) != COMPARE_EQUAL )
		return sal_False;

	const INetURLObject& rURL = pMedium->GetURLObject();

	// Falls die Filter nicht uebereinstimmen oder eine ViewId mitgegeben
	// wurde, nicht verwenden
	if( pMedium->GetFilter() &&	pOld->GetOrigFilter() != pMedium->GetFilter() )
		return sal_False;

	// Falls die Poststrings nicht uebereinstimmen nicht verwenden
	SfxItemSet* pOldSet = pOld->GetItemSet();
	SFX_ITEMSET_ARG( pSet, pPostItem, SfxStringItem, SID_POSTSTRING, sal_False );
	SFX_ITEMSET_ARG( pSet, pPost2Item, SfxRefItem, SID_POSTLOCKBYTES, sal_False );
	SFX_ITEMSET_ARG( pOldSet, pOldPostItem, SfxStringItem, SID_POSTSTRING, sal_False );
	SFX_ITEMSET_ARG( pOldSet, pOldPost2Item, SfxRefItem, SID_POSTLOCKBYTES, sal_False );
/*
	if( pPost2Item || pOldPost2Item ||
		( pPostItem && pOldPostItem &&
		  pOldPostItem->GetValue() != pPostItem->GetValue() ||
		  !pPostItem && pOldPostItem || pPostItem && !pOldPostItem ) &&
		!pMedium->GetURLObject().GetMark())
		return sal_False;
*/
	if( ( pPost2Item || pOldPost2Item ||
		( pPostItem && pOldPostItem &&
		  pOldPostItem->GetValue() != pPostItem->GetValue() ||
		  !pPostItem && pOldPostItem || pPostItem && !pOldPostItem ) ) &&
		(!pMedium->GetURLObject().GetMark().Len() || pPostItem || pPost2Item ))
		return sal_False;

	return sal_True;
}

sal_Bool UsableForOpen_Impl( SfxFrame* pFrame, SfxMedium* pMedium  )
{
	if( !pFrame )
		return sal_False;

	// View-Id
	SfxItemSet* pSet = pMedium->GetItemSet();
	SFX_ITEMSET_ARG( pSet, pViewIdItem, SfxUInt16Item, SID_VIEW_ID, sal_False );
	if ( pViewIdItem && pFrame->GetCurrentViewFrame() &&
		pViewIdItem->GetValue() != pFrame->GetCurrentViewFrame()->GetCurViewId() )
		return sal_False;
	return UsableForOpen_Impl( pFrame->GetCurrentDocument(), pMedium );
}

sal_Bool UsableForLocalJump_Impl( SfxFrame* pFrame, SfxMedium* pMedium )
{
	if( !pFrame )
		return sal_False;
	return UsableForOpen_Impl( pFrame, pMedium );
}

void LoadEnvironment_Impl::Start()
{
	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pRefererItem, SfxStringItem, SID_REFERER, sal_False );
	if( pRefererItem )
		pMedium->SetReferer( pRefererItem->GetValue() );

	eState = CONNECTING;
	sal_uInt32 nErr = ERRCODE_NONE;

	// Eigene Ref halten
	xThis = this;

	// Wenn wirklich geladen werden soll, muss auf bereits geladene
	// Doks geprueft werden
	if( nTodo & LEI_LOAD )
	{
		// Security-Check
		SFX_ITEMSET_ARG( pMedium->GetItemSet(), pRefererItem, SfxStringItem, SID_REFERER, sal_False );
		DBG_ASSERT( pRefererItem || bIsApi, "SID_OPEN... without referer => macro- and slot-URLs will be denied" );
		const INetURLObject &rURL = pMedium->GetURLObject();
		if ( !SFX_APP()->IsSecureURL( rURL, pRefererItem ? &pRefererItem->GetValue() : 0 ) )
		{
			eState = DONE;
			nErr = ERRCODE_IO_ACCESSDENIED;
			if ( bIsApi )
				SbxBase::SetError( nErr );
			else
				ErrorHandler::HandleError( nErr );
			xThis.Clear();
			return;
		}

		if( aMark.Len() )
			bLocal = sal_True;

		bUsableForLocal = sal_False;

		// Dies ist der Filename, falls nur ein Mark im Opendoc mitkam
		String aLocal( DEFINE_CONST_UNICODE("private:local#") );

		// View-Id
		// Falls ViewId mitkommt, nicht das lokale doc nehmen
		SFX_ITEMSET_ARG( pMedium->GetItemSet(), pViewIdItem, SfxUInt16Item, SID_VIEW_ID, sal_False );

		SfxObjectShell *pCur;
		SfxFrame *pCurFrame;
		if ( !pFrame || !pFrame->GetCurrentDocument() ||
			pFrame->GetCurrentViewFrame()->GetViewShell()->IsImplementedAsFrameset_Impl() )
		{
			// Bei ContainingDocFrames ( Mail... ) ist der TargetFrame immer das
			// Frameset, auch wenn ein local jump im body ausgef"uhrt werden soll
			pCur = SfxObjectShell::Current();
			pCurFrame = pCur ? SfxViewFrame::Current()->GetFrame() : 0;

			// Wenn ein neuer Frame ge"offnet wurde, keinen Local Jump probieren
			if( !bOwnsFrame && bUseCache )
			{
				if (bLocal)
					bUsableForLocal = UsableForLocalJump_Impl( pCurFrame, pMedium );

				if( !bUsableForLocal )
				{
					// Kein lokaler Sprung im aktuellen Document, wir bleiben
					// beim "ubergebenen Frame
					if ( pFrame )
					{
						pCurFrame = pFrame;
						pCur = pFrame->GetCurrentDocument();
					}

					bUsableForLocal = UsableForLocalJump_Impl( pFrame, pMedium );
				}
				else
				{
					// Lokaler Sprung erw"unscht und m"oglich
					pFrame = SfxViewFrame::Current()->GetFrame();
				}
			}
		}
		else
		{
			pCurFrame = pFrame;
			pCur = pFrame->GetCurrentDocument();
			if( !bOwnsFrame && bUseCache )
				bUsableForLocal = UsableForLocalJump_Impl( pFrame, pMedium );
		}

		SFX_ITEMSET_ARG( pMedium->GetItemSet(), pSilentItem, SfxBoolItem, SID_SILENT, sal_False);
		sal_Bool bSilent;
		if( pSilentItem )
			bSilent = pSilentItem->GetValue();
		else
			bSilent = sal_False;

		// bSilent ist fuer Maltes Hilfe
		if( !bUsableForLocal  )
		{
			if( bUseCache )
			{
				//! Hier besser das Itemset reinreichen und drinnen
				//  UsableForLocalJump_Impl usw. fragen
				SFX_ITEMSET_ARG( pMedium->GetItemSet(), pPostItem, SfxStringItem, SID_POSTSTRING, sal_False );
				xDoc = SFX_APP()->DocAlreadyLoaded(
					pMedium->GetName(), bSilent,
					bSilent, !bSilent && !bNewView,
					pPostItem ? &pPostItem->GetValue() : 0 );

				if( UsableForOpen_Impl( xDoc, pMedium ) )
				{
					MemCache_Impl &rCache = SfxPickList_Impl::Get()->GetMemCache();
					if ( xDoc.Is() && rCache.IsObjectCached( xDoc ) )
					{
						DBG_ASSERT( !SfxViewFrame::GetFirst( &xDoc ), "visible object is cached => not allowed" );
						rCache.RemoveObject( &xDoc );
						SfxObjectShell_Impl* pDocImpl = xDoc->Get_Impl();
						pDocImpl->bPreparedForClose = sal_False;
						pDocImpl->bClosing = sal_False;
						SfxDocumentInfo &rInfo = xDoc->GetDocInfo();
						xDoc->SetAutoLoad(
							rInfo.GetReloadURL(),
							rInfo.GetReloadDelay() * 1000,
							rInfo.IsReloadEnabled() );
					}
				}
				else
					xDoc.Clear();
			}
		}
		else
		{
			if ( pCurFrame )
			{
				SFX_ITEMSET_ARG( pMedium->GetItemSet(), pDescrItem, SfxFrameDescriptorItem, SID_FRAMEDESCRIPTOR, sal_False);
				SfxFrameSetDescriptor *pSet = pCurFrame->GetDescriptor()->GetFrameSet();
				if ( pDescrItem || !pSet || !pSet->CheckContent() )
					xDoc = pCur;
			}
			else
				xDoc = pCur;
		}

		if( xDoc.Is() )
		{
			SfxMedium* pDocMed = xDoc->GetMedium();
			pMedium->SetFilter( pDocMed->GetFilter() );
			pDocMed->SetName( pMedium->GetName() );
//            pDocMed->GetItemSet()->ClearItem();
			pDocMed->GetItemSet()->Put( *pMedium->GetItemSet() );
            if( pDocMed->GetContent().is() )
                UCB_Helper::ExecuteCommand( pDocMed->GetContent(), WID_UPDATE );
		}
	}

	if( xDoc.Is() )
	{
		xDoc->Get_Impl()->bIsAbortingImport = sal_False;
		nTodo &= (~( LEI_DETECTFILTER | LEI_LOAD ) );
	}

	// Existiert die Datei lokal?
	if( !xDoc.Is() )
	{
		// CHAOS View or Help-Dir-Entry (to redirect)?
		const INetURLObject& rObj = pMedium->GetURLObject();
		String aStr( rObj.GetMainURL() );

		if ( SfxIsHelpEntryURL( aStr, 0x002A ) ) // '*' = 2Ah
		{
			pMedium->SetOpenMode( SFX_STREAM_READONLY, sal_True );
			nErr = ERRCODE_NONE;
		}
        else
        {
	       	Reference < XContent > xContent( pMedium->GetContent() );
	        OUString aTarget;
			if( xContent.is() )
			{
   	        	Any aAny( UCB_Helper::GetProperty( xContent, WID_FLAG_IS_FOLDER ) );
        	    Any aNotherAny( UCB_Helper::GetProperty( xContent, WID_TARGET_URL ) );
	            BOOL bIsFolder = FALSE;
	            if ( ( aAny >>= bIsFolder ) && bIsFolder ||
	                 ( aNotherAny >>= aTarget ) && aTarget.len() ||
	                 rObj.GetProtocol() == INET_PROT_FILE && aStr.Search('{') != STRING_NOTFOUND )
    	        {
        	        // CHAOS macht alles selbst...
            	    nErr = ERRCODE_NONE;
	            }
    	        else
        	       nErr	 = pMedium->CheckOpenMode_Impl( bPlugIn, bAllowReadOnly );
			}
		}

		if( nErr )
		{
			eState = DONE;
			if( nErr != ERRCODE_ABORT )
			{
                if ( bAllowReadOnly )
				{
					if( bIsApi )
						SbxBase::SetError( nErr );
					else
						ErrorHandler::HandleError( nErr );
				}

				// bereit zum Loeschen
				xThis.Clear();
				nError = nErr;
				if ( aDoneLink.IsSet() )
				{
					aDoneLink.Call( NULL );
					aDoneLink = Link();
				}
				return;
		   }
		}
		if( pFrame )
		{
			if( pFrame->GetLoadEnvironment_Impl() != this )
			{
				xOldEnv = pFrame->GetLoadEnvironment_Impl();
				// Der neue Frame gehoert jetzt dem neuen Ladevorgang
				if( xOldEnv.Is() )
				{
					bOwnsFrame = xOldEnv->bOwnsFrame;
					xOldEnv->bOwnsFrame = sal_False;
				}

				pFrame->SetLoadEnvironment_Impl( this );
			}
			pMedium->SetLoadTargetFrame( pFrame );
			pFrame->SetLoadCancelable_Impl(
				new SfxLoadCancellable(	pFrame, pMedium ) );
		}
	}

	sal_Bool bProvidesData = pMedium->ProvidesData_Impl();
	if( bProvidesData && ( nTodo & (LEI_LOAD | LEI_DETECTFILTER ) ) )
	{
		Link aLink = LINK( this, LoadEnvironment_Impl, LoadDataAvailable_Impl );
		pMedium->SetDataAvailableLink( aLink );
		pMedium->SetDoneLink( aLink );
	}

	// Fuer diese Protokolle muss hier gecanceled werden, da
	// Connections knapp sind.
	INetProtocol eProt = pMedium->GetURLObject().GetProtocol();
	if( pFrame && ( eProt == INET_PROT_HTTP || eProt == INET_PROT_HTTPS ) && !bUsableForLocal )
	{
		pFrame->CancelTransfers( sal_False );
		if( xOldEnv.Is() )
		{
			xOldEnv->CancelTransfers();
			xOldEnv.Clear();
		}
	}

	LoadDataAvailable_Impl( 0 );
}

void LoadEnvironment_Impl::ConvertToTemplate()
{
	if ( GetMedium()->GetURLObject().GetProtocol() == INET_PROT_COMPONENT )
		return;

	// Template-Name
	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pTemplNamItem, SfxStringItem, SID_TEMPLATE_NAME, sal_False);
	String aTemplateName;
	if ( pTemplNamItem )
		aTemplateName = pTemplNamItem->GetValue();
	else
		// Interaktiv ( DClick, Contextmenu ) kommt kein Langname mit
		aTemplateName = xDoc->GetDocInfo().GetTitle();

	String aName = pMedium->GetName();
	pMedium->SetName( String(), sal_True );
	pMedium->Init_Impl();

	if( GetMedium()->GetFilter()->IsOwnFormat() )
	{
		SvStorageRef xTmpStor = new SvStorage( String() );
		xDoc->GetStorage()->CopyTo( &xTmpStor );
		xDoc->DoHandsOff();
		pMedium->SetStorage_Impl( xTmpStor );
		xDoc->ForgetMedium();
		if( !xDoc->DoSaveCompleted( pMedium ) )
			nError = xTmpStor->GetErrorCode();
        else if ( !bSalvage )
			SetTemplate_Impl( xTmpStor, aName, aTemplateName, xDoc );
	}
	else
	{
		SetTemplate_Impl( xDoc->GetStorage(), aName, aTemplateName, xDoc);
	}

	pMedium->GetItemSet()->ClearItem( SID_DOC_READONLY );
	pMedium->SetOpenMode( SFX_STREAM_READWRITE, sal_True, sal_True );
	xDoc->Broadcast( SfxSimpleHint(SFX_HINT_MODECHANGED) );
	xDoc->Broadcast( SfxDocumentInfoHint( &xDoc->GetDocInfo() ) );
	xDoc->SetNoName();
	xDoc->InvalidateName();
	xDoc->SetModified( sal_False );
}


void LoadEnvironment_Impl::DetectFilter()
{
	SfxApplication* pApp = SFX_APP();
	const SfxFilter* pFilter=0;
	ErrCode nErr = pMatcher->DetectFilter( *pMedium, &pFilter, bPlugIn, bIsApi );
	nError = nErr;
	if ( nErr == ERRCODE_NONE || nErr == ERRCODE_IO_PENDING )
	{
		pMedium->SetFilter( pFilter );
		if( !pMedium->GetOrigFilter( sal_True ) )
			pMedium->SetOrigFilter_Impl( pFilter );
	}

	return;
}

void LoadEnvironment_Impl::Execute()
{
	const SfxFilter* pFilt = pMedium->GetFilter();
	sal_uInt32 nErr = pMedium->GetFilter()->GetFilterContainer()->Execute( *pMedium, pFrame );
	if( nErr )
	{
		if ( pFrame && pFrame->GetCurrentDocument() )
			bOwnsFrame = sal_False;

        if ( nError == ERRCODE_NONE )
            nError = nErr;
        if ( nError == ERRCODE_SFX_RESTART )
		{
			// Der TargetFrame k"onnte sich ge"andert haben
			sal_Bool bOwns;
			SfxFrame *pNewFrame = SFX_APP()->GetTargetFrame_Impl( pMedium->GetItemSet(), bOwns );
			if ( pNewFrame != pFrame )
			{
				if( pFrame->GetLoadEnvironment_Impl() == this )
					pFrame->SetLoadEnvironment_Impl( 0 );
				pFrame->SetLoadCancelable_Impl( 0 );

				if ( bOwnsFrame )
				{
					aDoneLink.Call(NULL);
					aDoneLink = Link();
					pFrame->DoClose();
				}

				pFrame = pNewFrame;
				bOwnsFrame = bOwns;

				xOldEnv = pFrame->GetLoadEnvironment_Impl();

				// Der neue Frame gehoert jetzt dem neuen Ladevorgang
				if( xOldEnv.Is() )
				{
					bOwnsFrame = xOldEnv->bOwnsFrame;
					xOldEnv->bOwnsFrame = sal_False;
				}

				pFrame->SetLoadEnvironment_Impl( this );
				pMedium->SetLoadTargetFrame( pFrame );
				pFrame->SetLoadCancelable_Impl( new SfxLoadCancellable(	pFrame, pMedium ) );

				if( xOldEnv.Is() )
				{
					xOldEnv->CancelTransfers();
					xOldEnv.Clear();
				}

				nError = ERRCODE_SFX_RESTART;
			}
		}
        else if ( nError != ERRCODE_IO_PENDING )
		{
			nTodo &= ~LEI_CREATEVIEW;
		}

        const SfxPoolItem *pRet = pMedium->GetItemSet()->GetItem(SID_OPENURL);
		if ( pRet && pRet->ISA(SfxObjectItem) )
		{
            xDoc = (SfxObjectShell*) ((SfxObjectItem*)pRet)->GetShell();
			pMedium->GetItemSet()->ClearItem(SID_OPENURL);
		}
        else if ( pRet && pRet->ISA(SfxFrameItem) )
		{
            xDoc = ((SfxFrameItem*)pRet)->GetFrame()->GetCurrentDocument();
			pMedium->GetItemSet()->ClearItem(SID_OPENURL);
		}
	}
}


void LoadEnvironment_Impl::Load( const SfxObjectFactory *pFactory )
{
	const SfxFilter*pFilter = pMedium->GetFilter();
	if( pFilter && pFilter->GetFilterFlags() & SFX_FILTER_PLUGIN )
		pMedium->CreateDataSource();

	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pTemplateItem, SfxBoolItem, SID_TEMPLATE, sal_False);
    bTemplate = pTemplateItem && pTemplateItem->GetValue();
				// MI: z.B. private:calendar/
//				( !pMedium->GetFilter() ||
//				  pMedium->GetFilter()->IsAllowedAsTemplate() );

	SFX_ITEMSET_ARG(pMedium->GetItemSet(), pReadOnlyItem, SfxBoolItem, SID_DOC_READONLY, sal_False);
	const INetURLObject &rURL = pMedium->GetURLObject();
    if( ( bReadOnly || !pReadOnlyItem ) &&  // readonly prinzipiell erlaubt
        ( pFilter && ( pFilter->GetFilterFlags() & SFX_FILTER_OPENREADONLY ) )  // readonly n"otig / sinnvoll
        && !bTemplate )                 // nichts als Vorlage "offnen
	{
		bReadOnly = sal_True;
		if( pMedium->GetOpenMode() == SFX_STREAM_READWRITE )
			pMedium->SetOpenMode( SFX_STREAM_READONLY, sal_False, sal_True );
	}

	if( pFactory )
	{
		xDoc = pFactory->CreateObject();
		// Flags uebernehmen fuer Reload des Desktops
		SFX_ITEMSET_ARG( pMedium->GetItemSet(), pFlagItem, SfxUInt32Item, SID_FLAGS, sal_False );
		if( pFlagItem )
			xDoc->SetFlags( xDoc->GetFlags() | pFlagItem->GetValue() );
	}

	if ( !nError && xDoc.Is() )
	{
		if ( pFrame  )
		{
			xDoc->SetActualSize( pFrame->GetWindow().GetOutputSizePixel() );
			xDoc->SetInFrame( pFrame->GetParentFrame() != NULL );
		}

		// beim ersten Activate ein Open-Event verschicken
		//! pPsh nur wg. Absturz im Writer
		bDocCreated = sal_True;
		sal_Bool bAddToHistory = sal_False;
		SFX_ITEMSET_ARG(pMedium->GetItemSet(), pBrowsingItem, SfxBoolItem, SID_BROWSING, sal_False );
		if ( pBrowsingItem )
			bAddToHistory = pBrowsingItem->GetValue();
		if ( !bOpenTemplate )
			xDoc->SetActivateEvent_Impl( bTemplate ?  SFX_EVENT_CREATEDOC : SFX_EVENT_OPENDOC, bAddToHistory );

		// SFX_GETITEM(*pFile->GetItemSet(), SfxBoolItem, SID_LOAD_LAYOUT, sal_False);
		const SfxPoolItem *pItem;
        SfxItemState eItemState = pMedium->GetItemSet()? pMedium->GetItemSet()->GetItemState( SID_LOAD_LAYOUT, sal_True, &pItem): SFX_ITEM_UNKNOWN;
        if (SFX_ITEM_SET == eItemState)
		{
			DBG_ASSERT(pItem->IsA( TYPE(SfxBoolItem) ), "Fehler Parametertype");
			xDoc->SetLoadLayout_Impl( ((const SfxBoolItem *)pItem)->GetValue() );
		}
		sal_Bool bQueryLoadTemplate = sal_False;
		if( !bIsApi && !bHidden )
			bQueryLoadTemplate = sal_True;
		// Passwort?

		if( !(pMedium->GetFilter()->GetFilterFlags() & SFX_FILTER_CREATOR ))
		{
			// SuperDocChangerMode fuer html docs
			if( pFilter->GetFilterName() == DEFINE_CONST_UNICODE("HTML") ||
				pFilter->GetFilterName() == DEFINE_CONST_UNICODE("HTML (StarWriter)") )
			{
				pAntiImpl = new SfxLoadEnvironment( this );
				SfxRefItem aItem( SID_LOADENVIRONMENT, pAntiImpl );
				pMedium->GetItemSet()->Put( aItem );
			}

            // Gegen Rescheduling im DoLoad sch"utzen
            SfxObjectShellRef xSave( xDoc );

			if ( !xDoc->DoLoad(pMedium))
				nError=ERRCODE_IO_GENERAL;
			if( xDoc->GetErrorCode() )
				nError = xDoc->GetErrorCode();
			if( xDoc->IsAbortingImport() )
			{
				nError = ERRCODE_ABORT;
// pFrame darf nicht auf 0 gesetzt werden, da sonst im Destruktor das
// Environment nicht ausgetragen wird
//					pFrame = 0;
			}

            if ( !nError && bSalvage )
            {
                SFX_ITEMSET_ARG(pMedium->GetItemSet(), pFilterItem, SfxStringItem, SID_FILTER_NAME, sal_False );
                SfxFilterMatcher& rMatcher = SFX_APP()->GetFilterMatcher();
                const SfxFilter* pFilter = rMatcher.GetFilter( pFilterItem->GetValue() );
                pMedium->SetFilter( pFilter );
            }

            if( ERRCODE_TOERROR( nError ) )
				return;
		}
		else
		{
			// Es soll nur ein leeres Doc erzeugt werden
			xDoc->DoInitNew(0);
			SfxMedium *pNewMedium = xDoc->GetMedium();
			pNewMedium->SetOpenMode( pMedium->GetOpenMode(), sal_False );
			pNewMedium->SetName( pMedium->GetName() );
			SfxItemSet* pNewSet = new SfxAllItemSet(
				*pMedium->GetItemSet() );
			pNewMedium->SetItemSet( pNewSet );
			xDoc->SetTitle( pMedium->GetName() );
			xDoc->InvalidateName();
			xDoc->SetModified( sal_False );
			pNewMedium->SetFilter( pMedium->GetFilter() );
			pNewMedium->Init_Impl();
			pNewMedium->SetCancelManager_Impl( pMedium->GetCancelManager_Impl());
			pNewMedium->SetLoadTargetFrame( pMedium->GetLoadTargetFrame() );
			delete pMedium;
			pMedium = pNewMedium;
		}
	}
}

ErrCode LoadEnvironment_Impl::DocumentDetected( SfxObjectShell* pShell, ErrCode nErrorP )
{
    DBG_ASSERT( eState == DOWNLOADING, "Wrong state!" );
	nError = nErrorP;
	if( eState != DOWNLOADING )
		return ERRCODE_ABORT;

	if ( xDoc.Is() )
	{
		// Erster Aufruf vom Frameset
		if( &xDoc != pShell )
		{
			// DocInfo kopieren
			pShell->GetDocInfo() = xDoc->GetDocInfo();
			xDoc->ForgetMedium();
			if( xDoc->IsAbortingImport() )
				pShell->CancelTransfers();
			xDoc = pShell;
			return nErrorP;
		}
		// Import wurde bereits abgebrochen
		if( xDoc->IsAbortingImport() )
			nError = ERRCODE_ABORT;
	}


	eState = CREATINGVIEW;
	SvRefBaseRef xRef( this );
	GetMedium()->GetItemSet()->ClearItem( SID_LOADENVIRONMENT );
	LoadDataAvailable_Impl( 0 );
	return nError;
}


void LoadEnvironment_Impl::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
{
	SfxSimpleHint* pHint = PTR_CAST( SfxSimpleHint, &rHint );
	if( pHint && pHint->GetId() == SFX_HINT_DYING )
		pFrame = 0;
}


void LoadEnvironment_Impl::CreateView()
{
	DBG_ASSERT( xDoc.Is(), "CreateView ohne Doc gferufen" );
	if ( nTodo & LEI_LOAD )
	{
		if( bTemplate && !(pMedium->GetFilter()->GetFilterFlags() & SFX_FILTER_CREATOR ) )
			ConvertToTemplate();
		else
		{
			SFX_APP()->LoadEa_Impl(*pMedium, *xDoc);
			const SfxPoolItem *pItem;
            SfxItemState eItemState = pMedium->GetItemSet()->GetItemState(
				SID_FILE_LONGNAME, sal_True, &pItem);
            if ( SFX_ITEM_SET == eItemState )
			{
				DBG_ASSERT(pItem->IsA( TYPE(SfxStringItem) ),
						   "Fehler Parametertype");
				xDoc->SetTitle(((const SfxStringItem *)pItem)->
							   GetValue());
				xDoc->SetModified(sal_False);
			}
			pMedium->SetUpdatePickList( !bIsApi && !bHidden);
		}
		if( bOpenTemplate )
			xDoc->SetTemplate(sal_True);

		if( xDoc.Is() && nError )
			xDoc->ResetError();

		// ggf. Template pr"ufen ( nur bei Dokumenten im FileSystem )
		if ( xDoc.Is() && !bHidden && !bIsApi && pMedium->ProvidesData_Impl() && pMedium->GetURLObject().GetProtocol() == INET_PROT_FILE )
			xDoc->UpdateFromTemplate_Impl();
	}

	if ( xDoc.Is() && pFrame )
	{
		SfxMedium &rMedium = *xDoc->GetMedium();
		SvKeyValueIteratorRef xIter( xDoc->GetHeaderAttributes() );
		SvKeyValue aValue;
		for( sal_Bool bCont = xIter->GetFirst( aValue ); bCont; bCont = xIter->GetNext( aValue ) )
		{
			if ( aValue.GetKey().CompareIgnoreCaseToAscii( "Window-Target" ) == COMPARE_EQUAL )
			{
				SfxItemSet *pSet = rMedium.GetItemSet();
				pSet->Put( SfxStringItem( SID_TARGETNAME, aValue.GetValue() ) );
				pSet->Put( SfxFrameItem( SID_DOCFRAME, pFrame ) );
				pSet->ClearItem( SID_ONLYSUBFRAMES );

				sal_Bool bOwns;
				SfxFrame *pNewFrame = SFX_APP()->GetTargetFrame_Impl( pSet, bOwns );
				if ( pNewFrame != pFrame )
				{
					if( pFrame->GetLoadEnvironment_Impl() == this )
						pFrame->SetLoadEnvironment_Impl( 0 );
					pFrame->SetLoadCancelable_Impl( 0 );

					if ( bOwnsFrame )
					{
						aDoneLink.Call(NULL);
						aDoneLink = Link();
						pFrame->DoClose();
					}

					pFrame = pNewFrame;
					bOwnsFrame = bOwns;

					xOldEnv = pFrame->GetLoadEnvironment_Impl();

					// Der neue Frame gehoert jetzt dem neuen Ladevorgang
					if( xOldEnv.Is() )
					{
						bOwnsFrame = xOldEnv->bOwnsFrame;
						xOldEnv->bOwnsFrame = sal_False;
					}

					pFrame->SetLoadEnvironment_Impl( this );
					rMedium.SetLoadTargetFrame( pFrame );
					pFrame->SetLoadCancelable_Impl( new SfxLoadCancellable(	pFrame, &rMedium ) );

					if( xOldEnv.Is() )
					{
						xOldEnv->CancelTransfers();
						xOldEnv.Clear();
					}
				}

				break;
			}
		}
	}

	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pUserDataItem, SfxStringItem, SID_USER_DATA, sal_False);

	// Falls Lokal, History updaten.
	sal_Bool bIsLocal = sal_False;
	SfxViewFrame* pF = 0;
	if( pFrame && pFrame->GetCurrentDocument() == &xDoc )
	{
		bIsLocal = sal_True;
		String aNewName( pMedium->GetOrigURL() );
		pFrame->UpdatePickEntries();
		pFrame->UpdateHistory(	xDoc, &aNewName );
		if( xDoc->HasName() )
		{
			xDoc->SetName( pMedium->GetName() );
			xDoc->GetMedium()->SetName( pMedium->GetName(), sal_True );
		}
	}

	SfxObjectShell* pCurDoc = pFrame ? pFrame->GetCurrentDocument() : 0;

	SFX_ITEMSET_ARG( pMedium->GetItemSet(), pTargetItem, SfxStringItem, SID_TARGETNAME, sal_False);
	if ( pFrame )
	{
		if( pFrame->GetCurrentDocument() != &xDoc )
		{
			// Ist es ein MDIFrame?
			if( bOwnsFrame || pFrame->GetCurrentViewFrame() )
				pFrame->SetItemSet_Impl( pMedium->GetItemSet() );
			if( !pFrame->InsertDocument( xDoc ) )
			{
				nError = ERRCODE_ABORT;
				return;
			}
		}
		else
		{
			if ( pFrame->HasComponent() && pFrame->GetController().is() )
			{
				SFX_ITEMSET_ARG(
					pMedium->GetItemSet(), pAny, SfxUsrAnyItem, SID_VIEW_DATA, sal_False );
				if ( pAny )
					pFrame->GetController()->restoreViewData( pAny->GetValue() );

			}
			SFX_ITEMSET_ARG(
				pMedium->GetItemSet(), pDescriptor, SfxFrameDescriptorItem,
				SID_FRAMEDESCRIPTOR, sal_False );
			if ( pDescriptor )
			{
				SfxFrameSetDescriptor *pSet = pDescriptor->GetProperties().pFrame->GetFrameSet();
				if ( pSet )
					pFrame->ReFill_Impl( pSet );
			}
		}

		pF = pFrame->GetCurrentViewFrame();
	}
	else
	{
		// sonst View aus Doc laden bzw. neu erzeugen
        pF = SFX_APP()->CreateView_Impl( pMedium->GetItemSet(), xDoc, sal_True, bHidden );
		pFrame = pF->GetFrame();
	}

	// Ab in die Pickliste
	xDoc->Get_Impl()->bWaitingForPicklist = sal_True;

	// ggf. in der View zum Bookmark springen; aber nur wenn keine UserDaten mitkommen, denn die wurden
	// schon beim Erzeugen der View ber"ucksichtigt ( nat"urlich nur wenn eine erzeugt wurde ! )
	if ( bIsLocal && pUserDataItem )
	{
		pFrame->GetCurrentViewFrame()->GetViewShell()->ReadUserData( pUserDataItem->GetValue(), sal_True );
	}
	else if( pF && aMark.Len() && !pUserDataItem )
	{
		MarkData_Impl* pMark = new MarkData_Impl;
		pMark->aMark = aMark;
		xDoc->Get_Impl()->pMarkData = pMark;
		pMark->pFrame = pF;
		if( !xDoc->IsLoading() )
			xDoc->PositionView_Impl();
	}

	String aURL = xDoc->GetMedium()->GetName();

	SFX_APP()->Broadcast( SfxStringHint(
		SID_OPENURL, aURL ) );
	if( pF )
	{
		if( !bDocCreated && !bLocal  )
		{
			if( xDoc->GetMedium()->IsExpired() )
			{
				SfxAllItemSet aSet( SFX_APP()->GetPool() );
				((SfxItemSet*)&aSet)->Put(
					SfxBoolItem( SID_FORCERELOAD, sal_False ) );
				SfxRequest aReq( SID_RELOAD, SFX_CALLMODE_ASYNCHRON, aSet );
				pF->ExecReload_Impl( aReq, sal_True );
			}
		}
	}

	if ( bSalvage )
		xDoc->SetModified(sal_True);
}


sal_Bool LoadEnvironment_Impl::PrepareClose()
{
	if ( pFrame )
	{
		sal_uInt16 nRet = pFrame->PrepareClose_Impl( !bIsApi, sal_True );
		if ( nRet == RET_NEWTASK )
		{
			if( pFrame && pFrame->GetLoadEnvironment_Impl() == this )
				pFrame->SetLoadEnvironment_Impl( &xOldEnv );
			xOldEnv.Clear();
			if ( bOwnsFrame )
			{
				aDoneLink.Call(NULL);
				aDoneLink = Link();
				pFrame->DoClose();
			}
			pFrame = 0;
			nRet = sal_True;
		}
		else if ( nRet )
			pFrame->UpdatePickEntries();
		return (sal_Bool) nRet;
	}
	else
		return sal_True;
}


IMPL_LINK( LoadEnvironment_Impl,LoadDataAvailable_Impl, void* , pVoid )
{
	LoadEnvironment_ImplRef xSave( this );
	if ( pVoid && bProcessing )
	{
		// keine erneuten Aufrufe von aussen, solange ein anderer Aufruf
		// noch nicht komplett abgearbeitet wurde
		aDecoupleLink.ClearPendingCall();
		aDecoupleLink.Call( pVoid, sal_False, sal_True );
		return 0;
	}

	if ( Application::IsUICaptured() )
	{
		// Beim synchronen Laden k"onnten aktive UI-Elemente zerst"ort werden
		if ( pMedium->IsDownloadDone_Impl() )
			aDecoupleLink.Call( 0, sal_True, sal_True );
		return 0;
	}

	// Ab jetzt nicht mehr unterbrechbar ( Mutex alleine w"urde nicht reichen,
	// da Reentranz auch durch ein Reschedule entstehen kann )
	bProcessing = sal_True;
    if( pMedium && !nError )
	{
		// Auf aufgetretene Fehler testen
		ErrCode nMedErr = pMedium->GetErrorCode();
		if( nMedErr == ERRCODE_IO_PENDING )
		{
			// Pending gilt nicht als Error
			nMedErr = ERRCODE_NONE;
			pMedium->ResetError();
		}

		if( nMedErr )
			// Error vom Medium auf das LoadEnvironment "ubertragen
			nError = nMedErr;
	}

    if ( nError )
        Error();

	switch( eState )
	{
		case CONNECTING:
		{
			aDecoupleLink.ClearPendingCall();
			eState = DETECTING;
			LoadDataAvailable_Impl(0);
			break;
		}
		case DETECTING :
		{
			sal_Bool bHadToLoad = sal_False;
			if( !xDoc.Is() )
			{
				if( nTodo & LEI_DETECTFILTER )
				{
                    DBG_ASSERT( pMedium->GetFilter(), "LoadEnvironment started without filter!" );
                    nTodo &= (~LEI_DETECTFILTER);
                    bWaitingForFilterDetection = sal_False;
/*
					if ( bWaitingForFilterDetection )
					{
						// Es wurde schon einmal eine FilterDetection versucht,
						// aber es waren nicht genug Daten verf"ugbar.
						// Wurde schon ein vorl"aufiger Filter gefunden, der nicht
						// asynchron ist, muss erst der Download komplettiert werden.
						const SfxFilter *pFilter = pMedium->GetFilter();
						if ( pFilter && !(pFilter->GetFilterFlags() & SFX_FILTER_ASYNC)
							&& !pMedium->IsDownloadDone_Impl() )
							break;
					}

                    DetectFilter();
					if ( nError == ERRCODE_IO_PENDING )
					{
						// F"ur die FilterDetection werden noch mehr Daten
						// ben"otigt, also geht es noch weiter
						bWaitingForFilterDetection = sal_True;
						nError = 0;
						break;
					}
					else
					{
						// FilterDetection mit oder ohne Erfolg fertig
						nTodo &= (~LEI_DETECTFILTER);
						bWaitingForFilterDetection = sal_False;
					}
 */
				}

				if( ( nTodo & LEI_LOAD ) && !nError )
				{
					bHadToLoad = sal_True;
					pMedium->SetLoadEnvironment_Impl( this );
					while ( pMedium && pMedium->GetFilter() && ( pMedium->GetFilter()->GetFilterFlags() & SFX_FILTER_EXECUTABLE ) )
					{
						// Filter sind entweder ueber die FilterContainer ausfuehrbar,
						// oder sie folgen dem Document/View/Factory Schema
						Execute();
						if ( nError )
							break;
					}

					if ( !nError )
					{
						// erfolgreiches Execute setzt den ErrorCode auf
						// ERRCODE_ABORT oder ERRCODE_IO_PENDING
						const SfxFilter* pFilter = pMedium->GetFilter();
						if ( !pMedium || !pFilter )
						{
							nError =  ERRCODE_SFX_NOFILTER;
							break;
						}

						// Finden der richtigen DocShell fuer den Filter
						const SfxObjectFactory* pFactory = &(( SfxFactoryFilterContainer *) pFilter->GetFilterContainer())->GetFactory();
						if ( !pFactory  )
						{
							nError =  ERRCODE_SFX_NOFILTER;
							break;
						}

						if ( !pMedium->GetInStream() )
						{
							// erst Load aufrufen, wenn geladen werden kann
							pMedium->StartDownload();
							if ( !pMedium->IsDownloadDone_Impl() &&
									( !pMedium->GetInStream() || !( pFilter->GetFilterFlags() & SFX_FILTER_ASYNC ) ) )
								break;
						}

						if( !PrepareClose() )
                        {
                            nTodo &= ~LEI_CREATEVIEW;
                            nError = ERRCODE_ABORT;
                        }
                        else
                        {
                            if( pFrame )
                                pFrame->CancelTransfers( sal_False );

                            if( xOldEnv.Is() )
                            {
                                xOldEnv->CancelTransfers();
                                xOldEnv.Clear();
                            }

                            Load( pFactory );
                        }
					}

					// Jetzt gibt es keinen Weg zur"uck
					xOldEnv.Clear();
					eState = DOWNLOADING;

					// JavaScript URL asynchron
					if( nError == ERRCODE_IO_PENDING || nError == ERRCODE_SFX_RESTART )
					{
						if( nError == ERRCODE_SFX_RESTART )
						{
							nError = 0;
							if ( !pMedium->GetFilter() )
								nTodo |= LEI_DETECTFILTER;
							Start();
						}
						else
							nError = 0;
						break;
					}
				}
			}
			else if( nError != ERRCODE_ABORT && !bUsableForLocal && !PrepareClose() )
				nError = ERRCODE_ABORT;

			// Falls Filter synchron, gleich View erzeugen;
			// Bei asynchronem Filter passiert das in LoadEnvironment_Impl::DocumentDetected
			if( !bHadToLoad || pMedium->GetFilter() && !( pMedium->GetFilter()->GetFilterFlags() & SFX_FILTER_ASYNC ) )
				eState = CREATINGVIEW;
			LoadDataAvailable_Impl( 0 );
			break;
		}
		case DOWNLOADING:
		{
            if( pMedium && pMedium->IsOpen() )
				aDataAvailableLink.Call( 0 );
			break;
		}
		case CREATINGVIEW:
		{
			eState = DOWNLOADING;
            if( xDoc.Is() && !ERRCODE_TOERROR( nError ) )
            {
                if( nTodo & LEI_CREATEVIEW )
                {
                    CreateView();
                    if ( bHidden )
                        // prevent Document from being destroyed in dtor of LoadEnvironment
                        xDoc->OwnerLock( TRUE );
                }
                else
                    // prevent Document from being destroyed in dtor of LoadEnvironment
                    xDoc->OwnerLock( TRUE );
            }

			// Falls wg. UICaptured das Lesen vor"ubergehend eingestellt wurde
			if( pMedium && pMedium->IsOpen() )
				aDataAvailableLink.Call( 0 );

            eState = DONE;
            LoadDataAvailable_Impl(0);
			break;
		}
		case DONE:
        {
			// Falls wg. UICaptured das Lesen vor"ubergehend eingestellt wurde
            if( !nError && pMedium && pMedium->IsOpen() )
				aDataAvailableLink.Call( 0 );

            if( !bDocCreated && ( nTodo & LEI_LOAD ) /* ||
                pMedium && pMedium->GetFilter() &&
                ( pMedium->GetFilter()->GetFilterFlags() &
                    SFX_FILTER_CREATOR ) && !bTemplate */ )  DELETEZ( pMedium );

            if ( aDoneLink.IsSet() )
            {
                SfxPoolItem* pRet;
                if( pFrame )
                    pRet = new SfxViewFrameItem( 0, &xDoc ? pFrame->GetCurrentViewFrame() : 0);
                else
                    pRet = new SfxObjectShellItem( 0, xDoc );

                aDoneLink.Call( pRet );
                delete pRet;
                aDoneLink = Link();
            }

            if ( !nError )
                bOwnsFrame = sal_False;

            if( pMedium )
                pMedium->GetItemSet()->ClearItem( SID_BROWSEMODE );

			if ( !pMedium || pMedium->IsDownloadDone_Impl() )
            	// Von uns aus kann gel"oscht werden
            	xThis.Clear();

            break;
        }
	}

	bProcessing = sal_False;
	return 0;
}

void LoadEnvironment_Impl::Error()
{
    if( nError != ERRCODE_IO_ABORT && !bHidden )
    {
        // Keine Fehlermeldung beim hidden
        if( !bIsApi )
            ErrorHandler::HandleError( nError );
        else
            SbxBase::SetError( nError );
    }

    ErrCode nFatalError = ERRCODE_TOERROR( nError );
    if( nFatalError )
    {
        if( pFrame && pMedium )
        {
            SFX_ITEMSET_ARG( pMedium->GetItemSet(), pIsChildLoad, SfxBoolItem, SID_ISCHILDFRAMELOAD, sal_False );
            if ( pIsChildLoad && pIsChildLoad->GetValue() )
                pFrame->LoadFinished_Impl();
        }

        if( xDoc.Is() )
        {
            pMedium = 0;
            xDoc.Clear();
        }
        else
            DELETEZ( pMedium );
    }
    else if ( xDoc.Is() )
    {
        xDoc->ResetError();
    }
    else if ( bIsApi )
    {
        // kein Doc => Warning wird zum Error
        SbxBase::ResetError();
        SbxBase::SetError( nError & ~ERRCODE_WARNING_MASK );
    }

    nError = nFatalError;
    if ( nError )
        eState = DONE;
}

void LoadEnvironment_Impl::LoadAndCreateView( const SfxObjectFactory *pFactory )
{
	LoadEnvironment_ImplRef xTmp( this );
	SfxFilterMatcher aMatcher( pFactory->GetFilterContainer() );
	const SfxFilter* pFilter=0;
	pMedium->SetFilter( 0 );
	aMatcher.DetectFilter( *pMedium, &pFilter, bPlugIn, bIsApi );
	if ( pFilter )
		pMedium->SetFilter( pFilter );
	Load( pFactory );
	xOldEnv.Clear();
    if ( nError == ERRCODE_NONE )
    {
        eState = CREATINGVIEW;
        LoadDataAvailable_Impl(0);
    }

	xThis = this;
}
