/*************************************************************************
 *
 *  $RCSfile: picklist.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <osl/mutex.hxx>
#ifndef _SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif
#ifndef _MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _SFXINIMGR_HXX //autogen
#include <svtools/iniman.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#include <svtools/inethist.hxx>
#ifndef _COM_SUN_STAR_CHAOS_ANCHOREVENT_HPP_
#include <com/sun/star/chaos/AnchorEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XANCHOR_HPP_
#include <com/sun/star/chaos/XAnchor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XANCHORFACTORY_HPP_
#include <com/sun/star/chaos/XAnchorFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XANCHOREVENTLISTENER_HPP_
#include <com/sun/star/chaos/XAnchorEventListener.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_ACTION_HPP_
#include <com/sun/star/chaos/Action.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XCOMMANDEXECUTOR_HPP_
#include <com/sun/star/chaos/XCommandExecutor.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_XSTATUSCALLBACK_HPP_
#include <com/sun/star/chaos/XStatusCallback.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_UNKNOWNCOMMANDEXCEPTION_HPP_
#include <com/sun/star/chaos/UnknownCommandException.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_STATUSCALLBACKEVENT_HPP_
#include <com/sun/star/chaos/StatusCallbackEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HPP_
#include <com/sun/star/loader/CannotActivateFactoryException.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <unotools/processfactory.hxx>
#endif

#pragma hdrstop

#include "fcontnr.hxx"
#include "inimgr.hxx"
#include "picklist.hxx"
#include "app.hxx"
#include "bindings.hxx"
#include "objsh.hxx"
#include "docfile.hxx"
#include "docfilt.hxx"
#include "objshimp.hxx"
#include "saveopt.hxx"
#include "event.hxx"
#include "request.hxx"
#include "sfxtypes.hxx"
#include "docinf.hxx"
#include "sfxuno.hxx"
#include "sfxsids.hrc"
#include "sfx.hrc"
#include "viewfrm.hxx"

// class FileBase
#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif
using namespace ::osl;
using namespace ::vos;

SfxPickList_Impl* SfxPickList_Impl::pInstance = NULL;

SfxPickList_Impl* SfxPickList_Impl::Get()
{
	::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
	return pInstance;
}

SfxPickList_Impl* SfxPickList_Impl::GetOrCreate( const sal_uInt32 nMenuSize )
{
	::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
	if ( !pInstance )
		pInstance = new SfxPickList_Impl( nMenuSize );
	return pInstance;
}

void SfxPickList_Impl::Delete()
{
	::osl::MutexGuard aGuard( ::osl::Mutex::getGlobalMutex() );
	DELETEZ( pInstance );
}

//=========================================================================

// Hilfsfunktionen fuer Picklist-Eintraege

// ersetzt \\ durch \, \{ durch {, \} durch } sowie schliesst den ganzen String in
// ein {}-Paar ein
String Quote(const String& rSource)
{
	if (!rSource.Len())
		return DEFINE_CONST_UNICODE("{}");

	String sTemp(rSource);
	sTemp.SearchAndReplaceAll(DEFINE_CONST_UNICODE("\\"), DEFINE_CONST_UNICODE("\\\\"));
	sTemp.SearchAndReplaceAll(DEFINE_CONST_UNICODE("{"), DEFINE_CONST_UNICODE("\\{"));
	sTemp.SearchAndReplaceAll(DEFINE_CONST_UNICODE("}"), DEFINE_CONST_UNICODE("\\}"));
		// in dieser Reihenfolge !

	String sReturn(0x007B); // '{' = 7Bh

	sReturn += sTemp;
	sReturn += 0x007D; // '}' = 7Dh
	return sReturn;
}

// Umkehrung von Quote
String UnQuote(const String& rSource)
{
	if (!rSource.Len())
		return String();

	String sReturn(rSource);
	sReturn.SearchAndReplaceAll(DEFINE_CONST_UNICODE("\\{"), DEFINE_CONST_UNICODE("{"));
	sReturn.SearchAndReplaceAll(DEFINE_CONST_UNICODE("\\}"), DEFINE_CONST_UNICODE("}"));
	sReturn.SearchAndReplaceAll(DEFINE_CONST_UNICODE("\\\\"), DEFINE_CONST_UNICODE("\\"));

	if ((sReturn.GetChar(0) == 0x007B) && (sReturn.GetChar(sReturn.Len() - 1) == 0x007D)) // '{' = 7Bh und '}' = 7Dh
		// ist eigentlich nicht korrekt : normalerweise muessten wir testen, ob die oeffnende Klammer am Anfang und
		// die schliessende Klammer am Ende zum selben Paar gehoeren, aber fuer den Kontext, in dem es hier verwendet
		// wird, reicht es
		return sReturn.Copy(1, sReturn.Len() - 2);

	return sReturn;
}

// Hilfsfunktion, die aus einem String Tokens extrahiert, wobei in {}-Paare geklammerte Teilstrings
// uebersprungen werden, also den Token.Trenner enthalten duerfen. Verschachtelte Klammerungen sind
// erlaubt.
// \{ wird dabei als Einheit betrachtet, bei der die Klammer nicht zaehlt, analog \}.
// Um dabei Eindeutigkeit zu gewaehrleisten, zaehlt auch \\ als Einheit, \\{ also wiederum als Begin
// einer Klammerung.
// Wenn bPure == sal_True, wird das gefundene Token ohne Veraenderung geliefert
// Wenn bPure == sal_False und das Token insegesamt in ein {}-Paar eingeschlossen ist (so wie es bei Quote
// entsteht), wird es vor der Rueckgabe noch durch Unquote gejagt.
// Wenn bPure == sal_False und das Token nicht geklammert ist, wird es ebenfalls ohne Veraenderung geliefert.
String GetBrackToken(const String& rSource, sal_uInt16 nToken, char cTok = ';', sal_uInt16 nStart = 0, sal_Bool bPure = sal_False)
{
	static const String aEmptyStr;
	// leerer String oder nStart zu gross ?
	if (nStart >= rSource.Len())
		return aEmptyStr;

	ByteString sTemp(U2S(rSource));
	const char* pStart = sTemp.GetBuffer() + nStart;
	const char* pSearch = pStart;
	sal_uInt16 nBracketLevel = 0;
	sal_uInt16 nCurrentToken = 0;
	sal_uInt16 nCurrentTokenStart = nStart;
	const char* pFirstLevelZeroChar = NULL;

	while (*pSearch)
	{
		switch (*pSearch)
		{
			case '\\':
				switch (*(pSearch + 1))
				{
					case '{':
					case '}':
					case '\\':
						++pSearch;
						break;
					default:
						// andere Faelle sollten zwar nicht auftreten, wenn das Token irgendwann mal durch
						// Quote entstanden ist, aber wenn doch, behandeln wir den Backslash eben wie ein
						// normales Zeichen (ueberlesen ihn also)
						if (!pFirstLevelZeroChar)
							pFirstLevelZeroChar = pSearch;
				}
				break;
			case '{' :
				++nBracketLevel;
				break;

			case '}' :
				if (!nBracketLevel)
					// SO KANN ICH NICHT ARBEITEN !!!!
					// (soll heissen, wenn die Klammern nicht paarig auftreten, knn' wir nix machen ;)
					return aEmptyStr;
				--nBracketLevel;
				break;

			default:
				if (!nBracketLevel)
				{
					if (!pFirstLevelZeroChar)
						pFirstLevelZeroChar = pSearch;
					if (*pSearch == cTok)
					{
						if (nCurrentToken == nToken)
						{
							// wir haben das gewuenschte Token
							String sReturn ( S2U( sTemp.Copy(nCurrentTokenStart, pSearch - pStart - nCurrentTokenStart) ) );
							// eventuell Quotierung entfernen
							if (bPure)
								return sReturn;

							if (pFirstLevelZeroChar == pSearch)
								// der Token-Trenner war das erste nicht-geklammerte Zeichen, also ist das
								// gesamte Token geklammert, also Unquote
								return UnQuote(sReturn);
							return sReturn;
						}

						// nicht das gewuenschte Token -> weiter (was sonst)
						nCurrentTokenStart = pSearch - pStart + 1;
						nBracketLevel = 0;
						pFirstLevelZeroChar = NULL;
						++nCurrentToken;
					}
				}
				// alles andere - auf einer Klammerebene > 0 - wird ueberlesen
		}

		++pSearch;
	}
	if ((nBracketLevel == 0) && (nCurrentToken == nToken))
	{	// hinter dem letzten Token fehlte einfach ein Trenner
		String sReturn ( S2U( sTemp.Copy(nCurrentTokenStart, pSearch - pStart - nCurrentTokenStart)));
		// eventuell Quotierung entfernen (analog oben)
		if (bPure)
			return sReturn;
		if (!pFirstLevelZeroChar)
			return UnQuote(sReturn);
		return sReturn;
	}

	return aEmptyStr;
}

//=========================================================================

void MemCache_Impl::ClearObjects()
{
	ClearToLimit( 0 );
}

//-------------------------------------------------------------------------

MemCache_Impl::~MemCache_Impl()
{
	ClearObjects();
}

//-------------------------------------------------------------------------

sal_Bool MemCache_Impl::IsObjectCached( const SfxObjectShell *pObjSh ) const
{
	sal_uInt16 nCount = (sal_uInt16)Count();
	for ( sal_uInt16 n = 0; n<nCount; n++ )
	{
		SfxObjectShell *pFoundObjSh = *GetObject(n);
		if ( pFoundObjSh == pObjSh )
			return sal_True;
	}

	return sal_False;
}

//-------------------------------------------------------------------------

SfxObjectShell* MemCache_Impl::Find(
	const INetURLObject &rUrlToFind, const String& rPostString ) const
{
	sal_uInt16 nCount =(sal_uInt16) Count();
	for ( sal_uInt16 n = 0; n<nCount; n++ )
	{
		INetURLObject aUrl;
		aUrl.SetSmartProtocol(INET_PROT_FILE);
		SfxObjectShell *pDoc = *GetObject(n);
		aUrl.SetSmartURL( pDoc->GetMedium()->GetName());
		if ( !aUrl.HasError() && (
			aUrl == rUrlToFind || rUrlToFind ==
			pDoc->GetMedium()->GetPreRedirectedURL() ) )
		{
			SfxItemSet* pSet = pDoc->GetMedium()->GetItemSet();
			SFX_ITEMSET_ARG(
				pSet, pPost2Item,
				SfxRefItem, SID_POSTLOCKBYTES, sal_False);
			if( pPost2Item ) continue;
			String aPostString;
			if( pSet )
			{
				SFX_ITEMSET_ARG(
					pSet, pPostItem,
					SfxStringItem, SID_POSTSTRING, sal_False);
				if( pPostItem )
					aPostString = pPostItem->GetValue();
			}
			if( aPostString == rPostString )
				return pDoc;
		}
	}
	return 0;
}

//-------------------------------------------------------------------------

void MemCache_Impl::ClearToLimit( sal_uInt16 nCount )
{
	for( sal_uInt16 nPos = (sal_uInt16)Count(); nPos-- > nCount;  )
		delete Remove( (sal_uInt32) nPos );
}

sal_Bool MemCache_Impl::RemoveObject( const SfxObjectShell *pObjSh )
{
	sal_uInt16 nCount = (sal_uInt16)Count();
	for ( sal_uInt16 n = 0; n<nCount; n++ )
	{
		if ( *GetObject( n ) == pObjSh )
		{
			delete Remove( n );
			return sal_True;
		}
	}

	return sal_False;
}

//-------------------------------------------------------------------------

void MemCache_Impl::AddObject( SfxObjectShell *pObj )

/*	[Beschreibung]

	Nimmt das Dokument 'pObj' in den Memory-Cache auf, falls es ein
	Remote-Dokument ist, sonst nicht. Der Memory-Cache h"alt eine Referenz
	auf das Dokument, so da\s es nicht gel"oscht werden kann.
*/

{
	// Remote?
	SfxMedium *pMed = pObj->GetMedium();
	if ( !pMed || !pMed->IsRemote() )
		return;

	SFX_ITEMSET_ARG(
		pMed->GetItemSet(), pPost2Item,
		SfxRefItem, SID_POSTLOCKBYTES, sal_False);
	if( pPost2Item )
		return;

	String aPostString;
	SFX_ITEMSET_ARG( pMed->GetItemSet(), pPostItem,
					 SfxStringItem, SID_POSTSTRING, sal_False);

	// Bugfix 55810: durch POST erhaltene Docs d"urfen nicht gecached werden
	if( pPostItem )
		return;
//		aPostString = pPostItem->GetValue();

	// schon drin?
	if ( Find( pObj->GetMedium()->GetName(), aPostString ) )
		return;

	// Cache-Gr"o\se erreicht?
	sal_uInt16 nMax = SFX_APP()->GetIniManager()->Get( SFX_KEY_INET_MEMCACHE ).ToInt32();
	ClearToLimit( nMax - 1 );

	// in Cache aufnehmen
	pObj->Get_Impl()->bClosing = sal_False;	// Sonst funzt CLOSE_DOC nie mehr...
	if( nMax )
		Insert( new SfxObjectShellLock( pObj), 0UL );
}

//-------------------------------------------------------------------------

String PickString_Impl
(
	sal_uInt16 nNo						/* ::com::sun::star::sdbcx::Index des nachfolgenden Pick-Entries
									   in der Pick-Liste, beginnend mit 0 */,

	SfxPickEntry_Impl* pPick		/* Pick-Entry, der in einen String
									   umgewandelt werden soll */
)

/*	[Beschreibung]

	Hilfsroutine, mit der vor den Dateinamen eines Pick-Entries eine
	Ziffer als Short-Erase f"ur das Men"u gesetzt wird.
*/

{
#ifdef MAC
	String aPickEntry;
#else
	String aPickEntry( '~' );
	aPickEntry += String::CreateFromInt32( nNo + 1 );
	aPickEntry += DEFINE_CONST_UNICODE(": ");
#endif

	aPickEntry += pPick->aTitle;
	if ( aPickEntry.Len() > 50 )
	{
		aPickEntry.Erase( 48 );
		aPickEntry += DEFINE_CONST_UNICODE("...");
	}
	return aPickEntry;
}

//-------------------------------------------------------------------------

SfxPickEntry_Impl::SfxPickEntry_Impl( const SfxMedium *pMed, const String &rTitle )
:	aName( pMed->GetOrigURL() ),
	aTitle( rTitle )
{
	const SfxFilter* pFilter = pMed->GetOrigFilter();
	if ( pFilter )
	{
		// Filter eintragen
		aFilter = pFilter->GetName();

		// Filter-Optionen eintragen
		SfxItemSet *pSet= pMed->GetItemSet();
		const SfxPoolItem *pItem = 0;
		const SfxStringItem *pStringItem = 0;
		if ( pSet &&
				SFX_ITEM_SET == pSet->GetItemState(SID_FILE_FILTEROPTIONS, sal_False, &pItem ) )
			pStringItem = PTR_CAST( SfxStringItem, pItem );
		if( pStringItem )
		{
			aFilter += '|';
			aFilter += pStringItem->GetValue();
		}
	}
}

//-------------------------------------------------------------------------

SfxPickEntry_Impl::SfxPickEntry_Impl
(
	const String &rName,
	const String &rFilter,
	const String &rTitle
)
:	aName( rName ),
	aFilter( rFilter ),
	aTitle( rTitle )
{
}

//-------------------------------------------------------------------------

SfxPickList_Impl::SfxPickList_Impl( const sal_uInt32 nMenuSize )
:	aHistoryPickList( HISTORY_MAXSIZE , 0 ) ,
	aMenuPickList( PICKLIST_MAXSIZE , 0 ) ,
	nAllowedMenuSize( nMenuSize ) ,
	pPickMenu( NULL ),
	bHistoryInitialized( sal_False ),
	bPickListInitialized( sal_False )
{
	DBG_ASSERT( nAllowedMenuSize <= PICKLIST_MAXSIZE ,
				"Menueintragzahl > Historyzahl" );
	// auf Broadcasts der App h"oren
	StartListening( *SFX_APP() );
}

//***************************************************************************

SfxPickList_Impl::~SfxPickList_Impl()
{
	// Zerstoerung der Menupickliste
	sal_uInt32 nEntryCount = aMenuPickList.Count();
	sal_uInt32 nEntry;
	for( nEntry = 0 ; nEntry < nEntryCount ; nEntry++ )
		delete aMenuPickList.GetObject( nEntry );

	// Zerstoerung der Historypickliste
	nEntryCount = aHistoryPickList.Count();
	for( nEntry = 0 ; nEntry < nEntryCount ; nEntry++ )
		delete aHistoryPickList.GetObject( nEntry );
}

//***************************************************************************

void SfxPickList_Impl::LoadHistory()
/*
	[Beschreibung]
	Die Methode laedt die Historydaten aus dem Inifile.
*/
{
	DBG_ASSERT( !bHistoryInitialized, "LoadHistory ist ueberfluessig" );

	bHistoryInitialized = sal_True;

	// Einlesung der Historypickliste
	SfxIniManager *pIni = SFX_INIMANAGER();
	for ( sal_uInt16 i = 0; i < HISTORY_MAXSIZE; ++i )
	{
		// Eintrag vom Ini-Manager abholen
		sal_Bool bDone = sal_False;
		String aEntry( pIni->Get( SFX_KEY_HISTORY, i ) );
		if ( aEntry.Len() )
		{
			// History-Pick-Entry erzeugen und einfuegen
			String aName = GetBrackToken(aEntry, 0, ';');
			String aFilter = GetBrackToken(aEntry, 1, ';');
			String aTitle = GetBrackToken(aEntry, 2, ';');
			String aPass = GetBrackToken(aEntry, 3, ';');

			INetURLObject aURL;
			aURL.SetSmartURL( aName );
			aURL.SetPass( SfxStringDecode( aPass ) );
			SfxPickEntry_Impl *pPick = new SfxPickEntry_Impl(
										aURL.GetMainURL(), aFilter, aTitle );
			aHistoryPickList.Insert( pPick, LIST_APPEND );
			bDone = sal_True;
		}

		// beim ersten leeren Eintrag abbrechen
		if ( !bDone )
			break;
	}

	// Anfangs zum zuletzt geladenen springen
	aHistoryPickList.Seek( (sal_uInt32) 0L );
}

//-------------------------------------------------------------------------

void SfxPickList_Impl::LoadPickList()
{
	// mehrfach-Aufruf abfangen (kommt vom Menu)
	if ( bPickListInitialized )
		return;

	// Einlesen der Pickliste
	SfxIniManager *pIni = SFX_INIMANAGER();
	for ( sal_uInt16 i = 0; i < PICKLIST_MAXSIZE; ++i )
	{
		// Eintrag vom Ini-Manager abholen
		sal_Bool bDone = sal_False;
		String aEntry( pIni->Get( SFX_KEY_PICKLIST, i ) );
		if ( aEntry.Len() )
		{
			// Pick-Entry erzeugen und einfuegen
			String aName = GetBrackToken(aEntry, 0, ';');
			String aFilter = GetBrackToken(aEntry, 1, ';');
			String aTitle = GetBrackToken(aEntry, 2, ';');
			String aPass = GetBrackToken(aEntry, 3, ';');

			INetURLObject aURL;
			aURL.SetSmartURL( aName );
			aURL.SetPass( SfxStringDecode( aPass ) );
			SfxPickEntry_Impl *pPick = new SfxPickEntry_Impl(
										aURL.GetMainURL(), aFilter, aTitle );
			aMenuPickList.Insert( pPick, LIST_APPEND );
			bDone = sal_True;
		}

		// beim ersten leeren Eintrag abbrechen
		if ( !bDone )
			break;
	}

	bPickListInitialized = sal_True;
}

//***************************************************************************

void SfxPickList_Impl::SavePicklist()
/*
	[Beschreibung]
	Abspeicherung der Daten im Inifile
*/
{
	SfxIniManager *pIni = SFX_INIMANAGER();

	if( bPickListInitialized )
	{
		sal_uInt16 nCount = (sal_uInt16)aMenuPickList.Count();
		sal_Bool bBreak = sal_False;
		for ( sal_uInt16 nNo = 0; !bBreak && nNo < nCount; nNo++ )
		{
			SfxPickEntry_Impl *pEntry = aMenuPickList.GetObject( nNo );
			INetURLObject aURL( pEntry->aName );
			String aEntry;
			if ( pEntry->aName.Len() )
			{
				aEntry += Quote(aURL.GetURLNoPass());
				aEntry += ';';
				aEntry += Quote(pEntry->aFilter);
				aEntry += ';';
				aEntry += Quote(pEntry->aTitle);
				aEntry += ';';
				aEntry += Quote(SfxStringEncode( aURL.GetPass() ));
			}
			else
			{
				aEntry = aURL.GetURLNoPass();
				bBreak = sal_True;
			}
			pIni->Set( aEntry, SFX_KEY_PICKLIST, nNo );
		}
	}
	if( bHistoryInitialized )
	{
		sal_uInt16 nCount = (sal_uInt16)aHistoryPickList.Count();
		sal_Bool bBreak = sal_False;
		for ( sal_uInt16 nNo = 0; !bBreak && nNo < nCount; nNo++ )
		{
			SfxPickEntry_Impl *pEntry = aHistoryPickList.GetObject( nNo );
			INetURLObject aURL( pEntry->aName );
			String aEntry;
			if ( pEntry->aName.Len() )
			{
				aEntry += Quote(aURL.GetURLNoPass());
				aEntry += ';';
				aEntry += Quote(pEntry->aFilter);
				aEntry += ';';
				aEntry += Quote(pEntry->aTitle);
				aEntry += ';';
				aEntry += Quote(SfxStringEncode( aURL.GetPass() ));
			}
			else
			{
				aEntry = aURL.GetURLNoPass();
				bBreak = sal_True;
			}
			pIni->Set( aEntry, SFX_KEY_HISTORY, nNo );
		}
	}
}

//-------------------------------------------------------------------------

SfxPickEntry_Impl* SfxPickList_Impl::GetMenuPickEntry( const sal_uInt16 nPos ) const
{
	if ( !bPickListInitialized )
		((SfxPickList_Impl*)this)->LoadPickList();
	DBG_ASSERT( nPos < aMenuPickList.Count(), "Invalide Pickentrypos" );
	return aMenuPickList.GetObject( nPos );
}

//-------------------------------------------------------------------------

sal_uInt32 SfxPickList_Impl::MenuPickEntryCount() const
{
	if ( !bPickListInitialized )
		((SfxPickList_Impl*)this)->LoadPickList();
	return aMenuPickList.Count();
}

//***************************************************************************

SfxPickEntry_Impl* SfxPickList_Impl::GetHistoryPickEntry( const sal_uInt32 nPos )
/*
	[Beschreibung]
	Die Methode gibt den gegebenen Eintrag aus der History zurueck.
*/
{
	DBG_ASSERT( nPos < aHistoryPickList.Count() ,
			"Invalide Pickentrypos" );

	// Load on demand der Historypickliste
	if ( !bHistoryInitialized )
		LoadHistory();

	return aHistoryPickList.GetObject( nPos );
}


//***************************************************************************

SfxPickEntry_Impl* SfxPickList_Impl::GetHistoryPickEntry( const String& rURL )
/*
	[Beschreibung]
	Die Methode gibt den gegebenen Eintrag aus der History zurueck.
*/
{
	for( sal_uInt16 nPos = (sal_uInt16)aHistoryPickList.Count(); nPos--; )
	{
		INetURLObject aURL( aHistoryPickList.GetObject( nPos )->aName );
		if ( aURL.GetURLNoPass()  == rURL )
			return aHistoryPickList.GetObject( nPos );
	}
	return 0;
}

//***************************************************************************

SfxPickEntry_Impl* SfxPickList_Impl::GetHistoryPickEntryFromTitle(
														const String& rTitle )
/*
	[Beschreibung]
	Die Methode gibt den gegebenen Eintrag aus der History zurueck.
*/
{
	for( sal_uInt16 nPos = (sal_uInt16)aHistoryPickList.Count(); nPos--; )
	{
		SfxPickEntry_Impl* pEntry = aHistoryPickList.GetObject( nPos );
		if ( pEntry->aTitle == rTitle )
			return pEntry;
	}
	return NULL;
}

//***************************************************************************

sal_uInt32 SfxPickList_Impl::HistoryPickEntryCount()
/*
	[Beschreibung]
	Die Methode gibt die Anzahl der Historyeintraege zurueck.
*/
{
	// Load on demand der Historypickliste
	if ( !bHistoryInitialized )
		LoadHistory();

	return aHistoryPickList.Count();
}

//***************************************************************************

sal_uInt32 SfxPickList_Impl::GetCurHistoryPos()
/*
	[Beschreibung]
	Die Methode gibt die aktuelle Position in der History zurueck.
*/
{
	// Load on demand der History
	if( !bHistoryInitialized )
		LoadHistory();

	return aHistoryPickList.GetCurPos();
}

//***************************************************************************

SfxPickEntry_Impl* SfxPickList_Impl::SetCurHistoryPos( const sal_uInt32 nPos )
/*
	[Beschreibung]
	Die Methode "springt" zum gegebenen Eintrag und gibt selbigen zurueck.
*/
{
	DBG_ASSERT( nPos < aHistoryPickList.Count() ,
				"Invalide Pickentrypos" );

	// Load on demand der History
	if( !bHistoryInitialized )
		LoadHistory();

	return aHistoryPickList.Seek( nPos );
}

//***************************************************************************

void SfxPickList_Impl::SetPickMenu( Menu* pPickMenu )
/*
	[Beschreibung]
	Anzeige der Pickliste im gegebenen Menu
*/
{
	// ggf. on-demand laden
	if ( !bPickListInitialized )
		((SfxPickList_Impl*)this)->LoadPickList();

    for ( sal_uInt16 nId = SID_PICK1; nId <= SID_PICKLIST_END; ++nId )
        pPickMenu->RemoveItem( pPickMenu->GetItemPos( nId ) );
    if ( pPickMenu->GetItemType( pPickMenu->GetItemCount()-1 ) == MENUITEM_SEPARATOR )
        pPickMenu->RemoveItem( pPickMenu->GetItemCount()-1 );

    if ( aMenuPickList.Count() > 0 &&
            pPickMenu->GetItemType( pPickMenu->GetItemCount()-1 )
            != MENUITEM_SEPARATOR && nAllowedMenuSize )
        pPickMenu->InsertSeparator();
    for ( sal_uInt16 nNo = 0; ( nNo < nAllowedMenuSize ) && ( nNo < aMenuPickList.Count() ) ; ++nNo )
    {
        SfxPickEntry_Impl* pPickEntry = aMenuPickList.GetObject( nNo );
        DBG_ASSERT( pPickEntry , "Pickentry ist invalid" );
        pPickMenu->InsertItem( SID_PICK1 + nNo, PickString_Impl( nNo , pPickEntry ) );
    }
}

//***************************************************************************

void SfxPickList_Impl::InsertToHistory( SfxObjectShell* pDocSh )
{
	// soll der ueberhaupt rein?
	SfxMedium *pMed = pDocSh->GetMedium();
	if ( !pMed )
		return;

	INetProtocol eProt = pMed->GetURLObject().GetProtocol();
	if ( eProt != INET_PROT_FILE &&
		 eProt != INET_PROT_NEWS &&
		 eProt != INET_PROT_POP3 &&
		 eProt != INET_PROT_IMAP &&
		 eProt != INET_PROT_OUT  &&
		 eProt != INET_PROT_FTP  &&
		 eProt != INET_PROT_HTTP &&
		 eProt != INET_PROT_HTTPS )
		return;

	// ggf. on-demand laden
	if ( !bHistoryInitialized )
		((SfxPickList_Impl*)this)->LoadHistory();

	// Load der Historydaten aus dem Inifile, falls noch nicht
	// geschehen
	if( !bHistoryInitialized )
		LoadHistory();

	String aName = pMed->GetOrigURL();
	if ( !aName.Len() )
		return;

	// schon drin?
	INetURLObject aURL( aName );
	String aStr = aURL.GetURLNoPass();

	SfxPickEntry_Impl* pEntry = GetHistoryPickEntry( aStr );
	if ( pEntry )
		aHistoryPickList.Remove( aHistoryPickList.GetPos( pEntry ) );
	else
        pEntry = new SfxPickEntry_Impl( pMed, aStr );

	// Anzahl beschr"anken
	if ( aHistoryPickList.Count() == HISTORY_MAXSIZE )
		delete aHistoryPickList.Remove( aHistoryPickList.Count() - 1 );

	// den neuen einf"ugen
	aHistoryPickList.Insert( pEntry, PICKLIST_INSERT_POSITION );
	aHistoryPickList.Seek( PICKLIST_INSERT_POSITION );
}

//-------------------------------------------------------------------------

void SfxPickList_Impl::InsertToMenu( SfxObjectShell* pDocSh )
{
	// ggf. on-demand laden
	if ( !bPickListInitialized )
		((SfxPickList_Impl*)this)->LoadPickList();

	// nur r/w-Docs in die Pickliste
	SfxMedium *pMed = pDocSh->GetMedium();
	if( !pMed || pDocSh->IsReadOnly() || !pMed->IsUpdatePickList() )
		return;

	INetProtocol eProt = pMed->GetURLObject().GetProtocol();
	if ( eProt != INET_PROT_FILE &&
		 eProt != INET_PROT_FTP &&
		 eProt != INET_PROT_HTTP &&
		 eProt != INET_PROT_HTTPS )
		return;

	// keine Docs in Pickliste, die das explizit unterbinden (z.B. Message-Body)
	SFX_ITEMSET_ARG( pMed->GetItemSet(), pPicklistItem, SfxBoolItem, SID_PICKLIST, sal_False );
	if ( pPicklistItem && !pPicklistItem->GetValue() )
		return;

	// Neuer Eintrag fuer die Menupickliste
	SfxPickEntry_Impl* pNewPickEntry = new SfxPickEntry_Impl(
		pMed, pDocSh->GetTitle(SFX_TITLE_PICKLIST) );

	// Suche nach dem Eintrag in der Menuliste
	sal_uInt32 nPickEntryCount = aMenuPickList.Count();
	sal_uInt32 nPickEntry      = 0;
	sal_Bool  bFound          = sal_False;
	while( ( nPickEntry < nPickEntryCount ) && !bFound )
	{
		SfxPickEntry_Impl* pPickEntry =
			aMenuPickList.GetObject( nPickEntry );
		DBG_ASSERT( pPickEntry , "Pickentry ist invalid" );
		if ( pPickEntry->aName == pNewPickEntry->aName )
		{
			// Loeschung des Eintrags
			delete aMenuPickList.Remove( nPickEntry );
			bFound = sal_True;
		}
		++nPickEntry;
	}

	// Anzahl begrenzen
	if( aMenuPickList.Count() == PICKLIST_MAXSIZE )
		delete aMenuPickList.Remove( aMenuPickList.Count() - 1 );
	aMenuPickList.Insert( pNewPickEntry, PICKLIST_INSERT_POSITION );

	// Aktualisierung des Menus
	if( pPickMenu )
	{
		// alle alten Eintraege werden geloescht
		for ( sal_uInt16 nId = SID_PICK1 ; nId <=
				  SID_PICKLIST_END ; ++nId )
		{
			sal_uInt16 nPos = pPickMenu->GetItemPos( nId );
			if ( nPos != MENU_ITEM_NOTFOUND )
				pPickMenu->RemoveItem( nPos );
		}

		// neue Reihenfolge der Items
		if ( aMenuPickList.Count() > 0 )
		{
			if ( pPickMenu->GetItemType( pPickMenu->GetItemCount()-1 )
				 != MENUITEM_SEPARATOR && nAllowedMenuSize )
				pPickMenu->InsertSeparator();
		}
		else
		{
			if ( pPickMenu->GetItemType( pPickMenu->GetItemCount()-1 )
				 == MENUITEM_SEPARATOR )
				pPickMenu->RemoveItem( pPickMenu->GetItemCount()-1 );
		}
		for ( sal_uInt16 nNo = 0; ( nNo < nAllowedMenuSize ) &&
				  ( nNo < aMenuPickList.Count() ) ; ++nNo )
		{
			SfxPickEntry_Impl* pPickEntry =
				aMenuPickList.GetObject( nNo );
			DBG_ASSERT( pPickEntry , "Pickentry ist invalid" );
			pPickMenu->InsertItem( SID_PICK1+nNo ,
								   PickString_Impl( nNo , pPickEntry ) );
		}
	}

	// fill Windows Picklist
	if ( eProt == INET_PROT_FILE )
	{
		// convert URL to system path
		::rtl::OUString aFileName, aNormPath;
		if ( FileBase::getNormalizedPathFromFileURL( pMed->GetOrigURL(), aNormPath ) == FileBase::E_None )
		{
			FileBase::getSystemPathFromNormalizedPath( aNormPath, aFileName );
            SfxViewFrame *pFrame = SfxViewFrame::GetFirst( pDocSh );
            if ( pFrame )
                System::AddRecentDoc( &pFrame->GetWindow(), aFileName );
		}
	}
}

//-------------------------------------------------------------------------

void SfxPickList_Impl::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )
/*
	[Beschreibung]
	BroadCaster(muss):
	class SfxApplication
	class SfxObjectShell
*/
{
	if( rHint.IsA( TYPE( SfxStringHint ) ) )
	{
		SfxStringHint* pStringHint = (SfxStringHint*) &rHint;
		if( pStringHint->GetId() == SID_OPENURL )
			INetURLHistory::GetOrCreate()->PutUrl( INetURLObject( pStringHint->GetObject() ) );
	}

	if( rHint.IsA( TYPE( SfxEventHint ) ) )
	{
		SfxEventHint* pEventHint = PTR_CAST(SfxEventHint,&rHint);
		// nur ObjectShell-bezogene Events mit Medium interessieren
		SfxObjectShell* pDocSh = pEventHint->GetObjShell();
		if( !pDocSh )
			return;

		switch ( pEventHint->GetEventId() )
		{
			case SFX_EVENT_CREATEDOC:
			{
				pDocSh->GetDocInfo().SetCreated(
					SFX_APP()->GetIniManager()->GetUserFullName());
				break;
			}
			case SFX_EVENT_CLOSEDOC:
			{
				SfxMedium *pMed = pDocSh->GetMedium();
				if( !pMed )
					return;

				// unbenannt-Docs und embedded-Docs nicht in Pickliste
				if ( !pDocSh->HasName() ||
					 SFX_CREATE_MODE_STANDARD != pDocSh->GetCreateMode() )
					return;

				SfxIniManager* pMan = SFX_INIMANAGER();

				if( !pDocSh->IsModified() &&
					pDocSh->IsReadOnly() &&
					( !pDocSh->IsAbortingImport() || (sal_uInt16)pMan->Get(
						SFX_KEY_INET_CACHEABORTED ).ToInt32() ) &&
					!pDocSh->Get_Impl()->bForbidCaching &&
					(!pMed->IsExpired() || (sal_uInt16)pMan->Get(
						SFX_KEY_INET_CACHEEXPIRED ).ToInt32()) )
				{
#if 0 //(mba)
                    if( (sal_uInt16)pMan->Get(SFX_KEY_INET_CACHEEXPIRATION).ToInt32()
							!= INET_CACHE_VERIFY_ALWAYS )
#endif
							aMemoryCache.AddObject( pDocSh );
				}
				if( pDocSh->Get_Impl()->bWaitingForPicklist &&
					!pDocSh->Get_Impl()->bIsHelpObjSh )
				{
					InsertToMenu( pDocSh );
					pDocSh->Get_Impl()->bWaitingForPicklist = sal_False;
				}
				break;
			}
		}
	}
}


