/*************************************************************************
 *
 *  $RCSfile: remote.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
//
#ifndef _REMOTE_HXX
#define _REMOTE_HXX

#include <vos/mutex.hxx>
#include <vos/module.hxx>
#include <usr/uno.hxx>

#ifndef _SMART_COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HXX_
#include <smart/com/sun/star/lang/XMultiServiceFactory.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HXX_
#include <smart/com/sun/star/lang/XSingleServiceFactory.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BRIDGE_XCONNECTCALLBACK_HXX_
#include <smart/com/sun/star/bridge/XConnectCallback.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BRIDGE_XCONNECTIONSERVERSIDE_HXX_
#include <smart/com/sun/star/bridge/XConnectionServerSide.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BRIDGE_XCONNECTIONBROKER_HXX_
#include <smart/com/sun/star/bridge/XConnectionBroker.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_BRIDGE_XCONNECTIONCLIENTSIDE_HXX_
#include <smart/com/sun/star/bridge/XConnectionClientSide.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HXX_
#include <smart/com/sun/star/loader/XImplementationLoader.hxx>
#endif
#ifndef _SMART_COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HXX_
#include <smart/com/sun/star/loader/CannotActivateFactoryException.hxx>
#endif

class RemoteManager_Impl : public UsrObject
						, public XConnectCallback
{
public:
	RemoteManager_Impl(const XMultiServiceFactoryRef & xMgr);
	~RemoteManager_Impl();

	// XInterface
	BOOL queryInterface( Uik aUik, XInterfaceRef & rOut );
	void 							acquire() 						 { UsrObject::acquire(); }
	void 							release() 						 { UsrObject::release(); }
	void* 							getImplementation(Reflection *p) { return UsrObject::getImplementation(p); }

	// XConnectCallback
	void attemptConnect(const XConnectionServerSideRef& connection)
		THROWS( (SecurityException, UsrSystemException) );
protected:
	XMultiServiceFactoryRef		m_xMgr;
	NAMESPACE_VOS( OModule ) *	pS2UDll;
	NAMESPACE_VOS( OMutex )		aMutex;
};

class PalmPilotRemoteManager_Impl : public RemoteManager_Impl
{
public:
	PalmPilotRemoteManager_Impl(const XMultiServiceFactoryRef & xMgr);

	void attemptConnect(const XConnectionServerSideRef& connection)
		THROWS( (SecurityException, UsrSystemException) );
private:
	XMultiServiceFactoryRef xOriginalMgr;
};



#endif	// _REMOTE_HXX

