/*************************************************************************
 *
 *  $RCSfile: sfxdemo.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#pragma hdrstop

#include "sfxdemo.hxx"
#include "app.hxx"

const char pDemoFileName[]="svdbt.dll";
const char pAppGroupName[]="dbtdat";
const char pSpoilString[]="TestVersion";

SV_IMPL_PTRARR(DemoAppDataArr_Impl, DemoAppDataPtr_Impl);

DemoAppData_Impl *DemoData_Impl::GetDemoData(const String& aSystemName)
{
	USHORT nCount=aDemoAppDataArr.Count();
	for(USHORT n=0;n<nCount;n++)
	{
		DemoAppData_Impl* pLineData=aDemoAppDataArr[n];
		if(aSystemName.CompareIgnoreCaseToAscii(pLineData->aSystemName)==COMPARE_EQUAL)
			return pLineData;
	}
	return 0;
}

BOOL DemoData_Impl::Save(BOOL bCreateSum)
{
	return TRUE;
}

UINT32 DemoData_Impl::CalcSum(const String &rStr) const
{
	UINT32 nSum=0;
	const USHORT nLen=rStr.Len();
	const int nStart=rStr.Search(':');
	if(nStart!=STRING_NOTFOUND)
		for(USHORT n=nStart+1;n<nLen;n++)
		{
			nSum+=rStr.GetChar(n)%'t';
			nSum+=(rStr.GetChar(n)%'l')*(UINT32)'t';
			nSum+=(rStr.GetChar(n)%'x')*(UINT32)'t'*'l';
		}
	return nSum;
}

BOOL DemoData_Impl::Load(BOOL bCheckReg)
{
	return TRUE;
}

DemoData_Impl::DemoData_Impl(BOOL bAuth, const String &rPath,
							 const String* pApp)
{
	aPath = rPath;
	BOOL bLoadErr = !Load(bAuth);
	if(bAuth) //Falls autorisiert werden soll hier streng kontrollieren
	{
		BOOL bSave=FALSE;
		USHORT nCount=aDemoAppDataArr.Count();
		for(USHORT n=0; n<nCount; n++)
		{
			DemoAppData_Impl *pLineData=aDemoAppDataArr[n];
			BOOL bIsApp = !pApp || pApp->CompareIgnoreCaseToAscii( pLineData->aSystemName ) ==
				COMPARE_EQUAL;
			if(pLineData->nCalcSum!=pLineData->nLoadSum)
			{
				pLineData->nDemoKind=SFX_DEMOKIND_INVALID;
				continue;
			}
			if(pLineData->aInvalidateDay==Date(0,0,0))
			{
				Date aDate;
				aDate+=pLineData->nDaysToRun;
				pLineData->aInvalidateDay=aDate;
				pLineData->bSaveSum=TRUE;
				bSave=TRUE;
			}
			if( pLineData->nDemoKind==SFX_DEMOKIND_TRYBUY &&
				pLineData->aInvalidateDay <= Date() && bIsApp )
			{
				pLineData->nDemoKind=SFX_DEMOKIND_OLDTRYBUY;
				pLineData->bSaveSum=TRUE;
				bSave=TRUE;
			}
			else if( pLineData->nDemoKind == SFX_DEMOKIND_OLDTRYBUY && bIsApp )
			{
				pLineData->bSaveSum=TRUE;
				pLineData->nDemoKind = SFX_DEMOKIND_INVALID;
				bSave = TRUE;
			}
			if( pLineData->nDemoKind == SFX_DEMOKIND_TRYBUY &&
				pLineData->aInvalidateDay -
				pLineData->nDaysToRun > Date() )
			{
				pLineData->nDemoKind=SFX_DEMOKIND_INVALID;
				bSave=TRUE;
			}
		}

		// Falls nicht gespeichert werden sollte oder der Spoilstring ghackt
		// wurde auf INVALID setzen

		DemoAppData_Impl *pData=GetDemoData(String::CreateFromAscii(pSpoilString));
		if( !pData || pData->nDemoKind==SFX_DEMOKIND_INVALID )
		{
			for(USHORT i=0; i<nCount; i++)
				aDemoAppDataArr[i]->nDemoKind=SFX_DEMOKIND_INVALID;
			bSave = TRUE;
		}

		if( bSave && !Save(FALSE) || bLoadErr)
			for( USHORT i=0; i<nCount; i++)
				aDemoAppDataArr[i]->nDemoKind=SFX_DEMOKIND_INVALID;
	}
	else
		Save(TRUE);

}


