/*************************************************************************
 *
 *  $RCSfile: bstritem.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// INCLUDE ---------------------------------------------------------------

#pragma hdrstop

#include "bstritem.hxx"
#include "segmentc.hxx"

// STATIC DATA -----------------------------------------------------------

SEG_EOFGLOBALS()

// ------------------------------------------------------------------------
// SfxBoolStringItem

#pragma SEG_FUNCDEF(bstritem_01)

BOOL SfxBoolStringItem::SetStringValue( const String & rVal)
{
	aVal = rVal;
	return TRUE;
}

#pragma SEG_FUNCDEF(bstritem_02)

SfxPoolItem*    SfxBoolStringItem::Clone() const
{
	return new SfxBoolStringItem(*this);
}

#pragma SEG_FUNCDEF(bstritem_03)

SfxItemType 	SfxBoolStringItem::Type() const
{
	return (SfxItemType )SFX_TYPE_BOOL_STRING;
}

#pragma SEG_FUNCDEF(bstritem_04)

int SfxBoolStringItem::operator==( const SfxPoolItem& rCmp) const
{
	return rCmp.Type() == Type() &&
		aVal == ((const SfxBoolStringItem &)rCmp).aVal &&
		SfxBoolItem::operator==(rCmp);
}


// CTOR / DTOR -----------------------------------------------------------
#pragma SEG_FUNCDEF(bstritem_05)

SfxBoolStringItem::SfxBoolStringItem( USHORT nWhich, BOOL bValue) :
	SfxBoolItem(nWhich, bValue)
{
}

#pragma SEG_FUNCDEF(bstritem_06)

SfxBoolStringItem::SfxBoolStringItem( USHORT nWhich, BOOL bValue, const String &rStr) :
	SfxBoolItem(nWhich, bValue),
	aVal(rStr)
{
}

#pragma SEG_FUNCDEF(bstritem_07)

SfxBoolStringItem::SfxBoolStringItem( const SfxBoolStringItem& rCopy) :
	SfxBoolItem(rCopy),
	aVal(rCopy.aVal)
{
}

/*------------------------------------------------------------------------

	$Log: bstritem.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:52:28  hr
	initial import
	
	Revision 1.5  2000/09/17 16:47:17  willem.vandorp
	OpenOffice header added.
	
	Revision 1.4  2000/09/06 14:49:45  willem.vandorp
	Header and footer replaced.
	
	Revision 1.3  1994/10/25 10:49:00  VB
	hdrstop
	

	  Rev 1.2   25 Oct 1994 11:49:00   VB
   hdrstop

	  Rev 1.1   22 Sep 1994 17:35:46   MI
   Undo und ItemSet immer mit Pool

	  Rev 1.0   12 Aug 1994 17:08:40   VB
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


