/*************************************************************************
 *
 *  $RCSfile: downimpl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENT_HPP_
#include <com/sun/star/ucb/XContent.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDENVIRONMENT_HPP_
#include <com/sun/star/ucb/XCommandEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDENPROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDERMANAGER_HPP_
#include <com/sun/star/ucb/XContentProviderManager.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XRESULTACCEPTOR_HPP_
#include <com/sun/star/ucb/XResultAcceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDERSERVICEREGISTRY_HPP_
#include <com/sun/star/ucb/XContentProviderServiceRegistry.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIER_HPP_
#include <com/sun/star/ucb/XContentIdentifier.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIERFACTORY_HPP_
#include <com/sun/star/ucb/XContentIdentifierFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_COMMAND_HPP_
#include <com/sun/star/ucb/Command.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_OPENCOMMANDARGUMENT_HPP_
#include <com/sun/star/ucb/OpenCommandArgument.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_OPENMODE_HPP_
#include <com/sun/star/chaos/OpenMode.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XINTERACTIONHANDLER_HPP_
#include <com/sun/star/task/XInteractionHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_CHAOSPROGRESSSTART_HPP_
#include <com/sun/star/ucb/CHAOSProgressStart.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTIESCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertiesChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTIESCHANGENOTIFIER_HPP_
#include <com/sun/star/beans/XPropertiesChangeNotifier.hpp>
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _SFXBRDCST_HXX
#include <svtools/brdcst.hxx>
#endif
#ifndef _SFXSMPLHINT_HXX
#include <svtools/smplhint.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _TRANSBND_HXX
#include <so3/transbnd.hxx>
#endif

#include <vos/thread.hxx>
#include <tools/tempfile.hxx>

#include "downimpl.hxx"
#include "streams.hxx"
#include "sfxuno.hxx"
#include "helper.hxx"

using namespace com::sun::star::chaos;
using namespace com::sun::star::beans;
using namespace com::sun::star::lang;
using namespace com::sun::star::task;
using namespace com::sun::star::ucb;
using namespace com::sun::star::uno;
using namespace com::sun::star::io;
using namespace ::cppu;
using rtl::OUString;

static void UcbRegisterConfiguration_Impl (
    const Reference< XMultiServiceFactory >   &rxFactory,
	const Reference<com::sun::star::uno::XInterface> &rxBroker)
{
	com::sun::star::uno::Reference<XContentProviderManager>
		xManager (rxBroker, com::sun::star::uno::UNO_QUERY);
	if (!xManager.is())
		return;

	com::sun::star::uno::Sequence<ContentProviderInfo>
		aProviders (xManager->queryContentProviders());
	if (aProviders.getLength())
		return;


	com::sun::star::uno::Reference<XContentProviderServiceRegistry>
		xRegistry (
			rxFactory->createInstance ( DEFINE_CONST_UNICODE("com.sun.star.ucb.Configuration") ),
			com::sun::star::uno::UNO_QUERY);
	if (!xRegistry.is())
		return;

	com::sun::star::uno::Sequence<ContentProviderServiceInfo> aServices (
		xRegistry->queryContentProviderServiceInfo (rtl::OUString()));

	sal_Int32 i, n = aServices.getLength();
	for (i = 0; i < n; i++)
	{
		com::sun::star::uno::Reference<XContentProvider> xProvider (
			rxFactory->createInstance (aServices[i].Service),
			com::sun::star::uno::UNO_QUERY);

		if (xProvider.is())
		{
			try
			{
				xManager->registerContentProvider (
					xProvider, aServices[i].Scheme, sal_False);
			}
			catch (DuplicateProviderException)
			{
			}
		}
	}
}

Reference<XContent> CreateContent( const String& rURL )
{
	Reference<XContent> xContent;
    Reference< XMultiServiceFactory > xFactory = ::utl::getProcessServiceFactory();
	if (!xFactory.is())
		return xContent;

	Reference<com::sun::star::uno::XInterface> xBroker( xFactory->createInstance( DEFINE_CONST_UNICODE("com.sun.star.ucb.UniversalContentBroker") ) );
	if (!xBroker.is())
		return xContent;

	UcbRegisterConfiguration_Impl (xFactory, xBroker);

	Reference<XContentProvider> xProvider( xBroker, UNO_QUERY );
	if ( !xProvider.is() )
		return xContent;

	Reference<XContentIdentifierFactory> xIdentProv(xProvider, UNO_QUERY);
	if (!xIdentProv.is())
		return xContent;

    String aURL( rURL );
    INetURLObject aObj( rURL );
    if ( aObj.GetProtocol() == INET_PROT_FTP && SvBinding::ShouldUseFtpProxy( rURL ) )
    {
        aURL = DEFINE_CONST_UNICODE("private:httpcache#");
        aURL += rURL;
    }

    Reference<XContentIdentifier> xIdent( xIdentProv->createContentIdentifier( aURL ) );
	if (!xIdent.is())
		return xContent;

	return xProvider->queryContent( xIdent );
}

class DownloadThread_Impl : public ::vos::OThread
{
    Link            m_aLink;
public:
                            DownloadThread_Impl( const Link& rLink )
                                : m_aLink( rLink )
                            {}

#if SUPD>590
    virtual void SAL_CALL   run();
    void    SAL_CALL        onTerminated();
#else
    virtual void            run();
    void                    onTerminated();
#endif
};

void DownloadThread_Impl::run()
{
    if( schedule() && m_aLink.IsSet() )
        m_aLink.Call(0);
}

void DownloadThread_Impl::onTerminated()
{
	delete this;
}

class DownloaderEnv_Impl :
	public SfxBroadcaster,
	public OWeakObject,
    public XCommandEnvironment,
	public XInteractionHandler,
    public XPropertiesChangeListener,
	public XProgressHandler
{
public:
	vos::OMutex							m_aMutex;
	String								m_aTmpEntry;
    Command                             m_aCommand;
	Reference<XContent>					m_xContent;
	Reference<XInteractionHandler>		m_xInteractionHdl;
	Reference <com::sun::star::io::XOutputStream>			m_xOutputStream;
	SvFileStream*						m_pStream;
	oslInterlockedCount					m_nProgressDepth;
	sal_Int32							m_nProgressAct;
	sal_Int32							m_nProgressMax;
    sal_Int32                           m_nCommandId;

										DownloaderEnv_Impl()
											: m_pStream(0)
											, m_nProgressDepth(0)
											, m_nProgressAct(0)
											, m_nProgressMax(0)
                                            , m_nCommandId(0)
										{}

										~DownloaderEnv_Impl()
										{
											SfxContentHelper::Kill( m_aTmpEntry );
										}

    DECL_LINK(                          ExecuteCallback, void* );

    void                                abort();
	void								dispose_Impl();
	BOOL								startOpenTask( Reference <XContent> );
	sal_Int32   						getActLen()
										{ return m_nProgressAct; }
	sal_Int32   						getMaxLen()
										{ return m_nProgressMax; }

										// XInterface.
	virtual Any SAL_CALL 				queryInterface( const com::sun::star::uno::Type &rType) throw(RuntimeException );
	virtual void SAL_CALL 				acquire (void) throw(RuntimeException);
	virtual void SAL_CALL 				release (void) throw(RuntimeException);

                                        // XCommandEnvironment.
	virtual Reference<XInteractionHandler> SAL_CALL getInteractionHandler (void) throw(RuntimeException);
	virtual Reference<XProgressHandler> SAL_CALL getProgressHandler (void) throw(RuntimeException);

										// XInteractionHandler.
	virtual void SAL_CALL 				handle( const Reference<XInteractionRequest> &rxRequest) throw(RuntimeException);

										// XProgressHandler.
	virtual void SAL_CALL 				push( const Any &rStatus) throw(RuntimeException );
	virtual void SAL_CALL 				update( const Any &rStatus) throw(RuntimeException);
	virtual void SAL_CALL 				pop (void) throw(RuntimeException);

                                        // XPropertiesChangeListener.
    virtual void SAL_CALL               propertiesChange ( const Sequence<PropertyChangeEvent> &rEvent) throw(RuntimeException);
	virtual void SAL_CALL 				disposing( const EventObject &rEvent) throw(RuntimeException );
};

Downloader_Impl::Downloader_Impl()
	: pEnv( 0 )
{
	pEnv = new DownloaderEnv_Impl();
	pEnv->acquire();
}

Downloader_Impl::~Downloader_Impl()
{
    if ( pEnv )
        pEnv->release();
}

SfxBroadcaster* Downloader_Impl::GetBroadcaster()
{
	return SAL_STATIC_CAST(SfxBroadcaster*, pEnv);
}

BOOL Downloader_Impl::start( const String& rURL )
{
	Reference<XContent> xContent = CreateContent( rURL );
	if ( xContent.is() )
    {
        Reference<XPropertiesChangeNotifier> xProps (xContent, UNO_QUERY);
        if ( xProps.is() )
            xProps->addPropertiesChangeListener ( Sequence<OUString>(), pEnv );
		return pEnv->startOpenTask( xContent );
    }

	return FALSE;
}

void Downloader_Impl::abort (void)
{
	if( pEnv )
		pEnv->abort();
	pEnv->release();
	pEnv = 0;
}

ErrCode Downloader_Impl::WriteToFile( const String& rURL )
{
	if ( pEnv )
        return SfxContentHelper::MoveTo( pEnv->m_aTmpEntry, rURL, NameClash::OVERWRITE ) ? FSYS_ERR_OK : ERRCODE_IO_GENERAL;
	else
		return ERRCODE_ABORT;
}

INT32 Downloader_Impl::getActLen()
{
	return pEnv ? pEnv->getActLen() : 0;
}

INT32 Downloader_Impl::getMaxLen()
{
	return pEnv ? pEnv->getMaxLen() : 0;
}

Any SAL_CALL DownloaderEnv_Impl::queryInterface( const com::sun::star::uno::Type & rType ) throw (RuntimeException)
{
	Any aRet( ::cppu::queryInterface( rType,
        SAL_STATIC_CAST(XCommandEnvironment*, this ),
        SAL_STATIC_CAST(XPropertiesChangeListener*, this),
		SAL_STATIC_CAST(XInteractionHandler*, this),
		SAL_STATIC_CAST(XProgressHandler*, this) ) );
	return (aRet.hasValue() ? aRet : OWeakObject::queryInterface( rType ));
}

/*
 * XInterface: acquire.
 */
void SAL_CALL DownloaderEnv_Impl::acquire (void) throw(RuntimeException)
{
	OWeakObject::acquire();
}

/*
 * XInterface: release.
 */
void SAL_CALL DownloaderEnv_Impl::release (void) throw(RuntimeException)
{
	OWeakObject::release();
}

/*
 * XContentTaskEnvironment: getInteractionHandler.
 */
Reference<XInteractionHandler> SAL_CALL DownloaderEnv_Impl::getInteractionHandler (void) throw(RuntimeException)
{
	return this;
}

/*
 * XContentTaskEnvironment: getProgressHandler.
 */
Reference<XProgressHandler> SAL_CALL DownloaderEnv_Impl::getProgressHandler (void) 	throw(RuntimeException)
{
	return this;
}

/*
 * XEventListener: disposing.
 */
void SAL_CALL DownloaderEnv_Impl::disposing ( const EventObject &rEvent) throw(RuntimeException)
{
	vos::OGuard aGuard (m_aMutex);
	if ( rEvent.Source == m_xContent )
		dispose_Impl();
}

/*
 * XInteractionHandler: handle.
 */
void SAL_CALL DownloaderEnv_Impl::handle( const Reference<XInteractionRequest> &rxRequest) throw(RuntimeException)
{
	vos::OGuard aGuard (m_aMutex);
	if (!m_xInteractionHdl.is())
    {
        Reference< XMultiServiceFactory > xFactory = ::utl::getProcessServiceFactory();
        m_xInteractionHdl = Reference< XInteractionHandler > (
                xFactory->createInstance( DEFINE_CONST_UNICODE("com.sun.star.uui.InteractionHandler") ), UNO_QUERY );
    }

	m_xInteractionHdl->handle (rxRequest);
}

/*
 * XProgressHandler: push.
 */
void SAL_CALL DownloaderEnv_Impl::push ( const Any &rStatus) throw(RuntimeException )
{
	vos::OGuard aGuard (m_aMutex);
	if( osl_incrementInterlockedCount (&m_nProgressDepth) == 1 )
	{
		CHAOSProgressStart aStart;
		if (rStatus >>= aStart)
			m_nProgressMax = aStart.Maximum - aStart.Minimum;
	}
}

/*
 * XProgressHandler: update.
 */
void SAL_CALL DownloaderEnv_Impl::update ( 	const Any &rStatus) throw(RuntimeException)
{
	vos::OGuard aGuard (m_aMutex);
	if( m_nProgressDepth == 1 )
	{
		sal_Int32 nProgress = 0;
		if ( (rStatus >>= nProgress) && (nProgress > 0) )
		{
			m_nProgressAct = nProgress;
			Broadcast( SfxSimpleHint( SFX_HINT_DATAAVAILABLE ) );
		}
	}
}

/*
 * XProgressHandler: pop.
 */
void SAL_CALL DownloaderEnv_Impl::pop (void) throw(RuntimeException)
{
	vos::OGuard aGuard (m_aMutex);
	osl_decrementInterlockedCount( &m_nProgressDepth );
	m_nProgressAct = m_nProgressMax;
}

BOOL DownloaderEnv_Impl::startOpenTask( Reference<XContent> xContent )
{
	m_xContent = xContent;
    Reference<XCommandProcessor> xProcessor (m_xContent, UNO_QUERY);
	if (!xProcessor.is())
		return FALSE;

    m_aCommand.Name = OUString::createFromAscii ("open");
    m_aCommand.Handle = -1;

	TempFile aTempFile;
	m_aTmpEntry = aTempFile.GetName();
	m_pStream = new SvFileStream( m_aTmpEntry, STREAM_STD_READWRITE );

	m_xOutputStream = new OutputStream_Impl( m_pStream );
	OpenCommandArgument aArgument;
	aArgument.Mode = OpenMode::ALL;
	aArgument.Sink = Reference <XInterface> ( m_xOutputStream, UNO_QUERY );
    m_aCommand.Argument <<= aArgument;

    m_nCommandId = xProcessor->createCommandIdentifier();
    DownloadThread_Impl *pThread = new DownloadThread_Impl( LINK( this, DownloaderEnv_Impl, ExecuteCallback ) );
    pThread->create();
    return TRUE;
}

IMPL_LINK( DownloaderEnv_Impl, ExecuteCallback, void*, pVoid )
{
	vos::OGuard aGuard (m_aMutex);
    Reference<XCommandProcessor> xProcessor (m_xContent, UNO_QUERY);
    if ( xProcessor.is() && m_nCommandId )
    {
        Reference< XCommandEnvironment > xThis( this );
        BOOL bAborted=FALSE, bException=FALSE;
        try
        {
            // do it
            xProcessor->execute( m_aCommand, m_nCommandId, this );
        }
        catch ( CommandAbortedException )
        {
            bAborted = true;
        }
        catch ( Exception )
        {
            bException = true;
        }

        m_nCommandId = 0;
        if ( !bAborted && !bException )
            Broadcast( SfxSimpleHint( SFX_HINT_SAVECOMPLETED ) );
    }

    dispose_Impl();
    return 0;
}

void DownloaderEnv_Impl::abort()
{
	vos::OGuard aGuard (m_aMutex);
    if ( m_nCommandId )
    {
        m_nCommandId = 0;
        Reference<XCommandProcessor> xProcessor( m_xContent, UNO_QUERY );
        xProcessor->abort( m_nCommandId );
    }
}

void DownloaderEnv_Impl::dispose_Impl (void)
{
	vos::OGuard aGuard (m_aMutex);

    Reference<XPropertiesChangeNotifier> xProps (m_xContent, UNO_QUERY);
	if (xProps.is())
		xProps->removePropertiesChangeListener (Sequence<OUString>(), this);

	m_xContent = NULL;
	m_nProgressDepth = 0;
	m_xOutputStream = NULL;
}

void SAL_CALL DownloaderEnv_Impl::propertiesChange( const Sequence<PropertyChangeEvent> &rEvent ) throw(RuntimeException)
{
	sal_Int32 i, n = rEvent.getLength();
	for (i = 0; i < n; i++)
	{
		PropertyChangeEvent evt (rEvent[i]);
		if (evt.PropertyName == OUString::createFromAscii ("PresentationURL"))
        {
			OUString aUrl;
			if (evt.NewValue >>= aUrl)
			{
				OUString aBad (OUString::createFromAscii ("private:"));
				if (!(aUrl.compareTo (aBad, aBad.getLength()) == 0))
                {
                    vos::OGuard aGuard (m_aMutex);
                    m_pStream->Seek(0);
                    m_pStream->SetStreamSize( 0 );
                }
            }

            break;
        }
	}
}


