/*************************************************************************
 *
 *  $RCSfile: fltdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// INCLUDE ---------------------------------------------------------------

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SFXPOOLITEM_HXX //autogen
#include <svtools/poolitem.hxx>
#endif
#pragma hdrstop

#include "fltfnc.hxx"
#include "fltdlg.hxx"
#include "docfilt.hxx"
#include "sfxresid.hxx"
#include "app.hxx"
#include "docfile.hxx"

#include "bastyp.hrc"
#include "fltdlg.hrc"

// -----------------------------------------------------------------------

SfxFilterDialog::SfxFilterDialog
(
	Window* pParent,
	SfxMedium* pMed,
	const SfxFilterMatcher& rMatcherP,
	const String* pDefFilter,
	BOOL bShowConvert
) :

	ModalDialog( pParent, SfxResId( DLG_FILTER_SELECT ) ),

	aListbox	( this, ResId( LB_DLG_LISTBOX ) ),
	aOkBtn		( this, ResId( LB_DLG_OKBTN ) ),
	aCancelBtn	( this, ResId( LB_DLG_CANCELBTN ) ),
	aHelpBtn	( this, ResId( BTN_HELP ) ),
	aGroupFrm	( this, ResId( LB_DLG_GROUPFRM ) ),
	aGroupType	( this, ResId( GB_DLG_GROUPTYPE ) ),
	aMIMEType	( this, ResId( FT_DLG_MIMETYPE ) ),
	aExtension	( this, ResId( FT_DLG_EXTENSTION ) ),

	rMatcher	( rMatcherP ),
	aDefFilter	( rMatcherP.GetDefaultFilter()->GetName() )

{
	const short nExtra = *(short*)GetClassRes();
	IncrementRes(sizeof(short));
	FreeResource();

	String aMimeText( aMIMEType.GetText() );
	String aMime;
	pMed->GetMIMEAndRedirect( aMime );
	aMimeText += aMime;
	aMIMEType.SetText( aMimeText );
	String aExtensionText( aExtension.GetText() );
	aExtensionText += pMed->GetURLObject().GetExtension();
	aExtension.SetText( aExtensionText );

	aListbox.SetDoubleClickHdl(LINK(this, SfxFilterDialog, OkHdl));
	SfxFilterMatcherIter aIter(
		&rMatcher, SFX_FILTER_IMPORT,
		SFX_FILTER_INTERNAL|SFX_FILTER_NOTINCHOOSER );
	for( const SfxFilter* pFilter = aIter.First(); pFilter;
		 pFilter = aIter.Next() )
		aListbox.InsertEntry( pFilter->GetUIName() );
	if ( pDefFilter )
		aListbox.SelectEntry(*pDefFilter);
	else
		aListbox.SelectEntryPos( aListbox.GetEntryCount()-1 );
}

//-------------------------------------------------------------------------

String SfxFilterDialog::GetSelectEntry()  const
{
	return aListbox.GetSelectEntry();
}
//-------------------------------------------------------------------------

IMPL_LINK_INLINE_START( SfxFilterDialog, OkHdl, Control *, pControl )
{
	EndDialog(RET_OK);
	return 0;
}
IMPL_LINK_INLINE_END( SfxFilterDialog, OkHdl, Control *, pControl )


