/*************************************************************************
 *
 *  $RCSfile: saveopt.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _STREAM_HXX //autogen
#include <tools/stream.hxx>
#endif
#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _HELP_HXX //autogen
#include <vcl/help.hxx>
#endif
#pragma hdrstop

#include "app.hxx"
#include "inimgr.hxx"
#include "saveopt.hxx"

// -----------------------------------------------------------------------

#define SFX_OPTIONS_VER 10
#define MEM_CACHE 		2
#define DISK_CACHE  	1024

// -----------------------------------------------------------------------

int  SfxOptions::Load(SvStream &rStream)
{
	USHORT nFileVersion;
	rStream >> nFileVersion;
	if ( nFileVersion > SFX_OPTIONS_VER )
		return SfxConfigItem::WARNING_VERSION;

	rStream >> nAutoSaveTime;
	if ( nFileVersion >= 4 )
		rStream >> nUndoActions;
	unsigned char cIn;
	rStream >> cIn; bBackup = cIn;
	rStream >> cIn; bAutoSave = cIn;
	rStream >> cIn; bDocInfSave = cIn;
	rStream >> cIn; bIndepGrfFmt = cIn;
	rStream >> cIn; bAutoSavePrompt = cIn;
	rStream >> cIn; bSaveWorkingSet = cIn;
	rStream >> cIn; bHelpBalloons = cIn;
	rStream >> cIn; bHelpTips = cIn;
	USHORT nIn;
	rStream >> nIn; SetMetric_Impl( (FieldUnit) nIn, TRUE );
	rStream.ReadByteString(aDocMgrConfig);
	if ( nFileVersion >= 5 )
	{
		rStream >> cIn; pImp->bSaveDocWins = cIn;
		rStream >> cIn; pImp->bSaveDocView = cIn;
	}
	else
	{
		pImp->bSaveDocWins = FALSE;
		pImp->bSaveDocView = FALSE;
	}
	if ( nFileVersion >= 7 )
	{
		rStream >> cIn; pImp->bSaveRelINet = cIn;
		rStream >> cIn; pImp->bSaveRelFSys = cIn;
	}
	else
	{
		pImp->bSaveRelINet = TRUE;
		pImp->bSaveRelFSys = TRUE;
	}

	if ( nFileVersion >= 8 )
	{
		rStream >> cIn; pImp->bAutoHelpAgent = cIn;
	}
	else
	{
		pImp->bAutoHelpAgent = TRUE;
	}

	if ( nFileVersion >= 9 )
	{
		rStream >> cIn; pImp->bSaveGrfCompr = cIn;
	}
	else
		pImp->bSaveGrfCompr = FALSE;

	if ( nFileVersion >= 10 )
	{
		rStream >> cIn; pImp->bSaveGrfOrig = cIn;
	}
	else
		pImp->bSaveGrfOrig = FALSE;

	if ( nFileVersion >= 10 )
	{
		rStream >> cIn; pImp->bWelcomeScreen = cIn;
	}
	else
	{
		pImp->bWelcomeScreen = TRUE;
	}


	if ( SVSTREAM_OK == rStream.GetError() )
	{
		if ( bHelpBalloons )
			Help::EnableBalloonHelp();
		else
			Help::DisableBalloonHelp();

		if ( bHelpTips )
			Help::EnableQuickHelp();
		else
			Help::DisableQuickHelp();

		return SfxConfigItem::ERR_OK;
	}
	return SfxConfigItem::ERR_READ;
}

// -----------------------------------------------------------------------

BOOL SfxOptions::Store(SvStream &rStream)
{
	const unsigned char cOff = 0, cOn = 1;
	rStream << (USHORT) SFX_OPTIONS_VER << nAutoSaveTime;
	rStream << nUndoActions;
	rStream << (unsigned char)(bBackup? cOn: cOff);
	rStream << (unsigned char)(bAutoSave? cOn: cOff);
	rStream << (unsigned char)(bDocInfSave ? cOn: cOff);
	rStream << (unsigned char)(bIndepGrfFmt ? cOn: cOff);
	rStream << (unsigned char)(bAutoSavePrompt ? cOn: cOff);
	rStream << (unsigned char)(bSaveWorkingSet? cOn: cOff);
	rStream << (unsigned char)(bHelpBalloons? cOn: cOff);
	rStream << (unsigned char)(bHelpTips? cOn: cOff);
	USHORT nOut = (USHORT) eMetric;
	rStream << nOut;
	rStream.WriteByteString(aDocMgrConfig);
	rStream << (unsigned char)(pImp->bSaveDocWins? cOn: cOff);
	rStream << (unsigned char)(pImp->bSaveDocView? cOn: cOff);
	rStream << (unsigned char)(pImp->bSaveRelINet? cOn: cOff);
	rStream << (unsigned char)(pImp->bSaveRelFSys? cOn: cOff);
	rStream << (unsigned char)(pImp->bAutoHelpAgent? cOn: cOff);
	rStream << (unsigned char)(pImp->bSaveGrfCompr? cOn: cOff);
	rStream << (unsigned char)(pImp->bSaveGrfOrig? cOn: cOff);
	rStream << (unsigned char)(pImp->bWelcomeScreen ? cOn: cOff);
	return SVSTREAM_OK == rStream.GetError();
}

// -----------------------------------------------------------------------

void SfxOptions::UseDefault()
{
	nAutoSaveTime = 15;
	nUndoActions = 20;
	bBackup = FALSE;
	bAutoSave = FALSE;
	bDocInfSave = FALSE;
	bIndepGrfFmt = TRUE;
	bAutoSavePrompt = TRUE;
	bSaveWorkingSet = FALSE;
	bHelpBalloons = FALSE;
	bHelpTips = TRUE;
	SetMetric( MEASURE_US == Application::GetAppInternational().GetMeasurementSystem()
						? FUNIT_INCH
						: FUNIT_CM );
	aDocMgrConfig.Erase();
	pImp->bSaveDocWins = FALSE;
	pImp->bSaveDocView = TRUE;
	pImp->bSaveRelINet = TRUE;
	pImp->bSaveRelFSys = TRUE;
	pImp->bAutoHelpAgent = TRUE;
	pImp->bWelcomeScreen = TRUE;
	pImp->bSaveGrfCompr = TRUE;
	pImp->bSaveGrfOrig = TRUE;

	SfxConfigItem::UseDefault();

	Help::DisableBalloonHelp();
	Help::EnableQuickHelp();
}

// -----------------------------------------------------------------------

SfxOptions::SfxOptions() :
	SfxConfigItem(SFX_ITEMTYPE_OPTIONS),
	pImp(new SfxOptions_Impl)
{
}

// -----------------------------------------------------------------------

SfxOptions::~SfxOptions()
{
	delete pImp;
}

// -----------------------------------------------------------------------

void SfxOptions::SetMetric(FieldUnit e)
{
	SetMetric_Impl( e, FALSE );
}

// -----------------------------------------------------------------------

void SfxOptions::SetMetric_Impl(FieldUnit e, BOOL bLoading )
{
	eMetric = e;
	if ( !bLoading )
		SetDefault(FALSE);

	// MapUnit aus FieldUnit umrechnen
	if ( eMetric == FUNIT_MM )
		pImp->eUserMetric = SFX_MAPUNIT_MM;
	else if ( eMetric == FUNIT_CM )
		pImp->eUserMetric = SFX_MAPUNIT_CM;
	else if ( eMetric == FUNIT_INCH )
		pImp->eUserMetric = SFX_MAPUNIT_INCH;
	else if ( eMetric == FUNIT_TWIP )
		pImp->eUserMetric = SFX_MAPUNIT_TWIP;
	else if ( eMetric == FUNIT_POINT )
		pImp->eUserMetric = SFX_MAPUNIT_POINT;
	else
		pImp->eUserMetric = SFX_MAPUNIT_CM;
}

// -----------------------------------------------------------------------

SfxMapUnit SfxOptions::GetUserMetric() const
{
	return pImp->eUserMetric;
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveOriginalGraphics(BOOL b)
{
	pImp->bSaveGrfOrig = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveOriginalGraphics() const
{
	return pImp->bSaveGrfOrig;
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveGraphicsCompressed(BOOL b)
{
	pImp->bSaveGrfCompr = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveGraphicsCompressed() const
{
	return pImp->bSaveGrfCompr;
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveDocWins() const
{
	return pImp->bSaveDocWins;
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveDocWins( BOOL b )
{
	pImp->bSaveDocWins = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveDocView() const
{
	return pImp->bSaveDocView;
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveDocView( BOOL b )
{
	pImp->bSaveDocView = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsAutoHelpAgent() const
{
	return pImp->bAutoHelpAgent;
}

// -----------------------------------------------------------------------

void SfxOptions::SetAutoHelpAgent( BOOL b )
{
	pImp->bAutoHelpAgent = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsWelcomeScreen() const
{
	return pImp->bWelcomeScreen;
}

// -----------------------------------------------------------------------

void SfxOptions::SetWelcomeScreen( BOOL b )
{
	pImp->bWelcomeScreen = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveRelINet( BOOL b )
{
	pImp->bSaveRelINet = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveRelINet() const
{
	return pImp->bSaveRelINet;
}

// -----------------------------------------------------------------------

void SfxOptions::SetSaveRelFSys( BOOL b )
{
	pImp->bSaveRelFSys = b;
	SetDefault(FALSE);
}

// -----------------------------------------------------------------------

BOOL SfxOptions::IsSaveRelFSys() const
{
	return pImp->bSaveRelFSys;
}


