/*************************************************************************
 *
 *  $RCSfile: dlgcfg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// INCLUDE ---------------------------------------------------------------

#pragma hdrstop

#include "dlgcfg.hxx"
#include "segmentc.hxx"


// STATIC DATA -----------------------------------------------------------

SEG_EOFGLOBALS()

#pragma SEG_FUNCDEF(dlgcfg_01)

int SfxDialogConfig::Load(SvStream &rStream)
{
	USHORT X, Y;
	rStream >> X;
	rStream >> Y;
	aDlgPos = Point(X, Y);
	rStream >> nPage;
	return ERR_OK;
}

#pragma SEG_FUNCDEF(dlgcfg_02)

BOOL SfxDialogConfig::Store(SvStream &rStream)
{
	rStream << aDlgPos.X() << aDlgPos.Y() << nPage;
	return TRUE;
}


#pragma SEG_FUNCDEF(dlgcfg_03)

SfxDialogConfig::SfxDialogConfig(USHORT nType):
	SfxConfigItem(nType),
	aDlgPos(0xffff, 0xffff),
	nPage(1)
{
}

/*------------------------------------------------------------------------

	$Log: dlgcfg.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:52:30  hr
	initial import
	
	Revision 1.9  2000/09/17 16:47:22  willem.vandorp
	OpenOffice header added.
	
	Revision 1.8  2000/09/06 14:49:49  willem.vandorp
	Header and footer replaced.
	
	Revision 1.7  1995/11/03 17:47:24  MH
	301-Aenderungen
	

	  Rev 1.6   03 Nov 1995 18:47:24   MH
   301-Aenderungen

	  Rev 1.5   06 Jul 1995 18:09:54   OG
   segmentierung

	  Rev 1.4   10 Feb 1995 07:34:16   MI
   bin?strm raus

	  Rev 1.3   25 Oct 1994 11:54:18   VB
   hdrstop

	  Rev 1.2   10 Oct 1994 10:07:46   VB
   Type durch Applikation setzen, SetDefault(FALSE)

	  Rev 1.1   04 Oct 1994 16:47:36   MI
   SvStream

	  Rev 1.0   04 Oct 1994 10:16:10   VB
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


