/*************************************************************************
 *
 *  $RCSfile: compdoc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif

#pragma hdrstop

#include "compdoc.hxx"
#include "fcontnr.hxx"
#include "app.hxx"

#include "msg.hxx"
#include "sfx.hrc"
#include "sfxsids.hrc"
#include "objface.hxx"
#include "objshimp.hxx"

#define SfxComponentObjectShell
#include "sfxslots.hxx"

TYPEINIT1(SfxComponentObjectShell, SfxObjectShell);

SFX_IMPL_INTERFACE(SfxComponentObjectShell,SfxShell,ResId(0,0))
{
}

//=========================================================================

SFX_IMPL_SIMPLE_OBJECTFACTORY( SfxComponentObjectShell, SFXOBJECTSHELL_STD_SPECIAL | SFXOBJECTSHELL_HASMENU, Component )
{
	// Registration der Filter
	String aEmpty;
	SFX_SIMPLE_FILTER_REGISTRATION(
		DEFINE_CONST_UNICODE( "dummy" ), aEmpty,
		SFX_FILTER_CREATOR | SFX_FILTER_IMPORT |
		SFX_FILTER_NOTINFILEDLG | SFX_FILTER_NOTINCHOOSER,
		0, aEmpty, aEmpty, 0, aEmpty, aEmpty );

	Factory().RegisterHelpFile( String() );
	Factory().RegisterHelpPIFile( String() );
}

//------------------------------------------------------------------

SfxComponentObjectShell::SfxComponentObjectShell(SfxObjectCreateMode eMode) :
	SfxObjectShell(eMode)
{
	SetPool(&SFX_APP()->GetPool());
	SetHasName();
	Get_Impl()->bSupportsEventMacros = FALSE;
}

//------------------------------------------------------------------

SfxComponentObjectShell::~SfxComponentObjectShell()
{
}


