/*************************************************************************
 *
 *  $RCSfile: notes.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _LIBCALL_HXX //autogen
#include <svtools/libcall.hxx>
#endif
#pragma hdrstop

#include "app.hxx"
#include "appdata.hxx"
#include "notes.hxx"

//=========================================================================

#define NOTES_DOCINFO_CLIP_FORMAT "NotesDocInfo"
#define NOTES_HNOTE_CLIP_FORMAT   "NoteshNote"

//=========================================================================

class NotesData
{
public:
	ULONG                   nDocInfoFormat;
	ULONG                   nHNoteFormat;
	ULONG                   nNativeFormat;
	NotesLibrary*           pLibrary;
	NotesData()
	{
		nNativeFormat = nHNoteFormat = nDocInfoFormat = 0;
		pLibrary = 0;
	}
	static NotesData* GetData();
};

#define NDATA (*NotesData::GetData())

//=========================================================================

NotesData *NotesData::GetData()
{
	NotesData *&rpNotes = SFX_APP()->Get_Impl()->pNotesData;
	if( !rpNotes )
		rpNotes = new NotesData();
	return rpNotes;
}

//=========================================================================

ULONG NotesLibrary::GetDocInfoId()
{
	ULONG &rId = NDATA.nDocInfoFormat;
	if( !rId )
		rId = Exchange::RegisterFormatName(
			NOTES_DOCINFO_CLIP_FORMAT );
	return rId;
}

//=========================================================================

ULONG NotesLibrary::GetHNoteId()
{
	ULONG &rId = NDATA.nHNoteFormat;
	if( !rId )
		rId = Exchange::RegisterFormatName(
			NOTES_HNOTE_CLIP_FORMAT );
	return rId;
}

//=========================================================================

ULONG NotesLibrary::GetNativeId()
{
	ULONG &rId = NDATA.nNativeFormat;
	if( !rId )
		rId = Exchange::RegisterFormatName(
			"Native" );
	return rId;
}

//=========================================================================

NotesLibrary::NotesLibrary()
{
	String aName( "lnt" );
	aName += SOLARUPD;
	aName += __DLLEXTENSION;
#ifdef WIN
	aName += ".DLL";
#endif

	pLibrary = new Library( aName );
	pINotesLibrary = 0;
	if( pLibrary->ModulFound() )
	{
		typedef INotesLibrary* (*func)();
#if defined WIN || defined OS2
		func pFunc = (func) pLibrary->GetFunction( "_CREATELIBRARY" );
#else
		func pFunc = (func) pLibrary->GetFunction( "CREATELIBRARY" );
#endif
		pINotesLibrary = (*pFunc)();
	}
}

//=========================================================================

NotesLibrary::~NotesLibrary()
{
	delete pINotesLibrary;
	delete pLibrary;
}

//=========================================================================

INotesLibrary* NotesLibrary::GetLibrary()
{
	NotesLibrary *& rpLib = NDATA.pLibrary;
	if( !rpLib )
		rpLib = new NotesLibrary;
	return rpLib->pINotesLibrary;
}

//=========================================================================

void NotesLibrary::Dispose()
{
	NotesLibrary *& rpLib = NDATA.pLibrary;
	DELETEZ( rpLib );
}


