/*************************************************************************
 *
 *  $RCSfile: expfile.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------

#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _SV_SYSTEM_HXX //autogen
#include <vcl/system.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#pragma hdrstop

#if defined( OS2 ) || defined( MAC )
#ifndef _EXTATTR_HXX //autogen
#include <svtools/extattr.hxx>
#endif
#endif

#include "sfx.hrc"
#include "explorer.hrc"

#include "app.hxx"
#include "explorer.hxx"
#include "expfile.hxx"
#include "docfile.hxx"
#include "objsh.hxx"
#include "docfac.hxx"
#include "fltfnc.hxx"
#include "openflag.hxx"
#include "inimgr.hxx"
#include "sfxresid.hxx"
#include "helper.hxx"

// globals *******************************************************************

//****************************************************************************
// SfxExtensionResIdMapping_Impl
//****************************************************************************

/*	[Beschreibung]

	Instanzen dieser Klasse repraesentieren eine Zuordnung von Dateiendungen zu einer Resourcen-Id.
*/

struct SfxExtensionResIdMapping_Impl
{
	char*	_pExt;
	BOOL	_bExt;
	USHORT	_nStrId;
	USHORT	_nImgId;
};

//****************************************************************************
// DescriptionMap_Impl
//****************************************************************************

/*	[Beschreibung]

	Dieser Array enth"alt alle Zuordnungen von Dateiendungen zu Beschreibungen und Images.

	[Querverweise]
	<String SfxExplorerFile::GetDescription( const INetURLObject& rObject )>
*/

static SfxExtensionResIdMapping_Impl __READONLY_DATA ExtensionMap_Impl[] =
{
	// "fld",       0,                             IMG_SFX_EXP_FOLDER,
	"awk",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"bas",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
#ifndef WNT
	"bat",   TRUE,  STR_SFX_BATCHFILE,             IMG_SFX_EXP_APP,
#endif
	"bmk",   FALSE, STR_SFX_BOOKMARKFILE,          0,
	"bmp",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_BITMAP,
	"c",     TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"cfg",   FALSE, STR_SFX_CFGFILE,               0,
#ifndef WNT
	"cmd",   TRUE,  STR_SFX_BATCHFILE,             IMG_SFX_EXP_APP,
#endif
	"cob",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"com",   TRUE,  STR_SFX_APPLICATION,           IMG_SFX_EXP_APP,
	"cxx",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"dbf",   TRUE,  STR_SFX_DATABASE_TABLE,        IMG_SFX_EXP_TABLE,
	"def",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"dll",   TRUE,  STR_SFX_SYSFILE,               0,
	"doc",   FALSE, STR_SFX_WORD_DOC,              IMG_SFX_EXP_WORD,
	"dxf",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_DXF,
#ifndef WNT
	"exe",   TRUE,  STR_SFX_APPLICATION,           IMG_SFX_EXP_APP,
#endif
	"gif",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_GIF,
	"h",     TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"hlp",   FALSE, STR_SFX_HELP_DOC,              IMG_SFX_EXP_HELP,
	"hrc",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"htm",   FALSE, STR_SFX_HTMLFILE,              IMG_SFX_EXP_HTML,
	"html",  FALSE, STR_SFX_HTMLFILE,              IMG_SFX_EXP_HTML,
	"asp",   FALSE, STR_SFX_HTMLFILE,              IMG_SFX_EXP_HTML,
	"hxx",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"ini",   FALSE, STR_SFX_CFGFILE,               0,
	"java",  TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"jpeg",  TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_JPG,
	"jpg",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_JPG,
	"lha",   TRUE,  STR_SFX_ARCHIVFILE,            0,
#ifdef WNT
	"lnk",   FALSE, 0,                  			0,
#endif
	"log",   TRUE,  STR_SFX_LOGFILE,               0,
	"lst",   TRUE,  STR_SFX_LOGFILE,               0,
	"met",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_MET,
	"mod",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"pas",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"pcd",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_PCD,
	"pct",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_PCT,
	"pcx",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_PCX,
	"pl",    TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"png",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_PNG,
	"rar",   TRUE,  STR_SFX_ARCHIVFILE,            0,
	"sbl",   FALSE, 0,                             IMG_SFX_EXP_MACROLIB,
	"scc",   FALSE, STR_SFX_MAILSRV_INBOX,         IMG_SFX_EXP_MAILSERVER,
	"sch",   FALSE, STR_SFX_SCHART_DOC,            0,
	"sda",   FALSE, STR_SFX_SDRAW_DOC,             IMG_SFX_EXP_DRAW,
	"sdb",   FALSE, 0,                             IMG_SFX_EXP_DATABASE,
	"sdc",   FALSE, STR_SFX_SCALC_DOC,             IMG_SFX_EXP_CALC,
	"sdd",   FALSE, STR_SFX_SIMPRESS_DOC,          IMG_SFX_EXP_IMPRESS,
	"sds",   FALSE, STR_SFX_SCHART_DOC,            IMG_SFX_EXP_CHART,
	"sdw",   FALSE, STR_SFX_SWRITER_DOC,           IMG_SFX_EXP_WRITER,
	"sfs",   FALSE, STR_SFX_SOFFICE_FRAMESET_DOC,  IMG_SFX_EXP_FRAMESET,
	"sga",   FALSE, 0,                             IMG_SFX_EXP_GALLERY,
	"sgf",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_SGF,
	"sgl",   FALSE, STR_SFX_GLOBALDOC,             IMG_SFX_EXP_GLOBAL_DOC,
	"sgv",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_SGV,
	"shtml", FALSE, STR_SFX_HTMLFILE,              IMG_SFX_EXP_HTML,
	"sim",   FALSE, STR_SFX_SIMAGE_DOC,            IMG_SFX_EXP_SIM,
	"smd",   FALSE, 0,                             IMG_SFX_EXP_MESSAGE,
	"sdm",   FALSE, 0,                             IMG_SFX_EXP_MESSAGE,
	"smf",   FALSE, STR_SFX_SMATH_DOC,             IMG_SFX_EXP_MATH,
	"src",   TRUE,  STR_SFX_SOURCEFILE,            IMG_SFX_EXP_TEXTFILE,
	"svh",   FALSE, STR_SFX_HELP_DOC,              IMG_SFX_EXP_SVHELP,
	"svm",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_SVM,
	"sys",   TRUE,  STR_SFX_SYSFILE,               0,
	"tif",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_TIFF,
	"tiff",  TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_TIFF,
	"txt",   FALSE, STR_SFX_TEXTFILE,              IMG_SFX_EXP_TEXTFILE,
	"url",   FALSE, STR_SFX_LINK,                  IMG_SFX_EXP_HTML,
	"vor",   FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC,  IMG_SFX_EXP_WRITERTEMPLATE,
	"vxd",   TRUE,  STR_SFX_SYSFILE,               0,
	"wmf",   TRUE,  STR_SFX_GRAPHIC_DOC,           IMG_SFX_EXP_WMF,
	"xls",   FALSE, STR_SFX_EXCEL_DOC,             IMG_SFX_EXP_EXCEL,
	"xlt",   FALSE, STR_SFX_EXCEL_TEMPLATE_DOC,    IMG_SFX_EXP_EXCELTEMPLATE,
	"uu",    TRUE,  STR_SFX_ARCHIVFILE,            0,
	"uue",   TRUE,  STR_SFX_ARCHIVFILE,            0,
	"z",     TRUE,  STR_SFX_ARCHIVFILE,            0,
	"zip",   TRUE,  STR_SFX_ARCHIVFILE,            0,
	"zoo",   TRUE,  STR_SFX_ARCHIVFILE,            0,
	"gz",    TRUE,  STR_SFX_ARCHIVFILE,            0,
	0, FALSE, 0, 0
};

#ifdef MAC
	SfxExtensionResIdMapping_Impl Mappings[] =
	{
		"SW/0", FALSE, STR_SFX_SWRITER_DOC, 	IMG_SFX_EXP_WRITER,
		"SVsa0", FALSE, STR_SFX_SDRAW_DOC,		IMG_SFX_EXP_DRAW,
		"SVsd0", FALSE, STR_SFX_SIMPRESS_DOC,	IMG_SFX_EXP_IMPRESS,
		"SVsc0", FALSE, STR_SFX_SCALC_DOC,		IMG_SFX_EXP_CALC,
		"SVch0", FALSE, STR_SFX_SCHART_DOC,		IMG_SFX_EXP_CHART,
		"SVsm0", FALSE, STR_SFX_SMATH_DOC,		IMG_SFX_EXP_MATH,
		"sW/1", FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC, IMG_SFX_EXP_WRITERTEMPLATE,
		"sVsa1", FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC, IMG_SFX_EXP_DRAWTEMPLATE,
		"sVsd1", FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC, IMG_SFX_EXP_IMPRESSTEMPLATE,
		"sVsc1", FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC, IMG_SFX_EXP_CALCTEMPLATE,
		"sVsm1", FALSE, STR_SFX_SOFFICE_TEMPLATE_DOC, IMG_SFX_EXP_MATHTEMPLATE,
		"BMPp0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_BITMAP,
		"DXFl0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"GIFf0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_GIF,
		"JPEG0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_JPG,
		"MET 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"PCD 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCD,
		"PICT0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCT,
		"PCX 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCX,
		"PNG 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"SVM 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"TIFF0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_TIFF,
		"WMF 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_WMF,
		"XBM 0", FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_BITMAP,
		NULL, 0
	};
#endif
#ifdef OS2
	SfxExtensionResIdMapping_Impl Mappings[] =
	{
		"StarWriter 4.0", 	        FALSE, STR_SFX_SWRITER_DOC,	IMG_SFX_EXP_WRITER,
		"StarWriter 3.0", 	        FALSE, STR_SFX_SWRITER_DOC,	IMG_SFX_EXP_WRITER,
		"StarCalc 4.0", 	        FALSE, STR_SFX_SCALC_DOC,	IMG_SFX_EXP_CALC,
		"StarCalc 3.0", 	        FALSE, STR_SFX_SCALC_DOC,	IMG_SFX_EXP_CALC,
		"StarImpress 4.0", 	        FALSE, STR_SFX_SIMPRESS_DOC,IMG_SFX_EXP_IMPRESS,
		"StarDraw 4.0", 	        FALSE, STR_SFX_SDRAW_DOC,	IMG_SFX_EXP_DRAW,
		"StarDraw 3.0", 	        FALSE, STR_SFX_SDRAW_DOC,	IMG_SFX_EXP_DRAW,
		"StarChart 3.0",            FALSE, STR_SFX_SCHART_DOC,  IMG_SFX_EXP_CHART,
		"StarChart 4.0",            FALSE, STR_SFX_SCHART_DOC,  IMG_SFX_EXP_CHART,
		"Bitmap", 			        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_BITMAP,
		"AutoCAD", 			        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"Gif-File", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_GIF,
		"JPEG-File", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_JPG,
		"Metafile ", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"Photo-CD ", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCD,
		"Mac Pict", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCT,
		"PCX-File ", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_PCX,
		"PNG-File", 		        FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"SV-Metafile", 				FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_SIM,
		"TIFF-File", 				FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_TIFF,
		"MS-Metafile", 				FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_WMF,
		"XBM-File", 				FALSE, STR_SFX_GRAPHIC_DOC,	IMG_SFX_EXP_BITMAP,
		"UniformResourceLocator", 	FALSE, STR_SFX_LINK,		IMG_SFX_EXP_URL,
		NULL, 0
	};
#endif

//****************************************************************************
// SfxFactoryMapping_Impl
//****************************************************************************

/*  [Beschreibung]

	Instanzen dieser Klasse repraesentieren eine Zuordnung von Factories zu Dateiendungen.
*/

struct SfxFactoryMapping_Impl
{
	char*   _pFac;
	char*   _pExt;
};

static SfxFactoryMapping_Impl __READONLY_DATA FactoryMap_Impl[] =
{
	"private:factory/frameset",                 "sfs",
	"private:factory/swriter",                  "sdw",
	"private:factory/swriter/web",              "htm",
	"private:factory/swriter/globaldocument",   "sgl",
	"private:factory/scalc",                    "sdc",
	"private:factory/simpress",                 "sdd",
	"private:factory/sdraw",                    "sda",
	"private:factory/smath",                    "smf",
	"private:factory/schart",                   "sds",
	"private:factory/simage",                   "sim",
	NULL, NULL
};

// Import von Bookmarkdateien
#define BMKFILE_PUREEXTENSION "bmk"

// Sortierungsspalten
#define SORT_TITLE      0
#define SORT_FILENAME   1
#define SORT_FILETYPE   2
#define SORT_FILESIZE   3
#define SORT_FILECHANGE 4

// Imageerkennung ueber URLs
#define URL_EXTENSION_TOKEN '.'
#define MAIL_PROTOCOL "explorer/mail/"
#define HELPID_PROTOCOL "helpid/"
#define DATABASE_PROTOCOL "explorer/database/"

// Verhalten fuer die Lebenszeit
#define FILE_DEFSTYLE CONTENT_BROWSERCONTENT | CONTENT_DOCUMENT

//****************************************************************************

/*
USHORT GetExplicitImageId_Impl( const String &rPath )
{
	String aImage = SFX_INIMANAGER()->Get( "Images", FALSE, FALSE, rPath );
	return aImage.Len() ? (USHORT) aImage : 0;
}
*/

//****************************************************************************

USHORT SfxExplorerFile::GetDescriptionId_Impl
(
	const String& rExt,    // zu pruefende Dateiendung
	BOOL&		  rShowExt // ob die Extension im Typ angezeigt werden soll
)

/*	[Beschreibung]

	Die statische Methode bestimmt f"ur die spezifizierte Dateiendung die Id der
	passenden Beschreibung.

	[Rueckgabewert]
	0, wenn nichts gefunden wurde
	...
*/

{
	DBG_ASSERT( rExt.Len(), "SfxExplorerFile:Dateiendung der Laenge 0" );
	USHORT nId = 0;

	USHORT nIndex = 0;
	while ( ExtensionMap_Impl[ nIndex ]._pExt )
	{
		if ( rExt.EqualsAscii(ExtensionMap_Impl[ nIndex ]._pExt) )
		{
			nId = ExtensionMap_Impl[ nIndex ]._nStrId;
			rShowExt = ExtensionMap_Impl[ nIndex ]._bExt;
			break;
		}
		++nIndex;
	}

	return nId;
}

//****************************************************************************

Image SfxExplorerFile::GetImage( const INetURLObject& rObject, BOOL bBig )

/*	[Beschreibung]

	Die Methode liefert zu der gegebenen Instanz
	der Klasse <INetURLObject> ein entsprechendes <Image>.

	[Anmerkungen]
	Die Bestimmung des Images wird "uber die Extension realisiert.

	[Querverweise]
	<SfxExplorer::GetImage( USHORT )>
*/

{
	// Id des Images bestimmen
	USHORT nImage = GetImageId( rObject );
	DBG_ASSERT( nImage, "invalid ImageId" );
	Image aImage;

	if ( nImage == IMG_SFX_EXP_FILE )
	{
/*!!! (pb) needs new implementation
		// ask the system
		FileInfo aInfo;
		USHORT nInfo = bBig ? SYSTEM_FILEINFO_IMAGE : SYSTEM_FILEINFO_SMALLIMAGE;
		if ( System::GetFileInfo( Application::GetAppWindow(), rObject.PathToFileName(), nInfo, aInfo ) )
			aImage = bBig ? aInfo.GetImage() : aInfo.GetSmallImage();
*/
	}

	if ( !aImage )
		aImage = SfxExplorer::GetImage( nImage, bBig );

	return aImage;
}

//****************************************************************************

USHORT SfxExplorerFile::GetImageId(	const INetURLObject& rObject )
{
	String aExt = rObject.getExtension();

	if ( aExt.EqualsAscii( "vor" ) )
	{
		// Sinnbild fuer die Vorlage bestimmen
		SfxMedium* pMedium = new SfxMedium( rObject.PathToFileName(), SFX_STREAM_READONLY, FALSE, TRUE );
		const SfxFilter* pFilter = NULL;
		SFX_APP()->GetFilterMatcher().GuessFilter( *pMedium, &pFilter, SFX_FILTER_TEMPLATE );
		if( pFilter )
		{
			String aExt = pFilter->GetFilterContainer()->GetFilter( 0 )->GetDefaultExtension();
			// erase "*."
			aExt.Erase( 0, 2 );
		}
		delete pMedium;
		USHORT nId = IMG_SFX_EXP_WRITERTEMPLATE;
		if ( aExt.EqualsAscii( "sdc" ) )
		{
			nId = IMG_SFX_EXP_CALCTEMPLATE;
		}
		else if ( aExt.EqualsAscii( "sda" ) )
		{
			nId = IMG_SFX_EXP_DRAWTEMPLATE;
		}
		else if ( aExt.EqualsAscii( "sdd" ) )
		{
			nId = IMG_SFX_EXP_IMPRESSTEMPLATE;
		}
		else if ( aExt.EqualsAscii( "smf" ) )
		{
			nId = IMG_SFX_EXP_MATHTEMPLATE;
		}
		return nId;
	}

	USHORT nImage = IMG_SFX_EXP_FILE;
#if defined( OS2 ) || defined( MAC )
	SvEaMgr aMgr( rObject.PathToFileName() );
	String aType;
	if( aMgr.GetFileType( aType ) )
	{
		for( USHORT nIndex = 0; Mappings[ nIndex ]._pExt; nIndex++ )
			if ( Mappings[ nIndex ]._pExt == aType )
				nImage = Mappings[ nIndex ]._nImgId;
	}
#endif
	if( nImage == IMG_SFX_EXP_FILE )
		nImage = GetImageId( aExt );
	return nImage;
}

//****************************************************************************

Image SfxExplorerFile::GetImage
(
	const SfxObjectShell& rShell,    // URL, deren Image bestimmt werden soll
	BOOL  bBig,            /* TRUE  - Image soll 32x32 Pixel gross sein
							  FALSE - Image soll 16x16 Pixel gross sein
							  */
	BOOL bLink             /* TRUE  - Verknuepfungszeichen mit im Image
							  FALSE - normales Image
							  */
)
{
	Image aImage;
	String aName;
	if ( rShell.HasName() )
		aName = rShell.GetMedium()->GetName();;

	if ( aName.Len() )
	{
		if ( aName.SearchAscii( "file://" ) == 0 )
		{
			// Sinnbild "uber den Filter bestimmen
			String aExt = INetURLObject( aName ).getExtension().ToLowerAscii();
			if ( aExt.EqualsAscii( "vor" ) )
			{
				const SfxFilter* pFilter = rShell.GetMedium()->GetFilter();
				if ( pFilter )
					aExt = pFilter->GetFilterContainer()->GetFilter( 0 )->GetDefaultExtension().Copy(2);
				if ( aExt.EqualsAscii("sdw") )
					aImage = SfxExplorer::GetImage( IMG_SFX_EXP_WRITERTEMPLATE, bBig );
				else if ( aExt.EqualsAscii("sdc") )
					aImage = SfxExplorer::GetImage( IMG_SFX_EXP_CALCTEMPLATE, bBig );
				else if ( aExt.EqualsAscii("sda") )
					aImage = SfxExplorer::GetImage( IMG_SFX_EXP_DRAWTEMPLATE, bBig );
				else if ( aExt.EqualsAscii("sdd") )
					aImage = SfxExplorer::GetImage( IMG_SFX_EXP_IMPRESSTEMPLATE, bBig );
				else if ( aExt.EqualsAscii("smf") )
					aImage = SfxExplorer::GetImage( IMG_SFX_EXP_MATHTEMPLATE, bBig );
			}
		}
	}

	if ( !aImage )
	{
		USHORT nId = rShell.GetFactory().GetExplorerImageId();
		if ( nId )
			aImage = SfxExplorer::GetImage( rShell.GetFactory().GetExplorerImageId(), bBig );
		else
		{
			const SfxFilter *pFilter = rShell.GetFactory().GetFilter(0);
			if ( pFilter )
			{
				String aExt( pFilter->GetWildcard().GetWildCard() );
				aExt.Erase( 0, aExt.Search( '.' ) + 1 );
				USHORT nPos = aExt.Search( ';' );
				if ( nPos != STRING_NOTFOUND )
					aExt.Erase( nPos );
				USHORT nImageId = SfxExplorerFile::GetImageId ( aExt );
				aImage = SfxExplorer::GetImage( nImageId, bBig );
			}
			else
				aImage = SfxExplorer::GetImage( IMG_SFX_EXP_FILE, bBig );
		}
	}

	if ( bLink )
		aImage = SfxExplorer::ModifyImage( aImage, EXPLORER_MODIFYIMAGE_LINK );
	return aImage;
}

//****************************************************************************

USHORT SfxExplorerFile::GetImageId
(
	const String& rExtension    // Extension, fuer die ein Image soll
)

/*	[Beschreibung]

	Die Methode liefert zu der gegebenen Extension eine einem Image entsprechende Id.
	"Uber die Methode <SfxExplorer::GetImage( USHORT, BOOL )>, kann eine
	entsprechende Instanz der Klasse <Image> erzeugt werden.

	[Querverweise]
	<SfxExplorer::GetImage( USHORT, BOOL )>
*/

{
	USHORT nImage = IMG_SFX_EXP_FILE;
	if ( !rExtension.Len() )
		return nImage;
	USHORT nIndex = 0;
	String aExt( Application::GetAppInternational().Lower( rExtension ) );
	while ( ExtensionMap_Impl[ nIndex ]._pExt )
	{
		if ( aExt.EqualsAscii(ExtensionMap_Impl[ nIndex ]._pExt) )
		{
			nImage = ExtensionMap_Impl[ nIndex]._nImgId;
			if ( !nImage )
				nImage = IMG_SFX_EXP_FILE;
			break;
		}
		++nIndex;
	}

	return nImage;
}

//****************************************************************************

String SfxExplorerFile::GetDescription( const INetURLObject& rObject )

/*	[Beschreibung]

	Die statische Methode bestimmt eine Beschreibung fuer das spezifizierte	Dateisystemelement.

	[Rueckgabewert]
	Die Beschreibung fuer das Dateisystemelement.
*/

{
	String aDescript( SfxResId( STR_SFX_FOLDER ) );
	BOOL bShowExt = FALSE;
	BOOL bDetected = FALSE;
	sal_Bool bFolder = SfxContentHelper::IsFolder( rObject.GetMainURL() );
	if ( !bFolder )
	{
#if defined( OS2 ) || defined( MAC )
		// FileType via EAs
		SvEaMgr aMgr( rObject.PathToFileName() );
		String aType;
		if ( aMgr.GetFileType( aType ) )
		{
			for( USHORT nIndex = 0; !bDetected && Mappings[ nIndex ]._pExt; nIndex++ )
				if ( Mappings[ nIndex ]._pExt == aType )
				{
					aDescript = SfxResId( Mappings[ nIndex ]._nStrId );
					bDetected = TRUE;
				}
		}
#endif
		if ( !bDetected )
		{
			// Bestimmung der Dateiendung
			String aExtension( rObject.getExtension() );
			aExtension.ToLowerAscii();

			// Iteration ueber alle Zuordnungen
			USHORT nResId = 0;
			if ( aExtension.Len() )
			{
				nResId = GetDescriptionId_Impl( aExtension, bShowExt );
			}
			else
			{
				nResId = STR_SFX_FILE;
			}
			if ( nResId )
			{
				aDescript = SfxResId( nResId );
			}
/*!!! (pb) needs new implementation
			else
			{
				// if the detection failed, we ask the system
				USHORT nInfo = SYSTEM_FILEINFO_TYPENAME;
				FileInfo aInfo;
				if ( System::GetFileInfo( Application::GetAppWindow(),
										  rObject.PathToFileName(), nInfo, aInfo ) )
					aDescript = aInfo.GetTypeName();
				aDescript.EraseTrailingChars( '.' );
			}
*/
			DBG_ASSERT( aDescript.Len(), "file without description" );
		}
	}

	if ( bShowExt )
	{
		aDescript += DEFINE_CONST_UNICODE(" (");
		aDescript += rObject.getExtension().ToLowerAscii();
		aDescript += ')';
	}
	return aDescript;
}

//****************************************************************************

String SfxExplorerFile::GetDescription
(
	const String& rURL    // URL, fuer den die Beschreibung zu bestimmen ist
)

/*	[Beschreibung]

	Die statische Methode bestimmt eine Beschreibung fuer den spezifizierten URL.

	[Anmerkungen]
	Es werden nur 'smart' geparste URLs akzeptiert. Implementiert ist die Methode
	f"ur das Ftp-, Http-, File- und Private-Protokoll.

	[R"uckgabewert]
	Die Beschreibung f"ur den URL.
*/

{
	INetURLObject aURL( rURL );
	INetProtocol eProt = aURL.GetProtocol();

	// Nur fuer die folgenden Protokolle ist die Methode implementiert:
	DBG_ASSERT( eProt == INET_PROT_FILE || eProt == INET_PROT_FTP ||
				eProt == INET_PROT_HTTP || eProt == INET_PROT_PRIVATE ||
				eProt == INET_PROT_HTTP,
				"SfxExplorerFile:ungueltiger URL" );

	USHORT nDescId = STR_SFX_FILE;
	BOOL bShowExt = FALSE;

	switch ( eProt )
	{
		case INET_PROT_FILE:
		{
			// Bestimmung der Beschreibung fuer Dateisystemelemente
			return GetDescription( aURL );
		}

		case INET_PROT_FTP:
		case INET_PROT_HTTP:
		case INET_PROT_HTTPS:
		{
			// Bestimmung der Beschreibung fuer Internetdokumente
			String aLastName( aURL.GetLastName() );
			DBG_ASSERT( aLastName.Len(),
						"SfxExplorerFile:Name der Laenge 0" );
			USHORT nTokenCount = aLastName.GetTokenCount(
				URL_EXTENSION_TOKEN );
			if ( nTokenCount > 1 )
			{
				nDescId = GetDescriptionId_Impl( aLastName.GetToken(
					nTokenCount - 1, URL_EXTENSION_TOKEN ), bShowExt );
				DBG_ASSERT( nDescId, "SfxExplorerFile:Anpassungsfehler" );
			}
			break;
		}

		case INET_PROT_PRIVATE :
		{
			// Dokumenttyp aus der URL "private:factory/..." ermitteln
			USHORT nIndex = 0;
			String aCmp ( rURL );
			aCmp.ToLowerAscii();

			while ( FactoryMap_Impl[ nIndex ]._pFac )
			{
				if ( aCmp.EqualsAscii(FactoryMap_Impl[ nIndex ]._pFac) )
				{
					nDescId = GetDescriptionId_Impl( String::CreateFromAscii(FactoryMap_Impl[ nIndex ]._pExt), bShowExt );
					break;
				}
				++nIndex;
			}
			break;
		}
	}

	if ( !nDescId )
		nDescId = STR_SFX_FILE;
	String aType = String( SfxResId( nDescId ) );

	if ( bShowExt )
	{
		aType += DEFINE_CONST_UNICODE(" (");
		aType += aURL.GetExtension().ToLowerAscii();
		aType += ')';
	}
	return aType;
}


