/*************************************************************************
 *
 *  $RCSfile: iodlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------

#ifndef _COM_SUN_STAR_CHAOS_CONTENTTYPE_HPP_
#include <com/sun/star/chaos/ContentType.hpp>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _CNTCMPMN_HXX //autogen
#include <svtools/cntcmpmn.hxx>
#endif
#ifndef _SFXECODE_HXX
#include <svtools/sfxecode.hxx>
#endif
#include <svtools/ehdl.hxx>
#include <svtools/urihelper.hxx>
#pragma hdrstop

#include "iodlg.hxx"
#include "sfxresid.hxx"
#include "explorer.hxx"
#include "app.hxx"
#include "request.hxx"
#include "dispatch.hxx"
#include "fcontnr.hxx"
#include "docfac.hxx"
#include "imgmgr.hxx"
#include "docfilt.hxx"
#include "passwd.hxx"
#include "infodlgs.hxx"
#include "expfile.hxx"
#include "iodlgimp.hxx"
#include "inimgr.hxx"
#include "docfile.hxx"
#include "openflag.hxx"
#include "inettbc.hxx"
#include "progind.hxx"
#include "helper.hxx"
#include "fileview.hxx"

#ifndef _INIMAN_HXX
#include <svtools/iniman.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXEITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX //autogen
#include <svtools/ctypeitm.hxx>
#endif

#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#include "explorer.hrc"
#include "iodlg.hrc"
#include "sfxsids.hrc"
#include "sfxlocal.hrc"
#include "helpid.hrc"

// Zeit die beim Traveln in der Filterbox gewartet wird,
// bis in der Browsebox gefiltert wird ( in ms ).
#define TRAVELFILTER_TIMEOUT	750
// delay time to reset the cursor position after open a folder with a doubleclick
#define RESETCURSOR_TIMEOUT		100

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::chaos;
#include "ucbhelp.hxx"

#define GET_DECODED_NAME(aObj) \
	aObj.getName( INetURLObject::LAST_SEGMENT, true, INetURLObject::DECODE_WITH_CHARSET )

#define SMART_REL_TO_ABS( base, rel )							\
	URIHelper::SmartRel2Abs( base, rel, Link(), false, false,	\
							 INetURLObject::WAS_ENCODED,		\
							 INetURLObject::DECODE_TO_IURI,		\
							 RTL_TEXTENCODING_UTF8, true )

// functions -------------------------------------------------------------

String GetCurrentFilter_Impl( SfxExpFileDlg_Impl* pImpl )
{
	DBG_ASSERT( pImpl, "invalid impl pointer" );
	SfxFileDialogFilter_Impl* pFilter = pImpl->_pUserFilter;

	if ( !pFilter )
		pFilter = pImpl->_pCurFilter;

	// Filtern.
	if ( !pFilter )
		return String();

	return pFilter->GetType();
}

String GetFsysAccessDelimiter_Impl()
{
	String aDelim(
#ifdef WNT
					'\\'
#elif MAC
					':'
#else
					'/'
#endif
						);
	return aDelim;
}

String GetFsysExtension_Impl( const String& rFile )
{
	const sal_Unicode* p0 = rFile.GetBuffer();
	const sal_Unicode* p1 = p0 + rFile.Len() - 1;
	while ( p1 >= p0 && *p1 != sal_Unicode( '.' ) )
		p1--;
	if ( p1 >= p0 )
		return String( rFile.Copy( p1 - p0 + 1 ) );
	return String();
}

void SetFsysExtension_Impl( String& rFile, const String& rExtension )
{
	const sal_Unicode* p0 = rFile.GetBuffer();
	const sal_Unicode* p1 = p0 + rFile.Len() - 1;
	while ( p1 >= p0 && *p1 != sal_Unicode( '.' ) )
		p1--;
	if ( p1 >= p0 )
		// remove old extension
		rFile.Erase( p1 - p0 + 1 - ( rExtension.Len() > 0 ? 0 : 1 ) );
	else if ( rExtension.Len() )
		// no old extension
		rFile += sal_Unicode( '.' );
	rFile += rExtension;
}

//*****************************************************************************
// SfxFileDialog
//*****************************************************************************

SfxFileDialog* SfxFileDialog::_pActiveDlg = NULL;

//*****************************************************************************

SfxFileDialog::SfxFileDialog
(
	Window* pParent,
	ULONG nBits,
	const SfxObjectFactory& rDocFac,
	const SfxItemSet& rSet
) :
	VclFileDialog( pParent, SfxResId( DLG_SFX_EXPLORERFILE ) ),

	_pFileView( NULL ),
	_pCbReadOnly( NULL ),
	_pImp( new SfxExpFileDlg_Impl( this, nBits ) ),
	_pOutputItemSet( new SfxAllItemSet( rSet ) ),

	// !!!!!!! DIE CONTROLS WERDEN IN INIT_IMPL UNSICHTBAR GESCHALTET !!!!!!!
	_aFtDummy1( this ),
	_aEdDummy1( this ),
	_aFtDummy2( this ),
	_aLbDummy2( this ),
	_aFtDummy3( this ),
	_aCmbDummy3( this ),
	_aBtnDummy1( this ),
	_aBtnDummy2( this ),
	_aBtnDummy3( this ),
	_aBtnDummy4( this ),
	_aBtnDummy5( this )

{
	Init_Impl( nBits );

	// Untermenge bestimmen.
	if( nBits & WB_OPEN )
		AddFilter( String( SfxResId( STR_FILTERNAME_ALL ) ), DEFINE_CONST_UNICODE(FILEDIALOG_FILTER_ALL) );

	FASTBOOL bIsOpen = WB_OPEN == ( nBits & WB_OPEN );
	FASTBOOL bIsSave = WB_SAVEAS == ( nBits & WB_SAVEAS );
	USHORT nFlags = SFX_FILTER_EXPORT;

	if( bIsOpen )
		nFlags =  SFX_FILTER_IMPORT;

	// Filter einfuegen.
	SfxApplication *pSfxApp = SFX_APP();
	SfxFilterMatcher* pMatcher;

	if ( !&rDocFac )
		pMatcher = &pSfxApp->GetFilterMatcher();
	else
	{
		_pImp->_nState |= FILEDLG_STATE_OWNSMATCHER;
		pMatcher = new SfxFilterMatcher( rDocFac.GetFilterContainer() );
	}

	SfxFilterMatcherIter aIter(	pMatcher, nFlags, SFX_FILTER_INTERNAL | SFX_FILTER_NOTINFILEDLG );
	const SfxFilter* pDef = aIter.First();

	for ( const SfxFilter* pFilter = pDef; pFilter; pFilter = aIter.Next() )
	{
		String aUIName( pFilter->GetUIName() );
		AddFilter( aUIName, pFilter->GetWildcard().GetWildCard(), pFilter->GetFilterFlags() );
	}

	_pImp->_pMatcher =  pMatcher;

	// Standard einstellen.
	if ( pDef && ( !pDef->IsOwnFormat() || !&rDocFac ) && !bIsSave )
		pDef = NULL;
	String aLastFilter( pSfxApp->GetLastFilter_Impl() );

	if ( aLastFilter.Len() )
	{
		const SfxFilter *pFilt = pMatcher->GetFilter( aLastFilter, nFlags );

		if( !pFilt )
			pFilt = pDef;

		if( pFilt )
		{
			SetCurFilter( pFilt->GetFilterName() );
			String aWildcard = pFilt->GetDefaultExtension();
			SetDefaultExt( aWildcard.Copy( 2 ) );
		}
	}
	else
	{
		String aCurFilter( SfxResId( STR_FILTERNAME_ALL ) );

		if( pDef )
		{
			aCurFilter = pDef->GetUIName();
			String aWildcard = pDef->GetDefaultExtension();
			SetDefaultExt( aWildcard.Copy( 2 ) );
		}
		SetCurFilter( aCurFilter );
	}
}

//*****************************************************************************

SfxFileDialog::SfxFileDialog( Window* pParent, ULONG nBits ) :

	VclFileDialog( pParent, SfxResId( DLG_SFX_EXPLORERFILE ) ),

	_pFileView( NULL ),
	_pCbReadOnly( NULL ),
	_pImp( new SfxExpFileDlg_Impl( this, nBits ) ),
	_pOutputItemSet( NULL ),

	// !!!!!!! DIE CONTROLS WERDEN IN INIT_IMPL UNSICHTBAR GESCHALTET !!!!!!!
	_aFtDummy1( this ),
	_aEdDummy1( this ),
	_aFtDummy2( this ),
	_aLbDummy2( this ),
	_aFtDummy3( this ),
	_aCmbDummy3( this ),
	_aBtnDummy1( this ),
	_aBtnDummy2( this ),
	_aBtnDummy3( this ),
	_aBtnDummy4( this ),
	_aBtnDummy5( this )

{
	Init_Impl( nBits );
}

//*****************************************************************************

SfxFileDialog::~SfxFileDialog()
{
	if ( _pImp->_bHasWaitCursor )
		LeaveWait();

	if ( _pImp->_aIniKey.Len() )
	{
        String aIniStr = String::CreateFromInt32( _pImp->_aDlgSize.Width() );
        ( aIniStr += ',' ) += String::CreateFromInt32( _pImp->_aDlgSize.Height() );
        ( aIniStr += ',' ) += String::CreateFromInt32( 1 /*_pFileView->IsBrowserMode()*/ );
		SFX_INIMANAGER()->Set( aIniStr, SFX_GROUP_VIEW, _pImp->_aIniKey );
	}
	SaveSettings_Impl();

	delete _pImp->_pIndicator;
	delete _pImp;
	delete _pCbReadOnly;
	_pFileView->SetSelectHdl( Link() );
	delete _pFileView;
	delete _pOutputItemSet;
}

//*****************************************************************************

void SfxFileDialog::Init_Impl
(
	ULONG nStyle
)
{

	_aFtDummy1.Hide();
	_aEdDummy1.Hide();
	_aFtDummy2.Hide();
	_aLbDummy2.Hide();
	_aFtDummy3.Hide();
	_aCmbDummy3.Hide();
	_aBtnDummy1.Hide();
	_aBtnDummy2.Hide();
	_aBtnDummy3.Hide();
	_aBtnDummy4.Hide();
	_aBtnDummy5.Hide();

	_pImp->_nStyle = nStyle;
	_pImp->_a6Size = LogicToPixel( Size( 6, 6 ), MAP_APPFONT );
	_pImp->_eMode = ( nStyle & WB_SAVEAS ) ? FILEDLG_MODE_SAVE : FILEDLG_MODE_OPEN;
	_pImp->_eDlgType = FILEDLG_TYPE_FILEDLG;

	if ( ( nStyle & SFXWB_PATHDIALOG ) == SFXWB_PATHDIALOG )
		_pImp->_eDlgType = FILEDLG_TYPE_PATHDLG;

	if ( ( nStyle & SFXWB_SHOWALLFOLDER ) == SFXWB_SHOWALLFOLDER )
		_pImp->_eDlgType = FILEDLG_TYPE_FOLDERDLG;

	// Default-Standard-Dir setzen
	SfxApplication* pApp = SFX_APP();
	INetURLObject aStdDirObj( pApp->GetIniManager()->Get( SFX_KEY_WORK_PATH ), INET_PROT_FILE );
	SetStandardDir( aStdDirObj.GetMainURL() );

	// Reichweite bestimmen.
	if ( !( nStyle & SFXWB_NOREMOTE ) )
	{
		_pImp->_nState |= FILEDLG_STATE_REMOTE;
	}

	// Kontrollelement erzeugen, wobei die Reihenfolge die Tab-Steuerung
	// bestimmt.
	_pImp->_pFtFileName = new FixedText(
		this, ResId( FT_EXPLORERFILE_FILENAME ) );

	if ( 1 /* ab jetzt immer mit AutoComplete */ || _pImp->_eMode == FILEDLG_MODE_OPEN )
	{
		SfxURLBox* pURLBox = (SfxURLBox*)( _pImp->_pEdFileName = new SfxURLBox( this ) );
		Edit aDummy( this, ResId( ED_EXPLORERFILE_FILENAME ) );
		_pImp->_pEdFileName->SetPosSizePixel( aDummy.GetPosPixel(), aDummy.GetSizePixel() );
		_pImp->_pEdFileName->Show();
		pURLBox->SetSelectHdl( LINK( this, SfxFileDialog, EntrySelectHdl_Impl ) );
		pURLBox->SetOpenHdl( STATIC_LINK( this, SfxFileDialog, OpenHdl_Impl ) );
		// bei SaveAs oder im PfadDialog nur Verzeichnisse automatisch erg"anzen
		BOOL bOnlyDir = ( _pImp->_eMode != FILEDLG_MODE_OPEN ||
						  _pImp->_eDlgType == FILEDLG_TYPE_PATHDLG );
		pURLBox->SetOnlyDirectories( bOnlyDir );
		_pImp->_pEdFileName->SetHelpId( HID_FILEDLG_AUTOCOMPLETEBOX );
	}
	else
	{
		_pImp->_pEdFileName = new Edit( this, ResId( ED_EXPLORERFILE_FILENAME ) );
	}

	_pImp->_pFtFileVersion = new FixedText(
		this, ResId( FT_EXPLORERFILE_FILEVERSION ) );
	_pImp->_pLbFileVersion = new ListBox(
		this, ResId( LB_EXPLORERFILE_FILEVERSION ) );
	_pImp->_pFtFileType = new FixedText(
		this, ResId( FT_EXPLORERFILE_FILETYPE ) );
	_pImp->_pLbFilter = new ListBox(
		this, ResId( LB_EXPLORERFILE_FILETYPE ) );

	if ( !( nStyle & SFXWB_SHOWVERSIONS ) ||
		 FILEDLG_TYPE_FILEDLG != _pImp->_eDlgType || FILEDLG_MODE_OPEN != _pImp->_eMode )
	{
		_pImp->_pFtFileType->SetPosPixel( _pImp->_pFtFileVersion->GetPosPixel() );
		_pImp->_pLbFilter->SetPosPixel( _pImp->_pLbFileVersion->GetPosPixel() );
	}

	_pImp->_pFtCurrentPath = new SfxShortFixedText_Impl( this, ResId( FT_EXPLORERFILE_CURRENTPATH ) );
	_pImp->_pBtnFileOpen = new PushButton( this, ResId( BTN_EXPLORERFILE_OPEN ) );
	_pImp->_pBtnCancel = new CancelButton( this, ResId( BTN_EXPLORERFILE_CANCEL ) );
	_pImp->_pBtnHelp = new HelpButton( this, ResId( BTN_EXPLORERFILE_HELP ) );
	_pImp->_pBtnUp = new SfxUpButton_Impl( this, ResId( BTN_EXPLORERFILE_UP ) );
	_pImp->_pBtnNewFolder = new ImageButton( this, ResId( BTN_EXPLORERFILE_NEWFOLDER ) );
	_pImp->_pBtnNewFolder->SetStyle( _pImp->_pBtnNewFolder->GetStyle() | WB_NOPOINTERFOCUS );
	_pImp->_pBtnStandard = new SfxTravelButton_Impl( this, ResId( BTN_EXPLORERFILE_STANDARD ) );

	if ( ( nStyle & SFXWB_MULTISELECTION ) == SFXWB_MULTISELECTION )
		_pImp->_bMultiSelection = TRUE;

	_pFileView = new SfxFileView_Impl( this, ResId( CTL_EXPLORERFILE_FILELIST ),
									   FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType );
	_pImp->_pIndicator = new SfxPopupStatusIndicator( this );
//!	_pFileView->SetStatusIndicator( _pImp->_pIndicator->GetInterface() );
	USHORT nHelpId = HID_FILEDLG_STANDARD;
	_pFileView->SetHelpId( nHelpId );
	_pFileView->SetStyle( _pFileView->GetStyle() | WB_TABSTOP );

	// Positionen und Groessen der Knoepfe bestimmen.
	SfxImageManager* pImgMgr = SFX_IMAGEMANAGER();
	Image aNewFolderImg( pImgMgr->GetImage( SID_EXPLORER_CREATEFOLDER ) );
	_pImp->_pBtnNewFolder->SetImage( aNewFolderImg );
	Size aSize( aNewFolderImg.GetSizePixel() );
	aSize.Width() += FILEDIALOG_DEF_IMAGEBORDER;
	aSize.Height() += FILEDIALOG_DEF_IMAGEBORDER;
	_pImp->_pBtnNewFolder->SetSizePixel( aSize );
	_pImp->_pBtnUp->SetSizePixel( aSize );
	_pImp->_pBtnStandard->SetSizePixel( aSize );
	Point aPos( _pImp->_pBtnUp->GetPosPixel() );
	Size aDlgSize = GetOutputSizePixel();
	aPos.X() = aDlgSize.Width();
	long n6AppFontInPixel =
			LogicToPixel( Size( 6, 0 ), MAP_APPFONT ).Width();
	long n3AppFontInPixel =
			LogicToPixel( Size( 3, 0 ), MAP_APPFONT ).Width();
	aPos.X() -= n6AppFontInPixel;
	USHORT nBtnCount = 3;
	long nDelta = nBtnCount;
	nDelta *= aSize.Width();
	aPos.X() -= nDelta;
	aPos.X() -= n3AppFontInPixel;
	_pImp->_pBtnUp->SetPosPixel( aPos );
	nDelta = aPos.X();
	nDelta -= ( n6AppFontInPixel * 2 );
	Size aCurPathSize( _pImp->_pFtCurrentPath->GetOutputSizePixel() );
	aCurPathSize.Width() = nDelta;
	_pImp->_pFtCurrentPath->SetOutputSizePixel( aCurPathSize );
	aPos.X() += aSize.Width();
	aPos.X() += n3AppFontInPixel;
	_pImp->_pBtnNewFolder->SetPosPixel( aPos );
	aPos.X() += aSize.Width();
	aPos.X() += ( n3AppFontInPixel / 2 );
	_pImp->_pBtnStandard->SetPosPixel( aPos );
	nDelta = aSize.Height();
	nDelta -= aCurPathSize.Height();
	nDelta /= 2;
	Point aCurPathPos = _pImp->_pFtCurrentPath->GetPosPixel();
	aCurPathPos.Y() += nDelta;
	_pImp->_pFtCurrentPath->SetPosPixel( aCurPathPos );

	// Zahl der Pixel bestimmen, um die die anderen Elemente in der Position
	// Angepasst werden muessen.
	aPos.Y() += aSize.Height();
	aPos.Y() += LogicToPixel( Size( 0, 6 ), MAP_APPFONT ).Height();
	long nYOffset = aPos.Y();
	aPos = _pFileView->GetPosPixel();
	nYOffset -= aPos.Y();

	// Positionen der uebrigen Elemente anpassen.
	aPos.Y() += nYOffset;
	_pFileView->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileName->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileName->SetPosPixel( aPos );
	aPos = _pImp->_pEdFileName->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pEdFileName->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileVersion->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileVersion->SetPosPixel( aPos );
	aPos = _pImp->_pLbFileVersion->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pLbFileVersion->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileType->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileType->SetPosPixel( aPos );
	aPos = _pImp->_pLbFilter->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pLbFilter->SetPosPixel( aPos );
	aPos = _pImp->_pBtnFileOpen->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pBtnFileOpen->SetPosPixel( aPos );
	aPos = _pImp->_pBtnCancel->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pBtnCancel->SetPosPixel( aPos );
	aPos = _pImp->_pBtnHelp->GetPosPixel();
	aPos.Y() += nYOffset + 3; // a little more spacing between Cancel- and HelpButton
	_pImp->_pBtnHelp->SetPosPixel( aPos );

	// Groesse des Dialoges anpassen.
	aSize = GetSizePixel();
	aSize.Height() += nYOffset;
	SetSizePixel( aSize );

	if ( nStyle & SFXWB_READONLY )
	{
		_pCbReadOnly = new CheckBox( this, ResId( CB_EXPLORERFILE_READONLY ) );
		AddControl( _pCbReadOnly );
		ReleaseOwnerShip( _pCbReadOnly );
	}
	if ( nStyle & WB_SAVEAS )
	{
		_pImp->_pCbAutoExtension = new CheckBox( this, SfxResId( CB_AUTO_EXTENSION ) );
		_pImp->_pCbAutoExtension->Check(
			! SFX_INIMANAGER()->Get( SFX_KEY_FILEDIALOGEXT ).EqualsAscii("0") );
		AddControl( _pImp->_pCbAutoExtension );
		ReleaseOwnerShip( _pImp->_pCbAutoExtension );
		_pImp->_pCbOptions = new CheckBox( this, SfxResId( CB_OPTIONS ) );
		AddControl( _pImp->_pCbOptions );
		ReleaseOwnerShip( _pImp->_pCbOptions );
	}
	if ( nStyle & SFXWB_PASSWORD )
	{
		_pImp->_pCbPassword = new CheckBox( this, ResId( CB_EXPLORERFILE_PASSWORD ) );
		AddControl( _pImp->_pCbPassword );
		ReleaseOwnerShip( _pImp->_pCbPassword );
	}

	// Beschriftungen dem Modus anpassen.
	USHORT nResId = STR_EXPLORERFILE_OPEN;
	USHORT nButtonResId = 0;
	FASTBOOL bInsertMode = FALSE;

	if ( nStyle & WB_SAVEAS )
	{
		nResId = STR_EXPLORERFILE_SAVE;
		nButtonResId = STR_EXPLORERFILE_BUTTONSAVE;
	}
	else if ( ( nStyle & SFXWB_INSERT ) == SFXWB_INSERT )
	{
		nResId = STR_EXPLORERFILE_INSERT;
		nButtonResId = STR_EXPLORERFILE_BUTTONINSERT;
		bInsertMode = TRUE;
	}

	if ( ( nStyle & SFXWB_PATHDIALOG ) == SFXWB_PATHDIALOG )
	{
		_pImp->_pFtFileName->SetText( ResId( STR_PATHNAME ) );
		nResId = STR_PATHSELECT;
		nButtonResId = STR_BUTTONSELECT;
	}

	SetText( ResId( nResId ) );

	if ( nButtonResId )
		_pImp->_pBtnFileOpen->SetText( ResId( nButtonResId ) );

	if ( bInsertMode ||
		 FILEDLG_TYPE_FILEDLG != _pImp->_eDlgType ||
		 FILEDLG_MODE_SAVE == _pImp->_eMode )
	{
		// spezielle HelpIds setzen, wenn es sich nicht um Datei/"Offnen handelt
		if ( bInsertMode )
		{
			_pImp->_pBtnFileOpen->SetHelpId( HID_FILEDLG_INSERT_BTN );
		}
		else if ( FILEDLG_MODE_SAVE == _pImp->_eMode )
		{
			_pImp->_pBtnFileOpen->SetHelpId( HID_FILEDLG_SAVE_BTN );
			_pImp->_pEdFileName->SetHelpId( HID_FILEDLG_SAVE_FILENAME );
			_pImp->_pLbFilter->SetHelpId( HID_FILEDLG_SAVE_FILETYPE );
		}
		else if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType )
		{
			_pImp->_pBtnFileOpen->SetHelpId( HID_FILEDLG_PATH_BTN );
			_pImp->_pEdFileName->SetHelpId( HID_FILEDLG_PATH_FILENAME );
		}
		else if ( FILEDLG_TYPE_FOLDERDLG == _pImp->_eDlgType )
		{
			_pImp->_pBtnFileOpen->SetHelpId( HID_FILEDLG_FOLDER_BTN );
			_pImp->_pEdFileName->SetHelpId( HID_FILEDLG_FOLDER_FILENAME );
		}
	}

	if ( FILEDLG_TYPE_FILEDLG != _pImp->_eDlgType )
	{
		_pImp->_pFtFileVersion->Hide();
		_pImp->_pLbFileVersion->Hide();
		_pImp->_pFtFileType->Hide();
		_pImp->_pLbFilter->Hide();
	}
	else if ( !( nStyle & SFXWB_SHOWVERSIONS ) || FILEDLG_MODE_OPEN != _pImp->_eMode )
	{
		_pImp->_pFtFileVersion->Hide();
		_pImp->_pLbFileVersion->Hide();
	}

	// Einstellungen der Steuerelemente vornehmen.
	_pImp->_pBtnNewFolder->SetClickHdl( STATIC_LINK( this, SfxFileDialog, NewFolderHdl_Impl ) );
	_pImp->_pBtnFileOpen->SetClickHdl( STATIC_LINK( this, SfxFileDialog, OpenHdl_Impl ) );
	_pImp->_pLbFilter->SetSelectHdl( STATIC_LINK( this, SfxFileDialog, FilterSelectHdl_Impl ) );
	_pImp->_pEdFileName->SetGetFocusHdl( STATIC_LINK( this, SfxFileDialog, FileNameGetFocusHdl_Impl ) );
	_pImp->_pEdFileName->SetModifyHdl( STATIC_LINK( this, SfxFileDialog, FileNameModifiedHdl_Impl ) );
	_pFileView->SetSelectHdl( LINK( this, SfxFileDialog, SelectHdl_Impl ) );
	_pFileView->SetDoubleClickHdl( LINK( this, SfxFileDialog, DblClickHdl_Impl ) );
	_pFileView->SetOpenDoneHdl( LINK( this, SfxFileDialog, OpenDoneHdl_Impl ) );

	_pImp->_aActualVersion = String( ResId( STR_ACTUALVERSION ) );

	// Resourcen freigeben.
	FreeResource();

	// Pfad setzen.
	if ( _pOutputItemSet && _pOutputItemSet->GetItemState( SID_FILE_NAME ) == SFX_ITEM_SET )
	{
		_aPath = ( ( const SfxStringItem& )
				_pOutputItemSet->Get( SID_FILE_NAME ) ).GetValue();
	}

	// Timer fuer Filterbox Travel setzen
	_pImp->_aFilterTimer.SetTimeout(TRAVELFILTER_TIMEOUT);
	_pImp->_aFilterTimer.SetTimeoutHdl( STATIC_LINK( this, SfxFileDialog, FilterSelectHdl_Impl ) );

	_pImp->_aResetCursorTimer.SetTimeout( RESETCURSOR_TIMEOUT );
	_pImp->_aResetCursorTimer.SetTimeoutHdl( LINK( this, SfxFileDialog, ResetCursorHdl_Impl ) );

	// Anzahl der bisher erzeugten Child Windows ermitteln
	// um spaeter in Execute die Anzahl der dynamisch erzeugten
	// Child Windows zu ermitteln. #49066#
	_pImp->_nUserControls = GetChildCount();
	_pImp->_bHasWaitCursor = FALSE;
	_pImp->_bEnableEmptyFilename = FALSE;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, NewFolderHdl_Impl, PushButton*, pBtn )
{
	pThis->_pFileView->CreateNewFolder();
	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, ViewHdl_Impl, ImageButton*, pBtn )
{
	if ( pBtn && pBtn->IsChecked() )
		return 0;

	BOOL bBrowserMode = TRUE /*pThis->_pFileView->IsBrowserMode()*/;
	BOOL bList = pBtn ? bBrowserMode : !bBrowserMode;
	if ( pBtn )
		pThis->ToggleBrowserMode();
	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, OpenHdl_Impl, void*, pVoid )
{
	String aFileName;
    String aOldPath( pThis->_pFileView->GetViewURL() );
	if ( pThis->_pImp->_bDoubleClick )
		aFileName = pThis->_pFileView->GetCurrentURL();

	if ( !aFileName.Len() )
	{
		if ( pThis->_pImp->_eMode == FILEDLG_MODE_OPEN &&
			 ( (SfxURLBox*)pThis->_pImp->_pEdFileName )->IsTravelSelect() )
			return 0;

		// Eingabe auswerten.
		aFileName = pThis->_pImp->_pEdFileName->GetText();
		xub_StrLen nNameLen = aFileName.Len();

        if ( aFileName.CompareToAscii( "vnd.sun.star.webdav:", 20 ) == 0 )
        {
            aFileName = String::CreateFromAscii("http:");
            aFileName += pThis->_pImp->_pEdFileName->GetText().Copy(20);
        }

		if ( ( 1 == nNameLen &&  ( aFileName.GetChar(0) == '/' || aFileName.GetChar(0) == '\\' ) ) ||
			 ( nNameLen > 1 && aFileName.GetChar(0) == '\\' ) )
		{
			INetURLObject aCurrentURL( aOldPath );
			String aTmp( DEFINE_CONST_UNICODE("file:///") );
            aTmp += aCurrentURL.getName( 0, true, INetURLObject::DECODE_WITH_CHARSET );
			if ( nNameLen > 1 )
			{
				aTmp += '/';
				aTmp += aFileName.Copy(1);
			}
			INetURLObject aTemp( aTmp );
 			aTemp.setFinalSlash();
			aFileName = aTemp.GetMainURL();
		}
		else if ( ( 2 == nNameLen && aFileName.GetChar(1) == ':' ) ||
				  ( nNameLen > 2 && aFileName.GetChar(1) == ':' && aFileName.GetChar(2) != '\\' ) )
		{
			// c: -> c:\ || c:blah.sdw --> c:\blah.sdw
			aFileName.Insert( '\\', 2 );
			INetURLObject aFileObj( aFileName, INET_PROT_FILE );
			if ( SfxContentHelper::IsFolder( aFileObj.GetMainURL() ) )
				aFileObj.setFinalSlash();
			aFileName = aFileObj.GetMainURL();
		}
	}

	if ( pThis->_pImp->_bEnableEmptyFilename && !aFileName.Len() )
	{
		// wenn der Dateiname leer ist und dies so sein darf
		// dann sofort beenden
		pThis->_aPath.Erase();
		long nReturn;

		if ( pThis->_aOKHdl.IsSet() )
			nReturn = pThis->_aOKHdl.Call( pThis );
		else
			nReturn = pThis->OK();

		if ( nReturn )
		{
			pThis->UpdateHistory_Impl();
			pThis->EndDialog( TRUE );
		}

		return nReturn;
	}

	if ( !aFileName.Len() && pVoid == pThis->_pImp->_pEdFileName && pThis->_pImp->_pUserFilter )
	{
		DELETEZ( pThis->_pImp->_pUserFilter );
//(mba)	pThis->FilterBox_Impl( NULL );
		return 0;
	}

	USHORT nLen = aFileName.Len();

	if ( !nLen )
	{
		if( ( pThis->_pImp->_eDlgType != FILEDLG_TYPE_PATHDLG ) &&
			( pThis->_pImp->_eDlgType != FILEDLG_TYPE_FOLDERDLG ) )
		{
			return 0;
		}
		else
		{
			aFileName =	pThis->_pImp->_pFtCurrentPath->GetText();
			nLen = aFileName.Len();
		}
	}

// aFileName kann immer noch leer sein -> path/folder dialog
// xAnchor nur da, wenn Selektion

	// ggf. Eingabe selektieren.
	pThis->_pImp->_pEdFileName->SetSelection( Selection( 0, nLen ) );

	// ggf. Filter isolieren.
	String aFilter;
	String aEmpty;

	if ( !pThis->IsolateFilterFromPath_Impl( aFileName, aFilter ) )
		return 0;

	// Filter...
	BOOL bWildCard      = ( aFilter.Len() != 0 );
	BOOL bFilterChanged = bWildCard;
	BOOL bWildCardOnly  = bWildCard && ( aFileName.Len() == 0 );

	if ( bFilterChanged )
	{
		// Nach einem korrespondierenden Filter suchen.
		BOOL bFilterFound = pThis->FindFilter_Impl( aFilter, FALSE, bFilterChanged );
		if ( !bFilterFound )
			bFilterFound = pThis->FindFilter_Impl( aFilter, TRUE, bFilterChanged );

		// Ggf. neuen Filter erzeugen.
		if ( !bFilterFound )
		{
			// Neuen Filter generieren.
			delete pThis->_pImp->_pUserFilter;
			pThis->_pImp->_pUserFilter = new SfxFileDialogFilter_Impl( aFilter, aFilter, aEmpty, 0 );

			// Anzeige anpassen.
			if ( aFilter.EqualsAscii(FILEDIALOG_FILTER_ALL) )
				pThis->_aDefExt.Erase();
			else
				pThis->_aDefExt = aFilter.Copy( 2 );
		}
		pThis->_pImp->_pEdFileName->SetText( aFilter );
		pThis->_pImp->_pEdFileName->SetSelection( Selection( 0, aFilter.Len() ) );
	}

	INetURLObject aFileObject( aFileName );
    String aFileURL( aFileObject.GetMainURL() );

	// Ggf. absolutieren.
	INetURLObject aObj;
	if ( !bWildCardOnly )
	{
		String aNewBase;
		String aOldBase = INetURLObject::GetBaseURL();
/*(mba)
		CntAnchor* pTmpAnchor = &xAnchor;
		if ( !pTmpAnchor )
			pTmpAnchor = pThis->_pFileView->GetViewAnchor();

		aNewBase = pTmpAnchor->GetServiceURL();
 */
		INetURLObject aTemp( aOldPath, INET_PROT_FILE );
		aTemp.setFinalSlash();
        aNewBase = aTemp.GetMainURL();

		INetProtocol eProt = INetURLObject::CompareProtocolScheme( aNewBase );
		FASTBOOL bRealTarget = ( INET_PROT_FILE == eProt ||
								 INET_PROT_FTP == eProt ||
								 INET_PROT_HTTP == eProt ||
								 INET_PROT_HTTPS == eProt );
		INetURLObject::SetBaseURL( aNewBase );

		if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE )
		{
			// Erst pr"ufen, ob es sich um eine relative Angabe mit Laufwerken handelt.
			FASTBOOL bDirEntry = FALSE;

            if ( aFileName.Search( DEFINE_CONST_UNICODE(INET_HTTP_SCHEME ) ) == STRING_NOTFOUND &&
                 aFileName.Search( DEFINE_CONST_UNICODE(INET_FTP_SCHEME ) ) == STRING_NOTFOUND &&
                 aNewBase.Search( DEFINE_CONST_UNICODE(INET_FTP_SCHEME ) ) == STRING_NOTFOUND &&
				 bRealTarget )
			{
				// statt aEntry.ToAbs() jetzt operator+= benutzen,
				// weil ToAbs() das CWD ben"otigt. Dies wird nicht mehr
				// bei jedem Ordnerwechsel gesetzt.

                if ( !pThis->_pImp->_bDoubleClick && !pThis->_pImp->_aCWD.Len() )
				{
					ErrorHandler::HandleError( ERRCODE_IO_INVALIDDEVICE );
					return 0;
				}

				Link aLink;
				INetURLObject aBaseObj( pThis->_pImp->_aCWD );
				INetURLObject aNewObj =
					INetURLObject( SMART_REL_TO_ABS( aBaseObj, aFileName ) );
				if ( SfxContentHelper::IsFolder( aNewObj.GetMainURL() ) )
					aNewObj.setFinalSlash();
				aObj = aNewObj;
				bDirEntry = TRUE;
			}

			if ( !bDirEntry )
				aObj = INetURLObject::RelToAbs( aFileName );
		}
		else
		{
			INetURLObject aBaseObj( aNewBase );
			Link aLink;
			aObj = INetURLObject( SMART_REL_TO_ABS( aBaseObj, aFileName ) );

			if ( aObj.GetProtocol() == INET_PROT_NOT_VALID && aBaseObj.GetProtocol() == INET_PROT_FILE )
			{
				ErrorHandler::HandleError( ERRCODE_IO_INVALIDPARAMETER );
/*! (pb)
				if ( aNewBase != aFileName )
				{
					DirEntry aEntry( aNewBase );
                    if ( !aFileName.EqualsAscii ("..") || aEntry.GetFlag() != FSYS_FLAG_ABSROOT )
					{
						aEntry += DirEntry( aFileName );

						if ( aEntry.GetError() )
						{
							ErrorHandler::HandleError( aEntry.GetError() );
							return 0;
						}
					}
					BOOL bDir = FileStat( aEntry ).IsKind( FSYS_KIND_DIR );
					String aFullPath = aEntry.GetFull( FSYS_STYLE_URL, bDir );
					aObj.SetURL( aFullPath );
				}
				else
					aObj.SetURL( aFileName );
*/
			}

			// Pr"ufen, ob es nicht eine Datei gibt, die die Endung des
			// eingestellten Filters hat, wenn keine Endung mit eingegeben wurde.
			INetProtocol eFileProt = INetURLObject::CompareProtocolScheme( aFileName );
            if ( !aFileName.EqualsAscii( ".." ) && aObj.GetProtocol() != INET_PROT_FILE &&
				 ( INET_PROT_FILE == eFileProt || INET_PROT_NOT_VALID == eFileProt ) )
			{
				DBG_ERRORFILE( "do we need this?" );
/*! (pb) do we need this?
				DirEntry aFile( aFileName );
				DirEntry aTemp( pThis->_pImp->_aCWD );
				aTemp += aFile;
				aFile = aTemp;
				const String& rType = pThis->_pImp->_pCurFilter->GetType();

                if ( !aFile.GetExtension().Len() && rType != DEFINE_CONST_UNICODE(FILEDIALOG_FILTER_ALL) )
				{
					USHORT nToken = rType.GetTokenCount( FILEDIALOG_DEF_EXTSEP );
					String aExt;

					while ( nToken-- )
					{
						aExt = rType.GetToken( nToken, FILEDIALOG_DEF_EXTSEP ).Copy(2);
						aFile.SetExtension( aExt );

						if ( aFile.Exists() )
						{
							aObj = INetURLObject(
								URIHelper::SmartRel2Abs( aBaseObj, aFile.GetFull( FSYS_STYLE_URL ) ) );
							break;
						}
					}
				}
*/
			}
		}
		INetURLObject::SetBaseURL( aOldBase );
		aFileURL = aFileName = aObj.GetMainURL();
	}

	// Protokoll pruefen.
	INetProtocol eProt = aObj.GetProtocol();
	if ( !bWildCardOnly &&
		 ( eProt != INET_PROT_FILE && !( pThis->_pImp->_nState & FILEDLG_STATE_REMOTE ) ) )
	{
		ErrorHandler::HandleError( ERRCODE_SFX_INVALIDSYNTAX );
		return 0;
	}

	// Pr"ufen, ob es sich um einen Ordner handelt.
    aFileName = aFileURL;
	FASTBOOL bCreateAnchor = FALSE;
	BOOL bFolder = !bWildCardOnly;
	if ( bFolder )
	{
/*(mba)
		if ( !xAnchor.Is() )
		{
			xAnchor = new CntAnchor( NULL, aFileName );
			bCreateAnchor = TRUE;
		}

		bFolder = ITEMSET_VALUE( xAnchor, SfxBoolItem, WID_FLAG_IS_FOLDER );
		if ( bFolder && pThis->_pImp->_eMode == FILEDLG_MODE_SAVE &&
			 CntHelperFunctions::IsStorageAnchor( *xAnchor ) && INET_PROT_FILE == eProt )
			// StorageAnchor (*.scc,*.sdb,...) bei SaveAs als File ansehen
			bFolder = FALSE;
		String aTargetURL = ITEMSET_VALUE( xAnchor, CntStringItem, WID_TARGET_URL );
*/

		Any aAny( UCB_Helper::GetProperty( aFileName, WID_FLAG_IS_FOLDER ) );
        bFolder = FALSE;
        aAny >>= bFolder;

/*(mba)
		if ( bFolder && aTargetURL.Len() )
		{
			aObj.SetURL( aTargetURL );
			eProt = aObj.GetProtocol();
			aFileName = aObj.GetMainURL();
			xAnchor = new CntAnchor( NULL, aFileName );
		}

		FASTBOOL bSpecial = ( INET_PROT_FILE == eProt &&
							  String( aFileName ).ToLowerAscii().SearchAscii( RFS_IDENTIFIER ) >= 10 );
*/

/*!!! (pb) no Exists()-question any longer
		if ( bFolder && eProt == INET_PROT_FILE && !SfxContentHelper::Exists( aFileName ) )
		{
			ErrorHandler::HandleError( ERRCODE_IO_NOTEXISTS );
			return 0;
		}
*/

/*(mba)
		if ( bFolder && bSpecial && pThis->_pImp->_eMode == FILEDLG_MODE_SAVE )
		{
			// ggf. f"ur SpezialFolder ({network}, {system},...) pr"ufen
			ItemIDPath aTestFolderPath( aFileName );
			Folder aTestFolder( aTestFolderPath );
			bFolder = aTestFolder.IsValid();

			if ( !bFolder )
			{
				ErrorHandler::HandleError( ERRCODE_IO_INVALIDDEVICE );
				return 0;
			}
		}

        if ( bFolder && CntHelperFunctions::IsStorageAnchor( *xAnchor ) )
		{
			INetURLObject aTest( xAnchor->GetServiceURL() );
			SfxFileDialogFilter_Impl* pFilter = pThis->_pImp->_pCurFilter;

			if ( pFilter )
			{
				String aExt = "*.";
				aExt += aTest.GetExtension().ToLowerAscii();
				String aType = pFilter->GetType();
				USHORT nPos = 0, nCount = aType.GetTokenCount();

				for ( USHORT i = 0; i < nCount; ++i )
				{
					String aCmpExt = aType.GetToken( 0, ';', nPos ).ToLowerAscii();

					if ( aCmpExt == aExt )
					{
						bFolder = FALSE;
						break;
					}
				}
			}
		}
*/
	}

	// Pr"ufen, ob der Ordner als Textdarstellung angezeigt werden soll.
    if ( bFolder && INET_PROT_FTP == eProt && SvBinding::ShouldUseFtpProxy( aFileName ) )
        bFolder = FALSE;

	// wenn SpeichernUnter
	// und kein existierender Folder
	// und AutoExtensions an ist
	// und es eine Default-Extension gibt, die ungleich "*" ist
	if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE && !bFolder &&
		 pThis->_pImp->_pCbAutoExtension->IsChecked() &&
		 pThis->_aDefExt.Len() && pThis->_aDefExt != '*' )
	{
		// und diese nicht eh schon dran haengt
		String aExt = DEFINE_CONST_UNICODE("*.");
		INetURLObject aTemp( aFileName );
		aExt += aTemp.GetExtension().ToLowerAscii();
		const String& rType = pThis->_pImp->_pCurFilter->GetType();
		String aType = rType;
		aType.ToLowerAscii();

		if ( ! aType.EqualsAscii(FILEDIALOG_FILTER_ALL) )
		{
			USHORT nWildCard = aType.GetTokenCount( FILEDIALOG_DEF_EXTSEP );
			USHORT nIndex, nPos = 0;

			for ( nIndex = 0; nIndex < nWildCard; nIndex++ )
			{
				if ( aExt == aType.GetToken( 0, FILEDIALOG_DEF_EXTSEP, nPos ) )
					break;
			}

			if ( nIndex >= nWildCard )
			{
				aFileName += '.';
				aFileName += pThis->_aDefExt;
			}
		}
	}

	BOOL bOpenFolder = ( FILEDLG_TYPE_PATHDLG == pThis->_pImp->_eDlgType ||
						 FILEDLG_TYPE_FOLDERDLG == pThis->_pImp->_eDlgType ) &&
					   !pThis->_pImp->_bDoubleClick && pVoid != pThis->_pImp->_pEdFileName;
	if ( bFolder )
	{
/*(mba)
		// Ggf. die Instanz oeffnen.
		if ( aObj.GetMainURL() != pBox->GetViewAnchor()->GetServiceURL() )
		{
			pThis->SaveSettings_Impl();
			// alte URL merken falls neue URL ungueltig
            CntAnchor* pViewAnchor = pBox->GetViewAnchor();
            String aOldPath;
            if( pViewAnchor )
                aOldPath = pViewAnchor->GetViewURL();

			pThis->_pImp->_bBrowseBoxError = FALSE;
			// mit Filename erzeugter Anchor hat keine ViewURL
			String aInitURL;
			if ( bCreateAnchor )
				aInitURL = xAnchor->GetServiceURL();
			else
				aInitURL = xAnchor->GetViewURL();
			pThis->EndListeningAll();

			// Sonderpr"ufung 'Papierkorb'
			CntAnchorRef xTest = new CntAnchor( NULL, aInitURL );
			const CntContentTypeItem& rTypeItem =
				(CntContentTypeItem&)xTest->Get( WID_CONTENT_TYPE );

			if ( rTypeItem.GetEnumValue() == CONTENT_TYPE_X_CNT_TRASHBOX )
			{
				// Papierkorb nicht "offnen
				Sound::Beep();
				return 0;
			}

			pBox->Initialize( aInitURL, pThis );

			if ( pThis->_pImp->_bBrowseBoxError )
			{
				// neue URL ist ungueltig, also Alte wiederherstellen
				pBox->Initialize( aOldPath, pThis );
				bOpenFolder = FALSE;
			}

			pViewAnchor = pBox->GetViewAnchor();

			if (pThis->_pImp->_eMode == FILEDLG_MODE_OPEN)
				((SfxURLBox*)pThis->_pImp->_pEdFileName)->SetBaseURL( pViewAnchor->GetPresentationURL() );

			String aViewURL = pViewAnchor->GetViewURL();
*/
			INetURLObject aTempObj( aFileName );
            String aViewURL( aTempObj.GetMainURL() );
			pThis->_pFileView->Initialize( aViewURL, GetCurrentFilter_Impl( pThis->_pImp ) );
			if ( pThis->_pImp->_bDoubleClick )
				pThis->_pImp->_bFolderHasOpened = sal_True;
			pThis->_pImp->_aViewURL = aViewURL;
			pThis->_aPath = aFileName;

			if (pThis->_pImp->_eMode == FILEDLG_MODE_OPEN)
                ( (SfxURLBox*)pThis->_pImp->_pEdFileName )->SetBaseURL( aViewURL );
            pThis->_pImp->_pFtCurrentPath->SetText( aTempObj.PathToFileName() );

/*
			pBox->SetColumnSettings( (const CntViewColumnsListItem&)
				pViewAnchor->Get( WID_VIEW_COLS_FILEDLG ) );
			pBox->SetSortingItem( (const CntSortingItem&)
				pViewAnchor->Get( WID_VIEW_SORT_FILEDLG ) );
			pThis->FilterBox_Impl( pViewAnchor );
			bFilterChanged = FALSE;
			// Anzeige setzen
			pThis->SetCurPathText_Impl( pViewAnchor );
			// und "offnen
			pBox->Open( TRUE );

		}
		else if ( bFilterChanged )
			// Nur neu filtern.
			pThis->FilterBox_Impl( NULL );
*/
		if ( bOpenFolder )
		{
/* (pb)
			CntAnchor* pAnchor = pThis->_pFileView->GetViewAnchor();
			String aViewURL = pAnchor->GetViewURL();
*/
			pThis->_pImp->_aViewURL = aViewURL;
			pThis->_aPath = aFileName;
		}
		else
			return 0;
	}
    else if ( !bWildCard )
	{
		if ( FILEDLG_TYPE_PATHDLG == pThis->_pImp->_eDlgType )
		{
			// only fsysfolder allowed
            ContentType aType;
            Any aAny( UCB_Helper::GetProperty( aFileName, WID_CONTENT_TYPE ) );
            aAny >>= aType;

/* (pb)
			CntAnchorRef xFolder = new CntAnchor( NULL, aFileName );
			const CntContentTypeItem& rTypeItem =
			(CntContentTypeItem&)xFolder->Get( WID_CONTENT_TYPE );
			INetContentType eType = rTypeItem.GetEnumValue();
*/
            INetContentType eType = CONTENT_TYPE_UNKNOWN;
			FASTBOOL bShowError = FALSE;

			if ( eType != CONTENT_TYPE_X_CNT_FSYSBOX &&
				 eType != CONTENT_TYPE_X_CNT_FSYSFOLDER &&
				 eType != CONTENT_TYPE_X_CNT_REMOVEABLE_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_FIXED_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_REMOTE_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_RAM_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_CDROM_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_DISK_35 &&
				 eType != CONTENT_TYPE_X_CNT_DISK_525 &&
				 eType != CONTENT_TYPE_X_CNT_TAPEDRIVE &&
				 eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFOLDER )
			{
				BOOL bClassPath = ( ( pThis->_pImp->_nStyle & SFXWB_CLASSPATH ) == SFXWB_CLASSPATH );

//(mba)                if ( !bClassPath || ( eType != CONTENT_TYPE_APP_JAR && eType != CONTENT_TYPE_APP_ZIP ) )
//(mba)                    bShowError = TRUE;

				if ( bShowError && pThis->_pImp->_pPathTypes->Count() )
				{
					for ( USHORT i = 0; i < pThis->_pImp->_pPathTypes->Count(); ++i )
					{
						if ( eType == (INetContentType)pThis->_pImp->_pPathTypes->GetObject(i) )
						{
							bShowError = FALSE;
							break;
						}
					}
				}

				if ( bShowError )
				{
					// overload another error context
			    	SfxErrorContext aCtx( ERRCTX_ERROR );
					ErrorHandler::HandleError( ERRCODE_IO_INVALIDDEVICE );
					return 0;
				}
			}
		}
		// Ggf. URL speichern.
        pThis->_aPath = aFileName;
	}
	else
	{
		// Ggf. neu filtern.
		if ( bFilterChanged )
			pThis->ExecuteFilter();
		return 0;
	}

	// Sonderpr"ufungen bei FileSystem-URLs
	BOOL bExists = FALSE;
/*(mba)
	const CntContentTypeItem& rTypeItem =
		(CntContentTypeItem&)pBox->GetViewAnchor()->Get( WID_CONTENT_TYPE );
*/

    if ( /* rTypeItem.GetEnumValue() != CONTENT_TYPE_X_CNT_FSYSSPECIALFOLDER && */
         eProt == INET_PROT_FILE )
	{
		// g"ultiger Dateiname?
		INetURLObject aFileObj( aFileName );
		if ( aFileObj.HasError() )
		{
			ErrorHandler::HandleError( ERRCODE_IO_GENERAL );
			return 0;
		}

		// bei SaveAs Existenz ueberpruefen.
		bExists = SfxContentHelper::Exists( aFileName );

		if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE )
		{
			if ( bExists )
			{
				QueryBox aBox( pThis, WB_YES_NO, SfxResId( STR_SFX_ALREADYEXISTOVERWRITE ) );
				if ( aBox.Execute() != RET_YES )
				{
					return 0;
				}
			}
/*!!! (pb) no Exists()-question any longer
			else
			{
				INetURLObject aPathObj = aFileObj;
				aPathObj.removeSegment();
				if ( !SfxContentHelper::Exists( aPathObj.GetMainURL() ) )
				{
					// der Pfad zum Speichern ist nicht vorhanden!
					ErrorHandler::HandleError( ERRCODE_IO_NOTEXISTSPATH );
					return 0;
				}
			}
*/
		}

		// bei Open evtl. Extension anhaengen
		if ( 0 && !bExists && pThis->_pImp->_eMode == FILEDLG_MODE_OPEN ) //!!! (pb) no Exists()-question any longer
		{
			// Ggf. Endung anhaengen und erneut pruefen.
			String sExt = aFileObj.getExtension();
			if ( pThis->_aDefExt.Len() && pThis->_aDefExt != '*' && !sExt.Len() )
			{
				aFileObj.setExtension( pThis->_aDefExt );
				if ( aFileObj.HasError() )
				{
					// kein g"ultiger Dateiname!
					ErrorHandler::HandleError( ERRCODE_IO_GENERAL );
					return 0;
				}
				bExists = SfxContentHelper::Exists( aFileObj.GetMainURL() );
				pThis->_aPath = aFileObj.GetMainURL();
			}

			if ( !bExists )
			{
				ErrorHandler::HandleError( ERRCODE_IO_NOTEXISTS );
				return 0;
			}
		}
	}

	// Interessenten benachrichtigen.
	long nRet;

	if ( pThis->_aOKHdl.IsSet() )
		nRet = pThis->_aOKHdl.Call( pThis );
	else
		nRet = pThis->OK();

	if ( nRet )
	{
		if ( INetURLObject::CompareProtocolScheme( pThis->_aPath ) == INET_PROT_FILE )
		{
			INetURLObject aTestObj( pThis->_aPath );
			String aMainURL = aTestObj.GetMainURL();
			String aName;

			if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE && !bExists &&
				 aMainURL.GetChar( aMainURL.Len() - 1 ) != INET_PATH_TOKEN )
			{
				aName = aTestObj.GetLastName();
				aTestObj.CutLastName();
				pThis->_aPath = aTestObj.GetMainURL();
			}
/*(mba)
			// bei Dateinamen den R"uckgabewert immer CaseSensitive belassen
			CntAnchorRef xFileAnchor = new CntAnchor( NULL, pThis->_aPath );
			xFileAnchor->Put( SfxVoidItem( WID_GETDATA ) );
			const CntContentTypeItem& rCntItem =
				(CntContentTypeItem&)xFileAnchor->Get( WID_CONTENT_TYPE );
			const INetContentType eType = rCntItem.GetEnumValue();

			if ( eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFOLDER &&
				 eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFILE )
			{
				pThis->_aPath = xFileAnchor->GetCaseSensitiveFileURL();

				if ( aName.Len() )
				{
					if ( pThis->_aPath( pThis->_aPath.Len() - 1 ) !=
						 INET_PATH_TOKEN )
						pThis->_aPath += '/';
					pThis->_aPath += aName;
				}
			}
			else
 */
				pThis->_aPath = aMainURL;
		}
		pThis->UpdateHistory_Impl();
		pThis->EndDialog( TRUE );
	}
	return nRet;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, FilterSelectHdl_Impl, ListBox*, pBox )
{
	DBG_ASSERT( pBox, "SfxFileDialog:keine Instanz" );

	// wurde der Handler vom Travel-Timer gefeuert?
	if ( pBox == (ListBox*)&pThis->_pImp->_aFilterTimer )
	{
		// Anzeige erneut filtern.
		pThis->ExecuteFilter();
		return 0;
	}

	// Filter suchen.
	XubString aFilter;
	// Es gibt "gecachte" Filter, die stehen in der List oben. Deren Namen
	// sind mit '<','>' "dekoriert". Sie haben als EntryData einen Zeiger auf
	// den String mit dem undekorierten Filternamen
	USHORT nSelectedEntry = pBox->GetSelectEntryPos();
	XubString* pEntryData = (XubString*)pBox->GetEntryData ( nSelectedEntry );
	if ( pEntryData )
		aFilter = *pEntryData;
	else
		aFilter = pBox->GetSelectEntry();

	SfxFileDialogFilterList_Impl* pList = pThis->_pImp->_pFilter;
	USHORT nPos = pList->Count();

	while ( nPos-- )
	{
		SfxFileDialogFilter_Impl* pFilter = pList->GetObject( nPos );

		if ( pFilter->GetName() == aFilter )
		{
			if ( pFilter != pThis->_pImp->_pCurFilter || pThis->_pImp->_pUserFilter )
			{
				// Ggf. Filter des Benutzers entfernen.
				DELETEZ( pThis->_pImp->_pUserFilter );
				pThis->_pImp->_pCurFilter = pFilter;

				// Ggf. Endung anzeigen.
				const String& rType = pFilter->GetType();
				pThis->_aDefExt = rType.Copy( 2 );
				USHORT nSepPos = pThis->_aDefExt.Search( FILEDIALOG_DEF_EXTSEP );

				if ( nSepPos != STRING_NOTFOUND )
					pThis->_aDefExt.Erase( nSepPos );

				// beim Speichern
				// und automatischer Dateinamenserweiterung...
				if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE &&
					 pThis->_pImp->_pCbAutoExtension->IsChecked())
				{
					// Dateiextension beim Filterwechsel anpassen
					String aNewFile = pThis->_pImp->_pEdFileName->GetText();
					String aExt = GetFsysExtension_Impl( aNewFile );

					// aber nur wenn bereits eine Endung vorhanden ist
					if ( aExt.Len() )
					{
						SetFsysExtension_Impl( aNewFile, pThis->_aDefExt );
						pThis->_pImp->_pEdFileName->SetText( aNewFile );
					}
				}

				// Ggf. UI anpassen.
				pThis->EnablePasswordBox_Impl();

				// wenn der Benutzer schnell durch die Filterbox
				// travelt, nicht sofort Filtern
				if ( pBox->IsTravelSelect() )
				{
					// FilterSelectHdl_Impl soll in
					// TRAVELFILTER_TIMEOUT ms neu gefeuert werden
					pThis->_pImp->_aFilterTimer.Start();
				}
				else
				{
					// Anzeige erneut filtern.
					pThis->ExecuteFilter();

					// evtl. vorher gestarteten Timer stoppen
					pThis->_pImp->_aFilterTimer.Stop();
				}

				// Interessenten benachrichtigen.
				if ( pThis->_aFilterSelectHdl.IsSet() )
					pThis->_aFilterSelectHdl.Call( pThis );
				else
					pThis->FilterSelect();

			}
			break;
		}
	}

	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, FileNameGetFocusHdl_Impl, void*, EMPTYARG )
{
	pThis->_pFileView->SetNoSelection();
	pThis->_pFileView->Update();
	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxFileDialog, FileNameModifiedHdl_Impl, void*, EMPTYARG )
{
	FileNameGetFocusHdl_Impl( pThis, NULL );
	return 0;
}

//*****************************************************************************

void SfxFileDialog::ConfigControls_Impl()
/*
  [Beschreibung]
  Die Methode versetzt die Steuerelemente in den korrekten Zustand.
  */
{
}

//*****************************************************************************

BOOL SfxFileDialog::FindFilter_Impl
(
	const String& rFilter,
	BOOL bMultiExt, /* TRUE - auch Filter mit mehreren Endungen
					   beruecksichtigen
					   FALSE - keine ... */
	BOOL& rbFilterChanged
)

/*	[Beschreibung]

	Die Methode sucht in den eingef"ugten Filtern nach der
	spezifizierten Endung.
*/

{
	BOOL bFilterFound = FALSE;
	SfxFileDialogFilterList_Impl* pList = _pImp->_pFilter;
	USHORT nFilter = pList->Count();
	const USHORT nFilterCount = nFilter;

	while ( nFilter-- )
	{
		SfxFileDialogFilter_Impl* pFilter = pList->GetObject( nFilter );
		const String& rType = pFilter->GetType();
		String aSingleType = rType;
		USHORT nWildCard = rType.GetTokenCount(	FILEDIALOG_DEF_EXTSEP );

		if ( bMultiExt )
		{
			USHORT nIdx = 0;
			while ( !bFilterFound && nIdx != STRING_NOTFOUND )
			{
				aSingleType = rType.GetToken( 0, FILEDIALOG_DEF_EXTSEP, nIdx );
#ifdef UNX
				if ( aSingleType.CompareTo( rFilter ) == COMPARE_EQUAL )
#else
				if ( aSingleType.CompareIgnoreCaseToAscii( rFilter ) == COMPARE_EQUAL )
#endif
					bFilterFound = TRUE;
			}
		}
#ifdef UNX
		else if ( rType.CompareTo( rFilter ) == COMPARE_EQUAL )
#else
		else if ( rType.CompareIgnoreCaseToAscii( rFilter ) == COMPARE_EQUAL )
#endif
			bFilterFound = TRUE;

		if ( bFilterFound )
		{
			// Filter aktivieren.
			rbFilterChanged = _pImp->_pUserFilter || _pImp->_pCurFilter != pFilter;
			_pImp->_pUserFilter = new SfxFileDialogFilter_Impl( rFilter, rFilter, String(), 0 );
			_aDefExt = aSingleType.Copy( 2 );
			break;
		}
	}
	return bFilterFound;
}

//*****************************************************************************

void SfxFileDialog::ScrollToTop_Impl()

/*	[Beschreibung]

	Die Methode richtet das Fenster so aus,
	dass der oberste Eintrag sichtbar ist.
*/

{
	// muss noch mit der BrowseBox gemacht werden.
}

//*****************************************************************************

void SfxFileDialog::EnablePasswordBox_Impl()

/*	[Beschreibung]

	Die Methode pr"uft, ob das aktuelle Datenformat es zul"asst,
	ob eine Datei mit Passwort gesch"utzt wird und
	passt das UI entsprechend an.
*/

{
	if ( _pImp->_pCbPassword )
	{
		const SfxFilter* pFilter =
			_pImp->_pMatcher->GetFilter4UIName(
				_pImp->_pCurFilter->GetName(), 0, SFX_FILTER_NOTINFILEDLG );
		BOOL bEnablePasswd = pFilter && pFilter->UsesStorage() &&
			pFilter->IsOwnFormat();
		_pImp->_pCbPassword->Enable( bEnablePasswd );
		const SfxPoolItem* pItem;

		if ( bEnablePasswd && _pOutputItemSet &&
			 _pOutputItemSet->GetItemState( SID_PASSWORD, FALSE, &pItem )
			 == SFX_ITEM_SET )
		{
			_pImp->_aPasswd = ( (SfxStringItem*)pItem )->GetValue();
			_pImp->_pCbPassword->Check( TRUE );
			_pOutputItemSet->ClearItem( SID_PASSWORD );
		}
	}
}

//*****************************************************************************

void SfxFileDialog::ExecuteFilter()
{
	String aFileName = _pImp->_pEdFileName->GetText();
	_pFileView->ExecuteFilter( GetCurrentFilter_Impl( _pImp ) );
	_pFileView->SetNoSelection();
	_pImp->_pEdFileName->SetText( aFileName );
}

//*****************************************************************************

void SfxFileDialog::SaveSettings_Impl()

/*	[Beschreibung]

	In dieser Methode werden die aktuellen Konfigurationen der BrowseBox
	am aktuellen Anchor gespeichert.
*/

{
//!	_pFileView->SaveBrowserSettings();
}

//*****************************************************************************

void SfxFileDialog::UpdateHistory_Impl()

/*	[Desription]

	This method forwards the update of the folder history
	to the favorites button.
*/

{
//!	_pImp->_pBtnStandard->UpdateHistory();
}

//*****************************************************************************

void SfxFileDialog::OpenMultiSelection_Impl()

/*	[Beschreibung]

	OpenHandler f"ur MultiSelektion
*/

{
/*(dv)	String aPath;
	SfxAnchorListRef xAnchorList = _pFileView->GetSelectAnchorList();
	USHORT nCount = xAnchorList->Count();

	if ( nCount )
		_aPath = xAnchorList->GetObject(0)->GetServiceURL();

	// Interessenten benachrichtigen.
	long nRet;

	if ( _aOKHdl.IsSet() )
		nRet = _aOKHdl.Call( this );
	else
		nRet = OK();

	if ( nRet )
	{
		delete _pImp->_pPathList;
		_pImp->_pPathList = new SvStringsDtor;
		delete _pImp->_pURLList;
		_pImp->_pURLList = new SvStringsDtor;

		for ( USHORT i = 0; i < nCount; ++i )
		{
			CntAnchorRef xAnchor = xAnchorList->GetObject(i);
			String aURL = xAnchor->GetServiceURL();

			if ( INetURLObject::CompareProtocolScheme( aURL ) == INET_PROT_FILE )
			{
				// bei Dateinamen den R"uckgabewert immer CaseSensitive belassen
				CntAnchorRef xFileAnchor = new CntAnchor( NULL, aURL );
				xFileAnchor->Put( SfxVoidItem( WID_GETDATA ) );
				const CntContentTypeItem& rCntItem =
					(CntContentTypeItem&)xFileAnchor->Get( WID_CONTENT_TYPE );
				const INetContentType eType = rCntItem.GetEnumValue();

				if ( eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFOLDER &&
					 eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFILE )
					aURL = xFileAnchor->GetCaseSensitiveFileURL();
			}
			String* pURL = new String( aURL );
			_pImp->_pPathList->Insert( pURL, _pImp->_pPathList->Count() );
			pURL = new String( xAnchor->GetViewURL() );
			_pImp->_pURLList->Insert( pURL, _pImp->_pURLList->Count() );
		}
		UpdateHistory_Impl();
		EndDialog( TRUE );
	}
*/
}

//*****************************************************************************

IMPL_LINK( SfxFileDialog, SelectHdl_Impl, SvTabListBox*, pBox )
{
	if ( _pImp->_bFolderHasOpened )
		return 0;

	SvLBoxEntry* pEntry = pBox->FirstSelected();
	DBG_ASSERT( pEntry, "SelectHandler without selected entry" );
	ContentEntry_Impl* pUserData = (ContentEntry_Impl*)pEntry->GetUserData();

	if ( pUserData )
	{
		INetURLObject aObj( pUserData->maURL );
		if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType ||	FILEDLG_TYPE_FOLDERDLG == _pImp->_eDlgType )
		{
			if ( aObj.GetProtocol() == INET_PROT_FILE )
			{
				if ( !pUserData->mbIsFolder )
					aObj.removeSegment();
				String aName = aObj.getFSysPath( INetURLObject::FSYS_DETECT );
				_pImp->_pEdFileName->SetText( aName );
				_pImp->_pEdFileName->SetSelection( Selection( 0, aName.Len() ) );
				_aPath = pUserData->maURL;
			}
			else if ( !pUserData->mbIsFolder )
			{
				_pImp->_pEdFileName->SetText( pUserData->maURL );
				_pImp->_pEdFileName->SetSelection( Selection( 0, pUserData->maURL.Len() ) );
				_aPath = pUserData->maURL;
			}
			else
				_pImp->_pEdFileName->SetText( UniString() );
			_pImp->_aViewURL = pUserData->maURL;
		}
		else
		{
			if ( _pImp->_pLbFileVersion->IsReallyVisible() )
				_pImp->_pLbFileVersion->Clear();

			if ( !pUserData->mbIsFolder )
			{
				String aName = pBox->GetEntryText( pEntry, 0 );
				_pImp->_pEdFileName->SetText( aName );
				_pImp->_pEdFileName->SetSelection( Selection( 0, aName.Len() ) );
				_aPath = pUserData->maURL;
			}

			// ggf. die Versions-ListBox f"ullen (StarOffice-Dokumente)
			if ( !pUserData->mbIsFolder &&
			 	_pImp->_pLbFileVersion->IsReallyVisible() && aObj.GetProtocol() == INET_PROT_FILE )
			{
				_pImp->_pLbFileVersion->Clear();
				SfxMedium aMed( aObj.GetMainURL(), SFX_STREAM_READONLY_MAKECOPY, TRUE );
				const SfxVersionTableDtor* pVerTable = aMed.GetVersionList();

				if ( pVerTable )
				{
					_pImp->_pLbFileVersion->InsertEntry( _pImp->_aActualVersion );
					SvStringsDtor* pVersions = pVerTable->GetVersions();

					for ( USHORT i = 0; i < pVersions->Count(); ++i )
						_pImp->_pLbFileVersion->InsertEntry( *(pVersions->GetObject(i)) );
					delete pVersions;
					_pImp->_pLbFileVersion->SelectEntryPos(0);
				}
				else if ( aMed.GetStorage() )
				{
					_pImp->_pLbFileVersion->InsertEntry( _pImp->_aActualVersion );
					_pImp->_pLbFileVersion->SelectEntryPos(0);
				}
			}
		}
	}

/*(dv)	if ( _pImp->_bMultiSelection && _pFileView->GetSelectedAnchorCount() > 1 )
	{
		// bei Multiselektion den Datei-Edit leeren
		_pImp->_pEdFileName->SetText( String() );

		if ( _pImp->_pLbFileVersion->IsReallyVisible() )
			_pImp->_pLbFileVersion->Clear();
		return 0;
	}

	CntAnchor* pAnchor = _pFileView->GetFirstSelectedAnchor();

	if ( !pAnchor )
		return 0;

	String aServiceURL = pAnchor->GetServiceURL();
	String aViewURL = pAnchor->GetViewURL();

	if( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType ||	FILEDLG_TYPE_FOLDERDLG == _pImp->_eDlgType )
	{
		if ( INET_PROT_FILE ==
			 INetURLObject::CompareProtocolScheme( aServiceURL ) )
		{
			String aName = DirEntry( aServiceURL ).GetFull();
			_pImp->_pEdFileName->SetText( aName );
			_pImp->_pEdFileName->SetSelection( Selection( 0, aName.Len() ) );
			_aPath = aServiceURL;
		}
		else
		{
			_pImp->_pEdFileName->SetText( aServiceURL );
			_pImp->_pEdFileName->SetSelection( Selection( 0, aServiceURL.Len() ) );
			_aPath = aServiceURL;
		}
		_pImp->_aViewURL = aViewURL;
	}
	else
	{
		if ( _pImp->_pLbFileVersion->IsReallyVisible() )
			_pImp->_pLbFileVersion->Clear();

		INetURLObject aObj( aServiceURL );
		String aLastName( aObj.GetLastName() );
		FASTBOOL bFolder =
			ITEMSET_VALUE( pAnchor, SfxBoolItem, WID_FLAG_IS_FOLDER );

		if ( !bFolder )
		{
			aLastName = ITEMSET_VALUE( pAnchor, CntStringItem, WID_REAL_NAME );

			if ( !aLastName )
				aLastName = ITEMSET_VALUE( pAnchor, CntStringItem, WID_TITLE );
			_pImp->_pEdFileName->SetText( aLastName );
			_pImp->_pEdFileName->SetSelection( Selection( 0, aLastName.Len() ) );
			_aPath = aObj.GetMainURL();
		}

		// ggf. die Versions-ListBox f"ullen (StarOffice-Dokumente)
		if ( !bFolder &&
			 _pImp->_pLbFileVersion->IsReallyVisible() && aObj.GetProtocol() == INET_PROT_FILE )
		{
			_pImp->_pLbFileVersion->Clear();
			SfxMedium aMed( aObj.GetMainURL(), SFX_STREAM_READONLY_MAKECOPY, TRUE );
			const SfxVersionTableDtor* pVerTable = aMed.GetVersionList();

			if ( pVerTable )
			{
				_pImp->_pLbFileVersion->InsertEntry( _pImp->_aActualVersion );
				SvStringsDtor* pVersions = pVerTable->GetVersions();

				for ( USHORT i = 0; i < pVersions->Count(); ++i )
					_pImp->_pLbFileVersion->InsertEntry( *(pVersions->GetObject(i)) );
				delete pVersions;
				_pImp->_pLbFileVersion->SelectEntryPos(0);
			}
			else if ( aMed.GetStorage() )
			{
				_pImp->_pLbFileVersion->InsertEntry( _pImp->_aActualVersion );
				_pImp->_pLbFileVersion->SelectEntryPos(0);
			}
		}
	}
*/

	// ggf. Interessenten benachrichtigen.
	if ( FILEDLG_TYPE_FILEDLG == _pImp->_eDlgType )
	{
		if ( _aFileSelectHdl.IsSet() )
			_aFileSelectHdl.Call( this );
		else
			FileSelect();
	}

	return 0;
}

//*****************************************************************************

IMPL_LINK( SfxFileDialog, DblClickHdl_Impl, SvTabListBox*, EMPTYARG )
{
	_pImp->_bDoubleClick = TRUE;
	OpenHdl_Impl( this, NULL );
	_pImp->_bDoubleClick = FALSE;

	if ( _pImp->_bFolderHasOpened )
		_pImp->_aResetCursorTimer.Start();

	return 0;
}

//*****************************************************************************

IMPL_LINK( SfxFileDialog, EntrySelectHdl_Impl, ComboBox*, EMPTYARG )
{
	// beim Select in der AutoComplete-ComboBox nichts machen
	return 0;
}

//*****************************************************************************

IMPL_LINK( SfxFileDialog, OpenDoneHdl_Impl, SfxFileView_Impl*, pView )
{
	_pImp->_aCWD = pView->GetViewURL();
	return 0;
}

//*****************************************************************************

IMPL_LINK( SfxFileDialog, ResetCursorHdl_Impl, Timer*, EMPTYARG )
{
	_pFileView->ResetCursor();
	_pImp->_bFolderHasOpened = sal_False;
	return 0;
}

//*****************************************************************************

long SfxFileDialog::PreNotify( NotifyEvent& rNEvt )

/*	[Beschreibung]

	Die Methode wird gerufen, <BACKSPACE> abzufangen.
*/

{
	USHORT nType = rNEvt.GetType();
	long nRet = 0;

	if ( EVENT_KEYINPUT == nType && rNEvt.GetKeyEvent() )
	{
		const KeyCode& rKeyCode = rNEvt.GetKeyEvent()->GetKeyCode();
		USHORT nCode = rKeyCode.GetCode();

		if ( !rKeyCode.GetModifier() &&
			 KEY_BACKSPACE == nCode && !_pImp->_pEdFileName->HasChildPathFocus() )
		{
			nRet = 0; //! (long)_pFileView->DoBeamerKeyInput( *rNEvt.GetKeyEvent() );

			if ( !nRet && _pImp->_pBtnUp->IsEnabled() )
			{
				PrevLevel_Impl();
				nRet = 1;
			}
		}
		else if ( KEY_TAB == nCode )
		{
			if ( ( rKeyCode.IsShift() && _pImp->_pEdFileName->HasChildPathFocus() ) ||
				 ( !rKeyCode.GetModifier() && _pImp->_pBtnStandard->HasChildPathFocus() ) )
			{
				SetFocusInViewControl();
				nRet = 1;
			}
		}
		else if ( rKeyCode.IsMod1() && ( KEY_C == nCode || KEY_V == nCode || KEY_X == nCode ) )
		{
			String aVerb = KEY_C == nCode ? DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_COPY) :
				( KEY_V == nCode ? DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_PASTE) : DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_CUT) );
//(dv)			if ( !CntPopupMenu::DoVerbCommand( aVerb, _pFileView->GetView() ) )
//(dv)				Sound::Beep();
		}
	}
	return nRet ? nRet : VclFileDialog::PreNotify( rNEvt );
}

//*****************************************************************************

void SfxFileDialog::Notify( SfxBroadcaster& rBC, const SfxHint& rHint )

/*  [Beschreibung]

	Die Methode wird gerufen, um die Instanz zu benachrichtigen.
*/

{
/*(dv)	CntStatusHint* pStatHint = PTR_CAST(CntStatusHint, &rHint);
	if ( pStatHint )
	{
		const SfxPoolItem* pReq = pStatHint->GetRequest();
		if( pReq )
		{
			switch( pReq->Which() )
			{
				case WID_OPEN:
				{
					NotifyData_Impl* pHint = new NotifyData_Impl( *pStatHint );
					_pImp->_aNotifier.Lock();

					BOOL bNeedCall = ! _pImp->_aNotifier.HasEntries();

					_pImp->_aNotifier.CreateNew( pHint );

					NAMESPACE_VOS(IMutex) &rMutex = Application::GetSolarMutex();
					if ( rMutex.tryToAcquire() )
					{
						HandleNotify( NULL );
						rMutex.release();
					}
					else if ( bNeedCall )
					{
						_pImp->_aNotifier.Call();
					}

					_pImp->_aNotifier.Unlock();
					break;
				}

				case WID_GETDATA:
				{
					// Hack: hier wird sich gemerkt das die Browsebox
					// einen ungueltigen Path oeffnen sollte
					if(pStatHint->GetError() != ERRCODE_NONE)
						_pImp->_bBrowseBoxError = TRUE;
				}
			}
		}
	}
*/
}

// -----------------------------------------------------------------------

IMPL_LINK( SfxFileDialog, HandleNotify, void*, pVoid )
{
/*(dv)	_pImp->_aNotifier.Lock();
	NotifyData_Impl	*pHint = (NotifyData_Impl*)_pImp->_aNotifier.GetAndRemoveFirst();
	while ( pHint )
	{
		if ( pHint->GetType() == CNT_STATUS_HINT )
		{
			USHORT nWhich = pHint->GetWhich();
			switch ( nWhich )
			{
				case WID_OPEN :
				{
					const ErrCode nErr = pHint->GetError();
					CntAnchor* pAnchor = _pFileView->GetViewAnchor();
//					CntAnchor* pAnchor = PTR_CAST( CntAnchor, &rBC );
//					DBG_ASSERT( pAnchor, "Broadcaster kein CntAnchor" );

					if ( CNT_STATUS_STARTED == pHint->GetStatus() )
					{
						if ( !IsWait() )
							EnterWait();
						_pImp->_bHasWaitCursor = TRUE;
						_pFileView->EnableInput( FALSE, TRUE );
					}
					else
					{
						_pFileView->SetNewGrid( pAnchor );
						while ( IsWait() )
							LeaveWait();
						_pImp->_bHasWaitCursor = FALSE;
						_pFileView->EnableInput( TRUE, TRUE );
					}

					if ( CNT_STATUS_DONE == pHint->GetStatus() )
					{
						String aParentURL = pAnchor->GetParentViewURL();
						if ( !aParentURL && CntHelperFunctions::IsStorageAnchor( *pAnchor ) )
						{
							// StorageAnchor haben ggf. einen Parent (Adressbuch, Schedule,...)
							INetURLObject aURLObj( pAnchor->GetViewURL() );

							if ( pAnchor->GetServiceURL() != "file:///" && !aURLObj.HasMark() &&
									aURLObj.GetProtocol() == INET_PROT_FILE )
								aParentURL = aURLObj.GetMainURL();
						}
						_pImp->_pBtnUp->Enable( aParentURL.Len() > 0 );

						USHORT nFacPos = GetFolderFactoryPos_Impl( pAnchor );
						_pImp->_pBtnNewFolder->Enable( nFacPos != CNTFACTORY_NOTFOUND );
						INetURLObject aObj( pAnchor->GetServiceURL() );

						if ( aObj.GetProtocol() == INET_PROT_FILE )
						{
							// Ordner als aktuelles Verzeichnis setzen.
							String aMainURL = aObj.GetMainURL();

							if ( "file:///" != aMainURL )
							{
								DirEntry aFolder( aMainURL );
								_pImp->_aCWD = aFolder.GetFull();
							}
							else
								_pImp->_aCWD.Erase();
						}
						SetCurPathText_Impl( pAnchor );
					}
				}
			}
		}

		delete pHint;
		pHint = (NotifyData_Impl*) _pImp->_aNotifier.GetAndRemoveFirst();
	}

	_pImp->_aNotifier.Unlock();
*/	return 0;
}

//*****************************************************************************

void SfxFileDialog::FillItemSet( SfxItemSet& rSet )

/*	[Beschreibung]

	Die Methode wird gerufen, um die Daten, wie z.B. den Dateinamen,
	f"ur die Aktion zu bestimmen.
*/

{
	if ( _pImp->_pAccel )
		rSet.Put( SfxBoolItem( SID_LOAD_LAYOUT, _pImp->_bLoadLayout ) );
	if ( _pCbReadOnly )
	{
		BOOL bReadOnly = _pCbReadOnly->IsChecked();
		if ( !bReadOnly && !_pImp->_pPathList )
		{
			SfxMedium aMed( _aPath, SFX_STREAM_READONLY_MAKECOPY, TRUE );
			if ( aMed.IsRemote() )
				bReadOnly = TRUE;
		}
		rSet.Put( SfxBoolItem( SID_DOC_READONLY, bReadOnly ) );
	}
	if ( _pImp->_pCbPassword && _pImp->_pCbPassword->IsChecked() )
		rSet.Put( SfxStringItem( SID_PASSWORD, _pImp->_aPasswd ) );

	rSet.Put( SfxStringItem( SID_FILE_NAME, _aPath ) );

	USHORT nPos = _pImp->_pLbFileVersion->GetSelectEntryPos();
	if ( nPos > 0 && nPos != LISTBOX_ENTRY_NOTFOUND )
		rSet.Put( SfxInt16Item( SID_VERSION, nPos ) );

	if ( _pImp->_pCbOptions && _pImp->_pCbOptions->IsEnabled() )
		rSet.Put( SfxBoolItem( SID_USE_FILTEROPTIONS, _pImp->_pCbOptions->IsChecked() ) );
}

//*****************************************************************************

long SfxFileDialog::OK()
{
	if ( _pImp->_pCbPassword && _pImp->_pCbPassword->IsEnabled() &&
		 _pImp->_pCbPassword->IsChecked() && !_pImp->_aPasswd.Len() )
	{
		// Passwort abfragen.
		SfxPasswordDialog aPasswordDlg( this );
		aPasswordDlg.ShowExtras( SHOWEXTRAS_CONFIRM );
		BOOL bOK = FALSE;
		short nRet = aPasswordDlg.Execute();
		if ( RET_OK == nRet )
		{
			String aPasswd = aPasswordDlg.GetPassword();
			String aConfirm = aPasswordDlg.GetConfirm();
			if ( aPasswd == aConfirm )
			{
				_pImp->_aPasswd = aPasswd;
				bOK = TRUE;
			}
		}
		else
			return FALSE;

		// ggf. Fehlermeldung anzeigen.
		if ( !bOK )
		{
			ErrorBox( this, WB_OK, SfxResId( MSG_ERROR_PASSWD ) ).Execute();
			return FALSE;
		}
	}
	else if ( _pImp->_pCbPassword && _pImp->_pCbPassword->IsEnabled() &&
			  !_pImp->_pCbPassword->IsChecked() )
	{
		_pImp->_aPasswd.Erase();
	}

	return TRUE;
}

//*****************************************************************************

class SfxDefModalDialogParent_Impl
{
private:
	Window*	_pOld;

public:
	SfxDefModalDialogParent_Impl( Window *pNew ) :
		_pOld( Application::GetDefDialogParent() )
		{ Application::SetDefDialogParent( pNew ); }

	~SfxDefModalDialogParent_Impl() { Application::SetDefDialogParent( _pOld ); }
};

//*****************************************************************************

short SfxFileDialog::Execute()
{
	SfxApplication* pSfxApp = SFX_APP();

	if ( _pImp->_eMode == FILEDLG_MODE_SAVE && !_pImp->_bShowOptionsBox )
	{
		// CheckBox "Filtereinstellungen" nicht anzeigen,
		// wenn Filter mit diesem Feature gar nicht vorhanden sind
		DELETEZ(_pImp->_pCbOptions);
		// dadurch fehlt ein Control
		_pImp->_nUserControls--;
	}

	// Alle Controls die nach Init_impl in den Dialog eingefuegt wurden
	// werden hier in der Tabreihenfolge vor den Oeffnen Button verschoben
	// #49066#
	const USHORT nChildCount = GetChildCount();

	if ( nChildCount != _pImp->_nUserControls )
	{
		_pImp->_nUserControls = nChildCount - _pImp->_nUserControls;

		// Elemente positionieren.
		USHORT nChild = nChildCount;
		nChild -= _pImp->_nUserControls;

		for ( ; nChild < nChildCount; ++nChild )
		{
			Window* pWnd = GetChild( nChild );

			if ( pWnd )
			{
				pWnd->SetZOrder(_pImp->_pBtnFileOpen, WINDOW_ZORDER_BEFOR );

				if ( !_pImp->_pExtControls )
					_pImp->_pExtControls = new List;
				_pImp->_pExtControls->Insert( pWnd->GetWindow( WINDOW_CLIENT ), LIST_APPEND );
			}
		}
	}

	// #53016# evtl. nur ein Filename ohne Pfad?
	String aFileNameOnly;
	if( _aPath.Len() && (_pImp->_eMode == FILEDLG_MODE_SAVE)
					 && (_aPath.Search(':') == STRING_NOTFOUND)
					 && (_aPath.Search('\\') == STRING_NOTFOUND)
					 && (_aPath.Search('/') == STRING_NOTFOUND))
	{
		aFileNameOnly = _aPath;
		_aPath.Erase();
	}

	// im Pfaddialog nur File-Protokoll g"ultig
	if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType )
	{
		if ( _aPath.Len() )
		{
			INetURLObject aTemp;
			aTemp.SetSmartURL( _aPath );
			if ( aTemp.GetProtocol() != INET_PROT_FILE )
				_aPath.Erase();
		}

		if ( !_aPath.Len() && _pImp->_aPathURL.Len() )
			_aPath = _pImp->_aPathURL;
	}

	// kein Startpfad angegeben?
	if ( !_aPath.Len() )
	{
		// gemerkter Pfad vorhanden?
		String aLastURL( pSfxApp->GetLastDir_Impl() );

		if ( aLastURL.Len() )
		{
			// falls lokales Verzeichnis testen...
			INetURLObject aLastObj( aLastURL );
			aLastObj.setFinalSlash();
			if ( aLastObj.GetProtocol() == INET_PROT_FILE )
			{
				// ob auch physikalisch vorhanden
				aLastURL = aLastObj.GetMainURL();
				if ( 1 || SfxContentHelper::Exists( aLastURL ) ) //!!! (pb) no Exists()-question any longer
					_aPath = aLastURL;
			}
			else
				_aPath = aLastURL;
		}

		// hat es nicht geklappt?
		if ( !_aPath.Len() )
		{
			// dann das Standard-Dir verwenden
			INetURLObject aWorkPathObj( _pImp->GetStandardDir(), INET_PROT_FILE );
			aWorkPathObj.setFinalSlash();
			String aWorkPathURL = aWorkPathObj.GetMainURL();
			if ( 1 || SfxContentHelper::Exists( aWorkPathURL ) ) //!!! (pb) no Exists()-question any longer
				_aPath = aWorkPathURL;
			else
				_aPath = DEFINE_CONST_UNICODE( "file:///" );
		}

		// #53016# vorgegebener Dateiname an Pfad anh"angen
		if ( aFileNameOnly.Len() )
			_aPath += aFileNameOnly;
	}

	INetURLObject aTemp;
	aTemp.SetSmartURL( _aPath );
	_aPath = aTemp.GetMainURL();

	if ( aTemp.GetProtocol() == INET_PROT_FILE )
	{
		if ( SfxContentHelper::IsFolder( _aPath ) )
		{
			aTemp.setFinalSlash();
			_aPath = aTemp.GetMainURL();
		}
	}

	// Instanz als aktiv Dialog speichern,
	// vorher ggf. den alten aktiven Dialog merken.
	SfxFileDialog* pOldActiveDlg = _pActiveDlg;
	_pActiveDlg = this;

	// Ggf. Filter anzeigen.
	_pImp->_pLbFilter->Clear();
	USHORT nPos = _pImp->_pFilter->Count();
	while ( nPos-- )
	{
		SfxFileDialogFilter_Impl* pFilter = _pImp->_pFilter->GetObject( nPos );
		_pImp->_pLbFilter->InsertEntry( pFilter->GetName() );
	}

	// Initialen Filter einstellen.
	USHORT nFilterCount = GetFilterCount();
	String aAll( SfxResId( STR_FILTERNAME_ALL ) );
	BOOL bHasAll = _pImp->_pLbFilter->GetEntryPos( aAll ) != LISTBOX_ENTRY_NOTFOUND;
	if ( _pImp->_pCurFilter || nFilterCount == 1 || ( nFilterCount == 2 && bHasAll ) )
	{
		// Ggf. einzigen Filter als aktuellen Filter setzen oder den einzigen
		// Filter, der nicht auf alle Dateien verweist.
		if ( !_pImp->_pCurFilter )
		{
			nPos = 0;
			if ( 2 == nFilterCount && bHasAll )
			{
				nPos = nFilterCount;
				while ( nPos-- )
				{
					if ( GetFilterName( nPos ) != aAll )
						break;
				}
			}
			SetCurFilter( GetFilterName( nPos ) );
		}

		// Anzeige anpassen.
		_pImp->_pLbFilter->SelectEntry( _pImp->_pCurFilter->GetName() );
		String aType( _pImp->_pCurFilter->GetType() );
		_aDefExt = aType.Copy( 2 );
		USHORT nSepPos = _aDefExt.Search( FILEDIALOG_DEF_EXTSEP );
		if ( nSepPos != STRING_NOTFOUND )
			_aDefExt.Erase( nSepPos );
	}
	else
	{
		// Ggf. Filter fuer alle Dateien setzen bzw. erzeugen.
		if ( !bHasAll )
		{
			AddFilter( aAll, DEFINE_CONST_UNICODE(FILEDIALOG_FILTER_ALL) );
			SetCurFilter( aAll );
			_pImp->_pLbFilter->InsertEntry( aAll );
		}
		_pImp->_pLbFilter->SelectEntry( aAll );
	}

	_pImp->_pDefaultFilter = _pImp->_pCurFilter;

	// HACK #50065#
	// ggf. Filter isolieren.
	String aFilter;
	String aEmpty;

	if ( !IsolateFilterFromPath_Impl( _aPath, aFilter ) )
		return 0;

	if ( aFilter.Len() != 0 )
	{
		BOOL bFilterChanged = TRUE;

		// Nach einem korrespondierenden Filter suchen.
		BOOL bFilterFound = FindFilter_Impl( aFilter, FALSE, bFilterChanged );
		if ( !bFilterFound )
			bFilterFound = FindFilter_Impl( aFilter, TRUE, bFilterChanged );

		// Ggf. neuen Filter erzeugen.
		if ( !bFilterFound )
		{
			// Neuen Filter generieren.
			delete _pImp->_pUserFilter;
			_pImp->_pUserFilter = new SfxFileDialogFilter_Impl( aFilter, aFilter, aEmpty, 0 );

			// Anzeige anpassen.
			String aFilterDesc( aFilter );
			if ( aFilter.EqualsAscii(FILEDIALOG_FILTER_ALL) )
			{
				aFilterDesc = String( SfxResId( STR_FILTERNAME_ALL ) );
				_aDefExt.Erase();
			}
			else
				_aDefExt = aFilter.Copy( 2 );

			_pImp->_pEdFileName->SetText( aFilter );
			_pImp->_pLbFilter->SelectEntry( aFilterDesc );
		}
	}
	// HACK #50065#

	// Instanz fuer den gesetzten Pfad erzeugen und anzeigen.
	INetURLObject aFolderURL( _aPath );
	String aFileName( aFolderURL.getName( INetURLObject::LAST_SEGMENT, false ) );
	USHORT nFileNameLen = aFileName.Len();
	BOOL bFileToSelect;
	if ( ( bFileToSelect = nFileNameLen && aFileName.GetChar( nFileNameLen - 1 ) != INET_PATH_TOKEN ) )
	{
		_pImp->_pEdFileName->SetText( GET_DECODED_NAME( aFolderURL ) );
		aFolderURL.removeSegment();
	}
	//! URL existiert?
	INetURLObject aObj = aFolderURL;
	String aPathToShow = aObj.GetURLNoPass();

	if ( aObj.GetProtocol() == INET_PROT_FILE )
	{
		// Ordner als aktuelles Verzeichnis setzen.
		aObj.setFinalSlash();
		aPathToShow = aObj.getFSysPath( INetURLObject::FSYS_DETECT );
		_pImp->_aCWD = aObj.GetMainURL();
	}

	// Im Pfad-Auswahl Dialog wird der geoeffnete Pfad
	// auch in die Eingabe kopiert
	if(FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType ||
	   FILEDLG_TYPE_FOLDERDLG == _pImp->_eDlgType )
		_pImp->_pEdFileName->SetText( aPathToShow );

    if (_pImp->_eMode == FILEDLG_MODE_OPEN)
        ((SfxURLBox*)_pImp->_pEdFileName)->SetBaseURL( aObj.GetURLNoPass() );
    _pImp->_pFtCurrentPath->SetText( aPathToShow );

	// Zustand der Steuerelemente anpassen.
	ConfigControls_Impl();
	EnablePasswordBox_Impl();
	EndListeningAll();
	String aIniKey = _pImp->_aIniKey;
	if ( !aIniKey.Len() )
		aIniKey = DEFINE_CONST_UNICODE("FileDialogSize");
	String aIniStr = SFX_INIMANAGER()->Get( SFX_GROUP_VIEW, aIniKey );
	BOOL bBrowser = (BOOL)(USHORT)aIniStr.GetToken( 2, ',' ).ToInt32();
//!	_pFileView->SetBrowserMode( bBrowser, FALSE );
	ViewHdl_Impl( this, NULL );
	_pFileView->Initialize( aObj.GetMainURL(), GetCurrentFilter_Impl( _pImp ) );
/*(dv)	CntAnchor* pViewAnchor = _pFileView->GetViewAnchor();
	if (_pImp->_eMode == FILEDLG_MODE_OPEN)
		((SfxURLBox*)_pImp->_pEdFileName)->SetBaseURL( pViewAnchor->GetPresentationURL() );
	SetCurPathText_Impl( pViewAnchor );
	_pFileView->SetColumnSettings( (const CntViewColumnsListItem&)
		pViewAnchor->Get( WID_VIEW_COLS_FILEDLG ) );
	_pFileView->SetSortingItem( (const CntSortingItem&)
		pViewAnchor->Get( WID_VIEW_SORT_FILEDLG ) );
	FilterBox_Impl( pViewAnchor );
	_pFileView->Open( TRUE );
*/
	_pFileView->Show();
	SfxDefModalDialogParent_Impl aDefParent( this );

	// HACK: #51557# HTML Filter nach oben verschieben
	USHORT nCount = _pImp->_pLbFilter->GetEntryCount();
	USHORT nInsertPos = 0;
	// 1. HTML (StarWriter) Filter suchen
	while(nInsertPos < nCount)
	{
		String aFilter = _pImp->_pLbFilter->GetEntry(nInsertPos);
		if(aFilter.SearchAscii("HTML") == 0)
			break;
		nInsertPos++;
	}

	//2. HTML Filter suchen
	if ( nInsertPos < nCount )
	{
		USHORT nPos = nInsertPos + 1;
		while ( nPos < nCount )
		{
			String aFilter = _pImp->_pLbFilter->GetEntry( nPos );
			if ( aFilter.EqualsAscii("HTML") )
			{
				_pImp->_pLbFilter->RemoveEntry( nPos );
				_pImp->_pLbFilter->InsertEntry( aFilter, nInsertPos );
			}
			nPos++;
		}

	}

	if ( _pImp->_eMode == FILEDLG_MODE_OPEN )
		_pImp->InitFilterCache_Impl();

	// vorher noch den Statustext der Schnellsuche l"oschen
//(dv)	pSfxApp->Broadcast( CntViewHint( CNTVIEWHINT_RESET_QUICKSEARCH ) );

	// ggf. Gr"osse aus Ini lesen und setzen
	if ( !_pImp->_aIniKey.Len() )
		InitSize( DEFINE_CONST_UNICODE("FileDialogSize") );

	// nach InitSize ist MinOutputSizePixel gesetzt
	// maximale Grid-Breite der SmallIconView auf halbe minimale Control-Breite setzen
//!	_pFileView->SetMaxGridWidth( GetMinOutputSizePixel().Width() / 2 );

	// Start des Dialogs.
	short nResult = VclFileDialog::Execute();

	// nachher den Statustext der Schnellsuche l"oschen
//(dv)	pSfxApp->Broadcast( CntViewHint( CNTVIEWHINT_RESET_QUICKSEARCH ) );

	// Ggf. Daten fuer die Aktion einsammeln.
	if ( _pOutputItemSet )
		FillItemSet( *_pOutputItemSet );

	// letztes Verzeichnis merken
	if ( RET_OK == nResult )
	{
		if ( !_pImp->_bDisableSaveLastDir )
		{
			INetURLObject aURL( _aPath );
			if ( aURL.GetProtocol() == INET_PROT_FILE )
			{
				// nur bei File-URL's und nicht bei virtuelle Folder
				// das ausgew"ahlte Verzeichnis merken
				USHORT nLevel = aURL.getSegmentCount();
				sal_Bool bDir = SfxContentHelper::IsFolder( aURL.GetMainURL() );
				BOOL bClassPath = ( ( _pImp->_nStyle & SFXWB_CLASSPATH ) == SFXWB_CLASSPATH );
				if ( nLevel > 1 && ( FILEDLG_TYPE_FILEDLG == _pImp->_eDlgType || !bDir ) )
					aURL.removeSegment();
				pSfxApp->SetLastDir_Impl( aURL.GetMainURL() );
			}
		}

		// benutzen Filter cachen (UserFilter, DefaultFilter und <Alle> nicht, nur im
		// FileOpen-Mode)
		String aAll( SfxResId( STR_FILTERNAME_ALL ) );
		if( !_pImp->_pUserFilter
			&& aAll.CompareTo(_pImp->_pCurFilter->GetName()) != COMPARE_EQUAL
			&& _pImp->_eMode == FILEDLG_MODE_OPEN
			&& _pImp->_pDefaultFilter != _pImp->_pCurFilter )
			_pImp->CacheFilter_Impl(_pImp->_pCurFilter->GetName());
	}

	// AutoExtension-Flag merken
	if ( _pImp->_pCbAutoExtension )
		SFX_INIMANAGER()->Set( _pImp->_pCbAutoExtension->IsChecked() ? '1' : '0',
				SFX_KEY_FILEDIALOGEXT );

	if(_pImp->_eMode == FILEDLG_MODE_OPEN)
		_pImp->SaveFilterCache_Impl();

	// Markierung als aktive Instanz aufheben
	_pActiveDlg = pOldActiveDlg;

	return nResult;
}

//*****************************************************************************

void SfxFileDialog::FileSelect()
{
}

//*****************************************************************************

void SfxFileDialog::FilterSelect()
{
}

//*****************************************************************************

INetFtpConnection* SfxFileDialog::GetFtpConnection() const
/*
	[Beschreibung]
	Die Methode liefert ggf. die Verbindung zu einem Server, von dem die
	Datei ausgewaehlt wurde.
	*/
{
	return NULL;
}

//*****************************************************************************

void SfxFileDialog::SetStandardDir(	const String& rStdDir )

/*	[Beschreibung]

	Die Methode setzt den Pfad f"ur den Standardknopf.
*/

{
	INetURLObject aObj( rStdDir, INET_PROT_FILE );
	aObj.setFinalSlash();
	_pImp->SetStandardDir( aObj.GetMainURL() );
}

//*****************************************************************************

const String& SfxFileDialog::GetStandardDir() const

/*	[Beschreibung]

	Diese Methode gibt den eingestellten Standardpfad zur"uck.
*/

{
	return _pImp->GetStandardDir();
}

//*****************************************************************************

const String& SfxFileDialog::GetViewURL() const

/*	[Beschreibung]

	Diese Methode gibt die ausgew"ahlte ViewURL zur"uck.
*/

{
	return _pImp->GetViewURL();
}

//*****************************************************************************

void SfxFileDialog::PrevLevel_Impl()
{
	String aNewURL;
	if ( _pFileView->PreviousLevel( aNewURL ) )
	{
	    if ( _pImp->_eMode == FILEDLG_MODE_OPEN )
    	    ( (SfxURLBox*)_pImp->_pEdFileName )->SetBaseURL( aNewURL );
		String aText;
		INetURLObject aNewObj( aNewURL );
		if ( aNewObj.getSegmentCount() > 1 || !SfxContentHelper::GetTitle( aNewURL, aText ) )
			aText = aNewObj.getFSysPath( INetURLObject::FSYS_DETECT );
		_pImp->_pFtCurrentPath->SetText( aText );
	}
}

//*****************************************************************************

void SfxFileDialog::OpenURL_Impl( const String& rURL )
{
    if ( _pImp->_eMode == FILEDLG_MODE_OPEN )
        ( (SfxURLBox*)_pImp->_pEdFileName )->SetBaseURL( rURL );

    _pImp->_pFtCurrentPath->SetText( INetURLObject( rURL ).PathToFileName() );
	_pFileView->Initialize( rURL, GetCurrentFilter_Impl( _pImp ) );
}

//*****************************************************************************

void SfxFileDialog::SetSmartPath( const String& rPath )

/*	[Beschreibung]

  Die Methode erweitert die Methode <SfxFileDialog::SetPath> um einen
  schlaueren Mechanismus zur Auswertung des gegebenen Dateinamens.
*/

{
	INetURLObject aObj( rPath, INET_PROT_FILE );
	if ( aObj.GetProtocol() == INET_PROT_FILE )
	{
		// Pr"ufen, ob eine Datei unter diesem Namen existiert.
		if ( !SfxContentHelper::Exists( aObj.GetMainURL() ) )
		{
/*! (pb) don't use it anymore
			// Dateinamen kuerzen.
			String aName = aObj.GetLastName();
			aEntry = aObj.GetPartBeforeLastName();
			aEntry.MakeShortName( aName );
			SetPath( aEntry.GetFull(FSYS_STYLE_URL) );
			return;
*/
		}
		SetPath( rPath );
	}
	else
	{
		String aName = aObj.GetLastName();
		// ggf. dekodieren ('%20' -> ' ')
		aName = INetURLObject::decode( aName, INET_HEX_ESCAPE, INetURLObject::DECODE_WITH_CHARSET );
		if ( aName.Len() )
			SetPath( aName );
	}
}

//*****************************************************************************

void SfxFileDialog::AddFilter( const String& rFilter, const String& rType, ULONG nFlags )
{
	AddFilter( rFilter, rType, String(), nFlags );
}

//*****************************************************************************

void SfxFileDialog::AddFilter( const String& rFilter, const String& rType,
							   const String& rSysType,ULONG nFlags )
{
	DBG_ASSERT( !IsInExecute(), "SfxFileDialog:aktiv" );

	if ( ( nFlags & SFX_FILTER_CONSULTSERVICE ) == SFX_FILTER_CONSULTSERVICE )
		// dieser Filter muss erst gekauft werden
		return;

	SfxFileDialogFilter_Impl* pFilter =	new SfxFileDialogFilter_Impl( rFilter, rType, rSysType, nFlags );
	_pImp->_pFilter->C40_INSERT( SfxFileDialogFilter_Impl, pFilter, 0 );
	_pImp->_bShowOptionsBox |= pFilter->HasOptionsDialog();
}

//*****************************************************************************

void SfxFileDialog::RemoveFilter( const String& rFilter )
{
	DBG_ASSERT( !IsInExecute(), "SfxFileDialog:aktiv" );
	USHORT nPos = _pImp->_pFilter->Count();
	while ( nPos-- )
	{
		SfxFileDialogFilter_Impl* pFilter = _pImp->_pFilter->GetObject( nPos );
		if ( pFilter->GetName() == rFilter )
		{
			_pImp->_pFilter->DeleteAndDestroy( nPos );
			if ( pFilter == _pImp->_pCurFilter )
				_pImp->_pCurFilter = NULL;
			break;
		}
	}
}

//*****************************************************************************

void SfxFileDialog::RemoveAllFilter()
{
	DBG_ASSERT( !IsInExecute(), "SfxFileDialog:aktiv" );
	_pImp->_pFilter->DeleteAndDestroy( 0, _pImp->_pFilter->Count() );
	_pImp->_pCurFilter = NULL;
}

//*****************************************************************************

void SfxFileDialog::SetCurFilter
(
	const String& rFilter
)
{
	DBG_ASSERT( !IsInExecute(), "SfxFileDialog:aktiv" );

	// Ggf. konvertieren.
	String aRealFilterName( rFilter );
	if( _pImp->_pMatcher )
	{
		const SfxFilter* pFilter = _pImp->_pMatcher->GetFilter(
			aRealFilterName );
		if ( pFilter )
		{
			aRealFilterName = pFilter->GetUIName();
		}
	}

	// Entsprechenden Filter suchen.
	USHORT nPos = _pImp->_pFilter->Count();
	while ( nPos-- )
	{
		SfxFileDialogFilter_Impl* pFilter = _pImp->_pFilter->GetObject( nPos );
		if ( pFilter->GetName() == aRealFilterName )
		{
			_pImp->_pCurFilter = pFilter;
			break;
		}
	}
}

//*****************************************************************************

String SfxFileDialog::GetCurFilter() const
{
	String aFilter;
	if ( _pImp->_pCurFilter )
	{
		aFilter = _pImp->_pCurFilter->GetName();
		if( _pImp->_pMatcher )
		{
			const SfxFilter* pFilter = _pImp->_pMatcher->GetFilter4UIName(
				aFilter, 0, SFX_FILTER_NOTINFILEDLG );
			if ( pFilter )
			{
				aFilter = ( String ) pFilter->GetName();
			}
		}
	}
	return aFilter;
}

//*****************************************************************************

USHORT SfxFileDialog::GetFilterCount() const
{
	return _pImp->_pFilter->Count();
}

//*****************************************************************************

const String& SfxFileDialog::GetFilterName( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetName();
}

//*****************************************************************************

const String& SfxFileDialog::GetFilterType( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetType();
}

//*****************************************************************************

ULONG SfxFileDialog::GetFilterFlags( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetFlags();
}

//*****************************************************************************

void SfxFileDialog::SetDefaultButtonText( const XubString& rText, ULONG nHelpId )
{
	if ( _pImp && _pImp->_pBtnFileOpen )
	{
		_pImp->_pBtnFileOpen->SetText( rText );
		if ( nHelpId )
			_pImp->_pBtnFileOpen->SetHelpId( nHelpId );
	}
}

//*****************************************************************************

void SfxFileDialog::EnableEmptyFilename()
{
	if ( _pImp->_eDlgType == FILEDLG_TYPE_FILEDLG &&
		 _pImp->_eMode != FILEDLG_MODE_SAVE )
		_pImp->_bEnableEmptyFilename = TRUE;
}

//*****************************************************************************

void SfxFileDialog::DisableSaveLastDirectory()
{
	_pImp->_bDisableSaveLastDir = TRUE;
}

//*****************************************************************************

void SfxFileDialog::InitSize( const String& rIniKey )
{
	_pImp->_aIniKey = rIniKey;
	Size aDlgSize = GetOutputSizePixel();
	SetMinOutputSizePixel( aDlgSize );

	if ( !_pImp->_nFixDeltaHeight )
	{
		// Fixgr"ossen errechnen und merken
		Point aPnt = _pFileView->GetPosPixel();
		long nBoxH = _pFileView->GetSizePixel().Height();
		long nH = GetSizePixel().Height();
		_pImp->_nFixDeltaHeight = nH - ( aPnt.Y() + nBoxH ) + _pImp->_a6Size.Height();
	}
	// Gr"osse aus der Ini lesen und setzen
	String aIniStr = SFX_INIMANAGER()->Get( SFX_GROUP_VIEW, _pImp->_aIniKey );

	if ( aIniStr.Len() && aIniStr.GetTokenCount( ',' ) >= 2 )
	{
		USHORT nPos = 0;
		Size aNewSize;
		aNewSize.Width() = aIniStr.GetToken( 0, ',', nPos ).ToInt32();
		aNewSize.Height() = aIniStr.GetToken( 0, ',', nPos ).ToInt32();
		if ( aNewSize.Width() < aDlgSize.Width() || aNewSize.Height() < aDlgSize.Height() )
			aNewSize = aDlgSize;
		SetOutputSizePixel( aNewSize );
	}
}

//*****************************************************************************

SvStringsDtor* SfxFileDialog::GetPathList() const
{
	SvStringsDtor* pList = new SvStringsDtor;

	if ( _pImp->_pPathList )
	{
		for ( USHORT i = 0; i < _pImp->_pPathList->Count(); ++i )
		{
			String* pURL = new String( *(_pImp->_pPathList->GetObject(i)) );
			pList->Insert( pURL, pList->Count() );
		}
	}
	else
	{
		String* pURL = new String( _aPath );
		pList->Insert( pURL, pList->Count() );
	}

	return pList;
}

//*****************************************************************************

SvStringsDtor* SfxFileDialog::GetViewURLList() const
{
	SvStringsDtor* pList = new SvStringsDtor;

	if ( _pImp->_pURLList )
	{
		for ( USHORT i = 0; i < _pImp->_pURLList->Count(); ++i )
		{
			String* pURL = new String( *(_pImp->_pURLList->GetObject(i)) );
			pList->Insert( pURL, pList->Count() );
		}
	}
	else
	{
		String* pURL = new String( _pImp->_aViewURL );
		pList->Insert( pURL, pList->Count() );
	}

	return pList;
}

//*****************************************************************************

BOOL SfxFileDialog::IsolateFilterFromPath_Impl( String& rPath, String& rFilter )
{
	String aEmpty;
	String aReversePath( rPath );
	aReversePath.Reverse();
	USHORT nQuestionMarkPos = rPath.Search( '?' );

	if ( nQuestionMarkPos != STRING_NOTFOUND )
	{
		// Fragezeichen als Wildcard nur bei Files
		INetProtocol eProt = INetURLObject::CompareProtocolScheme( rPath );

		if ( INET_PROT_NOT_VALID != eProt && INET_PROT_FILE != eProt )
			nQuestionMarkPos = STRING_NOTFOUND;
	}
	USHORT nWildCardPos = Min( rPath.Search( FILEDIALOG_DEF_WILDCARD ), nQuestionMarkPos );
	rFilter = aEmpty;

	if ( nWildCardPos != STRING_NOTFOUND )
	{
		USHORT nPathTokenPos = aReversePath.Search( INET_PATH_TOKEN );

		if ( nPathTokenPos == STRING_NOTFOUND )
		{
			nPathTokenPos = aReversePath.Search( GetFsysAccessDelimiter_Impl() );
#if !defined( UNX ) && !defined( MAC )
			if ( nPathTokenPos == STRING_NOTFOUND )
			{
				nPathTokenPos = aReversePath.Search( ':' );
			}
#endif
		}

		// Syntax pr"ufen.
		if ( nPathTokenPos != STRING_NOTFOUND )
		{
			if ( nPathTokenPos < (rPath.Len() - nWildCardPos - 1) )
			{
				ErrorHandler::HandleError( ERRCODE_SFX_INVALIDSYNTAX );
				return FALSE;
			}

			// Filter abschneiden.
			rFilter = aReversePath;
			rFilter.Erase( nPathTokenPos );
			rFilter.Reverse();

			// Ordner bestimmen.
			rPath = aReversePath;
			rPath.Erase( 0, nPathTokenPos );
			rPath.Reverse();
		}
		else
		{
			rFilter = rPath;
			rPath = aEmpty;
		}
	}

	return TRUE;
}

//*****************************************************************************

void SfxFileDialog::Resize()
{
#if SUPD>596
    VclFileDialog::Resize();
    return;
#else
	if ( IsRollUp() )
		return;
#endif
	Size aDlgSize = GetOutputSizePixel();
	Size aOldSize = _pImp->_aDlgSize;
	_pImp->_aDlgSize = aDlgSize;
	long nWinDeltaW = 0;

	if ( _pImp->_pExtControls )
	{
		for ( USHORT i = 0; i < _pImp->_pExtControls->Count(); ++i )
		{
			Window* pWin = (Window*)_pImp->_pExtControls->GetObject(i);

			if ( pWin && pWin->GetType() == WINDOW_WINDOW &&
				 pWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
				nWinDeltaW = pWin->GetOutputSizePixel().Width() + _pImp->_a6Size.Width();
		}
	}

	Size aNewSize = _pFileView->GetSizePixel();
	Point aBoxPos( _pFileView->GetPosPixel() );
	long nDelta = aNewSize.Height();
	long nDeltaX = aNewSize.Width();
	aNewSize.Height() = aDlgSize.Height() - _pImp->_nFixDeltaHeight - _pImp->_a6Size.Height() / 2;
	aNewSize.Width() = aDlgSize.Width() - aBoxPos.X() - _pImp->_a6Size.Width() - nWinDeltaW;
	if ( aOldSize.Height() )
		nDelta = _pImp->_aDlgSize.Height() - aOldSize.Height();
	else
		nDelta = aNewSize.Height() - nDelta;
	nDeltaX = aNewSize.Width() - nDeltaX;

	if ( nWinDeltaW )
		nWinDeltaW = nDeltaX * 2 / 3;
	aNewSize.Width() -= nWinDeltaW;
	nDeltaX -= nWinDeltaW;

	if ( _pImp->_pIndicator->IsVisible() )
	{
		long nHeight = _pImp->_pIndicator->CalcWindowSizePixel().Height();
		aNewSize.Height() -= nHeight;
		_pImp->_pIndicator->SetPosSizePixel( aBoxPos.X(), aBoxPos.Y() + aNewSize.Height(),
											 aNewSize.Width(), nHeight, WINDOW_POSSIZE_POSSIZE );
	}

	_pFileView->SetSizePixel( aNewSize );

	if ( !nDelta && !nDeltaX )
		// Dieses Resize wurde nur zum Ein - oder Ausblenden des Indicators aufgerufen
		return;

	Point aNewPos = _pImp->_pFtFileName->GetPosPixel();
	aNewPos.Y() += nDelta;
	long nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileName->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pEdFileName->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pEdFileName->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pEdFileName->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pEdFileName->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pFtFileVersion->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileVersion->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pLbFileVersion->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pLbFileVersion->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pLbFileVersion->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pLbFileVersion->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pFtFileType->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileType->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pLbFilter->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pLbFilter->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pLbFilter->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pLbFilter->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pBtnFileOpen->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnFileOpen->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnCancel->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnCancel->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnHelp->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnHelp->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnUp->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnUp->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnNewFolder->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnNewFolder->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnStandard->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnStandard->SetPosPixel( aNewPos );

	if ( _pCbReadOnly )
	{
		aNewPos = _pCbReadOnly->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pCbReadOnly->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbPassword )
	{
		aNewPos = _pImp->_pCbPassword->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbPassword->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbAutoExtension )
	{
		aNewPos = _pImp->_pCbAutoExtension->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbAutoExtension->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbOptions )
	{
		aNewPos = _pImp->_pCbOptions->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbOptions->SetPosPixel( aNewPos );
	}

	// zus"atzliche Controls ausrichten
	if ( _pImp->_pExtControls )
	{
		for ( USHORT i = 0; i < _pImp->_pExtControls->Count(); ++i )
		{
			Window* pWin = (Window*)_pImp->_pExtControls->GetObject(i);

			if ( pWin )
			{
				WindowType nType = pWin->GetType();

				if ( nType == WINDOW_WINDOW &&
					 pWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
				{
					// Controls vom Typ Window speziell ausrichten
					// auch die Gr"osse anpassen
					aNewPos = pWin->GetPosPixel();
					aNewPos.X() += nDeltaX;
					pWin->SetPosPixel( aNewPos );
					aNewSize = pWin->GetOutputSizePixel();
					aNewSize.Width() += nWinDeltaW;
					aNewSize.Height() += nDelta;
					if ( !aOldSize.Height() )
						aNewSize.Height() -= ( _pImp->_a6Size.Height() / 2 );
					pWin->SetOutputSizePixel( aNewSize );
					pWin->Invalidate();
				}
				else
				{
					aNewPos = pWin->GetPosPixel();
					aNewPos.Y() += nDelta;
					pWin->SetPosPixel( aNewPos );
				}
			}
		}
	}
}

//*****************************************************************************

void SfxFileDialog::ToggleBrowserMode()
{
//!	_pFileView->SetBrowserMode( !_pFileView->IsBrowserMode() );
}

//*****************************************************************************

void SfxFileDialog::SetFocusInViewControl()
{
	_pFileView->SetFocusInView();
}

//*****************************************************************************
// SfxSimpleFileDialog_Impl
//*****************************************************************************

class SfxSimpleFileDialog_Impl
{
public:
	USHORT _nUserControls;

		   SfxSimpleFileDialog_Impl( USHORT nUserControls );
		   ~SfxSimpleFileDialog_Impl();
};

//*****************************************************************************

SfxSimpleFileDialog_Impl::SfxSimpleFileDialog_Impl
(
	USHORT nUserControls
)
	: _nUserControls( nUserControls )
{
}

//*****************************************************************************

SfxSimpleFileDialog_Impl::~SfxSimpleFileDialog_Impl()
{
}

//*****************************************************************************
// SfxSimpleFileDialog
//*****************************************************************************

SfxSimpleFileDialog::SfxSimpleFileDialog
(
	Window* pParent,
	ULONG nWinBits
)
	: SfxFileDialog( pParent, nWinBits | SFXWB_NOREMOTE ),
	  _pImp( new SfxSimpleFileDialog_Impl( GetChildCount() ) )
{
}

//*****************************************************************************

SfxSimpleFileDialog::~SfxSimpleFileDialog()
{
}

//*****************************************************************************

short SfxSimpleFileDialog::Execute()
{
	// Pruefen, ob neue Elemente eingefuegt wurden.
	const USHORT nChildCount = GetChildCount();
	if ( nChildCount != _pImp->_nUserControls )
	{
		_pImp->_nUserControls = nChildCount - _pImp->_nUserControls;

		// Elemente positionieren.
		USHORT nChild = nChildCount;
		nChild -= _pImp->_nUserControls;
		for ( ; nChild < nChildCount; ++nChild )
		{
			Window* pWnd = GetChild( nChild );
#if (SUPD < 540)
			AddControl( pWnd );
#else
			if ( AddControl( pWnd ) )
#endif
				ReleaseOwnerShip( pWnd );
		}
	}

	// Formatierten Pfad in URL konvertieren.
	if ( !_aPath.Len() )
	{
		String aLastDir( SFX_APP()->GetLastDir_Impl() );

		if ( aLastDir.Len() )
		{
			INetURLObject aObj( aLastDir );

			if ( aObj.GetProtocol() == INET_PROT_FILE )
				_aPath = aLastDir;
		}

		if ( !_aPath.Len() )
		{
			// sonst das Standard-Dir verwenden
			INetURLObject aWorkPathObj( SFX_INIMANAGER()->Get( SFX_KEY_WORK_PATH ), INET_PROT_FILE );
			aWorkPathObj.setFinalSlash();
			_aPath = aWorkPathObj.GetMainURL();
		}
	}
	else
	{
		INetURLObject aPathObj( _aPath, INET_PROT_FILE );
		if ( SfxContentHelper::IsFolder( aPathObj.GetMainURL() ) )
			aPathObj.setFinalSlash();
		_aPath = aPathObj.GetMainURL();
	}

	// Dialog ausfuehren.
	short nResult = SfxFileDialog::Execute();

	// URL in Pfad formatierens.
	_aPath = INetURLObject( _aPath ).PathToFileName();

	return nResult;
}

//*****************************************************************************

void SfxFileDialog::AddPathType( INetContentType eType )

/*	[Beschreibung]

*/

{
	_pImp->_pPathTypes->Insert( (USHORT)eType, _pImp->_pPathTypes->Count() );
}

//*****************************************************************************

void SfxFileDialog::SetPathURL( const XubString& rPathURL )

/*	[Beschreibung]

*/

{
	_pImp->_aPathURL = rPathURL;
}

//*****************************************************************************

Image* SfxFileDialog::GetDocumentImage() const
{
	return _pImp->_pDocImage;
}

//*****************************************************************************

Image* SfxFileDialog::GetFolderImage() const
{
	return _pImp->_pFolderImage;
}


