/*************************************************************************
 *
 *  $RCSfile: iodlgimp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes *******************************************************************

#ifndef _HEADBAR_HXX
#include <svtools/headbar.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX //autogen
#include <tools/debug.hxx>
#endif
#ifndef _WLDCRD_HXX //autogen
#include <tools/wldcrd.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _CSTRITEM_HXX //autogen
//(dv)#include <chaos2/cstritem.hxx>
#endif
#ifndef _CNTSYS_HXX //autogen
//(dv)#include <chaos2/cntsys.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif
#ifndef _SVTOOLS_CTYPEITM_HXX //autogen
#include <svtools/ctypeitm.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#pragma hdrstop

#include "iodlgimp.hxx"
#include "iodlg.hxx"
#include "app.hxx"
#include "explorer.hxx"
#include "sfxresid.hxx"
#include "expfile.hxx"
#include "request.hxx"
#include "dispatch.hxx"
#include "fcontnr.hxx"
#include "infodlgs.hxx"
#include "inimgr.hxx"
#include "helper.hxx"
#include "exptypes.hxx"
#include "fileview.hxx"

#include "explorer.hrc"
#include "iodlg.hrc"
#include "sfxlocal.hrc"
//#include "cntimage.hrc"
#include "helpid.hrc"

using namespace ::com::sun::star::uno;

#define _SVSTDARR_STRINGSSORTDTOR
#define _SVSTDARR_STRINGSDTOR
#define _SVSTDARR_USHORTS
#include <svtools/svstdarr.hxx>

// defines f"ur den Style der BrowseBox

#define STYLE_MULTI_SELECTION	\
	CNTVIEWSTYLE_NODE_BUTTONS | \
	CNTVIEWSTYLE_NODE_BUTTONS_AT_ROOT | \
	CNTVIEWSTYLE_SHOW_MESSAGES | \
	CNTVIEWSTYLE_SHOW_FOLDERS | \
	CNTVIEWSTYLE_NO_SMARTHIGHLIGHT | \
	CNTVIEWSTYLE_HIDE_OPENMENU | \
	CNTVIEWSTYLE_DEFAULT_APPEARANCE | \
	CNTVIEWSTYLE_SORT_BY_FOLDER

#define STYLE_SINGLE_SELECTION	\
	STYLE_MULTI_SELECTION | CNTVIEWSTYLE_SINGLE_SELECTION

#define BOOL_NOT_INITIALIZE		((sal_Bool)2)

//*****************************************************************************

String GetRegularExpression_Impl( const String& rFilter )
{
	String aFilter = rFilter;
	aFilter.EraseLeadingChars().EraseTrailingChars();
	String aRegExp = '^';

	for ( const sal_Unicode *pc = aFilter.GetBuffer(); *pc; ++pc )
	{
		if ( '*' == *pc )
			aRegExp += DEFINE_CONST_UNICODE(".*");
		else if ( '?' == *pc )
			aRegExp += '.';
		else
		{
			aRegExp += '\'';

			while ( *pc && *pc != '*' && *pc != '?' )
			{
				if ( '\'' == *pc )
					aRegExp += DEFINE_CONST_UNICODE("\\\'");
				else
					aRegExp += *pc;
				pc++;
			}
			aRegExp += '\'';

			if ( !*pc )
				break;
			else
				pc--;
		}
	}
	aRegExp += '$';
	return aRegExp;
}

//*****************************************************************************
// SfxFileDialogFilter_Impl
//*****************************************************************************

SfxFileDialogFilter_Impl::SfxFileDialogFilter_Impl
(
	const String& rName,
	const String& rType,
	const String& rSysType,
	sal_uInt32 nFlags
) :

	_aName		( rName ),
	_aType		( String(rType).ToLowerAscii() ),
	_aSysType	( rSysType ),
	_nFlags		( nFlags )

{
}

//*****************************************************************************

SfxFileDialogFilter_Impl::~SfxFileDialogFilter_Impl()
{
}

//*****************************************************************************
// SfxFileDialogFilterList_Impl
//*****************************************************************************

SV_IMPL_PTRARR( SfxFileDialogFilterList_Impl, SfxFileDialogFilter_Impl* );

//*****************************************************************************
// SfxUpButton_Impl
//*****************************************************************************

SfxUpButton_Impl::SfxUpButton_Impl( SfxFileDialog* pParent, const ResId& rResId ) :

	MenuButton( pParent, rResId ),

	_pParent		( pParent ),
	_pURLs			( NULL ),
	_pMenu			( new PopupMenu )

{
	SetStyle( GetStyle() | WB_NOPOINTERFOCUS | WB_RECTSTYLE | WB_SMALLSTYLE );
	SetImage( Image( ResId( IMG_FILEDLG_BTN_UP ) ) );
	SetMenuMode( MENUBUTTON_MENUMODE_TIMED );
	SetDropDown( PUSHBUTTON_DROPDOWN_TOOLBOX );
}

//*****************************************************************************

SfxUpButton_Impl::~SfxUpButton_Impl()
{
	delete _pURLs;
	delete _pMenu;
}

//*****************************************************************************

void SfxUpButton_Impl::Activate()
{
	delete _pURLs;
	_pURLs = new SvStringsDtor;
	SfxFileView_Impl* pBox = _pParent->GetView();
	_pMenu->Clear();
	sal_uInt16 nItemId = 1;

	// "Ubergeordnete Ebenen bestimmen.
	INetURLObject aObject( pBox->GetViewURL() );
	sal_Int32 nCount = aObject.getSegmentCount();

	while ( nCount > 1 )
	{
		aObject.removeSegment();
		String* pParentURL = new String( aObject.GetMainURL() );
		String aTitle;
		if ( !SfxContentHelper::GetTitle( *pParentURL, aTitle ) || aTitle.Len() == 0 )
			aTitle = aObject.getName();

//!		if ( !aName && !xParent->GetParentViewURL() )
//!			aName = String( SfxResId( STR_SFX_WORKPLACE ) );

//!		Image aImage = CntHelperFunctions::GetImage( *xParent, sal_False );
		_pMenu->InsertItem( nItemId++, aTitle, *_pParent->GetFolderImage() );

		_pURLs->Insert( pParentURL, _pURLs->Count() );
		nCount--;
	}

	// Workplace-Submenu
	nItemId--;
	MenuItemBits nBits = _pMenu->GetItemBits( nItemId );
	nBits |= MIB_POPUPSELECT;
	_pMenu->SetItemBits( nItemId, nBits );

	SetPopupMenu( _pMenu );
}

//*****************************************************************************

void SfxUpButton_Impl::Select()
{
	sal_uInt16 nId = GetCurItemId();

	if ( nId )
	{
		--nId;
		DBG_ASSERT( nId <= _pURLs->Count(), "SfxUpButton_Impl:falscher Index" );
		String aURL = *(_pURLs->GetObject( nId ));
		_pParent->OpenURL_Impl( aURL );
	}
}

//*****************************************************************************

void SfxUpButton_Impl::Click()
{
	_pParent->PrevLevel_Impl();
}

//*****************************************************************************
// SfxTravelButton_Impl
//*****************************************************************************

void SfxTravelButton_Impl::OpenURL( const String& rURL )

/*	[Beschreibung]

	Die Methode "offnet den Ordner,
	der durch den gespeicherten URL spezifiziert wird.
*/

{
	INetURLObject aObj( rURL, INET_PROT_FILE );
	_pParent->OpenURL_Impl( aObj.GetMainURL() );
}

//*****************************************************************************

SfxTravelButton_Impl::SfxTravelButton_Impl( SfxFileDialog* pParent, const ResId& rResId ) :

	MenuButton( pParent, rResId ),

	_pParent		( pParent )

{
	SetStyle( GetStyle() | WB_NOPOINTERFOCUS | WB_RECTSTYLE | WB_SMALLSTYLE );
	SetImage( Image( ResId( IMG_FILEDLG_BTN_STD ) ) );
	SetMenuMode( MENUBUTTON_MENUMODE_TIMED );
	SetDropDown( PUSHBUTTON_DROPDOWN_TOOLBOX );
}

//*****************************************************************************

SfxTravelButton_Impl::~SfxTravelButton_Impl()
{
}

//*****************************************************************************

void SfxTravelButton_Impl::Click()
{
	OpenURL( _pParent->GetStandardDir() );
}

//*****************************************************************************
// SfxExpFileDlg_Impl
//*****************************************************************************

SfxExpFileDlg_Impl::SfxExpFileDlg_Impl( SfxFileDialog* pDlg, WinBits nBits )	:

	_pFilter            ( new SfxFileDialogFilterList_Impl() ),
	_pCurFilter         ( NULL ),
	_pUserFilter        ( NULL ),
	_pMatcher           ( NULL ),
	_pFtFileName        ( NULL ),
	_pEdFileName        ( NULL ),
	_pFtFileVersion     ( NULL ),
	_pLbFileVersion     ( NULL ),
	_pFtFileType        ( NULL ),
	_pLbFilter          ( NULL ),
	_pBtnFileOpen       ( NULL ),
	_pBtnCancel         ( NULL ),
	_pBtnHelp			( NULL ),
	_pBtnUp             ( NULL ),
	_pBtnNewFolder      ( NULL ),
	_pBtnStandard       ( NULL ),
	_pCbPassword        ( NULL ),
	_pCbAutoExtension   ( NULL ),
	_pCbOptions			( NULL ),
	_pFtCurrentPath     ( NULL ),
	_nState             ( FILEDLG_STATE_REMOTE ),
	_bLoadLayout        ( sal_True ),
	_bDoubleClick       ( sal_False ),
	_bDisableSaveLastDir( sal_False ),
	_bShowOptionsBox	( sal_False ),
	_bMultiSelection	( sal_False ),
	_bFolderHasOpened	( sal_False ),
	_pPathList			( NULL ),
	_pURLList			( NULL ),
	_nFixDeltaHeight    ( 0 ),
	_pExtControls       ( NULL ),
	_pIndicator			( NULL ),
	_nStyle				( 0 )

{
	_pAccel = ( nBits & WB_OPEN  ) ? new Accelerator( SfxResId( ACC_LAYOUT_NOT_LOADING ) ) : NULL;
	if ( _pAccel )
	{
		_pAccel->SetSelectHdl( STATIC_LINK( this, SfxExpFileDlg_Impl, AccelHdl ) );
		GetpApp()->InsertAccel( _pAccel );
	}
	_pPathTypes = new SvUShorts;

	_pDocImage = new Image( ResId( IMG_FILEDLG_DOCUMENT ) );
	_pFolderImage = new Image( ResId( IMG_FILEDLG_FOLDER ) );
}

//*****************************************************************************

SfxExpFileDlg_Impl::~SfxExpFileDlg_Impl()
{
	delete _pFtCurrentPath;
	delete _pCbPassword;
	delete _pCbAutoExtension;
	delete _pCbOptions;
	delete _pBtnStandard;
	delete _pBtnNewFolder;
	delete _pBtnUp;
	delete _pBtnHelp;
	delete _pBtnCancel;
	delete _pBtnFileOpen;
	delete _pLbFilter;
	delete _pFtFileType;
	delete _pLbFileVersion;
	delete _pFtFileVersion;
	delete _pEdFileName;
	delete _pFtFileName;

	if ( _nState & FILEDLG_STATE_OWNSMATCHER )
		delete _pMatcher;

	delete _pUserFilter;
	delete _pFilter;
	delete _pPathList;
	delete _pURLList;
	delete _pExtControls;
	delete _pPathTypes;

	if ( _pAccel )
	{
		GetpApp()->RemoveAccel( _pAccel );
		delete _pAccel;
	}

	delete _pDocImage;
	delete _pFolderImage;
}

//*****************************************************************************

IMPL_STATIC_LINK( SfxExpFileDlg_Impl, AccelHdl, Accelerator *, pAccelerator )
{
	if ( pThis->_bLoadLayout )
	{
		pThis->_bLoadLayout = sal_False;
		InfoBox( 0, SfxResId( MSG_LAYOUT_NOT_LOADING ) ).Execute();
	}
	return 1L;
}

//******************************************************************************
//* Ab hier kommen die Methoden zum Cachen der 5 letzten Filter oberhalb des   *
//* <Alle> Filters in der FilterListBox										   *
//******************************************************************************

// Anzahl der zuletzt genutzten Filter die am Anfang der
// FilterBox angezeigt werden sollen
#define CACHE_FILTERS_COUNT	5

// Trennzeichen zum speichern der 5 zuletzt genutzten Filter
#define MULTIFILTER_DELIMITER ';'

// Schluessel fuer die Soffice.ini
#define FILEDIALOG_LASTFILTER_INISTR "FileDialogFilterCache"

//******************************************************************************

void SfxExpFileDlg_Impl::InitFilterCache_Impl()
{
	const String aFilters = SFX_INIMANAGER()->Get( SFX_GROUP_COMMON,
											DEFINE_CONST_UNICODE(FILEDIALOG_LASTFILTER_INISTR) );
	char cDelim = MULTIFILTER_DELIMITER;
	const sal_uInt16 nCount = aFilters.GetTokenCount( cDelim );

	for ( sal_uInt16 i = 0; i < nCount; i++ )
		_aFilterCacheList.Insert(
			new String(aFilters.GetToken( i, cDelim )), LIST_APPEND );

	// Position des <Alle> - Filters, falls er nicht da ist - raus
	String aAll( SfxResId( STR_FILTERNAME_ALL ) );
	sal_uInt16 nAllPos =  _pLbFilter->GetEntryPos( aAll );
	if ( nAllPos == LISTBOX_ENTRY_NOTFOUND )
		return;
	// Wenn der <Alle> - Filter der Letzte ist - anhaengen
	if ( ++nAllPos >= _pLbFilter->GetEntryCount() )
		nAllPos = LISTBOX_APPEND;

	// die Top5 Filter in der Box nach oben kopieren
	String* pFilterStr = (String*)_aFilterCacheList.Last();
	while(pFilterStr)
	{
		// Filter Nur in die Listbox eintragen, wenn er dort
		// bereits vorhanden ist
		sal_uInt16 nPos = _pLbFilter->GetEntryCount();
		while(nPos--)
		{
			if(pFilterStr->CompareTo(_pLbFilter->GetEntry(nPos)) ==
				COMPARE_EQUAL)
			{
				// der Filtername wird mit <> dekoriert
				String aDecoratedFilter = '<';
				aDecoratedFilter += *pFilterStr;
				aDecoratedFilter += '>';
				sal_uInt16 nFilterPos = _pLbFilter->InsertEntry(aDecoratedFilter,nAllPos);
				// der undekorierte Name wird als EntryData abgelegt.
				// Es wird der Zeiger in die _aFilterCacheList benutzt.
				// die uebernimmt auch das Freigeben
				_pLbFilter->SetEntryData ( nFilterPos, (void*)pFilterStr );
				break;
			}
		}
		pFilterStr = (String*)_aFilterCacheList.Prev();
	}
}

//******************************************************************************

void SfxExpFileDlg_Impl::SaveFilterCache_Impl()

/*	[Beschreibung]

	Filter Cache in die Ini schreiben
*/

{
	String aFilters;
	String* pFilterStr = (String*)_aFilterCacheList.First();
	while(pFilterStr)
	{
		aFilters += *pFilterStr;
		aFilters += MULTIFILTER_DELIMITER;
		delete pFilterStr;

		pFilterStr = (String*)_aFilterCacheList.Next();
	}
	_aFilterCacheList.Clear();
	aFilters.EraseTrailingChars( MULTIFILTER_DELIMITER );
	SFX_INIMANAGER()->Set( aFilters, SFX_GROUP_COMMON, DEFINE_CONST_UNICODE(FILEDIALOG_LASTFILTER_INISTR) );
}

//******************************************************************************

// Selektierten Filter im Filter Cache merken

void SfxExpFileDlg_Impl::CacheFilter_Impl( const String& aFilter )
{
	// ist der Filter schon im cache, wird er zuerst aus selbigen entfernt.
	String* pFilterStr = (String*)_aFilterCacheList.First();
	while(pFilterStr)
	{
		if(aFilter.CompareTo(*pFilterStr) == COMPARE_EQUAL)
		{
			_aFilterCacheList.Remove();
			delete pFilterStr;
			break;
		}

		pFilterStr = (String*)_aFilterCacheList.Next();
	}

	_aFilterCacheList.Insert((void*)new String(aFilter), (sal_uInt32)0);

	// pruefen, ob der Cache voll ist
	if(_aFilterCacheList.Count() > CACHE_FILTERS_COUNT)
	{
		String* pFilterStr = (String*)_aFilterCacheList.Last();
		_aFilterCacheList.Remove();
		delete pFilterStr;
	}
}


