/*************************************************************************
 *
 *  $RCSfile: iodlgimp.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IODLGIMP_HXX
#define _IODLGIMP_HXX

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_MENUBTN_HXX //autogen
#include <vcl/menubtn.hxx>
#endif
#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SVTABBX_HXX //autogen wg. SvTabListBox
#include <svtools/svtabbx.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen wg. ::com::sun::star::form
#include <vcl/group.hxx>
#endif

#include <svtools/lstner.hxx>

#include "docfilt.hxx"
#include "basedlgs.hxx"

class Accelerator;
class FixedText;
class Edit;
class ListBox;
class CheckBox;
class SfxShortFixedText_Impl;
class SfxFilterMatcher;
class SfxFileDialog;
class SvStringsDtor;
class SfxPopupStatusIndicator;
class CntIconView;
class CntBrowseBox;
class SfxAnchorList;
class SvStringsSortDtor;
class CntAnchor;
class SvUShorts;
class SvTabListBox;

//*****************************************************************************

#define FILEDIALOG_DEF_EXTSEP		';'
#define FILEDIALOG_DEF_WILDCARD		'*'
#define FILEDIALOG_DEF_IMAGEBORDER	10
#define FILEDIALOG_DEF_TIMEOUT		250

//*****************************************************************************

String GetRegularExpression_Impl( const String& rFilter );

//*****************************************************************************
// SfxFileDialogFilter_Impl
//*****************************************************************************

/*	[Beschreibung]

	Instanzen dieser Klasse repr"asentieren einen Filter
*/

class SfxFileDialogFilter_Impl
{
private:
	String	_aName;
	String	_aType;
	String	_aSysType;
	sal_uInt32	_nFlags;

public:
	SfxFileDialogFilter_Impl( const String& rName, const String& rType,
							  const String& rSysType, sal_uInt32 nFlags );
	~SfxFileDialogFilter_Impl();

	const String&		GetName() const				{ return _aName; }
	const String&		GetType() const				{ return _aType; }
	const String&		GetSysType() const			{ return _aSysType; }
	sal_uInt32			GetFlags() const			{ return _nFlags; }
	sal_Bool			HasOptionsDialog() const
							{ return ( ( _nFlags & SFX_FILTER_USESOPTIONS ) == SFX_FILTER_USESOPTIONS ); }
};

//*****************************************************************************
// SfxFileDialogFilterList_Impl
//*****************************************************************************

SV_DECL_PTRARR_DEL( SfxFileDialogFilterList_Impl, SfxFileDialogFilter_Impl*, 3, 3 );

//*****************************************************************************
// SfxFileDlgMode
//*****************************************************************************

enum SfxFileDlgMode
{
	FILEDLG_MODE_OPEN = 0,
	FILEDLG_MODE_SAVE = 1
};

//*****************************************************************************
// SfxFileDlgType
//*****************************************************************************

enum SfxFileDlgType
{
	FILEDLG_TYPE_FILEDLG = 0,
	FILEDLG_TYPE_PATHDLG,
	FILEDLG_TYPE_FOLDERDLG
};

//*****************************************************************************
// SfxUpButton_Impl
//*****************************************************************************

class SfxUpButton_Impl : public MenuButton
{
private:
	SfxFileDialog*		_pParent;
	SvStringsDtor*		_pURLs;
	PopupMenu*			_pMenu;

public:
	SfxUpButton_Impl( SfxFileDialog* pParent, const ResId& rResId );
	~SfxUpButton_Impl();

	virtual void		Activate();
	virtual void		Select();
	virtual void		Click();
};

//*****************************************************************************
// SfxTravelButton_Impl
//*****************************************************************************

class SfxTravelButton_Impl : public MenuButton
{
private:
	SfxFileDialog*			_pParent;		// FileDialog

	void					OpenURL( const String& rURL );

public:
	SfxTravelButton_Impl( SfxFileDialog* pParent, const ResId& rResId );
	~SfxTravelButton_Impl();

	virtual void			Click();
};

//*****************************************************************************
// SfxFileDlgState
//*****************************************************************************

typedef sal_uInt8 SfxFileDlgState;

#define FILEDLG_STATE_NONE        ((SfxFileDlgState)0x00)
#define FILEDLG_STATE_OWNSMATCHER ((SfxFileDlgState)0x01)
#define FILEDLG_STATE_REMOTE      ((SfxFileDlgState)0x02)

//*****************************************************************************
// SfxExpFileDlg_Impl
//*****************************************************************************

class SfxExpFileDlg_Impl
{
private:
	DECL_STATIC_LINK( SfxExpFileDlg_Impl, AccelHdl, Accelerator* );
	DECL_STATIC_LINK( SfxExpFileDlg_Impl, UnClickHdl, Button* );

public:
	SfxFileDialogFilterList_Impl*	_pFilter;
	SfxFileDialogFilter_Impl*		_pCurFilter;
	SfxFileDialogFilter_Impl*		_pUserFilter;

	Accelerator*					_pAccel;
	sal_Bool						_bLoadLayout;

	FixedText*						_pFtFileName;
	Edit*							_pEdFileName;
	FixedText*						_pFtFileVersion;
	ListBox*						_pLbFileVersion;
	FixedText*						_pFtFileType;
	ListBox*						_pLbFilter;
	PushButton*						_pBtnFileOpen;
	PushButton*						_pBtnCancel;
	HelpButton*						_pBtnHelp;
	SfxUpButton_Impl*				_pBtnUp;
	ImageButton*					_pBtnNewFolder;
	SfxTravelButton_Impl*			_pBtnStandard;
	CheckBox*						_pCbPassword;
	SfxShortFixedText_Impl*			_pFtCurrentPath;
	CheckBox*						_pCbAutoExtension;
	CheckBox*						_pCbOptions;

	SfxPopupStatusIndicator*		_pIndicator;
	SfxFilterMatcher*				_pMatcher;
	SfxFileDlgMode					_eMode;
	SfxFileDlgType					_eDlgType;
	SfxFileDlgState					_nState;
	ULONG							_nStyle;

	String							_aPasswd;
	String							_aStdDir;
	String							_aViewURL;
	String							_aCWD;
	String							_aActualVersion;

	// beim traveln der Filterbox erst Zeitversetzt filtern
	Timer							_aFilterTimer;

	// Zeigt der OpenHdl_Imp(), ob das Open durch einen Doppelclick ausgel"ost wurde
	sal_Bool				_bDoubleClick;

	// Liste mit den 5 zuletzt genutzten Filtern
	List				_aFilterCacheList;

	// Defaultfilter fuer <Alle> oder <Alle ...>
	SfxFileDialogFilter_Impl*
							_pDefaultFilter;

	// Anzahl der Controls welche dynamisch erzeugt wurden #49066#
	sal_uInt16				_nUserControls;

	// ist sal_True wenn der FileDialog den Waitcursor gesetzt hat
	sal_Bool				_bHasWaitCursor;

	// wird mit SetPath ein Pfad vorgegeben, diesen nicht zum LastDir machen
	sal_Bool				_bHasInitPath;

	// ist true wenn der selektierte Anker in der Browsebox auch wirklich
	// vom Benutzer selektiert wurde
	sal_Bool				_bIsSelectionValid;

	// Hack: merkt sich, ob bei initialize der Browsebox ein
	// Fehler auftritt.
	sal_Bool				_bBrowseBoxError;

	// auch ein Leerstring als Dateinamen zulassen
	sal_Bool				_bEnableEmptyFilename;

	sal_Bool				_bDisableSaveLastDir;

	// ::com::sun::star::form "Filtereinstellungen" zeigen
	sal_Bool				_bShowOptionsBox;

	// Multiselektion?
	sal_Bool				_bMultiSelection;
	SvStringsDtor*			_pPathList;
	SvStringsDtor*			_pURLList;

	// Fixgr"ossen f"ur Resize merken
	long                	_nFixDeltaHeight;
	List*               	_pExtControls;
	Size                	_a6Size;
	Size					_aDlgSize;
	String              	_aIniKey;

	// additional content types to show in the pathdialog
	SvUShorts*				_pPathTypes;
	XubString				_aPathURL;

	Image*					_pDocImage;
	Image*					_pFolderImage;

	sal_Bool				_bFolderHasOpened;
	Timer					_aResetCursorTimer;

	SfxExpFileDlg_Impl( SfxFileDialog* pDlg, WinBits nBits );
	~SfxExpFileDlg_Impl();

	void					SetStandardDir( const String &rStdDir )	{ _aStdDir = rStdDir; }
	const String&			GetStandardDir() const					{ return _aStdDir; }
	const String&			GetViewURL() const						{ return _aViewURL; }

	void InitFilterCache_Impl();
	void SaveFilterCache_Impl();
	void CacheFilter_Impl( const String& aFilter );
};

#endif // #ifndef _IODLGIMP_HXX


