/*************************************************************************
 *
 *  $RCSfile: ucbhelp.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------
#include "ucbhelp.hxx"

#ifndef _COM_SUN_STAR_UCB_XCONTENTIDENTIFIERFACTORY_HPP_
#include <com/sun/star/ucb/XContentIdentifierFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDERMANAGER_HPP_
#include <com/sun/star/ucb/XContentProviderManager.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCHAOSURLMANAGER_HPP_
#include <com/sun/star/ucb/XChaosURLManager.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDINFO_HPP_
#include <com/sun/star/ucb/XCommandInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDPROCESSOR_HPP_
#include <com/sun/star/ucb/XCommandProcessor.hpp>
#endif
#ifndef  _COM_SUN_STAR_TASK_XINTERACTIONHANDLER_HPP_
#include <com/sun/star/task/XInteractionHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_OPENCOMMANDARGUMENT2_HPP_
#include <com/sun/star/ucb/OpenCommandArgument2.hpp>
#endif
#ifndef _COM_SUN_STAR_CHAOS_OPENMODE_HPP_
#include <com/sun/star/chaos/OpenMode.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTY_HPP_
#include <com/sun/star/beans/Property.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTIESCHANGENOTIFIER_HPP_
#include <com/sun/star/beans/XPropertiesChangeNotifier.hpp>
#endif
#ifndef _COM_SUN_STAR_SDBC_XROW_HPP_
#include <com/sun/star/sdbc/XRow.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASINK_HPP_
#include <com/sun/star/io/XActiveDataSink.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATACONTROL_HPP_
#include <com/sun/star/io/XActiveDataControl.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XSEEKABLE_HPP_
#include <com/sun/star/io/XSeekable.hpp>
#endif

#ifndef _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif
#ifndef _CPPUHELPER_IMPLBASE2_HXX_
#include <cppuhelper/implbase2.hxx>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#ifndef _VOS_THREAD_HXX_
#include <vos/thread.hxx>
#endif
#ifndef _VOS_CONDITN_HXX_
#include <vos/conditn.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef  _UNOTOOLS_PROCESSFACTORY_HXX_
#include <unotools/processfactory.hxx>
#endif

#include <ucbhelper/contentbroker.hxx>

#include <vcl/svapp.hxx>
#include <svtools/cntwids.hrc>

#ifndef _SFXCANCEL_HXX
#include <svtools/cancel.hxx>
#endif

#include "sfxuno.hxx"

//----------------------------------------------------------------------------

using namespace rtl;
using namespace cppu;
using namespace vos;
using namespace com::sun::star::beans;
using namespace com::sun::star::container;
using namespace com::sun::star::lang;
using namespace com::sun::star::task;
using namespace com::sun::star::ucb;
using namespace com::sun::star::uno;
using namespace com::sun::star::sdbc;
using namespace com::sun::star::io;
using namespace com::sun::star::chaos;

static Reference< XInteractionHandler >	globalInteractionHandler;
static Reference< XProgressHandler >	globalProgressHandler;

//----------------------------------------------------------------------------

#define APP_VENDOR_TYPE_PREFIX	"application/"##INET_VENDOR_SCHEME_PREFIX
#define CHAOS_TYPE_PREFIX		".chaos/"
#define VIEW_DELIMITER			"#.view:"

//----------------------------------------------------------------------------

//============================================================================
//
//	UcbTaskEnvironment.
//
//============================================================================

class UcbTaskEnvironment : public WeakImplHelper1< XCommandEnvironment >
{
	Reference< XInteractionHandler > m_xInteractionHandler;
	Reference< XProgressHandler > m_xProgressHandler;

public:
			UcbTaskEnvironment( const Reference< XInteractionHandler>& rxInteractionHandler,
								const Reference< XProgressHandler>& rxProgressHandler );

	virtual Reference<XInteractionHandler> SAL_CALL getInteractionHandler() throw (RuntimeException)
	{ return m_xInteractionHandler; }

	virtual Reference<XProgressHandler> SAL_CALL getProgressHandler() throw (RuntimeException)
	{ return m_xProgressHandler; }
};

//----------------------------------------------------------------------------

static OUString getPropName_Impl( USHORT nPropId )
{
	OUString aPropName;
	switch ( nPropId ) {
		case WID_FLAG_IS_FOLDER :
				aPropName = DEFINE_CONST_OUSTRING("IsFolder");
				break;
		case WID_FLAG_IS_DOCUMENT :
				aPropName = DEFINE_CONST_OUSTRING("IsDocument");
				break;
		case WID_TARGET_URL :
				aPropName = DEFINE_CONST_OUSTRING("TargetURL");
				break;
		case WID_DOCUMENT_HEADER :
				aPropName = DEFINE_CONST_OUSTRING("DocumentHeader");
				break;
		case WID_IS_READ :
				aPropName = DEFINE_CONST_OUSTRING("IsRead");
				break;
		case WID_IS_PROTECTED :
				aPropName = DEFINE_CONST_OUSTRING("IsProtected");
				break;
		case WID_UPDATE :
				aPropName = DEFINE_CONST_OUSTRING("update");
				break;
		case WID_OPEN :
				aPropName = DEFINE_CONST_OUSTRING("open");
				break;
		case WID_INSERT :
				aPropName = DEFINE_CONST_OUSTRING("insert");
				break;
		case WID_TRANSFER :
				aPropName = DEFINE_CONST_OUSTRING("transfer");
				break;
		case WID_TITLE :
				aPropName = DEFINE_CONST_OUSTRING("Title");
				break;
		default:
#ifdef DBG_UTIL
				ByteString aErr( "Unknown PropertyId: " );
				aErr += ByteString::CreateFromInt32( (int) nPropId );
				aErr += " ! Can't get property name!";
				DBG_ERRORFILE( aErr.GetBuffer() );
#endif
				break;
	};
	return aPropName;
}

//----------------------------------------------------------------------------

class WrpJobList;

//============================================================================
//
//	WrpJob and WrpJobList.
//
//============================================================================

class WrpJob
{
	::vos::OMutex               maMutex;
	WrpJobList*					mpParent;
	Reference < XCommandProcessor> mxProcessor;
	sal_Int32                   mnId;
	sal_Bool                    mbDone;

public:
							WrpJob( WrpJobList* pParent, const Reference < XCommandProcessor > xProcessor, sal_Int32 nId );

							~WrpJob();

	void					SetParent( WrpJobList* pParent );
	void					Abort();
	void                    Done()
							{
								::vos::OGuard aGuard( maMutex );
								mbDone = TRUE;
							}
	BOOL                    IsDone()
							{
								::vos::OGuard aGuard( maMutex );
								return mbDone;
							}
};

//----------------------------------------------------------------------------

class WrpJobList : private List
{
	NAMESPACE_VOS(OMutex)	maMutex;

public:
							List::Count;
							List::First;
							List::Next;

							WrpJobList();
							~WrpJobList();

	WrpJob*                 CreateJob( const Reference < XCommandProcessor > xProcessor, sal_Int32 nId );
	void					RemoveJob( const WrpJob* pJob );
	void					AbortAll();
};

//----------------------------------------------------------------------------
WrpJob::WrpJob( WrpJobList* pParent,
			    const Reference < XCommandProcessor > xProcessor,
				sal_Int32 nId )
{
	mpParent = pParent;
	mbDone = FALSE;
	mnId = nId;
	mxProcessor = xProcessor;
}

//----------------------------------------------------------------------------
WrpJob::~WrpJob()
{
	if ( mpParent )
		mpParent->RemoveJob( this );
}

//----------------------------------------------------------------------------
void WrpJob::SetParent( WrpJobList* pParent )
{
	OGuard aGuard( maMutex );
	mpParent = pParent;
}

//----------------------------------------------------------------------------
void WrpJob::Abort()
{
	OGuard aGuard( maMutex );

	if ( !mbDone )
	{
		mxProcessor->abort( mnId );
		mbDone = TRUE;
	}
}

WrpJobList::WrpJobList()
	: List( 4, 4 )
{
}

//----------------------------------------------------------------------------
WrpJobList::~WrpJobList()
{
	AbortAll();
}

//----------------------------------------------------------------------------
WrpJob* WrpJobList::CreateJob( const Reference < XCommandProcessor > xProcessor, sal_Int32 nId )
{
	OGuard aGuard( maMutex );
	WrpJob* pJob = new WrpJob( this, xProcessor, nId );
	Insert( pJob, LIST_APPEND );
	return pJob;
}

//----------------------------------------------------------------------------
void WrpJobList::AbortAll()
{
	OGuard aGuard( maMutex );
	while ( Count() )
	{
		WrpJob* pJob = (WrpJob*) Remove( (ULONG) NULL );
		pJob->Abort();
		delete pJob;
	}
}

//----------------------------------------------------------------------------
void WrpJobList::RemoveJob( const WrpJob* pJob )
{
	OGuard aGuard( maMutex );
	Remove( (void*) pJob );
}

//----------------------------------------------------------------------------
// class UcbLockBytes
//----------------------------------------------------------------------------
class CommandThread_Impl;

class UcbLockBytes : public SfxCancellable, public virtual SvLockBytes
{
	vos::OCondition			m_aInitialized;
	vos::OCondition			m_aTerminated;
	vos::OMutex				m_aMutex;
	Reference<XInputStream> m_xInputStream;
	CommandThread_Impl*		m_pCommandThread;

	sal_Bool                m_bTerminated;
	sal_Bool				m_bDontClose;

	sal_uInt32              m_nRead;
	sal_uInt32              m_nSize;

	UCB_Link_HelperRef		m_aLinkList;

public:
							UcbLockBytes( UCB_Link_HelperRef xLink,
										  SfxCancelManager *pMgr,
										  const String &rTitle )
								: SfxCancellable( pMgr, rTitle ),
								m_xInputStream( NULL ),
								m_pCommandThread( NULL ),
								m_bTerminated( sal_False ),
								m_bDontClose( sal_False ),
								m_nRead (0),
								m_nSize (0),
								m_aLinkList( xLink )
								{}

							UcbLockBytes( UCB_Link_HelperRef xLink )
								: SfxCancellable( NULL, OUString() ),
								m_xInputStream (NULL),
								m_pCommandThread( NULL ),
								m_bTerminated  (sal_False),
								m_bDontClose( sal_False ),
								m_nRead (0),
								m_nSize (0),
								m_aLinkList( xLink )
								{}

	Reference<XInputStream> getInputStream (void) const
							{	vos::OGuard aGuard( SAL_CONST_CAST(UcbLockBytes*, this)->m_aMutex );
								return m_xInputStream; }

	sal_Bool                hasInputStream (void) const
							{	vos::OGuard aGuard( SAL_CONST_CAST(UcbLockBytes*, this)->m_aMutex );
								return m_xInputStream.is(); }

	sal_Bool                setInputStream ( const Reference<XInputStream> &rxInputStream);
	void                    terminate (void);
	void					setCommandThread( CommandThread_Impl* pThread )
							{ m_pCommandThread = pThread; }
	void					setDontClose() { m_bDontClose = sal_True; }

	// SvLockBytes
	virtual void            SetSynchronMode (BOOL bSynchron);
	virtual ErrCode         ReadAt ( ULONG nPos, void *pBuffer, ULONG nCount, ULONG *pRead) const;
	virtual ErrCode         WriteAt ( ULONG, const void*, ULONG, ULONG *pWritten);
	virtual ErrCode         Flush (void) const;
	virtual ErrCode         SetSize (ULONG);
	virtual ErrCode         Stat ( SvLockBytesStat *pStat, SvLockBytesStatFlag) const;

	// SfxCancellable
	virtual void			Cancel();

	virtual void			Canceled();

	DECL_LINK(				DataAvailHdl, void * );

protected:
	virtual                 ~UcbLockBytes (void);
};

//----------------------------------------------------------------------------
SV_DECL_IMPL_REF( UcbLockBytes );

//----------------------------------------------------------------------------
// class CommandThread_Impl
//----------------------------------------------------------------------------
class CommandThread_Impl : public ::vos::OThread
{
	Reference < XContent >				m_xContent;
	Reference< XInteractionHandler >	m_xInteract;
	Reference< XProgressHandler >		m_xProgress;

	OpenCommandArgument2    m_aArgument;
	UcbLockBytesRef			m_xLockBytes;
	UCB_Link_HelperRef		m_xLink;
	sal_Int32				m_nCmdId;
	sal_Bool				m_bCanceled	: 1;
	sal_Bool				m_bRunning	: 1;
	sal_Bool				m_bSimple	: 1;

public:
					CommandThread_Impl( Reference < XContent > xContent,
										const OpenCommandArgument2& rArg,
										Reference < XInteractionHandler > xInteract,
										Reference < XProgressHandler > xProgress,
										UCB_Link_HelperRef xLink )
						: m_xContent( xContent )
						, m_xInteract( xInteract )
						, m_xProgress( xProgress )
						, m_aArgument( rArg )
						, m_xLink( xLink )
						, m_bCanceled( sal_False )
						, m_bRunning( sal_False )
						, m_bSimple( sal_False )
					{}

					CommandThread_Impl( UcbLockBytesRef xLockBytes )
						: m_xLockBytes( xLockBytes )
						, m_bCanceled( sal_False )
						, m_bRunning( sal_False )
						, m_bSimple( sal_True )
					{}

	virtual void SAL_CALL   onTerminated();
	virtual void SAL_CALL   run();

	void					Cancel();
};

//----------------------------------------------------------------------------
void CommandThread_Impl::run()
{
	if ( m_bSimple )
	{
		m_bRunning = sal_True;
		m_xLockBytes->terminate();
		m_bRunning = sal_False;
		return;
	}

	m_bRunning = sal_True;

	if( !m_bCanceled && schedule() )
	{
		Reference< XCommandProcessor > xProc( m_xContent, UNO_QUERY );
		if ( xProc.is() )
		{
			m_nCmdId = xProc->createCommandIdentifier();
			Reference< XCommandEnvironment > xEnv( new UcbTaskEnvironment( m_xInteract, m_xProgress ) );

			Any aParam;
			sal_Bool bSuccess;

			aParam <<= m_aArgument;
			UCB_Helper::ExecuteOpenCommand( m_xContent, aParam, m_nCmdId, xEnv, bSuccess );
			
			if ( !bSuccess )
			{
				if( m_xLink.Is() )
					m_xLink->Cancel();

				Reference < XInputStream > aDummy;
				Reference < XActiveDataSink > ::query(m_aArgument.Sink)->setInputStream( aDummy );
			}

			Reference < XActiveDataControl > ::query(m_aArgument.Sink)->terminate();
		}
	}

	m_bRunning = sal_False;
}

//----------------------------------------------------------------------------
void CommandThread_Impl::onTerminated()
{
	delete this;
}

//----------------------------------------------------------------------------
void CommandThread_Impl::Cancel()
{
	if ( m_bCanceled )
		return;

	m_bCanceled = sal_True;

	if ( m_bRunning && !m_bSimple )
	{
		Reference< XCommandProcessor > xProc( m_xContent, UNO_QUERY );

		if ( xProc.is() )
		{
			xProc->abort( m_nCmdId );
		}

		m_bRunning = sal_False;
	}
}

//----------------------------------------------------------------------------
UcbLockBytes::~UcbLockBytes()
{
	if ( !m_bDontClose && m_xInputStream.is() )
		m_xInputStream->closeInput();
}

//----------------------------------------------------------------------------
sal_Bool UcbLockBytes::setInputStream( const Reference<XInputStream> &rxInputStream )
{
	BOOL bRet;

	vos::OClearableGuard aGuard( m_aMutex );

	if ( !m_bDontClose && m_xInputStream.is() )
		m_xInputStream->closeInput();

	m_xInputStream = rxInputStream;
	bRet = m_xInputStream.is();
	aGuard.clear();

	m_aInitialized.set();

	return bRet;
}

//----------------------------------------------------------------------------
void UcbLockBytes::terminate (void)
{
	m_pCommandThread = NULL;

	Reference<XInputStream> xStream = getInputStream();
	Reference<XSeekable> xSeekable (xStream, UNO_QUERY);

	if ( xSeekable.is() )
		m_nSize = sal_uInt32(xSeekable->getLength());

	m_bTerminated = sal_True;

	m_aInitialized.set();
	m_aTerminated.set();

	SetManager( NULL );

	m_aLinkList->Done();
}

//----------------------------------------------------------------------------
void UcbLockBytes::SetSynchronMode (BOOL bSynchron)
{
	SvLockBytes::SetSynchronMode (bSynchron);
}

//----------------------------------------------------------------------------
ErrCode UcbLockBytes::ReadAt ( ULONG nPos, void *pBuffer, ULONG nCount, ULONG *pRead) const
{
	if ( IsSynchronMode() )
	{
		ULONG nAcquireCount = 0;
		IMutex& rMutex = Application::GetSolarMutex();
		if ( rMutex.tryToAcquire() )
			nAcquireCount = Application::ReleaseSolarMutex() - 1;

		SAL_CONST_CAST(UcbLockBytes*, this)->m_aInitialized.wait();

		if ( nAcquireCount )
			Application::AcquireSolarMutex( nAcquireCount );
	}

	Reference<XInputStream> xStream = getInputStream();

	if ( !xStream.is() )
	{
		if ( m_bTerminated )
			return ERRCODE_IO_CANTREAD;
		else
			return ERRCODE_IO_PENDING;
	}

	if ( pRead )
		*pRead = 0;

	Reference < XSeekable > xSeekable( xStream, UNO_QUERY );
	if ( !xSeekable.is() )
		return ERRCODE_IO_CANTREAD;

	try
	{
		xSeekable->seek( nPos );
	}
	catch ( IOException )
	{
		return ERRCODE_IO_CANTSEEK;
	}

	Sequence<sal_Int8> aData;
	sal_Int32          nSize;

	nCount = VOS_MIN(nCount, 0x7FFFFFFF);
	try
	{
		if ( !m_bTerminated && !IsSynchronMode() )
		{
			sal_Int64 nLen = xSeekable->getLength();
			if ( nPos + nCount > nLen )
				return ERRCODE_IO_PENDING;
		}

		nSize = xStream->readBytes( aData, sal_Int32(nCount) );
	}
	catch (IOException)
	{
		return ERRCODE_IO_CANTREAD;
	}

	rtl_copyMemory (pBuffer, aData.getConstArray(), nSize);
	if (pRead)
		*pRead = ULONG(nSize);

	sal_uInt32 nRead = VOS_MAX(m_nRead, nPos + nSize);
	SAL_CONST_CAST(UcbLockBytes*, this)->m_nRead = nRead;

	return ERRCODE_NONE;
}

//----------------------------------------------------------------------------
ErrCode UcbLockBytes::WriteAt ( ULONG, const void*, ULONG, ULONG *pWritten)
{
	if ( pWritten )
		*pWritten = 0;
	return ERRCODE_IO_CANTWRITE;
}

//----------------------------------------------------------------------------
ErrCode UcbLockBytes::Flush (void) const
{
	return ERRCODE_NONE;
}

//----------------------------------------------------------------------------
ErrCode UcbLockBytes::SetSize (ULONG)
{
	return ERRCODE_IO_NOTSUPPORTED;
}

//----------------------------------------------------------------------------
ErrCode UcbLockBytes::Stat( SvLockBytesStat *pStat, SvLockBytesStatFlag) const
{
	if (!pStat)
		return ERRCODE_IO_INVALIDPARAMETER;

	if ( IsSynchronMode() )
	{
		ULONG nAcquireCount = 0;
		IMutex& rMutex = Application::GetSolarMutex();
		if ( rMutex.tryToAcquire() )
			nAcquireCount = Application::ReleaseSolarMutex() - 1;

		SAL_CONST_CAST(UcbLockBytes*, this)->m_aTerminated.wait();

		if ( nAcquireCount )
			Application::AcquireSolarMutex( nAcquireCount );
	}

	Reference<XInputStream> xStream = getInputStream();

	if (!xStream.is())
		return ERRCODE_IO_INVALIDACCESS;

	Reference<XSeekable> xSeekable (xStream, UNO_QUERY);
	if (!xSeekable.is())
		return ERRCODE_IO_INVALIDACCESS;

	try
	{
		pStat->nSize = ULONG(xSeekable->getLength());
	}
	catch (IOException)
	{
		return ERRCODE_IO_CANTTELL;
	}

	if (!m_bTerminated)
		return ERRCODE_IO_PENDING;
	else
		return ERRCODE_NONE;
}

//----------------------------------------------------------------------------
void UcbLockBytes::Cancel()
{
	if ( m_bTerminated )
		return;

	if ( m_pCommandThread )
	{
		m_pCommandThread->Cancel();
		m_pCommandThread = NULL;
	}

	SetManager( NULL );
}

//----------------------------------------------------------------------------
void UcbLockBytes::Canceled()
{
	if ( m_aLinkList.Is() )
		m_aLinkList->Cancel();
}


//----------------------------------------------------------------------------
IMPL_LINK( UcbLockBytes, DataAvailHdl, void*, EMPTYARG )
{
	if ( hasInputStream() )
		m_aLinkList->DataAvail();

	return 0;
}

//----------------------------------------------------------------------------
// class UcbDataSink_Impl
//----------------------------------------------------------------------------
class UcbDataSink_Impl : public WeakImplHelper2< XActiveDataControl, XActiveDataSink >
{
	UcbLockBytesRef         m_xLockBytes;

public:
							UcbDataSink_Impl( UcbLockBytes* pLockBytes )
								: m_xLockBytes( pLockBytes )
							{}

	SvLockBytes*            getLockBytes (void)
							{ return m_xLockBytes; }

	// XActiveDataControl.
	virtual void SAL_CALL   addListener ( const Reference<XStreamListener> &rxListener) throw(RuntimeException);
	virtual void SAL_CALL   removeListener ( const Reference<XStreamListener> &rxListener) throw(RuntimeException);
	virtual void SAL_CALL   start (void) throw(RuntimeException);
	virtual void SAL_CALL   terminate (void) throw(RuntimeException);

	// XActiveDataSink.
	virtual void SAL_CALL   setInputStream ( const Reference<XInputStream> &rxInputStream) throw(RuntimeException);
	virtual Reference<XInputStream> SAL_CALL getInputStream (void) throw(RuntimeException);
};

void SAL_CALL UcbDataSink_Impl::addListener ( const Reference<XStreamListener> &rxListener) throw(RuntimeException)
{
	// not supported
}

void SAL_CALL UcbDataSink_Impl::removeListener ( const Reference<XStreamListener> &rxListener) throw(RuntimeException)
{
	// not supported
}

void SAL_CALL UcbDataSink_Impl::start (void) throw(RuntimeException)
{
}

void SAL_CALL UcbDataSink_Impl::terminate (void) throw(RuntimeException)
{
	m_xLockBytes->terminate();
}

void SAL_CALL UcbDataSink_Impl::setInputStream ( const Reference<XInputStream> &rxInputStream) throw(RuntimeException)
{
	m_xLockBytes->setInputStream (rxInputStream);
}

Reference<XInputStream> SAL_CALL UcbDataSink_Impl::getInputStream (void) throw(RuntimeException)
{
	return m_xLockBytes->getInputStream();
}

//-------------------------------------------------------------------------
UcbTaskEnvironment::UcbTaskEnvironment( const Reference< XInteractionHandler >& rxInteractionHandler,
										const Reference< XProgressHandler >& rxProgressHandler )
	: m_xInteractionHandler( rxInteractionHandler )
	, m_xProgressHandler( rxProgressHandler )
{
}

//============================================================================
//
//	Ucb.
//
//============================================================================

#define UCB_MODULE_PREFIX "cnt"

class Ucb
{
	Reference< XMultiServiceFactory >	   m_xFac;
	Reference< XContentProviderManager >   m_xProvMgr;
	Reference< XContentProvider >   	   m_xProv;
	Reference< XContentIdentifierFactory > m_xIdFac;
	sal_Bool m_bInited : 1;

public:
	Ucb();
	~Ucb();

	sal_Bool init();

	XContentIdentifierFactory*	getContentIdentifierFactory();
	XContentProvider* 			getContentProvider();
};

//-------------------------------------------------------------------------

static Ucb* pUcb = NULL;

//-------------------------------------------------------------------------
Ucb::Ucb()
: m_bInited( sal_False )
{
	m_xFac = ::utl::getProcessServiceFactory();
}

//-------------------------------------------------------------------------
Ucb::~Ucb()
{
}

//-------------------------------------------------------------------------
sal_Bool Ucb::init()
{
	if ( m_bInited )
		return sal_True;

#if 0 //@@@ SB: That old hack of initializing the UCB with a
	  // XMultiServiceFactory is no longer supported/required:
	// init remote ucb
	Reference< XInitialization > xInit(
		m_xFac->createInstance(
			DEFINE_CONST_UNICODE("com.sun.star.ucb.UniversalContentBroker") ), UNO_QUERY );

	if (xInit.is())
	{
		try
		{
			Sequence<Any> params(1);

			params.getArray()[0] = makeAny(m_xFac);

			xInit->initialize(params);
		}
		catch (Exception&)
		{
		}
	}
#endif

	//////////////////////////////////////////////////////////////////////
	// Create and UCB service.
	//////////////////////////////////////////////////////////////////////

	if ( m_xFac.is() )
	{
		// Create auto configured UCB:
		Sequence< Any > aArgs(1);
		aArgs[0] <<= sal_True;
		Reference< XInterface > xIfc(
			m_xFac->createInstanceWithArguments(
				DEFINE_CONST_UNICODE("com.sun.star.ucb.UniversalContentBroker"),
				aArgs ) );

		if ( xIfc.is() )
			m_xProvMgr = Reference< XContentProviderManager >::query( xIfc );
	}

	m_bInited = sal_True;
	return m_bInited;
}

//-------------------------------------------------------------------------
XContentIdentifierFactory* Ucb::getContentIdentifierFactory()
{
	if ( !m_xIdFac.is() )
	{
		if ( init() )
			m_xIdFac =
				Reference< XContentIdentifierFactory >::query( m_xProvMgr );
	}

	return m_xIdFac.get();
}

//-------------------------------------------------------------------------
XContentProvider* Ucb::getContentProvider()
{
	if ( !m_xProv.is() )
	{
		if ( init() )
			m_xProv = Reference< XContentProvider >::query( m_xProvMgr );
	}

	return m_xProv.get();
}

//============================================================================
//
//	ProgressHandler_Impl.
//
//============================================================================

class ProgressHandler_Impl: public cppu::OWeakObject,
							public XProgressHandler
{
	Link	m_aProgress;

public:
							ProgressHandler_Impl() {}

	void					SetProgressLink( const Link& rLink )
								{ m_aProgress = rLink; }

	virtual Any SAL_CALL	queryInterface( const Type & rType )
								throw (RuntimeException);

	virtual void SAL_CALL	acquire() throw (RuntimeException)
								{ OWeakObject::acquire(); }

	virtual void SAL_CALL	release() throw (RuntimeException)
								{ OWeakObject::release(); }

	virtual void SAL_CALL	push(const Any & rStatus) throw (RuntimeException);

	virtual void SAL_CALL	update(const Any & rStatus)
								throw (RuntimeException);

	virtual void SAL_CALL	pop() throw (RuntimeException);
};

//----------------------------------------------------------------------------
// virtual
Any SAL_CALL ProgressHandler_Impl::queryInterface( const Type & rType )
	throw (RuntimeException)
{
	Any aRet( ::cppu::queryInterface(	rType,
										static_cast< XProgressHandler* >( this )));

	if ( aRet.hasValue() )
		return aRet ;
	else
		return OWeakObject::queryInterface( rType );
}

//----------------------------------------------------------------------------
// virtual
void SAL_CALL ProgressHandler_Impl::push( const Any & rStatus )
	throw (RuntimeException)
{
}

//----------------------------------------------------------------------------
// virtual
void SAL_CALL ProgressHandler_Impl::update( const Any & rStatus )
	throw (RuntimeException)
{
	if ( m_aProgress.IsSet() )
		m_aProgress.Call( 0 );
}

//----------------------------------------------------------------------------
// virtual
void SAL_CALL ProgressHandler_Impl::pop()
	throw (RuntimeException)
{
}

//----------------------------------------------------------------------------
//
//	WrpJobList
//
//----------------------------------------------------------------------------


//============================================================================
//
//	UCB_Helper.
//
//============================================================================

WrpJobList * UCB_Helper::mpJobList = NULL;

//----------------------------------------------------------------------------
Any UCB_Helper::GetProperty( Reference < XContent > xContent, USHORT nPropId )
{
	OUString aName = getPropName_Impl( nPropId );
	if ( xContent.is() && aName.getLength() )
	{
		Sequence< Property > aProps( 1 );
		Property& rProp = aProps.getArray()[ 0 ];

		rProp.Name       = aName;
		rProp.Handle     = -1; /* unknown */

		Any aArg;
		aArg <<= aProps;

		Any aResult = ExecuteCommand( xContent,
									  DEFINE_CONST_OUSTRING( "getPropertyValues" ),
									  aArg );
		Reference< XRow > xValues;
		if ( aResult >>= xValues )
		{
			if ( xValues.is() )
			return xValues->getObject( 1, Reference< XNameAccess>() );
    	}
	}

	return Any();
}

//----------------------------------------------------------------------------
Any UCB_Helper::GetProperty( const String& rURL, USHORT nPropId )
{
	Any aRet;
	Reference < XContent > xContent = CreateContent( rURL );
	aRet = GetProperty( xContent, nPropId );
	return aRet;
}

//----------------------------------------------------------------------------
void UCB_Helper::SetProperty( const String& rURL, USHORT nPropId, const Any& rValue )
{
	Reference < XContent > xContent = CreateContent( rURL );
	SetProperty( xContent, nPropId, rValue );
}

//----------------------------------------------------------------------------
void UCB_Helper::SetProperty( Reference < XContent > xContent, USHORT nPropId, const Any& rValue )
{
	OUString aName = getPropName_Impl( nPropId );
	if ( xContent.is() && aName.getLength() )
	{
		Sequence< PropertyValue > aProps( 1 );
		PropertyValue& rProp = aProps.getArray()[ 0 ];

		rProp.Name       = aName;
		rProp.Handle     = -1; /* unknown */
		rProp.Value      = rValue;

		Any aArg;
		aArg <<= aProps;
		ExecuteCommand( xContent, DEFINE_CONST_OUSTRING( "setPropertyValues" ), aArg );
	}
}

//----------------------------------------------------------------------------
BOOL UCB_Helper::HasCommand( Reference < XContent > xContent,
							 USHORT nWhich )
{
	if ( !xContent.is() )
		return FALSE;

	OUString aCmdName = getPropName_Impl( nWhich );
	if ( ! aCmdName.getLength() )
		return FALSE;

	Any aRet = ExecuteCommand( xContent,
							   DEFINE_CONST_OUSTRING( "getCommandInfo" ),
							   Any() );

	Reference < XCommandInfo > xInfo;
	aRet >>= xInfo;
	if ( ! xInfo.is() )
		return FALSE;

	BOOL bRet = xInfo->hasCommandByName( aCmdName );

	return bRet;
}

//----------------------------------------------------------------------------
void UCB_Helper::ExecuteCommand( const String& rURL,
								 USHORT nId,
								 sal_Bool *pSuccess )
{
	Reference < XContent > xContent = CreateContent( rURL );
	ExecuteCommand( xContent, nId, Any(), pSuccess );
}

//----------------------------------------------------------------------------
void UCB_Helper::ExecuteCommand( const String& rURL,
								 USHORT nId,
								 const Any& rArgument,
								 sal_Bool *pSuccess )
{
	Reference < XContent > xContent = CreateContent( rURL );
	ExecuteCommand( xContent, nId, rArgument, pSuccess );
}

//----------------------------------------------------------------------------
void UCB_Helper::ExecuteCommand( Reference < XContent > xContent,
								 USHORT nId,
								 sal_Bool *pSuccess )
{
	ExecuteCommand( xContent, nId, Any(), pSuccess );
}

//----------------------------------------------------------------------------
void UCB_Helper::ExecuteCommand( Reference < XContent > xContent,
								 USHORT nId,
								 const Any& rArgument,
								 sal_Bool *pSuccess )
{
	OUString aName = getPropName_Impl( nId );
	if ( !xContent.is() || !aName.getLength() )
		return;

	ExecuteCommand( xContent, aName, rArgument, pSuccess );
}

//----------------------------------------------------------------------------
Any UCB_Helper::ExecuteCommand( Reference < XContent > xContent,
								const OUString& rName,
								const Any& rArgument,
								sal_Bool *pSuccess )
{
	Reference< XCommandProcessor > xProc( xContent, UNO_QUERY );
	if ( xProc.is() )
	{
		sal_Int32 nId = xProc->createCommandIdentifier();

		Command aCommand;
		aCommand.Name     = rName;
		aCommand.Handle   = -1; /* unknown */
		aCommand.Argument = rArgument;

		if ( !mpJobList )
			mpJobList = new WrpJobList();
		WrpJob* pJob = mpJobList->CreateJob( xProc, nId );

		Reference< XCommandEnvironment > xEnv( new UcbTaskEnvironment( globalInteractionHandler, globalProgressHandler ) );

		Any aResult;
		bool bException = false;
		bool bAborted = false;

		ULONG nAcquireCount = 0;
		IMutex& rMutex = Application::GetSolarMutex();
		if ( rMutex.tryToAcquire() )
			nAcquireCount = Application::ReleaseSolarMutex() - 1;
		
		try
		{
			// CommandId!
			aResult = xProc->execute( aCommand, nId, xEnv );
		}
		catch ( CommandAbortedException )
		{
			bAborted = true;
		}
		catch ( Exception )
		{
			bException = true;
		}

		if ( nAcquireCount )
			Application::AcquireSolarMutex( nAcquireCount );

		if ( !bAborted && !bException )
			pJob->Done();

		if ( pSuccess )
		{
			if ( bAborted || bException )
				*pSuccess = sal_False;
			else
				*pSuccess = sal_True;
		}

#ifdef DB_UTIL
		if( bException )
		{
			String aStr( "Executing " );
			aStr += U2S( aName );
			aStr += " with Exception!";
			DBG_ERROR( aStr.GetBuffer() );
		}
		else if ( bAborted )
		{
			String aStr( "Executing " );
			aStr += U2S( aName );
			aStr += " with Abort!";
			DBG_ERROR( aStr.GetBuffer() );
		}
#endif
		delete pJob;
		return aResult;
	}

	return Any();
}

//----------------------------------------------------------------------------
Any UCB_Helper::ExecuteOpenCommand( Reference < XContent > xContent,
									const Any& rArgument,
									sal_Int32 nCmdId,
									Reference< XCommandEnvironment > xEnv,
									sal_Bool &rSuccess )
{
	Reference< XCommandProcessor > xProc( xContent, UNO_QUERY );

	if ( xProc.is() )
	{
		Command aCommand;
		aCommand.Name     = getPropName_Impl( WID_OPEN );
		aCommand.Handle   = WID_OPEN;
		aCommand.Argument = rArgument;

		if ( !mpJobList )
			mpJobList = new WrpJobList();

		WrpJob* pJob = mpJobList->CreateJob( xProc, nCmdId );

		Any aResult;
		bool bException = false;
		bool bAborted = false;

		ULONG nAcquireCount = 0;
		IMutex& rMutex = Application::GetSolarMutex();
		if ( rMutex.tryToAcquire() )
			nAcquireCount = Application::ReleaseSolarMutex() - 1;
		
		try
		{
			rSuccess = sal_False;
			aResult = xProc->execute( aCommand, nCmdId, xEnv );
			rSuccess = sal_True;
		}
		catch ( CommandAbortedException )
		{
			bAborted = true;
		}
		catch ( Exception )
		{
			bException = true;
		}

		if ( nAcquireCount )
			Application::AcquireSolarMutex( nAcquireCount );

		if ( !bAborted && !bException )
			pJob->Done();

#ifdef DB_UTIL
		if( bException )
		{
			String aStr( "Executing " );
			aStr += U2S( aName );
			aStr += " with Exception!";
			DBG_ERROR( aStr.GetBuffer() );
		}
		else if ( bAborted )
		{
			String aStr( "Executing " );
			aStr += U2S( aName );
			aStr += " with Abort!";
			DBG_ERROR( aStr.GetBuffer() );
		}
#endif
		delete pJob;
		return aResult;
	}

	return Any();
}

//----------------------------------------------------------------------------
Reference < XContent > UCB_Helper::CreateContent( const String& rURL )
{
	OUString aURL ( rURL );
	return CreateContent( aURL );
}

//----------------------------------------------------------------------------
Reference < XContent > UCB_Helper::CreateContent( const OUString& rURL )
{
	Reference < XContent > aRet;

	Reference< XContentIdentifierFactory > xIdFac =
		pUcb->getContentIdentifierFactory();

	if ( !xIdFac.is() )
		return aRet;

	Reference< XContentIdentifier > xId =
		xIdFac->createContentIdentifier( rURL );

	if ( !xId.is() )
		return aRet;

	//////////////////////////////////////////////////////////////////////
	// Get XContentProvider interface from UCB and let it create a
	// content for the given identifier.
	//////////////////////////////////////////////////////////////////////

	Reference< XContentProvider > xProv = pUcb->getContentProvider();
	if ( !xProv.is() )
		return aRet;

	try
	{
		aRet = xProv->queryContent( xId );
	}
	catch ( IllegalIdentifierException ) {}

	return aRet;
}

//----------------------------------------------------------------------------
void UCB_Helper::Initialize()
{
	Reference< XMultiServiceFactory > xFactory = ::utl::getProcessServiceFactory();
	globalInteractionHandler= Reference< XInteractionHandler > (
				xFactory->createInstance( DEFINE_CONST_UNICODE("com.sun.star.uui.InteractionHandler") ), UNO_QUERY );

	globalProgressHandler = new ProgressHandler_Impl();
	if ( !pUcb )
		pUcb = new Ucb;

	// Create auto configured UCB:
	Sequence< Any > aArgs(1);
	aArgs[0] <<= sal_True;
	::ucb::ContentBroker::initialize( xFactory, aArgs );
}

//----------------------------------------------------------------------------
void UCB_Helper::Deinitialize()
{
	::ucb::ContentBroker::deinitialize();
	delete pUcb;

//	CntSystem::Deinitialize();

	globalInteractionHandler = NULL;
}

//----------------------------------------------------------------------------
void UCB_Helper::SetConnectionMode( BOOL bOn )
{
	// bOn == Offline
//      CntConnModeItem aItem( WID_CONNECTION_MODE, bOffLine ? CNT_CONN_MODE_OFFLINE: CNT_CONN_MODE_ONLINE );
//      CNT_SYS()->Put( aItem );
//    DBG_ERRORFILE( "NYI" );
}

//----------------------------------------------------------------------------
BOOL UCB_Helper::GetConnectionMode()
{
//    DBG_ERRORFILE( "NYI" );
	return FALSE;
}

//----------------------------------------------------------------------------
SvLockBytesRef UCB_Helper::CreateInputLockBytes( Reference < XContent > xContent,
												 UCB_Link_HelperRef	xLink,
												 SfxCancelManager *pMgr )
{
	if( !xContent.is() )
		return NULL;;

/*
	Reference<XPropertiesChangeNotifier> xProps ( xContent, UNO_QUERY );
	if ( xProps.is() )
	{
		m_aContentType = getContentType_Impl (xProps);
		if( !m_aContentType.Len() )
			m_aContentType = CONTENT_TYPE_STR_APP_OCTSTREAM;
		m_bMimeAvail = sal_True;
		xProps->addPropertiesChangeListener ( Sequence< OUString >(), this );
	}
*/
	OpenCommandArgument2 aArgument;
	String aCmd = DEFINE_CONST_UNICODE( "Open" );
	UcbLockBytesRef xLockBytes = new UcbLockBytes( xLink, pMgr, aCmd );
	Reference < XActiveDataSink > xSink = new UcbDataSink_Impl( xLockBytes );
	aArgument.Sink = xSink;
	aArgument.Mode = OpenMode::DOCUMENT;

	ProgressHandler_Impl			*pProgressHdl = new ProgressHandler_Impl();
	Reference< XProgressHandler >	 xProgressHdl = pProgressHdl;
	pProgressHdl->SetProgressLink( LINK( &xLockBytes, UcbLockBytes, DataAvailHdl ) );

	::vos::OThread *pThread = new CommandThread_Impl( xContent, aArgument,
													  globalInteractionHandler,
													  xProgressHdl, xLink );
	xLockBytes->setCommandThread( (CommandThread_Impl*) pThread );
	pThread->create();

	return SvLockBytesRef( xLockBytes );
}

//----------------------------------------------------------------------------
SvLockBytesRef UCB_Helper::CreateInputLockBytes( const Reference< XInputStream > &rxInputStream,
												 UCB_Link_HelperRef	xLink,
												 SfxCancelManager *pMgr )
{
	if( !rxInputStream.is() )
		return NULL;;

	String aCmd = DEFINE_CONST_UNICODE( "Open" );
	UcbLockBytesRef xLockBytes = new UcbLockBytes( xLink, pMgr, aCmd );
	Reference < XActiveDataSink > xSink = new UcbDataSink_Impl( xLockBytes );

	xLockBytes->setDontClose();
	xLockBytes->setInputStream( rxInputStream );

	// we have to create a thread here so ::terminate() will be called
	// asynchronously
	::vos::OThread *pThread = new CommandThread_Impl( xLockBytes );
	pThread->create();

	return SvLockBytesRef( xLockBytes );
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
void UCB_Link_Helper::SetDoneLink( const Link& rLink )
{
	OGuard aGuard( maMutex );
	mbSet = TRUE;
	maDoneLink = rLink;
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::SetDataAvailLink( const Link& rLink )
{
	OGuard aGuard( maMutex );
	mbSet = TRUE;
	maDataAvailLink = rLink;
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::SetCancelLink( const Link& rLink )
{
	OGuard aGuard( maMutex );
	mbSet = TRUE;
	maCancelLink = rLink;
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::Done()
{
	OGuard aGuard( maMutex );

	if ( maDoneLink.IsSet() )
		maDoneLink.Call( 0 );
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::DataAvail()
{
	OGuard aGuard( maMutex );

	if ( maDataAvailLink.IsSet() )
		maDataAvailLink.Call( 0 );
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::Cancel()
{
	OGuard aGuard( maMutex );

	if ( maCancelLink.IsSet() )
		maCancelLink.Call( 0 );
}

//----------------------------------------------------------------------------
void UCB_Link_Helper::Clear()
{
	OGuard aGuard( maMutex );

	if ( mbSet )
	{
		maDoneLink = Link();
		maDataAvailLink = Link();
		maCancelLink = Link();
		mbSet = FALSE;
	}
}

