/*************************************************************************
 *
 *  $RCSfile: beanfrm.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_BEANFRM_HXX
#define _SFX_BEANFRM_HXX

#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_XIMPLEMENTATIONLOADER_HPP_
#include <com/sun/star/loader/XImplementationLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_LOADER_CANNOTACTIVATEFACTORYEXCEPTION_HPP_
#include <com/sun/star/loader/CannotActivateFactoryException.hpp>
#endif
#include <vcl/wrkwin.hxx>
#include "viewfrm.hxx"
#include "frame.hxx"

class SfxJavaBeanWorkWindow : public WorkWindow
{
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > 				xFrame;
public:
							SfxJavaBeanWorkWindow( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & rFrame, WinBits nWinStyle = 0 );
	virtual sal_Bool 			Close();
};

class SfxExternalTopFrame_Impl;
class SfxExternalTopFrame: public SfxFrame
{
	SfxExternalTopFrame_Impl*	pImp;
	Window*						pWindow;

public:

	TYPEINFO();
							SfxExternalTopFrame( Window *pExternal=0 );
	virtual 				~SfxExternalTopFrame();

	virtual Window&			GetWindow() const;
	virtual sal_Bool			Close();
	virtual	sal_Bool			InsertDocument( SfxObjectShell *pDoc );
};

#if __PRIVATE

class SfxExternalViewFrameWindow_Impl;
class SfxExternalTopViewFrame_Impl : public SfxViewFrame
{
	sal_Bool					bActive;
	SfxExternalViewFrameWindow_Impl *pImp;

protected:

	virtual void            Activate( sal_Bool bUI );
	virtual void            Deactivate( sal_Bool bUI );
	virtual sal_Bool            Close();
	virtual void            Notify(SfxBroadcaster& rBC,  const SfxHint& rHint);

public:
	TYPEINFO();
							SFX_DECL_INTERFACE(SFX_INTERFACE_SFXEXTERNALVIEWFRM);
							SfxExternalTopViewFrame_Impl( SfxFrame* pFrame,
								SfxObjectShell* pDoc=NULL, sal_uInt16 nViewId=0 );
	virtual 				~SfxExternalTopViewFrame_Impl();

	virtual void            SetZoomFactor( const Fraction &rZoomX,
										   const Fraction &rZoomY );
	virtual sal_Bool			SetBorderPixelImpl( const SfxViewShell *pSh,
									const SvBorder &rBorder );
	virtual void			InvalidateBorderImpl( const SfxViewShell *pSh );
	virtual	void			MakeActive_Impl();
	void					Exec_Impl(SfxRequest &);
	void                    GetState_Impl(SfxItemSet &);
	void					INetExecute_Impl(SfxRequest &);
	void					INetState_Impl(SfxItemSet &);
};

#endif

#endif


