/*************************************************************************
 *
 *  $RCSfile: downloadcontroller.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFX_DOWNLOADCONTROLLER_HXX
#define _SFX_DOWNLOADCONTROLLER_HXX

#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XACTIONLISTENER_HPP_
#include <com/sun/star/awt/XActionListener.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XCONTROL_HPP_
#include <com/sun/star/awt/XControl.hpp>
#endif

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#ifndef _VOS_MUTEX_HXX_
#include <vos/mutex.hxx>
#endif
#include "sfxuno.hxx"

class Downloader_Impl;

struct DownloadStatus
{
	sal_uInt32		nStartTime		;
	sal_uInt32		nBytesRec		;
	XubString	aStatusString	;
	sal_Bool		bOwnPercent		;
	sal_uInt32		nPercent		;
} ;

class LocalFile : public INetURLObject
{
	private:
		sal_Bool	bIsSet;

	public:
		 		LocalFile() :  bIsSet (sal_False) {} ;
				~LocalFile() {} ;
		void 	SetValid() { bIsSet = sal_True ; }
		void 	Invalidate() { bIsSet = sal_False; }
		sal_Bool 	IsValid() const { return bIsSet; }
} ;

class DownloadController : public ::com::sun::star::lang::XServiceInfo
						 , public ::com::sun::star::lang::XTypeProvider
						 , public ::com::sun::star::frame::XController
						 , public ::com::sun::star::awt::XActionListener
						 , public SfxListener
						 , public ::cppu::OWeakObject
{
	::vos::OMutex																			m_aMutex;
	::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > 					xDownloadMonitor	;
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > 					_xFrame				;
	Timer						aDownloadTimer		;
	DownloadStatus				aStat				;
	LocalFile					aLocalFile			;
	INetURLObject				_aSourceURL			;
	Downloader_Impl*			pDownloader			;
	sal_uInt32						nTotalSize			;
	sal_uInt32						nUserEventID		;
	sal_uInt32						nAskEventID			;
	sal_Bool 						bInAsk				;
	sal_Bool						bInClose			;
	sal_Bool 						bInCancel			;
	sal_Bool						bDownloading		;

	void						SendClose();
	sal_Bool						AskLocalFile();
	void						WriteToFile();
	sal_Bool 						IsSufficientDiskSpace( sal_uInt32 nFileSize, const XubString& rDestinationPath );
	virtual void 				SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType	);

	DECL_LINK ( 				Download_Impl, void* );
	DECL_LINK ( 				Finished_Impl, void* );
	DECL_LINK ( 				AskLocalFile_Impl, void* );
	void						CancelDownload_Impl();

public:
	sal_Bool 						StartDownload( const String& rSource );

	SFX_DECL_XINTERFACE_XTYPEPROVIDER_XSERVICEINFO
	// IMPLNAME "com.sun.star.comp.sfx2.DownloadController" );

	DownloadController( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xFactory );
	virtual	~DownloadController();

//ASDBG	virtual void* getImplementation(Reflection *p)
//ASDBG { return OWeakObject::getImplementation(p); }


	//----------------------------------------------------------------------------------------------------------------------------------
	//  ::com::sun::star::awt::XActionListener, ::com::sun::star::lang::XEventListener
    virtual void SAL_CALL actionPerformed					( const ::com::sun::star::awt::ActionEvent& rEvent																	) throw( ::com::sun::star::uno::RuntimeException );
	void 		 SAL_CALL 				addEventListener				( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener 														) throw( ::com::sun::star::uno::RuntimeException );
	void 		 SAL_CALL 				removeEventListener 			( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener 														) throw( ::com::sun::star::uno::RuntimeException );
	void 		 SAL_CALL 				disposing						( const ::com::sun::star::lang::EventObject& Source 																) throw( ::com::sun::star::uno::RuntimeException );

	//----------------------------------------------------------------------------------------------------------------------------------
	// ::com::sun::star::frame::XController, ::com::sun::star::lang::XComponent
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  SAL_CALL					getFrame						(																							) throw( ::com::sun::star::uno::RuntimeException );
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel >  SAL_CALL					getModel						(																							) throw( ::com::sun::star::uno::RuntimeException );
	::com::sun::star::uno::Any	  SAL_CALL					getViewData						(																							) throw( ::com::sun::star::uno::RuntimeException );
	void 			 SAL_CALL			attachFrame 					( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame 																	) throw( ::com::sun::star::uno::RuntimeException );
	sal_Bool 		 SAL_CALL				attachModel 					( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > & xModel 																	) throw( ::com::sun::star::uno::RuntimeException );
	sal_Bool 		 SAL_CALL				suspend 						( sal_Bool bSuspend 																			) throw( ::com::sun::star::uno::RuntimeException );
	void 			 SAL_CALL			restoreViewData 				( const ::com::sun::star::uno::Any& Data 																		) throw( ::com::sun::star::uno::RuntimeException );
	void			 SAL_CALL			dispose							(																							) throw( ::com::sun::star::uno::RuntimeException );							// ::com::sun::star::lang::XComponent
} ;

#endif
