/*************************************************************************
 *
 *  $RCSfile: framedlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FRAMEDLG_HXX
#define _FRAMEDLG_HXX

// include ---------------------------------------------------------------

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#include "tabdlg.hxx"

// forward ---------------------------------------------------------------

class SfxViewFrame;
class SfxFrameDescriptor;
class SfxFrameSetDescriptor;

// class SfxFrameEditDialog_Impl -----------------------------------------

class SfxFrameEditDialog_Impl: public SfxTabDialog
{
public:
	SfxFrameEditDialog_Impl( Window *pParent, const SfxItemSet* pSet );
};

// class SfxFramePropertiesPage_Impl -------------------------------------

class SfxFramePropertiesPage_Impl: public SfxTabPage
{
private:
	FixedText           	aFTName;
	Edit		        	aEDName;
	FixedText	        	aFTURL;
	Edit		        	aEDURL;
	PushButton				aBTOpen;

	RadioButton		    	aRBScrollingOn;
	RadioButton		    	aRBScrollingOff;
	RadioButton		    	aRBScrollingAuto;
	GroupBox		    	aScrollingGroupBox;

	RadioButton 	    	aRBFrameBorderOn;
	RadioButton 	    	aRBFrameBorderOff;
	RadioButton 	    	aRBFrameBorderInherit;
	GroupBox		    	aGBFrameBorder;

	FixedText		    	aFTMarginWidth;
	NumericField	    	aNMMarginWidth;
	CheckBox				aCBMarginWidthDefault;
	FixedText		    	aFTMarginHeight;
	NumericField	    	aNMMarginHeight;
	CheckBox				aCBMarginHeightDefault;
	GroupBox		    	aMarginGroupBox;

	DECL_STATIC_LINK( 		SfxFramePropertiesPage_Impl, OpenHdl, PushButton* );
	DECL_STATIC_LINK( 		SfxFramePropertiesPage_Impl, CheckHdl, CheckBox* );

public:
							SfxFramePropertiesPage_Impl( Window *pParent, const SfxItemSet& rSet );
	virtual BOOL			FillItemSet( SfxItemSet& );
	virtual void			Reset( const SfxItemSet& );
};

// class SfxFrameSizePage_Impl -------------------------------------------

class SfxFrameSizePage_Impl: public SfxTabPage
{
	GroupBox 		    	aGBWidth;
	NumericField	    	aNMWidth;
	CheckBox		    	aCBResizeWidth;
	RadioButton    			aRBPixelWidth;
	RadioButton 			aRBPercentWidth;
	RadioButton 			aRBRelativeWidth;
	FixedInfo				aWidthInfo;
	GroupBox 		    	aGBHeight;
	NumericField	    	aNMHeight;
	CheckBox		    	aCBResizeHeight;
	RadioButton				aRBPixelHeight;
	RadioButton     	   	aRBPercentHeight;
	RadioButton 	       	aRBRelativeHeight;
	FixedInfo				aHeightInfo;

public:
							SfxFrameSizePage_Impl( Window *pParent, const SfxItemSet& rSet );
	virtual BOOL			FillItemSet( SfxItemSet& );
	virtual void			Reset( const SfxItemSet& );
};

// class SfxFrameSpacingPage_Impl ----------------------------------------

class SfxFrameSpacingPage_Impl: public SfxTabPage
{
	FixedText		    	aFTFrameSpacing;
	NumericField	    	aNMFrameSpacing;
	CheckBox		    	aCBFrameSpacingInherit;
	FixedText		    	aFTFrameSpacingColor;
	Edit	    			aEdFrameSpacingColor;
	CheckBox		    	aCBFrameSpacingColorInherit;

	DECL_STATIC_LINK( 		SfxFrameSpacingPage_Impl, CheckHdl, CheckBox* );

public:
							SfxFrameSpacingPage_Impl( Window *pParent, const SfxItemSet& rSet );
	virtual BOOL			FillItemSet( SfxItemSet& );
	virtual void			Reset( const SfxItemSet& );
};


#endif

