/*************************************************************************
 *
 *  $RCSfile: propbag.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_PROPBAG_HXX
#define _SFX_PROPBAG_HXX

#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

//ASDBG #include <usr/uno.hxx>
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUES_HPP_
#include <com/sun/star/beans/PropertyValues.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATE_HPP_
#include <com/sun/star/beans/PropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSETINFO_HPP_
#include <com/sun/star/beans/XPropertySetInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XMULTIPROPERTYSET_HPP_
#include <com/sun/star/beans/XMultiPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XFASTPROPERTYSET_HPP_
#include <com/sun/star/beans/XFastPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XVETOABLECHANGELISTENER_HPP_
#include <com/sun/star/beans/XVetoableChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATE_HPP_
#include <com/sun/star/beans/XPropertyState.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSTATECHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertyStateChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYATTRIBUTE_HPP_
#include <com/sun/star/beans/PropertyAttribute.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTIESCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertiesChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYCHANGELISTENER_HPP_
#include <com/sun/star/beans/XPropertyChangeListener.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYACCESS_HPP_
#include <com/sun/star/beans/XPropertyAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYCONTAINER_HPP_
#include <com/sun/star/beans/XPropertyContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYSTATECHANGEEVENT_HPP_
#include <com/sun/star/beans/PropertyStateChangeEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYCHANGEEVENT_HPP_
#include <com/sun/star/beans/PropertyChangeEvent.hpp>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif

SV_DECL_PTRARR_DEL( SfxPropertyArr_Impl, Property, 4, 4 );

class SfxPropertyBag: 	public ::cppu::OWeakObject,
						public ::com::sun::star::beans::XPropertySet,
						public ::com::sun::star::beans::XPropertyContainer,
						public ::com::sun::star::lang::XTypeProvider
{
//ASDBG	friend Reflection *		::getCppuType((const SfxPropertyBag*)0);

	SfxPropertyArr_Impl		_aArr;

public:

							SfxPropertyBag();
	virtual					~SfxPropertyBag();

	// ::com::sun::star::uno::XInterface
	SFX_DECL_XINTERFACE_XTYPEPROVIDER

	// ::com::sun::star::beans::XPropertySet
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertySetInfo > SAL_CALL  getPropertySetInfo(void) throw( ::com::sun::star::uno::RuntimeException ) = 0;
	virtual void  SAL_CALL 			setPropertyValue(
								const ::rtl::OUString& aPropertyName,
								const ::com::sun::star::uno::Any& aValue)  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual ::com::sun::star::uno::Any 	   SAL_CALL 		getPropertyValue(
								const ::rtl::OUString& aPropertyName)  throw( ::com::sun::star::uno::RuntimeException ) = 0;
	virtual void 	  SAL_CALL 		addPropertyChangeListener(
								const ::rtl::OUString& aPropertyName,
								const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & )  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		removePropertyChangeListener(
								const ::rtl::OUString& aPropertyName,
								const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XPropertyChangeListener > & )  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		addVetoableChangeListener(
								const ::rtl::OUString& aPropertyName,
								const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & )  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		removeVetoableChangeListener(
								const ::rtl::OUString& aPropertyName,
								const ::com::sun::star::uno::Reference< ::com::sun::star::beans::XVetoableChangeListener > & )  throw( ::com::sun::star::uno::RuntimeException )= 0;

	// ::com::sun::star::beans::XPropertyContainer
	virtual void 	  SAL_CALL 		addProperty( const ::rtl::OUString& Name,
								const ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass > & Type)  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		removeProperty( const ::rtl::OUString& Name,
								const ::com::sun::star::uno::Reference< ::com::sun::star::reflection::XIdlClass > & Type)  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		addPropertyContainerListener(
								const ::com::sun::star::uno::Reference< XPropertyContainerListener > & l)  throw( ::com::sun::star::uno::RuntimeException )= 0;
	virtual void 	  SAL_CALL 		removePropertyContainerListener(
								const ::com::sun::star::uno::Reference< XPropertyContainerListener > & l)  throw( ::com::sun::star::uno::RuntimeException )= 0;
};

#endif


#endif
