/*************************************************************************
 *
 *  $RCSfile: sfxdemo.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXDEMO_HXX
#define _SFXDEMO_HXX

// include ---------------------------------------------------------------

#ifndef _DATE_HXX //autogen
#include <tools/date.hxx>
#endif
#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

extern const char pSpoilString[];

struct DemoAppData_Impl
{
	Date    aInvalidateDay;
	String  aSystemName;
	UINT32  nLoadSum;
	UINT32  nCalcSum;
	USHORT  nDaysToRun;
	USHORT  nDemoKind;
	BOOL    bSaveSum;
};

typedef DemoAppData_Impl *DemoAppDataPtr_Impl;
SV_DECL_PTRARR_DEL(DemoAppDataArr_Impl, DemoAppDataPtr_Impl,5,5);

class DemoData_Impl
{
private:
	String				aPath;
	DemoAppDataArr_Impl	aDemoAppDataArr;

public:
	DemoData_Impl(BOOL bAuth, const String &rPath, const String* pApp = 0);

	BOOL 				Load(BOOL bCheckReg);
	BOOL				Save(BOOL bCreateSum);
	UINT32				CalcSum(const String &rStr) const;
	DemoAppData_Impl*	GetDemoData(const String& aSystemName);
};


#endif

