/*************************************************************************
 *
 *  $RCSfile: tbedctrl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFX_TBEDCTRL_HXX
#define _SFX_TBEDCTRL_HXX

// includes *****************************************************************


#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#include "tbxctrl.hxx"

class Accelerator;


class SfxFrameEdit_Impl : public Edit
{
	USHORT			nId;
	String			aContent;

	virtual void	KeyInput( const KeyEvent& rKeyEvent );
	virtual void	LoseFocus();

public:
					SfxFrameEdit_Impl( Window* pParent, USHORT nSlotId );
	void			SetContent( const String& rContent );
};

class SfxFrameEditToolBoxControl_Impl : public SfxToolBoxControl
{
private:
	SfxFrameEdit_Impl* GetEdit() const
					{ return (SfxFrameEdit_Impl*) GetToolBox().GetItemWindow(GetId()); }

public:

					SFX_DECL_TOOLBOX_CONTROL();

					SfxFrameEditToolBoxControl_Impl( USHORT nId,
													ToolBox& rBox,
													SfxBindings& rBindings );

	virtual Window* CreateItemWindow( Window* pParent );
	virtual void	StateChanged( USHORT nSID, SfxItemState eState,
								  const SfxPoolItem* pState );

};

class SfxFrameNumericField_Impl : public NumericField
{
	String			aCurTxt;

protected:
	virtual void 	Modify();
	void    		GetFocus_Impl();
	void    		LoseFocus_Impl();
	void			KeyInput_Impl( const KeyEvent& rKEvt );
	virtual long	Notify( NotifyEvent& rEvt );
	virtual void    Down();
	virtual void    Up();
	void			Execute();

public:
					SfxFrameNumericField_Impl( Window* pParent,
						WinBits nBits = WB_BORDER | WB_SPIN | WB_REPEAT );
					~SfxFrameNumericField_Impl();
};

class SfxFrameSpacingControl_Impl : public SfxToolBoxControl
{
public:
					SFX_DECL_TOOLBOX_CONTROL();
					SfxFrameSpacingControl_Impl( USHORT nId,
													ToolBox& rBox,
													SfxBindings& rBindings );
	virtual Window* CreateItemWindow( Window* pParent );
	virtual void	StateChanged( USHORT nSID, SfxItemState eState,
								  const SfxPoolItem* pState );
};


#endif
