/*************************************************************************
 *
 *  $RCSfile: tbxcust.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _TBXCUST_HXX
#define _TBXCUST_HXX

// #include *****************************************************************

#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#include "basedlgs.hxx"
#include "imgmgr.hxx"
#include "childwin.hxx"
#include "sfxresid.hxx"
#include "cfg.hxx"

class SfxMacroInfoArr_Impl;
class SfxToolBoxManager;

// **************************************************************************

class SfxCustomizeToolBox : public ToolBox
{
	BOOL			bHelpInitialized;

public:
	SfxCustomizeToolBox( Window* pParent, const ResId& );
	virtual void    Customize( const ToolBoxCustomizeEvent& rCEvt );
};

class SfxUserBitmapDialog_Impl;
class SfxTbxControlArr_Impl;

class SfxToolboxCustomizer : public SfxFloatingWindow
{
friend class SfxCustomizeToolBox;
friend class SfxUserBitmapDialog_Impl;

	SfxSymbolSet			eSymbolSet;
	SfxCustomizeToolBox 	aTbFunctionTb;
	FixedText				aTbRegionFt;
	SfxConfigGroupListBox_Impl	aTbRegionLb;
	SfxConfigFunctionListBox_Impl aTbFunctionLb;
	FixedText				aTbFunctionFt;
	PushButton				aTbSymbolBtn;
	PushButton				aTbDefaultBtn;
	HelpButton				aTbHelpBtn;
	GroupBox				aTbFunctionGb;
	GroupBox				aTbFunctionsGb;
	SfxUserBitmapDialog_Impl*	 pBmpDlg;
	SfxTbxControlArr_Impl*	pControls;

protected:
	virtual	BOOL		Close();

public:
						SfxToolboxCustomizer( SfxBindings*, SfxChildWindow*,
							Window *pParent, const ResId& rResId );
						~SfxToolboxCustomizer();
	void            	SelectHdl(ListBox *pBox);
	void            	Init();
	DECL_LINK( 			SelectGroup, Control* );
	DECL_LINK( 			SelectFunction, Control* );
	DECL_LINK( 			SelectButton, ToolBox * );
	void            	SetSymbolSet();
	DECL_LINK( 			UserdefSymbols, Button * );
	DECL_LINK( 			ButtonDefaultHdl, Button * );
	void				ClearToolbox();
	SfxUserBitmapDialog_Impl*
						ConnectUserBitmapDialog_Impl(USHORT nId, ToolBox& rTbx, SfxToolBoxManager* pMgr=0);
	virtual long		Notify( NotifyEvent& );
	virtual void    	FillInfo(SfxChildWinInfo&) const;
};


class SfxUserBitmapDialog_Impl : public ModalDialog
{
friend class SfxToolboxCustomizer;

	ToolBox         	aSymbolTb;
	FixedText       	aDescLabelFt;
	Edit       			aDescEdit;
	OKButton        	aOKButton;
	CancelButton    	aCancelButton;
	HelpButton      	aHelpBtn;
	GroupBox        	aFunctionGb;
	USHORT          	nFuncId;
	String				aDirName;
	List				aBmpList;
	ToolBox*			pToolBox;
	SfxToolBoxManager*	pMgr;

public:

						SfxUserBitmapDialog_Impl(Window *pParent,
										const String& rName,
										ToolBox &rTbx,
										USHORT nId, SfxToolBoxManager* pMgr=NULL );

						~SfxUserBitmapDialog_Impl();
	DECL_LINK( 			OKHdl, OKButton * );
	DECL_LINK( 			SelectHdl, ToolBox * );
	void				SetFunctionId(USHORT nId);
	void				SetToolBox(ToolBox& rTbx);
};

class SfxToolboxCustomWindow : public SfxChildWindow
{
public:
						SfxToolboxCustomWindow(Window *pParent, USHORT nId,
							SfxBindings *pBindings, SfxChildWinInfo *pInfo);
						SFX_DECL_CHILDWINDOW(SfxToolboxCustomWindow);
};

#endif // #ifndef _TBXCUST_HXX


