/*************************************************************************
 *
 *  $RCSfile: contenv.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_MENU_HXX
#include <vcl/menu.hxx>
#endif
#ifndef _PSEUDO_HXX //autogen
#include <so3/pseudo.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _IPMENU_HXX //autogen
#include <so3/ipmenu.hxx>
#endif
#ifndef _SFXRECTITEM_HXX //autogen
#include <svtools/rectitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif
#pragma hdrstop

#include "app.hxx"
#include "virtmenu.hxx"
#include "mnumgr.hxx"
#include "stbmgr.hxx"
#include "viewsh.hxx"
#include "dispatch.hxx"
#include "contenv.hxx"
#include "workwin.hxx"
#include "viewfrm.hxx"
#include "appdata.hxx"
#include "docfile.hxx"
#include "topfrm.hxx"

// SFX_INIMANAGER()
#include "inimgr.hxx"

//=========================================================================

MenuBar * SfxContainerEnv_Impl::QueryMenu
(
	USHORT * pCount0,
	USHORT * pCount1,
	USHORT * pCount2
)
{
	if( !pMenuBar )
	{
        SfxMenuBarManager *pMMgr = pFrame->GetViewShell()->GetMenuBar_Impl();
        SfxVirtualMenu *pAppMenu = pMMgr->GetMenu();
		MenuBar *pAppBar;

#ifdef OS2
		pAppBar = new MenuBar( *(MenuBar*) pAppMenu->GetSVMenu() );
#else
		pAppBar = (MenuBar*) pAppMenu->GetSVMenu();
#endif

		// Bereich 1: das Datei-Menue
		USHORT nStart0 = 0, nCount0 = 1;

		// Bereich 2: haben wir nicht
		USHORT nStart1 = 0, nCount1 = 0;

		// Bereich 3: das Fenstermenue
		USHORT nPos = pAppBar->GetItemPos( SID_MDIWINDOWLIST );

		// Die Menue-Konfiguration mu\s sicherstellen, da\s vor dem Dateimenue
		// nichts steht und da\s Datei - und Fenstermenue nicht wegkonfiguriert
		// werden k"onnen !
		// OLE im PlugIn geht davon aus, da\s vom Container genau zwei Menues,
		// Datei und Fenster, an der 1. und einer beliebigen anderen Position
		// im InPlaceMenu stammen.
		DBG_ASSERT( nPos != MENU_ITEM_NOTFOUND, "Wer hat das MDI-Menue geklaut ?!");
		USHORT nStart2 = nPos, nCount2 = 1;

		pAppMenu->InitPopup(0);
		pAppMenu->InitPopup(nStart2);

		pMenuBar = new SvInPlaceMenuBar( pAppBar, nStart0, nCount0, nStart1, nCount1, nStart2, nCount2 );
        pMenuBar->PushSelectHdl( LINK(pMMgr,SfxMenuManager,Select) );

		if ( !SFX_INIMANAGER()->IsDontHideDisabledEntries() )
			pMenuBar->SetMenuFlags( pMenuBar->GetMenuFlags() | MENU_FLAG_HIDEDISABLEDENTRIES );
	}
	return pMenuBar->GetBlocks( pCount0, pCount1, pCount2 );
}

//-------------------------------------------------------------------------
void SfxContainerEnv_Impl::SetInPlaceMenu( MenuBar * pMenu, BOOL bSet )
{
//  DV the rvp office now is started with -appserver -bean
//	if ( SFX_APP()->Get_Impl()->bBean )
//		return;

	SfxApplication *pSfxApp = SFX_APP();
	if( !bSet)
		// AppMenue wieder zur"ucksetzen
        pMenu = (MenuBar*) pFrame->GetViewShell()->GetMenuBar_Impl()->GetMenu()->GetSVMenu();

    SfxTopViewFrame *pTop= PTR_CAST( SfxTopViewFrame, pFrame->GetTopViewFrame() );
    if ( pTop )
        pTop->GetTopFrame_Impl()->SetMenuBar_Impl( pMenu );
}

//-------------------------------------------------------------------------

void SfxContainerEnv_Impl::MenuReleased()
{
	DELETEZ( pMenuBar );
}

//-------------------------------------------------------------------------

SfxContainerEnv_Impl::~SfxContainerEnv_Impl()
{
}

//-------------------------------------------------------------------------

SfxContainerEnv_Impl::SfxContainerEnv_Impl
(
	SfxInPlaceClient* 	pClient,
	SfxViewFrame*		pViewFrame,
	WorkWindow*			pTopWin,
	Window* 			pEditWin
)
:	SvContainerEnvironment( pClient, pTopWin,
//			(WorkWindow*) &( pViewFrame->GetParentViewFrame_Impl() ?
//			pViewFrame->GetParentViewFrame_Impl() :
//			pViewFrame->GetTopViewFrame() )->GetWindow(),
			(WorkWindow*) &pViewFrame->GetWindow(),
			pEditWin ? pEditWin : pViewFrame->GetViewShell()->GetWindow() ),
	pFrame( pViewFrame ),
	pMenuBar( 0 )
{
	if (!GetAccel())
	{
		const Accelerator* pAcc = &SFX_APP()->GetAccelerator_Impl();
		SetAccel(SFX_APP()->GetAccelerator_Impl());
	}
}

//-------------------------------------------------------------------------

BOOL SfxContainerEnv_Impl::SetStatusText( const String & rText )
{
	if( GetParent() )
		return SvContainerEnvironment::SetStatusText( rText );
	else
	{
		if ( rText.Len() )
			pFrame->ShowStatusText( rText );
		else
			pFrame->HideStatusText();
	}
	return TRUE;
}

//-------------------------------------------------------------------------
void SfxContainerEnv_Impl::ShowDocument
(
	const INetURLObject & rURL,
	const XubString & rFrame
)
{
	SfxStringItem aReferer( SID_REFERER, pFrame->GetObjectShell()->GetMedium()->GetName() );
	SfxStringItem aName( SID_FILE_NAME, rURL.GetMainURL() );
	SfxStringItem aTarget( SID_TARGETNAME, rFrame );
	SfxBoolItem aCreateView( SID_OPEN_NEW_VIEW, TRUE );
	SfxFrameItem aFrame( SID_DOCFRAME, pFrame );

    SFX_APP()->GetAppDispatcher_Impl()->Execute( SID_OPENDOC,
			SFX_CALLMODE_ASYNCHRON, &aFrame, &aReferer,
			&aName, &aCreateView, &aTarget, 0L );
}


//-------------------------------------------------------------------------

Accelerator * SfxContainerEnv_Impl::GetAccel()
{
	return SvContainerEnvironment::GetAccel();
}

//-------------------------------------------------------------------------

BOOL SfxContainerEnv_Impl::DispatchAccel( const KeyCode &rKeyCode )
{
	// zum Glueck wird das char (1. Parameter) nicht benoetigt
	return SFX_APP()->KeyInput( KeyEvent( 0, rKeyCode ) );
}

//-------------------------------------------------------------------------

void SfxContainerEnv_Impl::RequestObjAreaPixel( const Rectangle & rObjRect )
{
	SfxRectangleItem *pRet, aReq( SID_OBJECTRESIZE, rObjRect );

	// gewuenschte Groesse erfragen
	SfxDispatcher * pDispat = pFrame->GetDispatcher();
	const SfxPoolItem *pBaseRet = pDispat->Execute( SID_OBJECTRESIZE,
			SFX_CALLMODE_SYNCHRON, &aReq, 0L, 0L );
	pRet = PTR_CAST( SfxRectangleItem, pBaseRet );
	if( pRet )
		((SfxInPlaceClient *)GetIPClient())->RequestObjAreaPixel( pRet->GetValue() );
	else
		((SfxInPlaceClient *)GetIPClient())->RequestObjAreaPixel( rObjRect );
}

//-------------------------------------------------------------------------

void SfxContainerEnv_Impl::UIToolsShown( BOOL bShow )
{
	SfxWorkWindow *pWorkWin =
		SFX_APP()->GetWorkWindow_Impl( pFrame );
	if ( bShow )
	{
		// Gleich zeigt ein Objekt seine UITools an; jetzt mu\s ich meine
		// Tools wegnehmen
		BOOL bObjIsStarApp = GetIPClient()->Owner();
/*
		// Erkennung "uber Verben haut initial im Writer nicht hin
		const SvVerbList *pList = pFrame->GetViewShell()->GetVerbs();
		if ( pList )
		{
			for (USHORT n=0; n<pList->Count(); n++)
			{
				if ((*pList)[n].GetName() == STARAPP_VERB)
				{
					bObjIsStarApp = TRUE;
					break;
				}
			}
		}
*/
		pFrame->GetBindings().HidePopups(TRUE);

		// Bei StarApp als Server bleibt die Funktionsleiste des Clients
		// sichtbar
		// Wenn das OLE-Object in einem PlugIn aktiviert wird, mu\s das UI
		// des OLE-Clients = PluginServers deaktiviert und das des PlugIn-Clients
		// in den ToolSpace einbezogen werden
		USHORT nVis = SFX_VISIBILITY_CLIENT;
		if ( !bObjIsStarApp )
			nVis = SFX_VISIBILITY_UNVISIBLE;
		pWorkWin->SetObjectBarVisibility_Impl( nVis );
        pFrame->GetDispatcher()->Update_Impl( TRUE );
//		pWorkWin->UpdateObjectBars_Impl();
	}
	else
	{
		// Das Objekt hat seine UITools weggenommen, jetzt kommen meine wieder.
		// Dabei setzt die Applikation den App-Border, da es kein UI-aktives
		// Objekt im aktiven Dokument gibt.
		//	(->SfxAppWindow::ArrangeChilds_Impl())
        pWorkWin->SetObjectBarVisibility_Impl( SFX_VISIBILITY_STANDARD );

		// Wenn ich gerade am sterben bin und mein ViewFrame noch der aktive ist,
		// brauche ich kein Update zu machen, da das dann beim Austragen oder
		// Wechseln des ViewFrames ohnehin geschieht (weniger Zappeln)
		if ( !pFrame->GetFrame()->IsClosing_Impl() ||
			SFX_APP()->GetViewFrame() != pFrame )
				pFrame->GetDispatcher()->Update_Impl( TRUE );
//				pWorkWin->UpdateObjectBars_Impl();

		pFrame->GetBindings().HidePopups(FALSE);
	}
}

BOOL SfxContainerEnv_Impl::SetTopToolSpacePixel( const SvBorder & rInner )
{
	if( !GetIPClient() || GetIPClient()->Owner() )
	{
		if( RequestTopToolSpacePixel( rInner ) )
		{
            if ( pFrame->GetFrame()->OwnsBindings_Impl() )
			{
				SvBorder aBorder( GetTopBorder() );
				aBorder += rInner;
				pFrame->GetFrame()->SetToolSpaceBorderPixel_Impl( aBorder );
			}
			else
			{
				return FALSE;
			}

			return TRUE;

			// Sind Top- und EditWin unterschiedlich, dann muss das EditWin
			// neu angeordnet werden. Dies muss von dem abgeleiteten
			// Environment geleistet werden.
			// Sind sie gleich, kann die Anordnung automatisch geschehen
			return GetEditWin() == GetTopWin();
		}
		return FALSE;
	}
	else
	{
		return SvContainerEnvironment::SetTopToolSpacePixel( rInner );
	}

	return FALSE;
}


