/*************************************************************************
 *
 *  $RCSfile: pinfrm.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <so3/iface.hxx>

#define _SVSTDARR_ULONGS
#include <svtools/svstdarr.hxx>

#include "virtmenu.hxx"
#include "ctrlitem.hxx"
#include "slotserv.hxx"
#include "interno.hxx"
#include "pinfrm.hxx"
#include "pinenv.hxx"

#include "sfxtypes.hxx"
#include "minarray.hxx"
#include "objsh.hxx"
#include "objshimp.hxx"
#include "docfac.hxx"
#include "viewfac.hxx"
#include "viewsh.hxx"
#include "bindings.hxx"
#include "dispatch.hxx"
#include "request.hxx"
#include "sfxresid.hxx"
#include "docfile.hxx"
#include "mnumgr.hxx"
#include "stbmgr.hxx"
#include "taskbar.hxx"
#include "accmgr.hxx"
#include "sfx.hrc"
#include "view.hrc"

// STATIC DATA -----------------------------------------------------------

DECL_PTRARRAY( SfxPlugInFrameArray_Impl, SfxPlugInFrame *, 2, 1);

#define SfxPlugInFrame
#include "sfxslots.hxx"

DBG_NAME(SfxPlugInFrame);

class SfxPlugInFrame_Impl : public SfxFrame
{
friend class SfxPlugInFrame;

	Window*				pWindow;

public:
						SfxPlugInFrame_Impl( SfxPlugInFrame *p );
	virtual Window&		GetWindow() const;
	virtual BOOL		Close();
	virtual	BOOL		InsertDocument( SfxObjectShell *pDoc );
};

BOOL SfxPlugInFrame_Impl::Close()
{
	delete this;
	return TRUE;
}

Window& SfxPlugInFrame_Impl::GetWindow() const
{
	return *pWindow;
}

SfxPlugInFrame_Impl::SfxPlugInFrame_Impl( SfxPlugInFrame *p )
	: SfxFrame( NULL )
	, pWindow( NULL )
{
	SetCurrentViewFrame_Impl( p );
}

BOOL SfxPlugInFrame_Impl::InsertDocument( SfxObjectShell *pDoc )
{
	DBG_ERROR( "InsertDocument am PluginFrame!" );
	return FALSE;
}

class SfxPlugInFrameWindow_Impl : public Window
{
friend class SfxPlugInFrame;

	BOOL                    bIgnoreFocus;
	SfxPlugInFrame*			pFrame;
	BOOL                    bActive;

							SfxPlugInFrameWindow_Impl( SfxPlugInFrame *pF,
										Window *pParent )
								: Window( pParent, WB_CLIPCHILDREN | WB_BORDER )
								, pFrame( pF )
								, bIgnoreFocus( 0 )
								, bActive( 0 )
							{
								SetActivateMode( ACTIVATE_MODE_GRABFOCUS );
							}

							~SfxPlugInFrameWindow_Impl();
	virtual long			Notify( NotifyEvent& rEvt );
	virtual void			Resize();
};

//--------------------------------------------------------------------

void SfxPlugInFrameWindow_Impl::Resize()
{
}

long SfxPlugInFrameWindow_Impl::Notify( NotifyEvent& rNEvt )
{
	if ( rNEvt.GetType() == EVENT_KEYINPUT )
	{
		const KeyEvent aKeyEvent = *rNEvt.GetKeyEvent();
		SfxAcceleratorManager *pAccMgr = pFrame->GetEnv_Impl()->GetAccMgr();
		if ( pAccMgr )
			pAccMgr->Call( aKeyEvent );
		return 0L;
	}

	return Window::Notify( rNEvt );
}

SfxPlugInFrameWindow_Impl::~SfxPlugInFrameWindow_Impl()
{

}

void SfxPlugInFrame::Notify( SfxBroadcaster& rBC,  const SfxHint& rHint)
{
	if( rHint.ISA(SfxSimpleHint) )
	{
		ULONG nHint = ((SfxSimpleHint&)rHint).GetId();
		if ( nHint == SFX_HINT_TITLECHANGED )
		{
			// Name des SbxObjects
			UpdateTitle();
			GetBindings().Invalidate( SID_DOCTITLE );
		}
	}
	SfxViewFrame::Notify( rBC, rHint );
}

TYPEINIT1(SfxPlugInFrame,SfxViewFrame);

SFX_IMPL_INTERFACE(SfxPlugInFrame,SfxViewFrame,SfxResId(0))
{
//    SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION |
//            SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_PLUGSERVER, SfxResId(RID_PLUGINTOOLBOX) );
}

//--------------------------------------------------------------------

void SfxPlugInFrame::SetZoomFactor( const Fraction &rZoomX,
									 const Fraction &rZoomY )
{
	GetViewShell()->SetZoomFactor( rZoomX, rZoomY );
}


//--------------------------------------------------------------------

BOOL SfxPlugInFrame::Close()
{
	{DBG_CHKTHIS(SfxPlugInFrame, 0);}

	if ( !SfxViewFrame::Close() )
		return FALSE;

	// Da das Fenster selbst hier nicht geclosed wird, mu\s das Deactivate
	// selbst erzeugt werden
	SfxApplication *pSfxApp = SFX_APP();
	if (pSfxApp->GetViewFrame() == this)
		pSfxApp->SetViewFrame(0);

	DBG_MEMTEST();
	DoDeactivate( TRUE );
	DBG_MEMTEST();
	delete this;
	return TRUE;
}

//--------------------------------------------------------------------

void SfxPlugInFrame::Activate( BOOL bMDI )
{
	DBG_CHKTHIS(SfxPlugInFrame, 0);
	DBG_ASSERT(GetViewShell(), "Keine Shell");
	if( bMDI )
		pImp->bActive = TRUE;
}

//--------------------------------------------------------------------

void SfxPlugInFrame::Deactivate( BOOL bMDI )
{
	DBG_CHKTHIS(SfxPlugInFrame, 0);
	DBG_ASSERT(GetViewShell(), "Keine Shell");
	if( bMDI )
		pImp->bActive = FALSE;
}

// CTOR / DTOR -----------------------------------------------------------

SfxPlugInFrame::SfxPlugInFrame(
	SfxObjectShell &rObjShell, Window *pWindow,
	SfxFrame* pFrame, USHORT nViewId
	):
 // Falls mitgegeben sind wir in einer StarOffice App
	SfxViewFrame( (SfxObjectShell&) rObjShell, *(new SfxBindings),
					new SfxPlugInFrame_Impl( this ),
					SFXFRAME_PLUGIN | SFXFRAME_HASTITLE | SFXFRAME_SERVER )
{
	DBG_CTOR(SfxPlugInFrame, 0);

	SetName( DEFINE_CONST_UNICODE( "DesktopHack" ) );

	// Environment setzen
	pEnv = new SfxPlugInEnv_Impl( this, pWindow );

	// Frame-Window erzeugen mit WorkWindow als Parent
	pImp = new SfxPlugInFrameWindow_Impl( this, pWindow );
	pImp->bActive = FALSE;
	((SfxPlugInFrame_Impl*)GetFrame())->pWindow = pImp;

	// Initial f"ullt das ViewWindow das WorkWindow ganz aus
	pImp->SetSizePixel( pWindow->GetOutputSizePixel() );
	Show();

	SvFactory::IncAliveCount();
	//MI?? rObjShell.Lock( TRUE );

	// View laden bzw. erzeugen
	SwitchToViewShell_Impl( nViewId );
/*
	// Nur bei Extended-Plugins darf ein DocLoaded versendet werden
	SFX_APP()->SetViewFrame( this );
*/
}

//-------------------------------------------------------------------------

SfxPlugInFrame::~SfxPlugInFrame()
{
	DBG_DTOR(SfxPlugInFrame, 0);
	DBG_MEMTEST();

	SfxApplication *pApp = SFX_APP();
	if ( pApp->GetViewFrame() == this )
		pApp->SetViewFrame(NULL);

	SetDowning_Impl();

	// Dokument freigeben und entlocken
	if ( GetObjectShell() )
		ReleaseObjectShell_Impl();
	KillDispatcher_Impl();

	delete pEnv;
	delete pImp;
	delete &GetBindings();
	SvFactory::DecAliveCount();
}

//------------------------------------------------------------------------

void SfxPlugInFrame::InvalidateBorderImpl( const SfxViewShell* pViewSh )
{
	if ( pViewSh && pImp->IsVisible() )
		DoAdjustPosSizePixel( (SfxViewShell*)pViewSh, Point(), pImp->GetOutputSizePixel() );
}

//------------------------------------------------------------------------

BOOL SfxPlugInFrame::SetBorderPixelImpl( const SfxViewShell *pSh, const SvBorder &rBorder )
{
	if( SfxViewFrame::SetBorderPixelImpl( pSh, rBorder ) )
	{
		Point aDefPoint;
		Rectangle aEditArea( aDefPoint, pImp->GetOutputSizePixel() );
		aEditArea.Left() += rBorder.Left();
		aEditArea.Right() -= rBorder.Right();
		aEditArea.Top() += rBorder.Top();
		aEditArea.Bottom() -= rBorder.Bottom();
		pSh->GetWindow()->SetPosSizePixel( aEditArea.TopLeft(), aEditArea.GetSize() );
		return TRUE;
	}
	return FALSE;
}

//------------------------------------------------------------------------

void SfxPlugInFrame::MakeActive_Impl()
{
	if ( !pImp->bActive && GetViewShell() )
	{
		SfxApplication *pSfxApp = SFX_APP();
		DoActivate( FALSE );
	}
}


