/*************************************************************************
 *
 *  $RCSfile: sample.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
//#include "so2.hxx"

#pragma hdrstop

#include <svtool.hxx>

#include <rtti.hxx>
#include <sfx.hrc>
#include <somon.hxx>

#include <sfxiiter.hxx>
#include <sfxdoc.hxx>
#include <sfxdlg.hxx>

#include <sfx.hxx>
#include <sfxbasic.hxx>

#define SFX_TYPEMAP
#include "sample.hxx"
#include "sample.hrc"

#include "testdoc.hxx"
#include "testview.hxx"

//==================================================================

Example aExample;

// -----------------------------------------------------------------------

class ColorWindow : public SfxPopupWindow
{
private:
	ValueSet        aSet;

public:
					ColorWindow( USHORT nId, SfxBindings &rBindings);
					~ColorWindow();

	void            StartSelection() { aSet.StartSelection(); }

	DECL_LINK( SelectHdl, ValueSet * );
	virtual void    Resize();
};

// -----------------------------------------------------------------------

ColorWindow::~ColorWindow()
{
}

ColorWindow::ColorWindow( USHORT nId, SfxBindings &rBindings ):
	SfxPopupWindow( nId, WB_SVLOOK | WB_BORDER | WB_CLOSEABLE | WB_MOVEABLE | WB_ZOOMABLE, rBindings ),
	aSet( this, WB_SVLOOK | WB_ITEMBORDER | WB_NAMEFIELD | WB_NONEFIELD )
{
	aSet.SetText( "None" );
	aSet.InsertItem(  1, Color( COL_BLACK ),         "Black" );
	aSet.InsertItem(  2, Color( COL_BLUE ),          "Blue" );
	aSet.InsertItem(  3, Color( COL_GREEN ),         "Green" );
	aSet.InsertItem(  4, Color( COL_CYAN ),          "Cyan" );
	aSet.InsertItem(  5, Color( COL_RED ),           "Red" );
	aSet.InsertItem(  6, Color( COL_MAGENTA ),       "Magenta" );
	aSet.InsertItem(  7, Color( COL_BROWN ),         "Brown" );
	aSet.InsertItem(  8, Color( COL_GRAY ),          "Gray" );
	aSet.InsertItem(  9, Color( COL_LIGHTGRAY ),     "LightGray" );
	aSet.InsertItem( 10, Color( COL_LIGHTBLUE ),     "LightBlue" );
	aSet.InsertItem( 11, Color( COL_LIGHTGREEN ),    "LightGreen" );
	aSet.InsertItem( 12, Color( COL_LIGHTCYAN ),     "LightCyan" );
	aSet.InsertItem( 13, Color( COL_LIGHTRED ),      "LightRed" );
	aSet.InsertItem( 14, Color( COL_LIGHTMAGENTA ),  "LightMagenta" );
	aSet.InsertItem( 15, Color( COL_YELLOW ),        "Yellow" );
	aSet.InsertItem( 16, Color( COL_WHITE ),         "White" );
	for ( USHORT i = 16; i < 64; i++ )
	{
		String aName( "Farbe " );
		aName += i+1;
		aSet.InsertItem( i+1, Color( ((long)rand()*2) % 65635,
									 ((long)rand()*2) % 65635,
									 ((long)rand()*2) % 65635 ), aName );
	}
	aSet.SetColCount( 8 );
	aSet.SetSelectHdl( LINK( this, ColorWindow, SelectHdl ) );

	Size aSize = aSet.CalcWindowSizePixel( Size( 12, 12 ) );
	aSize.Width()  += 4;
	aSize.Height() += 4;
	SetOutputSizePixel( aSize );
	aSet.Show();
	SetText( "Hintergrund" );
}

// -----------------------------------------------------------------------

IMPL_LINK( ColorWindow, SelectHdl, ValueSet *, pValueSet )
{
	SfxViewShell *pVSh = SfxViewShell::Current();
	if ( pVSh )
	{
		pVSh->GetWindow()->SetBackgroundBrush(
						Brush( aSet.GetItemColor( aSet.GetSelectItemId() ) ) );
		pVSh->GetWindow()->Invalidate();
	}
	return 0;
}

// -----------------------------------------------------------------------

void __EXPORT ColorWindow::Resize()
{
	Size aSize = GetOutputSizePixel();
	aSize.Width()  -= 4;
	aSize.Height() -= 4;
	aSet.SetPosSizePixel( Point( 2, 2 ), aSize );
}


// -----------------------------------------------------------------------
// --- class ChooseTable -------------------------------------------

class ChooseTable : public SfxPopupWindow
{
private:
	USHORT			nCol;
	USHORT			nLine;
	USHORT			nWidth;
	USHORT			nHeight;
	USHORT			nMX;
	USHORT			nMY;
	USHORT			nTextHeight;
	Pen 			aNullPen;
	Pen 			aPen;
	Pen 			aHighPen;
	Brush			aBrush;
	Brush			aHighBrush;

public:
					ChooseTable( USHORT nId, SfxBindings &rBindings );
					~ChooseTable();

	virtual void    MouseButtonUp( const MouseEvent& rMEvt );
	virtual void    MouseMove( const MouseEvent& rMEvt );
	virtual void    Paint( const Rectangle& );

	USHORT			GetColCount() const { return nCol; }
	USHORT			GetLineCount() const { return nLine; }
};

// --- ChooseTable::ChooseTable() ----------------------------------

ChooseTable::~ChooseTable()
{
}

ChooseTable::ChooseTable( USHORT nId, SfxBindings &rBindings ) :
	SfxPopupWindow( nId, WinBits(WB_STDFLOATWIN), rBindings ),
	aNullPen( PEN_NULL ),
	aPen( Color( (ColorName)COL_WINDOWTEXT ) ),
	aHighPen( Color( (ColorName)COL_HIGHLIGHTTEXT ) ),
	aBrush( Color( (ColorName)COL_WINDOWWORKSPACE ) ),
	aHighBrush( Color( (ColorName)COL_HIGHLIGHT ) )
{
	nCol    = 0;
	nLine   = 0;
	nWidth  = 5;
	nHeight = 5;
	nTextHeight = GetTextSize( String() ).Height()+1;

	SetBackgroundBrush( Brush( BRUSH_NULL ) );
	Size aLogicSize = LogicToPixel( Size( 55, 35 ), MapMode( MAP_10TH_MM ) );
	nMX = aLogicSize.Width();
	nMY = aLogicSize.Height();
	SetOutputSizePixel( Size( nMX*nWidth-1, nMY*nHeight-1+nTextHeight ) );
}

// --- ChooseTable::MouseButtonUp() --------------------------------

void __EXPORT ChooseTable::MouseButtonUp( const MouseEvent &rEvt )
{
	Hide();
	SfxPopupWindow::MouseButtonUp( rEvt );
}

// --- ChooseTable::MouseMove() ------------------------------------

void __EXPORT ChooseTable::MouseMove( const MouseEvent& rMEvt )
{
	Point   aPos = rMEvt.GetPosPixel();
	Size    aWinSize = GetOutputSizePixel();
	USHORT  nNewCol = 0;
	USHORT  nNewLine = 0;
	USHORT  nMinCol = 0;
	USHORT  nMinLine = 0;
	USHORT  nMaxCol = 0;
	USHORT  nMaxLine = 0;

	if ( aPos.X() > 0 )
		nNewCol = aPos.X() / nMX + 1;
	if ( aPos.Y() > 0 )
		nNewLine = aPos.Y() / nMY + 1;

	if ( (nWidth < nNewCol) || (nHeight < nNewLine) )
	{
		Point   aWinPos = GetPosPixel();
		Size    aSystemSize = System::GetScreenSizePixel();

		if ( nWidth <= nNewCol )
			nWidth = nNewCol;
		if ( nHeight <= nNewLine )
			nHeight = nNewLine;
		while ( (short)(aWinPos.X()+(nMX*nWidth-1)) >= aSystemSize.Width()-3 )
			nWidth--;
		while ( (short)(aWinPos.Y()+(nMY*nHeight-1+nTextHeight)) >=
				aSystemSize.Height()-3 )
			nHeight--;
		if ( nNewCol > nWidth )
			nNewCol = nWidth;
		if ( nNewLine > nHeight )
			nNewLine = nHeight;

		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
							   aWinSize.Width(), aWinSize.Height() ) );
		SetOutputSizePixel( Size( nMX*nWidth-1, nMY*nHeight-1+nTextHeight ) );
	}

	if ( nNewCol < nCol )
	{
		nMinCol = nNewCol;
		nMaxCol = nCol;
	}
	else
	{
		nMinCol = nCol;
		nMaxCol = nNewCol;
	}
	if ( nNewLine < nLine )
	{
		nMinLine = nNewLine;
		nMaxLine = nLine;
	}
	else
	{
		nMinLine = nLine;
		nMaxLine = nNewLine;
	}

	if ( (nNewCol != nCol) || (nNewLine != nLine) )
	{
		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
							   aWinSize.Width(), aWinSize.Height() ) );

		if ( nNewCol != nCol )
		{
			Invalidate( Rectangle( nMinCol*nMX-1, 0, nMaxCol*nMX+1, nMaxLine*nMY ) );
			nCol  = nNewCol;
		}
		if ( nNewLine != nLine )
		{
			Invalidate( Rectangle( 0, nMinLine*nMY-2, nMaxCol*nMX, nMaxLine*nMY+1 ) );
			nLine = nNewLine;
		}
	}

	Update();
	SfxPopupWindow::MouseMove( rMEvt );
}

// --- ChooseTable::Paint() ----------------------------------------

void __EXPORT ChooseTable::Paint( const Rectangle& )
{
	USHORT  i;
	USHORT  nStart;
	Size    aSize = GetOutputSizePixel();

	SetPen( aNullPen );
	SetFillInBrush( aHighBrush );
	DrawRect( Rectangle( 0, 0, nCol*nMX-1, nLine*nMY-1 ) );
	SetFillInBrush( aBrush );
	DrawRect( Rectangle( nCol*nMX-1, 0,
						 aSize.Width(), aSize.Height()-nTextHeight+1 ) );
	DrawRect( Rectangle( 0, nLine*nMY-1,
						 aSize.Width(), aSize.Height()-nTextHeight+1 ) );

	SetPen( aHighPen );
	for ( i = 1; i < nCol; i++ )
		DrawLine( Point( i*nMX-1, 0 ), Point( i*nMX-1, nLine*nMY-1 ) );
	for ( i = 1; i < nLine; i++ )
		DrawLine( Point( 0, i*nMY-1 ), Point( nCol*nMX-1, i*nMY-1 ) );
	SetPen( aPen );
	for ( i = 1; i <= nWidth; i++ )
	{
		if ( i < nCol )
			nStart = nLine*nMY-1;
		else
			nStart = 0;
		DrawLine( Point( i*nMX-1, nStart ), Point( i*nMX-1, nHeight*nMY-1 ) );
	}
	for ( i = 1; i <= nHeight; i++ )
	{
		if ( i < nLine )
			nStart = nCol*nMX-1;
		else
			nStart = 0;
		DrawLine( Point( nStart, i*nMY-1 ), Point( nWidth*nMX-1, i*nMY-1 ) );
	}

	SetPen( aNullPen );
	String aText;
	if ( nCol && nLine )
	{
		aText += nCol;
		aText += " x ";
		aText += nLine;
	}
	else
		aText = pApp->GetAppInternational().GetButtonText(BUTTONTEXT_CANCEL);
	Size aTextSize = GetTextSize( aText );
	DrawText( Point( (aSize.Width()-aTextSize.Width()) / 2,
					 aSize.Height()-nTextHeight+2 ),
			  aText );
	DrawRect( Rectangle( 0, aSize.Height()-nTextHeight+2,
						 (aSize.Width()-aTextSize.Width())/2-1, aSize.Height() ) );
	DrawRect( Rectangle( (aSize.Width()-aTextSize.Width())/2+aTextSize.Width(),
						 aSize.Height()-nTextHeight+2,
						 aSize.Width(), aSize.Height() ) );
}

// --- class ChooseColumn ------------------------------------------

class ChooseColumn : public WorkWindow
{
private:
	USHORT      nCol;
	USHORT      nWidth;
	USHORT      nMX;
	USHORT      nTextHeight;
	Pen         aNullPen;
	Pen         aPen;
	Pen         aHighPen;
	Brush       aBrush;
	Brush       aHighBrush;

public:
					ChooseColumn();

	virtual void    MouseButtonUp( const MouseEvent& rMEvt );
	virtual void    MouseMove( const MouseEvent& rMEvt );
	virtual void    Paint( const Rectangle& );

	USHORT      GetColCount() const { return nCol; }
};

// --- ChooseColumn::ChooseColumn() --------------------------------

ChooseColumn::ChooseColumn() :
				WorkWindow( pApp->GetAppWindow(), WB_BORDER ),
				aNullPen( PEN_NULL ),
				aPen( Color( (ColorName)COL_WINDOWTEXT ) ),
				aHighPen( Color( (ColorName)COL_HIGHLIGHTTEXT ) ),
				aBrush( Color( (ColorName)COL_WINDOWWORKSPACE ) ),
				aHighBrush( Color( (ColorName)COL_HIGHLIGHT ) )
{
	nCol        = 0;
	nWidth  = 4;
	nTextHeight = GetTextSize( String() ).Height()+1;

	SetBackgroundBrush( Brush( BRUSH_NULL ) );
	Size aLogicSize = LogicToPixel( Size( 95, 155 ), MapMode( MAP_10TH_MM ) );
	nMX = aLogicSize.Width();
	SetOutputSizePixel( Size( nMX*nWidth-1, aLogicSize.Height()+nTextHeight ) );
}

// --- ChooseColumn::MouseButtonUp() -------------------------------

void __EXPORT ChooseColumn::MouseButtonUp( const MouseEvent& )
{
	Hide();
}

// --- ChooseColumn::MouseMove() -----------------------------------

void __EXPORT ChooseColumn::MouseMove( const MouseEvent& rMEvt )
{
	Point   aPos = rMEvt.GetPosPixel();
	Size    aWinSize = GetOutputSizePixel();
	USHORT  nNewCol = 0;
	USHORT  nMinCol = 0;
	USHORT  nMaxCol = 0;

	if ( aPos.X() > 0 )
		nNewCol = aPos.X() / nMX + 1;

	if ( nWidth < nNewCol )
	{
		Point   aWinPos = GetPosPixel();
		Size    aSystemSize = System::GetScreenSizePixel();

		if ( nWidth <= nNewCol )
			nWidth = nNewCol;
		while ( (short)(aWinPos.X()+(nMX*nWidth-1)) >= aSystemSize.Width()-3 )
			nWidth--;
		if ( nNewCol > nWidth )
			nNewCol = nWidth;

		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
							   aWinSize.Width(), aWinSize.Height() ) );
		SetOutputSizePixel( Size( nMX*nWidth-1, aWinSize.Height() ) );
	}

	if ( aPos.Y() < 0 )
		nNewCol = 0;

	if ( nNewCol != nCol )
	{
		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
							   aWinSize.Width(), aWinSize.Height() ) );

		if ( nNewCol < nCol )
		{
			nMinCol = nNewCol;
			nMaxCol = nCol;
		}
		else
		{
			nMinCol = nCol;
			nMaxCol = nNewCol;
		}

		Invalidate( Rectangle( nMinCol*nMX-1, 0,
							   nMaxCol*nMX+1, aWinSize.Height()-nTextHeight+2 ) );
		nCol  = nNewCol;
	}

	Update();
}

// --- ChooseColumn::Paint() ---------------------------------------

void __EXPORT ChooseColumn::Paint( const Rectangle& )
{
	USHORT  i;
	USHORT  j;
	USHORT  nLineWidth;
	Size    aSize = GetOutputSizePixel();

	for ( i = 0; i < nWidth; i++ )
	{
		if ( i < nCol )
		{
			SetPen( aHighPen );
			SetFillInBrush( aHighBrush );
		}
		else
		{
			SetPen( aPen );
			SetFillInBrush( aBrush );
		}

		DrawRect( Rectangle( i*nMX-1, -1,
							 i*nMX+nMX, aSize.Height()-nTextHeight+1 ) );

		j = 4;
		while ( j < aSize.Height()-nTextHeight-4 )
		{
			if ( !(j % 16) )
				nLineWidth = 10;
			else
				nLineWidth = 4;
			DrawLine( Point( i*nMX+4, j ), Point( i*nMX+nMX-nLineWidth-4, j ) );
			j += 4;
		}
	}

	SetPen( aNullPen );
	SetFillInBrush( aBrush );
	String aText;
	if ( nCol )
		aText = String( nCol );
	else
		aText = pApp->GetAppInternational().GetButtonText(BUTTONTEXT_CANCEL);
	Size aTextSize = GetTextSize( aText );
	DrawText( Point( (aSize.Width()-aTextSize.Width()) / 2,
					 aSize.Height()-nTextHeight+2 ),
			  aText );
	DrawRect( Rectangle( 0, aSize.Height()-nTextHeight+2,
						 (aSize.Width()-aTextSize.Width())/2-1, aSize.Height() ) );
	DrawRect( Rectangle( (aSize.Width()-aTextSize.Width())/2+aTextSize.Width(),
						 aSize.Height()-nTextHeight+2,
						 aSize.Width(), aSize.Height() ) );
}

//==================================================================

class TestToolBoxControl: public SfxToolBoxControl
{
public:
	virtual void			StateChanged( USHORT, SfxItemState, const SfxPoolItem* );
	virtual SfxPopupWindowType GetPopupWindowType() const;
	virtual SfxPopupWindow* CreatePopupWindow();
	virtual Window* 		CreateItemWindow( Window *pParent );

public:
							SFX_DECL_TOOLBOX_CONTROL();

							TestToolBoxControl( USHORT nId, ToolBox &rTbx, SfxBindings & );
							~TestToolBoxControl();
};

TestToolBoxControl::TestToolBoxControl( USHORT nId, ToolBox &rTbx, SfxBindings &rBindings ):
	SfxToolBoxControl( nId, rTbx, rBindings )
{
}

TestToolBoxControl::~TestToolBoxControl()
{
}

SFX_IMPL_TOOLBOX_CONTROL(TestToolBoxControl,SfxEnumItem);

void __EXPORT TestToolBoxControl::StateChanged( USHORT nSID,
			SfxItemState eState, const SfxPoolItem* pState )
{
	SfxToolBoxControl::StateChanged( nSID, eState, pState );
}

SfxPopupWindowType __EXPORT TestToolBoxControl::GetPopupWindowType() const
{
	switch ( GetId() )
	{
		case SID_TEST_TABLE:
			return SFX_POPUPWINDOW_ONTIMEOUT;

		case SID_TEST_COLOR:
			return SFX_POPUPWINDOW_ONCLICK;
	}

	return SFX_POPUPWINDOW_NONE;
}

SfxPopupWindow* __EXPORT TestToolBoxControl::CreatePopupWindow()
{
	if ( GetId() == SID_TEST_TABLE )
	{
		ChooseTable *pWin = new ChooseTable(GetId(), GetBindings());
		pWin->StartPopupMode(&GetToolBox(), TRUE);
		//! pWin->StartSelection();
		return pWin;
	}
	else if ( GetId() == SID_TEST_COLOR )
	{
		ColorWindow *pWin = new ColorWindow(GetId(), GetBindings());
		pWin->StartPopupMode(&GetToolBox(), TRUE);
		pWin->StartSelection();
		return pWin;
	}
	return 0;
}

Window* __EXPORT TestToolBoxControl::CreateItemWindow( Window *pParent )
{
	if ( GetId() == SID_ALIGNMENT )
	{
		ListBox *pWin = new ListBox( pParent, WinBits(WB_BORDER|WB_DROPDOWN) );
		pWin->SetSizePixel( Size( 90, 100 ) );
		pWin->InsertEntry( "eins" );
		pWin->InsertEntry( "zewi" );
		pWin->InsertEntry( "drei" );
		pWin->InsertEntry( "vier" );
		pWin->InsertEntry( "fnf" );
		pWin->InsertEntry( "sechs" );
		pWin->InsertEntry( "sieben" );
		pWin->Show();
		return pWin;
	}
	return 0;
}

//==================================================================

SFX_EXEC_STUB(Example, Execute)
SFX_STATE_STUB(Example, GetState)

#define ShellClass Example
SFX_SLOTMAP(Example)
{
	SFX_SLOT( Example, SID_NEWDOCDIRECT, GID_DOC,
			 SFX_STUB_PTR(Example, Execute),
			 SFX_STUB_PTR(Example, GetState),
			 0, SfxVoidItem )
};

SFX_IMPL_CHILDWINDOW(TestObjectBar, RID_INPUTTOOLBOX)

SFX_IMPL_INTERFACE(Example,SfxApplication,RID_APPTITLE)
{
	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION |
		SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT, RID_DEFAULTTOOLBOX );
}

//==================================================================

Example::Example():
	SfxApplication( 0 ),
	pInputBar( 0 )
{
}


void __EXPORT Example::Main( int nArgc, char* pArgv[] )
{
	SetAppName( "sfd" );

	// Ressource-Manager erzeugen
	ResMgr* pResMgr = CreateResManager("sfd");
	Resource::SetResManager(pResMgr);

	SfxApplication::Main(nArgc, pArgv);

	Resource::SetResManager(NULL);
	delete pResMgr;
}

//------------------------------------------------------------------

Example::~Example()
{
}

//------------------------------------------------------------------

void Example::Execute( SfxRequest& rReq )
{
	switch ( rReq.GetSlot() )
	{
		case SID_NEWDOCDIRECT:
			// forwarding testen
			ExecuteSlot( rReq, SfxApplication::GetInterface() );
			break;
	}
}

void Example::GetState(SfxItemSet &rSet)
{
	SfxWhichIter aIter(rSet);
	USHORT nWhich = aIter.FirstWhich();
	while ( nWhich )
	{
		switch ( nWhich )
		{
			case SID_NEWDOCDIRECT:
				// forwarding of state ist schwieriger
				break;
		}
		nWhich = aIter.NextWhich();
	}
}

//------------------------------------------------------------------

SfxNewFileDialog* __EXPORT Example::CreateNewDialog()
{
	return new SfxNewFileDialog(GetAppWindow(), SFXWB_PREVIEW|SFXWB_DOCINFO);
}

//------------------------------------------------------------------

StatusBar* __EXPORT Example::CreateStatusBar()
{
	// This virtual function becomes called from the SFx to create the
	// main status bar.

	StatusBar* pStatusBar = new StatusBar(GetAppWindow(), WinBits(WB_BORDER|WB_SVLOOK) );
	pStatusBar->InsertItem( SID_CONTEXT, pStatusBar->GetTextSize(
		String().Fill( 64, 'x' ) ).Width() );
	pStatusBar->InsertItem( SID_MOUSEPOS, pStatusBar->GetTextSize(
		String("9999:9999") ).Width() );
	pStatusBar->InsertItem( SID_CURRENTTIME, pStatusBar->GetTextSize(
		String("::") + pApp->GetAppInternational().GetTime( Time() ) ).Width() );
	pStatusBar->InsertItem( SID_CURRENTDATE, pStatusBar->GetTextSize(
		String("::") + pApp->GetAppInternational().GetDate( Date() ) ).Width() );
	return pStatusBar;
}

//------------------------------------------------------------------

SfxFileDialog* __EXPORT Example::CreateDocFileDialog
(
	ULONG					nBits,
	const SfxObjectFactory& rFact
)
{
/*
	SfxItemSet aSet(GetPool(), SID_BTN_MANAGER, SID_NOTEMPLATES);
	aSet.Put(SfxBoolItem(SID_BTN_MANAGER, TRUE));
	aSet.Put(SfxBoolItem(SID_BTN_HOME, TRUE));
	if(nBits & WB_SAVEAS)
		aSet.Put(SfxBoolItem(SID_BTN_PASSWORD, TRUE));
	else
		aSet.Put(SfxBoolItem(SID_BTN_READONLY, TRUE));
	return new SfxFileDialog(GetAppWindow(), nBits, aSet);
*/
	return SfxApplication::CreateDocFileDialog( nBits, rFact );
}

//------------------------------------------------------------------

void __EXPORT Example::Init( int nArgs, char* pArgs[] )
{
	// This virtual function will be called from the SFx to initialize the
	// application. It is called from Application::Main(), though you can
	// create StarView objects. The Application Window does exist, but
	// isn't visible. No controller does exist and the configuration isn't
	// loaded.

	Example::RegisterInterface();

	TestDoc::RegisterFactory(1);
	TestDoc::RegisterInterface();

	DefaultView::RegisterFactory(1);
	DefaultView::RegisterInterface();

	SpecialView::RegisterFactory(2);
	SpecialView::RegisterInterface();

	RectShell::RegisterInterface();
	CircShell::RegisterInterface();

	Editor::RegisterFactory(2);
	EditorView::RegisterFactory(1);

	TestToolBoxControl::RegisterControl();
	TestObjectBar::RegisterChildWindow(TRUE);

	// activate the applications funcions
	IntroSlide();
	pInputBar = new TestController(GetAppBindings());
}

//------------------------------------------------------------------

void __EXPORT Example::Exit()
{
	// This virtual function becomes called from the SFx to deinitialize
	// the appication. It is called from Application::Main() after
	// Application::Execute(). The Application Window does exist, but
	// isn't visible. All Controllers, Documents and Views are destroyed
	// and the configuration is already stored.

	delete pInputBar;
}

//==================================================================

void __EXPORT TestController::StateChanged( USHORT nSID,
			SfxItemState eState, const SfxPoolItem* pState )
{
	// Sound::Beep();
}

TestController::TestController(SfxBindings &rBindings):
	SfxControllerItem(SID_CONTENT, rBindings)
{
}

TestController::~TestController()
{
}

TestObjectBar::TestObjectBar (Window *pParent, USHORT nId,
							  SfxBindings *pBindings, SfxChildWinInfo* pInfo) :
	SfxChildWindow(pParent, nId)
{


	WinBits nBits =   WB_BORDER | WB_SVLOOK
					| WB_CLIPCHILDREN | WB_DOCKABLE
					| WB_MOVEABLE | WB_CLOSEABLE
					| WB_SIZEABLE | WB_ENABLERESIZING;

//	pWindow = new InputBox( pBindings, this, pParent, ResId(RID_INPUTTOOLBOX) );
	pWindow = new InputBox( pBindings, this, pParent, nBits );
	eChildAlignment = SFX_ALIGN_LOWESTTOP;
	((SfxDockingWindow*)pWindow)->Initialize( pInfo );
};

InputBox::InputBox(SfxBindings *pBindings, SfxChildWindow *pCW,
				   Window *pParent, const ResId& rResId) :
	SfxDockingWindow (pBindings, pCW, pParent, rResId),
	aTextWindow ( this, ResId(RID_MULTIEDIT) )
{
}

InputBox::InputBox(SfxBindings *pBindings, SfxChildWindow *pCW,
				   Window *pParent, WinBits nWinBits) :
	SfxDockingWindow (pBindings, pCW, pParent, nWinBits),
	aTextWindow ( this, ResId(RID_MULTIEDIT) )
{
	SetFloatingMode(FALSE);
	Size aSize(pParent->GetOutputSizePixel());
	SetFloatingSize( Size(aSize.Width()/2, aSize.Height()/2));
}

SfxChildWinInfo __EXPORT TestObjectBar::GetInfo() const
{
	SfxChildWinInfo aInfo = SfxChildWindow::GetInfo();
	((SfxDockingWindow*)pWindow)->FillInfo(aInfo);
	return aInfo;
}

InputBox::~InputBox()
{
}

void __EXPORT InputBox::Resize()
{
	Size aSize;
	aSize.Width()  =
		GetOutputSizePixel().Width()  - 2 * aTextWindow.GetPosPixel().X();
	aSize.Height() =
		GetOutputSizePixel().Height() - 2 * aTextWindow.GetPosPixel().Y();
	aTextWindow.SetSizePixel(aSize);
	SfxDockingWindow::Resize();
}

Size __EXPORT InputBox::CalcDockingSize(SfxChildAlignment eAlign)
{
	Size aSize = SfxDockingWindow::CalcDockingSize(eAlign);
	switch (eAlign)
	{
		case SFX_ALIGN_TOP:
		case SFX_ALIGN_BOTTOM:
		case SFX_ALIGN_LOWESTTOP:
		case SFX_ALIGN_HIGHESTTOP:
		case SFX_ALIGN_LOWESTBOTTOM:
		case SFX_ALIGN_HIGHESTBOTTOM:

		{
			Edit aEdit(this);
			aSize.Height() = aEdit.GetSizePixel().Height() +
								2 * aTextWindow.GetPosPixel().Y();
			break;
		}

		case SFX_ALIGN_LEFT:
		case SFX_ALIGN_RIGHT:
		case SFX_ALIGN_FIRSTLEFT:
		case SFX_ALIGN_LASTLEFT:
		case SFX_ALIGN_FIRSTRIGHT:
		case SFX_ALIGN_LASTRIGHT:
		{
			aSize = Size();
			break;
		}

		default:
			break;
	}

	return aSize;
}

SfxChildAlignment __EXPORT InputBox::CheckAlignment(SfxChildAlignment eActAlign,SfxChildAlignment eAlign)
{
	switch (eAlign)
	{
		case SFX_ALIGN_TOP:
		case SFX_ALIGN_HIGHESTTOP:
		case SFX_ALIGN_LOWESTTOP:
			return SFX_ALIGN_LOWESTTOP;
			break;
		case SFX_ALIGN_BOTTOM:
		case SFX_ALIGN_LOWESTBOTTOM:
		case SFX_ALIGN_HIGHESTBOTTOM:
			return eAlign;
			break;

		case SFX_ALIGN_LEFT:
		case SFX_ALIGN_RIGHT:
		case SFX_ALIGN_FIRSTLEFT:
		case SFX_ALIGN_LASTLEFT:
		case SFX_ALIGN_FIRSTRIGHT:
		case SFX_ALIGN_LASTRIGHT:
			return eActAlign;
			break;

		default:
			return eAlign;
			break;
	}
}

void __EXPORT InputBox::Resizing( Size& rSize )
{
	long nHeight = GetOutputSizePixel().Height();
	SfxDockingWindow::Resizing( rSize );
	if ( rSize.Width() < 100 )
		rSize.Width() = 100;
	rSize.Height() = nHeight;
}




