/*************************************************************************
 *
 *  $RCSfile: sample.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SAMPLE_HXX
#define _SAMPLE_HXX

#include <sfx.hxx>
#include "sample.hrc"

#define SAMPLE_INTERFACE_APP			(SFX_INTERFACE_APP+0)
#define SAMPLE_INTERFACE_DEFAULT_VIEW 	(SFX_INTERFACE_APP+1)
#define SAMPLE_INTERFACE_SPECIAL_VIEW 	(SFX_INTERFACE_APP+2)
#define SAMPLE_INTERFACE_DOC 			(SFX_INTERFACE_APP+3)
#define SAMPLE_INTERFACE_RECT 			(SFX_INTERFACE_APP+4)
#define SAMPLE_INTERFACE_CIRCLE			(SFX_INTERFACE_APP+5)

//==================================================================

class TestController: public SfxControllerItem
{
protected:
	virtual void		StateChanged( USHORT, SfxItemState, const SfxPoolItem* );

public:
						TestController(SfxBindings &);
						~TestController();
};

//==================================================================

class Example: public SfxApplication
{
	TestController				   *pInputBar;

private:
	void							Initialize();

protected:
	// Factories
	virtual SfxFileDialog*			CreateDocFileDialog(
										ULONG nBits,
										const SfxObjectFactory &rFact );
	virtual StatusBar*				CreateStatusBar();

	// do application initialization and deinit. (see Application::Main())
	virtual void					Init( int nArgs, char* pArgs[] );
	virtual void					Exit();
	virtual SfxNewFileDialog*		CreateNewDialog();

	virtual void					Main( int nSfxArgs, char* pArgs[] );
public:
									SFX_DECL_INTERFACE(SAMPLE_INTERFACE_APP);

									Example();
									~Example();

	void							Execute( SfxRequest& rReq );
	void							GetState(SfxItemSet &);
};


class InputBox : public SfxDockingWindow
{
	MultiLineEdit	aTextWindow;

protected:
	virtual void	Resize();
	virtual Size	CalcDockingSize(SfxChildAlignment);
	virtual SfxChildAlignment
					CheckAlignment(SfxChildAlignment, SfxChildAlignment);
	virtual void	Resizing( Size& rSize );

public:
				InputBox(SfxBindings* pBindings, SfxChildWindow *pCW,
						 Window *pParent, const ResId& rResId);
				InputBox(SfxBindings* pBindings, SfxChildWindow *pCW,
						 Window *pParent, WinBits nWinBits);
				~InputBox();
};

class TestObjectBar : public SfxChildWindow
{
public:
						TestObjectBar (Window *pParent, USHORT nId,
							  SfxBindings *pBindings, SfxChildWinInfo*);
						SFX_DECL_CHILDWINDOW(TestObjectBar);
virtual SfxChildWinInfo GetInfo() const;
};

//==================================================================

/************************************************************/
extern SfxType0 aSfxVoidItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxVoidItem_Impl =
{
	TYPE(SfxVoidItem), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxBoolItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxBoolItem_Impl =
{
	TYPE(SfxBoolItem), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxUInt16Item_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxUInt16Item_Impl =
{
	TYPE(SfxUInt16Item), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxInt16Item_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxInt16Item_Impl =
{
	TYPE(SfxInt16Item), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxUInt32Item_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxUInt32Item_Impl =
{
	TYPE(SfxUInt32Item), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxInt32Item_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxInt32Item_Impl =
{
	TYPE(SfxInt32Item), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxStringItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxStringItem_Impl =
{
	TYPE(SfxStringItem), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxByteItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxByteItem_Impl =
{
	TYPE(SfxByteItem), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxEnumItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxEnumItem_Impl =
{
	TYPE(SfxEnumItem), 0
};
#endif

/************************************************************/
extern SfxType0 aSfxAllEnumItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxAllEnumItem_Impl =
{
	TYPE(SfxAllEnumItem), 0
};
#endif

/************************************************************/
extern SfxType2 aSfxPointItem_Impl;
#ifdef SFX_TYPEMAP
SfxType2 aSfxPointItem_Impl =
{
	TYPE(SfxPointItem), 2, { {MID_X,"x"}, {MID_Y,"y"} }
};
#endif

/************************************************************/
extern SfxType0 aSfxTemplateItem_Impl;
#ifdef SFX_TYPEMAP
SfxType0 aSfxTemplateItem_Impl =
{
	TYPE(SfxTemplateItem), 0
};
#endif

#endif
