/*************************************************************************
 *
 *  $RCSfile: test.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <tools/debug.hxx>
#include <usr/uno.hxx>
#include <stardiv/uno/repos/serinfo.hxx>
#include <vcl/window.hxx>
#include <sfxuno.hxx>
#include <tools/urlobj.hxx>

// F"ur TestComponent
#include <vcl/syschild.hxx>
#include <vcl/sysdep.hxx>
#include <vcl/sysdata.hxx>
#include <toolkit/unoiface.hxx>
#include <stardiv/uno/beans/propset.hxx>
#include <vcl/msgbox.hxx>
#include <stardiv/one/frame/xloader.hxx>
#include <stardiv/one/frame/xframe.hxx>
#include <stardiv/one/frame/xctrller.hxx>
#include <stardiv/one/frame/xdisp.hxx>
#include <stardiv/one/frame/xmodel.hxx>
#include <sfx2/childwin.hxx>

// --- Testkomponente mit UnoControl -------------------------------------------

class XEventListenerRef;
typedef XEventListenerRef* XEventListenerPtr;
SV_DECL_PTRARR_DEL( XEventListenerArr, XEventListenerPtr, 4, 4 );
SV_IMPL_PTRARR( XEventListenerArr, XEventListenerPtr );

class StatusDispatch
{
public:
	URL					aURL;
	XStatusListenerRef	xListener;
						StatusDispatch( const URL& rURL, const XStatusListenerRef xRef )
							: aURL( rURL )
							, xListener( xRef )
						{}
};

typedef StatusDispatch* StatusDispatchPtr;
SV_DECL_PTRARR_DEL( StatusDispatchArr, StatusDispatchPtr, 4, 4 );
SV_IMPL_PTRARR( StatusDispatchArr, StatusDispatchPtr );

class SfxTestController : public XController, public XDispatch,
							public XPropertyChangeListener, public UsrObject
{
friend class SfxTestLoader;
	XEventListenerArr		aListeners;
	StatusDispatchArr		aStatusListeners;
	BOOL					bDisposing;
	BOOL 					bModelChanged;
	XFrameRef				xFrame;

public:
							SMART_UNO_DECLARATION( SfxTestController, UsrObject );
	XInterface* 			queryInterface( UsrUik aUIK );

							SfxTestController()
								: bDisposing( FALSE )
								, bModelChanged( FALSE )
							{}

	virtual void 			connectFrame( const XFrameRef& xFrame );
	virtual BOOL 			connectModel( const XModelRef& xModel );
	virtual XDispatchRef 	queryDispatch( const URL& aURL,
								const UString& aTargetFrameName,
								FrameSearchFlags nSearchFlags);
	virtual Sequence< XDispatchRef > queryDispatches(
								const Sequence< DispatchDescriptor >& aDescripts);
	virtual BOOL 			suspend( BOOL bSuspend );
	virtual UsrAny			getViewData();
	virtual void			restoreViewData( const UsrAny& Value );
	virtual XFrameRef		getFrame();
	virtual XModelRef		getModel();
	virtual void 			addEventListener(
									const XEventListenerRef& aListener );
	virtual void 			removeEventListener(
									const XEventListenerRef& aListener );

	virtual void 			dispatch( const URL& aURL, const Sequence< PropertyValue >& aArgs );
	virtual void 			addStatusListener(const XStatusListenerRef& xControl, const URL& aURL);
	virtual void 			removeStatusListener(const XStatusListenerRef& xControl, const URL& aURL);
	virtual void			dispose();
	virtual void 			disposing( const EventObject& Source );
	virtual void 			propertyChange( const PropertyChangeEvent& evt);
};

class SfxTestLoader : public XLoader, public UsrObject
{
public:
						SMART_UNO_DECLARATION( SfxTestLoader, UsrObject );
	virtual XInterface*	queryInterface( UsrUik );

	// XLoader
	virtual void 		load(const XFrameRef& aFrame, const UString& aURL,
							const Sequence< PropertyValue >& aArgs,
							const XLoadEventListenerRef& aListener);
	virtual void 		cancel(void);
};

SMART_UNO_IMPLEMENTATION( SfxTestLoader, UsrObject );

extern "C" XLoader* __LOADONCALLAPI CreateLoader( const String& rProt )
{
	return new SfxTestLoader;
}

void SfxTestLoader::load( const XFrameRef& aFrame, const UString& aURL,
							const Sequence< PropertyValue >& aArgs,
							const XLoadEventListenerRef& aListener)
{
	// Controller "uberwacht den Status des Models
	SfxTestController *pCtrl = new SfxTestController;

	// ContainerWindow des Frames
	XVclComponentRef aRef = aFrame->getContainerWindow();
	VCLXComponent* pComp = (VCLXComponent*)
		aRef->getImplementation( VCLXComponent_getReflection() );
	Window* pParent = pComp->GetWindow();
	SystemChildWindow *pWin = new SystemChildWindow( pParent );
	pWin->Show();
	aFrame->setComponent( pWin->GetComponentInterface(), pCtrl );

#if defined(WNT) || defined(WIN)
	HWND aHWND = pWin->GetSystemData()->hWnd;
	// do what you want ...
#endif

/*
	// Name des UnoControls
	// Die URL mu\s lauten: .component:UnoControl/Name
	String aURLStr( U2S( aURL ) );
	INetURLObject aURLObj( aURLStr );
	String aName = aURLObj.GetPath().GetToken( 0, '/' );
	String aControlName = aURLObj.GetPath().GetToken( 1, '/' );

	// Edit als UnoControl und Model erzeugen ( wie findet man das Model zum Control ?? )
	XServiceManagerRef xMgr  = getGlobalServiceManager();
	XServiceProviderRef xProv = xMgr->getServiceProvider( L"stardiv.vcl.controlmodel.Edit", Sequence< Uik >(), Sequence< Uik >() );
	XInterfaceRef xModel =  xProv->newInstance();
	xProv = xMgr->getServiceProvider( L"stardiv.vcl.control.Edit", Sequence< Uik >(), Sequence< Uik >() );
	XControlRef xTextField = (XControl*)xProv->newInstance()->queryInterface( XControl::getSmartUik() );
	XVclComponentRef xTextFieldComp = (XVclComponent *)xTextField->queryInterface( XVclComponent::getSmartUik() );
	xTextField->setModel( QI( XControlModel, xModel ) );

	// Peer als Child zu dem FrameWindow
	XVclComponentPeerRef aPeer = (XVclComponentPeer*) aRef->queryInterface( XVclComponentPeer::getSmartUik() );
	xTextField->createPeer( aPeer );
	xTextFieldComp->setVisible( TRUE );

	aFrame->setComponent( xTextFieldComp, pCtrl );

	// Verbindung mit dem Frame
	XPropertySetRef xSet = (XPropertySet*) xModel->queryInterface( XPropertySet::getSmartUik() );
	xSet->addPropertyChangeListener( L"", pCtrl );
 */

	pCtrl->connectFrame( aFrame );
	aListener->loadFinished( this );
}

XInterface* SfxTestLoader::queryInterface( UsrUik aUIK )
{
	if( aUIK == XLoader::getSmartUik() )
		return (XLoader*) this;
	else return UsrObject::queryInterface( aUIK );
}

void SfxTestLoader::cancel()
{
}

SMART_UNO_IMPLEMENTATION( SfxTestController, UsrObject );

XInterface* SfxTestController::queryInterface( UsrUik aUIK )
{
	if( aUIK == XController::getSmartUik() )
		return (XController*) this;
	else if( aUIK == XDispatch::getSmartUik() )
		return (XDispatch*) this;
	else return UsrObject::queryInterface( aUIK );
}

XFrameRef SfxTestController::getFrame()
{
	return xFrame;
}

XModelRef SfxTestController::getModel()
{
	return XModelRef();
}

UsrAny SfxTestController::getViewData()
{
	return UsrAny();
}

void SfxTestController::restoreViewData( const UsrAny& Value )
{
}

void SfxTestController::dispose()
{
	bDisposing = TRUE;

	// tell all listeners to release this object
	USHORT nCount = aListeners.Count();
	for ( USHORT n=nCount; n>0; n--)
	{
		XEventListenerRef *pObj = aListeners[n-1];
		EventObject aObject;
		aObject.Source = (XComponent*) this;
		(*pObj)->disposing( aObject );
		aListeners.DeleteAndDestroy(n-1);
	}

	nCount = aStatusListeners.Count();
	for ( n=nCount; n>0; n--)
	{
		StatusDispatch *pObj = aStatusListeners[n-1];
		StatusEvent aEvent;
		aEvent.CommandURL = pObj->aURL;
		aEvent.Source = (XDispatch*) this;
		aEvent.Enabled = bModelChanged;
		aEvent.ReQuery = TRUE;
		pObj->xListener->statusChanged( aEvent );
	}

	// Falls im ReQuey nicht abgemeldet wurde
	nCount = aStatusListeners.Count();
	for ( n=nCount; n>0; n--)
	{
		StatusDispatch *pObj = aStatusListeners[n-1];
		EventObject aObject;
		aObject.Source = (XComponent*) this;
		pObj->xListener->disposing( aObject );
		aStatusListeners.DeleteAndDestroy(n-1);
	}
}

void SfxTestController::addEventListener(const XEventListenerRef& aListener)
{
	// create a new Reference and insert into listener array
	XEventListenerRef *pObj = new XEventListenerRef( (XEventListener*) aListener );
	aListeners.Insert( pObj, aListeners.Count() );
}

void SfxTestController::removeEventListener( const XEventListenerRef& aObject )
{
	// search listener array for given listener
	// for checking equality always "cast" to XInterface
	USHORT nCount = aListeners.Count();
	for ( USHORT n=0; n<nCount; n++ )
	{
		XEventListenerRef *pObj = aListeners[n];
		if ( (*pObj)->queryInterface( ::XInterface::getSmartUik() ) ==
				aObject->queryInterface( ::XInterface::getSmartUik() ) )
		{
			aListeners.DeleteAndDestroy( n );
			break;
		}
	}
}

void SfxTestController::addStatusListener(const XStatusListenerRef& aListener, const URL& aURL)
{
	// create a new Reference and insert into listener array
	aStatusListeners.Insert( new StatusDispatch( aURL, aListener ), aStatusListeners.Count() );

	// den ersten Status synchron zusenden
	if ( aURL.Path == "Save" )
	{
		StatusEvent aEvent;
		aEvent.CommandURL = aURL;
		aEvent.Source = (XDispatch*) this;
		aEvent.Enabled = bModelChanged;
		aEvent.ReQuery = FALSE;
		aListener->statusChanged( aEvent );
	}
	else if ( aURL.Path == "Modified" )
	{
		StatusEvent aEvent;
		aEvent.CommandURL = aURL;
		aEvent.Source = (XDispatch*) this;
		aEvent.Enabled = TRUE;
		aEvent.ReQuery = FALSE;
		aEvent.Status.setString( bModelChanged ? L"*" : L"" );
		aListener->statusChanged( aEvent );
	}
	else if ( aURL.Path == "Title" )
	{
		StatusEvent aEvent;
		aEvent.CommandURL = aURL;
		aEvent.Source = (XDispatch*) this;
		aEvent.Enabled = TRUE;
		aEvent.ReQuery = FALSE;
		aEvent.Status.setString( L"TestController" );
		aListener->statusChanged( aEvent );
	}
}

void SfxTestController::removeStatusListener( const XStatusListenerRef& aObject, const URL& aURL )
{
	// search listener array for given listener
	// for checking equality always "cast" to XInterface
	USHORT nCount = aStatusListeners.Count();
	for ( USHORT n=0; n<nCount; n++ )
	{
		StatusDispatch *pObj = aStatusListeners[n];
		if ( pObj->xListener->queryInterface( ::XInterface::getSmartUik() ) ==
				aObject->queryInterface( ::XInterface::getSmartUik() ) &&
			pObj->aURL == aURL )
		{
			aStatusListeners.DeleteAndDestroy( n );
			break;
		}
	}
}

void SfxTestController::disposing( const EventObject& Source )
{
	XControllerRef xCtrl( this );
	xFrame->removeEventListener( this );
	xFrame = XFrameRef();
}

void SfxTestController::connectFrame( const XFrameRef& aFrame )
{
	xFrame = aFrame;
	xFrame->addEventListener( this );
}

BOOL SfxTestController::connectModel( const XModelRef& )
{
	return FALSE;
}

XDispatchRef SfxTestController::queryDispatch( const URL& aURL,
		const UString& aTargetFrameName, FrameSearchFlags nSearchFlags )
{
	if ( !bDisposing )
	{
		String aCommand( U2S( aURL.Path ) );
		if ( aCommand == "Save" || aCommand == "Modified" ||
				aCommand == "Undo" || aCommand == "Title" )
			return (XDispatch*) this;
	}

	return XDispatchRef();
}

Sequence < XDispatchRef > SfxTestController::queryDispatches( const Sequence< DispatchDescriptor >& aDescripts)
{
	return Sequence < XDispatchRef > ();
}

BOOL SfxTestController::suspend( BOOL bSuspend )
{
	return TRUE;
}

void SfxTestController::propertyChange( const PropertyChangeEvent& evt )
{
	bModelChanged = TRUE;
	if ( U2S( evt.PropertyName ).ICompare( "text" ) == COMPARE_EQUAL )
	{
		USHORT nCount = aStatusListeners.Count();
		for ( USHORT n=0; n<nCount; n++ )
		{
			StatusDispatch *pObj = aStatusListeners[n];
			if ( pObj->aURL.Path == "Save" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = bModelChanged;
				aEvent.ReQuery = FALSE;
				pObj->xListener->statusChanged( aEvent );
			}
			else if ( pObj->aURL.Path == "Modified" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = TRUE;
				aEvent.ReQuery = FALSE;
				aEvent.Status.setString( bModelChanged ? L"*" : L"" );
				pObj->xListener->statusChanged( aEvent );
			}
			else if ( pObj->aURL.Path == "Title" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = TRUE;
				aEvent.ReQuery = FALSE;
				aEvent.Status.setString( bModelChanged ? L"Test" : L"TestController" );
				pObj->xListener->statusChanged( aEvent );
			}
		}
	}
}

void SfxTestController::dispatch( const URL& aURL, const Sequence< PropertyValue >& aArgs )
{
	String aCommand( U2S( aURL.Path ) );
	if ( aCommand == "Save" )
	{
		InfoBox( NULL, "Es wurde SAVE angefordert!" ).Execute();
		bModelChanged = FALSE;

		// Benachrichtigen
		USHORT nCount = aStatusListeners.Count();
		for ( USHORT n=0; n<nCount; n++ )
		{
			StatusDispatch *pObj = aStatusListeners[n];
			if ( pObj->aURL.Path == "Save" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = bModelChanged;
				aEvent.ReQuery = FALSE;
				pObj->xListener->statusChanged( aEvent );
			}
			else if ( pObj->aURL.Path == "Modified" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = TRUE;
				aEvent.ReQuery = FALSE;
				aEvent.Status.setBOOL( bModelChanged );
				pObj->xListener->statusChanged( aEvent );
			}
			else if ( pObj->aURL.Path == "Title" )
			{
				StatusEvent aEvent;
				aEvent.CommandURL = pObj->aURL;
				aEvent.Source = (XDispatch*) this;
				aEvent.Enabled = TRUE;
				aEvent.ReQuery = FALSE;
				aEvent.Status.setString( bModelChanged ? L"Test" : L"TestController" );
				pObj->xListener->statusChanged( aEvent );
			}
		}
	}
}
