/*************************************************************************
 *
 *  $RCSfile: testview.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:52:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <soipenv.hxx>
#include <sbx.hxx>
#include "sfx.hrc"
#include "sample.hrc"

#include "sfx.hxx"
#include "sfxdlg.hxx"
#include "testview.hxx"
#include "testdoc.hxx"
#include "sample.hxx"

DBG_NAME(TestView);

//==================================================================

SFX_EXEC_STUB( DefaultView, ExecTool)
SFX_STATE_STUB( DefaultView, GetToolState)

#define ShellClass DefaultView
SFX_SLOTMAP(DefaultView)
{
	SFX_SLOT     ( DefaultView, SID_TOOL, GID_DOC,
				   SFX_STUB_PTR(DefaultView, ExecTool),
				   SFX_STUB_PTR(DefaultView, GetToolState),
				  SFX_SLOT_CACHABLE|SFX_SLOT_AUTOUPDATE, SfxEnumItem ),
	SFX_SLOT_ENUM( SID_TOOL_SELECT, GID_DOC,
					SID_TOOL, TOOL_SELECT, SFX_SLOT_CACHABLE|SFX_SLOT_AUTOUPDATE),
	SFX_SLOT_ENUM( SID_TOOL_RECT, GID_DOC,
					SID_TOOL, TOOL_RECT, SFX_SLOT_CACHABLE|SFX_SLOT_AUTOUPDATE ),
	SFX_SLOT_ENUM( SID_TOOL_CIRCLE, GID_DOC,
					SID_TOOL, TOOL_CIRCLE, SFX_SLOT_CACHABLE|SFX_SLOT_AUTOUPDATE )
};
#undef ShellClass

// erack! ER 04.03.95 21:16
SFX_IMPL_INTERFACE(DefaultView,TestView,STR_DEFAULTVIEW)
{
	SFX_OBJECTBAR_REGISTRATION( 1, RID_DEFAULT_OBJECTBAR );
	SFX_CHILDWINDOW_REGISTRATION(SID_TEMPLATE);
}

SFX_IMPL_VIEWFACTORY(DefaultView, STR_DEFAULTVIEW )
{
	SFX_VIEW_REGISTRATION(TestDoc);
}

//------------------------------------------------------------------

SFX_EXEC_STUB(SpecialView, Execute)
SFX_STATE_STUB(SpecialView, GetState)


#define ShellClass SpecialView
SFX_SLOTMAP(SpecialView)
{
	SFX_SLOT     ( SpecialView, SID_MOUSEPOS,   GID_VIEW,
				  SFX_STUB_PTR(SpecialView, Execute),
				  SFX_STUB_PTR(SpecialView, GetState),
				  0, SfxStringItem ),
	SFX_SLOT     ( SpecialView, SID_INSERT_OBJECT, GID_EDIT,
				  SFX_STUB_PTR(SpecialView, Execute),
				  SFX_STUB_PTR(SpecialView, GetState),
				  0, SfxVoidItem ),
	SFX_SLOT     ( SpecialView, SID_BACKGROUND, GID_VIEW,
				  SFX_STUB_PTR(SpecialView, Execute),
				  SFX_STUB_PTR(SpecialView, GetState),
				  0, SfxVoidItem ),
	SFX_SLOT	 ( SpecialView, SID_OBJECTMENU0, 0,
				  SFX_STUB_PTR(SpecialView, Execute),
				  SFX_STUB_PTR(SpecialView, GetState),
				  0, SfxStringItem )
};
#undef ShellClass

SFX_IMPL_INTERFACE(SpecialView,TestView,STR_SPECIALVIEW)
{
	SFX_OBJECTBAR_REGISTRATION( 1, RID_SPECIAL_OBJECTBAR );
}

SFX_IMPL_VIEWFACTORY(SpecialView,STR_SPECIALVIEW )
{
	SFX_VIEW_REGISTRATION(TestDoc);
}

//------------------------------------------------------------------

#define ShellClass RectShell
SFX_SLOTMAP(RectShell)
{
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};
#undef ShellClass

SFX_IMPL_INTERFACE(RectShell,SfxShell,STR_RECTSHELL)
{
	SFX_OBJECTBAR_REGISTRATION( 2, RID_RECT_OBJECTBAR );
}

//------------------------------------------------------------------

#define ShellClass CircShell
SFX_SLOTMAP(CircShell)
{
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};
#undef ShellClass

SFX_IMPL_INTERFACE(CircShell,SfxShell,STR_CIRCLESHELL)
{
	SFX_OBJECTBAR_REGISTRATION( 2, RID_CIRCLE_OBJECTBAR );
}

//------------------------------------------------------------------

void DefaultView::ExecTool( SfxRequest& rReq )
{
	const SfxItemSet *pArgs = rReq.GetArgs();
	DBG_ASSERT(pArgs, "fehlende Argumente");

	nTool = ( (const SfxEnumItem&) pArgs->Get(SID_TOOL) ).GetValue();
	if ( pTool )
		SetSubShell( 0 );
	switch ( nTool )
	{
		case TOOL_RECT:
			pTool = pRect;
			break;
		case TOOL_CIRCLE:
			pTool = pCirc;
			break;
		default:
			pTool = 0;
	}
	if ( pTool )
		SetSubShell( pTool );
	rReq.Done();
}

void DefaultView::GetToolState(SfxItemSet &rSet)
{
	SfxWhichIter aIter(rSet);
	USHORT nWhich = aIter.FirstWhich();
	while(nWhich)
	{
		rSet.Put( SfxAllEnumItem( SID_TOOL, nTool ) );
		nWhich = aIter.NextWhich();
	}
}

//------------------------------------------------------------------

void SpecialView::Execute( SfxRequest& rReq )
{
	// This function becomes called from the SFx to execute functions
	// registered for this server.
	switch( rReq.GetSlot() )
	{
		case SID_INSERT_OBJECT:
		{
			SvInPlaceObjectRef aIPObj;
//            SvInsertObjectDialog aDlg;
			SvStorageRef aStor = new SvStorage( "", STREAM_STD_READWRITE );
//            aIPObj = aDlg.Execute( this, aStor );
			if( aIPObj.Is() )
			{
				GetViewFrame()->GetObjectShell()->InsertObject( aIPObj, String() );
				aIPObj->SetVisAreaSize( LogicToLogic( Size( 5000, 5000 ),
														MapMode(aIPObj->GetMapUnit()),

												  MapMode(MAP_100TH_MM )) );
				MapMode aMode = GetMapMode();
/*!MI dafuer habe ich heute leider keine Zeit
				SfxClientShell *pCliSh = FindIPClient( pSoNode->GetObject() );
				if ( !pCliSh )
					pCliSh = new SfxClientShell( pViewSh, pEditWin );
				aIPObj->DoConnect( pIPClient );
				return DoVerb( pCliSh, 0 );
*/
			}
			break;
		}
	}

	rReq.Done();
}

void SpecialView::GetState(SfxItemSet &rSet)
{
	rSet.Put( SfxStringItem( SID_MOUSEPOS,
		String( aMousePos.X() ) + String( ":" ) + String( aMousePos.Y() ) ) );
	rSet.Put( SfxStringItem( SID_OBJECTMENU0, "Datenbank" ) );
}

//------------------------------------------------------------------
#ifdef SFX_ZOOMDLG

#define SFX_PLUG( Class, Msg, AttrSet, pCore, Get, Set, pFrame, DialogClass ) \
                                                                            \
SfxArg Class::Execute##Msg( SfxRequest& rReq )                              \
{                                                                           \
    AttrSet *pAttrs = 0;
	if ( rReq.GetArgs() )
		/* verfuegbar via Makro etc. */
		pAttrs = new AttrSet( rReq );
	else
	{
		/* erfragen via Dialog */
		DialogClass *pDlg = new DialogClass( pFrame );
		pAttrs = pCore()->Get();
		pDlg->SetAttrSet( *pAttrs );
		if ( pDlg->Execute() != RET_OK )
		{
			rReq.Cancel();
			return SfxArg(FALSE);
		}
		else
			pAttrs = pDlg->GetAttrSet()
	}

	pCore->Set( *pAttrs );
	rReq.Done( *pAttrs );

	pAttrs->
}

SfxMessageState TestView::Get##Msg(USHORT i)
{
	return pCore->Get();
}

SFX_PLUG_DIALOG( SpecialView, this, GetBGBrush, SetBGBrush, this, BrushDialog );

#endif

//------------------------------------------------------------------

void __EXPORT TestView::Notify( SfxBroadcaster& rBC, const TypeId& rBCType,
					   const SfxHint& rHint, const TypeId& rHintType )
{
	// We are listening too creations of documents and vies.
	if ( rHint.Type() != TYPE(SfxSimpleHint) &&
		 ( (SfxSimpleHint&) rHint ).GetId() == SFX_HINT_DATACHANGED )
	{
		// determine the new screen size of the output
		ULONG nMaxWidth = 0, nHeight = 150;
		for ( SfxObjectShell* pDoc = SfxObjectShell::GetFirst();
			  pDoc;
			  pDoc = SfxObjectShell::GetNext(*pDoc) )
		{
			Font aFont = GetFont();
			SetFont( Font( FAMILY_SWISS, Size( 0, 320 ) ) );
			Size aTextSz = GetTextSize( pDoc->GetTitle() );
			nHeight += aTextSz.Height();
			USHORT nWidth = aTextSz.Width();
			nMaxWidth = max(nWidth + 300, nMaxWidth);
			SetFont( aFont );

			for ( SfxMDIFrame* pFrame = (SfxMDIFrame*)
					SfxViewFrame::GetFirst(pDoc, TYPE(SfxMDIFrame));
				  pFrame;
				  pFrame = (SfxMDIFrame*)
					SfxViewFrame::GetNext(*pFrame, pDoc, TYPE(SfxMDIFrame)) )
			{
				Size aTextSz = GetTextSize( pFrame->GetWindow().GetText() );
				nHeight += aTextSz.Height();
				USHORT nWidth = aTextSz.Width();
				nMaxWidth = max(nWidth + 450, nMaxWidth);
			}
		}
		aTotalSize = Size( nMaxWidth+300, nHeight+300 );
		TestDoc *pTestDoc = ((TestDoc *)GetViewFrame()->GetObjectShell());
		BOOL bModified = pTestDoc->IsModified();
		pTestDoc->SetVisAreaSize(LogicToLogic( aTotalSize, MapMode(pTestDoc->GetMapUnit()),  MapMode(MAP_TWIP)));
		if ( !bModified )
			pTestDoc->SetModified( bModified );

		// This would happen automatically too. But in practice we
		// only want to invalidate parts of the view.
		Window::Invalidate();
	}
}

//------------------------------------------------------------------

void __EXPORT TestView::MouseButtonUp( const MouseEvent& rMEvt )
{
	if( GetIPClient() )
	{
		if ( GetIPClient()->IsInPlaceActive() )
			GetIPClient()->GetProtocol().Reset2Open();
		if ( rMEvt.IsLeft() && rMEvt.GetClicks() == 2 &&
			 GetIPClient()->GetEnv()->GetObjAreaPixel().IsInside(
					rMEvt.GetPosPixel() ) )
		{
			if( GetIPClient()->GetIPObj() )
				GetIPClient()->GetIPObj()->DoUIProtocol();
		}
	}
}

//------------------------------------------------------------------

void __EXPORT TestView::Paint( const Rectangle& )
{
	((TestDoc *)GetViewFrame()->GetObjectShell())->
		DoDraw( this, Point(), GetOutputSize(), JobSetup() );
}

//------------------------------------------------------------------

void TestView::Construct()
{
	// Common initialization code called from each constructor.
	SetWindow(this);

	// listen to broadcasts from aExample
	StartListening( * (Example*) SFX_APP() );
	StartListening( *GetViewFrame()->GetObjectShell() );

	SetMapMode( MapMode( MAP_TWIP ) );
	Font aNewFont( FAMILY_SWISS, Size( 0, 240 ) );
	aNewFont.SetTransparent(TRUE);
	SetFont( aNewFont );

	ULONG nMaxWidth = 0, nHeight = 150;
	for ( SfxObjectShell* pDoc = SfxObjectShell::GetFirst();
		  pDoc;
		  pDoc = SfxObjectShell::GetNext(*pDoc) )
	{
		Font aFont = GetFont();
		SetFont( Font( FAMILY_SWISS, Size( 0, 320 ) ) );
		Size aTextSz = GetTextSize( pDoc->GetTitle() );
		nHeight += aTextSz.Height();
		USHORT nWidth = aTextSz.Width();
		nMaxWidth = max(nWidth + 300, nMaxWidth);
		SetFont( aFont );

		for ( SfxMDIFrame* pFrame = (SfxMDIFrame*)
				SfxViewFrame::GetFirst(pDoc, TYPE(SfxMDIFrame));
			  pFrame;
			  pFrame = (SfxMDIFrame*)
				SfxViewFrame::GetNext(*pFrame, pDoc, TYPE(SfxMDIFrame)) )
		{
			Size aTextSz = GetTextSize( pFrame->GetWindow().GetText() );
			nHeight += aTextSz.Height();
			USHORT nWidth = aTextSz.Width();
			nMaxWidth = max(nWidth + 450, nMaxWidth);
		}
	}
	aTotalSize = Size( nMaxWidth+300, nHeight+300 );
	TestDoc *pTestDoc = ((TestDoc *)GetViewFrame()->GetObjectShell());
	BOOL bModified = pTestDoc->IsModified();
	pTestDoc->SetVisAreaSize(LogicToLogic( aTotalSize, MapMode(pTestDoc->GetMapUnit()),  MapMode(MAP_TWIP)));
	if ( !bModified )
		pTestDoc->SetModified( bModified );
	Show();
}

//------------------------------------------------------------------

TestView::TestView( SfxViewFrame *pFrame, const TestView& rWin ):
	SfxViewShell( pFrame, SFX_VIEW_HAS_PRINTOPTIONS ),
	Window( &pFrame->GetWindow(), WinBits(WB_BORDER|WB_CLIPCHILDREN) )
{
	DBG_CTOR(TestView, 0);

	// Create a view, as a clone to another
	Construct();
}

//------------------------------------------------------------------

TestView::TestView( SfxViewFrame *pFrame, SfxViewShell * ):
	SfxViewShell( pFrame, SFX_VIEW_HAS_PRINTOPTIONS ),
	Window( &pFrame->GetWindow(), WinBits(WB_BORDER|WB_CLIPCHILDREN) )
{
	DBG_CTOR(TestView, 0);

	// Create a view to the specified document
	Construct();
}

//------------------------------------------------------------------

__EXPORT TestView::~TestView()
{
	DBG_DTOR(TestView, 0);

	// In destructors C++ calles at maximum the virtual function of the
	// class currently destroying. If StarFramework hides our window in its
	// DocView destructor, the Deactivate() function of class DocView, not
	// class TestView becomes called!
	Hide();
	SetWindow(0);
}

//------------------------------------------------------------------

Size __EXPORT TestView::GetOptimalSizePixel() const
{
	return LogicToPixel(aTotalSize);
}

//------------------------------------------------------------------

void __EXPORT TestView::OuterResizePixel( const Point &rOfs, const Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

//------------------------------------------------------------------

void __EXPORT TestView::InnerResizePixel( const Point &rOfs, const Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

//==================================================================

DefaultView::DefaultView( SfxViewFrame *pFrame, const DefaultView& rWin ):
	TestView( pFrame, rWin )
{
	Construct();
}

//------------------------------------------------------------------

DefaultView::DefaultView( SfxViewFrame *pFrame, SfxViewShell *pOld ):
	TestView( pFrame, pOld )
{
	Construct();
}

//------------------------------------------------------------------

void DefaultView::Construct()
{
	SfxUndoManager *pUndoMgr = GetViewFrame()->GetObjectShell()->GetUndoManager();
	pRect = new RectShell(GetPool()); pRect->SetUndoManager(pUndoMgr);
	pCirc = new CircShell(GetPool()); pCirc->SetUndoManager(pUndoMgr);
	pSel = new RectShell(GetPool());  pSel->SetUndoManager(pUndoMgr);
	pTool = pRect;
	nTool = TOOL_RECT;
	SetSubShell(pTool);
}

//------------------------------------------------------------------

__EXPORT DefaultView::~DefaultView()
{
	if ( pTool )
		SetSubShell(0);
	GetViewFrame()->GetDispatcher()->Flush();
	delete pRect; delete pCirc; delete pSel;
}

//------------------------------------------------------------------

void __EXPORT DefaultView::MouseButtonDown( const MouseEvent &rEvt )
{
	if ( ( rEvt.GetMode() & COMMAND_CONTEXTMENU ) == COMMAND_CONTEXTMENU )
	  SFX_DISPATCHER().ExecutePopup();
}

//==================================================================

SpecialView::SpecialView( SfxViewFrame *pFrame, const SpecialView& rWin ):
	TestView( pFrame, rWin ),
	pPrinter(0)
{
	SetBackgroundBrush( Brush( Color(COL_LIGHTRED) ) );
}

//------------------------------------------------------------------

SpecialView::SpecialView( SfxViewFrame *pFrame, SfxViewShell *pOld):
	TestView( pFrame, pOld ),
	pPrinter(0)
{
	SetBackgroundBrush( Brush( Color(COL_LIGHTRED) ) );
}

//------------------------------------------------------------------

__EXPORT SpecialView::~SpecialView()
{
	delete pPrinter;
}

//--------------------------------------------------------------------

void __EXPORT SpecialView::Paint( const Rectangle &rRect )
{
	Point aPos( 0, 0 );
	for ( USHORT nFont = 0;
		  nFont < GetPrinter()->GetFontCount() &&
		  aPos.Y() < rRect.Bottom();
		  ++nFont )
	{
		const SfxFont *pFont = GetPrinter()->GetFont( nFont );
		String aSizes( " " );
		SfxFontSizeInfo aInfo( *pFont, *this );
		for ( USHORT nSize = 0; nSize < aInfo.SizeCount(); ++nSize )
			aSizes += String( long(aInfo.GetSize(nSize).Height()) ) + String(" / ");
		DrawText( aPos, pFont->GetName() + aSizes );
		aPos.Y() += GetTextSize( "" ).Height();
	}
}

//--------------------------------------------------------------------

USHORT __EXPORT SpecialView::Print()
{
	//! not implemented
	Sound::Beep();
	Sound::Beep();
	Sound::Beep();
	Sound::Beep();
	return 0;
}

//--------------------------------------------------------------------

SfxPrinter* __EXPORT SpecialView::GetPrinter()
{
	if ( !pPrinter )
	{
		SfxItemSet *pOptions =
			new SfxItemSet(GetPool(), SID_PRINTER_NOTFOUND_WARN, SID_PRINTER_NOTFOUND_WARN );
		pOptions->Put( SfxBoolItem( SID_PRINTER_NOTFOUND_WARN, FALSE ) );
		pPrinter = new SfxPrinter( pOptions );
	}
	return pPrinter;
}

//--------------------------------------------------------------------

USHORT __EXPORT SpecialView::SetPrinter( SfxPrinter *pNewPrinter, USHORT nDiffFlags )
{
	if ( ( nDiffFlags & SFX_PRINTER_PRINTER ) == SFX_PRINTER_PRINTER )
	{
		delete pPrinter;
		pPrinter = pNewPrinter;
		Window::Invalidate();
	}
	else if ( ( nDiffFlags & SFX_PRINTER_JOBSETUP ) == SFX_PRINTER_JOBSETUP )
	{
		Window::Invalidate();
	}

	if ( ( nDiffFlags & SFX_PRINTER_OPTIONS ) == SFX_PRINTER_OPTIONS )
		;

	return 0;
}

//--------------------------------------------------------------------

class TestPrintOptionsPage: public SfxTabPage
{
	CheckBox                aCheckBtn;

protected:
	virtual BOOL            FillItemSet( SfxItemSet &rSet );
	virtual void            Reset(const SfxItemSet &);

public:
							TestPrintOptionsPage( Window *pParent,
												  const SfxItemSet &rOptions );
};

TestPrintOptionsPage::TestPrintOptionsPage( Window *pParent,
											const SfxItemSet &rOptions ):
	SfxTabPage( pParent, ResId(RID_PRINTOPTIONS), rOptions ),
	aCheckBtn( this )
{
	aCheckBtn.SetPosSizePixel( Point( 6, 6 ), Size( 120, 24 ) );
	aCheckBtn.SetText( "Warnung" );
	aCheckBtn.Check( ( (const SfxBoolItem&)
		( rOptions.Get( GetWhich(SID_PRINTER_NOTFOUND_WARN) ) ) ).GetValue());
	aCheckBtn.Show();

	SetText( "Druck-Zus\"atze" );
	SetOutputSizePixel( Size( 132, 68 ) );
};

BOOL __EXPORT TestPrintOptionsPage::FillItemSet( SfxItemSet &rSet )
{
	rSet.Put( SfxBoolItem( GetWhich(SID_PRINTER_NOTFOUND_WARN), aCheckBtn.IsChecked() ) );
	return TRUE;
}

void __EXPORT TestPrintOptionsPage::Reset(const SfxItemSet &rSet)
{
	aCheckBtn.Check( ( (const SfxBoolItem&)
		( rSet.Get( GetWhich(SID_PRINTER_NOTFOUND_WARN) ) ) ).GetValue());
}

//--------------------------------------------------------------------

SfxTabPage* __EXPORT SpecialView::CreatePrintOptionsPage( Window *pParent,
												 const SfxItemSet &rOptions )
{
	return new TestPrintOptionsPage( pParent, rOptions );
}

//------------------------------------------------------------------

void __EXPORT SpecialView::MouseMove( const MouseEvent &rEvt )
{
	aMousePos = rEvt.GetPosPixel();
	if ( rEvt.IsLeft() )
	{
		SfxStringItem aArg( SID_CONTENT,
			String( aMousePos.X() ) + String( "/" ) + String( aMousePos.Y() ) );
		SFX_DISPATCHER().Execute( SID_CONTENT,
#if SUPD>=324
								  SFX_CALLMODE_RECORD,
#else
								  TRUE, SFX_CALLMODE_SLOT,
#endif
								  &aArg, (void*) 0 );
	}
	else
	{
		SfxViewShell::Invalidate( SID_MOUSEPOS );
		SFX_BINDINGS().Update( SID_MOUSEPOS );
	}
}

//------------------------------------------------------------------

void __EXPORT SpecialView::MouseButtonDown( const MouseEvent &rEvt )
{
	if ( rEvt.IsLeft() )
		if ( rEvt.GetClicks() == 2 )
			SFX_DISPATCHER().Lock( TRUE );
		else
		{
			SFX_DISPATCHER().Lock( FALSE );
			Sound::Beep();
		}
	else
		if ( rEvt.GetClicks() == 2 )
			SFX_APP()->LockDispatcher( TRUE );
		else
		{
			SFX_APP()->LockDispatcher( FALSE );
			Sound::Beep();
		}
}

//==================================================================

SFX_IMPL_VIEWFACTORY(EditorView, STR_DEFAULTVIEW  )
{
	SFX_VIEW_REGISTRATION(Editor);
}

//------------------------------------------------------------------

void __EXPORT EditorView::OuterResizePixel( const Point &rOfs, const Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

//------------------------------------------------------------------

void __EXPORT EditorView::InnerResizePixel( const Point &rOfs, const Size &rSize )
{
	SetBorderPixel( SvBorder() );
}

IMPL_LINK_INLINE_START( EditorView, ModifyHdl, MultiLineEdit *, pEdit )
{
	((Editor *)GetViewFrame()->GetObjectShell())->SetText(pEdit->GetText());
	return 0;
}
IMPL_LINK_INLINE_END( EditorView, ModifyHdl, MultiLineEdit *, pEdit )

EditorView::EditorView(SfxViewFrame *pFrame, SfxViewShell*pOld):
	SfxViewShell( pFrame, SFX_VIEW_HAS_PRINTOPTIONS ),
	aMultiLineEdit(&pFrame->GetWindow(), WB_LEFT | WB_BORDER | WB_HSCROLL | WB_VSCROLL )
{
	SetWindow(&aMultiLineEdit);
	aMultiLineEdit.SetModifyHdl(LINK(this, EditorView, ModifyHdl));
	aMultiLineEdit.SetText(((Editor *)GetViewFrame()->GetObjectShell())->GetText());
	aMultiLineEdit.Show();
}

EditorView::EditorView( SfxViewFrame *pFrame, const EditorView& rWin ):
	SfxViewShell( pFrame, SFX_VIEW_HAS_PRINTOPTIONS ),
	aMultiLineEdit( &pFrame->GetWindow(), WB_LEFT | WB_BORDER | WB_HSCROLL | WB_VSCROLL  )
{
	SetWindow(&aMultiLineEdit);
	aMultiLineEdit.Show();
}
