/*************************************************************************
 *
 *  $RCSfile: simattr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_SIMATTR_HXX
#define _SIM_SIMATTR_HXX

#include <sfx2/sfx.hrc>

#define ATTR_START				(SID_OBJ0_START + 150)

// -----------------------------------------------------------------------------

#define ATTR_ROTATE_START		ATTR_START
#define ATTR_ROTATE_ANGLE		ATTR_ROTATE_START
#define ATTR_ROTATE_ORIENTATION	ATTR_ROTATE_START + 1
#define ATTR_ROTATE_END			ATTR_ROTATE_ORIENTATION

#define ATTR_SCALE_START		ATTR_ROTATE_END + 1
#define ATTR_SCALE_FORMAT		ATTR_SCALE_START
#define ATTR_SCALE_X			ATTR_SCALE_START + 1
#define ATTR_SCALE_Y			ATTR_SCALE_START + 2
#define ATTR_SCALE_END			ATTR_SCALE_Y

#define	ATTR_RGB_START			ATTR_SCALE_END + 1
#define	ATTR_RGB_RED			ATTR_RGB_START
#define	ATTR_RGB_GREEN			ATTR_RGB_START + 1
#define	ATTR_RGB_BLUE			ATTR_RGB_START + 2
#define	ATTR_RGB_END			ATTR_RGB_BLUE

#define	ATTR_BRI_CON_START		ATTR_RGB_END + 1
#define	ATTR_BRI_CON_BRIGHT	    ATTR_BRI_CON_START
#define	ATTR_BRI_CON_CONTRAST	ATTR_BRI_CON_START + 1
#define	ATTR_BRI_CON_END		ATTR_BRI_CON_CONTRAST

#define ATTR_GRAYSCALES_START	ATTR_BRI_CON_END + 1
#define ATTR_GRAYSCALES_COUNT	ATTR_GRAYSCALES_START
#define ATTR_GRAYSCALES_THRES	ATTR_GRAYSCALES_START + 1
#define ATTR_GRAYSCALES_END		ATTR_GRAYSCALES_THRES

#define ATTR_GAMMA_START		ATTR_GRAYSCALES_END + 1
#define ATTR_GAMMA_VALUE		ATTR_GAMMA_START
#define ATTR_GAMMA_END			ATTR_GAMMA_VALUE

#define ATTR_TILE_START			ATTR_GAMMA_END + 1
#define ATTR_TILE_X				ATTR_TILE_START
#define ATTR_TILE_Y				ATTR_TILE_START + 1
#define ATTR_TILE_SHARPNESS		ATTR_TILE_START + 2
#define ATTR_TILE_END			ATTR_TILE_SHARPNESS

#define ATTR_SOLAR_START		ATTR_TILE_END + 1
#define ATTR_SOLAR_THRES		ATTR_SOLAR_START
#define ATTR_SOLAR_INVERT		ATTR_SOLAR_START + 1
#define ATTR_SOLAR_END			ATTR_SOLAR_INVERT

#define ATTR_SHARPNESS_START	ATTR_SOLAR_END + 1
#define ATTR_SHARPNESS_TYPE		ATTR_SHARPNESS_START
#define ATTR_SHARPNESS_END		ATTR_SHARPNESS_TYPE

#define ATTR_RELIEF_START		ATTR_SHARPNESS_END + 1
#define ATTR_RELIEF_SOURCE		ATTR_RELIEF_START
#define ATTR_RELIEF_HEIGHT		ATTR_RELIEF_START + 1
#define ATTR_RELIEF_WIDTH		ATTR_RELIEF_START + 2
#define	ATTR_RELIEF_END			ATTR_RELIEF_WIDTH

#define	ATTR_SIZE_START			ATTR_RELIEF_END + 1
#define	ATTR_SIZE_PIXEL_X		ATTR_SIZE_START
#define ATTR_SIZE_PIXEL_Y		ATTR_SIZE_START + 1
#define ATTR_SIZE_MM_X			ATTR_SIZE_START + 2
#define ATTR_SIZE_MM_Y			ATTR_SIZE_START + 3
#define ATTR_SIZE_DEPTH			ATTR_SIZE_START + 4
#define ATTR_SIZE_INTERPOL		ATTR_SIZE_START + 5
#define ATTR_SIZE_END			ATTR_SIZE_INTERPOL

#define	ATTR_AGE_START			ATTR_SIZE_END + 1
#define	ATTR_AGE_VALUE			ATTR_AGE_START
#define ATTR_AGE_END			ATTR_AGE_VALUE

#define ATTR_POSTER_START		ATTR_AGE_END + 1
#define ATTR_POSTER_COLORS		ATTR_POSTER_START
#define	ATTR_POSTER_END			ATTR_POSTER_COLORS

#define	ATTR_DEF_START			ATTR_POSTER_END + 1
#define ATTR_DEF_ROTATE			ATTR_DEF_START
#define ATTR_DEF_SCALE_X       	ATTR_DEF_START + 1 
#define ATTR_DEF_SCALE_Y       	ATTR_DEF_START + 2
#define ATTR_DEF_RED            ATTR_DEF_START + 3
#define ATTR_DEF_GREEN          ATTR_DEF_START + 4
#define ATTR_DEF_BLUE           ATTR_DEF_START + 5
#define ATTR_DEF_BRIGHT			ATTR_DEF_START + 6
#define ATTR_DEF_CONTRAST		ATTR_DEF_START + 7
#define ATTR_DEF_BLACK_WHITE	ATTR_DEF_START + 8
#define ATTR_DEF_GRAY       	ATTR_DEF_START + 9
#define ATTR_DEF_MOSAIC_X		ATTR_DEF_START + 10
#define ATTR_DEF_MOSAIC_Y		ATTR_DEF_START + 11
#define ATTR_DEF_MOSAIC_SHARP	ATTR_DEF_START + 12
#define ATTR_DEF_AGE			ATTR_DEF_START + 13
#define ATTR_DEF_SOLAR_THRES	ATTR_DEF_START + 14
#define ATTR_DEF_SOLAR_INVERT	ATTR_DEF_START + 15
#define ATTR_DEF_POSTER			ATTR_DEF_START + 16
#define ATTR_DEF_TILE_X			ATTR_DEF_START + 17
#define ATTR_DEF_TILE_Y			ATTR_DEF_START + 18
#define ATTR_DEF_SHARP			ATTR_DEF_START + 19
#define ATTR_DEF_ROTATE_ORIENT	ATTR_DEF_START + 20
#define ATTR_DEF_ROTATE_END		ATTR_DEF_ROTATE_ORIENT

#define ATTR_PRINTOPT_START		ATTR_DEF_ROTATE_END + 1
#define ATTR_PRINTOPT_POSITION	ATTR_PRINTOPT_START
#define ATTR_PRINTOPT_WIDTH		ATTR_PRINTOPT_START + 1
#define ATTR_PRINTOPT_HEIGHT	ATTR_PRINTOPT_START + 2
#define	ATTR_PRINTOPT_DPI		ATTR_PRINTOPT_START + 3
#define ATTR_PRINTOPT_END		ATTR_PRINTOPT_DPI

// -----------------------------------------------------------------------------

#define ATTR_PNT_START			ATTR_PRINTOPT_END + 1

#define ATTR_PNT_LINE_START		ATTR_PNT_START
#define ATTR_PNT_LINE_WIDTH		ATTR_PNT_LINE_START
#define ATTR_PNT_LINE_ROUND		ATTR_PNT_LINE_START + 1
#define ATTR_PNT_LINE_STYLE		ATTR_PNT_LINE_START + 2
#define ATTR_PNT_LINE_END		ATTR_PNT_LINE_STYLE

#define ATTR_PNT_COLOR_START	ATTR_PNT_LINE_END + 1
#define ATTR_PNT_COLOR_FORE		ATTR_PNT_COLOR_START
#define ATTR_PNT_COLOR_BACK		ATTR_PNT_COLOR_START + 1
#define ATTR_PNT_COLOR_END		ATTR_PNT_COLOR_BACK

#define ATTR_PNT_AIR_START		ATTR_PNT_COLOR_END + 1
#define ATTR_PNT_AIR_INTENS		ATTR_PNT_AIR_START
#define ATTR_PNT_AIR_WIDTH		ATTR_PNT_AIR_START + 1
#define ATTR_PNT_AIR_END		ATTR_PNT_AIR_WIDTH

#define ATTR_PNT_PEN_START		ATTR_PNT_AIR_END + 1
#define ATTR_PNT_PEN_WIDTH		ATTR_PNT_PEN_START
#define ATTR_PNT_PEN_END		ATTR_PNT_PEN_WIDTH

#define ATTR_PNT_ALPHA_START		ATTR_PNT_PEN_END + 1
#define ATTR_PNT_LINE_TRANSPARENCY	ATTR_PNT_ALPHA_START
#define ATTR_PNT_FILL_TRANSPARENCY	ATTR_PNT_ALPHA_START + 1
#define ATTR_PNT_ALPHA_END			ATTR_PNT_FILL_TRANSPARENCY

#define ATTR_PNT_END			ATTR_PNT_ALPHA_END


#define ATTR_END				ATTR_PNT_END

#endif // _SIM_SIMATTR_HXX
