/*************************************************************************
 *
 *  $RCSfile: simdll.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_SIMDLL_HXX
#define _SIM_SIMDLL_HXX

#include <sfx2/sfxdefs.hxx>
#include <so3/embobj.hxx>
#include "simdll0.hxx"

class SfxMedium;
class OutputDevice;
class SfxFilter;
class SvInPlaceObjectRef;
class Window;
class Bitmap;
class Graphic;

#ifndef SO2_DECL_SVEMBEDDEDOBJECT_DEFINED
#define SO2_DECL_SVEMBEDDEDOBJECT_DEFINED
SO2_DECL_REF(SvEmbeddedObject)
#endif

#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif

#ifndef SO2_DECL_SVSTORAGESTREAM_DEFINED
#define SO2_DECL_SVSTORAGESTREAM_DEFINED
SO2_DECL_REF(SvStorageStream)
#endif

#define extern_c extern "C"

// ----------
// - SimDLL -
// ----------

class SvFactory;
class SimDrawDocShell;

class SimDLL
{
public:

					SimDLL();
					~SimDLL();

	// DLL-init/exit-code must be linked to the DLL only
    static void     Init();
    static void     Exit();

	// static-init/exit-code must be linked to the application
    static void     LibInit();
	static void     LibExit();

    static ULONG    DetectFilter( SfxMedium& rMedium, const SfxFilter **pFilter,
                                  SfxFilterFlags nMust, SfxFilterFlags nDont );

    static void     Update(SvInPlaceObjectRef aIPObj, OutputDevice* pOut);
    static void     Update(SvInPlaceObjectRef aIPObj, const Bitmap& rBitmap, OutputDevice* pOut);
	static Bitmap   GetBitmap(SvInPlaceObjectRef aIPObj);
    static void     Update(SvInPlaceObjectRef aIPObj, const Graphic& rGraphic, OutputDevice* pOut);
    static Graphic	GetGraphic(SvInPlaceObjectRef aIPObj);
	static void		ReplaceGraphic( SimDrawDocShell* pDocShell, Graphic* pGraphic );
};

/*************************************************************************
|*
|* Diese Funktionen werden aus der statischen
|* Schnittstelle (s.o.) nach dem Anziehen der DLL gerufen
|*
\************************************************************************/

extern_c void __LOADONCALLAPI SimUpdateClipbrd(SvInPlaceObjectRef aIPObj, OutputDevice* pOut);
extern_c void __LOADONCALLAPI SimUpdate(SvInPlaceObjectRef aIPObj, const Bitmap& rBitmap, OutputDevice* pOut);
extern_c void __LOADONCALLAPI SimGetBitmap(SvInPlaceObjectRef aIPObj, Bitmap* pBitmap);
extern_c void __LOADONCALLAPI SimUpdateGraphic(SvInPlaceObjectRef aIPObj, const Graphic& rGraphic, OutputDevice* pOut);
extern_c void __LOADONCALLAPI SimGetGraphic(SvInPlaceObjectRef aIPObj, Graphic* pGraphic);
extern_c void __LOADONCALLAPI SimReplaceGraphic( SimDrawDocShell* pDocShell, Graphic* pGraphic );

#endif // _SIM_SIMDLL_HXX
