/*************************************************************************
 *
 *  $RCSfile: svimage.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_SVIMAGE_HXX
#define _SIM_SVIMAGE_HXX

#include <vcl/salbtype.hxx>
#include "ibase.hxx"

// -----------------
// - class SvImage -
// -----------------

class SfxProgress;
class SfxViewFrame;
class Link;
class GDIMetaFile;
class Region;
class Color;

class SvImage : public IBase
{
private:

	BOOL			bLineSet;

					SvImage() {};

protected:

    BOOL    TransformLuminance(BYTE* pTransArray, ULONG nLast, SfxProgress* pProgress);
    BOOL    TransformLuminance(BYTE* pTransArray, const Rectangle& rDestRect, ULONG nLast, SfxProgress* pProgress);
    void    TransformPaletteLuminance( BYTE* pTransArray, BitmapPalette* pPal );
    BOOL    Convolute3(short* pMask, const short nDivisor, const BYTE cBias, ULONG nLast, SfxProgress* pProgress);
    BOOL    Convolute3(short* pMask, const short nDivisor, const BYTE cBias, const Rectangle& rDestRect, ULONG nLast, SfxProgress* pProgress);
    BOOL    Convolute5(BYTE* pMask, const short nDivisor, BYTE cBias, SfxViewFrame* pFrame);
    BOOL    Convolute5(BYTE* pMask, const short nDivisor, BYTE cBias, const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpEmboss(float fAzimuth, float fElevation, USHORT nWidth45, SfxViewFrame* pFrame );
    BOOL    ImpEmboss(float fAzimuth, float fElevation, USHORT nWidth45, const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpWarp(SfxViewFrame* pFrame);
    BOOL    ImpWarp(const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpScale(float fScaleX, float fScaleY, SfxViewFrame* pFrame);
    BOOL    ImpScaleFast(float fScaleX, float fScaleY, SfxViewFrame* pFrame);
    BOOL    ImpRotate90P(SfxViewFrame* pFrame);
    BOOL    ImpRotate90N(SfxViewFrame* pFrame);
    BOOL    ImpRotate180(SfxViewFrame* pFrame);
    BOOL    ImpRotate(float fAngle, const Color& rColor, SfxViewFrame* pFrame);
    BOOL    ImpMosaic(const Size& rPixelSize, SfxViewFrame* pFrame);
    BOOL    ImpMosaic(const Size& rPixelSize, const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpCharcoal(SfxViewFrame* pFrame);
    BOOL    ImpCharcoal(const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpRemoveNoise(SfxViewFrame* pFrame);
    BOOL    ImpRemoveNoise(const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpPoster(USHORT nColors, SfxViewFrame* pFrame);
    BOOL    ImpPoster(USHORT nColors, const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpPopart(SfxViewFrame* pFrame);
    BOOL    ImpPopart(const Rectangle& rDestRect, SfxViewFrame* pFrame);
    BOOL    ImpLuCo(float fLum, float fContr, SfxViewFrame* pFrame);
    BOOL    ImpLuCo(float fLum, float fContr, const Rectangle& rDestRect, SfxViewFrame* pFrame);
	
	void	ImplPaintRegion( const Region& rRegion, BYTE cMerge = 0 );
	void	ImplPaintPolyPolyLine( const PolyPolygon& rPolyPoly, BOOL bClose = FALSE, BYTE cMerge = 0 );
	void	ImplPaintMask( Bitmap& rMask, const Rectangle& rBound, BYTE cMerge = 0 );

			DECL_LINK( LineEnumHdl, Point* );
			DECL_LINK( MergeLineEnumHdl, Point* );


public:
            SvImage( const Bitmap& rBitmap );
            ~SvImage();

    // generelle Operationen
    BOOL    Undo(SfxProgress* pProgress = NULL) { return DoUndo(pProgress); }
    BOOL    Redo(SfxProgress* pProgress = NULL) { return DoRedo(pProgress); }

    // einfache Rasteroperationen
    BOOL    Invert(SfxViewFrame* pFrame = NULL);
    BOOL    Invert(const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Solarize(float fThres, BOOL bUpper, SfxViewFrame* pFrame = NULL);
    BOOL    Solarize(float fThres, BOOL bUpper, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Grayscale(USHORT nSteps, SfxViewFrame* pFrame = NULL);
    BOOL    Grayscale(USHORT nSteps, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Monochrome(float fLimit, BOOL bInvert, SfxViewFrame* pFrame = NULL);
    BOOL    Monochrome(float fLimit, BOOL bInvert, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    AdjustRGB(float fRed, float fGreen, float fBlue, SfxViewFrame* pFrame = NULL);
    BOOL    AdjustRGB(float fRed, float fGreen, float fBlue, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Sepia(float fSepia, SfxViewFrame* pFrame = NULL);
    BOOL    Sepia(float fSepia, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Crop(const Point& rOrg, const Size& rExt, SfxViewFrame* pFrame = NULL);
    BOOL    Mirror(BOOL bHorz, SfxViewFrame* pFrame = NULL);
    BOOL    Mirror(BOOL bHorz, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Pixellize(const Size& rPixelSize, SfxViewFrame* pFrame = NULL);
    BOOL    Pixellize(const Size& rPixelSize, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    InvertLuminance(const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    GammaCorrection(float fGamma, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    BandTransform(float fBegin1, float fEnd1, float fBegin2, float fEnd2, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    DitherRGBToMono(SfxViewFrame* pFrame = NULL);
    BOOL    DitherRGBTo16Gray(SfxViewFrame* pFrame = NULL);
    BOOL    DitherRGBTo16(SfxViewFrame* pFrame = NULL);
    BOOL    DitherRGBTo256(SfxViewFrame* pFrame = NULL);
    BOOL    Smooth(const BYTE cIntens, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Sharpen(const BYTE cIntens, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Emboss(float fAzimuth, float fElevation, USHORT nWidth45, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Scale(float fScaleX, float fScaleY, BOOL bFast, SfxViewFrame* pFrame = NULL);
    BOOL    Rotate(float fAngle, const Color& rColor, SfxViewFrame* pFrame = NULL);
    BOOL    Mosaic(const Size& rPixelSize, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Charcoal(const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    RemoveNoise(const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    Poster(USHORT nColors, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL );
    BOOL    Popart(const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
    BOOL    AdjustLu_Co(float fLum, float fContr, const Rectangle& rDestRect, SfxViewFrame* pFrame = NULL);
	BOOL	PaintMetaFileInProcessing( const GDIMetaFile& rMtf, BYTE cMerge = 0 );
	BOOL	PaintInProcessing( long nY, long nX, const Bitmap& rPaintBmp, const Bitmap& rMaskBmp, Bitmap* pRegionBmp = NULL );
	BOOL	PaintInProcessing( long nY, long nX, const Color& rPaintCol, const Bitmap& rMaskBmp, Bitmap* pRegionBmp = NULL );
};

#endif // _SIM_SVIMAGE_HXX
