/*************************************************************************
 *
 *  $RCSfile: ibase.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/new.hxx>
#include <tools/time.hxx>
#include <vcl/wrkwin.hxx>
#include <vcl/svapp.hxx>
#include <vcl/bmpacc.hxx>
#include <sfx2/progress.hxx>
#include "ibase.hxx"

// ------------------------------------------------------------------------

#define BGR12COL( B, G, R )	(((B) << 8) | ((G) << 4) | (R))

// ------------------------------------------------------------------------

BYTE cMap2[ 2 ] = { 0, 255 };
BYTE cMap6[ 6 ] = { 0, 51, 102, 153, 204, 255 };
BYTE cMap16[ 16 ] = { 0, 17, 34, 51, 68, 85, 102, 119, 136, 153, 170, 187, 204, 221, 238, 255 };

// ------------------------------------------------------------------------

USHORT nDither256[ 256 ] =
{
       0, 49152, 12288, 61440,  3072, 52224, 15360, 64512,   768, 49920, 13056,
   62208,  3840, 52992, 16128, 65280, 32768, 16384, 45056, 28672, 35840, 19456,
   48128, 31744, 33536, 17152, 45824, 29440, 36608, 20224, 48896, 32512, 8192,
   57344,  4096, 53248, 11264, 60416,  7168, 56320,  8960, 58112,  4864, 54016,
   12032, 61184,  7936, 57088, 40960, 24576, 36864, 20480, 44032, 27648, 39936,
   23552, 41728, 25344, 37632, 21248, 44800, 28416, 40704, 24320, 2048, 51200,
   14336, 63488,  1024, 50176, 13312, 62464,  2816, 51968, 15104, 64256,  1792,
   50944, 14080, 63232, 34816, 18432, 47104, 30720, 33792, 17408, 46080, 29696,
   35584, 19200, 47872, 31488, 34560, 18176, 46848, 30464, 10240, 59392,  6144,
   55296,  9216, 58368,  5120, 54272, 11008, 60160,  6912, 56064,  9984, 59136,
    5888, 55040, 43008, 26624, 38912, 22528, 41984, 25600, 37888, 21504, 43776,
   27392, 39680, 23296, 42752, 26368, 38656, 22272,   512, 49664, 12800, 61952,
    3584, 52736, 15872, 65024,   256, 49408, 12544, 61696,  3328, 52480, 15616,
   64768, 33280, 16896, 45568, 29184, 36352, 19968, 48640, 32256, 33024, 16640,
   45312, 28928, 36096, 19712, 48384, 32000,  8704, 57856,  4608, 53760, 11776,
   60928,  7680, 56832,  8448, 57600,  4352, 53504, 11520, 60672,  7424, 56576,
   41472, 25088, 37376, 20992, 44544, 28160, 40448, 24064, 41216, 24832, 37120,
   20736, 44288, 27904, 40192, 23808,  2560, 51712, 14848, 64000,  1536, 50688,
   13824, 62976,  2304, 51456, 14592, 63744,  1280, 50432, 13568, 62720, 35328,
   18944, 47616, 31232, 34304, 17920, 46592, 30208, 35072, 18688, 47360, 30976,
   34048, 17664, 46336, 29952, 10752, 59904,  6656, 55808,  9728, 58880,  5632,
   54784, 10496, 59648,  6400, 55552,  9472, 58624,  5376, 54528, 43520, 27136,
   39424, 23040, 42496, 26112, 38400, 22016, 43264, 26880, 39168, 22784, 42240,
   25856, 38144, 21760
};

// ------------------------------------------------------------------------

ULONG nLookUp[ 256 ] =
{
         0,  1286,  2572,  3858,  5144,  6430,  7716,  9002,
     10288, 11574, 12860, 14146, 15432, 16718, 18004, 19290,
     20576, 21862, 23148, 24434, 25720, 27006, 28292, 29578,
     30864, 32150, 33436, 34722, 36008, 37294, 38580, 39866,
     41152, 42438, 43724, 45010, 46296, 47582, 48868, 50154,
     51440, 52726, 54012, 55298, 56584, 57870, 59156, 60442,
     61728, 63014, 64300, 65586, 66872, 68158, 69444, 70730,
     72016, 73302, 74588, 75874, 77160, 78446, 79732, 81018,
     82304, 83590, 84876, 86162, 87448, 88734, 90020, 91306,
     92592, 93878, 95164, 96450, 97736, 99022,100308,101594,
    102880,104166,105452,106738,108024,109310,110596,111882,
    113168,114454,115740,117026,118312,119598,120884,122170,
    123456,124742,126028,127314,128600,129886,131172,132458,
    133744,135030,136316,137602,138888,140174,141460,142746,
    144032,145318,146604,147890,149176,150462,151748,153034,
    154320,155606,156892,158178,159464,160750,162036,163322,
    164608,165894,167180,168466,169752,171038,172324,173610,
    174896,176182,177468,178754,180040,181326,182612,183898,
    185184,186470,187756,189042,190328,191614,192900,194186,
    195472,196758,198044,199330,200616,201902,203188,204474,
    205760,207046,208332,209618,210904,212190,213476,214762,
    216048,217334,218620,219906,221192,222478,223764,225050,
    226336,227622,228908,230194,231480,232766,234052,235338,
    236624,237910,239196,240482,241768,243054,244340,245626,
    246912,248198,249484,250770,252056,253342,254628,255914,
    257200,258486,259772,261058,262344,263630,264916,266202,
    267488,268774,270060,271346,272632,273918,275204,276490,
    277776,279062,280348,281634,282920,284206,285492,286778,
    288064,289350,290636,291922,293208,294494,295780,297066,
    298352,299638,300924,302210,303496,304782,306068,307354,
    308640,309926,311212,312498,313784,315070,316356,317642,
    318928,320214,321500,322786,324072,325358,326644,327930
};

// ---------------
// - IBase -
// ---------------

IBase::IBase( const Bitmap &rBitmap )
{
	aInitBitmap = rBitmap;
    nWidth2 = nWidth3 = nWidth4 = nHeight2 = nHeight3 = nHeight4 = 0;
    nAlignedWidth2 = nAlignedWidth3 = nAlignedWidth4 = 0;
    bIsUndo = bIsRedo = FALSE;
    pPal1 = new BitmapPalette;
    pPal2 = new BitmapPalette;
    pPal3 = new BitmapPalette;
    pPal4 = new BitmapPalette;
    pArray1 = pOrgArray = pDestArray = NULL;
    pArray2 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( 1 * 24UL ) * 1 );
    pArray3 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( 1 * 24UL ) * 1 );
    pArray4 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( 1 * 24UL ) * 1 );
	nWhichOrg = 1;
	bValid = ImplConstruct();
	bInProcessing = FALSE;
	pSrcPointer = NULL;
	nSrcWidth = nSrcHeight = nSrcWidthAl = 0L;
}

// ------------------------------------------------------------------------

IBase::~IBase()
{
    if( pArray1 )
		SvMemFree( pArray1 );

    if( pArray2 )
		SvMemFree( pArray2 );

	if( pArray3 )
	    SvMemFree( pArray3 );

	if( pArray4 )
		SvMemFree( pArray4 );

	delete pPal1;
	delete pPal2;
	delete pPal3;
	delete pPal4;
}

// ------------------------------------------------------------------------

BOOL IBase::ImplConstruct()
{
	BitmapReadAccess*	pAcc = aInitBitmap.AcquireReadAccess();
	BOOL				bRet = FALSE;

	if( pAcc )
	{
		nWidth1 = pAcc->Width();
		nHeight1 = pAcc->Height();
		nAlignedWidth1 = AlignedWidth4Bytes( nWidth1 * 24L );

		if( pAcc->HasPalette() )
			*pPal1 = pAcc->GetPalette();
		else
			pPal1->SetEntryCount( 0 );

		nOrgDepth = nRedoDepth = nUndoDepth = pAcc->GetBitCount();
		aInitBitmap.ReleaseAccess( pAcc );
		bRet = TRUE;
	}

	nLastAccessTime = 0UL;

	return bRet;
}

// ------------------------------------------------------------------------

void IBase::ImplBitmapToArray24()
{
	if( !!aInitBitmap )
	{
		BitmapReadAccess* pAcc = aInitBitmap.AcquireReadAccess();

		if( pAcc )
		{
			pArray1 = (HPBYTE) SvMemAlloc( nAlignedWidth1 * nHeight1, MEM_NOCALLNEWHDL );
    
			if( pArray1 )
			{
				HPBYTE		pTmp;
				BitmapColor	aColor;
				long		i = 0, nWidth = (long) nWidth1;

				if( pAcc->HasPalette() )
				{
					for( long nY = nHeight1 - 1; nY >= 0L; nY-- )
					{
						pTmp = pArray1 + nAlignedWidth1 * i++;

						for( long nX = 0L; nX < nWidth; nX++ )
						{
							aColor = pAcc->GetPaletteColor( pAcc->GetPixel( nY, nX ) );
							*pTmp++ = aColor.GetBlue();
							*pTmp++ = aColor.GetGreen();
							*pTmp++ = aColor.GetRed();
						}
					}
				}
				else
				{
					for( long nY = nHeight1 - 1; nY >= 0L; nY-- )
					{
						pTmp = pArray1 + nAlignedWidth1 * i++;

						for( long nX = 0L; nX < nWidth; nX++ )
						{
							aColor = pAcc->GetPixel( nY, nX );
							*pTmp++ = aColor.GetBlue();
							*pTmp++ = aColor.GetGreen();
							*pTmp++ = aColor.GetRed();
						}
					}
				}
			}

			aInitBitmap.ReleaseAccess( pAcc );
			aInitBitmap = Bitmap();
		}
    }
}

// ------------------------------------------------------------------------

BOOL IBase::DoUndo( SfxProgress* pProgress )
{
	BOOL bRet = FALSE;

	nLastAccessTime = Time::GetSystemTicks();

    if( bIsUndo && pArray3 )
    {
		SvMemFree( pArray4 );
		delete pPal4;

        if( nWhichOrg == 1 )
        {
            pArray4 = pArray1;
			pPal4 = pPal1;
            nWidth4 = nWidth1;
            nHeight4 = nHeight1;
            nAlignedWidth4 = nAlignedWidth1;

            pSrcPointer = pOrgArray = pArray1 = pArray3;
			pPal1 = pPal3;
            nSrcWidth = nWidth1 = nWidth3;
            nSrcHeight = nHeight1 = nHeight3;
            nSrcWidthAl = nAlignedWidth1 = nAlignedWidth3;
        }
        else
        {	
            pArray4 = pArray2;
			pPal4 = pPal2;
            nWidth4 = nWidth2;
            nHeight4 = nHeight2;
            nAlignedWidth4 = nAlignedWidth2;

            pSrcPointer = pOrgArray = pArray2 = pArray3;
			pPal2 = pPal3;
            nSrcWidth = nWidth2 = nWidth3;
            nSrcHeight = nHeight2 = nHeight3;
            nSrcWidthAl = nAlignedWidth2 = nAlignedWidth3;
        }

        bIsUndo = FALSE;
        bIsRedo = TRUE;
        pArray3 = NULL;
		pPal3 = NULL;
        bRet = TRUE;
    }

	if( bRet )
		nOrgDepth = nUndoDepth;

    return bRet;
}

// ------------------------------------------------------------------------

BOOL IBase::DoRedo( SfxProgress* pProgress )
{
	BOOL bRet = FALSE;

	nLastAccessTime = Time::GetSystemTicks();

    if( bIsRedo && pArray4 )
    {
		SvMemFree( pArray3 );
		delete pPal3;

	    if( nWhichOrg == 1 )
	    {
			pArray3	= pArray1;
			pPal3 = pPal1;
	        nWidth3 = nWidth1;
	        nHeight3 = nHeight1;
	        nAlignedWidth3 = nAlignedWidth1;

            pSrcPointer = pOrgArray = pArray1 = pArray4;
			pPal1 = pPal4;
            nSrcWidth = nWidth1 = nWidth4;
            nSrcHeight = nHeight1 = nHeight4;
            nSrcWidthAl = nAlignedWidth1 = nAlignedWidth4;
	    }
	    else
	    {
			pArray3 = pArray2;
			pPal3 = pPal2;
	        nWidth3 = nWidth2;
	        nHeight3 = nHeight2;
	        nAlignedWidth3 = nAlignedWidth2;

            pSrcPointer = pOrgArray = pArray2 = pArray4;
			pPal2 = pPal4;
            nSrcWidth = nWidth2 = nWidth4;
            nSrcHeight = nHeight2 = nHeight4;
            nSrcWidthAl = nAlignedWidth2 = nAlignedWidth4;
	    }

		bIsUndo = TRUE;
	    bIsRedo = FALSE;
	    pArray4 = NULL;
		pPal4 = NULL;
	    bRet = TRUE;
    }

	if( bRet )
		nOrgDepth = nRedoDepth;

    return bRet;
}

// ------------------------------------------------------------------------

BOOL IBase::BeginProcessing( BOOL bUndo )
{
	long nWidth, nHeight;

	if( nWhichOrg == 1 )
		nWidth = nWidth1, nHeight = nHeight1;
	else
		nWidth = nWidth2, nHeight = nHeight2;

	return BeginProcessingExt( nWidth, nHeight, bUndo );
}

// ------------------------------------------------------------------------

BOOL IBase::BeginProcessingExt( ULONG nWidth, ULONG nHeight, BOOL bUndo )
{
	DBG_ASSERT( !IsInProcessing(), "Image is already processed!" );

	nLastAccessTime = Time::GetSystemTicks();

	if( !pArray1 )
		ImplBitmapToArray24();

	if( pArray4 )
	{
		SvMemFree( pArray4 );
		pArray4 = NULL;
	}

	if( pPal4 )
	{
		delete pPal4;
		pPal4 = NULL;
	}

    if( nWhichOrg == 1 )
    {
       	SvMemFree( pArray2 );
        pArray2 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( nWidth * 24UL ) * nHeight, MEM_NOCALLNEWHDL );

		delete pPal2;
		pPal2 = new BitmapPalette( *pPal1 );

		if( !pArray2 )
		{
		    pArray2 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( 1 * 24UL ) * 1 );
			nWidth2 = nHeight2 = nAlignedWidth2 = 0;
			pSrcPointer = pArray1;
			pDestArray = NULL;
			bInProcessing = FALSE;
		}
		else
		{
			pOrgArray = pArray1;
			pSrcPointer = pDestArray = pArray2;
			nSrcWidth = nWidth2 = nWidth;
			nSrcHeight = nHeight2 = nHeight;
			nSrcWidthAl = nAlignedWidth2 = AlignedWidth4Bytes( nWidth * 24L );
			bInProcessing = TRUE;
		}
    }
    else
    {
   		SvMemFree( pArray1 );
        pArray1 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( nWidth * 24UL ) * nHeight, MEM_NOCALLNEWHDL );

		delete pPal1;
		pPal1 = new BitmapPalette( *pPal2 );

		if( !pArray1 )
		{
		    pArray1 = (HPBYTE) SvMemAlloc( AlignedWidth4Bytes( 1 * 24UL ) * 1 );
			nWidth1 = nHeight1 = nAlignedWidth1 = 0;
			pSrcPointer = pArray2;
			pDestArray = NULL;
			bInProcessing = FALSE;
			bInProcessing = FALSE;
		}
		else
		{
			pOrgArray = pArray2;
			pSrcPointer = pDestArray = pArray1;
			nSrcWidth = nWidth1 = nWidth;
			nSrcHeight = nHeight1 = nHeight;
			nSrcWidthAl = nAlignedWidth1 = AlignedWidth4Bytes( nWidth * 24L );
			bInProcessing = TRUE;
		}
    }

    bCreateUndo = bUndo;

	if( bUndo )
		nRedoDepth = nUndoDepth = nOrgDepth;

    return( bInProcessing );
}

// ------------------------------------------------------------------------

void IBase::EndProcessing()
{
	DBG_ASSERT( IsInProcessing(), "Image is not processed!" );

    if( bCreateUndo && pArray3 )
    {
		SvMemFree( pArray3 );
		delete pPal3;
        pArray3 = NULL;
		pPal3 = NULL;
    }

    if( nWhichOrg == 1 )
    {
        nWhichOrg = 2;

        if( bCreateUndo )
        {
            pArray3 = pArray1;
			pPal3 = pPal1;
            nWidth3 = nWidth1;
            nHeight3 = nHeight1;
            nAlignedWidth3  = nAlignedWidth1;
            bIsUndo = TRUE;
            pArray1 = NULL;
			pPal1 = NULL;
        }
        else
        {
			SvMemFree( pArray1 );
			delete pPal1;
            pArray1 = NULL;
			pPal1 = NULL;
        }

		pSrcPointer = pOrgArray = pArray2;
		nSrcWidth = nWidth2;
		nSrcHeight = nHeight2;
		nSrcWidthAl = nAlignedWidth2;
    }
    else
    {
        nWhichOrg = 1;

        if( bCreateUndo )
        {
            pArray3 = pArray2;
			pPal3 = pPal2;
            nWidth3 = nWidth2;
            nHeight3 = nHeight2;
            nAlignedWidth3 = nAlignedWidth2;
            bIsUndo = TRUE;
            pArray2 = NULL;
			pPal2 = NULL;
        }
        else
        {
			SvMemFree( pArray2 );
			delete pPal2;
            pArray2 = NULL;
			pPal2 = NULL;
        }

		pSrcPointer = pOrgArray = pArray1;
		nSrcWidth = nWidth1;
		nSrcHeight = nHeight1;
		nSrcWidthAl = nAlignedWidth1;
    }

	pDestArray = NULL;
	bInProcessing = FALSE;
}

// ------------------------------------------------------------------------

Bitmap IBase::GetBitmap()
{
	Bitmap aBitmap;

	if( !!aInitBitmap )
		aBitmap = aInitBitmap;
	else
	{
		BitmapColor			aCol;
		BitmapWriteAccess*	pAcc = NULL;
		HPBYTE				pArray = GetSrcPointer();
		HPBYTE				pTmp;
		long				nWidth = GetSrcWidth();
		long				nHeight = GetSrcHeight();
		long				nAlignedWidth = GetSrcWidthAl();
		long				i = 0L, nY, nX;

		switch( nOrgDepth )
		{
			case( 24 ):
			{
				aBitmap = Bitmap( Size( nWidth, nHeight ), 24 );
				pAcc = aBitmap.AcquireWriteAccess();

				if( pAcc )
				{
					for( nY = nHeight - 1L; nY >= 0L; nY-- )
					{
						pTmp = pArray + nAlignedWidth * i++;

						for( nX = 0L; nX < nWidth; nX++ )
						{
							aCol.SetBlue( *pTmp++ );
							aCol.SetGreen( *pTmp++ );
							aCol.SetRed( *pTmp++ );
							pAcc->SetPixel( nY, nX, aCol );
						}
					}

					aBitmap.ReleaseAccess( pAcc );
				}
			}
			break;

			case( 4 ):
			case( 8 ):
			{
				long			nCols = 1 << nOrgDepth;
				BitmapPalette	aPal( (USHORT) nCols );
				long			nTmp;
				long			nIndex;
				long			nRed, nGreen, nBlue;
				long*			pOffs = new long[ 4096 ];
				BOOL*			pSet = new BOOL[ 4096 ];
				BOOL			bGray = TRUE;

				memset( pSet, 0, 4096 );

				// Farbeintraege des Bildes bestimmen( 256 Stueck )
				for( nY = 0L; nY < nHeight; nY++ )
				{
					pTmp = pArray + nAlignedWidth * nY;

					for( nX = 0L; nX < nWidth; nX++ )
					{
						if( bGray && ( pTmp[ 0 ] != pTmp[ 1 ] ||  pTmp[ 0 ] != pTmp[ 2 ] ) )
							bGray = FALSE;

						nBlue = (long) *pTmp++ >> 4;
						nGreen = (long) *pTmp++ >> 4;
						nRed = (long) *pTmp++ >> 4;

						nIndex = BGR12COL( nBlue, nGreen, nRed );
						
						if( !pSet[ nIndex ] )
						{
							pSet[ nIndex ] = TRUE;
							pOffs[ nIndex ] = pTmp - pArray - 3L;
						}
					}
				}

				if( bGray && ( nCols == 256 ) )
				{
					BitmapPalette	aGrayPal( 256 );
					BYTE			cCol = 0;

					for( USHORT nEntry = 0; nEntry < 256; cCol++ )
						aGrayPal[ nEntry++ ] = BitmapColor( cCol, cCol, cCol );

					// neue Bitmap mit Graustufen-Palette erzeugen
					aBitmap = Bitmap( Size( nWidth, nHeight ), 8, &aGrayPal );
					pAcc = aBitmap.AcquireWriteAccess();

					if( pAcc )
					{
						// Graustufenindizes setzen
						for( nY = nHeight - 1L; nY >= 0L; nY-- )
							for( nX = 0, pTmp = pArray + nAlignedWidth * i++; nX < nWidth; nX++, pTmp += 3 )
								pAcc->SetPixel( nY, nX, *pTmp );

						aBitmap.ReleaseAccess( pAcc );
					}
				}
				else
				{
					// Die ersten (maximal 16/256) gesetzten Eintraege auslesen
					// und von 'vorne' in die Palette setzen; somit
					// haben wir ggf. am Ende der Palette immer noch 
					// ein paar Standardfarben zur Verfuegung
					for( nX = 0, nTmp = 0; ( nX < 4096 ) && ( nTmp < nCols ); nX++ )
					{
						if( pSet[ nX ] )
						{
							BitmapColor& rPalCol = aPal[ (USHORT) nTmp ];
							
							pTmp = pArray + pOffs[ nX ];
							rPalCol.SetBlue( *pTmp++ );
							rPalCol.SetGreen( *pTmp++ );
							rPalCol.SetRed( *pTmp );

							// alte Offset-Zelle indiziert jetzt die Tabelle
							pOffs[ nX ] = nTmp++;
						}
					}

					// ans Ende der Palette noch so viele Standardfarben wie moeglich setzen
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_BLACK );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_BLUE );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_GREEN );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_CYAN );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_RED );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_MAGENTA );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_BROWN );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_GRAY );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTGRAY );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTBLUE );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTGREEN );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTCYAN );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTRED );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_LIGHTMAGENTA );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_YELLOW );
					if( nTmp < nCols )
						aPal[ (USHORT) nTmp++ ] = Color( COL_WHITE );

					// neue Bitmap erzeugen
					aBitmap = Bitmap( Size( nWidth, nHeight ), ( nCols == 16 ) ? 4 : 8, &aPal );
					pAcc = aBitmap.AcquireWriteAccess();

					// Pixel in neuer Bitmap setzen
					if( pAcc )
					{
						// Indizes setzen
						for( nY = nHeight - 1L; nY >= 0L; nY-- )
						{
							pTmp = pArray + nAlignedWidth * i++;

							for( nX = 0; nX < nWidth; nX++ )
							{
								nBlue = (ULONG) *pTmp++ >> 4;
								nGreen = (ULONG) *pTmp++ >> 4;
								nRed = (ULONG) *pTmp++ >> 4;
								pAcc->SetPixel( nY, nX, (BYTE) pOffs[ BGR12COL( nBlue, nGreen, nRed ) ] );
							}
						}

						aBitmap.ReleaseAccess( pAcc );
					}
				}

				delete[] pOffs;
				delete[] pSet;
			}
			break;

			case( 1 ):
			{
				aBitmap = Bitmap( Size( nWidth, nHeight ), 1 );
				pAcc = aBitmap.AcquireWriteAccess();

				if( pAcc )
				{
					long				nRed, nGreen, nBlue;
					const BitmapColor	aBlack( pAcc->GetBestMatchingColor( Color( COL_BLACK ) ) );
					const BitmapColor	aWhite( pAcc->GetBestMatchingColor( Color( COL_WHITE ) ) );

					// Pixel in neuer Bitmap setzen
					for( nY = nHeight - 1L; nY >= 0L; nY-- )
					{
						pTmp = pArray + nAlignedWidth * i++;

						for( nX = 0; nX < nWidth; nX++ )
						{
							nBlue = *pTmp++;
							nGreen = *pTmp++;
							nRed= *pTmp++;

							if( ( nRed > 127 ) || ( nGreen > 127 ) || ( nBlue > 127 ) )
								pAcc->SetPixel( nY, nX, aWhite );
							else
								pAcc->SetPixel( nY, nX, aBlack );
						}
					}

					aBitmap.ReleaseAccess( pAcc );
				}
			}
			break;
		}
	}

	return aBitmap;
}
