/*************************************************************************
 *
 *  $RCSfile: svcharc.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "svimage.hxx"
#include <sfx2/progress.hxx>
#include <sfx2/viewfrm.hxx>
#include "simresid.hxx"
#include "strings.hrc"

/******************************************************************************/

BOOL SvImage::ImpCharcoal(SfxViewFrame* pFrame)
{
	USHORT	nWidth;
	USHORT	nHeight;
	USHORT	nWidth2;
	USHORT	nHeight2;
	USHORT	nX;
	USHORT	nY;
	ULONG	nAlignedWidth;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE 	pTempOrg;
	HPBYTE 	pTempDest;
	HPBYTE	pNear;
	HPBYTE	p1;
	HPBYTE	p2;
	HPBYTE	p3;
	long	nSum1;
	long	nSum2;
	long	nGray;
	BYTE	cGray;
	ULONG	nOff;
	short	nMask111 = -1, nMask121 = 0, nMask131 = 1;
	short	nMask211 = -2, nMask221 = 0, nMask231 = 2;
	short	nMask311 = -1, nMask321 = 0, nMask331 = 1;
	short	nMask112 =  1, nMask122 =  2, nMask132 =  1;
	short	nMask212 =  0, nMask222 =  0, nMask232 =  0;
	short	nMask312 = -1, nMask322 = -2, nMask332 = -1;

	nWidth = (USHORT)GetOrgWidth();
	nHeight = (USHORT)GetOrgHeight();
	nAlignedWidth = GetOrgAlignedWidth();

	if ((nWidth < 3) || (nHeight < 3))
		return FALSE;

	// Pseudo-Array mit reinen Luminanzwerten erzeugen
	if (BeginProcessing())
	{
		pOrgArray		= GetOrgPointer();
		pDestArray		= GetDestPointer();

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_CHARC), (ULONG)nHeight*3);

		for (nY = 0; nY < nHeight; nY++)
		{
			nOff = (ULONG)nY*nAlignedWidth;
			pTempOrg	= pOrgArray + nOff;
			pTempDest 	= pDestArray + nOff;

			for (nX = 0; nX < nWidth; nX++)
			{
				*pTempDest = (BYTE)((((UINT16)(*pTempOrg) * 28 +
						  	 		(UINT16)(*(pTempOrg + 1)) * 151 +
									(UINT16)(*(pTempOrg + 2)) * 77) &
									0xFF00) >> 8);
				pTempOrg 	+= 3;
				pTempDest	+= 3;
			}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}

		EndProcessing();


		// Sobel-Filterung
		nWidth2 	= nWidth - 2;
		nHeight2	= nHeight - 1;

		// EIP einleiten
		if (BeginProcessing(FALSE))
		{
			pOrgArray = GetOrgPointer();
			pDestArray= GetDestPointer();

			pTempOrg = pOrgArray;

			// Zeilenschleife
			for (nY = 1; nY < nHeight2; nY++)
			{
				pTempDest = pDestArray + nAlignedWidth*(ULONG)nY + 3;

				// Spaltenschleife
				for (nX = 0; nX < nWidth2; nX++)
				{
					nSum1 = nSum2 = 0;

					p1 = pTempOrg + (ULONG)nX * 3;
					p2 = p1 + nAlignedWidth;
					p3 = p2 + nAlignedWidth;


					// 1. Faltungszeile (je drei Elemente)
					cGray = *p1;
					nSum1 += nMask111 * cGray;
					nSum2 += nMask112 * cGray;
					p1 += 3;

					cGray = *p1;
					nSum1 += nMask121 * cGray;
					nSum2 += nMask122 * cGray;
					p1 += 3;

					cGray = *p1;
					nSum1 += nMask131 * cGray;
					nSum2 += nMask132 * cGray;


					// 2. Faltungszeile (je drei Elemente)
					cGray = *p2;
					nSum1 += nMask211 * cGray;
					nSum2 += nMask212 * cGray;
					p2 += 3;

					cGray = *p2;
					nSum1 += nMask221 * cGray;
					nSum2 += nMask222 * cGray;
					p2 += 3;

					cGray = *p2;
					nSum1 += nMask231 * cGray;
					nSum2 += nMask232 * cGray;


					// 3. Faltungszeile (je drei Elemente)
					cGray = *p3;
					nSum1 += nMask311 * cGray;
					nSum2 += nMask312 * cGray;
					p3 += 3;

					cGray = *p3;
					nSum1 += nMask321 * cGray;
					nSum2 += nMask322 * cGray;
					p3 += 3;

					cGray = *p3;
					nSum1 += nMask331 * cGray;
					nSum2 += nMask332 * cGray;

					nGray = (long) sqrt((double)(nSum1*nSum1 + nSum2*nSum2));
					cGray = ~(BYTE) VOS_BOUND(nGray, 0, 255);

					*pTempDest++ = cGray;
					*pTempDest++ = cGray;
					*pTempDest++ = cGray;
				}

				pTempOrg += nAlignedWidth;

				if (!(nY%4))
					aProgress.SetState((ULONG)nHeight + nY);
			}


			// Umrandung mit Nachbarpixeln fuellen
			// links
			pTempDest 	= pDestArray + nAlignedWidth;
			pNear		= pTempDest + 3;
			for (nY = 1; nY < nHeight2; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest + 3;
			}
			// rechts
			pTempDest 	= pDestArray + nAlignedWidth + 3*(ULONG)(nWidth-1);
			pNear		= pTempDest - 3;
			for (nY = 1; nY < nHeight2; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest - 3;	
			}
			// oben
			pTempDest 	= pDestArray;
			pNear		= pTempDest + nAlignedWidth;
			for (nX = 0; nX < nAlignedWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}
			// unten
			pTempDest 	= pDestArray + (ULONG)nHeight2*nAlignedWidth;
			pNear		= pTempDest	- nAlignedWidth;
			for (nX = 0; nX < nAlignedWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}

			EndProcessing();
			*GetPalette() = Bitmap::GetGreyPalette( 256 );
			
			return TRUE;
		}
	}

	return FALSE;
}


/******************************************************************************/


BOOL SvImage::ImpCharcoal(const Rectangle& rDestRect, SfxViewFrame* pFrame)
{
	USHORT	nWidth = (USHORT) GetOrgWidth();
	USHORT	nHeight = (USHORT)GetOrgHeight();
	USHORT	nX;
	USHORT	nY;
	ULONG	nAlignedWidth = GetOrgAlignedWidth();
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE 	pTempOrg;
	HPBYTE 	pTempDest;
	HPBYTE	p1;
	HPBYTE	p2;
	HPBYTE	p3;
	HPBYTE	pNear;
	long	nSum1;
	long	nSum2;
	long	nGray;
	BYTE	cGray;
	ULONG	nOff;
	ULONG	nOff2;
	ULONG	nXOff;
	ULONG	nYOff;
	short	nMask111 = -1, nMask121 = 0, nMask131 = 1;
	short	nMask211 = -2, nMask221 = 0, nMask231 = 2;
	short	nMask311 = -1, nMask321 = 0, nMask331 = 1;
	short	nMask112 =  1, nMask122 =  2, nMask132 =  1;
	short	nMask212 =  0, nMask222 =  0, nMask232 =  0;
	short	nMask312 = -1, nMask322 = -2, nMask332 = -1;

	if ((nWidth < 3) || (nHeight < 3))
		return FALSE;

	if (BeginProcessing())
	{
		Point aDefPoint;

		pOrgArray = GetOrgPointer();
		pDestArray = GetDestPointer();

		Rectangle 	aSelRect(aDefPoint, Size(nWidth, nHeight)); 
		Rectangle	aOrgRect(Point(1, 1), Size(nWidth - 2, nHeight - 2));
		Rectangle&	rInterRect = aOrgRect.Intersection(rDestRect);

		aSelRect.Intersection(rDestRect);

		nXOff = 3 * (ULONG)(rInterRect.Left() - 1);
		nYOff = (ULONG)nHeight - (ULONG)rInterRect.Top() - (ULONG)rInterRect.GetHeight() - 1;
		nOff2 = nAlignedWidth + 3;

		// altes Array komplett kopieren
		HMEMCPY(pDestArray, pOrgArray, GetOrgAlignedWidth()*(ULONG)nHeight);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_CHARC), nHeight + rInterRect.GetHeight());

		// Operation auf Rectangle anwenden
		nWidth = (USHORT)rInterRect.GetWidth();
		nHeight = (USHORT)rInterRect.GetHeight();
		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();

		// Zeilenschleife
		for (nY = 0; nY < nHeight; nY++)
		{
			nOff = (nYOff + nY)*nAlignedWidth + nXOff;
			pTempOrg = pOrgArray + nOff;
			pTempDest= pDestArray + nOff + nOff2;

			// Spaltenschleife
			for (nX = 0; nX < nWidth; nX++)
			{
				nSum1 = nSum2 = 0;

				p1 = pTempOrg + (ULONG)nX * 3;
				p2 = p1 + nAlignedWidth;
				p3 = p2 + nAlignedWidth;


				// 1. Faltungszeile (je drei Elemente)
				cGray = (BYTE)((((UINT16)(*p1) * 28 +
					  	 		(UINT16)(*(p1 + 1)) * 151 +
								(UINT16)(*(p1 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask111 * cGray;
				nSum2 += nMask112 * cGray;
				p1 += 3;

				cGray = (BYTE)((((UINT16)(*p1) * 28 +
					  	 		(UINT16)(*(p1 + 1)) * 151 +
								(UINT16)(*(p1 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask121 * cGray;
				nSum2 += nMask122 * cGray;
				p1 += 3;

				cGray = (BYTE)((((UINT16)(*p1) * 28 +
					  	 		(UINT16)(*(p1 + 1)) * 151 +
								(UINT16)(*(p1 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask131 * cGray;
				nSum2 += nMask132 * cGray;

				// 2. Faltungszeile (je drei Elemente)
				cGray = (BYTE)((((UINT16)(*p2) * 28 +
					  	 		(UINT16)(*(p2 + 1)) * 151 +
								(UINT16)(*(p2 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask211 * cGray;
				nSum2 += nMask212 * cGray;
				p2 += 3;

				cGray = (BYTE)((((UINT16)(*p2) * 28 +
					  	 		(UINT16)(*(p2 + 1)) * 151 +
								(UINT16)(*(p2 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask221 * cGray;
				nSum2 += nMask222 * cGray;
				p2 += 3;

				cGray = (BYTE)((((UINT16)(*p2) * 28 +
					  	 		(UINT16)(*(p2 + 1)) * 151 +
								(UINT16)(*(p2 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask231 * cGray;
				nSum2 += nMask232 * cGray;


				// 3. Faltungszeile (je drei Elemente)
				cGray = (BYTE)((((UINT16)(*p3) * 28 +
					  	 		(UINT16)(*(p3 + 1)) * 151 +
								(UINT16)(*(p3 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask311 * cGray;
				nSum2 += nMask312 * cGray;
				p3 += 3;

				cGray = (BYTE)((((UINT16)(*p3) * 28 +
					  	 		(UINT16)(*(p3 + 1)) * 151 +
								(UINT16)(*(p3 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask321 * cGray;
				nSum2 += nMask322 * cGray;
				p3 += 3;

				cGray = (BYTE)((((UINT16)(*p3) * 28 +
					  	 		(UINT16)(*(p3 + 1)) * 151 +
								(UINT16)(*(p3 + 2)) * 77) &
								0xFF00) >> 8);
				nSum1 += nMask331 * cGray;
				nSum2 += nMask332 * cGray;

				nGray = (long) sqrt((double)(nSum1*nSum1 + nSum2*nSum2));
				cGray = ~(BYTE) VOS_BOUND(nGray, 0, 255);

				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
			}

			if (!(nY%4))
				aProgress.SetState((ULONG)nY+1);
		}


		// Umrandung mit Nachbarpixeln fuellen, falls Selektion am Rand liegt
		// links
		long nYOff2 = GetOrgHeight() - aSelRect.Top() - aSelRect.GetHeight();
		long nXOff2 = 3 * aSelRect.Left();
		if (!aSelRect.Left())
		{
			USHORT nRectHeight = (USHORT) aSelRect.GetHeight();

			pTempDest 	= pDestArray + (nYOff2 * nAlignedWidth);
			pNear		= pTempDest + 3;
			
			for (nY = 0; nY < nRectHeight; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest + 3;
			}
		}
		// rechts
		if ((USHORT) aSelRect.Right() == (GetOrgWidth() - 1))
		{
			USHORT nRectHeight = (USHORT) aSelRect.GetHeight();

			pTempDest 	= pDestArray + (nYOff2 * nAlignedWidth) + 
						  3*(ULONG)(GetOrgWidth()-1);
			pNear		= pTempDest - 3;
			for (nY = 0; nY < nRectHeight; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest - 3;	
			}
		}
		// oben
		if (!aSelRect.Top())
		{
			USHORT nRectWidth = (USHORT) aSelRect.GetWidth()*3;

			pTempDest 	= pDestArray + (GetOrgHeight() - 1)*nAlignedWidth + nXOff2;
			pNear		= pTempDest	- nAlignedWidth;
			for (nX = 0; nX < nRectWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}
		}
		// unten
		if ((USHORT) aSelRect.Bottom() == (GetOrgHeight() - 1))
		{
			USHORT nRectWidth = (USHORT) aSelRect.GetWidth()*3;

			pTempDest 	= pDestArray + nXOff2;
			pNear		= pTempDest + nAlignedWidth;
			for (nX = 0; nX < nRectWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}
		}

		EndProcessing();
		GetPalette()->SetEntryCount( 0 );

		return TRUE;
	}

	return FALSE;
}
