/*************************************************************************
 *
 *  $RCSfile: svemboss.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "svimage.hxx"
#include <sfx2/progress.hxx>
#include <sfx2/viewfrm.hxx>
#include "simresid.hxx"
#include "strings.hrc"

/******************************************************************************/


#define SV_PI 3.14159265359
#define GRAY(p) ((((UINT16)*(p) * 28 + (UINT16)*((p) + 1) * 151 + (UINT16)*((p) + 2) * 77) & 0xFF00) >> 8)

BOOL SvImage::ImpEmboss( float fAzimuth, float fElevation, USHORT nWidth45,
						 SfxViewFrame* pFrame )
{
	USHORT	nWidth = (USHORT) GetOrgWidth();
	USHORT	nHeight = (USHORT) GetOrgHeight();
	ULONG	nAlignedWidth = GetOrgAlignedWidth();
	BOOL	bRet = FALSE;

	if( ( nWidth < 3 ) || ( nHeight < 3 ) )
		return FALSE;

	// EIP einleiten
	if( BeginProcessing() )
	{
		USHORT	nWidth2;
		USHORT	nHeight2;
		USHORT	nX;
		USHORT	nY;
		HPBYTE 	pOrgArray;
		HPBYTE 	pDestArray;
		HPBYTE 	pTempOrg;
		HPBYTE 	pTempDest;
		HPBYTE	pNear;
		short 	nNx, nNy, nNz;
		long	nLx, nLy, nLz;
		long	nZ2, nNzLz, nDotL;
		HPBYTE	p1;
		HPBYTE	p2;
		HPBYTE	p3;
		double	fTemp;
		BYTE	cGray;

		nWidth2 = nWidth - 2;
		nHeight2 = nHeight - 1;
		pTempOrg = pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();
		fAzimuth *= (float)SV_PI / 180.F;
		fElevation *= (float)SV_PI / 180.F;
		nLx = (long)(cos(fAzimuth) * cos(fElevation) * 255.9F);
		nLy = (long)(sin(fAzimuth) * cos(fElevation) * 255.9F);
		nLz = (long)(sin(fElevation) * 255.9F);
		nNz = 1530 / nWidth45;
		nZ2 = (long)nNz * (long)nNz;
		nNzLz = (long)nNz * (long)nLz;

        SfxProgress aProgress( pFrame->GetObjectShell(), SimResId(STR_STAT_EMBOSS), nHeight << 1 );

		// Zeilenschleife
		for( nY = 1; nY < nHeight2; nY++ )
		{
			pTempDest = pDestArray + nAlignedWidth*(ULONG)nY + 3;

			// Spaltenschleife
			for (nX = 0; nX < nWidth2; nX++)
			{
				p1 = pTempOrg + (ULONG)nX*3;
				p2 = p1 + nAlignedWidth;
				p3 = p2 + nAlignedWidth;

				nNx = (short) (GRAY(p1) + GRAY(p2) + GRAY(p3));
				nNy = (short) (GRAY(p3) + GRAY(p3+3) + GRAY(p3+6) -
							   GRAY(p1) - GRAY(p1+3) - GRAY(p1+6));
				p1 += 6;
				p2 += 6;
				p3 += 6;
				nNx -= (short) (GRAY(p1) + GRAY(p2) + GRAY(p3));

				fTemp = (nNx==0 && nNy==0) ? nLz :
						((nDotL = nNx*nLx + nNy*nLy + nNz*nLz) < 0) ? 0 :
				   		nDotL / sqrt(nNx*nNx + nNy*nNy + nZ2 + .00001);
				cGray = (BYTE) VOS_BOUND(fTemp, 0.F, 255.F);

				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
			}

			pTempOrg += nAlignedWidth;

			if( !( nY % 4 ) )
				aProgress.SetState( nY+1 );
		}


		// Umrandung mit Nachbarpixeln fuellen
		// links
		pTempDest 	= pDestArray + nAlignedWidth;
		pNear		= pTempDest + 3;
		for (nY = 1; nY < nHeight2; nY++)
		{
			pTempDest[0]	= *pNear++;
			pTempDest[1]	= *pNear++;
			pTempDest[2]	= *pNear;

			pTempDest += nAlignedWidth;
			pNear	   = pTempDest + 3;
		}
		// rechts
		pTempDest 	= pDestArray + nAlignedWidth + 3*(ULONG)(nWidth-1);
		pNear		= pTempDest - 3;
		for (nY = 1; nY < nHeight2; nY++)
		{
			pTempDest[0]	= *pNear++;
			pTempDest[1]	= *pNear++;
			pTempDest[2]	= *pNear;

			pTempDest += nAlignedWidth;
			pNear	   = pTempDest - 3;
		}
		// oben
		pTempDest 	= pDestArray;
		pNear		= pTempDest + nAlignedWidth;
		for (nX = 0; nX < nAlignedWidth; nX++)
		{
			*pTempDest++ = *pNear++;
		}
		// unten
		pTempDest 	= pDestArray + (ULONG)nHeight2*nAlignedWidth;
		pNear		= pTempDest	- nAlignedWidth;
		for (nX = 0; nX < nAlignedWidth; nX++)
		{
			*pTempDest++ = *pNear++;
		}

		// EIP beenden
		EndProcessing();
		*GetPalette() = Bitmap::GetGreyPalette( 256 );

		bRet = TRUE;
	}

	return bRet;
}

/******************************************************************************/

BOOL SvImage::ImpEmboss(float fAzimuth, float fElevation, USHORT nWidth45,
						const Rectangle& rDestRect, SfxViewFrame* pFrame)
{
	USHORT	nWidth = (USHORT) GetOrgWidth();
	USHORT	nHeight = (USHORT) GetOrgHeight();
	ULONG	nAlignedWidth = GetOrgAlignedWidth();
	BOOL	bRet = FALSE;

	if( ( nWidth < 3 ) || ( nHeight < 3 ) )
		return FALSE;

	// EIP einleiten
	if( BeginProcessing() )
	{
		USHORT	nX;
		USHORT	nY;
		HPBYTE 	pOrgArray;
		HPBYTE 	pDestArray;
		HPBYTE 	pTempOrg;
		HPBYTE 	pTempDest;
		short 	nNx, nNy, nNz;
		long	nLx, nLy, nLz;
		long	nZ2, nNzLz, nDotL;
		HPBYTE	p1;
		HPBYTE	p2;
		HPBYTE	p3;
		HPBYTE	pNear;
		double	fTemp;
		BYTE	cGray;
		ULONG	nOff;
		ULONG	nOff2;
		ULONG	nXOff;
		ULONG	nYOff;

		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();

		static Point aDefPoint;
		Rectangle 	aSelRect(aDefPoint, Size(nWidth, nHeight)); 
		Rectangle	aOrgRect(Point(1, 1), Size(nWidth - 2, nHeight - 2));
		Rectangle&	rInterRect = aOrgRect.Intersection(rDestRect);

		aSelRect.Intersection(rDestRect);

		nXOff	= 3 * (ULONG)(rInterRect.Left() - 1);
		nYOff 	= 	(ULONG)nHeight -
					(ULONG)rInterRect.Top() -
					(ULONG)rInterRect.GetHeight() - 1;
		nOff2	=	nAlignedWidth + 3;

		// altes Array komplett kopieren
		HMEMCPY(pDestArray, pOrgArray, GetOrgAlignedWidth()*(ULONG)nHeight);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_EMBOSS), nHeight + rInterRect.GetHeight());


		// Operation auf Rectangle anwenden
		nWidth 	= (USHORT)rInterRect.GetWidth();
		nHeight = (USHORT)rInterRect.GetHeight();

   		fAzimuth 	*= (float)SV_PI / 180.F;
		fElevation	*= (float)SV_PI / 180.F;

		nLx = (long)(cos(fAzimuth) * cos(fElevation) * 255.9F);
		nLy = (long)(sin(fAzimuth) * cos(fElevation) * 255.9F);
		nLz = (long)(sin(fElevation) * 255.9F);

		nNz 	= 1530 / nWidth45;
		nZ2 	= (long)nNz * (long)nNz;
		nNzLz 	= (long)nNz * (long)nLz;

		pTempOrg = pOrgArray;

		// Zeilenschleife
		for (nY = 0; nY < nHeight; nY++)
		{
			nOff = (nYOff + nY)*nAlignedWidth + nXOff;
			pTempOrg = pOrgArray + nOff;
			pTempDest= pDestArray + nOff + nOff2;

			// Spaltenschleife
			for (nX = 0; nX < nWidth; nX++)
			{

				p1 = pTempOrg + (ULONG)nX*3;
				p2 = p1 + nAlignedWidth;
				p3 = p2 + nAlignedWidth;

				nNx = (short) (GRAY(p1) + GRAY(p2) + GRAY(p3));
				nNy = (short) (GRAY(p3) + GRAY(p3+3) + GRAY(p3+6) -
							   GRAY(p1) - GRAY(p1+3) - GRAY(p1+6));
				p1 += 6;
				p2 += 6;
				p3 += 6;
				nNx -= (short) (GRAY(p1) + GRAY(p2) + GRAY(p3));

				fTemp = (nNx==0 && nNy==0) ? nLz :
					    ((nDotL = nNx*nLx + nNy*nLy + nNz*nLz) < 0) ? 0 :
					   	nDotL / sqrt(nNx*nNx + nNy*nNy + nZ2 + .00001);
				cGray = (BYTE) VOS_BOUND( fTemp, 0.F, 255.F);

				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
				*pTempDest++ = cGray;
			}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}


		// Umrandung mit Nachbarpixeln fuellen, falls Selektion am Rand liegt
		// links
		long nYOff2 = GetOrgHeight() - aSelRect.Top() - aSelRect.GetHeight();
		long nXOff2 = 3 * aSelRect.Left();
		if (!aSelRect.Left())
		{
			USHORT nRectHeight = (USHORT) aSelRect.GetHeight();

			pTempDest 	= pDestArray + (nYOff2 * nAlignedWidth);
			pNear		= pTempDest + 3;
			
			for (nY = 0; nY < nRectHeight; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest + 3;
			}
		}
		// rechts
		if ((USHORT) aSelRect.Right() == (GetOrgWidth() - 1))
		{
			USHORT nRectHeight = (USHORT) aSelRect.GetHeight();

			pTempDest 	= pDestArray + (nYOff2 * nAlignedWidth) + 
						  3*(ULONG)(GetOrgWidth()-1);
			pNear		= pTempDest - 3;
			for (nY = 0; nY < nRectHeight; nY++)
			{
				pTempDest[0]	= *pNear++;
				pTempDest[1]	= *pNear++;
				pTempDest[2]	= *pNear;

				pTempDest += nAlignedWidth;
				pNear	   = pTempDest - 3;	
			}
		}
		// oben
		if (!aSelRect.Top())
		{
			USHORT nRectWidth = (USHORT) aSelRect.GetWidth()*3;

			pTempDest 	= pDestArray + (GetOrgHeight() - 1)*nAlignedWidth + nXOff2;
			pNear		= pTempDest	- nAlignedWidth;
			for (nX = 0; nX < nRectWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}
		}
		// unten
		if ((USHORT) aSelRect.Bottom() == (GetOrgHeight() - 1))
		{
			USHORT nRectWidth = (USHORT) aSelRect.GetWidth()*3;

			pTempDest 	= pDestArray + nXOff2;
			pNear		= pTempDest + nAlignedWidth;
			for (nX = 0; nX < nRectWidth; nX++)
			{
				*pTempDest++ = *pNear++;
			}
		}

		EndProcessing();
		GetPalette()->SetEntryCount( 0 );
		bRet = TRUE;
	}

	return bRet;
}
