/*************************************************************************
 *
 *  $RCSfile: svluco.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "svimage.hxx"
#include <sfx2/progress.hxx>
#include <sfx2/viewfrm.hxx>
#include "simresid.hxx"
#include "strings.hrc"

/******************************************************************************/

#define GRAYVAL( nB, nG, nR )	( (BYTE) ( ( (nB)*28L + (nG)*151L + (nR)*77L ) >> 8 ) )

/******************************************************************************/

// erack! 02.05.95 15:44 - internal compiler error
#if defined( MSC ) && defined( WNT )
#pragma optimize("g",off)
#endif

BOOL SvImage::ImpLuCo(float fContr, float fLum, SfxViewFrame* pFrame)
{
	USHORT	nY;
	USHORT	nX;
	USHORT	nWidth;
	USHORT	nHeight;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	BYTE	cValue;
	BYTE	cTempB;
	BYTE	cTempG;
	BYTE	cTempR;
	USHORT	i;
	float	fM;
	float	fB;
	BYTE*	pArray;
	INT16*	pModArray;
	INT16	nOff;
	BOOL	bCond;
	ULONG	nCond;

	// EIP einleiten
	if (BeginProcessing())
	{
		pArray = (BYTE*) new BYTE[256];
		pModArray = (INT16*) new INT16[256];
		fLum *= 1.28F;
		fM = 1.0F + fContr * 0.005F;
		fB = 127.5F * (1.F - fM);

		for( i=0; i < 256; i++ )
		{
			pArray[i] = (BYTE) VOS_BOUND(fM * (float)i + fB, 0.F, 255.F);
			cValue = (BYTE) VOS_BOUND((float)i + fLum, 0.F, 255.F);
			pModArray[i] = (INT16)cValue - i;
		}

		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();
		nWidth = (USHORT)GetOrgWidth();
		nHeight= (USHORT)GetOrgHeight();
		bCond = (BOOL)((nWidth*3) & 3);
		nCond = 4 - ((nWidth * 3) & 3);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_LUCO), (ULONG)nHeight << 1);

		// Zeilenschleife
		for (nY = 0; nY < nHeight; nY++)
		{
			// Spaltenschleife
			for (nX = 0; nX < nWidth; nX++)
			{
				// Kontrast-Aenderung ==> Zwischenwerte
				cTempB = pArray[ *pOrgArray++ ];
				cTempG = pArray[ *pOrgArray++ ];
				cTempR = pArray[ *pOrgArray++ ];

				// Offset fuer Helligkietsaenderung bestimmen
				nOff = (INT16) pModArray[ GRAYVAL( cTempB, cTempG, cTempR ) ];

				// Helligkeitsaenderung durchfuehren
				*pDestArray++ = (BYTE) VOS_BOUND( (INT16) cTempB + nOff, 0, 255 );
				*pDestArray++ = (BYTE) VOS_BOUND( (INT16) cTempG + nOff, 0, 255 );
				*pDestArray++ = (BYTE) VOS_BOUND( (INT16) cTempR + nOff, 0, 255 );
			}

			// Long-Alignment der Zeile beachten
			if (bCond)
			{
				pOrgArray 	+= nCond;
				pDestArray 	+= nCond;
			}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}


		// EIP beenden
		EndProcessing();

		// Palette aendern
		BitmapPalette* pPal = GetPalette();
		
		for( USHORT i = 0, nCount = pPal->GetEntryCount(); i < nCount; i++ )
		{
			BitmapColor& rColor = (*pPal)[ i ];

			// Kontrast-Aenderung ==> Zwischenwerte
			cTempR = rColor.GetRed();
			cTempG = rColor.GetGreen();
			cTempB = rColor.GetBlue();

			// Offset fuer Helligkietsaenderung bestimmen
			nOff = (INT16) pModArray[ GRAYVAL( cTempB, cTempG, cTempR ) ];

			// Helligkeitsaenderung durchfuehren
			rColor = BitmapColor( (BYTE) VOS_BOUND( (INT16) cTempR + nOff, 0, 255 ),
								  (BYTE) VOS_BOUND( (INT16) cTempG + nOff, 0, 255 ),
								  (BYTE) VOS_BOUND( (INT16) cTempB + nOff, 0, 255 ) );
		}

		delete[] pArray;
		delete[] pModArray;

		return TRUE;
	}

	return FALSE;
}

/******************************************************************************/

BOOL SvImage::ImpLuCo(float fContr, float fLum, const Rectangle& rDestRect,
						SfxViewFrame* pFrame)
{
	USHORT	nY;
	USHORT	nX;
	USHORT	nWidth;
	USHORT	nHeight;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE 	pTempOrg;
	HPBYTE 	pTempDest;
	BYTE	cValue;
	BYTE	cTempB;
	BYTE	cTempG;
	BYTE	cTempR;
	BYTE	cGray;
	USHORT	i;
	float	fM;
	float	fB;
	BYTE*	pArray;
	INT16*	pModArray;
	INT16	nOff;
	BOOL	bCond;
	ULONG	nCond;
	ULONG	nOff2;
	ULONG	nXOff;
	ULONG	nYOff;


	// EIP einleiten
	if (BeginProcessing())
	{
		pArray = (BYTE*) new BYTE[256];
		pModArray = (INT16*) new INT16[256];
		fLum *= 1.28F;
		fM = 1.0F + fContr*0.005F;
		fB = 127.5F * (1.F - fM);

		for (i=0; i < 256; i++)
		{
			pArray[i] = (BYTE) VOS_BOUND(fM * (float)i + fB, 0.F, 255.F);
			cValue = (BYTE) VOS_BOUND((float)i + fLum, 0.F, 255.F);
			pModArray[i] = (INT16)cValue - (INT16)i;
		}

		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();
		nWidth = (USHORT)GetOrgWidth();
		nHeight= (USHORT)GetOrgHeight();
		bCond = (BOOL)((nWidth*3) & 3);
		nCond = 4 - ((nWidth * 3) & 3);

		Rectangle	aOrgRect(Point(0,0), Size(nWidth, nHeight));
		Rectangle&	rInterRect = aOrgRect.Intersection(rDestRect);

		nXOff = 3 * (ULONG)(rInterRect.Left());
		nYOff = (ULONG)nHeight -
				(ULONG)rInterRect.Top() -
				(ULONG)rInterRect.GetHeight();

		// altes Array komplett kopieren
		HMEMCPY(pDestArray, pOrgArray, GetOrgAlignedWidth()*(ULONG)nHeight);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_LUCO), nHeight + rInterRect.GetHeight());

		// Operation auf Rectangle anwenden
		nWidth 	= (USHORT)rInterRect.GetWidth();
		nHeight = (USHORT)rInterRect.GetHeight();

 		// Zeilenschleife
		for (nY = 0; nY < nHeight; nY++)
		{
			nOff2 = (nYOff + nY)*GetOrgAlignedWidth() + nXOff;
			pTempOrg = pOrgArray + nOff2;
			pTempDest= pDestArray + nOff2;

			// Spaltenschleife
			for (nX = 0; nX < nWidth; nX++)
			{

				// Kontrast-Aenderung ==> Zwischenwerte
				cTempB = pArray[*pTempOrg++];
				cTempG = pArray[*pTempOrg++];
				cTempR = pArray[*pTempOrg++];

				// RGB-Wert in Y-Wert umrechnen
				cGray = (BYTE)	((((UINT16)cTempB * 28 +
								(UINT16)cTempG * 151 +
								(UINT16)cTempR * 77) & 0xFF00) >> 8);

				// Offset fuer Helligkietsaenderung bestimmen
				nOff = (INT16)*(pModArray + (ULONG)cGray);

				// Helligkeitsaenderung durchfuehren
				*pTempDest++ = (BYTE)VOS_BOUND((INT16)cTempB + nOff, 0, 255);
				*pTempDest++ = (BYTE)VOS_BOUND((INT16)cTempG + nOff, 0, 255);
				*pTempDest++ = (BYTE)VOS_BOUND((INT16)cTempR + nOff, 0, 255);
			}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}


		// EIP beenden
		EndProcessing();
		GetPalette()->SetEntryCount( 0 );
		delete[] pArray;
		delete[] pModArray;
		return TRUE;
	}

	return FALSE;
}
