/*************************************************************************
 *
 *  $RCSfile: svmedian.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "svimage.hxx"
#include <sfx2/progress.hxx>
#include <sfx2/viewfrm.hxx>
#include "simresid.hxx"
#include "strings.hrc"

/******************************************************************************/

#define s2(a,b) {register short t; if ((t=b-a)<0) {a+=t; b-=t;}}
#define mn3(a,b,c) s2(a,b); s2(a,c);
#define mx3(a,b,c) s2(b,c); s2(a,c);
#define mnmx3(a,b,c) mx3(a,b,c); s2(a,b);
#define mnmx4(a,b,c,d) s2(a,b); s2(c,d); s2(a,c); s2(b,d);
#define mnmx5(a,b,c,d,e) s2(a,b); s2(c,d); mn3(a,c,e); mx3(b,d,e);
#define mnmx6(a,b,c,d,e,f) s2(a,d); s2(b,e); s2(c,f);\
                            mn3(a,b,c); mx3(d,e,f);

/******************************************************************************/

BOOL SvImage::ImpRemoveNoise(SfxViewFrame* pFrame)
{
	USHORT	nWidth;
	USHORT	nWidth2;
	USHORT	nHeight;
	USHORT	nHeight2;
	USHORT	nX;
	USHORT	nY;
	ULONG	nAlignedWidth;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE 	pTempOrg;
	HPBYTE 	pTempDest;
	HPBYTE	pNear;
	HPBYTE	p1B;
	HPBYTE	p2B;
	HPBYTE	p3B;
	HPBYTE	p1G;
	HPBYTE	p2G;
	HPBYTE	p3G;
	HPBYTE	p1R;
	HPBYTE	p2R;
	HPBYTE	p3R;
	short	n1, n2, n3, n4, n5, n6;

    nWidth = (USHORT) GetOrgWidth();
    nHeight = (USHORT) GetOrgHeight();
	nAlignedWidth = GetOrgAlignedWidth();
	nWidth2 = nWidth - 2;
	nHeight2 = nHeight - 1;

	if((nWidth < 3) || (nHeight < 3))
		return FALSE;

    SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_NOISE), (ULONG)nHeight << 1);

	// EIP einleiten
	if (BeginProcessing())
	{
		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();
		pTempOrg = pOrgArray;

		// Zeilenschleife
		for (nY = 1; nY < nHeight2; nY++)
		{
			pTempDest = pDestArray + nAlignedWidth*(ULONG)nY + 3;

			// Spaltenschleife
			for (nX = 0; nX < nWidth2; nX++)
			{
				p1B = pTempOrg + (ULONG)nX * 3;
				p2B = p1B + nAlignedWidth;
				p3B = p2B + nAlignedWidth;

				p1G = p1B + 1;
				p2G = p2B + 1;
				p3G = p3B + 1;

				p1R = p1G + 1;
				p2R = p2G + 1;
				p3R = p3G + 1;

			   	// Median finden fuer Blau-Anteil
				n1 = *p1B;
				n2 = *(p1B + 3);
				n3 = *(p1B + 6);
				n4 = *p2B;
				n5 = *(p2B + 3);
				n6 = *(p2B + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3B;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3B + 3);
    			mnmx4(n1, n2, n3, n4);
    			n1 = *(p3B + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;

             	// Median finden fuer Gruen-Anteil
				n1 = *p1G;
				n2 = *(p1G + 3);
				n3 = *(p1G + 6);
				n4 = *p2G;
				n5 = *(p2G + 3);
				n6 = *(p2G + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3G;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3G + 3);
    			mnmx4(n1, n2, n3, n4);

				n1 = *(p3G + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;

              	// Median finden fuer Rot-Anteil
				n1 = *p1R;
				n2 = *(p1R + 3);
				n3 = *(p1R + 6);
				n4 = *p2R;
				n5 = *(p2R + 3);
				n6 = *(p2R + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3R;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3R + 3);
    			mnmx4(n1, n2, n3, n4);
    			n1 = *(p3R + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;
	    	}

			pTempOrg += nAlignedWidth;

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}


		// Umrandung mit Nachbarpixeln fuellen
		// links
		pTempDest 	= pDestArray + nAlignedWidth;
		pNear		= pTempDest + 3;
		for (nY = 1; nY < nHeight2; nY++)
		{
			pTempDest[0]	= *pNear++;
			pTempDest[1]	= *pNear++;
			pTempDest[2]	= *pNear;

			pTempDest += nAlignedWidth;
			pNear	   = pTempDest + 3;
		}
		// rechts
		pTempDest 	= pDestArray + nAlignedWidth + 3*(ULONG)(nWidth-1);
		pNear		= pTempDest - 3;
		for (nY = 1; nY < nHeight2; nY++)
		{
			pTempDest[0]	= *pNear++;
			pTempDest[1]	= *pNear++;
			pTempDest[2]	= *pNear;

			pTempDest += nAlignedWidth;
			pNear	   = pTempDest - 3;	
		}
		// oben
		pTempDest 	= pDestArray;
		pNear		= pTempDest + nAlignedWidth;
		for (nX = 0; nX < nAlignedWidth; nX++)
		{
			*pTempDest++ = *pNear++;
		}
		// unten
		pTempDest 	= pDestArray + (ULONG)nHeight2*nAlignedWidth;
		pNear		= pTempDest	- nAlignedWidth;
		for (nX = 0; nX < nAlignedWidth; nX++)
		{
			*pTempDest++ = *pNear++;
		}

		
		// EIP beenden
		EndProcessing();
		GetPalette()->SetEntryCount( 0 );
		return TRUE;
	}

	return FALSE;
}

/******************************************************************************/

BOOL SvImage::ImpRemoveNoise(const Rectangle& rDestRect, SfxViewFrame* pFrame)
{
	USHORT	nWidth;
	USHORT	nHeight;
	USHORT	nX;
	USHORT	nY;
	ULONG	nAlignedWidth;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE 	pTempOrg;
	HPBYTE 	pTempDest;
	HPBYTE	p1B;
	HPBYTE	p2B;
	HPBYTE	p3B;
	HPBYTE	p1G;
	HPBYTE	p2G;
	HPBYTE	p3G;
	HPBYTE	p1R;
	HPBYTE	p2R;
	HPBYTE	p3R;
	short	n1, n2, n3, n4, n5, n6;
	ULONG	nOff;
	ULONG	nOff2;
	ULONG	nXOff;
	ULONG	nYOff;


    nWidth 			= (USHORT) GetOrgWidth();
    nHeight			= (USHORT) GetOrgHeight();
	nAlignedWidth	= GetOrgAlignedWidth();

	if ((nWidth < 3) || (nHeight < 3))
	{
		return FALSE;
	}


	// EIP einleiten
	if (BeginProcessing())
	{
		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();

		// maximales Rechteck so gross wie Originalbild 
		// ohne aeussere Pixel
		Rectangle	aOrgRect(Point(1,1), Size(nWidth-2, nHeight-2));
		Rectangle&	rInterRect = aOrgRect.Intersection(rDestRect);

		nXOff = 3 * (ULONG)(rInterRect.Left() - 1);
		nYOff = (ULONG)nHeight -
				(ULONG)rInterRect.Top() -
				(ULONG)rInterRect.GetHeight() - 1;
		nOff2 = nAlignedWidth + 3;

		// altes Array komplett kopieren
		HMEMCPY(pDestArray, pOrgArray, GetOrgAlignedWidth()*(ULONG)nHeight);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_NOISE), nHeight + rInterRect.GetHeight());


		// Operation auf Rectangle anwenden
		nWidth 	= (USHORT)rInterRect.GetWidth();
		nHeight = (USHORT)rInterRect.GetHeight();


		// Zeilenschleife
		for (nY = 0; nY < nHeight; nY++)
		{
			nOff = (nYOff + nY)*nAlignedWidth + nXOff;
			pTempOrg = pOrgArray + nOff;
			pTempDest= pDestArray + nOff + nOff2;

			// Spaltenschleife
			for (nX = 0; nX < nWidth; nX++)
			{
				p1B = pTempOrg + (ULONG)nX * 3;
				p2B = p1B + nAlignedWidth;
				p3B = p2B + nAlignedWidth;

				p1G = p1B + 1;
				p2G = p2B + 1;
				p3G = p3B + 1;

				p1R = p1G + 1;
				p2R = p2G + 1;
				p3R = p3G + 1;

			   	// Median finden fuer Blau-Anteil
				n1 = *p1B;
				n2 = *(p1B + 3);
				n3 = *(p1B + 6);
				n4 = *p2B;
				n5 = *(p2B + 3);
				n6 = *(p2B + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3B;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3B + 3);
    			mnmx4(n1, n2, n3, n4);
    			n1 = *(p3B + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;

             	// Median finden fuer Gruen-Anteil
				n1 = *p1G;
				n2 = *(p1G + 3);
				n3 = *(p1G + 6);
				n4 = *p2G;
				n5 = *(p2G + 3);
				n6 = *(p2G + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3G;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3G + 3);
    			mnmx4(n1, n2, n3, n4);
    			n1 = *(p3G + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;

              	// Median finden fuer Rot-Anteil
				n1 = *p1R;
				n2 = *(p1R + 3);
				n3 = *(p1R + 6);
				n4 = *p2R;
				n5 = *(p2R + 3);
				n6 = *(p2R + 6);
    			mnmx6(n1, n2, n3, n4, n5, n6);
    			n1 = *p3R;
    			mnmx5(n1, n2, n3, n4, n5);
    			n1 = *(p3R + 3);
    			mnmx4(n1, n2, n3, n4);
    			n1 = *(p3R + 6);
    			mnmx3(n1, n2, n3);
    			*pTempDest++ = (BYTE)n2;
	    	}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}

		// Rahmen wird hier durch das alte Bild vorgegeben

		// EIP beenden
		EndProcessing();
		GetPalette()->SetEntryCount( 0 );
		return TRUE;
	}

	return FALSE;
}
