/*************************************************************************
 *
 *  $RCSfile: svmosaic.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/19 00:30:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "svimage.hxx"
#include <sfx2/progress.hxx>
#include <sfx2/viewfrm.hxx>
#include "simresid.hxx"
#include "strings.hrc"

/******************************************************************************/

BOOL SvImage::ImpMosaic(const Size& rPixelSize, SfxViewFrame* pFrame)
{
	USHORT	nWidth;
	USHORT	nHeight;
	USHORT	nX;
	USHORT	nX1;
	USHORT	nY;
	USHORT	nY1;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE	pTemp;
	USHORT	nRastRows;
	USHORT	nRestRows;
	USHORT	nRastCols;
	USHORT	nRestCols;
	USHORT	nSumR;
	USHORT	nSumG;
	USHORT	nSumB;
	USHORT	nPixWidth  = (USHORT)rPixelSize.Width();
	USHORT	nPixHeight = (USHORT)rPixelSize.Height();
	ULONG	nScan;
	ULONG	nOff;
	USHORT	nRasterSize;
	BOOL	bColFlag;
	BOOL	bRowFlag;
	BOOL	bCond;
	ULONG	nCond;
	BOOL	bReturn = FALSE;
	short	Mask1[9] = 	{ 	-1, -1, -1,
						    -1, 13, -1,
							-1, -1, -1
						};
			
	// EIP einleiten
	if (BeginProcessing())
	{
		pOrgArray = GetOrgPointer();
		pDestArray = GetDestPointer();
		nWidth = (USHORT)GetOrgWidth();
		nHeight = (USHORT)GetOrgHeight();
		bCond = (BOOL)((nWidth*3) & 3);
		nCond = 4 - ((nWidth * 3) & 3);
		nRastRows = nHeight / nPixHeight;
		nRestRows = nHeight % nPixHeight;
		nRastCols = nWidth / nPixWidth;
		nRestCols = nWidth % nPixWidth;

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_MOSAIC), (ULONG)nHeight*3);

 		for (nY = 0; nY < nHeight; nY += nPixHeight)
    	{
    		nScan = nY * GetOrgAlignedWidth();

      		// berprfung, ob die letzten Zeilen gesondert behandelt werden mssen
      		if ((nY / nPixHeight) != nRastRows) bRowFlag = FALSE; else bRowFlag = TRUE;

      		for (nX = 0; nX < nWidth; nX += nPixWidth)
      		{
      			nSumR = nSumG = nSumB = 0;

 	     	  	// berprfung, ob die letzten Spalten gesondert behandelt werden mssen
      	  		if ((nX / nPixWidth) != nRastCols) bColFlag = FALSE; else bColFlag = TRUE;

      	  		nOff = nScan + (ULONG)(nX * 3);

      	  		// Alle Werte des Raster-Rechtecks auslesen und addieren
      	  		for (nY1 = 0; nY1 < (bRowFlag ? nRestRows : nPixHeight); nY1++)
      	    	{
      	    		pTemp = pOrgArray + nOff + nY1 * GetOrgAlignedWidth();
      	      		for (nX1 = 0; nX1 < (bColFlag ? nRestCols : nPixWidth); nX1++)
      	        	{
      	        		nSumB += *pTemp++;
      	          		nSumG += *pTemp++;
      	          		nSumR += *pTemp++;
      	     		}
      	    	}

      	  		nRasterSize = 	(bColFlag ? nRestCols : nPixWidth)  *
      	                 		(bRowFlag ? nRestRows : nPixHeight);

	      	 	// gemittelten Wert in das Raster-Rechteck schreiben
      	  		for (nY1=0; nY1 < (bRowFlag ? nRestRows : nPixHeight); nY1++)
      	    	{
      	    		pTemp = pDestArray + nOff + nY1 * GetDestAlignedWidth();
      	      		for (nX1=0; nX1 < (bColFlag ? nRestCols : nPixWidth); nX1++)
      	        	{
      	        		*pTemp++ = (BYTE) (nSumB / nRasterSize);
      	          		*pTemp++ = (BYTE) (nSumG / nRasterSize);
      	          		*pTemp++ = (BYTE) (nSumR / nRasterSize);
      	        	}
      	    	}
       		}

			if (!(nY%4))
				aProgress.SetState(nY+1);
		}
		EndProcessing();

		// 2. Berechnungsschritt
		if (BeginProcessing(FALSE))
		{
			bReturn = Convolute3(&Mask1[0], 5, 0, nHeight, &aProgress);
			EndProcessing();
		}

		GetPalette()->SetEntryCount( 0 );

		return bReturn;
	}

	return FALSE;
}


BOOL SvImage::ImpMosaic(const Size& rPixelSize, const Rectangle& rDestRect,
                    	SfxViewFrame* pFrame)
{
	USHORT	nWidth;
	USHORT	nHeight;
	USHORT	nX;
	USHORT	nX1;
	USHORT	nY;
	USHORT	nY1;
	HPBYTE 	pOrgArray;
	HPBYTE 	pDestArray;
	HPBYTE	pTemp;
	USHORT	nRastRows;
	USHORT	nRestRows;
	USHORT	nRastCols;
	USHORT	nRestCols;
	USHORT	nSumR;
	USHORT	nSumG;
	USHORT	nSumB;
	USHORT	nPixWidth  = (USHORT)rPixelSize.Width();
	USHORT	nPixHeight = (USHORT)rPixelSize.Height();
	ULONG	nScan;
	ULONG	nOff;
	USHORT	nRasterSize;
	BOOL	bColFlag;
	BOOL	bRowFlag;
	BOOL	bCond;
	ULONG	nCond;
	BOOL	bReturn = FALSE;
	ULONG	nXOff;
	ULONG	nYOff;
	short	Mask1[9] = 	{ 	0, -1,  0,
						   -1,  5, -1,
							0, -1,  0
						};
			
	// EIP einleiten
	if (BeginProcessing())
	{
		pOrgArray = GetOrgPointer();
		pDestArray= GetDestPointer();

		nWidth = (USHORT)GetOrgWidth();
		nHeight= (USHORT)GetOrgHeight();
		bCond 	= (BOOL)((nWidth*3) & 3);
		nCond 	= 4 - ((nWidth * 3) & 3);

		Rectangle	aOrgRect(Point(0,0), Size(nWidth, nHeight));
		Rectangle&	rInterRect = aOrgRect.Intersection(rDestRect);

		nXOff = 3 * (ULONG)(rInterRect.Left());
		nYOff = (ULONG)nHeight -
				(ULONG)rInterRect.Top() -
				(ULONG)rInterRect.GetHeight();


		// altes Array komplett kopieren
		HMEMCPY(pDestArray, pOrgArray, GetOrgAlignedWidth()*(ULONG)nHeight);

        SfxProgress aProgress(pFrame->GetObjectShell(), SimResId(STR_STAT_MOSAIC), nHeight + (rInterRect.GetHeight() << 1));

		
		// Operation auf Rectangle anwenden
		nWidth 	= (USHORT)rInterRect.GetWidth();
		nHeight = (USHORT)rInterRect.GetHeight();
		nRastRows = nHeight / nPixHeight;
		nRestRows = nHeight % nPixHeight;
		nRastCols = nWidth / nPixWidth;
		nRestCols = nWidth % nPixWidth;

 		for (nY = 0; nY < nHeight; nY += nPixHeight)
    	{
			nScan = (nYOff + nY)*GetOrgAlignedWidth() + nXOff;

      		// berprfung, ob die letzten Zeilen gesondert behandelt werden mssen
      		if ((nY / nPixHeight) != nRastRows) bRowFlag = FALSE; else bRowFlag = TRUE;

      		for (nX = 0; nX < nWidth; nX += nPixWidth)
      		{
      			nSumR = nSumG = nSumB = 0;

 	     	  	// berprfung, ob die letzten Spalten gesondert behandelt werden mssen
      	  		if ((nX / nPixWidth) != nRastCols) bColFlag = FALSE; else bColFlag = TRUE;

      	  		nOff = nScan + (ULONG)(nX * 3);

      	  		// Alle Werte des Raster-Rechtecks auslesen und addieren
      	  		for (nY1 = 0; nY1 < (bRowFlag ? nRestRows : nPixHeight); nY1++)
      	    	{
      	    		pTemp = pOrgArray + nOff + nY1 * GetOrgAlignedWidth();
      	      		for (nX1 = 0; nX1 < (bColFlag ? nRestCols : nPixWidth); nX1++)
      	        	{
      	        		nSumB += *pTemp++;
      	          		nSumG += *pTemp++;
      	          		nSumR += *pTemp++;
      	     		}
      	    	}

      	  		nRasterSize = 	(bColFlag ? nRestCols : nPixWidth)  *
      	                 		(bRowFlag ? nRestRows : nPixHeight);

	      	 	// gemittelten Wert in das Raster-Rechteck schreiben
      	  		for (nY1=0; nY1 < (bRowFlag ? nRestRows : nPixHeight); nY1++)
      	    	{
      	    		pTemp = pDestArray + nOff + nY1 * GetDestAlignedWidth();
      	      		for (nX1=0; nX1 < (bColFlag ? nRestCols : nPixWidth); nX1++)
      	        	{
      	        		*pTemp++ = (BYTE) (nSumB / nRasterSize);
      	          		*pTemp++ = (BYTE) (nSumG / nRasterSize);
      	          		*pTemp++ = (BYTE) (nSumR / nRasterSize);
      	        	}
      	    	}
       		}

			if (!(nY%4)) 
				aProgress.SetState(nY+1);	
		}

		// EIP beenden
		EndProcessing();

		// 2. Berechnungsschritt
		if (BeginProcessing(FALSE))
		{
			bReturn = Convolute3(&Mask1[0], 1, 0, rDestRect, nHeight, &aProgress);
			EndProcessing();
		}

		GetPalette()->SetEntryCount( 0 );

		return bReturn;
	}

	return FALSE;
}
