/*************************************************************************
 *
 *  $RCSfile: simlib.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <tools/list.hxx>
#include <tools/stream.hxx>
#include <tools/urlobj.hxx>
#include <sot/formats.hxx>
#include <vcl/graph.hxx>
#include <vcl/exchange.hxx>
#include <svtools/libcall.hxx>
#include <sfx2/fcontnr.hxx>
#include <sfx2/docfile.hxx>
#include <svx/svxids.hrc>
#include <svx/impgrf.hxx>
#include <so3/clsids.hxx>
#include "simapp.hrc"				
#include "docshell.hxx"
#include "simdll.hxx"
#include "dllname.hxx"

TYPEINIT1( SimModuleDummy, SfxModule );

#if defined (WNT)
#pragma optimize ( "", off )
#endif

struct Filter
{
	String	aFilterKey;
	String	aType;
	String	aMacType;
	USHORT	nFlags;
};

// -----------------------------------------------------------------------------

// Version 4.0
SFX_IMPL_OBJECTFACTORY_LIB( SimDrawDocShell, 
							SFXOBJECTSHELL_STD_NORMAL, simage,
                            SvGlobalName( SO3_SIM_CLASSID_50 ),
							Sim, String( RTL_CONSTASCII_USTRINGPARAM( DLL_NAME ) ) )
{
    SFX_OWN_FILTER_REGISTRATION( SimDLL::DetectFilter,
                                 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 5.0" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "*.sim" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_INTERNAL,
                                 SOT_FORMATSTR_ID_STARIMAGE_50, 
								 String( RTL_CONSTASCII_USTRINGPARAM( "SDsi.sim" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 4.0" ) ),
                                 RID_DOCWINDOWICON, String(), String() );

    SFX_OWN_FILTER_REGISTRATION( SimDLL::DetectFilter,
                                 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 4.0" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "*.sim" ) ),
                                 SFX_FILTER_OWN | SFX_FILTER_INTERNAL,
                                 SOT_FORMATSTR_ID_STARIMAGE_40, 
								 String( RTL_CONSTASCII_USTRINGPARAM( "SDsi.sim" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 4.0" ) ),
                                 RID_DOCWINDOWICON, String(), String() );

    SFX_OWN_FILTER_REGISTRATION( SimDLL::DetectFilter,
								 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 3.0" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "*.sim" ) ),
								 SFX_FILTER_OWN | SFX_FILTER_INTERNAL,
								 SOT_FORMATSTR_ID_STARIMAGE, 
								 String( RTL_CONSTASCII_USTRINGPARAM( "SDsi.sim" ) ),
								 String( RTL_CONSTASCII_USTRINGPARAM( "StarImage 3.0" ) ),
								 RID_DOCWINDOWICON, String(), String() );
}

// -----------------------------------------------------------------------------

SfxModule* SimModuleDummy::Load()
{
	return LoadLibSim() ? SIM_MOD() : 0;
}

// -----------------------------------------------------------------------------

SvGlobalName SimModuleDummy::GetID( USHORT nFileFormat )
{
	SvGlobalName aGlobalName;

    switch (nFileFormat)
    {
        case SOFFICE_FILEFORMAT_31:
            aGlobalName = SvGlobalName(SO3_SIM_CLASSID_30);
            break;

        case SOFFICE_FILEFORMAT_40:
            aGlobalName = SvGlobalName(SO3_SIM_CLASSID_40);
            break;

        case SOFFICE_FILEFORMAT_50:
            aGlobalName = SvGlobalName(SO3_SIM_CLASSID_50);
            break;

        default:
            DBG_ASSERT(FALSE, "Unbekanntes Fileformat!");
            break;
    }

	return aGlobalName;
}

// -----------------------------------------------------------------------------

USHORT SimModuleDummy::HasID( const SvGlobalName& aTestName )
{
	USHORT nRet = 0;

    if ( aTestName == GetID( SOFFICE_FILEFORMAT_50 ) )
    {
        nRet = SOFFICE_FILEFORMAT_50;
    }
    else if ( aTestName == GetID( SOFFICE_FILEFORMAT_40 ) )
    {
		nRet = SOFFICE_FILEFORMAT_40;
    }
    else if ( aTestName == GetID( SOFFICE_FILEFORMAT_31 ) )
    {
		nRet = SOFFICE_FILEFORMAT_31;
    }

	return nRet;
}

// -----------------------------------------------------------------------------

SimDLL::SimDLL()
{
}

// -----------------------------------------------------------------------------

SimDLL::~SimDLL()
{
}

// -----------------------------------------------------------------------------

void SimDLL::LibInit()
{
    SimDrawDocShell::RegisterFactory( SDT_SIM_DOCFACTPRIO );
    SIM_MOD() = new SimModuleDummy( NULL, TRUE, &SimDrawDocShell::Factory() );
}

// -----------------------------------------------------------------------------

void SimDLL::LibExit()
{
	FreeLibSim();
    DELETEZ( SIM_MOD() );
}

// -----------------------------------------------------------------------------

ULONG __EXPORT SimDLL::DetectFilter(SfxMedium& rMedium, const SfxFilter **pFilter,
                                    SfxFilterFlags nMust, SfxFilterFlags nDont)
{
	ULONG nRet = 0;

	if ( rMedium.GetError() != SVSTREAM_OK )
		nRet = ULONG_MAX;
	else
	{
		SvStream* pStm = rMedium.GetInStream();

		if ( !pStm )
			nRet = ERRCODE_IO_GENERAL;
		else
		{
			pStm->Seek( STREAM_SEEK_TO_BEGIN );

			const String		aFileName( rMedium.GetURLObject().GetName() );
			GraphicDescriptor	aDesc( *pStm, &aFileName );
			GraphicFilter*		pGrfFilter = GetGrfFilter();

			if ( !aDesc.Detect( FALSE ) )
			{
				nRet = ERRCODE_IO_WRONGFORMAT;
				*pFilter = NULL;
			}
			else
			{
				USHORT	nFilter = aDesc.GetFileFormat();
				USHORT	nFilterNumber = aDesc.GetImportFormatNumber( nFilter, pGrfFilter->GetConfig() );

				if( pGrfFilter->IsImportPixelFormat( nFilterNumber ) )
				{
					String	aName( pGrfFilter->GetImportFormatName( nFilterNumber ) );

					*pFilter =  SimDrawDocShell::Factory().GetFilterContainer()->
								GetFilter4FilterName( aName );
				}
				else
				{
					nRet = ERRCODE_IO_WRONGFORMAT;
					*pFilter = NULL;
				}
			}
		}
	}

	return nRet;
}

// -----------------------------------------------------------------------------

void __EXPORT SimDLL::Update(SvInPlaceObjectRef aIPObj, OutputDevice* pOut)
{
    void ( __LOADONCALLAPI *fp)(SvInPlaceObjectRef, OutputDevice*);

    fp = (void (__LOADONCALLAPI*)(SvInPlaceObjectRef, OutputDevice*)) GetFuncSim("SimUpdateClipbrd");

    if (fp)
        fp(aIPObj, pOut);
}

// -----------------------------------------------------------------------------

void __EXPORT SimDLL::Update(SvInPlaceObjectRef aIPObj, const Bitmap& rBitmap,
                            OutputDevice* pOut)
{
    void ( __LOADONCALLAPI *fp)(SvInPlaceObjectRef, const Bitmap&, OutputDevice*);

    fp = (void (__LOADONCALLAPI*)(SvInPlaceObjectRef, const Bitmap&, OutputDevice*)) GetFuncSim("SimUpdate");

    if (fp)
        fp(aIPObj, rBitmap, pOut);
}

// -----------------------------------------------------------------------------

Bitmap __EXPORT SimDLL::GetBitmap(SvInPlaceObjectRef aIPObj)
{
    void ( __LOADONCALLAPI *fp)(SvInPlaceObjectRef, Bitmap*);
	Bitmap	aBitmap;

    fp = (void (__LOADONCALLAPI*)(SvInPlaceObjectRef, Bitmap*))GetFuncSim("SimGetBitmap");

    if (fp)
        fp(aIPObj, &aBitmap);

    return aBitmap;
}

// -----------------------------------------------------------------------------

void __EXPORT SimDLL::Update(SvInPlaceObjectRef aIPObj, const Graphic& rGraphic,
                    OutputDevice* pOut)
{
    void ( __LOADONCALLAPI *fp)(SvInPlaceObjectRef, const Graphic&, OutputDevice*);

    fp = (void (__LOADONCALLAPI*)(SvInPlaceObjectRef, const Graphic&, OutputDevice*)) GetFuncSim("SimUpdateGraphic");

    if (fp)
        fp( aIPObj, rGraphic, pOut );
}

// -----------------------------------------------------------------------------

Graphic __EXPORT SimDLL::GetGraphic(SvInPlaceObjectRef aIPObj)
{
    void ( __LOADONCALLAPI *fp)(SvInPlaceObjectRef, Graphic*);
	Graphic	aGraphic;

    fp = (void (__LOADONCALLAPI*)(SvInPlaceObjectRef, Graphic*))GetFuncSim("SimGetGraphic");

    if (fp)
        fp(aIPObj, &aGraphic);

    return aGraphic;
}

// -----------------------------------------------------------------------------

void __EXPORT SimDLL::ReplaceGraphic( SimDrawDocShell* pDocShell, Graphic* pGraphic )
{
    void ( __LOADONCALLAPI *fp)(SimDrawDocShell*, Graphic* );

    fp = (void (__LOADONCALLAPI*)(SimDrawDocShell*, Graphic*)) GetFuncSim("SimReplaceGraphic");

    if (fp)
        fp( pDocShell, pGraphic );
}

#if defined (WNT)
#pragma optimize ( "", on )
#endif
