/*************************************************************************
 *
 *  $RCSfile: alphactl.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

#include <vcl/toolbox.hxx>
#include <vcl/field.hxx>
#include <svtools/intitem.hxx>
#include <sfx2/app.hxx>
#include <sfx2/dispatch.hxx>
#include <svx/dialmgr.hxx>
#include "strings.hrc"
#include "simattr.hxx"
#include "glob.hxx"
#include "simapp.hrc"
#include "alphactl.hxx"
#include "simresid.hxx"

// -----------------
// - SimAirControl -
// -----------------

SFX_IMPL_TOOLBOX_CONTROL( SimAlphaControl, SfxUInt16Item );

// -----------------------------------------------------------------------------

SimAlphaControl::SimAlphaControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
			SfxToolBoxControl	( nId, rTbx, rBind ),
			pMtfAlpha			( NULL )
{
}

// -----------------------------------------------------------------------------

SimAlphaControl::~SimAlphaControl()
{
}

// -----------------------------------------------------------------------------

void SimAlphaControl::StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
{
	MetricField* pField = (MetricField*) GetToolBox().GetItemWindow( GetId() );

	DBG_ASSERT( pField, "Window not found" );

	if( eState == SFX_ITEM_DISABLED )
		pField->Disable();
	else
	{
		pField->Enable();

		if( eState == SFX_ITEM_AVAILABLE )
			pField->SetValue( ( (const SfxUInt16Item*) pState )->GetValue() );
	}
}

// -----------------------------------------------------------------------------

Window* SimAlphaControl::CreateItemWindow( Window *pParent )
{
	pMtfAlpha = new MetricField( pParent, WB_BORDER | WB_SPIN | WB_REPEAT );

	Size aSize( pMtfAlpha->GetTextWidth( String( RTL_CONSTASCII_USTRINGPARAM( "100 %" ) ) ), pMtfAlpha->GetTextHeight() );
	aSize.Width() += 20, aSize.Height() += 6;

	pMtfAlpha->SetUnit( FUNIT_CUSTOM );
	pMtfAlpha->SetCustomUnitText( String( RTL_CONSTASCII_USTRINGPARAM( " %" ) ) );
	pMtfAlpha->SetSizePixel( aSize );
	pMtfAlpha->SetDecimalDigits( 0 );
	pMtfAlpha->SetMin( 0 );
	pMtfAlpha->SetMax( 99 );
	pMtfAlpha->SetFirst( 0 );
	pMtfAlpha->SetLast( 99 );
	pMtfAlpha->SetSpinSize( 1 );
	pMtfAlpha->SetText( String() );
	pMtfAlpha->Show();
	pMtfAlpha->SetModifyHdl( LINK( this, SimAlphaControl, AlphaModifyHdl ) );

	return pMtfAlpha;
}

// -----------------------------------------------------------------------------

IMPL_LINK( SimAlphaControl, AlphaModifyHdl, MetricField*, pAlpha )
{
	const USHORT	nId = GetId();
	SfxUInt16Item	aItem( nId == SID_LINE_TRANSPARENCY ? 
						   ATTR_PNT_LINE_TRANSPARENCY : 
						   ATTR_PNT_FILL_TRANSPARENCY, (UINT16) pAlpha->GetValue() );
	
	SFX_DISPATCHER().Execute( nId == SID_LINE_TRANSPARENCY ?
							  SID_LINE_TRANSPARENCY:
							  SID_FILL_TRANSPARENCY, SFX_CALLMODE_ASYNCHRON, &aItem, 0L );
	
	return 0L;
}

