/*************************************************************************
 *
 *  $RCSfile: colstat.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vcl/status.hxx>
#include <sfx2/app.hxx>
#include "simapp.hrc"
#include "simitems.hxx"
#include "colstat.hxx"

// ----------------------------
// - SimColorStatusBarControl -
// ----------------------------

SFX_IMPL_STATUSBAR_CONTROL( SimColorStatusBarControl, SfxUInt16Item );

// -----------------------------------------------------------------------------

SimColorStatusBarControl::SimColorStatusBarControl( USHORT nId, StatusBar& rStb, SfxBindings& rBind ) :
			SfxStatusBarControl( nId, rStb, rBind )
{
}

// -----------------------------------------------------------------------------

void SimColorStatusBarControl::StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
{
	const SimColorItem* pStateItem = PTR_CAST( SimColorItem, pState );

	if ( pStateItem )
	{
		aForeCol = pStateItem->GetForeColor();
		aBackCol = pStateItem->GetBackColor();

		// Repaint ausloesen
		if ( GetStatusBar().AreItemsVisible() )
			GetStatusBar().SetItemData( GetId(), 0 );
	}
}

// -----------------------------------------------------------------------------

void SimColorStatusBarControl::Paint( const UserDrawEvent& rUsrEvt )
{
    const Rectangle&    rRect = rUsrEvt.GetRect();
	Rectangle			aPaintRect;
	OutputDevice*		pOut = rUsrEvt.GetDevice();
	const Color			aOldLineColor( pOut->GetLineColor() );
	const Color			aOldFillColor( pOut->GetFillColor() );
	const long			nCenterX = rRect.Center().X();

	pOut->SetLineColor();

	aPaintRect.Left() = rRect.Left() + 2;
	aPaintRect.Top() = rRect.Top() + 2;
	aPaintRect.Right() = nCenterX - 1;
	aPaintRect.Bottom() = rRect.Bottom() - 2;
	pOut->SetFillColor( aForeCol );
	pOut->DrawRect( aPaintRect );

	aPaintRect.Left() = nCenterX + 2;
	aPaintRect.Right() = rRect.Right() - 2;
	pOut->SetFillColor( aBackCol );
	pOut->DrawRect( aPaintRect );

	pOut->SetLineColor( aOldLineColor );
	pOut->SetFillColor( aOldFillColor );
}
