/*************************************************************************
 *
 *  $RCSfile: newdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vcl/msgbox.hxx>
#include "newdlg.hxx"
#include "newdlg.hrc"
#include "simresid.hxx"

// -------------
// - SimNewDlg -
// -------------

SimNewDlg::SimNewDlg( Window* pWindow ) :
			ModalDialog		( pWindow, SimResId( DLG_NEW ) ),
			aGrpPresets		( this, ResId( GRP_PRESETS ) ),
			aFtWidth		( this, ResId( FT_WIDTH ) ),
			aMtrFldPixelX	( this, ResId( MTR_FLD_PIXEL_X ) ),
			aFtHeight   	( this, ResId( FT_HEIGHT ) ),
			aMtrFldPixelY	( this, ResId( MTR_FLD_PIXEL_Y ) ),
			aFtColorCount	( this, ResId( FT_COLORCOUNT ) ),
			aLbColorCount	( this, ResId( LB_COLORCOUNT ) ),
			aBtnCreate		( this, ResId( BTN_CREATE ) ),
			aBtnHelp    	( this, ResId( BTN_HELP ) )
{
	FreeResource();
	InitDialog();

	aBtnCreate.SetClickHdl( LINK( this, SimNewDlg, CreateHdl ) );
}

// -----------------------------------------------------------------------------

void SimNewDlg::InitDialog()
{
	aMtrFldPixelX.SetValue( 256 );
	aMtrFldPixelY.SetValue( 256 );
	aLbColorCount.SelectEntryPos( 0 );
}

// -----------------------------------------------------------------------------

USHORT SimNewDlg::GetColorDepth() const
{
	const USHORT	nPos = aLbColorCount.GetSelectEntryPos();
	USHORT			nColorDepth;

	switch ( nPos )
	{				
		case ( 0 ) : nColorDepth = 24; break;
		case ( 1 ) : nColorDepth = 8; break;
		case ( 2 ) : nColorDepth = 4; break;
		case ( 3 ) : nColorDepth = 1; break;
		
		default	: 
			nColorDepth = 24; 
		break;
	}

	return nColorDepth;
}

// -----------------------------------------------------------------------------

IMPL_LINK( SimNewDlg, CreateHdl, PushButton*, pBtn )
{
	EndDialog( RET_OK );

	return 0L;
}
