/*************************************************************************
 *
 *  $RCSfile: sharpnss.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <svtools/intitem.hxx>
#include <svtools/aeitem.hxx>
#include <svtools/itemset.hxx>
#include "simattr.hxx"
#include "glob.hxx"
#include "sharpnss.hxx"
#include "sharpnss.hrc"
#include "simresid.hxx"

/*************************************************************************
|*
|* Dialog zum Einstellen des Mosaiks
|*
\************************************************************************/

SimSharpnessDlg::SimSharpnessDlg( Window* pWindow, const SfxItemSet& rInAttrs ) :
				ModalDialog		( pWindow, SimResId( DLG_SHARPNESS ) ),
				aRbtLow     	( this, ResId( RBT_LOW ) ),
				aRbtMedium  	( this, ResId( RBT_MEDIUM ) ),
				aRbtHigh    	( this, ResId( RBT_HIGH ) ),
				aGrpDefinition  ( this, ResId( GRP_DEFINITION ) ),
				aBtnOK      	( this, ResId( BTN_OK ) ),
				aBtnCancel  	( this, ResId( BTN_CANCEL ) ),
				aBtnHelp    	( this, ResId( BTN_HELP ) ),
				rOutAttrs		( rInAttrs )
{
	FreeResource();

	Reset();
}

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

SimSharpnessDlg::~SimSharpnessDlg()
{
}

/*************************************************************************
|*
|* Liest uebergebenen Item-Set
|*
\************************************************************************/

void SimSharpnessDlg::Reset()
{
	DefinitionType eDT;

	eDT = (DefinitionType) ( ( const SfxAllEnumItem& ) rOutAttrs.
				Get( ATTR_SHARPNESS_TYPE ) ).GetValue();

	switch( eDT )
	{
		case DEFINITION_LOW:	aRbtLow.Check(); break;
		case DEFINITION_MEDIUM: aRbtMedium.Check(); break;
		case DEFINITION_HIGH:	aRbtHigh.Check(); break;
	}
}

/*************************************************************************
|*
|* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
\************************************************************************/

void SimSharpnessDlg::GetAttr( SfxItemSet& rOutAttrs )
{
	DefinitionType eDT;

	if( aRbtLow.IsChecked() ) eDT = DEFINITION_LOW;
	else if( aRbtMedium.IsChecked() ) eDT = DEFINITION_MEDIUM;
	else if( aRbtHigh.IsChecked() ) eDT = DEFINITION_HIGH;

	rOutAttrs.Put( SfxAllEnumItem( ATTR_SHARPNESS_TYPE, eDT ) );
}



