/*************************************************************************
 *
 *  $RCSfile: solardlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <svtools/intitem.hxx>
#include <svtools/eitem.hxx>
#include <svtools/itemset.hxx>
#include "simattr.hxx"
#include "solardlg.hxx"
#include "solardlg.hrc"
#include "simresid.hxx"

/*************************************************************************
|*
|* Dialog zum Einstellen von Kontrast und Helligkeit
|*
\************************************************************************/

SimSolarDlg::SimSolarDlg( Window* pWindow, const SfxItemSet& rInAttrs ) :
				ModalDialog		( pWindow, SimResId( DLG_SOLARIZATION ) ),
				aFtThreshold	( this, ResId( FT_THRESHOLD ) ),
				aMtrFldThreshold( this, ResId( MTR_FLD_THRESHOLD ) ),
				aGrpThreshold   ( this, ResId( GRP_THRESHOLD ) ),
				aCbxInvert  	( this, ResId( CBX_INVERT ) ),
				aBtnOK      	( this, ResId( BTN_OK ) ),
				aBtnCancel  	( this, ResId( BTN_CANCEL ) ),
				aBtnHelp    	( this, ResId( BTN_HELP ) ),
				rOutAttrs		( rInAttrs )
{
	FreeResource();

	Reset();
}

/*************************************************************************
|*
|* Dtor
|*
\************************************************************************/

SimSolarDlg::~SimSolarDlg()
{
}

/*************************************************************************
|*
|* Liest uebergebenen Item-Set
|*
\************************************************************************/

void SimSolarDlg::Reset()
{
	aMtrFldThreshold.SetValue( ( ( const SfxInt16Item& ) rOutAttrs.
						Get( ATTR_SOLAR_THRES ) ).GetValue() );

	if( ( ( const SfxBoolItem& ) rOutAttrs.
						Get( ATTR_SOLAR_INVERT ) ).GetValue() )
		aCbxInvert.Check();
	else
		aCbxInvert.Check( FALSE );
}

/*************************************************************************
|*
|* Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
|*
\************************************************************************/

void SimSolarDlg::GetAttr( SfxItemSet& rOutAttrs )
{
	rOutAttrs.Put( SfxInt16Item( ATTR_SOLAR_THRES, (INT16) aMtrFldThreshold.GetValue() ) );
	rOutAttrs.Put( SfxBoolItem( ATTR_SOLAR_INVERT, aCbxInvert.IsChecked() ) );
}

