/*************************************************************************
 *
 *  $RCSfile: fuscale.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vcl/msgbox.hxx>
#include <sfx2/bindings.hxx>
#include <sfx2/dispatch.hxx>
#include <sfx2/viewfrm.hxx>
#include <svx/zoom.hxx>
#include <svx/zoomitem.hxx>
#include <svx/dialogs.hrc>
#include "simwin.hxx"
#include "simview.hxx"
#include "drviewsh.hxx"
#include "simmodel.hxx"
#include "docshell.hxx"
#include "fuscale.hxx"

// --------------
// - SimFuScale -
// --------------

SimFuScale::SimFuScale(SimViewShell* pViewSh, SimWindow* pWin, SimView* pView,
                 SimModel* pSimModel, SfxRequest& rReq)
       : SimFuPoor(pViewSh, pWin, pView, pSimModel, rReq)
{
    const SfxItemSet* pArgs = rReq.GetArgs();

    if( !pArgs )
    {
        SfxItemSet	aNewAttr( *pModel->GetPool(), SID_ATTR_ZOOM, SID_ATTR_ZOOM );
		SvxZoomItem	aZoom( SVX_ZOOM_PERCENT, (USHORT) pWindow->GetZoom() );

		aZoom.SetValueSet( SVX_ZOOM_ENABLE_50  | SVX_ZOOM_ENABLE_75  |
						   SVX_ZOOM_ENABLE_100 | SVX_ZOOM_ENABLE_150 |
						   SVX_ZOOM_ENABLE_200 | SVX_ZOOM_ENABLE_WHOLEPAGE |
						   ( pView->GetSelectionBoundRect().IsEmpty() ? 0 : SVX_ZOOM_ENABLE_OPTIMAL ) );
		aNewAttr.Put( aZoom );

        SvxZoomDialog* pDlg = new SvxZoomDialog( pWindow, aNewAttr );

		pDlg->SetLimits( 10, 1600 );

		if( pDlg->Execute() == RET_OK )
		{
            rReq.Done( *( pDlg->GetOutputItemSet() ) );
            pArgs = rReq.GetArgs();
		}
		else
		{
			delete pDlg;
			return;
		}

        delete pDlg;
    }

	const SvxZoomItem& rZoomItem = (const SvxZoomItem&) pArgs->Get( SID_ATTR_ZOOM );

	switch( rZoomItem.GetType() )
	{
		case( SVX_ZOOM_PERCENT ):
		{
			pViewShell->SetZoom( rZoomItem.GetValue() );
			SFX_BINDINGS().Invalidate( SID_ATTR_ZOOM );
			pView->Invalidate();
		}
		break;

		case( SVX_ZOOM_OPTIMAL ):
			SFX_DISPATCHER().Execute( SID_SIZE_ALL, SFX_CALLMODE_ASYNCHRON );
		break;

		case( SVX_ZOOM_WHOLEPAGE ):
			SFX_DISPATCHER().Execute( SID_SIZE_PAGE, SFX_CALLMODE_ASYNCHRON );
		break;

		default:
		break;
	}
}

// -----------------------------------------------------------------------------

SimFuScale::~SimFuScale()
{
}
