/*************************************************************************
 *
 *  $RCSfile: defaults.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_DEFAULTS_HXX
#define _SIM_DEFAULTS_HXX

#include <vcl/group.hxx>
#include <vcl/fixed.hxx>
#include <vcl/scrbar.hxx>
#include <vcl/button.hxx>
#include <vcl/field.hxx>
#include <sfx2/tabdlg.hxx>
#include <sfx2/basedlgs.hxx>
#include <svx/dlgctrl.hxx>

// -------------------------
// - SimStandards1TabPage  -
// -------------------------

class SimStandards1TabPage : public SfxTabPage
{
	FixedText			aFtRed;
	MetricField			aMtrFldRed;
	FixedText			aFtGreen;
	MetricField			aMtrFldGreen;
	FixedText			aFtBlue;
	MetricField			aMtrFldBlue;
	GroupBox			aGrpRgb;
	FixedText			aFtNumber;
	ListBox				aLbGrayscales;
	GroupBox			aGrpGrayscales;
	FixedText			aFtPoster;
	NumericField		aNumFldPoster;
	GroupBox			aGrpPoster;
	FixedText			aFtBrightness;
	MetricField			aMtrFldBrightness;
	FixedText			aFtContrast;
	MetricField			aMtrFldContrast;
	GroupBox			aGrpBrightness;
	FixedText			aFtAngle;
	MetricField			aMtrFldAngle;
	RadioButton			aRbtLeft;
	RadioButton			aRbtRight;
	GroupBox			aGrpRotation;
	FixedText			aFtThreshold;
	MetricField			aMtrFldThreshold;
	GroupBox			aGrpBlackWhite;
	SimDefaults*		pDefaults;

public:
						SimStandards1TabPage( Window* pParent, const SfxItemSet& rInAttrs  );

	static SfxTabPage*	Create( Window*, const SfxItemSet& );
	virtual BOOL		FillItemSet( SfxItemSet& );
	virtual void		Reset( const SfxItemSet & );

	void				SetDefaults( SimDefaults* _pDefaults ) { pDefaults = _pDefaults; }
};

// ------------------------
// - SimStandards2TabPage -
// ------------------------

class SimStandards2TabPage : public SfxTabPage
{
	FixedText			aFtMosaicX;
	MetricField			aMtrFldMosaicX;
	FixedText			aFtMosaicY;
	MetricField			aMtrFldMosaicY;
	FixedText			aFtMosaicDefinition;
	ListBox				aLbMosaicDefinition;
	GroupBox			aGrpMosaic;
	FixedText			aFtThreshold;
	MetricField			aMtrFldThreshold;
	CheckBox			aCbxInvert;
	GroupBox			aGrpSolarization;
	FixedText			aFtTileX;
	MetricField			aMtrFldTileX;
	FixedText			aFtTileY;
	MetricField			aMtrFldTileY;
	GroupBox			aGrpTile;
	FixedText			aFtDefinition;
	ListBox				aLbDefinition;
	GroupBox			aGrpSharpness;
	FixedText			aFtAge;
	MetricField			aMtrFldAge;
	GroupBox			aGrpAge;
	SimDefaults*		pDefaults;

public:
						SimStandards2TabPage( Window* pParent, const SfxItemSet& rInAttrs  );

	static SfxTabPage*	Create( Window*, const SfxItemSet& );
	virtual BOOL		FillItemSet( SfxItemSet& );
	virtual void		Reset( const SfxItemSet & );

	void				SetDefaults( SimDefaults* _pDefaults ) { pDefaults = _pDefaults; }
};

#endif // _SIM_DEFAULTS_HXX
