/*************************************************************************
 *
 *  $RCSfile: drviewsh.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_DRVIEWSH_HXX
#define _SIM_DRVIEWSH_HXX

#include <vcl/graph.hxx>
#include <sfx2/viewfac.hxx>
#include "viewshel.hxx"
#include "glob.hxx"

// --------------------
// - SimDrawViewShell -
// --------------------

class SimDrawDocShell;
class Timer;
class SimTabControl;
class SimFrame;

class SimDrawViewShell : public SimViewShell
{
private:

	Timer*				pNewDocTimer;
	SimTabControl*		pTabControl;
	static BOOL			bPipette;

	void				ImplConstruct();
	void				ImplPrintFrame( const SimFrame& rFrame, Printer* pPrinter );

						DECL_LINK( TabControlSplitHdl, SimTabControl* );
						DECL_LINK( TimerHdl, Timer* );
						DECL_LINK( NewDocHdl, void* );

protected:

	virtual long		GetIPZoom( const Size& rLogSize100 );

	virtual	long		GetHCtrlWidth();
	virtual void		AdjustControls( const Point& rNewPos, const Size& rNewSize );

public:

						TYPEINFO();
						SFX_DECL_VIEWFACTORY( SimDrawViewShell );
						SFX_DECL_INTERFACE( SCH_IF_DRVIEWSHELL );

						SimDrawViewShell( SfxViewFrame* pFrame, const SimDrawViewShell& rShell );
						SimDrawViewShell( SfxViewFrame* pFrame, Window* pParent );
						SimDrawViewShell( SfxViewFrame* pFrame, SfxViewShell* pOldShell );
						~SimDrawViewShell();

	SimDrawDocShell*	GetObjectShell() const;

	virtual void		FuAdmin( SfxRequest &rReq );
	virtual void		FuModify( SfxRequest &rReq );
	virtual void		FuPermanent( SfxRequest &rReq );
	virtual void		FuSupport( SfxRequest &rReq );
	virtual void		ExecCtrl( SfxRequest &rReq );
	virtual void		ExecAttr( SfxRequest &rReq );
	virtual void		ExecBmpMask( SfxRequest& rReq );
	virtual void		ExecGallery( SfxRequest& rReq );
	virtual void		ExecStatusBar( SfxRequest& rReq );

	virtual void		GetMenuState( SfxItemSet &rSet );
	virtual void		GetCtrlState( SfxItemSet &rSet );
	virtual void		GetAttrState( SfxItemSet &rSet );
	virtual void		GetPaintPixelState( SfxItemSet& rSet );
	virtual void		GetBmpMaskState( SfxItemSet& rSet );
	virtual void		GetGalleryState( SfxItemSet& rSet );
	virtual void		GetStatusBarState( SfxItemSet& rSet );

	virtual BOOL 		KeyInput( const KeyEvent& rKEvt, SimWindow* pWin );
	virtual void 		MouseMove( const MouseEvent& rMEvt, SimWindow* pWin );
	virtual void 		MouseButtonUp( const MouseEvent& rMEvt, SimWindow* pWin );
	virtual void 		MouseButtonDown( const MouseEvent& rMEvt, SimWindow* pWin );
	virtual USHORT		Print( SfxProgress &rProgress, PrintDialog *pPrintDialog = 0 );
	virtual SfxPrinter* GetPrinter( BOOL bCreate = FALSE );
	virtual USHORT		SetPrinter( SfxPrinter* pNewPrinter, USHORT nDiffFlags = SFX_PRINTER_ALL );
	virtual void 		AddWindow( SimWindow* pWin );
	virtual void 		RemoveWindow( SimWindow* pWin );

	virtual void		InitFrameChange();
	virtual void		EndFrameChange();

	void				CreateUndoAction( const String& rComment, const USHORT nSID );
	void				SwitchToFrame( ULONG nFramePos );
	void				InsertFrame();
	void				RemoveFrame( ULONG nFramePos );
	void				EditFrameProperties();
};

#endif // _SIM_DRVIEWSH_HXX
