/*************************************************************************
 *
 *  $RCSfile: fumod.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_FUMOD_HXX
#define _SIM_FUMOD_HXX

#include "fupoor.hxx"

// -----------
// - Defines -
// -----------

#define DECL_FUMOD( _def_FctName )																	\
class SimFu##_def_FctName : public SimFuPoor														\
{																									\
public:																								\
					SimFu##_def_FctName( SimViewShell* pViewSh, SimWindow* pWin, SimView* pView,	\
										 SimModel* pSimModel, SfxRequest& rReq );					\
	virtual 		~SimFu##_def_FctName() {}														\
	virtual void	Activate() {}																	\
	virtual void	Deactivate() {}																	\
};

// -----------------------------------------------------------------------------

#define IMPL_FUMOD( _def_FctName )																	\
SimFu##_def_FctName::SimFu##_def_FctName( SimViewShell* pViewSh, SimWindow* pWin, SimView* pView,	\
										  SimModel* pSimModel, SfxRequest& rReq ) :				\
		SimFuPoor( pViewSh, pWin, pView, pSimModel, rReq )

// ----------------------
// - Class declarations -
// ----------------------

DECL_FUMOD( Age )
DECL_FUMOD( Contrast )
DECL_FUMOD( Gamma )
DECL_FUMOD( Gray )
DECL_FUMOD( Mosaic )
DECL_FUMOD( Poster )
DECL_FUMOD( Relief )
DECL_FUMOD( Resize )
DECL_FUMOD( Rgb )
DECL_FUMOD( Rotate )
DECL_FUMOD( Sharp )
DECL_FUMOD( Solar )
DECL_FUMOD( Tile )

#endif // _SIM_FUMOD_HXX
