/*************************************************************************
 *
 *  $RCSfile: fupoor.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_FUPOOR_HXX
#define _SIM_FUPOOR_HXX

#include <tools/gen.hxx>
#include <vcl/timer.hxx>
#include <vcl/event.hxx>
#include <vcl/pointr.hxx>
#include <vcl/msgbox.hxx>
#include <vcl/exchange.hxx>
#include <svtools/eitem.hxx>
#include <svtools/aeitem.hxx>
#include <svtools/intitem.hxx>
#include <sfx2/request.hxx>
#include <sfx2/app.hxx>

// -------------
// - SimFuPoor -
// -------------

class SimView;
class SimViewShell;
class SimWindow;
class SimModel;
class Dialog;

class SimFuPoor
{
protected:

	SfxRequest			aSfxRequest;
	Timer				aScrollTimer;
	Timer				aDragTimer;
	Pointer				aOldPointer;
	Point				aMDPos;
	SimView* 			pView;
	SimViewShell*		pViewShell;
	SimWindow*			pWindow;
	SimModel*			pModel;
	Dialog* 			pDialog;
	ULONG				nDragFramePos;
	BOOL				bStartDrag;
	BOOL				bIsInDDMode;
	BOOL				bDlgRet;

						DECL_LINK( DragHdl, Timer * );
						DECL_LINK( ScrollHdl, Timer * );

	Polygon				CreateEllipse( const Rectangle& rBound ) const;
	virtual void		DragStarted();

public:

						SimFuPoor( SimViewShell* pViewSh, SimWindow* pWin, SimView* pView,
								   SimModel* pModel, SfxRequest& rReq );
	virtual				~SimFuPoor();

	virtual void		Paint( const Rectangle& rRect, SimWindow* pWin ) {}
	virtual BOOL		KeyInput( const KeyEvent& rKEvt );
	virtual BOOL		MouseButtonDown( const MouseEvent& rMEvt );
	virtual BOOL		MouseMove( const MouseEvent& rMEvt );
	virtual BOOL		MouseButtonUp( const MouseEvent& rMEvt );
	virtual void		Activate();
	virtual void		Deactivate();
	virtual Pointer		GetPointer() const;
	virtual BOOL		IsPaintFunc() const { return FALSE; }
	virtual void		Flush() {};

	void				SetWindow( SimWindow* pWin );
	void				ForceScroll( const Point& rPixPos, long nInnerOffsetPix = 0 );

	BOOL				IsDragging() const { return bIsInDDMode; }
	ULONG				GetDragFramePos() const { return nDragFramePos; }
	
	USHORT 				GetSlotID() const { return( aSfxRequest.GetSlot() ); }
	BOOL				GetDlgRet() const { return bDlgRet; }
};

#endif // _SIM_FUPOOR_HXX
