/*************************************************************************
 *
 *  $RCSfile: printopt.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SIM_PRINTOPT_HXX_
#define _SIM_PRINTOPT_HXX_

#include <vcl/group.hxx>
#include <vcl/fixed.hxx>
#include <vcl/scrbar.hxx>
#include <vcl/button.hxx>
#include <vcl/field.hxx>
#include <svx/rectenum.hxx>
#include <svx/dlgctrl.hxx>
#include <sfx2/basedlgs.hxx>

class SfxItemSet;

enum MeasureType
{
	MT_ORIGINAL = 0,
	MT_75DPI = 1,
	MT_150DPI = 2,
	MT_300DPI = 3,
	MT_600DPI = 4,
	MT_1200DPI = 5,
	MT_FREEHAND = 6,
	MT_PAGESIZE = 7
};

// -------------------
// - SimPrintOptPage -
// -------------------

class SimFrame;

class SimPrintOptPage : public SvxTabPage
{
private:
	
	FixedText			aFtMeasure;
	ListBox				aLbMeasure;
	FixedText			aFtWidth;
	MetricField        	aMtrFldWidth;
	FixedText			aFtHeight;
	MetricField			aMtrFldHeight;
	CheckBox			aCbxScale;
	GroupBox			aGrpSize;
	SvxRectCtl			aCtlPosition;
	GroupBox			aGrpPosition;
	SimFrame*			pFrame;
	BOOL				bWidthChanged;
	double				fXY;
	Size				aPageSize;
	UINT16				nDPI;
	
	const SfxItemSet&	rOutAttrs;

	void				ImplSetFieldValue( MetricField& rField, ULONG nVal );
	ULONG				ImplGetFieldValue( const MetricField& rField ) const ;

						DECL_LINK( ClickScaleHdl, void * );
						DECL_LINK( ChangeWidthHdl, void * );
						DECL_LINK( ChangeHeightHdl, void * );
						DECL_LINK( ChangeMeasureHdl, void * );

public:
		
						SimPrintOptPage( Window* pWindow, const SfxItemSet& rInAttrs, 
										 SimFrame* pFrame, const Size& rPageSize );
						~SimPrintOptPage();

	static SfxTabPage* 	Create( Window*, const SfxItemSet& );
	virtual BOOL 		FillItemSet( SfxItemSet& );
	virtual void 		Reset( const SfxItemSet & );

	virtual void 		PointChanged( Window* pWindow, RECT_POINT eRP );

};

// ------------------
// - SimPrintOptDlg -
// ------------------

class SimPrintOptDlg : public SfxSingleTabDialog
{

public:
					
						SimPrintOptDlg( Window* pParent, const SfxItemSet& rInAttrs, 
										SimFrame* pFrame, const Size& rPageSize ); 
						~SimPrintOptDlg();
};

#endif // _SIM_PRINTOPT_HXX_
