/*************************************************************************
 *
 *  $RCSfile: simwin.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIM_SIMWIN_HXX
#define _SIM_SIMWIN_HXX

#include <vcl/window.hxx>
#include "fupoor.hxx"

// -------------
// - SimWindow -
// -------------

class SimViewShell;

class SimWindow : public Window
{
private:

	void			ImplDrawFastBackground( const Rectangle& rRect );

protected:

	MapMode			aSimMap;
	Point			aWinPos;
	Point			aViewOrigin;
	Size			aViewSize;
	SimViewShell*	pViewShell;
	ULONG			nDropScrollCount;
	BOOL			bCenterAllowed;

	virtual void	Paint(const Rectangle& rRect);
	virtual void	KeyInput(const KeyEvent& rKEvt);
	virtual void	MouseMove(const MouseEvent& rMEvt);
	virtual void	MouseButtonUp(const MouseEvent& rMEvt);
	virtual void	MouseButtonDown(const MouseEvent& rMEvt);
	virtual void	Command( const CommandEvent& rCEvt );
	virtual BOOL	QueryDrop(DropEvent& rEvt);
	virtual BOOL	Drop( const DropEvent& rEvt );

 public:
					SimWindow( Window* pParent, SimViewShell* pShell );
					~SimWindow();

	virtual void	GrabFocus();
	virtual void	LoseFocus();

	void			ShareViewArea(const SimWindow* pOtherWin);
	
	long			SetZoomFactor( long nZoom );
	void			SetZoom( long nZoom );
	void			SetZoomPoint( const Point& rCenter, long nZoom );
	long			SetZoomRect( const Rectangle& rZoomRect );
	long			GetZoom() const	{ return aSimMap.GetScaleX().GetNumerator() * 100L / aSimMap.GetScaleX().GetDenominator(); }

	Point			GetWinViewPos() { return aWinPos; }
	void			SetWinViewPos(const Point& rPnt);
	void			SetViewOrigin(const Point& rPnt);
	void			SetViewSize(const Size& rSize);
	Size			GetViewSize() { return aViewSize; }
	void			SetCenterAllowed(BOOL bIsAllowed) { bCenterAllowed = bIsAllowed; }

	void			UpdateMapOrigin();
	double			GetVisibleX();			// Interface fuer ScrollBars
	double			GetVisibleY();
	void			SetVisibleXY(double fX, double fY);
	double			GetVisibleWidth();
	double			GetVisibleHeight();
	double			GetScrlLineWidth();
	double			GetScrlLineHeight();
	double			GetScrlPageWidth();
	double			GetScrlPageHeight();

	const MapMode&	GetSimMap() const { return aSimMap; }
};

#endif // _SIM_SIMWIN_HXX
