/*************************************************************************
 *
 *  $RCSfile: tbxctrl.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:53:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _TBXCTRL_HXX
#define _TBXCTRL_HXX

#ifdef NOOLDSV
#define ToolBoxAlign WindowAlign 
#endif

#include <sfx2/tbxctrl.hxx>
#include <sfx2/tbxmgr.hxx>
#include "simresid.hxx"

/*************************************************************************
|*
|* 
|* 
\************************************************************************/

class SimPopupWindowTbx : public SfxPopupWindow
{
	SfxToolBoxManager			aTbx;
	SimResId					aResIdWin;
	SimResId					aResIdTbx;
	ToolBoxAlign				eTbxAlign;
	Link						aSelectLink;

								DECL_LINK( TbxSelectHdl, void * );
								
public:							
								
								SimPopupWindowTbx( USHORT nId, WindowAlign eAlign,
					  								SimResId aRIdWin, SimResId aRIdTbx,
					   								SfxBindings& rBindings);
								~SimPopupWindowTbx();
								
	void						StartSelection() { aTbx.GetToolBox().StartSelection(); }
	virtual void				StateChanged( USHORT nSID, SfxItemState eState, SfxPoolItem* pPoolItem );
	virtual void				PopupModeEnd();
								
	virtual	SfxPopupWindow*		Clone() const;
};


/*************************************************************************
|*
|* 
|* 
\************************************************************************/

class SimTbxControl : public SfxToolBoxControl
{
public:

								SimTbxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
								~SimTbxControl() {}

	virtual SfxPopupWindowType	GetPopupWindowType() const;
	virtual SfxPopupWindow*		CreatePopupWindow();

	SFX_DECL_TOOLBOX_CONTROL();
};



#endif // _TBXCTRL_HXX
