#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: csaba $ $Date: 2000/10/16 15:06:56 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..
PRJNAME=sim
TARGET=simage3
LIBTARGET=NO
GEN_HID=TRUE

# --- Settings -----------------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

IENV!:=$(IENV);$(RES);..$/res

# --- OPTLINK ------------------------------------------------------------

# --- Files --------------------------------------------------------


RESLIB1LIST=\
	$(SRS)$/app.srs\
	$(SRS)$/dlg.srs\
	$(SRS)$/appmain.srs\
	$(SRS)$/simslots.srs \
	$(SOLARRESDIR)$/sfx.srs

.IF "$(GUI)"=="WIN"
RESLIBSPLIT1NAME=sim
RESLIBSPLIT1SRSFILES=\
	$(RESLIB1LIST)
.ELSE
RESLIB1NAME=sim
RESLIB1SRSFILES=\
	$(RESLIB1LIST)
.ENDIF

SHL1TARGET= sim$(UPD)$(DLLPOSTFIX)
SHL1VERSIONMAP = sim.map
.IF "$(GUI)" == "WNT"
SHL1RES=	$(RCTARGET)
.ENDIF
SHL1IMPLIB= simi

.IF "$(GUI)" == "MAC"
SHL1STDLIBS=					\
	$(TOOLSLIB)					\
	$(SVTOOLLIB)				\
	$(SVLLIB)					\
	$(SVLLIB)					\
	$(SVLIB)					\
	$(OSLLIB)					\
	$(SO2LIB)					\
	$(SOTLIB)					\
	$(SFX2LIB)					\
	$(GOODIESLIB)				\
	$(SVXLIB)					\
	$(PLUGCTORLIB)				\
	$(UTLLIB)					\
	$(UNOTOOLSLIB)				\
	$(UNOHELPERLIB)				\
    $(TKLIB)					\
	$(SALLIB)					\
	$(CPPULIB)					\
	$(CPPUHELPERLIB) 
.ELSE
SHL1STDLIBS=					\
	$(SFXLIB)					\
	$(SFXDEBUGLIB)				\
	$(SO2LIB)					\
	$(SVLIB)					\
	$(SVXLIB)					\
	$(GOODIESLIB)				\
	$(SVTOOLLIB)				\
	$(SVLLIB)					\
	$(SOTLIB)					\
	$(TOOLSLIB)					\
	$(UTLLIB)					\
	$(UNOTOOLSLIB)				\
	$(UNOHELPERLIB)				\
    $(TKLIB)					\
	$(SALLIB)					\
	$(CPPULIB)					\
	$(CPPUHELPERLIB) 
.ENDIF

.IF "$(TF_UCB)" == ""
SHL1STDLIBS+=\
		$(CHAOSLIB)
.ENDIF

.IF "$(GUI)" == "WNT"
SHL1STDLIBS+=\
	$(LIBPRE) gdi32.lib
.ENDIF

SHL1DEPN=	$(L)$/itools.lib
SHL1LIBS=	$(LIB3TARGET)

.IF "$(GUI)"!="UNX"
SHL1OBJS=	$(SLO)$/simdll.obj
.ENDIF

SHL1DEF=	$(MISC)$/$(SHL1TARGET).def
SHL1BASE=	0x1d200000

# --- Linken der Applikation ---------------------------------------


LIB2TARGET= $(SLB)$/simmod.lib
LIB2OBJFILES= $(SLO)$/simmod.obj

LIB3TARGET= $(SLB)$/sim.lib
LIB3FILES=	$(SLB)$/core.lib		\
			$(SLB)$/app.lib		\
			$(SLB)$/dlg.lib		\
			$(SLB)$/control.lib	\
			$(SLB)$/docshell.lib	\
			$(SLB)$/func.lib		\
			$(SLB)$/view.lib		\
			$(SLB)$/filter.lib

.IF "$(depend)" == ""

ALL: \
	$(SRS)$/hidother.hid\
	ALLTAR


.ENDIF

# --- Targets -------------------------------------------------------------

.INCLUDE :  target.mk

.IF "$(depend)" == ""

# -------------------------------------------------------------------------
# MAC
# -------------------------------------------------------------------------

.IF "$(GUI)" == "MAC"

MACRES= $(SV_RES)MPWToolCfrg.r -d SVTOOLNAME=""SV TOOL""

$(MISCX)$/$(APP1TARGET).def : makefile.mk
	@echo Keine def-Files fuer Applikationen auf Mac


$(MISC)$/$(SHL1TARGET).def:  makefile.mk
   @echo ------------------------------
   @echo Making: $@
	@echo CreateSimDrawDocShellDll 								>  $@
	@echo CreateObjSimDrawDocShellDll  							>> $@
	@echo InitSimDll  											>> $@
	@echo DeInitSimDll 											>> $@
	@echo SimUpdateClipBrd  									>> $@
	@echo SimGetBitmap 											>> $@
	@echo SimUpdate  											>> $@
	@echo SimReplaceGraphic 									>> $@
	@echo SimUpdateGraphic 										>> $@
	@echo SimGetGraphic  										>> $@
.ENDIF

.IF "$(GUI)" == "WNT"


$(MISCX)$/$(APP1TARGET).def : makefile.mk
	echo  NAME			simage								>$@
	echo  DESCRIPTION	'StarImage Version 1.00'           >>$@
	echo  DATA		READ WRITE NONSHARED		   >>$@
	echo  HEAPSIZE		0							   >>$@
	echo  STACKSIZE 	32000							   >>$@
.IF "$(OPTLINKS)" == "YES"
	echo  RC $(RCFLAGS) $(RES)$/simappi.res					  >>$@
.ENDIF


$(MISC)$/$(SHL1TARGET).def:  makefile.mk
    @echo ------------------------------
    @echo Making: $@
    @echo LIBRARY     $(SHL1TARGET)                                  >$@
    @echo DESCRIPTION 'SIMAGE3 DLL'                                 >>$@
    @echo DATA        READ WRITE NONSHARED                          >>$@
    @echo EXPORTS                                                   >>$@
	@echo 	CreateSimDrawDocShellDll @20                          	>>$@
	@echo 	CreateObjSimDrawDocShellDll @21    		    			>>$@
	@echo 	InitSimDll @22 											>>$@
	@echo 	DeInitSimDll @23										>>$@
	@echo 	SimUpdateClipBrd @24 									>>$@
	@echo 	SimGetBitmap @25 										>>$@
	@echo 	SimUpdate @26 											>>$@
	@echo 	SimReplaceGraphic @27 									>>$@
	@echo	SimUpdateGraphic @28									>>$@
	@echo	SimGetGraphic @29 										>>$@
.ENDIF

# -------------------------------------------------------------------------
# Presentation Manager 2.0
# -------------------------------------------------------------------------

.IF "$(GUI)" == "OS2"

$(MISCX)$/$(APP1TARGET).def : makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
	echo  NAME			simage WINDOWAPI						>$@
	echo  DESCRIPTION	'StarImage Version 1.00'           >>$@
.IF "$(COM)" != "TCPP"
	echo  STUB			'os2STUB.EXE'                      >>$@
.ENDIF
	echo  EXETYPE		OS2 							   >>$@
	echo  PROTMODE										   >>$@
	echo  CODE			LOADONCALL						   >>$@
	echo  DATA			PRELOAD MULTIPLE				   >>$@
	echo  HEAPSIZE		8192							   >>$@
	echo  STACKSIZE 	49152							   >>$@

$(MISC)$/$(SHL1TARGET).def:  makefile.mk
	@echo ================================================================
	@echo building $@
	@echo ----------------------------------------------------------------
.IF "$(COM)"!="WTC"
	echo  LIBRARY		INITINSTANCE TERMINSTANCE			>$@
	echo  DESCRIPTION	'SimDLL'           					>>$@
	echo  PROTMODE										   >>$@
    	@echo CODE        LOADONCALL 			              >>$@
	@echo DATA		  PRELOAD MULTIPLE NONSHARED					  >>$@
    	@echo EXPORTS                                                   >>$@
.IF "$(COM)"!="ICC"
	@echo _CreateSimDrawDocShellDll @2								>>$@
	@echo _CreateObjSimDrawDocShellDll @3 							>>$@
	@echo _InitSimDll @4											>>$@
	@echo _DeInitSimDll @5											>>$@
	@echo _SimUpdateClipbrd @6										>>$@
	@echo _SimUpdate @7												>>$@
	@echo _SimGetBitmap @8 											>>$@
	@echo _SimReplaceGraphic @9										>>$@
	@echo _SimUpdateGraphic @10										>>$@
	@echo _SimGetGraphic @11 										>>$@
.ELSE
	@echo CreateSimDrawDocShellDll @2								>>$@
	@echo CreateObjSimDrawDocShellDll @3 							>>$@
	@echo InitSimDll @4											>>$@
	@echo DeInitSimDll @5											>>$@
	@echo SimUpdate @7												>>$@
	@echo SimGetBitmap @8 											>>$@
	@echo SimReplaceGraphic @9										>>$@
	@echo SimUpdateGraphic @10										>>$@
	@echo SimGetGraphic @11 										>>$@
.ENDIF

.ELSE
    	@echo option DESCRIPTION 'SmDLL'		                    >$@
    	@echo name $(BIN)$/$(SHL1TARGET).dll                         >>$@
	@echo CreateSimDrawDocShellDll_ @2		>>temp.def
	@echo CreateObjSimDrawDocShellDll_ @3 	>>temp.def
	@echo InitSimDll_ @4					>>temp.def
	@echo DeInitSimDll_ @5					>>temp.def
	@echo SimUpdateClipBrd_ @6				>>temp.def
	@echo SimUpdate_ @7						>>temp.def
	@echo SimGetBitmap_ @8 					>>temp.def
	@echo SimReplaceGraphic_ @9				>>temp.def
	@echo SimUpdateGraphic_ @10				>>temp.def
	@echo SimGetGraphic_ @11 				>>temp.def
	@gawk -f s:\util\exp.awk temp.def				>>$@
	del temp.def
.ENDIF
.ENDIF

.IF "$(GUI)" != "MAC"
$(MISCX)$/$(SHL1TARGET).flt:
	@echo ------------------------------
	@echo Making: $@
	@echo WEP>$@
	@echo LIBMAIN>>$@
	@echo LibMain>>$@
	@echo SimApp>>$@
	@echo SimDrawDocShell>>$@
	@echo SimDrawDocument>>$@
	@echo SimDrawStdObjectBar>>$@
	@echo SimDrawView>>$@
	@echo SimDrawViewShell>>$@
	@echo SimDragServer>>$@
	@echo SimFuDraw>>$@
	@echo SimFuPoor>>$@
	@echo SimFuScale>>$@
	@echo SimFuSelelection>$@
	@echo SimFuZoom>>$@
	@echo SimFuContr>>$@
	@echo SimFuGamma>>$@
	@echo SimFuGray>>$@
	@echo SimFuMosaic>>$@
	@echo SimFuPoster>>$@
	@echo SimFuRelief>>$@
	@echo SimFuResize>>$@
	@echo SimFuRgb>>$@
	@echo SimFuRotate>>$@
	@echo SimPage>>$@
	@echo SimPageDlg>>$@
	@echo SimPool>>$@
	@echo SimPopupWindowTbx>>$@
	@echo SimPosition>>$@
	@echo SimResId>>$@
	@echo SimView>>$@
	@echo SimViewShell>>$@
	@echo SimWindow>>$@
	@echo SimStyleSheet>>$@
.ENDIF
.ENDIF


$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)$(CPU)"=="WNTI"
.IF "$(BUILD_SOSL)"==""
	@+-mhids hidother.src ..\$(INPATH)$/srs sim hidother
	@+echo NO HIDS !!!
.ENDIF
.ELSE
	@echo nix
.ENDIF

