/*************************************************************************
 *
 *  $RCSfile: IRmKeyCodes.java,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
package stardiv.unoctrl;

import java.awt.event.KeyEvent;

/**
 *	definition of the starview key codes
 */
public interface IRmKeyCodes
{

	public static final int JAVA_NUM_OFF		= KeyEvent.VK_0;
	public static final int JAVA_ALPHA_OFF		= KeyEvent.VK_A;
	public static final int JAVA_FUNC_OFF		= KeyEvent.VK_F1;

	public static final short KEYGROUP_NUM    = 0x0100;
	public static final short KEYGROUP_ALPHA  = 0x0200;
	public static final short KEYGROUP_FKEYS  = 0x0300;
	public static final short KEYGROUP_CURSOR = 0x0400;
	public static final short KEYGROUP_MISC   = 0x0500;
	public static final short KEYGROUP_TYPE   = 0x0F00;
	// Key-Codes
	public static final short SVKEY_0           = KEYGROUP_NUM+0;
	public static final short SVKEY_1           = KEYGROUP_NUM+1;
	public static final short SVKEY_2           = KEYGROUP_NUM+2;
	public static final short SVKEY_3           = KEYGROUP_NUM+3;
	public static final short SVKEY_4           = KEYGROUP_NUM+4;
	public static final short SVKEY_5           = KEYGROUP_NUM+5;
	public static final short SVKEY_6           = KEYGROUP_NUM+6;
	public static final short SVKEY_7           = KEYGROUP_NUM+7;
	public static final short SVKEY_8           = KEYGROUP_NUM+8;
	public static final short SVKEY_9           = KEYGROUP_NUM+9;
	public static final short SVKEY_A           = KEYGROUP_ALPHA+0;
	public static final short SVKEY_B           = KEYGROUP_ALPHA+1;
	public static final short SVKEY_C           = KEYGROUP_ALPHA+2;
	public static final short SVKEY_D           = KEYGROUP_ALPHA+3;
	public static final short SVKEY_E           = KEYGROUP_ALPHA+4;
	public static final short SVKEY_F           = KEYGROUP_ALPHA+5;
	public static final short SVKEY_G           = KEYGROUP_ALPHA+6;
	public static final short SVKEY_H           = KEYGROUP_ALPHA+7;
	public static final short SVKEY_I           = KEYGROUP_ALPHA+8;
	public static final short SVKEY_J           = KEYGROUP_ALPHA+9;
	public static final short SVKEY_K           = KEYGROUP_ALPHA+10;
	public static final short SVKEY_L           = KEYGROUP_ALPHA+11;
	public static final short SVKEY_M           = KEYGROUP_ALPHA+12;
	public static final short SVKEY_N           = KEYGROUP_ALPHA+13;
	public static final short SVKEY_O           = KEYGROUP_ALPHA+14;
	public static final short SVKEY_P           = KEYGROUP_ALPHA+15;
	public static final short SVKEY_Q           = KEYGROUP_ALPHA+16;
	public static final short SVKEY_R           = KEYGROUP_ALPHA+17;
	public static final short SVKEY_S           = KEYGROUP_ALPHA+18;
	public static final short SVKEY_T           = KEYGROUP_ALPHA+19;
	public static final short SVKEY_U           = KEYGROUP_ALPHA+20;
	public static final short SVKEY_V           = KEYGROUP_ALPHA+21;
	public static final short SVKEY_W           = KEYGROUP_ALPHA+22;
	public static final short SVKEY_X           = KEYGROUP_ALPHA+23;
	public static final short SVKEY_Y           = KEYGROUP_ALPHA+24;
	public static final short SVKEY_Z           = KEYGROUP_ALPHA+25;
	public static final short SVKEY_F1          = KEYGROUP_FKEYS+0;
	public static final short SVKEY_F2          = KEYGROUP_FKEYS+1;
	public static final short SVKEY_F3          = KEYGROUP_FKEYS+2;
	public static final short SVKEY_F4          = KEYGROUP_FKEYS+3;
	public static final short SVKEY_F5          = KEYGROUP_FKEYS+4;
	public static final short SVKEY_F6          = KEYGROUP_FKEYS+5;
	public static final short SVKEY_F7          = KEYGROUP_FKEYS+6;
	public static final short SVKEY_F8          = KEYGROUP_FKEYS+7;
	public static final short SVKEY_F9          = KEYGROUP_FKEYS+8;
	public static final short SVKEY_F10         = KEYGROUP_FKEYS+9;
	public static final short SVKEY_F11         = KEYGROUP_FKEYS+10;
	public static final short SVKEY_F12         = KEYGROUP_FKEYS+11;
	public static final short SVKEY_F13         = KEYGROUP_FKEYS+12;
	public static final short SVKEY_F14         = KEYGROUP_FKEYS+13;
	public static final short SVKEY_F15         = KEYGROUP_FKEYS+14;
	public static final short SVKEY_F16         = KEYGROUP_FKEYS+15;
	public static final short SVKEY_F17         = KEYGROUP_FKEYS+16;
	public static final short SVKEY_F18         = KEYGROUP_FKEYS+17;
	public static final short SVKEY_F19         = KEYGROUP_FKEYS+18;
	public static final short SVKEY_F20         = KEYGROUP_FKEYS+19;
	public static final short SVKEY_F21         = KEYGROUP_FKEYS+20;
	public static final short SVKEY_F22         = KEYGROUP_FKEYS+21;
	public static final short SVKEY_F23         = KEYGROUP_FKEYS+22;
	public static final short SVKEY_F24         = KEYGROUP_FKEYS+23;
	public static final short SVKEY_F25         = KEYGROUP_FKEYS+24;
	public static final short SVKEY_F26         = KEYGROUP_FKEYS+25;
	public static final short SVKEY_DOWN        = KEYGROUP_CURSOR+0;
	public static final short SVKEY_UP          = KEYGROUP_CURSOR+1;
	public static final short SVKEY_LEFT        = KEYGROUP_CURSOR+2;
	public static final short SVKEY_RIGHT       = KEYGROUP_CURSOR+3;
	public static final short SVKEY_HOME        = KEYGROUP_CURSOR+4;
	public static final short SVKEY_END         = KEYGROUP_CURSOR+5;
	public static final short SVKEY_PAGEUP      = KEYGROUP_CURSOR+6;
	public static final short SVKEY_PAGEDOWN    = KEYGROUP_CURSOR+7;
	public static final short SVKEY_RETURN      = KEYGROUP_MISC+0;
	public static final short SVKEY_ESCAPE      = KEYGROUP_MISC+1;
	public static final short SVKEY_TAB         = KEYGROUP_MISC+2;
	public static final short SVKEY_BACKSPACE   = KEYGROUP_MISC+3;
	public static final short SVKEY_SPACE       = KEYGROUP_MISC+4;
	public static final short SVKEY_INSERT      = KEYGROUP_MISC+5;
	public static final short SVKEY_DELETE      = KEYGROUP_MISC+6;
	public static final short SVKEY_ADD         = KEYGROUP_MISC+7;
	public static final short SVKEY_SUBTRACT    = KEYGROUP_MISC+8;
	public static final short SVKEY_MULTIPLY    = KEYGROUP_MISC+9;
	public static final short SVKEY_DIVIDE      = KEYGROUP_MISC+10;
	public static final short SVKEY_POINT       = KEYGROUP_MISC+11;
	public static final short SVKEY_COMMA       = KEYGROUP_MISC+12;
	public static final short SVKEY_LESS        = KEYGROUP_MISC+13;
	public static final short SVKEY_GREATER     = KEYGROUP_MISC+14;
	public static final short SVKEY_EQUAL       = KEYGROUP_MISC+15;
	public static final short SVKEY_OPEN        = KEYGROUP_MISC+16;
	public static final short SVKEY_CUT         = KEYGROUP_MISC+17;
	public static final short SVKEY_COPY        = KEYGROUP_MISC+18;
	public static final short SVKEY_PASTE       = KEYGROUP_MISC+19;
	public static final short SVKEY_UNDO        = KEYGROUP_MISC+20;
	public static final short SVKEY_REPEAT      = KEYGROUP_MISC+21;
	public static final short SVKEY_FIND        = KEYGROUP_MISC+22;
	public static final short SVKEY_PROPERTIES  = KEYGROUP_MISC+23;
	public static final short SVKEY_FRONT       = KEYGROUP_MISC+24;
	public static final short SVKEY_CONTEXTMENU = KEYGROUP_MISC+25;
	public static final short SVKEY_HELP        = KEYGROUP_MISC+26;
	// Modifier-Tasten
	public static final short KEY_SHIFT       = 0x1000;
	public static final short KEY_MOD1        = 0x2000;
	public static final short KEY_MOD2        = 0x4000;
	public static final int  KEY_MODTYPE     = 0xF000;
	// ---------------// - Mouse-Types -// ---------------
	public static final short MOUSE_LEFT      = 0x0001;
	public static final short MOUSE_MIDDLE    = 0x0002;
	public static final short MOUSE_RIGHT     = 0x0004;
}

