/*************************************************************************
 *
 *  $RCSfile: dtrans.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DTRANS_HXX
#define _DTRANS_HXX

#ifndef _SOT_DTRANS_HXX
#include <sot/dtrans.hxx>
#endif
#ifndef _SV_EVENT_HXX
#include <vcl/event.hxx>
#endif
#ifndef _SV_WINDOW_HXX
#include <vcl/window.hxx>
#endif
#ifndef _IFACE_HXX
#include <iface.hxx>
#endif

//========================================================================
struct tagFORMATETC;
typedef struct tagFORMATETC FORMATETC;
struct tagSTGMEDIUM;
typedef struct tagSTGMEDIUM STGMEDIUM;

//========================================================================
#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif

#ifndef SO2_DECL_SVSTORAGESTREAM_DEFINED
#define SO2_DECL_SVSTORAGESTREAM_DEFINED
SO2_DECL_REF(SvStorageStream)
#endif

//========================================================================
#ifndef SO2_DECL_SVDATAOBJECT_DEFINED
#define SO2_DECL_SVDATAOBJECT_DEFINED
SO2_DECL_REF(SvDataObject)
#endif

#ifndef SO2_DECL_SVDATAMEMBEROBJECT_DEFINED
#define SO2_DECL_SVDATAMEMBEROBJECT_DEFINED
SO2_DECL_REF(SvDataMemberObject)
#endif

class DropEvent;
class ImpDataObject;
struct IDataObject;
class Pointer;
class Window;
class Region;
class SvDataObject : virtual public SvObject, public SotDataObject
/*	[Beschreibung]

	Diese Klasse beschreibt, wie Daten von einem Objekt abgeholt oder
	in ein Objekt eingesetzt werden k"onnen. Das wichtigste
	Designkriterium ist, dass der eigentliche Austausch der Daten vom
	"wie komme ich an die Daten (z.B. D&D, Clipboard)" getrennt ist.

	[Anmerkung]

	Dioe Schnittstellen f"ur D&D und das Clipboard sind nur vorl"aufig.
*/
{
friend ImpDataObject;
friend class SvFactory;
	SvDataTypeList *	pTypeList;
	SvDataTypeList *	pSetDataTypeList;
	IDataObject *   	pObjI;
	static void         FlushClipboard();
protected:

	void				Impl_SetTypeList( const SvDataTypeList & );
	void				Impl_SetSetDataTypeList( const SvDataTypeList & );

	const SvDataTypeList & Impl_GetTypeList() const;
	const SvDataTypeList & Impl_GetSetDataTypeList() const;
	void				SetTypeList( const SvDataTypeList & );
	void				SetSetDataTypeList( const SvDataTypeList & );
	BOOL                IsTypeListSet() const { return pTypeList!=NULL; }
	BOOL                IsSetDataTypeListSet() const
						{ return pSetDataTypeList != NULL; }

						~SvDataObject();
public:
					SvDataObject();
					SO2_DECL_STANDARD_CLASS_DLL(SvDataObject,SOAPP)
	IDataObject *	GetDataObject() const;
	virtual const SvDataTypeList & GetTypeList() const;
	virtual const SvDataTypeList & GetSetDataTypeList() const;

	virtual BOOL    SetData( SvData * );
	virtual BOOL    GetData( SvData * );
	virtual BOOL    GetDataHere( SvData * );
	virtual BOOL    QueryDataType( SvDataType & rInOutType );
	BOOL            HasFormat( const SvDataType & rType ) const;

	virtual SvDataMemberObjectRef CreateSnapshot();

	BOOL            CopyClipboard();
	static SvDataObjectRef PasteClipboard();
	DropAction      ExecuteDrag( Window * pSource,
								 const Pointer& rMovePtr,
								 const Pointer& rCopyPtr,
								 USHORT nOptions = DRAG_ALL,
								 const Region* pDropRegion = NULL );
	DropAction      ExecuteDrag( Window * pSource,
								 const Pointer& rMovePtr,
								 const Pointer& rCopyPtr,
								 const Pointer& rLinkPtr,
								 USHORT nOptions = DRAG_ALL,
								 const Region* pDropRegion = NULL );
	static SvDataObjectRef PasteDragServer( const DropEvent & rEvt );

	static USHORT   Ole2SvAspect( ULONG nAspectP );
	static ULONG    Sv2OleAspect( USHORT nAspectP );

	static void		SetupType( SvDataType & rType, const FORMATETC * pFormat );
	static void		FillSysFormat( const SvDataType & rType, FORMATETC * pFormat );

	static void    SetSysData( SvData & rData, FORMATETC *, STGMEDIUM *, BOOL bConvert = TRUE,
						TransferOperation = TRANSFER_MOVE );
	static BOOL    GetSysData( SvData & rData, USHORT nTymed, STGMEDIUM * pMed, TransferOperation = TRANSFER_MOVE );
	static BOOL    GetSysData( SvData & rData, FORMATETC * pAsk, STGMEDIUM * pMed, TransferOperation = TRANSFER_MOVE );
};
SO2_IMPL_REF(SvDataObject)

/*************** SvDataMemberObject **************************************
*************************************************************************/
class SvDataMemberObject : public SvDataObject
/*	[Beschreibung]

	Diese Klasse ist f"ur einfache Applikationen, die kein
	"Delayed Rendering" f"ur den Datenaustausch nutzen wollen.
	Noch ein Punkt ist das hinzuf"ugen weiterer Formate, unabh"angig
	vom Objekt, welches die Inhaltsdaten liefert.
	Z.B. ein Ole-Container f"ugt noch die Daten f"ur das Linkformat
	auf ein eingebettetes Objekt hinzu.

	[Anmerkung]

	Dioe Schnittstellen f"ur D&D und das Clipboard sind nur vorl"aufig.
*/
{
	SvDataList          aDataList;
	SvDataTypeList      aTypeList;
	SvDataObjectRef		xExtObj;
public:
					SvDataMemberObject();
					SvDataMemberObject( SvDataObject * pExtObj );
					~SvDataMemberObject();

	virtual const SvDataTypeList & GetTypeList() const;
	virtual BOOL    GetData( SvData * );
	virtual BOOL    GetDataHere( SvData * );

	SvDataList &    GetDataList() { return aDataList; }
	void            Append( SvData * );
};
SO2_IMPL_REF(SvDataMemberObject)

#endif // _DTRANS_HXX
