/*************************************************************************
 *
 *  $RCSfile: lnkbase.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _LNKBASE_HXX
#define _LNKBASE_HXX

#ifndef _EXCHANGE_HXX //autogen
#include <vcl/exchange.hxx>
#endif
#ifndef _DTRANS_HXX
#include <dtrans.hxx>
#endif
#ifndef _LINKNAME_HXX
#include <linkname.hxx>
#endif
#ifndef _PSEUDO_HXX
#include <pseudo.hxx>
#endif
#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif


#ifndef SO2_DECL_SVLINKNAME_DEFINED
#define SO2_DECL_SVLINKNAME_DEFINED
SO2_DECL_REF(SvLinkName)
#endif

#ifndef SO2_DECL_SVPSEUDOOBJECT_DEFINED
#define SO2_DECL_SVPSEUDOOBJECT_DEFINED
SO2_DECL_REF(SvPseudoObject)
#endif

#define	OBJECT_INTERN		0x00
#define	OBJECT_SO_EXTERN	0x01
#define	OBJECT_DDE_EXTERN	0x02

#define	OBJECT_CLIENT_SO			0x80 // ein Link
#define	OBJECT_CLIENT_DDE			0x81
#define	OBJECT_CLIENT_OLE			0x82 // ein Ole-Link
#define	OBJECT_CLIENT_OLE_CACHE  	0x83 // ein Ole-Link mit SvEmbeddedObject
#define	OBJECT_CLIENT_FILE			0x90
#define	OBJECT_CLIENT_GRF			0x91


enum {
	// Ole2 compatibel und persistent
	LINKUPDATE_ALWAYS = 1,
	LINKUPDATE_ONCALL = 3,

	LINKUPDATE_END		// dummy!
};

struct ImplBaseLinkData;

/***************************************************************************/
struct Impl_LinkTime
{
	UINT32	nLowTime;
	UINT32	nHighTime;

					Impl_LinkTime();
					Impl_LinkTime( UINT32 nLow, UINT32 nHigh )
					  : nLowTime( nLow ), nHighTime( nHigh ) {}
					Impl_LinkTime( const Date &, const Time & );

	Date			GetDate() const; // not impl
	Time			GetTime() const; // not impl

	friend SvStream &	operator << ( SvStream & rStm, const Impl_LinkTime & );
	friend SvStream &	operator >> ( SvStream & rStm, Impl_LinkTime & );
};

/***************************************************************************/
struct Impl_LinkInfo
{
	USHORT 			nUpdateMode;
	SvLinkNameRef	xLinkMoniker; // Name des Links im Container
	SvLinkNameRef	xRelMoniker;
	SvLinkNameRef	xMoniker;
	SvGlobalName	aLastClass;
	String			aLastDisplayStr;
	Impl_LinkTime	aChangeOfUpdate;
	Impl_LinkTime	aKnownUpToDate;
	Impl_LinkTime	aUpdate;

					Impl_LinkInfo();

	friend SvStream &	operator << ( SvStream & rStm, const Impl_LinkInfo & );
	friend SvStream &	operator >> ( SvStream & rStm, Impl_LinkInfo & );
};

/***************************************************************************/
class SvEmbeddedObject;
class SvBaseLink : public SvAdviseSink
{
	friend class SvLinkManager;
	friend class SvPseudoObject;

	SvPseudoObjectRef xObj;
	SvLinkNameRef 	xLinkName;
	SvLinkManager* 	pLinkMgr;
	USHORT 			nObjType;
	BOOL			bVisible : 1;
	BOOL			bSynchron : 1;
	BOOL			bUseCache : 1;		// fuer GrafikLinks!

	void 			Impl_InitCtor( SvLinkName*, USHORT nObjectType,
								   SvPseudoObject* );
protected:
	void			SetObjType( USHORT );

					// setzen des LinkSourceName ohne aktion
	void			SetName( SvLinkName * );
					// LinkSourceName der im SvLinkBase steht
	SvLinkName * 	GetName() const;
	SvLinkName *	GetCacheName() const;

	void			SetObj( SvPseudoObject * pObj );
	void			SetCacheObj( SvEmbeddedObject * pObj );
	SvEmbeddedObject* GetCacheObj() const;

	void            SetLinkInfo( Impl_LinkInfo & );
	Impl_LinkInfo * GetLinkInfo() const;

	ImplBaseLinkData* pImplData;

					SvBaseLink();
					SvBaseLink( USHORT nLinkType, ULONG nContentType = FORMAT_STRING );
	virtual 		~SvBaseLink();

	void 			_GetRealObject( BOOL bConnect = TRUE );

	SvPseudoObject* GetRealObject()
					{
						if( !xObj.Is() )
							_GetRealObject();
						return xObj;
					}

	virtual void    Closed();
	virtual void	Load( SvStream & rStm );
	virtual void	Save( SvStream & rStm );

public:
					TYPEINFO();
	static USHORT	PersistId() { return 1; }
	virtual USHORT	GetPersistId();

					SvBaseLink( const String& rNm, USHORT nObjectType,
								 SvPseudoObject* );
					SvBaseLink( SvLinkName*, USHORT nObjectType,
								 SvPseudoObject* );

	friend SvStream & operator << ( SvStream & rStm, SvBaseLink & rThis )
				{
					rThis.Save( rStm );
					return rStm;
				}
	friend SvStream & operator >> ( SvStream & rStm, SvBaseLink & rThis )
				{
					rThis.Load( rStm );
					return rStm;
				}


	USHORT			GetObjType() const { return nObjType; }
							// So2 konvention, Obj statt Object
	SvPseudoObject*			GetObj() const	{ return xObj; }
	const SvPseudoObject*	GetObject() const	{ return xObj; }
		  SvPseudoObject*	GetObject() 		{ return xObj; }

	void    			SetLinkSourceName( SvLinkName * );
	const SvLinkName* 	GetLinkSourceName() const;
		  SvLinkName* 	GetLinkSourceName();

	virtual void 	DataChanged( SvData& rData );

	void			SetUpdateMode( USHORT );
	USHORT 			GetUpdateMode() const;
	ULONG  			GetContentType() const;
	BOOL 			SetContentType( ULONG nType );
	USHORT 			GetObjectType() const { return nObjType; }

	SvLinkManager*	GetLinkManager()			{ return pLinkMgr; }
	const SvLinkManager* GetLinkManager() const	{ return pLinkMgr; }

	BOOL			Update();
	void			Disconnect();

	void 			ShowError( Window * = NULL ) const;
	virtual BOOL 	Edit( Window* );

		// soll der Link im Dialog angezeigt werden ? (Links im Link im ...)
	BOOL 	        IsVisible() const   		{ return bVisible; }
	void 	        SetVisible( BOOL bFlag )	{ bVisible = bFlag; }
		// soll der Link synchron oder asynchron geladen werden?
	BOOL 	        IsSynchron() const   		{ return bSynchron; }
	void 	        SetSynchron( BOOL bFlag )	{ bSynchron = bFlag; }

	BOOL 	        IsUseCache() const   		{ return bUseCache; }
	void 			SetUseCache( BOOL bFlag )	{ bUseCache = bFlag; }
};

#ifndef SO2_DECL_SVBASELINK_DEFINED
#define SO2_DECL_SVBASELINK_DEFINED
SO2_DECL_REF(SvBaseLink)
#endif
SO2_IMPL_REF( SvBaseLink )



#endif

