/*************************************************************************
 *
 *  $RCSfile: svuidlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <vcl/dialog.hxx>
#include <vcl/group.hxx>
#include <vcl/fixed.hxx>
#include <vcl/button.hxx>
#include <vcl/edit.hxx>
#include <vcl/lstbox.hxx>

#include <svtools/svmedit.hxx>	// MultiLineEdit

// class MdPasteObject ---------------------------------------------------

class MdPasteObject : public ModalDialog
{
protected:
    FixedText aFtSource;
    FixedText aFtObjectSource;
    GroupBox aGbSource;
    RadioButton aRbPaste;
    RadioButton aRbPasteLink;
    ListBox aLbInsertList;
    CheckBox aCbDisplayAsIcon;
    PushButton aPbChangeIcon;
    GroupBox aGbChoice;
    FixedBitmap aFbResult;
    FixedText aFtResult;
    GroupBox aGbResult;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    String aSObject;
public:
    MdPasteObject( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdUpdateBaselinks -----------------------------------------------

class MdUpdateBaselinks : public ModalDialog
{
protected:
    FixedText aFtFiles;
    FixedText aFtLinks;
    FixedText aFtType;
    FixedText aFtStatus;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    PushButton aPbUpdateNow;
    PushButton aPbOpenSource;
    PushButton aPbChangeSource;
    PushButton aPbBreakLink;
    FixedText aFtFiles2;
    FixedText aFtSource2;
    FixedText aFtType2;
    FixedText aFtUpdate;
    RadioButton aRbAutomatic;
    RadioButton aRbManual;
    FixedText aFtFullFileName;
    FixedText aFtFullSourceName;
    FixedText aFtFullTypeName;
    String aStrAutolink;
    String aStrManuallink;
    String aStrBrokenlink;
    String aStrGraphiclink;
    String aStrButtonclose;
    String aStrCloselinkmsg;
    String aStrCloselinkmsgMulti;
    String aStrWaitinglink;
public:
    MdUpdateBaselinks( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdDdeLinkedit ---------------------------------------------------

class MdDdeLinkedit : public ModalDialog
{
protected:
    FixedText aFtDdeApp;
    Edit aEdDdeApp;
    FixedText aFtDdeTopic;
    Edit aEdDdeTopic;
    FixedText aFtDdeItem;
    Edit aEdDdeItem;
    GroupBox aGroupDdeChg;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
public:
    MdDdeLinkedit( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdLinkedit ------------------------------------------------------

class MdLinkedit : public ModalDialog
{
protected:
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    FixedText aFtFullTypeName;
    FixedText aFixedText2;
    Edit aEdFullSourceName;
public:
    MdLinkedit( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertObjectPlugin --------------------------------------------

class MdInsertObjectPlugin : public ModalDialog
{
protected:
    Edit aEdFileurl;
    PushButton aBtnFileurl;
    GroupBox aGbFileurl;
    MultiLineEdit aEdPluginsOptions;
    GroupBox aGbPluginsOptions;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
public:
    MdInsertObjectPlugin( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertObjectApplet --------------------------------------------

class MdInsertObjectApplet : public ModalDialog
{
protected:
    FixedText aFtClassfile;
    Edit aEdClassfile;
    FixedText aFtClasslocation;
    Edit aEdClasslocation;
    PushButton aBtnClass;
    GroupBox aGbClass;
    MultiLineEdit aEdAppletOptions;
    GroupBox aGbAppletOptions;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
public:
    MdInsertObjectApplet( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};

// class MdInsertOleobject -----------------------------------------------

class MdInsertOleobject : public ModalDialog
{
protected:
    RadioButton aRbNewObject;
    RadioButton aRbObjectFromfile;
    ListBox aLbObjecttype;
    Edit aEdFilepath;
    PushButton aBtnFilepath;
    CheckBox aCbFilelink;
    GroupBox aGbObject;
    OKButton aOKButton1;
    CancelButton aCancelButton1;
    HelpButton aHelpButton1;
    String aStrFile;
public:
    MdInsertOleobject( Window * pParent, const ResId & rResId, BOOL bFreeRes = TRUE );
};


