/*************************************************************************
 *
 *  $RCSfile: advise.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>


#include <advise.hxx>
#include <tools/debug.hxx>
#include <vcl/timer.hxx>
#include <so2dll.hxx>
#include <soerr.hxx>
#pragma hdrstop

/************** class SvAdviseSink **************************************/
SV_OLE_FACTORY(SvAdviseSinkFactory)
	{
	}
};
TYPEINIT1(SvAdviseSinkFactory,SvOleFactory);

SO2_IMPL_STANDARD_CLASS1_DLL(SvAdviseSink,SvAdviseSinkFactory,SvObject,
							 0x674AC3A0L, 0x81E3, 0x101B,
							 0x80, 0x4C, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD )

IUnknown * SvAdviseSink::GetMemberInterface( const SvGlobalName & )
{
	return NULL;
}

void SvAdviseSink::TestMemberObjRef( BOOL /*bFree*/ )
{
#ifdef DBG_UTIL
	if( xAdvise.Is() )
	{
		ByteString aTest = "\t\txAdvise == ";
		aTest.Append( ByteString::CreateFromInt32( (ULONG)(SvObject *)xAdvise ) );
		DBG_TRACE( aTest.GetBuffer() );
	}
#endif
}

#ifdef TEST_INVARIANT
void SvAdviseSink::TestMemberInvariant( BOOL /*bPrint*/ )
{
}
#endif

/************************************************************************
|*    SvAdviseSink::SvAdviseSink()
|*
|*    Beschreibung
*************************************************************************/
SvAdviseSink::SvAdviseSink()
{
	pObjI       = NULL;
	pAdviseSink = NULL;
	if( !SOAPP->pASIndexList )
		SOAPP->pASIndexList = new SvAdviseSinkIndex( 1 ); // darf nicht 0 sein
	SOAPP->pASIndexList->Insert( this );
}

SvAdviseSink::~SvAdviseSink()
{
	SOAPP->pASIndexList->Remove( SOAPP->pASIndexList->GetIndex( this ) );
	if( 0 == SOAPP->pASIndexList->Count() )
	{
		delete SOAPP->pASIndexList;
		SOAPP->pASIndexList = NULL;
	}
}

/*************************************************************************
|*    SvAdviseSink::ViewChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvAdviseSink::ViewChanged( USHORT nAspectsP )
{
}

/*************************************************************************
|*    SvAdviseSink::DataChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvAdviseSink::DataChanged( SvData & rData )
{
}

/*************************************************************************
|*    SvAdviseSink::Closed()
|*
|*    Beschreibung
*************************************************************************/
void SvAdviseSink::Closed()
{
}

/*************************************************************************
|*    SvAdviseSink::Saved()
|*
|*    Beschreibung
*************************************************************************/
void SvAdviseSink::Saved()
{
}

/*************************************************************************
|*    SvAdviseSink::Get()
|*
|*    Beschreibung
*************************************************************************/
SvAdviseSink * SvAdviseSink::Get( ULONG nUniqueId )
{
	return SOAPP->pASIndexList ? SOAPP->pASIndexList->Get( nUniqueId ) : NULL;
}

/*************************************************************************
|*    SvAdviseSink::GetUniqueId()
|*
|*    Beschreibung
*************************************************************************/
ULONG SvAdviseSink::GetUniqueId() const
{
	return SOAPP->pASIndexList->GetIndex( (SvAdviseSink *)this );
}

/************** class SvAdviseTimer *********************************/
/*********************************************************************
|*    SvAdviseTimer::SvAdviseTimer()
|*
|*    Beschreibung
*********************************************************************/
class SvAdviseTimer : public Timer
{
	SvAdvise *  pOwner;
	virtual void    Timeout();
public:
			SvAdviseTimer( SvAdvise * pOwn );
};

SvAdviseTimer::SvAdviseTimer( SvAdvise * pOwn )
	: pOwner( pOwn )
{
}

void SvAdviseTimer::Timeout()
{
	// sicher gegen zerstoeren im Handler
	pOwner->pTimer = NULL;
	SvAdviseRef aAdv( pOwner );
	SvData aData;
	pOwner->SendDataChanged( aData );
	pOwner->SendViewChanged();
	delete this;
}

/************** class SvAdvSelector *********************************/
TYPEINIT0(SvAdvSelector)
SvAdvSelector::SvAdvSelector( SvAdviseSink * pSink, USHORT nAdvTypes )
	: aSink( pSink )
	, nAdviseTypes( nAdvTypes )
{
}

SvAdvSelector::~SvAdvSelector() {}

TYPEINIT1(SvAdvDataSelector,SvAdvSelector)
SvAdvDataSelector::SvAdvDataSelector( SvAdviseSink * pSink,
									  const SvDataType & rType,
									  USHORT nAdvModes )
	: SvAdvSelector( pSink, ADVISE_DATA )
	, nAdviseModes( nAdvModes )
	, aType( rType )
	, nConnectNo( 0 )
	, bModified( FALSE )
{
}

TYPEINIT1(SvAdvViewSelector,SvAdvSelector)
SvAdvViewSelector::SvAdvViewSelector( SvAdviseSink * pSink,
									  USHORT nViewAsps,
									  USHORT nAdvModes )
	: SvAdvSelector( pSink, ADVISE_VIEW )
	, nAdviseModes( nAdvModes )
	, nViewAspects( nViewAsps )
	, nModifiedAspects( 0 )
{
}

TYPEINIT1(SvAdvConnectSelector,SvAdvSelector)
SvAdvConnectSelector::SvAdvConnectSelector( SvAdviseSink * pSink,
											USHORT nAdvTypes )
	: SvAdvSelector( pSink, nAdvTypes )
	, nConnectNo( 0 )
{
}

/************** class SvAdvise **************************************/
SO2_IMPL_STANDARD_CLASS1_DLL(SvAdvise,SvFactory,SvObject,
							 0xC38233E0L, 0x8212, 0x101B,
							 0x80, 0x4C, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD )

IUnknown * SvAdvise::GetMemberInterface( const SvGlobalName & /*rName*/ )
{
	return NULL;
}

void SvAdvise::TestMemberObjRef( BOOL /*bFree*/ )
{
#ifdef DBG_UTIL
	if( GetSelectorCount() )
	{
		for( ULONG i = 0; i < pSelectorList->Count(); i++ )
		{
			SvAdvSelector * pSel = pSelectorList->GetObject( i );
			if( pSel->GetSink() )
			{
				ByteString aTest = "\t\tpSelectorList[";
				aTest.Append( ByteString::CreateFromInt32( i ) );
				aTest.Append( "].aSink == " );
				aTest.Append( ByteString::CreateFromInt32( (ULONG)(SvObject *)pSel->GetSink() ) );
				DBG_TRACE( aTest.GetBuffer() )
			}
		}
	}
#endif
}

#ifdef TEST_INVARIANT
void SvAdvise::TestMemberInvariant( BOOL /*bPrint*/ )
{
}
#endif

/************************************************************************
|*    SvAdvise::SvAdvise()
|*
|*    Beschreibung
*************************************************************************/
SvAdvise::SvAdvise()
	: pTimer( NULL )
	, nTimeout( 3000 )
	, pSelectorList( NULL )
{
}

SvAdvise::~SvAdvise()
{
	delete pTimer;
	ClearSelectorList();
	delete pSelectorList;
}

void SvAdvise::ClearSelectorList()
{
	if( pSelectorList )
	{
		SvAdvSelector * pObj = pSelectorList->First();
		while( pObj )
		{
			delete pObj;
			pObj = pSelectorList->Next();
		}
		pSelectorList->Clear();
	}
}

/************************************************************************
|*    SvAdvise::StartTimer()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::StartTimer( BOOL bNewTimeOut )
{
	if( !pTimer )
	{
		pTimer = new SvAdviseTimer( this );
		pTimer->SetTimeout( nTimeout );
		pTimer->Start();
	}
	else if( bNewTimeOut )
		pTimer->Start();
}

/************************************************************************
|*    SvAdvise::SetUpdateTimeout()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::SetUpdateTimeout( ULONG nTime )
{
	nTimeout = nTime;
	if( pTimer )
		pTimer->SetTimeout( nTimeout );
}

ULONG SvAdvise::GetUpdateTimeout() const
{
	return pTimer ? pTimer->GetTimeout() : nTimeout;
}

/*************************************************************************
|*    SvAdvise::GetSelectorList()
|*    SvAdvise::Clear()
|*    SvAdvise::ClearExtern()
|*    SvAdvise::Remove()
|*
|*    Beschreibung
*************************************************************************/
SvAdvSelectorList & SvAdvise::GetSelectorList()
{
	if( !pSelectorList )
		pSelectorList = new SvAdvSelectorList();
	return *pSelectorList;
}

void SvAdvise::Clear()
{
	ClearSelectorList();
}
void SvAdvise::ClearExternDataAdvises()
{
	if( pSelectorList )
		for( ULONG i = pSelectorList->Count(); i > 0; )
		{
			i--;
			SvAdvDataSelector * pD;
			pD = PTR_CAST( SvAdvDataSelector, pSelectorList->GetObject( i ) );
			if( pD && pD->GetSink()->Owner() )
				delete pSelectorList->Remove( i );
		}
}
void SvAdvise::ClearExtern()
{
	if( pSelectorList )
		for( ULONG i = pSelectorList->Count(); i > 0; )
		{
			i--;
			if( !pSelectorList->GetObject( i )->GetSink()->Owner() )
				delete pSelectorList->Remove( i );
		}
}
void SvAdvise::Remove( SvAdvSelector * pSel )
{
	if( pSelectorList )
		delete pSelectorList->Remove( pSel );
}

void SvAdvise::SendDataOnStop()
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvViewSelector * pView = PTR_CAST(SvAdvViewSelector,pSel);
			SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
			if( pView )
				pView->nAdviseModes &= ~ADVISEMODE_DATAONSTOP;
			else if( pData )
				pData->nAdviseModes &= ~ADVISEMODE_DATAONSTOP;
			pSel = pSelectorList->Next();
		}
		SendViewChanged();
		SvData aSvData;
		SendDataChanged( aSvData );
	}
}
/*************************************************************************
|*    SvAdvise::Sv2OleAdviseModes()
|*    SvAdvise::Ole2SvAdviseModes()
|*
|*    Beschreibung
*************************************************************************/
ULONG SvAdvise::Sv2OleAdviseModes( USHORT nSvModes )
{
	// 1 zu MS-W
	return nSvModes;
}

USHORT SvAdvise::Ole2SvAdviseModes( ULONG nSysModes )
{
	return (USHORT)nSysModes;
}

/*************************************************************************
|*    SvAdvise::GetDataSelector()
|*    SvAdvise::GetViewSelector()
|*    SvAdvise::GetConnectSelector()
|*
|*    Beschreibung
*************************************************************************/
SvAdvDataSelector * SvAdvise::GetDataSelector( ULONG nConnect ) const
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
			if( pData && pData->GetSink()->GetUniqueId() == nConnect )
				return pData;
			pSel = pSelectorList->Next();
		}
	}
	return NULL;
}

SvAdvViewSelector * SvAdvise::GetViewSelector() const
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			// nur externe Anmeldung
			SvAdvViewSelector * pView = PTR_CAST(SvAdvViewSelector,pSel);
			if( pView && !pView->GetSink()->Owner() )
				return pView;
			pSel = pSelectorList->Next();
		}
	}
	return NULL;
}

SvAdvConnectSelector * SvAdvise::GetConnectSelector( ULONG nConnect ) const
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvConnectSelector * pCon = PTR_CAST(SvAdvConnectSelector,pSel);
			if( pCon && pCon->GetSink()->GetUniqueId() == nConnect )
				return pCon;
			pSel = pSelectorList->Next();
		}
	}
	return NULL;
}

/*************************************************************************
|*    SvAdvise::AddViewAdvise()
|*    SvAdvise::RemoveViewAdvise()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvAdvise::AddViewAdvise( SvAdviseSink * pSink, USHORT nAspects,
							  USHORT nAdviseModes )
{
	if( Owner() )
	{
		SvAdvViewSelector * pSel = new SvAdvViewSelector( pSink, nAspects,
														  nAdviseModes );
		GetSelectorList().Insert( pSel, LIST_APPEND );
		if( nAdviseModes & ADVISEMODE_PRIMEFIRST )
		{
			pSel->nModifiedAspects |= nAspects;
			StartTimer( FALSE ); // Timeout nicht neu
			DBG_ASSERT( pTimer, "no timer created" )
			pTimer->SetTimeout( 0 );
		}
		return TRUE;
	}
	return FALSE;
}

void SvAdvise::RemoveViewAdvise( SvAdviseSink * pSink, USHORT nAspects )
{
	if( Owner() )
	{
		// Liste wird erzeugt, wenn nicht vorhanden
		SvAdvSelector * pSel = GetSelectorList().First();
		while( pSel )
		{
			SvAdvViewSelector * pView = PTR_CAST(SvAdvViewSelector,pSel);
			if( pView && pView->GetSink() == pSink
			  && pView->GetViewAspects() == nAspects )
			{
				ULONG nCur = pSelectorList->GetCurPos();
				if( pView->nModifiedAspects )
				{
					ULONG nCur = pSelectorList->GetCurPos();
					// vor beenden senden, und nicht automatisch
					// herrausnehmen
					pView->nAdviseModes &= ~(ADVISEMODE_DATAONSTOP
											 | ADVISEMODE_ONLYONCE);
					SendViewChanged();
					pSelectorList->Seek( nCur );
				}
				delete pSelectorList->Remove( nCur );
				break;
			}
			// Liste ist auf jeden Fall da
			pSel = pSelectorList->Next();
		}
	}
}

/*************************************************************************
|*    SvAdvise::AddData()
|*    SvAdvise::RemoveData()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvAdvise::AddDataAdvise( SvAdviseSink * pSink, const SvDataType & rType,
							  USHORT nAdviseModes )
{
	if( Owner() )
	{
		SvAdvDataSelector * pSel = new SvAdvDataSelector( pSink, rType,
														  nAdviseModes );
		GetSelectorList().Insert( pSel, LIST_APPEND );
		if( nAdviseModes & ADVISEMODE_PRIMEFIRST )
		{
			pSel->bModified = TRUE;
			StartTimer( FALSE ); // Timeout nicht neu
			DBG_ASSERT( pTimer, "no timer created" )
			pTimer->SetTimeout( 0 );
		}
		return TRUE;
	}
	return FALSE;
}

void SvAdvise::RemoveDataAdvise( ULONG nPos )
{
	// Liste wird erzeugt, wenn nicht vorhanden
	SvAdvSelector * pSel      = GetSelectorList().GetObject( nPos );
	SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);

	ULONG nCur = pSelectorList->GetCurPos();
	if( Owner() )
	{
		if( pData->bModified )
		{
			// vor beenden senden, und nicht automatisch
			// herrausnehmen
			pData->nAdviseModes &= ~(ADVISEMODE_DATAONSTOP
									 | ADVISEMODE_ONLYONCE);
			SvData aData;
			SendDataChanged( aData );
		}
	}
	delete pSelectorList->Remove( nCur );
}

void SvAdvise::RemoveDataAdvise( SvAdviseSink * pSink,
								 const SvDataType & rType )
{
	// Liste wird erzeugt, wenn nicht vorhanden
	SvAdvSelector * pSel = GetSelectorList().First();
	while( pSel )
	{
		SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
		if( pData && pData->GetSink() == pSink
		  && pData->GetType() == rType )
		{
			RemoveDataAdvise( pSelectorList->GetCurPos() );
			break;
		}
		pSel = pSelectorList->Next();
	}
}

void SvAdvise::RemoveDataAdvise( SvAdviseSink * pSink )
{
	// Loesche den ersten Selektor des AdviseSinks
	// Liste wird erzeugt, wenn nicht vorhanden
	SvAdvSelector * pSel = GetSelectorList().First();
	while( pSel )
	{
		SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
		if( pData && pData->GetSink() == pSink )
		{
			RemoveDataAdvise( pSelectorList->GetCurPos() );
			break;
		}
		// Liste ist auf jeden Fall da
		pSel = pSelectorList->Next();
	}
}


void SvAdvise::RemoveAllDataAdvise( SvAdviseSink * pSink )
{
	// Loesche alle Selektorem des AdviseSinks, die angemeldet sind
	BOOL bDel = TRUE;
	while( bDel )
	{
		bDel = FALSE;
		// Liste wird erzeugt, wenn nicht vorhanden
		SvAdvSelector * pSel = GetSelectorList().First();
		while( pSel )
		{
			SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
			if( pData && pData->GetSink() == pSink )
			{
				RemoveDataAdvise( pSelectorList->GetCurPos() );
				bDel = TRUE;
				break;
			}
			// Liste ist auf jeden Fall da
			pSel = pSelectorList->Next();
		}
	}
}

/*************************************************************************
|*    SvAdvise::AddConnectAdvise()
|*    SvAdvise::RemoveConnectAdvise()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvAdvise::AddConnectAdvise( SvAdviseSink * pSink, USHORT nAdviseTypes )
{
	DBG_ASSERT( nAdviseTypes & ADVISE_CONNECTSTD, "wrong advise types" )
	if( Owner() )
	{
		SvAdvSelector * pSel = new SvAdvConnectSelector( pSink, nAdviseTypes );
		GetSelectorList().Insert( pSel, LIST_APPEND );
		return TRUE;
	}
	return FALSE;
}

void SvAdvise::RemoveConnectAdvise( SvAdviseSink * pSink, USHORT nAdviseTypes )
{
	// Liste wird erzeugt, wenn nicht vorhanden
	SvAdvSelector * pSel = GetSelectorList().First();
	while( pSel )
	{
		SvAdvConnectSelector * pCon = PTR_CAST(SvAdvConnectSelector,pSel);
		if( pCon && pCon->GetSink() == pSink
		  && pCon->GetAdviseTypes() == nAdviseTypes )
		{
			ULONG nCur = pSelectorList->GetCurPos();
			delete pSelectorList->Remove( nCur );
			break;
		}
		// Liste ist auf jeden Fall da
		pSel = pSelectorList->Next();
	}
}

/*************************************************************************
|*    SvAdvise::Closed()
|*
|*    Beschreibung:
*************************************************************************/
BOOL SvAdvise::Closed()
{
	SvAdviseRef( this );
	if( pSelectorList )
	{
		for( ULONG n = pSelectorList->Count(); pSelectorList && n; )
		{
			n--;
			SvAdvSelector * pSel = pSelectorList->GetObject( n );
			if( pSel && pSel->GetAdviseTypes() & ADVISE_CLOSED )
				pSel->GetSink()->Closed();
		}
		// ???DBG_ASSERT( !pSelectorList, "Wer hat sich nicht ausgetragen?" )
	}
	return 0 == GetSelectorCount();
}

/*************************************************************************
|*    SvAdvise::Saved()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::Saved()
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			if( pSel->GetAdviseTypes() & ADVISE_SAVE )
				pSel->GetSink()->Saved();
			pSel = pSelectorList->Next();
		}
	}
}

/*************************************************************************
|*    SvAdvise::SendViewChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::SendViewChanged()
{
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvViewSelector * pView = PTR_CAST(SvAdvViewSelector,pSel);
			if( pView && pView->nModifiedAspects
			  && !(pView->GetAdviseModes() & ADVISEMODE_DATAONSTOP) )
			{
				pSel->GetSink()->ViewChanged( pView->nModifiedAspects );
				pView->nModifiedAspects = 0;
				if( pView->GetAdviseModes() & ADVISEMODE_ONLYONCE )
				{
					ULONG nCur = pSelectorList->GetCurPos();
					delete pSelectorList->Remove();
					pSel = pSelectorList->Seek( nCur );
					continue;
				}
			}
			pSel = pSelectorList->Next();
		}
	}
}

/*************************************************************************
|*    SvAdvise::ViewChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::ViewChanged( USHORT nAspects )
{
	BOOL bChanged = FALSE;
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvViewSelector * pView = PTR_CAST(SvAdvViewSelector,pSel);
			if( pView && pView->GetViewAspects() & nAspects )
			{
				pView->nModifiedAspects |= pView->GetViewAspects() & nAspects;
				bChanged = TRUE;
			}
			pSel = pSelectorList->Next();
		}
	}

	if( bChanged )
	{
		if( nTimeout || pTimer )
			StartTimer( TRUE ); // Timeout neu
		else
			SendViewChanged();
	}
}

/*************************************************************************
|*    SvAdvise::SendDataChanged()
|*    SvAdvise::DataChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvAdvise::SendDataChanged( SvData & rData )
{
	if( pSelectorList )
	{
		SvData* pSvData = &rData;
		BOOL bDelSvData = FALSE;

		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
			if( pData && pData->bModified
			  && !(pData->GetAdviseModes() & ADVISEMODE_DATAONSTOP) )
			{
				BOOL bDelSelektor = TRUE;
				pData->bModified = FALSE;
				if( pData->GetAdviseModes() & ADVISEMODE_NODATA )
				{
					SvData aData( pData->GetType() );
					pData->GetSink()->DataChanged( aData );
				}
				else
				{
					if( pSvData->HasData() )
					{
						if( pSvData->Match( pData->GetType() ) )
							// hat er Daten und passen sie zum Advise
							pData->GetSink()->DataChanged( *pSvData );
						else
							bDelSelektor = FALSE;
					}
					else
					{
						if( bDelSvData )
							delete pSvData;
						bDelSvData = TRUE;

						pSvData = new SvData( pData->GetType() );
						SvDataObjectRef aDO( this );
						if( aDO->GetData( pSvData ))
							pData->GetSink()->DataChanged( *pSvData );
						else
							bDelSelektor = FALSE;
					}
				}

				if( bDelSelektor && pData->GetAdviseModes() & ADVISEMODE_ONLYONCE )
				{
					ULONG nCur = pSelectorList->GetCurPos();
					delete pSelectorList->Remove();
					pSel = pSelectorList->Seek( nCur );
					continue;
				}
			}
			pSel = pSelectorList->Next();
		}
		if( bDelSvData )
			delete pSvData;
	}
}

void SvAdvise::DataChanged( SvData & rData )
{
	DBG_ASSERT( Owner(), "SvAdvise::DataChanged: Owner == FALSE" );

	BOOL bChanged = FALSE;
	if( pSelectorList )
	{
		SvAdvSelector * pSel = pSelectorList->First();
		while( pSel )
		{
			SvAdvDataSelector * pData = PTR_CAST(SvAdvDataSelector,pSel);
			if( pData &&
			  (rData.GetFormat() == 0 || pData->GetType().Match( rData )) )
			{
				pData->bModified = TRUE;
				bChanged = TRUE;
			}
			pSel = pSelectorList->Next();
		}
	}
	if( bChanged )
	{
		if( (nTimeout || pTimer) && !rData.HasData() )
		{   // nur wenn keine Daten mitgegeben wurden
			StartTimer( TRUE ); // Timeout neu
		}
		else
			SendDataChanged( rData );
	}
}


