/*************************************************************************
 *
 *  $RCSfile: drop.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>


#include <drop.hxx>
#include <sysdep.hxx>
#include <sv.hxx>
#pragma hdrstop

/************** class SvDropTarget **************************************/
SV_OLE_FACTORY(SvDropTargetFactory)
	{
	}
};
TYPEINIT1(SvDropTargetFactory,SvOleFactory);

SO2_IMPL_STANDARD_CLASS1_DLL(SvDropTarget,SvDropTargetFactory,SvObject,
							 0x5F492DC0L, 0x6BE2, 0x101B,
							 0x80,0x4C,0x04,0x02,0x1C,0x00,0x70,0x02 )

IUnknown * SvDropTarget::GetMemberInterface( const SvGlobalName & rName )
{
	return NULL;
}

void SvDropTarget::TestMemberObjRef( BOOL bFree )
{
}

#ifdef TEST_INVARIANT
void SvDropTarget::TestMemberInvariant( BOOL bPrint )
{
}
#endif

/************************************************************************
|*
|*    SvDropTarget::SvDropTarget()
|*
|*    Beschreibung
|*    Ersterstellung    MM 05.06.94
|*    Letzte Aenderung  MM 05.06.94
|*
*************************************************************************/
SvDropTarget::SvDropTarget()
{
	pDropWin    = NULL;
	pObjI       = NULL;
}

SvDropTarget::SvDropTarget( Window * pDropWinP )
{
	pDropWin    = NULL;
	pObjI       = NULL;

	AddNextRef(); // schuetzen
	if( pDropWinP )
		Connect( pDropWinP );
	RestoreNoDelete(); //
	ReleaseRef(); // wieder herstellen
}

SvDropTarget::~SvDropTarget()
{
	Disconnect();

	if( pObjI )
	{
		// nicht fragen, einfach tun
		ExternalLock( FALSE );
	}
}


IDropTarget * SvDropTarget::GetDropTarget()
{
	return pObjI;
}

/*************************************************************************
|*
|*    SvDropTarget::Drop()
|*
|*    Beschreibung
|*    Ersterstellung    MM 05.06.94
|*    Letzte Aenderung  MM 05.06.94
|*
*************************************************************************/
BOOL SvDropTarget::Drop( SvDataObject *, const DropEvent & )
{
	return FALSE;
}
/*************************************************************************
|*
|*    SvDropTarget::Connect()
|*
|*    Beschreibung
|*    Ersterstellung    MM 05.06.94
|*    Letzte Aenderung  MM 05.06.94
|*
*************************************************************************/
BOOL SvDropTarget::Connect( Window * pDropWinP )
{
	Disconnect();
	pDropWin    = pDropWinP;
	return FALSE;
}

/*************************************************************************
|*
|*    SvDropTarget::Disconnect()
|*
|*    Beschreibung
|*    Ersterstellung    MM 05.06.94
|*    Letzte Aenderung  MM 05.06.94
|*
*************************************************************************/
void SvDropTarget::Disconnect()
{
	if( pDropWin )
	{
		pDropWin = NULL;
	}
}
