/*************************************************************************
 *
 *  $RCSfile: dtrans.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef MAC
#include <string.h>
#else
#include <memory.h>
#endif


#include <dtrans.hxx>
#include <soimpl.hxx>
#include <tools/debug.hxx>
#include <tools/cachestr.hxx>
#include <tools/new.hxx>
//#include <sysdep.hxx>
#include <vcl/gdimtf.hxx>
#include <vcl/event.hxx>
#include <vcl/drag.hxx>
#include <vcl/clip.hxx>
#include <vcl/jobset.hxx>
#include <vcl/cvtgrf.hxx>

#include <svstor.hxx>
#include <filelist.hxx>
#include <soerr.hxx>
#include <sot/absdev.hxx>
#pragma hdrstop

/*** Interne Klassen ***/
#ifndef VCL
class ImpSO2Clipboard : public Clipboard
{
	SvDataObjectRef aDObj;
	BOOL            bInCtor;
	void    Cleared();
	void    Request();
public:
			ImpSO2Clipboard( SvDataObject * pObj );
			~ImpSO2Clipboard();

	SvDataObject *	GetDataObj() const { return aDObj; }
};

class ImpSO2ClipObject : public SvDataObject
{
	SvDataTypeList  aTypeList;
public:
	virtual BOOL    GetData( SvData * pData );
	virtual const   SvDataTypeList & GetTypeList() const;
};

class ImpSO2DragServer : public DragServer
{
	SvDataObjectRef aDObj;
	void    Request();
public:
			ImpSO2DragServer( SvDataObject * pObj );
};

class ImpSO2DragObject : public SvDataObject
{
	SvDataTypeList  aTypeList;
public:
	virtual BOOL    GetData( SvData * pData );
	virtual const   SvDataTypeList & GetTypeList() const;
};
#endif
/********************** JobSetupWrapper **********************************
**************************************************************************/
JobSetupWrapper::JobSetupWrapper( const JobSetup & rJS )
	: aJobSetup( rJS )
{
	pJobSetup = &aJobSetup;
}

AbstractDeviceData *	JobSetupWrapper::Copy() const
{
	return new JobSetupWrapper( aJobSetup );
}

BOOL JobSetupWrapper::Equals( const AbstractDeviceData & rAD ) const
{
	return aJobSetup == ((const JobSetupWrapper &)rAD).aJobSetup;
}

/********************** SvData *******************************************
**************************************************************************/
BOOL SvData::GetData
(
	SvStorageRef & xStor,
	TransferOperation nMode
)
{
	SotStorageRef xSot( &xStor );
	BOOL bRet = GetData( xSot, nMode );
	xStor = &xSot;
	if( xSot.Is() && !xStor.Is() )
	{
		xStor = new SvStorage( String() );
		xSot->CopyTo( xStor );
	}
	return bRet;
}

BOOL SvData::GetData
(
	SvStorageStreamRef & xStm,
	TransferOperation nMode
)
{
	SotStorageStreamRef xSot( &xStm );
	BOOL bRet;
	if( nMode == TRANSFER_COPY )
		bRet = GetData( xSot, nMode );
	else
	{
		xSot = new SvStorageStream( String() );
		bRet = GetData( xSot, TRANSFER_COPY );
	}
	xStm = &xSot;
	return bRet;
}

BOOL SvData::GetData
(
	SvStorageStreamRef & xStm,
	UINT32 & rLen,
	TransferOperation nMode
)
{
	SotStorageStreamRef xSot( &xStm );
	BOOL bRet;
	if( nMode == TRANSFER_COPY )
		 bRet = GetData( xSot, rLen, nMode );
	else
	{
		xSot = new SvStorageStream( String() );
		bRet = GetData( xSot, rLen, TRANSFER_COPY );
	}
	xStm = &xSot;
	return bRet;
}

void SvData::SetData( SvStorageRef & xStor, TransferOperation nMode )
{
	SotStorageRef x = &xStor;
	SetData( x, nMode );
}
void SvData::SetData( SvStorageStreamRef & xStm, TransferOperation nMode  )
{
	SotStorageStreamRef x = &xStm;
	SetData( x, nMode );
}
void SvData::SetData( SvStorageStreamRef & xStm, UINT32 nLen, TransferOperation nMode )
{
	SotStorageStreamRef x = &xStm;
	SetData( x, nLen, nMode );
}

/************************************************************************/
class BitmapCopyStream : public SvDataCopyStream
{
public:
	Bitmap			aBmp;
					TYPEINFO();

					BitmapCopyStream()
					{}
					BitmapCopyStream( Bitmap & rBmp )
						: aBmp( rBmp )
					{}
	virtual	void	Load( SvStream & rStm )
					{
						rStm >> aBmp;
					}
	virtual	void	Save( SvStream & rStm )
					{
						rStm << aBmp;
					}
	virtual	void	Assign( const SvDataCopyStream & rDCS )
					{
						aBmp = ((const BitmapCopyStream &)rDCS).aBmp;
					}
};
TYPEINIT1_AUTOFACTORY(BitmapCopyStream,SvDataCopyStream);

/************************************************************************/
class GDIMetaFileCopyStream : public SvDataCopyStream
{
public:
	GDIMetaFile		aMtf;
					TYPEINFO();

					GDIMetaFileCopyStream()
					{}
					GDIMetaFileCopyStream( GDIMetaFile & rMtf )
						: aMtf( rMtf )
					{}
	virtual	void	Load( SvStream & rStm )
					{
						rStm >> aMtf;
					}
	virtual	void	Save( SvStream & rStm )
					{
						rStm << aMtf;
					}
	virtual	void	Assign( const SvDataCopyStream & rDCS )
					{
						aMtf = ((const GDIMetaFileCopyStream &)rDCS).aMtf;
					}
};
TYPEINIT1_AUTOFACTORY(GDIMetaFileCopyStream,SvDataCopyStream);

/************************************************************************/
void SvData::SetData( GDIMetaFile * pFile, TransferOperation nMode )
{
	SetData( new GDIMetaFileCopyStream( *pFile ), TRANSFER_MOVE );
	if( TRANSFER_MOVE == nMode )
		delete pFile;
}

/************************************************************************/
void SvData::SetData( Bitmap * pFile, TransferOperation nMode )
{
	SetData( new BitmapCopyStream( *pFile ), TRANSFER_MOVE );
	if( TRANSFER_MOVE == nMode )
		delete pFile;
}

//=========================================================================
BOOL SvData::GetData
(
	GDIMetaFile ** ppFile,	/* An diesem Parameter werden die Daten
							   "ubergeben. */
	TransferOperation nMode /* Bestimmt den Eigent"umer des Objektes. */
)
/*	[Beschreibung]

	Diese Methode holt die Daten im Objekt als <GDIMetaFile>. Dies
	hat, ausser dass das Format meistens <FORMAT_GDIMETAFILE> ist, nichts
	mit diesem zu tun.

	[R"uckgabewert]

	BOOL		TRUE, die Daten konnten als GDIMetaFile zur Verf"ugung
				gestellt werden.
				FALSE, die Daten konnten nicht als GDIMetaFile zur
				Verf"ugung gestellt werden. Es waren entweder keine Daten
				vorhanden oder sie konnten nicht konvertiert werden.

	[Anmerkung]

	Die Daten werden nur geliefert, wenn das Format im Objekt
	<FORMAT_GDIMETAFILE> ist.

	[Querverweise]

	<SvData::GetData>, <SotDataObject::GetData>, <SotDataType::GetFormat>
*/
{
	if( GetFormat() != FORMAT_GDIMETAFILE )
		return FALSE;

	if( !pSimpleObj || !PTR_CAST( GDIMetaFileCopyStream, pSimpleObj ) )
	{
		SvStream * pStm = NULL;
		SvStream * pDelStm = NULL;

		if( pData )
		{
			Graphic aGraphic;

			pStm = pDelStm = new SvMemoryStream( (sal_Char*)pData, nSize,
												 STREAM_STD_READWRITE );

			if( GraphicConverter::Import( *pStm, aGraphic ) == ERRCODE_NONE )
			{
				GDIMetaFile aMtf( aGraphic.GetGDIMetaFile() );
				SetData( &aMtf, TRANSFER_COPY );
				pStm = NULL;
			}
		}
		else if( pSimpleObj )
		{
			pStm = pDelStm = new SvCacheStream;
			pSimpleObj->Save( *pStm );
			pStm->Seek( 0L );
		}
		else if( aStream.Is() )
		{
			aStream->Seek( nStmBeginPos );
			pStm = &aStream;
		}
		if( pStm && pStm->GetError() == SVSTREAM_OK )
		{
			GDIMetaFile aMtf;
			*pStm >> aMtf;
			SetData( &aMtf, TRANSFER_COPY );
		}
		delete pDelStm;
	}

	if( pSimpleObj || PTR_CAST( GDIMetaFileCopyStream, pSimpleObj ) )
	{
		if( TRANSFER_COPY == nMode )
			**ppFile = ((GDIMetaFileCopyStream *)pSimpleObj)->aMtf;
		else if( TRANSFER_MOVE == nMode )
		{
			*ppFile = new GDIMetaFile( ((GDIMetaFileCopyStream *)pSimpleObj)->aMtf );
		}
		else
			*ppFile = &((GDIMetaFileCopyStream *)pSimpleObj)->aMtf;
		return TRUE;
	}
	return FALSE;
}

//=========================================================================
BOOL SvData::GetData
(
	Bitmap ** ppBmp,		/* An diesem Parameter werden die Daten
							   "ubergeben. */
	TransferOperation nMode /* Bestimmt den Eigent"umer des Objektes. */
)
/*	[Beschreibung]

	Diese Methode holt die Daten im Objekt als <Bitmap>. Dies
	hat, ausser dass das Format meistens <FORMAT_BITMAP> ist, nichts
	mit diesem zu tun.

	[R"uckgabewert]

	BOOL		TRUE, die Daten konnten als Bitmap zur Verf"ugung
				gestellt werden.
				FALSE, die Daten konnten nicht als Bitmap zur
				Verf"ugung gestellt werden. Es waren entweder keine Daten
				vorhanden oder sie konnten nicht konvertiert werden.

	[Anmerkung]

	Die Daten werden nur geliefert, wenn das Format im Objekt
	<FORMAT_BITMAP> ist.

	[Querverweise]

	<SvData::GetData>, <SotDataObject::GetData>, <SotDataType::GetFormat>
*/
{
	if( GetFormat() != FORMAT_BITMAP )
		return FALSE;

	if( !pSimpleObj || !PTR_CAST( BitmapCopyStream, pSimpleObj ) )
	{
		SvStream * pStm = NULL;
		SvStream * pDelStm = NULL;
		if( pData )
		{
			pStm = pDelStm = new SvMemoryStream( (sal_Char*)pData, nSize,
													 STREAM_STD_READWRITE );
		}
		else if( pSimpleObj )
		{
			pStm = pDelStm = new SvCacheStream;
			pSimpleObj->Save( *pStm );
			pStm->Seek( 0L );
		}
		else if( aStream.Is() )
		{
			aStream->Seek( nStmBeginPos );
			pStm = &aStream;
		}
		if( pStm && pStm->GetError() == SVSTREAM_OK )
		{
			Bitmap *pBmp = new Bitmap();
			*pStm >> *pBmp;
			SetData( pBmp, TRANSFER_MOVE );
		}
		delete pDelStm;
	}
	if( pSimpleObj || PTR_CAST( BitmapCopyStream, pSimpleObj ) )
	{
		if( TRANSFER_COPY == nMode )
			**ppBmp = ((BitmapCopyStream *)pSimpleObj)->aBmp;
		else if( TRANSFER_MOVE == nMode )
		{
			*ppBmp = new Bitmap( ((BitmapCopyStream *)pSimpleObj)->aBmp );
		}
		else
			*ppBmp = &((BitmapCopyStream *)pSimpleObj)->aBmp;
		return TRUE;
	}
	return FALSE;
}

/*************************************************************************
|*    SvDataType::Ole2SvAspect()
|*    SvDataType::Sv2OleAspect()
|*
|*    Beschreibung
*************************************************************************/
USHORT SvDataObject::Ole2SvAspect( ULONG nAspect )
{
	DBG_ASSERT( 0 == (nAspect & ~ASPECT_ALL), "unknown aspects" )
	return (USHORT)nAspect;    // MS-W, Sv 1 zu 1
}

ULONG SvDataObject::Sv2OleAspect( USHORT nAspect )
{
	DBG_ASSERT( 0 == (nAspect & ~ASPECT_ALL), "unknown aspects" )
	return nAspect;    // MS-W, Sv 1 zu 1
}

/********************** SvDataObject **************************************
**************************************************************************/


/************** class SvDataObject **************************************/
SV_OLE_FACTORY(SvDataObjectFactory)
	{
	}
};
TYPEINIT1(SvDataObjectFactory,SvOleFactory);
SO2_IMPL_STANDARD_CLASS2_DLL(SvDataObject,SvDataObjectFactory,SvObject,SotDataObject,
							 0xFFF5D3E0L, 0x64D5, 0x101B,
							 0x80,0x4C,0x04,0x02,0x1C,0x00,0x70,0x02 )

IUnknown * SvDataObject::GetMemberInterface( const SvGlobalName & )
{
	return NULL;
}

void SvDataObject::TestMemberObjRef( BOOL /*bFree*/ )
{
}

#ifdef TEST_INVARIANT
void SvDataObject::TestMemberInvariant( BOOL /*bPrint*/ )
{
}
#endif

/************************************************************************
|*    SvDataObject::SvDataObject()
|*
|*    Beschreibung
*************************************************************************/
SvDataObject::SvDataObject()
{
	pSetDataTypeList = NULL;
	pTypeList = NULL;
	pObjI  = NULL;
}

SvDataObject::~SvDataObject()
{
	if( SOAPP->pClipboardObj == this )
		SOAPP->pClipboardObj = NULL;

	delete pTypeList;
	delete pSetDataTypeList;
}


/*************************************************************************
|*    SvDataObject::Impl_SetTypeList()
|*    SvDataObject::SetTypeList()
|*
|*    Beschreibung
*************************************************************************/
void SvDataObject::Impl_SetTypeList( const SvDataTypeList & rTypesP )
{
	if( pTypeList )
	{
		pTypeList->Clear();
		*pTypeList = rTypesP;
	}
	else
		pTypeList = new SvDataTypeList( rTypesP );
}

void SvDataObject::Impl_SetSetDataTypeList( const SvDataTypeList & rTypesP )
{
	if( pSetDataTypeList )
	{
		pSetDataTypeList->Clear();
		*pSetDataTypeList = rTypesP;
	}
	else
		pSetDataTypeList = new SvDataTypeList( rTypesP );
}

void SvDataObject::SetTypeList( const SvDataTypeList & rTypeList )
{
	if( Owner() )
		Impl_SetTypeList( rTypeList );
}

void SvDataObject::SetSetDataTypeList( const SvDataTypeList & rTypeList )
{
	if( Owner() )
		Impl_SetSetDataTypeList( rTypeList );
}


/*************************************************************************
|*    SvDataObject::GetTypeList()
|*    SvDataObject::Impl_GetTypeList()
|*
|*    Beschreibung
*************************************************************************/
const SvDataTypeList & SvDataObject::Impl_GetTypeList() const
{
	if( !pTypeList )
		((SvDataObject *)this)->pTypeList = new SvDataTypeList();
	return *pTypeList;
}

const SvDataTypeList & SvDataObject::Impl_GetSetDataTypeList() const
{
	if( !pSetDataTypeList )
		(( SvDataObject* ) this )->pSetDataTypeList = new SvDataTypeList();
	return *pSetDataTypeList;
}

const SvDataTypeList & SvDataObject::GetTypeList() const
{
	if( !pTypeList )
		((SvDataObject *)this)->pTypeList = new SvDataTypeList();
	return *pTypeList;
}

/*************************************************************************
|*    SvDataObject::GetSetDataTypeList()
|*
|*    Beschreibung
*************************************************************************/
const SvDataTypeList & SvDataObject::GetSetDataTypeList() const
{
	return Impl_GetSetDataTypeList();
}

/*************************************************************************
|*    SvDataObject::GetData()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::GetData( SvData * pData )
{
	BOOL bRet = FALSE;
	return bRet;
}

/*************************************************************************
|*    SvDataObject::GetDataHere()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::GetDataHere( SvData * pData )
{
	BOOL bRet = FALSE;
	SvData aData( *(SvDataType *)pData );
	bRet = GetData( &aData );
	if( bRet )
	{
		if( pData->HasMedium( MEDIUM_MEMORY )
		  && pData->GetMinMemorySize() >= aData.GetMinMemorySize() )
		{
			void * pTmp;
			// Erst Zeiger holen, dann kopieren
			if( !pData->GetData( &pTmp, TRANSFER_REFERENCE )
			  || !aData.GetData( &pTmp, TRANSFER_COPY ) )
				bRet = FALSE;
		}
		if( pData->HasMedium( MEDIUM_STREAM ) )
		{
			SvStorageStreamRef aTmp;
			// Erst Zeiger holen, dann kopieren
			if( !pData->GetData( aTmp, TRANSFER_REFERENCE )
			  || !aData.GetData( aTmp, TRANSFER_COPY ) )
				bRet = FALSE;
		}
		if( pData->HasMedium( MEDIUM_STORAGE ) )
		{
			SvStorageRef aTmp;
			// Erst Zeiger holen, dann kopieren
			if( !pData->GetData( aTmp, TRANSFER_REFERENCE )
			  || !aData.GetData( aTmp, TRANSFER_COPY ) )
				bRet = FALSE;
		}
	}
	return bRet;
}

/*************************************************************************
|*    SvDataObject::SetData()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::SetData( SvData * /*pData*/ )
{
	return FALSE;
}

/*************************************************************************
|*    SvDataObject::QueryDataType()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::QueryDataType( SvDataType & rType )
{
	// Passenden Typ suchen
	const SvDataType * pType = GetTypeList().Get( rType );
	if( pType )
		rType = *pType;
	return pType != NULL;
}

/*************************************************************************
|*    SvDataObject::HasFormat()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::HasFormat( const SvDataType & rType ) const
{
	return NULL != GetTypeList().Get( rType );
}

/*************************************************************************
|*    SvDataObject::CreateSnapshot()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
SvDataMemberObjectRef SvDataObject::CreateSnapshot()
{
	SvDataMemberObjectRef xDataObj;

	// Datenobjekt, welches alle Formate als Member hat
	xDataObj = new SvDataMemberObject();

	// gegen Aenderungen sichern
	SvDataTypeList aTypeList( GetTypeList() );

	// nicht die eigene Typenliste verwenden !
	for( ULONG i = 0; i < aTypeList.Count(); i++ )
	{
		SvData * pData = new SvData( aTypeList[ i ] );
		if( GetData( pData ) )
			xDataObj->Append( pData );
		else
			delete pData;
	}
	return xDataObj;
}

/************************************************************************
|*    SvDataObject::SvDataObject()
|*
|*    Beschreibung
*************************************************************************/
void SvDataObject::FlushClipboard()
{
	VclClipboard::ReleaseClipboard( TRUE );
}

/*************************************************************************
|*    SvDataObject::CopyClipboard()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataObject::CopyClipboard()
{
	BOOL bRet = TRUE;
	VclClipboard::Copy( this );
	return bRet;
}

/*************************************************************************
|*    HACK fuer VCL: SotDataObject wrappen
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
static class SvDataSotWrpObject * pClipDataObject;

class SvDataSotWrpObject : public SvDataObject
{
	SotDataObjectRef	xSotDataObject;

public:
	SvDataSotWrpObject( SotDataObject* pSotDataObject );
	~SvDataSotWrpObject();

	virtual const SvDataTypeList & GetTypeList() const;

	virtual BOOL    GetData( SvData * );
	virtual BOOL    GetDataHere( SvData * );
	virtual BOOL    QueryDataType( SvDataType & rInOutType );

	// HACK fuer die Implementation der alten Clipboard-Schnittstelle
	// in VCL, primitives RTTI nur fuer SotData(Member)Object
	virtual BOOL    IsSotDataMemberObject( void );
};

BOOL IsClipboardObject_Impl( SotDataObject * pO )
{
	return pO == pClipDataObject;
}

SvDataSotWrpObject::SvDataSotWrpObject( SotDataObject* pSotDataObject )
{
	xSotDataObject = pSotDataObject;
}

SvDataSotWrpObject::~SvDataSotWrpObject()
{
	if( this == pClipDataObject )
		pClipDataObject = NULL;
}

const SvDataTypeList & SvDataSotWrpObject::GetTypeList() const
{
	return xSotDataObject->GetTypeList();
}

BOOL SvDataSotWrpObject::GetData( SvData* pData )
{
	return xSotDataObject->GetData( pData );
}

BOOL SvDataSotWrpObject::GetDataHere( SvData* pData )
{
	return xSotDataObject->GetDataHere( pData );
}

BOOL SvDataSotWrpObject::QueryDataType( SvDataType & rInOutType )
{
	return xSotDataObject->QueryDataType( rInOutType );
}

// HACK fuer die Implementation der alten Clipboard-Schnittstelle
// in VCL, primitives RTTI nur fuer SotData(Member)Object
BOOL SvDataSotWrpObject::IsSotDataMemberObject( void )
{
	return xSotDataObject->IsSotDataMemberObject();
}

/*************************************************************************
|*    SvDataObject::PasteClipboard()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
SvDataObjectRef SvDataObject::PasteClipboard()
{
	SotDataObject* pSotDataObj = VclClipboard::Paste();
	SvDataObjectRef aSvDataObjRef = pSotDataObj;
	// Kein SvDataObject -> SotDataObject wrappen, wenn vorhanden
	if( !aSvDataObjRef.Is() && pSotDataObj )
	{
		aSvDataObjRef = pClipDataObject = new SvDataSotWrpObject( pSotDataObj );
	}
	return aSvDataObjRef;
}

/*************************************************************************
|*    SvDataObject::CopyDragServer()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
DropAction SvDataObject::ExecuteDrag( Window * pSource,
									  const Pointer& rMovePtr,
									  const Pointer& rCopyPtr,
									  USHORT nOptions,
									  const Region* pDropRegion )
{
	SOAPP->pDragDropObj = this;
	DropAction eAct = DROP_CANCEL;
	eAct = DragManager::ExecuteDrag( this, nOptions );
	SOAPP->pDragDropObj = NULL;
	return eAct;
}

DropAction SvDataObject::ExecuteDrag( Window * pSource,
									  const Pointer& rMovePtr,
									  const Pointer& rCopyPtr,
									  const Pointer& rLinkPtr,
									  USHORT nOptions,
									  const Region* pDropRegion )
{
	SOAPP->pDragDropObj = this;
	DropAction eAct = DROP_CANCEL;
	eAct = DragManager::ExecuteDrag( this, nOptions );
	SOAPP->pDragDropObj = NULL;
	return eAct;
}

/*************************************************************************
|*    SvDataObject::PasteDragServer()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
SvDataObjectRef SvDataObject::PasteDragServer( const DropEvent & rEvt )
{
	if( SOAPP->pDragDropObj )
		// selber D&D ausgeloesst
		return SOAPP->pDragDropObj;
	else
	{
		SvDataObjectRef aObj;
		SotDataObject* pSotDataObj = rEvt.GetData();
		SvDataObjectRef aSvDataObjRef = pSotDataObj;
		// Kein SvDataObject -> SotDataObject wrappen, wenn vorhanden
		if( !aSvDataObjRef.Is() && pSotDataObj )
			aSvDataObjRef = new SvDataSotWrpObject( pSotDataObj );
		return aSvDataObjRef;
	}
}

/************** class SvDataMemberObject *********************************/
/************************************************************************
|*    SvDataMemberObject::SvDataMemberObject()
|*    SvDataMemberObject::~SvDataMemberObject()
|*
|*    Beschreibung
*************************************************************************/
SvDataMemberObject::SvDataMemberObject()
{
}

SvDataMemberObject::SvDataMemberObject( SvDataObject * pExtObj )
	: xExtObj( pExtObj )
{
	aTypeList = xExtObj->GetTypeList();
}

SvDataMemberObject::~SvDataMemberObject()
{
	SvData * pData = aDataList.First();
	while( pData )
	{
		delete pData;
		pData = aDataList.Next();
	}
}

/************************************************************************
|*    SvDataMemberObject::Append()
|*
|*    Beschreibung
*************************************************************************/
void SvDataMemberObject::Append( SvData * pData )
{
	const SvDataType * pType = aTypeList.Get( *pData );
	if( !pType )
	{
		aDataList.Insert( pData, LIST_APPEND );
		// Typenliste auch mitpflegen
		aTypeList.Append( *pData );
	}
	else
	{
		for( ULONG i = 0; i < aDataList.Count(); i++ )
		{
			if( aDataList.GetObject( i )->Match( *pData ) )
			{
				delete aDataList.Remove( i );
				aDataList.Insert( pData, i );
			}
		}
		aTypeList.Remove( (SvDataType *)pType );
		aTypeList.Insert( *pData );
	}
}

/*************************************************************************
|*    SvDataMemberObject::GetData()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
const SvDataTypeList & SvDataMemberObject::GetTypeList() const
{
	return aTypeList;
}

/*************************************************************************
|*    SvDataMemberObject::GetData()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataMemberObject::GetData( SvData * pOutData )
{
	SvData * pData = aDataList.First();
	while( pData )
	{
		if( pData->Match( *pOutData ) )
		{
			pOutData->SetData( pData );
			return TRUE;
		}
		pData = aDataList.Next();
	}
	if( xExtObj )
		return xExtObj->GetData( pOutData );
	return FALSE;
}

/*************************************************************************
|*    SvDataMemberObject::GetDataHere()
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL SvDataMemberObject::GetDataHere( SvData * pOutData )
{
	SvData * pData = aDataList.First();
	while( pData )
	{
		if( pData->Match( *pOutData ) )
			return SvDataObject::GetDataHere( pOutData );
		pData = aDataList.Next();
	}
	if( xExtObj.Is() )
		return xExtObj->GetDataHere( pOutData );
	return FALSE;
}

#ifndef VCL
/************** class ImpSO2Clipboard ***********************************/
/*************************************************************************
|*    ImpSO2Clipboard
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
void ImpSO2Clipboard::Cleared()
{
	if( !bInCtor )
		delete this;
}

void ImpSO2Clipboard::Request()
{
	ULONG nFormat = GetRequestFormat();
	SvData aData( nFormat );
	aDObj->GetData( &aData );
	if( FORMAT_GDIMETAFILE == nFormat )
	{
		GDIMetaFile * pMtf;
		if( aData.GetData( &pMtf, TRANSFER_REFERENCE ) )
			CopyGDIMetaFile( *pMtf );
	}
	else if( FORMAT_BITMAP == nFormat )
	{
		Bitmap * pBmp;
		if( aData.GetData( &pBmp, TRANSFER_REFERENCE ) )
			CopyBitmap( *pBmp );
	}
	else
	{
		void * pData;
		if( aData.GetData( &pData, TRANSFER_REFERENCE ) )
			CopyData( pData, aData.GetMinMemorySize(), nFormat );
	}
}

ImpSO2Clipboard::ImpSO2Clipboard( SvDataObject * pObj )
				: aDObj( pObj )
{
	if( SOAPP->pOwnClipboard )
		delete SOAPP->pOwnClipboard;
	SOAPP->pOwnClipboard = this;

	bInCtor = TRUE;
	Clear();
	const SvDataTypeList & rList = aDObj->GetTypeList();
	for( ULONG i = 0; i < rList.Count(); i++ )
		CopyRequest( rList.GetObject( i ).GetFormat() );
	bInCtor = FALSE;
}
ImpSO2Clipboard::~ImpSO2Clipboard()
{
	if( this == SOAPP->pOwnClipboard )
		SOAPP->pOwnClipboard = NULL;
}

/************** class ImpSO2ClipObject **********************************/
/*************************************************************************
|*    ImpSO2ClipObject
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
BOOL ImpSO2ClipObject::GetData( SvData * pData )
{
	ULONG nFormat = pData->GetFormat();
	if( FORMAT_BITMAP == nFormat )
	{
		Bitmap aBmp = Clipboard::PasteBitmap();
		pData->SetData( &aBmp );
		return TRUE;
	}
	else if( FORMAT_GDIMETAFILE == nFormat )
	{
		GDIMetaFile aMtf;
		if( !Clipboard::PasteGDIMetaFile( aMtf ) )
			return FALSE;
		pData->SetData( &aMtf );
		return TRUE;
	}
	else if ( Clipboard::HasFormat( nFormat ) )
	{
		ULONG nLen = Clipboard::GetDataLen( nFormat );
		void * pBuf = SvMemAlloc( nLen );
		if( !Clipboard::PasteData( pBuf, nLen, nFormat ) )
		{
			delete pBuf;
			return FALSE;
		}
		pData->SetData( pBuf, nLen, TRANSFER_MOVE );
		return TRUE;
	}
	else
		return FALSE;
}

/*************************************************************************/

const SvDataTypeList & ImpSO2ClipObject::GetTypeList() const
{
	if( !aTypeList.Count() )
		for( USHORT i = 0; i < Clipboard::GetFormatCount(); i++ )
			((SvDataTypeList *)&aTypeList)->
				Append( SvDataType( Clipboard::GetFormat( i ) ) );
	return aTypeList;
}

/************** class ImpSO2DragServer **********************************/
/*************************************************************************
|*    ImpSO2DragServer
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
void ImpSO2DragServer::Request()
{
	ULONG nFormat = GetRequestFormat();
	SvData aData( nFormat );
	aDObj->GetData( &aData );
	if( FORMAT_GDIMETAFILE == nFormat )
	{
		GDIMetaFile * pMtf;
		if( aData.GetData( &pMtf, TRANSFER_REFERENCE ) )
			CopyGDIMetaFile( *pMtf );
	}
	else if( FORMAT_BITMAP == nFormat )
	{
		Bitmap * pBmp;
		if( aData.GetData( &pBmp, TRANSFER_REFERENCE ) )
			CopyBitmap( *pBmp );
	}
	else
	{
		void * pData;
		if( aData.GetData( &pData, TRANSFER_REFERENCE ) )
			CopyData( pData, aData.GetMinMemorySize(), nFormat );
	}
}

ImpSO2DragServer::ImpSO2DragServer( SvDataObject * pObj )
				: aDObj( pObj )
{
	Clear();
	NewItem();

	// AB, 29.10.1996: Beim Format SV_FILE_LIST muss eine Umsetzung
	// der dort enthaltenen Files in mehrere Items vorgenommen werden
	const SvDataTypeList & rList = aDObj->GetTypeList();
	BOOL bFileFormat = FALSE;

	// Ist das Format SV_FILE_LIST enthalten?
	// Dann kann eine FileList geholt werden
	SvData aData( FORMAT_FILE_LIST );
	pObj->GetData( &aData );

	// FileList-Daten holen
	FileList* pFileList;
	BOOL bFileList = aData.GetData( (SvDataCopyStream**)&pFileList,
						FileList::StaticType(), TRANSFER_REFERENCE );

	// Ueber alle Formate gehen
	for( ULONG i = 0; i < rList.Count(); i++ )
	{
		ULONG nFormat = rList.GetObject( i ).GetFormat();

		// Wenn FORMAT_FILE neben File-List drinsteht,
		// 1. File der Liste als FORMAT_FILE kopieren
		// Das muss hier erfolgen, um die Reihenfolge der
		// Formate nicht zu veraendern
		if( nFormat == FORMAT_FILE && bFileList )
		{
			CopyFile( pFileList->GetFile( 0 ) );
			bFileFormat = TRUE;		// FORMAT_FILE ist vorhanden
		}
		// sonst alles als Request kopieren
		else
		{
			CopyRequest( nFormat );
		}
	}

	// Bei FileList Items anlegen
	if( bFileList )
	{
		ULONG nCount = pFileList->Count();
		ULONG nStart = 0;

		// Wenn FORMAT_FILE vorkommt, wurde das 1.File der
		// Liste bereits in das erste Item kopiert
		if( bFileFormat && nCount > 1 )
		{
			nStart++;
			NewItem();
		}
		// Alle Files der Liste in eigene Items kopieren
		for( ULONG i = nStart ; i < nCount ; i++ )
		{
			CopyFile( pFileList->GetFile( i ) );
			if( i != nCount-1 )		// nicht beim letzten
				NewItem();
		}
	}

}

/************** class ImpSO2DragObject **********************************/
/*************************************************************************
|*    ImpSO2ClipObject
|*
|*    Beschreibung      Holt die Daten von einen IDataObject.
*************************************************************************/
/*************************************************************************/

BOOL ImpSO2DragObject::GetData( SvData * pData )
{
	ULONG nFormat = pData->GetFormat();
	if( FORMAT_BITMAP == nFormat )
	{
		Bitmap aBmp = DragServer::PasteBitmap( 0 );
		pData->SetData( &aBmp );
		return TRUE;
	}
	else if( FORMAT_GDIMETAFILE == nFormat )
	{
		GDIMetaFile aMtf;
		if( !DragServer::PasteGDIMetaFile( 0, aMtf ) )
			return FALSE;
		pData->SetData( &aMtf );
		return TRUE;
	}
	else if( FORMAT_FILE_LIST == nFormat )
	{
		// Format grundsaetzlich vorhanden? Dann in Item 0
		if( DragServer::HasFormat( 0, FORMAT_FILE_LIST ) )
		{
			// Hat der DragServer wirklich FORMAT_FILE_LIST oder nur
			// einzelne Items mit FORMAT_FILE?
			// Am 1. Item alle Formate durchgehen
			USHORT nFormatCount = DragServer::GetFormatCount( 0 );
			BOOL bRealFormat = FALSE;
			for( USHORT iFormat = 0 ; iFormat < nFormatCount ; iFormat++ )
			{
				if( DragServer::GetFormat( 0 , iFormat ) == FORMAT_FILE_LIST )
				{
					bRealFormat = TRUE;
					break;
				}
			}

			// Format nicht wirklich da -> aus Files zusammenbasteln
			if( !bRealFormat )
			{
				//Pointer und TRANSFER_MOVE Ziel gibt FileList frei
				FileList *pFileList = new FileList();

				// Kann aus einzelnen Files eine FileList gebastelt werden?
				// Dazu werden alle Items mit FORMAT_FILE herangezogen.
				for( USHORT i = 0; i < DragServer::GetItemCount(); i++ )
				{
					if( DragServer::HasFormat( i, FORMAT_FILE ) )
						pFileList->AppendFile( DragServer::PasteFile( i ) );
				}

				// Wenn Files drin waren, FileList in SvData stopfen
				BOOL bRet = FALSE;
				if( pFileList->Count() )
				{
					pData->SetData( pFileList, TRANSFER_MOVE );
					bRet = TRUE;
				}
				return bRet;
			}

			// Wenn die Ausfuehrung diese Stelle erreicht, ist
			// FORMAT_FILE_LIST wirklich da -> Standard-Fall
		}
		else
		{
			// Keine FileList
			return FALSE;
		}
	}

	// Standard-Fall: Daten ueber PasteData ansprechen
	ULONG nLen = DragServer::GetDataLen( 0, nFormat );
	void * pBuf = SvMemAlloc( nLen );
	if( !DragServer::PasteData( 0, pBuf, nLen, nFormat ) )
	{
		delete pBuf;
		return FALSE;
	}
	pData->SetData( pBuf, nLen, TRANSFER_MOVE );
	return TRUE;
}

/*************************************************************************/

const SvDataTypeList & ImpSO2DragObject::GetTypeList() const
{
	if( !aTypeList.Count() )
		for( USHORT i = 0; i < DragServer::GetFormatCount( 0 ); i++ )
			((SvDataTypeList *)&aTypeList)->
				Append( SvDataType( DragServer::GetFormat( 0, i ) ) );
	return aTypeList;
}
#endif // !VCL

