/*************************************************************************
 *
 *  $RCSfile: insdlg.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define _INSDLG_CXX

// include ---------------------------------------------------------------

#include <stdio.h>
#include <insdlg.hxx>

#include <tools/urlobj.hxx>
#include <tools/debug.hxx>
#include <svtools/urihelper.hxx>
#include <vcl/config.hxx>
#include <svtools/iniman.hxx>
#include <svtools/svmedit.hxx>
#include <svtools/filedlg.hxx>
#include <vcl/filedlg.hxx>
#include <vcl/button.hxx>
#include <vcl/fixed.hxx>
#include <vcl/group.hxx>
#include <vcl/lstbox.hxx>
#include <vcl/msgbox.hxx>
#include <vcl/exchange.hxx>
#include <vcl/svapp.hxx>

#include <svuidlg.hxx>
#include <svuidlg.hrc>
#include <svstor.hxx>
#include <ipobj.hxx>
#include <plugin.hxx>
#include <applet.hxx>
#include <outplace.hxx>

#pragma hdrstop

#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>

#define SoResid( id )   ResId( id, SOAPP->GetResMgr() )

/********************** SvObjectServerList ********************************
**************************************************************************/
PRV_SV_IMPL_OWNER_LIST( SvObjectServerList, SvObjectServer )

/*************************************************************************
|*    SvObjectServerList::SvObjectServerList()
|*
|*    Beschreibung
*************************************************************************/
const SvObjectServer * SvObjectServerList::Get( const String & rHumanName ) const
{
	for( ULONG i = 0; i < Count(); i++ )
	{
		if( rHumanName == GetObject( i ).GetHumanName() )
			return &GetObject( i );
	}
	return NULL;
}

/*************************************************************************
|*    SvObjectServerList::SvObjectServerList()
|*
|*    Beschreibung
*************************************************************************/
const SvObjectServer * SvObjectServerList::Get( const SvGlobalName & rName ) const
{
	for( ULONG i = 0; i < Count(); i++ )
	{
		if( rName == GetObject( i ).GetClassName() )
			return &GetObject( i );
	}
	return NULL;
}

void SvObjectServerList::Remove( const SvGlobalName & rName )
{
	SvObjectServer * pS = (SvObjectServer *)aTypes.First();
	while( pS )
	{
		if( rName == pS->GetClassName() )
		{
			Remove();
			pS = (SvObjectServer *)aTypes.GetCurObject();
		}
		else
			pS = (SvObjectServer *)aTypes.Next();
	}
}

//---------------------------------------------------------------------
void SvObjectServerList::FillInsertObjects()
/* [Beschreibung]

	Die Liste wird mit allen Typen gef"ullt, die im Insert-Dialog
	ausgew"ahlt werden k"onnen.
*/
{
	String aPath;
	sal_Char * pEnv = getenv( "STAR_SOINI" );
	if( pEnv )
		aPath = String::CreateFromAscii( pEnv );
	else
	{
        aPath = SfxIniManager::Get()->Get( SFX_KEY_CONFIG_DIR );
		if( !aPath.Len() )
		{
			// Programmverzeichnis bestimmen
			INetURLObject aAppDir( GetpApp()->GetAppFileName(), INET_PROT_FILE );
			aAppDir.removeSegment();
			aPath = aAppDir.PathToFileName();
		}
	}
	Config aConfig( Config::GetConfigName( aPath, String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "so" ) ) ) );

	// first try language dependend
	ByteString aLangPostFix = ResMgr::GetLang();
	ByteString aGroup = "StarObjects";
	aGroup.Append( '-' );
	aGroup.Append( aLangPostFix );
	aConfig.SetGroup( aGroup );
	// !!! Server abfragen und in die ListBox stellen
	USHORT nCount = aConfig.GetKeyCount();
	if( !nCount )
	{
		// not found
		aConfig.SetGroup( "StarObjects" );
		nCount = aConfig.GetKeyCount();
	}

	ByteString aKeyName;
	for( USHORT i = 0; i < nCount; i++ )
	{
		SvGlobalName aClassName;
		aKeyName = aConfig.GetKeyName( i );
		if( aClassName.MakeId( String( aKeyName, gsl_getSystemTextEncoding() ) ) )
		{
			ByteString aVal = aConfig.ReadKey( aKeyName );
			aVal = aVal.GetToken( 0 );
			if( !Get( aClassName ) )
				// noch nicht eingetragen
				Append( SvObjectServer( aClassName, String( aVal, gsl_getSystemTextEncoding() ) ) );
		}
	}
#ifdef WNT
	SvGlobalName aOleFact = *SvOutPlaceObject::ClassFactory();
	String aOleObj( SoResid( STR_FURTHER_OBJECT ) );
	Append( SvObjectServer( aOleFact, aOleObj ) );
#endif

	/*
	const SvFactoryList * pFactList = SvFactory::GetFactoryList();
	if( pFactList )
	{
		const SvFactory * pFact;
		for( ULONG i = 0; i < pFactList->Count(); i++ )
		{
			pFact = pFactList->GetObject( i );
			if( pFact->IsRegistered()
			  && pFact->Is( SvEmbeddedObject::ClassFactory() )
			  && !Get( *pFact ) )
				Append( SvObjectServer( *pFact, pFact->GetClassName() ) );
		}
	}
	*/
}

// class SvInsertOleDlg --------------------------------------------------

class SvInsertOleDlg : public MdInsertOleobject
{
private:
	String      _aOldStr;

	DECL_LINK( DoubleClickHdl, ListBox * );
	DECL_LINK( BrowseHdl, PushButton * );
	DECL_LINK( RadioHdl, RadioButton * );

public:
	SvInsertOleDlg( Window* pParent );

	void        SelectDefault();
	ListBox&    GetObjectTypes()    { return aLbObjecttype; }
	String      GetFilePath() const { return aEdFilepath.GetText(); }
	BOOL        IsLinked() const    { return aCbFilelink.IsChecked(); }
	BOOL        IsCreateNew() const { return aRbNewObject.IsChecked(); }
};

// -----------------------------------------------------------------------

IMPL_LINK_INLINE_START( SvInsertOleDlg, DoubleClickHdl, ListBox *, EMPTYARG )
{
	EndDialog( RET_OK );
	return 0;
}
IMPL_LINK_INLINE_END( SvInsertOleDlg, DoubleClickHdl, ListBox *, pListBox )

// -----------------------------------------------------------------------

IMPL_LINK( SvInsertOleDlg, BrowseHdl, PushButton *, EMPTYARG )
{
	VclFileDialog *pFileDlg =
			GetpApp()->CreateFileDialog( this, WB_OPEN | WB_SVLOOK );

	if ( pFileDlg->Execute() )
		aEdFilepath.SetText( INetURLObject( pFileDlg->GetPath() ).PathToFileName() );
	delete pFileDlg;
	return 0;
}

// -----------------------------------------------------------------------

IMPL_LINK( SvInsertOleDlg, RadioHdl, RadioButton *, EMPTYARG )
{
	if ( aRbNewObject.IsChecked() )
	{
		aLbObjecttype.Show();
		aEdFilepath.Hide();
		aBtnFilepath.Hide();
		aCbFilelink.Hide();
		aGbObject.SetText( _aOldStr );
	}
	else
	{
		aLbObjecttype.Hide();
		aEdFilepath.Show();
		aBtnFilepath.Show();
		aGbObject.SetText( aStrFile );
	}
	return 0;
}

// -----------------------------------------------------------------------

SvInsertOleDlg::SvInsertOleDlg( Window* pParent ) :

	MdInsertOleobject( pParent, SoResid( MD_INSERT_OLEOBJECT ) )

{
	_aOldStr = aGbObject.GetText();
	aLbObjecttype.SetDoubleClickHdl(
		LINK( this, SvInsertOleDlg, DoubleClickHdl ) );
	aBtnFilepath.SetClickHdl( LINK( this, SvInsertOleDlg, BrowseHdl ) );
	Link aLink( LINK( this, SvInsertOleDlg, RadioHdl ) );
	aRbNewObject.SetClickHdl( aLink );
	aRbObjectFromfile.SetClickHdl( aLink );
	// Neu als Default
	aRbNewObject.Check( TRUE );
	RadioHdl( NULL );
}

// -----------------------------------------------------------------------

void SvInsertOleDlg::SelectDefault()
{
	aLbObjecttype.SelectEntryPos( 0 );
}

// class SvInsertPlugInDlg -----------------------------------------------

class SvInsertPlugInDlg : public MdInsertObjectPlugin
{
private:
	DECL_LINK( BrowseHdl, PushButton * );

public:
	SvInsertPlugInDlg( Window* pParent );

	String  GetPlugInFile() const { return aEdFileurl.GetText(); }
	String  GetPlugInOptions() const { return aEdPluginsOptions.GetText(); }
};

// -----------------------------------------------------------------------

IMPL_LINK( SvInsertPlugInDlg, BrowseHdl, PushButton *, EMPTYARG )
{
#if defined( VCL ) && SUPD!=370
	VclFileDialog* pDlg =
#else
	FileDialog* pDlg =
#endif
		GetpApp()->CreateFileDialog( this, WB_OPEN | WB_SVLOOK );

	void fillNetscapePluginFilters( VclFileDialog* );
	fillNetscapePluginFilters( pDlg );

//      // Zum ausprobieren
//      const PlugList* pList = SvFactory::GetPlugInManager()->GetPlugList();
//      SvStringsDtor aTmpList;

//      for ( USHORT i = 0; i < pList->Count(); ++i )
//      {
//          PlugData* pActPlug = (*pList)[i];

//          if ( !pActPlug->IsStarPlug() )
//          {
//              String aExt = pActPlug->GetFileExtents();
//              // keine gleichen Extensions einf"ugen
//              FASTBOOL bFound = FALSE;

//              for ( USHORT j = 0; j < aTmpList.Count(); ++j )
//              {
//                  if ( *aTmpList[j] == aExt )
//                  {
//                      bFound = TRUE;
//                      break;
//                  }
//              }

//              if ( !bFound )
//              {
//                  String* pStr = new String( aExt );
//                  aTmpList.Insert( pStr, aTmpList.Count() );

//                  // Fix f"ur 3.0 PlugIns mit mehreren FileExt.
//                  USHORT nPos = 0;

//                  while ( ( nPos = aExt.SearchAndReplace( ',', ';', nPos ) )
//                          != STRING_NOTFOUND )
//                      aExt.Insert( "*.", nPos+1 );
//                  aExt.Insert( "*.", 0 );
//                  pDlg->AddFilter( pActPlug->GetFileOpenName(), aExt );

//                  if ( pActPlug->GetFileExtents() == "*" )
//                      pDlg->SetCurFilter( pActPlug->GetFileOpenName() );
//              }
//          }
//      }

	if ( pDlg->Execute() )
		aEdFileurl.SetText( pDlg->GetPath() );
	delete pDlg;
	return 0;
}

// -----------------------------------------------------------------------

SvInsertPlugInDlg::SvInsertPlugInDlg( Window* pParent ) :

	MdInsertObjectPlugin( pParent, SoResid( MD_INSERT_OBJECT_PLUGIN ) )

{
	aBtnFileurl.SetClickHdl( LINK( this, SvInsertPlugInDlg, BrowseHdl ) );
}

// class SvInsertAppletDlg -----------------------------------------------

class SvInsertAppletDlg : public MdInsertObjectApplet
{
private:
	DECL_LINK( BrowseHdl, PushButton * );

public:
	SvInsertAppletDlg( Window* pParent );

	String  GetClass() const { return aEdClassfile.GetText(); }
	String  GetClassLocation() const { return aEdClasslocation.GetText(); }
	String  GetAppletOptions() const { return aEdAppletOptions.GetText(); }

	void    SetClass( const String &rClass ) { aEdClassfile.SetText(rClass); }
	void    SetClassLocation( const String &rLocation ) { aEdClasslocation.SetText(rLocation); }
	void    SetAppletOptions( const String &rOptions ) { aEdAppletOptions.SetText(rOptions); }
};

// -----------------------------------------------------------------------

IMPL_LINK( SvInsertAppletDlg, BrowseHdl, PushButton *, EMPTYARG )
{
	VclFileDialog*  pDlg =
		GetpApp()->CreateFileDialog( this, WB_OPEN | WB_SVLOOK );
	pDlg->AddFilter( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Applet" ) ), 
					String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "*.class" ) ) );

	if ( pDlg->Execute() )
	{
		INetURLObject aEntry( pDlg->GetPath() );
		aEdClassfile.SetText( aEntry.getName() );
		aEntry.removeSegment();
		aEdClasslocation.SetText( aEntry.PathToFileName() );
	}
	delete pDlg;
	return 0;
}

// -----------------------------------------------------------------------

SvInsertAppletDlg::SvInsertAppletDlg( Window* pParent ) :

	MdInsertObjectApplet( pParent, SoResid( MD_INSERT_OBJECT_APPLET ) )

{
	aBtnClass.SetClickHdl( LINK( this, SvInsertAppletDlg, BrowseHdl ) );
}


// class SvInsertOleObjectDialog -----------------------------------------

void SvInsertOleObjectDialog::FillObjectServerList( SvObjectServerList* pList )

/*  [Beschreibung]

	Statische Methode mit der die "ubergebene Liste gef"ullt wird.
*/

{
	pList->FillInsertObjects();
}

// -----------------------------------------------------------------------

SvInPlaceObjectRef SvInsertOleObjectDialog::Execute
(
	Window* pParent,                // Parent f"ur den eigentlichen Dialog
	SvStorage* pStor,               // Storage f"ur die Factory-Methode
	const SvObjectServerList* pServers // wenn NULL, dann Default-Liste
)

/*  [Beschreibung]

	In dieser Methode wird der eigentliche Dialog gestartet. Wenn dieser
	mit <OK> beendet wurde, wird das <SvInPlaceObject> mit dem
	ausgew"ahlten <SvObjectServer> erzeugt. Sonst wird ein leerer
	<SvInPlaceObjectRef> zur"uckgegeben.
*/

{
	SvInPlaceObjectRef  xRet;
	SvObjectServerList  aObjS;

	// ggf. Serverliste f"ullen
	if ( !pServers )
	{
		aObjS.FillInsertObjects();
		pServers = &aObjS;
	}

	SvInsertOleDlg* pDlg = new SvInsertOleDlg( pParent );
	ListBox& rBox = pDlg->GetObjectTypes();
	rBox.SetUpdateMode( FALSE );

	for ( ULONG i = 0; i < pServers->Count(); i++ )
		rBox.InsertEntry( (*pServers)[ i ].GetHumanName() );
	rBox.SetUpdateMode( TRUE );
	pDlg->SelectDefault();
	pDlg->SetHelpId( nHelpId );

	if ( pDlg->Execute() )
	{
		_aFileName.Erase();
		_bLink = FALSE;
		_bCreateNew = pDlg->IsCreateNew();

		if ( _bCreateNew )
		{
			String aName = rBox.GetSelectEntry();
			const SvObjectServer* pS = pServers->Get( aName );

			if ( pS )
			{
				BOOL bOk;
				if(	pS->GetClassName() == *SvOutPlaceObject::ClassFactory() )
				{
					xRet = SvOutPlaceObject::InsertObject( NULL, pStor, bOk, aName, _aFileName );
					if( _aFileName.Len() )
						_bCreateNew = FALSE;
				}
				else
				{
					xRet = &((SvFactory*)SvInPlaceObject::ClassFactory())->
									CreateAndInit( pS->GetClassName(), pStor );
					bOk = xRet.Is();
				}
				if ( !bOk )
				{
					if( _aFileName.Len() )
					{
						// Objekt konnte nicht aus Datei erzeugt werden
						String aErr( SoResid( STR_ERROR_OBJNOCREATE_FROM_FILE ) );
						aErr.SearchAndReplace( String( '%' ), _aFileName );
						ErrorBox( pParent, WB_SVLOOK | WB_OK, aErr ).Execute();
					}
					else
					{
						// Objekt konnte nicht erzeugt werden
						String aErr( SoResid( STR_ERROR_OBJNOCREATE ) );
						aErr.SearchAndReplace( String( '%' ), aName );
						ErrorBox( pParent, WB_SVLOOK | WB_OK, aErr ).Execute();
					}
				}
			}
		}
		else
		{
			_aFileName = pDlg->GetFilePath();
			_bLink = pDlg->IsLinked();

			xRet = &((SvFactory*)SvInPlaceObject::ClassFactory())->
					CreateAndInit( _aFileName, pStor, _bLink );

			if ( !xRet.Is() )
			{
				// Objekt konnte nicht aus Datei erzeugt werden
				String aErr( SoResid( STR_ERROR_OBJNOCREATE_FROM_FILE ) );
				aErr.SearchAndReplace( String( '%' ), _aFileName );
				ErrorBox( pParent, WB_SVLOOK | WB_OK, aErr ).Execute();
			}
		}
	}
	delete pDlg;
	return xRet;
}

// class SvInsertPlugInDialog --------------------------------------------

SvInsertPlugInDialog::~SvInsertPlugInDialog()
{
	delete pURL;
}

// -----------------------------------------------------------------------

SvInPlaceObjectRef SvInsertPlugInDialog::Execute
(
	Window* pParent,        // Parent f"ur den eigentlichen Dialog
	SvStorage* pStor        // Storage f"ur die Factory-Methode
)

/*  [Beschreibung]

	In dieser Methode wird der eigentliche Dialog gestartet. Wenn dieser
	mit <OK> beendet wurde, wird das <SvInPlaceObject> mit der
	ausgew"ahlten URL erzeugt. Sonst wird ein leerer
	<SvInPlaceObjectRef> zur"uckgegeben.
*/

{
	aCommands.Erase();
	SvInPlaceObjectRef xRet;
	SvInsertPlugInDlg* pDlg = new SvInsertPlugInDlg( pParent );

	if ( pDlg->Execute() )
	{
		if ( !pURL )
			pURL = new INetURLObject();
		else
			*pURL = INetURLObject();

		pURL->SetSmartProtocol( INET_PROT_FILE );
		aCommands = pDlg->GetPlugInOptions();
		String aURL = pDlg->GetPlugInFile();
		aURL = URIHelper::SmartRelToAbs( aURL );

		if ( pURL->SetSmartURL( aURL ) )
		{
			SvFactory * pPlugIn = SvFactory::GetDefaultPlugInFactory();
			SvPlugInObjectRef xObj =
				&pPlugIn->CreateAndInit( *pPlugIn, pStor );
			xObj->SetPlugInMode( (USHORT)PLUGIN_EMBEDED );
			xObj->SetURL( *pURL );
			USHORT nEaten;
			SvCommandList aLst;
			aLst.AppendCommands( aCommands, &nEaten );
			xObj->SetCommandList( aLst );
			xRet = (SvInPlaceObject*)&xObj;
		}
		else
		{
			// PlugIn konnte nicht erzeugt werden
			String aErr( SoResid( STR_ERROR_OBJNOCREATE_PLUGIN ) );
			aErr.SearchAndReplace( String( '%' ), aURL );
			ErrorBox( pParent, WB_SVLOOK | WB_OK, aErr ).Execute();
		}
	}
	delete pDlg;
	return xRet;
}

// class SvInsertAppletDialog --------------------------------------------

SvInsertAppletDialog::~SvInsertAppletDialog()
{
	delete pURL;
}

// -----------------------------------------------------------------------
#if SUPD<=358

SvInPlaceObjectRef SvInsertAppletDialog::Execute
(
	Window* pParent,        // Parent f"ur den eigentlichen Dialog
	SvStorage* pStor        // Storage f"ur die Factory-Methode
)
{
	return Execute( pParent, pStor, 0 );
}
#endif

SvInPlaceObjectRef SvInsertAppletDialog::Execute
(
	Window* pParent,        // Parent f"ur den eigentlichen Dialog
	SvStorage* pStor,       // Storage f"ur die Factory-Methode
	SvAppletObject* pObj    // != 0 => editieren / == 0 => neu anlegen
)

/*  [Beschreibung]

	In dieser Methode wird der eigentliche Dialog gestartet. Wenn dieser
	mit <OK> beendet wurde, wird das <SvInPlaceObject> mit der
	ausgew"ahlten URL erzeugt. Sonst wird ein leerer
	<SvInPlaceObjectRef> zur"uckgegeben.
*/

{
	aClass.Erase();
	aCommands.Erase();
	SvInPlaceObjectRef xRet;
	SvInsertAppletDlg *pDlg = new SvInsertAppletDlg( pParent );
	SvFactory *pApplet = SvFactory::GetDefaultAppletFactory();
	SvAppletObjectRef xObj = pObj;
	if ( xObj.Is() )
	{
		pDlg->SetClass( xObj->GetClass() );
		pDlg->SetClassLocation( xObj->GetCodeBase() );
		pDlg->SetAppletOptions( xObj->GetCommandList().GetCommands() );
		XubString aText( SoResid( STR_EDIT_APPLET ) );
		pDlg->SetText( aText );
	}

	if ( pDlg->Execute() )
	{
		if ( !xObj )
			xObj = &pApplet->CreateAndInit( *pApplet, pStor );
		BOOL bIPActive = xObj->GetProtocol().IsInPlaceActive();
		if ( bIPActive )
			xObj->GetProtocol().Reset2Open();
		String aClassLocation = pDlg->GetClassLocation();
		// Hack, aFileName wird auch fuer Class benutzt
		aClass = pDlg->GetClass();
		xObj->SetClass( aClass );
		xObj->SetCodeBase( aClassLocation );
		USHORT nEaten;
		aCommands = pDlg->GetAppletOptions();
		SvCommandList aLst;
		aLst.AppendCommands( aCommands, &nEaten );
		xObj->SetCommandList( aLst );
		xRet = (SvInPlaceObject*)&xObj;
		if ( bIPActive )
			xObj->DoInPlaceActivate(TRUE);
	}
	delete pDlg;
	return xRet;
}


