/*************************************************************************
 *
 *  $RCSfile: embobj.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:54:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
//#define DBG_UTIL_PROT
#include <stdio.h>



#include <embobj.hxx>

#include <vcl/cvtgrf.hxx>
#include <vcl/gdimtf.hxx>
#include <vcl/wrkwin.hxx>
#include <vcl/svapp.hxx>
#include <vcl/virdev.hxx>
#include <sot/storinfo.hxx>
#include <sot/absdev.hxx>
#include <tools/debug.hxx>
#include <sot/exchange.hxx>

#include <soimpl.hxx>
#include <client.hxx>
#include <svstor.hxx>
#include <bindctx.hxx>
#include <bindctx.hxx>
#include <so2dll.hxx>
#include <soerr.hxx>
#include <svuidlg.hrc>

#pragma hdrstop

#include <svtools/filter.hxx>
#include <viscache.hxx>
#include <sot/formats.hxx>

/************** class SvEmbeddedInfoObject ***************************************/
/*************************************************************************/
SV_IMPL_PERSIST1(SvEmbeddedInfoObject,SvInfoObject)

/************************************************************************
|*    SvEmbeddedInfoObject::SvEmbeddedInfoObject()
|*    SvEmbeddedInfoObject::~SvEmbeddedInfoObject()
|*
|*    Beschreibung
*************************************************************************/
#define EMBIO_CTOR()                                        \
    bIsLink    = FALSE;

SvEmbeddedInfoObject::SvEmbeddedInfoObject()
{
	EMBIO_CTOR()
}

SvEmbeddedInfoObject::SvEmbeddedInfoObject( SvEmbeddedObject * pObj )
	: SvInfoObject( pObj )
{
	EMBIO_CTOR()
}

SvEmbeddedInfoObject::SvEmbeddedInfoObject( SvEmbeddedObject * pObj,
											const String & rName )
	: SvInfoObject( pObj, rName )
{
	EMBIO_CTOR()
}

SvEmbeddedInfoObject::~SvEmbeddedInfoObject()
{
}

/************************************************************************
|*    SvEmbeddedInfoObject::MakeCopy()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedInfoObject::Assign( const SvInfoObject * pObj )
{
	SvInfoObject::Assign( pObj );
	SvEmbeddedInfoObject * pI = PTR_CAST(SvEmbeddedInfoObject, pObj );
	if( pI )
	{
		bIsLink  = pI->bIsLink;
		aVisArea = pI->aVisArea;
	}
}

/************************************************************************
|*    SvEmbeddedInfoObject::Load()
|*    SvEmbeddedInfoObject::Save()
|*
|*    Beschreibung
*************************************************************************/
#define INFO_VERSION    (BYTE)2
void SvEmbeddedInfoObject::Load( SvPersistStream & rStm )
{
	SvInfoObject::Load( rStm );
	BYTE nVers = 0;
	rStm >> nVers;
	DBG_ASSERT( nVers == INFO_VERSION, "SvInfoObject version conflict" )
	if( nVers != INFO_VERSION )
		rStm.SetError( SVSTREAM_WRONGVERSION );
	else
	{
		rStm >> bIsLink;
		rStm >> aVisArea;
	}
}

void SvEmbeddedInfoObject::Save( SvPersistStream & rStm )
{
	SvInfoObject::Save( rStm );
	rStm << (BYTE)INFO_VERSION;
	rStm << (BOOL)IsLink();
	rStm << GetVisArea();
}

/************************************************************************
|*    SvEmbeddedInfoObject::SetObj()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedInfoObject::SetObj( SvPersist * pObjP )
{
	SvInfoObject::SetObj( pObjP );
	SvEmbeddedObject * pObj = GetEmbed();
	if( pObj && !pObj->Owner() )
		pObj->SvEmbeddedObject::SetVisArea( aVisArea );
}

/************************************************************************
|*    SvEmbeddedInfoObject::IsLink()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvEmbeddedInfoObject::IsLink() const
{
	SvEmbeddedObject * pObj = GetEmbed();
	if( pObj && pObj->IsLink() )
		return TRUE;
	return bIsLink;
}

/************************************************************************
|*    SvEmbeddedInfoObject::GetVisArea()
|*
|*    Beschreibung
*************************************************************************/
const Rectangle & SvEmbeddedInfoObject::GetVisArea() const
{
	SvEmbeddedObject * pObj = GetEmbed();
	if( pObj )
		((SvEmbeddedInfoObject *)this)->aVisArea = pObj->GetVisArea();
	return aVisArea;
}

/********************** SvFilterList **************************************
**************************************************************************/
PRV_SV_IMPL_OWNER_LIST(SvFilterList,SvFilter)


/************** class SvObjectDescriptor ********************************
**************************************************************************/
/************************************************************************
|*    SvObjectDescriptor::SvObjectDescriptor()
|*
|*    Beschreibung
*************************************************************************/
#if SUPD <= 397
SvObjectDescriptor::SvObjectDescriptor( SvDataObject * pDataObj )
{
	Init( pDataObj );
}
#endif

SvObjectDescriptor::SvObjectDescriptor( SotDataObject * pDataObj )
{
	Init( pDataObj );
}

void SvObjectDescriptor::Init( SotDataObject * pDataObj )
{
	// Hat einen Descriptor
	bCanLink = FALSE;

	SvData aData = SvData( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR );
	pDataObj->GetData( &aData );

	void *  pData = NULL;
	if( aData.GetData( &pData, TRANSFER_REFERENCE ) )
	{
		BYTE * pSeek = (BYTE *)pData;
		ULONG nSize = *(ULONG *)pSeek;
		pSeek += sizeof( ULONG );

		SvMemoryStream aStr( (sal_Char*)pSeek, nSize - sizeof( ULONG ),
							 STREAM_STD_READ );

		aStr >> aClassName;
		aStr >> nViewAspect;
		aStr >> aSize.Width();
		aStr >> aSize.Height();
		aStr >> aDragStartPos.X();
		aStr >> aDragStartPos.Y();
		aStr.ReadByteString( aTypeName, gsl_getSystemTextEncoding() );
		aStr.ReadByteString( aDisplayName, gsl_getSystemTextEncoding() );
	}
};

void SvObjectDescriptor::Init( SvEmbeddedObject * pObj )
{
	String aAppName, aShortName, aFullName;
	ULONG  nClipFormat;

	pObj->FillClass( &aClassName, &nClipFormat, &aAppName,
					&aTypeName, &aShortName );
	nViewAspect     = ASPECT_CONTENT;
	// In 100th mm umrechnen
	aSize           = pObj->GetVisArea().GetSize();
	MapUnit nDestMU = pObj->GetMapUnit();
	aSize			= OutputDevice::LogicToLogic( aSize, nDestMU,
												  MAP_100TH_MM );
	nOle2Misc       = pObj->GetMiscStatus();
	bCanLink        = FALSE;
}

SvObjectDescriptor::SvObjectDescriptor( SvEmbeddedObject * pObj )
{
	Init( pObj );
}

SvObjectDescriptor::SvObjectDescriptor( SvEmbeddedObject * pObj,
										  const Point rDragStartPos )
{
	Init( pObj );
	aDragStartPos = rDragStartPos;
}


/************************************************************************
|*    SvObjectDescriptor::operator << ()
|*
|*    Beschreibung      In das Systemabhaengige Clipboardformat
*************************************************************************/
SvStream& operator << ( SvStream& rOStr, const SvObjectDescriptor & rObj )
{
	ULONG nSizePos = rOStr.Tell();  // Size-Pos merken
	rOStr << (ULONG)0;              // Dummy Groesse
	rOStr << rObj.aClassName;
	rOStr << rObj.nViewAspect;
	rOStr << rObj.aSize.Width();
	rOStr << rObj.aSize.Height();
	rOStr << rObj.aDragStartPos.X();
	rOStr << rObj.aDragStartPos.Y();
	rOStr.WriteByteString( rObj.aTypeName, gsl_getSystemTextEncoding() );
	rOStr.WriteByteString( rObj.aDisplayName, gsl_getSystemTextEncoding() );

	ULONG nPos = rOStr.Tell();          // um zurueck zu setzen
	rOStr.Seek( nSizePos );             // auf Size Position
	rOStr << (ULONG)(nPos - nSizePos);  // Groesse setzen
	rOStr.Seek( nPos );                 // zurueck setzen
	return rOStr;
}

/************** class SvObjectRegistryInfo ******************************/
/*************************************************************************
|*    SvObjectRegistryInfo::SvObjectRegistryInfo ()
|*
|*    Beschreibung
*************************************************************************/
SvObjectRegistryInfo::SvObjectRegistryInfo()
	: nMajorVers( 0 )
	, nMinorVers( 0 )
{
}

SvObjectRegistryInfo::SvObjectRegistryInfo( const SvGlobalName & rName,
											SvRegistry & rReg )
	: nMajorVers( 0 )
	, nMinorVers( 0 )
{
	Fill( rName, rReg );
}

/*************************************************************************
|*    SvObjectRegistryInfo::SetDefaults()
|*
|*    Beschreibung
*************************************************************************/
void SvObjectRegistryInfo::SetDefaults()
{
	aCompanyName	= String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "Sun Microsystems" ) );
	aServerPath		= GetpApp()->GetAppFileName();
	Window * pWin	= GetpApp()->GetAppWindow();
	if( pWin )
		aHumanAppName = pWin->GetText();
	aAppName = GetpApp()->GetAppName();
	nMajorVers = 1;
}

/*************************************************************************
|*    SvObjectRegistryInfo::Fill()
|*
|*    Beschreibung
*************************************************************************/
void SvObjectRegistryInfo::Fill( const SvGlobalName & rName,
								 SvRegistry & rReg )
{
	aClassName = rName;
	DBG_ERROR( "SvObjectRegistryInfo::Fill() not implemented" )
}

/*************************************************************************
|*    SvObjectRegistryInfo::GetLongAppName()
|*
|*    Beschreibung
*************************************************************************/
String SvObjectRegistryInfo::GetLongAppName() const
{
	String aLongAppName = aHumanAppName;
	aLongAppName += ' ';
	aLongAppName += nMajorVers;
	aLongAppName += '.';
	aLongAppName += nMinorVers;
	return aLongAppName;
}

/*************************************************************************
|*    SvObjectRegistryInfo::GetLongName()
|*
|*    Beschreibung
*************************************************************************/
String SvObjectRegistryInfo::GetLongName() const
{
	String aLongName = GetLongAppName();
	aLongName += ' ';
	aLongName += aHumanShortTypeName;
	return aLongName;;
}

/*************************************************************************
|*    SvEmbeddedRegistryInfo::SvEmbeddedRegistryInfo()
|*
|*    Beschreibung
*************************************************************************/
SvEmbeddedRegistryInfo::SvEmbeddedRegistryInfo( const SvGlobalName & rName,
												SvRegistry & rReg )
	: bInsertable( FALSE )
	, nMiscStatus( 0 )
	, nDefaultDataFormat( 0 )
	, nShell( REG_SHELL_OPEN|REG_SHELL_PRINT|REG_SHELL_PRINTTO )
	, nIconResId( 0 )
{
	Fill( rName, rReg );
}
/*************************************************************************
|*    SvEmbeddedRegistryInfo::SvEmbeddedRegistryInfo()
|*
|*    Beschreibung
*************************************************************************/
SvEmbeddedRegistryInfo::SvEmbeddedRegistryInfo()
	: bInsertable( FALSE )
	, nMiscStatus( 0 )
	, nDefaultDataFormat( 0 )
	, nShell( REG_SHELL_OPEN|REG_SHELL_PRINT|REG_SHELL_PRINTTO )
	, nIconResId( 0 )
{
}

/*************************************************************************
|*    SvEmbeddedRegistryInfo::Fill()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedRegistryInfo::Fill( const SvGlobalName & rName,
								   SvRegistry & rReg )
{
	SvObjectRegistryInfo::Fill( rName, rReg );
}

/*************************************************************************/
void Impl_CacheElement::Read( SvStream & rStm )
{
	ULONG nBeginPos = rStm.Tell();
	INT32 n;
	rStm >> n;
	if( n != -1 )
	{
		Bitmap aBmp;
		rStm >> aBmp;
		if( rStm.GetError() == SVSTREAM_OK )
		{
			SetFormat( FORMAT_BITMAP );
			aSize = aBmp.GetPrefSize();
			MapMode aMMSrc;
			if( !aSize.Width() || !aSize.Height() )
			{
				// letzte Chance
				aSize = aBmp.GetSizePixel();
				aMMSrc = MAP_PIXEL;
			}
			else
				aMMSrc = aBmp.GetPrefMapMode();
			MapMode aMMDst( MAP_100TH_MM );
			aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
			SetData( &aBmp );
			return;
		}
		else
		{
			GDIMetaFile aMtf;
			rStm.ResetError();
			rStm >> aMtf;
			if( rStm.GetError() == SVSTREAM_OK )
			{
				SetFormat( FORMAT_GDIMETAFILE );
				aSize = aMtf.GetPrefSize();
				MapMode aMMSrc = aBmp.GetPrefMapMode();
				MapMode aMMDst( MAP_100TH_MM );
				aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
				SetData( &aMtf );
				return;
			}
		}

	}

	rStm.ResetError();
	rStm.Seek( nBeginPos );
	ULONG nFormat = ReadClipboardFormat( rStm );
	SetFormat( nFormat );
	// JobSetup, bzw. TargetDevice ueberlesen
	// Information aufnehmen, um sie beim Schreiben nicht zu verlieren
	nJobLen = 0;
	rStm >> nJobLen;
	if( nJobLen >= 4 )
	{
		nJobLen -= 4;
		if( nJobLen )
		{
			pJob = new BYTE[ nJobLen ];
			rStm.Read( pJob, nJobLen );
		}
	}
	else
	{
		rStm.SetError( SVSTREAM_GENERALERROR );
		return;
	}
	UINT32 nAsp;
	rStm >> nAsp;
	USHORT nSvAsp = SvDataObject::Ole2SvAspect( nAsp );
	SetAspect( nSvAsp );
	rStm.SeekRel( 4 ); //L-Index ueberlesen
	rStm >> nAdvFlags;
	rStm.SeekRel( 4 ); //Compression
	UINT32 nWidth  = 0;
	UINT32 nHeight = 0;
	UINT32 nSize   = 0;
	rStm >> nWidth >> nHeight >> nSize;
	aSize.Width() = nWidth;
	aSize.Height() = nHeight;

	if( nFormat == FORMAT_GDIMETAFILE )
	{
		GDIMetaFile aMtf;
		ReadWindowMetafile( rStm, aMtf );
		SetData( &aMtf );
	}
	else if( nFormat == FORMAT_BITMAP )
	{
		Bitmap aBmp;
		rStm >> aBmp;
		SetData( &aBmp );
	}
	else
	{
		void * p = new BYTE[ nSize ];
		rStm.Read( p, nSize );
		SetData( p, nSize, TRANSFER_MOVE );
	}
}

/************************************************************************/
void Impl_CacheElement::Write( SvStream & rStm )
{
	WriteClipboardFormat( rStm, FORMAT_GDIMETAFILE );
	rStm << (INT32)(nJobLen +4);       // immer leeres TargetDevice
	if( nJobLen )
		rStm.Write( pJob, nJobLen );
	rStm << (UINT32)SvDataObject::Sv2OleAspect( GetAspect() );
	rStm << (INT32)-1;      //L-Index immer -1
	rStm << (INT32)nAdvFlags;
	rStm << (INT32)0;       //Compression
	rStm << (INT32)aSize.Width();
	rStm << (INT32)aSize.Height();
	ULONG nPos = rStm.Tell();
	rStm << (INT32)0;

	if( GetFormat() == FORMAT_GDIMETAFILE )
	{
		GDIMetaFile * pMtf;
		if( GetData( &pMtf, TRANSFER_REFERENCE ) )
		{
			// Immer auf 1/100 mm, bis Mtf-Loesung gefunden
			// Annahme (keine Skalierung, keine Org-Verschiebung)
			DBG_ASSERT( pMtf->GetPrefMapMode().GetScaleX() == Fraction( 1, 1 ),
						"X-Skalierung im Mtf" )
			DBG_ASSERT( pMtf->GetPrefMapMode().GetScaleY() == Fraction( 1, 1 ),
						"Y-Skalierung im Mtf" )
			DBG_ASSERT( pMtf->GetPrefMapMode().GetOrigin() == Point(),
						"Origin-Verschiebung im Mtf" )
			MapUnit nMU = pMtf->GetPrefMapMode().GetMapUnit();
			if( MAP_100TH_MM != nMU )
			{
				Size aPrefS( pMtf->GetPrefSize() );
				Size aS( aPrefS );
				aS = OutputDevice::LogicToLogic( aS, nMU, MAP_100TH_MM );

				pMtf->Scale( Fraction( aS.Width(), aPrefS.Width() ),
							 Fraction( aS.Height(), aPrefS.Height() ) );
				pMtf->SetPrefMapMode( MAP_100TH_MM );
				pMtf->SetPrefSize( aS );
			}
			WriteWindowMetafileBits( rStm, *pMtf );
		}
	}
	else if( GetFormat() == FORMAT_BITMAP )
	{
		Bitmap * pBmp;
		if( GetData( &pBmp, TRANSFER_REFERENCE ) )
			rStm << *pBmp;
	}
	else
	{
		void * p;
		if( GetData( &p, TRANSFER_REFERENCE ) )
			rStm.Write( p, GetMinMemorySize() );
	}
	ULONG nEndPos = rStm.Tell();
	rStm.Seek( nPos );
	rStm << (UINT32)nEndPos - nPos - 4;
	rStm.Seek( nEndPos );
}

/*************************************************************************/
Impl_Cache::~Impl_Cache()
{
	Impl_CacheElement * pEle = (Impl_CacheElement *)aDList.First();
	while( pEle )
	{
		delete pEle;
		pEle = (Impl_CacheElement *)aDList.Next();
	}
}

/*************************************************************************/
void Impl_Cache::SetData( SvData * pData, const Size & rSize )
{
	Impl_CacheElement * pEle = (Impl_CacheElement *)aDList.First();
	while( pEle )
	{
		if( pData->Match( *pEle ) )
		{
			pEle->SetData( pData );
			pEle->SetSize( rSize );
		}
		pEle = (Impl_CacheElement *)aDList.Next();
	}
}

/*************************************************************************/
BOOL Impl_Cache::GetData( SvData * pData )
{
	Impl_CacheElement * pEle = (Impl_CacheElement *)aDList.First();
	while( pEle )
	{
		if( pEle->Match( *pData ) )
		{
			pData->SetData( pEle );
			return TRUE;
		}
		pEle = (Impl_CacheElement *)aDList.Next();
	}
	return FALSE;
}

/*************************************************************************
|*
|*    SvEmbeddedObject::Factory()
|*
*************************************************************************/
SO2_IMPL_CLASS2_DLL(SvEmbeddedObject,SvFactory,SvPersist,SvPseudoObject,
					SvGlobalName( 0xBB0D2800L, 0x73EE, 0x101B,
								  0x80,0x4C,0xFD,0xFD,0xFD,0xFD,0xFD,0xFD) )

IUnknown * SvEmbeddedObject::GetMemberInterface( const SvGlobalName & )
{
	return NULL;
}

void SvEmbeddedObject::TestMemberObjRef( BOOL /*bFree*/ )
{
#ifdef DBG_UTIL
	if( GetClient() )
	{
		ByteString aTest = "\t\tGetClient() == ";
		aTest.Append( ByteString::CreateFromInt32( (ULONG)(SvObject *)GetClient() ) );
		DBG_TRACE( aTest.GetBuffer() );
	}
#endif
}

#ifdef TEST_INVARIANT
void SvEmbeddedObject::TestMemberInvariant( BOOL bPrint )
{
}
#endif

/************************************************************************
|*    SvEmbeddedObject::SvEmbeddedObject()
|*
|*    Beschreibung
*************************************************************************/
SvEmbeddedObject::SvEmbeddedObject()
	: pCache	      ( NULL )
	, pViewObj2       ( NULL )
	, bAutoSave       ( TRUE )
	, bAutoHatch      ( TRUE )
	, nMapUnit        ( MAP_100TH_MM )
{
}


SvEmbeddedObject::~SvEmbeddedObject()
{
	delete pCache;
}

//=========================================================================
USHORT SvEmbeddedObject::FuzzyLock
(
	BOOL bLock,		/* TRUE, lock. FALSE, unlock. */
	BOOL bIntern,	/* TRUE, es handelt sich um einen internen Lock.
					   FALSE, der Lock kam von aussen (Ole2, Ipc2) */
	BOOL bClose		/* TRUE, Close aufrufen wenn letzte Lock */
)
/*	[Beschreibung]

	Ruft FuzzyLock von <SvPseudoObject> und nicht von <SvPersist>.

	[Querverweise]

	<SvPseudoObject::FuzzyLock>
*/
{
	return SvPseudoObject::FuzzyLock( bLock, bIntern, bClose );
}

/*************************************************************************
|*    SvEmbeddedObject::CreateSnapshot()
|*
|*    Beschreibung
*************************************************************************/
SvDataMemberObjectRef SvEmbeddedObject::CreateSnapshot()
{
	SvDataMemberObjectRef xDataObj = SvDataObject::CreateSnapshot();
	return xDataObj;
}

/************************************************************************
|*    SvEmbeddedObject::Update()
|*    SvEmbeddedObject::IsUpToDate()
|*
|*    Beschreibung
*************************************************************************/
ULONG SvEmbeddedObject::GetUpToDateStatus()
{
	if( Owner() )
	{
		ULONG nErr = ERRCODE_NONE;
		const SvInfoObjectMemberList * pList = GetObjectList();
		if( pList )
		{
			for( ULONG i = 0; i < pList->Count(); i++ )
			{
				SvInfoObject * pEle = pList->GetObject( i );
				SvEmbeddedObjectRef xObj = pEle->GetObj();
				if( xObj.Is() )
				{
					ULONG n = xObj->GetUpToDateStatus();
					if( ERRCODE_TOERROR( n ) )
					{
						if( n != ERRCODE_SO_MK_UNAVAILABLE )
							return nErr;
						nErr = n;
					}
					else if( !ERRCODE_TOERROR( nErr )
					  && (n & ERRCODE_WARNING_MASK) )
						nErr = n;
				}
				else
					nErr = ERRCODE_SO_MK_UNAVAILABLE;
			}
		}
		return nErr;
	}
	else
		return SvPseudoObject::GetUpToDateStatus();
}

ULONG SvEmbeddedObject::Update()
{
	if( Owner() )
	{
		ULONG nErr = ERRCODE_NONE;
		LoadChilds();
		const SvInfoObjectMemberList * pList = GetObjectList();
		if( pList )
		{
			for( ULONG i = 0; i < pList->Count(); i++ )
			{
				SvInfoObject * pEle = pList->GetObject( i );
				if( pEle->GetObj() )
				{
					SvEmbeddedObjectRef xObj = pEle->GetObj();
					// kein Embedded Objekt ist Ok
					if( xObj.Is() )
					{
						ULONG n = xObj->Update();
						if( ERRCODE_TOERROR( n ) )
							return n;
						else if( n & ERRCODE_WARNING_MASK )
							nErr = n;
					}
				}
				else
					return ERRCODE_SO_CANT_BINDTOSOURCE;
			}
		}
		return nErr;
	}
	else
		return SvPseudoObject::Update();
}

/*************************************************************************
|*    SvEmbeddedObject::FillRegInfo()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::FillRegInfo( SvEmbeddedRegistryInfo * pInfo )
{
	if( Owner() )
	{
		pInfo->SetDefaults();
		pInfo->aClassName 		= *GetSvFactory();
		pInfo->aVerbList 		= GetVerbList();
		pInfo->bInsertable		= TRUE;
		pInfo->aHumanAppName	= GetAppName();
		SvGlobalName aN;
		String		 aStr;
		FillClass(	&aN,
					&pInfo->nDefaultDataFormat,
					&aStr,
					&aStr,
					&pInfo->aHumanShortTypeName );
		aStr = SotExchange::GetFormatName( pInfo->nDefaultDataFormat );
		pInfo->aObjName			= aStr;
		pInfo->nMiscStatus		= GetMiscStatus();
		pInfo->aSetDataTypeList = GetTypeList();
		pInfo->aGetDataTypeList = GetSetDataTypeList();
		pInfo->aFilterList.Append( pInfo->nDefaultDataFormat );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::Load()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvEmbeddedObject::Load( SvStorage * pStor )
{
	SvGlobalName aClassName = pStor->GetClassName();

	SvGlobalName aActualClassName =
		SvFactory::GetAutoConvertTo( aClassName );

	if( aActualClassName == *GetSvFactory() )
		return SvPersist::Load( pStor );
	else
	{ // Ich bin es nicht selbst
		return SvPersist::Load( pStor );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::Save()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvEmbeddedObject::Save()
{
	return SvPersist::Save();
}

BOOL SvEmbeddedObject::SaveAs( SvStorage * pNewStor )
{
	BOOL bRet = FALSE;
	if( SvPersist::SaveAs( pNewStor ) )
	{
		bRet = TRUE;
		if( bRet && Owner() && GetParent()
		  && SOFFICE_FILEFORMAT_31 == pNewStor->GetVersion() )
		{
			ULONG n = pNewStor->GetFormat();
			if( n == SOT_FORMATSTR_ID_STARWRITER_30 || n == SOT_FORMATSTR_ID_STARDRAW
			  || n == SOT_FORMATSTR_ID_STARCALC )
			{
				// Ole Stream und OlePress Stream erstellen
				Impl_CacheElement aEle( FORMAT_GDIMETAFILE );
				SvData aData( FORMAT_GDIMETAFILE );
				GDIMetaFile * pMtf;
				if( GetData( &aData ) && aData.GetData( &pMtf, TRANSFER_REFERENCE ) )
					MakeContentStream( pNewStor, *pMtf );
			}
		}
	}
	return bRet;
}

/*************************************************************************
|*    SvEmbeddedObject::LoadContent()
|*
|*    Beschreibung
*************************************************************************/
#define EMBEDDED_OBJECT_VERSION (BYTE)0
void SvEmbeddedObject::LoadContent( SvStream & rStm, BOOL bOwner )
{
	SvPersist::LoadContent( rStm, bOwner );
	if( rStm.GetError() != SVSTREAM_OK )
		return;

	if( bOwner )
	{
		BYTE nVers;
		rStm >> nVers;
		DBG_ASSERT( nVers == EMBEDDED_OBJECT_VERSION, "version conflict" )

		if( nVers != EMBEDDED_OBJECT_VERSION )
			rStm.SetError( SVSTREAM_WRONGVERSION );
		else
		{
			// Sichtbaren Bereich setzten
			rStm >> aVisArea;
			USHORT nUnit;
			rStm >> nUnit;
			SetMapUnit( (MapUnit)nUnit );
		}
	}
	else
	{
		if( !pCache )
			pCache = new Impl_Cache();
		Impl_CacheElement * pEle = new Impl_CacheElement( 0 );
		pEle->Read( rStm );
		// Eigentuemeruebergang
		pCache->Cache( pEle );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::SaveContent()
|*
|*    Beschreibung
*************************************************************************/

static void WriteExtContent( SvStream & rStm, const GDIMetaFile & rMtf,
							 USHORT nAspect, ULONG nAdviseModes )
{
	Impl_CacheElement * pEle = new Impl_CacheElement( FORMAT_GDIMETAFILE );

	// Die Groesse in 1/100 mm umrechnen
	// Falls eine nicht anwendbare MapUnit (Device abhaengig) verwendet wird,
	// versucht SV einen BestMatchden richtigen Wert zu raten.
	Size aSize = rMtf.GetPrefSize();
	MapMode aMMSrc = rMtf.GetPrefMapMode();
	MapMode aMMDst( MAP_100TH_MM );
	aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
	pEle->SetSize( aSize );
	pEle->SetAspect( nAspect );
	pEle->SetAdviseFlags( nAdviseModes );
	pEle->SetData( (GDIMetaFile *)&rMtf );
	pEle->Write( rStm );
	delete pEle;
}


void SvEmbeddedObject::SaveContent( SvStream & rStm, BOOL bOwner )
{
	SvPersist::SaveContent( rStm, bOwner );
	if( bOwner )
	{
		rStm << (BYTE)EMBEDDED_OBJECT_VERSION;
		rStm << GetVisArea();
		rStm << (USHORT)GetMapUnit();
	}
	else
	{
		if( !pCache )
			GetNewMetaFile();

		// ??? erst einmal nur einen schreiben
		Impl_CacheElement * pEle = pCache->GetObject( 0 );
		if( pEle )
		{
			pEle->Write( rStm );
		}
	}
}

/*************************************************************************
|*    SvEmbeddedObject::MakeContentStream()
|*
|*    Beschreibung
*************************************************************************/
BOOL SvEmbeddedObject::MakeContentStream( SvStorage * pStor,
										  SotDataObject * pDO )
{
	const SvDataTypeList & rList = pDO->GetTypeList();
	Impl_CacheElement * pEle = NULL;

	if( rList.Get( FORMAT_GDIMETAFILE ) )
	{
		GDIMetaFile *   pMtf;
		SvData          aData( FORMAT_GDIMETAFILE );
		if( pDO->GetData( &aData )
		  && aData.GetData( &pMtf, TRANSFER_MOVE ) )
		{
			Size aSize = pMtf->GetPrefSize();
			MapMode aMMSrc = pMtf->GetPrefMapMode();
			MapMode aMMDst( MAP_100TH_MM );
			aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
			pEle = new Impl_CacheElement( FORMAT_GDIMETAFILE );
			pEle->SetSize( aSize );
			pEle->SetData( pMtf, TRANSFER_MOVE );
		}
	}
	else if( rList.Get( FORMAT_BITMAP ) )
	{
		Bitmap      *   pBmp;
		SvData          aData( FORMAT_BITMAP );
		if( pDO->GetData( &aData )
		  && aData.GetData( &pBmp, TRANSFER_MOVE ) )
		{
			SvObjectDescriptor aDsc( pDO );
			Size aSize( aDsc.GetSize() );
			if( !aSize.Width() || !aSize.Height() )
			{
				aSize = pBmp->GetPrefSize();
				MapMode aMMSrc;
				if( !aSize.Width() || !aSize.Height() )
				{
					// letzte Chance
					aSize = pBmp->GetSizePixel();
					aMMSrc = MAP_PIXEL;
				}
				else
					aMMSrc = pBmp->GetPrefMapMode();
				MapMode aMMDst( MAP_100TH_MM );
				aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
			}
			pEle = new Impl_CacheElement( FORMAT_BITMAP );
			pEle->SetSize( aSize );
			pEle->SetData( pBmp, TRANSFER_MOVE );
		}
	}
	if( pEle )
	{
		// MAC MPW mag's sonst nicht ...
		String aPersistStream( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( SVEXT_PERSIST_STREAM ) ) );
		SvStorageStreamRef xStm = pStor->OpenStream( aPersistStream );
		xStm->SetVersion( pStor->GetVersion() );
		xStm->SetBufferSize( 8192 );

		pEle->SetAspect( ASPECT_CONTENT );
		pEle->SetAdviseFlags( 2 );
		pEle->Write( *xStm );
		delete pEle;

		xStm->SetBufferSize( 0 );
		return xStm->GetError() == SVSTREAM_OK;
	}
	return FALSE;
}

BOOL SvEmbeddedObject::MakeContentStream( SotStorage * pStor,
										  const GDIMetaFile & rMtf )
{
	// MAC MPW mag's sonst nicht ...
	String aPersistStream( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( SVEXT_PERSIST_STREAM ) ) );
	SotStorageStreamRef xStm = pStor->OpenSotStream( aPersistStream );
	xStm->SetVersion( pStor->GetVersion() );

	xStm->SetBufferSize( 8192 );
	WriteExtContent( *xStm, rMtf, ASPECT_CONTENT, 2 );
	xStm->SetBufferSize( 0 );
	return xStm->GetError() == SVSTREAM_OK;
}

BOOL SvEmbeddedObject::MakeContentStream( SvStorage * pStor,
										  const GDIMetaFile & rMtf )
{
	return MakeContentStream( (SotStorage *)pStor, rMtf );
}

//=========================================================================
void SvEmbeddedObject::FillClass
(
	SvGlobalName * pClassName,	/* Der Typ der Klasse */
	ULONG * pFormat,			/* Das Dateiformat in dem geschrieben wird */
	String * pAppName,			/* Der Applikationsname */
	String * pFullTypeName,     /* Der genaue Name des Typs	*/
	String * pShortTypeName,	/* Der kurze Name des Typs	*/
	long nFileFormat			/* F"ur dieses Office-Format sollen die
								   Parameter gef"ullt werden */
) const
/*  [Beschreibung]

	Die Methoden <SvPersist::FillClass> und <SvPseudoObject::FillClass>
	setzen nicht alle Parameter. <SvPersist::FillClass> setzt die
	Parameter pClassName und pFormat. <SvPseudoObject::FillClass> setzt
	die restlichen Parmeter.
*/
{
	SvGlobalName    aName;
	ULONG           nFormat;

	SvPersist::FillClass( pClassName, pFormat, pAppName, pFullTypeName,
							pShortTypeName, nFileFormat );
	SvPseudoObject::FillClass( &aName, &nFormat, pAppName, pFullTypeName,
								pShortTypeName, nFileFormat );
}


/*************************************************************************
|*    SvEmbeddedObject::SetModified()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::SetModified( BOOL bModifiedP )
{
	ASSERT_INIT()
	SvPersist::SetModified( bModifiedP );

	if( IsEnableSetModified() )
	{
		SvEmbeddedObjectRef xPar = this;

		while( xPar.Is() )
		{
			xPar->SetModifyTime( GetModifyTime() );

			SvPersist * pP = xPar->GetParent();
			xPar = pP;

			// Fuer diesen Fall muss der gesammte Ablauf noch
			// einmal geprueft werden
			DBG_ASSERT( xPar.Is() && pP || !pP && !xPar.Is(),
						"Persist-Parent ist kein EmbeddedObject" )
		}
	}
}

//=========================================================================
const SvDataTypeList & SvEmbeddedObject::GetStdFormatList()
/*	[Beschreibung]

	Es wird die FormatListe zur"ckgegeben, die alle Formate beinhaltet,
	welche n"otig sind, um ein Ole-Objekt auszutauschen. Die Formate
	"Embed Source", "Object Descriptor" und FORMAT_GDIMETFILE werden
	in dieser Reihenfolge in die Liste geschrieben. Auf dem Mac sind
	es die entsprechenden Formate. Man sollte diese deswegen nur "uber
	<SvEmbeddedObject::GetFormat()> und <SvObjectDescriptor::GetFormat()>
	benutzen.

	[R"uckgabewert]

	const SvDataTypeList &  Die Liste enth"alt alle Formate, die f"ur ein
							Ole-Objekt n"otig sind.
*/
{
	SoDll * pSoApp = SOAPP;
	if( !pSoApp->pEmbeddedStdFormatList )
	{
		pSoApp->pEmbeddedStdFormatList = new SvDataTypeList();
		// erst Ole-Object
		pSoApp->pEmbeddedStdFormatList->Append( SvDataType( SOT_FORMATSTR_ID_EMBED_SOURCE, MEDIUM_STORAGE ) );
		pSoApp->pEmbeddedStdFormatList->Append( SvDataType( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR, MEDIUM_MEMORY ) );
		// dann GDI-Metafile
		pSoApp->pEmbeddedStdFormatList->Append( SvDataType( FORMAT_GDIMETAFILE ) );
		//if( Link() )
		// Link kommt zuletz
		//pSoApp->pEmbeddedStdFormatList->Append( SvDataType( GetLinkFormat(), MEDIUM_STREAM ) );
		//pSoApp->pEmbeddedStdFormatList->Append( SvDataType( SvObjectDescriptor::GetLinkFormat(), MEDIUM_MEMORY ) );
	}
	return *pSoApp->pEmbeddedStdFormatList;
}

/*************************************************************************
|*    SvEmbeddedObject::GetMiscStatus()
|*
|*    Beschreibung
*************************************************************************/
ULONG SvEmbeddedObject::GetMiscStatus() const
{
	return SvPseudoObject::GetMiscStatus();
}

//=========================================================================
ErrCode SvEmbeddedObject::DoConnect
(
	SvEmbeddedClient * pClient	/* Der Client, mit das Objekt verbunden
								   wird. Darf nicht NULL sein. */
)
/*	[Beschreibung]

	Das Objekt wird mit dem "ubergebenen Client verbunden. Die Verbindung
	des Objektes und des Clients wird vorher abgebrochen. Ist der
	"ubergebene Client gleich dem Client, der mit dem Objekt verbunden
	ist passiert nichts.

	[R"uckgabewert]

	BOOL		TRUE, Objekt und Client konnten verbunden werden.
				FALSE, beim verbinden wurde DoClose gerufen.

	[Querverweise]

	<SvPseudoObject::DoClose>
*/
{
	DBG_ASSERT( pClient, "DoConnect( NULL ) not allowed" )
	DBG_ASSERT( !IsLink(), "try to connect a Link-Object" )

	if( IsLink() ) // nur "Ubergangsweise
		return ERRCODE_SO_GENERALERROR;

	if( aProt.GetClient() == pClient )
		return ERRCODE_NONE;

	SvObjectRef xHoldAlive( this );
	SvObjectRef xHoldAlive1( pClient );
	// Client freigeben
	pClient->aProt.Reset();
	aProt.Reset();

	aProt = SvEditObjectProtocol( this, pClient );
	pClient->aProt = aProt;
	aProt.Connected( TRUE );
	return aProt.IsConnect() ? ERRCODE_NONE : ERRCODE_SO_GENERALERROR;
}

/*************************************************************************
|*    SvEmbeddedObject::DoOpen()
|*
|*    Beschreibung
*************************************************************************/
ErrCode SvEmbeddedObject::DoOpen( BOOL bOpen )
{
	if( !aProt.IsConnect() )
		return ERRCODE_SO_GENERALERROR;
	if( aProt.IsOpen() == bOpen )
		return ERRCODE_NONE;

	SvEmbeddedObjectRef xHoldAliveDuringCall( this );

	if( !bOpen )
		aProt.Reset2Open();


	// Ein Open kommt nicht von Ole2
	// loest eventuell ein Close aus
	// Saved, wenn AutoSave
	aProt.Opened( bOpen );

	return (aProt.IsOpen() == bOpen) ? ERRCODE_NONE : ERRCODE_SO_GENERALERROR;
}

/*************************************************************************
|*    SvEmbeddedObject::DoEmbed()
|*
|*    Beschreibung
*************************************************************************/
ErrCode SvEmbeddedObject::DoEmbed( BOOL bEmbed )
{
	if( aProt.IsEmbed() == bEmbed )
		return ERRCODE_NONE;

	if( !bEmbed )
		aProt.Reset2Embed();

	ErrCode nRet = ERRCODE_NONE;
	if( Owner() )
	{
		if( bEmbed )
			// falls IP-Active
			aProt.Reset2Open();
		aProt.Embedded( bEmbed );
	}

	if( aProt.IsEmbed() != bEmbed && !ERRCODE_TOERROR( nRet ) )
		nRet = ERRCODE_SO_GENERALERROR;
	return nRet;
}

/*************************************************************************
|*    SvEmbeddedObject::Embed()
|*
|*    Beschreibung
*************************************************************************/
#ifdef DBG_UTIL_PROT
void SvEmbeddedObject::Embed( BOOL bEmbed )
#else
void SvEmbeddedObject::Embed( BOOL )
#endif
{
#ifdef DBG_UTIL_PROT
	String aTest( "Object---Embed---" );
	aTest += Owner() ? "Intern" : "Extern: ";
	aTest += bEmbed ? "TRUE" : "FALSE";
	DBG_TRACE( aTest )
#endif
	if( !Owner() )
	{
		// alle Verbindungen sofort mit neuen Daten updaten
		SvData aData;
		SendDataChanged( aData );
		SendViewChanged();
	}

	//if( Owner() ) ich bekomme leider das WorkWindow nicht
	//    GetClient()->GetTopWin()->ToTop();
}

//=========================================================================
ErrCode SvEmbeddedObject::DoPlugIn( BOOL bPlugIn )
/*	[Beschreibung]

	[R"uckgabewert]

	BOOL		TRUE, das Objekt ist im PlugIn-Zustand.
				FALSE, das Objekt ist nicht im PlugIn-Zustand.


	[Querverweise]
*/
{
	if( aProt.IsPlugIn() == bPlugIn )
		return ERRCODE_NONE;

	ErrCode nRet = ERRCODE_NONE;
	if( !bPlugIn )
		aProt.Reset2PlugIn();

	if( Owner() )
	{
		if( bPlugIn )
			// falls IP-Active
			aProt.Reset2Open();
		aProt.PlugIn( bPlugIn );
	}

	if( aProt.IsPlugIn() != bPlugIn && !ERRCODE_TOERROR( nRet ) )
		nRet = ERRCODE_SO_GENERALERROR;
	return nRet;
}

//=========================================================================
#ifdef DBG_UTIL_PROT
void SvEmbeddedObject::PlugIn( BOOL bPlugIn )
#else
void SvEmbeddedObject::PlugIn( BOOL )
#endif
{
#ifdef DBG_UTIL_PROT
	String aTest( "Object---PlugIn---" );
	aTest += Owner() ? "Intern" : "Extern: ";
	aTest += bPlugIn ? "TRUE" : "FALSE";
	DBG_TRACE( aTest )
#endif
	if( !Owner() )
	{
		// alle Verbindungen sofort mit neuen Daten updaten
		SvData aData;
		SendDataChanged( aData );
		SendViewChanged();
	}
}

/*************************************************************************
|*    SvEmbeddedObject::DoVerb()
|*
|*    Beschreibung
*************************************************************************/
ErrCode SvEmbeddedObject::DoVerb( long nVerb )
{
	SvEmbeddedClient * pCl = GetClient();
	if( !pCl )
		return DoVerb( nVerb, NULL, NULL, NULL );
	else
	{
		Rectangle aRect, * pRect = NULL;
		SvClientData * pData = pCl->GetClientData();
		Window * pWin = NULL;
		if( pData )
		{
			aRect = pData->GetObjAreaPixel();
			pWin = pData->GetEditWin();
		}
		// nur bei sinnvollen Groessen TRUE
		if( aRect.GetWidth() > 0 && aRect.GetHeight() > 0 )
			pRect = &aRect;

		return DoVerb( nVerb, pCl, pWin, pRect );
	}
}

ErrCode SvEmbeddedObject::DoVerb
(
	long nVerb,
	SvEmbeddedClient * pCallerClient,
	Window * pWin,
	const Rectangle * pWorkRectPixel
)
{
	return SvPseudoObject::DoVerb( nVerb, pCallerClient,
									pWin, pWorkRectPixel );
}

/*************************************************************************
|*    SvEmbeddedObject::Verb()
|*
|*    Beschreibung
*************************************************************************/
ErrCode SvEmbeddedObject::Verb
(
	long nVerb,
	SvEmbeddedClient * pCl,
	Window * pWin,
	const Rectangle * pWorkRectPixel
)
{
	ErrCode nRet = ERRCODE_NONE;
	if( Owner() )
	{
		if( nVerb == SVVERB_OPEN )
			nRet = GetProtocol().EmbedProtocol();
		else
			nRet = GetProtocol().PlugInProtocol();
	}
	else
	{
		nRet = SvPseudoObject::Verb( nVerb, pCl, pWin, pWorkRectPixel );
	}
	return nRet;
}

/*************************************************************************
|*    SvEmbeddedObject::SetDocumentName()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::SetDocumentName( const String & rName )
{
	aDocName = rName;
	GetProtocol().DocNameChanged( rName );
}

/*************************************************************************
|*    SvEmbeddedObject::DocumentNameChanged()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::DocumentNameChanged( const String & /*rDocName*/ )
{
}

//=========================================================================
// locker die Struktur von Windows kopiert
struct MY_GUID
{
	UINT32 Data1;
	UINT16 Data2;
	UINT16 Data3;
	BYTE   Data4[8];
};
static MY_GUID aSndRec32_EXE =
	{ 0x00020C01, 0x0000, 0x0000, 0xC0, 00, 00, 00, 00, 00, 00, 0x46 };

void SvEmbeddedObject::Connect
(
	BOOL bConnect	/* TRUE, connect. FALSE, disconnect */
)
/*	[Beschreibung]

	Ist bConnect == TRUE, dann wurde das Objekt mit einem
	<SvEmbeddedClient> verbunden. Diesen kann man mit
	<SvEmbeddedObject::GetClient> erfragen.
	Ist bConnect == TRUE, dann wurde das Objekt von dem Client getrennt,
	mit dem es vorher verbunden war.

	[Querverweise]

	<SvPseudoObject::DoClose>, <SvEmbeddedObject::DoConnect>
*/
{
	if( Owner() )
	{
		SvEmbeddedObjectRef xCont = GetClient()->GetContainer();
		// Owner muss abgefragt werden, da Ole2 sonst streikt
		if( xCont.Is() && xCont->Owner() )
			xCont->Lock( bConnect );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::Close()
|*
|*    Beschreibung: Close darf mehrmals gerufen werden
*************************************************************************/
BOOL SvEmbeddedObject::Close()
{
	const SvInfoObjectMemberList * pChildList = GetObjectList();
	if( pChildList )
	{
		ULONG nCount = pChildList->Count();
		for( ULONG i = 0; i < nCount; i++ )
		{
			SvInfoObject * pIO = pChildList->GetObject( i );
			SvPersist * pPer = pIO->GetPersist();
			SvEmbeddedObjectRef xEO( pPer );
			if( xEO.Is() )
				xEO->DoClose();
		}
	}

	// Unter Ole2 muss Close() vor SetClientSite( NULL ) gerufen werden.
	aProt.Reset2Connect();
	SvPseudoObject::Close();
	// Jetzt SetClientSite( NULL ).
	aProt.Reset();
	return TRUE;
}

/*************************************************************************
|*    SvEmbeddedObject::Open()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::Open( BOOL bOpen )
{
#ifdef DBG_UTIL_PROT
	String aTest( "Object---Open---" );
	aTest += Owner() ? "Intern" : "Extern: ";
	aTest += bOpen ? "TRUE" : "FALSE";
	DBG_TRACE( aTest )
#endif

	// kein Autosave im HandsOff State
	if( bAutoSave && !bOpen && !IsHandsOff())
	{
		SvEmbeddedClient * pCl = GetClient();
		if( pCl )
			pCl->SaveObject();
	}
}

//=========================================================================
BOOL SvEmbeddedObject::GetData
(
	SvData * pData	/* In pData werden die angeforderten Daten,
					   in dem in pData eingetragenen Typ, gesetzt.  */
)
/*	[Beschreibung]

	Diese Methode liefert die Formate "Embed Source", "Link Source",
	"Object Descriptor", "Link Source Descriptor" und
	FORMAT_GDIMETAFILE.
	Fr externe Objekte k"onnen weitere Formate geliefert werden.

	[R"uckgabewert]

	BOOL	TRUE, die Daten wurden geliefert.
			FALSE, die Daten konnten nicht geliefert werden.

	[Querverweise]

	<SvDataObject::GetData>, <SvEmbeddedObject::GetDataHere>,
	<SvEmbeddedObject::GetTypeList>
*/
{
	BOOL bRet = FALSE;
	if( !Owner() )
		bRet = SvDataObject::GetData( pData );
	if( !bRet )
	{
		if( pData->GetFormat() == SOT_FORMATSTR_ID_EMBED_SOURCE )
		{
			if( Owner() )
			{
				SvStorageRef aStor = new SvStorage( String() );
				// eigenes Format reinpacken
				SetupStorage( aStor );
				if( DoSaveAs( aStor ) )
				{
					bRet = TRUE;
					pData->SetData( aStor );
				}
				DoSaveCompleted();
			}
			else
			{
				SvStorageRef xStor( GetStorage() );
				pData->SetData( xStor, TRANSFER_REFERENCE );
				bRet = TRUE;
			}
		}
		else if( pData->GetFormat() == SOT_FORMATSTR_ID_OBJECTDESCRIPTOR )
		{
			SvMemoryStream aStm;
			aStm << SvObjectDescriptor( this );
			pData->SetData( (void *)aStm.GetData(), aStm.GetSize() );
			bRet = TRUE;
		}
		else if( pData->GetFormat() == FORMAT_GDIMETAFILE )
		{
			GDIMetaFile aMtf;
			JobSetup aJS;
			const AbstractDeviceData * pADD = pData->GetDeviceData();
			if( pADD && pADD->GetJobSetup() )
				aJS = *pADD->GetJobSetup();

			if( Owner() )
			{
				VirtualDevice aDev;
				aDev.EnableOutput( FALSE );

				MapMode aMode( GetMapUnit() );
				aDev.SetMapMode( aMode );
				Rectangle aVis = GetVisArea( pData->GetAspect() );
				aMtf.SetPrefSize( aVis.GetSize() );
				aMtf.SetPrefMapMode( aMode );
				aMtf.Record( &aDev );
				//aMtf.SaveStatus();
				DoDraw( &aDev, Point(), aVis.GetSize(),
						aJS, pData->GetAspect() );
				aMtf.Stop();
/*
				if( aMode.GetMapUnit() == MAP_TWIP )
				{
					// Writer Hack
					if( aVis.Left() || aVis.Top() )
						aMtf.Move( -aVis.Left(), -aVis.Top() );
				}
*/
			}
			else
			{
				MakeMetafile( aMtf, aJS, pData->GetAspect() );
			}
			pData->SetData( &aMtf );
			bRet = TRUE;
		}
	}
	else
		bRet = SvDataObject::GetData( pData );
	return bRet;
}

//=========================================================================
BOOL SvEmbeddedObject::GetDataHere
(
	SvData * pData	/* In pData ist schon das Medium eingesetzt, in den
					   die Daten geschrieben werden sollen */
)
/*	[Beschreibung]

	Ist das "ubergebene Medium ein Storage und das Format "Embed Source",
	dann wird ein <SvPersist::DoSaveAs> aufgerufen oder der Storage
	kopiert. Ansonsten wird die Basisklasse gerufen.

	[R"uckgabewert]

	BOOL	TRUE, die Daten wurden geliefert.
			FALSE, die Daten konnten nicht geliefert werden.

	[Querverweise]

	<SvDataObject::GetDataHere>, <SvEmbeddedObject::GetData>,
	<SvEmbeddedObject::GetTypeList>
*/
{
	BOOL bRet = FALSE;
	if( pData->HasMedium( MEDIUM_STORAGE )
		&& pData->GetFormat() == SOT_FORMATSTR_ID_EMBED_SOURCE )
	{
		SvStorageRef aDest;
		if( pData->GetData( aDest, TRANSFER_REFERENCE ) )
		{
			if( Owner() || IsRunning() )
			{
				// eigenes Format reinpacken
				SetupStorage( aDest );
				if( DoSaveAs( aDest ) )
					bRet = TRUE;
				DoSaveCompleted();
			}
			else
				bRet = GetStorage()->CopyTo( aDest );
		}
		return bRet;
	}
	bRet = SvDataObject::GetDataHere( pData );

	return bRet;
}

//=========================================================================
const SvDataTypeList & SvEmbeddedObject::GetTypeList() const
/*	[Beschreibung]

	Diese Methode gibt eine Liste der Typen zur"uck, die von dem
	Objekt unterst"utzt werden.

	[Querverweise]

	<SvDataObject::GetTypeList>, <SvEmbeddedObject::GetData>,
	<SvEmbeddedObject::GetDataHere>
*/
{
	if( Owner() )
	{
		if( IsTypeListSet() )
			return SvDataObject::GetTypeList();
		else
			return GetStdFormatList();
	}
	else
	{
		const SvDataTypeList & rList = SvDataObject::GetTypeList();
		// F"ur externe Objekte werden die Ole-Formate hinzugef"ugt, wenn
		// sie nicht angegeben waren
		SvDataTypeList aList( rList );
		SvDataType aT = SvDataType( SOT_FORMATSTR_ID_EMBED_SOURCE, MEDIUM_STORAGE );
		if( !rList.Get( aT ) )
			aList.Insert( aT, 0 );
		aT = SvDataType( FORMAT_GDIMETAFILE );
		if( !rList.Get( aT ) )
			aList.Append( aT );
		aT = SvDataType( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR, MEDIUM_MEMORY );
		if( !rList.Get( aT ) )
			aList.Append( aT );
		((SvEmbeddedObject *)this)->Impl_SetTypeList( aList );
		return Impl_GetTypeList();
	}
}

/*************************************************************************
|*    SvEmbeddedObject::GetNewMetaFile()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::GetNewMetaFile()
{
	if( !pCache )
	{
		pCache = new Impl_Cache();
		Impl_CacheElement * pEle = new Impl_CacheElement( FORMAT_GDIMETAFILE );
		pCache->Cache( pEle );
	}
	SvData aData( FORMAT_GDIMETAFILE );
	GDIMetaFile * pMtf;
	if( GetData( &aData ) && aData.GetData( &pMtf, TRANSFER_REFERENCE ) )
	{
		Size aSize = pMtf->GetPrefSize();
		MapMode aMMSrc = pMtf->GetPrefMapMode();
		MapMode aMMDst( MAP_100TH_MM );
		aSize = OutputDevice::LogicToLogic( aSize, aMMSrc, aMMDst );
		pCache->SetData( &aData, aSize );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::SetGetVisArea()
|*
|*    Beschreibung
*************************************************************************/
const Rectangle & SvEmbeddedObject::SetGetVisArea( const Rectangle & rArea )
{
	// nicht auf Gleichheit optimieren, da der Server sie jederzeit
	// modifizieren darf
	if( Owner() )
		// muss, weil SetVisArea ist virtuell ist
		SetVisArea( rArea );
	else
	{
		aVisArea = rArea;
		if( !IsRunning() && GetMiscStatus() == SVOBJ_MISCSTATUS_SERVERRESIZE )
			// wenn Server nicht luft, er aber zum Resizen gestartet werden
			// soll.
			Run();
	}
	return aVisArea;
}

/*************************************************************************
|*    SvEmbeddedObject::SetVisArea()
|*    SvEmbeddedObject::GetVisArea()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::SetVisArea( const Rectangle & rArea )
{
	if( Owner() )
		aVisArea = rArea;
	else
		SetGetVisArea( rArea );
}

void SvEmbeddedObject::SetVisAreaSize( const Size & rSize )
{
	SetVisArea( Rectangle( GetVisArea().TopLeft(), rSize ) );
}

Rectangle SvEmbeddedObject::GetVisArea( USHORT nAspect ) const
{
	if( nAspect == ASPECT_CONTENT )
		return aVisArea;
	else if( nAspect == ASPECT_THUMBNAIL )
	{
		Rectangle aRect;
		aRect.SetSize( OutputDevice::LogicToLogic( Size( 5000, 5000 ),
										 MAP_100TH_MM, GetMapUnit() ) );
		return aRect;
	}
	return Rectangle();
}

const Rectangle & SvEmbeddedObject::GetVisArea() const
{
	((SvEmbeddedObject *)this)->aVisArea = GetVisArea( ASPECT_CONTENT );
	return aVisArea;
}

/*************************************************************************
|*    SvEmbeddedObject::DrawHatch()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::DrawHatch( OutputDevice * pDev, const Point & rViewPos,
							   const Size &rSize )
{
	GDIMetaFile * pMtf = pDev->GetConnectMetaFile();
	if( pMtf && pMtf->IsRecord() )
		return;

	SvEmbeddedClient * pCl = GetClient();
	if( pCl && pCl->Owner() && bAutoHatch
	  && pDev->GetOutDevType() == OUTDEV_WINDOW
	  && GetProtocol().IsEmbed() )
	{
		pDev->Push();
		pDev->SetLineColor( Color( COL_BLACK ) );

		Size aPixSize = pDev->LogicToPixel( rSize );
		aPixSize.Width() -= 1;
		aPixSize.Height() -= 1;
		Point aPixViewPos = pDev->LogicToPixel( rViewPos );
		INT32 nMax = aPixSize.Width() + aPixSize.Height();
		for( INT32 i = 5; i < nMax; i += 5 )
		{
			Point a1( aPixViewPos ), a2( aPixViewPos );
			if( i > aPixSize.Width() )
				a1 += Point( aPixSize.Width(), i - aPixSize.Width() );
			else
				a1 += Point( i, 0 );
			if( i > aPixSize.Height() )
				a2 += Point( i - aPixSize.Height(), aPixSize.Height() );
			else
				a2 += Point( 0, i );

			pDev->DrawLine( pDev->PixelToLogic( a1 ), pDev->PixelToLogic( a2 ) );
		}
		pDev->Pop();
	}
}

/*************************************************************************
|*    SvEmbeddedObject::MakeMetafile()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::MakeMetafile( GDIMetaFile & rMtf,
									const JobSetup & rSetup,
									USHORT nAspect )
{
	DBG_ASSERT( !Owner(), "only for !Owner" )
	rMtf = GDIMetaFile(); // leer setzen
	if( pCache )
	{
		SvData aData( FORMAT_GDIMETAFILE );
		JobSetupWrapper aJS( rSetup );
		aData.SetDeviceData( &aJS );
		aData.SetAspect( nAspect );
		GDIMetaFile * pMtf;
		if( aData.GetData( &pMtf, TRANSFER_REFERENCE ) )
			rMtf = *pMtf;
	}
}

/*************************************************************************
|*    SvEmbeddedObject::DoDraw()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::DoDraw( OutputDevice * pDev, const Point & rViewPos,
							   const Size &rSize,
							   const JobSetup & rSetup, USHORT nAspect )
{
	if( Owner() )
	{
		MapMode aMod = pDev->GetMapMode();
		Size aSize = GetVisArea( nAspect ).GetSize();
		MapMode aWilliMode( GetMapUnit() );
		aSize = pDev->LogicToLogic( aSize, &aWilliMode, &aMod );
		if( aSize.Width() && aSize.Height() )
		{
			Fraction aXF( rSize.Width(), aSize.Width() );
			Fraction aYF( rSize.Height(), aSize.Height() );

			Point aOrg = rViewPos;

			DoDraw( pDev, aOrg, aXF, aYF, rSetup, nAspect );
		}
	}
	else
	{
		// Wegen Rundungs, Skalierungs-Problemen und Fehlern
		// direkt ber das Rechteck
		if( pCache )
		{
			// erst MetaFile versuchen
			SvData aDMtf( FORMAT_GDIMETAFILE );
			aDMtf.SetAspect( nAspect );
			JobSetupWrapper aJS( rSetup );
			aDMtf.SetDeviceData( &aJS );
			if( !pCache->GetData( &aDMtf ) )
			{
				aDMtf.SetDeviceData( NULL );
				pCache->GetData( &aDMtf );
			}

			GDIMetaFile * pMtf;
			if( aDMtf.GetData( &pMtf, TRANSFER_REFERENCE ) )
			{
				pMtf->WindStart();
				pMtf->Play( pDev, rViewPos, rSize );
			}
			else
			{
				// erst Bitmap versuchen
				SvData aDBmp( FORMAT_BITMAP );
				aDBmp.SetAspect( nAspect );
				aDBmp.SetDeviceData( &aJS );
				if( !pCache->GetData( &aDBmp ) )
				{
					aDBmp.SetDeviceData( NULL );
					pCache->GetData( &aDBmp );
				}
				Bitmap * pBmp;
				if( aDBmp.GetData( &pBmp, TRANSFER_REFERENCE ) )
				{
					pDev->DrawBitmap( rViewPos, rSize, *pBmp );
				}
			}
		}
		DrawHatch( pDev, rViewPos, rSize );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::DoDraw()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::DoDraw( OutputDevice * pDev, const Point & rViewPos,
							   const Fraction & rScaleX,
							   const Fraction & rScaleY,
							   const JobSetup & rSetup, USHORT nAspect )
{
	Rectangle aVisArea  = GetVisArea( nAspect );
	// MapUnit des Ziels
	MapMode aMapMode( GetMapUnit() );
	aMapMode.SetScaleX( rScaleX );
	aMapMode.SetScaleY( rScaleY );

	if( Owner() )
	{
		// Ziel in Pixel
		Point aOrg	 = pDev->LogicToLogic( rViewPos, NULL, &aMapMode );
		Point aDelta = aOrg - aVisArea.TopLeft();

		// Origin entsprechend zum sichtbaren Bereich verschieben
		// Origin mit Scale setzen
		aMapMode.SetOrigin( aDelta );

		// Deviceeinstellungen sichern
		pDev->Push();

		Region aRegion;
		if( pDev->IsClipRegion() && pDev->GetOutDevType() != OUTDEV_PRINTER )
		{
			aRegion = pDev->GetClipRegion();
			aRegion = pDev->LogicToPixel( aRegion );
		}
		pDev->SetRelativeMapMode( aMapMode );

		GDIMetaFile * pMtf = pDev->GetConnectMetaFile();
		if( pMtf )
			if( pMtf->IsRecord() && pDev->GetOutDevType() != OUTDEV_PRINTER )
				pMtf->Stop();
			else
				pMtf = NULL;
// #ifndef UNX
		if( pDev->IsClipRegion() && pDev->GetOutDevType() != OUTDEV_PRINTER )
// #endif
		{
			aRegion = pDev->PixelToLogic( aRegion );
			pDev->SetClipRegion( aRegion );
		}
		if( pMtf )
			pMtf->Record( pDev );

		Draw( pDev, rSetup, nAspect );
		DrawHatch( pDev, aVisArea.TopLeft(), aVisArea.GetSize() );

		// Deviceeinstellungen wieder herstellen
		pDev->Pop();
	}
	else
	{
		Size aSize = aVisArea.GetSize();
		pDev->LogicToLogic( rViewPos, NULL, &aMapMode );
		DoDraw( pDev, rViewPos, aSize, rSetup, nAspect );
	}
}

/*************************************************************************
|*    SvEmbeddedObject::Draw()
|*
|*    Beschreibung
*************************************************************************/
void SvEmbeddedObject::Draw( OutputDevice * /*pDev*/,
							 const JobSetup & /*rSetup*/, USHORT /*nAspect*/ )
{
}

/*************************************************************************
|*    SvEmbeddedObject::GetDocumentPrinter()
|*
|*    Beschreibung:
*************************************************************************/
Printer *	SvEmbeddedObject::GetDocumentPrinter()
{
	SvEmbeddedObjectRef xParent( GetParent() );
	if( xParent.Is() )
		return xParent->GetDocumentPrinter();
	return NULL;
}

/*************************************************************************
|*    SvEmbeddedObject::ConvertToOle1()
|*
|*    Beschreibung:
*************************************************************************/
struct ClsIDs {
	UINT32		nId;
	const sal_Char* pSvrName;
	const sal_Char* pDspName;
};
static ClsIDs aClsIDs[] = {

	{ 0x000212F0, "MSWordArt",     		"Microsoft Word Art"	 		},
	{ 0x000212F0, "MSWordArt.2",   		"Microsoft Word Art 2.0" 		},

	// MS Apps
	{ 0x00030000, "ExcelWorksheet",		"Microsoft Excel Worksheet"		},
	{ 0x00030001, "ExcelChart",			"Microsoft Excel Chart"			},
	{ 0x00030002, "ExcelMacrosheet",	"Microsoft Excel Macro"			},
	{ 0x00030003, "WordDocument",		"Microsoft Word Document"		},
	{ 0x00030004, "MSPowerPoint",		"Microsoft PowerPoint"			},
	{ 0x00030005, "MSPowerPointSho",	"Microsoft PowerPoint Slide Show"},
	{ 0x00030006, "MSGraph",			"Microsoft Graph"				},
	{ 0x00030007, "MSDraw",				"Microsoft Draw"				},
	{ 0x00030008, "Note-It",			"Microsoft Note-It"				},
	{ 0x00030009, "WordArt",			"Microsoft Word Art"			},
	{ 0x0003000a, "PBrush",				"Microsoft PaintBrush Picture"	},
	{ 0x0003000b, "Equation",			"Microsoft Equation Editor"		},
	{ 0x0003000c, "Package",			"Package"						},
	{ 0x0003000d, "SoundRec",			"Sound"							},
	{ 0x0003000e, "MPlayer",			"Media Player"					},
	// MS Demos
	{ 0x0003000f, "ServerDemo",			"OLE 1.0 Server Demo"			},
	{ 0x00030010, "Srtest",				"OLE 1.0 Test Demo"				},
	{ 0x00030011, "SrtInv",				"OLE 1.0 Inv Demo"				},
	{ 0x00030012, "OleDemo",			"OLE 1.0 Demo"					},

	// Coromandel / Dorai Swamy / 718-793-7963
	{ 0x00030013, "CoromandelIntegra",	"Coromandel Integra"			},
	{ 0x00030014, "CoromandelObjServer","Coromandel Object Server"		},

	// 3-d Visions Corp / Peter Hirsch / 310-325-1339
	{ 0x00030015, "StanfordGraphics",	"Stanford Graphics"				},

	// Deltapoint / Nigel Hearne / 408-648-4000
	{ 0x00030016, "DGraphCHART",		"DeltaPoint Graph Chart"		},
	{ 0x00030017, "DGraphDATA",			"DeltaPoint Graph Data"			},

	// Corel / Richard V. Woodend / 613-728-8200 x1153
	{ 0x00030018, "PhotoPaint",			"Corel PhotoPaint"				},
	{ 0x00030019, "CShow",				"Corel Show"					},
	{ 0x0003001a, "CorelChart",			"Corel Chart"					},
	{ 0x0003001b, "CDraw",				"Corel Draw"					},

	// Inset Systems / Mark Skiba / 203-740-2400
	{ 0x0003001c, "HJWIN1.0",			"Inset Systems"					},

	// Mark V Systems / Mark McGraw / 818-995-7671
	{ 0x0003001d, "ObjMakerOLE",		"MarkV Systems Object Maker"	},

	// IdentiTech / Mike Gilger / 407-951-9503
	{ 0x0003001e, "FYI",				"IdentiTech FYI"				},
	{ 0x0003001f, "FYIView",			"IdentiTech FYI Viewer"			},

	// Inventa Corporation / Balaji Varadarajan / 408-987-0220
	{ 0x00030020, "Stickynote",			"Inventa Sticky Note"			},

	// ShapeWare Corp. / Lori Pearce / 206-467-6723
	{ 0x00030021, "ShapewareVISIO10",   "Shapeware Visio 1.0"			},
	{ 0x00030022, "ImportServer",		"Spaheware Import Server"		},

	// test app SrTest
	{ 0x00030023, "SrvrTest",			"OLE 1.0 Server Test"			},

	// test app ClTest.  Doesn't really work as a server but is in reg db
	{ 0x00030025, "Cltest",				"OLE 1.0 Client Test"			},

	// Microsoft ClipArt Gallery   Sherry Larsen-Holmes
	{ 0x00030026, "MS_ClipArt_Gallery",	"Microsoft ClipArt Gallery"		},
	// Microsoft Project  Cory Reina
	{ 0x00030027, "MSProject",			"Microsoft Project"				},

	// Microsoft Works Chart
	{ 0x00030028, "MSWorksChart",		"Microsoft Works Chart"			},

	// Microsoft Works Spreadsheet
	{ 0x00030029, "MSWorksSpreadsheet",	"Microsoft Works Spreadsheet"	},

	// AFX apps - Dean McCrory
	{ 0x0003002A, "MinSvr",				"AFX Mini Server"				},
	{ 0x0003002B, "HierarchyList",		"AFX Hierarchy List"			},
	{ 0x0003002C, "BibRef",				"AFX BibRef"					},
	{ 0x0003002D, "MinSvrMI",			"AFX Mini Server MI"			},
	{ 0x0003002E, "TestServ",			"AFX Test Server"				},

	// Ami Pro
	{ 0x0003002F, "AmiProDocument",		"Ami Pro Document"				},

	// WordPerfect Presentations For Windows
	{ 0x00030030, "WPGraphics",			"WordPerfect Presentation"		},
	{ 0x00030031, "WPCharts",			"WordPerfect Chart"				},

	// MicroGrafx Charisma
	{ 0x00030032, "Charisma",			"MicroGrafx Charisma"			},
	{ 0x00030033, "Charisma_30",		"MicroGrafx Charisma 3.0"		},
	{ 0x00030034, "CharPres_30",		"MicroGrafx Charisma 3.0 Pres"	},
	// MicroGrafx Draw
	{ 0x00030035, "Draw",				"MicroGrafx Draw"				},
	// MicroGrafx Designer
	{ 0x00030036, "Designer_40",		"MicroGrafx Designer 4.0"		},

	// STAR DIVISION
//	{ 0x000424CA, "StarMath",			"StarMath 1.0"					},
	{ 0x00043AD2, "FontWork",			"Star FontWork"					},
//	{ 0x000456EE, "StarMath2",			"StarMath 2.0"					},

	{ 0, "", "" } };

/*
class Ole1Convert
{
    virtual DWORD FAR PASCAL Ole1_Get( void * pBuf, DWORD nSize );
    virtual DWORD FAR PASCAL Ole1_Put( const void * pBuf, DWORD nSize );
    SvStream &  rStm;
public:
    Ole1Convert( SvStream & rStmPar )
        : rStm( rStmPar )
    {
    }
};

DWORD Ole1Convert::Ole1_Get( void * pBuf, DWORD nSize )
{
    return rStm.Read( pBuf, nSize );
}

DWORD Ole1Convert::Ole1_Put( const void * pBuf, DWORD nSize )
{
    return rStm.Write( pBuf, nSize );
}
*/
BOOL SvEmbeddedObject::ConvertToOle2( SvStream& rStm, UINT32 nReadLen,
					const GDIMetaFile * pMtf, const SotStorageRef& rDest )
{
	BOOL bMtfRead = FALSE;
	SotStorageStreamRef xOle10Stm = rDest->OpenSotStream( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "\1Ole10Native" ) ),
													STREAM_WRITE| STREAM_SHARE_DENYALL );
	if( xOle10Stm->GetError() )
		return FALSE;

	UINT32 nType;
	UINT32 nRecType;
	UINT32 nStrLen;
	String aSvrName;
	UINT32 nDummy0;
	UINT32 nDummy1;
	UINT32 nDataLen;
	void * pData;
	UINT32 nBytesRead = 0;
	do
	{
		rStm >> nType;
		rStm >> nRecType;
		rStm >> nStrLen;
		if( nStrLen )
		{
			if( 0x10000L > nStrLen )
			{
				sal_Char * pBuf = new sal_Char[ nStrLen ];
				rStm.Read( pBuf, nStrLen );
				aSvrName.Assign( String( pBuf, nStrLen, gsl_getSystemTextEncoding() ) );
				delete pBuf;
			}
			else
				break;
		}
		rStm >> nDummy0;
		rStm >> nDummy1;
		rStm >> nDataLen;

		nBytesRead += 6 * sizeof( UINT32 ) + nStrLen + nDataLen;

		if( !rStm.IsEof() && nReadLen > nBytesRead && nDataLen )
		{
			if( xOle10Stm.Is() )
			{
				pData = new BYTE[ nDataLen ];
				if( !pData )
					return FALSE;

				rStm.Read( pData, nDataLen );

				// write to ole10 stream
				*xOle10Stm << nDataLen;
				xOle10Stm->Write( pData, nDataLen );
				xOle10Stm = SotStorageStreamRef();

				// set the compobj stream
				ClsIDs* pIds;
				for( pIds = aClsIDs; pIds->nId; pIds++ )
				{
					if( COMPARE_EQUAL == aSvrName.CompareToAscii( pIds->pSvrName ) )
						break;
				}
				SvGlobalName* pClsId = NULL;
				String aShort, aFull;
				if( pIds->nId )
				{
					// gefunden!
					ULONG nCbFmt = SotExchange::RegisterFormatName( aSvrName );
					rDest->SetClass( SvGlobalName( pIds->nId, 0, 0, 0xc0,0,0,0,0,0,0,0x46 ), nCbFmt, 
									String( pIds->pDspName, RTL_TEXTENCODING_ASCII_US ) );
				}
				else
				{
					ULONG nCbFmt = SotExchange::RegisterFormatName( aSvrName );
					rDest->SetClass( SvGlobalName(), nCbFmt, aSvrName );
				}

				delete pData;
			}
			else if( nRecType == 5 && !pMtf )
			{
				ULONG nPos = rStm.Tell();
				UINT16 sz[4];
				rStm.Read( sz, 8 );
				//rStm.SeekRel( 8 );
				Graphic aGraphic;
				if( ERRCODE_NONE == GraphicConverter::Import( rStm, aGraphic ) && aGraphic.GetType() )
				{
					const GDIMetaFile& rMtf = aGraphic.GetGDIMetaFile();
					MakeContentStream( rDest, rMtf );
					bMtfRead = TRUE;
				}
				// set behind the data
				rStm.Seek( nPos + nDataLen );
			}
			else
				rStm.SeekRel( nDataLen );
		}
	} while( !rStm.IsEof() && nReadLen >= nBytesRead );

	if( !bMtfRead && pMtf )
	{
		MakeContentStream( rDest, *pMtf );
		return TRUE;
	}
	return FALSE;
}

/*************************************************************************
|*    SvEmbeddedObject::OnDocumentPrinterChanged()
|*
|*    Beschreibung: An allen Child-Objekten sollte diese Methode gerufen
					werden, wenn im Dokument der Drucker gewechselt wird und
					sie das Flag SVOBJ_MISCSTATUS_RESIZEONPRINTERCHANGE "uber die
					Methode GetMiscStatus() liefern.
					Bevor der Container am Child diese Methode ruft,
					muss er einen Client angemeldet und ge"offnet haben.
					Dies tut er mit dem folgenden Codefragment.

					if( xChildObj->GetMiscStatus() & SVOBJ_MISCSTATUS_RESIZEONPRINTERCHANGE )
					{
						// Client erzeugen
						SvEmbeddedClientRef xClient = new MyClient( ... );
						// Client und ChildObj verbinden
						xChildObj->DoConnect( xClient );
						// Verbindung oeffnen, es wird ein ViewAdvise angemeldet
						xChildObj->DoOpen( TRUE );
						// Die Drucker"anderung melden
						xChildObj->OnDocumentPrinterChanged( pNewPrinter );
						...

					Wenn die VisArea aufgrund der Printer-"Anderung
					angepasst wird, dann muss das ChildObj diese "Anderung melden. Da
					sich sowohl seine Daten (VisArea), als auch seine Darstellung
					ge"andert hat, mssen folgen Methoden gerufen werden.

					SvData aData;
					// Alle anliegenden "Anderungen der Daten werden sofort (synchron) abgeschickt
					SendDataChanged( aData );
					// Alle "Anderungen der View werden synchron an den Client gemeldet.
					SendViewChanged();

					Auf der Client-Seite ist die ViewChanged-Benachrichtigung "berladen,
					sodass die Gr"osse angepasst wird.

|*		Anmerkung:	SendDataChanged und SendViewChanged senden nur, wenn vorher die Methoden
|*					ViewChanged und DataChanged "Anderungen	angemeldet haben. Dies sollte aber
|*					durch umsetzen der VisArea und den dadurch notwendigen "Anderungen
|*					automatisch passieren. In so3 passiert in dieser Hinsicht nichts
|*					automatisch!!!
|*
*************************************************************************/
void SvEmbeddedObject::OnDocumentPrinterChanged( Printer * )
{
	/*
	const SvInfoObjectMemberList * pChildList = GetObjectList();
	if( pChildList )
	{
		ULONG nCount = pChildList->Count();
		for( ULONG i = 0; i < nCount; i++ )
		{
			SvInfoObject * pIO = pChildList->GetObject( i );
			SvEmbeddedObjectRef xEO( pIO->GetPersist() );
			if( xEO.Is() && (xEO->GetMiscStatus() & SVOBJ_MISCSTATUS_RESIZEONPRINTERCHANGE) )
				xEO->OnDocumentPrinterChanged( pPrt );
		}
	}
	*/
}

