#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.2 $
#
#   last change: $Author: csaba $ $Date: 2000/10/16 15:08:10 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..

PRJPCH=

PRJNAME=SO3
TARGET=so2
NO_BSYMBOLIC=TRUE

# so2.hid generieren
GEN_HID=TRUE

USE_LDUMP2=TRUE
LDUMP2=LDUMP3

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

RSCFLAGS+=-p
.IF "$(GUI)"=="OS2"
.IF "$(COM)"!="WTC"
LIBFLAGS+=/P256
.ENDIF
.ENDIF

# --- Files --------------------------------------------------------

.IF "$(header)" == ""


LIB1TARGET= $(SLB)$/$(TARGET).lib
LIB1FILES=\
		$(SLB)$/solink.lib		\
		$(SLB)$/dialog.lib		\
		$(SLB)$/data.lib		\
		$(SLB)$/inplace.lib		\
		$(SLB)$/misc.lib		\
		$(SLB)$/persist.lib

.IF "$(GUI)"=="WNT"
LIB1FILES+=$(SLB)$/ole.lib
.ENDIF

.IF "$(UPDATER)"==""
RESLIB1NAME=so
RESLIB1SRSFILES= $(SRS)$/src.srs
.ENDIF

SHL1TARGET= so$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= so2
SHL1STDLIBS=\
		$(SOTLIB) \
		$(SVTOOLLIB) \
		$(SVLLIB)	\
		$(INETLIBSH) \
		$(SVLIB) \
		$(SVMEMLIB) \
		$(ONELIB) \
		$(TOOLSLIB)	\
		$(VOSLIB)	\
		$(UNOLIB) \
		$(SALLIB) \
		$(CPPULIB) \
		$(CPPUHELPERLIB) \
		$(UNOTOOLSLIB)

.IF "$(linkinc)" == ""
SHL1LIBS=	$(SLB)$/$(TARGET).lib
.ENDIF

.IF "$(GUI)"=="WNT"
SHL1STDLIBS+= \
			ole32.lib uuid.lib advapi32.lib gdi32.lib
.ENDIF

.IF "$(GUI)"=="WIN"
SHL1STDLIBS=$(VOSLIB) \
			ole2.lib compobj.lib storage.lib shell.lib \
			ole2disp.lib typelib.lib
.ENDIF

.IF "$(GUI)"=="MAC"
SHL1STDLIBS+=\
		$(VOSLIB) \
		$(UNOLIB) \
		$(SALLIB) \
		$(VCLLIB) \
		$(MWPPCLibraries)JMSessionStubs.PPC
.ENDIF

.IF "$(SOLAR_JAVA)" != ""
SHL1STDLIBS+=$(SJLIB)
.ENDIF

.IF "$(ACTIVEX)" != ""
# nur unter NT/95 ?
SHL1STDLIBS+=uuid3.lib urlmon.lib ni.lib
.ENDIF

.IF "$(GUI)"=="MAC"
SHL1DEPN=	$(SHL1STDLIBS)
.ELSE
.IF "$(GUI)"=="UNX"
SHL1DEPN=	$(L)$/itools.lib $(LIB1TARGET)
.ELSE
SHL1DEPN=	$(L)$/itools.lib $(LIB1TARGET)
.ENDIF
.ENDIF

.IF "$(linkinc)" == ""
.IF "$(GUI)"=="WNT"
SHL1OBJS+=	$(SLO)$/so2dll.obj					\
			$(SHLOBJECTS)

.ELSE
.IF "$(GUI)"=="OS2"
SHL1OBJS+=	$(SLO)$/so2dll.obj
.ENDIF
.ENDIF
SHL1DEF=	$(MISC)$/$(SHL1TARGET).def

.ELSE			#"$(linkinc)" == ""
SHL11FILE=	$(MISC)$/data.slo
SHL12FILE=	$(MISC)$/dialog.slo
SHL13FILE=	$(MISC)$/inplace.slo
SHL14FILE=	$(MISC)$/misc.slo
.IF "$(GUI)"=="WNT"
SHL15FILE=	$(MISC)$/ole.slo
.ENDIF
SHL16FILE=	$(MISC)$/persist.slo
SHL17FILE=	$(MISC)$/solink.slo
.ENDIF

DEF1NAME	=$(SHL1TARGET)
DEF1DEPN	=$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =so2
DEF1DES 	=StarObjects

# --- Targets ------------------------------------------------------

.IF "$(depend)" == ""
ALL:	\
	$(SRS)$/hidother.hid\
			ALLTAR


# --- SO2-Filter-Datei ---

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	@echo ------------------------------
	@echo Making: $@
	@echo WEP > $@
	@echo LIBMAIN >> $@
	@echo LibMain >> $@
	@echo CreateDdeExtern@SvBaseLink >> $@
	@echo RemoveDdeExtern@SvBaseLink >> $@
	@echo DataChanged@SvBaseLink >> $@
	@echo allocator >> $@
	@echo Exception >> $@
	@echo =@8 >> $@

$(SRS)$/hidother.hid: hidother.src
.IF "$(GUI)"=="WNT"
.IF "$(BUILD_SOSL)"==""
	@+echo HIER HIDS BAUEN!
	+mhids hidother.src ..\$(INPATH)$/srs so2 hidother
.ENDIF
.ELSE
	@echo nix
.ENDIF

.ENDIF
.ENDIF

# --- Targets -------------------------------------------------------

.INCLUDE :  target.mk
.INCLUDE :  target.pmk

