/*************************************************************************
* CODEBASE.HXX
* Tue Feb  2 13:27:31 1993
* (c) 1992 STAR DIVISION
*************************************************************************/
#ifndef _CBASE_HXX
#define _CBASE_HXX

#ifndef S4UNIX
#ifndef _SIZE_T_DEFINED_
#ifndef _SIZE_T_DEFINED
#ifndef _SIZE_T
   typedef unsigned size_t ;
#endif
#endif
#endif
#endif

#ifdef S4GERMAN
   #define S4LANGUAGE
#endif

#ifdef S4FRENCH
   #define S4LANGUAGE
#endif

#ifdef __TURBOC__
   #ifdef S4DLL
      #define S4CLASS huge
      #define S4FUNCTION far pascal
   #endif
#endif

#ifdef _MSC_VER
   #ifdef S4DLL
      #ifdef __cplusplus
         #define S4CLASS
      #else
         #define S4CLASS huge
      #endif
      #define S4FUNCTION far pascal
   #endif
#endif

#ifdef __ZTC__
   #ifdef S4DLL
      #ifdef __cplusplus
         #define S4CLASS
      #else
         #define S4CLASS huge
      #endif
      #define S4FUNCTION far pascal
   #endif
#endif

#ifdef S4DLL_BUILD
   #define __DLL__
#endif

#ifdef __DLL__
   #define S4DLL
   #define S4CLASS _export
   #define S4FUNCTION far pascal _export
#endif

#ifdef S4DLL
   #define S4WINDOWS
#endif

#ifndef S4CLASS
   #define S4CLASS
   #define S4FUNCTION
#endif

#ifdef S4DLL
   #define S4CALL far pascal _export
#else
   #ifdef _MSC_VER
      #define S4CALL _cdecl S4FUNCTION
   #else
      #define S4CALL S4FUNCTION
   #endif
#endif

#ifdef S4WINDOWS
   typedef unsigned int UINT ;
#endif

#ifdef _MSC_VER
   #define S4ERROR cdecl
#endif
#ifdef __TURBOC__
   #define S4ERROR cdecl
#endif
#ifdef __ZTC__
   #define S4ERROR cdecl
#endif
#ifdef __WATCOMC__
   #define S4ERROR cdecl
#endif
#ifndef S4ERROR
   #define S4ERROR S4FUNCTION
#endif

#ifdef S4DLL
   #define S4PTR far
#else
   #define S4PTR
#endif

#ifdef S4UNIX
   #define S4MDX
#endif

#ifdef S4NDX

#define S4MNDX
#define N4OTHER
#endif

#ifdef S4CLIPPER

#define S4MNDX
#define N4OTHER
#endif

#ifdef S4FOX

#define S4MFOX
#endif

#ifndef S4FOX
#ifndef N4OTHER
   #define S4MDX
#endif
#endif

#ifndef S4MDX
   #ifdef S4BYTE_SWAP
      #error: Byte Swap Not Supported for Non-Mdx Formats.
   #endif
#endif

#ifdef S4MNDX
#define   M4MEMO_SIZE   0x200
#endif

#ifndef S4UNIX
   typedef  const void S4PTR *  S4CMP_PARM ;
#endif

typedef int S4CALL  S4CMP_FUNCTION( S4CMP_PARM, S4CMP_PARM, size_t) ;

#ifdef S4DLL
   #define s4assign_cmp(s4,f)  (s4)->cmp = (S4CMP_FUNCTION S4PTR *) MakeProcInstance((FARPROC) f, (s4)->code_base->hInst)
#else
   #define s4assign_cmp(s4,f)  (s4)->cmp = (S4CMP_FUNCTION S4PTR *) (f)
#endif

#define r4success  0
#define r4found    1
#define r4after    2
#define r4eof      3
#define r4bof      4
#define r4entry    5
#define r4descending   10
#define r4unique   20
#define r4unique_continue  25
#define r4ignore   40
#define r4keep     45
#define r4locked   50
#define r4no_create 60
#define r4no_open  70
#define r4no_tag   80

#define e4close   -10
#define e4create  -20
#define e4len     -30
#define e4len_set -40
#define e4lock    -50
#define e4open    -60
#define e4read    -70
#define e4remove  -80
#define e4rename  -90
#define e4seek    -100
#define e4unlock  -110
#define e4write   -120

#define e4data  -200
#define e4field_name -210
#define e4field_type -220
#define e4record_len -230

#define e4entry  -300
#define e4index  -310
#define e4tag_name  -330
#define e4unique    -340

#define e4comma_expected   -400
#define e4complete   -410
#define e4data_name  -420
#define e4num_parms   -430
#define e4overflow   -440
#define e4right_missing   -450
#define e4type_sub      -460
#define e4unrec_function   -470
#define e4unrec_operator   -480
#define e4unrec_value   -490
#define e4unterminated   -500

#define e4info     -910
#define e4memory   -920
#define e4parm     -930
#define e4demo     -940
#define e4result   -950

#define E4DEMO_MAX 200

#ifdef  S4FOX
#define I4MULTIPLY     1
#define B4DO_BACK_LEVEL 3
#define I4MAX_KEY_SIZE 240
#else
   #define I4MULTIPLY     512

   #ifdef S4NDX
      #define I4MAX_KEY_SIZE 100
   #else
      #ifdef S4CLIPPER
         #define I4MAX_KEY_SIZE 338
      #else
         #define I4MAX_KEY_SIZE 102
      #endif
   #endif
#endif

#define D4GARBAGE_LEN  518
#define L4LOCK_POS     1000000000L
#define E4ACCURACY     1.0e-13
#define E4ACCURACY_DIGITS  15

typedef void C4STOK( char S4PTR *, char S4PTR *, int ) ;
typedef void C4DTOK( char S4PTR *, double ) ;

struct D4DATA_st ;
struct F4MEMO_st ;
struct I4INDEX_st ;
struct T4TAG_st ;

typedef struct l4link_st
{
   struct l4link_st S4PTR *n, S4PTR *p ;
} L4LINK ;

#ifdef __cplusplus
typedef struct S4CLASS
#else
typedef struct
#endif
{
   L4LINK S4PTR *last ;
   void   S4PTR *selected ;
   int     n_link ;
} L4LIST ;

typedef struct
{
   L4LINK link ;
   double  data ;
} Y4CHUNK ;

typedef struct
{
   L4LINK link ;

   L4LIST      chunks ;
   L4LIST      pieces ;

   int         unit_start;
   unsigned    unit_size ;
   int         unit_expand ;
   int         n_repeat ;

   int         n_used ;
}  Y4MEMORY_TYPE ;

#ifdef __cplusplus
typedef struct S4CLASS
#else
typedef struct
#endif
{
   unsigned hWnd ;
   unsigned hInst ;

   L4LIST   data_list ;
   int default_unique_error ;
   char date_format[19];

   unsigned mem_size_block ;
   unsigned mem_size_sort_pool ;
   unsigned mem_size_sort_buffer ;
   unsigned mem_size_buffer ;

   int mem_expand_block ;
   int mem_expand_data ;
   int mem_expand_index ;
   int mem_expand_tag ;

   int mem_start_data ;
   int mem_start_block ;
   int mem_start_index ;
   int mem_start_tag ;

   int  field_name_error ;
   int  go_error ;
   int  open_error ;
   int  create_error ;
   int  read_lock ;
   int  skip_error ;
   int  tag_name_error ;
   int  safety ;
   int  wait   ;
   int  auto_open ;

   Y4MEMORY_TYPE S4PTR *index_memory ;
   Y4MEMORY_TYPE S4PTR *data_memory ;
   Y4MEMORY_TYPE S4PTR *tag_memory ;

   #ifdef S4CLIPPER
      int numeric_str_len ;
      int decimals ;
   #endif

   int  error_code ;
   int  debug_int ;
} C4CODE ;

typedef struct
{
   char S4PTR *name ;
   C4CODE S4PTR *code_base ;
   int   hand ;
   char  is_temp ;
   char  do_alloc_free ;
} H4FILE ;

typedef struct
{
   H4FILE     file ;
   short      block_size ;
   struct D4DATA_st  S4PTR *data ;
} M4FILE ;

typedef struct
{
   H4FILE S4PTR *file ;

   long  pos ;
   char S4PTR *buffer ;
   unsigned next_read_len ;
   unsigned total ;
   unsigned working ;
   unsigned avail ;
} H4SEQ_READ ;

typedef struct
{
   H4FILE S4PTR *file ;

   long  pos ;
   char S4PTR *buffer ;
   unsigned total ;
   unsigned working ;
   unsigned avail ;
} H4SEQ_WRITE ;

typedef struct
{
   char     name[11] ;
   char     type ;
   char     filler[4] ;
   unsigned char  len ;
   unsigned char  dec ;
   char     filler2[13] ;
   char    has_tag ;
} F4FIELD_IMAGE ;

typedef struct
{
   char        name[11] ;
   unsigned    len ;
   int         dec ;
   int         type ;
   int         offset ;
   struct D4DATA_st  S4PTR *data ;
   struct F4MEMO_st  S4PTR *memo ;
   #ifdef S4VBASIC
      int  debug_int ;
   #endif
} F4FIELD ;

typedef struct F4MEMO_st
{
   int    is_changed ;

   int    status ;
   char  S4PTR *contents ;
   unsigned  len ;
   unsigned  len_max ;
   F4FIELD  S4PTR *field ;
} F4MEMO ;

typedef struct
{
   char   S4PTR *name ;
   char    type ;
   short   len ;
   short   dec ;
} F4FIELD_INFO ;

typedef struct
{

   char     version ;
   char     yy ;
   char     mm ;
   char     dd ;
   long     num_recs ;
   unsigned short header_len;
   unsigned short record_len;
   char     zero[16] ;
   short    has_mdx ;
   char     zero2[2] ;
} D4DATA_HEADER_FULL ;

typedef struct D4DATA_st
{
   L4LINK  link ;

   char     version ;
   char     yy ;
   char     mm ;
   char     dd ;
   long     num_recs ;
   unsigned short header_len;

   char     S4PTR *record_old ;
   char     S4PTR *record ;

   unsigned record_width ;
   int      record_changed ;
   long     rec_num ;
   long     rec_num_old ;

   H4FILE   file ;
   char     alias[11] ;

   char     memo_validated ;

   C4CODE   S4PTR *code_base ;
   short    has_mdx ;

   F4FIELD  S4PTR *fields ;
   int      n_fields ;

   F4MEMO   S4PTR *fields_memo ;
   int      n_fields_memo ;

   long     locked_record ;
   long     S4PTR *locks ;
   int      n_locks ;
   int      num_locked ;
   int      file_lock ;
   int      append_lock ;

   int      file_changed ;

   L4LIST   indexes ;
   int      bof_flag, eof_flag ;

   short    block_size ;
   M4FILE   memo_file ;
   #ifdef S4VBASIC
      int  debug_int ;
   #endif
} D4DATA ;

typedef struct e4expr_st
{
   char    S4PTR *source ;
   D4DATA  S4PTR *data ;
   char    S4PTR *parsed ;
   int     type ;
   #ifdef S4CLIPPER
      int   num_decimals ;
   #endif
} E4EXPR ;

#ifdef N4OTHER
   typedef struct
   {
      long  pointer ;
      long  num ;
      char  value[1] ;
   } B4KEY_DATA ;

   #define I4MAX_EXPR_SIZE 256
   #ifdef S4NDX
      #define B4BLOCK_SIZE 512
   #else
      #ifdef S4CLIPPER
         #define B4BLOCK_SIZE 1024
      #endif
   #endif
#else
   typedef struct
   {
      long  num ;
      char  value[1] ;
   } B4KEY_DATA ;
#endif

#ifdef S4FOX
#define VERSION_POS 498L

typedef struct
{
   int trail1 ;
   int trail2 ;
   int dup1 ;
   int dup2 ;
} INSERT_STRUCT ;

typedef struct
{
   short            free_space ;
   unsigned long    rec_num_mask ;
   unsigned char    dup_byte_cnt ;
   unsigned char    trail_byte_cnt ;
   unsigned char    rec_num_len ;
   unsigned char    dup_cnt_len ;
   unsigned char    trail_cnt_len ;
   unsigned char    info_len ;
} B4NODE_HEADER ;

typedef struct
{
      short      node_attribute ;
      short      n_keys ;
      long       left_node ;
      long       right_node ;
} B4STD_HEADER ;

typedef struct
{
   L4LINK link ;
   struct T4TAG_st  *tag ;

   int   changed ;
   long  file_block ;
   int   key_on ;
   int   built_on ;
   int   cur_trail_cnt ;
   int   cur_dup_cnt ;
   int   dup_pos ;
   int   trail_pos ;
   int   rec_pos ;
   char  *cur_pos ;
   B4KEY_DATA *current ;
   B4KEY_DATA *saved ;

   B4STD_HEADER header ;
   B4NODE_HEADER node_hdr ;
   char  data[1] ;
} B4BLOCK ;

#define T4HEADER_WR_LEN 0x10

#define B4BLOCK_SIZE 512
#endif

#ifndef S4FOX

#ifdef S4NDX
   typedef struct
   {
      long     root ;
      long     eof ;
      char     n1_dummy ;
      char     db_type ;
      char     n2_dummy[2] ;
      short    key_len  ;
      short    keys_max ;
      short    int_or_date ;
      short    group_len ;
      short    dummy ;
      short    unique ;

   } I4IND_HEAD_WRITE;
#else
   #ifdef S4CLIPPER
      typedef struct
      {
         short          sign ;
         short          version ;
         long           root ;
         long           eof ;
         short          group_len ;
         short          key_len ;
         short          key_dec ;
         short          keys_max ;
         short          keys_half ;

      } I4IND_HEAD_WRITE;
   #endif
#endif

#ifdef S4NDX
typedef struct
{
   long     old_version ;
   int      header_offset ;
   char     type ;

   long     root ;
   long     eof ;
   char     n1_dummy ;
   char     db_type ;
   char     n2_dummy[2] ;
   short    key_len  ;
   short    keys_max ;
   short    int_or_date ;
   short    group_len ;
   short    dummy ;
   short    unique ;

   long     version ;
}  T4HEADER ;
#else
   #ifdef S4CLIPPER
      typedef struct
      {
         long       old_version ;
         int        header_offset ;
         char       type ;
         long       virtual_eof ;
         short      sign ;
         short      version ;
         long       root ;
         long       eof ;
         short      group_len ;
         short      key_len ;
         short      key_dec ;
         short      keys_max ;
         short      keys_half ;

         short      unique   ;
      }  T4HEADER ;
   #else
      typedef struct
      {
         char   two ;
         char   yymmdd[3] ;
         char   data_name[12] ;
         char   dummy1[4] ;
         short  block_chunks ;
         short  block_rw ;
         char   is_production ;
         char   num_slots ;
         short  slot_size ;
         long   num_tags ;
         long   eof ;
         long   free_list ;
         char   zero[4] ;
         char   create_date[3];
         char   blank ;
         long   version ;
      }  I4HEADER ;
   #endif
#endif
#endif

#ifndef S4FOX
typedef struct
{
   L4LINK link ;
   struct T4TAG_st  S4PTR *tag ;

   long  file_block ;
   int   changed ;
   int   key_on ;

   short      n_keys ;
   #ifdef S4NDX
      char       dummy[2] ;
      B4KEY_DATA data ;
   #else
      #ifdef S4CLIPPER
         short pointers[511] ;
         B4KEY_DATA *data ;
      #else
         char       dummy[6] ;
         B4KEY_DATA info ;
      #endif
   #endif
} B4BLOCK ;

typedef struct
{
   long  header_pos ;
   char  tag[10] ;
   short x1000 ;
   char  left_chld ;
   char  right_chld ;
   char  parent ;
   char  x2 ;
   char  index_type ;
   char  zeros[11] ;
} T4DESC ;
#endif

#ifndef N4OTHER
typedef struct
{
#ifdef S4FOX
   long           root ;
   long           free_list ;
   char           dummy1[4] ;
   short          key_len ;
   unsigned char  type_code;
   unsigned char  signature ;

   long           version ;
   short          descending   ;
   short          filter_pos ;
   short          filter_len ;
   short          expr_pos ;
   short          expr_len ;

#else
   long           root ;
   char           dummy1[4] ;
   char           type_code;
   char           type ;
   char           dummy2[2] ;
   short          value_len ;
   short          keys_max ;
   char           dummy3[2] ;
   short          group_len ;
   char           version ;
   char           dummy4 ;
   short          unique   ;

#endif
}  T4HEADER ;
#endif

typedef struct T4TAG_st
{
   L4LINK link ;

   E4EXPR   S4PTR  *expr ;
   E4EXPR   S4PTR  *filter ;
   int              unique_error;
   struct I4INDEX_st S4PTR *index ;
   S4CMP_FUNCTION  *cmp ;
   C4STOK S4PTR    *stok ;
   C4DTOK S4PTR    *dtok ;
   C4CODE S4PTR    *code_base ;
   char             alias[11] ;
   char             has_keys ;
   L4LIST           blocks ;

   #ifdef S4FOX
      char          p_char ;
   #endif

   #ifdef N4OTHER
      H4FILE        file ;
      int           file_locked ;
   #endif

   T4HEADER    header ;
   long        header_offset ;
   int         root_write ;
   long        lock_pos ;
   int         key_dec ;
   L4LIST      saved ;
   int         debug_int ;
} T4TAG ;

typedef struct
{
   char S4PTR *name ;
   char S4PTR *expression ;
   char S4PTR *filter ;
   int   unique ;
   int   descending ;
} T4TAG_INFO ;

typedef struct I4INDEX_st
{
   L4LINK  link ;

   H4FILE  file ;
   D4DATA S4PTR *data ;
   C4CODE S4PTR *code_base ;
   L4LIST  tags ;

   #ifdef S4FOX
      T4TAG *tag_index ;
      long  eof ;
   #else
      #ifdef N4OTHER
         char alias[11] ;
        char *path ;
      #else
         I4HEADER header ;
      #endif
   #endif

   Y4MEMORY_TYPE S4PTR *block_memory ;
   T4TAG  S4PTR *tag_locked ;
   int   file_locked ;
   long  version_old ;
} I4INDEX ;

typedef struct
{
   #ifdef S4MFOX
      long  next_block ;
      char  usused[2] ;
      short block_size ;
   #else
      #ifdef S4MNDX
         long  next_block ;
      #else
         long  next_block ;
         long  zero ;
         char  file_name[8] ;
         short zero2 ;
         short x102 ;
         short block_size ;
         short zero3 ;
      #endif
   #endif
} M4MEMO_HEADER ;

#ifndef S4MNDX
#ifndef S4MFOX
typedef struct
{
   long  next ;
   long  num ;
   int   to_disk ;
   long  block_no ;
} M4CHAIN_ENTRY ;
#endif

typedef struct
{
   #ifdef S4MFOX
      long  type ;
      long  num_chars ;
   #else
      short minus_one ;
      short start_pos ;
      long  num_chars ;
   #endif
} M4MEMO_BLOCK ;
#endif

#ifdef S4UNIX
   typedef struct
   {
      unsigned  char  sig_dig ;
      unsigned  char  digit_info ;
      unsigned  char  bcd[10] ;
   }  C4BCD ;
#else
   typedef struct
   {
      unsigned  sig_dig : 8 ;
      #ifndef __ZTC__

         unsigned  one  : 2 ;
         unsigned  len  : 5 ;
         unsigned  sign : 1 ;
      #else
         #if __ZTC__ > 0x300
            unsigned  one  : 2 ;
            unsigned  len  : 5 ;
            unsigned  sign : 1 ;
         #else
            unsigned  sign : 1 ;
            unsigned  len  : 5 ;
            unsigned  one  : 2 ;
         #endif
      #endif
      unsigned  char  bcd[10] ;
   }  C4BCD ;
#endif

extern char   v4buffer[257] ;

#ifdef __cplusplus
   extern "C" {
#endif

void   S4FUNCTION a4assign( char S4PTR *, long ) ;
long   S4FUNCTION a4long( char S4PTR * ) ;
char S4PTR * S4FUNCTION a4cdow( char S4PTR * ) ;
char S4PTR * S4FUNCTION a4cmonth( char S4PTR * ) ;
int    S4FUNCTION a4day( char S4PTR * ) ;
int    S4FUNCTION a4dow( char S4PTR * ) ;
void   S4FUNCTION a4format( char S4PTR *, char S4PTR *, char S4PTR * ) ;
int    S4FUNCTION a4format_mdx2( char S4PTR *, double S4PTR * ) ;
double S4FUNCTION a4format_mdx( char S4PTR *) ;
void   S4FUNCTION a4init( char S4PTR *, char S4PTR *, char S4PTR * ) ;
int    S4FUNCTION a4month( char S4PTR * ) ;
void   S4FUNCTION a4today( char S4PTR * ) ;
int    S4FUNCTION a4year( char S4PTR * ) ;
void   S4FUNCTION a4time_now( char S4PTR * ) ;

#ifdef S4FOX
int    S4FUNCTION b4back_skip( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION b4branch_skip( B4BLOCK S4PTR *, long ) ;
int    S4FUNCTION b4calc_blanks( char S4PTR *, int, char ) ;
int    S4FUNCTION b4calc_dups( char S4PTR *, char S4PTR *, int ) ;
int    S4FUNCTION b4bytes_reqd( B4BLOCK S4PTR *, INSERT_STRUCT S4PTR *, char S4PTR *, int ) ;
int    S4FUNCTION b4do_skip( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION b4go( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION b4insert_leaf( B4BLOCK S4PTR *, void S4PTR *, long ) ;
int    S4FUNCTION b4insert_branch( B4BLOCK S4PTR *, void S4PTR *, long, long, char ) ;
void   S4FUNCTION b4leaf_init( B4BLOCK * ) ;
int    S4FUNCTION b4cmp( B4BLOCK *, char *, char *, size_t, int, int ) ;
int    S4FUNCTION b4leaf_seek( B4BLOCK S4PTR *, char S4PTR *, int ) ;
int    S4FUNCTION b4rec_len( long ) ;
int    S4FUNCTION b4reindex( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4remove_leaf( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4remove_branch( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4br_replace( B4BLOCK S4PTR *, char S4PTR *, long ) ;
int    S4FUNCTION b4top( B4BLOCK S4PTR * ) ;
int    S4CALL     t4desc_memcmp( S4CMP_PARM, S4CMP_PARM, size_t ) ;
void   S4FUNCTION t4branch_split( T4TAG S4PTR *, B4BLOCK S4PTR *, B4BLOCK S4PTR * ) ;
void   S4FUNCTION t4leaf_split( T4TAG S4PTR *, B4BLOCK S4PTR *, B4BLOCK S4PTR * ) ;
int    S4FUNCTION t4r_seek( T4TAG S4PTR *, void S4PTR *, int, long ) ;
int    S4FUNCTION t4rl_bottom( T4TAG * ) ;
int    S4FUNCTION t4rl_top( T4TAG * ) ;
int    S4FUNCTION b4r_brseek( B4BLOCK S4PTR *, char S4PTR *, int, long ) ;
long   S4FUNCTION x4recno( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION x4dup_cnt( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION x4trail_cnt( B4BLOCK S4PTR *, int ) ;
void   S4FUNCTION x4put_info( B4NODE_HEADER S4PTR *, void S4PTR *, long, int, int ) ;
int    S4FUNCTION b4insert( B4BLOCK S4PTR *, void S4PTR *, long, long, char ) ;
int    S4FUNCTION b4skip( B4BLOCK S4PTR *, long, int ) ;
int    S4FUNCTION t4init( T4TAG S4PTR *, I4INDEX S4PTR *, long, long, char S4PTR *) ;
#else
   #ifdef N4OTHER
      void   S4FUNCTION b4append( B4BLOCK S4PTR *, long ) ;
      int    S4FUNCTION b4skip( B4BLOCK S4PTR *, long ) ;
      void   S4FUNCTION b4insert( B4BLOCK S4PTR *, void S4PTR *, long, long ) ;
      #ifdef S4NDX
         int    S4FUNCTION b4find( B4BLOCK S4PTR *, long, B4BLOCK S4PTR * ) ;
         int    S4FUNCTION b4get_last_key( B4BLOCK S4PTR *, char S4PTR * ) ;
         int    S4FUNCTION i4get_last_key( T4TAG S4PTR *,char S4PTR *, long ) ;
      #else
         #ifdef S4CLIPPER
         int    S4FUNCTION c4clip( char S4PTR *, int ) ;
         void   S4FUNCTION b4append2( B4BLOCK S4PTR *, void S4PTR *, long, long ) ;
         void   S4FUNCTION t4remove_ref( T4TAG S4PTR * ) ;
         int    S4FUNCTION t4get_replace_entry( T4TAG S4PTR *, B4KEY_DATA S4PTR *, B4BLOCK S4PTR * ) ;
         int    S4FUNCTION t4shrink( T4TAG S4PTR *, long ) ;
         #endif
      #endif
      int    S4FUNCTION b4room( B4BLOCK S4PTR * ) ;
      int    S4FUNCTION t4close( T4TAG S4PTR * ) ;
      long   S4FUNCTION t4extend( T4TAG S4PTR * ) ;
      T4TAG *S4FUNCTION t4open( D4DATA S4PTR *, I4INDEX S4PTR *, char S4PTR * ) ;
      int    S4FUNCTION t4update_header( T4TAG S4PTR * ) ;
      int    S4FUNCTION t4version_check( T4TAG S4PTR* ) ;
      T4TAG *S4FUNCTION t4create( D4DATA S4PTR *, T4TAG_INFO S4PTR *, I4INDEX S4PTR * ) ;
      int    S4FUNCTION t4reindex( T4TAG S4PTR * ) ;
   #else
      void   S4FUNCTION b4insert( B4BLOCK S4PTR *, void S4PTR *, long ) ;
      int    S4FUNCTION b4skip( B4BLOCK S4PTR *, long ) ;
      int    S4FUNCTION t4init( T4TAG S4PTR *, I4INDEX S4PTR *, T4DESC S4PTR *, long ) ;
   #endif
#endif

#ifdef S4NDX
int S4FUNCTION b4find( B4BLOCK S4PTR *, long, B4BLOCK S4PTR * ) ;
int S4FUNCTION b4get_last_key( B4BLOCK S4PTR *, char S4PTR * ) ;
int S4FUNCTION i4get_last_key( T4TAG S4PTR *, char S4PTR *, long ) ;
#endif

B4BLOCK S4PTR *S4FUNCTION b4alloc( T4TAG S4PTR *, long ) ;
int    S4FUNCTION b4flush( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4free( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4go_eof( B4BLOCK S4PTR * ) ;
B4KEY_DATA S4PTR * S4FUNCTION b4key( B4BLOCK S4PTR *, int ) ;
unsigned char S4PTR * S4FUNCTION b4key_key( B4BLOCK S4PTR *, int ) ;
int    S4FUNCTION b4lastpos( B4BLOCK S4PTR * ) ;
int    S4FUNCTION b4leaf( B4BLOCK S4PTR * ) ;
long   S4FUNCTION b4recno( B4BLOCK S4PTR * ) ;
void   S4FUNCTION b4remove( B4BLOCK S4PTR *);
int    S4FUNCTION b4seek( B4BLOCK S4PTR *, char S4PTR *, int ) ;

int    S4FUNCTION c4atod2( char S4PTR *, int, double S4PTR * ) ;
double S4FUNCTION c4atod( char S4PTR *, int) ;
int    S4FUNCTION c4atoi( char S4PTR *, int) ;
long   S4FUNCTION c4atol( char S4PTR *, int) ;

int S4CALL c4bcd_cmp( S4CMP_PARM, S4CMP_PARM, size_t ) ;

#ifndef S4FOX
   #ifdef S4UNIX
      void c4bcd_from_a( char S4PTR *, char S4PTR *, int ) ;
      void t4str_to_date_mdx( char S4PTR *, char S4PTR *, int ) ;
      void t4no_change_str( char S4PTR *, char S4PTR *, int ) ;
      void c4bcd_from_d( char S4PTR *, double ) ;
      void t4no_change_double( char S4PTR *, double ) ;
   #else
      C4STOK c4bcd_from_a ;
      C4DTOK c4bcd_from_d ;
   #endif
#else
   C4STOK t4dtstr_to_fox ;
   C4STOK t4str_to_fox ;
   C4DTOK t4dbl_to_fox ;
#endif

void   S4FUNCTION c4dtoa45( double, char S4PTR *, int, int) ;
void   S4FUNCTION c4encode( char S4PTR *, char S4PTR *, char S4PTR *, char S4PTR *) ;
void   S4FUNCTION c4lower( char S4PTR * ) ;
void   S4FUNCTION c4ltoa45( long, char S4PTR *, int) ;
void   S4FUNCTION c4trim_n( char S4PTR *, int ) ;
void   S4FUNCTION c4upper( char S4PTR * ) ;

#ifdef S4VBASIC
   int c4parm_check( void *, int, char * ) ;
#endif

char S4PTR * S4FUNCTION d4alias( D4DATA S4PTR * ) ;
void   S4FUNCTION d4alias_set( D4DATA S4PTR *, char S4PTR * ) ;
int    S4FUNCTION d4append( D4DATA S4PTR * ) ;
int    S4FUNCTION d4append_data( D4DATA S4PTR * ) ;
int    S4FUNCTION d4append_blank( D4DATA S4PTR * ) ;
int    S4FUNCTION d4append_start( D4DATA S4PTR *, int ) ;
void   S4FUNCTION d4blank( D4DATA S4PTR * ) ;
int    S4FUNCTION d4bof( D4DATA S4PTR * ) ;
int    S4FUNCTION d4bottom( D4DATA S4PTR * ) ;
int    S4FUNCTION d4check( D4DATA S4PTR * ) ;
int    S4FUNCTION d4close( D4DATA S4PTR * ) ;
int    S4FUNCTION d4close_all( C4CODE S4PTR * ) ;
D4DATA S4PTR * S4FUNCTION d4create( C4CODE S4PTR *, char S4PTR *, F4FIELD_INFO S4PTR *, T4TAG_INFO S4PTR * ) ;
D4DATA S4PTR * S4FUNCTION d4data( C4CODE S4PTR *, char S4PTR * ) ;
void   S4FUNCTION d4delete( D4DATA S4PTR * ) ;
int    S4FUNCTION d4deleted( D4DATA S4PTR * ) ;
int    S4FUNCTION d4eof( D4DATA S4PTR * ) ;
F4FIELD S4PTR * S4FUNCTION d4field( D4DATA S4PTR *, char S4PTR * ) ;
F4FIELD S4PTR * S4FUNCTION d4field_j( D4DATA S4PTR *, int ) ;
int    S4FUNCTION d4field_number( D4DATA S4PTR *, char S4PTR * ) ;
int    S4FUNCTION d4flush_all( D4DATA S4PTR * ) ;
int    S4FUNCTION d4flush_record( D4DATA S4PTR * ) ;
int    S4FUNCTION d4free_blocks( D4DATA S4PTR * ) ;
int    S4FUNCTION d4go( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4go_data( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4go_eof( D4DATA S4PTR * ) ;
I4INDEX S4PTR * S4FUNCTION d4index( D4DATA S4PTR *, char S4PTR * ) ;
void   S4FUNCTION d4init( C4CODE S4PTR * ) ;
int    S4FUNCTION d4init_undo( C4CODE S4PTR * ) ;
int    S4FUNCTION d4lock( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4lock_append( D4DATA S4PTR * ) ;
int    S4FUNCTION d4lock_file( D4DATA S4PTR * ) ;
int    S4FUNCTION d4lock_index( D4DATA S4PTR * ) ;
int    S4FUNCTION d4lock_group( D4DATA S4PTR *, long S4PTR *, int ) ;
int    S4FUNCTION d4lock_test( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4lock_test_file( D4DATA S4PTR * ) ;
int    S4FUNCTION d4lock_test_append( D4DATA S4PTR * ) ;
int    S4FUNCTION d4memo_compress( D4DATA S4PTR * ) ;
int    S4FUNCTION d4num_fields ( D4DATA S4PTR * ) ;
D4DATA S4PTR *S4FUNCTION d4open( C4CODE S4PTR *, char S4PTR * ) ;
int    S4FUNCTION d4pack( D4DATA S4PTR * ) ;
int    S4FUNCTION d4pack_data( D4DATA S4PTR * ) ;
int    S4FUNCTION d4position2( D4DATA S4PTR *, double S4PTR * ) ;
double S4FUNCTION d4position( D4DATA S4PTR * ) ;
int    S4FUNCTION d4position_set( D4DATA S4PTR *, double ) ;
int    S4FUNCTION d4read( D4DATA S4PTR *, long, char S4PTR * ) ;
int    S4FUNCTION d4read_old( D4DATA S4PTR *, long ) ;
void   S4FUNCTION d4recall( D4DATA S4PTR * ) ;
long   S4FUNCTION d4reccount( D4DATA S4PTR * ) ;
long   S4FUNCTION d4recno( D4DATA S4PTR * ) ;
char  S4PTR *S4FUNCTION d4record( D4DATA S4PTR * ) ;
long   S4FUNCTION d4record_width( D4DATA S4PTR * ) ;
long   S4FUNCTION d4rec_pos( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4reindex( D4DATA S4PTR * ) ;
int    S4FUNCTION d4seek( D4DATA S4PTR *, char S4PTR * ) ;
int    S4FUNCTION d4seek_double( D4DATA S4PTR *, double ) ;
int    S4FUNCTION d4skip( D4DATA S4PTR *, long ) ;
T4TAG S4PTR *S4FUNCTION d4tag( D4DATA S4PTR *, char S4PTR * ) ;
T4TAG S4PTR *S4FUNCTION d4tag_default( D4DATA S4PTR * ) ;
T4TAG S4PTR *S4FUNCTION d4tag_next( D4DATA S4PTR *, T4TAG S4PTR * ) ;
T4TAG S4PTR *S4FUNCTION d4tag_prev( D4DATA S4PTR *, T4TAG S4PTR * ) ;
void   S4FUNCTION d4tag_select( D4DATA S4PTR *, T4TAG S4PTR * ) ;
T4TAG S4PTR *S4FUNCTION d4tag_selected( D4DATA S4PTR * ) ;
int    S4FUNCTION d4top( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_all( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_all_data( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_append( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_file( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_index( D4DATA S4PTR * ) ;
int    S4FUNCTION d4unlock_records( D4DATA S4PTR * ) ;
int    S4FUNCTION d4update_header( D4DATA S4PTR *, int, int ) ;
int    S4FUNCTION d4validate_memo_ids( D4DATA S4PTR * ) ;
int    S4FUNCTION d4write( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4write_data( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4write_keys( D4DATA S4PTR *, long ) ;
int    S4FUNCTION d4zap( D4DATA S4PTR *, long, long ) ;
int    S4FUNCTION d4zap_data( D4DATA S4PTR *, long, long ) ;

int    S4FUNCTION e4error_set( C4CODE S4PTR *, int ) ;
void   S4FUNCTION e4exit(C4CODE S4PTR *) ;
void   S4FUNCTION e4exit_test( C4CODE S4PTR * ) ;

#ifdef S4VARARGS
   int    S4ERROR    e4error( ) ;
   void   S4ERROR    e4severe( ) ;
#else
   int    S4ERROR    e4error( C4CODE S4PTR *, int, char *, ... ) ;
   void   S4ERROR    e4severe( int, char *, ... ) ;
   #ifdef S4VBASIC
      void   S4ERROR   e4severe_vbasic( int, char *, ... ) ;
   #endif
#endif

void   S4FUNCTION f4assign( F4FIELD S4PTR *, char S4PTR * ) ;
void   S4FUNCTION f4assign_char( F4FIELD S4PTR *, int ) ;
void   S4FUNCTION f4assign_double( F4FIELD S4PTR *, double ) ;
void   S4FUNCTION f4assign_int( F4FIELD S4PTR *, int ) ;
void   S4FUNCTION f4assign_long( F4FIELD S4PTR *, long ) ;
void   S4FUNCTION f4assign_n( F4FIELD S4PTR *, char S4PTR *, unsigned ) ;
char S4PTR * S4FUNCTION f4assign_ptr( F4FIELD S4PTR * ) ;
void   S4FUNCTION f4blank( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4char( F4FIELD S4PTR * ) ;
D4DATA S4PTR *S4FUNCTION f4data( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4decimals( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4double2( F4FIELD S4PTR *, double S4PTR * ) ;
double S4FUNCTION f4double( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4int( F4FIELD S4PTR * ) ;
unsigned  S4FUNCTION f4len( F4FIELD S4PTR * ) ;
long   S4FUNCTION f4long( F4FIELD S4PTR * ) ;
char S4PTR * S4FUNCTION f4name( F4FIELD S4PTR * ) ;
unsigned S4FUNCTION f4ncpy( F4FIELD S4PTR *, char S4PTR *, unsigned ) ;
char S4PTR * S4FUNCTION f4ptr( F4FIELD S4PTR * ) ;
char S4PTR * S4FUNCTION f4str( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4true( F4FIELD S4PTR * ) ;
int    S4FUNCTION f4type( F4FIELD S4PTR * ) ;

int    S4FUNCTION h4close( H4FILE S4PTR * ) ;
int    S4FUNCTION h4create( H4FILE S4PTR *, C4CODE S4PTR *, char S4PTR *, int ) ;
long   S4FUNCTION h4length( H4FILE S4PTR * ) ;
int    S4FUNCTION h4length_set( H4FILE S4PTR *, long ) ;
int    S4FUNCTION h4lock( H4FILE S4PTR *, long, long ) ;
int    S4FUNCTION h4open( H4FILE S4PTR *, C4CODE S4PTR *, char S4PTR *, int ) ;
int    S4FUNCTION h4open_test( H4FILE S4PTR * ) ;
unsigned  S4FUNCTION h4read( H4FILE S4PTR *, long, void S4PTR *, unsigned ) ;
int    S4FUNCTION h4read_all( H4FILE S4PTR *, long, void S4PTR *, unsigned ) ;
int    S4FUNCTION h4read_error( H4FILE S4PTR * ) ;
int    S4FUNCTION h4replace( H4FILE S4PTR *, H4FILE S4PTR * ) ;
int    S4FUNCTION h4temp( H4FILE S4PTR *, C4CODE S4PTR *, char S4PTR *, int ) ;
int    S4FUNCTION h4unlock( H4FILE S4PTR *, long, long ) ;
int    S4FUNCTION h4write( H4FILE S4PTR *, long, void S4PTR *, unsigned ) ;

void   S4FUNCTION h4seq_read_init( H4SEQ_READ S4PTR *, H4FILE S4PTR *, long, void S4PTR *, unsigned ) ;
unsigned  S4FUNCTION h4seq_read( H4SEQ_READ S4PTR *, void S4PTR *, unsigned ) ;
int    S4FUNCTION h4seq_read_all( H4SEQ_READ S4PTR *, void S4PTR *, unsigned ) ;

void   S4FUNCTION h4seq_write_init( H4SEQ_WRITE S4PTR *, H4FILE S4PTR *, long, void S4PTR *, unsigned ) ;
int    S4FUNCTION h4seq_write( H4SEQ_WRITE S4PTR *, void S4PTR *, unsigned ) ;
int    S4FUNCTION h4seq_write_flush( H4SEQ_WRITE S4PTR * ) ;
int    S4FUNCTION h4seq_write_repeat( H4SEQ_WRITE S4PTR *, long, char ) ;

int    S4FUNCTION i4check( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4close( I4INDEX S4PTR * ) ;
I4INDEX S4PTR *S4FUNCTION i4create( D4DATA S4PTR *, char S4PTR *, T4TAG_INFO S4PTR * ) ;
long   S4FUNCTION i4extend( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4flush( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4lock( I4INDEX S4PTR * ) ;
I4INDEX S4PTR *S4FUNCTION i4open( D4DATA S4PTR *, char S4PTR * ) ;
int    S4FUNCTION i4reindex( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4shrink( I4INDEX S4PTR *, long ) ;
T4TAG S4PTR *S4FUNCTION i4tag( I4INDEX S4PTR *, char S4PTR * ) ;
int    S4FUNCTION i4unlock( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4update_header( I4INDEX S4PTR * ) ;
int    S4FUNCTION i4version_check( I4INDEX S4PTR * ) ;

void   S4FUNCTION l4add( L4LIST S4PTR *, void S4PTR * ) ;
void   S4FUNCTION l4add_after(   L4LIST S4PTR *, void S4PTR *, void S4PTR * ) ;
void   S4FUNCTION l4add_before( L4LIST S4PTR *, void S4PTR *, void S4PTR * ) ;
void   l4check( L4LIST S4PTR * ) ;
void S4PTR * S4FUNCTION l4first( L4LIST S4PTR * ) ;
void S4PTR * S4FUNCTION l4last( L4LIST S4PTR * ) ;
void S4PTR * S4FUNCTION l4next( L4LIST S4PTR *, void S4PTR * ) ;
void S4PTR * S4FUNCTION l4prev( L4LIST S4PTR *, void S4PTR * ) ;
void S4PTR * S4FUNCTION l4pop( L4LIST S4PTR * ) ;
void   S4FUNCTION l4remove( L4LIST S4PTR *, void S4PTR * ) ;

int    S4FUNCTION l4lock_check( void ) ;
void   l4lock_remove( int,long,long) ;
void   l4lock_save( int,long,long) ;

#ifndef S4MFOX
#ifndef S4MNDX
int    m4file_chain_flush( M4FILE S4PTR *, M4CHAIN_ENTRY S4PTR * ) ;
int    m4file_chain_skip( M4FILE S4PTR *, M4CHAIN_ENTRY S4PTR * ) ;
int    S4FUNCTION m4check( M4FILE S4PTR * ) ;
#endif
#endif

int    m4file_check( M4FILE S4PTR * ) ;
int    m4file_create( M4FILE S4PTR *, C4CODE S4PTR *, D4DATA S4PTR *, char S4PTR * );

int    m4file_dump( M4FILE S4PTR *, long, char S4PTR *, unsigned ) ;
int    m4file_open( M4FILE S4PTR *, D4DATA S4PTR *, char S4PTR * ) ;
int    m4file_read( M4FILE S4PTR *, long , char S4PTR **, unsigned S4PTR * ) ;
int    m4file_write( M4FILE S4PTR *, long S4PTR *, char S4PTR *, unsigned ) ;

int    S4FUNCTION m4assign( F4FIELD S4PTR *, char S4PTR * ) ;
int    S4FUNCTION m4assign_n( F4FIELD S4PTR *, char S4PTR *, unsigned ) ;
unsigned S4FUNCTION m4len( F4FIELD S4PTR * ) ;
unsigned S4FUNCTION m4ncpy( F4FIELD S4PTR *, char S4PTR *, unsigned ) ;
int    S4FUNCTION m4set_len( F4FIELD S4PTR *, unsigned ) ;
char   S4PTR * S4FUNCTION m4str( F4FIELD S4PTR * ) ;
char   S4PTR * S4FUNCTION m4ptr( F4FIELD S4PTR * ) ;

int    S4FUNCTION m4flush( F4FIELD S4PTR * ) ;
void   S4FUNCTION m4free( F4FIELD S4PTR * ) ;
int    S4FUNCTION m4read( F4FIELD S4PTR * ) ;
int    S4FUNCTION m4read_low( F4FIELD S4PTR * ) ;
void   S4FUNCTION m4reset( F4FIELD S4PTR * ) ;
int    S4FUNCTION m4write( F4FIELD S4PTR * ) ;

int    S4FUNCTION t4add( T4TAG S4PTR *, unsigned char S4PTR *, long ) ;
int    S4FUNCTION t4add_calc( T4TAG S4PTR *, long ) ;
B4BLOCK S4PTR *S4FUNCTION t4block( T4TAG S4PTR * ) ;
int    S4FUNCTION t4bottom( T4TAG S4PTR * ) ;
int    S4FUNCTION t4check( T4TAG S4PTR * ) ;
int    S4FUNCTION t4down( T4TAG S4PTR * ) ;
int    S4FUNCTION t4dump( T4TAG S4PTR *, int, int ) ;
int    S4FUNCTION t4eof( T4TAG S4PTR * ) ;
int    S4FUNCTION t4flush( T4TAG S4PTR * ) ;
int    S4FUNCTION t4free_all( T4TAG S4PTR * ) ;
int    S4FUNCTION t4free_saved( T4TAG S4PTR * ) ;
int    S4FUNCTION t4go( T4TAG S4PTR *, char S4PTR *, long ) ;
void   S4FUNCTION t4init_seek_conv( T4TAG S4PTR *, int) ;
B4KEY_DATA S4PTR *S4FUNCTION t4key( T4TAG S4PTR * ) ;
int    S4FUNCTION t4lock( T4TAG S4PTR * ) ;
int    S4FUNCTION t4position2( T4TAG S4PTR *, double S4PTR * ) ;
double S4FUNCTION t4position( T4TAG S4PTR * ) ;
int    S4FUNCTION t4position_set( T4TAG S4PTR *, double ) ;
long   S4FUNCTION t4recno( T4TAG S4PTR * ) ;
int    S4FUNCTION t4remove_current( T4TAG S4PTR * ) ;
int    S4FUNCTION t4remove( T4TAG S4PTR *, char S4PTR *, long ) ;
int    S4FUNCTION t4remove_calc( T4TAG S4PTR *, long ) ;
int    S4FUNCTION t4seek( T4TAG S4PTR *, void S4PTR *, int ) ;
long   S4FUNCTION t4skip( T4TAG S4PTR *, long ) ;
B4BLOCK S4PTR *S4FUNCTION t4split( T4TAG S4PTR *, B4BLOCK S4PTR * ) ;
int    S4FUNCTION t4top( T4TAG S4PTR * ) ;
int    S4FUNCTION t4type( T4TAG S4PTR * ) ;
int    S4FUNCTION t4up( T4TAG S4PTR * ) ;
int    S4FUNCTION t4up_to_root( T4TAG S4PTR * ) ;

int    S4FUNCTION u4name_char( char ) ;
void   S4FUNCTION u4name_ext( char S4PTR *, int, char S4PTR *, int ) ;
void   S4FUNCTION u4name_piece( char S4PTR *, int, char S4PTR *, int, int ) ;
int    S4FUNCTION u4name_path( char S4PTR *, int, char S4PTR * ) ;

#ifdef S4WINDOWS
   int S4FUNCTION u4commit( D4DATA S4PTR * ) ;
#endif
unsigned S4FUNCTION u4ncpy( char S4PTR *, char S4PTR *, unsigned ) ;
int    S4FUNCTION u4ptr_equal( void S4PTR *, void S4PTR * ) ;
int    S4FUNCTION u4remove( char S4PTR * ) ;
void   S4FUNCTION u4yymmdd( char S4PTR * ) ;
int    S4FUNCTION u4rename( char S4PTR *, char S4PTR * ) ;

#ifdef S4CLIPPER
   char S4PTR * S4FUNCTION u4descend_char(char S4PTR*);
   char S4PTR * S4FUNCTION u4descend_date(char S4PTR*);
   char S4PTR * S4FUNCTION u4descend_num(char S4PTR*);
   char S4PTR * S4FUNCTION u4descend(F4FIELD S4PTR*);
#endif

void  S4PTR *S4FUNCTION u4alloc( long ) ;
int    S4FUNCTION u4alloc_again( C4CODE S4PTR *, char S4PTR **, unsigned S4PTR *, unsigned ) ;
void   S4FUNCTION u4free( void S4PTR * ) ;
short  S4FUNCTION x4reverse_short( short ) ;
long   S4FUNCTION x4reverse_long( long ) ;

void  S4PTR *S4FUNCTION y4alloc( Y4MEMORY_TYPE S4PTR * ) ;
Y4CHUNK S4PTR *S4FUNCTION y4alloc_chunk( Y4MEMORY_TYPE S4PTR * ) ;
void   S4FUNCTION y4free( Y4MEMORY_TYPE S4PTR *, void S4PTR * ) ;
int    S4FUNCTION y4free_check( int ) ;
void   S4FUNCTION y4check_memory( void ) ;
void   S4FUNCTION y4init( void ) ;
Y4MEMORY_TYPE S4PTR *S4FUNCTION y4memory_type( int, unsigned, int, int ) ;
void  S4PTR *S4FUNCTION y4memory_type_alloc( Y4MEMORY_TYPE S4PTR **, int, unsigned, int, int ) ;
void   S4FUNCTION y4release( Y4MEMORY_TYPE S4PTR * ) ;
void   S4FUNCTION y4reset( void ) ;

int S4CALL u4memcmp( S4CMP_PARM, S4CMP_PARM, size_t ) ;

#ifdef __cplusplus
   }
#endif


class S4CLASS d4Data ;
class S4CLASS i4Index ;
class S4CLASS s4Len ;

class S4CLASS c4Code : public C4CODE
{
public:
   c4Code() ;
   c4Code( c4Code& ) ;

   int     close_all()         { return d4close_all( this ) ; }
   d4Data  data( char *alias ) ;
   int     error()             { return this->error_code ; }
   int     error( int er )     { return e4error_set( this, er ) ; }
   void    exit()              {        e4exit( this ) ; }
   void    exit_test()         {        e4exit_test( this ) ; }
   int     init_undo()         { return d4init_undo( this ) ; }

   Y4MEMORY_TYPE *string_types[16] ;
} ;

class S4CLASS d4Data
{
public:
   d4Data()                           { data = 0 ; }
   d4Data( c4Code *code, char *name ) { data = d4open( code, name ) ; }
  ~d4Data();

   char * alias()                   { return d4alias( data ) ; }
   void   alias_set( char *ptr )    {        d4alias_set( data, ptr ) ; }
   int    append()                  { return d4append( data ) ; }
   int    append_data()             { return d4append_data( data ) ; }
   int    append_blank()            { return d4append_blank( data ) ; }
   int    append_start( int memo )  { return d4append_start( data, memo ) ; }
   void   blank()                   {        d4blank( data ) ; }
   int    bof()                     { return d4bof( data ) ; }
   int    bottom()                  { return d4bottom( data ) ; }
   int    check()                   { return d4check( data ) ; }
   int    close()            { int rc = d4close( data ) ; data = 0; return rc; }
   int    create( c4Code *cd, char *name, F4FIELD_INFO *f, T4TAG_INFO *t = 0 )
                                    { data = d4create( cd, name, f, t ) ;
                                      return cd->error_code ; }
   void   delete_rec()              {        d4delete( data ) ; }
   int    deleted()                 { return d4deleted( data ) ; }
   int    eof()                     { return d4eof( data ) ; }
   int    field_number( char *name) { return d4field_number( data, name) ; }
   int    flush_all()               { return d4flush_all( data ) ; }
   int    flush_record()            { return d4flush_record( data ) ; }
   int    go( long rec )            { return d4go( data, rec ) ; }
   int    go_data( long rec )       { return d4go_data( data, rec ) ; }
   int    go_eof()                  { return d4go_eof( data ) ; }
   i4Index index( char *name ) ;
   int    lock( long rec_num )      { return d4lock( data, rec_num ) ; }
   int    lock_append()             { return d4lock_append( data ) ; }
   int    lock_file()               { return d4lock_file( data ) ; }
   int    lock_index()              { return d4lock_index( data ) ; }
   int    lock_group(long *r, int n){ return d4lock_group( data, r, n ) ; }
   int    lock_test( long rec )     { return d4lock_test( data, rec ) ; }
   int    lock_test_file()          { return d4lock_test_file( data ) ; }
   int    lock_test_append()        { return d4lock_test_append( data ) ; }
   int    num_fields()              { return d4num_fields( data ) ; }
   int    memo_compress()           { return d4memo_compress( data ) ; }
   int    open( c4Code *code, char *name ) { data =  d4open( code, name ) ;
                                      return code->error_code ; }
   int    pack()                    { return d4pack( data ) ; }
   int    pack_data()               { return d4pack_data( data ) ; }
   double position()                { return d4position( data ) ; }
   int    position_set( double d )  { return d4position_set( data, d ) ; }
   int    read( long rec,char *buf) { return d4read( data, rec, buf ) ; }
   int    read_old( long rec )      { return d4read_old( data, rec ) ; }
   void   recall()                  {        d4recall( data ) ; }
   long   reccount()                { return d4reccount( data ) ; }
   long   recno()                   { return d4recno( data ) ; }
   char  *record()                  { return d4record( data ) ; }
   long   record_width()            { return d4record_width( data ) ; }
   long   rec_pos( long r )         { return d4rec_pos( data, r ) ; }
   int    reindex()                 { return d4reindex( data ) ; }
   int    seek( char *ptr )         { return d4seek( data, ptr ) ; }
   int    seek_double( double d )   { return d4seek_double( data, d ) ; }
   int    skip( long n )            { return d4skip( data, n ) ; }
   T4TAG *tag( char *name )         { return d4tag( data, name ) ; }
   T4TAG *tag_default()             { return d4tag_default( data ) ; }
   T4TAG *tag_next( T4TAG *tag )    { return d4tag_next( data, tag ) ; }
   T4TAG *tag_prev( T4TAG *tag )    { return d4tag_prev( data, tag ) ; }
   void   tag_select( T4TAG *tag )  {        d4tag_select( data, tag ) ; }
   T4TAG *tag_selected()            { return d4tag_selected( data ) ; }
   int    top()                     { return d4top( data ) ; }
   int    unlock_all()              { return d4unlock_all( data ) ; }
   int    unlock_all_data()         { return d4unlock_all_data( data ) ; }
   int    unlock_append()           { return d4unlock_append( data ) ; }
   int    unlock_file()             { return d4unlock_file( data ) ; }
   int    unlock_index()            { return d4unlock_index( data ) ; }
   int    unlock_records()          { return d4unlock_records( data ) ; }
   int    update_header(int t,int c){ return d4update_header( data, t, c ) ; }
   int    validate_memo_ids()       { return d4validate_memo_ids( data ) ; }
   int    write( long rec )         { return d4write( data, rec ) ; }
   int    write_data( long rec )    { return d4write_data( data, rec ) ; }
   int    write_keys( long rec )    { return d4write_keys( data, rec ) ; }
   int    zap( long f, long last)   { return d4zap( data, f, last ) ; }
   int    zap_data(long f,long last){ return d4zap_data( data, f, last ) ; }

   D4DATA *data ;
} ;

class S4CLASS i4Index
{
public:
   i4Index()  { index = 0 ; }

   int    close()        { int rc =  i4close( index ) ; index = 0 ; return rc;}
   int    create( d4Data& data, char *name, T4TAG_INFO *info )
                            { index = i4create( data.data, name, info ) ;
                              return data.data->code_base->error_code ; }
   int    lock()            { return i4lock( index ) ; }
   int    open( d4Data& data, char *file )  { index = i4open( data.data, file ) ;
                              return data.data->code_base->error_code ; }
   int    reindex()         { return i4reindex( index ) ; }
   T4TAG *tag( char *name ) { return i4tag( index, name ) ; }
   int    unlock()          { return i4unlock( index ) ; }

   I4INDEX *index ;
} ;

class S4CLASS s4Len ;

class S4CLASS s4Str
{
public:
   operator char() ;
   operator double() ;
   operator int() ;
   virtual operator long() ;

   int  operator==( s4Str& ) ;
   int  operator>=( s4Str& ) ;
   int  operator<=( s4Str& ) ;
   int  operator< ( s4Str& ) ;
   int  operator> ( s4Str& ) ;

   int    add( s4Str& ) ;
   int    assign( char *) ;
   int    assign( char *ptr, unsigned ptr_len ) ;
   int    assign( s4Str& from ) ;
   void   assign_double( double, int new_len = -1, int n_dec = -1 ) ;
   void   assign_long( long, int new_len = -1, int zeros_in_front = 0 ) ;
   char  *end_ptr() ;
   int    insert( s4Str&, unsigned pos= 0 ) ;
   void   lower() ;
   unsigned ncpy( char *to_ptr, unsigned to_len ) ;
   int    replace( s4Str&, unsigned pos= 0 ) ;
   void   set( int chr_value ) ;
   void   trim() ;
   void   upper() ;

   int    at( s4Str& ) ;
   s4Len  left( unsigned l ) ;
   s4Len  right( unsigned l ) ;
   s4Len  substr( unsigned pos, unsigned len ) ;
   int    true() ;

   virtual void      changed()          {}
   virtual int       decimals()         { return 0 ; }
   virtual unsigned  len() ;
   virtual unsigned  maximum()          { return len() ; }
   virtual char     *ptr()  = 0 ;
   virtual char     *str() ;
   virtual int       set_len(unsigned)  { return -1 ; }
   virtual int       set_max(unsigned)  { return -1 ; }
} ;

class S4CLASS s4Char : public s4Str
{
public:
   s4Char( char ch ) { c = ch ; }
   char    *ptr()     { return &c ; }
   unsigned len()     { return 1 ; }

private:
   char c ;
} ;

class S4CLASS s4Ptr : public s4Str
{
public:
   s4Ptr( char *ptr )   { p =   ptr ; }
   char *ptr()          { return p ; }
   char *str()          { return p ; }

   char *p ;
} ;

class S4CLASS s4Len : public s4Ptr
{
public:
   s4Len( void *ptr, unsigned ptr_len ) : s4Ptr((char *)ptr)
                   { cur_len =  ptr_len; }
   unsigned len()  { return cur_len ; }

   unsigned cur_len ;
} ;

class S4CLASS s4Max : public s4Len
{
public:
   s4Max( void *ptr, unsigned m ) : s4Len(ptr,m)  { max_len = m; }

   unsigned maximum() { return max_len ; }
   int      set_len( unsigned) ;

   unsigned max_len ;
} ;

class S4CLASS s4Ten : public s4Str
{
public:
   s4Ten()          { cur_len = 0; buf[0] = 0; buf[10] = 0; }
   s4Ten( char *p ) { cur_len = 0; buf[10] = 0; assign(s4Ptr(p)); }

   unsigned maximum()      { return 10 ; }
   unsigned len()          { return cur_len; }
   char    *ptr()          { return buf ; }
   int      set_len(unsigned new_len) ;

private:
   unsigned cur_len ;
   char buf[12] ;
} ;

class S4CLASS s4Large: public s4Str
{
public:
   s4Large()          { cur_len = 0; buf[0] = 0; buf[255] = 0; }
   s4Large( char *p ) { cur_len = 0; buf[255] = 0; assign(s4Ptr(p)); }

   unsigned maximum()     { return 255 ; }
   unsigned len()     { return cur_len; }
   char    *ptr()     { return buf ; }
   int      set_len(unsigned len) ;

private:
   unsigned cur_len ;
   char buf[256] ;
} ;

class S4CLASS s4Flex : public s4Max
{
public:
   s4Flex( c4Code * ) ;
   s4Flex( s4Flex& ) ;
  ~s4Flex() ;

   void *operator new( size_t ) ;
   void operator delete( void * ) ;

   void    free() ;
   int     set_max( unsigned ) ;
   char   *str()        { return ptr() ; }

   c4Code *code_base ;
} ;

class S4CLASS f4Field : public s4Str
{
public:
   f4Field( d4Data& d, int j )      { field =  d4field_j( d.data, j ) ; }
   f4Field( d4Data& d, char *name )  { field =  d4field( d.data, name ) ; }

   void          changed()   { field->data->record_changed = 1 ; }
   d4Data        data() ;
   int           decimals()  { return f4decimals(field) ; }
   unsigned      len()       { return f4len(field) ; }
   char         *name()      { return f4name(field) ; }
   int           type()      { return f4type(field) ; }
   char         *ptr()       { return f4ptr(field) ; }

   F4FIELD    *field ;
} ;

class S4CLASS f4Memo : public f4Field
{
public:
   f4Memo( d4Data& data, int j ) ;
   f4Memo( d4Data& data, char *name ) ;

   void changed() ;
   int  flush() ;
   unsigned len()    { return m4len(field) ; }
   int  set_len(unsigned new_len)   { return m4set_len(field,new_len) ; }

   char *ptr()       { return m4ptr(field) ; }
   char *str()       { return m4str(field) ; }
} ;

class S4CLASS  d4Date : public s4Str
{
public:
   d4Date()              { set( ' ' ) ; dt[8] = 0 ; }
   d4Date( long l )      { a4assign(dt, l) ; dt[8] = 0 ; }
   d4Date( char *p )     { u4ncpy( dt, p, sizeof(dt) ) ; }

   operator long()       { return a4long(dt) ; }

   void   assign(long l) { a4assign(dt,l) ; dt[8] = 0 ; }
   char  *cdow()         { return a4cdow(dt) ; }
   char  *cmonth()       { return a4cmonth(dt) ; }
   int    day()          { return a4day(dt) ; }
   int    dow()          { return a4dow(dt) ; }
   void   format( char *result, char *pict ) { a4format( dt, result, pict ) ; }
   void   init( char *value, char *picture ) { a4init( dt, value, picture ) ; }
   long   julian_day()   { return a4long(dt) ; }
   int    month()        { return a4month(dt) ; }
   void   today()        { a4today(dt) ; }
   int    year()         { return a4year(dt) ; } ;

   unsigned  len()       { return 8 ; }
   char *ptr()           { return dt ; }

private:
   char dt[9] ;
} ;

#define E4PARM_STACK_SIZE 20
#define E4MAX_PARMS 3

extern unsigned e4buf_len ;
extern char    S4PTR *e4buf ;

typedef struct
{
   char    S4PTR *ptr ;
   int      pos, len ;
} S4SCAN ;

typedef struct
{
   char S4PTR *ptr ;
   int   pos, len ;
   int   do_extend ;
   C4CODE S4PTR *code_base ;
} S4STACK ;

typedef struct parse_parm_st
{
   char    S4PTR *ptr ;
   int      type ;
} E4PARSE_PARM ;

typedef struct
{
   unsigned pos ;
   int      type ;
   unsigned len ;
} E4EXPR_PARM ;

typedef struct
{
   E4EXPR_PARM  parms[E4PARM_STACK_SIZE] ;
   int     on_parm ;
   D4DATA S4PTR *data ;
   C4CODE S4PTR *code_base ;
} E4PARMS ;

typedef struct
{
   E4EXPR   expr ;

   S4SCAN   scan ;
   S4STACK  op ;
   S4STACK  result ;
   C4CODE  S4PTR *code_base ;
} E4PARSE ;

typedef struct
{
   int      code ;
   int      name_len ;
   char     name[12] ;
   #ifdef S4UNIX
      void     (S4PTR *function_ptr)() ;
   #else
      void     (S4PTR *function_ptr)(E4PARMS S4PTR *) ;
   #endif
   int      priority ;
   int      return_type ;
   int      num_parms ;
   int      type[E4MAX_PARMS] ;
}  E4FUNCTIONS ;

#define  t4num_str   'n'
#define  t4num_doub  'F'
#define  t4num_bcd   'N'
#define  t4date_doub 'D'
#define  t4date_str  'd'
#define  t4str       'C'
#define  t4log       'L'
#ifdef S4CLIPPER
#define  t4num_clip  'c'
#endif
#ifdef S4FOX
   #define  t4num_fox       'f'
   #define  t4date_fox      'x'
#endif

#define  I4FIELD_STR        0
#define  I4FIELD_LOG        1
#define  I4FIELD_DATE_D     2
#define  I4FIELD_DATE_S     3
#define  I4FIELD_NUM_D      4
#define  I4FIELD_NUM_S      5
#define  I4FIELD_MEMO       6

#define  LAST_I4FIELD       5

#define  I4STRING           6
#define  I4DOUBLE           7

#define  I4LAST_IMMEDIATE   7

#define  E4FIRST_LOG          8
#define  E4LAST_LOG          12

#define  E4FIRST_OPERATOR    13
#define  E4LAST_OPERATOR     48

#define  E4FIRST_FUNCTION    49

extern E4FUNCTIONS  v4functions[] ;

#define E4OPERATOR_LEN  128

#define  Q4NO_FUNCTION  -2
#define  Q4L_BRACKET    -3
#define  Q4R_BRACKET    -4
#define  Q4COMMA        -5

#ifdef __cplusplus
   extern "C" {
#endif

double  S4FUNCTION e4double( E4EXPR S4PTR * ) ;
void    S4FUNCTION e4free( E4EXPR S4PTR * ) ;
int     S4FUNCTION e4key( E4EXPR S4PTR *, char S4PTR ** ) ;
E4EXPR S4PTR *S4FUNCTION e4parse( D4DATA S4PTR *, char S4PTR * ) ;
char S4PTR *  S4FUNCTION e4source( E4EXPR S4PTR * ) ;
int     S4FUNCTION e4true( E4EXPR S4PTR * ) ;
int     S4FUNCTION e4type( E4EXPR S4PTR * ) ;
int        S4FUNCTION e4vary( E4EXPR S4PTR *, char S4PTR ** ) ;

#ifdef __cplusplus
   }
#endif

int    e4field_function( F4FIELD S4PTR *) ;
int    e4get_f_code( E4PARSE S4PTR *, char S4PTR *, E4PARSE_PARM S4PTR * ) ;
int    e4get_operator( E4PARSE S4PTR *, int S4PTR * ) ;
int    e4lookup( char S4PTR *,int,int,int ) ;
int    e4parse_expr( E4PARSE S4PTR * ) ;
int    e4parse_function( E4PARSE S4PTR *, char S4PTR *,int ) ;
int    e4parse_value( E4PARSE S4PTR * ) ;
int    e4type_check( E4PARSE S4PTR * ) ;

char   s4scan_char( S4SCAN S4PTR * ) ;
void   s4scan_init( S4SCAN S4PTR *, char S4PTR * ) ;
char   s4scan_pop( S4SCAN S4PTR *) ;
int    s4scan_search( S4SCAN S4PTR *, char ) ;
int    s4scan_range( S4SCAN S4PTR *, char, char ) ;

int    s4stack_cur( S4STACK S4PTR * ) ;
int    s4stack_pop( S4STACK S4PTR * ) ;
int    s4stack_push_int( S4STACK S4PTR *, int ) ;
int    s4stack_push_str( S4STACK S4PTR *, void S4PTR *, int ) ;

void   e4parms_set( E4PARMS S4PTR *, void S4PTR *, unsigned, int ) ;
void   e4parms_set_logical( E4PARMS S4PTR *, int ) ;
void   e4parms_set_double( E4PARMS S4PTR *, double ) ;
#ifdef S4FOX
   char  S4PTR *e4parms_int_ptr( E4PARMS S4PTR *, int ) ;
#else
   int   S4PTR *e4parms_int_ptr( E4PARMS S4PTR *, int ) ;
#endif
double S4PTR *e4parms_double_ptr( E4PARMS S4PTR *, int ) ;

void   e4parms_init( E4PARMS S4PTR *, D4DATA S4PTR * ) ;
int    e4parms_check( E4PARMS S4PTR * ) ;
int    e4parms_pop( E4PARMS S4PTR *, int ) ;
void   e4parms_pos_align( E4PARMS S4PTR *) ;
void   e4parms_fix_pos( E4PARMS S4PTR * );
int    e4parms_push( E4PARMS S4PTR * ) ;

int    e4parms_space_reserve( E4PARMS S4PTR *, unsigned ) ;

void   e4true_eval(E4PARMS S4PTR *) ;
void   e4false(E4PARMS S4PTR *) ;
void   e4add(E4PARMS S4PTR *) ;
void   e4concatenate(E4PARMS S4PTR *) ;
void   e4sub(E4PARMS S4PTR *) ;
void   e4concat_two(E4PARMS S4PTR *) ;
void   e4multiply(E4PARMS S4PTR *) ;
void   e4divide(E4PARMS S4PTR *) ;
void   e4power(E4PARMS S4PTR *) ;
void   e4not_equal(E4PARMS S4PTR *) ;
void   e4equal(E4PARMS S4PTR *) ;
void   e4greater(E4PARMS S4PTR *) ;
void   e4less(E4PARMS S4PTR *) ;
void   e4greater_eq(E4PARMS S4PTR *) ;
void   e4less_eq(E4PARMS S4PTR *) ;
void   e4not(E4PARMS S4PTR *) ;
void   e4or(E4PARMS S4PTR *) ;
void   e4and(E4PARMS S4PTR *) ;
void   e4ctod(E4PARMS S4PTR *) ;
void   e4dtoc(E4PARMS S4PTR *) ;
void   e4dtos(E4PARMS S4PTR *) ;
void   e4stod(E4PARMS S4PTR *) ;
void   e4date(E4PARMS S4PTR *) ;
void   e4year(E4PARMS S4PTR *) ;
void   e4month(E4PARMS S4PTR *) ;
void   e4day(E4PARMS S4PTR *) ;
void   e4del(E4PARMS S4PTR *) ;
void   e4deleted(E4PARMS S4PTR *) ;
void   e4iif(E4PARMS S4PTR *) ;
void   e4reccount(E4PARMS S4PTR *) ;
void   e4recno(E4PARMS S4PTR *) ;
void   e4str(E4PARMS S4PTR *) ;
void   e4substr(E4PARMS S4PTR *) ;
void   e4time(E4PARMS S4PTR *) ;
void   e4upper(E4PARMS S4PTR *) ;
void   e4val(E4PARMS S4PTR *) ;
void   e4contain(E4PARMS S4PTR *) ;

#ifdef S4CLIPPER
   void e4descend(E4PARMS S4PTR *);
#endif

typedef struct
{
   C4CODE S4PTR *code_base ;
   unsigned char S4PTR *flags ;
   long     num_flags ;
} F4FLAG ;

#ifdef __cplusplus
   extern "C" {
#endif

int  f4flag_init( F4FLAG S4PTR *, C4CODE S4PTR *, long ) ;
int  f4flag_set( F4FLAG S4PTR *, long ) ;
int  f4flag_set_range( F4FLAG S4PTR *, long, long ) ;
int  f4flag_is_set( F4FLAG S4PTR *, long ) ;
int  f4flag_is_all_set( F4FLAG S4PTR *, long, long ) ;
int  f4flag_is_any_set( F4FLAG S4PTR *, long, long ) ;

#ifdef __cplusplus
   }
#endif


#ifdef S4UNIX


#ifdef S4UNIX
   #define S4LOCKING
   #define S4VARARGS
   #define S4PORTABLE
   #define S4DO_ERRNO
   #define S4NO_KBHIT

   #define S4NO_POW
   #define S4NO_SPAWNL
   #define S4NO_STRLWR
   #define S4NO_STRNICMP
   #define S4NO_STRUPR
   #define S4NO_FILELENGTH
   #define S4NO_REMOVE
   #define S4NO_RENAME
#endif

#ifdef S4UNIX
   typedef  void  S4PTR * S4CMP_PARM ;
   extern  long   filelength() ;
   extern  int    atoi() ;
   extern  long   atol() ;
   extern  int    chsize() ;
   extern  int    close() ;
   extern  char  *ecvt() ;
   extern  char  *fcvt() ;
   extern  void   exit() ;
   extern  int    lock() ;
   extern  int    locking() ;
   extern  long   lseek() ;
   extern  void  *malloc() ;
   extern  void  *calloc() ;
   extern  void  *realloc() ;
   extern  void   free() ;
   extern  int    read() ;
   extern  double strtod() ;
   extern  long   time() ;
   extern  int    unlink() ;
   extern  int    write() ;

   #define USHRT_MAX      0xFFFF
   #define INT_MAX        0x7FFF
   #define UINT_MAX       0xFFFF
#endif

#ifdef S4LOCKF
   #define S4LOCKING
#endif

#ifdef S4VARARGS
   #include <varargs.h>
#endif

#ifdef S4NO_SIZE_T
   typedef unsigned size_t ;
#endif

#ifdef S4NO_STRNICMP
   int strnicmp() ;
#endif

#ifdef S4NO_MEMMOVE
   void *memmove() ;
#endif

#endif


typedef struct
{
   char  S4PTR *ptr ;
   unsigned  pos ;
   unsigned  len ;

   long   disk ;

   int    spool_i ;
} S4SPOOL ;

typedef struct
{
   C4CODE S4PTR *code_base ;

   H4FILE        file ;
   char          file_name_buf[14] ;
   H4SEQ_WRITE   seqwrite ;
   char         S4PTR *seqwrite_buffer ;
   S4SPOOL S4PTR *spool_pointer ;
   int      spools_n ;
   int      spools_max ;

   char S4PTR **pointers ;
   int   pointers_i ;
   int   pointers_used ;
   int   pointers_init ;
   int   pointers_max ;

   L4LIST pool ;
   Y4MEMORY_TYPE S4PTR *pool_memory ;
   int    pool_n ;
   int    pool_entries ;

   int    sort_len ;

   long     spool_disk_len ;
   unsigned spool_mem_len ;

   int    info_offset ;
   int    info_len ;
   int    tot_len ;

   long   is_mem_avail ;
   S4CMP_FUNCTION *cmp ;
} S4SORT ;

#ifdef __cplusplus
   extern "C" {
#endif

void  s4quick( void S4PTR **, int, S4CMP_FUNCTION *, int ) ;
void  s4delete_spool_entry( S4SORT S4PTR * ) ;
int   s4flush( S4SORT S4PTR * ) ;
int   s4get_ptr_ptr( S4SORT S4PTR *, char S4PTR ** ) ;
void  s4init_pointers( S4SORT S4PTR *, char S4PTR *, unsigned ) ;
long  s4needed(S4SORT S4PTR *) ;
int   s4next_spool_entry(S4SORT S4PTR *) ;

int   S4FUNCTION s4free( S4SORT S4PTR * ) ;
int   S4FUNCTION s4get( S4SORT S4PTR *,  long S4PTR *, void S4PTR **, void S4PTR ** ) ;
int   S4FUNCTION s4get_init( S4SORT S4PTR * ) ;
int   S4FUNCTION s4init( S4SORT S4PTR *, C4CODE S4PTR *, int, int ) ;
int   S4FUNCTION s4put( S4SORT S4PTR *, long, void S4PTR *, void S4PTR * ) ;

#ifdef __cplusplus
   }
#endif

typedef int S4CALL X4FUNCTION( void S4PTR * ) ;

#ifdef S4DLL
   #define x4init( p1, p2, p3, p4 )    x4init_work( p1, p2, (X4FUNCTION S4PTR *) MakeProcInstance((FARPROC) p3, p2->code_base->hInst), p4 )
#else
   #define x4init( p1, p2, p3, p4 )    x4init_work( p1, p2, p3, p4 )
#endif

typedef struct
{
   D4DATA     S4PTR *data ;
   X4FUNCTION *routine ;
   void       S4PTR *routine_data ;
} X4FILTER ;

#ifdef __cplusplus
   extern "C" {
#endif

int  x4filter_go_eof( X4FILTER S4PTR * ) ;
int  x4find_good( X4FILTER S4PTR *, int) ;
int  x4seek_do( X4FILTER S4PTR *, int ) ;

int  S4FUNCTION x4bottom( X4FILTER S4PTR * ) ;
void S4FUNCTION x4init_work( X4FILTER S4PTR *, D4DATA S4PTR *, X4FUNCTION *, void S4PTR * ) ;
int  S4FUNCTION x4filter_test( X4FILTER S4PTR * ) ;
int  S4FUNCTION x4go( X4FILTER S4PTR *, long ) ;
int  S4FUNCTION x4seek( X4FILTER S4PTR *, char S4PTR * ) ;
int  S4FUNCTION x4seek_double( X4FILTER S4PTR *, double ) ;
int  S4FUNCTION x4skip( X4FILTER S4PTR *, long ) ;
int  S4FUNCTION x4top( X4FILTER S4PTR * ) ;

#ifdef __cplusplus
   }
#endif

#ifndef S4LANGUAGE

   #define  E4_CLOSE         "Unknown Name"
   #define  E4_CREATE_FIL    "File Name:"
   #define  E4_CREATE_TEM    "Temporary Working File"
   #define  E4_CREATE_TOO    "Too Many Fields"
   #define  E4_ERROR         "Error"
   #define  E4_ERROR_NUM     "\r\n\r\nError Number"
   #define  E4_ERROR_SEV     "\r\n\r\nSevere Error Number"
   #define  E4_ERROR_BAS     "CODEBASIC ERROR"
   #define  E4_ERROR_COD     "CODEBASE ERROR"
   #define  E4_ERROR_CDS     "CODEBASE SEVERE ERROR"
   #define  E4_ERROR_ENT     "\r\nPress Enter ..."
   #define  E4_ERROR_KEY     "\r\nPress a key ..."
   #define  E4_INDEX_COR     "Corrupted Free Block Chain in Index File"
   #define  E4_INDEX_EXP     "Expected '.CDX' file is of the '.IDX' type"
   #define  E4_INDEX_FIL     "Filter should be Logical"
   #define  E4_INFO_AME      "A memo block is used twice."
   #define  E4_INFO_CAL      "Call to d4reccount() in r4reindex_blocks_init() failed"
   #define  E4_INFO_CLO      "Error closing group file in i4open()"
   #define  E4_INFO_DAT      "Database is empty."
   #define  E4_INFO_INC      "Incorrect Record Number in tag:"
   #define  E4_INFO_KEY      "Error in Key Evaluation"
   #define  E4_INFO_LOC      "Error locking in i4open()"
   #define  E4_INFO_REA      "Error reading group file in i4open()"
   #define  E4_INFO_REC      "Record is missing."
   #define  E4_INFO_REP      "Repeated Record Number in tag:"
   #define  E4_INFO_SET      "Set C4CODE.auto_open to 'off'"
   #define  E4_INFO_SKI      "Skip must be made from valid record number"
   #define  E4_INFO_TAG      "Tag is corrupted"
   #define  E4_INFO_UNL      "Error unlocking group file in i4open()"
   #define  E4_MEMORY_B      "Block Size too Large for Indexing"
   #define  E4_MEMORY_S      "Sorting"
   #define  E4_NUM_PARMS     "Function"
   #define  E4_RESULT_D4F    "d4flush_record() did not work."
   #define  E4_RESULT_EXP    "Expecting logical result."
   #define  E4_RESULT_IDE    "Identical keys in unique key tag:"
   #define  E4_RESULT_LOS    "Lost Block in Index File"
   #define  E4_RESULT_REC    "Record numbers out of order for equal keys:"
   #define  E4_RESULT_TAG    "Tag is out of date:"
   #define  E4_RESULT_THE    "The tag is out of order:"
   #define  E4_RESULT_UNE    "Unexpected key evaluation length:"
   #define  E4_RESULT_WAS    "Wasted Space in Memo File"
   #define  E4_TYPE_SUB      "Expression:"
   #define  E4_UNIQUE        "Creating Tag"

   #define  E4_DATA_ILL      "Illegal field data."
   #define  E4_DATA_MEM      "Memo File not Open for Append"
   #define  E4_INFO_ALR      "Already initialized"
   #define  E4_INFO_BAD      "Bad NTX Clipper index file"
   #define  E4_INFO_BLO      "Block size is less than 1024 bytes"
   #define  E4_INFO_BLS      "This is unsupported since dBASE IV compatibility requires minimum blocks sizes of 1024 bytes"
   #define  E4_INFO_BMC      "Block/memory corruption"
   #define  E4_INFO_C4C      "'C4CODE.mem_size_block' is an illegal value."
   #define  E4_INFO_COD      "CodeBase internal error"
   #define  E4_INFO_CIF      "Corrupt index file"
   #define  E4_INFO_CIB      "Corrupt index block"
   #define  E4_INFO_CIS      "Corrupt index structure"
   #define  E4_INFO_CMF      "Corrupt memo file"
   #define  E4_INFO_CRL      "Corrupted Linked List"
   #define  E4_INFO_DAO      "Database file already open"
   #define  E4_INFO_DEL      "Deleted block not empty"
   #define  E4_INFO_DUP      "Duplicate Alias"
   #define  E4_INFO_EPV      "Expected value not built"
   #define  E4_INFO_EVA      "Evaluating Tag Expression"
   #define  E4_INFO_EXK      "Expression key is larger than maximum 102 characters"
   #define  E4_INFO_EXP      "Expression too large"
   #define  E4_INFO_FOR      "For tag"
   #define  E4_INFO_ILF      "Illegal file block reference"
   #define  E4_INFO_ILL      "Illegal locking configuration"
   #define  E4_INFO_ILP      "Illegal position"
   #define  E4_INFO_INT      "Internal t4remove_current() failure--index file corrupt"
   #define  E4_INFO_INV      "Invalid key type in index file"
   #define  E4_INFO_IVT      "Invalid type"
   #define  E4_INFO_LIN      "Link not on list"
   #define  E4_INFO_NKE      "n_keys invalid"
   #define  E4_INFO_STR      "Function was Passed an Invalid Structure Pointer"
   #define  E4_INFO_UNE      "Unexpected empty block"
   #define  E4_INFO_UNT      "Unexpected tag locks in index file"
   #define  E4_INFO_WRO      "Wrong number of links in linked list"
   #define  E4_INFO_WT4      "Wrong T4TAG Type"
   #define  E4_MEMORY_ERR    "Memory Error"
   #define  E4_MEMORY_SAV    "l4lock_save(), Saving Lock Information"
   #define  E4_MEMORY_YPO    "y4pop_pointer() with S4DEBUG switch."
   #define  E4_MEMORY_YPU    "y4push_pointer() with S4DEBUG switch."
   #define  E4_OPEN_NOD      "i4open(): No database specified"
   #define  E4_PARM_FLA      "Flag should be 'r4descending'."
   #define  E4_PARM_FOR      "For S4CLIPPER/NDX version, filter and descending should be 0"
   #define  E4_PARM_H4R      "h4read() with negative position"
   #define  E4_PARM_ILP      "Illegal position"
   #define  E4_PARM_IND      "Index file already open"
   #define  E4_PARM_INV      "Invalid lock position"
   #define  E4_PARM_NUL      "Null Data File Pointer"
   #define  E4_PARM_REC      "Record Numbers are not Consecutive"
   #define  E4_PARM_TAG      "Tag expression is missing."
   #define  E4_PARM_TOO      "Too many tags"
   #define  E4_PARM_UNI      "Unique flag data is an unrecognized value."
   #define  E4_PARM_ZER      "Zero parameter"
   #define  E4_RESULT_CLI    "Clipper Key Conversion failed"
   #define  E4_RESULT_COM    "Corrupted Memory Detected"
   #define  E4_RESULT_COR    "Corrupted Index File in Check"
   #define  E4_RESULT_D4A    "d4append_start() was not completed."
   #define  E4_RESULT_D4I    "d4init() has not been called."
   #define  E4_RESULT_EXI    "Exiting from within lock wait"
   #define  E4_RESULT_FRE    "Free value not found"
   #define  E4_RESULT_INC    "Incorrect index file locking order."
   #define  E4_RESULT_INQ    "In quick sort."
   #define  E4_RESULT_LOC    "Locking index could create deadlock."
   #define  E4_RESULT_LCO    "Locking Overlap Detected"
   #define  E4_RESULT_MEM    "Memory items not freed"
   #define  E4_RESULT_REM    "Removing Lock which was never placed."
   #define  E4_RESULT_S4L    "S4LOCK_CHECK cannot be used with 'y4reset'"
   #define  E4_RESULT_STC    "Stack length variable _stklen below minimum."
   #define  E4_RESULT_TOO    "Too many pointers"

   #ifdef S4WINDOWS
      #define E4_RESULT_CRE     "Creating Printer Display Context"
      #define E4_RESULT_DEL     "Deleting Display Context"
      #define E4_RESULT_END     "Ending Document"
      #define E4_RESULT_G4D     "G4DISPLAY buffer missing"
      #define E4_RESULT_G4E     "G4EDIT buffer missing"
      #define E4_RESULT_G4L     "G4LIST buffer missing"
      #define E4_RESULT_ON      "On New Frame"
      #define E4_RESULT_SET     "Setting Font"
      #define E4_RESULT_STA     "Starting Print Document"
      #define E4_MESSAG_EXI     "EXITING APPLICATION"
      #define E4_MESSAG_CAN     "Cancel"
      #define E4_MESSAG_OK      "OK"
      #define E4_MESSAG_PAC     "Are you sure you want to pack ?"
      #define E4_MESSAG_REC     "RECORD NUMBER"
      #define E4_MESSAG_REI     "Are you sure you want to reindex ?"
      #define E4_PARM_ADD       "Choice length must be > 0"
      #define E4_PARM_SA        "Invalid G4DISPLAY Pointer"
      #define E4_PARM_VIS       "WS_VISIBLE Style not Present"
      #define E4_PARM_WIN       "Invalid Window Dimensions"
      #define E4_RESULT_ADD     "Add String Failed"
      #define E4_RESULT_BUF     "G4LIST Buffer Not Big Enough"
      #define E4_RESULT_CDC     "CreateCompatibleDC() Failed"
      #define E4_RESULT_ENW     "EnableWindow() Failed"
      #define E4_RESULT_GDC     "GetDC() Failed"
      #define E4_RESULT_GTM     "GetTextMetrics Failed"
      #define E4_RESULT_ID      "Invalid Id Number"
      #define E4_RESULT_IDB     "Not A G4BUTTON Id Number"
      #define E4_RESULT_IDC     "Not A G4COMBO Id Number"
      #define E4_RESULT_IDD     "Not A G4DISPLAY Id Number"
      #define E4_RESULT_IDL     "Not A G4LIST Id Number"
      #define E4_RESULT_IDT     "Not A G4EDIT Id Number"
      #define E4_RESULT_PIC     "Bad Picture"
      #define E4_RESULT_POS     "Bad Caret Position"
      #define E4_RESULT_RDC     "ReleaseDC() Failed"
      #define E4_RESULT_RES     "FindResource() Failed"
      #define E4_RESULT_TA1     "No WM_TABSTOP Style Present"
      #define E4_RESULT_TA2     "Control Cannot Have The WM_TABSTOP Style"
      #define E4_RESULT_WIN     "CreateWindow() Failed"
   #endif

#else
   #ifdef S4FRENCH

      #define  E4_CLOSE         "Unknown Name"
      #define  E4_CREATE_FIL    "File Name:"
      #define  E4_CREATE_TEM    "Temporary Working File"
      #define  E4_CREATE_TOO    "Too Many Fields"
      #define  E4_ERROR         "Error"
      #define  E4_ERROR_NUM     "\r\n\r\nError Number"
      #define  E4_ERROR_SEV     "\r\n\r\nSevere Error Number"
      #define  E4_ERROR_BAS     "CODEBASIC ERROR"
      #define  E4_ERROR_COD     "CODEBASE ERROR"
      #define  E4_ERROR_CDS     "CODEBASE SEVERE ERROR"
      #define  E4_ERROR_ENT     "\r\nPress Enter ..."
      #define  E4_ERROR_KEY     "\r\nPress a key ..."
      #define  E4_INDEX_COR     "Corrupted Free Block Chain in Index File"
      #define  E4_INDEX_EXP     "Expected '.CDX' file is of the '.IDX' type"
      #define  E4_INDEX_FIL     "Filter should be Logical"
      #define  E4_INFO_AME      "A memo block is used twice."
      #define  E4_INFO_CAL      "Call to d4reccount() in r4reindex_blocks_init() failed"
      #define  E4_INFO_CLO      "Error closing group file in i4open()"
      #define  E4_INFO_DAT      "Database is empty."
      #define  E4_INFO_INC      "Incorrect Record Number in tag:"
      #define  E4_INFO_KEY      "Error in Key Evaluation"
      #define  E4_INFO_LOC      "Error locking in i4open()"
      #define  E4_INFO_REA      "Error reading group file in i4open()"
      #define  E4_INFO_REC      "Record is missing."
      #define  E4_INFO_REP      "Repeated Record Number in tag:"
      #define  E4_INFO_SET      "Set C4CODE.auto_open to 'off'"
      #define  E4_INFO_SKI      "Skip must be made from valid record number"
      #define  E4_INFO_TAG      "Tag is corrupted"
      #define  E4_INFO_UNL      "Error unlocking group file in i4open()"
      #define  E4_MEMORY_B      "Block Size too Large for Indexing"
      #define  E4_MEMORY_S      "Sorting"
      #define  E4_NUM_PARMS     "Function"
      #define  E4_RESULT_D4F    "d4flush_record() did not work."
      #define  E4_RESULT_EXP    "Expecting logical result."
      #define  E4_RESULT_IDE    "Identical keys in unique key tag:"
      #define  E4_RESULT_LOS    "Lost Block in Index File"
      #define  E4_RESULT_REC    "Record numbers out of order for equal keys:"
      #define  E4_RESULT_TAG    "Tag is out of date:"
      #define  E4_RESULT_THE    "The tag is out of order:"
      #define  E4_RESULT_UNE    "Unexpected key evaluation length:"
      #define  E4_RESULT_WAS    "Wasted SPace in Memo File"
      #define  E4_TYPE_SUB      "Expression:"
      #define  E4_UNIQUE        "Creating Tag"

      #define  E4_DATA_ILL      "Illegal field data."
      #define  E4_DATA_MEM      "Memo File not Open for Append"
      #define  E4_INFO_ALR      "Already initialized"
      #define  E4_INFO_BAD      "Bad NTX Clipper index file"
      #define  E4_INFO_BLO      "Block size is less than 1024 bytes"
      #define  E4_INFO_BLS      "This is unsupported since dBASE IV compatibility requires minimum blocks sizes of 1024 bytes"
      #define  E4_INFO_BMC      "Block/memory corruption"
      #define  E4_INFO_C4C      "'C4CODE.mem_size_block' is an illegal value."
      #define  E4_INFO_COD      "CodeBase internal error"
      #define  E4_INFO_CIF      "Corrupt index file"
      #define  E4_INFO_CIB      "Corrupt index block"
      #define  E4_INFO_CIS      "Corrupt index structure"
      #define  E4_INFO_CMF      "Corrupt memo file"
      #define  E4_INFO_CRL      "Corrupted Linked List"
      #define  E4_INFO_DAO      "Database file already open"
      #define  E4_INFO_DEL      "Deleted block not empty"
      #define  E4_INFO_DUP      "Duplicate Alias"
      #define  E4_INFO_EPV      "Expected value not built"
      #define  E4_INFO_EVA      "Evaluating Tag Expression"
      #define  E4_INFO_EXK      "Expression key is larger than maximum 102 characters"
      #define  E4_INFO_EXP      "Expression too large"
      #define  E4_INFO_FOR      "for tag"
      #define  E4_INFO_ILF      "Illegal file block reference"
      #define  E4_INFO_ILL      "Illegal locking configuration"
      #define  E4_INFO_ILP      "Illegal position"
      #define  E4_INFO_INT      "Internal t4remove_current() failure--index file corrupt"
      #define  E4_INFO_INV      "Invalid key type in index file"
      #define  E4_INFO_IVT      "Invalid type"
      #define  E4_INFO_LIN      "Link not on list"
      #define  E4_INFO_NKE      "n_keys invalid"
      #define  E4_INFO_STR      "Function was Passed an Invalid Structure Pointer"
      #define  E4_INFO_UNE      "Unexpected empty block"
      #define  E4_INFO_UNT      "Unexpected tag locks in index file"
      #define  E4_INFO_WRO      "Wrong number of links in linked list"
      #define  E4_INFO_WT4      "Wrong T4TAG Type"
      #define  E4_MEMORY_ERR    "Memory Error"
      #define  E4_MEMORY_SAV    "l4lock_save(), Saving Lock Information"
      #define  E4_MEMORY_YPO    "y4pop_pointer() with S4DEBUG switch."
      #define  E4_MEMORY_YPU    "y4push_pointer() with S4DEBUG switch."
      #define  E4_OPEN_NOD      "i4open(): No database specified"
      #define  E4_PARM_FLA      "Flag should be 'r4descending'."
      #define  E4_PARM_FOR      "For S4CLIPPER/NDX version, filter and descending should be 0"
      #define  E4_PARM_H4R      "h4read() with negative position"
      #define  E4_PARM_ILP      "Illegal position"
      #define  E4_PARM_IND      "Index file already open"
      #define  E4_PARM_INV      "Invalid lock position"
      #define  E4_PARM_NUL      "Null Data File Pointer"
      #define  E4_PARM_REC      "Record Numbers are not Consecutive"
      #define  E4_PARM_TAG      "Tag expression is missing."
      #define  E4_PARM_TOO      "Too many tags"
      #define  E4_PARM_UNI      "Unique flag data is an unrecognized value."
      #define  E4_PARM_ZER      "Zero parameter"
      #define  E4_RESULT_CLI    "Clipper Key Conversion failed"
      #define  E4_RESULT_COM    "Corrupted Memory Detected"
      #define  E4_RESULT_COR    "Corrupted Index File in Check"
      #define  E4_RESULT_D4A    "d4append_start() was not completed."
      #define  E4_RESULT_D4I    "d4init() has not been called."
      #define  E4_RESULT_EXI    "Exiting from within lock wait"
      #define  E4_RESULT_FRE    "Free value not found"
      #define  E4_RESULT_INC    "Incorrect index file locking order."
      #define  E4_RESULT_INQ    "In quick sort."
      #define  E4_RESULT_LOC    "Locking index could create deadlock."
      #define  E4_RESULT_LCO    "Locking Overlap Detected"
      #define  E4_RESULT_MEM    "Memory items not freed"
      #define  E4_RESULT_REM    "Removing Lock which was never placed."
      #define  E4_RESULT_S4L    "S4LOCK_CHECK cannot be used with 'y4reset'"
      #define  E4_RESULT_STC    "Stack length variable _stklen below minimum."
      #define  E4_RESULT_TOO    "Too many pointers"

      #ifdef S4WINDOWS
         #define E4_RESULT_CRE     "Creating Printer Display Context"
         #define E4_RESULT_DEL     "Deleting Display Context"
         #define E4_RESULT_END     "Ending Document"
         #define E4_RESULT_G4D     "G4DISPLAY buffer missing"
         #define E4_RESULT_G4E     "G4EDIT buffer missing"
         #define E4_RESULT_G4L     "G4LIST buffer missing"
         #define E4_RESULT_ON      "On New Frame"
         #define E4_RESULT_SET     "Setting Font"
         #define E4_RESULT_STA     "Starting Print Document"
         #define E4_MESSAG_EXI     "EXITING APPLICATION"
         #define E4_MESSAG_CAN     "Cancel"
         #define E4_MESSAG_OK      "OK"
         #define E4_MESSAG_PAC     "Are you sure you want to pack ?"
         #define E4_MESSAG_REC     "RECORD NUMBER"
         #define E4_MESSAG_REI     "Are you sure you want to reindex ?"
         #define E4_PARM_ADD       "Choice length must be > 0"
         #define E4_PARM_SA        "Invalid G4DISPLAY Pointer"
         #define E4_PARM_VIS       "WS_VISIBLE Style not Present"
         #define E4_PARM_WIN       "Invalid Window Dimensions"
         #define E4_RESULT_ADD     "Add String Failed"
         #define E4_RESULT_BUF     "G4LIST Buffer Not Big Enough"
         #define E4_RESULT_CDC     "CreateCompatibleDC() Failed"
         #define E4_RESULT_ENW     "EnableWindow() Failed"
         #define E4_RESULT_GDC     "GetDC() Failed"
         #define E4_RESULT_GTM     "GetTextMetrics Failed"
         #define E4_RESULT_ID      "Invalid Id Number"
         #define E4_RESULT_IDB     "Not A G4BUTTON Id Number"
         #define E4_RESULT_IDC     "Not A G4COMBO Id Number"
         #define E4_RESULT_IDD     "Not A G4DISPLAY Id Number"
         #define E4_RESULT_IDL     "Not A G4LIST Id Number"
         #define E4_RESULT_IDT     "Not A G4EDIT Id Number"
         #define E4_RESULT_PIC     "Bad Picture"
         #define E4_RESULT_POS     "Bad Caret Position"
         #define E4_RESULT_RDC     "ReleaseDC() Failed"
         #define E4_RESULT_RES     "FindResource() Failed"
         #define E4_RESULT_TA1     "No WM_TABSTOP Style Present"
         #define E4_RESULT_TA2     "Control Cannot Have The WM_TABSTOP Style"
         #define E4_RESULT_WIN     "CreateWindow() Failed"
      #endif

      #define  E4A_GRA   0x85
      #define  E4A_CIR   0x83
      #define  E4A_CI2   0x86
      #define  E4A_TRE   0x84
      #define  E4A_EGU   0xA0
      #define  E4C_CED   0x87
      #define  E4E_EGU   0x82
      #define  E4E_GRA   0x8A
      #define  E4E_CIR   0x88
      #define  E4E_TRE   0x89
      #define  E4I_TRE   0x8B
      #define  E4I_CIR   0x8C
      #define  E4I_EGU   0xA1
      #define  E4I_GRA   0x8D
      #define  E4N_ACC   0xA4
      #define  E4O_CIR   0x93
      #define  E4O_TRE   0x94
      #define  E4O_GRA   0x95
      #define  E4O_EGU   0xA2
      #define  E4U_CIR   0x96
      #define  E4U_GRA   0x97
      #define  E4U_TRE   0x81
      #define  E4U_EGU   0xA3
      #define  E4Y_TRE   0x98
      #define  E4CM_CED  0x80
      #define  E4AM_TRE  0x8E
      #define  E4AM_CIR  0x8F
      #define  E4EM_EGU  0x90
      #define  E4OM_TRE  0x89
      #define  E4UM_TRE  0x9A

   #else
   #ifdef S4GERMAN

      #define  E4_CLOSE            "Unbekannter Name"
      #define  E4_CREATE_FIL       "Dateiname"
      #define  E4_CREATE_TEM       "Zeitweilig arbeitende Datei"
      #define  E4_CREATE_TOO       "Zuviele Felder vorhanden"
      #define  E4_ERROR            "Fehler"
      #define  E4_ERROR_NUM        "\r\n\r\nFehler Nummer"
      #define  E4_ERROR_SEV        "\r\n\r\nSevere Fehler Nummer"
      #define  E4_ERROR_BAS        "CODEBASIC FEHLER"
      #define  E4_ERROR_COD        "CODEBASE FEHLER"
      #define  E4_ERROR_CDS        "CODEBASE SEVERE FEHLER"
      #define  E4_ERROR_ENT        "\r\nPress Enter ..."
      #define  E4_ERROR_KEY        "\r\nPress a key ..."
      #define  E4_INDEX_COR        "Beschdigte freie Blockkette in der Indexdatei"
      #define  E4_INDEX_EXP        "Die erwartete '.CDX' Datei ist vom '.IDX' Typ"
      #define  E4_INDEX_FIL        "Der Filter sollte logisch sein"
      #define  E4_INFO_AME         "Ein Memo Block wurde zweimal gentzt"
      #define  E4_INFO_CAL         "Der Aufruf von d4reccount() in r4reindex_blocks init() ist nicht gelungen"
      #define  E4_INFO_CLO         "Fehler bei Abschlu der Gruppendatei in i4open()"
      #define  E4_INFO_DAT         "Datenbank ist leer"
      #define  E4_INFO_INC         "Fehlerhafte Satznummer in 'Tag'"
      #define  E4_INFO_KEY         "Fehler bei der Schlsselauswertung"
      #define  E4_INFO_LOC         "Fehler beim Locken in i4open()"
      #define  E4_INFO_REA         "Fehler beim Lesen der Gruppendatei in i4open()"
      #define  E4_INFO_REC         "Ein Satz fehlt"
      #define  E4_INFO_REP         "Wiederholte Satznummer in 'Tag'"
      #define  E4_INFO_SET         "C4CODE.auto_open ausschalten"
      #define  E4_INFO_SKI         "Skip must be made from valid record number"
      #define  E4_INFO_TAG         "'Tag' ist beschdigt"
      #define  E4_INFO_UNL         "Fehler bei der Freigabe der Gruppendatei in i4open()"
      #define  E4_MEMORY_B         "Der Block ist zum Indexieren zu umfangreich"
      #define  E4_MEMORY_S         "Sortieren"
      #define  E4_NUM_PARMS        "Funktion"
      #define  E4_RESULT_D4F       "d4flush record() funktionierte nicht"
      #define  E4_RESULT_EXP       "Es werden logische Ergebnisse erwartet"
      #define  E4_RESULT_IDE       "Identische Schlssel in eindeutigem 'Tag'"
      #define  E4_RESULT_LOS       "Block in Indexdatei ging verloren"
      #define  E4_RESULT_REC       "Nummern der Datenstze fr gleiche Schlssel folgen nicht der Reihe nach"
      #define  E4_RESULT_TAG       "'Tag' ist veraltet"
      #define  E4_RESULT_THE       "'Tag' ist nicht in Ordnung"
      #define  E4_RESULT_UNE       "Unerwartete Lnge bei Schlsselauswertung"
      #define  E4_RESULT_WAS       "Raum in der Memo Datei ging verloren"
      #define  E4_TYPE_SUB         "Ausdruck"
      #define  E4_UNIQUE           "'Tag' wird angelegt"

      #define  E4_DATA_ILL         "Nichtzulssige Felddaten"
      #define  E4_DATA_MEM         "Memo Datei fr 'Append' wurde nicht angelegt"
      #define  E4_INFO_ALR         "Wurde bereits initialisiert"
      #define  E4_INFO_BAD         "Defekte NTX Clipper Indexdatei"
      #define  E4_INFO_BLO         "Blockgre betrgt weniger als 1024 Byte"
      #define  E4_INFO_BLS         "Die minimale Blockgre von 1024 Byte bentigt"
      #define  E4_INFO_BMC         "Blockspeicher beschdigt"
      #define  E4_INFO_C4C         "'C4CODE.mem size block' ist ein unzulssiger Wert"
      #define  E4_INFO_COD         "Innerer Fehler in CodeBase"
      #define  E4_INFO_CIF         "Indexdatei ist beschdigt"
      #define  E4_INFO_CIB         "Indexblock ist beschdigt"
      #define  E4_INFO_CIS         "Indexblockstruktur ist beschdigt"
      #define  E4_INFO_CMF         "Speicherdatei ist beschdigt"
      #define  E4_INFO_CRL         "Verkettete Liste ist beschdigt"
      #define  E4_INFO_DAO         "Datenbank-Datei bereits angelegt"
      #define  E4_INFO_DEL         "Der zu lschende Block ist nicht leer"
      #define  E4_INFO_DUP         "Alias ist verdoppelt"
      #define  E4_INFO_EPV         "Erwarteter Wert wurde nicht gebildet"
      #define  E4_INFO_EVA         "'Tag' Ausdruck wird ausgewertet"
      #define  E4_INFO_EXK         "Ausdrucksschlssel berschreitet das maximum von 102 Zeichen"
      #define  E4_INFO_EXP         "Ausdruck ist zu lang"
      #define  E4_INFO_FOR         "fr 'Tag'"
      #define  E4_INFO_ILF         "nichtzulssiger Bezug auf Dateiblock"
      #define  E4_INFO_ILL         "nichtzulssige Konfiguration beim Locken"
      #define  E4_INFO_ILP         "nichtzulssige Position"
      #define  E4_INFO_INT         "innerer Fehler im t4remove_current() Indexdatei beschdigt"
      #define  E4_INFO_INV         "Ungltiger Schlsseltyp in der Indexdatei"
      #define  E4_INFO_IVT         "Ungltiger Typ"
      #define  E4_INFO_LIN         "Linker befindet sich nicht auf der Liste"
      #define  E4_INFO_NKE         "n_Schlssel sind ungltig"
      #define  E4_INFO_STR         "Funktion entdeckte ungltigen Strukturzeiger"
      #define  E4_INFO_UNE         "Unerwarteter leerer Block"
      #define  E4_INFO_UNT         "Unerwartetes Locken des 'Tag' in der Indexdatei"
      #define  E4_INFO_WRO         "Falsche Nummer der Linker auf der verketteten Liste"
      #define  E4_INFO_WT4         "Falscher T4TAG Typ"
      #define  E4_MEMORY_ERR       "Fehler des Speichers"
      #define  E4_MEMORY_SAV       "14lock_save(), Information zum Locken wird gespeichert"
      #define  E4_MEMORY_YPO       "y4pop_pointer() mit S4DEBUG Umschalter"
      #define  E4_MEMORY_YPU       "y4push_pointer() mit S4DEBUG Umschalter"
      #define  E4_OPEN_NOD         "i4open(): keine Datenbank wurde spezifiziert"
      #define  E4_PARM_FLA         "Wert des Flags sollte 'r4descending' sein"
      #define  E4_PARM_FOR         "Fr die Version S4CLIPPER/NDX sollten Filter und Abstieg gleich 0 sein"
      #define  E4_PARM_H4R         "h4read() mit negativer Position"
      #define  E4_PARM_ILP         "nichtzulssige Position"
      #define  E4_PARM_IND         "Indexdatei wurde bereits angelegt"
      #define  E4_PARM_INV         "Ungltige Position beim Locken"
      #define  E4_PARM_NUL         "Nullwertiger Datenbankzeiger"
      #define  E4_PARM_REC         "Nummern der Datenstze befinden sich nicht in der Reihenfolge"
      #define  E4_PARM_TAG         "'Tag' Ausdruck ist nicht vorhanden"
      #define  E4_PARM_TOO         "Zuviele 'Tags' vorhanden"
      #define  E4_PARM_UNI         "Der Wert der eindeutigen Flag Daten wurde nicht erkannt"
      #define  E4_PARM_ZER         "Nullparameter"
      #define  E4_RESULT_CLI       "Schlsselkonvertierung fr CLIPPER konnte nicht vollzogen werden"
      #define  E4_RESULT_COM       "Beschdigter Speicher wurde entdeckt"
      #define  E4_RESULT_COR       "Beschdigte Indexdatei wird geprft"
      #define  E4_RESULT_D4A       "d4append_start() wurde nicht beendet"
      #define  E4_RESULT_D4I       "d4init() wurde nicht aufgerufen"
      #define  E4_RESULT_EXI       "Die Warteposition beim Locken wird verlassen"
      #define  E4_RESULT_FRE       "Freier Wert wurde nicht gefunden"
      #define  E4_RESULT_INC       "Unrichtige Reihenfolge beim Locken der Indexdatei"
      #define  E4_RESULT_INQ       "Schnelle Sortierung"
      #define  E4_RESULT_LOC       "Locken des Indexes knnte einen 'deadlock' bewirken"
      #define  E4_RESULT_LCO       "berlappung beim Locken wurde entdeckt"
      #define  E4_RESULT_MEM       "Speicherplatz wurde nicht freigegeben"
      #define  E4_RESULT_REM       "Ein niemals plazierter Locker wird entfernt"
      #define  E4_RESULT_S4L       "S4LOCK_CHECK kann nicht mit 'y4reset' bentzt werden"
      #define  E4_RESULT_STC       "Die gestapelte Lngenvariable _stklen ist unter dem Minimum"
      #define  E4_RESULT_TOO       "Zuviele Zeiger vorhanden"

      #ifdef S4WINDOWS
         #define E4_RESULT_CRE     "Anlegen eines Drucker Bildschirm Kontextes"
         #define E4_RESULT_DEL     "Lschen eines Bildschirm Kontextes"
         #define E4_RESULT_END     "Ein Dokument wird beendet"
         #define E4_RESULT_G4D     "G4DISPLAY Puffer fehlt"
         #define E4_RESULT_G4E     "G4EDIT Puffer fehlt"
         #define E4_RESULT_G4L     "G4LIST Puffer fehlt"
         #define E4_RESULT_ON      "Im neuen Rahmen"
         #define E4_RESULT_SET     "Ein Font wird definiert"
         #define E4_RESULT_STA     "Drucken eines Dokuments beginnt"
         #define E4_MESSAG_EXI     "APPLIKATION VERLASSEN"
         #define E4_MESSAG_CAN     "Cancel"
         #define E4_MESSAG_OK      "OK"
         #define E4_MESSAG_PAC     "Sind Sie sicher, da Sie packen mchten?"
         #define E4_MESSAG_REC     "SATZNUMMER"
         #define E4_MESSAG_REI     "Sind Sie sicher, da Sie umindexieren mchten?"
         #define E4_PARM_ADD       "Auswahllnge mu > 0 sein"
         #define E4_PARM_SA        "Ungltiger G4DISPLAY Zeiger"
         #define E4_PARM_VIS       "WS_VISIBLE-Modus nicht aktiv"
         #define E4_PARM_WIN       "Invalid Window Dimensions"
         #define E4_RESULT_ADD     "String kann nicht angehngt werden"
         #define E4_RESULT_BUF     "G4LIST-Buffer nicht gro genug"
         #define E4_RESULT_CDC     "CreateCompatibleDC() nicht erfolgreich"
         #define E4_RESULT_ENW     "EnableWindow() nicht erfolgreich"
         #define E4_RESULT_GDC     "GetDC() nicht erfolgreich"
         #define E4_RESULT_GTM     "GetTextMetrics nicht erfolgreich"
         #define E4_RESULT_ID      "Ungltige ID Nummer"
         #define E4_RESULT_IDB     "Keine G4BUTTON ID Nummer"
         #define E4_RESULT_IDC     "Keine G4COMBO ID Nummer"
         #define E4_RESULT_IDD     "Keine G4DISPLAY ID Nummer"
         #define E4_RESULT_IDL     "Keine G4LIST ID Nummer"
         #define E4_RESULT_IDT     "Keine G4EDIT ID Nummer"
         #define E4_RESULT_PIC     "Falsches Eingabeformat"
         #define E4_RESULT_POS     "Falsche Position"
         #define E4_RESULT_RDC     "ReleaseDC() nicht erfolgreich"
         #define E4_RESULT_RES     "FindResource() nicht erfolgreich"
         #define E4_RESULT_TA1     "WM_TABSTOP-Modus nicht aktiv"
         #define E4_RESULT_TA2     "Auswahl darf nicht im WM_TABSTOP-Modus sein"
         #define E4_RESULT_WIN     "CreateWindow() nicht erfolgreich"
      #endif
   #else
        #error No Specific Language Defined.
   #endif
   #endif
#endif


typedef struct
{

   #ifdef S4CLIPPER
      short  *block_index ;
      char   *data;
   #endif

   #ifdef S4FOX
      B4STD_HEADER header ;
   #else
      short  n_keys ;
   #endif

   #ifdef S4MDX
      char   dummy[6] ;
      char   info[2] ;
   #endif

   #ifdef S4NDX
      char   dummy[2] ;
      char   info;
   #endif
} R4BLOCK_DATA ;

typedef struct
{
   #ifndef N4OTHER
      T4TAG S4PTR *tag ;
      I4INDEX      S4PTR *index ;
      int           n_tags ;
   #endif

   #ifdef S4FOX
      char      *cur_pos ;
      B4NODE_HEADER node_hdr ;
      int        n_blocks_used ;
   #else
      #ifdef S4CLIPPER
         B4KEY_DATA *stranded ;
         int  lastblock_inc ;
      #else
         int  lastblock_inc ;
         unsigned  blocklen ;
      #endif
   #endif

   int  grouplen ;
   int  valuelen ;
   int  keysmax ;
   long lastblock ;
   long  key_count ;

   S4SORT        sort ;

   H4SEQ_WRITE   seqwrite ;
   char         S4PTR *buffer ;
   int           buffer_len ;

   R4BLOCK_DATA S4PTR *start_block ;
   int           n_blocks ;
   int           min_keysmax;

   D4DATA       S4PTR *data ;
   C4CODE       S4PTR *code_base ;
} R4REINDEX ;

#ifdef __cplusplus
   extern "C" {
#endif

void r4reindex_free( R4REINDEX S4PTR * ) ;

#ifdef N4OTHER
   int r4reindex_tag_headers_calc( R4REINDEX S4PTR *, T4TAG S4PTR * ) ;
   int r4reindex_supply_keys( R4REINDEX S4PTR *, T4TAG S4PTR * ) ;
   int r4reindex_write_keys( R4REINDEX S4PTR *, T4TAG S4PTR * ) ;
   int r4reindex_tag_headers_write( R4REINDEX S4PTR *, T4TAG S4PTR * ) ;
   int r4reindex_init( R4REINDEX S4PTR *, T4TAG S4PTR * ) ;
#else
   int r4reindex_tag_headers_calc( R4REINDEX S4PTR * ) ;
   int r4reindex_supply_keys( R4REINDEX S4PTR * ) ;
   int r4reindex_write_keys( R4REINDEX S4PTR * ) ;
   int r4reindex_tag_headers_write( R4REINDEX S4PTR * ) ;
   int r4reindex_init( R4REINDEX S4PTR *, I4INDEX S4PTR * ) ;
#endif
int r4reindex_blocks_alloc( R4REINDEX S4PTR * ) ;
T4TAG S4PTR *r4reindex_find_i_tag( R4REINDEX S4PTR *, int ) ;

#ifdef S4FOX
   int r4reindex_add( R4REINDEX S4PTR *, long, char S4PTR *, char S4PTR *, int S4PTR * ) ;
   int r4reindex_finish( R4REINDEX S4PTR *, char S4PTR * ) ;
   int r4reindex_todisk( R4REINDEX S4PTR *, char S4PTR * ) ;
#else
   int r4reindex_add( R4REINDEX S4PTR *, long, char S4PTR * ) ;
   int r4reindex_finish( R4REINDEX S4PTR * ) ;
   #ifdef S4CLIPPER
      int r4reindex_todisk( R4REINDEX S4PTR *, long, char S4PTR * ) ;
   #else
      int r4reindex_todisk( R4REINDEX S4PTR * ) ;
   #endif
#endif

#ifdef __cplusplus
   }
#endif
#endif
