#*******************************************************************
#*
#*    $Workfile:   sv.mk  $
#*
#*    Beschreibung      Ausnahmen fuer die StarView-Projekte
#*
#*    Ersterstellung    TH 28.03.94
#*    Letzte Aenderung  $Author: hr $ $Date: 2000/09/20 14:43:17 $
#*    $Revision: 1.1.1.1 $
#*
#*    $Logfile:   T:/solar/inc/sv.mkv  $
#*
#*    Copyright (c) 1990-1994, STAR DIVISION
#*
#*******************************************************************


# ------------------------------------------------------------------
#	deps auf solver 
# ------------------------------------------------------------------
.IF "$(depsolver)"!=""
MKDEPFLAGS +=$(MKDEPSOLVER)
.ENDIF
# ------------------------------------------------------------------
# DLL-Prefix
# ------------------------------------------------------------------

.IF "$(COM)" == "BLC"

TOOLSDLLPREFIX=tl
SVDLLPREFIX=sv
BROWSERDLLPREFIX=br
MAILDLLPREFIX=ma
SBASICRUNDLLPREFIX=sbr
SBASICDIALOGDLLPREFIX=sbd
SBASICCOMPILERDLLPREFIX=sbc

.ELSE

TOOLSDLLPREFIX=TL
SVDLLPREFIX=SV
BROWSERDLLPREFIX=BR
MAILDLLPREFIX=MA
SBASICRUNDLLPREFIX=SBR
SBASICDIALOGDLLPREFIX=SBD
SBASICCOMPILERDLLPREFIX=SBC

.ENDIF

# ------------------------------------------------------------------
# Ausnahmen MSC
# ------------------------------------------------------------------

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WIN"
.IF "$(PRODUCT)"=="FULL" || "$(PRODUCT)"=="full"
.IF "$(PRJNAME)"=="MAIL"
LINKFLAGS=$(LINKFLAGS)
.ELSE
LINKFLAGS=$(LINKFLAGS) /PACKC:16384 /PACKDATA
.ENDIF
.ENDIF
.IF "$(PRJNAME)" == "TOOLS" || "$(PRJNAME)" == "SV" || "$(PRJNAME)" == "SVTOOLS" || "$(PRJNAME)" == "HM2" || "$(PRJNAME)" == "SFX2" || "$(PRJNAME)" == "SVX"
.IF "$(TARGET)" != "svdem"
.IF "$(TARGET)" != "sfd"

# !!! -GEfs bei MSC nicht in TOOLS, nicht in SV und nicht in den SVTOOLS !!!
CFLAGSOBJGUIST=-Alfd -GA

# !!! Mit /PACKCODE linken
LINKFLAGS=$(LINKFLAGS) /PACKC:8192 /PACKDATA

.ENDIF
.ENDIF
.ENDIF

.IF "$(PRJNAME)"=="SVTOOLS"
LINKFLAGS=$(LINKFLAGS) /PACKC:32768 /PACKDATA
.ENDIF
.ENDIF
.ENDIF

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WNT"
.IF "$(CPU)" == "A" || "$(CPU)"=="P" || "$(CPU)" == "M"
.IF "$(PRJNAME)" == "SV"
.IF "$(TARGET)" == "sv"
LINKFLAGSSHL+= /ENTRY:DLLEntryPoint
.ENDIF
.ENDIF
.ENDIF
.ENDIF
.ENDIF

.IF "$(COM)" == "MSC"
.IF "$(GUI)" == "WNT"
.IF "$(CPU)" == "I"
.IF "$(PRJNAME)" == "SV"
.IF "$(TARGET)" == "sv"
LINKFLAGSSHL+= /ENTRY:DLLEntryPoint@12
.ENDIF
#CFLAGS=$(CFLAGS) -Od
.ENDIF
.IF "$(PRJNAME)"=="TOOLS"
#CFLAGS=$(CFLAGS) -Od
.ENDIF
.ENDIF
.ENDIF
.ENDIF

# ------------------------------------------------------------------
# Ausnahmen STC
# ------------------------------------------------------------------

.IF "$(COM)" == "STC"

# keine Optimierung bei STC (\sv\win\window muss dagegen immer mit Optimierung
# uebersetzt werden)
.IF "$(TARGET)" == "window"
CFLAGSNOOPT=-o+all
.ELSE
CFLAGSOPT=
.ENDIF

# anderen Linker unter Windows (mit unserem Optlink koennen wir linken)
.IF "$(GUI)" == "WIN"
LINK=n:\bin\optlinks\optlinks
.ENDIF

.ENDIF

# ------------------------------------------------------------------
# Ausnahmen Borland
# ------------------------------------------------------------------

# ------------------------------------------------------------------
# Fuer alte Sourcen !!!
# ------------------------------------------------------------------

.IF "$(GUI)" == "WIN"
CDEFS+=-DW30
.ENDIF

.IF "$(GUI)" == "OS2"
CDEFS+=-DPM2 -DPM20
RSCFLAGS+=-DPM2 -DPM20
.ENDIF

.IF "$(COM)" == "BLC"
CDEFS+=-DTCPP
.ENDIF

.IF "$(COM)" == "STC"
CDEFS+=-DZTC
.ENDIF

.IF "$(COM)" == "ICC"
CDEFS+=-DCSET
.ENDIF
