#ifndef _TCOV_HXX
//====================================================================
#define _TCOV_HXX

#if defined(TCOVER) || defined(TCV_CORE)
//=====================================================

#ifndef _SOLAR_H
#include <solar.h>
#endif

class TCovCall
{
	TCovCall		   *pPrevCall;
	USHORT				nModId;
	USHORT				nFuncId;

public:
						TCovCall( USHORT &rMod, const char *pModName, USHORT nFunc );
						~TCovCall();

	TCovCall*			GetCaller() const
						{ return pPrevCall; }
	USHORT				GetModId() const
						{ return nModId; }
	USHORT				GetFuncId() const
						{ return nFuncId; }

	static void 		Base( long nMinCallsPerSlice );
	static void 		Idle();
};

#define TCOV_UNKNOWN				0xFFFF
#define TCOV_MODULE(sModName)		static const char __FAR_DATA sTCovModule[] = sModName; \
									static USHORT	  __FAR_DATA nTCovModule	 = TCOV_UNKNOWN
#define TCOV_CALL(nFuncId)			TCovCall aTCovCall( nTCovModule, sTCovModule, nFuncId )
#define TCOV_BASE(nFuncId, nMinCPS) TCOV_CALL(nFuncId); \
									TCovCall::Base(nMinCPS)
#define TCOV_IDLE(nFuncId)			TCOV_CALL(nFuncId); \
									TCovCall::Idle()

#else
//===================

#define TCOV_MODULE(sModName)
#define TCOV_CALL(nFuncId)
#define TCOV_BASE(nFuncId,nMinCallsPerSlice)
#define TCOV_IDLE(nFuncId)

#endif
//====================================================

#endif
//======================================================================
