/*************************************************************************
 *
 *  $RCSfile: exchange.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:56:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SOT_EXCHANGE_HXX
#define _SOT_EXCHANGE_HXX

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

class SotDataObject;

typedef ULONG SotFormatStringId;

// -------------------------
// - Vordefinierte Formate -
// -------------------------

// Die Reihenfolge und die Werte drfen nicht gendert werden,
// da die Implementation sich darauf verlt.
// Standard-Formate fuer die es auch Copy/Paste-Methoden gibt
#define FORMAT_STRING           1
#define FORMAT_BITMAP           2
#define FORMAT_GDIMETAFILE      3
#define FORMAT_PRIVATE          4
#define FORMAT_FILE             5
#define FORMAT_FILE_LIST        6

// Weitere Standardformate (diese gehen nur ueber CopyData/PasteData)
#define FORMAT_RTF              10

// Source-Options
#define EXCHG_SOURCE_MOVEABLE		((USHORT)0x0001)
#define EXCHG_SOURCE_COPYABLE		((USHORT)0x0002)
#define EXCHG_SOURCE_LINKABLE		((USHORT)0x0004)
#define EXCHG_SOURCE_PRINTABLE		((USHORT)0x0008)
#define EXCHG_SOURCE_DISCARDABLE	((USHORT)0x0010)
#define EXCHG_SOURCE_ALL			((USHORT)0x001F)
#define EXCHG_SOURCE_DEF_COPYABLE	((USHORT)0x0020)

// Aktionen
#define EXCHG_ACTION_MASK						((USHORT)0x00FF)
#define EXCHG_INOUT_ACTION_NONE					((USHORT)0)
#define EXCHG_IN_ACTION_DEFAULT					EXCHG_INOUT_ACTION_NONE
#define EXCHG_IN_ACTION_MOVE					((USHORT)1)
#define EXCHG_IN_ACTION_COPY					((USHORT)2)
#define EXCHG_IN_ACTION_LINK					((USHORT)4)
#define EXCHG_INOUT_ACTION_PRINT				((USHORT)8)
#define EXCHG_INOUT_ACTION_DISCARD				((USHORT)16)
#define EXCHG_OUT_ACTION_INSERT_OBJ     		((USHORT)17)
#define EXCHG_OUT_ACTION_INSERT_BOOKMARK    	((USHORT)18)
#define EXCHG_OUT_ACTION_INSERT_FILELINK    	((USHORT)19)
#define EXCHG_OUT_ACTION_INSERT_FILE			((USHORT)20)
#define EXCHG_OUT_ACTION_INSERT_FILELIST        ((USHORT)21)
#define EXCHG_OUT_ACTION_INSERT_IMAGEMAP        ((USHORT)22)
#define EXCHG_OUT_ACTION_INSERT_OLE	            ((USHORT)23)
#define EXCHG_OUT_ACTION_INSERT_INTERACTIVE     ((USHORT)24)
#define EXCHG_OUT_ACTION_INSERT_URLBUTTON     	((USHORT)25)
#define EXCHG_OUT_ACTION_INSERT_CHAOSOBJ		((USHORT)26) // OBSOLET ab 500.b  ?
#define EXCHG_OUT_ACTION_REPLACE_OBJ 			((USHORT)27)
#define EXCHG_OUT_ACTION_REPLACE_LINK           ((USHORT)28)
#define EXCHG_OUT_ACTION_REPLACE_IMAGEMAP       ((USHORT)29)
#define EXCHG_OUT_ACTION_GET_ATTRIBUTES         ((USHORT)30)
#define EXCHG_OUT_ACTION_UPLOAD   				((USHORT)31)  // OBSOLET ab 500.b ?
#define EXCHG_OUT_ACTION_MOVE_FILE				((USHORT)32)
#define EXCHG_OUT_ACTION_MOVE_FILELIST        	((USHORT)33)
#define EXCHG_OUT_ACTION_UPDATE_RANGE        	((USHORT)34)
#define EXCHG_OUT_ACTION_INSERT_PRIVATE			((USHORT)35)
#define EXCHG_OUT_ACTION_INSERT_HTML			((USHORT)36)
#define EXCHG_OUT_ACTION_MOVE_PRIVATE			((USHORT)37)
#define EXCHG_OUT_ACTION_INSERT_STRING			((USHORT)38)
#define EXCHG_OUT_ACTION_INSERT_DRAWOBJ			((USHORT)39)
#define EXCHG_OUT_ACTION_INSERT_SVXB			((USHORT)40)
#define EXCHG_OUT_ACTION_INSERT_GDIMETAFILE		((USHORT)41)
#define EXCHG_OUT_ACTION_INSERT_BITMAP			((USHORT)42)
#define EXCHG_OUT_ACTION_INSERT_DDE				((USHORT)43)
#define EXCHG_OUT_ACTION_INSERT_HYPERLINK		((USHORT)44)
#define EXCHG_OUT_ACTION_REPLACE_DRAWOBJ      	((USHORT)45)
#define EXCHG_OUT_ACTION_REPLACE_SVXB      		((USHORT)46)
#define EXCHG_OUT_ACTION_REPLACE_GDIMETAFILE    ((USHORT)47)
#define EXCHG_OUT_ACTION_REPLACE_BITMAP    		((USHORT)48)
#define EXCHG_OUT_ACTION_REPLACE_GRAPH			((USHORT)49)
#define EXCHG_OUT_ACTION_INSERT_GRAPH			((USHORT)50)
#define EXCHG_OUT_ACTION_INSERT_MSGATTACH		((USHORT)51)  // obsolet ab 500.b ?
#define EXCHG_OUT_ACTION_COPY_CHAOSOBJ			((USHORT)52)
#define EXCHG_OUT_ACTION_MOVE_CHAOSOBJ			((USHORT)53)
#define EXCHG_OUT_ACTION_COPY_MSGATTACH			((USHORT)54)
#define EXCHG_OUT_ACTION_COPY_BOOKMARK    		((USHORT)55)
#define EXCHG_OUT_ACTION_COPY_FILE				((USHORT)56)

#define EXCHG_OUT_ACTION_FLAG_CREATE_THEME		((USHORT)0x0100)
#define EXCHG_OUT_ACTION_FLAG_KEEP_POSSIZE		((USHORT)0x0200)
#define EXCHG_OUT_ACTION_FLAG_INSERT_IMAGEMAP	((USHORT)0x0400)
#define EXCHG_OUT_ACTION_FLAG_REPLACE_IMAGEMAP	((USHORT)0x0800)
#define EXCHG_OUT_ACTION_FLAG_FILL				((USHORT)0x1000)
#define EXCHG_OUT_ACTION_FLAG_INSERT_TARGETURL	((USHORT)0x2000)

// Ziele
#define EXCHG_DEST_FTP_BOX				1
#define EXCHG_DEST_FTP_FLD              2
#define EXCHG_DEST_FTP_FILE             3
#define EXCHG_DEST_POP3_BOX             4
#define EXCHG_DEST_POP3_MSG             5
#define EXCHG_DEST_VIM_BOX              6
#define EXCHG_DEST_VIM_INBOX            7
#define EXCHG_DEST_VIM_BBFLD            8
#define EXCHG_DEST_VIM_BB               9
#define EXCHG_DEST_VIM_MSG              10
#define EXCHG_DEST_NEWS_BOX             11
#define EXCHG_DEST_NEWS_GROUP           12
#define EXCHG_DEST_NEWS_MSG             13
#define EXCHG_DEST_IMAP_BOX             14
#define EXCHG_DEST_IMAP_INBOX           15
#define EXCHG_DEST_IMAP_FLD             16
#define EXCHG_DEST_IMAP_MSG	            17
#define EXCHG_DEST_OUTTRAY_BOX          18
#define EXCHG_DEST_OUTTRAY_MSG          19
#define EXCHG_DEST_FSYS_BOX             20
#define EXCHG_DEST_FSYS_FLD             21
#define EXCHG_DEST_FSYS_FILE            22
#define EXCHG_DEST_TRASH                23
#define EXCHG_DEST_GAL_BEAMER           24
#define EXCHG_DEST_GAL_THEME            25
#define EXCHG_DEST_GAL_BOX              26
#define EXCHG_DEST_SEARCH_WINDOW        27
#define EXCHG_DEST_SEARCH_BOX           28
#define EXCHG_DEST_SEARCH_FLD           29
#define EXCHG_DEST_HYPERLINKBAR         30
#define EXCHG_DEST_DOC_OLEOBJ           31
#define EXCHG_DEST_CHARTDOC_OLEOBJ      32
#define EXCHG_DEST_DOC_TEXTFRAME        33
#define EXCHG_DEST_DOC_GRAPHOBJ          34
#define EXCHG_DEST_DOC_LNKD_GRAPHOBJ     35
#define EXCHG_DEST_DOC_GRAPH_W_IMAP      36
#define EXCHG_DEST_DOC_LNKD_GRAPH_W_IMAP 37
#define EXCHG_DEST_DOC_IMAPREGION        38
#define EXCHG_DEST_DOC_DRAWOBJ           39
#define EXCHG_DEST_DOC_URLBUTTON         40
#define EXCHG_DEST_DOC_URLFIELD          41
#define EXCHG_DEST_DOC_GROUPOBJ          42
#define EXCHG_DEST_DOC_MAILATTACHFRAME   43
#define EXCHG_DEST_DOC_MAILADDRESSFIELD  44
#define EXCHG_DEST_SWDOC_FREE_AREA       45
#define EXCHG_DEST_SCDOC_FREE_AREA       46
#define EXCHG_DEST_SDDOC_FREE_AREA       47
#define EXCHG_DEST_NAVIGATOR             48
#define EXCHG_DEST_STYLIST               49
#define EXCHG_DEST_SUBSCR_BOX			 50
#define EXCHG_DEST_SUBSCR_BMK			 51
#define EXCHG_DEST_SUBSCR_CDF			 52
#define EXCHG_DEST_SUBSCR_SITECHECKER	 53
#define EXCHG_DEST_SEARCH_LOCATIONS		 54
#define EXCHG_DEST_SEARCH_LOCATIONS_CONTENT		55
#define EXCHG_DEST_DOC_TEXTFRAME_WEB     56
#define EXCHG_DEST_SWDOC_FREE_AREA_WEB   57
#define EXCHG_DEST_SFX_GROUPVIEW		 58



// ------------
// - Exchange -
// ------------

class SotExchange
{
public:
    static ULONG	RegisterFormatName( const String& rName );
    static String   GetFormatName( ULONG nFormat );

	// bestimme die SotFormatStringId von dem registrierten Format
	//JP 12.11.98: diese 3 Methoden sind ab sofort ueberfluessig, da
	//				die ClipboardIds statisch sind und aequivalent zur
	//				SotFormatStringId ist!
    static SotFormatStringId GetFormatStringId( ULONG nFormat )
		{ return nFormat; }
    static SotFormatStringId GetFormatStringId( const String& rName )
		{ return SotExchange::RegisterFormatName( rName ); }
    static ULONG RegisterSotFormatName( SotFormatStringId nId )
		{ return nId; }

	// Anzahl der bereits registrierten Formate bzw. der hoechsten
	// registrierten ID abfragen (fuer System-Registrierung)
	// ACHTUNG: Die Algorithmen zur Registrierung beim System
	// verlassen sich darauf, dass die hier gelieferte maximale
	// Format-ID 'klein' ist, so dass eine Schleife ueber alle
	// Formate laufen kann.
	static ULONG	GetMaxFormat( void );

	// Hilfsfunktion fuer Drag&Drop und Clipboard:
	// Abhaengig von Ziel, Quelle und anwendergewaehltem
	// Einfuege-/Verschiebe-Modus wird eine Aktion und das zu
	// entnehmende Datenformat bestimmt. Die Zuordnung geschieht
	// ueber eine Tabelle, die auf pvcs/data7/doku/soffice/ui/dd_io.sdc
	// eingesehen werden kann.
	// Rueckgabe: Auszufuehrende Aktion (EXCHG_OUT_*,EXCHG_INOUT_*)
	static USHORT 	GetExchangeAction(
		// Clipboard oder Drag&Drop-Daten
		const SotDataObject& rData,
		// Ziel der Aktion (EXCHG_DEST_*)
		USHORT nDestination,
		// Aktionen, die Quelle unterstuetzt (EXCHG_SOURCE_...)
		USHORT nSourceOptions,
		// vom Anwender gewaehlte Aktion (EXCHG_IN_*, EXCHG_INOUT_*)
		USHORT nUserAction,
		// In:- Out: Zu benutzendes Format
		ULONG& rFormat,
		// In:- Out: Default-Action (EXCHG_IN_*, EXCHG_INOUT_*)
		USHORT& rDefaultAction );

};

#endif // _EXCHANGE_HXX
