/*************************************************************************
 *
 *  $RCSfile: appsettings.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/*
#include <usr/reflserv.hxx>
*/

#if defined ( UNX ) || defined( MAC )
#include <limits.h>
#define _MAX_PATH PATH_MAX
#endif

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#include <cppuhelper/typeprovider.hxx>
#ifndef _UNO_MAPPING_HXX_
#include <uno/mapping.hxx>
#endif
#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif
#ifndef _CPPUHELPER_STDIDLCLASS_HXX_
#include <cppuhelper/stdidlclass.hxx>
#endif
#ifndef	_RTL_WSTRING_HXX_
#include <rtl/wstring.hxx>
#endif
#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx>
#endif
#ifndef _VOS_DIAGNOSE_H_
#include <vos/diagnose.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#include <com/sun/star/lang/XTypeProvider.hpp>
#include <com/sun/star/lang/XServiceName.hpp>
#include <com/sun/star/lang/XServiceInfo.hpp>
#include <com/sun/star/registry/XRegistryKey.hpp>
#include <com/sun/star/lang/IllegalArgumentException.hpp>
#include <com/sun/star/container/XEnumerationAccess.hpp>
#include <com/sun/star/container/XHierarchicalNameAccess.hpp>
#include <com/sun/star/container/XNameAccess.hpp>
#include <com/sun/star/container/XContentEnumerationAccess.hpp>
#include <com/sun/star/container/XEnumeration.hpp>
#include <com/sun/star/container/XElementAccess.hpp>
#include <com/sun/star/container/XIndexAccess.hpp>
#include <com/sun/star/container/XContainer.hpp>
#include <com/sun/star/container/XIndexContainer.hpp>
#include <com/sun/star/container/XNameReplace.hpp>
#include <com/sun/star/container/XContainerListener.hpp>
#include <com/sun/star/container/XSet.hpp>
#include <com/sun/star/container/ContainerEvent.hpp>
#include <com/sun/star/container/XIndexReplace.hpp>
#include <com/sun/star/container/XNameContainer.hpp>
#include <com/sun/star/reflection/XIdlClassProvider.hpp>


#include <vos/profile.hxx>
#include <vos/process.hxx>
#include <vos/diagnose.hxx>

#include <tools/fsys.hxx>

using namespace vos;
using namespace rtl;
using namespace osl;
using namespace cppu;
using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace com::sun::star::container;
using namespace com::sun::star::reflection;
using namespace com::sun::star::registry;



class Section_Impl : 
public ::cppu::OWeakObject,
public ::com::sun::star::container::XNameContainer,
public XTypeProvider

{
private:
    OWString aSectionName;
//      OWString aProfileName;

	OProfile * pOProfile;
	Reference<XNameContainer> m_appsettings;

protected:
public:
    Section_Impl(OProfile * pOProfile, const OWString &SectionName, const Reference<XNameContainer> & appsettings);
//      Section_Impl(const OWString &ProfileName, const OWString &SectionName);
    ~Section_Impl();

//    SMART_UNO_DECLARATION(Section_Impl, UsrObject);

    // XInterface -------------------------------------------------------------
 	virtual Any SAL_CALL queryInterface( const Type & aType ) 
						throw( RuntimeException);
    virtual void    SAL_CALL acquire() throw( RuntimeException) 
						{ OWeakObject::acquire(); }
    virtual void	SAL_CALL release() throw( RuntimeException) 
						{ OWeakObject::release(); }


public:
	// XTypeProvider
    virtual Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes(  )
	   throw(RuntimeException);
    virtual Sequence< sal_Int8 > SAL_CALL getImplementationId(  )
	   throw( RuntimeException);

    // XNameContainer ---------------------------------------------------------
    virtual void SAL_CALL insertByName( const OWString& aName, const Any& aElement ) 
			throw( IllegalArgumentException, ElementExistException, WrappedTargetException,
					RuntimeException);
    virtual void SAL_CALL removeByName( const OWString& Name ) 
			throw( NoSuchElementException, WrappedTargetException, RuntimeException);

	//XNameReplace ---------------------------------------------------------------
    virtual void SAL_CALL replaceByName( const OWString& aName, const Any& aElement ) 
			throw( IllegalArgumentException, NoSuchElementException, WrappedTargetException,
				RuntimeException);


    // XNameAccess -----------------------------------------------------------------
    virtual Any SAL_CALL getByName( const OWString& aName ) 
			throw( NoSuchElementException, WrappedTargetException, RuntimeException);
    virtual Sequence< OWString > SAL_CALL getElementNames(  ) 
			throw( RuntimeException);
    virtual sal_Bool SAL_CALL hasByName( const OWString& aName ) 
		throw( RuntimeException);


    // XElementAccess -------------------------------------------------------------
	virtual Type SAL_CALL getElementType(  ) 
			throw( RuntimeException);
	virtual sal_Bool SAL_CALL hasElements(  ) 
			throw( RuntimeException);

};

class ReadOnlyAppSettings_Impl : 
	public com::sun::star::container::XNameContainer,
	public com::sun::star::lang::XServiceInfo,
	public ::cppu::OWeakObject,
	public com::sun::star::lang::XTypeProvider
{
private:
    OWString aProfileName;
    OProfile * pOProfile;
	Reference< XMultiServiceFactory> m_xMultiServiceFactory;

protected:

public:

    ReadOnlyAppSettings_Impl( const Reference< XMultiServiceFactory> & rSMgr );
    ~ReadOnlyAppSettings_Impl();


    // XInterface -------------------------------------------------------
 	virtual Any SAL_CALL queryInterface( const Type & aType ) 
						throw( RuntimeException);
    virtual void    SAL_CALL acquire() throw( RuntimeException) 
						{ OWeakObject::acquire(); }
    virtual void	SAL_CALL release() throw( RuntimeException) 
						{ OWeakObject::release(); }

	// XTypeProvider
    virtual Sequence< ::com::sun::star::uno::Type > SAL_CALL getTypes(  )
	   throw(RuntimeException);
    virtual Sequence< sal_Int8 > SAL_CALL getImplementationId(  )
	   throw( RuntimeException);

    // XServiceInfo -----------------------------------------------------------
	virtual OWString SAL_CALL getImplementationName(  ) 
			throw( RuntimeException);
    virtual sal_Bool SAL_CALL supportsService( const OWString& ServiceName ) 
			throw( RuntimeException);
    virtual Sequence< OWString > SAL_CALL getSupportedServiceNames(  ) 
			throw( RuntimeException);

    
    // XNameContainer ----------------------------------------------------------
    virtual void SAL_CALL insertByName( const OWString& aName, const Any& aElement ) 
			throw( IllegalArgumentException, ElementExistException, WrappedTargetException,
				RuntimeException);
    virtual void SAL_CALL removeByName( const OWString& Name ) 
			throw( NoSuchElementException, WrappedTargetException, RuntimeException);
  
	// XNameReplace -----------------------------------------------------------
    virtual void SAL_CALL replaceByName( const OWString& aName, const Any& aElement ) 
			throw( IllegalArgumentException, NoSuchElementException, WrappedTargetException,
				RuntimeException);


    // XNameAccess - Interface -------------------------------------------------
    virtual Any SAL_CALL getByName( const OWString& aName ) 
			throw( NoSuchElementException, WrappedTargetException, RuntimeException);
    virtual Sequence< OWString > SAL_CALL getElementNames(  ) 
			throw( RuntimeException);
    virtual sal_Bool SAL_CALL hasByName( const OWString& aName ) 
			throw(RuntimeException);


    // XElemenetAccess ----------------------------------------------------------
	virtual Type SAL_CALL getElementType(  ) 
			throw(RuntimeException);
    virtual sal_Bool SAL_CALL hasElements(  ) 
			throw(RuntimeException);


	static OWString              getImplementationName_Static()
                                {
                                    return L"com.sun.star.settings.AppSettings";//stardiv.extensions.AppSettings
                                }
    static Sequence< OWString >  getSupportedServiceNames_Static(void);

};


ReadOnlyAppSettings_Impl * pAppSettings;



//*****************************************************************************

// CLASS Section_Impl IMPLEMENTATION

//*****************************************************************************
//SMART_UNO_IMPLEMENTATION(Section_Impl, UsrObject)

Section_Impl::Section_Impl(OProfile * pOProfile, const OWString &SectionName, const Reference<XNameContainer> & appsettings)
    : aSectionName(SectionName)
    , pOProfile(pOProfile)
	, m_appsettings(appsettings)

{
}

Section_Impl::~Section_Impl()
{
}

// XInterface -----------------------------------------------------------------
Any SAL_CALL Section_Impl::queryInterface( const Type  &aType )
		throw( RuntimeException)

{
	Any a = ::cppu::queryInterface( aType, 
				SAL_STATIC_CAST( XTypeProvider * ,this), 
				SAL_STATIC_CAST( XNameContainer *, this),
				SAL_STATIC_CAST( XNameAccess*, this),
				SAL_STATIC_CAST( XElementAccess*, this),
				SAL_STATIC_CAST( XNameReplace*, this));
	if( a.hasValue())
	{
		return a;
	}
	return OWeakObject::queryInterface( aType );
}

// XTypeProvider
Sequence< Type > SAL_CALL Section_Impl::getTypes(void) throw( RuntimeException )
{
  static OTypeCollection *pCollection = 0;
  if( ! pCollection )
  {
	  MutexGuard guard( Mutex::getGlobalMutex() );
	  if( ! pCollection )
	  {
		  static OTypeCollection collection(
					getCppuType( (Reference< XTypeProvider> * )0),
					getCppuType( (Reference< XNameContainer > * ) 0 ),
					getCppuType( (Reference< XNameAccess > * ) 0 ),
					getCppuType( (Reference< XElementAccess > * ) 0 ),
					getCppuType( (Reference< XNameAccess > * ) 0 ) );
		  pCollection = &collection;
	  }
  }

  return (*pCollection).getTypes();
}


Sequence< sal_Int8 > SAL_CALL Section_Impl::getImplementationId(  ) throw( RuntimeException)
{
  static OImplementationId *pId = 0;
  if( ! pId )
  {
	  MutexGuard guard( Mutex::getGlobalMutex() );
	  if( ! pId )
	  {
		  static OImplementationId id( sal_False );
		  pId = &id;
	  }
  }
  return (*pId).getImplementationId();
}



// XNameContainer --------------------------------------------------------------------
void SAL_CALL Section_Impl::insertByName(const OWString& Name, const Any& Element)
	throw( IllegalArgumentException, ElementExistException, WrappedTargetException,
					RuntimeException)
{
    // not implemented
}

void SAL_CALL Section_Impl::removeByName(const OWString& Name)
			throw( NoSuchElementException, WrappedTargetException, RuntimeException)
{
    // not implemented
}

//XNameReplace ---------------------------------------------------------------
void SAL_CALL Section_Impl::replaceByName(const OWString& Name, const Any& Element)
			throw( IllegalArgumentException, NoSuchElementException, WrappedTargetException,
				RuntimeException)
{
    // not implemented
}


// XNameAccess ---------------------------------------------------------------
Any SAL_CALL Section_Impl::getByName(const OWString& Name)
		throw( NoSuchElementException, WrappedTargetException, RuntimeException)
{
   OString sec = OWStringToOString(Name, RTL_TEXTENCODING_ASCII_US);

    sal_Char * buffer = new sal_Char[1024];

    if (pOProfile->readString(OWStringToOString(aSectionName, RTL_TEXTENCODING_ASCII_US), sec, buffer, 1024, "") )
    {
        if (!buffer)
        {
            throw(NoSuchElementException());
            return Any();
        }
        else
		{
			OWString _s= OWString::createFromAscii( buffer);
            return Any( & _s, getCppuType( (OWString*)0) );
		}
    }
    else
    {
        throw(NoSuchElementException());
        return Any();
    }
}

Sequence< OWString > SAL_CALL Section_Impl::getElementNames(void)
			throw( RuntimeException)
{

//      UINT32 nMaxLen = aProfile.getSections(NULL, NULL, 0);

    sal_uInt32 nMaxLen = pOProfile->getSectionEntries(OWStringToOString(aSectionName, RTL_TEXTENCODING_ASCII_US), NULL, 0);

    sal_Char* buffer = new sal_Char[nMaxLen];
    //nMaxLen = aProfile.getSections(NULL, buffer, nMaxLen);
    nMaxLen = pOProfile->getSectionEntries(OWStringToOString(aSectionName, RTL_TEXTENCODING_ASCII_US), buffer, nMaxLen);

    Sequence<OWString> aSeq( 0 );
    sal_uInt32 nPos = 0;
    for ( sal_uInt32 nCharPos = 0; nCharPos < nMaxLen; )
    {
        OString aStr( buffer+nCharPos );
        nCharPos += aStr.getLength() + 1;

        aSeq.realloc( nPos +1 );
        OWString* pSeq = aSeq.getArray();
        pSeq[nPos++] = OWString::createFromAscii( aStr);
    }

    delete buffer;

    return aSeq;
}

sal_Bool SAL_CALL Section_Impl::hasByName(const OWString& Name) 
		throw( RuntimeException)
{
    OString sec = OWStringToOString(Name, RTL_TEXTENCODING_ASCII_US);

    sal_Char buffer[1024];

    sal_Bool res = pOProfile->readString(OWStringToOString(aSectionName, RTL_TEXTENCODING_ASCII_US), sec, buffer, 1024, "");
    return res && buffer[0];
}

// XElemenetAccess ------------------------------------------------------------
// !!! To be changed later !!!
Type SAL_CALL Section_Impl::getElementType(void)
			throw( RuntimeException)
{
    return Type();
}

sal_Bool SAL_CALL Section_Impl::hasElements(void)
			throw( RuntimeException)
{
    return pOProfile->getSectionEntries(NULL, NULL, 0) > 0;

}


//*****************************************************************************

// CLASS ReadOnlyAppSettings_Impl IMPLEMENTATION

//*****************************************************************************


// XInterface -----------------------------------------------------------------
Any SAL_CALL ReadOnlyAppSettings_Impl::queryInterface( const Type  &aType )
		throw( RuntimeException)

{
	Any a =  cppu::queryInterface( aType,
				SAL_STATIC_CAST( XNameContainer *, this),
				SAL_STATIC_CAST( XNameAccess*, this),
				SAL_STATIC_CAST( XElementAccess*, this),
				SAL_STATIC_CAST( XNameReplace*, this),
				SAL_STATIC_CAST( XTypeProvider*, this));
	if( a.hasValue() )
	{
		return a;
	}
	return OWeakObject::queryInterface( aType );
}


// Sequence< Reference<XIdlClass> > SAL_CALL ReadOnlyAppSettings_Impl::getIdlClasses()
// 		throw( RuntimeException) 
// {
// //    USR_GLOBAL_GUARD();
// //    static Reference<XIdlClass> xClass = createStandardClass( getImplementationName_Static(),
// //                                                OWeakObject::getStaticIdlClass(),
// //                                                2,
// //                                                XNameContainer_getReflection(),
// //                                                XServiceInfo_getReflection()
// //                                                );
// //    Sequence< Reference<XIdlClass> > aSeq(&xClass, 1);
// //    return aSeq;
// 	static WeakReference< XIdlClass >	weakRef;
// 	// try to make weakref hard
// 	Reference< XIdlClass > r = weakRef;

// 	if( ! r.is() ) {		
// 		// xidlclass has not been initialized before or has been destroyed already.
// 		r = createStandardClass( 
// 					m_xMultiServiceFactory,										// Servicemanager
// 					getImplementationName_Static() ,	// ImplementationName
// 					Reference < XIdlClass > () ,					// Base classes
// 					SAL_STATIC_CAST( XIdlClassProvider *, this), 		// Supported Interfaces
// 					SAL_STATIC_CAST( XNameContainer *, this), 		// Supported Interfaces
// 					SAL_STATIC_CAST( XServiceInfo *, this ) );

// 		// store reference for later use
// 		weakRef = r;
// 	}
// 	return Sequence < Reference < XIdlClass > > ( &r , 1 );
// }



// XTypeProvider
Sequence< Type > SAL_CALL ReadOnlyAppSettings_Impl::getTypes(void) throw( RuntimeException )
{
  static OTypeCollection *pCollection = 0;
  if( ! pCollection )
  {
	  MutexGuard guard( Mutex::getGlobalMutex() );
	  if( ! pCollection )
	  {
		  static OTypeCollection collection(
					getCppuType( (Reference< XTypeProvider> * )0),
					getCppuType( (Reference< XNameContainer > * ) 0 ),
					getCppuType( (Reference< XServiceInfo > * ) 0 ) );
		  pCollection = &collection;
	  }
  }

  return (*pCollection).getTypes();
}


Sequence< sal_Int8 > SAL_CALL ReadOnlyAppSettings_Impl::getImplementationId(  )
	 throw( RuntimeException)
{
  static OImplementationId *pId = 0;
  if( ! pId )
  {
	  MutexGuard guard( Mutex::getGlobalMutex() );
	  if( ! pId )
	  {
		  static OImplementationId id( sal_False );
		  pId = &id;
	  }
  }
  return (*pId).getImplementationId();
}


// XServiceInfo
OWString ReadOnlyAppSettings_Impl::getImplementationName() 
     throw (RuntimeException)
{
    return getImplementationName_Static();
}

// XServiceInfo
sal_Bool ReadOnlyAppSettings_Impl::supportsService(const OWString& ServiceName) 
     throw (RuntimeException)
{
    Sequence< OWString > aSNL = getSupportedServiceNames();
    const OWString * pArray = aSNL.getConstArray();

    for( sal_uInt32 i = 0; i < aSNL.getLength(); i++ )
        if( pArray[i] == ServiceName )
            return sal_True;

    return sal_False;
}

// XServiceInfo
Sequence< OWString > ReadOnlyAppSettings_Impl::getSupportedServiceNames(void) 
     throw (RuntimeException)
{
    return getSupportedServiceNames_Static();
}

// getSupportedServiceNames_Static
Sequence< OWString > ReadOnlyAppSettings_Impl::getSupportedServiceNames_Static(void) 
{
    Sequence< OWString > aSNS( 1 );
    aSNS.getArray()[0] = L"com.sun.star.settings.ApplicationSettings";
    return aSNS;
}

ReadOnlyAppSettings_Impl::ReadOnlyAppSettings_Impl( const Reference<XMultiServiceFactory> & rSMgr):
	m_xMultiServiceFactory( rSMgr)
{
    sal_Char    buffer[_MAX_PATH] = "";
//      OProfile::getProfileName( buffer, _MAX_PATH);
	OProfile::getProfileName( buffer, _MAX_PATH, 0, STAROFFICE_SVERSION_KEY );

//  	fprintf(stderr, "#### ReadOnlyAppSettings_Impl::ReadOnlyAppSettings_Impl: %s\n", buffer);
    aProfileName = OWString::createFromAscii( buffer );
	pOProfile = new OProfile();
	pOProfile->open(OWStringToOString(aProfileName, RTL_TEXTENCODING_ASCII_US));
}

ReadOnlyAppSettings_Impl::~ReadOnlyAppSettings_Impl()
{
	delete pOProfile;
}

// XNameContainer --------------------------------------------------------------------
void SAL_CALL ReadOnlyAppSettings_Impl::insertByName(const OWString& Name, const Any& Element)
	throw( IllegalArgumentException, ElementExistException, WrappedTargetException,
					RuntimeException)
{
    // not implemented yet
}

void SAL_CALL ReadOnlyAppSettings_Impl::removeByName(const OWString& Name)
			throw( NoSuchElementException, WrappedTargetException, RuntimeException)
{
    // not implemented yet
}
//XNameReplace ---------------------------------------------------------------
void SAL_CALL ReadOnlyAppSettings_Impl::replaceByName(const OWString& Name, const Any& Element)
			throw( IllegalArgumentException, NoSuchElementException, WrappedTargetException,
				RuntimeException)
{
    // not implemented yet
}


// XNameAccess ----------------------------------------------------------------
Any SAL_CALL ReadOnlyAppSettings_Impl::getByName(const OWString& Name)
		throw( NoSuchElementException, WrappedTargetException, RuntimeException)
{
    OString str = OWStringToOString(Name, RTL_TEXTENCODING_ASCII_US);
    Sequence< OWString > aSeq = getElementNames();
    const OWString * aStr = aSeq.getConstArray();

    for (sal_uInt32 i=0; i<aSeq.getLength(); i++)
    {
        if (aStr[i]==Name)
        {
			Reference<XNameContainer> xref((XNameContainer *) this);
            Section_Impl * section_Impl = new Section_Impl(pOProfile, Name, xref);
            Reference<XNameContainer> ref = section_Impl;

            return Any(&ref, getCppuType( (Reference<XNameContainer>*)0) );
        }
    }

    throw(NoSuchElementException());

    return Any();
}

Sequence< OWString > SAL_CALL ReadOnlyAppSettings_Impl::getElementNames()
			throw( RuntimeException)

{
    sal_uInt32 nMaxLen = pOProfile->getSections(NULL, NULL, 0);

    sal_Char* buffer = new sal_Char[nMaxLen];
    nMaxLen = pOProfile->getSections(NULL, buffer, nMaxLen);


    Sequence<OWString> aSeq( 0 );
    sal_uInt32 nPos = 0;
    for ( sal_Int32 nCharPos = 0; nCharPos < nMaxLen; )
    {
        OString aStr( buffer+nCharPos );
        nCharPos += aStr.getLength() + 1;

        aSeq.realloc( nPos +1 );
        OWString* pSeq = aSeq.getArray();

        pSeq[nPos++] = OWString::createFromAscii( aStr);//OStringToOWString( aStr, CHARSET_SYSTEM );
    }
    delete buffer;
    return aSeq;
}

sal_Bool SAL_CALL ReadOnlyAppSettings_Impl::hasByName(const OWString& Name)
			throw( RuntimeException)
{
    Sequence<OWString> aSeq = getElementNames();

    OWString* pStr = aSeq.getArray();
    sal_uInt32 nCount = aSeq.getLength();

    for (sal_uInt32 n = 0; n < nCount; n++)
    {
        if (pStr[n] == Name)
            return sal_True;
    }

    return sal_False;
}

// XElemenetAccess ------------------------------------------------------------
// !!!To be done later !!!
Type SAL_CALL ReadOnlyAppSettings_Impl::getElementType() 
			throw( RuntimeException)
{
    return Type();
}

sal_Bool SAL_CALL ReadOnlyAppSettings_Impl::hasElements(void) 
			throw( RuntimeException)
{
    return pOProfile->getSections(NULL, NULL, 0) > 0;
}

//***************************************************************************************
//
// Die vorgeschriebene C-Api muss erfuellt werden!
// Sie besteht aus zwei Funktionen, die von dem Modul exportiert werden muessen.
//
static Reference<XInterface> SAL_CALL ReadOnlyAppSettings_Impl_createInstance( const Reference<XMultiServiceFactory> & rMSFactory)
{
    return *new ReadOnlyAppSettings_Impl( rMSFactory);
}


#ifdef __cplusplus
extern "C"
{
#endif

//sal_Bool EXTERN_SERVICE_CALLTYPE exService_writeRegEntry(const UNO_INTERFACE(XRegistryKey)* xUnoKey)
//{
//    Reference<XRegistryKey>     xKey;
//
//    uno2smart(xKey, *xUnoKey);
//
//
//    Reference<XRegistryKey> xNewKey = xKey->createKey(
//        OWString( L"/" ) + ReadOnlyAppSettings_Impl::getImplementationName_Static() + OWString( L"/UNO/SERVICES" ) );
//    Sequence< OWString > aServices = ReadOnlyAppSettings_Impl::getSupportedServiceNames_Static();
//    for( sal_Int32 i = 0; i < aServices.getLen(); i++ )
//        xNewKey->createKey( aServices.getConstArray()[i]);
//
//    return True;
//}

//UNO_INTERFACE(XInterface) EXTERN_SERVICE_CALLTYPE exService_getFactory(const wchar_t* implementationName,
//                                                                       const UNO_INTERFACE(XMultiServiceFactory)* xUnoFact,
//                                                                       const UNO_INTERFACE(XRegistryKey)* xUnoKey)
//{
//    UNO_INTERFACE(XInterface) xUnoRet = {0, 0};
//
//    Reference<XInterface>           xRet;
//    Reference<XMultiServiceFactory> xSMgr;
//    Reference<XRegistryKey>         xKey;
//    OWString                 aImplementationName(implementationName);
//
//    uno2smart(xSMgr, *xUnoFact);
//    uno2smart(xKey, *xUnoKey);
//
//    if (aImplementationName == ReadOnlyAppSettings_Impl::getImplementationName_Static())
//    {
//        try
//        {
//            xRet = createSingleFactory( xSMgr, aImplementationName,
//                                        ReadOnlyAppSettings_Impl_createInstance,
//                                        ReadOnlyAppSettings_Impl::getSupportedServiceNames_Static() );
//        }
//        catch ( Exception& e)
//        {e;
//        }
//    }
//
//    if (xRet.is())
//    {
//        smart2uno(xRet, xUnoRet);
//    }
//
//    return xUnoRet;
//}
extern "C" uno_Interface* SAL_CALL createComponentFactory( const sal_wChar* pImplementationName, 
									    				   uno_Interface* pXUnoSMgr, 
									    				   uno_Interface* pXUnoKey )
{
	uno_Interface* pRet = 0;

	Mapping aUno2Current( UNO_LB_UNO, CPPU_CURRENT_LANGUAGE_BINDING_NAME );
	Mapping aCurrent2Uno( CPPU_CURRENT_LANGUAGE_BINDING_NAME, UNO_LB_UNO );

	if (aUno2Current.is() && aCurrent2Uno.is())
	{
		Reference<XMultiServiceFactory> xSMgr;
		if ( pXUnoSMgr )
		{
			XMultiServiceFactory * pSF = ( XMultiServiceFactory *)aUno2Current.mapInterface(
				pXUnoSMgr, ::getCppuType( (const Reference< XMultiServiceFactory > *)0 ) );
			if (pSF)
			{
				xSMgr = pSF;
				pSF->release();
			}
		}
		
		if ( ReadOnlyAppSettings_Impl::getImplementationName_Static().equals(pImplementationName) )
		{
			Reference<XSingleServiceFactory > xFactory( createSingleFactory(
				xSMgr, pImplementationName, 
				ReadOnlyAppSettings_Impl_createInstance, 
				ReadOnlyAppSettings_Impl::getSupportedServiceNames_Static() ) );
			
			if (xFactory.is())
			{
				pRet = (uno_Interface *)aCurrent2Uno.mapInterface(
					xFactory.get(), ::getCppuType( (const Reference< XSingleServiceFactory > *)0 ) );
			}
		}
	}
	return pRet;
}

extern "C" sal_Bool writeComponentInfo(uno_Interface* pXUnoKey)
{
	sal_Bool	ret = sal_False;

	if (pXUnoKey)
	{
		Mapping aUno2Current( UNO_LB_UNO, CPPU_CURRENT_LANGUAGE_BINDING_NAME );
		if (aUno2Current.is())
		{
			XRegistryKey* pKey = ( XRegistryKey *)aUno2Current.mapInterface(
				pXUnoKey, ::getCppuType( (const Reference< XRegistryKey> *)0 ) );
			if (pKey)
			{
				Reference< XRegistryKey> xKey( pKey );
				pKey->release();
				
				try
				{
					Reference<XRegistryKey> xNewKey = xKey->createKey(
						OWString(L"/") + ReadOnlyAppSettings_Impl::getImplementationName_Static() + ::rtl::OWString(L"/UNO/SERVICES"));
					
					Sequence< OWString > aSNL = ReadOnlyAppSettings_Impl::getSupportedServiceNames_Static();
					const OWString * pArray = aSNL.getArray();
					for( sal_Int32 i = 0; i < aSNL.getLength(); i++ )
					{
						xNewKey->createKey(pArray[i]);
					}
					ret = sal_True;
			
				}catch( InvalidRegistryException& e)
				{ e;
				}
			}
		}
	}
	return ret;
}

#ifdef __cplusplus
} //  END of extern "C"
#endif



