/*************************************************************************
 *
 *  $RCSfile: jre.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <tools/string.hxx>
#ifndef	_RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#if defined( WNT ) || defined( OS2 )
#define RUNTIME_LIB "javai"
#define RUNTIME_LIB_12 "jvm"

#if defined( OS2 ) 
#define RUNTIME_LIB_DEBUG "javai_g"
#else
#define RUNTIME_LIB_DEBUG "javai_g.dll"
#endif
#define ENV_DELIMITER	';'
#define PATH_DELIMITER	'\\'
#elif defined( UNX )
#define RUNTIME_LIB "libjava.so"
#define RUNTIME_LIB_12 "libjvm.so"
#define RUNTIME_LIB_DEBUG "libjava_g.so"
#define ENV_DELIMITER	':'
#define PATH_DELIMITER	'/'
#elif defined( MAC )
#define RUNTIME_LIB "javai"
#define RUNTIME_LIB_12 "jvm"
#define RUNTIME_LIB_DEBUG "javai_g"
#define ENV_DELIMITER	':'
#define PATH_DELIMITER	':'
#else
#define RUNTIME_LIB "javai"
#define RUNTIME_LIB_DEBUG "javai_g"
#define RUNTIME_LIB_12 "jvm"
#define ENV_DELIMITER	':'
#define PATH_DELIMITER	'/'
#endif
#ifndef DEFAULT_DEBUG_PORT
#define DEFAULT_DEBUG_PORT 1600
#endif

#if defined(UNX)
#define TKT_LIB_NAME "libtkt##SUPD##__DLLEXTENSION"
#else
#define TKT_LIB_NAME "tkt##SUPD##__DLLEXTENSION"
#endif

using namespace ::rtl;
/*
 * Java runtime settings.
 */

struct JRESettings 
{
	enum {JRE, JDK, MS_VM};

	sal_Int16 type;				/* type of java : JRE, JDK, Microsoft VM*/	
	OUString	javaHome;			/* Java home directory */
    OUString	runtimeLib;			/* Runtime shared library or DLL */
    OUString	classPath;			/* Default class path */
    OUString	compiler;			/* Just-in-time (JIT) compiler */
    OUString	majorVersion;		/* Major version of runtime */
    OUString	minorVersion;		/* Minor version of runtime */
    OUString	microVersion;		/* Micro version of runtime */
};

int JRE_GetCurrentSettings(JRESettings *set);
int JRE_GetSettings(JRESettings *set, const char *ver);
int JRE_GetDefaultSettings(JRESettings *set);
OString JRE_GetAppHome(); // where is the implementations?
OString JRE_GetDefaultRuntimeLib(const char *dir);// where is the implementations?
OString JRE_GetDefaultClassPath(const char *dir); // where is the implementations?

char *JRE_MakeVersion(const char *major, const char *minor, const char *micro);
void JRE_FatalError(JNIEnv *env, const char *msg);
jint JRE_ParseVersion(const char *ver, char **majorp, char **minorp, char **microp);
void * JRE_Malloc(size_t size);
BOOL JRE_UseVCLToolkit();

int JRE_InitJava();
#define INITJAVA_SUCCESS			 0
#define INITJAVA_JRE_NT_LOCATED		-1
#define INITJAVA_DLL_NT_FOUND		-2
#define INITJAVA_GDF_NT_FOUND		-3
#define INITJAVA_CRT_NT_FOUND		-4
#define INITJAVA_JRE_VERSION		-5
#define INITJAVA_CRT_ERROR			-6
#define INITJAVA_SYS_NT_FOUND		-7
#define INITJAVA_MLL_NT_FOUND		-8
#define INITJAVA_LL_ERROR			-9

class SvCommandList;
void JRE_PropertyChanged( JNIEnv * env, const SvCommandList & rCmdList );

