/*************************************************************************
 *
 *  $RCSfile: settings.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#define VCL_NEED_BASETSD

/*
 * Win32 specific JRE support functions
 */
#ifdef WNT
#include <windows.h>
#endif
#ifndef	_RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef ___JSETTINGS
#include "settings.hxx"
#endif

#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif

#ifdef UNX
#include <limits.h>
#define _MAX_PATH PATH_MAX
#endif

using namespace ::vos;
using namespace ::rtl;

#ifdef UNX
        // must be in the share library path!
OUString JVM_RUNTIME_1_1      = OUString::createFromAscii("libjava.so");
OUString JVM_RUNTIME_1_1_DBG  = OUString::createFromAscii("libjava_g.so");
OUString JVM_RUNTIME_1_2      = OUString::createFromAscii("libjvm.so");
OUString ENV_DEL              = OUString::createFromAscii(":");
OUString PATH_DEL             = OUString::createFromAscii("/");

#elif defined( OS2 )
OUString JVM_RUNTIME_1_1      = OUString::createFromAscii("javai.dll");
OUString JVM_RUNTIME_1_1_DBG  = OUString::createFromAscii("javai_g.dll");
OUString JVM_RUNTIME_1_2      = OUString::createFromAscii("jvm.dll");
OUString ENV_DEL              = OUString::createFromAscii(";");
OUString PATH_DEL             = OUString::createFromAscii("\\");


#elif defined( MAC )
OUString JVM_RUNTIME_1_1      = OUString::createFromAscii(":bin:javai");
OUString JVM_RUNTIME_1_1_DBG  = OUString::createFromAscii(":bin:javai_g");
OUString JVM_RUNTIME_1_2      = OUString::createFromAscii(":bin:jvm");
OUString ENV_DEL              = OUString::createFromAscii(":");
OUString PATH_DEL             = OUString::createFromAscii(":");

#elif defined( WNT )
OUString JVM_RUNTIME_1_1      = OUString::createFromAscii("\\bin\\javai.dll");
OUString JVM_RUNTIME_1_1_DBG  = OUString::createFromAscii("\\bin\\javai_g.dll");
OUString JVM_RUNTIME_1_2      = OUString::createFromAscii("\\bin\\classic\\jvm.dll");
OUString ENV_DEL              = OUString::createFromAscii(";");
OUString PATH_DEL             = OUString::createFromAscii("\\");

#else
#error( "unknown system" )
#endif

OUString LIB            = OUString::createFromAscii("lib");
OUString CLASSES        = OUString::createFromAscii("classes");
OUString CLASSES_JAR    = OUString::createFromAscii("classes.jar");
OUString CLASSES_ZIP    = OUString::createFromAscii("classes.zip");
OUString RT_JAR         = OUString::createFromAscii("rt.jar");
OUString I18N_JAR       = OUString::createFromAscii("i18n.jar");


#if defined(WNT) // || defined(UNX) 
#define JVM_PFAD_ABSOLUT
#endif

JSettings::JSettings()
	: debugEnable(sal_False)
{
}

void JSettings::setRuntimeLib(const OUString & usRuntimeLib)
{
	if(!runtimeLib.len())
	{
		runtimeLib = usRuntimeLib;

		OUString owTmp(runtimeLib);
		sal_Int32 index = owTmp.lastIndexOf(PATH_DEL);

		if(index >= 0)
		{
  			libraryPath = owTmp.copy(0, index + 1);
			runtimeLib = owTmp.copy(index + 1);
		}
	}
}

void JSettings::setCompiler(const OUString & usCompiler)
{
	compiler = usCompiler;
}

const OUString & JSettings::getRuntimeLib()
{
	return runtimeLib;
}


const OUString & JSettings::getLibraryPath() 
{
	return libraryPath;
}

const OUString & JSettings::getCompiler()
{
	return compiler;
}

void JSettings::setDebug(sal_Bool flag) 
{
	debugEnable = flag;
}

void JSettings::setDebugPort(jint jiDebugPort)
{
	if(jiDebugPort)
		this->jiDebugPort = jiDebugPort;
}

sal_Bool JSettings::getDebug() 
{
	return debugEnable;
}


#ifdef WNT
/*
 * Returns string data for the specified registry value name, or
 * NULL if not found.
 */
static OUString GetStringValue( const char * key, const char *name)
{
    OUString aRet;
    HKEY hKey;
    if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, key, 0, KEY_READ, &hKey ) == 0 )
    {
        DWORD type, size;
        OString aValue;

        if (RegQueryValueEx(hKey, name, 0, &type, 0, &size) == 0 && type == REG_SZ )
        {
            unsigned char * value = new unsigned char[size];
            if( RegQueryValueEx( hKey, name, 0, 0, value, &size ) == 0 )
                aRet = OStringToOUString( (const char *)value, RTL_TEXTENCODING_ASCII_US);
            delete value;
        }
        RegCloseKey(hKey);
    }
    return aRet;
}
#endif


sal_Bool GetVmHomeSettings( JSettings & rSettings, const OUString & rJavaHome, const OUString & rVersion, sal_Bool bDebugVM )
{
	if ( bDebugVM && rVersion < OUString::createFromAscii("1.2") )
	{
#ifdef JVM_PFAD_ABSOLUT
		rSettings.setRuntimeLib(rJavaHome + PATH_DEL + JVM_RUNTIME_1_1_DBG );
#else
		rSettings.setRuntimeLib(JVM_RUNTIME_1_1_DBG);
#endif
	}
	else
	{
		if (rVersion < OUString::createFromAscii("1.2") )
		{
#ifdef JVM_PFAD_ABSOLUT
			rSettings.setRuntimeLib(rJavaHome + PATH_DEL + JVM_RUNTIME_1_1);
#else
			rSettings.setRuntimeLib( JVM_RUNTIME_1_1 );
#endif
		}
		else
		{
#ifdef JVM_PFAD_ABSOLUT
				rSettings.setRuntimeLib(rJavaHome + PATH_DEL + JVM_RUNTIME_1_2);
#else
				rSettings.setRuntimeLib(JVM_RUNTIME_1_2);
#endif
		}
	}

    rSettings.javaHome = rJavaHome;

//      fprintf(stderr, "#### GetVmHomeSettings: home - %s\n", OUStringToString(rJavaHome, CHARSET_SYSTEM).GetStr());

//      fprintf(stderr, "#### GetVmHomeSettings: %s\n", OUStringToString(rSettings.runtimeLib, CHARSET_SYSTEM).GetStr());
                         // Get default class path
    OUString aClassPath = rJavaHome + PATH_DEL + LIB + PATH_DEL + RT_JAR + ENV_DEL;
    aClassPath = aClassPath + rJavaHome + PATH_DEL + LIB + PATH_DEL + I18N_JAR + ENV_DEL;
    aClassPath = aClassPath + rJavaHome + PATH_DEL + LIB + PATH_DEL + CLASSES_ZIP + ENV_DEL;
    aClassPath = aClassPath + rJavaHome + PATH_DEL + CLASSES + ENV_DEL;

    // Application home
/*
    char buf[_MAX_PATH];
    
    
    if( OStartupInfo::E_None != OStartupInfo().getExecutableFile(buf, _MAX_PATH ) )
        return sal_False;
    OString aPath = buf;
    sal_uInt16 nPos = aPath.getLength();
    if( nPos )
    {
        while( nPos-- && aPath[nPos] != PATH_DEL[0] )
            ;
#ifdef UNX
        // cut /bin too
        while( nPos-- && aPath[nPos] != PATH_DEL[0] )
            ;
#endif
//        aPath.Erase( nPos );
		  aPath= aPath.copy( 0, nPos +1 );
    }
*/
//      UString aAppHome = StringToOUString( aPath, CHARSET_SYSTEM );
//      aClassPath = aClassPath + aAppHome + PATH_DEL L"lib" PATH_DEL L"classes.jar" ENV_DEL;
//      aClassPath = aClassPath + aAppHome + PATH_DEL L"lib" PATH_DEL L"tkt.jar" ENV_DEL;
//      aClassPath = aClassPath + aAppHome + PATH_DEL L"lib" PATH_DEL L"sandbox.jar";

    // append classpath
    const char * pClassPath = getenv("CLASSPATH");
    if ( pClassPath )
    {
        aClassPath = aClassPath + ENV_DEL;
        aClassPath = aClassPath + OUString::createFromAscii( pClassPath );
    }

    rSettings.classPath = aClassPath;

    return sal_True;
}

sal_Bool GetVmNameSettings( JSettings & rSettings, const OUString & rJavaVmName, const OUString & rVersion, sal_Bool bDebugVM )
{
#ifdef WNT
    OString aKey = "Software\\JavaSoft\\";
    aKey += OUStringToOString( rJavaVmName, RTL_TEXTENCODING_ASCII_US);
    OString aVersion( OUStringToOString( rVersion, RTL_TEXTENCODING_ASCII_US) );
    // remove micro version
    aKey +=  "\\";
    aKey += aVersion.getToken( 0, '.' );
    aKey += ".";
    aKey += aVersion.getToken( 1, '.' );

    /* Full path name of JRE home directory (required) */
    OUString aJavaHome = GetStringValue( aKey, "JavaHome" );
	if( aJavaHome.len() )
	{
		if( GetVmHomeSettings( rSettings, aJavaHome, rVersion, bDebugVM ) )
		{
		    /* Full path name of JRE runtime DLL */
			OUString aRuntime = GetStringValue( aKey, "RuntimeLib" );
			if( aRuntime.getLength() )
				rSettings.setRuntimeLib(aRuntime);

			/* Class path setting to override default */
			OUString aClassPath = GetStringValue( aKey, "ClassPath" );
			if( aClassPath.getLength() )
				rSettings.classPath = aClassPath;

			/* Optional JIT compiler library name */
			OUString aCompiler = GetStringValue( aKey, "Compiler" );
			if( aCompiler.getLength() )
				rSettings.setCompiler(aCompiler);

			/* Release micro-version */
			OUString aMicroVersion = GetStringValue( aKey, "MicroVersion" );
			if( aMicroVersion.len() )
				rSettings.version = OStringToOUString( aVersion, RTL_TEXTENCODING_ASCII_US)
				+ OUString::createFromAscii(".") + aMicroVersion;
			return sal_True;
		}
	}
	else
	{
		HKEY hKey;

		aKey = "Software\\Microsoft\\";
		aKey += OUStringToOString( rJavaVmName, RTL_TEXTENCODING_ASCII_US );
		if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, aKey, 0, KEY_READ, &hKey) == 0)
		{
			rSettings.classPath = OUString();
			OUString & aClassPath = rSettings.classPath;
			OUString aValue = GetStringValue( aKey, "Classpath" );
			if( aValue.getLength() )
			{
				aClassPath = aClassPath + aValue;
				aClassPath = aClassPath + OUString::createFromAscii(";");
			}
			aValue = GetStringValue( aKey, "LibsDirectory" );
			if( aValue.getLength() )
			{
				aClassPath = aClassPath + aValue;
				aClassPath = aClassPath + OUString::createFromAscii(";");
			}
			aValue = GetStringValue( aKey, "TrustedClasspath" );
			if( aValue.getLength() )
			{
				aClassPath = aClassPath + aValue;
				aClassPath = aClassPath + OUString::createFromAscii(";");
			}
			aValue = GetStringValue( aKey, "TrustedLibsDirectory" );
			if( aValue.getLength() )
			{
				aClassPath = aClassPath + aValue;
				aClassPath = aClassPath + OUString::createFromAscii(";");
			}

			rSettings.setRuntimeLib( OUString::createFromAscii("msjava.dll") );
			RegCloseKey(hKey);
			return sal_True;
		}
	}
#endif
    return sal_False;
}

sal_Bool GetDefaultSettings( JSettings & rSettings, OUString aVersion, sal_Bool bDebugVM )
{
#ifdef WNT
	if( !aVersion.len() )
	{
		aVersion = GetStringValue( "Software\\JavaSoft\\Java Runtime Environment", "CurrentVersion" );
		if( aVersion.getLength() )
			return GetVmNameSettings( rSettings, OUString::createFromAscii("Java Runtime Environment"), aVersion, bDebugVM );

		aVersion = GetStringValue( "Software\\JavaSoft\\Java Development Kit", "CurrentVersion" );
		if( aVersion.getLength() )
			return GetVmNameSettings( rSettings, OUString::createFromAscii("Java Development Kit"), aVersion, bDebugVM );

		HKEY hKey;
		if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Java VM\\Security", 0, KEY_READ, &hKey) == 0)
		{
			RegCloseKey(hKey);
			return GetVmNameSettings( rSettings, OUString::createFromAscii("Java VM"), aVersion, bDebugVM );
		}
	}
#endif

    /* Full path name of JRE home directory (required) */
    const char * pJavaHome = getenv( "JAVA_HOME" );
    if ( pJavaHome )
    {
        if ( GetVmHomeSettings( rSettings, OStringToOUString( pJavaHome, RTL_TEXTENCODING_ASCII_US), aVersion, bDebugVM ) )
        {
            const char * pCompiler = getenv("JAVA_COMPILER");
            if( pCompiler )
                rSettings.setCompiler(OStringToOUString(pCompiler, RTL_TEXTENCODING_ASCII_US));
            return sal_True;
        }
    }

    OUString aJavaHome;
#if defined( OS2 )
    // set JAVA_HOME to the (heavy hack)
    char szBuffer[_MAX_PATH];
    szBuffer[0] = '0';
    OProcess::searchPath( "java.exe", szBuffer, sizeof( szBuffer ) );
    OString aPath = szBuffer;
    sal_Int16 nPos = aPath.getLenght();
    if( !nPos )
        return sal_False;
    while( nPos-- && aPath[nPos] != PATH_DEL[0] )
        ;
    aPath.Erase( nPos );
    aJavaHome = OStringToOUString( aPath, RTL_TEXTENCODING_ASCII_US);
#else
	OUString aExecFile;

    if( OStartupInfo::E_None != OStartupInfo().getExecutableFile(aExecFile) )
        return sal_False;

    OUString aPath = aExecFile;
    sal_uInt16 nPos = aPath.getLength();
    if( !nPos )
        return sal_False;
    // cut application name
    while ( nPos-- && aPath[nPos] != PATH_DEL[0] )
        ;
#ifdef UNX
    // cut /bin too
    while ( nPos-- && aPath[nPos] != PATH_DEL[0] )
        ;
#endif
//    aPath.Erase( nPos );
	aJavaHome = aPath.copy( 0, nPos+1);
#endif

    return GetVmHomeSettings( rSettings, aJavaHome, aVersion, bDebugVM );
}

