/*************************************************************************
 *
 *  $RCSfile: settings.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef ___JSETTINGS
#define ___JSETTINGS

#ifndef	_RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#include <jni.h>

extern ::rtl::OUString ENV_DEL;
extern ::rtl::OUString PATH_DEL;

struct JSettings
{
private:
    ::rtl::OUString runtimeLib;         /* Runtime shared library or DLL */
	::rtl::OUString libraryPath;        /* Java Library Path */
	sal_Bool debugEnable;
	jint jiDebugPort;
    ::rtl::OUString compiler;           /* Just-in-time (JIT) compiler */

public:
	JSettings();

	void setRuntimeLib(const ::rtl::OUString & usRuntimeLib);
	void setLibraryPath(const ::rtl::OUString & usLibraryPath);
	void setCompiler(const ::rtl::OUString & usCompiler);
	void setDebug(sal_Bool flag);
	void setDebugPort(jint jiDebugPort);

	const ::rtl::OUString & getRuntimeLib();
	const ::rtl::OUString & getLibraryPath();
	const ::rtl::OUString & getCompiler();
	sal_Bool getDebug();
	jint getDebugPort();

    ::rtl::OUString javaHome;           /* Java home directory */
    ::rtl::OUString classPath;          /* Default class path */
    ::rtl::OUString version;            /* Major version of runtime */
};

/*
 * Java runtime settings.
 */
sal_Bool GetVmHomeSettings( JSettings & rSettings, 
                            const ::rtl::OUString & rJavaHome, 
                            const ::rtl::OUString & rVersion, 
                            sal_Bool bDebugVM );
                            
sal_Bool GetVmNameSettings( JSettings & rSettings, 
                            const ::rtl::OUString & rJavaVmName, 
                            const ::rtl::OUString & rVersion, 
                            sal_Bool bDebugVM );
                            
sal_Bool GetDefaultSettings( JSettings & rSettings, 
                             ::rtl::OUString aVersion, 
                             sal_Bool bDebugVM );


#endif
