/*************************************************************************
 *
 *  $RCSfile: testexe.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 15:29:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <assert.h>

#include <osl/mutex.hxx>
#include <osl/conditn.h>

#include <vos/thread.hxx>
#include <vos/socket.hxx>

#include <cppuhelper/servicefactory.hxx>
#include <cppuhelper/implbase1.hxx>

#include <com/sun/star/connection/XConnector.hpp>
#include <com/sun/star/connection/XConnection.hpp>

#include <com/sun/star/registry/XImplementationRegistration.hpp>
#include <com/sun/star/bridge/XInstanceProvider.hpp>
#include <com/sun/star/bridge/XBridgeFactory.hpp>

#include <com/sun/star/lang/XComponent.hpp>
#include <com/sun/star/lang/XInitialization.hpp>

#include <osl/conditn.h>

#include <vos/channel.hxx>
#include <vos/process.hxx>

using namespace ::vos;
using namespace ::rtl;
using namespace ::cppu;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::bridge;
using namespace ::com::sun::star::registry;
using namespace ::com::sun::star::connection;


oslCondition g_myCondition;

class OInstanceProvider :
	public ::cppu::OWeakObject,
	public XInstanceProvider
{
public:
	OInstanceProvider( const Reference < XMultiServiceFactory  > & rSMgr  ) :
		m_rSMgr( rSMgr )
		{}
public:	
	// XInterface
	Any	        SAL_CALL queryInterface( const Type & aType);
	void 		SAL_CALL acquire() 						 { OWeakObject::acquire(); }
	void 		SAL_CALL release() 						 { OWeakObject::release(); }
	
public:
	// XConnectCallback
    virtual ::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > SAL_CALL
	       getInstance( const ::rtl::OUString& sObjectName )
		         throw( ::com::sun::star::container::NoSuchElementException,
			            ::com::sun::star::uno::RuntimeException);

	Reference < XMultiServiceFactory > m_rSMgr;
};

Any OInstanceProvider::queryInterface( const  Type & aType )
{
	Any a = ::cppu::queryInterface( aType , 
			SAL_STATIC_CAST( XInstanceProvider * , this ) );
	if( a.hasValue() )
	{
	    return a;
	}
	return OWeakObject::queryInterface( aType );
}

::com::sun::star::uno::Reference< ::com::sun::star::uno::XInterface > 
	OInstanceProvider::getInstance( const ::rtl::OUString& sObjectName )
		throw(::com::sun::star::container::NoSuchElementException,
			  ::com::sun::star::uno::RuntimeException)
{
//	return Reference < XInterface > ( (::cppu::OWeakObject * ) new OTestFactory() );
	osl_setCondition( g_myCondition );
	return Reference < XInterface > ( m_rSMgr , UNO_QUERY );
	// authentification successfull !
//	return Reference < XInterface > ();
}



Reference <XInterface > createComponent( const ::rtl::OUString &sService,
										 const ::rtl::OUString &sDllName,
										 const Reference < XMultiServiceFactory > &rSMgr )
{
	Reference< XInterface > rInterface;
	rInterface = rSMgr->createInstance( sService );

	if( ! rInterface.is() )
	{
		// erst registrieren
		Reference < XImplementationRegistration > rReg (
			rSMgr->createInstance(
				OUString::createFromAscii( "com.sun.star.registry.ImplementationRegistration" )),
			UNO_QUERY );
		
		assert( rReg.is() );
#ifdef SAL_W32
		OUString aDllName = sDllName;
#else
		OUString aDllName = L"lib";
		aDllName += sDllName;
		aDllName += L".so";
#endif

		try
		{
			rReg->registerImplementation(
				OUString::createFromAscii( "com.sun.star.loader.SharedLibrary" ),
				aDllName,
				Reference< XSimpleRegistry > () );
			rInterface = rSMgr->createInstance( sService );
		}
		catch( Exception & ) 
		{
			printf( "couldn't register dll %s\n" ,
					OUStringToOString( aDllName, RTL_TEXTENCODING_ASCII_US ).getStr()  );
		}		
	}
	return rInterface;
}

#ifdef SOLARIS
extern "C" void ChangeGlobalInit();
#endif

void main()
{
#ifdef SOLARIS
	ChangeGlobalInit();
#endif

	g_myCondition = osl_createCondition();
	
	
	ORef< OChannel > channel;

	{
		ORef< OChannelBroker > broker = OChannelBroker::getGlobalChannelBroker();
		printf( "before accept\n" );
		if( OChannelBroker::NoError == broker->accept( channel , OString ( "blubber" ) , 0 , 0 ) )
		{
		}
		else
		{
			OSL_ENSHURE( 0 , "resource couldn't be transmitted\n" );
			exit(1);
		}
	}

	
	Reference< XMultiServiceFactory > rSMgr = createRegistryServiceFactory( "exe.rdb" );
	
	Reference < XConnector > rConnector(
		createComponent( L"com.sun.star.connection.Connector",
						 L"connectr",
						 rSMgr ),
		UNO_QUERY );

	try
	{
		OString sParameter( "channel:" );
		sParameter += OString::valueOf( ( sal_Int64 ) &channel , 10 );
		
		Reference < XConnection > rConnection =
			rConnector->connect( OStringToOUString( sParameter , RTL_TEXTENCODING_ASCII_US )  );
		
		// just ensure that it is registered
		createComponent( L"com.sun.star.bridge.Bridge.iiop",
						 L"iiopbrdg",
						 rSMgr );
		
		Reference < XBridgeFactory > rFactory(
			createComponent( L"com.sun.star.bridge.BridgeFactory",
							 L"brdgfctr",
							 rSMgr ),
			UNO_QUERY );
		
		if( rFactory.is() )
		{
			
			Reference < XBridge > rBridge = rFactory->createBridge(
				L"bla blub",
				L"iiop",
				rConnection,
				Reference < XInstanceProvider > ( new OInstanceProvider( rSMgr ) ) );
			
			osl_waitCondition( g_myCondition , 0 );

			TimeValue value = {10,0};
			osl_waitThread( &value );
		}
	}
	catch( Exception & )
	{
		printf( "Login failed, got an Exception !\n" );
	}		

	OSL_ENSHURE( 0 , "Leaving testexe\n" );
	osl_destroyCondition( g_myCondition );

}
