/*************************************************************************
 *
 *  $RCSfile: cntcmpmn.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _CNTCMPMN_HXX
#define _CNTCMPMN_HXX

#ifndef _CHAOS_RESOURCE

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#include "poolitem.hxx"

#ifndef _SVARRAY_HXX
#include "svarray.hxx"
#endif

class SvStream;
class CntCmpMenuEntry;
class CntCmpMenu_Impl;

#endif	// _CHAOS_RESOURCE

#define MID_COMPONENT_ENTRIES_START		1000
#define MID_COMPONENT_ENTRIES_END		1100
#define MENUPART_OPEN_OBJECT_BEGIN		MID_COMPONENT_ENTRIES_START
#define MENUPART_OPEN_OBJECT_END		MID_COMPONENT_ENTRIES_START+1
#define MENUPART_GLOBAL_PROPS_BEGIN		MID_COMPONENT_ENTRIES_START+2
#define MENUPART_GLOBAL_PROPS_END		MID_COMPONENT_ENTRIES_START+3
#define MENUPART_CREATE_OBJECT_BEGIN 	MID_COMPONENT_ENTRIES_START+4
#define MENUPART_CREATE_OBJECT_END		MID_COMPONENT_ENTRIES_START+5
#define MENUPART_OBJECT_ACTION_BEGIN	MID_COMPONENT_ENTRIES_START+6
#define MENUPART_OBJECT_ACTION_END		MID_COMPONENT_ENTRIES_START+7
#define MENUPART_FOLDER_PROPS_BEGIN		MID_COMPONENT_ENTRIES_START+8
#define MENUPART_FOLDER_PROPS_END		MID_COMPONENT_ENTRIES_START+9
#define MENUPART_OBJECT_REPLYTO_BEGIN	MID_COMPONENT_ENTRIES_START+10
#define MENUPART_OBJECT_REPLYTO_END 	MID_COMPONENT_ENTRIES_START+11
#define MENUPART_FOLDER_RULES_BEGIN		MID_COMPONENT_ENTRIES_START+12
#define MENUPART_FOLDER_RULES_END		MID_COMPONENT_ENTRIES_START+13
#define MENUPART_MULTI_OBJ_PROPS_BEGIN	MID_COMPONENT_ENTRIES_START+14
#define MENUPART_MULTI_OBJ_PROPS_END	MID_COMPONENT_ENTRIES_START+15
#define MENUPART_OBJECT_PROPS_BEGIN		MID_COMPONENT_ENTRIES_START+16
#define MENUPART_OBJECT_PROPS_END		MID_COMPONENT_ENTRIES_START+17
#define MENUPART_EDIT_PROPS_BEGIN		MID_COMPONENT_ENTRIES_START+18

/* string defines of known verbs */
#define SVT_MENUPART_VERB_CUT        "cut"
#define SVT_MENUPART_VERB_COPY       "copy"
#define SVT_MENUPART_VERB_PASTE      "paste"
#define SVT_MENUPART_VERB_OPEN       "open"
#define SVT_MENUPART_VERB_RENAME     "rename"
#define SVT_MENUPART_VERB_PROPERTIES "properties"

#ifndef _CHAOS_RESOURCE

#define CNT_COMPMENU_CHECKED		0x0001
#define CNT_COMPMENU_RADIOCHECKED	0x0002
#define CNT_COMPMENU_SEPARATOR		0x0004
#define CNT_COMPMENU_DISABLED		0x0008


DBG_NAMEEX(CntComponentMenuItem);


class CntCmpMenu : public SvPtrarr
{
public:
							CntCmpMenu() : SvPtrarr() {}
							CntCmpMenu( const CntCmpMenu& );
							~CntCmpMenu();
	const CntCmpMenuEntry* 	GetObject( USHORT nPos ) const
							{
								return (const CntCmpMenuEntry*)SvPtrarr::GetObject(nPos);
							}
	// Alle Verben des Menues ermitteln
	/*
		Returnwert: Anzahl der gefundenen Verben
		Parameter:
		aVerbs	 	[OUT] 	:	String aus allen Verben
		cSep		[IN]	:	Separator, der die einzelnen Verben abtrennt
		bDeep 		[IN]	:	True - rekursive Suche durch Submenues

	*/
	USHORT					GetVerbs (XubString& aVerbs, xub_Unicode cSep =';', BOOL bDeep = FALSE) const;
	// Gibt es ein bestimmtes Verb im Menu ?
	/*
		Returnwert: TRUE - ja, es gibt es
		Parameter:
		pVerb	 	[IN] 	:	Gesuchtes Verb
		rCommand 	[OUT] 	:	das Command zum gesuchten Verb
		bDeep 		[IN]	:	True - rekursive Suche durch Submenues

	*/
	BOOL					HasVerb ( XubString const & rVerb, XubString& rCommand
																,BOOL bDeep = FALSE ) const;
};


class CntCmpMenuEntry
{
private:
	String 			_aText;
	String          _aCommand;
	String			_aHelpURL;
	String			_aVerb;
	CntCmpMenu*		_pSubMenu;
	USHORT			_nFlags;
	USHORT			_nMenuPart;

public:
					CntCmpMenuEntry() : _pSubMenu(0),_nFlags(0),_nMenuPart(0) {}
					CntCmpMenuEntry( const CntCmpMenuEntry& );
					~CntCmpMenuEntry() { delete _pSubMenu; }

	const String&	GetText() const { return _aText; }
	const String&	GetCommand() const { return _aCommand; }
	const String&	GetHelpURL() const { return _aHelpURL; }
	const String&	GetVerb() const { return _aVerb; }
	USHORT			GetFlags() const { return _nFlags; }
	const CntCmpMenu* GetSubMenu() const { return _pSubMenu; }
	USHORT			GetMenuPart() const { return _nMenuPart; }

	void			SetText( const String& rText ) { _aText=rText; }
	void			SetCommand( const String& rCommand) { _aCommand=rCommand; }
	void			SetHelpURL( const String& rHelpURL) { _aHelpURL=rHelpURL; }
	void			SetVerb( const String& rVerb ) { _aVerb=rVerb; }
	void			SetSubMenu( CntCmpMenu* pMenu);
	void			SetFlags( USHORT nFlags) { _nFlags = nFlags; }
	void			SetMenuPart( USHORT nMenuPart ) { _nMenuPart = nMenuPart; }
};

// class CntCmpMenuItem -------------------------------------------------

class CntCmpMenuItem : public SfxPoolItem
{
private:
	CntCmpMenu_Impl* 		_pMenu;
	void					ReleaseMenu();

public:
							TYPEINFO();

							CntCmpMenuItem(	USHORT nWhich );
							CntCmpMenuItem( const CntCmpMenuItem& rCpy );
							~CntCmpMenuItem();

	virtual	int				operator==( const SfxPoolItem& ) const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT nItemVersion ) const;
	virtual SvStream&		Store( SvStream&, USHORT nItemVersion ) const;
	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 ) const;

	virtual	BOOL 			QueryValue( com::sun::star::uno::Any& rVal,
										BYTE nMemberId = 0 ) const;
	virtual	BOOL 			PutValue( const com::sun::star::uno::Any& rVal,
						  			  BYTE nMemberId = 0 );

	CntCmpMenuItem&			operator=( const CntCmpMenuItem& );

	void					SetMenu(
								CntCmpMenu* pMenu, //Eigentumsuebergang
								USHORT nMenuPart=1000 );
	const CntCmpMenu*		GetMenu() const;
	USHORT					GetMenuPart() const;
};

#endif	// _CHAOS_RESOURCE

////////////////////////////////////////////////////////////////////////////////
/*
  $Log: cntcmpmn.hxx,v $
  Revision 1.1.1.1  2000/09/18 16:58:49  hr
  initial import

  Revision 1.17  2000/09/18 14:13:09  willem.vandorp
  OpenOffice header added.

  Revision 1.16  2000/08/31 13:41:08  willem.vandorp
  Header and footer replaced

  Revision 1.15  2000/04/12 07:59:00  sb
  Adapted to Unicode.

  Revision 1.14  2000/03/22 11:47:47  kso
  Removed: SmartUno leftovers.

  Revision 1.13  2000/03/20 16:07:09  kso
  Added: [Put|QueryValue( ... com::sun::star::uno::Any ... )

  Revision 1.12  2000/02/09 16:11:29  hr
  #70473# changes for unicode ( patched by automated patchtool )

  Revision 1.11  1999/06/17 03:36:59  mh
  chg: Syntax in Kommentar wg. cvs

 Revision 1.10  1998/09/18 21:22:20  OV
 CHG: #55766# GetVerbs, HasVerb am CntCmpMenu


	  Rev 1.9   18 Sep 1998 23:22:20   OV
   CHG: #55766# GetVerbs, HasVerb am CntCmpMenu

	  Rev 1.8   16 Sep 1998 09:51:44   OV
   #55577# Neu: operator=

	  Rev 1.7   10 Sep 1998 09:33:34   UT
   #55577#: Added string defines for verbs.

	  Rev 1.6   09 Sep 1998 10:47:38   OV
   #55577# Verb setzbar am Menu-Entry

	  Rev 1.5   18 Jun 1998 09:38:30   OV
   MenuEntry um Position erweitert

	  Rev 1.4   17 Jun 1998 10:12:12   OV
   Menue-Eintrag um Position erweitert


*/

#endif

