/*************************************************************************
 *
 *  $RCSfile: dtritem.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _DTRITEM_HXX
#define _DTRITEM_HXX

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif

#ifndef _DATETIME_HXX
#include <tools/datetime.hxx>
#endif

#include "poolitem.hxx"

class SvStream;

DBG_NAMEEX(SfxDateTimeRangeItem);

// class SfxDateTimeRangeItem -------------------------------------------------

class SfxDateTimeRangeItem : public SfxPoolItem
{
private:
	DateTime				aStartDateTime;
	DateTime				aEndDateTime;

public:
			TYPEINFO();

			SfxDateTimeRangeItem( const SfxDateTimeRangeItem& rCpy );
			SfxDateTimeRangeItem( USHORT nWhich );
			SfxDateTimeRangeItem( USHORT nWhich, const DateTime& rStartDT,
								  const DateTime& rEndDT );

			~SfxDateTimeRangeItem()
				{ DBG_DTOR(SfxDateTimeRangeItem, 0); }

	virtual	int				operator==( const SfxPoolItem& )			const;
	virtual int				Compare( const SfxPoolItem &rWith )			const;
	virtual SfxPoolItem*	Create( SvStream&, USHORT nItemVersion )	const;
	virtual SvStream&		Store( SvStream&, USHORT nItemVersion )		const;
	virtual SfxPoolItem*	Clone( SfxItemPool* pPool = 0 )				const;
	virtual SfxItemPresentation GetPresentation( SfxItemPresentation ePres,
									SfxMapUnit eCoreMetric,
									SfxMapUnit ePresMetric,
									XubString &rText,
									const International * pInternational = 0 )
		const;

	virtual	BOOL 			PutValue  ( const com::sun::star::uno::Any& rVal,
						     			BYTE nMemberId = 0 );
	virtual	BOOL 			QueryValue( com::sun::star::uno::Any& rVal,
							 			BYTE nMemberId = 0 ) const;

	const DateTime&			GetStartDateTime()		const { return aStartDateTime; }
	const DateTime&			GetEndDateTime()		const { return aEndDateTime; }

	void					SetStartDateTime( const DateTime& rDT )
							{ DBG_ASSERT( GetRef() == 0, "SetDateTime() with pooled item" );
							  aStartDateTime = rDT; }

	void					SetEndDateTime( const DateTime& rDT )
							{ DBG_ASSERT( GetRef() == 0, "SetDateTime() with pooled item" );
							  aEndDateTime = rDT; }
};

////////////////////////////////////////////////////////////////////////////////
/*
	 $Log: dtritem.hxx,v $
	 Revision 1.1.1.1  2000/09/18 16:58:50  hr
	 initial import
	
	 Revision 1.10  2000/09/18 14:13:10  willem.vandorp
	 OpenOffice header added.
	
	 Revision 1.9  2000/08/31 13:41:08  willem.vandorp
	 Header and footer replaced
	
	 Revision 1.8  2000/03/22 11:47:47  kso
	 Removed: SmartUno leftovers.
	
	 Revision 1.7  2000/02/21 09:36:12  kso
	 #68274# - Added: [Put|QueryValue( ... com::sun::star::uno::Any ... )

	 Revision 1.6  2000/02/09 16:11:42  hr
	 #70473# changes for unicode ( patched by automated patchtool )

	 Revision 1.5  1999/09/01 06:51:24  sb
	 #66082# Added International param to SfxPoolItem::GetPresentation().

	 Revision 1.4  1999/06/17 03:37:00  mh
	 chg: Syntax in Kommentar wg. cvs

 Revision 1.3  1998/07/17 08:21:46  KSO
 #52764# ( StarONE-API for CHAOS ) SfxDateTimeRangeItem::[Put|Query]Value(...)


	  Rev 1.2   17 Jul 1998 10:21:46   KSO
   #52764# ( StarONE-API for CHAOS ) SfxDateTimeRangeItem::[Put|Query]Value(...)

	  Rev 1.1   11 Feb 1998 19:03:10   HR
   #endif was hidden by comment

	  Rev 1.0   04 Feb 1998 10:19:44   OK
   NEW: SfxDateTimeRangeItem
*/

#endif

