/*************************************************************************
 *
 *  $RCSfile: iniman.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXINIMGR_HXX
#define _SFXINIMGR_HXX

//_______________________________________________________________________________________________________________________
//	includes of other projects
//_______________________________________________________________________________________________________________________


#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif

#ifndef SVTOOLS_INIADRTK_HXX
#include <iniadrtk.hxx>
#endif

#include <brdcst.hxx>
#include <hint.hxx>
#include <limits.h>

//_______________________________________________________________________________________________________________________
// 	namespace
//_______________________________________________________________________________________________________________________

//_______________________________________________________________________________________________________________________
// 	forwards
//_______________________________________________________________________________________________________________________

class Config						;
class Point							;
//class ::com::sun::star::awt::Size	;
class Size							;
class Window						;
class SfxAllEnumItem				;
class SfxIniDefaultManager			;
struct SfxIniManager_Impl			;

//_______________________________________________________________________________________________________________________
// 	defines, types
//_______________________________________________________________________________________________________________________

#define SFX_SEARCHPATH_DELIMITER	';'
#define SFX_PATH_NOTCHANGED			" "
#define SFX_NO_BOXPARENT			((Window*)0xFFFFFFFF)

#define SFX_FEATURE_NONE            0x00000000
#define SFX_FEATURE_MAIL_NEWS_IMAP  0x00000010
#define SFX_FEATURE_BASIC_IDE       0x00000020
#define SFX_FEATURE_DATABASE        0x00000040
#define SFX_FEATURE_SCHEDULE        0x00000080
#define SFX_FEATURE_SMATH           0x00000100
#define SFX_FEATURE_SCHART          0x00000200
#define SFX_FEATURE_SIMAGE          0x00000400
#define SFX_FEATURE_SCALC           0x00000800
#define SFX_FEATURE_SDRAW           0x00001000
#define SFX_FEATURE_SWRITER     	0x00002000
#define SFX_FEATURE_SWRITERFULL     SFX_FEATURE_SWRITER // for compatibility
#define SFX_FEATURE_SWRITERWEB     	0x00004000
#define SFX_FEATURE_SIMPRESS     	0x00008000
#define SFX_FEATURE_SWRITERGLOBAL   0x00010000
#define SFX_FEATURE_GALLERY   		0x00020000
#define SFX_FEATURE_IEXPLORER       0x00040000

#define SFX_MODULE_MAIL_NEWS_IMAP  	"snews"
#define SFX_MODULE_BASIC_IDE        "sbasic"
#define SFX_MODULE_DATABASE         "sbase"
#define SFX_MODULE_SCHEDULE         "sschedule"
#define SFX_MODULE_SMATH            "smath"
#define SFX_MODULE_SCHART           "schart"
#define SFX_MODULE_SIMAGE           "simage"
#define SFX_MODULE_SCALC            "scalc"
#define SFX_MODULE_SDRAW            "sdraw"
#define SFX_MODULE_SWRITER          "swriter"
#define SFX_MODULE_SWRITERWEB       "swriterweb"
#define SFX_MODULE_SIMPRESS         "simpress"
#define SFX_MODULE_SWRITERGLOBAL    "swriterglob"
#define SFX_MODULE_GALLERY          "sgallery"
#define SFX_MODULE_IEXPLORER        "iexplorer"

#define GROUPNAME_DIRBACKUP			"Directories-Standard"

enum SfxIniGroup

/*  [Beschreibung]

	Dem Applikationsentwickler stehen einige vordefinierte 'virtuelle'
	Gruppen zur Verf"ungung. Diese werden ggf. durch den Namen der
	betreffenden Applikation und/oder das betreffende Betriebssystem
	erweitert.
*/

{
	SFX_GROUP_COMMON				,	// [Common					]
	SFX_GROUP_DIR					,	// [Directories-OS			]
	SFX_GROUP_USER					,	// [User					]
	SFX_GROUP_VIEW					,	// [APP-View-OS				]

	SFX_GROUP_PICKLIST_IMPL			,	// [APP-Picklist-OS			]
	SFX_GROUP_WORKINGSET_IMPL		,	// [APP-Workingset-OS		]
	SFX_GROUP_GRAPHIC_FILTER_OPTIONS,	// [Graphic-Filter-Options	]

	SFX_GROUP_INET					,	// [INet-OS					]
	SFX_GROUP_DATABASE				,	// [Database-OS				]
	SFX_GROUP_SECURITY				,	// [Security-OS				]
	SFX_GROUP_EXTBRW				,	// [Externer Browser		]
	SFX_GROUP_3D_ENGINE				,	// [3D-Engine-OS			]
	SFX_GROUP_MODULES				,	// [APP-Apps				]
	SFX_GROUP_RECENTEXECUTES		,	// [APP-Recent				]
	SFX_GROUP_INTERNATIONAL			,	// [International			]
	SFX_GROUP_JAVA					,	// [Java					]
	SFX_GROUP_DESKTOP				,	// [Desktop					]

	SFX_GROUP_UNKNOWN
};

/*  [Beschreibung]

	Diese Werte identifizieren die verschidenen Ini-Datei Eintr"age.
	Sie werden in den angegebenen Gruppen zun"achst in APP.ini
	gesucht, dann in der unter SFX_KEY_SUBINI angegebenen Ini-Datei.

	Komplett gro"s geschreibene Bezeichner stehen dabei als Platzhalter:
	- APP:  f"ur den Kurznamen der Applikation (z.B. 'swriter3')
	- OS:   f"ur den Namen des betreffenden Betriebssystems


	[Hinzuf"ugen neuer Eintr"age in bestehede Gruppen]

	Kompatibel k"onnen die freien Nummern zwischen den folgenden #defines
	verwendet werden, dabei ist die Zuordnung in die richtige Gruppe zu
	beachten. Ist die Gruppe voll, mu\s ein inkompatibles Update abgewartet
	werden. Wenn in einer Gruppe weniger als zwei freie Nummern "ubrigbleiben,
	m"ussen f"ur da n"achste inkompatible Update die Nummern so verschoben
	werden, da\s wieder ausreichend Luft ist (SUPD verwenden!).

	Bei Neueintrag von Keys bitte beachten:

	1. Den neuen symbolischen Namen eintragen und kommentieren.
	2. Ggf. das Ende-#define der betroffenen Gruppe anpassen.
	3. In inimgr.cxx im Array pKeys die Tags f"ur die ini-Datei angeben.
	4. Bei Eintr"agen der Gruppe DIR in config.hrc in den Bereichen
		CONFIG_PATH_... und CONFIG_OSPATH die Resource-Ids einsetzen.
	5. In inidirs.src und config.src die String-Resourcen eintragen.
	6. Ggf. in inimgr.cxx im 2. Konstruktor die for-Schleifenbedingung
		in "im Default Vereichnis anlegen" anpassen.
	7. Ggf. in inimgr.cxx in der Methode 'Fill' die for-Schleifenbedingung
		anpassen.
*/

typedef sal_uInt16 SfxIniKey;

// SFX_GROUP_COMMON: [Common]
#define	SFX_KEY_LAST_DATABASE					  1
#define	SFX_KEY_SHOW_INTRO			 			  2
#define	SFX_KEY_PAGEQUEUESIZE		 			  3
#define	SFX_KEY_PRINTTHREADPRIO		 			  4
#define	SFX_KEY_BROWSEREADONLY       			  5
#define SFX_KEY_LDAP_SERVER	 		 			  6
#define SFX_KEY_MAXPREVIEWSIZE   	 			  7
#define SFX_KEY_SLOTLIST			 			  8
#define SFX_KEY_BROWSERRESTORE		 			  9
#define SFX_KEY_DONTPLUGHELP        			 10
#define	SFX_KEY_METAFILEPRINT					 11
#define SFX_KEY_FILEDIALOGEXT 					 12
#define SFX_KEY_ADDRESSBOOK_FIELDS				 13
#define	SFX_KEY_SAP_ENABLE						 14
#define SFX_KEY_SEARCHTEMPLATE      			 15
#define SFX_KEY_HELPVIEW						 16
#define SFX_KEY_DONTASKFORDEFAULTS				 17
#define SFX_KEY_ALLOWFOLDERWEBVIEW				 18
#define SFX_KEY_LOG_RULES						 19	// Log use of rules into a file
#define	SFX_KEY_GROUP_COMMON_END				 19

// SFX_GROUP_DIR: [Directories-OS] z.B. [Directories-Windows]
#define	SFX_KEY_SUB_INI							 50	// hier wird ggf. weitergesucht
#define SFX_KEY_CONFIG_DIR     					 51	// *.cfg-Dateien
#define SFX_KEY_WORK_PATH      					 52	// Home/Arbeitsverzeichnis
#define SFX_KEY_GRAPHICS_PATH  					 53	// Grafikdateien
#define SFX_KEY_BITMAP_PATH    					 54	// Bitmaps f"ur Config
#define SFX_KEY_BASIC_PATH     					 55	// Basic-Libraries
#define SFX_KEY_DATABASE_PATH  					 56	// Datenbanken
#define	SFX_KEY_PALETTE_PATH					 57	// Farb- Bitmap- Farbverlaufs-Tabellen
#define SFX_KEY_BACKUP_PATH    					 58	// Sicherungsdateien
#define SFX_KEY_MODULES_PATH   					 59	// weitere Programmteile
#define SFX_KEY_TEMPLATE_PATH  					 60	// Dokumentvorlagen
#define	SFX_KEY_GLOSSARY_PATH  					 61	// (Text- etc.) Bausteine
#define	SFX_KEY_DICTIONARY_PATH					 62	// W"orterb"ucher
#define	SFX_KEY_DESKTOP_DIR  					 63	// Desktop-Verzeichnis
#define SFX_KEY_HELP_DIR						 64	// Hilfe-Root-Directory
#define SFX_KEY_BOOKMARK_DIR        			 65	// Verzeichnis fuer Bookmarks
#define SFX_KEY_GALLERY_DIR         			 66	// Verzeichnis fuer Gallery
#define SFX_KEY_NEW_DIR             			 67	// Verzeichnis fuer Neu-Men"u-URL's
#define SFX_KEY_AGENT_DIR						 68	// Agent-Verzeichnis
#define SFX_KEY_AUTOPILOT_DIR   				 69	// Autopiloten-Menu
#define SFX_KEY_EXPLORER_DIR        			 70	// Default-Explorer-Root
#define SFX_KEY_TRASH_DIR           			 71	// M"ulleimer
#define SFX_KEY_STORAGE_DIR						 72	// Chaos-Storages
#define SFX_KEY_STARTMENU_DIR					 73	// Taskbar-Start-Menu
#define SFX_KEY_DOWNLOAD_DIR					 74	// Default Download Verzeichnis
#define SFX_KEY_AUTOSTART_DIR					 75	// Default Autostart Verzeichnis
#define SFX_KEY_QUICKSTART_DIR					 76	// Default Quickstart Verzeichnis
#define SFX_KEY_GROUP_DIR						 77	// Startverzeichnis Outlook-Leiste
#define SFX_KEY_PLUGINS_PATH					 78	// Plugins
#define SFX_KEY_FAVORITES_DIR					 79	// Benutzerverzeichnisse
#define SFX_KEY_FILTER_PATH						 80 // Filter DLL's
#define SFX_KEY_ADDINS_PATH					 	 81	// AddIns
#define SFX_KEY_USERCONFIG_PATH				 	 82	// User Config
#define	SFX_KEY_USERDICTIONARY_DIR				 83	// Benutzerw"orterb"ucher
#define SFX_KEY_LINGUISTIC_DIR					 84 // Linguistik
#define SFX_KEY_AUTOCORRECT_DIR				 	 85 // Auto correction
#define SFX_KEY_GROUP_DIR_END       			 85

// SFX_GROUP_USER: [User]
#define	SFX_KEY_USER_NAME						100	// User-Name
#define SFX_KEY_USER_ID        					101	// User-K"urzel
#define SFX_KEY_USER_ADDRESS   					102	// User-Adresse
#define SFX_KEY_COUNTRY        					103	// Landescode
#define SFX_KEY_LANGUAGE       					104	// Sprachencode
#define SFX_KEY_USER_FIRSTNAME 					105	// User-Vorname
#define SFX_KEY_HTMLFONTSIZE					106	// HTML-Fontgr"o\sen
#define SFX_KEY_LINKPREFIX						107	// "Verknuepfen mit..." oder nicht
#define SFX_KEY_USINGOFFICE						108	// private und/oder gesch"aftl. Nutzung
#define SFX_KEY_CUSTOMERNUMBER					109	// Kundennummer
#define	SFX_KEY_GROUP_USER_END					109

// SFX_GROUP_VIEW: [View-APP-OS] z.B. [View-SWriter3-Windows]
#define SFX_KEY_APP_WINDOW     					130	// Pos/Size App-Fenster
#define SFX_KEY_MAILINBOX      					131	// Pos/Size Mail-InBox
#define SFX_KEY_HELPER         	   				132	// Pos/Size Helferlein
#define	SFX_KEY_DIALOG 							133	// Pos/Size Dialoge
#define	SFX_KEY_WINDOW 							134	// Pos/Size Fenster
#define	SFX_KEY_PAGE							135	// UserData TabPages
#define SFX_KEY_SPLITWINDOW						136	// SplitWindow-Config
#define SFX_KEY_OPENCONTAINER       			137	// Expandierter Eintrag im Explorer
#define SFX_KEY_BROWSERSETS         			138	// Settings des Explorer-Browsers
#define SFX_KEY_ICONGRID						139	// Icon-Abstand/Autoarrange (Explorer)
#define SFX_KEY_AUTOOPEN						140	// Unterordner automatisch oeffnen
#define	SFX_KEY_GROUP_VIEW_END 					140

// [Picklist-APP-OS] z.B. [Picklist-SWriter3-Windows]
#define	SFX_KEY_PICKLIST        				145	// vollst"andiger Dateiname
#define	SFX_KEY_HISTORY         				146
#define	SFX_KEY_FOLDERHISTORY         			147
#define	SFX_KEY_GROUP_PICKLIST_END  			147

// [WorkingSet-APP-OS]
#define	SFX_KEY_WORKINGSET						150	// offene Dokumente und Views mit Position etc.
#define	SFX_KEY_GROUP_WORKINGSET_END			150

// [INet-OS]
#define	SFX_KEY_INET_HOME						160	// HomePage
#define	SFX_KEY_INET_BOOKMARKFILE				161	// offene Bookmarkfiles im Bookmarkwindow
#define	SFX_KEY_INET_MAILGATEWAY				162	// z.B. "$ at smtplink-star"
#define SFX_KEY_INET_PROXYNAME					163	// Name des Proxy-Servers
#define SFX_KEY_INET_PROXYPORT					164	// Port Nr. des Proxy-Servers
#define SFX_KEY_INET_PROXYTYPE					165	// Typ des Proxy-Servers
#define SFX_KEY_INET_COOKIES					166	// Cookie Handling
#define SFX_KEY_INET_MEMCACHE					167	// Anzahl zu cachender Docs
#define SFX_KEY_INET_DISKCACHE					168	// Groesse des Disk-Cache in KB
#define SFX_KEY_INET_CACHEEXPIRATION			169	// ???
#define SFX_KEY_INET_SMTPSERVER    				170	// Name des SMTP-Servers
#define SFX_KEY_INET_POPSERVER     				171	// Name des POP-Servers
#define SFX_KEY_INET_MAILUSERNAME  				172	// Username f"ur Mail
#define SFX_KEY_INET_MAILPASSWORD  				173	// Password f"ur Mail
#define SFX_KEY_INET_NOPROXY	   				174	// Liste mit internen Hosts
#define SFX_KEY_INET_HTTPPROXYNAME 				175	// Name des HTTP-Proxy-Servers
#define SFX_KEY_INET_HTTPPROXYPORT 				176	// Port Nr. des HTTP-Proxy-Servers
#define SFX_KEY_INET_FTPPROXYNAME				177	// Name des FTP-Proxy-Servers
#define SFX_KEY_INET_FTPPROXYPORT				178	// Port Nr. des FTP-Proxy-Servers
#define SFX_KEY_INET_SOCKSPROXYNAME				179	// Name des SOCKS-Proxy-Servers
#define SFX_KEY_INET_SOCKSPROXYPORT				180	// Port Nr. des SOCKS-Proxy-Servers
#define SFX_KEY_INET_SECURITYPROXYNAME			181	// Name des SECURITY-Proxy-Servers
#define SFX_KEY_INET_SECURITYPROXYPORT			182	// Port Nr. des SECURITY-Proxy-Servers
#define SFX_KEY_INET_NNTPSERVER					183	// News-Server
#define SFX_KEY_INET_MAXNEWS					184	// maximal am Stueck zu holende Msgs
#define SFX_KEY_INET_MAXHTTPCONS				185	// maximale Anzahl von HTTP-Connections
#define SFX_KEY_INET_MAXFTPCONS					186	// maximale Anzahl von FTP-Connections
#define SFX_KEY_INET_DNS						187	// Domain-Name-Server
#define SFX_KEY_INET_USERAGENT					188	// UserAgent String des Browsers
#define SFX_KEY_INET_NONCACHED_SERVER			189	// Server die nichht gecached werden.
#define SFX_KEY_INET_EXE_JAVASCRIPT				190	// soll JavaScript ausgef"uhrt werden
#define SFX_KEY_INET_EXE_PLUGIN					191	// sollen PlugIns ausgef"uhrt werden
#define SFX_KEY_INET_EXE_APPLETS				192	// sollen Applets ausgef"uhrt werden
#define SFX_KEY_INET_MAILTEXTFORMAT				193	// Standard-Format f"ur den MailText
#define SFX_KEY_INET_CHANNELS					194	//
#define SFX_KEY_INET_CACHEJS					195	// Javascript Seiten cachen?
#define SFX_KEY_INET_CACHEEXPIRED				196	// Expired Seiten cachen?
#define SFX_KEY_INET_CACHEABORTED				197	// Aborted Seiten cachen?
#define SFX_KEY_INET_REVEAL_MAILADDR			198	// beim browsen Email-Adresse senden
#define SFX_KEY_INET_READTIMER_ON				199	// Nachrichten zeitverz"ogert auf
#define SFX_KEY_INET_READTIMER_OUT				200	// gelesen setzen
#define SFX_KEY_INET_AUTOLOAD					201	// erste Mail/Newsmessage automatisch laden
#define SFX_KEY_INET_MAILTEXT_FONTHEIGHT		202	// font height of mail text component
#define	SFX_KEY_GROUP_INET_END					202	// Ende der INET-Gruppe

// [Database-OS]
#define SFX_KEY_ADDRESSBOOK						220
#define	SFX_KEY_GROUP_DATABASE_END  			220

// [Security-OS]
#define SFX_KEY_SECURE_URL						230 // sichere URL (z.b. "file:")
#define	SFX_KEY_BASIC_ENABLE					231 // 0=aus, 1=gemaess Liste, 3=an
#define	SFX_KEY_GROUP_SECURITY_END				231

// [Externer Browser]
#define SFX_KEY_EXTBRW_ON               		240 // externen Browser benutzen?
#define SFX_KEY_EXTBRW_ON_EXCEPTION     		241 // Ausnahmeliste f"ur externen Browser
#define SFX_KEY_EXTBRW_OFF_EXCEPTION    		242 // Ausnahmeliste f"ur internen Browser
#define SFX_KEY_EXTBRW_NO_HINT					243 // Hinweis ausblenden
#define SFX_KEY_EXTBRW_FILE						244 // externes Programm oder Skript
#define SFX_KEY_GROUP_EXTBRW_END        		244

// [3D-Engine-OS]
#define SFX_KEY_3D_OPENGL						250	// OpenGL benutzen
#define SFX_KEY_3D_DITHERING					251	// Dithering benutzen
#define SFX_KEY_3D_SHOWFULL						252	// Volldarstellung bei Interaktion
#define SFX_KEY_3D_OPENGL_FASTER				253	// OpenGL: optimierte Ausgabe
#define	SFX_KEY_GROUP_3D_ENGINE_END				254	// Ende-Kennung

// [International]
#define SFX_KEY_INTERNATIONAL_AUTOMNEMONIC		260
#define SFX_KEY_INTERNATIONAL_DIALOGSCALEX		261
#define SFX_KEY_GROUP_INTERNATIONAL_END			261

// [JAVA]
#define SFX_KEY_JAVA_ENABLE						270 // 0 == Java aus sonst an
#define SFX_KEY_JAVA_SECURITY					271 // != 0 -> Security checks are on, 0 -> Security checks are off
#define SFX_KEY_JAVA_SYSTEMCLASSPATH			272 // System classpath
#define SFX_KEY_JAVA_USERCLASSPATH				273 // User classpath
#define SFX_KEY_JAVA_NETACCESS					274 // Access Type fuer ein Applet auf das Netz
#define	SFX_KEY_GROUP_JAVA_END					274 // Ende der JAVA-Gruppe

// [Desktop]
#define SFX_KEY_EXPLORERROOT        			300	// Ursprung des Explorers (File|Dir)
#define SFX_KEY_ENABLE_DOCINFO_READ  			301	// DocInfo lesen zur Anzeige im Beamer, etc.
#define SFX_KEY_SHOW_FSYS_EXTENSION  			302	// Extension in der Symbolansicht an/aus
#define SFX_KEY_SHOW_ONLY_DRIVES     			303	// Nur Laufwerke unterm Arbeitsplatz
#define SFX_KEY_SHOW_FONTBOX_WYSIWYG			304	// FontNameBox with WYSIWYG
#define SFX_KEY_FORCE_BODY_EXPORT				305 // Mail/News Export w/ *all* bodies
#define SFX_KEY_DONTHIDE_DISABLEDENTRIES		306 // do not hide disabled menu tems
#define SFX_KEY_FONT_HISTORY					307 // most recently used fonts
#define	SFX_KEY_GROUP_DESKTOP_END 				307

#define	SFX_KEY_UNKNOWN							0	// ung"ultiger Key f"ur interne Zwecke

//_______________________________________________________________________________________________________________________
// 	classes
//_______________________________________________________________________________________________________________________

class SfxIniManagerHint : public SfxHint
{

//_______________________________________________________________________________________________________________________
//	public methods
//_______________________________________________________________________________________________________________________

public:

	TYPEINFO();

	SfxIniManagerHint	(			SfxIniKey	nKey	,
							const	XubString&	rOldVal	,
							const	XubString&	rNewVal	)
		:	mnIniKey	( nKey		)
		,	maOldValue	( rOldVal	)
		,	maNewValue	( rNewVal	)
	{
	}

	SfxIniKey			GetIniKey() const { return mnIniKey; }
	const XubString		GetOldValue() const { return maOldValue; }
	const XubString		GetNewValue() const { return maNewValue; }

//_______________________________________________________________________________________________________________________
//	private variables
//_______________________________________________________________________________________________________________________

private:

	SfxIniKey	mnIniKey	;
	XubString	maOldValue	;
	XubString	maNewValue	;

};

/*
 	[Beschreibung]

	Der SfxIniManager verwaltet mehrere <StarView> Config-Instanzen.
	Die Master-Ini-Datei wird unter dem namen 'APP.ini' (z.B. 'sdraw3.ini')
	zun"achst dem Verzeichnis gesucht in dem auch die Applikation steht,
	dann in dem Verzeichnis, auf dem unter dem Betriebssystem
	"ublicherweise solche Dateien abgelegt werden (z.B. unter MS-Windows
	im Windows-Verzeichnis). Wird sie nicht gefunden, so wird sie in dem
	von Betriebssystem vorgesehenen Verzeichnis angelegt.

	In dieser Master-Ini-Datei werden vorrangig alle Eintr"age gesucht,
	werden sie hier nicht gefunden, wird rekursiv in der Ini-Datei
	weitergesucht, deren Pfad und Name unter SFX_KEY_SUBINI angegeben
	ist. Neue Eintr"age werden grunds"atzlich in der Master-Ini-Datei
	angelegt.
*/

class SfxIniManager : public SfxBroadcaster
{

//_______________________________________________________________________________________________________________________
//	public methods
//_______________________________________________________________________________________________________________________

public:

    static SfxIniManager*   Get();
    static SfxIniManager*   Create( const String* pAppName=0, const String* pVersion=0 );
    static void             Close();
	const String&			GetName() const;
	sal_Bool				IsReadOnly() const;
	sal_Bool				IsValid() const ;
	void					EnterLock();
	void					LeaveLock();
	void					ResetLock();
	static char 			GetToken();
	const String&			GetProgramPath() const;
	String                  SubstPathVars( const String &rPath ) const;
	String					UsePathVars( const String &rPath ) const;
	SfxIniManager*			GetSubManager() const;
	String					GetGroupName( SfxIniGroup eGroup ) const;
	String					GetGroupName( const String &rName, sal_Bool bSysDepen, sal_Bool bAppDepen ) const;
	SfxIniManager*			Find( SfxIniKey eKey, sal_uInt16 nIdx = USHRT_MAX );
	SfxIniManager*			Find( SfxIniGroup eKey, const String &rKey, sal_uInt16 nIdx = USHRT_MAX );
	String					GetKeyName( SfxIniKey eKey ) const;
	String					Get( SfxIniKey eKey, sal_uInt16 nIdx = USHRT_MAX );
	String                  Get( SfxIniGroup eKey, const String &rKey, sal_uInt16 nIdx = USHRT_MAX );
	String                  Get( const String &rGroup, sal_Bool bSysDepen, sal_Bool bAppDepen, const String &rKey, sal_uInt16 nIdx = USHRT_MAX );
	void                    Set( const String& rContent, SfxIniKey eKey, sal_uInt16 nIdx = USHRT_MAX );
	void                    Set( const String& rContent, SfxIniGroup eKey, const String &rKey, sal_uInt16 nIdx = USHRT_MAX );
	void					Delete( SfxIniKey eKey, sal_uInt16 nIdx = USHRT_MAX );
	void					Delete( SfxIniGroup eKey, const String &rKey, sal_uInt16 nIdx = USHRT_MAX );
	void					DeleteGroup( SfxIniGroup eKey );
	void					DeleteGroup( const String& rGroup );
	void					DeleteKey( const String& rGroup, const String& rKey );
	String					ReadKey( const String& rGroup, const String& rKey );
	void					WriteKey( const String& rGroup, const String& rKey, const String& rValue );
	void					Flush();
	sal_uInt16				GetKeyCount( const String& rGroup );
	String					GetKeyName( const String& rGroup, sal_uInt16 nIndex );
	void                    Fill(SfxIniGroup eKey, SfxAllEnumItem &rNames, SfxAllEnumItem &rValues);
	void                    Set(SfxIniGroup eKey, const SfxAllEnumItem &rValues);

	// Hilfsfunktionen
	static String			GetString( const Point &rPt, const Size &rSz );
	static sal_Bool			GetPosSize( const XubString &rStr, Point &rPt, Size &rSz );
	static sal_Bool			CheckPLZ( const XubString& rPLZ, Window* pBoxParent = SFX_NO_BOXPARENT );
	sal_uInt32				GetFeatures();
	String 					GetUserFullName();
	String					GetAddressToken( AddressToken eToken );
	Config*					GetDocMgrConfig();

	// nicht const, weil Get() nicht const ist
	sal_Bool				IsInternetExplorerAvailable();
	sal_Bool				IsJavaEnabled();
	sal_Bool				IsAppletsEnabled();
	sal_Bool				SearchFile( String& rIniFile, SfxIniKey eDirKey = SFX_KEY_CONFIG_DIR );
	sal_Bool				IsDontHideDisabledEntries();

//_______________________________________________________________________________________________________________________
//	protected methods
//_______________________________________________________________________________________________________________________

protected:

#ifndef _SVCONFIG_HXX

	String                  ToRel(const String &) const;
	SfxIniGroup 			FindGroup( SfxIniKey eKey ) const;

#endif

//_______________________________________________________________________________________________________________________
//	private methods
//_______________________________________________________________________________________________________________________

private:

			SfxIniManager( const String* );
			SfxIniManager( const SfxIniManager& );// Kopieren und zuweisen verboten!
	virtual ~SfxIniManager();

	const SfxIniManager& operator=( const SfxIniManager& );// Kopieren und zuweisen verboten

#ifndef _SVCONFIG_HXX
	String Get_Impl(		SfxIniGroup	eGroup	,
					const	String&		rKey	,
							SfxIniKey	eKey	,
							sal_uInt16	nIdx	);
#endif

//_______________________________________________________________________________________________________________________
//	private variables
//_______________________________________________________________________________________________________________________

private:

	static SfxIniManager*	pIniMgr		;
    static const String*    pVersionKey	;
	SfxIniManager_Impl*     pImp		;           // Imp-Struktur
	SfxIniManager*			pSub		;			// verkettete Liste

};

//------------------------------------------------------------------------

/*	[Beschreibung]

	Kurzschreibweise f"ur den Ini-Manger der Document-Factory des
	gerade aktiven Dokuments.
*/

//------------------------------------------------------------------------

inline SfxIniManager* SfxIniManager::GetSubManager() const
{
	return pSub;
}

//------------------------------------------------------------------------

inline char SfxIniManager::GetToken()

/*	[Beschreibung]

	Liefert das von SfxIniManger verwendete Trennzeichen, um in einem
	Eintrag mehrere Daten unterzubringen. Diese kann in der Methode
	String::GetToken() als zweiter Parameter verwendet werden.
*/

{
	return ',';
}

//------------------------------------------------------------------------

#define SFX_WINSIZE_MIN 	"min"
#define SFX_WINSIZE_MAX 	"max"
#define SFX_WINSIZE_FULL	"full"

/*	[Beschreibung]

	Diese Strings k"onnen f"ur minimierte, maximierte oder Full-Screen
	Fenster verwendet werden und anstelle des mit Strings verwendet
	werden, der mit <SfxIniManager::GetString(const Point&, const SIZE&) const>
	erzeugt werden kann.
*/

//------------------------------------------------------------------------

#define LDAP_TOKEN_DELIMITER	'|'

/*	[Beschreibung]

	Dieser Delimiter trennt die Eigenschaften eines LDAP-Servers.
*/

//------------------------------------------------------------------------

enum LDAPToken

/*	[Beschreibung]

	Dieser enum beschreibt die einzelnen Token eines LDAP-Server-Ini-Strings
*/

{
	LDAP_DESCRIPTION = 0,
	LDAP_SERVER,
	LDAP_SEARCHROOT,
	LDAP_PORT,
	LDAP_MAXHITS
};

#endif // #ifndef _SFXINIMGR_HXX

