/*************************************************************************
 *
 *  $RCSfile: libcall.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _LIBCALL_HXX
#define _LIBCALL_HXX

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif

#ifndef SOLAR_HRC
#include <solar.hrc>
#endif

#define LIBRARY_STR(s)	 	# s
#define LIBRARY_STRING(s)	LIBRARY_STR(s)
#define LIBRARY_SOLARUPD()	LIBRARY_STRING(SOLARUPD)

#ifdef WTC
#define LIBRARY_CONCAT2( s1, s2 ) s1##s2
#define GETFUNCTION( s ) GetFunction( LIBRARY_CONCAT2( s, "_" ) )
#elif defined WNT || defined UNX || defined MAC || defined ICC
#define GETFUNCTION( s ) GetFunction( s )
#else
#define LIBRARY_CONCAT2( s1, s2 ) s1##s2
#define GETFUNCTION( s ) GetFunction( LIBRARY_CONCAT2( "_", s ) )
#endif

#if defined WIN
#define LIBRARY_CONCAT4( s1, s2, s3, s4 ) \
	s1##s2##s3##s4
#define SVLIBRARY( Base ) \
	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), __DLLEXTENSION, ".DLL" )
#define SVLIBRARYLANG( Base, Lang ) \
	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), Lang, ".DLL" )
#elif defined MAC
#define LIBRARY_CONCAT4( s1, s2, s3, s4 ) \
	s1##s2##s3##s4
#define SVLIBRARY( Base ) \
	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), __DLLEXTENSION, ".dll" )
//	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), __DLLEXTENSION, " Library" )
#define SVLIBRARYLANG( Base, Lang ) \
	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), Lang, ".dll" )
//	LIBRARY_CONCAT4( Base, LIBRARY_SOLARUPD(), Lang, " Library" )
#elif defined UNX
#define LIBRARY_CONCAT4( s1, s2, s3, s4 ) \
	s1##s2##s3##s4
#define SVLIBRARY( Base ) \
	LIBRARY_CONCAT4( "lib", Base, LIBRARY_SOLARUPD(), __DLLEXTENSION )
#define SVLIBRARYLANG( Base, Lang ) \
	LIBRARY_CONCAT4( "lib", Base, LIBRARY_SOLARUPD(), Lang )
#else
#define LIBRARY_CONCAT3( s1, s2, s3 ) \
	s1##s2##s3
#define SVLIBRARY( Base ) \
	LIBRARY_CONCAT3( Base, LIBRARY_SOLARUPD(), __DLLEXTENSION )
#define SVLIBRARYLANG( Base, Lang ) \
	LIBRARY_CONCAT3( Base, LIBRARY_SOLARUPD(), Lang )
#endif

// Macros zum erzeugen des LibFileNames
#if defined MAC
#define LIBRARYFILENAME_CONCAT4( s1, s2, s3, s4 ) \
	s1##s2##s3##s4
#define SV_LIBFILENAME(str)	\
	LIBRARYFILENAME_CONCAT4( str, LIBRARY_SOLARUPD(), __DLLEXTENSION, ".dll" )
//	LIBRARYFILENAME_CONCAT4( str, LIBRARY_SOLARUPD(), __DLLEXTENSION, " Library" )
#elif defined UNX
#define LIBRARYFILENAME_CONCAT3( s1, s2, s3 ) \
	s1##s2##s3
#define SV_LIBFILENAME(str)	\
	LIBRARYFILENAME_CONCAT3( str, LIBRARY_SOLARUPD(), __DLLEXTENSION )
#else
#define LIBRARYFILENAME_CONCAT4( s1, s2, s3, s4 ) \
	s1##s2##s3##s4
#define SV_LIBFILENAME(str)	\
	LIBRARYFILENAME_CONCAT4( str, LIBRARY_SOLARUPD(), __DLLEXTENSION, ".dll" )
#endif

struct LibraryPrivateData;

class Library
{
public:
	Library(const String & rPathname);
	~Library();

	BOOL ModulFound() const;

	static BOOL ModulFound( const String &rPathname );

	void * GetFunction  (const String & rFuncName) const;
#if defined MAC
	void * GetDescriptor(const String & rFuncName) const;
private:
	void * GetShlbSymbol(const String& rFuncName, int nRequestSymbol) const;
#endif

#if defined OS2
	// erfragt ob es sich um einen 16 oder 32 Bit Funktion handelt
	// returnt	USHRT_MAX 	=> FEHLER
	//			0 			=> 16 Bit
	//			1 			=> 32 Bit
	USHORT GetProcType( const String& rFuncName ) const;
#endif

private:

	LibraryPrivateData * pPriv;
};

class SvLibrary : public Library
{
public:
	SvLibrary( const String &rPathname ) : Library( rPathname ) {}

#if defined WIN || ( defined OS2 && !defined ICC )
	void * GetFunction( const String &rFunctionName ) const
#if defined WTC && defined OS2
	  {
		String aFunctionName( rFunctionName );
		aFunctionName.Append( "_" );
#else
	  {
		String aFunctionName( '_' );
		aFunctionName.Append( rFunctionName );
#endif
		return Library::GetFunction( aFunctionName ); }
#endif
};

#endif  // _LIBCALL_HXX
