/*************************************************************************
 *
 *  $RCSfile: pathoptions.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#define INCLUDED_SVTOOLS_PATHOPTIONS_HXX

#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#define PATH_ADDIN			0
#define PATH_AUTOCORRECT	1
#define PATH_AUTOPILOT		2
#define PATH_BACKUP			3
#define PATH_BASIC			4
#define PATH_BITMAP			5
#define PATH_CONFIG			6
#define PATH_DATABASE		7
#define PATH_DICTIONARY		8
#define PATH_FAVORITES		9
#define PATH_FILTER			10
#define PATH_GALLERY		11
#define PATH_GLOSSARY		12
#define PATH_GRAPHIC		13
#define PATH_HELP			14
#define PATH_LINGUISTIC		15
#define PATH_MODULE			16
#define PATH_NEWMENU		17
#define PATH_PALETTE		18
#define PATH_PLUGIN			19
#define PATH_STORAGE		20
#define PATH_SUBINI			21
#define PATH_TEMP			22
#define PATH_TEMPLATE		23
#define PATH_TRASH			24
#define PATH_USERCONFIG		25
#define PATH_USERDICTIONARY	26
#define PATH_WORK			27

class SvtPathOptions : public utl::ConfigItem
{
private:
	String			m_aAddinPath;
	String			m_aAutoCorrectPath;
	String			m_aAutoPilotPath;
	String			m_aBackupPath;
	String			m_aBasicPath;
	String			m_aBitmapPath;
	String			m_aConfigPath;
	String			m_aDatabasePath;
	String			m_aDictionaryPath;
	String			m_aFavoritesPath;
	String			m_aFilterPath;
	String			m_aGalleryPath;
	String			m_aGlossaryPath;
	String			m_aGraphicPath;
	String			m_aHelpPath;
	String			m_aLinguisticPath;
	String			m_aModulePath;
	String			m_aNewMenuPath;
	String			m_aPalettePath;
	String			m_aPluginPath;
	String			m_aStoragePath;
	String			m_aSubIniPath;
	String			m_aTempPath;
	String			m_aTemplatePath;
	String			m_aTrashPath;
	String			m_aUserConfigPath;
	String			m_aUserDictionaryPath;
	String			m_aWorkPath;

	String			m_aEmptyString;

	::osl::Mutex	m_aMutex;

	static SvtPathOptions*	m_pOptions;

	com::sun::star::uno::Sequence< rtl::OUString > GetPropertyNames();

	// not const because of using a mutex
	const String&	GetPath( int nIndex );
	void			SetPath( int nIndex, const String& rNewPath );

	SvtPathOptions();

public:
	virtual ~SvtPathOptions();

	static SvtPathOptions*	GetPathOptions();
	static void				DestroyPathOptions();

	virtual void 	Notify( const com::sun::star::uno::Sequence< rtl::OUString >& aPropertyNames );
	virtual void	Commit();

	// get the pathes, not const because of using a mutex
	const String&	GetAddinPath() { return GetPath( PATH_ADDIN ); }
	const String&	GetAutoCorrectPath() { return GetPath( PATH_AUTOCORRECT ); }
	const String&	GetAutoPilotPath() { return GetPath( PATH_AUTOPILOT ); }
	const String&	GetBackupPath() { return GetPath( PATH_BACKUP ); }
	const String&	GetBasicPath() { return GetPath( PATH_BASIC ); }
	const String&	GetBitmapPath() { return GetPath( PATH_BITMAP ); }
	const String&	GetConfigPath() { return GetPath( PATH_CONFIG ); }
	const String&	GetDatabasePath() { return GetPath( PATH_DATABASE ); }
	const String&	GetDictionaryPath() { return GetPath( PATH_DICTIONARY ); }
	const String&	GetFavoritesPath() { return GetPath( PATH_FAVORITES ); }
	const String&	GetFilterPath() { return GetPath( PATH_FILTER ); }
	const String&	GetGalleryPath() { return GetPath( PATH_GALLERY ); }
	const String&	GetGlossaryPath() { return GetPath( PATH_GLOSSARY ); }
	const String&	GetGraphicPath() { return GetPath( PATH_GRAPHIC ); }
	const String&	GetHelpPath() { return GetPath( PATH_HELP ); }
	const String&	GetLinguisticPath() { return GetPath( PATH_LINGUISTIC ); }
	const String&	GetModulePath() { return GetPath( PATH_MODULE ); }
	const String&	GetNewMenuPath() { return GetPath( PATH_NEWMENU ); }
	const String&	GetPalettePath() { return GetPath( PATH_PALETTE ); }
	const String&	GetPluginPath() { return GetPath( PATH_PLUGIN ); }
	const String&	GetStoragePath() { return GetPath( PATH_STORAGE ); }
	const String&	GetSubIniPath() { return GetPath( PATH_SUBINI ); }
	const String&	GetTempPath() { return GetPath( PATH_TEMP ); }
	const String&	GetTemplatePath() { return GetPath( PATH_TEMPLATE ); }
	const String&	GetTrashPath() { return GetPath( PATH_TRASH ); }
	const String&	GetUserConfigPath() { return GetPath( PATH_USERCONFIG ); }
	const String&	GetUserDictionaryPath() { return GetPath( PATH_USERDICTIONARY ); }
	const String&	GetWorkPath() { return GetPath( PATH_WORK ); }

	// set the pathes
	void			SetAddinPath( const String& rPath ) { SetPath( PATH_ADDIN, rPath ); }
	void			SetAutoCorrectPath( const String& rPath ) { SetPath( PATH_AUTOCORRECT, rPath ); }
	void			SetAutoPilotPath( const String& rPath ) { SetPath( PATH_AUTOPILOT, rPath ); }
	void			SetBackupPath( const String& rPath ) { SetPath( PATH_BACKUP, rPath ); }
	void			SetBasicPath( const String& rPath ) { SetPath( PATH_BASIC, rPath ); }
	void			SetBitmapPath( const String& rPath ) { SetPath( PATH_BITMAP, rPath ); }
	void			SetConfigPath( const String& rPath ) { SetPath( PATH_CONFIG, rPath ); }
	void			SetDatabasePath( const String& rPath ) { SetPath( PATH_DATABASE, rPath ); }
	void			SetDictionaryPath( const String& rPath ) { SetPath( PATH_DICTIONARY, rPath ); }
	void			SetFavoritesPath( const String& rPath ) { SetPath( PATH_FAVORITES, rPath ); }
	void			SetFilterPath( const String& rPath ) { SetPath( PATH_FILTER, rPath ); }
	void			SetGalleryPath( const String& rPath ) { SetPath( PATH_GALLERY, rPath ); }
	void			SetGlossaryPath( const String& rPath ) { SetPath( PATH_GLOSSARY, rPath ); }
	void			SetGraphicPath( const String& rPath ) { SetPath( PATH_GRAPHIC, rPath ); }
	void			SetHelpPath( const String& rPath ) { SetPath( PATH_HELP, rPath ); }
	void			SetLinguisticPath( const String& rPath ) { SetPath( PATH_LINGUISTIC, rPath ); }
	void			SetModulePath( const String& rPath ) { SetPath( PATH_MODULE, rPath ); }
	void			SetNewMenuPath( const String& rPath ) { SetPath( PATH_NEWMENU, rPath ); }
	void			SetPalettePath( const String& rPath ) { SetPath( PATH_PALETTE, rPath ); }
	void			SetPluginPath( const String& rPath ) { SetPath( PATH_PLUGIN, rPath ); }
	void			SetStoragePath( const String& rPath ) { SetPath( PATH_STORAGE, rPath ); }
	void			SetSubIniPath( const String& rPath ) { SetPath( PATH_SUBINI, rPath ); }
	void			SetTempPath( const String& rPath ) { SetPath( PATH_TEMP, rPath ); }
	void			SetTemplatePath( const String& rPath ) { SetPath( PATH_TEMPLATE, rPath ); }
	void			SetTrashPath( const String& rPath ) { SetPath( PATH_TRASH, rPath ); }
	void			SetUserConfigPath( const String& rPath ) { SetPath( PATH_USERCONFIG, rPath ); }
	void			SetUserDictionaryPath( const String& rPath ) { SetPath( PATH_USERDICTIONARY, rPath ); }
	void			SetWorkPath( const String& rPath ) { SetPath( PATH_WORK, rPath ); }
};

#define SVT_PATHOPTIONS()	SvtPathOptions::GetPathOptions()

#endif // #ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX

