/*************************************************************************
 *
 *  $RCSfile: zforlist.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ZFORLIST_HXX
#define _ZFORLIST_HXX

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _TABLE_HXX //autogen
#include <tools/table.hxx>
#endif
#ifndef _LANG_HXX //autogen
#include <tools/lang.hxx>
#endif
#ifndef _TOOLS_INTN_HXX //autogen
#include <tools/intn.hxx>
#endif
#ifndef _SVARRAY_HXX //autogen
#include <svarray.hxx>
#endif

class Date;
class SvStream;
class Link;
class Color;
class SvUShorts;
class CharClass;

class ImpSvNumberformatScan;
class ImpSvNumberInputScan;
class SvNumberformat;


#define SV_COUNTRY_LANGUAGE_OFFSET  5000	// Max. Anzahl Formate pro Sprache/Land
#define SV_MAX_ANZ_STANDARD_FORMATE  100	// Max. Anzahl vorgegebener Strings davon

#ifndef NUMBERFORMAT_ALL
//	werden auch in stardiv/one/util/numfrm.hxx definiert:
//!	in einzelne idl Datei und hier includen !!!
#define NUMBERFORMAT_ALL			 0x000	// Fuer Ausgabe der Gesamtliste, kein echtes Format
#define NUMBERFORMAT_DEFINED		 0x001	// Zahlenformat Benutzerdefiniert
#define NUMBERFORMAT_DATE			 0x002	// Zahlenformat Zahl als Datum
#define NUMBERFORMAT_TIME			 0x004	// Zahlenformat Zahl als Uhrzeit
#define NUMBERFORMAT_CURRENCY		 0x008	// Zahlenformat Zahl in Waehrung
#define NUMBERFORMAT_NUMBER			 0x010	// Zahlenformat Zahl
#define NUMBERFORMAT_SCIENTIFIC		 0x020	// Zahlenformat Zahl wissenschaftlich
#define NUMBERFORMAT_FRACTION		 0x040	// Zahlenformat Zahl als Bruch
#define NUMBERFORMAT_PERCENT		 0x080	// Zahlenformat Zahl in Prozent
#define NUMBERFORMAT_TEXT			 0x100	// Zahlenformat Text
#define NUMBERFORMAT_DATETIME		 0x006	// Zahlenformat Datum/Uhrzeit
#define NUMBERFORMAT_LOGICAL		 0x400	// Zahlenformat logisch
#define NUMBERFORMAT_UNDEFINED		 0x800	// Format noch unbestimmt
#endif
#define NUMBERFORMAT_ENTRY_NOT_FOUND 0xffffffff	// MAX_ULONG


// enums fuer ULONG GetFormatIndex( NfIndexTableOffset, LanguageType )
// eingebaute Standardformate, sollte auch die Anordnung in der Listbox im Dialog sein
// speziell Datum:
// SYSTEM: Systemeinstellung Regional Settings
// SYS: kurze/lange Angaben definiert, Reihenfolge und Separatoren aus System
// DEF: kurze/lange Angaben und Reihenfolge definiert, Separatoren aus System
// DIN: alle Einstellungen hart definiert
// alles andere: hart definiert
enum NfIndexTableOffset
{
	NF_NUMERIC_START = 0,

	NF_NUMBER_START = NF_NUMERIC_START,
	NF_NUMBER_STANDARD = NF_NUMBER_START,	// Standard
	NF_NUMBER_INT,							// 0
	NF_NUMBER_DEC2,							// 0,00
	NF_NUMBER_1000INT,						// #.##0
	NF_NUMBER_1000DEC2,						// #.##0,00
	NF_NUMBER_SYSTEM,						// #.##0,00 oder was immer eingestellt ist
	NF_NUMBER_END = NF_NUMBER_SYSTEM,

	NF_SCIENTIFIC_START,
	NF_SCIENTIFIC_000E000 = NF_SCIENTIFIC_START,	// 000E+000
	NF_SCIENTIFIC_000E00,							// 000E+00
	NF_SCIENTIFIC_END = NF_SCIENTIFIC_000E00,

	NF_PERCENT_START,
	NF_PERCENT_INT = NF_PERCENT_START,		// 0%
	NF_PERCENT_DEC2,						// 0,00%
	NF_PERCENT_END = NF_PERCENT_DEC2,

	NF_FRACTION_START,
	NF_FRACTION_1 = NF_FRACTION_START,		// # ?/?
	NF_FRACTION_2,							// # ??/??
	NF_FRACTION_END = NF_FRACTION_2,

	NF_NUMERIC_END = NF_FRACTION_END,

	NF_CURRENCY_START,
	NF_CURRENCY_1000INT = NF_CURRENCY_START,// #.##0 DM
	NF_CURRENCY_1000DEC2,					// #.##0,00 DM
	NF_CURRENCY_1000INT_RED,                // #.##0 DM			negativ in Rot
	NF_CURRENCY_1000DEC2_RED,				// #.##0,00 DM		negativ in Rot
	NF_CURRENCY_1000DEC2_CCC,				// #.##0,00 DEM		Bank
	NF_CURRENCY_1000DEC2_DASHED,			// #.##0,-- DM
	NF_CURRENCY_END = NF_CURRENCY_1000DEC2_DASHED,

	NF_DATE_START,
	NF_DATE_SYSTEM_SHORT = NF_DATE_START,	// 08.10.97
	NF_DATE_SYSTEM_LONG,					// Mittwoch, 8. Oktober 1997
	NF_DATE_SYS_DDMMYY,		   				// 08.10.97
	NF_DATE_SYS_DDMMYYYY,	   				// 08.10.1997
	NF_DATE_SYS_DMMMYY,	   					// 8. Okt 97
	NF_DATE_SYS_DMMMYYYY,	   				// 8. Okt 1997
	NF_DATE_DIN_DMMMYYYY,					// 8. Okt. 1997					DIN
	NF_DATE_SYS_DMMMMYYYY,					// 8. Oktober 1997
	NF_DATE_DIN_DMMMMYYYY,					// 8. Oktober 1997				DIN
	NF_DATE_SYS_NNDMMMYY,		 			// Mi, 8. Okt 97
	NF_DATE_DEF_NNDDMMMYY,		 			// Mi 08.Okt 97
	NF_DATE_SYS_NNDMMMMYYYY,	   			// Mi, 8. Oktober 1997
	NF_DATE_SYS_NNNNDMMMMYYYY,	   			// Mittwoch, 8. Oktober 1997
	NF_DATE_DIN_MMDD,		 				// 10-08						DIN
	NF_DATE_DIN_YYMMDD,		 				// 97-10-08						DIN
	NF_DATE_DIN_YYYYMMDD,	 				// 1997-10-08					DIN
	NF_DATE_SYS_MMYY,		   				// 10.97
	NF_DATE_SYS_DDMMM,						// 08.Okt
	NF_DATE_MMMM,							// Oktober
	NF_DATE_QQJJ,							// 4. Quartal 97
	NF_DATE_WW,								// Kalenderwoche
	NF_DATE_END = NF_DATE_WW,

	NF_TIME_START,
	NF_TIME_HHMM = NF_TIME_START,			// HH:MM
	NF_TIME_HHMMSS,							// HH:MM:SS
	NF_TIME_HHMMAMPM,						// HH:MM AM/PM
	NF_TIME_HHMMSSAMPM,						// HH:MM:SS AM/PM
	NF_TIME_HH_MMSS,						// [HH]:MM:SS
	NF_TIME_MMSS00,							// MM:SS,00
	NF_TIME_HH_MMSS00,	  					// [HH]:MM:SS,00
	NF_TIME_END = NF_TIME_HH_MMSS00,

	NF_DATETIME_START,
	NF_DATETIME_SYSTEM_SHORT_HHMM = NF_DATETIME_START,	// 08.10.97 01:23
	NF_DATETIME_SYS_DDMMYYYY_HHMMSS,		// 08.10.1997 01:23:45
	NF_DATETIME_END = NF_DATETIME_SYS_DDMMYYYY_HHMMSS,

	NF_BOOLEAN,								// LOGISCH
	NF_TEXT,								// @
	NF_INDEX_TABLE_ENTRIES
};


// ab Build 375
// #45717# IsNumberFormat( "98-10-24", 30, x ), eingestelltes YMD Format
// mit DMY International-Settings erkennt den String nicht als Datum.
// enum fuer SetEvalDateFormat( NfEvalDateFormat )
// wie ImpSvNumberInputScan::GetDateRef das DateFormat (YMD,DMY,MDY)
// beruecksichtigen soll, wenn aus IsNumberFormat mit Datumformat gerufen
enum NfEvalDateFormat
{
	NF_EVALDATEFORMAT_INTL,				// DateFormat nur aus International,
										// default, bisheriges Verhalten

	NF_EVALDATEFORMAT_FORMAT,			// DateFormat nur aus uebergebenem
										// Datumformat (wenn vorhanden),
										// wenn kein Datumformat uebergeben
										// wurde aus International

	NF_EVALDATEFORMAT_INTL_FORMAT,		// zuerst DateFormat aus International,
										// wenn sich damit kein gueltiges Datum
										// ergibt, mit DateFormat aus dem
										// uebergebenen Format probieren

	NF_EVALDATEFORMAT_FORMAT_INTL		// zuerst DateFormat aus uebergebenem
										// Format, wenn sich damit kein
										// gueltiges Datum ergibt, mit
										// DateFormat aus International probieren
};


#if __PRIVATE
#define _ZFORLIST_DECLARE_TABLE
#endif
#ifdef _ZFORLIST_DECLARE_TABLE
DECLARE_TABLE (SvNumberFormatTable, SvNumberformat*);
DECLARE_TABLE (SvULONGTable, ULONG*);
#else
typedef Table SvNumberFormatTable;
typedef Table SvULONGTable;
#endif


class NfCurrencyEntry
{
	XubString   		aSymbol;
	XubString		aBankSymbol;
	LanguageType	eLanguage;
	USHORT			nPositiveFormat;
	USHORT			nNegativeFormat;
	USHORT			nDigits;
	xub_Unicode			cZeroChar;

						// not implemented
						NfCurrencyEntry( const NfCurrencyEntry& );
	NfCurrencyEntry&	operator=( const NfCurrencyEntry& );

private:

#if __PRIVATE
						// nDecimalFormat := 0, 1, 2
						// #.##0 bzw. #.##0,00 bzw. #.##0,-- werden zugewiesen
	void				Impl_BuildFormatStringNumChars( XubString&,
							const International&, USHORT nDecimalFormat ) const;
#endif	// __PRIVATE

public:

						NfCurrencyEntry();
						NfCurrencyEntry( const International& );

						// EURo-Entry erzeugen, ueberschreibt andere Einstellungen
	void				SetEuro();
	BOOL				IsEuro() const;

						// Formatinformationen uebernehmen
	void				ApplyVariableInformation( const NfCurrencyEntry& );

	const XubString&		GetSymbol() const			{ return aSymbol; }
	const XubString&		GetBankSymbol() const		{ return aBankSymbol; }
	LanguageType		GetLanguage() const			{ return eLanguage; }
	USHORT				GetPositiveFormat() const	{ return nPositiveFormat; }
	USHORT				GetNegativeFormat() const	{ return nNegativeFormat; }
	USHORT				GetDigits() const			{ return nDigits; }
	xub_Unicode				GetZeroChar() const			{ return cZeroChar; }

						// [$DM-407] (bBank==FALSE) oder [$DEM] (bBank==TRUE)
						// wird zugewiesen, bei bBank==FALSE und
						// bWithoutExtension==TRUE nur [$DM]
	void				BuildSymbolString( XubString&, BOOL bBank,
							BOOL bWithoutExtension = FALSE ) const;

						// #.##0,00 [$DM-407] wird zugewiesen, Seps aus rIntl,
						// inkl. Minuszeichen aber ohne [ROT]
	void				BuildPositiveFormatString( XubString&, BOOL bBank,
							const International&, USHORT nDecimalFormat = 1 ) const;
	void				BuildNegativeFormatString( XubString&, BOOL bBank,
							const International&, USHORT nDecimalFormat = 1 ) const;

						// [$DM-407] (bzw. [$DEM] bei bBank==TRUE)
						// wird angehaengt/vorangestellt, inkl. Minuszeichen
	void				CompletePositiveFormatString( XubString&, BOOL bBank,
							USHORT nPosiFormat ) const;
	void				CompleteNegativeFormatString( XubString&, BOOL bBank,
							USHORT nNegaFormat ) const;

						// rSymStr wird angehaengt/vorangestellt, inkl. Minuszeichen
	static	void		CompletePositiveFormatString( XubString&,
							const XubString& rSymStr, USHORT nPosiFormat );
	static	void		CompleteNegativeFormatString( XubString&,
							const XubString& rSymStr, USHORT nNegaFormat );

						// Darstellung von Symbolen in Sprachen
	static	USHORT		GetEffectivePositiveFormat( USHORT nIntlFormat,
							USHORT nCurrFormat, BOOL bBank );
	static	USHORT		GetEffectiveNegativeFormat( USHORT nIntlFormat,
							USHORT nCurrFormat, BOOL bBank );

						// platform and CharSet dependent EuroSymbol
	static inline sal_Unicode	GetEuroSymbol() { return sal_Unicode(0x20AC); }
	static	sal_Char	GetEuroSymbol( rtl_TextEncoding eTextEncoding );
};

typedef NfCurrencyEntry* NfCurrencyEntryPtr;
SV_DECL_PTRARR_DEL( NfCurrencyTable, NfCurrencyEntryPtr, LANGUAGE_COUNT, 1 );
typedef XubString* WSStringPtr;
SV_DECL_PTRARR_DEL( NfWSStringsDtor, WSStringPtr, 8, 1 );


class SvNumberFormatter
{
public:								// ---- oeffentlicher Teil
	SvNumberFormatter(LanguageType eLnge);
		// Anlegen der Formatliste mit System-Sprache / Land
	~SvNumberFormatter();
		// Aufraeumen

	void SetColorLink(Link* pColorTableCallBack)
		{ pColorLink = pColorTableCallBack; }
	Color* GetUserDefColor(USHORT nIndex);
		// Fuehrt den Rueckruf auf die Color-Table aus

	void ChangeIntl(LanguageType eLnge);
		// Setzt C-L ggfs. um incl.Input und FormatSc
	void ChangeNullDate(USHORT nDay, USHORT nMonth, USHORT nYear);
		// Tauscht das Referenzdatum aus
	void ChangeStandardPrec(short nPrec);
		// tauscht Standardprecision aus
	void SetNoZero(BOOL bNZ) { bNoZero = bNZ; }
		// Setzt die Nullwert-Unterdrueckung

	BOOL IsCompatible(short eOldType, short eNewType);
		// Ueberprueft, ob die beiden Typen eingabekompatibel sind

	SvNumberFormatTable& GetEntryTable(short eType,
									   ULONG& FIndex,
									   LanguageType eLnge);
		// Holt Table mit allen Formaten des Typs eType zu Sprache/Land,
		// F_Index gibt das Standardformat zum Typ zurueck
	SvNumberFormatTable& ChangeCL(short eType,
								  ULONG& FIndex,
								  LanguageType eLnge);
		// Holt Table mit allen Formaten des Typs zu einer neuen Sprache/Land
		// und erzeugt ggfs. die neuen Standardstrings
		// Ist die Sprache neu, wird FIndex auf das Standardformat
		// des richtigen Typs gesetzt.
	SvNumberFormatTable& GetFirstEntryTable(short& eType,
											ULONG& FIndex,
											LanguageType& rLnge);
		// Gibt Table (Typ alle) und Sprache/Land passend zum Format
		// FIndex zurueck; ein unbekanntes Format wird auf Standard
		// gesetzt
	void DeleteEntry(ULONG nKey);
		// Loeschen eines Eintrags (incl. delete auf Pointer)

	BOOL PutEntry( XubString& rString, xub_StrLen& nCheckPos, short& nType, ULONG& nKey,
				  LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Neueintrag eines Formatsstrings zu Land/Sprache.
		// Gibt Typ, Formatnummer und ggfs. korrigierten String zurueck.
		// nCheckPos == 0 <=> String ist ok
		// return FALSE <=> String schon vorhanden oder nicht ok
		// return TRUE <=> String neu und ok

	BOOL PutandConvertEntry( XubString& rString, xub_StrLen& nCheckPos,
							 short& nType, ULONG& nKey,
							 LanguageType eLnge, LanguageType eNewLnge );
		// Neueintrag eines Formatsstrings. Der String ist nach eCtry/eLnge
		// formatiert und wird beim Scannen nach eNewCtry/eNewLnge konvertiert.
		// Gibt Typ, Formatnummer und ggfs. korrigierten String zurueck.
		// nCheckPos == 0 <=> String ist ok
		// return FALSE <=> String schon vorhanden oder nicht ok
		// return TRUE <=> String neu und ok

	void GenerateFormat( XubString& sString, ULONG nIndex,
						LanguageType eLnge = LANGUAGE_DONTKNOW,
						BOOL bThousand = FALSE, BOOL IsRed = FALSE,
						USHORT nPrecision = 0, USHORT nAnzLeading = 1 );
		// erzeugt Standardstrings aus den Angaben des Formatdialogs

	BOOL IsNumberFormat( const XubString& sString, ULONG& F_Index, double& fOutNumber );
		// Analyse der Eingabe: return True <=> Eingabe ist Zahl im Format
		//										F_Index mit Wert fOutNumber
		//                      return False: Eingabe ist keine Zahl

	void GetOutputString( const double& fOutNumber, ULONG nFIndex,
						  XubString& sOutString, Color** ppColor );
		// Formatiert eine Zahl gemaess Formatindex.
		// Gibt String und Farbe zurueck.

	void GetOutputString( XubString& sString, ULONG nFIndex,
						  XubString& sOutString, Color** ppColor );
		// Formatiert einen String gemaess Formatindex.
		// Gibt String und Farbe zurueck. Nur Typ Text oder 4. Teilstr.
		// sonst return FALSE und OutString == ""

	void GetInputLineString( const double& fOutNumber,
							ULONG nFIndex, XubString& sOutString );
		// Formatiert eine Zahl gemaess Standardformat zum Formatindex.
		// Gibt nur zurueck.

	BOOL GetPreviewString( const XubString& sFormatString, double fPreviewNumber,
						  XubString& sOutString, Color** ppColor,
						  LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Formatiert einen String gemaess zu scannendem Format.
		// Gibt String und Farbe zurueck. Return False <=> Format unkorrekt

	BOOL GetPreviewStringGuess( const XubString& sFormatString, double fPreviewNumber,
						  XubString& sOutString, Color** ppColor,
						  LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Formatiert einen String gemaess zu scannendem Format.
		// Gibt String und Farbe zurueck. Return False <=> Format unkorrekt.
		// Der FormatString kann english_us oder in der angegebenen Sprache sein

	ULONG TestNewString( const XubString& sFormatString,
						LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Testet, ob der String in gescannter Version bereits vorhanden ist
		// return NUMBERFORMAT_ENTRY_NOT_FOUND
		// <=> Ist in quivalenter (gescannter) Form im Baum noch nicht da

	BOOL IsTextFormat(ULONG nFIndex) const;
		// return True <=>	F_index vom Typ Text
	BOOL HasTextFormat(ULONG nFIndex) const;
		// return True <=>	F_index 4. Teilstr. vorh.

	BOOL Load( SvStream& rStream );			// Laden der Zahlenformate
	BOOL Save( SvStream& rStream ) const;	// Speichern der Zahlenformate
	void PrepareSave();						// Reset der Used-Kennungen

	void SetFormatUsed(ULONG nFIndex);		// Kennzeichnet benutzte Formate

	void GetFormatSpecialInfo(ULONG nFormat, BOOL& bThousand, BOOL& IsRed,
							  USHORT& nPrecision, USHORT& nAnzLeading);
		// Gibt die Info fuer die
		// Zusatzboxen zum Format
	USHORT GetFormatPrecision( ULONG nFormat ) const;
		// Anzahl Nachkommastellen

	ULONG GetFormatSpecialInfo( const XubString&, BOOL& bThousand, BOOL& IsRed,
							  USHORT& nPrecision, USHORT& nAnzLeading,
							  LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Gibt die Info fuer die Zusatzboxen zum FormatString durch
		// temporaren Parse, nur benutzen wenn Format noch nicht drin,
		// sonst uneffektiv..
		// return 0 wenn FormatString korrekt geparst wurde, sonst
		// Fehlerposition (wie nCheckPos bei PutEntry)

	BOOL IsUserDefined( const XubString& sStr, LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Checkt, ob der String vom Benutzer geloescht werden darf

	ULONG GetEntryKey( const XubString& sStr, LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Gibt Key des String zu C L zurueck, bzw. 0xffffffff, wenn noch nicht da

	const SvNumberformat* GetEntry(ULONG nKey)	// Zugriff auf Formate
		{ return (SvNumberformat*) aFTable.Get(nKey); }
	ULONG GetStandardIndex(LanguageType eLnge = LANGUAGE_DONTKNOW);
		// Gibt den Index des Standard- zahlenformats zurueck

	ULONG GetStandardFormat(short eType, LanguageType eLnge = LANGUAGE_DONTKNOW);
		// Liefert den Index des jeweiligen Standardformats pro Typ

	ULONG GetStandardFormat( ULONG nFIndex, short eType, LanguageType eLnge );
		// Liefert den Index des jeweiligen Standardformats pro Typ,
		// evtl. nicht das Standardformat sondern ein spezielles Standardformat,
		// z.B. fuer NF_TIME_HH_MMSS00, wenn dieses per nFIndex uebergeben wurde.

	ULONG GetStandardFormat( double fNumber, ULONG nFIndex, short eType,
							LanguageType eLnge );
		// Liefert den Index des jeweiligen Standardformats pro Typ,
		// evtl. nicht das Standardformat sondern ein spezielles Standardformat,
		// z.B. fuer NF_TIME_HH_MMSS00, oder NF_TIME_HH_MMSS bei fNumber >= 1.0

	BOOL IsSpecialStandardFormat( ULONG nFIndex, LanguageType eLnge );
		// ob nFIndex ein spezielles Standardformat ist

	Date* GetNullDate();
		// Gibt das Referenzdatum zurueck
	short GetStandardPrec();
		// Gibt die Standardprecision zurueck
	BOOL GetNoZero() { return bNoZero; }
		// Gibt die Nullwert-Unterdrueckung zurueck
	short GetType(ULONG nFIndex);
		// Gibt den Typ eines Formats zurck (bzw. UNDEFINED, wenn nicht
		// eingetragen) jedoch ohne defined-Kennung!!

	void ClearMergeTable();
		// Loescht die Merge-Liste
	SvULONGTable* MergeFormatter(SvNumberFormatter& rNewTable);
		// Traegt alle neuen Formate aus rNewTable ein und gibt eine
		// Liste mit neuen Indizes zurueck

	inline BOOL HasMergeFmtTbl() const;
	inline ULONG GetMergeFmtIndex( ULONG nOldFmt ) const;
		// gibt den Index aus der MergeTabelle zurueck; wenn eine existiert

	USHORT GetLastInsertKey(ULONG CLOffset);
		// Gibt letzte jemals gefuellte Position fuer diese CL-Kombination

	ULONG GetFormatForLanguageIfBuiltIn( ULONG nFormat,
									LanguageType eLnge = LANGUAGE_DONTKNOW );
		// Gibt den Index fuer ein eingebautes Standardformat fuer eine
		// andere Sprache zurueck. Wenn nFormat kein eingebautes Format
		// ist, wird nFormat zurueckgegeben

	ULONG GetFormatIndex( NfIndexTableOffset, LanguageType eLnge = LANGUAGE_DONTKNOW );
		// FormatIndex eingebauter Standardformate

	NfIndexTableOffset GetIndexTableOffset( ULONG nFormat ) const;
		// enum zu einem eingebauten Format, NF_INDEX_TABLE_ENTRIES wenn keins

	void SetEvalDateFormat( NfEvalDateFormat eEDF ) { eEvalDateFormat = eEDF; }
	NfEvalDateFormat GetEvalDateFormat() const { return eEvalDateFormat; }
		// Evaluierungsart und -reihenfolge von eingegebenen Datum-Strings

	void	SetYear2000( USHORT nVal );
	USHORT	GetYear2000() const;
		// TwoDigitYearStart, wie der StringScanner eine zweistellige
		// Jahreszahl behandelt.
		// Default aus VCL 1930, 30-99 19xx, 00-29 20xx
	static	USHORT	GetYear2000Default();
		// Anmerkung: historisch (vor src513e) war das mal
		// bis zu welcher Zahl der StringScanner eine zweistellige Jahreszahl
		// als 20xx erkennt, default <= 29 wird von SFX/OfaMiscCfg verwendet.
		// Der Name Year2000 ist gleich geblieben, obwohl es jetzt funktionell
		// ein TwoDigitYearStart ist.

	USHORT	ExpandTwoDigitYear( USHORT nYear ) const;
	inline	static	USHORT	ExpandTwoDigitYear( USHORT nYear, USHORT nTwoDigitYearStart );

	xub_Unicode	GetDecSep() const { return pIntl->GetNumDecimalSep(); }
		// Dezimalseparator der aktuell eingestellten Sprache

	const NfCurrencyTable& GetTheCurrencyTable() const;
		// SvPtrArr mit NfCurrencyEntry*

	const NfCurrencyEntry*	MatchSystemCurrency() const;
		// Sucht zu der eingestellten Systemwaehrung einen Eintrag aus der
		// CurrencyTable, der _nicht_ der erste (System) ist, gibt NULL wenn
		// nicht gefunden.

	const NfCurrencyEntry&	GetCurrencyEntry( LanguageType ) const;
		// Gibt einen Eintrag aus der CurrencyTable entsprechend der Sprache
		// zurueck. Wenn Sprache System ist, wird per MatchSystemCurrency
		// versucht, den Eintrag zu ermitteln. Schlaegt das fehl, oder ist die
		// Sprache nicht vertreten, wird der Eintrag fuer System zurueckgegeben.

	USHORT	GetCurrencyFormatStrings( NfWSStringsDtor&, const NfCurrencyEntry&,
				BOOL bBank ) const;
		// Standardformate fuer bestimmte Waehrung, werden angehaengt.
		// Gibt die Position des Default-Formats zurueck.
		// Bei bBank==TRUE werden nur Formatstrings mit Banksymbolen erzeugt,
		// bei bBank==FALSE die gemischten Standard-Formatstrings.

	BOOL	GetNewCurrencySymbolString( ULONG nFormat, XubString& rSymbol,
				const NfCurrencyEntry** ppEntry = NULL, BOOL* pBank = NULL ) const;
		// ob bei NUMBERFORMAT_CURRENCY ein neues SYMBOLTYPE_CURRENCY im
		// Format ist und wenn ja welches [$xxx-nnn]
		// Wenn ppEntry!=NULL ist und exakt ein Entry gefunden wurde, wird auch
		// dann ein [$xxx-nnn] geliefert, wenn im Formatstring nur [$xxx] steht!

	void	GetUsedLanguages( SvUShorts& rList );
		// Fills rList with the languages that have been allocated

	XubString GetKeyword( LanguageType eLnge, USHORT nIndex );
		// Returns a keyword for a language and NfKeywordIndex
		// for XML import, to generate number format strings.

	static void SkipNumberFormatterInStream( SvStream& );
		// ueberspringt beim Laden einen NumberFormatter im Stream, fuer Chart

private:							// ---- privater Teil
	SvNumberFormatTable aFTable;
	SvNumberFormatTable* pFormatTable;		// zur Uebergabe an UI
	SvULONGTable* pMergeTable;				// Indexliste zum Mergen zweier Formatierer
	International* pIntl;					// Lokale Intl-Klasse
	CharClass* pCharClass;					// CharacterClassification
	ImpSvNumberInputScan* pStringScanner;	// Klasse zum Scannen der Eingabe
	ImpSvNumberformatScan* pFormatScanner;	// Klasse zum Scannen der Formate
	Link* pColorLink;						// Pointer auf Link zur Abfrage von
											// benutzerdef. Farben
	ULONG MaxCLOffset;						// Maximale Cntr-Lang.Offset
	ULONG nDefaultCurrencyFormat;			// NewCurrency fuer System erst bei Bedarf
	LanguageType SysLnge;                   // System Einstellungen Land/Sprache
	LanguageType ActLnge;                   // aktuelle Einstellungen Land/Sprache
	NfEvalDateFormat eEvalDateFormat;		// DateFormat-Bestimmung
	BOOL bNoZero;							// Nullwert-Unterdrueckung

#ifdef _ZFORLIST_CXX				// ----- private Methoden -----

	static BOOL 			bCurrencyTableInitialized;
	static NfCurrencyTable	theCurrencyTable;
	static USHORT			nSystemCurrencyPosition;

	void ImpChangeSysCL(LanguageType eLnge);
		// Tauscht die Sys C L aus, loescht alle Eintraege
		// im Baum und erzeugt die neuen Standardformate
	void ImpGenerateFormats(ULONG CLOffset);
		// erzeugt Standardsatz hinter Offset
		// erzeugt den Formatsatz fuer die Kombination

	SvNumberformat* ImpInsertFormat( XubString& sStr, BOOL bStandard, ULONG nPos );
	// ImpInsertNewStandardFormat fuer neu zugefuegte Standardformate
	SvNumberformat* ImpInsertNewStandardFormat( XubString& sStr, ULONG nPos,
												USHORT nVersion );

	ULONG ImpGetCLOffset(LanguageType eLnge) const;
		// Gibt CLOffset oder MaxCLOffset + SV_COUNTRY_LANGUAGE_OFFSET,
		// wenn neue C-L-Kombination

//	ULONG ImpGetLastCLEntryKey(ULONG CLOffset, LanguageType eLnge);
		// Key des letzten C-L Eintrags

	ULONG ImpIsEntry( const XubString& rString,	// Test, ob schon da
						ULONG CLOffset, 	// return Key oder
						LanguageType eLnge );// NUMBERFORMAT_ENTRY_NOT_FOUND

	ULONG ImpGenerateCL(LanguageType eLnge);// Legt ggfs. die neuen
											// Standardstrings fuer
											// Spr./Land an, gibt
											// CLOffset zurueck
	void ImpGetNegCurrFormat( XubString& sNegStr );	// Bastelt Negative Waehrungsformate
	void ImpGetPosCurrFormat( XubString& sPosStr );	// Bastelt Positive Waehrungsformate
	void ImpGetDateFormat( XubString& sDateStr );	// Bastelt Datumsformate
	void ImpGetLongDateFormat( XubString& sDateStr,	// Bastelt lange Datumsformate
								short nShortLongDayOfWeek = 0,
								short nShortLongDay = 0,
								short nShortLongMonth = 0,
								short nShortLongYear = 0 );
							// -1: none, 0: system, 1: short, 2: long

	static void ImpInitCurrencyTable();	// legt theCurrencyTable mit NfCurrencyEntry an

	ULONG	ImpGetDefaultSystemCurrencyFormat();
		// Gibt den Index des Waehrungsformats der System Sprache zurueck,
		// ggbf. wird das Format angelegt, falls noch nicht vorhanden.

#endif // _ZFORLIST_CXX

public:

		// return current International
	inline const International* GetInternational() const { return pIntl; }

		// return the corresponding CharacterClassification wrapper
	inline const CharClass* GetCharClass() const { return pCharClass; }

};


// --------------------------- inline --------------------------------------
	// gibt den Index aus der MergeTabelle zurueck; wenn eine existiert
inline ULONG SvNumberFormatter::GetMergeFmtIndex( ULONG nOldFmt ) const
{
	ULONG* pU = pMergeTable->Count() ? (ULONG*)pMergeTable->Get( nOldFmt ) : 0;
	return pU ? *pU : nOldFmt;
}

inline BOOL SvNumberFormatter::HasMergeFmtTbl() const
{
	return 0 != pMergeTable->Count();
}


// static
inline USHORT SvNumberFormatter::ExpandTwoDigitYear(
			USHORT nYear, USHORT nTwoDigitYearStart )
{
	if ( nYear < 100 )
	{
		if ( nYear < (nTwoDigitYearStart % 100) )
			return nYear + (((nTwoDigitYearStart / 100) + 1) * 100);
		else
			return nYear + ((nTwoDigitYearStart / 100) * 100);
	}
	return nYear;
}



#endif	// _ZFORLIST_HXX
