/*************************************************************************
 *
 *  $RCSfile: zformat.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ZFORMAT_HXX
#define _ZFORMAT_HXX

#ifndef _STRING_HXX //autogen
#include <tools/string.hxx>
#endif
#ifndef _LANG_HXX //autogen
#include <tools/lang.hxx>
#endif
#ifndef _INTN_HXX //autogen
#include <tools/intn.hxx>
#endif

#include "zforlist.hxx"
#include "nfversi.hxx"


//! Fuer ImpSvNumberformatScan: zuerst die kurzen Symbole, dann die langen!
//! zB. erst TT dann TTTT
//! An die interne Reihenfolge knuepfen sich Bedingungen im Scan des Formatstring!
//! Es duerfen keine neuen Keywords eingefuegt werden, lediglich die
//! NF_KEY_UNUSEDn Eintraege duerfen benutzt werden, NF_KEY_LASTKEYWORD ist
//! entsprechend anzupassen. Sonst kommen alte Versionen ins schleudern.
//! Auswerten koennen alte Versionen diese trotzdem nicht => keine Anzeige.
//
// ER 15.12.99: This table is externally only to be used with method
// XubString SvNumberformat::GetMappedFormatstring( const NfKeywordTable&, const International& );
enum NfKeywordIndex
{
	NF_KEY_NONE = 0,
	NF_KEY_E,			// exponential symbol
	NF_KEY_AMPM,		// AM/PM
	NF_KEY_AP,			// a/p
	NF_KEY_MI,			// minute		(!)
	NF_KEY_MMI,			// minute 02	(!)
	NF_KEY_M,			// month		(!)
	NF_KEY_MM,			// month 02		(!)
	NF_KEY_MMM,			// month short name
	NF_KEY_MMMM,		// month long name
	NF_KEY_H,			// hour
	NF_KEY_HH,			// hour 02
	NF_KEY_S,			// second
	NF_KEY_SS,			// second 02
	NF_KEY_Q,			// quarter
	NF_KEY_QQ,			// quarter 02
	NF_KEY_T,			// day of month
	NF_KEY_TT,			// day of month 02
	NF_KEY_TTT,			// day of week short
	NF_KEY_TTTT,		// day of week long
	NF_KEY_JJ,			// year two digits
	NF_KEY_JJJJ,		// year four digits
	NF_KEY_NN,			// day of week short
	NF_KEY_NNNN,		// day of week long with separator
	NF_KEY_CCC,			// currency bank symbol (old version)
	NF_KEY_GENERAL,		// General / Standard
	NF_KEY_LASTOLDKEYWORD = NF_KEY_GENERAL,
	NF_KEY_NNN,			// day of week long without separator, as of version 6, 10.10.97
	NF_KEY_WW,			// week of year, as of version 8, 19.06.98
	NF_KEY_LASTKEYWORD = NF_KEY_WW,
	NF_KEY_UNUSED3,
	NF_KEY_UNUSED4,
	NF_KEY_QUARTER,		// quarter long
	NF_KEY_TRUE,		// boolean true
	NF_KEY_FALSE,		// boolean false
	NF_KEY_BOOLEAN,		// boolean
	NF_KEY_COLOR,		// color
	NF_KEY_FIRSTCOLOR,
	NF_KEY_BLACK = NF_KEY_FIRSTCOLOR,	// you know colors, don't you?
	NF_KEY_BLUE,
	NF_KEY_GREEN,
	NF_KEY_CYAN,
	NF_KEY_RED,
	NF_KEY_MAGENTA,
	NF_KEY_BROWN,
	NF_KEY_GREY,
	NF_KEY_YELLOW,
	NF_KEY_WHITE,
	NF_KEY_LASTCOLOR = NF_KEY_WHITE,
	NF_KEYWORD_ENTRIES_COUNT
};

typedef XubString NfKeywordTable [NF_KEYWORD_ENTRIES_COUNT];

// This is a bit twisted because zforscan.hxx includes zformat.hxx again but
// does not need anything else than the typedef above. But in case of the
// private SvNumberformat definitions we need ImpSvNumberformatScan.
#ifdef _ZFORMAT_CXX
#include "zforscan.hxx"
#endif


// ob Kommentar auch im Formatstring ist, ab 371 ist es so,
// soll aber moeglichst wieder rausfliegen und per Dialog gesetzt werden.
// Ab 372 Kommentar nicht mehr im Formatstring.
#if SUPD < 372
#define NF_COMMENT_IN_FORMATSTRING 1
#else
#define NF_COMMENT_IN_FORMATSTRING 0
#endif

class SvStream;
class Color;

class ImpSvNumberformatScan;			// Der Scanner der Formatstrings
class ImpSvNumberInputScan;				// Der Scanner von Zahleneingaben
class ImpSvNumMultipleWriteHeader;		// Kompatibles Dateiformat
class ImpSvNumMultipleReadHeader;		// Kompatibles Dateiformat
class SvNumberFormatter;


enum SvNumberformatLimitOps
{
	NUMBERFORMAT_OP_NO  = 0,			// Undefiniert
	NUMBERFORMAT_OP_EQ  = 1, 			// Operator =
	NUMBERFORMAT_OP_NE  = 2,			// Operator <>
	NUMBERFORMAT_OP_LT  = 3,			// Operator <
	NUMBERFORMAT_OP_LE  = 4,			// Operator <=
	NUMBERFORMAT_OP_GT  = 5,			// Operator >
	NUMBERFORMAT_OP_GE  = 6				// Operator >=
};


// SYSTEM-german to SYSTEM-xxx and vice versa conversion hack onLoad
enum NfHackConversion
{
	NF_CONVERT_NONE,
	NF_CONVERT_GERMAN_ENGLISH,
	NF_CONVERT_ENGLISH_GERMAN
};


struct ImpSvNumberformatInfo            	// Struct zur Uebergabe des Formatinfo
{
	XubString* sStrArray;				// Array der Symbole
	short* nTypeArray;					// Array der Infos
	USHORT nThousand;					// Zaehlt ....-Folgen
	USHORT nCntPre;						// Zaehlt Vorkommastellen
	USHORT nCntPost;					// Zaehlt Nachkommastellen
	USHORT nCntExp;					   	// Zaehlt Exp.Stellen, AM/PM
	short eScannedType;					// Typ gemaess Scan
	BOOL bThousand;						// Mit Tausenderpunkt

	void Copy( const ImpSvNumberformatInfo& rNumFor, USHORT nAnz );	// Kopieren
	void Load(SvStream& rStream, USHORT nAnz);				// Laden
	void Save(SvStream& rStream, USHORT nAnz) const;		// Speichern
};


class CharClass;

class ImpSvNumFor						// der Teilformatstring mit Infos
{
public:
	ImpSvNumFor();						// Konstruktor ohne Aufuellen der Info
	~ImpSvNumFor();						// Destruktor

	void Enlarge(USHORT nAnz);			// Init der Arrays auf richtige Groesse
	void Load( SvStream& rStream, ImpSvNumberformatScan& rSc,
				XubString& rLoadedColorName);		// Laden
	void Save( SvStream& rStream ) const;// Speichern

	void Copy( const ImpSvNumFor& rNumFor );	// Copyfunktion

	ImpSvNumberformatInfo& Info() { return aI;}	// Zugriff auf die Info;vorher Enlarge!!
	const ImpSvNumberformatInfo& Info() const { return aI; }

	USHORT GetnAnz() const { return nAnzStrings;}// Lesezugriff auf die Anzahl der Strings

	Color* GetColor() const { return pColor; }	// Zugriff auf die Farbe
	void SetColor( Color* pCol, XubString& rName )
	 { pColor = pCol; sColorName = rName; }
	const XubString& GetColorName() const { return sColorName; }

	BOOL HasNewCurrency() const;		// neues SYMBOLTYPE_CURRENCY im Teilformat?
	BOOL GetNewCurrencySymbol( XubString& rSymbol, XubString& rExtension ) const;
	void SaveNewCurrencyMap( SvStream& rStream ) const;
	void LoadNewCurrencyMap( SvStream& rStream );

private:
	ImpSvNumberformatInfo aI;			// Hilfsstruct fuer die restlichen Infos
	XubString sColorName;				// Farbname
	Color* pColor;						// Pointer auf die Farbe des Formats
	USHORT nAnzStrings;					// Anzahl der Symbole

};


class SvNumberformat
{
public:							// ---- oeffentlicher Teil
	SvNumberformat( ImpSvNumberformatScan& rSc, LanguageType eLge );
									// Konstruktor fuer Load
	SvNumberformat( XubString& rString,
				   ImpSvNumberformatScan* pSc,
				   ImpSvNumberInputScan* pISc,
				   xub_StrLen& nCheckPos,
				   LanguageType& eLan,
				   BOOL bStand = FALSE );

	SvNumberformat( SvNumberformat& rFormat );		// CopyKonstr.
	SvNumberformat( SvNumberformat& rFormat, ImpSvNumberformatScan& rSc );
	~SvNumberformat();

	short GetType() const
		{ return (nNewStandardDefined &&
			(nNewStandardDefined <= SV_NUMBERFORMATTER_VERSION)) ?
			(eType & ~NUMBERFORMAT_DEFINED) : eType; }

	void SetType(const short eSetType)          { eType = eSetType; }
	void SetStandard()                          { bStandard = TRUE; }
	void SetNewStandardDefined( USHORT nVer )
		{ nNewStandardDefined = nVer; eType |= NUMBERFORMAT_DEFINED; }
		// fuer Versionen vor Version nVer ist es UserDefined,
		// nVer aus SV_NUMBERFORMATTER_VERSION_...
	USHORT GetNewStandardDefined() const		{ return nNewStandardDefined; }

	LanguageType GetLanguage() const            { return eLnge;}

	const XubString& GetFormatstring()	const	{ return sFormatstring; }

		// builds a format string of application defined keywords
	XubString GetMappedFormatstring( const NfKeywordTable& rKeywords,
									const International& rIntl,
									BOOL bDontQuote = FALSE ) const;

	void SetUsed(const BOOL b)					{ bIsUsed = b; }
	BOOL GetUsed() const						{ return bIsUsed; }
	BOOL IsStarFormatSupported() const			{ return bStarFlag; }
	void SetStarFormatSupport( BOOL b )			{ bStarFlag = b; }

	NfHackConversion Load( SvStream& rStream, ImpSvNumMultipleReadHeader& rHdr,
		SvNumberFormatter* pConverter, ImpSvNumberInputScan& rISc );
											// Laden der Zahlenformate
	void Save( SvStream& rStream, ImpSvNumMultipleWriteHeader& rHdr  ) const;
											// Speichern der Zahlenformate

		// load a string which might contain an Euro symbol
		// in fact that could be any string used in number formats
	static void LoadString( SvStream& rStream, XubString& rStr );

	BOOL GetOutputString( double fNumber, XubString& OutString, Color** ppColor );
	BOOL GetOutputString( XubString& sString, XubString& OutString, Color** ppColor );
	BOOL IsTextFormat() const { return (eType & NUMBERFORMAT_TEXT) != 0; }
		// True bei Typ Text
	BOOL HasTextFormat() const { return NumFor[3].GetnAnz() > 0; }
		// True bei 4. Teilf.
	void GetFormatSpecialInfo(BOOL& bThousand,
							  BOOL& IsRed,
							  USHORT& nPrecision,
							  USHORT& nAnzLeading);
											// Gibt die Info fuer die Zusatz-
											// boxen aus
	USHORT GetFormatPrecision()				// Anzahl Nachkommastellen
		{ return NumFor[0].Info().nCntPost; }
	USHORT GetLastInsertKey()				// Schreib- und Lesezugriff auf
	 { return NumFor[0].Info().nThousand; }	// eine spezielle USHORT-Komponente
	void SetLastInsertKey(USHORT nKey)		// !! darf nur fuer das Standardformat
	 { NumFor[0].Info().nThousand = nKey; }	// 0, 5000, ... benutzt werden !!

	void ConvertLanguage( SvNumberFormatter& rConverter,
		LanguageType eConvertFrom, LanguageType eConvertTo, BOOL bSystem = FALSE );
		//! nur onLoad: konvertiert z.B. von gespeichertem nach aktuellem System

	const XubString* GetNumForString( USHORT nNumFor, USHORT nPos,
			BOOL bString = FALSE ) const;
		// TeilString eines Formats (0..3), nPos == 0xFFFF => letzter
		// bString==TRUE: erster/letzter SYMBOLTYPE_STRING oder SYMBOLTYPE_CURRENCY

	short GetNumForType( USHORT nNumFor, USHORT nPos, BOOL bString = FALSE ) const;
		// TeilTyp eines Formats (0..3), nPos == 0xFFFF => letzter
		// bString==TRUE: erster/letzter SYMBOLTYPE_STRING oder SYMBOLTYPE_CURRENCY

	BOOL IsNegativeRealNegative() const
		{	// zweites Teilformat wirklich fuer negative Zahlen?
			return fLimit1 == 0.0 && fLimit2 == 0.0 &&
			( (eOp1 == NUMBERFORMAT_OP_GE && eOp2 == NUMBERFORMAT_OP_NO) ||
			  (eOp1 == NUMBERFORMAT_OP_GT && eOp2 == NUMBERFORMAT_OP_LT) ||
			  (eOp1 == NUMBERFORMAT_OP_NO && eOp2 == NUMBERFORMAT_OP_NO) );
		}

	BOOL IsNegativeWithoutSign() const;
		// hat negativ Format kein Vorzeichen?

	BOOL HasNewCurrency() const;
		// neues SYMBOLTYPE_CURRENCY im Format?

	void Build50Formatstring( XubString& rStr ) const;
		// NewCurrency -> String

	BOOL GetNewCurrencySymbol( XubString& rSymbol, XubString& rExtension ) const;
		// ob bei NUMBERFORMAT_CURRENCY ein neues SYMBOLTYPE_CURRENCY im
		// Format ist und wenn ja welches, xxx und nnn von [$xxx-nnn]

	static BOOL HasStringNegativeSign( const XubString& rStr );

		// Ob Zeichen an nPos innerhalb von zwei matchenden cQuote liegt.
		// Zeigt nPos auf ein cQuote, wird bei einem oeffnenden cQuote TRUE
		// zurueckgegeben, bei einem schliessenden cQuote FALSE.
		// Ein cQuote kann innerhalb eines Quotes durch ein cEscIn escaped
		// sein, ausserhalb durch ein cEscOut.
		// Der Default '\0' bewirkt, dass kein Escapement moeglich ist.
		// Defaults sind fuer die Unlogik des Numberformatters richtig gesetzt.
	static BOOL IsInQuote( const XubString&, xub_StrLen nPos, xub_Unicode cQuote = '"',
				xub_Unicode cEscIn = '\0', xub_Unicode cEscOut = '\\' );

		// Position des matchenden Ende-cQuote wenn Zeichen an nPos innerhalb
		// von zwei matchenden cQuote liegt, sonst STRING_NOTFOUND.
		// Zeigt nPos auf ein oeffnendes cQuote, wird die Position des
		// zugehoerigen schliessenden cQuote zurueckgegeben. Zeigt nPos auf ein
		// schliessendes cQuote, wird nPos zurueckgegeben. Zeigt nPos in einen
		// Teil, der mit einem oeffnenden Quote anfaengt aber kein schliessendes
		// Quote hat, wird XubString.Len() zurueckgegeben.
		// Verwendet IsInQuote, selbiges muss also nicht vorher aufgerufen werden.
	static xub_StrLen GetQuoteEnd( const XubString&, xub_StrLen nPos, xub_Unicode cQuote = '"',
				xub_Unicode cEscIn = '\0', xub_Unicode cEscOut = '\\' );


	void SetComment( const XubString& rStr )		// setzt Kommentar
#if NF_COMMENT_IN_FORMATSTRING
		{ SetComment( rStr, sFormatstring, sComment ); }
#else
		{ sComment = rStr; }
#endif
	const XubString& GetComment() { return sComment; }

	// ggbf. "{ "..." }" aus Formatteilstring loeschen, um auf Comment zu kommen
	static void EraseCommentBraces( XubString& rStr );
	// setzt Kommentar rStr an Formatstring rFormat und in rComment
	static void SetComment( const XubString& rStr, XubString& rFormat, XubString& rComment );
	// loescht Kommentar am Ende von rStr um reinen Formatstring zu erhalten
	static void EraseComment( XubString& rStr );


	DateFormat GetDateOrder() const;	// YMD,DMY,MDY bei Datumformat

	ImpSvNumberformatScan& ImpGetScan() const { return rScan; }

	// used in XML export
	void GetConditions( SvNumberformatLimitOps& rOper1, double& rVal1,
						SvNumberformatLimitOps& rOper2, double& rVal2 ) const;
	Color* GetColor( USHORT nNumFor ) const;

private:						// ---- privater Teil
	ImpSvNumFor NumFor[4];			// Array fuer die 4 Teilformate
	XubString sFormatstring;			// Der Formatstring
	XubString sComment;				// Kommentar ab Version 6
	double fLimit1;					// Zahl fuer erste Bedingung
	double fLimit2;					// Zahl fr zweite Bedingung
	ImpSvNumberformatScan& rScan;	// Referenz auf die Formatscanklasse
	LanguageType eLnge;				// Sprache des Formats
	SvNumberformatLimitOps eOp1;	// Operator fuer die erste Bedingung
	SvNumberformatLimitOps eOp2;	// Operator fuer die zweite Bedingung
	USHORT nNewStandardDefined;		// neue Standardformate ab Version 6
	short eType;					// Typ des Gesamtformats
	BOOL bStarFlag;					// *n-Format als ESC n uebernehmen
	BOOL bStandard;					// Kennzeichnet ein Standardformat
	BOOL bIsUsed;					// Kennzeichnet benutzte Formate zum Speichern

#ifdef _ZFORMAT_CXX				// ----- private Methoden -----

	const International& rIntl() const { return rScan.GetIntl(); }
	const CharClass& rChrCls() const { return rScan.GetChrCls(); }

	short ImpNextSymbol( XubString& rString,
					 xub_StrLen& nPos,
					 XubString& sSymbol );
									// lexikalsiche Analyse Farben-Bedingungen
	xub_StrLen ImpGetNumber( XubString& rString,
				   xub_StrLen& nPos,
				   XubString& sSymbol );// liest String bis zur naechsten ']'
									// (hinter einer Bedingung)
	void ImpGetOutputStandard( double& fNumber, XubString& OutString );
									// Ausgabe des Standardzahlenformats
	void ImpGetOutputInputLine( double fNumber, XubString& OutString );
									// Sonderfall Zahlen in InputLine

	short ImpCheckCondition(double& fNumber,
						 double& fLimit,
						 SvNumberformatLimitOps eOp);
									// Prueft die Teilbedingungen ab
									// Op undefiniert => -1, sonst 0 oder 1
	ULONG ImpGGT(ULONG x, ULONG y);	// Bestimmt GGT nach Euklid
	ULONG ImpGGTRound(ULONG x, ULONG y);
									// Erlaubt auch ungenauen GGT
/*	void ImpGetNextFareyNumber(ULONG nPrec, ULONG x0, ULONG x1,
							ULONG y0, ULONG y1,
							ULONG& x2,ULONG& y2);
									// Bestimmt die gekuerzten Brueche in
									// aufsteigender Reihenfolge
									// (2stufige Rekursion, Farey Series,
									// Knuth)
*/

	BOOL ImpNumberFill( XubString& sStr,
					double& rNumber,
					xub_StrLen& k,
					USHORT& j,
					USHORT nIx,
					short eSymbolType );
									// Hilfsfunktion zum Abarbeiten von Zahlen
									// (ergaenzen mit Stringsymbolen,auffuellen
									// mit fuehrender 0 oder ' ', ...)
	BOOL ImpNumberFillWithThousands( XubString& sStr,
								 double& rNumber,
								 xub_StrLen k,
								 USHORT j,
								 USHORT nIx,
								 USHORT nDigCnt );
									// Hilfsfunktion zum Auffuellen der Vor-
									// kommazahl auch mit Tausenderpunkt
	void ImpDigitFill( XubString& sStr,
					xub_StrLen nStart,
					xub_StrLen& k,
					USHORT nIx,
					USHORT nThousandCnt );
									// Hilfsfunktion zum Auffuellen mit Tau-
									// senderpunkten oder zum Ueberspringen
									// weiterer Ziffern
	BOOL ImpGetDateOutput( double fNumber,
					   USHORT nIx,
					   XubString& OutString );
	BOOL ImpGetTimeOutput( double fNumber,
					   USHORT nIx,
					   XubString& OutString );
									// Hilfsfunktion zur Datumsausgabe
	BOOL ImpGetDateTimeOutput( double fNumber,
						   USHORT nIx,
						   XubString& OutString );
									// Hilfsfunktion zur gemeinsamen Datums-
									// Zeitausgabe
	BOOL ImpGetNumberOutput( double fNumber,
						 USHORT nIx,
						 XubString& OutString );
									// Hilfsfunktion zur Ausgabe von Zahlen
	void CopyNumberformat( const SvNumberformat& rFormat );

#endif // _ZFORMAT_CXX
};



#endif	// _ZFORMAT_HXX
