#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.1.1.1 $
#
#   last change: $Author: hr $ $Date: 2000/09/18 16:58:55 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

.IF "$(COM)" == "ICC"


PRJ=..$/..$/..

PRJNAME=svtools
TARGET=wpswrt5

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

.SUFFIXES: .cxx .hxx .c .asm .obj .qbj .lib .plb .rc .res .dll .exe .hcd .pch .pcs .ih .csc

MYRES=$(PRJ)$/WIN\res

SCPATH=$(DEVROOT)$/toolkt21\sc
SMINCLUDE=$(SCPATH)
SMTMP=$(TMP)
#!if "$(COM)" == "BLC"
#keine Underlines fuer som
#CFLAGS=$(CFLAGS) -u-
#!endif

.IF "$(COM)" == "ICC"

# Compile- & Linkflags siehe TOOLKIT\SAMPLES\WPCAR
CFLAGS= /c /Gd- /Se /Re /ss /Ms /Gm+ /Ge- /D__EXTENDED__
LINKFLAGS= /noi /map /nol /nod /exepack /packcode /packdata /align:16
LINK=LINK386
LINKFLAGSAPPGUI=
LINKFLAGSSHLGUI=
LINKFLAGSAPPCUI=
LINKFLAGSSHLCUI=
LINKFLAGSTACK=
LINKFLAGSPROF=
LINKFLAGSDEBUG=
LINKFLAGSOPT=
LINKFLAGSAPP=
LINKFLAGSSHL=

.ENDIF

# Icons lokal (braucht IBM Resource-Compiler)
MYRES=.

# --- Files --------------------------------------------------------

.IF "$(COM)" == "ICC"
SLOFILES= \
	$(SLO)$/wpsexe.obj	\
	$(SLO)$/wpswri.obj	\
	$(SLO)$/wpscalc.obj	\
	$(SLO)$/wpsdraw.obj	\
	$(SLO)$/wpschar.obj	\
	$(SLO)$/wpsmath.obj	\
	$(SLO)$/wpsimpl.obj	\
	$(SLO)$/wpsglob.obj	\
	$(SLO)$/wpsimpr.obj	\
	$(SLO)$/wpshtml.obj


LIBS= \
	dde4mbs.lib \
	os2386.lib \
        $(DEVROOT)$/toolkt21\os2lib\som
.ENDIF

LIB1TARGET=$(SLB)$/wps.lib
LIB1OBJFILES=  \
	$(SLO)$/wpsexe.obj	\
	$(SLO)$/wpswri.obj	\
	$(SLO)$/wpscalc.obj	\
	$(SLO)$/wpsdraw.obj	\
	$(SLO)$/wpschar.obj	\
	$(SLO)$/wpsmath.obj	\
	$(SLO)$/wpsimpl.obj	\
	$(SLO)$/wpsglob.obj	\
	$(SLO)$/wpsimpr.obj	\
	$(SLO)$/wpshtml.obj

.IF "$(depend)" == ""

ALL: $(SLB)$/wps.lib		\
	 $(BIN)$/wpswrt4.dll	\
	 ALLTAR

.ENDIF

# --- Targets ---------------------------------------------------------

# fuer $(INCLUDE)

.INCLUDE :  target.mk

.IF "$(depend)" == ""

$(BIN)$/wpswrt5.dll: \
		$(SLB)$/wps.lib 	\
#                $(RES)$/wpswrt3.res      \
		$(MYRES)$/wpsexe.ico
    @echo --------------------------------------------
	@echo DLL erstellen
	$(LINK) $(LINKFLAGS) $(DLLLINKFLAGS) @<<
		$(SLB)$/wps.lib
		$@
		$(LIST)$/$(@B).map
		$(LIBS)
		wpswrt3.def
<<
#        rc -k -t $(RES)$/wpswrt3.res $@

.csc.ih:
		set SMINCLUDE=$(SCPATH)
		set SMEMIT=h;ih;c
		set SMTMP=$(TMP)
		if exist $(@B).h attrib -r $(@B).h
		if exist $(@B).ih attrib -r $(@B).ih
        sc -v $*
#		sed -f def.sed $*.def > x
#		copy x $*.def

#$(RES)$/wpswrt3.res: wpswrt3.rc $(MYRES)$/wpsexe.ico
#    rc -r $(@B).rc $@

wpswri.ih: wpswri.csc
wpswri.c: wpswri.csc wpswri.ih
$(SLO)$/wpswri.obj: wpswri.c wps_port.h

wpscalc.ih: wpscalc.csc
wpscalc.c: wpscalc.csc wpscalc.ih
$(SLO)$/wpscalc.obj: wpscalc.c wps_port.h

wpsdraw.ih: wpsdraw.csc
wpsdraw.c: wpsdraw.csc wpsdraw.ih
$(SLO)$/wpsdraw.obj: wpsdraw.c wps_port.h

wpschar.ih: wpschar.csc
wpschar.c: wpschar.csc wpschar.ih
$(SLO)$/wpschar.obj: wpschar.c wps_port.h

wpsmath.ih: wpsmath.csc
wpsmath.c: wpsmath.csc wpsmath.ih
$(SLO)$/wpsmath.obj: wpsmath.c wps_port.h

wpsexe.ih: wpsexe.csc
wpsexe.c: wpsexe.csc wpsexe.ih
$(SLO)$/wpsexe.obj: wpsexe.c wps_port.h

wpsglob.ih: wpsglob.csc
wpsglob.c: wpsglob.csc wpsglob.ih
$(SLO)$/wpsglob.obj: wpsglob.c wps_port.h

wpshtml.ih: wpshtml.csc
wpshtml.c: wpshtml.csc wpshtml.ih
$(SLO)$/wpshtml.obj: wpshtml.c wps_port.h

wpsimpr.ih: wpsimpr.csc
wpsimpr.c: wpsimpr.csc wpsimpr.ih
$(SLO)$/wpsimpr.obj: wpsimpr.c wps_port.h

$(SLO)$/wpsimpl.obj: wpsimpl.c wpsimpl.h

.ENDIF
.ENDIF

