/*************************************************************************
 *
 *  $RCSfile: wpsexe.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef wpsexe_h
#define wpsexe_h


#include <som.h>

/*
 * Define the class name as an object type
 */
#ifndef WPStOfExe5
#define WPStOfExe5 SOMAny
#endif
#include "wppgm.h"

#define WPStOfExe5_MajorVersion 1
#define WPStOfExe5_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define WPStOfExe5NewClass wpstofexe5c
#pragma linkage(wpstofexe5c, system)
#define WPStOfExe5ClassData wpstofexe5d
#define WPStOfExe5CClassData wpstofexe5x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define WPStOfExe5_classObj WPStOfExe5ClassData.classObject
#define _WPStOfExe5 WPStOfExe5_classObj

/*
 * New and Renew macros for WPStOfExe5
 */
#define _WPStOfExe5New() (_somNew(WPStOfExe5ClassData.classObject))
#define WPStOfExe5New() \
	( WPStOfExe5ClassData.classObject \
		? _WPStOfExe5New() \
		: ( WPStOfExe5NewClass(WPStOfExe5_MajorVersion, WPStOfExe5_MinorVersion), _WPStOfExe5New() ) )
#define WPStOfExe5Renew(buf) \
	( _somRenew(WPStOfExe5ClassData.classObject, buf) )

/*
 * Override method: wpOpen
 */
#define WPStOfExe5_wpOpen(somSelf,hwndCnr,ulView,param) \
	WPObject_wpOpen(somSelf,hwndCnr,ulView,param)

/*
 * Override method: wpDrop
 */
#define WPStOfExe5_wpDrop(somSelf,hwndCnr,pdrgInfo,pdrgItem) \
	WPObject_wpDrop(somSelf,hwndCnr,pdrgInfo,pdrgItem)

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK WPStOfExe5NewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(WPStOfExe5NewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct WPStOfExe5ClassDataStructure {
	SOMAny *classObject;
} WPStOfExe5ClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct WPStOfExe5CClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} WPStOfExe5CClassData;

#endif       /* wpsexe_h */

/*
 * This file was generated by the SOM Compiler.
 * FileName: wpsexe.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter N:\TOOLKT21\OS2BIN\EMITH.EXE: 1.11
 */

#ifndef wpsexe_mh
#define wpsexe_mh


/*
 * Define the class name as an object type
 */
#ifndef M_WPStOfExe5
#define M_WPStOfExe5 SOMAny
#endif

#define M_WPStOfExe5_MajorVersion 1
#define M_WPStOfExe5_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_WPStOfExe5NewClass wpstofexe5c
#pragma linkage(wpstofexe5c, system)
#define M_WPStOfExe5ClassData wpstofexe5d
#define M_WPStOfExe5CClassData wpstofexe5x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_WPStOfExe5_classObj M_WPStOfExe5ClassData.classObject
#define _M_WPStOfExe5 M_WPStOfExe5_classObj

/*
 * New and Renew macros for M_WPStOfExe5
 */
#define _M_WPStOfExe5New() (_somNew(M_WPStOfExe5ClassData.classObject))
#define M_WPStOfExe5New() \
	( M_WPStOfExe5ClassData.classObject \
		? _M_WPStOfExe5New() \
		: ( M_WPStOfExe5NewClass(M_WPStOfExe5_MajorVersion, M_WPStOfExe5_MinorVersion), _M_WPStOfExe5New() ) )
#define M_WPStOfExe5Renew(buf) \
	( _somRenew(M_WPStOfExe5ClassData.classObject, buf) )

/*
 * Override method: wpclsQueryStyle
 */
#define M_WPStOfExe5_wpclsQueryStyle(somSelf) \
	M_WPObject_wpclsQueryStyle(somSelf)

/*
 * Override method: wpclsQueryTitle
 */
#define M_WPStOfExe5_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK M_WPStOfExe5NewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(M_WPStOfExe5NewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_WPStOfExe5ClassDataStructure {
	SOMAny *classObject;
} M_WPStOfExe5ClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_WPStOfExe5CClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} M_WPStOfExe5CClassData;

#endif       /* wpsexe_h */
