/*************************************************************************
 *
 *  $RCSfile: wpsimpr.h,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:58:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef wpsimpr_h
#define wpsimpr_h


#include <som.h>

/*
 * Define the class name as an object type
 */
#ifndef WPStOfImpr5
#define WPStOfImpr5 SOMAny
#endif
#include "wpdataf.h"

#define WPStOfImpr5_MajorVersion 1
#define WPStOfImpr5_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define WPStOfImpr5NewClass wpstofimpr5c
#pragma linkage(wpstofimpr5c, system)
#define WPStOfImpr5ClassData wpstofimpr5d
#define WPStOfImpr5CClassData wpstofimpr5x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define WPStOfImpr5_classObj WPStOfImpr5ClassData.classObject
#define _WPStOfImpr5 WPStOfImpr5_classObj

/*
 * New and Renew macros for WPStOfImpr5
 */
#define _WPStOfImpr5New() (_somNew(WPStOfImpr5ClassData.classObject))
#define WPStOfImpr5New() \
	( WPStOfImpr5ClassData.classObject \
		? _WPStOfImpr5New() \
		: ( WPStOfImpr5NewClass(WPStOfImpr5_MajorVersion, WPStOfImpr5_MinorVersion), _WPStOfImpr5New() ) )
#define WPStOfImpr5Renew(buf) \
	( _somRenew(WPStOfImpr5ClassData.classObject, buf) )

/*
 * Override method: wpPrintObject
 */
#define WPStOfImpr5_wpPrintObject(somSelf,pPrintDest,ulReserved) \
	WPObject_wpPrintObject(somSelf,pPrintDest,ulReserved)

/*
 * Override method: wpOpen
 */
#define WPStOfImpr5_wpOpen(somSelf,hwndCnr,ulView,param) \
	WPObject_wpOpen(somSelf,hwndCnr,ulView,param)

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK WPStOfImpr5NewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(WPStOfImpr5NewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct WPStOfImpr5ClassDataStructure {
	SOMAny *classObject;
} WPStOfImpr5ClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct WPStOfImpr5CClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} WPStOfImpr5CClassData;

#endif       /* wpsimpr_h */

/*
 * This file was generated by the SOM Compiler.
 * FileName: wpsimpr.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter N:\TOOLKT21\OS2BIN\EMITH.EXE: 1.11
 */

#ifndef wpsimpr_mh
#define wpsimpr_mh


/*
 * Define the class name as an object type
 */
#ifndef M_WPStOfImpr5
#define M_WPStOfImpr5 SOMAny
#endif

#define M_WPStOfImpr5_MajorVersion 1
#define M_WPStOfImpr5_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_WPStOfImpr5NewClass wpstofimpr5c
#pragma linkage(wpstofimpr5c, system)
#define M_WPStOfImpr5ClassData wpstofimpr5d
#define M_WPStOfImpr5CClassData wpstofimpr5x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_WPStOfImpr5_classObj M_WPStOfImpr5ClassData.classObject
#define _M_WPStOfImpr5 M_WPStOfImpr5_classObj

/*
 * New and Renew macros for M_WPStOfImpr5
 */
#define _M_WPStOfImpr5New() (_somNew(M_WPStOfImpr5ClassData.classObject))
#define M_WPStOfImpr5New() \
	( M_WPStOfImpr5ClassData.classObject \
		? _M_WPStOfImpr5New() \
		: ( M_WPStOfImpr5NewClass(M_WPStOfImpr5_MajorVersion, M_WPStOfImpr5_MinorVersion), _M_WPStOfImpr5New() ) )
#define M_WPStOfImpr5Renew(buf) \
	( _somRenew(M_WPStOfImpr5ClassData.classObject, buf) )

/*
 * Override method: wpclsQueryInstanceFilter
 */
#define M_WPStOfImpr5_wpclsQueryInstanceFilter(somSelf) \
	M_WPFileSystem_wpclsQueryInstanceFilter(somSelf)

/*
 * Override method: wpclsQueryInstanceType
 */
#define M_WPStOfImpr5_wpclsQueryInstanceType(somSelf) \
	M_WPFileSystem_wpclsQueryInstanceType(somSelf)

/*
 * Override method: wpclsQueryStyle
 */
#define M_WPStOfImpr5_wpclsQueryStyle(somSelf) \
	M_WPObject_wpclsQueryStyle(somSelf)

/*
 * Override method: wpclsCreateDefaultTemplates
 */
#define M_WPStOfImpr5_wpclsCreateDefaultTemplates(somSelf,Folder) \
	M_WPObject_wpclsCreateDefaultTemplates(somSelf,Folder)

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK M_WPStOfImpr5NewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(M_WPStOfImpr5NewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_WPStOfImpr5ClassDataStructure {
	SOMAny *classObject;
} M_WPStOfImpr5ClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_WPStOfImpr5CClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} M_WPStOfImpr5CClassData;

#endif       /* wpsimpr_h */
