/*************************************************************************
 *
 *  $RCSfile: lckbitem.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif

#ifndef _CACHESTR_HXX //autogen
#include <tools/cachestr.hxx>
#endif

#define _LCKBITEM_CXX
#include "lckbitem.hxx"
#include "args.hxx"
#include "poolitem.hxx"
#include "segmentc.hxx"

// STATIC DATA -----------------------------------------------------------

SEG_EOFGLOBALS()

// -----------------------------------------------------------------------

TYPEINIT1_AUTOFACTORY(SfxLockBytesItem, SfxPoolItem);

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(stritem_01)

SfxLockBytesItem::SfxLockBytesItem()
{
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_02)

SfxLockBytesItem::SfxLockBytesItem( USHORT nW, SvLockBytes *pLockBytes )
:	SfxPoolItem( nW ),
	_xVal( pLockBytes )
{
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_03)

SfxLockBytesItem::SfxLockBytesItem( USHORT nW, SvStream &rStream )
:	SfxPoolItem( nW )
{
	rStream.Seek( 0L );
	_xVal = new SvLockBytes( new SvCacheStream(), TRUE );

	SvStream aLockBytesStream( _xVal );
	rStream >> aLockBytesStream;
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_04)

SfxLockBytesItem::SfxLockBytesItem( const SfxLockBytesItem& rItem )
:	SfxPoolItem( rItem ),
	_xVal( rItem._xVal )
{
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_05)

SfxLockBytesItem::~SfxLockBytesItem()
{
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_06)

int SfxLockBytesItem::operator==( const SfxPoolItem& rItem ) const
{
	return ((SfxLockBytesItem&)rItem)._xVal == _xVal;
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_07)

SfxPoolItem* SfxLockBytesItem::Clone(SfxItemPool *) const
{
	return new SfxLockBytesItem( *this );
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_08)

#define MAX_BUF	32000

SfxPoolItem* SfxLockBytesItem::Create( SvStream &rStream, USHORT nVersion ) const
{
	ULONG nSize = 0;
	ULONG nActRead = 0;
	sal_Char cTmpBuf[MAX_BUF];
	SvMemoryStream aNewStream;
	rStream >> nSize;

	do {
		ULONG nToRead;
		if( (nSize - nActRead) > MAX_BUF )
			nToRead = MAX_BUF;
		else
			nToRead = nSize - nActRead;
		nActRead += rStream.Read( cTmpBuf, nToRead );
		aNewStream.Write( cTmpBuf, nToRead );
	} while( nSize > nActRead );

	return new SfxLockBytesItem( Which(), aNewStream );
}

// -----------------------------------------------------------------------
#pragma SEG_FUNCDEF(lockbitem_09)

SvStream& SfxLockBytesItem::Store(SvStream &rStream, USHORT nItemVersion ) const
{
	SvStream aLockBytesStream( _xVal );
	ULONG nSize = aLockBytesStream.Seek( STREAM_SEEK_TO_END );
	aLockBytesStream.Seek( 0L );

	rStream << nSize;
	rStream << aLockBytesStream;

	return rStream;
}

//----------------------------------------------------------------------------
// virtual
BOOL SfxLockBytesItem::PutValue( const com::sun::star::uno::Any& rVal,
						   		 BYTE nMemberId )
{
	com::sun::star::uno::Sequence< sal_Int8 > aSeq;
	if ( rVal >>= aSeq )
	{
		if ( aSeq.getLength() )
		{
			SvCacheStream* pStream = new SvCacheStream;
			pStream->Write( (void*)aSeq.getConstArray(), aSeq.getLength() );

			_xVal = new SvLockBytes( pStream, TRUE );
		}
		else
			_xVal = NULL;

		return TRUE;
	}

	DBG_ERROR( "SfxLockBytesItem::PutValue - Wrong type!" );
	return FALSE;
}

//----------------------------------------------------------------------------
// virtual
BOOL SfxLockBytesItem::QueryValue( com::sun::star::uno::Any& rVal,
							 	   BYTE nMemberId ) const
{
	if ( _xVal.Is() )
	{
		sal_uInt32 nLen;
		SvLockBytesStat aStat;

		if ( _xVal->Stat( &aStat, SVSTATFLAG_DEFAULT ) == ERRCODE_NONE )
			nLen = aStat.nSize;
		else
			return FALSE;

		ULONG nRead = 0;
		com::sun::star::uno::Sequence< sal_Int8 > aSeq( nLen );

		_xVal->ReadAt( 0, aSeq.getArray(), nLen, &nRead );
		rVal <<= aSeq;
	}
	else
	{
		com::sun::star::uno::Sequence< sal_Int8 > aSeq( 0 );
		rVal <<= aSeq;
	}

	return TRUE;
}

/*------------------------------------------------------------------------

	$Log: lckbitem.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:59:01  hr
	initial import
	
	Revision 1.13  2000/09/18 14:13:34  willem.vandorp
	OpenOffice header added.
	
	Revision 1.12  2000/08/31 13:41:28  willem.vandorp
	Header and footer replaced
	
	Revision 1.11  2000/04/12 08:01:39  sb
	Adapted to Unicode.
	
	Revision 1.10  2000/03/22 11:49:37  kso
	Removed: SmartUno leftovers.
	
	Revision 1.9  2000/02/21 09:33:42  kso
	#68274# - Added: [Put|QueryValue( ... com::sun::star::uno::Any ... )

	Revision 1.8  1999/03/18 07:52:34  KSO
	#63656# - Implemented SfxLockBytesItem::[Put|Query]Value(...) methods.


	  Rev 1.7   18 Mar 1999 08:52:34   KSO
   #63656# - Implemented SfxLockBytesItem::[Put|Query]Value(...) methods.

	  Rev 1.6   09 Jun 1998 18:43:46   OK
   FIX: Laenge des Stream wird rusgeschrieben!

	  Rev 1.5   17 Mar 1998 18:29:04   OK
   FIX: Ctor mit Stream muss vorher LBRef erzeugen!

	  Rev 1.4   19 Jan 1998 19:18:34   MH
   chg: header

	  Rev 1.3   03 Feb 1997 10:00:26   MI
   Dtor

	  Rev 1.2   31 Jan 1997 12:16:18   MI
   internal/external header

	  Rev 1.1   31 Jan 1997 11:58:24   MI
   1. Version

	  Rev 1.0   31 Jan 1997 11:10:54   MI
   Initial revision.

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE

