/*************************************************************************
 *
 *  $RCSfile: sitem.cxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hr $ $Date: 2000/09/18 16:59:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// INCLUDE ---------------------------------------------------------------

#pragma hdrstop

#include <tools/string.hxx>
#include <tools/stream.hxx>

#include "poolitem.hxx"
#include "itemset.hxx"


// STATIC DATA -----------------------------------------------------------

DBG_NAME(SfxSetItem);

// --------------------------------------------------------------------------

SfxSetItem::SfxSetItem( USHORT nWhich, const SfxItemSet &rSet) :
	SfxPoolItem(nWhich),
	pSet(rSet.Clone(TRUE))
{
	DBG_CTOR(SfxSetItem, 0);
}

// --------------------------------------------------------------------------

SfxSetItem::SfxSetItem( USHORT nWhich, SfxItemSet *pS) :
	SfxPoolItem(nWhich),
	pSet(pS)
{
	DBG_CTOR(SfxSetItem, 0);
	DBG_ASSERT(pS, "SfxSetItem without set constructed" );
}

// --------------------------------------------------------------------------

SfxSetItem::SfxSetItem( const SfxSetItem& rCopy, SfxItemPool *pPool ) :
	SfxPoolItem(rCopy.Which()),
	pSet(rCopy.pSet->Clone(TRUE, pPool))
{
	DBG_CTOR(SfxSetItem, 0);
}

// --------------------------------------------------------------------------

SfxSetItem::~SfxSetItem()
{
	DBG_DTOR(SfxSetItem, 0);
	delete pSet; pSet = 0;
}

// --------------------------------------------------------------------------

int SfxSetItem::operator==( const SfxPoolItem& rCmp) const
{
	DBG_CHKTHIS(SfxSetItem, 0);
	DBG_ASSERT( SfxPoolItem::operator==( rCmp ), "unequal type" );
	return *pSet == *(((const SfxSetItem &)rCmp).pSet);
}

// --------------------------------------------------------------------------

SfxItemPresentation SfxSetItem::GetPresentation
(
	SfxItemPresentation     ePresentation,
	SfxMapUnit              eCoreMetric,
	SfxMapUnit              ePresentationMetric,
	XubString&               rText,
	const International *
)   const
{
	DBG_CHKTHIS(SfxSetItem, 0);
	return SFX_ITEM_PRESENTATION_NONE;
}

// --------------------------------------------------------------------------

SvStream& SfxSetItem::Store(SvStream& rStream, USHORT nVer) const
{
	GetItemSet().Store(rStream);
	return rStream;
}

/*------------------------------------------------------------------------

	$Log: sitem.cxx,v $
	Revision 1.1.1.1  2000/09/18 16:59:01  hr
	initial import
	
	Revision 1.20  2000/09/18 14:13:35  willem.vandorp
	OpenOffice header added.
	
	Revision 1.19  2000/08/31 13:41:28  willem.vandorp
	Header and footer replaced
	
	Revision 1.18  2000/02/09 16:23:54  hr
	#70473# changes for unicode ( patched by automated patchtool )
	
	Revision 1.17  1999/09/01 06:52:37  sb
	#66082# Added International param to SfxPoolItem::GetPresentation().
	
	Revision 1.16  1997/07/02 11:40:12  MH
	headerfile Unstellung auf Unterverzeichnisse
	

	  Rev 1.15   02 Jul 1997 13:40:12   MH
   headerfile Unstellung auf Unterverzeichnisse

	  Rev 1.14   18 Nov 1996 19:14:34   JOE
   SetItem::Store() nun nicht mehr pure weil trivial

	  Rev 1.13   20 Nov 1995 12:14:30   AB
   Unicode-Anpassung

	  Rev 1.12   05 Jul 1995 18:11:38   MI
   GetValueText raus #pragmas rein

	  Rev 1.11   29 Jun 1995 17:16:20   MI
   GetPresentation impl.

	  Rev 1.10   04 Apr 1995 15:08:12   MI
   Assertion bei Ctor ohne pSet

------------------------------------------------------------------------*/

#pragma SEG_EOFMODULE


